(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}(g.jsTraverse || (g.jsTraverse = {})).traverse = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var traverse = module.exports = function (obj) {
    return new Traverse(obj);
};

function Traverse (obj) {
    this.value = obj;
}

Traverse.prototype.get = function (ps) {
    var node = this.value;
    for (var i = 0; i < ps.length; i ++) {
        var key = ps[i];
        if (!node || !hasOwnProperty.call(node, key)) {
            node = undefined;
            break;
        }
        node = node[key];
    }
    return node;
};

Traverse.prototype.has = function (ps) {
    var node = this.value;
    for (var i = 0; i < ps.length; i ++) {
        var key = ps[i];
        if (!node || !hasOwnProperty.call(node, key)) {
            return false;
        }
        node = node[key];
    }
    return true;
};

Traverse.prototype.set = function (ps, value) {
    var node = this.value;
    for (var i = 0; i < ps.length - 1; i ++) {
        var key = ps[i];
        if (!hasOwnProperty.call(node, key)) node[key] = {};
        node = node[key];
    }
    node[ps[i]] = value;
    return value;
};

Traverse.prototype.map = function (cb) {
    return walk(this.value, cb, true);
};

Traverse.prototype.forEach = function (cb) {
    this.value = walk(this.value, cb, false);
    return this.value;
};

Traverse.prototype.reduce = function (cb, init) {
    var skip = arguments.length === 1;
    var acc = skip ? this.value : init;
    this.forEach(function (x) {
        if (!this.isRoot || !skip) {
            acc = cb.call(this, acc, x);
        }
    });
    return acc;
};

Traverse.prototype.paths = function () {
    var acc = [];
    this.forEach(function (x) {
        acc.push(this.path); 
    });
    return acc;
};

Traverse.prototype.nodes = function () {
    var acc = [];
    this.forEach(function (x) {
        acc.push(this.node);
    });
    return acc;
};

Traverse.prototype.clone = function () {
    var parents = [], nodes = [];
    
    return (function clone (src) {
        for (var i = 0; i < parents.length; i++) {
            if (parents[i] === src) {
                return nodes[i];
            }
        }
        
        if (typeof src === 'object' && src !== null) {
            var dst = copy(src);
            
            parents.push(src);
            nodes.push(dst);
            
            forEach(objectKeys(src), function (key) {
                dst[key] = clone(src[key]);
            });
            
            parents.pop();
            nodes.pop();
            return dst;
        }
        else {
            return src;
        }
    })(this.value);
};

function walk (root, cb, immutable) {
    var path = [];
    var parents = [];
    var alive = true;
    
    return (function walker (node_) {
        var node = immutable ? copy(node_) : node_;
        var modifiers = {};
        
        var keepGoing = true;
        
        var state = {
            node : node,
            node_ : node_,
            path : [].concat(path),
            parent : parents[parents.length - 1],
            parents : parents,
            key : path.slice(-1)[0],
            isRoot : path.length === 0,
            level : path.length,
            circular : null,
            update : function (x, stopHere) {
                if (!state.isRoot) {
                    state.parent.node[state.key] = x;
                }
                state.node = x;
                if (stopHere) keepGoing = false;
            },
            'delete' : function (stopHere) {
                delete state.parent.node[state.key];
                if (stopHere) keepGoing = false;
            },
            remove : function (stopHere) {
                if (isArray(state.parent.node)) {
                    state.parent.node.splice(state.key, 1);
                }
                else {
                    delete state.parent.node[state.key];
                }
                if (stopHere) keepGoing = false;
            },
            keys : null,
            before : function (f) { modifiers.before = f },
            after : function (f) { modifiers.after = f },
            pre : function (f) { modifiers.pre = f },
            post : function (f) { modifiers.post = f },
            stop : function () { alive = false },
            block : function () { keepGoing = false }
        };
        
        if (!alive) return state;
        
        function updateState() {
            if (typeof state.node === 'object' && state.node !== null) {
                if (!state.keys || state.node_ !== state.node) {
                    state.keys = objectKeys(state.node)
                }
                
                state.isLeaf = state.keys.length == 0;
                
                for (var i = 0; i < parents.length; i++) {
                    if (parents[i].node_ === node_) {
                        state.circular = parents[i];
                        break;
                    }
                }
            }
            else {
                state.isLeaf = true;
                state.keys = null;
            }
            
            state.notLeaf = !state.isLeaf;
            state.notRoot = !state.isRoot;
        }
        
        updateState();
        
        // use return values to update if defined
        var ret = cb.call(state, state.node);
        if (ret !== undefined && state.update) state.update(ret);
        
        if (modifiers.before) modifiers.before.call(state, state.node);
        
        if (!keepGoing) return state;
        
        if (typeof state.node == 'object'
        && state.node !== null && !state.circular) {
            parents.push(state);
            
            updateState();
            
            forEach(state.keys, function (key, i) {
                path.push(key);
                
                if (modifiers.pre) modifiers.pre.call(state, state.node[key], key);
                
                var child = walker(state.node[key]);
                if (immutable && hasOwnProperty.call(state.node, key)) {
                    state.node[key] = child.node;
                }
                
                child.isLast = i == state.keys.length - 1;
                child.isFirst = i == 0;
                
                if (modifiers.post) modifiers.post.call(state, child);
                
                path.pop();
            });
            parents.pop();
        }
        
        if (modifiers.after) modifiers.after.call(state, state.node);
        
        return state;
    })(root).node;
}

function copy (src) {
    if (typeof src === 'object' && src !== null) {
        var dst;
        
        if (isArray(src)) {
            dst = [];
        }
        else if (isDate(src)) {
            dst = new Date(src.getTime ? src.getTime() : src);
        }
        else if (isRegExp(src)) {
            dst = new RegExp(src);
        }
        else if (isError(src)) {
            dst = { message: src.message };
        }
        else if (isBoolean(src)) {
            dst = new Boolean(src);
        }
        else if (isNumber(src)) {
            dst = new Number(src);
        }
        else if (isString(src)) {
            dst = new String(src);
        }
        else if (Object.create && Object.getPrototypeOf) {
            dst = Object.create(Object.getPrototypeOf(src));
        }
        else if (src.constructor === Object) {
            dst = {};
        }
        else {
            var proto =
                (src.constructor && src.constructor.prototype)
                || src.__proto__
                || {}
            ;
            var T = function () {};
            T.prototype = proto;
            dst = new T;
        }
        
        forEach(objectKeys(src), function (key) {
            dst[key] = src[key];
        });
        return dst;
    }
    else return src;
}

var objectKeys = Object.keys || function keys (obj) {
    var res = [];
    for (var key in obj) res.push(key)
    return res;
};

function toS (obj) { return Object.prototype.toString.call(obj) }
function isDate (obj) { return toS(obj) === '[object Date]' }
function isRegExp (obj) { return toS(obj) === '[object RegExp]' }
function isError (obj) { return toS(obj) === '[object Error]' }
function isBoolean (obj) { return toS(obj) === '[object Boolean]' }
function isNumber (obj) { return toS(obj) === '[object Number]' }
function isString (obj) { return toS(obj) === '[object String]' }

var isArray = Array.isArray || function isArray (xs) {
    return Object.prototype.toString.call(xs) === '[object Array]';
};

var forEach = function (xs, fn) {
    if (xs.forEach) return xs.forEach(fn)
    else for (var i = 0; i < xs.length; i++) {
        fn(xs[i], i, xs);
    }
};

forEach(objectKeys(Traverse.prototype), function (key) {
    traverse[key] = function (obj) {
        var args = [].slice.call(arguments, 1);
        var t = new Traverse(obj);
        return t[key].apply(t, args);
    };
});

var hasOwnProperty = Object.hasOwnProperty || function (obj, key) {
    return key in obj;
};

},{}]},{},[1])(1)
});
function __cons(t,a){return eval("new t("+a.map(function(t,e){return"a["+e+"]"}).join(",")+")")}Object.getPrototypeOf||(Object.getPrototypeOf=function(t){if(t!==Object(t))throw TypeError("Object.getPrototypeOf called on non-object");return t.__proto__||t.constructor.prototype||Object.prototype}),"function"!=typeof Object.getOwnPropertyNames&&(Object.getOwnPropertyNames=function(t){if(t!==Object(t))throw TypeError("Object.getOwnPropertyNames called on non-object");var e,r=[];for(e in t)Object.prototype.hasOwnProperty.call(t,e)&&r.push(e);return r}),"function"!=typeof Object.create&&(Object.create=function(t,e){function r(){}if("object"!=typeof t)throw TypeError();r.prototype=t;var n=new r;if(t&&(n.constructor=r),e!==undefined){if(e!==Object(e))throw TypeError();Object.defineProperties(n,e)}return n}),function(){if(!Object.defineProperty||!function(){try{return Object.defineProperty({},"x",{}),!0}catch(t){return!1}}()){var t=Object.defineProperty;Object.defineProperty=function(e,r,n){if(t)try{return t(e,r,n)}catch(o){}if(e!==Object(e))throw TypeError("Object.defineProperty called on non-object");return Object.prototype.__defineGetter__&&"get"in n&&Object.prototype.__defineGetter__.call(e,r,n.get),Object.prototype.__defineSetter__&&"set"in n&&Object.prototype.__defineSetter__.call(e,r,n.set),"value"in n&&(e[r]=n.value),e}}}(),"function"!=typeof Object.defineProperties&&(Object.defineProperties=function(t,e){if(t!==Object(t))throw TypeError("Object.defineProperties called on non-object");var r;for(r in e)Object.prototype.hasOwnProperty.call(e,r)&&Object.defineProperty(t,r,e[r]);return t}),Object.keys||(Object.keys=function(t){if(t!==Object(t))throw TypeError("Object.keys called on non-object");var e,r=[];for(e in t)Object.prototype.hasOwnProperty.call(t,e)&&r.push(e);return r}),Function.prototype.bind||(Function.prototype.bind=function(t){if("function"!=typeof this)throw TypeError("Bind must be called on a function");var e=Array.prototype.slice.call(arguments,1),r=this,n=function(){},o=function(){return r.apply(this instanceof n?this:t,e.concat(Array.prototype.slice.call(arguments)))};return this.prototype&&(n.prototype=this.prototype),o.prototype=new n,o}),Array.isArray=Array.isArray||function(t){return Boolean(t&&"[object Array]"===Object.prototype.toString.call(Object(t)))},Array.prototype.indexOf||(Array.prototype.indexOf=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if(0===r)return-1;var n=0;if(arguments.length>0&&(n=Number(arguments[1]),isNaN(n)?n=0:0!==n&&n!==1/0&&n!==-1/0&&(n=(n>0||-1)*Math.floor(Math.abs(n)))),n>=r)return-1;for(var o=n>=0?n:Math.max(r-Math.abs(n),0);o<r;o++)if(o in e&&e[o]===t)return o;return-1}),Array.prototype.lastIndexOf||(Array.prototype.lastIndexOf=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if(0===r)return-1;var n=r;arguments.length>1&&((n=Number(arguments[1]))!==n?n=0:0!==n&&n!==1/0&&n!==-1/0&&(n=(n>0||-1)*Math.floor(Math.abs(n))));for(var o=n>=0?Math.min(n,r-1):r-Math.abs(n);o>=0;o--)if(o in e&&e[o]===t)return o;return-1}),Array.prototype.every||(Array.prototype.every=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();var n,o=arguments[1];for(n=0;n<r;n++)if(n in e&&!t.call(o,e[n],n,e))return!1;return!0}),Array.prototype.some||(Array.prototype.some=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();var n,o=arguments[1];for(n=0;n<r;n++)if(n in e&&t.call(o,e[n],n,e))return!0;return!1}),Array.prototype.forEach||(Array.prototype.forEach=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();var n,o=arguments[1];for(n=0;n<r;n++)n in e&&t.call(o,e[n],n,e)}),Array.prototype.map||(Array.prototype.map=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();var n=[];n.length=r;var o,i=arguments[1];for(o=0;o<r;o++)o in e&&(n[o]=t.call(i,e[o],o,e));return n}),Array.prototype.filter||(Array.prototype.filter=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();var n,o=[],i=arguments[1];for(n=0;n<r;n++)if(n in e){var a=e[n];t.call(i,a,n,e)&&o.push(a)}return o}),Array.prototype.reduce||(Array.prototype.reduce=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();if(0===r&&1===arguments.length)throw TypeError();var n,o=0;if(arguments.length>=2)n=arguments[1];else for(;;){if(o in e){n=e[o++];break}if(++o>=r)throw TypeError()}for(;o<r;)o in e&&(n=t.call(undefined,n,e[o],o,e)),o++;return n}),Array.prototype.reduceRight||(Array.prototype.reduceRight=function(t){if(void 0===this||null===this)throw TypeError();var e=Object(this),r=e.length>>>0;if("function"!=typeof t)throw TypeError();if(0===r&&1===arguments.length)throw TypeError();var n,o=r-1;if(arguments.length>=2)n=arguments[1];else for(;;){if(o in this){n=this[o--];break}if(--o<0)throw TypeError()}for(;o>=0;)o in e&&(n=t.call(undefined,n,e[o],o,e)),o--;return n}),String.prototype.trim||(String.prototype.trim=function(){return String(this).replace(/^\s+/,"").replace(/\s+$/,"")}),Date.now||(Date.now=function(){return Number(new Date)}),Date.prototype.toISOString||(Date.prototype.toISOString=function(){function t(t){return("00"+t).slice(-2)}return this.getUTCFullYear()+"-"+t(this.getUTCMonth()+1)+"-"+t(this.getUTCDate())+"T"+t(this.getUTCHours())+":"+t(this.getUTCMinutes())+":"+t(this.getUTCSeconds())+"."+function(t){return("000"+t).slice(-3)}(this.getUTCMilliseconds())+"Z"}),function(t){"use strict";function e(e){return e===t?C:e}function r(t,e){for(var r=Object.getOwnPropertyDescriptor(t,e),n=Object.getPrototypeOf(t);!r&&n;)r=Object.getOwnPropertyDescriptor(n,e),n=Object.getPrototypeOf(n);return r}function n(t,e,r,n){e in t&&!n&&!I||("function"==typeof r?Object.defineProperty(t,e,{value:r,configurable:!0,enumerable:!1,writable:!0}):Object.defineProperty(t,e,{value:r,configurable:!1,enumerable:!1,writable:!1}))}function o(t,e,r){Object.defineProperty(t,e,{value:r,configurable:!1,enumerable:!1,writable:!0})}function i(){function t(t){var e=t.valueOf,n=R(null);return Object.defineProperty(t,"valueOf",{value:function(r){return function(o){return o===r?n:e.apply(t,arguments)}}(r),configurable:!0,writeable:!0,enumerable:!1}),n}function e(t){var e="function"==typeof t.valueOf&&t.valueOf(r);return e===t?null:e}var r=R(null);return{clear:function(){r=R(null)},remove:function(t){var r=e(t);return!(!r||!b(r,"value"))&&(delete r.value,!0)},get:function(t,r){var n=e(t);return n&&b(n,"value")?n.value:r},has:function(t){var r=e(t);return Boolean(r&&b(r,"value"))},set:function(r,n){(e(r)||t(r)).value=n}}}function a(e){switch(typeof e){case"undefined":return"undefined";case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"symbol":return"symbol";default:return null===e?"null":e instanceof t.Symbol?"symbol":"object"}}function u(t){return t=Number(t),L(t)?0:0===t||t===Infinity||t===-Infinity?t:(t<0?-1:1)*V(H(t))}function c(t){return t>>>0}function s(t){if(null===t||t===C)throw TypeError();return Object(t)}function f(t){var e=u(t);return e<=0?0:e===Infinity?9007199254740991:K(e,9007199254740991)}function l(t){return"function"==typeof t}function p(t){return!!/Constructor/.test(Object.prototype.toString.call(t))||(!!/Function/.test(Object.prototype.toString.call(t))||"function"==typeof t)}function h(t,e){if(typeof t!=typeof e)return!1;switch(typeof t){case"undefined":return!0;case"number":return t!==t&&e!==e||(0===t&&0===e?1/t==1/e:t===e);case"boolean":case"string":case"object":default:return t===e}}function y(t,e){if(typeof t!=typeof e)return!1;switch(typeof t){case"undefined":return!0;case"number":return t!==t&&e!==e||t===e;case"boolean":case"string":case"object":default:return t===e}}function v(t,e){return s(t)[e]}function d(t,e){var r=v(t,e);if(r===C||null===r)return C;if(!l(r))throw TypeError();return r}function m(t,e){for(;t;){if(Object.prototype.hasOwnProperty.call(t,e))return!0;if("object"!==a(t))return!1;var r=Object.getPrototypeOf(t);if(r===t)return!1;t=r}return!1}function b(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function g(t,e){arguments.length<2&&(e=d(t,it));var r=e.call(t);if("object"!==a(r))throw TypeError();return r}function E(t,e){if(arguments.length<2)var r=t.next();else r=t.next(e);if("object"!==a(r))throw TypeError();return r}function w(t){return t.value}function S(t,e){var r=E(t,e),n=r.done;return!0!==Boolean(n)&&r}function O(t,e){var r={};return r.value=t,r.done=e,r}function T(t,e,r){k(function(){e.apply(C,r)})}function j(t){}function _(t){var e=[];if(Object(t)!==t)return e;for(var r=new Set;null!==t;)Object.getOwnPropertyNames(t).forEach(function(n){if(!r.has(n)){var o=Object.getOwnPropertyDescriptor(t,n);o&&(r.add(n),o.enumerable&&e.push(n))}}),t=Object.getPrototypeOf(t);return e[it]()}function P(t){return Object.getOwnPropertyNames(t)}function R(t,e){return Object.create(t,e)}function A(){}function D(t,e){var r=String(t),n=new A;return o(n,"[[IteratedString]]",r),o(n,"[[StringIteratorNextIndex]]",0),o(n,"[[StringIterationKind]]",e),n}function N(){}function M(t,e){var r=s(t),n=new N;return o(n,"[[IteratedObject]]",r),o(n,"[[ArrayIteratorNextIndex]]",0),o(n,"[[ArrayIterationKind]]",e),n}var x,I=!1,C=void 0,k=function(t,e){return t?function(e){t.resolve().then(function(){e()})}:e?function(t){e(t)}:function(t){setTimeout(t,0)}}(t.Promise,t.setImmediate),L=t.isNaN,U=t.parseInt,F=t.parseFloat,W=Math.E,q=Math.LOG10E,B=Math.LOG2E,H=Math.abs,X=Math.ceil,G=Math.exp,V=Math.floor,z=Math.log,$=Math.max,K=Math.min,J=Math.pow,Y=Math.random,Z=Math.sqrt,Q=String.prototype.match,tt=String.prototype.replace,et=String.prototype.search,rt=String.prototype.split,nt=Object.create(null);!function(){function r(t){return Array(t+1).join("x").replace(/x/g,function(){return Y()<.5?"‌":"‍"})}function i(t){if(!(this instanceof i))return new i(t,a);if(this instanceof i&&arguments[1]!==a)throw TypeError();var e=t===C?C:String(t);return o(this,"[[SymbolData]]",r(128)),o(this,"[[Description]]",e),u[this]=this,this}var a=Object.create(null),u={};x=function(t){return u[t]};var c=[];"Symbol"in t&&!I||(t.Symbol=i),n(i,"for",function(t){for(var e=String(t),r=0;r<c.length;++r){var n=c[r];if(h(n["[[key]]"],e))return n["[[symbol]]"]}var o=i(t);return c.push({"[[key]]":e,"[[symbol]]":o}),o}),n(t.Symbol,"iterator",t.Symbol("Symbol.iterator")),n(i,"keyFor",function(t){if(!(t instanceof i))throw TypeError();for(var e=0;e<c.length;++e){var r=c[e];if(h(r["[[symbol]]"],t))return r["[[key]]"]}return C}),n(t.Symbol,"match",t.Symbol("Symbol.match")),n(t.Symbol,"replace",t.Symbol("Symbol.replace")),n(t.Symbol,"search",t.Symbol("Symbol.search")),n(t.Symbol,"split",t.Symbol("Symbol.split")),n(t.Symbol,"toStringTag",t.Symbol("Symbol.toStringTag")),Object.defineProperty(i.prototype,"toString",{value:function(){var t=e(this),r=t["[[Description]]"];return"Symbol("+(r===C?"":r)+t["[[SymbolData]]"]+")"},configurable:!0,writeable:!0,enumerable:!1}),Object.defineProperty(i.prototype,"valueOf",{value:function(){throw TypeError()},configurable:!0,writeable:!0,enumerable:!1})}();var ot={},it=t.Symbol.iterator,at=t.Symbol.match,ut=t.Symbol.replace,ct=t.Symbol.search,st=t.Symbol.split,ft=t.Symbol.toStringTag;n(Object,"assign",function(t,e){var r=s(t);if(arguments.length<2)return r;for(var n=1;n<arguments.length;){var o=arguments[n++];if(o===C||null===o)var i=[];else{var a=s(o);i=P(a)}for(var u=0;u<i.length;++u){var c=i[u],f=Object.getOwnPropertyDescriptor(a,c);if(f!==C&&f.enumerable){var l=a[c];r[c]=l}}}return r}),function(){function e(t){return!x(t)}var r="symbol"==typeof t.Symbol(),o=Object.getOwnPropertyNames,i=Object.keys,a="object"==typeof window?o(window):[];n(Object,"getOwnPropertyNames",function(t){if("[object Window]"===Object.prototype.toString.call(t))try{return o(t).filter(e)}catch(r){return a.slice()}return o(t).filter(e)},!r),n(Object,"getOwnPropertySymbols",function(t){return o(t).filter(x).map(x)},!r),n(Object,"keys",function(t){return i(t).filter(e)},!r)}(),n(Object,"is",function(t,e){return h(t,e)}),n(Object,"setPrototypeOf",function(t,e){if("object"!==a(t))throw TypeError();if("object"!==a(e)&&"null"!==a(e))throw TypeError();return t.__proto__=e,t});var lt=Object.prototype.toString;n(Object.prototype,"toString",function(){var t=e(this);return t===Object(t)&&ft in t?"[object "+t[ft]+"]":lt.apply(t,arguments)}),n(t.Symbol.prototype,t.Symbol.toStringTag,"Symbol"),n(Number,"EPSILON",function(){var t,e;for(t=1;1+t!==1;t/=2)e=t;return e}()),n(Number,"isFinite",function(t){return"number"===a(t)&&(t===t&&t!==+Infinity&&t!==-Infinity)}),n(Number,"isInteger",function(t){return"number"===a(t)&&(t===t&&t!==+Infinity&&t!==-Infinity&&u(t)===t)}),n(Number,"isNaN",function(t){return"number"===a(t)&&t!==t}),n(Number,"isSafeInteger",function(t){if("number"!==a(t))return!1;if(t!==t||t===+Infinity||t===-Infinity)return!1;var e=u(t);return e===t&&H(e)<=9007199254740991}),n(Number,"MAX_SAFE_INTEGER",9007199254740991),n(Number,"MIN_SAFE_INTEGER",-9007199254740991),n(Number,"parseFloat",F),n(Number,"parseInt",U),n(Math,ft,"Math"),n(Math,"acosh",function(t){return t=Number(t),z(t+Z(t*t-1))}),n(Math,"asinh",function(t){if(t=Number(t),h(t,-0))return t;var e=Z(t*t+1);return z(e===-t?0:t+e)}),n(Math,"atanh",function(t){return 0===(t=Number(t))?t:z((1+t)/(1-t))/2}),n(Math,"cbrt",function(t){if(t=Number(t),L(t/t))return t;var e=J(H(t),1/3),r=t/e/e;return e+e*(r-e)/(2*e+r)}),n(Math,"clz32",function(t){function e(t){return 240&t?128&t?0:64&t?1:32&t?2:3:8&t?4:4&t?5:2&t?6:1&t?7:8}return 4278190080&(t=c(t))?e(t>>24):16711680&t?e(t>>16)+8:65280&t?e(t>>8)+16:e(t)+24}),n(Math,"cosh",function(t){return t=Number(t),(J(W,t)+J(W,-t))/2}),n(Math,"expm1",function(t){return t=Number(t),h(t,-0)?-0:H(t)<1e-5?t+.5*t*t:G(t)-1}),n(Math,"fround",function(t){return L(t)?NaN:1/t==+Infinity||1/t==-Infinity||t===+Infinity||t===-Infinity?t:new Float32Array([t])[0]}),n(Math,"hypot",function(){for(var t=[],e=0,r=!1,n=0;n<arguments.length;++n){var o=H(Number(arguments[n]));if(o===Infinity)return o;o!==o&&(r=!0),o>e&&(e=o),t[n]=o}if(r)return NaN;if(0===e)return 0;var i=0;for(n=0;n<t.length;++n){var a=t[n]/e;i+=a*a}return e*Z(i)}),n(Math,"imul",function(t,e){var r=c(t),n=c(e),o=65535&r,i=65535&n;return o*i+((r>>>16&65535)*i+o*(n>>>16&65535)<<16>>>0)|0},"imul"in Math&&0===Math.imul(1,2147483648)),n(Math,"log1p",function(t){return(t=Number(t))<-1?NaN:h(t,-0)?-0:H(t)>1e-4?z(1+t):(-.5*t+1)*t}),n(Math,"log10",function(t){return t=Number(t),z(t)*q}),n(Math,"log2",function(t){return t=Number(t),z(t)*B}),n(Math,"sign",function(t){return(t=Number(t))<0?-1:t>0?1:t}),n(Math,"sinh",function(t){return t=Number(t),h(t,-0)?t:(J(W,t)-J(W,-t))/2}),n(Math,"tanh",function(t){t=Number(t);var e=J(W,2*t)-1,r=J(W,2*t)+1;return h(t,-0)?t:e===r?1:e/r}),n(Math,"trunc",function(t){return t=Number(t),L(t)?NaN:t<0?X(t):V(t)});var pt=function(){var t={},e=Symbol();return t[Symbol.match]=function(){return e},"".match(t)===e}();n(String,"fromCodePoint",function(){for(var t=arguments,e=t.length,r=[],n=0;n<e;){var o=t[n],i=Number(o);if(!h(i,u(i))||i<0||i>1114111)throw RangeError("Invalid code point "+i);i<65536?r.push(String.fromCharCode(i)):(i-=65536,r.push(String.fromCharCode(55296+(i>>10))),r.push(String.fromCharCode(i%1024+56320))),n+=1}return r.join("")}),n(String,"raw",function(t){var e=[].slice.call(arguments,1),r=Object(t).raw,n=Object(r),o=f(n.length);if(o<=0)return"";for(var i=[],a=0;;){var u=n[a],c=String(u);if(i.push(c),a+1===o)return i.join("");u=e[a];var s=String(u);i.push(s),a+=1}}),n(String.prototype,"codePointAt",function(t){var r=e(this),n=String(r),o=u(t),i=n.length;if(o<0||o>=i)return C;var a=n.charCodeAt(o);if(a<55296||a>56319||o+1===i)return a;var c=n.charCodeAt(o+1);return c<56320||c>57343?a:1024*(a-55296)+(c-56320)+65536}),n(String.prototype,"endsWith",function(t){var r=arguments[1],n=e(this),o=String(n),i=String(t),a=o.length,c=r===C?a:u(r),s=K($(c,0),a),f=i.length,l=s-f;return!(l<0)&&o.substring(l,l+f)===i}),n(String.prototype,"includes",function(t){var r=arguments[1],n=e(this),o=String(n),i=String(t),a=u(r),c=o.length,s=K($(a,0),c);return-1!==o.indexOf(i,s)}),n(String.prototype,"match",function(t){var r=e(this),n=String(r);if(m(t,at))var o=t;else o=new RegExp(t);return o[at](n)},!pt),n(String.prototype,"repeat",function(t){var r=e(this),n=String(r),o=u(t);if(o<0)throw RangeError();if(o===Infinity)throw RangeError();return new Array(o+1).join(n)}),n(String.prototype,"replace",function(t,r){var n=e(this);return m(t,ut)?t[ut](n,r):tt.call(n,t,r)},!pt),n(String.prototype,"search",function(t){var r=e(this),n=String(r);if(m(t,ct))var o=t;else o=new RegExp(t);return o[ct](n)},!pt),n(String.prototype,"split",function(t,r){var n=e(this);return m(t,st)?t[st](n,r):rt.call(n,t,r)},!pt),n(String.prototype,"startsWith",function(t){var r=arguments[1],n=e(this),o=String(n),i=String(t),a=u(r),c=o.length,s=K($(a,0),c),f=i.length;return!(f+s>c)&&o.substring(s,s+f)===i}),n(String.prototype,it,function(){return D(this,"value")});var ht=Object.create(ot);A.prototype=ht,n(ht,"next",function(){var t=s(this),e=String(t["[[IteratedString]]"]),r=t["[[StringIteratorNextIndex]]"];if(r>=e.length)return o(t,"[[StringIteratorNextIndex]]",Infinity),O(C,!0);var n=e.codePointAt(r);return o(t,"[[StringIteratorNextIndex]]",r+(n>65535?2:1)),O(String.fromCodePoint(n),!1)}),n(ht,ft,"String Iterator"),"flags"in RegExp.prototype||Object.defineProperty(RegExp.prototype,"flags",{get:function(){var t=String(this);return t.substring(t.lastIndexOf("/")+1)}}),n(RegExp.prototype,at,function(t){var r=e(this);return Q.call(t,r)}),n(RegExp.prototype,ut,function(t,r){var n=e(this);return tt.call(t,n,r)}),n(RegExp.prototype,ct,function(t){var r=e(this);return et.call(t,r)}),n(RegExp.prototype,st,function(t,r){var n=e(this);return rt.call(t,n,r)}),n(Array,"from",function(t){var r=arguments[1],n=arguments[2],o=e(this);if(r===C)var i=!1;else{if(!l(r))throw TypeError();var a=n;i=!0}var u=d(t,it);if(u!==C){if(p(o))var c=new o;else c=new Array(0);for(var h=g(t,u),y=0;;){var v=S(h);if(!1===v)return c.length=y,c;var m=w(v);if(i)var b=r.call(a,m);else b=m;c[y]=b,y+=1}}var E=s(t),O=f(E.length);for(c=p(o)?new o(O):new Array(O),y=0;y<O;){var T=E[y];b=i?r.call(a,T,y):T,c[y]=b,y+=1}return c.length=O,c}),n(Array,"of",function(){var t,r=arguments,n=c(r.length),o=e(this);t=p(o)?s(t=new o(n)):new Array(n);for(var i=0;i<n;)t[i]=r[i],i+=1;return t.length=n,t}),n(Array.prototype,"copyWithin",function(t,e){var r=arguments[2],n=s(this),o=f(n.length);o=$(o,0);var i,a=u(t);i=a<0?$(o+a,0):K(a,o);var c,l=u(e);c=l<0?$(o+l,0):K(l,o);var p,h;h=(p=r===C?o:u(r))<0?$(o+p,0):K(p,o);var y,v=K(h-c,o-i);for(c<i&&i<c+v?(y=-1,c=c+v-1,i=i+v-1):y=1;v>0;){var d=String(c),b=String(i);if(m(n,d)){var g=n[d];n[b]=g}else delete n[b];c+=y,i+=y,v-=1}return n});var yt="entries"in Array.prototype&&"next"in[].entries();n(Array.prototype,"entries",function(){return M(this,"key+value")},!yt),n(Array.prototype,"fill",function(t){var e=arguments[1],r=arguments[2],n=s(this),o=f(n.length);o=$(o,0);var i,a=u(e);i=a<0?$(o+a,0):K(a,o);var c,l;for(l=(c=r===C?o:u(r))<0?$(o+c,0):K(c,o);i<l;)n[String(i)]=t,i+=1;return n}),n(Array.prototype,"find",function(t){var e=s(this),r=u(e.length);if(!l(t))throw TypeError();for(var n=arguments.length>1?arguments[1]:C,o=0;o<r;){var i=String(o);if(m(e,i)){var a=e[i],c=t.call(n,a,o,e);if(Boolean(c))return a}++o}return C}),n(Array.prototype,"findIndex",function(t){var e=s(this),r=f(e.length);if(!l(t))throw TypeError();for(var n=arguments.length>1?arguments[1]:C,o=0;o<r;){var i=String(o);if(m(e,i)){var a=e[i],u=t.call(n,a,o,e);if(Boolean(u))return o}++o}return-1}),n(Array.prototype,"keys",function(){return M(this,"key")},!yt),n(Array.prototype,"values",function(){return M(this,"value")},!yt),n(Array.prototype,it,Array.prototype.values);var vt=Object.create(ot);N.prototype=vt,n(vt,"next",function(){var t=e(this);if("object"!==a(t))throw TypeError();var r,n,i=t["[[IteratedObject]]"],u=t["[[ArrayIteratorNextIndex]]"],s=t["[[ArrayIterationKind]]"],f=c(i.length);if(-1!==s.indexOf("sparse"))for(var l=!1;!l&&u<f;)(l=m(i,r=String(u)))||(u+=1);if(u>=f)return o(t,"[[ArrayIteratorNextIndex]]",Infinity),O(C,!0);if(r=u,o(t,"[[ArrayIteratorNextIndex]]",u+1),-1!==s.indexOf("value")&&(n=i[r]),-1!==s.indexOf("key+value"))return O([r,n],!1);if(-1!==s.indexOf("key"))return O(r,!1);if("value"===s)return O(n,!1);throw Error("Internal error")}),n(vt,ft,"Array Iterator"),["Int8Array","Uint8Array","Uint8ClampedArray","Int16Array","Uint16Array","Int32Array","Uint32Array","Float32Array","Float64Array"].forEach(function(r){if(r in t){var o=t[r];n(o,"from",function(t){var r=arguments[1],n=arguments[2],o=e(this);if(!p(o))throw TypeError();if(r===C)var i=!1;else{if(l(r))throw TypeError();var a=n;i=!0}var u=d(t,it);if(u!==C){for(var c=g(t,u),h=[],y=!0;!1!==y;)if(!1!==(y=S(c))){var v=w(y);h.push(v)}for(var m=h.length,b=new o(m),E=0;E<m;){var O=h.shift();if(i)var T=r.call(a,O);else T=O;b[E]=T,++E}return b}var j=s(t);for(b=new o(m=f(j.length)),E=0;E<m;)O=j[E],T=i?r.call(a,O,E):O,b[E]=T,++E;return b}),n(o,"of",function(){for(var t=arguments,r=t.length,n=new(e(this))(r),o=0;o<r;)n[o]=t[o],++o;return n}),n(o.prototype,"copyWithin",Array.prototype.copyWithin),n(o.prototype,"entries",Array.prototype.entries),n(o.prototype,"every",Array.prototype.every),n(o.prototype,"fill",function(t){var e=arguments[1],r=arguments[2],n=s(this),o=f(n.length);o=$(o,0);var i,a=u(e);i=a<0?$(o+a,0):K(a,o);var c,l;for(l=(c=r===C?o:u(r))<0?$(o+c,0):K(c,o);i<l;)n[String(i)]=t,i+=1;return n}),n(o.prototype,"filter",function(t){var e=arguments[1],r=s(this),n=f(r.length);if(!l(t))throw TypeError();for(var o=e,i=r.constructor,a=[],u=0,c=0;u<n;){var p=r[u];t.call(o,p,u,r)&&(a.push(p),++c),++u}for(var h=new i(c),y=0,v=0;v<a.length;++v){var d=a[v];h[y]=d,++y}return h}),n(o.prototype,"find",Array.prototype.find),n(o.prototype,"findIndex",Array.prototype.findIndex),n(o.prototype,"forEach",Array.prototype.forEach),n(o.prototype,"indexOf",Array.prototype.indexOf),n(o.prototype,"join",Array.prototype.join),n(o.prototype,"keys",Array.prototype.keys),n(o.prototype,"lastIndexOf",Array.prototype.lastIndexOf),n(o.prototype,"map",function(t){var e=arguments[1],r=s(this),n=f(r.length);if(!l(t))throw TypeError();var o=e,i=C,a=r.constructor;p(a)&&(i=new a(n)),i===C&&(i=new Array(n));for(var u=0;u<n;){if(m(r,u)){var c=r[u],h=t.call(o,c,u,r);i[u]=h}++u}return i}),n(o.prototype,"reduce",Array.prototype.reduce),n(o.prototype,"reduceRight",Array.prototype.reduceRight),n(o.prototype,"reverse",Array.prototype.reverse),n(o.prototype,"slice",function(t,e){var r=s(this),n=f(r.length),o=u(t),i=o<0?$(n+o,0):K(o,n),a=e===C?n:u(e),c=a<0?$(n+a,0):K(a,n),l=c-i,h=r.constructor;if(!p(h))throw TypeError();for(var y=new h(l),v=0;i<c;){var d=r[i];y[v]=d,++i,++v}return y}),n(o.prototype,"some",Array.prototype.some),n(o.prototype,"sort",function(){var t=arguments[0];return Array.prototype.sort.call(this,function(e,r){return e!==e&&r!==r?0:e!==e?1:r!==r?-1:t!==C?t(e,r):e<r?-1:e>r?1:0})}),n(o.prototype,"values",Array.prototype.values),n(o.prototype,it,o.prototype.values),n(o.prototype,ft,r)}}),function(){function r(){var t=e(this),r=arguments[0];if("object"!==a(t))throw TypeError();if("[[MapData]]"in t)throw TypeError();if(r!==C){var n=t.set;if(!l(n))throw TypeError();var i=g(s(r))}if(o(t,"[[MapData]]",{keys:[],values:[]}),i===C)return t;for(;;){var u=S(i);if(!1===u)return t;var c=w(u);if("object"!==a(c))throw TypeError();var f=c[0],p=c[1];n.call(t,f,p)}return t}function i(t,e){var r;if(e===e)return t.keys.indexOf(e);for(r=0;r<t.keys.length;r+=1)if(y(t.keys[r],e))return r;return-1}function u(){}function c(t,e){if("object"!==a(t))throw TypeError();if(!("[[MapData]]"in t))throw TypeError();if(t["[[MapData]]"]===C)throw TypeError();var r=new u;return o(r,"[[Map]]",t),o(r,"[[MapNextIndex]]",0),o(r,"[[MapIterationKind]]",e),r}"Map"in t&&!I&&!function(){try{return new t.Map([]),!1}catch(e){return!0}}()&&!function(){try{return!(new t.Map).entries().next}catch(e){return!0}}()&&1===new t.Map([["a",1]]).size||(t.Map=r);var f={};n(r.prototype=f,"clear",function(){var t=e(this);if("object"!==a(t))throw TypeError();if(!("[[MapData]]"in t))throw TypeError();if(t["[[MapData]]"]===C)throw TypeError();var r=t["[[MapData]]"];return r.keys.length=0,r.values.length=0,C}),n(r.prototype,"delete",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(!("[[MapData]]"in r))throw TypeError();if(r["[[MapData]]"]===C)throw TypeError();var n=r["[[MapData]]"],o=i(n,t);return!(o<0)&&(n.keys[o]=nt,n.values[o]=nt,!0)}),n(r.prototype,"entries",function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t,"key+value")}),n(r.prototype,"forEach",function(t){var r=arguments[1],n=e(this);if("object"!==a(n))throw TypeError();if(!("[[MapData]]"in n))throw TypeError();if(n["[[MapData]]"]===C)throw TypeError();var o=n["[[MapData]]"];if(!l(t))throw TypeError("First argument to forEach is not callable.");for(var i=0;i<o.keys.length;++i)o.keys[i]!==nt&&t.call(r,o.values[i],o.keys[i],n);return C}),n(r.prototype,"get",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(!("[[MapData]]"in r))throw TypeError();if(r["[[MapData]]"]===C)throw TypeError();var n=r["[[MapData]]"],o=i(n,t);return o>=0?n.values[o]:C}),n(r.prototype,"has",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(!("[[MapData]]"in r))throw TypeError();if(r["[[MapData]]"]===C)throw TypeError();return i(r["[[MapData]]"],t)>=0}),n(r.prototype,"keys",function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t,"key")}),n(r.prototype,"set",function(t,r){var n=e(this);if("object"!==a(n))throw TypeError();if(!("[[MapData]]"in n))throw TypeError();if(n["[[MapData]]"]===C)throw TypeError();var o=n["[[MapData]]"],u=i(o,t);return u<0&&(u=o.keys.length),h(t,-0)&&(t=0),o.keys[u]=t,o.values[u]=r,n}),Object.defineProperty(r.prototype,"size",{get:function(){var t=e(this);if("object"!==a(t))throw TypeError();if(!("[[MapData]]"in t))throw TypeError();if(t["[[MapData]]"]===C)throw TypeError();for(var r=t["[[MapData]]"],n=0,o=0;o<r.keys.length;++o)r.keys[o]!==nt&&(n+=1);return n}}),n(r.prototype,"values",function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t,"value")}),n(r.prototype,it,function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t,"key+value")}),n(t.Map.prototype,ft,"Map");var p=Object.create(ot);u.prototype=p,n(p,"next",function(){var t=e(this);if("object"!==a(t))throw TypeError();for(var r=t["[[Map]]"],n=t["[[MapNextIndex]]"],i=t["[[MapIterationKind]]"],u=r["[[MapData]]"];n<u.keys.length;){var c={key:u.keys[n],value:u.values[n]};if(n=n+=1,o(t,"[[MapNextIndex]]",n),c.key!==nt)return"key"===i?O(c.key,!1):"value"===i?O(c.value,!1):O([c.key,c.value],!1)}return O(C,!0)}),n(p,ft,"Map Iterator")}(),function(){function r(){var t=e(this),r=arguments[0];if("object"!==a(t))throw TypeError();if("[[SetData]]"in t)throw TypeError();if(r!==C){var n=t.add;if(!l(n))throw TypeError();var i=g(s(r))}if(o(t,"[[SetData]]",[]),i===C)return t;for(;;){var u=S(i);if(!1===u)return t;var c=w(u);n.call(t,c)}return t}function i(t,e){var r;if(e===e)return t.indexOf(e);for(r=0;r<t.length;r+=1)if(y(t[r],e))return r;return-1}function u(){}function c(t,e){if("object"!==a(t))throw TypeError();if(!("[[SetData]]"in t))throw TypeError();if(t["[[SetData]]"]===C)throw TypeError();var r=new u;return o(r,"[[IteratedSet]]",t),o(r,"[[SetNextIndex]]",0),o(r,"[[SetIterationKind]]",e),r}"Set"in t&&!I&&!function(){try{return!(new t.Set).entries().next}catch(e){return!0}}()&&1===new t.Set([1]).size||(t.Set=r);var f={};n(r.prototype=f,"add",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(!("[[SetData]]"in r))throw TypeError();if(r["[[SetData]]"]===C)throw TypeError();h(t,-0)&&(t=0);var n=i(r["[[SetData]]"],t);return n<0&&(n=r["[[SetData]]"].length),r["[[SetData]]"][n]=t,r}),n(r.prototype,"clear",function(){var t=e(this);if("object"!==a(t))throw TypeError();if(!("[[SetData]]"in t))throw TypeError();if(t["[[SetData]]"]===C)throw TypeError();return t["[[SetData]]"].length=0,C}),n(r.prototype,"delete",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(!("[[SetData]]"in r))throw TypeError();if(r["[[SetData]]"]===C)throw TypeError();var n=r["[[SetData]]"],o=i(n,t);return!(o<0)&&(n[o]=nt,!0)}),n(r.prototype,"entries",function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t,"key+value")}),n(r.prototype,"forEach",function(t){var r=arguments[1],n=e(this);if("object"!==a(n))throw TypeError();if(!("[[SetData]]"in n))throw TypeError();if(n["[[SetData]]"]===C)throw TypeError();var o=n["[[SetData]]"];if(!l(t))throw TypeError("First argument to forEach is not callable.");for(var i=0;i<o.length;++i)o[i]!==nt&&t.call(r,o[i],o[i],n)}),n(r.prototype,"has",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(!("[[SetData]]"in r))throw TypeError();if(r["[[SetData]]"]===C)throw TypeError();return-1!==i(r["[[SetData]]"],t)}),Object.defineProperty(r.prototype,"size",{get:function(){var t=e(this);if("object"!==a(t))throw TypeError();if(!("[[SetData]]"in t))throw TypeError();if(t["[[SetData]]"]===C)throw TypeError();for(var r=t["[[SetData]]"],n=0,o=0;o<r.length;++o)r[o]!==nt&&(n+=1);return n}}),n(r.prototype,"values",function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t,"value")}),r.prototype.keys=r.prototype.values,n(r.prototype,it,function(){var t=e(this);if("object"!==a(t))throw TypeError();return c(t)}),n(t.Set.prototype,ft,"Set");var p=Object.create(ot);u.prototype=p,n(p,"next",function(){var t=e(this);if("object"!==a(t))throw TypeError();for(var r=t["[[IteratedSet]]"],n=t["[[SetNextIndex]]"],i=t["[[SetIterationKind]]"],u=r["[[SetData]]"];n<u.length;){var c=u[n];if(n=n+=1,o(t,"[[SetNextIndex]]",n),c!==nt)return"key+value"===i?O([c,c],!1):O(c,!1)}return O(C,!0)}),n(p,ft,"Set Iterator")}(),function(){function r(){var t=e(this),r=arguments[0];if("object"!==a(t))throw TypeError();if("[[WeakMapData]]"in t)throw TypeError();if(r!==C){var n=t.set;if(!l(n))throw TypeError();var u=g(s(r))}if(o(t,"[[WeakMapData]]",new i),u===C)return t;for(;;){var c=S(u);if(!1===c)return t;var f=w(c);if("object"!==a(f))throw TypeError();var p=f[0],h=f[1];n.call(t,p,h)}return t}"WeakMap"in t&&!I||(t.WeakMap=r);var u={};n(r.prototype=u,"delete",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(r["[[WeakMapData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return r["[[WeakMapData]]"].remove(t)}),n(r.prototype,"get",function(t,r){var n=e(this);if("object"!==a(n))throw TypeError();if(n["[[WeakMapData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return n["[[WeakMapData]]"].get(t,r)}),n(r.prototype,"has",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(r["[[WeakMapData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return r["[[WeakMapData]]"].has(t)}),n(r.prototype,"set",function(t,r){var n=e(this);if("object"!==a(n))throw TypeError();if(n["[[WeakMapData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return n["[[WeakMapData]]"].set(t,r),n}),n(t.WeakMap.prototype,ft,"WeakMap"),function(){var e=new t.WeakMap,r=t.WeakMap.prototype.set;n(t.WeakMap.prototype,"set",function(){return r.apply(this,arguments),this},e.set({},0)!==e)}()}(),function(){function r(){var t=e(this),r=arguments[0];if("object"!==a(t))throw TypeError();if("[[WeakSetData]]"in t)throw TypeError();if(r!==C){var n=t.add;if(!l(n))throw TypeError();var u=g(s(r))}if(o(t,"[[WeakSetData]]",new i),u===C)return t;for(;;){var c=S(u);if(!1===c)return t;var f=w(c);n.call(t,f)}return t}"WeakSet"in t&&!I||(t.WeakSet=r);var u={};n(r.prototype=u,"add",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(r["[[WeakSetData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return r["[[WeakSetData]]"].set(t,!0),r}),n(r.prototype,"delete",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(r["[[WeakSetData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return r["[[WeakSetData]]"].remove(t)}),n(r.prototype,"has",function(t){var r=e(this);if("object"!==a(r))throw TypeError();if(r["[[WeakSetData]]"]===C)throw TypeError();if("object"!==a(t))throw TypeError("Expected object");return r["[[WeakSetData]]"].has(t)}),n(t.WeakSet.prototype,ft,"WeakSet"),function(){var e=new t.WeakSet,r=t.WeakSet.prototype.add;n(t.WeakSet.prototype,"add",function(){return r.apply(this,arguments),this},e.add({})!==e)}()}(),"ArrayBuffer"in t&&(n(ArrayBuffer,"isView",function(t){return"object"===a(t)&&("buffer"in t&&t.buffer instanceof ArrayBuffer)}),n(ArrayBuffer.prototype,ft,"ArrayBuffer")),"DataView"in t&&n(DataView.prototype,ft,"DataView"),n(JSON,ft,"JSON"),n(ot,it,function(){return this}),function(){function r(t){var e={"[[value]]":!1},r=u();o(r,"[[Promise]]",t),o(r,"[[AlreadyResolved]]",e);var n=i();return o(n,"[[Promise]]",t),o(n,"[[AlreadyResolved]]",e),{"[[Resolve]]":r,"[[Reject]]":n}}function i(){var t=function(e){var r=t["[[Promise]]"],n=t["[[AlreadyResolved]]"];return n["[[value]]"]?C:(o(n,"[[value]]",!0),v(r,e))};return t}function u(){var t=function(e){var r=t["[[Promise]]"],n=t["[[AlreadyResolved]]"];if(n["[[value]]"])return C;if(o(n,"[[value]]",!0),h(e,r)){var i=TypeError();return v(r,i)}if("object"!==a(e))return c(r,e);try{var u=e.then}catch(u){return v(r,u)}return l(u)?(T("PromiseJobs",b,[r,e,u]),C):c(r,e)};return t}function c(t,e){var r=t["[[PromiseFulfillReactions]]"];return o(t,"[[PromiseResult]]",e),o(t,"[[PromiseFulfillReactions]]",C),o(t,"[[PromiseRejectReactions]]",C),o(t,"[[PromiseState]]","fulfilled"),d(r,e)}function s(t){return f(C,t)}function f(t,e){var r={};o(r,"[[Promise]]",t),o(r,"[[Resolve]]",C),o(r,"[[Reject]]",C);var n=p();o(n,"[[Capability]]",r);var i=t=new e(n);if(o(r,"[[Promise]]",t),!l(r["[[Resolve]]"]))throw TypeError();if(!l(r["[[Reject]]"]))throw TypeError();if("object"===a(i)&&!h(t,i))throw TypeError();return r}function p(){var t=function(e,r){var n=t["[[Capability]]"];if(n["[[Resolve]]"]!==C)throw TypeError();if(n["[[Reject]]"]!==C)throw TypeError();return o(n,"[[Resolve]]",e),o(n,"[[Reject]]",r),C};return t}function y(t){return"object"===a(t)&&("[[PromiseState]]"in t&&t["[[PromiseState]]"]!==C)}function v(t,e){var r=t["[[PromiseRejectReactions]]"];return o(t,"[[PromiseResult]]",e),o(t,"[[PromiseFulfillReactions]]",C),o(t,"[[PromiseRejectReactions]]",C),o(t,"[[PromiseState]]","rejected"),d(r,e)}function d(t,e){for(var r=0,n=t.length;r<n;++r)T("PromiseJobs",m,[t[r],e]);return C}function m(t,e){var r,n,o=t["[[Capabilities]]"],i=t["[[Handler]]"];try{if("Identity"===i)r=e;else{if("Thrower"===i)throw e;r=i.call(C,e)}}catch(r){return n=o["[[Reject]]"].call(C,r),void j(n)}j(n=o["[[Resolve]]"].call(C,r))}function b(t,e,n){var o=r(t);try{var i=n.call(e,o["[[Resolve]]"],o["[[Reject]]"])}catch(i){return void j(o["[[Reject]]"].call(C,i))}j(i)}function E(t){var e={configurable:!1,enumerable:!1,writable:!0,value:C};Object.defineProperty(this,"[[PromiseState]]",e),Object.defineProperty(this,"[[PromiseConstructor]]",e),Object.defineProperty(this,"[[PromiseResult]]",e),Object.defineProperty(this,"[[PromiseFulfillReactions]]",e),Object.defineProperty(this,"[[PromiseRejectReactions]]",e);var r=this;if("object"!==a(r))throw new TypeError;if(!("[[PromiseState]]"in r))throw TypeError();if(r["[[PromiseState]]"]!==C)throw TypeError();if(!l(t))throw TypeError();return o(r,"[[PromiseConstructor]]",E),O(r,t)}function O(t,e){o(t,"[[PromiseState]]","pending"),o(t,"[[PromiseFulfillReactions]]",[]),o(t,"[[PromiseRejectReactions]]",[]);var n=r(t);try{var i=e.call(C,n["[[Resolve]]"],n["[[Reject]]"])}catch(i){n["[[Reject]]"].call(C,i)}return t}function _(){var t=function(e){var r=t["[[AlreadyCalled]]"];if(r.value)return C;r.value=!0;var n=t["[[Index]]"],o=t["[[Values]]"],i=t["[[Capabilities]]"],a=t["[[RemainingElements]]"];try{o[n]=e}catch(u){return i["[[Reject]]"].call(C,u),i["[[Promise]]"]}return a.value-=1,0===a.value?i["[[Resolve]]"].call(C,o):C};return t}n(E,"all",function(t){var r=e(this),n=s(r);try{var i=g(t)}catch(y){return n["[[Reject]]"].call(C,y),n["[[Promise]]"]}for(var a=[],u={value:1},c=0;;){try{var f=S(i)}catch(y){return n["[[Reject]]"].call(C,y),n["[[Promise]]"]}if(!f){if(u.value-=1,0===u.value)n["[[Resolve]]"].apply(C,a);return n["[[Promise]]"]}try{var l=w(f)}catch(y){return n["[[Reject]]"].call(C,y),n["[[Promise]]"]}try{var p=r.resolve(l)}catch(y){return n["[[Reject]]"].call(C,y),n["[[Promise]]"]}var h=_();o(h,"[[AlreadyCalled]]",{value:!1}),o(h,"[[Index]]",c),o(h,"[[Values]]",a),o(h,"[[Capabilities]]",n),o(h,"[[RemainingElements]]",u),u.value+=1;try{p.then(h,n["[[Reject]]"])}catch(y){return n["[[Reject]]"].call(C,y),n["[[Promise]]"]}c+=1}}),E.prototype={},n(E,"race",function(t){var r=e(this),n=s(r);try{var o=g(t)}catch(c){return n["[[Reject]]"].call(C,c),n["[[Promise]]"]}for(;;){try{var i=S(o)}catch(c){return n["[[Reject]]"].call(C,c),n["[[Promise]]"]}if(!i)return n["[[Promise]]"];try{var a=w(i)}catch(c){return n["[[Reject]]"].call(C,c),n["[[Promise]]"]}try{var u=r.resolve(a)}catch(c){return n["[[Reject]]"].call(C,c),n["[[Promise]]"]}try{u.then(n["[[Resolve]]"],n["[[Reject]]"])}catch(c){return n["[[Reject]]"].call(C,c),n["[[Promise]]"]}}}),n(E,"reject",function(t){var r=s(e(this));r["[[Reject]]"].call(C,t);return r["[[Promise]]"]}),n(E,"resolve",function(t){var r=e(this);if(y(t)&&h(t["[[PromiseConstructor]]"],r))return t;var n=s(r);n["[[Resolve]]"].call(C,t);return n["[[Promise]]"]}),n(E.prototype,"catch",function(t){return this.then(C,t)}),E.prototype.constructor=E,n(E.prototype,"then",function(t,e){var r=this;if(!y(r))throw TypeError();l(t)||(t="Identity"),l(e)||(e="Thrower");var n=s(r.constructor),o={"[[Capabilities]]":n,"[[Handler]]":t},i={"[[Capabilities]]":n,"[[Handler]]":e};return"pending"===r["[[PromiseState]]"]?(r["[[PromiseFulfillReactions]]"].push(o),r["[[PromiseRejectReactions]]"].push(i)):"fulfilled"===r["[[PromiseState]]"]?T("PromiseJobs",m,[o,r["[[PromiseResult]]"]]):"rejected"===r["[[PromiseState]]"]&&T("PromiseJobs",m,[i,r["[[PromiseResult]]"]]),n["[[Promise]]"]}),"Promise"in t&&!I||(t.Promise=E),"cast"in t.Promise&&(t.Promise.resolve=t.Promise.cast)}(),n(Promise.prototype,ft,"Promise"),"Reflect"in t&&!I||(t.Reflect={}),n(Reflect,"apply",function(t,e,r){if(!l(t))throw TypeError();return Function.prototype.apply.call(t,e,r)}),n(Reflect,"construct",function(t,e){return __cons(t,e)}),n(Reflect,"defineProperty",function(t,e,r){try{return Object.defineProperty(t,e,r),!0}catch(n){return!1}}),n(Reflect,"deleteProperty",function(t,e){try{return delete t[e],!b(t,e)}catch(r){return!1}}),n(Reflect,"enumerate",function(t){return _(t=s(t))}),n(Reflect,"get",function(t,e,n){t=s(t),e=String(e),n=n===C?t:s(n);var o=r(t,e);return o&&"get"in o?Function.prototype.call.call(o.get,n):t[e]}),n(Reflect,"getOwnPropertyDescriptor",Object.getOwnPropertyDescriptor),n(Reflect,"getPrototypeOf",Object.getPrototypeOf),n(Reflect,"has",function(t,e){return String(e)in s(t)}),n(Reflect,"isExtensible",Object.isExtensible),n(Reflect,"ownKeys",function(t){var e=s(t);return Object.getOwnPropertyNames(e)}),n(Reflect,"preventExtensions",function(t){try{return Object.preventExtensions(t),!0}catch(e){return!1}}),n(Reflect,"set",function(t,e,n,o){t=s(t),e=String(e),o=o===C?t:s(o);var i=r(t,e);try{return i&&"set"in i?Function.prototype.call.call(i.set,o,n):t[e]=n,!0}catch(a){return!1}}),n(Reflect,"setPrototypeOf",function(t,e){try{return t.__proto__=e,Reflect.getPrototypeOf(t)===e}catch(r){return!1}})}(self),function(t){"use strict";function e(t){return t=Number(t),a(t)?0:0===t||t===Infinity||t===-Infinity?t:(t<0?-1:1)*c(u(t))}function r(t){if(null===t||t===i)throw TypeError();return Object(t)}function n(t){var r=e(t);return r<=0?0:s(r,9007199254740991)}function o(t,e){if(typeof t!=typeof e)return!1;switch(typeof t){case"undefined":return!0;case"number":return t!==t&&e!==e||t===e;case"boolean":case"string":case"object":default:return t===e}}var i=void 0,a=t.isNaN,u=Math.abs,c=Math.floor,s=(Math.max,Math.min);!function(t,e,r,n){e in t&&!n||("function"==typeof r?Object.defineProperty(t,e,{value:r,configurable:!0,enumerable:!1,writable:!0}):Object.defineProperty(t,e,{value:r,configurable:!1,enumerable:!1,writable:!1}))}(Array.prototype,"includes",function(t){var i=arguments[1],a=r(this),u=n(a.length);if(0===u)return!1;var c=e(i);if(c>=0)var s=c;else(s=u+c)<0&&(s=0);for(;s<u;){a[s];if(o(a[s],t))return!0;s+=1}return!1})}(this),function(t){"use strict";function e(t,e,r,n){e in t&&!n||("function"==typeof r?Object.defineProperty(t,e,{value:r,configurable:!0,enumerable:!1,writable:!0}):Object.defineProperty(t,e,{value:r,configurable:!1,enumerable:!1,writable:!1}))}function r(t){return t=Number(t),c(t)?0:0===t||t===Infinity||t===-Infinity?t:(t<0?-1:1)*f(s(t))}function n(t){if(null===t||t===u)throw TypeError();return Object(t)}function o(t){var e=r(t);return e<=0?0:l(e,9007199254740991)}function i(t,e,r){Object.defineProperty(t,e,{value:r,writable:!0,enumerable:!0,configurable:!0})}function a(t,e){var r=[];return Object.keys(t).forEach(function(n){var o=Object.getOwnPropertyDescriptor(t,n);if(o&&o.enumerable)if("key"===e)r.push(n);else{var i=t[n];"value"===e?r.push(i):r.push([n,i])}}),r}var u=void 0,c=t.isNaN,s=Math.abs,f=Math.floor,l=Math.min;e(Object,"entries",function(t){return a(n(t),"key+value")}),e(Object,"getOwnPropertyDescriptors",function(t){for(var e=n(t),r=Object.getOwnPropertyNames(e),o={},a=0;a<r.length;++a){var u=r[a];i(o,u,Object.getOwnPropertyDescriptor(e,u))}return o}),e(Object,"values",function(t){return a(n(t),"value")}),e(String.prototype,"padEnd",function(t){var e=arguments[1],r=String(this),n=r.length;if(e===u)var i="";else i=String(e);""===i&&(i=" ");var a=o(t);if(a<=n)return r;for(var c=a-n,s="";s.length<c;)s+=i;return r+s.substring(0,c)}),e(String.prototype,"padStart",function(t){var e=arguments[1],r=String(this),n=r.length;if(e===u)var i="";else i=String(e);""===i&&(i=" ");var a=o(t);if(a<=n)return r;for(var c=a-n,s="";s.length<c;)s+=i;return s.substring(0,c)+r})}(this),function(t){"use strict";"window"in t&&"document"in t&&("head"in document||(document.head=document.getElementsByTagName("head")[0]),["abbr","article","aside","audio","bdi","canvas","data","datalist","details","dialog","figcaption","figure","footer","header","hgroup","main","mark","meter","nav","output","picture","progress","section","summary","template","time","video"].forEach(function(t){document.createElement(t)}),!("dataset"in document.createElement("span"))&&"Element"in t&&Element.prototype&&Object.defineProperty&&Object.defineProperty(Element.prototype,"dataset",{get:function(){for(var t=Object.create(null),e=0;e<this.attributes.length;++e){var r=this.attributes[e];r.specified&&"data-"===r.name.substring(0,5)&&function(e,r){var n=r.replace(/-([a-z])/g,function(t,e){return e.toUpperCase()});t[n]=e.getAttribute("data-"+r),Object.defineProperty(t,n,{get:function(){return e.getAttribute("data-"+r)},set:function(t){e.setAttribute("data-"+r,t)}})}(this,r.name.substring(5))}return t}}),function(){if(!("atob"in t&&"btoa"in t)){var e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";t.atob=function(t){var r=0,n=[],o=0,i=0;if((t=(t=String(t)).replace(/\s/g,"")).length%4==0&&(t=t.replace(/=+$/,"")),t.length%4==1)throw Error("InvalidCharacterError");if(/[^+/0-9A-Za-z]/.test(t))throw Error("InvalidCharacterError");for(;r<t.length;)o=o<<6|e.indexOf(t.charAt(r)),24===(i+=6)&&(n.push(String.fromCharCode(o>>16&255)),n.push(String.fromCharCode(o>>8&255)),n.push(String.fromCharCode(255&o)),i=0,o=0),r+=1;return 12===i?(o>>=4,n.push(String.fromCharCode(255&o))):18===i&&(o>>=2,n.push(String.fromCharCode(o>>8&255)),n.push(String.fromCharCode(255&o))),n.join("")},t.btoa=function(t){t=String(t);var r,n,o,i,a,u,c,s=0,f=[];if(/[^\x00-\xFF]/.test(t))throw Error("InvalidCharacterError");for(;s<t.length;)i=(r=t.charCodeAt(s++))>>2,a=(3&r)<<4|(n=t.charCodeAt(s++))>>4,u=(15&n)<<2|(o=t.charCodeAt(s++))>>6,c=63&o,s===t.length+2?(u=64,c=64):s===t.length+1&&(c=64),f.push(e.charAt(i),e.charAt(a),e.charAt(u),e.charAt(c));return f.join("")}}}(),function(){function e(t){return t.offsetWidth>0&&t.offsetHeight>0}function r(){var t=o;o=Object.create(null),a=-1,Object.keys(t).forEach(function(r){var n=t[r];n.element&&!e(n.element)||n.callback(Date.now())})}if(!("requestAnimationFrame"in t)){var n=60,o=Object.create(null),i=0,a=-1;t.requestAnimationFrame=function(e,u){var c=++i;return o[c]={callback:e,element:u},-1===a&&(a=t.setTimeout(r,1e3/n)),c},t.cancelAnimationFrame=function(e){delete o[e],0===Object.keys(o).length&&(t.clearTimeout(a),a=-1)}}}())}(self),function(t){"use strict";function e(t,e){t&&Object.keys(e).forEach(function(r){if(!(r in t||r in t.prototype))try{Object.defineProperty(t.prototype,r,Object.getOwnPropertyDescriptor(e,r))}catch(n){t[r]=e[r]}})}function r(t){var e=null;return 1===(t=t.map(function(t){return t instanceof Node?t:document.createTextNode(t)})).length?e=t[0]:(e=document.createDocumentFragment(),t.forEach(function(t){e.appendChild(t)})),e}if("window"in t&&"document"in t){document.querySelectorAll||(document.querySelectorAll=function(t){var e,r=document.createElement("style"),n=[];for(document.documentElement.firstChild.appendChild(r),document._qsa=[],r.styleSheet.cssText=t+"{x-qsa:expression(document._qsa && document._qsa.push(this))}",window.scrollBy(0,0),r.parentNode.removeChild(r);document._qsa.length;)(e=document._qsa.shift()).style.removeAttribute("x-qsa"),n.push(e);return document._qsa=null,n}),document.querySelector||(document.querySelector=function(t){var e=document.querySelectorAll(t);return e.length?e[0]:null}),document.getElementsByClassName||(document.getElementsByClassName=function(t){return t=String(t).replace(/^|\s+/g,"."),document.querySelectorAll(t)}),t.Node=t.Node||function(){throw TypeError("Illegal constructor")},[["ELEMENT_NODE",1],["ATTRIBUTE_NODE",2],["TEXT_NODE",3],["CDATA_SECTION_NODE",4],["ENTITY_REFERENCE_NODE",5],["ENTITY_NODE",6],["PROCESSING_INSTRUCTION_NODE",7],["COMMENT_NODE",8],["DOCUMENT_NODE",9],["DOCUMENT_TYPE_NODE",10],["DOCUMENT_FRAGMENT_NODE",11],["NOTATION_NODE",12]].forEach(function(e){e[0]in t.Node||(t.Node[e[0]]=e[1])}),t.DOMException=t.DOMException||function(){throw TypeError("Illegal constructor")},[["INDEX_SIZE_ERR",1],["DOMSTRING_SIZE_ERR",2],["HIERARCHY_REQUEST_ERR",3],["WRONG_DOCUMENT_ERR",4],["INVALID_CHARACTER_ERR",5],["NO_DATA_ALLOWED_ERR",6],["NO_MODIFICATION_ALLOWED_ERR",7],["NOT_FOUND_ERR",8],["NOT_SUPPORTED_ERR",9],["INUSE_ATTRIBUTE_ERR",10],["INVALID_STATE_ERR",11],["SYNTAX_ERR",12],["INVALID_MODIFICATION_ERR",13],["NAMESPACE_ERR",14],["INVALID_ACCESS_ERR",15]].forEach(function(e){e[0]in t.DOMException||(t.DOMException[e[0]]=e[1])}),function(){function e(t,e,r){if("function"==typeof e){"DOMContentLoaded"===t&&(t="load");var n=this,o=function(t){t._timeStamp=Date.now(),t._currentTarget=n,e.call(this,t),t._currentTarget=null};this["_"+t+e]=o,this.attachEvent("on"+t,o)}}function r(t,e,r){if("function"==typeof e){"DOMContentLoaded"===t&&(t="load");var n=this["_"+t+e];n&&(this.detachEvent("on"+t,n),this["_"+t+e]=null)}}"Element"in t&&!Element.prototype.addEventListener&&Object.defineProperty&&(Event.CAPTURING_PHASE=1,Event.AT_TARGET=2,Event.BUBBLING_PHASE=3,Object.defineProperties(Event.prototype,{CAPTURING_PHASE:{get:function(){return 1}},AT_TARGET:{get:function(){return 2}},BUBBLING_PHASE:{get:function(){return 3}},target:{get:function(){return this.srcElement}},currentTarget:{get:function(){return this._currentTarget}},eventPhase:{get:function(){return this.srcElement===this.currentTarget?Event.AT_TARGET:Event.BUBBLING_PHASE}},bubbles:{get:function(){switch(this.type){case"click":case"dblclick":case"mousedown":case"mouseup":case"mouseover":case"mousemove":case"mouseout":case"mousewheel":case"keydown":case"keypress":case"keyup":case"resize":case"scroll":case"select":case"change":case"submit":case"reset":return!0}return!1}},cancelable:{get:function(){switch(this.type){case"click":case"dblclick":case"mousedown":case"mouseup":case"mouseover":case"mouseout":case"mousewheel":case"keydown":case"keypress":case"keyup":case"submit":return!0}return!1}},timeStamp:{get:function(){return this._timeStamp}},stopPropagation:{value:function(){this.cancelBubble=!0}},preventDefault:{value:function(){this.returnValue=!1}},defaultPrevented:{get:function(){return!1===this.returnValue}}}),[Window,HTMLDocument,Element].forEach(function(t){t.prototype.addEventListener=e,t.prototype.removeEventListener=r}))}(),function(){function e(t,e){e=e||{bubbles:!1,cancelable:!1,detail:undefined};var r=document.createEvent("CustomEvent");return r.initCustomEvent(t,e.bubbles,e.cancelable,e.detail),r}"CustomEvent"in t&&"function"==typeof t.CustomEvent||(e.prototype=t.Event.prototype,t.CustomEvent=e)}(),window.addEvent=function(t,e,r){t.addEventListener?t.addEventListener(e,r,!1):t.attachEvent&&(t["e"+e+r]=r,t[e+r]=function(){var n=window.event;n.currentTarget=t,n.preventDefault=function(){n.returnValue=!1},n.stopPropagation=function(){n.cancelBubble=!0},n.target=n.srcElement,n.timeStamp=Date.now(),t["e"+e+r].call(this,n)},t.attachEvent("on"+e,t[e+r]))},window.removeEvent=function(t,e,r){t.removeEventListener?t.removeEventListener(e,r,!1):t.detachEvent&&(t.detachEvent("on"+e,t[e+r]),t[e+r]=null,t["e"+e+r]=null)},function(){function e(t,e){function r(t){return t.length?t.split(/\s+/g):[]}function n(t,e){var n=r(e),o=n.indexOf(t);return-1!==o&&n.splice(o,1),n.join(" ")}if(Object.defineProperties(this,{length:{get:function(){return r(t[e]).length}},item:{value:function(n){var o=r(t[e]);return 0<=n&&n<o.length?o[n]:null}},contains:{value:function(n){if(0===(n=String(n)).length)throw SyntaxError();if(/\s/.test(n))throw Error("InvalidCharacterError");return-1!==r(t[e]).indexOf(n)}},add:{value:function(){var n=Array.prototype.slice.call(arguments).map(String);if(n.some(function(t){return 0===t.length}))throw SyntaxError();if(n.some(function(t){return/\s/.test(t)}))throw Error("InvalidCharacterError");try{var o=t[e],i=r(o);if(0===(n=n.filter(function(t){return-1===i.indexOf(t)})).length)return;0===o.length||/\s$/.test(o)||(o+=" "),o+=n.join(" "),t[e]=o}finally{var a=r(t[e]).length;this.length!==a&&(this.length=a)}}},remove:{value:function(){var o=Array.prototype.slice.call(arguments).map(String);if(o.some(function(t){return 0===t.length}))throw SyntaxError();if(o.some(function(t){return/\s/.test(t)}))throw Error("InvalidCharacterError");try{var i=t[e];o.forEach(function(t){i=n(t,i)}),t[e]=i}finally{var a=r(t[e]).length;this.length!==a&&(this.length=a)}}},toggle:{value:function(o){var i=arguments[1];try{if(0===(o=String(o)).length)throw SyntaxError();if(/\s/.test(o))throw Error("InvalidCharacterError");var a=r(t[e]).indexOf(o);if(-1!==a&&(!i||void 0===i))return t[e]=n(o,t[e]),!1;if(-1!==a&&i)return!0;var u=t[e];return 0===u.length||/\s$/.test(u)||(u+=" "),u+=o,t[e]=u,!0}finally{var c=r(t[e]).length;this.length!==c&&(this.length=c)}}},toString:{value:function(){return t[e]}}}),"length"in this)for(var o=0;o<100;++o)Object.defineProperty(this,String(o),{get:function(t){return function(){return this.item(t)}}(o)});else this.length=r(t[e]).length}function r(e,r){"Element"in t&&Element.prototype&&Object.defineProperty&&Object.defineProperty(Element.prototype,e,{get:r})}"classList"in document.createElement("span")?window.getClassList=function(t){return t.classList}:(window.getClassList=function(t){return new e(t,"className")},r("classList",function(){return new e(this,"className")})),"relList"in document.createElement("link")?window.getRelList=function(t){return t.relList}:(window.getRelList=function(t){return new e(t,"rel")},r("relList",function(){return new e(this,"rel")})),function(){if("DOMTokenList"in t){var e=document.createElement("span");"classList"in e&&(e.classList.toggle("x",!1),e.classList.contains("x")&&(t.DOMTokenList.prototype.toggle=function(t){var e=arguments[1];if(e===undefined){var r=!this.contains(t);return this[r?"add":"remove"](t),r}return e=!!e,this[e?"add":"remove"](t),e}))}}(),"previousElementSibling"in document.documentElement||r("previousElementSibling",function(){for(var t=this.previousSibling;t&&t.nodeType!==Node.ELEMENT_NODE;)t=t.previousSibling;return t}),"nextElementSibling"in document.documentElement||r("nextElementSibling",function(){for(var t=this.nextSibling;t&&t.nodeType!==Node.ELEMENT_NODE;)t=t.nextSibling;return t})}(),"Element"in t&&!Element.prototype.matches&&(Element.prototype.msMatchesSelector?Element.prototype.matches=Element.prototype.msMatchesSelector:Element.prototype.oMatchesSelector?Element.prototype.matches=Element.prototype.oMatchesSelector:Element.prototype.mozMatchesSelector?Element.prototype.matches=Element.prototype.mozMatchesSelector:Element.prototype.webkitMatchesSelector?Element.prototype.matches=Element.prototype.webkitMatchesSelector:document.querySelectorAll&&(Element.prototype.matches=function(t){for(var e=(this.document||this.ownerDocument).querySelectorAll(t),r=e.length;--r>=0&&e.item(r)!==this;);return r>-1})),window.Element&&!Element.prototype.closest&&(Element.prototype.closest=function(t){var e,r=(this.document||this.ownerDocument).querySelectorAll(t),n=this;do{for(e=r.length;--e>=0&&r.item(e)!==n;);}while(e<0&&(n=n.parentElement));return n});var n={prepend:function(){var t=[].slice.call(arguments);t=r(t),this.insertBefore(t,this.firstChild)},append:function(){var t=[].slice.call(arguments);t=r(t),this.appendChild(t)}};e(t.Document||t.HTMLDocument,n),e(t.DocumentFragment,n),e(t.Element,n);var o={before:function(){var t=[].slice.call(arguments),e=this.parentNode;if(e){for(var n=this.previousSibling;-1!==t.indexOf(n);)n=n.previousSibling;var o=r(t);e.insertBefore(o,n?n.nextSibling:e.firstChild)}},after:function(){var t=[].slice.call(arguments),e=this.parentNode;if(e){for(var n=this.nextSibling;-1!==t.indexOf(n);)n=n.nextSibling;var o=r(t);e.insertBefore(o,n)}},replaceWith:function(){var t=[].slice.call(arguments),e=this.parentNode;if(e){for(var n=this.nextSibling;-1!==t.indexOf(n);)n=n.nextSibling;var o=r(t);this.parentNode===e?e.replaceChild(o,this):e.insertBefore(o,n)}},remove:function(){this.parentNode&&this.parentNode.removeChild(this)}};e(t.DocumentType,o),e(t.Element,o),e(t.CharacterData,o)}}(self),function(t){"use strict";"window"in t&&"document"in t&&(t.XMLHttpRequest=t.XMLHttpRequest||function(){try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(t){}throw Error("This browser does not support XMLHttpRequest.")},[["UNSENT",0],["OPENED",1],["HEADERS_RECEIVED",2],["LOADING",3],["DONE",4]].forEach(function(e){e[0]in t.XMLHttpRequest||(t.XMLHttpRequest[e[0]]=e[1])}),function(){function e(t){if(this._data=[],t)for(var e=0;e<t.elements.length;++e){var r=t.elements[e];""!==r.name&&this.append(r.name,r.value)}}if(!("FormData"in t)){e.prototype={append:function(e,r){if("Blob"in t&&r instanceof t.Blob)throw TypeError("Blob not supported");e=String(e),this._data.push([e,r])},toString:function(){return this._data.map(function(t){return encodeURIComponent(t[0])+"="+encodeURIComponent(t[1])}).join("&")}},t.FormData=e;var r=t.XMLHttpRequest.prototype.send;t.XMLHttpRequest.prototype.send=function(t){return t instanceof e&&(this.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),arguments[0]=t.toString()),r.apply(this,arguments)}}}())}(self),function(t){"use strict";"window"in t&&"document"in t&&"TextRectangle"in t&&!("width"in t.TextRectangle.prototype)&&Object.defineProperties(t.TextRectangle.prototype,{width:{get:function(){return this.right-this.left}},height:{get:function(){return this.bottom-this.top}}})}(self),function(t){"use strict";function e(e){return!!e&&("Symbol"in t&&"iterator"in t.Symbol&&"function"==typeof e[Symbol.iterator]||!!Array.isArray(e))}function r(t){return"from"in Array?Array.from(t):Array.prototype.slice.call(t)}!function(){function n(t){var e="",r=!0;return t.forEach(function(t){var n=encodeURIComponent(t.name),o=encodeURIComponent(t.value);r||(e+="&"),e+=n+"="+o,r=!1}),e.replace(/%20/g,"+")}function o(t,e){var r=t.split("&");e&&-1===r[0].indexOf("=")&&(r[0]="="+r[0]);var n=[];r.forEach(function(t){if(0!==t.length){var e=t.indexOf("=");if(-1!==e)var r=t.substring(0,e),o=t.substring(e+1);else r=t,o="";r=r.replace(/\+/g," "),o=o.replace(/\+/g," "),n.push({name:r,value:o})}});var o=[];return n.forEach(function(t){o.push({name:decodeURIComponent(t.name),value:decodeURIComponent(t.value)})}),o}function i(t){if(s)return new f(t);var e=document.createElement("a");return e.href=t,e}function a(t){var i=this;this._list=[],t===undefined||null===t||(t instanceof a?this._list=o(String(t)):"object"==typeof t&&e(t)?r(t).forEach(function(t){if(!e(t))throw TypeError();var n=r(t);if(2!==n.length)throw TypeError();i._list.push({name:String(n[0]),value:String(n[1])})}):"object"==typeof t&&t?Object.keys(t).forEach(function(e){i._list.push({name:String(e),value:String(t[e])})}):("?"===(t=String(t)).substring(0,1)&&(t=t.substring(1)),this._list=o(t))),this._url_object=null,this._setList=function(t){u||(i._list=t)};var u=!1;this._update_steps=function(){u||(u=!0,i._url_object&&("about:"===i._url_object.protocol&&-1!==i._url_object.pathname.indexOf("?")&&(i._url_object.pathname=i._url_object.pathname.split("?")[0]),i._url_object.search=n(i._list),u=!1))}}function u(t,e){var r=0;this.next=function(){if(r>=t.length)return{done:!0,value:undefined};var n=t[r++];return{done:!1,value:"key"===e?n.name:"value"===e?n.value:[n.name,n.value]}}}function c(e,r){function n(){var t=c.href.replace(/#$|\?$|\?(?=#)/g,"");c.href!==t&&(c.href=t)}function u(){p._setList(c.search?o(c.search.substring(1)):[]),p._update_steps()}if(!(this instanceof t.URL))throw new TypeError("Failed to construct 'URL': Please use the 'new' operator.");r&&(e=function(){if(s)return new f(e,r).href;var t;try{var n;if("[object OperaMini]"===Object.prototype.toString.call(window.operamini)?((t=document.createElement("iframe")).style.display="none",document.documentElement.appendChild(t),n=t.contentWindow.document):document.implementation&&document.implementation.createHTMLDocument?n=document.implementation.createHTMLDocument(""):document.implementation&&document.implementation.createDocument?((n=document.implementation.createDocument("http://www.w3.org/1999/xhtml","html",null)).documentElement.appendChild(n.createElement("head")),n.documentElement.appendChild(n.createElement("body"))):window.ActiveXObject&&((n=new window.ActiveXObject("htmlfile")).write("<head></head><body></body>"),n.close()),!n)throw Error("base not supported");var o=n.createElement("base");o.href=r,n.getElementsByTagName("head")[0].appendChild(o);var i=n.createElement("a");return i.href=e,i.href}finally{t&&t.parentNode.removeChild(t)}}());var c=i(e||""),l=function(){if(!("defineProperties"in Object))return!1;try{var t={};return Object.defineProperties(t,{prop:{get:function(){return!0}}}),t.prop}catch(e){return!1}}()?this:document.createElement("a"),p=new a(c.search?c.search.substring(1):null);return p._url_object=l,Object.defineProperties(l,{href:{get:function(){return c.href},set:function(t){c.href=t,n(),u()},enumerable:!0,configurable:!0},origin:{get:function(){return"origin"in c?c.origin:this.protocol+"//"+this.host},enumerable:!0,configurable:!0},protocol:{get:function(){return c.protocol},set:function(t){c.protocol=t},enumerable:!0,configurable:!0},username:{get:function(){return c.username},set:function(t){c.username=t},enumerable:!0,configurable:!0},password:{get:function(){return c.password},set:function(t){c.password=t},enumerable:!0,configurable:!0},host:{get:function(){var t={"http:":/:80$/,"https:":/:443$/,"ftp:":/:21$/}[c.protocol];return t?c.host.replace(t,""):c.host},set:function(t){c.host=t},enumerable:!0,configurable:!0},hostname:{get:function(){return c.hostname},set:function(t){c.hostname=t},enumerable:!0,configurable:!0},port:{get:function(){return c.port},set:function(t){c.port=t},enumerable:!0,configurable:!0},pathname:{get:function(){return"/"!==c.pathname.charAt(0)?"/"+c.pathname:c.pathname},set:function(t){c.pathname=t},enumerable:!0,configurable:!0},search:{get:function(){return c.search},set:function(t){c.search!==t&&(c.search=t,n(),u())},enumerable:!0,configurable:!0},searchParams:{get:function(){return p},enumerable:!0,configurable:!0},hash:{get:function(){return c.hash},set:function(t){c.hash=t,n()},enumerable:!0,configurable:!0},toString:{value:function(){return c.toString()},enumerable:!1,configurable:!0},valueOf:{value:function(){return c.valueOf()},enumerable:!1,configurable:!0}}),l}var s,f=t.URL;try{if(f){if("searchParams"in(s=new t.URL("http://example.com")))return;"href"in s||(s=undefined)}}catch(p){}if(Object.defineProperties(a.prototype,{append:{value:function(t,e){this._list.push({name:t,value:e}),this._update_steps()},writable:!0,enumerable:!0,configurable:!0},"delete":{value:function(t){for(var e=0;e<this._list.length;)this._list[e].name===t?this._list.splice(e,1):++e;this._update_steps()},writable:!0,enumerable:!0,configurable:!0},get:{value:function(t){for(var e=0;e<this._list.length;++e)if(this._list[e].name===t)return this._list[e].value;return null},writable:!0,enumerable:!0,configurable:!0},getAll:{value:function(t){for(var e=[],r=0;r<this._list.length;++r)this._list[r].name===t&&e.push(this._list[r].value);return e},writable:!0,enumerable:!0,configurable:!0},has:{value:function(t){for(var e=0;e<this._list.length;++e)if(this._list[e].name===t)return!0;return!1},writable:!0,enumerable:!0,configurable:!0},set:{value:function(t,e){for(var r=!1,n=0;n<this._list.length;)this._list[n].name===t?r?this._list.splice(n,1):(this._list[n].value=e,r=!0,++n):++n;r||this._list.push({name:t,value:e}),this._update_steps()},writable:!0,enumerable:!0,configurable:!0},entries:{value:function(){return new u(this._list,"key+value")},writable:!0,enumerable:!0,configurable:!0},keys:{value:function(){return new u(this._list,"key")},writable:!0,enumerable:!0,configurable:!0},values:{value:function(){return new u(this._list,"value")},writable:!0,enumerable:!0,configurable:!0},forEach:{value:function(t){var e=arguments.length>1?arguments[1]:undefined;this._list.forEach(function(r,n){t.call(e,r.value,r.name)})},writable:!0,enumerable:!0,configurable:!0},toString:{value:function(){return n(this._list)},writable:!0,enumerable:!1,configurable:!0}}),"Symbol"in t&&"iterator"in t.Symbol&&(Object.defineProperty(a.prototype,t.Symbol.iterator,{value:a.prototype.entries,writable:!0,enumerable:!0,configurable:!0}),Object.defineProperty(u.prototype,t.Symbol.iterator,{value:function(){return this},writable:!0,enumerable:!0,configurable:!0})),f)for(var l in f)f.hasOwnProperty(l)&&"function"==typeof f[l]&&(c[l]=f[l]);t.URL=c,t.URLSearchParams=a}(),function(){if("1"!==new t.URLSearchParams([["a",1]]).get("a")||"1"!==new t.URLSearchParams({a:1}).get("a")){var n=t.URLSearchParams;t.URLSearchParams=function(t){if(t&&"object"==typeof t&&e(t)){var o=new n;return r(t).forEach(function(t){if(!e(t))throw TypeError();var n=r(t);if(2!==n.length)throw TypeError();o.append(n[0],n[1])}),o}return t&&"object"==typeof t?(o=new n,Object.keys(t).forEach(function(e){o.set(e,t[e])}),o):new n(t)}}}()}(self),function(t){"use strict";function e(t){if((t=String(t)).match(/[^\x00-\xFF]/))throw TypeError("Not a valid ByteString");return t}function r(t){return(t=String(t)).replace(/([\u0000-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDFFF])/g,function(t){return/^[\uD800-\uDFFF]$/.test(t)?"�":t})}function n(t){return 65535&t}function o(t){return String(t).replace(/[a-z]/g,function(t){return t.toUpperCase()})}function i(t){return"CONNECT"===(t=o(t))||"TRACE"===t||"TRACK"===t}function a(t){var e=o(t);return"DELETE"===e||"GET"===e||"HEAD"===e||"OPTIONS"===e||"POST"===e||"PUT"===e?e:t}function u(t){return/^[!#$%&'*+\-.09A-Z^_`a-z|~]+$/.test(t)}function c(t){return{"accept-charset":!0,"accept-encoding":!0,"access-control-request-headers":!0,"access-control-request-method":!0,connection:!0,"content-length":!0,cookie:!0,cookie2:!0,date:!0,dnt:!0,expect:!0,host:!0,"keep-alive":!0,origin:!0,referer:!0,te:!0,trailer:!0,"transfer-encoding":!0,upgrade:!0,"user-agent":!0,via:!0}[t=String(t).toLowerCase()]||"proxy-"===t.substring(0,6)||"sec-"===t.substring(0,4)}function s(t){return{"set-cookie":!0,"set-cookie2":!0}[t=String(t).toLowerCase()]}function f(t,e){return"accept"===(t=String(t).toLowerCase())||"accept-language"===t||"content-language"===t||"content-type"===t&&-1!==["application/x-www-form-encoded","multipart/form-data","text/plain"].indexOf(e)}function l(t){this._guard="none",this._headerList=[],t&&p(this,t)}function p(t,e){e instanceof l?e._headerList.forEach(function(e){t.append(e[0],e[1])}):Array.isArray(e)?e.forEach(function(e){if(!Array.isArray(e)||2!==e.length)throw TypeError();t.append(e[0],e[1])}):(e=Object(e),Object.keys(e).forEach(function(r){t.append(r,e[r])}))}function h(t){this._headers=t,this._index=0}function y(t){this._stream=t,this.bodyUsed=!1}function v(t,n){if(arguments.length<1)throw TypeError("Not enough arguments");if(y.call(this,null),this.method="GET",this.url="",this.headers=new l,this.headers._guard="request",this.referrer=null,this.mode=null,this.credentials="omit",t instanceof v){if(t.bodyUsed)throw TypeError();t.bodyUsed=!0,this.method=t.method,this.url=t.url,this.headers=new l(t.headers),this.headers._guard=t.headers._guard,this.credentials=t.credentials,this._stream=t._stream}else t=r(t),this.url=String(new URL(t,self.location));if("method"in(n=Object(n))){var o=e(n.method);if(i(o))throw TypeError();this.method=a(o)}"headers"in n&&(this.headers=new l,p(this.headers,n.headers)),"body"in n&&(this._stream=n.body),"credentials"in n&&-1!==["omit","same-origin","include"].indexOf(n.credentials)&&(this.credentials=n.credentials)}function d(t,e){if(arguments.length<1&&(t=""),this.headers=new l,this.headers._guard="response",t instanceof XMLHttpRequest&&"_url"in t){var o=t;return this.type="basic",this.url=r(o._url),this.status=o.status,this.ok=200<=this.status&&this.status<=299,this.statusText=o.statusText,o.getAllResponseHeaders().split(/\r?\n/).filter(function(t){return t.length}).forEach(function(t){var e=t.indexOf(":");this.headers.append(t.substring(0,e),t.substring(e+2))},this),void y.call(this,o.responseText)}y.call(this,t),e=Object(e)||{},this.url="";var i="status"in e?n(e.status):200;if(i<200||i>599)throw RangeError();this.status=i,this.ok=200<=this.status&&this.status<=299;var a="statusText"in e?String(e.statusText):"OK";if(/[^\x00-\xFF]/.test(a))throw TypeError();this.statusText=a,"headers"in e&&p(this.headers,e),this.type="basic"}l.prototype={append:function(t,r){if(t=e(t),!u(t))throw TypeError();if("immutable"===this._guard)throw TypeError();"request"===this._guard&&c(t)||("request-no-CORS"!==this._guard||f(t,r))&&("response"===this._guard&&s(t)||(t=t.toLowerCase(),this._headerList.push([t,r])))},"delete":function(t){if(t=e(t),!u(t))throw TypeError();if("immutable"===this._guard)throw TypeError();if(("request"!==this._guard||!c(t))&&("request-no-CORS"!==this._guard||f(t,"invalid"))&&("response"!==this._guard||!s(t))){t=t.toLowerCase();for(var r=0;r<this._headerList.length;)this._headerList[r][0]===t?this._headerList.splice(r,1):++r}},get:function(t){if(t=e(t),!u(t))throw TypeError();t=t.toLowerCase();for(var r=0;r<this._headerList.length;++r)if(this._headerList[r][0]===t)return this._headerList[r][1];return null},getAll:function(t){if(t=e(t),!u(t))throw TypeError();t=t.toLowerCase();for(var r=[],n=0;n<this._headerList.length;++n)this._headerList[n][0]===t&&r.push(this._headerList[n][1]);return r},has:function(t){if(t=e(t),!u(t))throw TypeError();t=t.toLowerCase();for(var r=0;r<this._headerList.length;++r)if(this._headerList[r][0]===t)return!0;return!1},set:function(t,r){if(t=e(t),!u(t))throw TypeError();if("immutable"===this._guard)throw TypeError();if(("request"!==this._guard||!c(t))&&("request-no-CORS"!==this._guard||f(t,r))&&("response"!==this._guard||!s(t))){t=t.toLowerCase();for(var n=0;n<this._headerList.length;++n)if(this._headerList[n][0]===t){for(this._headerList[n++][1]=r;n<this._headerList.length;)this._headerList[n][0]===t?this._headerList.splice(n,1):++n;return}this._headerList.push([t,r])}}},l.prototype[Symbol.iterator]=function(){return new h(this)},(h.prototype={}).next=function(){return this._index>=this._headers._headerList.length?{value:undefined,done:!0}:{value:this._headers._headerList[this._index++],done:!1}},h.prototype[Symbol.iterator]=function(){return this},y.prototype={arrayBuffer:function(){if(this.bodyUsed)return Promise.reject(TypeError());if(this.bodyUsed=!0,this._stream instanceof ArrayBuffer)return Promise.resolve(this._stream);var t=this._stream;return new Promise(function(e,r){var n=unescape(encodeURIComponent(t)).split("").map(function(t){return t.charCodeAt(0)});e(new Uint8Array(n).buffer)})},blob:function(){return this.bodyUsed?Promise.reject(TypeError()):(this.bodyUsed=!0,this._stream instanceof Blob?Promise.resolve(this._stream):Promise.resolve(new Blob([this._stream])))},formData:function(){return this.bodyUsed?Promise.reject(TypeError()):(this.bodyUsed=!0,this._stream instanceof FormData?Promise.resolve(this._stream):Promise.reject(Error("Not yet implemented")))},json:function(){if(this.bodyUsed)return Promise.reject(TypeError());this.bodyUsed=!0;var t=this;return new Promise(function(e,r){e(JSON.parse(t._stream))})},text:function(){return this.bodyUsed?Promise.reject(TypeError()):(this.bodyUsed=!0,Promise.resolve(String(this._stream)))}},v.prototype=y.prototype,d.prototype=y.prototype,d.redirect=function(){throw Error("Not supported")},"fetch"in t||(t.Headers=l,t.Request=v,t.Response=d,t.fetch=function(t,e){return new Promise(function(r,n){var o=new v(t,e),i=new XMLHttpRequest;i._url=o.url;try{i.open(o.method,o.url,!0)}catch(c){throw TypeError(c.message)}for(var a=o.headers[Symbol.iterator](),u=a.next();!u.done;u=a.next())i.setRequestHeader(u.value[0],u.value[1]);"include"===o.credentials&&(i.withCredentials=!0),i.onreadystatechange=function(){i.readyState===XMLHttpRequest.DONE&&(0===i.status?n(new TypeError("Network error")):r(new d(i)))},i.send(o._stream)})})}(self);

!function(e){function n(){}function t(e,n){return function(){e.apply(n,arguments)}}function o(e){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],s(e,this)}function i(e,n){for(;3===e._state;)e=e._value;return 0===e._state?void e._deferreds.push(n):(e._handled=!0,void o._immediateFn(function(){var t=1===e._state?n.onFulfilled:n.onRejected;if(null===t)return void(1===e._state?r:u)(n.promise,e._value);var o;try{o=t(e._value)}catch(i){return void u(n.promise,i)}r(n.promise,o)}))}function r(e,n){try{if(n===e)throw new TypeError("A promise cannot be resolved with itself.");if(n&&("object"==typeof n||"function"==typeof n)){var i=n.then;if(n instanceof o)return e._state=3,e._value=n,void f(e);if("function"==typeof i)return void s(t(i,n),e)}e._state=1,e._value=n,f(e)}catch(r){u(e,r)}}function u(e,n){e._state=2,e._value=n,f(e)}function f(e){2===e._state&&0===e._deferreds.length&&o._immediateFn(function(){e._handled||o._unhandledRejectionFn(e._value)});for(var n=0,t=e._deferreds.length;n<t;n++)i(e,e._deferreds[n]);e._deferreds=null}function c(e,n,t){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof n?n:null,this.promise=t}function s(e,n){var t=!1;try{e(function(e){t||(t=!0,r(n,e))},function(e){t||(t=!0,u(n,e))})}catch(o){if(t)return;t=!0,u(n,o)}}var a=setTimeout;o.prototype["catch"]=function(e){return this.then(null,e)},o.prototype.then=function(e,t){var o=new this.constructor(n);return i(this,new c(e,t,o)),o},o.all=function(e){var n=Array.prototype.slice.call(e);return new o(function(e,t){function o(r,u){try{if(u&&("object"==typeof u||"function"==typeof u)){var f=u.then;if("function"==typeof f)return void f.call(u,function(e){o(r,e)},t)}n[r]=u,0===--i&&e(n)}catch(c){t(c)}}if(0===n.length)return e([]);for(var i=n.length,r=0;r<n.length;r++)o(r,n[r])})},o.resolve=function(e){return e&&"object"==typeof e&&e.constructor===o?e:new o(function(n){n(e)})},o.reject=function(e){return new o(function(n,t){t(e)})},o.race=function(e){return new o(function(n,t){for(var o=0,i=e.length;o<i;o++)e[o].then(n,t)})},o._immediateFn="function"==typeof setImmediate&&function(e){setImmediate(e)}||function(e){a(e,0)},o._unhandledRejectionFn=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)},o._setImmediateFn=function(e){o._immediateFn=e},o._setUnhandledRejectionFn=function(e){o._unhandledRejectionFn=e},"undefined"!=typeof module&&module.exports?module.exports=o:e.Promise||(e.Promise=o)}(this);
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports["RAML.JsonValidation"]=t():e["RAML.JsonValidation"]=t()}(this,function(){return function(e){function t(n){if(r[n])return r[n].exports;var i=r[n]={exports:{},id:n,loaded:!1};return e[n].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var r={};return t.m=e,t.c=r,t.p="",t(0)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(1),i=function(){function e(){this.validator=new n({ignoreUnknownFormats:!0})}return e.prototype.setRemoteReference=function(e,t){this.validator.setRemoteReference(e,t)},e.prototype.validateSchema=function(e){this.validator.validateSchema(e)},e.prototype.getMissingRemoteReferences=function(){return this.validator.getMissingRemoteReferences()},e.prototype.isResourceLoaded=function(e){return null!=this.validator.cache[e]},e.prototype.validate=function(e,t){this.validator.validate(e,t)},e.prototype.getLastErrors=function(){return this.validator.getLastErrors()},e}();t.JSONValidator=i},function(e,t,r){(function(t){"use strict";function n(e){if(this.cache={},this.referenceCache=[],this.setRemoteReference("http://json-schema.org/draft-04/schema",c),this.setRemoteReference("http://json-schema.org/draft-04/hyper-schema",p),"object"==typeof e){for(var t,r=Object.keys(e),n=r.length;n--;)if(t=r[n],void 0===h[t])throw new Error("Unexpected option passed to constructor: "+t);for(r=Object.keys(h),n=r.length;n--;)t=r[n],void 0===e[t]&&(e[t]=d.clone(h[t]));this.options=e}else this.options=d.clone(h);this.options.strictMode===!0&&(this.options.forceAdditional=!0,this.options.forceItems=!0,this.options.forceMaxLength=!0,this.options.forceProperties=!0,this.options.noExtraKeywords=!0,this.options.noTypeless=!0,this.options.noEmptyStrings=!0,this.options.noEmptyArrays=!0)}r(3);var i=r(4),o=r(5),a=r(8),s=r(77),u=r(78),l=r(81),f=r(82),d=r(7),c=r(83),p=r(84),h={asyncTimeout:2e3,forceAdditional:!1,assumeAdditional:!1,forceItems:!1,forceMinItems:!1,forceMaxItems:!1,forceMinLength:!1,forceMaxLength:!1,forceProperties:!1,ignoreUnresolvableReferences:!1,noExtraKeywords:!1,noTypeless:!1,noEmptyStrings:!1,noEmptyArrays:!1,strictUris:!1,strictMode:!1,reportPathAsArray:!1,breakOnFirstError:!0,pedanticCheck:!1,ignoreUnknownFormats:!1,customValidator:null};n.prototype.compileSchema=function(e){var t=new o(this.options);return e=u.getSchema.call(this,t,e),l.compileSchema.call(this,t,e),this.lastReport=t,t.isValid()},n.prototype.validateSchema=function(e){if(Array.isArray(e)&&0===e.length)throw new Error(".validateSchema was called with an empty array");var t=new o(this.options);e=u.getSchema.call(this,t,e);var r=l.compileSchema.call(this,t,e);return r&&f.validateSchema.call(this,t,e),this.lastReport=t,t.isValid()},n.prototype.validate=function(e,r,n,a){"function"===d.whatIs(n)&&(a=n,n={}),n||(n={});var c=d.whatIs(r);if("string"!==c&&"object"!==c){var p=new Error("Invalid .validate call - schema must be an string or object but "+c+" was passed!");if(a)return void t.nextTick(function(){a(p,!1)});throw p}var h=!1,_=new o(this.options);if("string"==typeof r){var m=r;if(r=u.getSchema.call(this,_,m),!r)throw new Error("Schema with id '"+m+"' wasn't found in the validator cache!")}else r=u.getSchema.call(this,_,r);var y=!1;h||(y=l.compileSchema.call(this,_,r)),y||(this.lastReport=_,h=!0);var v=!1;if(h||(v=f.validateSchema.call(this,_,r)),v||(this.lastReport=_,h=!0),n.schemaPath&&(_.rootSchema=r,r=i(r,n.schemaPath),!r))throw new Error("Schema path '"+n.schemaPath+"' wasn't found in the schema!");if(h||s.validate.call(this,_,r,e),a)return void _.processAsyncTasks(this.options.asyncTimeout,a);if(_.asyncTasks.length>0)throw new Error("This validation has async tasks and cannot be done in sync mode, please provide callback argument.");return this.lastReport=_,_.isValid()},n.prototype.getLastError=function(){if(0===this.lastReport.errors.length)return null;var e=new Error;return e.name="z-schema validation error",e.message=this.lastReport.commonErrorMessage,e.details=this.lastReport.errors,e},n.prototype.getLastErrors=function(){return this.lastReport&&this.lastReport.errors.length>0?this.lastReport.errors:void 0},n.prototype.getMissingReferences=function(e){e=e||this.lastReport.errors;for(var t=[],r=e.length;r--;){var n=e[r];if("UNRESOLVABLE_REFERENCE"===n.code){var i=n.params[0];t.indexOf(i)===-1&&t.push(i)}n.inner&&(t=t.concat(this.getMissingReferences(n.inner)))}return t},n.prototype.getMissingRemoteReferences=function(){for(var e=this.getMissingReferences(),t=[],r=e.length;r--;){var n=u.getRemotePath(e[r]);n&&t.indexOf(n)===-1&&t.push(n)}return t},n.prototype.setRemoteReference=function(e,t){t="string"==typeof t?JSON.parse(t):d.cloneDeep(t),u.cacheSchemaByUri.call(this,e,t)},n.prototype.getResolvedSchema=function(e){var t=new o(this.options);e=u.getSchema.call(this,t,e),e=d.cloneDeep(e);var r=[],n=function(e){var t,i=d.whatIs(e);if(("object"===i||"array"===i)&&!e.___$visited){if(e.___$visited=!0,r.push(e),e.$ref&&e.__$refResolved){var o=e.__$refResolved,a=e;delete e.$ref,delete e.__$refResolved;for(t in o)o.hasOwnProperty(t)&&(a[t]=o[t])}for(t in e)e.hasOwnProperty(t)&&(0===t.indexOf("__$")?delete e[t]:n(e[t]))}};if(n(e),r.forEach(function(e){delete e.___$visited}),this.lastReport=t,t.isValid())return e;throw this.getLastError()},n.prototype.setSchemaReader=function(e){return n.setSchemaReader(e)},n.prototype.getSchemaReader=function(){return n.schemaReader},n.setSchemaReader=function(e){n.schemaReader=e},n.registerFormat=function(e,t){a[e]=t},n.unregisterFormat=function(e){delete a[e]},n.getRegisteredFormats=function(){return Object.keys(a)},n.getDefaultOptions=function(){return d.cloneDeep(h)},e.exports=n}).call(t,r(2))},function(e,t){function r(){throw new Error("setTimeout has not been defined")}function n(){throw new Error("clearTimeout has not been defined")}function i(e){if(f===setTimeout)return setTimeout(e,0);if((f===r||!f)&&setTimeout)return f=setTimeout,setTimeout(e,0);try{return f(e,0)}catch(t){try{return f.call(null,e,0)}catch(t){return f.call(this,e,0)}}}function o(e){if(d===clearTimeout)return clearTimeout(e);if((d===n||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(e);try{return d(e)}catch(t){try{return d.call(null,e)}catch(t){return d.call(this,e)}}}function a(){_&&p&&(_=!1,p.length?h=p.concat(h):m=-1,h.length&&s())}function s(){if(!_){var e=i(a);_=!0;for(var t=h.length;t;){for(p=h,h=[];++m<t;)p&&p[m].run();m=-1,t=h.length}p=null,_=!1,o(e)}}function u(e,t){this.fun=e,this.array=t}function l(){}var f,d,c=e.exports={};!function(){try{f="function"==typeof setTimeout?setTimeout:r}catch(e){f=r}try{d="function"==typeof clearTimeout?clearTimeout:n}catch(e){d=n}}();var p,h=[],_=!1,m=-1;c.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)t[r-1]=arguments[r];h.push(new u(e,t)),1!==h.length||_||i(s)},u.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=l,c.addListener=l,c.once=l,c.off=l,c.removeListener=l,c.removeAllListeners=l,c.emit=l,c.prependListener=l,c.prependOnceListener=l,c.listeners=function(e){return[]},c.binding=function(e){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(e){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}},function(e,t){"function"!=typeof Number.isFinite&&(Number.isFinite=function(e){return"number"==typeof e&&(e===e&&e!==1/0&&e!==-(1/0))})},function(e,t){(function(t){function r(e,t){return null==e?void 0:e[t]}function n(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}function i(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function o(){this.__data__=me?me(null):{}}function a(e){return this.has(e)&&delete this.__data__[e]}function s(e){var t=this.__data__;if(me){var r=t[e];return r===W?void 0:r}return fe.call(t,e)?t[e]:void 0}function u(e){var t=this.__data__;return me?void 0!==t[e]:fe.call(t,e)}function l(e,t){var r=this.__data__;return r[e]=me&&void 0===t?W:t,this}function f(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function d(){this.__data__=[]}function c(e){var t=this.__data__,r=O(t,e);if(r<0)return!1;var n=t.length-1;return r==n?t.pop():he.call(t,r,1),!0}function p(e){var t=this.__data__,r=O(t,e);return r<0?void 0:t[r][1]}function h(e){return O(this.__data__,e)>-1}function _(e,t){var r=this.__data__,n=O(r,e);return n<0?r.push([e,t]):r[n][1]=t,this}function m(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function y(){this.__data__={hash:new i,map:new(_e||f),string:new i}}function v(e){return M(this,e).delete(e)}function E(e){return M(this,e).get(e)}function g(e){return M(this,e).has(e)}function b(e,t){return M(this,e).set(e,t),this}function O(e,t){for(var r=e.length;r--;)if(F(e[r][0],t))return r;return-1}function A(e,t){t=S(t,e)?[t]:P(t);for(var r=0,n=t.length;null!=e&&r<n;)e=e[j(t[r++])];return r&&r==n?e:void 0}function x(e){if(!C(e)||$(e))return!1;var t=N(e)||n(e)?ce:ee;return t.test(D(e))}function R(e){if("string"==typeof e)return e;if(k(e))return ve?ve.call(e):"";var t=e+"";return"0"==t&&1/e==-B?"-0":t}function P(e){return ge(e)?e:Ee(e)}function M(e,t){var r=e.__data__;return I(t)?r["string"==typeof t?"string":"hash"]:r.map}function T(e,t){var n=r(e,t);return x(n)?n:void 0}function S(e,t){if(ge(e))return!1;var r=typeof e;return!("number"!=r&&"symbol"!=r&&"boolean"!=r&&null!=e&&!k(e))||(X.test(e)||!V.test(e)||null!=t&&e in Object(t))}function I(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}function $(e){return!!ue&&ue in e}function j(e){if("string"==typeof e||k(e))return e;var t=e+"";return"0"==t&&1/e==-B?"-0":t}function D(e){if(null!=e){try{return le.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function w(e,t){if("function"!=typeof e||t&&"function"!=typeof t)throw new TypeError(K);var r=function(){var n=arguments,i=t?t.apply(this,n):n[0],o=r.cache;if(o.has(i))return o.get(i);var a=e.apply(this,n);return r.cache=o.set(i,a),a};return r.cache=new(w.Cache||m),r}function F(e,t){return e===t||e!==e&&t!==t}function N(e){var t=C(e)?de.call(e):"";return t==q||t==Z}function C(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function U(e){return!!e&&"object"==typeof e}function k(e){return"symbol"==typeof e||U(e)&&de.call(e)==z}function Y(e){return null==e?"":R(e)}function L(e,t,r){var n=null==e?void 0:A(e,t);return void 0===n?r:n}var K="Expected a function",W="__lodash_hash_undefined__",B=1/0,q="[object Function]",Z="[object GeneratorFunction]",z="[object Symbol]",V=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,X=/^\w*$/,H=/^\./,G=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,J=/[\\^$.*+?()[\]{}|]/g,Q=/\\(\\)?/g,ee=/^\[object .+?Constructor\]$/,te="object"==typeof t&&t&&t.Object===Object&&t,re="object"==typeof self&&self&&self.Object===Object&&self,ne=te||re||Function("return this")(),ie=Array.prototype,oe=Function.prototype,ae=Object.prototype,se=ne["__core-js_shared__"],ue=function(){var e=/[^.]+$/.exec(se&&se.keys&&se.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),le=oe.toString,fe=ae.hasOwnProperty,de=ae.toString,ce=RegExp("^"+le.call(fe).replace(J,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),pe=ne.Symbol,he=ie.splice,_e=T(ne,"Map"),me=T(Object,"create"),ye=pe?pe.prototype:void 0,ve=ye?ye.toString:void 0;i.prototype.clear=o,i.prototype.delete=a,i.prototype.get=s,i.prototype.has=u,i.prototype.set=l,f.prototype.clear=d,f.prototype.delete=c,f.prototype.get=p,f.prototype.has=h,f.prototype.set=_,m.prototype.clear=y,m.prototype.delete=v,m.prototype.get=E,m.prototype.has=g,m.prototype.set=b;var Ee=w(function(e){e=Y(e);var t=[];return H.test(e)&&t.push(""),e.replace(G,function(e,r,n,i){t.push(n?i.replace(Q,"$1"):r||e)}),t});w.Cache=m;var ge=Array.isArray;e.exports=L}).call(t,function(){return this}())},function(e,t,r){(function(t){"use strict";function n(e,t){this.parentReport=e instanceof n?e:void 0,this.options=e instanceof n?e.options:e||{},this.reportOptions=t||{},this.errors=[],this.path=[],this.asyncTasks=[]}var i=r(4),o=r(6),a=r(7);n.prototype.isValid=function(){if(this.asyncTasks.length>0)throw new Error("Async tasks pending, can't answer isValid");return 0===this.errors.length},n.prototype.addAsyncTask=function(e,t,r){this.asyncTasks.push([e,t,r])},n.prototype.processAsyncTasks=function(e,r){function n(){t.nextTick(function(){var e=0===l.errors.length,t=e?void 0:l.errors;r(t,e)})}function i(e){return function(t){u||(e(t),0===--a&&n())}}var o=e||2e3,a=this.asyncTasks.length,s=a,u=!1,l=this;if(0===a||this.errors.length>0)return void n();for(;s--;){var f=this.asyncTasks[s];f[0].apply(null,f[1].concat(i(f[2])))}setTimeout(function(){a>0&&(u=!0,l.addError("ASYNC_TIMEOUT",[a,o]),r(l.errors,!1))},o)},n.prototype.getPath=function(e){var t=[];return this.parentReport&&(t=t.concat(this.parentReport.path)),t=t.concat(this.path),e!==!0&&(t="#/"+t.map(function(e){return a.isAbsoluteUri(e)?"uri("+e+")":e.replace(/\~/g,"~0").replace(/\//g,"~1")}).join("/")),t},n.prototype.getSchemaId=function(){if(!this.rootSchema)return null;var e=[];for(this.parentReport&&(e=e.concat(this.parentReport.path)),e=e.concat(this.path);e.length>0;){var t=i(this.rootSchema,e);if(t&&t.id)return t.id;e.pop()}return this.rootSchema.id},n.prototype.hasError=function(e,t){for(var r=this.errors.length;r--;)if(this.errors[r].code===e){for(var n=!0,i=this.errors[r].params.length;i--;)this.errors[r].params[i]!==t[i]&&(n=!1);if(n)return n}return!1},n.prototype.addError=function(e,t,r,n){if(!e)throw new Error("No errorCode passed into addError()");this.addCustomError(e,o[e],t,r,n)},n.prototype.addCustomError=function(e,t,r,n,i){if(!(this.errors.length>=this.reportOptions.maxErrors)){if(!t)throw new Error("No errorMessage known for code "+e);r=r||[];for(var o=r.length;o--;){var s=a.whatIs(r[o]),u="object"===s||"null"===s?JSON.stringify(r[o]):r[o];t=t.replace("{"+o+"}",u)}var l={code:e,params:r,message:t,path:this.getPath(this.options.reportPathAsArray),schemaId:this.getSchemaId()};if(i&&(l.description=i),null!=n){for(Array.isArray(n)||(n=[n]),l.inner=[],o=n.length;o--;)for(var f=n[o],d=f.errors.length;d--;)l.inner.push(f.errors[d]);0===l.inner.length&&(l.inner=void 0)}this.errors.push(l)}},e.exports=n}).call(t,r(2))},function(e,t){"use strict";e.exports={INVALID_TYPE:"Expected type {0} but found type {1}",INVALID_FORMAT:"Object didn't pass validation for format {0}: {1}",ENUM_MISMATCH:"No enum match for: {0}",ANY_OF_MISSING:"Data does not match any schemas from 'anyOf'",ONE_OF_MISSING:"Data does not match any schemas from 'oneOf'",ONE_OF_MULTIPLE:"Data is valid against more than one schema from 'oneOf'",NOT_PASSED:"Data matches schema from 'not'",ARRAY_LENGTH_SHORT:"Array is too short ({0}), minimum {1}",ARRAY_LENGTH_LONG:"Array is too long ({0}), maximum {1}",ARRAY_UNIQUE:"Array items are not unique (indexes {0} and {1})",ARRAY_ADDITIONAL_ITEMS:"Additional items not allowed",MULTIPLE_OF:"Value {0} is not a multiple of {1}",MINIMUM:"Value {0} is less than minimum {1}",MINIMUM_EXCLUSIVE:"Value {0} is equal or less than exclusive minimum {1}",MAXIMUM:"Value {0} is greater than maximum {1}",MAXIMUM_EXCLUSIVE:"Value {0} is equal or greater than exclusive maximum {1}",OBJECT_PROPERTIES_MINIMUM:"Too few properties defined ({0}), minimum {1}",OBJECT_PROPERTIES_MAXIMUM:"Too many properties defined ({0}), maximum {1}",OBJECT_MISSING_REQUIRED_PROPERTY:"Missing required property: {0}",OBJECT_ADDITIONAL_PROPERTIES:"Additional properties not allowed: {0}",OBJECT_DEPENDENCY_KEY:"Dependency failed - key must exist: {0} (due to key: {1})",MIN_LENGTH:"String is too short ({0} chars), minimum {1}",MAX_LENGTH:"String is too long ({0} chars), maximum {1}",PATTERN:"String does not match pattern {0}: {1}",KEYWORD_TYPE_EXPECTED:"Keyword '{0}' is expected to be of type '{1}'",KEYWORD_UNDEFINED_STRICT:"Keyword '{0}' must be defined in strict mode",KEYWORD_UNEXPECTED:"Keyword '{0}' is not expected to appear in the schema",KEYWORD_MUST_BE:"Keyword '{0}' must be {1}",KEYWORD_DEPENDENCY:"Keyword '{0}' requires keyword '{1}'",KEYWORD_PATTERN:"Keyword '{0}' is not a valid RegExp pattern: {1}",KEYWORD_VALUE_TYPE:"Each element of keyword '{0}' array must be a '{1}'",UNKNOWN_FORMAT:"There is no validation function for format '{0}'",CUSTOM_MODE_FORCE_PROPERTIES:"{0} must define at least one property if present",REF_UNRESOLVED:"Reference has not been resolved during compilation: {0}",UNRESOLVABLE_REFERENCE:"Reference could not be resolved: {0}",SCHEMA_NOT_REACHABLE:"Validator was not able to read schema with uri: {0}",SCHEMA_TYPE_EXPECTED:"Schema is expected to be of type 'object'",SCHEMA_NOT_AN_OBJECT:"Schema is not an object: {0}",ASYNC_TIMEOUT:"{0} asynchronous task(s) have timed out after {1} ms",PARENT_SCHEMA_VALIDATION_FAILED:"Schema failed to validate against its parent schema, see inner errors for details.",REMOTE_NOT_VALID:"Remote reference didn't compile successfully: {0}"}},function(e,t){"use strict";t.isAbsoluteUri=function(e){return/^https?:\/\//.test(e)},t.isRelativeUri=function(e){return/.+#/.test(e)},t.whatIs=function(e){var t=typeof e;return"object"===t?null===e?"null":Array.isArray(e)?"array":"object":"number"===t?Number.isFinite(e)?e%1===0?"integer":"number":Number.isNaN(e)?"not-a-number":"unknown-number":t},t.areEqual=function e(r,n){if(r===n)return!0;var i,o;if(Array.isArray(r)&&Array.isArray(n)){if(r.length!==n.length)return!1;for(o=r.length,i=0;i<o;i++)if(!e(r[i],n[i]))return!1;return!0}if("object"===t.whatIs(r)&&"object"===t.whatIs(n)){var a=Object.keys(r),s=Object.keys(n);if(!e(a,s))return!1;for(o=a.length,i=0;i<o;i++)if(!e(r[a[i]],n[a[i]]))return!1;return!0}return!1},t.isUniqueArray=function(e,r){var n,i,o=e.length;for(n=0;n<o;n++)for(i=n+1;i<o;i++)if(t.areEqual(e[n],e[i]))return r&&r.push(n,i),!1;return!0},t.difference=function(e,t){for(var r=[],n=e.length;n--;)t.indexOf(e[n])===-1&&r.push(e[n]);return r},t.clone=function(e){if("undefined"!=typeof e){if("object"!=typeof e||null===e)return e;var t,r;if(Array.isArray(e))for(t=[],r=e.length;r--;)t[r]=e[r];else{t={};var n=Object.keys(e);for(r=n.length;r--;){var i=n[r];t[i]=e[i]}}return t}},t.cloneDeep=function(e){function t(e){if("object"!=typeof e||null===e)return e;var i,o,a;if(a=r.indexOf(e),a!==-1)return n[a];if(r.push(e),Array.isArray(e))for(i=[],n.push(i),o=e.length;o--;)i[o]=t(e[o]);else{i={},n.push(i);var s=Object.keys(e);for(o=s.length;o--;){var u=s[o];i[u]=t(e[u])}}return i}var r=[],n=[];return t(e)},t.ucs2decode=function(e){for(var t,r,n=[],i=0,o=e.length;i<o;)t=e.charCodeAt(i++),t>=55296&&t<=56319&&i<o?(r=e.charCodeAt(i++),56320==(64512&r)?n.push(((1023&t)<<10)+(1023&r)+65536):(n.push(t),i--)):n.push(t);return n}},function(e,t,r){var n=r(9),i={date:function(e){if("string"!=typeof e)return!0;var t=/^([0-9]{4})-([0-9]{2})-([0-9]{2})$/.exec(e);return null!==t&&!(t[2]<"01"||t[2]>"12"||t[3]<"01"||t[3]>"31")},"date-time":function(e){if("string"!=typeof e)return!0;var t=e.toLowerCase().split("t");if(!i.date(t[0]))return!1;var r=/^([0-9]{2}):([0-9]{2}):([0-9]{2})(.[0-9]+)?(z|([+-][0-9]{2}:[0-9]{2}))$/.exec(t[1]);return null!==r&&!(r[1]>"23"||r[2]>"59"||r[3]>"59")},email:function(e){return"string"!=typeof e||n.isEmail(e,{require_tld:!0})},hostname:function(e){if("string"!=typeof e)return!0;var t=/^[a-zA-Z](([-0-9a-zA-Z]+)?[0-9a-zA-Z])?(\.[a-zA-Z](([-0-9a-zA-Z]+)?[0-9a-zA-Z])?)*$/.test(e);if(t){if(e.length>255)return!1;for(var r=e.split("."),n=0;n<r.length;n++)if(r[n].length>63)return!1}return t},"host-name":function(e){return i.hostname.call(this,e)},ipv4:function(e){return"string"!=typeof e||n.isIP(e,4)},ipv6:function(e){return"string"!=typeof e||n.isIP(e,6)},regex:function(e){try{return RegExp(e),!0}catch(e){return!1}},uri:function(e){return this.options.strictUris?i["strict-uri"].apply(this,arguments):"string"!=typeof e||RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?").test(e)},"strict-uri":function(e){return"string"!=typeof e||n.isURL(e)}};e.exports=i},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var i=r(10),o=n(i),a=r(12),s=n(a),u=r(13),l=n(u),f=r(14),d=n(f),c=r(15),p=n(c),h=r(16),_=n(h),m=r(18),y=n(m),v=r(19),E=n(v),g=r(23),b=n(g),O=r(25),A=n(O),x=r(24),R=n(x),P=r(22),M=n(P),T=r(26),S=n(T),I=r(27),$=n(I),j=r(29),D=n(j),w=r(30),F=n(w),N=r(31),C=n(N),U=r(32),k=n(U),Y=r(33),L=n(Y),K=r(34),W=n(K),B=r(35),q=n(B),Z=r(36),z=n(Z),V=r(37),X=n(V),H=r(38),G=n(H),J=r(39),Q=n(J),ee=r(40),te=n(ee),re=r(41),ne=n(re),ie=r(42),oe=n(ie),ae=r(43),se=n(ae),ue=r(44),le=n(ue),fe=r(45),de=n(fe),ce=r(46),pe=n(ce),he=r(47),_e=n(he),me=r(48),ye=n(me),ve=r(49),Ee=n(ve),ge=r(50),be=n(ge),Oe=r(21),Ae=n(Oe),xe=r(51),Re=n(xe),Pe=r(52),Me=n(Pe),Te=r(53),Se=n(Te),Ie=r(54),$e=n(Ie),je=r(55),De=n(je),we=r(56),Fe=n(we),Ne=r(57),Ce=n(Ne),Ue=r(58),ke=n(Ue),Ye=r(59),Le=n(Ye),Ke=r(60),We=n(Ke),Be=r(61),qe=n(Be),Ze=r(62),ze=n(Ze),Ve=r(63),Xe=n(Ve),He=r(64),Ge=n(He),Je=r(65),Qe=n(Je),et=r(66),tt=n(et),rt=r(67),nt=n(rt),it=r(68),ot=n(it),at=r(69),st=n(at),ut=r(70),lt=n(ut),ft=r(71),dt=n(ft),ct=r(72),pt=n(ct),ht=r(74),_t=n(ht),mt=r(73),yt=n(mt),vt=r(75),Et=n(vt),gt=r(76),bt=n(gt),Ot=r(17),At=n(Ot),xt="8.2.0",Rt={version:xt,toDate:o.default,toFloat:s.default,toInt:l.default,toBoolean:d.default,equals:p.default,contains:_.default,matches:y.default,isEmail:E.default,isURL:b.default,isMACAddress:A.default,isIP:R.default,isFQDN:M.default,isBoolean:S.default,isAlpha:$.default,isAlphanumeric:D.default,isNumeric:F.default,isLowercase:C.default,isUppercase:k.default,isAscii:L.default,isFullWidth:W.default,isHalfWidth:q.default,isVariableWidth:z.default,isMultibyte:X.default,isSurrogatePair:G.default,isInt:Q.default,isFloat:te.default,isDecimal:ne.default,isHexadecimal:oe.default,isDivisibleBy:se.default,isHexColor:le.default,isISRC:de.default,isMD5:pe.default,isHash:_e.default,isJSON:ye.default,isEmpty:Ee.default,isLength:be.default,isByteLength:Ae.default,isUUID:Re.default,isMongoId:Me.default,isAfter:Se.default,isBefore:$e.default,isIn:De.default,isCreditCard:Fe.default,isISIN:Ce.default,isISBN:ke.default,isISSN:Le.default,isMobilePhone:We.default,isPostalCode:tt.default,isCurrency:qe.default,isISO8601:ze.default,isBase64:Xe.default,isDataURI:Ge.default,isLatLong:Qe.default,ltrim:nt.default,rtrim:ot.default,trim:st.default,escape:lt.default,unescape:dt.default,stripLow:pt.default,whitelist:_t.default,blacklist:yt.default,isWhitelisted:Et.default,normalizeEmail:bt.default,toString:At.default};t.default=Rt,e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),e=Date.parse(e),isNaN(e)?null:new Date(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t){"use strict";function r(e){var t="string"==typeof e||e instanceof String;if(!t)throw new TypeError("This library (validator.js) validates strings only")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=r,e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),parseFloat(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),parseInt(e,t||10)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),t?"1"===e||"true"===e:"0"!==e&&"false"!==e&&""!==e}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),e===t}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),e.indexOf((0,u.default)(t))>=0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(17),u=n(s);e.exports=t.default},function(e,t){"use strict";function r(e){return"object"===("undefined"==typeof e?"undefined":n(e))&&null!==e?e="function"==typeof e.toString?e.toString():"[object Object]":(null===e||"undefined"==typeof e||isNaN(e)&&!e.length)&&(e=""),String(e)}Object.defineProperty(t,"__esModule",{value:!0});var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};t.default=r,e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t,r){return(0,a.default)(e),"[object RegExp]"!==Object.prototype.toString.call(t)&&(t=new RegExp(t,r)),t.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){if((0,a.default)(e),t=(0,u.default)(t,p),t.require_display_name||t.allow_display_name){var r=e.match(h);if(r)e=r[1];else if(t.require_display_name)return!1}var n=e.split("@"),i=n.pop(),o=n.join("@"),s=i.toLowerCase();if("gmail.com"!==s&&"googlemail.com"!==s||(o=o.replace(/\./g,"").toLowerCase()),!(0,f.default)(o,{max:64})||!(0,f.default)(i,{max:254}))return!1;if(!(0,c.default)(i,{require_tld:t.require_tld}))return!1;if('"'===o[0])return o=o.slice(1,o.length-1),t.allow_utf8_local_part?v.test(o):m.test(o);for(var l=t.allow_utf8_local_part?y:_,d=o.split("."),E=0;E<d.length;E++)if(!l.test(d[E]))return!1;return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(20),u=n(s),l=r(21),f=n(l),d=r(22),c=n(d),p={allow_display_name:!1,require_display_name:!1,allow_utf8_local_part:!0,require_tld:!0},h=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\,\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i,_=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i,m=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i,y=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i,v=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;e.exports=t.default},function(e,t){"use strict";function r(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments[1];for(var r in t)"undefined"==typeof e[r]&&(e[r]=t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0}),t.default=r,e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,s.default)(e);var r=void 0,n=void 0;"object"===("undefined"==typeof t?"undefined":o(t))?(r=t.min||0,n=t.max):(r=arguments[1],n=arguments[2]);var i=encodeURI(e).split(/%..|./).length-1;return i>=r&&("undefined"==typeof n||i<=n)}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};t.default=i;var a=r(11),s=n(a);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e),t=(0,u.default)(t,l),t.allow_trailing_dot&&"."===e[e.length-1]&&(e=e.substring(0,e.length-1));var r=e.split(".");if(t.require_tld){var n=r.pop();if(!r.length||!/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(n))return!1;if(/[\s\u2002-\u200B\u202F\u205F\u3000\uFEFF\uDB40\uDC20]/.test(n))return!1}for(var i,o=0;o<r.length;o++){if(i=r[o],t.allow_underscores&&(i=i.replace(/_/g,"")),!/^[a-z\u00a1-\uffff0-9-]+$/i.test(i))return!1;if(/[\uff01-\uff5e]/.test(i))return!1;if("-"===i[0]||"-"===i[i.length-1])return!1}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(20),u=n(s),l={require_tld:!0,allow_underscores:!1,allow_trailing_dot:!1};e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function o(e,t){for(var r=0;r<t.length;r++){var n=t[r];if(e===n||i(n)&&n.test(e))return!0}return!1}function a(e,t){if((0,u.default)(e),!e||e.length>=2083||/[\s<>]/.test(e))return!1;if(0===e.indexOf("mailto:"))return!1;t=(0,h.default)(t,_);var r=void 0,n=void 0,i=void 0,a=void 0,s=void 0,l=void 0,d=void 0,p=void 0;if(d=e.split("#"),e=d.shift(),d=e.split("?"),e=d.shift(),d=e.split("://"),d.length>1){if(r=d.shift(),t.require_valid_protocol&&t.protocols.indexOf(r)===-1)return!1}else{if(t.require_protocol)return!1;t.allow_protocol_relative_urls&&"//"===e.substr(0,2)&&(d[0]=e.substr(2))}if(e=d.join("://"),""===e)return!1;if(d=e.split("/"),e=d.shift(),""===e&&!t.require_host)return!0;if(d=e.split("@"),d.length>1&&(n=d.shift(),n.indexOf(":")>=0&&n.split(":").length>2))return!1;a=d.join("@"),l=null,p=null;var y=a.match(m);return y?(i="",p=y[1],l=y[2]||null):(d=a.split(":"),i=d.shift(),d.length&&(l=d.join(":"))),!(null!==l&&(s=parseInt(l,10),!/^[0-9]+$/.test(l)||s<=0||s>65535))&&(!!((0,c.default)(i)||(0,f.default)(i,t)||p&&(0,c.default)(p,6))&&(i=i||p,!(t.host_whitelist&&!o(i,t.host_whitelist))&&(!t.host_blacklist||!o(i,t.host_blacklist))))}Object.defineProperty(t,"__esModule",{value:!0}),t.default=a;var s=r(11),u=n(s),l=r(22),f=n(l),d=r(24),c=n(d),p=r(20),h=n(p),_={protocols:["http","https","ftp"],require_tld:!0,require_protocol:!1,require_host:!0,require_valid_protocol:!0,allow_underscores:!1,allow_trailing_dot:!1,allow_protocol_relative_urls:!1},m=/^\[([^\]]+)\](?::([0-9]+))?$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";if((0,a.default)(e),t=String(t),!t)return i(e,4)||i(e,6);if("4"===t){if(!s.test(e))return!1;var r=e.split(".").sort(function(e,t){return e-t});return r[3]<=255}if("6"===t){var n=e.split(":"),o=!1,l=i(n[n.length-1],4),f=l?7:8;if(n.length>f)return!1;if("::"===e)return!0;"::"===e.substr(0,2)?(n.shift(),n.shift(),o=!0):"::"===e.substr(e.length-2)&&(n.pop(),n.pop(),o=!0);for(var d=0;d<n.length;++d)if(""===n[d]&&d>0&&d<n.length-1){if(o)return!1;o=!0}else if(l&&d===n.length-1);else if(!u.test(n[d]))return!1;return o?n.length>=1:n.length===f}return!1}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/,u=/^[0-9A-F]{1,4}$/i;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),["true","false","1","0"].indexOf(e)>=0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"en-US";if((0,a.default)(e),t in s.alpha)return s.alpha[t].test(e);
throw new Error("Invalid locale '"+t+"'")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(28);e.exports=t.default},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});for(var r,n=t.alpha={"en-US":/^[A-Z]+$/i,"cs-CZ":/^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"da-DK":/^[A-ZÆØÅ]+$/i,"de-DE":/^[A-ZÄÖÜß]+$/i,"es-ES":/^[A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"it-IT":/^[A-ZÀÉÈÌÎÓÒÙ]+$/i,"nb-NO":/^[A-ZÆØÅ]+$/i,"nl-NL":/^[A-ZÁÉËÏÓÖÜÚ]+$/i,"nn-NO":/^[A-ZÆØÅ]+$/i,"hu-HU":/^[A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"pl-PL":/^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[А-ЯЁ]+$/i,"sr-RS@latin":/^[A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[А-ЯЂЈЉЊЋЏ]+$/i,"sv-SE":/^[A-ZÅÄÖ]+$/i,"tr-TR":/^[A-ZÇĞİıÖŞÜ]+$/i,"uk-UA":/^[А-ЩЬЮЯЄIЇҐ]+$/i,ar:/^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},i=t.alphanumeric={"en-US":/^[0-9A-Z]+$/i,"cs-CZ":/^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"da-DK":/^[0-9A-ZÆØÅ]+$/i,"de-DE":/^[0-9A-ZÄÖÜß]+$/i,"es-ES":/^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"it-IT":/^[0-9A-ZÀÉÈÌÎÓÒÙ]+$/i,"hu-HU":/^[0-9A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"nb-NO":/^[0-9A-ZÆØÅ]+$/i,"nl-NL":/^[0-9A-ZÁÉËÏÓÖÜÚ]+$/i,"nn-NO":/^[0-9A-ZÆØÅ]+$/i,"pl-PL":/^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[0-9А-ЯЁ]+$/i,"sr-RS@latin":/^[0-9A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[0-9А-ЯЂЈЉЊЋЏ]+$/i,"sv-SE":/^[0-9A-ZÅÄÖ]+$/i,"tr-TR":/^[0-9A-ZÇĞİıÖŞÜ]+$/i,"uk-UA":/^[0-9А-ЩЬЮЯЄIЇҐ]+$/i,ar:/^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},o=t.englishLocales=["AU","GB","HK","IN","NZ","ZA","ZM"],a=0;a<o.length;a++)r="en-"+o[a],n[r]=n["en-US"],i[r]=i["en-US"];n["pt-BR"]=n["pt-PT"],i["pt-BR"]=i["pt-PT"];for(var s,u=t.arabicLocales=["AE","BH","DZ","EG","IQ","JO","KW","LB","LY","MA","QM","QA","SA","SD","SY","TN","YE"],l=0;l<u.length;l++)s="ar-"+u[l],n[s]=n.ar,i[s]=i.ar},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"en-US";if((0,a.default)(e),t in s.alphanumeric)return s.alphanumeric[t].test(e);throw new Error("Invalid locale '"+t+"'")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(28);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[-+]?[0-9]+$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),e===e.toLowerCase()}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),e===e.toUpperCase()}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[\x00-\x7F]+$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.fullWidth=void 0,t.default=i;var o=r(11),a=n(o),s=t.fullWidth=/[^\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.halfWidth=void 0,t.default=i;var o=r(11),a=n(o),s=t.halfWidth=/[\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.fullWidth.test(e)&&u.halfWidth.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(34),u=r(35);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/[^\x00-\x7F]/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/[\uD800-\uDBFF][\uDC00-\uDFFF]/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e),t=t||{};var r=t.hasOwnProperty("allow_leading_zeroes")&&!t.allow_leading_zeroes?s:u,n=!t.hasOwnProperty("min")||e>=t.min,i=!t.hasOwnProperty("max")||e<=t.max,o=!t.hasOwnProperty("lt")||e<t.lt,l=!t.hasOwnProperty("gt")||e>t.gt;return r.test(e)&&n&&i&&o&&l}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^(?:[-+]?(?:0|[1-9][0-9]*))$/,u=/^[-+]?[0-9]+$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),t=t||{},""!==e&&"."!==e&&(s.test(e)&&(!t.hasOwnProperty("min")||e>=t.min)&&(!t.hasOwnProperty("max")||e<=t.max)&&(!t.hasOwnProperty("lt")||e<t.lt)&&(!t.hasOwnProperty("gt")||e>t.gt))}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^(?:[-+])?(?:[0-9]+)?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),""!==e&&s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[-+]?([0-9]+|\.[0-9]+|[0-9]+\.[0-9]+)$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[0-9A-F]+$/i;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),(0,u.default)(e)%parseInt(t,10)===0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(12),u=n(s);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[A-Z]{2}[0-9A-Z]{3}\d{2}\d{5}$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[a-f0-9]{32}$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e);var r=new RegExp("^[a-f0-9]{"+s[t]+"}$");return r.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s={md5:32,md4:32,sha1:40,sha256:64,sha384:96,sha512:128,ripemd128:32,ripemd160:40,tiger128:32,tiger160:40,tiger192:48,crc32:8,crc32b:8};e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){(0,s.default)(e);try{var t=JSON.parse(e);return!!t&&"object"===("undefined"==typeof t?"undefined":o(t))}catch(e){}return!1}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};t.default=i;var a=r(11),s=n(a);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),0===e.length}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,s.default)(e);var r=void 0,n=void 0;"object"===("undefined"==typeof t?"undefined":o(t))?(r=t.min||0,n=t.max):(r=arguments[1],n=arguments[2]);var i=e.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g)||[],a=e.length-i.length;return a>=r&&("undefined"==typeof n||a<=n)}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};t.default=i;var a=r(11),s=n(a);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"all";(0,a.default)(e);var r=s[t];return r&&r.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s={3:/^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,4:/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,5:/^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,all:/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i};e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),(0,u.default)(e)&&24===e.length}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(42),u=n(s);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:String(new Date);(0,a.default)(e);var r=(0,u.default)(t),n=(0,u.default)(e);return!!(n&&r&&n>r)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(10),u=n(s);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:String(new Date);(0,a.default)(e);var r=(0,u.default)(t),n=(0,u.default)(e);return!!(n&&r&&n<r)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(10),u=n(s);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,s.default)(e);var r=void 0;if("[object Array]"===Object.prototype.toString.call(t)){var n=[];for(r in t)({}).hasOwnProperty.call(t,r)&&(n[r]=(0,l.default)(t[r]));return n.indexOf(e)>=0}return"object"===("undefined"==typeof t?"undefined":o(t))?t.hasOwnProperty(e):!(!t||"function"!=typeof t.indexOf)&&t.indexOf(e)>=0}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};t.default=i;var a=r(11),s=n(a),u=r(17),l=n(u);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){(0,a.default)(e);var t=e.replace(/[- ]+/g,"");if(!s.test(t))return!1;for(var r=0,n=void 0,i=void 0,o=void 0,u=t.length-1;u>=0;u--)n=t.substring(u,u+1),i=parseInt(n,10),o?(i*=2,r+=i>=10?i%10+1:i):r+=i,o=!o;return!(r%10!==0||!t)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11}|62[0-9]{14})$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){if((0,a.default)(e),!s.test(e))return!1;for(var t=e.replace(/[A-Z]/g,function(e){return parseInt(e,36)}),r=0,n=void 0,i=void 0,o=!0,u=t.length-2;u>=0;u--)n=t.substring(u,u+1),i=parseInt(n,10),o?(i*=2,r+=i>=10?i+1:i):r+=i,o=!o;return parseInt(e.substr(e.length-1),10)===(1e4-r)%10}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^[A-Z]{2}[0-9A-Z]{9}[0-9]$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";if((0,a.default)(e),t=String(t),!t)return i(e,10)||i(e,13);var r=e.replace(/[\s-]+/g,""),n=0,o=void 0;if("10"===t){if(!s.test(r))return!1;for(o=0;o<9;o++)n+=(o+1)*r.charAt(o);if(n+="X"===r.charAt(9)?100:10*r.charAt(9),n%11===0)return!!r}else if("13"===t){if(!u.test(r))return!1;for(o=0;o<12;o++)n+=l[o%2]*r.charAt(o);if(r.charAt(12)-(10-n%10)%10===0)return!!r}return!1}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^(?:[0-9]{9}X|[0-9]{10})$/,u=/^(?:[0-9]{13})$/,l=[1,3];e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};(0,a.default)(e);var r=s;if(r=t.require_hyphen?r.replace("?",""):r,r=t.case_sensitive?new RegExp(r):new RegExp(r,"i"),!r.test(e))return!1;var n=e.replace("-",""),i=8,o=0,u=!0,l=!1,f=void 0;try{for(var d,c=n[Symbol.iterator]();!(u=(d=c.next()).done);u=!0){var p=d.value,h="X"===p.toUpperCase()?10:+p;o+=h*i,--i}}catch(e){l=!0,f=e}finally{try{!u&&c.return&&c.return()}finally{if(l)throw f}}return o%11===0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s="^\\d{4}-?\\d{3}[\\dX]$";e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){if((0,a.default)(e),t in s)return s[t].test(e);if("any"===t){for(var r in s)if(s.hasOwnProperty(r)){var n=s[r];if(n.test(e))return!0}return!1}throw new Error("Invalid locale '"+t+"'")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s={"ar-AE":/^((\+?971)|0)?5[024568]\d{7}$/,"ar-DZ":/^(\+?213|0)(5|6|7)\d{8}$/,"ar-EG":/^((\+?20)|0)?1[012]\d{8}$/,"ar-JO":/^(\+?962|0)?7[789]\d{7}$/,"ar-SY":/^(!?(\+?963)|0)?9\d{8}$/,"ar-SA":/^(!?(\+?966)|0)?5\d{8}$/,"en-US":/^(\+?1)?[2-9]\d{2}[2-9](?!11)\d{6}$/,"cs-CZ":/^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"sk-SK":/^(\+?421)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"de-DE":/^(\+?49[ \.\-])?([\(]{1}[0-9]{1,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,"da-DK":/^(\+?45)?(\d{8})$/,"el-GR":/^(\+?30)?(69\d{8})$/,"en-AU":/^(\+?61|0)4\d{8}$/,"en-GB":/^(\+?44|0)7\d{9}$/,"en-HK":/^(\+?852\-?)?[569]\d{3}\-?\d{4}$/,"en-IN":/^(\+?91|0)?[789]\d{9}$/,"en-KE":/^(\+?254|0)?[7]\d{8}$/,"en-NG":/^(\+?234|0)?[789]\d{9}$/,"en-NZ":/^(\+?64|0)2\d{7,9}$/,"en-UG":/^(\+?256|0)?[7]\d{8}$/,"en-RW":/^(\+?250|0)?[7]\d{8}$/,"en-TZ":/^(\+?255|0)?[67]\d{8}$/,"en-ZA":/^(\+?27|0)\d{9}$/,"en-ZM":/^(\+?26)?09[567]\d{7}$/,"es-ES":/^(\+?34)?(6\d{1}|7[1234])\d{7}$/,"fi-FI":/^(\+?358|0)\s?(4(0|1|2|4|5|6)?|50)\s?(\d\s?){4,8}\d$/,"fa-IR":/^(\+?98[\-\s]?|0)9[0-39]\d[\-\s]?\d{3}[\-\s]?\d{4}$/,"fr-FR":/^(\+?33|0)[67]\d{8}$/,"he-IL":/^(\+972|0)([23489]|5[0248]|77)[1-9]\d{6}/,"hu-HU":/^(\+?36)(20|30|70)\d{7}$/,"lt-LT":/^(\+370|8)\d{8}$/,"id-ID":/^(\+?62|0[1-9])[\s|\d]+$/,"it-IT":/^(\+?39)?\s?3\d{2} ?\d{6,7}$/,"ko-KR":/^((\+?82)[ \-]?)?0?1([0|1|6|7|8|9]{1})[ \-]?\d{3,4}[ \-]?\d{4}$/,"ja-JP":/^(\+?81|0)\d{1,4}[ \-]?\d{1,4}[ \-]?\d{4}$/,"ms-MY":/^(\+?6?01){1}(([145]{1}(\-|\s)?\d{7,8})|([236789]{1}(\s|\-)?\d{7}))$/,"nb-NO":/^(\+?47)?[49]\d{7}$/,"nl-BE":/^(\+?32|0)4?\d{8}$/,"nn-NO":/^(\+?47)?[49]\d{7}$/,"pl-PL":/^(\+?48)? ?[5-8]\d ?\d{3} ?\d{2} ?\d{2}$/,"pt-BR":/^(\+?55|0)\-?[1-9]{2}\-?[2-9]{1}\d{3,4}\-?\d{4}$/,"pt-PT":/^(\+?351)?9[1236]\d{7}$/,"ro-RO":/^(\+?4?0)\s?7\d{2}(\/|\s|\.|\-)?\d{3}(\s|\.|\-)?\d{3}$/,"en-PK":/^((\+92)|(0092))-{0,1}\d{3}-{0,1}\d{7}$|^\d{11}$|^\d{4}-\d{7}$/,"ru-RU":/^(\+?7|8)?9\d{9}$/,"sr-RS":/^(\+3816|06)[- \d]{5,9}$/,"tr-TR":/^(\+?90|0)?5\d{9}$/,"vi-VN":/^(\+?84|0)?((1(2([0-9])|6([2-9])|88|99))|(9((?!5)[0-9])))([0-9]{7})$/,"zh-CN":/^(\+?0?86\-?)?1[345789]\d{9}$/,"zh-TW":/^(\+?886\-?|0)?9\d{8}$/};s["en-CA"]=s["en-US"],s["fr-BE"]=s["nl-BE"],s["zh-HK"]=s["en-HK"],e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){var t="\\d{"+e.digits_after_decimal[0]+"}";e.digits_after_decimal.forEach(function(e,r){0!==r&&(t=t+"|\\d{"+e+"}")});var r="(\\"+e.symbol.replace(/\./g,"\\.")+")"+(e.require_symbol?"":"?"),n="-?",i="[1-9]\\d*",o="[1-9]\\d{0,2}(\\"+e.thousands_separator+"\\d{3})*",a=["0",i,o],s="("+a.join("|")+")?",u="(\\"+e.decimal_separator+"("+t+"))"+(e.require_decimal?"":"?"),l=s+(e.allow_decimal||e.require_decimal?u:"");return e.allow_negatives&&!e.parens_for_negatives&&(e.negative_sign_after_digits?l+=n:e.negative_sign_before_digits&&(l=n+l)),e.allow_negative_sign_placeholder?l="( (?!\\-))?"+l:e.allow_space_after_symbol?l=" ?"+l:e.allow_space_after_digits&&(l+="( (?!$))?"),e.symbol_after_digits?l+=r:l=r+l,e.allow_negatives&&(e.parens_for_negatives?l="(\\("+l+"\\)|"+l+")":e.negative_sign_before_digits||e.negative_sign_after_digits||(l=n+l)),new RegExp("^(?!-? )(?=.*\\d)"+l+"$")}function o(e,t){return(0,l.default)(e),t=(0,s.default)(t,f),i(t).test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=o;var a=r(20),s=n(a),u=r(11),l=n(u),f={symbol:"$",require_symbol:!1,allow_space_after_symbol:!1,symbol_after_digits:!1,allow_negatives:!0,parens_for_negatives:!1,negative_sign_before_digits:!1,negative_sign_after_digits:!1,allow_negative_sign_placeholder:!1,thousands_separator:",",decimal_separator:".",allow_decimal:!0,require_decimal:!1,digits_after_decimal:[2],allow_space_after_digits:!1};e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){(0,a.default)(e);var t=e.length;if(!t||t%4!==0||s.test(e))return!1;var r=e.indexOf("=");return r===-1||r===t-1||r===t-2&&"="===e[t-1]}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/[^A-Z0-9+\/=]/i;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=/^\s*data:([a-z]+\/[a-z0-9\-\+]+(;[a-z\-]+=[a-z0-9\-]+)?)?(;base64)?,[a-z0-9!\$&',\(\)\*\+,;=\-\._~:@\/\?%\s]*\s*$/i;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){if((0,o.default)(e),!e.includes(","))return!1;var t=e.split(",");return a.test(t[0])&&s.test(t[1])};var i=r(11),o=n(i),a=/^\(?[+-]?(90(\.0+)?|[1-8]?\d(\.\d+)?)$/,s=/^\s?[+-]?(180(\.0+)?|1[0-7]\d(\.\d+)?|\d{1,2}(\.\d+)?)\)?$/;e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0}),t.locales=void 0,t.default=function(e,t){if((0,o.default)(e),t in f)return f[t].test(e);if("any"===t){for(var r in f)if(f.hasOwnProperty(r)){var n=f[r];if(n.test(e))return!0}return!1}throw new Error("Invalid locale '"+t+"'")};var i=r(11),o=n(i),a=/^\d{3}$/,s=/^\d{4}$/,u=/^\d{5}$/,l=/^\d{6}$/,f={AT:s,AU:l,BE:s,CA:/^[ABCEGHJKLMNPRSTVXY]\d[ABCEGHJ-NPRSTV-Z][\s\-]?\d[ABCEGHJ-NPRSTV-Z]\d$/i,CH:s,CZ:/^\d{3}\s?\d{2}$/,DE:u,DK:s,DZ:u,ES:u,FI:u,FR:/^\d{2}\s?\d{3}$/,GB:/^(gir\s?0aa|[a-z]{1,2}\d[\da-z]?\s?(\d[a-z]{2})?)$/i,GR:/^\d{3}\s?\d{2}$/,IL:u,IN:l,IS:a,IT:u,JP:/^\d{3}\-\d{4}$/,KE:u,LI:/^(948[5-9]|949[0-7])$/,MX:u,NL:/^\d{4}\s?[a-z]{2}$/i,NO:s,PL:/^\d{2}\-\d{3}$/,PT:/^\d{4}(\-\d{3})?$/,RO:l,RU:l,SA:u,SE:/^\d{3}\s?\d{2}$/,TW:/^\d{3}(\d{2})?$/,US:/^\d{5}(-\d{4})?$/,ZA:s,ZM:u};t.locales=Object.keys(f)},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e);var r=t?new RegExp("^["+t+"]+","g"):/^\s+/g;return e.replace(r,"")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e);for(var r=t?new RegExp("["+t+"]"):/\s/,n=e.length-1;n>=0&&r.test(e[n]);)n--;return n<e.length?e.substr(0,n+1):e}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)((0,u.default)(e,t),t)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(68),a=n(o),s=r(67),u=n(s);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),e.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\//g,"&#x2F;").replace(/\\/g,"&#x5C;").replace(/`/g,"&#96;")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e){return(0,a.default)(e),e.replace(/&amp;/g,"&").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#x2F;/g,"/").replace(/&#x5C;/g,"\\").replace(/&#96;/g,"`")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e);var r=t?"\\x00-\\x09\\x0B\\x0C\\x0E-\\x1F\\x7F":"\\x00-\\x1F\\x7F";return(0,u.default)(e,r)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o),s=r(73),u=n(s);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),e.replace(new RegExp("["+t+"]+","g"),"")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){return(0,a.default)(e),e.replace(new RegExp("[^"+t+"]+","g"),"")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){(0,a.default)(e);for(var r=e.length-1;r>=0;r--)if(t.indexOf(e[r])===-1)return!1;return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(11),a=n(o);e.exports=t.default},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function i(e,t){if(t=(0,u.default)(t,l),!(0,a.default)(e))return!1;var r=e.split("@"),n=r.pop(),i=r.join("@"),o=[i,n];if(o[1]=o[1].toLowerCase(),"gmail.com"===o[1]||"googlemail.com"===o[1]){if(t.gmail_remove_subaddress&&(o[0]=o[0].split("+")[0]),t.gmail_remove_dots&&(o[0]=o[0].replace(/\./g,"")),!o[0].length)return!1;(t.all_lowercase||t.gmail_lowercase)&&(o[0]=o[0].toLowerCase()),o[1]=t.gmail_convert_googlemaildotcom?"gmail.com":o[1]}else if(~f.indexOf(o[1])){if(t.icloud_remove_subaddress&&(o[0]=o[0].split("+")[0]),!o[0].length)return!1;(t.all_lowercase||t.icloud_lowercase)&&(o[0]=o[0].toLowerCase())}else if(~d.indexOf(o[1])){if(t.outlookdotcom_remove_subaddress&&(o[0]=o[0].split("+")[0]),!o[0].length)return!1;(t.all_lowercase||t.outlookdotcom_lowercase)&&(o[0]=o[0].toLowerCase())}else if(~c.indexOf(o[1])){if(t.yahoo_remove_subaddress){var s=o[0].split("-");o[0]=s.length>1?s.slice(0,-1).join("-"):s[0]}if(!o[0].length)return!1;(t.all_lowercase||t.yahoo_lowercase)&&(o[0]=o[0].toLowerCase())}else t.all_lowercase&&(o[0]=o[0].toLowerCase());return o.join("@")}Object.defineProperty(t,"__esModule",{value:!0}),t.default=i;var o=r(19),a=n(o),s=r(20),u=n(s),l={all_lowercase:!0,gmail_lowercase:!0,gmail_remove_dots:!0,gmail_remove_subaddress:!0,gmail_convert_googlemaildotcom:!0,outlookdotcom_lowercase:!0,outlookdotcom_remove_subaddress:!0,yahoo_lowercase:!0,yahoo_remove_subaddress:!0,icloud_lowercase:!0,icloud_remove_subaddress:!0},f=["icloud.com","me.com"],d=["hotmail.at","hotmail.be","hotmail.ca","hotmail.cl","hotmail.co.il","hotmail.co.nz","hotmail.co.th","hotmail.co.uk","hotmail.com","hotmail.com.ar","hotmail.com.au","hotmail.com.br","hotmail.com.gr","hotmail.com.mx","hotmail.com.pe","hotmail.com.tr","hotmail.com.vn","hotmail.cz","hotmail.de","hotmail.dk","hotmail.es","hotmail.fr","hotmail.hu","hotmail.id","hotmail.ie","hotmail.in","hotmail.it","hotmail.jp","hotmail.kr","hotmail.lv","hotmail.my","hotmail.ph","hotmail.pt","hotmail.sa","hotmail.sg","hotmail.sk","live.be","live.co.uk","live.com","live.com.ar","live.com.mx","live.de","live.es","live.eu","live.fr","live.it","live.nl","msn.com","outlook.at","outlook.be","outlook.cl","outlook.co.il","outlook.co.nz","outlook.co.th","outlook.com","outlook.com.ar","outlook.com.au","outlook.com.br","outlook.com.gr","outlook.com.pe","outlook.com.tr","outlook.com.vn","outlook.cz","outlook.de","outlook.dk","outlook.es","outlook.fr","outlook.hu","outlook.id","outlook.ie","outlook.in","outlook.it","outlook.jp","outlook.kr","outlook.lv","outlook.my","outlook.ph","outlook.pt","outlook.sa","outlook.sg","outlook.sk","passport.com"],c=["rocketmail.com","yahoo.ca","yahoo.co.uk","yahoo.com","yahoo.de","yahoo.fr","yahoo.in","yahoo.it","ymail.com"];e.exports=t.default},function(e,t,r){"use strict";var n=r(8),i=r(5),o=r(7),a={multipleOf:function(e,t,r){"number"==typeof r&&"integer"!==o.whatIs(r/t.multipleOf)&&e.addError("MULTIPLE_OF",[r,t.multipleOf],null,t.description)},maximum:function(e,t,r){"number"==typeof r&&(t.exclusiveMaximum!==!0?r>t.maximum&&e.addError("MAXIMUM",[r,t.maximum],null,t.description):r>=t.maximum&&e.addError("MAXIMUM_EXCLUSIVE",[r,t.maximum],null,t.description))},exclusiveMaximum:function(){},minimum:function(e,t,r){"number"==typeof r&&(t.exclusiveMinimum!==!0?r<t.minimum&&e.addError("MINIMUM",[r,t.minimum],null,t.description):r<=t.minimum&&e.addError("MINIMUM_EXCLUSIVE",[r,t.minimum],null,t.description))},exclusiveMinimum:function(){},maxLength:function(e,t,r){"string"==typeof r&&o.ucs2decode(r).length>t.maxLength&&e.addError("MAX_LENGTH",[r.length,t.maxLength],null,t.description)},minLength:function(e,t,r){"string"==typeof r&&o.ucs2decode(r).length<t.minLength&&e.addError("MIN_LENGTH",[r.length,t.minLength],null,t.description)},pattern:function(e,t,r){"string"==typeof r&&RegExp(t.pattern).test(r)===!1&&e.addError("PATTERN",[t.pattern,r],null,t.description)},additionalItems:function(e,t,r){Array.isArray(r)&&t.additionalItems===!1&&Array.isArray(t.items)&&r.length>t.items.length&&e.addError("ARRAY_ADDITIONAL_ITEMS",null,null,t.description)},items:function(){},maxItems:function(e,t,r){Array.isArray(r)&&r.length>t.maxItems&&e.addError("ARRAY_LENGTH_LONG",[r.length,t.maxItems],null,t.description)},minItems:function(e,t,r){Array.isArray(r)&&r.length<t.minItems&&e.addError("ARRAY_LENGTH_SHORT",[r.length,t.minItems],null,t.description)},uniqueItems:function(e,t,r){if(Array.isArray(r)&&t.uniqueItems===!0){var n=[];o.isUniqueArray(r,n)===!1&&e.addError("ARRAY_UNIQUE",n,null,t.description)}},maxProperties:function(e,t,r){if("object"===o.whatIs(r)){var n=Object.keys(r).length;n>t.maxProperties&&e.addError("OBJECT_PROPERTIES_MAXIMUM",[n,t.maxProperties],null,t.description)}},minProperties:function(e,t,r){if("object"===o.whatIs(r)){var n=Object.keys(r).length;n<t.minProperties&&e.addError("OBJECT_PROPERTIES_MINIMUM",[n,t.minProperties],null,t.description)}},required:function(e,t,r){if("object"===o.whatIs(r))for(var n=t.required.length;n--;){var i=t.required[n];void 0===r[i]&&e.addError("OBJECT_MISSING_REQUIRED_PROPERTY",[i],null,t.description)}},additionalProperties:function(e,t,r){if(void 0===t.properties&&void 0===t.patternProperties)return a.properties.call(this,e,t,r)},patternProperties:function(e,t,r){if(void 0===t.properties)return a.properties.call(this,e,t,r)},properties:function(e,t,r){if("object"===o.whatIs(r)){var n=void 0!==t.properties?t.properties:{},i=void 0!==t.patternProperties?t.patternProperties:{};if(t.additionalProperties===!1){var a=Object.keys(r),s=Object.keys(n),u=Object.keys(i);a=o.difference(a,s);for(var l=u.length;l--;)for(var f=RegExp(u[l]),d=a.length;d--;)f.test(a[d])===!0&&a.splice(d,1);if(a.length>0){var c=this.options.assumeAdditional.length;if(c)for(;c--;){var p=a.indexOf(this.options.assumeAdditional[c]);p!==-1&&a.splice(p,1)}a.length>0&&e.addError("OBJECT_ADDITIONAL_PROPERTIES",[a],null,t.description)}}}},dependencies:function(e,r,n){if("object"===o.whatIs(n))for(var i=Object.keys(r.dependencies),a=i.length;a--;){var s=i[a];if(n[s]){var u=r.dependencies[s];if("object"===o.whatIs(u))t.validate.call(this,e,u,n);else for(var l=u.length;l--;){var f=u[l];void 0===n[f]&&e.addError("OBJECT_DEPENDENCY_KEY",[f,s],null,r.description)}}}},enum:function(e,t,r){for(var n=!1,i=t.enum.length;i--;)if(o.areEqual(r,t.enum[i])){n=!0;break}n===!1&&e.addError("ENUM_MISMATCH",[r],null,t.description)},allOf:function(e,r,n){for(var i=r.allOf.length;i--;){var o=t.validate.call(this,e,r.allOf[i],n);if(this.options.breakOnFirstError&&o===!1)break}},anyOf:function(e,r,n){for(var o=[],a=!1,s=r.anyOf.length;s--&&a===!1;){var u=new i(e);o.push(u),a=t.validate.call(this,u,r.anyOf[s],n)}a===!1&&e.addError("ANY_OF_MISSING",void 0,o,r.description)},oneOf:function(e,r,n){for(var o=0,a=[],s=r.oneOf.length;s--;){var u=new i(e,{maxErrors:1});a.push(u),t.validate.call(this,u,r.oneOf[s],n)===!0&&o++}0===o?e.addError("ONE_OF_MISSING",void 0,a,r.description):o>1&&e.addError("ONE_OF_MULTIPLE",null,null,r.description)},not:function(e,r,n){var o=new i(e);t.validate.call(this,o,r.not,n)===!0&&e.addError("NOT_PASSED",null,null,r.description)},definitions:function(){},format:function(e,t,r){var i=n[t.format];"function"==typeof i?2===i.length?e.addAsyncTask(i,[r],function(n){n!==!0&&e.addError("INVALID_FORMAT",[t.format,r],null,t.description)}):i.call(this,r)!==!0&&e.addError("INVALID_FORMAT",[t.format,r],null,t.description):this.options.ignoreUnknownFormats!==!0&&e.addError("UNKNOWN_FORMAT",[t.format],null,t.description)}},s=function(e,r,n){var i=n.length;if(Array.isArray(r.items))for(;i--;)i<r.items.length?(e.path.push(i.toString()),t.validate.call(this,e,r.items[i],n[i]),e.path.pop()):"object"==typeof r.additionalItems&&(e.path.push(i.toString()),t.validate.call(this,e,r.additionalItems,n[i]),e.path.pop());else if("object"==typeof r.items)for(;i--;)e.path.push(i.toString()),t.validate.call(this,e,r.items,n[i]),e.path.pop()},u=function(e,r,n){var i=r.additionalProperties;i!==!0&&void 0!==i||(i={});for(var o=r.properties?Object.keys(r.properties):[],a=r.patternProperties?Object.keys(r.patternProperties):[],s=Object.keys(n),u=s.length;u--;){var l=s[u],f=n[l],d=[];o.indexOf(l)!==-1&&d.push(r.properties[l]);for(var c=a.length;c--;){var p=a[c];RegExp(p).test(l)===!0&&d.push(r.patternProperties[p])}for(0===d.length&&i!==!1&&d.push(i),c=d.length;c--;)e.path.push(l),t.validate.call(this,e,d[c],f),e.path.pop()}};t.validate=function(e,t,r){e.commonErrorMessage="JSON_OBJECT_VALIDATION_FAILED";var n=o.whatIs(t);if("object"!==n)return e.addError("SCHEMA_NOT_AN_OBJECT",[n],null,t.description),!1;var i=Object.keys(t);if(0===i.length)return!0;var l=!1;if(e.rootSchema||(e.rootSchema=t,l=!0),void 0!==t.$ref){
for(var f=99;t.$ref&&f>0;){if(!t.__$refResolved){e.addError("REF_UNRESOLVED",[t.$ref],null,t.description);break}if(t.__$refResolved===t)break;t=t.__$refResolved,i=Object.keys(t),f--}if(0===f)throw new Error("Circular dependency by $ref references!")}var d=o.whatIs(r);if(t.type)if("string"==typeof t.type){if(d!==t.type&&("integer"!==d||"number"!==t.type)&&(e.addError("INVALID_TYPE",[t.type,d],null,t.description),this.options.breakOnFirstError))return!1}else if(t.type.indexOf(d)===-1&&("integer"!==d||t.type.indexOf("number")===-1)&&(e.addError("INVALID_TYPE",[t.type,d],null,t.description),this.options.breakOnFirstError))return!1;for(var c=i.length;c--&&!(a[i[c]]&&(a[i[c]].call(this,e,t,r),e.errors.length&&this.options.breakOnFirstError)););return 0!==e.errors.length&&this.options.breakOnFirstError!==!1||("array"===d?s.call(this,e,t,r):"object"===d&&u.call(this,e,t,r)),"function"==typeof this.options.customValidator&&this.options.customValidator(e,t,r),l&&(e.rootSchema=void 0),0===e.errors.length}},function(e,t,r){"use strict";function n(e){return decodeURIComponent(e).replace(/~[0-1]/g,function(e){return"~1"===e?"/":"~"})}function i(e){var t=e.indexOf("#");return t===-1?e:e.slice(0,t)}function o(e){var t=e.indexOf("#"),r=t===-1?void 0:e.slice(t+1);return r}function a(e,t){if("object"==typeof e&&null!==e){if(!t)return e;if(e.id&&(e.id===t||"#"===e.id[0]&&e.id.substring(1)===t))return e;var r,n;if(Array.isArray(e)){for(r=e.length;r--;)if(n=a(e[r],t))return n}else{var i=Object.keys(e);for(r=i.length;r--;){var o=i[r];if(0!==o.indexOf("__$")&&(n=a(e[o],t)))return n}}}}var s=r(79),u=r(5),l=r(81),f=r(82),d=r(7);t.cacheSchemaByUri=function(e,t){var r=i(e);r&&(this.cache[r]=t)},t.removeFromCacheByUri=function(e){var t=i(e);t&&delete this.cache[t]},t.checkCacheForUri=function(e){var t=i(e);return!!t&&null!=this.cache[t]},t.getSchema=function(e,r){return"object"==typeof r&&(r=t.getSchemaByReference.call(this,e,r)),"string"==typeof r&&(r=t.getSchemaByUri.call(this,e,r)),r},t.getSchemaByReference=function(e,t){for(var r=this.referenceCache.length;r--;)if(s(this.referenceCache[r][0],t))return this.referenceCache[r][1];var n=d.cloneDeep(t);return this.referenceCache.push([t,n]),n},t.getSchemaByUri=function(e,t,r){var s=i(t),d=o(t),c=s?this.cache[s]:r;if(c&&s){var p=c!==r;if(p){e.path.push(s);var h=new u(e);l.compileSchema.call(this,h,c)&&f.validateSchema.call(this,h,c);var _=h.isValid();if(_||e.addError("REMOTE_NOT_VALID",[t],h),e.path.pop(),!_)return}}if(c&&d)for(var m=d.split("/"),y=0,v=m.length;c&&y<v;y++){var E=n(m[y]);c=0===y?a(c,E):c[E]}return c},t.getRemotePath=i},function(e,t,r){(function(e,r){function n(e,t){for(var r=-1,n=null==e?0:e.length,i=0,o=[];++r<n;){var a=e[r];t(a,r,e)&&(o[i++]=a)}return o}function i(e,t){for(var r=-1,n=t.length,i=e.length;++r<n;)e[i+r]=t[r];return e}function o(e,t){for(var r=-1,n=null==e?0:e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}function a(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function s(e){return function(t){return e(t)}}function u(e,t){return e.has(t)}function l(e,t){return null==e?void 0:e[t]}function f(e){var t=-1,r=Array(e.size);return e.forEach(function(e,n){r[++t]=[n,e]}),r}function d(e,t){return function(r){return e(t(r))}}function c(e){var t=-1,r=Array(e.size);return e.forEach(function(e){r[++t]=e}),r}function p(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function h(){this.__data__=Ct?Ct(null):{},this.size=0}function _(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}function m(e){var t=this.__data__;if(Ct){var r=t[e];return r===ge?void 0:r}return Et.call(t,e)?t[e]:void 0}function y(e){var t=this.__data__;return Ct?void 0!==t[e]:Et.call(t,e)}function v(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=Ct&&void 0===t?ge:t,this}function E(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function g(){this.__data__=[],this.size=0}function b(e){var t=this.__data__,r=L(t,e);if(r<0)return!1;var n=t.length-1;return r==n?t.pop():Mt.call(t,r,1),--this.size,!0}function O(e){var t=this.__data__,r=L(t,e);return r<0?void 0:t[r][1]}function A(e){return L(this.__data__,e)>-1}function x(e,t){var r=this.__data__,n=L(r,e);return n<0?(++this.size,r.push([e,t])):r[n][1]=t,this}function R(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function P(){this.size=0,this.__data__={hash:new p,map:new(Dt||E),string:new p}}function M(e){var t=ee(this,e).delete(e);return this.size-=t?1:0,t}function T(e){return ee(this,e).get(e)}function S(e){return ee(this,e).has(e)}function I(e,t){var r=ee(this,e),n=r.size;return r.set(e,t),this.size+=r.size==n?0:1,this}function $(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new R;++t<r;)this.add(e[t])}function j(e){return this.__data__.set(e,ge),this}function D(e){return this.__data__.has(e)}function w(e){var t=this.__data__=new E(e);this.size=t.size}function F(){this.__data__=new E,this.size=0}function N(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r}function C(e){return this.__data__.get(e)}function U(e){return this.__data__.has(e)}function k(e,t){var r=this.__data__;if(r instanceof E){var n=r.__data__;if(!Dt||n.length<Ee-1)return n.push([e,t]),this.size=++r.size,this;r=this.__data__=new R(n)}return r.set(e,t),this.size=r.size,this}function Y(e,t){var r=Vt(e),n=!r&&zt(e),i=!r&&!n&&Xt(e),o=!r&&!n&&!i&&Ht(e),s=r||n||i||o,u=s?a(e.length,String):[],l=u.length;for(var f in e)!t&&!Et.call(e,f)||s&&("length"==f||i&&("offset"==f||"parent"==f)||o&&("buffer"==f||"byteLength"==f||"byteOffset"==f)||ne(f,l))||u.push(f);return u}function L(e,t){for(var r=e.length;r--;)if(le(e[r][0],t))return r;return-1}function K(e,t,r){var n=t(e);return Vt(e)?n:i(n,r(e))}function W(e){return null==e?void 0===e?Ke:we:Tt&&Tt in Object(e)?re(e):se(e)}function B(e){return _e(e)&&W(e)==xe}function q(e,t,r,n,i){return e===t||(null==e||null==t||!_e(e)&&!_e(t)?e!==e&&t!==t:Z(e,t,r,n,q,i))}function Z(e,t,r,n,i,o){var a=Vt(e),s=Vt(t),u=a?Re:Zt(e),l=s?Re:Zt(t);u=u==xe?Fe:u,l=l==xe?Fe:l;var f=u==Fe,d=l==Fe,c=u==l;if(c&&Xt(e)){if(!Xt(t))return!1;a=!0,f=!1}if(c&&!f)return o||(o=new w),a||Ht(e)?H(e,t,r,n,i,o):G(e,t,u,r,n,i,o);if(!(r&be)){var p=f&&Et.call(e,"__wrapped__"),h=d&&Et.call(t,"__wrapped__");if(p||h){var _=p?e.value():e,m=h?t.value():t;return o||(o=new w),i(_,m,r,n,o)}}return!!c&&(o||(o=new w),J(e,t,r,n,i,o))}function z(e){if(!he(e)||oe(e))return!1;var t=ce(e)?Ot:rt;return t.test(ue(e))}function V(e){return _e(e)&&pe(e.length)&&!!it[W(e)]}function X(e){if(!ae(e))return $t(e);var t=[];for(var r in Object(e))Et.call(e,r)&&"constructor"!=r&&t.push(r);return t}function H(e,t,r,n,i,a){var s=r&be,l=e.length,f=t.length;if(l!=f&&!(s&&f>l))return!1;var d=a.get(e);if(d&&a.get(t))return d==t;var c=-1,p=!0,h=r&Oe?new $:void 0;for(a.set(e,t),a.set(t,e);++c<l;){var _=e[c],m=t[c];if(n)var y=s?n(m,_,c,t,e,a):n(_,m,c,e,t,a);if(void 0!==y){if(y)continue;p=!1;break}if(h){if(!o(t,function(e,t){if(!u(h,t)&&(_===e||i(_,e,r,n,a)))return h.push(t)})){p=!1;break}}else if(_!==m&&!i(_,m,r,n,a)){p=!1;break}}return a.delete(e),a.delete(t),p}function G(e,t,r,n,i,o,a){switch(r){case qe:if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case Be:return!(e.byteLength!=t.byteLength||!o(new Rt(e),new Rt(t)));case Me:case Te:case De:return le(+e,+t);case Se:return e.name==t.name&&e.message==t.message;case Ue:case Ye:return e==t+"";case je:var s=f;case ke:var u=n&be;if(s||(s=c),e.size!=t.size&&!u)return!1;var l=a.get(e);if(l)return l==t;n|=Oe,a.set(e,t);var d=H(s(e),s(t),n,i,o,a);return a.delete(e),d;case Le:if(Bt)return Bt.call(e)==Bt.call(t)}return!1}function J(e,t,r,n,i,o){var a=r&be,s=Q(e),u=s.length,l=Q(t),f=l.length;if(u!=f&&!a)return!1;for(var d=u;d--;){var c=s[d];if(!(a?c in t:Et.call(t,c)))return!1}var p=o.get(e);if(p&&o.get(t))return p==t;var h=!0;o.set(e,t),o.set(t,e);for(var _=a;++d<u;){c=s[d];var m=e[c],y=t[c];if(n)var v=a?n(y,m,c,t,e,o):n(m,y,c,e,t,o);if(!(void 0===v?m===y||i(m,y,r,n,o):v)){h=!1;break}_||(_="constructor"==c)}if(h&&!_){var E=e.constructor,g=t.constructor;E!=g&&"constructor"in e&&"constructor"in t&&!("function"==typeof E&&E instanceof E&&"function"==typeof g&&g instanceof g)&&(h=!1)}return o.delete(e),o.delete(t),h}function Q(e){return K(e,me,qt)}function ee(e,t){var r=e.__data__;return ie(t)?r["string"==typeof t?"string":"hash"]:r.map}function te(e,t){var r=l(e,t);return z(r)?r:void 0}function re(e){var t=Et.call(e,Tt),r=e[Tt];try{e[Tt]=void 0;var n=!0}catch(e){}var i=bt.call(e);return n&&(t?e[Tt]=r:delete e[Tt]),i}function ne(e,t){return t=null==t?Ae:t,!!t&&("number"==typeof e||nt.test(e))&&e>-1&&e%1==0&&e<t}function ie(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}function oe(e){return!!gt&&gt in e}function ae(e){var t=e&&e.constructor,r="function"==typeof t&&t.prototype||mt;return e===r}function se(e){return bt.call(e)}function ue(e){if(null!=e){try{return vt.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function le(e,t){return e===t||e!==e&&t!==t}function fe(e){return null!=e&&pe(e.length)&&!ce(e)}function de(e,t){return q(e,t)}function ce(e){if(!he(e))return!1;var t=W(e);return t==Ie||t==$e||t==Pe||t==Ce}function pe(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=Ae}function he(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}function _e(e){return null!=e&&"object"==typeof e}function me(e){return fe(e)?Y(e):X(e)}function ye(){return[]}function ve(){return!1}var Ee=200,ge="__lodash_hash_undefined__",be=1,Oe=2,Ae=9007199254740991,xe="[object Arguments]",Re="[object Array]",Pe="[object AsyncFunction]",Me="[object Boolean]",Te="[object Date]",Se="[object Error]",Ie="[object Function]",$e="[object GeneratorFunction]",je="[object Map]",De="[object Number]",we="[object Null]",Fe="[object Object]",Ne="[object Promise]",Ce="[object Proxy]",Ue="[object RegExp]",ke="[object Set]",Ye="[object String]",Le="[object Symbol]",Ke="[object Undefined]",We="[object WeakMap]",Be="[object ArrayBuffer]",qe="[object DataView]",Ze="[object Float32Array]",ze="[object Float64Array]",Ve="[object Int8Array]",Xe="[object Int16Array]",He="[object Int32Array]",Ge="[object Uint8Array]",Je="[object Uint8ClampedArray]",Qe="[object Uint16Array]",et="[object Uint32Array]",tt=/[\\^$.*+?()[\]{}|]/g,rt=/^\[object .+?Constructor\]$/,nt=/^(?:0|[1-9]\d*)$/,it={};it[Ze]=it[ze]=it[Ve]=it[Xe]=it[He]=it[Ge]=it[Je]=it[Qe]=it[et]=!0,it[xe]=it[Re]=it[Be]=it[Me]=it[qe]=it[Te]=it[Se]=it[Ie]=it[je]=it[De]=it[Fe]=it[Ue]=it[ke]=it[Ye]=it[We]=!1;var ot="object"==typeof e&&e&&e.Object===Object&&e,at="object"==typeof self&&self&&self.Object===Object&&self,st=ot||at||Function("return this")(),ut="object"==typeof t&&t&&!t.nodeType&&t,lt=ut&&"object"==typeof r&&r&&!r.nodeType&&r,ft=lt&&lt.exports===ut,dt=ft&&ot.process,ct=function(){try{return dt&&dt.binding&&dt.binding("util")}catch(e){}}(),pt=ct&&ct.isTypedArray,ht=Array.prototype,_t=Function.prototype,mt=Object.prototype,yt=st["__core-js_shared__"],vt=_t.toString,Et=mt.hasOwnProperty,gt=function(){var e=/[^.]+$/.exec(yt&&yt.keys&&yt.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),bt=mt.toString,Ot=RegExp("^"+vt.call(Et).replace(tt,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),At=ft?st.Buffer:void 0,xt=st.Symbol,Rt=st.Uint8Array,Pt=mt.propertyIsEnumerable,Mt=ht.splice,Tt=xt?xt.toStringTag:void 0,St=Object.getOwnPropertySymbols,It=At?At.isBuffer:void 0,$t=d(Object.keys,Object),jt=te(st,"DataView"),Dt=te(st,"Map"),wt=te(st,"Promise"),Ft=te(st,"Set"),Nt=te(st,"WeakMap"),Ct=te(Object,"create"),Ut=ue(jt),kt=ue(Dt),Yt=ue(wt),Lt=ue(Ft),Kt=ue(Nt),Wt=xt?xt.prototype:void 0,Bt=Wt?Wt.valueOf:void 0;p.prototype.clear=h,p.prototype.delete=_,p.prototype.get=m,p.prototype.has=y,p.prototype.set=v,E.prototype.clear=g,E.prototype.delete=b,E.prototype.get=O,E.prototype.has=A,E.prototype.set=x,R.prototype.clear=P,R.prototype.delete=M,R.prototype.get=T,R.prototype.has=S,R.prototype.set=I,$.prototype.add=$.prototype.push=j,$.prototype.has=D,w.prototype.clear=F,w.prototype.delete=N,w.prototype.get=C,w.prototype.has=U,w.prototype.set=k;var qt=St?function(e){return null==e?[]:(e=Object(e),n(St(e),function(t){return Pt.call(e,t)}))}:ye,Zt=W;(jt&&Zt(new jt(new ArrayBuffer(1)))!=qe||Dt&&Zt(new Dt)!=je||wt&&Zt(wt.resolve())!=Ne||Ft&&Zt(new Ft)!=ke||Nt&&Zt(new Nt)!=We)&&(Zt=function(e){var t=W(e),r=t==Fe?e.constructor:void 0,n=r?ue(r):"";if(n)switch(n){case Ut:return qe;case kt:return je;case Yt:return Ne;case Lt:return ke;case Kt:return We}return t});var zt=B(function(){return arguments}())?B:function(e){return _e(e)&&Et.call(e,"callee")&&!Pt.call(e,"callee")},Vt=Array.isArray,Xt=It||ve,Ht=pt?s(pt):V;r.exports=de}).call(t,function(){return this}(),r(80)(e))},function(e,t){e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children=[],e.webpackPolyfill=1),e}},function(e,t,r){"use strict";function n(e,t){if(u.isAbsoluteUri(t))return t;var r,n=e.join(""),i=u.isAbsoluteUri(n),o=u.isRelativeUri(n),a=u.isRelativeUri(t);i&&a?(r=n.match(/\/[^\/]*$/),r&&(n=n.slice(0,r.index+1))):o&&a?n="":(r=n.match(/[^#\/]+$/),r&&(n=n.slice(0,r.index)));var s=n+t;return s=s.replace(/##/,"#")}function i(e,t,r,o){if(t=t||[],r=r||[],o=o||[],"object"!=typeof e||null===e)return t;"string"==typeof e.id&&r.push(e.id),"string"==typeof e.$ref&&"undefined"==typeof e.__$refResolved&&t.push({ref:n(r,e.$ref),key:"$ref",obj:e,path:o.slice(0)}),"string"==typeof e.$schema&&"undefined"==typeof e.__$schemaResolved&&t.push({ref:n(r,e.$schema),key:"$schema",obj:e,path:o.slice(0)});var a;if(Array.isArray(e))for(a=e.length;a--;)o.push(a.toString()),i(e[a],t,r,o),o.pop();else{var s=Object.keys(e);for(a=s.length;a--;)0!==s[a].indexOf("__$")&&(o.push(s[a]),i(e[s[a]],t,r,o),o.pop())}return"string"==typeof e.id&&r.pop(),t}function o(e,t){for(var r=e.length;r--;)if(e[r].id===t)return e[r];return null}var a=r(5),s=r(78),u=r(7),l=function(e,r){for(var n=r.length,i=0;n--;){var o=new a(e),s=t.compileSchema.call(this,o,r[n]);s&&i++,e.errors=e.errors.concat(o.errors)}return i},f=function(e,t){var r,n=0;do{for(var i=e.errors.length;i--;)"UNRESOLVABLE_REFERENCE"===e.errors[i].code&&e.errors.splice(i,1);for(r=n,n=l.call(this,e,t),i=t.length;i--;){var a=t[i];if(a.__$missingReferences){for(var s=a.__$missingReferences.length;s--;){var u=a.__$missingReferences[s],f=o(t,u.ref);f&&(u.obj["__"+u.key+"Resolved"]=f,a.__$missingReferences.splice(s,1))}0===a.__$missingReferences.length&&delete a.__$missingReferences}}}while(n!==t.length&&n!==r);return e.isValid()};t.compileSchema=function(e,r){if(e.commonErrorMessage="SCHEMA_COMPILATION_FAILED","string"==typeof r){var n=s.getSchemaByUri.call(this,e,r);if(!n)return e.addError("SCHEMA_NOT_REACHABLE",[r]),!1;r=n}if(Array.isArray(r))return f.call(this,e,r);if(r.__$compiled&&r.id&&s.checkCacheForUri.call(this,r.id)===!1&&(r.__$compiled=void 0),r.__$compiled)return!0;r.id&&"string"==typeof r.id&&s.cacheSchemaByUri.call(this,r.id,r);var o=!1;e.rootSchema||(e.rootSchema=r,o=!0);var l=e.isValid();delete r.__$missingReferences;for(var d=i.call(this,r),c=d.length;c--;){var p=d[c],h=s.getSchemaByUri.call(this,e,p.ref,r);if(!h){var _=this.getSchemaReader();if(_){var m=_(p.ref);if(m){m.id=p.ref;var y=new a(e);t.compileSchema.call(this,y,m)?h=s.getSchemaByUri.call(this,e,p.ref,r):e.errors=e.errors.concat(y.errors)}}}if(!h){var v=e.hasError("REMOTE_NOT_VALID",[p.ref]),E=u.isAbsoluteUri(p.ref),g=!1,b=this.options.ignoreUnresolvableReferences===!0;E&&(g=s.checkCacheForUri.call(this,p.ref)),v||b&&E||g||(Array.prototype.push.apply(e.path,p.path),e.addError("UNRESOLVABLE_REFERENCE",[p.ref]),e.path=e.path.slice(0,-p.path.length),l&&(r.__$missingReferences=r.__$missingReferences||[],r.__$missingReferences.push(p)))}p.obj["__"+p.key+"Resolved"]=h}var O=e.isValid();return O?r.__$compiled=!0:r.id&&"string"==typeof r.id&&s.removeFromCacheByUri.call(this,r.id),o&&(e.rootSchema=void 0),O}},function(e,t,r){"use strict";var n=r(8),i=r(77),o=r(5),a=r(7),s={$ref:function(e,t){"string"!=typeof t.$ref&&e.addError("KEYWORD_TYPE_EXPECTED",["$ref","string"])},$schema:function(e,t){"string"!=typeof t.$schema&&e.addError("KEYWORD_TYPE_EXPECTED",["$schema","string"])},multipleOf:function(e,t){"number"!=typeof t.multipleOf?e.addError("KEYWORD_TYPE_EXPECTED",["multipleOf","number"]):t.multipleOf<=0&&e.addError("KEYWORD_MUST_BE",["multipleOf","strictly greater than 0"])},maximum:function(e,t){"number"!=typeof t.maximum&&e.addError("KEYWORD_TYPE_EXPECTED",["maximum","number"])},exclusiveMaximum:function(e,t){"boolean"!=typeof t.exclusiveMaximum?e.addError("KEYWORD_TYPE_EXPECTED",["exclusiveMaximum","boolean"]):void 0===t.maximum&&e.addError("KEYWORD_DEPENDENCY",["exclusiveMaximum","maximum"])},minimum:function(e,t){"number"!=typeof t.minimum&&e.addError("KEYWORD_TYPE_EXPECTED",["minimum","number"])},exclusiveMinimum:function(e,t){"boolean"!=typeof t.exclusiveMinimum?e.addError("KEYWORD_TYPE_EXPECTED",["exclusiveMinimum","boolean"]):void 0===t.minimum&&e.addError("KEYWORD_DEPENDENCY",["exclusiveMinimum","minimum"])},maxLength:function(e,t){"integer"!==a.whatIs(t.maxLength)?e.addError("KEYWORD_TYPE_EXPECTED",["maxLength","integer"]):t.maxLength<0&&e.addError("KEYWORD_MUST_BE",["maxLength","greater than, or equal to 0"])},minLength:function(e,t){"integer"!==a.whatIs(t.minLength)?e.addError("KEYWORD_TYPE_EXPECTED",["minLength","integer"]):t.minLength<0&&e.addError("KEYWORD_MUST_BE",["minLength","greater than, or equal to 0"])},pattern:function(e,t){if("string"!=typeof t.pattern)e.addError("KEYWORD_TYPE_EXPECTED",["pattern","string"]);else try{RegExp(t.pattern)}catch(r){e.addError("KEYWORD_PATTERN",["pattern",t.pattern])}},additionalItems:function(e,r){var n=a.whatIs(r.additionalItems);"boolean"!==n&&"object"!==n?e.addError("KEYWORD_TYPE_EXPECTED",["additionalItems",["boolean","object"]]):"object"===n&&(e.path.push("additionalItems"),t.validateSchema.call(this,e,r.additionalItems),e.path.pop())},items:function(e,r){var n=a.whatIs(r.items);if("object"===n)e.path.push("items"),t.validateSchema.call(this,e,r.items),e.path.pop();else if("array"===n)for(var i=r.items.length;i--;)e.path.push("items"),e.path.push(i.toString()),t.validateSchema.call(this,e,r.items[i]),e.path.pop(),e.path.pop();else e.addError("KEYWORD_TYPE_EXPECTED",["items",["array","object"]]);this.options.forceAdditional===!0&&void 0===r.additionalItems&&Array.isArray(r.items)&&e.addError("KEYWORD_UNDEFINED_STRICT",["additionalItems"]),this.options.assumeAdditional&&void 0===r.additionalItems&&Array.isArray(r.items)&&(r.additionalItems=!1)},maxItems:function(e,t){"number"!=typeof t.maxItems?e.addError("KEYWORD_TYPE_EXPECTED",["maxItems","integer"]):t.maxItems<0&&e.addError("KEYWORD_MUST_BE",["maxItems","greater than, or equal to 0"])},minItems:function(e,t){"integer"!==a.whatIs(t.minItems)?e.addError("KEYWORD_TYPE_EXPECTED",["minItems","integer"]):t.minItems<0&&e.addError("KEYWORD_MUST_BE",["minItems","greater than, or equal to 0"])},uniqueItems:function(e,t){"boolean"!=typeof t.uniqueItems&&e.addError("KEYWORD_TYPE_EXPECTED",["uniqueItems","boolean"])},maxProperties:function(e,t){"integer"!==a.whatIs(t.maxProperties)?e.addError("KEYWORD_TYPE_EXPECTED",["maxProperties","integer"]):t.maxProperties<0&&e.addError("KEYWORD_MUST_BE",["maxProperties","greater than, or equal to 0"])},minProperties:function(e,t){"integer"!==a.whatIs(t.minProperties)?e.addError("KEYWORD_TYPE_EXPECTED",["minProperties","integer"]):t.minProperties<0&&e.addError("KEYWORD_MUST_BE",["minProperties","greater than, or equal to 0"])},required:function(e,t){if("array"!==a.whatIs(t.required))e.addError("KEYWORD_TYPE_EXPECTED",["required","array"]);else if(0===t.required.length)e.addError("KEYWORD_MUST_BE",["required","an array with at least one element"]);else{for(var r=t.required.length;r--;)"string"!=typeof t.required[r]&&e.addError("KEYWORD_VALUE_TYPE",["required","string"]);a.isUniqueArray(t.required)===!1&&e.addError("KEYWORD_MUST_BE",["required","an array with unique items"])}},additionalProperties:function(e,r){var n=a.whatIs(r.additionalProperties);"boolean"!==n&&"object"!==n?e.addError("KEYWORD_TYPE_EXPECTED",["additionalProperties",["boolean","object"]]):"object"===n&&(e.path.push("additionalProperties"),t.validateSchema.call(this,e,r.additionalProperties),e.path.pop())},properties:function(e,r){if("object"!==a.whatIs(r.properties))return void e.addError("KEYWORD_TYPE_EXPECTED",["properties","object"]);for(var n=Object.keys(r.properties),i=n.length;i--;){var o=n[i],s=r.properties[o];e.path.push("properties"),e.path.push(o),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop()}this.options.forceAdditional===!0&&void 0===r.additionalProperties&&e.addError("KEYWORD_UNDEFINED_STRICT",["additionalProperties"]),this.options.assumeAdditional&&void 0===r.additionalProperties&&(r.additionalProperties=!1),this.options.forceProperties===!0&&0===n.length&&e.addError("CUSTOM_MODE_FORCE_PROPERTIES",["properties"])},patternProperties:function(e,r){if("object"!==a.whatIs(r.patternProperties))return void e.addError("KEYWORD_TYPE_EXPECTED",["patternProperties","object"]);for(var n=Object.keys(r.patternProperties),i=n.length;i--;){var o=n[i],s=r.patternProperties[o];try{RegExp(o)}catch(t){e.addError("KEYWORD_PATTERN",["patternProperties",o])}e.path.push("patternProperties"),e.path.push(o.toString()),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop()}this.options.forceProperties===!0&&0===n.length&&e.addError("CUSTOM_MODE_FORCE_PROPERTIES",["patternProperties"])},dependencies:function(e,r){if("object"!==a.whatIs(r.dependencies))e.addError("KEYWORD_TYPE_EXPECTED",["dependencies","object"]);else for(var n=Object.keys(r.dependencies),i=n.length;i--;){var o=n[i],s=r.dependencies[o],u=a.whatIs(s);if("object"===u)e.path.push("dependencies"),e.path.push(o),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop();else if("array"===u){var l=s.length;for(0===l&&e.addError("KEYWORD_MUST_BE",["dependencies","not empty array"]);l--;)"string"!=typeof s[l]&&e.addError("KEYWORD_VALUE_TYPE",["dependensices","string"]);a.isUniqueArray(s)===!1&&e.addError("KEYWORD_MUST_BE",["dependencies","an array with unique items"])}else e.addError("KEYWORD_VALUE_TYPE",["dependencies","object or array"])}},enum:function(e,t){Array.isArray(t.enum)===!1?e.addError("KEYWORD_TYPE_EXPECTED",["enum","array"]):0===t.enum.length?e.addError("KEYWORD_MUST_BE",["enum","an array with at least one element"]):a.isUniqueArray(t.enum)===!1&&e.addError("KEYWORD_MUST_BE",["enum","an array with unique elements"])},type:function(e,t){var r=["array","boolean","integer","number","null","object","string"],n=r.join(","),i=Array.isArray(t.type);if(i){for(var o=t.type.length;o--;)r.indexOf(t.type[o])===-1&&e.addError("KEYWORD_TYPE_EXPECTED",["type",n]);a.isUniqueArray(t.type)===!1&&e.addError("KEYWORD_MUST_BE",["type","an object with unique properties"])}else"string"==typeof t.type?r.indexOf(t.type)===-1&&e.addError("KEYWORD_TYPE_EXPECTED",["type",n]):e.addError("KEYWORD_TYPE_EXPECTED",["type",["string","array"]]);this.options.noEmptyStrings===!0&&("string"===t.type||i&&t.type.indexOf("string")!==-1)&&void 0===t.minLength&&void 0===t.enum&&void 0===t.format&&(t.minLength=1),this.options.noEmptyArrays===!0&&("array"===t.type||i&&t.type.indexOf("array")!==-1)&&void 0===t.minItems&&(t.minItems=1),this.options.forceProperties===!0&&("object"===t.type||i&&t.type.indexOf("object")!==-1)&&void 0===t.properties&&void 0===t.patternProperties&&e.addError("KEYWORD_UNDEFINED_STRICT",["properties"]),this.options.forceItems===!0&&("array"===t.type||i&&t.type.indexOf("array")!==-1)&&void 0===t.items&&e.addError("KEYWORD_UNDEFINED_STRICT",["items"]),this.options.forceMinItems===!0&&("array"===t.type||i&&t.type.indexOf("array")!==-1)&&void 0===t.minItems&&e.addError("KEYWORD_UNDEFINED_STRICT",["minItems"]),this.options.forceMaxItems===!0&&("array"===t.type||i&&t.type.indexOf("array")!==-1)&&void 0===t.maxItems&&e.addError("KEYWORD_UNDEFINED_STRICT",["maxItems"]),this.options.forceMinLength===!0&&("string"===t.type||i&&t.type.indexOf("string")!==-1)&&void 0===t.minLength&&void 0===t.format&&void 0===t.enum&&void 0===t.pattern&&e.addError("KEYWORD_UNDEFINED_STRICT",["minLength"]),this.options.forceMaxLength===!0&&("string"===t.type||i&&t.type.indexOf("string")!==-1)&&void 0===t.maxLength&&void 0===t.format&&void 0===t.enum&&void 0===t.pattern&&e.addError("KEYWORD_UNDEFINED_STRICT",["maxLength"])},allOf:function(e,r){if(Array.isArray(r.allOf)===!1)e.addError("KEYWORD_TYPE_EXPECTED",["allOf","array"]);else if(0===r.allOf.length)e.addError("KEYWORD_MUST_BE",["allOf","an array with at least one element"]);else for(var n=r.allOf.length;n--;)e.path.push("allOf"),e.path.push(n.toString()),t.validateSchema.call(this,e,r.allOf[n]),e.path.pop(),e.path.pop()},anyOf:function(e,r){if(Array.isArray(r.anyOf)===!1)e.addError("KEYWORD_TYPE_EXPECTED",["anyOf","array"]);else if(0===r.anyOf.length)e.addError("KEYWORD_MUST_BE",["anyOf","an array with at least one element"]);else for(var n=r.anyOf.length;n--;)e.path.push("anyOf"),e.path.push(n.toString()),t.validateSchema.call(this,e,r.anyOf[n]),e.path.pop(),e.path.pop()},oneOf:function(e,r){if(Array.isArray(r.oneOf)===!1)e.addError("KEYWORD_TYPE_EXPECTED",["oneOf","array"]);else if(0===r.oneOf.length)e.addError("KEYWORD_MUST_BE",["oneOf","an array with at least one element"]);else for(var n=r.oneOf.length;n--;)e.path.push("oneOf"),e.path.push(n.toString()),t.validateSchema.call(this,e,r.oneOf[n]),e.path.pop(),e.path.pop()},not:function(e,r){"object"!==a.whatIs(r.not)?e.addError("KEYWORD_TYPE_EXPECTED",["not","object"]):(e.path.push("not"),t.validateSchema.call(this,e,r.not),e.path.pop())},definitions:function(e,r){if("object"!==a.whatIs(r.definitions))e.addError("KEYWORD_TYPE_EXPECTED",["definitions","object"]);else for(var n=Object.keys(r.definitions),i=n.length;i--;){var o=n[i],s=r.definitions[o];e.path.push("definitions"),e.path.push(o),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop()}},format:function(e,t){"string"!=typeof t.format?e.addError("KEYWORD_TYPE_EXPECTED",["format","string"]):void 0===n[t.format]&&this.options.ignoreUnknownFormats!==!0&&e.addError("UNKNOWN_FORMAT",[t.format])},id:function(e,t){"string"!=typeof t.id&&e.addError("KEYWORD_TYPE_EXPECTED",["id","string"])},title:function(e,t){"string"!=typeof t.title&&e.addError("KEYWORD_TYPE_EXPECTED",["title","string"])},description:function(e,t){"string"!=typeof t.description&&e.addError("KEYWORD_TYPE_EXPECTED",["description","string"])},default:function(){}},u=function(e,r){for(var n=r.length;n--;)t.validateSchema.call(this,e,r[n]);return e.isValid()};t.validateSchema=function(e,t){if(e.commonErrorMessage="SCHEMA_VALIDATION_FAILED",Array.isArray(t))return u.call(this,e,t);if(t.__$validated)return!0;var r=t.$schema&&t.id!==t.$schema;if(r)if(t.__$schemaResolved&&t.__$schemaResolved!==t){var n=new o(e),l=i.validate.call(this,n,t.__$schemaResolved,t);l===!1&&e.addError("PARENT_SCHEMA_VALIDATION_FAILED",null,n)}else this.options.ignoreUnresolvableReferences!==!0&&e.addError("REF_UNRESOLVED",[t.$schema]);if(this.options.noTypeless===!0){if(void 0!==t.type){var f=[];Array.isArray(t.anyOf)&&(f=f.concat(t.anyOf)),Array.isArray(t.oneOf)&&(f=f.concat(t.oneOf)),Array.isArray(t.allOf)&&(f=f.concat(t.allOf)),f.forEach(function(e){e.type||(e.type=t.type)})}void 0===t.enum&&void 0===t.type&&void 0===t.anyOf&&void 0===t.oneOf&&void 0===t.not&&void 0===t.$ref&&e.addError("KEYWORD_UNDEFINED_STRICT",["type"])}for(var d=Object.keys(t),c=d.length;c--;){var p=d[c];0!==p.indexOf("__")&&(void 0!==s[p]?s[p].call(this,e,t):r||this.options.noExtraKeywords===!0&&e.addError("KEYWORD_UNEXPECTED",[p]))}if(this.options.pedanticCheck===!0){if(t.enum){var h=a.clone(t);for(delete h.enum,delete h.default,e.path.push("enum"),c=t.enum.length;c--;)e.path.push(c.toString()),i.validate.call(this,e,h,t.enum[c]),e.path.pop();e.path.pop()}t.default&&(e.path.push("default"),i.validate.call(this,e,t,t.default),e.path.pop())}var _=e.isValid();return _&&(t.__$validated=!0),_}},function(e,t){e.exports={id:"http://json-schema.org/draft-04/schema#",$schema:"http://json-schema.org/draft-04/schema#",description:"Core schema meta-schema",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},positiveInteger:{type:"integer",minimum:0},positiveIntegerDefault0:{allOf:[{$ref:"#/definitions/positiveInteger"},{default:0}]},simpleTypes:{enum:["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},minItems:1,uniqueItems:!0}},type:"object",properties:{id:{type:"string",format:"uri"},$schema:{type:"string",format:"uri"},title:{type:"string"},description:{type:"string"},default:{},multipleOf:{type:"number",minimum:0,exclusiveMinimum:!0},maximum:{type:"number"},exclusiveMaximum:{type:"boolean",default:!1},minimum:{type:"number"},exclusiveMinimum:{type:"boolean",default:!1},maxLength:{$ref:"#/definitions/positiveInteger"},minLength:{$ref:"#/definitions/positiveIntegerDefault0"},pattern:{type:"string",format:"regex"},additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}],default:{}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],default:{}},maxItems:{$ref:"#/definitions/positiveInteger"},minItems:{$ref:"#/definitions/positiveIntegerDefault0"},uniqueItems:{type:"boolean",default:!1},maxProperties:{$ref:"#/definitions/positiveInteger"},minProperties:{$ref:"#/definitions/positiveIntegerDefault0"},required:{$ref:"#/definitions/stringArray"},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}],default:{}},definitions:{type:"object",additionalProperties:{$ref:"#"},default:{}},properties:{type:"object",additionalProperties:{$ref:"#"},default:{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},default:{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},enum:{type:"array",minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{type:"string"},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"}},dependencies:{exclusiveMaximum:["maximum"],exclusiveMinimum:["minimum"]},default:{}}},function(e,t){e.exports={$schema:"http://json-schema.org/draft-04/hyper-schema#",id:"http://json-schema.org/draft-04/hyper-schema#",title:"JSON Hyper-Schema",allOf:[{$ref:"http://json-schema.org/draft-04/schema#"}],properties:{additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}]},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}]},dependencies:{additionalProperties:{anyOf:[{$ref:"#"},{type:"array"}]}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}]},definitions:{additionalProperties:{$ref:"#"}},patternProperties:{additionalProperties:{$ref:"#"}},properties:{additionalProperties:{$ref:"#"}},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"},links:{type:"array",items:{$ref:"#/definitions/linkDescription"}},fragmentResolution:{type:"string"},media:{type:"object",properties:{type:{description:"A media type, as described in RFC 2046",type:"string"},binaryEncoding:{description:"A content encoding scheme, as described in RFC 2045",type:"string"}}},pathStart:{description:"Instances' URIs must start with this value for this schema to apply to them",type:"string",format:"uri"}},definitions:{schemaArray:{type:"array",items:{$ref:"#"}},linkDescription:{title:"Link Description Object",type:"object",required:["href","rel"],properties:{href:{description:"a URI template, as defined by RFC 6570, with the addition of the $, ( and ) characters for pre-processing",type:"string"},rel:{description:"relation to the target resource of the link",type:"string"},title:{description:"a title for the link",type:"string"
},targetSchema:{description:"JSON Schema describing the link target",$ref:"#"},mediaType:{description:"media type (as defined by RFC 2046) describing the link target",type:"string"},method:{description:'method for requesting the target of the link (e.g. for HTTP this might be "GET" or "DELETE")',type:"string"},encType:{description:"The media type in which to submit data along with the request",type:"string",default:"application/json"},schema:{description:"Schema describing the data to submit along with the request",$ref:"#"}}}}}}])});
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["RAML.XmlValidation"] = factory();
	else
		root["RAML.XmlValidation"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	"use strict";
	Object.defineProperty(exports, "__esModule", { value: true });
	var validator = __webpack_require__(1);
	var XMLValidator = (function () {
	    function XMLValidator(schema) {
	        this.schema = schema;
	    }
	    XMLValidator.prototype.validate = function (xml, references) {
	        if (references === void 0) { references = []; }
	        if (references.length === 0) {
	            var result = validator.validateXML({ xml: xml, schema: this.schema });
	            return (result && result.errors && result.errors.map(function (error) { return new Error(error); })) || [];
	        }
	        var schemas = this.remoteSchemas(references);
	        schemas.push(this.schema);
	        var result = validator.validateXML({ xml: xml, schema: schemas });
	        return (result && result.errors && result.errors.map(function (error) {
	            return new Error(error);
	        })) || [];
	    };
	    XMLValidator.prototype.remoteSchemas = function (refs) {
	        return refs.map(function (ref) { return ref.patchedContent; });
	    };
	    return XMLValidator;
	}());
	exports.XMLValidator = XMLValidator;
	var XMLSchemaReference = (function () {
	    function XMLSchemaReference(originalPath, virtualIndex, patchedContent) {
	        this.originalPath = originalPath;
	        this.virtualIndex = virtualIndex;
	        this.patchedContent = patchedContent;
	    }
	    return XMLSchemaReference;
	}());
	exports.XMLSchemaReference = XMLSchemaReference;
	//# sourceMappingURL=index.js.map

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {var xmllint = {};
	var errrCount=0;
	(function() {
	    var module = undefined;
	    var process = undefined;
	    var require = undefined;

	    if(typeof window === 'undefined') {
	        var window = {};
	    }

	    xmllint.validateXML = function (options) {
	        var Module = {
	                xml: options.xml,
	                schema: options.schema
	            }
	            ;
	        

	        Module["preRun"] = (function () {
	            var i;
	            for (i = 0; i < (1 || Module["xml"].length); i++) {
	                FS.createDataFile("/", "file_" + i + ".xml", Module["intArrayFromString"](Module["xml"][i]), true, true)
	            }
	            for (i = 0; i < Module["schema"].length; i++) {
	                FS.createDataFile("/", "file_" + i + ".xsd", Module["intArrayFromString"](Module["schema"][i]), true, true)
	            }
	        });
	        Module.arguments = ["--noout"];
	        ((function () {
	            var i;
	            if ("[object Array]" !== Object.prototype.toString.call(Module["schema"])) {
	                Module["schema"] = [Module["schema"]]
	            }
	            if ("[object Array]" !== Object.prototype.toString.call(Module["xml"])) {
	                Module["xml"] = [Module["xml"]]
	            }
	            for (i = 0; i < Module["schema"].length; i++) {
	                Module.arguments.push("--schema");
	                Module.arguments.push("file_" + i + ".xsd")
	            }
	            for (i = 0; i < (1 || Module["xml"].length); i++) {
	                Module.arguments.push("file_" + i + ".xml")
	            }
	        }))();
	        Module["return"] = "";
	        Module["stdout"] = Module["stderr"] = (function (code) {
	            Module["return"] += String.fromCharCode(code)
	        });
	        var Module;
	        if (!Module)Module = (typeof Module !== "undefined" ? Module : null) || {};
	        var moduleOverrides = {};
	        for (var key in Module) {
	            if (Module.hasOwnProperty(key)) {
	                moduleOverrides[key] = Module[key]
	            }
	        }
	        
	        if (true) {
	            Module["read"] = function read(url) {
	                var xhr = new XMLHttpRequest;
	                xhr.open("GET", url, false);
	                xhr.send(null);
	                return xhr.responseText
	            };
	            if (typeof arguments != "undefined") {
	                Module["arguments"] = arguments
	            }
	            if (typeof console !== "undefined") {
	                if (!Module["print"])Module["print"] = function print(x) {
	                    console.log(x)
	                };
	                if (!Module["printErr"])Module["printErr"] = function printErr(x) {

	                        /*throw new Error("!_PERF_!")

	                    console.log(x)*/
	                    console.log("111!"+(new Error("t").stack)+"!111")

	                }
	            } else {
	                var TRY_USE_DUMP = false;
	                if (!Module["print"])Module["print"] = TRY_USE_DUMP && typeof dump !== "undefined" ? (function (x) {
	                    dump(x)
	                }) : (function (x) {
	                })
	            }
	            window["Module"] = Module;
	        } else {
	            throw"Unknown runtime environment. Where are we?"
	        }
	        function globalEval(x) {
	            eval.call(null, x)
	        }

	        if (!Module["load"] && Module["read"]) {
	            Module["load"] = function load(f) {
	                globalEval(Module["read"](f))
	            }
	        }
	        if (!Module["print"]) {
	            Module["print"] = (function () {
	            })
	        }
	        if (!Module["printErr"]) {
	            Module["printErr"] = Module["print"]
	        }
	        if (!Module["arguments"]) {
	            Module["arguments"] = []
	        }
	        if (!Module["thisProgram"]) {
	            Module["thisProgram"] = "./this.program"
	        }
	        Module.print = Module["print"];
	        Module.printErr = Module["printErr"];
	        Module["preRun"] = [];
	        Module["postRun"] = [];
	        for (var key in moduleOverrides) {
	            if (moduleOverrides.hasOwnProperty(key)) {
	                Module[key] = moduleOverrides[key]
	            }
	        }
	        var Runtime = {
	            setTempRet0: (function (value) {
	                tempRet0 = value
	            }), getTempRet0: (function () {
	                return tempRet0
	            }), stackSave: (function () {
	                return STACKTOP
	            }), stackRestore: (function (stackTop) {
	                STACKTOP = stackTop
	            }), getNativeTypeSize: (function (type) {
	                switch (type) {
	                    case"i1":
	                    case"i8":
	                        return 1;
	                    case"i16":
	                        return 2;
	                    case"i32":
	                        return 4;
	                    case"i64":
	                        return 8;
	                    case"float":
	                        return 4;
	                    case"double":
	                        return 8;
	                    default:
	                    {
	                        if (type[type.length - 1] === "*") {
	                            return Runtime.QUANTUM_SIZE
	                        } else if (type[0] === "i") {
	                            var bits = parseInt(type.substr(1));
	                            assert(bits % 8 === 0);
	                            return bits / 8
	                        } else {
	                            return 0
	                        }
	                    }
	                }
	            }), getNativeFieldSize: (function (type) {
	                return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE)
	            }), STACK_ALIGN: 16, getAlignSize: (function (type, size, vararg) {
	                if (!vararg && (type == "i64" || type == "double"))return 8;
	                if (!type)return Math.min(size, 8);
	                return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE)
	            }), dynCall: (function (sig, ptr, args) {
	                if (args && args.length) {
	                    if (!args.splice)args = Array.prototype.slice.call(args);
	                    args.splice(0, 0, ptr);
	                    return Module["dynCall_" + sig].apply(null, args)
	                } else {
	                    return Module["dynCall_" + sig].call(null, ptr)
	                }
	            }), functionPointers: [], addFunction: (function (func) {
	                for (var i = 0; i < Runtime.functionPointers.length; i++) {
	                    if (!Runtime.functionPointers[i]) {
	                        Runtime.functionPointers[i] = func;
	                        return 2 * (1 + i)
	                    }
	                }
	                throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."
	            }), removeFunction: (function (index) {
	                Runtime.functionPointers[(index - 2) / 2] = null
	            }), getAsmConst: (function (code, numArgs) {
	                if (!Runtime.asmConstCache)Runtime.asmConstCache = {};
	                var func = Runtime.asmConstCache[code];
	                if (func)return func;
	                var args = [];
	                for (var i = 0; i < numArgs; i++) {
	                    args.push(String.fromCharCode(36) + i)
	                }
	                var source = Pointer_stringify(code);
	                if (source[0] === '"') {
	                    if (source.indexOf('"', 1) === source.length - 1) {
	                        source = source.substr(1, source.length - 2)
	                    } else {
	                        abort("invalid EM_ASM input |" + source + "|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)")
	                    }
	                }
	                try {
	                    var evalled = eval("(function(Module, FS) { return function(" + args.join(",") + "){ " + source + " } })")(Module, typeof FS !== "undefined" ? FS : null)
	                } catch (e) {
	                    Module.printErr("error in executing inline EM_ASM code: " + e + " on: \n\n" + source + "\n\nwith args |" + args + "| (make sure to use the right one out of EM_ASM, EM_ASM_ARGS, etc.)");
	                    throw e
	                }
	                return Runtime.asmConstCache[code] = evalled
	            }), warnOnce: (function (text) {
	                if (!Runtime.warnOnce.shown)Runtime.warnOnce.shown = {};
	                if (!Runtime.warnOnce.shown[text]) {
	                    Runtime.warnOnce.shown[text] = 1;
	                    Module.printErr(text)
	                }
	            }), funcWrappers: {}, getFuncWrapper: (function (func, sig) {
	                assert(sig);
	                if (!Runtime.funcWrappers[sig]) {
	                    Runtime.funcWrappers[sig] = {}
	                }
	                var sigCache = Runtime.funcWrappers[sig];
	                if (!sigCache[func]) {
	                    sigCache[func] = function dynCall_wrapper() {
	                        return Runtime.dynCall(sig, func, arguments)
	                    }
	                }
	                return sigCache[func]
	            }), UTF8Processor: (function () {
	                var buffer = [];
	                var needed = 0;
	                this.processCChar = (function (code) {
	                    code = code & 255;
	                    if (buffer.length == 0) {
	                        if ((code & 128) == 0) {
	                            return String.fromCharCode(code)
	                        }
	                        buffer.push(code);
	                        if ((code & 224) == 192) {
	                            needed = 1
	                        } else if ((code & 240) == 224) {
	                            needed = 2
	                        } else {
	                            needed = 3
	                        }
	                        return ""
	                    }
	                    if (needed) {
	                        buffer.push(code);
	                        needed--;
	                        if (needed > 0)return ""
	                    }
	                    var c1 = buffer[0];
	                    var c2 = buffer[1];
	                    var c3 = buffer[2];
	                    var c4 = buffer[3];
	                    var ret;
	                    if (buffer.length == 2) {
	                        ret = String.fromCharCode((c1 & 31) << 6 | c2 & 63)
	                    } else if (buffer.length == 3) {
	                        ret = String.fromCharCode((c1 & 15) << 12 | (c2 & 63) << 6 | c3 & 63)
	                    } else {
	                        var codePoint = (c1 & 7) << 18 | (c2 & 63) << 12 | (c3 & 63) << 6 | c4 & 63;
	                        ret = String.fromCharCode(((codePoint - 65536) / 1024 | 0) + 55296, (codePoint - 65536) % 1024 + 56320)
	                    }
	                    buffer.length = 0;
	                    return ret
	                });
	                this.processJSString = function processJSString(string) {
	                    string = unescape(encodeURIComponent(string));
	                    var ret = [];
	                    for (var i = 0; i < string.length; i++) {
	                        ret.push(string.charCodeAt(i))
	                    }
	                    return ret
	                }
	            }), getCompilerSetting: (function (name) {
	                throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"
	            }), stackAlloc: (function (size) {
	                var ret = STACKTOP;
	                STACKTOP = STACKTOP + size | 0;
	                STACKTOP = STACKTOP + 15 & -16;
	                return ret
	            }), staticAlloc: (function (size) {
	                var ret = STATICTOP;
	                STATICTOP = STATICTOP + size | 0;
	                STATICTOP = STATICTOP + 15 & -16;
	                return ret
	            }), dynamicAlloc: (function (size) {
	                var ret = DYNAMICTOP;
	                DYNAMICTOP = DYNAMICTOP + size | 0;
	                DYNAMICTOP = DYNAMICTOP + 15 & -16;
	                if (DYNAMICTOP >= TOTAL_MEMORY)enlargeMemory();
	                return ret
	            }), alignMemory: (function (size, quantum) {
	                var ret = size = Math.ceil(size / (quantum ? quantum : 16)) * (quantum ? quantum : 16);
	                return ret
	            }), makeBigInt: (function (low, high, unsigned) {
	                var ret = unsigned ? +(low >>> 0) + +(high >>> 0) * +4294967296 : +(low >>> 0) + +(high | 0) * +4294967296;
	                return ret
	            }), GLOBAL_BASE: 8, QUANTUM_SIZE: 4, __dummy__: 0
	        };
	        Module["Runtime"] = Runtime;
	        var __THREW__ = 0;
	        var ABORT = false;
	        var EXITSTATUS = 0;
	        var undef = 0;
	        var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
	        var tempI64, tempI64b;
	        var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

	        function assert(condition, text) {
	            if (!condition) {
	                abort("Assertion failed: " + text)
	            }
	        }

	        var globalScope = this;

	        function getCFunc(ident) {
	            var func = Module["_" + ident];
	            if (!func) {
	                try {
	                    func = eval("_" + ident)
	                } catch (e) {
	                }
	            }
	            assert(func, "Cannot call unknown function " + ident + " (perhaps LLVM optimizations or closure removed it?)");
	            return func
	        }

	        var cwrap, ccall;
	        ((function () {
	            var JSfuncs = {
	                "stackSave": (function () {
	                    Runtime.stackSave()
	                }), "stackRestore": (function () {
	                    Runtime.stackRestore()
	                }), "arrayToC": (function (arr) {
	                    var ret = Runtime.stackAlloc(arr.length);
	                    writeArrayToMemory(arr, ret);
	                    return ret
	                }), "stringToC": (function (str) {
	                    var ret = 0;
	                    if (str !== null && str !== undefined && str !== 0) {
	                        ret = Runtime.stackAlloc((str.length << 2) + 1);
	                        writeStringToMemory(str, ret)
	                    }
	                    return ret
	                })
	            };
	            var toC = {"string": JSfuncs["stringToC"], "array": JSfuncs["arrayToC"]};
	            ccall = function ccallFunc(ident, returnType, argTypes, args) {
	                var func = getCFunc(ident);
	                var cArgs = [];
	                var stack = 0;
	                if (args) {
	                    for (var i = 0; i < args.length; i++) {
	                        var converter = toC[argTypes[i]];
	                        if (converter) {
	                            if (stack === 0)stack = Runtime.stackSave();
	                            cArgs[i] = converter(args[i])
	                        } else {
	                            cArgs[i] = args[i]
	                        }
	                    }
	                }
	                var ret = func.apply(null, cArgs);
	                if (returnType === "string")ret = Pointer_stringify(ret);
	                if (stack !== 0)Runtime.stackRestore(stack);
	                return ret
	            };
	            var sourceRegex = /^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;

	            function parseJSFunc(jsfunc) {
	                var parsed = jsfunc.toString().match(sourceRegex).slice(1);
	                return {arguments: parsed[0], body: parsed[1], returnValue: parsed[2]}
	            }

	            var JSsource = {};
	            for (var fun in JSfuncs) {
	                if (JSfuncs.hasOwnProperty(fun)) {
	                    JSsource[fun] = parseJSFunc(JSfuncs[fun])
	                }
	            }
	            cwrap = function cwrap(ident, returnType, argTypes) {
	                argTypes = argTypes || [];
	                var cfunc = getCFunc(ident);
	                var numericArgs = argTypes.every((function (type) {
	                    return type === "number"
	                }));
	                var numericRet = returnType !== "string";
	                if (numericRet && numericArgs) {
	                    return cfunc
	                }
	                var argNames = argTypes.map((function (x, i) {
	                    return "$" + i
	                }));
	                var funcstr = "(function(" + argNames.join(",") + ") {";
	                var nargs = argTypes.length;
	                if (!numericArgs) {
	                    funcstr += "var stack = " + JSsource["stackSave"].body + ";";
	                    for (var i = 0; i < nargs; i++) {
	                        var arg = argNames[i], type = argTypes[i];
	                        if (type === "number")continue;
	                        var convertCode = JSsource[type + "ToC"];
	                        funcstr += "var " + convertCode.arguments + " = " + arg + ";";
	                        funcstr += convertCode.body + ";";
	                        funcstr += arg + "=" + convertCode.returnValue + ";"
	                    }
	                }
	                var cfuncname = parseJSFunc((function () {
	                    return cfunc
	                })).returnValue;
	                funcstr += "var ret = " + cfuncname + "(" + argNames.join(",") + ");";
	                if (!numericRet) {
	                    var strgfy = parseJSFunc((function () {
	                        return Pointer_stringify
	                    })).returnValue;
	                    funcstr += "ret = " + strgfy + "(ret);"
	                }
	                if (!numericArgs) {
	                    funcstr += JSsource["stackRestore"].body.replace("()", "(stack)") + ";"
	                }
	                funcstr += "return ret})";
	                return eval(funcstr)
	            }
	        }))();
	        Module["cwrap"] = cwrap;
	        Module["ccall"] = ccall;
	        function setValue(ptr, value, type, noSafe) {
	            type = type || "i8";
	            if (type.charAt(type.length - 1) === "*")type = "i32";
	            switch (type) {
	                case"i1":
	                    HEAP8[ptr >> 0] = value;
	                    break;
	                case"i8":
	                    HEAP8[ptr >> 0] = value;
	                    break;
	                case"i16":
	                    HEAP16[ptr >> 1] = value;
	                    break;
	                case"i32":
	                    HEAP32[ptr >> 2] = value;
	                    break;
	                case"i64":
	                    tempI64 = [value >>> 0, (tempDouble = value, +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0)], HEAP32[ptr >> 2] = tempI64[0], HEAP32[ptr + 4 >> 2] = tempI64[1];
	                    break;
	                case"float":
	                    HEAPF32[ptr >> 2] = value;
	                    break;
	                case"double":
	                    HEAPF64[ptr >> 3] = value;
	                    break;
	                default:
	                    abort("invalid type for setValue: " + type)
	            }
	        }

	        Module["setValue"] = setValue;
	        function getValue(ptr, type, noSafe) {
	            type = type || "i8";
	            if (type.charAt(type.length - 1) === "*")type = "i32";
	            switch (type) {
	                case"i1":
	                    return HEAP8[ptr >> 0];
	                case"i8":
	                    return HEAP8[ptr >> 0];
	                case"i16":
	                    return HEAP16[ptr >> 1];
	                case"i32":
	                    return HEAP32[ptr >> 2];
	                case"i64":
	                    return HEAP32[ptr >> 2];
	                case"float":
	                    return HEAPF32[ptr >> 2];
	                case"double":
	                    return HEAPF64[ptr >> 3];
	                default:
	                    abort("invalid type for setValue: " + type)
	            }
	            return null
	        }

	        Module["getValue"] = getValue;
	        var ALLOC_NORMAL = 0;
	        var ALLOC_STACK = 1;
	        var ALLOC_STATIC = 2;
	        var ALLOC_DYNAMIC = 3;
	        var ALLOC_NONE = 4;
	        Module["ALLOC_NORMAL"] = ALLOC_NORMAL;
	        Module["ALLOC_STACK"] = ALLOC_STACK;
	        Module["ALLOC_STATIC"] = ALLOC_STATIC;
	        Module["ALLOC_DYNAMIC"] = ALLOC_DYNAMIC;
	        Module["ALLOC_NONE"] = ALLOC_NONE;
	        function allocate(slab, types, allocator, ptr) {
	            var zeroinit, size;
	            if (typeof slab === "number") {
	                zeroinit = true;
	                size = slab
	            } else {
	                zeroinit = false;
	                size = slab.length
	            }
	            var singleType = typeof types === "string" ? types : null;
	            var ret;
	            if (allocator == ALLOC_NONE) {
	                ret = ptr
	            } else {
	                ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length))
	            }
	            if (zeroinit) {
	                var ptr = ret, stop;
	                assert((ret & 3) == 0);
	                stop = ret + (size & ~3);
	                for (; ptr < stop; ptr += 4) {
	                    HEAP32[ptr >> 2] = 0
	                }
	                stop = ret + size;
	                while (ptr < stop) {
	                    HEAP8[ptr++ >> 0] = 0
	                }
	                return ret
	            }
	            if (singleType === "i8") {
	                if (slab.subarray || slab.slice) {
	                    HEAPU8.set(slab, ret)
	                } else {
	                    HEAPU8.set(new Uint8Array(slab), ret)
	                }
	                return ret
	            }
	            var i = 0, type, typeSize, previousType;
	            while (i < size) {
	                var curr = slab[i];
	                if (typeof curr === "function") {
	                    curr = Runtime.getFunctionIndex(curr)
	                }
	                type = singleType || types[i];
	                if (type === 0) {
	                    i++;
	                    continue
	                }
	                if (type == "i64")type = "i32";
	                setValue(ret + i, curr, type);
	                if (previousType !== type) {
	                    typeSize = Runtime.getNativeTypeSize(type);
	                    previousType = type
	                }
	                i += typeSize
	            }
	            return ret
	        }

	        Module["allocate"] = allocate;
	        function Pointer_stringify(ptr, length) {
	            if (length === 0 || !ptr)return "";
	            var hasUtf = false;
	            var t;
	            var i = 0;
	            while (1) {
	                t = HEAPU8[ptr + i >> 0];
	                if (t >= 128)hasUtf = true; else if (t == 0 && !length)break;
	                i++;
	                if (length && i == length)break
	            }
	            if (!length)length = i;
	            var ret = "";
	            if (!hasUtf) {
	                var MAX_CHUNK = 1024;
	                var curr;
	                while (length > 0) {
	                    curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
	                    ret = ret ? ret + curr : curr;
	                    ptr += MAX_CHUNK;
	                    length -= MAX_CHUNK
	                }
	                return ret
	            }
	            var utf8 = new Runtime.UTF8Processor;
	            for (i = 0; i < length; i++) {
	                t = HEAPU8[ptr + i >> 0];
	                ret += utf8.processCChar(t)
	            }
	            return ret
	        }

	        Module["Pointer_stringify"] = Pointer_stringify;
	        function UTF16ToString(ptr) {
	            var i = 0;
	            var str = "";
	            while (1) {
	                var codeUnit = HEAP16[ptr + i * 2 >> 1];
	                if (codeUnit == 0)return str;
	                ++i;
	                str += String.fromCharCode(codeUnit)
	            }
	        }

	        Module["UTF16ToString"] = UTF16ToString;
	        function stringToUTF16(str, outPtr) {
	            for (var i = 0; i < str.length; ++i) {
	                var codeUnit = str.charCodeAt(i);
	                HEAP16[outPtr + i * 2 >> 1] = codeUnit
	            }
	            HEAP16[outPtr + str.length * 2 >> 1] = 0
	        }

	        Module["stringToUTF16"] = stringToUTF16;
	        function UTF32ToString(ptr) {
	            var i = 0;
	            var str = "";
	            while (1) {
	                var utf32 = HEAP32[ptr + i * 4 >> 2];
	                if (utf32 == 0)return str;
	                ++i;
	                if (utf32 >= 65536) {
	                    var ch = utf32 - 65536;
	                    str += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023)
	                } else {
	                    str += String.fromCharCode(utf32)
	                }
	            }
	        }

	        Module["UTF32ToString"] = UTF32ToString;
	        function stringToUTF32(str, outPtr) {
	            var iChar = 0;
	            for (var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
	                var codeUnit = str.charCodeAt(iCodeUnit);
	                if (codeUnit >= 55296 && codeUnit <= 57343) {
	                    var trailSurrogate = str.charCodeAt(++iCodeUnit);
	                    codeUnit = 65536 + ((codeUnit & 1023) << 10) | trailSurrogate & 1023
	                }
	                HEAP32[outPtr + iChar * 4 >> 2] = codeUnit;
	                ++iChar
	            }
	            HEAP32[outPtr + iChar * 4 >> 2] = 0
	        }

	        Module["stringToUTF32"] = stringToUTF32;
	        function demangle(func) {
	            var hasLibcxxabi = !!Module["___cxa_demangle"];
	            if (hasLibcxxabi) {
	                try {
	                    var buf = _malloc(func.length);
	                    writeStringToMemory(func.substr(1), buf);
	                    var status = _malloc(4);
	                    var ret = Module["___cxa_demangle"](buf, 0, 0, status);
	                    if (getValue(status, "i32") === 0 && ret) {
	                        return Pointer_stringify(ret)
	                    }
	                } catch (e) {
	                } finally {
	                    if (buf)_free(buf);
	                    if (status)_free(status);
	                    if (ret)_free(ret)
	                }
	            }
	            var i = 3;
	            var basicTypes = {
	                "v": "void",
	                "b": "bool",
	                "c": "char",
	                "s": "short",
	                "i": "int",
	                "l": "long",
	                "f": "float",
	                "d": "double",
	                "w": "wchar_t",
	                "a": "signed char",
	                "h": "unsigned char",
	                "t": "unsigned short",
	                "j": "unsigned int",
	                "m": "unsigned long",
	                "x": "long long",
	                "y": "unsigned long long",
	                "z": "..."
	            };
	            var subs = [];
	            var first = true;

	            function dump(x) {
	                if (x)Module.print(x);
	                Module.print(func);
	                var pre = "";
	                for (var a = 0; a < i; a++)pre += " ";
	                Module.print(pre + "^")
	            }

	            function parseNested() {
	                i++;
	                if (func[i] === "K")i++;
	                var parts = [];
	                while (func[i] !== "E") {
	                    if (func[i] === "S") {
	                        i++;
	                        var next = func.indexOf("_", i);
	                        var num = func.substring(i, next) || 0;
	                        parts.push(subs[num] || "?");
	                        i = next + 1;
	                        continue
	                    }
	                    if (func[i] === "C") {
	                        parts.push(parts[parts.length - 1]);
	                        i += 2;
	                        continue
	                    }
	                    var size = parseInt(func.substr(i));
	                    var pre = size.toString().length;
	                    if (!size || !pre) {
	                        i--;
	                        break
	                    }
	                    var curr = func.substr(i + pre, size);
	                    parts.push(curr);
	                    subs.push(curr);
	                    i += pre + size
	                }
	                i++;
	                return parts
	            }

	            function parse(rawList, limit, allowVoid) {
	                limit = limit || Infinity;
	                var ret = "", list = [];

	                function flushList() {
	                    return "(" + list.join(", ") + ")"
	                }

	                var name;
	                if (func[i] === "N") {
	                    name = parseNested().join("::");
	                    limit--;
	                    if (limit === 0)return rawList ? [name] : name
	                } else {
	                    if (func[i] === "K" || first && func[i] === "L")i++;
	                    var size = parseInt(func.substr(i));
	                    if (size) {
	                        var pre = size.toString().length;
	                        name = func.substr(i + pre, size);
	                        i += pre + size
	                    }
	                }
	                first = false;
	                if (func[i] === "I") {
	                    i++;
	                    var iList = parse(true);
	                    var iRet = parse(true, 1, true);
	                    ret += iRet[0] + " " + name + "<" + iList.join(", ") + ">"
	                } else {
	                    ret = name
	                }
	                paramLoop:while (i < func.length && limit-- > 0) {
	                    var c = func[i++];
	                    if (c in basicTypes) {
	                        list.push(basicTypes[c])
	                    } else {
	                        switch (c) {
	                            case"P":
	                                list.push(parse(true, 1, true)[0] + "*");
	                                break;
	                            case"R":
	                                list.push(parse(true, 1, true)[0] + "&");
	                                break;
	                            case"L":
	                            {
	                                i++;
	                                var end = func.indexOf("E", i);
	                                var size = end - i;
	                                list.push(func.substr(i, size));
	                                i += size + 2;
	                                break
	                            }
	                                ;
	                            case"A":
	                            {
	                                var size = parseInt(func.substr(i));
	                                i += size.toString().length;
	                                if (func[i] !== "_")throw"?";
	                                i++;
	                                list.push(parse(true, 1, true)[0] + " [" + size + "]");
	                                break
	                            }
	                                ;
	                            case"E":
	                                break paramLoop;
	                            default:
	                                ret += "?" + c;
	                                break paramLoop
	                        }
	                    }
	                }
	                if (!allowVoid && list.length === 1 && list[0] === "void")list = [];
	                if (rawList) {
	                    if (ret) {
	                        list.push(ret + "?")
	                    }
	                    return list
	                } else {
	                    return ret + flushList()
	                }
	            }

	            var parsed = func;
	            try {
	                if (func == "Object._main" || func == "_main") {
	                    return "main()"
	                }
	                if (typeof func === "number")func = Pointer_stringify(func);
	                if (func[0] !== "_")return func;
	                if (func[1] !== "_")return func;
	                if (func[2] !== "Z")return func;
	                switch (func[3]) {
	                    case"n":
	                        return "operator new()";
	                    case"d":
	                        return "operator delete()"
	                }
	                parsed = parse()
	            } catch (e) {
	                parsed += "?"
	            }
	            if (parsed.indexOf("?") >= 0 && !hasLibcxxabi) {
	                Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling")
	            }
	            return parsed
	        }

	        function demangleAll(text) {
	            return text.replace(/__Z[\w\d_]+/g, (function (x) {
	                var y = demangle(x);
	                return x === y ? x : x + " [" + y + "]"
	            }))
	        }

	        function jsStackTrace() {
	            var err = new Error;
	            if (!err.stack) {
	                try {
	                    throw new Error(0)
	                } catch (e) {
	                    err = e
	                }
	                if (!err.stack) {
	                    return "(no stack trace available)"
	                }
	            }
	            return err.stack.toString()
	        }

	        function stackTrace() {
	            return demangleAll(jsStackTrace())
	        }

	        Module["stackTrace"] = stackTrace;
	        var PAGE_SIZE = 4096;

	        function alignMemoryPage(x) {
	            return x + 4095 & -4096
	        }

	        var HEAP;
	        var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
	        var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false;
	        var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0;
	        var DYNAMIC_BASE = 0, DYNAMICTOP = 0;

	        function enlargeMemory() {
	            abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value " + TOTAL_MEMORY + ", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.")
	        }

	        var TOTAL_STACK = Module["TOTAL_STACK"] || 5242880;
	        var TOTAL_MEMORY = Module["TOTAL_MEMORY"] || 16777216;
	        var FAST_MEMORY = Module["FAST_MEMORY"] || 2097152;
	        var totalMemory = 64 * 1024;
	        while (totalMemory < TOTAL_MEMORY || totalMemory < 2 * TOTAL_STACK) {
	            if (totalMemory < 16 * 1024 * 1024) {
	                totalMemory *= 2
	            } else {
	                totalMemory += 16 * 1024 * 1024
	            }
	        }
	        if (totalMemory !== TOTAL_MEMORY) {
	            Module.printErr("increasing TOTAL_MEMORY to " + totalMemory + " to be compliant with the asm.js spec");
	            TOTAL_MEMORY = totalMemory
	        }
	        assert(typeof Int32Array !== "undefined" && typeof Float64Array !== "undefined" && !!(new Int32Array(1))["subarray"] && !!(new Int32Array(1))["set"], "JS engine does not provide full typed array support");
	        var buffer = new ArrayBuffer(TOTAL_MEMORY);
	        HEAP8 = new Int8Array(buffer);
	        HEAP16 = new Int16Array(buffer);
	        HEAP32 = new Int32Array(buffer);
	        HEAPU8 = new Uint8Array(buffer);
	        HEAPU16 = new Uint16Array(buffer);
	        HEAPU32 = new Uint32Array(buffer);
	        HEAPF32 = new Float32Array(buffer);
	        HEAPF64 = new Float64Array(buffer);
	        HEAP32[0] = 255;
	        assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, "Typed arrays 2 must be run on a little-endian system");
	        Module["HEAP"] = HEAP;
	        Module["buffer"] = buffer;
	        Module["HEAP8"] = HEAP8;
	        Module["HEAP16"] = HEAP16;
	        Module["HEAP32"] = HEAP32;
	        Module["HEAPU8"] = HEAPU8;
	        Module["HEAPU16"] = HEAPU16;
	        Module["HEAPU32"] = HEAPU32;
	        Module["HEAPF32"] = HEAPF32;
	        Module["HEAPF64"] = HEAPF64;
	        function callRuntimeCallbacks(callbacks) {
	            while (callbacks.length > 0) {
	                var callback = callbacks.shift();
	                if (typeof callback == "function") {
	                    callback();
	                    continue
	                }
	                var func = callback.func;
	                if (typeof func === "number") {
	                    if (callback.arg === undefined) {
	                        Runtime.dynCall("v", func)
	                    } else {
	                        Runtime.dynCall("vi", func, [callback.arg])
	                    }
	                } else {
	                    func(callback.arg === undefined ? null : callback.arg)
	                }
	            }
	        }

	        var __ATPRERUN__ = [];
	        var __ATINIT__ = [];
	        var __ATMAIN__ = [];
	        var __ATEXIT__ = [];
	        var __ATPOSTRUN__ = [];
	        var runtimeInitialized = false;
	        var runtimeExited = false;

	        function preRun() {
	            if (Module["preRun"]) {
	                if (typeof Module["preRun"] == "function")Module["preRun"] = [Module["preRun"]];
	                while (Module["preRun"].length) {
	                    addOnPreRun(Module["preRun"].shift())
	                }
	            }
	            callRuntimeCallbacks(__ATPRERUN__)
	        }

	        function ensureInitRuntime() {
	            if (runtimeInitialized)return;
	            runtimeInitialized = true;
	            callRuntimeCallbacks(__ATINIT__)
	        }

	        function preMain() {
	            callRuntimeCallbacks(__ATMAIN__)
	        }

	        function exitRuntime() {
	            callRuntimeCallbacks(__ATEXIT__);
	            runtimeExited = true
	        }

	        function postRun() {
	            if (Module["postRun"]) {
	                if (typeof Module["postRun"] == "function")Module["postRun"] = [Module["postRun"]];
	                while (Module["postRun"].length) {
	                    addOnPostRun(Module["postRun"].shift())
	                }
	            }
	            callRuntimeCallbacks(__ATPOSTRUN__)
	        }

	        function addOnPreRun(cb) {
	            __ATPRERUN__.unshift(cb)
	        }

	        Module["addOnPreRun"] = Module.addOnPreRun = addOnPreRun;
	        function addOnInit(cb) {
	            __ATINIT__.unshift(cb)
	        }

	        Module["addOnInit"] = Module.addOnInit = addOnInit;
	        function addOnPreMain(cb) {
	            __ATMAIN__.unshift(cb)
	        }

	        Module["addOnPreMain"] = Module.addOnPreMain = addOnPreMain;
	        function addOnExit(cb) {
	            __ATEXIT__.unshift(cb)
	        }

	        Module["addOnExit"] = Module.addOnExit = addOnExit;
	        function addOnPostRun(cb) {
	            __ATPOSTRUN__.unshift(cb)
	        }

	        Module["addOnPostRun"] = Module.addOnPostRun = addOnPostRun;
	        function intArrayFromString(stringy, dontAddNull, length) {
	            var ret = (new Runtime.UTF8Processor).processJSString(stringy);
	            if (length) {
	                ret.length = length
	            }
	            if (!dontAddNull) {
	                ret.push(0)
	            }
	            return ret
	        }

	        Module["intArrayFromString"] = intArrayFromString;
	        function intArrayToString(array) {
	            var ret = [];
	            for (var i = 0; i < array.length; i++) {
	                var chr = array[i];
	                if (chr > 255) {
	                    chr &= 255
	                }
	                ret.push(String.fromCharCode(chr))
	            }
	            return ret.join("")
	        }

	        Module["intArrayToString"] = intArrayToString;
	        function writeStringToMemory(string, buffer, dontAddNull) {
	            var array = intArrayFromString(string, dontAddNull);
	            var i = 0;
	            while (i < array.length) {
	                var chr = array[i];
	                HEAP8[buffer + i >> 0] = chr;
	                i = i + 1
	            }
	        }

	        Module["writeStringToMemory"] = writeStringToMemory;
	        function writeArrayToMemory(array, buffer) {
	            for (var i = 0; i < array.length; i++) {
	                HEAP8[buffer + i >> 0] = array[i]
	            }
	        }

	        Module["writeArrayToMemory"] = writeArrayToMemory;
	        function writeAsciiToMemory(str, buffer, dontAddNull) {
	            for (var i = 0; i < str.length; i++) {
	                HEAP8[buffer + i >> 0] = str.charCodeAt(i)
	            }
	            if (!dontAddNull)HEAP8[buffer + str.length >> 0] = 0
	        }

	        Module["writeAsciiToMemory"] = writeAsciiToMemory;
	        function unSign(value, bits, ignore) {
	            if (value >= 0) {
	                return value
	            }
	            return bits <= 32 ? 2 * Math.abs(1 << bits - 1) + value : Math.pow(2, bits) + value
	        }

	        function reSign(value, bits, ignore) {
	            if (value <= 0) {
	                return value
	            }
	            var half = bits <= 32 ? Math.abs(1 << bits - 1) : Math.pow(2, bits - 1);
	            if (value >= half && (bits <= 32 || value > half)) {
	                value = -2 * half + value
	            }
	            return value
	        }

	        if (!Math["imul"] || Math["imul"](4294967295, 5) !== -5)Math["imul"] = function imul(a, b) {
	            var ah = a >>> 16;
	            var al = a & 65535;
	            var bh = b >>> 16;
	            var bl = b & 65535;
	            return al * bl + (ah * bl + al * bh << 16) | 0
	        };
	        Math.imul = Math["imul"];
	        var Math_abs = Math.abs;
	        var Math_cos = Math.cos;
	        var Math_sin = Math.sin;
	        var Math_tan = Math.tan;
	        var Math_acos = Math.acos;
	        var Math_asin = Math.asin;
	        var Math_atan = Math.atan;
	        var Math_atan2 = Math.atan2;
	        var Math_exp = Math.exp;
	        var Math_log = Math.log;
	        var Math_sqrt = Math.sqrt;
	        var Math_ceil = Math.ceil;
	        var Math_floor = Math.floor;
	        var Math_pow = Math.pow;
	        var Math_imul = Math.imul;
	        var Math_fround = Math.fround;
	        var Math_min = Math.min;
	        var runDependencies = 0;
	        var runDependencyWatcher = null;
	        var dependenciesFulfilled = null;

	        function addRunDependency(id) {
	            runDependencies++;
	            if (Module["monitorRunDependencies"]) {
	                Module["monitorRunDependencies"](runDependencies)
	            }
	        }

	        Module["addRunDependency"] = addRunDependency;
	        function removeRunDependency(id) {
	            runDependencies--;
	            if (Module["monitorRunDependencies"]) {
	                Module["monitorRunDependencies"](runDependencies)
	            }
	            if (runDependencies == 0) {
	                if (runDependencyWatcher !== null) {
	                    clearInterval(runDependencyWatcher);
	                    runDependencyWatcher = null
	                }
	                if (dependenciesFulfilled) {
	                    var callback = dependenciesFulfilled;
	                    dependenciesFulfilled = null;
	                    callback()
	                }
	            }
	        }

	        Module["removeRunDependency"] = removeRunDependency;
	        Module["preloadedImages"] = {};
	        Module["preloadedAudios"] = {};
	        var memoryInitializer = null;
	        STATIC_BASE = 8;
	        STATICTOP = STATIC_BASE + 329776;
	        __ATINIT__.push();
	        allocate([1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 19, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 22, 0, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 25, 0, 0, 0, 26, 0, 0, 0, 27, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 100, 101, 98, 117, 103, 0, 0, 45, 45, 100, 101, 98, 117, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 115, 104, 101, 108, 108, 0, 0, 45, 45, 115, 104, 101, 108, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 99, 111, 112, 121, 0, 0, 0, 45, 45, 99, 111, 112, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 114, 101, 99, 111, 118, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 114, 101, 99, 111, 118, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 45, 104, 117, 103, 101, 0, 0, 0, 45, 45, 104, 117, 103, 101, 0, 0, 45, 110, 111, 101, 110, 116, 0, 0, 45, 45, 110, 111, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 101, 110, 99, 0, 0, 45, 45, 110, 111, 101, 110, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 115, 99, 108, 101, 97, 110, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 110, 115, 99, 108, 101, 97, 110, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 99, 100, 97, 116, 97, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 110, 111, 99, 100, 97, 116, 97, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 100, 105, 99, 116, 0, 45, 45, 110, 111, 100, 105, 99, 116, 0, 0, 0, 0, 0, 0, 0, 0, 45, 118, 101, 114, 115, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 118, 101, 114, 115, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 111, 117, 116, 0, 0, 45, 45, 110, 111, 111, 117, 116, 0, 45, 111, 0, 0, 0, 0, 0, 0, 45, 111, 117, 116, 112, 117, 116, 0, 45, 45, 111, 117, 116, 112, 117, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 104, 116, 109, 108, 111, 117, 116, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 104, 116, 109, 108, 111, 117, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 119, 114, 97, 112, 0, 45, 45, 110, 111, 119, 114, 97, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 104, 116, 109, 108, 0, 0, 0, 45, 45, 104, 116, 109, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 120, 109, 108, 111, 117, 116, 0, 45, 45, 120, 109, 108, 111, 117, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 100, 101, 102, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 45, 45, 110, 111, 100, 101, 102, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 108, 111, 97, 100, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 108, 111, 97, 100, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 100, 116, 100, 97, 116, 116, 114, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 100, 116, 100, 97, 116, 116, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 118, 97, 108, 105, 100, 0, 0, 45, 45, 118, 97, 108, 105, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 112, 111, 115, 116, 118, 97, 108, 105, 100, 0, 0, 0, 0, 0, 0, 45, 45, 112, 111, 115, 116, 118, 97, 108, 105, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 100, 116, 100, 118, 97, 108, 105, 100, 0, 0, 0, 0, 0, 0, 0, 45, 45, 100, 116, 100, 118, 97, 108, 105, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 100, 116, 100, 118, 97, 108, 105, 100, 102, 112, 105, 0, 0, 0, 0, 45, 45, 100, 116, 100, 118, 97, 108, 105, 100, 102, 112, 105, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 100, 114, 111, 112, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 100, 114, 111, 112, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 105, 110, 115, 101, 114, 116, 0, 45, 45, 105, 110, 115, 101, 114, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 116, 105, 109, 105, 110, 103, 0, 45, 45, 116, 105, 109, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 97, 117, 116, 111, 0, 0, 0, 45, 45, 97, 117, 116, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 114, 101, 112, 101, 97, 116, 0, 45, 45, 114, 101, 112, 101, 97, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 112, 117, 115, 104, 0, 0, 0, 45, 45, 112, 117, 115, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 112, 117, 115, 104, 115, 109, 97, 108, 108, 0, 0, 0, 0, 0, 0, 45, 45, 112, 117, 115, 104, 115, 109, 97, 108, 108, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 45, 109, 101, 109, 111, 114, 121, 0, 45, 45, 109, 101, 109, 111, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 116, 101, 115, 116, 73, 79, 0, 45, 45, 116, 101, 115, 116, 73, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 120, 105, 110, 99, 108, 117, 100, 101, 0, 0, 0, 0, 0, 0, 0, 45, 45, 120, 105, 110, 99, 108, 117, 100, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 120, 105, 110, 99, 108, 117, 100, 101, 110, 111, 100, 101, 0, 45, 45, 110, 111, 120, 105, 110, 99, 108, 117, 100, 101, 110, 111, 100, 101, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 102, 105, 120, 117, 112, 45, 98, 97, 115, 101, 45, 117, 114, 105, 115, 0, 0, 0, 0, 0, 0, 45, 45, 110, 111, 102, 105, 120, 117, 112, 45, 98, 97, 115, 101, 45, 117, 114, 105, 115, 0, 0, 0, 0, 0, 45, 110, 111, 119, 97, 114, 110, 105, 110, 103, 0, 0, 0, 0, 0, 0, 45, 45, 110, 111, 119, 97, 114, 110, 105, 110, 103, 0, 0, 0, 0, 0, 45, 112, 101, 100, 97, 110, 116, 105, 99, 0, 0, 0, 0, 0, 0, 0, 45, 45, 112, 101, 100, 97, 110, 116, 105, 99, 0, 0, 0, 0, 0, 0, 45, 100, 101, 98, 117, 103, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 45, 45, 100, 101, 98, 117, 103, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 99, 49, 52, 110, 0, 0, 0, 45, 45, 99, 49, 52, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 99, 49, 52, 110, 49, 49, 0, 45, 45, 99, 49, 52, 110, 49, 49, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 101, 120, 99, 45, 99, 49, 52, 110, 0, 0, 0, 0, 0, 0, 0, 45, 45, 101, 120, 99, 45, 99, 49, 52, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 99, 97, 116, 97, 108, 111, 103, 115, 0, 0, 0, 0, 0, 0, 0, 45, 45, 99, 97, 116, 97, 108, 111, 103, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 99, 97, 116, 97, 108, 111, 103, 115, 0, 0, 0, 0, 0, 45, 45, 110, 111, 99, 97, 116, 97, 108, 111, 103, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 101, 110, 99, 111, 100, 101, 0, 45, 45, 101, 110, 99, 111, 100, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 56, 0, 0, 0, 68, 86, 69, 110, 99, 0, 0, 0, 45, 110, 111, 98, 108, 97, 110, 107, 115, 0, 0, 0, 0, 0, 0, 0, 45, 45, 110, 111, 98, 108, 97, 110, 107, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 109, 97, 120, 109, 101, 109, 0, 45, 45, 109, 97, 120, 109, 101, 109, 0, 0, 0, 0, 0, 0, 0, 0, 37, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 102, 111, 114, 109, 97, 116, 0, 45, 45, 102, 111, 114, 109, 97, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 112, 114, 101, 116, 116, 121, 0, 45, 45, 112, 114, 101, 116, 116, 121, 0, 0, 0, 0, 0, 0, 0, 0, 45, 115, 116, 114, 101, 97, 109, 0, 45, 45, 115, 116, 114, 101, 97, 109, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 119, 97, 108, 107, 101, 114, 0, 45, 45, 119, 97, 108, 107, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 115, 97, 120, 49, 0, 0, 0, 45, 45, 115, 97, 120, 49, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 115, 97, 120, 0, 0, 0, 0, 45, 45, 115, 97, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 99, 104, 107, 114, 101, 103, 105, 115, 116, 101, 114, 0, 0, 0, 0, 45, 45, 99, 104, 107, 114, 101, 103, 105, 115, 116, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 114, 101, 108, 97, 120, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 114, 101, 108, 97, 120, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 115, 99, 104, 101, 109, 97, 0, 45, 45, 115, 99, 104, 101, 109, 97, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 0, 0, 0, 0, 0, 45, 45, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 110, 111, 110, 101, 116, 0, 0, 45, 45, 110, 111, 110, 101, 116, 0, 45, 110, 111, 99, 111, 109, 112, 97, 99, 116, 0, 0, 0, 0, 0, 0, 45, 45, 110, 111, 99, 111, 109, 112, 97, 99, 116, 0, 0, 0, 0, 0, 45, 108, 111, 97, 100, 45, 116, 114, 97, 99, 101, 0, 0, 0, 0, 0, 45, 45, 108, 111, 97, 100, 45, 116, 114, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 112, 97, 116, 104, 0, 0, 0, 45, 45, 112, 97, 116, 104, 0, 0, 45, 112, 97, 116, 116, 101, 114, 110, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 112, 97, 116, 116, 101, 114, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 120, 112, 97, 116, 104, 0, 0, 45, 45, 120, 112, 97, 116, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 111, 108, 100, 120, 109, 108, 49, 48, 0, 0, 0, 0, 0, 0, 0, 45, 45, 111, 108, 100, 120, 109, 108, 49, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 111, 112, 116, 105, 111, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 83, 71, 77, 76, 95, 67, 65, 84, 65, 76, 79, 71, 95, 70, 73, 76, 69, 83, 0, 0, 0, 0, 0, 0, 86, 97, 114, 105, 97, 98, 108, 101, 32, 36, 83, 71, 77, 76, 95, 67, 65, 84, 65, 76, 79, 71, 95, 70, 73, 76, 69, 83, 32, 110, 111, 116, 32, 115, 101, 116, 10, 0, 0, 0, 88, 77, 76, 76, 73, 78, 84, 95, 73, 78, 68, 69, 78, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 33, 68, 79, 67, 84, 89, 80, 69, 32, 72, 84, 77, 76, 32, 80, 85, 66, 76, 73, 67, 32, 34, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 72, 84, 77, 76, 32, 52, 46, 48, 32, 84, 114, 97, 110, 115, 105, 116, 105, 111, 110, 97, 108, 47, 47, 69, 78, 34, 10, 0, 0, 9, 34, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 84, 82, 47, 82, 69, 67, 45, 104, 116, 109, 108, 52, 48, 47, 108, 111, 111, 115, 101, 46, 100, 116, 100, 34, 62, 10, 0, 0, 60, 104, 116, 109, 108, 62, 60, 104, 101, 97, 100, 62, 60, 116, 105, 116, 108, 101, 62, 37, 115, 32, 111, 117, 116, 112, 117, 116, 60, 47, 116, 105, 116, 108, 101, 62, 60, 47, 104, 101, 97, 100, 62, 10, 0, 0, 0, 0, 60, 98, 111, 100, 121, 32, 98, 103, 99, 111, 108, 111, 114, 61, 34, 35, 102, 102, 102, 102, 102, 102, 34, 62, 60, 104, 49, 32, 97, 108, 105, 103, 110, 61, 34, 99, 101, 110, 116, 101, 114, 34, 62, 37, 115, 32, 111, 117, 116, 112, 117, 116, 60, 47, 104, 49, 62, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 99, 104, 101, 109, 97, 116, 114, 111, 110, 32, 115, 99, 104, 101, 109, 97, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 111, 109, 112, 105, 108, 105, 110, 103, 32, 116, 104, 101, 32, 115, 99, 104, 101, 109, 97, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 101, 108, 97, 120, 45, 78, 71, 32, 115, 99, 104, 101, 109, 97, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 88, 83, 32, 115, 99, 104, 101, 109, 97, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 97, 116, 116, 101, 114, 110, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 101, 103, 105, 115, 116, 114, 97, 116, 105, 111, 110, 32, 99, 111, 117, 110, 116, 32, 111, 102, 102, 58, 32, 37, 100, 10, 0, 0, 0, 0, 0, 37, 100, 32, 105, 116, 101, 114, 97, 116, 105, 111, 110, 115, 0, 0, 0, 60, 47, 98, 111, 100, 121, 62, 60, 47, 104, 116, 109, 108, 62, 10, 0, 49, 46, 48, 0, 0, 0, 0, 0, 105, 110, 102, 111, 0, 0, 0, 0, 97, 98, 99, 0, 0, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 109, 109, 97, 112, 32, 102, 97, 105, 108, 117, 114, 101, 32, 102, 111, 114, 32, 102, 105, 108, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 80, 97, 114, 115, 105, 110, 103, 0, 88, 105, 110, 99, 108, 117, 100, 101, 32, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 0, 0, 0, 0, 0, 67, 111, 112, 121, 105, 110, 103, 0, 70, 114, 101, 101, 105, 110, 103, 32, 111, 114, 105, 103, 105, 110, 97, 108, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 103, 101, 116, 32, 118, 97, 108, 105, 100, 32, 108, 105, 115, 116, 32, 111, 102, 32, 101, 108, 101, 109, 101, 110, 116, 115, 10, 0, 0, 0, 78, 111, 32, 101, 108, 101, 109, 101, 110, 116, 32, 99, 97, 110, 32, 98, 101, 32, 105, 110, 115, 101, 114, 116, 101, 100, 32, 117, 110, 100, 101, 114, 32, 114, 111, 111, 116, 10, 0, 0, 37, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 116, 121, 112, 101, 115, 32, 99, 97, 110, 32, 98, 101, 32, 105, 110, 115, 101, 114, 116, 101, 100, 32, 117, 110, 100, 101, 114, 32, 114, 111, 111, 116, 58, 10, 0, 0, 0, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 98, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 111, 112, 101, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 83, 97, 118, 105, 110, 103, 0, 0, 67, 97, 110, 39, 116, 32, 119, 114, 105, 116, 101, 32, 100, 97, 116, 97, 10, 0, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 105, 122, 101, 10, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 115, 97, 118, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 115, 97, 118, 101, 32, 116, 111, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 80, 97, 114, 115, 105, 110, 103, 32, 68, 84, 68, 0, 0, 0, 0, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 112, 97, 114, 115, 101, 32, 68, 84, 68, 32, 37, 115, 10, 0, 67, 111, 117, 108, 100, 110, 39, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 68, 111, 99, 117, 109, 101, 110, 116, 32, 37, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 97, 103, 97, 105, 110, 115, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 86, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 103, 97, 105, 110, 115, 116, 32, 68, 84, 68, 0, 0, 68, 111, 99, 117, 109, 101, 110, 116, 32, 37, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 97, 116, 101, 10, 0, 0, 86, 97, 108, 105, 100, 97, 116, 105, 110, 103, 0, 0, 0, 0, 0, 0, 37, 115, 32, 118, 97, 108, 105, 100, 97, 116, 101, 115, 10, 0, 0, 0, 37, 115, 32, 102, 97, 105, 108, 115, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 10, 0, 0, 0, 37, 115, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 103, 101, 110, 101, 114, 97, 116, 101, 100, 32, 97, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 70, 114, 101, 101, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 116, 114, 101, 97, 109, 80, 117, 115, 104, 40, 41, 32, 102, 97, 105, 108, 117, 114, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 119, 97, 108, 107, 105, 110, 103, 32, 116, 104, 114, 111, 117, 103, 104, 32, 116, 104, 101, 32, 100, 111, 99, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 119, 97, 108, 107, 32, 116, 104, 114, 111, 117, 103, 104, 32, 116, 104, 101, 32, 100, 111, 99, 10, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 97, 116, 101, 32, 97, 32, 114, 101, 97, 100, 101, 114, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 45, 45, 0, 0, 0, 0, 0, 0, 37, 100, 32, 37, 100, 32, 37, 115, 32, 37, 100, 32, 37, 100, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 32, 37, 115, 10, 0, 0, 0, 0, 78, 111, 100, 101, 32, 37, 115, 32, 109, 97, 116, 99, 104, 101, 115, 32, 112, 97, 116, 116, 101, 114, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 116, 116, 101, 114, 110, 77, 97, 116, 99, 104, 32, 97, 110, 100, 32, 120, 109, 108, 83, 116, 114, 101, 97, 109, 80, 117, 115, 104, 32, 100, 105, 115, 97, 103, 114, 101, 101, 10, 0, 0, 0, 0, 0, 32, 32, 112, 97, 116, 116, 101, 114, 110, 32, 37, 115, 32, 110, 111, 100, 101, 32, 37, 115, 10, 0, 0, 0, 120, 109, 108, 83, 116, 114, 101, 97, 109, 80, 111, 112, 40, 41, 32, 102, 97, 105, 108, 117, 114, 101, 10, 0, 37, 115, 0, 0, 0, 0, 0, 0, 79, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 88, 80, 97, 116, 104, 10, 0, 0, 0, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 117, 114, 101, 10, 0, 0, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 32, 115, 101, 116, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 116, 114, 117, 101, 0, 0, 0, 0, 102, 97, 108, 115, 101, 0, 0, 0, 73, 110, 102, 105, 110, 105, 116, 121, 0, 0, 0, 0, 0, 0, 0, 0, 45, 73, 110, 102, 105, 110, 105, 116, 121, 0, 0, 0, 0, 0, 0, 0, 78, 97, 78, 0, 0, 0, 0, 0, 37, 48, 103, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 32, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 117, 110, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 100, 10, 0, 0, 88, 80, 97, 116, 104, 32, 111, 98, 106, 101, 99, 116, 32, 111, 102, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 116, 121, 112, 101, 10], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
	        allocate([60, 98, 62, 118, 97, 108, 105, 100, 105, 116, 121, 32, 119, 97, 114, 110, 105, 110, 103, 60, 47, 98, 62, 58, 32, 0, 0, 0, 0, 0, 0, 0, 60, 47, 112, 62, 10, 0, 0, 0, 60, 112, 114, 101, 62, 10, 0, 0, 37, 99, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 94, 10, 0, 0, 0, 0, 0, 0, 60, 47, 112, 114, 101, 62, 0, 0, 60, 112, 62, 0, 0, 0, 0, 0, 37, 115, 58, 37, 100, 58, 32, 0, 69, 110, 116, 105, 116, 121, 58, 32, 108, 105, 110, 101, 32, 37, 100, 58, 32, 0, 0, 0, 0, 0, 0, 0, 60, 98, 62, 118, 97, 108, 105, 100, 105, 116, 121, 32, 101, 114, 114, 111, 114, 60, 47, 98, 62, 58, 32, 0, 60, 98, 62, 119, 97, 114, 110, 105, 110, 103, 60, 47, 98, 62, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 60, 98, 62, 101, 114, 114, 111, 114, 60, 47, 98, 62, 58, 32, 0, 0, 117, 115, 101, 114, 95, 100, 97, 116, 97, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 217, 0, 0, 0, 0, 0, 0, 112, 212, 0, 0, 0, 0, 0, 0, 83, 65, 88, 32, 103, 101, 110, 101, 114, 97, 116, 101, 100, 32, 97, 32, 100, 111, 99, 32, 33, 10, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 19, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 22, 0, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 25, 0, 0, 0, 26, 0, 0, 0, 27, 0, 0, 0, 175, 190, 237, 222, 0, 0, 0, 0, 28, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 101, 110, 100, 69, 108, 101, 109, 101, 110, 116, 78, 115, 40, 37, 115, 0, 0, 0, 0, 0, 44, 32, 78, 85, 76, 76, 0, 0, 44, 32, 37, 115, 0, 0, 0, 0, 44, 32, 78, 85, 76, 76, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 44, 32, 39, 37, 115, 39, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 115, 116, 97, 114, 116, 69, 108, 101, 109, 101, 110, 116, 78, 115, 40, 37, 115, 0, 0, 0, 44, 32, 39, 37, 115, 39, 0, 0, 44, 32, 37, 100, 0, 0, 0, 0, 44, 32, 120, 109, 108, 110, 115, 0, 58, 37, 115, 0, 0, 0, 0, 0, 61, 39, 37, 115, 39, 0, 0, 0, 44, 32, 37, 100, 44, 32, 37, 100, 0, 0, 0, 0, 0, 0, 0, 0, 44, 32, 37, 115, 58, 37, 115, 61, 39, 0, 0, 0, 0, 0, 0, 0, 44, 32, 37, 115, 61, 39, 0, 0, 37, 46, 52, 115, 46, 46, 46, 39, 44, 32, 37, 100, 0, 0, 0, 0, 41, 10, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 101, 120, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 40, 37, 115, 44, 0, 0, 32, 44, 0, 0, 0, 0, 0, 0, 32, 37, 115, 44, 0, 0, 0, 0, 32, 41, 10, 0, 0, 0, 0, 0, 32, 37, 115, 41, 10, 0, 0, 0, 83, 65, 88, 46, 112, 99, 100, 97, 116, 97, 40, 37, 46, 50, 48, 115, 44, 32, 37, 100, 41, 10, 0, 0, 83, 65, 88, 46, 103, 101, 116, 80, 97, 114, 97, 109, 101, 116, 101, 114, 69, 110, 116, 105, 116, 121, 40, 37, 115, 41, 10, 0, 0, 0, 0, 0, 83, 65, 88, 46, 102, 97, 116, 97, 108, 69, 114, 114, 111, 114, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 101, 114, 114, 111, 114, 58, 32, 0, 0, 0, 0, 0, 83, 65, 88, 46, 119, 97, 114, 110, 105, 110, 103, 58, 32, 0, 0, 0, 83, 65, 88, 46, 99, 111, 109, 109, 101, 110, 116, 40, 37, 115, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 73, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 40, 37, 115, 44, 32, 37, 115, 41, 10, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 73, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 40, 37, 115, 44, 32, 78, 85, 76, 76, 41, 10, 0, 0, 0, 0, 83, 65, 88, 46, 105, 103, 110, 111, 114, 97, 98, 108, 101, 87, 104, 105, 116, 101, 115, 112, 97, 99, 101, 40, 37, 115, 44, 32, 37, 100, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 99, 104, 97, 114, 97, 99, 116, 101, 114, 115, 40, 37, 115, 44, 32, 37, 100, 41, 10, 0, 83, 65, 88, 46, 114, 101, 102, 101, 114, 101, 110, 99, 101, 40, 37, 115, 41, 10, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 101, 110, 100, 68, 111, 99, 117, 109, 101, 110, 116, 40, 41, 10, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 115, 116, 97, 114, 116, 68, 111, 99, 117, 109, 101, 110, 116, 40, 41, 10, 0, 0, 0, 0, 83, 65, 88, 46, 115, 101, 116, 68, 111, 99, 117, 109, 101, 110, 116, 76, 111, 99, 97, 116, 111, 114, 40, 41, 10, 0, 0, 0, 0, 0, 0, 0, 40, 110, 117, 108, 108, 41, 0, 0, 83, 65, 88, 46, 117, 110, 112, 97, 114, 115, 101, 100, 69, 110, 116, 105, 116, 121, 68, 101, 99, 108, 40, 37, 115, 44, 32, 37, 115, 44, 32, 37, 115, 44, 32, 37, 115, 41, 10, 0, 83, 65, 88, 46, 101, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 40, 37, 115, 44, 32, 37, 100, 44, 32, 46, 46, 46, 41, 10, 0, 0, 0, 83, 65, 88, 46, 97, 116, 116, 114, 105, 98, 117, 116, 101, 68, 101, 99, 108, 40, 37, 115, 44, 32, 37, 115, 44, 32, 37, 100, 44, 32, 37, 100, 44, 32, 78, 85, 76, 76, 44, 32, 46, 46, 46, 41, 10, 0, 0, 0, 83, 65, 88, 46, 97, 116, 116, 114, 105, 98, 117, 116, 101, 68, 101, 99, 108, 40, 37, 115, 44, 32, 37, 115, 44, 32, 37, 100, 44, 32, 37, 100, 44, 32, 37, 115, 44, 32, 46, 46, 46, 41, 10, 0, 0, 0, 0, 0, 83, 65, 88, 46, 110, 111, 116, 97, 116, 105, 111, 110, 68, 101, 99, 108, 40, 37, 115, 44, 32, 37, 115, 44, 32, 37, 115, 41, 10, 0, 0, 0, 83, 65, 88, 46, 101, 110, 116, 105, 116, 121, 68, 101, 99, 108, 40, 37, 115, 44, 32, 37, 100, 44, 32, 37, 115, 44, 32, 37, 115, 44, 32, 37, 115, 41, 10, 0, 0, 0, 0, 0, 83, 65, 88, 46, 103, 101, 116, 69, 110, 116, 105, 116, 121, 40, 37, 115, 41, 10, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 114, 101, 115, 111, 108, 118, 101, 69, 110, 116, 105, 116, 121, 40, 0, 0, 0, 0, 0, 0, 44, 32, 37, 115, 41, 10, 0, 0, 44, 32, 41, 10, 0, 0, 0, 0, 83, 65, 88, 46, 104, 97, 115, 69, 120, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 40, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 104, 97, 115, 73, 110, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 40, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 105, 115, 83, 116, 97, 110, 100, 97, 108, 111, 110, 101, 40, 41, 10, 0, 0, 0, 0, 0, 83, 65, 88, 46, 105, 110, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 40, 37, 115, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 190, 237, 222, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 83, 68, 32, 115, 99, 104, 101, 109, 97, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 80, 97, 114, 115, 105, 110, 103, 32, 97, 110, 100, 32, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 0, 0, 37, 115, 32, 58, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 10, 0, 0, 0, 85, 110, 97, 98, 108, 101, 32, 116, 111, 32, 111, 112, 101, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 116, 111, 111, 107, 32, 37, 108, 100, 32, 109, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 111, 97, 100, 101, 100, 32, 85, 82, 76, 61, 34, 37, 115, 34, 32, 73, 68, 61, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 110, 111, 100, 101, 45, 62, 95, 112, 114, 105, 118, 97, 116, 101, 32, 33, 61, 32, 78, 85, 76, 76, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 120, 109, 108, 108, 105, 110, 116, 46, 99, 0, 0, 0, 0, 100, 101, 114, 101, 103, 105, 115, 116, 101, 114, 78, 111, 100, 101, 0, 0, 42, 40, 108, 111, 110, 103, 42, 41, 110, 111, 100, 101, 45, 62, 95, 112, 114, 105, 118, 97, 116, 101, 32, 61, 61, 32, 40, 108, 111, 110, 103, 41, 32, 48, 120, 56, 49, 55, 50, 54, 51, 53, 52, 0, 0, 0, 0, 0, 79, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 32, 105, 110, 32, 120, 109, 108, 108, 105, 110, 116, 58, 114, 101, 103, 105, 115, 116, 101, 114, 78, 111, 100, 101, 40, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 77, 65, 88, 95, 80, 65, 84, 72, 83, 32, 114, 101, 97, 99, 104, 101, 100, 58, 32, 116, 111, 111, 32, 109, 97, 110, 121, 32, 112, 97, 116, 104, 115, 10, 0, 0, 0, 0, 0, 0, 82, 97, 110, 32, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 32, 110, 101, 101, 100, 115, 32, 62, 32, 37, 100, 32, 98, 121, 116, 101, 115, 10, 0, 0, 0, 0, 0, 37, 115, 58, 32, 117, 115, 105, 110, 103, 32, 108, 105, 98, 120, 109, 108, 32, 118, 101, 114, 115, 105, 111, 110, 32, 37, 115, 10, 0, 0, 0, 0, 32, 32, 32, 99, 111, 109, 112, 105, 108, 101, 100, 32, 119, 105, 116, 104, 58, 32, 0, 0, 0, 0, 0, 0, 84, 104, 114, 101, 97, 100, 115, 32, 0, 0, 0, 0, 0, 0, 0, 0, 84, 114, 101, 101, 32, 0, 0, 0, 79, 117, 116, 112, 117, 116, 32, 0, 80, 117, 115, 104, 32, 0, 0, 0, 82, 101, 97, 100, 101, 114, 32, 0, 80, 97, 116, 116, 101, 114, 110, 115, 32, 0, 0, 0, 0, 0, 0, 0, 87, 114, 105, 116, 101, 114, 32, 0, 83, 65, 88, 118, 49, 32, 0, 0, 70, 84, 80, 32, 0, 0, 0, 0, 72, 84, 84, 80, 32, 0, 0, 0, 68, 84, 68, 86, 97, 108, 105, 100, 32, 0, 0, 0, 0, 0, 0, 0, 72, 84, 77, 76, 32, 0, 0, 0, 76, 101, 103, 97, 99, 121, 32, 0, 67, 49, 52, 78, 32, 0, 0, 0, 67, 97, 116, 97, 108, 111, 103, 32, 0, 0, 0, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 32, 0, 0, 88, 80, 111, 105, 110, 116, 101, 114, 32, 0, 0, 0, 0, 0, 0, 0, 88, 73, 110, 99, 108, 117, 100, 101, 32, 0, 0, 0, 0, 0, 0, 0, 73, 99, 111, 110, 118, 32, 0, 0, 73, 83, 79, 56, 56, 53, 57, 88, 32, 0, 0, 0, 0, 0, 0, 0, 85, 110, 105, 99, 111, 100, 101, 32, 0, 0, 0, 0, 0, 0, 0, 0, 82, 101, 103, 101, 120, 112, 115, 32, 0, 0, 0, 0, 0, 0, 0, 0, 65, 117, 116, 111, 109, 97, 116, 97, 32, 0, 0, 0, 0, 0, 0, 0, 69, 120, 112, 114, 32, 0, 0, 0, 83, 99, 104, 101, 109, 97, 115, 32, 0, 0, 0, 0, 0, 0, 0, 0, 83, 99, 104, 101, 109, 97, 116, 114, 111, 110, 32, 0, 0, 0, 0, 0, 77, 111, 100, 117, 108, 101, 115, 32, 0, 0, 0, 0, 0, 0, 0, 0, 68, 101, 98, 117, 103, 32, 0, 0, 77, 101, 109, 68, 101, 98, 117, 103, 32, 0, 0, 0, 0, 0, 0, 0, 82, 117, 110, 68, 101, 98, 117, 103, 32, 0, 0, 0, 0, 0, 0, 0, 90, 108, 105, 98, 32, 0, 0, 0, 76, 122, 109, 97, 32, 0, 0, 0, 85, 115, 97, 103, 101, 32, 58, 32, 37, 115, 32, 91, 111, 112, 116, 105, 111, 110, 115, 93, 32, 88, 77, 76, 102, 105, 108, 101, 115, 32, 46, 46, 46, 10, 0, 0, 0, 0, 0, 0, 9, 80, 97, 114, 115, 101, 32, 116, 104, 101, 32, 88, 77, 76, 32, 102, 105, 108, 101, 115, 32, 97, 110, 100, 32, 111, 117, 116, 112, 117, 116, 32, 116, 104, 101, 32, 114, 101, 115, 117, 108, 116, 32, 111, 102, 32, 116, 104, 101, 32, 112, 97, 114, 115, 105, 110, 103, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 118, 101, 114, 115, 105, 111, 110, 32, 58, 32, 100, 105, 115, 112, 108, 97, 121, 32, 116, 104, 101, 32, 118, 101, 114, 115, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 88, 77, 76, 32, 108, 105, 98, 114, 97, 114, 121, 32, 117, 115, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 100, 101, 98, 117, 103, 32, 58, 32, 100, 117, 109, 112, 32, 97, 32, 100, 101, 98, 117, 103, 32, 116, 114, 101, 101, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 45, 109, 101, 109, 111, 114, 121, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 9, 45, 45, 115, 104, 101, 108, 108, 32, 58, 32, 114, 117, 110, 32, 97, 32, 110, 97, 118, 105, 103, 97, 116, 105, 110, 103, 32, 115, 104, 101, 108, 108, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 100, 101, 98, 117, 103, 101, 110, 116, 32, 58, 32, 100, 101, 98, 117, 103, 32, 116, 104, 101, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 99, 111, 112, 121, 32, 58, 32, 117, 115, 101, 100, 32, 116, 111, 32, 116, 101, 115, 116, 32, 116, 104, 101, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 99, 111, 112, 121, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 97, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 114, 101, 99, 111, 118, 101, 114, 32, 58, 32, 111, 117, 116, 112, 117, 116, 32, 119, 104, 97, 116, 32, 119, 97, 115, 32, 112, 97, 114, 115, 97, 98, 108, 101, 32, 111, 110, 32, 98, 114, 111, 107, 101, 110, 32, 88, 77, 76, 32, 100, 111, 99, 117, 109, 101, 110, 116, 115, 10, 0, 0, 9, 45, 45, 104, 117, 103, 101, 32, 58, 32, 114, 101, 109, 111, 118, 101, 32, 97, 110, 121, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 97, 114, 98, 105, 116, 114, 97, 114, 121, 32, 112, 97, 114, 115, 101, 114, 32, 108, 105, 109, 105, 116, 115, 10, 0, 0, 9, 45, 45, 110, 111, 101, 110, 116, 32, 58, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 101, 32, 101, 110, 116, 105, 116, 121, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 98, 121, 32, 116, 104, 101, 105, 114, 32, 118, 97, 108, 117, 101, 10, 0, 9, 45, 45, 110, 111, 101, 110, 99, 32, 58, 32, 105, 103, 110, 111, 114, 101, 32, 97, 110, 121, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 105, 110, 115, 105, 100, 101, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 0, 0, 9, 45, 45, 110, 111, 111, 117, 116, 32, 58, 32, 100, 111, 110, 39, 116, 32, 111, 117, 116, 112, 117, 116, 32, 116, 104, 101, 32, 114, 101, 115, 117, 108, 116, 32, 116, 114, 101, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 112, 97, 116, 104, 32, 39, 112, 97, 116, 104, 115, 39, 58, 32, 112, 114, 111, 118, 105, 100, 101, 32, 97, 32, 115, 101, 116, 32, 111, 102, 32, 112, 97, 116, 104, 115, 32, 102, 111, 114, 32, 114, 101, 115, 111, 117, 114, 99, 101, 115, 10, 0, 0, 9, 45, 45, 108, 111, 97, 100, 45, 116, 114, 97, 99, 101, 32, 58, 32, 112, 114, 105, 110, 116, 32, 116, 114, 97, 99, 101, 32, 111, 102, 32, 97, 108, 108, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 108, 111, 97, 100, 101, 100, 10, 0, 0, 0, 0, 9, 45, 45, 110, 111, 110, 101, 116, 32, 58, 32, 114, 101, 102, 117, 115, 101, 32, 116, 111, 32, 102, 101, 116, 99, 104, 32, 68, 84, 68, 115, 32, 111, 114, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 111, 118, 101, 114, 32, 110, 101, 116, 119, 111, 114, 107, 10, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 110, 111, 99, 111, 109, 112, 97, 99, 116, 32, 58, 32, 100, 111, 32, 110, 111, 116, 32, 103, 101, 110, 101, 114, 97, 116, 101, 32, 99, 111, 109, 112, 97, 99, 116, 32, 116, 101, 120, 116, 32, 110, 111, 100, 101, 115, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 104, 116, 109, 108, 111, 117, 116, 32, 58, 32, 111, 117, 116, 112, 117, 116, 32, 114, 101, 115, 117, 108, 116, 115, 32, 97, 115, 32, 72, 84, 77, 76, 10, 0, 0, 0, 0, 9, 45, 45, 110, 111, 119, 114, 97, 112, 32, 58, 32, 100, 111, 32, 110, 111, 116, 32, 112, 117, 116, 32, 72, 84, 77, 76, 32, 100, 111, 99, 32, 119, 114, 97, 112, 112, 101, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 118, 97, 108, 105, 100, 32, 58, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 105, 110, 32, 97, 100, 100, 105, 116, 105, 111, 110, 32, 116, 111, 32, 115, 116, 100, 32, 119, 101, 108, 108, 45, 102, 111, 114, 109, 101, 100, 32, 99, 104, 101, 99, 107, 10, 0, 0, 9, 45, 45, 112, 111, 115, 116, 118, 97, 108, 105, 100, 32, 58, 32, 100, 111, 32, 97, 32, 112, 111, 115, 116, 101, 114, 105, 111, 114, 105, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 44, 32, 105, 46, 101, 32, 97, 102, 116, 101, 114, 32, 112, 97, 114, 115, 105, 110, 103, 10, 0, 0, 0, 9, 45, 45, 100, 116, 100, 118, 97, 108, 105, 100, 32, 85, 82, 76, 32, 58, 32, 100, 111, 32, 97, 32, 112, 111, 115, 116, 101, 114, 105, 111, 114, 105, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 32, 103, 105, 118, 101, 110, 32, 68, 84, 68, 10, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 100, 116, 100, 118, 97, 108, 105, 100, 102, 112, 105, 32, 70, 80, 73, 32, 58, 32, 115, 97, 109, 101, 32, 98, 117, 116, 32, 110, 97, 109, 101, 32, 116, 104, 101, 32, 68, 84, 68, 32, 119, 105, 116, 104, 32, 97, 32, 80, 117, 98, 108, 105, 99, 32, 73, 100, 101, 110, 116, 105, 102, 105, 101, 114, 10, 0, 0, 0, 0, 9, 45, 45, 116, 105, 109, 105, 110, 103, 32, 58, 32, 112, 114, 105, 110, 116, 32, 115, 111, 109, 101, 32, 116, 105, 109, 105, 110, 103, 115, 10, 0, 9, 45, 45, 111, 117, 116, 112, 117, 116, 32, 102, 105, 108, 101, 32, 111, 114, 32, 45, 111, 32, 102, 105, 108, 101, 58, 32, 115, 97, 118, 101, 32, 116, 111, 32, 97, 32, 103, 105, 118, 101, 110, 32, 102, 105, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 114, 101, 112, 101, 97, 116, 32, 58, 32, 114, 101, 112, 101, 97, 116, 32, 49, 48, 48, 32, 116, 105, 109, 101, 115, 44, 32, 102, 111, 114, 32, 116, 105, 109, 105, 110, 103, 32, 111, 114, 32, 112, 114, 111, 102, 105, 108, 105, 110, 103, 10, 0, 0, 9, 45, 45, 105, 110, 115, 101, 114, 116, 32, 58, 32, 97, 100, 45, 104, 111, 99, 32, 116, 101, 115, 116, 32, 102, 111, 114, 32, 118, 97, 108, 105, 100, 32, 105, 110, 115, 101, 114, 116, 105, 111, 110, 115, 10, 0, 0, 0, 9, 45, 45, 104, 116, 109, 108, 32, 58, 32, 117, 115, 101, 32, 116, 104, 101, 32, 72, 84, 77, 76, 32, 112, 97, 114, 115, 101, 114, 10, 0, 0, 9, 45, 45, 120, 109, 108, 111, 117, 116, 32, 58, 32, 102, 111, 114, 99, 101, 32, 116, 111, 32, 117, 115, 101, 32, 116, 104, 101, 32, 88, 77, 76, 32, 115, 101, 114, 105, 97, 108, 105, 122, 101, 114, 32, 119, 104, 101, 110, 32, 117, 115, 105, 110, 103, 32, 45, 45, 104, 116, 109, 108, 10, 0, 0, 9, 45, 45, 110, 111, 100, 101, 102, 100, 116, 100, 32, 58, 32, 100, 111, 32, 110, 111, 116, 32, 100, 101, 102, 97, 117, 108, 116, 32, 72, 84, 77, 76, 32, 100, 111, 99, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 112, 117, 115, 104, 32, 58, 32, 117, 115, 101, 32, 116, 104, 101, 32, 112, 117, 115, 104, 32, 109, 111, 100, 101, 32, 111, 102, 32, 116, 104, 101, 32, 112, 97, 114, 115, 101, 114, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 112, 117, 115, 104, 115, 109, 97, 108, 108, 32, 58, 32, 117, 115, 101, 32, 116, 104, 101, 32, 112, 117, 115, 104, 32, 109, 111, 100, 101, 32, 111, 102, 32, 116, 104, 101, 32, 112, 97, 114, 115, 101, 114, 32, 117, 115, 105, 110, 103, 32, 116, 105, 110, 121, 32, 105, 110, 99, 114, 101, 109, 101, 110, 116, 115, 10, 0, 0, 0, 9, 45, 45, 109, 101, 109, 111, 114, 121, 32, 58, 32, 112, 97, 114, 115, 101, 32, 102, 114, 111, 109, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 9, 45, 45, 109, 97, 120, 109, 101, 109, 32, 110, 98, 98, 121, 116, 101, 115, 32, 58, 32, 108, 105, 109, 105, 116, 115, 32, 109, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 116, 111, 32, 110, 98, 98, 121, 116, 101, 115, 32, 98, 121, 116, 101, 115, 10, 0, 0, 9, 45, 45, 110, 111, 119, 97, 114, 110, 105, 110, 103, 32, 58, 32, 100, 111, 32, 110, 111, 116, 32, 101, 109, 105, 116, 32, 119, 97, 114, 110, 105, 110, 103, 115, 32, 102, 114, 111, 109, 32, 112, 97, 114, 115, 101, 114, 47, 118, 97, 108, 105, 100, 97, 116, 111, 114, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 110, 111, 98, 108, 97, 110, 107, 115, 32, 58, 32, 100, 114, 111, 112, 32, 40, 105, 103, 110, 111, 114, 97, 98, 108, 101, 63, 41, 32, 98, 108, 97, 110, 107, 115, 32, 115, 112, 97, 99, 101, 115, 10, 0, 0, 9, 45, 45, 110, 111, 99, 100, 97, 116, 97, 32, 58, 32, 114, 101, 112, 108, 97, 99, 101, 32, 99, 100, 97, 116, 97, 32, 115, 101, 99, 116, 105, 111, 110, 32, 119, 105, 116, 104, 32, 116, 101, 120, 116, 32, 110, 111, 100, 101, 115, 10, 0, 0, 0, 0, 0, 9, 45, 45, 102, 111, 114, 109, 97, 116, 32, 58, 32, 114, 101, 102, 111, 114, 109, 97, 116, 47, 114, 101, 105, 110, 100, 101, 110, 116, 32, 116, 104, 101, 32, 105, 110, 112, 117, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 101, 110, 99, 111, 100, 101, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 58, 32, 111, 117, 116, 112, 117, 116, 32, 105, 110, 32, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 101, 110, 99, 111, 100, 105, 110, 103, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 100, 114, 111, 112, 100, 116, 100, 32, 58, 32, 114, 101, 109, 111, 118, 101, 32, 116, 104, 101, 32, 68, 79, 67, 84, 89, 80, 69, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 112, 117, 116, 32, 100, 111, 99, 115, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 112, 114, 101, 116, 116, 121, 32, 83, 84, 89, 76, 69, 32, 58, 32, 112, 114, 101, 116, 116, 121, 45, 112, 114, 105, 110, 116, 32, 105, 110, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 115, 116, 121, 108, 101, 10, 0, 0, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 48, 32, 68, 111, 32, 110, 111, 116, 32, 112, 114, 101, 116, 116, 121, 32, 112, 114, 105, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 49, 32, 70, 111, 114, 109, 97, 116, 32, 116, 104, 101, 32, 88, 77, 76, 32, 99, 111, 110, 116, 101, 110, 116, 44, 32, 97, 115, 32, 45, 45, 102, 111, 114, 109, 97, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 50, 32, 65, 100, 100, 32, 119, 104, 105, 116, 101, 115, 112, 97, 99, 101, 32, 105, 110, 115, 105, 100, 101, 32, 116, 97, 103, 115, 44, 32, 112, 114, 101, 115, 101, 114, 118, 105, 110, 103, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 9, 45, 45, 99, 49, 52, 110, 32, 58, 32, 115, 97, 118, 101, 32, 105, 110, 32, 87, 51, 67, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 32, 102, 111, 114, 109, 97, 116, 32, 118, 49, 46, 48, 32, 40, 119, 105, 116, 104, 32, 99, 111, 109, 109, 101, 110, 116, 115, 41, 10, 0, 0, 0, 0, 9, 45, 45, 99, 49, 52, 110, 49, 49, 32, 58, 32, 115, 97, 118, 101, 32, 105, 110, 32, 87, 51, 67, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 32, 102, 111, 114, 109, 97, 116, 32, 118, 49, 46, 49, 32, 40, 119, 105, 116, 104, 32, 99, 111, 109, 109, 101, 110, 116, 115, 41, 10, 0, 0, 9, 45, 45, 101, 120, 99, 45, 99, 49, 52, 110, 32, 58, 32, 115, 97, 118, 101, 32, 105, 110, 32, 87, 51, 67, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 32, 102, 111, 114, 109, 97, 116, 32, 40, 119, 105, 116, 104, 32, 99, 111, 109, 109, 101, 110, 116, 115, 41, 10, 0, 0, 0, 9, 45, 45, 110, 115, 99, 108, 101, 97, 110, 32, 58, 32, 114, 101, 109, 111, 118, 101, 32, 114, 101, 100, 117, 110, 100, 97, 110, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 115, 10, 0, 0, 0, 9, 45, 45, 116, 101, 115, 116, 73, 79, 32, 58, 32, 116, 101, 115, 116, 32, 117, 115, 101, 114, 32, 73, 47, 79, 32, 115, 117, 112, 112, 111, 114, 116, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 99, 97, 116, 97, 108, 111, 103, 115, 32, 58, 32, 117, 115, 101, 32, 83, 71, 77, 76, 32, 99, 97, 116, 97, 108, 111, 103, 115, 32, 102, 114, 111, 109, 32, 36, 83, 71, 77, 76, 95, 67, 65, 84, 65, 76, 79, 71, 95, 70, 73, 76, 69, 83, 10, 0, 0, 0, 0, 0, 0, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 116, 104, 101, 114, 119, 105, 115, 101, 32, 88, 77, 76, 32, 67, 97, 116, 97, 108, 111, 103, 115, 32, 115, 116, 97, 114, 116, 105, 110, 103, 32, 102, 114, 111, 109, 32, 10, 0, 0, 0, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 37, 115, 32, 97, 114, 101, 32, 97, 99, 116, 105, 118, 97, 116, 101, 100, 32, 98, 121, 32, 100, 101, 102, 97, 117, 108, 116, 10, 0, 0, 102, 105, 108, 101, 58, 47, 47, 47, 101, 116, 99, 47, 120, 109, 108, 47, 99, 97, 116, 97, 108, 111, 103, 0, 9, 45, 45, 110, 111, 99, 97, 116, 97, 108, 111, 103, 115, 58, 32, 100, 101, 97, 99, 116, 105, 118, 97, 116, 101, 32, 97, 108, 108, 32, 99, 97, 116, 97, 108, 111, 103, 115, 10, 0, 9, 45, 45, 97, 117, 116, 111, 32, 58, 32, 103, 101, 110, 101, 114, 97, 116, 101, 32, 97, 32, 115, 109, 97, 108, 108, 32, 100, 111, 99, 32, 111, 110, 32, 116, 104, 101, 32, 102, 108, 121, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 120, 105, 110, 99, 108, 117, 100, 101, 32, 58, 32, 100, 111, 32, 88, 73, 110, 99, 108, 117, 100, 101, 32, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 10, 0, 0, 0, 9, 45, 45, 110, 111, 120, 105, 110, 99, 108, 117, 100, 101, 110, 111, 100, 101, 32, 58, 32, 115, 97, 109, 101, 32, 98, 117, 116, 32, 100, 111, 32, 110, 111, 116, 32, 103, 101, 110, 101, 114, 97, 116, 101, 32, 88, 73, 110, 99, 108, 117, 100, 101, 32, 110, 111, 100, 101, 115, 10, 0, 0, 0, 0, 9, 45, 45, 110, 111, 102, 105, 120, 117, 112, 45, 98, 97, 115, 101, 45, 117, 114, 105, 115, 32, 58, 32, 100, 111, 32, 110, 111, 116, 32, 102, 105, 120, 117, 112, 32, 120, 109, 108, 58, 98, 97, 115, 101, 32, 117, 114, 105, 115, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 108, 111, 97, 100, 100, 116, 100, 32, 58, 32, 102, 101, 116, 99, 104, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 68, 84, 68, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 100, 116, 100, 97, 116, 116, 114, 32, 58, 32, 108, 111, 97, 100, 100, 116, 100, 32, 43, 32, 112, 111, 112, 117, 108, 97, 116, 101, 32, 116, 104, 101, 32, 116, 114, 101, 101, 32, 119, 105, 116, 104, 32, 105, 110, 104, 101, 114, 105, 116, 101, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 10, 0, 0, 0, 0, 9, 45, 45, 115, 116, 114, 101, 97, 109, 32, 58, 32, 117, 115, 101, 32, 116, 104, 101, 32, 115, 116, 114, 101, 97, 109, 105, 110, 103, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 116, 111, 32, 112, 114, 111, 99, 101, 115, 115, 32, 118, 101, 114, 121, 32, 108, 97, 114, 103, 101, 32, 102, 105, 108, 101, 115, 10, 0, 0, 0, 0, 9, 45, 45, 119, 97, 108, 107, 101, 114, 32, 58, 32, 99, 114, 101, 97, 116, 101, 32, 97, 32, 114, 101, 97, 100, 101, 114, 32, 97, 110, 100, 32, 119, 97, 108, 107, 32, 116, 104, 111, 117, 103, 104, 32, 116, 104, 101, 32, 114, 101, 115, 117, 108, 116, 105, 110, 103, 32, 100, 111, 99, 10, 0, 0, 9, 45, 45, 112, 97, 116, 116, 101, 114, 110, 32, 112, 97, 116, 116, 101, 114, 110, 95, 118, 97, 108, 117, 101, 32, 58, 32, 116, 101, 115, 116, 32, 116, 104, 101, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 117, 112, 112, 111, 114, 116, 10, 0, 0, 0, 0, 9, 45, 45, 99, 104, 107, 114, 101, 103, 105, 115, 116, 101, 114, 32, 58, 32, 118, 101, 114, 105, 102, 121, 32, 116, 104, 101, 32, 110, 111, 100, 101, 32, 114, 101, 103, 105, 115, 116, 114, 97, 116, 105, 111, 110, 32, 99, 111, 100, 101, 10, 0, 0, 0, 0, 0, 9, 45, 45, 114, 101, 108, 97, 120, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 58, 32, 100, 111, 32, 82, 101, 108, 97, 120, 78, 71, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 97, 103, 97, 105, 110, 115, 116, 32, 116, 104, 101, 32, 115, 99, 104, 101, 109, 97, 10, 0, 0, 0, 9, 45, 45, 115, 99, 104, 101, 109, 97, 32, 115, 99, 104, 101, 109, 97, 32, 58, 32, 100, 111, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 97, 103, 97, 105, 110, 115, 116, 32, 116, 104, 101, 32, 87, 88, 83, 32, 115, 99, 104, 101, 109, 97, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 45, 45, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 32, 115, 99, 104, 101, 109, 97, 32, 58, 32, 100, 111, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 32, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 10, 0, 0, 0, 0, 0, 0, 9, 45, 45, 115, 97, 120, 49, 58, 32, 117, 115, 101, 32, 116, 104, 101, 32, 111, 108, 100, 32, 83, 65, 88, 49, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 115, 32, 102, 111, 114, 32, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 10, 0, 0, 0, 0, 9, 45, 45, 115, 97, 120, 58, 32, 100, 111, 32, 110, 111, 116, 32, 98, 117, 105, 108, 100, 32, 97, 32, 116, 114, 101, 101, 32, 98, 117, 116, 32, 119, 111, 114, 107, 32, 106, 117, 115, 116, 32, 97, 116, 32, 116, 104, 101, 32, 83, 65, 88, 32, 108, 101, 118, 101, 108, 10, 0, 0, 0, 0, 0, 9, 45, 45, 111, 108, 100, 120, 109, 108, 49, 48, 58, 32, 117, 115, 101, 32, 88, 77, 76, 45, 49, 46, 48, 32, 112, 97, 114, 115, 105, 110, 103, 32, 114, 117, 108, 101, 115, 32, 98, 101, 102, 111, 114, 101, 32, 116, 104, 101, 32, 53, 116, 104, 32, 101, 100, 105, 116, 105, 111, 110, 10, 0, 0, 9, 45, 45, 120, 112, 97, 116, 104, 32, 101, 120, 112, 114, 58, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 104, 101, 32, 88, 80, 97, 116, 104, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 105, 109, 112, 108, 121, 32, 45, 45, 110, 111, 111, 117, 116, 10, 0, 0, 0, 0, 10, 76, 105, 98, 120, 109, 108, 32, 112, 114, 111, 106, 101, 99, 116, 32, 104, 111, 109, 101, 32, 112, 97, 103, 101, 58, 32, 104, 116, 116, 112, 58, 47, 47, 120, 109, 108, 115, 111, 102, 116, 46, 111, 114, 103, 47, 10, 0, 84, 111, 32, 114, 101, 112, 111, 114, 116, 32, 98, 117, 103, 115, 32, 111, 114, 32, 103, 101, 116, 32, 115, 111, 109, 101, 32, 104, 101, 108, 112, 32, 99, 104, 101, 99, 107, 58, 32, 104, 116, 116, 112, 58, 47, 47, 120, 109, 108, 115, 111, 102, 116, 46, 111, 114, 103, 47, 98, 117, 103, 115, 46, 104, 116, 109, 108, 10, 0, 0, 0, 0, 83, 65, 88, 46, 101, 110, 100, 69, 108, 101, 109, 101, 110, 116, 40, 37, 115, 41, 10, 0, 0, 0, 0, 0, 83, 65, 88, 46, 115, 116, 97, 114, 116, 69, 108, 101, 109, 101, 110, 116, 40, 37, 115, 0, 0, 0, 0, 0, 37, 115, 39, 0, 0, 0, 0, 0, 108, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 56, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 242, 0, 0, 120, 242, 0, 0, 1, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 103, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 144, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 242, 0, 0, 112, 242, 0, 0, 1, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 97, 109, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 232, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 242, 0, 0, 104, 242, 0, 0, 1, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 97, 112, 111, 115, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 64, 239, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 242, 0, 0, 96, 242, 0, 0, 1, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 113, 117, 111, 116, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 152, 239, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 241, 0, 0, 64, 241, 0, 0, 1, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 68, 116, 100, 69, 110, 116, 105, 116, 121, 58, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 68, 116, 100, 69, 110, 116, 105, 116, 121, 58, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 119, 105, 116, 104, 111, 117, 116, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 68, 111, 99, 69, 110, 116, 105, 116, 121, 58, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 68, 111, 99, 69, 110, 116, 105, 116, 121, 58, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 119, 105, 116, 104, 111, 117, 116, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 0, 0, 0, 0, 0, 0, 0, 60, 33, 69, 78, 84, 73, 84, 89, 32, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 62, 10, 0, 0, 0, 0, 0, 0, 32, 80, 85, 66, 76, 73, 67, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 83, 89, 83, 84, 69, 77, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 78, 68, 65, 84, 65, 32, 0, 60, 33, 69, 78, 84, 73, 84, 89, 32, 37, 32, 0, 0, 0, 0, 0, 120, 109, 108, 68, 117, 109, 112, 69, 110, 116, 105, 116, 105, 101, 115, 68, 101, 99, 108, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 58, 32, 117, 110, 107, 110, 111, 119, 110, 32, 116, 121, 112, 101, 32, 101, 110, 116, 105, 116, 121, 32, 116, 121, 112, 101, 0, 34, 0, 0, 0, 0, 0, 0, 0, 38, 113, 117, 111, 116, 59, 0, 0, 38, 35, 120, 50, 53, 59, 0, 0, 120, 109, 108, 67, 111, 112, 121, 69, 110, 116, 105, 116, 121, 58, 58, 32, 109, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 0, 120, 109, 108, 69, 110, 99, 111, 100, 101, 69, 110, 116, 105, 116, 105, 101, 115, 58, 32, 109, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 62, 0, 0, 0, 0, 0, 120, 109, 108, 69, 110, 99, 111, 100, 101, 69, 110, 116, 105, 116, 105, 101, 115, 58, 32, 105, 110, 112, 117, 116, 32, 110, 111, 116, 32, 85, 84, 70, 45, 56, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 49, 0, 0, 0, 0, 0, 0, 38, 35, 37, 100, 59, 0, 0, 0, 120, 109, 108, 69, 110, 99, 111, 100, 101, 69, 110, 116, 105, 116, 105, 101, 115, 58, 32, 99, 104, 97, 114, 32, 111, 117, 116, 32, 111, 102, 32, 114, 97, 110, 103, 101, 10, 0, 0, 0, 38, 35, 120, 37, 88, 59, 0, 0, 120, 109, 108, 69, 110, 99, 111, 100, 101, 69, 110, 116, 105, 116, 105, 101, 115, 58, 32, 114, 101, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 67, 114, 101, 97, 116, 101, 69, 110, 116, 105, 116, 121, 58, 32, 109, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 56, 0, 0, 0, 85, 84, 70, 56, 0, 0, 0, 0, 85, 84, 70, 45, 49, 54, 0, 0, 85, 84, 70, 49, 54, 0, 0, 0, 73, 83, 79, 45, 49, 48, 54, 52, 54, 45, 85, 67, 83, 45, 50, 0, 85, 67, 83, 45, 50, 0, 0, 0, 85, 67, 83, 50, 0, 0, 0, 0, 73, 83, 79, 45, 49, 48, 54, 52, 54, 45, 85, 67, 83, 45, 52, 0, 85, 67, 83, 45, 52, 0, 0, 0, 85, 67, 83, 52, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 49, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 76, 65, 84, 73, 78, 45, 49, 0, 0, 0, 0, 0, 73, 83, 79, 32, 76, 65, 84, 73, 78, 32, 49, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 50, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 76, 65, 84, 73, 78, 45, 50, 0, 0, 0, 0, 0, 73, 83, 79, 32, 76, 65, 84, 73, 78, 32, 50, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 51, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 52, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 53, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 54, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 55, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 56, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 57, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 50, 48, 50, 50, 45, 74, 80, 0, 0, 0, 0, 0, 83, 72, 73, 70, 84, 95, 74, 73, 83, 0, 0, 0, 0, 0, 0, 0, 69, 85, 67, 45, 74, 80, 0, 0, 69, 66, 67, 68, 73, 67, 0, 0, 83, 104, 105, 102, 116, 45, 74, 73, 83, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 78, 101, 119, 67, 104, 97, 114, 69, 110, 99, 111, 100, 105, 110, 103, 72, 97, 110, 100, 108, 101, 114, 32, 58, 32, 110, 111, 32, 110, 97, 109, 101, 32, 33, 10, 0, 0, 120, 109, 108, 78, 101, 119, 67, 104, 97, 114, 69, 110, 99, 111, 100, 105, 110, 103, 72, 97, 110, 100, 108, 101, 114, 32, 58, 32, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 32, 33, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 79, 100, 100, 32, 112, 114, 111, 98, 108, 101, 109, 32, 97, 116, 32, 101, 110, 100, 105, 97, 110, 110, 101, 115, 115, 32, 100, 101, 116, 101, 99, 116, 105, 111, 110, 10, 0, 0, 0, 0, 120, 109, 108, 73, 110, 105, 116, 67, 104, 97, 114, 69, 110, 99, 111, 100, 105, 110, 103, 72, 97, 110, 100, 108, 101, 114, 115, 32, 58, 32, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 32, 33, 10, 0, 0, 85, 84, 70, 45, 49, 54, 76, 69, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 49, 54, 66, 69, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 83, 67, 73, 73, 0, 0, 0, 85, 83, 45, 65, 83, 67, 73, 73, 0, 0, 0, 0, 0, 0, 0, 0, 72, 84, 77, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 103, 105, 115, 116, 101, 114, 67, 104, 97, 114, 69, 110, 99, 111, 100, 105, 110, 103, 72, 97, 110, 100, 108, 101, 114, 58, 32, 78, 85, 76, 76, 32, 104, 97, 110, 100, 108, 101, 114, 32, 33, 10, 0, 120, 109, 108, 82, 101, 103, 105, 115, 116, 101, 114, 67, 104, 97, 114, 69, 110, 99, 111, 100, 105, 110, 103, 72, 97, 110, 100, 108, 101, 114, 58, 32, 84, 111, 111, 32, 109, 97, 110, 121, 32, 104, 97, 110, 100, 108, 101, 114, 32, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 44, 32, 115, 101, 101, 32, 37, 115, 10, 0, 0, 0, 0, 77, 65, 88, 95, 69, 78, 67, 79, 68, 73, 78, 71, 95, 72, 65, 78, 68, 76, 69, 82, 83, 0, 0, 0, 101, 98, 99, 100, 105, 99, 0, 0, 69, 66, 67, 68, 73, 67, 45, 85, 83, 0, 0, 0, 0, 0, 0, 0, 73, 66, 77, 45, 48, 51, 55, 0, 83, 72, 73, 70, 84, 45, 74, 73, 83, 0, 0, 0, 0, 0, 0, 0, 83, 104, 105, 102, 116, 95, 74, 73, 83, 0, 0, 0, 0, 0, 0, 0, 105, 99, 111, 110, 118, 32, 58, 32, 112, 114, 111, 98, 108, 101, 109, 115, 32, 119, 105, 116, 104, 32, 102, 105, 108, 116, 101, 114, 115, 32, 102, 111, 114, 32, 39, 37, 115, 39, 10, 0, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 0, 0, 0, 0, 0, 105, 110, 112, 117, 116, 32, 99, 111, 110, 118, 101, 114, 115, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 100, 117, 101, 32, 116, 111, 32, 105, 110, 112, 117, 116, 32, 101, 114, 114, 111, 114, 44, 32, 98, 121, 116, 101, 115, 32, 37, 115, 10, 0, 0, 0, 120, 109, 108, 67, 104, 97, 114, 69, 110, 99, 79, 117, 116, 70, 117, 110, 99, 58, 32, 110, 111, 32, 111, 117, 116, 112, 117, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 33, 10, 0, 0, 0, 0, 0, 0, 0, 0, 38, 35, 37, 100, 59, 0, 0, 0, 111, 117, 116, 112, 117, 116, 32, 99, 111, 110, 118, 101, 114, 115, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 100, 117, 101, 32, 116, 111, 32, 99, 111, 110, 118, 32, 101, 114, 114, 111, 114, 44, 32, 98, 121, 116, 101, 115, 32, 37, 115, 10, 0, 0, 0, 37, 115, 58, 37, 100, 58, 32, 0, 69, 110, 116, 105, 116, 121, 58, 32, 108, 105, 110, 101, 32, 37, 100, 58, 32, 0, 0, 0, 0, 0, 0, 0, 78, 111, 32, 101, 114, 114, 111, 114, 32, 109, 101, 115, 115, 97, 103, 101, 32, 112, 114, 111, 118, 105, 100, 101, 100, 0, 0, 0, 0, 0, 0, 0, 104, 114, 101, 102, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 101, 114, 114, 111, 114, 58, 32, 0, 10, 0, 0, 0, 0, 0, 0, 0, 119, 97, 114, 110, 105, 110, 103, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 97, 108, 105, 100, 105, 116, 121, 32, 101, 114, 114, 111, 114, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 118, 97, 108, 105, 100, 105, 116, 121, 32, 119, 97, 114, 110, 105, 110, 103, 58, 32, 0, 0, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 58, 32, 0, 0, 0, 0, 112, 97, 114, 115, 101, 114, 32, 0, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 0, 0, 0, 0, 0, 0, 118, 97, 108, 105, 100, 105, 116, 121, 32, 0, 0, 0, 0, 0, 0, 0, 72, 84, 77, 76, 32, 112, 97, 114, 115, 101, 114, 32, 0, 0, 0, 0, 109, 101, 109, 111, 114, 121, 32, 0, 111, 117, 116, 112, 117, 116, 32, 0, 73, 47, 79, 32, 0, 0, 0, 0, 88, 73, 110, 99, 108, 117, 100, 101, 32, 0, 0, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 32, 0, 0, 114, 101, 103, 101, 120, 112, 32, 0, 109, 111, 100, 117, 108, 101, 32, 0, 83, 99, 104, 101, 109, 97, 115, 32, 118, 97, 108, 105, 100, 105, 116, 121, 32, 0, 0, 0, 0, 0, 0, 0, 83, 99, 104, 101, 109, 97, 115, 32, 112, 97, 114, 115, 101, 114, 32, 0, 82, 101, 108, 97, 120, 45, 78, 71, 32, 112, 97, 114, 115, 101, 114, 32, 0, 0, 0, 0, 0, 0, 0, 0, 82, 101, 108, 97, 120, 45, 78, 71, 32, 118, 97, 108, 105, 100, 105, 116, 121, 32, 0, 0, 0, 0, 0, 0, 67, 97, 116, 97, 108, 111, 103, 32, 0, 0, 0, 0, 0, 0, 0, 0, 67, 49, 52, 78, 32, 0, 0, 0, 88, 83, 76, 84, 32, 0, 0, 0, 101, 110, 99, 111, 100, 105, 110, 103, 32, 0, 0, 0, 0, 0, 0, 0, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 32, 0, 0, 0, 0, 0, 105, 110, 116, 101, 114, 110, 97, 108, 32, 98, 117, 102, 102, 101, 114, 32, 0, 0, 0, 0, 0, 0, 0, 0, 85, 82, 73, 32, 0, 0, 0, 0, 58, 32, 0, 0, 0, 0, 0, 0, 119, 97, 114, 110, 105, 110, 103, 32, 58, 32, 0, 0, 0, 0, 0, 0, 101, 114, 114, 111, 114, 32, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 37, 115, 10, 0, 0, 0, 0, 0, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 37, 115, 58, 37, 100, 58, 32, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 58, 32, 108, 105, 110, 101, 32, 37, 100, 58, 32, 10, 0, 0, 0, 0, 0, 0, 70, 97, 116, 97, 108, 58, 32, 112, 114, 111, 103, 114, 97, 109, 32, 99, 111, 109, 112, 105, 108, 101, 100, 32, 97, 103, 97, 105, 110, 115, 116, 32, 108, 105, 98, 120, 109, 108, 32, 37, 100, 32, 117, 115, 105, 110, 103, 32, 108, 105, 98, 120, 109, 108, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 87, 97, 114, 110, 105, 110, 103, 58, 32, 112, 114, 111, 103, 114, 97, 109, 32, 99, 111, 109, 112, 105, 108, 101, 100, 32, 97, 103, 97, 105, 110, 115, 116, 32, 108, 105, 98, 120, 109, 108, 32, 37, 100, 32, 117, 115, 105, 110, 103, 32, 111, 108, 100, 101, 114, 32, 37, 100, 10, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 32, 48, 120, 37, 88, 32, 111, 117, 116, 32, 111, 102, 32, 97, 108, 108, 111, 119, 101, 100, 32, 114, 97, 110, 103, 101, 10, 0, 73, 110, 112, 117, 116, 32, 105, 115, 32, 110, 111, 116, 32, 112, 114, 111, 112, 101, 114, 32, 85, 84, 70, 45, 56, 44, 32, 105, 110, 100, 105, 99, 97, 116, 101, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 33, 10, 0, 66, 121, 116, 101, 115, 58, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 10, 0, 0, 0, 0, 0, 73, 110, 112, 117, 116, 32, 105, 115, 32, 110, 111, 116, 32, 112, 114, 111, 112, 101, 114, 32, 85, 84, 70, 45, 56, 44, 32, 105, 110, 100, 105, 99, 97, 116, 101, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 33, 10, 37, 115, 0, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 32, 48, 120, 48, 32, 111, 117, 116, 32, 111, 102, 32, 97, 108, 108, 111, 119, 101, 100, 32, 114, 97, 110, 103, 101, 10, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 120, 109, 108, 67, 111, 112, 121, 67, 104, 97, 114, 77, 117, 108, 116, 105, 66, 121, 116, 101, 32, 48, 120, 37, 88, 32, 111, 117, 116, 32, 111, 102, 32, 98, 111, 117, 110, 100, 10, 0, 101, 110, 99, 111, 100, 105, 110, 103, 32, 117, 110, 107, 110, 111, 119, 110, 10, 0, 0, 0, 0, 0, 0, 0, 101, 110, 99, 111, 100, 105, 110, 103, 32, 110, 111, 116, 32, 115, 117, 112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 54128);
	        allocate([112, 111, 114, 116, 101, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 85, 83, 67, 52, 32, 108, 105, 116, 116, 108, 101, 32, 101, 110, 100, 105, 97, 110, 0, 0, 0, 0, 0, 0, 85, 83, 67, 52, 32, 98, 105, 103, 32, 101, 110, 100, 105, 97, 110, 0, 69, 66, 67, 68, 73, 67, 0, 0, 85, 67, 83, 52, 32, 50, 49, 52, 51, 0, 0, 0, 0, 0, 0, 0, 85, 67, 83, 52, 32, 51, 52, 49, 50, 0, 0, 0, 0, 0, 0, 0, 85, 67, 83, 50, 0, 0, 0, 0, 73, 83, 79, 45, 50, 48, 50, 50, 45, 74, 80, 0, 0, 0, 0, 0, 83, 104, 105, 102, 116, 95, 74, 73, 83, 0, 0, 0, 0, 0, 0, 0, 69, 85, 67, 45, 74, 80, 0, 0, 99, 111, 117, 108, 100, 110, 39, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 97, 32, 110, 101, 119, 32, 105, 110, 112, 117, 116, 32, 115, 116, 114, 101, 97, 109, 10, 0, 0, 0, 110, 101, 119, 32, 105, 110, 112, 117, 116, 32, 102, 114, 111, 109, 32, 73, 47, 79, 10, 0, 0, 0, 0, 0, 120, 109, 108, 78, 101, 119, 69, 110, 116, 105, 116, 121, 73, 110, 112, 117, 116, 83, 116, 114, 101, 97, 109, 32, 101, 110, 116, 105, 116, 121, 32, 61, 32, 78, 85, 76, 76, 10, 0, 0, 110, 101, 119, 32, 105, 110, 112, 117, 116, 32, 102, 114, 111, 109, 32, 101, 110, 116, 105, 116, 121, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 67, 97, 110, 110, 111, 116, 32, 112, 97, 114, 115, 101, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 10, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 32, 119, 105, 116, 104, 111, 117, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 33, 10, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 32, 119, 105, 116, 104, 111, 117, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 33, 10, 0, 80, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 32, 119, 105, 116, 104, 111, 117, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 33, 10, 0, 110, 101, 119, 32, 105, 110, 112, 117, 116, 32, 102, 114, 111, 109, 32, 102, 105, 108, 101, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 121, 58, 32, 78, 85, 76, 76, 32, 102, 105, 108, 101, 110, 97, 109, 101, 32, 10, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 71, 111, 116, 32, 78, 85, 76, 76, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 110, 110, 111, 116, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 0, 99, 97, 110, 110, 111, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 98, 117, 102, 102, 101, 114, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 119, 105, 116, 99, 104, 84, 111, 69, 110, 99, 111, 100, 105, 110, 103, 32, 58, 32, 110, 111, 32, 105, 110, 112, 117, 116, 10, 0, 85, 84, 70, 45, 49, 54, 76, 69, 0, 0, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 49, 54, 0, 0, 85, 84, 70, 45, 49, 54, 66, 69, 0, 0, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 56, 0, 0, 0, 115, 119, 105, 116, 99, 104, 105, 110, 103, 32, 101, 110, 99, 111, 100, 105, 110, 103, 58, 32, 101, 110, 99, 111, 100, 101, 114, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 115, 119, 105, 116, 99, 104, 105, 110, 103, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 58, 32, 110, 111, 32, 105, 110, 112, 117, 116, 10, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 69, 120, 99, 101, 115, 115, 105, 118, 101, 32, 100, 101, 112, 116, 104, 32, 105, 110, 32, 100, 111, 99, 117, 109, 101, 110, 116, 58, 32, 37, 100, 32, 117, 115, 101, 32, 88, 77, 76, 95, 80, 65, 82, 83, 69, 95, 72, 85, 71, 69, 32, 111, 112, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 80, 111, 112, 112, 105, 110, 103, 32, 105, 110, 112, 117, 116, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 37, 115, 40, 37, 100, 41, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 80, 117, 115, 104, 105, 110, 103, 32, 105, 110, 112, 117, 116, 32, 37, 100, 32, 58, 32, 37, 46, 51, 48, 115, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 120, 109, 108, 67, 104, 97, 114, 32, 118, 97, 108, 117, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 37, 37, 37, 115, 59, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 83, 116, 114, 105, 110, 103, 32, 100, 101, 99, 111, 100, 105, 110, 103, 32, 69, 110, 116, 105, 116, 121, 32, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 37, 46, 51, 48, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 112, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 101, 110, 116, 105, 116, 121, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 83, 116, 114, 105, 110, 103, 32, 100, 101, 99, 111, 100, 105, 110, 103, 32, 80, 69, 32, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 37, 46, 51, 48, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 88, 77, 76, 32, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 99, 111, 109, 112, 108, 105, 97, 110, 116, 10, 0, 78, 97, 109, 101, 0, 0, 0, 0, 78, 109, 84, 111, 107, 101, 110, 0, 69, 110, 116, 105, 116, 121, 86, 97, 108, 117, 101, 58, 32, 39, 37, 99, 39, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 101, 120, 99, 101, 112, 116, 32, 102, 111, 114, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 10, 0, 0, 0, 0, 0, 83, 121, 115, 116, 101, 109, 76, 105, 116, 101, 114, 97, 108, 0, 0, 0, 80, 117, 98, 108, 105, 99, 32, 73, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 33, 34, 35, 36, 37, 0, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 0, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 0, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 83, 89, 83, 84, 69, 77, 39, 10, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 80, 85, 66, 76, 73, 67, 39, 10, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 80, 117, 98, 108, 105, 99, 32, 73, 100, 101, 110, 116, 105, 102, 105, 101, 114, 10, 0, 0, 0, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 116, 111, 111, 32, 98, 105, 103, 32, 102, 111, 117, 110, 100, 0, 0, 0, 99, 111, 109, 109, 101, 110, 116, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 68, 111, 117, 98, 108, 101, 32, 104, 121, 112, 104, 101, 110, 32, 119, 105, 116, 104, 105, 110, 32, 99, 111, 109, 109, 101, 110, 116, 58, 32, 60, 33, 45, 45, 37, 46, 53, 48, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 68, 111, 117, 98, 108, 101, 32, 104, 121, 112, 104, 101, 110, 32, 119, 105, 116, 104, 105, 110, 32, 99, 111, 109, 109, 101, 110, 116, 10, 0, 0, 0, 88, 77, 76, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 97, 108, 108, 111, 119, 101, 100, 32, 111, 110, 108, 121, 32, 97, 116, 32, 116, 104, 101, 32, 115, 116, 97, 114, 116, 32, 111, 102, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 168, 27, 1, 0, 184, 27, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 80, 73, 84, 97, 114, 103, 101, 116, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 110, 97, 109, 101, 32, 112, 114, 101, 102, 105, 120, 32, 39, 120, 109, 108, 39, 10, 0, 0, 0, 0, 99, 111, 108, 111, 110, 115, 32, 97, 114, 101, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 102, 114, 111, 109, 32, 80, 73, 32, 110, 97, 109, 101, 115, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 80, 73, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 80, 97, 114, 115, 101, 80, 73, 58, 32, 80, 73, 32, 37, 115, 32, 115, 112, 97, 99, 101, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 80, 73, 32, 37, 115, 32, 116, 111, 111, 32, 98, 105, 103, 32, 102, 111, 117, 110, 100, 0, 0, 0, 0, 0, 80, 97, 114, 115, 101, 80, 73, 58, 32, 80, 73, 32, 37, 115, 32, 110, 101, 118, 101, 114, 32, 101, 110, 100, 32, 46, 46, 46, 10, 0, 0, 0, 111, 97, 115, 105, 115, 45, 120, 109, 108, 45, 99, 97, 116, 97, 108, 111, 103, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 60, 33, 78, 79, 84, 65, 84, 73, 79, 78, 39, 10, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 78, 79, 84, 65, 84, 73, 79, 78, 32, 110, 97, 109, 101, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 108, 111, 110, 115, 32, 97, 114, 101, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 102, 114, 111, 109, 32, 110, 111, 116, 97, 116, 105, 111, 110, 32, 110, 97, 109, 101, 115, 32, 39, 37, 115, 39, 10, 0, 0, 78, 111, 116, 97, 116, 105, 111, 110, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 60, 33, 69, 78, 84, 73, 84, 89, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 37, 39, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 110, 116, 105, 116, 121, 68, 101, 99, 108, 58, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 99, 111, 108, 111, 110, 115, 32, 97, 114, 101, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 102, 114, 111, 109, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 110, 97, 109, 101, 115, 32, 39, 37, 115, 39, 10, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 101, 110, 116, 105, 116, 121, 32, 110, 97, 109, 101, 10, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 85, 82, 73, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 32, 99, 111, 109, 112, 97, 116, 105, 98, 105, 108, 105, 116, 121, 32, 109, 111, 100, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 0, 78, 101, 119, 32, 68, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 102, 97, 107, 101, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 98, 101, 102, 111, 114, 101, 32, 39, 78, 68, 65, 84, 65, 39, 10, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 78, 68, 65, 84, 65, 39, 10, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 110, 116, 105, 116, 121, 68, 101, 99, 108, 58, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 32, 110, 111, 116, 32, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 10, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 35, 70, 73, 88, 69, 68, 39, 10, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 118, 97, 108, 117, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 105, 110, 32, 78, 79, 84, 65, 84, 73, 79, 78, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 10, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 110, 111, 116, 97, 116, 105, 111, 110, 32, 118, 97, 108, 117, 101, 32, 116, 111, 107, 101, 110, 32, 37, 115, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 32, 118, 97, 108, 117, 101, 32, 116, 111, 107, 101, 110, 32, 37, 115, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 100, 10, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 78, 79, 84, 65, 84, 73, 79, 78, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 60, 33, 65, 84, 84, 76, 73, 83, 84, 39, 10, 0, 0, 0, 0, 0, 0, 0, 65, 84, 84, 76, 73, 83, 84, 58, 32, 110, 111, 32, 110, 97, 109, 101, 32, 102, 111, 114, 32, 69, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 65, 84, 84, 76, 73, 83, 84, 58, 32, 110, 111, 32, 110, 97, 109, 101, 32, 102, 111, 114, 32, 65, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 0, 0, 105, 110, 32, 120, 109, 108, 80, 97, 114, 115, 101, 65, 116, 116, 114, 105, 98, 117, 116, 101, 76, 105, 115, 116, 68, 101, 99, 108, 10, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 108, 105, 115, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 77, 105, 120, 101, 100, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 78, 97, 109, 101, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 37, 115, 32, 39, 40, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 69, 76, 69, 77, 69, 78, 84, 39, 10, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 110, 111, 32, 110, 97, 109, 101, 32, 102, 111, 114, 32, 69, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 97, 109, 101, 10, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 119, 105, 116, 104, 105, 110, 32, 109, 97, 114, 107, 117, 112, 32, 100, 101, 99, 108, 32, 105, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 39, 69, 77, 80, 84, 89, 39, 44, 32, 39, 65, 78, 89, 39, 32, 111, 114, 32, 39, 40, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 83, 112, 97, 99, 101, 32, 110, 101, 101, 100, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 60, 63, 120, 109, 108, 39, 10, 0, 0, 0, 0, 0, 49, 46, 48, 0, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 110, 101, 101, 100, 101, 100, 32, 104, 101, 114, 101, 10, 0, 0, 0, 0, 0, 0, 77, 105, 115, 115, 105, 110, 103, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 105, 110, 32, 116, 101, 120, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 10, 0, 0, 0, 35, 120, 37, 88, 0, 0, 0, 0, 35, 37, 100, 0, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 101, 110, 116, 105, 116, 121, 32, 116, 121, 112, 101, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 39, 37, 115, 39, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 10, 0, 0, 0, 0, 110, 98, 107, 116, 101, 120, 116, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 110, 116, 105, 116, 121, 82, 101, 102, 58, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 39, 37, 115, 39, 32, 110, 111, 116, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 117, 110, 112, 97, 114, 115, 101, 100, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 10, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 121, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 39, 60, 39, 32, 105, 110, 32, 101, 110, 116, 105, 116, 121, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 118, 97, 108, 117, 101, 115, 10, 0, 65, 116, 116, 101, 109, 112, 116, 32, 116, 111, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 104, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 110, 116, 105, 116, 121, 32, 39, 37, 115, 39, 10, 0, 120, 109, 108, 80, 97, 114, 115, 101, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 37, 37, 37, 115, 59, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 68, 111, 99, 84, 121, 112, 101, 68, 101, 99, 108, 32, 58, 32, 110, 111, 32, 68, 79, 67, 84, 89, 80, 69, 32, 110, 97, 109, 101, 32, 33, 10, 0, 0, 0, 0, 0, 0, 0, 0, 101, 114, 114, 111, 114, 32, 112, 97, 114, 115, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 110, 97, 109, 101, 10, 0, 0, 0, 83, 112, 101, 99, 105, 102, 105, 99, 97, 116, 105, 111, 110, 32, 109, 97, 110, 100, 97, 116, 101, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 10, 0, 0, 0, 120, 109, 108, 58, 108, 97, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 77, 97, 108, 102, 111, 114, 109, 101, 100, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 120, 109, 108, 58, 108, 97, 110, 103, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 58, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 0, 112, 114, 101, 115, 101, 114, 118, 101, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 120, 109, 108, 58, 115, 112, 97, 99, 101, 32, 58, 32, 34, 100, 101, 102, 97, 117, 108, 116, 34, 32, 111, 114, 32, 34, 112, 114, 101, 115, 101, 114, 118, 101, 34, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 97, 109, 101, 10, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 112, 114, 111, 98, 108, 101, 109, 32, 112, 97, 114, 115, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 10, 0, 0, 0, 67, 68, 97, 116, 97, 32, 115, 101, 99, 116, 105, 111, 110, 32, 116, 111, 111, 32, 98, 105, 103, 32, 102, 111, 117, 110, 100, 0, 0, 0, 0, 0, 67, 68, 97, 116, 97, 32, 115, 101, 99, 116, 105, 111, 110, 32, 110, 111, 116, 32, 102, 105, 110, 105, 115, 104, 101, 100, 10, 37, 46, 53, 48, 115, 10, 0, 0, 0, 0, 0, 0, 0, 100, 101, 116, 101, 99, 116, 101, 100, 32, 97, 110, 32, 101, 114, 114, 111, 114, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 67, 111, 117, 108, 100, 110, 39, 116, 32, 102, 105, 110, 100, 32, 101, 110, 100, 32, 111, 102, 32, 83, 116, 97, 114, 116, 32, 84, 97, 103, 32, 37, 115, 32, 108, 105, 110, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 80, 114, 101, 109, 97, 116, 117, 114, 101, 32, 101, 110, 100, 32, 111, 102, 32, 100, 97, 116, 97, 32, 105, 110, 32, 116, 97, 103, 32, 37, 115, 32, 108, 105, 110, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 49, 54, 0, 0, 85, 84, 70, 49, 54, 0, 0, 0, 68, 111, 99, 117, 109, 101, 110, 116, 32, 108, 97, 98, 101, 108, 108, 101, 100, 32, 85, 84, 70, 45, 49, 54, 32, 98, 117, 116, 32, 104, 97, 115, 32, 85, 84, 70, 45, 56, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 85, 84, 70, 45, 56, 0, 0, 0, 85, 84, 70, 56, 0, 0, 0, 0, 85, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 66, 108, 97, 110, 107, 32, 110, 101, 101, 100, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 60, 63, 120, 109, 108, 39, 10, 0, 0, 0, 0, 0, 85, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 118, 101, 114, 115, 105, 111, 110, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 0, 66, 108, 97, 110, 107, 32, 110, 101, 101, 100, 101, 100, 32, 104, 101, 114, 101, 10, 0, 0, 0, 0, 0, 0, 83, 116, 97, 114, 116, 32, 116, 97, 103, 32, 101, 120, 112, 101, 99, 116, 101, 100, 44, 32, 39, 60, 39, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 85, 67, 83, 45, 52, 0, 0, 0, 85, 67, 83, 52, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 67, 104, 117, 110, 107, 58, 32, 101, 110, 99, 111, 100, 101, 114, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 72, 117, 103, 101, 32, 105, 110, 112, 117, 116, 32, 108, 111, 111, 107, 117, 112, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 112, 97, 114, 115, 101, 114, 58, 32, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 110, 111, 110, 101, 0, 0, 0, 0, 112, 115, 101, 117, 100, 111, 114, 111, 111, 116, 0, 0, 0, 0, 0, 0, 86, 101, 114, 115, 105, 111, 110, 32, 109, 105, 115, 109, 97, 116, 99, 104, 32, 98, 101, 116, 119, 101, 101, 110, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 97, 110, 100, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 99, 97, 110, 110, 111, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 111, 117, 108, 100, 110, 39, 116, 32, 102, 105, 110, 100, 32, 101, 110, 100, 32, 111, 102, 32, 83, 116, 97, 114, 116, 32, 84, 97, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 60, 33, 91, 67, 68, 65, 84, 65, 91, 0, 0, 0, 0, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 67, 79, 77, 77, 69, 78, 84, 10, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 73, 71, 78, 79, 82, 69, 0, 0, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 80, 73, 10, 0, 0, 0, 0, 0, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 69, 78, 84, 73, 84, 89, 95, 68, 69, 67, 76, 10, 0, 0, 0, 0, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 69, 78, 84, 73, 84, 89, 95, 86, 65, 76, 85, 69, 10, 0, 0, 0, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 65, 84, 84, 82, 73, 66, 85, 84, 69, 95, 86, 65, 76, 85, 69, 10, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 83, 89, 83, 84, 69, 77, 95, 76, 73, 84, 69, 82, 65, 76, 10, 0, 0, 0, 0, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 80, 85, 66, 76, 73, 67, 95, 76, 73, 84, 69, 82, 65, 76, 10, 0, 0, 0, 0, 66, 121, 116, 101, 115, 58, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 10, 0, 0, 0, 0, 0, 73, 110, 112, 117, 116, 32, 105, 115, 32, 110, 111, 116, 32, 112, 114, 111, 112, 101, 114, 32, 85, 84, 70, 45, 56, 44, 32, 105, 110, 100, 105, 99, 97, 116, 101, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 33, 10, 37, 115, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 80, 97, 114, 115, 101, 71, 101, 116, 76, 97, 115, 116, 115, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 58, 32, 101, 114, 114, 111, 114, 32, 100, 101, 116, 101, 99, 116, 101, 100, 32, 105, 110, 32, 77, 97, 114, 107, 117, 112, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 10, 0, 0, 0, 117, 110, 112, 97, 114, 115, 101, 97, 98, 108, 101, 0, 0, 0, 0, 0, 79, 112, 101, 110, 105, 110, 103, 32, 97, 110, 100, 32, 101, 110, 100, 105, 110, 103, 32, 116, 97, 103, 32, 109, 105, 115, 109, 97, 116, 99, 104, 58, 32, 37, 115, 32, 108, 105, 110, 101, 32, 37, 100, 32, 97, 110, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 81, 78, 97, 109, 101, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 81, 78, 97, 109, 101, 32, 39, 37, 115, 58, 39, 10, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 81, 78, 97, 109, 101, 32, 39, 37, 115, 58, 37, 115, 58, 39, 10, 0, 78, 67, 78, 97, 109, 101, 0, 0, 80, 98, 109, 32, 112, 111, 112, 112, 105, 110, 103, 32, 37, 100, 32, 78, 83, 10, 0, 0, 0, 0, 0, 0, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 97, 109, 101, 10, 0, 100, 105, 99, 116, 105, 111, 110, 97, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 117, 114, 101, 0, 0, 0, 120, 109, 108, 110, 115, 58, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 85, 82, 73, 10, 0, 120, 109, 108, 110, 115, 58, 32, 85, 82, 73, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 98, 115, 111, 108, 117, 116, 101, 10, 0, 0, 120, 109, 108, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 85, 82, 73, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 116, 104, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 10, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 48, 47, 120, 109, 108, 110, 115, 47, 0, 0, 0, 114, 101, 117, 115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 120, 109, 108, 110, 115, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 97, 109, 101, 32, 105, 115, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 10, 0, 120, 109, 108, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 32, 109, 97, 112, 112, 101, 100, 32, 116, 111, 32, 119, 114, 111, 110, 103, 32, 85, 82, 73, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 85, 82, 73, 32, 109, 97, 112, 112, 101, 100, 32, 116, 111, 32, 119, 114, 111, 110, 103, 32, 112, 114, 101, 102, 105, 120, 10, 0, 0, 0, 0, 0, 0, 0, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 120, 109, 108, 110, 115, 32, 112, 114, 101, 102, 105, 120, 32, 105, 115, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 10, 0, 0, 120, 109, 108, 110, 115, 58, 37, 115, 58, 32, 69, 109, 112, 116, 121, 32, 88, 77, 76, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 10, 0, 0, 0, 120, 109, 108, 110, 115, 58, 37, 115, 58, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 85, 82, 73, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 58, 37, 115, 58, 32, 85, 82, 73, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 98, 115, 111, 108, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 110, 32, 37, 115, 32, 100, 101, 102, 97, 117, 108, 116, 101, 100, 32, 102, 114, 111, 109, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 32, 102, 111, 114, 32, 37, 115, 32, 111, 110, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 100, 32, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 105, 110, 32, 39, 37, 115, 39, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 32, 111, 110, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 115, 112, 97, 99, 101, 0, 0, 0, 65, 116, 116, 86, 97, 108, 117, 101, 32, 108, 101, 110, 103, 116, 104, 32, 116, 111, 111, 32, 108, 111, 110, 103, 10, 0, 0, 0, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 105, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 65, 116, 116, 86, 97, 108, 117, 101, 58, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 110, 100, 84, 97, 103, 58, 32, 39, 60, 47, 39, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 58, 37, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 83, 116, 114, 105, 110, 103, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 37, 37, 37, 115, 59, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 76, 111, 97, 100, 69, 110, 116, 105, 116, 121, 67, 111, 110, 116, 101, 110, 116, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 82, 101, 97, 100, 105, 110, 103, 32, 37, 115, 32, 101, 110, 116, 105, 116, 121, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 110, 112, 117, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 76, 111, 97, 100, 69, 110, 116, 105, 116, 121, 67, 111, 110, 116, 101, 110, 116, 32, 105, 110, 112, 117, 116, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 76, 111, 97, 100, 69, 110, 116, 105, 116, 121, 67, 111, 110, 116, 101, 110, 116, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 99, 104, 97, 114, 32, 118, 97, 108, 117, 101, 32, 37, 100, 10, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 83, 116, 114, 105, 110, 103, 69, 110, 116, 105, 116, 121, 82, 101, 102, 58, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 0, 65, 108, 108, 32, 109, 97, 114, 107, 117, 112, 32, 111, 102, 32, 116, 104, 101, 32, 99, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 115, 101, 99, 116, 105, 111, 110, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 101, 114, 105, 110, 103, 32, 73, 78, 67, 76, 85, 68, 69, 32, 67, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 83, 101, 99, 116, 105, 111, 110, 10, 0, 0, 0, 76, 101, 97, 118, 105, 110, 103, 32, 73, 78, 67, 76, 85, 68, 69, 32, 67, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 83, 101, 99, 116, 105, 111, 110, 10, 0, 0, 0, 0, 69, 110, 116, 101, 114, 105, 110, 103, 32, 73, 71, 78, 79, 82, 69, 32, 67, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 83, 101, 99, 116, 105, 111, 110, 10, 0, 0, 0, 0, 76, 101, 97, 118, 105, 110, 103, 32, 73, 71, 78, 79, 82, 69, 32, 67, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 83, 101, 99, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 67, 104, 105, 108, 100, 114, 101, 110, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 100, 101, 112, 116, 104, 32, 37, 100, 32, 116, 111, 111, 32, 100, 101, 101, 112, 44, 32, 117, 115, 101, 32, 88, 77, 76, 95, 80, 65, 82, 83, 69, 95, 72, 85, 71, 69, 10, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 67, 104, 105, 108, 100, 114, 101, 110, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 39, 37, 99, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 0, 0, 101, 120, 116, 101, 114, 110, 97, 108, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 116, 97, 108, 111, 103, 0, 67, 97, 116, 97, 108, 111, 103, 32, 80, 73, 32, 115, 121, 110, 116, 97, 120, 32, 101, 114, 114, 111, 114, 58, 32, 37, 115, 10, 0, 0, 0, 0, 120, 109, 108, 45, 115, 116, 121, 108, 101, 115, 104, 101, 101, 116, 0, 0, 120, 109, 108, 45, 109, 111, 100, 101, 108, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 67, 111, 109, 109, 101, 110, 116, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 120, 109, 108, 67, 104, 97, 114, 32, 118, 97, 108, 117, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 110, 111, 116, 32, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 32, 10, 60, 33, 45, 45, 37, 46, 53, 48, 115, 10, 0, 0, 0, 0, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 100, 111, 101, 115, 110, 39, 116, 32, 115, 116, 97, 114, 116, 32, 97, 110, 100, 32, 115, 116, 111, 112, 32, 105, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 0, 0, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 110, 111, 116, 32, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 10, 0, 80, 67, 68, 65, 84, 65, 32, 105, 110, 118, 97, 108, 105, 100, 32, 67, 104, 97, 114, 32, 118, 97, 108, 117, 101, 32, 37, 100, 10, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 83, 116, 114, 105, 110, 103, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 120, 109, 108, 67, 104, 97, 114, 32, 118, 97, 108, 117, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 78, 101, 119, 66, 108, 97, 110, 107, 115, 87, 114, 97, 112, 112, 101, 114, 73, 110, 112, 117, 116, 83, 116, 114, 101, 97, 109, 32, 101, 110, 116, 105, 116, 121, 10, 0, 0, 110, 101, 119, 32, 98, 108, 97, 110, 107, 115, 32, 119, 114, 97, 112, 112, 101, 114, 32, 102, 111, 114, 32, 101, 110, 116, 105, 116, 121, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 104, 101, 120, 97, 100, 101, 99, 105, 109, 97, 108, 32, 118, 97, 108, 117, 101, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 100, 101, 99, 105, 109, 97, 108, 32, 118, 97, 108, 117, 101, 0, 0, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 0, 0, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 97, 116, 32, 101, 110, 100, 32, 111, 102, 32, 100, 111, 99, 117, 109, 101, 110, 116, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 105, 110, 32, 112, 114, 111, 108, 111, 103, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 105, 110, 32, 101, 112, 105, 108, 111, 103, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 110, 111, 32, 110, 97, 109, 101, 0, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 59, 39, 0, 0, 0, 0, 0, 0, 68, 101, 116, 101, 99, 116, 101, 100, 32, 97, 110, 32, 101, 110, 116, 105, 116, 121, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 108, 111, 111, 112, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 86, 97, 108, 117, 101, 58, 32, 34, 32, 111, 114, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 105, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 0, 0, 0, 0, 0, 0, 0, 65, 116, 116, 86, 97, 108, 117, 101, 58, 32, 34, 32, 111, 114, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 0, 0, 85, 110, 101, 115, 99, 97, 112, 101, 100, 32, 39, 60, 39, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 118, 97, 108, 117, 101, 115, 0, 0, 83, 121, 115, 116, 101, 109, 76, 105, 116, 101, 114, 97, 108, 32, 34, 32, 111, 114, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 85, 110, 102, 105, 110, 105, 115, 104, 101, 100, 32, 83, 121, 115, 116, 101, 109, 32, 111, 114, 32, 80, 117, 98, 108, 105, 99, 32, 73, 68, 32, 34, 32, 111, 114, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 83, 101, 113, 117, 101, 110, 99, 101, 32, 39, 93, 93, 62, 39, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 110, 32, 99, 111, 110, 116, 101, 110, 116, 0, 0, 0, 83, 89, 83, 84, 69, 77, 32, 111, 114, 32, 80, 85, 66, 76, 73, 67, 44, 32, 116, 104, 101, 32, 85, 82, 73, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 0, 0, 0, 0, 80, 85, 66, 76, 73, 67, 44, 32, 116, 104, 101, 32, 80, 117, 98, 108, 105, 99, 32, 73, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 39, 45, 45, 39, 32, 40, 100, 111, 117, 98, 108, 101, 45, 104, 121, 112, 104, 101, 110, 41, 0, 0, 0, 120, 109, 108, 80, 97, 114, 115, 101, 80, 73, 32, 58, 32, 110, 111, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 80, 73, 32, 110, 97, 109, 101, 0, 78, 79, 84, 65, 84, 73, 79, 78, 58, 32, 78, 97, 109, 101, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 104, 101, 114, 101, 0, 0, 0, 0, 39, 62, 39, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 116, 111, 32, 99, 108, 111, 115, 101, 32, 78, 79, 84, 65, 84, 73, 79, 78, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 118, 97, 108, 117, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 0, 0, 0, 70, 114, 97, 103, 109, 101, 110, 116, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 0, 0, 0, 0, 39, 40, 39, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 116, 111, 32, 115, 116, 97, 114, 116, 32, 65, 84, 84, 76, 73, 83, 84, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 78, 109, 84, 111, 107, 101, 110, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 105, 110, 32, 65, 84, 84, 76, 73, 83, 84, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 0, 39, 41, 39, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 116, 111, 32, 102, 105, 110, 105, 115, 104, 32, 65, 84, 84, 76, 73, 83, 84, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 77, 105, 120, 101, 100, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 39, 124, 39, 32, 111, 114, 32, 39, 41, 42, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 77, 105, 120, 101, 100, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 39, 35, 80, 67, 68, 65, 84, 65, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 78, 97, 109, 101, 32, 111, 114, 32, 39, 40, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 0, 67, 111, 110, 116, 101, 110, 116, 68, 101, 99, 108, 32, 58, 32, 39, 44, 39, 32, 39, 124, 39, 32, 111, 114, 32, 39, 41, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 80, 69, 82, 101, 102, 101, 114, 101, 110, 99, 101, 58, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 119, 105, 116, 104, 105, 110, 32, 109, 97, 114, 107, 117, 112, 32, 100, 101, 99, 108, 32, 105, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 0, 0, 0, 0, 101, 120, 112, 101, 99, 116, 101, 100, 32, 39, 62, 39, 0, 0, 0, 0, 88, 77, 76, 32, 99, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 115, 101, 99, 116, 105, 111, 110, 32, 39, 91, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 67, 111, 110, 116, 101, 110, 116, 32, 101, 114, 114, 111, 114, 32, 105, 110, 32, 116, 104, 101, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 0, 0, 0, 0, 99, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 115, 101, 99, 116, 105, 111, 110, 32, 73, 78, 67, 76, 85, 68, 69, 32, 111, 114, 32, 73, 71, 78, 79, 82, 69, 32, 107, 101, 121, 119, 111, 114, 100, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 88, 77, 76, 32, 99, 111, 110, 100, 105, 116, 105, 111, 110, 97, 108, 32, 115, 101, 99, 116, 105, 111, 110, 32, 110, 111, 116, 32, 99, 108, 111, 115, 101, 100, 0, 0, 0, 0, 0, 0, 84, 101, 120, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 39, 60, 63, 120, 109, 108, 39, 32, 114, 101, 113, 117, 105, 114, 101, 100, 0, 0, 0, 0, 0, 0, 0, 112, 97, 114, 115, 105, 110, 103, 32, 88, 77, 76, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 58, 32, 39, 63, 62, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 101, 120, 116, 101, 114, 110, 97, 108, 32, 112, 97, 114, 115, 101, 100, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 0, 0, 0, 69, 110, 116, 105, 116, 121, 82, 101, 102, 58, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 59, 39, 0, 0, 0, 0, 0, 0, 0, 0, 68, 79, 67, 84, 89, 80, 69, 32, 105, 109, 112, 114, 111, 112, 101, 114, 108, 121, 32, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 64368);
	        allocate([69, 110, 100, 84, 97, 103, 58, 32, 39, 60, 47, 39, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 0, 0, 101, 120, 112, 101, 99, 116, 101, 100, 32, 39, 61, 39, 0, 0, 0, 0, 83, 116, 114, 105, 110, 103, 32, 110, 111, 116, 32, 99, 108, 111, 115, 101, 100, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 34, 32, 111, 114, 32, 39, 0, 0, 0, 0, 0, 0, 83, 116, 114, 105, 110, 103, 32, 110, 111, 116, 32, 115, 116, 97, 114, 116, 101, 100, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 32, 111, 114, 32, 34, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 88, 77, 76, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 110, 97, 109, 101, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 32, 97, 99, 99, 101, 112, 116, 115, 32, 111, 110, 108, 121, 32, 39, 121, 101, 115, 39, 32, 111, 114, 32, 39, 110, 111, 39, 0, 0, 0, 68, 111, 99, 117, 109, 101, 110, 116, 32, 105, 115, 32, 101, 109, 112, 116, 121, 0, 0, 0, 0, 0, 0, 0, 69, 120, 116, 114, 97, 32, 99, 111, 110, 116, 101, 110, 116, 32, 97, 116, 32, 116, 104, 101, 32, 101, 110, 100, 32, 111, 102, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 99, 104, 117, 110, 107, 32, 105, 115, 32, 110, 111, 116, 32, 119, 101, 108, 108, 32, 98, 97, 108, 97, 110, 99, 101, 100, 0, 0, 0, 0, 0, 0, 101, 120, 116, 114, 97, 32, 99, 111, 110, 116, 101, 110, 116, 32, 97, 116, 32, 116, 104, 101, 32, 101, 110, 100, 32, 111, 102, 32, 119, 101, 108, 108, 32, 98, 97, 108, 97, 110, 99, 101, 100, 32, 99, 104, 117, 110, 107, 0, 77, 97, 108, 102, 111, 114, 109, 101, 100, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 118, 101, 114, 115, 105, 111, 110, 0, 78, 97, 109, 101, 32, 116, 111, 111, 32, 108, 111, 110, 103, 32, 117, 115, 101, 32, 88, 77, 76, 95, 80, 65, 82, 83, 69, 95, 72, 85, 71, 69, 32, 111, 112, 116, 105, 111, 110, 0, 85, 110, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 32, 101, 114, 114, 111, 114, 32, 109, 101, 115, 115, 97, 103, 101, 0, 0, 0, 0, 0, 0, 37, 115, 10, 0, 0, 0, 0, 0, 37, 115, 58, 32, 37, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 101, 120, 116, 0, 0, 0, 0, 116, 101, 120, 116, 110, 111, 101, 110, 99, 0, 0, 0, 0, 0, 0, 0, 99, 111, 109, 109, 101, 110, 116, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 81, 78, 97, 109, 101, 0, 0, 81, 78, 97, 109, 101, 32, 115, 112, 108, 105, 116, 0, 0, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 68, 84, 68, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 0, 0, 0, 0, 0, 0, 0, 0, 49, 46, 48, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 100, 111, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 80, 73, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 110, 111, 100, 101, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 116, 101, 120, 116, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 99, 111, 109, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 67, 68, 65, 84, 65, 0, 0, 103, 101, 116, 116, 105, 110, 103, 32, 110, 111, 100, 101, 32, 112, 97, 116, 104, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 37, 115, 58, 37, 115, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 0, 99, 111, 109, 109, 101, 110, 116, 40, 41, 0, 0, 0, 0, 0, 0, 0, 116, 101, 120, 116, 40, 41, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 45, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 40, 39, 37, 115, 39, 41, 0, 0, 0, 0, 47, 64, 0, 0, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 37, 115, 37, 115, 37, 115, 0, 0, 37, 115, 37, 115, 91, 37, 100, 93, 37, 115, 0, 0, 0, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 115, 112, 97, 99, 101, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 0, 112, 114, 101, 115, 101, 114, 118, 101, 0, 0, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 104, 116, 109, 108, 0, 0, 0, 0, 104, 101, 97, 100, 0, 0, 0, 0, 104, 114, 101, 102, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 0, 102, 116, 112, 58, 47, 47, 0, 0, 117, 114, 110, 58, 0, 0, 0, 0, 103, 101, 116, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 108, 105, 115, 116, 0, 0, 115, 101, 97, 114, 99, 104, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 49, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 103, 114, 111, 119, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 38, 113, 117, 111, 116, 59, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 37, 46, 50, 48, 115, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 37, 100, 0, 0, 0, 0, 0, 0, 0, 37, 46, 50, 48, 115, 37, 100, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 88, 77, 76, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 99, 111, 112, 121, 105, 110, 103, 32, 110, 111, 100, 101, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 104, 101, 120, 97, 100, 101, 99, 105, 109, 97, 108, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 100, 101, 99, 105, 109, 97, 108, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 32, 101, 110, 116, 105, 116, 121, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 37, 49, 53, 115, 10, 0, 0, 0, 0, 0, 115, 116, 114, 105, 110, 103, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 32, 85, 84, 70, 45, 56, 10, 0, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 101, 114, 114, 111, 114, 32, 110, 117, 109, 98, 101, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 152, 45, 1, 0, 176, 45, 1, 0, 200, 45, 1, 0, 240, 45, 1, 0, 8, 46, 1, 0, 24, 46, 1, 0, 40, 46, 1, 0, 64, 46, 1, 0, 88, 46, 1, 0, 120, 46, 1, 0, 136, 46, 1, 0, 152, 46, 1, 0, 168, 46, 1, 0, 184, 46, 1, 0, 208, 46, 1, 0, 240, 46, 1, 0, 8, 47, 1, 0, 32, 47, 1, 0, 48, 47, 1, 0, 72, 47, 1, 0, 88, 47, 1, 0, 128, 47, 1, 0, 152, 47, 1, 0, 184, 47, 1, 0, 200, 47, 1, 0, 232, 47, 1, 0, 0, 48, 1, 0, 24, 48, 1, 0, 48, 48, 1, 0, 72, 48, 1, 0, 104, 48, 1, 0, 120, 48, 1, 0, 144, 48, 1, 0, 160, 48, 1, 0, 200, 48, 1, 0, 232, 48, 1, 0, 0, 49, 1, 0, 16, 49, 1, 0, 40, 49, 1, 0, 64, 49, 1, 0, 80, 49, 1, 0, 96, 49, 1, 0, 120, 49, 1, 0, 136, 49, 1, 0, 176, 49, 1, 0, 192, 49, 1, 0, 208, 49, 1, 0, 224, 49, 1, 0, 240, 49, 1, 0, 0, 50, 1, 0, 16, 50, 1, 0, 32, 50, 1, 0, 56, 50, 1, 0, 80, 50, 1, 0, 104, 50, 1, 0, 120, 50, 1, 0, 136, 50, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 114, 101, 97, 100, 40, 41, 0, 102, 102, 108, 117, 115, 104, 40, 41, 0, 0, 0, 0, 0, 0, 0, 0, 102, 99, 108, 111, 115, 101, 40, 41, 0, 0, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 105, 110, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 111, 117, 116, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 0, 0, 102, 105, 108, 101, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 105, 110, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 32, 112, 97, 116, 104, 10, 0, 0, 0, 0, 0, 0, 0, 0, 102, 116, 112, 58, 47, 47, 0, 0, 104, 116, 116, 112, 58, 47, 47, 0, 78, 85, 76, 76, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 102, 105, 108, 101, 58, 47, 47, 108, 111, 99, 97, 108, 104, 111, 115, 116, 47, 0, 0, 0, 0, 0, 0, 0, 102, 105, 108, 101, 58, 47, 47, 47, 0, 0, 0, 0, 0, 0, 0, 0, 119, 114, 105, 116, 101, 40, 41, 0, 99, 108, 111, 115, 101, 40, 41, 0, 114, 101, 97, 100, 40, 41, 0, 0, 102, 119, 114, 105, 116, 101, 40, 41, 0, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 119, 98, 0, 0, 0, 0, 0, 0, 102, 105, 108, 101, 58, 47, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 73, 79, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 80, 101, 114, 109, 105, 115, 115, 105, 111, 110, 32, 100, 101, 110, 105, 101, 100, 0, 0, 0, 0, 0, 0, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 116, 101, 109, 112, 111, 114, 97, 114, 105, 108, 121, 32, 117, 110, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 66, 97, 100, 32, 102, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 0, 0, 0, 0, 0, 66, 97, 100, 32, 109, 101, 115, 115, 97, 103, 101, 0, 0, 0, 0, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 98, 117, 115, 121, 0, 0, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 110, 99, 101, 108, 101, 100, 0, 0, 0, 0, 0, 0, 78, 111, 32, 99, 104, 105, 108, 100, 32, 112, 114, 111, 99, 101, 115, 115, 101, 115, 0, 0, 0, 0, 0, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 100, 101, 97, 100, 108, 111, 99, 107, 32, 97, 118, 111, 105, 100, 101, 100, 0, 0, 0, 0, 0, 0, 0, 68, 111, 109, 97, 105, 110, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 70, 105, 108, 101, 32, 101, 120, 105, 115, 116, 115, 0, 0, 0, 0, 0, 66, 97, 100, 32, 97, 100, 100, 114, 101, 115, 115, 0, 0, 0, 0, 0, 70, 105, 108, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 105, 110, 32, 112, 114, 111, 103, 114, 101, 115, 115, 0, 0, 0, 73, 110, 116, 101, 114, 114, 117, 112, 116, 101, 100, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 97, 108, 108, 0, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 112, 117, 116, 47, 111, 117, 116, 112, 117, 116, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 73, 115, 32, 97, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 111, 112, 101, 110, 32, 102, 105, 108, 101, 115, 0, 0, 0, 0, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 108, 105, 110, 107, 115, 0, 0, 73, 110, 97, 112, 112, 114, 111, 112, 114, 105, 97, 116, 101, 32, 109, 101, 115, 115, 97, 103, 101, 32, 98, 117, 102, 102, 101, 114, 32, 108, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 70, 105, 108, 101, 110, 97, 109, 101, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0, 0, 0, 0, 0, 0, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 111, 112, 101, 110, 32, 102, 105, 108, 101, 115, 32, 105, 110, 32, 115, 121, 115, 116, 101, 109, 0, 0, 0, 78, 111, 32, 115, 117, 99, 104, 32, 100, 101, 118, 105, 99, 101, 0, 0, 78, 111, 32, 115, 117, 99, 104, 32, 102, 105, 108, 101, 32, 111, 114, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 0, 0, 0, 0, 0, 0, 69, 120, 101, 99, 32, 102, 111, 114, 109, 97, 116, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 0, 78, 111, 32, 108, 111, 99, 107, 115, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 0, 0, 0, 0, 0, 78, 111, 116, 32, 101, 110, 111, 117, 103, 104, 32, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 0, 78, 111, 32, 115, 112, 97, 99, 101, 32, 108, 101, 102, 116, 32, 111, 110, 32, 100, 101, 118, 105, 99, 101, 0, 70, 117, 110, 99, 116, 105, 111, 110, 32, 110, 111, 116, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 78, 111, 116, 32, 97, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 68, 105, 114, 101, 99, 116, 111, 114, 121, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 0, 0, 0, 0, 0, 78, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 0, 0, 73, 110, 97, 112, 112, 114, 111, 112, 114, 105, 97, 116, 101, 32, 73, 47, 79, 32, 99, 111, 110, 116, 114, 111, 108, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 78, 111, 32, 115, 117, 99, 104, 32, 100, 101, 118, 105, 99, 101, 32, 111, 114, 32, 97, 100, 100, 114, 101, 115, 115, 0, 0, 0, 0, 0, 0, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 110, 111, 116, 32, 112, 101, 114, 109, 105, 116, 116, 101, 100, 0, 66, 114, 111, 107, 101, 110, 32, 112, 105, 112, 101, 0, 0, 0, 0, 0, 82, 101, 115, 117, 108, 116, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0, 0, 0, 0, 0, 0, 0, 0, 82, 101, 97, 100, 45, 111, 110, 108, 121, 32, 102, 105, 108, 101, 32, 115, 121, 115, 116, 101, 109, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 115, 101, 101, 107, 0, 0, 0, 0, 78, 111, 32, 115, 117, 99, 104, 32, 112, 114, 111, 99, 101, 115, 115, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 116, 105, 109, 101, 100, 32, 111, 117, 116, 0, 0, 0, 0, 0, 73, 109, 112, 114, 111, 112, 101, 114, 32, 108, 105, 110, 107, 0, 0, 0, 65, 116, 116, 101, 109, 112, 116, 32, 116, 111, 32, 108, 111, 97, 100, 32, 110, 101, 116, 119, 111, 114, 107, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 0, 0, 0, 0, 0, 0, 0, 101, 110, 99, 111, 100, 101, 114, 32, 101, 114, 114, 111, 114, 0, 0, 0, 102, 108, 117, 115, 104, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 119, 114, 105, 116, 101, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 110, 111, 32, 105, 110, 112, 117, 116, 0, 0, 0, 0, 0, 0, 0, 0, 98, 117, 102, 102, 101, 114, 32, 102, 117, 108, 108, 0, 0, 0, 0, 0, 108, 111, 97, 100, 105, 110, 103, 32, 101, 114, 114, 111, 114, 0, 0, 0, 110, 111, 116, 32, 97, 32, 115, 111, 99, 107, 101, 116, 0, 0, 0, 0, 97, 108, 114, 101, 97, 100, 121, 32, 99, 111, 110, 110, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 0, 0, 99, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 102, 117, 115, 101, 100, 0, 0, 0, 0, 0, 0, 117, 110, 114, 101, 97, 99, 104, 97, 98, 108, 101, 32, 110, 101, 116, 119, 111, 114, 107, 0, 0, 0, 0, 0, 97, 100, 100, 100, 114, 101, 115, 115, 32, 105, 110, 32, 117, 115, 101, 0, 97, 108, 114, 101, 97, 100, 121, 32, 105, 110, 32, 117, 115, 101, 0, 0, 117, 110, 107, 110, 111, 119, 110, 32, 97, 100, 100, 114, 101, 115, 115, 32, 102, 97, 109, 105, 108, 108, 121, 0, 120, 109, 108, 77, 97, 108, 108, 111, 99, 66, 114, 101, 97, 107, 112, 111, 105, 110, 116, 32, 114, 101, 97, 99, 104, 101, 100, 32, 111, 110, 32, 98, 108, 111, 99, 107, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 77, 97, 108, 108, 111, 99, 76, 111, 99, 32, 58, 32, 79, 117, 116, 32, 111, 102, 32, 102, 114, 101, 101, 32, 115, 112, 97, 99, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 112, 32, 58, 32, 77, 97, 108, 108, 111, 99, 40, 37, 108, 117, 41, 32, 79, 107, 10, 0, 0, 0, 0, 110, 111, 110, 101, 0, 0, 0, 0, 37, 112, 32, 58, 32, 82, 101, 97, 108, 108, 111, 99, 101, 100, 40, 37, 108, 117, 32, 45, 62, 32, 37, 108, 117, 41, 32, 79, 107, 10, 0, 0, 116, 114, 121, 105, 110, 103, 32, 116, 111, 32, 102, 114, 101, 101, 32, 112, 111, 105, 110, 116, 101, 114, 32, 102, 114, 111, 109, 32, 102, 114, 101, 101, 100, 32, 97, 114, 101, 97, 10, 0, 37, 112, 32, 58, 32, 70, 114, 101, 101, 100, 40, 41, 10, 0, 0, 0, 120, 109, 108, 77, 101, 109, 70, 114, 101, 101, 40, 37, 108, 88, 41, 32, 101, 114, 114, 111, 114, 10, 0, 0, 37, 112, 32, 58, 32, 83, 116, 114, 100, 117, 112, 40, 41, 32, 79, 107, 10, 0, 0, 0, 0, 0, 0, 0, 32, 32, 32, 32, 32, 32, 77, 69, 77, 79, 82, 89, 32, 65, 76, 76, 79, 67, 65, 84, 69, 68, 32, 58, 32, 37, 108, 117, 44, 32, 77, 65, 88, 32, 119, 97, 115, 32, 37, 108, 117, 10, 0, 0, 0, 0, 0, 0, 88, 77, 76, 95, 77, 69, 77, 95, 66, 82, 69, 65, 75, 80, 79, 73, 78, 84, 0, 0, 0, 0, 0, 0, 37, 117, 100, 0, 0, 0, 0, 0, 88, 77, 76, 95, 77, 69, 77, 95, 84, 82, 65, 67, 69, 0, 0, 0, 37, 112, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 116, 97, 103, 32, 101, 114, 114, 111, 114, 32, 111, 99, 99, 117, 114, 115, 32, 58, 37, 112, 32, 10, 9, 32, 98, 121, 101, 10, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 85, 82, 73, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 10, 0, 115, 97, 118, 105, 110, 103, 32, 85, 82, 73, 10, 0, 0, 0, 0, 0, 58, 37, 100, 0, 0, 0, 0, 0, 102, 105, 108, 101, 0, 0, 0, 0, 117, 110, 101, 115, 99, 97, 112, 105, 110, 103, 32, 85, 82, 73, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 101, 115, 99, 97, 112, 105, 110, 103, 32, 85, 82, 73, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 43, 45, 46, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 47, 63, 59, 58, 64, 0, 0, 0, 47, 47, 0, 0, 0, 0, 0, 0, 59, 58, 38, 61, 43, 36, 44, 0, 64, 0, 0, 0, 0, 0, 0, 0, 37, 100, 0, 0, 0, 0, 0, 0, 58, 64, 38, 61, 43, 36, 44, 47, 63, 59, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 59, 47, 63, 58, 64, 38, 61, 43, 44, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 114, 101, 115, 111, 108, 118, 105, 110, 103, 32, 85, 82, 73, 32, 97, 103, 97, 105, 110, 115, 116, 32, 98, 97, 115, 101, 10, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 47, 59, 38, 61, 43, 36, 44, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 114, 101, 108, 97, 116, 105, 118, 101, 32, 85, 82, 73, 10, 0, 0, 58, 47, 47, 0, 0, 0, 0, 0, 58, 47, 63, 95, 46, 35, 38, 59, 61, 0, 0, 0, 0, 0, 0, 0, 114, 101, 97, 99, 104, 105, 110, 103, 32, 97, 114, 98, 105, 116, 114, 97, 114, 121, 32, 77, 65, 88, 95, 85, 82, 73, 95, 76, 69, 78, 71, 84, 72, 32, 108, 105, 109, 105, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 67, 97, 110, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 97, 117, 116, 111, 109, 97, 116, 97, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 67, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 116, 101, 114, 109, 105, 110, 105, 115, 116, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 109, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 0, 120, 109, 108, 78, 101, 119, 69, 108, 101, 109, 101, 110, 116, 67, 111, 110, 116, 101, 110, 116, 32, 58, 32, 110, 97, 109, 101, 32, 61, 61, 32, 78, 85, 76, 76, 32, 33, 10, 0, 0, 120, 109, 108, 78, 101, 119, 69, 108, 101, 109, 101, 110, 116, 67, 111, 110, 116, 101, 110, 116, 32, 58, 32, 110, 97, 109, 101, 32, 33, 61, 32, 78, 85, 76, 76, 32, 33, 10, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 69, 76, 69, 77, 69, 78, 84, 32, 99, 111, 110, 116, 101, 110, 116, 32, 99, 111, 114, 114, 117, 112, 116, 101, 100, 32, 105, 110, 118, 97, 108, 105, 100, 32, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 0, 0, 32, 46, 46, 46, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 35, 80, 67, 68, 65, 84, 65, 0, 58, 0, 0, 0, 0, 0, 0, 0, 32, 44, 32, 0, 0, 0, 0, 0, 32, 124, 32, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 99, 111, 110, 116, 101, 110, 116, 32, 33, 61, 32, 78, 85, 76, 76, 32, 102, 111, 114, 32, 69, 77, 80, 84, 89, 10, 0, 0, 0, 120, 109, 108, 65, 100, 100, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 99, 111, 110, 116, 101, 110, 116, 32, 33, 61, 32, 78, 85, 76, 76, 32, 102, 111, 114, 32, 65, 78, 89, 10, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 99, 111, 110, 116, 101, 110, 116, 32, 61, 61, 32, 78, 85, 76, 76, 32, 102, 111, 114, 32, 77, 73, 88, 69, 68, 10, 0, 0, 0, 120, 109, 108, 65, 100, 100, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 99, 111, 110, 116, 101, 110, 116, 32, 61, 61, 32, 78, 85, 76, 76, 32, 102, 111, 114, 32, 69, 76, 69, 77, 69, 78, 84, 10, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 69, 76, 69, 77, 69, 78, 84, 32, 100, 101, 99, 108, 32, 99, 111, 114, 114, 117, 112, 116, 101, 100, 32, 105, 110, 118, 97, 108, 105, 100, 32, 116, 121, 112, 101, 10, 0, 0, 120, 109, 108, 65, 100, 100, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 58, 32, 84, 97, 98, 108, 101, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 0, 0, 82, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 60, 33, 69, 76, 69, 77, 69, 78, 84, 32, 0, 0, 0, 0, 0, 0, 32, 69, 77, 80, 84, 89, 62, 10, 0, 0, 0, 0, 0, 0, 0, 0, 32, 65, 78, 89, 62, 10, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 62, 10, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 69, 76, 69, 77, 69, 78, 84, 32, 115, 116, 114, 117, 99, 116, 32, 99, 111, 114, 114, 117, 112, 116, 101, 100, 32, 105, 110, 118, 97, 108, 105, 100, 32, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 65, 84, 84, 82, 73, 66, 85, 84, 69, 32, 115, 116, 114, 117, 99, 116, 32, 99, 111, 114, 114, 117, 112, 116, 101, 100, 32, 105, 110, 118, 97, 108, 105, 100, 32, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 100, 101, 102, 97, 117, 108, 116, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 65, 116, 116, 114, 105, 98, 117, 116, 101, 68, 101, 99, 108, 58, 32, 84, 97, 98, 108, 101, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 58, 32, 97, 108, 114, 101, 97, 100, 121, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 116, 111, 111, 32, 109, 97, 121, 32, 73, 68, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 100, 101, 102, 105, 110, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 60, 33, 65, 84, 84, 76, 73, 83, 84, 32, 0, 0, 0, 0, 0, 0, 32, 67, 68, 65, 84, 65, 0, 0, 32, 73, 68, 0, 0, 0, 0, 0, 32, 73, 68, 82, 69, 70, 0, 0, 32, 73, 68, 82, 69, 70, 83, 0, 32, 69, 78, 84, 73, 84, 89, 0, 32, 69, 78, 84, 73, 84, 73, 69, 83, 0, 0, 0, 0, 0, 0, 0, 32, 78, 77, 84, 79, 75, 69, 78, 0, 0, 0, 0, 0, 0, 0, 0, 32, 78, 77, 84, 79, 75, 69, 78, 83, 0, 0, 0, 0, 0, 0, 0, 32, 40, 0, 0, 0, 0, 0, 0, 32, 78, 79, 84, 65, 84, 73, 79, 78, 32, 40, 0, 0, 0, 0, 0, 32, 35, 82, 69, 81, 85, 73, 82, 69, 68, 0, 0, 0, 0, 0, 0, 32, 35, 73, 77, 80, 76, 73, 69, 68, 0, 0, 0, 0, 0, 0, 0, 32, 35, 70, 73, 88, 69, 68, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 65, 84, 84, 82, 73, 66, 85, 84, 69, 32, 115, 116, 114, 117, 99, 116, 32, 99, 111, 114, 114, 117, 112, 116, 101, 100, 32, 105, 110, 118, 97, 108, 105, 100, 32, 100, 101, 102, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 78, 111, 116, 97, 116, 105, 111, 110, 68, 101, 99, 108, 58, 32, 84, 97, 98, 108, 101, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 78, 111, 116, 97, 116, 105, 111, 110, 68, 101, 99, 108, 58, 32, 37, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 60, 33, 78, 79, 84, 65, 84, 73, 79, 78, 32, 0, 0, 0, 0, 0, 32, 80, 85, 66, 76, 73, 67, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 83, 89, 83, 84, 69, 77, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 62, 10, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 73, 68, 58, 32, 84, 97, 98, 108, 101, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 0, 0, 0, 73, 68, 32, 37, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 82, 101, 102, 58, 32, 84, 97, 98, 108, 101, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 82, 101, 102, 58, 32, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 108, 105, 115, 116, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 0, 120, 109, 108, 65, 100, 100, 82, 101, 102, 58, 32, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 108, 105, 115, 116, 32, 105, 110, 115, 101, 114, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 33, 10, 0, 0, 0, 0, 78, 79, 84, 65, 84, 73, 79, 78, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 99, 108, 97, 114, 101, 100, 10, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 58, 32, 37, 115, 32, 111, 110, 32, 37, 115, 32, 118, 97, 108, 117, 101, 32, 104, 97, 100, 32, 116, 111, 32, 98, 101, 32, 110, 111, 114, 109, 97, 108, 105, 122, 101, 100, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 10, 0, 0, 0, 83, 121, 110, 116, 97, 120, 32, 111, 102, 32, 100, 101, 102, 97, 117, 108, 116, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 10, 0, 0, 0, 0, 73, 68, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 32, 109, 117, 115, 116, 32, 98, 101, 32, 35, 73, 77, 80, 76, 73, 69, 68, 32, 111, 114, 32, 35, 82, 69, 81, 85, 73, 82, 69, 68, 10, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 37, 100, 32, 73, 68, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 37, 100, 32, 73, 68, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 73, 68, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 97, 110, 100, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 58, 32, 37, 115, 10, 0, 0, 68, 101, 102, 97, 117, 108, 116, 32, 118, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 68, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 37, 115, 32, 104, 97, 115, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 111, 102, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 68, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 37, 115, 32, 104, 97, 115, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 111, 102, 32, 37, 115, 58, 37, 115, 10, 0, 0, 0, 0, 0, 68, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 37, 115, 32, 104, 97, 115, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 116, 111, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 68, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 37, 115, 32, 104, 97, 115, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 116, 111, 32, 37, 115, 58, 37, 115, 10, 0, 0, 0, 0, 0, 78, 111, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 83, 121, 110, 116, 97, 120, 32, 111, 102, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 10, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 102, 114, 111, 109, 32, 100, 101, 102, 97, 117, 108, 116, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 78, 111, 116, 97, 116, 105, 111, 110, 10, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 110, 111, 116, 97, 116, 105, 111, 110, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 102, 32, 37, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 86, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 78, 111, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 78, 111, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 83, 121, 110, 116, 97, 120, 32, 111, 102, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 10, 0, 0, 0, 0, 0, 0, 83, 121, 110, 116, 97, 120, 32, 111, 102, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 10, 0, 86, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 102, 114, 111, 109, 32, 100, 101, 102, 97, 117, 108, 116, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 102, 114, 111, 109, 32, 100, 101, 102, 97, 117, 108, 116, 32, 34, 37, 115, 34, 10, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 78, 111, 116, 97, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 78, 111, 116, 97, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 110, 111, 116, 97, 116, 105, 111, 110, 115, 10, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 110, 111, 116, 97, 116, 105, 111, 110, 115, 10, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 34, 37, 115, 34, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 115, 101, 116, 10, 0, 0, 0, 86, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 58, 37, 115, 32, 111, 102, 32, 37, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 120, 109, 108, 110, 115, 32, 111, 102, 32, 37, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 34, 37, 115, 34, 10, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 119, 97, 115, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 69, 77, 80, 84, 89, 32, 116, 104, 105, 115, 32, 111, 110, 101, 32, 104, 97, 115, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 119, 97, 115, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 35, 80, 67, 68, 65, 84, 65, 32, 98, 117, 116, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 110, 111, 110, 32, 116, 101, 120, 116, 32, 110, 111, 100, 101, 115, 10, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 105, 110, 32, 37, 115, 32, 108, 105, 115, 116, 32, 111, 102, 32, 112, 111, 115, 115, 105, 98, 108, 101, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 44, 32, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 44, 32, 84, 101, 120, 116, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 10, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 44, 32, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 109, 111, 114, 101, 32, 99, 104, 105, 108, 100, 10, 0, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 84, 101, 120, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 99, 104, 105, 108, 100, 114, 101, 110, 32, 33, 10, 0, 0, 0, 0, 84, 101, 120, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 33, 10, 0, 0, 0, 84, 101, 120, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 32, 33, 10, 0, 0, 69, 110, 116, 105, 116, 121, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 0, 78, 111, 116, 97, 116, 105, 111, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 68, 111, 99, 117, 109, 101, 110, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 72, 84, 77, 76, 32, 68, 111, 99, 117, 109, 101, 110, 116, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 0, 0, 117, 110, 107, 110, 111, 119, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 116, 121, 112, 101, 10, 0, 0, 0, 78, 111, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 77, 73, 88, 69, 68, 32, 115, 116, 114, 117, 99, 116, 32, 99, 111, 114, 114, 117, 112, 116, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 58, 32, 37, 115, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 119, 104, 105, 116, 101, 32, 115, 112, 97, 99, 101, 115, 32, 110, 111, 100, 101, 115, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 99, 97, 114, 114, 121, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 10, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 99, 97, 114, 114, 121, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 58, 37, 115, 10, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 58, 37, 115, 32, 104, 97, 115, 32, 110, 111, 32, 112, 114, 101, 102, 105, 120, 10, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 58, 37, 115, 32, 104, 97, 115, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 112, 114, 101, 102, 105, 120, 10, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 97, 109, 101, 32, 102, 111, 114, 32, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 68, 84, 68, 10, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 97, 109, 101, 32, 102, 111, 114, 32, 37, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 68, 84, 68, 10, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 32, 114, 111, 111, 116, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 72, 84, 77, 76, 0, 0, 0, 0, 104, 116, 109, 108, 0, 0, 0, 0, 114, 111, 111, 116, 32, 97, 110, 100, 32, 68, 84, 68, 32, 110, 97, 109, 101, 32, 100, 111, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 39, 37, 115, 39, 32, 97, 110, 100, 32, 39, 37, 115, 39, 10, 0, 0, 0, 120, 109, 108, 86, 97, 108, 105, 100, 97, 116, 101, 68, 111, 99, 117, 109, 101, 110, 116, 70, 105, 110, 97, 108, 58, 32, 100, 111, 99, 32, 61, 61, 32, 78, 85, 76, 76, 10, 0, 0, 110, 111, 32, 68, 84, 68, 32, 102, 111, 117, 110, 100, 33, 10, 0, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 117, 105, 108, 100, 32, 85, 82, 73, 32, 102, 111, 114, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 34, 37, 115, 34, 10, 0, 0, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 108, 111, 97, 100, 32, 116, 104, 101, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 0, 0, 60, 33, 100, 117, 109, 109, 121, 63, 62, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 86, 97, 108, 105, 100, 97, 116, 101, 65, 116, 116, 114, 105, 98, 117, 116, 101, 67, 97, 108, 108, 98, 97, 99, 107, 40, 37, 115, 41, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 58, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 100, 101, 99, 108, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 78, 79, 84, 65, 84, 73, 79, 78, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 102, 111, 114, 32, 69, 77, 80, 84, 89, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 108, 105, 110, 101, 32, 37, 100, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 97, 110, 32, 117, 110, 107, 110, 111, 119, 110, 32, 73, 68, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 73, 68, 82, 69, 70, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 97, 110, 32, 117, 110, 107, 110, 111, 119, 110, 32, 73, 68, 32, 34, 37, 115, 34], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 74608);
	        allocate([10, 0, 0, 0, 0, 0, 0, 0, 73, 68, 82, 69, 70, 83, 32, 115, 112, 108, 105, 116, 0, 0, 0, 0, 73, 68, 82, 69, 70, 83, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 97, 110, 32, 117, 110, 107, 110, 111, 119, 110, 32, 73, 68, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 44, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 37, 115, 44, 32, 103, 111, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 44, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 37, 115, 44, 32, 103, 111, 116, 32, 37, 115, 10, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 101, 32, 68, 84, 68, 10, 0, 0, 0, 0, 0, 0, 0, 0, 67, 68, 65, 84, 65, 0, 0, 0, 63, 63, 63, 0, 0, 0, 0, 0, 114, 101, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 98, 117, 105, 108, 100, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 32, 114, 101, 103, 101, 120, 112, 32, 102, 111, 114, 32, 37, 115, 10, 0, 0, 0, 0, 69, 78, 84, 73, 84, 89, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 97, 110, 32, 117, 110, 107, 110, 111, 119, 110, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 10, 0, 0, 0, 69, 78, 84, 73, 84, 89, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 97, 110, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 32, 111, 102, 32, 119, 114, 111, 110, 103, 32, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 69, 78, 84, 73, 84, 73, 69, 83, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 97, 110, 32, 117, 110, 107, 110, 111, 119, 110, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 10, 0, 69, 78, 84, 73, 84, 73, 69, 83, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 97, 110, 32, 101, 110, 116, 105, 116, 121, 32, 34, 37, 115, 34, 32, 111, 102, 32, 119, 114, 111, 110, 103, 32, 116, 121, 112, 101, 10, 0, 0, 0, 78, 79, 84, 65, 84, 73, 79, 78, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 97, 110, 32, 117, 110, 107, 110, 111, 119, 110, 32, 110, 111, 116, 97, 116, 105, 111, 110, 32, 34, 37, 115, 34, 10, 0, 0, 0, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 116, 97, 98, 108, 101, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 116, 111, 111, 32, 109, 97, 110, 121, 32, 73, 68, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 100, 101, 102, 105, 110, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 78, 85, 76, 76, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 110, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 32, 111, 102, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 80, 67, 68, 65, 84, 65, 32, 105, 110, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 32, 111, 102, 32, 37, 115, 10, 0, 0, 0, 0, 66, 117, 105, 108, 100, 105, 110, 103, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 0, 0, 67, 111, 110, 116, 101, 110, 116, 77, 111, 100, 101, 108, 32, 98, 114, 111, 107, 101, 110, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 121, 1, 0, 200, 121, 1, 0, 176, 119, 1, 0, 136, 197, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 208, 192, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 240, 201, 1, 0, 216, 191, 1, 0, 56, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 168, 117, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 216, 119, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 160, 117, 1, 0, 168, 117, 1, 0, 24, 115, 1, 0, 208, 119, 1, 0, 216, 119, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 0, 120, 1, 0, 168, 117, 1, 0, 24, 115, 1, 0, 208, 119, 1, 0, 216, 119, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 48, 122, 1, 0, 176, 119, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 208, 192, 1, 0, 56, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 168, 117, 1, 0, 48, 122, 1, 0, 0, 0, 0, 0, 136, 197, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 208, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 216, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 224, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 232, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 240, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 248, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 216, 191, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 56, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 24, 212, 1, 0, 0, 0, 0, 0, 80, 122, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 24, 212, 1, 0, 0, 0, 0, 0, 40, 216, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 48, 216, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 96, 121, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 208, 192, 1, 0, 176, 119, 1, 0, 176, 121, 1, 0, 240, 201, 1, 0, 216, 191, 1, 0, 56, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 176, 121, 1, 0, 176, 119, 1, 0, 240, 201, 1, 0, 216, 191, 1, 0, 56, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 168, 117, 1, 0, 152, 121, 1, 0, 0, 0, 0, 0, 152, 121, 1, 0, 176, 119, 1, 0, 240, 201, 1, 0, 216, 191, 1, 0, 56, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 168, 117, 1, 0, 176, 121, 1, 0, 0, 0, 0, 0, 24, 212, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 112, 205, 1, 0, 240, 201, 1, 0, 216, 191, 1, 0, 56, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 0, 0, 0, 0, 112, 205, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 24, 212, 1, 0, 0, 0, 0, 0, 240, 201, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 24, 212, 1, 0, 0, 0, 0, 0, 176, 119, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 0, 0, 0, 0, 96, 118, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 56, 122, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 128, 121, 1, 0, 192, 121, 1, 0, 72, 121, 1, 0, 0, 122, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 32, 121, 1, 0, 32, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 120, 121, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 32, 191, 1, 0, 120, 121, 1, 0, 32, 191, 1, 0, 176, 190, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 176, 190, 1, 0, 120, 121, 1, 0, 176, 190, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 152, 118, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 32, 121, 1, 0, 0, 0, 0, 0, 112, 118, 1, 0, 112, 118, 1, 0, 104, 118, 1, 0, 176, 119, 1, 0, 120, 122, 1, 0, 192, 121, 1, 0, 32, 121, 1, 0, 72, 121, 1, 0, 0, 122, 1, 0, 152, 122, 1, 0, 0, 0, 0, 0, 104, 118, 1, 0, 112, 118, 1, 0, 104, 118, 1, 0, 176, 119, 1, 0, 120, 122, 1, 0, 192, 121, 1, 0, 32, 121, 1, 0, 72, 121, 1, 0, 0, 122, 1, 0, 152, 122, 1, 0, 0, 0, 0, 0, 120, 118, 1, 0, 112, 118, 1, 0, 104, 118, 1, 0, 120, 118, 1, 0, 120, 121, 1, 0, 176, 190, 1, 0, 32, 191, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 128, 118, 1, 0, 120, 121, 1, 0, 176, 190, 1, 0, 32, 191, 1, 0, 0, 0, 0, 0, 144, 118, 1, 0, 112, 118, 1, 0, 104, 118, 1, 0, 120, 118, 1, 0, 120, 121, 1, 0, 176, 190, 1, 0, 32, 191, 1, 0, 128, 118, 1, 0, 136, 118, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 136, 118, 1, 0, 112, 118, 1, 0, 104, 118, 1, 0, 120, 118, 1, 0, 120, 121, 1, 0, 176, 190, 1, 0, 32, 191, 1, 0, 128, 118, 1, 0, 144, 118, 1, 0, 136, 118, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 160, 205, 1, 0, 200, 205, 1, 0, 0, 0, 0, 0, 200, 205, 1, 0, 200, 205, 1, 0, 0, 0, 0, 0, 184, 193, 1, 0, 40, 122, 1, 0, 176, 119, 1, 0, 168, 117, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 80, 122, 1, 0, 40, 216, 1, 0, 48, 216, 1, 0, 32, 121, 1, 0, 0, 0, 0, 0, 144, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 0, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 72, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 152, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 96, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 128, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 88, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 112, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 184, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 136, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 168, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 144, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 104, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 24, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 160, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 136, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 40, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 48, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 112, 198, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 192, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 168, 189, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 96, 201, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 88, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 104, 177, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 144, 177, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 120, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 80, 121, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 8, 122, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 32, 182, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 200, 182, 1, 0, 64, 183, 1, 0, 0, 0, 0, 0, 40, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 72, 183, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 160, 183, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 183, 1, 0, 192, 183, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 121, 1, 0, 0, 0, 0, 0, 1, 1, 2, 0, 104, 184, 1, 0, 120, 184, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 185, 1, 0, 0, 0, 0, 0, 184, 185, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 192, 185, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 185, 1, 0, 64, 183, 1, 0, 8, 186, 1, 0, 72, 121, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 16, 186, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 119, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 32, 186, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 183, 1, 0, 56, 186, 1, 0, 64, 186, 1, 0, 0, 2, 2, 1, 1, 1, 1, 0, 80, 186, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 186, 1, 0, 0, 0, 0, 0, 80, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 120, 186, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 144, 186, 1, 0, 0, 0, 0, 0, 176, 186, 1, 0, 88, 121, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 184, 186, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 186, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 224, 187, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 117, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 40, 188, 1, 0, 56, 188, 1, 0, 96, 118, 1, 0, 64, 189, 1, 0, 136, 189, 1, 0, 0, 0, 0, 0, 168, 189, 1, 0, 0, 2, 2, 1, 0, 0, 1, 0, 176, 189, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 189, 1, 0, 224, 189, 1, 0, 0, 0, 0, 0, 112, 121, 1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 232, 189, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 248, 189, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 190, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 121, 1, 0, 0, 3, 0, 0, 1, 1, 0, 0, 104, 190, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 136, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 136, 190, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 152, 190, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 190, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 184, 190, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 190, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 191, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 48, 191, 1, 0, 72, 191, 1, 0, 176, 190, 1, 0, 200, 190, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 121, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 80, 191, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 121, 1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 104, 191, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 120, 191, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 121, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 192, 191, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 191, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 224, 191, 1, 0, 240, 191, 1, 0, 48, 122, 1, 0, 0, 0, 0, 0, 88, 192, 1, 0, 0, 0, 0, 0, 96, 118, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 192, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 208, 192, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 192, 1, 0, 240, 192, 1, 0, 152, 121, 1, 0, 96, 183, 1, 0, 0, 193, 1, 0, 0, 0, 0, 0, 176, 121, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 8, 193, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 121, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 32, 193, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 193, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 56, 193, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 193, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 193, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 193, 1, 0, 224, 193, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 121, 1, 0, 0, 3, 0, 0, 1, 1, 1, 0, 224, 194, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 194, 1, 0, 0, 0, 0, 0, 200, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 195, 1, 0, 56, 195, 1, 0, 184, 193, 1, 0, 48, 196, 1, 0, 64, 183, 1, 0, 144, 196, 1, 0, 248, 119, 1, 0, 0, 2, 2, 1, 0, 2, 0, 0, 152, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 196, 1, 0, 0, 0, 0, 0, 0, 120, 1, 0, 0, 0, 0, 0, 0, 2, 0, 0, 224, 196, 1, 0, 248, 196, 1, 0, 232, 119, 1, 0, 0, 0, 0, 0, 8, 197, 1, 0, 0, 0, 0, 0, 208, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 197, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 216, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 197, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 224, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 197, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 232, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 197, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 240, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 197, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 248, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 197, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 168, 117, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 64, 197, 1, 0, 80, 197, 1, 0, 0, 0, 0, 0, 120, 197, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 197, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 144, 197, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 183, 1, 0, 168, 197, 1, 0, 0, 0, 0, 0, 32, 112, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 192, 197, 1, 0, 216, 197, 1, 0, 0, 0, 0, 0, 232, 197, 1, 0, 248, 197, 1, 0, 0, 0, 0, 0, 0, 122, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 198, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 122, 1, 0, 0, 0, 0, 0, 0, 1, 2, 0, 24, 198, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 198, 1, 0, 0, 0, 0, 0, 112, 198, 1, 0, 0, 2, 2, 1, 0, 0, 1, 0, 120, 198, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 198, 1, 0, 200, 192, 1, 0, 224, 198, 1, 0, 240, 198, 1, 0, 0, 2, 2, 1, 0, 0, 1, 0, 248, 198, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 199, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 16, 122, 1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 152, 199, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 120, 191, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 199, 1, 0, 0, 2, 2, 1, 1, 1, 0, 0, 176, 199, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 199, 1, 0, 0, 0, 0, 0, 24, 122, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 232, 199, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 122, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 8, 200, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 32, 200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 122, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 200, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 136, 200, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 48, 122, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 208, 200, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 119, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 224, 200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 1, 0, 64, 183, 1, 0, 0, 0, 0, 0, 96, 201, 1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 104, 201, 1, 0, 128, 201, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 232, 201, 1, 0, 240, 201, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 248, 201, 1, 0, 240, 191, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 192, 1, 0, 0, 0, 0, 0, 200, 119, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 8, 202, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 202, 1, 0, 0, 0, 0, 0, 72, 202, 1, 0, 232, 119, 1, 0, 0, 0, 0, 0, 0, 2, 0, 0, 80, 202, 1, 0, 144, 202, 1, 0, 160, 117, 1, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 122, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 203, 1, 0, 224, 186, 1, 0, 96, 118, 1, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 122, 1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 56, 193, 1, 0, 216, 203, 1, 0, 96, 118, 1, 0, 224, 204, 1, 0, 88, 205, 1, 0, 0, 0, 0, 0, 112, 205, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 205, 1, 0, 136, 205, 1, 0, 48, 122, 1, 0, 96, 183, 1, 0, 144, 205, 1, 0, 0, 0, 0, 0, 160, 205, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 205, 1, 0, 192, 205, 1, 0, 200, 205, 1, 0, 208, 205, 1, 0, 0, 0, 0, 0, 24, 206, 1, 0, 200, 205, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 32, 206, 1, 0, 56, 206, 1, 0, 0, 0, 0, 0, 64, 206, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 119, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 144, 206, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 200, 192, 1, 0, 0, 0, 0, 0, 160, 206, 1, 0, 0, 2, 2, 1, 0, 0, 0, 0, 168, 206, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 206, 1, 0, 0, 0, 0, 0, 232, 201, 1, 0, 80, 122, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 206, 1, 0, 240, 206, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 88, 207, 1, 0, 0, 0, 0, 0, 88, 122, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 96, 207, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 224, 187, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 122, 1, 0, 0, 3, 0, 0, 1, 1, 1, 0, 120, 207, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 104, 122, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 152, 207, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 115, 1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 192, 207, 1, 0, 56, 206, 1, 0, 0, 0, 0, 0, 216, 207, 1, 0, 240, 207, 1, 0, 248, 207, 1, 0, 0, 208, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 8, 208, 1, 0, 32, 208, 1, 0, 0, 0, 0, 0, 48, 208, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 122, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 144, 208, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 122, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 168, 208, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 122, 1, 0, 0, 3, 0, 0, 1, 1, 1, 0, 208, 208, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 136, 122, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 232, 208, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 115, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 208, 1, 0, 56, 206, 1, 0, 0, 0, 0, 0, 8, 209, 1, 0, 0, 0, 0, 0, 248, 207, 1, 0, 104, 177, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 32, 209, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 177, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 48, 209, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 118, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 183, 1, 0, 64, 209, 1, 0, 120, 118, 1, 0, 96, 209, 1, 0, 192, 209, 1, 0, 0, 0, 0, 0, 136, 118, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 208, 209, 1, 0, 224, 209, 1, 0, 120, 118, 1, 0, 232, 209, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 118, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 210, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 72, 210, 1, 0, 176, 210, 1, 0, 0, 0, 0, 0, 200, 210, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 216, 210, 1, 0, 56, 206, 1, 0, 0, 0, 0, 0, 240, 210, 1, 0, 0, 0, 0, 0, 88, 211, 1, 0, 144, 118, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 104, 211, 1, 0, 224, 209, 1, 0, 120, 118, 1, 0, 232, 209, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 118, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 120, 211, 1, 0, 224, 186, 1, 0, 0, 0, 0, 0, 72, 210, 1, 0, 176, 210, 1, 0, 0, 0, 0, 0, 128, 118, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 144, 211, 1, 0, 224, 209, 1, 0, 120, 118, 1, 0, 232, 209, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 119, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 211, 1, 0, 56, 206, 1, 0, 0, 0, 0, 0, 232, 197, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 118, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 211, 1, 0, 192, 211, 1, 0, 104, 118, 1, 0, 232, 209, 1, 0, 208, 211, 1, 0, 0, 0, 0, 0, 144, 122, 1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 216, 211, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 122, 1, 0, 0, 3, 0, 0, 1, 1, 1, 0, 0, 212, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 24, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 212, 1, 0, 136, 205, 1, 0, 48, 122, 1, 0, 96, 183, 1, 0, 48, 212, 1, 0, 0, 0, 0, 0, 160, 122, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 64, 212, 1, 0, 40, 182, 1, 0, 0, 0, 0, 0, 96, 183, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0, 56, 127, 1, 0, 64, 127, 1, 0, 38, 0, 0, 0, 112, 127, 1, 0, 120, 127, 1, 0, 39, 0, 0, 0, 152, 127, 1, 0, 160, 127, 1, 0, 60, 0, 0, 0, 176, 127, 1, 0, 184, 127, 1, 0, 62, 0, 0, 0, 216, 127, 1, 0, 224, 127, 1, 0, 160, 0, 0, 0, 8, 128, 1, 0, 16, 128, 1, 0, 161, 0, 0, 0, 72, 128, 1, 0, 80, 128, 1, 0, 162, 0, 0, 0, 128, 128, 1, 0, 136, 128, 1, 0, 163, 0, 0, 0, 168, 128, 1, 0, 176, 128, 1, 0, 164, 0, 0, 0, 208, 128, 1, 0, 216, 128, 1, 0, 165, 0, 0, 0, 248, 128, 1, 0, 0, 129, 1, 0, 166, 0, 0, 0, 40, 129, 1, 0, 48, 129, 1, 0, 167, 0, 0, 0, 96, 129, 1, 0, 104, 129, 1, 0, 168, 0, 0, 0, 136, 129, 1, 0, 144, 129, 1, 0, 169, 0, 0, 0, 192, 129, 1, 0, 200, 129, 1, 0, 170, 0, 0, 0, 232, 129, 1, 0, 240, 129, 1, 0, 171, 0, 0, 0, 32, 130, 1, 0, 40, 130, 1, 0, 172, 0, 0, 0, 128, 130, 1, 0, 136, 130, 1, 0, 173, 0, 0, 0, 160, 130, 1, 0, 168, 130, 1, 0, 174, 0, 0, 0, 224, 130, 1, 0, 232, 130, 1, 0, 175, 0, 0, 0, 40, 131, 1, 0, 48, 131, 1, 0, 176, 0, 0, 0, 112, 131, 1, 0, 120, 131, 1, 0, 177, 0, 0, 0, 152, 131, 1, 0, 160, 131, 1, 0, 178, 0, 0, 0, 216, 131, 1, 0, 224, 131, 1, 0, 179, 0, 0, 0, 40, 132, 1, 0, 48, 132, 1, 0, 180, 0, 0, 0, 120, 132, 1, 0, 128, 132, 1, 0, 181, 0, 0, 0, 176, 132, 1, 0, 184, 132, 1, 0, 182, 0, 0, 0, 216, 132, 1, 0, 224, 132, 1, 0, 183, 0, 0, 0, 16, 133, 1, 0, 24, 133, 1, 0, 184, 0, 0, 0, 88, 133, 1, 0, 96, 133, 1, 0, 185, 0, 0, 0, 144, 133, 1, 0, 152, 133, 1, 0, 186, 0, 0, 0, 208, 133, 1, 0, 216, 133, 1, 0, 187, 0, 0, 0, 8, 134, 1, 0, 16, 134, 1, 0, 188, 0, 0, 0, 104, 134, 1, 0, 112, 134, 1, 0, 189, 0, 0, 0, 184, 134, 1, 0, 192, 134, 1, 0, 190, 0, 0, 0, 0, 135, 1, 0, 8, 135, 1, 0, 191, 0, 0, 0, 80, 135, 1, 0, 88, 135, 1, 0, 192, 0, 0, 0, 152, 135, 1, 0, 160, 135, 1, 0, 193, 0, 0, 0, 248, 135, 1, 0, 0, 136, 1, 0, 194, 0, 0, 0, 56, 136, 1, 0, 64, 136, 1, 0, 195, 0, 0, 0, 120, 136, 1, 0, 128, 136, 1, 0, 196, 0, 0, 0, 184, 136, 1, 0, 192, 136, 1, 0, 197, 0, 0, 0, 248, 136, 1, 0, 0, 137, 1, 0, 198, 0, 0, 0, 88, 137, 1, 0, 96, 137, 1, 0, 199, 0, 0, 0, 168, 137, 1, 0, 176, 137, 1, 0, 200, 0, 0, 0, 232, 137, 1, 0, 240, 137, 1, 0, 201, 0, 0, 0, 40, 138, 1, 0, 48, 138, 1, 0, 202, 0, 0, 0, 104, 138, 1, 0, 112, 138, 1, 0, 203, 0, 0, 0, 168, 138, 1, 0, 176, 138, 1, 0, 204, 0, 0, 0, 232, 138, 1, 0, 240, 138, 1, 0, 205, 0, 0, 0, 40, 139, 1, 0, 48, 139, 1, 0, 206, 0, 0, 0, 104, 139, 1, 0, 112, 139, 1, 0, 207, 0, 0, 0, 168, 139, 1, 0, 176, 139, 1, 0, 208, 0, 0, 0, 232, 139, 1, 0, 240, 139, 1, 0, 209, 0, 0, 0, 32, 140, 1, 0, 40, 140, 1, 0, 210, 0, 0, 0, 96, 140, 1, 0, 104, 140, 1, 0, 211, 0, 0, 0, 160, 140, 1, 0, 168, 140, 1, 0, 212, 0, 0, 0, 224, 140, 1, 0, 232, 140, 1, 0, 213, 0, 0, 0, 32, 141, 1, 0, 40, 141, 1, 0, 214, 0, 0, 0, 96, 141, 1, 0, 104, 141, 1, 0, 215, 0, 0, 0, 160, 141, 1, 0, 168, 141, 1, 0, 216, 0, 0, 0, 208, 141, 1, 0, 216, 141, 1, 0, 217, 0, 0, 0, 40, 142, 1, 0, 48, 142, 1, 0, 218, 0, 0, 0, 104, 142, 1, 0, 112, 142, 1, 0, 219, 0, 0, 0, 168, 142, 1, 0, 176, 142, 1, 0, 220, 0, 0, 0, 232, 142, 1, 0, 240, 142, 1, 0, 221, 0, 0, 0, 40, 143, 1, 0, 48, 143, 1, 0, 222, 0, 0, 0, 104, 143, 1, 0, 112, 143, 1, 0, 223, 0, 0, 0, 160, 143, 1, 0, 168, 143, 1, 0, 224, 0, 0, 0, 224, 143, 1, 0, 232, 143, 1, 0, 225, 0, 0, 0, 56, 144, 1, 0, 64, 144, 1, 0, 226, 0, 0, 0, 112, 144, 1, 0, 120, 144, 1, 0, 227, 0, 0, 0, 176, 144, 1, 0, 184, 144, 1, 0, 228, 0, 0, 0, 232, 144, 1, 0, 240, 144, 1, 0, 229, 0, 0, 0, 40, 145, 1, 0, 48, 145, 1, 0, 230, 0, 0, 0, 136, 145, 1, 0, 144, 145, 1, 0, 231, 0, 0, 0, 208, 145, 1, 0, 216, 145, 1, 0, 232, 0, 0, 0, 16, 146, 1, 0, 24, 146, 1, 0, 233, 0, 0, 0, 72, 146, 1, 0, 80, 146, 1, 0, 234, 0, 0, 0, 128, 146, 1, 0, 136, 146, 1, 0, 235, 0, 0, 0, 192, 146, 1, 0, 200, 146, 1, 0, 236, 0, 0, 0, 0, 147, 1, 0, 8, 147, 1, 0, 237, 0, 0, 0, 56, 147, 1, 0, 64, 147, 1, 0, 238, 0, 0, 0, 112, 147, 1, 0, 120, 147, 1, 0, 239, 0, 0, 0, 176, 147, 1, 0, 184, 147, 1, 0, 240, 0, 0, 0, 240, 147, 1, 0, 248, 147, 1, 0, 241, 0, 0, 0, 32, 148, 1, 0, 40, 148, 1, 0, 242, 0, 0, 0, 88, 148, 1, 0, 96, 148, 1, 0, 243, 0, 0, 0, 144, 148, 1, 0, 152, 148, 1, 0, 244, 0, 0, 0, 200, 148, 1, 0, 208, 148, 1, 0, 245, 0, 0, 0, 8, 149, 1, 0, 16, 149, 1, 0, 246, 0, 0, 0, 64, 149, 1, 0, 72, 149, 1, 0, 247, 0, 0, 0, 128, 149, 1, 0, 136, 149, 1, 0, 248, 0, 0, 0, 168, 149, 1, 0, 176, 149, 1, 0, 249, 0, 0, 0, 0, 150, 1, 0, 8, 150, 1, 0, 250, 0, 0, 0, 56, 150, 1, 0, 64, 150, 1, 0, 251, 0, 0, 0, 112, 150, 1, 0, 120, 150, 1, 0, 252, 0, 0, 0, 176, 150, 1, 0, 184, 150, 1, 0, 253, 0, 0, 0, 240, 150, 1, 0, 248, 150, 1, 0, 254, 0, 0, 0, 40, 151, 1, 0, 48, 151, 1, 0, 255, 0, 0, 0, 96, 151, 1, 0, 104, 151, 1, 0, 82, 1, 0, 0, 160, 151, 1, 0, 168, 151, 1, 0, 83, 1, 0, 0, 216, 151, 1, 0, 224, 151, 1, 0, 96, 1, 0, 0, 8, 152, 1, 0, 16, 152, 1, 0, 97, 1, 0, 0, 72, 152, 1, 0, 80, 152, 1, 0, 120, 1, 0, 0, 128, 152, 1, 0, 136, 152, 1, 0, 146, 1, 0, 0, 192, 152, 1, 0, 200, 152, 1, 0, 198, 2, 0, 0, 8, 153, 1, 0, 16, 153, 1, 0, 220, 2, 0, 0, 72, 153, 1, 0, 80, 153, 1, 0, 145, 3, 0, 0, 112, 153, 1, 0, 120, 153, 1, 0, 146, 3, 0, 0, 160, 153, 1, 0, 168, 153, 1, 0, 147, 3, 0, 0, 208, 153, 1, 0, 216, 153, 1, 0, 148, 3, 0, 0, 8, 154, 1, 0, 16, 154, 1, 0, 149, 3, 0, 0, 64, 154, 1, 0, 72, 154, 1, 0, 150, 3, 0, 0, 112, 154, 1, 0, 120, 154, 1, 0, 151, 3, 0, 0, 160, 154, 1, 0, 168, 154, 1, 0, 152, 3, 0, 0, 208, 154, 1, 0, 216, 154, 1, 0, 153, 3, 0, 0, 8, 155, 1, 0, 16, 155, 1, 0, 154, 3, 0, 0, 56, 155, 1, 0, 64, 155, 1, 0, 155, 3, 0, 0, 104, 155, 1, 0, 112, 155, 1, 0, 156, 3, 0, 0, 160, 155, 1, 0, 168, 155, 1, 0, 157, 3, 0, 0, 200, 155, 1, 0, 208, 155, 1, 0, 158, 3, 0, 0, 240, 155, 1, 0, 248, 155, 1, 0, 159, 3, 0, 0, 32, 156, 1, 0, 40, 156, 1, 0, 160, 3, 0, 0, 80, 156, 1, 0, 88, 156, 1, 0, 161, 3, 0, 0, 128, 156, 1, 0, 136, 156, 1, 0, 163, 3, 0, 0, 176, 156, 1, 0, 184, 156, 1, 0, 164, 3, 0, 0, 232, 156, 1, 0, 240, 156, 1, 0, 165, 3, 0, 0, 24, 157, 1, 0, 32, 157, 1, 0, 166, 3, 0, 0, 80, 157, 1, 0, 88, 157, 1, 0, 167, 3, 0, 0, 136, 157, 1, 0, 144, 157, 1, 0, 168, 3, 0, 0, 184, 157, 1, 0, 192, 157, 1, 0, 169, 3, 0, 0, 240, 157, 1, 0, 248, 157, 1, 0, 177, 3, 0, 0, 40, 158, 1, 0, 48, 158, 1, 0, 178, 3, 0, 0, 96, 158, 1, 0, 104, 158, 1, 0, 179, 3, 0, 0, 144, 158, 1, 0, 152, 158, 1, 0, 180, 3, 0, 0, 200, 158, 1, 0, 208, 158, 1, 0, 181, 3, 0, 0, 0, 159, 1, 0, 8, 159, 1, 0, 182, 3, 0, 0, 56, 159, 1, 0, 64, 159, 1, 0, 183, 3, 0, 0, 104, 159, 1, 0, 112, 159, 1, 0, 184, 3, 0, 0, 152, 159, 1, 0, 160, 159, 1, 0, 185, 3, 0, 0, 208, 159, 1, 0, 216, 159, 1, 0, 186, 3, 0, 0, 0, 160, 1, 0, 8, 160, 1, 0, 187, 3, 0, 0, 56, 160, 1, 0, 64, 160, 1, 0, 188, 3, 0, 0, 112, 160, 1, 0, 120, 160, 1, 0, 189, 3, 0, 0, 160, 160, 1, 0, 168, 160, 1, 0, 190, 3, 0, 0, 208, 160, 1, 0, 216, 160, 1, 0, 191, 3, 0, 0, 0, 161, 1, 0, 8, 161, 1, 0, 192, 3, 0, 0, 48, 161, 1, 0, 56, 161, 1, 0, 193, 3, 0, 0, 96, 161, 1, 0, 104, 161, 1, 0, 194, 3, 0, 0, 144, 161, 1, 0, 152, 161, 1, 0, 195, 3, 0, 0, 200, 161, 1, 0, 208, 161, 1, 0, 196, 3, 0, 0, 0, 162, 1, 0, 8, 162, 1, 0, 197, 3, 0, 0, 48, 162, 1, 0, 56, 162, 1, 0, 198, 3, 0, 0, 104, 162, 1, 0, 112, 162, 1, 0, 199, 3, 0, 0, 152, 162, 1, 0, 160, 162, 1, 0, 200, 3, 0, 0, 200, 162, 1, 0, 208, 162, 1, 0, 201, 3, 0, 0, 248, 162, 1, 0, 0, 163, 1, 0, 209, 3, 0, 0, 48, 163, 1, 0, 64, 163, 1, 0, 210, 3, 0, 0, 112, 163, 1, 0, 120, 163, 1, 0, 214, 3, 0, 0, 168, 163, 1, 0, 176, 163, 1, 0, 2, 32, 0, 0, 208, 163, 1, 0, 216, 163, 1, 0, 3, 32, 0, 0, 240, 163, 1, 0, 248, 163, 1, 0, 9, 32, 0, 0, 16, 164, 1, 0, 24, 164, 1, 0, 12, 32, 0, 0, 56, 164, 1, 0, 64, 164, 1, 0, 13, 32, 0, 0, 112, 164, 1, 0, 120, 164, 1, 0, 14, 32, 0, 0, 160, 164, 1, 0, 168, 164, 1, 0, 15, 32, 0, 0, 208, 164, 1, 0, 216, 164, 1, 0, 19, 32, 0, 0, 0, 165, 1, 0, 8, 165, 1, 0, 20, 32, 0, 0, 32, 165, 1, 0, 40, 165, 1, 0, 24, 32, 0, 0, 64, 165, 1, 0, 72, 165, 1, 0, 25, 32, 0, 0, 120, 165, 1, 0, 128, 165, 1, 0, 26, 32, 0, 0, 176, 165, 1, 0, 184, 165, 1, 0, 28, 32, 0, 0, 224, 165, 1, 0, 232, 165, 1, 0, 29, 32, 0, 0, 24, 166, 1, 0, 32, 166, 1, 0, 30, 32, 0, 0, 80, 166, 1, 0, 88, 166, 1, 0, 32, 32, 0, 0, 128, 166, 1, 0, 136, 166, 1, 0, 33, 32, 0, 0, 160, 166, 1, 0, 168, 166, 1, 0, 34, 32, 0, 0, 200, 166, 1, 0, 208, 166, 1, 0, 38, 32, 0, 0, 0, 167, 1, 0, 8, 167, 1, 0, 48, 32, 0, 0, 64, 167, 1, 0, 72, 167, 1, 0, 50, 32, 0, 0, 104, 167, 1, 0, 112, 167, 1, 0, 51, 32, 0, 0, 152, 167, 1, 0, 160, 167, 1, 0, 57, 32, 0, 0, 208, 167, 1, 0, 216, 167, 1, 0, 58, 32, 0, 0, 24, 168, 1, 0, 32, 168, 1, 0, 62, 32, 0, 0, 96, 168, 1, 0, 104, 168, 1, 0, 68, 32, 0, 0, 152, 168, 1, 0, 160, 168, 1, 0, 172, 32, 0, 0, 192, 168, 1, 0, 200, 168, 1, 0, 17, 33, 0, 0, 224, 168, 1, 0, 232, 168, 1, 0, 24, 33, 0, 0, 32, 169, 1, 0, 40, 169, 1, 0, 28, 33, 0, 0, 104, 169, 1, 0, 112, 169, 1, 0, 34, 33, 0, 0, 176, 169, 1, 0, 184, 169, 1, 0, 53, 33, 0, 0, 216, 169, 1, 0, 224, 169, 1, 0, 144, 33, 0, 0, 24, 170, 1, 0, 32, 170, 1, 0, 145, 33, 0, 0, 64, 170, 1, 0, 72, 170, 1, 0, 146, 33, 0, 0, 104, 170, 1, 0, 112, 170, 1, 0, 147, 33, 0, 0, 144, 170, 1, 0, 152, 170, 1, 0, 148, 33, 0, 0, 184, 170, 1, 0, 192, 170, 1, 0, 181, 33, 0, 0, 232, 170, 1, 0, 240, 170, 1, 0, 208, 33, 0, 0, 56, 171, 1, 0, 64, 171, 1, 0, 209, 33, 0, 0, 104, 171, 1, 0, 112, 171, 1, 0, 210, 33, 0, 0, 152, 171, 1, 0, 160, 171, 1, 0, 211, 33, 0, 0, 200, 171, 1, 0, 208, 171, 1, 0, 212, 33, 0, 0, 248, 171, 1, 0, 0, 172, 1, 0, 0, 34, 0, 0, 40, 172, 1, 0, 48, 172, 1, 0, 2, 34, 0, 0, 72, 172, 1, 0, 80, 172, 1, 0, 3, 34, 0, 0, 120, 172, 1, 0, 128, 172, 1, 0, 5, 34, 0, 0, 160, 172, 1, 0, 168, 172, 1, 0, 7, 34, 0, 0, 216, 172, 1, 0, 224, 172, 1, 0, 8, 34, 0, 0, 16, 173, 1, 0, 24, 173, 1, 0, 9, 34, 0, 0, 56, 173, 1, 0, 64, 173, 1, 0, 11, 34, 0, 0, 104, 173, 1, 0, 112, 173, 1, 0, 15, 34, 0, 0, 152, 173, 1, 0, 160, 173, 1, 0, 17, 34, 0, 0, 208, 173, 1, 0, 216, 173, 1, 0, 18, 34, 0, 0, 248, 173, 1, 0, 0, 174, 1, 0, 23, 34, 0, 0, 32, 174, 1, 0, 40, 174, 1, 0, 26, 34, 0, 0, 80, 174, 1, 0, 88, 174, 1, 0, 29, 34, 0, 0, 136, 174, 1, 0, 144, 174, 1, 0, 30, 34, 0, 0, 176, 174, 1, 0, 184, 174, 1, 0, 32, 34, 0, 0, 216, 174, 1, 0, 224, 174, 1, 0, 39, 34, 0, 0, 248, 174, 1, 0, 0, 175, 1, 0, 40, 34, 0, 0, 40, 175, 1, 0, 48, 175, 1, 0, 41, 34, 0, 0, 88, 175, 1, 0, 96, 175, 1, 0, 42, 34, 0, 0, 136, 175, 1, 0, 144, 175, 1, 0, 43, 34, 0, 0, 176, 175, 1, 0, 184, 175, 1, 0, 52, 34, 0, 0, 216, 175, 1, 0, 224, 175, 1, 0, 60, 34, 0, 0, 0, 176, 1, 0, 8, 176, 1, 0, 69, 34, 0, 0, 72, 176, 1, 0, 80, 176, 1, 0, 72, 34, 0, 0, 120, 176, 1, 0, 128, 176, 1, 0, 96, 34, 0, 0, 176, 176, 1, 0, 184, 176, 1, 0, 97, 34, 0, 0, 216, 176, 1, 0, 224, 176, 1, 0, 100, 34, 0, 0, 0, 177, 1, 0, 8, 177, 1, 0, 101, 34, 0, 0, 48, 177, 1, 0, 56, 177, 1, 0, 130, 34, 0, 0, 104, 177, 1, 0, 112, 177, 1, 0, 131, 34, 0, 0, 144, 177, 1, 0, 152, 177, 1, 0, 132, 34, 0, 0, 184, 177, 1, 0, 192, 177, 1, 0, 134, 34, 0, 0, 224, 177, 1, 0, 232, 177, 1, 0, 135, 34, 0, 0, 16, 178, 1, 0, 24, 178, 1, 0, 149, 34, 0, 0, 64, 178, 1, 0, 72, 178, 1, 0, 151, 34, 0, 0, 120, 178, 1, 0, 128, 178, 1, 0, 165, 34, 0, 0, 176, 178, 1, 0, 184, 178, 1, 0, 197, 34, 0, 0, 240, 178, 1, 0, 248, 178, 1, 0, 8, 35, 0, 0, 24, 179, 1, 0, 32, 179, 1, 0, 9, 35, 0, 0, 80, 179, 1, 0, 88, 179, 1, 0, 10, 35, 0, 0, 120, 179, 1, 0, 128, 179, 1, 0, 11, 35, 0, 0, 176, 179, 1, 0, 184, 179, 1, 0, 41, 35, 0, 0, 216, 179, 1, 0, 224, 179, 1, 0, 42, 35, 0, 0, 24, 180, 1, 0, 32, 180, 1, 0, 202, 37, 0, 0, 88, 180, 1, 0, 96, 180, 1, 0, 96, 38, 0, 0, 120, 180, 1, 0, 128, 180, 1, 0, 99, 38, 0, 0, 160, 180, 1, 0, 168, 180, 1, 0, 101, 38, 0, 0, 216, 180, 1, 0, 224, 180, 1, 0, 102, 38, 0, 0, 16, 181, 1, 0, 24, 181, 1, 0, 0, 0, 0, 0, 35, 37, 117, 0, 0, 0, 0, 0, 72, 84, 77, 76, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 99, 114, 101, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 104, 116, 109, 108, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 84, 82, 47, 82, 69, 67, 45, 104, 116, 109, 108, 52, 48, 47, 108, 111, 111, 115, 101, 46, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 72, 84, 77, 76, 32, 52, 46, 48, 32, 84, 114, 97, 110, 115, 105, 116, 105, 111, 110, 97, 108, 47, 47, 69, 78, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 69, 110, 116, 105, 116, 121, 82, 101, 102, 58, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 69, 110, 116, 105, 116, 121, 82, 101, 102, 58, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 59, 39, 10, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 67, 104, 97, 114, 82, 101, 102, 58, 32, 99, 111, 110, 116, 101, 120, 116, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 67, 104, 97, 114, 82, 101, 102, 58, 32, 109, 105, 115, 115, 105, 110, 103, 32, 115, 101, 109, 105, 99, 111, 108, 111, 110, 10, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 67, 104, 97, 114, 82, 101, 102, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 120, 109, 108, 67, 104, 97, 114, 32, 118, 97, 108, 117, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 84, 97, 103, 32, 37, 115, 32, 105, 110, 118, 97, 108, 105, 100, 10, 0, 67, 111, 117, 108, 100, 110, 39, 116, 32, 102, 105, 110, 100, 32, 101, 110, 100, 32, 111, 102, 32, 83, 116, 97, 114, 116, 32, 84, 97, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 68, 111, 99, 117, 109, 101, 110, 116, 58, 32, 99, 111, 110, 116, 101, 120, 116, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 68, 111, 99, 117, 109, 101, 110, 116, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 78, 101, 119, 80, 97, 114, 115, 101, 114, 67, 116, 120, 116, 58, 32, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 67, 104, 117, 110, 107, 58, 32, 99, 111, 110, 116, 101, 120, 116, 32, 101, 114, 114, 111, 114, 10, 0, 0, 101, 110, 99, 111, 100, 101, 114, 32, 101, 114, 114, 111, 114, 10, 0, 0, 99, 104, 97, 114, 115, 101, 116, 61, 0, 0, 0, 0, 0, 0, 0, 0, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 99, 104, 97, 114, 115, 101, 116, 0, 61, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 67, 104, 101, 99, 107, 69, 110, 99, 111, 100, 105, 110, 103, 58, 32, 119, 114, 111, 110, 103, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 109, 101, 116, 97, 10, 0, 104, 116, 109, 108, 67, 104, 101, 99, 107, 69, 110, 99, 111, 100, 105, 110, 103, 58, 32, 117, 110, 107, 110, 111, 119, 110, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 37, 115, 10, 0, 104, 116, 109, 108, 67, 104, 101, 99, 107, 69, 110, 99, 111, 100, 105, 110, 103, 58, 32, 101, 110, 99, 111, 100, 101, 114, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 99, 111, 117, 108, 100, 110, 39, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 97, 32, 110, 101, 119, 32, 105, 110, 112, 117, 116, 32, 115, 116, 114, 101, 97, 109, 10, 0, 0, 0, 115, 99, 114, 105, 112, 116, 0, 0, 115, 116, 121, 108, 101, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 68, 79, 67, 84, 89, 80, 69, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 10, 0, 0, 68, 79, 67, 84, 89, 80, 69, 0, 59, 32, 62, 47, 0, 0, 0, 0, 60, 38, 0, 0, 0, 0, 0, 0, 100, 101, 116, 101, 99, 116, 101, 100, 32, 97, 110, 32, 101, 114, 114, 111, 114, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 84848);
	        allocate([116, 101, 110, 116, 10, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 67, 68, 65, 84, 65, 10, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 68, 84, 68, 10, 0, 0, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 67, 79, 77, 77, 69, 78, 84, 10, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 80, 73, 10, 0, 0, 0, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 69, 78, 84, 73, 84, 89, 95, 68, 69, 67, 76, 10, 0, 0, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 69, 78, 84, 73, 84, 89, 95, 86, 65, 76, 85, 69, 10, 0, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 65, 84, 84, 82, 73, 66, 85, 84, 69, 95, 86, 65, 76, 85, 69, 10, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 88, 77, 76, 95, 80, 65, 82, 83, 69, 82, 95, 83, 89, 83, 84, 69, 77, 95, 76, 73, 84, 69, 82, 65, 76, 10, 0, 0, 0, 0, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 88, 77, 76, 95, 80, 65, 82, 83, 69, 82, 95, 73, 71, 78, 79, 82, 69, 10, 0, 0, 0, 0, 0, 0, 0, 0, 72, 80, 80, 58, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 116, 101, 32, 61, 61, 32, 88, 77, 76, 95, 80, 65, 82, 83, 69, 82, 95, 76, 73, 84, 69, 82, 65, 76, 10, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 69, 110, 100, 84, 97, 103, 58, 32, 39, 60, 47, 39, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 100, 32, 116, 97, 103, 32, 58, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 39, 62, 39, 10, 0, 98, 111, 100, 121, 0, 0, 0, 0, 104, 101, 97, 100, 0, 0, 0, 0, 85, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 101, 110, 100, 32, 116, 97, 103, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 79, 112, 101, 110, 105, 110, 103, 32, 97, 110, 100, 32, 101, 110, 100, 105, 110, 103, 32, 116, 97, 103, 32, 109, 105, 115, 109, 97, 116, 99, 104, 58, 32, 37, 115, 32, 97, 110, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 96, 118, 1, 0, 150, 0, 0, 0, 104, 118, 1, 0, 160, 0, 0, 0, 112, 118, 1, 0, 160, 0, 0, 0, 120, 118, 1, 0, 170, 0, 0, 0, 128, 118, 1, 0, 180, 0, 0, 0, 136, 118, 1, 0, 180, 0, 0, 0, 144, 118, 1, 0, 180, 0, 0, 0, 152, 118, 1, 0, 190, 0, 0, 0, 168, 117, 1, 0, 200, 0, 0, 0, 160, 117, 1, 0, 200, 0, 0, 0, 32, 112, 1, 0, 220, 0, 0, 0, 0, 0, 0, 0, 100, 0, 0, 0, 100, 105, 118, 0, 0, 0, 0, 0, 116, 100, 0, 0, 0, 0, 0, 0, 116, 104, 0, 0, 0, 0, 0, 0, 116, 114, 0, 0, 0, 0, 0, 0, 116, 104, 101, 97, 100, 0, 0, 0, 116, 98, 111, 100, 121, 0, 0, 0, 116, 102, 111, 111, 116, 0, 0, 0, 116, 97, 98, 108, 101, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 101, 109, 98, 101, 100, 115, 32, 99, 108, 111, 115, 101, 32, 116, 97, 103, 10, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 99, 104, 97, 114, 32, 105, 110, 32, 67, 68, 65, 84, 65, 32, 48, 120, 37, 88, 10, 0, 0, 0, 0, 0, 67, 104, 97, 114, 32, 48, 120, 37, 88, 32, 111, 117, 116, 32, 111, 102, 32, 97, 108, 108, 111, 119, 101, 100, 32, 114, 97, 110, 103, 101, 10, 0, 85, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 37, 115, 0, 66, 121, 116, 101, 115, 58, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 32, 48, 120, 37, 48, 50, 88, 10, 0, 0, 0, 0, 0, 66, 121, 116, 101, 115, 58, 32, 48, 120, 37, 48, 50, 88, 10, 0, 0, 73, 110, 112, 117, 116, 32, 105, 115, 32, 110, 111, 116, 32, 112, 114, 111, 112, 101, 114, 32, 85, 84, 70, 45, 56, 44, 32, 105, 110, 100, 105, 99, 97, 116, 101, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 33, 10, 0, 72, 84, 84, 80, 45, 69, 81, 85, 73, 86, 0, 0, 0, 0, 0, 0, 67, 79, 78, 84, 69, 78, 84, 0, 67, 72, 65, 82, 83, 69, 84, 61, 0, 0, 0, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 32, 112, 1, 0, 168, 117, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 101, 116, 97, 0, 0, 0, 0, 108, 105, 110, 107, 0, 0, 0, 0, 116, 105, 116, 108, 101, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 110, 111, 102, 114, 97, 109, 101, 115, 0, 0, 0, 0, 0, 0, 0, 0, 102, 114, 97, 109, 101, 0, 0, 0, 102, 114, 97, 109, 101, 115, 101, 116, 0, 0, 0, 0, 0, 0, 0, 0, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 72, 84, 77, 76, 32, 52, 46, 48, 49, 47, 47, 69, 78, 0, 0, 0, 0, 0, 0, 0, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 72, 84, 77, 76, 32, 52, 47, 47, 69, 78, 0, 0, 32, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 56, 121, 1, 0, 64, 121, 1, 0, 72, 121, 1, 0, 80, 121, 1, 0, 88, 121, 1, 0, 96, 121, 1, 0, 160, 117, 1, 0, 112, 121, 1, 0, 120, 121, 1, 0, 128, 121, 1, 0, 136, 121, 1, 0, 144, 121, 1, 0, 152, 121, 1, 0, 160, 121, 1, 0, 168, 121, 1, 0, 96, 118, 1, 0, 176, 121, 1, 0, 184, 121, 1, 0, 192, 121, 1, 0, 200, 121, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 0, 122, 1, 0, 8, 122, 1, 0, 16, 122, 1, 0, 24, 122, 1, 0, 32, 122, 1, 0, 40, 122, 1, 0, 48, 122, 1, 0, 232, 119, 1, 0, 56, 122, 1, 0, 72, 122, 1, 0, 176, 119, 1, 0, 80, 122, 1, 0, 88, 122, 1, 0, 96, 122, 1, 0, 104, 122, 1, 0, 112, 122, 1, 0, 120, 122, 1, 0, 128, 122, 1, 0, 136, 122, 1, 0, 104, 118, 1, 0, 112, 118, 1, 0, 144, 122, 1, 0, 152, 122, 1, 0, 160, 122, 1, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 97, 98, 98, 114, 0, 0, 0, 0, 97, 99, 114, 111, 110, 121, 109, 0, 97, 100, 100, 114, 101, 115, 115, 0, 97, 112, 112, 108, 101, 116, 0, 0, 98, 0, 0, 0, 0, 0, 0, 0, 98, 100, 111, 0, 0, 0, 0, 0, 98, 105, 103, 0, 0, 0, 0, 0, 98, 108, 111, 99, 107, 113, 117, 111, 116, 101, 0, 0, 0, 0, 0, 0, 98, 117, 116, 116, 111, 110, 0, 0, 99, 97, 112, 116, 105, 111, 110, 0, 99, 101, 110, 116, 101, 114, 0, 0, 99, 105, 116, 101, 0, 0, 0, 0, 99, 111, 100, 101, 0, 0, 0, 0, 100, 100, 0, 0, 0, 0, 0, 0, 100, 101, 108, 0, 0, 0, 0, 0, 100, 102, 110, 0, 0, 0, 0, 0, 100, 116, 0, 0, 0, 0, 0, 0, 101, 109, 0, 0, 0, 0, 0, 0, 102, 111, 110, 116, 0, 0, 0, 0, 102, 111, 114, 109, 0, 0, 0, 0, 104, 49, 0, 0, 0, 0, 0, 0, 104, 50, 0, 0, 0, 0, 0, 0, 104, 51, 0, 0, 0, 0, 0, 0, 104, 52, 0, 0, 0, 0, 0, 0, 104, 53, 0, 0, 0, 0, 0, 0, 104, 54, 0, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 0, 0, 105, 102, 114, 97, 109, 101, 0, 0, 105, 110, 115, 0, 0, 0, 0, 0, 107, 98, 100, 0, 0, 0, 0, 0, 108, 97, 98, 101, 108, 0, 0, 0, 108, 101, 103, 101, 110, 100, 0, 0, 108, 105, 0, 0, 0, 0, 0, 0, 110, 111, 115, 99, 114, 105, 112, 116, 0, 0, 0, 0, 0, 0, 0, 0, 111, 98, 106, 101, 99, 116, 0, 0, 112, 114, 101, 0, 0, 0, 0, 0, 113, 0, 0, 0, 0, 0, 0, 0, 115, 0, 0, 0, 0, 0, 0, 0, 115, 97, 109, 112, 0, 0, 0, 0, 115, 109, 97, 108, 108, 0, 0, 0, 115, 112, 97, 110, 0, 0, 0, 0, 115, 116, 114, 105, 107, 101, 0, 0, 115, 116, 114, 111, 110, 103, 0, 0, 116, 116, 0, 0, 0, 0, 0, 0, 117, 0, 0, 0, 0, 0, 0, 0, 118, 97, 114, 0, 0, 0, 0, 0, 104, 116, 109, 108, 73, 110, 105, 116, 80, 97, 114, 115, 101, 114, 67, 116, 120, 116, 58, 32, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 68, 111, 99, 84, 121, 112, 101, 68, 101, 99, 108, 32, 58, 32, 110, 111, 32, 68, 79, 67, 84, 89, 80, 69, 32, 110, 97, 109, 101, 32, 33, 10, 0, 0, 0, 0, 0, 0, 0, 68, 79, 67, 84, 89, 80, 69, 32, 105, 109, 112, 114, 111, 112, 101, 114, 108, 121, 32, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 10, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 83, 89, 83, 84, 69, 77, 39, 10, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 69, 120, 116, 101, 114, 110, 97, 108, 73, 68, 58, 32, 83, 89, 83, 84, 69, 77, 44, 32, 110, 111, 32, 85, 82, 73, 10, 0, 0, 0, 0, 83, 112, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 102, 116, 101, 114, 32, 39, 80, 85, 66, 76, 73, 67, 39, 10, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 69, 120, 116, 101, 114, 110, 97, 108, 73, 68, 58, 32, 80, 85, 66, 76, 73, 67, 44, 32, 110, 111, 32, 80, 117, 98, 108, 105, 99, 32, 73, 100, 101, 110, 116, 105, 102, 105, 101, 114, 10, 0, 0, 0, 0, 0, 0, 85, 110, 102, 105, 110, 105, 115, 104, 101, 100, 32, 80, 117, 98, 105, 100, 76, 105, 116, 101, 114, 97, 108, 10, 0, 0, 0, 0, 0, 0, 0, 0, 80, 117, 98, 105, 100, 76, 105, 116, 101, 114, 97, 108, 32, 34, 32, 111, 114, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 85, 110, 102, 105, 110, 105, 115, 104, 101, 100, 32, 83, 121, 115, 116, 101, 109, 76, 105, 116, 101, 114, 97, 108, 10, 0, 0, 0, 0, 0, 0, 0, 32, 111, 114, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 80, 97, 114, 115, 101, 80, 73, 58, 32, 80, 73, 32, 37, 115, 32, 115, 112, 97, 99, 101, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 80, 97, 114, 115, 101, 80, 73, 58, 32, 80, 73, 32, 37, 115, 32, 110, 101, 118, 101, 114, 32, 101, 110, 100, 32, 46, 46, 46, 10, 0, 0, 0, 80, 73, 32, 105, 115, 32, 110, 111, 116, 32, 115, 116, 97, 114, 116, 101, 100, 32, 99, 111, 114, 114, 101, 99, 116, 108, 121, 0, 0, 0, 0, 0, 98, 117, 102, 102, 101, 114, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 110, 111, 116, 32, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 32, 10, 60, 33, 45, 45, 37, 46, 53, 48, 115, 10, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 105, 110, 118, 97, 108, 105, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 99, 111, 110, 116, 101, 120, 116, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 99, 111, 110, 116, 101, 120, 116, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 109, 105, 115, 112, 108, 97, 99, 101, 100, 32, 60, 104, 116, 109, 108, 62, 32, 116, 97, 103, 10, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 109, 105, 115, 112, 108, 97, 99, 101, 100, 32, 60, 104, 101, 97, 100, 62, 32, 116, 97, 103, 10, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 109, 105, 115, 112, 108, 97, 99, 101, 100, 32, 60, 98, 111, 100, 121, 62, 32, 116, 97, 103, 10, 0, 0, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 104, 116, 109, 108, 80, 97, 114, 115, 101, 83, 116, 97, 114, 116, 84, 97, 103, 58, 32, 112, 114, 111, 98, 108, 101, 109, 32, 112, 97, 114, 115, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 10, 0, 0, 104, 116, 116, 112, 45, 101, 113, 117, 105, 118, 0, 0, 0, 0, 0, 0, 67, 111, 110, 116, 101, 110, 116, 45, 84, 121, 112, 101, 0, 0, 0, 0, 99, 111, 110, 116, 101, 110, 116, 0, 101, 114, 114, 111, 114, 32, 112, 97, 114, 115, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 110, 97, 109, 101, 10, 0, 0, 0, 65, 116, 116, 86, 97, 108, 117, 101, 58, 32, 34, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 65, 116, 116, 86, 97, 108, 117, 101, 58, 32, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 10, 0, 0, 0, 65, 116, 116, 86, 97, 108, 117, 101, 58, 32, 110, 111, 32, 118, 97, 108, 117, 101, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 10, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 113, 117, 111, 116, 0, 0, 0, 0, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 32, 61, 32, 65, 80, 76, 32, 113, 117, 111, 116, 101, 44, 32, 85, 43, 48, 48, 50, 50, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 97, 109, 112, 0, 0, 0, 0, 0, 97, 109, 112, 101, 114, 115, 97, 110, 100, 44, 32, 85, 43, 48, 48, 50, 54, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 0, 97, 112, 111, 115, 0, 0, 0, 0, 115, 105, 110, 103, 108, 101, 32, 113, 117, 111, 116, 101, 0, 0, 0, 0, 108, 116, 0, 0, 0, 0, 0, 0, 108, 101, 115, 115, 45, 116, 104, 97, 110, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 51, 67, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 103, 116, 0, 0, 0, 0, 0, 0, 103, 114, 101, 97, 116, 101, 114, 45, 116, 104, 97, 110, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 51, 69, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 0, 110, 98, 115, 112, 0, 0, 0, 0, 110, 111, 45, 98, 114, 101, 97, 107, 32, 115, 112, 97, 99, 101, 32, 61, 32, 110, 111, 110, 45, 98, 114, 101, 97, 107, 105, 110, 103, 32, 115, 112, 97, 99, 101, 44, 32, 85, 43, 48, 48, 65, 48, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 105, 101, 120, 99, 108, 0, 0, 0, 105, 110, 118, 101, 114, 116, 101, 100, 32, 101, 120, 99, 108, 97, 109, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 48, 48, 65, 49, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 0, 99, 101, 110, 116, 0, 0, 0, 0, 99, 101, 110, 116, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 50, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 0, 112, 111, 117, 110, 100, 0, 0, 0, 112, 111, 117, 110, 100, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 51, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 99, 117, 114, 114, 101, 110, 0, 0, 99, 117, 114, 114, 101, 110, 99, 121, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 52, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 121, 101, 110, 0, 0, 0, 0, 0, 121, 101, 110, 32, 115, 105, 103, 110, 32, 61, 32, 121, 117, 97, 110, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 53, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 98, 114, 118, 98, 97, 114, 0, 0, 98, 114, 111, 107, 101, 110, 32, 98, 97, 114, 32, 61, 32, 98, 114, 111, 107, 101, 110, 32, 118, 101, 114, 116, 105, 99, 97, 108, 32, 98, 97, 114, 44, 32, 85, 43, 48, 48, 65, 54, 32, 73, 83, 79, 110, 117, 109, 0, 115, 101, 99, 116, 0, 0, 0, 0, 115, 101, 99, 116, 105, 111, 110, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 55, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 117, 109, 108, 0, 0, 0, 0, 0, 100, 105, 97, 101, 114, 101, 115, 105, 115, 32, 61, 32, 115, 112, 97, 99, 105, 110, 103, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 65, 56, 32, 73, 83, 79, 100, 105, 97, 0, 0, 0, 0, 99, 111, 112, 121, 0, 0, 0, 0, 99, 111, 112, 121, 114, 105, 103, 104, 116, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 57, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 111, 114, 100, 102, 0, 0, 0, 0, 102, 101, 109, 105, 110, 105, 110, 101, 32, 111, 114, 100, 105, 110, 97, 108, 32, 105, 110, 100, 105, 99, 97, 116, 111, 114, 44, 32, 85, 43, 48, 48, 65, 65, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 108, 97, 113, 117, 111, 0, 0, 0, 108, 101, 102, 116, 45, 112, 111, 105, 110, 116, 105, 110, 103, 32, 100, 111, 117, 98, 108, 101, 32, 97, 110, 103, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 32, 61, 32, 108, 101, 102, 116, 32, 112, 111, 105, 110, 116, 105, 110, 103, 32, 103, 117, 105, 108, 108, 101, 109, 101, 116, 44, 32, 85, 43, 48, 48, 65, 66, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 110, 111, 116, 0, 0, 0, 0, 0, 110, 111, 116, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 67, 32, 73, 83, 79, 110, 117, 109, 0, 115, 104, 121, 0, 0, 0, 0, 0, 115, 111, 102, 116, 32, 104, 121, 112, 104, 101, 110, 32, 61, 32, 100, 105, 115, 99, 114, 101, 116, 105, 111, 110, 97, 114, 121, 32, 104, 121, 112, 104, 101, 110, 44, 32, 85, 43, 48, 48, 65, 68, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 114, 101, 103, 0, 0, 0, 0, 0, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 32, 115, 105, 103, 110, 32, 61, 32, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 32, 116, 114, 97, 100, 101, 32, 109, 97, 114, 107, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 65, 69, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 109, 97, 99, 114, 0, 0, 0, 0, 109, 97, 99, 114, 111, 110, 32, 61, 32, 115, 112, 97, 99, 105, 110, 103, 32, 109, 97, 99, 114, 111, 110, 32, 61, 32, 111, 118, 101, 114, 108, 105, 110, 101, 32, 61, 32, 65, 80, 76, 32, 111, 118, 101, 114, 98, 97, 114, 44, 32, 85, 43, 48, 48, 65, 70, 32, 73, 83, 79, 100, 105, 97, 0, 100, 101, 103, 0, 0, 0, 0, 0, 100, 101, 103, 114, 101, 101, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 66, 48, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 112, 108, 117, 115, 109, 110, 0, 0, 112, 108, 117, 115, 45, 109, 105, 110, 117, 115, 32, 115, 105, 103, 110, 32, 61, 32, 112, 108, 117, 115, 45, 111, 114, 45, 109, 105, 110, 117, 115, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 66, 49, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 115, 117, 112, 50, 0, 0, 0, 0, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 116, 119, 111, 32, 61, 32, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 100, 105, 103, 105, 116, 32, 116, 119, 111, 32, 61, 32, 115, 113, 117, 97, 114, 101, 100, 44, 32, 85, 43, 48, 48, 66, 50, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 0, 115, 117, 112, 51, 0, 0, 0, 0, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 116, 104, 114, 101, 101, 32, 61, 32, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 100, 105, 103, 105, 116, 32, 116, 104, 114, 101, 101, 32, 61, 32, 99, 117, 98, 101, 100, 44, 32, 85, 43, 48, 48, 66, 51, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 97, 99, 117, 116, 101, 0, 0, 0, 97, 99, 117, 116, 101, 32, 97, 99, 99, 101, 110, 116, 32, 61, 32, 115, 112, 97, 99, 105, 110, 103, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 66, 52, 32, 73, 83, 79, 100, 105, 97, 0, 0, 0, 0, 0, 109, 105, 99, 114, 111, 0, 0, 0, 109, 105, 99, 114, 111, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 66, 53, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 112, 97, 114, 97, 0, 0, 0, 0, 112, 105, 108, 99, 114, 111, 119, 32, 115, 105, 103, 110, 32, 61, 32, 112, 97, 114, 97, 103, 114, 97, 112, 104, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 66, 54, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 109, 105, 100, 100, 111, 116, 0, 0, 109, 105, 100, 100, 108, 101, 32, 100, 111, 116, 32, 61, 32, 71, 101, 111, 114, 103, 105, 97, 110, 32, 99, 111, 109, 109, 97, 32, 71, 114, 101, 101, 107, 32, 109, 105, 100, 100, 108, 101, 32, 100, 111, 116, 44, 32, 85, 43, 48, 48, 66, 55, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 99, 101, 100, 105, 108, 0, 0, 0, 99, 101, 100, 105, 108, 108, 97, 32, 61, 32, 115, 112, 97, 99, 105, 110, 103, 32, 99, 101, 100, 105, 108, 108, 97, 44, 32, 85, 43, 48, 48, 66, 56, 32, 73, 83, 79, 100, 105, 97, 0, 0, 0, 0, 0, 0, 0, 0, 115, 117, 112, 49, 0, 0, 0, 0, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 111, 110, 101, 32, 61, 32, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 100, 105, 103, 105, 116, 32, 111, 110, 101, 44, 32, 85, 43, 48, 48, 66, 57, 32, 73, 83, 79, 110, 117, 109, 0, 0, 111, 114, 100, 109, 0, 0, 0, 0, 109, 97, 115, 99, 117, 108, 105, 110, 101, 32, 111, 114, 100, 105, 110, 97, 108, 32, 105, 110, 100, 105, 99, 97, 116, 111, 114, 44, 32, 85, 43, 48, 48, 66, 65, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 114, 97, 113, 117, 111, 0, 0, 0, 114, 105, 103, 104, 116, 45, 112, 111, 105, 110, 116, 105, 110, 103, 32, 100, 111, 117, 98, 108, 101, 32, 97, 110, 103, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 32, 114, 105, 103, 104, 116, 32, 112, 111, 105, 110, 116, 105, 110, 103, 32, 103, 117, 105, 108, 108, 101, 109, 101, 116, 44, 32, 85, 43, 48, 48, 66, 66, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 102, 114, 97, 99, 49, 52, 0, 0, 118, 117, 108, 103, 97, 114, 32, 102, 114, 97, 99, 116, 105, 111, 110, 32, 111, 110, 101, 32, 113, 117, 97, 114, 116, 101, 114, 32, 61, 32, 102, 114, 97, 99, 116, 105, 111, 110, 32, 111, 110, 101, 32, 113, 117, 97, 114, 116, 101, 114, 44, 32, 85, 43, 48, 48, 66, 67, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 102, 114, 97, 99, 49, 50, 0, 0, 118, 117, 108, 103, 97, 114, 32, 102, 114, 97, 99, 116, 105, 111, 110, 32, 111, 110, 101, 32, 104, 97, 108, 102, 32, 61, 32, 102, 114, 97, 99, 116, 105, 111, 110, 32, 111, 110, 101, 32, 104, 97, 108, 102, 44, 32, 85, 43, 48, 48, 66, 68, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 102, 114, 97, 99, 51, 52, 0, 0, 118, 117, 108, 103, 97, 114, 32, 102, 114, 97, 99, 116, 105, 111, 110, 32, 116, 104, 114, 101, 101, 32, 113, 117, 97, 114, 116, 101, 114, 115, 32, 61, 32, 102, 114, 97, 99, 116, 105, 111, 110, 32, 116, 104, 114, 101, 101, 32, 113, 117, 97, 114, 116, 101, 114, 115, 44, 32, 85, 43, 48, 48, 66, 69, 32, 73, 83, 79, 110, 117, 109, 0, 105, 113, 117, 101, 115, 116, 0, 0, 105, 110, 118, 101, 114, 116, 101, 100, 32, 113, 117, 101, 115, 116, 105, 111, 110, 32, 109, 97, 114, 107, 32, 61, 32, 116, 117, 114, 110, 101, 100, 32, 113, 117, 101, 115, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 48, 48, 66, 70, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 65, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 32, 61, 32, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 67, 48, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 0, 65, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 67, 49, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 65, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 67, 50, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 65, 116, 105, 108, 100, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 119, 105, 116, 104, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 48, 67, 51, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 65, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 67, 52, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 65, 114, 105, 110, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 119, 105, 116, 104, 32, 114, 105, 110, 103, 32, 97, 98, 111, 118, 101, 32, 61, 32, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 32, 114, 105, 110, 103, 44, 32, 85, 43, 48, 48, 67, 53, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 65, 69, 108, 105, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 65, 69, 32, 61, 32, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 105, 103, 97, 116, 117, 114, 101, 32, 65, 69, 44, 32, 85, 43, 48, 48, 67, 54, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 67, 99, 101, 100, 105, 108, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 67, 32, 119, 105, 116, 104, 32, 99, 101, 100, 105, 108, 108, 97, 44, 32, 85, 43, 48, 48, 67, 55, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 69, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 69, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 67, 56, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 69, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 69, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 67, 57, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 69, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 69, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 67, 65, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 69, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 69, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 67, 66, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 73, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 73, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 67, 67, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 73, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 73, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 67, 68, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 73, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 73, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 67, 69, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 73, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 73, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 67, 70, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 69, 84, 72, 0, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 69, 84, 72, 44, 32, 85, 43, 48, 48, 68, 48, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 0, 78, 116, 105, 108, 100, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 78, 32, 119, 105, 116, 104, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 48, 68, 49, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 79, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 68, 50, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 79, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 68, 51, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 79, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 68, 52, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 79, 116, 105, 108, 100, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 119, 105, 116, 104, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 48, 68, 53, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 79, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 68, 54, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 116, 105, 109, 101, 115, 0, 0, 0, 109, 117, 108, 116, 105, 112, 108, 105, 99, 97, 116, 105, 111, 110, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 68, 55, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 79, 115, 108, 97, 115, 104, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 119, 105, 116, 104, 32, 115, 116, 114, 111, 107, 101, 32, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 79, 32, 115, 108, 97, 115, 104, 44, 32, 85, 43, 48, 48, 68, 56, 32, 73, 83, 79, 108, 97, 116, 49, 0, 85, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 85, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 68, 57, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 85, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 85, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 68, 65, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 85, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 85, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 68, 66, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 85, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 85, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 68, 67, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 89, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 89, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 68, 68, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 84, 72, 79, 82, 78, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 84, 72, 79, 82, 78, 44, 32, 85, 43, 48, 48, 68, 69, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 115, 122, 108, 105, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 115, 104, 97, 114, 112, 32, 115, 32, 61, 32, 101, 115, 115, 45, 122, 101, 100, 44, 32, 85, 43, 48, 48, 68, 70, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 97, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 32, 61, 32, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 69, 48, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 97, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 69, 49, 32, 73, 83, 79, 108, 97, 116, 49, 0, 97, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 69, 50, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 97, 116, 105, 108, 100, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 119, 105, 116, 104, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 48, 69, 51, 32, 73, 83, 79, 108, 97, 116, 49, 0, 97, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 69, 52, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 97, 114, 105, 110, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 119, 105, 116, 104, 32, 114, 105, 110, 103, 32, 97, 98, 111, 118, 101, 32, 61, 32, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 32, 114, 105, 110, 103, 44, 32, 85, 43, 48, 48, 69, 53, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 0, 97, 101, 108, 105, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 101, 32, 61, 32, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 105, 103, 97, 116, 117, 114, 101, 32, 97, 101, 44, 32, 85, 43, 48, 48, 69, 54, 32, 73, 83, 79, 108, 97, 116, 49, 0, 99, 99, 101, 100, 105, 108, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 99, 32, 119, 105, 116, 104, 32, 99, 101, 100, 105, 108, 108, 97, 44, 32, 85, 43, 48, 48, 69, 55, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 0, 0, 101, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 69, 56, 32, 73, 83, 79, 108, 97, 116, 49, 0, 101, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 69, 57, 32, 73, 83, 79, 108, 97, 116, 49, 0, 101, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 69, 65, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 101, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 69, 66, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 105, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 105, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 69, 67, 32, 73, 83, 79, 108, 97, 116, 49, 0, 105, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 105, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 69, 68, 32, 73, 83, 79, 108, 97, 116, 49, 0, 105, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 105, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 69, 69, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 105, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 105, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 69, 70, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 101, 116, 104, 0, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 116, 104, 44, 32, 85, 43, 48, 48, 70, 48, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 110, 116, 105, 108, 100, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 110, 32, 119, 105, 116, 104, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 48, 70, 49, 32, 73, 83, 79, 108, 97, 116, 49, 0, 111, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 70, 50, 32, 73, 83, 79, 108, 97, 116, 49, 0, 111, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 70, 51, 32, 73, 83, 79, 108, 97, 116, 49, 0, 111, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 70, 52, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 111, 116, 105, 108, 100, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 119, 105, 116, 104, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 48, 70, 53, 32, 73, 83, 79, 108, 97, 116, 49, 0, 111, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 70, 54, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 100, 105, 118, 105, 100, 101, 0, 0, 100, 105, 118, 105, 115, 105, 111, 110, 32, 115, 105, 103, 110, 44, 32, 85, 43, 48, 48, 70, 55, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 111, 115, 108, 97, 115, 104, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 119, 105, 116, 104, 32, 115, 116, 114, 111, 107, 101, 44, 32, 61, 32, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 32, 115, 108, 97, 115, 104, 44, 32, 85, 43, 48, 48, 70, 56, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 117, 103, 114, 97, 118, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 117, 32, 119, 105, 116, 104, 32, 103, 114, 97, 118, 101, 44, 32, 85, 43, 48, 48, 70, 57, 32, 73, 83, 79, 108, 97, 116, 49, 0, 117, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 117, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 70, 65, 32, 73, 83, 79, 108, 97, 116, 49, 0, 117, 99, 105, 114, 99, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 117, 32, 119, 105, 116, 104, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 44, 32, 85, 43, 48, 48, 70, 66, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 117, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 117, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 70, 67, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 121, 97, 99, 117, 116, 101, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 121, 32, 119, 105, 116, 104, 32, 97, 99, 117, 116, 101, 44, 32, 85, 43, 48, 48, 70, 68, 32, 73, 83, 79, 108, 97, 116, 49, 0, 116, 104, 111, 114, 110, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 116, 104, 111, 114, 110, 32, 119, 105, 116, 104, 44, 32, 85, 43, 48, 48, 70, 69, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 121, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 121, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 48, 70, 70, 32, 73, 83, 79, 108, 97, 116, 49, 0, 0, 0, 0, 0, 79, 69, 108, 105, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 105, 103, 97, 116, 117, 114, 101, 32, 79, 69, 44, 32, 85, 43, 48, 49, 53, 50, 32, 73, 83, 79, 108, 97, 116, 50, 0, 0, 0, 0, 0, 0, 0, 111, 101, 108, 105, 103, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 105, 103, 97, 116, 117, 114, 101, 32, 111, 101, 44, 32, 85, 43, 48, 49, 53, 51, 32, 73, 83, 79, 108, 97, 116, 50, 0, 83, 99, 97, 114, 111, 110, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 83, 32, 119, 105, 116, 104, 32, 99, 97, 114, 111, 110, 44, 32, 85, 43, 48, 49, 54, 48, 32, 73, 83, 79, 108, 97, 116, 50, 0, 0, 0, 0, 0, 0, 0, 115, 99, 97, 114, 111, 110, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 115, 32, 119, 105, 116, 104, 32, 99, 97, 114, 111, 110, 44, 32, 85, 43, 48, 49, 54, 49, 32, 73, 83, 79, 108, 97, 116, 50, 0, 89, 117, 109, 108, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 89, 32, 119, 105, 116, 104, 32, 100, 105, 97, 101, 114, 101, 115, 105, 115, 44, 32, 85, 43, 48, 49, 55, 56, 32, 73, 83, 79, 108, 97, 116, 50, 0, 0, 0, 102, 110, 111, 102, 0, 0, 0, 0, 108, 97, 116, 105, 110, 32, 115, 109, 97, 108, 108, 32, 102, 32, 119, 105, 116, 104, 32, 104, 111, 111, 107, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 102, 108, 111, 114, 105, 110, 44, 32, 85, 43, 48, 49, 57, 50, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 99, 105, 114, 99, 0, 0, 0, 0, 109, 111, 100, 105, 102, 105, 101, 114, 32, 108, 101, 116, 116, 101, 114, 32, 99, 105, 114, 99, 117, 109, 102, 108, 101, 120, 32, 97, 99, 99, 101, 110, 116, 44, 32, 85, 43, 48, 50, 67, 54, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 0, 0, 0, 0, 116, 105, 108, 100, 101, 0, 0, 0, 115, 109, 97, 108, 108, 32, 116, 105, 108, 100, 101, 44, 32, 85, 43, 48, 50, 68, 67, 32, 73, 83, 79, 100, 105, 97, 0, 0, 0, 0, 0, 0, 65, 108, 112, 104, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 108, 112, 104, 97, 44, 32, 85, 43, 48, 51, 57, 49, 0, 0, 0, 0, 0, 0, 66, 101, 116, 97, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 98, 101, 116, 97, 44, 32, 85, 43, 48, 51, 57, 50, 0, 0, 0, 0, 0, 0, 0, 71, 97, 109, 109, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 103, 97, 109, 109, 97, 44, 32, 85, 43, 48, 51, 57, 51, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 68, 101, 108, 116, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 100, 101, 108, 116, 97, 44, 32, 85, 43, 48, 51, 57, 52, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 69, 112, 115, 105, 108, 111, 110, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 112, 115, 105, 108, 111, 110, 44, 32, 85, 43, 48, 51, 57, 53, 0, 0, 0, 0, 90, 101, 116, 97, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 122, 101, 116, 97, 44, 32, 85, 43, 48, 51, 57, 54, 0, 0, 0, 0, 0, 0, 0, 69, 116, 97, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 116, 97, 44, 32, 85, 43, 48, 51, 57, 55, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 116, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 116, 104, 101, 116, 97, 44, 32, 85, 43, 48, 51, 57, 56, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 73, 111, 116, 97, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 105, 111, 116, 97, 44, 32, 85, 43, 48, 51, 57, 57, 0, 0, 0, 0, 0, 0, 0, 75, 97, 112, 112, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 107, 97, 112, 112, 97, 44, 32, 85, 43, 48, 51, 57, 65, 0, 0, 0, 0, 0, 0, 76, 97, 109, 98, 100, 97, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 95088);
	        allocate([112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 108, 97, 109, 98, 100, 97, 44, 32, 85, 43, 48, 51, 57, 66, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 77, 117, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 109, 117, 44, 32, 85, 43, 48, 51, 57, 67, 0, 78, 117, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 110, 117, 44, 32, 85, 43, 48, 51, 57, 68, 0, 88, 105, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 120, 105, 44, 32, 85, 43, 48, 51, 57, 69, 32, 73, 83, 79, 103, 114, 107, 51, 0, 79, 109, 105, 99, 114, 111, 110, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 109, 105, 99, 114, 111, 110, 44, 32, 85, 43, 48, 51, 57, 70, 0, 0, 0, 0, 80, 105, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 112, 105, 44, 32, 85, 43, 48, 51, 65, 48, 32, 73, 83, 79, 103, 114, 107, 51, 0, 82, 104, 111, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 114, 104, 111, 44, 32, 85, 43, 48, 51, 65, 49, 0, 0, 0, 0, 0, 0, 0, 0, 83, 105, 103, 109, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 115, 105, 103, 109, 97, 44, 32, 85, 43, 48, 51, 65, 51, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 84, 97, 117, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 116, 97, 117, 44, 32, 85, 43, 48, 51, 65, 52, 0, 0, 0, 0, 0, 0, 0, 0, 85, 112, 115, 105, 108, 111, 110, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 117, 112, 115, 105, 108, 111, 110, 44, 32, 85, 43, 48, 51, 65, 53, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 80, 104, 105, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 112, 104, 105, 44, 32, 85, 43, 48, 51, 65, 54, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 67, 104, 105, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 99, 104, 105, 44, 32, 85, 43, 48, 51, 65, 55, 0, 0, 0, 0, 0, 0, 0, 0, 80, 115, 105, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 112, 115, 105, 44, 32, 85, 43, 48, 51, 65, 56, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 79, 109, 101, 103, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 99, 97, 112, 105, 116, 97, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 109, 101, 103, 97, 44, 32, 85, 43, 48, 51, 65, 57, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 97, 108, 112, 104, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 97, 108, 112, 104, 97, 44, 32, 85, 43, 48, 51, 66, 49, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 98, 101, 116, 97, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 98, 101, 116, 97, 44, 32, 85, 43, 48, 51, 66, 50, 32, 73, 83, 79, 103, 114, 107, 51, 0, 103, 97, 109, 109, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 103, 97, 109, 109, 97, 44, 32, 85, 43, 48, 51, 66, 51, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 100, 101, 108, 116, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 100, 101, 108, 116, 97, 44, 32, 85, 43, 48, 51, 66, 52, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 101, 112, 115, 105, 108, 111, 110, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 112, 115, 105, 108, 111, 110, 44, 32, 85, 43, 48, 51, 66, 53, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 122, 101, 116, 97, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 122, 101, 116, 97, 44, 32, 85, 43, 48, 51, 66, 54, 32, 73, 83, 79, 103, 114, 107, 51, 0, 101, 116, 97, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 101, 116, 97, 44, 32, 85, 43, 48, 51, 66, 55, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 116, 104, 101, 116, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 116, 104, 101, 116, 97, 44, 32, 85, 43, 48, 51, 66, 56, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 105, 111, 116, 97, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 105, 111, 116, 97, 44, 32, 85, 43, 48, 51, 66, 57, 32, 73, 83, 79, 103, 114, 107, 51, 0, 107, 97, 112, 112, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 107, 97, 112, 112, 97, 44, 32, 85, 43, 48, 51, 66, 65, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 108, 97, 109, 98, 100, 97, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 108, 97, 109, 98, 100, 97, 44, 32, 85, 43, 48, 51, 66, 66, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 109, 117, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 109, 117, 44, 32, 85, 43, 48, 51, 66, 67, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 110, 117, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 110, 117, 44, 32, 85, 43, 48, 51, 66, 68, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 120, 105, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 120, 105, 44, 32, 85, 43, 48, 51, 66, 69, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 111, 109, 105, 99, 114, 111, 110, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 109, 105, 99, 114, 111, 110, 44, 32, 85, 43, 48, 51, 66, 70, 32, 78, 69, 87, 0, 0, 112, 105, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 112, 105, 44, 32, 85, 43, 48, 51, 67, 48, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 114, 104, 111, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 114, 104, 111, 44, 32, 85, 43, 48, 51, 67, 49, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 115, 105, 103, 109, 97, 102, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 102, 105, 110, 97, 108, 32, 115, 105, 103, 109, 97, 44, 32, 85, 43, 48, 51, 67, 50, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 115, 105, 103, 109, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 115, 105, 103, 109, 97, 44, 32, 85, 43, 48, 51, 67, 51, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 116, 97, 117, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 116, 97, 117, 44, 32, 85, 43, 48, 51, 67, 52, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 117, 112, 115, 105, 108, 111, 110, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 117, 112, 115, 105, 108, 111, 110, 44, 32, 85, 43, 48, 51, 67, 53, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 112, 104, 105, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 112, 104, 105, 44, 32, 85, 43, 48, 51, 67, 54, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 99, 104, 105, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 99, 104, 105, 44, 32, 85, 43, 48, 51, 67, 55, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 112, 115, 105, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 112, 115, 105, 44, 32, 85, 43, 48, 51, 67, 56, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 111, 109, 101, 103, 97, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 111, 109, 101, 103, 97, 44, 32, 85, 43, 48, 51, 67, 57, 32, 73, 83, 79, 103, 114, 107, 51, 0, 0, 0, 0, 0, 0, 0, 0, 116, 104, 101, 116, 97, 115, 121, 109, 0, 0, 0, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 115, 109, 97, 108, 108, 32, 108, 101, 116, 116, 101, 114, 32, 116, 104, 101, 116, 97, 32, 115, 121, 109, 98, 111, 108, 44, 32, 85, 43, 48, 51, 68, 49, 32, 78, 69, 87, 0, 0, 0, 0, 0, 117, 112, 115, 105, 104, 0, 0, 0, 103, 114, 101, 101, 107, 32, 117, 112, 115, 105, 108, 111, 110, 32, 119, 105, 116, 104, 32, 104, 111, 111, 107, 32, 115, 121, 109, 98, 111, 108, 44, 32, 85, 43, 48, 51, 68, 50, 32, 78, 69, 87, 0, 0, 0, 0, 0, 0, 112, 105, 118, 0, 0, 0, 0, 0, 103, 114, 101, 101, 107, 32, 112, 105, 32, 115, 121, 109, 98, 111, 108, 44, 32, 85, 43, 48, 51, 68, 54, 32, 73, 83, 79, 103, 114, 107, 51, 0, 101, 110, 115, 112, 0, 0, 0, 0, 101, 110, 32, 115, 112, 97, 99, 101, 44, 32, 85, 43, 50, 48, 48, 50, 32, 73, 83, 79, 112, 117, 98, 0, 101, 109, 115, 112, 0, 0, 0, 0, 101, 109, 32, 115, 112, 97, 99, 101, 44, 32, 85, 43, 50, 48, 48, 51, 32, 73, 83, 79, 112, 117, 98, 0, 116, 104, 105, 110, 115, 112, 0, 0, 116, 104, 105, 110, 32, 115, 112, 97, 99, 101, 44, 32, 85, 43, 50, 48, 48, 57, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 0, 0, 0, 122, 119, 110, 106, 0, 0, 0, 0, 122, 101, 114, 111, 32, 119, 105, 100, 116, 104, 32, 110, 111, 110, 45, 106, 111, 105, 110, 101, 114, 44, 32, 85, 43, 50, 48, 48, 67, 32, 78, 69, 87, 32, 82, 70, 67, 32, 50, 48, 55, 48, 0, 0, 0, 0, 0, 0, 122, 119, 106, 0, 0, 0, 0, 0, 122, 101, 114, 111, 32, 119, 105, 100, 116, 104, 32, 106, 111, 105, 110, 101, 114, 44, 32, 85, 43, 50, 48, 48, 68, 32, 78, 69, 87, 32, 82, 70, 67, 32, 50, 48, 55, 48, 0, 0, 108, 114, 109, 0, 0, 0, 0, 0, 108, 101, 102, 116, 45, 116, 111, 45, 114, 105, 103, 104, 116, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 48, 69, 32, 78, 69, 87, 32, 82, 70, 67, 32, 50, 48, 55, 48, 0, 114, 108, 109, 0, 0, 0, 0, 0, 114, 105, 103, 104, 116, 45, 116, 111, 45, 108, 101, 102, 116, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 48, 70, 32, 78, 69, 87, 32, 82, 70, 67, 32, 50, 48, 55, 48, 0, 110, 100, 97, 115, 104, 0, 0, 0, 101, 110, 32, 100, 97, 115, 104, 44, 32, 85, 43, 50, 48, 49, 51, 32, 73, 83, 79, 112, 117, 98, 0, 0, 109, 100, 97, 115, 104, 0, 0, 0, 101, 109, 32, 100, 97, 115, 104, 44, 32, 85, 43, 50, 48, 49, 52, 32, 73, 83, 79, 112, 117, 98, 0, 0, 108, 115, 113, 117, 111, 0, 0, 0, 108, 101, 102, 116, 32, 115, 105, 110, 103, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 49, 56, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 114, 115, 113, 117, 111, 0, 0, 0, 114, 105, 103, 104, 116, 32, 115, 105, 110, 103, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 49, 57, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 115, 98, 113, 117, 111, 0, 0, 0, 115, 105, 110, 103, 108, 101, 32, 108, 111, 119, 45, 57, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 49, 65, 32, 78, 69, 87, 0, 108, 100, 113, 117, 111, 0, 0, 0, 108, 101, 102, 116, 32, 100, 111, 117, 98, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 49, 67, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 0, 114, 100, 113, 117, 111, 0, 0, 0, 114, 105, 103, 104, 116, 32, 100, 111, 117, 98, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 49, 68, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 0, 0, 98, 100, 113, 117, 111, 0, 0, 0, 100, 111, 117, 98, 108, 101, 32, 108, 111, 119, 45, 57, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 49, 69, 32, 78, 69, 87, 0, 100, 97, 103, 103, 101, 114, 0, 0, 100, 97, 103, 103, 101, 114, 44, 32, 85, 43, 50, 48, 50, 48, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 68, 97, 103, 103, 101, 114, 0, 0, 100, 111, 117, 98, 108, 101, 32, 100, 97, 103, 103, 101, 114, 44, 32, 85, 43, 50, 48, 50, 49, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 98, 117, 108, 108, 0, 0, 0, 0, 98, 117, 108, 108, 101, 116, 32, 61, 32, 98, 108, 97, 99, 107, 32, 115, 109, 97, 108, 108, 32, 99, 105, 114, 99, 108, 101, 44, 32, 85, 43, 50, 48, 50, 50, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 0, 0, 104, 101, 108, 108, 105, 112, 0, 0, 104, 111, 114, 105, 122, 111, 110, 116, 97, 108, 32, 101, 108, 108, 105, 112, 115, 105, 115, 32, 61, 32, 116, 104, 114, 101, 101, 32, 100, 111, 116, 32, 108, 101, 97, 100, 101, 114, 44, 32, 85, 43, 50, 48, 50, 54, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 112, 101, 114, 109, 105, 108, 0, 0, 112, 101, 114, 32, 109, 105, 108, 108, 101, 32, 115, 105, 103, 110, 44, 32, 85, 43, 50, 48, 51, 48, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 112, 114, 105, 109, 101, 0, 0, 0, 112, 114, 105, 109, 101, 32, 61, 32, 109, 105, 110, 117, 116, 101, 115, 32, 61, 32, 102, 101, 101, 116, 44, 32, 85, 43, 50, 48, 51, 50, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 80, 114, 105, 109, 101, 0, 0, 0, 100, 111, 117, 98, 108, 101, 32, 112, 114, 105, 109, 101, 32, 61, 32, 115, 101, 99, 111, 110, 100, 115, 32, 61, 32, 105, 110, 99, 104, 101, 115, 44, 32, 85, 43, 50, 48, 51, 51, 32, 73, 83, 79, 116, 101, 99, 104, 0, 108, 115, 97, 113, 117, 111, 0, 0, 115, 105, 110, 103, 108, 101, 32, 108, 101, 102, 116, 45, 112, 111, 105, 110, 116, 105, 110, 103, 32, 97, 110, 103, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 51, 57, 32, 73, 83, 79, 32, 112, 114, 111, 112, 111, 115, 101, 100, 0, 0, 114, 115, 97, 113, 117, 111, 0, 0, 115, 105, 110, 103, 108, 101, 32, 114, 105, 103, 104, 116, 45, 112, 111, 105, 110, 116, 105, 110, 103, 32, 97, 110, 103, 108, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 44, 32, 85, 43, 50, 48, 51, 65, 32, 73, 83, 79, 32, 112, 114, 111, 112, 111, 115, 101, 100, 0, 111, 108, 105, 110, 101, 0, 0, 0, 111, 118, 101, 114, 108, 105, 110, 101, 32, 61, 32, 115, 112, 97, 99, 105, 110, 103, 32, 111, 118, 101, 114, 115, 99, 111, 114, 101, 44, 32, 85, 43, 50, 48, 51, 69, 32, 78, 69, 87, 0, 0, 0, 0, 0, 0, 0, 0, 102, 114, 97, 115, 108, 0, 0, 0, 102, 114, 97, 99, 116, 105, 111, 110, 32, 115, 108, 97, 115, 104, 44, 32, 85, 43, 50, 48, 52, 52, 32, 78, 69, 87, 0, 0, 0, 0, 0, 0, 101, 117, 114, 111, 0, 0, 0, 0, 101, 117, 114, 111, 32, 115, 105, 103, 110, 44, 32, 85, 43, 50, 48, 65, 67, 32, 78, 69, 87, 0, 0, 0, 105, 109, 97, 103, 101, 0, 0, 0, 98, 108, 97, 99, 107, 108, 101, 116, 116, 101, 114, 32, 99, 97, 112, 105, 116, 97, 108, 32, 73, 32, 61, 32, 105, 109, 97, 103, 105, 110, 97, 114, 121, 32, 112, 97, 114, 116, 44, 32, 85, 43, 50, 49, 49, 49, 32, 73, 83, 79, 97, 109, 115, 111, 0, 0, 119, 101, 105, 101, 114, 112, 0, 0, 115, 99, 114, 105, 112, 116, 32, 99, 97, 112, 105, 116, 97, 108, 32, 80, 32, 61, 32, 112, 111, 119, 101, 114, 32, 115, 101, 116, 32, 61, 32, 87, 101, 105, 101, 114, 115, 116, 114, 97, 115, 115, 32, 112, 44, 32, 85, 43, 50, 49, 49, 56, 32, 73, 83, 79, 97, 109, 115, 111, 0, 0, 0, 0, 114, 101, 97, 108, 0, 0, 0, 0, 98, 108, 97, 99, 107, 108, 101, 116, 116, 101, 114, 32, 99, 97, 112, 105, 116, 97, 108, 32, 82, 32, 61, 32, 114, 101, 97, 108, 32, 112, 97, 114, 116, 32, 115, 121, 109, 98, 111, 108, 44, 32, 85, 43, 50, 49, 49, 67, 32, 73, 83, 79, 97, 109, 115, 111, 0, 0, 0, 0, 0, 0, 0, 0, 116, 114, 97, 100, 101, 0, 0, 0, 116, 114, 97, 100, 101, 32, 109, 97, 114, 107, 32, 115, 105, 103, 110, 44, 32, 85, 43, 50, 49, 50, 50, 32, 73, 83, 79, 110, 117, 109, 0, 0, 97, 108, 101, 102, 115, 121, 109, 0, 97, 108, 101, 102, 32, 115, 121, 109, 98, 111, 108, 32, 61, 32, 102, 105, 114, 115, 116, 32, 116, 114, 97, 110, 115, 102, 105, 110, 105, 116, 101, 32, 99, 97, 114, 100, 105, 110, 97, 108, 44, 32, 85, 43, 50, 49, 51, 53, 32, 78, 69, 87, 0, 0, 0, 0, 108, 97, 114, 114, 0, 0, 0, 0, 108, 101, 102, 116, 119, 97, 114, 100, 115, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 57, 48, 32, 73, 83, 79, 110, 117, 109, 0, 0, 117, 97, 114, 114, 0, 0, 0, 0, 117, 112, 119, 97, 114, 100, 115, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 57, 49, 32, 73, 83, 79, 110, 117, 109, 0, 0, 0, 0, 114, 97, 114, 114, 0, 0, 0, 0, 114, 105, 103, 104, 116, 119, 97, 114, 100, 115, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 57, 50, 32, 73, 83, 79, 110, 117, 109, 0, 100, 97, 114, 114, 0, 0, 0, 0, 100, 111, 119, 110, 119, 97, 114, 100, 115, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 57, 51, 32, 73, 83, 79, 110, 117, 109, 0, 0, 104, 97, 114, 114, 0, 0, 0, 0, 108, 101, 102, 116, 32, 114, 105, 103, 104, 116, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 57, 52, 32, 73, 83, 79, 97, 109, 115, 97, 0, 0, 0, 0, 0, 0, 0, 0, 99, 114, 97, 114, 114, 0, 0, 0, 100, 111, 119, 110, 119, 97, 114, 100, 115, 32, 97, 114, 114, 111, 119, 32, 119, 105, 116, 104, 32, 99, 111, 114, 110, 101, 114, 32, 108, 101, 102, 116, 119, 97, 114, 100, 115, 32, 61, 32, 99, 97, 114, 114, 105, 97, 103, 101, 32, 114, 101, 116, 117, 114, 110, 44, 32, 85, 43, 50, 49, 66, 53, 32, 78, 69, 87, 0, 0, 0, 0, 0, 108, 65, 114, 114, 0, 0, 0, 0, 108, 101, 102, 116, 119, 97, 114, 100, 115, 32, 100, 111, 117, 98, 108, 101, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 68, 48, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 117, 65, 114, 114, 0, 0, 0, 0, 117, 112, 119, 97, 114, 100, 115, 32, 100, 111, 117, 98, 108, 101, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 68, 49, 32, 73, 83, 79, 97, 109, 115, 97, 0, 0, 0, 0, 114, 65, 114, 114, 0, 0, 0, 0, 114, 105, 103, 104, 116, 119, 97, 114, 100, 115, 32, 100, 111, 117, 98, 108, 101, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 68, 50, 32, 73, 83, 79, 116, 101, 99, 104, 0, 100, 65, 114, 114, 0, 0, 0, 0, 100, 111, 119, 110, 119, 97, 114, 100, 115, 32, 100, 111, 117, 98, 108, 101, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 68, 51, 32, 73, 83, 79, 97, 109, 115, 97, 0, 0, 104, 65, 114, 114, 0, 0, 0, 0, 108, 101, 102, 116, 32, 114, 105, 103, 104, 116, 32, 100, 111, 117, 98, 108, 101, 32, 97, 114, 114, 111, 119, 44, 32, 85, 43, 50, 49, 68, 52, 32, 73, 83, 79, 97, 109, 115, 97, 0, 102, 111, 114, 97, 108, 108, 0, 0, 102, 111, 114, 32, 97, 108, 108, 44, 32, 85, 43, 50, 50, 48, 48, 32, 73, 83, 79, 116, 101, 99, 104, 0, 112, 97, 114, 116, 0, 0, 0, 0, 112, 97, 114, 116, 105, 97, 108, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 105, 97, 108, 44, 32, 85, 43, 50, 50, 48, 50, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 101, 120, 105, 115, 116, 0, 0, 0, 116, 104, 101, 114, 101, 32, 101, 120, 105, 115, 116, 115, 44, 32, 85, 43, 50, 50, 48, 51, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 101, 109, 112, 116, 121, 0, 0, 0, 101, 109, 112, 116, 121, 32, 115, 101, 116, 32, 61, 32, 110, 117, 108, 108, 32, 115, 101, 116, 32, 61, 32, 100, 105, 97, 109, 101, 116, 101, 114, 44, 32, 85, 43, 50, 50, 48, 53, 32, 73, 83, 79, 97, 109, 115, 111, 0, 110, 97, 98, 108, 97, 0, 0, 0, 110, 97, 98, 108, 97, 32, 61, 32, 98, 97, 99, 107, 119, 97, 114, 100, 32, 100, 105, 102, 102, 101, 114, 101, 110, 99, 101, 44, 32, 85, 43, 50, 50, 48, 55, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 105, 115, 105, 110, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 111, 102, 44, 32, 85, 43, 50, 50, 48, 56, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 110, 111, 116, 105, 110, 0, 0, 0, 110, 111, 116, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 111, 102, 44, 32, 85, 43, 50, 50, 48, 57, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 110, 105, 0, 0, 0, 0, 0, 0, 99, 111, 110, 116, 97, 105, 110, 115, 32, 97, 115, 32, 109, 101, 109, 98, 101, 114, 44, 32, 85, 43, 50, 50, 48, 66, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 112, 114, 111, 100, 0, 0, 0, 0, 110, 45, 97, 114, 121, 32, 112, 114, 111, 100, 117, 99, 116, 32, 61, 32, 112, 114, 111, 100, 117, 99, 116, 32, 115, 105, 103, 110, 44, 32, 85, 43, 50, 50, 48, 70, 32, 73, 83, 79, 97, 109, 115, 98, 0, 0, 0, 0, 115, 117, 109, 0, 0, 0, 0, 0, 110, 45, 97, 114, 121, 32, 115, 117, 109, 109, 97, 116, 105, 111, 110, 44, 32, 85, 43, 50, 50, 49, 49, 32, 73, 83, 79, 97, 109, 115, 98, 0, 109, 105, 110, 117, 115, 0, 0, 0, 109, 105, 110, 117, 115, 32, 115, 105, 103, 110, 44, 32, 85, 43, 50, 50, 49, 50, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 108, 111, 119, 97, 115, 116, 0, 0, 97, 115, 116, 101, 114, 105, 115, 107, 32, 111, 112, 101, 114, 97, 116, 111, 114, 44, 32, 85, 43, 50, 50, 49, 55, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 114, 97, 100, 105, 99, 0, 0, 0, 115, 113, 117, 97, 114, 101, 32, 114, 111, 111, 116, 32, 61, 32, 114, 97, 100, 105, 99, 97, 108, 32, 115, 105, 103, 110, 44, 32, 85, 43, 50, 50, 49, 65, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 112, 114, 111, 112, 0, 0, 0, 0, 112, 114, 111, 112, 111, 114, 116, 105, 111, 110, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 49, 68, 32, 73, 83, 79, 116, 101, 99, 104, 0, 105, 110, 102, 105, 110, 0, 0, 0, 105, 110, 102, 105, 110, 105, 116, 121, 44, 32, 85, 43, 50, 50, 49, 69, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 103, 0, 0, 0, 0, 0, 97, 110, 103, 108, 101, 44, 32, 85, 43, 50, 50, 50, 48, 32, 73, 83, 79, 97, 109, 115, 111, 0, 0, 0, 97, 110, 100, 0, 0, 0, 0, 0, 108, 111, 103, 105, 99, 97, 108, 32, 97, 110, 100, 32, 61, 32, 119, 101, 100, 103, 101, 44, 32, 85, 43, 50, 50, 50, 55, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 111, 114, 0, 0, 0, 0, 0, 0, 108, 111, 103, 105, 99, 97, 108, 32, 111, 114, 32, 61, 32, 118, 101, 101, 44, 32, 85, 43, 50, 50, 50, 56, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 112, 0, 0, 0, 0, 0, 105, 110, 116, 101, 114, 115, 101, 99, 116, 105, 111, 110, 32, 61, 32, 99, 97, 112, 44, 32, 85, 43, 50, 50, 50, 57, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 99, 117, 112, 0, 0, 0, 0, 0, 117, 110, 105, 111, 110, 32, 61, 32, 99, 117, 112, 44, 32, 85, 43, 50, 50, 50, 65, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 105, 110, 116, 0, 0, 0, 0, 0, 105, 110, 116, 101, 103, 114, 97, 108, 44, 32, 85, 43, 50, 50, 50, 66, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 0, 116, 104, 101, 114, 101, 52, 0, 0, 116, 104, 101, 114, 101, 102, 111, 114, 101, 44, 32, 85, 43, 50, 50, 51, 52, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 115, 105, 109, 0, 0, 0, 0, 0, 116, 105, 108, 100, 101, 32, 111, 112, 101, 114, 97, 116, 111, 114, 32, 61, 32, 118, 97, 114, 105, 101, 115, 32, 119, 105, 116, 104, 32, 61, 32, 115, 105, 109, 105, 108, 97, 114, 32, 116, 111, 44, 32, 85, 43, 50, 50, 51, 67, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 99, 111, 110, 103, 0, 0, 0, 0, 97, 112, 112, 114, 111, 120, 105, 109, 97, 116, 101, 108, 121, 32, 101, 113, 117, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 52, 53, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 97, 115, 121, 109, 112, 0, 0, 0, 97, 108, 109, 111, 115, 116, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 61, 32, 97, 115, 121, 109, 112, 116, 111, 116, 105, 99, 32, 116, 111, 44, 32, 85, 43, 50, 50, 52, 56, 32, 73, 83, 79, 97, 109, 115, 114, 0, 110, 101, 0, 0, 0, 0, 0, 0, 110, 111, 116, 32, 101, 113, 117, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 54, 48, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 101, 113, 117, 105, 118, 0, 0, 0, 105, 100, 101, 110, 116, 105, 99, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 54, 49, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 108, 101, 0, 0, 0, 0, 0, 0, 108, 101, 115, 115, 45, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 54, 52, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 103, 101, 0, 0, 0, 0, 0, 0, 103, 114, 101, 97, 116, 101, 114, 45, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 54, 53, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 0, 115, 117, 98, 0, 0, 0, 0, 0, 115, 117, 98, 115, 101, 116, 32, 111, 102, 44, 32, 85, 43, 50, 50, 56, 50, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 115, 117, 112, 0, 0, 0, 0, 0, 115, 117, 112, 101, 114, 115, 101, 116, 32, 111, 102, 44, 32, 85, 43, 50, 50, 56, 51, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 110, 115, 117, 98, 0, 0, 0, 0, 110, 111, 116, 32, 97, 32, 115, 117, 98, 115, 101, 116, 32, 111, 102, 44, 32, 85, 43, 50, 50, 56, 52, 32, 73, 83, 79, 97, 109, 115, 110, 0, 115, 117, 98, 101, 0, 0, 0, 0, 115, 117, 98, 115, 101, 116, 32, 111, 102, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 56, 54, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 115, 117, 112, 101, 0, 0, 0, 0, 115, 117, 112, 101, 114, 115, 101, 116, 32, 111, 102, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 44, 32, 85, 43, 50, 50, 56, 55, 32, 73, 83, 79, 116, 101, 99, 104, 0, 111, 112, 108, 117, 115, 0, 0, 0, 99, 105, 114, 99, 108, 101, 100, 32, 112, 108, 117, 115, 32, 61, 32, 100, 105, 114, 101, 99, 116, 32, 115, 117, 109, 44, 32, 85, 43, 50, 50, 57, 53, 32, 73, 83, 79, 97, 109, 115, 98, 0, 0, 0, 0, 0, 0, 0, 111, 116, 105, 109, 101, 115, 0, 0, 99, 105, 114, 99, 108, 101, 100, 32, 116, 105, 109, 101, 115, 32, 61, 32, 118, 101, 99, 116, 111, 114, 32, 112, 114, 111, 100, 117, 99, 116, 44, 32, 85, 43, 50, 50, 57, 55, 32, 73, 83, 79, 97, 109, 115, 98, 0, 0, 112, 101, 114, 112, 0, 0, 0, 0, 117, 112, 32, 116, 97, 99, 107, 32, 61, 32, 111, 114, 116, 104, 111, 103, 111, 110, 97, 108, 32, 116, 111, 32, 61, 32, 112, 101, 114, 112, 101, 110, 100, 105, 99, 117, 108, 97, 114, 44, 32, 85, 43, 50, 50, 65, 53, 32, 73, 83, 79, 116, 101, 99, 104, 0, 115, 100, 111, 116, 0, 0, 0, 0, 100, 111, 116, 32, 111, 112, 101, 114, 97, 116, 111, 114, 44, 32, 85, 43, 50, 50, 67, 53, 32, 73, 83, 79, 97, 109, 115, 98, 0, 0, 0, 0, 108, 99, 101, 105, 108, 0, 0, 0, 108, 101, 102, 116, 32, 99, 101, 105, 108, 105, 110, 103, 32, 61, 32, 97, 112, 108, 32, 117, 112, 115, 116, 105, 108, 101, 44, 32, 85, 43, 50, 51, 48, 56, 32, 73, 83, 79, 97, 109, 115, 99, 0, 0, 0, 0, 0, 0, 114, 99, 101, 105, 108, 0, 0, 0, 114, 105, 103, 104, 116, 32, 99, 101, 105, 108, 105, 110, 103, 44, 32, 85, 43, 50, 51, 48, 57, 32, 73, 83, 79, 97, 109, 115, 99, 0, 0, 0, 108, 102, 108, 111, 111, 114, 0, 0, 108, 101, 102, 116, 32, 102, 108, 111, 111, 114, 32, 61, 32, 97, 112, 108, 32, 100, 111, 119, 110, 115, 116, 105, 108, 101, 44, 32, 85, 43, 50, 51, 48, 65, 32, 73, 83, 79, 97, 109, 115, 99, 0, 0, 0, 0, 0, 0, 114, 102, 108, 111, 111, 114, 0, 0, 114, 105, 103, 104, 116, 32, 102, 108, 111, 111, 114, 44, 32, 85, 43, 50, 51, 48, 66, 32, 73, 83, 79, 97, 109, 115, 99, 0, 0, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 108, 101, 102, 116, 45, 112, 111, 105, 110, 116, 105, 110, 103, 32, 97, 110, 103, 108, 101, 32, 98, 114, 97, 99, 107, 101, 116, 32, 61, 32, 98, 114, 97, 44, 32, 85, 43, 50, 51, 50, 57, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 0, 114, 97, 110, 103, 0, 0, 0, 0, 114, 105, 103, 104, 116, 45, 112, 111, 105, 110, 116, 105, 110, 103, 32, 97, 110, 103, 108, 101, 32, 98, 114, 97, 99, 107, 101, 116, 32, 61, 32, 107, 101, 116, 44, 32, 85, 43, 50, 51, 50, 65, 32, 73, 83, 79, 116, 101, 99, 104, 0, 0, 0, 0, 0, 0, 108, 111, 122, 0, 0, 0, 0, 0, 108, 111, 122, 101, 110, 103, 101, 44, 32, 85, 43, 50, 53, 67, 65, 32, 73, 83, 79, 112, 117, 98, 0, 0, 115, 112, 97, 100, 101, 115, 0, 0, 98, 108, 97, 99, 107, 32, 115, 112, 97, 100, 101, 32, 115, 117, 105, 116, 44, 32, 85, 43, 50, 54, 54, 48, 32, 73, 83, 79, 112, 117, 98, 0, 99, 108, 117, 98, 115, 0, 0, 0, 98, 108, 97, 99, 107, 32, 99, 108, 117, 98, 32, 115, 117, 105, 116, 32, 61, 32, 115, 104, 97, 109, 114, 111, 99, 107, 44, 32, 85, 43, 50, 54, 54, 51, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 0, 0, 0, 104, 101, 97, 114, 116, 115, 0, 0, 98, 108, 97, 99, 107, 32, 104, 101, 97, 114, 116, 32, 115, 117, 105, 116, 32, 61, 32, 118, 97, 108, 101, 110, 116, 105, 110, 101, 44, 32, 85, 43, 50, 54, 54, 53, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 0, 100, 105, 97, 109, 115, 0, 0, 0, 98, 108, 97, 99, 107, 32, 100, 105, 97, 109, 111, 110, 100, 32, 115, 117, 105, 116, 44, 32, 85, 43, 50, 54, 54, 54, 32, 73, 83, 79, 112, 117, 98, 0, 0, 0, 0, 0, 0, 0, 111, 110, 99, 108, 105, 99, 107, 0, 111, 110, 100, 98, 108, 99, 108, 105, 99, 107, 0, 0, 0, 0, 0, 0, 111, 110, 109, 111, 117, 115, 101, 100, 111, 119, 110, 0, 0, 0, 0, 0, 111, 110, 109, 111, 117, 115, 101, 117, 112, 0, 0, 0, 0, 0, 0, 0, 111, 110, 109, 111, 117, 115, 101, 111, 118, 101, 114, 0, 0, 0, 0, 0, 111, 110, 109, 111, 117, 115, 101, 111, 117, 116, 0, 0, 0, 0, 0, 0, 111, 110, 107, 101, 121, 112, 114, 101, 115, 115, 0, 0, 0, 0, 0, 0, 111, 110, 107, 101, 121, 100, 111, 119, 110, 0, 0, 0, 0, 0, 0, 0, 111, 110, 107, 101, 121, 117, 112, 0, 111, 110, 108, 111, 97, 100, 0, 0, 111, 110, 117, 110, 108, 111, 97, 100, 0, 0, 0, 0, 0, 0, 0, 0, 111, 110, 102, 111, 99, 117, 115, 0, 111, 110, 98, 108, 117, 114, 0, 0, 111, 110, 115, 117, 98, 109, 105, 116, 0, 0, 0, 0, 0, 0, 0, 0, 111, 110, 114, 101, 115, 101, 116, 0, 111, 110, 99, 104, 97, 110, 103, 101, 0, 0, 0, 0, 0, 0, 0, 0, 111, 110, 115, 101, 108, 101, 99, 116, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 99, 104, 111, 114, 32, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 96, 114, 1, 0, 112, 212, 1, 0, 168, 212, 1, 0, 128, 214, 1, 0, 136, 214, 1, 0, 152, 214, 1, 0, 160, 214, 1, 0, 224, 212, 1, 0, 8, 216, 1, 0, 16, 216, 1, 0, 208, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 216, 1, 0, 0, 0, 0, 0, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 100, 32, 102, 111, 114, 109, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 32, 111, 110, 32, 97, 117, 116, 104, 111, 114, 32, 0, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 176, 119, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 97, 118, 97, 32, 97, 112, 112, 108, 101, 116, 32, 0, 0, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 160, 206, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 56, 214, 1, 0, 96, 214, 1, 0, 200, 214, 1, 0, 168, 212, 1, 0, 0, 213, 1, 0, 248, 212, 1, 0, 48, 213, 1, 0, 24, 214, 1, 0, 32, 214, 1, 0, 0, 0, 0, 0, 97, 114, 101, 97, 0, 0, 0, 0, 99, 108, 105, 101, 110, 116, 45, 115, 105, 100, 101, 32, 105, 109, 97, 103, 101, 32, 109, 97, 112, 32, 97, 114, 101, 97, 32, 0, 0, 0, 0, 0, 8, 216, 1, 0, 16, 216, 1, 0, 128, 214, 1, 0, 24, 216, 1, 0, 208, 212, 1, 0, 224, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 214, 1, 0, 0, 0, 0, 0, 98, 111, 108, 100, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 100, 111, 99, 117, 109, 101, 110, 116, 32, 98, 97, 115, 101, 32, 117, 114, 105, 32, 0, 0, 0, 0, 0, 0, 128, 214, 1, 0, 0, 0, 0, 0, 98, 97, 115, 101, 102, 111, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 32, 102, 111, 110, 116, 32, 115, 105, 122, 101, 32, 0, 152, 212, 1, 0, 160, 213, 1, 0, 128, 215, 1, 0, 136, 215, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 49, 56, 110, 32, 98, 105, 100, 105, 32, 111, 118, 101, 114, 45, 114, 105, 100, 101, 32, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 191, 1, 0, 0, 0, 0, 0, 108, 97, 114, 103, 101, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 108, 111, 110, 103, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 136, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 111, 99, 117, 109, 101, 110, 116, 32, 98, 111, 100, 121, 32, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 16, 122, 1, 0, 160, 121, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 192, 181, 1, 0, 200, 181, 1, 0, 0, 0, 0, 0, 224, 215, 1, 0, 128, 212, 1, 0, 240, 215, 1, 0, 208, 119, 1, 0, 248, 215, 1, 0, 0, 216, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 114, 0, 0, 0, 0, 0, 0, 102, 111, 114, 99, 101, 100, 32, 108, 105, 110, 101, 32, 98, 114, 101, 97, 107, 32, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 215, 1, 0, 0, 0, 0, 0, 112, 117, 115, 104, 32, 98, 117, 116, 116, 111, 110, 32, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 168, 212, 1, 0, 232, 213, 1, 0, 112, 212, 1, 0, 176, 212, 1, 0, 208, 212, 1, 0, 224, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 99, 97, 112, 116, 105, 111, 110, 32, 0, 0, 115, 104, 111, 114, 116, 104, 97, 110, 100, 32, 102, 111, 114, 32, 100, 105, 118, 32, 97, 108, 105, 103, 110, 61, 99, 101, 110, 116, 101, 114, 32, 0, 99, 105, 116, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 109, 112, 117, 116, 101, 114, 32, 99, 111, 100, 101, 32, 102, 114, 97, 103, 109, 101, 110, 116, 0, 0, 99, 111, 108, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 99, 111, 108, 117, 109, 110, 32, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 120, 122, 1, 0, 248, 212, 1, 0, 48, 213, 1, 0, 56, 213, 1, 0, 64, 213, 1, 0, 72, 213, 1, 0, 0, 0, 0, 0, 99, 111, 108, 103, 114, 111, 117, 112, 0, 0, 0, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 99, 111, 108, 117, 109, 110, 32, 103, 114, 111, 117, 112, 32, 0, 0, 0, 0, 0, 176, 190, 1, 0, 0, 0, 0, 0, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 0, 100, 101, 108, 101, 116, 101, 100, 32, 116, 101, 120, 116, 32, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 200, 215, 1, 0, 136, 121, 1, 0, 0, 0, 0, 0, 105, 110, 115, 116, 97, 110, 99, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 100, 105, 114, 0, 0, 0, 0, 0, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 108, 105, 115, 116, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 48, 122, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 120, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 101, 110, 101, 114, 105, 99, 32, 108, 97, 110, 103, 117, 97, 103, 101, 47, 115, 116, 121, 108, 101, 32, 99, 111, 110, 116, 97, 105, 110, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 48, 213, 1, 0, 0, 0, 0, 0, 100, 108, 0, 0, 0, 0, 0, 0, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 108, 105, 115, 116, 32, 0, 0, 0, 0, 0, 0, 0, 0, 176, 121, 1, 0, 152, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 212, 1, 0, 0, 0, 0, 0, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 116, 101, 114, 109, 32, 0, 0, 0, 0, 0, 0, 0, 0, 101, 109, 112, 104, 97, 115, 105, 115, 0, 0, 0, 0, 0, 0, 0, 0, 101, 109, 98, 101, 100, 0, 0, 0, 103, 101, 110, 101, 114, 105, 99, 32, 101, 109, 98, 101, 100, 100, 101, 100, 32, 111, 98, 106, 101, 99, 116, 32, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 48, 213, 1, 0, 200, 214, 1, 0, 88, 213, 1, 0, 144, 121, 1, 0, 56, 214, 1, 0, 240, 214, 1, 0, 0, 213, 1, 0, 144, 215, 1, 0, 24, 214, 1, 0, 168, 212, 1, 0, 152, 215, 1, 0, 160, 215, 1, 0, 176, 215, 1, 0, 200, 213, 1, 0, 112, 212, 1, 0, 192, 215, 1, 0, 32, 214, 1, 0, 248, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 105, 101, 108, 100, 115, 101, 116, 0, 0, 0, 0, 0, 0, 0, 0, 102, 111, 114, 109, 32, 99, 111, 110, 116, 114, 111, 108, 32, 103, 114, 111, 117, 112, 32, 0, 0, 0, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 40, 122, 1, 0, 108, 111, 99, 97, 108, 32, 99, 104, 97, 110, 103, 101, 32, 116, 111, 32, 102, 111, 110, 116, 32, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 160, 213, 1, 0, 128, 215, 1, 0, 136, 215, 1, 0, 0, 0, 0, 0, 105, 110, 116, 101, 114, 97, 99, 116, 105, 118, 101, 32, 102, 111, 114, 109, 32, 0, 0, 0, 0, 0, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 105328);
	        allocate([88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 96, 215, 1, 0, 104, 215, 1, 0, 216, 214, 1, 0, 168, 212, 1, 0, 232, 181, 1, 0, 248, 181, 1, 0, 112, 215, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 215, 1, 0, 0, 0, 0, 0, 115, 117, 98, 119, 105, 110, 100, 111, 119, 32, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 224, 214, 1, 0, 168, 212, 1, 0, 200, 213, 1, 0, 240, 214, 1, 0, 0, 215, 1, 0, 16, 215, 1, 0, 72, 215, 1, 0, 32, 215, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 105, 110, 100, 111, 119, 32, 115, 117, 98, 100, 105, 118, 105, 115, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 120, 1, 0, 248, 119, 1, 0, 232, 119, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 136, 212, 1, 0, 144, 212, 1, 0, 192, 181, 1, 0, 200, 181, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 101, 97, 100, 105, 110, 103, 32, 0, 0, 0, 0, 0, 0, 0, 0, 100, 111, 99, 117, 109, 101, 110, 116, 32, 104, 101, 97, 100, 32, 0, 0, 216, 119, 1, 0, 168, 199, 1, 0, 224, 119, 1, 0, 16, 115, 1, 0, 24, 115, 1, 0, 200, 119, 1, 0, 208, 119, 1, 0, 72, 122, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 215, 1, 0, 0, 0, 0, 0, 104, 114, 0, 0, 0, 0, 0, 0, 104, 111, 114, 105, 122, 111, 110, 116, 97, 108, 32, 114, 117, 108, 101, 32, 0, 0, 0, 0, 0, 0, 0, 0, 48, 213, 1, 0, 56, 215, 1, 0, 160, 213, 1, 0, 248, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 111, 99, 117, 109, 101, 110, 116, 32, 114, 111, 111, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 0, 0, 168, 117, 1, 0, 160, 117, 1, 0, 0, 120, 1, 0, 0, 0, 0, 0, 216, 179, 1, 0, 216, 191, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 215, 1, 0, 0, 0, 0, 0, 105, 116, 97, 108, 105, 99, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 0, 0, 0, 0, 0, 0, 105, 110, 108, 105, 110, 101, 32, 115, 117, 98, 119, 105, 110, 100, 111, 119, 32, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 224, 214, 1, 0, 168, 212, 1, 0, 200, 213, 1, 0, 240, 214, 1, 0, 0, 215, 1, 0, 16, 215, 1, 0, 32, 215, 1, 0, 48, 213, 1, 0, 0, 213, 1, 0, 248, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 109, 103, 0, 0, 0, 0, 0, 101, 109, 98, 101, 100, 100, 101, 100, 32, 105, 109, 97, 103, 101, 32, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 224, 214, 1, 0, 168, 212, 1, 0, 0, 213, 1, 0, 248, 212, 1, 0, 112, 214, 1, 0, 208, 214, 1, 0, 0, 0, 0, 0, 200, 213, 1, 0, 200, 214, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 112, 117, 116, 0, 0, 0, 102, 111, 114, 109, 32, 99, 111, 110, 116, 114, 111, 108, 32, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 112, 212, 1, 0, 168, 212, 1, 0, 232, 213, 1, 0, 176, 214, 1, 0, 176, 212, 1, 0, 192, 212, 1, 0, 160, 213, 1, 0, 184, 214, 1, 0, 200, 213, 1, 0, 200, 214, 1, 0, 112, 214, 1, 0, 208, 214, 1, 0, 208, 212, 1, 0, 224, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 16, 182, 1, 0, 0, 182, 1, 0, 216, 214, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 115, 101, 114, 116, 101, 100, 32, 116, 101, 120, 116, 0, 0, 0, 105, 115, 105, 110, 100, 101, 120, 0, 115, 105, 110, 103, 108, 101, 32, 108, 105, 110, 101, 32, 112, 114, 111, 109, 112, 116, 32, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 168, 214, 1, 0, 0, 0, 0, 0, 116, 101, 120, 116, 32, 116, 111, 32, 98, 101, 32, 101, 110, 116, 101, 114, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 117, 115, 101, 114, 0, 0, 102, 111, 114, 109, 32, 102, 105, 101, 108, 100, 32, 108, 97, 98, 101, 108, 32, 116, 101, 120, 116, 32, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 224, 213, 1, 0, 224, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 0, 0, 0, 0, 102, 105, 101, 108, 100, 115, 101, 116, 32, 108, 101, 103, 101, 110, 100, 32, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 224, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 105, 115, 116, 32, 105, 116, 101, 109, 32, 0, 0, 0, 0, 0, 0, 97, 32, 109, 101, 100, 105, 97, 45, 105, 110, 100, 101, 112, 101, 110, 100, 101, 110, 116, 32, 108, 105, 110, 107, 32, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 96, 114, 1, 0, 128, 214, 1, 0, 136, 214, 1, 0, 112, 212, 1, 0, 152, 214, 1, 0, 160, 214, 1, 0, 152, 213, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 97, 112, 0, 0, 0, 0, 0, 99, 108, 105, 101, 110, 116, 45, 115, 105, 100, 101, 32, 105, 109, 97, 103, 101, 32, 109, 97, 112, 32, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 184, 185, 1, 0, 0, 0, 0, 0, 168, 212, 1, 0, 0, 0, 0, 0, 109, 101, 110, 117, 0, 0, 0, 0, 109, 101, 110, 117, 32, 108, 105, 115, 116, 32, 0, 0, 0, 0, 0, 0, 103, 101, 110, 101, 114, 105, 99, 32, 109, 101, 116, 97, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 32, 0, 0, 0, 0, 0, 0, 0, 0, 216, 179, 1, 0, 216, 191, 1, 0, 80, 126, 1, 0, 168, 212, 1, 0, 120, 214, 1, 0, 96, 114, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 126, 1, 0, 0, 0, 0, 0, 97, 108, 116, 101, 114, 110, 97, 116, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 99, 111, 110, 116, 97, 105, 110, 101, 114, 32, 102, 111, 114, 32, 110, 111, 110, 32, 102, 114, 97, 109, 101, 45, 98, 97, 115, 101, 100, 32, 114, 101, 110, 100, 101, 114, 105, 110, 103, 32, 0, 0, 0, 0, 0, 0, 160, 117, 1, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 116, 101, 114, 110, 97, 116, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 99, 111, 110, 116, 97, 105, 110, 101, 114, 32, 102, 111, 114, 32, 110, 111, 110, 32, 115, 99, 114, 105, 112, 116, 45, 98, 97, 115, 101, 100, 32, 114, 101, 110, 100, 101, 114, 105, 110, 103, 32, 0, 0, 0, 0, 0, 208, 121, 1, 0, 216, 121, 1, 0, 224, 121, 1, 0, 232, 121, 1, 0, 240, 121, 1, 0, 248, 121, 1, 0, 24, 212, 1, 0, 112, 205, 1, 0, 216, 191, 1, 0, 240, 201, 1, 0, 80, 122, 1, 0, 176, 119, 1, 0, 208, 192, 1, 0, 96, 118, 1, 0, 128, 121, 1, 0, 56, 122, 1, 0, 232, 119, 1, 0, 96, 121, 1, 0, 200, 121, 1, 0, 168, 199, 1, 0, 136, 197, 1, 0, 152, 118, 1, 0, 184, 193, 1, 0, 56, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 88, 121, 1, 0, 112, 122, 1, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 32, 121, 1, 0, 112, 198, 1, 0, 64, 121, 1, 0, 48, 193, 1, 0, 72, 122, 1, 0, 192, 121, 1, 0, 64, 186, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 104, 177, 1, 0, 144, 177, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 240, 198, 1, 0, 0, 208, 1, 0, 200, 210, 1, 0, 32, 122, 1, 0, 112, 121, 1, 0, 160, 206, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 40, 214, 1, 0, 48, 214, 1, 0, 56, 214, 1, 0, 72, 214, 1, 0, 112, 212, 1, 0, 80, 214, 1, 0, 96, 214, 1, 0, 104, 214, 1, 0, 0, 213, 1, 0, 248, 212, 1, 0, 112, 214, 1, 0, 168, 212, 1, 0, 208, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 213, 1, 0, 88, 213, 1, 0, 24, 214, 1, 0, 32, 214, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 108, 0, 0, 0, 0, 0, 0, 111, 114, 100, 101, 114, 101, 100, 32, 108, 105, 115, 116, 32, 0, 0, 0, 48, 122, 1, 0, 0, 0, 0, 0, 112, 212, 1, 0, 120, 212, 1, 0, 16, 214, 1, 0, 0, 0, 0, 0, 111, 112, 116, 103, 114, 111, 117, 112, 0, 0, 0, 0, 0, 0, 0, 0, 111, 112, 116, 105, 111, 110, 32, 103, 114, 111, 117, 112, 32, 0, 0, 0, 200, 205, 1, 0, 0, 0, 0, 0, 111, 112, 116, 105, 111, 110, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 176, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 122, 1, 0, 0, 0, 0, 0, 115, 101, 108, 101, 99, 116, 97, 98, 108, 101, 32, 99, 104, 111, 105, 99, 101, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 176, 212, 1, 0, 32, 122, 1, 0, 0, 214, 1, 0, 232, 213, 1, 0, 0, 0, 0, 0, 112, 97, 114, 97, 103, 114, 97, 112, 104, 32, 0, 0, 0, 0, 0, 0, 112, 97, 114, 97, 109, 0, 0, 0, 110, 97, 109, 101, 100, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 118, 97, 108, 117, 101, 32, 0, 0, 0, 152, 212, 1, 0, 232, 213, 1, 0, 240, 213, 1, 0, 112, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 114, 101, 102, 111, 114, 109, 97, 116, 116, 101, 100, 32, 116, 101, 120, 116, 32, 0, 0, 0, 0, 0, 0, 184, 121, 1, 0, 136, 122, 1, 0, 168, 121, 1, 0, 144, 121, 1, 0, 104, 122, 1, 0, 24, 122, 1, 0, 160, 122, 1, 0, 136, 121, 1, 0, 40, 121, 1, 0, 48, 121, 1, 0, 144, 122, 1, 0, 0, 122, 1, 0, 72, 121, 1, 0, 152, 122, 1, 0, 96, 122, 1, 0, 128, 122, 1, 0, 32, 121, 1, 0, 168, 189, 1, 0, 16, 115, 1, 0, 96, 201, 1, 0, 88, 122, 1, 0, 120, 122, 1, 0, 80, 121, 1, 0, 8, 122, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 212, 1, 0, 0, 0, 0, 0, 115, 104, 111, 114, 116, 32, 105, 110, 108, 105, 110, 101, 32, 113, 117, 111, 116, 97, 116, 105, 111, 110, 32, 0, 115, 116, 114, 105, 107, 101, 45, 116, 104, 114, 111, 117, 103, 104, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 0, 0, 0, 0, 0, 0, 115, 97, 109, 112, 108, 101, 32, 112, 114, 111, 103, 114, 97, 109, 32, 111, 117, 116, 112, 117, 116, 44, 32, 115, 99, 114, 105, 112, 116, 115, 44, 32, 101, 116, 99, 46, 0, 0, 0, 0, 115, 99, 114, 105, 112, 116, 32, 115, 116, 97, 116, 101, 109, 101, 110, 116, 115, 32, 0, 0, 0, 0, 0, 0, 96, 114, 1, 0, 200, 213, 1, 0, 208, 213, 1, 0, 216, 213, 1, 0, 224, 213, 1, 0, 0, 0, 0, 0, 184, 213, 1, 0, 0, 0, 0, 0, 112, 212, 1, 0, 0, 0, 0, 0, 115, 101, 108, 101, 99, 116, 0, 0, 111, 112, 116, 105, 111, 110, 32, 115, 101, 108, 101, 99, 116, 111, 114, 32, 0, 0, 0, 0, 0, 0, 0, 0, 160, 205, 1, 0, 200, 205, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 168, 212, 1, 0, 160, 213, 1, 0, 168, 213, 1, 0, 176, 212, 1, 0, 208, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 0, 182, 1, 0, 0, 0, 0, 0, 115, 109, 97, 108, 108, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 103, 101, 110, 101, 114, 105, 99, 32, 108, 97, 110, 103, 117, 97, 103, 101, 47, 115, 116, 121, 108, 101, 32, 99, 111, 110, 116, 97, 105, 110, 101, 114, 32, 0, 0, 0, 0, 0, 0, 0, 115, 116, 114, 105, 107, 101, 45, 116, 104, 114, 111, 117, 103, 104, 32, 116, 101, 120, 116, 0, 0, 0, 0, 0, 115, 116, 114, 111, 110, 103, 32, 101, 109, 112, 104, 97, 115, 105, 115, 0, 115, 116, 121, 108, 101, 32, 105, 110, 102, 111, 32, 0, 0, 0, 0, 0, 216, 179, 1, 0, 216, 191, 1, 0, 152, 213, 1, 0, 216, 119, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 117, 98, 115, 99, 114, 105, 112, 116, 0, 0, 0, 0, 0, 0, 0, 115, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 32, 0, 0, 0, 0, 120, 121, 1, 0, 176, 190, 1, 0, 32, 191, 1, 0, 128, 118, 1, 0, 144, 118, 1, 0, 136, 118, 1, 0, 120, 118, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 80, 213, 1, 0, 248, 212, 1, 0, 88, 213, 1, 0, 248, 119, 1, 0, 96, 213, 1, 0, 104, 213, 1, 0, 120, 213, 1, 0, 136, 213, 1, 0, 0, 0, 0, 0, 48, 213, 1, 0, 128, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 98, 111, 100, 121, 32, 0, 0, 0, 0, 0, 120, 118, 1, 0, 0, 0, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 48, 213, 1, 0, 56, 213, 1, 0, 64, 213, 1, 0, 72, 213, 1, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 100, 97, 116, 97, 32, 99, 101, 108, 108, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 40, 121, 1, 0, 8, 213, 1, 0, 16, 213, 1, 0, 24, 213, 1, 0, 32, 213, 1, 0, 40, 213, 1, 0, 48, 213, 1, 0, 56, 213, 1, 0, 64, 213, 1, 0, 72, 213, 1, 0, 0, 0, 0, 0, 240, 212, 1, 0, 128, 212, 1, 0, 248, 212, 1, 0, 0, 213, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 101, 120, 116, 97, 114, 101, 97, 0, 0, 0, 0, 0, 0, 0, 0, 109, 117, 108, 116, 105, 45, 108, 105, 110, 101, 32, 116, 101, 120, 116, 32, 102, 105, 101, 108, 100, 32, 0, 0, 152, 212, 1, 0, 160, 212, 1, 0, 24, 115, 1, 0, 216, 119, 1, 0, 216, 179, 1, 0, 216, 191, 1, 0, 64, 181, 1, 0, 72, 181, 1, 0, 88, 181, 1, 0, 104, 181, 1, 0, 120, 181, 1, 0, 136, 181, 1, 0, 152, 181, 1, 0, 168, 181, 1, 0, 184, 181, 1, 0, 168, 212, 1, 0, 176, 212, 1, 0, 192, 212, 1, 0, 208, 212, 1, 0, 224, 212, 1, 0, 216, 181, 1, 0, 224, 181, 1, 0, 16, 182, 1, 0, 0, 182, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 212, 1, 0, 144, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 102, 111, 111, 116, 101, 114, 32, 0, 0, 0, 116, 97, 98, 108, 101, 32, 104, 101, 97, 100, 101, 114, 32, 99, 101, 108, 108, 0, 0, 0, 0, 0, 0, 0, 116, 97, 98, 108, 101, 32, 104, 101, 97, 100, 101, 114, 32, 0, 0, 0, 100, 111, 99, 117, 109, 101, 110, 116, 32, 116, 105, 116, 108, 101, 32, 0, 116, 97, 98, 108, 101, 32, 114, 111, 119, 32, 0, 0, 0, 0, 0, 0, 112, 118, 1, 0, 104, 118, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 212, 1, 0, 0, 0, 0, 0, 116, 101, 108, 101, 116, 121, 112, 101, 32, 111, 114, 32, 109, 111, 110, 111, 115, 112, 97, 99, 101, 100, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 0, 0, 0, 0, 0, 0, 117, 110, 100, 101, 114, 108, 105, 110, 101, 100, 32, 116, 101, 120, 116, 32, 115, 116, 121, 108, 101, 0, 0, 0, 117, 108, 0, 0, 0, 0, 0, 0, 117, 110, 111, 114, 100, 101, 114, 101, 100, 32, 108, 105, 115, 116, 32, 0, 112, 212, 1, 0, 120, 212, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 115, 116, 97, 110, 99, 101, 32, 111, 102, 32, 97, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 111, 114, 32, 112, 114, 111, 103, 114, 97, 109, 32, 97, 114, 103, 117, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 116, 121, 112, 101, 0, 0, 0, 0, 99, 111, 109, 112, 97, 99, 116, 0, 98, 103, 99, 111, 108, 111, 114, 0, 114, 111, 119, 115, 0, 0, 0, 0, 99, 111, 108, 115, 0, 0, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 99, 108, 97, 115, 115, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 100, 105, 115, 97, 98, 108, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 114, 101, 97, 100, 111, 110, 108, 121, 0, 0, 0, 0, 0, 0, 0, 0, 116, 97, 98, 105, 110, 100, 101, 120, 0, 0, 0, 0, 0, 0, 0, 0, 97, 99, 99, 101, 115, 115, 107, 101, 121, 0, 0, 0, 0, 0, 0, 0, 110, 111, 119, 114, 97, 112, 0, 0, 119, 105, 100, 116, 104, 0, 0, 0, 104, 101, 105, 103, 104, 116, 0, 0, 97, 120, 105, 115, 0, 0, 0, 0, 104, 101, 97, 100, 101, 114, 115, 0, 115, 99, 111, 112, 101, 0, 0, 0, 114, 111, 119, 115, 112, 97, 110, 0, 99, 111, 108, 115, 112, 97, 110, 0, 97, 108, 105, 103, 110, 0, 0, 0, 99, 104, 97, 114, 0, 0, 0, 0, 99, 104, 97, 114, 111, 102, 102, 0, 118, 97, 108, 105, 103, 110, 0, 0, 115, 117, 109, 109, 97, 114, 121, 0, 98, 111, 114, 100, 101, 114, 0, 0, 114, 117, 108, 101, 115, 0, 0, 0, 99, 101, 108, 108, 115, 112, 97, 99, 105, 110, 103, 0, 0, 0, 0, 0, 99, 101, 108, 108, 112, 97, 100, 100, 105, 110, 103, 0, 0, 0, 0, 0, 100, 97, 116, 97, 112, 97, 103, 101, 115, 105, 122, 101, 0, 0, 0, 0, 109, 101, 100, 105, 97, 0, 0, 0, 115, 105, 122, 101, 0, 0, 0, 0, 109, 117, 108, 116, 105, 112, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 108, 97, 110, 103, 117, 97, 103, 101, 0, 0, 0, 0, 0, 0, 0, 0, 115, 114, 99, 0, 0, 0, 0, 0, 100, 101, 102, 101, 114, 0, 0, 0, 101, 118, 101, 110, 116, 0, 0, 0, 102, 111, 114, 0, 0, 0, 0, 0, 118, 97, 108, 117, 101, 0, 0, 0, 118, 97, 108, 117, 101, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 115, 101, 108, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 114, 116, 0, 0, 0, 104, 115, 112, 97, 99, 101, 0, 0, 118, 115, 112, 97, 99, 101, 0, 0, 100, 101, 99, 108, 97, 114, 101, 0, 99, 108, 97, 115, 115, 105, 100, 0, 99, 111, 100, 101, 98, 97, 115, 101, 0, 0, 0, 0, 0, 0, 0, 0, 100, 97, 116, 97, 0, 0, 0, 0, 99, 111, 100, 101, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 97, 114, 99, 104, 105, 118, 101, 0, 115, 116, 97, 110, 100, 98, 121, 0, 117, 115, 101, 109, 97, 112, 0, 0, 115, 99, 104, 101, 109, 101, 0, 0, 104, 114, 101, 102, 0, 0, 0, 0, 104, 114, 101, 102, 108, 97, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 114, 101, 108, 0, 0, 0, 0, 0, 114, 101, 118, 0, 0, 0, 0, 0, 112, 114, 111, 109, 112, 116, 0, 0, 99, 104, 101, 99, 107, 101, 100, 0, 109, 97, 120, 108, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 0, 0, 97, 108, 116, 0, 0, 0, 0, 0, 105, 115, 109, 97, 112, 0, 0, 0, 97, 99, 99, 101, 112, 116, 0, 0, 108, 111, 110, 103, 100, 101, 115, 99, 0, 0, 0, 0, 0, 0, 0, 0, 102, 114, 97, 109, 101, 98, 111, 114, 100, 101, 114, 0, 0, 0, 0, 0, 109, 97, 114, 103, 105, 110, 119, 105, 100, 116, 104, 0, 0, 0, 0, 0, 109, 97, 114, 103, 105, 110, 104, 101, 105, 103, 104, 116, 0, 0, 0, 0, 115, 99, 114, 111, 108, 108, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 118, 101, 114, 115, 105, 111, 110, 0, 110, 111, 115, 104, 97, 100, 101, 0, 112, 114, 111, 102, 105, 108, 101, 0, 110, 111, 114, 101, 115, 105, 122, 101, 0, 0, 0, 0, 0, 0, 0, 0, 97, 99, 116, 105, 111, 110, 0, 0, 109, 101, 116, 104, 111, 100, 0, 0, 101, 110, 99, 116, 121, 112, 101, 0, 97, 99, 99, 101, 112, 116, 45, 99, 104, 97, 114, 115, 101, 116, 0, 0, 99, 111, 108, 111, 114, 0, 0, 0, 102, 97, 99, 101, 0, 0, 0, 0, 104, 105, 100, 100, 101, 110, 0, 0, 112, 97, 108, 101, 116, 116, 101, 0, 112, 108, 117, 103, 105, 110, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 112, 108, 117, 103, 105, 110, 117, 114, 108, 0, 0, 0, 0, 0, 0, 0, 117, 110, 105, 116, 115, 0, 0, 0, 100, 97, 116, 101, 116, 105, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 99, 108, 101, 97, 114, 0, 0, 0, 98, 97, 99, 107, 103, 114, 111, 117, 110, 100, 0, 0, 0, 0, 0, 0, 116, 101, 120, 116, 0, 0, 0, 0, 118, 108, 105, 110, 107, 0, 0, 0, 97, 108, 105, 110, 107, 0, 0, 0, 115, 104, 97, 112, 101, 0, 0, 0, 99, 111, 111, 114, 100, 115, 0, 0, 110, 111, 104, 114, 101, 102, 0, 0, 116, 97, 114, 103, 101, 116, 0, 0, 108, 105, 115, 116, 105, 110, 103, 0, 120, 109, 112, 0, 0, 0, 0, 0, 104, 116, 109, 108, 0, 0, 0, 0, 104, 101, 97, 100, 0, 0, 0, 0, 109, 101, 116, 97, 0, 0, 0, 0, 104, 116, 116, 112, 45, 101, 113, 117, 105, 118, 0, 0, 0, 0, 0, 0, 67, 111, 110, 116, 101, 110, 116, 45, 84, 121, 112, 101, 0, 0, 0, 0, 99, 111, 110, 116, 101, 110, 116, 0, 99, 104, 97, 114, 115, 101, 116, 61, 0, 0, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 115, 101, 116, 61, 0, 0, 0, 0, 0, 0, 0, 0, 67, 72, 65, 82, 83, 69, 84, 61, 0, 0, 0, 0, 0, 0, 0, 0, 99, 104, 97, 114, 115, 101, 116, 32, 61, 0, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 115, 101, 116, 32, 61, 0, 0, 0, 0, 0, 0, 0, 67, 72, 65, 82, 83, 69, 84, 32, 61, 0, 0, 0, 0, 0, 0, 0, 116, 101, 120, 116, 47, 104, 116, 109, 108, 59, 32, 99, 104, 97, 114, 115, 101, 116, 61, 37, 115, 0, 0, 0, 200, 218, 1, 0, 208, 218, 1, 0, 216, 218, 1, 0, 224, 218, 1, 0, 232, 218, 1, 0, 248, 218, 1, 0, 0, 219, 1, 0, 16, 219, 1, 0, 24, 219, 1, 0, 40, 219, 1, 0, 48, 219, 1, 0, 56, 219, 1, 0, 72, 219, 1, 0, 0, 0, 0, 0, 72, 84, 77, 76, 0, 0, 0, 0, 97, 115, 99, 105, 105, 0, 0, 0, 115, 99, 114, 105, 112, 116, 0, 0, 115, 116, 121, 108, 101, 0, 0, 0, 60, 33, 45, 45, 0, 0, 0, 0, 45, 45, 62, 0, 0, 0, 0, 0, 60, 63, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 98, 111, 100, 121, 0, 0, 0, 0, 62, 60, 47, 0, 0, 0, 0, 0, 60, 47, 0, 0, 0, 0, 0, 0, 85, 84, 70, 45, 56, 0, 0, 0, 60, 33, 68, 79, 67, 84, 89, 80, 69, 32, 0, 0, 0, 0, 0, 0, 32, 80, 85, 66, 76, 73, 67, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 83, 89, 83, 84, 69, 77, 32, 0, 0, 0, 0, 0, 0, 0, 0, 62, 10, 0, 0, 0, 0, 0, 0, 61, 0, 0, 0, 0, 0, 0, 0, 104, 114, 101, 102, 0, 0, 0, 0, 97, 99, 116, 105, 111, 110, 0, 0, 115, 114, 99, 0, 0, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 64, 47, 58, 61, 63, 59, 35, 37, 38, 44, 43, 0, 0, 0, 0, 0, 61, 34, 34, 0, 0, 0, 0, 0, 115, 116, 114, 105, 110, 103, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 32, 85, 84, 70, 45, 56, 10, 0, 105, 110, 118, 97, 108, 105, 100, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 107, 110, 111, 119, 110, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 37, 115, 10, 0, 0, 0, 0, 72, 84, 77, 76, 32, 104, 97, 115, 32, 110, 111, 32, 68, 79, 67, 84, 89, 80, 69, 10, 0, 0, 0, 0, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 101, 114, 114, 111, 114, 32, 110, 117, 109, 98, 101, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 99, 104, 101, 99, 107, 101, 100, 0, 99, 111, 109, 112, 97, 99, 116, 0, 100, 101, 99, 108, 97, 114, 101, 0, 100, 101, 102, 101, 114, 0, 0, 0, 100, 105, 115, 97, 98, 108, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 105, 115, 109, 97, 112, 0, 0, 0, 109, 117, 108, 116, 105, 112, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 104, 114, 101, 102, 0, 0, 110, 111, 114, 101, 115, 105, 122, 101, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 115, 104, 97, 100, 101, 0, 110, 111, 119, 114, 97, 112, 0, 0, 114, 101, 97, 100, 111, 110, 108, 121, 0, 0, 0, 0, 0, 0, 0, 0, 115, 101, 108, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 40, 78, 85, 76, 76, 41, 0, 0, 35, 37, 88, 0, 0, 0, 0, 0, 46, 46, 46, 0, 0, 0, 0, 0, 78, 85, 76, 76, 10, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 99, 0, 0, 0, 0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 0, 0, 0, 0, 78, 0, 0, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 32, 37, 56, 100, 32, 0, 0, 0, 37, 115, 58, 0, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 32, 45, 62, 32, 37, 115, 0, 0, 0, 37, 115, 32, 45, 62, 32, 37, 115, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 37, 115, 58, 32, 110, 111, 32, 115, 117, 99, 104, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 37, 115, 32, 105, 115, 32, 97, 32, 66, 111, 111, 108, 101, 97, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 37, 115, 32, 105, 115, 32, 97, 32, 110, 117, 109, 98, 101, 114, 10, 0, 37, 115, 32, 105, 115, 32, 97, 32, 115, 116, 114, 105, 110, 103, 10, 0, 37, 115, 32, 105, 115, 32, 97, 32, 112, 111, 105, 110, 116, 10, 0, 0, 37, 115, 32, 105, 115, 32, 97, 32, 114, 97, 110, 103, 101, 10, 0, 0, 37, 115, 32, 105, 115, 32, 117, 115, 101, 114, 45, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 37, 115, 32, 105, 115, 32, 97, 110, 32, 88, 83, 76, 84, 32, 118, 97, 108, 117, 101, 32, 116, 114, 101, 101, 10, 0, 0, 0, 0, 0, 0, 0, 32, 78, 111, 32, 98, 97, 115, 101, 32, 102, 111, 117, 110, 100, 32, 33, 33, 33, 10, 0, 0, 0, 0, 0, 37, 115, 10, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 119, 114, 105, 116, 101, 32, 116, 111, 32, 37, 115, 10, 0, 0, 119, 0, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 115, 97, 118, 101, 32, 116, 111, 32, 37, 115, 10, 0, 0, 0, 84, 111, 32, 115, 97, 118, 101, 32, 116, 111, 32, 115, 117, 98, 112, 97, 114, 116, 115, 32, 111, 102, 32, 97, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 117, 115, 101, 32, 116, 104, 101, 32, 39, 119, 114, 105, 116, 101, 39, 32, 99, 111, 109, 109, 97, 110, 100, 10, 0, 0, 0, 0, 0, 0, 47, 10, 0, 0, 0, 0, 0, 0, 32, 32, 0, 0, 0, 0, 0, 0, 37, 115, 32, 62, 32, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 37, 115, 58, 37, 115, 32, 62, 32, 0, 0, 0, 0, 0, 0, 0, 0, 63, 32, 62, 32, 0, 0, 0, 0, 101, 120, 105, 116, 0, 0, 0, 0, 113, 117, 105, 116, 0, 0, 0, 0, 98, 121, 101, 0, 0, 0, 0, 0, 104, 101, 108, 112, 0, 0, 0, 0, 9, 98, 97, 115, 101, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 115, 112, 108, 97, 121, 32, 88, 77, 76, 32, 98, 97, 115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 9, 115, 101, 116, 98, 97, 115, 101, 32, 85, 82, 73, 32, 32, 99, 104, 97, 110, 103, 101, 32, 116, 104, 101, 32, 88, 77, 76, 32, 98, 97, 115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 110, 111, 100, 101, 10, 0, 0, 9, 98, 121, 101, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 97, 118, 101, 32, 115, 104, 101, 108, 108, 10, 0, 0, 0, 0, 0, 0, 9, 99, 97, 116, 32, 91, 110, 111, 100, 101, 93, 32, 32, 32, 100, 105, 115, 112, 108, 97, 121, 32, 110, 111, 100, 101, 32, 111, 114, 32, 99, 117, 114, 114, 101, 110, 116, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 9, 99, 100, 32, 91, 112, 97, 116, 104, 93, 32, 32, 32, 32, 99, 104, 97, 110, 103, 101, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 116, 111, 32, 112, 97, 116, 104, 32, 111, 114, 32, 116, 111, 32, 114, 111, 111, 116, 10, 0, 0, 0, 0, 0, 0, 9, 100, 105, 114, 32, 91, 112, 97, 116, 104, 93, 32, 32, 32, 100, 117, 109, 112, 115, 32, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 115, 32, 97, 98, 111, 117, 116, 32, 116, 104, 101, 32, 110, 111, 100, 101, 32, 40, 110, 97, 109, 101, 115, 112, 97, 99, 101, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 44, 32, 99, 111, 110, 116, 101, 110, 116, 41, 10, 0, 0, 0, 0, 0, 0, 0, 9, 100, 117, 32, 91, 112, 97, 116, 104, 93, 32, 32, 32, 32, 115, 104, 111, 119, 32, 116, 104, 101, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 32, 111, 102, 32, 116, 104, 101, 32, 115, 117, 98, 116, 114, 101, 101, 32, 117, 110, 100, 101, 114, 32, 112, 97, 116, 104, 32, 111, 114, 32, 116, 104, 101, 32, 99, 117, 114, 114, 101, 110, 116, 32, 110, 111, 100, 101, 10, 0, 9, 101, 120, 105, 116, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 97, 118, 101, 32, 115, 104, 101, 108, 108, 10, 0, 0, 0, 0, 0, 0, 9, 104, 101, 108, 112, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 115, 112, 108, 97, 121, 32, 116, 104, 105, 115, 32, 104, 101, 108, 112, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 102, 114, 101, 101, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 115, 112, 108, 97, 121, 32, 109, 101, 109, 111, 114, 121, 32, 117, 115, 97, 103, 101, 10, 0, 0, 0, 0, 0, 9, 108, 111, 97, 100, 32, 91, 110, 97, 109, 101, 93, 32, 32, 108, 111, 97, 100, 32, 97, 32, 110, 101, 119, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 119, 105, 116, 104, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 9, 108, 115, 32, 91, 112, 97, 116, 104, 93, 32, 32, 32, 32, 108, 105, 115, 116, 32, 99, 111, 110, 116, 101, 110, 116, 115, 32, 111, 102, 32, 112, 97, 116, 104, 32, 111, 114, 32, 116, 104, 101, 32, 99, 117, 114, 114, 101, 110, 116, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 10, 0, 0, 0, 9, 115, 101, 116, 32, 120, 109, 108, 95, 102, 114, 97, 103, 109, 101, 110, 116, 32, 114, 101, 112, 108, 97, 99, 101, 32, 116, 104, 101, 32, 99, 117, 114, 114, 101, 110, 116, 32, 110, 111, 100, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 119, 105, 116, 104, 32, 116, 104, 101, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 112, 97, 114, 115, 101, 100, 32, 105, 110, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 9, 120, 112, 97, 116, 104, 32, 101, 120, 112, 114, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 104, 101, 32, 88, 80, 97, 116, 104, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 105, 110, 32, 116, 104, 97, 116, 32, 99, 111, 110, 116, 101, 120, 116, 32, 97, 110, 100, 32, 112, 114, 105, 110, 116, 32, 116, 104, 101, 32, 114, 101, 115, 117, 108, 116, 10, 0, 0, 0, 0, 0, 0, 0, 9, 115, 101, 116, 110, 115, 32, 110, 115, 114, 101, 103, 32, 32, 114, 101, 103, 105, 115, 116, 101, 114, 32, 97, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 116, 111, 32, 97, 32, 112, 114, 101, 102, 105, 120, 32, 105, 110, 32, 116, 104, 101, 32, 88, 80, 97, 116, 104, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 109, 97, 116, 32, 102, 111, 114, 32, 110, 115, 114, 101, 103, 32, 105, 115, 58, 32, 112, 114, 101, 102, 105, 120, 61, 91, 110, 115, 117, 114, 105, 93, 32, 40, 105, 46, 101, 46, 32, 112, 114, 101, 102, 105, 120, 61, 32, 117, 110, 115, 101, 116, 115, 32, 97, 32, 112, 114, 101, 102, 105, 120, 41, 10, 0, 0, 0, 0, 0, 0, 0, 9, 115, 101, 116, 114, 111, 111, 116, 110, 115, 32, 32, 32, 32, 114, 101, 103, 105, 115, 116, 101, 114, 32, 97, 108, 108, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 102, 111, 117, 110, 100, 32, 111, 110, 32, 116, 104, 101, 32, 114, 111, 111, 116, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 9, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 105, 102, 32, 97, 110, 121, 32, 117, 115, 101, 115, 32, 39, 100, 101, 102, 97, 117, 108, 116, 110, 115, 39, 32, 112, 114, 101, 102, 105, 120, 10, 0, 0, 0, 0, 0, 9, 112, 119, 100, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 115, 112, 108, 97, 121, 32, 99, 117, 114, 114, 101, 110, 116, 32, 119, 111, 114, 107, 105, 110, 103, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 9, 119, 104, 101, 114, 101, 105, 115, 32, 32, 32, 32, 32, 32, 100, 105, 115, 112, 108, 97, 121, 32, 97, 98, 115, 111, 108, 117, 116, 101, 32, 112, 97, 116, 104, 32, 111, 102, 32, 91, 112, 97, 116, 104, 93, 32, 111, 114, 32, 99, 117, 114, 114, 101, 110, 116, 32, 119, 111, 114, 107, 105, 110, 103, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 10, 0, 0, 0, 0, 0, 9, 113, 117, 105, 116, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 97, 118, 101, 32, 115, 104, 101, 108, 108, 10, 0, 0, 0, 0, 0, 0, 9, 115, 97, 118, 101, 32, 91, 110, 97, 109, 101, 93, 32, 32, 115, 97, 118, 101, 32, 116, 104, 105, 115, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 116, 111, 32, 110, 97, 109, 101, 32, 111, 114, 32, 116, 104, 101, 32, 111, 114, 105, 103, 105, 110, 97, 108, 32, 110, 97, 109, 101, 10, 0, 0, 9, 119, 114, 105, 116, 101, 32, 91, 110, 97, 109, 101, 93, 32, 119, 114, 105, 116, 101, 32, 116, 104, 101, 32, 99, 117, 114, 114, 101, 110, 116, 32, 110, 111, 100, 101, 32, 116, 111, 32, 116, 104, 101, 32, 102, 105, 108, 101, 110, 97, 109, 101, 10, 0, 0, 0, 9, 118, 97, 108, 105, 100, 97, 116, 101, 32, 32, 32, 32, 32, 99, 104, 101, 99, 107, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 102, 111, 114, 32, 101, 114, 114, 111, 114, 115, 10, 0, 0, 0, 0, 9, 114, 101, 108, 97, 120, 110, 103, 32, 114, 110, 103, 32, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 97, 103, 97, 105, 115, 110, 116, 32, 116, 104, 101, 32, 82, 101, 108, 97, 120, 45, 78, 71, 32, 115, 99, 104, 101, 109, 97, 115, 10, 0, 0, 0, 0, 0, 0, 0, 9, 103, 114, 101, 112, 32, 115, 116, 114, 105, 110, 103, 32, 32, 115, 101, 97, 114, 99, 104, 32, 102, 111, 114, 32, 97, 32, 115, 116, 114, 105, 110, 103, 32, 105, 110, 32, 116, 104, 101, 32, 115, 117, 98, 116, 114, 101, 101, 10, 0, 0, 0, 0, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 101, 0, 0, 0, 0, 0, 0, 0, 0, 108, 111, 97, 100, 0, 0, 0, 0, 114, 101, 108, 97, 120, 110, 103, 0, 115, 97, 118, 101, 0, 0, 0, 0, 119, 114, 105, 116, 101, 0, 0, 0, 87, 114, 105, 116, 101, 32, 99, 111, 109, 109, 97, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 32, 102, 105, 108, 101, 110, 97, 109, 101, 32, 97, 114, 103, 117, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 103, 114, 101, 112, 0, 0, 0, 0, 102, 114, 101, 101, 0, 0, 0, 0, 37, 100, 0, 0, 0, 0, 0, 0, 112, 119, 100, 0, 0, 0, 0, 0, 100, 117, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 115, 101, 116, 0, 0, 0, 0, 0, 115, 101, 116, 110, 115, 0, 0, 0, 115, 101, 116, 110, 115, 58, 32, 112, 114, 101, 102, 105, 120, 61, 91, 110, 115, 117, 114, 105, 93, 32, 114, 101, 113, 117, 105, 114, 101, 100, 10, 0, 115, 101, 116, 114, 111, 111, 116, 110, 115, 0, 0, 0, 0, 0, 0, 0, 120, 112, 97, 116, 104, 0, 0, 0, 120, 112, 97, 116, 104, 58, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 114, 101, 113, 117, 105, 114, 101, 100, 10, 0, 0, 0, 0, 0, 115, 101, 116, 98, 97, 115, 101, 0, 108, 115, 0, 0, 0, 0, 0, 0, 100, 105, 114, 0, 0, 0, 0, 0, 119, 104, 101, 114, 101, 105, 115, 0, 99, 100, 0, 0, 0, 0, 0, 0, 99, 97, 110, 110, 111, 116, 32, 99, 100, 32, 116, 111, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 10, 0, 37, 115, 32, 105, 115, 32, 97, 32, 37, 100, 32, 78, 111, 100, 101, 32, 83, 101, 116, 10, 0, 0, 0, 0, 37, 115, 32, 105, 115, 32, 97, 110, 32, 101, 109, 112, 116, 121, 32, 78, 111, 100, 101, 32, 83, 101, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 116, 0, 0, 0, 0, 0, 32, 45, 45, 45, 45, 45, 45, 45, 10, 0, 0, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 99, 111, 109, 109, 97, 110, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 110, 115, 0, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 58, 32, 117, 110, 97, 98, 108, 101, 32, 116, 111, 32, 114, 101, 103, 105, 115, 116, 101, 114, 32, 78, 83, 32, 119, 105, 116, 104, 32, 112, 114, 101, 102, 105, 120, 61, 34, 37, 115, 34, 32, 97, 110, 100, 32, 104, 114, 101, 102, 61, 34, 37, 115, 34, 10, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 37, 115, 32, 58, 32, 0, 0, 0, 82, 101, 108, 97, 120, 45, 78, 71, 32, 115, 99, 104, 101, 109, 97, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 10, 0, 0, 0, 37, 115, 32, 118, 97, 108, 105, 100, 97, 116, 101, 115, 10, 0, 0, 0, 37, 115, 32, 102, 97, 105, 108, 115, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 10, 0, 0, 0, 37, 115, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 103, 101, 110, 101, 114, 97, 116, 101, 100, 32, 97, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 68, 84, 68, 32, 110, 111, 100, 101, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 0, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 68, 84, 68, 0, 0, 0, 0, 0, 0, 0, 68, 84, 68, 40, 37, 115, 41, 0, 68, 84, 68, 0, 0, 0, 0, 0, 44, 32, 80, 85, 66, 76, 73, 67, 32, 37, 115, 0, 0, 0, 0, 0, 44, 32, 83, 89, 83, 84, 69, 77, 32, 37, 115, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 104, 97, 115, 32, 110, 111, 32, 112, 97, 114, 101, 110, 116, 10, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 104, 97, 115, 32, 110, 111, 32, 100, 111, 99, 10, 0, 0, 0, 0, 0, 0, 0, 0, 112, 115, 101, 117, 100, 111, 114, 111, 111, 116, 0, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 100, 111, 99, 32, 100, 105, 102, 102, 101, 114, 115, 32, 102, 114, 111, 109, 32, 112, 97, 114, 101, 110, 116, 39, 115, 32, 111, 110, 101, 10, 0, 0, 0, 0, 0, 65, 116, 116, 114, 32, 104, 97, 115, 32, 110, 111, 32, 112, 114, 101, 118, 32, 97, 110, 100, 32, 110, 111, 116, 32, 102, 105, 114, 115, 116, 32, 111, 102, 32, 97, 116, 116, 114, 32, 108, 105, 115, 116, 10, 0, 0, 0, 0, 78, 111, 100, 101, 32, 104, 97, 115, 32, 110, 111, 32, 112, 114, 101, 118, 32, 97, 110, 100, 32, 110, 111, 116, 32, 102, 105, 114, 115, 116, 32, 111, 102, 32, 112, 97, 114, 101, 110, 116, 32, 108, 105, 115, 116, 10, 0, 0, 78, 111, 100, 101, 32, 112, 114, 101, 118, 45, 62, 110, 101, 120, 116, 32, 58, 32, 98, 97, 99, 107, 32, 108, 105, 110, 107, 32, 119, 114, 111, 110, 103, 10, 0, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 104, 97, 115, 32, 110, 111, 32, 110, 101, 120, 116, 32, 97, 110, 100, 32, 110, 111, 116, 32, 108, 97, 115, 116, 32, 111, 102, 32, 112, 97, 114, 101, 110, 116, 32, 108, 105, 115, 116, 10, 0, 0, 0, 78, 111, 100, 101, 32, 110, 101, 120, 116, 45, 62, 112, 114, 101, 118, 32, 58, 32, 102, 111, 114, 119, 97, 114, 100, 32, 108, 105, 110, 107, 32, 119, 114, 111, 110, 103, 10, 0, 0, 0, 110, 98, 107, 116, 101, 120, 116, 0, 84, 101, 120, 116, 32, 110, 111, 100, 101, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 0, 0, 0, 67, 111, 109, 109, 101, 110, 116, 32, 110, 111, 100, 101, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 0, 67, 68, 97, 116, 97, 32, 115, 101, 99, 116, 105, 111, 110, 32, 104, 97, 115, 32, 110, 111, 110, 32, 78, 85, 76, 76, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 0, 0, 0, 0, 78, 97, 109, 101, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 78, 97, 109, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 32, 105, 115, 32, 110, 111, 116, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 100, 105, 99, 116, 105, 111, 110, 110, 97, 114, 121, 32, 39, 37, 115, 39, 0, 0, 83, 116, 114, 105, 110, 103, 32, 105, 115, 32, 110, 111, 116, 32, 85, 84, 70, 45, 56, 32, 37, 115, 0, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 111, 116, 32, 105, 110, 32, 115, 99, 111, 112, 101, 10, 0, 0, 0, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 32, 110, 111, 116, 32, 105, 110, 32, 115, 99, 111, 112, 101, 10, 0, 0, 0, 0, 0, 0, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 111, 116, 32, 111, 110, 32, 97, 110, 99, 101, 115, 116, 111, 114, 10, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 32, 110, 111, 116, 32, 111, 110, 32, 97, 110, 99, 101, 115, 116, 111, 114, 10, 0, 0, 0, 0, 68, 79, 67, 85, 77, 69, 78, 84, 32, 61, 61, 32, 78, 85, 76, 76, 32, 33, 10, 0, 0, 0, 0, 0, 110, 97, 109, 101, 61, 0, 0, 0, 118, 101, 114, 115, 105, 111, 110, 61, 0, 0, 0, 0, 0, 0, 0, 0, 101, 110, 99, 111, 100, 105, 110, 103, 61, 0, 0, 0, 0, 0, 0, 0, 85, 82, 76, 61, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 61, 116, 114, 117, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 111, 100, 101, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 78, 111, 100, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 73, 110, 99, 111, 109, 112, 108, 101, 116, 101, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 37, 115, 32, 104, 114, 101, 102, 61, 78, 85, 76, 76, 10, 0, 0, 0, 0, 0, 0, 73, 110, 99, 111, 109, 112, 108, 101, 116, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 104, 114, 101, 102, 61, 78, 85, 76, 76, 10, 0, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 37, 115, 32, 104, 114, 101, 102, 61, 0, 0, 0, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 104, 114, 101, 102, 61, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 69, 76, 69, 77, 69, 78, 84, 32, 110, 111, 100, 101, 10, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 65, 84, 84, 82, 73, 66, 85, 84, 69, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 84, 69, 88, 84, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 67, 68, 65, 84, 65, 32, 110, 111, 100, 101, 10, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 69, 78, 84, 73, 84, 89, 82, 69, 70, 32, 110, 111, 100, 101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 115568);
	        allocate([10, 0, 0, 0, 0, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 69, 78, 84, 73, 84, 89, 32, 110, 111, 100, 101, 10, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 80, 73, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 67, 79, 77, 77, 69, 78, 84, 32, 110, 111, 100, 101, 10, 0, 68, 79, 67, 85, 77, 69, 78, 84, 10, 0, 0, 0, 0, 0, 0, 0, 72, 84, 77, 76, 32, 68, 79, 67, 85, 77, 69, 78, 84, 10, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 68, 79, 67, 84, 89, 80, 69, 32, 110, 111, 100, 101, 10, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 70, 82, 65, 71, 77, 69, 78, 84, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 77, 105, 115, 112, 108, 97, 99, 101, 100, 32, 78, 79, 84, 65, 84, 73, 79, 78, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 110, 111, 100, 101, 32, 116, 121, 112, 101, 32, 37, 100, 10, 0, 0, 0, 110, 111, 100, 101, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 0, 0, 69, 76, 69, 77, 69, 78, 84, 32, 0, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 44, 32, 65, 84, 84, 82, 73, 66, 85, 84, 69, 32, 102, 111, 117, 110, 100, 32, 104, 101, 114, 101, 10, 0, 0, 0, 0, 84, 69, 88, 84, 32, 110, 111, 32, 101, 110, 99, 0, 0, 0, 0, 0, 84, 69, 88, 84, 0, 0, 0, 0, 32, 99, 111, 109, 112, 97, 99, 116, 10, 0, 0, 0, 0, 0, 0, 0, 32, 105, 110, 116, 101, 114, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 67, 68, 65, 84, 65, 95, 83, 69, 67, 84, 73, 79, 78, 10, 0, 0, 69, 78, 84, 73, 84, 89, 95, 82, 69, 70, 40, 37, 115, 41, 10, 0, 69, 78, 84, 73, 84, 89, 10, 0, 80, 73, 32, 37, 115, 10, 0, 0, 67, 79, 77, 77, 69, 78, 84, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 44, 32, 68, 79, 67, 85, 77, 69, 78, 84, 32, 102, 111, 117, 110, 100, 32, 104, 101, 114, 101, 10, 0, 0, 0, 0, 0, 68, 79, 67, 85, 77, 69, 78, 84, 95, 84, 89, 80, 69, 10, 0, 0, 68, 79, 67, 85, 77, 69, 78, 84, 95, 70, 82, 65, 71, 10, 0, 0, 78, 79, 84, 65, 84, 73, 79, 78, 10, 0, 0, 0, 0, 0, 0, 0, 73, 78, 67, 76, 85, 68, 69, 32, 83, 84, 65, 82, 84, 10, 0, 0, 73, 78, 67, 76, 85, 68, 69, 32, 69, 78, 68, 10, 0, 0, 0, 0, 80, 66, 77, 58, 32, 100, 111, 99, 32, 61, 61, 32, 78, 85, 76, 76, 32, 33, 33, 33, 10, 0, 0, 0, 99, 111, 110, 116, 101, 110, 116, 61, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 73, 78, 84, 69, 82, 78, 65, 76, 95, 71, 69, 78, 69, 82, 65, 76, 95, 69, 78, 84, 73, 84, 89, 32, 0, 0, 0, 0, 0, 0, 0, 0, 69, 88, 84, 69, 82, 78, 65, 76, 95, 71, 69, 78, 69, 82, 65, 76, 95, 80, 65, 82, 83, 69, 68, 95, 69, 78, 84, 73, 84, 89, 32, 0, 69, 88, 84, 69, 82, 78, 65, 76, 95, 71, 69, 78, 69, 82, 65, 76, 95, 85, 78, 80, 65, 82, 83, 69, 68, 95, 69, 78, 84, 73, 84, 89, 32, 0, 0, 0, 0, 0, 0, 0, 73, 78, 84, 69, 82, 78, 65, 76, 95, 80, 65, 82, 65, 77, 69, 84, 69, 82, 95, 69, 78, 84, 73, 84, 89, 32, 0, 0, 0, 0, 0, 0, 69, 88, 84, 69, 82, 78, 65, 76, 95, 80, 65, 82, 65, 77, 69, 84, 69, 82, 95, 69, 78, 84, 73, 84, 89, 32, 0, 0, 0, 0, 0, 0, 69, 78, 84, 73, 84, 89, 95, 37, 100, 32, 33, 32, 0, 0, 0, 0, 69, 120, 116, 101, 114, 110, 97, 108, 73, 68, 61, 37, 115, 10, 0, 0, 83, 121, 115, 116, 101, 109, 73, 68, 61, 37, 115, 10, 0, 0, 0, 0, 85, 82, 73, 61, 37, 115, 10, 0, 69, 110, 116, 105, 116, 121, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 101, 110, 116, 105, 116, 121, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 69, 78, 84, 73, 84, 89, 68, 69, 67, 76, 40, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 0, 0, 44, 32, 105, 110, 116, 101, 114, 110, 97, 108, 10, 0, 0, 0, 0, 0, 44, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 112, 97, 114, 115, 101, 100, 10, 0, 0, 0, 0, 0, 0, 44, 32, 117, 110, 112, 97, 114, 115, 101, 100, 10, 0, 0, 0, 0, 0, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 10, 0, 0, 0, 0, 44, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 10, 0, 0, 0, 44, 32, 112, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 32, 69, 120, 116, 101, 114, 110, 97, 108, 73, 68, 61, 37, 115, 10, 0, 32, 83, 121, 115, 116, 101, 109, 73, 68, 61, 37, 115, 10, 0, 0, 0, 32, 85, 82, 73, 61, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 32, 99, 111, 110, 116, 101, 110, 116, 61, 0, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 0, 78, 111, 100, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 65, 84, 84, 82, 68, 69, 67, 76, 40, 37, 115, 41, 0, 0, 0, 0, 78, 111, 100, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 0, 0, 32, 102, 111, 114, 32, 37, 115, 0, 78, 111, 100, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 104, 97, 115, 32, 110, 111, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 97, 109, 101, 0, 0, 32, 67, 68, 65, 84, 65, 0, 0, 32, 73, 68, 0, 0, 0, 0, 0, 32, 73, 68, 82, 69, 70, 0, 0, 32, 73, 68, 82, 69, 70, 83, 0, 32, 69, 78, 84, 73, 84, 89, 0, 32, 69, 78, 84, 73, 84, 73, 69, 83, 0, 0, 0, 0, 0, 0, 0, 32, 78, 77, 84, 79, 75, 69, 78, 0, 0, 0, 0, 0, 0, 0, 0, 32, 78, 77, 84, 79, 75, 69, 78, 83, 0, 0, 0, 0, 0, 0, 0, 32, 69, 78, 85, 77, 69, 82, 65, 84, 73, 79, 78, 0, 0, 0, 0, 32, 78, 79, 84, 65, 84, 73, 79, 78, 32, 0, 0, 0, 0, 0, 0, 124, 37, 115, 0, 0, 0, 0, 0, 32, 40, 37, 115, 0, 0, 0, 0, 46, 46, 46, 41, 0, 0, 0, 0, 32, 82, 69, 81, 85, 73, 82, 69, 68, 0, 0, 0, 0, 0, 0, 0, 32, 73, 77, 80, 76, 73, 69, 68, 0, 0, 0, 0, 0, 0, 0, 0, 32, 70, 73, 88, 69, 68, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 115, 32, 78, 85, 76, 76, 10, 0, 0, 0, 0, 78, 111, 100, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 69, 76, 69, 77, 68, 69, 67, 76, 40, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 0, 44, 32, 85, 78, 68, 69, 70, 73, 78, 69, 68, 0, 0, 0, 0, 0, 44, 32, 69, 77, 80, 84, 89, 0, 44, 32, 65, 78, 89, 0, 0, 0, 44, 32, 77, 73, 88, 69, 68, 32, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 105, 101, 115, 32, 105, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 0, 78, 111, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 105, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 69, 110, 116, 105, 116, 105, 101, 115, 32, 105, 110, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 0, 78, 111, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 105, 110, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 69, 110, 116, 105, 116, 121, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 73, 78, 84, 69, 82, 78, 65, 76, 32, 71, 69, 78, 69, 82, 65, 76, 44, 32, 0, 0, 0, 0, 0, 0, 69, 88, 84, 69, 82, 78, 65, 76, 32, 80, 65, 82, 83, 69, 68, 44, 32, 0, 0, 0, 0, 0, 0, 0, 69, 88, 84, 69, 82, 78, 65, 76, 32, 85, 78, 80, 65, 82, 83, 69, 68, 44, 32, 0, 0, 0, 0, 0, 73, 78, 84, 69, 82, 78, 65, 76, 32, 80, 65, 82, 65, 77, 69, 84, 69, 82, 44, 32, 0, 0, 0, 0, 69, 88, 84, 69, 82, 78, 65, 76, 32, 80, 65, 82, 65, 77, 69, 84, 69, 82, 44, 32, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 101, 110, 116, 105, 116, 121, 32, 116, 121, 112, 101, 32, 37, 100, 10, 0, 73, 68, 32, 34, 37, 115, 34, 0, 83, 89, 83, 84, 69, 77, 32, 34, 37, 115, 34, 0, 0, 0, 0, 0, 10, 32, 111, 114, 105, 103, 32, 34, 37, 115, 34, 0, 0, 0, 0, 0, 10, 32, 99, 111, 110, 116, 101, 110, 116, 32, 34, 37, 115, 34, 0, 0, 65, 116, 116, 114, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 65, 84, 84, 82, 73, 66, 85, 84, 69, 32, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 63, 0, 0, 0, 0, 0, 0, 240, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 96, 0, 2, 0, 104, 0, 2, 0, 128, 0, 2, 0, 152, 0, 2, 0, 176, 0, 2, 0, 216, 0, 2, 0, 240, 0, 2, 0, 8, 1, 2, 0, 32, 1, 2, 0, 64, 1, 2, 0, 88, 1, 2, 0, 112, 1, 2, 0, 128, 1, 2, 0, 160, 1, 2, 0, 184, 1, 2, 0, 216, 1, 2, 0, 248, 1, 2, 0, 8, 2, 2, 0, 24, 2, 2, 0, 48, 2, 2, 0, 80, 2, 2, 0, 96, 2, 2, 0, 120, 2, 2, 0, 152, 2, 2, 0, 176, 2, 2, 0, 200, 2, 2, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 101, 109, 112, 116, 121, 32, 40, 78, 85, 76, 76, 41, 10, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 117, 110, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 78, 111, 100, 101, 32, 83, 101, 116, 32, 58, 10, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 110, 32, 88, 83, 76, 84, 32, 118, 97, 108, 117, 101, 32, 116, 114, 101, 101, 32, 58, 10, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 66, 111, 111, 108, 101, 97, 110, 32, 58, 32, 0, 0, 116, 114, 117, 101, 10, 0, 0, 0, 102, 97, 108, 115, 101, 10, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 110, 117, 109, 98, 101, 114, 32, 58, 32, 73, 110, 102, 105, 110, 105, 116, 121, 10, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 110, 117, 109, 98, 101, 114, 32, 58, 32, 45, 73, 110, 102, 105, 110, 105, 116, 121, 10, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 110, 117, 109, 98, 101, 114, 32, 58, 32, 78, 97, 78, 10, 0, 0, 0, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 110, 117, 109, 98, 101, 114, 32, 58, 32, 48, 10, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 110, 117, 109, 98, 101, 114, 32, 58, 32, 37, 48, 103, 10, 0, 0, 0, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 115, 116, 114, 105, 110, 103, 32, 58, 32, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 112, 111, 105, 110, 116, 32, 58, 32, 105, 110, 100, 101, 120, 32, 37, 100, 32, 105, 110, 32, 110, 111, 100, 101, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 99, 111, 108, 108, 97, 112, 115, 101, 100, 32, 114, 97, 110, 103, 101, 32, 58, 10, 0, 0, 105, 110, 100, 101, 120, 32, 37, 100, 32, 105, 110, 32, 0, 0, 0, 0, 110, 111, 100, 101, 10, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 114, 97, 110, 103, 101, 32, 58, 10, 0, 0, 0, 0, 70, 114, 111, 109, 32, 0, 0, 0, 84, 111, 32, 0, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97, 32, 76, 111, 99, 97, 116, 105, 111, 110, 32, 83, 101, 116, 58, 10, 0, 0, 0, 0, 0, 0, 79, 98, 106, 101, 99, 116, 32, 105, 115, 32, 117, 115, 101, 114, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 120, 112, 97, 116, 104, 46, 99, 0, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 32, 115, 116, 97, 99, 107, 32, 100, 101, 112, 116, 104, 32, 108, 105, 109, 105, 116, 32, 114, 101, 97, 99, 104, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 112, 117, 115, 104, 105, 110, 103, 32, 118, 97, 108, 117, 101, 10, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 111, 100, 101, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 110, 111, 100, 101, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 110, 111, 100, 101, 115, 101, 116, 32, 104, 105, 116, 32, 108, 105, 109, 105, 116, 10, 0, 0, 0, 0, 0, 0, 109, 101, 114, 103, 105, 110, 103, 32, 110, 111, 100, 101, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 109, 101, 114, 103, 105, 110, 103, 32, 110, 111, 100, 101, 115, 101, 116, 32, 104, 105, 116, 32, 108, 105, 109, 105, 116, 10, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 111, 100, 101, 32, 115, 101, 116, 32, 111, 98, 106, 101, 99, 116, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 102, 108, 111, 97, 116, 32, 111, 98, 106, 101, 99, 116, 10, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 98, 111, 111, 108, 101, 97, 110, 32, 111, 98, 106, 101, 99, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 115, 116, 114, 105, 110, 103, 32, 111, 98, 106, 101, 99, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 112, 121, 105, 110, 103, 32, 111, 98, 106, 101, 99, 116, 10, 0, 120, 109, 108, 88, 80, 97, 116, 104, 79, 98, 106, 101, 99, 116, 67, 111, 112, 121, 58, 32, 117, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 116, 121, 112, 101, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 116, 114, 117, 101, 0, 0, 0, 0, 102, 97, 108, 115, 101, 0, 0, 0, 73, 110, 102, 105, 110, 105, 116, 121, 0, 0, 0, 0, 0, 0, 0, 0, 45, 73, 110, 102, 105, 110, 105, 116, 121, 0, 0, 0, 0, 0, 0, 0, 78, 97, 78, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 107, 101, 32, 110, 111, 100, 101, 32, 108, 105, 98, 120, 115, 108, 116, 0, 0, 0, 0, 0, 0, 0, 184, 254, 1, 0, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 84, 114, 97, 110, 115, 108, 97, 116, 101, 70, 117, 110, 99, 116, 105, 111, 110, 58, 32, 73, 110, 118, 97, 108, 105, 100, 32, 85, 84, 70, 56, 32, 115, 116, 114, 105, 110, 103, 10, 0, 0, 0, 0, 0, 0, 0, 240, 63, 0, 0, 0, 0, 0, 0, 36, 64, 0, 0, 0, 0, 0, 0, 89, 64, 0, 0, 0, 0, 0, 64, 143, 64, 0, 0, 0, 0, 0, 136, 195, 64, 0, 0, 0, 0, 0, 106, 248, 64, 0, 0, 0, 0, 128, 132, 46, 65, 0, 0, 0, 0, 208, 18, 99, 65, 0, 0, 0, 0, 132, 215, 151, 65, 0, 0, 0, 0, 101, 205, 205, 65, 0, 0, 0, 32, 95, 160, 2, 66, 0, 0, 0, 232, 118, 72, 55, 66, 0, 0, 0, 162, 148, 26, 109, 66, 0, 0, 64, 229, 156, 48, 162, 66, 0, 0, 144, 30, 196, 188, 214, 66, 0, 0, 52, 38, 245, 107, 12, 67, 0, 128, 224, 55, 121, 195, 65, 67, 0, 160, 216, 133, 87, 52, 118, 67, 0, 200, 78, 103, 109, 193, 171, 67, 0, 61, 145, 96, 228, 88, 225, 67, 64, 140, 181, 120, 29, 175, 21, 68, 110, 111, 100, 101, 0, 0, 0, 0, 116, 101, 120, 116, 0, 0, 0, 0, 99, 111, 109, 109, 101, 110, 116, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 45, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 78, 85, 76, 76, 32, 99, 111, 110, 116, 101, 120, 116, 32, 112, 111, 105, 110, 116, 101, 114, 10, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 69, 118, 97, 108, 58, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 69, 118, 97, 108, 58, 32, 37, 100, 32, 111, 98, 106, 101, 99, 116, 32, 108, 101, 102, 116, 32, 111, 110, 32, 116, 104, 101, 32, 115, 116, 97, 99, 107, 10, 0, 0, 0, 0, 0, 0, 98, 111, 111, 108, 101, 97, 110, 0, 99, 101, 105, 108, 105, 110, 103, 0, 99, 111, 117, 110, 116, 0, 0, 0, 99, 111, 110, 99, 97, 116, 0, 0, 99, 111, 110, 116, 97, 105, 110, 115, 0, 0, 0, 0, 0, 0, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 102, 108, 111, 111, 114, 0, 0, 0, 108, 97, 115, 116, 0, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 108, 111, 99, 97, 108, 45, 110, 97, 109, 101, 0, 0, 0, 0, 0, 0, 110, 111, 116, 0, 0, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 110, 97, 109, 101, 115, 112, 97, 99, 101, 45, 117, 114, 105, 0, 0, 0, 110, 111, 114, 109, 97, 108, 105, 122, 101, 45, 115, 112, 97, 99, 101, 0, 110, 117, 109, 98, 101, 114, 0, 0, 112, 111, 115, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 114, 111, 117, 110, 100, 0, 0, 0, 115, 116, 114, 105, 110, 103, 0, 0, 115, 116, 114, 105, 110, 103, 45, 108, 101, 110, 103, 116, 104, 0, 0, 0, 115, 116, 97, 114, 116, 115, 45, 119, 105, 116, 104, 0, 0, 0, 0, 0, 115, 117, 98, 115, 116, 114, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 115, 117, 98, 115, 116, 114, 105, 110, 103, 45, 98, 101, 102, 111, 114, 101, 0, 0, 0, 0, 0, 0, 0, 0, 115, 117, 98, 115, 116, 114, 105, 110, 103, 45, 97, 102, 116, 101, 114, 0, 115, 117, 109, 0, 0, 0, 0, 0, 116, 114, 97, 110, 115, 108, 97, 116, 101, 0, 0, 0, 0, 0, 0, 0, 101, 115, 99, 97, 112, 101, 45, 117, 114, 105, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 50, 47, 48, 56, 47, 120, 113, 117, 101, 114, 121, 45, 102, 117, 110, 99, 116, 105, 111, 110, 115, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 82, 117, 110, 69, 118, 97, 108, 58, 32, 108, 97, 115, 116, 32, 105, 115, 32, 108, 101, 115, 115, 32, 116, 104, 97, 110, 32, 122, 101, 114, 111, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 67, 111, 109, 112, 79, 112, 69, 118, 97, 108, 58, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 37, 115, 32, 98, 111, 117, 110, 100, 32, 116, 111, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 10, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 67, 111, 109, 112, 79, 112, 69, 118, 97, 108, 58, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 67, 111, 109, 112, 79, 112, 69, 118, 97, 108, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 37, 115, 32, 98, 111, 117, 110, 100, 32, 116, 111, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 10, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 67, 111, 109, 112, 79, 112, 69, 118, 97, 108, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 37, 115, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 88, 80, 97, 116, 104, 58, 32, 117, 110, 107, 110, 111, 119, 110, 32, 112, 114, 101, 99, 111, 109, 112, 105, 108, 101, 100, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 67, 111, 109, 112, 105, 108, 101, 100, 69, 118, 97, 108, 58, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 88, 80, 97, 116, 104, 67, 111, 109, 112, 105, 108, 101, 100, 69, 118, 97, 108, 58, 32, 37, 100, 32, 111, 98, 106, 101, 99, 116, 115, 32, 108, 101, 102, 116, 32, 111, 110, 32, 116, 104, 101, 32, 115, 116, 97, 99, 107, 46, 10, 0, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 115, 116, 101, 112, 10, 0, 0, 0, 0, 58, 58, 0, 0, 0, 0, 0, 0, 114, 97, 110, 103, 101, 45, 116, 111, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 99, 101, 115, 116, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 99, 101, 115, 116, 111, 114, 45, 111, 114, 45, 115, 101, 108, 102, 0, 0, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 0, 99, 104, 105, 108, 100, 0, 0, 0, 100, 101, 115, 99, 101, 110, 100, 97, 110, 116, 0, 0, 0, 0, 0, 0, 100, 101, 115, 99, 101, 110, 100, 97, 110, 116, 45, 111, 114, 45, 115, 101, 108, 102, 0, 0, 0, 0, 0, 0, 102, 111, 108, 108, 111, 119, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 102, 111, 108, 108, 111, 119, 105, 110, 103, 45, 115, 105, 98, 108, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 112, 97, 114, 101, 110, 116, 0, 0, 112, 114, 101, 99, 101, 100, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 112, 114, 101, 99, 101, 100, 105, 110, 103, 45, 115, 105, 98, 108, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 115, 101, 108, 102, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 97, 114, 114, 97, 121, 10, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 116, 114, 101, 97, 109, 97, 98, 108, 101, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 40, 247, 1, 0, 32, 247, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 109, 112, 97, 114, 105, 110, 103, 32, 110, 111, 100, 101, 115, 101, 116, 115, 10, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 10, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 116, 101, 112, 115, 10, 0, 0, 0, 0, 0, 0, 0, 37, 100, 0, 0, 0, 0, 0, 0, 37, 42, 46, 42, 101, 0, 0, 0, 37, 48, 46, 42, 102, 0, 0, 0, 120, 109, 108, 80, 111, 105, 110, 116, 101, 114, 76, 105, 115, 116, 67, 114, 101, 97, 116, 101, 58, 32, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 105, 116, 101, 109, 10, 0, 0, 120, 109, 108, 80, 111, 105, 110, 116, 101, 114, 76, 105, 115, 116, 65, 100, 100, 83, 105, 122, 101, 58, 32, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 105, 116, 101, 109, 10, 0, 0, 0, 0, 0, 0, 100, 117, 112, 108, 105, 99, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 76, 111, 99, 97, 116, 105, 111, 110, 83, 101, 116, 32, 105, 115, 32, 78, 85, 76, 76, 32, 33, 10, 0, 0, 37, 100, 32, 58, 32, 0, 0, 0, 78, 111, 100, 101, 32, 105, 115, 32, 78, 85, 76, 76, 32, 33, 10, 0, 32, 47, 10, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 84, 114, 101, 101, 32, 105, 115, 32, 78, 85, 76, 76, 32, 33, 10, 0, 0, 0, 78, 111, 100, 101, 83, 101, 116, 32, 105, 115, 32, 78, 85, 76, 76, 32, 33, 10, 0, 0, 0, 0, 0, 0, 83, 101, 116, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 37, 100, 32, 110, 111, 100, 101, 115, 58, 10, 0, 79, 107, 10, 0, 0, 0, 0, 0, 78, 117, 109, 98, 101, 114, 32, 101, 110, 99, 111, 100, 105, 110, 103, 10, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 102, 105, 110, 105, 115, 104, 101, 100, 32, 108, 105, 116, 101, 114, 97, 108, 10, 0, 0, 0, 0, 0, 83, 116, 97, 114, 116, 32, 111, 102, 32, 108, 105, 116, 101, 114, 97, 108, 10, 0, 0, 0, 0, 0, 0, 0, 69, 120, 112, 101, 99, 116, 101, 100, 32, 36, 32, 102, 111, 114, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 10, 0, 0, 0, 0, 0, 0, 85, 110, 100, 101, 102, 105, 110, 101, 100, 32, 118, 97, 114, 105, 97, 98, 108, 101, 10, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 112, 114, 101, 100, 105, 99, 97, 116, 101, 10, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 10, 0, 0, 0, 0, 0, 77, 105, 115, 115, 105, 110, 103, 32, 99, 108, 111, 115, 105, 110, 103, 32, 99, 117, 114, 108, 121, 32, 98, 114, 97, 99, 101, 10, 0, 0, 0, 0, 85, 110, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 32, 102, 117, 110, 99, 116, 105, 111, 110, 10, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 111, 112, 101, 114, 97, 110, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 116, 121, 112, 101, 10, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 10, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 99, 111, 110, 116, 101, 120, 116, 32, 115, 105, 122, 101, 10, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 99, 111, 110, 116, 101, 120, 116, 32, 112, 111, 115, 105, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 121, 110, 116, 97, 120, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 101, 114, 114, 111, 114, 10, 0, 83, 117, 98, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 85, 110, 100, 101, 102, 105, 110, 101, 100, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 10, 0, 0, 0, 0, 0, 69, 110, 99, 111, 100, 105, 110, 103, 32, 101, 114, 114, 111, 114, 10, 0, 67, 104, 97, 114, 32, 111, 117, 116, 32, 111, 102, 32, 88, 77, 76, 32, 114, 97, 110, 103, 101, 10, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 111, 114, 32, 105, 110, 99, 111, 109, 112, 108, 101, 116, 101, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 83, 116, 97, 99, 107, 32, 117, 115, 97, 103, 101, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 70, 111, 114, 98, 105, 100, 100, 101, 110, 32, 118, 97, 114, 105, 97, 98, 108, 101, 10, 0, 0, 0, 0, 0, 63, 63, 32, 85, 110, 107, 110, 111, 119, 110, 32, 101, 114, 114, 111, 114, 32, 63, 63, 10, 0, 0, 0, 0, 128, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3, 4, 5, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 240, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 32, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 101, 109, 112, 111, 114, 97, 114, 121, 32, 115, 116, 111, 114, 97, 103, 101, 32, 102, 111, 114, 32, 116, 105, 109, 32, 115, 111, 114, 116, 58, 32, 110, 101, 101, 100, 32, 37, 108, 117, 32, 98, 121, 116, 101, 115, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 114, 97, 110, 103, 101, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 120, 112, 111, 105, 110, 116, 101, 114, 46, 99, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 108, 111, 99, 97, 116, 105, 111, 110, 115, 101, 116, 0, 0, 97, 100, 100, 105, 110, 103, 32, 108, 111, 99, 97, 116, 105, 111, 110, 32, 116, 111, 32, 115, 101, 116, 0, 0, 114, 97, 110, 103, 101, 45, 116, 111, 0, 0, 0, 0, 0, 0, 0, 0, 114, 97, 110, 103, 101, 0, 0, 0, 114, 97, 110, 103, 101, 45, 105, 110, 115, 105, 100, 101, 0, 0, 0, 0, 115, 116, 114, 105, 110, 103, 45, 114, 97, 110, 103, 101, 0, 0, 0, 0, 115, 116, 97, 114, 116, 45, 112, 111, 105, 110, 116, 0, 0, 0, 0, 0, 101, 110, 100, 45, 112, 111, 105, 110, 116, 0, 0, 0, 0, 0, 0, 0, 104, 101, 114, 101, 0, 0, 0, 0, 32, 111, 114, 105, 103, 105, 110, 0, 120, 109, 108, 88, 80, 116, 114, 69, 118, 97, 108, 58, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 114, 101, 116, 117, 114, 110, 32, 97, 32, 110, 111, 100, 101, 32, 115, 101, 116, 10, 0, 0, 0, 0, 120, 109, 108, 88, 80, 116, 114, 69, 118, 97, 108, 58, 32, 111, 98, 106, 101, 99, 116, 40, 115, 41, 32, 108, 101, 102, 116, 32, 111, 110, 32, 116, 104, 101, 32, 101, 118, 97, 108, 32, 115, 116, 97, 99, 107, 10, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 112, 111, 105, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 120, 112, 111, 105, 110, 116, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 0, 120, 109, 108, 110, 115, 0, 0, 0, 117, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 115, 99, 104, 101, 109, 101, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 119, 97, 114, 110, 105, 110, 103, 58, 32, 67, 104, 105, 108, 100, 83, 101, 113, 32, 110, 111, 116, 32, 115, 116, 97, 114, 116, 105, 110, 103, 32, 98, 121, 32, 47, 49, 10, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 88, 73, 110, 99, 108, 117, 100, 101, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 88, 73, 110, 99, 108, 117, 100, 101, 32, 101, 114, 114, 111, 114, 58, 32, 119, 111, 117, 108, 100, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 32, 109, 117, 108, 116, 105, 112, 108, 101, 32, 114, 111, 111, 116, 32, 110, 111, 100, 101, 115, 10, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 98, 117, 105, 108, 100, 32, 110, 111, 100, 101, 10, 0, 0, 0, 104, 114, 101, 102, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 97, 114, 115, 101, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 116, 101, 120, 116, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 37, 115, 32, 102, 111, 114, 32, 39, 112, 97, 114, 115, 101, 39, 10, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 98, 117, 105, 108, 100, 32, 85, 82, 76, 10, 0, 0, 0, 0, 0, 0, 0, 102, 97, 108, 108, 98, 97, 99, 107, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 51, 47, 88, 73, 110, 99, 108, 117, 100, 101, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 73, 110, 99, 108, 117, 100, 101, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 108, 111, 97, 100, 32, 37, 115, 44, 32, 97, 110, 100, 32, 110, 111, 32, 102, 97, 108, 108, 98, 97, 99, 107, 32, 119, 97, 115, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 85, 82, 73, 32, 37, 115, 10, 0, 0, 0, 102, 114, 97, 103, 109, 101, 110, 116, 32, 105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 102, 111, 114, 32, 116, 101, 120, 116, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 116, 101, 120, 116, 32, 115, 101, 114, 105, 97, 108, 105, 122, 97, 116, 105, 111, 110, 32, 111, 102, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 110, 111, 116, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 10, 0, 0, 0, 101, 110, 99, 111, 100, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 101, 110, 99, 111, 100, 105, 110, 103, 32, 37, 115, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 10, 0, 0, 0, 0, 0, 0, 37, 115, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 105, 110, 118, 97, 108, 105, 100, 32, 99, 104, 97, 114, 10, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 116, 101, 120, 116, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 88, 80, 111, 105, 110, 116, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 88, 80, 111, 105, 110, 116, 101, 114, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 58, 32, 35, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 88, 80, 111, 105, 110, 116, 101, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 114, 97, 110, 103, 101, 58, 32, 35, 37, 115, 10, 0, 0, 0, 88, 80, 111, 105, 110, 116, 101, 114, 32, 115, 101, 108, 101, 99, 116, 115, 32, 97, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 58, 32, 35, 37, 115, 10, 0, 0, 0, 0, 0, 88, 80, 111, 105, 110, 116, 101, 114, 32, 115, 101, 108, 101, 99, 116, 115, 32, 97, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 58, 32, 35, 37, 115, 10, 0, 0, 0, 0, 0, 0, 88, 80, 111, 105, 110, 116, 101, 114, 32, 115, 101, 108, 101, 99, 116, 115, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 110, 111, 100, 101, 115, 58, 32, 35, 37, 115, 10, 0, 98, 97, 115, 101, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 116, 114, 121, 105, 110, 103, 32, 116, 111, 32, 98, 117, 105, 108, 100, 32, 114, 101, 108, 97, 116, 105, 118, 101, 32, 85, 82, 73, 32, 102, 114, 111, 109, 32, 37, 115, 10, 0, 0, 0, 116, 114, 121, 105, 110, 103, 32, 116, 111, 32, 114, 101, 98, 117, 105, 108, 100, 32, 98, 97, 115, 101, 32, 102, 114, 111, 109, 32, 37, 115, 10, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 100, 111, 99, 0, 0, 109, 105, 115, 109, 97, 116, 99, 104, 32, 105, 110, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 10, 0, 0, 99, 97, 110, 110, 111, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 120, 112, 111, 105, 110, 116, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 105, 110, 32, 85, 82, 73, 32, 37, 115, 32, 117, 115, 101, 32, 116, 104, 101, 32, 120, 112, 111, 105, 110, 116, 101, 114, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 100, 101, 116, 101, 99, 116, 101, 100, 32, 97, 32, 108, 111, 99, 97, 108, 32, 114, 101, 99, 117, 114, 115, 105, 111, 110, 32, 119, 105, 116, 104, 32, 110, 111, 32, 120, 112, 111, 105, 110, 116, 101, 114, 32, 105, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 100, 101, 116, 101, 99, 116, 101, 100, 32, 97, 32, 114, 101, 99, 117, 114, 115, 105, 111, 110, 32, 105, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 88, 73, 110, 99, 108, 117, 100, 101, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 99, 108, 117, 100, 101, 0, 37, 115, 32, 104, 97, 115, 32, 97, 110, 32, 39, 105, 110, 99, 108, 117, 100, 101, 39, 32, 99, 104, 105, 108, 100, 10, 0, 0, 0, 0, 0, 0, 37, 115, 32, 104, 97, 115, 32, 109, 117, 108, 116, 105, 112, 108, 101, 32, 102, 97, 108, 108, 98, 97, 99, 107, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 0, 0, 0, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 116, 104, 101, 32, 99, 104, 105, 108, 100, 32, 111, 102, 32, 97, 110, 32, 39, 105, 110, 99, 108, 117, 100, 101, 39, 10, 0, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 85, 82, 76, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 82, 101, 115, 111, 108, 118, 101, 58, 32, 112, 117, 98, 73, 68, 32, 37, 115, 32, 115, 121, 115, 73, 68, 32, 37, 115, 10, 0, 0, 0, 0, 0, 82, 101, 115, 111, 108, 118, 101, 58, 32, 112, 117, 98, 73, 68, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 82, 101, 115, 111, 108, 118, 101, 58, 32, 115, 121, 115, 73, 68, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 82, 101, 115, 111, 108, 118, 101, 32, 85, 82, 73, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 77, 76, 95, 68, 69, 66, 85, 71, 95, 67, 65, 84, 65, 76, 79, 71, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 77, 76, 95, 67, 65, 84, 65, 76, 79, 71, 95, 70, 73, 76, 69, 83, 0, 0, 0, 0, 0, 0, 0, 102, 105, 108, 101, 58, 47, 47, 47, 101, 116, 99, 47, 120, 109, 108, 47, 99, 97, 116, 97, 108, 111, 103, 0, 67, 97, 116, 97, 108, 111, 103, 115, 32, 99, 108, 101, 97, 110, 117, 112, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 116, 97, 108, 111, 103, 0, 3, 0, 0, 0, 0, 0, 0, 0, 65, 100, 100, 105, 110, 103, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 99, 97, 116, 97, 108, 111, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 76, 111, 99, 97, 108, 32, 82, 101, 115, 111, 108, 118, 101, 58, 32, 112, 117, 98, 73, 68, 32, 37, 115, 32, 115, 121, 115, 73, 68, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 76, 111, 99, 97, 108, 32, 82, 101, 115, 111, 108, 118, 101, 58, 32, 112, 117, 98, 73, 68, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 76, 111, 99, 97, 108, 32, 82, 101, 115, 111, 108, 118, 101, 58, 32, 115, 121, 115, 73, 68, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 37, 115, 32, 105, 110, 32, 102, 105, 108, 101, 32, 104, 97, 115, 104, 10, 0, 0, 37, 115, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 102, 105, 108, 101, 32, 104, 97, 115, 104, 10, 0, 0, 0, 0, 0, 0, 37, 115, 32, 97, 100, 100, 101, 100, 32, 116, 111, 32, 102, 105, 108, 101, 32, 104, 97, 115, 104, 10, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 99, 97, 116, 97, 108, 111, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 37, 100, 32, 80, 97, 114, 115, 105, 110, 103, 32, 99, 97, 116, 97, 108, 111, 103, 32, 37, 115, 10, 0, 0, 117, 114, 110, 58, 111, 97, 115, 105, 115, 58, 110, 97, 109, 101, 115, 58, 116, 99, 58, 101, 110, 116, 105, 116, 121, 58, 120, 109, 108, 110, 115, 58, 120, 109, 108, 58, 99, 97, 116, 97, 108, 111, 103, 0, 0, 0, 0, 0, 112, 114, 101, 102, 101, 114, 0, 0, 115, 121, 115, 116, 101, 109, 0, 0, 112, 117, 98, 108, 105, 99, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 112, 114, 101, 102, 101, 114, 58, 32, 39, 37, 115, 39, 10, 0, 70, 105, 108, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 88, 77, 76, 32, 67, 97, 116, 97, 108, 111, 103, 10, 0, 0, 103, 114, 111, 117, 112, 0, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 112, 117, 98, 108, 105, 99, 73, 100, 0, 0, 0, 0, 0, 0, 0, 0, 117, 114, 105, 0, 0, 0, 0, 0, 115, 121, 115, 116, 101, 109, 73, 100, 0, 0, 0, 0, 0, 0, 0, 0, 114, 101, 119, 114, 105, 116, 101, 83, 121, 115, 116, 101, 109, 0, 0, 0, 115, 121, 115, 116, 101, 109, 73, 100, 83, 116, 97, 114, 116, 83, 116, 114, 105, 110, 103, 0, 0, 0, 0, 0, 114, 101, 119, 114, 105, 116, 101, 80, 114, 101, 102, 105, 120, 0, 0, 0, 100, 101, 108, 101, 103, 97, 116, 101, 80, 117, 98, 108, 105, 99, 0, 0, 112, 117, 98, 108, 105, 99, 73, 100, 83, 116, 97, 114, 116, 83, 116, 114, 105, 110, 103, 0, 0, 0, 0, 0, 100, 101, 108, 101, 103, 97, 116, 101, 83, 121, 115, 116, 101, 109, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 114, 101, 119, 114, 105, 116, 101, 85, 82, 73, 0, 0, 0, 0, 0, 0, 117, 114, 105, 83, 116, 97, 114, 116, 83, 116, 114, 105, 110, 103, 0, 0, 100, 101, 108, 101, 103, 97, 116, 101, 85, 82, 73, 0, 0, 0, 0, 0, 110, 101, 120, 116, 67, 97, 116, 97, 108, 111, 103, 0, 0, 0, 0, 0, 37, 115, 32, 101, 110, 116, 114, 121, 32, 108, 97, 99, 107, 115, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 37, 115, 58, 32, 39, 37, 115, 39, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 37, 115, 58, 32, 39, 37, 115, 39, 10, 0, 37, 115, 32, 101, 110, 116, 114, 121, 32, 39, 37, 115, 39, 32, 98, 114, 111, 107, 101, 110, 32, 63, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 83, 89, 83, 84, 69, 77, 0, 0, 80, 85, 66, 76, 73, 67, 0, 0, 68, 69, 76, 69, 71, 65, 84, 69, 0, 0, 0, 0, 0, 0, 0, 0, 69, 78, 84, 73, 84, 89, 0, 0, 68, 79, 67, 84, 89, 80, 69, 0, 76, 73, 78, 75, 84, 89, 80, 69, 0, 0, 0, 0, 0, 0, 0, 0, 78, 79, 84, 65, 84, 73, 79, 78, 0, 0, 0, 0, 0, 0, 0, 0, 83, 71, 77, 76, 68, 69, 67, 76, 0, 0, 0, 0, 0, 0, 0, 0, 68, 79, 67, 85, 77, 69, 78, 84, 0, 0, 0, 0, 0, 0, 0, 0, 67, 65, 84, 65, 76, 79, 71, 0, 66, 65, 83, 69, 0, 0, 0, 0, 117, 114, 110, 58, 112, 117, 98, 108, 105, 99, 105, 100, 58, 0, 0, 0, 85, 82, 78, 32, 73, 68, 32, 37, 115, 32, 101, 120, 112, 97, 110, 100, 101, 100, 32, 116, 111, 32, 78, 85, 76, 76, 10, 0, 0, 0, 0, 0, 85, 82, 78, 32, 73, 68, 32, 101, 120, 112, 97, 110, 100, 101, 100, 32, 116, 111, 32, 37, 115, 10, 0, 0, 68, 101, 116, 101, 99, 116, 101, 100, 32, 114, 101, 99, 117, 114, 115, 105, 111, 110, 32, 105, 110, 32, 99, 97, 116, 97, 108, 111, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 85, 82, 73, 32, 109, 97, 116, 99, 104, 32, 37, 115, 10, 0, 0, 0, 0, 0, 85, 115, 105, 110, 103, 32, 114, 101, 119, 114, 105, 116, 105, 110, 103, 32, 114, 117, 108, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 84, 114, 121, 105, 110, 103, 32, 85, 82, 73, 32, 100, 101, 108, 101, 103, 97, 116, 101, 32, 37, 115, 10, 0, 80, 117, 98, 108, 105, 99, 32, 85, 82, 78, 32, 73, 68, 32, 37, 115, 32, 101, 120, 112, 97, 110, 100, 101, 100, 32, 116, 111, 32, 78, 85, 76, 76, 10, 0, 0, 0, 0, 0, 0, 80, 117, 98, 108, 105, 99, 32, 85, 82, 78, 32, 73, 68, 32, 101, 120, 112, 97, 110, 100, 101, 100, 32, 116, 111, 32, 37, 115, 10, 0, 0, 0, 83, 121, 115, 116, 101, 109, 32, 85, 82, 78, 32, 73, 68, 32, 37, 115, 32, 101, 120, 112, 97, 110, 100, 101, 100, 32, 116, 111, 32, 78, 85, 76, 76, 10, 0, 0, 0, 0, 0, 0, 83, 121, 115, 116, 101, 109, 32, 85, 82, 78, 32, 73, 68, 32, 101, 120, 112, 97, 110, 100, 101, 100, 32, 116, 111, 32, 37, 115, 10, 0, 0, 0, 70, 111, 117, 110, 100, 32, 115, 121, 115, 116, 101, 109, 32, 109, 97, 116, 99, 104, 32, 37, 115, 44, 32, 117, 115, 105, 110, 103, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 84, 114, 121, 105, 110, 103, 32, 115, 121, 115, 116, 101, 109, 32, 100, 101, 108, 101, 103, 97, 116, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 112, 117, 98, 108, 105, 99, 32, 109, 97, 116, 99, 104, 32, 37, 115, 10, 0, 0, 84, 114, 121, 105, 110, 103, 32, 112, 117, 98, 108, 105, 99, 32, 100, 101, 108, 101, 103, 97, 116, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 99, 97, 116, 97, 108, 111, 103, 32, 101, 110, 116, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 79, 86, 69, 82, 82, 73, 68, 69, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 112, 117, 98, 108, 105, 99, 32, 73, 68, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 99, 97, 116, 97, 108, 111, 103, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 99, 97, 116, 97, 108, 111, 103, 32, 100, 97, 116, 97, 0, 70, 114, 101, 101, 32, 99, 97, 116, 97, 108, 111, 103, 32, 101, 110, 116, 114, 121, 32, 37, 115, 10, 0, 0, 70, 114, 101, 101, 32, 99, 97, 116, 97, 108, 111, 103, 32, 101, 110, 116, 114, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 33, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 50, 48, 57, 48, 50, 0, 0, 0, 96, 18, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 32, 32, 0, 0, 0, 0, 0, 0, 8, 19, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 0, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 39, 0, 0, 0, 40, 0, 0, 0, 41, 0, 0, 0, 42, 0, 0, 0, 43, 0, 0, 0, 44, 0, 0, 0, 45, 0, 0, 0, 46, 0, 0, 0, 47, 0, 0, 0, 48, 0, 0, 0, 49, 0, 0, 0, 50, 0, 0, 0, 51, 0, 0, 0, 52, 0, 0, 0, 53, 0, 0, 0, 53, 0, 0, 0, 54, 0, 0, 0, 55, 0, 0, 0, 56], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 125808);
	        allocate([57, 0, 0, 0, 57, 0, 0, 0, 58, 0, 0, 0, 59, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 61, 0, 0, 0, 62, 0, 0, 0, 63, 0, 0, 0, 64, 0, 0, 0, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 48, 0, 0, 0, 49, 0, 0, 0, 50, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 53, 0, 0, 0, 65, 0, 0, 0, 54, 0, 0, 0, 55, 0, 0, 0, 56, 0, 0, 0, 57, 0, 0, 0, 57, 0, 0, 0, 58, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 120, 101, 99, 117, 116, 105, 110, 103, 32, 99, 49, 52, 110, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 109, 111, 100, 101, 32, 102, 111, 114, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 32, 99, 49, 52, 110, 0, 120, 109, 108, 67, 49, 52, 78, 69, 120, 101, 99, 117, 116, 101, 58, 32, 111, 117, 116, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 32, 101, 110, 99, 111, 100, 101, 114, 32, 33, 61, 32, 78, 85, 76, 76, 32, 98, 117, 116, 32, 67, 49, 52, 78, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 85, 84, 70, 56, 32, 111, 117, 116, 112, 117, 116, 10, 0, 0, 0, 0, 120, 109, 108, 67, 49, 52, 78, 69, 120, 101, 99, 117, 116, 101, 58, 32, 117, 110, 97, 98, 108, 101, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 67, 49, 52, 78, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 100, 111, 99, 115, 32, 99, 104, 105, 108, 100, 114, 101, 110, 32, 108, 105, 115, 116, 0, 0, 0, 102, 108, 117, 115, 104, 105, 110, 103, 32, 111, 117, 116, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 0, 0, 100, 117, 109, 112, 105, 110, 103, 32, 100, 111, 99, 32, 116, 111, 32, 109, 101, 109, 111, 114, 121, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 111, 117, 116, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 0, 0, 115, 97, 118, 105, 110, 103, 32, 100, 111, 99, 32, 116, 111, 32, 111, 117, 116, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 99, 111, 112, 105, 110, 103, 32, 99, 97, 110, 111, 110, 105, 99, 97, 110, 105, 122, 101, 100, 32, 100, 111, 99, 117, 109, 101, 110, 116, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 102, 114, 101, 101, 105, 110, 103, 32, 99, 111, 110, 116, 101, 120, 116, 0, 100, 101, 115, 116, 114, 111, 121, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 110, 111, 100, 101, 32, 108, 105, 115, 116, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 110, 111, 100, 101, 0, 110, 111, 114, 109, 97, 108, 105, 122, 105, 110, 103, 32, 116, 101, 120, 116, 32, 110, 111, 100, 101, 0, 0, 0, 10, 60, 63, 0, 0, 0, 0, 0, 60, 63, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 110, 111, 114, 109, 97, 108, 105, 122, 105, 110, 103, 32, 112, 105, 32, 110, 111, 100, 101, 0, 0, 0, 0, 0, 63, 62, 10, 0, 0, 0, 0, 0, 63, 62, 0, 0, 0, 0, 0, 0, 10, 60, 33, 45, 45, 0, 0, 0, 60, 33, 45, 45, 0, 0, 0, 0, 110, 111, 114, 109, 97, 108, 105, 122, 105, 110, 103, 32, 99, 111, 109, 109, 101, 110, 116, 32, 110, 111, 100, 101, 0, 0, 0, 0, 0, 0, 0, 0, 45, 45, 62, 10, 0, 0, 0, 0, 45, 45, 62, 0, 0, 0, 0, 0, 88, 77, 76, 95, 65, 84, 84, 82, 73, 66, 85, 84, 69, 95, 78, 79, 68, 69, 0, 0, 0, 0, 0, 0, 88, 77, 76, 95, 78, 65, 77, 69, 83, 80, 65, 67, 69, 95, 68, 69, 67, 76, 0, 0, 0, 0, 0, 0, 88, 77, 76, 95, 69, 78, 84, 73, 84, 89, 95, 82, 69, 70, 95, 78, 79, 68, 69, 0, 0, 0, 0, 0, 88, 77, 76, 95, 69, 78, 84, 73, 84, 89, 95, 78, 79, 68, 69, 0, 85, 110, 107, 110, 111, 119, 110, 32, 110, 111, 100, 101, 32, 116, 121, 112, 101, 32, 37, 100, 32, 102, 111, 117, 110, 100, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 78, 111, 100, 101, 32, 37, 115, 32, 105, 115, 32, 105, 110, 118, 97, 108, 105, 100, 32, 104, 101, 114, 101, 32, 58, 32, 37, 115, 10, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 100, 101, 0, 99, 104, 101, 99, 107, 105, 110, 103, 32, 102, 111, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 0, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 97, 120, 105, 115, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 97, 120, 105, 115, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 99, 104, 105, 108, 100, 114, 101, 110, 115, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 0, 60, 47, 0, 0, 0, 0, 0, 0, 114, 101, 115, 116, 111, 114, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 115, 112, 97, 99, 101, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 119, 114, 105, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 0, 0, 0, 0, 0, 0, 61, 34, 0, 0, 0, 0, 0, 0, 110, 111, 114, 109, 97, 108, 105, 122, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 97, 120, 105, 115, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 120, 109, 108, 58, 98, 97, 115, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 120, 109, 108, 58, 98, 97, 115, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 45, 32, 99, 97, 110, 39, 116, 32, 103, 101, 116, 32, 97, 116, 116, 114, 32, 118, 97, 108, 117, 101, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 120, 109, 108, 58, 98, 97, 115, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 45, 32, 99, 97, 110, 39, 116, 32, 109, 111, 100, 105, 102, 121, 32, 117, 114, 105, 0, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 120, 109, 108, 58, 98, 97, 115, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 45, 32, 99, 97, 110, 39, 116, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 32, 117, 114, 105, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 120, 109, 108, 58, 98, 97, 115, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 45, 32, 99, 97, 110, 39, 116, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 115, 104, 105, 102, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 97, 120, 105, 115, 32, 40, 101, 120, 99, 32, 99, 49, 52, 110, 41, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 108, 105, 115, 116, 32, 40, 101, 120, 99, 32, 99, 49, 52, 110, 41, 0, 0, 0, 0, 0, 35, 100, 101, 102, 97, 117, 108, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 114, 105, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 0, 0, 0, 0, 0, 0, 32, 120, 109, 108, 110, 115, 58, 0, 61, 0, 0, 0, 0, 0, 0, 0, 32, 120, 109, 108, 110, 115, 61, 0, 34, 34, 0, 0, 0, 0, 0, 0, 115, 101, 97, 114, 99, 104, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 32, 40, 101, 120, 99, 32, 99, 49, 52, 110, 41, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 116, 111, 32, 115, 116, 97, 99, 107, 0, 0, 0, 0, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 110, 111, 100, 101, 32, 116, 111, 32, 115, 116, 97, 99, 107, 0, 0, 0, 0, 115, 101, 97, 114, 99, 104, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 32, 40, 99, 49, 52, 110, 41, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 97, 120, 105, 115, 32, 40, 99, 49, 52, 110, 41, 0, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 108, 105, 115, 116, 32, 40, 99, 49, 52, 110, 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 97, 118, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 0, 112, 97, 114, 115, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 117, 114, 105, 0, 0, 0, 117, 114, 110, 0, 0, 0, 0, 0, 100, 97, 118, 0, 0, 0, 0, 0, 82, 101, 108, 97, 116, 105, 118, 101, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 85, 82, 32, 105, 115, 32, 105, 110, 118, 97, 108, 105, 100, 32, 104, 101, 114, 101, 32, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 101, 119, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 120, 109, 108, 67, 49, 52, 78, 78, 101, 119, 67, 116, 120, 58, 32, 111, 117, 116, 112, 117, 116, 32, 98, 117, 102, 102, 101, 114, 32, 101, 110, 99, 111, 100, 101, 114, 32, 33, 61, 32, 78, 85, 76, 76, 32, 98, 117, 116, 32, 67, 49, 52, 78, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 85, 84, 70, 56, 32, 111, 117, 116, 112, 117, 116, 10, 0, 0, 0, 0, 0, 120, 109, 108, 67, 49, 52, 78, 78, 101, 119, 67, 116, 120, 58, 32, 115, 111, 117, 114, 99, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 110, 111, 116, 32, 105, 110, 32, 85, 84, 70, 56, 10, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 67, 49, 52, 78, 78, 101, 119, 67, 116, 120, 58, 32, 120, 109, 108, 67, 49, 52, 78, 86, 105, 115, 105, 98, 108, 101, 78, 115, 83, 116, 97, 99, 107, 67, 114, 101, 97, 116, 101, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 32, 115, 116, 97, 99, 107, 0, 0, 0, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 58, 32, 37, 115, 10, 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 109, 97, 108, 108, 111, 99, 32, 111, 102, 32, 37, 108, 100, 32, 98, 121, 116, 101, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 38, 113, 117, 111, 116, 59, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 73, 110, 112, 117, 116, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 111, 117, 116, 115, 105, 100, 101, 32, 111, 102, 32, 116, 104, 101, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 101, 120, 101, 99, 117, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 120, 109, 108, 70, 65, 80, 97, 114, 115, 101, 82, 101, 103, 69, 120, 112, 58, 32, 101, 120, 116, 114, 97, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 115, 0, 0, 0, 0, 0, 0, 110, 111, 116, 32, 37, 115, 0, 0, 97, 116, 111, 109, 32, 112, 117, 115, 104, 58, 32, 97, 116, 111, 109, 32, 105, 115, 32, 78, 85, 76, 76, 0, 112, 117, 115, 104, 105, 110, 103, 32, 97, 116, 111, 109, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 99, 111, 117, 110, 116, 101, 114, 0, 0, 0, 0, 0, 0, 97, 100, 100, 32, 115, 116, 97, 116, 101, 58, 32, 115, 116, 97, 116, 101, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 0, 0, 97, 100, 100, 32, 115, 116, 97, 116, 101, 58, 32, 116, 97, 114, 103, 101, 116, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 116, 114, 97, 110, 115, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 103, 101, 110, 114, 97, 116, 101, 32, 116, 114, 97, 110, 115, 105, 116, 105, 111, 110, 58, 32, 97, 116, 111, 109, 32, 61, 61, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 112, 121, 105, 110, 103, 32, 97, 116, 111, 109, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 114, 97, 110, 103, 101, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 116, 111, 109, 0, 84, 79, 68, 79, 58, 32, 88, 77, 76, 95, 82, 69, 71, 69, 88, 80, 95, 83, 84, 82, 73, 78, 71, 10, 0, 0, 0, 0, 0, 0, 0, 0, 114, 117, 110, 110, 105, 110, 103, 32, 114, 101, 103, 101, 120, 112, 0, 0, 101, 112, 115, 105, 108, 111, 110, 32, 116, 114, 97, 110, 115, 105, 116, 105, 111, 110, 32, 108, 101, 102, 116, 32, 97, 116, 32, 114, 117, 110, 116, 105, 109, 101, 10, 0, 0, 0, 0, 0, 101, 120, 101, 99, 32, 115, 97, 118, 101, 58, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 0, 0, 0, 0, 115, 97, 118, 105, 110, 103, 32, 114, 101, 103, 101, 120, 112, 0, 0, 0, 99, 111, 109, 112, 105, 108, 105, 110, 103, 32, 114, 101, 103, 101, 120, 112, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 58, 32, 37, 115, 10, 0, 0, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 32, 98, 114, 97, 110, 99, 104, 32, 97, 102, 116, 101, 114, 32, 124, 0, 0, 0, 0, 0, 0, 105, 110, 116, 101, 114, 110, 97, 108, 58, 32, 110, 111, 32, 97, 116, 111, 109, 32, 103, 101, 110, 101, 114, 97, 116, 101, 100, 0, 0, 0, 0, 0, 73, 109, 112, 114, 111, 112, 101, 114, 32, 113, 117, 97, 110, 116, 105, 102, 105, 101, 114, 0, 0, 0, 0, 0, 85, 110, 116, 101, 114, 109, 105, 110, 97, 116, 101, 100, 32, 113, 117, 97, 110, 116, 105, 102, 105, 101, 114, 0, 120, 109, 108, 70, 65, 80, 97, 114, 115, 101, 65, 116, 111, 109, 58, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 41, 39, 0, 0, 0, 120, 109, 108, 70, 65, 80, 97, 114, 115, 101, 67, 104, 97, 114, 67, 108, 97, 115, 115, 58, 32, 39, 93, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 0, 0, 69, 115, 99, 97, 112, 101, 100, 32, 115, 101, 113, 117, 101, 110, 99, 101, 58, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 92, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 123, 39, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 125, 39, 0, 0, 0, 87, 114, 111, 110, 103, 32, 101, 115, 99, 97, 112, 101, 32, 115, 101, 113, 117, 101, 110, 99, 101, 44, 32, 109, 105, 115, 117, 115, 101, 32, 111, 102, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 39, 92, 39, 0, 0, 73, 115, 88, 88, 88, 88, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 85, 110, 107, 110, 111, 119, 110, 32, 99, 104, 97, 114, 32, 112, 114, 111, 112, 101, 114, 116, 121, 0, 0, 0, 97, 100, 100, 32, 114, 97, 110, 103, 101, 58, 32, 97, 116, 111, 109, 32, 105, 115, 32, 78, 85, 76, 76, 0, 97, 100, 100, 32, 114, 97, 110, 103, 101, 58, 32, 97, 116, 111, 109, 32, 105, 115, 32, 110, 111, 116, 32, 114, 97, 110, 103, 101, 115, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 114, 97, 110, 103, 101, 115, 0, 0, 0, 99, 104, 97, 114, 67, 108, 97, 115, 115, 69, 120, 112, 114, 58, 32, 39, 93, 39, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 39, 93, 39, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 101, 115, 99, 97, 112, 101, 32, 118, 97, 108, 117, 101, 0, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 32, 99, 104, 97, 114, 32, 114, 97, 110, 103, 101, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 116, 104, 101, 32, 101, 110, 100, 32, 111, 102, 32, 97, 32, 99, 104, 97, 114, 32, 114, 97, 110, 103, 101, 0, 0, 0, 0, 0, 0, 0, 69, 110, 100, 32, 111, 102, 32, 114, 97, 110, 103, 101, 32, 105, 115, 32, 98, 101, 102, 111, 114, 101, 32, 115, 116, 97, 114, 116, 32, 111, 102, 32, 114, 97, 110, 103, 101, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 115, 116, 97, 116, 101, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 116, 97, 116, 101, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 120, 109, 108, 114, 101, 103, 101, 120, 112, 46, 99, 0, 0, 112, 117, 115, 104, 105, 110, 103, 32, 105, 110, 112, 117, 116, 32, 115, 116, 114, 105, 110, 103, 0, 0, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 120, 109, 108, 115, 99, 104, 101, 109, 97, 115, 46, 99, 0, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 70, 97, 99, 101, 116, 0, 0, 0, 0, 0, 97, 32, 116, 121, 112, 101, 32, 117, 115, 101, 114, 32, 100, 101, 114, 105, 118, 101, 100, 32, 116, 121, 112, 101, 32, 104, 97, 115, 32, 110, 111, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 70, 97, 99, 101, 116, 44, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 102, 97, 99, 101, 116, 32, 39, 37, 115, 39, 32, 97, 103, 97, 105, 110, 115, 116, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 102, 97, 99, 101, 116, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 97, 103, 97, 105, 110, 115, 116, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 0, 118, 97, 108, 117, 101, 32, 119, 97, 115, 32, 110, 111, 116, 32, 99, 111, 109, 112, 117, 116, 101, 100, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 102, 97, 99, 101, 116, 32, 39, 112, 97, 116, 116, 101, 114, 110, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 102, 97, 99, 101, 116, 32, 118, 97, 108, 117, 101, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 102, 97, 99, 101, 116, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 39, 37, 115, 39, 0, 0, 0, 0, 110, 111, 110, 78, 101, 103, 97, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 0, 0, 0, 0, 0, 112, 111, 115, 105, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 112, 114, 101, 115, 101, 114, 118, 101, 0, 0, 0, 0, 0, 0, 0, 0, 114, 101, 112, 108, 97, 99, 101, 0, 99, 111, 108, 108, 97, 112, 115, 101, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 102, 97, 99, 101, 116, 32, 39, 119, 104, 105, 116, 101, 115, 112, 97, 99, 101, 39, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 99, 97, 116, 101, 32, 116, 104, 101, 32, 109, 97, 105, 110, 32, 115, 99, 104, 101, 109, 97, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 97, 116, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 99, 97, 116, 101, 32, 116, 104, 101, 32, 109, 97, 105, 110, 32, 115, 99, 104, 101, 109, 97, 32, 114, 101, 115, 111, 117, 114, 99, 101, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 97, 114, 115, 101, 0, 0, 65, 110, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 111, 99, 99, 117, 114, 101, 100, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 84, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 101, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 65, 117, 103, 109, 101, 110, 116, 73, 68, 67, 58, 32, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 97, 117, 103, 109, 101, 110, 116, 101, 100, 32, 73, 68, 67, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 114, 101, 97, 116, 101, 80, 67, 116, 120, 116, 79, 110, 86, 67, 116, 120, 116, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 97, 32, 116, 101, 109, 112, 46, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 83, 65, 88, 72, 97, 110, 100, 108, 101, 67, 68, 97, 116, 97, 83, 101, 99, 116, 105, 111, 110, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 80, 117, 115, 104, 84, 101, 120, 116, 40, 41, 0, 0, 0, 0, 78, 101, 105, 116, 104, 101, 114, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 110, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 97, 108, 108, 111, 119, 101, 100, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 115, 32, 39, 110, 105, 108, 108, 101, 100, 39, 0, 0, 0, 0, 0, 0, 0, 0, 67, 104, 97, 114, 97, 99, 116, 101, 114, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 105, 115, 32, 101, 109, 112, 116, 121, 0, 0, 0, 0, 0, 67, 104, 97, 114, 97, 99, 116, 101, 114, 32, 99, 111, 110, 116, 101, 110, 116, 32, 111, 116, 104, 101, 114, 32, 116, 104, 97, 110, 32, 119, 104, 105, 116, 101, 115, 112, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 105, 115, 32, 39, 101, 108, 101, 109, 101, 110, 116, 45, 111, 110, 108, 121, 39, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 83, 65, 88, 72, 97, 110, 100, 108, 101, 69, 110, 100, 69, 108, 101, 109, 101, 110, 116, 78, 115, 0, 0, 101, 108, 101, 109, 32, 112, 111, 112, 32, 109, 105, 115, 109, 97, 116, 99, 104, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 111, 114, 80, 111, 112, 69, 108, 101, 109, 40, 41, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 111, 114, 80, 111, 112, 69, 108, 101, 109, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 97, 32, 114, 101, 103, 101, 120, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 0, 77, 105, 115, 115, 105, 110, 103, 32, 99, 104, 105, 108, 100, 32, 101, 108, 101, 109, 101, 110, 116, 40, 115, 41, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 67, 104, 101, 99, 107, 67, 86, 67, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 40, 41, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 67, 79, 83, 86, 97, 108, 105, 100, 68, 101, 102, 97, 117, 108, 116, 40, 41, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 78, 101, 119, 84, 101, 120, 116, 40, 41, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 100, 101, 115, 32, 115, 105, 110, 99, 101, 32, 116, 104, 101, 114, 101, 32, 105, 115, 32, 97, 32, 102, 105, 120, 101, 100, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 0, 0, 0, 84, 104, 101, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 102, 105, 120, 101, 100, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 39, 37, 115, 39, 0, 0, 0, 84, 104, 101, 32, 97, 99, 116, 117, 97, 108, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 102, 105, 120, 101, 100, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 39, 37, 115, 39, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 73, 68, 67, 32, 108, 105, 115, 116, 32, 111, 102, 32, 110, 111, 100, 101, 45, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 115, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 73, 68, 67, 32, 108, 105, 115, 116, 32, 111, 102, 32, 110, 111, 100, 101, 45, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 115, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 73, 68, 67, 32, 110, 111, 100, 101, 45, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 115, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 80, 83, 86, 73, 32, 73, 68, 67, 32, 98, 105, 110, 100, 105, 110, 103, 32, 105, 116, 101, 109, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 110, 101, 119, 32, 105, 116, 101, 109, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 0, 0, 103, 114, 111, 119, 105, 110, 103, 32, 105, 116, 101, 109, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 0, 77, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 101, 32, 109, 97, 116, 99, 104, 32, 102, 111, 117, 110, 100, 32, 102, 111, 114, 32, 107, 101, 121, 45, 115, 101, 113, 117, 101, 110, 99, 101, 32, 37, 115, 32, 111, 102, 32, 107, 101, 121, 114, 101, 102, 32, 39, 37, 115, 39, 0, 0, 0, 0, 78, 111, 32, 109, 97, 116, 99, 104, 32, 102, 111, 117, 110, 100, 32, 102, 111, 114, 32, 107, 101, 121, 45, 115, 101, 113, 117, 101, 110, 99, 101, 32, 37, 115, 32, 111, 102, 32, 107, 101, 121, 114, 101, 102, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 77, 76, 83, 99, 104, 101, 109, 97, 0, 0, 0, 0, 0, 0, 0, 0, 91, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 70, 111, 114, 109, 97, 116, 73, 68, 67, 75, 101, 121, 83, 101, 113, 117, 101, 110, 99, 101, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 117, 116, 101, 32, 97, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 32, 118, 97, 108, 117, 101, 0, 0, 0, 0, 0, 63, 63, 63, 0, 0, 0, 0, 0, 39, 44, 32, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 39, 37, 115, 39, 58, 32, 0, 0, 46, 10, 0, 0, 0, 0, 0, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 73, 68, 67, 32, 110, 111, 100, 101, 45, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 115, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 88, 80, 97, 116, 104, 80, 114, 111, 99, 101, 115, 115, 72, 105, 115, 116, 111, 114, 121, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 116, 114, 101, 97, 109, 80, 111, 112, 40, 41, 0, 0, 102, 105, 101, 108, 100, 32, 114, 101, 115, 111, 108, 118, 101, 115, 32, 116, 111, 32, 97, 32, 67, 84, 32, 119, 105, 116, 104, 32, 115, 105, 109, 112, 108, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 98, 117, 116, 32, 116, 104, 101, 32, 67, 84, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 32, 116, 104, 101, 32, 83, 84, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 88, 80, 97, 116, 104, 32, 39, 37, 115, 39, 32, 111, 102, 32, 97, 32, 102, 105, 101, 108, 100, 32, 111, 102, 32, 37, 115, 32, 100, 111, 101, 115, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 111, 32, 97, 32, 110, 111, 100, 101, 32, 111, 102, 32, 110, 111, 110, 45, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 87, 97, 114, 110, 105, 110, 103, 58, 32, 78, 111, 32, 112, 114, 101, 99, 111, 109, 112, 117, 116, 101, 100, 32, 118, 97, 108, 117, 101, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 44, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 119, 97, 115, 32, 101, 105, 116, 104, 101, 114, 32, 105, 110, 118, 97, 108, 105, 100, 32, 111, 114, 32, 115, 111, 109, 101, 116, 104, 105, 110, 103, 32, 115, 116, 114, 97, 110, 103, 101, 32, 104, 97, 112, 112, 101, 110, 100, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 107, 101, 121, 45, 115, 101, 113, 117, 101, 110, 99, 101, 115, 0, 0, 0, 0, 114, 101, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 107, 101, 121, 45, 115, 101, 113, 117, 101, 110, 99, 101, 115, 0, 0, 84, 104, 101, 32, 88, 80, 97, 116, 104, 32, 39, 37, 115, 39, 32, 111, 102, 32, 97, 32, 102, 105, 101, 108, 100, 32, 111, 102, 32, 37, 115, 32, 101, 118, 97, 108, 117, 97, 116, 101, 115, 32, 116, 111, 32, 97, 32, 110, 111, 100, 101, 45, 115, 101, 116, 32, 119, 105, 116, 104, 32, 109, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 101, 32, 109, 101, 109, 98, 101, 114, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 73, 68, 67, 32, 107, 101, 121, 45, 115, 101, 113, 117, 101, 110, 99, 101, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 73, 68, 67, 32, 107, 101, 121, 0, 0, 0, 0, 68, 117, 112, 108, 105, 99, 97, 116, 101, 32, 107, 101, 121, 45, 115, 101, 113, 117, 101, 110, 99, 101, 32, 37, 115, 32, 105, 110, 32, 37, 115, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 73, 68, 67, 32, 110, 111, 100, 101, 45, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 0, 0, 0, 0, 0, 0, 0, 78, 111, 116, 32, 97, 108, 108, 32, 102, 105, 101, 108, 100, 115, 32, 111, 102, 32, 37, 115, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 111, 32, 97, 32, 110, 111, 100, 101, 0, 84, 104, 101, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 32, 116, 111, 32, 98, 101, 32, 114, 101, 109, 111, 118, 101, 100, 32, 105, 115, 32, 110, 111, 116, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 105, 110, 32, 116, 104, 101, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 73, 68, 67, 32, 110, 111, 100, 101, 32, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 32, 108, 105, 115, 116, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 73, 68, 67, 32, 110, 111, 100, 101, 32, 116, 97, 98, 108, 101, 32, 105, 116, 101, 109, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 73, 68, 67, 32, 107, 101, 121, 32, 115, 116, 111, 114, 97, 103, 101, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 73, 68, 67, 32, 107, 101, 121, 32, 115, 116, 111, 114, 97, 103, 101, 32, 108, 105, 115, 116, 0, 0, 32, 39, 0, 0, 0, 0, 0, 0, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 110, 111, 116, 97, 116, 105, 111, 110, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 40, 115, 101, 113, 117, 101, 110, 99, 101, 41, 0, 0, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 40, 99, 104, 111, 105, 99, 101, 41, 0, 0, 0, 0, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 40, 97, 108, 108, 41, 0, 0, 0, 0, 0, 0, 0, 112, 97, 114, 116, 105, 99, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 105, 113, 117, 101, 32, 105, 100, 101, 110, 116, 105, 116, 121, 45, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 0, 0, 0, 0, 107, 101, 121, 32, 105, 100, 101, 110, 116, 105, 116, 121, 45, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 107, 101, 121, 114, 101, 102, 32, 105, 100, 101, 110, 116, 105, 116, 121, 45, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 0, 0, 0, 0, 119, 105, 108, 100, 99, 97, 114, 100, 32, 40, 97, 110, 121, 41, 0, 0, 91, 104, 101, 108, 112, 101, 114, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 93, 32, 81, 78, 97, 109, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 0, 0, 0, 0, 0, 0, 91, 104, 101, 108, 112, 101, 114, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 93, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 0, 0, 0, 0, 78, 111, 116, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 70, 111, 114, 32, 97, 32, 115, 116, 114, 105, 110, 103, 32, 116, 111, 32, 98, 101, 32, 97, 32, 118, 97, 108, 105, 100, 32, 100, 101, 102, 97, 117, 108, 116, 44, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 111, 114, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 119, 105, 116, 104, 32, 115, 105, 109, 112, 108, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 111, 114, 32, 109, 105, 120, 101, 100, 32, 99, 111, 110, 116, 101, 110, 116, 32, 97, 110, 100, 32, 97, 32, 112, 97, 114, 116, 105, 99, 108, 101, 32, 101, 109, 112, 116, 105, 97, 98, 108, 101, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 67, 79, 83, 86, 97, 108, 105, 100, 68, 101, 102, 97, 117, 108, 116, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 32, 69, 120, 112, 101, 99, 116, 101, 100, 32, 105, 115, 32, 111, 110, 101, 32, 111, 102, 32, 40, 32, 0, 0, 32, 69, 120, 112, 101, 99, 116, 101, 100, 32, 105, 115, 32, 40, 32, 0, 35, 35, 111, 116, 104, 101, 114, 0, 123, 42, 125, 0, 0, 0, 0, 0, 123, 35, 35, 111, 116, 104, 101, 114, 58, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, 0, 0, 0, 0, 0, 125, 0, 0, 0, 0, 0, 0, 0, 44, 32, 0, 0, 0, 0, 0, 0, 32, 41, 46, 10, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 39, 0, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 0, 0, 0, 0, 0, 39, 58, 32, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 83, 65, 88, 72, 97, 110, 100, 108, 101, 83, 116, 97, 114, 116, 69, 108, 101, 109, 101, 110, 116, 78, 115, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 111, 114, 80, 117, 115, 104, 69, 108, 101, 109, 40, 41, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 98, 105, 110, 100, 105, 110, 103, 115, 32, 102, 111, 114, 32, 83, 65, 88, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 98, 105, 110, 100, 105, 110, 103, 115, 32, 102, 111, 114, 32, 83, 65, 88, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 111, 114, 80, 117, 115, 104, 65, 116, 116, 114, 105, 98, 117, 116, 101, 40, 41, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 69, 108, 101, 109, 40, 41, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 69, 108, 101, 109, 0, 0, 0, 105, 110, 32, 115, 107, 105, 112, 45, 115, 116, 97, 116, 101, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 83, 116, 114, 101, 97, 109, 86, 97, 108, 105, 100, 97, 116, 101, 67, 104, 105, 108, 100, 69, 108, 101, 109, 101, 110, 116, 40, 41, 0, 0, 0, 116, 104, 101, 32, 99, 104, 105, 108, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 119, 97, 115, 32, 118, 97, 108, 105, 100, 32, 98, 117, 116, 32, 110, 101, 105, 116, 104, 101, 114, 32, 116, 104, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 110, 111, 114, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 119, 97, 115, 32, 115, 101, 116, 0, 0, 0, 0, 78, 111, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 103, 108, 111, 98, 97, 108, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 32, 102, 111, 114, 32, 116, 104, 101, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 114, 111, 111, 116, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 69, 108, 101, 109, 87, 105, 108, 100, 99, 97, 114, 100, 40, 41, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 69, 108, 101, 109, 68, 101, 99, 108, 40, 41, 0, 0, 0, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 97, 98, 115, 101, 110, 116, 0, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 97, 98, 115, 116, 114, 97, 99, 116, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 88, 80, 97, 116, 104, 69, 118, 97, 108, 117, 97, 116, 101, 40, 41, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 46, 10, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 65, 116, 116, 114, 105, 98, 117, 116, 101, 115, 67, 111, 109, 112, 108, 101, 120, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 71, 101, 116, 70, 114, 101, 115, 104, 65, 116, 116, 114, 73, 110, 102, 111, 40, 41, 0, 0, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 47, 102, 105, 120, 101, 100, 32, 118, 97, 108, 117, 101, 32, 111, 110, 32, 97, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 119, 97, 115, 32, 110, 111, 116, 32, 112, 114, 101, 99, 111, 109, 112, 117, 116, 101, 100, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 111, 112, 121, 86, 97, 108, 117, 101, 40, 41, 0, 0, 0, 0, 99, 97, 108, 108, 108, 105, 110, 103, 32, 120, 109, 108, 78, 101, 119, 80, 114, 111, 112, 40, 41, 0, 0, 0, 112, 37, 100, 0, 0, 0, 0, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 99, 111, 109, 112, 117, 116, 101, 32, 97, 32, 110, 115, 32, 112, 114, 101, 102, 105, 120, 32, 102, 111, 114, 32, 97, 32, 100, 101, 102, 97, 117, 108, 116, 47, 102, 105, 120, 101, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 83, 116, 114, 101, 97, 109, 86, 97, 108, 105, 100, 97, 116, 101, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 86, 97, 108, 117, 101, 40, 41, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 98, 117, 116, 32, 109, 105, 115, 115, 105, 110, 103, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 102, 105, 120, 101, 100, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 39, 37, 115, 39, 0, 0, 0, 78, 111, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 103, 108, 111, 98, 97, 108, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 44, 32, 98, 117, 116, 32, 100, 101, 109, 97, 110, 100, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 116, 114, 105, 99, 116, 32, 119, 105, 108, 100, 99, 97, 114, 100, 0, 35, 35, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 105, 110, 102, 111, 32, 108, 105, 115, 116, 0, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 105, 110, 102, 111, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 71, 101, 116, 70, 114, 101, 115, 104, 65, 116, 116, 114, 73, 110, 102, 111, 0, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 32, 105, 110, 102, 111, 32, 110, 111, 116, 32, 99, 108, 101, 97, 114, 101, 100, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 110, 101, 119, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 105, 110, 102, 111, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 88, 80, 97, 116, 104, 69, 118, 97, 108, 117, 97, 116, 101, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 116, 114, 101, 97, 109, 80, 117, 115, 104, 40, 41, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 32, 104, 105, 115, 116, 111, 114, 121, 0, 0, 0, 0, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 32, 104, 105, 115, 116, 111, 114, 121, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 73, 68, 67, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 73, 68, 67, 65, 100, 100, 83, 116, 97, 116, 101, 79, 98, 106, 101, 99, 116, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 97, 110, 32, 88, 80, 97, 116, 104, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 78, 111, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 115, 32, 97, 98, 115, 116, 114, 97, 99, 116, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 136048);
	        allocate([101, 69, 108, 101, 109, 68, 101, 99, 108, 0, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 67, 104, 101, 99, 107, 67, 86, 67, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 40, 41, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 120, 115, 105, 58, 110, 105, 108, 39, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 39, 110, 105, 108, 108, 97, 98, 108, 101, 39, 0, 0, 0, 84, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 39, 110, 105, 108, 108, 101, 100, 39, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 114, 101, 32, 105, 115, 32, 97, 32, 102, 105, 120, 101, 100, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 100, 101, 102, 105, 110, 101, 100, 32, 102, 111, 114, 32, 105, 116, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 114, 111, 99, 101, 115, 115, 88, 83, 73, 84, 121, 112, 101, 40, 41, 32, 116, 111, 32, 112, 114, 111, 99, 101, 115, 115, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 120, 115, 105, 58, 116, 121, 112, 101, 39, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 73, 68, 67, 82, 101, 103, 105, 115, 116, 101, 114, 77, 97, 116, 99, 104, 101, 114, 115, 0, 0, 0, 0, 84, 104, 101, 32, 99, 104, 97, 105, 110, 32, 111, 102, 32, 73, 68, 67, 32, 109, 97, 116, 99, 104, 101, 114, 115, 32, 105, 115, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 116, 111, 32, 98, 101, 32, 101, 109, 112, 116, 121, 0, 0, 0, 0, 0, 0, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 97, 110, 32, 97, 117, 103, 109, 101, 110, 116, 101, 100, 32, 73, 68, 67, 32, 105, 116, 101, 109, 32, 102, 111, 114, 32, 97, 110, 32, 73, 68, 67, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 73, 68, 67, 32, 109, 97, 116, 99, 104, 101, 114, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 69, 108, 101, 109, 101, 110, 116, 66, 121, 68, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 81, 78, 97, 109, 101, 69, 120, 112, 97, 110, 100, 40, 41, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 120, 115, 105, 58, 116, 121, 112, 101, 39, 0, 0, 0, 0, 0, 84, 104, 101, 32, 81, 78, 97, 109, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 120, 115, 105, 58, 116, 121, 112, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 116, 111, 32, 97, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 44, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 120, 115, 105, 58, 116, 121, 112, 101, 44, 32, 105, 115, 32, 98, 108, 111, 99, 107, 101, 100, 32, 111, 114, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 108, 121, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 84, 121, 112, 101, 70, 105, 120, 117, 112, 0, 0, 0, 0, 0, 0, 116, 104, 105, 115, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 101, 100, 115, 32, 97, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 70, 105, 120, 117, 112, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 83, 116, 97, 103, 101, 84, 119, 111, 0, 0, 0, 0, 0, 0, 0, 0, 109, 105, 115, 115, 105, 110, 103, 32, 98, 97, 115, 101, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 73, 116, 32, 105, 115, 32, 97, 110, 32, 101, 114, 114, 111, 114, 32, 102, 111, 114, 32, 98, 111, 116, 104, 32, 39, 108, 101, 110, 103, 116, 104, 39, 32, 97, 110, 100, 32, 101, 105, 116, 104, 101, 114, 32, 111, 102, 32, 39, 109, 105, 110, 76, 101, 110, 103, 116, 104, 39, 32, 111, 114, 32, 39, 109, 97, 120, 76, 101, 110, 103, 116, 104, 39, 32, 116, 111, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 111, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 73, 116, 32, 105, 115, 32, 97, 110, 32, 101, 114, 114, 111, 114, 32, 102, 111, 114, 32, 98, 111, 116, 104, 32, 39, 37, 115, 39, 32, 97, 110, 100, 32, 39, 37, 115, 39, 32, 116, 111, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 111, 110, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 39, 115, 32, 102, 97, 99, 101, 116, 32, 105, 115, 32, 39, 102, 105, 120, 101, 100, 39, 44, 32, 116, 104, 117, 115, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 100, 105, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 39, 119, 104, 105, 116, 101, 115, 112, 97, 99, 101, 39, 32, 118, 97, 108, 117, 101, 32, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 111, 114, 32, 115, 116, 114, 111, 110, 103, 101, 114, 32, 116, 104, 97, 110, 32, 116, 104, 101, 32, 39, 119, 104, 105, 116, 101, 115, 112, 97, 99, 101, 39, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 100, 101, 114, 105, 118, 105, 110, 103, 32, 102, 97, 99, 101, 116, 115, 44, 32, 99, 114, 101, 97, 116, 105, 110, 103, 32, 97, 32, 102, 97, 99, 101, 116, 32, 108, 105, 110, 107, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 68, 101, 114, 105, 118, 101, 65, 110, 100, 86, 97, 108, 105, 100, 97, 116, 101, 70, 97, 99, 101, 116, 115, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 32, 101, 114, 114, 111, 114, 32, 111, 99, 99, 117, 114, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 39, 32, 104, 97, 115, 32, 116, 111, 32, 98, 101, 0, 0, 0, 0, 0, 32, 101, 113, 117, 97, 108, 32, 116, 111, 0, 0, 0, 0, 0, 0, 0, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 0, 0, 0, 32, 108, 101, 115, 115, 32, 116, 104, 97, 110, 0, 0, 0, 0, 0, 0, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 0, 0, 0, 0, 39, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 37, 115, 58, 32, 0, 0, 0, 0, 97, 116, 111, 109, 105, 99, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 0, 0, 0, 0, 0, 0, 0, 0, 108, 105, 115, 116, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 0, 0, 117, 110, 105, 111, 110, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 0, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 0, 0, 0, 0, 0, 0, 0, 0, 108, 111, 99, 97, 108, 32, 0, 0, 97, 116, 111, 109, 105, 99, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 108, 105, 115, 116, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 117, 110, 105, 111, 110, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 0, 0, 40, 117, 110, 107, 110, 111, 119, 110, 41, 0, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 46, 0, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 46, 0, 0, 0, 117, 110, 105, 113, 117, 101, 32, 39, 0, 0, 0, 0, 0, 0, 0, 0, 107, 101, 121, 32, 39, 0, 0, 0, 107, 101, 121, 82, 101, 102, 32, 39, 0, 0, 0, 0, 0, 0, 0, 0, 32, 119, 105, 108, 100, 99, 97, 114, 100, 0, 0, 0, 0, 0, 0, 0, 102, 97, 99, 101, 116, 32, 39, 0, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 46, 0, 0, 0, 0, 0, 0, 0, 0, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 0, 0, 0, 115, 107, 105, 112, 0, 0, 0, 0, 108, 97, 120, 0, 0, 0, 0, 0, 115, 116, 114, 105, 99, 116, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 112, 114, 111, 99, 101, 115, 115, 32, 99, 111, 110, 116, 101, 110, 116, 115, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 114, 101, 97, 116, 101, 86, 67, 116, 120, 116, 79, 110, 80, 67, 116, 120, 116, 44, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 97, 32, 116, 101, 109, 112, 46, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 46, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 67, 79, 83, 83, 84, 82, 101, 115, 116, 114, 105, 99, 116, 115, 0, 0, 0, 0, 103, 105, 118, 101, 110, 32, 116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 117, 115, 101, 114, 45, 100, 101, 114, 105, 118, 101, 100, 32, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 0, 0, 0, 0, 0, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 97, 116, 111, 109, 105, 99, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 84, 104, 101, 32, 102, 105, 110, 97, 108, 32, 111, 102, 32, 105, 116, 115, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 39, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 39, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 103, 101, 116, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 104, 101, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 104, 97, 118, 101, 32, 97, 32, 118, 97, 114, 105, 101, 116, 121, 32, 111, 102, 32, 97, 116, 111, 109, 105, 99, 32, 111, 114, 32, 117, 110, 105, 111, 110, 0, 0, 0, 84, 104, 101, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 105, 115, 32, 97, 32, 117, 110, 105, 111, 110, 32, 116, 121, 112, 101, 44, 32, 98, 117, 116, 32, 116, 104, 101, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 105, 115, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 116, 111, 109, 105, 99, 0, 84, 104, 101, 32, 102, 105, 110, 97, 108, 32, 111, 102, 32, 105, 116, 115, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 39, 108, 105, 115, 116, 39, 0, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 108, 105, 115, 116, 32, 116, 121, 112, 101, 0, 0, 84, 104, 101, 32, 39, 102, 105, 110, 97, 108, 39, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 39, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 39, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 101, 118, 97, 108, 32, 116, 104, 101, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 111, 102, 32, 97, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 84, 104, 101, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 108, 121, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 105, 116, 101, 109, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 0, 84, 104, 101, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 101, 105, 116, 104, 101, 114, 32, 97, 110, 32, 97, 116, 111, 109, 105, 99, 44, 32, 110, 111, 114, 32, 97, 32, 108, 105, 115, 116, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 39, 102, 105, 110, 97, 108, 39, 32, 111, 102, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 39, 117, 110, 105, 111, 110, 39, 0, 0, 0, 0, 0, 0, 0, 0, 78, 111, 32, 102, 97, 99, 101, 116, 115, 32, 97, 108, 108, 111, 119, 101, 100, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 117, 110, 105, 111, 110, 32, 116, 121, 112, 101, 0, 0, 84, 104, 101, 32, 39, 102, 105, 110, 97, 108, 39, 32, 111, 102, 32, 105, 116, 115, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 39, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 39, 0, 0, 0, 0, 0, 0, 0, 0, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 115, 32, 105, 110, 32, 98, 97, 115, 101, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 108, 121, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 105, 116, 115, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 32, 37, 115, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 37, 115, 0, 0, 0, 0, 0, 37, 115, 58, 32, 84, 104, 101, 32, 102, 97, 99, 101, 116, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 46, 10, 0, 0, 0, 0, 0, 37, 115, 58, 32, 84, 104, 101, 32, 102, 97, 99, 101, 116, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 111, 110, 32, 116, 121, 112, 101, 115, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 37, 115, 46, 10, 0, 0, 0, 78, 111, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 101, 120, 105, 115, 116, 101, 110, 116, 0, 0, 0, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 65, 32, 116, 121, 112, 101, 44, 32, 100, 101, 114, 105, 118, 101, 100, 32, 98, 121, 32, 108, 105, 115, 116, 32, 111, 114, 32, 117, 110, 105, 111, 110, 44, 32, 109, 117, 115, 116, 32, 104, 97, 118, 101, 32, 116, 104, 101, 32, 115, 105, 109, 112, 108, 101, 32, 117, 114, 45, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 97, 115, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 44, 32, 110, 111, 116, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 114, 105, 101, 116, 121, 32, 105, 115, 32, 97, 98, 115, 101, 110, 116, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 116, 121, 112, 101, 32, 108, 105, 110, 107, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 70, 105, 120, 117, 112, 67, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 84, 121, 112, 101, 70, 105, 120, 117, 112, 44, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 58, 32, 116, 104, 101, 32, 60, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 62, 60, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 62, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 32, 97, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 44, 32, 98, 117, 116, 32, 119, 97, 115, 32, 110, 111, 116, 32, 99, 97, 116, 99, 104, 101, 100, 32, 98, 121, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 83, 82, 67, 67, 84, 40, 41, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 84, 121, 112, 101, 70, 105, 120, 117, 112, 44, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 58, 32, 116, 104, 101, 32, 60, 101, 120, 116, 101, 110, 115, 105, 111, 110, 62, 101, 100, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 105, 115, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 119, 105, 116, 104, 32, 110, 111, 32, 115, 105, 109, 112, 108, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 84, 121, 112, 101, 70, 105, 120, 117, 112, 44, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 119, 105, 116, 104, 32, 60, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 62, 58, 32, 117, 110, 104, 97, 110, 100, 108, 101, 100, 32, 100, 101, 114, 105, 118, 97, 116, 105, 111, 110, 32, 99, 97, 115, 101, 0, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 104, 97, 115, 32, 97, 110, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 105, 110, 32, 105, 116, 115, 32, 123, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 125, 32, 97, 110, 100, 32, 116, 104, 117, 115, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 97, 32, 110, 111, 110, 45, 101, 109, 112, 116, 121, 32, 116, 121, 112, 101, 44, 32, 115, 105, 110, 99, 101, 32, 116, 104, 105, 115, 32, 119, 111, 117, 108, 100, 32, 112, 114, 111, 100, 117, 99, 101, 32, 97, 32, 39, 115, 101, 113, 117, 101, 110, 99, 101, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 99, 111, 110, 116, 97, 105, 110, 105, 110, 103, 32, 116, 104, 101, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 59, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 115, 32, 97, 114, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 97, 112, 112, 101, 97, 114, 32, 105, 110, 115, 105, 100, 101, 32, 111, 116, 104, 101, 114, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 115, 0, 0, 0, 0, 65, 32, 116, 121, 112, 101, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 100, 101, 114, 105, 118, 101, 100, 32, 98, 121, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 102, 114, 111, 109, 32, 97, 32, 116, 121, 112, 101, 32, 119, 104, 105, 99, 104, 32, 104, 97, 115, 32, 97, 110, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 105, 110, 32, 105, 116, 115, 32, 123, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 125, 44, 32, 115, 105, 110, 99, 101, 32, 116, 104, 105, 115, 32, 119, 111, 117, 108, 100, 32, 112, 114, 111, 100, 117, 99, 101, 32, 97, 32, 39, 115, 101, 113, 117, 101, 110, 99, 101, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 99, 111, 110, 116, 97, 105, 110, 105, 110, 103, 32, 116, 104, 101, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 59, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 115, 32, 97, 114, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 97, 112, 112, 101, 97, 114, 32, 105, 110, 115, 105, 100, 101, 32, 111, 116, 104, 101, 114, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 115, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 0, 0, 0, 0, 84, 104, 101, 32, 39, 102, 105, 110, 97, 108, 39, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 39, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 39, 0, 0, 84, 104, 101, 32, 123, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 125, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 108, 121, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 39, 115, 32, 123, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 125, 32, 37, 115, 0, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 101, 105, 116, 104, 101, 114, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 111, 114, 32, 39, 109, 105, 120, 101, 100, 39, 32, 97, 110, 100, 32, 97, 110, 32, 101, 109, 112, 116, 105, 97, 98, 108, 101, 32, 112, 97, 114, 116, 105, 99, 108, 101, 0, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 101, 105, 116, 104, 101, 114, 32, 101, 109, 112, 116, 121, 32, 111, 114, 32, 39, 109, 105, 120, 101, 100, 39, 32, 40, 111, 114, 32, 39, 101, 108, 101, 109, 101, 110, 116, 115, 45, 111, 110, 108, 121, 39, 41, 32, 97, 110, 100, 32, 97, 110, 32, 101, 109, 112, 116, 105, 97, 98, 108, 101, 32, 112, 97, 114, 116, 105, 99, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 73, 102, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 105, 115, 32, 39, 109, 105, 120, 101, 100, 39, 44, 32, 116, 104, 101, 110, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 97, 108, 115, 111, 32, 98, 101, 32, 39, 109, 105, 120, 101, 100, 39, 0, 0, 0, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 32, 111, 102, 32, 105, 116, 115, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 84, 104, 101, 32, 39, 111, 112, 116, 105, 111, 110, 97, 108, 39, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 105, 115, 32, 105, 110, 99, 111, 110, 115, 105, 115, 116, 101, 110, 116, 32, 119, 105, 116, 104, 32, 116, 104, 101, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 39, 114, 101, 113, 117, 105, 114, 101, 100, 39, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 0, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 114, 101, 100, 101, 102, 105, 110, 101, 100, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 39, 115, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 108, 121, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 37, 115, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 110, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 101, 102, 102, 101, 99, 116, 105, 118, 101, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 105, 115, 32, 105, 110, 99, 111, 110, 115, 105, 115, 116, 101, 110, 116, 32, 119, 105, 116, 104, 32, 105, 116, 115, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 101, 110, 116, 32, 105, 110, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 0, 78, 101, 105, 116, 104, 101, 114, 32, 97, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 44, 32, 110, 111, 114, 32, 97, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 101, 120, 105, 115, 116, 115, 32, 105, 110, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 0, 0, 0, 65, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 102, 111, 114, 32, 116, 104, 101, 32, 39, 114, 101, 113, 117, 105, 114, 101, 100, 39, 32, 37, 115, 32, 111, 102, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 0, 0, 84, 104, 101, 32, 37, 115, 32, 104, 97, 115, 32, 97, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 108, 100, 99, 97, 114, 100, 44, 32, 98, 117, 116, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 104, 97, 118, 101, 32, 111, 110, 101, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 115, 117, 98, 115, 101, 116, 32, 111, 102, 32, 116, 104, 101, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 105, 110, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 32, 39, 37, 115, 39, 0, 0, 84, 104, 101, 32, 123, 112, 114, 111, 99, 101, 115, 115, 32, 99, 111, 110, 116, 101, 110, 116, 115, 125, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 105, 115, 32, 119, 101, 97, 107, 101, 114, 32, 116, 104, 97, 110, 32, 116, 104, 101, 32, 111, 110, 101, 32, 105, 110, 32, 116, 104, 101, 32, 37, 115, 32, 37, 115, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 58, 32, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 39, 102, 105, 110, 97, 108, 39, 32, 111, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 39, 101, 120, 116, 101, 110, 115, 105, 111, 110, 39, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 115, 112, 101, 99, 105, 102, 121, 32, 97, 32, 112, 97, 114, 116, 105, 99, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 111, 102, 32, 98, 111, 116, 104, 44, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 97, 110, 100, 32, 105, 116, 115, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 44, 32, 109, 117, 115, 116, 32, 101, 105, 116, 104, 101, 114, 32, 39, 109, 105, 120, 101, 100, 39, 32, 111, 114, 32, 39, 101, 108, 101, 109, 101, 110, 116, 45, 111, 110, 108, 121, 39, 0, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 116, 104, 101, 32, 115, 105, 109, 112, 108, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 73, 102, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 105, 115, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 44, 32, 116, 104, 101, 32, 100, 101, 114, 105, 118, 97, 116, 105, 111, 110, 32, 109, 101, 116, 104, 111, 100, 32, 109, 117, 115, 116, 32, 98, 101, 32, 39, 101, 120, 116, 101, 110, 115, 105, 111, 110, 39, 0, 0, 0, 0, 68, 117, 112, 108, 105, 99, 97, 116, 101, 32, 37, 115, 0, 0, 0, 0, 84, 104, 101, 114, 101, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 101, 120, 105, 115, 116, 32, 109, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 111, 102, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 73, 68, 39, 32, 40, 111, 114, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 39, 120, 115, 58, 73, 68, 39, 41, 46, 32, 84, 104, 101, 32, 37, 115, 32, 118, 105, 111, 108, 97, 116, 101, 115, 32, 116, 104, 105, 115, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 73, 116, 101, 109, 76, 105, 115, 116, 82, 101, 109, 111, 118, 101, 44, 32, 105, 110, 100, 101, 120, 32, 101, 114, 114, 111, 114, 46, 10, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 70, 105, 120, 117, 112, 84, 121, 112, 101, 65, 116, 116, 114, 105, 98, 117, 116, 101, 85, 115, 101, 115, 0, 110, 111, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 101, 120, 112, 97, 110, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 0, 0, 0, 0, 0, 84, 104, 101, 32, 117, 110, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 119, 105, 108, 99, 97, 114, 100, 32, 105, 115, 32, 110, 111, 116, 32, 101, 120, 112, 114, 101, 115, 115, 105, 98, 108, 101, 46, 10, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 69, 120, 112, 97, 110, 100, 65, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 82, 101, 102, 115, 0, 0, 0, 0, 0, 0, 0, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 97, 116, 116, 114, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 32, 102, 111, 117, 110, 100, 0, 0, 0, 0, 0, 0, 0, 83, 107, 105, 112, 112, 105, 110, 103, 32, 112, 111, 105, 110, 116, 108, 101, 115, 115, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 44, 32, 115, 105, 110, 99, 101, 32, 97, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 101, 120, 105, 115, 116, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 110, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 84, 104, 101, 32, 105, 110, 116, 101, 114, 115, 101, 99, 116, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 119, 105, 108, 99, 97, 114, 100, 32, 105, 115, 32, 110, 111, 116, 32, 101, 120, 112, 114, 101, 115, 115, 105, 98, 108, 101, 46, 10, 0, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 119, 105, 108, 100, 99, 97, 114, 100, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 112, 97, 114, 116, 105, 99, 108, 101, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 70, 105, 120, 117, 112, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 83, 116, 97, 103, 101, 79, 110, 101, 0, 0, 0, 0, 0, 0, 0, 0, 108, 105, 115, 116, 32, 116, 121, 112, 101, 32, 104, 97, 115, 32, 110, 111, 32, 105, 116, 101, 109, 45, 116, 121, 112, 101, 32, 97, 115, 115, 105, 103, 110, 101, 100, 0, 0, 0, 0, 0, 117, 110, 105, 111, 110, 32, 116, 121, 112, 101, 32, 104, 97, 115, 32, 110, 111, 32, 109, 101, 109, 98, 101, 114, 45, 116, 121, 112, 101, 115, 32, 97, 115, 115, 105, 103, 110, 101, 100, 0, 116, 121, 112, 101, 32, 104, 97, 115, 32, 110, 111, 32, 98, 97, 115, 101, 45, 116, 121, 112, 101, 32, 97, 115, 115, 105, 103, 110, 101, 100, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 121, 112, 101, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 110, 102, 111, 0, 0, 0, 0, 73, 102, 32, 117, 115, 105, 110, 103, 32, 60, 99, 111, 109, 112, 108, 101, 120, 67, 111, 110, 116, 101, 110, 116, 62, 44, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 105, 115, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 116, 111, 32, 98, 101, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 46, 32, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 73, 102, 32, 117, 115, 105, 110, 103, 32, 60, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 62, 32, 97, 110, 100, 32, 60, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 62, 44, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 46, 32, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 83, 82, 67, 67, 84, 44, 32, 39, 37, 115, 39, 44, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 65, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 105, 115, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 97, 109, 111, 110, 103, 32, 116, 104, 101, 32, 99, 104, 105, 108, 100, 114, 101, 110, 32, 111, 102, 32, 60, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 62, 44, 32, 105, 102, 32, 60, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 62, 32, 105, 115, 32, 117, 115, 101, 100, 32, 97, 110, 100, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 73, 102, 32, 60, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 62, 32, 97, 110, 100, 32, 60, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 62, 32, 105, 115, 32, 117, 115, 101, 100, 44, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 111, 114, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 119, 105, 116, 104, 32, 109, 105, 120, 101, 100, 32, 99, 111, 110, 116, 101, 110, 116, 32, 97, 110, 100, 32, 112, 97, 114, 116, 105, 99, 108, 101, 32, 101, 109, 112, 116, 105, 97, 98, 108, 101, 46, 32, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 110, 101, 32, 111, 102, 32, 116, 104, 111, 115, 101, 0, 0, 0, 0, 0, 0, 73, 102, 32, 60, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 62, 32, 97, 110, 100, 32, 60, 101, 120, 116, 101, 110, 115, 105, 111, 110, 62, 32, 105, 115, 32, 117, 115, 101, 100, 44, 32, 116, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 46, 32, 84, 104, 101, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 0, 0, 0, 184, 44, 2, 0, 0, 0, 0, 0, 84, 104, 101, 32, 81, 78, 97, 109, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 110, 32, 115, 99, 111, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 76, 111, 111, 107, 117, 112, 78, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 32, 110, 111, 100, 101, 32, 111, 114, 32, 110, 111, 100, 101, 39, 115, 32, 100, 111, 99, 32, 97, 118, 97, 108, 105, 97, 98, 108, 101, 0, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 0, 0, 0, 84, 104, 101, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 0, 0, 116, 104, 101, 32, 108, 111, 99, 97, 108, 32, 0, 0, 0, 0, 0, 0, 116, 104, 101, 32, 0, 0, 0, 0, 120, 115, 58, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 69, 108, 101, 109, 87, 105, 108, 100, 99, 97, 114, 100, 0, 0, 0, 98, 97, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 0, 0, 0, 78, 111, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 103, 108, 111, 98, 97, 108, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 44, 32, 98, 117, 116, 32, 100, 101, 109, 97, 110, 100, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 116, 114, 105, 99, 116, 32, 119, 105, 108, 100, 99, 97, 114, 100, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 114, 111, 99, 101, 115, 115, 88, 83, 73, 84, 121, 112, 101, 40, 41, 32, 116, 111, 32, 112, 114, 111, 99, 101, 115, 115, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 120, 115, 105, 58, 110, 105, 108, 39, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 67, 104, 105, 108, 100, 69, 108, 101, 109, 0, 0, 0, 0, 0, 0, 110, 111, 116, 32, 105, 110, 116, 101, 110, 100, 101, 100, 32, 102, 111, 114, 32, 116, 104, 101, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 114, 111, 111, 116, 0, 0, 0, 0, 78, 101, 105, 116, 104, 101, 114, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 110, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 119, 97, 115, 32, 39, 110, 105, 108, 108, 101, 100, 39, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 105, 115, 32, 101, 109, 112, 116, 121, 0, 0, 0, 0, 0, 0, 0, 116, 121, 112, 101, 32, 104, 97, 115, 32, 101, 108, 101, 109, 32, 99, 111, 110, 116, 101, 110, 116, 32, 98, 117, 116, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 0, 0, 0, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 101, 108, 101, 109, 44, 32, 98, 117, 116, 32, 101, 108, 101, 109, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 110, 118, 97, 108, 105, 100, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 82, 101, 103, 69, 120, 101, 99, 80, 117, 115, 104, 83, 116, 114, 105, 110, 103, 50, 40, 41, 0, 84, 104, 105, 115, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 105, 115, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 98, 101, 99, 97, 117, 115, 101, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 115, 105, 109, 112, 108, 101, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 109, 117, 115, 116, 32, 99, 111, 110, 115, 105, 115, 116, 32, 111, 102, 32, 116, 117, 112, 108, 101, 115, 58, 32, 116, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 97, 109, 101, 32, 97, 110, 100, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 39, 115, 32, 85, 82, 73, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 65, 115, 115, 101, 109, 98, 108, 101, 66, 121, 88, 83, 73, 0, 0, 97, 115, 115, 101, 109, 98, 108, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 116, 97, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 65, 115, 115, 101, 109, 98, 108, 101, 66, 121, 76, 111, 99, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 110, 111, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 0, 0, 0, 0, 110, 111, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 0, 0, 84, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 97, 116, 32, 108, 111, 99, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 97, 99, 113, 117, 105, 114, 101, 100, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 117, 115, 104, 65, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 110, 105, 108, 0, 0, 0, 0, 0, 152, 95, 2, 0, 0, 0, 0, 0, 116, 121, 112, 101, 0, 0, 0, 0, 115, 99, 104, 101, 109, 97, 76, 111, 99, 97, 116, 105, 111, 110, 0, 0, 110, 111, 78, 97, 109, 101, 115, 112, 97, 99, 101, 83, 99, 104, 101, 109, 97, 76, 111, 99, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 120, 95, 2, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 48, 47, 120, 109, 108, 110, 115, 47, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 77, 76, 83, 99, 104, 101, 109, 97, 45, 105, 110, 115, 116, 97, 110, 99, 101, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 111, 114, 80, 117, 115, 104, 69, 108, 101, 109, 0, 0, 0, 0, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 71, 101, 116, 70, 114, 101, 115, 104, 69, 108, 101, 109, 73, 110, 102, 111, 40, 41, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 71, 101, 116, 70, 114, 101, 115, 104, 69, 108, 101, 109, 73, 110, 102, 111, 0, 0, 0, 0, 0, 0, 0, 105, 110, 99, 111, 110, 115, 105, 115, 116, 101, 110, 116, 32, 100, 101, 112, 116, 104, 32, 101, 110, 99, 111, 117, 110, 116, 101, 114, 101, 100, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 110, 102, 111, 32, 97, 114, 114, 97, 121, 0, 0, 0, 0, 0, 0, 0, 114, 101, 45, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 110, 102, 111, 32, 97, 114, 114, 97, 121, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 110, 102, 111, 0, 0, 0, 0, 0, 0, 101, 108, 101, 109, 32, 105, 110, 102, 111, 32, 104, 97, 115, 32, 110, 111, 116, 32, 98, 101, 101, 110, 32, 99, 108, 101, 97, 114, 101, 100, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 83, 116, 97, 114, 116, 0, 110, 111, 32, 105, 110, 115, 116, 97, 110, 99, 101, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 68, 111, 99, 87, 97, 108, 107, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 68, 111, 99, 87, 97, 108, 107, 0, 0, 0, 0, 0, 0, 0, 116, 104, 101, 114, 101, 32, 105, 115, 32, 97, 116, 32, 108, 101, 97, 115, 116, 32, 111, 110, 101, 32, 101, 110, 116, 105, 116, 121, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 105, 110, 32, 116, 104, 101, 32, 110, 111, 100, 101, 45, 116, 114, 101, 101, 32, 99, 117, 114, 114, 101, 110, 116, 108, 121, 32, 98, 101, 105, 110, 103, 32, 118, 97, 108, 105, 100, 97, 116, 101, 100, 46, 32, 80, 114, 111, 99, 101, 115, 115, 105, 110, 103, 32, 111, 102, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 119, 105, 116, 104, 32, 116, 104, 105, 115, 32, 88, 77, 76, 32, 83, 99, 104, 101, 109, 97, 32, 112, 114, 111, 99, 101, 115, 115, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 40, 121, 101, 116, 41, 46, 32, 80, 108, 101, 97, 115, 101, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 101, 32, 101, 110, 116, 105, 116, 105, 101, 115, 32, 98, 101, 102, 111, 114, 101, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 46, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 109, 105, 115, 109, 97, 116, 99, 104, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 105, 116, 101, 109, 32, 108, 105, 115, 116, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 67, 104, 101, 99, 107, 67, 86, 67, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 0, 0, 0, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 103, 101, 116, 32, 116, 104, 101, 32, 98, 117, 105, 108, 116, 45, 105, 110, 32, 116, 121, 112, 101, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 32, 98, 117, 105, 108, 116, 45, 105, 110, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 102, 97, 99, 101, 116, 115, 32, 111, 102, 32, 97, 116, 111, 109, 105, 99, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 110, 32, 105, 116, 101, 109, 32, 111, 102, 32, 108, 105, 115, 116, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 102, 97, 99, 101, 116, 115, 32, 111, 102, 32, 108, 105, 115, 116, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 0, 117, 110, 105, 111, 110, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 104, 97, 115, 32, 110, 111, 32, 109, 101, 109, 98, 101, 114, 32, 116, 121, 112, 101, 115, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 109, 101, 109, 98, 101, 114, 115, 32, 111, 102, 32, 117, 110, 105, 111, 110, 32, 115, 105, 109, 112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 146288);
	        allocate([108, 101, 32, 116, 121, 112, 101, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 102, 97, 99, 101, 116, 115, 32, 111, 102, 32, 117, 110, 105, 111, 110, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 70, 97, 99, 101, 116, 115, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 32, 97, 116, 111, 109, 105, 99, 32, 116, 121, 112, 101, 32, 102, 97, 99, 101, 116, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 32, 108, 105, 115, 116, 32, 116, 121, 112, 101, 32, 102, 97, 99, 101, 116, 0, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 110, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 32, 102, 97, 99, 101, 116, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 97, 103, 97, 105, 110, 115, 116, 32, 97, 32, 112, 97, 116, 116, 101, 114, 110, 32, 102, 97, 99, 101, 116, 0, 0, 0, 0, 0, 0, 39, 93, 32, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 97, 32, 108, 101, 110, 103, 116, 104, 32, 111, 102, 32, 39, 37, 115, 39, 59, 32, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 104, 97, 115, 32, 97, 32, 108, 101, 110, 103, 116, 104, 32, 111, 102, 32, 39, 37, 115, 39, 59, 32, 0, 0, 0, 0, 0, 0, 0, 0, 37, 108, 117, 0, 0, 0, 0, 0, 116, 104, 105, 115, 32, 100, 105, 102, 102, 101, 114, 115, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 108, 101, 110, 103, 116, 104, 32, 111, 102, 32, 39, 37, 115, 39, 46, 10, 0, 0, 116, 104, 105, 115, 32, 101, 120, 99, 101, 101, 100, 115, 32, 116, 104, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 109, 97, 120, 105, 109, 117, 109, 32, 108, 101, 110, 103, 116, 104, 32, 111, 102, 32, 39, 37, 115, 39, 46, 10, 0, 0, 0, 0, 0, 0, 0, 116, 104, 105, 115, 32, 117, 110, 100, 101, 114, 114, 117, 110, 115, 32, 116, 104, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 109, 105, 110, 105, 109, 117, 109, 32, 108, 101, 110, 103, 116, 104, 32, 111, 102, 32, 39, 37, 115, 39, 46, 10, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 111, 102, 32, 116, 104, 101, 32, 115, 101, 116, 32, 123, 37, 115, 125, 46, 10, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 99, 99, 101, 112, 116, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 112, 97, 116, 116, 101, 114, 110, 32, 39, 37, 115, 39, 46, 10, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 108, 101, 115, 115, 32, 116, 104, 97, 110, 32, 116, 104, 101, 32, 109, 105, 110, 105, 109, 117, 109, 32, 118, 97, 108, 117, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 40, 39, 37, 115, 39, 41, 46, 10, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 118, 97, 108, 117, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 40, 39, 37, 115, 39, 41, 46, 10, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 98, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 39, 37, 115, 39, 46, 10, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 98, 101, 32, 108, 101, 115, 115, 32, 116, 104, 97, 110, 32, 39, 37, 115, 39, 46, 10, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 109, 111, 114, 101, 32, 100, 105, 103, 105, 116, 115, 32, 116, 104, 97, 110, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 40, 39, 37, 115, 39, 41, 46, 10, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 109, 111, 114, 101, 32, 102, 114, 97, 99, 116, 105, 111, 110, 97, 108, 32, 100, 105, 103, 105, 116, 115, 32, 116, 104, 97, 110, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 40, 39, 37, 115, 39, 41, 46, 10, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 102, 97, 99, 101, 116, 45, 118, 97, 108, 105, 100, 46, 10, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 105, 115, 32, 110, 111, 116, 32, 102, 97, 99, 101, 116, 45, 118, 97, 108, 105, 100, 46, 10, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 70, 111, 114, 109, 97, 116, 70, 97, 99, 101, 116, 69, 110, 117, 109, 83, 101, 116, 0, 0, 0, 0, 0, 99, 111, 109, 112, 117, 116, 101, 32, 116, 104, 101, 32, 99, 97, 110, 111, 110, 105, 99, 97, 108, 32, 108, 101, 120, 105, 99, 97, 108, 32, 114, 101, 112, 114, 101, 115, 101, 110, 116, 97, 116, 105, 111, 110, 0, 0, 0, 0, 44, 32, 39, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 81, 78, 97, 109, 101, 0, 0, 99, 97, 108, 108, 105, 110, 103, 32, 120, 109, 108, 86, 97, 108, 105, 100, 97, 116, 101, 81, 78, 97, 109, 101, 40, 41, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 86, 97, 108, 105, 100, 97, 116, 101, 78, 111, 116, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 97, 32, 115, 99, 104, 101, 109, 97, 32, 105, 115, 32, 110, 101, 101, 100, 101, 100, 32, 111, 110, 32, 116, 104, 101, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 112, 97, 116, 116, 101, 114, 110, 0, 109, 97, 120, 69, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 109, 97, 120, 73, 110, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 109, 105, 110, 69, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 109, 105, 110, 73, 110, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 119, 104, 105, 116, 101, 83, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 108, 101, 110, 103, 116, 104, 0, 0, 109, 97, 120, 76, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 0, 0, 109, 105, 110, 76, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 0, 0, 116, 111, 116, 97, 108, 68, 105, 103, 105, 116, 115, 0, 0, 0, 0, 0, 102, 114, 97, 99, 116, 105, 111, 110, 68, 105, 103, 105, 116, 115, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 69, 114, 114, 111, 114, 0, 0, 67, 97, 110, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 97, 117, 116, 111, 109, 97, 116, 97, 32, 102, 111, 114, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 32, 116, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 0, 0, 0, 0, 0, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 116, 101, 114, 109, 105, 110, 105, 115, 116, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 66, 117, 105, 108, 100, 65, 67, 111, 110, 116, 101, 110, 116, 77, 111, 100, 101, 108, 0, 0, 0, 0, 0, 112, 97, 114, 116, 105, 99, 108, 101, 32, 105, 115, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 0, 0, 60, 101, 108, 101, 109, 101, 110, 116, 62, 32, 112, 97, 114, 116, 105, 99, 108, 101, 32, 104, 97, 115, 32, 110, 111, 32, 116, 101, 114, 109, 0, 0, 102, 111, 117, 110, 100, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 116, 101, 114, 109, 32, 111, 102, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 110, 32, 99, 111, 110, 116, 101, 110, 116, 32, 109, 111, 100, 101, 108, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 66, 117, 105, 108, 100, 67, 111, 110, 116, 101, 110, 116, 77, 111, 100, 101, 108, 70, 111, 114, 83, 117, 98, 115, 116, 71, 114, 111, 117, 112, 44, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 115, 32, 109, 97, 114, 107, 101, 100, 32, 104, 97, 118, 105, 110, 103, 32, 97, 32, 115, 117, 98, 115, 116, 46, 32, 103, 114, 111, 117, 112, 32, 98, 117, 116, 32, 110, 111, 110, 101, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 46, 10, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 32, 103, 114, 111, 117, 112, 32, 99, 111, 110, 116, 97, 105, 110, 101, 114, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 83, 117, 98, 115, 116, 71, 114, 111, 117, 112, 65, 100, 100, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 97, 100, 100, 32, 97, 32, 110, 101, 119, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 32, 99, 111, 110, 116, 97, 105, 110, 101, 114, 0, 0, 0, 0, 0, 0, 79, 110, 108, 121, 32, 103, 108, 111, 98, 97, 108, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 115, 32, 99, 97, 110, 32, 104, 97, 118, 101, 32, 97, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 32, 103, 114, 111, 117, 112, 32, 97, 102, 102, 105, 108, 105, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 100, 101, 102, 105, 110, 101, 115, 32, 97, 32, 99, 105, 114, 99, 117, 108, 97, 114, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 32, 103, 114, 111, 117, 112, 32, 116, 111, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 119, 97, 115, 32, 101, 105, 116, 104, 101, 114, 32, 114, 101, 106, 101, 99, 116, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 32, 103, 114, 111, 117, 112, 32, 97, 102, 102, 105, 108, 105, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 44, 32, 111, 114, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 108, 121, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 105, 116, 115, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 0, 0, 0, 84, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 40, 111, 114, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 39, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 41, 32, 105, 115, 32, 111, 114, 32, 105, 115, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 73, 68, 59, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 115, 32, 97, 114, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 110, 32, 99, 111, 110, 106, 117, 110, 99, 116, 105, 111, 110, 32, 119, 105, 116, 104, 32, 115, 117, 99, 104, 32, 97, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 69, 108, 101, 109, 80, 114, 111, 112, 115, 67, 111, 114, 114, 101, 99, 116, 44, 32, 116, 121, 112, 101, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 46, 46, 46, 32, 115, 107, 105, 112, 112, 105, 110, 103, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 102, 105, 120, 101, 100, 0, 0, 0, 100, 101, 102, 97, 117, 108, 116, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 69, 108, 101, 109, 67, 104, 101, 99, 107, 86, 97, 108, 67, 111, 110, 115, 116, 114, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 111, 102, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 70, 111, 114, 32, 97, 32, 115, 116, 114, 105, 110, 103, 32, 116, 111, 32, 98, 101, 32, 97, 32, 118, 97, 108, 105, 100, 32, 100, 101, 102, 97, 117, 108, 116, 44, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 111, 114, 32, 97, 32, 99, 111, 109, 112, 108, 101, 120, 32, 116, 121, 112, 101, 32, 119, 105, 116, 104, 32, 109, 105, 120, 101, 100, 32, 99, 111, 110, 116, 101, 110, 116, 32, 97, 110, 100, 32, 97, 32, 112, 97, 114, 116, 105, 99, 108, 101, 32, 101, 109, 112, 116, 105, 97, 98, 108, 101, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 97, 114, 115, 101, 67, 104, 101, 99, 107, 67, 79, 83, 86, 97, 108, 105, 100, 68, 101, 102, 97, 117, 108, 116, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 104, 97, 115, 32, 97, 32, 39, 102, 105, 120, 101, 100, 39, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 44, 32, 116, 104, 117, 115, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 109, 117, 115, 116, 32, 97, 108, 115, 111, 32, 104, 97, 118, 101, 32, 97, 32, 39, 102, 105, 120, 101, 100, 39, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 0, 0, 0, 0, 0, 86, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 115, 32, 97, 114, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 102, 32, 116, 104, 101, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 111, 114, 32, 105, 115, 32, 100, 101, 114, 105, 118, 101, 100, 32, 102, 114, 111, 109, 32, 120, 115, 58, 73, 68, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 65, 116, 116, 114, 85, 115, 101, 80, 114, 111, 112, 115, 67, 111, 114, 114, 101, 99, 116, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 0, 0, 84, 104, 101, 32, 39, 102, 105, 120, 101, 100, 39, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 109, 117, 115, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 39, 115, 32, 118, 97, 108, 117, 101, 32, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 39, 37, 115, 39, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 65, 116, 116, 114, 80, 114, 111, 112, 115, 67, 111, 114, 114, 101, 99, 116, 0, 0, 84, 104, 101, 32, 117, 110, 105, 111, 110, 32, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 99, 105, 114, 99, 117, 108, 97, 114, 0, 0, 0, 67, 105, 114, 99, 117, 108, 97, 114, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 103, 114, 111, 117, 112, 32, 39, 37, 115, 39, 32, 100, 101, 102, 105, 110, 101, 100, 0, 0, 67, 105, 114, 99, 117, 108, 97, 114, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 116, 104, 101, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 100, 101, 102, 105, 110, 101, 100, 0, 0, 0, 84, 104, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 99, 105, 114, 99, 117, 108, 97, 114, 0, 0, 0, 0, 0, 0, 114, 101, 102, 0, 0, 0, 0, 0, 37, 115, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 37, 115, 39, 58, 32, 84, 104, 101, 32, 81, 78, 97, 109, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 116, 111, 32, 97, 40, 110, 41, 32, 37, 115, 46, 10, 0, 0, 114, 101, 102, 101, 114, 0, 0, 0, 84, 104, 101, 32, 107, 101, 121, 114, 101, 102, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 97, 32, 107, 101, 121, 114, 101, 102, 0, 0, 84, 104, 101, 32, 99, 97, 114, 100, 105, 110, 97, 108, 105, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 107, 101, 121, 114, 101, 102, 32, 100, 105, 102, 102, 101, 114, 115, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 99, 97, 114, 100, 105, 110, 97, 108, 105, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 100, 32, 107, 101, 121, 47, 117, 110, 105, 113, 117, 101, 32, 39, 37, 115, 39, 0, 0, 0, 0, 65, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 105, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 100, 44, 32, 98, 117, 116, 32, 105, 116, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 97, 110, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 44, 32, 119, 104, 105, 99, 104, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 99, 111, 110, 116, 97, 105, 110, 101, 100, 32, 98, 121, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 115, 0, 105, 116, 101, 109, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 112, 97, 114, 116, 105, 99, 108, 101, 39, 115, 32, 123, 109, 97, 120, 32, 111, 99, 99, 117, 114, 115, 125, 32, 109, 117, 115, 116, 32, 98, 101, 32, 49, 44, 32, 115, 105, 110, 99, 101, 32, 116, 104, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 114, 101, 115, 111, 108, 118, 101, 115, 32, 116, 111, 32, 97, 110, 32, 39, 97, 108, 108, 39, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 0, 0, 0, 0, 0, 109, 101, 109, 98, 101, 114, 84, 121, 112, 101, 115, 0, 0, 0, 0, 0, 116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 71, 114, 111, 117, 112, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 65, 100, 100, 67, 111, 109, 112, 111, 110, 101, 110, 116, 115, 0, 0, 85, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 103, 108, 111, 98, 97, 108, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 97, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 32, 104, 97, 115, 104, 32, 116, 97, 98, 108, 101, 0, 65, 32, 103, 108, 111, 98, 97, 108, 32, 37, 115, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 101, 120, 105, 115, 116, 0, 0, 0, 0, 0, 84, 104, 101, 32, 37, 115, 32, 39, 37, 115, 39, 32, 116, 111, 32, 98, 101, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 116, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 115, 99, 104, 101, 109, 97, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 82, 101, 115, 111, 108, 118, 101, 82, 101, 100, 101, 102, 82, 101, 102, 101, 114, 101, 110, 99, 101, 115, 0, 85, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 84, 104, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 100, 32, 37, 115, 32, 119, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 46, 32, 77, 117, 108, 116, 105, 112, 108, 101, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 0, 0, 105, 110, 99, 108, 117, 100, 101, 0, 105, 109, 112, 111, 114, 116, 0, 0, 114, 101, 100, 101, 102, 105, 110, 101, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 99, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 0, 0, 0, 0, 0, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 0, 0, 103, 114, 111, 117, 112, 0, 0, 0, 110, 111, 116, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 40, 40, 105, 110, 99, 108, 117, 100, 101, 32, 124, 32, 105, 109, 112, 111, 114, 116, 32, 124, 32, 114, 101, 100, 101, 102, 105, 110, 101, 32, 124, 32, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 41, 42, 44, 32, 40, 40, 40, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 32, 124, 32, 99, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 32, 124, 32, 103, 114, 111, 117, 112, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 32, 124, 32, 101, 108, 101, 109, 101, 110, 116, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 124, 32, 110, 111, 116, 97, 116, 105, 111, 110, 41, 44, 32, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 42, 41, 42, 41, 0, 0, 0, 37, 115, 58, 32, 37, 115, 46, 10, 0, 0, 0, 0, 0, 0, 0, 0, 37, 115, 58, 32, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 46, 32, 69, 120, 112, 101, 99, 116, 101, 100, 32, 105, 115, 32, 37, 115, 46, 10, 0, 0, 37, 115, 58, 32, 84, 104, 101, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 46, 10, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 78, 111, 116, 97, 116, 105, 111, 110, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 41, 0, 0, 0, 68, 117, 112, 108, 105, 99, 97, 116, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 73, 68, 39, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 73, 68, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 39, 120, 115, 58, 78, 67, 78, 97, 109, 101, 39, 0, 0, 0, 0, 0, 0, 0, 0, 39, 46, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 46, 0, 0, 0, 0, 84, 104, 101, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 46, 0, 0, 0, 0, 0, 32, 69, 120, 112, 101, 99, 116, 101, 100, 32, 105, 115, 32, 39, 0, 0, 39, 46, 10, 0, 0, 0, 0, 0, 97, 100, 100, 32, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 0, 0, 97, 108, 108, 0, 0, 0, 0, 0, 99, 104, 111, 105, 99, 101, 0, 0, 115, 101, 113, 117, 101, 110, 99, 101, 0, 0, 0, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 97, 108, 108, 32, 124, 32, 99, 104, 111, 105, 99, 101, 32, 124, 32, 115, 101, 113, 117, 101, 110, 99, 101, 41, 63, 41, 0, 0, 0, 0, 0, 0, 0, 40, 48, 32, 124, 32, 49, 41, 0, 49, 0, 0, 0, 0, 0, 0, 0, 120, 115, 58, 110, 111, 110, 78, 101, 103, 97, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 0, 0, 40, 120, 115, 58, 110, 111, 110, 78, 101, 103, 97, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 32, 124, 32, 117, 110, 98, 111, 117, 110, 100, 101, 100, 41, 0, 0, 0, 0, 0, 109, 97, 120, 79, 99, 99, 117, 114, 115, 0, 0, 0, 0, 0, 0, 0, 109, 105, 110, 79, 99, 99, 117, 114, 115, 0, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 109, 105, 110, 79, 99, 99, 117, 114, 115, 32, 40, 109, 117, 115, 116, 32, 98, 101, 32, 48, 32, 111, 114, 32, 49, 41, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 109, 97, 120, 79, 99, 99, 117, 114, 115, 32, 40, 109, 117, 115, 116, 32, 98, 101, 32, 48, 32, 111, 114, 32, 49, 41, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 101, 108, 101, 109, 101, 110, 116, 42, 41, 0, 0, 0, 97, 110, 121, 0, 0, 0, 0, 0, 84, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 105, 110, 103, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 109, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 116, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 84, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 105, 110, 103, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 97, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 116, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 119, 105, 116, 104, 32, 97, 32, 109, 97, 120, 79, 99, 99, 117, 114, 115, 47, 109, 105, 110, 79, 99, 99, 117, 114, 115, 32, 111, 116, 104, 101, 114, 32, 116, 104, 97, 110, 32, 49, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 101, 108, 101, 109, 101, 110, 116, 32, 124, 32, 103, 114, 111, 117, 112, 32, 124, 32, 99, 104, 111, 105, 99, 101, 32, 124, 32, 115, 101, 113, 117, 101, 110, 99, 101, 32, 124, 32, 97, 110, 121, 41, 42, 41, 0, 0, 0, 0, 0, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 99, 101, 115, 115, 67, 111, 110, 116, 101, 110, 116, 115, 0, 40, 115, 116, 114, 105, 99, 116, 32, 124, 32, 115, 107, 105, 112, 32, 124, 32, 108, 97, 120, 41, 0, 0, 0, 35, 35, 97, 110, 121, 0, 0, 0, 40, 40, 35, 35, 97, 110, 121, 32, 124, 32, 35, 35, 111, 116, 104, 101, 114, 41, 32, 124, 32, 76, 105, 115, 116, 32, 111, 102, 32, 40, 120, 115, 58, 97, 110, 121, 85, 82, 73, 32, 124, 32, 40, 35, 35, 116, 97, 114, 103, 101, 116, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 124, 32, 35, 35, 108, 111, 99, 97, 108, 41, 41, 41, 0, 0, 0, 0, 0, 0, 0, 35, 35, 116, 97, 114, 103, 101, 116, 78, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 0, 35, 35, 108, 111, 99, 97, 108, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 86, 97, 108, 65, 116, 116, 114, 78, 111, 100, 101, 86, 97, 108, 117, 101, 0, 0, 0, 0, 0, 0, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 98, 117, 105, 108, 116, 45, 105, 110, 32, 116, 121, 112, 101, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 117, 115, 105, 110, 103, 32, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 119, 104, 105, 108, 101, 32, 112, 97, 114, 115, 105, 110, 103, 32, 97, 32, 115, 99, 104, 101, 109, 97, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 118, 97, 108, 117, 101, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 81, 78, 97, 109, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 105, 116, 101, 109, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 102, 114, 111, 109, 32, 116, 104, 105, 115, 32, 115, 99, 104, 101, 109, 97, 32, 116, 111, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 115, 32, 105, 110, 32, 110, 111, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 97, 114, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 115, 105, 110, 99, 101, 32, 110, 111, 116, 32, 105, 110, 100, 105, 99, 97, 116, 101, 100, 32, 98, 121, 32, 97, 110, 32, 105, 109, 112, 111, 114, 116, 32, 115, 116, 97, 116, 101, 109, 101, 110, 116, 0, 0, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 102, 114, 111, 109, 32, 116, 104, 105, 115, 32, 115, 99, 104, 101, 109, 97, 32, 116, 111, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 115, 32, 105, 110, 32, 116, 104, 101, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 32, 97, 114, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 44, 32, 115, 105, 110, 99, 101, 32, 110, 111, 116, 32, 105, 110, 100, 105, 99, 97, 116, 101, 100, 32, 98, 121, 32, 97, 110, 32, 105, 109, 112, 111, 114, 116, 32, 115, 116, 97, 116, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 32, 39, 120, 115, 58, 81, 78, 97, 109, 101, 39, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 105, 110, 32, 115, 99, 111, 112, 101, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 49, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 116, 104, 101, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 39, 109, 97, 120, 79, 99, 99, 117, 114, 115, 39, 0, 0, 0, 0, 0, 37, 115, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 37, 115, 39, 58, 32, 37, 115, 46, 10, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 0, 117, 110, 98, 111, 117, 110, 100, 101, 100, 0, 0, 0, 0, 0, 0, 0, 37, 115, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 46, 10, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 103, 114, 111, 117, 112, 0, 0, 0, 0, 37, 115, 58, 32, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 98, 117, 116, 32, 109, 105, 115, 115, 105, 110, 103, 46, 10, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 121, 65, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 42, 44, 32, 97, 110, 121, 65, 116, 116, 114, 105, 98, 117, 116, 101, 63, 41, 41, 0, 0, 0, 84, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 103, 114, 111, 117, 112, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 99, 111, 110, 116, 97, 105, 110, 32, 109, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 32, 116, 104, 101, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 102, 111, 114, 109, 0, 0, 0, 0, 113, 117, 97, 108, 105, 102, 105, 101, 100, 0, 0, 0, 0, 0, 0, 0, 117, 110, 113, 117, 97, 108, 105, 102, 105, 101, 100, 0, 0, 0, 0, 0, 40, 113, 117, 97, 108, 105, 102, 105, 101, 100, 32, 124, 32, 117, 110, 113, 117, 97, 108, 105, 102, 105, 101, 100, 41, 0, 0, 0, 0, 0, 0, 0, 117, 115, 101, 0, 0, 0, 0, 0, 111, 112, 116, 105, 111, 110, 97, 108, 0, 0, 0, 0, 0, 0, 0, 0, 112, 114, 111, 104, 105, 98, 105, 116, 101, 100, 0, 0, 0, 0, 0, 0, 114, 101, 113, 117, 105, 114, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 40, 111, 112, 116, 105, 111, 110, 97, 108, 32, 124, 32, 112, 114, 111, 104, 105, 98, 105, 116, 101, 100, 32, 124, 32, 114, 101, 113, 117, 105, 114, 101, 100, 41, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 117, 115, 101, 39, 32, 109, 117, 115, 116, 32, 98, 101, 32, 39, 111, 112, 116, 105, 111, 110, 97, 108, 39, 32, 105, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 100, 101, 102, 97, 117, 108, 116, 39, 32, 105, 115, 32, 112, 114, 101, 115, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 39, 120, 109, 108, 110, 115, 39, 0, 0, 0, 0, 0, 0, 0, 83, 107, 105, 112, 112, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 44, 32, 115, 105, 110, 99, 101, 32, 105, 116, 32, 105, 115, 32, 112, 111, 105, 110, 116, 108, 101, 115, 115, 32, 105, 110, 115, 105, 100, 101, 32, 97, 110, 32, 60, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 62, 0, 0, 0, 0, 83, 107, 105, 112, 112, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 44, 32, 115, 105, 110, 99, 101, 32, 105, 116, 32, 105, 115, 32, 112, 111, 105, 110, 116, 108, 101, 115, 115, 32, 119, 104, 101, 110, 32, 101, 120, 116, 101, 110, 100, 105, 110, 103, 32, 97, 32, 116, 121, 112, 101, 0, 83, 107, 105, 112, 112, 105, 110, 103, 32, 100, 117, 112, 108, 105, 99, 97, 116, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 116, 121, 112, 101, 39, 32, 97, 110, 100, 32, 116, 104, 101, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 97, 114, 101, 32, 109, 117, 116, 117, 97, 108, 108, 121, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 63, 41, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 117, 115, 101, 32, 112, 114, 111, 104, 105, 98, 105, 116, 105, 111, 110, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 37, 115, 58, 32, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 39, 37, 115, 39, 32, 97, 110, 100, 32, 39, 37, 115, 39, 32, 97, 114, 101, 32, 109, 117, 116, 117, 97, 108, 108, 121, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 46, 10, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 103, 114, 111, 117, 112, 0, 0, 0, 0, 0, 0, 79, 110, 108, 121, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 39, 109, 105, 110, 79, 99, 99, 117, 114, 115, 39, 44, 32, 39, 109, 97, 120, 79, 99, 99, 117, 114, 115, 39, 32, 97, 110, 100, 32, 39, 105, 100, 39, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 110, 32, 97, 100, 100, 105, 116, 105, 111, 110, 32, 116, 111, 32, 39, 114, 101, 102, 39, 0, 0, 98, 108, 111, 99, 107, 0, 0, 0, 110, 105, 108, 108, 97, 98, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 102, 105, 110, 97, 108, 0, 0, 0, 97, 98, 115, 116, 114, 97, 99, 116, 0, 0, 0, 0, 0, 0, 0, 0, 40, 35, 97, 108, 108, 32, 124, 32, 76, 105, 115, 116, 32, 111, 102, 32, 40, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 124, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 41, 41, 0, 0, 0, 0, 0, 0, 40, 35, 97, 108, 108, 32, 124, 32, 76, 105, 115, 116, 32, 111, 102, 32, 40, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 124, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 32, 124, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 41, 41, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 116, 121, 112, 101, 39, 32, 97, 110, 100, 32, 116, 104, 101, 32, 60, 99, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 97, 114, 101, 32, 109, 117, 116, 117, 97, 108, 108, 121, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 0, 117, 110, 105, 113, 117, 101, 0, 0, 107, 101, 121, 0, 0, 0, 0, 0, 107, 101, 121, 114, 101, 102, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 40, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 32, 124, 32, 99, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 41, 63, 44, 32, 40, 117, 110, 105, 113, 117, 101, 32, 124, 32, 107, 101, 121, 32, 124, 32, 107, 101, 121, 114, 101, 102, 41, 42, 41, 41, 0, 0, 65, 32, 99, 104, 105, 108, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 115, 32, 109, 105, 115, 115, 105, 110, 103, 0, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 115, 101, 108, 101, 99, 116, 111, 114, 44, 32, 102, 105, 101, 108, 100, 43, 41, 41, 0, 0, 0, 0, 0, 0, 0, 115, 101, 108, 101, 99, 116, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 102, 105, 101, 108, 100, 0, 0, 0, 120, 112, 97, 116, 104, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 39, 115, 101, 108, 101, 99, 116, 111, 114, 39, 32, 111, 102, 32, 97, 110, 32, 105, 100, 101, 110, 116, 105, 116, 121, 45, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 97, 114, 115, 101, 73, 68, 67, 83, 101, 108, 101, 99, 116, 111, 114, 65, 110, 100, 70, 105, 101, 108, 100, 44, 32, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 116, 104, 101, 32, 88, 80, 97, 116, 104, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 111, 102, 32, 97, 32, 73, 68, 67, 32, 115, 101, 108, 101, 99, 116, 111, 114, 46, 10, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 65, 100, 100, 65, 110, 110, 111, 116, 97, 116, 105, 111, 110, 44, 32, 84, 104, 101, 32, 105, 116, 101, 109, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 97, 110, 110, 111, 116, 97, 116, 101, 100, 32, 115, 99, 104, 101, 109, 97, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 104, 101, 99, 107, 67, 83, 101, 108, 101, 99, 116, 111, 114, 88, 80, 97, 116, 104, 44, 32, 116, 104, 101, 32, 115, 101, 108, 101, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 46, 10, 0, 0, 0, 84, 104, 101, 32, 88, 80, 97, 116, 104, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 111, 102, 32, 116, 104, 101, 32, 115, 101, 108, 101, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 118, 97, 108, 105, 100, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 97, 114, 114, 97, 121, 0, 0, 0, 0, 84, 104, 101, 32, 88, 80, 97, 116, 104, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 39, 37, 115, 39, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 99, 111, 109, 112, 105, 108, 101, 100, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 32, 105, 100, 101, 110, 116, 105, 116, 121, 45, 99, 111, 110, 115, 116, 114, 97, 105, 110, 116, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 35, 97, 108, 108, 0, 0, 0, 0, 101, 120, 116, 101, 110, 115, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 0, 0, 0, 0, 0, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 0, 0, 0, 0, 108, 105, 115, 116, 0, 0, 0, 0, 117, 110, 105, 111, 110, 0, 0, 0, 116, 114, 117, 101, 0, 0, 0, 0, 102, 97, 108, 115, 101, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 101, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 82, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 111, 102, 32, 98, 117, 105, 108, 116, 45, 105, 110, 32, 115, 105, 109, 112, 108, 101, 32, 116, 121, 112, 101, 115, 32, 105, 115, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 0, 40, 35, 97, 108, 108, 32, 124, 32, 76, 105, 115, 116, 32, 111, 102, 32, 40, 108, 105, 115, 116, 32, 124, 32, 117, 110, 105, 111, 110, 32, 124, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 41, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 32, 124, 32, 108, 105, 115, 116, 32, 124, 32, 117, 110, 105, 111, 110, 41, 41, 0, 0, 0, 0, 0, 84, 104, 105, 115, 32, 105, 115, 32, 97, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 44, 32, 116, 104, 117, 115, 32, 116, 104, 101, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 109, 117, 115, 116, 32, 104, 97, 118, 101, 32, 97, 32, 60, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 62, 32, 99, 104, 105, 108, 100, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 97, 114, 115, 101, 85, 110, 105, 111, 110, 44, 32, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 116, 121, 112, 101, 32, 108, 105, 110, 107, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 42, 41, 0, 0, 0, 0, 0, 0, 69, 105, 116, 104, 101, 114, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 109, 101, 109, 98, 101, 114, 84, 121, 112, 101, 115, 39, 32, 111, 114, 32, 97, 116, 32, 108, 101, 97, 115, 116, 32, 111, 110, 101, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 109, 117, 115, 116, 32, 98, 101, 32, 112, 114, 101, 115, 101, 110, 116, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 105, 116, 101, 109, 84, 121, 112, 101, 39, 32, 97, 110, 100, 32, 116, 104, 101, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 97, 114, 101, 32, 109, 117, 116, 117, 97, 108, 108, 121, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 0, 0, 69, 105, 116, 104, 101, 114, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 105, 116, 101, 109, 84, 121, 112, 101, 39, 32, 111, 114, 32, 116, 104, 101, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 109, 117, 115, 116, 32, 98, 101, 32, 112, 114, 101, 115, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 84, 104, 105, 115, 32, 105, 115, 32, 97, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 44, 32, 98, 117, 116, 32, 116, 104, 101, 32, 81, 78, 97, 109, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 39, 98, 97, 115, 101, 39, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 116, 121, 112, 101, 39, 115, 32, 100, 101, 115, 105, 103, 110, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 98, 97, 115, 101, 39, 32, 97, 110, 100, 32, 116, 104, 101, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 97, 114, 101, 32, 109, 117, 116, 117, 97, 108, 108, 121, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 69, 105, 116, 104, 101, 114, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 98, 97, 115, 101, 39, 32, 111, 114, 32, 97, 32, 60, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 62, 32, 99, 104, 105, 108, 100, 32, 109, 117, 115, 116, 32, 98, 101, 32, 112, 114, 101, 115, 101, 110, 116, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 102, 97, 99, 101, 116, 32, 108, 105, 110, 107, 0, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 103, 114, 111, 117, 112, 32, 124, 32, 97, 108, 108, 32, 124, 32, 99, 104, 111, 105, 99, 101, 32, 124, 32, 115, 101, 113, 117, 101, 110, 99, 101, 41, 63, 44, 32, 40, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 42, 44, 32, 97, 110, 121, 65, 116, 116, 114, 105, 98, 117, 116, 101, 63, 41, 41, 0, 0, 0, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 63, 44, 32, 40, 109, 105, 110, 69, 120, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 109, 105, 110, 73, 110, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 109, 97, 120, 69, 120, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 109, 97, 120, 73, 110, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 116, 111, 116, 97, 108, 68, 105, 103, 105, 116, 115, 32, 124, 32, 102, 114, 97, 99, 116, 105, 111, 110, 68, 105, 103, 105, 116, 115, 32, 124, 32, 108, 101, 110, 103, 116, 104, 32, 124, 32, 109, 105, 110, 76, 101, 110, 103, 116, 104, 32, 124, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 124, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 32, 124, 32, 119, 104, 105, 116, 101, 83, 112, 97, 99, 101, 32, 124, 32, 112, 97, 116, 116, 101, 114, 110, 41, 42, 41, 63, 44, 32, 40, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 42, 44, 32, 97, 110, 121, 65, 116, 116, 114, 105, 98, 117, 116, 101, 63, 41, 41, 0, 0, 0, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 115, 105, 109, 112, 108, 101, 84, 121, 112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 156528);
	        allocate([101, 63, 44, 32, 40, 109, 105, 110, 69, 120, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 109, 105, 110, 73, 110, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 109, 97, 120, 69, 120, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 109, 97, 120, 73, 110, 99, 108, 117, 115, 105, 118, 101, 32, 124, 32, 116, 111, 116, 97, 108, 68, 105, 103, 105, 116, 115, 32, 124, 32, 102, 114, 97, 99, 116, 105, 111, 110, 68, 105, 103, 105, 116, 115, 32, 124, 32, 108, 101, 110, 103, 116, 104, 32, 124, 32, 109, 105, 110, 76, 101, 110, 103, 116, 104, 32, 124, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 124, 32, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 32, 124, 32, 119, 104, 105, 116, 101, 83, 112, 97, 99, 101, 32, 124, 32, 112, 97, 116, 116, 101, 114, 110, 41, 42, 41, 41, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 102, 97, 99, 101, 116, 0, 0, 0, 0, 0, 0, 0, 0, 118, 97, 108, 117, 101, 0, 0, 0, 70, 97, 99, 101, 116, 32, 37, 115, 32, 104, 97, 115, 32, 110, 111, 32, 118, 97, 108, 117, 101, 10, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 102, 97, 99, 101, 116, 32, 116, 121, 112, 101, 32, 37, 115, 10, 0, 0, 70, 97, 99, 101, 116, 32, 37, 115, 32, 104, 97, 115, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 99, 104, 105, 108, 100, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 109, 105, 120, 101, 100, 0, 0, 0, 40, 35, 97, 108, 108, 32, 124, 32, 76, 105, 115, 116, 32, 111, 102, 32, 40, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 124, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 41, 41, 32, 0, 0, 0, 0, 0, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 0, 0, 0, 99, 111, 109, 112, 108, 101, 120, 67, 111, 110, 116, 101, 110, 116, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 115, 105, 109, 112, 108, 101, 67, 111, 110, 116, 101, 110, 116, 32, 124, 32, 99, 111, 109, 112, 108, 101, 120, 67, 111, 110, 116, 101, 110, 116, 32, 124, 32, 40, 40, 103, 114, 111, 117, 112, 32, 124, 32, 97, 108, 108, 32, 124, 32, 99, 104, 111, 105, 99, 101, 32, 124, 32, 115, 101, 113, 117, 101, 110, 99, 101, 41, 63, 44, 32, 40, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 42, 44, 32, 97, 110, 121, 65, 116, 116, 114, 105, 98, 117, 116, 101, 63, 41, 41, 41, 41, 0, 0, 84, 104, 105, 115, 32, 105, 115, 32, 97, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 44, 32, 116, 104, 117, 115, 32, 116, 104, 101, 32, 60, 99, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 62, 32, 109, 117, 115, 116, 32, 104, 97, 118, 101, 32, 97, 32, 60, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 62, 32, 111, 114, 32, 60, 101, 120, 116, 101, 110, 115, 105, 111, 110, 62, 32, 103, 114, 97, 110, 100, 45, 99, 104, 105, 108, 100, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 32, 124, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 41, 41, 0, 0, 0, 0, 0, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 63, 44, 32, 40, 40, 103, 114, 111, 117, 112, 32, 124, 32, 97, 108, 108, 32, 124, 32, 99, 104, 111, 105, 99, 101, 32, 124, 32, 115, 101, 113, 117, 101, 110, 99, 101, 41, 63, 44, 32, 40, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 42, 44, 32, 97, 110, 121, 65, 116, 116, 114, 105, 98, 117, 116, 101, 63, 41, 41, 41, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 102, 111, 114, 32, 105, 110, 99, 108, 117, 115, 105, 111, 110, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 102, 111, 114, 32, 114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 101, 100, 47, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 115, 99, 104, 101, 109, 97, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 97, 98, 115, 101, 110, 116, 44, 32, 115, 105, 110, 99, 101, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 105, 110, 103, 47, 114, 101, 100, 101, 102, 105, 110, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 104, 97, 115, 32, 110, 111, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 101, 100, 47, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 115, 99, 104, 101, 109, 97, 32, 39, 37, 115, 39, 32, 100, 105, 102, 102, 101, 114, 115, 32, 102, 114, 111, 109, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 105, 110, 103, 47, 114, 101, 100, 101, 102, 105, 110, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 0, 0, 0, 0, 84, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 101, 100, 47, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 115, 99, 104, 101, 109, 97, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 97, 98, 115, 101, 110, 116, 32, 111, 114, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 97, 115, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 105, 110, 103, 47, 114, 101, 100, 101, 102, 105, 110, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 39, 115, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 40, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 32, 124, 32, 40, 115, 105, 109, 112, 108, 101, 84, 121, 112, 101, 32, 124, 32, 99, 111, 109, 112, 108, 101, 120, 84, 121, 112, 101, 32, 124, 32, 103, 114, 111, 117, 112, 32, 124, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 71, 114, 111, 117, 112, 41, 41, 42, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 97, 114, 115, 101, 78, 101, 119, 68, 111, 99, 0, 0, 0, 0, 114, 101, 112, 97, 114, 115, 105, 110, 103, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 0, 0, 112, 97, 114, 115, 105, 110, 103, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 44, 32, 98, 117, 116, 32, 116, 104, 101, 114, 101, 39, 115, 32, 110, 111, 32, 100, 111, 99, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 97, 114, 115, 101, 73, 110, 99, 108, 117, 100, 101, 79, 114, 82, 101, 100, 101, 102, 105, 110, 101, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 117, 105, 108, 100, 32, 97, 110, 32, 85, 82, 73, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 115, 99, 104, 101, 109, 97, 76, 111, 99, 97, 116, 105, 111, 110, 0, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 99, 97, 110, 110, 111, 116, 32, 114, 101, 100, 101, 102, 105, 110, 101, 32, 105, 116, 115, 101, 108, 102, 46, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 99, 97, 110, 110, 111, 116, 32, 105, 110, 99, 108, 117, 100, 101, 32, 105, 116, 115, 101, 108, 102, 46, 0, 84, 104, 101, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 116, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 110, 97, 109, 101, 115, 112, 97, 99, 101, 39, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 32, 116, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 32, 111, 102, 32, 116, 104, 101, 32, 105, 109, 112, 111, 114, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 0, 84, 104, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 39, 110, 97, 109, 101, 115, 112, 97, 99, 101, 39, 32, 109, 117, 115, 116, 32, 98, 101, 32, 101, 120, 105, 115, 116, 101, 110, 116, 32, 105, 102, 32, 116, 104, 101, 32, 105, 109, 112, 111, 114, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 104, 97, 115, 32, 110, 111, 32, 116, 97, 114, 103, 101, 116, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 99, 97, 116, 101, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 97, 116, 32, 108, 111, 99, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 46, 32, 83, 107, 105, 112, 112, 105, 110, 103, 32, 116, 104, 101, 32, 105, 109, 112, 111, 114, 116, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 80, 86, 97, 108, 65, 116, 116, 114, 44, 32, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 98, 117, 105, 108, 116, 45, 105, 110, 32, 116, 121, 112, 101, 46, 10, 0, 97, 112, 112, 105, 110, 102, 111, 0, 115, 111, 117, 114, 99, 101, 0, 0, 100, 111, 99, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 40, 97, 112, 112, 105, 110, 102, 111, 32, 124, 32, 100, 111, 99, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 41, 42, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 110, 110, 111, 116, 97, 116, 105, 111, 110, 0, 0, 0, 116, 97, 114, 103, 101, 116, 78, 97, 109, 101, 115, 112, 97, 99, 101, 0, 101, 108, 101, 109, 101, 110, 116, 70, 111, 114, 109, 68, 101, 102, 97, 117, 108, 116, 0, 0, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 70, 111, 114, 109, 68, 101, 102, 97, 117, 108, 116, 0, 0, 0, 0, 102, 105, 110, 97, 108, 68, 101, 102, 97, 117, 108, 116, 0, 0, 0, 0, 40, 35, 97, 108, 108, 32, 124, 32, 76, 105, 115, 116, 32, 111, 102, 32, 40, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 124, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110, 32, 124, 32, 108, 105, 115, 116, 32, 124, 32, 117, 110, 105, 111, 110, 41, 41, 0, 0, 0, 0, 0, 0, 0, 98, 108, 111, 99, 107, 68, 101, 102, 97, 117, 108, 116, 0, 0, 0, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 105, 109, 112, 111, 114, 116, 47, 105, 110, 99, 108, 117, 100, 101, 47, 114, 101, 100, 101, 102, 105, 110, 101, 32, 105, 116, 115, 101, 108, 102, 0, 0, 0, 0, 0, 0, 105, 110, 95, 109, 101, 109, 111, 114, 121, 95, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 105, 109, 112, 111, 114, 116, 101, 100, 44, 32, 115, 105, 110, 99, 101, 32, 105, 116, 32, 119, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 111, 114, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 111, 114, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 44, 32, 115, 105, 110, 99, 101, 32, 105, 116, 32, 119, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 109, 112, 111, 114, 116, 101, 100, 0, 83, 107, 105, 112, 112, 105, 110, 103, 32, 105, 109, 112, 111, 114, 116, 32, 111, 102, 32, 115, 99, 104, 101, 109, 97, 32, 108, 111, 99, 97, 116, 101, 100, 32, 97, 116, 32, 39, 37, 115, 39, 32, 102, 111, 114, 32, 116, 104, 101, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 44, 32, 115, 105, 110, 99, 101, 32, 116, 104, 105, 115, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 119, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 109, 112, 111, 114, 116, 101, 100, 32, 119, 105, 116, 104, 32, 116, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 108, 111, 99, 97, 116, 101, 100, 32, 97, 116, 32, 39, 37, 115, 39, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 65, 100, 100, 83, 99, 104, 101, 109, 97, 68, 111, 99, 0, 0, 0, 116, 114, 121, 105, 110, 103, 32, 116, 111, 32, 108, 111, 97, 100, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 44, 32, 98, 117, 116, 32, 97, 32, 100, 111, 99, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 97, 115, 115, 105, 103, 110, 101, 100, 32, 116, 111, 32, 116, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 98, 117, 99, 107, 101, 116, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 71, 101, 116, 68, 111, 99, 44, 32, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 97, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 116, 104, 101, 32, 88, 77, 76, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 39, 37, 115, 39, 0, 0, 0, 78, 111, 32, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 32, 102, 111, 114, 32, 112, 97, 114, 115, 105, 110, 103, 32, 119, 97, 115, 32, 112, 114, 111, 118, 105, 100, 101, 100, 32, 119, 105, 116, 104, 32, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 115, 99, 104, 101, 109, 97, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 46, 10, 0, 0, 84, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 110, 111, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 101, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 115, 99, 104, 101, 109, 97, 0, 0, 84, 104, 101, 32, 88, 77, 76, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 115, 99, 104, 101, 109, 97, 32, 100, 111, 99, 117, 109, 101, 110, 116, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 66, 117, 99, 107, 101, 116, 67, 114, 101, 97, 116, 101, 0, 0, 0, 110, 111, 32, 109, 97, 105, 110, 32, 115, 99, 104, 101, 109, 97, 32, 111, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 98, 117, 99, 107, 101, 116, 0, 0, 0, 0, 0, 0, 0, 0, 102, 105, 114, 115, 116, 32, 98, 117, 99, 107, 101, 116, 32, 98, 117, 116, 32, 105, 116, 39, 115, 32, 97, 110, 32, 105, 110, 99, 108, 117, 100, 101, 32, 111, 114, 32, 114, 101, 100, 101, 102, 105, 110, 101, 0, 0, 0, 0, 109, 97, 105, 110, 32, 98, 117, 99, 107, 101, 116, 32, 98, 117, 116, 32, 105, 116, 39, 115, 32, 110, 111, 116, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 111, 110, 101, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 97, 100, 100, 32, 116, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 98, 117, 99, 107, 101, 116, 32, 116, 111, 32, 116, 104, 101, 32, 104, 97, 115, 104, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 114, 101, 108, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 108, 105, 115, 116, 32, 111, 102, 32, 115, 99, 104, 101, 109, 97, 32, 98, 117, 99, 107, 101, 116, 115, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 108, 105, 115, 116, 32, 111, 102, 32, 112, 101, 110, 100, 105, 110, 103, 32, 103, 108, 111, 98, 97, 108, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 115, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 0, 0, 0, 0, 0, 0, 0, 40, 78, 85, 76, 76, 41, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 120, 109, 108, 83, 99, 104, 101, 109, 97, 67, 111, 109, 112, 111, 110, 101, 110, 116, 76, 105, 115, 116, 70, 114, 101, 101, 44, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 121, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 109, 111, 100, 101, 108, 32, 103, 114, 111, 117, 112, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 97, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 108, 100, 99, 97, 114, 100, 32, 111, 110, 32, 97, 110, 121, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 97, 110, 121, 83, 105, 109, 112, 108, 101, 84, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 116, 114, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 101, 99, 105, 109, 97, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 97, 116, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 97, 116, 101, 84, 105, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 105, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 89, 101, 97, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 89, 101, 97, 114, 77, 111, 110, 116, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 77, 111, 110, 116, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 77, 111, 110, 116, 104, 68, 97, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 68, 97, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 117, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 108, 111, 97, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 111, 117, 98, 108, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 111, 111, 108, 101, 97, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 121, 85, 82, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 101, 120, 66, 105, 110, 97, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 54, 52, 66, 105, 110, 97, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 79, 84, 65, 84, 73, 79, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 78, 97, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 116, 101, 103, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 110, 80, 111, 115, 105, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 101, 103, 97, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 111, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 104, 111, 114, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 121, 116, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 110, 78, 101, 103, 97, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 115, 105, 103, 110, 101, 100, 76, 111, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 115, 105, 103, 110, 101, 100, 73, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 115, 105, 103, 110, 101, 100, 83, 104, 111, 114, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 115, 105, 103, 110, 101, 100, 66, 121, 116, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 111, 115, 105, 116, 105, 118, 101, 73, 110, 116, 101, 103, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 114, 109, 97, 108, 105, 122, 101, 100, 83, 116, 114, 105, 110, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 111, 107, 101, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 97, 110, 103, 117, 97, 103, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 77, 84, 79, 75, 69, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 67, 78, 97, 109, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 68, 82, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 78, 84, 73, 84, 89, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 78, 84, 73, 84, 73, 69, 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 68, 82, 69, 70, 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 77, 84, 79, 75, 69, 78, 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, 0, 0, 0, 0, 0, 125, 0, 0, 0, 0, 0, 0, 0, 48, 46, 48, 0, 0, 0, 0, 0, 37, 108, 117, 37, 108, 117, 37, 108, 117, 0, 0, 0, 0, 0, 0, 0, 37, 108, 117, 37, 108, 117, 0, 0, 37, 108, 117, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 45, 37, 108, 117, 37, 108, 117, 37, 108, 117, 0, 0, 0, 0, 0, 0, 45, 37, 108, 117, 37, 108, 117, 0, 45, 37, 108, 117, 0, 0, 0, 0, 116, 114, 117, 101, 0, 0, 0, 0, 102, 97, 108, 115, 101, 0, 0, 0, 80, 37, 108, 117, 89, 37, 108, 117, 77, 37, 108, 117, 68, 84, 37, 108, 117, 72, 37, 108, 117, 77, 37, 46, 49, 52, 103, 83, 0, 0, 0, 0, 45, 80, 37, 108, 117, 89, 37, 108, 117, 77, 37, 108, 117, 68, 84, 37, 108, 117, 72, 37, 108, 117, 77, 37, 46, 49, 52, 103, 83, 0, 0, 0, 37, 48, 52, 108, 100, 0, 0, 0, 45, 45, 37, 48, 50, 117, 0, 0, 45, 45, 45, 37, 48, 50, 117, 0, 45, 45, 37, 48, 50, 117, 45, 37, 48, 50, 117, 0, 0, 0, 0, 0, 45, 37, 48, 52, 108, 100, 45, 37, 48, 50, 117, 0, 0, 0, 0, 0, 37, 48, 52, 108, 100, 45, 37, 48, 50, 117, 0, 0, 0, 0, 0, 0, 37, 48, 50, 117, 58, 37, 48, 50, 117, 58, 37, 48, 50, 46, 49, 52, 103, 90, 0, 0, 0, 0, 0, 0, 37, 48, 50, 117, 58, 37, 48, 50, 117, 58, 37, 48, 50, 46, 49, 52, 103, 0, 0, 0, 0, 0, 0, 0, 37, 48, 52, 108, 100, 58, 37, 48, 50, 117, 58, 37, 48, 50, 117, 90, 0, 0, 0, 0, 0, 0, 0, 0, 37, 48, 52, 108, 100, 58, 37, 48, 50, 117, 58, 37, 48, 50, 117, 0, 37, 48, 52, 108, 100, 58, 37, 48, 50, 117, 58, 37, 48, 50, 117, 84, 37, 48, 50, 117, 58, 37, 48, 50, 117, 58, 37, 48, 50, 46, 49, 52, 103, 90, 0, 0, 0, 0, 0, 0, 37, 48, 52, 108, 100, 58, 37, 48, 50, 117, 58, 37, 48, 50, 117, 84, 37, 48, 50, 117, 58, 37, 48, 50, 117, 58, 37, 48, 50, 46, 49, 52, 103, 0, 0, 0, 0, 0, 0, 0, 37, 48, 49, 46, 49, 52, 101, 0, 63, 63, 63, 0, 0, 0, 0, 0, 31, 0, 0, 0, 29, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 31, 0, 0, 0, 28, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 120, 109, 108, 115, 99, 104, 101, 109, 97, 115, 116, 121, 112, 101, 115, 46, 99, 0, 0, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 60, 0, 0, 0, 91, 0, 0, 0, 121, 0, 0, 0, 152, 0, 0, 0, 182, 0, 0, 0, 213, 0, 0, 0, 244, 0, 0, 0, 18, 1, 0, 0, 49, 1, 0, 0, 79, 1, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 59, 0, 0, 0, 90, 0, 0, 0, 120, 0, 0, 0, 151, 0, 0, 0, 181, 0, 0, 0, 212, 0, 0, 0, 243, 0, 0, 0, 17, 1, 0, 0, 48, 1, 0, 0, 78, 1, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 59, 0, 0, 0, 89, 0, 0, 0, 120, 0, 0, 0, 150, 0, 0, 0, 181, 0, 0, 0, 212, 0, 0, 0, 242, 0, 0, 0, 17, 1, 0, 0, 47, 1, 0, 0, 78, 1, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 62, 0, 0, 0, 92, 0, 0, 0, 123, 0, 0, 0, 153, 0, 0, 0, 184, 0, 0, 0, 215, 0, 0, 0, 245, 0, 0, 0, 20, 1, 0, 0, 50, 1, 0, 0, 81, 1, 0, 0, 37, 102, 0, 0, 0, 0, 0, 0, 37, 108, 102, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 104, 101, 120, 98, 105, 110, 32, 100, 97, 116, 97, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 98, 97, 115, 101, 54, 52, 32, 100, 97, 116, 97, 0, 0, 89, 77, 68, 72, 77, 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 245, 64, 0, 0, 0, 0, 0, 32, 172, 64, 0, 0, 0, 0, 0, 0, 78, 64, 0, 0, 0, 0, 0, 0, 240, 63, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 112, 97, 114, 116, 105, 99, 108, 101, 32, 99, 111, 109, 112, 111, 110, 101, 110, 116, 0, 0, 0, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 32, 98, 97, 115, 105, 99, 32, 116, 121, 112, 101, 115, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 77, 76, 83, 99, 104, 101, 109, 97, 0, 0, 0, 0, 0, 0, 0, 0, 16, 206, 2, 0, 128, 0, 0, 0, 18, 0, 0, 0, 7, 0, 0, 0, 144, 205, 2, 0, 216, 205, 2, 0, 11, 0, 0, 0, 3, 0, 0, 0, 72, 205, 2, 0, 120, 205, 2, 0, 23, 1, 0, 0, 50, 0, 0, 0, 88, 199, 2, 0, 184, 203, 2, 0, 140, 1, 0, 0, 28, 0, 0, 0, 72, 192, 2, 0, 120, 198, 2, 0, 20, 0, 0, 0, 0, 0, 0, 0, 248, 191, 2, 0, 0, 0, 0, 0, 211, 0, 0, 0, 20, 0, 0, 0, 8, 188, 2, 0, 88, 191, 2, 0, 10, 0, 0, 0, 0, 0, 0, 0, 224, 187, 2, 0, 0, 0, 0, 0, 134, 1, 0, 0, 31, 0, 0, 0, 208, 180, 2, 0, 232, 186, 2, 0, 113, 0, 0, 0, 6, 0, 0, 0, 216, 178, 2, 0, 160, 180, 2, 0, 55, 0, 0, 0, 2, 0, 0, 0, 232, 177, 2, 0, 200, 178, 2, 0, 108, 0, 0, 0, 5, 0, 0, 0, 16, 176, 2, 0, 192, 177, 2, 0, 42, 0, 0, 0, 5, 0, 0, 0, 64, 175, 2, 0, 232, 175, 2, 0, 21, 0, 0, 0, 2, 0, 0, 0, 216, 174, 2, 0, 48, 175, 2, 0, 20, 0, 0, 0, 2, 0, 0, 0, 120, 174, 2, 0, 200, 174, 2, 0, 84, 0, 0, 0, 2, 0, 0, 0, 24, 173, 2, 0, 104, 174, 2, 0, 11, 0, 0, 0, 0, 0, 0, 0, 232, 172, 2, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 232, 171, 2, 0, 0, 0, 0, 0, 72, 0, 0, 0, 2, 0, 0, 0, 184, 170, 2, 0, 216, 171, 2, 0, 65, 0, 0, 0, 0, 0, 0, 0, 176, 169, 2, 0, 0, 0, 0, 0, 133, 0, 0, 0, 20, 0, 0, 0, 248, 166, 2, 0, 16, 169, 2, 0, 13, 0, 0, 0, 0, 0, 0, 0, 192, 166, 2, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 104, 166, 2, 0, 0, 0, 0, 0, 48, 0, 0, 0, 10, 0, 0, 0, 88, 165, 2, 0, 24, 166, 2, 0, 103, 0, 0, 0, 10, 0, 0, 0, 104, 163, 2, 0, 8, 165, 2, 0, 9, 0, 0, 0, 0, 0, 0, 0, 64, 163, 2, 0, 0, 0, 0, 0, 32, 0, 32, 0, 160, 0, 160, 0, 128, 22, 128, 22, 14, 24, 14, 24, 0, 32, 10, 32, 40, 32, 41, 32, 47, 32, 47, 32, 95, 32, 95, 32, 0, 48, 0, 48, 0, 0, 0, 0, 166, 0, 167, 0, 169, 0, 169, 0, 174, 0, 174, 0, 176, 0, 176, 0, 182, 0, 182, 0, 130, 4, 130, 4, 14, 6, 15, 6, 233, 6, 233, 6, 253, 6, 254, 6, 250, 9, 250, 9, 112, 11, 112, 11, 243, 11, 248, 11, 250, 11, 250, 11, 1, 15, 3, 15, 19, 15, 23, 15, 26, 15, 31, 15, 52, 15, 52, 15, 54, 15, 54, 15, 56, 15, 56, 15, 190, 15, 197, 15, 199, 15, 204, 15, 207, 15, 207, 15, 64, 25, 64, 25, 224, 25, 255, 25, 0, 33, 1, 33, 3, 33, 6, 33, 8, 33, 9, 33, 20, 33, 20, 33, 22, 33, 24, 33, 30, 33, 35, 33, 37, 33, 37, 33, 39, 33, 39, 33, 41, 33, 41, 33, 46, 33, 46, 33, 50, 33, 50, 33, 58, 33, 59, 33, 74, 33, 74, 33, 149, 33, 153, 33, 156, 33, 159, 33, 161, 33, 162, 33, 164, 33, 165, 33, 167, 33, 173, 33, 175, 33, 205, 33, 208, 33, 209, 33, 211, 33, 211, 33, 213, 33, 243, 33, 0, 35, 7, 35, 12, 35, 31, 35, 34, 35, 40, 35, 43, 35, 123, 35, 125, 35, 154, 35, 183, 35, 208, 35, 0, 36, 38, 36, 64, 36, 74, 36, 156, 36, 233, 36, 0, 37, 182, 37, 184, 37, 192, 37, 194, 37, 247, 37, 0, 38, 23, 38, 25, 38, 110, 38, 112, 38, 125, 38, 128, 38, 145, 38, 160, 38, 161, 38, 1, 39, 4, 39, 6, 39, 9, 39, 12, 39, 39, 39, 41, 39, 75, 39, 77, 39, 77, 39, 79, 39, 82, 39, 86, 39, 86, 39, 88, 39, 94, 39, 97, 39, 103, 39, 148, 39, 148, 39, 152, 39, 175, 39, 177, 39, 190, 39, 0, 40, 255, 40, 0, 43, 13, 43, 128, 46, 153, 46, 155, 46, 243, 46, 0, 47, 213, 47, 240, 47, 251, 47, 4, 48, 4, 48, 18, 48, 19, 48, 32, 48, 32, 48, 54, 48, 55, 48, 62, 48, 63, 48, 144, 49, 145, 49, 150, 49, 159, 49, 0, 50, 30, 50, 42, 50, 67, 50, 80, 50, 80, 50, 96, 50, 125, 50, 127, 50, 127, 50, 138, 50, 176, 50, 192, 50, 254, 50, 0, 51, 255, 51, 192, 77, 255, 77, 144, 164, 198, 164, 253, 253, 253, 253, 228, 255, 228, 255, 232, 255, 232, 255, 237, 255, 238, 255, 252, 255, 253, 255, 0, 0, 0, 0, 2, 1, 1, 0, 2, 1, 1, 0, 55, 1, 1, 0, 63, 1, 1, 0, 0, 208, 1, 0, 245, 208, 1, 0, 0, 209, 1, 0, 38, 209, 1, 0, 42, 209, 1, 0, 100, 209, 1, 0, 106, 209, 1, 0, 108, 209, 1, 0, 131, 209, 1, 0, 132, 209, 1, 0, 140, 209, 1, 0, 169, 209, 1, 0, 174, 209, 1, 0, 221, 209, 1, 0, 0, 211, 1, 0, 86, 211, 1, 0, 43, 0, 43, 0, 60, 0, 62, 0, 124, 0, 124, 0, 126, 0, 126, 0, 172, 0, 172, 0, 177, 0, 177, 0, 215, 0, 215, 0, 247, 0, 247, 0, 246, 3, 246, 3, 68, 32, 68, 32, 82, 32, 82, 32, 122, 32, 124, 32, 138, 32, 140, 32, 64, 33, 68, 33, 75, 33, 75, 33, 144, 33, 148, 33, 154, 33, 155, 33, 160, 33, 160, 33, 163, 33, 163, 33, 166, 33, 166, 33, 174, 33, 174, 33, 206, 33, 207, 33, 210, 33, 210, 33, 212, 33, 212, 33, 244, 33, 255, 34, 8, 35, 11, 35, 32, 35, 33, 35, 124, 35, 124, 35, 155, 35, 179, 35, 183, 37, 183, 37, 193, 37, 193, 37, 248, 37, 255, 37, 111, 38, 111, 38, 208, 39, 229, 39, 240, 39, 255, 39, 0, 41, 130, 41, 153, 41, 215, 41, 220, 41, 251, 41, 254, 41, 255, 42, 41, 251, 41, 251, 98, 254, 98, 254, 100, 254, 102, 254, 11, 255, 11, 255, 28, 255, 30, 255, 92, 255, 92, 255, 94, 255, 94, 255, 226, 255, 226, 255, 233, 255, 236, 255, 193, 214, 1, 0, 193, 214, 1, 0, 219, 214, 1, 0, 219, 214, 1, 0, 251, 214, 1, 0, 251, 214, 1, 0, 21, 215, 1, 0, 21, 215, 1, 0, 53, 215, 1, 0, 53, 215, 1, 0, 79, 215, 1, 0, 79, 215, 1, 0, 111, 215, 1, 0, 111, 215, 1, 0, 137, 215, 1, 0, 137, 215, 1, 0, 169, 215, 1, 0, 169, 215, 1, 0, 195, 215, 1, 0, 195, 215, 1, 0, 94, 0, 94, 0, 96, 0, 96, 0, 168, 0, 168, 0, 175, 0, 175, 0, 180, 0, 180, 0, 184, 0, 184, 0, 194, 2, 197, 2, 210, 2, 223, 2, 229, 2, 237, 2, 239, 2, 255, 2, 116, 3, 117, 3, 132, 3, 133, 3, 189, 31, 189, 31, 191, 31, 193, 31, 205, 31, 207, 31, 221, 31, 223, 31, 237, 31, 239, 31, 253, 31, 254, 31, 155, 48, 156, 48, 62, 255, 62, 255, 64, 255, 64, 255, 227, 255, 227, 255, 36, 0, 36, 0, 162, 0, 165, 0, 242, 9, 243, 9, 241, 10, 241, 10, 249, 11, 249, 11, 63, 14, 63, 14, 219, 23, 219, 23, 160, 32, 177, 32, 252, 253, 252, 253, 105, 254, 105, 254, 4, 255, 4, 255, 224, 255, 225, 255, 229, 255, 230, 255, 0, 0, 0, 0, 36, 0, 36, 0, 43, 0, 43, 0, 60, 0, 62, 0, 94, 0, 94, 0, 96, 0, 96, 0, 124, 0, 124, 0, 126, 0, 126, 0, 162, 0, 169, 0, 172, 0, 172, 0, 174, 0, 177, 0, 180, 0, 180, 0, 182, 0, 182, 0, 184, 0, 184, 0, 215, 0, 215, 0, 247, 0, 247, 0, 194, 2, 197, 2, 210, 2, 223, 2, 229, 2, 237, 2, 239, 2, 255, 2, 116, 3, 117, 3, 132, 3, 133, 3, 246, 3, 246, 3, 130, 4, 130, 4, 14, 6, 15, 6, 233, 6, 233, 6, 253, 6, 254, 6, 242, 9, 243, 9, 250, 9, 250, 9, 241, 10, 241, 10, 112, 11, 112, 11, 243, 11, 250, 11, 63, 14, 63, 14, 1, 15, 3, 15, 19, 15, 23, 15, 26, 15, 31, 15, 52, 15, 52, 15, 54, 15, 54, 15, 56, 15, 56, 15, 190, 15, 197, 15, 199, 15, 204, 15, 207, 15, 207, 15, 219, 23, 219, 23, 64, 25, 64, 25, 224, 25, 255, 25, 189, 31, 189, 31, 191, 31, 193, 31, 205, 31, 207, 31, 221, 31, 223, 31, 237, 31, 239, 31, 253, 31, 254, 31, 68, 32, 68, 32, 82, 32, 82, 32, 122, 32, 124, 32, 138, 32, 140, 32, 160, 32, 177, 32, 0, 33, 1, 33, 3, 33, 6, 33, 8, 33, 9, 33, 20, 33, 20, 33, 22, 33, 24, 33, 30, 33, 35, 33, 37, 33, 37, 33, 39, 33, 39, 33, 41, 33, 41, 33, 46, 33, 46, 33, 50, 33, 50, 33, 58, 33, 59, 33, 64, 33, 68, 33, 74, 33, 75, 33, 144, 33, 40, 35, 43, 35, 179, 35, 183, 35, 208, 35, 0, 36, 38, 36, 64, 36, 74, 36, 156, 36, 233, 36, 0, 37, 23, 38, 25, 38, 125, 38, 128, 38, 145, 38, 160, 38, 161, 38, 1, 39, 4, 39, 6, 39, 9, 39, 12, 39, 39, 39, 41, 39, 75, 39, 77, 39, 77, 39, 79, 39, 82, 39, 86, 39, 86, 39, 88, 39, 94, 39, 97, 39, 103, 39, 148, 39, 148, 39, 152, 39, 175, 39, 177, 39, 190, 39, 208, 39, 229, 39, 240, 39, 130, 41, 153, 41, 215, 41, 220, 41, 251, 41, 254, 41, 13, 43, 128, 46, 153, 46, 155, 46, 243, 46, 0, 47, 213, 47, 240, 47, 251, 47, 4, 48, 4, 48, 18, 48, 19, 48, 32, 48, 32, 48, 54, 48, 55, 48, 62, 48, 63, 48, 155, 48, 156, 48, 144, 49, 145, 49, 150, 49, 159, 49, 0, 50, 30, 50, 42, 50, 67, 50, 80, 50, 80, 50, 96, 50, 125, 50, 127, 50, 127, 50, 138, 50, 176, 50, 192, 50, 254, 50, 0, 51, 255, 51, 192, 77, 255, 77, 144, 164, 198, 164, 41, 251, 41, 251, 252, 253, 253, 253, 98, 254, 98, 254, 100, 254, 102, 254, 105, 254, 105, 254, 4, 255, 4, 255, 11, 255, 11, 255, 28, 255, 30, 255, 62, 255, 62, 255, 64, 255, 64, 255, 92, 255, 92, 255, 94, 255, 94, 255, 224, 255, 230, 255, 232, 255, 238, 255, 252, 255, 253, 255, 0, 0, 0, 0, 2, 1, 1, 0, 2, 1, 1, 0, 55, 1, 1, 0, 63, 1, 1, 0, 0, 208, 1, 0, 245, 208, 1, 0, 0, 209, 1, 0, 38, 209, 1, 0, 42, 209, 1, 0, 100, 209, 1, 0, 106, 209, 1, 0, 108, 209, 1, 0, 131, 209, 1, 0, 132, 209, 1, 0, 140, 209, 1, 0, 169, 209, 1, 0, 174, 209, 1, 0, 221, 209, 1, 0, 0, 211, 1, 0, 86, 211, 1, 0, 193, 214, 1, 0, 193, 214, 1, 0, 219, 214, 1, 0, 219, 214, 1, 0, 251, 214, 1, 0, 251, 214, 1, 0, 21, 215, 1, 0, 21, 215, 1, 0, 53, 215, 1, 0, 53, 215, 1, 0, 79, 215, 1, 0, 79, 215, 1, 0, 111, 215, 1, 0, 111, 215, 1, 0, 137, 215, 1, 0, 137, 215, 1, 0, 169, 215, 1, 0, 169, 215, 1, 0, 195, 215, 1, 0, 195, 215, 1, 0, 40, 0, 40, 0, 91, 0, 91, 0, 123, 0, 123, 0, 58, 15, 58, 15, 60, 15, 60, 15, 155, 22, 155, 22, 26, 32, 26, 32, 30, 32, 30, 32, 69, 32, 69, 32, 125, 32, 125, 32, 141, 32, 141, 32, 41, 35, 41, 35, 180, 35, 180, 35, 104, 39, 104, 39, 106, 39, 106, 39, 108, 39, 108, 39, 110, 39, 110, 39, 112, 39, 112, 39, 114, 39, 114, 39, 116, 39, 116, 39, 230, 39, 230, 39, 232, 39, 232, 39, 234, 39, 234, 39, 131, 41, 131, 41, 133, 41, 133, 41, 135, 41, 135, 41, 137, 41, 137, 41, 139, 41, 139, 41, 141, 41, 141, 41, 143, 41, 143, 41, 145, 41, 145, 41, 147, 41, 147, 41, 149, 41, 149, 41, 151, 41, 151, 41, 216, 41, 216, 41, 218, 41, 218, 41, 252, 41, 252, 41, 8, 48, 8, 48, 10, 48, 10, 48, 12, 48, 12, 48, 14, 48, 14, 48, 16, 48, 16, 48, 20, 48, 20, 48, 22, 48, 22, 48, 24, 48, 24, 48, 26, 48, 26, 48, 29, 48, 29, 48, 62, 253, 62, 253, 53, 254, 53, 254, 55, 254, 55, 254, 57, 254, 57, 254, 59, 254, 59, 254, 61, 254, 61, 254, 63, 254, 63, 254, 65, 254, 65, 254, 67, 254, 67, 254, 71, 254, 71, 254, 89, 254, 89, 254, 91, 254, 91, 254, 93, 254, 93, 254, 8, 255, 8, 255, 59, 255, 59, 255, 91, 255, 91, 255, 95, 255, 95, 255, 98, 255, 98, 255, 0, 0, 0, 0, 33, 0, 35, 0, 37, 0, 39, 0, 42, 0, 42, 0, 44, 0, 44, 0, 46, 0, 47, 0, 58, 0, 59, 0, 63, 0, 64, 0, 92, 0, 92, 0, 161, 0, 161, 0, 183, 0, 183, 0, 191, 0, 191, 0, 126, 3, 126, 3, 135, 3, 135, 3, 90, 5, 95, 5, 137, 5, 137, 5, 190, 5, 190, 5, 192, 5, 192, 5, 195, 5, 195, 5, 243, 5, 244, 5, 12, 6, 13, 6, 27, 6, 27, 6, 31, 6, 31, 6, 106, 6, 109, 6, 212, 6, 212, 6, 0, 7, 13, 7, 100, 9, 101, 9, 112, 9, 112, 9, 244, 13, 244, 13, 79, 14, 79, 14, 90, 14, 91, 14, 4, 15, 18, 15, 133, 15, 133, 15, 74, 16, 79, 16, 251, 16, 251, 16, 97, 19, 104, 19, 109, 22, 110, 22, 235, 22, 237, 22, 53, 23, 54, 23, 212, 23, 214, 23, 216, 23, 218, 23, 0, 24, 5, 24, 7, 24, 10, 24, 68, 25, 69, 25, 22, 32, 23, 32, 32, 32, 39, 32, 48, 32, 56, 32, 59, 32, 62, 32, 65, 32, 67, 32, 71, 32, 81, 32, 83, 32, 83, 32, 87, 32, 87, 32, 182, 35, 182, 35, 1, 48, 3, 48, 61, 48, 61, 48, 48, 254, 48, 254, 69, 254, 70, 254, 73, 254, 76, 254, 80, 254, 82, 254, 84, 254, 87, 254, 95, 254, 97, 254, 104, 254, 104, 254, 106, 254, 107, 254, 1, 255, 3, 255, 5, 255, 7, 255, 10, 255, 10, 255, 12, 255, 12, 255, 14, 255, 15, 255, 26, 255, 27, 255, 31, 255, 32, 255, 60, 255, 60, 255, 97, 255, 97, 255, 100, 255, 100, 255, 0, 1, 1, 0, 1, 1, 1, 0, 159, 3, 1, 0, 159, 3, 1, 0, 41, 0, 41, 0, 93, 0, 93, 0, 125, 0, 125, 0, 59, 15, 59, 15, 61, 15, 61, 15, 156, 22, 156, 22, 70, 32, 70, 32, 126, 32, 126, 32, 142, 32, 142, 32, 42, 35, 42, 35, 181, 35, 181, 35, 105, 39, 105, 39, 107, 39, 107, 39, 109, 39, 109, 39, 111, 39, 111, 39, 113, 39, 113, 39, 115, 39, 115, 39, 117, 39, 117, 39, 231, 39, 231, 39, 233, 39, 233, 39, 235, 39, 235, 39, 132, 41, 132, 41, 134, 41, 134, 41, 136, 41, 136, 41, 138, 41, 138, 41, 140, 41, 140, 41, 142, 41, 142, 41, 144, 41, 144, 41, 146, 41, 146, 41, 148, 41, 148, 41, 150, 41, 150, 41, 152, 41, 152, 41, 217, 41, 217, 41, 219, 41, 219, 41, 253, 41, 253, 41, 9, 48, 9, 48, 11, 48, 11, 48, 13, 48, 13, 48, 15, 48, 15, 48, 17, 48, 17, 48, 21, 48, 21, 48, 23, 48, 23, 48, 25, 48, 25, 48, 27, 48, 27, 48, 30, 48, 31, 48, 63, 253, 63, 253, 54, 254, 54, 254, 56, 254, 56, 254, 58, 254, 58, 254, 60, 254, 60, 254, 62, 254, 62, 254, 64, 254, 64, 254, 66, 254, 66, 254, 68, 254, 68, 254, 72, 254, 72, 254, 90, 254, 90, 254, 92, 254, 92, 254, 94, 254, 94, 254, 9, 255, 9, 255, 61, 255, 61, 255, 93, 255, 93, 255, 96, 255, 96, 255, 99, 255, 99, 255, 0, 0, 0, 0, 45, 0, 45, 0, 138, 5, 138, 5, 6, 24, 6, 24, 16, 32, 21, 32, 28, 48, 28, 48, 48, 48, 48, 48, 160, 48, 160, 48, 49, 254, 50, 254, 88, 254, 88, 254, 99, 254, 99, 254, 13, 255, 13, 255, 0, 0, 0, 0, 33, 0, 35, 0, 37, 0, 42, 0, 44, 0, 47, 0, 58, 0, 59, 0, 63, 0, 64, 0, 91, 0, 93, 0, 95, 0, 95, 0, 123, 0, 123, 0, 125, 0, 125, 0, 161, 0, 161, 0, 171, 0, 171, 0, 183, 0, 183, 0, 187, 0, 187, 0, 191, 0, 191, 0, 126, 3, 126, 3, 135, 3, 135, 3, 90, 5, 95, 5, 137, 5, 138, 5, 190, 5, 190, 5, 192, 5, 192, 5, 195, 5, 195, 5, 243, 5, 244, 5, 12, 6, 13, 6, 27, 6, 27, 6, 31, 6, 31, 6, 106, 6, 109, 6, 212, 6, 212, 6, 0, 7, 13, 7, 100, 9, 101, 9, 112, 9, 112, 9, 244, 13, 244, 13, 79, 14, 79, 14, 90, 14, 91, 14, 4, 15, 18, 15, 58, 15, 61, 15, 133, 15, 133, 15, 74, 16, 79, 16, 251, 16, 251, 16, 97, 19, 104, 19, 109, 22, 110, 22, 155, 22, 156, 22, 235, 22, 237, 22, 53, 23, 54, 23, 212, 23, 214, 23, 216, 23, 218, 23, 0, 24, 10, 24, 68, 25, 69, 25, 16, 32, 39, 32, 48, 32, 67, 32, 69, 32, 81, 32, 83, 32, 84, 32, 87, 32, 87, 32, 125, 32, 126, 32, 141, 32, 142, 32, 41, 35, 42, 35, 180, 35, 182, 35, 104, 39, 117, 39, 230, 39, 235, 39, 131, 41, 152, 41, 216, 41, 219, 41, 252, 41, 253, 41, 1, 48, 3, 48, 8, 48, 17, 48, 20, 48, 31, 48, 48, 48, 48, 48, 61, 48, 61, 48, 160, 48, 160, 48, 251, 48, 251, 48, 62, 253, 63, 253, 48, 254, 82, 254, 84, 254, 97, 254, 99, 254, 99, 254, 104, 254, 104, 254, 106, 254, 107, 254, 1, 255, 3, 255, 5, 255, 10, 255, 12, 255, 15, 255, 26, 255, 27, 255, 31, 255, 32, 255, 59, 255, 61, 255, 63, 255, 63, 255, 91, 255, 91, 255, 93, 255, 93, 255, 95, 255, 101, 255, 0, 1, 1, 0, 1, 1, 1, 0, 159, 3, 1, 0, 159, 3, 1, 0, 178, 0, 179, 0, 185, 0, 185, 0, 188, 0, 190, 0, 244, 9, 249, 9, 240, 11, 242, 11, 42, 15, 51, 15, 114, 19, 124, 19, 240, 23, 249, 23, 112, 32, 112, 32, 116, 32, 121, 32, 128, 32, 137, 32, 83, 33, 95, 33, 96, 36, 155, 36, 234, 36, 255, 36, 118, 39, 147, 39, 146, 49, 149, 49, 32, 50, 41, 50, 81, 50, 95, 50, 128, 50, 137, 50, 177, 50, 191, 50, 7, 1, 1, 0, 51, 1, 1, 0, 32, 3, 1, 0, 35, 3, 1, 0, 48, 0, 57, 0, 96, 6, 105, 6, 240, 6, 249, 6, 102, 9, 111, 9, 230, 9, 239, 9, 102, 10, 111, 10, 230, 10, 239, 10, 102, 11, 111, 11, 231, 11, 239, 11, 102, 12, 111, 12, 230, 12, 239, 12, 102, 13, 111, 13, 80, 14, 89, 14, 208, 14, 217, 14, 32, 15, 41, 15, 64, 16, 73, 16, 105, 19, 113, 19, 224, 23, 233, 23, 16, 24, 25, 24, 70, 25, 79, 25, 16, 255, 25, 255, 0, 0, 0, 0, 160, 4, 1, 0, 169, 4, 1, 0, 206, 215, 1, 0, 255, 215, 1, 0, 48, 0, 57, 0, 178, 0, 179, 0, 185, 0, 185, 0, 188, 0, 190, 0, 96, 6, 105, 6, 240, 6, 249, 6, 102, 9, 111, 9, 230, 9, 239, 9, 244, 9, 249, 9, 102, 10, 111, 10, 230, 10, 239, 10, 102, 11, 111, 11, 231, 11, 242, 11, 102, 12, 111, 12, 230, 12, 239, 12, 102, 13, 111, 13, 80, 14, 89, 14, 208, 14, 217, 14, 32, 15, 51, 15, 64, 16, 73, 16, 105, 19, 124, 19, 238, 22, 240, 22, 224, 23, 233, 23, 240, 23, 249, 23, 16, 24, 25, 24, 70, 25, 79, 25, 112, 32, 112, 32, 116, 32, 121, 32, 128, 32, 137, 32, 83, 33, 131, 33, 96, 36, 155, 36, 234, 36, 255, 36, 118, 39, 147, 39, 7, 48, 7, 48, 33, 48, 41, 48, 56, 48, 58, 48, 146, 49, 149, 49, 32, 50, 41, 50, 81, 50, 95, 50, 128, 50, 137, 50, 177, 50, 191, 50, 16, 255, 25, 255, 7, 1, 1, 0, 51, 1, 1, 0, 32, 3, 1, 0, 35, 3, 1, 0, 74, 3, 1, 0, 74, 3, 1, 0, 160, 4, 1, 0, 169, 4, 1, 0, 206, 215, 1, 0, 255, 215, 1, 0, 0, 3, 87, 3, 93, 3, 111, 3, 131, 4, 134, 4, 145, 5, 161, 5, 163, 5, 185, 5, 187, 5, 189, 5, 191, 5, 191, 5, 193, 5, 194, 5, 196, 5, 196, 5, 16, 6, 21, 6, 75, 6, 88, 6, 112, 6, 112, 6, 214, 6, 220, 6, 223, 6, 228, 6, 231, 6, 232, 6, 234, 6, 237, 6, 17, 7, 17, 7, 48, 7, 74, 7, 166, 7, 176, 7, 1, 9, 2, 9, 60, 9, 60, 9, 65, 9, 72, 9, 77, 9, 77, 9, 81, 9, 84, 9, 98, 9, 99, 9, 129, 9, 129, 9, 188, 9, 188, 9, 193, 9, 196, 9, 205, 9, 205, 9, 226, 9, 227, 9, 1, 10, 2, 10, 60, 10, 60, 10, 65, 10, 66, 10, 71, 10, 72, 10, 75, 10, 77, 10, 112, 10, 113, 10, 129, 10, 130, 10, 188, 10, 188, 10, 193, 10, 197, 10, 199, 10, 200, 10, 205, 10, 205, 10, 226, 10, 227, 10, 1, 11, 1, 11, 60, 11, 60, 11, 63, 11, 63, 11, 65, 11, 67, 11, 77, 11, 77, 11, 86, 11, 86, 11, 130, 11, 130, 11, 192, 11, 192, 11, 205, 11, 205, 11, 62, 12, 64, 12, 70, 12, 72, 12, 74, 12, 77, 12, 85, 12, 86, 12, 188, 12, 188, 12, 191, 12, 191, 12, 198, 12, 198, 12, 204, 12, 205, 12, 65, 13, 67, 13, 77, 13, 77, 13, 202, 13, 202, 13, 210, 13, 212, 13, 214, 13, 214, 13, 49, 14, 49, 14, 52, 14, 58, 14, 71, 14, 78, 14, 177, 14, 177, 14, 180, 14, 185, 14, 187, 14, 188, 14, 200, 14, 205, 14, 24, 15, 25, 15, 53, 15, 53, 15, 55, 15, 55, 15, 57, 15, 57, 15, 113, 15, 126, 15, 128, 15, 132, 15, 134, 15, 135, 15, 144, 15, 151, 15, 153, 15, 188, 15, 198, 15, 198, 15, 45, 16, 48, 16, 50, 16, 50, 16, 54, 16, 55, 16, 57, 16, 57, 16, 88, 16, 89, 16, 18, 23, 20, 23, 50, 23, 52, 23, 82, 23, 83, 23, 114, 23, 115, 23, 183, 23, 189, 23, 198, 23, 198, 23, 201, 23, 211, 23, 221, 23, 221, 23, 11, 24, 13, 24, 169, 24, 169, 24, 32, 25, 34, 25, 39, 25, 40, 25, 50, 25, 50, 25, 57, 25, 59, 25, 208, 32, 220, 32, 225, 32, 225, 32, 229, 32, 234, 32, 42, 48, 47, 48, 153, 48, 154, 48, 30, 251, 30, 251, 0, 254, 15, 254, 32, 254, 35, 254, 103, 209, 1, 0, 105, 209, 1, 0, 123, 209, 1, 0, 130, 209, 1, 0, 133, 209, 1, 0, 139, 209, 1, 0, 170, 209, 1, 0, 173, 209, 1, 0, 0, 1, 14, 0, 239, 1, 14, 0, 3, 9, 3, 9, 62, 9, 64, 9, 73, 9, 76, 9, 130, 9, 131, 9, 190, 9, 192, 9, 199, 9, 200, 9, 203, 9, 204, 9, 215, 9, 215, 9, 3, 10, 3, 10, 62, 10, 64, 10, 131, 10, 131, 10, 190, 10, 192, 10, 201, 10, 201, 10, 203, 10, 204, 10, 2, 11, 3, 11, 62, 11, 62, 11, 64, 11, 64, 11, 71, 11, 72, 11, 75, 11, 76, 11, 87, 11, 87, 11, 190, 11, 191, 11, 193, 11, 194, 11, 198, 11, 200, 11, 202, 11, 204, 11, 215, 11, 215, 11, 1, 12, 3, 12, 65, 12, 68, 12, 130, 12, 131, 12, 190, 12, 190, 12, 192, 12, 196, 12, 199, 12, 200, 12, 202, 12, 203, 12, 213, 12, 214, 12, 2, 13, 3, 13, 62, 13, 64, 13, 70, 13, 72, 13, 74, 13, 76, 13, 87, 13, 87, 13, 130, 13, 131, 13, 207, 13, 209, 13, 216, 13, 223, 13, 242, 13, 243, 13, 62, 15, 63, 15, 127, 15, 127, 15, 44, 16, 44, 16, 49, 16, 49, 16, 56, 16, 56, 16, 86, 16, 87, 16, 182, 23, 182, 23, 190, 23, 197, 23, 199, 23, 200, 23, 35, 25, 38, 25, 41, 25, 43, 25, 48, 25, 49, 25, 51, 25, 56, 25, 0, 0, 0, 0, 101, 209, 1, 0, 102, 209, 1, 0, 109, 209, 1, 0, 114, 209, 1, 0, 0, 3, 87, 3, 93, 3, 111, 3, 131, 4, 134, 4, 136, 4, 137, 4, 145, 5, 161, 5, 163, 5, 185, 5, 187, 5, 189, 5, 191, 5, 191, 5, 193, 5, 194, 5, 196, 5, 196, 5, 16, 6, 21, 6, 75, 6, 88, 6, 112, 6, 112, 6, 214, 6, 220, 6, 222, 6, 228, 6, 231, 6, 232, 6, 234, 6, 237, 6, 17, 7, 17, 7, 48, 7, 74, 7, 166, 7, 176, 7, 1, 9, 3, 9, 60, 9, 60, 9, 62, 9, 77, 9, 81, 9, 84, 9, 98, 9, 99, 9, 129, 9, 131, 9, 188, 9, 188, 9, 190, 9, 196, 9, 199, 9, 200, 9, 203, 9, 205, 9, 215, 9, 215, 9, 226, 9, 227, 9, 1, 10, 3, 10, 60, 10, 60, 10, 62, 10, 66, 10, 71, 10, 72, 10, 75, 10, 77, 10, 112, 10, 113, 10, 129, 10, 131, 10, 188, 10, 188, 10], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 166768);
	        allocate([190, 10, 197, 10, 199, 10, 201, 10, 203, 10, 205, 10, 226, 10, 227, 10, 1, 11, 3, 11, 60, 11, 60, 11, 62, 11, 67, 11, 71, 11, 72, 11, 75, 11, 77, 11, 86, 11, 87, 11, 130, 11, 130, 11, 190, 11, 194, 11, 198, 11, 200, 11, 202, 11, 205, 11, 215, 11, 215, 11, 1, 12, 3, 12, 62, 12, 68, 12, 70, 12, 72, 12, 74, 12, 77, 12, 85, 12, 86, 12, 130, 12, 131, 12, 188, 12, 188, 12, 190, 12, 196, 12, 198, 12, 200, 12, 202, 12, 205, 12, 213, 12, 214, 12, 2, 13, 3, 13, 62, 13, 67, 13, 70, 13, 72, 13, 74, 13, 77, 13, 87, 13, 87, 13, 130, 13, 131, 13, 202, 13, 202, 13, 207, 13, 212, 13, 214, 13, 214, 13, 216, 13, 223, 13, 242, 13, 243, 13, 49, 14, 49, 14, 52, 14, 58, 14, 71, 14, 78, 14, 177, 14, 177, 14, 180, 14, 185, 14, 187, 14, 188, 14, 200, 14, 205, 14, 24, 15, 25, 15, 53, 15, 53, 15, 55, 15, 55, 15, 57, 15, 57, 15, 62, 15, 63, 15, 113, 15, 132, 15, 134, 15, 135, 15, 144, 15, 151, 15, 153, 15, 188, 15, 198, 15, 198, 15, 44, 16, 50, 16, 54, 16, 57, 16, 86, 16, 89, 16, 18, 23, 20, 23, 50, 23, 52, 23, 82, 23, 83, 23, 114, 23, 115, 23, 182, 23, 211, 23, 221, 23, 221, 23, 11, 24, 13, 24, 169, 24, 169, 24, 32, 25, 43, 25, 48, 25, 59, 25, 208, 32, 234, 32, 42, 48, 47, 48, 153, 48, 154, 48, 30, 251, 30, 251, 0, 254, 15, 254, 32, 254, 35, 254, 0, 0, 0, 0, 101, 209, 1, 0, 105, 209, 1, 0, 109, 209, 1, 0, 114, 209, 1, 0, 123, 209, 1, 0, 130, 209, 1, 0, 133, 209, 1, 0, 139, 209, 1, 0, 170, 209, 1, 0, 173, 209, 1, 0, 0, 1, 14, 0, 239, 1, 14, 0, 65, 0, 90, 0, 192, 0, 214, 0, 216, 0, 222, 0, 0, 1, 0, 1, 2, 1, 2, 1, 4, 1, 4, 1, 6, 1, 6, 1, 8, 1, 8, 1, 10, 1, 10, 1, 12, 1, 12, 1, 14, 1, 14, 1, 16, 1, 16, 1, 18, 1, 18, 1, 20, 1, 20, 1, 22, 1, 22, 1, 24, 1, 24, 1, 26, 1, 26, 1, 28, 1, 28, 1, 30, 1, 30, 1, 32, 1, 32, 1, 34, 1, 34, 1, 36, 1, 36, 1, 38, 1, 38, 1, 40, 1, 40, 1, 42, 1, 42, 1, 44, 1, 44, 1, 46, 1, 46, 1, 48, 1, 48, 1, 50, 1, 50, 1, 52, 1, 52, 1, 54, 1, 54, 1, 57, 1, 57, 1, 59, 1, 59, 1, 61, 1, 61, 1, 63, 1, 63, 1, 65, 1, 65, 1, 67, 1, 67, 1, 69, 1, 69, 1, 71, 1, 71, 1, 74, 1, 74, 1, 76, 1, 76, 1, 78, 1, 78, 1, 80, 1, 80, 1, 82, 1, 82, 1, 84, 1, 84, 1, 86, 1, 86, 1, 88, 1, 88, 1, 90, 1, 90, 1, 92, 1, 92, 1, 94, 1, 94, 1, 96, 1, 96, 1, 98, 1, 98, 1, 100, 1, 100, 1, 102, 1, 102, 1, 104, 1, 104, 1, 106, 1, 106, 1, 108, 1, 108, 1, 110, 1, 110, 1, 112, 1, 112, 1, 114, 1, 114, 1, 116, 1, 116, 1, 118, 1, 118, 1, 120, 1, 121, 1, 123, 1, 123, 1, 125, 1, 125, 1, 129, 1, 130, 1, 132, 1, 132, 1, 134, 1, 135, 1, 137, 1, 139, 1, 142, 1, 145, 1, 147, 1, 148, 1, 150, 1, 152, 1, 156, 1, 157, 1, 159, 1, 160, 1, 162, 1, 162, 1, 164, 1, 164, 1, 166, 1, 167, 1, 169, 1, 169, 1, 172, 1, 172, 1, 174, 1, 175, 1, 177, 1, 179, 1, 181, 1, 181, 1, 183, 1, 184, 1, 188, 1, 188, 1, 196, 1, 196, 1, 199, 1, 199, 1, 202, 1, 202, 1, 205, 1, 205, 1, 207, 1, 207, 1, 209, 1, 209, 1, 211, 1, 211, 1, 213, 1, 213, 1, 215, 1, 215, 1, 217, 1, 217, 1, 219, 1, 219, 1, 222, 1, 222, 1, 224, 1, 224, 1, 226, 1, 226, 1, 228, 1, 228, 1, 230, 1, 230, 1, 232, 1, 232, 1, 234, 1, 234, 1, 236, 1, 236, 1, 238, 1, 238, 1, 241, 1, 241, 1, 244, 1, 244, 1, 246, 1, 248, 1, 250, 1, 250, 1, 252, 1, 252, 1, 254, 1, 254, 1, 0, 2, 0, 2, 2, 2, 2, 2, 4, 2, 4, 2, 6, 2, 6, 2, 8, 2, 8, 2, 10, 2, 10, 2, 12, 2, 12, 2, 14, 2, 14, 2, 16, 2, 16, 2, 18, 2, 18, 2, 20, 2, 20, 2, 22, 2, 22, 2, 24, 2, 24, 2, 26, 2, 26, 2, 28, 2, 28, 2, 30, 2, 30, 2, 32, 2, 32, 2, 34, 2, 34, 2, 36, 2, 36, 2, 38, 2, 38, 2, 40, 2, 40, 2, 42, 2, 42, 2, 44, 2, 44, 2, 46, 2, 46, 2, 48, 2, 48, 2, 50, 2, 50, 2, 134, 3, 134, 3, 136, 3, 138, 3, 140, 3, 140, 3, 142, 3, 143, 3, 145, 3, 161, 3, 163, 3, 171, 3, 210, 3, 212, 3, 216, 3, 216, 3, 218, 3, 218, 3, 220, 3, 220, 3, 222, 3, 222, 3, 224, 3, 224, 3, 226, 3, 226, 3, 228, 3, 228, 3, 230, 3, 230, 3, 232, 3, 232, 3, 234, 3, 234, 3, 236, 3, 236, 3, 238, 3, 238, 3, 244, 3, 244, 3, 247, 3, 247, 3, 249, 3, 250, 3, 0, 4, 47, 4, 96, 4, 96, 4, 98, 4, 98, 4, 100, 4, 100, 4, 102, 4, 102, 4, 104, 4, 104, 4, 106, 4, 106, 4, 108, 4, 108, 4, 110, 4, 110, 4, 112, 4, 112, 4, 114, 4, 114, 4, 116, 4, 116, 4, 118, 4, 118, 4, 120, 4, 120, 4, 122, 4, 122, 4, 124, 4, 124, 4, 126, 4, 126, 4, 128, 4, 128, 4, 138, 4, 138, 4, 140, 4, 140, 4, 142, 4, 142, 4, 144, 4, 144, 4, 146, 4, 146, 4, 148, 4, 148, 4, 150, 4, 150, 4, 152, 4, 152, 4, 154, 4, 154, 4, 156, 4, 156, 4, 158, 4, 158, 4, 160, 4, 160, 4, 162, 4, 162, 4, 164, 4, 164, 4, 166, 4, 166, 4, 168, 4, 168, 4, 170, 4, 170, 4, 172, 4, 172, 4, 174, 4, 174, 4, 176, 4, 176, 4, 178, 4, 178, 4, 180, 4, 180, 4, 182, 4, 182, 4, 184, 4, 184, 4, 186, 4, 186, 4, 188, 4, 188, 4, 190, 4, 190, 4, 192, 4, 193, 4, 195, 4, 195, 4, 197, 4, 197, 4, 199, 4, 199, 4, 201, 4, 201, 4, 203, 4, 203, 4, 205, 4, 205, 4, 208, 4, 208, 4, 210, 4, 210, 4, 212, 4, 212, 4, 214, 4, 214, 4, 216, 4, 216, 4, 218, 4, 218, 4, 220, 4, 220, 4, 222, 4, 222, 4, 224, 4, 224, 4, 226, 4, 226, 4, 228, 4, 228, 4, 230, 4, 230, 4, 232, 4, 232, 4, 234, 4, 234, 4, 236, 4, 236, 4, 238, 4, 238, 4, 240, 4, 240, 4, 242, 4, 242, 4, 244, 4, 244, 4, 248, 4, 248, 4, 0, 5, 0, 5, 2, 5, 2, 5, 4, 5, 4, 5, 6, 5, 6, 5, 8, 5, 8, 5, 10, 5, 10, 5, 12, 5, 12, 5, 14, 5, 14, 5, 49, 5, 86, 5, 160, 16, 197, 16, 0, 30, 0, 30, 2, 30, 2, 30, 4, 30, 4, 30, 6, 30, 6, 30, 8, 30, 8, 30, 10, 30, 10, 30, 12, 30, 12, 30, 14, 30, 14, 30, 16, 30, 16, 30, 18, 30, 18, 30, 20, 30, 20, 30, 22, 30, 22, 30, 24, 30, 24, 30, 26, 30, 26, 30, 28, 30, 28, 30, 30, 30, 30, 30, 32, 30, 32, 30, 34, 30, 34, 30, 36, 30, 36, 30, 38, 30, 38, 30, 40, 30, 40, 30, 42, 30, 42, 30, 44, 30, 44, 30, 46, 30, 46, 30, 48, 30, 48, 30, 50, 30, 50, 30, 52, 30, 52, 30, 54, 30, 54, 30, 56, 30, 56, 30, 58, 30, 58, 30, 60, 30, 60, 30, 62, 30, 62, 30, 64, 30, 64, 30, 66, 30, 66, 30, 68, 30, 68, 30, 70, 30, 70, 30, 72, 30, 72, 30, 74, 30, 74, 30, 76, 30, 76, 30, 78, 30, 78, 30, 80, 30, 80, 30, 82, 30, 82, 30, 84, 30, 84, 30, 86, 30, 86, 30, 88, 30, 88, 30, 90, 30, 90, 30, 92, 30, 92, 30, 94, 30, 94, 30, 96, 30, 96, 30, 98, 30, 98, 30, 100, 30, 100, 30, 102, 30, 102, 30, 104, 30, 104, 30, 106, 30, 106, 30, 108, 30, 108, 30, 110, 30, 110, 30, 112, 30, 112, 30, 114, 30, 114, 30, 116, 30, 116, 30, 118, 30, 118, 30, 120, 30, 120, 30, 122, 30, 122, 30, 124, 30, 124, 30, 126, 30, 126, 30, 128, 30, 128, 30, 130, 30, 130, 30, 132, 30, 132, 30, 134, 30, 134, 30, 136, 30, 136, 30, 138, 30, 138, 30, 140, 30, 140, 30, 142, 30, 142, 30, 144, 30, 144, 30, 146, 30, 146, 30, 148, 30, 148, 30, 160, 30, 160, 30, 162, 30, 162, 30, 164, 30, 164, 30, 166, 30, 166, 30, 168, 30, 168, 30, 170, 30, 170, 30, 172, 30, 172, 30, 174, 30, 174, 30, 176, 30, 176, 30, 178, 30, 178, 30, 180, 30, 180, 30, 182, 30, 182, 30, 184, 30, 184, 30, 186, 30, 186, 30, 188, 30, 188, 30, 190, 30, 190, 30, 192, 30, 192, 30, 194, 30, 194, 30, 196, 30, 196, 30, 198, 30, 198, 30, 200, 30, 200, 30, 202, 30, 202, 30, 204, 30, 204, 30, 206, 30, 206, 30, 208, 30, 208, 30, 210, 30, 210, 30, 212, 30, 212, 30, 214, 30, 214, 30, 216, 30, 216, 30, 218, 30, 218, 30, 220, 30, 220, 30, 222, 30, 222, 30, 224, 30, 224, 30, 226, 30, 226, 30, 228, 30, 228, 30, 230, 30, 230, 30, 232, 30, 232, 30, 234, 30, 234, 30, 236, 30, 236, 30, 238, 30, 238, 30, 240, 30, 240, 30, 242, 30, 242, 30, 244, 30, 244, 30, 246, 30, 246, 30, 248, 30, 248, 30, 8, 31, 15, 31, 24, 31, 29, 31, 40, 31, 47, 31, 56, 31, 63, 31, 72, 31, 77, 31, 89, 31, 89, 31, 91, 31, 91, 31, 93, 31, 93, 31, 95, 31, 95, 31, 104, 31, 111, 31, 184, 31, 187, 31, 200, 31, 203, 31, 216, 31, 219, 31, 232, 31, 236, 31, 248, 31, 251, 31, 2, 33, 2, 33, 7, 33, 7, 33, 11, 33, 13, 33, 16, 33, 18, 33, 21, 33, 21, 33, 25, 33, 29, 33, 36, 33, 36, 33, 38, 33, 38, 33, 40, 33, 40, 33, 42, 33, 45, 33, 48, 33, 49, 33, 51, 33, 51, 33, 62, 33, 63, 33, 69, 33, 69, 33, 33, 255, 58, 255, 0, 4, 1, 0, 39, 4, 1, 0, 0, 212, 1, 0, 25, 212, 1, 0, 52, 212, 1, 0, 77, 212, 1, 0, 104, 212, 1, 0, 129, 212, 1, 0, 156, 212, 1, 0, 156, 212, 1, 0, 158, 212, 1, 0, 159, 212, 1, 0, 162, 212, 1, 0, 162, 212, 1, 0, 165, 212, 1, 0, 166, 212, 1, 0, 169, 212, 1, 0, 172, 212, 1, 0, 174, 212, 1, 0, 181, 212, 1, 0, 208, 212, 1, 0, 233, 212, 1, 0, 4, 213, 1, 0, 5, 213, 1, 0, 7, 213, 1, 0, 10, 213, 1, 0, 13, 213, 1, 0, 20, 213, 1, 0, 22, 213, 1, 0, 28, 213, 1, 0, 56, 213, 1, 0, 57, 213, 1, 0, 59, 213, 1, 0, 62, 213, 1, 0, 64, 213, 1, 0, 68, 213, 1, 0, 70, 213, 1, 0, 70, 213, 1, 0, 74, 213, 1, 0, 80, 213, 1, 0, 108, 213, 1, 0, 133, 213, 1, 0, 160, 213, 1, 0, 185, 213, 1, 0, 212, 213, 1, 0, 237, 213, 1, 0, 8, 214, 1, 0, 33, 214, 1, 0, 60, 214, 1, 0, 85, 214, 1, 0, 112, 214, 1, 0, 137, 214, 1, 0, 168, 214, 1, 0, 192, 214, 1, 0, 226, 214, 1, 0, 250, 214, 1, 0, 28, 215, 1, 0, 52, 215, 1, 0, 86, 215, 1, 0, 110, 215, 1, 0, 144, 215, 1, 0, 168, 215, 1, 0, 197, 1, 197, 1, 200, 1, 200, 1, 203, 1, 203, 1, 242, 1, 242, 1, 136, 31, 143, 31, 152, 31, 159, 31, 168, 31, 175, 31, 188, 31, 188, 31, 204, 31, 204, 31, 252, 31, 252, 31, 187, 1, 187, 1, 192, 1, 195, 1, 208, 5, 234, 5, 240, 5, 242, 5, 33, 6, 58, 6, 65, 6, 74, 6, 110, 6, 111, 6, 113, 6, 211, 6, 213, 6, 213, 6, 238, 6, 239, 6, 250, 6, 252, 6, 255, 6, 255, 6, 16, 7, 16, 7, 18, 7, 47, 7, 77, 7, 79, 7, 128, 7, 165, 7, 177, 7, 177, 7, 4, 9, 57, 9, 61, 9, 61, 9, 80, 9, 80, 9, 88, 9, 97, 9, 133, 9, 140, 9, 143, 9, 144, 9, 147, 9, 168, 9, 170, 9, 176, 9, 178, 9, 178, 9, 182, 9, 185, 9, 189, 9, 189, 9, 220, 9, 221, 9, 223, 9, 225, 9, 240, 9, 241, 9, 5, 10, 10, 10, 15, 10, 16, 10, 19, 10, 40, 10, 42, 10, 48, 10, 50, 10, 51, 10, 53, 10, 54, 10, 56, 10, 57, 10, 89, 10, 92, 10, 94, 10, 94, 10, 114, 10, 116, 10, 133, 10, 141, 10, 143, 10, 145, 10, 147, 10, 168, 10, 170, 10, 176, 10, 178, 10, 179, 10, 181, 10, 185, 10, 189, 10, 189, 10, 208, 10, 208, 10, 224, 10, 225, 10, 5, 11, 12, 11, 15, 11, 16, 11, 19, 11, 40, 11, 42, 11, 48, 11, 50, 11, 51, 11, 53, 11, 57, 11, 61, 11, 61, 11, 92, 11, 93, 11, 95, 11, 97, 11, 113, 11, 113, 11, 131, 11, 131, 11, 133, 11, 138, 11, 142, 11, 144, 11, 146, 11, 149, 11, 153, 11, 154, 11, 156, 11, 156, 11, 158, 11, 159, 11, 163, 11, 164, 11, 168, 11, 170, 11, 174, 11, 181, 11, 183, 11, 185, 11, 5, 12, 12, 12, 14, 12, 16, 12, 18, 12, 40, 12, 42, 12, 51, 12, 53, 12, 57, 12, 96, 12, 97, 12, 133, 12, 140, 12, 142, 12, 144, 12, 146, 12, 168, 12, 170, 12, 179, 12, 181, 12, 185, 12, 189, 12, 189, 12, 222, 12, 222, 12, 224, 12, 225, 12, 5, 13, 12, 13, 14, 13, 16, 13, 18, 13, 40, 13, 42, 13, 57, 13, 96, 13, 97, 13, 133, 13, 150, 13, 154, 13, 177, 13, 179, 13, 187, 13, 189, 13, 189, 13, 192, 13, 198, 13, 1, 14, 48, 14, 50, 14, 51, 14, 64, 14, 69, 14, 129, 14, 130, 14, 132, 14, 132, 14, 135, 14, 136, 14, 138, 14, 138, 14, 141, 14, 141, 14, 148, 14, 151, 14, 153, 14, 159, 14, 161, 14, 163, 14, 165, 14, 165, 14, 167, 14, 167, 14, 170, 14, 171, 14, 173, 14, 176, 14, 178, 14, 179, 14, 189, 14, 189, 14, 192, 14, 196, 14, 220, 14, 221, 14, 0, 15, 0, 15, 64, 15, 71, 15, 73, 15, 106, 15, 136, 15, 139, 15, 0, 16, 33, 16, 35, 16, 39, 16, 41, 16, 42, 16, 80, 16, 85, 16, 208, 16, 248, 16, 0, 17, 89, 17, 95, 17, 162, 17, 168, 17, 249, 17, 0, 18, 6, 18, 8, 18, 70, 18, 72, 18, 72, 18, 74, 18, 77, 18, 80, 18, 86, 18, 88, 18, 88, 18, 90, 18, 93, 18, 96, 18, 134, 18, 136, 18, 136, 18, 138, 18, 141, 18, 144, 18, 174, 18, 176, 18, 176, 18, 178, 18, 181, 18, 184, 18, 190, 18, 192, 18, 192, 18, 194, 18, 197, 18, 200, 18, 206, 18, 208, 18, 214, 18, 216, 18, 238, 18, 240, 18, 14, 19, 16, 19, 16, 19, 18, 19, 21, 19, 24, 19, 30, 19, 32, 19, 70, 19, 72, 19, 90, 19, 160, 19, 244, 19, 1, 20, 108, 22, 111, 22, 118, 22, 129, 22, 154, 22, 160, 22, 234, 22, 0, 23, 12, 23, 14, 23, 17, 23, 32, 23, 49, 23, 64, 23, 81, 23, 96, 23, 108, 23, 110, 23, 112, 23, 128, 23, 179, 23, 220, 23, 220, 23, 32, 24, 66, 24, 68, 24, 119, 24, 128, 24, 168, 24, 0, 25, 28, 25, 80, 25, 109, 25, 112, 25, 116, 25, 53, 33, 56, 33, 6, 48, 6, 48, 60, 48, 60, 48, 65, 48, 150, 48, 159, 48, 159, 48, 161, 48, 250, 48, 255, 48, 255, 48, 5, 49, 44, 49, 49, 49, 142, 49, 160, 49, 183, 49, 240, 49, 255, 49, 0, 52, 0, 52, 181, 77, 181, 77, 0, 78, 0, 78, 165, 159, 165, 159, 0, 160, 140, 164, 0, 172, 0, 172, 163, 215, 163, 215, 0, 249, 45, 250, 48, 250, 106, 250, 29, 251, 29, 251, 31, 251, 40, 251, 42, 251, 54, 251, 56, 251, 60, 251, 62, 251, 62, 251, 64, 251, 65, 251, 67, 251, 68, 251, 70, 251, 177, 251, 211, 251, 61, 253, 80, 253, 143, 253, 146, 253, 199, 253, 240, 253, 251, 253, 112, 254, 116, 254, 118, 254, 252, 254, 102, 255, 111, 255, 113, 255, 157, 255, 160, 255, 190, 255, 194, 255, 199, 255, 202, 255, 207, 255, 210, 255, 215, 255, 218, 255, 220, 255, 0, 0, 0, 0, 0, 0, 1, 0, 11, 0, 1, 0, 13, 0, 1, 0, 38, 0, 1, 0, 40, 0, 1, 0, 58, 0, 1, 0, 60, 0, 1, 0, 61, 0, 1, 0, 63, 0, 1, 0, 77, 0, 1, 0, 80, 0, 1, 0, 93, 0, 1, 0, 128, 0, 1, 0, 250, 0, 1, 0, 0, 3, 1, 0, 30, 3, 1, 0, 48, 3, 1, 0, 73, 3, 1, 0, 128, 3, 1, 0, 157, 3, 1, 0, 80, 4, 1, 0, 157, 4, 1, 0, 0, 8, 1, 0, 5, 8, 1, 0, 8, 8, 1, 0, 8, 8, 1, 0, 10, 8, 1, 0, 53, 8, 1, 0, 55, 8, 1, 0, 56, 8, 1, 0, 60, 8, 1, 0, 60, 8, 1, 0, 63, 8, 1, 0, 63, 8, 1, 0, 0, 0, 2, 0, 0, 0, 2, 0, 214, 166, 2, 0, 214, 166, 2, 0, 0, 248, 2, 0, 29, 250, 2, 0, 176, 2, 193, 2, 198, 2, 209, 2, 224, 2, 228, 2, 238, 2, 238, 2, 122, 3, 122, 3, 89, 5, 89, 5, 64, 6, 64, 6, 229, 6, 230, 6, 70, 14, 70, 14, 198, 14, 198, 14, 215, 23, 215, 23, 67, 24, 67, 24, 44, 29, 97, 29, 5, 48, 5, 48, 49, 48, 53, 48, 59, 48, 59, 48, 157, 48, 158, 48, 252, 48, 254, 48, 112, 255, 112, 255, 158, 255, 159, 255, 97, 0, 122, 0, 170, 0, 170, 0, 181, 0, 181, 0, 186, 0, 186, 0, 223, 0, 246, 0, 248, 0, 255, 0, 1, 1, 1, 1, 3, 1, 3, 1, 5, 1, 5, 1, 7, 1, 7, 1, 9, 1, 9, 1, 11, 1, 11, 1, 13, 1, 13, 1, 15, 1, 15, 1, 17, 1, 17, 1, 19, 1, 19, 1, 21, 1, 21, 1, 23, 1, 23, 1, 25, 1, 25, 1, 27, 1, 27, 1, 29, 1, 29, 1, 31, 1, 31, 1, 33, 1, 33, 1, 35, 1, 35, 1, 37, 1, 37, 1, 39, 1, 39, 1, 41, 1, 41, 1, 43, 1, 43, 1, 45, 1, 45, 1, 47, 1, 47, 1, 49, 1, 49, 1, 51, 1, 51, 1, 53, 1, 53, 1, 55, 1, 56, 1, 58, 1, 58, 1, 60, 1, 60, 1, 62, 1, 62, 1, 64, 1, 64, 1, 66, 1, 66, 1, 68, 1, 68, 1, 70, 1, 70, 1, 72, 1, 73, 1, 75, 1, 75, 1, 77, 1, 77, 1, 79, 1, 79, 1, 81, 1, 81, 1, 83, 1, 83, 1, 85, 1, 85, 1, 87, 1, 87, 1, 89, 1, 89, 1, 91, 1, 91, 1, 93, 1, 93, 1, 95, 1, 95, 1, 97, 1, 97, 1, 99, 1, 99, 1, 101, 1, 101, 1, 103, 1, 103, 1, 105, 1, 105, 1, 107, 1, 107, 1, 109, 1, 109, 1, 111, 1, 111, 1, 113, 1, 113, 1, 115, 1, 115, 1, 117, 1, 117, 1, 119, 1, 119, 1, 122, 1, 122, 1, 124, 1, 124, 1, 126, 1, 128, 1, 131, 1, 131, 1, 133, 1, 133, 1, 136, 1, 136, 1, 140, 1, 141, 1, 146, 1, 146, 1, 149, 1, 149, 1, 153, 1, 155, 1, 158, 1, 158, 1, 161, 1, 161, 1, 163, 1, 163, 1, 165, 1, 165, 1, 168, 1, 168, 1, 170, 1, 171, 1, 173, 1, 173, 1, 176, 1, 176, 1, 180, 1, 180, 1, 182, 1, 182, 1, 185, 1, 186, 1, 189, 1, 191, 1, 198, 1, 198, 1, 201, 1, 201, 1, 204, 1, 204, 1, 206, 1, 206, 1, 208, 1, 208, 1, 210, 1, 210, 1, 212, 1, 212, 1, 214, 1, 214, 1, 216, 1, 216, 1, 218, 1, 218, 1, 220, 1, 221, 1, 223, 1, 223, 1, 225, 1, 225, 1, 227, 1, 227, 1, 229, 1, 229, 1, 231, 1, 231, 1, 233, 1, 233, 1, 235, 1, 235, 1, 237, 1, 237, 1, 239, 1, 240, 1, 243, 1, 243, 1, 245, 1, 245, 1, 249, 1, 249, 1, 251, 1, 251, 1, 253, 1, 253, 1, 255, 1, 255, 1, 1, 2, 1, 2, 3, 2, 3, 2, 5, 2, 5, 2, 7, 2, 7, 2, 9, 2, 9, 2, 11, 2, 11, 2, 13, 2, 13, 2, 15, 2, 15, 2, 17, 2, 17, 2, 19, 2, 19, 2, 21, 2, 21, 2, 23, 2, 23, 2, 25, 2, 25, 2, 27, 2, 27, 2, 29, 2, 29, 2, 31, 2, 31, 2, 33, 2, 33, 2, 35, 2, 35, 2, 37, 2, 37, 2, 39, 2, 39, 2, 41, 2, 41, 2, 43, 2, 43, 2, 45, 2, 45, 2, 47, 2, 47, 2, 49, 2, 49, 2, 51, 2, 54, 2, 80, 2, 175, 2, 144, 3, 144, 3, 172, 3, 206, 3, 208, 3, 209, 3, 213, 3, 215, 3, 217, 3, 217, 3, 219, 3, 219, 3, 221, 3, 221, 3, 223, 3, 223, 3, 225, 3, 225, 3, 227, 3, 227, 3, 229, 3, 229, 3, 231, 3, 231, 3, 233, 3, 233, 3, 235, 3, 235, 3, 237, 3, 237, 3, 239, 3, 243, 3, 245, 3, 245, 3, 248, 3, 248, 3, 251, 3, 251, 3, 48, 4, 95, 4, 97, 4, 97, 4, 99, 4, 99, 4, 101, 4, 101, 4, 103, 4, 103, 4, 105, 4, 105, 4, 107, 4, 107, 4, 109, 4, 109, 4, 111, 4, 111, 4, 113, 4, 113, 4, 115, 4, 115, 4, 117, 4, 117, 4, 119, 4, 119, 4, 121, 4, 121, 4, 123, 4, 123, 4, 125, 4, 125, 4, 127, 4, 127, 4, 129, 4, 129, 4, 139, 4, 139, 4, 141, 4, 141, 4, 143, 4, 143, 4, 145, 4, 145, 4, 147, 4, 147, 4, 149, 4, 149, 4, 151, 4, 151, 4, 153, 4, 153, 4, 155, 4, 155, 4, 157, 4, 157, 4, 159, 4, 159, 4, 161, 4, 161, 4, 163, 4, 163, 4, 165, 4, 165, 4, 167, 4, 167, 4, 169, 4, 169, 4, 171, 4, 171, 4, 173, 4, 173, 4, 175, 4, 175, 4, 177, 4, 177, 4, 179, 4, 179, 4, 181, 4, 181, 4, 183, 4, 183, 4, 185, 4, 185, 4, 187, 4, 187, 4, 189, 4, 189, 4, 191, 4, 191, 4, 194, 4, 194, 4, 196, 4, 196, 4, 198, 4, 198, 4, 200, 4, 200, 4, 202, 4, 202, 4, 204, 4, 204, 4, 206, 4, 206, 4, 209, 4, 209, 4, 211, 4, 211, 4, 213, 4, 213, 4, 215, 4, 215, 4, 217, 4, 217, 4, 219, 4, 219, 4, 221, 4, 221, 4, 223, 4, 223, 4, 225, 4, 225, 4, 227, 4, 227, 4, 229, 4, 229, 4, 231, 4, 231, 4, 233, 4, 233, 4, 235, 4, 235, 4, 237, 4, 237, 4, 239, 4, 239, 4, 241, 4, 241, 4, 243, 4, 243, 4, 245, 4, 245, 4, 249, 4, 249, 4, 1, 5, 1, 5, 3, 5, 3, 5, 5, 5, 5, 5, 7, 5, 7, 5, 9, 5, 9, 5, 11, 5, 11, 5, 13, 5, 13, 5, 15, 5, 15, 5, 97, 5, 135, 5, 0, 29, 43, 29, 98, 29, 107, 29, 1, 30, 1, 30, 3, 30, 3, 30, 5, 30, 5, 30, 7, 30, 7, 30, 9, 30, 9, 30, 11, 30, 11, 30, 13, 30, 13, 30, 15, 30, 15, 30, 17, 30, 17, 30, 19, 30, 19, 30, 21, 30, 21, 30, 23, 30, 23, 30, 25, 30, 25, 30, 27, 30, 27, 30, 29, 30, 29, 30, 31, 30, 31, 30, 33, 30, 33, 30, 35, 30, 35, 30, 37, 30, 37, 30, 39, 30, 39, 30, 41, 30, 41, 30, 43, 30, 43, 30, 45, 30, 45, 30, 47, 30, 47, 30, 49, 30, 49, 30, 51, 30, 51, 30, 53, 30, 53, 30, 55, 30, 55, 30, 57, 30, 57, 30, 59, 30, 59, 30, 61, 30, 61, 30, 63, 30, 63, 30, 65, 30, 65, 30, 67, 30, 67, 30, 69, 30, 69, 30, 71, 30, 71, 30, 73, 30, 73, 30, 75, 30, 75, 30, 77, 30, 77, 30, 79, 30, 79, 30, 81, 30, 81, 30, 83, 30, 83, 30, 85, 30, 85, 30, 87, 30, 87, 30, 89, 30, 89, 30, 91, 30, 91, 30, 93, 30, 93, 30, 95, 30, 95, 30, 97, 30, 97, 30, 99, 30, 99, 30, 101, 30, 101, 30, 103, 30, 103, 30, 105, 30, 105, 30, 107, 30, 107, 30, 109, 30, 109, 30, 111, 30, 111, 30, 113, 30, 113, 30, 115, 30, 115, 30, 117, 30, 117, 30, 119, 30, 119, 30, 121, 30, 121, 30, 123, 30, 123, 30, 125, 30, 125, 30, 127, 30, 127, 30, 129, 30, 129, 30, 131, 30, 131, 30, 133, 30, 133, 30, 135, 30, 135, 30, 137, 30, 137, 30, 139, 30, 139, 30, 141, 30, 141, 30, 143, 30, 143, 30, 145, 30, 145, 30, 147, 30, 147, 30, 149, 30, 155, 30, 161, 30, 161, 30, 163, 30, 163, 30, 165, 30, 165, 30, 167, 30, 167, 30, 169, 30, 169, 30, 171, 30, 171, 30, 173, 30, 173, 30, 175, 30, 175, 30, 177, 30, 177, 30, 179, 30, 179, 30, 181, 30, 181, 30, 183, 30, 183, 30, 185, 30, 185, 30, 187, 30, 187, 30, 189, 30, 189, 30, 191, 30, 191, 30, 193, 30, 193, 30, 195, 30, 195, 30, 197, 30, 197, 30, 199, 30, 199, 30, 201, 30, 201, 30, 203, 30, 203, 30, 205, 30, 205, 30, 207, 30, 207, 30, 209, 30, 209, 30, 211, 30, 211, 30, 213, 30, 213, 30, 215, 30, 215, 30, 217, 30, 217, 30, 219, 30, 219, 30, 221, 30, 221, 30, 223, 30, 223, 30, 225, 30, 225, 30, 227, 30, 227, 30, 229, 30, 229, 30, 231, 30, 231, 30, 233, 30, 233, 30, 235, 30, 235, 30, 237, 30, 237, 30, 239, 30, 239, 30, 241, 30, 241, 30, 243, 30, 243, 30, 245, 30, 245, 30, 247, 30, 247, 30, 249, 30, 249, 30, 0, 31, 7, 31, 16, 31, 21, 31, 32, 31, 39, 31, 48, 31, 55, 31, 64, 31, 69, 31, 80, 31, 87, 31, 96, 31, 103, 31, 112, 31, 125, 31, 128, 31, 135, 31, 144, 31, 151, 31, 160, 31, 167, 31, 176, 31, 180, 31, 182, 31, 183, 31, 190, 31, 190, 31, 194, 31, 196, 31, 198, 31, 199, 31, 208, 31, 211, 31, 214, 31, 215, 31, 224, 31, 231, 31, 242, 31, 244, 31, 246, 31, 247, 31, 113, 32, 113, 32, 127, 32, 127, 32, 10, 33, 10, 33, 14, 33, 15, 33, 19, 33, 19, 33, 47, 33, 47, 33, 52, 33, 52, 33, 57, 33, 57, 33, 61, 33, 61, 33, 70, 33, 73, 33, 0, 251, 6, 251, 19, 251, 23, 251, 65, 255, 90, 255, 40, 4, 1, 0, 79, 4, 1, 0, 26, 212, 1, 0, 51, 212, 1, 0, 78, 212, 1, 0, 84, 212, 1, 0, 86, 212, 1, 0, 103, 212, 1, 0, 130, 212, 1, 0, 155, 212, 1, 0, 182, 212, 1, 0, 185, 212, 1, 0, 187, 212, 1, 0, 187, 212, 1, 0, 189, 212, 1, 0, 195, 212, 1, 0, 197, 212, 1, 0, 207, 212, 1, 0, 234, 212, 1, 0, 3, 213, 1, 0, 30, 213, 1, 0, 55, 213, 1, 0, 82, 213, 1, 0, 107, 213, 1, 0, 134, 213, 1, 0, 159, 213, 1, 0, 186, 213, 1, 0, 211, 213, 1, 0, 238, 213, 1, 0, 7, 214, 1, 0, 34, 214, 1, 0, 59, 214, 1, 0, 86, 214, 1, 0, 111, 214, 1, 0, 138, 214, 1, 0, 163, 214, 1, 0, 194, 214, 1, 0, 218, 214, 1, 0, 220, 214, 1, 0, 225, 214, 1, 0, 252, 214, 1, 0, 20, 215, 1, 0, 22, 215, 1, 0, 27, 215, 1, 0, 54, 215, 1, 0, 78, 215, 1, 0, 80, 215, 1, 0, 85, 215, 1, 0, 112, 215, 1, 0, 136, 215, 1, 0, 138, 215, 1, 0, 143, 215, 1, 0, 170, 215, 1, 0, 194, 215, 1, 0, 196, 215, 1, 0, 201, 215, 1, 0, 65, 0, 90, 0, 97, 0, 122, 0, 170, 0, 170, 0, 181, 0, 181, 0, 186, 0, 186, 0, 192, 0, 214, 0, 216, 0, 246, 0, 248, 0, 54, 2, 80, 2, 193, 2, 198, 2, 209, 2, 224, 2, 228, 2, 238, 2, 238, 2, 122, 3, 122, 3, 134, 3, 134, 3, 136, 3, 138, 3, 140, 3, 140, 3, 142, 3, 161, 3, 163, 3, 206, 3, 208, 3, 245, 3, 247, 3, 251, 3, 0, 4, 129, 4, 138, 4, 206, 4, 208, 4, 245, 4, 248, 4, 249, 4, 0, 5, 15, 5, 49, 5, 86, 5, 89, 5, 89, 5, 97, 5, 135, 5, 208, 5, 234, 5, 240, 5, 242, 5, 33, 6, 58, 6, 64, 6, 74, 6, 110, 6, 111, 6, 113, 6, 211, 6, 213, 6, 213, 6, 229, 6, 230, 6, 238, 6, 239, 6, 250, 6, 252, 6, 255, 6, 255, 6, 16, 7, 16, 7, 18, 7, 47, 7, 77, 7, 79, 7, 128, 7, 165, 7, 177, 7, 177, 7, 4, 9, 57, 9, 61, 9, 61, 9, 80, 9, 80, 9, 88, 9, 97, 9, 133, 9, 140, 9, 143, 9, 144, 9, 147, 9, 168, 9, 170, 9, 176, 9, 178, 9, 178, 9, 182, 9, 185, 9, 189, 9, 189, 9, 220, 9, 221, 9, 223, 9, 225, 9, 240, 9, 241, 9, 5, 10, 10, 10, 15, 10, 16, 10, 19, 10, 40, 10, 42, 10, 48, 10, 50, 10, 51, 10, 53, 10, 54, 10, 56, 10, 57, 10, 89, 10, 92, 10, 94, 10, 94, 10, 114, 10, 116, 10, 133, 10, 141, 10, 143, 10, 145, 10, 147, 10, 168, 10, 170, 10, 176, 10, 178, 10, 179, 10, 181, 10, 185, 10, 189, 10, 189, 10, 208, 10, 208, 10, 224, 10, 225, 10, 5, 11, 12, 11, 15, 11, 16, 11, 19, 11, 40, 11, 42, 11, 48, 11, 50, 11, 51, 11, 53, 11, 57, 11, 61, 11, 61, 11, 92, 11, 93, 11, 95, 11, 97, 11, 113, 11, 113, 11, 131, 11, 131, 11, 133, 11, 138, 11, 142, 11, 144, 11, 146, 11, 149, 11, 153, 11, 154, 11, 156, 11, 156, 11, 158, 11, 159, 11, 163, 11, 164, 11, 168, 11, 170, 11, 174, 11, 181, 11, 183, 11, 185, 11, 5, 12, 12, 12, 14, 12, 16, 12, 18, 12, 40, 12, 42, 12, 51, 12, 53, 12, 57, 12, 96, 12, 97, 12, 133, 12, 140, 12, 142, 12, 144, 12, 146, 12, 168, 12, 170, 12, 179, 12, 181, 12, 185, 12, 189, 12, 189, 12, 222, 12, 222, 12, 224, 12, 225, 12, 5, 13, 12, 13, 14, 13, 16, 13, 18, 13, 40, 13, 42, 13, 57, 13, 96, 13, 97, 13, 133, 13, 150, 13, 154, 13, 177, 13, 179, 13, 187, 13, 189, 13, 189, 13, 192, 13, 198, 13, 1, 14, 48, 14, 50, 14, 51, 14, 64, 14, 70, 14, 129, 14, 130, 14, 132, 14, 132, 14, 135, 14, 136, 14, 138, 14, 138, 14, 141, 14, 141, 14, 148, 14, 151, 14, 153, 14, 159, 14, 161, 14, 163, 14, 165, 14, 165, 14, 167, 14, 167, 14, 170, 14, 171, 14, 173, 14, 176, 14, 178, 14, 179, 14, 189, 14, 189, 14, 192, 14, 196, 14, 198, 14, 198, 14, 220, 14, 221, 14, 0, 15, 0, 15, 64, 15, 71, 15, 73, 15, 106, 15, 136, 15, 139, 15, 0, 16, 33, 16, 35, 16, 39, 16, 41, 16, 42, 16, 80, 16, 85, 16, 160, 16, 197, 16, 208, 16, 248, 16, 0, 17, 89, 17, 95, 17, 162, 17, 168, 17, 249, 17, 0, 18, 6, 18, 8, 18, 70, 18, 72, 18, 72, 18, 74, 18, 77, 18, 80, 18, 86, 18, 88, 18, 88, 18, 90, 18, 93, 18, 96, 18, 134, 18, 136, 18, 136, 18, 138, 18, 141, 18, 144, 18, 174, 18, 176, 18, 176, 18, 178, 18, 181, 18, 184, 18, 190, 18, 192, 18, 192, 18, 194, 18, 197, 18, 200, 18, 206, 18, 208, 18, 214, 18, 216, 18, 238, 18, 240, 18, 14, 19, 16, 19, 16, 19, 18, 19, 21, 19, 24, 19, 30, 19, 32, 19, 70, 19, 72, 19, 90, 19, 160, 19, 244, 19, 1, 20, 108, 22, 111, 22, 118, 22, 129, 22, 154, 22, 160, 22, 234, 22, 0, 23, 12, 23, 14, 23, 17, 23, 32, 23, 49, 23, 64, 23, 81, 23, 96, 23, 108, 23, 110, 23, 112, 23, 128, 23, 179, 23, 215, 23, 215, 23, 220, 23, 220, 23, 32, 24, 119, 24, 128, 24, 168, 24, 0, 25, 28, 25, 80, 25, 109, 25, 112, 25, 116, 25, 0, 29, 107, 29, 0, 30, 155, 30, 160, 30, 249, 30, 0, 31, 21, 31, 24, 31, 29, 31, 32, 31, 69, 31, 72, 31, 77, 31, 80, 31, 87, 31, 89, 31, 89, 31, 91, 31, 91, 31, 93, 31, 93, 31, 95, 31, 125, 31, 128, 31, 180, 31, 182, 31, 188, 31, 190, 31, 190, 31, 194, 31, 196, 31, 198, 31, 204, 31, 208, 31, 211, 31, 214, 31, 219, 31, 224, 31, 236, 31, 242, 31, 244, 31, 246, 31, 252, 31, 113, 32, 113, 32, 127, 32, 127, 32, 2, 33, 2, 33, 7, 33, 7, 33, 10, 33, 19, 33, 21, 33, 21, 33, 25, 33, 29, 33, 36, 33, 36, 33, 38, 33, 38, 33, 40, 33, 40, 33, 42, 33, 45, 33, 47, 33, 49, 33, 51, 33, 57, 33, 61, 33, 63, 33, 69, 33, 73, 33, 5, 48, 6, 48, 49, 48, 53, 48, 59, 48, 60, 48, 65, 48, 150, 48, 157, 48, 159, 48, 161, 48, 250, 48, 252, 48, 255, 48, 5, 49, 44, 49, 49, 49, 142, 49, 160, 49, 183, 49, 240, 49, 255, 49, 0, 52, 0, 52, 181, 77, 181, 77, 0, 78, 0, 78, 165, 159, 165, 159, 0, 160, 140, 164, 0, 172, 0, 172, 163, 215, 163, 215, 0, 249, 45, 250, 48, 250, 106, 250, 0, 251, 6, 251, 19, 251, 23, 251, 29, 251, 29, 251, 31, 251, 40, 251, 42, 251, 54, 251, 56, 251, 60, 251, 62, 251, 62, 251, 64, 251, 65, 251, 67, 251, 68, 251, 70, 251, 177, 251, 211, 251, 61, 253, 80, 253, 143, 253, 146, 253, 199, 253, 240, 253, 251, 253, 112, 254, 116, 254, 118, 254, 252, 254, 33, 255, 58, 255, 65, 255, 90, 255, 102, 255, 190, 255, 194, 255, 199, 255, 202, 255, 207, 255, 210, 255, 215, 255, 218, 255, 220, 255, 0, 0, 0, 0, 0, 0, 1, 0, 11, 0, 1, 0, 13, 0, 1, 0, 38, 0, 1, 0, 40, 0, 1, 0, 58, 0, 1, 0, 60, 0, 1, 0, 61, 0, 1, 0, 63, 0, 1, 0, 77, 0, 1, 0, 80, 0, 1, 0, 93, 0, 1, 0, 128, 0, 1, 0, 250, 0, 1, 0, 0, 3, 1, 0, 30, 3, 1, 0, 48, 3, 1, 0, 73, 3, 1, 0, 128, 3, 1, 0, 157, 3, 1, 0, 0, 4, 1, 0, 157, 4, 1, 0, 0, 8, 1, 0, 5, 8, 1, 0, 8, 8, 1, 0, 8, 8, 1, 0, 10, 8, 1, 0, 53, 8, 1, 0, 55, 8, 1, 0, 56, 8, 1, 0, 60, 8, 1, 0, 60, 8, 1, 0, 63, 8, 1, 0, 63, 8, 1, 0, 0, 212, 1, 0, 84, 212, 1, 0, 86, 212, 1, 0, 156, 212, 1, 0, 158, 212, 1, 0, 159, 212, 1, 0, 162, 212, 1, 0, 162, 212, 1, 0, 165, 212, 1, 0, 166, 212, 1, 0, 169, 212, 1, 0, 172, 212, 1, 0, 174, 212, 1, 0, 185, 212, 1, 0, 187, 212, 1, 0, 187, 212, 1, 0, 189, 212, 1, 0, 195, 212, 1, 0, 197, 212, 1, 0, 5, 213, 1, 0, 7, 213, 1, 0, 10, 213, 1, 0, 13, 213, 1, 0, 20, 213, 1, 0, 22, 213, 1, 0, 28, 213, 1, 0, 30, 213, 1, 0, 57, 213, 1, 0, 59, 213, 1, 0, 62, 213, 1, 0, 64, 213, 1, 0, 68, 213, 1, 0, 70, 213, 1, 0, 70, 213, 1, 0, 74, 213, 1, 0, 80, 213, 1, 0, 82, 213, 1, 0, 163, 214, 1, 0, 168, 214, 1, 0, 192, 214, 1, 0, 194, 214, 1, 0, 218, 214, 1, 0, 220, 214, 1, 0, 250, 214, 1, 0, 252, 214, 1, 0, 20, 215, 1, 0, 22, 215, 1, 0, 52, 215, 1, 0, 54, 215, 1, 0, 78, 215, 1, 0, 80, 215, 1, 0, 110, 215, 1, 0, 112, 215, 1, 0, 136, 215, 1, 0, 138, 215, 1, 0, 168, 215, 1, 0, 170, 215, 1, 0, 194, 215, 1, 0, 196, 215, 1, 0, 201, 215, 1, 0, 0, 0, 2, 0, 0, 0, 2, 0, 214, 166, 2, 0, 214, 166, 2, 0, 0, 248, 2, 0, 29, 250, 2, 0, 173, 0, 173, 0, 0, 6, 3, 6, 221, 6, 221, 6, 15, 7, 15, 7, 180, 23, 181, 23, 11, 32, 15, 32, 42, 32, 46, 32, 96, 32, 99, 32, 106, 32, 111, 32, 255, 254, 255, 254, 249, 255, 251, 255, 0, 0, 0, 0, 115, 209, 1, 0, 122, 209, 1, 0, 1, 0, 14, 0, 1, 0, 14, 0, 32, 0, 14, 0, 127, 0, 14, 0, 0, 0, 31, 0, 127, 0, 159, 0, 173, 0, 173, 0, 0, 6, 3, 6, 221, 6, 221, 6, 15, 7, 15, 7, 180, 23, 181, 23, 11, 32, 15, 32, 42, 32, 46, 32, 96, 32, 99, 32, 106, 32, 111, 32, 0, 216, 0, 216, 127, 219, 128, 219, 255, 219, 0, 220, 255, 223, 0, 224, 255, 248, 255, 248, 255, 254, 255, 254, 249, 255, 251, 255, 115, 209, 1, 0, 122, 209, 1, 0, 1, 0, 14, 0, 1, 0, 14, 0, 32, 0, 14, 0, 127, 0, 14, 0, 0, 0, 15, 0, 0, 0, 15, 0, 253, 255, 15, 0, 253, 255, 15, 0, 0, 0, 16, 0, 0, 0, 16, 0, 253, 255, 16, 0, 253, 255, 16, 0, 16, 210, 2, 0, 66, 0, 0, 0, 32, 210, 2, 0, 67, 0, 0, 0, 64, 210, 2, 0, 68, 0, 0, 0, 72, 210, 2, 0, 69, 0, 0, 0, 104, 210, 2, 0, 70, 0, 0, 0, 136, 210, 2, 0, 71, 0, 0, 0, 152, 210, 2, 0, 72, 0, 0, 0, 160, 210, 2, 0, 73, 0, 0, 0, 176, 210, 2, 0, 74, 0, 0, 0, 184, 210, 2, 0, 75, 0, 0, 0, 200, 210, 2, 0, 76, 0, 0, 0, 216, 210, 2, 0, 77, 0, 0, 0, 240, 210, 2, 0, 78, 0, 0, 0, 0, 211, 2, 0, 79, 0, 0, 0, 16, 211, 2, 0, 80, 0, 0, 0, 24, 211, 2, 0, 81, 0, 0, 0, 48, 211, 2, 0, 82, 0, 0, 0, 72, 211, 2, 0, 83, 0, 0, 0, 96, 211, 2, 0, 84, 0, 0, 0, 128, 211, 2, 0, 85, 0, 0, 0, 168, 211, 2, 0, 86, 0, 0, 0, 192, 211, 2, 0, 87, 0, 0, 0, 224, 211, 2, 0, 88, 0, 0, 0, 248, 211, 2, 0, 89, 0, 0, 0, 24, 212, 2, 0, 90, 0, 0, 0, 56, 212, 2, 0, 91, 0, 0, 0, 72, 212, 2, 0, 92, 0, 0, 0, 104, 212, 2, 0, 93, 0, 0, 0, 144, 212, 2, 0, 94, 0, 0, 0, 168, 212, 2, 0, 95, 0, 0, 0, 200, 212, 2, 0, 96, 0, 0, 0, 216, 212, 2, 0, 97, 0, 0, 0, 232, 212, 2, 0, 98, 0, 0, 0, 0, 213, 2, 0, 99, 0, 0, 0, 16, 213, 2, 0, 100, 0, 0, 0, 40, 213, 2, 0, 101, 0, 0, 0, 48, 213, 2, 0, 102, 0, 0, 0, 64, 213, 2, 0, 103, 0, 0, 0, 80, 213, 2, 0, 104, 0, 0, 0, 104, 213, 2, 0, 105, 0, 0, 0, 136, 213, 2, 0, 106, 0, 0, 0, 152, 213, 2, 0, 107, 0, 0, 0, 176, 213, 2, 0, 108, 0, 0, 0, 192, 213, 2, 0, 109, 0, 0, 0, 208, 213, 2, 0, 110, 0, 0, 0, 216, 213, 2, 0, 111, 0, 0, 0, 224, 213, 2, 0, 112, 0, 0, 0, 240, 213, 2, 0, 113, 0, 0, 0, 0, 214, 2, 0, 114, 0, 0, 0, 16, 214, 2, 0, 115, 0, 0, 0, 32, 214, 2, 0, 116, 0, 0, 0, 64, 214, 2, 0, 117, 0, 0, 0, 88, 214, 2, 0, 118, 0, 0, 0, 104, 214, 2, 0, 119, 0, 0, 0, 120, 214, 2, 0, 120, 0, 0, 0, 128, 214, 2, 0, 121, 0, 0, 0, 136, 214, 2, 0, 122, 0, 0, 0, 168, 214, 2, 0, 123, 0, 0, 0, 184, 214, 2, 0, 124, 0, 0, 0, 200, 214, 2, 0, 125, 0, 0, 0, 216, 214, 2, 0, 126, 0, 0, 0, 0, 215, 2, 0, 127, 0, 0, 0, 8, 215, 2, 0, 128, 0, 0, 0, 24, 215, 2, 0, 129, 0, 0, 0, 32, 215, 2, 0, 130, 0, 0, 0, 48, 215, 2, 0, 131, 0, 0, 0, 80, 215, 2, 0, 132, 0, 0, 0, 88, 215, 2, 0, 133, 0, 0, 0, 104, 215, 2, 0, 134, 0, 0, 0, 112, 215, 2, 0, 135, 0, 0, 0, 136, 215, 2, 0, 136, 0, 0, 0, 152, 215, 2, 0, 137, 0, 0, 0, 168, 215, 2, 0, 138, 0, 0, 0, 192, 215, 2, 0, 139, 0, 0, 0, 216, 215, 2, 0, 140, 0, 0, 0, 224, 215, 2, 0, 141, 0, 0, 0, 248, 215, 2, 0, 142, 0, 0, 0, 16, 216, 2, 0, 143, 0, 0, 0, 32, 216, 2, 0, 144, 0, 0, 0, 48, 216, 2, 0, 145, 0, 0, 0, 80, 216, 2, 0, 146, 0, 0, 0, 104, 216, 2, 0, 147, 0, 0, 0, 144, 216, 2, 0, 148, 0, 0, 0, 184, 216, 2, 0, 149, 0, 0, 0, 208, 216, 2, 0, 150, 0, 0, 0, 240, 216, 2, 0, 151, 0, 0, 0, 8, 217, 2, 0, 152, 0, 0, 0, 24, 217, 2, 0, 153, 0, 0, 0, 40, 217, 2, 0, 154, 0, 0, 0, 48, 217, 2, 0, 155, 0, 0, 0, 64, 217, 2, 0, 156, 0, 0, 0, 72, 217, 2, 0, 157, 0, 0, 0, 88, 217, 2, 0, 158, 0, 0, 0, 120, 217, 2, 0, 159, 0, 0, 0, 128, 217, 2, 0, 160, 0, 0, 0, 136, 217, 2, 0, 161, 0, 0, 0, 160, 217, 2, 0, 162, 0, 0, 0, 176, 217, 2, 0, 163, 0, 0, 0, 192, 217, 2, 0, 164, 0, 0, 0, 200, 217, 2, 0, 165, 0, 0, 0, 208, 217, 2, 0, 166, 0, 0, 0, 216, 217, 2, 0, 167, 0, 0, 0, 240, 217, 2, 0, 168, 0, 0, 0, 8, 218, 2, 0, 169, 0, 0, 0, 24, 218, 2, 0, 170, 0, 0, 0, 56, 218, 2, 0, 171, 0, 0, 0, 80, 218, 2, 0, 172, 0, 0, 0, 104, 218, 2, 0, 173, 0, 0, 0, 144, 218, 2, 0, 174, 0, 0, 0, 176, 218, 2, 0, 175, 0, 0, 0, 208, 218, 2, 0, 176, 0, 0, 0, 216, 218, 2, 0, 177, 0, 0, 0, 224, 218, 2, 0, 178, 0, 0, 0, 240, 218, 2, 0, 179, 0, 0, 0, 248, 218, 2, 0, 180, 0, 0, 0, 0, 219, 2, 0, 181, 0, 0, 0, 24, 219, 2, 0, 182, 0, 0, 0, 32, 219, 2, 0, 183, 0, 0, 0, 40, 219, 2, 0, 184, 0, 0, 0, 48, 219, 2, 0, 185, 0, 0, 0, 56, 219, 2, 0, 186, 0, 0, 0, 64, 219, 2, 0, 187, 0, 0, 0, 80, 219, 2, 0, 188, 0, 0, 0, 120, 219, 2, 0, 189, 0, 0, 0, 144, 219, 2, 0, 190, 0, 0, 0, 176, 219, 2, 0, 191, 0, 0, 0, 192, 219, 2, 0, 192, 0, 0, 0, 208, 219, 2, 0, 193, 0, 0, 0, 65, 101, 103, 101, 97, 110, 78, 117, 109, 98, 101, 114, 115, 0, 0, 0, 65, 108, 112, 104, 97, 98, 101, 116, 105, 99, 80, 114, 101, 115, 101, 110, 116, 97, 116, 105, 111, 110, 70, 111, 114, 109, 115, 0, 0, 0, 0, 0, 65, 114, 97, 98, 105, 99, 0, 0, 65, 114, 97, 98, 105, 99, 80, 114, 101, 115, 101, 110, 116, 97, 116, 105, 111, 110, 70, 111, 114, 109, 115, 45, 65, 0, 0, 0, 0, 0, 0, 0, 65, 114, 97, 98, 105, 99, 80, 114, 101, 115, 101, 110, 116, 97, 116, 105, 111, 110, 70, 111, 114, 109, 115, 45, 66, 0, 0, 0, 0, 0, 0, 0, 65, 114, 109, 101, 110, 105, 97, 110, 0, 0, 0, 0, 0, 0, 0, 0, 65, 114, 114, 111, 119, 115, 0, 0, 66, 97, 115, 105, 99, 76, 97, 116, 105, 110, 0, 0, 0, 0, 0, 0, 66, 101, 110, 103, 97, 108, 105, 0, 66, 108, 111, 99, 107, 69, 108, 101, 109, 101, 110, 116, 115, 0, 0, 0, 66, 111, 112, 111, 109, 111, 102, 111, 0, 0, 0, 0, 0, 0, 0, 0, 66, 111, 112, 111, 109, 111, 102, 111, 69, 120, 116, 101, 110, 100, 101, 100, 0, 0, 0, 0, 0, 0, 0, 0, 66, 111, 120, 68, 114, 97, 119, 105, 110, 103, 0, 0, 0, 0, 0, 0, 66, 114, 97, 105, 108, 108, 101, 80, 97, 116, 116, 101, 114, 110, 115, 0, 66, 117, 104, 105, 100, 0, 0, 0, 66, 121, 122, 97, 110, 116, 105, 110, 101, 77, 117, 115, 105, 99, 97, 108, 83, 121, 109, 98, 111, 108, 115, 0, 67, 74, 75, 67, 111, 109, 112, 97, 116, 105, 98, 105, 108, 105, 116, 121, 0, 0, 0, 0, 0, 0, 0, 0, 67, 74, 75, 67, 111, 109, 112, 97, 116, 105, 98, 105, 108, 105, 116, 121, 70, 111, 114, 109, 115, 0, 0, 0, 67, 74, 75, 67, 111, 109, 112, 97, 116, 105, 98, 105, 108, 105, 116, 121, 73, 100, 101, 111, 103, 114, 97, 112, 104, 115, 0, 0, 0, 0, 0, 0, 67, 74, 75, 67, 111, 109, 112, 97, 116, 105, 98, 105, 108, 105, 116, 121, 73, 100, 101, 111, 103, 114, 97, 112, 104, 115, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 67, 74, 75, 82, 97, 100, 105, 99, 97, 108, 115, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 0, 0, 0, 67, 74, 75, 83, 121, 109, 98, 111, 108, 115, 97, 110, 100, 80, 117, 110, 99, 116, 117, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 0, 0, 67, 74, 75, 85, 110, 105, 102, 105, 101, 100, 73, 100, 101, 111, 103, 114, 97, 112, 104, 115, 0, 0, 0, 0, 67, 74, 75, 85, 110, 105, 102, 105, 101, 100, 73, 100, 101, 111, 103, 114, 97, 112, 104, 115, 69, 120, 116, 101, 110, 115, 105, 111, 110, 65, 0, 0, 67, 74, 75, 85, 110, 105, 102, 105, 101, 100, 73, 100, 101, 111, 103, 114, 97, 112, 104, 115, 69, 120, 116, 101, 110, 115, 105, 111, 110, 66, 0, 0, 67, 104, 101, 114, 111, 107, 101, 101, 0, 0, 0, 0, 0, 0, 0, 0, 67, 111, 109, 98, 105, 110, 105, 110, 103, 68, 105, 97, 99, 114, 105, 116, 105, 99, 97, 108, 77, 97, 114, 107, 115, 0, 0, 0, 0, 0, 0, 0, 67, 111, 109, 98, 105, 110, 105, 110, 103, 68, 105, 97, 99, 114, 105, 116, 105, 99, 97, 108, 77, 97, 114, 107, 115, 102, 111, 114, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 0, 67, 111, 109, 98, 105, 110, 105, 110, 103, 72, 97, 108, 102, 77, 97, 114, 107, 115, 0, 0, 0, 0, 0, 0, 67, 111, 109, 98, 105, 110, 105, 110, 103, 77, 97, 114, 107, 115, 102, 111, 114, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 0, 0, 0, 0, 67, 111, 110, 116, 114, 111, 108, 80, 105, 99, 116, 117, 114, 101, 115, 0, 67, 117, 114, 114, 101, 110, 99, 121, 83, 121, 109, 98, 111, 108, 115, 0, 67, 121, 112, 114, 105, 111, 116, 83, 121, 108, 108, 97, 98, 97, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 67, 121, 114, 105, 108, 108, 105, 99, 0, 0, 0, 0, 0, 0, 0, 0, 67, 121, 114, 105, 108, 108, 105, 99, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 68, 101, 115, 101, 114, 101, 116, 0, 68, 101, 118, 97, 110, 97, 103, 97, 114, 105, 0, 0, 0, 0, 0, 0, 68, 105, 110, 103, 98, 97, 116, 115, 0, 0, 0, 0, 0, 0, 0, 0, 69, 110, 99, 108, 111, 115, 101, 100, 65, 108, 112, 104, 97, 110, 117, 109, 101, 114, 105, 99, 115, 0, 0, 0, 69, 110, 99, 108, 111, 115, 101, 100, 67, 74, 75, 76, 101, 116, 116, 101, 114, 115, 97, 110, 100, 77, 111, 110, 116, 104, 115, 0, 0, 0, 0, 0, 69, 116, 104, 105, 111, 112, 105, 99, 0, 0, 0, 0, 0, 0, 0, 0, 71, 101, 110, 101, 114, 97, 108, 80, 117, 110, 99, 116, 117, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 0, 71, 101, 111, 109, 101, 116, 114, 105, 99, 83, 104, 97, 112, 101, 115, 0, 71, 101, 111, 114, 103, 105, 97, 110, 0, 0, 0, 0, 0, 0, 0, 0, 71, 111, 116, 104, 105, 99, 0, 0, 71, 114, 101, 101, 107, 0, 0, 0, 71, 114, 101, 101, 107, 69, 120, 116, 101, 110, 100, 101, 100, 0, 0, 0, 71, 114, 101, 101, 107, 97, 110, 100, 67, 111, 112, 116, 105, 99, 0, 0, 71, 117, 106, 97, 114, 97, 116, 105, 0, 0, 0, 0, 0, 0, 0, 0, 71, 117, 114, 109, 117, 107, 104, 105, 0, 0, 0, 0, 0, 0, 0, 0, 72, 97, 108, 102, 119, 105, 100, 116, 104, 97, 110, 100, 70, 117, 108, 108, 119, 105, 100, 116, 104, 70, 111, 114, 109, 115, 0, 0, 0, 0, 0, 0, 72, 97, 110, 103, 117, 108, 67, 111, 109, 112, 97, 116, 105, 98, 105, 108, 105, 116, 121, 74, 97, 109, 111, 0, 72, 97, 110, 103, 117, 108, 74, 97, 109, 111, 0, 0, 0, 0, 0, 0, 72, 97, 110, 103, 117, 108, 83, 121, 108, 108, 97, 98, 108, 101, 115, 0, 72, 97, 110, 117, 110, 111, 111, 0, 72, 101, 98, 114, 101, 119, 0, 0, 72, 105, 103, 104, 80, 114, 105, 118, 97, 116, 101, 85, 115, 101, 83, 117, 114, 114, 111, 103, 97, 116, 101, 115, 0, 0, 0, 0, 0, 0, 0, 0, 72, 105, 103, 104, 83, 117, 114, 114, 111, 103, 97, 116, 101, 115, 0, 0, 72, 105, 114, 97, 103, 97, 110, 97, 0, 0, 0, 0, 0, 0, 0, 0, 73, 80, 65, 69, 120, 116, 101, 110, 115, 105, 111, 110, 115, 0, 0, 0, 73, 100, 101, 111, 103, 114, 97, 112, 104, 105, 99, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 0, 0, 0, 0, 0, 0, 0, 0, 75, 97, 110, 98, 117, 110, 0, 0, 75, 97, 110, 103, 120, 105, 82, 97, 100, 105, 99, 97, 108, 115, 0, 0, 75, 97, 110, 110, 97, 100, 97, 0, 75, 97, 116, 97, 107, 97, 110, 97, 0, 0, 0, 0, 0, 0, 0, 0, 75, 97, 116, 97, 107, 97, 110, 97, 80, 104, 111, 110, 101, 116, 105, 99, 69, 120, 116, 101, 110, 115, 105, 111, 110, 115, 0, 0, 0, 0, 0, 0, 75, 104, 109, 101, 114, 0, 0, 0, 75, 104, 109, 101, 114, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 76, 97, 111, 0, 0, 0, 0, 0, 76, 97, 116, 105, 110, 45, 49, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 76, 97, 116, 105, 110, 69, 120, 116, 101, 110, 100, 101, 100, 45, 65, 0, 76, 97, 116, 105, 110, 69, 120, 116, 101, 110, 100, 101, 100, 45, 66, 0, 76, 97, 116, 105, 110, 69, 120, 116, 101, 110, 100, 101, 100, 65, 100, 100, 105, 116, 105, 111, 110, 97, 108, 0, 76, 101, 116, 116, 101, 114, 108, 105, 107, 101, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 0, 0, 0, 76, 105, 109, 98, 117, 0, 0, 0, 76, 105, 110, 101, 97, 114, 66, 73, 100, 101, 111, 103, 114, 97, 109, 115, 0, 0, 0, 0, 0, 0, 0, 0, 76, 105, 110, 101, 97, 114, 66, 83, 121, 108, 108, 97, 98, 97, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 76, 111, 119, 83, 117, 114, 114, 111, 103, 97, 116, 101, 115, 0, 0, 0, 77, 97, 108, 97, 121, 97, 108, 97, 109, 0, 0, 0, 0, 0, 0, 0, 77, 97, 116, 104, 101, 109, 97, 116, 105, 99, 97, 108, 65, 108, 112, 104, 97, 110, 117, 109, 101, 114, 105, 99, 83, 121, 109, 98, 111, 108, 115, 0, 77, 97, 116, 104, 101, 109, 97, 116, 105, 99, 97, 108, 79, 112, 101, 114, 97, 116, 111, 114, 115, 0, 0, 0, 77, 105, 115, 99, 101, 108, 108, 97, 110, 101, 111, 117, 115, 77, 97, 116, 104, 101, 109, 97, 116, 105, 99, 97, 108, 83, 121, 109, 98, 111, 108, 115, 45, 65, 0, 0, 0, 0, 0, 0, 77, 105, 115, 99, 101, 108, 108, 97, 110, 101, 111, 117, 115, 77, 97, 116, 104, 101, 109, 97, 116, 105, 99, 97, 108, 83, 121, 109, 98, 111, 108, 115, 45, 66, 0, 0, 0, 0, 0, 0, 77, 105, 115, 99, 101, 108, 108, 97, 110, 101, 111, 117, 115, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 77, 105, 115, 99, 101, 108, 108, 97, 110, 101, 111, 117, 115, 83, 121, 109, 98, 111, 108, 115, 97, 110, 100, 65, 114, 114, 111, 119, 115, 0, 0, 0, 77, 105, 115, 99, 101, 108, 108, 97, 110, 101, 111, 117, 115, 84, 101, 99, 104, 110, 105, 99, 97, 108, 0, 0, 77, 111, 110, 103, 111, 108, 105, 97, 110, 0, 0, 0, 0, 0, 0, 0, 77, 117, 115, 105, 99, 97, 108, 83, 121, 109, 98, 111, 108, 115, 0, 0, 77, 121, 97, 110, 109, 97, 114, 0, 78, 117, 109, 98, 101, 114, 70, 111, 114, 109, 115, 0, 0, 0, 0, 0, 79, 103, 104, 97, 109, 0, 0, 0, 79, 108, 100, 73, 116, 97, 108, 105, 99, 0, 0, 0, 0, 0, 0, 0, 79, 112, 116, 105, 99, 97, 108, 67, 104, 97, 114, 97, 99, 116, 101, 114, 82, 101, 99, 111, 103, 110, 105, 116, 105, 111, 110, 0, 0, 0, 0, 0, 79, 114, 105, 121, 97, 0, 0, 0, 79, 115, 109, 97, 110, 121, 97, 0, 80, 104, 111, 110, 101, 116, 105, 99, 69, 120, 116, 101, 110, 115, 105, 111, 110, 115, 0, 0, 0, 0, 0, 0, 80, 114, 105, 118, 97, 116, 101, 85, 115, 101, 0, 0, 0, 0, 0, 0, 80, 114, 105, 118, 97, 116, 101, 85, 115, 101, 65, 114, 101, 97, 0, 0, 82, 117, 110, 105, 99, 0, 0, 0, 83, 104, 97, 118, 105, 97, 110, 0, 83, 105, 110, 104, 97, 108, 97, 0, 83, 109, 97, 108, 108, 70, 111, 114, 109, 86, 97, 114, 105, 97, 110, 116, 115, 0, 0, 0, 0, 0, 0, 0, 83, 112, 97, 99, 105, 110, 103, 77, 111, 100, 105, 102, 105, 101, 114, 76, 101, 116, 116, 101, 114, 115, 0, 0, 83, 112, 101, 99, 105, 97, 108, 115, 0, 0, 0, 0, 0, 0, 0, 0, 83, 117, 112, 101, 114, 115, 99, 114, 105, 112, 116, 115, 97, 110, 100, 83, 117, 98, 115, 99, 114, 105, 112, 116, 115, 0, 0, 0, 0, 0, 0, 0, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 97, 108, 65, 114, 114, 111, 119, 115, 45, 65, 0, 0, 0, 0, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 97, 108, 65, 114, 114, 111, 119, 115, 45, 66, 0, 0, 0, 0, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 97, 108, 77, 97, 116, 104, 101, 109, 97, 116, 105, 99, 97, 108, 79, 112, 101, 114, 97, 116, 111, 114, 115, 0, 0, 0, 0, 0, 0, 0, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 97, 114, 121, 80, 114, 105, 118, 97, 116, 101, 85, 115, 101, 65, 114, 101, 97, 45, 65, 0, 0, 0, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 97, 114, 121, 80, 114, 105, 118, 97, 116, 101, 85, 115, 101, 65, 114, 101, 97, 45, 66, 0, 0, 0, 83, 121, 114, 105, 97, 99, 0, 0, 84, 97, 103, 97, 108, 111, 103, 0, 84, 97, 103, 98, 97, 110, 119, 97, 0, 0, 0, 0, 0, 0, 0, 0, 84, 97, 103, 115, 0, 0, 0, 0, 84, 97, 105, 76, 101, 0, 0, 0, 84, 97, 105, 88, 117, 97, 110, 74, 105, 110, 103, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 0, 0, 84, 97, 109, 105, 108, 0, 0, 0, 84, 101, 108, 117, 103, 117, 0, 0, 84, 104, 97, 97, 110, 97, 0, 0, 84, 104, 97, 105, 0, 0, 0, 0, 84, 105, 98, 101, 116, 97, 110, 0, 85, 103, 97, 114, 105, 116, 105, 99, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 105, 102, 105, 101, 100, 67, 97, 110, 97, 100, 105, 97, 110, 65, 98, 111, 114, 105, 103, 105, 110, 97, 108, 83, 121, 108, 108, 97, 98, 105, 99, 115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 177008);
	        allocate([86, 97, 114, 105, 97, 116, 105, 111, 110, 83, 101, 108, 101, 99, 116, 111, 114, 115, 0, 0, 0, 0, 0, 0, 86, 97, 114, 105, 97, 116, 105, 111, 110, 83, 101, 108, 101, 99, 116, 111, 114, 115, 83, 117, 112, 112, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 89, 105, 82, 97, 100, 105, 99, 97, 108, 115, 0, 0, 0, 0, 0, 0, 89, 105, 83, 121, 108, 108, 97, 98, 108, 101, 115, 0, 0, 0, 0, 0, 89, 105, 106, 105, 110, 103, 72, 101, 120, 97, 103, 114, 97, 109, 83, 121, 109, 98, 111, 108, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 51, 47, 88, 73, 110, 99, 108, 117, 100, 101, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 73, 110, 99, 108, 117, 100, 101, 0, 120, 109, 108, 78, 101, 119, 84, 101, 120, 116, 82, 101, 97, 100, 101, 114, 32, 58, 32, 109, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 48, 47, 120, 109, 108, 110, 115, 47, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 35, 116, 101, 120, 116, 0, 0, 0, 35, 99, 100, 97, 116, 97, 45, 115, 101, 99, 116, 105, 111, 110, 0, 0, 35, 99, 111, 109, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 35, 100, 111, 99, 117, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 0, 35, 100, 111, 99, 117, 109, 101, 110, 116, 45, 102, 114, 97, 103, 109, 101, 110, 116, 0, 0, 0, 0, 0, 0, 120, 109, 108, 84, 101, 120, 116, 82, 101, 97, 100, 101, 114, 83, 101, 116, 117, 112, 32, 58, 32, 109, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 120, 109, 108, 77, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 32, 33, 10, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 97, 108, 108, 111, 99, 32, 102, 97, 105, 108, 101, 100, 32, 33, 10, 0, 0, 0, 0, 105, 110, 99, 108, 117, 100, 101, 0, 118, 115, 110, 112, 114, 105, 110, 116, 102, 32, 102, 97, 105, 108, 101, 100, 32, 33, 10, 0, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 69, 120, 112, 97, 110, 100, 32, 102, 97, 105, 108, 101, 100, 32, 33, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 115, 104, 32, 116, 97, 98, 108, 101, 32, 102, 111, 114, 32, 82, 101, 108, 97, 120, 45, 78, 71, 32, 116, 121, 112, 101, 115, 10, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 77, 76, 83, 99, 104, 101, 109, 97, 45, 100, 97, 116, 97, 116, 121, 112, 101, 115, 0, 0, 0, 0, 0, 0, 64, 241, 2, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 112, 97, 114, 115, 101, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 108, 111, 97, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 112, 97, 114, 115, 101, 32, 115, 99, 104, 101, 109, 97, 115, 10, 0, 0, 0, 0, 0, 0, 0, 105, 110, 95, 109, 101, 109, 111, 114, 121, 95, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 110, 111, 116, 104, 105, 110, 103, 32, 116, 111, 32, 112, 97, 114, 115, 101, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 37, 115, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 115, 99, 104, 101, 109, 97, 115, 0, 35, 116, 101, 120, 116, 0, 0, 0, 32, 84, 79, 68, 79, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 0, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 116, 121, 112, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 84, 121, 112, 101, 32, 37, 115, 32, 100, 111, 101, 115, 110, 39, 116, 32, 97, 108, 108, 111, 119, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 0, 73, 68, 32, 37, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 97, 114, 101, 32, 116, 121, 112, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 110, 111, 32, 115, 116, 97, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 110, 111, 32, 100, 101, 102, 105, 110, 101, 10, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 69, 120, 116, 114, 97, 32, 100, 97, 116, 97, 32, 105, 110, 32, 108, 105, 115, 116, 58, 32, 37, 115, 10, 0, 73, 110, 116, 101, 114, 110, 97, 108, 58, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 32, 98, 108, 111, 99, 107, 32, 104, 97, 115, 32, 110, 111, 32, 100, 97, 116, 97, 10, 0, 73, 110, 118, 97, 108, 105, 100, 32, 115, 101, 113, 117, 101, 110, 99, 101, 32, 105, 110, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 69, 120, 116, 114, 97, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 105, 110, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 44, 32, 103, 111, 116, 32, 37, 115, 10, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 58, 32, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 37, 115, 10, 0, 0, 0, 68, 105, 100, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 116, 104, 101, 114, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 68, 105, 100, 32, 110, 111, 116, 32, 101, 120, 112, 101, 99, 116, 32, 116, 101, 120, 116, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 110, 111, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 116, 111, 32, 98, 101, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 44, 32, 103, 111, 116, 32, 110, 111, 116, 104, 105, 110, 103, 10, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 103, 111, 116, 32, 116, 101, 120, 116, 10, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 10, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 118, 97, 108, 105, 100, 97, 116, 101, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 101, 120, 116, 114, 97, 32, 99, 111, 110, 116, 101, 110, 116, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 118, 97, 108, 105, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 102, 111, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 10, 0, 0, 0, 0, 68, 97, 116, 97, 116, 121, 112, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 110, 111, 32, 100, 97, 116, 97, 10, 0, 0, 0, 68, 97, 116, 97, 116, 121, 112, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 99, 104, 105, 108, 100, 32, 101, 108, 101, 109, 101, 110, 116, 115, 10, 0, 86, 97, 108, 117, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 99, 104, 105, 108, 100, 32, 101, 108, 101, 109, 101, 110, 116, 115, 10, 0, 0, 0, 0, 76, 105, 115, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 99, 104, 105, 108, 100, 32, 101, 108, 101, 109, 101, 110, 116, 115, 10, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 32, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 100, 97, 116, 97, 116, 121, 112, 101, 32, 37, 115, 10, 0, 0, 0, 69, 114, 114, 111, 114, 32, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 118, 97, 108, 117, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 32, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 108, 105, 115, 116, 10, 0, 0, 78, 111, 32, 116, 111, 112, 32, 103, 114, 97, 109, 109, 97, 114, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 69, 120, 116, 114, 97, 32, 100, 97, 116, 97, 32, 105, 110, 32, 116, 104, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 101, 114, 114, 111, 114, 32, 33, 10, 0, 0, 0, 0, 0, 0, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 101, 114, 114, 111, 114, 32, 99, 111, 100, 101, 32, 37, 100, 10, 0, 0, 115, 116, 111, 114, 105, 110, 103, 32, 115, 116, 97, 116, 101, 115, 10, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 32, 58, 32, 37, 115, 10, 0, 0, 77, 101, 109, 111, 114, 121, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 10, 0, 0, 0, 0, 0, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 114, 101, 108, 97, 120, 110, 103, 46, 99, 0, 0, 0, 0, 97, 100, 100, 105, 110, 103, 32, 115, 116, 97, 116, 101, 115, 10, 0, 0, 35, 97, 110, 121, 0, 0, 0, 0, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 10, 0, 0, 0, 0, 0, 110, 111, 110, 97, 109, 101, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 116, 97, 116, 101, 115, 10, 0, 0, 0, 0, 0, 0, 78, 85, 76, 76, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 108, 105, 115, 116, 0, 0, 0, 0, 99, 97, 108, 108, 98, 97, 99, 107, 32, 111, 110, 32, 37, 115, 32, 109, 105, 115, 115, 105, 110, 103, 32, 99, 111, 110, 116, 101, 120, 116, 10, 0, 99, 97, 108, 108, 98, 97, 99, 107, 32, 111, 110, 32, 37, 115, 32, 109, 105, 115, 115, 105, 110, 103, 32, 100, 101, 102, 105, 110, 101, 10, 0, 0, 99, 97, 108, 108, 98, 97, 99, 107, 32, 111, 110, 32, 37, 115, 32, 109, 105, 115, 115, 105, 110, 103, 32, 105, 110, 102, 111, 10, 0, 0, 0, 0, 99, 97, 108, 108, 98, 97, 99, 107, 32, 111, 110, 32, 37, 115, 32, 100, 101, 102, 105, 110, 101, 32, 105, 115, 32, 110, 111, 116, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 112, 117, 115, 104, 105, 110, 103, 32, 101, 114, 114, 111, 114, 10, 0, 0, 82, 78, 71, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 116, 114, 121, 105, 110, 103, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 110, 101, 0, 0, 0, 0, 101, 109, 112, 116, 121, 0, 0, 0, 110, 111, 116, 65, 108, 108, 111, 119, 101, 100, 0, 0, 0, 0, 0, 0, 101, 120, 99, 101, 112, 116, 0, 0, 116, 101, 120, 116, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 0, 100, 97, 116, 97, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 118, 97, 108, 117, 101, 0, 0, 0, 108, 105, 115, 116, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 0, 100, 101, 102, 0, 0, 0, 0, 0, 114, 101, 102, 0, 0, 0, 0, 0, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 0, 0, 0, 0, 0, 112, 97, 114, 101, 110, 116, 82, 101, 102, 0, 0, 0, 0, 0, 0, 0, 111, 112, 116, 105, 111, 110, 97, 108, 0, 0, 0, 0, 0, 0, 0, 0, 122, 101, 114, 111, 79, 114, 77, 111, 114, 101, 0, 0, 0, 0, 0, 0, 111, 110, 101, 79, 114, 77, 111, 114, 101, 0, 0, 0, 0, 0, 0, 0, 99, 104, 111, 105, 99, 101, 0, 0, 103, 114, 111, 117, 112, 0, 0, 0, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 0, 0, 0, 0, 0, 0, 115, 116, 97, 114, 116, 0, 0, 0, 110, 111, 111, 112, 0, 0, 0, 0, 112, 97, 114, 97, 109, 0, 0, 0, 117, 110, 107, 110, 111, 119, 110, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 100, 101, 102, 105, 110, 101, 10, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 111, 114, 32, 116, 101, 120, 116, 32, 99, 111, 110, 102, 108, 105, 99, 116, 115, 32, 105, 110, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 99, 111, 110, 102, 108, 105, 99, 116, 115, 32, 105, 110, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 0, 0, 0, 0, 105, 110, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 32, 99, 111, 109, 112, 117, 116, 97, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 24, 231, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 103, 101, 116, 116, 105, 110, 103, 32, 101, 108, 101, 109, 101, 110, 116, 32, 108, 105, 115, 116, 10, 0, 0, 0, 103, 114, 97, 109, 109, 97, 114, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 114, 101, 102, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 102, 111, 117, 110, 100, 32, 110, 111, 32, 100, 101, 102, 105, 110, 101, 32, 102, 111, 114, 32, 112, 97, 114, 101, 110, 116, 32, 114, 101, 102, 115, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 102, 111, 117, 110, 100, 32, 110, 111, 32, 100, 101, 102, 105, 110, 101, 32, 102, 111, 114, 32, 114, 101, 102, 32, 37, 115, 10, 0, 0, 0, 0, 110, 117, 108, 108, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 101, 108, 101, 109, 101, 110, 116, 40, 114, 101, 102, 41, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 108, 105, 115, 116, 47, 47, 101, 108, 101, 109, 101, 110, 116, 40, 114, 101, 102, 41, 10, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 47, 47, 101, 108, 101, 109, 101, 110, 116, 40, 114, 101, 102, 41, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 104, 97, 118, 101, 32, 97, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 104, 97, 115, 32, 97, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 101, 114, 114, 111, 114, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 47, 47, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 108, 105, 115, 116, 47, 47, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 111, 110, 101, 79, 114, 77, 111, 114, 101, 47, 47, 103, 114, 111, 117, 112, 47, 47, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 111, 110, 101, 79, 114, 77, 111, 114, 101, 47, 47, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 47, 47, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 97, 110, 121, 78, 97, 109, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 116, 104, 111, 117, 116, 32, 111, 110, 101, 79, 114, 77, 111, 114, 101, 32, 97, 110, 99, 101, 115, 116, 111, 114, 10, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 110, 115, 78, 97, 109, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 116, 104, 111, 117, 116, 32, 111, 110, 101, 79, 114, 77, 111, 114, 101, 32, 97, 110, 99, 101, 115, 116, 111, 114, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 111, 110, 101, 79, 114, 77, 111, 114, 101, 10, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 111, 110, 101, 79, 114, 77, 111, 114, 101, 10, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 108, 105, 115, 116, 47, 47, 108, 105, 115, 116, 10, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 108, 105, 115, 116, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 108, 105, 115, 116, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 103, 114, 111, 117, 112, 10, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 103, 114, 111, 117, 112, 10, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 108, 105, 115, 116, 47, 47, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 100, 97, 116, 97, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 118, 97, 108, 117, 101, 10, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 108, 105, 115, 116, 47, 47, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 116, 101, 120, 116, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 116, 101, 120, 116, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 100, 97, 116, 97, 47, 101, 120, 99, 101, 112, 116, 47, 47, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 112, 97, 116, 116, 101, 114, 110, 32, 115, 116, 97, 114, 116, 47, 47, 101, 109, 112, 116, 121, 10, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 99, 104, 111, 105, 99, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 98, 117, 105, 108, 100, 105, 110, 103, 32, 103, 114, 111, 117, 112, 10, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 115, 32, 99, 111, 110, 102, 108, 105, 99, 116, 115, 32, 105, 110, 32, 103, 114, 111, 117, 112, 10, 0, 0, 68, 101, 116, 101, 99, 116, 101, 100, 32, 97, 32, 99, 121, 99, 108, 101, 32, 105, 110, 32, 37, 115, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 10, 0, 0, 0, 0, 0, 0, 115, 116, 97, 114, 116, 32, 104, 97, 115, 32, 110, 111, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 101, 109, 112, 116, 121, 32, 105, 115, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 116, 65, 108, 108, 111, 119, 101, 100, 32, 105, 115, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 114, 116, 32, 109, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 101, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 101, 109, 112, 116, 121, 58, 32, 104, 97, 100, 32, 97, 32, 99, 104, 105, 108, 100, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 116, 101, 120, 116, 58, 32, 104, 97, 100, 32, 97, 32, 99, 104, 105, 108, 100, 32, 110, 111, 100, 101, 10, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 114, 101, 102, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 114, 101, 102, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 114, 101, 102, 32, 105, 115, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 115, 32, 104, 97, 115, 104, 10, 0, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 32, 114, 101, 102, 115, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 115, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 69, 114, 114, 111, 114, 32, 114, 101, 102, 115, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 115, 10, 0, 100, 97, 116, 97, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 110, 111, 116, 65, 108, 108, 111, 119, 101, 100, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 115, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 85, 115, 101, 32, 111, 102, 32, 112, 97, 114, 101, 110, 116, 82, 101, 102, 32, 119, 105, 116, 104, 111, 117, 116, 32, 97, 32, 112, 97, 114, 101, 110, 116, 32, 103, 114, 97, 109, 109, 97, 114, 10, 0, 0, 0, 0, 0, 0, 112, 97, 114, 101, 110, 116, 82, 101, 102, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 112, 97, 114, 101, 110, 116, 82, 101, 102, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 0, 112, 97, 114, 101, 110, 116, 82, 101, 102, 32, 105, 115, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 10, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 112, 97, 114, 101, 110, 116, 82, 101, 102, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 115, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 109, 105, 120, 101, 100, 0, 0, 0, 77, 105, 120, 101, 100, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 85, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 110, 111, 100, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 112, 97, 116, 116, 101, 114, 110, 10, 0, 0, 0, 0, 110, 115, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 101, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 115, 10, 0, 0, 0, 0, 0, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 37, 100, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 97, 100, 100, 32, 37, 115, 32, 116, 111, 32, 104, 97, 115, 104, 32, 116, 97, 98, 108, 101, 10, 0, 69, 108, 101, 109, 101, 110, 116, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 116, 121, 112, 101, 0, 0, 0, 0, 118, 97, 108, 117, 101, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 114, 101, 108, 97, 120, 110, 103, 46, 111, 114, 103, 47, 110, 115, 47, 115, 116, 114, 117, 99, 116, 117, 114, 101, 47, 49, 46, 48, 0, 0, 0, 0, 0, 85, 115, 101, 32, 111, 102, 32, 117, 110, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 32, 116, 121, 112, 101, 32, 108, 105, 98, 114, 97, 114, 121, 32, 39, 37, 115, 39, 10, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 119, 105, 116, 104, 32, 116, 121, 112, 101, 32, 108, 105, 98, 114, 97, 114, 121, 32, 39, 37, 115, 39, 58, 32, 110, 111, 32, 39, 104, 97, 118, 101, 39, 10, 0, 0, 0, 0, 0, 0, 0, 69, 114, 114, 111, 114, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 101, 120, 112, 111, 114, 116, 101, 100, 32, 98, 121, 32, 116, 121, 112, 101, 32, 108, 105, 98, 114, 97, 114, 121, 32, 39, 37, 115, 39, 10, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 32, 115, 105, 110, 103, 108, 101, 32, 116, 101, 120, 116, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 60, 118, 97, 108, 117, 101, 62, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 60, 118, 97, 108, 117, 101, 62, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 86, 97, 108, 117, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 99, 99, 101, 112, 116, 97, 98, 108, 101, 32, 102, 111, 114, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 100, 97, 116, 97, 116, 121, 112, 101, 76, 105, 98, 114, 97, 114, 121, 0, 58, 47, 35, 63, 0, 0, 0, 0, 100, 97, 116, 97, 32, 104, 97, 115, 32, 110, 111, 32, 116, 121, 112, 101, 10, 0, 0, 0, 0, 0, 0, 0, 100, 97, 116, 97, 32, 116, 121, 112, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 73, 68, 82, 69, 70, 0, 0, 0, 73, 68, 82, 69, 70, 83, 0, 0, 84, 121, 112, 101, 32, 108, 105, 98, 114, 97, 114, 121, 32, 39, 37, 115, 39, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 32, 116, 121, 112, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 10, 0, 0, 0, 0, 0, 0, 0, 112, 97, 114, 97, 109, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 101, 120, 99, 101, 112, 116, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 100, 97, 116, 97, 32, 104, 97, 115, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 99, 111, 110, 116, 101, 110, 116, 32, 37, 115, 10, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 97, 116, 116, 114, 105, 98, 117, 116, 101, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 104, 97, 115, 32, 110, 111, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 104, 97, 115, 32, 105, 110, 118, 97, 108, 105, 100, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 82, 78, 71, 32, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 110, 111, 111, 112, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 104, 97, 115, 32, 109, 117, 108, 116, 105, 112, 108, 101, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 97, 110, 121, 78, 97, 109, 101, 0, 110, 115, 78, 97, 109, 101, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 110, 97, 109, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 48, 47, 120, 109, 108, 110, 115, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 116, 104, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 10, 0, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 119, 105, 116, 104, 32, 81, 78, 97, 109, 101, 32, 39, 120, 109, 108, 110, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 10, 0, 0, 0, 0, 110, 115, 78, 97, 109, 101, 32, 104, 97, 115, 32, 110, 111, 32, 110, 115, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 99, 104, 111, 105, 99, 101, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 101, 120, 112, 101, 99, 116, 105, 110, 103, 32, 110, 97, 109, 101, 44, 32, 97, 110, 121, 78, 97, 109, 101, 44, 32, 110, 115, 78, 97, 109, 101, 32, 111, 114, 32, 99, 104, 111, 105, 99, 101, 32, 58, 32, 103, 111, 116, 32, 37, 115, 10, 0, 0, 0, 0, 0, 110, 111, 116, 104, 105, 110, 103, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 110, 32, 101, 120, 99, 101, 112, 116, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 101, 120, 99, 101, 112, 116, 78, 97, 109, 101, 67, 108, 97, 115, 115, 32, 97, 108, 108, 111, 119, 115, 32, 111, 110, 108, 121, 32, 97, 32, 115, 105, 110, 103, 108, 101, 32, 101, 120, 99, 101, 112, 116, 32, 110, 111, 100, 101, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 58, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 69, 108, 101, 109, 101, 110, 116, 58, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 82, 78, 71, 32, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 115, 116, 97, 114, 116, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 82, 78, 71, 32, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 112, 97, 114, 97, 109, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 82, 78, 71, 32, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 82, 78, 71, 32, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 44, 32, 110, 111, 111, 112, 32, 102, 111, 117, 110, 100, 32, 105, 110, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 60, 103, 114, 97, 109, 109, 97, 114, 62, 32, 99, 111, 110, 116, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 69, 108, 101, 109, 101, 110, 116, 32, 60, 103, 114, 97, 109, 109, 97, 114, 62, 32, 104, 97, 115, 32, 110, 111, 32, 60, 115, 116, 97, 114, 116, 62, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 110, 111, 32, 103, 114, 97, 109, 109, 97, 114, 32, 105, 110, 32, 67, 104, 101, 99, 107, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 104, 97, 115, 32, 99, 111, 110, 116, 101, 110, 116, 32, 105, 110, 32, 67, 104, 101, 99, 107, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 82, 101, 102, 101, 114, 101, 110, 99, 101, 32, 37, 115, 32, 104, 97, 115, 32, 110, 111, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 109, 98, 105, 110, 101, 0, 68, 101, 102, 105, 110, 101, 115, 32, 102, 111, 114, 32, 37, 115, 32, 117, 115, 101, 32, 98, 111, 116, 104, 32, 39, 99, 104, 111, 105, 99, 101, 39, 32, 97, 110, 100, 32, 39, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 39, 10, 0, 0, 0, 0, 0, 0, 68, 101, 102, 105, 110, 101, 115, 32, 102, 111, 114, 32, 37, 115, 32, 117, 115, 101, 32, 117, 110, 107, 110, 111, 119, 110, 32, 99, 111, 109, 98, 105, 110, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 39, 10, 0, 83, 111, 109, 101, 32, 100, 101, 102, 105, 110, 101, 115, 32, 102, 111, 114, 32, 37, 115, 32, 110, 101, 101, 100, 115, 32, 116, 104, 101, 32, 99, 111, 109, 98, 105, 110, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 115, 32, 104, 97, 115, 104, 32, 116, 97, 98, 108, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 58, 32, 115, 116, 97, 114, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 0, 0, 60, 115, 116, 97, 114, 116, 62, 32, 117, 115, 101, 32, 98, 111, 116, 104, 32, 39, 99, 104, 111, 105, 99, 101, 39, 32, 97, 110, 100, 32, 39, 105, 110, 116, 101, 114, 108, 101, 97, 118, 101, 39, 10, 0, 0, 0, 0, 0, 60, 115, 116, 97, 114, 116, 62, 32, 117, 115, 101, 115, 32, 117, 110, 107, 110, 111, 119, 110, 32, 99, 111, 109, 98, 105, 110, 101, 32, 118, 97, 108, 117, 101, 32, 39, 37, 115, 39, 39, 10, 0, 0, 0, 0, 0, 0, 0, 83, 111, 109, 101, 32, 60, 115, 116, 97, 114, 116, 62, 32, 101, 108, 101, 109, 101, 110, 116, 32, 109, 105, 115, 115, 32, 116, 104, 101, 32, 99, 111, 109, 98, 105, 110, 101, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 103, 114, 97, 109, 109, 97, 114, 32, 104, 97, 115, 32, 110, 111, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 0, 0, 0, 0, 0, 0, 0, 100, 101, 102, 105, 110, 101, 0, 0, 105, 110, 99, 108, 117, 100, 101, 0, 103, 114, 97, 109, 109, 97, 114, 32, 104, 97, 115, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 99, 104, 105, 108, 100, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 99, 108, 117, 100, 101, 32, 110, 111, 100, 101, 32, 104, 97, 115, 32, 110, 111, 32, 100, 97, 116, 97, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 99, 108, 117, 100, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 105, 115, 32, 101, 109, 112, 116, 121, 10, 0, 0, 0, 0, 0, 0, 73, 110, 99, 108, 117, 100, 101, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 114, 111, 111, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 103, 114, 97, 109, 109, 97, 114, 10, 0, 100, 101, 102, 105, 110, 101, 32, 104, 97, 115, 32, 110, 111, 32, 110, 97, 109, 101, 10, 0, 0, 0, 0, 0, 100, 101, 102, 105, 110, 101, 32, 110, 97, 109, 101, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 0, 0, 0, 0, 100, 101, 102, 105, 110, 101, 32, 104, 97, 115, 32, 110, 111, 32, 99, 104, 105, 108, 100, 114, 101, 110, 10, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 104, 97, 115, 104, 10, 0, 0, 0, 0, 0, 0, 0, 73, 110, 116, 101, 114, 110, 97, 108, 32, 101, 114, 114, 111, 114, 32, 111, 110, 32, 100, 101, 102, 105, 110, 101, 32, 97, 103, 103, 114, 101, 103, 97, 116, 105, 111, 110, 32, 111, 102, 32, 37, 115, 10, 0, 0, 0, 0, 0, 101, 108, 101, 109, 101, 110, 116, 32, 37, 115, 32, 100, 111, 101, 115, 110, 39, 116, 32, 97, 108, 108, 111, 119, 32, 102, 111, 114, 101, 105, 103, 110, 32, 101, 108, 101, 109, 101, 110, 116, 115, 10, 0, 0, 0, 0, 0, 0, 104, 114, 101, 102, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 32, 104, 97, 115, 32, 110, 111, 32, 104, 114, 101, 102, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 0, 0, 0, 0, 73, 110, 99, 111, 114, 114, 101, 99, 116, 32, 85, 82, 73, 32, 102, 111, 114, 32, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 70, 114, 97, 103, 109, 101, 110, 116, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 105, 110, 32, 85, 82, 73, 32, 102, 111, 114, 32, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 32, 37, 115, 10, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 117, 116, 101, 32, 85, 82, 76, 32, 102, 111, 114, 32, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 32, 37, 115, 10, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 105, 110, 99, 108, 117, 100, 101, 32, 104, 97, 115, 32, 110, 111, 32, 104, 114, 101, 102, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 10, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 117, 116, 101, 32, 85, 82, 76, 32, 102, 111, 114, 32, 105, 110, 99, 108, 117, 100, 101, 32, 37, 115, 10, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 108, 111, 97, 100, 32, 105, 110, 99, 108, 117, 100, 101, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 114, 101, 97, 116, 101, 32, 97, 32, 110, 97, 109, 101, 32, 37, 115, 32, 101, 108, 101, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 80, 97, 114, 115, 101, 58, 32, 110, 111, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 102, 111, 114, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 10, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 110, 115, 78, 97, 109, 101, 47, 101, 120, 99, 101, 112, 116, 47, 47, 110, 115, 78, 97, 109, 101, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 97, 110, 121, 78, 97, 109, 101, 47, 101, 120, 99, 101, 112, 116, 47, 47, 97, 110, 121, 78, 97, 109, 101, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 10, 0, 0, 0, 0, 0, 0, 70, 111, 117, 110, 100, 32, 110, 115, 78, 97, 109, 101, 47, 101, 120, 99, 101, 112, 116, 47, 47, 97, 110, 121, 78, 97, 109, 101, 32, 102, 111, 114, 98, 105, 100, 100, 101, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 10, 0, 0, 0, 0, 0, 0, 0, 100, 105, 118, 0, 0, 0, 0, 0, 68, 101, 116, 101, 99, 116, 101, 100, 32, 97, 110, 32, 73, 110, 99, 108, 117, 100, 101, 32, 114, 101, 99, 117, 114, 115, 105, 111, 110, 32, 102, 111, 114, 32, 37, 115, 10, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 108, 111, 97, 100, 32, 37, 115, 10, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 105, 110, 99, 108, 117, 100, 101, 10, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 105, 115, 32, 101, 109, 112, 116, 121, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 37, 115, 32, 114, 111, 111, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 103, 114, 97, 109, 109, 97, 114, 10, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 105, 110, 99, 108, 117, 100, 101, 32, 37, 115, 32, 104, 97, 115, 32, 97, 32, 115, 116, 97, 114, 116, 32, 98, 117, 116, 32, 110, 111, 116, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 103, 114, 97, 109, 109, 97, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 105, 110, 99, 108, 117, 100, 101, 32, 37, 115, 32, 104, 97, 115, 32, 100, 101, 102, 105, 110, 101, 32, 119, 105, 116, 104, 111, 117, 116, 32, 110, 97, 109, 101, 10, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 105, 110, 99, 108, 117, 100, 101, 32, 37, 115, 32, 104, 97, 115, 32, 97, 32, 100, 101, 102, 105, 110, 101, 32, 37, 115, 32, 98, 117, 116, 32, 110, 111, 116, 32, 116, 104, 101, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 103, 114, 97, 109, 109, 97, 114, 10, 0, 0, 0, 0, 68, 101, 116, 101, 99, 116, 101, 100, 32, 97, 110, 32, 101, 120, 116, 101, 114, 110, 97, 108, 82, 101, 102, 32, 114, 101, 99, 117, 114, 115, 105, 111, 110, 32, 102, 111, 114, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 82, 101, 108, 97, 120, 78, 71, 58, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 100, 111, 99, 32, 37, 115, 10, 0, 97, 100, 100, 105, 110, 103, 32, 100, 111, 99, 117, 109, 101, 110, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 111, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32, 105, 110, 118, 97, 108, 105, 100, 32, 85, 82, 73, 32, 37, 115, 10, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 85, 82, 73, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 98, 115, 111, 108, 117, 116, 101, 10, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 85, 82, 73, 32, 37, 115, 32, 104, 97, 115, 32, 97, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 73, 68, 10, 0, 0, 85, 110, 107, 110, 111, 119, 110, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 110, 32, 37, 115, 10, 0, 0, 0, 0, 0, 115, 116, 114, 105, 110, 103, 0, 0, 116, 111, 107, 101, 110, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 50, 48, 48, 49, 47, 88, 77, 76, 83, 99, 104, 101, 109, 97, 0, 0, 0, 0, 0, 0, 0, 0, 109, 105, 110, 73, 110, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 109, 105, 110, 69, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 109, 97, 120, 73, 110, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 109, 97, 120, 69, 120, 99, 108, 117, 115, 105, 118, 101, 0, 0, 0, 0, 116, 111, 116, 97, 108, 68, 105, 103, 105, 116, 115, 0, 0, 0, 0, 0, 102, 114, 97, 99, 116, 105, 111, 110, 68, 105, 103, 105, 116, 115, 0, 0, 112, 97, 116, 116, 101, 114, 110, 0, 101, 110, 117, 109, 101, 114, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 119, 104, 105, 116, 101, 83, 112, 97, 99, 101, 0, 0, 0, 0, 0, 0, 108, 101, 110, 103, 116, 104, 0, 0, 109, 97, 120, 76, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 0, 0, 109, 105, 110, 76, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 0, 0, 82, 101, 108, 97, 120, 45, 78, 71, 32, 116, 121, 112, 101, 115, 32, 108, 105, 98, 114, 97, 114, 121, 32, 39, 37, 115, 39, 32, 97, 108, 114, 101, 97, 100, 121, 32, 114, 101, 103, 105, 115, 116, 101, 114, 101, 100, 10, 0, 97, 100, 100, 105, 110, 103, 32, 116, 121, 112, 101, 115, 32, 108, 105, 98, 114, 97, 114, 121, 10, 0, 0, 0, 82, 101, 108, 97, 120, 45, 78, 71, 32, 116, 121, 112, 101, 115, 32, 108, 105, 98, 114, 97, 114, 121, 32, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 114, 101, 103, 105, 115, 116, 101, 114, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 73, 110, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 69, 120, 116, 101, 114, 110, 97, 108, 83, 117, 98, 115, 101, 116, 0, 0, 0, 69, 110, 116, 105, 116, 121, 40, 37, 115, 41, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 32, 98, 117, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 0, 0, 70, 97, 105, 108, 117, 114, 101, 32, 116, 111, 32, 112, 114, 111, 99, 101, 115, 115, 32, 101, 110, 116, 105, 116, 121, 32, 37, 115, 10, 0, 0, 0, 69, 110, 116, 105, 116, 121, 40, 37, 115, 41, 32, 97, 108, 114, 101, 97, 100, 121, 32, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 69, 110, 116, 105, 116, 121, 40, 37, 115, 41, 32, 97, 108, 114, 101, 97, 100, 121, 32, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 120, 109, 108, 83, 65, 88, 50, 69, 110, 116, 105, 116, 121, 68, 101, 99, 108, 40, 37, 115, 41, 32, 99, 97, 108, 108, 101, 100, 32, 119, 104, 105, 108, 101, 32, 110, 111, 116, 32, 105, 110, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 120, 109, 108, 58, 105, 100, 0, 0, 120, 109, 108, 58, 105, 100, 32, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 116, 121, 112, 101, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 73, 68, 10, 0, 0, 0, 83, 65, 88, 46, 120, 109, 108, 83, 65, 88, 50, 65, 116, 116, 114, 105, 98, 117, 116, 101, 68, 101, 99, 108, 40, 37, 115, 41, 32, 99, 97, 108, 108, 101, 100, 32, 119, 104, 105, 108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 187248);
	        allocate([101, 32, 110, 111, 116, 32, 105, 110, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 88, 46, 120, 109, 108, 83, 65, 88, 50, 69, 108, 101, 109, 101, 110, 116, 68, 101, 99, 108, 40, 37, 115, 41, 32, 99, 97, 108, 108, 101, 100, 32, 119, 104, 105, 108, 101, 32, 110, 111, 116, 32, 105, 110, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 83, 65, 88, 46, 120, 109, 108, 83, 65, 88, 50, 78, 111, 116, 97, 116, 105, 111, 110, 68, 101, 99, 108, 40, 37, 115, 41, 32, 101, 120, 116, 101, 114, 110, 97, 108, 73, 68, 32, 111, 114, 32, 80, 117, 98, 108, 105, 99, 73, 68, 32, 109, 105, 115, 115, 105, 110, 103, 10, 0, 0, 0, 0, 0, 83, 65, 88, 46, 120, 109, 108, 83, 65, 88, 50, 78, 111, 116, 97, 116, 105, 111, 110, 68, 101, 99, 108, 40, 37, 115, 41, 32, 99, 97, 108, 108, 101, 100, 32, 119, 104, 105, 108, 101, 32, 110, 111, 116, 32, 105, 110, 32, 115, 117, 98, 115, 101, 116, 10, 0, 83, 65, 88, 46, 120, 109, 108, 83, 65, 88, 50, 85, 110, 112, 97, 114, 115, 101, 100, 69, 110, 116, 105, 116, 121, 68, 101, 99, 108, 40, 37, 115, 41, 32, 99, 97, 108, 108, 101, 100, 32, 119, 104, 105, 108, 101, 32, 110, 111, 116, 32, 105, 110, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 83, 116, 97, 114, 116, 68, 111, 99, 117, 109, 101, 110, 116, 0, 0, 0, 0, 86, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 102, 97, 105, 108, 101, 100, 58, 32, 110, 111, 32, 68, 84, 68, 32, 102, 111, 117, 110, 100, 32, 33, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 83, 116, 97, 114, 116, 69, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 83, 116, 97, 114, 116, 69, 108, 101, 109, 101, 110, 116, 78, 115, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 32, 119, 97, 115, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 112, 114, 101, 102, 105, 120, 32, 119, 97, 115, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 10, 0, 120, 109, 108, 83, 65, 88, 50, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 58, 32, 120, 109, 108, 83, 116, 114, 100, 117, 112, 32, 114, 101, 116, 117, 114, 110, 101, 100, 32, 78, 85, 76, 76, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 58, 32, 104, 117, 103, 101, 32, 116, 101, 120, 116, 32, 110, 111, 100, 101, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 32, 111, 118, 101, 114, 102, 108, 111, 119, 32, 112, 114, 101, 118, 101, 110, 116, 101, 100, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 65, 88, 50, 84, 101, 120, 116, 78, 111, 100, 101, 0, 120, 109, 108, 83, 65, 88, 50, 65, 116, 116, 114, 105, 98, 117, 116, 101, 78, 115, 0, 0, 0, 0, 0, 0, 120, 109, 108, 58, 105, 100, 32, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 118, 97, 108, 117, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 78, 67, 78, 97, 109, 101, 10, 0, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 65, 118, 111, 105, 100, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 101, 110, 100, 105, 110, 103, 32, 119, 105, 116, 104, 32, 39, 58, 39, 32, 108, 105, 107, 101, 32, 39, 37, 115, 39, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 58, 32, 37, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 85, 82, 73, 10, 0, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 58, 32, 85, 82, 73, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 98, 115, 111, 108, 117, 116, 101, 10, 0, 0, 69, 109, 112, 116, 121, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 32, 110, 97, 109, 101, 32, 102, 111, 114, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 10, 0, 0, 0, 0, 0, 120, 109, 108, 110, 115, 58, 37, 115, 58, 32, 37, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 108, 105, 100, 32, 85, 82, 73, 10, 0, 0, 0, 120, 109, 108, 110, 115, 58, 37, 115, 58, 32, 85, 82, 73, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 97, 98, 115, 111, 108, 117, 116, 101, 10, 0, 0, 0, 0, 0, 0, 0, 78, 97, 109, 101, 115, 112, 97, 99, 101, 32, 112, 114, 101, 102, 105, 120, 32, 37, 115, 32, 111, 102, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 105, 115, 32, 110, 111, 116, 32, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 0, 0, 65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 105, 110, 32, 37, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 10, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 58, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, 37, 115, 32, 111, 110, 32, 37, 115, 32, 100, 101, 102, 97, 117, 108, 116, 101, 100, 32, 102, 114, 111, 109, 32, 101, 120, 116, 101, 114, 110, 97, 108, 32, 115, 117, 98, 115, 101, 116, 10, 0, 0, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 49, 1, 52, 1, 62, 1, 65, 1, 72, 1, 74, 1, 126, 1, 128, 1, 195, 1, 205, 1, 240, 1, 244, 1, 245, 1, 250, 1, 23, 2, 80, 2, 168, 2, 187, 2, 193, 2, 134, 3, 134, 3, 136, 3, 138, 3, 140, 3, 140, 3, 142, 3, 161, 3, 163, 3, 206, 3, 208, 3, 214, 3, 218, 3, 218, 3, 220, 3, 220, 3, 222, 3, 222, 3, 224, 3, 224, 3, 226, 3, 243, 3, 1, 4, 12, 4, 14, 4, 79, 4, 81, 4, 92, 4, 94, 4, 129, 4, 144, 4, 196, 4, 199, 4, 200, 4, 203, 4, 204, 4, 208, 4, 235, 4, 238, 4, 245, 4, 248, 4, 249, 4, 49, 5, 86, 5, 89, 5, 89, 5, 97, 5, 134, 5, 208, 5, 234, 5, 240, 5, 242, 5, 33, 6, 58, 6, 65, 6, 74, 6, 113, 6, 183, 6, 186, 6, 190, 6, 192, 6, 206, 6, 208, 6, 211, 6, 213, 6, 213, 6, 229, 6, 230, 6, 5, 9, 57, 9, 61, 9, 61, 9, 88, 9, 97, 9, 133, 9, 140, 9, 143, 9, 144, 9, 147, 9, 168, 9, 170, 9, 176, 9, 178, 9, 178, 9, 182, 9, 185, 9, 220, 9, 221, 9, 223, 9, 225, 9, 240, 9, 241, 9, 5, 10, 10, 10, 15, 10, 16, 10, 19, 10, 40, 10, 42, 10, 48, 10, 50, 10, 51, 10, 53, 10, 54, 10, 56, 10, 57, 10, 89, 10, 92, 10, 94, 10, 94, 10, 114, 10, 116, 10, 133, 10, 139, 10, 141, 10, 141, 10, 143, 10, 145, 10, 147, 10, 168, 10, 170, 10, 176, 10, 178, 10, 179, 10, 181, 10, 185, 10, 189, 10, 189, 10, 224, 10, 224, 10, 5, 11, 12, 11, 15, 11, 16, 11, 19, 11, 40, 11, 42, 11, 48, 11, 50, 11, 51, 11, 54, 11, 57, 11, 61, 11, 61, 11, 92, 11, 93, 11, 95, 11, 97, 11, 133, 11, 138, 11, 142, 11, 144, 11, 146, 11, 149, 11, 153, 11, 154, 11, 156, 11, 156, 11, 158, 11, 159, 11, 163, 11, 164, 11, 168, 11, 170, 11, 174, 11, 181, 11, 183, 11, 185, 11, 5, 12, 12, 12, 14, 12, 16, 12, 18, 12, 40, 12, 42, 12, 51, 12, 53, 12, 57, 12, 96, 12, 97, 12, 133, 12, 140, 12, 142, 12, 144, 12, 146, 12, 168, 12, 170, 12, 179, 12, 181, 12, 185, 12, 222, 12, 222, 12, 224, 12, 225, 12, 5, 13, 12, 13, 14, 13, 16, 13, 18, 13, 40, 13, 42, 13, 57, 13, 96, 13, 97, 13, 1, 14, 46, 14, 48, 14, 48, 14, 50, 14, 51, 14, 64, 14, 69, 14, 129, 14, 130, 14, 132, 14, 132, 14, 135, 14, 136, 14, 138, 14, 138, 14, 141, 14, 141, 14, 148, 14, 151, 14, 153, 14, 159, 14, 161, 14, 163, 14, 165, 14, 165, 14, 167, 14, 167, 14, 170, 14, 171, 14, 173, 14, 174, 14, 176, 14, 176, 14, 178, 14, 179, 14, 189, 14, 189, 14, 192, 14, 196, 14, 64, 15, 71, 15, 73, 15, 105, 15, 160, 16, 197, 16, 208, 16, 246, 16, 0, 17, 0, 17, 2, 17, 3, 17, 5, 17, 7, 17, 9, 17, 9, 17, 11, 17, 12, 17, 14, 17, 18, 17, 60, 17, 60, 17, 62, 17, 62, 17, 64, 17, 64, 17, 76, 17, 76, 17, 78, 17, 78, 17, 80, 17, 80, 17, 84, 17, 85, 17, 89, 17, 89, 17, 95, 17, 97, 17, 99, 17, 99, 17, 101, 17, 101, 17, 103, 17, 103, 17, 105, 17, 105, 17, 109, 17, 110, 17, 114, 17, 115, 17, 117, 17, 117, 17, 158, 17, 158, 17, 168, 17, 168, 17, 171, 17, 171, 17, 174, 17, 175, 17, 183, 17, 184, 17, 186, 17, 186, 17, 188, 17, 194, 17, 235, 17, 235, 17, 240, 17, 240, 17, 249, 17, 249, 17, 0, 30, 155, 30, 160, 30, 249, 30, 0, 31, 21, 31, 24, 31, 29, 31, 32, 31, 69, 31, 72, 31, 77, 31, 80, 31, 87, 31, 89, 31, 89, 31, 91, 31, 91, 31, 93, 31, 93, 31, 95, 31, 125, 31, 128, 31, 180, 31, 182, 31, 188, 31, 190, 31, 190, 31, 194, 31, 196, 31, 198, 31, 204, 31, 208, 31, 211, 31, 214, 31, 219, 31, 224, 31, 236, 31, 242, 31, 244, 31, 246, 31, 252, 31, 38, 33, 38, 33, 42, 33, 43, 33, 46, 33, 46, 33, 128, 33, 130, 33, 65, 48, 148, 48, 161, 48, 250, 48, 5, 49, 44, 49, 0, 172, 163, 215, 0, 0, 0, 0, 197, 0, 0, 0, 0, 0, 0, 0, 40, 9, 3, 0, 0, 0, 0, 0, 0, 3, 69, 3, 96, 3, 97, 3, 131, 4, 134, 4, 145, 5, 161, 5, 163, 5, 185, 5, 187, 5, 189, 5, 191, 5, 191, 5, 193, 5, 194, 5, 196, 5, 196, 5, 75, 6, 82, 6, 112, 6, 112, 6, 214, 6, 220, 6, 221, 6, 223, 6, 224, 6, 228, 6, 231, 6, 232, 6, 234, 6, 237, 6, 1, 9, 3, 9, 60, 9, 60, 9, 62, 9, 76, 9, 77, 9, 77, 9, 81, 9, 84, 9, 98, 9, 99, 9, 129, 9, 131, 9, 188, 9, 188, 9, 190, 9, 190, 9, 191, 9, 191, 9, 192, 9, 196, 9, 199, 9, 200, 9, 203, 9, 205, 9, 215, 9, 215, 9, 226, 9, 227, 9, 2, 10, 2, 10, 60, 10, 60, 10, 62, 10, 62, 10, 63, 10, 63, 10, 64, 10, 66, 10, 71, 10, 72, 10, 75, 10, 77, 10, 112, 10, 113, 10, 129, 10, 131, 10, 188, 10, 188, 10, 190, 10, 197, 10, 199, 10, 201, 10, 203, 10, 205, 10, 1, 11, 3, 11, 60, 11, 60, 11, 62, 11, 67, 11, 71, 11, 72, 11, 75, 11, 77, 11, 86, 11, 87, 11, 130, 11, 131, 11, 190, 11, 194, 11, 198, 11, 200, 11, 202, 11, 205, 11, 215, 11, 215, 11, 1, 12, 3, 12, 62, 12, 68, 12, 70, 12, 72, 12, 74, 12, 77, 12, 85, 12, 86, 12, 130, 12, 131, 12, 190, 12, 196, 12, 198, 12, 200, 12, 202, 12, 205, 12, 213, 12, 214, 12, 2, 13, 3, 13, 62, 13, 67, 13, 70, 13, 72, 13, 74, 13, 77, 13, 87, 13, 87, 13, 49, 14, 49, 14, 52, 14, 58, 14, 71, 14, 78, 14, 177, 14, 177, 14, 180, 14, 185, 14, 187, 14, 188, 14, 200, 14, 205, 14, 24, 15, 25, 15, 53, 15, 53, 15, 55, 15, 55, 15, 57, 15, 57, 15, 62, 15, 62, 15, 63, 15, 63, 15, 113, 15, 132, 15, 134, 15, 139, 15, 144, 15, 149, 15, 151, 15, 151, 15, 153, 15, 173, 15, 177, 15, 183, 15, 185, 15, 185, 15, 208, 32, 220, 32, 225, 32, 225, 32, 42, 48, 47, 48, 153, 48, 153, 48, 154, 48, 154, 48, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 0, 0, 80, 12, 3, 0, 0, 0, 0, 0, 96, 6, 105, 6, 240, 6, 249, 6, 102, 9, 111, 9, 230, 9, 239, 9, 102, 10, 111, 10, 230, 10, 239, 10, 102, 11, 111, 11, 231, 11, 239, 11, 102, 12, 111, 12, 230, 12, 239, 12, 102, 13, 111, 13, 80, 14, 89, 14, 208, 14, 217, 14, 32, 15, 41, 15, 14, 0, 0, 0, 0, 0, 0, 0, 224, 13, 3, 0, 0, 0, 0, 0, 208, 2, 208, 2, 209, 2, 209, 2, 135, 3, 135, 3, 64, 6, 64, 6, 70, 14, 70, 14, 198, 14, 198, 14, 5, 48, 5, 48, 49, 48, 53, 48, 157, 48, 158, 48, 252, 48, 254, 48, 10, 0, 0, 0, 0, 0, 0, 0, 40, 14, 3, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 88, 77, 76, 47, 49, 57, 57, 56, 47, 110, 97, 109, 101, 115, 112, 97, 99, 101, 0, 0, 0, 0, 99, 104, 105, 108, 100, 0, 0, 0, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 0, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 88, 72, 84, 77, 76, 32, 49, 46, 48, 32, 83, 116, 114, 105, 99, 116, 47, 47, 69, 78, 0, 0, 0, 0, 0, 0, 0, 0, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 88, 72, 84, 77, 76, 32, 49, 46, 48, 32, 70, 114, 97, 109, 101, 115, 101, 116, 47, 47, 69, 78, 0, 0, 0, 0, 0, 0, 45, 47, 47, 87, 51, 67, 47, 47, 68, 84, 68, 32, 88, 72, 84, 77, 76, 32, 49, 46, 48, 32, 84, 114, 97, 110, 115, 105, 116, 105, 111, 110, 97, 108, 47, 47, 69, 78, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 84, 82, 47, 120, 104, 116, 109, 108, 49, 47, 68, 84, 68, 47, 120, 104, 116, 109, 108, 49, 45, 115, 116, 114, 105, 99, 116, 46, 100, 116, 100, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 84, 82, 47, 120, 104, 116, 109, 108, 49, 47, 68, 84, 68, 47, 120, 104, 116, 109, 108, 49, 45, 102, 114, 97, 109, 101, 115, 101, 116, 46, 100, 116, 100, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 84, 82, 47, 120, 104, 116, 109, 108, 49, 47, 68, 84, 68, 47, 120, 104, 116, 109, 108, 49, 45, 116, 114, 97, 110, 115, 105, 116, 105, 111, 110, 97, 108, 46, 100, 116, 100, 0, 38, 35, 49, 48, 59, 0, 0, 0, 38, 35, 49, 51, 59, 0, 0, 0, 38, 35, 57, 59, 0, 0, 0, 0, 38, 113, 117, 111, 116, 59, 0, 0, 38, 108, 116, 59, 0, 0, 0, 0, 38, 103, 116, 59, 0, 0, 0, 0, 38, 97, 109, 112, 59, 0, 0, 0, 73, 83, 79, 45, 56, 56, 53, 57, 45, 49, 0, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 85, 84, 70, 45, 56, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 111, 117, 116, 112, 117, 116, 0, 60, 63, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 63, 62, 0, 0, 0, 0, 0, 0, 60, 33, 45, 45, 0, 0, 0, 0, 45, 45, 62, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 60, 33, 91, 67, 68, 65, 84, 65, 91, 93, 93, 62, 0, 0, 0, 0, 60, 33, 91, 67, 68, 65, 84, 65, 91, 0, 0, 0, 0, 0, 0, 0, 93, 93, 62, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 104, 116, 109, 108, 0, 0, 0, 0, 32, 120, 109, 108, 110, 115, 61, 34, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 49, 57, 57, 57, 47, 120, 104, 116, 109, 108, 34, 0, 0, 0, 104, 101, 97, 100, 0, 0, 0, 0, 109, 101, 116, 97, 0, 0, 0, 0, 104, 116, 116, 112, 45, 101, 113, 117, 105, 118, 0, 0, 0, 0, 0, 0, 67, 111, 110, 116, 101, 110, 116, 45, 84, 121, 112, 101, 0, 0, 0, 0, 32, 47, 62, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 60, 109, 101, 116, 97, 32, 104, 116, 116, 112, 45, 101, 113, 117, 105, 118, 61, 34, 67, 111, 110, 116, 101, 110, 116, 45, 84, 121, 112, 101, 34, 32, 99, 111, 110, 116, 101, 110, 116, 61, 34, 116, 101, 120, 116, 47, 104, 116, 109, 108, 59, 32, 99, 104, 97, 114, 115, 101, 116, 61, 0, 0, 0, 0, 34, 32, 47, 62, 0, 0, 0, 0, 60, 47, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 119, 51, 46, 111, 114, 103, 47, 49, 57, 57, 57, 47, 120, 104, 116, 109, 108, 0, 0, 0, 0, 97, 114, 101, 97, 0, 0, 0, 0, 98, 114, 0, 0, 0, 0, 0, 0, 98, 97, 115, 101, 0, 0, 0, 0, 98, 97, 115, 101, 102, 111, 110, 116, 0, 0, 0, 0, 0, 0, 0, 0, 99, 111, 108, 0, 0, 0, 0, 0, 102, 114, 97, 109, 101, 0, 0, 0, 104, 114, 0, 0, 0, 0, 0, 0, 105, 109, 103, 0, 0, 0, 0, 0, 105, 110, 112, 117, 116, 0, 0, 0, 105, 115, 105, 110, 100, 101, 120, 0, 108, 105, 110, 107, 0, 0, 0, 0, 112, 97, 114, 97, 109, 0, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 108, 97, 110, 103, 0, 0, 0, 0, 120, 109, 108, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 100, 105, 118, 0, 0, 0, 0, 0, 109, 97, 112, 0, 0, 0, 0, 0, 97, 112, 112, 108, 101, 116, 0, 0, 102, 111, 114, 109, 0, 0, 0, 0, 105, 102, 114, 97, 109, 101, 0, 0, 32, 105, 100, 61, 34, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 32, 120, 109, 108, 58, 108, 97, 110, 103, 61, 34, 0, 0, 0, 0, 0, 32, 108, 97, 110, 103, 61, 34, 0, 61, 34, 0, 0, 0, 0, 0, 0, 60, 33, 68, 79, 67, 84, 89, 80, 69, 32, 0, 0, 0, 0, 0, 0, 32, 80, 85, 66, 76, 73, 67, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 83, 89, 83, 84, 69, 77, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 91, 10, 0, 0, 0, 0, 0, 93, 62, 0, 0, 0, 0, 0, 0, 120, 109, 108, 69, 115, 99, 97, 112, 101, 69, 110, 116, 105, 116, 105, 101, 115, 32, 58, 32, 99, 104, 97, 114, 32, 111, 117, 116, 32, 111, 102, 32, 114, 97, 110, 103, 101, 10, 0, 0, 115, 116, 114, 105, 110, 103, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 32, 85, 84, 70, 45, 56, 10, 0, 105, 110, 118, 97, 108, 105, 100, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 118, 97, 108, 117, 101, 10, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 107, 110, 111, 119, 110, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 37, 115, 10, 0, 0, 0, 0, 100, 111, 99, 117, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 68, 79, 67, 84, 89, 80, 69, 10, 0, 0, 0, 0, 0, 0, 0, 0, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 101, 114, 114, 111, 114, 32, 110, 117, 109, 98, 101, 114, 10, 0, 0, 0, 0, 0, 0, 0, 0, 47, 62, 0, 0, 0, 0, 0, 0, 72, 84, 77, 76, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 101, 110, 99, 111, 100, 105, 110, 103, 32, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 60, 63, 120, 109, 108, 32, 118, 101, 114, 115, 105, 111, 110, 61, 0, 0, 34, 49, 46, 48, 34, 0, 0, 0, 32, 101, 110, 99, 111, 100, 105, 110, 103, 61, 0, 0, 0, 0, 0, 0, 32, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 61, 34, 110, 111, 34, 0, 0, 0, 0, 0, 0, 0, 0, 32, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 61, 34, 121, 101, 115, 34, 0, 0, 0, 0, 0, 0, 0, 63, 62, 10, 0, 0, 0, 0, 0, 99, 114, 101, 97, 116, 105, 110, 103, 32, 115, 97, 118, 105, 110, 103, 32, 99, 111, 110, 116, 101, 120, 116, 0, 120, 109, 108, 110, 115, 58, 0, 0, 120, 109, 108, 110, 115, 0, 0, 0, 61, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 112, 97, 114, 115, 101, 114, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 112, 97, 114, 115, 101, 114, 32, 88, 80, 97, 116, 104, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 116, 114, 111, 110, 80, 97, 114, 115, 101, 58, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 108, 111, 97, 100, 32, 39, 37, 115, 39, 46, 10, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 83, 99, 104, 101, 109, 97, 116, 114, 111, 110, 80, 97, 114, 115, 101, 58, 32, 99, 111, 117, 108, 100, 32, 110, 111, 116, 32, 112, 97, 114, 115, 101, 46, 10, 0, 0, 0, 105, 110, 95, 109, 101, 109, 111, 114, 121, 95, 98, 117, 102, 102, 101, 114, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 32, 104, 97, 115, 32, 110, 111, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 101, 108, 101, 109, 101, 110, 116, 46, 10, 0, 0, 0, 0, 115, 99, 104, 101, 109, 97, 0, 0, 96, 25, 3, 0, 0, 0, 0, 0, 56, 25, 3, 0, 0, 0, 0, 0, 84, 104, 101, 32, 88, 77, 76, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 88, 77, 76, 32, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 32, 100, 111, 99, 117, 109, 101, 110, 116, 0, 0, 116, 105, 116, 108, 101, 0, 0, 0, 110, 115, 0, 0, 0, 0, 0, 0, 112, 114, 101, 102, 105, 120, 0, 0, 117, 114, 105, 0, 0, 0, 0, 0, 110, 115, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 117, 114, 105, 0, 0, 0, 110, 115, 32, 101, 108, 101, 109, 101, 110, 116, 32, 104, 97, 115, 32, 110, 111, 32, 112, 114, 101, 102, 105, 120, 0, 0, 0, 0, 0, 0, 0, 0, 112, 97, 116, 116, 101, 114, 110, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 32, 112, 97, 116, 116, 101, 114, 110, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 37, 115, 0, 0, 0, 0, 0, 0, 0, 84, 104, 101, 32, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 32, 100, 111, 99, 117, 109, 101, 110, 116, 32, 39, 37, 115, 39, 32, 104, 97, 115, 32, 110, 111, 32, 112, 97, 116, 116, 101, 114, 110, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 101, 120, 116, 0, 0, 0, 85, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 98, 108, 111, 99, 107, 32, 97, 116, 32, 37, 115, 58, 37, 100, 10, 0, 0, 0, 46, 46, 47, 108, 105, 98, 120, 109, 108, 50, 47, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 46, 99, 0, 80, 97, 116, 116, 101, 114, 110, 58, 32, 37, 115, 10, 0, 0, 0, 0, 37, 115, 0, 0, 0, 0, 0, 0, 110, 111, 100, 101, 32, 102, 97, 105, 108, 101, 100, 32, 97, 115, 115, 101, 114, 116, 0, 0, 0, 0, 0, 0, 110, 111, 100, 101, 32, 102, 97, 105, 108, 101, 100, 32, 114, 101, 112, 111, 114, 116, 0, 0, 0, 0, 0, 0, 37, 115, 32, 108, 105, 110, 101, 32, 37, 108, 100, 58, 32, 37, 115, 10, 0, 0, 0, 0, 0, 0, 0, 0, 110, 97, 109, 101, 0, 0, 0, 0, 112, 97, 116, 104, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 105, 100, 0, 0, 0, 0, 0, 0, 114, 117, 108, 101, 0, 0, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 32, 114, 117, 108, 101, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 37, 115, 0, 0, 80, 97, 116, 116, 101, 114, 110, 32, 104, 97, 115, 32, 110, 111, 32, 114, 117, 108, 101, 32, 101, 108, 101, 109, 101, 110, 116, 0, 0, 0, 0, 0, 99, 111, 110, 116, 101, 120, 116, 0, 114, 117, 108, 101, 32, 104, 97, 115, 32, 110, 111, 32, 99, 111, 110, 116, 101, 120, 116, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 114, 117, 108, 101, 32, 104, 97, 115, 32, 97, 110, 32, 101, 109, 112, 116, 121, 32, 99, 111, 110, 116, 101, 120, 116, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 97, 115, 115, 101, 114, 116, 0, 0, 116, 101, 115, 116, 0, 0, 0, 0, 97, 115, 115, 101, 114, 116, 32, 104, 97, 115, 32, 110, 111, 32, 116, 101, 115, 116, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 97, 115, 115, 101, 114, 116, 32, 104, 97, 115, 32, 97, 110, 32, 101, 109, 112, 116, 121, 32, 116, 101, 115, 116, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0, 0, 0, 0, 0, 0, 114, 101, 112, 111, 114, 116, 0, 0, 69, 120, 112, 101, 99, 116, 105, 110, 103, 32, 97, 110, 32, 97, 115, 115, 101, 114, 116, 32, 111, 114, 32, 97, 32, 114, 101, 112, 111, 114, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 37, 115, 0, 0, 0, 114, 117, 108, 101, 32, 104, 97, 115, 32, 110, 111, 32, 97, 115, 115, 101, 114, 116, 32, 110, 111, 114, 32, 114, 101, 112, 111, 114, 116, 32, 101, 108, 101, 109, 101, 110, 116, 0, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 32, 116, 101, 115, 116, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 37, 115, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 116, 101, 115, 116, 0, 0, 70, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 109, 112, 105, 108, 101, 32, 99, 111, 110, 116, 101, 120, 116, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 37, 115, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 114, 117, 108, 101, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 32, 112, 97, 116, 116, 101, 114, 110, 0, 0, 0, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 112, 97, 114, 115, 101, 114, 32, 110, 97, 109, 101, 115, 112, 97, 99, 101, 115, 0, 0, 0, 0, 97, 108, 108, 111, 99, 97, 116, 105, 110, 103, 32, 115, 99, 104, 101, 109, 97, 0, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 97, 115, 99, 99, 46, 110, 101, 116, 47, 120, 109, 108, 47, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 0, 0, 0, 0, 0, 0, 104, 116, 116, 112, 58, 47, 47, 112, 117, 114, 108, 46, 111, 99, 108, 99, 46, 111, 114, 103, 47, 100, 115, 100, 108, 47, 115, 99, 104, 101, 109, 97, 116, 114, 111, 110, 0, 0, 0, 0, 67, 97, 110, 110, 111, 116, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 108, 105, 115, 116, 0, 0, 0, 0, 0, 0, 0, 67, 97, 110, 110, 111, 116, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 115, 101, 110, 116, 105, 110, 101, 108, 0, 0, 0, 67, 97, 110, 110, 111, 116, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 110, 101, 119, 32, 108, 105, 110, 107, 0, 0, 0, 117, 116, 102, 56, 0, 0, 200, 119, 99, 104, 97, 114, 116, 0, 0, 198, 117, 99, 115, 50, 0, 117, 99, 115, 50, 98, 101, 0, 0, 196, 117, 99, 115, 50, 108, 101, 0, 0, 197, 117, 116, 102, 49, 54, 0, 117, 116, 102, 49, 54, 98, 101, 0, 0, 194, 117, 116, 102, 49, 54, 108, 101, 0, 0, 193, 117, 99, 115, 52, 0, 117, 99, 115, 52, 98, 101, 0, 117, 116, 102, 51, 50, 0, 117, 116, 102, 51, 50, 98, 101, 0, 0, 192, 117, 99, 115, 52, 108, 101, 0, 117, 116, 102, 51, 50, 108, 101, 0, 0, 195, 97, 115, 99, 105, 105, 0, 117, 115, 97, 115, 99, 105, 105, 0, 105, 115, 111, 54, 52, 54, 0, 105, 115, 111, 54, 52, 54, 117, 115, 0, 0, 199, 101, 117, 99, 106, 112, 0, 0, 208, 115, 104, 105, 102, 116, 106, 105, 115, 0, 115, 106, 105, 115, 0, 0, 209, 103, 98, 49, 56, 48, 51, 48, 0, 0, 216, 103, 98, 107, 0, 0, 217, 103, 98, 50, 51, 49, 50, 0, 0, 218, 98, 105, 103, 53, 0, 98, 105, 103, 102, 105, 118, 101, 0, 99, 112, 57, 53, 48, 0, 98, 105, 103, 53, 104, 107, 115, 99, 115, 0, 0, 224, 101, 117, 99, 107, 114, 0, 107, 115, 99, 53, 54, 48, 49, 0, 107, 115, 120, 49, 48, 48, 49, 0, 99, 112, 57, 52, 57, 0, 0, 232, 105, 115, 111, 56, 56, 53, 57, 49, 0, 108, 97, 116, 105, 110, 49, 0, 0, 128, 105, 115, 111, 56, 56, 53, 57, 50, 0, 0, 32, 0, 84, 0, 137, 18, 0, 32, 1, 6, 0, 0, 152, 65, 134, 26, 127, 0, 48, 72, 32, 0, 88, 32, 201, 18, 0, 36, 17, 198, 35, 0, 156, 81, 198, 26, 128, 80, 66, 136, 32, 90, 0, 0, 192, 4, 0, 16, 113, 1, 0, 29, 0, 112, 2, 0, 41, 0, 0, 192, 7, 33, 48, 1, 5, 0, 0, 88, 1, 0, 0, 94, 208, 1, 128, 29, 0, 0, 128, 6, 0, 91, 0, 0, 0, 5, 0, 20, 129, 1, 0, 30, 0, 128, 2, 0, 42, 0, 0, 0, 8, 34, 52, 17, 5, 0, 0, 92, 1, 0, 0, 95, 212, 1, 192, 29, 0, 0, 144, 70, 36, 105, 115, 111, 56, 56, 53, 57, 51, 0, 0, 32, 0, 212, 0, 9, 0, 0, 4, 48, 3, 0, 0, 244, 64, 70, 11, 63, 0, 16, 64, 32, 0, 216, 0, 0, 0, 0, 0, 64, 3, 0, 0, 248, 80, 134, 11, 64, 0, 16, 128, 32, 0, 0, 0, 64, 0, 0, 108, 144, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 188, 0, 0, 0, 43, 0, 0, 0, 0, 0, 200, 33, 6, 0, 0, 0, 0, 64, 0, 0, 112, 160, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 192, 0, 0, 0, 44, 0, 0, 0, 0, 0, 204, 49, 70, 36, 105, 115, 111, 56, 56, 53, 57, 52, 0, 0, 32, 0, 84, 48, 4, 23, 0, 220, 96, 4, 0, 0, 152, 49, 66, 12, 108, 0, 48, 8, 0, 0, 88, 32, 73, 23, 0, 224, 112, 196, 35, 0, 156, 65, 130, 12, 109, 72, 65, 200, 20, 17, 0, 0, 0, 0, 0, 0, 0, 192, 14, 29, 0, 112, 2, 0, 37, 0, 0, 64, 14, 33, 56, 65, 69, 16, 0, 0, 0, 0, 0, 0, 224, 1, 0, 0, 0, 184, 1, 7, 0, 18, 0, 0, 0, 0, 0, 0, 0, 0, 15, 30, 0, 128, 2, 0, 38, 0, 0, 128, 14, 34, 60, 81, 133, 16, 0, 0, 0, 0, 0, 0, 228, 1, 0, 0, 0, 188, 17, 71, 36, 105, 115, 111, 56, 56, 53, 57, 53, 0, 0, 32, 0, 136, 51, 14, 57, 229, 152, 115, 14, 58, 233, 168, 179, 14, 59, 237, 0, 224, 206, 59, 240, 196, 35, 207, 60, 244, 212, 99, 207, 61, 248, 228, 163, 207, 62, 252, 244, 227, 207, 63, 0, 5, 36, 208, 64, 4, 21, 100, 208, 65, 8, 37, 164, 208, 66, 12, 53, 228, 208, 67, 16, 69, 36, 209, 68, 20, 85, 100, 209, 69, 24, 101, 164, 209, 70, 28, 117, 228, 209, 71, 32, 133, 36, 210, 72, 36, 149, 100, 210, 73, 40, 165, 164, 210, 74, 44, 181, 228, 210, 75, 53, 194, 20, 147, 76, 51, 209, 84, 147, 77, 55, 225, 148, 147, 78, 59, 13, 192, 83, 79, 105, 115, 111, 56, 56, 53, 57, 54, 0, 0, 32, 0, 4, 16, 64, 0, 0, 4, 16, 64, 0, 1, 4, 16, 64, 0, 115, 1, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 0, 93, 1, 4, 16, 64, 93, 1, 216, 117, 23, 94, 121, 233, 181, 23, 95, 125, 249, 245, 23, 96, 129, 9, 54, 24, 97, 133, 25, 118, 24, 98, 137, 41, 182, 24, 99, 141, 57, 246, 88, 0, 1, 4, 16, 64, 0, 144, 69, 38, 217, 100, 148, 85, 102, 217, 101, 152, 101, 166, 217, 102, 156, 117, 230, 217, 103, 160, 133, 38, 90, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 105, 115, 111, 56, 56, 53, 57, 55, 0, 0, 32, 0, 144, 88, 34, 0, 51, 210, 8, 0, 0, 0, 0, 160, 9, 0, 0, 0, 16, 128, 136, 0, 0, 0, 0, 0, 155, 112, 210, 9, 0, 158, 124, 2, 10, 0, 161, 0, 32, 202, 40, 164, 148, 98, 202, 41, 168, 164, 162, 202, 42, 172, 180, 226, 202, 43, 176, 196, 34, 203, 44, 180, 212, 18, 128, 45, 183, 224, 146, 139, 46, 187, 240, 210, 139, 47, 191, 0, 19, 140, 48, 195, 16, 83, 140, 49, 199, 32, 147, 140, 50, 203, 48, 211, 140, 51, 207, 64, 19, 141, 52, 211, 80, 83, 141, 53, 215, 96, 147, 141, 54, 219, 112, 211, 141, 55, 223, 128, 19, 78, 0, 105, 115, 111, 56, 56, 53, 57, 56, 0, 0, 32, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 0, 0, 0, 0, 0, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 64, 0, 1, 4, 16, 192, 136, 83, 81, 85, 149, 85, 87, 97, 149, 149, 86, 91, 113, 213, 149, 87, 95, 129, 21, 150, 88, 99, 145, 85, 150, 89, 103, 161, 149, 150, 90, 107, 177, 213, 86, 0, 1, 120, 248, 97, 0, 105, 115, 111, 56, 56, 53, 57, 57, 0, 0, 80, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 64, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 80, 6, 0, 105, 115, 111, 56, 56, 53, 57, 49, 48, 0, 0, 32, 0, 84, 48, 66, 12, 57, 220, 16, 4, 0, 70, 132, 96, 6, 27, 131, 0, 0, 135, 20, 0, 88, 64, 130, 12, 58, 224, 32, 4, 0, 71, 136, 112, 70, 27, 132, 136, 24, 199, 20, 17, 0, 0, 0, 0, 0, 0, 0, 192, 14, 29, 0, 112, 2, 0, 37, 0, 0, 0, 0, 0, 56, 65, 5, 0, 0, 0, 0, 128, 27, 0, 224, 1, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 0, 15, 30, 0, 128, 2, 0, 38, 0, 0, 0, 0, 0, 60, 81, 5, 0, 0, 0, 0, 192, 27, 0, 228, 1, 0, 0, 0, 0, 0, 192, 16, 105, 115, 111, 56, 56, 53, 57, 49, 49, 0, 116, 105, 115, 54, 50, 48, 0, 0, 32, 0, 188, 6, 91, 108, 178, 205, 70, 91, 109, 182, 221, 134, 91, 110, 186, 237, 198, 91, 111, 190, 253, 6, 92, 112, 194, 13, 71, 92, 113, 198, 29, 135, 92, 114, 202, 45, 199, 92, 115, 206, 61, 7, 93, 116, 210, 77, 71, 93, 117, 214, 93, 135, 93, 118, 218, 109, 199, 93, 119, 222, 125, 7, 94, 120, 226, 141, 71, 94, 121, 230, 157, 135, 94, 0, 1, 4, 16, 64, 122, 234, 173, 199, 94, 123, 238, 189, 7, 95, 124, 242, 205, 71, 95, 125, 246, 221, 135, 95, 126, 250, 237, 199, 95, 127, 254, 253, 7, 96, 128, 2, 14, 72, 96, 129, 1, 4, 16, 64, 0, 105, 115, 111, 56, 56, 53, 57, 49, 51, 0, 0, 32, 0, 160, 8, 0, 0, 0, 164, 8, 0, 0, 13, 0, 192, 5, 0, 0, 0, 0, 192, 2, 0, 0, 0, 0, 0, 39, 2, 0, 0, 0, 16, 0, 208, 5, 0, 0, 0, 0, 128, 3, 21, 236, 16, 193, 5, 0, 0, 112, 194, 8, 29, 0, 240, 71, 9, 49, 4, 145, 131, 17, 102, 48, 225, 4, 0, 84, 0, 0, 0, 0, 120, 40, 1, 6, 28, 0, 4, 50, 8, 0, 22, 240, 32, 1, 6, 0, 0, 128, 2, 9, 30, 0, 0, 136, 9, 50, 8, 161, 195, 17, 103, 52, 241, 4, 0, 85, 0, 0, 0, 0, 121, 44, 17, 70, 28, 0, 8, 66, 72, 137, 105, 115, 111, 56, 56, 53, 57, 49, 52, 0, 0, 32, 0, 24, 120, 32, 0, 27, 112, 128, 32, 0, 20, 2, 96, 97, 130, 26, 2, 0, 128, 31, 10, 46, 248, 2, 12, 12, 54, 8, 128, 131, 21, 62, 120, 33, 132, 27, 98, 152, 97, 132, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 0, 0, 0, 0, 0, 0, 0, 128, 132, 0, 0, 0, 0, 0, 0, 0, 192, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, 0, 0, 0, 0, 0, 192, 132, 0, 0, 0, 0, 0, 0, 0, 208, 7, 0, 105, 115, 111, 56, 56, 53, 57, 49, 53, 0, 108, 97, 116, 105, 110, 57, 0, 0, 36, 51, 2, 96, 6, 0, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 0, 0, 0, 0, 132, 0, 0, 0, 0, 88, 100, 225, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 115, 111, 56, 56, 53, 57, 49, 54, 0, 0, 32, 0, 84, 96, 129, 18, 51, 166, 104, 6, 0, 103, 0, 160, 8, 0, 127, 0, 0, 72, 32, 0, 0, 208, 193, 18, 131, 160, 8, 0, 0, 132, 120, 176, 8, 0, 88, 100, 225, 135, 32, 0, 0, 0, 192, 4, 0, 92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 48, 1, 0, 0, 0, 88, 1, 0, 24, 118, 0, 0, 0, 0, 0, 156, 192, 8, 0, 0, 0, 0, 0, 5, 0, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 52, 1, 0, 0, 0, 92, 1, 64, 24, 119, 0, 0, 0, 0, 0, 160, 208, 8, 0, 99, 112, 49, 50, 53, 48, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 48, 0, 0, 0, 51, 6, 96, 98, 0, 41, 182, 168, 226, 138, 1, 184, 104, 198, 139, 96, 168, 49, 200, 31, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 1, 216, 120, 6, 140, 97, 172, 65, 8, 32, 0, 60, 2, 137, 18, 0, 84, 0, 0, 0, 0, 0, 64, 6, 0, 0, 0, 0, 64, 32, 0, 0, 32, 201, 18, 0, 0, 0, 0, 0, 0, 88, 80, 6, 0, 72, 80, 146, 132, 32, 90, 0, 0, 192, 4, 0, 16, 113, 1, 0, 29, 0, 112, 2, 0, 41, 0, 0, 192, 7, 33, 48, 1, 5, 0, 0, 88, 1, 0, 0, 94, 208, 1, 128, 29, 0, 0, 128, 6, 0, 91, 0, 0, 0, 5, 0, 20, 129, 1, 0, 30, 0, 128, 2, 0, 42, 0, 0, 0, 8, 34, 52, 17, 5, 0, 0, 92, 1, 0, 0, 95, 212, 1, 192, 29, 0, 0, 144, 70, 36, 99, 112, 49, 50, 53, 49, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 49, 0, 0, 0, 227, 144, 99, 162, 76, 41, 182, 168, 226, 138, 51, 186, 168, 206, 139, 235, 180, 195, 206, 59, 49, 145, 88, 226, 137, 40, 178, 8, 98, 136, 1, 216, 136, 19, 140, 57, 237, 164, 83, 79, 0, 184, 195, 83, 58, 0, 248, 4, 0, 0, 226, 0, 80, 14, 0, 0, 0, 0, 0, 58, 0, 0, 112, 78, 77, 63, 1, 0, 0, 0, 48, 213, 56, 19, 0, 55, 153, 67, 147, 77, 240, 196, 35, 207, 60, 244, 212, 99, 207, 61, 248, 228, 163, 207, 62, 252, 244, 227, 207, 63, 0, 5, 36, 208, 64, 4, 21, 100, 208, 65, 8, 37, 164, 208, 66, 12, 53, 228, 208, 67, 16, 69, 36, 209, 68, 20, 85, 100, 209, 69, 24, 101, 164, 209, 70, 28, 117, 228, 209, 71, 32, 133, 36, 210, 72, 36, 149, 100, 210, 73, 40, 165, 164, 210, 74, 44, 181, 228, 210, 75, 99, 112, 49, 50, 53, 50, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 50, 0, 0, 0, 51, 6, 96, 98, 33, 41, 182, 168, 226, 138, 142, 184, 104, 198, 139, 88, 4, 48, 72, 0, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 147, 216, 120, 6, 140, 89, 4, 64, 136, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 112, 49, 50, 53, 51, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 51, 0, 0, 0, 51, 6, 96, 98, 33, 41, 182, 168, 226, 138, 1, 184, 24, 192, 139, 1, 4, 16, 64, 0, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 1, 216, 24, 0, 140, 1, 4, 16, 64, 0, 0, 112, 210, 9, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 128, 136, 0, 0, 0, 0, 0, 155, 0, 0, 0, 0, 158, 124, 2, 10, 0, 161, 0, 32, 202, 40, 164, 148, 98, 202, 41, 168, 164, 162, 202, 42, 172, 180, 226, 202, 43, 176, 196, 34, 203, 44, 180, 212, 18, 128, 45, 183, 224, 146, 139, 46, 187, 240, 210, 139, 47, 191, 0, 19, 140, 48, 195, 16, 83, 140, 49, 199, 32, 147, 140, 50, 203, 48, 211, 140, 51, 207, 64, 19, 141, 52, 211, 80, 83, 141, 53, 215, 96, 147, 141, 54, 219, 112, 211, 141, 55, 223, 128, 19, 78, 0, 99, 112, 49, 50, 53, 52, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 52, 0, 0, 0, 51, 6, 96, 98, 33, 41, 182, 168, 226, 138, 142, 184, 104, 198, 139, 88, 4, 16, 64, 0, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 147, 216, 120, 6, 140, 89, 4, 16, 128, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 64, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 80, 6, 0, 99, 112, 49, 50, 53, 53, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 53, 0, 0, 0, 51, 6, 96, 98, 33, 41, 182, 168, 226, 138, 142, 184, 24, 192, 139, 1, 4, 16, 64, 0, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 147, 216, 24, 0, 140, 1, 4, 16, 64, 0, 0, 0, 0, 0, 0, 49, 2, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 0, 0, 0, 0, 0, 0, 0, 64, 5, 37, 212, 80, 68, 21, 101, 212, 81, 72, 37, 21, 128, 82, 75, 49, 213, 148, 83, 79, 65, 21, 149, 84, 110, 189, 5, 87, 92, 114, 5, 16, 64, 0, 1, 4, 16, 64, 0, 83, 81, 85, 149, 85, 87, 97, 149, 149, 86, 91, 113, 213, 149, 87, 95, 129, 21, 150, 88, 99, 145, 85, 150, 89, 103, 161, 149, 150, 90, 107, 177, 213, 86, 0, 1, 120, 248, 97, 0, 99, 112, 49, 50, 53, 54, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 54, 0, 0, 0, 51, 146, 102, 98, 33, 41, 182, 168, 226, 138, 142, 184, 56, 218, 139, 88, 148, 134, 154, 105, 170, 145, 88, 226, 137, 40, 178, 8, 98, 136, 169, 217, 120, 26, 140, 89, 112, 216, 225, 106, 0, 204, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 23, 0, 0, 0, 0, 64, 93, 173, 217, 117, 23, 94, 121, 233, 181, 23, 95, 125, 249, 245, 23, 96, 129, 9, 54, 24, 97, 133, 25, 118, 24, 98, 137, 41, 182, 24, 0, 140, 53, 230, 216, 99, 144, 69, 38, 217, 100, 0, 80, 6, 64, 101, 150, 93, 134, 25, 0, 0, 0, 0, 0, 0, 153, 105, 6, 0, 0, 155, 113, 214, 153, 103, 0, 124, 6, 26, 0, 161, 1, 32, 26, 0, 0, 120, 248, 161, 107, 99, 112, 49, 50, 53, 55, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 55, 0, 0, 0, 51, 6, 96, 98, 0, 41, 182, 168, 226, 138, 1, 184, 24, 192, 139, 1, 16, 240, 136, 2, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 1, 216, 24, 0, 140, 1, 24, 32, 73, 0, 0, 4, 0, 0, 0, 0, 4, 0, 0, 0, 13, 0, 192, 5, 0, 0, 0, 0, 192, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 208, 5, 0, 0, 0, 0, 128, 3, 21, 236, 16, 193, 5, 0, 0, 112, 194, 8, 29, 0, 240, 71, 9, 49, 4, 145, 131, 17, 102, 48, 225, 4, 0, 84, 0, 0, 0, 0, 120, 40, 1, 6, 28, 0, 4, 50, 8, 0, 22, 240, 32, 1, 6, 0, 0, 128, 2, 9, 30, 0, 0, 136, 9, 50, 8, 161, 195, 17, 103, 52, 241, 4, 0, 85, 0, 0, 0, 0, 121, 44, 17, 70, 28, 0, 8, 66, 72, 36, 99, 112, 49, 50, 53, 56, 0, 119, 105, 110, 100, 111, 119, 115, 49, 50, 53, 56, 0, 0, 0, 51, 6, 96, 98, 33, 41, 182, 168, 226, 138, 142, 184, 24, 192, 139, 88, 4, 16, 64, 0, 1, 144, 88, 226, 137, 40, 178, 8, 98, 136, 147, 216, 24, 0, 140, 89, 4, 16, 128, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 0, 0, 0, 0, 33, 0, 128, 9, 0, 0, 24, 2, 0, 0, 0, 0, 0, 0, 0, 0, 32, 114, 9, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 0, 0, 0, 0, 34, 0, 144, 9, 0, 0, 28, 2, 0, 0, 0, 0, 0, 0, 0, 0, 36, 34, 35, 0, 107, 111, 105, 56, 114, 0, 0, 0, 62, 254, 8, 100, 144, 66, 14, 73, 100, 145, 70, 30, 137, 164, 153, 103, 162, 153, 166, 154, 107, 178, 217, 38, 143, 110, 222, 136, 99, 142, 58, 238, 40, 64, 143, 7, 32, 144, 192, 3, 73, 42, 185, 36, 76, 76, 54, 233, 228, 147, 80, 70, 41, 229, 148, 84, 86, 105, 229, 149, 88, 102, 169, 165, 56, 91, 114, 217, 165, 151, 95, 130, 25, 166, 152, 99, 146, 89, 102, 1, 46, 65, 20, 145, 73, 20, 85, 68, 210, 68, 37, 97, 148, 145, 70, 27, 113, 212, 145, 71, 31, 189, 4, 82, 72, 34, 141, 100, 145, 68, 44, 173, 116, 17, 74, 45, 165, 116, 146, 74, 14, 193, 19, 143, 65, 244, 212, 67, 208, 60, 5, 225, 147, 143, 62, 251, 240, 211, 143, 63, 255, 60, 4, 80, 64, 2, 13, 100, 143, 60, 12, 45, 116, 15, 66, 13, 37, 116, 144, 66, 107, 111, 105, 56, 117, 0, 0, 0, 62, 254, 8, 100, 144, 66, 14, 73, 100, 145, 70, 30, 137, 164, 153, 103, 162, 153, 166, 154, 107, 178, 217, 38, 143, 110, 222, 136, 99, 142, 58, 238, 40, 64, 143, 7, 32, 144, 192, 3, 73, 42, 185, 36, 76, 51, 53, 89, 147, 77, 80, 70, 41, 229, 148, 84, 254, 100, 229, 149, 88, 102, 169, 165, 56, 229, 112, 121, 14, 58, 95, 130, 25, 166, 152, 99, 250, 84, 102, 1, 46, 65, 20, 145, 73, 20, 85, 68, 210, 68, 37, 97, 148, 145, 70, 27, 113, 212, 145, 71, 31, 189, 4, 82, 72, 34, 141, 100, 145, 68, 44, 173, 116, 17, 74, 45, 165, 116, 146, 74, 14, 193, 19, 143, 65, 244, 212, 67, 208, 60, 5, 225, 147, 143, 62, 251, 240, 211, 143, 63, 255, 60, 4, 80, 64, 2, 13, 100, 143, 60, 12, 45, 116, 15, 66, 13, 37, 116, 144, 66, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 1, 48, 2, 48, 12, 255, 14, 255, 251, 48, 26, 255, 27, 255, 31, 255, 1, 255, 155, 48, 156, 48, 180, 0, 64, 255, 168, 0, 62, 255, 227, 255, 63, 255, 253, 48, 254, 48, 157, 48, 158, 48, 3, 48, 221, 78, 5, 48, 6, 48, 7, 48, 252, 48, 21, 32, 16, 32, 15, 255, 92, 0, 28, 48, 22, 32, 92, 255, 38, 32, 37, 32, 24, 32, 25, 32, 28, 32, 29, 32, 8, 255, 9, 255, 20, 48, 21, 48, 59, 255, 61, 255, 91, 255, 93, 255, 8, 48, 9, 48, 10, 48, 11, 48, 12, 48, 13, 48, 14, 48, 15, 48, 16, 48, 17, 48, 11, 255, 18, 34, 177, 0, 215, 0, 247, 0, 29, 255, 96, 34, 28, 255, 30, 255, 102, 34, 103, 34, 30, 34, 52, 34, 66, 38, 64, 38, 176, 0, 50, 32, 51, 32, 3, 33, 229, 255, 4, 255, 162, 0, 163, 0, 5, 255, 3, 255, 6, 255, 10, 255, 32, 255, 167, 0, 6, 38, 5, 38, 203, 37, 207, 37, 206, 37, 199, 37, 198, 37, 161, 37, 160, 37, 179, 37, 178, 37, 189, 37, 188, 37, 59, 32, 18, 48, 146, 33, 144, 33, 145, 33, 147, 33, 19, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 34, 11, 34, 134, 34, 135, 34, 130, 34, 131, 34, 42, 34, 41, 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 34, 40, 34, 172, 0, 210, 33, 212, 33, 0, 34, 3, 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 34, 165, 34, 18, 35, 2, 34, 7, 34, 97, 34, 82, 34, 106, 34, 107, 34, 26, 34, 61, 34, 29, 34, 53, 34, 43, 34, 44, 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 33, 48, 32, 111, 38, 109, 38, 106, 38, 32, 32, 33, 32, 182, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 255, 17, 255, 18, 255, 19, 255, 20, 255, 21, 255, 22, 255, 23, 255, 24, 255, 25, 255], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 197488);
	        allocate([33, 255, 34, 255, 35, 255, 36, 255, 37, 255, 38, 255, 39, 255, 40, 255, 41, 255, 42, 255, 43, 255, 44, 255, 45, 255, 46, 255, 47, 255, 48, 255, 49, 255, 50, 255, 51, 255, 52, 255, 53, 255, 54, 255, 55, 255, 56, 255, 57, 255, 58, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 255, 66, 255, 67, 255, 68, 255, 69, 255, 70, 255, 71, 255, 72, 255, 73, 255, 74, 255, 75, 255, 76, 255, 77, 255, 78, 255, 79, 255, 80, 255, 81, 255, 82, 255, 83, 255, 84, 255, 85, 255, 86, 255, 87, 255, 88, 255, 89, 255, 90, 255, 0, 0, 0, 0, 0, 0, 0, 0, 65, 48, 66, 48, 67, 48, 68, 48, 69, 48, 70, 48, 71, 48, 72, 48, 73, 48, 74, 48, 75, 48, 76, 48, 77, 48, 78, 48, 79, 48, 80, 48, 81, 48, 82, 48, 83, 48, 84, 48, 85, 48, 86, 48, 87, 48, 88, 48, 89, 48, 90, 48, 91, 48, 92, 48, 93, 48, 94, 48, 95, 48, 96, 48, 97, 48, 98, 48, 99, 48, 100, 48, 101, 48, 102, 48, 103, 48, 104, 48, 105, 48, 106, 48, 107, 48, 108, 48, 109, 48, 110, 48, 111, 48, 112, 48, 113, 48, 114, 48, 115, 48, 116, 48, 117, 48, 118, 48, 119, 48, 120, 48, 121, 48, 122, 48, 123, 48, 124, 48, 125, 48, 126, 48, 127, 48, 128, 48, 129, 48, 130, 48, 131, 48, 132, 48, 133, 48, 134, 48, 135, 48, 136, 48, 137, 48, 138, 48, 139, 48, 140, 48, 141, 48, 142, 48, 143, 48, 144, 48, 145, 48, 146, 48, 147, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 48, 162, 48, 163, 48, 164, 48, 165, 48, 166, 48, 167, 48, 168, 48, 169, 48, 170, 48, 171, 48, 172, 48, 173, 48, 174, 48, 175, 48, 176, 48, 177, 48, 178, 48, 179, 48, 180, 48, 181, 48, 182, 48, 183, 48, 184, 48, 185, 48, 186, 48, 187, 48, 188, 48, 189, 48, 190, 48, 191, 48, 192, 48, 193, 48, 194, 48, 195, 48, 196, 48, 197, 48, 198, 48, 199, 48, 200, 48, 201, 48, 202, 48, 203, 48, 204, 48, 205, 48, 206, 48, 207, 48, 208, 48, 209, 48, 210, 48, 211, 48, 212, 48, 213, 48, 214, 48, 215, 48, 216, 48, 217, 48, 218, 48, 219, 48, 220, 48, 221, 48, 222, 48, 223, 48, 224, 48, 225, 48, 226, 48, 227, 48, 228, 48, 229, 48, 230, 48, 231, 48, 232, 48, 233, 48, 234, 48, 235, 48, 236, 48, 237, 48, 238, 48, 239, 48, 240, 48, 241, 48, 242, 48, 243, 48, 244, 48, 245, 48, 246, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 3, 146, 3, 147, 3, 148, 3, 149, 3, 150, 3, 151, 3, 152, 3, 153, 3, 154, 3, 155, 3, 156, 3, 157, 3, 158, 3, 159, 3, 160, 3, 161, 3, 163, 3, 164, 3, 165, 3, 166, 3, 167, 3, 168, 3, 169, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 3, 178, 3, 179, 3, 180, 3, 181, 3, 182, 3, 183, 3, 184, 3, 185, 3, 186, 3, 187, 3, 188, 3, 189, 3, 190, 3, 191, 3, 192, 3, 193, 3, 195, 3, 196, 3, 197, 3, 198, 3, 199, 3, 200, 3, 201, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 4, 17, 4, 18, 4, 19, 4, 20, 4, 21, 4, 1, 4, 22, 4, 23, 4, 24, 4, 25, 4, 26, 4, 27, 4, 28, 4, 29, 4, 30, 4, 31, 4, 32, 4, 33, 4, 34, 4, 35, 4, 36, 4, 37, 4, 38, 4, 39, 4, 40, 4, 41, 4, 42, 4, 43, 4, 44, 4, 45, 4, 46, 4, 47, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 4, 49, 4, 50, 4, 51, 4, 52, 4, 53, 4, 81, 4, 54, 4, 55, 4, 56, 4, 57, 4, 58, 4, 59, 4, 60, 4, 61, 4, 62, 4, 63, 4, 64, 4, 65, 4, 66, 4, 67, 4, 68, 4, 69, 4, 70, 4, 71, 4, 72, 4, 73, 4, 74, 4, 75, 4, 76, 4, 77, 4, 78, 4, 79, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 2, 37, 12, 37, 16, 37, 24, 37, 20, 37, 28, 37, 44, 37, 36, 37, 52, 37, 60, 37, 1, 37, 3, 37, 15, 37, 19, 37, 27, 37, 23, 37, 35, 37, 51, 37, 43, 37, 59, 37, 75, 37, 32, 37, 47, 37, 40, 37, 55, 37, 63, 37, 29, 37, 48, 37, 37, 37, 56, 37, 66, 37], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 207728);
	        allocate([156, 78, 22, 85, 3, 90, 63, 150, 192, 84, 27, 97, 40, 99, 246, 89, 34, 144, 117, 132, 28, 131, 80, 122, 170, 96, 225, 99, 37, 110, 237, 101, 102, 132, 166, 130, 245, 155, 147, 104, 39, 87, 161, 101, 113, 98, 155, 91, 208, 89, 123, 134, 244, 152, 98, 125, 190, 125, 142, 155, 22, 98, 159, 124, 183, 136, 137, 91, 181, 94, 9, 99, 151, 102, 72, 104, 199, 149, 141, 151, 79, 103, 229, 78, 10, 79, 77, 79, 157, 79, 73, 80, 242, 86, 55, 89, 212, 89, 1, 90, 9, 92, 223, 96, 15, 97, 112, 97, 19, 102, 5, 105, 186, 112, 79, 117, 112, 117, 251, 121, 173, 125, 239, 125, 195, 128, 14, 132, 99, 136, 2, 139, 85, 144, 122, 144, 59, 83, 149, 78, 165, 78, 223, 87, 178, 128, 193, 144, 239, 120, 0, 78, 241, 88, 162, 110, 56, 144, 50, 122, 40, 131, 139, 130, 47, 156, 65, 81, 112, 83, 189, 84, 225, 84, 224, 86, 251, 89, 21, 95, 242, 152, 235, 109, 228, 128, 45, 133, 98, 150, 112, 150, 160, 150, 251, 151, 11, 84, 243, 83, 135, 91, 207, 112, 189, 127, 194, 143, 232, 150, 111, 83, 92, 157, 186, 122, 17, 78, 147, 120, 252, 129, 38, 110, 24, 86, 4, 85, 29, 107, 26, 133, 59, 156, 229, 89, 169, 83, 102, 109, 220, 116, 143, 149, 66, 86, 145, 78, 75, 144, 242, 150, 79, 131, 12, 153, 225, 83, 182, 85, 48, 91, 113, 95, 32, 102, 243, 102, 4, 104, 56, 108, 243, 108, 41, 109, 91, 116, 200, 118, 78, 122, 52, 152, 241, 130, 91, 136, 96, 138, 237, 146, 178, 109, 171, 117, 202, 118, 197, 153, 166, 96, 1, 139, 138, 141, 178, 149, 142, 105, 173, 83, 134, 81, 18, 87, 48, 88, 68, 89, 180, 91, 246, 94, 40, 96, 169, 99, 244, 99, 191, 108, 20, 111, 142, 112, 20, 113, 89, 113, 213, 113, 63, 115, 1, 126, 118, 130, 209, 130, 151, 133, 96, 144, 91, 146, 27, 157, 105, 88, 188, 101, 90, 108, 37, 117, 249, 81, 46, 89, 101, 89, 128, 95, 220, 95, 188, 98, 250, 101, 42, 106, 39, 107, 180, 107, 139, 115, 193, 127, 86, 137, 44, 157, 14, 157, 196, 158, 161, 92, 150, 108, 123, 131, 4, 81, 75, 92, 182, 97, 198, 129, 118, 104, 97, 114, 89, 78, 250, 79, 120, 83, 105, 96, 41, 110, 79, 122, 243, 151, 11, 78, 22, 83, 238, 78, 85, 79, 61, 79, 161, 79, 115, 79, 160, 82, 239, 83, 9, 86, 15, 89, 193, 90, 182, 91, 225, 91, 209, 121, 135, 102, 156, 103, 182, 103, 76, 107, 179, 108, 107, 112, 194, 115, 141, 121, 190, 121, 60, 122, 135, 123, 177, 130, 219, 130, 4, 131, 119, 131, 239, 131, 211, 131, 102, 135, 178, 138, 41, 86, 168, 140, 230, 143, 78, 144, 30, 151, 138, 134, 196, 79, 232, 92, 17, 98, 89, 114, 59, 117, 229, 129, 189, 130, 254, 134, 192, 140, 197, 150, 19, 153, 213, 153, 203, 78, 26, 79, 227, 137, 222, 86, 74, 88, 202, 88, 251, 94, 235, 95, 42, 96, 148, 96, 98, 96, 208, 97, 18, 98, 208, 98, 57, 101, 65, 155, 102, 102, 176, 104, 119, 109, 112, 112, 76, 117, 134, 118, 117, 125, 165, 130, 249, 135, 139, 149, 142, 150, 157, 140, 241, 81, 190, 82, 22, 89, 179, 84, 179, 91, 22, 93, 104, 97, 130, 105, 175, 109, 141, 120, 203, 132, 87, 136, 114, 138, 167, 147, 184, 154, 108, 109, 168, 153, 217, 134, 163, 87, 255, 103, 206, 134, 14, 146, 131, 82, 135, 86, 4, 84, 211, 94, 225, 98, 185, 100, 60, 104, 56, 104, 187, 107, 114, 115, 186, 120, 107, 122, 154, 137, 210, 137, 107, 141, 3, 143, 237, 144, 163, 149, 148, 150, 105, 151, 102, 91, 179, 92, 125, 105, 77, 152, 78, 152, 155, 99, 32, 123, 43, 106, 127, 106, 182, 104, 13, 156, 95, 111, 114, 82, 157, 85, 112, 96, 236, 98, 59, 109, 7, 110, 209, 110, 91, 132, 16, 137, 68, 143, 20, 78, 57, 156, 246, 83, 27, 105, 58, 106, 132, 151, 42, 104, 92, 81, 195, 122, 178, 132, 220, 145, 140, 147, 91, 86, 40, 157, 34, 104, 5, 131, 49, 132, 165, 124, 8, 82, 197, 130, 230, 116, 126, 78, 131, 79, 160, 81, 210, 91, 10, 82, 216, 82, 231, 82, 251, 93, 154, 85, 42, 88, 230, 89, 140, 91, 152, 91, 219, 91, 114, 94, 121, 94, 163, 96, 31, 97, 99, 97, 190, 97, 219, 99, 98, 101, 209, 103, 83, 104, 250, 104, 62, 107, 83, 107, 87, 108, 34, 111, 151, 111, 69, 111, 176, 116, 24, 117, 227, 118, 11, 119, 255, 122, 161, 123, 33, 124, 233, 125, 54, 127, 240, 127, 157, 128, 102, 130, 158, 131, 179, 137, 204, 138, 171, 140, 132, 144, 81, 148, 147, 149, 145, 149, 162, 149, 101, 150, 211, 151, 40, 153, 24, 130, 56, 78, 43, 84, 184, 92, 204, 93, 169, 115, 76, 118, 60, 119, 169, 92, 235, 127, 11, 141, 193, 150, 17, 152, 84, 152, 88, 152, 1, 79, 14, 79, 113, 83, 156, 85, 104, 86, 250, 87, 71, 89, 9, 91, 196, 91, 144, 92, 12, 94, 126, 94, 204, 95, 238, 99, 58, 103, 215, 101, 226, 101, 31, 103, 203, 104, 196, 104, 95, 106, 48, 94, 197, 107, 23, 108, 125, 108, 127, 117, 72, 121, 99, 91, 0, 122, 0, 125, 189, 95, 143, 137, 24, 138, 180, 140, 119, 141, 204, 142, 29, 143, 226, 152, 14, 154, 60, 155, 128, 78, 125, 80, 0, 81, 147, 89, 156, 91, 47, 98, 128, 98, 236, 100, 58, 107, 160, 114, 145, 117, 71, 121, 169, 127, 251, 135, 188, 138, 112, 139, 172, 99, 202, 131, 160, 151, 9, 84, 3, 84, 171, 85, 84, 104, 88, 106, 112, 138, 39, 120, 117, 103, 205, 158, 116, 83, 162, 91, 26, 129, 80, 134, 6, 144, 24, 78, 69, 78, 199, 78, 17, 79, 202, 83, 56, 84, 174, 91, 19, 95, 37, 96, 81, 101, 61, 103, 66, 108, 114, 108, 227, 108, 120, 112, 3, 116, 118, 122, 174, 122, 8, 123, 26, 125, 254, 124, 102, 125, 231, 101, 91, 114, 187, 83, 69, 92, 232, 93, 210, 98, 224, 98, 25, 99, 32, 110, 90, 134, 49, 138, 221, 141, 248, 146, 1, 111, 166, 121, 90, 155, 168, 78, 171, 78, 172, 78, 155, 79, 160, 79, 209, 80, 71, 81, 246, 122, 113, 81, 246, 81, 84, 83, 33, 83, 127, 83, 235, 83, 172, 85, 131, 88, 225, 92, 55, 95, 74, 95, 47, 96, 80, 96, 109, 96, 31, 99, 89, 101, 75, 106, 193, 108, 194, 114, 237, 114, 239, 119, 248, 128, 5, 129, 8, 130, 78, 133, 247, 144, 225, 147, 255, 151, 87, 153, 90, 154, 240, 78, 221, 81, 45, 92, 129, 102, 109, 105, 64, 92, 242, 102, 117, 105, 137, 115, 80, 104, 129, 124, 197, 80, 228, 82, 71, 87, 254, 93, 38, 147, 164, 101, 35, 107, 61, 107, 52, 116, 129, 121, 189, 121, 75, 123, 202, 125, 185, 130, 204, 131, 127, 136, 95, 137, 57, 139, 209, 143, 209, 145, 31, 84, 128, 146, 93, 78, 54, 80, 229, 83, 58, 83, 215, 114, 150, 115, 233, 119, 230, 130, 175, 142, 198, 153, 200, 153, 210, 153, 119, 81, 26, 97, 94, 134, 176, 85, 122, 122, 118, 80, 211, 91, 71, 144, 133, 150, 50, 78, 219, 106, 231, 145, 81, 92, 72, 92, 152, 99, 159, 122, 147, 108, 116, 151, 97, 143, 170, 122, 138, 113, 136, 150, 130, 124, 23, 104, 112, 126, 81, 104, 108, 147, 242, 82, 27, 84, 171, 133, 19, 138, 164, 127, 205, 142, 225, 144, 102, 83, 136, 136, 65, 121, 194, 79, 190, 80, 17, 82, 68, 81, 83, 85, 45, 87, 234, 115, 139, 87, 81, 89, 98, 95, 132, 95, 117, 96, 118, 97, 103, 97, 169, 97, 178, 99, 58, 100, 108, 101, 111, 102, 66, 104, 19, 110, 102, 117, 61, 122, 251, 124, 76, 125, 153, 125, 75, 126, 107, 127, 14, 131, 74, 131, 205, 134, 8, 138, 99, 138, 102, 139, 253, 142, 26, 152, 143, 157, 184, 130, 206, 143, 232, 155, 135, 82, 31, 98, 131, 100, 192, 111, 153, 150, 65, 104, 145, 80, 32, 107, 122, 108, 84, 111, 116, 122, 80, 125, 64, 136, 35, 138, 8, 103, 246, 78, 57, 80, 38, 80, 101, 80, 124, 81, 56, 82, 99, 82, 167, 85, 15, 87, 5, 88, 204, 90, 250, 94, 178, 97, 248, 97, 243, 98, 114, 99, 28, 105, 41, 106, 125, 114, 172, 114, 46, 115, 20, 120, 111, 120, 121, 125, 12, 119, 169, 128, 139, 137, 25, 139, 226, 140, 210, 142, 99, 144, 117, 147, 122, 150, 85, 152, 19, 154, 120, 158, 67, 81, 159, 83, 179, 83, 123, 94, 38, 95, 27, 110, 144, 110, 132, 115, 254, 115, 67, 125, 55, 130, 0, 138, 250, 138, 80, 150, 78, 78, 11, 80, 228, 83, 124, 84, 250, 86, 209, 89, 100, 91, 241, 93, 171, 94, 39, 95, 56, 98, 69, 101, 175, 103, 86, 110, 208, 114, 202, 124, 180, 136, 161, 128, 225, 128, 240, 131, 78, 134, 135, 138, 232, 141, 55, 146, 199, 150, 103, 152, 19, 159, 148, 78, 146, 78, 13, 79, 72, 83, 73, 84, 62, 84, 47, 90, 140, 95, 161, 95, 159, 96, 167, 104, 142, 106, 90, 116, 129, 120, 158, 138, 164, 138, 119, 139, 144, 145, 94, 78, 201, 155, 164, 78, 124, 79, 175, 79, 25, 80, 22, 80, 73, 81, 108, 81, 159, 82, 185, 82, 254, 82, 154, 83, 227, 83, 17, 84, 14, 84, 137, 85, 81, 87, 162, 87, 125, 89, 84, 91, 93, 91, 143, 91, 229, 93, 231, 93, 247, 93, 120, 94, 131, 94, 154, 94, 183, 94, 24, 95, 82, 96, 76, 97, 151, 98, 216, 98, 167, 99, 59, 101, 2, 102, 67, 102, 244, 102, 109, 103, 33, 104, 151, 104, 203, 105, 95, 108, 42, 109, 105, 109, 47, 110, 157, 110, 50, 117, 135, 118, 108, 120, 63, 122, 224, 124, 5, 125, 24, 125, 94, 125, 177, 125, 21, 128, 3, 128, 175, 128, 177, 128, 84, 129, 143, 129, 42, 130, 82, 131, 76, 136, 97, 136, 27, 139, 162, 140, 252, 140, 202, 144, 117, 145, 113, 146, 63, 120, 252, 146, 164, 149, 77, 150, 5, 152, 153, 153, 216, 154, 59, 157, 91, 82, 171, 82, 247, 83, 8, 84, 213, 88, 247, 98, 224, 111, 106, 140, 95, 143, 185, 158, 75, 81, 59, 82, 74, 84, 253, 86, 64, 122, 119, 145, 96, 157, 210, 158, 68, 115, 9, 111, 112, 129, 17, 117, 253, 95, 218, 96, 168, 154, 219, 114, 188, 143, 100, 107, 3, 152, 202, 78, 240, 86, 100, 87, 190, 88, 90, 90, 104, 96, 199, 97, 15, 102, 6, 102, 57, 104, 177, 104, 247, 109, 213, 117, 58, 125, 110, 130, 66, 155, 155, 78, 80, 79, 201, 83, 6, 85, 111, 93, 230, 93, 238, 93, 251, 103, 153, 108, 115, 116, 2, 120, 80, 138, 150, 147, 223, 136, 80, 87, 167, 94, 43, 99, 181, 80, 172, 80, 141, 81, 0, 103, 201, 84, 94, 88, 187, 89, 176, 91, 105, 95, 77, 98, 161, 99, 61, 104, 115, 107, 8, 110, 125, 112, 199, 145, 128, 114, 21, 120, 38, 120, 109, 121, 142, 101, 48, 125, 220, 131, 193, 136, 9, 143, 155, 150, 100, 82, 40, 87, 80, 103, 106, 127, 161, 140, 180, 81, 66, 87, 42, 150, 58, 88, 138, 105, 180, 128, 178, 84, 14, 93, 252, 87, 149, 120, 250, 157, 92, 79, 74, 82, 139, 84, 62, 100, 40, 102, 20, 103, 245, 103, 132, 122, 86, 123, 34, 125, 47, 147, 92, 104, 173, 155, 57, 123, 25, 83, 138, 81, 55, 82, 223, 91, 246, 98, 174, 100, 230, 100, 45, 103, 186, 107, 169, 133, 209, 150, 144, 118, 214, 155, 76, 99, 6, 147, 171, 155, 191, 118, 82, 102, 9, 78, 152, 80, 194, 83, 113, 92, 232, 96, 146, 100, 99, 101, 95, 104, 230, 113, 202, 115, 35, 117, 151, 123, 130, 126, 149, 134, 131, 139, 219, 140, 120, 145, 16, 153, 172, 101, 171, 102, 139, 107, 213, 78, 212, 78, 58, 79, 127, 79, 58, 82, 248, 83, 242, 83, 227, 85, 219, 86, 235, 88, 203, 89, 201, 89, 255, 89, 80, 91, 77, 92, 2, 94, 43, 94, 215, 95, 29, 96, 7, 99, 47, 101, 92, 91, 175, 101, 189, 101, 232, 101, 157, 103, 98, 107, 123, 107, 15, 108, 69, 115, 73, 121, 193, 121, 248, 124, 25, 125, 43, 125, 162, 128, 2, 129, 243, 129, 150, 137, 94, 138, 105, 138, 102, 138, 140, 138, 238, 138, 199, 140, 220, 140, 204, 150, 252, 152, 111, 107, 139, 78, 60, 79, 141, 79, 80, 81, 87, 91, 250, 91, 72, 97, 1, 99, 66, 102, 33, 107, 203, 110, 187, 108, 62, 114, 189, 116, 212, 117, 193, 120, 58, 121, 12, 128, 51, 128, 234, 129, 148, 132, 158, 143, 80, 108, 127, 158, 15, 95, 88, 139, 43, 157, 250, 122, 248, 142, 141, 91, 235, 150, 3, 78, 241, 83, 247, 87, 49, 89, 201, 90, 164, 91, 137, 96, 127, 110, 6, 111, 190, 117, 234, 140, 159, 91, 0, 133, 224, 123, 114, 80, 244, 103, 157, 130, 97, 92, 74, 133, 30, 126, 14, 130, 153, 81, 4, 92, 104, 99, 102, 141, 156, 101, 110, 113, 62, 121, 23, 125, 5, 128, 29, 139, 202, 142, 110, 144, 199, 134, 170, 144, 31, 80, 250, 82, 58, 92, 83, 103, 124, 112, 53, 114, 76, 145, 200, 145, 43, 147, 229, 130, 194, 91, 49, 95, 249, 96, 59, 78, 214, 83, 136, 91, 75, 98, 49, 103, 138, 107, 233, 114, 224, 115, 46, 122, 107, 129, 163, 141, 82, 145, 150, 153, 18, 81, 215, 83, 106, 84, 255, 91, 136, 99, 57, 106, 172, 125, 0, 151, 218, 86, 206, 83, 104, 84, 151, 91, 49, 92, 222, 93, 238, 79, 1, 97, 254, 98, 50, 109, 192, 121, 203, 121, 66, 125, 77, 126, 210, 127, 237, 129, 31, 130, 144, 132, 70, 136, 114, 137, 144, 139, 116, 142, 47, 143, 49, 144, 75, 145, 108, 145, 198, 150, 156, 145, 192, 78, 79, 79, 69, 81, 65, 83, 147, 95, 14, 98, 212, 103, 65, 108, 11, 110, 99, 115, 38, 126, 205, 145, 131, 146, 212, 83, 25, 89, 191, 91, 209, 109, 93, 121, 46, 126, 155, 124, 126, 88, 159, 113, 250, 81, 83, 136, 240, 143, 202, 79, 251, 92, 37, 102, 172, 119, 227, 122, 28, 130, 255, 153, 198, 81, 170, 95, 236, 101, 111, 105, 137, 107, 243, 109, 150, 110, 100, 111, 254, 118, 20, 125, 225, 93, 117, 144, 135, 145, 6, 152, 230, 81, 29, 82, 64, 98, 145, 102, 217, 102, 26, 110, 182, 94, 210, 125, 114, 127, 248, 102, 175, 133, 247, 133, 248, 138, 169, 82, 217, 83, 115, 89, 143, 94, 144, 95, 85, 96, 228, 146, 100, 150, 183, 80, 31, 81, 221, 82, 32, 83, 71, 83, 236, 83, 232, 84, 70, 85, 49, 85, 23, 86, 104, 89, 190, 89, 60, 90, 181, 91, 6, 92, 15, 92, 17, 92, 26, 92, 132, 94, 138, 94, 224, 94, 112, 95, 127, 98, 132, 98, 219, 98, 140, 99, 119, 99, 7, 102, 12, 102, 45, 102, 118, 102, 126, 103, 162, 104, 31, 106, 53, 106, 188, 108, 136, 109, 9, 110, 88, 110, 60, 113, 38, 113, 103, 113, 199, 117, 1, 119, 93, 120, 1, 121, 101, 121, 240, 121, 224, 122, 17, 123, 167, 124, 57, 125, 150, 128, 214, 131, 139, 132, 73, 133, 93, 136, 243, 136, 31, 138, 60, 138, 84, 138, 115, 138, 97, 140, 222, 140, 164, 145, 102, 146, 126, 147, 24, 148, 156, 150, 152, 151, 10, 78, 8, 78, 30, 78, 87, 78, 151, 81, 112, 82, 206, 87, 52, 88, 204, 88, 34, 91, 56, 94, 197, 96, 254, 100, 97, 103, 86, 103, 68, 109, 182, 114, 115, 117, 99, 122, 184, 132, 114, 139, 184, 145, 32, 147, 49, 86, 244, 87, 254, 152, 237, 98, 13, 105, 150, 107, 237, 113, 84, 126, 119, 128, 114, 130, 230, 137, 223, 152, 85, 135, 177, 143, 59, 92, 56, 79, 225, 79, 181, 79, 7, 85, 32, 90, 221, 91, 233, 91, 195, 95, 78, 97, 47, 99, 176, 101, 75, 102, 238, 104, 155, 105, 120, 109, 241, 109, 51, 117, 185, 117, 31, 119, 94, 121, 230, 121, 51, 125, 227, 129, 175, 130, 170, 133, 170, 137, 58, 138, 171, 142, 155, 143, 50, 144, 221, 145, 7, 151, 186, 78, 193, 78, 3, 82, 117, 88, 236, 88, 11, 92, 26, 117, 61, 92, 78, 129, 10, 138, 197, 143, 99, 150, 109, 151, 37, 123, 207, 138, 8, 152, 98, 145, 243, 86, 168, 83, 23, 144, 57, 84, 130, 87, 37, 94, 168, 99, 52, 108, 138, 112, 97, 119, 139, 124, 224, 127, 112, 136, 66, 144, 84, 145, 16, 147, 24, 147, 143, 150, 94, 116, 196, 154, 7, 93, 105, 93, 112, 101, 162, 103, 168, 141, 219, 150, 110, 99, 73, 103, 25, 105, 197, 131, 23, 152, 192, 150, 254, 136, 132, 111, 122, 100, 248, 91, 22, 78, 44, 112, 93, 117, 47, 102, 196, 81, 54, 82, 226, 82, 211, 89, 129, 95, 39, 96, 16, 98, 63, 101, 116, 101, 31, 102, 116, 102, 242, 104, 22, 104, 99, 107, 5, 110, 114, 114, 31, 117, 219, 118, 190, 124, 86, 128, 240, 88, 253, 136, 127, 137, 160, 138, 147, 138, 203, 138, 29, 144, 146, 145, 82, 151, 89, 151, 137, 101, 14, 122, 6, 129, 187, 150, 45, 94, 220, 96, 26, 98, 165, 101, 20, 102, 144, 103, 243, 119, 77, 122, 77, 124, 62, 126, 10, 129, 172, 140, 100, 141, 225, 141, 95, 142, 169, 120, 7, 82, 217, 98, 165, 99, 66, 100, 152, 98, 45, 138, 131, 122, 192, 123, 172, 138, 234, 150, 118, 125, 12, 130, 73, 135, 217, 78, 72, 81, 67, 83, 96, 83, 163, 91, 2, 92, 22, 92, 221, 93, 38, 98, 71, 98, 176, 100, 19, 104, 52, 104, 201, 108, 69, 109, 23, 109, 211, 103, 92, 111, 78, 113, 125, 113, 203, 101, 127, 122, 173, 123, 218, 125, 74, 126, 168, 127, 122, 129, 27, 130, 57, 130, 166, 133, 110, 138, 206, 140, 245, 141, 120, 144, 119, 144, 173, 146, 145, 146, 131, 149, 174, 155, 77, 82, 132, 85, 56, 111, 54, 113, 104, 81, 133, 121, 85, 126, 179, 129, 206, 124, 76, 86, 81, 88, 168, 92, 170, 99, 254, 102, 253, 102, 90, 105, 217, 114, 143, 117, 142, 117, 14, 121, 86, 121, 223, 121, 151, 124, 32, 125, 68, 125, 7, 134, 52, 138, 59, 150, 97, 144, 32, 159, 231, 80, 117, 82, 204, 83, 226, 83, 9, 80, 170, 85, 238, 88, 79, 89, 61, 114, 139, 91, 100, 92, 29, 83, 227, 96, 243, 96, 92, 99, 131, 99, 63, 99, 187, 99, 205, 100, 233, 101, 249, 102, 227, 93, 205, 105, 253, 105, 21, 111, 229, 113, 137, 78, 233, 117, 248, 118, 147, 122, 223, 124, 207, 125, 156, 125, 97, 128, 73, 131, 88, 131, 108, 132, 188, 132, 251, 133, 197, 136, 112, 141, 1, 144, 109, 144, 151, 147, 28, 151, 18, 154, 207, 80, 151, 88, 142, 97, 211, 129, 53, 133, 8, 141, 32, 144, 195, 79, 116, 80, 71, 82, 115, 83, 111, 96, 73, 99, 95, 103, 44, 110, 179, 141, 31, 144, 215, 79, 94, 92, 202, 140, 207, 101, 154, 125, 82, 83, 150, 136, 118, 81, 195, 99, 88, 91, 107, 91, 10, 92, 13, 100, 81, 103, 92, 144, 214, 78, 26, 89, 42, 89, 112, 108, 81, 138, 62, 85, 21, 88, 165, 89, 240, 96, 83, 98, 193, 103, 53, 130, 85, 105, 64, 150, 196, 153, 40, 154, 83, 79, 6, 88, 254, 91, 16, 128, 177, 92, 47, 94, 133, 95, 32, 96, 75, 97, 52, 98, 255, 102, 240, 108, 222, 110, 206, 128, 127, 129, 212, 130, 139, 136, 184, 140, 0, 144, 46, 144, 138, 150, 219, 158, 219, 155, 227, 78, 240, 83, 39, 89, 44, 123, 141, 145, 76, 152, 249, 157, 221, 110, 39, 112, 83, 83, 68, 85, 133, 91, 88, 98, 158, 98, 211, 98, 162, 108, 239, 111, 34, 116, 23, 138, 56, 148, 193, 111, 254, 138, 56, 131, 231, 81, 248, 134, 234, 83, 233, 83, 70, 79, 84, 144, 176, 143, 106, 89, 49, 129, 253, 93, 234, 122, 191, 143, 218, 104, 55, 140, 248, 114, 72, 156, 61, 106, 176, 138, 57, 78, 88, 83, 6, 86, 102, 87, 197, 98, 162, 99, 230, 101, 78, 107, 225, 109, 91, 110, 173, 112, 237, 119, 239, 122, 170, 123, 187, 125, 61, 128, 198, 128, 203, 134, 149, 138, 91, 147, 227, 86, 199, 88, 62, 95, 173, 101, 150, 102, 128, 106, 181, 107, 55, 117, 199, 138, 36, 80, 229, 119, 48, 87, 27, 95, 101, 96, 122, 102, 96, 108, 244, 117, 26, 122, 110, 127, 244, 129, 24, 135, 69, 144, 179, 153, 201, 123, 92, 117, 249, 122, 81, 123, 196, 132, 16, 144, 233, 121, 146, 122, 54, 131, 225, 90, 64, 119, 45, 78, 242, 78, 153, 91, 224, 95, 189, 98, 60, 102, 241, 103, 232, 108, 107, 134, 119, 136, 59, 138, 78, 145, 243, 146, 208, 153, 23, 106, 38, 112, 42, 115, 231, 130, 87, 132, 175, 140, 1, 78, 70, 81, 203, 81, 139, 85, 245, 91, 22, 94, 51, 94, 129, 94, 20, 95, 53, 95, 107, 95, 180, 95, 242, 97, 17, 99, 162, 102, 29, 103, 110, 111, 82, 114, 58, 117, 58, 119, 116, 128, 57, 129, 120, 129, 118, 135, 191, 138, 220, 138, 133, 141, 243, 141, 154, 146, 119, 149, 2, 152, 229, 156, 197, 82, 87, 99, 244, 118, 21, 103, 136, 108, 205, 115, 195, 140, 174, 147, 115, 150, 37, 109, 156, 88, 14, 105, 204, 105, 253, 143, 154, 147, 219, 117, 26, 144, 90, 88, 2, 104, 180, 99, 251, 105, 67, 79, 44, 111, 216, 103, 187, 143, 38, 133, 180, 125, 84, 147, 63, 105, 112, 111, 106, 87, 247, 88, 44, 91, 44, 125, 42, 114, 10, 84, 227, 145, 180, 157, 173, 78, 78, 79, 92, 80, 117, 80, 67, 82, 158, 140, 72, 84, 36, 88, 154, 91, 29, 94, 149, 94, 173, 94, 247, 94, 31, 95, 140, 96, 181, 98, 58, 99, 208, 99, 175, 104, 64, 108, 135, 120, 142, 121, 11, 122, 224, 125, 71, 130, 2, 138, 230, 138, 68, 142, 19, 144, 184, 144, 45, 145, 216, 145, 14, 159, 229, 108, 88, 100, 226, 100, 117, 101, 244, 110, 132, 118, 27, 123, 105, 144, 209, 147, 186, 110, 242, 84, 185, 95, 164, 100, 77, 143, 237, 143, 68, 146, 120, 81, 107, 88, 41, 89, 85, 92, 151, 94, 251, 109, 143, 126, 28, 117, 188, 140, 226, 142, 91, 152, 185, 112, 29, 79, 191, 107, 177, 111, 48, 117, 251, 150, 78, 81, 16, 84, 53, 88, 87, 88, 172, 89, 96, 92, 146, 95, 151, 101, 92, 103, 33, 110, 123, 118, 223, 131, 237, 140, 20, 144, 253, 144, 77, 147, 37, 120, 58, 120, 170, 82, 166, 94, 31, 87, 116, 89, 18, 96, 18, 80, 90, 81, 172, 81, 205, 81, 0, 82, 16, 85, 84, 88, 88, 88, 87, 89, 149, 91, 246, 92, 139, 93, 188, 96, 149, 98, 45, 100, 113, 103, 67, 104, 188, 104, 223, 104, 215, 118, 216, 109, 111, 110, 155, 109, 111, 112, 200, 113, 83, 95, 216, 117, 119, 121, 73, 123, 84, 123, 82, 123, 214, 124, 113, 125, 48, 82, 99, 132, 105, 133, 228, 133, 14, 138, 4, 139, 70, 140, 15, 142, 3, 144, 15, 144, 25, 148, 118, 150, 45, 152, 48, 154, 216, 149, 205, 80, 213, 82, 12, 84, 2, 88, 14, 92, 167, 97, 158, 100, 30, 109, 179, 119, 229, 122, 244, 128, 4, 132, 83, 144, 133, 146, 224, 92, 7, 157, 63, 83, 151, 95, 179, 95, 156, 109, 121, 114, 99, 119, 191, 121, 228, 123, 210, 107, 236, 114, 173, 138, 3, 104, 97, 106, 248, 81, 129, 122, 52, 105, 74, 92, 246, 156, 235, 130, 197, 91, 73, 145, 30, 112, 120, 86, 111, 92, 199, 96, 102, 101, 140, 108, 90, 140, 65, 144, 19, 152, 81, 84, 199, 102, 13, 146, 72, 89, 163, 144, 133, 81, 77, 78, 234, 81, 153, 133, 14, 139, 88, 112, 122, 99, 75, 147, 98, 105, 180, 153, 4, 126, 119, 117, 87, 83, 96, 105, 223, 142, 227, 150, 93, 108, 140, 78, 60, 92, 16, 95, 233, 143, 2, 83, 209, 140, 137, 128, 121, 134, 255, 94, 229, 101, 115, 78, 101, 81, 130, 89, 63, 92, 238, 151, 251, 78, 138, 89, 205, 95, 141, 138, 225, 111, 176, 121, 98, 121, 231, 91, 113, 132, 43, 115, 177, 113, 116, 94, 245, 95, 123, 99, 154, 100, 195, 113, 152, 124, 67, 78, 252, 94, 75, 78, 220, 87, 162, 86, 169, 96, 195, 111, 13, 125, 253, 128, 51, 129, 191, 129, 178, 143, 151, 137, 164, 134, 244, 93, 138, 98, 173, 100, 135, 137, 119, 103, 226, 108, 62, 109, 54, 116, 52, 120, 70, 90, 117, 127, 173, 130, 172, 153, 243, 79, 195, 94, 221, 98, 146, 99, 87, 101, 111, 103, 195, 118, 76, 114, 204, 128, 186, 128, 41, 143, 77, 145, 13, 80, 249, 87, 146, 90, 133, 104, 115, 105, 100, 113, 253, 114, 183, 140, 242, 88, 224, 140, 106, 150, 25, 144, 127, 135, 228, 121, 231, 119, 41, 132, 47, 79, 101, 82, 90, 83, 205, 98, 207, 103, 202, 108, 125, 118, 148, 123, 149, 124, 54, 130, 132, 133, 235, 143, 221, 102, 32, 111, 6, 114, 27, 126, 171, 131, 193, 153, 166, 158, 253, 81, 177, 123, 114, 120, 184, 123, 135, 128, 72, 123, 232, 106, 97, 94, 140, 128, 81, 117, 96, 117, 107, 81, 98, 146, 140, 110, 122, 118, 151, 145, 234, 154, 16, 79, 112, 127, 156, 98, 79, 123, 165, 149, 233, 156, 122, 86, 89, 88, 228, 134, 188, 150, 52, 79, 36, 82, 74, 83, 205, 83, 219, 83, 6, 94, 44, 100, 145, 101, 127, 103, 62, 108, 78, 108, 72, 114, 175, 114, 237, 115, 84, 117, 65, 126, 44, 130, 233, 133, 169, 140, 196, 123, 198, 145, 105, 113, 18, 152, 239, 152, 61, 99, 105, 102, 106, 117, 228, 118, 208, 120, 67, 133, 238, 134, 42, 83, 81, 83, 38, 84, 131, 89, 135, 94, 124, 95, 178, 96, 73, 98, 121, 98, 171, 98, 144, 101, 212, 107, 204, 108, 178, 117, 174, 118, 145, 120, 216, 121, 203, 125, 119, 127, 165, 128, 171, 136, 185, 138, 187, 140, 127, 144, 94, 151, 219, 152, 11, 106, 56, 124, 153, 80, 62, 92, 174, 95, 135, 103, 216, 107, 53, 116, 9, 119, 142, 127, 59, 159, 202, 103, 23, 122, 57, 83, 139, 117, 237, 154, 102, 95, 157, 129, 241, 131, 152, 128, 60, 95, 197, 95, 98, 117, 70, 123, 60, 144, 103, 104, 235, 89, 155, 90, 16, 125, 126, 118, 44, 139, 245, 79, 106, 95, 25, 106, 55, 108, 2, 111, 226, 116, 104, 121, 104, 136, 85, 138, 121, 140, 223, 94, 207, 99, 197, 117, 210, 121, 215, 130, 40, 147, 242, 146, 156, 132, 237, 134, 45, 156, 193, 84, 108, 95, 140, 101, 92, 109, 21, 112, 167, 140, 211, 140, 59, 152, 79, 101, 246, 116, 13, 78, 216, 78, 224, 87, 43, 89, 102, 90, 204, 91, 168, 81, 3, 94, 156, 94, 22, 96, 118, 98, 119, 101, 167, 101, 110, 102, 110, 109, 54, 114, 38, 123, 80, 129, 154, 129, 153, 130, 92, 139, 160, 140, 230, 140, 116, 141, 28, 150, 68, 150, 174, 79, 171, 100, 102, 107, 30, 130, 97, 132, 106, 133, 232, 144, 1, 92, 83, 105, 168, 152, 122, 132, 87, 133, 15, 79, 111, 82, 169, 95, 69, 94, 13, 103, 143, 121, 121, 129, 7, 137, 134, 137, 245, 109, 23, 95, 85, 98, 184, 108, 207, 78, 105, 114, 146, 155, 6, 82, 59, 84, 116, 86, 179, 88, 164, 97, 110, 98, 26, 113, 110, 89, 137, 124, 222, 124, 27, 125, 240, 150, 135, 101, 94, 128, 25, 78, 117, 79, 117, 81, 64, 88, 99, 94, 115, 94, 10, 95, 196, 103, 38, 78, 61, 133, 137, 149, 91, 150, 115, 124, 1, 152, 251, 80, 193, 88, 86, 118, 167, 120, 37, 82, 165, 119, 17, 133, 134, 123, 79, 80, 9, 89, 71, 114, 199, 123, 232, 125, 186, 143, 212, 143, 77, 144, 191, 79, 201, 82, 41, 90, 1, 95, 173, 151, 221, 79, 23, 130, 234, 146, 3, 87, 85, 99, 105, 107, 43, 117, 220, 136, 20, 143, 66, 122, 223, 82, 147, 88, 85, 97, 10, 98, 174, 102, 205, 107, 63, 124, 233, 131, 35, 80, 248, 79, 5, 83, 70, 84, 49, 88, 73, 89, 157, 91, 240, 92, 239, 92, 41, 93, 150, 94, 177, 98, 103, 99, 62, 101, 185, 101, 11, 103, 213, 108, 225, 108, 249, 112, 50, 120, 43, 126, 222, 128, 179, 130, 12, 132, 236, 132, 2, 135, 18, 137, 42, 138, 74, 140, 166, 144, 210, 146, 253, 152, 243, 156, 108, 157, 79, 78, 161, 78, 141, 80, 86, 82, 74, 87, 168, 89, 61, 94, 216, 95, 217, 95, 63, 98, 180, 102, 27, 103, 208, 103, 210, 104, 146, 81, 33, 125, 170, 128, 168, 129, 0, 139, 140, 140, 191, 140, 126, 146, 50, 150, 32, 84, 44, 152, 23, 83, 213, 80, 92, 83, 168, 88, 178, 100, 52, 103, 103, 114, 102, 119, 70, 122, 230, 145, 195, 82, 161, 108, 134, 107, 0, 88, 76, 94, 84, 89, 44, 103, 251, 127, 225, 81, 198, 118, 105, 100, 232, 120, 84, 155, 187, 158, 203, 87, 185, 89, 39, 102, 154, 103, 206, 107, 233, 84, 217, 105, 85, 94, 156, 129, 149, 103, 170, 155, 254, 103, 82, 156, 93, 104, 166, 78, 227, 79, 200, 83, 185, 98, 43, 103, 171, 108, 196, 143, 173, 79, 109, 126, 191, 158, 7, 78, 98, 97, 128, 110, 43, 111, 19, 133, 115, 84, 42, 103, 69, 155, 243, 93, 149, 123, 172, 92, 198, 91, 28, 135, 74, 110, 209, 132, 20, 122, 8, 129, 153, 89, 141, 124, 17, 108, 32, 119, 217, 82, 34, 89, 33, 113, 95, 114, 219, 119, 39, 151, 97, 157, 11, 105, 127, 90, 24, 90, 165, 81, 13, 84, 125, 84, 14, 102, 223, 118, 247, 143, 152, 146, 244, 156, 234, 89, 93, 114, 197, 110, 77, 81, 201, 104, 191, 125, 236, 125, 98, 151, 186, 158, 120, 100, 33, 106, 2, 131, 132, 89, 95, 91, 219, 107, 27, 115, 242, 118, 178, 125, 23, 128, 153, 132, 50, 81, 40, 103, 217, 158, 238, 118, 98, 103, 255, 82, 5, 153, 36, 92, 59, 98, 126, 124, 176, 140, 79, 85, 182, 96, 11, 125, 128, 149, 1, 83, 95, 78, 182, 81, 28, 89, 58, 114, 54, 128, 206, 145, 37, 95, 226, 119, 132, 83, 121, 95, 4, 125, 172, 133, 51, 138, 141, 142, 86, 151, 243, 103, 174, 133, 83, 148, 9, 97, 8, 97, 185, 108, 82, 118, 237, 138, 56, 143, 47, 85, 81, 79, 42, 81, 199, 82, 203, 83, 165, 91, 125, 94, 160, 96, 130, 97, 214, 99, 9, 103, 218, 103, 103, 110, 140, 109, 54, 115, 55, 115, 49, 117, 80, 121, 213, 136, 152, 138, 74, 144, 145, 144, 245, 144, 196, 150, 141, 135, 21, 89, 136, 78, 89, 79, 14, 78, 137, 138, 63, 143, 16, 152, 173, 80, 124, 94, 150, 89, 185, 91, 184, 94, 218, 99, 250, 99, 193, 100, 220, 102, 74, 105, 216, 105, 11, 109, 182, 110, 148, 113, 40, 117, 175, 122, 138, 127, 0, 128, 73, 132, 201, 132, 129, 137, 33, 139, 10, 142, 101, 144, 125, 150, 10, 153, 126, 97, 145, 98, 50, 107, 131, 108, 116, 109, 204, 127, 252, 127, 192, 109, 133, 127, 186, 135, 248, 136, 101, 103, 177, 131, 60, 152, 247, 150, 27, 109, 97, 125, 61, 132, 106, 145, 113, 78, 117, 83, 80, 93, 4, 107, 235, 111, 205, 133, 45, 134, 167, 137, 41, 82, 15, 84, 101, 92, 78, 103, 168, 104, 6, 116, 131, 116, 226, 117, 207, 136, 225, 136, 204, 145, 226, 150, 120, 150, 139, 95, 135, 115, 203, 122, 78, 132, 160, 99, 101, 117, 137, 82, 65, 109, 156, 110, 9, 116, 89, 117, 107, 120, 146, 124, 134, 150, 220, 122, 141, 159, 182, 79, 110, 97, 197, 101, 92, 134, 134, 78, 174, 78, 218, 80, 33, 78, 204, 81, 238, 91, 153, 101, 129, 104, 188, 109, 31, 115, 66, 118, 173, 119, 28, 122, 231, 124, 111, 130, 210, 138, 124, 144, 207, 145, 117, 150, 24, 152, 155, 82, 209, 125, 43, 80, 152, 83, 151, 103, 203, 109, 208, 113, 51, 116, 232, 129, 42, 143, 163, 150, 87, 156, 159, 158, 96, 116, 65, 88, 153, 109, 47, 125, 94, 152, 228, 78, 54, 79, 139, 79, 183, 81, 177, 82, 186, 93, 28, 96, 178, 115, 60, 121, 211, 130, 52, 146, 183, 150, 246, 150, 10, 151, 151, 158, 98, 159, 166, 102, 116, 107, 23, 82, 163, 82, 200, 112, 194, 136, 201, 94, 75, 96, 144, 97, 35, 111, 73, 113, 62, 124, 244, 125, 111, 128, 238, 132, 35, 144, 44, 147, 66, 84, 111, 155, 211, 106, 137, 112, 194, 140, 239, 141, 50, 151, 180, 82, 65, 90, 202, 94, 4, 95, 23, 103, 124, 105, 148, 105, 106, 109, 15, 111, 98, 114, 252, 114, 237, 123, 1, 128, 126, 128, 75, 135, 206, 144, 109, 81, 147, 158, 132, 121, 139, 128, 50, 147, 214, 138, 45, 80, 140, 84, 113, 138, 106, 107, 196, 140, 7, 129, 209, 96, 160, 103, 242, 157, 153, 78, 152, 78, 16, 156, 107, 138, 193, 133, 104, 133, 0, 105, 126, 110, 151, 120, 85, 129, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 95, 16, 78, 21, 78, 42, 78, 49, 78, 54, 78, 60, 78, 63, 78, 66, 78, 86, 78, 88, 78, 130, 78, 133, 78, 107, 140, 138, 78, 18, 130, 13, 95, 142, 78, 158, 78, 159, 78, 160, 78, 162, 78, 176, 78, 179, 78, 182, 78, 206, 78, 205, 78, 196, 78, 198, 78, 194, 78, 215, 78, 222, 78, 237, 78, 223, 78, 247, 78, 9, 79, 90, 79, 48, 79, 91, 79, 93, 79, 87, 79, 71, 79, 118, 79, 136, 79, 143, 79, 152, 79, 123, 79, 105, 79, 112, 79, 145, 79, 111, 79, 134, 79, 150, 79, 24, 81, 212, 79, 223, 79, 206, 79, 216, 79, 219, 79, 209, 79, 218, 79, 208, 79, 228, 79, 229, 79, 26, 80, 40, 80, 20, 80, 42, 80, 37, 80, 5, 80, 28, 79, 246, 79, 33, 80, 41, 80, 44, 80, 254, 79, 239, 79, 17, 80, 6, 80, 67, 80, 71, 80, 3, 103, 85, 80, 80, 80, 72, 80, 90, 80, 86, 80, 108, 80, 120, 80, 128, 80, 154, 80, 133, 80, 180, 80, 178, 80, 201, 80, 202, 80, 179, 80, 194, 80, 214, 80, 222, 80, 229, 80, 237, 80, 227, 80, 238, 80, 249, 80, 245, 80, 9, 81, 1, 81, 2, 81, 22, 81, 21, 81, 20, 81, 26, 81, 33, 81, 58, 81, 55, 81, 60, 81, 59, 81, 63, 81, 64, 81, 82, 81, 76, 81, 84, 81, 98, 81, 248, 122, 105, 81, 106, 81, 110, 81, 128, 81, 130, 81, 216, 86, 140, 81, 137, 81, 143, 81, 145, 81, 147, 81, 149, 81, 150, 81, 164, 81, 166, 81, 162, 81, 169, 81, 170, 81, 171, 81, 179, 81, 177, 81, 178, 81, 176, 81, 181, 81, 189, 81, 197, 81, 201, 81, 219, 81, 224, 81, 85, 134, 233, 81, 237, 81, 240, 81, 245, 81, 254, 81, 4, 82, 11, 82, 20, 82, 14, 82, 39, 82, 42, 82, 46, 82, 51, 82, 57, 82, 79, 82, 68, 82, 75, 82, 76, 82, 94, 82, 84, 82, 106, 82, 116, 82, 105, 82, 115, 82, 127, 82, 125, 82, 141, 82, 148, 82, 146, 82, 113, 82, 136, 82, 145, 82, 168, 143, 167, 143, 172, 82, 173, 82, 188, 82, 181, 82, 193, 82, 205, 82, 215, 82, 222, 82, 227, 82, 230, 82, 237, 152, 224, 82, 243, 82, 245, 82, 248, 82, 249, 82, 6, 83, 8, 83, 56, 117, 13, 83, 16, 83, 15, 83, 21, 83, 26, 83, 35, 83, 47, 83, 49, 83, 51, 83, 56, 83, 64, 83, 70, 83, 69, 83, 23, 78, 73, 83, 77, 83, 214, 81, 94, 83, 105, 83, 110, 83, 24, 89, 123, 83, 119, 83, 130, 83, 150, 83, 160, 83, 166, 83, 165, 83, 174, 83, 176, 83, 182, 83, 195, 83, 18, 124, 217, 150, 223, 83, 252, 102, 238, 113, 238, 83, 232, 83, 237, 83, 250, 83, 1, 84, 61, 84, 64, 84, 44, 84, 45, 84, 60, 84, 46, 84, 54, 84, 41, 84, 29, 84, 78, 84, 143, 84, 117, 84, 142, 84, 95, 84, 113, 84, 119, 84, 112, 84, 146, 84, 123, 84, 128, 84, 118, 84, 132, 84, 144, 84, 134, 84, 199, 84, 162, 84, 184, 84, 165, 84, 172, 84, 196, 84, 200, 84, 168, 84, 171, 84, 194, 84, 164, 84, 190, 84, 188, 84, 216, 84, 229, 84, 230, 84, 15, 85, 20, 85, 253, 84, 238, 84, 237, 84, 250, 84, 226, 84, 57, 85, 64, 85, 99, 85, 76, 85, 46, 85, 92, 85, 69, 85, 86, 85, 87, 85, 56, 85, 51, 85, 93, 85, 153, 85, 128, 85, 175, 84, 138, 85, 159, 85, 123, 85, 126, 85, 152, 85, 158, 85, 174, 85, 124, 85, 131, 85, 169, 85, 135, 85, 168, 85, 218, 85, 197, 85, 223, 85, 196, 85, 220, 85, 228, 85, 212, 85, 20, 86, 247, 85, 22, 86, 254, 85, 253, 85, 27, 86, 249, 85, 78, 86, 80, 86, 223, 113, 52, 86, 54, 86, 50, 86, 56, 86, 107, 86, 100, 86, 47, 86, 108, 86, 106, 86, 134, 86, 128, 86, 138, 86, 160, 86, 148, 86, 143, 86, 165, 86, 174, 86, 182, 86, 180, 86, 194, 86, 188, 86, 193, 86, 195, 86, 192, 86, 200, 86, 206, 86, 209, 86, 211, 86, 215, 86, 238, 86, 249, 86, 0, 87, 255, 86, 4, 87, 9, 87, 8, 87, 11, 87, 13, 87, 19, 87, 24, 87, 22, 87, 199, 85, 28, 87, 38, 87, 55, 87, 56, 87, 78, 87, 59, 87, 64, 87, 79, 87, 105, 87, 192, 87, 136, 87, 97, 87, 127, 87, 137, 87, 147, 87, 160, 87, 179, 87, 164, 87, 170, 87, 176, 87, 195, 87, 198, 87, 212, 87, 210, 87, 211, 87, 10, 88, 214, 87, 227, 87, 11, 88, 25, 88, 29, 88, 114, 88, 33, 88, 98, 88, 75, 88, 112, 88, 192, 107, 82, 88, 61, 88, 121, 88, 133, 88, 185, 88, 159, 88, 171, 88, 186, 88, 222, 88, 187, 88, 184, 88, 174, 88, 197, 88, 211, 88, 209, 88, 215, 88, 217, 88, 216, 88, 229, 88, 220, 88, 228, 88, 223, 88, 239, 88, 250, 88, 249, 88, 251, 88, 252, 88, 253, 88, 2, 89, 10, 89, 16, 89, 27, 89, 166, 104, 37, 89, 44, 89, 45, 89, 50, 89, 56, 89, 62, 89, 210, 122, 85, 89, 80, 89, 78, 89, 90, 89, 88, 89, 98, 89, 96, 89, 103, 89, 108, 89, 105, 89, 120, 89, 129, 89, 157, 89, 94, 79, 171, 79, 163, 89, 178, 89, 198, 89, 232, 89, 220, 89, 141, 89, 217, 89, 218, 89, 37, 90, 31, 90, 17, 90, 28, 90, 9, 90, 26, 90, 64, 90, 108, 90, 73, 90, 53, 90, 54, 90, 98, 90, 106, 90, 154, 90, 188, 90, 190, 90, 203, 90, 194, 90, 189, 90, 227, 90, 215, 90, 230, 90, 233, 90, 214, 90, 250, 90, 251, 90, 12, 91, 11, 91, 22, 91, 50, 91, 208, 90, 42, 91, 54, 91, 62, 91, 67, 91, 69, 91, 64, 91, 81, 91, 85, 91, 90, 91, 91, 91, 101, 91, 105, 91, 112, 91, 115, 91, 117, 91, 120, 91, 136, 101, 122, 91, 128, 91, 131, 91, 166, 91, 184, 91, 195, 91, 199, 91, 201, 91, 212, 91, 208, 91, 228, 91, 230, 91, 226, 91, 222, 91, 229, 91, 235, 91, 240, 91, 246, 91, 243, 91, 5, 92, 7, 92, 8, 92, 13, 92, 19, 92, 32, 92, 34, 92, 40, 92, 56, 92, 57, 92, 65, 92, 70, 92, 78, 92, 83, 92, 80, 92, 79, 92, 113, 91, 108, 92, 110, 92, 98, 78, 118, 92, 121, 92, 140, 92, 145, 92, 148, 92, 155, 89, 171, 92, 187, 92, 182, 92, 188, 92, 183, 92, 197, 92, 190, 92, 199, 92, 217, 92, 233, 92, 253, 92, 250, 92, 237, 92, 140, 93, 234, 92, 11, 93, 21, 93, 23, 93, 92, 93, 31, 93, 27, 93, 17, 93, 20, 93, 34, 93, 26, 93, 25, 93, 24, 93, 76, 93, 82, 93, 78, 93, 75, 93, 108, 93, 115, 93, 118, 93, 135, 93, 132, 93, 130, 93, 162, 93, 157, 93, 172, 93, 174, 93, 189, 93, 144, 93, 183, 93, 188, 93, 201, 93, 205, 93, 211, 93, 210, 93, 214, 93, 219, 93, 235, 93, 242, 93, 245, 93, 11, 94, 26, 94, 25, 94, 17, 94, 27, 94, 54, 94, 55, 94, 68, 94, 67, 94, 64, 94, 78, 94, 87, 94, 84, 94, 95, 94, 98, 94, 100, 94, 71, 94, 117, 94, 118, 94, 122, 94, 188, 158, 127, 94, 160, 94, 193, 94, 194, 94, 200, 94, 208, 94, 207, 94, 214, 94, 227, 94, 221, 94, 218, 94, 219, 94, 226, 94, 225, 94, 232, 94, 233, 94, 236, 94, 241, 94, 243, 94, 240, 94, 244, 94, 248, 94, 254, 94, 3, 95, 9, 95, 93, 95, 92, 95, 11, 95, 17, 95, 22, 95, 41, 95, 45, 95, 56, 95, 65, 95, 72, 95, 76, 95, 78, 95, 47, 95, 81, 95, 86, 95, 87, 95, 89, 95, 97, 95, 109, 95, 115, 95, 119, 95, 131, 95, 130, 95, 127, 95, 138, 95, 136, 95, 145, 95, 135, 95, 158, 95, 153, 95, 152, 95, 160, 95, 168, 95, 173, 95, 188, 95, 214, 95, 251, 95, 228, 95, 248, 95, 241, 95, 221, 95, 179, 96, 255, 95, 33, 96, 96, 96, 25, 96, 16, 96, 41, 96, 14, 96, 49, 96, 27, 96, 21, 96, 43, 96, 38, 96, 15, 96, 58, 96, 90, 96, 65, 96, 106, 96, 119, 96, 95, 96, 74, 96, 70, 96, 77, 96, 99, 96, 67, 96, 100, 96, 66, 96, 108, 96, 107, 96, 89, 96, 129, 96, 141, 96, 231, 96, 131, 96, 154, 96, 132, 96, 155, 96, 150, 96, 151, 96, 146, 96, 167, 96, 139, 96, 225, 96, 184, 96, 224, 96, 211, 96, 180, 96, 240, 95, 189, 96, 198, 96, 181, 96, 216, 96, 77, 97, 21, 97, 6, 97, 246, 96, 247, 96, 0, 97, 244, 96, 250, 96, 3, 97, 33, 97, 251, 96, 241, 96, 13, 97, 14, 97, 71, 97, 62, 97, 40, 97, 39, 97, 74, 97, 63, 97, 60, 97, 44, 97, 52, 97, 61, 97, 66, 97, 68, 97, 115, 97, 119, 97, 88, 97, 89, 97, 90, 97, 107, 97, 116, 97, 111, 97, 101, 97, 113, 97, 95, 97, 93, 97, 83, 97, 117, 97, 153, 97, 150, 97, 135, 97, 172, 97, 148, 97, 154, 97, 138, 97, 145, 97, 171, 97, 174, 97, 204, 97, 202, 97, 201, 97, 247, 97, 200, 97, 195, 97, 198, 97, 186, 97, 203, 97, 121, 127, 205, 97, 230, 97, 227, 97, 246, 97, 250, 97, 244, 97, 255, 97, 253, 97, 252, 97, 254, 97, 0, 98, 8, 98, 9, 98, 13, 98, 12, 98, 20, 98, 27, 98, 30, 98, 33, 98, 42, 98, 46, 98, 48, 98, 50, 98, 51, 98, 65, 98, 78, 98, 94, 98, 99, 98, 91, 98, 96, 98, 104, 98, 124, 98, 130, 98, 137, 98, 126, 98, 146, 98, 147, 98, 150, 98, 212, 98, 131, 98, 148, 98, 215, 98, 209, 98, 187, 98, 207, 98, 255, 98, 198, 98, 212, 100, 200, 98, 220, 98, 204, 98, 202, 98, 194, 98, 199, 98, 155, 98, 201, 98, 12, 99, 238, 98, 241, 98, 39, 99, 2, 99, 8, 99, 239, 98, 245, 98, 80, 99, 62, 99, 77, 99, 28, 100, 79, 99, 150, 99, 142, 99, 128, 99, 171, 99, 118, 99, 163, 99, 143, 99, 137, 99, 159, 99, 181, 99, 107, 99, 105, 99, 190, 99, 233, 99, 192, 99, 198, 99, 227, 99, 201, 99, 210, 99, 246, 99, 196, 99, 22, 100, 52, 100, 6, 100, 19, 100, 38, 100, 54, 100, 29, 101, 23, 100, 40, 100, 15, 100, 103, 100, 111, 100, 118, 100, 78, 100, 42, 101, 149, 100, 147, 100, 165, 100, 169, 100, 136, 100, 188, 100, 218, 100, 210, 100, 197, 100, 199, 100, 187, 100, 216, 100, 194, 100, 241, 100, 231, 100, 9, 130, 224, 100, 225, 100, 172, 98, 227, 100, 239, 100, 44, 101, 246, 100, 244, 100, 242, 100, 250, 100, 0, 101, 253, 100, 24, 101, 28, 101, 5, 101, 36, 101, 35, 101, 43, 101, 52, 101, 53, 101, 55, 101, 54, 101, 56, 101, 75, 117, 72, 101, 86, 101, 85, 101, 77, 101, 88, 101, 94, 101, 93, 101, 114, 101, 120, 101, 130, 101, 131, 101, 138, 139, 155, 101, 159, 101, 171, 101, 183, 101, 195, 101, 198, 101, 193, 101, 196, 101, 204, 101, 210, 101, 219, 101, 217, 101, 224, 101, 225, 101, 241, 101, 114, 103, 10, 102, 3, 102, 251, 101, 115, 103, 53, 102, 54, 102, 52, 102, 28, 102, 79, 102, 68, 102, 73, 102, 65, 102, 94, 102, 93, 102, 100, 102, 103, 102, 104, 102, 95, 102, 98, 102, 112, 102, 131, 102, 136, 102, 142, 102, 137, 102, 132, 102, 152, 102, 157, 102, 193, 102, 185, 102, 201, 102, 190, 102, 188, 102, 196, 102, 184, 102, 214, 102, 218, 102, 224, 102, 63, 102, 230, 102, 233, 102, 240, 102, 245, 102, 247, 102, 15, 103, 22, 103, 30, 103, 38, 103, 39, 103, 56, 151, 46, 103, 63, 103, 54, 103, 65, 103, 56, 103, 55, 103, 70, 103, 94, 103, 96, 103, 89, 103, 99, 103, 100, 103, 137, 103, 112, 103, 169, 103, 124, 103, 106, 103, 140, 103, 139, 103, 166, 103, 161, 103, 133, 103, 183, 103, 239, 103, 180, 103, 236, 103, 179, 103, 233, 103, 184, 103, 228, 103, 222, 103, 221, 103, 226, 103, 238, 103, 185, 103, 206, 103, 198, 103, 231, 103, 156, 106, 30, 104, 70, 104, 41, 104, 64, 104, 77, 104, 50, 104, 78, 104, 179, 104, 43, 104, 89, 104, 99, 104, 119, 104, 127, 104, 159, 104, 143, 104, 173, 104, 148, 104, 157, 104, 155, 104, 131, 104, 174, 106, 185, 104, 116, 104, 181, 104, 160, 104, 186, 104, 15, 105, 141, 104, 126, 104, 1, 105, 202, 104, 8, 105, 216, 104, 34, 105, 38, 105, 225, 104, 12, 105, 205, 104, 212, 104, 231, 104, 213, 104, 54, 105, 18, 105, 4, 105, 215, 104, 227, 104, 37, 105, 249, 104, 224, 104, 239, 104, 40, 105, 42, 105, 26, 105, 35, 105, 33, 105, 198, 104, 121, 105, 119, 105, 92, 105, 120, 105, 107, 105, 84, 105, 126, 105, 110, 105, 57, 105, 116, 105, 61, 105, 89, 105, 48, 105, 97, 105, 94, 105, 93, 105, 129, 105, 106, 105, 178, 105, 174, 105, 208, 105, 191, 105, 193, 105, 211, 105, 190, 105, 206, 105, 232, 91, 202, 105, 221, 105, 187, 105, 195, 105, 167, 105, 46, 106, 145, 105, 160, 105, 156, 105, 149, 105, 180, 105, 222, 105, 232, 105, 2, 106, 27, 106, 255, 105, 10, 107, 249, 105, 242, 105, 231, 105, 5, 106, 177, 105, 30, 106, 237, 105, 20, 106, 235, 105, 10, 106, 18, 106, 193, 106, 35, 106, 19, 106, 68, 106, 12, 106, 114, 106, 54, 106, 120, 106, 71, 106, 98, 106, 89, 106, 102, 106, 72, 106, 56, 106, 34, 106, 144, 106, 141, 106, 160, 106, 132, 106, 162, 106, 163, 106, 151, 106, 23, 134, 187, 106, 195, 106, 194, 106, 184, 106, 179, 106, 172, 106, 222, 106, 209, 106, 223, 106, 170, 106, 218, 106, 234, 106, 251, 106, 5, 107, 22, 134, 250, 106, 18, 107, 22, 107, 49, 155, 31, 107, 56, 107, 55, 107, 220, 118, 57, 107, 238, 152, 71, 107, 67, 107, 73, 107, 80, 107, 89, 107, 84, 107, 91, 107, 95, 107, 97, 107, 120, 107, 121, 107, 127, 107, 128, 107, 132, 107, 131, 107, 141, 107, 152, 107, 149, 107, 158, 107, 164, 107, 170, 107, 171, 107, 175, 107, 178, 107, 177, 107, 179, 107, 183, 107, 188, 107, 198, 107, 203, 107, 211, 107, 223, 107, 236, 107, 235, 107, 243, 107, 239, 107, 190, 158, 8, 108, 19, 108, 20, 108, 27, 108, 36, 108, 35, 108, 94, 108, 85, 108, 98, 108, 106, 108, 130, 108, 141, 108, 154, 108, 129, 108, 155, 108, 126, 108, 104, 108, 115, 108, 146, 108, 144, 108, 196, 108, 241, 108, 211, 108, 189, 108, 215, 108, 197, 108, 221, 108, 174, 108, 177, 108, 190, 108, 186, 108, 219, 108, 239, 108, 217, 108, 234, 108, 31, 109, 77, 136, 54, 109, 43, 109, 61, 109, 56, 109, 25, 109, 53, 109, 51, 109, 18, 109, 12, 109, 99, 109, 147, 109, 100, 109, 90, 109, 121, 109, 89, 109, 142, 109, 149, 109, 228, 111, 133, 109, 249, 109, 21, 110, 10, 110, 181, 109, 199, 109, 230, 109, 184, 109, 198, 109, 236, 109, 222, 109, 204, 109, 232, 109, 210, 109, 197, 109, 250, 109, 217, 109, 228, 109, 213, 109, 234, 109, 238, 109, 45, 110, 110, 110, 46, 110, 25, 110, 114, 110, 95, 110, 62, 110, 35, 110, 107, 110, 43, 110, 118, 110, 77, 110, 31, 110, 67, 110, 58, 110, 78, 110, 36, 110, 255, 110, 29, 110, 56, 110, 130, 110, 170, 110, 152, 110, 201, 110, 183, 110, 211, 110, 189, 110, 175, 110, 196, 110, 178, 110, 212, 110, 213, 110, 143, 110, 165, 110, 194, 110, 159, 110, 65, 111, 17, 111, 76, 112, 236, 110, 248, 110, 254, 110, 63, 111, 242, 110, 49, 111, 239, 110, 50, 111, 204, 110, 62, 111, 19, 111, 247, 110, 134, 111, 122, 111, 120, 111, 129, 111, 128, 111, 111, 111, 91, 111, 243, 111, 109, 111, 130, 111, 124, 111, 88, 111, 142, 111, 145, 111, 194, 111, 102, 111, 179, 111, 163, 111, 161, 111, 164, 111, 185, 111, 198, 111, 170, 111, 223, 111, 213, 111, 236, 111, 212, 111, 216, 111, 241, 111, 238, 111, 219, 111, 9, 112, 11, 112, 250, 111, 17, 112, 1, 112, 15, 112, 254, 111, 27, 112, 26, 112, 116, 111, 29, 112, 24, 112, 31, 112, 48, 112, 62, 112, 50, 112, 81, 112, 99, 112, 153, 112, 146, 112, 175, 112, 241, 112, 172, 112, 184, 112, 179, 112, 174, 112, 223, 112, 203, 112, 221, 112, 217, 112, 9, 113, 253, 112, 28, 113, 25, 113, 101, 113, 85, 113, 136, 113, 102, 113, 98, 113, 76, 113, 86, 113, 108, 113, 143, 113, 251, 113, 132, 113, 149, 113, 168, 113, 172, 113, 215, 113, 185, 113, 190, 113, 210, 113, 201, 113, 212, 113, 206, 113, 224, 113, 236, 113, 231, 113, 245, 113, 252, 113, 249, 113, 255, 113, 13, 114, 16, 114, 27, 114, 40, 114, 45, 114, 44, 114, 48, 114, 50, 114, 59, 114, 60, 114, 63, 114, 64, 114, 70, 114, 75, 114, 88, 114, 116, 114, 126, 114, 130, 114, 129, 114, 135, 114, 146, 114, 150, 114, 162, 114, 167, 114, 185, 114, 178, 114, 195, 114, 198, 114, 196, 114, 206, 114, 210, 114, 226, 114, 224, 114, 225, 114, 249, 114, 247, 114, 15, 80, 23, 115, 10, 115, 28, 115, 22, 115, 29, 115, 52, 115, 47, 115, 41, 115, 37, 115, 62, 115, 78, 115, 79, 115, 216, 158, 87, 115, 106, 115, 104, 115, 112, 115, 120, 115, 117, 115, 123, 115, 122, 115, 200, 115, 179, 115, 206, 115, 187, 115, 192, 115, 229, 115, 238, 115, 222, 115, 162, 116, 5, 116, 111, 116, 37, 116, 248, 115, 50, 116, 58, 116, 85, 116, 63, 116, 95, 116, 89, 116, 65, 116, 92, 116, 105, 116, 112, 116, 99, 116, 106, 116, 118, 116, 126, 116, 139, 116, 158, 116, 167, 116, 202, 116, 207, 116, 212, 116, 241, 115, 224, 116, 227, 116, 231, 116, 233, 116, 238, 116, 242, 116, 240, 116, 241, 116, 248, 116, 247, 116, 4, 117, 3, 117, 5, 117, 12, 117, 14, 117, 13, 117, 21, 117, 19, 117, 30, 117, 38, 117, 44, 117, 60, 117, 68, 117, 77, 117, 74, 117, 73, 117, 91, 117, 70, 117, 90, 117, 105, 117, 100, 117, 103, 117, 107, 117, 109, 117, 120, 117, 118, 117, 134, 117, 135, 117, 116, 117, 138, 117, 137, 117, 130, 117, 148, 117, 154, 117, 157, 117, 165, 117, 163, 117, 194, 117, 179, 117, 195, 117, 181, 117, 189, 117, 184, 117, 188, 117, 177, 117, 205, 117, 202, 117, 210, 117, 217, 117, 227, 117, 222, 117, 254, 117, 255, 117, 252, 117, 1, 118, 240, 117, 250, 117, 242, 117, 243, 117, 11, 118, 13, 118, 9, 118, 31, 118, 39, 118, 32, 118, 33, 118, 34, 118, 36, 118, 52, 118, 48, 118, 59, 118, 71, 118, 72, 118, 70, 118, 92, 118, 88, 118, 97, 118, 98, 118, 104, 118, 105, 118, 106, 118, 103, 118, 108, 118, 112, 118, 114, 118, 118, 118, 120, 118, 124, 118, 128, 118, 131, 118, 136, 118, 139, 118, 142, 118, 150, 118, 147, 118, 153, 118, 154, 118, 176, 118, 180, 118, 184, 118, 185, 118, 186, 118, 194, 118, 205, 118, 214, 118, 210, 118, 222, 118, 225, 118, 229, 118, 231, 118, 234, 118, 47, 134, 251, 118, 8, 119, 7, 119, 4, 119, 41, 119, 36, 119, 30, 119, 37, 119, 38, 119, 27, 119, 55, 119, 56, 119, 71, 119, 90, 119, 104, 119, 107, 119, 91, 119, 101, 119, 127, 119, 126, 119, 121, 119, 142, 119, 139, 119, 145, 119, 160, 119, 158, 119, 176, 119, 182, 119, 185, 119, 191, 119, 188, 119, 189, 119, 187, 119, 199, 119, 205, 119, 215, 119, 218, 119, 220, 119, 227, 119, 238, 119, 252, 119, 12, 120, 18, 120, 38, 121, 32, 120, 42, 121, 69, 120, 142, 120, 116, 120, 134, 120, 124, 120, 154, 120, 140, 120, 163, 120, 181, 120, 170, 120, 175, 120, 209, 120, 198, 120, 203, 120, 212, 120, 190, 120, 188, 120, 197, 120, 202, 120, 236, 120, 231, 120, 218, 120, 253, 120, 244, 120, 7, 121, 18, 121, 17, 121, 25, 121, 44, 121, 43, 121, 64, 121, 96, 121, 87, 121, 95, 121, 90, 121, 85, 121, 83, 121, 122, 121, 127, 121, 138, 121, 157, 121, 167, 121, 75, 159, 170, 121, 174, 121, 179, 121, 185, 121, 186, 121, 201, 121, 213, 121, 231, 121, 236, 121, 225, 121, 227, 121, 8, 122, 13, 122, 24, 122, 25, 122, 32, 122, 31, 122, 128, 121, 49, 122, 59, 122, 62, 122, 55, 122, 67, 122, 87, 122, 73, 122, 97, 122, 98, 122, 105, 122, 157, 159, 112, 122, 121, 122, 125, 122, 136, 122, 151, 122, 149, 122, 152, 122, 150, 122, 169, 122, 200, 122, 176, 122, 182, 122, 197, 122, 196, 122, 191, 122, 131, 144, 199, 122, 202, 122, 205, 122, 207, 122, 213, 122, 211, 122, 217, 122, 218, 122, 221, 122, 225, 122, 226, 122, 230, 122, 237, 122, 240, 122, 2, 123, 15, 123, 10, 123, 6, 123, 51, 123, 24, 123, 25, 123, 30, 123, 53, 123, 40, 123, 54, 123, 80, 123, 122, 123, 4, 123, 77, 123, 11, 123, 76, 123, 69, 123, 117, 123, 101, 123, 116, 123, 103, 123, 112, 123, 113, 123, 108, 123, 110, 123, 157, 123, 152, 123, 159, 123, 141, 123, 156, 123, 154, 123, 139, 123, 146, 123, 143, 123, 93, 123, 153, 123, 203, 123, 193, 123, 204, 123, 207, 123, 180, 123, 198, 123, 221, 123, 233, 123, 17, 124, 20, 124, 230, 123, 229, 123, 96, 124, 0, 124, 7, 124, 19, 124, 243, 123, 247, 123, 23, 124, 13, 124, 246, 123, 35, 124, 39, 124, 42, 124, 31, 124, 55, 124, 43, 124, 61, 124, 76, 124, 67, 124, 84, 124, 79, 124, 64, 124, 80, 124, 88, 124, 95, 124, 100, 124, 86, 124, 101, 124, 108, 124, 117, 124, 131, 124, 144, 124, 164, 124, 173, 124, 162, 124, 171, 124, 161, 124, 168, 124, 179, 124, 178, 124, 177, 124, 174, 124, 185, 124, 189, 124, 192, 124, 197, 124, 194, 124, 216, 124, 210, 124, 220, 124, 226, 124, 59, 155, 239, 124, 242, 124, 244, 124, 246, 124, 250, 124, 6, 125, 2, 125, 28, 125, 21, 125, 10, 125, 69, 125, 75, 125, 46, 125, 50, 125, 63, 125, 53, 125, 70, 125, 115, 125, 86, 125, 78, 125, 114, 125, 104, 125, 110, 125, 79, 125, 99, 125, 147, 125, 137, 125, 91, 125, 143, 125, 125, 125, 155, 125, 186, 125, 174, 125, 163, 125, 181, 125, 199, 125, 189, 125, 171, 125, 61, 126, 162, 125, 175, 125, 220, 125, 184, 125, 159, 125, 176, 125, 216, 125, 221, 125, 228, 125, 222, 125, 251, 125, 242, 125, 225, 125, 5, 126, 10, 126, 35, 126, 33, 126, 18, 126, 49, 126, 31, 126, 9, 126, 11, 126, 34, 126, 70, 126, 102, 126, 59, 126, 53, 126, 57, 126, 67, 126, 55, 126, 50, 126, 58, 126, 103, 126, 93, 126, 86, 126, 94, 126, 89, 126, 90, 126, 121, 126, 106, 126, 105, 126, 124, 126, 123, 126, 131, 126, 213, 125, 125, 126, 174, 143, 127, 126, 136, 126, 137, 126, 140, 126, 146, 126, 144, 126, 147, 126, 148, 126, 150, 126, 142, 126, 155, 126, 156, 126, 56, 127, 58, 127, 69, 127, 76, 127, 77, 127, 78, 127, 80, 127, 81, 127, 85, 127, 84, 127, 88, 127, 95, 127, 96, 127, 104, 127, 105, 127, 103, 127, 120, 127, 130, 127, 134, 127, 131, 127, 136, 127, 135, 127, 140, 127, 148, 127, 158, 127, 157, 127, 154, 127, 163, 127, 175, 127, 178, 127, 185, 127, 174, 127, 182, 127, 184, 127, 113, 139, 197, 127, 198, 127, 202, 127, 213, 127, 212, 127, 225, 127, 230, 127, 233, 127, 243, 127, 249, 127, 220, 152], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 210108);
	        allocate([6, 128, 4, 128, 11, 128, 18, 128, 24, 128, 25, 128, 28, 128, 33, 128, 40, 128, 63, 128, 59, 128, 74, 128, 70, 128, 82, 128, 88, 128, 90, 128, 95, 128, 98, 128, 104, 128, 115, 128, 114, 128, 112, 128, 118, 128, 121, 128, 125, 128, 127, 128, 132, 128, 134, 128, 133, 128, 155, 128, 147, 128, 154, 128, 173, 128, 144, 81, 172, 128, 219, 128, 229, 128, 217, 128, 221, 128, 196, 128, 218, 128, 214, 128, 9, 129, 239, 128, 241, 128, 27, 129, 41, 129, 35, 129, 47, 129, 75, 129, 139, 150, 70, 129, 62, 129, 83, 129, 81, 129, 252, 128, 113, 129, 110, 129, 101, 129, 102, 129, 116, 129, 131, 129, 136, 129, 138, 129, 128, 129, 130, 129, 160, 129, 149, 129, 164, 129, 163, 129, 95, 129, 147, 129, 169, 129, 176, 129, 181, 129, 190, 129, 184, 129, 189, 129, 192, 129, 194, 129, 186, 129, 201, 129, 205, 129, 209, 129, 217, 129, 216, 129, 200, 129, 218, 129, 223, 129, 224, 129, 231, 129, 250, 129, 251, 129, 254, 129, 1, 130, 2, 130, 5, 130, 7, 130, 10, 130, 13, 130, 16, 130, 22, 130, 41, 130, 43, 130, 56, 130, 51, 130, 64, 130, 89, 130, 88, 130, 93, 130, 90, 130, 95, 130, 100, 130, 98, 130, 104, 130, 106, 130, 107, 130, 46, 130, 113, 130, 119, 130, 120, 130, 126, 130, 141, 130, 146, 130, 171, 130, 159, 130, 187, 130, 172, 130, 225, 130, 227, 130, 223, 130, 210, 130, 244, 130, 243, 130, 250, 130, 147, 131, 3, 131, 251, 130, 249, 130, 222, 130, 6, 131, 220, 130, 9, 131, 217, 130, 53, 131, 52, 131, 22, 131, 50, 131, 49, 131, 64, 131, 57, 131, 80, 131, 69, 131, 47, 131, 43, 131, 23, 131, 24, 131, 133, 131, 154, 131, 170, 131, 159, 131, 162, 131, 150, 131, 35, 131, 142, 131, 135, 131, 138, 131, 124, 131, 181, 131, 115, 131, 117, 131, 160, 131, 137, 131, 168, 131, 244, 131, 19, 132, 235, 131, 206, 131, 253, 131, 3, 132, 216, 131, 11, 132, 193, 131, 247, 131, 7, 132, 224, 131, 242, 131, 13, 132, 34, 132, 32, 132, 189, 131, 56, 132, 6, 133, 251, 131, 109, 132, 42, 132, 60, 132, 90, 133, 132, 132, 119, 132, 107, 132, 173, 132, 110, 132, 130, 132, 105, 132, 70, 132, 44, 132, 111, 132, 121, 132, 53, 132, 202, 132, 98, 132, 185, 132, 191, 132, 159, 132, 217, 132, 205, 132, 187, 132, 218, 132, 208, 132, 193, 132, 198, 132, 214, 132, 161, 132, 33, 133, 255, 132, 244, 132, 23, 133, 24, 133, 44, 133, 31, 133, 21, 133, 20, 133, 252, 132, 64, 133, 99, 133, 88, 133, 72, 133, 65, 133, 2, 134, 75, 133, 85, 133, 128, 133, 164, 133, 136, 133, 145, 133, 138, 133, 168, 133, 109, 133, 148, 133, 155, 133, 234, 133, 135, 133, 156, 133, 119, 133, 126, 133, 144, 133, 201, 133, 186, 133, 207, 133, 185, 133, 208, 133, 213, 133, 221, 133, 229, 133, 220, 133, 249, 133, 10, 134, 19, 134, 11, 134, 254, 133, 250, 133, 6, 134, 34, 134, 26, 134, 48, 134, 63, 134, 77, 134, 85, 78, 84, 134, 95, 134, 103, 134, 113, 134, 147, 134, 163, 134, 169, 134, 170, 134, 139, 134, 140, 134, 182, 134, 175, 134, 196, 134, 198, 134, 176, 134, 201, 134, 35, 136, 171, 134, 212, 134, 222, 134, 233, 134, 236, 134, 223, 134, 219, 134, 239, 134, 18, 135, 6, 135, 8, 135, 0, 135, 3, 135, 251, 134, 17, 135, 9, 135, 13, 135, 249, 134, 10, 135, 52, 135, 63, 135, 55, 135, 59, 135, 37, 135, 41, 135, 26, 135, 96, 135, 95, 135, 120, 135, 76, 135, 78, 135, 116, 135, 87, 135, 104, 135, 110, 135, 89, 135, 83, 135, 99, 135, 106, 135, 5, 136, 162, 135, 159, 135, 130, 135, 175, 135, 203, 135, 189, 135, 192, 135, 208, 135, 214, 150, 171, 135, 196, 135, 179, 135, 199, 135, 198, 135, 187, 135, 239, 135, 242, 135, 224, 135, 15, 136, 13, 136, 254, 135, 246, 135, 247, 135, 14, 136, 210, 135, 17, 136, 22, 136, 21, 136, 34, 136, 33, 136, 49, 136, 54, 136, 57, 136, 39, 136, 59, 136, 68, 136, 66, 136, 82, 136, 89, 136, 94, 136, 98, 136, 107, 136, 129, 136, 126, 136, 158, 136, 117, 136, 125, 136, 181, 136, 114, 136, 130, 136, 151, 136, 146, 136, 174, 136, 153, 136, 162, 136, 141, 136, 164, 136, 176, 136, 191, 136, 177, 136, 195, 136, 196, 136, 212, 136, 216, 136, 217, 136, 221, 136, 249, 136, 2, 137, 252, 136, 244, 136, 232, 136, 242, 136, 4, 137, 12, 137, 10, 137, 19, 137, 67, 137, 30, 137, 37, 137, 42, 137, 43, 137, 65, 137, 68, 137, 59, 137, 54, 137, 56, 137, 76, 137, 29, 137, 96, 137, 94, 137, 102, 137, 100, 137, 109, 137, 106, 137, 111, 137, 116, 137, 119, 137, 126, 137, 131, 137, 136, 137, 138, 137, 147, 137, 152, 137, 161, 137, 169, 137, 166, 137, 172, 137, 175, 137, 178, 137, 186, 137, 189, 137, 191, 137, 192, 137, 218, 137, 220, 137, 221, 137, 231, 137, 244, 137, 248, 137, 3, 138, 22, 138, 16, 138, 12, 138, 27, 138, 29, 138, 37, 138, 54, 138, 65, 138, 91, 138, 82, 138, 70, 138, 72, 138, 124, 138, 109, 138, 108, 138, 98, 138, 133, 138, 130, 138, 132, 138, 168, 138, 161, 138, 145, 138, 165, 138, 166, 138, 154, 138, 163, 138, 196, 138, 205, 138, 194, 138, 218, 138, 235, 138, 243, 138, 231, 138, 228, 138, 241, 138, 20, 139, 224, 138, 226, 138, 247, 138, 222, 138, 219, 138, 12, 139, 7, 139, 26, 139, 225, 138, 22, 139, 16, 139, 23, 139, 32, 139, 51, 139, 171, 151, 38, 139, 43, 139, 62, 139, 40, 139, 65, 139, 76, 139, 79, 139, 78, 139, 73, 139, 86, 139, 91, 139, 90, 139, 107, 139, 95, 139, 108, 139, 111, 139, 116, 139, 125, 139, 128, 139, 140, 139, 142, 139, 146, 139, 147, 139, 150, 139, 153, 139, 154, 139, 58, 140, 65, 140, 63, 140, 72, 140, 76, 140, 78, 140, 80, 140, 85, 140, 98, 140, 108, 140, 120, 140, 122, 140, 130, 140, 137, 140, 133, 140, 138, 140, 141, 140, 142, 140, 148, 140, 124, 140, 152, 140, 29, 98, 173, 140, 170, 140, 189, 140, 178, 140, 179, 140, 174, 140, 182, 140, 200, 140, 193, 140, 228, 140, 227, 140, 218, 140, 253, 140, 250, 140, 251, 140, 4, 141, 5, 141, 10, 141, 7, 141, 15, 141, 13, 141, 16, 141, 78, 159, 19, 141, 205, 140, 20, 141, 22, 141, 103, 141, 109, 141, 113, 141, 115, 141, 129, 141, 153, 141, 194, 141, 190, 141, 186, 141, 207, 141, 218, 141, 214, 141, 204, 141, 219, 141, 203, 141, 234, 141, 235, 141, 223, 141, 227, 141, 252, 141, 8, 142, 9, 142, 255, 141, 29, 142, 30, 142, 16, 142, 31, 142, 66, 142, 53, 142, 48, 142, 52, 142, 74, 142, 71, 142, 73, 142, 76, 142, 80, 142, 72, 142, 89, 142, 100, 142, 96, 142, 42, 142, 99, 142, 85, 142, 118, 142, 114, 142, 124, 142, 129, 142, 135, 142, 133, 142, 132, 142, 139, 142, 138, 142, 147, 142, 145, 142, 148, 142, 153, 142, 170, 142, 161, 142, 172, 142, 176, 142, 198, 142, 177, 142, 190, 142, 197, 142, 200, 142, 203, 142, 219, 142, 227, 142, 252, 142, 251, 142, 235, 142, 254, 142, 10, 143, 5, 143, 21, 143, 18, 143, 25, 143, 19, 143, 28, 143, 31, 143, 27, 143, 12, 143, 38, 143, 51, 143, 59, 143, 57, 143, 69, 143, 66, 143, 62, 143, 76, 143, 73, 143, 70, 143, 78, 143, 87, 143, 92, 143, 98, 143, 99, 143, 100, 143, 156, 143, 159, 143, 163, 143, 173, 143, 175, 143, 183, 143, 218, 143, 229, 143, 226, 143, 234, 143, 239, 143, 135, 144, 244, 143, 5, 144, 249, 143, 250, 143, 17, 144, 21, 144, 33, 144, 13, 144, 30, 144, 22, 144, 11, 144, 39, 144, 54, 144, 53, 144, 57, 144, 248, 143, 79, 144, 80, 144, 81, 144, 82, 144, 14, 144, 73, 144, 62, 144, 86, 144, 88, 144, 94, 144, 104, 144, 111, 144, 118, 144, 168, 150, 114, 144, 130, 144, 125, 144, 129, 144, 128, 144, 138, 144, 137, 144, 143, 144, 168, 144, 175, 144, 177, 144, 181, 144, 226, 144, 228, 144, 72, 98, 219, 144, 2, 145, 18, 145, 25, 145, 50, 145, 48, 145, 74, 145, 86, 145, 88, 145, 99, 145, 101, 145, 105, 145, 115, 145, 114, 145, 139, 145, 137, 145, 130, 145, 162, 145, 171, 145, 175, 145, 170, 145, 181, 145, 180, 145, 186, 145, 192, 145, 193, 145, 201, 145, 203, 145, 208, 145, 214, 145, 223, 145, 225, 145, 219, 145, 252, 145, 245, 145, 246, 145, 30, 146, 255, 145, 20, 146, 44, 146, 21, 146, 17, 146, 94, 146, 87, 146, 69, 146, 73, 146, 100, 146, 72, 146, 149, 146, 63, 146, 75, 146, 80, 146, 156, 146, 150, 146, 147, 146, 155, 146, 90, 146, 207, 146, 185, 146, 183, 146, 233, 146, 15, 147, 250, 146, 68, 147, 46, 147, 25, 147, 34, 147, 26, 147, 35, 147, 58, 147, 53, 147, 59, 147, 92, 147, 96, 147, 124, 147, 110, 147, 86, 147, 176, 147, 172, 147, 173, 147, 148, 147, 185, 147, 214, 147, 215, 147, 232, 147, 229, 147, 216, 147, 195, 147, 221, 147, 208, 147, 200, 147, 228, 147, 26, 148, 20, 148, 19, 148, 3, 148, 7, 148, 16, 148, 54, 148, 43, 148, 53, 148, 33, 148, 58, 148, 65, 148, 82, 148, 68, 148, 91, 148, 96, 148, 98, 148, 94, 148, 106, 148, 41, 146, 112, 148, 117, 148, 119, 148, 125, 148, 90, 148, 124, 148, 126, 148, 129, 148, 127, 148, 130, 149, 135, 149, 138, 149, 148, 149, 150, 149, 152, 149, 153, 149, 160, 149, 168, 149, 167, 149, 173, 149, 188, 149, 187, 149, 185, 149, 190, 149, 202, 149, 246, 111, 195, 149, 205, 149, 204, 149, 213, 149, 212, 149, 214, 149, 220, 149, 225, 149, 229, 149, 226, 149, 33, 150, 40, 150, 46, 150, 47, 150, 66, 150, 76, 150, 79, 150, 75, 150, 119, 150, 92, 150, 94, 150, 93, 150, 95, 150, 102, 150, 114, 150, 108, 150, 141, 150, 152, 150, 149, 150, 151, 150, 170, 150, 167, 150, 177, 150, 178, 150, 176, 150, 180, 150, 182, 150, 184, 150, 185, 150, 206, 150, 203, 150, 201, 150, 205, 150, 77, 137, 220, 150, 13, 151, 213, 150, 249, 150, 4, 151, 6, 151, 8, 151, 19, 151, 14, 151, 17, 151, 15, 151, 22, 151, 25, 151, 36, 151, 42, 151, 48, 151, 57, 151, 61, 151, 62, 151, 68, 151, 70, 151, 72, 151, 66, 151, 73, 151, 92, 151, 96, 151, 100, 151, 102, 151, 104, 151, 210, 82, 107, 151, 113, 151, 121, 151, 133, 151, 124, 151, 129, 151, 122, 151, 134, 151, 139, 151, 143, 151, 144, 151, 156, 151, 168, 151, 166, 151, 163, 151, 179, 151, 180, 151, 195, 151, 198, 151, 200, 151, 203, 151, 220, 151, 237, 151, 79, 159, 242, 151, 223, 122, 246, 151, 245, 151, 15, 152, 12, 152, 56, 152, 36, 152, 33, 152, 55, 152, 61, 152, 70, 152, 79, 152, 75, 152, 107, 152, 111, 152, 112, 152, 113, 152, 116, 152, 115, 152, 170, 152, 175, 152, 177, 152, 182, 152, 196, 152, 195, 152, 198, 152, 233, 152, 235, 152, 3, 153, 9, 153, 18, 153, 20, 153, 24, 153, 33, 153, 29, 153, 30, 153, 36, 153, 32, 153, 44, 153, 46, 153, 61, 153, 62, 153, 66, 153, 73, 153, 69, 153, 80, 153, 75, 153, 81, 153, 82, 153, 76, 153, 85, 153, 151, 153, 152, 153, 165, 153, 173, 153, 174, 153, 188, 153, 223, 153, 219, 153, 221, 153, 216, 153, 209, 153, 237, 153, 238, 153, 241, 153, 242, 153, 251, 153, 248, 153, 1, 154, 15, 154, 5, 154, 226, 153, 25, 154, 43, 154, 55, 154, 69, 154, 66, 154, 64, 154, 67, 154, 62, 154, 85, 154, 77, 154, 91, 154, 87, 154, 95, 154, 98, 154, 101, 154, 100, 154, 105, 154, 107, 154, 106, 154, 173, 154, 176, 154, 188, 154, 192, 154, 207, 154, 209, 154, 211, 154, 212, 154, 222, 154, 223, 154, 226, 154, 227, 154, 230, 154, 239, 154, 235, 154, 238, 154, 244, 154, 241, 154, 247, 154, 251, 154, 6, 155, 24, 155, 26, 155, 31, 155, 34, 155, 35, 155, 37, 155, 39, 155, 40, 155, 41, 155, 42, 155, 46, 155, 47, 155, 50, 155, 68, 155, 67, 155, 79, 155, 77, 155, 78, 155, 81, 155, 88, 155, 116, 155, 147, 155, 131, 155, 145, 155, 150, 155, 151, 155, 159, 155, 160, 155, 168, 155, 180, 155, 192, 155, 202, 155, 185, 155, 198, 155, 207, 155, 209, 155, 210, 155, 227, 155, 226, 155, 228, 155, 212, 155, 225, 155, 58, 156, 242, 155, 241, 155, 240, 155, 21, 156, 20, 156, 9, 156, 19, 156, 12, 156, 6, 156, 8, 156, 18, 156, 10, 156, 4, 156, 46, 156, 27, 156, 37, 156, 36, 156, 33, 156, 48, 156, 71, 156, 50, 156, 70, 156, 62, 156, 90, 156, 96, 156, 103, 156, 118, 156, 120, 156, 231, 156, 236, 156, 240, 156, 9, 157, 8, 157, 235, 156, 3, 157, 6, 157, 42, 157, 38, 157, 175, 157, 35, 157, 31, 157, 68, 157, 21, 157, 18, 157, 65, 157, 63, 157, 62, 157, 70, 157, 72, 157, 93, 157, 94, 157, 100, 157, 81, 157, 80, 157, 89, 157, 114, 157, 137, 157, 135, 157, 171, 157, 111, 157, 122, 157, 154, 157, 164, 157, 169, 157, 178, 157, 196, 157, 193, 157, 187, 157, 184, 157, 186, 157, 198, 157, 207, 157, 194, 157, 217, 157, 211, 157, 248, 157, 230, 157, 237, 157, 239, 157, 253, 157, 26, 158, 27, 158, 30, 158, 117, 158, 121, 158, 125, 158, 129, 158, 136, 158, 139, 158, 140, 158, 146, 158, 149, 158, 145, 158, 157, 158, 165, 158, 169, 158, 184, 158, 170, 158, 173, 158, 97, 151, 204, 158, 206, 158, 207, 158, 208, 158, 212, 158, 220, 158, 222, 158, 221, 158, 224, 158, 229, 158, 232, 158, 239, 158, 244, 158, 246, 158, 247, 158, 249, 158, 251, 158, 252, 158, 253, 158, 7, 159, 8, 159, 183, 118, 21, 159, 33, 159, 44, 159, 62, 159, 74, 159, 82, 159, 84, 159, 99, 159, 95, 159, 96, 159, 97, 159, 102, 159, 103, 159, 108, 159, 106, 159, 119, 159, 114, 159, 118, 159, 149, 159, 156, 159, 160, 159, 47, 88, 199, 105, 89, 144, 100, 116, 220, 81, 153, 113, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 78, 4, 78, 5, 78, 6, 78, 15, 78, 18, 78, 23, 78, 31, 78, 32, 78, 33, 78, 35, 78, 38, 78, 41, 78, 46, 78, 47, 78, 49, 78, 51, 78, 53, 78, 55, 78, 60, 78, 64, 78, 65, 78, 66, 78, 68, 78, 70, 78, 74, 78, 81, 78, 85, 78, 87, 78, 90, 78, 91, 78, 98, 78, 99, 78, 100, 78, 101, 78, 103, 78, 104, 78, 106, 78, 107, 78, 108, 78, 109, 78, 110, 78, 111, 78, 114, 78, 116, 78, 117, 78, 118, 78, 119, 78, 120, 78, 121, 78, 122, 78, 123, 78, 124, 78, 125, 78, 127, 78, 128, 78, 129, 78, 130, 78, 131, 78, 132, 78, 133, 78, 135, 78, 138, 78, 144, 78, 150, 78, 151, 78, 153, 78, 156, 78, 157, 78, 158, 78, 163, 78, 170, 78, 175, 78, 176, 78, 177, 78, 180, 78, 182, 78, 183, 78, 184, 78, 185, 78, 188, 78, 189, 78, 190, 78, 200, 78, 204, 78, 207, 78, 208, 78, 210, 78, 218, 78, 219, 78, 220, 78, 224, 78, 226, 78, 230, 78, 231, 78, 233, 78, 237, 78, 238, 78, 239, 78, 241, 78, 244, 78, 248, 78, 249, 78, 250, 78, 252, 78, 254, 78, 0, 79, 2, 79, 3, 79, 4, 79, 5, 79, 6, 79, 7, 79, 8, 79, 11, 79, 12, 79, 18, 79, 19, 79, 20, 79, 21, 79, 22, 79, 28, 79, 29, 79, 33, 79, 35, 79, 40, 79, 41, 79, 44, 79, 45, 79, 46, 79, 49, 79, 51, 79, 53, 79, 55, 79, 57, 79, 59, 79, 62, 79, 63, 79, 64, 79, 65, 79, 66, 79, 68, 79, 69, 79, 71, 79, 72, 79, 73, 79, 74, 79, 75, 79, 76, 79, 82, 79, 84, 79, 86, 79, 97, 79, 98, 79, 102, 79, 104, 79, 106, 79, 107, 79, 109, 79, 110, 79, 113, 79, 114, 79, 117, 79, 119, 79, 120, 79, 121, 79, 122, 79, 125, 79, 128, 79, 129, 79, 130, 79, 133, 79, 134, 79, 135, 79, 138, 79, 140, 79, 142, 79, 144, 79, 146, 79, 147, 79, 149, 79, 150, 79, 152, 79, 153, 79, 154, 79, 156, 79, 158, 79, 159, 79, 161, 79, 162, 79, 164, 79, 171, 79, 173, 79, 176, 79, 177, 79, 178, 79, 179, 79, 180, 79, 182, 79, 183, 79, 184, 79, 185, 79, 186, 79, 187, 79, 188, 79, 189, 79, 190, 79, 192, 79, 193, 79, 194, 79, 198, 79, 199, 79, 200, 79, 201, 79, 203, 79, 204, 79, 205, 79, 210, 79, 211, 79, 212, 79, 213, 79, 214, 79, 217, 79, 219, 79, 224, 79, 226, 79, 228, 79, 229, 79, 231, 79, 235, 79, 236, 79, 240, 79, 242, 79, 244, 79, 245, 79, 246, 79, 247, 79, 249, 79, 251, 79, 252, 79, 253, 79, 255, 79, 0, 80, 1, 80, 2, 80, 3, 80, 4, 80, 5, 80, 6, 80, 7, 80, 8, 80, 9, 80, 10, 80, 11, 80, 14, 80, 16, 80, 17, 80, 19, 80, 21, 80, 22, 80, 23, 80, 27, 80, 29, 80, 30, 80, 32, 80, 34, 80, 35, 80, 36, 80, 39, 80, 43, 80, 47, 80, 48, 80, 49, 80, 50, 80, 51, 80, 52, 80, 53, 80, 54, 80, 55, 80, 56, 80, 57, 80, 59, 80, 61, 80, 63, 80, 64, 80, 65, 80, 66, 80, 68, 80, 69, 80, 70, 80, 73, 80, 74, 80, 75, 80, 77, 80, 80, 80, 81, 80, 82, 80, 83, 80, 84, 80, 86, 80, 87, 80, 88, 80, 89, 80, 91, 80, 93, 80, 94, 80, 95, 80, 96, 80, 97, 80, 98, 80, 99, 80, 100, 80, 102, 80, 103, 80, 104, 80, 105, 80, 106, 80, 107, 80, 109, 80, 110, 80, 111, 80, 112, 80, 113, 80, 114, 80, 115, 80, 116, 80, 117, 80, 120, 80, 121, 80, 122, 80, 124, 80, 125, 80, 129, 80, 130, 80, 131, 80, 132, 80, 134, 80, 135, 80, 137, 80, 138, 80, 139, 80, 140, 80, 142, 80, 143, 80, 144, 80, 145, 80, 146, 80, 147, 80, 148, 80, 149, 80, 150, 80, 151, 80, 152, 80, 153, 80, 154, 80, 155, 80, 156, 80, 157, 80, 158, 80, 159, 80, 160, 80, 161, 80, 162, 80, 164, 80, 166, 80, 170, 80, 171, 80, 173, 80, 174, 80, 175, 80, 176, 80, 177, 80, 179, 80, 180, 80, 181, 80, 182, 80, 183, 80, 184, 80, 185, 80, 188, 80, 189, 80, 190, 80, 191, 80, 192, 80, 193, 80, 194, 80, 195, 80, 196, 80, 197, 80, 198, 80, 199, 80, 200, 80, 201, 80, 202, 80, 203, 80, 204, 80, 205, 80, 206, 80, 208, 80, 209, 80, 210, 80, 211, 80, 212, 80, 213, 80, 215, 80, 216, 80, 217, 80, 219, 80, 220, 80, 221, 80, 222, 80, 223, 80, 224, 80, 225, 80, 226, 80, 227, 80, 228, 80, 229, 80, 232, 80, 233, 80, 234, 80, 235, 80, 239, 80, 240, 80, 241, 80, 242, 80, 244, 80, 246, 80, 247, 80, 248, 80, 249, 80, 250, 80, 252, 80, 253, 80, 254, 80, 255, 80, 0, 81, 1, 81, 2, 81, 3, 81, 4, 81, 5, 81, 8, 81, 9, 81, 10, 81, 12, 81, 13, 81, 14, 81, 15, 81, 16, 81, 17, 81, 19, 81, 20, 81, 21, 81, 22, 81, 23, 81, 24, 81, 25, 81, 26, 81, 27, 81, 28, 81, 29, 81, 30, 81, 31, 81, 32, 81, 34, 81, 35, 81, 36, 81, 37, 81, 38, 81, 39, 81, 40, 81, 41, 81, 42, 81, 43, 81, 44, 81, 45, 81, 46, 81, 47, 81, 48, 81, 49, 81, 50, 81, 51, 81, 52, 81, 53, 81, 54, 81, 55, 81, 56, 81, 57, 81, 58, 81, 59, 81, 60, 81, 61, 81, 62, 81, 66, 81, 71, 81, 74, 81, 76, 81, 78, 81, 79, 81, 80, 81, 82, 81, 83, 81, 87, 81, 88, 81, 89, 81, 91, 81, 93, 81, 94, 81, 95, 81, 96, 81, 97, 81, 99, 81, 100, 81, 102, 81, 103, 81, 105, 81, 106, 81, 111, 81, 114, 81, 122, 81, 126, 81, 127, 81, 131, 81, 132, 81, 134, 81, 135, 81, 138, 81, 139, 81, 142, 81, 143, 81, 144, 81, 145, 81, 147, 81, 148, 81, 152, 81, 154, 81, 157, 81, 158, 81, 159, 81, 161, 81, 163, 81, 166, 81, 167, 81, 168, 81, 169, 81, 170, 81, 173, 81, 174, 81, 180, 81, 184, 81, 185, 81, 186, 81, 190, 81, 191, 81, 193, 81, 194, 81, 195, 81, 197, 81, 200, 81, 202, 81, 205, 81, 206, 81, 208, 81, 210, 81, 211, 81, 212, 81, 213, 81, 214, 81, 215, 81, 216, 81, 217, 81, 218, 81, 220, 81, 222, 81, 223, 81, 226, 81, 227, 81, 229, 81, 230, 81, 231, 81, 232, 81, 233, 81, 234, 81, 236, 81, 238, 81, 241, 81, 242, 81, 244, 81, 247, 81, 254, 81, 4, 82, 5, 82, 9, 82, 11, 82, 12, 82, 15, 82, 16, 82, 19, 82, 20, 82, 21, 82, 28, 82, 30, 82, 31, 82, 33, 82, 34, 82, 35, 82, 37, 82, 38, 82, 39, 82, 42, 82, 44, 82, 47, 82, 49, 82, 50, 82, 52, 82, 53, 82, 60, 82, 62, 82, 68, 82, 69, 82, 70, 82, 71, 82, 72, 82, 73, 82, 75, 82, 78, 82, 79, 82, 82, 82, 83, 82, 85, 82, 87, 82, 88, 82, 89, 82, 90, 82, 91, 82, 93, 82, 95, 82, 96, 82, 98, 82, 99, 82, 100, 82, 102, 82, 104, 82, 107, 82, 108, 82, 109, 82, 110, 82, 112, 82, 113, 82, 115, 82, 116, 82, 117, 82, 118, 82, 119, 82, 120, 82, 121, 82, 122, 82, 123, 82, 124, 82, 126, 82, 128, 82, 131, 82, 132, 82, 133, 82, 134, 82, 135, 82, 137, 82, 138, 82, 139, 82, 140, 82, 141, 82, 142, 82, 143, 82, 145, 82, 146, 82, 148, 82, 149, 82, 150, 82, 151, 82, 152, 82, 153, 82, 154, 82, 156, 82, 164, 82, 165, 82, 166, 82, 167, 82, 174, 82, 175, 82, 176, 82, 180, 82, 181, 82, 182, 82, 183, 82, 184, 82, 185, 82, 186, 82, 187, 82, 188, 82, 189, 82, 192, 82, 193, 82, 194, 82, 196, 82, 197, 82, 198, 82, 200, 82, 202, 82, 204, 82, 205, 82, 206, 82, 207, 82, 209, 82, 211, 82, 212, 82, 213, 82, 215, 82, 217, 82, 218, 82, 219, 82, 220, 82, 221, 82, 222, 82, 224, 82, 225, 82, 226, 82, 227, 82, 229, 82, 230, 82, 231, 82, 232, 82, 233, 82, 234, 82, 235, 82, 236, 82, 237, 82, 238, 82, 239, 82, 241, 82, 242, 82, 243, 82, 244, 82, 245, 82, 246, 82, 247, 82, 248, 82, 251, 82, 252, 82, 253, 82, 1, 83, 2, 83, 3, 83, 4, 83, 7, 83, 9, 83, 10, 83, 11, 83, 12, 83, 14, 83, 17, 83, 18, 83, 19, 83, 20, 83, 24, 83, 27, 83, 28, 83, 30, 83, 31, 83, 34, 83, 36, 83, 37, 83, 39, 83, 40, 83, 41, 83, 43, 83, 44, 83, 45, 83, 47, 83, 48, 83, 49, 83, 50, 83, 51, 83, 52, 83, 53, 83, 54, 83, 55, 83, 56, 83, 60, 83, 61, 83, 64, 83, 66, 83, 68, 83, 70, 83, 75, 83, 76, 83, 77, 83, 80, 83, 84, 83, 88, 83, 89, 83, 91, 83, 93, 83, 101, 83, 104, 83, 106, 83, 108, 83, 109, 83, 114, 83, 118, 83, 121, 83, 123, 83, 124, 83, 125, 83, 126, 83, 128, 83, 129, 83, 131, 83, 135, 83, 136, 83, 138, 83, 142, 83, 143, 83, 144, 83, 145, 83, 146, 83, 147, 83, 148, 83, 150, 83, 151, 83, 153, 83, 155, 83, 156, 83, 158, 83, 160, 83, 161, 83, 164, 83, 167, 83, 170, 83, 171, 83, 172, 83, 173, 83, 175, 83, 176, 83, 177, 83, 178, 83, 179, 83, 180, 83, 181, 83, 183, 83, 184, 83, 185, 83, 186, 83, 188, 83, 189, 83, 190, 83, 192, 83, 195, 83, 196, 83, 197, 83, 198, 83, 199, 83, 206, 83, 207, 83, 208, 83, 210, 83, 211, 83, 213, 83, 218, 83, 220, 83, 221, 83, 222, 83, 225, 83, 226, 83, 231, 83, 244, 83, 250, 83, 254, 83, 255, 83, 0, 84, 2, 84, 5, 84, 7, 84, 11, 84, 20, 84, 24, 84, 25, 84, 26, 84, 28, 84, 34, 84, 36, 84, 37, 84, 42, 84, 48, 84, 51, 84, 54, 84, 55, 84, 58, 84, 61, 84, 63, 84, 65, 84, 66, 84, 68, 84, 69, 84, 71, 84, 73, 84, 76, 84, 77, 84, 78, 84, 79, 84, 81, 84, 90, 84, 93, 84, 94, 84, 95, 84, 96, 84, 97, 84, 99, 84, 101, 84, 103, 84, 105, 84, 106, 84, 107, 84, 108, 84, 109, 84, 110, 84, 111, 84, 112, 84, 116, 84, 121, 84, 122, 84, 126, 84, 127, 84, 129, 84, 131, 84, 133, 84, 135, 84, 136, 84, 137, 84, 138, 84, 141, 84, 145, 84, 147, 84, 151, 84, 152, 84, 156, 84, 158, 84, 159, 84, 160, 84, 161, 84, 162, 84, 165, 84, 174, 84, 176, 84, 178, 84, 181, 84, 182, 84, 183, 84, 185, 84, 186, 84, 188, 84, 190, 84, 195, 84, 197, 84, 202, 84, 203, 84, 214, 84, 216, 84, 219, 84, 224, 84, 225, 84, 226, 84, 227, 84, 228, 84, 235, 84, 236, 84, 239, 84, 240, 84, 241, 84, 244, 84, 245, 84, 246, 84, 247, 84, 248, 84, 249, 84, 251, 84, 254, 84, 0, 85, 2, 85, 3, 85, 4, 85, 5, 85, 8, 85, 10, 85, 11, 85, 12, 85, 13, 85, 14, 85, 18, 85, 19, 85, 21, 85, 22, 85, 23, 85, 24, 85, 25, 85, 26, 85, 28, 85, 29, 85, 30, 85, 31, 85, 33, 85, 37, 85, 38, 85, 40, 85, 41, 85, 43, 85, 45, 85, 50, 85, 52, 85, 53, 85, 54, 85, 56, 85, 57, 85, 58, 85, 59, 85, 61, 85, 64, 85, 66, 85, 69, 85, 71, 85, 72, 85, 75, 85, 76, 85, 77, 85, 78, 85, 79, 85, 81, 85, 82, 85, 83, 85, 84, 85, 87, 85, 88, 85, 89, 85, 90, 85, 91, 85, 93, 85, 94, 85, 95, 85, 96, 85, 98, 85, 99, 85, 104, 85, 105, 85, 107, 85, 111, 85, 112, 85, 113, 85, 114, 85, 115, 85, 116, 85, 121, 85, 122, 85, 125, 85, 127, 85, 133, 85, 134, 85, 140, 85, 141, 85, 142, 85, 144, 85, 146, 85, 147, 85, 149, 85, 150, 85, 151, 85, 154, 85, 155, 85, 158, 85, 160, 85, 161, 85, 162, 85, 163, 85, 164, 85, 165, 85, 166, 85, 168, 85, 169, 85, 170, 85, 171, 85, 172, 85, 173, 85, 174, 85, 175, 85, 176, 85, 178, 85, 180, 85, 182, 85, 184, 85, 186, 85, 188, 85, 191, 85, 192, 85, 193, 85, 194, 85, 195, 85, 198, 85, 199, 85, 200, 85, 202, 85, 203, 85, 206, 85, 207, 85, 208, 85, 213, 85, 215, 85, 216, 85, 217, 85, 218, 85, 219, 85, 222, 85, 224, 85, 226, 85, 231, 85, 233, 85, 237, 85, 238, 85, 240, 85, 241, 85, 244, 85, 246, 85, 248, 85, 249, 85, 250, 85, 251, 85, 252, 85, 255, 85, 2, 86, 3, 86, 4, 86, 5, 86, 6, 86, 7, 86, 10, 86, 11, 86, 13, 86, 16, 86, 17, 86, 18, 86, 19, 86, 20, 86, 21, 86, 22, 86, 23, 86, 25, 86, 26, 86, 28, 86, 29, 86, 32, 86, 33, 86, 34, 86, 37, 86, 38, 86, 40, 86, 41, 86, 42, 86, 43, 86, 46, 86, 47, 86, 48, 86, 51, 86, 53, 86, 55, 86, 56, 86, 58, 86, 60, 86, 61, 86, 62, 86, 64, 86, 65, 86, 66, 86, 67, 86, 68, 86, 69, 86, 70, 86, 71, 86, 72, 86, 73, 86, 74, 86, 75, 86, 79, 86, 80, 86, 81, 86, 82, 86, 83, 86, 85, 86, 86, 86, 90, 86, 91, 86, 93, 86, 94, 86, 95, 86, 96, 86, 97, 86, 99, 86, 101, 86, 102, 86, 103, 86, 109, 86, 110, 86, 111, 86, 112, 86, 114, 86, 115, 86, 116, 86, 117, 86, 119, 86, 120, 86, 121, 86, 122, 86, 125, 86, 126, 86, 127, 86, 128, 86, 129, 86, 130, 86, 131, 86, 132, 86, 135, 86, 136, 86, 137, 86, 138, 86, 139, 86, 140, 86, 141, 86, 144, 86, 145, 86, 146, 86, 148, 86, 149, 86, 150, 86, 151, 86, 152, 86, 153, 86, 154, 86, 155, 86, 156, 86, 157, 86, 158, 86, 159, 86, 160, 86, 161, 86, 162, 86, 164, 86, 165, 86, 166, 86, 167, 86, 168, 86, 169, 86, 170, 86, 171, 86, 172, 86, 173, 86, 174, 86, 176, 86, 177, 86, 178, 86, 179, 86, 180, 86, 181, 86, 182, 86, 184, 86, 185, 86, 186, 86, 187, 86, 189, 86, 190, 86, 191, 86, 192, 86, 193, 86, 194, 86, 195, 86, 196, 86, 197, 86, 198, 86, 199, 86, 200, 86, 201, 86, 203, 86, 204, 86, 205, 86, 206, 86, 207, 86, 208, 86, 209, 86, 210, 86, 211, 86, 213, 86, 214, 86, 216, 86, 217, 86, 220, 86, 227, 86, 229, 86, 230, 86, 231, 86, 232, 86, 233, 86, 234, 86, 236, 86, 238, 86, 239, 86, 242, 86, 243, 86, 246, 86, 247, 86, 248, 86, 251, 86, 252, 86, 0, 87, 1, 87, 2, 87, 5, 87, 7, 87, 11, 87, 12, 87, 13, 87, 14, 87, 15, 87, 16, 87, 17, 87, 18, 87, 19, 87, 20, 87, 21, 87, 22, 87, 23, 87, 24, 87, 25, 87, 26, 87, 27, 87, 29, 87, 30, 87, 32, 87, 33, 87, 34, 87, 36, 87, 37, 87, 38, 87, 39, 87, 43, 87, 49, 87, 50, 87, 52, 87, 53, 87, 54, 87, 55, 87, 56, 87, 60, 87, 61, 87, 63, 87, 65, 87, 67, 87, 68, 87, 69, 87, 70, 87, 72, 87, 73, 87, 75, 87, 82, 87, 83, 87, 84, 87, 85, 87, 86, 87, 88, 87, 89, 87, 98, 87, 99, 87, 101, 87, 103, 87, 108, 87, 110, 87, 112, 87, 113, 87, 114, 87, 116, 87, 117, 87, 120, 87, 121, 87, 122, 87, 125, 87, 126, 87, 127, 87, 128, 87, 129, 87, 135, 87, 136, 87, 137, 87, 138, 87, 141, 87, 142, 87, 143, 87, 144, 87, 145, 87, 148, 87, 149, 87, 150, 87, 151, 87, 152, 87, 153, 87, 154, 87, 156, 87, 157, 87, 158, 87, 159, 87, 165, 87, 168, 87, 170, 87, 172, 87, 175, 87, 176, 87, 177, 87, 179, 87, 181, 87, 182, 87, 183, 87, 185, 87, 186, 87, 187, 87, 188, 87, 189, 87, 190, 87, 191, 87, 192, 87, 193, 87, 196, 87, 197, 87, 198, 87, 199, 87, 200, 87, 201, 87, 202, 87, 204, 87, 205, 87, 208, 87, 209, 87, 211, 87, 214, 87, 215, 87, 219, 87, 220, 87, 222, 87, 225, 87, 226, 87, 227, 87, 229, 87, 230, 87, 231, 87, 232, 87, 233, 87, 234, 87, 235, 87, 236, 87, 238, 87, 240, 87, 241, 87, 242, 87, 243, 87, 245, 87, 246, 87, 247, 87, 251, 87, 252, 87, 254, 87, 255, 87, 1, 88, 3, 88, 4, 88, 5, 88, 8, 88, 9, 88, 10, 88, 12, 88, 14, 88, 15, 88, 16, 88, 18, 88, 19, 88, 20, 88, 22, 88, 23, 88, 24, 88, 26, 88, 27, 88, 28, 88, 29, 88, 31, 88, 34, 88, 35, 88, 37, 88, 38, 88, 39, 88, 40, 88, 41, 88, 43, 88, 44, 88, 45, 88, 46, 88, 47, 88, 49, 88, 50, 88, 51, 88, 52, 88, 54, 88, 55, 88, 56, 88, 57, 88, 58, 88, 59, 88, 60, 88, 61, 88, 62, 88, 63, 88, 64, 88, 65, 88, 66, 88, 67, 88, 69, 88, 70, 88, 71, 88, 72, 88, 73, 88, 74, 88, 75, 88, 78, 88, 79, 88, 80, 88, 82, 88, 83, 88, 85, 88, 86, 88, 87, 88, 89, 88, 90, 88, 91, 88, 92, 88, 93, 88, 95, 88, 96, 88, 97, 88, 98, 88, 99, 88, 100, 88, 102, 88, 103, 88, 104, 88, 105, 88, 106, 88, 109, 88, 110, 88, 111, 88, 112, 88, 113, 88, 114, 88, 115, 88, 116, 88, 117, 88, 118, 88, 119, 88, 120, 88, 121, 88, 122, 88, 123, 88, 124, 88, 125, 88, 127, 88, 130, 88, 132, 88, 134, 88, 135, 88, 136, 88, 138, 88, 139, 88, 140, 88, 141, 88, 142, 88, 143, 88, 144, 88, 145, 88, 148, 88, 149, 88, 150, 88, 151, 88, 152, 88, 155, 88, 156, 88, 157, 88, 160, 88, 161, 88, 162, 88, 163, 88, 164, 88, 165, 88, 166, 88, 167, 88, 170, 88, 171, 88, 172, 88, 173, 88, 174, 88, 175, 88, 176, 88, 177, 88, 178, 88, 179, 88, 180, 88, 181, 88, 182, 88, 183, 88, 184, 88, 185, 88, 186, 88, 187, 88, 189, 88, 190, 88, 191, 88, 192, 88, 194, 88, 195, 88, 196, 88, 198, 88, 199, 88, 200, 88, 201, 88, 202, 88, 203, 88, 204, 88, 205, 88, 206, 88, 207, 88, 208, 88, 210, 88, 211, 88, 212, 88, 214, 88, 215, 88, 216, 88, 217, 88, 218, 88, 219, 88, 220, 88, 221, 88, 222, 88, 223, 88, 224, 88, 225, 88, 226, 88, 227, 88, 229, 88, 230, 88, 231, 88, 232, 88, 233, 88, 234, 88, 237, 88, 239, 88, 241, 88, 242, 88, 244, 88, 245, 88, 247, 88, 248, 88, 250, 88, 251, 88, 252, 88, 253, 88, 254, 88, 255, 88, 0, 89, 1, 89, 3, 89, 5, 89, 6, 89, 8, 89, 9, 89, 10, 89, 11, 89, 12, 89, 14, 89, 16, 89, 17, 89, 18, 89, 19, 89, 23, 89, 24, 89, 27, 89, 29, 89, 30, 89, 32, 89, 33, 89, 34, 89, 35, 89, 38, 89, 40, 89, 44, 89, 48, 89, 50, 89, 51, 89, 53, 89, 54, 89, 59, 89, 61, 89, 62, 89, 63, 89, 64, 89, 67, 89, 69, 89, 70, 89, 74, 89, 76, 89, 77, 89, 80, 89, 82, 89, 83, 89, 89, 89, 91, 89, 92, 89, 93, 89, 94, 89, 95, 89, 97, 89, 99, 89, 100, 89, 102, 89, 103, 89, 104, 89, 105, 89, 106, 89, 107, 89, 108, 89, 109, 89, 110, 89, 111, 89, 112, 89, 113, 89, 114, 89, 117, 89, 119, 89, 122, 89, 123, 89, 124, 89, 126, 89, 127, 89, 128, 89, 133, 89, 137, 89, 139, 89, 140, 89, 142, 89, 143, 89, 144, 89, 145, 89, 148, 89, 149, 89, 152, 89, 154, 89, 155, 89, 156, 89, 157, 89, 159, 89, 160, 89, 161, 89, 162, 89, 166, 89, 167, 89, 172, 89, 173, 89, 176, 89, 177, 89, 179, 89, 180, 89, 181, 89, 182, 89, 183, 89, 184, 89, 186, 89, 188, 89, 189, 89, 191, 89, 192, 89, 193, 89, 194, 89, 195, 89, 196, 89, 197, 89, 199, 89, 200, 89, 201, 89, 204, 89, 205, 89, 206, 89, 207, 89, 213, 89, 214, 89, 217, 89, 219, 89, 222, 89, 223, 89, 224, 89, 225, 89, 226, 89, 228, 89, 230, 89, 231, 89, 233, 89, 234, 89, 235, 89, 237, 89, 238, 89, 239, 89, 240, 89, 241, 89, 242, 89, 243, 89, 244, 89, 245, 89, 246, 89, 247, 89, 248, 89, 250, 89, 252, 89, 253, 89, 254, 89, 0, 90, 2, 90, 10, 90, 11, 90, 13, 90, 14, 90, 15, 90, 16, 90, 18, 90, 20, 90, 21, 90, 22, 90, 23, 90, 25, 90, 26, 90, 27, 90, 29, 90, 30, 90, 33, 90, 34, 90, 36, 90, 38, 90, 39, 90, 40, 90, 42, 90, 43, 90, 44, 90, 45, 90, 46, 90, 47, 90, 48, 90, 51, 90, 53, 90, 55, 90, 56, 90, 57, 90, 58, 90, 59, 90, 61, 90, 62, 90, 63, 90, 65, 90, 66, 90, 67, 90, 68, 90, 69, 90, 71, 90, 72, 90, 75, 90, 76, 90, 77, 90, 78, 90, 79, 90, 80, 90, 81, 90, 82, 90, 83, 90, 84, 90, 86, 90, 87, 90, 88, 90, 89, 90, 91, 90, 92, 90, 93, 90, 94, 90, 95, 90, 96, 90, 97, 90, 99, 90, 100, 90, 101, 90, 102, 90, 104, 90, 105, 90, 107, 90, 108, 90, 109, 90, 110, 90, 111, 90, 112, 90, 113, 90, 114, 90, 115, 90, 120, 90, 121, 90, 123, 90, 124, 90, 125, 90, 126, 90, 128, 90, 129, 90, 130, 90, 131, 90, 132, 90, 133, 90, 134, 90, 135, 90, 136, 90, 137, 90, 138, 90, 139, 90, 140, 90, 141, 90, 142, 90, 143, 90, 144, 90, 145, 90, 147, 90, 148, 90, 149, 90, 150, 90, 151, 90, 152, 90, 153, 90, 156, 90, 157, 90, 158, 90, 159, 90, 160, 90, 161, 90, 162, 90, 163, 90, 164, 90, 165, 90, 166, 90, 167, 90, 168, 90, 169, 90, 171, 90, 172, 90, 173, 90, 174, 90, 175, 90, 176, 90, 177, 90, 180, 90, 182, 90, 183, 90, 185, 90, 186, 90, 187, 90, 188, 90, 189, 90, 191, 90, 192, 90, 195, 90, 196, 90, 197, 90, 198, 90, 199, 90, 200, 90, 202, 90, 203, 90, 205, 90, 206, 90, 207, 90, 208, 90, 209, 90, 211, 90, 213, 90, 215, 90, 217, 90, 218, 90, 219, 90, 221, 90, 222, 90, 223, 90, 226, 90, 228, 90, 229, 90, 231, 90, 232, 90, 234, 90, 236, 90, 237, 90, 238, 90, 239, 90, 240, 90, 242, 90, 243, 90, 244, 90, 245, 90, 246, 90, 247, 90, 248, 90, 249, 90, 250, 90, 251, 90, 252, 90, 253, 90, 254, 90, 255, 90, 0, 91, 1, 91, 2, 91, 3, 91, 4, 91, 5, 91, 6, 91, 7, 91, 8, 91, 10, 91, 11, 91, 12, 91, 13, 91, 14, 91, 15, 91, 16, 91, 17, 91, 18, 91, 19, 91, 20, 91, 21, 91, 24, 91, 25, 91, 26, 91, 27, 91, 28, 91, 29, 91, 30, 91, 31, 91, 32, 91, 33, 91, 34, 91, 35, 91, 36, 91, 37, 91, 38, 91, 39, 91, 40, 91, 41, 91, 42, 91, 43, 91, 44, 91, 45, 91, 46, 91, 47, 91, 48, 91, 49, 91, 51, 91, 53, 91, 54, 91, 56, 91, 57, 91, 58, 91, 59, 91, 60, 91, 61, 91, 62, 91, 63, 91, 65, 91, 66, 91, 67, 91, 68, 91, 69, 91, 70, 91, 71, 91, 72, 91, 73, 91, 74, 91, 75, 91, 76, 91, 77, 91, 78, 91, 79, 91, 82, 91, 86, 91, 94, 91, 96, 91, 97, 91, 103, 91, 104, 91, 107, 91, 109, 91, 110, 91, 111, 91, 114, 91, 116, 91, 118, 91, 119, 91, 120, 91, 121, 91, 123, 91, 124, 91, 126, 91, 127, 91, 130, 91, 134, 91, 138, 91, 141, 91, 142, 91, 144, 91, 145, 91, 146, 91, 148, 91, 150, 91, 159, 91, 167, 91, 168, 91, 169, 91, 172, 91, 173, 91, 174, 91, 175, 91, 177, 91, 178, 91, 183, 91, 186, 91, 187, 91, 188, 91, 192, 91, 193, 91, 195, 91, 200, 91, 201, 91, 202, 91, 203, 91, 205, 91, 206, 91, 207, 91, 209, 91, 212, 91, 213, 91, 214, 91, 215, 91, 216, 91, 217, 91, 218, 91, 219, 91, 220, 91, 224, 91, 226, 91, 227, 91, 230, 91, 231, 91, 233, 91, 234, 91, 235, 91, 236, 91, 237, 91, 239, 91, 241, 91, 242, 91, 243, 91, 244, 91, 245, 91, 246, 91, 247, 91, 253, 91, 254, 91, 0, 92, 2, 92, 3, 92, 5, 92, 7, 92, 8, 92, 11, 92, 12, 92, 13, 92, 14, 92, 16, 92, 18, 92, 19, 92, 23, 92, 25, 92, 27, 92, 30, 92, 31, 92, 32, 92, 33, 92, 35, 92, 38, 92, 40, 92, 41, 92, 42, 92, 43, 92, 45, 92, 46, 92, 47, 92, 48, 92, 50, 92, 51, 92, 53, 92, 54, 92, 55, 92, 67, 92, 68, 92, 70, 92, 71, 92, 76, 92, 77, 92, 82, 92, 83, 92, 84, 92, 86, 92, 87, 92, 88, 92, 90, 92, 91, 92, 92, 92, 93, 92, 95, 92, 98, 92, 100, 92, 103, 92, 104, 92, 105, 92, 106, 92, 107, 92, 108, 92, 109, 92, 112, 92, 114, 92, 115, 92, 116, 92, 117, 92, 118, 92, 119, 92, 120, 92, 123, 92, 124, 92, 125, 92, 126, 92, 128, 92, 131, 92, 132, 92, 133, 92, 134, 92, 135, 92, 137, 92, 138, 92, 139, 92, 142, 92, 143, 92, 146, 92, 147, 92, 149, 92, 157, 92, 158, 92, 159, 92, 160, 92, 161, 92, 164, 92, 165, 92, 166, 92, 167, 92, 168, 92, 170, 92, 174, 92, 175, 92, 176, 92, 178, 92, 180, 92, 182, 92, 185, 92, 186, 92, 187, 92, 188, 92, 190, 92, 192, 92, 194, 92, 195, 92, 197, 92, 198, 92, 199, 92, 200, 92, 201, 92, 202, 92, 204, 92, 205, 92, 206, 92, 207, 92, 208, 92, 209, 92, 211, 92, 212, 92, 213, 92, 214, 92, 215, 92, 216, 92, 218, 92, 219, 92, 220, 92, 221, 92, 222, 92, 223, 92, 224, 92, 226, 92, 227, 92, 231, 92, 233, 92, 235, 92, 236, 92, 238, 92, 239, 92, 241, 92, 242, 92, 243, 92, 244, 92, 245, 92, 246, 92, 247, 92, 248, 92, 249, 92, 250, 92, 252, 92, 253, 92, 254, 92, 255, 92, 0, 93, 1, 93, 4, 93, 5, 93, 8, 93, 9, 93, 10, 93, 11, 93, 12, 93, 13, 93, 15, 93, 16, 93, 17, 93, 18, 93, 19, 93, 21, 93, 23, 93, 24, 93, 25, 93, 26, 93, 28, 93, 29, 93, 31, 93, 32, 93, 33, 93, 34, 93, 35, 93, 37, 93, 40, 93, 42, 93, 43, 93, 44, 93, 47, 93, 48, 93, 49, 93, 50, 93, 51, 93, 53, 93, 54, 93, 55, 93, 56, 93, 57, 93, 58, 93, 59, 93, 60, 93, 63, 93, 64, 93, 65, 93, 66, 93, 67, 93, 68, 93, 69, 93, 70, 93, 72, 93, 73, 93, 77, 93, 78, 93, 79, 93, 80, 93, 81, 93, 82, 93, 83, 93, 84, 93, 85, 93, 86, 93, 87, 93, 89, 93, 90, 93, 92, 93, 94, 93, 95, 93, 96, 93, 97, 93, 98, 93, 99, 93, 100, 93, 101, 93, 102, 93, 103, 93, 104, 93, 106, 93, 109, 93, 110, 93, 112, 93, 113, 93, 114, 93, 115, 93, 117, 93, 118, 93, 119, 93, 120, 93, 121, 93, 122, 93, 123, 93, 124, 93, 125, 93, 126, 93, 127, 93, 128, 93, 129, 93, 131, 93, 132, 93, 133, 93, 134, 93, 135, 93, 136, 93, 137, 93, 138, 93, 139, 93, 140, 93, 141, 93, 142, 93, 143, 93, 144, 93, 145, 93, 146, 93, 147, 93, 148, 93, 149, 93, 150, 93, 151, 93, 152, 93, 154, 93, 155, 93, 156, 93, 158, 93, 159, 93, 160, 93, 161, 93, 162, 93, 163, 93, 164, 93, 165, 93, 166, 93, 167, 93, 168, 93, 169, 93, 170, 93, 171, 93, 172, 93, 173, 93, 174, 93, 175, 93, 176, 93, 177, 93, 178, 93, 179, 93, 180, 93, 181, 93, 182, 93, 184, 93, 185, 93, 186, 93, 187, 93, 188, 93, 189, 93, 190, 93, 191, 93, 192, 93, 193, 93, 194, 93, 195, 93, 196, 93, 198, 93, 199, 93, 200, 93, 201, 93, 202, 93, 203, 93, 204, 93, 206, 93, 207, 93, 208, 93, 209, 93, 210, 93, 211, 93, 212, 93, 213, 93, 214, 93, 215, 93, 216, 93, 217, 93, 218, 93, 220, 93, 223, 93, 224, 93, 227, 93, 228, 93, 234, 93, 236, 93, 237, 93, 240, 93, 245, 93, 246, 93, 248, 93, 249, 93, 250, 93, 251, 93, 252, 93, 255, 93, 0, 94, 4, 94, 7, 94, 9, 94, 10, 94, 11, 94, 13, 94, 14, 94, 18, 94, 19, 94, 23, 94, 30, 94, 31, 94, 32, 94, 33, 94, 34, 94, 35, 94, 36, 94, 37, 94, 40, 94, 41, 94, 42, 94, 43, 94, 44, 94, 47, 94, 48, 94, 50, 94, 51, 94, 52, 94, 53, 94, 54, 94, 57, 94, 58, 94, 62, 94, 63, 94, 64, 94, 65, 94, 67, 94, 70, 94, 71, 94, 72, 94, 73, 94, 74, 94, 75, 94, 77, 94, 78, 94, 79, 94, 80, 94, 81, 94, 82, 94, 83, 94, 86, 94, 87, 94, 88, 94, 89, 94, 90, 94, 92, 94, 93, 94, 95, 94, 96, 94, 99, 94, 100, 94, 101, 94, 102, 94, 103, 94, 104, 94, 105, 94, 106, 94, 107, 94, 108, 94, 109, 94, 110, 94, 111, 94, 112, 94, 113, 94, 117, 94, 119, 94, 121, 94, 126, 94, 129, 94, 130, 94, 131, 94, 133, 94, 136, 94, 137, 94, 140, 94, 141, 94, 142, 94, 146, 94, 152, 94, 155, 94, 157, 94, 161, 94, 162, 94, 163, 94, 164, 94, 168, 94, 169, 94, 170, 94, 171, 94, 172, 94, 174, 94, 175, 94, 176, 94, 177, 94, 178, 94, 180, 94, 186, 94, 187, 94, 188, 94, 189, 94, 191, 94, 192, 94, 193, 94, 194, 94, 195, 94, 196, 94, 197, 94, 198, 94, 199, 94, 200, 94, 203, 94, 204, 94, 205, 94, 206, 94, 207, 94, 208, 94, 212, 94, 213, 94, 215, 94, 216, 94, 217, 94, 218, 94, 220, 94, 221, 94, 222, 94, 223, 94, 224, 94, 225, 94, 226, 94, 227, 94, 228, 94, 229, 94, 230, 94, 231, 94, 233, 94, 235, 94, 236, 94, 237, 94, 238, 94, 239, 94, 240, 94, 241, 94, 242, 94, 243, 94, 245, 94, 248, 94, 249, 94, 251, 94, 252, 94, 253, 94, 5, 95, 6, 95, 7, 95, 9, 95, 12, 95, 13, 95, 14, 95, 16, 95, 18, 95, 20, 95, 22, 95, 25, 95, 26, 95, 28, 95, 29, 95, 30, 95, 33, 95, 34, 95, 35, 95, 36, 95, 40, 95, 43, 95, 44, 95, 46, 95, 48, 95, 50, 95, 51, 95, 52, 95, 53, 95, 54, 95, 55, 95, 56, 95, 59, 95, 61, 95, 62, 95, 63, 95, 65, 95, 66, 95, 67, 95, 68, 95, 69, 95, 70, 95, 71, 95, 72, 95, 73, 95, 74, 95, 75, 95, 76, 95, 77, 95, 78, 95, 79, 95, 81, 95, 84, 95, 89, 95, 90, 95, 91, 95, 92, 95, 94, 95, 95, 95, 96, 95, 99, 95, 101, 95, 103, 95, 104, 95, 107, 95, 110, 95, 111, 95, 114, 95, 116, 95, 117, 95, 118, 95, 120, 95, 122, 95, 125, 95, 126, 95, 127, 95, 131, 95, 134, 95, 141, 95, 142, 95, 143, 95, 145, 95, 147, 95, 148, 95, 150, 95, 154, 95, 155, 95, 157, 95, 158, 95, 159, 95, 160, 95, 162, 95, 163, 95, 164, 95, 165, 95, 166, 95, 167, 95, 169, 95, 171, 95, 172, 95, 175, 95, 176, 95, 177, 95, 178, 95, 179, 95, 180, 95, 182, 95, 184, 95, 185, 95, 186, 95, 187, 95, 190, 95, 191, 95, 192, 95, 193, 95, 194, 95, 199, 95, 200, 95, 202, 95, 203, 95, 206, 95, 211, 95, 212, 95, 213, 95, 218, 95, 219, 95, 220, 95, 222, 95, 223, 95, 226, 95, 227, 95, 229, 95, 230, 95, 232, 95, 233, 95, 236, 95, 239, 95, 240, 95, 242, 95, 243, 95, 244, 95, 246, 95, 247, 95, 249, 95, 250, 95, 252, 95, 7, 96, 8, 96, 9, 96, 11, 96, 12, 96, 16, 96, 17, 96, 19, 96, 23, 96, 24, 96, 26, 96, 30, 96, 31, 96, 34, 96, 35, 96, 36, 96, 44, 96, 45, 96, 46, 96, 48, 96, 49, 96, 50, 96, 51, 96, 52, 96, 54, 96, 55, 96, 56, 96, 57, 96, 58, 96, 61, 96, 62, 96, 64, 96, 68, 96, 69, 96, 70, 96, 71, 96, 72, 96, 73, 96, 74, 96, 76, 96, 78, 96, 79, 96, 81, 96, 83, 96, 84, 96, 86, 96, 87, 96, 88, 96, 91, 96, 92, 96, 94, 96, 95, 96, 96, 96, 97, 96, 101, 96, 102, 96, 110, 96, 113, 96, 114, 96, 116, 96, 117, 96, 119, 96, 126, 96, 128, 96, 129, 96, 130, 96, 133, 96, 134, 96, 135, 96, 136, 96, 138, 96, 139, 96, 142, 96, 143, 96, 144, 96, 145, 96, 147, 96, 149, 96, 151, 96, 152, 96, 153, 96, 156, 96, 158, 96, 161, 96, 162, 96, 164, 96, 165, 96, 167, 96, 169, 96, 170, 96, 174, 96, 176, 96, 179, 96, 181, 96, 182, 96, 183, 96, 185, 96, 186, 96, 189, 96, 190, 96, 191, 96, 192, 96, 193, 96, 194, 96, 195, 96, 196, 96, 199, 96, 200, 96, 201, 96, 204, 96, 205, 96, 206, 96, 207, 96, 208, 96, 210, 96, 211, 96, 212, 96, 214, 96, 215, 96, 217, 96, 219, 96, 222, 96, 225, 96, 226, 96, 227, 96, 228, 96, 229, 96, 234, 96, 241, 96, 242, 96, 245, 96, 247, 96, 248, 96, 251, 96, 252, 96, 253, 96, 254, 96, 255, 96, 2, 97, 3, 97, 4, 97, 5, 97, 7, 97, 10, 97, 11, 97, 12, 97, 16, 97, 17, 97, 18, 97, 19, 97, 20, 97, 22, 97, 23, 97, 24, 97, 25, 97, 27, 97, 28, 97, 29, 97, 30, 97, 33, 97, 34, 97, 37, 97, 40, 97, 41, 97, 42, 97, 44, 97, 45, 97, 46, 97, 47, 97, 48, 97, 49, 97, 50, 97, 51, 97, 52, 97, 53, 97, 54, 97, 55, 97, 56, 97, 57, 97, 58, 97, 59, 97, 60, 97, 61, 97, 62, 97, 64, 97, 65, 97, 66, 97, 67, 97, 68, 97, 69, 97, 70, 97, 71, 97, 73, 97, 75, 97, 77, 97, 79, 97, 80, 97, 82, 97, 83, 97, 84, 97, 86, 97, 87, 97, 88, 97, 89, 97, 90, 97, 91, 97, 92, 97, 94, 97, 95, 97, 96, 97, 97, 97, 99, 97, 100, 97, 101, 97, 102, 97, 105, 97, 106, 97, 107, 97, 108, 97, 109, 97, 110, 97, 111, 97, 113, 97, 114, 97, 115, 97, 116, 97, 118, 97, 120, 97, 121, 97, 122, 97, 123, 97, 124, 97, 125, 97, 126, 97, 127, 97, 128, 97, 129, 97, 130, 97, 131, 97, 132, 97, 133, 97, 134, 97, 135, 97, 136, 97, 137, 97, 138, 97, 140, 97, 141, 97, 143, 97, 144, 97, 145, 97, 146, 97, 147, 97, 149, 97, 150, 97, 151, 97, 152, 97, 153, 97, 154, 97, 155, 97, 156, 97, 158, 97, 159, 97, 160, 97, 161, 97, 162, 97, 163, 97, 164, 97, 165, 97, 166, 97, 170, 97, 171, 97, 173, 97, 174, 97, 175, 97, 176, 97, 177, 97, 178, 97, 179, 97, 180, 97, 181, 97, 182, 97, 184, 97, 185, 97, 186, 97, 187, 97, 188, 97, 189, 97, 191, 97, 192, 97, 193, 97, 195, 97, 196, 97, 197, 97, 198, 97, 199, 97, 201, 97, 204, 97, 205, 97, 206, 97, 207, 97, 208, 97, 211, 97, 213, 97, 214, 97, 215, 97, 216, 97, 217, 97, 218, 97, 219, 97, 220, 97, 221, 97, 222, 97, 223, 97, 224, 97, 225, 97, 226, 97, 227, 97, 228, 97, 229, 97, 231, 97, 232, 97, 233, 97, 234, 97, 235, 97, 236, 97, 237, 97, 238, 97, 239, 97, 240, 97, 241, 97, 242, 97, 243, 97, 244, 97, 246, 97, 247, 97, 248, 97, 249, 97, 250, 97, 251, 97, 252, 97, 253, 97, 254, 97, 0, 98, 1, 98, 2, 98, 3, 98, 4, 98, 5, 98, 7, 98, 9, 98, 19, 98, 20, 98, 25, 98, 28, 98, 29, 98, 30, 98, 32, 98, 35, 98, 38, 98, 39, 98, 40, 98, 41, 98, 43, 98, 45, 98, 47, 98, 48, 98, 49, 98, 50, 98, 53, 98, 54, 98, 56, 98, 57, 98, 58, 98, 59, 98, 60, 98, 66, 98, 68, 98, 69, 98, 70, 98, 74, 98, 79, 98, 80, 98, 85, 98, 86, 98, 87, 98, 89, 98, 90, 98, 92, 98, 93, 98, 94, 98, 95, 98, 96, 98, 97, 98, 98, 98, 100, 98, 101, 98, 104, 98, 113, 98, 114, 98, 116, 98, 117, 98, 119, 98, 120, 98, 122, 98, 123, 98, 125, 98, 129, 98, 130, 98, 131, 98, 133, 98, 134, 98, 135, 98, 136, 98, 139, 98, 140, 98, 141, 98, 142, 98, 143, 98, 144, 98, 148, 98, 153, 98, 156, 98, 157, 98, 158, 98, 163, 98, 166, 98, 167, 98, 169, 98, 170, 98, 173, 98, 174, 98, 175, 98, 176, 98, 178, 98, 179, 98, 180, 98, 182, 98, 183, 98, 184, 98, 186, 98, 190, 98, 192, 98, 193, 98, 195, 98, 203, 98, 207, 98, 209, 98, 213, 98, 221, 98, 222, 98, 224, 98, 225, 98, 228, 98, 234, 98, 235, 98, 240, 98, 242, 98, 245, 98, 248, 98, 249, 98, 250, 98, 251, 98, 0, 99, 3, 99, 4, 99, 5, 99, 6, 99, 10, 99, 11, 99, 12, 99, 13, 99, 15, 99, 16, 99, 18, 99, 19, 99, 20, 99, 21, 99, 23, 99, 24, 99, 25, 99, 28, 99, 38, 99, 39, 99, 41, 99, 44, 99, 45, 99, 46, 99, 48, 99, 49, 99, 51, 99, 52, 99, 53, 99, 54, 99, 55, 99, 56, 99, 59, 99, 60, 99, 62, 99, 63, 99, 64, 99, 65, 99, 68, 99, 71, 99, 72, 99, 74, 99, 81, 99, 82, 99, 83, 99, 84, 99, 86, 99, 87, 99, 88, 99, 89, 99, 90, 99, 91, 99, 92, 99, 93, 99, 96, 99, 100, 99, 101, 99, 102, 99, 104, 99, 106, 99, 107, 99, 108, 99, 111, 99, 112, 99, 114, 99, 115, 99, 116, 99, 117, 99, 120, 99, 121, 99, 124, 99, 125, 99, 126, 99, 127, 99, 129, 99, 131, 99, 132, 99, 133, 99, 134, 99, 139, 99, 141, 99, 145, 99, 147, 99, 148, 99, 149, 99, 151, 99, 153, 99, 154, 99, 155, 99, 156, 99, 157, 99, 158, 99, 159, 99, 161, 99, 164, 99, 166, 99, 171, 99, 175, 99, 177, 99, 178, 99, 181, 99, 182, 99, 185, 99, 187, 99, 189, 99, 191, 99, 192, 99, 193, 99, 194, 99, 195, 99, 197, 99, 199, 99, 200, 99, 202, 99, 203, 99, 204, 99, 209, 99, 211, 99, 212, 99, 213, 99, 215, 99, 216, 99, 217, 99, 218, 99, 219, 99, 220, 99, 221, 99, 223, 99, 226, 99, 228, 99, 229, 99, 230, 99, 231, 99, 232, 99, 235, 99, 236, 99, 238, 99, 239, 99, 240, 99, 241, 99, 243, 99, 245, 99, 247, 99, 249, 99, 250, 99, 251, 99, 252, 99, 254, 99, 3, 100, 4, 100, 6, 100, 7, 100, 8, 100, 9, 100, 10, 100, 13, 100, 14, 100, 17, 100, 18, 100, 21, 100, 22, 100, 23, 100, 24, 100, 25, 100, 26, 100, 29, 100, 31, 100, 34, 100, 35, 100, 36, 100, 37, 100, 39, 100, 40, 100, 41, 100, 43, 100, 46, 100, 47, 100, 48, 100, 49, 100, 50, 100, 51, 100, 53, 100, 54, 100, 55, 100, 56, 100, 57, 100, 59, 100, 60, 100, 62, 100, 64, 100, 66, 100, 67, 100, 73, 100, 75, 100, 76, 100, 77, 100, 78, 100, 79, 100, 80, 100, 81, 100, 83, 100, 85, 100, 86, 100, 87, 100, 89, 100, 90, 100, 91, 100, 92, 100, 93, 100, 95, 100, 96, 100, 97, 100, 98, 100, 99, 100, 100, 100, 101, 100, 102, 100, 104, 100, 106, 100, 107, 100, 108, 100, 110, 100, 111, 100, 112, 100, 113, 100, 114, 100, 115, 100, 116, 100, 117, 100, 118, 100, 119, 100, 123, 100, 124, 100, 125, 100, 126, 100, 127, 100, 128, 100, 129, 100, 131, 100, 134, 100, 136, 100, 137, 100, 138, 100, 139, 100, 140, 100, 141, 100, 142, 100, 143, 100, 144, 100, 147, 100, 148, 100, 151, 100, 152, 100, 154, 100, 155, 100, 156, 100, 157, 100, 159, 100, 160, 100, 161, 100, 162, 100, 163, 100, 165, 100, 166, 100, 167, 100, 168, 100, 170, 100, 171, 100, 175, 100, 177, 100, 178, 100, 179, 100, 180, 100, 182, 100, 185, 100, 187, 100, 189, 100, 190, 100, 191, 100, 193, 100, 195, 100, 196, 100, 198, 100, 199, 100, 200, 100, 201, 100, 202, 100, 203, 100, 204, 100, 207, 100, 209, 100, 211, 100, 212, 100, 213, 100, 214, 100, 217, 100, 218, 100, 219, 100, 220, 100, 221, 100, 223, 100, 224, 100, 225, 100, 227, 100, 229, 100, 231, 100, 232, 100, 233, 100, 234, 100, 235, 100, 236, 100, 237, 100, 238, 100, 239, 100, 240, 100, 241, 100, 242, 100, 243, 100, 244, 100, 245, 100, 246, 100, 247, 100, 248, 100, 249, 100, 250, 100, 251, 100, 252, 100, 253, 100, 254, 100, 255, 100, 1, 101, 2, 101, 3, 101, 4, 101, 5, 101, 6, 101, 7, 101, 8, 101, 10, 101, 11, 101, 12, 101, 13, 101, 14, 101, 15, 101, 16, 101, 17, 101, 19, 101, 20, 101, 21, 101, 22, 101, 23, 101, 25, 101, 26, 101, 27, 101, 28, 101, 29, 101, 30, 101, 31, 101, 32, 101, 33, 101, 34, 101, 35, 101, 36, 101, 38, 101, 39, 101, 40, 101, 41, 101, 42, 101, 44, 101, 45, 101, 48, 101, 49, 101, 50, 101, 51, 101, 55, 101, 58, 101, 60, 101, 61, 101, 64, 101, 65, 101, 66, 101, 67, 101, 68, 101, 70, 101, 71, 101, 74, 101, 75, 101, 77, 101, 78, 101, 80, 101, 82, 101, 83, 101, 84, 101, 87, 101, 88, 101, 90, 101, 92, 101, 95, 101, 96, 101, 97, 101, 100, 101, 101, 101, 103, 101, 104, 101, 105, 101, 106, 101, 109, 101, 110, 101, 111, 101, 113, 101, 115, 101, 117, 101, 118, 101, 120, 101, 121, 101, 122, 101, 123, 101, 124, 101, 125, 101, 126, 101, 127, 101, 128, 101, 129, 101, 130, 101, 131, 101, 132, 101, 133, 101, 134, 101, 136, 101, 137, 101, 138, 101, 141, 101, 142, 101, 143, 101, 146, 101, 148, 101, 149, 101, 150, 101, 152, 101, 154, 101, 157, 101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 220348);
	        allocate([158, 101, 160, 101, 162, 101, 163, 101, 166, 101, 168, 101, 170, 101, 172, 101, 174, 101, 177, 101, 178, 101, 179, 101, 180, 101, 181, 101, 182, 101, 183, 101, 184, 101, 186, 101, 187, 101, 190, 101, 191, 101, 192, 101, 194, 101, 199, 101, 200, 101, 201, 101, 202, 101, 205, 101, 208, 101, 209, 101, 211, 101, 212, 101, 213, 101, 216, 101, 217, 101, 218, 101, 219, 101, 220, 101, 221, 101, 222, 101, 223, 101, 225, 101, 227, 101, 228, 101, 234, 101, 235, 101, 242, 101, 243, 101, 244, 101, 245, 101, 248, 101, 249, 101, 251, 101, 252, 101, 253, 101, 254, 101, 255, 101, 1, 102, 4, 102, 5, 102, 7, 102, 8, 102, 9, 102, 11, 102, 13, 102, 16, 102, 17, 102, 18, 102, 22, 102, 23, 102, 24, 102, 26, 102, 27, 102, 28, 102, 30, 102, 33, 102, 34, 102, 35, 102, 36, 102, 38, 102, 41, 102, 42, 102, 43, 102, 44, 102, 46, 102, 48, 102, 50, 102, 51, 102, 55, 102, 56, 102, 57, 102, 58, 102, 59, 102, 61, 102, 63, 102, 64, 102, 66, 102, 68, 102, 69, 102, 70, 102, 71, 102, 72, 102, 73, 102, 74, 102, 77, 102, 78, 102, 80, 102, 81, 102, 88, 102, 89, 102, 91, 102, 92, 102, 93, 102, 94, 102, 96, 102, 98, 102, 99, 102, 101, 102, 103, 102, 105, 102, 106, 102, 107, 102, 108, 102, 109, 102, 113, 102, 114, 102, 115, 102, 117, 102, 120, 102, 121, 102, 123, 102, 124, 102, 125, 102, 127, 102, 128, 102, 129, 102, 131, 102, 133, 102, 134, 102, 136, 102, 137, 102, 138, 102, 139, 102, 141, 102, 142, 102, 143, 102, 144, 102, 146, 102, 147, 102, 148, 102, 149, 102, 152, 102, 153, 102, 154, 102, 155, 102, 156, 102, 158, 102, 159, 102, 160, 102, 161, 102, 162, 102, 163, 102, 164, 102, 165, 102, 166, 102, 169, 102, 170, 102, 171, 102, 172, 102, 173, 102, 175, 102, 176, 102, 177, 102, 178, 102, 179, 102, 181, 102, 182, 102, 183, 102, 184, 102, 186, 102, 187, 102, 188, 102, 189, 102, 191, 102, 192, 102, 193, 102, 194, 102, 195, 102, 196, 102, 197, 102, 198, 102, 199, 102, 200, 102, 201, 102, 202, 102, 203, 102, 204, 102, 205, 102, 206, 102, 207, 102, 208, 102, 209, 102, 210, 102, 211, 102, 212, 102, 213, 102, 214, 102, 215, 102, 216, 102, 218, 102, 222, 102, 223, 102, 224, 102, 225, 102, 226, 102, 227, 102, 228, 102, 229, 102, 231, 102, 232, 102, 234, 102, 235, 102, 236, 102, 237, 102, 238, 102, 239, 102, 241, 102, 245, 102, 246, 102, 248, 102, 250, 102, 251, 102, 253, 102, 1, 103, 2, 103, 3, 103, 4, 103, 5, 103, 6, 103, 7, 103, 12, 103, 14, 103, 15, 103, 17, 103, 18, 103, 19, 103, 22, 103, 24, 103, 25, 103, 26, 103, 28, 103, 30, 103, 32, 103, 33, 103, 34, 103, 35, 103, 36, 103, 37, 103, 39, 103, 41, 103, 46, 103, 48, 103, 50, 103, 51, 103, 54, 103, 55, 103, 56, 103, 57, 103, 59, 103, 60, 103, 62, 103, 63, 103, 65, 103, 68, 103, 69, 103, 71, 103, 74, 103, 75, 103, 77, 103, 82, 103, 84, 103, 85, 103, 87, 103, 88, 103, 89, 103, 90, 103, 91, 103, 93, 103, 98, 103, 99, 103, 100, 103, 102, 103, 103, 103, 107, 103, 108, 103, 110, 103, 113, 103, 116, 103, 118, 103, 120, 103, 121, 103, 122, 103, 123, 103, 125, 103, 128, 103, 130, 103, 131, 103, 133, 103, 134, 103, 136, 103, 138, 103, 140, 103, 141, 103, 142, 103, 143, 103, 145, 103, 146, 103, 147, 103, 148, 103, 150, 103, 153, 103, 155, 103, 159, 103, 160, 103, 161, 103, 164, 103, 166, 103, 169, 103, 172, 103, 174, 103, 177, 103, 178, 103, 180, 103, 185, 103, 186, 103, 187, 103, 188, 103, 189, 103, 190, 103, 191, 103, 192, 103, 194, 103, 197, 103, 198, 103, 199, 103, 200, 103, 201, 103, 202, 103, 203, 103, 204, 103, 205, 103, 206, 103, 213, 103, 214, 103, 215, 103, 219, 103, 223, 103, 225, 103, 227, 103, 228, 103, 230, 103, 231, 103, 232, 103, 234, 103, 235, 103, 237, 103, 238, 103, 242, 103, 245, 103, 246, 103, 247, 103, 248, 103, 249, 103, 250, 103, 251, 103, 252, 103, 254, 103, 1, 104, 2, 104, 3, 104, 4, 104, 6, 104, 13, 104, 16, 104, 18, 104, 20, 104, 21, 104, 24, 104, 25, 104, 26, 104, 27, 104, 28, 104, 30, 104, 31, 104, 32, 104, 34, 104, 35, 104, 36, 104, 37, 104, 38, 104, 39, 104, 40, 104, 43, 104, 44, 104, 45, 104, 46, 104, 47, 104, 48, 104, 49, 104, 52, 104, 53, 104, 54, 104, 58, 104, 59, 104, 63, 104, 71, 104, 75, 104, 77, 104, 79, 104, 82, 104, 86, 104, 87, 104, 88, 104, 89, 104, 90, 104, 91, 104, 92, 104, 93, 104, 94, 104, 95, 104, 106, 104, 108, 104, 109, 104, 110, 104, 111, 104, 112, 104, 113, 104, 114, 104, 115, 104, 117, 104, 120, 104, 121, 104, 122, 104, 123, 104, 124, 104, 125, 104, 126, 104, 127, 104, 128, 104, 130, 104, 132, 104, 135, 104, 136, 104, 137, 104, 138, 104, 139, 104, 140, 104, 141, 104, 142, 104, 144, 104, 145, 104, 146, 104, 148, 104, 149, 104, 150, 104, 152, 104, 153, 104, 154, 104, 155, 104, 156, 104, 157, 104, 158, 104, 159, 104, 160, 104, 161, 104, 163, 104, 164, 104, 165, 104, 169, 104, 170, 104, 171, 104, 172, 104, 174, 104, 177, 104, 178, 104, 180, 104, 182, 104, 183, 104, 184, 104, 185, 104, 186, 104, 187, 104, 188, 104, 189, 104, 190, 104, 191, 104, 193, 104, 195, 104, 196, 104, 197, 104, 198, 104, 199, 104, 200, 104, 202, 104, 204, 104, 206, 104, 207, 104, 208, 104, 209, 104, 211, 104, 212, 104, 214, 104, 215, 104, 217, 104, 219, 104, 220, 104, 221, 104, 222, 104, 223, 104, 225, 104, 226, 104, 228, 104, 229, 104, 230, 104, 231, 104, 232, 104, 233, 104, 234, 104, 235, 104, 236, 104, 237, 104, 239, 104, 242, 104, 243, 104, 244, 104, 246, 104, 247, 104, 248, 104, 251, 104, 253, 104, 254, 104, 255, 104, 0, 105, 2, 105, 3, 105, 4, 105, 6, 105, 7, 105, 8, 105, 9, 105, 10, 105, 12, 105, 15, 105, 17, 105, 19, 105, 20, 105, 21, 105, 22, 105, 23, 105, 24, 105, 25, 105, 26, 105, 27, 105, 28, 105, 29, 105, 30, 105, 33, 105, 34, 105, 35, 105, 37, 105, 38, 105, 39, 105, 40, 105, 41, 105, 42, 105, 43, 105, 44, 105, 46, 105, 47, 105, 49, 105, 50, 105, 51, 105, 53, 105, 54, 105, 55, 105, 56, 105, 58, 105, 59, 105, 60, 105, 62, 105, 64, 105, 65, 105, 67, 105, 68, 105, 69, 105, 70, 105, 71, 105, 72, 105, 73, 105, 74, 105, 75, 105, 76, 105, 77, 105, 78, 105, 79, 105, 80, 105, 81, 105, 82, 105, 83, 105, 85, 105, 86, 105, 88, 105, 89, 105, 91, 105, 92, 105, 95, 105, 97, 105, 98, 105, 100, 105, 101, 105, 103, 105, 104, 105, 105, 105, 106, 105, 108, 105, 109, 105, 111, 105, 112, 105, 114, 105, 115, 105, 116, 105, 117, 105, 118, 105, 122, 105, 123, 105, 125, 105, 126, 105, 127, 105, 129, 105, 131, 105, 133, 105, 138, 105, 139, 105, 140, 105, 142, 105, 143, 105, 144, 105, 145, 105, 146, 105, 147, 105, 150, 105, 151, 105, 153, 105, 154, 105, 157, 105, 158, 105, 159, 105, 160, 105, 161, 105, 162, 105, 163, 105, 164, 105, 165, 105, 166, 105, 169, 105, 170, 105, 172, 105, 174, 105, 175, 105, 176, 105, 178, 105, 179, 105, 181, 105, 182, 105, 184, 105, 185, 105, 186, 105, 188, 105, 189, 105, 190, 105, 191, 105, 192, 105, 194, 105, 195, 105, 196, 105, 197, 105, 198, 105, 199, 105, 200, 105, 201, 105, 203, 105, 205, 105, 207, 105, 209, 105, 210, 105, 211, 105, 213, 105, 214, 105, 215, 105, 216, 105, 217, 105, 218, 105, 220, 105, 221, 105, 222, 105, 225, 105, 226, 105, 227, 105, 228, 105, 229, 105, 230, 105, 231, 105, 232, 105, 233, 105, 234, 105, 235, 105, 236, 105, 238, 105, 239, 105, 240, 105, 241, 105, 243, 105, 244, 105, 245, 105, 246, 105, 247, 105, 248, 105, 249, 105, 250, 105, 251, 105, 252, 105, 254, 105, 0, 106, 1, 106, 2, 106, 3, 106, 4, 106, 5, 106, 6, 106, 7, 106, 8, 106, 9, 106, 11, 106, 12, 106, 13, 106, 14, 106, 15, 106, 16, 106, 17, 106, 18, 106, 19, 106, 20, 106, 21, 106, 22, 106, 25, 106, 26, 106, 27, 106, 28, 106, 29, 106, 30, 106, 32, 106, 34, 106, 35, 106, 36, 106, 37, 106, 38, 106, 39, 106, 41, 106, 43, 106, 44, 106, 45, 106, 46, 106, 48, 106, 50, 106, 51, 106, 52, 106, 54, 106, 55, 106, 56, 106, 57, 106, 58, 106, 59, 106, 60, 106, 63, 106, 64, 106, 65, 106, 66, 106, 67, 106, 69, 106, 70, 106, 72, 106, 73, 106, 74, 106, 75, 106, 76, 106, 77, 106, 78, 106, 79, 106, 81, 106, 82, 106, 83, 106, 84, 106, 85, 106, 86, 106, 87, 106, 90, 106, 92, 106, 93, 106, 94, 106, 95, 106, 96, 106, 98, 106, 99, 106, 100, 106, 102, 106, 103, 106, 104, 106, 105, 106, 106, 106, 107, 106, 108, 106, 109, 106, 110, 106, 111, 106, 112, 106, 114, 106, 115, 106, 116, 106, 117, 106, 118, 106, 119, 106, 120, 106, 122, 106, 123, 106, 125, 106, 126, 106, 127, 106, 129, 106, 130, 106, 131, 106, 133, 106, 134, 106, 135, 106, 136, 106, 137, 106, 138, 106, 139, 106, 140, 106, 141, 106, 143, 106, 146, 106, 147, 106, 148, 106, 149, 106, 150, 106, 152, 106, 153, 106, 154, 106, 155, 106, 156, 106, 157, 106, 158, 106, 159, 106, 161, 106, 162, 106, 163, 106, 164, 106, 165, 106, 166, 106, 167, 106, 168, 106, 170, 106, 173, 106, 174, 106, 175, 106, 176, 106, 177, 106, 178, 106, 179, 106, 180, 106, 181, 106, 182, 106, 183, 106, 184, 106, 185, 106, 186, 106, 187, 106, 188, 106, 189, 106, 190, 106, 191, 106, 192, 106, 193, 106, 194, 106, 195, 106, 196, 106, 197, 106, 198, 106, 199, 106, 200, 106, 201, 106, 202, 106, 203, 106, 204, 106, 205, 106, 206, 106, 207, 106, 208, 106, 209, 106, 210, 106, 211, 106, 212, 106, 213, 106, 214, 106, 215, 106, 216, 106, 217, 106, 218, 106, 219, 106, 220, 106, 221, 106, 222, 106, 223, 106, 224, 106, 225, 106, 226, 106, 227, 106, 228, 106, 229, 106, 230, 106, 231, 106, 232, 106, 233, 106, 234, 106, 235, 106, 236, 106, 237, 106, 238, 106, 239, 106, 240, 106, 241, 106, 242, 106, 243, 106, 244, 106, 245, 106, 246, 106, 247, 106, 248, 106, 249, 106, 250, 106, 251, 106, 252, 106, 253, 106, 254, 106, 255, 106, 0, 107, 1, 107, 2, 107, 3, 107, 4, 107, 5, 107, 6, 107, 7, 107, 8, 107, 9, 107, 10, 107, 11, 107, 12, 107, 13, 107, 14, 107, 15, 107, 16, 107, 17, 107, 18, 107, 19, 107, 20, 107, 21, 107, 22, 107, 23, 107, 24, 107, 25, 107, 26, 107, 27, 107, 28, 107, 29, 107, 30, 107, 31, 107, 37, 107, 38, 107, 40, 107, 41, 107, 42, 107, 43, 107, 44, 107, 45, 107, 46, 107, 47, 107, 48, 107, 49, 107, 51, 107, 52, 107, 53, 107, 54, 107, 56, 107, 59, 107, 60, 107, 61, 107, 63, 107, 64, 107, 65, 107, 66, 107, 68, 107, 69, 107, 72, 107, 74, 107, 75, 107, 77, 107, 78, 107, 79, 107, 80, 107, 81, 107, 82, 107, 83, 107, 84, 107, 85, 107, 86, 107, 87, 107, 88, 107, 90, 107, 91, 107, 92, 107, 93, 107, 94, 107, 95, 107, 96, 107, 97, 107, 104, 107, 105, 107, 107, 107, 108, 107, 109, 107, 110, 107, 111, 107, 112, 107, 113, 107, 114, 107, 115, 107, 116, 107, 117, 107, 118, 107, 119, 107, 120, 107, 122, 107, 125, 107, 126, 107, 127, 107, 128, 107, 133, 107, 136, 107, 140, 107, 142, 107, 143, 107, 144, 107, 145, 107, 148, 107, 149, 107, 151, 107, 152, 107, 153, 107, 156, 107, 157, 107, 158, 107, 159, 107, 160, 107, 162, 107, 163, 107, 164, 107, 165, 107, 166, 107, 167, 107, 168, 107, 169, 107, 171, 107, 172, 107, 173, 107, 174, 107, 175, 107, 176, 107, 177, 107, 178, 107, 182, 107, 184, 107, 185, 107, 186, 107, 187, 107, 188, 107, 189, 107, 190, 107, 192, 107, 195, 107, 196, 107, 198, 107, 199, 107, 200, 107, 201, 107, 202, 107, 204, 107, 206, 107, 208, 107, 209, 107, 216, 107, 218, 107, 220, 107, 221, 107, 222, 107, 223, 107, 224, 107, 226, 107, 227, 107, 228, 107, 229, 107, 230, 107, 231, 107, 232, 107, 233, 107, 236, 107, 237, 107, 238, 107, 240, 107, 241, 107, 242, 107, 244, 107, 246, 107, 247, 107, 248, 107, 250, 107, 251, 107, 252, 107, 254, 107, 255, 107, 0, 108, 1, 108, 2, 108, 3, 108, 4, 108, 8, 108, 9, 108, 10, 108, 11, 108, 12, 108, 14, 108, 18, 108, 23, 108, 28, 108, 29, 108, 30, 108, 32, 108, 35, 108, 37, 108, 43, 108, 44, 108, 45, 108, 49, 108, 51, 108, 54, 108, 55, 108, 57, 108, 58, 108, 59, 108, 60, 108, 62, 108, 63, 108, 67, 108, 68, 108, 69, 108, 72, 108, 75, 108, 76, 108, 77, 108, 78, 108, 79, 108, 81, 108, 82, 108, 83, 108, 86, 108, 88, 108, 89, 108, 90, 108, 98, 108, 99, 108, 101, 108, 102, 108, 103, 108, 107, 108, 108, 108, 109, 108, 110, 108, 111, 108, 113, 108, 115, 108, 117, 108, 119, 108, 120, 108, 122, 108, 123, 108, 124, 108, 127, 108, 128, 108, 132, 108, 135, 108, 138, 108, 139, 108, 141, 108, 142, 108, 145, 108, 146, 108, 149, 108, 150, 108, 151, 108, 152, 108, 154, 108, 156, 108, 157, 108, 158, 108, 160, 108, 162, 108, 168, 108, 172, 108, 175, 108, 176, 108, 180, 108, 181, 108, 182, 108, 183, 108, 186, 108, 192, 108, 193, 108, 194, 108, 195, 108, 198, 108, 199, 108, 200, 108, 203, 108, 205, 108, 206, 108, 207, 108, 209, 108, 210, 108, 216, 108, 217, 108, 218, 108, 220, 108, 221, 108, 223, 108, 228, 108, 230, 108, 231, 108, 233, 108, 236, 108, 237, 108, 242, 108, 244, 108, 249, 108, 255, 108, 0, 109, 2, 109, 3, 109, 5, 109, 6, 109, 8, 109, 9, 109, 10, 109, 13, 109, 15, 109, 16, 109, 17, 109, 19, 109, 20, 109, 21, 109, 22, 109, 24, 109, 28, 109, 29, 109, 31, 109, 32, 109, 33, 109, 34, 109, 35, 109, 36, 109, 38, 109, 40, 109, 41, 109, 44, 109, 45, 109, 47, 109, 48, 109, 52, 109, 54, 109, 55, 109, 56, 109, 58, 109, 63, 109, 64, 109, 66, 109, 68, 109, 73, 109, 76, 109, 80, 109, 85, 109, 86, 109, 87, 109, 88, 109, 91, 109, 93, 109, 95, 109, 97, 109, 98, 109, 100, 109, 101, 109, 103, 109, 104, 109, 107, 109, 108, 109, 109, 109, 112, 109, 113, 109, 114, 109, 115, 109, 117, 109, 118, 109, 121, 109, 122, 109, 123, 109, 125, 109, 126, 109, 127, 109, 128, 109, 129, 109, 131, 109, 132, 109, 134, 109, 135, 109, 138, 109, 139, 109, 141, 109, 143, 109, 144, 109, 146, 109, 150, 109, 151, 109, 152, 109, 153, 109, 154, 109, 156, 109, 162, 109, 165, 109, 172, 109, 173, 109, 176, 109, 177, 109, 179, 109, 180, 109, 182, 109, 183, 109, 185, 109, 186, 109, 187, 109, 188, 109, 189, 109, 190, 109, 193, 109, 194, 109, 195, 109, 200, 109, 201, 109, 202, 109, 205, 109, 206, 109, 207, 109, 208, 109, 210, 109, 211, 109, 212, 109, 213, 109, 215, 109, 218, 109, 219, 109, 220, 109, 223, 109, 226, 109, 227, 109, 229, 109, 231, 109, 232, 109, 233, 109, 234, 109, 237, 109, 239, 109, 240, 109, 242, 109, 244, 109, 245, 109, 246, 109, 248, 109, 250, 109, 253, 109, 254, 109, 255, 109, 0, 110, 1, 110, 2, 110, 3, 110, 4, 110, 6, 110, 7, 110, 8, 110, 9, 110, 11, 110, 15, 110, 18, 110, 19, 110, 21, 110, 24, 110, 25, 110, 27, 110, 28, 110, 30, 110, 31, 110, 34, 110, 38, 110, 39, 110, 40, 110, 42, 110, 44, 110, 46, 110, 48, 110, 49, 110, 51, 110, 53, 110, 54, 110, 55, 110, 57, 110, 59, 110, 60, 110, 61, 110, 62, 110, 63, 110, 64, 110, 65, 110, 66, 110, 69, 110, 70, 110, 71, 110, 72, 110, 73, 110, 74, 110, 75, 110, 76, 110, 79, 110, 80, 110, 81, 110, 82, 110, 85, 110, 87, 110, 89, 110, 90, 110, 92, 110, 93, 110, 94, 110, 96, 110, 97, 110, 98, 110, 99, 110, 100, 110, 101, 110, 102, 110, 103, 110, 104, 110, 105, 110, 106, 110, 108, 110, 109, 110, 111, 110, 112, 110, 113, 110, 114, 110, 115, 110, 116, 110, 117, 110, 118, 110, 119, 110, 120, 110, 121, 110, 122, 110, 123, 110, 124, 110, 125, 110, 128, 110, 129, 110, 130, 110, 132, 110, 135, 110, 136, 110, 138, 110, 139, 110, 140, 110, 141, 110, 142, 110, 145, 110, 146, 110, 147, 110, 148, 110, 149, 110, 150, 110, 151, 110, 153, 110, 154, 110, 155, 110, 157, 110, 158, 110, 160, 110, 161, 110, 163, 110, 164, 110, 166, 110, 168, 110, 169, 110, 171, 110, 172, 110, 173, 110, 174, 110, 176, 110, 179, 110, 181, 110, 184, 110, 185, 110, 188, 110, 190, 110, 191, 110, 192, 110, 195, 110, 196, 110, 197, 110, 198, 110, 200, 110, 201, 110, 202, 110, 204, 110, 205, 110, 206, 110, 208, 110, 210, 110, 214, 110, 216, 110, 217, 110, 219, 110, 220, 110, 221, 110, 227, 110, 231, 110, 234, 110, 235, 110, 236, 110, 237, 110, 238, 110, 239, 110, 240, 110, 241, 110, 242, 110, 243, 110, 245, 110, 246, 110, 247, 110, 248, 110, 250, 110, 251, 110, 252, 110, 253, 110, 254, 110, 255, 110, 0, 111, 1, 111, 3, 111, 4, 111, 5, 111, 7, 111, 8, 111, 10, 111, 11, 111, 12, 111, 13, 111, 14, 111, 16, 111, 17, 111, 18, 111, 22, 111, 23, 111, 24, 111, 25, 111, 26, 111, 27, 111, 28, 111, 29, 111, 30, 111, 31, 111, 33, 111, 34, 111, 35, 111, 37, 111, 38, 111, 39, 111, 40, 111, 44, 111, 46, 111, 48, 111, 50, 111, 52, 111, 53, 111, 55, 111, 56, 111, 57, 111, 58, 111, 59, 111, 60, 111, 61, 111, 63, 111, 64, 111, 65, 111, 66, 111, 67, 111, 68, 111, 69, 111, 72, 111, 73, 111, 74, 111, 76, 111, 78, 111, 79, 111, 80, 111, 81, 111, 82, 111, 83, 111, 84, 111, 85, 111, 86, 111, 87, 111, 89, 111, 90, 111, 91, 111, 93, 111, 95, 111, 96, 111, 97, 111, 99, 111, 100, 111, 101, 111, 103, 111, 104, 111, 105, 111, 106, 111, 107, 111, 108, 111, 111, 111, 112, 111, 113, 111, 115, 111, 117, 111, 118, 111, 119, 111, 121, 111, 123, 111, 125, 111, 126, 111, 127, 111, 128, 111, 129, 111, 130, 111, 131, 111, 133, 111, 134, 111, 135, 111, 138, 111, 139, 111, 143, 111, 144, 111, 145, 111, 146, 111, 147, 111, 148, 111, 149, 111, 150, 111, 151, 111, 152, 111, 153, 111, 154, 111, 155, 111, 157, 111, 158, 111, 159, 111, 160, 111, 162, 111, 163, 111, 164, 111, 165, 111, 166, 111, 168, 111, 169, 111, 170, 111, 171, 111, 172, 111, 173, 111, 174, 111, 175, 111, 176, 111, 177, 111, 178, 111, 180, 111, 181, 111, 183, 111, 184, 111, 186, 111, 187, 111, 188, 111, 189, 111, 190, 111, 191, 111, 193, 111, 195, 111, 196, 111, 197, 111, 198, 111, 199, 111, 200, 111, 202, 111, 203, 111, 204, 111, 205, 111, 206, 111, 207, 111, 208, 111, 211, 111, 212, 111, 213, 111, 214, 111, 215, 111, 216, 111, 217, 111, 218, 111, 219, 111, 220, 111, 221, 111, 223, 111, 226, 111, 227, 111, 228, 111, 229, 111, 230, 111, 231, 111, 232, 111, 233, 111, 234, 111, 235, 111, 236, 111, 237, 111, 240, 111, 241, 111, 242, 111, 243, 111, 244, 111, 245, 111, 246, 111, 247, 111, 248, 111, 249, 111, 250, 111, 251, 111, 252, 111, 253, 111, 254, 111, 255, 111, 0, 112, 1, 112, 2, 112, 3, 112, 4, 112, 5, 112, 6, 112, 7, 112, 8, 112, 9, 112, 10, 112, 11, 112, 12, 112, 13, 112, 14, 112, 15, 112, 16, 112, 18, 112, 19, 112, 20, 112, 21, 112, 22, 112, 23, 112, 24, 112, 25, 112, 28, 112, 29, 112, 30, 112, 31, 112, 32, 112, 33, 112, 34, 112, 36, 112, 37, 112, 38, 112, 39, 112, 40, 112, 41, 112, 42, 112, 43, 112, 44, 112, 45, 112, 46, 112, 47, 112, 48, 112, 49, 112, 50, 112, 51, 112, 52, 112, 54, 112, 55, 112, 56, 112, 58, 112, 59, 112, 60, 112, 61, 112, 62, 112, 63, 112, 64, 112, 65, 112, 66, 112, 67, 112, 68, 112, 69, 112, 70, 112, 71, 112, 72, 112, 73, 112, 74, 112, 75, 112, 77, 112, 78, 112, 80, 112, 81, 112, 82, 112, 83, 112, 84, 112, 85, 112, 86, 112, 87, 112, 88, 112, 89, 112, 90, 112, 91, 112, 92, 112, 93, 112, 95, 112, 96, 112, 97, 112, 98, 112, 99, 112, 100, 112, 101, 112, 102, 112, 103, 112, 104, 112, 105, 112, 106, 112, 110, 112, 113, 112, 114, 112, 115, 112, 116, 112, 119, 112, 121, 112, 122, 112, 123, 112, 125, 112, 129, 112, 130, 112, 131, 112, 132, 112, 134, 112, 135, 112, 136, 112, 139, 112, 140, 112, 141, 112, 143, 112, 144, 112, 145, 112, 147, 112, 151, 112, 152, 112, 154, 112, 155, 112, 158, 112, 159, 112, 160, 112, 161, 112, 162, 112, 163, 112, 164, 112, 165, 112, 166, 112, 167, 112, 168, 112, 169, 112, 170, 112, 176, 112, 178, 112, 180, 112, 181, 112, 182, 112, 186, 112, 190, 112, 191, 112, 196, 112, 197, 112, 198, 112, 199, 112, 201, 112, 203, 112, 204, 112, 205, 112, 206, 112, 207, 112, 208, 112, 209, 112, 210, 112, 211, 112, 212, 112, 213, 112, 214, 112, 215, 112, 218, 112, 220, 112, 221, 112, 222, 112, 224, 112, 225, 112, 226, 112, 227, 112, 229, 112, 234, 112, 238, 112, 240, 112, 241, 112, 242, 112, 243, 112, 244, 112, 245, 112, 246, 112, 248, 112, 250, 112, 251, 112, 252, 112, 254, 112, 255, 112, 0, 113, 1, 113, 2, 113, 3, 113, 4, 113, 5, 113, 6, 113, 7, 113, 8, 113, 11, 113, 12, 113, 13, 113, 14, 113, 15, 113, 17, 113, 18, 113, 20, 113, 23, 113, 27, 113, 28, 113, 29, 113, 30, 113, 31, 113, 32, 113, 33, 113, 34, 113, 35, 113, 36, 113, 37, 113, 39, 113, 40, 113, 41, 113, 42, 113, 43, 113, 44, 113, 45, 113, 46, 113, 50, 113, 51, 113, 52, 113, 53, 113, 55, 113, 56, 113, 57, 113, 58, 113, 59, 113, 60, 113, 61, 113, 62, 113, 63, 113, 64, 113, 65, 113, 66, 113, 67, 113, 68, 113, 70, 113, 71, 113, 72, 113, 73, 113, 75, 113, 77, 113, 79, 113, 80, 113, 81, 113, 82, 113, 83, 113, 84, 113, 85, 113, 86, 113, 87, 113, 88, 113, 89, 113, 90, 113, 91, 113, 93, 113, 95, 113, 96, 113, 97, 113, 98, 113, 99, 113, 101, 113, 105, 113, 106, 113, 107, 113, 108, 113, 109, 113, 111, 113, 112, 113, 113, 113, 116, 113, 117, 113, 118, 113, 119, 113, 121, 113, 123, 113, 124, 113, 126, 113, 127, 113, 128, 113, 129, 113, 130, 113, 131, 113, 133, 113, 134, 113, 135, 113, 136, 113, 137, 113, 139, 113, 140, 113, 141, 113, 142, 113, 144, 113, 145, 113, 146, 113, 147, 113, 149, 113, 150, 113, 151, 113, 154, 113, 155, 113, 156, 113, 157, 113, 158, 113, 161, 113, 162, 113, 163, 113, 164, 113, 165, 113, 166, 113, 167, 113, 169, 113, 170, 113, 171, 113, 173, 113, 174, 113, 175, 113, 176, 113, 177, 113, 178, 113, 180, 113, 182, 113, 183, 113, 184, 113, 186, 113, 187, 113, 188, 113, 189, 113, 190, 113, 191, 113, 192, 113, 193, 113, 194, 113, 196, 113, 197, 113, 198, 113, 199, 113, 200, 113, 201, 113, 202, 113, 203, 113, 204, 113, 205, 113, 207, 113, 208, 113, 209, 113, 210, 113, 211, 113, 214, 113, 215, 113, 216, 113, 217, 113, 218, 113, 219, 113, 220, 113, 221, 113, 222, 113, 223, 113, 225, 113, 226, 113, 227, 113, 228, 113, 230, 113, 232, 113, 233, 113, 234, 113, 235, 113, 236, 113, 237, 113, 239, 113, 240, 113, 241, 113, 242, 113, 243, 113, 244, 113, 245, 113, 246, 113, 247, 113, 248, 113, 250, 113, 251, 113, 252, 113, 253, 113, 254, 113, 255, 113, 0, 114, 1, 114, 2, 114, 3, 114, 4, 114, 5, 114, 7, 114, 8, 114, 9, 114, 10, 114, 11, 114, 12, 114, 13, 114, 14, 114, 15, 114, 16, 114, 17, 114, 18, 114, 19, 114, 20, 114, 21, 114, 22, 114, 23, 114, 24, 114, 25, 114, 26, 114, 27, 114, 28, 114, 30, 114, 31, 114, 32, 114, 33, 114, 34, 114, 35, 114, 36, 114, 37, 114, 38, 114, 39, 114, 41, 114, 43, 114, 45, 114, 46, 114, 47, 114, 50, 114, 51, 114, 52, 114, 58, 114, 60, 114, 62, 114, 64, 114, 65, 114, 66, 114, 67, 114, 68, 114, 69, 114, 70, 114, 73, 114, 74, 114, 75, 114, 78, 114, 79, 114, 80, 114, 81, 114, 83, 114, 84, 114, 85, 114, 87, 114, 88, 114, 90, 114, 92, 114, 94, 114, 96, 114, 99, 114, 100, 114, 101, 114, 104, 114, 106, 114, 107, 114, 108, 114, 109, 114, 112, 114, 113, 114, 115, 114, 116, 114, 118, 114, 119, 114, 120, 114, 123, 114, 124, 114, 125, 114, 130, 114, 131, 114, 133, 114, 134, 114, 135, 114, 136, 114, 137, 114, 140, 114, 142, 114, 144, 114, 145, 114, 147, 114, 148, 114, 149, 114, 150, 114, 151, 114, 152, 114, 153, 114, 154, 114, 155, 114, 156, 114, 157, 114, 158, 114, 160, 114, 161, 114, 162, 114, 163, 114, 164, 114, 165, 114, 166, 114, 167, 114, 168, 114, 169, 114, 170, 114, 171, 114, 174, 114, 177, 114, 178, 114, 179, 114, 181, 114, 186, 114, 187, 114, 188, 114, 189, 114, 190, 114, 191, 114, 192, 114, 197, 114, 198, 114, 199, 114, 201, 114, 202, 114, 203, 114, 204, 114, 207, 114, 209, 114, 211, 114, 212, 114, 213, 114, 214, 114, 216, 114, 218, 114, 219, 114, 198, 228, 199, 228, 200, 228, 201, 228, 202, 228, 203, 228, 204, 228, 205, 228, 206, 228, 207, 228, 208, 228, 209, 228, 210, 228, 211, 228, 212, 228, 213, 228, 214, 228, 215, 228, 216, 228, 217, 228, 218, 228, 219, 228, 220, 228, 221, 228, 222, 228, 223, 228, 224, 228, 225, 228, 226, 228, 227, 228, 228, 228, 229, 228, 230, 228, 231, 228, 232, 228, 233, 228, 234, 228, 235, 228, 236, 228, 237, 228, 238, 228, 239, 228, 240, 228, 241, 228, 242, 228, 243, 228, 244, 228, 245, 228, 246, 228, 247, 228, 248, 228, 249, 228, 250, 228, 251, 228, 252, 228, 253, 228, 254, 228, 255, 228, 0, 229, 1, 229, 2, 229, 3, 229, 4, 229, 5, 229, 6, 229, 7, 229, 8, 229, 9, 229, 10, 229, 11, 229, 12, 229, 13, 229, 14, 229, 15, 229, 16, 229, 17, 229, 18, 229, 19, 229, 20, 229, 21, 229, 22, 229, 23, 229, 24, 229, 25, 229, 26, 229, 27, 229, 28, 229, 29, 229, 30, 229, 31, 229, 32, 229, 33, 229, 34, 229, 35, 229, 36, 229, 37, 229, 0, 48, 1, 48, 2, 48, 183, 0, 201, 2, 199, 2, 168, 0, 3, 48, 5, 48, 20, 32, 94, 255, 22, 32, 38, 32, 24, 32, 25, 32, 28, 32, 29, 32, 20, 48, 21, 48, 8, 48, 9, 48, 10, 48, 11, 48, 12, 48, 13, 48, 14, 48, 15, 48, 22, 48, 23, 48, 16, 48, 17, 48, 177, 0, 215, 0, 247, 0, 54, 34, 39, 34, 40, 34, 17, 34, 15, 34, 42, 34, 41, 34, 8, 34, 55, 34, 26, 34, 165, 34, 37, 34, 32, 34, 18, 35, 153, 34, 43, 34, 46, 34, 97, 34, 76, 34, 72, 34, 61, 34, 29, 34, 96, 34, 110, 34, 111, 34, 100, 34, 101, 34, 30, 34, 53, 34, 52, 34, 66, 38, 64, 38, 176, 0, 50, 32, 51, 32, 3, 33, 4, 255, 164, 0, 224, 255, 225, 255, 48, 32, 167, 0, 22, 33, 6, 38, 5, 38, 203, 37, 207, 37, 206, 37, 199, 37, 198, 37, 161, 37, 160, 37, 179, 37, 178, 37, 59, 32, 146, 33, 144, 33, 145, 33, 147, 33, 19, 48, 38, 229, 39, 229, 40, 229, 41, 229, 42, 229, 43, 229, 44, 229, 45, 229, 46, 229, 47, 229, 48, 229, 49, 229, 50, 229, 51, 229, 52, 229, 53, 229, 54, 229, 55, 229, 56, 229, 57, 229, 58, 229, 59, 229, 60, 229, 61, 229, 62, 229, 63, 229, 64, 229, 65, 229, 66, 229, 67, 229, 68, 229, 69, 229, 70, 229, 71, 229, 72, 229, 73, 229, 74, 229, 75, 229, 76, 229, 77, 229, 78, 229, 79, 229, 80, 229, 81, 229, 82, 229, 83, 229, 84, 229, 85, 229, 86, 229, 87, 229, 88, 229, 89, 229, 90, 229, 91, 229, 92, 229, 93, 229, 94, 229, 95, 229, 96, 229, 97, 229, 98, 229, 99, 229, 100, 229, 101, 229, 102, 229, 103, 229, 104, 229, 105, 229, 106, 229, 107, 229, 108, 229, 109, 229, 110, 229, 111, 229, 112, 229, 113, 229, 114, 229, 115, 229, 116, 229, 117, 229, 118, 229, 119, 229, 120, 229, 121, 229, 122, 229, 123, 229, 124, 229, 125, 229, 126, 229, 127, 229, 128, 229, 129, 229, 130, 229, 131, 229, 132, 229, 133, 229, 112, 33, 113, 33, 114, 33, 115, 33, 116, 33, 117, 33, 118, 33, 119, 33, 120, 33, 121, 33, 102, 231, 103, 231, 104, 231, 105, 231, 106, 231, 107, 231, 136, 36, 137, 36, 138, 36, 139, 36, 140, 36, 141, 36, 142, 36, 143, 36, 144, 36, 145, 36, 146, 36, 147, 36, 148, 36, 149, 36, 150, 36, 151, 36, 152, 36, 153, 36, 154, 36, 155, 36, 116, 36, 117, 36, 118, 36, 119, 36, 120, 36, 121, 36, 122, 36, 123, 36, 124, 36, 125, 36, 126, 36, 127, 36, 128, 36, 129, 36, 130, 36, 131, 36, 132, 36, 133, 36, 134, 36, 135, 36, 96, 36, 97, 36, 98, 36, 99, 36, 100, 36, 101, 36, 102, 36, 103, 36, 104, 36, 105, 36, 172, 32, 109, 231, 32, 50, 33, 50, 34, 50, 35, 50, 36, 50, 37, 50, 38, 50, 39, 50, 40, 50, 41, 50, 110, 231, 111, 231, 96, 33, 97, 33, 98, 33, 99, 33, 100, 33, 101, 33, 102, 33, 103, 33, 104, 33, 105, 33, 106, 33, 107, 33, 112, 231, 113, 231, 134, 229, 135, 229, 136, 229, 137, 229, 138, 229, 139, 229, 140, 229, 141, 229, 142, 229, 143, 229, 144, 229, 145, 229, 146, 229, 147, 229, 148, 229, 149, 229, 150, 229, 151, 229, 152, 229, 153, 229, 154, 229, 155, 229, 156, 229, 157, 229, 158, 229, 159, 229, 160, 229, 161, 229, 162, 229, 163, 229, 164, 229, 165, 229, 166, 229, 167, 229, 168, 229, 169, 229, 170, 229, 171, 229, 172, 229, 173, 229, 174, 229, 175, 229, 176, 229, 177, 229, 178, 229, 179, 229, 180, 229, 181, 229, 182, 229, 183, 229, 184, 229, 185, 229, 186, 229, 187, 229, 188, 229, 189, 229, 190, 229, 191, 229, 192, 229, 193, 229, 194, 229, 195, 229, 196, 229, 197, 229, 198, 229, 199, 229, 200, 229, 201, 229, 202, 229, 203, 229, 204, 229, 205, 229, 206, 229, 207, 229, 208, 229, 209, 229, 210, 229, 211, 229, 212, 229, 213, 229, 214, 229, 215, 229, 216, 229, 217, 229, 218, 229, 219, 229, 220, 229, 221, 229, 222, 229, 223, 229, 224, 229, 225, 229, 226, 229, 227, 229, 228, 229, 229, 229, 1, 255, 2, 255, 3, 255, 229, 255, 5, 255, 6, 255, 7, 255, 8, 255, 9, 255, 10, 255, 11, 255, 12, 255, 13, 255, 14, 255, 15, 255, 16, 255, 17, 255, 18, 255, 19, 255, 20, 255, 21, 255, 22, 255, 23, 255, 24, 255, 25, 255, 26, 255, 27, 255, 28, 255, 29, 255, 30, 255, 31, 255, 32, 255, 33, 255, 34, 255, 35, 255, 36, 255, 37, 255, 38, 255, 39, 255, 40, 255, 41, 255, 42, 255, 43, 255, 44, 255, 45, 255, 46, 255, 47, 255, 48, 255, 49, 255, 50, 255, 51, 255, 52, 255, 53, 255, 54, 255, 55, 255, 56, 255, 57, 255, 58, 255, 59, 255, 60, 255, 61, 255, 62, 255, 63, 255, 64, 255, 65, 255, 66, 255, 67, 255, 68, 255, 69, 255, 70, 255, 71, 255, 72, 255, 73, 255, 74, 255, 75, 255, 76, 255, 77, 255, 78, 255, 79, 255, 80, 255, 81, 255, 82, 255, 83, 255, 84, 255, 85, 255, 86, 255, 87, 255, 88, 255, 89, 255, 90, 255, 91, 255, 92, 255, 93, 255, 227, 255, 230, 229, 231, 229, 232, 229, 233, 229, 234, 229, 235, 229, 236, 229, 237, 229, 238, 229, 239, 229, 240, 229, 241, 229, 242, 229, 243, 229, 244, 229, 245, 229, 246, 229, 247, 229, 248, 229, 249, 229, 250, 229, 251, 229, 252, 229, 253, 229, 254, 229, 255, 229, 0, 230, 1, 230, 2, 230, 3, 230, 4, 230, 5, 230, 6, 230, 7, 230, 8, 230, 9, 230, 10, 230, 11, 230, 12, 230, 13, 230, 14, 230, 15, 230, 16, 230, 17, 230, 18, 230, 19, 230, 20, 230, 21, 230, 22, 230, 23, 230, 24, 230, 25, 230, 26, 230, 27, 230, 28, 230, 29, 230, 30, 230, 31, 230, 32, 230, 33, 230, 34, 230, 35, 230, 36, 230, 37, 230, 38, 230, 39, 230, 40, 230, 41, 230, 42, 230, 43, 230, 44, 230, 45, 230, 46, 230, 47, 230, 48, 230, 49, 230, 50, 230, 51, 230, 52, 230, 53, 230, 54, 230, 55, 230, 56, 230, 57, 230, 58, 230, 59, 230, 60, 230, 61, 230, 62, 230, 63, 230, 64, 230, 65, 230, 66, 230, 67, 230, 68, 230, 69, 230, 65, 48, 66, 48, 67, 48, 68, 48, 69, 48, 70, 48, 71, 48, 72, 48, 73, 48, 74, 48, 75, 48, 76, 48, 77, 48, 78, 48, 79, 48, 80, 48, 81, 48, 82, 48, 83, 48, 84, 48, 85, 48, 86, 48, 87, 48, 88, 48, 89, 48, 90, 48, 91, 48, 92, 48, 93, 48, 94, 48, 95, 48, 96, 48, 97, 48, 98, 48, 99, 48, 100, 48, 101, 48, 102, 48, 103, 48, 104, 48, 105, 48, 106, 48, 107, 48, 108, 48, 109, 48, 110, 48, 111, 48, 112, 48, 113, 48, 114, 48, 115, 48, 116, 48, 117, 48, 118, 48, 119, 48, 120, 48, 121, 48, 122, 48, 123, 48, 124, 48, 125, 48, 126, 48, 127, 48, 128, 48, 129, 48, 130, 48, 131, 48, 132, 48, 133, 48, 134, 48, 135, 48, 136, 48, 137, 48, 138, 48, 139, 48, 140, 48, 141, 48, 142, 48, 143, 48, 144, 48, 145, 48, 146, 48, 147, 48, 114, 231, 115, 231, 116, 231, 117, 231, 118, 231, 119, 231, 120, 231, 121, 231, 122, 231, 123, 231, 124, 231, 70, 230, 71, 230, 72, 230, 73, 230, 74, 230, 75, 230, 76, 230, 77, 230, 78, 230, 79, 230, 80, 230, 81, 230, 82, 230, 83, 230, 84, 230, 85, 230, 86, 230, 87, 230, 88, 230, 89, 230, 90, 230, 91, 230, 92, 230, 93, 230, 94, 230, 95, 230, 96, 230, 97, 230, 98, 230, 99, 230, 100, 230, 101, 230, 102, 230, 103, 230, 104, 230, 105, 230, 106, 230, 107, 230, 108, 230, 109, 230, 110, 230, 111, 230, 112, 230, 113, 230, 114, 230, 115, 230, 116, 230, 117, 230, 118, 230, 119, 230, 120, 230, 121, 230, 122, 230, 123, 230, 124, 230, 125, 230, 126, 230, 127, 230, 128, 230, 129, 230, 130, 230, 131, 230, 132, 230, 133, 230, 134, 230, 135, 230, 136, 230, 137, 230, 138, 230, 139, 230, 140, 230, 141, 230, 142, 230, 143, 230, 144, 230, 145, 230, 146, 230, 147, 230, 148, 230, 149, 230, 150, 230, 151, 230, 152, 230, 153, 230, 154, 230, 155, 230, 156, 230, 157, 230, 158, 230, 159, 230, 160, 230, 161, 230, 162, 230, 163, 230, 164, 230, 165, 230, 161, 48, 162, 48, 163, 48, 164, 48, 165, 48, 166, 48, 167, 48, 168, 48, 169, 48, 170, 48, 171, 48, 172, 48, 173, 48, 174, 48, 175, 48, 176, 48, 177, 48, 178, 48, 179, 48, 180, 48, 181, 48, 182, 48, 183, 48, 184, 48, 185, 48, 186, 48, 187, 48, 188, 48, 189, 48, 190, 48, 191, 48, 192, 48, 193, 48, 194, 48, 195, 48, 196, 48, 197, 48, 198, 48, 199, 48, 200, 48, 201, 48, 202, 48, 203, 48, 204, 48, 205, 48, 206, 48, 207, 48, 208, 48, 209, 48, 210, 48, 211, 48, 212, 48, 213, 48, 214, 48, 215, 48, 216, 48, 217, 48, 218, 48, 219, 48, 220, 48, 221, 48, 222, 48, 223, 48, 224, 48, 225, 48, 226, 48, 227, 48, 228, 48, 229, 48, 230, 48, 231, 48, 232, 48, 233, 48, 234, 48, 235, 48, 236, 48, 237, 48, 238, 48, 239, 48, 240, 48, 241, 48, 242, 48, 243, 48, 244, 48, 245, 48, 246, 48, 125, 231, 126, 231, 127, 231, 128, 231, 129, 231, 130, 231, 131, 231, 132, 231, 166, 230, 167, 230, 168, 230, 169, 230, 170, 230, 171, 230, 172, 230, 173, 230, 174, 230, 175, 230, 176, 230, 177, 230, 178, 230, 179, 230, 180, 230, 181, 230, 182, 230, 183, 230, 184, 230, 185, 230, 186, 230, 187, 230, 188, 230, 189, 230, 190, 230, 191, 230, 192, 230, 193, 230, 194, 230, 195, 230, 196, 230, 197, 230, 198, 230, 199, 230, 200, 230, 201, 230, 202, 230, 203, 230, 204, 230, 205, 230, 206, 230, 207, 230, 208, 230, 209, 230, 210, 230, 211, 230, 212, 230, 213, 230, 214, 230, 215, 230, 216, 230, 217, 230, 218, 230, 219, 230, 220, 230, 221, 230, 222, 230, 223, 230, 224, 230, 225, 230, 226, 230, 227, 230, 228, 230, 229, 230, 230, 230, 231, 230, 232, 230, 233, 230, 234, 230, 235, 230, 236, 230, 237, 230, 238, 230, 239, 230, 240, 230, 241, 230, 242, 230, 243, 230, 244, 230, 245, 230, 246, 230, 247, 230, 248, 230, 249, 230, 250, 230, 251, 230, 252, 230, 253, 230, 254, 230, 255, 230, 0, 231, 1, 231, 2, 231, 3, 231, 4, 231, 5, 231, 145, 3, 146, 3, 147, 3, 148, 3, 149, 3, 150, 3, 151, 3, 152, 3, 153, 3, 154, 3, 155, 3, 156, 3, 157, 3, 158, 3, 159, 3, 160, 3, 161, 3, 163, 3, 164, 3, 165, 3, 166, 3, 167, 3, 168, 3, 169, 3, 133, 231, 134, 231, 135, 231, 136, 231, 137, 231, 138, 231, 139, 231, 140, 231, 177, 3, 178, 3, 179, 3, 180, 3, 181, 3, 182, 3, 183, 3, 184, 3, 185, 3, 186, 3, 187, 3, 188, 3, 189, 3, 190, 3, 191, 3, 192, 3, 193, 3, 195, 3, 196, 3, 197, 3, 198, 3, 199, 3, 200, 3, 201, 3, 141, 231, 142, 231, 143, 231, 144, 231, 145, 231, 146, 231, 147, 231, 53, 254, 54, 254, 57, 254, 58, 254, 63, 254, 64, 254, 61, 254, 62, 254, 65, 254, 66, 254, 67, 254, 68, 254, 148, 231, 149, 231, 59, 254, 60, 254, 55, 254, 56, 254, 49, 254, 150, 231, 51, 254, 52, 254, 151, 231, 152, 231, 153, 231, 154, 231, 155, 231, 156, 231, 157, 231, 158, 231, 159, 231, 6, 231, 7, 231, 8, 231, 9, 231, 10, 231, 11, 231, 12, 231, 13, 231, 14, 231, 15, 231, 16, 231, 17, 231, 18, 231, 19, 231, 20, 231, 21, 231, 22, 231, 23, 231, 24, 231, 25, 231, 26, 231, 27, 231, 28, 231, 29, 231, 30, 231, 31, 231, 32, 231, 33, 231, 34, 231, 35, 231, 36, 231, 37, 231, 38, 231, 39, 231, 40, 231, 41, 231, 42, 231, 43, 231, 44, 231, 45, 231, 46, 231, 47, 231, 48, 231, 49, 231, 50, 231, 51, 231, 52, 231, 53, 231, 54, 231, 55, 231, 56, 231, 57, 231, 58, 231, 59, 231, 60, 231, 61, 231, 62, 231, 63, 231, 64, 231, 65, 231, 66, 231, 67, 231, 68, 231, 69, 231, 70, 231, 71, 231, 72, 231, 73, 231, 74, 231, 75, 231, 76, 231, 77, 231, 78, 231, 79, 231, 80, 231, 81, 231, 82, 231, 83, 231, 84, 231, 85, 231, 86, 231, 87, 231, 88, 231, 89, 231, 90, 231, 91, 231, 92, 231, 93, 231, 94, 231, 95, 231, 96, 231, 97, 231, 98, 231, 99, 231, 100, 231, 101, 231, 16, 4, 17, 4, 18, 4, 19, 4, 20, 4, 21, 4, 1, 4, 22, 4, 23, 4, 24, 4, 25, 4, 26, 4, 27, 4, 28, 4, 29, 4, 30, 4, 31, 4, 32, 4, 33, 4, 34, 4, 35, 4, 36, 4, 37, 4, 38, 4, 39, 4, 40, 4, 41, 4, 42, 4, 43, 4, 44, 4, 45, 4, 46, 4, 47, 4, 160, 231, 161, 231, 162, 231, 163, 231, 164, 231, 165, 231, 166, 231, 167, 231, 168, 231, 169, 231, 170, 231, 171, 231, 172, 231, 173, 231, 174, 231, 48, 4, 49, 4, 50, 4, 51, 4, 52, 4, 53, 4, 81, 4, 54, 4, 55, 4, 56, 4, 57, 4, 58, 4, 59, 4, 60, 4, 61, 4, 62, 4, 63, 4, 64, 4, 65, 4, 66, 4, 67, 4, 68, 4, 69, 4, 70, 4, 71, 4, 72, 4, 73, 4, 74, 4, 75, 4, 76, 4, 77, 4, 78, 4, 79, 4, 175, 231, 176, 231, 177, 231, 178, 231, 179, 231, 180, 231, 181, 231, 182, 231, 183, 231, 184, 231, 185, 231, 186, 231, 187, 231, 202, 2, 203, 2, 217, 2, 19, 32, 21, 32, 37, 32, 53, 32, 5, 33, 9, 33, 150, 33, 151, 33, 152, 33, 153, 33, 21, 34, 31, 34, 35, 34, 82, 34, 102, 34, 103, 34, 191, 34, 80, 37, 81, 37, 82, 37, 83, 37, 84, 37, 85, 37, 86, 37, 87, 37, 88, 37, 89, 37, 90, 37, 91, 37, 92, 37, 93, 37, 94, 37, 95, 37, 96, 37, 97, 37, 98, 37, 99, 37, 100, 37, 101, 37, 102, 37, 103, 37, 104, 37, 105, 37, 106, 37, 107, 37, 108, 37, 109, 37, 110, 37, 111, 37, 112, 37, 113, 37, 114, 37, 115, 37, 129, 37, 130, 37, 131, 37, 132, 37, 133, 37, 134, 37, 135, 37, 136, 37, 137, 37, 138, 37, 139, 37, 140, 37, 141, 37, 142, 37, 143, 37, 147, 37, 148, 37, 149, 37, 188, 37, 189, 37, 226, 37, 227, 37, 228, 37, 229, 37, 9, 38, 149, 34, 18, 48, 29, 48, 30, 48, 188, 231, 189, 231, 190, 231, 191, 231, 192, 231, 193, 231, 194, 231, 195, 231, 196, 231, 197, 231, 198, 231, 1, 1, 225, 0, 206, 1, 224, 0, 19, 1, 233, 0, 27, 1, 232, 0, 43, 1, 237, 0, 208, 1, 236, 0, 77, 1, 243, 0, 210, 1, 242, 0, 107, 1, 250, 0, 212, 1, 249, 0, 214, 1, 216, 1, 218, 1, 220, 1, 252, 0, 234, 0, 81, 2, 199, 231, 68, 1, 72, 1, 249, 1, 97, 2, 201, 231, 202, 231, 203, 231, 204, 231, 5, 49, 6, 49, 7, 49, 8, 49, 9, 49, 10, 49, 11, 49, 12, 49, 13, 49, 14, 49, 15, 49, 16, 49, 17, 49, 18, 49, 19, 49, 20, 49, 21, 49, 22, 49, 23, 49, 24, 49, 25, 49, 26, 49, 27, 49, 28, 49, 29, 49, 30, 49, 31, 49, 32, 49, 33, 49, 34, 49, 35, 49, 36, 49, 37, 49, 38, 49, 39, 49, 40, 49, 41, 49, 205, 231, 206, 231, 207, 231, 208, 231, 209, 231, 210, 231, 211, 231, 212, 231, 213, 231, 214, 231, 215, 231, 216, 231, 217, 231, 218, 231, 219, 231, 220, 231, 221, 231, 222, 231, 223, 231, 224, 231, 225, 231, 33, 48, 34, 48, 35, 48, 36, 48, 37, 48, 38, 48, 39, 48, 40, 48, 41, 48, 163, 50, 142, 51, 143, 51, 156, 51, 157, 51, 158, 51, 161, 51, 196, 51, 206, 51, 209, 51, 210, 51, 213, 51, 48, 254, 226, 255, 228, 255, 226, 231, 33, 33, 49, 50, 227, 231, 16, 32, 228, 231, 229, 231, 230, 231, 252, 48, 155, 48, 156, 48, 253, 48, 254, 48, 6, 48, 157, 48, 158, 48, 73, 254, 74, 254, 75, 254, 76, 254, 77, 254, 78, 254, 79, 254, 80, 254, 81, 254, 82, 254, 84, 254, 85, 254, 86, 254, 87, 254, 89, 254, 90, 254, 91, 254, 92, 254, 93, 254, 94, 254, 95, 254, 96, 254, 97, 254, 98, 254, 99, 254, 100, 254, 101, 254, 102, 254, 104, 254, 105, 254, 106, 254, 107, 254, 62, 48, 240, 47, 241, 47, 242, 47, 243, 47, 244, 47, 245, 47, 246, 47, 247, 47, 248, 47, 249, 47, 250, 47, 251, 47, 7, 48, 244, 231, 245, 231, 246, 231, 247, 231, 248, 231, 249, 231, 250, 231, 251, 231, 252, 231, 253, 231, 254, 231, 255, 231, 0, 232, 0, 37, 1, 37, 2, 37, 3, 37, 4, 37, 5, 37, 6, 37, 7, 37, 8, 37, 9, 37, 10, 37, 11, 37, 12, 37, 13, 37, 14, 37, 15, 37, 16, 37, 17, 37, 18, 37, 19, 37, 20, 37, 21, 37, 22, 37, 23, 37, 24, 37, 25, 37, 26, 37, 27, 37, 28, 37, 29, 37, 30, 37, 31, 37, 32, 37, 33, 37, 34, 37, 35, 37, 36, 37, 37, 37, 38, 37, 39, 37, 40, 37, 41, 37, 42, 37, 43, 37, 44, 37, 45, 37, 46, 37, 47, 37, 48, 37, 49, 37, 50, 37, 51, 37, 52, 37, 53, 37, 54, 37, 55, 37, 56, 37, 57, 37, 58, 37, 59, 37, 60, 37, 61, 37, 62, 37, 63, 37, 64, 37, 65, 37, 66, 37, 67, 37, 68, 37, 69, 37, 70, 37, 71, 37, 72, 37, 73, 37, 74, 37, 75, 37, 1, 232, 2, 232, 3, 232, 4, 232, 5, 232, 6, 232, 7, 232, 8, 232, 9, 232, 10, 232, 11, 232, 12, 232, 13, 232, 14, 232, 15, 232, 220, 114, 221, 114, 223, 114, 226, 114, 227, 114, 228, 114, 229, 114, 230, 114, 231, 114, 234, 114, 235, 114, 245, 114, 246, 114, 249, 114, 253, 114, 254, 114, 255, 114, 0, 115, 2, 115, 4, 115, 5, 115, 6, 115, 7, 115, 8, 115, 9, 115, 11, 115, 12, 115, 13, 115, 15, 115, 16, 115, 17, 115, 18, 115, 20, 115, 24, 115, 25, 115, 26, 115, 31, 115, 32, 115, 35, 115, 36, 115, 38, 115, 39, 115, 40, 115, 45, 115, 47, 115, 48, 115, 50, 115, 51, 115, 53, 115, 54, 115, 58, 115, 59, 115, 60, 115, 61, 115, 64, 115, 65, 115, 66, 115, 67, 115, 68, 115, 69, 115, 70, 115, 71, 115, 72, 115, 73, 115, 74, 115, 75, 115, 76, 115, 78, 115, 79, 115, 81, 115, 83, 115, 84, 115, 85, 115, 86, 115, 88, 115, 89, 115, 90, 115, 91, 115, 92, 115, 93, 115, 94, 115, 95, 115, 97, 115, 98, 115, 99, 115, 100, 115, 101, 115, 102, 115, 103, 115, 104, 115, 105, 115, 106, 115, 107, 115, 110, 115, 112, 115, 113, 115, 0, 224, 1, 224, 2, 224, 3, 224, 4, 224, 5, 224, 6, 224, 7, 224, 8, 224, 9, 224, 10, 224, 11, 224, 12, 224, 13, 224, 14, 224, 15, 224, 16, 224, 17, 224, 18, 224, 19, 224, 20, 224, 21, 224, 22, 224, 23, 224, 24, 224, 25, 224, 26, 224, 27, 224, 28, 224, 29, 224, 30, 224, 31, 224, 32, 224, 33, 224, 34, 224, 35, 224, 36, 224, 37, 224, 38, 224, 39, 224, 40, 224, 41, 224, 42, 224, 43, 224, 44, 224, 45, 224, 46, 224, 47, 224, 48, 224, 49, 224, 50, 224, 51, 224, 52, 224, 53, 224, 54, 224, 55, 224, 56, 224, 57, 224, 58, 224, 59, 224, 60, 224, 61, 224, 62, 224, 63, 224, 64, 224, 65, 224, 66, 224, 67, 224, 68, 224, 69, 224, 70, 224, 71, 224, 72, 224, 73, 224, 74, 224, 75, 224, 76, 224, 77, 224, 78, 224, 79, 224, 80, 224, 81, 224, 82, 224, 83, 224, 84, 224, 85, 224, 86, 224, 87, 224, 88, 224, 89, 224, 90, 224, 91, 224, 92, 224, 93, 224, 114, 115, 115, 115, 116, 115, 117, 115, 118, 115, 119, 115, 120, 115, 121, 115, 122, 115, 123, 115, 124, 115, 125, 115, 127, 115, 128, 115, 129, 115, 130, 115, 131, 115, 133, 115, 134, 115, 136, 115, 138, 115, 140, 115, 141, 115, 143, 115, 144, 115, 146, 115, 147, 115, 148, 115, 149, 115, 151, 115, 152, 115, 153, 115, 154, 115, 156, 115, 157, 115, 158, 115, 160, 115, 161, 115, 163, 115, 164, 115, 165, 115, 166, 115, 167, 115, 168, 115, 170, 115, 172, 115, 173, 115, 177, 115, 180, 115, 181, 115, 182, 115, 184, 115, 185, 115, 188, 115, 189, 115, 190, 115, 191, 115, 193, 115, 195, 115, 196, 115, 197, 115, 198, 115, 199, 115, 203, 115, 204, 115, 206, 115, 210, 115, 211, 115, 212, 115, 213, 115, 214, 115, 215, 115, 216, 115, 218, 115, 219, 115, 220, 115, 221, 115, 223, 115, 225, 115, 226, 115, 227, 115, 228, 115, 230, 115, 232, 115, 234, 115, 235, 115, 236, 115, 238, 115, 239, 115, 240, 115, 241, 115, 243, 115, 244, 115, 245, 115, 246, 115, 247, 115, 94, 224, 95, 224, 96, 224, 97, 224, 98, 224, 99, 224, 100, 224, 101, 224, 102, 224, 103, 224, 104, 224, 105, 224, 106, 224, 107, 224, 108, 224, 109, 224, 110, 224, 111, 224, 112, 224, 113, 224, 114, 224, 115, 224, 116, 224, 117, 224, 118, 224, 119, 224, 120, 224, 121, 224, 122, 224, 123, 224, 124, 224, 125, 224, 126, 224, 127, 224, 128, 224, 129, 224, 130, 224, 131, 224, 132, 224, 133, 224, 134, 224, 135, 224, 136, 224, 137, 224, 138, 224, 139, 224, 140, 224, 141, 224, 142, 224, 143, 224, 144, 224, 145, 224, 146, 224, 147, 224, 148, 224, 149, 224, 150, 224, 151, 224, 152, 224, 153, 224, 154, 224, 155, 224, 156, 224, 157, 224, 158, 224, 159, 224, 160, 224, 161, 224, 162, 224, 163, 224, 164, 224, 165, 224, 166, 224, 167, 224, 168, 224, 169, 224, 170, 224, 171, 224, 172, 224, 173, 224, 174, 224, 175, 224, 176, 224, 177, 224, 178, 224, 179, 224, 180, 224, 181, 224, 182, 224, 183, 224, 184, 224, 185, 224, 186, 224, 187, 224, 248, 115, 249, 115, 250, 115, 251, 115, 252, 115, 253, 115, 254, 115, 255, 115, 0, 116, 1, 116, 2, 116, 4, 116, 7, 116, 8, 116, 11, 116, 12, 116, 13, 116, 14, 116, 17, 116, 18, 116, 19, 116, 20, 116, 21, 116, 22, 116, 23, 116, 24, 116, 25, 116, 28, 116, 29, 116, 30, 116, 31, 116, 32, 116, 33, 116, 35, 116, 36, 116, 39, 116, 41, 116, 43, 116, 45, 116, 47, 116, 49, 116, 50, 116, 55, 116, 56, 116, 57, 116, 58, 116, 59, 116, 61, 116, 62, 116, 63, 116, 64, 116, 66, 116, 67, 116, 68, 116, 69, 116, 70, 116, 71, 116, 72, 116, 73, 116, 74, 116, 75, 116, 76, 116, 77, 116, 78, 116, 79, 116, 80, 116, 81, 116, 82, 116, 83, 116, 84, 116, 86, 116, 88, 116, 93, 116, 96, 116, 97, 116, 98, 116, 99, 116, 100, 116, 101, 116, 102, 116, 103, 116, 104, 116, 105, 116, 106, 116, 107, 116, 108, 116, 110, 116, 111, 116, 113, 116, 114, 116, 115, 116, 116, 116, 117, 116, 120, 116, 121, 116, 122, 116, 188, 224, 189, 224, 190, 224, 191, 224, 192, 224, 193, 224, 194, 224, 195, 224, 196, 224, 197, 224, 198, 224, 199, 224, 200, 224, 201, 224, 202, 224, 203, 224, 204, 224, 205, 224, 206, 224, 207, 224, 208, 224, 209, 224, 210, 224, 211, 224, 212, 224, 213, 224, 214, 224, 215, 224, 216, 224, 217, 224, 218, 224, 219, 224, 220, 224, 221, 224, 222, 224, 223, 224, 224, 224, 225, 224, 226, 224, 227, 224, 228, 224, 229, 224, 230, 224, 231, 224, 232, 224, 233, 224, 234, 224, 235, 224, 236, 224, 237, 224, 238, 224, 239, 224, 240, 224, 241, 224, 242, 224, 243, 224, 244, 224, 245, 224, 246, 224, 247, 224, 248, 224, 249, 224, 250, 224, 251, 224, 252, 224, 253, 224, 254, 224, 255, 224, 0, 225, 1, 225, 2, 225, 3, 225, 4, 225, 5, 225, 6, 225, 7, 225, 8, 225, 9, 225, 10, 225, 11, 225, 12, 225, 13, 225, 14, 225, 15, 225, 16, 225, 17, 225, 18, 225, 19, 225, 20, 225, 21, 225, 22, 225, 23, 225, 24, 225, 25, 225, 123, 116, 124, 116, 125, 116, 127, 116, 130, 116, 132, 116, 133, 116, 134, 116, 136, 116, 137, 116, 138, 116, 140, 116, 141, 116, 143, 116, 145, 116, 146, 116, 147, 116, 148, 116, 149, 116, 150, 116, 151, 116, 152, 116, 153, 116, 154, 116, 155, 116, 157, 116, 159, 116, 160, 116, 161, 116, 162, 116, 163, 116, 164, 116, 165, 116, 166, 116, 170, 116, 171, 116, 172, 116, 173, 116, 174, 116, 175, 116, 176, 116, 177, 116, 178, 116, 179, 116, 180, 116, 181, 116, 182, 116, 183, 116, 184, 116, 185, 116, 187, 116, 188, 116, 189, 116, 190, 116, 191, 116, 192, 116, 193, 116, 194, 116, 195, 116, 196, 116, 197, 116, 198, 116, 199, 116, 200, 116, 201, 116, 202, 116, 203, 116, 204, 116, 205, 116, 206, 116, 207, 116, 208, 116, 209, 116, 211, 116, 212, 116, 213, 116, 214, 116, 215, 116, 216, 116, 217, 116, 218, 116, 219, 116, 221, 116, 223, 116, 225, 116, 229, 116, 231, 116, 232, 116, 233, 116, 234, 116, 235, 116, 236, 116, 237, 116, 240, 116, 241, 116, 242, 116, 26, 225, 27, 225, 28, 225, 29, 225, 30, 225, 31, 225, 32, 225, 33, 225, 34, 225, 35, 225, 36, 225, 37, 225, 38, 225, 39, 225, 40, 225, 41, 225, 42, 225, 43, 225, 44, 225, 45, 225, 46, 225, 47, 225, 48, 225, 49, 225, 50, 225, 51, 225, 52, 225, 53, 225, 54, 225, 55, 225, 56, 225, 57, 225, 58, 225, 59, 225, 60, 225, 61, 225, 62, 225, 63, 225, 64, 225, 65, 225, 66, 225, 67, 225, 68, 225, 69, 225, 70, 225, 71, 225, 72, 225, 73, 225, 74, 225, 75, 225, 76, 225, 77, 225, 78, 225, 79, 225, 80, 225, 81, 225, 82, 225, 83, 225, 84, 225, 85, 225, 86, 225, 87, 225, 88, 225, 89, 225, 90, 225, 91, 225, 92, 225, 93, 225, 94, 225, 95, 225, 96, 225, 97, 225, 98, 225, 99, 225, 100, 225, 101, 225, 102, 225, 103, 225, 104, 225, 105, 225, 106, 225, 107, 225, 108, 225, 109, 225, 110, 225, 111, 225, 112, 225, 113, 225, 114, 225, 115, 225, 116, 225, 117, 225, 118, 225, 119, 225, 243, 116, 245, 116, 248, 116, 249, 116, 250, 116, 251, 116, 252, 116, 253, 116, 254, 116, 0, 117, 1, 117, 2, 117, 3, 117, 5, 117, 6, 117, 7, 117, 8, 117, 9, 117, 10, 117, 11, 117, 12, 117, 14, 117, 16, 117, 18, 117, 20, 117, 21, 117, 22, 117, 23, 117, 27, 117, 29, 117, 30, 117, 32, 117, 33, 117, 34, 117, 35, 117, 36, 117, 38, 117, 39, 117, 42, 117, 46, 117, 52, 117, 54, 117, 57, 117, 60, 117, 61, 117, 63, 117, 65, 117, 66, 117, 67, 117, 68, 117, 70, 117, 71, 117, 73, 117, 74, 117, 77, 117, 80, 117, 81, 117, 82, 117, 83, 117, 85, 117, 86, 117, 87, 117, 88, 117, 93, 117, 94, 117, 95, 117, 96, 117, 97, 117, 98, 117, 99, 117, 100, 117, 103, 117, 104, 117, 105, 117, 107, 117, 108, 117, 109, 117, 110, 117, 111, 117, 112, 117, 113, 117, 115, 117, 117, 117, 118, 117, 119, 117, 122, 117, 123, 117, 124, 117, 125, 117, 126, 117, 128, 117, 129, 117, 130, 117, 132, 117, 133, 117, 135, 117, 120, 225, 121, 225, 122, 225, 123, 225, 124, 225, 125, 225, 126, 225, 127, 225, 128, 225, 129, 225, 130, 225, 131, 225, 132, 225, 133, 225, 134, 225, 135, 225, 136, 225, 137, 225, 138, 225, 139, 225, 140, 225, 141, 225, 142, 225, 143, 225, 144, 225, 145, 225, 146, 225, 147, 225, 148, 225, 149, 225, 150, 225, 151, 225, 152, 225, 153, 225, 154, 225, 155, 225, 156, 225, 157, 225, 158, 225, 159, 225, 160, 225, 161, 225, 162, 225, 163, 225, 164, 225, 165, 225, 166, 225, 167, 225, 168, 225, 169, 225, 170, 225, 171, 225, 172, 225, 173, 225, 174, 225, 175, 225, 176, 225, 177, 225, 178, 225, 179, 225, 180, 225, 181, 225, 182, 225, 183, 225, 184, 225, 185, 225, 186, 225, 187, 225, 188, 225, 189, 225, 190, 225, 191, 225, 192, 225, 193, 225, 194, 225, 195, 225, 196, 225, 197, 225, 198, 225, 199, 225, 200, 225, 201, 225, 202, 225, 203, 225, 204, 225, 205, 225, 206, 225, 207, 225, 208, 225, 209, 225, 210, 225, 211, 225, 212, 225, 213, 225, 136, 117, 137, 117, 138, 117, 140, 117, 141, 117, 142, 117, 144, 117, 147, 117, 149, 117, 152, 117, 155, 117, 156, 117, 158, 117, 162, 117, 166, 117, 167, 117, 168, 117, 169, 117, 170, 117, 173, 117, 182, 117, 183, 117, 186, 117, 187, 117, 191, 117, 192, 117, 193, 117, 198, 117, 203, 117, 204, 117, 206, 117, 207, 117, 208, 117, 209, 117, 211, 117, 215, 117, 217, 117, 218, 117, 220, 117, 221, 117, 223, 117, 224, 117, 225, 117, 229, 117, 233, 117, 236, 117, 237, 117, 238, 117, 239, 117, 242, 117, 243, 117, 245, 117, 246, 117, 247, 117, 248, 117, 250, 117, 251, 117, 253, 117, 254, 117, 2, 118, 4, 118, 6, 118, 7, 118, 8, 118, 9, 118, 11, 118, 13, 118, 14, 118, 15, 118, 17, 118, 18, 118, 19, 118, 20, 118, 22, 118, 26, 118, 28, 118, 29, 118, 30, 118, 33, 118, 35, 118, 39, 118, 40, 118, 44, 118, 46, 118, 47, 118, 49, 118, 50, 118, 54, 118, 55, 118, 57, 118, 58, 118, 59, 118, 61, 118, 65, 118, 66, 118, 68, 118, 214, 225, 215, 225, 216, 225, 217, 225, 218, 225, 219, 225, 220, 225, 221, 225, 222, 225, 223, 225, 224, 225, 225, 225, 226, 225, 227, 225, 228, 225, 229, 225, 230, 225, 231, 225, 232, 225, 233, 225, 234, 225, 235, 225, 236, 225, 237, 225, 238, 225, 239, 225, 240, 225, 241, 225, 242, 225, 243, 225, 244, 225, 245, 225, 246, 225, 247, 225, 248, 225, 249, 225, 250, 225, 251, 225], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 230588);
	        allocate([252, 225, 253, 225, 254, 225, 255, 225, 0, 226, 1, 226, 2, 226, 3, 226, 4, 226, 5, 226, 6, 226, 7, 226, 8, 226, 9, 226, 10, 226, 11, 226, 12, 226, 13, 226, 14, 226, 15, 226, 16, 226, 17, 226, 18, 226, 19, 226, 20, 226, 21, 226, 22, 226, 23, 226, 24, 226, 25, 226, 26, 226, 27, 226, 28, 226, 29, 226, 30, 226, 31, 226, 32, 226, 33, 226, 34, 226, 35, 226, 36, 226, 37, 226, 38, 226, 39, 226, 40, 226, 41, 226, 42, 226, 43, 226, 44, 226, 45, 226, 46, 226, 47, 226, 48, 226, 49, 226, 50, 226, 51, 226, 69, 118, 70, 118, 71, 118, 72, 118, 73, 118, 74, 118, 75, 118, 78, 118, 79, 118, 80, 118, 81, 118, 82, 118, 83, 118, 85, 118, 87, 118, 88, 118, 89, 118, 90, 118, 91, 118, 93, 118, 95, 118, 96, 118, 97, 118, 98, 118, 100, 118, 101, 118, 102, 118, 103, 118, 104, 118, 105, 118, 106, 118, 108, 118, 109, 118, 110, 118, 112, 118, 113, 118, 114, 118, 115, 118, 116, 118, 117, 118, 118, 118, 119, 118, 121, 118, 122, 118, 124, 118, 127, 118, 128, 118, 129, 118, 131, 118, 133, 118, 137, 118, 138, 118, 140, 118, 141, 118, 143, 118, 144, 118, 146, 118, 148, 118, 149, 118, 151, 118, 152, 118, 154, 118, 155, 118, 156, 118, 157, 118, 158, 118, 159, 118, 160, 118, 161, 118, 162, 118, 163, 118, 165, 118, 166, 118, 167, 118, 168, 118, 169, 118, 170, 118, 171, 118, 172, 118, 173, 118, 175, 118, 176, 118, 179, 118, 181, 118, 182, 118, 183, 118, 184, 118, 185, 118, 186, 118, 187, 118, 188, 118, 189, 118, 190, 118, 192, 118, 193, 118, 195, 118, 74, 85, 63, 150, 195, 87, 40, 99, 206, 84, 9, 85, 192, 84, 145, 118, 76, 118, 60, 133, 238, 119, 126, 130, 141, 120, 49, 114, 152, 150, 141, 151, 40, 108, 137, 91, 250, 79, 9, 99, 151, 102, 184, 92, 250, 128, 72, 104, 174, 128, 2, 102, 206, 118, 249, 81, 86, 101, 172, 113, 241, 127, 132, 136, 178, 80, 101, 89, 202, 97, 179, 111, 173, 130, 76, 99, 82, 98, 237, 83, 39, 84, 6, 123, 107, 81, 164, 117, 244, 93, 212, 98, 203, 141, 118, 151, 138, 98, 25, 128, 93, 87, 56, 151, 98, 127, 56, 114, 125, 118, 207, 103, 126, 118, 70, 100, 112, 79, 37, 141, 220, 98, 23, 122, 145, 101, 237, 115, 44, 100, 115, 98, 44, 130, 129, 152, 127, 103, 72, 114, 110, 98, 204, 98, 52, 79, 227, 116, 74, 83, 158, 82, 202, 126, 166, 144, 46, 94, 134, 104, 156, 105, 128, 129, 209, 126, 210, 104, 197, 120, 140, 134, 81, 149, 141, 80, 36, 140, 222, 130, 222, 128, 5, 83, 18, 137, 101, 82, 196, 118, 199, 118, 201, 118, 203, 118, 204, 118, 211, 118, 213, 118, 217, 118, 218, 118, 220, 118, 221, 118, 222, 118, 224, 118, 225, 118, 226, 118, 227, 118, 228, 118, 230, 118, 231, 118, 232, 118, 233, 118, 234, 118, 235, 118, 236, 118, 237, 118, 240, 118, 243, 118, 245, 118, 246, 118, 247, 118, 250, 118, 251, 118, 253, 118, 255, 118, 0, 119, 2, 119, 3, 119, 5, 119, 6, 119, 10, 119, 12, 119, 14, 119, 15, 119, 16, 119, 17, 119, 18, 119, 19, 119, 20, 119, 21, 119, 22, 119, 23, 119, 24, 119, 27, 119, 28, 119, 29, 119, 30, 119, 33, 119, 35, 119, 36, 119, 37, 119, 39, 119, 42, 119, 43, 119, 44, 119, 46, 119, 48, 119, 49, 119, 50, 119, 51, 119, 52, 119, 57, 119, 59, 119, 61, 119, 62, 119, 63, 119, 66, 119, 68, 119, 69, 119, 70, 119, 72, 119, 73, 119, 74, 119, 75, 119, 76, 119, 77, 119, 78, 119, 79, 119, 82, 119, 83, 119, 84, 119, 85, 119, 86, 119, 87, 119, 88, 119, 89, 119, 92, 119, 132, 133, 249, 150, 221, 79, 33, 88, 113, 153, 157, 91, 177, 98, 165, 98, 180, 102, 121, 140, 141, 156, 6, 114, 111, 103, 145, 120, 178, 96, 81, 83, 23, 83, 136, 143, 204, 128, 29, 141, 161, 148, 13, 80, 200, 114, 7, 89, 235, 96, 25, 113, 171, 136, 84, 89, 239, 130, 44, 103, 40, 123, 41, 93, 247, 126, 45, 117, 245, 108, 102, 142, 248, 143, 60, 144, 59, 159, 212, 107, 25, 145, 20, 123, 124, 95, 167, 120, 214, 132, 61, 133, 213, 107, 217, 107, 214, 107, 1, 94, 135, 94, 249, 117, 237, 149, 93, 101, 10, 95, 197, 95, 159, 143, 193, 88, 194, 129, 127, 144, 91, 150, 173, 151, 185, 143, 22, 127, 44, 141, 65, 98, 191, 79, 216, 83, 94, 83, 168, 143, 169, 143, 171, 143, 77, 144, 7, 104, 106, 95, 152, 129, 104, 136, 214, 156, 139, 97, 43, 82, 42, 118, 108, 95, 140, 101, 210, 111, 232, 110, 190, 91, 72, 100, 117, 81, 176, 81, 196, 103, 25, 78, 201, 121, 124, 153, 179, 112, 93, 119, 94, 119, 95, 119, 96, 119, 100, 119, 103, 119, 105, 119, 106, 119, 109, 119, 110, 119, 111, 119, 112, 119, 113, 119, 114, 119, 115, 119, 116, 119, 117, 119, 118, 119, 119, 119, 120, 119, 122, 119, 123, 119, 124, 119, 129, 119, 130, 119, 131, 119, 134, 119, 135, 119, 136, 119, 137, 119, 138, 119, 139, 119, 143, 119, 144, 119, 147, 119, 148, 119, 149, 119, 150, 119, 151, 119, 152, 119, 153, 119, 154, 119, 155, 119, 156, 119, 157, 119, 158, 119, 161, 119, 163, 119, 164, 119, 166, 119, 168, 119, 171, 119, 173, 119, 174, 119, 175, 119, 177, 119, 178, 119, 180, 119, 182, 119, 183, 119, 184, 119, 185, 119, 186, 119, 188, 119, 190, 119, 192, 119, 193, 119, 194, 119, 195, 119, 196, 119, 197, 119, 198, 119, 199, 119, 200, 119, 201, 119, 202, 119, 203, 119, 204, 119, 206, 119, 207, 119, 208, 119, 209, 119, 210, 119, 211, 119, 212, 119, 213, 119, 214, 119, 216, 119, 217, 119, 218, 119, 221, 119, 222, 119, 223, 119, 224, 119, 225, 119, 228, 119, 197, 117, 118, 94, 187, 115, 224, 131, 173, 100, 232, 98, 181, 148, 226, 108, 90, 83, 195, 82, 15, 100, 194, 148, 148, 123, 47, 79, 27, 94, 54, 130, 22, 129, 138, 129, 36, 110, 202, 108, 115, 154, 85, 99, 92, 83, 250, 84, 101, 136, 224, 87, 13, 78, 3, 94, 101, 107, 63, 124, 232, 144, 22, 96, 230, 100, 28, 115, 193, 136, 80, 103, 77, 98, 34, 141, 108, 119, 41, 142, 199, 145, 105, 95, 220, 131, 33, 133, 16, 153, 194, 83, 149, 134, 139, 107, 237, 96, 232, 96, 127, 112, 205, 130, 49, 130, 211, 78, 167, 108, 207, 133, 205, 100, 217, 124, 253, 105, 249, 102, 73, 131, 149, 83, 86, 123, 167, 79, 140, 81, 75, 109, 66, 92, 109, 142, 210, 99, 201, 83, 44, 131, 54, 131, 229, 103, 180, 120, 61, 100, 223, 91, 148, 92, 238, 93, 231, 139, 198, 98, 244, 103, 122, 140, 0, 100, 186, 99, 73, 135, 139, 153, 23, 140, 32, 127, 242, 148, 167, 78, 16, 150, 164, 152, 12, 102, 22, 115, 230, 119, 232, 119, 234, 119, 239, 119, 240, 119, 241, 119, 242, 119, 244, 119, 245, 119, 247, 119, 249, 119, 250, 119, 251, 119, 252, 119, 3, 120, 4, 120, 5, 120, 6, 120, 7, 120, 8, 120, 10, 120, 11, 120, 14, 120, 15, 120, 16, 120, 19, 120, 21, 120, 25, 120, 27, 120, 30, 120, 32, 120, 33, 120, 34, 120, 36, 120, 40, 120, 42, 120, 43, 120, 46, 120, 47, 120, 49, 120, 50, 120, 51, 120, 53, 120, 54, 120, 61, 120, 63, 120, 65, 120, 66, 120, 67, 120, 68, 120, 70, 120, 72, 120, 73, 120, 74, 120, 75, 120, 77, 120, 79, 120, 81, 120, 83, 120, 84, 120, 88, 120, 89, 120, 90, 120, 91, 120, 92, 120, 94, 120, 95, 120, 96, 120, 97, 120, 98, 120, 99, 120, 100, 120, 101, 120, 102, 120, 103, 120, 104, 120, 105, 120, 111, 120, 112, 120, 113, 120, 114, 120, 115, 120, 116, 120, 117, 120, 118, 120, 120, 120, 121, 120, 122, 120, 123, 120, 125, 120, 126, 120, 127, 120, 128, 120, 129, 120, 130, 120, 131, 120, 58, 87, 29, 92, 56, 94, 127, 149, 127, 80, 160, 128, 130, 83, 94, 101, 69, 117, 49, 85, 33, 80, 133, 141, 132, 98, 158, 148, 29, 103, 50, 86, 110, 111, 226, 93, 53, 84, 146, 112, 102, 143, 111, 98, 164, 100, 163, 99, 123, 95, 136, 111, 244, 144, 227, 129, 176, 143, 24, 92, 104, 102, 241, 95, 137, 108, 72, 150, 129, 141, 108, 136, 145, 100, 240, 121, 206, 87, 89, 106, 16, 98, 72, 84, 88, 78, 11, 122, 233, 96, 132, 111, 218, 139, 127, 98, 30, 144, 139, 154, 228, 121, 3, 84, 244, 117, 1, 99, 25, 83, 96, 108, 223, 143, 27, 95, 112, 154, 59, 128, 127, 159, 136, 79, 58, 92, 100, 141, 197, 127, 165, 101, 189, 112, 69, 81, 178, 81, 107, 134, 7, 93, 160, 91, 189, 98, 108, 145, 116, 117, 12, 142, 32, 122, 1, 97, 121, 123, 199, 78, 248, 126, 133, 119, 17, 78, 237, 129, 29, 82, 250, 81, 113, 106, 168, 83, 135, 142, 4, 149, 207, 150, 193, 110, 100, 150, 90, 105, 132, 120, 133, 120, 134, 120, 136, 120, 138, 120, 139, 120, 143, 120, 144, 120, 146, 120, 148, 120, 149, 120, 150, 120, 153, 120, 157, 120, 158, 120, 160, 120, 162, 120, 164, 120, 166, 120, 168, 120, 169, 120, 170, 120, 171, 120, 172, 120, 173, 120, 174, 120, 175, 120, 181, 120, 182, 120, 183, 120, 184, 120, 186, 120, 187, 120, 188, 120, 189, 120, 191, 120, 192, 120, 194, 120, 195, 120, 196, 120, 198, 120, 199, 120, 200, 120, 204, 120, 205, 120, 206, 120, 207, 120, 209, 120, 210, 120, 211, 120, 214, 120, 215, 120, 216, 120, 218, 120, 219, 120, 220, 120, 221, 120, 222, 120, 223, 120, 224, 120, 225, 120, 226, 120, 227, 120, 228, 120, 229, 120, 230, 120, 231, 120, 233, 120, 234, 120, 235, 120, 237, 120, 238, 120, 239, 120, 240, 120, 241, 120, 243, 120, 245, 120, 246, 120, 248, 120, 249, 120, 251, 120, 252, 120, 253, 120, 254, 120, 255, 120, 0, 121, 2, 121, 3, 121, 4, 121, 6, 121, 7, 121, 8, 121, 9, 121, 10, 121, 11, 121, 12, 121, 64, 120, 168, 80, 215, 119, 16, 100, 230, 137, 4, 89, 227, 99, 221, 93, 127, 122, 61, 105, 32, 79, 57, 130, 152, 85, 50, 78, 174, 117, 151, 122, 98, 94, 138, 94, 239, 149, 27, 82, 57, 84, 138, 112, 118, 99, 36, 149, 130, 87, 37, 102, 63, 105, 135, 145, 7, 85, 243, 109, 175, 126, 34, 136, 51, 98, 240, 126, 181, 117, 40, 131, 193, 120, 204, 150, 158, 143, 72, 97, 247, 116, 205, 139, 100, 107, 58, 82, 80, 141, 33, 107, 106, 128, 113, 132, 241, 86, 6, 83, 206, 78, 27, 78, 209, 81, 151, 124, 139, 145, 7, 124, 195, 79, 127, 142, 225, 123, 156, 122, 103, 100, 20, 93, 172, 80, 6, 129, 1, 118, 185, 124, 236, 109, 224, 127, 81, 103, 88, 91, 248, 91, 203, 120, 174, 100, 19, 100, 170, 99, 43, 99, 25, 149, 45, 100, 190, 143, 84, 123, 41, 118, 83, 98, 39, 89, 70, 84, 121, 107, 163, 80, 52, 98, 38, 94, 134, 107, 227, 78, 55, 141, 139, 136, 133, 95, 46, 144, 13, 121, 14, 121, 15, 121, 16, 121, 17, 121, 18, 121, 20, 121, 21, 121, 22, 121, 23, 121, 24, 121, 25, 121, 26, 121, 27, 121, 28, 121, 29, 121, 31, 121, 32, 121, 33, 121, 34, 121, 35, 121, 37, 121, 38, 121, 39, 121, 40, 121, 41, 121, 42, 121, 43, 121, 44, 121, 45, 121, 46, 121, 47, 121, 48, 121, 49, 121, 50, 121, 51, 121, 53, 121, 54, 121, 55, 121, 56, 121, 57, 121, 61, 121, 63, 121, 66, 121, 67, 121, 68, 121, 69, 121, 71, 121, 74, 121, 75, 121, 76, 121, 77, 121, 78, 121, 79, 121, 80, 121, 81, 121, 82, 121, 84, 121, 85, 121, 88, 121, 89, 121, 97, 121, 99, 121, 100, 121, 102, 121, 105, 121, 106, 121, 107, 121, 108, 121, 110, 121, 112, 121, 113, 121, 114, 121, 115, 121, 116, 121, 117, 121, 118, 121, 121, 121, 123, 121, 124, 121, 125, 121, 126, 121, 127, 121, 130, 121, 131, 121, 134, 121, 135, 121, 136, 121, 137, 121, 139, 121, 140, 121, 141, 121, 142, 121, 144, 121, 145, 121, 146, 121, 32, 96, 61, 128, 197, 98, 57, 78, 85, 83, 248, 144, 184, 99, 198, 128, 230, 101, 46, 108, 70, 79, 238, 96, 225, 109, 222, 139, 57, 95, 203, 134, 83, 95, 33, 99, 90, 81, 97, 131, 99, 104, 0, 82, 99, 99, 72, 142, 18, 80, 155, 92, 119, 121, 252, 91, 48, 82, 59, 122, 188, 96, 83, 144, 215, 118, 183, 95, 151, 95, 132, 118, 108, 142, 111, 112, 123, 118, 73, 123, 170, 119, 243, 81, 147, 144, 36, 88, 78, 79, 244, 110, 234, 143, 76, 101, 27, 123, 196, 114, 164, 109, 223, 127, 225, 90, 181, 98, 149, 94, 48, 87, 130, 132, 44, 123, 29, 94, 31, 95, 18, 144, 20, 127, 160, 152, 130, 99, 199, 110, 152, 120, 185, 112, 120, 81, 91, 151, 171, 87, 53, 117, 67, 79, 56, 117, 151, 94, 230, 96, 96, 89, 192, 109, 191, 107, 137, 120, 252, 83, 213, 150, 203, 81, 1, 82, 137, 99, 10, 84, 147, 148, 3, 140, 204, 141, 57, 114, 159, 120, 118, 135, 237, 143, 13, 140, 224, 83, 147, 121, 148, 121, 149, 121, 150, 121, 151, 121, 152, 121, 153, 121, 155, 121, 156, 121, 157, 121, 158, 121, 159, 121, 160, 121, 161, 121, 162, 121, 163, 121, 164, 121, 165, 121, 166, 121, 168, 121, 169, 121, 170, 121, 171, 121, 172, 121, 173, 121, 174, 121, 175, 121, 176, 121, 177, 121, 178, 121, 180, 121, 181, 121, 182, 121, 183, 121, 184, 121, 188, 121, 191, 121, 194, 121, 196, 121, 197, 121, 199, 121, 200, 121, 202, 121, 204, 121, 206, 121, 207, 121, 208, 121, 211, 121, 212, 121, 214, 121, 215, 121, 217, 121, 218, 121, 219, 121, 220, 121, 221, 121, 222, 121, 224, 121, 225, 121, 226, 121, 229, 121, 232, 121, 234, 121, 236, 121, 238, 121, 241, 121, 242, 121, 243, 121, 244, 121, 245, 121, 246, 121, 247, 121, 249, 121, 250, 121, 252, 121, 254, 121, 255, 121, 1, 122, 4, 122, 5, 122, 7, 122, 8, 122, 9, 122, 10, 122, 12, 122, 15, 122, 16, 122, 17, 122, 18, 122, 19, 122, 21, 122, 22, 122, 24, 122, 25, 122, 27, 122, 28, 122, 1, 78, 239, 118, 238, 83, 137, 148, 118, 152, 14, 159, 45, 149, 154, 91, 162, 139, 34, 78, 28, 78, 172, 81, 99, 132, 194, 97, 168, 82, 11, 104, 151, 79, 107, 96, 187, 81, 30, 109, 92, 81, 150, 98, 151, 101, 97, 150, 70, 140, 23, 144, 216, 117, 253, 144, 99, 119, 210, 107, 138, 114, 236, 114, 251, 139, 53, 88, 121, 119, 76, 141, 92, 103, 64, 149, 154, 128, 166, 94, 33, 110, 146, 89, 239, 122, 237, 119, 59, 149, 181, 107, 173, 101, 14, 127, 6, 88, 81, 81, 31, 150, 249, 91, 169, 88, 40, 84, 114, 142, 102, 101, 127, 152, 228, 86, 157, 148, 254, 118, 65, 144, 135, 99, 198, 84, 26, 89, 58, 89, 155, 87, 178, 142, 53, 103, 250, 141, 53, 130, 65, 82, 240, 96, 21, 88, 254, 134, 232, 92, 69, 158, 196, 79, 157, 152, 185, 139, 37, 90, 118, 96, 132, 83, 124, 98, 79, 144, 2, 145, 127, 153, 105, 96, 12, 128, 63, 81, 51, 128, 20, 92, 117, 153, 49, 109, 140, 78, 29, 122, 31, 122, 33, 122, 34, 122, 36, 122, 37, 122, 38, 122, 39, 122, 40, 122, 41, 122, 42, 122, 43, 122, 44, 122, 45, 122, 46, 122, 47, 122, 48, 122, 49, 122, 50, 122, 52, 122, 53, 122, 54, 122, 56, 122, 58, 122, 62, 122, 64, 122, 65, 122, 66, 122, 67, 122, 68, 122, 69, 122, 71, 122, 72, 122, 73, 122, 74, 122, 75, 122, 76, 122, 77, 122, 78, 122, 79, 122, 80, 122, 82, 122, 83, 122, 84, 122, 85, 122, 86, 122, 88, 122, 89, 122, 90, 122, 91, 122, 92, 122, 93, 122, 94, 122, 95, 122, 96, 122, 97, 122, 98, 122, 99, 122, 100, 122, 101, 122, 102, 122, 103, 122, 104, 122, 105, 122, 106, 122, 107, 122, 108, 122, 109, 122, 110, 122, 111, 122, 113, 122, 114, 122, 115, 122, 117, 122, 123, 122, 124, 122, 125, 122, 126, 122, 130, 122, 133, 122, 135, 122, 137, 122, 138, 122, 139, 122, 140, 122, 142, 122, 143, 122, 144, 122, 147, 122, 148, 122, 153, 122, 154, 122, 155, 122, 158, 122, 161, 122, 162, 122, 48, 141, 209, 83, 90, 127, 79, 123, 16, 79, 79, 78, 0, 150, 213, 108, 208, 115, 233, 133, 6, 94, 106, 117, 251, 127, 10, 106, 254, 119, 146, 148, 65, 126, 225, 81, 230, 112, 205, 83, 212, 143, 3, 131, 41, 141, 175, 114, 109, 153, 219, 108, 74, 87, 179, 130, 185, 101, 170, 128, 63, 98, 50, 150, 168, 89, 255, 78, 191, 139, 186, 126, 62, 101, 242, 131, 94, 151, 97, 85, 222, 152, 165, 128, 42, 83, 253, 139, 32, 84, 186, 128, 159, 94, 184, 108, 57, 141, 172, 130, 90, 145, 41, 84, 27, 108, 6, 82, 183, 126, 95, 87, 26, 113, 126, 108, 137, 124, 75, 89, 253, 78, 255, 95, 36, 97, 170, 124, 48, 78, 1, 92, 171, 103, 2, 135, 240, 92, 11, 149, 206, 152, 175, 117, 253, 112, 34, 144, 175, 81, 29, 127, 189, 139, 73, 89, 228, 81, 91, 79, 38, 84, 43, 89, 119, 101, 164, 128, 117, 91, 118, 98, 194, 98, 144, 143, 69, 94, 31, 108, 38, 123, 15, 79, 216, 79, 13, 103, 163, 122, 164, 122, 167, 122, 169, 122, 170, 122, 171, 122, 174, 122, 175, 122, 176, 122, 177, 122, 178, 122, 180, 122, 181, 122, 182, 122, 183, 122, 184, 122, 185, 122, 186, 122, 187, 122, 188, 122, 189, 122, 190, 122, 192, 122, 193, 122, 194, 122, 195, 122, 196, 122, 197, 122, 198, 122, 199, 122, 200, 122, 201, 122, 202, 122, 204, 122, 205, 122, 206, 122, 207, 122, 208, 122, 209, 122, 210, 122, 211, 122, 212, 122, 213, 122, 215, 122, 216, 122, 218, 122, 219, 122, 220, 122, 221, 122, 225, 122, 226, 122, 228, 122, 231, 122, 232, 122, 233, 122, 234, 122, 235, 122, 236, 122, 238, 122, 240, 122, 241, 122, 242, 122, 243, 122, 244, 122, 245, 122, 246, 122, 247, 122, 248, 122, 251, 122, 252, 122, 254, 122, 0, 123, 1, 123, 2, 123, 5, 123, 7, 123, 9, 123, 12, 123, 13, 123, 14, 123, 16, 123, 18, 123, 19, 123, 22, 123, 23, 123, 24, 123, 26, 123, 28, 123, 29, 123, 31, 123, 33, 123, 34, 123, 35, 123, 39, 123, 41, 123, 45, 123, 110, 109, 170, 109, 143, 121, 177, 136, 23, 95, 43, 117, 154, 98, 133, 143, 239, 79, 220, 145, 167, 101, 47, 129, 81, 129, 156, 94, 80, 129, 116, 141, 111, 82, 134, 137, 75, 141, 13, 89, 133, 80, 216, 78, 28, 150, 54, 114, 121, 129, 31, 141, 204, 91, 163, 139, 68, 150, 135, 89, 26, 127, 144, 84, 118, 86, 14, 86, 229, 139, 57, 101, 130, 105, 153, 148, 214, 118, 137, 110, 114, 94, 24, 117, 70, 103, 209, 103, 255, 122, 157, 128, 118, 141, 31, 97, 198, 121, 98, 101, 99, 141, 136, 81, 26, 82, 162, 148, 56, 127, 155, 128, 178, 126, 151, 92, 47, 110, 96, 103, 217, 123, 139, 118, 216, 154, 143, 129, 148, 127, 213, 124, 30, 100, 80, 149, 63, 122, 74, 84, 229, 84, 76, 107, 1, 100, 8, 98, 61, 158, 243, 128, 153, 117, 114, 82, 105, 151, 91, 132, 60, 104, 228, 134, 1, 150, 148, 150, 236, 148, 42, 78, 4, 84, 217, 126, 57, 104, 223, 141, 21, 128, 244, 102, 154, 94, 185, 127, 47, 123, 48, 123, 50, 123, 52, 123, 53, 123, 54, 123, 55, 123, 57, 123, 59, 123, 61, 123, 63, 123, 64, 123, 65, 123, 66, 123, 67, 123, 68, 123, 70, 123, 72, 123, 74, 123, 77, 123, 78, 123, 83, 123, 85, 123, 87, 123, 89, 123, 92, 123, 94, 123, 95, 123, 97, 123, 99, 123, 100, 123, 101, 123, 102, 123, 103, 123, 104, 123, 105, 123, 106, 123, 107, 123, 108, 123, 109, 123, 111, 123, 112, 123, 115, 123, 116, 123, 118, 123, 120, 123, 122, 123, 124, 123, 125, 123, 127, 123, 129, 123, 130, 123, 131, 123, 132, 123, 134, 123, 135, 123, 136, 123, 137, 123, 138, 123, 139, 123, 140, 123, 142, 123, 143, 123, 145, 123, 146, 123, 147, 123, 150, 123, 152, 123, 153, 123, 154, 123, 155, 123, 158, 123, 159, 123, 160, 123, 163, 123, 164, 123, 165, 123, 174, 123, 175, 123, 176, 123, 178, 123, 179, 123, 181, 123, 182, 123, 183, 123, 185, 123, 186, 123, 187, 123, 188, 123, 189, 123, 190, 123, 191, 123, 192, 123, 194, 123, 195, 123, 196, 123, 194, 87, 63, 128, 151, 104, 229, 93, 59, 101, 159, 82, 109, 96, 154, 159, 155, 79, 172, 142, 108, 81, 171, 91, 19, 95, 233, 93, 94, 108, 241, 98, 33, 141, 113, 81, 169, 148, 254, 82, 159, 108, 223, 130, 215, 114, 162, 87, 132, 103, 45, 141, 31, 89, 156, 143, 199, 131, 149, 84, 141, 123, 48, 79, 189, 108, 100, 91, 209, 89, 19, 159, 228, 83, 202, 134, 168, 154, 55, 140, 161, 128, 69, 101, 126, 152, 250, 86, 199, 150, 46, 82, 220, 116, 80, 82, 225, 91, 2, 99, 2, 137, 86, 78, 208, 98, 42, 96, 250, 104, 115, 81, 152, 91, 160, 81, 194, 137, 161, 123, 134, 153, 80, 127, 239, 96, 76, 112, 47, 141, 73, 81, 127, 94, 27, 144, 112, 116, 196, 137, 45, 87, 69, 120, 82, 95, 159, 159, 250, 149, 104, 143, 60, 155, 225, 139, 120, 118, 66, 104, 220, 103, 234, 141, 53, 141, 61, 82, 138, 143, 218, 110, 205, 104, 5, 149, 237, 144, 253, 86, 156, 103, 249, 136, 199, 143, 200, 84, 197, 123, 200, 123, 201, 123, 202, 123, 203, 123, 205, 123, 206, 123, 207, 123, 208, 123, 210, 123, 212, 123, 213, 123, 214, 123, 215, 123, 216, 123, 219, 123, 220, 123, 222, 123, 223, 123, 224, 123, 226, 123, 227, 123, 228, 123, 231, 123, 232, 123, 233, 123, 235, 123, 236, 123, 237, 123, 239, 123, 240, 123, 242, 123, 243, 123, 244, 123, 245, 123, 246, 123, 248, 123, 249, 123, 250, 123, 251, 123, 253, 123, 255, 123, 0, 124, 1, 124, 2, 124, 3, 124, 4, 124, 5, 124, 6, 124, 8, 124, 9, 124, 10, 124, 13, 124, 14, 124, 16, 124, 17, 124, 18, 124, 19, 124, 20, 124, 21, 124, 23, 124, 24, 124, 25, 124, 26, 124, 27, 124, 28, 124, 29, 124, 30, 124, 32, 124, 33, 124, 34, 124, 35, 124, 36, 124, 37, 124, 40, 124, 41, 124, 43, 124, 44, 124, 45, 124, 46, 124, 47, 124, 48, 124, 49, 124, 50, 124, 51, 124, 52, 124, 53, 124, 54, 124, 55, 124, 57, 124, 58, 124, 59, 124, 60, 124, 61, 124, 62, 124, 66, 124, 184, 154, 105, 91, 119, 109, 38, 108, 165, 78, 179, 91, 135, 154, 99, 145, 168, 97, 175, 144, 233, 151, 43, 84, 181, 109, 210, 91, 253, 81, 138, 85, 85, 127, 240, 127, 188, 100, 77, 99, 241, 101, 190, 97, 141, 96, 10, 113, 87, 108, 73, 108, 47, 89, 109, 103, 42, 130, 213, 88, 142, 86, 106, 140, 235, 107, 221, 144, 125, 89, 23, 128, 247, 83, 105, 109, 117, 84, 157, 85, 119, 131, 207, 131, 56, 104, 190, 121, 140, 84, 85, 79, 8, 84, 210, 118, 137, 140, 2, 150, 179, 108, 184, 109, 107, 141, 16, 137, 100, 158, 58, 141, 63, 86, 209, 158, 213, 117, 136, 95, 224, 114, 104, 96, 252, 84, 168, 78, 42, 106, 97, 136, 82, 96, 112, 143, 196, 84, 216, 112, 121, 134, 63, 158, 42, 109, 143, 91, 24, 95, 162, 126, 137, 85, 175, 79, 52, 115, 60, 84, 154, 83, 25, 80, 14, 84, 124, 84, 78, 78, 253, 95, 90, 116, 246, 88, 107, 132, 225, 128, 116, 135, 208, 114, 202, 124, 86, 110, 67, 124, 68, 124, 69, 124, 70, 124, 71, 124, 72, 124, 73, 124, 74, 124, 75, 124, 76, 124, 78, 124, 79, 124, 80, 124, 81, 124, 82, 124, 83, 124, 84, 124, 85, 124, 86, 124, 87, 124, 88, 124, 89, 124, 90, 124, 91, 124, 92, 124, 93, 124, 94, 124, 95, 124, 96, 124, 97, 124, 98, 124, 99, 124, 100, 124, 101, 124, 102, 124, 103, 124, 104, 124, 105, 124, 106, 124, 107, 124, 108, 124, 109, 124, 110, 124, 111, 124, 112, 124, 113, 124, 114, 124, 117, 124, 118, 124, 119, 124, 120, 124, 121, 124, 122, 124, 126, 124, 127, 124, 128, 124, 129, 124, 130, 124, 131, 124, 132, 124, 133, 124, 134, 124, 135, 124, 136, 124, 138, 124, 139, 124, 140, 124, 141, 124, 142, 124, 143, 124, 144, 124, 147, 124, 148, 124, 150, 124, 153, 124, 154, 124, 155, 124, 160, 124, 161, 124, 163, 124, 166, 124, 167, 124, 168, 124, 169, 124, 171, 124, 172, 124, 173, 124, 175, 124, 176, 124, 180, 124, 181, 124, 182, 124, 183, 124, 184, 124, 186, 124, 187, 124, 39, 95, 78, 134, 44, 85, 164, 98, 146, 78, 170, 108, 55, 98, 177, 130, 215, 84, 78, 83, 62, 115, 209, 110, 59, 117, 18, 82, 22, 83, 221, 139, 208, 105, 138, 95, 0, 96, 238, 109, 79, 87, 34, 107, 175, 115, 83, 104, 216, 143, 19, 127, 98, 99, 163, 96, 36, 85, 234, 117, 98, 140, 21, 113, 163, 109, 166, 91, 123, 94, 82, 131, 76, 97, 196, 158, 250, 120, 87, 135, 39, 124, 135, 118, 240, 81, 246, 96, 76, 113, 67, 102, 76, 94, 77, 96, 14, 140, 112, 112, 37, 99, 137, 143, 189, 95, 98, 96, 212, 134, 222, 86, 193, 107, 148, 96, 103, 97, 73, 83, 224, 96, 102, 102, 63, 141, 253, 121, 26, 79, 233, 112, 71, 108, 179, 139, 242, 139, 216, 126, 100, 131, 15, 102, 90, 90, 66, 155, 81, 109, 247, 109, 65, 140, 59, 109, 25, 79, 107, 112, 183, 131, 22, 98, 209, 96, 13, 151, 39, 141, 120, 121, 251, 81, 62, 87, 250, 87, 58, 103, 120, 117, 61, 122, 239, 121, 149, 123, 191, 124, 192, 124, 194, 124, 195, 124, 196, 124, 198, 124, 201, 124, 203, 124, 206, 124, 207, 124, 208, 124, 209, 124, 210, 124, 211, 124, 212, 124, 216, 124, 218, 124, 219, 124, 221, 124, 222, 124, 225, 124, 226, 124, 227, 124, 228, 124, 229, 124, 230, 124, 231, 124, 233, 124, 234, 124, 235, 124, 236, 124, 237, 124, 238, 124, 240, 124, 241, 124, 242, 124, 243, 124, 244, 124, 245, 124, 246, 124, 247, 124, 249, 124, 250, 124, 252, 124, 253, 124, 254, 124, 255, 124, 0, 125, 1, 125, 2, 125, 3, 125, 4, 125, 5, 125, 6, 125, 7, 125, 8, 125, 9, 125, 11, 125, 12, 125, 13, 125, 14, 125, 15, 125, 16, 125, 17, 125, 18, 125, 19, 125, 20, 125, 21, 125, 22, 125, 23, 125, 24, 125, 25, 125, 26, 125, 27, 125, 28, 125, 29, 125, 30, 125, 31, 125, 33, 125, 35, 125, 36, 125, 37, 125, 38, 125, 40, 125, 41, 125, 42, 125, 44, 125, 45, 125, 46, 125, 48, 125, 49, 125, 50, 125, 51, 125, 52, 125, 53, 125, 54, 125, 140, 128, 101, 153, 249, 143, 192, 111, 165, 139, 33, 158, 236, 89, 233, 126, 9, 127, 9, 84, 129, 103, 216, 104, 145, 143, 77, 124, 198, 150, 202, 83, 37, 96, 190, 117, 114, 108, 115, 83, 201, 90, 167, 126, 36, 99, 224, 81, 10, 129, 241, 93, 223, 132, 128, 98, 128, 81, 99, 91, 14, 79, 109, 121, 66, 82, 184, 96, 78, 109, 196, 91, 194, 91, 161, 139, 176, 139, 226, 101, 204, 95, 69, 150, 147, 89, 231, 126, 170, 126, 9, 86, 183, 103, 57, 89, 115, 79, 182, 91, 160, 82, 90, 131, 138, 152, 62, 141, 50, 117, 190, 148, 71, 80, 60, 122, 247, 78, 182, 103, 126, 154, 193, 90, 124, 107, 209, 118, 90, 87, 22, 92, 58, 123, 244, 149, 78, 113, 124, 81, 169, 128, 112, 130, 120, 89, 4, 127, 39, 131, 192, 104, 236, 103, 177, 120, 119, 120, 227, 98, 97, 99, 128, 123, 237, 79, 106, 82, 207, 81, 80, 131, 219, 105, 116, 146, 245, 141, 49, 141, 193, 137, 46, 149, 173, 123, 246, 78, 55, 125, 56, 125, 57, 125, 58, 125, 59, 125, 60, 125, 61, 125, 62, 125, 63, 125, 64, 125, 65, 125, 66, 125, 67, 125, 68, 125, 69, 125, 70, 125, 71, 125, 72, 125, 73, 125, 74, 125, 75, 125, 76, 125, 77, 125, 78, 125, 79, 125, 80, 125, 81, 125, 82, 125, 83, 125, 84, 125, 85, 125, 86, 125, 87, 125, 88, 125, 89, 125, 90, 125, 91, 125, 92, 125, 93, 125, 94, 125, 95, 125, 96, 125, 97, 125, 98, 125, 99, 125, 100, 125, 101, 125, 102, 125, 103, 125, 104, 125, 105, 125, 106, 125, 107, 125, 108, 125, 109, 125, 111, 125, 112, 125, 113, 125, 114, 125, 115, 125, 116, 125, 117, 125, 118, 125, 120, 125, 121, 125, 122, 125, 123, 125, 124, 125, 125, 125, 126, 125, 127, 125, 128, 125, 129, 125, 130, 125, 131, 125, 132, 125, 133, 125, 134, 125, 135, 125, 136, 125, 137, 125, 138, 125, 139, 125, 140, 125, 141, 125, 142, 125, 143, 125, 144, 125, 145, 125, 146, 125, 147, 125, 148, 125, 149, 125, 150, 125, 151, 125, 152, 125, 101, 80, 48, 130, 81, 82, 111, 153, 16, 110, 133, 110, 167, 109, 250, 94, 245, 80, 220, 89, 6, 92, 70, 109, 95, 108, 134, 117, 139, 132, 104, 104, 86, 89, 178, 139, 32, 83, 113, 145, 77, 150, 73, 133, 18, 105, 1, 121, 38, 113, 246, 128, 164, 78, 202, 144, 71, 109, 132, 154, 7, 90, 188, 86, 5, 100, 240, 148, 235, 119, 165, 79, 26, 129, 225, 114, 210, 137, 122, 153, 52, 127, 222, 126, 127, 82, 89, 101, 117, 145, 127, 143, 131, 143, 235, 83, 150, 122, 237, 99, 165, 99, 134, 118, 248, 121, 87, 136, 54, 150, 42, 98, 171, 82, 130, 130, 84, 104, 112, 103, 119, 99, 107, 119, 237, 122, 1, 109, 211, 126, 227, 137, 208, 89, 18, 98, 201, 133, 165, 130, 76, 117, 31, 80, 203, 78, 165, 117, 235, 139, 74, 92, 254, 93, 75, 123, 164, 101, 209, 145, 202, 78, 37, 109, 95, 137, 39, 125, 38, 149, 197, 78, 40, 140, 219, 143, 115, 151, 75, 102, 129, 121, 209, 143, 236, 112, 120, 109, 153, 125, 154, 125, 155, 125, 156, 125, 157, 125, 158, 125, 159, 125, 160, 125, 161, 125, 162, 125, 163, 125, 164, 125, 165, 125, 167, 125, 168, 125, 169, 125, 170, 125, 171, 125, 172, 125, 173, 125, 175, 125, 176, 125, 177, 125, 178, 125, 179, 125, 180, 125, 181, 125, 182, 125, 183, 125, 184, 125, 185, 125, 186, 125, 187, 125, 188, 125, 189, 125, 190, 125, 191, 125, 192, 125, 193, 125, 194, 125, 195, 125, 196, 125, 197, 125, 198, 125, 199, 125, 200, 125, 201, 125, 202, 125, 203, 125, 204, 125, 205, 125, 206, 125, 207, 125, 208, 125, 209, 125, 210, 125, 211, 125, 212, 125, 213, 125, 214, 125, 215, 125, 216, 125, 217, 125, 218, 125, 219, 125, 220, 125, 221, 125, 222, 125, 223, 125, 224, 125, 225, 125, 226, 125, 227, 125, 228, 125, 229, 125, 230, 125, 231, 125, 232, 125, 233, 125, 234, 125, 235, 125, 236, 125, 237, 125, 238, 125, 239, 125, 240, 125, 241, 125, 242, 125, 243, 125, 244, 125, 245, 125, 246, 125, 247, 125, 248, 125, 249, 125, 250, 125, 61, 92, 178, 82, 70, 131, 98, 81, 14, 131, 91, 119, 118, 102, 184, 156, 172, 78, 202, 96, 190, 124, 179, 124, 207, 126, 149, 78, 102, 139, 111, 102, 136, 152, 89, 151, 131, 88, 108, 101, 92, 149, 132, 95, 201, 117, 86, 151, 223, 122, 222, 122, 192, 81, 175, 112, 152, 122, 234, 99, 118, 122, 160, 126, 150, 115, 237, 151, 69, 78, 120, 112, 93, 78, 82, 145, 169, 83, 81, 101, 231, 101, 252, 129, 5, 130, 142, 84, 49, 92, 154, 117, 160, 151, 216, 98, 217, 114, 189, 117, 69, 92, 121, 154, 202, 131, 64, 92, 128, 84, 233, 119, 62, 78, 174, 108, 90, 128, 210, 98, 110, 99, 232, 93, 119, 81, 221, 141, 30, 142, 47, 149, 241, 79, 229, 83, 231, 96, 172, 112, 103, 82, 80, 99, 67, 158, 31, 90, 38, 80, 55, 119, 119, 83, 226, 126, 133, 100, 43, 101, 137, 98, 152, 99, 20, 80, 53, 114, 201, 137, 179, 81, 192, 139, 221, 126, 71, 87, 204, 131, 167, 148, 155, 81, 27, 84, 251, 92, 251, 125, 252, 125, 253, 125, 254, 125, 255, 125, 0, 126, 1, 126, 2, 126, 3, 126, 4, 126, 5, 126, 6, 126, 7, 126, 8, 126, 9, 126, 10, 126, 11, 126, 12, 126, 13, 126, 14, 126, 15, 126, 16, 126, 17, 126, 18, 126, 19, 126, 20, 126, 21, 126, 22, 126, 23, 126, 24, 126, 25, 126, 26, 126, 27, 126, 28, 126, 29, 126, 30, 126, 31, 126, 32, 126, 33, 126, 34, 126, 35, 126, 36, 126, 37, 126, 38, 126, 39, 126, 40, 126, 41, 126, 42, 126, 43, 126, 44, 126, 45, 126, 46, 126, 47, 126, 48, 126, 49, 126, 50, 126, 51, 126, 52, 126, 53, 126, 54, 126, 55, 126, 56, 126, 57, 126, 58, 126, 60, 126, 61, 126, 62, 126, 63, 126, 64, 126, 66, 126, 67, 126, 68, 126, 69, 126, 70, 126, 72, 126, 73, 126, 74, 126, 75, 126, 76, 126, 77, 126, 78, 126, 79, 126, 80, 126, 81, 126, 82, 126, 83, 126, 84, 126, 85, 126, 86, 126, 87, 126, 88, 126, 89, 126, 90, 126, 91, 126, 92, 126, 93, 126, 202, 79, 227, 122, 90, 109, 225, 144, 143, 154, 128, 85, 150, 84, 97, 83, 175, 84, 0, 95, 233, 99, 119, 105, 239, 81, 104, 97, 10, 82, 42, 88, 216, 82, 78, 87, 13, 120, 11, 119, 183, 94, 119, 97, 224, 124, 91, 98, 151, 98, 162, 78, 149, 112, 3, 128, 247, 98, 228, 112, 96, 151, 119, 87, 219, 130, 239, 103, 245, 104, 213, 120, 151, 152, 209, 121, 243, 88, 179, 84, 239, 83, 52, 110, 75, 81, 59, 82, 162, 91, 254, 139, 175, 128, 67, 85, 166, 87, 115, 96, 81, 87, 45, 84, 122, 122, 80, 96, 84, 91, 167, 99, 160, 98, 227, 83, 99, 98, 199, 91, 175, 103, 237, 84, 159, 122, 230, 130, 119, 145, 147, 94, 228, 136, 56, 89, 174, 87, 14, 99, 232, 141, 239, 128, 87, 87, 119, 123, 169, 79, 235, 95, 189, 91, 62, 107, 33, 83, 80, 123, 194, 114, 70, 104, 255, 119, 54, 119, 247, 101, 181, 81, 143, 78, 212, 118, 191, 92, 165, 122, 117, 132, 78, 89, 65, 155, 128, 80, 94, 126, 95, 126, 96, 126, 97, 126, 98, 126, 99, 126, 100, 126, 101, 126, 102, 126, 103, 126, 104, 126, 105, 126, 106, 126, 107, 126, 108, 126, 109, 126, 110, 126, 111, 126, 112, 126, 113, 126, 114, 126, 115, 126, 116, 126, 117, 126, 118, 126, 119, 126, 120, 126, 121, 126, 122, 126, 123, 126, 124, 126, 125, 126, 126, 126, 127, 126, 128, 126, 129, 126, 131, 126, 132, 126, 133, 126, 134, 126, 135, 126, 136, 126, 137, 126, 138, 126, 139, 126, 140, 126, 141, 126, 142, 126, 143, 126, 144, 126, 145, 126, 146, 126, 147, 126, 148, 126, 149, 126, 150, 126, 151, 126, 152, 126, 153, 126, 154, 126, 156, 126, 157, 126, 158, 126, 174, 126, 180, 126, 187, 126, 188, 126, 214, 126, 228, 126, 236, 126, 249, 126, 10, 127, 16, 127, 30, 127, 55, 127, 57, 127, 59, 127, 60, 127, 61, 127, 62, 127, 63, 127, 64, 127, 65, 127, 67, 127, 70, 127, 71, 127, 72, 127, 73, 127, 74, 127, 75, 127, 76, 127, 77, 127, 78, 127, 79, 127, 82, 127, 83, 127, 136, 153, 39, 97, 131, 110, 100, 87, 6, 102, 70, 99, 240, 86, 236, 98, 105, 98, 211, 94, 20, 150, 131, 87, 201, 98, 135, 85, 33, 135, 74, 129, 163, 143, 102, 85, 177, 131, 101, 103, 86, 141, 221, 132, 106, 90, 15, 104, 230, 98, 238, 123, 17, 150, 112, 81, 156, 111, 48, 140, 253, 99, 200, 137, 210, 97, 6, 127, 194, 112, 229, 110, 5, 116, 148, 105, 252, 114, 202, 94, 206, 144, 23, 103, 106, 109, 94, 99, 179, 82, 98, 114, 1, 128, 108, 79, 229, 89, 106, 145, 217, 112, 157, 109, 210, 82, 80, 78, 247, 150, 109, 149, 126, 133, 202, 120, 47, 125, 33, 81, 146, 87, 194, 100, 139, 128, 123, 124, 234, 108, 241, 104, 94, 105, 183, 81, 152, 83, 168, 104, 129, 114, 206, 158, 241, 123, 248, 114, 187, 121, 19, 111, 6, 116, 78, 103, 204, 145, 164, 156, 60, 121, 137, 131, 84, 131, 15, 84, 23, 104, 61, 78, 137, 83, 177, 82, 62, 120, 134, 83, 41, 82, 136, 80, 139, 79, 208, 79, 86, 127, 89, 127, 91, 127, 92, 127, 93, 127, 94, 127, 96, 127, 99, 127, 100, 127, 101, 127, 102, 127, 103, 127, 107, 127, 108, 127, 109, 127, 111, 127, 112, 127, 115, 127, 117, 127, 118, 127, 119, 127, 120, 127, 122, 127, 123, 127, 124, 127, 125, 127, 127, 127, 128, 127, 130, 127, 131, 127, 132, 127, 133, 127, 134, 127, 135, 127, 136, 127, 137, 127, 139, 127, 141, 127, 143, 127, 144, 127, 145, 127, 146, 127, 147, 127, 149, 127, 150, 127, 151, 127, 152, 127, 153, 127, 155, 127, 156, 127, 160, 127, 162, 127, 163, 127, 165, 127, 166, 127, 168, 127, 169, 127, 170, 127, 171, 127, 172, 127, 173, 127, 174, 127, 177, 127, 179, 127, 180, 127, 181, 127, 182, 127, 183, 127, 186, 127, 187, 127, 190, 127, 192, 127, 194, 127, 195, 127, 196, 127, 198, 127, 199, 127, 200, 127, 201, 127, 203, 127, 205, 127, 207, 127, 208, 127, 209, 127, 210, 127, 211, 127, 214, 127, 215, 127, 217, 127, 218, 127, 219, 127, 220, 127, 221, 127, 222, 127, 226, 127, 227, 127, 226, 117, 203, 122, 146, 124, 165, 108, 182, 150, 155, 82, 131, 116, 233, 84, 233, 79, 84, 128, 178, 131, 222, 143, 112, 149, 201, 94, 28, 96, 159, 109, 24, 94, 91, 101, 56, 129, 254, 148, 75, 96, 188, 112, 195, 126, 174, 124, 201, 81, 129, 104, 177, 124, 111, 130, 36, 78, 134, 143, 207, 145, 126, 102, 174, 78, 5, 140, 169, 100, 74, 128, 218, 80, 151, 117, 206, 113, 229, 91, 189, 143, 102, 111, 134, 78, 130, 100, 99, 149, 214, 94, 153, 101, 23, 82, 194, 136, 200, 112, 163, 82, 14, 115, 51, 116, 151, 103, 247, 120, 22, 151, 52, 78, 187, 144, 222, 156, 203, 109, 219, 81, 65, 141, 29, 84, 206, 98, 178, 115, 241, 131, 246, 150, 132, 159, 195, 148, 54, 79, 154, 127, 204, 81, 117, 112, 117, 150, 173, 92, 134, 152, 230, 83, 228, 78, 156, 110, 9, 116, 180, 105, 107, 120, 143, 153, 89, 117, 24, 82, 36, 118, 65, 109, 243, 103, 109, 81, 153, 159, 75, 128, 153, 84, 60, 123, 191, 122, 228, 127, 231, 127, 232, 127, 234, 127, 235, 127, 236, 127, 237, 127, 239, 127, 242, 127, 244, 127, 245, 127, 246, 127, 247, 127, 248, 127, 249, 127, 250, 127, 253, 127, 254, 127, 255, 127, 2, 128, 7, 128, 8, 128, 9, 128, 10, 128, 14, 128, 15, 128, 17, 128, 19, 128, 26, 128, 27, 128, 29, 128, 30, 128, 31, 128, 33, 128, 35, 128, 36, 128, 43, 128, 44, 128, 45, 128, 46, 128, 47, 128, 48, 128, 50, 128, 52, 128, 57, 128, 58, 128, 60, 128, 62, 128, 64, 128, 65, 128, 68, 128, 69, 128, 71, 128, 72, 128, 73, 128, 78, 128, 79, 128, 80, 128, 81, 128, 83, 128, 85, 128, 86, 128, 87, 128, 89, 128, 91, 128, 92, 128, 93, 128, 94, 128, 95, 128, 96, 128, 97, 128, 98, 128, 99, 128, 100, 128, 101, 128, 102, 128, 103, 128, 104, 128, 107, 128, 108, 128, 109, 128, 110, 128, 111, 128, 112, 128, 114, 128, 115, 128, 116, 128, 117, 128, 118, 128, 119, 128, 120, 128, 121, 128, 122, 128, 123, 128, 124, 128, 125, 128, 134, 150, 132, 87, 226, 98, 71, 150, 124, 105, 4, 90, 2, 100, 211, 123, 15, 111, 75, 150, 166, 130, 98, 83, 133, 152, 144, 94, 137, 112, 179, 99, 100, 83, 79, 134, 129, 156, 147, 158, 140, 120, 50, 151, 239, 141, 66, 141, 127, 158, 94, 111, 132, 121, 85, 95, 70, 150, 46, 98, 116, 154, 21, 84, 221, 148, 163, 79, 197, 101, 101, 92, 97, 92, 21, 127, 81, 134, 47, 108, 139, 95, 135, 115, 228, 110, 255, 126, 230, 92, 27, 99, 106, 91, 230, 110, 117, 83, 113, 78, 160, 99, 101, 117, 161, 98, 110, 143, 38, 79, 209, 78, 166, 108, 182, 126, 186, 139, 29, 132, 186, 135, 87, 127, 59, 144, 35, 149, 169, 123, 161, 154, 248, 136, 61, 132, 27, 109, 134, 154, 220, 126, 136, 89, 187, 158, 155, 115, 1, 120, 130, 134, 108, 154, 130, 154, 27, 86, 23, 84, 203, 87, 112, 78, 166, 158, 86, 83, 200, 143, 9, 129, 146, 119, 146, 153, 238, 134, 225, 110, 19, 133, 252, 102, 98, 97, 43, 111, 126, 128, 129, 128, 130, 128, 133, 128, 136, 128, 138, 128, 141, 128, 142, 128, 143, 128, 144, 128, 145, 128, 146, 128, 148, 128, 149, 128, 151, 128, 153, 128, 158, 128, 163, 128, 166, 128, 167, 128, 168, 128, 172, 128, 176, 128, 179, 128, 181, 128, 182, 128, 184, 128, 185, 128, 187, 128, 197, 128, 199, 128, 200, 128, 201, 128, 202, 128, 203, 128, 207, 128, 208, 128, 209, 128, 210, 128, 211, 128, 212, 128, 213, 128, 216, 128, 223, 128, 224, 128, 226, 128, 227, 128, 230, 128, 238, 128, 245, 128, 247, 128, 249, 128, 251, 128, 254, 128, 255, 128, 0, 129, 1, 129, 3, 129, 4, 129, 5, 129, 7, 129, 8, 129, 11, 129, 12, 129, 21, 129, 23, 129, 25, 129, 27, 129, 28, 129, 29, 129, 31, 129, 32, 129, 33, 129, 34, 129, 35, 129, 36, 129, 37, 129, 38, 129, 39, 129, 40, 129, 41, 129, 42, 129, 43, 129, 45, 129, 46, 129, 48, 129, 51, 129, 52, 129, 53, 129, 55, 129, 57, 129, 58, 129, 59, 129, 60, 129, 61, 129, 63, 129, 41, 140, 146, 130, 43, 131, 242, 118, 19, 108, 217, 95, 189, 131, 43, 115, 5, 131, 26, 149, 219, 107, 219, 119, 198, 148, 111, 83, 2, 131, 146, 81, 61, 94, 140, 140, 56, 141, 72, 78, 171, 115, 154, 103, 133, 104, 118, 145, 9, 151, 100, 113, 161, 108, 9, 119, 146, 90, 65, 149, 207, 107, 142, 127, 39, 102, 208, 91, 185, 89, 154, 90, 232, 149, 247, 149, 236, 78, 12, 132, 153, 132, 172, 106, 223, 118, 48, 149, 27, 115, 166, 104, 95, 91, 47, 119, 154, 145, 97, 151, 220, 124, 247, 143, 28, 140, 37, 95, 115, 124, 216, 121, 197, 137, 204, 108, 28, 135, 198, 91, 66, 94, 201, 104, 32, 119, 245, 126, 149, 81, 77, 81, 201, 82, 41, 90, 5, 127, 98, 151, 215, 130, 207, 99, 132, 119, 208, 133, 210, 121, 58, 110, 153, 94, 153, 89, 17, 133, 109, 112, 17, 108, 191, 98, 191, 118, 79, 101, 175, 96, 253, 149, 14, 102, 159, 135, 35, 158, 237, 148, 13, 84, 125, 84, 44, 140, 120, 100, 64, 129, 65, 129, 66, 129, 67, 129, 68, 129, 69, 129, 71, 129, 73, 129, 77, 129, 78, 129, 79, 129, 82, 129, 86, 129, 87, 129, 88, 129, 91, 129, 92, 129, 93, 129, 94, 129, 95, 129, 97, 129, 98, 129, 99, 129, 100, 129, 102, 129, 104, 129, 106, 129, 107, 129, 108, 129, 111, 129, 114, 129, 115, 129, 117, 129, 118, 129, 119, 129, 120, 129, 129, 129, 131, 129, 132, 129, 133, 129, 134, 129, 135, 129, 137, 129, 139, 129, 140, 129, 141, 129, 142, 129, 144, 129, 146, 129, 147, 129, 148, 129, 149, 129, 150, 129, 151, 129, 153, 129, 154, 129, 158, 129, 159, 129, 160, 129, 161, 129, 162, 129, 164, 129, 165, 129, 167, 129, 169, 129, 171, 129, 172, 129, 173, 129, 174, 129, 175, 129, 176, 129, 177, 129, 178, 129, 180, 129, 181, 129, 182, 129, 183, 129, 184, 129, 185, 129, 188, 129, 189, 129, 190, 129, 191, 129, 196, 129, 197, 129, 199, 129, 200, 129, 201, 129, 203, 129, 205, 129, 206, 129, 207, 129, 208, 129, 209, 129, 210, 129, 211, 129, 121, 100, 17, 134, 33, 106, 156, 129, 232, 120, 105, 100, 84, 155, 185, 98, 43, 103, 171, 131, 168, 88, 216, 158, 171, 108, 32, 111, 222, 91, 76, 150, 11, 140, 95, 114, 208, 103, 199, 98, 97, 114, 169, 78, 198, 89, 205, 107, 147, 88, 174, 102, 85, 94, 223, 82, 85, 97, 40, 103, 238, 118, 102, 119, 103, 114, 70, 122, 255, 98, 234, 84, 80, 84, 160, 148, 163, 144, 28, 90, 179, 126, 22, 108, 67, 78, 118, 89, 16, 128, 72, 89, 87, 83, 55, 117, 190, 150, 202, 86, 32, 99, 17, 129, 124, 96, 249, 149, 214, 109, 98, 84, 129, 153, 133, 81, 233, 90, 253, 128, 174, 89, 19, 151, 42, 80, 229, 108, 60, 92, 223, 98, 96, 79, 63, 83, 123, 129, 6, 144, 186, 110, 43, 133, 200, 98, 116, 94, 190, 120, 181, 100, 123, 99, 245, 95, 24, 90, 127, 145, 31, 158, 63, 92, 79, 99, 66, 128, 125, 91, 110, 85, 74, 149, 77, 149, 133, 109, 168, 96, 224, 103, 222, 114, 221, 81, 129, 91, 212, 129, 213, 129, 214, 129, 215, 129, 216, 129, 217, 129, 218, 129, 219, 129, 220, 129, 221, 129, 222, 129, 223, 129, 224, 129, 225, 129, 226, 129, 228, 129, 229, 129, 230, 129, 232, 129, 233, 129, 235, 129, 238, 129, 239, 129, 240, 129, 241, 129, 242, 129, 245, 129, 246, 129, 247, 129, 248, 129, 249, 129, 250, 129, 253, 129, 255, 129, 3, 130, 7, 130, 8, 130, 9, 130, 10, 130, 11, 130, 14, 130, 15, 130, 17, 130, 19, 130, 21, 130, 22, 130, 23, 130, 24, 130, 25, 130, 26, 130, 29, 130, 32, 130, 36, 130, 37, 130, 38, 130, 39, 130, 41, 130, 46, 130, 50, 130, 58, 130, 60, 130, 61, 130, 63, 130, 64, 130, 65, 130, 66, 130, 67, 130, 69, 130, 70, 130, 72, 130, 74, 130, 76, 130, 77, 130, 78, 130, 80, 130, 81, 130, 82, 130, 83, 130, 84, 130, 85, 130, 86, 130, 87, 130, 89, 130, 91, 130, 92, 130, 93, 130, 94, 130, 96, 130, 97, 130, 98, 130, 99, 130, 100, 130, 101, 130, 102, 130, 103, 130, 105, 130, 231, 98, 222, 108, 91, 114, 109, 98, 174, 148, 189, 126, 19, 129, 83, 109, 156, 81, 4, 95, 116, 89, 170, 82, 18, 96, 115, 89, 150, 102, 80, 134, 159, 117, 42, 99, 230, 97, 239, 124, 250, 139, 230, 84, 39, 107, 37, 158, 180, 107, 213, 133, 85, 84, 118, 80, 164, 108, 106, 85, 180, 141, 44, 114, 21, 94, 21, 96, 54, 116, 205, 98, 146, 99, 76, 114, 152, 95, 67, 110, 62, 109, 0, 101, 88, 111, 216, 118, 208, 120, 252, 118, 84, 117, 36, 82, 219, 83, 83, 78, 158, 94, 193, 101, 42, 128, 214, 128, 155, 98, 134, 84, 40, 82, 174, 112, 141, 136, 209, 141, 225, 108, 120, 84, 218, 128, 249, 87, 244, 136, 84, 141, 106, 150, 77, 145, 105, 79, 155, 108, 183, 85, 198, 118, 48, 120, 168, 98, 249, 112, 142, 111, 109, 95, 236, 132, 218, 104, 124, 120, 247, 123, 168, 129, 11, 103, 79, 158, 103, 99, 176, 120, 111, 87, 18, 120, 57, 151, 121, 98, 171, 98, 136, 82, 53, 116, 215, 107, 106, 130, 107, 130, 108, 130, 109, 130, 113, 130, 117, 130, 118, 130, 119, 130, 120, 130, 123, 130, 124, 130, 128, 130, 129, 130, 131, 130, 133, 130, 134, 130, 135, 130, 137, 130, 140, 130, 144, 130, 147, 130, 148, 130, 149, 130, 150, 130, 154, 130, 155, 130, 158, 130, 160, 130, 162, 130, 163, 130, 167, 130, 178, 130, 181, 130, 182, 130, 186, 130, 187, 130, 188, 130, 191, 130, 192, 130, 194, 130, 195, 130, 197, 130, 198, 130, 201, 130, 208, 130, 214, 130, 217, 130, 218, 130, 221, 130, 226, 130, 231, 130, 232, 130, 233, 130, 234, 130, 236, 130, 237, 130, 238, 130, 240, 130, 242, 130, 243, 130, 245, 130, 246, 130, 248, 130, 250, 130, 252, 130, 253, 130, 254, 130, 255, 130, 0, 131, 10, 131, 11, 131, 13, 131, 16, 131, 18, 131, 19, 131, 22, 131, 24, 131, 25, 131, 29, 131, 30, 131, 31, 131, 32, 131, 33, 131, 34, 131, 35, 131, 36, 131, 37, 131, 38, 131, 41, 131, 42, 131, 46, 131, 48, 131, 50, 131, 55, 131, 59, 131, 61, 131, 100, 85, 62, 129, 178, 117, 174, 118, 57, 83, 222, 117, 251, 80, 65, 92, 108, 139, 199, 123, 79, 80, 71, 114, 151, 154, 216, 152, 2, 111, 226, 116, 104, 121, 135, 100, 165, 119, 252, 98, 145, 152, 43, 141, 193, 84, 88, 128, 82, 78, 106, 87, 249, 130, 13, 132, 115, 94, 237, 81, 246, 116, 196, 139, 79, 92, 97, 87, 252, 108, 135, 152, 70, 90, 52, 120, 68, 155, 235, 143, 149, 124, 86, 82, 81, 98, 250, 148, 198, 78, 134, 131, 97, 132, 233, 131, 178, 132, 212, 87, 52, 103, 3, 87, 110, 102, 102, 109, 49, 140, 221, 102, 17, 112, 31, 103, 58, 107, 22, 104, 26, 98, 187, 89, 3, 78, 196, 81, 6, 111, 210, 103, 143, 108, 118, 81, 203, 104, 71, 89, 103, 107, 102, 117, 14, 93, 16, 129, 80, 159, 215, 101, 72, 121, 65, 121, 145, 154, 119, 141, 130, 92, 94, 78, 1, 79, 47, 84, 81, 89, 12, 120, 104, 86, 20, 108, 196, 143, 3, 95, 125, 108, 227, 108, 171, 139, 144, 99, 62, 131, 63, 131, 65, 131, 66, 131, 68, 131, 69, 131, 72, 131, 74, 131, 75, 131, 76, 131, 77, 131, 78, 131, 83, 131, 85, 131, 86, 131, 87, 131, 88, 131, 89, 131, 93, 131, 98, 131, 112, 131, 113, 131, 114, 131, 115, 131, 116, 131, 117, 131, 118, 131, 121, 131, 122, 131, 126, 131, 127, 131, 128, 131, 129, 131, 130, 131, 131, 131, 132, 131, 135, 131, 136, 131, 138, 131, 139, 131, 140, 131, 141, 131, 143, 131, 144, 131, 145, 131, 148, 131, 149, 131, 150, 131, 151, 131, 153, 131, 154, 131, 157, 131, 159, 131, 161, 131, 162, 131, 163, 131, 164, 131, 165, 131, 166, 131, 167, 131, 172, 131, 173, 131, 174, 131, 175, 131, 181, 131, 187, 131, 190, 131, 191, 131, 194, 131, 195, 131, 196, 131, 198, 131, 200, 131, 201, 131, 203, 131, 205, 131, 206, 131, 208, 131, 209, 131, 210, 131, 211, 131, 213, 131, 215, 131, 217, 131, 218, 131, 219, 131, 222, 131, 226, 131, 227, 131, 228, 131, 230, 131, 231, 131, 232, 131, 235, 131, 236, 131, 237, 131, 112, 96, 61, 109, 117, 114, 102, 98, 142, 148, 197, 148, 67, 83, 193, 143, 126, 123, 223, 78, 38, 140, 126, 78, 212, 158, 177, 148, 179, 148, 77, 82, 92, 111, 99, 144, 69, 109, 52, 140, 17, 88, 76, 93, 32, 107, 73, 107, 170, 103, 91, 84, 84, 129, 140, 127, 153, 88, 55, 133, 58, 95, 162, 98, 71, 106, 57, 149, 114, 101, 132, 96, 101, 104, 167, 119, 84, 78, 168, 79, 231, 93, 152, 151, 172, 100, 216, 127, 237, 92, 207, 79, 141, 122, 7, 82, 4, 131, 20, 78, 47, 96, 131, 122, 166, 148, 181, 79, 178, 78, 230, 121, 52, 116, 228, 82, 185, 130, 210, 100, 189, 121, 221, 91, 129, 108, 82, 151, 123, 143, 34, 108, 62, 80, 127, 83, 5, 110, 206, 100, 116, 102, 48, 108, 197, 96, 119, 152, 247, 139, 134, 94, 60, 116, 119, 122, 203, 121, 24, 78, 177, 144, 3, 116, 66, 108, 218, 86, 75, 145, 197, 108, 139, 141, 58, 83, 198, 134, 242, 102, 175, 142, 72, 92, 113, 154, 32, 110, 238, 131, 239, 131, 243, 131, 244, 131, 245, 131, 246, 131, 247, 131, 250, 131, 251, 131, 252, 131, 254, 131, 255, 131, 0, 132, 2, 132, 5, 132, 7, 132, 8, 132, 9, 132, 10, 132, 16, 132, 18, 132, 19, 132, 20, 132, 21, 132, 22, 132, 23, 132, 25, 132, 26, 132, 27, 132, 30, 132, 31, 132, 32, 132, 33, 132, 34, 132, 35, 132, 41, 132, 42, 132, 43, 132, 44, 132, 45, 132, 46, 132, 47, 132, 48, 132, 50, 132, 51, 132, 52, 132, 53, 132, 54, 132, 55, 132, 57, 132, 58, 132, 59, 132, 62, 132, 63, 132, 64, 132, 65, 132, 66, 132, 67, 132, 68, 132, 69, 132, 71, 132, 72, 132, 73, 132, 74, 132, 75, 132, 76, 132, 77, 132, 78, 132, 79, 132, 80, 132, 82, 132, 83, 132, 84, 132, 85, 132, 86, 132, 88, 132, 93, 132, 94, 132, 95, 132, 96, 132, 98, 132, 100, 132, 101, 132, 102, 132, 103, 132, 104, 132, 106, 132, 110, 132, 111, 132, 112, 132, 114, 132, 116, 132, 119, 132, 121, 132, 123, 132, 124, 132, 214, 83, 54, 90, 139, 159, 163, 141, 187, 83, 8, 87, 167, 152, 67, 103, 155, 145, 201, 108, 104, 81, 202, 117, 243, 98, 172, 114, 56, 82, 157, 82, 58, 127, 148, 112, 56, 118, 116, 83, 74, 158, 183, 105, 110, 120, 192, 150, 217, 136, 164, 127, 54, 113, 195, 113, 137, 81, 211, 103, 228, 116, 228, 88, 24, 101, 183, 86, 169, 139, 118, 153, 112, 98, 213, 126, 249, 96, 237, 112, 236, 88, 193, 78, 186, 78, 205, 95, 231, 151, 251, 78, 164, 139, 3, 82, 138, 89, 171, 126, 84, 98, 205, 78, 229, 101, 14, 98, 56, 131, 201, 132, 99, 131, 141, 135, 148, 113, 182, 110, 185, 91, 210, 126, 151, 81, 201, 99, 212, 103, 137, 128, 57, 131, 21, 136, 18, 81, 122, 91, 130, 89, 177, 143, 115, 78, 93, 108, 101, 81, 37, 137, 111, 143, 46, 150, 74, 133, 94, 116, 16, 149, 240, 149, 166, 109, 229, 130, 49, 95, 146, 100, 18, 109, 40, 132, 110, 129, 195, 156, 94, 88, 91, 141, 9, 78, 193, 83, 125, 132, 126, 132, 127, 132, 128, 132, 129, 132, 131, 132, 132, 132, 133, 132, 134, 132, 138, 132, 141, 132, 143, 132, 144, 132, 145, 132, 146, 132, 147, 132, 148, 132, 149, 132, 150, 132, 152, 132, 154, 132, 155, 132, 157, 132, 158, 132, 159, 132, 160, 132, 162, 132, 163, 132, 164, 132, 165, 132, 166, 132, 167, 132, 168, 132, 169, 132, 170, 132, 171, 132, 172, 132, 173, 132, 174, 132, 176, 132, 177, 132, 179, 132, 181, 132, 182, 132, 183, 132, 187, 132, 188, 132, 190, 132, 192, 132, 194, 132, 195, 132, 197, 132, 198, 132, 199, 132, 200, 132, 203, 132, 204, 132, 206, 132, 207, 132, 210, 132, 212, 132, 213, 132, 215, 132, 216, 132, 217, 132, 218, 132, 219, 132, 220, 132, 222, 132, 225, 132, 226, 132, 228, 132, 231, 132, 232, 132, 233, 132, 234, 132, 235, 132, 237, 132, 238, 132, 239, 132, 241, 132, 242, 132, 243, 132, 244, 132, 245, 132, 246, 132, 247, 132, 248, 132, 249, 132, 250, 132, 251, 132, 253, 132, 254, 132, 0, 133, 1, 133, 2, 133, 30, 79, 99, 101, 81, 104, 211, 85, 39, 78, 20, 100, 154, 154, 107, 98, 194, 90, 95, 116, 114, 130, 169, 109, 238, 104, 231, 80, 142, 131, 2, 120, 64, 103, 57, 82, 153, 108, 177, 126, 187, 80, 101, 85, 94, 113, 91, 123, 82, 102, 202, 115, 235, 130, 73, 103, 113, 92, 32, 82, 125, 113, 107, 136, 234, 149, 85, 150, 197, 100, 97, 141, 179, 129, 132, 85, 85, 108, 71, 98, 46, 127, 146, 88, 36, 79, 70, 85, 79, 141, 76, 102, 10, 78, 26, 92, 243, 136, 162, 104, 78, 99, 13, 122, 231, 112, 141, 130, 250, 82, 246, 151, 17, 92, 232, 84, 181, 144, 205, 126, 98, 89, 74, 141, 199, 134, 12, 130, 13, 130, 102, 141, 68, 100, 4, 92, 81, 97, 137, 109, 62, 121, 190, 139, 55, 120, 51, 117, 123, 84, 56, 79, 171, 142, 241, 109, 32, 90, 197, 126, 94, 121, 136, 108, 161, 91, 118, 90, 26, 117, 190, 128, 78, 97, 23, 110, 240, 88, 31, 117, 37, 117, 114, 114, 71, 83, 243, 126, 3, 133, 4, 133, 5, 133, 6, 133, 7, 133, 8, 133, 9, 133, 10, 133, 11, 133, 13, 133, 14, 133, 15, 133, 16, 133, 18, 133, 20, 133, 21, 133, 22, 133, 24, 133, 25, 133, 27, 133, 28, 133, 29, 133, 30, 133, 32, 133, 34, 133, 35, 133, 36, 133, 37, 133, 38, 133, 39, 133, 40, 133, 41, 133, 42, 133, 45, 133, 46, 133, 47, 133, 48, 133, 49, 133, 50, 133, 51, 133, 52, 133, 53, 133, 54, 133, 62, 133, 63, 133, 64, 133, 65, 133, 66, 133, 68, 133, 69, 133, 70, 133, 71, 133, 75, 133, 76, 133, 77, 133, 78, 133, 79, 133, 80, 133, 81, 133, 82, 133, 83, 133, 84, 133, 85, 133, 87, 133, 88, 133, 90, 133, 91, 133, 92, 133, 93, 133, 95, 133, 96, 133, 97, 133, 98, 133, 99, 133, 101, 133, 102, 133, 103, 133, 105, 133, 106, 133, 107, 133, 108, 133, 109, 133, 110, 133, 111, 133, 112, 133, 113, 133, 115, 133, 117, 133, 118, 133, 119, 133, 120, 133, 124, 133, 125, 133, 127, 133, 128, 133, 129, 133, 1, 119, 219, 118, 105, 82, 220, 128, 35, 87, 8, 94, 49, 89, 238, 114, 189, 101, 127, 110, 215, 139, 56, 92, 113, 134, 65, 83, 243, 119, 254, 98, 246, 101, 192, 78, 223, 152, 128, 134, 158, 91, 198, 139, 242, 83, 226, 119, 127, 79, 78, 92, 118, 154, 203, 89], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 240828);
	        allocate([15, 95, 58, 121, 235, 88, 22, 78, 255, 103, 139, 78, 237, 98, 147, 138, 29, 144, 191, 82, 47, 102, 220, 85, 108, 86, 2, 144, 213, 78, 141, 79, 202, 145, 112, 153, 15, 108, 2, 94, 67, 96, 164, 91, 198, 137, 213, 139, 54, 101, 75, 98, 150, 153, 136, 91, 255, 91, 136, 99, 46, 85, 215, 83, 38, 118, 125, 81, 44, 133, 162, 103, 179, 104, 138, 107, 146, 98, 147, 143, 212, 83, 18, 130, 209, 109, 143, 117, 102, 78, 78, 141, 112, 91, 159, 113, 175, 133, 145, 102, 217, 102, 114, 127, 0, 135, 205, 158, 32, 159, 94, 92, 47, 103, 240, 143, 17, 104, 95, 103, 13, 98, 214, 122, 133, 88, 182, 94, 112, 101, 49, 111, 130, 133, 131, 133, 134, 133, 136, 133, 137, 133, 138, 133, 139, 133, 140, 133, 141, 133, 142, 133, 144, 133, 145, 133, 146, 133, 147, 133, 148, 133, 149, 133, 150, 133, 151, 133, 152, 133, 153, 133, 154, 133, 157, 133, 158, 133, 159, 133, 160, 133, 161, 133, 162, 133, 163, 133, 165, 133, 166, 133, 167, 133, 169, 133, 171, 133, 172, 133, 173, 133, 177, 133, 178, 133, 179, 133, 180, 133, 181, 133, 182, 133, 184, 133, 186, 133, 187, 133, 188, 133, 189, 133, 190, 133, 191, 133, 192, 133, 194, 133, 195, 133, 196, 133, 197, 133, 198, 133, 199, 133, 200, 133, 202, 133, 203, 133, 204, 133, 205, 133, 206, 133, 209, 133, 210, 133, 212, 133, 214, 133, 215, 133, 216, 133, 217, 133, 218, 133, 219, 133, 221, 133, 222, 133, 223, 133, 224, 133, 225, 133, 226, 133, 227, 133, 229, 133, 230, 133, 231, 133, 232, 133, 234, 133, 235, 133, 236, 133, 237, 133, 238, 133, 239, 133, 240, 133, 241, 133, 242, 133, 243, 133, 244, 133, 245, 133, 246, 133, 247, 133, 248, 133, 85, 96, 55, 82, 13, 128, 84, 100, 112, 136, 41, 117, 5, 94, 19, 104, 244, 98, 28, 151, 204, 83, 61, 114, 1, 140, 52, 108, 97, 119, 14, 122, 46, 84, 172, 119, 122, 152, 28, 130, 244, 139, 85, 120, 20, 103, 193, 112, 175, 101, 149, 100, 54, 86, 29, 96, 193, 121, 248, 83, 29, 78, 123, 107, 134, 128, 250, 91, 227, 85, 219, 86, 58, 79, 60, 79, 114, 153, 243, 93, 126, 103, 56, 128, 2, 96, 130, 152, 1, 144, 139, 91, 188, 139, 245, 139, 28, 100, 88, 130, 222, 100, 253, 85, 207, 130, 101, 145, 215, 79, 32, 125, 31, 144, 159, 124, 243, 80, 81, 88, 175, 110, 191, 91, 201, 139, 131, 128, 120, 145, 156, 132, 151, 123, 125, 134, 139, 150, 143, 150, 229, 126, 211, 154, 142, 120, 129, 92, 87, 122, 66, 144, 167, 150, 95, 121, 89, 91, 95, 99, 11, 123, 209, 132, 173, 104, 6, 85, 41, 127, 16, 116, 34, 125, 1, 149, 64, 98, 76, 88, 214, 78, 131, 91, 121, 89, 84, 88, 249, 133, 250, 133, 252, 133, 253, 133, 254, 133, 0, 134, 1, 134, 2, 134, 3, 134, 4, 134, 6, 134, 7, 134, 8, 134, 9, 134, 10, 134, 11, 134, 12, 134, 13, 134, 14, 134, 15, 134, 16, 134, 18, 134, 19, 134, 20, 134, 21, 134, 23, 134, 24, 134, 25, 134, 26, 134, 27, 134, 28, 134, 29, 134, 30, 134, 31, 134, 32, 134, 33, 134, 34, 134, 35, 134, 36, 134, 37, 134, 38, 134, 40, 134, 42, 134, 43, 134, 44, 134, 45, 134, 46, 134, 47, 134, 48, 134, 49, 134, 50, 134, 51, 134, 52, 134, 53, 134, 54, 134, 55, 134, 57, 134, 58, 134, 59, 134, 61, 134, 62, 134, 63, 134, 64, 134, 65, 134, 66, 134, 67, 134, 68, 134, 69, 134, 70, 134, 71, 134, 72, 134, 73, 134, 74, 134, 75, 134, 76, 134, 82, 134, 83, 134, 85, 134, 86, 134, 87, 134, 88, 134, 89, 134, 91, 134, 92, 134, 93, 134, 95, 134, 96, 134, 97, 134, 99, 134, 100, 134, 101, 134, 102, 134, 103, 134, 104, 134, 105, 134, 106, 134, 109, 115, 30, 99, 75, 142, 15, 142, 206, 128, 212, 130, 172, 98, 240, 83, 240, 108, 94, 145, 42, 89, 1, 96, 112, 108, 77, 87, 74, 100, 42, 141, 43, 118, 233, 110, 91, 87, 128, 106, 240, 117, 109, 111, 45, 140, 8, 140, 102, 87, 239, 107, 146, 136, 179, 120, 162, 99, 249, 83, 173, 112, 100, 108, 88, 88, 42, 100, 2, 88, 224, 104, 155, 129, 16, 85, 214, 124, 24, 80, 186, 142, 204, 109, 159, 141, 235, 112, 143, 99, 155, 109, 212, 110, 230, 126, 4, 132, 67, 104, 3, 144, 216, 109, 118, 150, 168, 139, 87, 89, 121, 114, 228, 133, 126, 129, 188, 117, 138, 138, 175, 104, 84, 82, 34, 142, 17, 149, 208, 99, 152, 152, 68, 142, 124, 85, 83, 79, 255, 102, 143, 86, 213, 96, 149, 109, 67, 82, 73, 92, 41, 89, 251, 109, 107, 88, 48, 117, 28, 117, 108, 96, 20, 130, 70, 129, 17, 99, 97, 103, 226, 143, 58, 119, 243, 141, 52, 141, 193, 148, 22, 94, 133, 83, 44, 84, 195, 112, 109, 134, 111, 134, 112, 134, 114, 134, 115, 134, 116, 134, 117, 134, 118, 134, 119, 134, 120, 134, 131, 134, 132, 134, 133, 134, 134, 134, 135, 134, 136, 134, 137, 134, 142, 134, 143, 134, 144, 134, 145, 134, 146, 134, 148, 134, 150, 134, 151, 134, 152, 134, 153, 134, 154, 134, 155, 134, 158, 134, 159, 134, 160, 134, 161, 134, 162, 134, 165, 134, 166, 134, 171, 134, 173, 134, 174, 134, 178, 134, 179, 134, 183, 134, 184, 134, 185, 134, 187, 134, 188, 134, 189, 134, 190, 134, 191, 134, 193, 134, 194, 134, 195, 134, 197, 134, 200, 134, 204, 134, 205, 134, 210, 134, 211, 134, 213, 134, 214, 134, 215, 134, 218, 134, 220, 134, 221, 134, 224, 134, 225, 134, 226, 134, 227, 134, 229, 134, 230, 134, 231, 134, 232, 134, 234, 134, 235, 134, 236, 134, 239, 134, 245, 134, 246, 134, 247, 134, 250, 134, 251, 134, 252, 134, 253, 134, 255, 134, 1, 135, 4, 135, 5, 135, 6, 135, 11, 135, 12, 135, 14, 135, 15, 135, 16, 135, 17, 135, 20, 135, 22, 135, 64, 108, 247, 94, 92, 80, 173, 78, 173, 94, 58, 99, 71, 130, 26, 144, 80, 104, 110, 145, 179, 119, 12, 84, 220, 148, 100, 95, 229, 122, 118, 104, 69, 99, 82, 123, 223, 126, 219, 117, 119, 80, 149, 98, 52, 89, 15, 144, 248, 81, 195, 121, 129, 122, 254, 86, 146, 95, 20, 144, 130, 109, 96, 92, 31, 87, 16, 84, 84, 81, 77, 110, 226, 86, 168, 99, 147, 152, 127, 129, 21, 135, 42, 137, 0, 144, 30, 84, 111, 92, 192, 129, 214, 98, 88, 98, 49, 129, 53, 158, 64, 150, 110, 154, 124, 154, 45, 105, 165, 89, 211, 98, 62, 85, 22, 99, 199, 84, 217, 134, 60, 109, 3, 90, 230, 116, 156, 136, 106, 107, 22, 89, 76, 140, 47, 95, 126, 110, 169, 115, 125, 152, 56, 78, 247, 112, 140, 91, 151, 120, 61, 99, 90, 102, 150, 118, 203, 96, 155, 91, 73, 90, 7, 78, 85, 129, 106, 108, 139, 115, 161, 78, 137, 103, 81, 127, 128, 95, 250, 101, 27, 103, 216, 95, 132, 89, 1, 90, 25, 135, 27, 135, 29, 135, 31, 135, 32, 135, 36, 135, 38, 135, 39, 135, 40, 135, 42, 135, 43, 135, 44, 135, 45, 135, 47, 135, 48, 135, 50, 135, 51, 135, 53, 135, 54, 135, 56, 135, 57, 135, 58, 135, 60, 135, 61, 135, 64, 135, 65, 135, 66, 135, 67, 135, 68, 135, 69, 135, 70, 135, 74, 135, 75, 135, 77, 135, 79, 135, 80, 135, 81, 135, 82, 135, 84, 135, 85, 135, 86, 135, 88, 135, 90, 135, 91, 135, 92, 135, 93, 135, 94, 135, 95, 135, 97, 135, 98, 135, 102, 135, 103, 135, 104, 135, 105, 135, 106, 135, 107, 135, 108, 135, 109, 135, 111, 135, 113, 135, 114, 135, 115, 135, 117, 135, 119, 135, 120, 135, 121, 135, 122, 135, 127, 135, 128, 135, 129, 135, 132, 135, 134, 135, 135, 135, 137, 135, 138, 135, 140, 135, 142, 135, 143, 135, 144, 135, 145, 135, 146, 135, 148, 135, 149, 135, 150, 135, 152, 135, 153, 135, 154, 135, 155, 135, 156, 135, 157, 135, 158, 135, 160, 135, 161, 135, 162, 135, 163, 135, 164, 135, 205, 93, 174, 95, 113, 83, 230, 151, 221, 143, 69, 104, 244, 86, 47, 85, 223, 96, 58, 78, 77, 111, 244, 126, 199, 130, 14, 132, 212, 89, 31, 79, 42, 79, 62, 92, 172, 126, 42, 103, 26, 133, 115, 84, 79, 117, 195, 128, 130, 85, 79, 155, 77, 79, 45, 110, 19, 140, 9, 92, 112, 97, 107, 83, 31, 118, 41, 110, 138, 134, 135, 101, 251, 149, 185, 126, 59, 84, 51, 122, 10, 125, 238, 149, 225, 85, 193, 127, 238, 116, 29, 99, 23, 135, 161, 109, 157, 122, 17, 98, 161, 101, 103, 83, 225, 99, 131, 108, 235, 93, 92, 84, 168, 148, 76, 78, 97, 108, 236, 139, 75, 92, 224, 101, 156, 130, 167, 104, 62, 84, 52, 84, 203, 107, 102, 107, 148, 78, 66, 99, 72, 83, 30, 130, 13, 79, 174, 79, 94, 87, 10, 98, 254, 150, 100, 102, 105, 114, 255, 82, 161, 82, 159, 96, 239, 139, 20, 102, 153, 113, 144, 103, 127, 137, 82, 120, 253, 119, 112, 102, 59, 86, 56, 84, 33, 149, 122, 114, 165, 135, 166, 135, 167, 135, 169, 135, 170, 135, 174, 135, 176, 135, 177, 135, 178, 135, 180, 135, 182, 135, 183, 135, 184, 135, 185, 135, 187, 135, 188, 135, 190, 135, 191, 135, 193, 135, 194, 135, 195, 135, 196, 135, 197, 135, 199, 135, 200, 135, 201, 135, 204, 135, 205, 135, 206, 135, 207, 135, 208, 135, 212, 135, 213, 135, 214, 135, 215, 135, 216, 135, 217, 135, 218, 135, 220, 135, 221, 135, 222, 135, 223, 135, 225, 135, 226, 135, 227, 135, 228, 135, 230, 135, 231, 135, 232, 135, 233, 135, 235, 135, 236, 135, 237, 135, 239, 135, 240, 135, 241, 135, 242, 135, 243, 135, 244, 135, 245, 135, 246, 135, 247, 135, 248, 135, 250, 135, 251, 135, 252, 135, 253, 135, 255, 135, 0, 136, 1, 136, 2, 136, 4, 136, 5, 136, 6, 136, 7, 136, 8, 136, 9, 136, 11, 136, 12, 136, 13, 136, 14, 136, 15, 136, 16, 136, 17, 136, 18, 136, 20, 136, 23, 136, 24, 136, 25, 136, 26, 136, 28, 136, 29, 136, 30, 136, 31, 136, 32, 136, 35, 136, 0, 122, 111, 96, 12, 94, 137, 96, 157, 129, 21, 89, 220, 96, 132, 113, 239, 112, 170, 110, 80, 108, 128, 114, 132, 106, 173, 136, 45, 94, 96, 78, 179, 90, 156, 85, 227, 148, 23, 109, 251, 124, 153, 150, 15, 98, 198, 126, 142, 119, 126, 134, 35, 83, 30, 151, 150, 143, 135, 102, 225, 92, 160, 79, 237, 114, 11, 78, 166, 83, 15, 89, 19, 84, 128, 99, 40, 149, 72, 81, 217, 78, 156, 156, 164, 126, 184, 84, 36, 141, 84, 136, 55, 130, 242, 149, 142, 109, 38, 95, 204, 90, 62, 102, 105, 150, 176, 115, 46, 115, 191, 83, 122, 129, 133, 153, 161, 127, 170, 91, 119, 150, 80, 150, 191, 126, 248, 118, 162, 83, 118, 149, 153, 153, 177, 123, 68, 137, 88, 110, 97, 78, 212, 127, 101, 121, 230, 139, 243, 96, 205, 84, 171, 78, 121, 152, 247, 93, 97, 106, 207, 80, 17, 84, 97, 140, 39, 132, 93, 120, 4, 151, 74, 82, 238, 84, 163, 86, 0, 149, 136, 109, 181, 91, 198, 109, 83, 102, 36, 136, 37, 136, 38, 136, 39, 136, 40, 136, 41, 136, 42, 136, 43, 136, 44, 136, 45, 136, 46, 136, 47, 136, 48, 136, 49, 136, 51, 136, 52, 136, 53, 136, 54, 136, 55, 136, 56, 136, 58, 136, 59, 136, 61, 136, 62, 136, 63, 136, 65, 136, 66, 136, 67, 136, 70, 136, 71, 136, 72, 136, 73, 136, 74, 136, 75, 136, 78, 136, 79, 136, 80, 136, 81, 136, 82, 136, 83, 136, 85, 136, 86, 136, 88, 136, 90, 136, 91, 136, 92, 136, 93, 136, 94, 136, 95, 136, 96, 136, 102, 136, 103, 136, 106, 136, 109, 136, 111, 136, 113, 136, 115, 136, 116, 136, 117, 136, 118, 136, 120, 136, 121, 136, 122, 136, 123, 136, 124, 136, 128, 136, 131, 136, 134, 136, 135, 136, 137, 136, 138, 136, 140, 136, 142, 136, 143, 136, 144, 136, 145, 136, 147, 136, 148, 136, 149, 136, 151, 136, 152, 136, 153, 136, 154, 136, 155, 136, 157, 136, 158, 136, 159, 136, 160, 136, 161, 136, 163, 136, 165, 136, 166, 136, 167, 136, 168, 136, 169, 136, 170, 136, 15, 92, 93, 91, 33, 104, 150, 128, 120, 85, 17, 123, 72, 101, 84, 105, 155, 78, 71, 107, 78, 135, 139, 151, 79, 83, 31, 99, 58, 100, 170, 144, 156, 101, 193, 128, 16, 140, 153, 81, 176, 104, 120, 83, 249, 135, 200, 97, 196, 108, 251, 108, 34, 140, 81, 92, 170, 133, 175, 130, 12, 149, 35, 107, 155, 143, 176, 101, 251, 95, 195, 95, 225, 79, 69, 136, 31, 102, 101, 129, 41, 115, 250, 96, 116, 81, 17, 82, 139, 87, 98, 95, 162, 144, 76, 136, 146, 145, 120, 94, 79, 103, 39, 96, 211, 89, 68, 81, 246, 81, 248, 128, 8, 83, 121, 108, 196, 150, 138, 113, 17, 79, 238, 79, 158, 127, 61, 103, 197, 85, 8, 149, 192, 121, 150, 136, 227, 126, 159, 88, 12, 98, 0, 151, 90, 134, 24, 86, 123, 152, 144, 95, 184, 139, 196, 132, 87, 145, 217, 83, 237, 101, 143, 94, 92, 117, 100, 96, 110, 125, 127, 90, 234, 126, 237, 126, 105, 143, 167, 85, 163, 91, 172, 96, 203, 101, 132, 115, 172, 136, 174, 136, 175, 136, 176, 136, 178, 136, 179, 136, 180, 136, 181, 136, 182, 136, 184, 136, 185, 136, 186, 136, 187, 136, 189, 136, 190, 136, 191, 136, 192, 136, 195, 136, 196, 136, 199, 136, 200, 136, 202, 136, 203, 136, 204, 136, 205, 136, 207, 136, 208, 136, 209, 136, 211, 136, 214, 136, 215, 136, 218, 136, 219, 136, 220, 136, 221, 136, 222, 136, 224, 136, 225, 136, 230, 136, 231, 136, 233, 136, 234, 136, 235, 136, 236, 136, 237, 136, 238, 136, 239, 136, 242, 136, 245, 136, 246, 136, 247, 136, 250, 136, 251, 136, 253, 136, 255, 136, 0, 137, 1, 137, 3, 137, 4, 137, 5, 137, 6, 137, 7, 137, 8, 137, 9, 137, 11, 137, 12, 137, 13, 137, 14, 137, 15, 137, 17, 137, 20, 137, 21, 137, 22, 137, 23, 137, 24, 137, 28, 137, 29, 137, 30, 137, 31, 137, 32, 137, 34, 137, 35, 137, 36, 137, 38, 137, 39, 137, 40, 137, 41, 137, 44, 137, 45, 137, 46, 137, 47, 137, 49, 137, 50, 137, 51, 137, 53, 137, 55, 137, 9, 144, 99, 118, 41, 119, 218, 126, 116, 151, 155, 133, 102, 91, 116, 122, 234, 150, 64, 136, 203, 82, 143, 113, 170, 95, 236, 101, 226, 139, 251, 91, 111, 154, 225, 93, 137, 107, 91, 108, 173, 139, 175, 139, 10, 144, 197, 143, 139, 83, 188, 98, 38, 158, 45, 158, 64, 84, 43, 78, 189, 130, 89, 114, 156, 134, 22, 93, 89, 136, 175, 109, 197, 150, 209, 84, 154, 78, 182, 139, 9, 113, 189, 84, 9, 150, 223, 112, 249, 109, 208, 118, 37, 78, 20, 120, 18, 135, 169, 92, 246, 94, 0, 138, 156, 152, 14, 150, 142, 112, 191, 108, 68, 89, 169, 99, 60, 119, 77, 136, 20, 111, 115, 130, 48, 88, 213, 113, 140, 83, 26, 120, 193, 150, 1, 85, 102, 95, 48, 113, 180, 91, 26, 140, 140, 154, 131, 107, 46, 89, 47, 158, 231, 121, 104, 103, 108, 98, 111, 79, 161, 117, 138, 127, 11, 109, 51, 150, 39, 108, 240, 78, 210, 117, 123, 81, 55, 104, 62, 111, 128, 144, 112, 129, 150, 89, 118, 116, 56, 137, 57, 137, 58, 137, 59, 137, 60, 137, 61, 137, 62, 137, 63, 137, 64, 137, 66, 137, 67, 137, 69, 137, 70, 137, 71, 137, 72, 137, 73, 137, 74, 137, 75, 137, 76, 137, 77, 137, 78, 137, 79, 137, 80, 137, 81, 137, 82, 137, 83, 137, 84, 137, 85, 137, 86, 137, 87, 137, 88, 137, 89, 137, 90, 137, 91, 137, 92, 137, 93, 137, 96, 137, 97, 137, 98, 137, 99, 137, 100, 137, 101, 137, 103, 137, 104, 137, 105, 137, 106, 137, 107, 137, 108, 137, 109, 137, 110, 137, 111, 137, 112, 137, 113, 137, 114, 137, 115, 137, 116, 137, 117, 137, 118, 137, 119, 137, 120, 137, 121, 137, 122, 137, 124, 137, 125, 137, 126, 137, 128, 137, 130, 137, 132, 137, 133, 137, 135, 137, 136, 137, 137, 137, 138, 137, 139, 137, 140, 137, 141, 137, 142, 137, 143, 137, 144, 137, 145, 137, 146, 137, 147, 137, 148, 137, 149, 137, 150, 137, 151, 137, 152, 137, 153, 137, 154, 137, 155, 137, 156, 137, 157, 137, 158, 137, 159, 137, 160, 137, 161, 137, 71, 100, 39, 92, 101, 144, 145, 122, 35, 140, 218, 89, 172, 84, 0, 130, 111, 131, 129, 137, 0, 128, 48, 105, 78, 86, 54, 128, 55, 114, 206, 145, 182, 81, 95, 78, 117, 152, 150, 99, 26, 78, 246, 83, 243, 102, 75, 129, 28, 89, 178, 109, 0, 78, 249, 88, 59, 83, 214, 99, 241, 148, 157, 79, 10, 79, 99, 136, 144, 152, 55, 89, 87, 144, 251, 121, 234, 78, 240, 128, 145, 117, 130, 108, 156, 91, 232, 89, 93, 95, 5, 105, 129, 134, 26, 80, 242, 93, 89, 78, 227, 119, 229, 78, 122, 130, 145, 98, 19, 102, 145, 144, 121, 92, 191, 78, 121, 95, 198, 129, 56, 144, 132, 128, 171, 117, 166, 78, 212, 136, 15, 97, 197, 107, 198, 95, 73, 78, 202, 118, 162, 110, 227, 139, 174, 139, 10, 140, 209, 139, 2, 95, 252, 127, 204, 127, 206, 126, 53, 131, 107, 131, 224, 86, 183, 107, 243, 151, 52, 150, 251, 89, 31, 84, 246, 148, 235, 109, 197, 91, 110, 153, 57, 92, 21, 95, 144, 150, 162, 137, 163, 137, 164, 137, 165, 137, 166, 137, 167, 137, 168, 137, 169, 137, 170, 137, 171, 137, 172, 137, 173, 137, 174, 137, 175, 137, 176, 137, 177, 137, 178, 137, 179, 137, 180, 137, 181, 137, 182, 137, 183, 137, 184, 137, 185, 137, 186, 137, 187, 137, 188, 137, 189, 137, 190, 137, 191, 137, 192, 137, 195, 137, 205, 137, 211, 137, 212, 137, 213, 137, 215, 137, 216, 137, 217, 137, 219, 137, 221, 137, 223, 137, 224, 137, 225, 137, 226, 137, 228, 137, 231, 137, 232, 137, 233, 137, 234, 137, 236, 137, 237, 137, 238, 137, 240, 137, 241, 137, 242, 137, 244, 137, 245, 137, 246, 137, 247, 137, 248, 137, 249, 137, 250, 137, 251, 137, 252, 137, 253, 137, 254, 137, 255, 137, 1, 138, 2, 138, 3, 138, 4, 138, 5, 138, 6, 138, 8, 138, 9, 138, 10, 138, 11, 138, 12, 138, 13, 138, 14, 138, 15, 138, 16, 138, 17, 138, 18, 138, 19, 138, 20, 138, 21, 138, 22, 138, 23, 138, 24, 138, 25, 138, 26, 138, 27, 138, 28, 138, 29, 138, 112, 83, 241, 130, 49, 106, 116, 90, 112, 158, 148, 94, 40, 127, 185, 131, 36, 132, 37, 132, 103, 131, 71, 135, 206, 143, 98, 141, 200, 118, 113, 95, 150, 152, 108, 120, 32, 102, 223, 84, 229, 98, 99, 79, 195, 129, 200, 117, 184, 94, 205, 150, 10, 142, 249, 134, 143, 84, 243, 108, 140, 109, 56, 108, 127, 96, 199, 82, 40, 117, 125, 94, 24, 79, 160, 96, 231, 95, 36, 92, 49, 117, 174, 144, 192, 148, 185, 114, 185, 108, 56, 110, 73, 145, 9, 103, 203, 83, 243, 83, 81, 79, 201, 145, 241, 139, 200, 83, 124, 94, 194, 143, 228, 109, 142, 78, 194, 118, 134, 105, 94, 134, 26, 97, 6, 130, 89, 79, 222, 79, 62, 144, 124, 156, 9, 97, 29, 110, 20, 110, 133, 150, 136, 78, 49, 90, 232, 150, 14, 78, 127, 92, 185, 121, 135, 91, 237, 139, 189, 127, 137, 115, 223, 87, 139, 130, 193, 144, 1, 84, 71, 144, 187, 85, 234, 92, 161, 95, 8, 97, 50, 107, 241, 114, 178, 128, 137, 138, 30, 138, 31, 138, 32, 138, 33, 138, 34, 138, 35, 138, 36, 138, 37, 138, 38, 138, 39, 138, 40, 138, 41, 138, 42, 138, 43, 138, 44, 138, 45, 138, 46, 138, 47, 138, 48, 138, 49, 138, 50, 138, 51, 138, 52, 138, 53, 138, 54, 138, 55, 138, 56, 138, 57, 138, 58, 138, 59, 138, 60, 138, 61, 138, 63, 138, 64, 138, 65, 138, 66, 138, 67, 138, 68, 138, 69, 138, 70, 138, 71, 138, 73, 138, 74, 138, 75, 138, 76, 138, 77, 138, 78, 138, 79, 138, 80, 138, 81, 138, 82, 138, 83, 138, 84, 138, 85, 138, 86, 138, 87, 138, 88, 138, 89, 138, 90, 138, 91, 138, 92, 138, 93, 138, 94, 138, 95, 138, 96, 138, 97, 138, 98, 138, 99, 138, 100, 138, 101, 138, 102, 138, 103, 138, 104, 138, 105, 138, 106, 138, 107, 138, 108, 138, 109, 138, 110, 138, 111, 138, 112, 138, 113, 138, 114, 138, 115, 138, 116, 138, 117, 138, 118, 138, 119, 138, 120, 138, 122, 138, 123, 138, 124, 138, 125, 138, 126, 138, 127, 138, 128, 138, 116, 109, 211, 91, 213, 136, 132, 152, 107, 140, 109, 154, 51, 158, 10, 110, 164, 81, 67, 81, 163, 87, 129, 136, 159, 83, 244, 99, 149, 143, 237, 86, 88, 84, 6, 87, 63, 115, 144, 110, 24, 127, 220, 143, 209, 130, 63, 97, 40, 96, 98, 150, 240, 102, 166, 126, 138, 141, 195, 141, 165, 148, 179, 92, 164, 124, 8, 103, 166, 96, 5, 150, 24, 128, 145, 78, 231, 144, 0, 83, 104, 150, 65, 81, 208, 143, 116, 133, 93, 145, 85, 102, 245, 151, 85, 91, 29, 83, 56, 120, 66, 103, 61, 104, 201, 84, 126, 112, 176, 91, 125, 143, 141, 81, 40, 87, 177, 84, 18, 101, 130, 102, 94, 141, 67, 141, 15, 129, 108, 132, 109, 144, 223, 124, 255, 81, 251, 133, 163, 103, 233, 101, 161, 111, 164, 134, 129, 142, 106, 86, 32, 144, 130, 118, 118, 112, 229, 113, 35, 141, 233, 98, 25, 82, 253, 108, 60, 141, 14, 96, 158, 88, 142, 97, 254, 102, 96, 141, 78, 98, 179, 85, 35, 110, 45, 103, 103, 143, 129, 138, 130, 138, 131, 138, 132, 138, 133, 138, 134, 138, 135, 138, 136, 138, 139, 138, 140, 138, 141, 138, 142, 138, 143, 138, 144, 138, 145, 138, 146, 138, 148, 138, 149, 138, 150, 138, 151, 138, 152, 138, 153, 138, 154, 138, 155, 138, 156, 138, 157, 138, 158, 138, 159, 138, 160, 138, 161, 138, 162, 138, 163, 138, 164, 138, 165, 138, 166, 138, 167, 138, 168, 138, 169, 138, 170, 138, 171, 138, 172, 138, 173, 138, 174, 138, 175, 138, 176, 138, 177, 138, 178, 138, 179, 138, 180, 138, 181, 138, 182, 138, 183, 138, 184, 138, 185, 138, 186, 138, 187, 138, 188, 138, 189, 138, 190, 138, 191, 138, 192, 138, 193, 138, 194, 138, 195, 138, 196, 138, 197, 138, 198, 138, 199, 138, 200, 138, 201, 138, 202, 138, 203, 138, 204, 138, 205, 138, 206, 138, 207, 138, 208, 138, 209, 138, 210, 138, 211, 138, 212, 138, 213, 138, 214, 138, 215, 138, 216, 138, 217, 138, 218, 138, 219, 138, 220, 138, 221, 138, 222, 138, 223, 138, 224, 138, 225, 138, 226, 138, 227, 138, 225, 148, 248, 149, 40, 119, 5, 104, 168, 105, 139, 84, 77, 78, 184, 112, 200, 139, 88, 100, 139, 101, 133, 91, 132, 122, 58, 80, 232, 91, 187, 119, 225, 107, 121, 138, 152, 124, 190, 108, 207, 118, 169, 101, 151, 143, 45, 93, 85, 92, 56, 134, 8, 104, 96, 83, 24, 98, 217, 122, 91, 110, 253, 126, 31, 106, 224, 122, 112, 95, 51, 111, 32, 95, 140, 99, 168, 109, 86, 103, 8, 78, 16, 94, 38, 141, 215, 78, 192, 128, 52, 118, 156, 150, 219, 98, 45, 102, 126, 98, 188, 108, 117, 141, 103, 113, 105, 127, 70, 81, 135, 128, 236, 83, 110, 144, 152, 98, 242, 84, 240, 134, 153, 143, 5, 128, 23, 149, 23, 133, 217, 143, 89, 109, 205, 115, 159, 101, 31, 119, 4, 117, 39, 120, 251, 129, 30, 141, 136, 148, 166, 79, 149, 103, 185, 117, 202, 139, 7, 151, 47, 99, 71, 149, 53, 150, 184, 132, 35, 99, 65, 119, 129, 95, 240, 114, 137, 78, 20, 96, 116, 101, 239, 98, 99, 107, 63, 101, 228, 138, 229, 138, 230, 138, 231, 138, 232, 138, 233, 138, 234, 138, 235, 138, 236, 138, 237, 138, 238, 138, 239, 138, 240, 138, 241, 138, 242, 138, 243, 138, 244, 138, 245, 138, 246, 138, 247, 138, 248, 138, 249, 138, 250, 138, 251, 138, 252, 138, 253, 138, 254, 138, 255, 138, 0, 139, 1, 139, 2, 139, 3, 139, 4, 139, 5, 139, 6, 139, 8, 139, 9, 139, 10, 139, 11, 139, 12, 139, 13, 139, 14, 139, 15, 139, 16, 139, 17, 139, 18, 139, 19, 139, 20, 139, 21, 139, 22, 139, 23, 139, 24, 139, 25, 139, 26, 139, 27, 139, 28, 139, 29, 139, 30, 139, 31, 139, 32, 139, 33, 139, 34, 139, 35, 139, 36, 139, 37, 139, 39, 139, 40, 139, 41, 139, 42, 139, 43, 139, 44, 139, 45, 139, 46, 139, 47, 139, 48, 139, 49, 139, 50, 139, 51, 139, 52, 139, 53, 139, 54, 139, 55, 139, 56, 139, 57, 139, 58, 139, 59, 139, 60, 139, 61, 139, 62, 139, 63, 139, 64, 139, 65, 139, 66, 139, 67, 139, 68, 139, 69, 139, 39, 94, 199, 117, 209, 144, 193, 139, 157, 130, 157, 103, 47, 101, 49, 84, 24, 135, 229, 119, 162, 128, 2, 129, 65, 108, 75, 78, 199, 126, 76, 128, 244, 118, 13, 105, 150, 107, 103, 98, 60, 80, 132, 79, 64, 87, 7, 99, 98, 107, 190, 141, 234, 83, 232, 101, 184, 126, 215, 95, 26, 99, 183, 99, 243, 129, 244, 129, 110, 127, 28, 94, 217, 92, 54, 82, 122, 102, 233, 121, 26, 122, 40, 141, 153, 112, 212, 117, 222, 110, 187, 108, 146, 122, 45, 78, 197, 118, 224, 95, 159, 148, 119, 136, 200, 126, 205, 121, 191, 128, 205, 145, 242, 78, 23, 79, 31, 130, 104, 84, 222, 93, 50, 109, 204, 139, 165, 124, 116, 143, 152, 128, 26, 94, 146, 84, 177, 118, 153, 91, 60, 102, 164, 154, 224, 115, 42, 104, 219, 134, 49, 103, 42, 115, 248, 139, 219, 139, 16, 144, 249, 122, 219, 112, 110, 113, 196, 98, 169, 119, 49, 86, 59, 78, 87, 132, 241, 103, 169, 82, 192, 134, 46, 141, 248, 148, 81, 123, 70, 139, 71, 139, 72, 139, 73, 139, 74, 139, 75, 139, 76, 139, 77, 139, 78, 139, 79, 139, 80, 139, 81, 139, 82, 139, 83, 139, 84, 139, 85, 139, 86, 139, 87, 139, 88, 139, 89, 139, 90, 139, 91, 139, 92, 139, 93, 139, 94, 139, 95, 139, 96, 139, 97, 139, 98, 139, 99, 139, 100, 139, 101, 139, 103, 139, 104, 139, 105, 139, 106, 139, 107, 139, 109, 139, 110, 139, 111, 139, 112, 139, 113, 139, 114, 139, 115, 139, 116, 139, 117, 139, 118, 139, 119, 139, 120, 139, 121, 139, 122, 139, 123, 139, 124, 139, 125, 139, 126, 139, 127, 139, 128, 139, 129, 139, 130, 139, 131, 139, 132, 139, 133, 139, 134, 139, 135, 139, 136, 139, 137, 139, 138, 139, 139, 139, 140, 139, 141, 139, 142, 139, 143, 139, 144, 139, 145, 139, 146, 139, 147, 139, 148, 139, 149, 139, 150, 139, 151, 139, 152, 139, 153, 139, 154, 139, 155, 139, 156, 139, 157, 139, 158, 139, 159, 139, 172, 139, 177, 139, 187, 139, 199, 139, 208, 139, 234, 139, 9, 140, 30, 140, 79, 79, 232, 108, 93, 121, 123, 154, 147, 98, 42, 114, 253, 98, 19, 78, 22, 120, 108, 143, 176, 100, 90, 141, 198, 123, 105, 104, 132, 94, 197, 136, 134, 89, 158, 100, 238, 88, 182, 114, 14, 105, 37, 149, 253, 143, 88, 141, 96, 87, 0, 127, 6, 140, 198, 81, 73, 99, 217, 98, 83, 83, 76, 104, 34, 116, 1, 131, 76, 145, 68, 85, 64, 119, 124, 112, 74, 109, 121, 81, 168, 84, 68, 141, 255, 89, 203, 110, 196, 109, 92, 91, 43, 125, 212, 78, 125, 124, 211, 110, 80, 91, 234, 129, 13, 110, 87, 91, 3, 155, 213, 104, 42, 142, 151, 91, 252, 126, 59, 96, 181, 126, 185, 144, 112, 141, 79, 89, 205, 99, 223, 121, 179, 141, 82, 83, 207, 101, 86, 121, 197, 139, 59, 150, 196, 126, 187, 148, 130, 126, 52, 86, 137, 145, 0, 103, 106, 127, 10, 92, 117, 144, 40, 102, 230, 93, 80, 79, 222, 103, 90, 80, 92, 79, 80, 87, 167, 94, 16, 232, 17, 232, 18, 232, 19, 232, 20, 232, 56, 140, 57, 140, 58, 140, 59, 140, 60, 140, 61, 140, 62, 140, 63, 140, 64, 140, 66, 140, 67, 140, 68, 140, 69, 140, 72, 140, 74, 140, 75, 140, 77, 140, 78, 140, 79, 140, 80, 140, 81, 140, 82, 140, 83, 140, 84, 140, 86, 140, 87, 140, 88, 140, 89, 140, 91, 140, 92, 140, 93, 140, 94, 140, 95, 140, 96, 140, 99, 140, 100, 140, 101, 140, 102, 140, 103, 140, 104, 140, 105, 140, 108, 140, 109, 140, 110, 140, 111, 140, 112, 140, 113, 140, 114, 140, 116, 140, 117, 140, 118, 140, 119, 140, 123, 140, 124, 140, 125, 140, 126, 140, 127, 140, 128, 140, 129, 140, 131, 140, 132, 140, 134, 140, 135, 140, 136, 140, 139, 140, 141, 140, 142, 140, 143, 140, 144, 140, 145, 140, 146, 140, 147, 140, 149, 140, 150, 140, 151, 140, 153, 140, 154, 140, 155, 140, 156, 140, 157, 140, 158, 140, 159, 140, 160, 140, 161, 140, 162, 140, 163, 140, 164, 140, 165, 140, 166, 140, 167, 140, 168, 140, 169, 140, 170, 140, 171, 140, 172, 140, 173, 140, 141, 78, 12, 78, 64, 81, 16, 78, 255, 94, 69, 83, 21, 78, 152, 78, 30, 78, 50, 155, 108, 91, 105, 86, 40, 78, 186, 121, 63, 78, 21, 83, 71, 78, 45, 89, 59, 114, 110, 83, 16, 108, 223, 86, 228, 128, 151, 153, 211, 107, 126, 119, 23, 159, 54, 78, 159, 78, 16, 159, 92, 78, 105, 78, 147, 78, 136, 130, 91, 91, 108, 85, 15, 86, 196, 78, 141, 83, 157, 83, 163, 83, 165, 83, 174, 83, 101, 151, 93, 141, 26, 83, 245, 83, 38, 83, 46, 83, 62, 83, 92, 141, 102, 83, 99, 83, 2, 82, 8, 82, 14, 82, 45, 82, 51, 82, 63, 82, 64, 82, 76, 82, 94, 82, 97, 82, 92, 82, 175, 132, 125, 82, 130, 82, 129, 82, 144, 82, 147, 82, 130, 81, 84, 127, 187, 78, 195, 78, 201, 78, 194, 78, 232, 78, 225, 78, 235, 78, 222, 78, 27, 79, 243, 78, 34, 79, 100, 79, 245, 78, 37, 79, 39, 79, 9, 79, 43, 79, 94, 79, 103, 79, 56, 101, 90, 79, 93, 79, 174, 140, 175, 140, 176, 140, 177, 140, 178, 140, 179, 140, 180, 140, 181, 140, 182, 140, 183, 140, 184, 140, 185, 140, 186, 140, 187, 140, 188, 140, 189, 140, 190, 140, 191, 140, 192, 140, 193, 140, 194, 140, 195, 140, 196, 140, 197, 140, 198, 140, 199, 140, 200, 140, 201, 140, 202, 140, 203, 140, 204, 140, 205, 140, 206, 140, 207, 140, 208, 140, 209, 140, 210, 140, 211, 140, 212, 140, 213, 140, 214, 140, 215, 140, 216, 140, 217, 140, 218, 140, 219, 140, 220, 140, 221, 140, 222, 140, 223, 140, 224, 140, 225, 140, 226, 140, 227, 140, 228, 140, 229, 140, 230, 140, 231, 140, 232, 140, 233, 140, 234, 140, 235, 140, 236, 140, 237, 140, 238, 140, 239, 140, 240, 140, 241, 140, 242, 140, 243, 140, 244, 140, 245, 140, 246, 140, 247, 140, 248, 140, 249, 140, 250, 140, 251, 140, 252, 140, 253, 140, 254, 140, 255, 140, 0, 141, 1, 141, 2, 141, 3, 141, 4, 141, 5, 141, 6, 141, 7, 141, 8, 141, 9, 141, 10, 141, 11, 141, 12, 141, 13, 141, 95, 79, 87, 79, 50, 79, 61, 79, 118, 79, 116, 79, 145, 79, 137, 79, 131, 79, 143, 79, 126, 79, 123, 79, 170, 79, 124, 79, 172, 79, 148, 79, 230, 79, 232, 79, 234, 79, 197, 79, 218, 79, 227, 79, 220, 79, 209, 79, 223, 79, 248, 79, 41, 80, 76, 80, 243, 79, 44, 80, 15, 80, 46, 80, 45, 80, 254, 79, 28, 80, 12, 80, 37, 80, 40, 80, 126, 80, 67, 80, 85, 80, 72, 80, 78, 80, 108, 80, 123, 80, 165, 80, 167, 80, 169, 80, 186, 80, 214, 80, 6, 81, 237, 80, 236, 80, 230, 80, 238, 80, 7, 81, 11, 81, 221, 78, 61, 108, 88, 79, 101, 79, 206, 79, 160, 159, 70, 108, 116, 124, 110, 81, 253, 93, 201, 158, 152, 153, 129, 81, 20, 89, 249, 82, 13, 83, 7, 138, 16, 83, 235, 81, 25, 89, 85, 81, 160, 78, 86, 81, 179, 78, 110, 136, 164, 136, 181, 78, 20, 129, 210, 136, 128, 121, 52, 91, 3, 136, 184, 127, 171, 81, 177, 81, 189, 81, 188, 81, 14, 141, 15, 141, 16, 141, 17, 141, 18, 141, 19, 141, 20, 141, 21, 141, 22, 141, 23, 141, 24, 141, 25, 141, 26, 141, 27, 141, 28, 141, 32, 141, 81, 141, 82, 141, 87, 141, 95, 141, 101, 141, 104, 141, 105, 141, 106, 141, 108, 141, 110, 141, 111, 141, 113, 141, 114, 141, 120, 141, 121, 141, 122, 141, 123, 141, 124, 141, 125, 141, 126, 141, 127, 141, 128, 141, 130, 141, 131, 141, 134, 141, 135, 141, 136, 141, 137, 141, 140, 141, 141, 141, 142, 141, 143, 141, 144, 141, 146, 141, 147, 141, 149, 141, 150, 141, 151, 141, 152, 141, 153, 141, 154, 141, 155, 141, 156, 141, 157, 141, 158, 141, 160, 141, 161, 141, 162, 141, 164, 141, 165, 141, 166, 141, 167, 141, 168, 141, 169, 141, 170, 141, 171, 141, 172, 141, 173, 141, 174, 141, 175, 141, 176, 141, 178, 141, 182, 141, 183, 141, 185, 141, 187, 141, 189, 141, 192, 141, 193, 141, 194, 141, 197, 141, 199, 141, 200, 141, 201, 141, 202, 141, 205, 141, 208, 141, 210, 141, 211, 141, 212, 141, 199, 81, 150, 81, 162, 81, 165, 81, 160, 139, 166, 139, 167, 139, 170, 139, 180, 139, 181, 139, 183, 139, 194, 139, 195, 139, 203, 139, 207, 139, 206, 139, 210, 139, 211, 139, 212, 139, 214, 139, 216, 139, 217, 139, 220, 139, 223, 139, 224, 139, 228, 139, 232, 139, 233, 139, 238, 139, 240, 139, 243, 139, 246, 139, 249, 139, 252, 139, 255, 139, 0, 140, 2, 140, 4, 140, 7, 140, 12, 140, 15, 140, 17, 140, 18, 140, 20, 140, 21, 140, 22, 140, 25, 140, 27, 140, 24, 140, 29, 140, 31, 140, 32, 140, 33, 140, 37, 140, 39, 140, 42, 140, 43, 140, 46, 140, 47, 140, 50, 140, 51, 140, 53, 140, 54, 140, 105, 83, 122, 83, 29, 150, 34, 150, 33, 150, 49, 150, 42, 150, 61, 150, 60, 150, 66, 150, 73, 150, 84, 150, 95, 150, 103, 150, 108, 150, 114, 150, 116, 150, 136, 150, 141, 150, 151, 150, 176, 150, 151, 144, 155, 144, 157, 144, 153, 144, 172, 144, 161, 144, 180, 144, 179, 144, 182, 144, 186, 144, 213, 141, 216, 141, 217, 141, 220, 141, 224, 141, 225, 141, 226, 141, 229, 141, 230, 141, 231, 141, 233, 141, 237, 141, 238, 141, 240, 141, 241, 141, 242, 141, 244, 141, 246, 141, 252, 141, 254, 141, 255, 141, 0, 142, 1, 142, 2, 142, 3, 142, 4, 142, 6, 142, 7, 142, 8, 142, 11, 142, 13, 142, 14, 142, 16, 142, 17, 142, 18, 142, 19, 142, 21, 142, 22, 142, 23, 142, 24, 142, 25, 142, 26, 142, 27, 142, 28, 142, 32, 142, 33, 142, 36, 142, 37, 142, 38, 142, 39, 142, 40, 142, 43, 142, 45, 142, 48, 142, 50, 142, 51, 142, 52, 142, 54, 142, 55, 142, 56, 142, 59, 142, 60, 142, 62, 142, 63, 142, 67, 142, 69, 142, 70, 142, 76, 142, 77, 142, 78, 142, 79, 142, 80, 142, 83, 142, 84, 142, 85, 142, 86, 142, 87, 142, 88, 142, 90, 142, 91, 142, 92, 142, 93, 142, 94, 142, 95, 142, 96, 142, 97, 142, 98, 142, 99, 142, 100, 142, 101, 142, 103, 142, 104, 142, 106, 142, 107, 142, 110, 142, 113, 142, 184, 144, 176, 144, 207, 144, 197, 144, 190, 144, 208, 144, 196, 144, 199, 144, 211, 144, 230, 144, 226, 144, 220, 144, 215, 144, 219, 144, 235, 144, 239, 144, 254, 144, 4, 145, 34, 145, 30, 145, 35, 145, 49, 145, 47, 145, 57, 145, 67, 145, 70, 145, 13, 82, 66, 89, 162, 82, 172, 82, 173, 82, 190, 82, 255, 84, 208, 82, 214, 82, 240, 82, 223, 83, 238, 113, 205, 119, 244, 94, 245, 81, 252, 81, 47, 155, 182, 83, 1, 95, 90, 117, 239, 93, 76, 87, 169, 87, 161, 87, 126, 88, 188, 88, 197, 88, 209, 88, 41, 87, 44, 87, 42, 87, 51, 87, 57, 87, 46, 87, 47, 87, 92, 87, 59, 87, 66, 87, 105, 87, 133, 87, 107, 87, 134, 87, 124, 87, 123, 87, 104, 87, 109, 87, 118, 87, 115, 87, 173, 87, 164, 87, 140, 87, 178, 87, 207, 87, 167, 87, 180, 87, 147, 87, 160, 87, 213, 87, 216, 87, 218, 87, 217, 87, 210, 87, 184, 87, 244, 87, 239, 87, 248, 87, 228, 87, 221, 87, 115, 142, 117, 142, 119, 142, 120, 142, 121, 142, 122, 142, 123, 142, 125, 142, 126, 142, 128, 142, 130, 142, 131, 142, 132, 142, 134, 142, 136, 142, 137, 142, 138, 142, 139, 142, 140, 142, 141, 142, 142, 142, 145, 142, 146, 142, 147, 142, 149, 142, 150, 142, 151, 142, 152, 142, 153, 142, 154, 142, 155, 142, 157, 142, 159, 142, 160, 142, 161, 142, 162, 142, 163, 142, 164, 142, 165, 142, 166, 142, 167, 142, 168, 142, 169, 142, 170, 142, 173, 142, 174, 142, 176, 142, 177, 142, 179, 142, 180, 142, 181, 142, 182, 142, 183, 142, 184, 142, 185, 142, 187, 142, 188, 142, 189, 142, 190, 142, 191, 142, 192, 142, 193, 142, 194, 142, 195, 142, 196, 142, 197, 142, 198, 142, 199, 142, 200, 142, 201, 142, 202, 142, 203, 142, 204, 142, 205, 142, 207, 142, 208, 142, 209, 142, 210, 142, 211, 142, 212, 142, 213, 142, 214, 142, 215, 142, 216, 142, 217, 142, 218, 142, 219, 142, 220, 142, 221, 142, 222, 142, 223, 142, 224, 142, 225, 142, 226, 142, 227, 142, 228, 142, 11, 88, 13, 88, 253, 87, 237, 87, 0, 88, 30, 88, 25, 88, 68, 88, 32, 88, 101, 88, 108, 88, 129, 88, 137, 88, 154, 88, 128, 88, 168, 153, 25, 159, 255, 97, 121, 130, 125, 130, 127, 130, 143, 130, 138, 130, 168, 130, 132, 130, 142, 130, 145, 130, 151, 130, 153, 130, 171, 130, 184, 130, 190, 130, 176, 130, 200, 130, 202, 130, 227, 130, 152, 130, 183, 130, 174, 130, 203, 130, 204, 130, 193, 130, 169, 130, 180, 130, 161, 130, 170, 130, 159, 130, 196, 130, 206, 130, 164, 130, 225, 130, 9, 131, 247, 130, 228, 130, 15, 131, 7, 131, 220, 130, 244, 130, 210, 130, 216, 130, 12, 131, 251, 130, 211, 130, 17, 131, 26, 131, 6, 131, 20, 131, 21, 131, 224, 130, 213, 130, 28, 131, 81, 131, 91, 131, 92, 131, 8, 131, 146, 131, 60, 131, 52, 131, 49, 131, 155, 131, 94, 131, 47, 131, 79, 131, 71, 131, 67, 131, 95, 131, 64, 131, 23, 131, 96, 131, 45, 131, 58, 131, 51, 131, 102, 131, 101, 131, 229, 142, 230, 142, 231, 142, 232, 142, 233, 142, 234, 142, 235, 142, 236, 142, 237, 142, 238, 142, 239, 142, 240, 142, 241, 142, 242, 142, 243, 142, 244, 142, 245, 142, 246, 142, 247, 142, 248, 142, 249, 142, 250, 142, 251, 142, 252, 142, 253, 142, 254, 142, 255, 142, 0, 143, 1, 143, 2, 143, 3, 143, 4, 143, 5, 143, 6, 143, 7, 143, 8, 143, 9, 143, 10, 143, 11, 143, 12, 143, 13, 143, 14, 143, 15, 143, 16, 143, 17, 143, 18, 143, 19, 143, 20, 143, 21, 143, 22, 143, 23, 143, 24, 143, 25, 143, 26, 143, 27, 143, 28, 143, 29, 143, 30, 143, 31, 143, 32, 143, 33, 143, 34, 143, 35, 143, 36, 143, 37, 143, 38, 143, 39, 143, 40, 143, 41, 143, 42, 143, 43, 143, 44, 143, 45, 143, 46, 143, 47, 143, 48, 143, 49, 143, 50, 143, 51, 143, 52, 143, 53, 143, 54, 143, 55, 143, 56, 143, 57, 143, 58, 143, 59, 143, 60, 143, 61, 143, 62, 143, 63, 143, 64, 143, 65, 143, 66, 143, 67, 143, 68, 143, 104, 131, 27, 131, 105, 131, 108, 131, 106, 131, 109, 131, 110, 131, 176, 131, 120, 131, 179, 131, 180, 131, 160, 131, 170, 131, 147, 131, 156, 131, 133, 131, 124, 131, 182, 131, 169, 131, 125, 131, 184, 131, 123, 131, 152, 131, 158, 131, 168, 131, 186, 131, 188, 131, 193, 131, 1, 132, 229, 131, 216, 131, 7, 88, 24, 132, 11, 132, 221, 131, 253, 131, 214, 131, 28, 132, 56, 132, 17, 132, 6, 132, 212, 131, 223, 131, 15, 132, 3, 132, 248, 131, 249, 131, 234, 131, 197, 131, 192, 131, 38, 132, 240, 131, 225, 131, 92, 132, 81, 132, 90, 132, 89, 132, 115, 132, 135, 132, 136, 132, 122, 132, 137, 132, 120, 132, 60, 132, 70, 132, 105, 132, 118, 132, 140, 132, 142, 132, 49, 132, 109, 132, 193, 132, 205, 132, 208, 132, 230, 132, 189, 132, 211, 132, 202, 132, 191, 132, 186, 132, 224, 132, 161, 132, 185, 132, 180, 132, 151, 132, 229, 132, 227, 132, 12, 133, 13, 117, 56, 133, 240, 132, 57, 133, 31, 133, 58, 133, 69, 143, 70, 143, 71, 143, 72, 143, 73, 143, 74, 143, 75, 143, 76, 143, 77, 143, 78, 143, 79, 143, 80, 143, 81, 143, 82, 143, 83, 143, 84, 143, 85, 143, 86, 143, 87, 143, 88, 143, 89, 143, 90, 143, 91, 143, 92, 143, 93, 143, 94, 143, 95, 143, 96, 143, 97, 143, 98, 143, 99, 143, 100, 143, 101, 143, 106, 143, 128, 143, 140, 143, 146, 143, 157, 143, 160, 143, 161, 143, 162, 143, 164, 143, 165, 143, 166, 143, 167, 143, 170, 143, 172, 143, 173, 143, 174, 143, 175, 143, 178, 143, 179, 143, 180, 143, 181, 143, 183, 143, 184, 143, 186, 143, 187, 143, 188, 143, 191, 143, 192, 143, 195, 143, 198, 143, 201, 143, 202, 143, 203, 143, 204, 143, 205, 143, 207, 143, 210, 143, 214, 143, 215, 143, 218, 143, 224, 143, 225, 143, 227, 143, 231, 143, 236, 143, 239, 143, 241, 143, 242, 143, 244, 143, 245, 143, 246, 143, 250, 143, 251, 143, 252, 143, 254, 143, 255, 143, 7, 144, 8, 144, 12, 144, 14, 144, 19, 144, 21, 144, 24, 144, 86, 133, 59, 133, 255, 132, 252, 132, 89, 133, 72, 133, 104, 133, 100, 133, 94, 133, 122, 133, 162, 119, 67, 133, 114, 133, 123, 133, 164, 133, 168, 133, 135, 133, 143, 133, 121, 133, 174, 133, 156, 133, 133, 133, 185, 133, 183, 133, 176, 133, 211, 133, 193, 133, 220, 133, 255, 133, 39, 134, 5, 134, 41, 134, 22, 134, 60, 134, 254, 94, 8, 95, 60, 89, 65, 89, 55, 128, 85, 89, 90, 89, 88, 89, 15, 83, 34, 92, 37, 92, 44, 92, 52, 92, 76, 98, 106, 98, 159, 98, 187, 98, 202, 98, 218, 98, 215, 98, 238, 98, 34, 99, 246, 98, 57, 99, 75, 99, 67, 99, 173, 99, 246, 99, 113, 99, 122, 99, 142, 99, 180, 99, 109, 99, 172, 99, 138, 99, 105, 99, 174, 99, 188, 99, 242, 99, 248, 99, 224, 99, 255, 99, 196, 99, 222, 99, 206, 99, 82, 100, 198, 99, 190, 99, 69, 100, 65, 100, 11, 100, 27, 100, 32, 100, 12, 100, 38, 100, 33, 100, 94, 100, 132, 100, 109, 100, 150, 100, 25, 144, 28, 144, 35, 144, 36, 144, 37, 144, 39, 144, 40, 144, 41, 144, 42, 144, 43, 144, 44, 144, 48, 144, 49, 144, 50, 144, 51, 144, 52, 144, 55, 144, 57, 144, 58, 144, 61, 144, 63, 144, 64, 144, 67, 144, 69, 144, 70, 144, 72, 144, 73, 144, 74, 144, 75, 144, 76, 144, 78, 144, 84, 144, 85, 144, 86, 144, 89, 144, 90, 144, 92, 144, 93, 144, 94, 144, 95, 144, 96, 144, 97, 144, 100, 144, 102, 144, 103, 144, 105, 144, 106, 144, 107, 144, 108, 144, 111, 144, 112, 144, 113, 144, 114, 144, 115, 144, 118, 144, 119, 144, 120, 144, 121, 144, 122, 144, 123, 144, 124, 144, 126, 144, 129, 144, 132, 144, 133, 144, 134, 144, 135, 144, 137, 144, 138, 144, 140, 144, 141, 144, 142, 144, 143, 144, 144, 144, 146, 144, 148, 144, 150, 144, 152, 144, 154, 144, 156, 144, 158, 144, 159, 144, 160, 144, 164, 144, 165, 144, 167, 144, 168, 144, 169, 144, 171, 144, 173, 144, 178, 144, 183, 144, 188, 144, 189, 144, 191, 144, 192, 144, 122, 100, 183, 100, 184, 100, 153, 100, 186, 100, 192, 100, 208, 100, 215, 100, 228, 100, 226, 100, 9, 101, 37, 101, 46, 101, 11, 95, 210, 95, 25, 117, 17, 95, 95, 83, 241, 83, 253, 83, 233, 83, 232, 83, 251, 83, 18, 84, 22, 84, 6, 84, 75, 84, 82, 84, 83, 84, 84, 84, 86, 84, 67, 84, 33, 84, 87, 84, 89, 84, 35, 84, 50, 84, 130, 84, 148, 84, 119, 84, 113, 84, 100, 84, 154, 84, 155, 84, 132, 84, 118, 84, 102, 84, 157, 84, 208, 84, 173, 84, 194, 84, 180, 84, 210, 84, 167, 84, 166, 84, 211, 84, 212, 84, 114, 84, 163, 84, 213, 84, 187, 84, 191, 84, 204, 84, 217, 84, 218, 84, 220, 84, 169, 84, 170, 84, 164, 84, 221, 84, 207, 84, 222, 84, 27, 85, 231, 84, 32, 85, 253, 84, 20, 85, 243, 84, 34, 85, 35, 85, 15, 85, 17, 85, 39, 85, 42, 85, 103, 85, 143, 85, 181, 85, 73, 85, 109, 85, 65, 85, 85, 85, 63, 85, 80, 85, 60, 85, 194, 144, 195, 144, 198, 144, 200, 144, 201, 144, 203, 144, 204, 144, 205, 144, 210, 144, 212, 144, 213, 144, 214, 144, 216, 144, 217, 144, 218, 144, 222, 144, 223, 144, 224, 144, 227, 144, 228, 144, 229, 144, 233, 144, 234, 144, 236, 144, 238, 144, 240, 144, 241, 144, 242, 144, 243, 144, 245, 144, 246, 144, 247, 144, 249, 144, 250, 144, 251, 144, 252, 144, 255, 144, 0, 145, 1, 145, 3, 145, 5, 145, 6, 145, 7, 145, 8, 145, 9, 145, 10, 145, 11, 145, 12, 145, 13, 145, 14, 145, 15, 145, 16, 145, 17, 145, 18, 145, 19, 145, 20, 145, 21, 145, 22, 145, 23, 145, 24, 145, 26, 145, 27, 145, 28, 145, 29, 145, 31, 145, 32, 145, 33, 145, 36, 145, 37, 145, 38, 145, 39, 145, 40, 145, 41, 145, 42, 145, 43, 145, 44, 145, 45, 145, 46, 145, 48, 145, 50, 145, 51, 145, 52, 145, 53, 145, 54, 145, 55, 145, 56, 145, 58, 145, 59, 145, 60, 145, 61, 145, 62, 145, 63, 145, 64, 145, 65, 145, 66, 145, 68, 145, 55, 85, 86, 85, 117, 85, 118, 85, 119, 85, 51, 85, 48, 85, 92, 85, 139, 85, 210, 85, 131, 85, 177, 85, 185, 85, 136, 85, 129, 85, 159, 85, 126, 85, 214, 85, 145, 85, 123, 85, 223, 85, 189, 85, 190, 85, 148, 85, 153, 85, 234, 85, 247, 85, 201, 85, 31, 86, 209, 85, 235, 85, 236, 85, 212, 85, 230, 85, 221, 85, 196, 85, 239, 85, 229, 85, 242, 85, 243, 85, 204, 85, 205, 85, 232, 85, 245, 85, 228, 85, 148, 143, 30, 86, 8, 86, 12, 86, 1, 86, 36, 86, 35, 86, 254, 85, 0, 86, 39, 86, 45, 86, 88, 86, 57, 86, 87, 86, 44, 86, 77, 86, 98, 86, 89, 86, 92, 86, 76, 86, 84, 86, 134, 86, 100, 86, 113, 86, 107, 86, 123, 86, 124, 86, 133, 86, 147, 86, 175, 86, 212, 86, 215, 86, 221, 86, 225, 86, 245, 86, 235, 86, 249, 86, 255, 86, 4, 87, 10, 87, 9, 87, 28, 87, 15, 94, 25, 94, 20, 94, 17, 94, 49, 94, 59, 94, 60, 94, 69, 145, 71, 145, 72, 145, 81, 145, 83, 145, 84, 145, 85, 145, 86, 145, 88, 145, 89, 145, 91, 145, 92, 145, 95, 145, 96, 145, 102, 145, 103, 145, 104, 145, 107, 145, 109, 145, 115, 145, 122, 145, 123, 145, 124, 145, 128, 145, 129, 145, 130, 145, 131, 145, 132, 145, 134, 145, 136, 145, 138, 145, 142, 145, 143, 145, 147, 145, 148, 145, 149, 145, 150, 145, 151, 145, 152, 145, 153, 145, 156, 145, 157, 145, 158, 145, 159, 145, 160, 145, 161, 145, 164, 145, 165, 145, 166, 145, 167, 145, 168, 145, 169, 145, 171, 145, 172, 145, 176, 145, 177, 145, 178, 145, 179, 145, 182, 145, 183, 145, 184, 145, 185, 145, 187, 145, 188, 145, 189, 145, 190, 145, 191, 145, 192, 145, 193, 145, 194, 145, 195, 145, 196, 145, 197, 145, 198, 145, 200, 145, 203, 145, 208, 145, 210, 145, 211, 145, 212, 145, 213, 145, 214, 145, 215, 145, 216, 145, 217, 145, 218, 145, 219, 145, 221, 145, 222, 145, 223, 145, 224, 145, 225, 145, 226, 145, 227, 145, 228, 145, 229, 145, 55, 94, 68, 94, 84, 94, 91, 94, 94, 94, 97, 94, 140, 92, 122, 92, 141, 92, 144, 92, 150, 92, 136, 92, 152, 92, 153, 92, 145, 92, 154, 92, 156, 92, 181, 92, 162, 92, 189, 92, 172, 92, 171, 92, 177, 92, 163, 92, 193, 92, 183, 92, 196, 92, 210, 92, 228, 92, 203, 92, 229, 92, 2, 93, 3, 93, 39, 93, 38, 93, 46, 93, 36, 93, 30, 93, 6, 93, 27, 93, 88, 93, 62, 93, 52, 93, 61, 93, 108, 93, 91, 93, 111, 93, 93, 93, 107, 93, 75, 93, 74, 93, 105, 93, 116, 93, 130, 93, 153, 93, 157, 93, 115, 140, 183, 93, 197, 93, 115, 95, 119, 95, 130, 95, 135, 95, 137, 95, 140, 95, 149, 95, 153, 95, 156, 95, 168, 95, 173, 95, 181, 95, 188, 95, 98, 136, 97, 95, 173, 114, 176, 114, 180, 114, 183, 114, 184, 114, 195, 114, 193, 114, 206, 114, 205, 114, 210, 114, 232, 114, 239, 114, 233, 114, 242, 114, 244, 114, 247, 114, 1, 115, 243, 114, 3, 115, 250, 114, 230, 145, 231, 145, 232, 145, 233, 145, 234, 145, 235, 145, 236, 145, 237, 145, 238, 145, 239, 145, 240, 145, 241, 145, 242, 145, 243, 145, 244, 145, 245, 145, 246, 145, 247, 145, 248, 145, 249, 145, 250, 145, 251, 145, 252, 145, 253, 145, 254, 145, 255, 145, 0, 146, 1, 146, 2, 146, 3, 146, 4, 146, 5, 146, 6, 146, 7, 146, 8, 146, 9, 146, 10, 146, 11, 146, 12, 146, 13, 146, 14, 146, 15, 146, 16, 146, 17, 146, 18, 146, 19, 146, 20, 146, 21, 146, 22, 146, 23, 146, 24, 146, 25, 146, 26, 146, 27, 146, 28, 146, 29, 146, 30, 146, 31, 146, 32, 146, 33, 146, 34, 146, 35, 146, 36, 146, 37, 146, 38, 146, 39, 146, 40, 146, 41, 146, 42, 146, 43, 146, 44, 146, 45, 146, 46, 146, 47, 146, 48, 146, 49, 146, 50, 146, 51, 146, 52, 146, 53, 146, 54, 146, 55, 146, 56, 146, 57, 146, 58, 146, 59, 146, 60, 146, 61, 146, 62, 146, 63, 146, 64, 146, 65, 146, 66, 146, 67, 146, 68, 146, 69, 146, 251, 114, 23, 115, 19, 115, 33, 115, 10, 115, 30, 115, 29, 115, 21, 115, 34, 115, 57, 115, 37, 115, 44, 115, 56, 115, 49, 115, 80, 115, 77, 115, 87, 115, 96, 115, 108, 115, 111, 115, 126, 115, 27, 130, 37, 89, 231, 152, 36, 89, 2, 89, 99, 153, 103, 153, 104, 153, 105, 153, 106, 153, 107, 153, 108, 153, 116, 153, 119, 153, 125, 153, 128, 153, 132, 153, 135, 153, 138, 153, 141, 153, 144, 153, 145, 153, 147, 153, 148, 153, 149, 153, 128, 94, 145, 94, 139, 94, 150, 94, 165, 94, 160, 94, 185, 94, 181, 94, 190, 94, 179, 94, 83, 141, 210, 94, 209, 94, 219, 94, 232, 94, 234, 94, 186, 129, 196, 95, 201, 95, 214, 95, 207, 95, 3, 96, 238, 95, 4, 96, 225, 95, 228, 95, 254, 95, 5, 96, 6, 96, 234, 95, 237, 95, 248, 95, 25, 96, 53, 96, 38, 96, 27, 96, 15, 96, 13, 96, 41, 96, 43, 96, 10, 96, 63, 96, 33, 96, 120, 96, 121, 96, 123, 96, 122, 96, 66, 96, 70, 146, 71, 146, 72, 146, 73, 146, 74, 146, 75, 146, 76, 146, 77, 146, 78, 146, 79, 146, 80, 146, 81, 146, 82, 146, 83, 146, 84, 146, 85, 146, 86, 146, 87, 146, 88, 146, 89, 146, 90, 146, 91, 146, 92, 146, 93, 146, 94, 146, 95, 146, 96, 146, 97, 146, 98, 146, 99, 146, 100, 146, 101, 146, 102, 146, 103, 146, 104, 146, 105, 146, 106, 146, 107, 146, 108, 146, 109, 146, 110, 146, 111, 146, 112, 146, 113, 146, 114, 146, 115, 146, 117, 146, 118, 146, 119, 146, 120, 146, 121, 146, 122, 146, 123, 146, 124, 146, 125, 146, 126, 146, 127, 146, 128, 146, 129, 146, 130, 146, 131, 146, 132, 146, 133, 146, 134, 146, 135, 146, 136, 146, 137, 146, 138, 146, 139, 146, 140, 146, 141, 146, 143, 146, 144, 146, 145, 146, 146, 146, 147, 146, 148, 146, 149, 146, 150, 146, 151, 146, 152, 146, 153, 146, 154, 146, 155, 146, 156, 146, 157, 146, 158, 146, 159, 146, 160, 146, 161, 146, 162, 146, 163, 146, 164, 146, 165, 146, 166, 146, 167, 146, 106, 96, 125, 96, 150, 96, 154, 96, 173, 96, 157, 96, 131, 96, 146, 96, 140, 96, 155, 96, 236, 96, 187, 96, 177, 96, 221, 96, 216, 96, 198, 96, 218, 96, 180, 96, 32, 97, 38, 97, 21, 97, 35, 97, 244, 96, 0, 97, 14, 97, 43, 97, 74, 97, 117, 97, 172, 97, 148, 97, 167, 97, 183, 97, 212, 97, 245, 97, 221, 95, 179, 150, 233, 149, 235, 149, 241, 149, 243, 149, 245, 149, 246, 149, 252, 149, 254, 149, 3, 150, 4, 150, 6, 150, 8, 150, 10, 150, 11, 150, 12, 150, 13, 150, 15, 150, 18, 150, 21, 150, 22, 150, 23, 150, 25, 150, 26, 150, 44, 78, 63, 114, 21, 98, 53, 108, 84, 108, 92, 108, 74, 108, 163, 108, 133, 108, 144, 108, 148, 108, 140, 108, 104, 108, 105, 108, 116, 108, 118, 108, 134, 108, 169, 108, 208, 108, 212, 108, 173, 108, 247, 108, 248, 108, 241, 108, 215, 108, 178, 108, 224, 108, 214, 108, 250, 108, 235, 108, 238, 108, 177, 108, 211, 108, 239, 108, 254, 108, 168, 146, 169, 146, 170, 146, 171, 146, 172, 146, 173, 146, 175, 146, 176, 146, 177, 146, 178, 146, 179, 146, 180, 146, 181, 146, 182, 146, 183, 146, 184, 146, 185, 146, 186, 146, 187, 146, 188, 146, 189, 146, 190, 146, 191, 146, 192, 146, 193, 146, 194, 146, 195, 146, 196, 146, 197, 146, 198, 146, 199, 146, 201, 146, 202, 146, 203, 146, 204, 146, 205, 146, 206, 146, 207, 146, 208, 146, 209, 146, 210, 146, 211, 146, 212, 146, 213, 146, 214, 146, 215, 146, 216, 146, 217, 146, 218, 146, 219, 146, 220, 146, 221, 146, 222, 146, 223, 146, 224, 146, 225, 146, 226, 146, 227, 146, 228, 146, 229, 146, 230, 146, 231, 146, 232, 146, 233, 146, 234, 146, 235, 146, 236, 146, 237, 146, 238, 146, 239, 146, 240, 146, 241, 146, 242, 146, 243, 146, 244, 146, 245, 146, 246, 146, 247, 146, 248, 146, 249, 146, 250, 146, 251, 146, 252, 146, 253, 146, 254, 146, 255, 146, 0, 147, 1, 147, 2, 147, 3, 147, 4, 147, 5, 147, 6, 147, 7, 147, 8, 147, 9, 147, 57, 109, 39, 109, 12, 109, 67, 109, 72, 109, 7, 109, 4, 109, 25, 109, 14, 109, 43, 109, 77, 109, 46, 109, 53, 109, 26, 109, 79, 109, 82, 109, 84, 109, 51, 109, 145, 109, 111, 109, 158, 109, 160, 109, 94, 109, 147, 109, 148, 109, 92, 109, 96, 109, 124, 109, 99, 109, 26, 110, 199, 109, 197, 109, 222, 109, 14, 110, 191, 109, 224, 109, 17, 110, 230, 109, 221, 109, 217, 109, 22, 110, 171, 109, 12, 110, 174, 109, 43, 110, 110, 110, 78, 110, 107, 110, 178, 110, 95, 110, 134, 110, 83, 110, 84, 110, 50, 110, 37, 110, 68, 110, 223, 110, 177, 110, 152, 110, 224, 110, 45, 111, 226, 110, 165, 110, 167, 110, 189, 110, 187, 110, 183, 110, 215, 110, 180, 110, 207, 110, 143, 110, 194, 110, 159, 110, 98, 111, 70, 111, 71, 111, 36, 111, 21, 111, 249, 110, 47, 111, 54, 111, 75, 111, 116, 111, 42, 111, 9, 111, 41, 111, 137, 111, 141, 111, 140, 111, 120, 111, 114, 111, 124, 111, 122, 111, 209, 111, 10, 147, 11, 147, 12, 147, 13, 147, 14, 147, 15, 147, 16, 147, 17, 147, 18, 147, 19, 147, 20, 147, 21, 147, 22, 147, 23, 147, 24, 147, 25, 147, 26, 147, 27, 147, 28, 147, 29, 147, 30, 147, 31, 147, 32, 147, 33, 147, 34, 147, 35, 147, 36, 147, 37, 147, 38, 147, 39, 147, 40, 147, 41, 147, 42, 147, 43, 147, 44, 147, 45, 147, 46, 147, 47, 147, 48, 147, 49, 147, 50, 147, 51, 147, 52, 147, 53, 147, 54, 147, 55, 147, 56, 147, 57, 147, 58, 147, 59, 147, 60, 147, 61, 147, 63, 147, 64, 147, 65, 147, 66, 147, 67, 147, 68, 147, 69, 147, 70, 147, 71, 147, 72, 147, 73, 147, 74, 147, 75, 147, 76, 147, 77, 147, 78, 147, 79, 147, 80, 147, 81, 147, 82, 147, 83, 147, 84, 147, 85, 147, 86, 147, 87, 147, 88, 147, 89, 147, 90, 147, 91, 147, 92, 147, 93, 147, 94, 147, 95, 147, 96, 147, 97, 147, 98, 147, 99, 147, 100, 147, 101, 147, 102, 147, 103, 147, 104, 147, 105, 147, 107, 147, 201, 111, 167, 111, 185, 111, 182, 111, 194, 111, 225, 111, 238, 111, 222, 111, 224, 111, 239, 111, 26, 112, 35, 112, 27, 112, 57, 112, 53, 112, 79, 112, 94, 112, 128, 91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 251068);
	        allocate([132, 91, 149, 91, 147, 91, 165, 91, 184, 91, 47, 117, 158, 154, 52, 100, 228, 91, 238, 91, 48, 137, 240, 91, 71, 142, 7, 139, 182, 143, 211, 143, 213, 143, 229, 143, 238, 143, 228, 143, 233, 143, 230, 143, 243, 143, 232, 143, 5, 144, 4, 144, 11, 144, 38, 144, 17, 144, 13, 144, 22, 144, 33, 144, 53, 144, 54, 144, 45, 144, 47, 144, 68, 144, 81, 144, 82, 144, 80, 144, 104, 144, 88, 144, 98, 144, 91, 144, 185, 102, 116, 144, 125, 144, 130, 144, 136, 144, 131, 144, 139, 144, 80, 95, 87, 95, 86, 95, 88, 95, 59, 92, 171, 84, 80, 92, 89, 92, 113, 91, 99, 92, 102, 92, 188, 127, 42, 95, 41, 95, 45, 95, 116, 130, 60, 95, 59, 155, 110, 92, 129, 89, 131, 89, 141, 89, 169, 89, 170, 89, 163, 89, 108, 147, 109, 147, 110, 147, 111, 147, 112, 147, 113, 147, 114, 147, 115, 147, 116, 147, 117, 147, 118, 147, 119, 147, 120, 147, 121, 147, 122, 147, 123, 147, 124, 147, 125, 147, 126, 147, 127, 147, 128, 147, 129, 147, 130, 147, 131, 147, 132, 147, 133, 147, 134, 147, 135, 147, 136, 147, 137, 147, 138, 147, 139, 147, 140, 147, 141, 147, 142, 147, 144, 147, 145, 147, 146, 147, 147, 147, 148, 147, 149, 147, 150, 147, 151, 147, 152, 147, 153, 147, 154, 147, 155, 147, 156, 147, 157, 147, 158, 147, 159, 147, 160, 147, 161, 147, 162, 147, 163, 147, 164, 147, 165, 147, 166, 147, 167, 147, 168, 147, 169, 147, 170, 147, 171, 147, 172, 147, 173, 147, 174, 147, 175, 147, 176, 147, 177, 147, 178, 147, 179, 147, 180, 147, 181, 147, 182, 147, 183, 147, 184, 147, 185, 147, 186, 147, 187, 147, 188, 147, 189, 147, 190, 147, 191, 147, 192, 147, 193, 147, 194, 147, 195, 147, 196, 147, 197, 147, 198, 147, 199, 147, 200, 147, 201, 147, 203, 147, 204, 147, 205, 147, 151, 89, 202, 89, 171, 89, 158, 89, 164, 89, 210, 89, 178, 89, 175, 89, 215, 89, 190, 89, 5, 90, 6, 90, 221, 89, 8, 90, 227, 89, 216, 89, 249, 89, 12, 90, 9, 90, 50, 90, 52, 90, 17, 90, 35, 90, 19, 90, 64, 90, 103, 90, 74, 90, 85, 90, 60, 90, 98, 90, 117, 90, 236, 128, 170, 90, 155, 90, 119, 90, 122, 90, 190, 90, 235, 90, 178, 90, 210, 90, 212, 90, 184, 90, 224, 90, 227, 90, 241, 90, 214, 90, 230, 90, 216, 90, 220, 90, 9, 91, 23, 91, 22, 91, 50, 91, 55, 91, 64, 91, 21, 92, 28, 92, 90, 91, 101, 91, 115, 91, 81, 91, 83, 91, 98, 91, 117, 154, 119, 154, 120, 154, 122, 154, 127, 154, 125, 154, 128, 154, 129, 154, 133, 154, 136, 154, 138, 154, 144, 154, 146, 154, 147, 154, 150, 154, 152, 154, 155, 154, 156, 154, 157, 154, 159, 154, 160, 154, 162, 154, 163, 154, 165, 154, 167, 154, 159, 126, 161, 126, 163, 126, 165, 126, 168, 126, 169, 126, 206, 147, 207, 147, 208, 147, 209, 147, 210, 147, 211, 147, 212, 147, 213, 147, 215, 147, 216, 147, 217, 147, 218, 147, 219, 147, 220, 147, 221, 147, 222, 147, 223, 147, 224, 147, 225, 147, 226, 147, 227, 147, 228, 147, 229, 147, 230, 147, 231, 147, 232, 147, 233, 147, 234, 147, 235, 147, 236, 147, 237, 147, 238, 147, 239, 147, 240, 147, 241, 147, 242, 147, 243, 147, 244, 147, 245, 147, 246, 147, 247, 147, 248, 147, 249, 147, 250, 147, 251, 147, 252, 147, 253, 147, 254, 147, 255, 147, 0, 148, 1, 148, 2, 148, 3, 148, 4, 148, 5, 148, 6, 148, 7, 148, 8, 148, 9, 148, 10, 148, 11, 148, 12, 148, 13, 148, 14, 148, 15, 148, 16, 148, 17, 148, 18, 148, 19, 148, 20, 148, 21, 148, 22, 148, 23, 148, 24, 148, 25, 148, 26, 148, 27, 148, 28, 148, 29, 148, 30, 148, 31, 148, 32, 148, 33, 148, 34, 148, 35, 148, 36, 148, 37, 148, 38, 148, 39, 148, 40, 148, 41, 148, 42, 148, 43, 148, 44, 148, 45, 148, 46, 148, 173, 126, 176, 126, 190, 126, 192, 126, 193, 126, 194, 126, 201, 126, 203, 126, 204, 126, 208, 126, 212, 126, 215, 126, 219, 126, 224, 126, 225, 126, 232, 126, 235, 126, 238, 126, 239, 126, 241, 126, 242, 126, 13, 127, 246, 126, 250, 126, 251, 126, 254, 126, 1, 127, 2, 127, 3, 127, 7, 127, 8, 127, 11, 127, 12, 127, 15, 127, 17, 127, 18, 127, 23, 127, 25, 127, 28, 127, 27, 127, 31, 127, 33, 127, 34, 127, 35, 127, 36, 127, 37, 127, 38, 127, 39, 127, 42, 127, 43, 127, 44, 127, 45, 127, 47, 127, 48, 127, 49, 127, 50, 127, 51, 127, 53, 127, 122, 94, 127, 117, 219, 93, 62, 117, 149, 144, 142, 115, 145, 115, 174, 115, 162, 115, 159, 115, 207, 115, 194, 115, 209, 115, 183, 115, 179, 115, 192, 115, 201, 115, 200, 115, 229, 115, 217, 115, 124, 152, 10, 116, 233, 115, 231, 115, 222, 115, 186, 115, 242, 115, 15, 116, 42, 116, 91, 116, 38, 116, 37, 116, 40, 116, 48, 116, 46, 116, 44, 116, 47, 148, 48, 148, 49, 148, 50, 148, 51, 148, 52, 148, 53, 148, 54, 148, 55, 148, 56, 148, 57, 148, 58, 148, 59, 148, 60, 148, 61, 148, 63, 148, 64, 148, 65, 148, 66, 148, 67, 148, 68, 148, 69, 148, 70, 148, 71, 148, 72, 148, 73, 148, 74, 148, 75, 148, 76, 148, 77, 148, 78, 148, 79, 148, 80, 148, 81, 148, 82, 148, 83, 148, 84, 148, 85, 148, 86, 148, 87, 148, 88, 148, 89, 148, 90, 148, 91, 148, 92, 148, 93, 148, 94, 148, 95, 148, 96, 148, 97, 148, 98, 148, 99, 148, 100, 148, 101, 148, 102, 148, 103, 148, 104, 148, 105, 148, 106, 148, 108, 148, 109, 148, 110, 148, 111, 148, 112, 148, 113, 148, 114, 148, 115, 148, 116, 148, 117, 148, 118, 148, 119, 148, 120, 148, 121, 148, 122, 148, 123, 148, 124, 148, 125, 148, 126, 148, 127, 148, 128, 148, 129, 148, 130, 148, 131, 148, 132, 148, 145, 148, 150, 148, 152, 148, 199, 148, 207, 148, 211, 148, 212, 148, 218, 148, 230, 148, 251, 148, 28, 149, 32, 149, 27, 116, 26, 116, 65, 116, 92, 116, 87, 116, 85, 116, 89, 116, 119, 116, 109, 116, 126, 116, 156, 116, 142, 116, 128, 116, 129, 116, 135, 116, 139, 116, 158, 116, 168, 116, 169, 116, 144, 116, 167, 116, 210, 116, 186, 116, 234, 151, 235, 151, 236, 151, 76, 103, 83, 103, 94, 103, 72, 103, 105, 103, 165, 103, 135, 103, 106, 103, 115, 103, 152, 103, 167, 103, 117, 103, 168, 103, 158, 103, 173, 103, 139, 103, 119, 103, 124, 103, 240, 103, 9, 104, 216, 103, 10, 104, 233, 103, 176, 103, 12, 104, 217, 103, 181, 103, 218, 103, 179, 103, 221, 103, 0, 104, 195, 103, 184, 103, 226, 103, 14, 104, 193, 103, 253, 103, 50, 104, 51, 104, 96, 104, 97, 104, 78, 104, 98, 104, 68, 104, 100, 104, 131, 104, 29, 104, 85, 104, 102, 104, 65, 104, 103, 104, 64, 104, 62, 104, 74, 104, 73, 104, 41, 104, 181, 104, 143, 104, 116, 104, 119, 104, 147, 104, 107, 104, 194, 104, 110, 105, 252, 104, 31, 105, 32, 105, 249, 104, 39, 149, 51, 149, 61, 149, 67, 149, 72, 149, 75, 149, 85, 149, 90, 149, 96, 149, 110, 149, 116, 149, 117, 149, 119, 149, 120, 149, 121, 149, 122, 149, 123, 149, 124, 149, 125, 149, 126, 149, 128, 149, 129, 149, 130, 149, 131, 149, 132, 149, 133, 149, 134, 149, 135, 149, 136, 149, 137, 149, 138, 149, 139, 149, 140, 149, 141, 149, 142, 149, 143, 149, 144, 149, 145, 149, 146, 149, 147, 149, 148, 149, 149, 149, 150, 149, 151, 149, 152, 149, 153, 149, 154, 149, 155, 149, 156, 149, 157, 149, 158, 149, 159, 149, 160, 149, 161, 149, 162, 149, 163, 149, 164, 149, 165, 149, 166, 149, 167, 149, 168, 149, 169, 149, 170, 149, 171, 149, 172, 149, 173, 149, 174, 149, 175, 149, 176, 149, 177, 149, 178, 149, 179, 149, 180, 149, 181, 149, 182, 149, 183, 149, 184, 149, 185, 149, 186, 149, 187, 149, 188, 149, 189, 149, 190, 149, 191, 149, 192, 149, 193, 149, 194, 149, 195, 149, 196, 149, 197, 149, 198, 149, 199, 149, 200, 149, 201, 149, 202, 149, 203, 149, 36, 105, 240, 104, 11, 105, 1, 105, 87, 105, 227, 104, 16, 105, 113, 105, 57, 105, 96, 105, 66, 105, 93, 105, 132, 105, 107, 105, 128, 105, 152, 105, 120, 105, 52, 105, 204, 105, 135, 105, 136, 105, 206, 105, 137, 105, 102, 105, 99, 105, 121, 105, 155, 105, 167, 105, 187, 105, 171, 105, 173, 105, 212, 105, 177, 105, 193, 105, 202, 105, 223, 105, 149, 105, 224, 105, 141, 105, 255, 105, 47, 106, 237, 105, 23, 106, 24, 106, 101, 106, 242, 105, 68, 106, 62, 106, 160, 106, 80, 106, 91, 106, 53, 106, 142, 106, 121, 106, 61, 106, 40, 106, 88, 106, 124, 106, 145, 106, 144, 106, 169, 106, 151, 106, 171, 106, 55, 115, 82, 115, 129, 107, 130, 107, 135, 107, 132, 107, 146, 107, 147, 107, 141, 107, 154, 107, 155, 107, 161, 107, 170, 107, 107, 143, 109, 143, 113, 143, 114, 143, 115, 143, 117, 143, 118, 143, 120, 143, 119, 143, 121, 143, 122, 143, 124, 143, 126, 143, 129, 143, 130, 143, 132, 143, 135, 143, 139, 143, 204, 149, 205, 149, 206, 149, 207, 149, 208, 149, 209, 149, 210, 149, 211, 149, 212, 149, 213, 149, 214, 149, 215, 149, 216, 149, 217, 149, 218, 149, 219, 149, 220, 149, 221, 149, 222, 149, 223, 149, 224, 149, 225, 149, 226, 149, 227, 149, 228, 149, 229, 149, 230, 149, 231, 149, 236, 149, 255, 149, 7, 150, 19, 150, 24, 150, 27, 150, 30, 150, 32, 150, 35, 150, 36, 150, 37, 150, 38, 150, 39, 150, 40, 150, 41, 150, 43, 150, 44, 150, 45, 150, 47, 150, 48, 150, 55, 150, 56, 150, 57, 150, 58, 150, 62, 150, 65, 150, 67, 150, 74, 150, 78, 150, 79, 150, 81, 150, 82, 150, 83, 150, 86, 150, 87, 150, 88, 150, 89, 150, 90, 150, 92, 150, 93, 150, 94, 150, 96, 150, 99, 150, 101, 150, 102, 150, 107, 150, 109, 150, 110, 150, 111, 150, 112, 150, 113, 150, 115, 150, 120, 150, 121, 150, 122, 150, 123, 150, 124, 150, 125, 150, 126, 150, 127, 150, 128, 150, 129, 150, 130, 150, 131, 150, 132, 150, 135, 150, 137, 150, 138, 150, 141, 143, 142, 143, 143, 143, 152, 143, 154, 143, 206, 142, 11, 98, 23, 98, 27, 98, 31, 98, 34, 98, 33, 98, 37, 98, 36, 98, 44, 98, 231, 129, 239, 116, 244, 116, 255, 116, 15, 117, 17, 117, 19, 117, 52, 101, 238, 101, 239, 101, 240, 101, 10, 102, 25, 102, 114, 103, 3, 102, 21, 102, 0, 102, 133, 112, 247, 102, 29, 102, 52, 102, 49, 102, 54, 102, 53, 102, 6, 128, 95, 102, 84, 102, 65, 102, 79, 102, 86, 102, 97, 102, 87, 102, 119, 102, 132, 102, 140, 102, 167, 102, 157, 102, 190, 102, 219, 102, 220, 102, 230, 102, 233, 102, 50, 141, 51, 141, 54, 141, 59, 141, 61, 141, 64, 141, 69, 141, 70, 141, 72, 141, 73, 141, 71, 141, 77, 141, 85, 141, 89, 141, 199, 137, 202, 137, 203, 137, 204, 137, 206, 137, 207, 137, 208, 137, 209, 137, 110, 114, 159, 114, 93, 114, 102, 114, 111, 114, 126, 114, 127, 114, 132, 114, 139, 114, 141, 114, 143, 114, 146, 114, 8, 99, 50, 99, 176, 99, 140, 150, 142, 150, 145, 150, 146, 150, 147, 150, 149, 150, 150, 150, 154, 150, 155, 150, 157, 150, 158, 150, 159, 150, 160, 150, 161, 150, 162, 150, 163, 150, 164, 150, 165, 150, 166, 150, 168, 150, 169, 150, 170, 150, 171, 150, 172, 150, 173, 150, 174, 150, 175, 150, 177, 150, 178, 150, 180, 150, 181, 150, 183, 150, 184, 150, 186, 150, 187, 150, 191, 150, 194, 150, 195, 150, 200, 150, 202, 150, 203, 150, 208, 150, 209, 150, 211, 150, 212, 150, 214, 150, 215, 150, 216, 150, 217, 150, 218, 150, 219, 150, 220, 150, 221, 150, 222, 150, 223, 150, 225, 150, 226, 150, 227, 150, 228, 150, 229, 150, 230, 150, 231, 150, 235, 150, 236, 150, 237, 150, 238, 150, 240, 150, 241, 150, 242, 150, 244, 150, 245, 150, 248, 150, 250, 150, 251, 150, 252, 150, 253, 150, 255, 150, 2, 151, 3, 151, 5, 151, 10, 151, 11, 151, 12, 151, 16, 151, 17, 151, 18, 151, 20, 151, 21, 151, 23, 151, 24, 151, 25, 151, 26, 151, 27, 151, 29, 151, 31, 151, 32, 151, 63, 100, 216, 100, 4, 128, 234, 107, 243, 107, 253, 107, 245, 107, 249, 107, 5, 108, 7, 108, 6, 108, 13, 108, 21, 108, 24, 108, 25, 108, 26, 108, 33, 108, 41, 108, 36, 108, 42, 108, 50, 108, 53, 101, 85, 101, 107, 101, 77, 114, 82, 114, 86, 114, 48, 114, 98, 134, 22, 82, 159, 128, 156, 128, 147, 128, 188, 128, 10, 103, 189, 128, 177, 128, 171, 128, 173, 128, 180, 128, 183, 128, 231, 128, 232, 128, 233, 128, 234, 128, 219, 128, 194, 128, 196, 128, 217, 128, 205, 128, 215, 128, 16, 103, 221, 128, 235, 128, 241, 128, 244, 128, 237, 128, 13, 129, 14, 129, 242, 128, 252, 128, 21, 103, 18, 129, 90, 140, 54, 129, 30, 129, 44, 129, 24, 129, 50, 129, 72, 129, 76, 129, 83, 129, 116, 129, 89, 129, 90, 129, 113, 129, 96, 129, 105, 129, 124, 129, 125, 129, 109, 129, 103, 129, 77, 88, 181, 90, 136, 129, 130, 129, 145, 129, 213, 110, 163, 129, 170, 129, 204, 129, 38, 103, 202, 129, 187, 129, 33, 151, 34, 151, 35, 151, 36, 151, 37, 151, 38, 151, 39, 151, 40, 151, 41, 151, 43, 151, 44, 151, 46, 151, 47, 151, 49, 151, 51, 151, 52, 151, 53, 151, 54, 151, 55, 151, 58, 151, 59, 151, 60, 151, 61, 151, 63, 151, 64, 151, 65, 151, 66, 151, 67, 151, 68, 151, 69, 151, 70, 151, 71, 151, 72, 151, 73, 151, 74, 151, 75, 151, 76, 151, 77, 151, 78, 151, 79, 151, 80, 151, 81, 151, 84, 151, 85, 151, 87, 151, 88, 151, 90, 151, 92, 151, 93, 151, 95, 151, 99, 151, 100, 151, 102, 151, 103, 151, 104, 151, 106, 151, 107, 151, 108, 151, 109, 151, 110, 151, 111, 151, 112, 151, 113, 151, 114, 151, 117, 151, 119, 151, 120, 151, 121, 151, 122, 151, 123, 151, 125, 151, 126, 151, 127, 151, 128, 151, 129, 151, 130, 151, 131, 151, 132, 151, 134, 151, 135, 151, 136, 151, 137, 151, 138, 151, 140, 151, 142, 151, 143, 151, 144, 151, 147, 151, 149, 151, 150, 151, 151, 151, 153, 151, 154, 151, 155, 151, 156, 151, 157, 151, 193, 129, 166, 129, 36, 107, 55, 107, 57, 107, 67, 107, 70, 107, 89, 107, 209, 152, 210, 152, 211, 152, 213, 152, 217, 152, 218, 152, 179, 107, 64, 95, 194, 107, 243, 137, 144, 101, 81, 159, 147, 101, 188, 101, 198, 101, 196, 101, 195, 101, 204, 101, 206, 101, 210, 101, 214, 101, 128, 112, 156, 112, 150, 112, 157, 112, 187, 112, 192, 112, 183, 112, 171, 112, 177, 112, 232, 112, 202, 112, 16, 113, 19, 113, 22, 113, 47, 113, 49, 113, 115, 113, 92, 113, 104, 113, 69, 113, 114, 113, 74, 113, 120, 113, 122, 113, 152, 113, 179, 113, 181, 113, 168, 113, 160, 113, 224, 113, 212, 113, 231, 113, 249, 113, 29, 114, 40, 114, 108, 112, 24, 113, 102, 113, 185, 113, 62, 98, 61, 98, 67, 98, 72, 98, 73, 98, 59, 121, 64, 121, 70, 121, 73, 121, 91, 121, 92, 121, 83, 121, 90, 121, 98, 121, 87, 121, 96, 121, 111, 121, 103, 121, 122, 121, 133, 121, 138, 121, 154, 121, 167, 121, 179, 121, 209, 95, 208, 95, 158, 151, 159, 151, 161, 151, 162, 151, 164, 151, 165, 151, 166, 151, 167, 151, 168, 151, 169, 151, 170, 151, 172, 151, 174, 151, 176, 151, 177, 151, 179, 151, 181, 151, 182, 151, 183, 151, 184, 151, 185, 151, 186, 151, 187, 151, 188, 151, 189, 151, 190, 151, 191, 151, 192, 151, 193, 151, 194, 151, 195, 151, 196, 151, 197, 151, 198, 151, 199, 151, 200, 151, 201, 151, 202, 151, 203, 151, 204, 151, 205, 151, 206, 151, 207, 151, 208, 151, 209, 151, 210, 151, 211, 151, 212, 151, 213, 151, 214, 151, 215, 151, 216, 151, 217, 151, 218, 151, 219, 151, 220, 151, 221, 151, 222, 151, 223, 151, 224, 151, 225, 151, 226, 151, 227, 151, 228, 151, 229, 151, 232, 151, 238, 151, 239, 151, 240, 151, 241, 151, 242, 151, 244, 151, 247, 151, 248, 151, 249, 151, 250, 151, 251, 151, 252, 151, 253, 151, 254, 151, 255, 151, 0, 152, 1, 152, 2, 152, 3, 152, 4, 152, 5, 152, 6, 152, 7, 152, 8, 152, 9, 152, 10, 152, 11, 152, 12, 152, 13, 152, 14, 152, 60, 96, 93, 96, 90, 96, 103, 96, 65, 96, 89, 96, 99, 96, 171, 96, 6, 97, 13, 97, 93, 97, 169, 97, 157, 97, 203, 97, 209, 97, 6, 98, 128, 128, 127, 128, 147, 108, 246, 108, 252, 109, 246, 119, 248, 119, 0, 120, 9, 120, 23, 120, 24, 120, 17, 120, 171, 101, 45, 120, 28, 120, 29, 120, 57, 120, 58, 120, 59, 120, 31, 120, 60, 120, 37, 120, 44, 120, 35, 120, 41, 120, 78, 120, 109, 120, 86, 120, 87, 120, 38, 120, 80, 120, 71, 120, 76, 120, 106, 120, 155, 120, 147, 120, 154, 120, 135, 120, 156, 120, 161, 120, 163, 120, 178, 120, 185, 120, 165, 120, 212, 120, 217, 120, 201, 120, 236, 120, 242, 120, 5, 121, 244, 120, 19, 121, 36, 121, 30, 121, 52, 121, 155, 159, 249, 158, 251, 158, 252, 158, 241, 118, 4, 119, 13, 119, 249, 118, 7, 119, 8, 119, 26, 119, 34, 119, 25, 119, 45, 119, 38, 119, 53, 119, 56, 119, 80, 119, 81, 119, 71, 119, 67, 119, 90, 119, 104, 119, 15, 152, 16, 152, 17, 152, 18, 152, 19, 152, 20, 152, 21, 152, 22, 152, 23, 152, 24, 152, 25, 152, 26, 152, 27, 152, 28, 152, 29, 152, 30, 152, 31, 152, 32, 152, 33, 152, 34, 152, 35, 152, 36, 152, 37, 152, 38, 152, 39, 152, 40, 152, 41, 152, 42, 152, 43, 152, 44, 152, 45, 152, 46, 152, 47, 152, 48, 152, 49, 152, 50, 152, 51, 152, 52, 152, 53, 152, 54, 152, 55, 152, 56, 152, 57, 152, 58, 152, 59, 152, 60, 152, 61, 152, 62, 152, 63, 152, 64, 152, 65, 152, 66, 152, 67, 152, 68, 152, 69, 152, 70, 152, 71, 152, 72, 152, 73, 152, 74, 152, 75, 152, 76, 152, 77, 152, 78, 152, 79, 152, 80, 152, 81, 152, 82, 152, 83, 152, 84, 152, 85, 152, 86, 152, 87, 152, 88, 152, 89, 152, 90, 152, 91, 152, 92, 152, 93, 152, 94, 152, 95, 152, 96, 152, 97, 152, 98, 152, 99, 152, 100, 152, 101, 152, 102, 152, 103, 152, 104, 152, 105, 152, 106, 152, 107, 152, 108, 152, 109, 152, 110, 152, 98, 119, 101, 119, 127, 119, 141, 119, 125, 119, 128, 119, 140, 119, 145, 119, 159, 119, 160, 119, 176, 119, 181, 119, 189, 119, 58, 117, 64, 117, 78, 117, 75, 117, 72, 117, 91, 117, 114, 117, 121, 117, 131, 117, 88, 127, 97, 127, 95, 127, 72, 138, 104, 127, 116, 127, 113, 127, 121, 127, 129, 127, 126, 127, 205, 118, 229, 118, 50, 136, 133, 148, 134, 148, 135, 148, 139, 148, 138, 148, 140, 148, 141, 148, 143, 148, 144, 148, 148, 148, 151, 148, 149, 148, 154, 148, 155, 148, 156, 148, 163, 148, 164, 148, 171, 148, 170, 148, 173, 148, 172, 148, 175, 148, 176, 148, 178, 148, 180, 148, 182, 148, 183, 148, 184, 148, 185, 148, 186, 148, 188, 148, 189, 148, 191, 148, 196, 148, 200, 148, 201, 148, 202, 148, 203, 148, 204, 148, 205, 148, 206, 148, 208, 148, 209, 148, 210, 148, 213, 148, 214, 148, 215, 148, 217, 148, 216, 148, 219, 148, 222, 148, 223, 148, 224, 148, 226, 148, 228, 148, 229, 148, 231, 148, 232, 148, 234, 148, 111, 152, 112, 152, 113, 152, 114, 152, 115, 152, 116, 152, 139, 152, 142, 152, 146, 152, 149, 152, 153, 152, 163, 152, 168, 152, 169, 152, 170, 152, 171, 152, 172, 152, 173, 152, 174, 152, 175, 152, 176, 152, 177, 152, 178, 152, 179, 152, 180, 152, 181, 152, 182, 152, 183, 152, 184, 152, 185, 152, 186, 152, 187, 152, 188, 152, 189, 152, 190, 152, 191, 152, 192, 152, 193, 152, 194, 152, 195, 152, 196, 152, 197, 152, 198, 152, 199, 152, 200, 152, 201, 152, 202, 152, 203, 152, 204, 152, 205, 152, 207, 152, 208, 152, 212, 152, 214, 152, 215, 152, 219, 152, 220, 152, 221, 152, 224, 152, 225, 152, 226, 152, 227, 152, 228, 152, 229, 152, 230, 152, 233, 152, 234, 152, 235, 152, 236, 152, 237, 152, 238, 152, 239, 152, 240, 152, 241, 152, 242, 152, 243, 152, 244, 152, 245, 152, 246, 152, 247, 152, 248, 152, 249, 152, 250, 152, 251, 152, 252, 152, 253, 152, 254, 152, 255, 152, 0, 153, 1, 153, 2, 153, 3, 153, 4, 153, 5, 153, 6, 153, 7, 153, 233, 148, 235, 148, 238, 148, 239, 148, 243, 148, 244, 148, 245, 148, 247, 148, 249, 148, 252, 148, 253, 148, 255, 148, 3, 149, 2, 149, 6, 149, 7, 149, 9, 149, 10, 149, 13, 149, 14, 149, 15, 149, 18, 149, 19, 149, 20, 149, 21, 149, 22, 149, 24, 149, 27, 149, 29, 149, 30, 149, 31, 149, 34, 149, 42, 149, 43, 149, 41, 149, 44, 149, 49, 149, 50, 149, 52, 149, 54, 149, 55, 149, 56, 149, 60, 149, 62, 149, 63, 149, 66, 149, 53, 149, 68, 149, 69, 149, 70, 149, 73, 149, 76, 149, 78, 149, 79, 149, 82, 149, 83, 149, 84, 149, 86, 149, 87, 149, 88, 149, 89, 149, 91, 149, 94, 149, 95, 149, 93, 149, 97, 149, 98, 149, 100, 149, 101, 149, 102, 149, 103, 149, 104, 149, 105, 149, 106, 149, 107, 149, 108, 149, 111, 149, 113, 149, 114, 149, 115, 149, 58, 149, 231, 119, 236, 119, 201, 150, 213, 121, 237, 121, 227, 121, 235, 121, 6, 122, 71, 93, 3, 122, 2, 122, 30, 122, 20, 122, 8, 153, 9, 153, 10, 153, 11, 153, 12, 153, 14, 153, 15, 153, 17, 153, 18, 153, 19, 153, 20, 153, 21, 153, 22, 153, 23, 153, 24, 153, 25, 153, 26, 153, 27, 153, 28, 153, 29, 153, 30, 153, 31, 153, 32, 153, 33, 153, 34, 153, 35, 153, 36, 153, 37, 153, 38, 153, 39, 153, 40, 153, 41, 153, 42, 153, 43, 153, 44, 153, 45, 153, 47, 153, 48, 153, 49, 153, 50, 153, 51, 153, 52, 153, 53, 153, 54, 153, 55, 153, 56, 153, 57, 153, 58, 153, 59, 153, 60, 153, 61, 153, 62, 153, 63, 153, 64, 153, 65, 153, 66, 153, 67, 153, 68, 153, 69, 153, 70, 153, 71, 153, 72, 153, 73, 153, 74, 153, 75, 153, 76, 153, 77, 153, 78, 153, 79, 153, 80, 153, 81, 153, 82, 153, 83, 153, 86, 153, 87, 153, 88, 153, 89, 153, 90, 153, 91, 153, 92, 153, 93, 153, 94, 153, 95, 153, 96, 153, 97, 153, 98, 153, 100, 153, 102, 153, 115, 153, 120, 153, 121, 153, 123, 153, 126, 153, 130, 153, 131, 153, 137, 153, 57, 122, 55, 122, 81, 122, 207, 158, 165, 153, 112, 122, 136, 118, 142, 118, 147, 118, 153, 118, 164, 118, 222, 116, 224, 116, 44, 117, 32, 158, 34, 158, 40, 158, 41, 158, 42, 158, 43, 158, 44, 158, 50, 158, 49, 158, 54, 158, 56, 158, 55, 158, 57, 158, 58, 158, 62, 158, 65, 158, 66, 158, 68, 158, 70, 158, 71, 158, 72, 158, 73, 158, 75, 158, 76, 158, 78, 158, 81, 158, 85, 158, 87, 158, 90, 158, 91, 158, 92, 158, 94, 158, 99, 158, 102, 158, 103, 158, 104, 158, 105, 158, 106, 158, 107, 158, 108, 158, 113, 158, 109, 158, 115, 158, 146, 117, 148, 117, 150, 117, 160, 117, 157, 117, 172, 117, 163, 117, 179, 117, 180, 117, 184, 117, 196, 117, 177, 117, 176, 117, 195, 117, 194, 117, 214, 117, 205, 117, 227, 117, 232, 117, 230, 117, 228, 117, 235, 117, 231, 117, 3, 118, 241, 117, 252, 117, 255, 117, 16, 118, 0, 118, 5, 118, 12, 118, 23, 118, 10, 118, 37, 118, 24, 118, 21, 118, 25, 118, 140, 153, 142, 153, 154, 153, 155, 153, 156, 153, 157, 153, 158, 153, 159, 153, 160, 153, 161, 153, 162, 153, 163, 153, 164, 153, 166, 153, 167, 153, 169, 153, 170, 153, 171, 153, 172, 153, 173, 153, 174, 153, 175, 153, 176, 153, 177, 153, 178, 153, 179, 153, 180, 153, 181, 153, 182, 153, 183, 153, 184, 153, 185, 153, 186, 153, 187, 153, 188, 153, 189, 153, 190, 153, 191, 153, 192, 153, 193, 153, 194, 153, 195, 153, 196, 153, 197, 153, 198, 153, 199, 153, 200, 153, 201, 153, 202, 153, 203, 153, 204, 153, 205, 153, 206, 153, 207, 153, 208, 153, 209, 153, 210, 153, 211, 153, 212, 153, 213, 153, 214, 153, 215, 153, 216, 153, 217, 153, 218, 153, 219, 153, 220, 153, 221, 153, 222, 153, 223, 153, 224, 153, 225, 153, 226, 153, 227, 153, 228, 153, 229, 153, 230, 153, 231, 153, 232, 153, 233, 153, 234, 153, 235, 153, 236, 153, 237, 153, 238, 153, 239, 153, 240, 153, 241, 153, 242, 153, 243, 153, 244, 153, 245, 153, 246, 153, 247, 153, 248, 153, 249, 153, 27, 118, 60, 118, 34, 118, 32, 118, 64, 118, 45, 118, 48, 118, 63, 118, 53, 118, 67, 118, 62, 118, 51, 118, 77, 118, 94, 118, 84, 118, 92, 118, 86, 118, 107, 118, 111, 118, 202, 127, 230, 122, 120, 122, 121, 122, 128, 122, 134, 122, 136, 122, 149, 122, 166, 122, 160, 122, 172, 122, 168, 122, 173, 122, 179, 122, 100, 136, 105, 136, 114, 136, 125, 136, 127, 136, 130, 136, 162, 136, 198, 136, 183, 136, 188, 136, 201, 136, 226, 136, 206, 136, 227, 136, 229, 136, 241, 136, 26, 137, 252, 136, 232, 136, 254, 136, 240, 136, 33, 137, 25, 137, 19, 137, 27, 137, 10, 137, 52, 137, 43, 137, 54, 137, 65, 137, 102, 137, 123, 137, 139, 117, 229, 128, 178, 118, 180, 118, 220, 119, 18, 128, 20, 128, 22, 128, 28, 128, 32, 128, 34, 128, 37, 128, 38, 128, 39, 128, 41, 128, 40, 128, 49, 128, 11, 128, 53, 128, 67, 128, 70, 128, 77, 128, 82, 128, 105, 128, 113, 128, 131, 137, 120, 152, 128, 152, 131, 152, 250, 153, 251, 153, 252, 153, 253, 153, 254, 153, 255, 153, 0, 154, 1, 154, 2, 154, 3, 154, 4, 154, 5, 154, 6, 154, 7, 154, 8, 154, 9, 154, 10, 154, 11, 154, 12, 154, 13, 154, 14, 154, 15, 154, 16, 154, 17, 154, 18, 154, 19, 154, 20, 154, 21, 154, 22, 154, 23, 154, 24, 154, 25, 154, 26, 154, 27, 154, 28, 154, 29, 154, 30, 154, 31, 154, 32, 154, 33, 154, 34, 154, 35, 154, 36, 154, 37, 154, 38, 154, 39, 154, 40, 154, 41, 154, 42, 154, 43, 154, 44, 154, 45, 154, 46, 154, 47, 154, 48, 154, 49, 154, 50, 154, 51, 154, 52, 154, 53, 154, 54, 154, 55, 154, 56, 154, 57, 154, 58, 154, 59, 154, 60, 154, 61, 154, 62, 154, 63, 154, 64, 154, 65, 154, 66, 154, 67, 154, 68, 154, 69, 154, 70, 154, 71, 154, 72, 154, 73, 154, 74, 154, 75, 154, 76, 154, 77, 154, 78, 154, 79, 154, 80, 154, 81, 154, 82, 154, 83, 154, 84, 154, 85, 154, 86, 154, 87, 154, 88, 154, 89, 154, 137, 152, 140, 152, 141, 152, 143, 152, 148, 152, 154, 152, 155, 152, 158, 152, 159, 152, 161, 152, 162, 152, 165, 152, 166, 152, 77, 134, 84, 134, 108, 134, 110, 134, 127, 134, 122, 134, 124, 134, 123, 134, 168, 134, 141, 134, 139, 134, 172, 134, 157, 134, 167, 134, 163, 134, 170, 134, 147, 134, 169, 134, 182, 134, 196, 134, 181, 134, 206, 134, 176, 134, 186, 134, 177, 134, 175, 134, 201, 134, 207, 134, 180, 134, 233, 134, 241, 134, 242, 134, 237, 134, 243, 134, 208, 134, 19, 135, 222, 134, 244, 134, 223, 134, 216, 134, 209, 134, 3, 135, 7, 135, 248, 134, 8, 135, 10, 135, 13, 135, 9, 135, 35, 135, 59, 135, 30, 135, 37, 135, 46, 135, 26, 135, 62, 135, 72, 135, 52, 135, 49, 135, 41, 135, 55, 135, 63, 135, 130, 135, 34, 135, 125, 135, 126, 135, 123, 135, 96, 135, 112, 135, 76, 135, 110, 135, 139, 135, 83, 135, 99, 135, 124, 135, 100, 135, 89, 135, 101, 135, 147, 135, 175, 135, 168, 135, 210, 135, 90, 154, 91, 154, 92, 154, 93, 154, 94, 154, 95, 154, 96, 154, 97, 154, 98, 154, 99, 154, 100, 154, 101, 154, 102, 154, 103, 154, 104, 154, 105, 154, 106, 154, 107, 154, 114, 154, 131, 154, 137, 154, 141, 154, 142, 154, 148, 154, 149, 154, 153, 154, 166, 154, 169, 154, 170, 154, 171, 154, 172, 154, 173, 154, 174, 154, 175, 154, 178, 154, 179, 154, 180, 154, 181, 154, 185, 154, 187, 154, 189, 154, 190, 154, 191, 154, 195, 154, 196, 154, 198, 154, 199, 154, 200, 154, 201, 154, 202, 154, 205, 154, 206, 154, 207, 154, 208, 154, 210, 154, 212, 154, 213, 154, 214, 154, 215, 154, 217, 154, 218, 154, 219, 154, 220, 154, 221, 154, 222, 154, 224, 154, 226, 154, 227, 154, 228, 154, 229, 154, 231, 154, 232, 154, 233, 154, 234, 154, 236, 154, 238, 154, 240, 154, 241, 154, 242, 154, 243, 154, 244, 154, 245, 154, 246, 154, 247, 154, 248, 154, 250, 154, 252, 154, 253, 154, 254, 154, 255, 154, 0, 155, 1, 155, 2, 155, 4, 155, 5, 155, 6, 155, 198, 135, 136, 135, 133, 135, 173, 135, 151, 135, 131, 135, 171, 135, 229, 135, 172, 135, 181, 135, 179, 135, 203, 135, 211, 135, 189, 135, 209, 135, 192, 135, 202, 135, 219, 135, 234, 135, 224, 135, 238, 135, 22, 136, 19, 136, 254, 135, 10, 136, 27, 136, 33, 136, 57, 136, 60, 136, 54, 127, 66, 127, 68, 127, 69, 127, 16, 130, 250, 122, 253, 122, 8, 123, 3, 123, 4, 123, 21, 123, 10, 123, 43, 123, 15, 123, 71, 123, 56, 123, 42, 123, 25, 123, 46, 123, 49, 123, 32, 123, 37, 123, 36, 123, 51, 123, 62, 123, 30, 123, 88, 123, 90, 123, 69, 123, 117, 123, 76, 123, 93, 123, 96, 123, 110, 123, 123, 123, 98, 123, 114, 123, 113, 123, 144, 123, 166, 123, 167, 123, 184, 123, 172, 123, 157, 123, 168, 123, 133, 123, 170, 123, 156, 123, 162, 123, 171, 123, 180, 123, 209, 123, 193, 123, 204, 123, 221, 123, 218, 123, 229, 123, 230, 123, 234, 123, 12, 124, 254, 123, 252, 123, 15, 124, 22, 124, 11, 124, 7, 155, 9, 155, 10, 155, 11, 155, 12, 155, 13, 155, 14, 155, 16, 155, 17, 155, 18, 155, 20, 155, 21, 155, 22, 155, 23, 155, 24, 155, 25, 155, 26, 155, 27, 155, 28, 155, 29, 155, 30, 155, 32, 155, 33, 155, 34, 155, 36, 155, 37, 155, 38, 155, 39, 155, 40, 155, 41, 155, 42, 155, 43, 155, 44, 155, 45, 155, 46, 155, 48, 155, 49, 155, 51, 155, 52, 155, 53, 155, 54, 155, 55, 155, 56, 155, 57, 155, 58, 155, 61, 155, 62, 155, 63, 155, 64, 155, 70, 155, 74, 155, 75, 155, 76, 155, 78, 155, 80, 155, 82, 155, 83, 155, 85, 155, 86, 155, 87, 155, 88, 155, 89, 155, 90, 155, 91, 155, 92, 155, 93, 155, 94, 155, 95, 155, 96, 155, 97, 155, 98, 155, 99, 155, 100, 155, 101, 155, 102, 155, 103, 155, 104, 155, 105, 155, 106, 155, 107, 155, 108, 155, 109, 155, 110, 155, 111, 155, 112, 155, 113, 155, 114, 155, 115, 155, 116, 155, 117, 155, 118, 155, 119, 155, 120, 155, 121, 155, 122, 155, 123, 155, 31, 124, 42, 124, 38, 124, 56, 124, 65, 124, 64, 124, 254, 129, 1, 130, 2, 130, 4, 130, 236, 129, 68, 136, 33, 130, 34, 130, 35, 130, 45, 130, 47, 130, 40, 130, 43, 130, 56, 130, 59, 130, 51, 130, 52, 130, 62, 130, 68, 130, 73, 130, 75, 130, 79, 130, 90, 130, 95, 130, 104, 130, 126, 136, 133, 136, 136, 136, 216, 136, 223, 136, 94, 137, 157, 127, 159, 127, 167, 127, 175, 127, 176, 127, 178, 127, 124, 124, 73, 101, 145, 124, 157, 124, 156, 124, 158, 124, 162, 124, 178, 124, 188, 124, 189, 124, 193, 124, 199, 124, 204, 124, 205, 124, 200, 124, 197, 124, 215, 124, 232, 124, 110, 130, 168, 102, 191, 127, 206, 127, 213, 127, 229, 127, 225, 127, 230, 127, 233, 127, 238, 127, 243, 127, 248, 124, 119, 125, 166, 125, 174, 125, 71, 126, 155, 126, 184, 158, 180, 158, 115, 141, 132, 141, 148, 141, 145, 141, 177, 141, 103, 141, 109, 141, 71, 140, 73, 140, 74, 145, 80, 145, 78, 145, 79, 145, 100, 145, 124, 155, 125, 155, 126, 155, 127, 155, 128, 155, 129, 155, 130, 155, 131, 155, 132, 155, 133, 155, 134, 155, 135, 155, 136, 155, 137, 155, 138, 155, 139, 155, 140, 155, 141, 155, 142, 155, 143, 155, 144, 155, 145, 155, 146, 155, 147, 155, 148, 155, 149, 155, 150, 155, 151, 155, 152, 155, 153, 155, 154, 155, 155, 155, 156, 155, 157, 155, 158, 155, 159, 155, 160, 155, 161, 155, 162, 155, 163, 155, 164, 155, 165, 155, 166, 155, 167, 155, 168, 155, 169, 155, 170, 155, 171, 155, 172, 155, 173, 155, 174, 155, 175, 155, 176, 155, 177, 155, 178, 155, 179, 155, 180, 155, 181, 155, 182, 155, 183, 155, 184, 155, 185, 155, 186, 155, 187, 155, 188, 155, 189, 155, 190, 155, 191, 155, 192, 155, 193, 155, 194, 155, 195, 155, 196, 155, 197, 155, 198, 155, 199, 155, 200, 155, 201, 155, 202, 155, 203, 155, 204, 155, 205, 155, 206, 155, 207, 155, 208, 155, 209, 155, 210, 155, 211, 155, 212, 155, 213, 155, 214, 155, 215, 155, 216, 155, 217, 155, 218, 155, 219, 155, 98, 145, 97, 145, 112, 145, 105, 145, 111, 145, 125, 145, 126, 145, 114, 145, 116, 145, 121, 145, 140, 145, 133, 145, 144, 145, 141, 145, 145, 145, 162, 145, 163, 145, 170, 145, 173, 145, 174, 145, 175, 145, 181, 145, 180, 145, 186, 145, 85, 140, 126, 158, 184, 141, 235, 141, 5, 142, 89, 142, 105, 142, 181, 141, 191, 141, 188, 141, 186, 141, 196, 141, 214, 141, 215, 141, 218, 141, 222, 141, 206, 141, 207, 141, 219, 141, 198, 141, 236, 141, 247, 141, 248, 141, 227, 141, 249, 141, 251, 141, 228, 141, 9, 142, 253, 141, 20, 142, 29, 142, 31, 142, 44, 142, 46, 142, 35, 142, 47, 142, 58, 142, 64, 142, 57, 142, 53, 142, 61, 142, 49, 142, 73, 142, 65, 142, 66, 142, 81, 142, 82, 142, 74, 142, 112, 142, 118, 142, 124, 142, 111, 142, 116, 142, 133, 142, 143, 142, 148, 142, 144, 142, 156, 142, 158, 142, 120, 140, 130, 140, 138, 140, 133, 140, 152, 140, 148, 140, 155, 101, 214, 137, 222, 137, 218, 137, 220, 137, 220, 155, 221, 155, 222, 155, 223, 155, 224, 155, 225, 155, 226, 155, 227, 155, 228, 155, 229, 155, 230, 155, 231, 155, 232, 155, 233, 155, 234, 155, 235, 155, 236, 155, 237, 155, 238, 155, 239, 155, 240, 155, 241, 155, 242, 155, 243, 155, 244, 155, 245, 155, 246, 155, 247, 155, 248, 155, 249, 155, 250, 155, 251, 155, 252, 155, 253, 155, 254, 155, 255, 155, 0, 156, 1, 156, 2, 156, 3, 156, 4, 156, 5, 156, 6, 156, 7, 156, 8, 156, 9, 156, 10, 156, 11, 156, 12, 156, 13, 156, 14, 156, 15, 156, 16, 156, 17, 156, 18, 156, 19, 156, 20, 156, 21, 156, 22, 156, 23, 156, 24, 156, 25, 156, 26, 156, 27, 156, 28, 156, 29, 156, 30, 156, 31, 156, 32, 156, 33, 156, 34, 156, 35, 156, 36, 156, 37, 156, 38, 156, 39, 156, 40, 156, 41, 156, 42, 156, 43, 156, 44, 156, 45, 156, 46, 156, 47, 156, 48, 156, 49, 156, 50, 156, 51, 156, 52, 156, 53, 156, 54, 156, 55, 156, 56, 156, 57, 156, 58, 156, 59, 156, 229, 137, 235, 137, 239, 137, 62, 138, 38, 139, 83, 151, 233, 150, 243, 150, 239, 150, 6, 151, 1, 151, 8, 151, 15, 151, 14, 151, 42, 151, 45, 151, 48, 151, 62, 151, 128, 159, 131, 159, 133, 159, 134, 159, 135, 159, 136, 159, 137, 159, 138, 159, 140, 159, 254, 158, 11, 159, 13, 159, 185, 150, 188, 150, 189, 150, 206, 150, 210, 150, 191, 119, 224, 150, 142, 146, 174, 146, 200, 146, 62, 147, 106, 147, 202, 147, 143, 147, 62, 148, 107, 148, 127, 156, 130, 156, 133, 156, 134, 156, 135, 156, 136, 156, 35, 122, 139, 156, 142, 156, 144, 156, 145, 156, 146, 156, 148, 156, 149, 156, 154, 156, 155, 156, 158, 156, 159, 156, 160, 156, 161, 156, 162, 156, 163, 156, 165, 156, 166, 156, 167, 156, 168, 156, 169, 156, 171, 156, 173, 156, 174, 156, 176, 156, 177, 156, 178, 156, 179, 156, 180, 156, 181, 156, 182, 156, 183, 156, 186, 156, 187, 156, 188, 156, 189, 156, 196, 156, 197, 156, 198, 156, 199, 156, 202, 156, 203, 156, 60, 156, 61, 156, 62, 156, 63, 156, 64, 156, 65, 156, 66, 156, 67, 156, 68, 156, 69, 156, 70, 156, 71, 156, 72, 156, 73, 156, 74, 156, 75, 156, 76, 156, 77, 156, 78, 156, 79, 156, 80, 156, 81, 156, 82, 156, 83, 156, 84, 156, 85, 156, 86, 156, 87, 156, 88, 156, 89, 156, 90, 156, 91, 156, 92, 156, 93, 156, 94, 156, 95, 156, 96, 156, 97, 156, 98, 156, 99, 156, 100, 156, 101, 156, 102, 156, 103, 156, 104, 156, 105, 156, 106, 156, 107, 156, 108, 156, 109, 156, 110, 156, 111, 156, 112, 156, 113, 156, 114, 156, 115, 156, 116, 156, 117, 156, 118, 156, 119, 156, 120, 156, 121, 156, 122, 156, 123, 156, 125, 156, 126, 156, 128, 156, 131, 156, 132, 156, 137, 156, 138, 156, 140, 156, 143, 156, 147, 156, 150, 156, 151, 156, 152, 156, 153, 156, 157, 156, 170, 156, 172, 156, 175, 156, 185, 156, 190, 156, 191, 156, 192, 156, 193, 156, 194, 156, 200, 156, 201, 156, 209, 156, 210, 156, 218, 156, 219, 156, 224, 156, 225, 156, 204, 156, 205, 156, 206, 156, 207, 156, 208, 156, 211, 156, 212, 156, 213, 156, 215, 156, 216, 156, 217, 156, 220, 156, 221, 156, 223, 156, 226, 156, 124, 151, 133, 151, 145, 151, 146, 151, 148, 151, 175, 151, 171, 151, 163, 151, 178, 151, 180, 151, 177, 154, 176, 154, 183, 154, 88, 158, 182, 154, 186, 154, 188, 154, 193, 154, 192, 154, 197, 154, 194, 154, 203, 154, 204, 154, 209, 154, 69, 155, 67, 155, 71, 155, 73, 155, 72, 155, 77, 155, 81, 155, 232, 152, 13, 153, 46, 153, 85, 153, 84, 153, 223, 154, 225, 154, 230, 154, 239, 154, 235, 154, 251, 154, 237, 154, 249, 154, 8, 155, 15, 155, 19, 155, 31, 155, 35, 155, 189, 158, 190, 158, 59, 126, 130, 158, 135, 158, 136, 158, 139, 158, 146, 158, 214, 147, 157, 158, 159, 158, 219, 158, 220, 158, 221, 158, 224, 158, 223, 158, 226, 158, 233, 158, 231, 158, 229, 158, 234, 158, 239, 158, 34, 159, 44, 159, 47, 159, 57, 159, 55, 159, 61, 159, 62, 159, 68, 159, 227, 156, 228, 156, 229, 156, 230, 156, 231, 156, 232, 156, 233, 156, 234, 156, 235, 156, 236, 156, 237, 156, 238, 156, 239, 156, 240, 156, 241, 156, 242, 156, 243, 156, 244, 156, 245, 156, 246, 156, 247, 156, 248, 156, 249, 156, 250, 156, 251, 156, 252, 156, 253, 156, 254, 156, 255, 156, 0, 157, 1, 157, 2, 157, 3, 157, 4, 157, 5, 157, 6, 157, 7, 157, 8, 157, 9, 157, 10, 157, 11, 157, 12, 157, 13, 157, 14, 157, 15, 157, 16, 157, 17, 157, 18, 157, 19, 157, 20, 157, 21, 157, 22, 157, 23, 157, 24, 157, 25, 157, 26, 157, 27, 157, 28, 157, 29, 157, 30, 157, 31, 157, 32, 157, 33, 157, 34, 157, 35, 157, 36, 157, 37, 157, 38, 157, 39, 157, 40, 157, 41, 157, 42, 157, 43, 157, 44, 157, 45, 157, 46, 157, 47, 157, 48, 157, 49, 157, 50, 157, 51, 157, 52, 157, 53, 157, 54, 157, 55, 157, 56, 157, 57, 157, 58, 157, 59, 157, 60, 157, 61, 157, 62, 157, 63, 157, 64, 157, 65, 157, 66, 157, 52, 226, 53, 226, 54, 226, 55, 226, 56, 226, 57, 226, 58, 226, 59, 226, 60, 226, 61, 226, 62, 226, 63, 226, 64, 226, 65, 226, 66, 226, 67, 226, 68, 226, 69, 226, 70, 226, 71, 226, 72, 226, 73, 226, 74, 226, 75, 226, 76, 226, 77, 226, 78, 226, 79, 226, 80, 226, 81, 226, 82, 226, 83, 226, 84, 226, 85, 226, 86, 226, 87, 226, 88, 226, 89, 226, 90, 226, 91, 226, 92, 226, 93, 226, 94, 226, 95, 226, 96, 226, 97, 226, 98, 226, 99, 226, 100, 226, 101, 226, 102, 226, 103, 226, 104, 226, 105, 226, 106, 226, 107, 226, 108, 226, 109, 226, 110, 226, 111, 226, 112, 226, 113, 226, 114, 226, 115, 226, 116, 226, 117, 226, 118, 226, 119, 226, 120, 226, 121, 226, 122, 226, 123, 226, 124, 226, 125, 226, 126, 226, 127, 226, 128, 226, 129, 226, 130, 226, 131, 226, 132, 226, 133, 226, 134, 226, 135, 226, 136, 226, 137, 226, 138, 226, 139, 226, 140, 226, 141, 226, 142, 226, 143, 226, 144, 226, 145, 226, 67, 157, 68, 157, 69, 157, 70, 157, 71, 157, 72, 157, 73, 157, 74, 157, 75, 157, 76, 157, 77, 157, 78, 157, 79, 157, 80, 157, 81, 157, 82, 157, 83, 157, 84, 157, 85, 157, 86, 157, 87, 157, 88, 157, 89, 157, 90, 157, 91, 157, 92, 157, 93, 157, 94, 157, 95, 157, 96, 157, 97, 157, 98, 157, 99, 157, 100, 157, 101, 157, 102, 157, 103, 157, 104, 157, 105, 157, 106, 157, 107, 157, 108, 157, 109, 157, 110, 157, 111, 157, 112, 157, 113, 157, 114, 157, 115, 157, 116, 157, 117, 157, 118, 157, 119, 157, 120, 157, 121, 157, 122, 157, 123, 157, 124, 157, 125, 157, 126, 157, 127, 157, 128, 157, 129, 157, 130, 157, 131, 157, 132, 157, 133, 157, 134, 157, 135, 157, 136, 157, 137, 157, 138, 157, 139, 157, 140, 157, 141, 157, 142, 157, 143, 157, 144, 157, 145, 157, 146, 157, 147, 157, 148, 157, 149, 157, 150, 157, 151, 157, 152, 157, 153, 157, 154, 157, 155, 157, 156, 157, 157, 157, 158, 157, 159, 157, 160, 157, 161, 157, 162, 157, 146, 226, 147, 226, 148, 226, 149, 226, 150, 226, 151, 226, 152, 226, 153, 226, 154, 226, 155, 226, 156, 226, 157, 226, 158, 226, 159, 226, 160, 226, 161, 226, 162, 226, 163, 226, 164, 226, 165, 226, 166, 226, 167, 226, 168, 226, 169, 226, 170, 226, 171, 226, 172, 226, 173, 226, 174, 226, 175, 226, 176, 226, 177, 226, 178, 226, 179, 226, 180, 226, 181, 226, 182, 226, 183, 226, 184, 226, 185, 226, 186, 226, 187, 226, 188, 226, 189, 226, 190, 226, 191, 226, 192, 226, 193, 226, 194, 226, 195, 226, 196, 226, 197, 226, 198, 226, 199, 226, 200, 226, 201, 226, 202, 226, 203, 226, 204, 226, 205, 226, 206, 226, 207, 226, 208, 226, 209, 226, 210, 226, 211, 226, 212, 226, 213, 226, 214, 226, 215, 226, 216, 226, 217, 226, 218, 226, 219, 226, 220, 226, 221, 226, 222, 226, 223, 226, 224, 226, 225, 226, 226, 226, 227, 226, 228, 226, 229, 226, 230, 226, 231, 226, 232, 226, 233, 226, 234, 226, 235, 226, 236, 226, 237, 226, 238, 226, 239, 226, 163, 157, 164, 157, 165, 157, 166, 157, 167, 157, 168, 157, 169, 157, 170, 157, 171, 157, 172, 157, 173, 157, 174, 157, 175, 157, 176, 157, 177, 157, 178, 157, 179, 157, 180, 157, 181, 157, 182, 157, 183, 157, 184, 157, 185, 157, 186, 157, 187, 157, 188, 157, 189, 157, 190, 157, 191, 157, 192, 157, 193, 157, 194, 157, 195, 157, 196, 157, 197, 157, 198, 157, 199, 157, 200, 157, 201, 157, 202, 157, 203, 157, 204, 157, 205, 157, 206, 157, 207, 157, 208, 157, 209, 157, 210, 157, 211, 157, 212, 157, 213, 157, 214, 157, 215, 157, 216, 157, 217, 157, 218, 157, 219, 157, 220, 157, 221, 157, 222, 157, 223, 157, 224, 157, 225, 157, 226, 157, 227, 157, 228, 157, 229, 157, 230, 157, 231, 157, 232, 157, 233, 157, 234, 157, 235, 157, 236, 157, 237, 157, 238, 157, 239, 157, 240, 157, 241, 157, 242, 157, 243, 157, 244, 157, 245, 157, 246, 157, 247, 157, 248, 157, 249, 157, 250, 157, 251, 157, 252, 157, 253, 157, 254, 157, 255, 157, 0, 158, 1, 158, 2, 158, 240, 226, 241, 226, 242, 226, 243, 226, 244, 226, 245, 226, 246, 226, 247, 226, 248, 226, 249, 226, 250, 226, 251, 226, 252, 226, 253, 226, 254, 226, 255, 226, 0, 227, 1, 227, 2, 227, 3, 227, 4, 227, 5, 227, 6, 227, 7, 227, 8, 227, 9, 227, 10, 227, 11, 227, 12, 227, 13, 227, 14, 227, 15, 227, 16, 227, 17, 227, 18, 227, 19, 227, 20, 227, 21, 227, 22, 227, 23, 227, 24, 227, 25, 227, 26, 227, 27, 227, 28, 227, 29, 227, 30, 227, 31, 227, 32, 227, 33, 227, 34, 227, 35, 227, 36, 227, 37, 227, 38, 227, 39, 227, 40, 227, 41, 227, 42, 227, 43, 227, 44, 227, 45, 227, 46, 227, 47, 227, 48, 227, 49, 227, 50, 227, 51, 227, 52, 227, 53, 227, 54, 227, 55, 227, 56, 227, 57, 227, 58, 227, 59, 227, 60, 227, 61, 227, 62, 227, 63, 227, 64, 227, 65, 227, 66, 227, 67, 227, 68, 227, 69, 227, 70, 227, 71, 227, 72, 227, 73, 227, 74, 227, 75, 227, 76, 227, 77, 227, 3, 158, 4, 158, 5, 158, 6, 158, 7, 158, 8, 158, 9, 158, 10, 158, 11, 158, 12, 158, 13, 158, 14, 158, 15, 158, 16, 158, 17, 158, 18, 158, 19, 158, 20, 158, 21, 158, 22, 158, 23, 158, 24, 158, 25, 158, 26, 158, 27, 158, 28, 158, 29, 158, 30, 158, 36, 158, 39, 158, 46, 158, 48, 158, 52, 158, 59, 158, 60, 158, 64, 158, 77, 158, 80, 158, 82, 158, 83, 158, 84, 158, 86, 158, 89, 158, 93, 158, 95, 158, 96, 158, 97, 158, 98, 158, 101, 158, 110, 158, 111, 158, 114, 158, 116, 158, 117, 158, 118, 158, 119, 158, 120, 158, 121, 158, 122, 158, 123, 158, 124, 158, 125, 158, 128, 158, 129, 158, 131, 158, 132, 158, 133, 158, 134, 158, 137, 158, 138, 158, 140, 158, 141, 158, 142, 158, 143, 158, 144, 158, 145, 158, 148, 158, 149, 158, 150, 158, 151, 158, 152, 158, 153, 158, 154, 158, 155, 158, 156, 158, 158, 158, 160, 158, 161, 158, 162, 158, 163, 158, 164, 158, 165, 158, 167, 158, 168, 158, 169, 158, 170, 158, 78, 227, 79, 227, 80, 227, 81, 227, 82, 227, 83, 227, 84, 227, 85, 227, 86, 227, 87, 227, 88, 227, 89, 227, 90, 227, 91, 227, 92, 227, 93, 227, 94, 227, 95, 227, 96, 227, 97, 227, 98, 227, 99, 227, 100, 227, 101, 227, 102, 227, 103, 227, 104, 227, 105, 227, 106, 227, 107, 227, 108, 227, 109, 227, 110, 227, 111, 227, 112, 227, 113, 227, 114, 227, 115, 227, 116, 227, 117, 227, 118, 227, 119, 227, 120, 227, 121, 227, 122, 227, 123, 227, 124, 227, 125, 227, 126, 227, 127, 227, 128, 227, 129, 227, 130, 227, 131, 227, 132, 227, 133, 227, 134, 227, 135, 227, 136, 227, 137, 227, 138, 227, 139, 227, 140, 227, 141, 227, 142, 227, 143, 227, 144, 227, 145, 227, 146, 227, 147, 227, 148, 227, 149, 227, 150, 227, 151, 227, 152, 227, 153, 227, 154, 227, 155, 227, 156, 227, 157, 227, 158, 227, 159, 227, 160, 227, 161, 227, 162, 227, 163, 227, 164, 227, 165, 227, 166, 227, 167, 227, 168, 227, 169, 227, 170, 227, 171, 227, 171, 158, 172, 158, 173, 158, 174, 158, 175, 158, 176, 158, 177, 158, 178, 158, 179, 158, 181, 158, 182, 158, 183, 158, 185, 158, 186, 158, 188, 158, 191, 158, 192, 158, 193, 158, 194, 158, 195, 158, 197, 158, 198, 158, 199, 158, 200, 158, 202, 158, 203, 158, 204, 158, 208, 158, 210, 158, 211, 158, 213, 158, 214, 158, 215, 158, 217, 158, 218, 158, 222, 158, 225, 158, 227, 158, 228, 158, 230, 158, 232, 158, 235, 158, 236, 158, 237, 158, 238, 158, 240, 158, 241, 158, 242, 158, 243, 158, 244, 158, 245, 158, 246, 158, 247, 158, 248, 158, 250, 158, 253, 158, 255, 158, 0, 159, 1, 159, 2, 159, 3, 159, 4, 159, 5, 159, 6, 159, 7, 159, 8, 159, 9, 159, 10, 159, 12, 159, 15, 159, 17, 159, 18, 159, 20, 159, 21, 159, 22, 159, 24, 159, 26, 159, 27, 159, 28, 159, 29, 159, 30, 159, 31, 159, 33, 159, 35, 159, 36, 159, 37, 159, 38, 159, 39, 159, 40, 159, 41, 159, 42, 159, 43, 159, 45, 159, 46, 159, 48, 159, 49, 159, 172, 227, 173, 227, 174, 227, 175, 227, 176, 227, 177, 227, 178, 227, 179, 227, 180, 227, 181, 227, 182, 227, 183, 227, 184, 227, 185, 227, 186, 227, 187, 227, 188, 227, 189, 227, 190, 227, 191, 227, 192, 227, 193, 227, 194, 227, 195, 227, 196, 227, 197, 227, 198, 227, 199, 227, 200, 227, 201, 227, 202, 227, 203, 227, 204, 227, 205, 227, 206, 227, 207, 227, 208, 227, 209, 227, 210, 227, 211, 227, 212, 227, 213, 227, 214, 227, 215, 227, 216, 227, 217, 227, 218, 227, 219, 227, 220, 227, 221, 227, 222, 227, 223, 227, 224, 227, 225, 227, 226, 227, 227, 227, 228, 227, 229, 227, 230, 227, 231, 227, 232, 227, 233, 227, 234, 227, 235, 227, 236, 227, 237, 227, 238, 227, 239, 227, 240, 227, 241, 227, 242, 227, 243, 227, 244, 227, 245, 227, 246, 227, 247, 227, 248, 227, 249, 227, 250, 227, 251, 227, 252, 227, 253, 227, 254, 227, 255, 227, 0, 228, 1, 228, 2, 228, 3, 228, 4, 228, 5, 228, 6, 228, 7, 228, 8, 228, 9, 228, 50, 159, 51, 159, 52, 159, 53, 159, 54, 159, 56, 159, 58, 159, 60, 159, 63, 159, 64, 159, 65, 159, 66, 159, 67, 159, 69, 159, 70, 159, 71, 159, 72, 159, 73, 159, 74, 159, 75, 159, 76, 159, 77, 159, 78, 159, 79, 159, 82, 159, 83, 159, 84, 159, 85, 159, 86, 159, 87, 159, 88, 159, 89, 159, 90, 159, 91, 159, 92, 159, 93, 159, 94, 159, 95, 159, 96, 159, 97, 159, 98, 159, 99, 159, 100, 159, 101, 159, 102, 159, 103, 159, 104, 159, 105, 159, 106, 159, 107, 159, 108, 159, 109, 159, 110, 159, 111, 159, 112, 159, 113, 159, 114, 159, 115, 159, 116, 159, 117, 159, 118, 159, 119, 159, 120, 159, 121, 159, 122, 159, 123, 159, 124, 159, 125, 159, 126, 159, 129, 159, 130, 159, 141, 159, 142, 159, 143, 159, 144, 159, 145, 159, 146, 159, 147, 159, 148, 159, 149, 159, 150, 159, 151, 159, 152, 159, 156, 159, 157, 159, 158, 159, 161, 159, 162, 159, 163, 159, 164, 159, 165, 159, 44, 249, 121, 249, 149, 249, 231, 249, 241, 249, 10, 228, 11, 228, 12, 228, 13, 228, 14, 228, 15, 228, 16, 228, 17, 228, 18, 228, 19, 228, 20, 228, 21, 228, 22, 228, 23, 228, 24, 228, 25, 228, 26, 228, 27, 228, 28, 228, 29, 228, 30, 228, 31, 228, 32, 228, 33, 228, 34, 228, 35, 228, 36, 228, 37, 228, 38, 228, 39, 228, 40, 228, 41, 228, 42, 228, 43, 228, 44, 228, 45, 228, 46, 228, 47, 228, 48, 228, 49, 228, 50, 228, 51, 228, 52, 228, 53, 228, 54, 228, 55, 228, 56, 228, 57, 228, 58, 228, 59, 228, 60, 228, 61, 228, 62, 228, 63, 228, 64, 228, 65, 228, 66, 228, 67, 228, 68, 228, 69, 228, 70, 228, 71, 228, 72, 228, 73, 228, 74, 228, 75, 228, 76, 228, 77, 228, 78, 228, 79, 228, 80, 228, 81, 228, 82, 228, 83, 228, 84, 228, 85, 228, 86, 228, 87, 228, 88, 228, 89, 228, 90, 228, 91, 228, 92, 228, 93, 228, 94, 228, 95, 228, 96, 228, 97, 228, 98, 228, 99, 228, 100, 228, 101, 228, 102, 228, 103, 228, 12, 250, 13, 250, 14, 250, 15, 250, 17, 250, 19, 250, 20, 250, 24, 250, 31, 250, 32, 250, 33, 250, 35, 250, 36, 250, 39, 250, 40, 250, 41, 250, 129, 46, 22, 232, 23, 232, 24, 232, 132, 46, 115, 52, 71, 52, 136, 46, 139, 46, 30, 232, 158, 53, 26, 54, 14, 54, 140, 46, 151, 46, 110, 57, 24, 57, 38, 232, 207, 57, 223, 57, 115, 58, 208, 57, 43, 232, 44, 232, 78, 59, 110, 60, 224, 60, 167, 46, 49, 232, 50, 232, 170, 46, 86, 64, 95, 65, 174, 46, 55, 67, 179, 46, 182, 46, 183, 46, 59, 232, 177, 67, 172, 67, 187, 46, 221, 67, 214, 68, 97, 70, 76, 70, 67, 232, 35, 71, 41, 71, 124, 71, 141, 71, 202, 46, 71, 73, 122, 73, 125, 73, 130, 73, 131, 73, 133, 73, 134, 73, 159, 73, 155, 73, 183, 73, 182, 73, 84, 232, 85, 232, 163, 76, 159, 76, 160, 76, 161, 76, 119, 76, 162, 76, 19, 77, 20, 77, 21, 77, 22, 77, 23, 77, 24, 77, 25, 77, 174, 77, 100, 232, 104, 228, 105, 228, 106, 228, 107, 228, 108, 228, 109, 228, 110, 228, 111, 228, 112, 228, 113, 228, 114, 228, 115, 228, 116, 228, 117, 228, 118, 228, 119, 228, 120, 228, 121, 228, 122, 228, 123, 228, 124, 228, 125, 228, 126, 228, 127, 228, 128, 228, 129, 228, 130, 228, 131, 228, 132, 228, 133, 228, 134, 228, 135, 228, 136, 228, 137, 228, 138, 228, 139, 228, 140, 228, 141, 228, 142, 228, 143, 228, 144, 228, 145, 228, 146, 228, 147, 228, 148, 228, 149, 228, 150, 228, 151, 228, 152, 228, 153, 228, 154, 228, 155, 228, 156, 228, 157, 228, 158, 228, 159, 228, 160, 228, 161, 228, 162, 228, 163, 228, 164, 228, 165, 228, 166, 228, 167, 228, 168, 228, 169, 228, 170, 228, 171, 228, 172, 228, 173, 228, 174, 228, 175, 228, 176, 228, 177, 228, 178, 228, 179, 228, 180, 228, 181, 228, 182, 228, 183, 228, 184, 228, 185, 228, 186, 228, 187, 228, 188, 228, 189, 228, 190, 228, 191, 228, 192, 228, 193, 228, 194, 228, 195, 228, 196, 228, 197, 228, 240, 67, 50, 76, 3, 70, 166, 69, 120, 69, 103, 114, 119, 77, 179, 69, 177, 124, 226, 76, 197, 124, 149, 59, 54, 71, 68, 71, 71, 76, 64, 76, 191, 66, 23, 54, 82, 115, 139, 110, 210, 112, 87, 76, 81, 163, 79, 71, 218, 69, 133, 76, 108, 124, 7, 77, 164, 74, 161, 70, 35, 107, 37, 114, 84, 90, 99, 26, 6, 62, 97, 63, 77, 102, 251, 86, 0, 0, 149, 125, 29, 89, 185, 139, 244, 61, 52, 151, 239, 123, 219, 91, 94, 29, 164, 90, 37, 54, 176, 158, 209, 90, 183, 91, 252, 92, 110, 103, 147, 133, 69, 153, 97, 116, 157, 116, 117, 56, 83, 29, 158, 54, 33, 96, 236, 62, 222, 88, 245, 58, 252, 122, 151, 159, 97, 65, 13, 137, 234, 49, 138, 10, 94, 50, 10, 67, 132, 132, 150, 159, 47, 148, 48, 73, 19, 134, 150, 88, 74, 151, 24, 146, 208, 121, 50, 122, 96, 102, 41, 106, 157, 136, 76, 116, 197, 123, 130, 103, 44, 122, 79, 82, 70, 144, 230, 52, 196, 115, 185, 93, 198, 116, 199, 159, 179, 87, 47, 73, 76, 84, 49, 65, 142, 54, 24, 88, 114, 122, 101, 123, 143, 139, 174, 70, 136, 110, 129, 65, 153, 93, 174, 123, 188, 36, 200, 159, 193, 36, 201, 36, 204, 36, 201, 159, 4, 133, 187, 53, 180, 64, 202, 159, 225, 68, 255, 173, 193, 98, 110, 112, 203, 159, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 49, 193, 49, 194, 49, 195, 49, 196, 49, 12, 1, 197, 49, 209, 0, 205, 0, 198, 49, 199, 49, 203, 0, 232, 31, 200, 49, 202, 0, 201, 49, 202, 49, 203, 49, 204, 49, 14, 1, 205, 49, 206, 49, 0, 1, 193, 0, 205, 1, 192, 0, 18, 1, 201, 0, 26, 1, 200, 0, 76, 1, 211, 0, 209, 1, 210, 0, 0, 220, 190, 30, 4, 220, 192, 30, 202, 0, 1, 1, 225, 0, 206, 1, 224, 0, 81, 2, 19, 1, 233, 0, 27, 1, 232, 0, 43, 1, 237, 0, 208, 1, 236, 0, 77, 1, 243, 0, 210, 1, 242, 0, 107, 1, 250, 0, 212, 1, 249, 0, 214, 1, 216, 1, 218, 1, 220, 1, 252, 0, 8, 220, 191, 30, 12, 220, 193, 30, 234, 0, 97, 2, 218, 35, 219, 35], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 261308);
	        allocate([169, 163, 69, 17, 0, 0, 10, 101, 0, 0, 0, 0, 61, 78, 221, 110, 78, 157, 223, 145, 0, 0, 0, 0, 53, 119, 145, 100, 26, 79, 40, 79, 168, 79, 86, 81, 116, 81, 156, 81, 228, 81, 161, 82, 168, 82, 59, 83, 78, 83, 209, 83, 216, 83, 226, 86, 240, 88, 4, 89, 7, 89, 50, 89, 52, 89, 102, 91, 158, 91, 159, 91, 154, 92, 134, 94, 59, 96, 137, 101, 254, 103, 4, 104, 101, 104, 78, 109, 188, 112, 53, 117, 164, 126, 172, 126, 186, 126, 199, 126, 207, 126, 223, 126, 6, 127, 55, 127, 122, 130, 207, 130, 111, 131, 198, 137, 190, 139, 226, 139, 102, 143, 103, 143, 110, 143, 17, 116, 252, 124, 205, 125, 70, 105, 201, 122, 39, 82, 0, 0, 0, 0, 0, 0, 0, 0, 140, 145, 184, 120, 94, 145, 188, 128, 0, 0, 11, 141, 246, 128, 231, 9, 0, 0, 0, 0, 159, 128, 199, 158, 205, 76, 201, 157, 12, 158, 62, 76, 246, 157, 14, 112, 10, 158, 51, 161, 193, 53, 0, 0, 154, 110, 62, 130, 25, 117, 0, 0, 17, 73, 108, 154, 143, 154, 153, 159, 135, 121, 108, 132, 202, 29, 208, 5, 230, 42, 36, 78, 129, 78, 128, 78, 135, 78, 191, 78, 235, 78, 55, 79, 76, 52, 189, 79, 72, 62, 3, 80, 136, 80, 125, 52, 147, 52, 165, 52, 134, 81, 5, 89, 219, 81, 252, 81, 5, 82, 137, 78, 121, 82, 144, 82, 39, 83, 199, 53, 169, 83, 81, 53, 176, 83, 83, 53, 194, 83, 35, 84, 109, 53, 114, 53, 129, 54, 147, 84, 163, 84, 180, 84, 185, 84, 208, 84, 239, 84, 24, 85, 35, 85, 40, 85, 152, 53, 63, 85, 165, 53, 191, 53, 215, 85, 197, 53, 132, 125, 37, 85, 0, 0, 66, 12, 21, 13, 43, 81, 144, 85, 198, 44, 236, 57, 65, 3, 70, 142, 184, 77, 229, 148, 83, 64, 190, 128, 122, 119, 56, 44, 52, 58, 213, 71, 93, 129, 242, 105, 234, 77, 221, 100, 124, 13, 180, 15, 213, 12, 244, 16, 141, 100, 126, 142, 150, 14, 11, 12, 100, 15, 169, 44, 86, 130, 211, 68, 0, 0, 70, 13, 77, 154, 233, 128, 244, 71, 167, 78, 194, 44, 178, 154, 103, 58, 244, 149, 237, 63, 6, 53, 199, 82, 212, 151, 200, 120, 68, 45, 110, 157, 21, 152, 0, 0, 217, 67, 165, 96, 180, 100, 227, 84, 76, 45, 202, 43, 119, 16, 251, 57, 111, 16, 218, 102, 22, 103, 160, 121, 234, 100, 82, 80, 67, 12, 104, 142, 161, 33, 76, 139, 49, 7, 0, 0, 11, 72, 169, 1, 250, 63, 115, 88, 141, 45, 0, 0, 200, 69, 252, 4, 151, 96, 76, 15, 150, 13, 121, 85, 187, 64, 186, 67, 0, 0, 180, 74, 102, 42, 157, 16, 170, 129, 245, 152, 156, 13, 121, 99, 254, 57, 117, 39, 192, 141, 161, 86, 124, 100, 67, 62, 0, 0, 1, 166, 9, 14, 207, 42, 201, 44, 0, 0, 200, 16, 194, 57, 146, 57, 6, 58, 155, 130, 120, 53, 73, 94, 199, 32, 82, 86, 49, 15, 178, 44, 32, 151, 188, 52, 61, 108, 59, 78, 0, 0, 0, 0, 116, 117, 139, 46, 8, 34, 91, 166, 205, 140, 122, 14, 52, 12, 28, 104, 147, 127, 207, 16, 3, 40, 57, 41, 251, 53, 227, 81, 140, 14, 141, 15, 170, 14, 147, 63, 48, 15, 71, 13, 79, 17, 76, 14, 0, 0, 171, 14, 169, 11, 72, 13, 192, 16, 61, 17, 249, 63, 150, 38, 50, 100, 173, 15, 244, 51, 57, 118, 206, 43, 126, 13, 127, 13, 81, 44, 85, 44, 24, 58, 152, 14, 199, 16, 46, 15, 50, 166, 80, 107, 210, 140, 153, 141, 202, 140, 170, 149, 204, 84, 196, 130, 185, 85, 0, 0, 195, 158, 38, 156, 182, 154, 94, 119, 238, 45, 64, 113, 109, 129, 236, 128, 28, 92, 114, 101, 52, 129, 151, 55, 95, 83, 189, 128, 182, 145, 250, 14, 15, 14, 119, 14, 251, 14, 221, 53, 235, 77, 9, 54, 214, 12, 175, 86, 181, 39, 201, 16, 16, 14, 120, 14, 120, 16, 72, 17, 7, 130, 85, 20, 121, 14, 80, 78, 164, 45, 84, 90, 29, 16, 30, 16, 245, 16, 246, 16, 156, 87, 17, 14, 148, 118, 205, 130, 181, 15, 123, 14, 126, 81, 3, 55, 182, 15, 128, 17, 216, 82, 189, 162, 218, 73, 58, 24, 119, 65, 124, 130, 153, 88, 104, 82, 26, 54, 61, 87, 178, 123, 104, 91, 0, 72, 44, 75, 39, 159, 231, 73, 31, 156, 141, 155, 116, 91, 61, 49, 251, 85, 242, 53, 137, 86, 40, 78, 2, 89, 193, 27, 120, 248, 81, 151, 134, 0, 91, 78, 187, 78, 62, 53, 35, 92, 81, 95, 196, 95, 250, 56, 76, 98, 53, 101, 122, 107, 53, 108, 58, 108, 108, 112, 43, 114, 44, 78, 173, 114, 233, 72, 82, 127, 59, 121, 249, 124, 83, 127, 106, 98, 193, 52, 0, 0, 75, 99, 2, 128, 128, 128, 18, 102, 81, 105, 93, 83, 100, 136, 193, 137, 178, 120, 160, 139, 29, 141, 133, 148, 120, 149, 127, 149, 232, 149, 15, 142, 230, 151, 117, 152, 206, 152, 222, 152, 99, 153, 16, 152, 124, 156, 31, 158, 196, 158, 111, 107, 7, 249, 55, 78, 135, 0, 29, 150, 55, 98, 162, 148, 0, 0, 59, 80, 254, 109, 115, 156, 166, 159, 201, 61, 143, 136, 78, 65, 119, 112, 245, 92, 32, 75, 205, 81, 89, 53, 48, 93, 34, 97, 50, 138, 167, 143, 246, 145, 145, 113, 25, 103, 186, 115, 129, 50, 7, 161, 139, 60, 128, 25, 16, 75, 228, 120, 2, 116, 174, 81, 15, 135, 9, 64, 99, 106, 186, 162, 35, 66, 15, 134, 111, 10, 42, 122, 71, 153, 234, 138, 85, 151, 77, 112, 36, 83, 126, 32, 244, 147, 217, 118, 227, 137, 167, 159, 221, 119, 163, 78, 240, 79, 188, 80, 47, 78, 23, 79, 168, 159, 52, 84, 139, 125, 146, 88, 208, 88, 182, 29, 146, 94, 153, 94, 194, 95, 18, 39, 139, 101, 249, 51, 25, 105, 67, 106, 99, 60, 255, 108, 0, 0, 0, 114, 5, 69, 140, 115, 219, 62, 19, 74, 21, 91, 185, 116, 131, 139, 164, 92, 149, 86, 147, 122, 236, 123, 195, 124, 108, 126, 248, 130, 151, 133, 169, 159, 144, 136, 170, 159, 185, 142, 171, 159, 207, 143, 95, 133, 224, 153, 33, 146, 172, 159, 185, 141, 63, 20, 113, 64, 162, 66, 26, 90, 0, 0, 0, 0, 0, 0, 104, 152, 107, 103, 118, 66, 61, 87, 0, 0, 214, 133, 123, 73, 191, 130, 13, 113, 129, 76, 116, 109, 123, 93, 21, 107, 190, 111, 173, 159, 174, 159, 150, 91, 175, 159, 231, 102, 91, 126, 87, 110, 202, 121, 136, 61, 195, 68, 86, 50, 150, 39, 154, 67, 54, 69, 0, 0, 213, 92, 26, 59, 249, 138, 120, 92, 18, 61, 81, 53, 120, 93, 178, 159, 87, 113, 88, 69, 236, 64, 35, 30, 119, 76, 120, 57, 74, 52, 164, 1, 65, 108, 204, 138, 180, 79, 57, 2, 191, 89, 108, 129, 86, 152, 250, 152, 59, 95, 159, 11, 0, 0, 193, 33, 109, 137, 2, 65, 187, 70, 121, 144, 7, 63, 179, 159, 181, 161, 248, 64, 214, 55, 247, 70, 70, 108, 124, 65, 178, 134, 255, 115, 109, 69, 212, 56, 154, 84, 97, 69, 27, 69, 137, 77, 123, 76, 118, 77, 234, 69, 200, 63, 15, 75, 97, 54, 222, 68, 189, 68, 237, 65, 62, 93, 72, 93, 86, 93, 252, 61, 15, 56, 164, 93, 185, 93, 32, 56, 56, 56, 66, 94, 189, 94, 37, 95, 131, 95, 8, 57, 20, 57, 63, 57, 77, 57, 215, 96, 61, 97, 229, 92, 137, 57, 183, 97, 185, 97, 207, 97, 184, 57, 44, 98, 144, 98, 229, 98, 24, 99, 248, 57, 177, 86, 3, 58, 226, 99, 251, 99, 7, 100, 90, 100, 75, 58, 192, 100, 21, 93, 33, 86, 159, 159, 151, 58, 134, 101, 189, 58, 255, 101, 83, 102, 242, 58, 146, 102, 34, 59, 22, 103, 66, 59, 164, 103, 0, 104, 88, 59, 74, 104, 132, 104, 114, 59, 113, 59, 123, 59, 9, 105, 67, 105, 92, 114, 100, 105, 159, 105, 133, 105, 188, 59, 214, 105, 221, 59, 101, 106, 116, 106, 113, 106, 130, 106, 236, 59, 153, 106, 242, 59, 171, 106, 181, 106, 212, 106, 246, 106, 129, 107, 193, 107, 234, 107, 117, 108, 170, 108, 203, 60, 2, 109, 6, 109, 38, 109, 129, 109, 239, 60, 164, 109, 177, 109, 21, 110, 24, 110, 41, 110, 134, 110, 192, 137, 187, 110, 226, 110, 218, 110, 127, 159, 232, 110, 233, 110, 36, 111, 52, 111, 70, 61, 65, 63, 129, 111, 190, 111, 106, 61, 117, 61, 183, 113, 153, 92, 138, 61, 44, 112, 145, 61, 80, 112, 84, 112, 111, 112, 127, 112, 137, 112, 37, 3, 193, 67, 241, 53, 216, 14, 215, 62, 190, 87, 211, 110, 62, 113, 224, 87, 78, 54, 162, 105, 233, 139, 116, 91, 73, 122, 225, 88, 217, 148, 101, 122, 125, 122, 172, 89, 187, 122, 176, 122, 194, 122, 195, 122, 209, 113, 141, 100, 202, 65, 218, 122, 221, 122, 234, 122, 239, 65, 178, 84, 1, 92, 11, 123, 85, 123, 41, 123, 14, 83, 254, 92, 162, 123, 111, 123, 156, 131, 180, 91, 127, 108, 208, 123, 33, 132, 146, 123, 0, 0, 32, 93, 173, 61, 101, 92, 146, 132, 250, 123, 0, 0, 53, 124, 193, 92, 68, 124, 131, 124, 130, 72, 166, 124, 125, 102, 120, 69, 201, 124, 199, 124, 230, 124, 116, 124, 243, 124, 245, 124, 0, 0, 103, 126, 29, 69, 68, 110, 93, 125, 214, 110, 141, 116, 137, 125, 171, 125, 53, 113, 179, 125, 0, 0, 87, 64, 41, 96, 228, 125, 19, 61, 245, 125, 249, 23, 229, 125, 109, 131, 0, 0, 33, 97, 90, 97, 110, 126, 146, 126, 43, 67, 108, 148, 39, 126, 64, 127, 65, 127, 71, 127, 54, 121, 208, 98, 225, 153, 151, 127, 81, 99, 163, 127, 97, 22, 104, 0, 92, 69, 102, 55, 3, 69, 58, 131, 250, 127, 137, 100, 0, 0, 8, 128, 29, 128, 0, 0, 47, 128, 135, 160, 195, 108, 59, 128, 60, 128, 97, 128, 20, 39, 137, 73, 38, 102, 227, 61, 232, 102, 37, 103, 167, 128, 72, 138, 7, 129, 26, 129, 176, 88, 246, 38, 127, 108, 152, 100, 184, 79, 231, 100, 138, 20, 24, 130, 94, 24, 83, 106, 101, 74, 149, 74, 122, 68, 41, 130, 13, 11, 82, 106, 126, 61, 249, 79, 253, 20, 226, 132, 98, 131, 10, 107, 167, 73, 48, 53, 115, 23, 248, 61, 170, 130, 27, 105, 148, 249, 219, 65, 75, 133, 208, 130, 26, 131, 22, 14, 180, 23, 193, 54, 125, 49, 90, 53, 123, 130, 226, 130, 24, 131, 139, 62, 163, 109, 5, 107, 151, 107, 206, 53, 191, 61, 29, 131, 236, 85, 133, 131, 11, 69, 165, 109, 172, 131, 0, 0, 211, 131, 126, 52, 212, 110, 87, 106, 90, 133, 150, 52, 66, 110, 239, 46, 88, 132, 228, 91, 113, 132, 211, 61, 228, 68, 167, 106, 74, 132, 181, 60, 88, 121, 0, 0, 150, 107, 119, 110, 67, 110, 222, 132, 0, 0, 145, 131, 160, 68, 147, 132, 228, 132, 145, 92, 64, 66, 192, 92, 67, 69, 52, 133, 242, 90, 153, 110, 39, 69, 115, 133, 22, 69, 191, 103, 22, 134, 37, 134, 59, 134, 193, 133, 136, 112, 2, 134, 130, 21, 205, 112, 178, 249, 106, 69, 40, 134, 72, 54, 162, 24, 247, 83, 154, 115, 126, 134, 113, 135, 248, 160, 238, 135, 39, 44, 177, 135, 218, 135, 15, 136, 97, 86, 108, 134, 86, 104, 15, 70, 69, 136, 70, 136, 224, 117, 185, 61, 228, 117, 94, 136, 156, 136, 91, 70, 180, 136, 181, 136, 193, 99, 197, 136, 119, 119, 15, 119, 135, 137, 138, 137, 0, 0, 0, 0, 167, 137, 188, 137, 37, 138, 231, 137, 36, 121, 189, 122, 156, 138, 147, 119, 254, 145, 144, 138, 89, 122, 233, 122, 58, 123, 143, 63, 19, 71, 56, 123, 124, 113, 12, 139, 31, 139, 48, 84, 101, 85, 63, 139, 76, 139, 77, 139, 169, 138, 122, 74, 144, 139, 155, 139, 175, 138, 223, 22, 21, 70, 79, 136, 155, 140, 84, 125, 143, 125, 212, 249, 37, 55, 83, 125, 214, 140, 152, 125, 189, 125, 18, 141, 3, 141, 16, 25, 219, 140, 92, 112, 17, 141, 201, 76, 208, 62, 0, 0, 169, 141, 2, 128, 20, 16, 138, 73, 124, 59, 188, 129, 12, 113, 231, 122, 173, 142, 182, 142, 195, 142, 212, 146, 25, 143, 45, 143, 101, 131, 18, 132, 165, 143, 3, 147, 159, 162, 80, 10, 179, 143, 42, 73, 222, 137, 61, 133, 187, 61, 248, 94, 98, 50, 249, 143, 20, 160, 188, 134, 1, 133, 37, 35, 128, 57, 215, 110, 55, 144, 60, 133, 190, 122, 97, 144, 108, 133, 11, 134, 168, 144, 19, 135, 196, 144, 230, 134, 174, 144, 0, 0, 103, 145, 240, 58, 169, 145, 196, 145, 172, 124, 51, 137, 137, 30, 14, 146, 159, 108, 65, 146, 98, 146, 185, 85, 0, 0, 198, 138, 155, 60, 12, 139, 219, 85, 49, 13, 44, 147, 107, 147, 225, 138, 235, 139, 143, 112, 195, 90, 226, 138, 229, 138, 101, 73, 68, 146, 236, 139, 57, 140, 255, 139, 115, 147, 91, 148, 188, 142, 133, 149, 166, 149, 38, 148, 160, 149, 246, 111, 185, 66, 122, 38, 216, 134, 124, 18, 46, 62, 223, 73, 28, 108, 123, 150, 150, 150, 108, 65, 163, 150, 213, 110, 218, 97, 182, 150, 245, 120, 224, 138, 189, 150, 204, 83, 161, 73, 184, 108, 116, 2, 16, 100, 175, 144, 229, 144, 209, 74, 21, 25, 10, 51, 49, 151, 66, 134, 54, 151, 15, 74, 61, 69, 133, 69, 233, 74, 117, 112, 65, 91, 27, 151, 0, 0, 213, 145, 87, 151, 74, 91, 235, 145, 95, 151, 37, 148, 208, 80, 183, 48, 188, 48, 137, 151, 159, 151, 177, 151, 190, 151, 192, 151, 210, 151, 224, 151, 108, 84, 238, 151, 28, 116, 51, 148, 0, 0, 245, 151, 29, 148, 122, 121, 209, 74, 52, 152, 51, 152, 75, 152, 102, 152, 14, 59, 117, 113, 81, 61, 48, 6, 92, 65, 6, 87, 202, 152, 183, 152, 200, 152, 199, 152, 255, 74, 39, 109, 211, 22, 176, 85, 225, 152, 230, 152, 236, 152, 120, 147, 57, 153, 41, 74, 114, 75, 87, 152, 5, 153, 245, 153, 12, 154, 59, 154, 16, 154, 88, 154, 37, 87, 196, 54, 177, 144, 213, 155, 224, 154, 226, 154, 5, 155, 244, 154, 14, 76, 20, 155, 45, 155, 0, 134, 52, 80, 52, 155, 168, 105, 195, 56, 125, 48, 80, 155, 64, 155, 62, 157, 69, 90, 99, 24, 142, 155, 75, 66, 2, 156, 255, 155, 12, 156, 104, 158, 212, 157, 183, 159, 146, 161, 171, 161, 225, 160, 35, 161, 223, 161, 126, 157, 131, 157, 52, 161, 14, 158, 136, 104, 196, 157, 91, 33, 147, 161, 32, 162, 59, 25, 51, 162, 57, 157, 185, 160, 180, 162, 144, 158, 149, 158, 158, 158, 162, 158, 52, 77, 170, 158, 175, 158, 100, 67, 193, 158, 96, 59, 229, 57, 29, 61, 50, 79, 190, 55, 43, 140, 2, 159, 8, 159, 150, 75, 36, 148, 162, 109, 23, 159, 0, 0, 57, 159, 159, 86, 138, 86, 69, 159, 184, 153, 139, 144, 242, 151, 127, 132, 98, 159, 105, 159, 220, 122, 142, 159, 22, 114, 190, 75, 117, 73, 187, 73, 119, 113, 248, 73, 72, 67, 81, 74, 158, 115, 218, 139, 250, 24, 159, 121, 126, 137, 54, 142, 105, 147, 243, 147, 68, 138, 236, 146, 129, 147, 203, 147, 108, 137, 185, 68, 23, 114, 235, 62, 114, 119, 67, 122, 208, 112, 115, 68, 248, 67, 126, 113, 239, 23, 163, 112, 190, 24, 153, 53, 199, 62, 133, 24, 47, 84, 248, 23, 34, 55, 251, 22, 57, 24, 225, 54, 116, 23, 209, 24, 75, 95, 35, 55, 192, 22, 91, 87, 37, 74, 254, 19, 168, 18, 198, 19, 182, 20, 3, 133, 166, 54, 0, 0, 85, 132, 148, 73, 101, 113, 49, 62, 92, 85, 251, 62, 82, 112, 244, 68, 238, 54, 157, 153, 38, 111, 249, 103, 51, 55, 21, 60, 231, 61, 108, 88, 34, 25, 16, 104, 87, 64, 63, 55, 225, 64, 139, 64, 15, 65, 33, 108, 203, 84, 158, 86, 177, 102, 146, 86, 223, 15, 168, 11, 13, 14, 198, 147, 19, 139, 156, 147, 248, 78, 43, 81, 25, 56, 54, 68, 188, 78, 101, 4, 127, 3, 75, 79, 138, 79, 81, 86, 104, 90, 171, 1, 203, 3, 153, 57, 10, 3, 20, 4, 53, 52, 41, 79, 192, 2, 179, 142, 117, 2, 218, 138, 12, 2, 152, 78, 205, 80, 13, 81, 162, 79, 3, 79, 14, 74, 138, 62, 66, 79, 46, 80, 108, 80, 129, 80, 204, 79, 229, 79, 88, 80, 252, 80, 0, 0, 0, 0, 0, 0, 0, 0, 118, 110, 149, 53, 57, 62, 191, 62, 114, 109, 132, 24, 137, 62, 168, 81, 195, 81, 224, 5, 221, 68, 163, 4, 146, 4, 145, 4, 122, 141, 156, 138, 14, 7, 89, 82, 164, 82, 115, 8, 225, 82, 0, 0, 122, 70, 140, 113, 140, 67, 32, 12, 172, 73, 228, 16, 209, 105, 29, 14, 0, 0, 222, 62, 153, 116, 20, 116, 86, 116, 152, 115, 142, 75, 188, 74, 141, 64, 208, 83, 132, 53, 15, 114, 201, 64, 180, 85, 69, 3, 205, 84, 198, 11, 29, 87, 93, 146, 244, 150, 102, 147, 221, 87, 141, 87, 127, 87, 62, 54, 203, 88, 153, 90, 70, 138, 250, 22, 111, 23, 16, 23, 44, 90, 184, 89, 143, 146, 126, 90, 207, 90, 18, 90, 70, 89, 243, 25, 97, 24, 149, 66, 245, 54, 5, 109, 67, 116, 33, 90, 131, 94, 129, 90, 215, 139, 19, 4, 224, 147, 140, 116, 3, 19, 5, 113, 114, 73, 8, 148, 251, 137, 189, 147, 160, 55, 30, 92, 158, 92, 94, 94, 72, 94, 150, 25, 124, 25, 238, 58, 205, 94, 79, 91, 3, 25, 4, 25, 1, 55, 160, 24, 221, 54, 254, 22, 211, 54, 42, 129, 71, 138, 186, 29, 114, 52, 168, 137, 12, 95, 14, 95, 39, 25, 171, 23, 107, 90, 59, 23, 68, 91, 20, 134, 253, 117, 96, 136, 126, 96, 96, 40, 43, 38, 219, 95, 184, 62, 175, 37, 190, 37, 136, 144, 115, 111, 192, 97, 62, 0, 70, 0, 27, 38, 153, 97, 152, 97, 117, 96, 155, 44, 7, 45, 212, 70, 77, 145, 113, 100, 101, 70, 106, 43, 41, 58, 34, 43, 80, 52, 234, 152, 120, 46, 55, 99, 91, 164, 182, 100, 49, 99, 209, 99, 227, 73, 103, 45, 164, 98, 161, 44, 59, 100, 107, 101, 114, 105, 244, 59, 142, 48, 173, 50, 137, 73, 171, 50, 13, 85, 224, 50, 217, 24, 63, 148, 206, 102, 137, 50, 179, 49, 224, 58, 144, 65, 132, 85, 34, 139, 143, 85, 252, 22, 91, 85, 37, 84, 238, 120, 3, 49, 42, 24, 52, 50, 100, 52, 15, 50, 130, 49, 201, 66, 142, 102, 36, 109, 107, 102, 147, 75, 48, 102, 112, 120, 235, 29, 99, 102, 210, 50, 225, 50, 30, 102, 114, 88, 209, 56, 58, 56, 188, 55, 153, 59, 162, 55, 254, 51, 208, 116, 150, 59, 143, 103, 42, 70, 182, 104, 30, 104, 196, 59, 190, 106, 99, 56, 213, 55, 135, 68, 51, 106, 82, 106, 201, 106, 5, 107, 18, 25, 17, 101, 152, 104, 76, 106, 215, 59, 122, 106, 87, 107, 192, 63, 154, 60, 160, 147, 242, 146, 234, 139, 203, 138, 137, 146, 30, 128, 220, 137, 103, 148, 165, 109, 11, 111, 236, 73, 0, 0, 127, 63, 143, 61, 4, 110, 60, 64, 61, 90, 10, 110, 71, 88, 36, 109, 66, 120, 59, 113, 26, 67, 118, 66, 241, 112, 80, 114, 135, 114, 148, 114, 143, 71, 37, 71, 121, 81, 164, 74, 235, 5, 122, 116, 248, 62, 95, 54, 74, 74, 23, 73, 225, 95, 6, 63, 177, 62, 223, 74, 35, 140, 53, 63, 167, 96, 243, 62, 204, 116, 60, 116, 135, 147, 55, 116, 159, 68, 234, 109, 81, 69, 131, 117, 99, 63, 217, 76, 6, 77, 88, 63, 85, 117, 115, 118, 198, 165, 25, 59, 104, 116, 204, 138, 171, 73, 142, 73, 251, 58, 205, 61, 78, 74, 255, 62, 197, 73, 243, 72, 250, 145, 50, 87, 66, 147, 227, 138, 100, 24, 223, 80, 33, 82, 231, 81, 120, 119, 50, 50, 14, 119, 15, 119, 123, 119, 151, 70, 129, 55, 94, 58, 240, 72, 56, 116, 155, 116, 191, 62, 186, 74, 199, 74, 200, 64, 150, 74, 174, 97, 7, 147, 129, 85, 30, 120, 141, 120, 136, 120, 210, 120, 208, 115, 89, 121, 65, 119, 227, 86, 14, 65, 0, 0, 150, 132, 165, 121, 45, 106, 250, 62, 58, 122, 244, 121, 110, 65, 230, 22, 50, 65, 53, 146, 241, 121, 76, 13, 140, 73, 153, 2, 186, 61, 110, 23, 151, 53, 107, 85, 112, 53, 170, 54, 212, 1, 13, 12, 226, 122, 89, 90, 245, 38, 175, 90, 156, 90, 13, 90, 91, 2, 240, 120, 42, 90, 198, 91, 254, 122, 249, 65, 93, 124, 109, 124, 17, 66, 179, 91, 188, 94, 166, 94, 205, 124, 249, 73, 176, 23, 142, 124, 124, 124, 174, 124, 178, 106, 220, 125, 7, 126, 211, 125, 78, 127, 97, 98, 92, 97, 72, 123, 151, 125, 130, 94, 106, 66, 117, 107, 22, 9, 214, 103, 78, 0, 207, 53, 196, 87, 18, 100, 248, 99, 98, 73, 221, 127, 39, 123, 44, 8, 233, 90, 67, 93, 12, 123, 14, 94, 230, 153, 69, 134, 99, 154, 28, 106, 63, 52, 226, 57, 247, 73, 173, 101, 31, 154, 160, 101, 128, 132, 39, 113, 209, 108, 234, 68, 55, 129, 2, 68, 198, 128, 9, 129, 66, 129, 180, 103, 195, 152, 66, 106, 98, 130, 101, 130, 81, 106, 83, 132, 167, 109, 16, 134, 27, 114, 134, 90, 127, 65, 64, 24, 43, 91, 161, 24, 228, 90, 216, 24, 160, 134, 188, 249, 143, 61, 45, 136, 34, 116, 2, 90, 110, 136, 69, 79, 135, 136, 191, 136, 230, 136, 101, 137, 77, 137, 131, 86, 84, 137, 133, 119, 132, 119, 245, 139, 217, 139, 156, 139, 249, 137, 173, 62, 163, 132, 245, 70, 207, 70, 242, 55, 61, 138, 28, 138, 72, 148, 77, 95, 43, 146, 132, 66, 212, 101, 41, 113, 196, 112, 69, 24, 109, 157, 159, 140, 233, 140, 220, 125, 154, 89, 195, 119, 240, 89, 110, 67, 212, 54, 42, 142, 167, 142, 9, 76, 48, 143, 74, 143, 244, 66, 88, 108, 187, 111, 33, 35, 155, 72, 121, 111, 139, 110, 218, 23, 233, 155, 181, 54, 47, 73, 187, 144, 0, 0, 113, 85, 6, 73, 187, 145, 4, 148, 75, 138, 98, 64, 252, 138, 39, 148, 29, 140, 59, 140, 229, 132, 43, 138, 153, 149, 167, 149, 151, 149, 150, 149, 52, 141, 69, 116, 194, 62, 255, 72, 66, 74, 234, 67, 231, 62, 37, 50, 143, 150, 231, 142, 102, 142, 101, 142, 204, 62, 237, 73, 120, 74, 238, 63, 18, 116, 107, 116, 252, 62, 65, 151, 176, 144, 71, 104, 29, 74, 147, 144, 223, 87, 0, 0, 104, 147, 137, 137, 38, 140, 47, 139, 190, 99, 186, 146, 17, 91, 105, 139, 60, 73, 249, 115, 27, 66, 155, 151, 113, 151, 56, 153, 38, 15, 193, 93, 197, 139, 178, 74, 31, 152, 218, 148, 246, 146, 215, 149, 229, 145, 192, 68, 80, 139, 103, 74, 100, 139, 220, 152, 69, 138, 0, 63, 42, 146, 37, 73, 20, 132, 59, 153, 77, 153, 6, 123, 253, 61, 155, 153, 111, 75, 170, 153, 92, 154, 101, 139, 200, 88, 143, 106, 33, 154, 254, 90, 47, 154, 241, 152, 144, 75, 72, 153, 188, 153, 189, 75, 151, 75, 125, 147, 114, 88, 2, 19, 34, 88, 184, 73, 232, 20, 68, 120, 31, 39, 184, 61, 197, 104, 125, 61, 88, 148, 39, 57, 80, 97, 129, 39, 107, 41, 7, 97, 79, 156, 83, 156, 123, 156, 53, 156, 16, 156, 127, 155, 207, 155, 45, 158, 159, 155, 245, 161, 254, 160, 33, 157, 174, 76, 4, 65, 24, 158, 176, 76, 12, 157, 180, 161, 237, 160, 243, 160, 47, 153, 165, 157, 189, 132, 18, 110, 223, 111, 130, 107, 252, 133, 51, 69, 164, 109, 132, 110, 240, 109, 32, 132, 238, 133, 0, 110, 215, 55, 100, 96, 226, 121, 156, 53, 64, 54, 45, 73, 222, 73, 98, 61, 219, 147, 190, 146, 72, 147, 191, 2, 185, 120, 119, 146, 77, 148, 228, 79, 64, 52, 100, 144, 93, 85, 61, 120, 84, 120, 182, 120, 75, 120, 87, 23, 201, 49, 65, 73, 154, 54, 114, 79, 218, 111, 217, 111, 0, 0, 30, 112, 20, 84, 181, 65, 187, 87, 243, 88, 138, 87, 22, 157, 215, 87, 52, 113, 175, 52, 172, 65, 235, 113, 64, 108, 151, 79, 0, 0, 181, 23, 73, 138, 12, 97, 206, 90, 11, 90, 188, 66, 136, 68, 44, 55, 123, 75, 252, 137, 187, 147, 184, 147, 214, 24, 29, 15, 114, 132, 192, 108, 19, 20, 250, 66, 38, 44, 193, 67, 148, 89, 183, 61, 65, 103, 168, 125, 91, 97, 164, 96, 185, 73, 139, 73, 250, 137, 229, 146, 226, 115, 233, 62, 180, 116, 99, 139, 159, 24, 225, 62, 179, 74, 216, 106, 243, 115, 251, 115, 214, 62, 62, 74, 148, 74, 217, 23, 102, 74, 167, 3, 36, 20, 229, 73, 72, 116, 22, 73, 165, 112, 118, 73, 132, 146, 230, 115, 95, 147, 254, 4, 49, 147, 206, 138, 22, 138, 134, 147, 231, 139, 213, 85, 53, 73, 130, 138, 107, 113, 67, 73, 255, 12, 164, 86, 26, 6, 235, 11, 184, 12, 2, 85, 196, 121, 250, 23, 254, 125, 194, 22, 80, 74, 82, 24, 46, 69, 1, 148, 10, 55, 192, 138, 173, 73, 176, 89, 191, 24, 131, 24, 132, 116, 161, 90, 226, 54, 91, 61, 176, 54, 95, 146, 121, 90, 129, 138, 98, 24, 116, 147, 205, 60, 180, 10, 150, 74, 138, 57, 244, 80, 105, 61, 76, 61, 156, 19, 117, 113, 251, 66, 24, 130, 15, 110, 228, 144, 235, 68, 87, 109, 79, 126, 103, 112, 175, 108, 214, 60, 237, 63, 45, 62, 2, 110, 12, 111, 111, 61, 245, 3, 81, 117, 188, 54, 200, 52, 128, 70, 218, 62, 113, 72, 196, 89, 110, 146, 62, 73, 65, 143, 28, 140, 192, 107, 18, 88, 200, 87, 214, 54, 82, 20, 254, 112, 98, 67, 113, 74, 227, 47, 176, 18, 189, 35, 185, 104, 103, 105, 152, 19, 229, 52, 244, 123, 223, 54, 131, 138, 214, 55, 250, 51, 159, 76, 26, 106, 173, 54, 183, 108, 62, 132, 223, 68, 206, 68, 38, 109, 81, 109, 130, 108, 222, 111, 23, 111, 9, 113, 61, 131, 58, 23, 237, 131, 128, 108, 83, 112, 219, 23, 137, 89, 130, 90, 179, 23, 97, 90, 113, 90, 5, 25, 252, 65, 45, 55, 239, 89, 60, 23, 199, 54, 142, 113, 144, 147, 154, 102, 165, 66, 110, 90, 43, 90, 147, 66, 43, 106, 249, 62, 54, 119, 91, 68, 202, 66, 29, 113, 89, 66, 225, 137, 176, 79, 40, 109, 194, 92, 206, 68, 77, 126, 189, 67, 12, 106, 86, 66, 4, 19, 166, 112, 51, 113, 233, 67, 165, 61, 223, 108, 37, 248, 79, 74, 101, 126, 235, 89, 47, 93, 243, 61, 92, 95, 93, 74, 223, 23, 164, 125, 38, 132, 133, 84, 250, 58, 0, 51, 20, 2, 126, 87, 213, 8, 25, 6, 229, 63, 158, 31, 182, 162, 3, 112, 91, 145, 112, 93, 143, 115, 211, 124, 89, 138, 32, 148, 200, 79, 231, 127, 205, 114, 16, 115, 244, 122, 56, 115, 57, 115, 246, 86, 65, 115, 72, 115, 169, 62, 24, 123, 108, 144, 245, 113, 242, 72, 225, 115, 246, 129, 202, 62, 12, 119, 209, 62, 162, 108, 253, 86, 25, 116, 30, 116, 31, 116, 226, 62, 240, 62, 244, 62, 250, 62, 211, 116, 14, 63, 83, 63, 66, 117, 109, 117, 114, 117, 141, 117, 124, 63, 200, 117, 220, 117, 192, 63, 77, 118, 215, 63, 116, 118, 220, 63, 122, 118, 92, 79, 136, 113, 35, 86, 128, 137, 105, 88, 29, 64, 67, 119, 57, 64, 97, 103, 69, 64, 219, 53, 152, 119, 106, 64, 111, 64, 94, 92, 190, 119, 203, 119, 242, 88, 24, 120, 185, 112, 28, 120, 168, 64, 57, 120, 71, 120, 81, 120, 102, 120, 72, 132, 53, 85, 51, 121, 3, 104, 50, 121, 3, 65, 9, 65, 145, 121, 153, 121, 187, 143, 6, 122, 188, 143, 103, 65, 145, 122, 178, 65, 188, 122, 121, 130, 196, 65, 207, 122, 219, 122, 207, 65, 33, 78, 98, 123, 108, 123, 123, 123, 18, 124, 27, 124, 96, 66, 122, 66, 123, 124, 156, 124, 140, 66, 184, 124, 148, 66, 237, 124, 147, 143, 192, 112, 207, 12, 207, 125, 212, 125, 208, 125, 253, 125, 174, 127, 180, 127, 159, 114, 151, 67, 32, 128, 37, 128, 57, 123, 46, 128, 49, 128, 84, 128, 204, 61, 180, 87, 160, 112, 183, 128, 233, 128, 237, 67, 12, 129, 42, 115, 14, 129, 18, 129, 96, 117, 20, 129, 1, 68, 57, 59, 86, 129, 89, 129, 90, 129, 19, 68, 58, 88, 124, 129, 132, 129, 37, 68, 147, 129, 45, 68, 165, 129, 239, 87, 193, 129, 228, 129, 84, 130, 143, 68, 166, 130, 118, 130, 202, 130, 216, 130, 255, 130, 176, 68, 87, 131, 105, 150, 138, 105, 5, 132, 245, 112, 100, 132, 227, 96, 136, 132, 4, 69, 190, 132, 225, 132, 248, 132, 16, 133, 56, 133, 82, 133, 59, 69, 111, 133, 112, 133, 224, 133, 119, 69, 114, 134, 146, 134, 178, 134, 239, 134, 69, 150, 139, 135, 6, 70, 23, 70, 174, 136, 255, 136, 36, 137, 71, 137, 145, 137, 103, 121, 41, 138, 56, 138, 148, 138, 180, 138, 81, 140, 212, 140, 242, 140, 28, 141, 152, 71, 95, 88, 195, 141, 237, 71, 238, 78, 58, 142, 216, 85, 84, 87, 113, 142, 245, 85, 176, 142, 55, 72, 206, 142, 226, 142, 228, 142, 237, 142, 242, 142, 183, 143, 193, 143, 202, 143, 204, 143, 51, 144, 196, 153, 173, 72, 224, 152, 19, 146, 30, 73, 40, 146, 88, 146, 107, 146, 177, 146, 174, 146, 191, 146, 227, 146, 235, 146, 243, 146, 244, 146, 253, 146, 67, 147, 132, 147, 173, 147, 69, 73, 81, 73, 191, 158, 23, 148, 1, 83, 29, 148, 45, 148, 62, 148, 106, 73, 84, 148, 121, 148, 45, 149, 162, 149, 167, 73, 244, 149, 51, 150, 229, 73, 160, 103, 36, 74, 64, 151, 53, 74, 178, 151, 194, 151, 84, 86, 228, 74, 232, 96, 185, 152, 25, 75, 241, 152, 68, 88, 14, 153, 25, 153, 180, 81, 28, 153, 55, 153, 66, 153, 93, 153, 98, 153, 112, 75, 197, 153, 157, 75, 60, 154, 15, 155, 131, 122, 105, 155, 129, 155, 221, 155, 241, 155, 244, 155, 109, 76, 32, 156, 111, 55, 194, 27, 73, 157, 58, 156, 254, 158, 80, 86, 147, 157, 189, 157, 192, 157, 252, 157, 246, 148, 182, 143, 123, 158, 172, 158, 177, 158, 189, 158, 198, 158, 220, 148, 226, 158, 241, 158, 248, 158, 200, 122, 68, 159, 148, 0, 183, 2, 160, 3, 26, 105, 195, 148, 172, 89, 215, 4, 64, 88, 193, 148, 185, 55, 213, 5, 21, 6, 118, 6, 186, 22, 87, 87, 115, 113, 194, 10, 205, 10, 191, 11, 106, 84, 59, 248, 203, 11, 158, 84, 251, 11, 59, 12, 83, 12, 101, 12, 124, 12, 231, 96, 141, 12, 122, 86, 181, 12, 221, 12, 237, 12, 111, 13, 178, 13, 200, 13, 85, 105, 47, 156, 165, 135, 4, 14, 14, 14, 215, 14, 144, 15, 45, 15, 115, 14, 32, 92, 188, 15, 11, 94, 92, 16, 79, 16, 118, 16, 30, 103, 123, 16, 136, 16, 150, 16, 71, 54, 191, 16, 211, 16, 47, 17, 59, 17, 100, 83, 173, 132, 227, 18, 117, 19, 54, 19, 129, 139, 119, 21, 25, 22, 195, 23, 199, 23, 120, 78, 187, 112, 45, 24, 106, 25, 45, 26, 69, 26, 42, 28, 112, 28, 172, 28, 200, 30, 195, 98, 213, 30, 21, 31, 152, 113, 85, 104, 69, 32, 233, 105, 200, 54, 124, 34, 215, 35, 250, 35, 42, 39, 113, 40, 79, 41, 253, 130, 103, 41, 147, 41, 213, 42, 165, 137, 232, 42, 160, 143, 14, 43, 184, 151, 63, 43, 71, 152, 189, 154, 76, 44, 0, 0, 136, 44, 183, 44, 232, 91, 8, 45, 18, 45, 183, 45, 149, 45, 66, 46, 116, 47, 204, 47, 51, 48, 102, 48, 31, 51, 222, 51, 177, 95, 72, 102, 191, 102, 121, 122, 103, 53, 243, 53, 0, 0, 186, 73, 0, 0, 26, 54, 22, 55, 0, 0, 70, 3, 181, 88, 14, 103, 24, 105, 167, 58, 87, 118, 226, 95, 17, 62, 185, 62, 254, 117, 154, 32, 208, 72, 184, 74, 25, 65, 154, 138, 238, 66, 13, 67, 59, 64, 52, 67, 150, 67, 69, 74, 202, 5, 210, 81, 17, 6, 159, 89, 168, 30, 190, 59, 255, 60, 4, 68, 214, 68, 136, 87, 116, 70, 155, 57, 47, 71, 232, 133, 201, 153, 98, 55, 195, 33, 94, 139, 78, 139, 0, 0, 18, 72, 251, 72, 21, 74, 9, 114, 192, 74, 120, 12, 101, 89, 165, 78, 134, 79, 121, 7, 218, 142, 44, 80, 143, 82, 63, 87, 113, 113, 153, 82, 25, 84, 74, 63, 167, 74, 188, 85, 70, 84, 110, 84, 82, 107, 0, 0, 115, 52, 63, 85, 50, 118, 94, 85, 24, 71, 98, 85, 102, 85, 199, 87, 63, 73, 93, 88, 102, 80, 251, 52, 204, 51, 0, 0, 3, 89, 124, 71, 72, 137, 174, 90, 137, 91, 6, 92, 144, 29, 161, 87, 81, 113, 0, 0, 2, 97, 18, 124, 86, 144, 178, 97, 154, 79, 98, 139, 2, 100, 74, 100, 91, 93, 247, 107, 0, 0, 132, 100, 28, 25, 234, 138, 246, 73, 136, 100, 239, 63, 18, 101, 192, 75, 191, 101, 181, 102, 27, 39, 101, 148, 225, 87, 149, 97, 39, 90, 205, 248, 0, 0, 185, 86, 33, 69, 252, 102, 106, 78, 52, 73, 86, 150, 143, 109, 189, 108, 24, 54, 119, 137, 153, 103, 110, 104, 17, 100, 94, 104, 0, 0, 199, 104, 66, 123, 192, 144, 17, 10, 38, 105, 0, 0, 57, 105, 69, 122, 0, 0, 250, 105, 38, 154, 45, 106, 95, 54, 105, 100, 33, 0, 131, 121, 52, 106, 91, 107, 44, 93, 25, 53, 0, 0, 157, 107, 208, 70, 164, 108, 59, 117, 101, 136, 174, 109, 182, 88, 28, 55, 141, 37, 75, 112, 205, 113, 84, 60, 128, 114, 133, 114, 129, 146, 122, 33, 139, 114, 48, 147, 230, 114, 208, 73, 57, 108, 159, 148, 80, 116, 248, 14, 39, 136, 245, 136, 38, 41, 115, 132, 177, 23, 184, 110, 42, 74, 32, 24, 164, 57, 185, 54, 0, 0, 0, 0, 63, 69, 182, 102, 173, 156, 164, 152, 67, 137, 204, 119, 88, 120, 214, 86, 223, 64, 10, 22, 161, 57, 47, 55, 232, 128, 197, 19, 173, 113, 102, 131, 221, 121, 168, 145, 0, 0, 183, 76, 175, 112, 171, 137, 253, 121, 10, 122, 11, 123, 102, 125, 122, 65, 67, 123, 126, 121, 9, 128, 181, 111, 223, 162, 3, 106, 24, 131, 162, 83, 7, 110, 191, 147, 54, 104, 93, 151, 111, 129, 35, 128, 181, 105, 237, 19, 47, 50, 72, 128, 133, 93, 48, 140, 131, 128, 21, 87, 35, 152, 73, 137, 171, 93, 136, 73, 190, 101, 213, 105, 210, 83, 165, 74, 129, 63, 17, 60, 54, 103, 144, 128, 244, 128, 46, 129, 161, 31, 79, 129, 137, 129, 175, 129, 26, 130, 6, 131, 47, 131, 138, 131, 202, 53, 104, 132, 170, 134, 250, 72, 230, 99, 86, 137, 8, 120, 85, 146, 184, 137, 242, 67, 231, 137, 223, 67, 232, 137, 70, 139, 212, 139, 248, 89, 9, 140, 0, 0, 197, 143, 236, 144, 0, 0, 16, 145, 60, 145, 247, 61, 94, 145, 202, 74, 208, 143, 143, 114, 139, 86, 231, 148, 233, 149, 176, 149, 184, 149, 50, 151, 209, 152, 73, 153, 106, 153, 195, 153, 40, 154, 14, 155, 90, 157, 155, 157, 159, 126, 248, 158, 35, 159, 164, 76, 71, 149, 147, 162, 162, 113, 255, 162, 145, 77, 18, 144, 203, 165, 156, 77, 156, 12, 190, 143, 193, 85, 186, 143, 176, 36, 185, 143, 147, 74, 9, 69, 127, 126, 86, 111, 177, 106, 234, 78, 228, 52, 44, 139, 157, 120, 58, 55, 128, 142, 245, 23, 36, 128, 108, 139, 153, 139, 62, 122, 175, 102, 235, 61, 85, 118, 183, 60, 53, 86, 86, 89, 154, 78, 129, 94, 88, 98, 191, 86, 109, 14, 14, 142, 109, 91, 136, 62, 158, 76, 222, 99, 0, 0, 246, 23, 123, 24, 48, 101, 45, 86, 74, 92, 26, 84, 17, 83, 198, 61, 152, 157, 125, 76, 34, 86, 30, 86, 73, 127, 216, 94, 117, 89, 64, 61, 112, 135, 28, 78, 234, 15, 73, 13, 186, 54, 23, 129, 94, 157, 24, 141, 59, 118, 69, 156, 78, 118, 185, 119, 69, 147, 50, 84, 72, 129, 247, 130, 37, 86, 50, 129, 24, 132, 189, 128, 234, 85, 98, 121, 67, 86, 22, 84, 157, 14, 206, 53, 5, 86, 241, 85, 241, 102, 226, 130, 45, 54, 52, 117, 240, 85, 186, 85, 151, 84, 114, 85, 65, 12, 150, 12, 208, 94, 72, 81, 118, 14, 98, 44, 162, 14, 171, 158, 90, 125, 222, 85, 117, 16, 157, 98, 109, 151, 148, 84, 205, 140, 246, 113, 118, 145, 252, 99, 185, 99, 254, 99, 105, 85, 67, 43, 114, 156, 179, 46, 154, 81, 223, 52, 167, 13, 167, 81, 77, 84, 30, 85, 19, 85, 102, 118, 45, 142, 138, 104, 177, 117, 182, 128, 4, 136, 134, 135, 199, 136, 182, 129, 28, 132, 193, 16, 236, 68, 4, 115, 6, 71, 144, 91, 11, 131, 147, 104, 123, 86, 244, 38, 47, 125, 163, 65, 115, 125, 208, 110, 182, 114, 112, 145, 217, 17, 8, 146, 252, 60, 169, 166, 172, 14, 249, 14, 102, 114, 162, 28, 78, 71, 194, 79, 249, 127, 235, 15, 250, 64, 93, 156, 31, 101, 160, 45, 243, 72, 224, 71, 124, 157, 236, 15, 10, 14, 0, 0, 163, 117, 237, 15, 0, 0, 72, 96, 135, 17, 163, 113, 142, 126, 80, 157, 26, 78, 4, 78, 119, 53, 13, 91, 178, 108, 103, 83, 172, 54, 220, 57, 125, 83, 165, 54, 24, 70, 154, 88, 110, 75, 45, 130, 75, 84, 170, 87, 149, 90, 121, 9, 0, 0, 82, 58, 101, 36, 116, 115, 172, 158, 9, 77, 237, 155, 254, 60, 48, 159, 91, 76, 169, 79, 158, 149, 222, 159, 92, 132, 182, 61, 178, 114, 179, 103, 32, 55, 46, 99, 37, 125, 247, 62, 44, 62, 42, 58, 8, 144, 204, 82, 116, 62, 122, 54, 233, 69, 142, 4, 64, 118, 240, 90, 182, 14, 122, 120, 46, 127, 167, 88, 191, 64, 124, 86, 139, 155, 116, 93, 84, 118, 52, 164, 133, 158, 225, 76, 0, 0, 251, 55, 25, 97, 218, 48, 242, 67, 0, 0, 93, 86, 169, 18, 167, 87, 99, 73, 6, 158, 52, 82, 174, 112, 173, 53, 0, 0, 124, 157, 86, 124, 57, 155, 222, 87, 108, 23, 83, 92, 211, 100, 208, 148, 53, 99, 100, 113, 173, 134, 40, 13, 34, 109, 226, 74, 113, 13, 0, 0, 254, 81, 15, 31, 142, 93, 3, 151, 209, 29, 129, 158, 76, 144, 31, 123, 2, 155, 209, 92, 163, 123, 104, 98, 53, 99, 255, 154, 207, 123, 42, 155, 126, 124, 0, 0, 66, 124, 134, 124, 21, 156, 252, 123, 9, 155, 0, 0, 27, 156, 62, 73, 90, 159, 115, 85, 195, 91, 253, 79, 152, 158, 242, 79, 96, 82, 6, 62, 209, 82, 103, 87, 86, 80, 183, 89, 18, 94, 200, 151, 171, 157, 92, 143, 105, 84, 180, 151, 64, 153, 186, 151, 44, 83, 48, 97, 44, 105, 218, 83, 10, 156, 2, 157, 59, 76, 65, 150, 128, 105, 166, 80, 70, 117, 109, 23, 218, 153, 115, 82, 0, 0, 89, 145, 129, 150, 92, 145, 0, 0, 81, 145, 151, 142, 127, 99, 35, 109, 202, 106, 17, 86, 142, 145, 122, 117, 133, 98, 252, 3, 79, 115, 112, 124, 33, 92, 253, 60, 0, 0, 25, 73, 214, 118, 157, 155, 42, 78, 212, 12, 190, 131, 66, 136, 0, 0, 74, 92, 192, 105, 0, 0, 122, 87, 31, 82, 245, 93, 206, 78, 49, 108, 242, 1, 57, 79, 156, 84, 218, 84, 154, 82, 130, 141, 254, 53, 0, 0, 243, 53, 0, 0, 82, 107, 124, 145, 165, 159, 151, 155, 46, 152, 180, 152, 186, 154, 168, 158, 132, 158, 122, 113, 20, 123, 0, 0, 250, 107, 24, 136, 120, 127, 0, 0, 32, 86, 74, 166, 119, 142, 83, 159, 0, 0, 212, 141, 79, 142, 28, 158, 1, 142, 130, 98, 125, 131, 40, 142, 117, 142, 211, 122, 119, 74, 62, 122, 216, 120, 234, 108, 103, 138, 7, 118, 90, 138, 38, 159, 206, 108, 214, 135, 195, 117, 178, 162, 83, 120, 64, 248, 12, 141, 226, 114, 113, 115, 45, 139, 2, 115, 241, 116, 235, 140, 187, 74, 47, 134, 186, 95, 160, 136, 183, 68, 0, 0, 59, 24, 5, 110, 0, 0, 126, 138, 27, 37, 0, 0, 253, 96, 103, 118, 215, 154, 68, 157, 110, 147, 143, 155, 245, 135, 0, 0, 0, 0, 247, 140, 44, 115, 33, 151, 176, 155, 214, 53, 178, 114, 7, 76, 81, 124, 74, 153, 89, 97, 89, 97, 4, 76, 150, 158, 125, 97, 0, 0, 95, 87, 111, 97, 166, 98, 57, 98, 0, 0, 92, 58, 226, 97, 170, 83, 245, 51, 100, 99, 2, 104, 210, 53, 87, 93, 194, 139, 218, 143, 57, 142, 0, 0, 217, 80, 70, 29, 6, 121, 50, 83, 56, 150, 59, 15, 101, 64, 0, 0, 254, 119, 0, 0, 194, 124, 26, 95, 218, 124, 45, 122, 102, 128, 99, 128, 77, 125, 5, 117, 242, 116, 148, 137, 26, 130, 12, 103, 98, 128, 134, 116, 91, 128, 240, 116, 3, 129, 36, 119, 137, 137, 204, 103, 83, 117, 209, 110, 169, 135, 206, 135, 200, 129, 140, 135, 73, 138, 173, 140, 67, 139, 43, 119, 248, 116, 218, 132, 53, 54, 178, 105, 166, 141, 0, 0, 169, 137, 0, 0, 185, 109, 193, 135, 17, 64, 231, 116, 219, 61, 118, 113, 164, 96, 156, 97, 209, 60, 0, 0, 119, 96, 0, 0, 113, 127, 45, 139, 0, 0, 233, 96, 126, 75, 32, 82, 24, 60, 199, 60, 215, 94, 86, 118, 49, 85, 68, 25, 254, 18, 3, 153, 220, 109, 173, 112, 193, 92, 173, 97, 15, 138, 119, 54, 238, 0, 70, 104, 14, 79, 98, 69, 31, 91, 76, 99, 80, 159, 166, 158, 107, 98, 71, 5, 219, 146, 223, 5, 197, 63, 76, 133, 181, 66, 239, 115, 181, 81, 73, 54, 66, 73, 228, 137, 68, 147, 219, 25, 238, 130, 200, 60, 60, 120, 68, 103, 223, 98, 51, 73, 170, 137, 160, 2, 179, 107, 5, 19, 171, 79, 237, 36, 8, 80, 41, 109, 132, 122, 0, 54, 177, 74, 19, 37, 0, 0, 126, 3, 164, 95, 128, 3, 71, 3, 219, 110, 31, 4, 0, 0, 1, 81, 122, 52, 14, 81, 108, 152, 67, 55, 22, 132, 164, 73, 135, 4, 96, 81, 180, 51, 106, 81, 255, 11, 252, 32, 229, 2, 48, 37, 142, 5, 51, 50, 131, 25, 130, 91, 125, 135, 179, 5, 153, 60, 178, 81, 184, 81, 52, 157, 201, 81, 207, 81, 209, 81, 220, 60, 211, 81, 166, 74, 179, 81, 226, 81, 66, 83, 237, 81, 205, 131, 62, 105, 45, 55, 123, 95, 11, 82, 38, 82, 60, 82, 181, 82, 87, 82, 148, 82, 185, 82, 197, 82, 21, 124, 66, 133, 224, 82, 13, 134, 19, 107, 0, 0, 222, 138, 73, 85, 217, 110, 128, 63, 84, 9, 236, 63, 51, 83, 0, 0, 226, 11, 203, 108, 38, 23, 27, 104, 213, 115, 74, 96, 170, 62, 204, 56, 232, 22, 221, 113, 162, 68, 109, 83, 116, 83, 171, 134, 126, 83, 0, 0, 150, 21, 19, 22, 230, 119, 147, 83, 155, 138, 160, 83, 171, 83, 174, 83, 167, 115, 114, 87, 89, 63, 156, 115, 193, 83, 197, 83, 73, 108, 73, 78, 254, 87, 217, 83, 171, 58, 143, 11, 224, 83, 235, 63, 163, 45, 246, 83, 119, 12, 19, 84, 121, 112, 43, 85, 87, 102, 91, 109, 109, 84, 83, 107, 116, 13, 93, 85, 143, 84, 164, 84, 166, 71, 13, 23, 221, 14, 180, 61, 77, 13, 188, 137, 152, 38, 71, 85, 237, 76, 47, 84, 23, 116, 134, 85, 169, 85, 0, 0, 215, 24, 58, 64, 82, 69, 53, 68, 179, 102, 180, 16, 55, 86, 205, 102, 138, 50, 164, 102, 173, 102, 77, 86, 79, 86, 241, 120, 241, 86, 135, 151, 254, 83, 0, 87, 239, 86, 237, 86, 102, 139, 35, 54, 79, 18, 70, 87, 165, 65, 110, 108, 139, 112, 66, 87, 177, 54, 126, 108, 230, 87, 22, 20, 3, 88, 84, 20, 99, 67, 38, 88, 245, 75, 92, 88, 170, 88, 97, 53, 224, 88, 220, 88, 60, 18, 251, 88, 255, 91, 67, 87, 80, 161, 120, 66, 211, 147, 161, 53, 31, 89, 166, 104, 195, 54, 89, 110, 62, 22, 36, 90, 83, 85, 146, 22, 5, 133, 201, 89, 78, 13, 129, 108, 42, 109, 220, 23, 217, 89, 251, 23, 178, 23, 166, 109, 113, 109, 40, 24, 213, 22, 249, 89, 69, 110, 171, 90, 99, 90, 230, 54, 169, 73, 0, 0, 8, 55, 150, 90, 101, 116, 211, 90, 161, 111, 84, 37, 133, 61, 17, 25, 50, 55, 184, 22, 131, 94, 208, 82, 118, 91, 136, 101, 124, 91, 14, 122, 4, 64, 93, 72, 4, 2, 213, 91, 96, 97, 52, 26, 204, 89, 165, 5, 243, 91, 157, 91, 16, 77, 5, 92, 68, 27, 19, 92, 206, 115, 20, 92, 165, 28, 40, 107, 73, 92, 221, 72, 133, 92, 233, 92, 239, 92, 139, 93, 249, 29, 55, 30, 16, 93, 24, 93, 70, 93, 164, 30, 186, 92, 215, 93, 252, 130, 45, 56, 1, 73, 73, 32, 115, 33, 135, 130, 54, 56, 194, 59, 46, 94, 138, 106, 0, 0, 122, 94, 188, 68, 211, 12, 166, 83, 183, 78, 0, 0, 168, 83, 113, 23, 9, 94, 244, 94, 130, 132, 249, 94, 251, 94, 160, 56, 252, 94, 62, 104, 27, 148, 13, 95, 193, 1, 148, 248, 222, 58, 174, 72, 58, 19, 58, 95, 136, 104, 208, 35, 0, 0, 113, 36, 99, 95, 189, 151, 110, 110, 114, 95, 64, 147, 54, 138, 167, 95, 182, 93, 95, 61, 80, 82, 106, 31, 248, 112, 104, 38, 214, 145, 158, 2, 41, 138, 49, 96, 133, 102, 119, 24, 99, 57, 199, 61, 57, 54, 144, 87, 180, 39, 113, 121, 64, 62, 158, 96, 0, 0, 179, 96, 130, 73, 143, 73, 83, 122, 164, 116, 225, 80, 160, 90, 100, 97, 36, 132, 66, 97, 166, 248, 210, 110, 129, 97, 244, 81, 86, 6, 135, 97, 170, 91, 183, 63, 95, 40, 211, 97, 157, 139, 93, 153, 208, 97, 50, 57, 128, 41, 193, 40, 35, 96, 92, 97, 30, 101, 139, 99, 24, 1, 197, 98, 112, 23, 213, 98, 13, 46, 108, 99, 223, 73, 23, 58, 56, 100, 248, 99, 142, 19, 252, 23, 0, 0, 138, 111, 54, 46, 20, 152, 140, 64, 29, 87, 225, 100, 229, 100, 123, 148, 102, 58, 58, 100, 87, 58, 77, 101, 22, 111, 40, 74, 35, 74, 133, 101, 109, 101, 95, 101, 126, 48, 181, 101, 64, 73, 55, 75, 209, 101, 216, 64, 41, 24, 224, 101, 227, 101, 223, 95, 0, 52, 24, 102, 247, 49, 248, 49, 68, 102, 164, 49, 165, 49, 75, 102, 117, 14, 103, 102, 230, 81, 115, 102, 0, 0, 61, 30, 49, 50, 244, 133, 200, 49, 19, 83, 197, 119, 247, 40, 164, 153, 2, 103, 156, 67, 33, 74, 43, 59, 250, 105, 194, 55, 0, 0, 103, 103, 98, 103, 205, 65, 237, 144, 215, 103, 233, 68, 34, 104, 80, 110, 60, 146, 1, 104, 230, 51, 160, 109, 93, 104, 111, 52, 225, 105, 11, 106, 223, 138, 115, 105, 195, 104, 205, 53, 1, 105, 0, 105, 50, 61, 1, 58, 60, 54, 128, 59, 172, 103, 97, 105, 74, 138, 252, 66, 54, 105, 152, 105, 161, 59, 201, 3, 99, 131, 144, 80, 249, 105, 89, 54, 42, 33, 69, 106, 3, 55, 157, 106, 243, 59, 177, 103, 200, 106, 156, 145, 13, 60, 29, 107, 35, 9, 222, 96, 53, 107, 116, 107, 205, 39, 181, 110, 219, 58, 181, 3, 88, 25, 64, 55, 33, 84, 90, 59, 225, 107, 252, 62, 220, 107, 55, 108, 139, 36, 241, 72, 81, 107, 90, 108, 38, 130, 121, 108, 188, 61, 197, 68, 189, 61, 164, 65, 12, 73, 0, 73, 201, 60, 229, 54, 235, 60, 50, 13, 131, 155, 249, 49, 145, 36, 143, 127, 55, 104, 37, 109, 161, 109, 235, 109, 150, 109, 92, 109, 124, 110, 4, 111, 127, 73, 133, 64, 114, 110, 51, 133, 116, 111, 199, 81, 0, 0, 0, 0, 46, 132, 33, 139, 0, 0, 47, 62, 83, 116, 130, 63, 204, 121, 79, 110, 145, 90, 75, 48, 248, 111, 13, 55, 157, 111, 48, 62, 250, 110, 151, 20, 61, 64, 85, 69, 240, 147, 68, 111, 92, 111, 78, 61, 116, 111, 112, 145, 59, 61, 159, 111, 68, 65, 211, 111, 145, 64, 85, 65, 57, 64, 240, 63, 180, 63, 63, 65, 223, 81, 86, 65, 87, 65, 64, 65, 221, 97, 75, 112, 126, 112, 167, 112, 129, 112, 204, 112, 213, 112, 214, 112, 223, 112, 4, 65, 232, 61, 180, 113, 150, 113, 119, 66, 43, 113, 69, 113, 136, 90, 74, 113, 0, 0, 156, 92, 101, 67, 79, 113, 98, 147, 193, 66, 44, 113, 90, 68, 39, 74, 34, 74, 186, 113, 232, 139, 189, 112, 14, 114, 66, 148, 21, 114, 17, 89, 67, 148, 36, 114, 65, 147, 5, 86, 46, 114, 64, 114, 116, 73, 189, 104, 85, 114, 87, 114, 85, 62, 68, 48, 13, 104, 61, 111, 130, 114, 0, 0, 43, 115, 35, 72, 43, 136, 237, 72, 4, 136, 40, 115, 46, 115, 207, 115, 170, 115, 58, 12, 46, 106, 201, 115, 73, 116, 226, 65, 231, 22, 36, 74, 35, 102, 197, 54, 183, 73, 141, 73, 251, 73, 247, 115, 21, 116, 3, 105, 38, 74, 57, 116, 195, 5, 215, 62, 0, 0, 173, 40, 96, 116, 178, 142, 71, 116, 228, 115, 118, 116, 185, 131, 108, 116, 48, 55, 116, 116, 241, 147, 44, 106, 130, 116, 83, 73, 140, 74, 95, 65, 121, 74, 143, 139, 70, 91, 3, 140, 158, 24, 200, 116, 136, 25, 14, 117, 0, 0, 30, 117, 217, 142, 75, 26, 215, 91, 172, 142, 133, 147, 77, 117, 74, 117, 103, 117, 110, 117, 130, 79, 4, 63, 19, 77, 142, 117, 93, 116, 158, 117, 180, 117, 2, 118, 44, 118, 81, 118, 79, 118, 111, 118, 118, 118, 245, 99, 144, 118, 239, 129, 248, 55, 17, 105, 14, 105, 161, 118, 165, 118, 183, 118, 204, 118, 159, 111, 98, 132, 157, 80, 125, 81, 28, 30, 30, 119, 38, 119, 64, 119, 175, 100, 32, 82, 88, 119, 172, 50, 175, 119, 100, 137, 104, 137, 193, 22, 244, 119, 0, 0, 118, 19, 18, 74, 202, 104, 175, 120, 199, 120, 211, 120, 165, 150, 46, 121, 224, 85, 215, 120, 52, 121, 177, 120, 12, 118, 184, 143, 132, 136, 43, 139, 131, 96, 28, 38, 134, 121, 0, 137, 2, 105, 128, 121, 87, 88, 157, 121, 57, 123, 60, 121, 169, 121, 42, 110, 38, 113, 168, 62, 198, 121, 13, 145, 212, 121, 32, 5, 95, 68, 15, 82, 130, 184, 248, 0, 0, 64, 32, 169, 78, 4, 0, 0, 0, 0, 52, 11, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 64, 0, 0, 0, 0, 0, 0, 0, 0, 4, 88, 0, 60, 0, 0, 0, 0, 0, 128, 92, 173, 220, 243, 187, 201, 67, 238, 237, 164, 15, 38, 193, 155, 118, 242, 239, 222, 251, 250, 247, 15, 50, 68, 175, 254, 239, 253, 254, 17, 96, 176, 0, 0, 33, 25, 129, 32, 16, 136, 168, 96, 33, 105, 36, 0, 68, 137, 196, 0, 0, 3, 64, 53, 0, 67, 132, 49, 81, 147, 104, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 1, 128, 172, 100, 130, 64, 140, 161, 144, 4, 80, 96, 212, 0, 210, 42, 24, 157, 104, 53, 151, 79, 216, 248, 32, 196, 130, 28, 40, 130, 117, 148, 2, 56, 64, 160, 161, 197, 16, 113, 77, 196, 13, 152, 185, 94, 91, 1, 67, 159, 153, 3, 120, 32, 226, 31, 8, 137, 1, 201, 64, 7, 3, 13, 154, 144, 82, 209, 79, 124, 3, 2, 33, 32, 192, 110, 19, 131, 181, 219, 245, 229, 119, 144, 79, 23, 154, 54, 23, 12, 0, 110, 186, 9, 47, 96, 84, 0, 30, 120, 104, 34, 112, 86, 158, 37, 243, 142, 183, 23, 11, 239, 230, 119, 23, 91, 27, 193, 16, 152, 141, 18, 24, 182, 207, 1, 49, 114, 26, 91, 44, 182, 192, 32, 226, 195, 92, 130, 27, 224, 218, 206, 133, 214, 64, 169, 84, 11, 208, 15, 72, 68, 64, 16, 9, 212, 64, 174, 59, 100, 30, 68, 43, 23, 8, 134, 130, 54, 24, 160, 137, 231, 156, 91, 8, 132, 3, 2, 218, 144, 236, 219, 135, 133, 191, 162, 173, 157, 142, 157, 152, 32, 37, 70, 0, 70, 159, 127, 227, 213, 201, 132, 244, 214, 77, 6, 227, 182, 24, 18, 9, 0, 0, 0, 4, 0, 0, 32, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 142, 120, 110, 95, 63, 126, 221, 61, 247, 252, 155, 252, 174, 210, 255, 143, 107, 241, 231, 191, 186, 174, 110, 23, 239, 220, 167, 62, 182, 181, 119, 201, 146, 215, 165, 182, 74, 110, 155, 185, 129, 77, 103, 254, 84, 241, 155, 98, 254, 111, 82, 215, 54, 254, 191, 41, 69, 129, 249, 189, 101, 166, 66, 57, 0, 0, 66, 96, 143, 0, 148, 64, 64, 210, 175, 215, 209, 219, 0, 160, 152, 178, 123, 6, 82, 32, 152, 22, 200, 61, 9, 0, 0, 1, 0, 0, 0, 1, 10, 178, 8, 128, 0, 0, 0, 4, 136, 32, 20, 16, 76, 0, 0, 4, 0, 161, 68, 16, 0, 65, 1, 0, 8, 64, 240, 223, 79, 54, 88, 241, 245, 181, 128, 245, 103, 128, 64, 0, 80, 78, 65, 200, 132, 0, 90, 96, 216, 1, 43, 1, 80, 161, 22, 196, 64, 242, 110, 17, 172, 32, 57, 196, 192, 8, 7, 12, 9, 152, 150, 196, 155, 16, 28, 152, 108, 134, 42, 166, 1, 70, 17, 109, 229, 203, 196, 192, 146, 16, 33, 22, 18, 157, 114, 244, 105, 14, 23, 42, 162, 129, 244, 123, 0, 8, 164, 11, 144, 16, 44, 204, 57, 74, 1, 240, 22, 11, 10, 64, 12, 29, 234, 12, 68, 14, 69, 2, 0, 8, 4, 4, 8, 4, 4, 8, 2, 4, 0, 0, 0, 0, 0, 0, 0, 195, 138, 204, 132, 195, 138, 204, 140, 195, 170, 204, 132, 195, 170, 204, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 12, 255, 1, 48, 2, 48, 14, 255, 39, 32, 27, 255, 26, 255, 31, 255, 1, 255, 48, 254, 38, 32, 37, 32, 80, 254, 81, 254, 82, 254, 183, 0, 84, 254, 85, 254, 86, 254, 87, 254, 92, 255, 19, 32, 49, 254, 20, 32, 51, 254, 116, 37, 52, 254, 79, 254, 8, 255, 9, 255, 53, 254, 54, 254, 91, 255, 93, 255, 55, 254, 56, 254, 20, 48, 21, 48, 57, 254, 58, 254, 16, 48, 17, 48, 59, 254, 60, 254, 10, 48, 11, 48, 61, 254, 62, 254, 8, 48, 9, 48, 63, 254, 64, 254, 12, 48, 13, 48, 65, 254, 66, 254, 14, 48, 15, 48, 67, 254, 68, 254, 89, 254, 90, 254, 91, 254, 92, 254, 93, 254, 94, 254, 24, 32, 25, 32, 28, 32, 29, 32, 29, 48, 30, 48, 53, 32, 50, 32, 3, 255, 6, 255, 10, 255, 59, 32, 167, 0, 3, 48, 203, 37, 207, 37, 179, 37, 178, 37, 206, 37, 6, 38, 5, 38, 199, 37, 198, 37, 161, 37, 160, 37, 189, 37, 188, 37, 163, 50, 5, 33, 175, 0, 227, 255, 63, 255, 205, 2, 73, 254, 74, 254, 77, 254, 78, 254, 75, 254, 76, 254, 95, 254, 96, 254, 97, 254, 11, 255, 13, 255, 215, 0, 247, 0, 177, 0, 26, 34, 28, 255, 30, 255, 29, 255, 102, 34, 103, 34, 96, 34, 30, 34, 82, 34, 97, 34, 98, 254, 99, 254, 100, 254, 101, 254, 102, 254, 94, 255, 41, 34, 42, 34, 165, 34, 32, 34, 31, 34, 191, 34, 210, 51, 209, 51, 43, 34, 46, 34, 53, 34, 52, 34, 64, 38, 66, 38, 149, 34, 153, 34, 145, 33, 147, 33, 144, 33, 146, 33, 150, 33, 151, 33, 153, 33, 152, 33, 37, 34, 35, 34, 15, 255, 60, 255, 21, 34, 104, 254, 4, 255, 229, 255, 18, 48, 224, 255, 225, 255, 5, 255, 32, 255, 3, 33, 9, 33, 105, 254, 106, 254, 107, 254, 213, 51, 156, 51, 157, 51, 158, 51, 206, 51, 161, 51, 142, 51, 143, 51, 196, 51, 176, 0, 89, 81, 91, 81, 94, 81, 93, 81, 97, 81, 99, 81, 231, 85, 233, 116, 206, 124, 129, 37, 130, 37, 131, 37, 132, 37, 133, 37, 134, 37, 135, 37, 136, 37, 143, 37, 142, 37, 141, 37, 140, 37, 139, 37, 138, 37, 137, 37, 60, 37, 52, 37, 44, 37, 36, 37, 28, 37, 148, 37, 0, 37, 2, 37, 149, 37, 12, 37, 16, 37, 20, 37, 24, 37, 109, 37, 110, 37, 112, 37, 111, 37, 80, 37, 94, 37, 106, 37, 97, 37, 226, 37, 227, 37, 229, 37, 228, 37, 113, 37, 114, 37, 115, 37, 16, 255, 17, 255, 18, 255, 19, 255, 20, 255, 21, 255, 22, 255, 23, 255], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 271588);
	        allocate([24, 255, 25, 255, 96, 33, 97, 33, 98, 33, 99, 33, 100, 33, 101, 33, 102, 33, 103, 33, 104, 33, 105, 33, 33, 48, 34, 48, 35, 48, 36, 48, 37, 48, 38, 48, 39, 48, 40, 48, 41, 48, 65, 83, 68, 83, 69, 83, 33, 255, 34, 255, 35, 255, 36, 255, 37, 255, 38, 255, 39, 255, 40, 255, 41, 255, 42, 255, 43, 255, 44, 255, 45, 255, 46, 255, 47, 255, 48, 255, 49, 255, 50, 255, 51, 255, 52, 255, 53, 255, 54, 255, 55, 255, 56, 255, 57, 255, 58, 255, 65, 255, 66, 255, 67, 255, 68, 255, 69, 255, 70, 255, 71, 255, 72, 255, 73, 255, 74, 255, 75, 255, 76, 255, 77, 255, 78, 255, 79, 255, 80, 255, 81, 255, 82, 255, 83, 255, 84, 255, 85, 255, 86, 255, 87, 255, 88, 255, 89, 255, 90, 255, 145, 3, 146, 3, 147, 3, 148, 3, 149, 3, 150, 3, 151, 3, 152, 3, 153, 3, 154, 3, 155, 3, 156, 3, 157, 3, 158, 3, 159, 3, 160, 3, 161, 3, 163, 3, 164, 3, 165, 3, 166, 3, 167, 3, 168, 3, 169, 3, 177, 3, 178, 3, 179, 3, 180, 3, 181, 3, 182, 3, 183, 3, 184, 3, 185, 3, 186, 3, 187, 3, 188, 3, 189, 3, 190, 3, 191, 3, 192, 3, 193, 3, 195, 3, 196, 3, 197, 3, 198, 3, 199, 3, 200, 3, 201, 3, 5, 49, 6, 49, 7, 49, 8, 49, 9, 49, 10, 49, 11, 49, 12, 49, 13, 49, 14, 49, 15, 49, 16, 49, 17, 49, 18, 49, 19, 49, 20, 49, 21, 49, 22, 49, 23, 49, 24, 49, 25, 49, 26, 49, 27, 49, 28, 49, 29, 49, 30, 49, 31, 49, 32, 49, 33, 49, 34, 49, 35, 49, 36, 49, 37, 49, 38, 49, 39, 49, 40, 49, 41, 49, 217, 2, 201, 2, 202, 2, 199, 2, 203, 2, 0, 36, 1, 36, 2, 36, 3, 36, 4, 36, 5, 36, 6, 36, 7, 36, 8, 36, 9, 36, 10, 36, 11, 36, 12, 36, 13, 36, 14, 36, 15, 36, 16, 36, 17, 36, 18, 36, 19, 36, 20, 36, 21, 36, 22, 36, 23, 36, 24, 36, 25, 36, 26, 36, 27, 36, 28, 36, 29, 36, 30, 36, 31, 36, 33, 36, 172, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 89, 78, 1, 78, 3, 78, 67, 78, 93, 78, 134, 78, 140, 78, 186, 78, 63, 81, 101, 81, 107, 81, 224, 81, 0, 82, 1, 82, 155, 82, 21, 83, 65, 83, 92, 83, 200, 83, 9, 78, 11, 78, 8, 78, 10, 78, 43, 78, 56, 78, 225, 81, 69, 78, 72, 78, 95, 78, 94, 78, 142, 78, 161, 78, 64, 81, 3, 82, 250, 82, 67, 83, 201, 83, 227, 83, 31, 87, 235, 88, 21, 89, 39, 89, 115, 89, 80, 91, 81, 91, 83, 91, 248, 91, 15, 92, 34, 92, 56, 92, 113, 92, 221, 93, 229, 93, 241, 93, 242, 93, 243, 93, 254, 93, 114, 94, 254, 94, 11, 95, 19, 95, 77, 98, 17, 78, 16, 78, 13, 78, 45, 78, 48, 78, 57, 78, 75, 78, 57, 92, 136, 78, 145, 78, 149, 78, 146, 78, 148, 78, 162, 78, 193, 78, 192, 78, 195, 78, 198, 78, 199, 78, 205, 78, 202, 78, 203, 78, 196, 78, 67, 81, 65, 81, 103, 81, 109, 81, 110, 81, 108, 81, 151, 81, 246, 81, 6, 82, 7, 82, 8, 82, 251, 82, 254, 82, 255, 82, 22, 83, 57, 83, 72, 83, 71, 83, 69, 83, 94, 83, 132, 83, 203, 83, 202, 83, 205, 83, 236, 88, 41, 89, 43, 89, 42, 89, 45, 89, 84, 91, 17, 92, 36, 92, 58, 92, 111, 92, 244, 93, 123, 94, 255, 94, 20, 95, 21, 95, 195, 95, 8, 98, 54, 98, 75, 98, 78, 98, 47, 101, 135, 101, 151, 101, 164, 101, 185, 101, 229, 101, 240, 102, 8, 103, 40, 103, 32, 107, 98, 107, 121, 107, 203, 107, 212, 107, 219, 107, 15, 108, 52, 108, 107, 112, 42, 114, 54, 114, 59, 114, 71, 114, 89, 114, 91, 114, 172, 114, 139, 115, 25, 78, 22, 78, 21, 78, 20, 78, 24, 78, 59, 78, 77, 78, 79, 78, 78, 78, 229, 78, 216, 78, 212, 78, 213, 78, 214, 78, 215, 78, 227, 78, 228, 78, 217, 78, 222, 78, 69, 81, 68, 81, 137, 81, 138, 81, 172, 81, 249, 81, 250, 81, 248, 81, 10, 82, 160, 82, 159, 82, 5, 83, 6, 83, 23, 83, 29, 83, 223, 78, 74, 83, 73, 83, 97, 83, 96, 83, 111, 83, 110, 83, 187, 83, 239, 83, 228, 83, 243, 83, 236, 83, 238, 83, 233, 83, 232, 83, 252, 83, 248, 83, 245, 83, 235, 83, 230, 83, 234, 83, 242, 83, 241, 83, 240, 83, 229, 83, 237, 83, 251, 83, 219, 86, 218, 86, 22, 89, 46, 89, 49, 89, 116, 89, 118, 89, 85, 91, 131, 91, 60, 92, 232, 93, 231, 93, 230, 93, 2, 94, 3, 94, 115, 94, 124, 94, 1, 95, 24, 95, 23, 95, 197, 95, 10, 98, 83, 98, 84, 98, 82, 98, 81, 98, 165, 101, 230, 101, 46, 103, 44, 103, 42, 103, 43, 103, 45, 103, 99, 107, 205, 107, 17, 108, 16, 108, 56, 108, 65, 108, 64, 108, 62, 108, 175, 114, 132, 115, 137, 115, 220, 116, 230, 116, 24, 117, 31, 117, 40, 117, 41, 117, 48, 117, 49, 117, 50, 117, 51, 117, 139, 117, 125, 118, 174, 118, 191, 118, 238, 118, 219, 119, 226, 119, 243, 119, 58, 121, 190, 121, 116, 122, 203, 122, 30, 78, 31, 78, 82, 78, 83, 78, 105, 78, 153, 78, 164, 78, 166, 78, 165, 78, 255, 78, 9, 79, 25, 79, 10, 79, 21, 79, 13, 79, 16, 79, 17, 79, 15, 79, 242, 78, 246, 78, 251, 78, 240, 78, 243, 78, 253, 78, 1, 79, 11, 79, 73, 81, 71, 81, 70, 81, 72, 81, 104, 81, 113, 81, 141, 81, 176, 81, 23, 82, 17, 82, 18, 82, 14, 82, 22, 82, 163, 82, 8, 83, 33, 83, 32, 83, 112, 83, 113, 83, 9, 84, 15, 84, 12, 84, 10, 84, 16, 84, 1, 84, 11, 84, 4, 84, 17, 84, 13, 84, 8, 84, 3, 84, 14, 84, 6, 84, 18, 84, 224, 86, 222, 86, 221, 86, 51, 87, 48, 87, 40, 87, 45, 87, 44, 87, 47, 87, 41, 87, 25, 89, 26, 89, 55, 89, 56, 89, 132, 89, 120, 89, 131, 89, 125, 89, 121, 89, 130, 89, 129, 89, 87, 91, 88, 91, 135, 91, 136, 91, 133, 91, 137, 91, 250, 91, 22, 92, 121, 92, 222, 93, 6, 94, 118, 94, 116, 94, 15, 95, 27, 95, 217, 95, 214, 95, 14, 98, 12, 98, 13, 98, 16, 98, 99, 98, 91, 98, 88, 98, 54, 101, 233, 101, 232, 101, 236, 101, 237, 101, 242, 102, 243, 102, 9, 103, 61, 103, 52, 103, 49, 103, 53, 103, 33, 107, 100, 107, 123, 107, 22, 108, 93, 108, 87, 108, 89, 108, 95, 108, 96, 108, 80, 108, 85, 108, 97, 108, 91, 108, 77, 108, 78, 108, 112, 112, 95, 114, 93, 114, 126, 118, 249, 122, 115, 124, 248, 124, 54, 127, 138, 127, 189, 127, 1, 128, 3, 128, 12, 128, 18, 128, 51, 128, 127, 128, 137, 128, 139, 128, 140, 128, 227, 129, 234, 129, 243, 129, 252, 129, 12, 130, 27, 130, 31, 130, 110, 130, 114, 130, 126, 130, 107, 134, 64, 136, 76, 136, 99, 136, 127, 137, 33, 150, 50, 78, 168, 78, 77, 79, 79, 79, 71, 79, 87, 79, 94, 79, 52, 79, 91, 79, 85, 79, 48, 79, 80, 79, 81, 79, 61, 79, 58, 79, 56, 79, 67, 79, 84, 79, 60, 79, 70, 79, 99, 79, 92, 79, 96, 79, 47, 79, 78, 79, 54, 79, 89, 79, 93, 79, 72, 79, 90, 79, 76, 81, 75, 81, 77, 81, 117, 81, 182, 81, 183, 81, 37, 82, 36, 82, 41, 82, 42, 82, 40, 82, 171, 82, 169, 82, 170, 82, 172, 82, 35, 83, 115, 83, 117, 83, 29, 84, 45, 84, 30, 84, 62, 84, 38, 84, 78, 84, 39, 84, 70, 84, 67, 84, 51, 84, 72, 84, 66, 84, 27, 84, 41, 84, 74, 84, 57, 84, 59, 84, 56, 84, 46, 84, 53, 84, 54, 84, 32, 84, 60, 84, 64, 84, 49, 84, 43, 84, 31, 84, 44, 84, 234, 86, 240, 86, 228, 86, 235, 86, 74, 87, 81, 87, 64, 87, 77, 87, 71, 87, 78, 87, 62, 87, 80, 87, 79, 87, 59, 87, 239, 88, 62, 89, 157, 89, 146, 89, 168, 89, 158, 89, 163, 89, 153, 89, 150, 89, 141, 89, 164, 89, 147, 89, 138, 89, 165, 89, 93, 91, 92, 91, 90, 91, 91, 91, 140, 91, 139, 91, 143, 91, 44, 92, 64, 92, 65, 92, 63, 92, 62, 92, 144, 92, 145, 92, 148, 92, 140, 92, 235, 93, 12, 94, 143, 94, 135, 94, 138, 94, 247, 94, 4, 95, 31, 95, 100, 95, 98, 95, 119, 95, 121, 95, 216, 95, 204, 95, 215, 95, 205, 95, 241, 95, 235, 95, 248, 95, 234, 95, 18, 98, 17, 98, 132, 98, 151, 98, 150, 98, 128, 98, 118, 98, 137, 98, 109, 98, 138, 98, 124, 98, 126, 98, 121, 98, 115, 98, 146, 98, 111, 98, 152, 98, 110, 98, 149, 98, 147, 98, 145, 98, 134, 98, 57, 101, 59, 101, 56, 101, 241, 101, 244, 102, 95, 103, 78, 103, 79, 103, 80, 103, 81, 103, 92, 103, 86, 103, 94, 103, 73, 103, 70, 103, 96, 103, 83, 103, 87, 103, 101, 107, 207, 107, 66, 108, 94, 108, 153, 108, 129, 108, 136, 108, 137, 108, 133, 108, 155, 108, 106, 108, 122, 108, 144, 108, 112, 108, 140, 108, 104, 108, 150, 108, 146, 108, 125, 108, 131, 108, 114, 108, 126, 108, 116, 108, 134, 108, 118, 108, 141, 108, 148, 108, 152, 108, 130, 108, 118, 112, 124, 112, 125, 112, 120, 112, 98, 114, 97, 114, 96, 114, 196, 114, 194, 114, 150, 115, 44, 117, 43, 117, 55, 117, 56, 117, 130, 118, 239, 118, 227, 119, 193, 121, 192, 121, 191, 121, 118, 122, 251, 124, 85, 127, 150, 128, 147, 128, 157, 128, 152, 128, 155, 128, 154, 128, 178, 128, 111, 130, 146, 130, 139, 130, 141, 130, 139, 137, 210, 137, 0, 138, 55, 140, 70, 140, 85, 140, 157, 140, 100, 141, 112, 141, 179, 141, 171, 142, 202, 142, 155, 143, 176, 143, 194, 143, 198, 143, 197, 143, 196, 143, 225, 93, 145, 144, 162, 144, 170, 144, 166, 144, 163, 144, 73, 145, 198, 145, 204, 145, 50, 150, 46, 150, 49, 150, 42, 150, 44, 150, 38, 78, 86, 78, 115, 78, 139, 78, 155, 78, 158, 78, 171, 78, 172, 78, 111, 79, 157, 79, 141, 79, 115, 79, 127, 79, 108, 79, 155, 79, 139, 79, 134, 79, 131, 79, 112, 79, 117, 79, 136, 79, 105, 79, 123, 79, 150, 79, 126, 79, 143, 79, 145, 79, 122, 79, 84, 81, 82, 81, 85, 81, 105, 81, 119, 81, 118, 81, 120, 81, 189, 81, 253, 81, 59, 82, 56, 82, 55, 82, 58, 82, 48, 82, 46, 82, 54, 82, 65, 82, 190, 82, 187, 82, 82, 83, 84, 83, 83, 83, 81, 83, 102, 83, 119, 83, 120, 83, 121, 83, 214, 83, 212, 83, 215, 83, 115, 84, 117, 84, 150, 84, 120, 84, 149, 84, 128, 84, 123, 84, 119, 84, 132, 84, 146, 84, 134, 84, 124, 84, 144, 84, 113, 84, 118, 84, 140, 84, 154, 84, 98, 84, 104, 84, 139, 84, 125, 84, 142, 84, 250, 86, 131, 87, 119, 87, 106, 87, 105, 87, 97, 87, 102, 87, 100, 87, 124, 87, 28, 89, 73, 89, 71, 89, 72, 89, 68, 89, 84, 89, 190, 89, 187, 89, 212, 89, 185, 89, 174, 89, 209, 89, 198, 89, 208, 89, 205, 89, 203, 89, 211, 89, 202, 89, 175, 89, 179, 89, 210, 89, 197, 89, 95, 91, 100, 91, 99, 91, 151, 91, 154, 91, 152, 91, 156, 91, 153, 91, 155, 91, 26, 92, 72, 92, 69, 92, 70, 92, 183, 92, 161, 92, 184, 92, 169, 92, 171, 92, 177, 92, 179, 92, 24, 94, 26, 94, 22, 94, 21, 94, 27, 94, 17, 94, 120, 94, 154, 94, 151, 94, 156, 94, 149, 94, 150, 94, 246, 94, 38, 95, 39, 95, 41, 95, 128, 95, 129, 95, 127, 95, 124, 95, 221, 95, 224, 95, 253, 95, 245, 95, 255, 95, 15, 96, 20, 96, 47, 96, 53, 96, 22, 96, 42, 96, 21, 96, 33, 96, 39, 96, 41, 96, 43, 96, 27, 96, 22, 98, 21, 98, 63, 98, 62, 98, 64, 98, 127, 98, 201, 98, 204, 98, 196, 98, 191, 98, 194, 98, 185, 98, 210, 98, 219, 98, 171, 98, 211, 98, 212, 98, 203, 98, 200, 98, 168, 98, 189, 98, 188, 98, 208, 98, 217, 98, 199, 98, 205, 98, 181, 98, 218, 98, 177, 98, 216, 98, 214, 98, 215, 98, 198, 98, 172, 98, 206, 98, 62, 101, 167, 101, 188, 101, 250, 101, 20, 102, 19, 102, 12, 102, 6, 102, 2, 102, 14, 102, 0, 102, 15, 102, 21, 102, 10, 102, 7, 102, 13, 103, 11, 103, 109, 103, 139, 103, 149, 103, 113, 103, 156, 103, 115, 103, 119, 103, 135, 103, 157, 103, 151, 103, 111, 103, 112, 103, 127, 103, 137, 103, 126, 103, 144, 103, 117, 103, 154, 103, 147, 103, 124, 103, 106, 103, 114, 103, 35, 107, 102, 107, 103, 107, 127, 107, 19, 108, 27, 108, 227, 108, 232, 108, 243, 108, 177, 108, 204, 108, 229, 108, 179, 108, 189, 108, 190, 108, 188, 108, 226, 108, 171, 108, 213, 108, 211, 108, 184, 108, 196, 108, 185, 108, 193, 108, 174, 108, 215, 108, 197, 108, 241, 108, 191, 108, 187, 108, 225, 108, 219, 108, 202, 108, 172, 108, 239, 108, 220, 108, 214, 108, 224, 108, 149, 112, 142, 112, 146, 112, 138, 112, 153, 112, 44, 114, 45, 114, 56, 114, 72, 114, 103, 114, 105, 114, 192, 114, 206, 114, 217, 114, 215, 114, 208, 114, 169, 115, 168, 115, 159, 115, 171, 115, 165, 115, 61, 117, 157, 117, 153, 117, 154, 117, 132, 118, 194, 118, 242, 118, 244, 118, 229, 119, 253, 119, 62, 121, 64, 121, 65, 121, 201, 121, 200, 121, 122, 122, 121, 122, 250, 122, 254, 124, 84, 127, 140, 127, 139, 127, 5, 128, 186, 128, 165, 128, 162, 128, 177, 128, 161, 128, 171, 128, 169, 128, 180, 128, 170, 128, 175, 128, 229, 129, 254, 129, 13, 130, 179, 130, 157, 130, 153, 130, 173, 130, 189, 130, 159, 130, 185, 130, 177, 130, 172, 130, 165, 130, 175, 130, 184, 130, 163, 130, 176, 130, 190, 130, 183, 130, 78, 134, 113, 134, 29, 82, 104, 136, 203, 142, 206, 143, 212, 143, 209, 143, 181, 144, 184, 144, 177, 144, 182, 144, 199, 145, 209, 145, 119, 149, 128, 149, 28, 150, 64, 150, 63, 150, 59, 150, 68, 150, 66, 150, 185, 150, 232, 150, 82, 151, 94, 151, 159, 78, 173, 78, 174, 78, 225, 79, 181, 79, 175, 79, 191, 79, 224, 79, 209, 79, 207, 79, 221, 79, 195, 79, 182, 79, 216, 79, 223, 79, 202, 79, 215, 79, 174, 79, 208, 79, 196, 79, 194, 79, 218, 79, 206, 79, 222, 79, 183, 79, 87, 81, 146, 81, 145, 81, 160, 81, 78, 82, 67, 82, 74, 82, 77, 82, 76, 82, 75, 82, 71, 82, 199, 82, 201, 82, 195, 82, 193, 82, 13, 83, 87, 83, 123, 83, 154, 83, 219, 83, 172, 84, 192, 84, 168, 84, 206, 84, 201, 84, 184, 84, 166, 84, 179, 84, 199, 84, 194, 84, 189, 84, 170, 84, 193, 84, 196, 84, 200, 84, 175, 84, 171, 84, 177, 84, 187, 84, 169, 84, 167, 84, 191, 84, 255, 86, 130, 87, 139, 87, 160, 87, 163, 87, 162, 87, 206, 87, 174, 87, 147, 87, 85, 89, 81, 89, 79, 89, 78, 89, 80, 89, 220, 89, 216, 89, 255, 89, 227, 89, 232, 89, 3, 90, 229, 89, 234, 89, 218, 89, 230, 89, 1, 90, 251, 89, 105, 91, 163, 91, 166, 91, 164, 91, 162, 91, 165, 91, 1, 92, 78, 92, 79, 92, 77, 92, 75, 92, 217, 92, 210, 92, 247, 93, 29, 94, 37, 94, 31, 94, 125, 94, 160, 94, 166, 94, 250, 94, 8, 95, 45, 95, 101, 95, 136, 95, 133, 95, 138, 95, 139, 95, 135, 95, 140, 95, 137, 95, 18, 96, 29, 96, 32, 96, 37, 96, 14, 96, 40, 96, 77, 96, 112, 96, 104, 96, 98, 96, 70, 96, 67, 96, 108, 96, 107, 96, 106, 96, 100, 96, 65, 98, 220, 98, 22, 99, 9, 99, 252, 98, 237, 98, 1, 99, 238, 98, 253, 98, 7, 99, 241, 98, 247, 98, 239, 98, 236, 98, 254, 98, 244, 98, 17, 99, 2, 99, 63, 101, 69, 101, 171, 101, 189, 101, 226, 101, 37, 102, 45, 102, 32, 102, 39, 102, 47, 102, 31, 102, 40, 102, 49, 102, 36, 102, 247, 102, 255, 103, 211, 103, 241, 103, 212, 103, 208, 103, 236, 103, 182, 103, 175, 103, 245, 103, 233, 103, 239, 103, 196, 103, 209, 103, 180, 103, 218, 103, 229, 103, 184, 103, 207, 103, 222, 103, 243, 103, 176, 103, 217, 103, 226, 103, 221, 103, 210, 103, 106, 107, 131, 107, 134, 107, 181, 107, 210, 107, 215, 107, 31, 108, 201, 108, 11, 109, 50, 109, 42, 109, 65, 109, 37, 109, 12, 109, 49, 109, 30, 109, 23, 109, 59, 109, 61, 109, 62, 109, 54, 109, 27, 109, 245, 108, 57, 109, 39, 109, 56, 109, 41, 109, 46, 109, 53, 109, 14, 109, 43, 109, 171, 112, 186, 112, 179, 112, 172, 112, 175, 112, 173, 112, 184, 112, 174, 112, 164, 112, 48, 114, 114, 114, 111, 114, 116, 114, 233, 114, 224, 114, 225, 114, 183, 115, 202, 115, 187, 115, 178, 115, 205, 115, 192, 115, 179, 115, 26, 117, 45, 117, 79, 117, 76, 117, 78, 117, 75, 117, 171, 117, 164, 117, 165, 117, 162, 117, 163, 117, 120, 118, 134, 118, 135, 118, 136, 118, 200, 118, 198, 118, 195, 118, 197, 118, 1, 119, 249, 118, 248, 118, 9, 119, 11, 119, 254, 118, 252, 118, 7, 119, 220, 119, 2, 120, 20, 120, 12, 120, 13, 120, 70, 121, 73, 121, 72, 121, 71, 121, 185, 121, 186, 121, 209, 121, 210, 121, 203, 121, 127, 122, 129, 122, 255, 122, 253, 122, 125, 124, 2, 125, 5, 125, 0, 125, 9, 125, 7, 125, 4, 125, 6, 125, 56, 127, 142, 127, 191, 127, 4, 128, 16, 128, 13, 128, 17, 128, 54, 128, 214, 128, 229, 128, 218, 128, 195, 128, 196, 128, 204, 128, 225, 128, 219, 128, 206, 128, 222, 128, 228, 128, 221, 128, 244, 129, 34, 130, 231, 130, 3, 131, 5, 131, 227, 130, 219, 130, 230, 130, 4, 131, 229, 130, 2, 131, 9, 131, 210, 130, 215, 130, 241, 130, 1, 131, 220, 130, 212, 130, 209, 130, 222, 130, 211, 130, 223, 130, 239, 130, 6, 131, 80, 134, 121, 134, 123, 134, 122, 134, 77, 136, 107, 136, 129, 137, 212, 137, 8, 138, 2, 138, 3, 138, 158, 140, 160, 140, 116, 141, 115, 141, 180, 141, 205, 142, 204, 142, 240, 143, 230, 143, 226, 143, 234, 143, 229, 143, 237, 143, 235, 143, 228, 143, 232, 143, 202, 144, 206, 144, 193, 144, 195, 144, 75, 145, 74, 145, 205, 145, 130, 149, 80, 150, 75, 150, 76, 150, 77, 150, 98, 151, 105, 151, 203, 151, 237, 151, 243, 151, 1, 152, 168, 152, 219, 152, 223, 152, 150, 153, 153, 153, 88, 78, 179, 78, 12, 80, 13, 80, 35, 80, 239, 79, 38, 80, 37, 80, 248, 79, 41, 80, 22, 80, 6, 80, 60, 80, 31, 80, 26, 80, 18, 80, 17, 80, 250, 79, 0, 80, 20, 80, 40, 80, 241, 79, 33, 80, 11, 80, 25, 80, 24, 80, 243, 79, 238, 79, 45, 80, 42, 80, 254, 79, 43, 80, 9, 80, 124, 81, 164, 81, 165, 81, 162, 81, 205, 81, 204, 81, 198, 81, 203, 81, 86, 82, 92, 82, 84, 82, 91, 82, 93, 82, 42, 83, 127, 83, 159, 83, 157, 83, 223, 83, 232, 84, 16, 85, 1, 85, 55, 85, 252, 84, 229, 84, 242, 84, 6, 85, 250, 84, 20, 85, 233, 84, 237, 84, 225, 84, 9, 85, 238, 84, 234, 84, 230, 84, 39, 85, 7, 85, 253, 84, 15, 85, 3, 87, 4, 87, 194, 87, 212, 87, 203, 87, 195, 87, 9, 88, 15, 89, 87, 89, 88, 89, 90, 89, 17, 90, 24, 90, 28, 90, 31, 90, 27, 90, 19, 90, 236, 89, 32, 90, 35, 90, 41, 90, 37, 90, 12, 90, 9, 90, 107, 91, 88, 92, 176, 91, 179, 91, 182, 91, 180, 91, 174, 91, 181, 91, 185, 91, 184, 91, 4, 92, 81, 92, 85, 92, 80, 92, 237, 92, 253, 92, 251, 92, 234, 92, 232, 92, 240, 92, 246, 92, 1, 93, 244, 92, 238, 93, 45, 94, 43, 94, 171, 94, 173, 94, 167, 94, 49, 95, 146, 95, 145, 95, 144, 95, 89, 96, 99, 96, 101, 96, 80, 96, 85, 96, 109, 96, 105, 96, 111, 96, 132, 96, 159, 96, 154, 96, 141, 96, 148, 96, 140, 96, 133, 96, 150, 96, 71, 98, 243, 98, 8, 99, 255, 98, 78, 99, 62, 99, 47, 99, 85, 99, 66, 99, 70, 99, 79, 99, 73, 99, 58, 99, 80, 99, 61, 99, 42, 99, 43, 99, 40, 99, 77, 99, 76, 99, 72, 101, 73, 101, 153, 101, 193, 101, 197, 101, 66, 102, 73, 102, 79, 102, 67, 102, 82, 102, 76, 102, 69, 102, 65, 102, 248, 102, 20, 103, 21, 103, 23, 103, 33, 104, 56, 104, 72, 104, 70, 104, 83, 104, 57, 104, 66, 104, 84, 104, 41, 104, 179, 104, 23, 104, 76, 104, 81, 104, 61, 104, 244, 103, 80, 104, 64, 104, 60, 104, 67, 104, 42, 104, 69, 104, 19, 104, 24, 104, 65, 104, 138, 107, 137, 107, 183, 107, 35, 108, 39, 108, 40, 108, 38, 108, 36, 108, 240, 108, 106, 109, 149, 109, 136, 109, 135, 109, 102, 109, 120, 109, 119, 109, 89, 109, 147, 109, 108, 109, 137, 109, 110, 109, 90, 109, 116, 109, 105, 109, 140, 109, 138, 109, 121, 109, 133, 109, 101, 109, 148, 109, 202, 112, 216, 112, 228, 112, 217, 112, 200, 112, 207, 112, 57, 114, 121, 114, 252, 114, 249, 114, 253, 114, 248, 114, 247, 114, 134, 115, 237, 115, 9, 116, 238, 115, 224, 115, 234, 115, 222, 115, 84, 117, 93, 117, 92, 117, 90, 117, 89, 117, 190, 117, 197, 117, 199, 117, 178, 117, 179, 117, 189, 117, 188, 117, 185, 117, 194, 117, 184, 117, 139, 118, 176, 118, 202, 118, 205, 118, 206, 118, 41, 119, 31, 119, 32, 119, 40, 119, 233, 119, 48, 120, 39, 120, 56, 120, 29, 120, 52, 120, 55, 120, 37, 120, 45, 120, 32, 120, 31, 120, 50, 120, 85, 121, 80, 121, 96, 121, 95, 121, 86, 121, 94, 121, 93, 121, 87, 121, 90, 121, 228, 121, 227, 121, 231, 121, 223, 121, 230, 121, 233, 121, 216, 121, 132, 122, 136, 122, 217, 122, 6, 123, 17, 123, 137, 124, 33, 125, 23, 125, 11, 125, 10, 125, 32, 125, 34, 125, 20, 125, 16, 125, 21, 125, 26, 125, 28, 125, 13, 125, 25, 125, 27, 125, 58, 127, 95, 127, 148, 127, 197, 127, 193, 127, 6, 128, 24, 128, 21, 128, 25, 128, 23, 128, 61, 128, 63, 128, 241, 128, 2, 129, 240, 128, 5, 129, 237, 128, 244, 128, 6, 129, 248, 128, 243, 128, 8, 129, 253, 128, 10, 129, 252, 128, 239, 128, 237, 129, 236, 129, 0, 130, 16, 130, 42, 130, 43, 130, 40, 130, 44, 130, 187, 130, 43, 131, 82, 131, 84, 131, 74, 131, 56, 131, 80, 131, 73, 131, 53, 131, 52, 131, 79, 131, 50, 131, 57, 131, 54, 131, 23, 131, 64, 131, 49, 131, 40, 131, 67, 131, 84, 134, 138, 134, 170, 134, 147, 134, 164, 134, 169, 134, 140, 134, 163, 134, 156, 134, 112, 136, 119, 136, 129, 136, 130, 136, 125, 136, 121, 136, 24, 138, 16, 138, 14, 138, 12, 138, 21, 138, 10, 138, 23, 138, 19, 138, 22, 138, 15, 138, 17, 138, 72, 140, 122, 140, 121, 140, 161, 140, 162, 140, 119, 141, 172, 142, 210, 142, 212, 142, 207, 142, 177, 143, 1, 144, 6, 144, 247, 143, 0, 144, 250, 143, 244, 143, 3, 144, 253, 143, 5, 144, 248, 143, 149, 144, 225, 144, 221, 144, 226, 144, 82, 145, 77, 145, 76, 145, 216, 145, 221, 145, 215, 145, 220, 145, 217, 145, 131, 149, 98, 150, 99, 150, 97, 150, 91, 150, 93, 150, 100, 150, 88, 150, 94, 150, 187, 150, 226, 152, 172, 153, 168, 154, 216, 154, 37, 155, 50, 155, 60, 155, 126, 78, 122, 80, 125, 80, 92, 80, 71, 80, 67, 80, 76, 80, 90, 80, 73, 80, 101, 80, 118, 80, 78, 80, 85, 80, 117, 80, 116, 80, 119, 80, 79, 80, 15, 80, 111, 80, 109, 80, 92, 81, 149, 81, 240, 81, 106, 82, 111, 82, 210, 82, 217, 82, 216, 82, 213, 82, 16, 83, 15, 83, 25, 83, 63, 83, 64, 83, 62, 83, 195, 83, 252, 102, 70, 85, 106, 85, 102, 85, 68, 85, 94, 85, 97, 85, 67, 85, 74, 85, 49, 85, 86, 85, 79, 85, 85, 85, 47, 85, 100, 85, 56, 85, 46, 85, 92, 85, 44, 85, 99, 85, 51, 85, 65, 85, 87, 85, 8, 87, 11, 87, 9, 87, 223, 87, 5, 88, 10, 88, 6, 88, 224, 87, 228, 87, 250, 87, 2, 88, 53, 88, 247, 87, 249, 87, 32, 89, 98, 89, 54, 90, 65, 90, 73, 90, 102, 90, 106, 90, 64, 90, 60, 90, 98, 90, 90, 90, 70, 90, 74, 90, 112, 91, 199, 91, 197, 91, 196, 91, 194, 91, 191, 91, 198, 91, 9, 92, 8, 92, 7, 92, 96, 92, 92, 92, 93, 92, 7, 93, 6, 93, 14, 93, 27, 93, 22, 93, 34, 93, 17, 93, 41, 93, 20, 93, 25, 93, 36, 93, 39, 93, 23, 93, 226, 93, 56, 94, 54, 94, 51, 94, 55, 94, 183, 94, 184, 94, 182, 94, 181, 94, 190, 94, 53, 95, 55, 95, 87, 95, 108, 95, 105, 95, 107, 95, 151, 95, 153, 95, 158, 95, 152, 95, 161, 95, 160, 95, 156, 95, 127, 96, 163, 96, 137, 96, 160, 96, 168, 96, 203, 96, 180, 96, 230, 96, 189, 96, 197, 96, 187, 96, 181, 96, 220, 96, 188, 96, 216, 96, 213, 96, 198, 96, 223, 96, 184, 96, 218, 96, 199, 96, 26, 98, 27, 98, 72, 98, 160, 99, 167, 99, 114, 99, 150, 99, 162, 99, 165, 99, 119, 99, 103, 99, 152, 99, 170, 99, 113, 99, 169, 99, 137, 99, 131, 99, 155, 99, 107, 99, 168, 99, 132, 99, 136, 99, 153, 99, 161, 99, 172, 99, 146, 99, 143, 99, 128, 99, 123, 99, 105, 99, 104, 99, 122, 99, 93, 101, 86, 101, 81, 101, 89, 101, 87, 101, 95, 85, 79, 101, 88, 101, 85, 101, 84, 101, 156, 101, 155, 101, 172, 101, 207, 101, 203, 101, 204, 101, 206, 101, 93, 102, 90, 102, 100, 102, 104, 102, 102, 102, 94, 102, 249, 102, 215, 82, 27, 103, 129, 104, 175, 104, 162, 104, 147, 104, 181, 104, 127, 104, 118, 104, 177, 104, 167, 104, 151, 104, 176, 104, 131, 104, 196, 104, 173, 104, 134, 104, 133, 104, 148, 104, 157, 104, 168, 104, 159, 104, 161, 104, 130, 104, 50, 107, 186, 107, 235, 107, 236, 107, 43, 108, 142, 109, 188, 109, 243, 109, 217, 109, 178, 109, 225, 109, 204, 109, 228, 109, 251, 109, 250, 109, 5, 110, 199, 109, 203, 109, 175, 109, 209, 109, 174, 109, 222, 109, 249, 109, 184, 109, 247, 109, 245, 109, 197, 109, 210, 109, 26, 110, 181, 109, 218, 109, 235, 109, 216, 109, 234, 109, 241, 109, 238, 109, 232, 109, 198, 109, 196, 109, 170, 109, 236, 109, 191, 109, 230, 109, 249, 112, 9, 113, 10, 113, 253, 112, 239, 112, 61, 114, 125, 114, 129, 114, 28, 115, 27, 115, 22, 115, 19, 115, 25, 115, 135, 115, 5, 116, 10, 116, 3, 116, 6, 116, 254, 115, 13, 116, 224, 116, 246, 116, 247, 116, 28, 117, 34, 117, 101, 117, 102, 117, 98, 117, 112, 117, 143, 117, 212, 117, 213, 117, 181, 117, 202, 117, 205, 117, 142, 118, 212, 118, 210, 118, 219, 118, 55, 119, 62, 119, 60, 119, 54, 119, 56, 119, 58, 119, 107, 120, 67, 120, 78, 120, 101, 121, 104, 121, 109, 121, 251, 121, 146, 122, 149, 122, 32, 123, 40, 123, 27, 123, 44, 123, 38, 123, 25, 123, 30, 123, 46, 123, 146, 124, 151, 124, 149, 124, 70, 125, 67, 125, 113, 125, 46, 125, 57, 125, 60, 125, 64, 125, 48, 125, 51, 125, 68, 125, 47, 125, 66, 125, 50, 125, 49, 125, 61, 127, 158, 127, 154, 127, 204, 127, 206, 127, 210, 127, 28, 128, 74, 128, 70, 128, 47, 129, 22, 129, 35, 129, 43, 129, 41, 129, 48, 129, 36, 129, 2, 130, 53, 130, 55, 130, 54, 130, 57, 130, 142, 131, 158, 131, 152, 131, 120, 131, 162, 131, 150, 131, 189, 131, 171, 131, 146, 131, 138, 131, 147, 131, 137, 131, 160, 131, 119, 131, 123, 131, 124, 131, 134, 131, 167, 131, 85, 134, 106, 95, 199, 134, 192, 134, 182, 134, 196, 134, 181, 134, 198, 134, 203, 134, 177, 134, 175, 134, 201, 134, 83, 136, 158, 136, 136, 136, 171, 136, 146, 136, 150, 136, 141, 136, 139, 136, 147, 137, 143, 137, 42, 138, 29, 138, 35, 138, 37, 138, 49, 138, 45, 138, 31, 138, 27, 138, 34, 138, 73, 140, 90, 140, 169, 140, 172, 140, 171, 140, 168, 140, 170, 140, 167, 140, 103, 141, 102, 141, 190, 141, 186, 141, 219, 142, 223, 142, 25, 144, 13, 144, 26, 144, 23, 144, 35, 144, 31, 144, 29, 144, 16, 144, 21, 144, 30, 144, 32, 144, 15, 144, 34, 144, 22, 144, 27, 144, 20, 144, 232, 144, 237, 144, 253, 144, 87, 145, 206, 145, 245, 145, 230, 145, 227, 145, 231, 145, 237, 145, 233, 145, 137, 149, 106, 150, 117, 150, 115, 150, 120, 150, 112, 150, 116, 150, 118, 150, 119, 150, 108, 150, 192, 150, 234, 150, 233, 150, 224, 122, 223, 122, 2, 152, 3, 152, 90, 155, 229, 156, 117, 158, 127, 158, 165, 158, 187, 158, 162, 80, 141, 80, 133, 80, 153, 80, 145, 80, 128, 80, 150, 80, 152, 80, 154, 80, 0, 103, 241, 81, 114, 82, 116, 82, 117, 82, 105, 82, 222, 82, 221, 82, 219, 82, 90, 83, 165, 83, 123, 85, 128, 85, 167, 85, 124, 85, 138, 85, 157, 85, 152, 85, 130, 85, 156, 85, 170, 85, 148, 85, 135, 85, 139, 85, 131, 85, 179, 85, 174, 85, 159, 85, 62, 85, 178, 85, 154, 85, 187, 85, 172, 85, 177, 85, 126, 85, 137, 85, 171, 85, 153, 85, 13, 87, 47, 88, 42, 88, 52, 88, 36, 88, 48, 88, 49, 88, 33, 88, 29, 88, 32, 88, 249, 88, 250, 88, 96, 89, 119, 90, 154, 90, 127, 90, 146, 90, 155, 90, 167, 90, 115, 91, 113, 91, 210, 91, 204, 91, 211, 91, 208, 91, 10, 92, 11, 92, 49, 92, 76, 93, 80, 93, 52, 93, 71, 93, 253, 93, 69, 94, 61, 94, 64, 94, 67, 94, 126, 94, 202, 94, 193, 94, 194, 94, 196, 94, 60, 95, 109, 95, 169, 95, 170, 95, 168, 95, 209, 96, 225, 96, 178, 96, 182, 96, 224, 96, 28, 97, 35, 97, 250, 96, 21, 97, 240, 96, 251, 96, 244, 96, 104, 97, 241, 96, 14, 97, 246, 96, 9, 97, 0, 97, 18, 97, 31, 98, 73, 98, 163, 99, 140, 99, 207, 99, 192, 99, 233, 99, 201, 99, 198, 99, 205, 99, 210, 99, 227, 99, 208, 99, 225, 99, 214, 99, 237, 99, 238, 99, 118, 99, 244, 99, 234, 99, 219, 99, 82, 100, 218, 99, 249, 99, 94, 101, 102, 101, 98, 101, 99, 101, 145, 101, 144, 101, 175, 101, 110, 102, 112, 102, 116, 102, 118, 102, 111, 102, 145, 102, 122, 102, 126, 102, 119, 102, 254, 102, 255, 102, 31, 103, 29, 103, 250, 104, 213, 104, 224, 104, 216, 104, 215, 104, 5, 105, 223, 104, 245, 104, 238, 104, 231, 104, 249, 104, 210, 104, 242, 104, 227, 104, 203, 104, 205, 104, 13, 105, 18, 105, 14, 105, 201, 104, 218, 104, 110, 105, 251, 104, 62, 107, 58, 107, 61, 107, 152, 107, 150, 107, 188, 107, 239, 107, 46, 108, 47, 108, 44, 108, 47, 110, 56, 110, 84, 110, 33, 110, 50, 110, 103, 110, 74, 110, 32, 110, 37, 110, 35, 110, 27, 110, 91, 110, 88, 110, 36, 110, 86, 110, 110, 110, 45, 110, 38, 110, 111, 110, 52, 110, 77, 110, 58, 110, 44, 110, 67, 110, 29, 110, 62, 110, 203, 110, 137, 110, 25, 110, 78, 110, 99, 110, 68, 110, 114, 110, 105, 110, 95, 110, 25, 113, 26, 113, 38, 113, 48, 113, 33, 113, 54, 113, 110, 113, 28, 113, 76, 114, 132, 114, 128, 114, 54, 115, 37, 115, 52, 115, 41, 115, 58, 116, 42, 116, 51, 116, 34, 116, 37, 116, 53, 116, 54, 116, 52, 116, 47, 116, 27, 116, 38, 116, 40, 116, 37, 117, 38, 117, 107, 117, 106, 117, 226, 117, 219, 117, 227, 117, 217, 117, 216, 117, 222, 117, 224, 117, 123, 118, 124, 118, 150, 118, 147, 118, 180, 118, 220, 118, 79, 119, 237, 119, 93, 120, 108, 120, 111, 120, 13, 122, 8, 122, 11, 122, 5, 122, 0, 122, 152, 122, 151, 122, 150, 122, 229, 122, 227, 122, 73, 123, 86, 123, 70, 123, 80, 123, 82, 123, 84, 123, 77, 123, 75, 123, 79, 123, 81, 123, 159, 124, 165, 124, 94, 125, 80, 125, 104, 125, 85, 125, 43, 125, 110, 125, 114, 125, 97, 125, 102, 125, 98, 125, 112, 125, 115, 125, 132, 85, 212, 127, 213, 127, 11, 128, 82, 128, 133, 128, 85, 129, 84, 129, 75, 129, 81, 129, 78, 129, 57, 129, 70, 129, 62, 129, 76, 129, 83, 129, 116, 129, 18, 130, 28, 130, 233, 131, 3, 132, 248, 131, 13, 132, 224, 131, 197, 131, 11, 132, 193, 131, 239, 131, 241, 131, 244, 131, 87, 132, 10, 132, 240, 131, 12, 132, 204, 131, 253, 131, 242, 131, 202, 131, 56, 132, 14, 132, 4, 132, 220, 131, 7, 132, 212, 131, 223, 131, 91, 134, 223, 134, 217, 134, 237, 134, 212, 134, 219, 134, 228, 134, 208, 134, 222, 134, 87, 136, 193, 136, 194, 136, 177, 136, 131, 137, 150, 137, 59, 138, 96, 138, 85, 138, 94, 138, 60, 138, 65, 138, 84, 138, 91, 138, 80, 138, 70, 138, 52, 138, 58, 138, 54, 138, 86, 138, 97, 140, 130, 140, 175, 140, 188, 140, 179, 140, 189, 140, 193, 140, 187, 140, 192, 140, 180, 140, 183, 140, 182, 140, 191, 140, 184, 140, 138, 141, 133, 141, 129, 141, 206, 141, 221, 141, 203, 141, 218, 141, 209, 141, 204, 141, 219, 141, 198, 141, 251, 142, 248, 142, 252, 142, 156, 143, 46, 144, 53, 144, 49, 144, 56, 144, 50, 144, 54, 144, 2, 145, 245, 144, 9, 145, 254, 144, 99, 145, 101, 145, 207, 145, 20, 146, 21, 146, 35, 146, 9, 146, 30, 146, 13, 146, 16, 146, 7, 146, 17, 146, 148, 149, 143, 149, 139, 149, 145, 149, 147, 149, 146, 149, 142, 149, 138, 150, 142, 150, 139, 150, 125, 150, 133, 150, 134, 150, 141, 150, 114, 150, 132, 150, 193, 150, 197, 150, 196, 150, 198, 150, 199, 150, 239, 150, 242, 150, 204, 151, 5, 152, 6, 152, 8, 152, 231, 152, 234, 152, 239, 152, 233, 152, 242, 152, 237, 152, 174, 153, 173, 153, 195, 158, 205, 158, 209, 158, 130, 78, 173, 80, 181, 80, 178, 80, 179, 80, 197, 80, 190, 80, 172, 80, 183, 80, 187, 80, 175, 80, 199, 80, 127, 82, 119, 82, 125, 82, 223, 82, 230, 82, 228, 82, 226, 82, 227, 82, 47, 83, 223, 85, 232, 85, 211, 85, 230, 85, 206, 85, 220, 85, 199, 85, 209, 85, 227, 85, 228, 85, 239, 85, 218, 85, 225, 85, 197, 85, 198, 85, 229, 85, 201, 85, 18, 87, 19, 87, 94, 88, 81, 88, 88, 88, 87, 88, 90, 88, 84, 88, 107, 88, 76, 88, 109, 88, 74, 88, 98, 88, 82, 88, 75, 88, 103, 89, 193, 90, 201, 90, 204, 90, 190, 90, 189, 90, 188, 90, 179, 90, 194, 90, 178, 90, 105, 93, 111, 93, 76, 94, 121, 94, 201, 94, 200, 94, 18, 95, 89, 95, 172, 95, 174, 95, 26, 97, 15, 97, 72, 97, 31, 97, 243, 96, 27, 97, 249, 96, 1, 97, 8, 97, 78, 97, 76, 97, 68, 97, 77, 97, 62, 97, 52, 97, 39, 97, 13, 97, 6, 97, 55, 97, 33, 98, 34, 98, 19, 100, 62, 100, 30, 100, 42, 100, 45, 100, 61, 100, 44, 100, 15, 100, 28, 100, 20, 100, 13, 100, 54, 100, 22, 100, 23, 100, 6, 100, 108, 101, 159, 101, 176, 101, 151, 102, 137, 102, 135, 102, 136, 102, 150, 102, 132, 102, 152, 102, 141, 102, 3, 103, 148, 105, 109, 105, 90, 105, 119, 105, 96, 105, 84, 105, 117, 105, 48, 105, 130, 105, 74, 105, 104, 105, 107, 105, 94, 105, 83, 105, 121, 105, 134, 105, 93, 105, 99, 105, 91, 105, 71, 107, 114, 107, 192, 107, 191, 107, 211, 107, 253, 107, 162, 110, 175, 110, 211, 110, 182, 110, 194, 110, 144, 110, 157, 110, 199, 110, 197, 110, 165, 110, 152, 110, 188, 110, 186, 110, 171, 110, 209, 110, 150, 110, 156, 110, 196, 110, 212, 110, 170, 110, 167, 110, 180, 110, 78, 113, 89, 113, 105, 113, 100, 113, 73, 113, 103, 113, 92, 113, 108, 113, 102, 113, 76, 113, 101, 113, 94, 113, 70, 113, 104, 113, 86, 113, 58, 114, 82, 114, 55, 115, 69, 115, 63, 115, 62, 115, 111, 116, 90, 116, 85, 116, 95, 116, 94, 116, 65, 116, 63, 116, 89, 116, 91, 116, 92, 116, 118, 117, 120, 117, 0, 118, 240, 117, 1, 118, 242, 117, 241, 117, 250, 117, 255, 117, 244, 117, 243, 117, 222, 118, 223, 118, 91, 119, 107, 119, 102, 119, 94, 119, 99, 119, 121, 119, 106, 119, 108, 119, 92, 119, 101, 119, 104, 119, 98, 119, 238, 119, 142, 120, 176, 120, 151, 120, 152, 120, 140, 120, 137, 120, 124, 120, 145, 120, 147, 120, 127, 120, 122, 121, 127, 121, 129, 121, 44, 132, 189, 121, 28, 122, 26, 122, 32, 122, 20, 122, 31, 122, 30, 122, 159, 122, 160, 122, 119, 123, 192, 123, 96, 123, 110, 123, 103, 123, 177, 124, 179, 124, 181, 124, 147, 125, 121, 125, 145, 125, 129, 125, 143, 125, 91, 125, 110, 127, 105, 127, 106, 127, 114, 127, 169, 127, 168, 127, 164, 127, 86, 128, 88, 128, 134, 128, 132, 128, 113, 129, 112, 129, 120, 129, 101, 129, 110, 129, 115, 129, 107, 129, 121, 129, 122, 129, 102, 129, 5, 130, 71, 130, 130, 132, 119, 132, 61, 132, 49, 132, 117, 132, 102, 132, 107, 132, 73, 132, 108, 132, 91, 132, 60, 132, 53, 132, 97, 132, 99, 132, 105, 132, 109, 132, 70, 132, 94, 134, 92, 134, 95, 134, 249, 134, 19, 135, 8, 135, 7, 135, 0, 135, 254, 134, 251, 134, 2, 135, 3, 135, 6, 135, 10, 135, 89, 136, 223, 136, 212, 136, 217, 136, 220, 136, 216, 136, 221, 136, 225, 136, 202, 136, 213, 136, 210, 136, 156, 137, 227, 137, 107, 138, 114, 138, 115, 138, 102, 138, 105, 138, 112, 138, 135, 138, 124, 138, 99, 138, 160, 138, 113, 138, 133, 138, 109, 138, 98, 138, 110, 138, 108, 138, 121, 138, 123, 138, 62, 138, 104, 138, 98, 140, 138, 140, 137, 140, 202, 140, 199, 140, 200, 140, 196, 140, 178, 140, 195, 140, 194, 140, 197, 140, 225, 141, 223, 141, 232, 141, 239, 141, 243, 141, 250, 141, 234, 141, 228, 141, 230, 141, 178, 142, 3, 143, 9, 143, 254, 142, 10, 143, 159, 143, 178, 143, 75, 144, 74, 144, 83, 144, 66, 144, 84, 144, 60, 144, 85, 144, 80, 144, 71, 144, 79, 144, 78, 144, 77, 144, 81, 144, 62, 144, 65, 144, 18, 145, 23, 145, 108, 145, 106, 145, 105, 145, 201, 145, 55, 146, 87, 146, 56, 146, 61, 146, 64, 146, 62, 146, 91, 146, 75, 146, 100, 146, 81, 146, 52, 146, 73, 146, 77, 146, 69, 146, 57, 146, 63, 146, 90, 146, 152, 149, 152, 150, 148, 150, 149, 150, 205, 150, 203, 150, 201, 150, 202, 150, 247, 150, 251, 150, 249, 150, 246, 150, 86, 151, 116, 151, 118, 151, 16, 152, 17, 152, 19, 152, 10, 152, 18, 152, 12, 152, 252, 152, 244, 152, 253, 152, 254, 152, 179, 153, 177, 153, 180, 153, 225, 154, 233, 156, 130, 158, 14, 159, 19, 159, 32, 159, 231, 80, 238, 80, 229, 80, 214, 80, 237, 80, 218, 80, 213, 80, 207, 80, 209, 80, 241, 80, 206, 80, 233, 80, 98, 81, 243, 81, 131, 82, 130, 82, 49, 83, 173, 83, 254, 85, 0, 86, 27, 86, 23, 86, 253, 85, 20, 86, 6, 86, 9, 86, 13, 86, 14, 86, 247, 85, 22, 86, 31, 86, 8, 86, 16, 86, 246, 85, 24, 87, 22, 87, 117, 88, 126, 88, 131, 88, 147, 88, 138, 88, 121, 88, 133, 88, 125, 88, 253, 88, 37, 89, 34, 89, 36, 89, 106, 89, 105, 89, 225, 90, 230, 90, 233, 90, 215, 90, 214, 90, 216, 90, 227, 90, 117, 91, 222, 91, 231, 91, 225, 91, 229, 91, 230, 91, 232, 91, 226, 91, 228, 91, 223, 91, 13, 92, 98, 92, 132, 93, 135, 93, 91, 94, 99, 94, 85, 94, 87, 94, 84, 94, 211, 94, 214, 94, 10, 95, 70, 95, 112, 95, 185, 95, 71, 97, 63, 97, 75, 97, 119, 97, 98, 97, 99, 97, 95, 97, 90, 97, 88, 97, 117, 97, 42, 98, 135, 100, 88, 100, 84, 100, 164, 100, 120, 100, 95, 100, 122, 100, 81, 100, 103, 100, 52, 100, 109, 100, 123, 100, 114, 101, 161, 101, 215, 101, 214, 101, 162, 102, 168, 102, 157, 102, 156, 105, 168, 105, 149, 105, 193, 105, 174, 105, 211, 105, 203, 105, 155, 105, 183, 105, 187, 105, 171, 105, 180, 105, 208, 105, 205, 105, 173, 105, 204, 105, 166, 105, 195, 105, 163, 105, 73, 107, 76, 107, 51, 108, 51, 111, 20, 111, 254, 110, 19, 111, 244, 110, 41, 111, 62, 111, 32, 111, 44, 111, 15, 111, 2, 111, 34, 111, 255, 110, 239, 110, 6, 111, 49, 111, 56, 111, 50, 111, 35, 111, 21, 111, 43, 111, 47, 111, 136, 111, 42, 111, 236, 110, 1, 111, 242, 110, 204, 110, 247, 110, 148, 113, 153, 113, 125, 113, 138, 113, 132, 113, 146, 113, 62, 114, 146, 114, 150, 114, 68, 115, 80, 115, 100, 116, 99, 116, 106, 116, 112, 116, 109, 116, 4, 117, 145, 117, 39, 118, 13, 118, 11, 118, 9, 118, 19, 118, 225, 118, 227, 118, 132, 119, 125, 119, 127, 119, 97, 119, 193, 120, 159, 120, 167, 120, 179, 120, 169, 120, 163, 120, 142, 121, 143, 121, 141, 121, 46, 122, 49, 122, 170, 122, 169, 122, 237, 122, 239, 122, 161, 123, 149, 123, 139, 123, 117, 123, 151, 123, 157, 123, 148, 123, 143, 123, 184, 123, 135, 123, 132, 123, 185, 124, 189, 124, 190, 124, 187, 125, 176, 125, 156, 125, 189, 125, 190, 125, 160, 125, 202, 125, 180, 125, 178, 125, 177, 125, 186, 125, 162, 125, 191, 125, 181, 125, 184, 125, 173, 125, 210, 125, 199, 125, 172, 125, 112, 127, 224, 127, 225, 127, 223, 127, 94, 128, 90, 128, 135, 128, 80, 129, 128, 129, 143, 129, 136, 129, 138, 129, 127, 129, 130, 129, 231, 129, 250, 129, 7, 130, 20, 130, 30, 130, 75, 130, 201, 132, 191, 132, 198, 132, 196, 132, 153, 132, 158, 132, 178, 132, 156, 132, 203, 132, 184, 132, 192, 132, 211, 132, 144, 132, 188, 132, 209, 132, 202, 132, 63, 135, 28, 135, 59, 135, 34, 135, 37, 135, 52, 135, 24, 135, 85, 135, 55, 135, 41, 135, 243, 136, 2, 137, 244, 136, 249, 136, 248, 136, 253, 136, 232, 136, 26, 137, 239, 136, 166, 138, 140, 138, 158, 138, 163, 138, 141, 138, 161, 138, 147, 138, 164, 138, 170, 138, 165, 138, 168, 138, 152, 138, 145, 138, 154, 138, 167, 138, 106, 140, 141, 140, 140, 140, 211, 140, 209, 140, 210, 140, 107, 141, 153, 141, 149, 141, 252, 141, 20, 143, 18, 143, 21, 143, 19, 143, 163, 143, 96, 144, 88, 144, 92, 144, 99, 144, 89, 144, 94, 144, 98, 144, 93, 144, 91, 144, 25, 145, 24, 145, 30, 145, 117, 145, 120, 145, 119, 145, 116, 145, 120, 146, 128, 146, 133, 146, 152, 146, 150, 146, 123, 146, 147, 146, 156, 146, 168, 146, 124, 146, 145, 146, 161, 149, 168, 149, 169, 149, 163, 149, 165, 149, 164, 149, 153, 150, 156, 150, 155, 150, 204, 150, 210, 150, 0, 151, 124, 151, 133, 151, 246, 151, 23, 152, 24, 152, 175, 152, 177, 152, 3, 153, 5, 153, 12, 153, 9, 153, 193, 153, 175, 154, 176, 154, 230, 154, 65, 155, 66, 155, 244, 156, 246, 156, 243, 156, 188, 158, 59, 159, 74, 159, 4, 81, 0, 81, 251, 80, 245, 80, 249, 80, 2, 81, 8, 81, 9, 81, 5, 81, 220, 81, 135, 82, 136, 82, 137, 82, 141, 82, 138, 82, 240, 82, 178, 83, 46, 86, 59, 86, 57, 86, 50, 86, 63, 86, 52, 86, 41, 86, 83, 86, 78, 86, 87, 86, 116, 86, 54, 86, 47, 86, 48, 86, 128, 88, 159, 88, 158, 88, 179, 88, 156, 88, 174, 88, 169, 88, 166, 88, 109, 89, 9, 91, 251, 90, 11, 91, 245, 90, 12, 91, 8, 91, 238, 91, 236, 91, 233, 91, 235, 91, 100, 92, 101, 92, 157, 93, 148, 93, 98, 94, 95, 94, 97, 94, 226, 94, 218, 94, 223, 94, 221, 94, 227, 94, 224, 94, 72, 95, 113, 95, 183, 95, 181, 95, 118, 97, 103, 97, 110, 97, 93, 97, 85, 97, 130, 97, 124, 97, 112, 97, 107, 97, 126, 97, 167, 97, 144, 97, 171, 97, 142, 97, 172, 97, 154, 97, 164, 97, 148, 97, 174, 97, 46, 98, 105, 100, 111, 100, 121, 100, 158, 100, 178, 100, 136, 100, 144, 100, 176, 100, 165, 100, 147, 100, 149, 100, 169, 100, 146, 100, 174, 100, 173, 100, 171, 100, 154, 100, 172, 100, 153, 100, 162, 100, 179, 100, 117, 101, 119, 101, 120, 101, 174, 102, 171, 102, 180, 102, 177, 102, 35, 106, 31, 106, 232, 105, 1, 106, 30, 106, 25, 106, 253, 105, 33, 106, 19, 106, 10, 106, 243, 105, 2, 106, 5, 106, 237, 105, 17, 106, 80, 107, 78, 107, 164, 107, 197, 107, 198, 107, 63, 111, 124, 111, 132, 111, 81, 111, 102, 111, 84, 111, 134, 111, 109, 111, 91, 111, 120, 111, 110, 111, 142, 111, 122, 111, 112, 111, 100, 111, 151, 111, 88, 111, 213, 110, 111, 111, 96, 111, 95, 111, 159, 113, 172, 113, 177, 113, 168, 113, 86, 114, 155, 114, 78, 115, 87, 115, 105, 116, 139, 116, 131, 116, 126, 116, 128, 116, 127, 117, 32, 118, 41, 118, 31, 118, 36, 118, 38, 118, 33, 118, 34, 118, 154, 118, 186, 118, 228, 118, 142, 119, 135, 119, 140, 119, 145, 119, 139, 119, 203, 120, 197, 120, 186, 120, 202, 120, 190, 120, 213, 120, 188, 120, 208, 120, 63, 122, 60, 122, 64, 122, 61, 122, 55, 122, 59, 122, 175, 122, 174, 122, 173, 123, 177, 123, 196, 123, 180, 123, 198, 123, 199, 123, 193, 123, 160, 123, 204, 123, 202, 124, 224, 125, 244, 125, 239, 125, 251, 125, 216, 125, 236, 125, 221, 125, 232, 125, 227, 125, 218, 125, 222, 125, 233, 125, 158, 125, 217, 125, 242, 125, 249, 125, 117, 127, 119, 127, 175, 127, 233, 127, 38, 128, 155, 129, 156, 129, 157, 129, 160, 129, 154, 129, 152, 129, 23, 133, 61, 133, 26, 133, 238, 132, 44, 133, 45, 133, 19, 133, 17, 133, 35, 133, 33, 133, 20, 133, 236, 132, 37, 133, 255, 132, 6, 133, 130, 135, 116, 135, 118, 135, 96, 135, 102, 135, 120, 135, 104, 135, 89, 135, 87, 135, 76, 135, 83, 135, 91, 136, 93, 136, 16, 137, 7, 137, 18, 137, 19, 137, 21, 137, 10, 137, 188, 138, 210, 138, 199, 138, 196, 138, 149, 138, 203, 138, 248, 138, 178, 138, 201, 138, 194, 138, 191, 138, 176, 138, 214, 138, 205, 138, 182, 138, 185, 138, 219, 138, 76, 140, 78, 140, 108, 140, 224, 140, 222, 140, 230, 140, 228, 140, 236, 140, 237, 140, 226, 140, 227, 140, 220, 140, 234, 140, 225, 140, 109, 141, 159, 141, 163, 141, 43, 142, 16, 142, 29, 142, 34, 142, 15, 142, 41, 142, 31, 142, 33, 142, 30, 142, 186, 142, 29, 143, 27, 143, 31, 143, 41, 143, 38, 143, 42, 143, 28, 143, 30, 143, 37, 143, 105, 144, 110, 144, 104, 144, 109, 144, 119, 144, 48, 145, 45, 145, 39, 145, 49, 145, 135, 145, 137, 145, 139, 145, 131, 145, 197, 146, 187, 146, 183, 146, 234, 146, 172, 146, 228, 146, 193, 146, 179, 146, 188, 146, 210, 146, 199, 146, 240, 146, 178, 146, 173, 149, 177, 149, 4, 151, 6, 151, 7, 151, 9, 151, 96, 151, 141, 151, 139, 151, 143, 151, 33, 152, 43, 152, 28, 152, 179, 152, 10, 153, 19, 153, 18, 153, 24, 153, 221, 153, 208, 153, 223, 153, 219, 153, 209, 153, 213, 153, 210, 153, 217, 153, 183, 154, 238, 154, 239, 154, 39, 155, 69, 155, 68, 155, 119, 155, 111, 155, 6, 157, 9, 157, 3, 157, 169, 158, 190, 158, 206, 158, 168, 88, 82, 159, 18, 81, 24, 81, 20, 81, 16, 81, 21, 81, 128, 81, 170, 81, 221, 81, 145, 82, 147, 82, 243, 82, 89, 86, 107, 86, 121, 86, 105, 86, 100, 86, 120, 86, 106, 86, 104, 86, 101, 86, 113, 86, 111, 86, 108, 86, 98, 86, 118, 86, 193, 88, 190, 88, 199, 88, 197, 88, 110, 89, 29, 91, 52, 91, 120, 91, 240, 91, 14, 92, 74, 95, 178, 97, 145, 97, 169, 97, 138, 97, 205, 97, 182, 97, 190, 97, 202, 97, 200, 97, 48, 98, 197, 100, 193, 100, 203, 100, 187, 100, 188, 100, 218, 100, 196, 100, 199, 100, 194, 100, 205, 100, 191, 100, 210, 100, 212, 100, 190, 100, 116, 101, 198, 102, 201, 102, 185, 102, 196, 102, 199, 102, 184, 102, 61, 106, 56, 106, 58, 106, 89, 106, 107, 106, 88, 106, 57, 106, 68, 106, 98, 106, 97, 106, 75, 106, 71, 106, 53, 106, 95, 106, 72, 106, 89, 107, 119, 107, 5, 108, 194, 111, 177, 111, 161, 111, 195, 111, 164, 111, 193, 111, 167, 111, 179, 111, 192, 111, 185, 111, 182, 111, 166, 111, 160, 111, 180, 111, 190, 113, 201, 113, 208, 113, 210, 113, 200, 113, 213, 113, 185, 113, 206, 113, 217, 113, 220, 113, 195, 113, 196, 113, 104, 115, 156, 116, 163, 116, 152, 116, 159, 116, 158, 116, 226, 116, 12, 117, 13, 117, 52, 118, 56, 118, 58, 118, 231, 118, 229, 118, 160, 119, 158, 119, 159, 119, 165, 119, 232, 120, 218, 120, 236, 120, 231, 120, 166, 121, 77, 122, 78, 122, 70, 122, 76, 122, 75, 122, 186, 122, 217, 123, 17, 124, 201, 123, 228, 123, 219, 123, 225, 123, 233, 123, 230, 123, 213, 124, 214, 124, 10, 126, 17, 126, 8, 126, 27, 126, 35, 126, 30, 126, 29, 126, 9, 126, 16, 126, 121, 127, 178, 127, 240, 127, 241, 127, 238, 127, 40, 128, 179, 129, 169, 129, 168, 129, 251, 129, 8, 130, 88, 130, 89, 130, 74, 133, 89, 133, 72, 133, 104, 133, 105, 133, 67, 133, 73, 133, 109, 133, 106, 133, 94, 133, 131, 135, 159, 135, 158, 135, 162, 135, 141, 135, 97, 136, 42, 137, 50, 137, 37, 137, 43, 137, 33, 137, 170, 137, 166, 137, 230, 138, 250, 138, 235, 138, 241, 138, 0, 139, 220, 138, 231, 138, 238, 138, 254, 138, 1, 139, 2, 139, 247, 138, 237, 138, 243, 138, 246, 138, 252, 138, 107, 140, 109, 140, 147, 140, 244, 140, 68, 142, 49, 142, 52, 142, 66, 142, 57, 142, 53, 142, 59, 143, 47, 143, 56, 143, 51, 143, 168, 143, 166, 143, 117, 144, 116, 144, 120, 144, 114, 144, 124, 144, 122, 144, 52, 145, 146, 145, 32, 147, 54, 147, 248, 146, 51, 147, 47, 147, 34, 147, 252, 146, 43, 147, 4, 147, 26, 147, 16, 147, 38, 147, 33, 147, 21, 147, 46, 147, 25, 147, 187, 149, 167, 150, 168, 150, 170, 150, 213, 150, 14, 151, 17, 151, 22, 151, 13, 151, 19, 151, 15, 151, 91, 151, 92, 151, 102, 151, 152, 151, 48, 152, 56, 152, 59, 152, 55, 152, 45, 152, 57, 152, 36, 152, 16, 153, 40, 153, 30, 153, 27, 153, 33, 153, 26, 153, 237, 153, 226, 153, 241, 153, 184, 154, 188, 154, 251, 154, 237, 154, 40, 155, 145, 155, 21, 157, 35, 157, 38, 157, 40, 157, 18, 157, 27, 157, 216, 158, 212, 158, 141, 159, 156, 159, 42, 81, 31, 81, 33, 81, 50, 81, 245, 82, 142, 86, 128, 86, 144, 86, 133, 86, 135, 86, 143, 86, 213, 88, 211, 88, 209, 88, 206, 88, 48, 91, 42, 91, 36, 91, 122, 91, 55, 92, 104, 92, 188, 93, 186, 93, 189, 93, 184, 93, 107, 94, 76, 95, 189, 95, 201, 97, 194, 97, 199, 97, 230, 97, 203, 97, 50, 98, 52, 98, 206, 100, 202, 100, 216, 100, 224, 100, 240, 100, 230, 100, 236, 100, 241, 100, 226, 100, 237, 100, 130, 101, 131, 101, 217, 102, 214, 102, 128, 106, 148, 106, 132, 106, 162, 106, 156, 106, 219, 106, 163, 106, 126, 106, 151, 106, 144, 106, 160, 106, 92, 107, 174, 107, 218, 107, 8, 108, 216, 111, 241, 111, 223, 111, 224, 111, 219, 111, 228, 111, 235, 111, 239, 111, 128, 111, 236, 111, 225, 111, 233, 111, 213, 111, 238, 111, 240, 111, 231, 113, 223, 113, 238, 113, 230, 113, 229, 113, 237, 113, 236, 113, 244, 113, 224, 113, 53, 114, 70, 114, 112, 115, 114, 115, 169, 116, 176, 116, 166, 116, 168, 116, 70, 118, 66, 118, 76, 118, 234, 118, 179, 119, 170, 119, 176, 119, 172, 119, 167, 119, 173, 119, 239, 119, 247, 120, 250, 120, 244, 120, 239, 120, 1, 121, 167, 121, 170, 121, 87, 122, 191, 122, 7, 124, 13, 124, 254, 123, 247, 123, 12, 124, 224, 123, 224, 124, 220, 124, 222, 124, 226, 124, 223, 124, 217, 124, 221, 124, 46, 126, 62, 126, 70, 126, 55, 126, 50, 126, 67, 126, 43, 126, 61, 126, 49, 126, 69, 126, 65, 126, 52, 126, 57, 126, 72, 126, 53, 126, 63, 126, 47, 126, 68, 127, 243, 127, 252, 127, 113, 128, 114, 128, 112, 128, 111, 128, 115, 128, 198, 129, 195, 129, 186, 129, 194, 129, 192, 129, 191, 129, 189, 129, 201, 129, 190, 129, 232, 129, 9, 130, 113, 130, 170, 133, 132, 133, 126, 133, 156, 133, 145, 133, 148, 133, 175, 133, 155, 133, 135, 133, 168, 133, 138, 133, 103, 134, 192, 135, 209, 135, 179, 135, 210, 135, 198, 135, 171, 135, 187, 135, 186, 135, 200, 135, 203, 135, 59, 137, 54, 137, 68, 137, 56, 137, 61, 137, 172, 137, 14, 139, 23, 139, 25, 139, 27, 139, 10, 139, 32, 139, 29, 139, 4, 139, 16, 139, 65, 140, 63, 140, 115, 140, 250, 140, 253, 140, 252, 140, 248, 140, 251, 140, 168, 141, 73, 142, 75, 142, 72, 142, 74, 142, 68, 143, 62, 143, 66, 143, 69, 143, 63, 143, 127, 144, 125, 144, 132, 144, 129, 144, 130, 144, 128, 144, 57, 145, 163, 145, 158, 145, 156, 145, 77, 147, 130, 147, 40, 147, 117, 147, 74, 147, 101, 147, 75, 147, 24, 147, 126, 147, 108, 147, 91, 147, 112, 147, 90, 147, 84, 147, 202, 149, 203, 149, 204, 149, 200, 149, 198, 149, 177, 150, 184, 150, 214, 150, 28, 151, 30, 151, 160, 151, 211, 151, 70, 152, 182, 152, 53, 153, 1, 154, 255, 153, 174, 155, 171, 155, 170, 155, 173, 155, 59, 157, 63, 157, 139, 158, 207, 158, 222, 158, 220, 158, 221, 158, 219, 158, 62, 159, 75, 159, 226, 83, 149, 86, 174, 86, 217, 88, 216, 88, 56, 91, 93, 95, 227, 97, 51, 98, 244, 100, 242, 100, 254, 100, 6, 101, 250, 100, 251, 100, 247, 100, 183, 101, 220, 102, 38, 103, 179, 106, 172, 106, 195, 106, 187, 106, 184, 106, 194, 106, 174, 106, 175, 106, 95, 107, 120, 107, 175, 107, 9, 112, 11, 112, 254, 111, 6, 112, 250, 111, 17, 112, 15, 112, 251, 113, 252, 113, 254, 113, 248, 113, 119, 115, 117, 115, 167, 116, 191, 116, 21, 117, 86, 118, 88, 118, 82, 118, 189, 119, 191, 119, 187, 119, 188, 119, 14, 121, 174, 121, 97, 122, 98, 122, 96, 122, 196, 122, 197, 122, 43, 124, 39, 124, 42, 124, 30, 124, 35, 124, 33, 124, 231, 124, 84, 126, 85, 126, 94, 126, 90, 126, 97, 126, 82, 126, 89, 126, 72, 127, 249, 127, 251, 127, 119, 128, 118, 128, 205, 129, 207, 129, 10, 130, 207, 133, 169, 133, 205, 133, 208, 133, 201, 133, 176, 133, 186, 133, 185, 133, 166, 133, 239, 135, 236, 135, 242, 135, 224, 135, 134, 137, 178, 137, 244, 137, 40, 139, 57, 139, 44, 139, 43, 139, 80, 140, 5, 141, 89, 142, 99, 142, 102, 142, 100, 142, 95, 142, 85, 142, 192, 142, 73, 143, 77, 143, 135, 144, 131, 144, 136, 144, 171, 145, 172, 145, 208, 145, 148, 147, 138, 147, 150, 147, 162, 147, 179, 147, 174, 147, 172, 147, 176, 147, 152, 147, 154, 147, 151, 147, 212, 149, 214, 149, 208, 149, 213, 149, 226, 150, 220, 150, 217, 150, 219, 150, 222, 150, 36, 151, 163, 151, 166, 151, 173, 151, 249, 151, 77, 152, 79, 152, 76, 152, 78, 152, 83, 152, 186, 152, 62, 153, 63, 153, 61, 153, 46, 153, 165, 153, 14, 154, 193, 154, 3, 155, 6, 155, 79, 155, 78, 155, 77, 155, 202, 155, 201, 155, 253, 155, 200, 155], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 281828);
	        allocate([192, 155, 81, 157, 93, 157, 96, 157, 224, 158, 21, 159, 44, 159, 51, 81, 165, 86, 222, 88, 223, 88, 226, 88, 245, 91, 144, 159, 236, 94, 242, 97, 247, 97, 246, 97, 245, 97, 0, 101, 15, 101, 224, 102, 221, 102, 229, 106, 221, 106, 218, 106, 211, 106, 27, 112, 31, 112, 40, 112, 26, 112, 29, 112, 21, 112, 24, 112, 6, 114, 13, 114, 88, 114, 162, 114, 120, 115, 122, 115, 189, 116, 202, 116, 227, 116, 135, 117, 134, 117, 95, 118, 97, 118, 199, 119, 25, 121, 177, 121, 107, 122, 105, 122, 62, 124, 63, 124, 56, 124, 61, 124, 55, 124, 64, 124, 107, 126, 109, 126, 121, 126, 105, 126, 106, 126, 133, 127, 115, 126, 182, 127, 185, 127, 184, 127, 216, 129, 233, 133, 221, 133, 234, 133, 213, 133, 228, 133, 229, 133, 247, 133, 251, 135, 5, 136, 13, 136, 249, 135, 254, 135, 96, 137, 95, 137, 86, 137, 94, 137, 65, 139, 92, 139, 88, 139, 73, 139, 90, 139, 78, 139, 79, 139, 70, 139, 89, 139, 8, 141, 10, 141, 124, 142, 114, 142, 135, 142, 118, 142, 108, 142, 122, 142, 116, 142, 84, 143, 78, 143, 173, 143, 138, 144, 139, 144, 177, 145, 174, 145, 225, 147, 209, 147, 223, 147, 195, 147, 200, 147, 220, 147, 221, 147, 214, 147, 226, 147, 205, 147, 216, 147, 228, 147, 215, 147, 232, 147, 220, 149, 180, 150, 227, 150, 42, 151, 39, 151, 97, 151, 220, 151, 251, 151, 94, 152, 88, 152, 91, 152, 188, 152, 69, 153, 73, 153, 22, 154, 25, 154, 13, 155, 232, 155, 231, 155, 214, 155, 219, 155, 137, 157, 97, 157, 114, 157, 106, 157, 108, 157, 146, 158, 151, 158, 147, 158, 180, 158, 248, 82, 168, 86, 183, 86, 182, 86, 180, 86, 188, 86, 228, 88, 64, 91, 67, 91, 125, 91, 246, 91, 201, 93, 248, 97, 250, 97, 24, 101, 20, 101, 25, 101, 230, 102, 39, 103, 236, 106, 62, 112, 48, 112, 50, 112, 16, 114, 123, 115, 207, 116, 98, 118, 101, 118, 38, 121, 42, 121, 44, 121, 43, 121, 199, 122, 246, 122, 76, 124, 67, 124, 77, 124, 239, 124, 240, 124, 174, 143, 125, 126, 124, 126, 130, 126, 76, 127, 0, 128, 218, 129, 102, 130, 251, 133, 249, 133, 17, 134, 250, 133, 6, 134, 11, 134, 7, 134, 10, 134, 20, 136, 21, 136, 100, 137, 186, 137, 248, 137, 112, 139, 108, 139, 102, 139, 111, 139, 95, 139, 107, 139, 15, 141, 13, 141, 137, 142, 129, 142, 133, 142, 130, 142, 180, 145, 203, 145, 24, 148, 3, 148, 253, 147, 225, 149, 48, 151, 196, 152, 82, 153, 81, 153, 168, 153, 43, 154, 48, 154, 55, 154, 53, 154, 19, 156, 13, 156, 121, 158, 181, 158, 232, 158, 47, 159, 95, 159, 99, 159, 97, 159, 55, 81, 56, 81, 193, 86, 192, 86, 194, 86, 20, 89, 108, 92, 205, 93, 252, 97, 254, 97, 29, 101, 28, 101, 149, 101, 233, 102, 251, 106, 4, 107, 250, 106, 178, 107, 76, 112, 27, 114, 167, 114, 214, 116, 212, 116, 105, 118, 211, 119, 80, 124, 143, 126, 140, 126, 188, 127, 23, 134, 45, 134, 26, 134, 35, 136, 34, 136, 33, 136, 31, 136, 106, 137, 108, 137, 189, 137, 116, 139, 119, 139, 125, 139, 19, 141, 138, 142, 141, 142, 139, 142, 95, 143, 175, 143, 186, 145, 46, 148, 51, 148, 53, 148, 58, 148, 56, 148, 50, 148, 43, 148, 226, 149, 56, 151, 57, 151, 50, 151, 255, 151, 103, 152, 101, 152, 87, 153, 69, 154, 67, 154, 64, 154, 62, 154, 207, 154, 84, 155, 81, 155, 45, 156, 37, 156, 175, 157, 180, 157, 194, 157, 184, 157, 157, 158, 239, 158, 25, 159, 92, 159, 102, 159, 103, 159, 60, 81, 59, 81, 200, 86, 202, 86, 201, 86, 127, 91, 212, 93, 210, 93, 78, 95, 255, 97, 36, 101, 10, 107, 97, 107, 81, 112, 88, 112, 128, 115, 228, 116, 138, 117, 110, 118, 108, 118, 179, 121, 96, 124, 95, 124, 126, 128, 125, 128, 223, 129, 114, 137, 111, 137, 252, 137, 128, 139, 22, 141, 23, 141, 145, 142, 147, 142, 97, 143, 72, 145, 68, 148, 81, 148, 82, 148, 61, 151, 62, 151, 195, 151, 193, 151, 107, 152, 85, 153, 85, 154, 77, 154, 210, 154, 26, 155, 73, 156, 49, 156, 62, 156, 59, 156, 211, 157, 215, 157, 52, 159, 108, 159, 106, 159, 148, 159, 204, 86, 214, 93, 0, 98, 35, 101, 43, 101, 42, 101, 236, 102, 16, 107, 218, 116, 202, 122, 100, 124, 99, 124, 101, 124, 147, 126, 150, 126, 148, 126, 226, 129, 56, 134, 63, 134, 49, 136, 138, 139, 144, 144, 143, 144, 99, 148, 96, 148, 100, 148, 104, 151, 111, 152, 92, 153, 90, 154, 91, 154, 87, 154, 211, 154, 212, 154, 209, 154, 84, 156, 87, 156, 86, 156, 229, 157, 159, 158, 244, 158, 209, 86, 233, 88, 44, 101, 94, 112, 113, 118, 114, 118, 215, 119, 80, 127, 136, 127, 54, 136, 57, 136, 98, 136, 147, 139, 146, 139, 150, 139, 119, 130, 27, 141, 192, 145, 106, 148, 66, 151, 72, 151, 68, 151, 198, 151, 112, 152, 95, 154, 34, 155, 88, 155, 95, 156, 249, 157, 250, 157, 124, 158, 125, 158, 7, 159, 119, 159, 114, 159, 243, 94, 22, 107, 99, 112, 108, 124, 110, 124, 59, 136, 192, 137, 161, 142, 193, 145, 114, 148, 112, 148, 113, 152, 94, 153, 214, 154, 35, 155, 204, 158, 100, 112, 218, 119, 154, 139, 119, 148, 201, 151, 98, 154, 101, 154, 156, 126, 156, 139, 170, 142, 197, 145, 125, 148, 126, 148, 124, 148, 119, 156, 120, 156, 247, 158, 84, 140, 127, 148, 26, 158, 40, 114, 106, 154, 49, 155, 27, 158, 30, 158, 114, 124, 96, 36, 97, 36, 98, 36, 99, 36, 100, 36, 101, 36, 102, 36, 103, 36, 104, 36, 105, 36, 116, 36, 117, 36, 118, 36, 119, 36, 120, 36, 121, 36, 122, 36, 123, 36, 124, 36, 125, 36, 112, 33, 113, 33, 114, 33, 115, 33, 116, 33, 117, 33, 118, 33, 119, 33, 120, 33, 121, 33, 54, 78, 63, 78, 133, 78, 160, 78, 130, 81, 150, 81, 171, 81, 249, 82, 56, 83, 105, 83, 182, 83, 10, 89, 128, 91, 219, 93, 122, 94, 127, 94, 244, 94, 80, 95, 97, 95, 52, 101, 224, 101, 146, 117, 118, 118, 181, 143, 182, 150, 168, 0, 198, 2, 253, 48, 254, 48, 157, 48, 158, 48, 0, 0, 0, 0, 5, 48, 6, 48, 7, 48, 252, 48, 59, 255, 61, 255, 61, 39, 65, 48, 66, 48, 67, 48, 68, 48, 69, 48, 70, 48, 71, 48, 72, 48, 73, 48, 74, 48, 75, 48, 76, 48, 77, 48, 78, 48, 79, 48, 80, 48, 81, 48, 82, 48, 83, 48, 84, 48, 85, 48, 86, 48, 87, 48, 88, 48, 89, 48, 90, 48, 91, 48, 92, 48, 93, 48, 94, 48, 95, 48, 96, 48, 97, 48, 98, 48, 99, 48, 100, 48, 101, 48, 102, 48, 103, 48, 104, 48, 105, 48, 106, 48, 107, 48, 108, 48, 109, 48, 110, 48, 111, 48, 112, 48, 113, 48, 114, 48, 115, 48, 116, 48, 117, 48, 118, 48, 119, 48, 120, 48, 121, 48, 122, 48, 123, 48, 124, 48, 125, 48, 126, 48, 127, 48, 128, 48, 129, 48, 130, 48, 131, 48, 132, 48, 133, 48, 134, 48, 135, 48, 136, 48, 137, 48, 138, 48, 139, 48, 140, 48, 141, 48, 142, 48, 143, 48, 144, 48, 145, 48, 146, 48, 147, 48, 161, 48, 162, 48, 163, 48, 164, 48, 165, 48, 166, 48, 167, 48, 168, 48, 169, 48, 170, 48, 171, 48, 172, 48, 173, 48, 174, 48, 175, 48, 176, 48, 177, 48, 178, 48, 179, 48, 180, 48, 181, 48, 182, 48, 183, 48, 184, 48, 185, 48, 186, 48, 187, 48, 188, 48, 189, 48, 190, 48, 191, 48, 192, 48, 193, 48, 194, 48, 195, 48, 196, 48, 197, 48, 198, 48, 199, 48, 200, 48, 201, 48, 202, 48, 203, 48, 204, 48, 205, 48, 206, 48, 207, 48, 208, 48, 209, 48, 210, 48, 211, 48, 212, 48, 213, 48, 214, 48, 215, 48, 216, 48, 217, 48, 218, 48, 219, 48, 220, 48, 221, 48, 222, 48, 223, 48, 224, 48, 225, 48, 226, 48, 227, 48, 228, 48, 229, 48, 230, 48, 231, 48, 232, 48, 233, 48, 234, 48, 235, 48, 236, 48, 237, 48, 238, 48, 239, 48, 240, 48, 241, 48, 242, 48, 243, 48, 244, 48, 245, 48, 246, 48, 16, 4, 17, 4, 18, 4, 19, 4, 20, 4, 21, 4, 1, 4, 22, 4, 23, 4, 24, 4, 25, 4, 26, 4, 27, 4, 28, 4, 29, 4, 30, 4, 31, 4, 32, 4, 33, 4, 34, 4, 35, 4, 36, 4, 37, 4, 38, 4, 39, 4, 40, 4, 41, 4, 42, 4, 43, 4, 44, 4, 45, 4, 46, 4, 47, 4, 48, 4, 49, 4, 50, 4, 51, 4, 52, 4, 53, 4, 81, 4, 54, 4, 55, 4, 56, 4, 57, 4, 58, 4, 59, 4, 60, 4, 61, 4, 62, 4, 63, 4, 64, 4, 65, 4, 66, 4, 67, 4, 68, 4, 69, 4, 70, 4, 71, 4, 72, 4, 73, 4, 74, 4, 75, 4, 76, 4, 77, 4, 78, 4, 79, 4, 231, 33, 184, 33, 185, 33, 207, 49, 204, 0, 90, 78, 138, 0, 2, 82, 145, 68, 176, 159, 136, 81, 177, 159, 7, 118, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 255, 228, 255, 7, 255, 2, 255, 49, 50, 22, 33, 33, 33, 155, 48, 156, 48, 128, 46, 132, 46, 134, 46, 135, 46, 136, 46, 138, 46, 140, 46, 141, 46, 149, 46, 156, 46, 157, 46, 165, 46, 167, 46, 170, 46, 172, 46, 174, 46, 182, 46, 188, 46, 190, 46, 198, 46, 202, 46, 204, 46, 205, 46, 207, 46, 214, 46, 215, 46, 222, 46, 227, 46, 0, 0, 0, 0, 0, 0, 131, 2, 80, 2, 91, 2, 84, 2, 117, 2, 83, 1, 248, 0, 75, 1, 138, 2, 106, 2, 66, 78, 92, 78, 245, 81, 26, 83, 130, 83, 7, 78, 12, 78, 71, 78, 141, 78, 215, 86, 12, 250, 110, 92, 115, 95, 15, 78, 135, 81, 14, 78, 46, 78, 147, 78, 194, 78, 201, 78, 200, 78, 152, 81, 252, 82, 108, 83, 185, 83, 32, 87, 3, 89, 44, 89, 16, 92, 255, 93, 225, 101, 179, 107, 204, 107, 20, 108, 63, 114, 49, 78, 60, 78, 232, 78, 220, 78, 233, 78, 225, 78, 221, 78, 218, 78, 12, 82, 28, 83, 76, 83, 34, 87, 35, 87, 23, 89, 47, 89, 129, 91, 132, 91, 18, 92, 59, 92, 116, 92, 115, 92, 4, 94, 128, 94, 130, 94, 201, 95, 9, 98, 80, 98, 21, 108, 54, 108, 67, 108, 63, 108, 59, 108, 174, 114, 176, 114, 138, 115, 184, 121, 138, 128, 30, 150, 14, 79, 24, 79, 44, 79, 245, 78, 20, 79, 241, 78, 0, 79, 247, 78, 8, 79, 29, 79, 2, 79, 5, 79, 34, 79, 19, 79, 4, 79, 244, 78, 18, 79, 177, 81, 19, 82, 9, 82, 16, 82, 166, 82, 34, 83, 31, 83, 77, 83, 138, 83, 7, 84, 225, 86, 223, 86, 46, 87, 42, 87, 52, 87, 60, 89, 128, 89, 124, 89, 133, 89, 123, 89, 126, 89, 119, 89, 127, 89, 86, 91, 21, 92, 37, 92, 124, 92, 122, 92, 123, 92, 126, 92, 223, 93, 117, 94, 132, 94, 2, 95, 26, 95, 116, 95, 213, 95, 212, 95, 207, 95, 92, 98, 94, 98, 100, 98, 97, 98, 102, 98, 98, 98, 89, 98, 96, 98, 90, 98, 101, 98, 239, 101, 238, 101, 62, 103, 57, 103, 56, 103, 59, 103, 58, 103, 63, 103, 60, 103, 51, 103, 24, 108, 70, 108, 82, 108, 92, 108, 79, 108, 74, 108, 84, 108, 75, 108, 76, 108, 113, 112, 94, 114, 180, 114, 181, 114, 142, 115, 42, 117, 127, 118, 117, 122, 81, 127, 120, 130, 124, 130, 128, 130, 125, 130, 127, 130, 77, 134, 126, 137, 153, 144, 151, 144, 152, 144, 155, 144, 148, 144, 34, 150, 36, 150, 32, 150, 35, 150, 86, 79, 59, 79, 98, 79, 73, 79, 83, 79, 100, 79, 62, 79, 103, 79, 82, 79, 95, 79, 65, 79, 88, 79, 45, 79, 51, 79, 63, 79, 97, 79, 143, 81, 185, 81, 28, 82, 30, 82, 33, 82, 173, 82, 174, 82, 9, 83, 99, 83, 114, 83, 142, 83, 143, 83, 48, 84, 55, 84, 42, 84, 84, 84, 69, 84, 25, 84, 28, 84, 37, 84, 24, 84, 61, 84, 79, 84, 65, 84, 40, 84, 36, 84, 71, 84, 238, 86, 231, 86, 229, 86, 65, 87, 69, 87, 76, 87, 73, 87, 75, 87, 82, 87, 6, 89, 64, 89, 166, 89, 152, 89, 160, 89, 151, 89, 142, 89, 162, 89, 144, 89, 143, 89, 167, 89, 161, 89, 142, 91, 146, 91, 40, 92, 42, 92, 141, 92, 143, 92, 136, 92, 139, 92, 137, 92, 146, 92, 138, 92, 134, 92, 147, 92, 149, 92, 224, 93, 10, 94, 14, 94, 139, 94, 137, 94, 140, 94, 136, 94, 141, 94, 5, 95, 29, 95, 120, 95, 118, 95, 210, 95, 209, 95, 208, 95, 237, 95, 232, 95, 238, 95, 243, 95, 225, 95, 228, 95, 227, 95, 250, 95, 239, 95, 247, 95, 251, 95, 0, 96, 244, 95, 58, 98, 131, 98, 140, 98, 142, 98, 143, 98, 148, 98, 135, 98, 113, 98, 123, 98, 122, 98, 112, 98, 129, 98, 136, 98, 119, 98, 125, 98, 114, 98, 116, 98, 55, 101, 240, 101, 244, 101, 243, 101, 242, 101, 245, 101, 69, 103, 71, 103, 89, 103, 85, 103, 76, 103, 72, 103, 93, 103, 77, 103, 90, 103, 75, 103, 208, 107, 25, 108, 26, 108, 120, 108, 103, 108, 107, 108, 132, 108, 139, 108, 143, 108, 113, 108, 111, 108, 105, 108, 154, 108, 109, 108, 135, 108, 149, 108, 156, 108, 102, 108, 115, 108, 101, 108, 123, 108, 142, 108, 116, 112, 122, 112, 99, 114, 191, 114, 189, 114, 195, 114, 198, 114, 193, 114, 186, 114, 197, 114, 149, 115, 151, 115, 147, 115, 148, 115, 146, 115, 58, 117, 57, 117, 148, 117, 149, 117, 129, 118, 61, 121, 52, 128, 149, 128, 153, 128, 144, 128, 146, 128, 156, 128, 144, 130, 143, 130, 133, 130, 142, 130, 145, 130, 147, 130, 138, 130, 131, 130, 132, 130, 120, 140, 201, 143, 191, 143, 159, 144, 161, 144, 165, 144, 158, 144, 167, 144, 160, 144, 48, 150, 40, 150, 47, 150, 45, 150, 51, 78, 152, 79, 124, 79, 133, 79, 125, 79, 128, 79, 135, 79, 118, 79, 116, 79, 137, 79, 132, 79, 119, 79, 76, 79, 151, 79, 106, 79, 154, 79, 121, 79, 129, 79, 120, 79, 144, 79, 156, 79, 148, 79, 158, 79, 146, 79, 130, 79, 149, 79, 107, 79, 110, 79, 158, 81, 188, 81, 190, 81, 53, 82, 50, 82, 51, 82, 70, 82, 49, 82, 188, 82, 10, 83, 11, 83, 60, 83, 146, 83, 148, 83, 135, 84, 127, 84, 129, 84, 145, 84, 130, 84, 136, 84, 107, 84, 122, 84, 126, 84, 101, 84, 108, 84, 116, 84, 102, 84, 141, 84, 111, 84, 97, 84, 96, 84, 152, 84, 99, 84, 103, 84, 100, 84, 247, 86, 249, 86, 111, 87, 114, 87, 109, 87, 107, 87, 113, 87, 112, 87, 118, 87, 128, 87, 117, 87, 123, 87, 115, 87, 116, 87, 98, 87, 104, 87, 125, 87, 12, 89, 69, 89, 181, 89, 186, 89, 207, 89, 206, 89, 178, 89, 204, 89, 193, 89, 182, 89, 188, 89, 195, 89, 214, 89, 177, 89, 189, 89, 192, 89, 200, 89, 180, 89, 199, 89, 98, 91, 101, 91, 147, 91, 149, 91, 68, 92, 71, 92, 174, 92, 164, 92, 160, 92, 181, 92, 175, 92, 168, 92, 172, 92, 159, 92, 163, 92, 173, 92, 162, 92, 170, 92, 167, 92, 157, 92, 165, 92, 182, 92, 176, 92, 166, 92, 23, 94, 20, 94, 25, 94, 40, 95, 34, 95, 35, 95, 36, 95, 84, 95, 130, 95, 126, 95, 125, 95, 222, 95, 229, 95, 45, 96, 38, 96, 25, 96, 50, 96, 11, 96, 52, 96, 10, 96, 23, 96, 51, 96, 26, 96, 30, 96, 44, 96, 34, 96, 13, 96, 16, 96, 46, 96, 19, 96, 17, 96, 12, 96, 9, 96, 28, 96, 20, 98, 61, 98, 173, 98, 180, 98, 209, 98, 190, 98, 170, 98, 182, 98, 202, 98, 174, 98, 179, 98, 175, 98, 187, 98, 169, 98, 176, 98, 184, 98, 61, 101, 168, 101, 187, 101, 9, 102, 252, 101, 4, 102, 18, 102, 8, 102, 251, 101, 3, 102, 11, 102, 13, 102, 5, 102, 253, 101, 17, 102, 16, 102, 246, 102, 10, 103, 133, 103, 108, 103, 142, 103, 146, 103, 118, 103, 123, 103, 152, 103, 134, 103, 132, 103, 116, 103, 141, 103, 140, 103, 122, 103, 159, 103, 145, 103, 153, 103, 131, 103, 125, 103, 129, 103, 120, 103, 121, 103, 148, 103, 37, 107, 128, 107, 126, 107, 222, 107, 29, 108, 147, 108, 236, 108, 235, 108, 238, 108, 217, 108, 182, 108, 212, 108, 173, 108, 231, 108, 183, 108, 208, 108, 194, 108, 186, 108, 195, 108, 198, 108, 237, 108, 242, 108, 210, 108, 221, 108, 180, 108, 138, 108, 157, 108, 128, 108, 222, 108, 192, 108, 48, 109, 205, 108, 199, 108, 176, 108, 249, 108, 207, 108, 233, 108, 209, 108, 148, 112, 152, 112, 133, 112, 147, 112, 134, 112, 132, 112, 145, 112, 150, 112, 130, 112, 154, 112, 131, 112, 106, 114, 214, 114, 203, 114, 216, 114, 201, 114, 220, 114, 210, 114, 212, 114, 218, 114, 204, 114, 209, 114, 164, 115, 161, 115, 173, 115, 166, 115, 162, 115, 160, 115, 172, 115, 157, 115, 221, 116, 232, 116, 63, 117, 64, 117, 62, 117, 140, 117, 152, 117, 175, 118, 243, 118, 241, 118, 240, 118, 245, 118, 248, 119, 252, 119, 249, 119, 251, 119, 250, 119, 247, 119, 66, 121, 63, 121, 197, 121, 120, 122, 123, 122, 251, 122, 117, 124, 253, 124, 53, 128, 143, 128, 174, 128, 163, 128, 184, 128, 181, 128, 173, 128, 32, 130, 160, 130, 192, 130, 171, 130, 154, 130, 152, 130, 155, 130, 181, 130, 167, 130, 174, 130, 188, 130, 158, 130, 186, 130, 180, 130, 168, 130, 161, 130, 169, 130, 194, 130, 164, 130, 195, 130, 182, 130, 162, 130, 112, 134, 111, 134, 109, 134, 110, 134, 86, 140, 210, 143, 203, 143, 211, 143, 205, 143, 214, 143, 213, 143, 215, 143, 178, 144, 180, 144, 175, 144, 179, 144, 176, 144, 57, 150, 61, 150, 60, 150, 58, 150, 67, 150, 205, 79, 197, 79, 211, 79, 178, 79, 201, 79, 203, 79, 193, 79, 212, 79, 220, 79, 217, 79, 187, 79, 179, 79, 219, 79, 199, 79, 214, 79, 186, 79, 192, 79, 185, 79, 236, 79, 68, 82, 73, 82, 192, 82, 194, 82, 61, 83, 124, 83, 151, 83, 150, 83, 153, 83, 152, 83, 186, 84, 161, 84, 173, 84, 165, 84, 207, 84, 195, 84, 13, 131, 183, 84, 174, 84, 214, 84, 182, 84, 197, 84, 198, 84, 160, 84, 112, 84, 188, 84, 162, 84, 190, 84, 114, 84, 222, 84, 176, 84, 181, 87, 158, 87, 159, 87, 164, 87, 140, 87, 151, 87, 157, 87, 155, 87, 148, 87, 152, 87, 143, 87, 153, 87, 165, 87, 154, 87, 149, 87, 244, 88, 13, 89, 83, 89, 225, 89, 222, 89, 238, 89, 0, 90, 241, 89, 221, 89, 250, 89, 253, 89, 252, 89, 246, 89, 228, 89, 242, 89, 247, 89, 219, 89, 233, 89, 243, 89, 245, 89, 224, 89, 254, 89, 244, 89, 237, 89, 168, 91, 76, 92, 208, 92, 216, 92, 204, 92, 215, 92, 203, 92, 219, 92, 222, 92, 218, 92, 201, 92, 199, 92, 202, 92, 214, 92, 211, 92, 212, 92, 207, 92, 200, 92, 198, 92, 206, 92, 223, 92, 248, 92, 249, 93, 33, 94, 34, 94, 35, 94, 32, 94, 36, 94, 176, 94, 164, 94, 162, 94, 155, 94, 163, 94, 165, 94, 7, 95, 46, 95, 86, 95, 134, 95, 55, 96, 57, 96, 84, 96, 114, 96, 94, 96, 69, 96, 83, 96, 71, 96, 73, 96, 91, 96, 76, 96, 64, 96, 66, 96, 95, 96, 36, 96, 68, 96, 88, 96, 102, 96, 110, 96, 66, 98, 67, 98, 207, 98, 13, 99, 11, 99, 245, 98, 14, 99, 3, 99, 235, 98, 249, 98, 15, 99, 12, 99, 248, 98, 246, 98, 0, 99, 19, 99, 20, 99, 250, 98, 21, 99, 251, 98, 240, 98, 65, 101, 67, 101, 170, 101, 191, 101, 54, 102, 33, 102, 50, 102, 53, 102, 28, 102, 38, 102, 34, 102, 51, 102, 43, 102, 58, 102, 29, 102, 52, 102, 57, 102, 46, 102, 15, 103, 16, 103, 193, 103, 242, 103, 200, 103, 186, 103, 220, 103, 187, 103, 248, 103, 216, 103, 192, 103, 183, 103, 197, 103, 235, 103, 228, 103, 223, 103, 181, 103, 205, 103, 179, 103, 247, 103, 246, 103, 238, 103, 227, 103, 194, 103, 185, 103, 206, 103, 231, 103, 240, 103, 178, 103, 252, 103, 198, 103, 237, 103, 204, 103, 174, 103, 230, 103, 219, 103, 250, 103, 201, 103, 202, 103, 195, 103, 234, 103, 203, 103, 40, 107, 130, 107, 132, 107, 182, 107, 214, 107, 216, 107, 224, 107, 32, 108, 33, 108, 40, 109, 52, 109, 45, 109, 31, 109, 60, 109, 63, 109, 18, 109, 10, 109, 218, 108, 51, 109, 4, 109, 25, 109, 58, 109, 26, 109, 17, 109, 0, 109, 29, 109, 66, 109, 1, 109, 24, 109, 55, 109, 3, 109, 15, 109, 64, 109, 7, 109, 32, 109, 44, 109, 8, 109, 34, 109, 9, 109, 16, 109, 183, 112, 159, 112, 190, 112, 177, 112, 176, 112, 161, 112, 180, 112, 181, 112, 169, 112, 65, 114, 73, 114, 74, 114, 108, 114, 112, 114, 115, 114, 110, 114, 202, 114, 228, 114, 232, 114, 235, 114, 223, 114, 234, 114, 230, 114, 227, 114, 133, 115, 204, 115, 194, 115, 200, 115, 197, 115, 185, 115, 182, 115, 181, 115, 180, 115, 235, 115, 191, 115, 199, 115, 190, 115, 195, 115, 198, 115, 184, 115, 203, 115, 236, 116, 238, 116, 46, 117, 71, 117, 72, 117, 167, 117, 170, 117, 121, 118, 196, 118, 8, 119, 3, 119, 4, 119, 5, 119, 10, 119, 247, 118, 251, 118, 250, 118, 231, 119, 232, 119, 6, 120, 17, 120, 18, 120, 5, 120, 16, 120, 15, 120, 14, 120, 9, 120, 3, 120, 19, 120, 74, 121, 76, 121, 75, 121, 69, 121, 68, 121, 213, 121, 205, 121, 207, 121, 214, 121, 206, 121, 128, 122, 126, 122, 209, 122, 0, 123, 1, 123, 122, 124, 120, 124, 121, 124, 127, 124, 128, 124, 129, 124, 3, 125, 8, 125, 1, 125, 88, 127, 145, 127, 141, 127, 190, 127, 7, 128, 14, 128, 15, 128, 20, 128, 55, 128, 216, 128, 199, 128, 224, 128, 209, 128, 200, 128, 194, 128, 208, 128, 197, 128, 227, 128, 217, 128, 220, 128, 202, 128, 213, 128, 201, 128, 207, 128, 215, 128, 230, 128, 205, 128, 255, 129, 33, 130, 148, 130, 217, 130, 254, 130, 249, 130, 7, 131, 232, 130, 0, 131, 213, 130, 58, 131, 235, 130, 214, 130, 244, 130, 236, 130, 225, 130, 242, 130, 245, 130, 12, 131, 251, 130, 246, 130, 240, 130, 234, 130, 228, 130, 224, 130, 250, 130, 243, 130, 237, 130, 119, 134, 116, 134, 124, 134, 115, 134, 65, 136, 78, 136, 103, 136, 106, 136, 105, 136, 211, 137, 4, 138, 7, 138, 114, 141, 227, 143, 225, 143, 238, 143, 224, 143, 241, 144, 189, 144, 191, 144, 213, 144, 197, 144, 190, 144, 199, 144, 203, 144, 200, 144, 212, 145, 211, 145, 84, 150, 79, 150, 81, 150, 83, 150, 74, 150, 78, 150, 30, 80, 5, 80, 7, 80, 19, 80, 34, 80, 48, 80, 27, 80, 245, 79, 244, 79, 51, 80, 55, 80, 44, 80, 246, 79, 247, 79, 23, 80, 28, 80, 32, 80, 39, 80, 53, 80, 47, 80, 49, 80, 14, 80, 90, 81, 148, 81, 147, 81, 202, 81, 196, 81, 197, 81, 200, 81, 206, 81, 97, 82, 90, 82, 82, 82, 94, 82, 95, 82, 85, 82, 98, 82, 205, 82, 14, 83, 158, 83, 38, 85, 226, 84, 23, 85, 18, 85, 231, 84, 243, 84, 228, 84, 26, 85, 255, 84, 4, 85, 8, 85, 235, 84, 17, 85, 5, 85, 241, 84, 10, 85, 251, 84, 247, 84, 248, 84, 224, 84, 14, 85, 3, 85, 11, 85, 1, 87, 2, 87, 204, 87, 50, 88, 213, 87, 210, 87, 186, 87, 198, 87, 189, 87, 188, 87, 184, 87, 182, 87, 191, 87, 199, 87, 208, 87, 185, 87, 193, 87, 14, 89, 74, 89, 25, 90, 22, 90, 45, 90, 46, 90, 21, 90, 15, 90, 23, 90, 10, 90, 30, 90, 51, 90, 108, 91, 167, 91, 173, 91, 172, 91, 3, 92, 86, 92, 84, 92, 236, 92, 255, 92, 238, 92, 241, 92, 247, 92, 0, 93, 249, 92, 41, 94, 40, 94, 168, 94, 174, 94, 170, 94, 172, 94, 51, 95, 48, 95, 103, 95, 93, 96, 90, 96, 103, 96, 65, 96, 162, 96, 136, 96, 128, 96, 146, 96, 129, 96, 157, 96, 131, 96, 149, 96, 155, 96, 151, 96, 135, 96, 156, 96, 142, 96, 25, 98, 70, 98, 242, 98, 16, 99, 86, 99, 44, 99, 68, 99, 69, 99, 54, 99, 67, 99, 228, 99, 57, 99, 75, 99, 74, 99, 60, 99, 41, 99, 65, 99, 52, 99, 88, 99, 84, 99, 89, 99, 45, 99, 71, 99, 51, 99, 90, 99, 81, 99, 56, 99, 87, 99, 64, 99, 72, 99, 74, 101, 70, 101, 198, 101, 195, 101, 196, 101, 194, 101, 74, 102, 95, 102, 71, 102, 81, 102, 18, 103, 19, 103, 31, 104, 26, 104, 73, 104, 50, 104, 51, 104, 59, 104, 75, 104, 79, 104, 22, 104, 49, 104, 28, 104, 53, 104, 43, 104, 45, 104, 47, 104, 78, 104, 68, 104, 52, 104, 29, 104, 18, 104, 20, 104, 38, 104, 40, 104, 46, 104, 77, 104, 58, 104, 37, 104, 32, 104, 44, 107, 47, 107, 45, 107, 49, 107, 52, 107, 109, 107, 130, 128, 136, 107, 230, 107, 228, 107, 232, 107, 227, 107, 226, 107, 231, 107, 37, 108, 122, 109, 99, 109, 100, 109, 118, 109, 13, 109, 97, 109, 146, 109, 88, 109, 98, 109, 109, 109, 111, 109, 145, 109, 141, 109, 239, 109, 127, 109, 134, 109, 94, 109, 103, 109, 96, 109, 151, 109, 112, 109, 124, 109, 95, 109, 130, 109, 152, 109, 47, 109, 104, 109, 139, 109, 126, 109, 128, 109, 132, 109, 22, 109, 131, 109, 123, 109, 125, 109, 117, 109, 144, 109, 220, 112, 211, 112, 209, 112, 221, 112, 203, 112, 57, 127, 226, 112, 215, 112, 210, 112, 222, 112, 224, 112, 212, 112, 205, 112, 197, 112, 198, 112, 199, 112, 218, 112, 206, 112, 225, 112, 66, 114, 120, 114, 119, 114, 118, 114, 0, 115, 250, 114, 244, 114, 254, 114, 246, 114, 243, 114, 251, 114, 1, 115, 211, 115, 217, 115, 229, 115, 214, 115, 188, 115, 231, 115, 227, 115, 233, 115, 220, 115, 210, 115, 219, 115, 212, 115, 221, 115, 218, 115, 215, 115, 216, 115, 232, 115, 222, 116, 223, 116, 244, 116, 245, 116, 33, 117, 91, 117, 95, 117, 176, 117, 193, 117, 187, 117, 196, 117, 192, 117, 191, 117, 182, 117, 186, 117, 138, 118, 201, 118, 29, 119, 27, 119, 16, 119, 19, 119, 18, 119, 35, 119, 17, 119, 21, 119, 25, 119, 26, 119, 34, 119, 39, 119, 35, 120, 44, 120, 34, 120, 53, 120, 47, 120, 40, 120, 46, 120, 43, 120, 33, 120, 41, 120, 51, 120, 42, 120, 49, 120, 84, 121, 91, 121, 79, 121, 92, 121, 83, 121, 82, 121, 81, 121, 235, 121, 236, 121, 224, 121, 238, 121, 237, 121, 234, 121, 220, 121, 222, 121, 221, 121, 134, 122, 137, 122, 133, 122, 139, 122, 140, 122, 138, 122, 135, 122, 216, 122, 16, 123, 4, 123, 19, 123, 5, 123, 15, 123, 8, 123, 10, 123, 14, 123, 9, 123, 18, 123, 132, 124, 145, 124, 138, 124, 140, 124, 136, 124, 141, 124, 133, 124, 30, 125, 29, 125, 17, 125, 14, 125, 24, 125, 22, 125, 19, 125, 31, 125, 18, 125, 15, 125, 12, 125, 92, 127, 97, 127, 94, 127, 96, 127, 93, 127, 91, 127, 150, 127, 146, 127, 195, 127, 194, 127, 192, 127, 22, 128, 62, 128, 57, 128, 250, 128, 242, 128, 249, 128, 245, 128, 1, 129, 251, 128, 0, 129, 1, 130, 47, 130, 37, 130, 51, 131, 45, 131, 68, 131, 25, 131, 81, 131, 37, 131, 86, 131, 63, 131, 65, 131, 38, 131, 28, 131, 34, 131, 66, 131, 78, 131, 27, 131, 42, 131, 8, 131, 60, 131, 77, 131, 22, 131, 36, 131, 32, 131, 55, 131, 47, 131, 41, 131, 71, 131, 69, 131, 76, 131, 83, 131, 30, 131, 44, 131, 75, 131, 39, 131, 72, 131, 83, 134, 82, 134, 162, 134, 168, 134, 150, 134, 141, 134, 145, 134, 158, 134, 135, 134, 151, 134, 134, 134, 139, 134, 154, 134, 133, 134, 165, 134, 153, 134, 161, 134, 167, 134, 149, 134, 152, 134, 142, 134, 157, 134, 144, 134, 148, 134, 67, 136, 68, 136, 109, 136, 117, 136, 118, 136, 114, 136, 128, 136, 113, 136, 127, 136, 111, 136, 131, 136, 126, 136, 116, 136, 124, 136, 18, 138, 71, 140, 87, 140, 123, 140, 164, 140, 163, 140, 118, 141, 120, 141, 181, 141, 183, 141, 182, 141, 209, 142, 211, 142, 254, 143, 245, 143, 2, 144, 255, 143, 251, 143, 4, 144, 252, 143, 246, 143, 214, 144, 224, 144, 217, 144, 218, 144, 227, 144, 223, 144, 229, 144, 216, 144, 219, 144, 215, 144, 220, 144, 228, 144, 80, 145, 78, 145, 79, 145, 213, 145, 226, 145, 218, 145, 92, 150, 95, 150, 188, 150, 227, 152, 223, 154, 47, 155, 127, 78, 112, 80, 106, 80, 97, 80, 94, 80, 96, 80, 83, 80, 75, 80, 93, 80, 114, 80, 72, 80, 77, 80, 65, 80, 91, 80, 74, 80, 98, 80, 21, 80, 69, 80, 95, 80, 105, 80, 107, 80, 99, 80, 100, 80, 70, 80, 64, 80, 110, 80, 115, 80, 87, 80, 81, 80, 208, 81, 107, 82, 109, 82, 108, 82, 110, 82, 214, 82, 211, 82, 45, 83, 156, 83, 117, 85, 118, 85, 60, 85, 77, 85, 80, 85, 52, 85, 42, 85, 81, 85, 98, 85, 54, 85, 53, 85, 48, 85, 82, 85, 69, 85, 12, 85, 50, 85, 101, 85, 78, 85, 57, 85, 72, 85, 45, 85, 59, 85, 64, 85, 75, 85, 10, 87, 7, 87, 251, 87, 20, 88, 226, 87, 246, 87, 220, 87, 244, 87, 0, 88, 237, 87, 253, 87, 8, 88, 248, 87, 11, 88, 243, 87, 207, 87, 7, 88, 238, 87, 227, 87, 242, 87, 229, 87, 236, 87, 225, 87, 14, 88, 252, 87, 16, 88, 231, 87, 1, 88, 12, 88, 241, 87, 233, 87, 240, 87, 13, 88, 4, 88, 92, 89, 96, 90, 88, 90, 85, 90, 103, 90, 94, 90, 56, 90, 53, 90, 109, 90, 80, 90, 95, 90, 101, 90, 108, 90, 83, 90, 100, 90, 87, 90, 67, 90, 93, 90, 82, 90, 68, 90, 91, 90, 72, 90, 142, 90, 62, 90, 77, 90, 57, 90, 76, 90, 112, 90, 105, 90, 71, 90, 81, 90, 86, 90, 66, 90, 92, 90, 114, 91, 110, 91, 193, 91, 192, 91, 89, 92, 30, 93, 11, 93, 29, 93, 26, 93, 32, 93, 12, 93, 40, 93, 13, 93, 38, 93, 37, 93, 15, 93, 48, 93, 18, 93, 35, 93, 31, 93, 46, 93, 62, 94, 52, 94, 177, 94, 180, 94, 185, 94, 178, 94, 179, 94, 54, 95, 56, 95, 155, 95, 150, 95, 159, 95, 138, 96, 144, 96, 134, 96, 190, 96, 176, 96, 186, 96, 211, 96, 212, 96, 207, 96, 228, 96, 217, 96, 221, 96, 200, 96, 177, 96, 219, 96, 183, 96, 202, 96, 191, 96, 195, 96, 205, 96, 192, 96, 50, 99, 101, 99, 138, 99, 130, 99, 125, 99, 189, 99, 158, 99, 173, 99, 157, 99, 151, 99, 171, 99, 142, 99, 111, 99, 135, 99, 144, 99, 110, 99, 175, 99, 117, 99, 156, 99, 109, 99, 174, 99, 124, 99, 164, 99, 59, 99, 159, 99, 120, 99, 133, 99, 129, 99, 145, 99, 141, 99, 112, 99, 83, 101, 205, 101, 101, 102, 97, 102, 91, 102, 89, 102, 92, 102, 98, 102, 24, 103, 121, 104, 135, 104, 144, 104, 156, 104, 109, 104, 110, 104, 174, 104, 171, 104, 86, 105, 111, 104, 163, 104, 172, 104, 169, 104, 117, 104, 116, 104, 178, 104, 143, 104, 119, 104, 146, 104, 124, 104, 107, 104, 114, 104, 170, 104, 128, 104, 113, 104, 126, 104, 155, 104, 150, 104, 139, 104, 160, 104, 137, 104, 164, 104, 120, 104, 123, 104, 145, 104, 140, 104, 138, 104, 125, 104, 54, 107, 51, 107, 55, 107, 56, 107, 145, 107, 143, 107, 141, 107, 142, 107, 140, 107, 42, 108, 192, 109, 171, 109, 180, 109, 179, 109, 116, 110, 172, 109, 233, 109, 226, 109, 183, 109, 246, 109, 212, 109, 0, 110, 200, 109, 224, 109, 223, 109, 214, 109, 190, 109, 229, 109, 220, 109, 221, 109, 219, 109, 244, 109, 202, 109, 189, 109, 237, 109, 240, 109, 186, 109, 213, 109, 194, 109, 207, 109, 201, 109, 208, 109, 242, 109, 211, 109, 253, 109, 215, 109, 205, 109, 227, 109, 187, 109, 250, 112, 13, 113, 247, 112, 23, 113, 244, 112, 12, 113, 240, 112, 4, 113, 243, 112, 16, 113, 252, 112, 255, 112, 6, 113, 19, 113, 0, 113, 248, 112, 246, 112, 11, 113, 2, 113, 14, 113, 126, 114, 123, 114, 124, 114, 127, 114, 29, 115, 23, 115, 7, 115, 17, 115, 24, 115, 10, 115, 8, 115, 255, 114, 15, 115, 30, 115, 136, 115, 246, 115, 248, 115, 245, 115, 4, 116, 1, 116, 253, 115, 7, 116, 0, 116, 250, 115, 252, 115, 255, 115, 12, 116, 11, 116, 244, 115, 8, 116, 100, 117, 99, 117, 206, 117, 210, 117, 207, 117, 203, 117, 204, 117, 209, 117, 208, 117, 143, 118, 137, 118, 211, 118, 57, 119, 47, 119, 45, 119, 49, 119, 50, 119, 52, 119, 51, 119, 61, 119, 37, 119, 59, 119, 53, 119, 72, 120, 82, 120, 73, 120, 77, 120, 74, 120, 76, 120, 38, 120, 69, 120, 80, 120, 100, 121, 103, 121, 105, 121, 106, 121, 99, 121, 107, 121, 97, 121, 187, 121, 250, 121, 248, 121, 246, 121, 247, 121, 143, 122, 148, 122, 144, 122, 53, 123, 71, 123, 52, 123, 37, 123, 48, 123, 34, 123, 36, 123, 51, 123, 24, 123, 42, 123, 29, 123, 49, 123, 43, 123, 45, 123, 47, 123, 50, 123, 56, 123, 26, 123, 35, 123, 148, 124, 152, 124, 150, 124, 163, 124, 53, 125, 61, 125, 56, 125, 54, 125, 58, 125, 69, 125, 44, 125, 41, 125, 65, 125, 71, 125, 62, 125, 63, 125, 74, 125, 59, 125, 40, 125, 99, 127, 149, 127, 156, 127, 157, 127, 155, 127, 202, 127, 203, 127, 205, 127, 208, 127, 209, 127, 199, 127, 207, 127, 201, 127, 31, 128, 30, 128, 27, 128, 71, 128, 67, 128, 72, 128, 24, 129, 37, 129, 25, 129, 27, 129, 45, 129, 31, 129, 44, 129, 30, 129, 33, 129, 21, 129, 39, 129, 29, 129, 34, 129, 17, 130, 56, 130, 51, 130, 58, 130, 52, 130, 50, 130, 116, 130, 144, 131, 163, 131, 168, 131, 141, 131, 122, 131, 115, 131, 164, 131, 116, 131, 143, 131, 129, 131, 149, 131, 153, 131, 117, 131, 148, 131, 169, 131, 125, 131, 131, 131, 140, 131, 157, 131, 155, 131, 170, 131, 139, 131, 126, 131, 165, 131, 175, 131, 136, 131, 151, 131, 176, 131, 127, 131, 166, 131, 135, 131, 174, 131, 118, 131, 154, 131, 89, 134, 86, 134, 191, 134, 183, 134, 194, 134, 193, 134, 197, 134, 186, 134, 176, 134, 200, 134, 185, 134, 179, 134, 184, 134, 204, 134, 180, 134, 187, 134, 188, 134, 195, 134, 189, 134, 190, 134, 82, 136, 137, 136, 149, 136, 168, 136, 162, 136, 170, 136, 154, 136, 145, 136, 161, 136, 159, 136, 152, 136, 167, 136, 153, 136, 155, 136, 151, 136, 164, 136, 172, 136, 140, 136, 147, 136, 142, 136, 130, 137, 214, 137, 217, 137, 213, 137, 48, 138, 39, 138, 44, 138, 30, 138, 57, 140, 59, 140, 92, 140, 93, 140, 125, 140, 165, 140, 125, 141, 123, 141, 121, 141, 188, 141, 194, 141, 185, 141, 191, 141, 193, 141, 216, 142, 222, 142, 221, 142, 220, 142, 215, 142, 224, 142, 225, 142, 36, 144, 11, 144, 17, 144, 28, 144, 12, 144, 33, 144, 239, 144, 234, 144, 240, 144, 244, 144, 242, 144, 243, 144, 212, 144, 235, 144, 236, 144, 233, 144, 86, 145, 88, 145, 90, 145, 83, 145, 85, 145, 236, 145, 244, 145, 241, 145, 243, 145, 248, 145, 228, 145, 249, 145, 234, 145, 235, 145, 247, 145, 232, 145, 238, 145, 122, 149, 134, 149, 136, 149, 124, 150, 109, 150, 107, 150, 113, 150, 111, 150, 191, 150, 106, 151, 4, 152, 229, 152, 151, 153, 155, 80, 149, 80, 148, 80, 158, 80, 139, 80, 163, 80, 131, 80, 140, 80, 142, 80, 157, 80, 104, 80, 156, 80, 146, 80, 130, 80, 135, 80, 95, 81, 212, 81, 18, 83, 17, 83, 164, 83, 167, 83, 145, 85, 168, 85, 165, 85, 173, 85, 119, 85, 69, 86, 162, 85, 147, 85, 136, 85, 143, 85, 181, 85, 129, 85, 163, 85, 146, 85, 164, 85, 125, 85, 140, 85, 166, 85, 127, 85, 149, 85, 161, 85, 142, 85, 12, 87, 41, 88, 55, 88, 25, 88, 30, 88, 39, 88, 35, 88, 40, 88, 245, 87, 72, 88, 37, 88, 28, 88, 27, 88, 51, 88, 63, 88, 54, 88, 46, 88, 57, 88, 56, 88, 45, 88, 44, 88, 59, 88, 97, 89, 175, 90, 148, 90, 159, 90, 122, 90, 162, 90, 158, 90, 120, 90, 166, 90, 124, 90, 165, 90, 172, 90, 149, 90, 174, 90, 55, 90, 132, 90, 138, 90, 151, 90, 131, 90, 139, 90, 169, 90, 123, 90, 125, 90, 140, 90, 156, 90, 143, 90, 147, 90, 157, 90, 234, 91, 205, 91, 203, 91, 212, 91, 209, 91, 202, 91, 206, 91, 12, 92, 48, 92, 55, 93, 67, 93, 107, 93, 65, 93, 75, 93, 63, 93, 53, 93, 81, 93, 78, 93, 85, 93, 51, 93, 58, 93, 82, 93, 61, 93, 49, 93, 89, 93, 66, 93, 57, 93, 73, 93, 56, 93, 60, 93, 50, 93, 54, 93, 64, 93, 69, 93, 68, 94, 65, 94, 88, 95, 166, 95, 165, 95, 171, 95, 201, 96, 185, 96, 204, 96, 226, 96, 206, 96, 196, 96, 20, 97, 242, 96, 10, 97, 22, 97, 5, 97, 245, 96, 19, 97, 248, 96, 252, 96, 254, 96, 193, 96, 3, 97, 24, 97, 29, 97, 16, 97, 255, 96, 4, 97, 11, 97, 74, 98, 148, 99, 177, 99, 176, 99, 206, 99, 229, 99, 232, 99, 239, 99, 195, 99, 157, 100, 243, 99, 202, 99, 224, 99, 246, 99, 213, 99, 242, 99, 245, 99, 97, 100, 223, 99, 190, 99, 221, 99, 220, 99, 196, 99, 216, 99, 211, 99, 194, 99, 199, 99, 204, 99, 203, 99, 200, 99, 240, 99, 215, 99, 217, 99, 50, 101, 103, 101, 106, 101, 100, 101, 92, 101, 104, 101, 101, 101, 140, 101, 157, 101, 158, 101, 174, 101, 208, 101, 210, 101, 124, 102, 108, 102, 123, 102, 128, 102, 113, 102, 121, 102, 106, 102, 114, 102, 1, 103, 12, 105, 211, 104, 4, 105, 220, 104, 42, 105, 236, 104, 234, 104, 241, 104, 15, 105, 214, 104, 247, 104, 235, 104, 228, 104, 246, 104, 19, 105, 16, 105, 243, 104, 225, 104, 7, 105, 204, 104, 8, 105, 112, 105, 180, 104, 17, 105, 239, 104, 198, 104, 20, 105, 248, 104, 208, 104, 253, 104, 252, 104, 232, 104, 11, 105, 10, 105, 23, 105, 206, 104, 200, 104, 221, 104, 222, 104, 230, 104, 244, 104, 209, 104, 6, 105, 212, 104, 233, 104, 21, 105, 37, 105, 199, 104, 57, 107, 59, 107, 63, 107, 60, 107, 148, 107, 151, 107, 153, 107, 149, 107, 189, 107, 240, 107, 242, 107, 243, 107, 48, 108, 252, 109, 70, 110, 71, 110, 31, 110, 73, 110, 136, 110, 60, 110, 61, 110, 69, 110, 98, 110, 43, 110, 63, 110, 65, 110, 93, 110, 115, 110, 28, 110, 51, 110, 75, 110, 64, 110, 81, 110, 59, 110, 3, 110, 46, 110, 94, 110, 104, 110, 92, 110, 97, 110, 49, 110, 40, 110, 96, 110, 113, 110, 107, 110, 57, 110, 34, 110, 48, 110, 83, 110, 101, 110, 39, 110, 120, 110, 100, 110, 119, 110, 85, 110, 121, 110, 82, 110, 102, 110, 53, 110, 54, 110, 90, 110, 32, 113, 30, 113, 47, 113, 251, 112, 46, 113, 49, 113, 35, 113, 37, 113, 34, 113, 50, 113, 31, 113, 40, 113, 58, 113, 27, 113, 75, 114, 90, 114, 136, 114, 137, 114, 134, 114, 133, 114, 139, 114, 18, 115, 11, 115, 48, 115, 34, 115, 49, 115, 51, 115, 39, 115, 50, 115, 45, 115, 38, 115, 35, 115, 53, 115, 12, 115, 46, 116, 44, 116, 48, 116, 43, 116, 22, 116, 26, 116, 33, 116, 45, 116, 49, 116, 36, 116, 35, 116, 29, 116, 41, 116, 32, 116, 50, 116, 251, 116, 47, 117, 111, 117, 108, 117, 231, 117, 218, 117, 225, 117, 230, 117, 221, 117, 223, 117, 228, 117, 215, 117, 149, 118, 146, 118, 218, 118, 70, 119, 71, 119, 68, 119, 77, 119, 69, 119, 74, 119, 78, 119, 75, 119, 76, 119, 222, 119, 236, 119, 96, 120, 100, 120, 101, 120, 92, 120, 109, 120, 113, 120, 106, 120, 110, 120, 112, 120, 105, 120, 104, 120, 94, 120, 98, 120, 116, 121, 115, 121, 114, 121, 112, 121, 2, 122, 10, 122, 3, 122, 12, 122, 4, 122, 153, 122, 230, 122, 228, 122, 74, 123, 59, 123, 68, 123, 72, 123, 76, 123, 78, 123, 64, 123, 88, 123, 69, 123, 162, 124, 158, 124, 168, 124, 161, 124, 88, 125, 111, 125, 99, 125, 83, 125, 86, 125, 103, 125, 106, 125, 79, 125, 109, 125, 92, 125, 107, 125, 82, 125, 84, 125, 105, 125, 81, 125, 95, 125, 78, 125, 62, 127, 63, 127, 101, 127, 102, 127, 162, 127, 160, 127, 161, 127, 215, 127, 81, 128, 79, 128, 80, 128, 254, 128, 212, 128, 67, 129, 74, 129, 82, 129, 79, 129, 71, 129, 61, 129, 77, 129, 58, 129, 230, 129, 238, 129, 247, 129, 248, 129, 249, 129, 4, 130, 60, 130, 61, 130, 63, 130, 117, 130, 59, 131, 207, 131, 249, 131, 35, 132, 192, 131, 232, 131, 18, 132, 231, 131, 228, 131, 252, 131, 246, 131, 16, 132, 198, 131, 200, 131, 235, 131, 227, 131, 191, 131, 1, 132, 221, 131, 229, 131, 216, 131, 255, 131, 225, 131, 203, 131, 206, 131, 214, 131, 245, 131, 201, 131, 9, 132, 15, 132, 222, 131, 17, 132, 6, 132, 194, 131, 243, 131, 213, 131, 250, 131, 199, 131, 209, 131, 234, 131, 19, 132, 195, 131, 236, 131, 238, 131, 196, 131, 251, 131, 215, 131, 226, 131, 27, 132, 219, 131, 254, 131, 216, 134, 226, 134, 230, 134, 211, 134, 227, 134, 218, 134, 234, 134, 221, 134, 235, 134, 220, 134, 236, 134, 233, 134, 215, 134, 232, 134, 209, 134, 72, 136, 86, 136, 85, 136, 186, 136, 215, 136, 185, 136, 184, 136, 192, 136, 190, 136, 182, 136, 188, 136, 183, 136, 189, 136, 178, 136, 1, 137, 201, 136, 149, 137, 152, 137, 151, 137, 221, 137, 218, 137, 219, 137, 78, 138, 77, 138, 57, 138, 89, 138, 64, 138, 87, 138, 88, 138, 68, 138, 69, 138, 82, 138, 72, 138, 81, 138, 74, 138, 76, 138, 79, 138, 95, 140, 129, 140, 128, 140, 186, 140, 190, 140, 176, 140, 185, 140, 181, 140, 132, 141, 128, 141, 137, 141, 216, 141, 211, 141, 205, 141, 199, 141, 214, 141, 220, 141, 207, 141, 213, 141, 217, 141, 200, 141, 215, 141, 197, 141, 239, 142, 247, 142, 250, 142, 249, 142, 230, 142, 238, 142, 229, 142, 245, 142, 231, 142, 232, 142, 246, 142, 235, 142, 241, 142, 236, 142, 244, 142, 233, 142, 45, 144, 52, 144, 47, 144, 6, 145, 44, 145, 4, 145, 255, 144, 252, 144, 8, 145, 249, 144, 251, 144, 1, 145, 0, 145, 7, 145, 5, 145, 3, 145, 97, 145, 100, 145, 95, 145, 98, 145, 96, 145, 1, 146, 10, 146, 37, 146, 3, 146, 26, 146, 38, 146, 15, 146, 12, 146, 0, 146, 18, 146, 255, 145, 253, 145, 6, 146, 4, 146, 39, 146, 2, 146, 28, 146, 36, 146, 25, 146, 23, 146, 5, 146, 22, 146, 123, 149, 141, 149, 140, 149, 144, 149, 135, 150, 126, 150, 136, 150, 137, 150, 131, 150, 128, 150, 194, 150, 200, 150, 195, 150, 241, 150, 240, 150, 108, 151, 112, 151, 110, 151, 7, 152, 169, 152, 235, 152, 230, 156, 249, 158, 131, 78, 132, 78, 182, 78, 189, 80, 191, 80, 198, 80, 174, 80, 196, 80, 202, 80, 180, 80, 200, 80, 194, 80, 176, 80, 193, 80, 186, 80, 177, 80, 203, 80, 201, 80, 182, 80, 184, 80, 215, 81, 122, 82, 120, 82, 123, 82, 124, 82, 195, 85, 219, 85, 204, 85, 208, 85, 203, 85, 202, 85, 221, 85, 192, 85, 212, 85, 196, 85, 233, 85, 191, 85, 210, 85, 141, 85, 207, 85, 213, 85, 226, 85, 214, 85, 200, 85, 242, 85, 205, 85, 217, 85, 194, 85, 20, 87, 83, 88, 104, 88, 100, 88, 79, 88, 77, 88, 73, 88, 111, 88, 85, 88, 78, 88, 93, 88, 89, 88, 101, 88, 91, 88, 61, 88, 99, 88, 113, 88, 252, 88, 199, 90, 196, 90, 203, 90, 186, 90, 184, 90, 177, 90, 181, 90, 176, 90, 191, 90, 200, 90, 187, 90, 198, 90, 183, 90, 192, 90, 202, 90, 180, 90, 182, 90, 205, 90, 185, 90, 144, 90, 214, 91, 216, 91, 217, 91, 31, 92, 51, 92, 113, 93, 99, 93, 74, 93, 101, 93, 114, 93, 108, 93, 94, 93, 104, 93, 103, 93, 98, 93, 240, 93, 79, 94, 78, 94, 74, 94, 77, 94, 75, 94, 197, 94, 204, 94, 198, 94, 203, 94, 199, 94, 64, 95, 175, 95, 173, 95, 247, 96, 73, 97, 74, 97, 43, 97, 69, 97, 54, 97, 50, 97, 46, 97, 70, 97, 47, 97, 79, 97, 41, 97, 64, 97, 32, 98, 104, 145, 35, 98, 37, 98, 36, 98, 197, 99, 241, 99, 235, 99, 16, 100, 18, 100, 9, 100, 32, 100, 36, 100, 51, 100, 67, 100, 31, 100, 21, 100, 24, 100, 57, 100, 55, 100, 34, 100, 35, 100, 12, 100, 38, 100, 48, 100, 40, 100, 65, 100, 53, 100, 47, 100, 10, 100, 26, 100, 64, 100, 37, 100, 39, 100, 11, 100, 231, 99, 27, 100, 46, 100, 33, 100, 14, 100, 111, 101, 146, 101, 211, 101, 134, 102, 140, 102, 149, 102, 144, 102, 139, 102, 138, 102, 153, 102, 148, 102, 120, 102, 32, 103, 102, 105, 95, 105, 56, 105, 78, 105, 98, 105, 113, 105, 63, 105, 69, 105, 106, 105, 57, 105, 66, 105, 87, 105, 89, 105, 122, 105, 72, 105, 73, 105, 53, 105, 108, 105, 51, 105, 61, 105, 101, 105, 240, 104, 120, 105, 52, 105, 105, 105, 64, 105, 111, 105, 68, 105, 118, 105, 88, 105, 65, 105, 116, 105, 76, 105, 59, 105, 75, 105, 55, 105, 92, 105, 79, 105, 81, 105, 50, 105, 82, 105, 47, 105, 123, 105, 60, 105, 70, 107, 69, 107, 67, 107, 66, 107, 72, 107, 65, 107, 155, 107, 13, 250, 251, 107, 252, 107, 249, 107, 247, 107, 248, 107, 155, 110, 214, 110, 200, 110, 143, 110, 192, 110, 159, 110, 147, 110, 148, 110, 160, 110, 177, 110, 185, 110, 198, 110, 210, 110, 189, 110, 193, 110, 158, 110, 201, 110, 183, 110, 176, 110, 205, 110, 166, 110, 207, 110, 178, 110, 190, 110, 195, 110, 220, 110, 216, 110, 153, 110, 146, 110, 142, 110, 141, 110, 164, 110, 161, 110, 191, 110, 179, 110, 208, 110, 202, 110, 151, 110, 174, 110, 163, 110, 71, 113, 84, 113, 82, 113, 99, 113, 96, 113, 65, 113, 93, 113, 98, 113, 114, 113, 120, 113, 106, 113, 97, 113, 66, 113, 88, 113, 67, 113, 75, 113, 112, 113, 95, 113, 80, 113, 83, 113, 68, 113, 77, 113, 90, 113, 79, 114, 141, 114, 140, 114, 145, 114, 144, 114, 142, 114, 60, 115, 66, 115, 59, 115, 58, 115, 64, 115, 74, 115, 73, 115, 68, 116, 74, 116, 75, 116, 82, 116, 81, 116, 87, 116, 64, 116, 79, 116, 80, 116, 78, 116, 66, 116, 70, 116, 77, 116, 84, 116, 225, 116, 255, 116, 254, 116, 253, 116, 29, 117, 121, 117, 119, 117, 131, 105, 239, 117, 15, 118, 3, 118, 247, 117, 254, 117, 252, 117, 249, 117, 248, 117, 16, 118, 251, 117, 246, 117, 237, 117, 245, 117, 253, 117, 153, 118, 181, 118, 221, 118, 85, 119, 95, 119, 96, 119, 82, 119, 86, 119, 90, 119, 105, 119, 103, 119, 84, 119, 89, 119, 109, 119, 224, 119, 135, 120, 154, 120, 148, 120, 143, 120, 132, 120, 149, 120, 133, 120, 134, 120, 161, 120, 131, 120, 121, 120, 153, 120, 128, 120, 150, 120, 123, 120, 124, 121, 130, 121, 125, 121, 121, 121, 17, 122, 24, 122, 25, 122, 18, 122, 23, 122, 21, 122, 34, 122, 19, 122, 27, 122, 16, 122, 163, 122, 162, 122, 158, 122, 235, 122, 102, 123, 100, 123, 109, 123, 116, 123, 105, 123, 114, 123, 101, 123, 115, 123, 113, 123, 112, 123, 97, 123, 120, 123, 118, 123, 99, 123, 178, 124, 180, 124, 175, 124, 136, 125, 134, 125, 128, 125, 141, 125, 127, 125, 133, 125, 122, 125, 142, 125, 123, 125, 131, 125, 124, 125, 140, 125, 148, 125, 132, 125, 125, 125, 146, 125, 109, 127, 107, 127, 103, 127, 104, 127, 108, 127, 166, 127, 165, 127, 167, 127, 219, 127, 220, 127, 33, 128, 100, 129, 96, 129, 119, 129, 92, 129, 105, 129, 91, 129, 98, 129, 114, 129, 33, 103, 94, 129, 118, 129, 103, 129, 111, 129, 68, 129, 97, 129, 29, 130, 73, 130, 68, 130, 64, 130, 66, 130, 69, 130, 241, 132, 63, 132, 86, 132, 118, 132, 121, 132, 143, 132, 141, 132, 101, 132, 81, 132, 64, 132, 134, 132, 103, 132, 48, 132, 77, 132, 125, 132, 90, 132, 89, 132, 116, 132, 115, 132, 93, 132, 7, 133, 94, 132, 55, 132, 58, 132, 52, 132, 122, 132, 67, 132, 120, 132, 50, 132, 69, 132, 41, 132, 217, 131, 75, 132, 47, 132, 66, 132, 45, 132, 95, 132, 112, 132, 57, 132, 78, 132, 76, 132, 82, 132, 111, 132, 197, 132, 142, 132, 59, 132, 71, 132, 54, 132, 51, 132, 104, 132, 126, 132, 68, 132, 43, 132, 96, 132, 84, 132, 110, 132, 80, 132, 11, 135, 4, 135, 247, 134, 12, 135, 250, 134, 214, 134, 245, 134, 77, 135, 248, 134, 14, 135, 9, 135, 1, 135, 246, 134, 13, 135, 5, 135, 214, 136, 203, 136, 205, 136, 206, 136, 222, 136, 219, 136, 218, 136, 204, 136, 208, 136, 133, 137, 155, 137, 223, 137, 229, 137, 228, 137, 225, 137, 224, 137, 226, 137, 220, 137, 230, 137, 118, 138, 134, 138, 127, 138, 97, 138, 63, 138, 119, 138, 130, 138, 132, 138, 117, 138, 131, 138, 129, 138, 116, 138, 122, 138, 60, 140, 75, 140, 74, 140, 101, 140, 100, 140, 102, 140, 134, 140, 132, 140, 133, 140, 204, 140, 104, 141, 105, 141, 145, 141, 140, 141, 142, 141, 143, 141, 141, 141, 147, 141, 148, 141, 144, 141, 146, 141, 240, 141, 224, 141, 236, 141, 241, 141, 238, 141, 208, 141, 233, 141, 227, 141, 226, 141, 231, 141, 242, 141, 235, 141, 244, 141, 6, 143, 255, 142, 1, 143, 0, 143, 5, 143, 7, 143, 8, 143, 2, 143, 11, 143, 82, 144, 63, 144, 68, 144, 73, 144, 61, 144, 16, 145, 13, 145, 15, 145, 17, 145, 22, 145, 20, 145, 11, 145, 14, 145, 110, 145, 111, 145, 72, 146, 82, 146, 48, 146, 58, 146, 102, 146, 51, 146, 101, 146, 94, 146, 131, 146, 46, 146, 74, 146, 70, 146, 109, 146, 108, 146, 79, 146, 96, 146, 103, 146, 111, 146, 54, 146, 97, 146, 112, 146, 49, 146, 84, 146, 99, 146, 80, 146, 114, 146, 78, 146, 83, 146, 76, 146, 86, 146, 50, 146, 159, 149, 156, 149, 158, 149, 155, 149, 146, 150, 147, 150, 145, 150, 151, 150, 206, 150, 250, 150, 253, 150, 248, 150, 245, 150, 115, 151, 119, 151, 120, 151, 114, 151, 15, 152, 13, 152, 14, 152, 172, 152, 246, 152, 249, 152, 175, 153, 178, 153, 176, 153, 181, 153, 173, 154, 171, 154, 91, 155, 234, 156, 237, 156, 231, 156, 128, 158, 253, 158, 230, 80, 212, 80, 215, 80, 232, 80, 243, 80, 219, 80, 234, 80, 221, 80, 228, 80, 211, 80, 236, 80, 240, 80, 239, 80, 227, 80, 224, 80, 216, 81, 128, 82, 129, 82, 233, 82, 235, 82, 48, 83, 172, 83, 39, 86, 21, 86, 12, 86, 18, 86, 252, 85, 15, 86, 28, 86, 1, 86, 19, 86, 2, 86, 250, 85, 29, 86, 4, 86, 255, 85, 249, 85, 137, 88, 124, 88, 144, 88, 152, 88, 134, 88, 129, 88, 127, 88, 116, 88, 139, 88, 122, 88, 135, 88, 145, 88, 142, 88, 118, 88, 130, 88, 136, 88, 123, 88, 148, 88, 143, 88, 254, 88, 107, 89, 220, 90, 238, 90, 229, 90, 213, 90, 234, 90, 218, 90, 237, 90, 235, 90, 243, 90, 226, 90, 224, 90, 219, 90, 236, 90, 222, 90, 221, 90, 217, 90, 232, 90, 223, 90, 119, 91, 224, 91, 227, 91, 99, 92, 130, 93, 128, 93, 125, 93, 134, 93, 122, 93, 129, 93, 119, 93, 138, 93, 137, 93, 136, 93, 126, 93, 124, 93, 141, 93, 121, 93, 127, 93, 88, 94, 89, 94, 83, 94, 216, 94, 209, 94, 215, 94, 206, 94, 220, 94, 213, 94, 217, 94, 210, 94, 212, 94, 68, 95, 67, 95, 111, 95, 182, 95, 44, 97, 40, 97, 65, 97, 94, 97, 113, 97, 115, 97, 82, 97, 83, 97, 114, 97, 108, 97, 128, 97, 116, 97, 84, 97, 122, 97, 91, 97, 101, 97, 59, 97, 106, 97, 97, 97, 86, 97, 41, 98, 39, 98, 43, 98, 43, 100, 77, 100, 91, 100, 93, 100, 116, 100, 118, 100, 114, 100, 115, 100, 125, 100, 117, 100, 102, 100, 166, 100, 78, 100, 130, 100, 94, 100, 92, 100, 75, 100, 83, 100, 96, 100, 80, 100, 127, 100, 63, 100, 108, 100, 107, 100, 89, 100, 101, 100, 119, 100, 115, 101, 160, 101, 161, 102, 160, 102, 159, 102, 5, 103, 4, 103, 34, 103, 177, 105, 182, 105, 201, 105, 160, 105, 206, 105, 150, 105, 176, 105, 172, 105, 188, 105, 145, 105, 153, 105, 142, 105, 167, 105, 141, 105, 169, 105, 190, 105, 175, 105, 191, 105, 196, 105, 189, 105, 164, 105, 212, 105, 185, 105, 202, 105, 154, 105, 207, 105, 179, 105, 147, 105, 170, 105, 161, 105, 158, 105, 217, 105, 151, 105, 144, 105, 194, 105, 181, 105, 165, 105, 198, 105, 74, 107, 77, 107, 75, 107, 158, 107, 159, 107, 160, 107, 195, 107, 196, 107, 254, 107, 206, 110, 245, 110, 241, 110, 3, 111, 37, 111, 248, 110, 55, 111, 251, 110, 46, 111, 9, 111, 78, 111, 25, 111, 26, 111, 39, 111, 24, 111, 59, 111, 18, 111, 237, 110, 10, 111, 54, 111, 115, 111, 249, 110, 238, 110, 45, 111, 64, 111, 48, 111, 60, 111, 53, 111, 235, 110, 7, 111, 14, 111, 67, 111, 5, 111, 253, 110, 246, 110, 57, 111, 28, 111, 252, 110, 58, 111, 31, 111, 13, 111, 30, 111, 8, 111, 33, 111, 135, 113, 144, 113, 137, 113, 128, 113, 133, 113, 130, 113, 143, 113, 123, 113, 134, 113, 129, 113, 151, 113, 68, 114, 83, 114, 151, 114, 149, 114, 147, 114, 67, 115, 77, 115, 81, 115, 76, 115, 98, 116, 115, 116, 113, 116, 117, 116, 114, 116, 103, 116, 110, 116, 0, 117, 2, 117, 3, 117, 125, 117, 144, 117, 22, 118, 8, 118, 12, 118, 21, 118, 17, 118, 10, 118, 20, 118, 184, 118, 129, 119, 124, 119, 133, 119, 130, 119, 110, 119, 128, 119, 111, 119, 126, 119, 131, 119, 178, 120, 170, 120, 180, 120, 173, 120, 168, 120, 126, 120, 171, 120, 158, 120, 165, 120, 160, 120, 172, 120, 162, 120, 164, 120, 152, 121, 138, 121, 139, 121, 150, 121, 149, 121, 148, 121, 147, 121, 151, 121, 136, 121, 146, 121, 144, 121, 43, 122, 74, 122, 48, 122, 47, 122, 40, 122, 38, 122, 168, 122, 171, 122, 172, 122, 238, 122, 136, 123, 156, 123, 138, 123, 145, 123, 144, 123, 150, 123, 141, 123, 140, 123, 155, 123, 142, 123, 133, 123, 152, 123, 132, 82, 153, 123, 164, 123, 130, 123, 187, 124, 191, 124, 188, 124, 186, 124, 167, 125, 183, 125, 194, 125, 163, 125, 170, 125, 193, 125, 192, 125, 197, 125, 157, 125, 206, 125, 196, 125, 198, 125, 203, 125, 204, 125, 175, 125, 185, 125, 150, 125, 188, 125, 159, 125, 166, 125, 174, 125, 169, 125, 161, 125, 201, 125, 115, 127, 226, 127, 227, 127, 229, 127, 222, 127, 36, 128, 93, 128, 92, 128, 137, 129, 134, 129, 131, 129, 135, 129, 141, 129, 140, 129, 139, 129, 21, 130, 151, 132, 164, 132, 161, 132, 159, 132, 186, 132, 206, 132, 194, 132, 172, 132, 174, 132, 171, 132, 185, 132, 180, 132, 193, 132, 205, 132, 170, 132, 154, 132, 177, 132, 208, 132, 157, 132, 167, 132, 187, 132, 162, 132, 148, 132, 199, 132, 204, 132, 155, 132, 169, 132, 175, 132, 168, 132, 214, 132, 152, 132, 182, 132, 207, 132, 160, 132, 215, 132, 212, 132, 210, 132, 219, 132, 176, 132, 145, 132, 97, 134, 51, 135, 35, 135, 40, 135, 107, 135, 64, 135], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 292068);
	        allocate([46, 135, 30, 135, 33, 135, 25, 135, 27, 135, 67, 135, 44, 135, 65, 135, 62, 135, 70, 135, 32, 135, 50, 135, 42, 135, 45, 135, 60, 135, 18, 135, 58, 135, 49, 135, 53, 135, 66, 135, 38, 135, 39, 135, 56, 135, 36, 135, 26, 135, 48, 135, 17, 135, 247, 136, 231, 136, 241, 136, 242, 136, 250, 136, 254, 136, 238, 136, 252, 136, 246, 136, 251, 136, 240, 136, 236, 136, 235, 136, 157, 137, 161, 137, 159, 137, 158, 137, 233, 137, 235, 137, 232, 137, 171, 138, 153, 138, 139, 138, 146, 138, 143, 138, 150, 138, 61, 140, 104, 140, 105, 140, 213, 140, 207, 140, 215, 140, 150, 141, 9, 142, 2, 142, 255, 141, 13, 142, 253, 141, 10, 142, 3, 142, 7, 142, 6, 142, 5, 142, 254, 141, 0, 142, 4, 142, 16, 143, 17, 143, 14, 143, 13, 143, 35, 145, 28, 145, 32, 145, 34, 145, 31, 145, 29, 145, 26, 145, 36, 145, 33, 145, 27, 145, 122, 145, 114, 145, 121, 145, 115, 145, 165, 146, 164, 146, 118, 146, 155, 146, 122, 146, 160, 146, 148, 146, 170, 146, 141, 146, 166, 146, 154, 146, 171, 146, 121, 146, 151, 146, 127, 146, 163, 146, 238, 146, 142, 146, 130, 146, 149, 146, 162, 146, 125, 146, 136, 146, 161, 146, 138, 146, 134, 146, 140, 146, 153, 146, 167, 146, 126, 146, 135, 146, 169, 146, 157, 146, 139, 146, 45, 146, 158, 150, 161, 150, 255, 150, 88, 151, 125, 151, 122, 151, 126, 151, 131, 151, 128, 151, 130, 151, 123, 151, 132, 151, 129, 151, 127, 151, 206, 151, 205, 151, 22, 152, 173, 152, 174, 152, 2, 153, 0, 153, 7, 153, 157, 153, 156, 153, 195, 153, 185, 153, 187, 153, 186, 153, 194, 153, 189, 153, 199, 153, 177, 154, 227, 154, 231, 154, 62, 155, 63, 155, 96, 155, 97, 155, 95, 155, 241, 156, 242, 156, 245, 156, 167, 158, 255, 80, 3, 81, 48, 81, 248, 80, 6, 81, 7, 81, 246, 80, 254, 80, 11, 81, 12, 81, 253, 80, 10, 81, 139, 82, 140, 82, 241, 82, 239, 82, 72, 86, 66, 86, 76, 86, 53, 86, 65, 86, 74, 86, 73, 86, 70, 86, 88, 86, 90, 86, 64, 86, 51, 86, 61, 86, 44, 86, 62, 86, 56, 86, 42, 86, 58, 86, 26, 87, 171, 88, 157, 88, 177, 88, 160, 88, 163, 88, 175, 88, 172, 88, 165, 88, 161, 88, 255, 88, 255, 90, 244, 90, 253, 90, 247, 90, 246, 90, 3, 91, 248, 90, 2, 91, 249, 90, 1, 91, 7, 91, 5, 91, 15, 91, 103, 92, 153, 93, 151, 93, 159, 93, 146, 93, 162, 93, 147, 93, 149, 93, 160, 93, 156, 93, 161, 93, 154, 93, 158, 93, 105, 94, 93, 94, 96, 94, 92, 94, 243, 125, 219, 94, 222, 94, 225, 94, 73, 95, 178, 95, 139, 97, 131, 97, 121, 97, 177, 97, 176, 97, 162, 97, 137, 97, 155, 97, 147, 97, 175, 97, 173, 97, 159, 97, 146, 97, 170, 97, 161, 97, 141, 97, 102, 97, 179, 97, 45, 98, 110, 100, 112, 100, 150, 100, 160, 100, 133, 100, 151, 100, 156, 100, 143, 100, 139, 100, 138, 100, 140, 100, 163, 100, 159, 100, 104, 100, 177, 100, 152, 100, 118, 101, 122, 101, 121, 101, 123, 101, 178, 101, 179, 101, 181, 102, 176, 102, 169, 102, 178, 102, 183, 102, 170, 102, 175, 102, 0, 106, 6, 106, 23, 106, 229, 105, 248, 105, 21, 106, 241, 105, 228, 105, 32, 106, 255, 105, 236, 105, 226, 105, 27, 106, 29, 106, 254, 105, 39, 106, 242, 105, 238, 105, 20, 106, 247, 105, 231, 105, 64, 106, 8, 106, 230, 105, 251, 105, 13, 106, 252, 105, 235, 105, 9, 106, 4, 106, 24, 106, 37, 106, 15, 106, 246, 105, 38, 106, 7, 106, 244, 105, 22, 106, 81, 107, 165, 107, 163, 107, 162, 107, 166, 107, 1, 108, 0, 108, 255, 107, 2, 108, 65, 111, 38, 111, 126, 111, 135, 111, 198, 111, 146, 111, 141, 111, 137, 111, 140, 111, 98, 111, 79, 111, 133, 111, 90, 111, 150, 111, 118, 111, 108, 111, 130, 111, 85, 111, 114, 111, 82, 111, 80, 111, 87, 111, 148, 111, 147, 111, 93, 111, 0, 111, 97, 111, 107, 111, 125, 111, 103, 111, 144, 111, 83, 111, 139, 111, 105, 111, 127, 111, 149, 111, 99, 111, 119, 111, 106, 111, 123, 111, 178, 113, 175, 113, 155, 113, 176, 113, 160, 113, 154, 113, 169, 113, 181, 113, 157, 113, 165, 113, 158, 113, 164, 113, 161, 113, 170, 113, 156, 113, 167, 113, 179, 113, 152, 114, 154, 114, 88, 115, 82, 115, 94, 115, 95, 115, 96, 115, 93, 115, 91, 115, 97, 115, 90, 115, 89, 115, 98, 115, 135, 116, 137, 116, 138, 116, 134, 116, 129, 116, 125, 116, 133, 116, 136, 116, 124, 116, 121, 116, 8, 117, 7, 117, 126, 117, 37, 118, 30, 118, 25, 118, 29, 118, 28, 118, 35, 118, 26, 118, 40, 118, 27, 118, 156, 118, 157, 118, 158, 118, 155, 118, 141, 119, 143, 119, 137, 119, 136, 119, 205, 120, 187, 120, 207, 120, 204, 120, 209, 120, 206, 120, 212, 120, 200, 120, 195, 120, 196, 120, 201, 120, 154, 121, 161, 121, 160, 121, 156, 121, 162, 121, 155, 121, 118, 107, 57, 122, 178, 122, 180, 122, 179, 122, 183, 123, 203, 123, 190, 123, 172, 123, 206, 123, 175, 123, 185, 123, 202, 123, 181, 123, 197, 124, 200, 124, 204, 124, 203, 124, 247, 125, 219, 125, 234, 125, 231, 125, 215, 125, 225, 125, 3, 126, 250, 125, 230, 125, 246, 125, 241, 125, 240, 125, 238, 125, 223, 125, 118, 127, 172, 127, 176, 127, 173, 127, 237, 127, 235, 127, 234, 127, 236, 127, 230, 127, 232, 127, 100, 128, 103, 128, 163, 129, 159, 129, 158, 129, 149, 129, 162, 129, 153, 129, 151, 129, 22, 130, 79, 130, 83, 130, 82, 130, 80, 130, 78, 130, 81, 130, 36, 133, 59, 133, 15, 133, 0, 133, 41, 133, 14, 133, 9, 133, 13, 133, 31, 133, 10, 133, 39, 133, 28, 133, 251, 132, 43, 133, 250, 132, 8, 133, 12, 133, 244, 132, 42, 133, 242, 132, 21, 133, 247, 132, 235, 132, 243, 132, 252, 132, 18, 133, 234, 132, 233, 132, 22, 133, 254, 132, 40, 133, 29, 133, 46, 133, 2, 133, 253, 132, 30, 133, 246, 132, 49, 133, 38, 133, 231, 132, 232, 132, 240, 132, 239, 132, 249, 132, 24, 133, 32, 133, 48, 133, 11, 133, 25, 133, 47, 133, 98, 134, 86, 135, 99, 135, 100, 135, 119, 135, 225, 135, 115, 135, 88, 135, 84, 135, 91, 135, 82, 135, 97, 135, 90, 135, 81, 135, 94, 135, 109, 135, 106, 135, 80, 135, 78, 135, 95, 135, 93, 135, 111, 135, 108, 135, 122, 135, 110, 135, 92, 135, 101, 135, 79, 135, 123, 135, 117, 135, 98, 135, 103, 135, 105, 135, 90, 136, 5, 137, 12, 137, 20, 137, 11, 137, 23, 137, 24, 137, 25, 137, 6, 137, 22, 137, 17, 137, 14, 137, 9, 137, 162, 137, 164, 137, 163, 137, 237, 137, 240, 137, 236, 137, 207, 138, 198, 138, 184, 138, 211, 138, 209, 138, 212, 138, 213, 138, 187, 138, 215, 138, 190, 138, 192, 138, 197, 138, 216, 138, 195, 138, 186, 138, 189, 138, 217, 138, 62, 140, 77, 140, 143, 140, 229, 140, 223, 140, 217, 140, 232, 140, 218, 140, 221, 140, 231, 140, 160, 141, 156, 141, 161, 141, 155, 141, 32, 142, 35, 142, 37, 142, 36, 142, 46, 142, 21, 142, 27, 142, 22, 142, 17, 142, 25, 142, 38, 142, 39, 142, 20, 142, 18, 142, 24, 142, 19, 142, 28, 142, 23, 142, 26, 142, 44, 143, 36, 143, 24, 143, 26, 143, 32, 143, 35, 143, 22, 143, 23, 143, 115, 144, 112, 144, 111, 144, 103, 144, 107, 144, 47, 145, 43, 145, 41, 145, 42, 145, 50, 145, 38, 145, 46, 145, 133, 145, 134, 145, 138, 145, 129, 145, 130, 145, 132, 145, 128, 145, 208, 146, 195, 146, 196, 146, 192, 146, 217, 146, 182, 146, 207, 146, 241, 146, 223, 146, 216, 146, 233, 146, 215, 146, 221, 146, 204, 146, 239, 146, 194, 146, 232, 146, 202, 146, 200, 146, 206, 146, 230, 146, 205, 146, 213, 146, 201, 146, 224, 146, 222, 146, 231, 146, 209, 146, 211, 146, 181, 146, 225, 146, 198, 146, 180, 146, 124, 149, 172, 149, 171, 149, 174, 149, 176, 149, 164, 150, 162, 150, 211, 150, 5, 151, 8, 151, 2, 151, 90, 151, 138, 151, 142, 151, 136, 151, 208, 151, 207, 151, 30, 152, 29, 152, 38, 152, 41, 152, 40, 152, 32, 152, 27, 152, 39, 152, 178, 152, 8, 153, 250, 152, 17, 153, 20, 153, 22, 153, 23, 153, 21, 153, 220, 153, 205, 153, 207, 153, 211, 153, 212, 153, 206, 153, 201, 153, 214, 153, 216, 153, 203, 153, 215, 153, 204, 153, 179, 154, 236, 154, 235, 154, 243, 154, 242, 154, 241, 154, 70, 155, 67, 155, 103, 155, 116, 155, 113, 155, 102, 155, 118, 155, 117, 155, 112, 155, 104, 155, 100, 155, 108, 155, 252, 156, 250, 156, 253, 156, 255, 156, 247, 156, 7, 157, 0, 157, 249, 156, 251, 156, 8, 157, 5, 157, 4, 157, 131, 158, 211, 158, 15, 159, 16, 159, 28, 81, 19, 81, 23, 81, 26, 81, 17, 81, 222, 81, 52, 83, 225, 83, 112, 86, 96, 86, 110, 86, 115, 86, 102, 86, 99, 86, 109, 86, 114, 86, 94, 86, 119, 86, 28, 87, 27, 87, 200, 88, 189, 88, 201, 88, 191, 88, 186, 88, 194, 88, 188, 88, 198, 88, 23, 91, 25, 91, 27, 91, 33, 91, 20, 91, 19, 91, 16, 91, 22, 91, 40, 91, 26, 91, 32, 91, 30, 91, 239, 91, 172, 93, 177, 93, 169, 93, 167, 93, 181, 93, 176, 93, 174, 93, 170, 93, 168, 93, 178, 93, 173, 93, 175, 93, 180, 93, 103, 94, 104, 94, 102, 94, 111, 94, 233, 94, 231, 94, 230, 94, 232, 94, 229, 94, 75, 95, 188, 95, 157, 97, 168, 97, 150, 97, 197, 97, 180, 97, 198, 97, 193, 97, 204, 97, 186, 97, 191, 97, 184, 97, 140, 97, 215, 100, 214, 100, 208, 100, 207, 100, 201, 100, 189, 100, 137, 100, 195, 100, 219, 100, 243, 100, 217, 100, 51, 101, 127, 101, 124, 101, 162, 101, 200, 102, 190, 102, 192, 102, 202, 102, 203, 102, 207, 102, 189, 102, 187, 102, 186, 102, 204, 102, 35, 103, 52, 106, 102, 106, 73, 106, 103, 106, 50, 106, 104, 106, 62, 106, 93, 106, 109, 106, 118, 106, 91, 106, 81, 106, 40, 106, 90, 106, 59, 106, 63, 106, 65, 106, 106, 106, 100, 106, 80, 106, 79, 106, 84, 106, 111, 106, 105, 106, 96, 106, 60, 106, 94, 106, 86, 106, 85, 106, 77, 106, 78, 106, 70, 106, 85, 107, 84, 107, 86, 107, 167, 107, 170, 107, 171, 107, 200, 107, 199, 107, 4, 108, 3, 108, 6, 108, 173, 111, 203, 111, 163, 111, 199, 111, 188, 111, 206, 111, 200, 111, 94, 111, 196, 111, 189, 111, 158, 111, 202, 111, 168, 111, 4, 112, 165, 111, 174, 111, 186, 111, 172, 111, 170, 111, 207, 111, 191, 111, 184, 111, 162, 111, 201, 111, 171, 111, 205, 111, 175, 111, 178, 111, 176, 111, 197, 113, 194, 113, 191, 113, 184, 113, 214, 113, 192, 113, 193, 113, 203, 113, 212, 113, 202, 113, 199, 113, 207, 113, 189, 113, 216, 113, 188, 113, 198, 113, 218, 113, 219, 113, 157, 114, 158, 114, 105, 115, 102, 115, 103, 115, 108, 115, 101, 115, 107, 115, 106, 115, 127, 116, 154, 116, 160, 116, 148, 116, 146, 116, 149, 116, 161, 116, 11, 117, 128, 117, 47, 118, 45, 118, 49, 118, 61, 118, 51, 118, 60, 118, 53, 118, 50, 118, 48, 118, 187, 118, 230, 118, 154, 119, 157, 119, 161, 119, 156, 119, 155, 119, 162, 119, 163, 119, 149, 119, 153, 119, 151, 119, 221, 120, 233, 120, 229, 120, 234, 120, 222, 120, 227, 120, 219, 120, 225, 120, 226, 120, 237, 120, 223, 120, 224, 120, 164, 121, 68, 122, 72, 122, 71, 122, 182, 122, 184, 122, 181, 122, 177, 122, 183, 122, 222, 123, 227, 123, 231, 123, 221, 123, 213, 123, 229, 123, 218, 123, 232, 123, 249, 123, 212, 123, 234, 123, 226, 123, 220, 123, 235, 123, 216, 123, 223, 123, 210, 124, 212, 124, 215, 124, 208, 124, 209, 124, 18, 126, 33, 126, 23, 126, 12, 126, 31, 126, 32, 126, 19, 126, 14, 126, 28, 126, 21, 126, 26, 126, 34, 126, 11, 126, 15, 126, 22, 126, 13, 126, 20, 126, 37, 126, 36, 126, 67, 127, 123, 127, 124, 127, 122, 127, 177, 127, 239, 127, 42, 128, 41, 128, 108, 128, 177, 129, 166, 129, 174, 129, 185, 129, 181, 129, 171, 129, 176, 129, 172, 129, 180, 129, 178, 129, 183, 129, 167, 129, 242, 129, 85, 130, 86, 130, 87, 130, 86, 133, 69, 133, 107, 133, 77, 133, 83, 133, 97, 133, 88, 133, 64, 133, 70, 133, 100, 133, 65, 133, 98, 133, 68, 133, 81, 133, 71, 133, 99, 133, 62, 133, 91, 133, 113, 133, 78, 133, 110, 133, 117, 133, 85, 133, 103, 133, 96, 133, 140, 133, 102, 133, 93, 133, 84, 133, 101, 133, 108, 133, 99, 134, 101, 134, 100, 134, 155, 135, 143, 135, 151, 135, 147, 135, 146, 135, 136, 135, 129, 135, 150, 135, 152, 135, 121, 135, 135, 135, 163, 135, 133, 135, 144, 135, 145, 135, 157, 135, 132, 135, 148, 135, 156, 135, 154, 135, 137, 135, 30, 137, 38, 137, 48, 137, 45, 137, 46, 137, 39, 137, 49, 137, 34, 137, 41, 137, 35, 137, 47, 137, 44, 137, 31, 137, 241, 137, 224, 138, 226, 138, 242, 138, 244, 138, 245, 138, 221, 138, 20, 139, 228, 138, 223, 138, 240, 138, 200, 138, 222, 138, 225, 138, 232, 138, 255, 138, 239, 138, 251, 138, 145, 140, 146, 140, 144, 140, 245, 140, 238, 140, 241, 140, 240, 140, 243, 140, 108, 141, 110, 141, 165, 141, 167, 141, 51, 142, 62, 142, 56, 142, 64, 142, 69, 142, 54, 142, 60, 142, 61, 142, 65, 142, 48, 142, 63, 142, 189, 142, 54, 143, 46, 143, 53, 143, 50, 143, 57, 143, 55, 143, 52, 143, 118, 144, 121, 144, 123, 144, 134, 144, 250, 144, 51, 145, 53, 145, 54, 145, 147, 145, 144, 145, 145, 145, 141, 145, 143, 145, 39, 147, 30, 147, 8, 147, 31, 147, 6, 147, 15, 147, 122, 147, 56, 147, 60, 147, 27, 147, 35, 147, 18, 147, 1, 147, 70, 147, 45, 147, 14, 147, 13, 147, 203, 146, 29, 147, 250, 146, 37, 147, 19, 147, 249, 146, 247, 146, 52, 147, 2, 147, 36, 147, 255, 146, 41, 147, 57, 147, 53, 147, 42, 147, 20, 147, 12, 147, 11, 147, 254, 146, 9, 147, 0, 147, 251, 146, 22, 147, 188, 149, 205, 149, 190, 149, 185, 149, 186, 149, 182, 149, 191, 149, 181, 149, 189, 149, 169, 150, 212, 150, 11, 151, 18, 151, 16, 151, 153, 151, 151, 151, 148, 151, 240, 151, 248, 151, 53, 152, 47, 152, 50, 152, 36, 153, 31, 153, 39, 153, 41, 153, 158, 153, 238, 153, 236, 153, 229, 153, 228, 153, 240, 153, 227, 153, 234, 153, 233, 153, 231, 153, 185, 154, 191, 154, 180, 154, 187, 154, 246, 154, 250, 154, 249, 154, 247, 154, 51, 155, 128, 155, 133, 155, 135, 155, 124, 155, 126, 155, 123, 155, 130, 155, 147, 155, 146, 155, 144, 155, 122, 155, 149, 155, 125, 155, 136, 155, 37, 157, 23, 157, 32, 157, 30, 157, 20, 157, 41, 157, 29, 157, 24, 157, 34, 157, 16, 157, 25, 157, 31, 157, 136, 158, 134, 158, 135, 158, 174, 158, 173, 158, 213, 158, 214, 158, 250, 158, 18, 159, 61, 159, 38, 81, 37, 81, 34, 81, 36, 81, 32, 81, 41, 81, 244, 82, 147, 86, 140, 86, 141, 86, 134, 86, 132, 86, 131, 86, 126, 86, 130, 86, 127, 86, 129, 86, 214, 88, 212, 88, 207, 88, 210, 88, 45, 91, 37, 91, 50, 91, 35, 91, 44, 91, 39, 91, 38, 91, 47, 91, 46, 91, 123, 91, 241, 91, 242, 91, 183, 93, 108, 94, 106, 94, 190, 95, 187, 95, 195, 97, 181, 97, 188, 97, 231, 97, 224, 97, 229, 97, 228, 97, 232, 97, 222, 97, 239, 100, 233, 100, 227, 100, 235, 100, 228, 100, 232, 100, 129, 101, 128, 101, 182, 101, 218, 101, 210, 102, 141, 106, 150, 106, 129, 106, 165, 106, 137, 106, 159, 106, 155, 106, 161, 106, 158, 106, 135, 106, 147, 106, 142, 106, 149, 106, 131, 106, 168, 106, 164, 106, 145, 106, 127, 106, 166, 106, 154, 106, 133, 106, 140, 106, 146, 106, 91, 107, 173, 107, 9, 108, 204, 111, 169, 111, 244, 111, 212, 111, 227, 111, 220, 111, 237, 111, 231, 111, 230, 111, 222, 111, 242, 111, 221, 111, 226, 111, 232, 111, 225, 113, 241, 113, 232, 113, 242, 113, 228, 113, 240, 113, 226, 113, 115, 115, 110, 115, 111, 115, 151, 116, 178, 116, 171, 116, 144, 116, 170, 116, 173, 116, 177, 116, 165, 116, 175, 116, 16, 117, 17, 117, 18, 117, 15, 117, 132, 117, 67, 118, 72, 118, 73, 118, 71, 118, 164, 118, 233, 118, 181, 119, 171, 119, 178, 119, 183, 119, 182, 119, 180, 119, 177, 119, 168, 119, 240, 119, 243, 120, 253, 120, 2, 121, 251, 120, 252, 120, 242, 120, 5, 121, 249, 120, 254, 120, 4, 121, 171, 121, 168, 121, 92, 122, 91, 122, 86, 122, 88, 122, 84, 122, 90, 122, 190, 122, 192, 122, 193, 122, 5, 124, 15, 124, 242, 123, 0, 124, 255, 123, 251, 123, 14, 124, 244, 123, 11, 124, 243, 123, 2, 124, 9, 124, 3, 124, 1, 124, 248, 123, 253, 123, 6, 124, 240, 123, 241, 123, 16, 124, 10, 124, 232, 124, 45, 126, 60, 126, 66, 126, 51, 126, 72, 152, 56, 126, 42, 126, 73, 126, 64, 126, 71, 126, 41, 126, 76, 126, 48, 126, 59, 126, 54, 126, 68, 126, 58, 126, 69, 127, 127, 127, 126, 127, 125, 127, 244, 127, 242, 127, 44, 128, 187, 129, 196, 129, 204, 129, 202, 129, 197, 129, 199, 129, 188, 129, 233, 129, 91, 130, 90, 130, 92, 130, 131, 133, 128, 133, 143, 133, 167, 133, 149, 133, 160, 133, 139, 133, 163, 133, 123, 133, 164, 133, 154, 133, 158, 133, 119, 133, 124, 133, 137, 133, 161, 133, 122, 133, 120, 133, 87, 133, 142, 133, 150, 133, 134, 133, 141, 133, 153, 133, 157, 133, 129, 133, 162, 133, 130, 133, 136, 133, 133, 133, 121, 133, 118, 133, 152, 133, 144, 133, 159, 133, 104, 134, 190, 135, 170, 135, 173, 135, 197, 135, 176, 135, 172, 135, 185, 135, 181, 135, 188, 135, 174, 135, 201, 135, 195, 135, 194, 135, 204, 135, 183, 135, 175, 135, 196, 135, 202, 135, 180, 135, 182, 135, 191, 135, 184, 135, 189, 135, 222, 135, 178, 135, 53, 137, 51, 137, 60, 137, 62, 137, 65, 137, 82, 137, 55, 137, 66, 137, 173, 137, 175, 137, 174, 137, 242, 137, 243, 137, 30, 139, 24, 139, 22, 139, 17, 139, 5, 139, 11, 139, 34, 139, 15, 139, 18, 139, 21, 139, 7, 139, 13, 139, 8, 139, 6, 139, 28, 139, 19, 139, 26, 139, 79, 140, 112, 140, 114, 140, 113, 140, 111, 140, 149, 140, 148, 140, 249, 140, 111, 141, 78, 142, 77, 142, 83, 142, 80, 142, 76, 142, 71, 142, 67, 143, 64, 143, 133, 144, 126, 144, 56, 145, 154, 145, 162, 145, 155, 145, 153, 145, 159, 145, 161, 145, 157, 145, 160, 145, 161, 147, 131, 147, 175, 147, 100, 147, 86, 147, 71, 147, 124, 147, 88, 147, 92, 147, 118, 147, 73, 147, 80, 147, 81, 147, 96, 147, 109, 147, 143, 147, 76, 147, 106, 147, 121, 147, 87, 147, 85, 147, 82, 147, 79, 147, 113, 147, 119, 147, 123, 147, 97, 147, 94, 147, 99, 147, 103, 147, 128, 147, 78, 147, 89, 147, 199, 149, 192, 149, 201, 149, 195, 149, 197, 149, 183, 149, 174, 150, 176, 150, 172, 150, 32, 151, 31, 151, 24, 151, 29, 151, 25, 151, 154, 151, 161, 151, 156, 151, 158, 151, 157, 151, 213, 151, 212, 151, 241, 151, 65, 152, 68, 152, 74, 152, 73, 152, 69, 152, 67, 152, 37, 153, 43, 153, 44, 153, 42, 153, 51, 153, 50, 153, 47, 153, 45, 153, 49, 153, 48, 153, 152, 153, 163, 153, 161, 153, 2, 154, 250, 153, 244, 153, 247, 153, 249, 153, 248, 153, 246, 153, 251, 153, 253, 153, 254, 153, 252, 153, 3, 154, 190, 154, 254, 154, 253, 154, 1, 155, 252, 154, 72, 155, 154, 155, 168, 155, 158, 155, 155, 155, 166, 155, 161, 155, 165, 155, 164, 155, 134, 155, 162, 155, 160, 155, 175, 155, 51, 157, 65, 157, 103, 157, 54, 157, 46, 157, 47, 157, 49, 157, 56, 157, 48, 157, 69, 157, 66, 157, 67, 157, 62, 157, 55, 157, 64, 157, 61, 157, 245, 127, 45, 157, 138, 158, 137, 158, 141, 158, 176, 158, 200, 158, 218, 158, 251, 158, 255, 158, 36, 159, 35, 159, 34, 159, 84, 159, 160, 159, 49, 81, 45, 81, 46, 81, 152, 86, 156, 86, 151, 86, 154, 86, 157, 86, 153, 86, 112, 89, 60, 91, 105, 92, 106, 92, 192, 93, 109, 94, 110, 94, 216, 97, 223, 97, 237, 97, 238, 97, 241, 97, 234, 97, 240, 97, 235, 97, 214, 97, 233, 97, 255, 100, 4, 101, 253, 100, 248, 100, 1, 101, 3, 101, 252, 100, 148, 101, 219, 101, 218, 102, 219, 102, 216, 102, 197, 106, 185, 106, 189, 106, 225, 106, 198, 106, 186, 106, 182, 106, 183, 106, 199, 106, 180, 106, 173, 106, 94, 107, 201, 107, 11, 108, 7, 112, 12, 112, 13, 112, 1, 112, 5, 112, 20, 112, 14, 112, 255, 111, 0, 112, 251, 111, 38, 112, 252, 111, 247, 111, 10, 112, 1, 114, 255, 113, 249, 113, 3, 114, 253, 113, 118, 115, 184, 116, 192, 116, 181, 116, 193, 116, 190, 116, 182, 116, 187, 116, 194, 116, 20, 117, 19, 117, 92, 118, 100, 118, 89, 118, 80, 118, 83, 118, 87, 118, 90, 118, 166, 118, 189, 118, 236, 118, 194, 119, 186, 119, 255, 120, 12, 121, 19, 121, 20, 121, 9, 121, 16, 121, 18, 121, 17, 121, 173, 121, 172, 121, 95, 122, 28, 124, 41, 124, 25, 124, 32, 124, 31, 124, 45, 124, 29, 124, 38, 124, 40, 124, 34, 124, 37, 124, 48, 124, 92, 126, 80, 126, 86, 126, 99, 126, 88, 126, 98, 126, 95, 126, 81, 126, 96, 126, 87, 126, 83, 126, 181, 127, 179, 127, 247, 127, 248, 127, 117, 128, 209, 129, 210, 129, 208, 129, 95, 130, 94, 130, 180, 133, 198, 133, 192, 133, 195, 133, 194, 133, 179, 133, 181, 133, 189, 133, 199, 133, 196, 133, 191, 133, 203, 133, 206, 133, 200, 133, 197, 133, 177, 133, 182, 133, 210, 133, 36, 134, 184, 133, 183, 133, 190, 133, 105, 134, 231, 135, 230, 135, 226, 135, 219, 135, 235, 135, 234, 135, 229, 135, 223, 135, 243, 135, 228, 135, 212, 135, 220, 135, 211, 135, 237, 135, 216, 135, 227, 135, 164, 135, 215, 135, 217, 135, 1, 136, 244, 135, 232, 135, 221, 135, 83, 137, 75, 137, 79, 137, 76, 137, 70, 137, 80, 137, 81, 137, 73, 137, 42, 139, 39, 139, 35, 139, 51, 139, 48, 139, 53, 139, 71, 139, 47, 139, 60, 139, 62, 139, 49, 139, 37, 139, 55, 139, 38, 139, 54, 139, 46, 139, 36, 139, 59, 139, 61, 139, 58, 139, 66, 140, 117, 140, 153, 140, 152, 140, 151, 140, 254, 140, 4, 141, 2, 141, 0, 141, 92, 142, 98, 142, 96, 142, 87, 142, 86, 142, 94, 142, 101, 142, 103, 142, 91, 142, 90, 142, 97, 142, 93, 142, 105, 142, 84, 142, 70, 143, 71, 143, 72, 143, 75, 143, 40, 145, 58, 145, 59, 145, 62, 145, 168, 145, 165, 145, 167, 145, 175, 145, 170, 145, 181, 147, 140, 147, 146, 147, 183, 147, 155, 147, 157, 147, 137, 147, 167, 147, 142, 147, 170, 147, 158, 147, 166, 147, 149, 147, 136, 147, 153, 147, 159, 147, 141, 147, 177, 147, 145, 147, 178, 147, 164, 147, 168, 147, 180, 147, 163, 147, 165, 147, 210, 149, 211, 149, 209, 149, 179, 150, 215, 150, 218, 150, 194, 93, 223, 150, 216, 150, 221, 150, 35, 151, 34, 151, 37, 151, 172, 151, 174, 151, 168, 151, 171, 151, 164, 151, 170, 151, 162, 151, 165, 151, 215, 151, 217, 151, 214, 151, 216, 151, 250, 151, 80, 152, 81, 152, 82, 152, 184, 152, 65, 153, 60, 153, 58, 153, 15, 154, 11, 154, 9, 154, 13, 154, 4, 154, 17, 154, 10, 154, 5, 154, 7, 154, 6, 154, 192, 154, 220, 154, 8, 155, 4, 155, 5, 155, 41, 155, 53, 155, 74, 155, 76, 155, 75, 155, 199, 155, 198, 155, 195, 155, 191, 155, 193, 155, 181, 155, 184, 155, 211, 155, 182, 155, 196, 155, 185, 155, 189, 155, 92, 157, 83, 157, 79, 157, 74, 157, 91, 157, 75, 157, 89, 157, 86, 157, 76, 157, 87, 157, 82, 157, 84, 157, 95, 157, 88, 157, 90, 157, 142, 158, 140, 158, 223, 158, 1, 159, 0, 159, 22, 159, 37, 159, 43, 159, 42, 159, 41, 159, 40, 159, 76, 159, 85, 159, 52, 81, 53, 81, 150, 82, 247, 82, 180, 83, 171, 86, 173, 86, 166, 86, 167, 86, 170, 86, 172, 86, 218, 88, 221, 88, 219, 88, 18, 89, 61, 91, 62, 91, 63, 91, 195, 93, 112, 94, 191, 95, 251, 97, 7, 101, 16, 101, 13, 101, 9, 101, 12, 101, 14, 101, 132, 101, 222, 101, 221, 101, 222, 102, 231, 106, 224, 106, 204, 106, 209, 106, 217, 106, 203, 106, 223, 106, 220, 106, 208, 106, 235, 106, 207, 106, 205, 106, 222, 106, 96, 107, 176, 107, 12, 108, 25, 112, 39, 112, 32, 112, 22, 112, 43, 112, 33, 112, 34, 112, 35, 112, 41, 112, 23, 112, 36, 112, 28, 112, 42, 112, 12, 114, 10, 114, 7, 114, 2, 114, 5, 114, 165, 114, 166, 114, 164, 114, 163, 114, 161, 114, 203, 116, 197, 116, 183, 116, 195, 116, 22, 117, 96, 118, 201, 119, 202, 119, 196, 119, 241, 119, 29, 121, 27, 121, 33, 121, 28, 121, 23, 121, 30, 121, 176, 121, 103, 122, 104, 122, 51, 124, 60, 124, 57, 124, 44, 124, 59, 124, 236, 124, 234, 124, 118, 126, 117, 126, 120, 126, 112, 126, 119, 126, 111, 126, 122, 126, 114, 126, 116, 126, 104, 126, 75, 127, 74, 127, 131, 127, 134, 127, 183, 127, 253, 127, 254, 127, 120, 128, 215, 129, 213, 129, 100, 130, 97, 130, 99, 130, 235, 133, 241, 133, 237, 133, 217, 133, 225, 133, 232, 133, 218, 133, 215, 133, 236, 133, 242, 133, 248, 133, 216, 133, 223, 133, 227, 133, 220, 133, 209, 133, 240, 133, 230, 133, 239, 133, 222, 133, 226, 133, 0, 136, 250, 135, 3, 136, 246, 135, 247, 135, 9, 136, 12, 136, 11, 136, 6, 136, 252, 135, 8, 136, 255, 135, 10, 136, 2, 136, 98, 137, 90, 137, 91, 137, 87, 137, 97, 137, 92, 137, 88, 137, 93, 137, 89, 137, 136, 137, 183, 137, 182, 137, 246, 137, 80, 139, 72, 139, 74, 139, 64, 139, 83, 139, 86, 139, 84, 139, 75, 139, 85, 139, 81, 139, 66, 139, 82, 139, 87, 139, 67, 140, 119, 140, 118, 140, 154, 140, 6, 141, 7, 141, 9, 141, 172, 141, 170, 141, 173, 141, 171, 141, 109, 142, 120, 142, 115, 142, 106, 142, 111, 142, 123, 142, 194, 142, 82, 143, 81, 143, 79, 143, 80, 143, 83, 143, 180, 143, 64, 145, 63, 145, 176, 145, 173, 145, 222, 147, 199, 147, 207, 147, 194, 147, 218, 147, 208, 147, 249, 147, 236, 147, 204, 147, 217, 147, 169, 147, 230, 147, 202, 147, 212, 147, 238, 147, 227, 147, 213, 147, 196, 147, 206, 147, 192, 147, 210, 147, 231, 147, 125, 149, 218, 149, 219, 149, 225, 150, 41, 151, 43, 151, 44, 151, 40, 151, 38, 151, 179, 151, 183, 151, 182, 151, 221, 151, 222, 151, 223, 151, 92, 152, 89, 152, 93, 152, 87, 152, 191, 152, 189, 152, 187, 152, 190, 152, 72, 153, 71, 153, 67, 153, 166, 153, 167, 153, 26, 154, 21, 154, 37, 154, 29, 154, 36, 154, 27, 154, 34, 154, 32, 154, 39, 154, 35, 154, 30, 154, 28, 154, 20, 154, 194, 154, 11, 155, 10, 155, 14, 155, 12, 155, 55, 155, 234, 155, 235, 155, 224, 155, 222, 155, 228, 155, 230, 155, 226, 155, 240, 155, 212, 155, 215, 155, 236, 155, 220, 155, 217, 155, 229, 155, 213, 155, 225, 155, 218, 155, 119, 157, 129, 157, 138, 157, 132, 157, 136, 157, 113, 157, 128, 157, 120, 157, 134, 157, 139, 157, 140, 157, 125, 157, 107, 157, 116, 157, 117, 157, 112, 157, 105, 157, 133, 157, 115, 157, 123, 157, 130, 157, 111, 157, 121, 157, 127, 157, 135, 157, 104, 157, 148, 158, 145, 158, 192, 158, 252, 158, 45, 159, 64, 159, 65, 159, 77, 159, 86, 159, 87, 159, 88, 159, 55, 83, 178, 86, 181, 86, 179, 86, 227, 88, 69, 91, 198, 93, 199, 93, 238, 94, 239, 94, 192, 95, 193, 95, 249, 97, 23, 101, 22, 101, 21, 101, 19, 101, 223, 101, 232, 102, 227, 102, 228, 102, 243, 106, 240, 106, 234, 106, 232, 106, 249, 106, 241, 106, 238, 106, 239, 106, 60, 112, 53, 112, 47, 112, 55, 112, 52, 112, 49, 112, 66, 112, 56, 112, 63, 112, 58, 112, 57, 112, 64, 112, 59, 112, 51, 112, 65, 112, 19, 114, 20, 114, 168, 114, 125, 115, 124, 115, 186, 116, 171, 118, 170, 118, 190, 118, 237, 118, 204, 119, 206, 119, 207, 119, 205, 119, 242, 119, 37, 121, 35, 121, 39, 121, 40, 121, 36, 121, 41, 121, 178, 121, 110, 122, 108, 122, 109, 122, 247, 122, 73, 124, 72, 124, 74, 124, 71, 124, 69, 124, 238, 124, 123, 126, 126, 126, 129, 126, 128, 126, 186, 127, 255, 127, 121, 128, 219, 129, 217, 129, 11, 130, 104, 130, 105, 130, 34, 134, 255, 133, 1, 134, 254, 133, 27, 134, 0, 134, 246, 133, 4, 134, 9, 134, 5, 134, 12, 134, 253, 133, 25, 136, 16, 136, 17, 136, 23, 136, 19, 136, 22, 136, 99, 137, 102, 137, 185, 137, 247, 137, 96, 139, 106, 139, 93, 139, 104, 139, 99, 139, 101, 139, 103, 139, 109, 139, 174, 141, 134, 142, 136, 142, 132, 142, 89, 143, 86, 143, 87, 143, 85, 143, 88, 143, 90, 143, 141, 144, 67, 145, 65, 145, 183, 145, 181, 145, 178, 145, 179, 145, 11, 148, 19, 148, 251, 147, 32, 148, 15, 148, 20, 148, 254, 147, 21, 148, 16, 148, 40, 148, 25, 148, 13, 148, 245, 147, 0, 148, 247, 147, 7, 148, 14, 148, 22, 148, 18, 148, 250, 147, 9, 148, 248, 147, 10, 148, 255, 147, 252, 147, 12, 148, 246, 147, 17, 148, 6, 148, 222, 149, 224, 149, 223, 149, 46, 151, 47, 151, 185, 151, 187, 151, 253, 151, 254, 151, 96, 152, 98, 152, 99, 152, 95, 152, 193, 152, 194, 152, 80, 153, 78, 153, 89, 153, 76, 153, 75, 153, 83, 153, 50, 154, 52, 154, 49, 154, 44, 154, 42, 154, 54, 154, 41, 154, 46, 154, 56, 154, 45, 154, 199, 154, 202, 154, 198, 154, 16, 155, 18, 155, 17, 155, 11, 156, 8, 156, 247, 155, 5, 156, 18, 156, 248, 155, 64, 156, 7, 156, 14, 156, 6, 156, 23, 156, 20, 156, 9, 156, 159, 157, 153, 157, 164, 157, 157, 157, 146, 157, 152, 157, 144, 157, 155, 157, 160, 157, 148, 157, 156, 157, 170, 157, 151, 157, 161, 157, 154, 157, 162, 157, 168, 157, 158, 157, 163, 157, 191, 157, 169, 157, 150, 157, 166, 157, 167, 157, 153, 158, 155, 158, 154, 158, 229, 158, 228, 158, 231, 158, 230, 158, 48, 159, 46, 159, 91, 159, 96, 159, 94, 159, 93, 159, 89, 159, 145, 159, 58, 81, 57, 81, 152, 82, 151, 82, 195, 86, 189, 86, 190, 86, 72, 91, 71, 91, 203, 93, 207, 93, 241, 94, 253, 97, 27, 101, 2, 107, 252, 106, 3, 107, 248, 106, 0, 107, 67, 112, 68, 112, 74, 112, 72, 112, 73, 112, 69, 112, 70, 112, 29, 114, 26, 114, 25, 114, 126, 115, 23, 117, 106, 118, 208, 119, 45, 121, 49, 121, 47, 121, 84, 124, 83, 124, 242, 124, 138, 126, 135, 126, 136, 126, 139, 126, 134, 126, 141, 126, 77, 127, 187, 127, 48, 128, 221, 129, 24, 134, 42, 134, 38, 134, 31, 134, 35, 134, 28, 134, 25, 134, 39, 134, 46, 134, 33, 134, 32, 134, 41, 134, 30, 134, 37, 134, 41, 136, 29, 136, 27, 136, 32, 136, 36, 136, 28, 136, 43, 136, 74, 136, 109, 137, 105, 137, 110, 137, 107, 137, 250, 137, 121, 139, 120, 139, 69, 139, 122, 139, 123, 139, 16, 141, 20, 141, 175, 141, 142, 142, 140, 142, 94, 143, 91, 143, 93, 143, 70, 145, 68, 145, 69, 145, 185, 145, 63, 148, 59, 148, 54, 148, 41, 148, 61, 148, 60, 148, 48, 148, 57, 148, 42, 148, 55, 148, 44, 148, 64, 148, 49, 148, 229, 149, 228, 149, 227, 149, 53, 151, 58, 151, 191, 151, 225, 151, 100, 152, 201, 152, 198, 152, 192, 152, 88, 153, 86, 153, 57, 154, 61, 154, 70, 154, 68, 154, 66, 154, 65, 154, 58, 154, 63, 154, 205, 154, 21, 155, 23, 155, 24, 155, 22, 155, 58, 155, 82, 155, 43, 156, 29, 156, 28, 156, 44, 156, 35, 156, 40, 156, 41, 156, 36, 156, 33, 156, 183, 157, 182, 157, 188, 157, 193, 157, 199, 157, 202, 157, 207, 157, 190, 157, 197, 157, 195, 157, 187, 157, 181, 157, 206, 157, 185, 157, 186, 157, 172, 157, 200, 157, 177, 157, 173, 157, 204, 157, 179, 157, 205, 157, 178, 157, 122, 158, 156, 158, 235, 158, 238, 158, 237, 158, 27, 159, 24, 159, 26, 159, 49, 159, 78, 159, 101, 159, 100, 159, 146, 159, 185, 78, 198, 86, 197, 86, 203, 86, 113, 89, 75, 91, 76, 91, 213, 93, 209, 93, 242, 94, 33, 101, 32, 101, 38, 101, 34, 101, 11, 107, 8, 107, 9, 107, 13, 108, 85, 112, 86, 112, 87, 112, 82, 112, 30, 114, 31, 114, 169, 114, 127, 115, 216, 116, 213, 116, 217, 116, 215, 116, 109, 118, 173, 118, 53, 121, 180, 121, 112, 122, 113, 122, 87, 124, 92, 124, 89, 124, 91, 124, 90, 124, 244, 124, 241, 124, 145, 126, 79, 127, 135, 127, 222, 129, 107, 130, 52, 134, 53, 134, 51, 134, 44, 134, 50, 134, 54, 134, 44, 136, 40, 136, 38, 136, 42, 136, 37, 136, 113, 137, 191, 137, 190, 137, 251, 137, 126, 139, 132, 139, 130, 139, 134, 139, 133, 139, 127, 139, 21, 141, 149, 142, 148, 142, 154, 142, 146, 142, 144, 142, 150, 142, 151, 142, 96, 143, 98, 143, 71, 145, 76, 148, 80, 148, 74, 148, 75, 148, 79, 148, 71, 148, 69, 148, 72, 148, 73, 148, 70, 148, 63, 151, 227, 151, 106, 152, 105, 152, 203, 152, 84, 153, 91, 153, 78, 154, 83, 154, 84, 154, 76, 154, 79, 154, 72, 154, 74, 154, 73, 154, 82, 154, 80, 154, 208, 154, 25, 155, 43, 155, 59, 155, 86, 155, 85, 155, 70, 156, 72, 156, 63, 156, 68, 156, 57, 156, 51, 156, 65, 156, 60, 156, 55, 156, 52, 156, 50, 156, 61, 156, 54, 156, 219, 157, 210, 157, 222, 157, 218, 157, 203, 157, 208, 157, 220, 157, 209, 157, 223, 157, 233, 157, 217, 157, 216, 157, 214, 157, 245, 157, 213, 157, 221, 157, 182, 158, 240, 158, 53, 159, 51, 159, 50, 159, 66, 159, 107, 159, 149, 159, 162, 159, 61, 81, 153, 82, 232, 88, 231, 88, 114, 89, 77, 91, 216, 93, 47, 136, 79, 95, 1, 98, 3, 98, 4, 98, 41, 101, 37, 101, 150, 101, 235, 102, 17, 107, 18, 107, 15, 107, 202, 107, 91, 112, 90, 112, 34, 114, 130, 115, 129, 115, 131, 115, 112, 118, 212, 119, 103, 124, 102, 124, 149, 126, 108, 130, 58, 134, 64, 134, 57, 134, 60, 134, 49, 134, 59, 134, 62, 134, 48, 136, 50, 136, 46, 136, 51, 136, 118, 137, 116, 137, 115, 137, 254, 137, 140, 139, 142, 139, 139, 139, 136, 139, 69, 140, 25, 141, 152, 142, 100, 143, 99, 143, 188, 145, 98, 148, 85, 148, 93, 148, 87, 148, 94, 148, 196, 151, 197, 151, 0, 152, 86, 154, 89, 154, 30, 155, 31, 155, 32, 155, 82, 156, 88, 156, 80, 156, 74, 156, 77, 156, 75, 156, 85, 156, 89, 156, 76, 156, 78, 156, 251, 157, 247, 157, 239, 157, 227, 157, 235, 157, 248, 157, 228, 157, 246, 157, 225, 157, 238, 157, 230, 157, 242, 157, 240, 157, 226, 157, 236, 157, 244, 157, 243, 157, 232, 157, 237, 157, 194, 158, 208, 158, 242, 158, 243, 158, 6, 159, 28, 159, 56, 159, 55, 159, 54, 159, 67, 159, 79, 159, 113, 159, 112, 159, 110, 159, 111, 159, 211, 86, 205, 86, 78, 91, 109, 92, 45, 101, 237, 102, 238, 102, 19, 107, 95, 112, 97, 112, 93, 112, 96, 112, 35, 114, 219, 116, 229, 116, 213, 119, 56, 121, 183, 121, 182, 121, 106, 124, 151, 126, 137, 127, 109, 130, 67, 134, 56, 136, 55, 136, 53, 136, 75, 136, 148, 139, 149, 139, 158, 142, 159, 142, 160, 142, 157, 142, 190, 145, 189, 145, 194, 145, 107, 148, 104, 148, 105, 148, 229, 150, 70, 151, 67, 151, 71, 151, 199, 151, 229, 151, 94, 154, 213, 154, 89, 155, 99, 156, 103, 156, 102, 156, 98, 156, 94, 156, 96, 156, 2, 158, 254, 157, 7, 158, 3, 158, 6, 158, 5, 158, 0, 158, 1, 158, 9, 158, 255, 157, 253, 157, 4, 158, 160, 158, 30, 159, 70, 159, 116, 159, 117, 159, 118, 159, 212, 86, 46, 101, 184, 101, 24, 107, 25, 107, 23, 107, 26, 107, 98, 112, 38, 114, 170, 114, 216, 119, 217, 119, 57, 121, 105, 124, 107, 124, 246, 124, 154, 126, 152, 126, 155, 126, 153, 126, 224, 129, 225, 129, 70, 134, 71, 134, 72, 134, 121, 137, 122, 137, 124, 137, 123, 137, 255, 137, 152, 139, 153, 139, 165, 142, 164, 142, 163, 142, 110, 148, 109, 148, 111, 148, 113, 148, 115, 148, 73, 151, 114, 152, 95, 153, 104, 156, 110, 156, 109, 156, 11, 158, 13, 158, 16, 158, 15, 158, 18, 158, 17, 158, 161, 158, 245, 158, 9, 159, 71, 159, 120, 159, 123, 159, 122, 159, 121, 159, 30, 87, 102, 112, 111, 124, 60, 136, 178, 141, 166, 142, 195, 145, 116, 148, 120, 148, 118, 148, 117, 148, 96, 154, 116, 156, 115, 156, 113, 156, 117, 156, 20, 158, 19, 158, 246, 158, 10, 159, 164, 159, 104, 112, 101, 112, 247, 124, 106, 134, 62, 136, 61, 136, 63, 136, 158, 139, 156, 140, 169, 142, 201, 142, 75, 151, 115, 152, 116, 152, 204, 152, 97, 153, 171, 153, 100, 154, 102, 154, 103, 154, 36, 155, 21, 158, 23, 158, 72, 159, 7, 98, 30, 107, 39, 114, 76, 134, 168, 142, 130, 148, 128, 148, 129, 148, 105, 154, 104, 154, 46, 155, 25, 158, 41, 114, 75, 134, 159, 139, 131, 148, 121, 156, 183, 158, 117, 118, 107, 154, 122, 156, 29, 158, 105, 112, 106, 112, 164, 158, 126, 159, 73, 159, 152, 159, 129, 120, 185, 146, 207, 136, 187, 88, 82, 96, 167, 124, 250, 90, 84, 37, 102, 37, 87, 37, 96, 37, 108, 37, 99, 37, 90, 37, 105, 37, 93, 37, 82, 37, 100, 37, 85, 37, 94, 37, 106, 37, 97, 37, 88, 37, 103, 37, 91, 37, 83, 37, 101, 37, 86, 37, 95, 37, 107, 37, 98, 37, 89, 37, 104, 37, 92, 37, 81, 37, 80, 37, 109, 37, 110, 37, 112, 37, 111, 37, 147, 37, 0, 0, 0, 0, 0, 0, 0, 48, 1, 48, 2, 48, 183, 0, 37, 32, 38, 32, 168, 0, 3, 48, 173, 0, 21, 32, 37, 34, 60, 255, 60, 34, 24, 32, 25, 32, 28, 32, 29, 32, 20, 48, 21, 48, 8, 48, 9, 48, 10, 48, 11, 48, 12, 48, 13, 48, 14, 48, 15, 48, 16, 48, 17, 48, 177, 0, 215, 0, 247, 0, 96, 34, 100, 34, 101, 34, 30, 34, 52, 34, 176, 0, 50, 32, 51, 32, 3, 33, 43, 33, 224, 255, 225, 255, 229, 255, 66, 38, 64, 38, 32, 34, 165, 34, 18, 35, 2, 34, 7, 34, 97, 34, 82, 34, 167, 0, 59, 32, 6, 38, 5, 38, 203, 37, 207, 37, 206, 37, 199, 37, 198, 37, 161, 37, 160, 37, 179, 37, 178, 37, 189, 37, 188, 37, 146, 33, 144, 33, 145, 33, 147, 33, 148, 33, 19, 48, 106, 34, 107, 34, 26, 34, 61, 34, 29, 34, 53, 34, 43, 34, 44, 34, 8, 34, 11, 34, 134, 34, 135, 34, 130, 34, 131, 34, 42, 34, 41, 34, 39, 34, 40, 34, 226, 255, 210, 33, 212, 33, 0, 34, 3, 34, 180, 0, 94, 255, 199, 2, 216, 2, 221, 2, 218, 2, 217, 2, 184, 0, 219, 2, 161, 0, 191, 0, 208, 2, 46, 34, 17, 34, 15, 34, 164, 0, 9, 33, 48, 32, 193, 37, 192, 37, 183, 37, 182, 37, 100, 38, 96, 38, 97, 38, 101, 38, 103, 38, 99, 38, 153, 34, 200, 37, 163, 37, 208, 37, 209, 37, 146, 37, 164, 37, 165, 37, 168, 37, 167, 37, 166, 37, 169, 37, 104, 38, 15, 38, 14, 38, 28, 38, 30, 38, 182, 0, 32, 32, 33, 32, 149, 33, 151, 33, 153, 33, 150, 33, 152, 33, 109, 38, 105, 38, 106, 38, 108, 38, 127, 50, 28, 50, 22, 33, 199, 51, 34, 33, 194, 51, 216, 51, 33, 33, 172, 32, 174, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 255, 2, 255, 3, 255, 4, 255, 5, 255, 6, 255, 7, 255, 8, 255, 9, 255, 10, 255, 11, 255, 12, 255, 13, 255, 14, 255, 15, 255, 16, 255, 17, 255, 18, 255, 19, 255, 20, 255, 21, 255, 22, 255, 23, 255, 24, 255, 25, 255, 26, 255, 27, 255, 28, 255, 29, 255, 30, 255, 31, 255, 32, 255, 33, 255, 34, 255, 35, 255, 36, 255, 37, 255, 38, 255, 39, 255, 40, 255, 41, 255, 42, 255, 43, 255, 44, 255, 45, 255, 46, 255, 47, 255, 48, 255, 49, 255, 50, 255, 51, 255, 52, 255, 53, 255, 54, 255, 55, 255, 56, 255, 57, 255, 58, 255, 59, 255, 230, 255, 61, 255, 62, 255, 63, 255, 64, 255, 65, 255, 66, 255, 67, 255, 68, 255, 69, 255, 70, 255, 71, 255, 72, 255, 73, 255, 74, 255, 75, 255, 76, 255, 77, 255, 78, 255, 79, 255, 80, 255, 81, 255, 82, 255, 83, 255, 84, 255, 85, 255, 86, 255, 87, 255, 88, 255, 89, 255, 90, 255, 91, 255, 92, 255, 93, 255, 227, 255, 49, 49, 50, 49, 51, 49, 52, 49, 53, 49, 54, 49, 55, 49, 56, 49, 57, 49, 58, 49, 59, 49, 60, 49, 61, 49, 62, 49, 63, 49, 64, 49, 65, 49, 66, 49, 67, 49, 68, 49, 69, 49, 70, 49, 71, 49, 72, 49, 73, 49, 74, 49, 75, 49, 76, 49, 77, 49, 78, 49, 79, 49, 80, 49, 81, 49, 82, 49, 83, 49, 84, 49, 85, 49, 86, 49, 87, 49, 88, 49, 89, 49, 90, 49, 91, 49, 92, 49, 93, 49, 94, 49, 95, 49, 96, 49, 97, 49, 98, 49, 99, 49, 100, 49, 101, 49, 102, 49, 103, 49, 104, 49, 105, 49, 106, 49, 107, 49, 108, 49, 109, 49, 110, 49, 111, 49, 112, 49, 113, 49, 114, 49, 115, 49, 116, 49, 117, 49, 118, 49, 119, 49, 120, 49, 121, 49, 122, 49, 123, 49, 124, 49, 125, 49, 126, 49, 127, 49, 128, 49, 129, 49, 130, 49, 131, 49, 132, 49, 133, 49, 134, 49, 135, 49, 136, 49, 137, 49, 138, 49, 139, 49, 140, 49, 141, 49, 142, 49, 112, 33, 113, 33, 114, 33, 115, 33, 116, 33, 117, 33, 118, 33, 119, 33, 120, 33, 121, 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 33, 97, 33, 98, 33, 99, 33, 100, 33, 101, 33, 102, 33, 103, 33, 104, 33, 105, 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 3, 146, 3, 147, 3, 148, 3, 149, 3, 150, 3, 151, 3, 152, 3, 153, 3, 154, 3, 155, 3, 156, 3, 157, 3, 158, 3, 159, 3, 160, 3, 161, 3, 163, 3, 164, 3, 165, 3, 166, 3, 167, 3, 168, 3, 169, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 3, 178, 3, 179, 3, 180, 3, 181, 3, 182, 3, 183, 3, 184, 3, 185, 3, 186, 3, 187, 3, 188, 3, 189, 3, 190, 3, 191, 3, 192, 3, 193, 3, 195, 3, 196, 3, 197, 3, 198, 3, 199, 3, 200, 3, 201, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 2, 37, 12, 37, 16, 37, 24, 37, 20, 37, 28, 37, 44, 37, 36, 37, 52, 37, 60, 37, 1, 37, 3, 37, 15, 37, 19, 37, 27, 37, 23, 37, 35, 37, 51, 37, 43, 37, 59, 37, 75, 37, 32, 37, 47, 37, 40, 37, 55, 37, 63, 37, 29, 37, 48, 37, 37, 37, 56, 37, 66, 37, 18, 37, 17, 37, 26, 37, 25, 37, 22, 37, 21, 37, 14, 37, 13, 37, 30, 37, 31, 37, 33, 37, 34, 37, 38, 37, 39, 37, 41, 37, 42, 37, 45, 37, 46, 37, 49, 37, 50, 37, 53, 37, 54, 37, 57, 37, 58, 37, 61, 37, 62, 37, 64, 37, 65, 37, 67, 37, 68, 37, 69, 37, 70, 37, 71, 37, 72, 37, 73, 37, 74, 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 51, 150, 51, 151, 51, 19, 33, 152, 51, 196, 51, 163, 51, 164, 51, 165, 51, 166, 51, 153, 51, 154, 51, 155, 51, 156, 51, 157, 51, 158, 51, 159, 51, 160, 51, 161, 51, 162, 51, 202, 51, 141, 51, 142, 51, 143, 51, 207, 51, 136, 51, 137, 51, 200, 51, 167, 51, 168, 51, 176, 51, 177, 51, 178, 51, 179, 51, 180, 51, 181, 51, 182, 51, 183, 51, 184, 51, 185, 51, 128, 51, 129, 51, 130, 51, 131, 51, 132, 51, 186, 51, 187, 51, 188, 51, 189, 51, 190, 51, 191, 51, 144, 51, 145, 51, 146, 51, 147, 51, 148, 51, 38, 33, 192, 51, 193, 51, 138, 51, 139, 51, 140, 51, 214, 51, 197, 51, 173, 51, 174, 51, 175, 51, 219, 51, 169, 51, 170, 51, 171, 51, 172, 51, 221, 51, 208, 51, 211, 51, 195, 51, 201, 51, 220, 51, 198, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 0, 208, 0, 170, 0, 38, 1, 0, 0, 50, 1, 0, 0, 63, 1, 65, 1, 216, 0, 82, 1, 186, 0, 222, 0, 102, 1, 74, 1, 0, 0, 96, 50, 97, 50, 98, 50, 99, 50, 100, 50, 101, 50, 102, 50, 103, 50, 104, 50, 105, 50, 106, 50, 107, 50, 108, 50, 109, 50, 110, 50, 111, 50, 112, 50, 113, 50, 114, 50, 115, 50, 116, 50, 117, 50, 118, 50, 119, 50, 120, 50, 121, 50, 122, 50, 123, 50, 208, 36, 209, 36, 210, 36, 211, 36, 212, 36, 213, 36, 214, 36, 215, 36, 216, 36, 217, 36, 218, 36, 219, 36, 220, 36, 221, 36, 222, 36, 223, 36, 224, 36, 225, 36, 226, 36, 227, 36, 228, 36, 229, 36, 230, 36, 231, 36, 232, 36, 233, 36, 96, 36, 97, 36, 98, 36, 99, 36, 100, 36, 101, 36, 102, 36, 103, 36, 104, 36, 105, 36, 106, 36, 107, 36, 108, 36, 109, 36, 110, 36, 189, 0, 83, 33, 84, 33, 188, 0, 190, 0, 91, 33, 92, 33, 93, 33, 94, 33, 230, 0, 17, 1, 240, 0, 39, 1, 49, 1, 51, 1, 56, 1, 64, 1, 66, 1, 248, 0, 83, 1, 223, 0, 254, 0, 103, 1, 75, 1, 73, 1, 0, 50, 1, 50, 2, 50, 3, 50, 4, 50, 5, 50, 6, 50, 7, 50, 8, 50, 9, 50, 10, 50, 11, 50, 12, 50, 13, 50, 14, 50, 15, 50, 16, 50, 17, 50, 18, 50, 19, 50, 20, 50, 21, 50, 22, 50, 23, 50, 24, 50, 25, 50, 26, 50, 27, 50, 156, 36, 157, 36, 158, 36, 159, 36, 160, 36, 161, 36, 162, 36, 163, 36, 164, 36, 165, 36, 166, 36, 167, 36, 168, 36, 169, 36, 170, 36, 171, 36, 172, 36, 173, 36, 174, 36, 175, 36, 176, 36, 177, 36, 178, 36, 179, 36, 180, 36, 181, 36, 116, 36, 117, 36, 118, 36, 119, 36, 120, 36, 121, 36, 122, 36, 123, 36, 124, 36, 125, 36, 126, 36, 127, 36, 128, 36, 129, 36, 130, 36, 185, 0, 178, 0, 179, 0, 116, 32, 127, 32, 129, 32, 130, 32, 131, 32, 132, 32, 65, 48, 66, 48, 67, 48, 68, 48, 69, 48, 70, 48, 71, 48, 72, 48, 73, 48, 74, 48, 75, 48, 76, 48, 77, 48, 78, 48, 79, 48, 80, 48, 81, 48, 82, 48, 83, 48, 84, 48, 85, 48, 86, 48, 87, 48, 88, 48, 89, 48, 90, 48, 91, 48, 92, 48, 93, 48, 94, 48, 95, 48, 96, 48, 97, 48, 98, 48, 99, 48, 100, 48, 101, 48, 102, 48, 103, 48, 104, 48, 105, 48, 106, 48, 107, 48, 108, 48, 109, 48, 110, 48, 111, 48, 112, 48, 113, 48, 114, 48, 115, 48, 116, 48, 117, 48, 118, 48, 119, 48, 120, 48, 121, 48, 122, 48, 123, 48, 124, 48, 125, 48, 126, 48, 127, 48, 128, 48, 129, 48, 130, 48, 131, 48, 132, 48, 133, 48, 134, 48, 135, 48, 136, 48, 137, 48, 138, 48, 139, 48, 140, 48, 141, 48, 142, 48, 143, 48, 144, 48, 145, 48, 146, 48, 147, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 48, 162, 48, 163, 48, 164, 48, 165, 48, 166, 48, 167, 48, 168, 48, 169, 48, 170, 48, 171, 48, 172, 48, 173, 48, 174, 48, 175, 48, 176, 48, 177, 48, 178, 48, 179, 48, 180, 48, 181, 48, 182, 48, 183, 48, 184, 48, 185, 48, 186, 48, 187, 48, 188, 48, 189, 48, 190, 48, 191, 48, 192, 48, 193, 48, 194, 48, 195, 48, 196, 48, 197, 48, 198, 48, 199, 48, 200, 48, 201, 48, 202, 48, 203, 48, 204, 48, 205, 48, 206, 48, 207, 48, 208, 48, 209, 48, 210, 48, 211, 48, 212, 48, 213, 48, 214, 48, 215, 48, 216, 48, 217, 48, 218, 48, 219, 48, 220, 48, 221, 48, 222, 48, 223, 48, 224, 48, 225, 48, 226, 48, 227, 48, 228, 48, 229, 48, 230, 48, 231, 48, 232, 48, 233, 48, 234, 48, 235, 48, 236, 48, 237, 48, 238, 48, 239, 48, 240, 48, 241, 48, 242, 48, 243, 48, 244, 48, 245, 48, 246, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 4, 17, 4, 18, 4, 19, 4, 20, 4, 21, 4, 1, 4, 22, 4, 23, 4, 24, 4, 25, 4, 26, 4, 27, 4, 28, 4, 29, 4, 30, 4, 31, 4, 32, 4, 33, 4, 34, 4, 35, 4, 36, 4, 37, 4, 38, 4, 39, 4, 40, 4, 41, 4, 42, 4, 43, 4, 44, 4, 45, 4, 46, 4, 47, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 4, 49, 4, 50, 4, 51, 4, 52, 4, 53, 4, 81, 4, 54, 4, 55, 4, 56, 4, 57, 4, 58, 4, 59, 4, 60, 4, 61, 4, 62, 4, 63, 4, 64, 4, 65, 4, 66, 4, 67, 4, 68, 4, 69, 4, 70, 4, 71, 4, 72, 4, 73, 4, 74, 4, 75, 4, 76, 4, 77, 4, 78, 4, 79, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 1, 172, 4, 172, 7, 172, 8, 172, 9, 172, 10, 172, 16, 172, 17, 172, 18, 172, 19, 172, 20, 172, 21, 172, 22, 172, 23, 172, 25, 172, 26, 172, 27, 172, 28, 172, 29, 172, 32, 172, 36, 172, 44, 172, 45, 172, 47, 172, 48, 172, 49, 172, 56, 172, 57, 172, 60, 172, 64, 172, 75, 172, 77, 172, 84, 172, 88, 172, 92, 172, 112, 172, 113, 172, 116, 172, 119, 172, 120, 172, 122, 172, 128, 172, 129, 172, 131, 172, 132, 172, 133, 172, 134, 172, 137, 172, 138, 172, 139, 172, 140, 172, 144, 172, 148, 172, 156, 172, 157, 172, 159, 172, 160, 172, 161, 172, 168, 172, 169, 172, 170, 172, 172, 172, 175, 172, 176, 172, 184, 172, 185, 172, 187, 172, 188, 172, 189, 172, 193, 172, 196, 172, 200, 172, 204, 172, 213, 172, 215, 172, 224, 172, 225, 172, 228, 172, 231, 172, 232, 172, 234, 172, 236, 172, 239, 172, 240, 172, 241, 172, 243, 172, 245, 172, 246, 172, 252, 172, 253, 172, 0, 173, 4, 173, 6, 173, 12, 173, 13, 173, 15, 173, 17, 173, 24, 173, 28, 173, 32, 173, 41, 173, 44, 173, 45, 173, 52, 173, 53, 173, 56, 173, 60, 173, 68, 173, 69, 173, 71, 173, 73, 173, 80, 173, 84, 173, 88, 173, 97, 173, 99, 173, 108, 173, 109, 173, 112, 173, 115, 173, 116, 173, 117, 173, 118, 173, 123, 173, 124, 173, 125, 173, 127, 173, 129, 173, 130, 173, 136, 173, 137, 173, 140, 173, 144, 173, 156, 173, 157, 173, 164, 173, 183, 173, 192, 173, 193, 173, 196, 173, 200, 173, 208, 173, 209, 173, 211, 173, 220, 173, 224, 173, 228, 173, 248, 173, 249, 173, 252, 173, 255, 173, 0, 174, 1, 174, 8, 174, 9, 174, 11, 174, 13, 174, 20, 174, 48, 174, 49, 174, 52, 174, 55, 174, 56, 174, 58, 174, 64, 174, 65, 174, 67, 174, 69, 174, 70, 174, 74, 174, 76, 174, 77, 174, 78, 174, 80, 174, 84, 174, 86, 174, 92, 174, 93, 174, 95, 174, 96, 174, 97, 174, 101, 174, 104, 174, 105, 174, 108, 174, 112, 174, 120, 174, 121, 174, 123, 174, 124, 174, 125, 174, 132, 174, 133, 174, 140, 174, 188, 174, 189, 174, 190, 174, 192, 174, 196, 174, 204, 174, 205, 174, 207, 174, 208, 174, 209, 174, 216, 174, 217, 174, 220, 174, 232, 174, 235, 174, 237, 174, 244, 174, 248, 174, 252, 174, 7, 175, 8, 175], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 302308);
	        allocate([13, 175, 16, 175, 44, 175, 45, 175, 48, 175, 50, 175, 52, 175, 60, 175, 61, 175, 63, 175, 65, 175, 66, 175, 67, 175, 72, 175, 73, 175, 80, 175, 92, 175, 93, 175, 100, 175, 101, 175, 121, 175, 128, 175, 132, 175, 136, 175, 144, 175, 145, 175, 149, 175, 156, 175, 184, 175, 185, 175, 188, 175, 192, 175, 199, 175, 200, 175, 201, 175, 203, 175, 205, 175, 206, 175, 212, 175, 220, 175, 232, 175, 233, 175, 240, 175, 241, 175, 244, 175, 248, 175, 0, 176, 1, 176, 4, 176, 12, 176, 16, 176, 20, 176, 28, 176, 29, 176, 40, 176, 68, 176, 69, 176, 72, 176, 74, 176, 76, 176, 78, 176, 83, 176, 84, 176, 85, 176, 87, 176, 89, 176, 93, 176, 124, 176, 125, 176, 128, 176, 132, 176, 140, 176, 141, 176, 143, 176, 145, 176, 152, 176, 153, 176, 154, 176, 156, 176, 159, 176, 160, 176, 161, 176, 162, 176, 168, 176, 169, 176, 171, 176, 172, 176, 173, 176, 174, 176, 175, 176, 177, 176, 179, 176, 180, 176, 181, 176, 184, 176, 188, 176, 196, 176, 197, 176, 199, 176, 200, 176, 201, 176, 208, 176, 209, 176, 212, 176, 216, 176, 224, 176, 229, 176, 8, 177, 9, 177, 11, 177, 12, 177, 16, 177, 18, 177, 19, 177, 24, 177, 25, 177, 27, 177, 28, 177, 29, 177, 35, 177, 36, 177, 37, 177, 40, 177, 44, 177, 52, 177, 53, 177, 55, 177, 56, 177, 57, 177, 64, 177, 65, 177, 68, 177, 72, 177, 80, 177, 81, 177, 84, 177, 85, 177, 88, 177, 92, 177, 96, 177, 120, 177, 121, 177, 124, 177, 128, 177, 130, 177, 136, 177, 137, 177, 139, 177, 141, 177, 146, 177, 147, 177, 148, 177, 152, 177, 156, 177, 168, 177, 204, 177, 208, 177, 212, 177, 220, 177, 221, 177, 223, 177, 232, 177, 233, 177, 236, 177, 240, 177, 249, 177, 251, 177, 253, 177, 4, 178, 5, 178, 8, 178, 11, 178, 12, 178, 20, 178, 21, 178, 23, 178, 25, 178, 32, 178, 52, 178, 60, 178, 88, 178, 92, 178, 96, 178, 104, 178, 105, 178, 116, 178, 117, 178, 124, 178, 132, 178, 133, 178, 137, 178, 144, 178, 145, 178, 148, 178, 152, 178, 153, 178, 154, 178, 160, 178, 161, 178, 163, 178, 165, 178, 166, 178, 170, 178, 172, 178, 176, 178, 180, 178, 200, 178, 201, 178, 204, 178, 208, 178, 210, 178, 216, 178, 217, 178, 219, 178, 221, 178, 226, 178, 228, 178, 229, 178, 230, 178, 232, 178, 235, 178, 236, 178, 237, 178, 238, 178, 239, 178, 243, 178, 244, 178, 245, 178, 247, 178, 248, 178, 249, 178, 250, 178, 251, 178, 255, 178, 0, 179, 1, 179, 4, 179, 8, 179, 16, 179, 17, 179, 19, 179, 20, 179, 21, 179, 28, 179, 84, 179, 85, 179, 86, 179, 88, 179, 91, 179, 92, 179, 94, 179, 95, 179, 100, 179, 101, 179, 103, 179, 105, 179, 107, 179, 110, 179, 112, 179, 113, 179, 116, 179, 120, 179, 128, 179, 129, 179, 131, 179, 132, 179, 133, 179, 140, 179, 144, 179, 148, 179, 160, 179, 161, 179, 168, 179, 172, 179, 196, 179, 197, 179, 200, 179, 203, 179, 204, 179, 206, 179, 208, 179, 212, 179, 213, 179, 215, 179, 217, 179, 219, 179, 221, 179, 224, 179, 228, 179, 232, 179, 252, 179, 16, 180, 24, 180, 28, 180, 32, 180, 40, 180, 41, 180, 43, 180, 52, 180, 80, 180, 81, 180, 84, 180, 88, 180, 96, 180, 97, 180, 99, 180, 101, 180, 108, 180, 128, 180, 136, 180, 157, 180, 164, 180, 168, 180, 172, 180, 181, 180, 183, 180, 185, 180, 192, 180, 196, 180, 200, 180, 208, 180, 213, 180, 220, 180, 221, 180, 224, 180, 227, 180, 228, 180, 230, 180, 236, 180, 237, 180, 239, 180, 241, 180, 248, 180, 20, 181, 21, 181, 24, 181, 27, 181, 28, 181, 36, 181, 37, 181, 39, 181, 40, 181, 41, 181, 42, 181, 48, 181, 49, 181, 52, 181, 56, 181, 64, 181, 65, 181, 67, 181, 68, 181, 69, 181, 75, 181, 76, 181, 77, 181, 80, 181, 84, 181, 92, 181, 93, 181, 95, 181, 96, 181, 97, 181, 160, 181, 161, 181, 164, 181, 168, 181, 170, 181, 171, 181, 176, 181, 177, 181, 179, 181, 180, 181, 181, 181, 187, 181, 188, 181, 189, 181, 192, 181, 196, 181, 204, 181, 205, 181, 207, 181, 208, 181, 209, 181, 216, 181, 236, 181, 16, 182, 17, 182, 20, 182, 24, 182, 37, 182, 44, 182, 52, 182, 72, 182, 100, 182, 104, 182, 156, 182, 157, 182, 160, 182, 164, 182, 171, 182, 172, 182, 177, 182, 212, 182, 240, 182, 244, 182, 248, 182, 0, 183, 1, 183, 5, 183, 40, 183, 41, 183, 44, 183, 47, 183, 48, 183, 56, 183, 57, 183, 59, 183, 68, 183, 72, 183, 76, 183, 84, 183, 85, 183, 96, 183, 100, 183, 104, 183, 112, 183, 113, 183, 115, 183, 117, 183, 124, 183, 125, 183, 128, 183, 132, 183, 140, 183, 141, 183, 143, 183, 144, 183, 145, 183, 146, 183, 150, 183, 151, 183, 152, 183, 153, 183, 156, 183, 160, 183, 168, 183, 169, 183, 171, 183, 172, 183, 173, 183, 180, 183, 181, 183, 184, 183, 199, 183, 201, 183, 236, 183, 237, 183, 240, 183, 244, 183, 252, 183, 253, 183, 255, 183, 0, 184, 1, 184, 7, 184, 8, 184, 9, 184, 12, 184, 16, 184, 24, 184, 25, 184, 27, 184, 29, 184, 36, 184, 37, 184, 40, 184, 44, 184, 52, 184, 53, 184, 55, 184, 56, 184, 57, 184, 64, 184, 68, 184, 81, 184, 83, 184, 92, 184, 93, 184, 96, 184, 100, 184, 108, 184, 109, 184, 111, 184, 113, 184, 120, 184, 124, 184, 141, 184, 168, 184, 176, 184, 180, 184, 184, 184, 192, 184, 193, 184, 195, 184, 197, 184, 204, 184, 208, 184, 212, 184, 221, 184, 223, 184, 225, 184, 232, 184, 233, 184, 236, 184, 240, 184, 248, 184, 249, 184, 251, 184, 253, 184, 4, 185, 24, 185, 32, 185, 60, 185, 61, 185, 64, 185, 68, 185, 76, 185, 79, 185, 81, 185, 88, 185, 89, 185, 92, 185, 96, 185, 104, 185, 105, 185, 107, 185, 109, 185, 116, 185, 117, 185, 120, 185, 124, 185, 132, 185, 133, 185, 135, 185, 137, 185, 138, 185, 141, 185, 142, 185, 172, 185, 173, 185, 176, 185, 180, 185, 188, 185, 189, 185, 191, 185, 193, 185, 200, 185, 201, 185, 204, 185, 206, 185, 207, 185, 208, 185, 209, 185, 210, 185, 216, 185, 217, 185, 219, 185, 221, 185, 222, 185, 225, 185, 227, 185, 228, 185, 229, 185, 232, 185, 236, 185, 244, 185, 245, 185, 247, 185, 248, 185, 249, 185, 250, 185, 0, 186, 1, 186, 8, 186, 21, 186, 56, 186, 57, 186, 60, 186, 64, 186, 66, 186, 72, 186, 73, 186, 75, 186, 77, 186, 78, 186, 83, 186, 84, 186, 85, 186, 88, 186, 92, 186, 100, 186, 101, 186, 103, 186, 104, 186, 105, 186, 112, 186, 113, 186, 116, 186, 120, 186, 131, 186, 132, 186, 133, 186, 135, 186, 140, 186, 168, 186, 169, 186, 171, 186, 172, 186, 176, 186, 178, 186, 184, 186, 185, 186, 187, 186, 189, 186, 196, 186, 200, 186, 216, 186, 217, 186, 252, 186, 0, 187, 4, 187, 13, 187, 15, 187, 17, 187, 24, 187, 28, 187, 32, 187, 41, 187, 43, 187, 52, 187, 53, 187, 54, 187, 56, 187, 59, 187, 60, 187, 61, 187, 62, 187, 68, 187, 69, 187, 71, 187, 73, 187, 77, 187, 79, 187, 80, 187, 84, 187, 88, 187, 97, 187, 99, 187, 108, 187, 136, 187, 140, 187, 144, 187, 164, 187, 168, 187, 172, 187, 180, 187, 183, 187, 192, 187, 196, 187, 200, 187, 208, 187, 211, 187, 248, 187, 249, 187, 252, 187, 255, 187, 0, 188, 2, 188, 8, 188, 9, 188, 11, 188, 12, 188, 13, 188, 15, 188, 17, 188, 20, 188, 21, 188, 22, 188, 23, 188, 24, 188, 27, 188, 28, 188, 29, 188, 30, 188, 31, 188, 36, 188, 37, 188, 39, 188, 41, 188, 45, 188, 48, 188, 49, 188, 52, 188, 56, 188, 64, 188, 65, 188, 67, 188, 68, 188, 69, 188, 73, 188, 76, 188, 77, 188, 80, 188, 93, 188, 132, 188, 133, 188, 136, 188, 139, 188, 140, 188, 142, 188, 148, 188, 149, 188, 151, 188, 153, 188, 154, 188, 160, 188, 161, 188, 164, 188, 167, 188, 168, 188, 176, 188, 177, 188, 179, 188, 180, 188, 181, 188, 188, 188, 189, 188, 192, 188, 196, 188, 205, 188, 207, 188, 208, 188, 209, 188, 213, 188, 216, 188, 220, 188, 244, 188, 245, 188, 246, 188, 248, 188, 252, 188, 4, 189, 5, 189, 7, 189, 9, 189, 16, 189, 20, 189, 36, 189, 44, 189, 64, 189, 72, 189, 73, 189, 76, 189, 80, 189, 88, 189, 89, 189, 100, 189, 104, 189, 128, 189, 129, 189, 132, 189, 135, 189, 136, 189, 137, 189, 138, 189, 144, 189, 145, 189, 147, 189, 149, 189, 153, 189, 154, 189, 156, 189, 164, 189, 176, 189, 184, 189, 212, 189, 213, 189, 216, 189, 220, 189, 233, 189, 240, 189, 244, 189, 248, 189, 0, 190, 3, 190, 5, 190, 12, 190, 13, 190, 16, 190, 20, 190, 28, 190, 29, 190, 31, 190, 68, 190, 69, 190, 72, 190, 76, 190, 78, 190, 84, 190, 85, 190, 87, 190, 89, 190, 90, 190, 91, 190, 96, 190, 97, 190, 100, 190, 104, 190, 106, 190, 112, 190, 113, 190, 115, 190, 116, 190, 117, 190, 123, 190, 124, 190, 125, 190, 128, 190, 132, 190, 140, 190, 141, 190, 143, 190, 144, 190, 145, 190, 152, 190, 153, 190, 168, 190, 208, 190, 209, 190, 212, 190, 215, 190, 216, 190, 224, 190, 227, 190, 228, 190, 229, 190, 236, 190, 1, 191, 8, 191, 9, 191, 24, 191, 25, 191, 27, 191, 28, 191, 29, 191, 64, 191, 65, 191, 68, 191, 72, 191, 80, 191, 81, 191, 85, 191, 148, 191, 176, 191, 197, 191, 204, 191, 205, 191, 208, 191, 212, 191, 220, 191, 223, 191, 225, 191, 60, 192, 81, 192, 88, 192, 92, 192, 96, 192, 104, 192, 105, 192, 144, 192, 145, 192, 148, 192, 152, 192, 160, 192, 161, 192, 163, 192, 165, 192, 172, 192, 173, 192, 175, 192, 176, 192, 179, 192, 180, 192, 181, 192, 182, 192, 188, 192, 189, 192, 191, 192, 192, 192, 193, 192, 197, 192, 200, 192, 201, 192, 204, 192, 208, 192, 216, 192, 217, 192, 219, 192, 220, 192, 221, 192, 228, 192, 229, 192, 232, 192, 236, 192, 244, 192, 245, 192, 247, 192, 249, 192, 0, 193, 4, 193, 8, 193, 16, 193, 21, 193, 28, 193, 29, 193, 30, 193, 31, 193, 32, 193, 35, 193, 36, 193, 38, 193, 39, 193, 44, 193, 45, 193, 47, 193, 48, 193, 49, 193, 54, 193, 56, 193, 57, 193, 60, 193, 64, 193, 72, 193, 73, 193, 75, 193, 76, 193, 77, 193, 84, 193, 85, 193, 88, 193, 92, 193, 100, 193, 101, 193, 103, 193, 104, 193, 105, 193, 112, 193, 116, 193, 120, 193, 133, 193, 140, 193, 141, 193, 142, 193, 144, 193, 148, 193, 150, 193, 156, 193, 157, 193, 159, 193, 161, 193, 165, 193, 168, 193, 169, 193, 172, 193, 176, 193, 189, 193, 196, 193, 200, 193, 204, 193, 212, 193, 215, 193, 216, 193, 224, 193, 228, 193, 232, 193, 240, 193, 241, 193, 243, 193, 252, 193, 253, 193, 0, 194, 4, 194, 12, 194, 13, 194, 15, 194, 17, 194, 24, 194, 25, 194, 28, 194, 31, 194, 32, 194, 40, 194, 41, 194, 43, 194, 45, 194, 47, 194, 49, 194, 50, 194, 52, 194, 72, 194, 80, 194, 81, 194, 84, 194, 88, 194, 96, 194, 101, 194, 108, 194, 109, 194, 112, 194, 116, 194, 124, 194, 125, 194, 127, 194, 129, 194, 136, 194, 137, 194, 144, 194, 152, 194, 155, 194, 157, 194, 164, 194, 165, 194, 168, 194, 172, 194, 173, 194, 180, 194, 181, 194, 183, 194, 185, 194, 220, 194, 221, 194, 224, 194, 227, 194, 228, 194, 235, 194, 236, 194, 237, 194, 239, 194, 241, 194, 246, 194, 248, 194, 249, 194, 251, 194, 252, 194, 0, 195, 8, 195, 9, 195, 12, 195, 13, 195, 19, 195, 20, 195, 21, 195, 24, 195, 28, 195, 36, 195, 37, 195, 40, 195, 41, 195, 69, 195, 104, 195, 105, 195, 108, 195, 112, 195, 114, 195, 120, 195, 121, 195, 124, 195, 125, 195, 132, 195, 136, 195, 140, 195, 192, 195, 216, 195, 217, 195, 220, 195, 223, 195, 224, 195, 226, 195, 232, 195, 233, 195, 237, 195, 244, 195, 245, 195, 248, 195, 8, 196, 16, 196, 36, 196, 44, 196, 48, 196, 52, 196, 60, 196, 61, 196, 72, 196, 100, 196, 101, 196, 104, 196, 108, 196, 116, 196, 117, 196, 121, 196, 128, 196, 148, 196, 156, 196, 184, 196, 188, 196, 233, 196, 240, 196, 241, 196, 244, 196, 248, 196, 250, 196, 255, 196, 0, 197, 1, 197, 12, 197, 16, 197, 20, 197, 28, 197, 40, 197, 41, 197, 44, 197, 48, 197, 56, 197, 57, 197, 59, 197, 61, 197, 68, 197, 69, 197, 72, 197, 73, 197, 74, 197, 76, 197, 77, 197, 78, 197, 83, 197, 84, 197, 85, 197, 87, 197, 88, 197, 89, 197, 93, 197, 94, 197, 96, 197, 97, 197, 100, 197, 104, 197, 112, 197, 113, 197, 115, 197, 116, 197, 117, 197, 124, 197, 125, 197, 128, 197, 132, 197, 135, 197, 140, 197, 141, 197, 143, 197, 145, 197, 149, 197, 151, 197, 152, 197, 156, 197, 160, 197, 169, 197, 180, 197, 181, 197, 184, 197, 185, 197, 187, 197, 188, 197, 189, 197, 190, 197, 196, 197, 197, 197, 198, 197, 199, 197, 200, 197, 201, 197, 202, 197, 204, 197, 206, 197, 208, 197, 209, 197, 212, 197, 216, 197, 224, 197, 225, 197, 227, 197, 229, 197, 236, 197, 237, 197, 238, 197, 240, 197, 244, 197, 246, 197, 247, 197, 252, 197, 253, 197, 254, 197, 255, 197, 0, 198, 1, 198, 5, 198, 6, 198, 7, 198, 8, 198, 12, 198, 16, 198, 24, 198, 25, 198, 27, 198, 28, 198, 36, 198, 37, 198, 40, 198, 44, 198, 45, 198, 46, 198, 48, 198, 51, 198, 52, 198, 53, 198, 55, 198, 57, 198, 59, 198, 64, 198, 65, 198, 68, 198, 72, 198, 80, 198, 81, 198, 83, 198, 84, 198, 85, 198, 92, 198, 93, 198, 96, 198, 108, 198, 111, 198, 113, 198, 120, 198, 121, 198, 124, 198, 128, 198, 136, 198, 137, 198, 139, 198, 141, 198, 148, 198, 149, 198, 152, 198, 156, 198, 164, 198, 165, 198, 167, 198, 169, 198, 176, 198, 177, 198, 180, 198, 184, 198, 185, 198, 186, 198, 192, 198, 193, 198, 195, 198, 197, 198, 204, 198, 205, 198, 208, 198, 212, 198, 220, 198, 221, 198, 224, 198, 225, 198, 232, 198, 233, 198, 236, 198, 240, 198, 248, 198, 249, 198, 253, 198, 4, 199, 5, 199, 8, 199, 12, 199, 20, 199, 21, 199, 23, 199, 25, 199, 32, 199, 33, 199, 36, 199, 40, 199, 48, 199, 49, 199, 51, 199, 53, 199, 55, 199, 60, 199, 61, 199, 64, 199, 68, 199, 74, 199, 76, 199, 77, 199, 79, 199, 81, 199, 82, 199, 83, 199, 84, 199, 85, 199, 86, 199, 87, 199, 88, 199, 92, 199, 96, 199, 104, 199, 107, 199, 116, 199, 117, 199, 120, 199, 124, 199, 125, 199, 126, 199, 131, 199, 132, 199, 133, 199, 135, 199, 136, 199, 137, 199, 138, 199, 142, 199, 144, 199, 145, 199, 148, 199, 150, 199, 151, 199, 152, 199, 154, 199, 160, 199, 161, 199, 163, 199, 164, 199, 165, 199, 166, 199, 172, 199, 173, 199, 176, 199, 180, 199, 188, 199, 189, 199, 191, 199, 192, 199, 193, 199, 200, 199, 201, 199, 204, 199, 206, 199, 208, 199, 216, 199, 221, 199, 228, 199, 232, 199, 236, 199, 0, 200, 1, 200, 4, 200, 8, 200, 10, 200, 16, 200, 17, 200, 19, 200, 21, 200, 22, 200, 28, 200, 29, 200, 32, 200, 36, 200, 44, 200, 45, 200, 47, 200, 49, 200, 56, 200, 60, 200, 64, 200, 72, 200, 73, 200, 76, 200, 77, 200, 84, 200, 112, 200, 113, 200, 116, 200, 120, 200, 122, 200, 128, 200, 129, 200, 131, 200, 133, 200, 134, 200, 135, 200, 139, 200, 140, 200, 141, 200, 148, 200, 157, 200, 159, 200, 161, 200, 168, 200, 188, 200, 189, 200, 196, 200, 200, 200, 204, 200, 212, 200, 213, 200, 215, 200, 217, 200, 224, 200, 225, 200, 228, 200, 245, 200, 252, 200, 253, 200, 0, 201, 4, 201, 5, 201, 6, 201, 12, 201, 13, 201, 15, 201, 17, 201, 24, 201, 44, 201, 52, 201, 80, 201, 81, 201, 84, 201, 88, 201, 96, 201, 97, 201, 99, 201, 108, 201, 112, 201, 116, 201, 124, 201, 136, 201, 137, 201, 140, 201, 144, 201, 152, 201, 153, 201, 155, 201, 157, 201, 192, 201, 193, 201, 196, 201, 199, 201, 200, 201, 202, 201, 208, 201, 209, 201, 211, 201, 213, 201, 214, 201, 217, 201, 218, 201, 220, 201, 221, 201, 224, 201, 226, 201, 228, 201, 231, 201, 236, 201, 237, 201, 239, 201, 240, 201, 241, 201, 248, 201, 249, 201, 252, 201, 0, 202, 8, 202, 9, 202, 11, 202, 12, 202, 13, 202, 20, 202, 24, 202, 41, 202, 76, 202, 77, 202, 80, 202, 84, 202, 92, 202, 93, 202, 95, 202, 96, 202, 97, 202, 104, 202, 125, 202, 132, 202, 152, 202, 188, 202, 189, 202, 192, 202, 196, 202, 204, 202, 205, 202, 207, 202, 209, 202, 211, 202, 216, 202, 217, 202, 224, 202, 236, 202, 244, 202, 8, 203, 16, 203, 20, 203, 24, 203, 32, 203, 33, 203, 65, 203, 72, 203, 73, 203, 76, 203, 80, 203, 88, 203, 89, 203, 93, 203, 100, 203, 120, 203, 121, 203, 156, 203, 184, 203, 212, 203, 228, 203, 231, 203, 233, 203, 12, 204, 13, 204, 16, 204, 20, 204, 28, 204, 29, 204, 33, 204, 34, 204, 39, 204, 40, 204, 41, 204, 44, 204, 46, 204, 48, 204, 56, 204, 57, 204, 59, 204, 60, 204, 61, 204, 62, 204, 68, 204, 69, 204, 72, 204, 76, 204, 84, 204, 85, 204, 87, 204, 88, 204, 89, 204, 96, 204, 100, 204, 102, 204, 104, 204, 112, 204, 117, 204, 152, 204, 153, 204, 156, 204, 160, 204, 168, 204, 169, 204, 171, 204, 172, 204, 173, 204, 180, 204, 181, 204, 184, 204, 188, 204, 196, 204, 197, 204, 199, 204, 201, 204, 208, 204, 212, 204, 228, 204, 236, 204, 240, 204, 1, 205, 8, 205, 9, 205, 12, 205, 16, 205, 24, 205, 25, 205, 27, 205, 29, 205, 36, 205, 40, 205, 44, 205, 57, 205, 92, 205, 96, 205, 100, 205, 108, 205, 109, 205, 111, 205, 113, 205, 120, 205, 136, 205, 148, 205, 149, 205, 152, 205, 156, 205, 164, 205, 165, 205, 167, 205, 169, 205, 176, 205, 196, 205, 204, 205, 208, 205, 232, 205, 236, 205, 240, 205, 248, 205, 249, 205, 251, 205, 253, 205, 4, 206, 8, 206, 12, 206, 20, 206, 25, 206, 32, 206, 33, 206, 36, 206, 40, 206, 48, 206, 49, 206, 51, 206, 53, 206, 88, 206, 89, 206, 92, 206, 95, 206, 96, 206, 97, 206, 104, 206, 105, 206, 107, 206, 109, 206, 116, 206, 117, 206, 120, 206, 124, 206, 132, 206, 133, 206, 135, 206, 137, 206, 144, 206, 145, 206, 148, 206, 152, 206, 160, 206, 161, 206, 163, 206, 164, 206, 165, 206, 172, 206, 173, 206, 193, 206, 228, 206, 229, 206, 232, 206, 235, 206, 236, 206, 244, 206, 245, 206, 247, 206, 248, 206, 249, 206, 0, 207, 1, 207, 4, 207, 8, 207, 16, 207, 17, 207, 19, 207, 21, 207, 28, 207, 32, 207, 36, 207, 44, 207, 45, 207, 47, 207, 48, 207, 49, 207, 56, 207, 84, 207, 85, 207, 88, 207, 92, 207, 100, 207, 101, 207, 103, 207, 105, 207, 112, 207, 113, 207, 116, 207, 120, 207, 128, 207, 133, 207, 140, 207, 161, 207, 168, 207, 176, 207, 196, 207, 224, 207, 225, 207, 228, 207, 232, 207, 240, 207, 241, 207, 243, 207, 245, 207, 252, 207, 0, 208, 4, 208, 17, 208, 24, 208, 45, 208, 52, 208, 53, 208, 56, 208, 60, 208, 68, 208, 69, 208, 71, 208, 73, 208, 80, 208, 84, 208, 88, 208, 96, 208, 108, 208, 109, 208, 112, 208, 116, 208, 124, 208, 125, 208, 129, 208, 164, 208, 165, 208, 168, 208, 172, 208, 180, 208, 181, 208, 183, 208, 185, 208, 192, 208, 193, 208, 196, 208, 200, 208, 201, 208, 208, 208, 209, 208, 211, 208, 212, 208, 213, 208, 220, 208, 221, 208, 224, 208, 228, 208, 236, 208, 237, 208, 239, 208, 240, 208, 241, 208, 248, 208, 13, 209, 48, 209, 49, 209, 52, 209, 56, 209, 58, 209, 64, 209, 65, 209, 67, 209, 68, 209, 69, 209, 76, 209, 77, 209, 80, 209, 84, 209, 92, 209, 93, 209, 95, 209, 97, 209, 104, 209, 108, 209, 124, 209, 132, 209, 136, 209, 160, 209, 161, 209, 164, 209, 168, 209, 176, 209, 177, 209, 179, 209, 181, 209, 186, 209, 188, 209, 192, 209, 216, 209, 244, 209, 248, 209, 7, 210, 9, 210, 16, 210, 44, 210, 45, 210, 48, 210, 52, 210, 60, 210, 61, 210, 63, 210, 65, 210, 72, 210, 92, 210, 100, 210, 128, 210, 129, 210, 132, 210, 136, 210, 144, 210, 145, 210, 149, 210, 156, 210, 160, 210, 164, 210, 172, 210, 177, 210, 184, 210, 185, 210, 188, 210, 191, 210, 192, 210, 194, 210, 200, 210, 201, 210, 203, 210, 212, 210, 216, 210, 220, 210, 228, 210, 229, 210, 240, 210, 241, 210, 244, 210, 248, 210, 0, 211, 1, 211, 3, 211, 5, 211, 12, 211, 13, 211, 14, 211, 16, 211, 20, 211, 22, 211, 28, 211, 29, 211, 31, 211, 32, 211, 33, 211, 37, 211, 40, 211, 41, 211, 44, 211, 48, 211, 56, 211, 57, 211, 59, 211, 60, 211, 61, 211, 68, 211, 69, 211, 124, 211, 125, 211, 128, 211, 132, 211, 140, 211, 141, 211, 143, 211, 144, 211, 145, 211, 152, 211, 153, 211, 156, 211, 160, 211, 168, 211, 169, 211, 171, 211, 173, 211, 180, 211, 184, 211, 188, 211, 196, 211, 197, 211, 200, 211, 201, 211, 208, 211, 216, 211, 225, 211, 227, 211, 236, 211, 237, 211, 240, 211, 244, 211, 252, 211, 253, 211, 255, 211, 1, 212, 8, 212, 29, 212, 64, 212, 68, 212, 92, 212, 96, 212, 100, 212, 109, 212, 111, 212, 120, 212, 121, 212, 124, 212, 127, 212, 128, 212, 130, 212, 136, 212, 137, 212, 139, 212, 141, 212, 148, 212, 169, 212, 204, 212, 208, 212, 212, 212, 220, 212, 223, 212, 232, 212, 236, 212, 240, 212, 248, 212, 251, 212, 253, 212, 4, 213, 8, 213, 12, 213, 20, 213, 21, 213, 23, 213, 60, 213, 61, 213, 64, 213, 68, 213, 76, 213, 77, 213, 79, 213, 81, 213, 88, 213, 89, 213, 92, 213, 96, 213, 101, 213, 104, 213, 105, 213, 107, 213, 109, 213, 116, 213, 117, 213, 120, 213, 124, 213, 132, 213, 133, 213, 135, 213, 136, 213, 137, 213, 144, 213, 165, 213, 200, 213, 201, 213, 204, 213, 208, 213, 210, 213, 216, 213, 217, 213, 219, 213, 221, 213, 228, 213, 229, 213, 232, 213, 236, 213, 244, 213, 245, 213, 247, 213, 249, 213, 0, 214, 1, 214, 4, 214, 8, 214, 16, 214, 17, 214, 19, 214, 20, 214, 21, 214, 28, 214, 32, 214, 36, 214, 45, 214, 56, 214, 57, 214, 60, 214, 64, 214, 69, 214, 72, 214, 73, 214, 75, 214, 77, 214, 81, 214, 84, 214, 85, 214, 88, 214, 92, 214, 103, 214, 105, 214, 112, 214, 113, 214, 116, 214, 131, 214, 133, 214, 140, 214, 141, 214, 144, 214, 148, 214, 157, 214, 159, 214, 161, 214, 168, 214, 172, 214, 176, 214, 185, 214, 187, 214, 196, 214, 197, 214, 200, 214, 204, 214, 209, 214, 212, 214, 215, 214, 217, 214, 224, 214, 228, 214, 232, 214, 240, 214, 245, 214, 252, 214, 253, 214, 0, 215, 4, 215, 17, 215, 24, 215, 25, 215, 28, 215, 32, 215, 40, 215, 41, 215, 43, 215, 45, 215, 52, 215, 53, 215, 56, 215, 60, 215, 68, 215, 71, 215, 73, 215, 80, 215, 81, 215, 84, 215, 86, 215, 87, 215, 88, 215, 89, 215, 96, 215, 97, 215, 99, 215, 101, 215, 105, 215, 108, 215, 112, 215, 116, 215, 124, 215, 125, 215, 129, 215, 136, 215, 137, 215, 140, 215, 144, 215, 152, 215, 153, 215, 155, 215, 157, 215, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 79, 115, 79, 71, 80, 249, 80, 160, 82, 239, 83, 117, 84, 229, 84, 9, 86, 193, 90, 182, 91, 135, 102, 182, 103, 183, 103, 239, 103, 76, 107, 194, 115, 194, 117, 60, 122, 219, 130, 4, 131, 87, 136, 136, 136, 54, 138, 200, 140, 207, 141, 251, 142, 230, 143, 213, 153, 59, 82, 116, 83, 4, 84, 106, 96, 100, 97, 188, 107, 207, 115, 26, 129, 186, 137, 210, 137, 163, 149, 131, 79, 10, 82, 190, 88, 120, 89, 230, 89, 114, 94, 121, 94, 199, 97, 192, 99, 70, 103, 236, 103, 127, 104, 151, 111, 78, 118, 11, 119, 245, 120, 8, 122, 255, 122, 33, 124, 157, 128, 110, 130, 113, 130, 235, 138, 147, 149, 107, 78, 157, 85, 247, 102, 52, 110, 163, 120, 237, 122, 91, 132, 16, 137, 78, 135, 168, 151, 216, 82, 78, 87, 42, 88, 76, 93, 31, 97, 190, 97, 33, 98, 98, 101, 209, 103, 68, 106, 27, 110, 24, 117, 179, 117, 227, 118, 176, 119, 58, 125, 175, 144, 81, 148, 82, 148, 149, 159, 35, 83, 172, 92, 50, 117, 219, 128, 64, 146, 152, 149, 91, 82, 8, 88, 220, 89, 161, 92, 23, 93, 183, 94, 58, 95, 74, 95, 119, 97, 95, 108, 122, 117, 134, 117, 224, 124, 115, 125, 177, 125, 140, 127, 84, 129, 33, 130, 145, 133, 65, 137, 27, 139, 252, 146, 77, 150, 71, 156, 203, 78, 247, 78, 11, 80, 241, 81, 79, 88, 55, 97, 62, 97, 104, 97, 57, 101, 234, 105, 17, 111, 165, 117, 134, 118, 214, 118, 135, 123, 165, 130, 203, 132, 0, 249, 167, 147, 139, 149, 128, 85, 162, 91, 81, 87, 1, 249, 179, 124, 185, 127, 181, 145, 40, 80, 187, 83, 69, 92, 232, 93, 210, 98, 110, 99, 218, 100, 231, 100, 32, 110, 172, 112, 91, 121, 221, 141, 30, 142, 2, 249, 125, 144, 69, 146, 248, 146, 126, 78, 246, 78, 101, 80, 254, 93, 250, 94, 6, 97, 87, 105, 113, 129, 84, 134, 71, 142, 117, 147, 43, 154, 94, 78, 145, 80, 112, 103, 64, 104, 9, 81, 141, 82, 146, 82, 162, 106, 188, 119, 16, 146, 212, 158, 171, 82, 47, 96, 242, 143, 72, 80, 169, 97, 237, 99, 202, 100, 60, 104, 132, 106, 192, 111, 136, 129, 161, 137, 148, 150, 5, 88, 125, 114, 172, 114, 4, 117, 121, 125, 109, 126, 169, 128, 139, 137, 116, 139, 99, 144, 81, 157, 137, 98, 122, 108, 84, 111, 80, 125, 58, 127, 35, 138, 124, 81, 74, 97, 157, 123, 25, 139, 87, 146, 140, 147, 172, 78, 211, 79, 30, 80, 190, 80, 6, 81, 193, 82, 205, 82, 127, 83, 112, 87, 131, 88, 154, 94, 145, 95, 118, 97, 172, 97, 206, 100, 108, 101, 111, 102, 187, 102, 244, 102, 151, 104, 135, 109, 133, 112, 241, 112, 159, 116, 165, 116, 202, 116, 217, 117, 108, 120, 236, 120, 223, 122, 246, 122, 69, 125, 147, 125, 21, 128, 63, 128, 27, 129, 150, 131, 102, 139, 21, 143, 21, 144, 225, 147, 3, 152, 56, 152, 90, 154, 232, 155, 194, 79, 83, 85, 58, 88, 81, 89, 99, 91, 70, 92, 184, 96, 18, 98, 66, 104, 176, 104, 232, 104, 170, 110, 76, 117, 120, 118, 206, 120, 61, 122, 251, 124, 107, 126, 124, 126, 8, 138, 161, 138, 63, 140, 142, 150, 196, 157, 228, 83, 233, 83, 74, 84, 113, 84, 250, 86, 209, 89, 100, 91, 59, 92, 171, 94, 247, 98, 55, 101, 69, 101, 114, 101, 160, 102, 175, 103, 193, 105, 189, 108, 252, 117, 144, 118, 126, 119, 63, 122, 148, 127, 3, 128, 161, 128, 143, 129, 230, 130, 253, 130, 240, 131, 193, 133, 49, 136, 180, 136, 165, 138, 3, 249, 156, 143, 46, 147, 199, 150, 103, 152, 216, 154, 19, 159, 237, 84, 155, 101, 242, 102, 143, 104, 64, 122, 55, 140, 96, 157, 240, 86, 100, 87, 17, 93, 6, 102, 177, 104, 205, 104, 254, 110, 40, 116, 158, 136, 228, 155, 104, 108, 4, 249, 168, 154, 155, 79, 108, 81, 113, 81, 159, 82, 84, 91, 229, 93, 80, 96, 109, 96, 241, 98, 167, 99, 59, 101, 217, 115, 122, 122, 163, 134, 162, 140, 143, 151, 50, 78, 225, 91, 8, 98, 156, 103, 220, 116, 209, 121, 211, 131, 135, 138, 178, 138, 232, 141, 78, 144, 75, 147, 70, 152, 211, 94, 232, 105, 255, 133, 237, 144, 5, 249, 160, 81, 152, 91, 236, 91, 99, 97, 250, 104, 62, 107, 76, 112, 47, 116, 216, 116, 161, 123, 80, 127, 197, 131, 192, 137, 171, 140, 220, 149, 40, 153, 46, 82, 93, 96, 236, 98, 2, 144, 138, 79, 73, 81, 33, 83, 217, 88, 227, 94, 224, 102, 56, 109, 154, 112, 194, 114, 214, 115, 80, 123, 241, 128, 91, 148, 102, 83, 155, 99, 107, 127, 86, 78, 128, 80, 74, 88, 222, 88, 42, 96, 39, 97, 208, 98, 208, 105, 65, 155, 143, 91, 24, 125, 177, 128, 95, 143, 164, 78, 209, 80, 172, 84, 172, 85, 12, 91, 160, 93, 231, 93, 42, 101, 78, 101, 33, 104, 75, 106, 225, 114, 142, 118, 239, 119, 94, 125, 249, 127, 160, 129, 78, 133, 223, 134, 3, 143, 78, 143, 202, 144, 3, 153, 85, 154, 171, 155, 24, 78, 69, 78, 93, 78, 199, 78, 241, 79, 119, 81, 254, 82, 64, 83, 227, 83, 229, 83, 142, 84, 20, 86, 117, 87, 162, 87, 199, 91, 135, 93, 208, 94, 252, 97, 216, 98, 81, 101, 184, 103, 233, 103, 203, 105, 80, 107, 198, 107, 236, 107, 66, 108, 157, 110, 120, 112, 215, 114, 150, 115, 3, 116, 191, 119, 233, 119, 118, 122, 127, 125, 9, 128, 252, 129, 5, 130, 10, 130, 223, 130, 98, 136, 51, 139, 252, 140, 192, 142, 17, 144, 177, 144, 100, 146, 182, 146, 210, 153, 69, 154, 233, 156, 215, 157, 156, 159, 11, 87, 64, 92, 202, 131, 160, 151, 171, 151, 180, 158, 27, 84, 152, 122, 164, 127, 217, 136, 205, 142, 225, 144, 0, 88, 72, 92, 152, 99, 159, 122, 174, 91, 19, 95, 121, 122, 174, 122, 142, 130, 172, 142, 38, 80, 56, 82, 248, 82, 119, 83, 8, 87, 243, 98, 114, 99, 10, 107, 195, 109, 55, 119, 165, 83, 87, 115, 104, 133, 118, 142, 213, 149, 58, 103, 195, 106, 112, 111, 109, 138, 204, 142, 75, 153, 6, 249, 119, 102, 120, 107, 180, 140, 60, 155, 7, 249, 235, 83, 45, 87, 78, 89, 198, 99, 251, 105, 234, 115, 69, 120, 186, 122, 197, 122, 254, 124, 117, 132, 143, 137, 115, 141, 53, 144, 168, 149, 251, 82, 71, 87, 71, 117, 96, 123, 204, 131, 30, 146, 8, 249, 88, 106, 75, 81, 75, 82, 135, 82, 31, 98, 216, 104, 117, 105, 153, 150, 197, 80, 164, 82, 228, 82, 195, 97, 164, 101, 57, 104, 255, 105, 126, 116, 75, 123, 185, 130, 235, 131, 178, 137, 57, 139, 209, 143, 73, 153, 9, 249, 202, 78, 151, 89, 210, 100, 17, 102, 142, 106, 52, 116, 129, 121, 189, 121, 169, 130, 126, 136, 127, 136, 95, 137, 10, 249, 38, 147, 11, 79, 202, 83, 37, 96, 113, 98, 114, 108, 26, 125, 102, 125, 152, 78, 98, 81, 220, 119, 175, 128, 1, 79, 14, 79, 118, 81, 128, 81, 220, 85, 104, 86, 59, 87, 250, 87, 252, 87, 20, 89, 71, 89, 147, 89, 196, 91, 144, 92, 14, 93, 241, 93, 126, 94, 204, 95, 128, 98, 215, 101, 227, 101, 30, 103, 31, 103, 94, 103, 203, 104, 196, 104, 95, 106, 58, 107, 35, 108, 125, 108, 130, 108, 199, 109, 152, 115, 38, 116, 42, 116, 130, 116, 163, 116, 120, 117, 127, 117, 129, 120, 239, 120, 65, 121, 71, 121, 72, 121, 122, 121, 149, 123, 0, 125, 186, 125, 136, 127, 6, 128, 45, 128, 140, 128, 24, 138, 79, 139, 72, 140, 119, 141, 33, 147, 36, 147, 226, 152, 81, 153, 14, 154, 15, 154, 101, 154, 146, 158, 202, 125, 118, 79, 9, 84, 238, 98, 84, 104, 209, 145, 171, 85, 58, 81, 11, 249, 12, 249, 28, 90, 230, 97, 13, 249, 207, 98, 255, 98, 14, 249, 15, 249, 16, 249, 17, 249, 18, 249, 19, 249, 163, 144, 20, 249, 21, 249, 22, 249, 23, 249, 24, 249, 254, 138, 25, 249, 26, 249, 27, 249, 28, 249, 150, 102, 29, 249, 86, 113, 30, 249, 31, 249, 227, 150, 32, 249, 79, 99, 122, 99, 87, 83, 33, 249, 143, 103, 96, 105, 115, 110, 34, 249, 55, 117, 35, 249, 36, 249, 37, 249, 13, 125, 38, 249, 39, 249, 114, 136, 202, 86, 24, 90, 40, 249, 41, 249, 42, 249, 43, 249, 44, 249, 67, 78, 45, 249, 103, 81, 72, 89, 240, 103, 16, 128, 46, 249, 115, 89, 116, 94, 154, 100, 202, 121, 245, 95, 108, 96, 200, 98, 123, 99, 231, 91, 215, 91, 170, 82, 47, 249, 116, 89, 41, 95, 18, 96, 48, 249, 49, 249, 50, 249, 89, 116, 51, 249, 52, 249, 53, 249, 54, 249, 55, 249, 56, 249, 209, 153, 57, 249, 58, 249, 59, 249, 60, 249, 61, 249, 62, 249, 63, 249, 64, 249, 65, 249, 66, 249, 67, 249, 195, 111, 68, 249, 69, 249, 191, 129, 178, 143, 241, 96, 70, 249, 71, 249, 102, 129, 72, 249, 73, 249, 63, 92, 74, 249, 75, 249, 76, 249, 77, 249, 78, 249, 79, 249, 80, 249, 81, 249, 233, 90, 37, 138, 123, 103, 16, 125, 82, 249, 83, 249, 84, 249, 85, 249, 86, 249, 87, 249, 253, 128, 88, 249, 89, 249, 60, 92, 229, 108, 63, 83, 186, 110, 26, 89, 54, 131, 57, 78, 182, 78, 70, 79, 174, 85, 24, 87, 199, 88, 86, 95, 183, 101, 230, 101, 128, 106, 181, 107, 77, 110, 237, 119, 239, 122, 30, 124, 222, 125, 203, 134, 146, 136, 50, 145, 91, 147, 187, 100, 190, 111, 122, 115, 184, 117, 84, 144, 86, 85, 77, 87, 186, 97, 212, 100, 199, 102, 225, 109, 91, 110, 109, 111, 185, 111, 240, 117, 67, 128, 189, 129, 65, 133, 131, 137, 199, 138, 90, 139, 31, 147, 147, 108, 83, 117, 84, 123, 15, 142, 93, 144, 16, 85, 2, 88, 88, 88, 98, 94, 7, 98, 158, 100, 224, 104, 118, 117, 214, 124, 179, 135, 232, 158, 227, 78, 136, 87, 110, 87, 39, 89, 13, 92, 177, 92, 54, 94, 133, 95, 52, 98, 225, 100, 179, 115, 250, 129, 139, 136, 184, 140, 138, 150, 219, 158, 133, 91, 183, 95, 179, 96, 18, 80, 0, 82, 48, 82, 22, 87, 53, 88, 87, 88, 14, 92, 96, 92, 246, 92, 139, 93, 166, 94, 146, 95, 188, 96, 17, 99, 137, 99, 23, 100, 67, 104, 249, 104, 194, 106, 216, 109, 33, 110, 212, 110, 228, 111, 254, 113, 220, 118, 121, 119, 177, 121, 59, 122, 4, 132, 169, 137, 237, 140, 243, 141, 72, 142, 3, 144, 20, 144, 83, 144, 253, 144, 77, 147, 118, 150, 220, 151, 210, 107, 6, 112, 88, 114, 162, 114, 104, 115, 99, 119, 191, 121, 228, 123, 155, 126, 128, 139, 169, 88, 199, 96, 102, 101, 253, 101, 190, 102, 140, 108, 30, 113, 201, 113, 90, 140, 19, 152, 109, 78, 129, 122, 221, 78, 172, 81, 205, 81, 213, 82, 12, 84, 167, 97, 113, 103, 80, 104, 223, 104, 30, 109, 124, 111, 188, 117, 179, 119, 229, 122, 244, 128, 99, 132, 133, 146, 92, 81, 151, 101, 92, 103, 147, 103, 216, 117, 199, 122, 115, 131, 90, 249, 70, 140, 23, 144, 45, 152, 111, 92, 192, 129, 154, 130, 65, 144, 111, 144, 13, 146, 151, 95, 157, 93, 89, 106, 200, 113, 123, 118, 73, 123, 228, 133, 4, 139, 39, 145, 48, 154, 135, 85, 246, 97, 91, 249, 105, 118, 133, 127, 63, 134, 186, 135, 248, 136, 143, 144, 92, 249, 27, 109, 217, 112, 222, 115, 97, 125, 61, 132, 93, 249, 106, 145, 241, 153, 94, 249, 130, 78, 117, 83, 4, 107, 18, 107, 62, 112, 27, 114, 45, 134, 30, 158, 76, 82, 163, 143, 80, 93, 229, 100, 44, 101, 22, 107, 235, 111, 67, 124, 156, 126, 205, 133, 100, 137, 189, 137, 201, 98, 216, 129, 31, 136, 202, 94, 23, 103, 106, 109, 252, 114, 5, 116, 111, 116, 130, 135, 222, 144, 134, 79, 13, 93, 160, 95, 10, 132, 183, 81, 160, 99, 101, 117, 174, 78, 6, 80, 105, 81, 201, 81, 129, 104, 17, 106, 174, 124, 177, 124, 231, 124, 111, 130, 210, 138, 27, 143, 207, 145, 182, 79, 55, 81, 245, 82, 66, 84, 236, 94, 110, 97, 62, 98, 197, 101, 218, 106, 254, 111, 42, 121, 220, 133, 35, 136, 173, 149, 98, 154, 106, 154, 151, 158, 206, 158, 155, 82, 198, 102, 119, 107, 29, 112, 43, 121, 98, 143, 66, 151, 144, 97, 0, 98, 35, 101, 35, 111, 73, 113, 137, 116, 244, 125, 111, 128, 238, 132, 38, 143, 35, 144, 74, 147, 189, 81, 23, 82, 163, 82, 12, 109, 200, 112, 194, 136, 201, 94, 130, 101, 174, 107, 194, 111, 62, 124, 117, 115, 228, 78, 54, 79, 249, 86, 95, 249, 186, 92, 186, 93, 28, 96, 178, 115, 45, 123, 154, 127, 206, 127, 70, 128, 30, 144, 52, 146, 246, 150, 72, 151, 24, 152, 97, 159, 139, 79, 167, 111, 174, 121, 180, 145, 183, 150, 222, 82, 96, 249, 136, 100, 196, 100, 211, 106, 94, 111, 24, 112, 16, 114, 231, 118, 1, 128, 6, 134, 92, 134, 239, 141, 5, 143, 50, 151, 111, 155, 250, 157, 117, 158, 140, 120, 127, 121, 160, 125, 201, 131, 4, 147, 127, 158, 147, 158, 214, 138, 223, 88, 4, 95, 39, 103, 39, 112, 207, 116, 96, 124, 126, 128, 33, 81, 40, 112, 98, 114, 202, 120, 194, 140, 218, 140, 244, 140, 247, 150, 134, 78, 218, 80, 238, 91, 214, 94, 153, 101, 206, 113, 66, 118, 173, 119, 74, 128, 252, 132, 124, 144, 39, 155, 141, 159, 216, 88, 65, 90, 98, 92, 19, 106, 218, 109, 15, 111, 59, 118, 47, 125, 55, 126, 30, 133, 56, 137, 228, 147, 75, 150, 137, 82, 210, 101, 243, 103, 180, 105, 65, 109, 156, 110, 15, 112, 9, 116, 96, 116, 89, 117, 36, 118, 107, 120, 44, 139, 94, 152, 109, 81, 46, 98, 120, 150, 150, 79, 43, 80, 25, 93, 234, 109, 184, 125, 42, 143, 139, 95, 68, 97, 23, 104, 97, 249, 134, 150, 210, 82, 139, 128, 220, 81, 204, 81, 94, 105, 28, 122, 190, 125, 241, 131, 117, 150, 218, 79, 41, 82, 152, 83, 15, 84, 14, 85, 101, 92, 167, 96, 78, 103, 168, 104, 108, 109, 129, 114, 248, 114, 6, 116, 131, 116, 98, 249, 226, 117, 108, 124, 121, 127, 184, 127, 137, 131, 207, 136, 225, 136, 204, 145, 208, 145, 226, 150, 201, 155, 29, 84, 126, 111, 208, 113, 152, 116, 250, 133, 170, 142, 163, 150, 87, 156, 159, 158, 151, 103, 203, 109, 51, 116, 232, 129, 22, 151, 44, 120, 203, 122, 32, 123, 146, 124, 105, 100, 106, 116, 242, 117, 188, 120, 232, 120, 172, 153, 84, 155, 187, 158, 222, 91, 85, 94, 32, 111, 156, 129, 171, 131, 136, 144, 7, 78, 77, 83, 41, 90, 210, 93, 78, 95, 98, 97, 61, 99, 105, 102, 252, 102, 255, 110, 43, 111, 99, 112, 158, 119, 44, 132, 19, 133, 59, 136, 19, 143, 69, 153, 59, 156, 28, 85, 185, 98, 43, 103, 171, 108, 9, 131, 106, 137, 122, 151, 161, 78, 132, 89, 216, 95, 217, 95, 27, 103, 178, 125, 84, 127, 146, 130, 43, 131, 189, 131, 30, 143, 153, 144, 203, 87, 185, 89, 146, 90, 208, 91, 39, 102, 154, 103, 133, 104, 207, 107, 100, 113, 117, 127, 183, 140, 227, 140, 129, 144, 69, 155, 8, 129, 138, 140, 76, 150, 64, 154, 165, 158, 95, 91, 19, 108, 27, 115, 242, 118, 223, 118, 12, 132, 170, 81, 147, 137, 77, 81, 149, 81, 201, 82, 201, 104, 148, 108, 4, 119, 32, 119, 191, 125, 236, 125, 98, 151, 181, 158, 197, 110, 17, 133, 165, 81, 13, 84, 125, 84, 14, 102, 157, 102, 39, 105, 159, 110, 191, 118, 145, 119, 23, 131, 194, 132, 159, 135, 105, 145, 152, 146, 244, 156, 130, 136, 174, 79, 146, 81, 223, 82, 198, 89, 61, 94, 85, 97, 120, 100, 121, 100, 174, 102, 208, 103, 33, 106, 205, 107, 219, 107, 95, 114, 97, 114, 65, 116, 56, 119, 219, 119, 23, 128, 188, 130, 5, 131, 0, 139, 40, 139, 140, 140, 40, 103, 144, 108, 103, 114, 238, 118, 102, 119, 70, 122, 169, 157, 127, 107, 146, 108, 34, 89, 38, 103, 153, 132, 111, 83, 147, 88, 153, 89, 223, 94, 207, 99, 52, 102, 115, 103, 58, 110, 43, 115, 215, 122, 215, 130, 40, 147, 217, 82, 235, 93, 174, 97, 203, 97, 10, 98, 199, 98, 171, 100, 224, 101, 89, 105, 102, 107, 203, 107, 33, 113, 247, 115, 93, 117, 70, 126, 30, 130, 2, 131, 106, 133, 163, 138, 191, 140, 39, 151, 97, 157, 168, 88, 216, 158, 17, 80, 14, 82, 59, 84, 79, 85, 135, 101, 118, 108, 10, 125, 11, 125, 94, 128, 138, 134, 128, 149, 239, 150, 255, 82, 149, 108, 105, 114, 115, 84, 154, 90, 62, 92, 75, 93, 76, 95, 174, 95, 42, 103, 182, 104, 99, 105, 60, 110, 68, 110, 9, 119, 115, 124, 142, 127, 135, 133, 14, 139, 247, 143, 97, 151, 244, 158, 183, 92, 182, 96, 13, 97, 171, 97, 79, 101, 251, 101, 252, 101, 17, 108, 239, 108, 159, 115, 201, 115, 225, 125, 148, 149, 198, 91, 28, 135, 16, 139, 93, 82, 90, 83, 205, 98, 15, 100, 178, 100, 52, 103, 56, 106, 202, 108, 192, 115, 158, 116, 148, 123, 149, 124, 27, 126, 138, 129, 54, 130, 132, 133, 235, 143, 249, 150, 193, 153, 52, 79, 74, 83, 205, 83, 219, 83, 204, 98, 44, 100, 0, 101, 145, 101, 195, 105, 238, 108, 88, 111, 237, 115, 84, 117, 34, 118, 228, 118, 252, 118, 208, 120, 251, 120, 44, 121, 70, 125, 44, 130, 224, 135, 212, 143, 18, 152, 239, 152, 195, 82, 212, 98, 165, 100, 36, 110, 81, 111, 124, 118, 203, 141, 177, 145, 98, 146, 238, 154, 67, 155, 35, 80, 141, 80, 74, 87, 168, 89, 40, 92, 71, 94, 119, 95, 63, 98, 62, 101, 185, 101, 193, 101, 9, 102, 139, 103, 156, 105, 194, 110, 197, 120, 33, 125, 170, 128, 128, 129, 43, 130, 179, 130, 161, 132, 140, 134, 42, 138, 23, 139, 166, 144, 50, 150, 144, 159, 13, 80, 243, 79, 99, 249, 249, 87, 152, 95, 220, 98, 146, 99, 111, 103, 67, 110, 25, 113, 195, 118, 204, 128, 218, 128, 244, 136, 245, 136, 25, 137, 224, 140, 41, 143, 77, 145, 106, 150, 47, 79, 112, 79, 27, 94, 207, 103, 34, 104, 125, 118, 126, 118, 68, 155, 97, 94, 10, 106, 105, 113, 212, 113, 106, 117, 100, 249, 65, 126, 67, 133, 233, 133, 220, 152, 16, 79, 79, 123, 112, 127, 165, 149, 225, 81, 6, 94, 181, 104, 62, 108, 78, 108, 219, 108, 175, 114, 196, 123, 3, 131, 213, 108, 58, 116, 251, 80, 136, 82, 193, 88, 216, 100, 151, 106, 167, 116, 86, 118, 167, 120, 23, 134, 226, 149, 57, 151, 101, 249, 94, 83, 1, 95, 138, 139, 168, 143, 175, 143, 138, 144, 37, 82, 165, 119, 73, 156, 8, 159, 25, 78, 2, 80, 117, 81, 91, 92, 119, 94, 30, 102, 58, 102, 196, 103, 197, 104, 179, 112, 1, 117, 197, 117, 201, 121, 221, 122, 39, 143, 32, 153, 8, 154, 221, 79, 33, 88, 49, 88, 246, 91, 110, 102, 101, 107, 17, 109, 122, 110, 125, 111, 228, 115, 43, 117, 233, 131, 220, 136, 19, 137, 92, 139, 20, 143, 15, 79, 213, 80, 16, 83, 92, 83, 147, 91, 169, 95, 13, 103, 143, 121, 121, 129, 47, 131, 20, 133, 7, 137, 134, 137, 57, 143, 59, 143, 165, 153, 18, 156, 44, 103, 118, 78, 248, 79, 73, 89, 1, 92, 239, 92, 240, 92, 103, 99, 210, 104, 253, 112, 162, 113, 43, 116, 43, 126, 236, 132, 2, 135, 34, 144, 210, 146, 243, 156, 13, 78, 216, 78, 239, 79, 133, 80, 86, 82, 111, 82, 38, 84, 144, 84, 224, 87, 43, 89, 102, 90, 90, 91, 117, 91, 204, 91, 156, 94, 102, 249, 118, 98, 119, 101, 167, 101, 110, 109, 165, 110, 54, 114, 38, 123, 63, 124, 54, 127, 80, 129, 81, 129, 154, 129, 64, 130, 153, 130, 169, 131, 3, 138, 160, 140, 230, 140, 251, 140, 116, 141, 186, 141, 232, 144, 220, 145, 28, 150, 68, 150, 217, 153, 231, 156, 23, 83, 6, 82, 41, 84, 116, 86, 179, 88, 84, 89, 110, 89, 255, 95, 164, 97, 110, 98, 16, 102, 126, 108, 26, 113, 198, 118, 137, 124, 222, 124, 27, 125, 172, 130, 193, 140, 240, 150, 103, 249, 91, 79, 23, 95, 127, 95, 194, 98, 41, 93, 11, 103, 218, 104, 124, 120, 67, 126, 108, 157, 21, 78, 153, 80, 21, 83, 42, 83, 81, 83, 131, 89, 98, 90, 135, 94, 178, 96, 138, 97, 73, 98, 121, 98, 144, 101, 135, 103, 167, 105, 212, 107, 214, 107, 215, 107, 216, 107, 184, 108, 104, 249, 53, 116, 250, 117, 18, 120, 145, 120, 213, 121, 216, 121, 131, 124, 203, 125, 225, 127, 165, 128, 62, 129, 194, 129, 242, 131, 26, 135, 232, 136, 185, 138, 108, 139, 187, 140, 25, 145, 94, 151, 219, 152, 59, 159, 172, 86, 42, 91, 108, 95, 140, 101, 179, 106, 175, 107, 92, 109, 241, 111, 21, 112, 93, 114, 173, 115, 167, 140, 211, 140, 59, 152, 145, 97, 55, 108, 88, 128, 1, 154, 77, 78, 139, 78, 155, 78, 213, 78, 58, 79, 60, 79, 127, 79, 223, 79, 255, 80, 242, 83, 248, 83, 6, 85, 227, 85, 219, 86, 235, 88, 98, 89, 17, 90, 235, 91, 250, 91, 4, 92, 243, 93, 43, 94, 153, 95, 29, 96, 104, 99, 156, 101, 175, 101, 246, 103, 251, 103, 173, 104, 123, 107, 153, 108, 215, 108, 35, 110, 9, 112, 69, 115, 2, 120, 62, 121, 64, 121, 96, 121, 193, 121, 233, 123, 23, 125, 114, 125, 134, 128, 13, 130, 142, 131, 209, 132, 199, 134, 223, 136, 80, 138, 94, 138, 29, 139, 220, 140, 102, 141, 173, 143, 170, 144, 252, 152, 223, 153, 157, 158, 74, 82, 105, 249, 20, 103, 106, 249, 152, 80, 42, 82, 113, 92, 99, 101, 85, 108, 202, 115, 35, 117, 157, 117, 151, 123, 156, 132, 120, 145, 48, 151, 119, 78, 146, 100, 186, 107, 94, 113, 169, 133, 9, 78, 107, 249, 73, 103, 238, 104, 23, 110, 159, 130, 24, 133, 107, 136, 247, 99, 129, 111, 18, 146, 175, 152, 10, 78, 183, 80, 207, 80, 31, 81, 70, 85, 170, 85, 23, 86, 64, 91, 25, 92, 224, 92, 56, 94, 138, 94, 160, 94, 194, 94, 243, 96, 81, 104, 97, 106, 88, 110, 61, 114, 64, 114, 192, 114, 248, 118, 101, 121, 177, 123, 212, 127, 243, 136, 244, 137, 115, 138, 97, 140, 222, 140, 28, 151, 94, 88, 189, 116, 253, 140, 199, 85, 108, 249, 97, 122, 34, 125, 114, 130, 114, 114, 31, 117, 37, 117, 109, 249, 25, 123, 133, 88, 251, 88, 188, 93, 143, 94, 182, 94, 144, 95, 85, 96, 146, 98, 127, 99, 77, 101, 145, 102, 217, 102, 248, 102, 22, 104, 242, 104, 128, 114, 94, 116, 110, 123, 110, 125, 214, 125, 114, 127, 229, 128, 18, 130, 175, 133, 127, 137, 147, 138, 29, 144, 228, 146, 205, 158, 32, 159, 21, 89, 109, 89, 45, 94, 220, 96, 20, 102, 115, 102, 144, 103, 80, 108, 197, 109, 95, 111, 243, 119, 169, 120, 198, 132, 203, 145, 43, 147, 217, 78, 202, 80, 72, 81, 132, 85, 11, 91, 163, 91, 71, 98, 126, 101, 203, 101, 50, 110, 125, 113, 1, 116, 68, 116, 135, 116, 191, 116, 108, 118, 170, 121, 218, 125, 85, 126, 168, 127, 122, 129, 179, 129, 57, 130, 26, 134, 236, 135, 117, 138, 227, 141, 120, 144, 145, 146, 37, 148, 77, 153, 174, 155, 104, 83, 81, 92, 84, 105, 196, 108, 41, 109, 43, 110, 12, 130, 155, 133, 59, 137, 45, 138, 170, 138, 234, 150, 103, 159, 97, 82, 185, 102, 178, 107, 150, 126, 254, 135, 13, 141, 131, 149, 93, 150, 29, 101, 137, 109, 238, 113, 110, 249, 206, 87, 211, 89, 172, 91, 39, 96, 250, 96, 16, 98, 31, 102, 95, 102, 41, 115, 249, 115, 219, 118, 1, 119, 108, 123, 86, 128, 114, 128, 101, 129, 160, 138, 146, 145, 22, 78, 226, 82, 114, 107, 23, 109, 5, 122, 57, 123, 48, 125, 111, 249, 176, 140, 236, 83, 47, 86, 81, 88, 181, 91, 15, 92, 17, 92, 226, 93, 64, 98, 131, 99, 20, 100, 45, 102, 179, 104, 188, 108, 136, 109, 175, 110, 31, 112, 164, 112, 210, 113, 38, 117, 143, 117, 142, 117, 25, 118, 17, 123, 224, 123, 43, 124, 32, 125, 57, 125, 44, 133, 109, 133, 7, 134, 52, 138, 13, 144, 97, 144, 181, 144, 183, 146, 246, 151, 55, 154, 215, 79, 108, 92, 95, 103, 145, 109, 159, 124, 140, 126, 22, 139, 22, 141, 31, 144, 107, 91, 253, 93, 13, 100, 192, 132, 92, 144, 225, 152, 135, 115, 139, 91, 154, 96, 126, 103, 222, 109, 31, 138, 166, 138, 1, 144, 12, 152, 55, 82, 112, 249, 81, 112, 142, 120, 150, 147, 112, 136, 215, 145, 238, 79, 215, 83, 253, 85, 218, 86, 130, 87, 253, 88, 194, 90, 136, 91, 171, 92, 192, 92, 37, 94, 1, 97, 13, 98, 75, 98, 136, 99, 28, 100, 54, 101, 120, 101, 57, 106, 138, 107, 52, 108, 25, 109, 49, 111, 231, 113, 233, 114, 120, 115, 7, 116, 178, 116, 38, 118, 97, 119, 192, 121, 87, 122, 234, 122, 185, 124, 143, 125, 172, 125, 97, 126, 158, 127, 41, 129, 49, 131, 144, 132, 218, 132, 234, 133, 150, 136, 176, 138, 144, 139, 56, 143, 66, 144, 131, 144, 108, 145, 150, 146, 185, 146, 139, 150, 167, 150, 168, 150, 214, 150, 0, 151, 8, 152, 150, 153, 211, 154, 26, 155, 212, 83, 126, 88, 25, 89, 112, 91, 191, 91, 209, 109, 90, 111, 159, 113, 33, 116, 185, 116, 133, 128, 253, 131, 225, 93, 135, 95, 170, 95, 66, 96, 236, 101, 18, 104, 111, 105, 83, 106, 137, 107, 53, 109, 243, 109, 227, 115, 254, 118, 172, 119, 77, 123, 20, 125, 35, 129, 28, 130, 64, 131, 244, 132, 99, 133, 98, 138, 196, 138, 135, 145, 30, 147, 6, 152, 180, 153, 12, 98, 83, 136, 240, 143, 101, 146, 7, 93, 39, 93, 105, 93, 95, 116, 157, 129, 104, 135, 213, 111, 254, 98, 210, 127, 54, 137, 114, 137, 30, 78, 88, 78, 231, 80, 221, 82, 71, 83, 127, 98, 7, 102, 105, 126, 5, 136, 94, 150, 141, 79, 25, 83, 54, 86, 203, 89, 164, 90, 56, 92, 78, 92, 77, 92, 2, 94, 17, 95, 67, 96, 189, 101, 47, 102, 66, 102, 190, 103, 244, 103, 28, 115, 226, 119, 58, 121, 197, 127, 148, 132, 205, 132, 150, 137, 102, 138, 105, 138, 225, 138, 85, 140, 122, 140, 244, 87, 212, 91, 15, 95, 111, 96, 237, 98, 13, 105, 150, 107, 92, 110, 132, 113, 210, 123, 85, 135, 88, 139, 254, 142, 223, 152, 254, 152, 56, 79, 129, 79, 225, 79, 123, 84, 32, 90, 184, 91, 60, 97, 176, 101, 104, 102, 252, 113, 51, 117, 94, 121, 51, 125, 78, 129, 227, 129, 152, 131, 170, 133, 206, 133, 3, 135, 10, 138, 171, 142, 155, 143, 113, 249, 197, 143, 49, 89, 164, 91, 230, 91, 137, 96, 233, 91, 11, 92, 195, 95, 129, 108, 114, 249, 241, 109, 11, 112, 26, 117, 175, 130, 246, 138, 192, 78, 65, 83, 115, 249, 217, 150, 15, 108, 158, 78, 196, 79, 82, 81, 94, 85, 37, 90, 232, 92, 17, 98, 89, 114, 189, 130, 170, 131, 254, 134, 89, 136, 29, 138, 63, 150, 197, 150, 19, 153, 9, 157, 93, 157, 10, 88, 179, 92, 189, 93, 68, 94, 225, 96, 21, 97, 225, 99, 2, 106, 37, 110, 2, 145, 84, 147, 78, 152, 16, 156, 119, 159, 137, 91, 184, 92, 9, 99, 79, 102, 72, 104, 60, 119, 193, 150, 141, 151, 84, 152, 159, 155, 161, 101, 1, 139, 203, 142, 188, 149, 53, 85, 169, 92, 214, 93, 181, 94, 151, 102, 76, 118, 244, 131, 199, 149, 211, 88, 188, 98, 206, 114, 40, 157, 240, 78, 46, 89, 15, 96, 59, 102, 131, 107, 231, 121, 38, 157, 147, 83, 192, 84, 195, 87, 22, 93, 27, 97, 214, 102, 175, 109, 141, 120, 126, 130, 152, 150, 68, 151, 132, 83, 124, 98, 150, 99, 178, 109, 10, 126, 75, 129, 77, 152, 251, 106, 76, 127, 175, 157, 26, 158, 95, 78, 59, 80, 182, 81, 28, 89, 249, 96, 246, 99, 48, 105, 58, 114, 54, 128, 116, 249, 206, 145, 49, 95, 117, 249, 118, 249, 4, 125, 229, 130, 111, 132, 187, 132, 229, 133, 141, 142, 119, 249, 111, 79, 120, 249, 121, 249, 228, 88, 67, 91, 89, 96, 218, 99, 24, 101, 109, 101, 152, 102, 122, 249, 74, 105, 35, 106, 11, 109, 1, 112, 108, 113, 210, 117, 13, 118, 179, 121, 112, 122, 123, 249, 138, 127, 124, 249, 68, 137, 125, 249, 147, 139, 192, 145, 125, 150, 126, 249, 10, 153, 4, 87, 161, 95, 188, 101, 1, 111, 0, 118, 166, 121, 158, 138, 173, 153, 90, 155, 108, 159, 4, 81, 182, 97, 145, 98, 141, 106, 198, 129, 67, 80, 48, 88, 102, 95, 9, 113, 0, 138, 250, 138, 124, 91, 22, 134, 250, 79, 60, 81, 180, 86, 68, 89, 169, 99, 249, 109, 170, 93, 109, 105, 134, 81, 136, 78, 89, 79, 127, 249, 128, 249, 129, 249, 130, 89, 130, 249, 131, 249, 95, 107, 93, 108, 132, 249, 181, 116, 22, 121, 133, 249, 7, 130, 69, 130, 57, 131, 63, 143, 93, 143, 134, 249, 24, 153, 135, 249, 136, 249, 137, 249, 166, 78, 138, 249, 223, 87, 121, 95, 19, 102, 139, 249, 140, 249, 171, 117, 121, 126, 111, 139, 141, 249, 6, 144, 91, 154, 165, 86, 39, 88, 248, 89, 31, 90, 180, 91, 142, 249, 246, 94, 143, 249, 144, 249, 80, 99, 59, 99, 145, 249, 61, 105, 135, 108, 191, 108, 142, 109, 147, 109, 245, 109, 20, 111, 146, 249, 223, 112, 54, 113, 89, 113, 147, 249, 195, 113, 213, 113, 148, 249, 79, 120, 111, 120, 149, 249, 117, 123, 227, 125, 150, 249, 47, 126, 151, 249, 77, 136, 223, 142, 152, 249, 153, 249, 154, 249, 91, 146, 155, 249, 246, 156, 156, 249, 157, 249, 158, 249, 133, 96, 133, 109, 159, 249, 177, 113, 160, 249, 161, 249, 177, 149, 173, 83, 162, 249, 163, 249, 164, 249, 211, 103, 165, 249, 142, 112, 48, 113, 48, 116, 118, 130, 210, 130, 166, 249, 187, 149, 229, 154, 125, 158, 196, 102, 167, 249, 193, 113, 73, 132, 168, 249, 169, 249, 75, 88, 170, 249, 171, 249, 184, 93, 113, 95, 172, 249, 32, 102, 142, 102, 121, 105, 174, 105, 56, 108, 243, 108, 54, 110, 65, 111, 218, 111, 27, 112, 47, 112, 80, 113, 223, 113, 112, 115, 173, 249, 91, 116, 174, 249, 212, 116, 200, 118, 78, 122, 147, 126, 175, 249, 176, 249, 241, 130, 96, 138, 206, 143, 177, 249, 72, 147, 178, 249, 25, 151, 179, 249, 180, 249, 66, 78, 42, 80, 181, 249, 8, 82, 225, 83, 243, 102, 109, 108, 202, 111, 10, 115, 127, 119, 98, 122, 174, 130, 221, 133, 2, 134, 182, 249, 212, 136, 99, 138, 125, 139, 107, 140, 183, 249, 179, 146, 184, 249, 19, 151, 16, 152, 148, 78, 13, 79, 201, 79, 178, 80, 72, 83, 62, 84, 51, 84, 218, 85, 98, 88, 186, 88, 103, 89, 27, 90, 228, 91, 159, 96, 185, 249, 202, 97, 86, 101, 255, 101, 100, 102, 167, 104, 90, 108, 179, 111, 207, 112, 172, 113, 82, 115, 125, 123, 8, 135, 164, 138, 50, 156, 7, 159, 75, 92, 131, 108, 68, 115, 137, 115, 58, 146, 171, 110, 101, 116, 31, 118, 105, 122, 21, 126, 10, 134, 64, 81, 197, 88, 193, 100, 238, 116, 21, 117, 112, 118, 193, 127, 149, 144, 205, 150, 84, 153, 38, 110, 230, 116, 169, 122, 170, 122, 229, 129, 217, 134, 120, 135, 27, 138, 73, 90, 140, 91, 155, 91, 161, 104, 0, 105, 99, 109, 169, 115, 19, 116, 44, 116, 151, 120, 233, 125, 235, 127, 24, 129, 85, 129, 158, 131, 76, 140, 46, 150, 17, 152, 240, 102, 128, 95, 250, 101, 137, 103, 106, 108, 139, 115, 45, 80, 3, 90, 106, 107, 238, 119, 22, 89, 108, 93, 205, 93, 37, 115, 79, 117, 186, 249, 187, 249], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 312548);
	        allocate([229, 80, 249, 81, 47, 88, 45, 89, 150, 89, 218, 89, 229, 91, 188, 249, 189, 249, 162, 93, 215, 98, 22, 100, 147, 100, 254, 100, 190, 249, 220, 102, 191, 249, 72, 106, 192, 249, 255, 113, 100, 116, 193, 249, 136, 122, 175, 122, 71, 126, 94, 126, 0, 128, 112, 129, 194, 249, 239, 135, 129, 137, 32, 139, 89, 144, 195, 249, 128, 144, 82, 153, 126, 97, 50, 107, 116, 109, 31, 126, 37, 137, 177, 143, 209, 79, 173, 80, 151, 81, 199, 82, 199, 87, 137, 88, 185, 91, 184, 94, 66, 97, 149, 105, 140, 109, 103, 110, 182, 110, 148, 113, 98, 116, 40, 117, 44, 117, 115, 128, 56, 131, 201, 132, 10, 142, 148, 147, 222, 147, 196, 249, 142, 78, 81, 79, 118, 80, 42, 81, 200, 83, 203, 83, 243, 83, 135, 91, 211, 91, 36, 92, 26, 97, 130, 97, 244, 101, 91, 114, 151, 115, 64, 116, 194, 118, 80, 121, 145, 121, 185, 121, 6, 125, 189, 127, 139, 130, 213, 133, 94, 134, 194, 143, 71, 144, 245, 144, 234, 145, 133, 150, 232, 150, 233, 150, 214, 82, 103, 95, 237, 101, 49, 102, 47, 104, 92, 113, 54, 122, 193, 144, 10, 152, 145, 78, 197, 249, 82, 106, 158, 107, 144, 111, 137, 113, 24, 128, 184, 130, 83, 133, 75, 144, 149, 150, 242, 150, 251, 151, 26, 133, 49, 155, 144, 78, 138, 113, 196, 150, 67, 81, 159, 83, 225, 84, 19, 87, 18, 87, 163, 87, 155, 90, 196, 90, 195, 91, 40, 96, 63, 97, 244, 99, 133, 108, 57, 109, 114, 110, 144, 110, 48, 114, 63, 115, 87, 116, 209, 130, 129, 136, 69, 143, 96, 144, 198, 249, 98, 150, 88, 152, 27, 157, 8, 103, 138, 141, 94, 146, 77, 79, 73, 80, 222, 80, 113, 83, 13, 87, 212, 89, 1, 90, 9, 92, 112, 97, 144, 102, 45, 110, 50, 114, 75, 116, 239, 125, 195, 128, 14, 132, 102, 132, 63, 133, 95, 135, 91, 136, 24, 137, 2, 139, 85, 144, 203, 151, 79, 155, 115, 78, 145, 79, 18, 81, 106, 81, 199, 249, 47, 85, 169, 85, 122, 91, 165, 91, 124, 94, 125, 94, 190, 94, 160, 96, 223, 96, 8, 97, 9, 97, 196, 99, 56, 101, 9, 103, 200, 249, 212, 103, 218, 103, 201, 249, 97, 105, 98, 105, 185, 108, 39, 109, 202, 249, 56, 110, 203, 249, 225, 111, 54, 115, 55, 115, 204, 249, 92, 116, 49, 117, 205, 249, 82, 118, 206, 249, 207, 249, 173, 125, 254, 129, 56, 132, 213, 136, 152, 138, 219, 138, 237, 138, 48, 142, 66, 142, 74, 144, 62, 144, 122, 144, 73, 145, 201, 145, 110, 147, 208, 249, 209, 249, 9, 88, 210, 249, 211, 107, 137, 128, 178, 128, 211, 249, 212, 249, 65, 81, 107, 89, 57, 92, 213, 249, 214, 249, 100, 111, 167, 115, 228, 128, 7, 141, 215, 249, 23, 146, 143, 149, 216, 249, 217, 249, 218, 249, 219, 249, 127, 128, 14, 98, 28, 112, 104, 125, 141, 135, 220, 249, 160, 87, 105, 96, 71, 97, 183, 107, 190, 138, 128, 146, 177, 150, 89, 78, 31, 84, 235, 109, 45, 133, 112, 150, 243, 151, 238, 152, 214, 99, 227, 108, 145, 144, 221, 81, 201, 97, 186, 129, 249, 157, 157, 79, 26, 80, 0, 81, 156, 91, 15, 97, 255, 97, 236, 100, 5, 105, 197, 107, 145, 117, 227, 119, 169, 127, 100, 130, 143, 133, 251, 135, 99, 136, 188, 138, 112, 139, 171, 145, 140, 78, 229, 78, 10, 79, 221, 249, 222, 249, 55, 89, 232, 89, 223, 249, 242, 93, 27, 95, 91, 95, 33, 96, 224, 249, 225, 249, 226, 249, 227, 249, 62, 114, 229, 115, 228, 249, 112, 117, 205, 117, 229, 249, 251, 121, 230, 249, 12, 128, 51, 128, 132, 128, 225, 130, 81, 131, 231, 249, 232, 249, 189, 140, 179, 140, 135, 144, 233, 249, 234, 249, 244, 152, 12, 153, 235, 249, 236, 249, 55, 112, 202, 118, 202, 127, 204, 127, 252, 127, 26, 139, 186, 78, 193, 78, 3, 82, 112, 83, 237, 249, 189, 84, 224, 86, 251, 89, 197, 91, 21, 95, 205, 95, 110, 110, 238, 249, 239, 249, 106, 125, 53, 131, 240, 249, 147, 134, 141, 138, 241, 249, 109, 151, 119, 151, 242, 249, 243, 249, 0, 78, 90, 79, 126, 79, 249, 88, 229, 101, 162, 110, 56, 144, 176, 147, 185, 153, 251, 78, 236, 88, 138, 89, 217, 89, 65, 96, 244, 249, 245, 249, 20, 122, 246, 249, 79, 131, 195, 140, 101, 81, 68, 83, 247, 249, 248, 249, 249, 249, 205, 78, 105, 82, 85, 91, 191, 130, 212, 78, 58, 82, 168, 84, 201, 89, 255, 89, 80, 91, 87, 91, 92, 91, 99, 96, 72, 97, 203, 110, 153, 112, 110, 113, 134, 115, 247, 116, 181, 117, 193, 120, 43, 125, 5, 128, 234, 129, 40, 131, 23, 133, 201, 133, 238, 138, 199, 140, 204, 150, 92, 79, 250, 82, 188, 86, 171, 101, 40, 102, 124, 112, 184, 112, 53, 114, 189, 125, 141, 130, 76, 145, 192, 150, 114, 157, 113, 91, 231, 104, 152, 107, 122, 111, 222, 118, 145, 92, 171, 102, 91, 111, 180, 123, 42, 124, 54, 136, 220, 150, 8, 78, 215, 78, 32, 83, 52, 88, 187, 88, 239, 88, 108, 89, 7, 92, 51, 94, 132, 94, 53, 95, 140, 99, 178, 102, 86, 103, 31, 106, 163, 106, 12, 107, 63, 111, 70, 114, 250, 249, 80, 115, 139, 116, 224, 122, 167, 124, 120, 129, 223, 129, 231, 129, 138, 131, 108, 132, 35, 133, 148, 133, 207, 133, 221, 136, 19, 141, 172, 145, 119, 149, 156, 150, 141, 81, 201, 84, 40, 87, 176, 91, 77, 98, 80, 103, 61, 104, 147, 104, 61, 110, 211, 110, 125, 112, 33, 126, 193, 136, 161, 140, 9, 143, 75, 159, 78, 159, 45, 114, 143, 123, 205, 138, 26, 147, 71, 79, 78, 79, 50, 81, 128, 84, 208, 89, 149, 94, 181, 98, 117, 103, 110, 105, 23, 106, 174, 108, 26, 110, 217, 114, 42, 115, 189, 117, 184, 123, 53, 125, 231, 130, 249, 131, 87, 132, 247, 133, 91, 138, 175, 140, 135, 142, 25, 144, 184, 144, 206, 150, 95, 159, 227, 82, 10, 84, 225, 90, 194, 91, 88, 100, 117, 101, 244, 110, 196, 114, 251, 249, 132, 118, 77, 122, 27, 123, 77, 124, 62, 126, 223, 127, 123, 131, 43, 139, 202, 140, 100, 141, 225, 141, 95, 142, 234, 143, 249, 143, 105, 144, 209, 147, 67, 79, 122, 79, 179, 80, 104, 81, 120, 81, 77, 82, 106, 82, 97, 88, 124, 88, 96, 89, 8, 92, 85, 92, 219, 94, 155, 96, 48, 98, 19, 104, 191, 107, 8, 108, 177, 111, 78, 113, 32, 116, 48, 117, 56, 117, 81, 117, 114, 118, 76, 123, 139, 123, 173, 123, 198, 123, 143, 126, 110, 138, 62, 143, 73, 143, 63, 146, 147, 146, 34, 147, 43, 148, 251, 150, 90, 152, 107, 152, 30, 153, 7, 82, 42, 98, 152, 98, 89, 109, 100, 118, 202, 122, 192, 123, 118, 125, 96, 83, 190, 92, 151, 94, 56, 111, 185, 112, 152, 124, 17, 151, 142, 155, 222, 158, 165, 99, 122, 100, 118, 135, 1, 78, 149, 78, 173, 78, 92, 80, 117, 80, 72, 84, 195, 89, 154, 91, 64, 94, 173, 94, 247, 94, 129, 95, 197, 96, 58, 99, 63, 101, 116, 101, 204, 101, 118, 102, 120, 102, 254, 103, 104, 105, 137, 106, 99, 107, 64, 108, 192, 109, 232, 109, 31, 110, 94, 110, 30, 112, 161, 112, 142, 115, 253, 115, 58, 117, 91, 119, 135, 120, 142, 121, 11, 122, 125, 122, 190, 124, 142, 125, 71, 130, 2, 138, 234, 138, 158, 140, 45, 145, 74, 145, 216, 145, 102, 146, 204, 146, 32, 147, 6, 151, 86, 151, 92, 151, 2, 152, 14, 159, 54, 82, 145, 82, 124, 85, 36, 88, 29, 94, 31, 95, 140, 96, 208, 99, 175, 104, 223, 111, 109, 121, 44, 123, 205, 129, 186, 133, 253, 136, 248, 138, 68, 142, 141, 145, 100, 150, 155, 150, 61, 151, 76, 152, 74, 159, 206, 79, 70, 81, 203, 81, 169, 82, 50, 86, 20, 95, 107, 95, 170, 99, 205, 100, 233, 101, 65, 102, 250, 102, 249, 102, 29, 103, 157, 104, 215, 104, 253, 105, 21, 111, 110, 111, 103, 113, 229, 113, 42, 114, 170, 116, 58, 119, 86, 121, 90, 121, 223, 121, 32, 122, 149, 122, 151, 124, 223, 124, 68, 125, 112, 126, 135, 128, 251, 133, 164, 134, 84, 138, 191, 138, 153, 141, 129, 142, 32, 144, 109, 144, 227, 145, 59, 150, 213, 150, 229, 156, 207, 101, 7, 124, 179, 141, 195, 147, 88, 91, 10, 92, 82, 83, 217, 98, 29, 115, 39, 80, 151, 91, 158, 95, 176, 96, 107, 97, 213, 104, 217, 109, 46, 116, 46, 122, 66, 125, 156, 125, 49, 126, 107, 129, 42, 142, 53, 142, 126, 147, 24, 148, 80, 79, 80, 87, 230, 93, 167, 94, 43, 99, 106, 127, 59, 78, 79, 79, 143, 79, 90, 80, 221, 89, 196, 128, 106, 84, 104, 84, 254, 85, 79, 89, 153, 91, 222, 93, 218, 94, 93, 102, 49, 103, 241, 103, 42, 104, 232, 108, 50, 109, 74, 110, 141, 111, 183, 112, 224, 115, 135, 117, 76, 124, 2, 125, 44, 125, 162, 125, 31, 130, 219, 134, 59, 138, 133, 138, 112, 141, 138, 142, 51, 143, 49, 144, 78, 145, 82, 145, 68, 148, 208, 153, 249, 122, 165, 124, 202, 79, 1, 81, 198, 81, 200, 87, 239, 91, 251, 92, 89, 102, 61, 106, 90, 109, 150, 110, 236, 111, 12, 113, 111, 117, 227, 122, 34, 136, 33, 144, 117, 144, 203, 150, 255, 153, 1, 131, 45, 78, 242, 78, 70, 136, 205, 145, 125, 83, 219, 106, 107, 105, 65, 108, 122, 132, 158, 88, 142, 97, 254, 102, 239, 98, 221, 112, 17, 117, 199, 117, 82, 126, 184, 132, 73, 139, 8, 141, 75, 78, 234, 83, 171, 84, 48, 87, 64, 87, 215, 95, 1, 99, 7, 99, 111, 100, 47, 101, 232, 101, 122, 102, 157, 103, 179, 103, 98, 107, 96, 108, 154, 108, 44, 111, 229, 119, 37, 120, 73, 121, 87, 121, 25, 125, 162, 128, 2, 129, 243, 129, 157, 130, 183, 130, 24, 135, 140, 138, 252, 249, 4, 141, 190, 141, 114, 144, 244, 118, 25, 122, 55, 122, 84, 126, 119, 128, 7, 85, 212, 85, 117, 88, 47, 99, 34, 100, 73, 102, 75, 102, 109, 104, 155, 105, 132, 107, 37, 109, 177, 110, 205, 115, 104, 116, 161, 116, 91, 117, 185, 117, 225, 118, 30, 119, 139, 119, 230, 121, 9, 126, 29, 126, 251, 129, 47, 133, 151, 136, 58, 138, 209, 140, 235, 142, 176, 143, 50, 144, 173, 147, 99, 150, 115, 150, 7, 151, 132, 79, 241, 83, 234, 89, 201, 90, 25, 94, 78, 104, 198, 116, 190, 117, 233, 121, 146, 122, 163, 129, 237, 134, 234, 140, 204, 141, 237, 143, 159, 101, 21, 103, 253, 249, 247, 87, 87, 111, 221, 125, 47, 143, 246, 147, 198, 150, 181, 95, 242, 97, 132, 111, 20, 78, 152, 79, 31, 80, 201, 83, 223, 85, 111, 93, 238, 93, 33, 107, 100, 107, 203, 120, 154, 123, 254, 249, 73, 142, 202, 142, 110, 144, 73, 99, 62, 100, 64, 119, 132, 122, 47, 147, 127, 148, 106, 159, 176, 100, 175, 111, 230, 113, 168, 116, 218, 116, 196, 122, 18, 124, 130, 126, 178, 124, 152, 126, 154, 139, 10, 141, 125, 148, 16, 153, 76, 153, 57, 82, 223, 91, 230, 100, 45, 103, 46, 125, 237, 80, 195, 83, 121, 88, 88, 97, 89, 97, 250, 97, 172, 101, 217, 122, 146, 139, 150, 139, 9, 80, 33, 80, 117, 82, 49, 85, 60, 90, 224, 94, 112, 95, 52, 97, 94, 101, 12, 102, 54, 102, 162, 102, 205, 105, 196, 110, 50, 111, 22, 115, 33, 118, 147, 122, 57, 129, 89, 130, 214, 131, 188, 132, 181, 80, 240, 87, 192, 91, 232, 91, 105, 95, 161, 99, 38, 120, 181, 125, 220, 131, 33, 133, 199, 145, 245, 145, 138, 81, 245, 103, 86, 123, 172, 140, 196, 81, 187, 89, 189, 96, 85, 134, 28, 80, 255, 249, 84, 82, 58, 92, 125, 97, 26, 98, 211, 98, 242, 100, 165, 101, 204, 110, 32, 118, 10, 129, 96, 142, 95, 150, 187, 150, 223, 78, 67, 83, 152, 85, 41, 89, 221, 93, 197, 100, 201, 108, 250, 109, 148, 115, 127, 122, 27, 130, 166, 133, 228, 140, 16, 142, 119, 144, 231, 145, 225, 149, 33, 150, 198, 151, 248, 81, 242, 84, 134, 85, 185, 95, 164, 100, 136, 111, 180, 125, 31, 143, 77, 143, 53, 148, 201, 80, 22, 92, 190, 108, 251, 109, 27, 117, 187, 119, 61, 124, 100, 124, 121, 138, 194, 138, 30, 88, 190, 89, 22, 94, 119, 99, 82, 114, 138, 117, 107, 119, 220, 138, 188, 140, 18, 143, 243, 94, 116, 102, 248, 109, 125, 128, 193, 131, 203, 138, 81, 151, 214, 155, 0, 250, 67, 82, 255, 102, 149, 109, 239, 110, 224, 125, 230, 138, 46, 144, 94, 144, 212, 154, 29, 82, 127, 82, 232, 84, 148, 97, 132, 98, 219, 98, 162, 104, 18, 105, 90, 105, 53, 106, 146, 112, 38, 113, 93, 120, 1, 121, 14, 121, 210, 121, 13, 122, 150, 128, 120, 130, 213, 130, 73, 131, 73, 133, 130, 140, 133, 141, 98, 145, 139, 145, 174, 145, 195, 79, 209, 86, 237, 113, 215, 119, 0, 135, 248, 137, 248, 91, 214, 95, 81, 103, 168, 144, 226, 83, 90, 88, 245, 91, 164, 96, 129, 97, 96, 100, 61, 126, 112, 128, 37, 133, 131, 146, 174, 100, 172, 80, 20, 93, 0, 103, 156, 88, 189, 98, 168, 99, 14, 105, 120, 105, 30, 106, 107, 110, 186, 118, 203, 121, 187, 130, 41, 132, 207, 138, 168, 141, 253, 143, 18, 145, 75, 145, 156, 145, 16, 147, 24, 147, 154, 147, 219, 150, 54, 154, 13, 156, 17, 78, 92, 117, 93, 121, 250, 122, 81, 123, 201, 123, 46, 126, 196, 132, 89, 142, 116, 142, 248, 142, 16, 144, 37, 102, 63, 105, 67, 116, 250, 81, 46, 103, 220, 158, 69, 81, 224, 95, 150, 108, 242, 135, 93, 136, 119, 136, 180, 96, 181, 129, 3, 132, 5, 141, 214, 83, 57, 84, 52, 86, 54, 90, 49, 92, 138, 112, 224, 127, 90, 128, 6, 129, 237, 129, 163, 141, 137, 145, 95, 154, 242, 157, 116, 80, 196, 78, 160, 83, 251, 96, 44, 110, 100, 92, 136, 79, 36, 80, 228, 85, 217, 92, 95, 94, 101, 96, 148, 104, 187, 108, 196, 109, 190, 113, 212, 117, 244, 117, 97, 118, 26, 122, 73, 122, 199, 125, 251, 125, 110, 127, 244, 129, 169, 134, 28, 143, 201, 150, 179, 153, 82, 159, 71, 82, 197, 82, 237, 152, 170, 137, 3, 78, 210, 103, 6, 111, 181, 79, 226, 91, 149, 103, 136, 108, 120, 109, 27, 116, 39, 120, 221, 145, 124, 147, 196, 135, 228, 121, 49, 122, 235, 95, 214, 78, 164, 84, 62, 85, 174, 88, 165, 89, 240, 96, 83, 98, 214, 98, 54, 103, 85, 105, 53, 130, 64, 150, 177, 153, 221, 153, 44, 80, 83, 83, 68, 85, 124, 87, 1, 250, 88, 98, 2, 250, 226, 100, 107, 102, 221, 103, 193, 111, 239, 111, 34, 116, 56, 116, 23, 138, 56, 148, 81, 84, 6, 86, 102, 87, 72, 95, 154, 97, 78, 107, 88, 112, 173, 112, 187, 125, 149, 138, 106, 89, 43, 129, 162, 99, 8, 119, 61, 128, 170, 140, 84, 88, 45, 100, 187, 105, 149, 91, 17, 94, 111, 110, 3, 250, 105, 133, 76, 81, 240, 83, 42, 89, 32, 96, 75, 97, 134, 107, 112, 108, 240, 108, 30, 123, 206, 128, 212, 130, 198, 141, 176, 144, 177, 152, 4, 250, 199, 100, 164, 111, 145, 100, 4, 101, 78, 81, 16, 84, 31, 87, 14, 138, 95, 97, 118, 104, 5, 250, 219, 117, 82, 123, 113, 125, 26, 144, 6, 88, 204, 105, 127, 129, 42, 137, 0, 144, 57, 152, 120, 80, 87, 89, 172, 89, 149, 98, 15, 144, 42, 155, 93, 97, 121, 114, 214, 149, 97, 87, 70, 90, 244, 93, 138, 98, 173, 100, 250, 100, 119, 103, 226, 108, 62, 109, 44, 114, 54, 116, 52, 120, 119, 127, 173, 130, 219, 141, 23, 152, 36, 82, 66, 87, 127, 103, 72, 114, 227, 116, 169, 140, 166, 143, 17, 146, 42, 150, 107, 81, 237, 83, 76, 99, 105, 79, 4, 85, 150, 96, 87, 101, 155, 108, 127, 109, 76, 114, 253, 114, 23, 122, 135, 137, 157, 140, 109, 95, 142, 111, 249, 112, 168, 129, 14, 97, 191, 79, 79, 80, 65, 98, 71, 114, 199, 123, 232, 125, 233, 127, 77, 144, 173, 151, 25, 154, 182, 140, 106, 87, 115, 94, 176, 103, 13, 132, 85, 138, 32, 84, 22, 91, 99, 94, 226, 94, 10, 95, 131, 101, 186, 128, 61, 133, 137, 149, 91, 150, 72, 79, 5, 83, 13, 83, 15, 83, 134, 84, 250, 84, 3, 87, 3, 94, 22, 96, 155, 98, 177, 98, 85, 99, 6, 250, 225, 108, 102, 109, 177, 117, 50, 120, 222, 128, 47, 129, 222, 130, 97, 132, 178, 132, 141, 136, 18, 137, 11, 144, 234, 146, 253, 152, 145, 155, 69, 94, 180, 102, 221, 102, 17, 112, 6, 114, 7, 250, 245, 79, 125, 82, 106, 95, 83, 97, 83, 103, 25, 106, 2, 111, 226, 116, 104, 121, 104, 136, 121, 140, 199, 152, 196, 152, 67, 154, 193, 84, 31, 122, 83, 105, 247, 138, 74, 140, 168, 152, 174, 153, 124, 95, 171, 98, 178, 117, 174, 118, 171, 136, 127, 144, 66, 150, 57, 83, 60, 95, 197, 95, 204, 108, 204, 115, 98, 117, 139, 117, 70, 123, 254, 130, 157, 153, 79, 78, 60, 144, 11, 78, 85, 79, 166, 83, 15, 89, 200, 94, 48, 102, 179, 108, 85, 116, 119, 131, 102, 135, 192, 140, 80, 144, 30, 151, 21, 156, 209, 88, 120, 91, 80, 134, 20, 139, 180, 157, 210, 91, 104, 96, 141, 96, 241, 101, 87, 108, 34, 111, 163, 111, 26, 112, 85, 127, 240, 127, 145, 149, 146, 149, 80, 150, 211, 151, 114, 82, 68, 143, 253, 81, 43, 84, 184, 84, 99, 85, 138, 85, 187, 106, 181, 109, 216, 125, 102, 130, 156, 146, 119, 150, 121, 158, 8, 84, 200, 84, 210, 118, 228, 134, 164, 149, 212, 149, 92, 150, 162, 78, 9, 79, 238, 89, 230, 90, 247, 93, 82, 96, 151, 98, 109, 103, 65, 104, 134, 108, 47, 110, 56, 127, 155, 128, 42, 130, 8, 250, 9, 250, 5, 152, 165, 78, 85, 80, 179, 84, 147, 87, 90, 89, 105, 91, 179, 91, 200, 97, 119, 105, 119, 109, 35, 112, 249, 135, 227, 137, 114, 138, 231, 138, 130, 144, 237, 153, 184, 154, 190, 82, 56, 104, 22, 80, 120, 94, 79, 103, 71, 131, 76, 136, 171, 78, 17, 84, 174, 86, 230, 115, 21, 145, 255, 151, 9, 153, 87, 153, 153, 153, 83, 86, 159, 88, 91, 134, 49, 138, 178, 97, 246, 106, 123, 115, 210, 142, 71, 107, 170, 150, 87, 154, 85, 89, 0, 114, 107, 141, 105, 151, 212, 79, 244, 92, 38, 95, 248, 97, 91, 102, 235, 108, 171, 112, 132, 115, 185, 115, 254, 115, 41, 119, 77, 119, 67, 125, 98, 125, 35, 126, 55, 130, 82, 136, 10, 250, 226, 140, 73, 146, 111, 152, 81, 91, 116, 122, 64, 136, 1, 152, 204, 90, 224, 79, 84, 83, 62, 89, 253, 92, 62, 99, 121, 109, 249, 114, 5, 129, 7, 129, 162, 131, 207, 146, 48, 152, 168, 78, 68, 81, 17, 82, 139, 87, 98, 95, 194, 108, 206, 110, 5, 112, 80, 112, 175, 112, 146, 113, 233, 115, 105, 116, 74, 131, 162, 135, 97, 136, 8, 144, 162, 144, 163, 147, 168, 153, 110, 81, 87, 95, 224, 96, 103, 97, 179, 102, 89, 133, 74, 142, 175, 145, 139, 151, 78, 78, 146, 78, 124, 84, 213, 88, 250, 88, 125, 89, 181, 92, 39, 95, 54, 98, 72, 98, 10, 102, 103, 102, 235, 107, 105, 109, 207, 109, 86, 110, 248, 110, 148, 111, 224, 111, 233, 111, 93, 112, 208, 114, 37, 116, 90, 116, 224, 116, 147, 118, 92, 121, 202, 124, 30, 126, 225, 128, 166, 130, 107, 132, 191, 132, 78, 134, 95, 134, 116, 135, 119, 139, 106, 140, 172, 147, 0, 152, 101, 152, 209, 96, 22, 98, 119, 145, 90, 90, 15, 102, 247, 109, 62, 110, 63, 116, 66, 155, 253, 95, 218, 96, 15, 123, 196, 84, 24, 95, 94, 108, 211, 108, 42, 109, 216, 112, 5, 125, 121, 134, 12, 138, 59, 157, 22, 83, 140, 84, 5, 91, 58, 106, 107, 112, 117, 117, 141, 121, 190, 121, 177, 130, 239, 131, 113, 138, 65, 139, 168, 140, 116, 151, 11, 250, 244, 100, 43, 101, 186, 120, 187, 120, 107, 122, 56, 78, 154, 85, 80, 89, 166, 91, 123, 94, 163, 96, 219, 99, 97, 107, 101, 102, 83, 104, 25, 110, 101, 113, 176, 116, 8, 125, 132, 144, 105, 154, 37, 156, 59, 109, 209, 110, 62, 115, 65, 140, 202, 149, 240, 81, 76, 94, 168, 95, 77, 96, 246, 96, 48, 97, 76, 97, 67, 102, 68, 102, 165, 105, 193, 108, 95, 110, 201, 110, 98, 111, 76, 113, 156, 116, 135, 118, 193, 123, 39, 124, 82, 131, 87, 135, 81, 144, 141, 150, 195, 158, 47, 83, 222, 86, 251, 94, 138, 95, 98, 96, 148, 96, 247, 97, 102, 102, 3, 103, 156, 106, 238, 109, 174, 111, 112, 112, 106, 115, 106, 126, 190, 129, 52, 131, 212, 134, 168, 138, 196, 140, 131, 82, 114, 115, 150, 91, 107, 106, 4, 148, 238, 84, 134, 86, 93, 91, 72, 101, 133, 101, 201, 102, 159, 104, 141, 109, 198, 109, 59, 114, 180, 128, 117, 145, 77, 154, 175, 79, 25, 80, 154, 83, 14, 84, 60, 84, 137, 85, 197, 85, 63, 94, 140, 95, 61, 103, 102, 113, 221, 115, 5, 144, 219, 82, 243, 82, 100, 88, 206, 88, 4, 113, 143, 113, 251, 113, 176, 133, 19, 138, 136, 102, 168, 133, 167, 85, 132, 102, 74, 113, 49, 132, 73, 83, 153, 85, 193, 107, 89, 95, 189, 95, 238, 99, 137, 102, 71, 113, 241, 138, 29, 143, 190, 158, 17, 79, 58, 100, 203, 112, 102, 117, 103, 134, 100, 96, 78, 139, 248, 157, 71, 81, 246, 81, 8, 83, 54, 109, 248, 128, 209, 158, 21, 102, 35, 107, 152, 112, 213, 117, 3, 84, 121, 92, 7, 125, 22, 138, 32, 107, 61, 107, 70, 107, 56, 84, 112, 96, 61, 109, 213, 127, 8, 130, 214, 80, 222, 81, 156, 85, 107, 86, 205, 86, 236, 89, 9, 91, 12, 94, 153, 97, 152, 97, 49, 98, 94, 102, 230, 102, 153, 113, 185, 113, 186, 113, 167, 114, 167, 121, 0, 122, 178, 127, 112, 138, 0, 0, 0, 0, 0, 0, 1, 0, 160, 0, 167, 0, 168, 0, 169, 0, 175, 0, 176, 0, 178, 0, 183, 0, 184, 0, 198, 0, 215, 0, 216, 0, 230, 0, 247, 0, 248, 0, 0, 1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8, 1, 9, 1, 10, 1, 11, 1, 12, 1, 13, 1, 14, 1, 15, 1, 16, 1, 17, 1, 18, 1, 19, 1, 22, 1, 23, 1, 24, 1, 25, 1, 26, 1, 27, 1, 28, 1, 29, 1, 30, 1, 31, 1, 32, 1, 33, 1, 34, 1, 35, 1, 36, 1, 37, 1, 38, 1, 39, 1, 40, 1, 41, 1, 42, 1, 43, 1, 46, 1, 47, 1, 48, 1, 49, 1, 52, 1, 53, 1, 54, 1, 55, 1, 56, 1, 57, 1, 58, 1, 59, 1, 60, 1, 61, 1, 62, 1, 65, 1, 66, 1, 67, 1, 68, 1, 69, 1, 70, 1, 71, 1, 72, 1, 74, 1, 75, 1, 76, 1, 77, 1, 80, 1, 81, 1, 82, 1, 83, 1, 84, 1, 85, 1, 86, 1, 87, 1, 88, 1, 89, 1, 90, 1, 91, 1, 92, 1, 93, 1, 94, 1, 95, 1, 96, 1, 97, 1, 98, 1, 99, 1, 100, 1, 101, 1, 102, 1, 103, 1, 104, 1, 105, 1, 106, 1, 107, 1, 108, 1, 109, 1, 110, 1, 111, 1, 112, 1, 113, 1, 114, 1, 115, 1, 116, 1, 117, 1, 118, 1, 119, 1, 120, 1, 121, 1, 122, 1, 123, 1, 124, 1, 125, 1, 126, 1, 146, 1, 160, 1, 161, 1, 175, 1, 176, 1, 24, 2, 25, 2, 26, 2, 27, 2, 198, 2, 199, 2, 216, 2, 217, 2, 219, 2, 220, 2, 221, 2, 0, 3, 1, 3, 3, 3, 9, 3, 35, 3, 122, 3, 132, 3, 133, 3, 134, 3, 136, 3, 137, 3, 138, 3, 140, 3, 142, 3, 143, 3, 144, 3, 145, 3, 146, 3, 147, 3, 148, 3, 149, 3, 150, 3, 151, 3, 152, 3, 153, 3, 154, 3, 155, 3, 156, 3, 157, 3, 158, 3, 159, 3, 160, 3, 161, 3, 163, 3, 164, 3, 165, 3, 166, 3, 167, 3, 168, 3, 169, 3, 170, 3, 171, 3, 172, 3, 173, 3, 174, 3, 175, 3, 176, 3, 177, 3, 178, 3, 179, 3, 180, 3, 181, 3, 182, 3, 183, 3, 184, 3, 185, 3, 186, 3, 187, 3, 188, 3, 189, 3, 190, 3, 191, 3, 192, 3, 193, 3, 194, 3, 195, 3, 196, 3, 197, 3, 198, 3, 199, 3, 200, 3, 201, 3, 202, 3, 203, 3, 204, 3, 205, 3, 206, 3, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 4, 7, 4, 8, 4, 9, 4, 10, 4, 11, 4, 12, 4, 14, 4, 15, 4, 16, 4, 17, 4, 18, 4, 19, 4, 20, 4, 21, 4, 22, 4, 23, 4, 24, 4, 25, 4, 26, 4, 27, 4, 28, 4, 29, 4, 30, 4, 31, 4, 32, 4, 33, 4, 34, 4, 35, 4, 36, 4, 37, 4, 38, 4, 39, 4, 40, 4, 41, 4, 42, 4, 43, 4, 44, 4, 45, 4, 46, 4, 47, 4, 48, 4, 49, 4, 50, 4, 51, 4, 52, 4, 53, 4, 54, 4, 55, 4, 56, 4, 57, 4, 58, 4, 59, 4, 60, 4, 61, 4, 62, 4, 63, 4, 64, 4, 65, 4, 66, 4, 67, 4, 68, 4, 69, 4, 70, 4, 71, 4, 72, 4, 73, 4, 74, 4, 75, 4, 76, 4, 77, 4, 78, 4, 79, 4, 81, 4, 82, 4, 83, 4, 84, 4, 85, 4, 86, 4, 87, 4, 88, 4, 89, 4, 90, 4, 91, 4, 92, 4, 94, 4, 95, 4, 144, 4, 145, 4, 176, 5, 177, 5, 178, 5, 179, 5, 180, 5, 181, 5, 182, 5, 183, 5, 184, 5, 185, 5, 187, 5, 188, 5, 189, 5, 190, 5, 191, 5, 192, 5, 193, 5, 194, 5, 195, 5, 208, 5, 209, 5, 210, 5, 211, 5, 212, 5, 213, 5, 214, 5, 215, 5, 216, 5, 217, 5, 218, 5, 219, 5, 220, 5, 221, 5, 222, 5, 223, 5, 224, 5, 225, 5, 226, 5, 227, 5, 228, 5, 229, 5, 230, 5, 231, 5, 232, 5, 233, 5, 234, 5, 240, 5, 241, 5, 242, 5, 243, 5, 244, 5, 12, 6, 27, 6, 31, 6, 33, 6, 34, 6, 35, 6, 36, 6, 37, 6, 38, 6, 39, 6, 40, 6, 41, 6, 42, 6, 43, 6, 44, 6, 45, 6, 46, 6, 47, 6, 48, 6, 49, 6, 50, 6, 51, 6, 52, 6, 53, 6, 54, 6, 55, 6, 56, 6, 57, 6, 58, 6, 64, 6, 65, 6, 66, 6, 67, 6, 68, 6, 69, 6, 70, 6, 71, 6, 72, 6, 73, 6, 74, 6, 75, 6, 76, 6, 77, 6, 78, 6, 79, 6, 80, 6, 81, 6, 82, 6, 121, 6, 126, 6, 134, 6, 136, 6, 145, 6, 152, 6, 169, 6, 175, 6, 186, 6, 190, 6, 193, 6, 210, 6, 1, 14, 2, 14, 3, 14, 4, 14, 5, 14, 6, 14, 7, 14, 8, 14, 9, 14, 10, 14, 11, 14, 12, 14, 13, 14, 14, 14, 15, 14, 16, 14, 17, 14, 18, 14, 19, 14, 20, 14, 21, 14, 22, 14, 23, 14, 24, 14, 25, 14, 26, 14, 27, 14, 28, 14, 29, 14, 30, 14, 31, 14, 32, 14, 33, 14, 34, 14, 35, 14, 36, 14, 37, 14, 38, 14, 39, 14, 40, 14, 41, 14, 42, 14, 43, 14, 44, 14, 45, 14, 46, 14, 47, 14, 48, 14, 49, 14, 50, 14, 51, 14, 52, 14, 53, 14, 54, 14, 55, 14, 56, 14, 57, 14, 58, 14, 63, 14, 64, 14, 65, 14, 66, 14, 67, 14, 68, 14, 69, 14, 70, 14, 71, 14, 72, 14, 73, 14, 74, 14, 75, 14, 76, 14, 77, 14, 78, 14, 79, 14, 80, 14, 81, 14, 82, 14, 83, 14, 84, 14, 85, 14, 86, 14, 87, 14, 88, 14, 89, 14, 90, 14, 91, 14, 2, 30, 3, 30, 10, 30, 11, 30, 30, 30, 31, 30, 64, 30, 65, 30, 86, 30, 87, 30, 96, 30, 97, 30, 106, 30, 107, 30, 128, 30, 129, 30, 130, 30, 131, 30, 132, 30, 133, 30, 242, 30, 243, 30, 12, 32, 13, 32, 14, 32, 15, 32, 19, 32, 20, 32, 21, 32, 23, 32, 24, 32, 25, 32, 26, 32, 28, 32, 29, 32, 30, 32, 32, 32, 33, 32, 34, 32, 38, 32, 48, 32, 57, 32, 58, 32, 170, 32, 171, 32, 172, 32, 175, 32, 22, 33, 34, 33, 25, 34, 26, 34, 72, 34, 100, 34, 101, 34, 32, 35, 33, 35, 0, 37, 2, 37, 12, 37, 16, 37, 20, 37, 24, 37, 28, 37, 36, 37, 44, 37, 52, 37, 60, 37, 80, 37, 81, 37, 82, 37, 83, 37, 84, 37, 85, 37, 86, 37, 87, 37, 88, 37, 89, 37, 90, 37, 91, 37, 92, 37, 93, 37, 94, 37, 95, 37, 96, 37, 97, 37, 98, 37, 99, 37, 100, 37, 101, 37, 102, 37, 103, 37, 104, 37, 105, 37, 106, 37, 107, 37, 108, 37, 128, 37, 132, 37, 136, 37, 140, 37, 144, 37, 145, 37, 146, 37, 147, 37, 160, 37, 0, 0, 2, 0, 0, 192, 3, 0, 0, 192, 4, 0, 0, 192, 5, 0, 0, 192, 6, 0, 0, 192, 7, 0, 0, 192, 8, 0, 0, 192, 9, 0, 0, 192, 10, 0, 0, 192, 11, 0, 0, 192, 12, 0, 0, 192, 13, 0, 0, 192, 14, 0, 0, 192, 15, 0, 0, 192, 16, 0, 0, 192, 17, 0, 0, 192, 18, 0, 0, 192, 19, 0, 0, 192, 20, 0, 0, 192, 21, 0, 0, 192, 22, 0, 0, 192, 23, 0, 0, 192, 24, 0, 0, 192, 25, 0, 0, 192, 26, 0, 0, 192, 27, 0, 0, 192, 28, 0, 0, 192, 29, 0, 0, 192, 30, 0, 0, 192, 31, 0, 0, 192, 0, 0, 0, 179, 1, 0, 0, 195, 2, 0, 0, 195, 3, 0, 0, 195, 4, 0, 0, 195, 5, 0, 0, 195, 6, 0, 0, 195, 7, 0, 0, 195, 8, 0, 0, 195, 9, 0, 0, 195, 10, 0, 0, 195, 11, 0, 0, 195, 12, 0, 0, 195, 13, 0, 0, 211, 14, 0, 0, 195, 15, 0, 0, 195, 0, 0, 12, 187, 1, 0, 12, 195, 2, 0, 12, 195, 3, 0, 12, 195, 4, 0, 12, 211, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 255, 255, 255, 255, 255, 255, 255, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 255, 255, 255, 255, 255, 255, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 4, 7, 3, 6, 5, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 102, 105, 110, 105, 116, 121, 0, 0, 0, 0, 0, 0, 0, 0, 110, 97, 110, 0, 0, 0, 0, 0, 95, 112, 137, 0, 255, 9, 47, 15, 10, 0, 0, 0, 100, 0, 0, 0, 232, 3, 0, 0, 16, 39, 0, 0, 160, 134, 1, 0, 64, 66, 15, 0, 128, 150, 152, 0, 0, 225, 245, 5, 17, 0, 10, 0, 17, 17, 17, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 15, 10, 17, 17, 17, 3, 10, 7, 0, 1, 19, 9, 11, 11, 0, 0, 9, 6, 11, 0, 0, 11, 0, 6, 17, 0, 0, 0, 17, 17, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 10, 10, 17, 17, 17, 0, 10, 0, 0, 2, 0, 9, 11, 0, 0, 0, 9, 0, 11, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 9, 12, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 4, 13, 0, 0, 0, 0, 9, 14, 0, 0, 0, 0, 0, 14, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 15, 0, 0, 0, 0, 9, 16, 0, 0, 0, 0, 0, 16, 0, 0, 16, 0, 0, 18, 0, 0, 0, 18, 18, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 18, 18, 18, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 10, 0, 0, 0, 0, 9, 11, 0, 0, 0, 0, 0, 11, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 9, 12, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 0, 45, 43, 32, 32, 32, 48, 88, 48, 120, 0, 0, 0, 0, 0, 0, 0, 40, 110, 117, 108, 108, 41, 0, 0, 45, 48, 88, 43, 48, 88, 32, 48, 88, 45, 48, 120, 43, 48, 120, 32, 48, 120, 0, 0, 0, 0, 0, 0, 105, 110, 102, 0, 0, 0, 0, 0, 73, 78, 70, 0, 0, 0, 0, 0, 110, 97, 110, 0, 0, 0, 0, 0, 78, 65, 78, 0, 0, 0, 0, 0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 322788);
	        var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
	        assert(tempDoublePtr % 8 == 0);
	        function copyTempFloat(ptr) {
	            HEAP8[tempDoublePtr] = HEAP8[ptr];
	            HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
	            HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
	            HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3]
	        }

	        function copyTempDouble(ptr) {
	            HEAP8[tempDoublePtr] = HEAP8[ptr];
	            HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
	            HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
	            HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
	            HEAP8[tempDoublePtr + 4] = HEAP8[ptr + 4];
	            HEAP8[tempDoublePtr + 5] = HEAP8[ptr + 5];
	            HEAP8[tempDoublePtr + 6] = HEAP8[ptr + 6];
	            HEAP8[tempDoublePtr + 7] = HEAP8[ptr + 7]
	        }

	        Module["_i64Subtract"] = _i64Subtract;
	        function ___assert_fail(condition, filename, line, func) {
	            ABORT = true;
	            throw"Assertion failed: " + Pointer_stringify(condition) + ", at: " + [filename ? Pointer_stringify(filename) : "unknown filename", line, func ? Pointer_stringify(func) : "unknown function"] + " at " + stackTrace()
	        }

	        Module["_bitshift64Ashr"] = _bitshift64Ashr;
	        var ERRNO_CODES = {
	            EPERM: 1,
	            ENOENT: 2,
	            ESRCH: 3,
	            EINTR: 4,
	            EIO: 5,
	            ENXIO: 6,
	            E2BIG: 7,
	            ENOEXEC: 8,
	            EBADF: 9,
	            ECHILD: 10,
	            EAGAIN: 11,
	            EWOULDBLOCK: 11,
	            ENOMEM: 12,
	            EACCES: 13,
	            EFAULT: 14,
	            ENOTBLK: 15,
	            EBUSY: 16,
	            EEXIST: 17,
	            EXDEV: 18,
	            ENODEV: 19,
	            ENOTDIR: 20,
	            EISDIR: 21,
	            EINVAL: 22,
	            ENFILE: 23,
	            EMFILE: 24,
	            ENOTTY: 25,
	            ETXTBSY: 26,
	            EFBIG: 27,
	            ENOSPC: 28,
	            ESPIPE: 29,
	            EROFS: 30,
	            EMLINK: 31,
	            EPIPE: 32,
	            EDOM: 33,
	            ERANGE: 34,
	            ENOMSG: 42,
	            EIDRM: 43,
	            ECHRNG: 44,
	            EL2NSYNC: 45,
	            EL3HLT: 46,
	            EL3RST: 47,
	            ELNRNG: 48,
	            EUNATCH: 49,
	            ENOCSI: 50,
	            EL2HLT: 51,
	            EDEADLK: 35,
	            ENOLCK: 37,
	            EBADE: 52,
	            EBADR: 53,
	            EXFULL: 54,
	            ENOANO: 55,
	            EBADRQC: 56,
	            EBADSLT: 57,
	            EDEADLOCK: 35,
	            EBFONT: 59,
	            ENOSTR: 60,
	            ENODATA: 61,
	            ETIME: 62,
	            ENOSR: 63,
	            ENONET: 64,
	            ENOPKG: 65,
	            EREMOTE: 66,
	            ENOLINK: 67,
	            EADV: 68,
	            ESRMNT: 69,
	            ECOMM: 70,
	            EPROTO: 71,
	            EMULTIHOP: 72,
	            EDOTDOT: 73,
	            EBADMSG: 74,
	            ENOTUNIQ: 76,
	            EBADFD: 77,
	            EREMCHG: 78,
	            ELIBACC: 79,
	            ELIBBAD: 80,
	            ELIBSCN: 81,
	            ELIBMAX: 82,
	            ELIBEXEC: 83,
	            ENOSYS: 38,
	            ENOTEMPTY: 39,
	            ENAMETOOLONG: 36,
	            ELOOP: 40,
	            EOPNOTSUPP: 95,
	            EPFNOSUPPORT: 96,
	            ECONNRESET: 104,
	            ENOBUFS: 105,
	            EAFNOSUPPORT: 97,
	            EPROTOTYPE: 91,
	            ENOTSOCK: 88,
	            ENOPROTOOPT: 92,
	            ESHUTDOWN: 108,
	            ECONNREFUSED: 111,
	            EADDRINUSE: 98,
	            ECONNABORTED: 103,
	            ENETUNREACH: 101,
	            ENETDOWN: 100,
	            ETIMEDOUT: 110,
	            EHOSTDOWN: 112,
	            EHOSTUNREACH: 113,
	            EINPROGRESS: 115,
	            EALREADY: 114,
	            EDESTADDRREQ: 89,
	            EMSGSIZE: 90,
	            EPROTONOSUPPORT: 93,
	            ESOCKTNOSUPPORT: 94,
	            EADDRNOTAVAIL: 99,
	            ENETRESET: 102,
	            EISCONN: 106,
	            ENOTCONN: 107,
	            ETOOMANYREFS: 109,
	            EUSERS: 87,
	            EDQUOT: 122,
	            ESTALE: 116,
	            ENOTSUP: 95,
	            ENOMEDIUM: 123,
	            EILSEQ: 84,
	            EOVERFLOW: 75,
	            ECANCELED: 125,
	            ENOTRECOVERABLE: 131,
	            EOWNERDEAD: 130,
	            ESTRPIPE: 86
	        };
	        var ERRNO_MESSAGES = {
	            0: "Success",
	            1: "Not super-user",
	            2: "No such file or directory",
	            3: "No such process",
	            4: "Interrupted system call",
	            5: "I/O error",
	            6: "No such device or address",
	            7: "Arg list too long",
	            8: "Exec format error",
	            9: "Bad file number",
	            10: "No children",
	            11: "No more processes",
	            12: "Not enough core",
	            13: "Permission denied",
	            14: "Bad address",
	            15: "Block device required",
	            16: "Mount device busy",
	            17: "File exists",
	            18: "Cross-device link",
	            19: "No such device",
	            20: "Not a directory",
	            21: "Is a directory",
	            22: "Invalid argument",
	            23: "Too many open files in system",
	            24: "Too many open files",
	            25: "Not a typewriter",
	            26: "Text file busy",
	            27: "File too large",
	            28: "No space left on device",
	            29: "Illegal seek",
	            30: "Read only file system",
	            31: "Too many links",
	            32: "Broken pipe",
	            33: "Math arg out of domain of func",
	            34: "Math result not representable",
	            35: "File locking deadlock error",
	            36: "File or path name too long",
	            37: "No record locks available",
	            38: "Function not implemented",
	            39: "Directory not empty",
	            40: "Too many symbolic links",
	            42: "No message of desired type",
	            43: "Identifier removed",
	            44: "Channel number out of range",
	            45: "Level 2 not synchronized",
	            46: "Level 3 halted",
	            47: "Level 3 reset",
	            48: "Link number out of range",
	            49: "Protocol driver not attached",
	            50: "No CSI structure available",
	            51: "Level 2 halted",
	            52: "Invalid exchange",
	            53: "Invalid request descriptor",
	            54: "Exchange full",
	            55: "No anode",
	            56: "Invalid request code",
	            57: "Invalid slot",
	            59: "Bad font file fmt",
	            60: "Device not a stream",
	            61: "No data (for no delay io)",
	            62: "Timer expired",
	            63: "Out of streams resources",
	            64: "Machine is not on the network",
	            65: "Package not installed",
	            66: "The object is remote",
	            67: "The link has been severed",
	            68: "Advertise error",
	            69: "Srmount error",
	            70: "Communication error on send",
	            71: "Protocol error",
	            72: "Multihop attempted",
	            73: "Cross mount point (not really error)",
	            74: "Trying to read unreadable message",
	            75: "Value too large for defined data type",
	            76: "Given log. name not unique",
	            77: "f.d. invalid for this operation",
	            78: "Remote address changed",
	            79: "Can   access a needed shared lib",
	            80: "Accessing a corrupted shared lib",
	            81: ".lib section in a.out corrupted",
	            82: "Attempting to link in too many libs",
	            83: "Attempting to exec a shared library",
	            84: "Illegal byte sequence",
	            86: "Streams pipe error",
	            87: "Too many users",
	            88: "Socket operation on non-socket",
	            89: "Destination address required",
	            90: "Message too long",
	            91: "Protocol wrong type for socket",
	            92: "Protocol not available",
	            93: "Unknown protocol",
	            94: "Socket type not supported",
	            95: "Not supported",
	            96: "Protocol family not supported",
	            97: "Address family not supported by protocol family",
	            98: "Address already in use",
	            99: "Address not available",
	            100: "Network interface is not configured",
	            101: "Network is unreachable",
	            102: "Connection reset by network",
	            103: "Connection aborted",
	            104: "Connection reset by peer",
	            105: "No buffer space available",
	            106: "Socket is already connected",
	            107: "Socket is not connected",
	            108: "Can't send after socket shutdown",
	            109: "Too many references",
	            110: "Connection timed out",
	            111: "Connection refused",
	            112: "Host is down",
	            113: "Host is unreachable",
	            114: "Socket already connected",
	            115: "Connection already in progress",
	            116: "Stale file handle",
	            122: "Quota exceeded",
	            123: "No medium (in tape drive)",
	            125: "Operation canceled",
	            130: "Previous owner died",
	            131: "State not recoverable"
	        };
	        var ___errno_state = 0;

	        function ___setErrNo(value) {
	            HEAP32[___errno_state >> 2] = value;
	            return value
	        }

	        var PATH = {
	            splitPath: (function (filename) {
	                var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
	                return splitPathRe.exec(filename).slice(1)
	            }), normalizeArray: (function (parts, allowAboveRoot) {
	                var up = 0;
	                for (var i = parts.length - 1; i >= 0; i--) {
	                    var last = parts[i];
	                    if (last === ".") {
	                        parts.splice(i, 1)
	                    } else if (last === "..") {
	                        parts.splice(i, 1);
	                        up++
	                    } else if (up) {
	                        parts.splice(i, 1);
	                        up--
	                    }
	                }
	                if (allowAboveRoot) {
	                    for (; up--; up) {
	                        parts.unshift("..")
	                    }
	                }
	                return parts
	            }), normalize: (function (path) {
	                var isAbsolute = path.charAt(0) === "/", trailingSlash = path.substr(-1) === "/";
	                path = PATH.normalizeArray(path.split("/").filter((function (p) {
	                    return !!p
	                })), !isAbsolute).join("/");
	                if (!path && !isAbsolute) {
	                    path = "."
	                }
	                if (path && trailingSlash) {
	                    path += "/"
	                }
	                return (isAbsolute ? "/" : "") + path
	            }), dirname: (function (path) {
	                var result = PATH.splitPath(path), root = result[0], dir = result[1];
	                if (!root && !dir) {
	                    return "."
	                }
	                if (dir) {
	                    dir = dir.substr(0, dir.length - 1)
	                }
	                return root + dir
	            }), basename: (function (path) {
	                if (path === "/")return "/";
	                var lastSlash = path.lastIndexOf("/");
	                if (lastSlash === -1)return path;
	                return path.substr(lastSlash + 1)
	            }), extname: (function (path) {
	                return PATH.splitPath(path)[3]
	            }), join: (function () {
	                var paths = Array.prototype.slice.call(arguments, 0);
	                return PATH.normalize(paths.join("/"))
	            }), join2: (function (l, r) {
	                return PATH.normalize(l + "/" + r)
	            }), resolve: (function () {
	                var resolvedPath = "", resolvedAbsolute = false;
	                for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
	                    var path = i >= 0 ? arguments[i] : FS.cwd();
	                    if (typeof path !== "string") {
	                        throw new TypeError("Arguments to path.resolve must be strings")
	                    } else if (!path) {
	                        return ""
	                    }
	                    resolvedPath = path + "/" + resolvedPath;
	                    resolvedAbsolute = path.charAt(0) === "/"
	                }
	                resolvedPath = PATH.normalizeArray(resolvedPath.split("/").filter((function (p) {
	                    return !!p
	                })), !resolvedAbsolute).join("/");
	                return (resolvedAbsolute ? "/" : "") + resolvedPath || "."
	            }), relative: (function (from, to) {
	                from = PATH.resolve(from).substr(1);
	                to = PATH.resolve(to).substr(1);
	                function trim(arr) {
	                    var start = 0;
	                    for (; start < arr.length; start++) {
	                        if (arr[start] !== "")break
	                    }
	                    var end = arr.length - 1;
	                    for (; end >= 0; end--) {
	                        if (arr[end] !== "")break
	                    }
	                    if (start > end)return [];
	                    return arr.slice(start, end - start + 1)
	                }

	                var fromParts = trim(from.split("/"));
	                var toParts = trim(to.split("/"));
	                var length = Math.min(fromParts.length, toParts.length);
	                var samePartsLength = length;
	                for (var i = 0; i < length; i++) {
	                    if (fromParts[i] !== toParts[i]) {
	                        samePartsLength = i;
	                        break
	                    }
	                }
	                var outputParts = [];
	                for (var i = samePartsLength; i < fromParts.length; i++) {
	                    outputParts.push("..")
	                }
	                outputParts = outputParts.concat(toParts.slice(samePartsLength));
	                return outputParts.join("/")
	            })
	        };
	        var TTY = {
	            ttys: [], init: (function () {
	            }), shutdown: (function () {
	            }), register: (function (dev, ops) {
	                TTY.ttys[dev] = {input: [], output: [], ops: ops};
	                FS.registerDevice(dev, TTY.stream_ops)
	            }), stream_ops: {
	                open: (function (stream) {
	                    var tty = TTY.ttys[stream.node.rdev];
	                    if (!tty) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENODEV)
	                    }
	                    stream.tty = tty;
	                    stream.seekable = false
	                }), close: (function (stream) {
	                    stream.tty.ops.flush(stream.tty)
	                }), flush: (function (stream) {
	                    stream.tty.ops.flush(stream.tty)
	                }), read: (function (stream, buffer, offset, length, pos) {
	                    if (!stream.tty || !stream.tty.ops.get_char) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENXIO)
	                    }
	                    var bytesRead = 0;
	                    for (var i = 0; i < length; i++) {
	                        var result;
	                        try {
	                            result = stream.tty.ops.get_char(stream.tty)
	                        } catch (e) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EIO)
	                        }
	                        if (result === undefined && bytesRead === 0) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)
	                        }
	                        if (result === null || result === undefined)break;
	                        bytesRead++;
	                        buffer[offset + i] = result
	                    }
	                    if (bytesRead) {
	                        stream.node.timestamp = Date.now()
	                    }
	                    return bytesRead
	                }), write: (function (stream, buffer, offset, length, pos) {
	                    if (!stream.tty || !stream.tty.ops.put_char) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENXIO)
	                    }
	                    for (var i = 0; i < length; i++) {
	                        try {
	                            stream.tty.ops.put_char(stream.tty, buffer[offset + i])
	                        } catch (e) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EIO)
	                        }
	                    }
	                    if (length) {
	                        stream.node.timestamp = Date.now()
	                    }
	                    return i
	                })
	            }, default_tty_ops: {
	                get_char: (function (tty) {
	                    if (!tty.input.length) {
	                        var result = null;
	                        if (typeof window != "undefined" && typeof window.prompt == "function") {
	                            result = window.prompt("Input: ");
	                            if (result !== null) {
	                                result += "\n"
	                            }
	                        } else if (typeof readline == "function") {
	                            result = readline();
	                            if (result !== null) {
	                                result += "\n"
	                            }
	                        }
	                        if (!result) {
	                            return null
	                        }
	                        tty.input = intArrayFromString(result, true)
	                    }
	                    return tty.input.shift()
	                }), flush: (function (tty) {
	                    if (tty.output && tty.output.length > 0) {
	                        Module["print"](tty.output.join(""));
	                        tty.output = []
	                    }
	                }), put_char: (function (tty, val) {
	                    if (val === null || val === 10) {
	                        Module["print"](tty.output.join(""));
	                        tty.output = []
	                    } else {
	                        tty.output.push(TTY.utf8.processCChar(val))
	                    }
	                })
	            }, default_tty1_ops: {
	                put_char: (function (tty, val) {
	                    if (val === null || val === 10) {
	                        Module["printErr"](tty.output.join(""));
	                        tty.output = []
	                    } else {
	                        tty.output.push(TTY.utf8.processCChar(val))
	                    }
	                }), flush: (function (tty) {
	                    if (tty.output && tty.output.length > 0) {
	                        Module["printErr"](tty.output.join(""));
	                        tty.output = []
	                    }
	                })
	            }
	        };
	        var MEMFS = {
	            ops_table: null, mount: (function (mount) {
	                return MEMFS.createNode(null, "/", 16384 | 511, 0)
	            }), createNode: (function (parent, name, mode, dev) {
	                if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                if (!MEMFS.ops_table) {
	                    MEMFS.ops_table = {
	                        dir: {
	                            node: {
	                                getattr: MEMFS.node_ops.getattr,
	                                setattr: MEMFS.node_ops.setattr,
	                                lookup: MEMFS.node_ops.lookup,
	                                mknod: MEMFS.node_ops.mknod,
	                                rename: MEMFS.node_ops.rename,
	                                unlink: MEMFS.node_ops.unlink,
	                                rmdir: MEMFS.node_ops.rmdir,
	                                readdir: MEMFS.node_ops.readdir,
	                                symlink: MEMFS.node_ops.symlink
	                            }, stream: {llseek: MEMFS.stream_ops.llseek}
	                        },
	                        file: {
	                            node: {getattr: MEMFS.node_ops.getattr, setattr: MEMFS.node_ops.setattr},
	                            stream: {
	                                llseek: MEMFS.stream_ops.llseek,
	                                read: MEMFS.stream_ops.read,
	                                write: MEMFS.stream_ops.write,
	                                allocate: MEMFS.stream_ops.allocate,
	                                mmap: MEMFS.stream_ops.mmap
	                            }
	                        },
	                        link: {
	                            node: {
	                                getattr: MEMFS.node_ops.getattr,
	                                setattr: MEMFS.node_ops.setattr,
	                                readlink: MEMFS.node_ops.readlink
	                            }, stream: {}
	                        },
	                        chrdev: {
	                            node: {getattr: MEMFS.node_ops.getattr, setattr: MEMFS.node_ops.setattr},
	                            stream: FS.chrdev_stream_ops
	                        }
	                    }
	                }
	                var node = FS.createNode(parent, name, mode, dev);
	                if (FS.isDir(node.mode)) {
	                    node.node_ops = MEMFS.ops_table.dir.node;
	                    node.stream_ops = MEMFS.ops_table.dir.stream;
	                    node.contents = {}
	                } else if (FS.isFile(node.mode)) {
	                    node.node_ops = MEMFS.ops_table.file.node;
	                    node.stream_ops = MEMFS.ops_table.file.stream;
	                    node.usedBytes = 0;
	                    node.contents = null
	                } else if (FS.isLink(node.mode)) {
	                    node.node_ops = MEMFS.ops_table.link.node;
	                    node.stream_ops = MEMFS.ops_table.link.stream
	                } else if (FS.isChrdev(node.mode)) {
	                    node.node_ops = MEMFS.ops_table.chrdev.node;
	                    node.stream_ops = MEMFS.ops_table.chrdev.stream
	                }
	                node.timestamp = Date.now();
	                if (parent) {
	                    parent.contents[name] = node
	                }
	                return node
	            }), getFileDataAsRegularArray: (function (node) {
	                if (node.contents && node.contents.subarray) {
	                    var arr = [];
	                    for (var i = 0; i < node.usedBytes; ++i)arr.push(node.contents[i]);
	                    return arr
	                }
	                return node.contents
	            }), getFileDataAsTypedArray: (function (node) {
	                if (!node.contents)return new Uint8Array;
	                if (node.contents.subarray)return node.contents.subarray(0, node.usedBytes);
	                return new Uint8Array(node.contents)
	            }), expandFileStorage: (function (node, newCapacity) {
	                if (node.contents && node.contents.subarray && newCapacity > node.contents.length) {
	                    node.contents = MEMFS.getFileDataAsRegularArray(node);
	                    node.usedBytes = node.contents.length
	                }
	                if (!node.contents || node.contents.subarray) {
	                    var prevCapacity = node.contents ? node.contents.buffer.byteLength : 0;
	                    if (prevCapacity >= newCapacity)return;
	                    var CAPACITY_DOUBLING_MAX = 1024 * 1024;
	                    newCapacity = Math.max(newCapacity, prevCapacity * (prevCapacity < CAPACITY_DOUBLING_MAX ? 2 : 1.125) | 0);
	                    if (prevCapacity != 0)newCapacity = Math.max(newCapacity, 256);
	                    var oldContents = node.contents;
	                    node.contents = new Uint8Array(newCapacity);
	                    if (node.usedBytes > 0)node.contents.set(oldContents.subarray(0, node.usedBytes), 0);
	                    return
	                }
	                if (!node.contents && newCapacity > 0)node.contents = [];
	                while (node.contents.length < newCapacity)node.contents.push(0)
	            }), resizeFileStorage: (function (node, newSize) {
	                if (node.usedBytes == newSize)return;
	                if (newSize == 0) {
	                    node.contents = null;
	                    node.usedBytes = 0;
	                    return
	                }
	                if (!node.contents || node.contents.subarray) {
	                    var oldContents = node.contents;
	                    node.contents = new Uint8Array(new ArrayBuffer(newSize));
	                    if (oldContents) {
	                        node.contents.set(oldContents.subarray(0, Math.min(newSize, node.usedBytes)))
	                    }
	                    node.usedBytes = newSize;
	                    return
	                }
	                if (!node.contents)node.contents = [];
	                if (node.contents.length > newSize)node.contents.length = newSize; else while (node.contents.length < newSize)node.contents.push(0);
	                node.usedBytes = newSize
	            }), node_ops: {
	                getattr: (function (node) {
	                    var attr = {};
	                    attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
	                    attr.ino = node.id;
	                    attr.mode = node.mode;
	                    attr.nlink = 1;
	                    attr.uid = 0;
	                    attr.gid = 0;
	                    attr.rdev = node.rdev;
	                    if (FS.isDir(node.mode)) {
	                        attr.size = 4096
	                    } else if (FS.isFile(node.mode)) {
	                        attr.size = node.usedBytes
	                    } else if (FS.isLink(node.mode)) {
	                        attr.size = node.link.length
	                    } else {
	                        attr.size = 0
	                    }
	                    attr.atime = new Date(node.timestamp);
	                    attr.mtime = new Date(node.timestamp);
	                    attr.ctime = new Date(node.timestamp);
	                    attr.blksize = 4096;
	                    attr.blocks = Math.ceil(attr.size / attr.blksize);
	                    return attr
	                }), setattr: (function (node, attr) {
	                    if (attr.mode !== undefined) {
	                        node.mode = attr.mode
	                    }
	                    if (attr.timestamp !== undefined) {
	                        node.timestamp = attr.timestamp
	                    }
	                    if (attr.size !== undefined) {
	                        MEMFS.resizeFileStorage(node, attr.size)
	                    }
	                }), lookup: (function (parent, name) {
	                    throw FS.genericErrors[ERRNO_CODES.ENOENT]
	                }), mknod: (function (parent, name, mode, dev) {
	                    return MEMFS.createNode(parent, name, mode, dev)
	                }), rename: (function (old_node, new_dir, new_name) {
	                    if (FS.isDir(old_node.mode)) {
	                        var new_node;
	                        try {
	                            new_node = FS.lookupNode(new_dir, new_name)
	                        } catch (e) {
	                        }
	                        if (new_node) {
	                            for (var i in new_node.contents) {
	                                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)
	                            }
	                        }
	                    }
	                    delete old_node.parent.contents[old_node.name];
	                    old_node.name = new_name;
	                    new_dir.contents[new_name] = old_node;
	                    old_node.parent = new_dir
	                }), unlink: (function (parent, name) {
	                    delete parent.contents[name]
	                }), rmdir: (function (parent, name) {
	                    var node = FS.lookupNode(parent, name);
	                    for (var i in node.contents) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)
	                    }
	                    delete parent.contents[name]
	                }), readdir: (function (node) {
	                    var entries = [".", ".."];
	                    for (var key in node.contents) {
	                        if (!node.contents.hasOwnProperty(key)) {
	                            continue
	                        }
	                        entries.push(key)
	                    }
	                    return entries
	                }), symlink: (function (parent, newname, oldpath) {
	                    var node = MEMFS.createNode(parent, newname, 511 | 40960, 0);
	                    node.link = oldpath;
	                    return node
	                }), readlink: (function (node) {
	                    if (!FS.isLink(node.mode)) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                    return node.link
	                })
	            }, stream_ops: {
	                read: (function (stream, buffer, offset, length, position) {
	                    var contents = stream.node.contents;
	                    if (position >= stream.node.usedBytes)return 0;
	                    var size = Math.min(stream.node.usedBytes - position, length);
	                    assert(size >= 0);
	                    if (size > 8 && contents.subarray) {
	                        buffer.set(contents.subarray(position, position + size), offset)
	                    } else {
	                        for (var i = 0; i < size; i++)buffer[offset + i] = contents[position + i]
	                    }
	                    return size
	                }), write: (function (stream, buffer, offset, length, position, canOwn) {
	                    if (!length)return 0;
	                    var node = stream.node;
	                    node.timestamp = Date.now();
	                    if (buffer.subarray && (!node.contents || node.contents.subarray)) {
	                        if (canOwn) {
	                            node.contents = buffer.subarray(offset, offset + length);
	                            node.usedBytes = length;
	                            return length
	                        } else if (node.usedBytes === 0 && position === 0) {
	                            node.contents = new Uint8Array(buffer.subarray(offset, offset + length));
	                            node.usedBytes = length;
	                            return length
	                        } else if (position + length <= node.usedBytes) {
	                            node.contents.set(buffer.subarray(offset, offset + length), position);
	                            return length
	                        }
	                    }
	                    MEMFS.expandFileStorage(node, position + length);
	                    if (node.contents.subarray && buffer.subarray)node.contents.set(buffer.subarray(offset, offset + length), position); else for (var i = 0; i < length; i++) {
	                        node.contents[position + i] = buffer[offset + i]
	                    }
	                    node.usedBytes = Math.max(node.usedBytes, position + length);
	                    return length
	                }), llseek: (function (stream, offset, whence) {
	                    var position = offset;
	                    if (whence === 1) {
	                        position += stream.position
	                    } else if (whence === 2) {
	                        if (FS.isFile(stream.node.mode)) {
	                            position += stream.node.usedBytes
	                        }
	                    }
	                    if (position < 0) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                    return position
	                }), allocate: (function (stream, offset, length) {
	                    MEMFS.expandFileStorage(stream.node, offset + length);
	                    stream.node.usedBytes = Math.max(stream.node.usedBytes, offset + length)
	                }), mmap: (function (stream, buffer, offset, length, position, prot, flags) {
	                    if (!FS.isFile(stream.node.mode)) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENODEV)
	                    }
	                    var ptr;
	                    var allocated;
	                    var contents = stream.node.contents;
	                    if (!(flags & 2) && (contents.buffer === buffer || contents.buffer === buffer.buffer)) {
	                        allocated = false;
	                        ptr = contents.byteOffset
	                    } else {
	                        if (position > 0 || position + length < stream.node.usedBytes) {
	                            if (contents.subarray) {
	                                contents = contents.subarray(position, position + length)
	                            } else {
	                                contents = Array.prototype.slice.call(contents, position, position + length)
	                            }
	                        }
	                        allocated = true;
	                        ptr = _malloc(length);
	                        if (!ptr) {
	                            throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)
	                        }
	                        buffer.set(contents, ptr)
	                    }
	                    return {ptr: ptr, allocated: allocated}
	                })
	            }
	        };
	        var IDBFS = {
	            dbs: {}, indexedDB: (function () {
	                if (typeof indexedDB !== "undefined")return indexedDB;
	                var ret = null;
	                if (typeof window === "object")ret = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
	                assert(ret, "IDBFS used, but indexedDB not supported");
	                return ret
	            }), DB_VERSION: 21, DB_STORE_NAME: "FILE_DATA", mount: (function (mount) {
	                return MEMFS.mount.apply(null, arguments)
	            }), syncfs: (function (mount, populate, callback) {
	                IDBFS.getLocalSet(mount, (function (err, local) {
	                    if (err)return callback(err);
	                    IDBFS.getRemoteSet(mount, (function (err, remote) {
	                        if (err)return callback(err);
	                        var src = populate ? remote : local;
	                        var dst = populate ? local : remote;
	                        IDBFS.reconcile(src, dst, callback)
	                    }))
	                }))
	            }), getDB: (function (name, callback) {
	                var db = IDBFS.dbs[name];
	                if (db) {
	                    return callback(null, db)
	                }
	                var req;
	                try {
	                    req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION)
	                } catch (e) {
	                    return callback(e)
	                }
	                req.onupgradeneeded = (function (e) {
	                    var db = e.target.result;
	                    var transaction = e.target.transaction;
	                    var fileStore;
	                    if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
	                        fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME)
	                    } else {
	                        fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME)
	                    }
	                    fileStore.createIndex("timestamp", "timestamp", {unique: false})
	                });
	                req.onsuccess = (function () {
	                    db = req.result;
	                    IDBFS.dbs[name] = db;
	                    callback(null, db)
	                });
	                req.onerror = (function () {
	                    callback(this.error)
	                })
	            }), getLocalSet: (function (mount, callback) {
	                var entries = {};

	                function isRealDir(p) {
	                    return p !== "." && p !== ".."
	                }

	                function toAbsolute(root) {
	                    return (function (p) {
	                        return PATH.join2(root, p)
	                    })
	                }

	                var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
	                while (check.length) {
	                    var path = check.pop();
	                    var stat;
	                    try {
	                        stat = FS.stat(path)
	                    } catch (e) {
	                        return callback(e)
	                    }
	                    if (FS.isDir(stat.mode)) {
	                        check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))
	                    }
	                    entries[path] = {timestamp: stat.mtime}
	                }
	                return callback(null, {type: "local", entries: entries})
	            }), getRemoteSet: (function (mount, callback) {
	                var entries = {};
	                IDBFS.getDB(mount.mountpoint, (function (err, db) {
	                    if (err)return callback(err);
	                    var transaction = db.transaction([IDBFS.DB_STORE_NAME], "readonly");
	                    transaction.onerror = (function () {
	                        callback(this.error)
	                    });
	                    var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
	                    var index = store.index("timestamp");
	                    index.openKeyCursor().onsuccess = (function (event) {
	                        var cursor = event.target.result;
	                        if (!cursor) {
	                            return callback(null, {type: "remote", db: db, entries: entries})
	                        }
	                        entries[cursor.primaryKey] = {timestamp: cursor.key};
	                        cursor.continue()
	                    })
	                }))
	            }), loadLocalEntry: (function (path, callback) {
	                var stat, node;
	                try {
	                    var lookup = FS.lookupPath(path);
	                    node = lookup.node;
	                    stat = FS.stat(path)
	                } catch (e) {
	                    return callback(e)
	                }
	                if (FS.isDir(stat.mode)) {
	                    return callback(null, {timestamp: stat.mtime, mode: stat.mode})
	                } else if (FS.isFile(stat.mode)) {
	                    node.contents = MEMFS.getFileDataAsTypedArray(node);
	                    return callback(null, {timestamp: stat.mtime, mode: stat.mode, contents: node.contents})
	                } else {
	                    return callback(new Error("node type not supported"))
	                }
	            }), storeLocalEntry: (function (path, entry, callback) {
	                try {
	                    if (FS.isDir(entry.mode)) {
	                        FS.mkdir(path, entry.mode)
	                    } else if (FS.isFile(entry.mode)) {
	                        FS.writeFile(path, entry.contents, {encoding: "binary", canOwn: true})
	                    } else {
	                        return callback(new Error("node type not supported"))
	                    }
	                    FS.chmod(path, entry.mode);
	                    FS.utime(path, entry.timestamp, entry.timestamp)
	                } catch (e) {
	                    return callback(e)
	                }
	                callback(null)
	            }), removeLocalEntry: (function (path, callback) {
	                try {
	                    var lookup = FS.lookupPath(path);
	                    var stat = FS.stat(path);
	                    if (FS.isDir(stat.mode)) {
	                        FS.rmdir(path)
	                    } else if (FS.isFile(stat.mode)) {
	                        FS.unlink(path)
	                    }
	                } catch (e) {
	                    return callback(e)
	                }
	                callback(null)
	            }), loadRemoteEntry: (function (store, path, callback) {
	                var req = store.get(path);
	                req.onsuccess = (function (event) {
	                    callback(null, event.target.result)
	                });
	                req.onerror = (function () {
	                    callback(this.error)
	                })
	            }), storeRemoteEntry: (function (store, path, entry, callback) {
	                var req = store.put(entry, path);
	                req.onsuccess = (function () {
	                    callback(null)
	                });
	                req.onerror = (function () {
	                    callback(this.error)
	                })
	            }), removeRemoteEntry: (function (store, path, callback) {
	                var req = store.delete(path);
	                req.onsuccess = (function () {
	                    callback(null)
	                });
	                req.onerror = (function () {
	                    callback(this.error)
	                })
	            }), reconcile: (function (src, dst, callback) {
	                var total = 0;
	                var create = [];
	                Object.keys(src.entries).forEach((function (key) {
	                    var e = src.entries[key];
	                    var e2 = dst.entries[key];
	                    if (!e2 || e.timestamp > e2.timestamp) {
	                        create.push(key);
	                        total++
	                    }
	                }));
	                var remove = [];
	                Object.keys(dst.entries).forEach((function (key) {
	                    var e = dst.entries[key];
	                    var e2 = src.entries[key];
	                    if (!e2) {
	                        remove.push(key);
	                        total++
	                    }
	                }));
	                if (!total) {
	                    return callback(null)
	                }
	                var errored = false;
	                var completed = 0;
	                var db = src.type === "remote" ? src.db : dst.db;
	                var transaction = db.transaction([IDBFS.DB_STORE_NAME], "readwrite");
	                var store = transaction.objectStore(IDBFS.DB_STORE_NAME);

	                function done(err) {
	                    if (err) {
	                        if (!done.errored) {
	                            done.errored = true;
	                            return callback(err)
	                        }
	                        return
	                    }
	                    if (++completed >= total) {
	                        return callback(null)
	                    }
	                }

	                transaction.onerror = (function () {
	                    done(this.error)
	                });
	                create.sort().forEach((function (path) {
	                    if (dst.type === "local") {
	                        IDBFS.loadRemoteEntry(store, path, (function (err, entry) {
	                            if (err)return done(err);
	                            IDBFS.storeLocalEntry(path, entry, done)
	                        }))
	                    } else {
	                        IDBFS.loadLocalEntry(path, (function (err, entry) {
	                            if (err)return done(err);
	                            IDBFS.storeRemoteEntry(store, path, entry, done)
	                        }))
	                    }
	                }));
	                remove.sort().reverse().forEach((function (path) {
	                    if (dst.type === "local") {
	                        IDBFS.removeLocalEntry(path, done)
	                    } else {
	                        IDBFS.removeRemoteEntry(store, path, done)
	                    }
	                }))
	            })
	        };
	        var NODEFS = {
	            isWindows: false,
	            staticInit: (function () {
	                NODEFS.isWindows = !!process.platform.match(/^win/)
	            }),
	            mount: (function (mount) {
	                assert(false);
	                return NODEFS.createNode(null, "/", NODEFS.getMode(mount.opts.root), 0)
	            }),
	            createNode: (function (parent, name, mode, dev) {
	                if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                var node = FS.createNode(parent, name, mode);
	                node.node_ops = NODEFS.node_ops;
	                node.stream_ops = NODEFS.stream_ops;
	                return node
	            }),
	            getMode: (function (path) {
	                var stat;
	                try {
	                    stat = fs.lstatSync(path);
	                    if (NODEFS.isWindows) {
	                        stat.mode = stat.mode | (stat.mode & 146) >> 1
	                    }
	                } catch (e) {
	                    if (!e.code)throw e;
	                    throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                }
	                return stat.mode
	            }),
	            realPath: (function (node) {
	                var parts = [];
	                while (node.parent !== node) {
	                    parts.push(node.name);
	                    node = node.parent
	                }
	                parts.push(node.mount.opts.root);
	                parts.reverse();
	                return PATH.join.apply(null, parts)
	            }),
	            flagsToPermissionStringMap: {
	                0: "r",
	                1: "r+",
	                2: "r+",
	                64: "r",
	                65: "r+",
	                66: "r+",
	                129: "rx+",
	                193: "rx+",
	                514: "w+",
	                577: "w",
	                578: "w+",
	                705: "wx",
	                706: "wx+",
	                1024: "a",
	                1025: "a",
	                1026: "a+",
	                1089: "a",
	                1090: "a+",
	                1153: "ax",
	                1154: "ax+",
	                1217: "ax",
	                1218: "ax+",
	                4096: "rs",
	                4098: "rs+"
	            },
	            flagsToPermissionString: (function (flags) {
	                if (flags in NODEFS.flagsToPermissionStringMap) {
	                    return NODEFS.flagsToPermissionStringMap[flags]
	                } else {
	                    return flags
	                }
	            }),
	            node_ops: {
	                getattr: (function (node) {
	                    var path = NODEFS.realPath(node);
	                    var stat;
	                    try {
	                        stat = fs.lstatSync(path)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                    if (NODEFS.isWindows && !stat.blksize) {
	                        stat.blksize = 4096
	                    }
	                    if (NODEFS.isWindows && !stat.blocks) {
	                        stat.blocks = (stat.size + stat.blksize - 1) / stat.blksize | 0
	                    }
	                    return {
	                        dev: stat.dev,
	                        ino: stat.ino,
	                        mode: stat.mode,
	                        nlink: stat.nlink,
	                        uid: stat.uid,
	                        gid: stat.gid,
	                        rdev: stat.rdev,
	                        size: stat.size,
	                        atime: stat.atime,
	                        mtime: stat.mtime,
	                        ctime: stat.ctime,
	                        blksize: stat.blksize,
	                        blocks: stat.blocks
	                    }
	                }), setattr: (function (node, attr) {
	                    var path = NODEFS.realPath(node);
	                    try {
	                        if (attr.mode !== undefined) {
	                            fs.chmodSync(path, attr.mode);
	                            node.mode = attr.mode
	                        }
	                        if (attr.timestamp !== undefined) {
	                            var date = new Date(attr.timestamp);
	                            fs.utimesSync(path, date, date)
	                        }
	                        if (attr.size !== undefined) {
	                            fs.truncateSync(path, attr.size)
	                        }
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), lookup: (function (parent, name) {
	                    var path = PATH.join2(NODEFS.realPath(parent), name);
	                    var mode = NODEFS.getMode(path);
	                    return NODEFS.createNode(parent, name, mode)
	                }), mknod: (function (parent, name, mode, dev) {
	                    var node = NODEFS.createNode(parent, name, mode, dev);
	                    var path = NODEFS.realPath(node);
	                    try {
	                        if (FS.isDir(node.mode)) {
	                            fs.mkdirSync(path, node.mode)
	                        } else {
	                            fs.writeFileSync(path, "", {mode: node.mode})
	                        }
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                    return node
	                }), rename: (function (oldNode, newDir, newName) {
	                    var oldPath = NODEFS.realPath(oldNode);
	                    var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
	                    try {
	                        fs.renameSync(oldPath, newPath)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), unlink: (function (parent, name) {
	                    var path = PATH.join2(NODEFS.realPath(parent), name);
	                    try {
	                        fs.unlinkSync(path)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), rmdir: (function (parent, name) {
	                    var path = PATH.join2(NODEFS.realPath(parent), name);
	                    try {
	                        fs.rmdirSync(path)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), readdir: (function (node) {
	                    var path = NODEFS.realPath(node);
	                    try {
	                        return fs.readdirSync(path)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), symlink: (function (parent, newName, oldPath) {
	                    var newPath = PATH.join2(NODEFS.realPath(parent), newName);
	                    try {
	                        fs.symlinkSync(oldPath, newPath)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), readlink: (function (node) {
	                    var path = NODEFS.realPath(node);
	                    try {
	                        return fs.readlinkSync(path)
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                })
	            },
	            stream_ops: {
	                open: (function (stream) {
	                    var path = NODEFS.realPath(stream.node);
	                    try {
	                        if (FS.isFile(stream.node.mode)) {
	                            stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags))
	                        }
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), close: (function (stream) {
	                    try {
	                        if (FS.isFile(stream.node.mode) && stream.nfd) {
	                            fs.closeSync(stream.nfd)
	                        }
	                    } catch (e) {
	                        if (!e.code)throw e;
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                }), read: (function (stream, buffer, offset, length, position) {
	                    if (length === 0)return 0;
	                    var nbuffer = new Buffer(length);
	                    var res;
	                    try {
	                        res = fs.readSync(stream.nfd, nbuffer, 0, length, position)
	                    } catch (e) {
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                    if (res > 0) {
	                        for (var i = 0; i < res; i++) {
	                            buffer[offset + i] = nbuffer[i]
	                        }
	                    }
	                    return res
	                }), write: (function (stream, buffer, offset, length, position) {
	                    var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
	                    var res;
	                    try {
	                        res = fs.writeSync(stream.nfd, nbuffer, 0, length, position)
	                    } catch (e) {
	                        throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                    }
	                    return res
	                }), llseek: (function (stream, offset, whence) {
	                    var position = offset;
	                    if (whence === 1) {
	                        position += stream.position
	                    } else if (whence === 2) {
	                        if (FS.isFile(stream.node.mode)) {
	                            try {
	                                var stat = fs.fstatSync(stream.nfd);
	                                position += stat.size
	                            } catch (e) {
	                                throw new FS.ErrnoError(ERRNO_CODES[e.code])
	                            }
	                        }
	                    }
	                    if (position < 0) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                    return position
	                })
	            }
	        };
	        var _stdin = allocate(1, "i32*", ALLOC_STATIC);
	        var _stdout = allocate(1, "i32*", ALLOC_STATIC);
	        var _stderr = allocate(1, "i32*", ALLOC_STATIC);

	        function _fflush(stream) {
	        }

	        var FS = {
	            root: null,
	            mounts: [],
	            devices: [null],
	            streams: [],
	            nextInode: 1,
	            nameTable: null,
	            currentPath: "/",
	            initialized: false,
	            ignorePermissions: true,
	            trackingDelegate: {},
	            tracking: {openFlags: {READ: 1, WRITE: 2}},
	            ErrnoError: null,
	            genericErrors: {},
	            handleFSError: (function (e) {
	                if (!(e instanceof FS.ErrnoError))throw e + " : " + stackTrace();
	                return ___setErrNo(e.errno)
	            }),
	            lookupPath: (function (path, opts) {
	                path = PATH.resolve(FS.cwd(), path);
	                opts = opts || {};
	                if (!path)return {path: "", node: null};
	                var defaults = {follow_mount: true, recurse_count: 0};
	                for (var key in defaults) {
	                    if (opts[key] === undefined) {
	                        opts[key] = defaults[key]
	                    }
	                }
	                if (opts.recurse_count > 8) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ELOOP)
	                }
	                var parts = PATH.normalizeArray(path.split("/").filter((function (p) {
	                    return !!p
	                })), false);
	                var current = FS.root;
	                var current_path = "/";
	                for (var i = 0; i < parts.length; i++) {
	                    var islast = i === parts.length - 1;
	                    if (islast && opts.parent) {
	                        break
	                    }
	                    current = FS.lookupNode(current, parts[i]);
	                    current_path = PATH.join2(current_path, parts[i]);
	                    if (FS.isMountpoint(current)) {
	                        if (!islast || islast && opts.follow_mount) {
	                            current = current.mounted.root
	                        }
	                    }
	                    if (!islast || opts.follow) {
	                        var count = 0;
	                        while (FS.isLink(current.mode)) {
	                            var link = FS.readlink(current_path);
	                            current_path = PATH.resolve(PATH.dirname(current_path), link);
	                            var lookup = FS.lookupPath(current_path, {recurse_count: opts.recurse_count});
	                            current = lookup.node;
	                            if (count++ > 40) {
	                                throw new FS.ErrnoError(ERRNO_CODES.ELOOP)
	                            }
	                        }
	                    }
	                }
	                return {path: current_path, node: current}
	            }),
	            getPath: (function (node) {
	                var path;
	                while (true) {
	                    if (FS.isRoot(node)) {
	                        var mount = node.mount.mountpoint;
	                        if (!path)return mount;
	                        return mount[mount.length - 1] !== "/" ? mount + "/" + path : mount + path
	                    }
	                    path = path ? node.name + "/" + path : node.name;
	                    node = node.parent
	                }
	            }),
	            hashName: (function (parentid, name) {
	                var hash = 0;
	                for (var i = 0; i < name.length; i++) {
	                    hash = (hash << 5) - hash + name.charCodeAt(i) | 0
	                }
	                return (parentid + hash >>> 0) % FS.nameTable.length
	            }),
	            hashAddNode: (function (node) {
	                var hash = FS.hashName(node.parent.id, node.name);
	                node.name_next = FS.nameTable[hash];
	                FS.nameTable[hash] = node
	            }),
	            hashRemoveNode: (function (node) {
	                var hash = FS.hashName(node.parent.id, node.name);
	                if (FS.nameTable[hash] === node) {
	                    FS.nameTable[hash] = node.name_next
	                } else {
	                    var current = FS.nameTable[hash];
	                    while (current) {
	                        if (current.name_next === node) {
	                            current.name_next = node.name_next;
	                            break
	                        }
	                        current = current.name_next
	                    }
	                }
	            }),
	            lookupNode: (function (parent, name) {
	                var err = FS.mayLookup(parent);
	                if (err) {
	                    throw new FS.ErrnoError(err, parent)
	                }
	                var hash = FS.hashName(parent.id, name);
	                for (var node = FS.nameTable[hash]; node; node = node.name_next) {
	                    var nodeName = node.name;
	                    if (node.parent.id === parent.id && nodeName === name) {
	                        return node
	                    }
	                }
	                return FS.lookup(parent, name)
	            }),
	            createNode: (function (parent, name, mode, rdev) {
	                if (!FS.FSNode) {
	                    FS.FSNode = (function (parent, name, mode, rdev) {
	                        if (!parent) {
	                            parent = this
	                        }
	                        this.parent = parent;
	                        this.mount = parent.mount;
	                        this.mounted = null;
	                        this.id = FS.nextInode++;
	                        this.name = name;
	                        this.mode = mode;
	                        this.node_ops = {};
	                        this.stream_ops = {};
	                        this.rdev = rdev
	                    });
	                    FS.FSNode.prototype = {};
	                    var readMode = 292 | 73;
	                    var writeMode = 146;
	                    Object.defineProperties(FS.FSNode.prototype, {
	                        read: {
	                            get: (function () {
	                                return (this.mode & readMode) === readMode
	                            }), set: (function (val) {
	                                val ? this.mode |= readMode : this.mode &= ~readMode
	                            })
	                        }, write: {
	                            get: (function () {
	                                return (this.mode & writeMode) === writeMode
	                            }), set: (function (val) {
	                                val ? this.mode |= writeMode : this.mode &= ~writeMode
	                            })
	                        }, isFolder: {
	                            get: (function () {
	                                return FS.isDir(this.mode)
	                            })
	                        }, isDevice: {
	                            get: (function () {
	                                return FS.isChrdev(this.mode)
	                            })
	                        }
	                    })
	                }
	                var node = new FS.FSNode(parent, name, mode, rdev);
	                FS.hashAddNode(node);
	                return node
	            }),
	            destroyNode: (function (node) {
	                FS.hashRemoveNode(node)
	            }),
	            isRoot: (function (node) {
	                return node === node.parent
	            }),
	            isMountpoint: (function (node) {
	                return !!node.mounted
	            }),
	            isFile: (function (mode) {
	                return (mode & 61440) === 32768
	            }),
	            isDir: (function (mode) {
	                return (mode & 61440) === 16384
	            }),
	            isLink: (function (mode) {
	                return (mode & 61440) === 40960
	            }),
	            isChrdev: (function (mode) {
	                return (mode & 61440) === 8192
	            }),
	            isBlkdev: (function (mode) {
	                return (mode & 61440) === 24576
	            }),
	            isFIFO: (function (mode) {
	                return (mode & 61440) === 4096
	            }),
	            isSocket: (function (mode) {
	                return (mode & 49152) === 49152
	            }),
	            flagModes: {
	                "r": 0,
	                "rs": 1052672,
	                "r+": 2,
	                "w": 577,
	                "wx": 705,
	                "xw": 705,
	                "w+": 578,
	                "wx+": 706,
	                "xw+": 706,
	                "a": 1089,
	                "ax": 1217,
	                "xa": 1217,
	                "a+": 1090,
	                "ax+": 1218,
	                "xa+": 1218
	            },
	            modeStringToFlags: (function (str) {
	                var flags = FS.flagModes[str];
	                if (typeof flags === "undefined") {
	                    throw new Error("Unknown file open mode: " + str)
	                }
	                return flags
	            }),
	            flagsToPermissionString: (function (flag) {
	                var accmode = flag & 2097155;
	                var perms = ["r", "w", "rw"][accmode];
	                if (flag & 512) {
	                    perms += "w"
	                }
	                return perms
	            }),
	            nodePermissions: (function (node, perms) {
	                if (FS.ignorePermissions) {
	                    return 0
	                }
	                if (perms.indexOf("r") !== -1 && !(node.mode & 292)) {
	                    return ERRNO_CODES.EACCES
	                } else if (perms.indexOf("w") !== -1 && !(node.mode & 146)) {
	                    return ERRNO_CODES.EACCES
	                } else if (perms.indexOf("x") !== -1 && !(node.mode & 73)) {
	                    return ERRNO_CODES.EACCES
	                }
	                return 0
	            }),
	            mayLookup: (function (dir) {
	                var err = FS.nodePermissions(dir, "x");
	                if (err)return err;
	                if (!dir.node_ops.lookup)return ERRNO_CODES.EACCES;
	                return 0
	            }),
	            mayCreate: (function (dir, name) {
	                try {
	                    var node = FS.lookupNode(dir, name);
	                    return ERRNO_CODES.EEXIST
	                } catch (e) {
	                }
	                return FS.nodePermissions(dir, "wx")
	            }),
	            mayDelete: (function (dir, name, isdir) {
	                var node;
	                try {
	                    node = FS.lookupNode(dir, name)
	                } catch (e) {
	                    return e.errno
	                }
	                var err = FS.nodePermissions(dir, "wx");
	                if (err) {
	                    return err
	                }
	                if (isdir) {
	                    if (!FS.isDir(node.mode)) {
	                        return ERRNO_CODES.ENOTDIR
	                    }
	                    if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
	                        return ERRNO_CODES.EBUSY
	                    }
	                } else {
	                    if (FS.isDir(node.mode)) {
	                        return ERRNO_CODES.EISDIR
	                    }
	                }
	                return 0
	            }),
	            mayOpen: (function (node, flags) {
	                if (!node) {
	                    return ERRNO_CODES.ENOENT
	                }
	                if (FS.isLink(node.mode)) {
	                    return ERRNO_CODES.ELOOP
	                } else if (FS.isDir(node.mode)) {
	                    if ((flags & 2097155) !== 0 || flags & 512) {
	                        return ERRNO_CODES.EISDIR
	                    }
	                }
	                return FS.nodePermissions(node, FS.flagsToPermissionString(flags))
	            }),
	            MAX_OPEN_FDS: 4096,
	            nextfd: (function (fd_start, fd_end) {
	                fd_start = fd_start || 0;
	                fd_end = fd_end || FS.MAX_OPEN_FDS;
	                for (var fd = fd_start; fd <= fd_end; fd++) {
	                    if (!FS.streams[fd]) {
	                        return fd
	                    }
	                }
	                throw new FS.ErrnoError(ERRNO_CODES.EMFILE)
	            }),
	            getStream: (function (fd) {
	                return FS.streams[fd]
	            }),
	            createStream: (function (stream, fd_start, fd_end) {
	                if (!FS.FSStream) {
	                    FS.FSStream = (function () {
	                    });
	                    FS.FSStream.prototype = {};
	                    Object.defineProperties(FS.FSStream.prototype, {
	                        object: {
	                            get: (function () {
	                                return this.node
	                            }), set: (function (val) {
	                                this.node = val
	                            })
	                        }, isRead: {
	                            get: (function () {
	                                return (this.flags & 2097155) !== 1
	                            })
	                        }, isWrite: {
	                            get: (function () {
	                                return (this.flags & 2097155) !== 0
	                            })
	                        }, isAppend: {
	                            get: (function () {
	                                return this.flags & 1024
	                            })
	                        }
	                    })
	                }
	                var newStream = new FS.FSStream;
	                for (var p in stream) {
	                    newStream[p] = stream[p]
	                }
	                stream = newStream;
	                var fd = FS.nextfd(fd_start, fd_end);
	                stream.fd = fd;
	                FS.streams[fd] = stream;
	                return stream
	            }),
	            closeStream: (function (fd) {
	                FS.streams[fd] = null
	            }),
	            getStreamFromPtr: (function (ptr) {
	                return FS.streams[ptr - 1]
	            }),
	            getPtrForStream: (function (stream) {
	                return stream ? stream.fd + 1 : 0
	            }),
	            chrdev_stream_ops: {
	                open: (function (stream) {
	                    var device = FS.getDevice(stream.node.rdev);
	                    stream.stream_ops = device.stream_ops;
	                    if (stream.stream_ops.open) {
	                        stream.stream_ops.open(stream)
	                    }
	                }), llseek: (function () {
	                    throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)
	                })
	            },
	            major: (function (dev) {
	                return dev >> 8
	            }),
	            minor: (function (dev) {
	                return dev & 255
	            }),
	            makedev: (function (ma, mi) {
	                return ma << 8 | mi
	            }),
	            registerDevice: (function (dev, ops) {
	                FS.devices[dev] = {stream_ops: ops}
	            }),
	            getDevice: (function (dev) {
	                return FS.devices[dev]
	            }),
	            getMounts: (function (mount) {
	                var mounts = [];
	                var check = [mount];
	                while (check.length) {
	                    var m = check.pop();
	                    mounts.push(m);
	                    check.push.apply(check, m.mounts)
	                }
	                return mounts
	            }),
	            syncfs: (function (populate, callback) {
	                if (typeof populate === "function") {
	                    callback = populate;
	                    populate = false
	                }
	                var mounts = FS.getMounts(FS.root.mount);
	                var completed = 0;

	                function done(err) {
	                    if (err) {
	                        if (!done.errored) {
	                            done.errored = true;
	                            return callback(err)
	                        }
	                        return
	                    }
	                    if (++completed >= mounts.length) {
	                        callback(null)
	                    }
	                }

	                mounts.forEach((function (mount) {
	                    if (!mount.type.syncfs) {
	                        return done(null)
	                    }
	                    mount.type.syncfs(mount, populate, done)
	                }))
	            }),
	            mount: (function (type, opts, mountpoint) {
	                var root = mountpoint === "/";
	                var pseudo = !mountpoint;
	                var node;
	                if (root && FS.root) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBUSY)
	                } else if (!root && !pseudo) {
	                    var lookup = FS.lookupPath(mountpoint, {follow_mount: false});
	                    mountpoint = lookup.path;
	                    node = lookup.node;
	                    if (FS.isMountpoint(node)) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EBUSY)
	                    }
	                    if (!FS.isDir(node.mode)) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)
	                    }
	                }
	                var mount = {type: type, opts: opts, mountpoint: mountpoint, mounts: []};
	                var mountRoot = type.mount(mount);
	                mountRoot.mount = mount;
	                mount.root = mountRoot;
	                if (root) {
	                    FS.root = mountRoot
	                } else if (node) {
	                    node.mounted = mount;
	                    if (node.mount) {
	                        node.mount.mounts.push(mount)
	                    }
	                }
	                return mountRoot
	            }),
	            unmount: (function (mountpoint) {
	                var lookup = FS.lookupPath(mountpoint, {follow_mount: false});
	                if (!FS.isMountpoint(lookup.node)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                var node = lookup.node;
	                var mount = node.mounted;
	                var mounts = FS.getMounts(mount);
	                Object.keys(FS.nameTable).forEach((function (hash) {
	                    var current = FS.nameTable[hash];
	                    while (current) {
	                        var next = current.name_next;
	                        if (mounts.indexOf(current.mount) !== -1) {
	                            FS.destroyNode(current)
	                        }
	                        current = next
	                    }
	                }));
	                node.mounted = null;
	                var idx = node.mount.mounts.indexOf(mount);
	                assert(idx !== -1);
	                node.mount.mounts.splice(idx, 1)
	            }),
	            lookup: (function (parent, name) {
	                return parent.node_ops.lookup(parent, name)
	            }),
	            mknod: (function (path, mode, dev) {
	                var lookup = FS.lookupPath(path, {parent: true});
	                var parent = lookup.node;
	                var name = PATH.basename(path);
	                if (!name || name === "." || name === "..") {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                var err = FS.mayCreate(parent, name);
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                if (!parent.node_ops.mknod) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                return parent.node_ops.mknod(parent, name, mode, dev)
	            }),
	            create: (function (path, mode) {
	                mode = mode !== undefined ? mode : 438;
	                mode &= 4095;
	                mode |= 32768;
	                return FS.mknod(path, mode, 0)
	            }),
	            mkdir: (function (path, mode) {
	                mode = mode !== undefined ? mode : 511;
	                mode &= 511 | 512;
	                mode |= 16384;
	                return FS.mknod(path, mode, 0)
	            }),
	            mkdev: (function (path, mode, dev) {
	                if (typeof dev === "undefined") {
	                    dev = mode;
	                    mode = 438
	                }
	                mode |= 8192;
	                return FS.mknod(path, mode, dev)
	            }),
	            symlink: (function (oldpath, newpath) {
	                if (!PATH.resolve(oldpath)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOENT)
	                }
	                var lookup = FS.lookupPath(newpath, {parent: true});
	                var parent = lookup.node;
	                if (!parent) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOENT)
	                }
	                var newname = PATH.basename(newpath);
	                var err = FS.mayCreate(parent, newname);
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                if (!parent.node_ops.symlink) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                return parent.node_ops.symlink(parent, newname, oldpath)
	            }),
	            rename: (function (old_path, new_path) {
	                var old_dirname = PATH.dirname(old_path);
	                var new_dirname = PATH.dirname(new_path);
	                var old_name = PATH.basename(old_path);
	                var new_name = PATH.basename(new_path);
	                var lookup, old_dir, new_dir;
	                try {
	                    lookup = FS.lookupPath(old_path, {parent: true});
	                    old_dir = lookup.node;
	                    lookup = FS.lookupPath(new_path, {parent: true});
	                    new_dir = lookup.node
	                } catch (e) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBUSY)
	                }
	                if (!old_dir || !new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
	                if (old_dir.mount !== new_dir.mount) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EXDEV)
	                }
	                var old_node = FS.lookupNode(old_dir, old_name);
	                var relative = PATH.relative(old_path, new_dirname);
	                if (relative.charAt(0) !== ".") {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                relative = PATH.relative(new_path, old_dirname);
	                if (relative.charAt(0) !== ".") {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)
	                }
	                var new_node;
	                try {
	                    new_node = FS.lookupNode(new_dir, new_name)
	                } catch (e) {
	                }
	                if (old_node === new_node) {
	                    return
	                }
	                var isdir = FS.isDir(old_node.mode);
	                var err = FS.mayDelete(old_dir, old_name, isdir);
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                err = new_node ? FS.mayDelete(new_dir, new_name, isdir) : FS.mayCreate(new_dir, new_name);
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                if (!old_dir.node_ops.rename) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                if (FS.isMountpoint(old_node) || new_node && FS.isMountpoint(new_node)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBUSY)
	                }
	                if (new_dir !== old_dir) {
	                    err = FS.nodePermissions(old_dir, "w");
	                    if (err) {
	                        throw new FS.ErrnoError(err)
	                    }
	                }
	                try {
	                    if (FS.trackingDelegate["willMovePath"]) {
	                        FS.trackingDelegate["willMovePath"](old_path, new_path)
	                    }
	                } catch (e) {
	                    console.log("FS.trackingDelegate['willMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message)
	                }
	                FS.hashRemoveNode(old_node);
	                try {
	                    old_dir.node_ops.rename(old_node, new_dir, new_name)
	                } catch (e) {
	                    throw e
	                } finally {
	                    FS.hashAddNode(old_node)
	                }
	                try {
	                    if (FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path, new_path)
	                } catch (e) {
	                    console.log("FS.trackingDelegate['onMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message)
	                }
	            }),
	            rmdir: (function (path) {
	                var lookup = FS.lookupPath(path, {parent: true});
	                var parent = lookup.node;
	                var name = PATH.basename(path);
	                var node = FS.lookupNode(parent, name);
	                var err = FS.mayDelete(parent, name, true);
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                if (!parent.node_ops.rmdir) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                if (FS.isMountpoint(node)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBUSY)
	                }
	                try {
	                    if (FS.trackingDelegate["willDeletePath"]) {
	                        FS.trackingDelegate["willDeletePath"](path)
	                    }
	                } catch (e) {
	                    console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message)
	                }
	                parent.node_ops.rmdir(parent, name);
	                FS.destroyNode(node);
	                try {
	                    if (FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)
	                } catch (e) {
	                    console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message)
	                }
	            }),
	            readdir: (function (path) {
	                var lookup = FS.lookupPath(path, {follow: true});
	                var node = lookup.node;
	                if (!node.node_ops.readdir) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)
	                }
	                return node.node_ops.readdir(node)
	            }),
	            unlink: (function (path) {
	                var lookup = FS.lookupPath(path, {parent: true});
	                var parent = lookup.node;
	                var name = PATH.basename(path);
	                var node = FS.lookupNode(parent, name);
	                var err = FS.mayDelete(parent, name, false);
	                if (err) {
	                    if (err === ERRNO_CODES.EISDIR)err = ERRNO_CODES.EPERM;
	                    throw new FS.ErrnoError(err)
	                }
	                if (!parent.node_ops.unlink) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                if (FS.isMountpoint(node)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBUSY)
	                }
	                try {
	                    if (FS.trackingDelegate["willDeletePath"]) {
	                        FS.trackingDelegate["willDeletePath"](path)
	                    }
	                } catch (e) {
	                    console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message)
	                }
	                parent.node_ops.unlink(parent, name);
	                FS.destroyNode(node);
	                try {
	                    if (FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)
	                } catch (e) {
	                    console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message)
	                }
	            }),
	            readlink: (function (path) {
	                var lookup = FS.lookupPath(path);
	                var link = lookup.node;
	                if (!link) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOENT)
	                }
	                if (!link.node_ops.readlink) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                return link.node_ops.readlink(link)
	            }),
	            stat: (function (path, dontFollow) {
	                var lookup = FS.lookupPath(path, {follow: !dontFollow});
	                var node = lookup.node;
	                if (!node) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOENT)
	                }
	                if (!node.node_ops.getattr) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                return node.node_ops.getattr(node)
	            }),
	            lstat: (function (path) {
	                return FS.stat(path, true)
	            }),
	            chmod: (function (path, mode, dontFollow) {
	                var node;
	                if (typeof path === "string") {
	                    var lookup = FS.lookupPath(path, {follow: !dontFollow});
	                    node = lookup.node
	                } else {
	                    node = path
	                }
	                if (!node.node_ops.setattr) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                node.node_ops.setattr(node, {mode: mode & 4095 | node.mode & ~4095, timestamp: Date.now()})
	            }),
	            lchmod: (function (path, mode) {
	                FS.chmod(path, mode, true)
	            }),
	            fchmod: (function (fd, mode) {
	                var stream = FS.getStream(fd);
	                if (!stream) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBADF)
	                }
	                FS.chmod(stream.node, mode)
	            }),
	            chown: (function (path, uid, gid, dontFollow) {
	                var node;
	                if (typeof path === "string") {
	                    var lookup = FS.lookupPath(path, {follow: !dontFollow});
	                    node = lookup.node
	                } else {
	                    node = path
	                }
	                if (!node.node_ops.setattr) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                node.node_ops.setattr(node, {timestamp: Date.now()})
	            }),
	            lchown: (function (path, uid, gid) {
	                FS.chown(path, uid, gid, true)
	            }),
	            fchown: (function (fd, uid, gid) {
	                var stream = FS.getStream(fd);
	                if (!stream) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBADF)
	                }
	                FS.chown(stream.node, uid, gid)
	            }),
	            truncate: (function (path, len) {
	                if (len < 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                var node;
	                if (typeof path === "string") {
	                    var lookup = FS.lookupPath(path, {follow: true});
	                    node = lookup.node
	                } else {
	                    node = path
	                }
	                if (!node.node_ops.setattr) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EPERM)
	                }
	                if (FS.isDir(node.mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EISDIR)
	                }
	                if (!FS.isFile(node.mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                var err = FS.nodePermissions(node, "w");
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                node.node_ops.setattr(node, {size: len, timestamp: Date.now()})
	            }),
	            ftruncate: (function (fd, len) {
	                var stream = FS.getStream(fd);
	                if (!stream) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBADF)
	                }
	                if ((stream.flags & 2097155) === 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                FS.truncate(stream.node, len)
	            }),
	            utime: (function (path, atime, mtime) {
	                var lookup = FS.lookupPath(path, {follow: true});
	                var node = lookup.node;
	                node.node_ops.setattr(node, {timestamp: Math.max(atime, mtime)})
	            }),
	            open: (function (path, flags, mode, fd_start, fd_end) {
	                if (path === "") {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOENT)
	                }
	                flags = typeof flags === "string" ? FS.modeStringToFlags(flags) : flags;
	                mode = typeof mode === "undefined" ? 438 : mode;
	                if (flags & 64) {
	                    mode = mode & 4095 | 32768
	                } else {
	                    mode = 0
	                }
	                var node;
	                if (typeof path === "object") {
	                    node = path
	                } else {
	                    path = PATH.normalize(path);
	                    try {
	                        var lookup = FS.lookupPath(path, {follow: !(flags & 131072)});
	                        node = lookup.node
	                    } catch (e) {
	                    }
	                }
	                var created = false;
	                if (flags & 64) {
	                    if (node) {
	                        if (flags & 128) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EEXIST)
	                        }
	                    } else {
	                        node = FS.mknod(path, mode, 0);
	                        created = true
	                    }
	                }
	                if (!node) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOENT)
	                }
	                if (FS.isChrdev(node.mode)) {
	                    flags &= ~512
	                }
	                if (!created) {
	                    var err = FS.mayOpen(node, flags);
	                    if (err) {
	                        throw new FS.ErrnoError(err)
	                    }
	                }
	                if (flags & 512) {
	                    FS.truncate(node, 0)
	                }
	                flags &= ~(128 | 512);
	                var stream = FS.createStream({
	                    node: node,
	                    path: FS.getPath(node),
	                    flags: flags,
	                    seekable: true,
	                    position: 0,
	                    stream_ops: node.stream_ops,
	                    ungotten: [],
	                    error: false
	                }, fd_start, fd_end);
	                if (stream.stream_ops.open) {
	                    stream.stream_ops.open(stream)
	                }
	                if (Module["logReadFiles"] && !(flags & 1)) {
	                    if (!FS.readFiles)FS.readFiles = {};
	                    if (!(path in FS.readFiles)) {
	                        FS.readFiles[path] = 1;
	                        Module["printErr"]("read file: " + path)
	                    }
	                }
	                try {
	                    if (FS.trackingDelegate["onOpenFile"]) {
	                        var trackingFlags = 0;
	                        if ((flags & 2097155) !== 1) {
	                            trackingFlags |= FS.tracking.openFlags.READ
	                        }
	                        if ((flags & 2097155) !== 0) {
	                            trackingFlags |= FS.tracking.openFlags.WRITE
	                        }
	                        FS.trackingDelegate["onOpenFile"](path, trackingFlags)
	                    }
	                } catch (e) {
	                    console.log("FS.trackingDelegate['onOpenFile']('" + path + "', flags) threw an exception: " + e.message)
	                }
	                return stream
	            }),
	            close: (function (stream) {
	                try {
	                    if (stream.stream_ops.close) {
	                        stream.stream_ops.close(stream)
	                    }
	                } catch (e) {
	                    throw e
	                } finally {
	                    FS.closeStream(stream.fd)
	                }
	            }),
	            llseek: (function (stream, offset, whence) {
	                if (!stream.seekable || !stream.stream_ops.llseek) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)
	                }
	                stream.position = stream.stream_ops.llseek(stream, offset, whence);
	                stream.ungotten = [];
	                return stream.position
	            }),
	            read: (function (stream, buffer, offset, length, position) {
	                if (length < 0 || position < 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                if ((stream.flags & 2097155) === 1) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBADF)
	                }
	                if (FS.isDir(stream.node.mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EISDIR)
	                }
	                if (!stream.stream_ops.read) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                var seeking = true;
	                if (typeof position === "undefined") {
	                    position = stream.position;
	                    seeking = false
	                } else if (!stream.seekable) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)
	                }
	                var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
	                if (!seeking)stream.position += bytesRead;
	                return bytesRead
	            }),
	            write: (function (stream, buffer, offset, length, position, canOwn) {
	                if (length < 0 || position < 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                if ((stream.flags & 2097155) === 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBADF)
	                }
	                if (FS.isDir(stream.node.mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EISDIR)
	                }
	                if (!stream.stream_ops.write) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                if (stream.flags & 1024) {
	                    FS.llseek(stream, 0, 2)
	                }
	                var seeking = true;
	                if (typeof position === "undefined") {
	                    position = stream.position;
	                    seeking = false
	                } else if (!stream.seekable) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)
	                }
	                var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
	                if (!seeking)stream.position += bytesWritten;
	                try {
	                    if (stream.path && FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)
	                } catch (e) {
	                    console.log("FS.trackingDelegate['onWriteToFile']('" + path + "') threw an exception: " + e.message)
	                }
	                return bytesWritten
	            }),
	            allocate: (function (stream, offset, length) {
	                if (offset < 0 || length <= 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                }
	                if ((stream.flags & 2097155) === 0) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EBADF)
	                }
	                if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENODEV)
	                }
	                if (!stream.stream_ops.allocate) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)
	                }
	                stream.stream_ops.allocate(stream, offset, length)
	            }),
	            mmap: (function (stream, buffer, offset, length, position, prot, flags) {
	                if ((stream.flags & 2097155) === 1) {
	                    throw new FS.ErrnoError(ERRNO_CODES.EACCES)
	                }
	                if (!stream.stream_ops.mmap) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENODEV)
	                }
	                return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags)
	            }),
	            ioctl: (function (stream, cmd, arg) {
	                if (!stream.stream_ops.ioctl) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)
	                }
	                return stream.stream_ops.ioctl(stream, cmd, arg)
	            }),
	            readFile: (function (path, opts) {
	                opts = opts || {};
	                opts.flags = opts.flags || "r";
	                opts.encoding = opts.encoding || "binary";
	                if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
	                    throw new Error('Invalid encoding type "' + opts.encoding + '"')
	                }
	                var ret;
	                var stream = FS.open(path, opts.flags);
	                var stat = FS.stat(path);
	                var length = stat.size;
	                var buf = new Uint8Array(length);
	                FS.read(stream, buf, 0, length, 0);
	                if (opts.encoding === "utf8") {
	                    ret = "";
	                    var utf8 = new Runtime.UTF8Processor;
	                    for (var i = 0; i < length; i++) {
	                        ret += utf8.processCChar(buf[i])
	                    }
	                } else if (opts.encoding === "binary") {
	                    ret = buf
	                }
	                FS.close(stream);
	                return ret
	            }),
	            writeFile: (function (path, data, opts) {
	                opts = opts || {};
	                opts.flags = opts.flags || "w";
	                opts.encoding = opts.encoding || "utf8";
	                if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
	                    throw new Error('Invalid encoding type "' + opts.encoding + '"')
	                }
	                var stream = FS.open(path, opts.flags, opts.mode);
	                if (opts.encoding === "utf8") {
	                    var utf8 = new Runtime.UTF8Processor;
	                    var buf = new Uint8Array(utf8.processJSString(data));
	                    FS.write(stream, buf, 0, buf.length, 0, opts.canOwn)
	                } else if (opts.encoding === "binary") {
	                    FS.write(stream, data, 0, data.length, 0, opts.canOwn)
	                }
	                FS.close(stream)
	            }),
	            cwd: (function () {
	                return FS.currentPath
	            }),
	            chdir: (function (path) {
	                var lookup = FS.lookupPath(path, {follow: true});
	                if (!FS.isDir(lookup.node.mode)) {
	                    throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)
	                }
	                var err = FS.nodePermissions(lookup.node, "x");
	                if (err) {
	                    throw new FS.ErrnoError(err)
	                }
	                FS.currentPath = lookup.path
	            }),
	            createDefaultDirectories: (function () {
	                FS.mkdir("/tmp");
	                FS.mkdir("/home");
	                FS.mkdir("/home/web_user")
	            }),
	            createDefaultDevices: (function () {
	                FS.mkdir("/dev");
	                FS.registerDevice(FS.makedev(1, 3), {
	                    read: (function () {
	                        return 0
	                    }), write: (function () {
	                        return 0
	                    })
	                });
	                FS.mkdev("/dev/null", FS.makedev(1, 3));
	                TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
	                TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
	                FS.mkdev("/dev/tty", FS.makedev(5, 0));
	                FS.mkdev("/dev/tty1", FS.makedev(6, 0));
	                var random_device;
	                if (typeof crypto !== "undefined") {
	                    var randomBuffer = new Uint8Array(1);
	                    random_device = (function () {
	                        crypto.getRandomValues(randomBuffer);
	                        return randomBuffer[0]
	                    })
	                } else {
	                    random_device = (function () {
	                        return Math.random() * 256 | 0
	                    })
	                }
	                FS.createDevice("/dev", "random", random_device);
	                FS.createDevice("/dev", "urandom", random_device);
	                FS.mkdir("/dev/shm");
	                FS.mkdir("/dev/shm/tmp")
	            }),
	            createStandardStreams: (function () {
	                if (Module["stdin"]) {
	                    FS.createDevice("/dev", "stdin", Module["stdin"])
	                } else {
	                    FS.symlink("/dev/tty", "/dev/stdin")
	                }
	                if (Module["stdout"]) {
	                    FS.createDevice("/dev", "stdout", null, Module["stdout"])
	                } else {
	                    FS.symlink("/dev/tty", "/dev/stdout")
	                }
	                if (Module["stderr"]) {
	                    FS.createDevice("/dev", "stderr", null, Module["stderr"])
	                } else {
	                    FS.symlink("/dev/tty1", "/dev/stderr")
	                }
	                var stdin = FS.open("/dev/stdin", "r");
	                HEAP32[_stdin >> 2] = FS.getPtrForStream(stdin);
	                assert(stdin.fd === 0, "invalid handle for stdin (" + stdin.fd + ")");
	                var stdout = FS.open("/dev/stdout", "w");
	                HEAP32[_stdout >> 2] = FS.getPtrForStream(stdout);
	                assert(stdout.fd === 1, "invalid handle for stdout (" + stdout.fd + ")");
	                var stderr = FS.open("/dev/stderr", "w");
	                HEAP32[_stderr >> 2] = FS.getPtrForStream(stderr);
	                assert(stderr.fd === 2, "invalid handle for stderr (" + stderr.fd + ")")
	            }),
	            ensureErrnoError: (function () {
	                if (FS.ErrnoError)return;
	                FS.ErrnoError = function ErrnoError(errno, node) {
	                    this.node = node;
	                    this.setErrno = (function (errno) {
	                        this.errno = errno;
	                        for (var key in ERRNO_CODES) {
	                            if (ERRNO_CODES[key] === errno) {
	                                this.code = key;
	                                break
	                            }
	                        }
	                    });
	                    this.setErrno(errno);
	                    this.message = ERRNO_MESSAGES[errno]
	                };
	                FS.ErrnoError.prototype = new Error;
	                FS.ErrnoError.prototype.constructor = FS.ErrnoError;
	                [ERRNO_CODES.ENOENT].forEach((function (code) {
	                    FS.genericErrors[code] = new FS.ErrnoError(code);
	                    FS.genericErrors[code].stack = "<generic error, no stack>"
	                }))
	            }),
	            staticInit: (function () {
	                FS.ensureErrnoError();
	                FS.nameTable = new Array(4096);
	                FS.mount(MEMFS, {}, "/");
	                FS.createDefaultDirectories();
	                FS.createDefaultDevices()
	            }),
	            init: (function (input, output, error) {
	                assert(!FS.init.initialized, "FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");
	                FS.init.initialized = true;
	                FS.ensureErrnoError();
	                Module["stdin"] = input || Module["stdin"];
	                Module["stdout"] = output || Module["stdout"];
	                Module["stderr"] = error || Module["stderr"];
	                FS.createStandardStreams()
	            }),
	            quit: (function () {
	                FS.init.initialized = false;
	                for (var i = 0; i < FS.streams.length; i++) {
	                    var stream = FS.streams[i];
	                    if (!stream) {
	                        continue
	                    }
	                    FS.close(stream)
	                }
	            }),
	            getMode: (function (canRead, canWrite) {
	                var mode = 0;
	                if (canRead)mode |= 292 | 73;
	                if (canWrite)mode |= 146;
	                return mode
	            }),
	            joinPath: (function (parts, forceRelative) {
	                var path = PATH.join.apply(null, parts);
	                if (forceRelative && path[0] == "/")path = path.substr(1);
	                return path
	            }),
	            absolutePath: (function (relative, base) {
	                return PATH.resolve(base, relative)
	            }),
	            standardizePath: (function (path) {
	                return PATH.normalize(path)
	            }),
	            findObject: (function (path, dontResolveLastLink) {
	                var ret = FS.analyzePath(path, dontResolveLastLink);
	                if (ret.exists) {
	                    return ret.object
	                } else {
	                    ___setErrNo(ret.error);
	                    return null
	                }
	            }),
	            analyzePath: (function (path, dontResolveLastLink) {
	                try {
	                    var lookup = FS.lookupPath(path, {follow: !dontResolveLastLink});
	                    path = lookup.path
	                } catch (e) {
	                }
	                var ret = {
	                    isRoot: false,
	                    exists: false,
	                    error: 0,
	                    name: null,
	                    path: null,
	                    object: null,
	                    parentExists: false,
	                    parentPath: null,
	                    parentObject: null
	                };
	                try {
	                    var lookup = FS.lookupPath(path, {parent: true});
	                    ret.parentExists = true;
	                    ret.parentPath = lookup.path;
	                    ret.parentObject = lookup.node;
	                    ret.name = PATH.basename(path);
	                    lookup = FS.lookupPath(path, {follow: !dontResolveLastLink});
	                    ret.exists = true;
	                    ret.path = lookup.path;
	                    ret.object = lookup.node;
	                    ret.name = lookup.node.name;
	                    ret.isRoot = lookup.path === "/"
	                } catch (e) {
	                    ret.error = e.errno
	                }
	                return ret
	            }),
	            createFolder: (function (parent, name, canRead, canWrite) {
	                var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
	                var mode = FS.getMode(canRead, canWrite);
	                return FS.mkdir(path, mode)
	            }),
	            createPath: (function (parent, path, canRead, canWrite) {
	                parent = typeof parent === "string" ? parent : FS.getPath(parent);
	                var parts = path.split("/").reverse();
	                while (parts.length) {
	                    var part = parts.pop();
	                    if (!part)continue;
	                    var current = PATH.join2(parent, part);
	                    try {
	                        FS.mkdir(current)
	                    } catch (e) {
	                    }
	                    parent = current
	                }
	                return current
	            }),
	            createFile: (function (parent, name, properties, canRead, canWrite) {
	                var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
	                var mode = FS.getMode(canRead, canWrite);
	                return FS.create(path, mode)
	            }),
	            createDataFile: (function (parent, name, data, canRead, canWrite, canOwn) {
	                var path = name ? PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name) : parent;
	                var mode = FS.getMode(canRead, canWrite);
	                var node = FS.create(path, mode);
	                if (data) {
	                    if (typeof data === "string") {
	                        var arr = new Array(data.length);
	                        for (var i = 0, len = data.length; i < len; ++i)arr[i] = data.charCodeAt(i);
	                        data = arr
	                    }
	                    FS.chmod(node, mode | 146);
	                    var stream = FS.open(node, "w");
	                    FS.write(stream, data, 0, data.length, 0, canOwn);
	                    FS.close(stream);
	                    FS.chmod(node, mode)
	                }
	                return node
	            }),
	            createDevice: (function (parent, name, input, output) {
	                var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
	                var mode = FS.getMode(!!input, !!output);
	                if (!FS.createDevice.major)FS.createDevice.major = 64;
	                var dev = FS.makedev(FS.createDevice.major++, 0);
	                FS.registerDevice(dev, {
	                    open: (function (stream) {
	                        stream.seekable = false
	                    }), close: (function (stream) {
	                        if (output && output.buffer && output.buffer.length) {
	                            output(10)
	                        }
	                    }), read: (function (stream, buffer, offset, length, pos) {
	                        var bytesRead = 0;
	                        for (var i = 0; i < length; i++) {
	                            var result;
	                            try {
	                                result = input()
	                            } catch (e) {
	                                throw new FS.ErrnoError(ERRNO_CODES.EIO)
	                            }
	                            if (result === undefined && bytesRead === 0) {
	                                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)
	                            }
	                            if (result === null || result === undefined)break;
	                            bytesRead++;
	                            buffer[offset + i] = result
	                        }
	                        if (bytesRead) {
	                            stream.node.timestamp = Date.now()
	                        }
	                        return bytesRead
	                    }), write: (function (stream, buffer, offset, length, pos) {
	                        for (var i = 0; i < length; i++) {
	                            try {
	                                output(buffer[offset + i])
	                            } catch (e) {
	                                throw new FS.ErrnoError(ERRNO_CODES.EIO)
	                            }
	                        }
	                        if (length) {
	                            stream.node.timestamp = Date.now()
	                        }
	                        return i
	                    })
	                });
	                return FS.mkdev(path, mode, dev)
	            }),
	            createLink: (function (parent, name, target, canRead, canWrite) {
	                var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
	                return FS.symlink(target, path)
	            }),
	            forceLoadFile: (function (obj) {
	                if (obj.isDevice || obj.isFolder || obj.link || obj.contents)return true;
	                var success = true;
	                if (typeof XMLHttpRequest !== "undefined") {
	                    throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")
	                } else if (Module["read"]) {
	                    try {
	                        obj.contents = intArrayFromString(Module["read"](obj.url), true);
	                        obj.usedBytes = obj.contents.length
	                    } catch (e) {
	                        success = false
	                    }
	                } else {
	                    throw new Error("Cannot load without read() or XMLHttpRequest.")
	                }
	                if (!success)___setErrNo(ERRNO_CODES.EIO);
	                return success
	            }),
	            createLazyFile: (function (parent, name, url, canRead, canWrite) {
	                function LazyUint8Array() {
	                    this.lengthKnown = false;
	                    this.chunks = []
	                }

	                LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
	                    if (idx > this.length - 1 || idx < 0) {
	                        return undefined
	                    }
	                    var chunkOffset = idx % this.chunkSize;
	                    var chunkNum = idx / this.chunkSize | 0;
	                    return this.getter(chunkNum)[chunkOffset]
	                };
	                LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
	                    this.getter = getter
	                };
	                LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
	                    var xhr = new XMLHttpRequest;
	                    xhr.open("HEAD", url, false);
	                    xhr.send(null);
	                    if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304))throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
	                    var datalength = Number(xhr.getResponseHeader("Content-length"));
	                    var header;
	                    var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
	                    var chunkSize = 1024 * 1024;
	                    if (!hasByteServing)chunkSize = datalength;
	                    var doXHR = (function (from, to) {
	                        if (from > to)throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
	                        if (to > datalength - 1)throw new Error("only " + datalength + " bytes available! programmer error!");
	                        var xhr = new XMLHttpRequest;
	                        xhr.open("GET", url, false);
	                        if (datalength !== chunkSize)xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
	                        if (typeof Uint8Array != "undefined")xhr.responseType = "arraybuffer";
	                        if (xhr.overrideMimeType) {
	                            xhr.overrideMimeType("text/plain; charset=x-user-defined")
	                        }
	                        xhr.send(null);
	                        if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304))throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
	                        if (xhr.response !== undefined) {
	                            return new Uint8Array(xhr.response || [])
	                        } else {
	                            return intArrayFromString(xhr.responseText || "", true)
	                        }
	                    });
	                    var lazyArray = this;
	                    lazyArray.setDataGetter((function (chunkNum) {
	                        var start = chunkNum * chunkSize;
	                        var end = (chunkNum + 1) * chunkSize - 1;
	                        end = Math.min(end, datalength - 1);
	                        if (typeof lazyArray.chunks[chunkNum] === "undefined") {
	                            lazyArray.chunks[chunkNum] = doXHR(start, end)
	                        }
	                        if (typeof lazyArray.chunks[chunkNum] === "undefined")throw new Error("doXHR failed!");
	                        return lazyArray.chunks[chunkNum]
	                    }));
	                    this._length = datalength;
	                    this._chunkSize = chunkSize;
	                    this.lengthKnown = true
	                };
	                if (typeof XMLHttpRequest !== "undefined") {
	                    throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";
	                    var lazyArray = new LazyUint8Array;
	                    Object.defineProperty(lazyArray, "length", {
	                        get: (function () {
	                            if (!this.lengthKnown) {
	                                this.cacheLength()
	                            }
	                            return this._length
	                        })
	                    });
	                    Object.defineProperty(lazyArray, "chunkSize", {
	                        get: (function () {
	                            if (!this.lengthKnown) {
	                                this.cacheLength()
	                            }
	                            return this._chunkSize
	                        })
	                    });
	                    var properties = {isDevice: false, contents: lazyArray}
	                } else {
	                    var properties = {isDevice: false, url: url}
	                }
	                var node = FS.createFile(parent, name, properties, canRead, canWrite);
	                if (properties.contents) {
	                    node.contents = properties.contents
	                } else if (properties.url) {
	                    node.contents = null;
	                    node.url = properties.url
	                }
	                Object.defineProperty(node, "usedBytes", {
	                    get: (function () {
	                        return this.contents.length
	                    })
	                });
	                var stream_ops = {};
	                var keys = Object.keys(node.stream_ops);
	                keys.forEach((function (key) {
	                    var fn = node.stream_ops[key];
	                    stream_ops[key] = function forceLoadLazyFile() {
	                        if (!FS.forceLoadFile(node)) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EIO)
	                        }
	                        return fn.apply(null, arguments)
	                    }
	                }));
	                stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
	                    if (!FS.forceLoadFile(node)) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EIO)
	                    }
	                    var contents = stream.node.contents;
	                    if (position >= contents.length)return 0;
	                    var size = Math.min(contents.length - position, length);
	                    assert(size >= 0);
	                    if (contents.slice) {
	                        for (var i = 0; i < size; i++) {
	                            buffer[offset + i] = contents[position + i]
	                        }
	                    } else {
	                        for (var i = 0; i < size; i++) {
	                            buffer[offset + i] = contents.get(position + i)
	                        }
	                    }
	                    return size
	                };
	                node.stream_ops = stream_ops;
	                return node
	            }),
	            createPreloadedFile: (function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
	                Browser.init();
	                var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;

	                function processData(byteArray) {
	                    function finish(byteArray) {
	                        if (!dontCreateFile) {
	                            FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn)
	                        }
	                        if (onload)onload();
	                        removeRunDependency("cp " + fullname)
	                    }

	                    var handled = false;
	                    Module["preloadPlugins"].forEach((function (plugin) {
	                        if (handled)return;
	                        if (plugin["canHandle"](fullname)) {
	                            plugin["handle"](byteArray, fullname, finish, (function () {
	                                if (onerror)onerror();
	                                removeRunDependency("cp " + fullname)
	                            }));
	                            handled = true
	                        }
	                    }));
	                    if (!handled)finish(byteArray)
	                }

	                addRunDependency("cp " + fullname);
	                if (typeof url == "string") {
	                    Browser.asyncLoad(url, (function (byteArray) {
	                        processData(byteArray)
	                    }), onerror)
	                } else {
	                    processData(url)
	                }
	            }),
	            indexedDB: (function () {
	                return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB
	            }),
	            DB_NAME: (function () {
	                return "EM_FS_" + window.location.pathname
	            }),
	            DB_VERSION: 20,
	            DB_STORE_NAME: "FILE_DATA",
	            saveFilesToDB: (function (paths, onload, onerror) {
	                onload = onload || (function () {
	                    });
	                onerror = onerror || (function () {
	                    });
	                var indexedDB = FS.indexedDB();
	                try {
	                    var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION)
	                } catch (e) {
	                    return onerror(e)
	                }
	                openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
	                    console.log("creating db");
	                    var db = openRequest.result;
	                    db.createObjectStore(FS.DB_STORE_NAME)
	                };
	                openRequest.onsuccess = function openRequest_onsuccess() {
	                    var db = openRequest.result;
	                    var transaction = db.transaction([FS.DB_STORE_NAME], "readwrite");
	                    var files = transaction.objectStore(FS.DB_STORE_NAME);
	                    var ok = 0, fail = 0, total = paths.length;

	                    function finish() {
	                        if (fail == 0)onload(); else onerror()
	                    }

	                    paths.forEach((function (path) {
	                        var putRequest = files.put(FS.analyzePath(path).object.contents, path);
	                        putRequest.onsuccess = function putRequest_onsuccess() {
	                            ok++;
	                            if (ok + fail == total)finish()
	                        };
	                        putRequest.onerror = function putRequest_onerror() {
	                            fail++;
	                            if (ok + fail == total)finish()
	                        }
	                    }));
	                    transaction.onerror = onerror
	                };
	                openRequest.onerror = onerror
	            }),
	            loadFilesFromDB: (function (paths, onload, onerror) {
	                onload = onload || (function () {
	                    });
	                onerror = onerror || (function () {
	                    });
	                var indexedDB = FS.indexedDB();
	                try {
	                    var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION)
	                } catch (e) {
	                    return onerror(e)
	                }
	                openRequest.onupgradeneeded = onerror;
	                openRequest.onsuccess = function openRequest_onsuccess() {
	                    var db = openRequest.result;
	                    try {
	                        var transaction = db.transaction([FS.DB_STORE_NAME], "readonly")
	                    } catch (e) {
	                        onerror(e);
	                        return
	                    }
	                    var files = transaction.objectStore(FS.DB_STORE_NAME);
	                    var ok = 0, fail = 0, total = paths.length;

	                    function finish() {
	                        if (fail == 0)onload(); else onerror()
	                    }

	                    paths.forEach((function (path) {
	                        var getRequest = files.get(path);
	                        getRequest.onsuccess = function getRequest_onsuccess() {
	                            if (FS.analyzePath(path).exists) {
	                                FS.unlink(path)
	                            }
	                            FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
	                            ok++;
	                            if (ok + fail == total)finish()
	                        };
	                        getRequest.onerror = function getRequest_onerror() {
	                            fail++;
	                            if (ok + fail == total)finish()
	                        }
	                    }));
	                    transaction.onerror = onerror
	                };
	                openRequest.onerror = onerror
	            })
	        };

	        function _mkport() {
	            throw"TODO"
	        }

	        var SOCKFS = {
	            mount: (function (mount) {
	                Module["websocket"] = Module["websocket"] && "object" === typeof Module["websocket"] ? Module["websocket"] : {};
	                Module["websocket"]._callbacks = {};
	                Module["websocket"]["on"] = (function (event, callback) {
	                    if ("function" === typeof callback) {
	                        this._callbacks[event] = callback
	                    }
	                    return this
	                });
	                Module["websocket"].emit = (function (event, param) {
	                    if ("function" === typeof this._callbacks[event]) {
	                        this._callbacks[event].call(this, param)
	                    }
	                });
	                return FS.createNode(null, "/", 16384 | 511, 0)
	            }), createSocket: (function (family, type, protocol) {
	                var streaming = type == 1;
	                if (protocol) {
	                    assert(streaming == (protocol == 6))
	                }
	                var sock = {
	                    family: family,
	                    type: type,
	                    protocol: protocol,
	                    server: null,
	                    error: null,
	                    peers: {},
	                    pending: [],
	                    recv_queue: [],
	                    sock_ops: SOCKFS.websocket_sock_ops
	                };
	                var name = SOCKFS.nextname();
	                var node = FS.createNode(SOCKFS.root, name, 49152, 0);
	                node.sock = sock;
	                var stream = FS.createStream({
	                    path: name,
	                    node: node,
	                    flags: FS.modeStringToFlags("r+"),
	                    seekable: false,
	                    stream_ops: SOCKFS.stream_ops
	                });
	                sock.stream = stream;
	                return sock
	            }), getSocket: (function (fd) {
	                var stream = FS.getStream(fd);
	                if (!stream || !FS.isSocket(stream.node.mode)) {
	                    return null
	                }
	                return stream.node.sock
	            }), stream_ops: {
	                poll: (function (stream) {
	                    var sock = stream.node.sock;
	                    return sock.sock_ops.poll(sock)
	                }), ioctl: (function (stream, request, varargs) {
	                    var sock = stream.node.sock;
	                    return sock.sock_ops.ioctl(sock, request, varargs)
	                }), read: (function (stream, buffer, offset, length, position) {
	                    var sock = stream.node.sock;
	                    var msg = sock.sock_ops.recvmsg(sock, length);
	                    if (!msg) {
	                        return 0
	                    }
	                    buffer.set(msg.buffer, offset);
	                    return msg.buffer.length
	                }), write: (function (stream, buffer, offset, length, position) {
	                    var sock = stream.node.sock;
	                    return sock.sock_ops.sendmsg(sock, buffer, offset, length)
	                }), close: (function (stream) {
	                    var sock = stream.node.sock;
	                    sock.sock_ops.close(sock)
	                })
	            }, nextname: (function () {
	                if (!SOCKFS.nextname.current) {
	                    SOCKFS.nextname.current = 0
	                }
	                return "socket[" + SOCKFS.nextname.current++ + "]"
	            }), websocket_sock_ops: {
	                createPeer: (function (sock, addr, port) {
	                    var ws;
	                    if (typeof addr === "object") {
	                        ws = addr;
	                        addr = null;
	                        port = null
	                    }
	                    if (ws) {
	                        if (ws._socket) {
	                            addr = ws._socket.remoteAddress;
	                            port = ws._socket.remotePort
	                        } else {
	                            var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
	                            if (!result) {
	                                throw new Error("WebSocket URL must be in the format ws(s)://address:port")
	                            }
	                            addr = result[1];
	                            port = parseInt(result[2], 10)
	                        }
	                    } else {
	                        try {
	                            var runtimeConfig = Module["websocket"] && "object" === typeof Module["websocket"];
	                            var url = "ws:#".replace("#", "//");
	                            if (runtimeConfig) {
	                                if ("string" === typeof Module["websocket"]["url"]) {
	                                    url = Module["websocket"]["url"]
	                                }
	                            }
	                            if (url === "ws://" || url === "wss://") {
	                                var parts = addr.split("/");
	                                url = url + parts[0] + ":" + port + "/" + parts.slice(1).join("/")
	                            }
	                            var subProtocols = "binary";
	                            if (runtimeConfig) {
	                                if ("string" === typeof Module["websocket"]["subprotocol"]) {
	                                    subProtocols = Module["websocket"]["subprotocol"]
	                                }
	                            }
	                            subProtocols = subProtocols.replace(/^ +| +$/g, "").split(/ *, */);
	                            var opts = subProtocols;
	                            var WebSocket = window["WebSocket"];
	                            ws = new WebSocket(url, opts);
	                            ws.binaryType = "arraybuffer"
	                        } catch (e) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH)
	                        }
	                    }
	                    var peer = {addr: addr, port: port, socket: ws, dgram_send_queue: []};
	                    SOCKFS.websocket_sock_ops.addPeer(sock, peer);
	                    SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
	                    if (sock.type === 2 && typeof sock.sport !== "undefined") {
	                        peer.dgram_send_queue.push(new Uint8Array([255, 255, 255, 255, "p".charCodeAt(0), "o".charCodeAt(0), "r".charCodeAt(0), "t".charCodeAt(0), (sock.sport & 65280) >> 8, sock.sport & 255]))
	                    }
	                    return peer
	                }), getPeer: (function (sock, addr, port) {
	                    return sock.peers[addr + ":" + port]
	                }), addPeer: (function (sock, peer) {
	                    sock.peers[peer.addr + ":" + peer.port] = peer
	                }), removePeer: (function (sock, peer) {
	                    delete sock.peers[peer.addr + ":" + peer.port]
	                }), handlePeerEvents: (function (sock, peer) {
	                    var first = true;
	                    var handleOpen = (function () {
	                        Module["websocket"].emit("open", sock.stream.fd);
	                        try {
	                            var queued = peer.dgram_send_queue.shift();
	                            while (queued) {
	                                peer.socket.send(queued);
	                                queued = peer.dgram_send_queue.shift()
	                            }
	                        } catch (e) {
	                            peer.socket.close()
	                        }
	                    });

	                    function handleMessage(data) {
	                        assert(typeof data !== "string" && data.byteLength !== undefined);
	                        data = new Uint8Array(data);
	                        var wasfirst = first;
	                        first = false;
	                        if (wasfirst && data.length === 10 && data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 && data[4] === "p".charCodeAt(0) && data[5] === "o".charCodeAt(0) && data[6] === "r".charCodeAt(0) && data[7] === "t".charCodeAt(0)) {
	                            var newport = data[8] << 8 | data[9];
	                            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
	                            peer.port = newport;
	                            SOCKFS.websocket_sock_ops.addPeer(sock, peer);
	                            return
	                        }
	                        sock.recv_queue.push({addr: peer.addr, port: peer.port, data: data});
	                        Module["websocket"].emit("message", sock.stream.fd)
	                    }

	                    {
	                        peer.socket.onopen = handleOpen;
	                        peer.socket.onclose = (function () {
	                            Module["websocket"].emit("close", sock.stream.fd)
	                        });
	                        peer.socket.onmessage = function peer_socket_onmessage(event) {
	                            handleMessage(event.data)
	                        };
	                        peer.socket.onerror = (function (error) {
	                            sock.error = ERRNO_CODES.ECONNREFUSED;
	                            Module["websocket"].emit("error", [sock.stream.fd, sock.error, "ECONNREFUSED: Connection refused"])
	                        })
	                    }
	                }), poll: (function (sock) {
	                    if (sock.type === 1 && sock.server) {
	                        return sock.pending.length ? 64 | 1 : 0
	                    }
	                    var mask = 0;
	                    var dest = sock.type === 1 ? SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) : null;
	                    if (sock.recv_queue.length || !dest || dest && dest.socket.readyState === dest.socket.CLOSING || dest && dest.socket.readyState === dest.socket.CLOSED) {
	                        mask |= 64 | 1
	                    }
	                    if (!dest || dest && dest.socket.readyState === dest.socket.OPEN) {
	                        mask |= 4
	                    }
	                    if (dest && dest.socket.readyState === dest.socket.CLOSING || dest && dest.socket.readyState === dest.socket.CLOSED) {
	                        mask |= 16
	                    }
	                    return mask
	                }), ioctl: (function (sock, request, arg) {
	                    switch (request) {
	                        case 21531:
	                            var bytes = 0;
	                            if (sock.recv_queue.length) {
	                                bytes = sock.recv_queue[0].data.length
	                            }
	                            HEAP32[arg >> 2] = bytes;
	                            return 0;
	                        default:
	                            return ERRNO_CODES.EINVAL
	                    }
	                }), close: (function (sock) {
	                    if (sock.server) {
	                        try {
	                            sock.server.close()
	                        } catch (e) {
	                        }
	                        sock.server = null
	                    }
	                    var peers = Object.keys(sock.peers);
	                    for (var i = 0; i < peers.length; i++) {
	                        var peer = sock.peers[peers[i]];
	                        try {
	                            peer.socket.close()
	                        } catch (e) {
	                        }
	                        SOCKFS.websocket_sock_ops.removePeer(sock, peer)
	                    }
	                    return 0
	                }), bind: (function (sock, addr, port) {
	                    if (typeof sock.saddr !== "undefined" || typeof sock.sport !== "undefined") {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                    sock.saddr = addr;
	                    sock.sport = port || _mkport();
	                    if (sock.type === 2) {
	                        if (sock.server) {
	                            sock.server.close();
	                            sock.server = null
	                        }
	                        try {
	                            sock.sock_ops.listen(sock, 0)
	                        } catch (e) {
	                            if (!(e instanceof FS.ErrnoError))throw e;
	                            if (e.errno !== ERRNO_CODES.EOPNOTSUPP)throw e
	                        }
	                    }
	                }), connect: (function (sock, addr, port) {
	                    if (sock.server) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)
	                    }
	                    if (typeof sock.daddr !== "undefined" && typeof sock.dport !== "undefined") {
	                        var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
	                        if (dest) {
	                            if (dest.socket.readyState === dest.socket.CONNECTING) {
	                                throw new FS.ErrnoError(ERRNO_CODES.EALREADY)
	                            } else {
	                                throw new FS.ErrnoError(ERRNO_CODES.EISCONN)
	                            }
	                        }
	                    }
	                    var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
	                    sock.daddr = peer.addr;
	                    sock.dport = peer.port;
	                    throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS)
	                }), listen: (function (sock, backlog) {
	                    if (true) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)
	                    }
	                    if (sock.server) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                    var WebSocketServer = undefined;
	                    var host = sock.saddr;
	                    sock.server = new WebSocketServer({host: host, port: sock.sport});
	                    Module["websocket"].emit("listen", sock.stream.fd);
	                    sock.server.on("connection", (function (ws) {
	                        if (sock.type === 1) {
	                            var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
	                            var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
	                            newsock.daddr = peer.addr;
	                            newsock.dport = peer.port;
	                            sock.pending.push(newsock);
	                            Module["websocket"].emit("connection", newsock.stream.fd)
	                        } else {
	                            SOCKFS.websocket_sock_ops.createPeer(sock, ws);
	                            Module["websocket"].emit("connection", sock.stream.fd)
	                        }
	                    }));
	                    sock.server.on("closed", (function () {
	                        Module["websocket"].emit("close", sock.stream.fd);
	                        sock.server = null
	                    }));
	                    sock.server.on("error", (function (error) {
	                        sock.error = ERRNO_CODES.EHOSTUNREACH;
	                        Module["websocket"].emit("error", [sock.stream.fd, sock.error, "EHOSTUNREACH: Host is unreachable"])
	                    }))
	                }), accept: (function (listensock) {
	                    if (!listensock.server) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                    var newsock = listensock.pending.shift();
	                    newsock.stream.flags = listensock.stream.flags;
	                    return newsock
	                }), getname: (function (sock, peer) {
	                    var addr, port;
	                    if (peer) {
	                        if (sock.daddr === undefined || sock.dport === undefined) {
	                            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)
	                        }
	                        addr = sock.daddr;
	                        port = sock.dport
	                    } else {
	                        addr = sock.saddr || 0;
	                        port = sock.sport || 0
	                    }
	                    return {addr: addr, port: port}
	                }), sendmsg: (function (sock, buffer, offset, length, addr, port) {
	                    if (sock.type === 2) {
	                        if (addr === undefined || port === undefined) {
	                            addr = sock.daddr;
	                            port = sock.dport
	                        }
	                        if (addr === undefined || port === undefined) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ)
	                        }
	                    } else {
	                        addr = sock.daddr;
	                        port = sock.dport
	                    }
	                    var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
	                    if (sock.type === 1) {
	                        if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
	                            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)
	                        } else if (dest.socket.readyState === dest.socket.CONNECTING) {
	                            throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)
	                        }
	                    }
	                    var data;
	                    if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
	                        data = buffer.slice(offset, offset + length)
	                    } else {
	                        data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length)
	                    }
	                    if (sock.type === 2) {
	                        if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
	                            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
	                                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port)
	                            }
	                            dest.dgram_send_queue.push(data);
	                            return length
	                        }
	                    }
	                    try {
	                        dest.socket.send(data);
	                        return length
	                    } catch (e) {
	                        throw new FS.ErrnoError(ERRNO_CODES.EINVAL)
	                    }
	                }), recvmsg: (function (sock, length) {
	                    if (sock.type === 1 && sock.server) {
	                        throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)
	                    }
	                    var queued = sock.recv_queue.shift();
	                    if (!queued) {
	                        if (sock.type === 1) {
	                            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
	                            if (!dest) {
	                                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)
	                            } else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
	                                return null
	                            } else {
	                                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)
	                            }
	                        } else {
	                            throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)
	                        }
	                    }
	                    var queuedLength = queued.data.byteLength || queued.data.length;
	                    var queuedOffset = queued.data.byteOffset || 0;
	                    var queuedBuffer = queued.data.buffer || queued.data;
	                    var bytesRead = Math.min(length, queuedLength);
	                    var res = {
	                        buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
	                        addr: queued.addr,
	                        port: queued.port
	                    };
	                    if (sock.type === 1 && bytesRead < queuedLength) {
	                        var bytesRemaining = queuedLength - bytesRead;
	                        queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
	                        sock.recv_queue.unshift(queued)
	                    }
	                    return res
	                })
	            }
	        };

	        function _recv(fd, buf, len, flags) {
	            var sock = SOCKFS.getSocket(fd);
	            if (!sock) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            return _read(fd, buf, len)
	        }

	        function _pread(fildes, buf, nbyte, offset) {
	            var stream = FS.getStream(fildes);
	            if (!stream) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            try {
	                var slab = HEAP8;
	                return FS.read(stream, slab, buf, nbyte, offset)
	            } catch (e) {
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _read(fildes, buf, nbyte) {
	            var stream = FS.getStream(fildes);
	            if (!stream) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            try {
	                var slab = HEAP8;
	                return FS.read(stream, slab, buf, nbyte)
	            } catch (e) {
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _fread(ptr, size, nitems, stream) {
	            var bytesToRead = nitems * size;
	            if (bytesToRead == 0) {
	                return 0
	            }
	            var bytesRead = 0;
	            var streamObj = FS.getStreamFromPtr(stream);
	            if (!streamObj) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return 0
	            }
	            while (streamObj.ungotten.length && bytesToRead > 0) {
	                HEAP8[ptr++ >> 0] = streamObj.ungotten.pop();
	                bytesToRead--;
	                bytesRead++
	            }
	            var err = _read(streamObj.fd, ptr, bytesToRead);
	            if (err == -1) {
	                if (streamObj)streamObj.error = true;
	                return 0
	            }
	            bytesRead += err;
	            if (bytesRead < bytesToRead)streamObj.eof = true;
	            return bytesRead / size | 0
	        }

	        function _close(fildes) {
	            var stream = FS.getStream(fildes);
	            if (!stream) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            try {
	                FS.close(stream);
	                return 0
	            } catch (e) {
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _fsync(fildes) {
	            var stream = FS.getStream(fildes);
	            if (stream) {
	                return 0
	            } else {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	        }

	        function _fileno(stream) {
	            stream = FS.getStreamFromPtr(stream);
	            if (!stream)return -1;
	            return stream.fd
	        }

	        function _fclose(stream) {
	            var fd = _fileno(stream);
	            _fsync(fd);
	            return _close(fd)
	        }

	        Module["_strlen"] = _strlen;
	        Module["_strcat"] = _strcat;
	        function _strerror_r(errnum, strerrbuf, buflen) {
	            if (errnum in ERRNO_MESSAGES) {
	                if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
	                    return ___setErrNo(ERRNO_CODES.ERANGE)
	                } else {
	                    var msg = ERRNO_MESSAGES[errnum];
	                    writeAsciiToMemory(msg, strerrbuf);
	                    return 0
	                }
	            } else {
	                return ___setErrNo(ERRNO_CODES.EINVAL)
	            }
	        }

	        function _strerror(errnum) {
	            if (!_strerror.buffer)_strerror.buffer = _malloc(256);
	            _strerror_r(errnum, _strerror.buffer, 256);
	            return _strerror.buffer
	        }

	        Module["_bitshift64Shl"] = _bitshift64Shl;
	        function _send(fd, buf, len, flags) {
	            var sock = SOCKFS.getSocket(fd);
	            if (!sock) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            return _write(fd, buf, len)
	        }

	        function _pwrite(fildes, buf, nbyte, offset) {
	            var stream = FS.getStream(fildes);
	            if (!stream) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            try {
	                var slab = HEAP8;
	                return FS.write(stream, slab, buf, nbyte, offset)
	            } catch (e) {
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _write(fildes, buf, nbyte) {
	            var stream = FS.getStream(fildes);
	            if (!stream) {
	                ___setErrNo(ERRNO_CODES.EBADF);
	                return -1
	            }
	            try {
	                var slab = HEAP8;
	                return FS.write(stream, slab, buf, nbyte)
	            } catch (e) {
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _fwrite(ptr, size, nitems, stream) {
	            var bytesToWrite = nitems * size;
	            if (bytesToWrite == 0)return 0;
	            var fd = _fileno(stream);
	            var bytesWritten = _write(fd, ptr, bytesToWrite);
	            if (bytesWritten == -1) {
	                var streamObj = FS.getStreamFromPtr(stream);
	                if (streamObj)streamObj.error = true;
	                return 0
	            } else {
	                return bytesWritten / size | 0
	            }
	        }

	        function _abort() {
	            Module["abort"]()
	        }

	        function __reallyNegative(x) {
	            return x < 0 || x === 0 && 1 / x === -Infinity
	        }

	        function __formatString(format, varargs) {
	            var textIndex = format;
	            var argIndex = 0;

	            function getNextArg(type) {
	                var ret;
	                if (type === "double") {
	                    ret = (HEAP32[tempDoublePtr >> 2] = HEAP32[varargs + argIndex >> 2], HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[varargs + (argIndex + 4) >> 2], +HEAPF64[tempDoublePtr >> 3])
	                } else if (type == "i64") {
	                    ret = [HEAP32[varargs + argIndex >> 2], HEAP32[varargs + (argIndex + 4) >> 2]]
	                } else {
	                    type = "i32";
	                    ret = HEAP32[varargs + argIndex >> 2]
	                }
	                argIndex += Runtime.getNativeFieldSize(type);
	                return ret
	            }

	            var ret = [];
	            var curr, next, currArg;
	            while (1) {
	                var startTextIndex = textIndex;
	                curr = HEAP8[textIndex >> 0];
	                if (curr === 0)break;
	                next = HEAP8[textIndex + 1 >> 0];
	                if (curr == 37) {
	                    var flagAlwaysSigned = false;
	                    var flagLeftAlign = false;
	                    var flagAlternative = false;
	                    var flagZeroPad = false;
	                    var flagPadSign = false;
	                    flagsLoop:while (1) {
	                        switch (next) {
	                            case 43:
	                                flagAlwaysSigned = true;
	                                break;
	                            case 45:
	                                flagLeftAlign = true;
	                                break;
	                            case 35:
	                                flagAlternative = true;
	                                break;
	                            case 48:
	                                if (flagZeroPad) {
	                                    break flagsLoop
	                                } else {
	                                    flagZeroPad = true;
	                                    break
	                                }
	                                ;
	                            case 32:
	                                flagPadSign = true;
	                                break;
	                            default:
	                                break flagsLoop
	                        }
	                        textIndex++;
	                        next = HEAP8[textIndex + 1 >> 0]
	                    }
	                    var width = 0;
	                    if (next == 42) {
	                        width = getNextArg("i32");
	                        textIndex++;
	                        next = HEAP8[textIndex + 1 >> 0]
	                    } else {
	                        while (next >= 48 && next <= 57) {
	                            width = width * 10 + (next - 48);
	                            textIndex++;
	                            next = HEAP8[textIndex + 1 >> 0]
	                        }
	                    }
	                    var precisionSet = false, precision = -1;
	                    if (next == 46) {
	                        precision = 0;
	                        precisionSet = true;
	                        textIndex++;
	                        next = HEAP8[textIndex + 1 >> 0];
	                        if (next == 42) {
	                            precision = getNextArg("i32");
	                            textIndex++
	                        } else {
	                            while (1) {
	                                var precisionChr = HEAP8[textIndex + 1 >> 0];
	                                if (precisionChr < 48 || precisionChr > 57)break;
	                                precision = precision * 10 + (precisionChr - 48);
	                                textIndex++
	                            }
	                        }
	                        next = HEAP8[textIndex + 1 >> 0]
	                    }
	                    if (precision < 0) {
	                        precision = 6;
	                        precisionSet = false
	                    }
	                    var argSize;
	                    switch (String.fromCharCode(next)) {
	                        case"h":
	                            var nextNext = HEAP8[textIndex + 2 >> 0];
	                            if (nextNext == 104) {
	                                textIndex++;
	                                argSize = 1
	                            } else {
	                                argSize = 2
	                            }
	                            break;
	                        case"l":
	                            var nextNext = HEAP8[textIndex + 2 >> 0];
	                            if (nextNext == 108) {
	                                textIndex++;
	                                argSize = 8
	                            } else {
	                                argSize = 4
	                            }
	                            break;
	                        case"L":
	                        case"q":
	                        case"j":
	                            argSize = 8;
	                            break;
	                        case"z":
	                        case"t":
	                        case"I":
	                            argSize = 4;
	                            break;
	                        default:
	                            argSize = null
	                    }
	                    if (argSize)textIndex++;
	                    next = HEAP8[textIndex + 1 >> 0];
	                    switch (String.fromCharCode(next)) {
	                        case"d":
	                        case"i":
	                        case"u":
	                        case"o":
	                        case"x":
	                        case"X":
	                        case"p":
	                        {
	                            var signed = next == 100 || next == 105;
	                            argSize = argSize || 4;
	                            var currArg = getNextArg("i" + argSize * 8);
	                            var origArg = currArg;
	                            var argText;
	                            if (argSize == 8) {
	                                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117)
	                            }
	                            if (argSize <= 4) {
	                                var limit = Math.pow(256, argSize) - 1;
	                                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8)
	                            }
	                            var currAbsArg = Math.abs(currArg);
	                            var prefix = "";
	                            if (next == 100 || next == 105) {
	                                if (argSize == 8 && i64Math)argText = i64Math.stringify(origArg[0], origArg[1], null); else argText = reSign(currArg, 8 * argSize, 1).toString(10)
	                            } else if (next == 117) {
	                                if (argSize == 8 && i64Math)argText = i64Math.stringify(origArg[0], origArg[1], true); else argText = unSign(currArg, 8 * argSize, 1).toString(10);
	                                currArg = Math.abs(currArg)
	                            } else if (next == 111) {
	                                argText = (flagAlternative ? "0" : "") + currAbsArg.toString(8)
	                            } else if (next == 120 || next == 88) {
	                                prefix = flagAlternative && currArg != 0 ? "0x" : "";
	                                if (argSize == 8 && i64Math) {
	                                    if (origArg[1]) {
	                                        argText = (origArg[1] >>> 0).toString(16);
	                                        var lower = (origArg[0] >>> 0).toString(16);
	                                        while (lower.length < 8)lower = "0" + lower;
	                                        argText += lower
	                                    } else {
	                                        argText = (origArg[0] >>> 0).toString(16)
	                                    }
	                                } else if (currArg < 0) {
	                                    currArg = -currArg;
	                                    argText = (currAbsArg - 1).toString(16);
	                                    var buffer = [];
	                                    for (var i = 0; i < argText.length; i++) {
	                                        buffer.push((15 - parseInt(argText[i], 16)).toString(16))
	                                    }
	                                    argText = buffer.join("");
	                                    while (argText.length < argSize * 2)argText = "f" + argText
	                                } else {
	                                    argText = currAbsArg.toString(16)
	                                }
	                                if (next == 88) {
	                                    prefix = prefix.toUpperCase();
	                                    argText = argText.toUpperCase()
	                                }
	                            } else if (next == 112) {
	                                if (currAbsArg === 0) {
	                                    argText = "(nil)"
	                                } else {
	                                    prefix = "0x";
	                                    argText = currAbsArg.toString(16)
	                                }
	                            }
	                            if (precisionSet) {
	                                while (argText.length < precision) {
	                                    argText = "0" + argText
	                                }
	                            }
	                            if (currArg >= 0) {
	                                if (flagAlwaysSigned) {
	                                    prefix = "+" + prefix
	                                } else if (flagPadSign) {
	                                    prefix = " " + prefix
	                                }
	                            }
	                            if (argText.charAt(0) == "-") {
	                                prefix = "-" + prefix;
	                                argText = argText.substr(1)
	                            }
	                            while (prefix.length + argText.length < width) {
	                                if (flagLeftAlign) {
	                                    argText += " "
	                                } else {
	                                    if (flagZeroPad) {
	                                        argText = "0" + argText
	                                    } else {
	                                        prefix = " " + prefix
	                                    }
	                                }
	                            }
	                            argText = prefix + argText;
	                            argText.split("").forEach((function (chr) {
	                                ret.push(chr.charCodeAt(0))
	                            }));
	                            break
	                        }
	                            ;
	                        case"f":
	                        case"F":
	                        case"e":
	                        case"E":
	                        case"g":
	                        case"G":
	                        {
	                            var currArg = getNextArg("double");
	                            var argText;
	                            if (isNaN(currArg)) {
	                                argText = "nan";
	                                flagZeroPad = false
	                            } else if (!isFinite(currArg)) {
	                                argText = (currArg < 0 ? "-" : "") + "inf";
	                                flagZeroPad = false
	                            } else {
	                                var isGeneral = false;
	                                var effectivePrecision = Math.min(precision, 20);
	                                if (next == 103 || next == 71) {
	                                    isGeneral = true;
	                                    precision = precision || 1;
	                                    var exponent = parseInt(currArg.toExponential(effectivePrecision).split("e")[1], 10);
	                                    if (precision > exponent && exponent >= -4) {
	                                        next = (next == 103 ? "f" : "F").charCodeAt(0);
	                                        precision -= exponent + 1
	                                    } else {
	                                        next = (next == 103 ? "e" : "E").charCodeAt(0);
	                                        precision--
	                                    }
	                                    effectivePrecision = Math.min(precision, 20)
	                                }
	                                if (next == 101 || next == 69) {
	                                    argText = currArg.toExponential(effectivePrecision);
	                                    if (/[eE][-+]\d$/.test(argText)) {
	                                        argText = argText.slice(0, -1) + "0" + argText.slice(-1)
	                                    }
	                                } else if (next == 102 || next == 70) {
	                                    argText = currArg.toFixed(effectivePrecision);
	                                    if (currArg === 0 && __reallyNegative(currArg)) {
	                                        argText = "-" + argText
	                                    }
	                                }
	                                var parts = argText.split("e");
	                                if (isGeneral && !flagAlternative) {
	                                    while (parts[0].length > 1 && parts[0].indexOf(".") != -1 && (parts[0].slice(-1) == "0" || parts[0].slice(-1) == ".")) {
	                                        parts[0] = parts[0].slice(0, -1)
	                                    }
	                                } else {
	                                    if (flagAlternative && argText.indexOf(".") == -1)parts[0] += ".";
	                                    while (precision > effectivePrecision++)parts[0] += "0"
	                                }
	                                argText = parts[0] + (parts.length > 1 ? "e" + parts[1] : "");
	                                if (next == 69)argText = argText.toUpperCase();
	                                if (currArg >= 0) {
	                                    if (flagAlwaysSigned) {
	                                        argText = "+" + argText
	                                    } else if (flagPadSign) {
	                                        argText = " " + argText
	                                    }
	                                }
	                            }
	                            while (argText.length < width) {
	                                if (flagLeftAlign) {
	                                    argText += " "
	                                } else {
	                                    if (flagZeroPad && (argText[0] == "-" || argText[0] == "+")) {
	                                        argText = argText[0] + "0" + argText.slice(1)
	                                    } else {
	                                        argText = (flagZeroPad ? "0" : " ") + argText
	                                    }
	                                }
	                            }
	                            if (next < 97)argText = argText.toUpperCase();
	                            argText.split("").forEach((function (chr) {
	                                ret.push(chr.charCodeAt(0))
	                            }));
	                            break
	                        }
	                            ;
	                        case"s":
	                        {
	                            var arg = getNextArg("i8*");
	                            var argLength = arg ? _strlen(arg) : "(null)".length;
	                            if (precisionSet)argLength = Math.min(argLength, precision);
	                            if (!flagLeftAlign) {
	                                while (argLength < width--) {
	                                    ret.push(32)
	                                }
	                            }
	                            if (arg) {
	                                for (var i = 0; i < argLength; i++) {
	                                    ret.push(HEAPU8[arg++ >> 0])
	                                }
	                            } else {
	                                ret = ret.concat(intArrayFromString("(null)".substr(0, argLength), true))
	                            }
	                            if (flagLeftAlign) {
	                                while (argLength < width--) {
	                                    ret.push(32)
	                                }
	                            }
	                            break
	                        }
	                            ;
	                        case"c":
	                        {
	                            if (flagLeftAlign)ret.push(getNextArg("i8"));
	                            while (--width > 0) {
	                                ret.push(32)
	                            }
	                            if (!flagLeftAlign)ret.push(getNextArg("i8"));
	                            break
	                        }
	                            ;
	                        case"n":
	                        {
	                            var ptr = getNextArg("i32*");
	                            HEAP32[ptr >> 2] = ret.length;
	                            break
	                        }
	                            ;
	                        case"%":
	                        {
	                            ret.push(curr);
	                            break
	                        }
	                            ;
	                        default:
	                        {
	                            for (var i = startTextIndex; i < textIndex + 2; i++) {
	                                ret.push(HEAP8[i >> 0])
	                            }
	                        }
	                    }
	                    textIndex += 2
	                } else {
	                    ret.push(curr);
	                    textIndex += 1
	                }
	            }
	            return ret
	        }

	        function _fprintf(stream, format, varargs) {
	            var result = __formatString(format, varargs);
	            var stack = Runtime.stackSave();
	            var ret = _fwrite(allocate(result, "i8", ALLOC_STACK), 1, result.length, stream);
	            Runtime.stackRestore(stack);
	            return ret
	        }

	        function _printf(format, varargs) {
	            var stdout = HEAP32[_stdout >> 2];
	            return _fprintf(stdout, format, varargs)
	        }

	        function _fgetc(stream) {
	            var streamObj = FS.getStreamFromPtr(stream);
	            if (!streamObj)return -1;
	            if (streamObj.eof || streamObj.error)return -1;
	            var ret = _fread(_fgetc.ret, 1, 1, stream);
	            if (ret == 0) {
	                return -1
	            } else if (ret == -1) {
	                streamObj.error = true;
	                return -1
	            } else {
	                return HEAPU8[_fgetc.ret >> 0]
	            }
	        }

	        function _fgets(s, n, stream) {
	            var streamObj = FS.getStreamFromPtr(stream);
	            if (!streamObj)return 0;
	            if (streamObj.error || streamObj.eof)return 0;
	            var byte_;
	            for (var i = 0; i < n - 1 && byte_ != 10; i++) {
	                byte_ = _fgetc(stream);
	                if (byte_ == -1) {
	                    if (streamObj.error || streamObj.eof && i == 0)return 0; else if (streamObj.eof)break
	                }
	                HEAP8[s + i >> 0] = byte_
	            }
	            HEAP8[s + i >> 0] = 0;
	            return s
	        }

	        function _open(path, oflag, varargs) {
	            var mode = HEAP32[varargs >> 2];
	            path = Pointer_stringify(path);
	            try {
	                var stream = FS.open(path, oflag, mode);
	                return stream.fd
	            } catch (e) {
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _fopen(filename, mode) {
	            var flags;
	            mode = Pointer_stringify(mode);
	            if (mode[0] == "r") {
	                if (mode.indexOf("+") != -1) {
	                    flags = 2
	                } else {
	                    flags = 0
	                }
	            } else if (mode[0] == "w") {
	                if (mode.indexOf("+") != -1) {
	                    flags = 2
	                } else {
	                    flags = 1
	                }
	                flags |= 64;
	                flags |= 512
	            } else if (mode[0] == "a") {
	                if (mode.indexOf("+") != -1) {
	                    flags = 2
	                } else {
	                    flags = 1
	                }
	                flags |= 64;
	                flags |= 1024
	            } else {
	                ___setErrNo(ERRNO_CODES.EINVAL);
	                return 0
	            }
	            var fd = _open(filename, flags, allocate([511, 0, 0, 0], "i32", ALLOC_STACK));
	            return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd))
	        }

	        Module["_strncpy"] = _strncpy;
	        function _fputc(c, stream) {
	            var chr = unSign(c & 255);
	            HEAP8[_fputc.ret >> 0] = chr;
	            var fd = _fileno(stream);
	            var ret = _write(fd, _fputc.ret, 1);
	            if (ret == -1) {
	                var streamObj = FS.getStreamFromPtr(stream);
	                if (streamObj)streamObj.error = true;
	                return -1
	            } else {
	                return chr
	            }
	        }

	        Module["_i64Add"] = _i64Add;
	        var _fabs = Math_abs;
	        var _floor = Math_floor;
	        Module["_memset"] = _memset;
	        function _mmap(start, num, prot, flags, fd, offset) {
	            var MAP_PRIVATE = 2;
	            var ptr;
	            var allocated = false;
	            if (!_mmap.mappings)_mmap.mappings = {};
	            if (fd == -1) {
	                ptr = _malloc(num);
	                if (!ptr)return -1;
	                _memset(ptr, 0, num);
	                allocated = true
	            } else {
	                var info = FS.getStream(fd);
	                if (!info)return -1;
	                try {
	                    var res = FS.mmap(info, HEAPU8, start, num, offset, prot, flags);
	                    ptr = res.ptr;
	                    allocated = res.allocated
	                } catch (e) {
	                    FS.handleFSError(e);
	                    return -1
	                }
	            }
	            _mmap.mappings[ptr] = {malloc: ptr, num: num, allocated: allocated};
	            return ptr
	        }

	        function __exit(status) {
	            Module["exit"](status)
	        }

	        function _exit(status) {
	            __exit(status)
	        }

	        function _emscripten_set_main_loop_timing(mode, value) {
	            Browser.mainLoop.timingMode = mode;
	            Browser.mainLoop.timingValue = value;
	            if (!Browser.mainLoop.func) {
	                return 1
	            }
	            if (mode == 0) {
	                Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
	                    setTimeout(Browser.mainLoop.runner, value)
	                };
	                Browser.mainLoop.method = "timeout"
	            } else if (mode == 1) {
	                Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
	                    Browser.requestAnimationFrame(Browser.mainLoop.runner)
	                };
	                Browser.mainLoop.method = "rAF"
	            }
	            return 0
	        }

	        function _emscripten_set_main_loop(func, fps, simulateInfiniteLoop, arg) {
	            Module["noExitRuntime"] = true;
	            assert(!Browser.mainLoop.func, "emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");
	            Browser.mainLoop.func = func;
	            Browser.mainLoop.arg = arg;
	            var thisMainLoopId = Browser.mainLoop.currentlyRunningMainloop;
	            Browser.mainLoop.runner = function Browser_mainLoop_runner() {
	                if (ABORT)return;
	                if (Browser.mainLoop.queue.length > 0) {
	                    var start = Date.now();
	                    var blocker = Browser.mainLoop.queue.shift();
	                    blocker.func(blocker.arg);
	                    if (Browser.mainLoop.remainingBlockers) {
	                        var remaining = Browser.mainLoop.remainingBlockers;
	                        var next = remaining % 1 == 0 ? remaining - 1 : Math.floor(remaining);
	                        if (blocker.counted) {
	                            Browser.mainLoop.remainingBlockers = next
	                        } else {
	                            next = next + .5;
	                            Browser.mainLoop.remainingBlockers = (8 * remaining + next) / 9
	                        }
	                    }
	                    console.log('main loop blocker "' + blocker.name + '" took ' + (Date.now() - start) + " ms");
	                    Browser.mainLoop.updateStatus();
	                    setTimeout(Browser.mainLoop.runner, 0);
	                    return
	                }
	                if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop)return;
	                Browser.mainLoop.currentFrameNumber = Browser.mainLoop.currentFrameNumber + 1 | 0;
	                if (Browser.mainLoop.timingMode == 1 && Browser.mainLoop.timingValue > 1 && Browser.mainLoop.currentFrameNumber % Browser.mainLoop.timingValue != 0) {
	                    Browser.mainLoop.scheduler();
	                    return
	                }
	                if (Browser.mainLoop.method === "timeout" && Module.ctx) {
	                    Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");
	                    Browser.mainLoop.method = ""
	                }
	                Browser.mainLoop.runIter((function () {
	                    if (typeof arg !== "undefined") {
	                        Runtime.dynCall("vi", func, [arg])
	                    } else {
	                        Runtime.dynCall("v", func)
	                    }
	                }));
	                if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop)return;
	                if (typeof SDL === "object" && SDL.audio && SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();
	                Browser.mainLoop.scheduler()
	            };
	            if (fps && fps > 0)_emscripten_set_main_loop_timing(0, 1e3 / fps); else _emscripten_set_main_loop_timing(1, 1);
	            Browser.mainLoop.scheduler();
	            if (simulateInfiniteLoop) {
	                throw"SimulateInfiniteLoop"
	            }
	        }

	        var Browser = {
	            mainLoop: {
	                scheduler: null,
	                method: "",
	                currentlyRunningMainloop: 0,
	                func: null,
	                arg: 0,
	                timingMode: 0,
	                timingValue: 0,
	                currentFrameNumber: 0,
	                queue: [],
	                pause: (function () {
	                    Browser.mainLoop.scheduler = null;
	                    Browser.mainLoop.currentlyRunningMainloop++
	                }),
	                resume: (function () {
	                    Browser.mainLoop.currentlyRunningMainloop++;
	                    var timingMode = Browser.mainLoop.timingMode;
	                    var timingValue = Browser.mainLoop.timingValue;
	                    var func = Browser.mainLoop.func;
	                    Browser.mainLoop.func = null;
	                    _emscripten_set_main_loop(func, 0, false, Browser.mainLoop.arg);
	                    _emscripten_set_main_loop_timing(timingMode, timingValue)
	                }),
	                updateStatus: (function () {
	                    if (Module["setStatus"]) {
	                        var message = Module["statusMessage"] || "Please wait...";
	                        var remaining = Browser.mainLoop.remainingBlockers;
	                        var expected = Browser.mainLoop.expectedBlockers;
	                        if (remaining) {
	                            if (remaining < expected) {
	                                Module["setStatus"](message + " (" + (expected - remaining) + "/" + expected + ")")
	                            } else {
	                                Module["setStatus"](message)
	                            }
	                        } else {
	                            Module["setStatus"]("")
	                        }
	                    }
	                }),
	                runIter: (function (func) {
	                    if (ABORT)return;
	                    if (Module["preMainLoop"]) {
	                        var preRet = Module["preMainLoop"]();
	                        if (preRet === false) {
	                            return
	                        }
	                    }
	                    try {
	                        func()
	                    } catch (e) {
	                        if (e instanceof ExitStatus) {
	                            return
	                        } else {
	                            if (e && typeof e === "object" && e.stack)Module.printErr("exception thrown: " + [e, e.stack]);
	                            throw e
	                        }
	                    }
	                    if (Module["postMainLoop"])Module["postMainLoop"]()
	                })
	            },
	            isFullScreen: false,
	            pointerLock: false,
	            moduleContextCreatedCallbacks: [],
	            workers: [],
	            init: (function () {
	                if (!Module["preloadPlugins"])Module["preloadPlugins"] = [];
	                if (Browser.initted)return;
	                Browser.initted = true;
	                try {
	                    new Blob;
	                    Browser.hasBlobConstructor = true
	                } catch (e) {
	                    Browser.hasBlobConstructor = false;
	                    console.log("warning: no blob constructor, cannot create blobs with mimetypes")
	                }
	                Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : !Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null;
	                Browser.URLObject = typeof window != "undefined" ? window.URL ? window.URL : window.webkitURL : undefined;
	                if (!Module.noImageDecoding && typeof Browser.URLObject === "undefined") {
	                    console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
	                    Module.noImageDecoding = true
	                }
	                var imagePlugin = {};
	                imagePlugin["canHandle"] = function imagePlugin_canHandle(name) {
	                    return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name)
	                };
	                imagePlugin["handle"] = function imagePlugin_handle(byteArray, name, onload, onerror) {
	                    var b = null;
	                    if (Browser.hasBlobConstructor) {
	                        try {
	                            b = new Blob([byteArray], {type: Browser.getMimetype(name)});
	                            if (b.size !== byteArray.length) {
	                                b = new Blob([(new Uint8Array(byteArray)).buffer], {type: Browser.getMimetype(name)})
	                            }
	                        } catch (e) {
	                            Runtime.warnOnce("Blob constructor present but fails: " + e + "; falling back to blob builder")
	                        }
	                    }
	                    if (!b) {
	                        var bb = new Browser.BlobBuilder;
	                        bb.append((new Uint8Array(byteArray)).buffer);
	                        b = bb.getBlob()
	                    }
	                    var url = Browser.URLObject.createObjectURL(b);
	                    var img = new Image;
	                    img.onload = function img_onload() {
	                        assert(img.complete, "Image " + name + " could not be decoded");
	                        var canvas = document.createElement("canvas");
	                        canvas.width = img.width;
	                        canvas.height = img.height;
	                        var ctx = canvas.getContext("2d");
	                        ctx.drawImage(img, 0, 0);
	                        Module["preloadedImages"][name] = canvas;
	                        Browser.URLObject.revokeObjectURL(url);
	                        if (onload)onload(byteArray)
	                    };
	                    img.onerror = function img_onerror(event) {
	                        console.log("Image " + url + " could not be decoded");
	                        if (onerror)onerror()
	                    };
	                    img.src = url
	                };
	                Module["preloadPlugins"].push(imagePlugin);
	                var audioPlugin = {};
	                audioPlugin["canHandle"] = function audioPlugin_canHandle(name) {
	                    return !Module.noAudioDecoding && name.substr(-4) in {".ogg": 1, ".wav": 1, ".mp3": 1}
	                };
	                audioPlugin["handle"] = function audioPlugin_handle(byteArray, name, onload, onerror) {
	                    var done = false;

	                    function finish(audio) {
	                        if (done)return;
	                        done = true;
	                        Module["preloadedAudios"][name] = audio;
	                        if (onload)onload(byteArray)
	                    }

	                    function fail() {
	                        if (done)return;
	                        done = true;
	                        Module["preloadedAudios"][name] = new Audio;
	                        if (onerror)onerror()
	                    }

	                    if (Browser.hasBlobConstructor) {
	                        try {
	                            var b = new Blob([byteArray], {type: Browser.getMimetype(name)})
	                        } catch (e) {
	                            return fail()
	                        }
	                        var url = Browser.URLObject.createObjectURL(b);
	                        var audio = new Audio;
	                        audio.addEventListener("canplaythrough", (function () {
	                            finish(audio)
	                        }), false);
	                        audio.onerror = function audio_onerror(event) {
	                            if (done)return;
	                            console.log("warning: browser could not fully decode audio " + name + ", trying slower base64 approach");
	                            function encode64(data) {
	                                var BASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	                                var PAD = "=";
	                                var ret = "";
	                                var leftchar = 0;
	                                var leftbits = 0;
	                                for (var i = 0; i < data.length; i++) {
	                                    leftchar = leftchar << 8 | data[i];
	                                    leftbits += 8;
	                                    while (leftbits >= 6) {
	                                        var curr = leftchar >> leftbits - 6 & 63;
	                                        leftbits -= 6;
	                                        ret += BASE[curr]
	                                    }
	                                }
	                                if (leftbits == 2) {
	                                    ret += BASE[(leftchar & 3) << 4];
	                                    ret += PAD + PAD
	                                } else if (leftbits == 4) {
	                                    ret += BASE[(leftchar & 15) << 2];
	                                    ret += PAD
	                                }
	                                return ret
	                            }

	                            audio.src = "data:audio/x-" + name.substr(-3) + ";base64," + encode64(byteArray);
	                            finish(audio)
	                        };
	                        audio.src = url;
	                        Browser.safeSetTimeout((function () {
	                            finish(audio)
	                        }), 1e4)
	                    } else {
	                        return fail()
	                    }
	                };
	                Module["preloadPlugins"].push(audioPlugin);
	                var canvas = Module["canvas"];

	                function pointerLockChange() {
	                    Browser.pointerLock = document["pointerLockElement"] === canvas || document["mozPointerLockElement"] === canvas || document["webkitPointerLockElement"] === canvas || document["msPointerLockElement"] === canvas
	                }

	                if (canvas) {
	                    canvas.requestPointerLock = canvas["requestPointerLock"] || canvas["mozRequestPointerLock"] || canvas["webkitRequestPointerLock"] || canvas["msRequestPointerLock"] || (function () {
	                        });
	                    canvas.exitPointerLock = document["exitPointerLock"] || document["mozExitPointerLock"] || document["webkitExitPointerLock"] || document["msExitPointerLock"] || (function () {
	                        });
	                    canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
	                    document.addEventListener("pointerlockchange", pointerLockChange, false);
	                    document.addEventListener("mozpointerlockchange", pointerLockChange, false);
	                    document.addEventListener("webkitpointerlockchange", pointerLockChange, false);
	                    document.addEventListener("mspointerlockchange", pointerLockChange, false);
	                    if (Module["elementPointerLock"]) {
	                        canvas.addEventListener("click", (function (ev) {
	                            if (!Browser.pointerLock && canvas.requestPointerLock) {
	                                canvas.requestPointerLock();
	                                ev.preventDefault()
	                            }
	                        }), false)
	                    }
	                }
	            }),
	            createContext: (function (canvas, useWebGL, setInModule, webGLContextAttributes) {
	                if (useWebGL && Module.ctx && canvas == Module.canvas)return Module.ctx;
	                var ctx;
	                var contextHandle;
	                if (useWebGL) {
	                    var contextAttributes = {antialias: false, alpha: false};
	                    if (webGLContextAttributes) {
	                        for (var attribute in webGLContextAttributes) {
	                            contextAttributes[attribute] = webGLContextAttributes[attribute]
	                        }
	                    }
	                    contextHandle = GL.createContext(canvas, contextAttributes);
	                    if (contextHandle) {
	                        ctx = GL.getContext(contextHandle).GLctx
	                    }
	                    canvas.style.backgroundColor = "black"
	                } else {
	                    ctx = canvas.getContext("2d")
	                }
	                if (!ctx)return null;
	                if (setInModule) {
	                    if (!useWebGL)assert(typeof GLctx === "undefined", "cannot set in module if GLctx is used, but we are a non-GL context that would replace it");
	                    Module.ctx = ctx;
	                    if (useWebGL)GL.makeContextCurrent(contextHandle);
	                    Module.useWebGL = useWebGL;
	                    Browser.moduleContextCreatedCallbacks.forEach((function (callback) {
	                        callback()
	                    }));
	                    Browser.init()
	                }
	                return ctx
	            }),
	            destroyContext: (function (canvas, useWebGL, setInModule) {
	            }),
	            fullScreenHandlersInstalled: false,
	            lockPointer: undefined,
	            resizeCanvas: undefined,
	            requestFullScreen: (function (lockPointer, resizeCanvas) {
	                Browser.lockPointer = lockPointer;
	                Browser.resizeCanvas = resizeCanvas;
	                if (typeof Browser.lockPointer === "undefined")Browser.lockPointer = true;
	                if (typeof Browser.resizeCanvas === "undefined")Browser.resizeCanvas = false;
	                var canvas = Module["canvas"];

	                function fullScreenChange() {
	                    Browser.isFullScreen = false;
	                    var canvasContainer = canvas.parentNode;
	                    if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvasContainer) {
	                        canvas.cancelFullScreen = document["cancelFullScreen"] || document["mozCancelFullScreen"] || document["webkitCancelFullScreen"] || document["msExitFullscreen"] || document["exitFullscreen"] || (function () {
	                            });
	                        canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
	                        if (Browser.lockPointer)canvas.requestPointerLock();
	                        Browser.isFullScreen = true;
	                        if (Browser.resizeCanvas)Browser.setFullScreenCanvasSize()
	                    } else {
	                        canvasContainer.parentNode.insertBefore(canvas, canvasContainer);
	                        canvasContainer.parentNode.removeChild(canvasContainer);
	                        if (Browser.resizeCanvas)Browser.setWindowedCanvasSize()
	                    }
	                    if (Module["onFullScreen"])Module["onFullScreen"](Browser.isFullScreen);
	                    Browser.updateCanvasDimensions(canvas)
	                }

	                if (!Browser.fullScreenHandlersInstalled) {
	                    Browser.fullScreenHandlersInstalled = true;
	                    document.addEventListener("fullscreenchange", fullScreenChange, false);
	                    document.addEventListener("mozfullscreenchange", fullScreenChange, false);
	                    document.addEventListener("webkitfullscreenchange", fullScreenChange, false);
	                    document.addEventListener("MSFullscreenChange", fullScreenChange, false)
	                }
	                var canvasContainer = document.createElement("div");
	                canvas.parentNode.insertBefore(canvasContainer, canvas);
	                canvasContainer.appendChild(canvas);
	                canvasContainer.requestFullScreen = canvasContainer["requestFullScreen"] || canvasContainer["mozRequestFullScreen"] || canvasContainer["msRequestFullscreen"] || (canvasContainer["webkitRequestFullScreen"] ? (function () {
	                        canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])
	                    }) : null);
	                canvasContainer.requestFullScreen()
	            }),
	            nextRAF: 0,
	            fakeRequestAnimationFrame: (function (func) {
	                var now = Date.now();
	                if (Browser.nextRAF === 0) {
	                    Browser.nextRAF = now + 1e3 / 60
	                } else {
	                    while (now + 2 >= Browser.nextRAF) {
	                        Browser.nextRAF += 1e3 / 60
	                    }
	                }
	                var delay = Math.max(Browser.nextRAF - now, 0);
	                setTimeout(func, delay)
	            }),
	            requestAnimationFrame: function requestAnimationFrame(func) {
	                if (typeof window === "undefined") {
	                    Browser.fakeRequestAnimationFrame(func)
	                } else {
	                    if (!window.requestAnimationFrame) {
	                        window.requestAnimationFrame = window["requestAnimationFrame"] || window["mozRequestAnimationFrame"] || window["webkitRequestAnimationFrame"] || window["msRequestAnimationFrame"] || window["oRequestAnimationFrame"] || Browser.fakeRequestAnimationFrame
	                    }
	                    window.requestAnimationFrame(func)
	                }
	            },
	            safeCallback: (function (func) {
	                return (function () {
	                    if (!ABORT)return func.apply(null, arguments)
	                })
	            }),
	            safeRequestAnimationFrame: (function (func) {
	                return Browser.requestAnimationFrame((function () {
	                    if (!ABORT)func()
	                }))
	            }),
	            safeSetTimeout: (function (func, timeout) {
	                Module["noExitRuntime"] = true;
	                return setTimeout((function () {
	                    if (!ABORT)func()
	                }), timeout)
	            }),
	            safeSetInterval: (function (func, timeout) {
	                Module["noExitRuntime"] = true;
	                return setInterval((function () {
	                    if (!ABORT)func()
	                }), timeout)
	            }),
	            getMimetype: (function (name) {
	                return {
	                    "jpg": "image/jpeg",
	                    "jpeg": "image/jpeg",
	                    "png": "image/png",
	                    "bmp": "image/bmp",
	                    "ogg": "audio/ogg",
	                    "wav": "audio/wav",
	                    "mp3": "audio/mpeg"
	                }[name.substr(name.lastIndexOf(".") + 1)]
	            }),
	            getUserMedia: (function (func) {
	                if (!window.getUserMedia) {
	                    window.getUserMedia = navigator["getUserMedia"] || navigator["mozGetUserMedia"]
	                }
	                window.getUserMedia(func)
	            }),
	            getMovementX: (function (event) {
	                return event["movementX"] || event["mozMovementX"] || event["webkitMovementX"] || 0
	            }),
	            getMovementY: (function (event) {
	                return event["movementY"] || event["mozMovementY"] || event["webkitMovementY"] || 0
	            }),
	            getMouseWheelDelta: (function (event) {
	                var delta = 0;
	                switch (event.type) {
	                    case"DOMMouseScroll":
	                        delta = event.detail;
	                        break;
	                    case"mousewheel":
	                        delta = event.wheelDelta;
	                        break;
	                    case"wheel":
	                        delta = event["deltaY"];
	                        break;
	                    default:
	                        throw"unrecognized mouse wheel event: " + event.type
	                }
	                return delta
	            }),
	            mouseX: 0,
	            mouseY: 0,
	            mouseMovementX: 0,
	            mouseMovementY: 0,
	            touches: {},
	            lastTouches: {},
	            calculateMouseEvent: (function (event) {
	                if (Browser.pointerLock) {
	                    if (event.type != "mousemove" && "mozMovementX" in event) {
	                        Browser.mouseMovementX = Browser.mouseMovementY = 0
	                    } else {
	                        Browser.mouseMovementX = Browser.getMovementX(event);
	                        Browser.mouseMovementY = Browser.getMovementY(event)
	                    }
	                    if (typeof SDL != "undefined") {
	                        Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
	                        Browser.mouseY = SDL.mouseY + Browser.mouseMovementY
	                    } else {
	                        Browser.mouseX += Browser.mouseMovementX;
	                        Browser.mouseY += Browser.mouseMovementY
	                    }
	                } else {
	                    var rect = Module["canvas"].getBoundingClientRect();
	                    var cw = Module["canvas"].width;
	                    var ch = Module["canvas"].height;
	                    var scrollX = typeof window.scrollX !== "undefined" ? window.scrollX : window.pageXOffset;
	                    var scrollY = typeof window.scrollY !== "undefined" ? window.scrollY : window.pageYOffset;
	                    if (event.type === "touchstart" || event.type === "touchend" || event.type === "touchmove") {
	                        var touch = event.touch;
	                        if (touch === undefined) {
	                            return
	                        }
	                        var adjustedX = touch.pageX - (scrollX + rect.left);
	                        var adjustedY = touch.pageY - (scrollY + rect.top);
	                        adjustedX = adjustedX * (cw / rect.width);
	                        adjustedY = adjustedY * (ch / rect.height);
	                        var coords = {x: adjustedX, y: adjustedY};
	                        if (event.type === "touchstart") {
	                            Browser.lastTouches[touch.identifier] = coords;
	                            Browser.touches[touch.identifier] = coords
	                        } else if (event.type === "touchend" || event.type === "touchmove") {
	                            Browser.lastTouches[touch.identifier] = Browser.touches[touch.identifier];
	                            Browser.touches[touch.identifier] = {x: adjustedX, y: adjustedY}
	                        }
	                        return
	                    }
	                    var x = event.pageX - (scrollX + rect.left);
	                    var y = event.pageY - (scrollY + rect.top);
	                    x = x * (cw / rect.width);
	                    y = y * (ch / rect.height);
	                    Browser.mouseMovementX = x - Browser.mouseX;
	                    Browser.mouseMovementY = y - Browser.mouseY;
	                    Browser.mouseX = x;
	                    Browser.mouseY = y
	                }
	            }),
	            xhrLoad: (function (url, onload, onerror) {
	                var xhr = new XMLHttpRequest;
	                xhr.open("GET", url, true);
	                xhr.responseType = "arraybuffer";
	                xhr.onload = function xhr_onload() {
	                    if (xhr.status == 200 || xhr.status == 0 && xhr.response) {
	                        onload(xhr.response)
	                    } else {
	                        onerror()
	                    }
	                };
	                xhr.onerror = onerror;
	                xhr.send(null)
	            }),
	            asyncLoad: (function (url, onload, onerror, noRunDep) {
	                Browser.xhrLoad(url, (function (arrayBuffer) {
	                    assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
	                    onload(new Uint8Array(arrayBuffer));
	                    if (!noRunDep)removeRunDependency("al " + url)
	                }), (function (event) {
	                    if (onerror) {
	                        onerror()
	                    } else {
	                        throw'Loading data file "' + url + '" failed.'
	                    }
	                }));
	                if (!noRunDep)addRunDependency("al " + url)
	            }),
	            resizeListeners: [],
	            updateResizeListeners: (function () {
	                var canvas = Module["canvas"];
	                Browser.resizeListeners.forEach((function (listener) {
	                    listener(canvas.width, canvas.height)
	                }))
	            }),
	            setCanvasSize: (function (width, height, noUpdates) {
	                var canvas = Module["canvas"];
	                Browser.updateCanvasDimensions(canvas, width, height);
	                if (!noUpdates)Browser.updateResizeListeners()
	            }),
	            windowedWidth: 0,
	            windowedHeight: 0,
	            setFullScreenCanvasSize: (function () {
	                if (typeof SDL != "undefined") {
	                    var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
	                    flags = flags | 8388608;
	                    HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags
	                }
	                Browser.updateResizeListeners()
	            }),
	            setWindowedCanvasSize: (function () {
	                if (typeof SDL != "undefined") {
	                    var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
	                    flags = flags & ~8388608;
	                    HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags
	                }
	                Browser.updateResizeListeners()
	            }),
	            updateCanvasDimensions: (function (canvas, wNative, hNative) {
	                if (wNative && hNative) {
	                    canvas.widthNative = wNative;
	                    canvas.heightNative = hNative
	                } else {
	                    wNative = canvas.widthNative;
	                    hNative = canvas.heightNative
	                }
	                var w = wNative;
	                var h = hNative;
	                if (Module["forcedAspectRatio"] && Module["forcedAspectRatio"] > 0) {
	                    if (w / h < Module["forcedAspectRatio"]) {
	                        w = Math.round(h * Module["forcedAspectRatio"])
	                    } else {
	                        h = Math.round(w / Module["forcedAspectRatio"])
	                    }
	                }
	                if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvas.parentNode && typeof screen != "undefined") {
	                    var factor = Math.min(screen.width / w, screen.height / h);
	                    w = Math.round(w * factor);
	                    h = Math.round(h * factor)
	                }
	                if (Browser.resizeCanvas) {
	                    if (canvas.width != w)canvas.width = w;
	                    if (canvas.height != h)canvas.height = h;
	                    if (typeof canvas.style != "undefined") {
	                        canvas.style.removeProperty("width");
	                        canvas.style.removeProperty("height")
	                    }
	                } else {
	                    if (canvas.width != wNative)canvas.width = wNative;
	                    if (canvas.height != hNative)canvas.height = hNative;
	                    if (typeof canvas.style != "undefined") {
	                        if (w != wNative || h != hNative) {
	                            canvas.style.setProperty("width", w + "px", "important");
	                            canvas.style.setProperty("height", h + "px", "important")
	                        } else {
	                            canvas.style.removeProperty("width");
	                            canvas.style.removeProperty("height")
	                        }
	                    }
	                }
	            }),
	            wgetRequests: {},
	            nextWgetRequestHandle: 0,
	            getNextWgetRequestHandle: (function () {
	                var handle = Browser.nextWgetRequestHandle;
	                Browser.nextWgetRequestHandle++;
	                return handle
	            })
	        };

	        function _munmap(start, num) {
	            if (!_mmap.mappings)_mmap.mappings = {};
	            var info = _mmap.mappings[start];
	            if (!info)return 0;
	            if (num == info.num) {
	                _mmap.mappings[start] = null;
	                if (info.allocated) {
	                    _free(info.malloc)
	                }
	            }
	            return 0
	        }

	        function _stat(path, buf, dontResolveLastLink) {
	            path = typeof path !== "string" ? Pointer_stringify(path) : path;
	            try {
	                var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
	                HEAP32[buf >> 2] = stat.dev;
	                HEAP32[buf + 4 >> 2] = 0;
	                HEAP32[buf + 8 >> 2] = stat.ino;
	                HEAP32[buf + 12 >> 2] = stat.mode;
	                HEAP32[buf + 16 >> 2] = stat.nlink;
	                HEAP32[buf + 20 >> 2] = stat.uid;
	                HEAP32[buf + 24 >> 2] = stat.gid;
	                HEAP32[buf + 28 >> 2] = stat.rdev;
	                HEAP32[buf + 32 >> 2] = 0;
	                HEAP32[buf + 36 >> 2] = stat.size;
	                HEAP32[buf + 40 >> 2] = 4096;
	                HEAP32[buf + 44 >> 2] = stat.blocks;
	                HEAP32[buf + 48 >> 2] = stat.atime.getTime() / 1e3 | 0;
	                HEAP32[buf + 52 >> 2] = 0;
	                HEAP32[buf + 56 >> 2] = stat.mtime.getTime() / 1e3 | 0;
	                HEAP32[buf + 60 >> 2] = 0;
	                HEAP32[buf + 64 >> 2] = stat.ctime.getTime() / 1e3 | 0;
	                HEAP32[buf + 68 >> 2] = 0;
	                HEAP32[buf + 72 >> 2] = stat.ino;
	                return 0
	            } catch (e) {
	                if (e.node && PATH.normalize(path) !== PATH.normalize(FS.getPath(e.node))) {
	                    e.setErrno(ERRNO_CODES.ENOTDIR)
	                }
	                FS.handleFSError(e);
	                return -1
	            }
	        }

	        function _sysconf(name) {
	            switch (name) {
	                case 30:
	                    return PAGE_SIZE;
	                case 132:
	                case 133:
	                case 12:
	                case 137:
	                case 138:
	                case 15:
	                case 235:
	                case 16:
	                case 17:
	                case 18:
	                case 19:
	                case 20:
	                case 149:
	                case 13:
	                case 10:
	                case 236:
	                case 153:
	                case 9:
	                case 21:
	                case 22:
	                case 159:
	                case 154:
	                case 14:
	                case 77:
	                case 78:
	                case 139:
	                case 80:
	                case 81:
	                case 79:
	                case 82:
	                case 68:
	                case 67:
	                case 164:
	                case 11:
	                case 29:
	                case 47:
	                case 48:
	                case 95:
	                case 52:
	                case 51:
	                case 46:
	                    return 200809;
	                case 27:
	                case 246:
	                case 127:
	                case 128:
	                case 23:
	                case 24:
	                case 160:
	                case 161:
	                case 181:
	                case 182:
	                case 242:
	                case 183:
	                case 184:
	                case 243:
	                case 244:
	                case 245:
	                case 165:
	                case 178:
	                case 179:
	                case 49:
	                case 50:
	                case 168:
	                case 169:
	                case 175:
	                case 170:
	                case 171:
	                case 172:
	                case 97:
	                case 76:
	                case 32:
	                case 173:
	                case 35:
	                    return -1;
	                case 176:
	                case 177:
	                case 7:
	                case 155:
	                case 8:
	                case 157:
	                case 125:
	                case 126:
	                case 92:
	                case 93:
	                case 129:
	                case 130:
	                case 131:
	                case 94:
	                case 91:
	                    return 1;
	                case 74:
	                case 60:
	                case 69:
	                case 70:
	                case 4:
	                    return 1024;
	                case 31:
	                case 42:
	                case 72:
	                    return 32;
	                case 87:
	                case 26:
	                case 33:
	                    return 2147483647;
	                case 34:
	                case 1:
	                    return 47839;
	                case 38:
	                case 36:
	                    return 99;
	                case 43:
	                case 37:
	                    return 2048;
	                case 0:
	                    return 2097152;
	                case 3:
	                    return 65536;
	                case 28:
	                    return 32768;
	                case 44:
	                    return 32767;
	                case 75:
	                    return 16384;
	                case 39:
	                    return 1e3;
	                case 89:
	                    return 700;
	                case 71:
	                    return 256;
	                case 40:
	                    return 255;
	                case 2:
	                    return 100;
	                case 180:
	                    return 64;
	                case 25:
	                    return 20;
	                case 5:
	                    return 16;
	                case 6:
	                    return 6;
	                case 73:
	                    return 4;
	                case 84:
	                {
	                    if (typeof navigator === "object")return navigator["hardwareConcurrency"] || 1;
	                    return 1
	                }
	            }
	            ___setErrNo(ERRNO_CODES.EINVAL);
	            return -1
	        }

	        Module["_bitshift64Lshr"] = _bitshift64Lshr;
	        var _BDtoILow = true;

	        function _ferror(stream) {
	            stream = FS.getStreamFromPtr(stream);
	            return Number(stream && stream.error)
	        }

	        var _BDtoIHigh = true;

	        function _getcwd(buf, size) {
	            if (size == 0) {
	                ___setErrNo(ERRNO_CODES.EINVAL);
	                return 0
	            }
	            var cwd = FS.cwd();
	            if (size < cwd.length + 1) {
	                ___setErrNo(ERRNO_CODES.ERANGE);
	                return 0
	            } else {
	                writeAsciiToMemory(cwd, buf);
	                return buf
	            }
	        }

	        var _environ = allocate(1, "i32*", ALLOC_STATIC);
	        var ___environ = _environ;

	        function ___buildEnvironment(env) {
	            var MAX_ENV_VALUES = 64;
	            var TOTAL_ENV_SIZE = 1024;
	            var poolPtr;
	            var envPtr;
	            if (!___buildEnvironment.called) {
	                ___buildEnvironment.called = true;
	                ENV["USER"] = "web_user";
	                ENV["PATH"] = "/";
	                ENV["PWD"] = "/";
	                ENV["HOME"] = "/home/web_user";
	                ENV["LANG"] = "C";
	                ENV["_"] = Module["thisProgram"];
	                poolPtr = allocate(TOTAL_ENV_SIZE, "i8", ALLOC_STATIC);
	                envPtr = allocate(MAX_ENV_VALUES * 4, "i8*", ALLOC_STATIC);
	                HEAP32[envPtr >> 2] = poolPtr;
	                HEAP32[_environ >> 2] = envPtr
	            } else {
	                envPtr = HEAP32[_environ >> 2];
	                poolPtr = HEAP32[envPtr >> 2]
	            }
	            var strings = [];
	            var totalSize = 0;
	            for (var key in env) {
	                if (typeof env[key] === "string") {
	                    var line = key + "=" + env[key];
	                    strings.push(line);
	                    totalSize += line.length
	                }
	            }
	            if (totalSize > TOTAL_ENV_SIZE) {
	                throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")
	            }
	            var ptrSize = 4;
	            for (var i = 0; i < strings.length; i++) {
	                var line = strings[i];
	                writeAsciiToMemory(line, poolPtr);
	                HEAP32[envPtr + i * ptrSize >> 2] = poolPtr;
	                poolPtr += line.length + 1
	            }
	            HEAP32[envPtr + strings.length * ptrSize >> 2] = 0
	        }

	        var ENV = {};

	        function _getenv(name) {
	            if (name === 0)return 0;
	            name = Pointer_stringify(name);
	            if (!ENV.hasOwnProperty(name))return 0;
	            if (_getenv.ret)_free(_getenv.ret);
	            _getenv.ret = allocate(intArrayFromString(ENV[name]), "i8", ALLOC_NORMAL);
	            return _getenv.ret
	        }

	        var _labs = Math_abs;

	        function _gettimeofday(ptr) {
	            var now = Date.now();
	            HEAP32[ptr >> 2] = now / 1e3 | 0;
	            HEAP32[ptr + 4 >> 2] = now % 1e3 * 1e3 | 0;
	            return 0
	        }

	        function _vfprintf(s, f, va_arg) {
	            return _fprintf(s, f, HEAP32[va_arg >> 2])
	        }

	        function _emscripten_memcpy_big(dest, src, num) {
	            HEAPU8.set(HEAPU8.subarray(src, src + num), dest);
	            return dest
	        }

	        Module["_memcpy"] = _memcpy;
	        var _llvm_pow_f64 = Math_pow;

	        function _sbrk(bytes) {
	            var self = _sbrk;
	            if (!self.called) {
	                DYNAMICTOP = alignMemoryPage(DYNAMICTOP);
	                self.called = true;
	                assert(Runtime.dynamicAlloc);
	                self.alloc = Runtime.dynamicAlloc;
	                Runtime.dynamicAlloc = (function () {
	                    abort("cannot dynamically allocate, sbrk now has control")
	                })
	            }
	            var ret = DYNAMICTOP;
	            if (bytes != 0)self.alloc(bytes);
	            return ret
	        }

	        Module["_memmove"] = _memmove;
	        function ___errno_location() {
	            return ___errno_state
	        }

	        var _BItoD = true;
	        Module["_strcpy"] = _strcpy;
	        function _time(ptr) {
	            var ret = Date.now() / 1e3 | 0;
	            if (ptr) {
	                HEAP32[ptr >> 2] = ret
	            }
	            return ret
	        }

	        var ctlz_i8 = allocate([8, 7, 6, 6, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], "i8", ALLOC_STATIC);
	        Module["_llvm_ctlz_i32"] = _llvm_ctlz_i32;
	        function _llvm_ctlz_i64(l, h) {
	            var ret = _llvm_ctlz_i32(h);
	            if (ret == 32)ret += _llvm_ctlz_i32(l);
	            return (asm["setTempRet0"](0), ret) | 0
	        }

	        FS.staticInit();
	        __ATINIT__.unshift({
	            func: (function () {
	                if (!Module["noFSInit"] && !FS.init.initialized)FS.init()
	            })
	        });
	        __ATMAIN__.push({
	            func: (function () {
	                FS.ignorePermissions = false
	            })
	        });
	        __ATEXIT__.push({
	            func: (function () {
	                FS.quit()
	            })
	        });
	        Module["FS_createFolder"] = FS.createFolder;
	        Module["FS_createPath"] = FS.createPath;
	        Module["FS_createDataFile"] = FS.createDataFile;
	        Module["FS_createPreloadedFile"] = FS.createPreloadedFile;
	        Module["FS_createLazyFile"] = FS.createLazyFile;
	        Module["FS_createLink"] = FS.createLink;
	        Module["FS_createDevice"] = FS.createDevice;
	        ___errno_state = Runtime.staticAlloc(4);
	        HEAP32[___errno_state >> 2] = 0;
	        __ATINIT__.unshift({
	            func: (function () {
	                TTY.init()
	            })
	        });
	        __ATEXIT__.push({
	            func: (function () {
	                TTY.shutdown()
	            })
	        });
	        TTY.utf8 = new Runtime.UTF8Processor;
	        
	        __ATINIT__.push({
	            func: (function () {
	                SOCKFS.root = FS.mount(SOCKFS, {}, null)
	            })
	        });
	        _fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
	        _fputc.ret = allocate([0], "i8", ALLOC_STATIC);
	        Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) {
	            Browser.requestFullScreen(lockPointer, resizeCanvas)
	        };
	        Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) {
	            Browser.requestAnimationFrame(func)
	        };
	        Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) {
	            Browser.setCanvasSize(width, height, noUpdates)
	        };
	        Module["pauseMainLoop"] = function Module_pauseMainLoop() {
	            Browser.mainLoop.pause()
	        };
	        Module["resumeMainLoop"] = function Module_resumeMainLoop() {
	            Browser.mainLoop.resume()
	        };
	        Module["getUserMedia"] = function Module_getUserMedia() {
	            Browser.getUserMedia()
	        };
	        ___buildEnvironment(ENV);
	        STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
	        staticSealed = true;
	        STACK_MAX = STACK_BASE + TOTAL_STACK;
	        DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
	        assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");
	        var cttz_i8 = allocate([8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0], "i8", ALLOC_DYNAMIC);

	        function invoke_iiiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
	            try {
	                return Module["dynCall_iiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_iiii(index, a1, a2, a3) {
	            try {
	                return Module["dynCall_iiii"](index, a1, a2, a3)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_viiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
	            try {
	                Module["dynCall_viiiiiii"](index, a1, a2, a3, a4, a5, a6, a7)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_viiiii(index, a1, a2, a3, a4, a5) {
	            try {
	                Module["dynCall_viiiii"](index, a1, a2, a3, a4, a5)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_i(index) {
	            try {
	                return Module["dynCall_i"](index)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_vi(index, a1) {
	            try {
	                Module["dynCall_vi"](index, a1)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_vii(index, a1, a2) {
	            try {
	                Module["dynCall_vii"](index, a1, a2)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_iiiiiii(index, a1, a2, a3, a4, a5, a6) {
	            try {
	                return Module["dynCall_iiiiiii"](index, a1, a2, a3, a4, a5, a6)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_ii(index, a1) {
	            try {
	                return Module["dynCall_ii"](index, a1)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_viii(index, a1, a2, a3) {
	            try {
	                Module["dynCall_viii"](index, a1, a2, a3)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_viiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
	            try {
	                Module["dynCall_viiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_iiiii(index, a1, a2, a3, a4) {
	            try {
	                return Module["dynCall_iiiii"](index, a1, a2, a3, a4)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_viiiiii(index, a1, a2, a3, a4, a5, a6) {
	            try {
	                Module["dynCall_viiiiii"](index, a1, a2, a3, a4, a5, a6)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_iii(index, a1, a2) {
	            try {
	                return Module["dynCall_iii"](index, a1, a2)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_iiiiii(index, a1, a2, a3, a4, a5) {
	            try {
	                return Module["dynCall_iiiiii"](index, a1, a2, a3, a4, a5)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        function invoke_viiii(index, a1, a2, a3, a4) {
	            try {
	                Module["dynCall_viiii"](index, a1, a2, a3, a4)
	            } catch (e) {
	                if (typeof e !== "number" && e !== "longjmp")throw e;
	                asm["setThrew"](1, 0)
	            }
	        }

	        Module.asmGlobalArg = {
	            "Math": Math,
	            "Int8Array": Int8Array,
	            "Int16Array": Int16Array,
	            "Int32Array": Int32Array,
	            "Uint8Array": Uint8Array,
	            "Uint16Array": Uint16Array,
	            "Uint32Array": Uint32Array,
	            "Float32Array": Float32Array,
	            "Float64Array": Float64Array
	        };
	        Module.asmLibraryArg = {
	            "abort": abort,
	            "assert": assert,
	            "min": Math_min,
	            "invoke_iiiiiiii": invoke_iiiiiiii,
	            "invoke_iiii": invoke_iiii,
	            "invoke_viiiiiii": invoke_viiiiiii,
	            "invoke_viiiii": invoke_viiiii,
	            "invoke_i": invoke_i,
	            "invoke_vi": invoke_vi,
	            "invoke_vii": invoke_vii,
	            "invoke_iiiiiii": invoke_iiiiiii,
	            "invoke_ii": invoke_ii,
	            "invoke_viii": invoke_viii,
	            "invoke_viiiiiiiii": invoke_viiiiiiiii,
	            "invoke_iiiii": invoke_iiiii,
	            "invoke_viiiiii": invoke_viiiiii,
	            "invoke_iii": invoke_iii,
	            "invoke_iiiiii": invoke_iiiiii,
	            "invoke_viiii": invoke_viiii,
	            "_fabs": _fabs,
	            "_llvm_pow_f64": _llvm_pow_f64,
	            "_send": _send,
	            "_getcwd": _getcwd,
	            "_fread": _fread,
	            "__reallyNegative": __reallyNegative,
	            "_vfprintf": _vfprintf,
	            "_emscripten_set_main_loop_timing": _emscripten_set_main_loop_timing,
	            "___assert_fail": ___assert_fail,
	            "_floor": _floor,
	            "_fflush": _fflush,
	            "_llvm_ctlz_i64": _llvm_ctlz_i64,
	            "_pwrite": _pwrite,
	            "_strerror_r": _strerror_r,
	            "_fprintf": _fprintf,
	            "_open": _open,
	            "_sbrk": _sbrk,
	            "_emscripten_memcpy_big": _emscripten_memcpy_big,
	            "_fileno": _fileno,
	            "__formatString": __formatString,
	            "__exit": __exit,
	            "_close": _close,
	            "_ferror": _ferror,
	            "_munmap": _munmap,
	            "___buildEnvironment": ___buildEnvironment,
	            "_pread": _pread,
	            "_printf": _printf,
	            "_fclose": _fclose,
	            "_write": _write,
	            "_fsync": _fsync,
	            "___errno_location": ___errno_location,
	            "_stat": _stat,
	            "_recv": _recv,
	            "_fgetc": _fgetc,
	            "_getenv": _getenv,
	            "_sysconf": _sysconf,
	            "_read": _read,
	            "_fputc": _fputc,
	            "_emscripten_set_main_loop": _emscripten_set_main_loop,
	            "_abort": _abort,
	            "_fwrite": _fwrite,
	            "_time": _time,
	            "_mkport": _mkport,
	            "_strerror": _strerror,
	            "_gettimeofday": _gettimeofday,
	            "_fgets": _fgets,
	            "_mmap": _mmap,
	            "_fopen": _fopen,
	            "_exit": _exit,
	            "_labs": _labs,
	            "___setErrNo": ___setErrNo,
	            "STACKTOP": STACKTOP,
	            "STACK_MAX": STACK_MAX,
	            "tempDoublePtr": tempDoublePtr,
	            "ABORT": ABORT,
	            "cttz_i8": cttz_i8,
	            "ctlz_i8": ctlz_i8,
	            "NaN": NaN,
	            "Infinity": Infinity,
	            "_stderr": _stderr,
	            "_stdin": _stdin,
	            "_stdout": _stdout
	        };// EMSCRIPTEN_START_ASM
	        var asm = (function (global, env, buffer) {
	            "use asm";
	            var a = new global.Int8Array(buffer);
	            var b = new global.Int16Array(buffer);
	            var c = new global.Int32Array(buffer);
	            var d = new global.Uint8Array(buffer);
	            var e = new global.Uint16Array(buffer);
	            var f = new global.Uint32Array(buffer);
	            var g = new global.Float32Array(buffer);
	            var h = new global.Float64Array(buffer);
	            var i = env.STACKTOP | 0;
	            var j = env.STACK_MAX | 0;
	            var k = env.tempDoublePtr | 0;
	            var l = env.ABORT | 0;
	            var m = env.cttz_i8 | 0;
	            var n = env.ctlz_i8 | 0;
	            var o = env._stderr | 0;
	            var p = env._stdin | 0;
	            var q = env._stdout | 0;
	            var r = 0;
	            var s = 0;
	            var t = 0;
	            var u = 0;
	            var v = +env.NaN, w = +env.Infinity;
	            var x = 0, y = 0, z = 0, A = 0, B = 0.0, C = 0, D = 0, E = 0, F = 0.0;
	            var G = 0;
	            var H = 0;
	            var I = 0;
	            var J = 0;
	            var K = 0;
	            var L = 0;
	            var M = 0;
	            var N = 0;
	            var O = 0;
	            var P = 0;
	            var Q = global.Math.floor;
	            var R = global.Math.abs;
	            var S = global.Math.sqrt;
	            var T = global.Math.pow;
	            var U = global.Math.cos;
	            var V = global.Math.sin;
	            var W = global.Math.tan;
	            var X = global.Math.acos;
	            var Y = global.Math.asin;
	            var Z = global.Math.atan;
	            var _ = global.Math.atan2;
	            var $ = global.Math.exp;
	            var aa = global.Math.log;
	            var ba = global.Math.ceil;
	            var ca = global.Math.imul;
	            var da = env.abort;
	            var ea = env.assert;
	            var fa = env.min;
	            var ga = env.invoke_iiiiiiii;
	            var ha = env.invoke_iiii;
	            var ia = env.invoke_viiiiiii;
	            var ja = env.invoke_viiiii;
	            var ka = env.invoke_i;
	            var la = env.invoke_vi;
	            var ma = env.invoke_vii;
	            var na = env.invoke_iiiiiii;
	            var oa = env.invoke_ii;
	            var pa = env.invoke_viii;
	            var qa = env.invoke_viiiiiiiii;
	            var ra = env.invoke_iiiii;
	            var sa = env.invoke_viiiiii;
	            var ta = env.invoke_iii;
	            var ua = env.invoke_iiiiii;
	            var va = env.invoke_viiii;
	            var wa = env._fabs;
	            var xa = env._llvm_pow_f64;
	            var ya = env._send;
	            var za = env._getcwd;
	            var Aa = env._fread;
	            var Ba = env.__reallyNegative;
	            var Ca = env._vfprintf;
	            var Da = env._emscripten_set_main_loop_timing;
	            var Ea = env.___assert_fail;
	            var Fa = env._floor;
	            var Ga = env._fflush;
	            var Ha = env._llvm_ctlz_i64;
	            var Ia = env._pwrite;
	            var Ja = env._strerror_r;
	            var Ka = env._fprintf;
	            var La = env._open;
	            var Ma = env._sbrk;
	            var Na = env._emscripten_memcpy_big;
	            var Oa = env._fileno;
	            var Pa = env.__formatString;
	            var Qa = env.__exit;
	            var Ra = env._close;
	            var Sa = env._ferror;
	            var Ta = env._munmap;
	            var Ua = env.___buildEnvironment;
	            var Va = env._pread;
	            var Wa = env._printf;
	            var Xa = env._fclose;
	            var Ya = env._write;
	            var Za = env._fsync;
	            var _a = env.___errno_location;
	            var $a = env._stat;
	            var ab = env._recv;
	            var bb = env._fgetc;
	            var cb = env._getenv;
	            var db = env._sysconf;
	            var eb = env._read;
	            var fb = env._fputc;
	            var gb = env._emscripten_set_main_loop;
	            var hb = env._abort;
	            var ib = env._fwrite;
	            var jb = env._time;
	            var kb = env._mkport;
	            var lb = env._strerror;
	            var mb = env._gettimeofday;
	            var nb = env._fgets;
	            var ob = env._mmap;
	            var pb = env._fopen;
	            var qb = env._exit;
	            var rb = env._labs;
	            var sb = env.___setErrNo;
	            var tb = 0.0;
	// EMSCRIPTEN_START_FUNCS
	            function Vo(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[f >> 2] = a;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 2;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 2;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 2;
	                    c[g >> 2] = Po(c[f >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    Fo(c[f >> 2] | 0) | 0;
	                    if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)m = 10; else if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)m = 11; else m = 10;
	                    if ((m | 0) == 10)if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62)m = 11; else me(c[f >> 2] | 0);
	                    a:do if ((m | 0) == 11 ? (zo(c[f >> 2] | 0, 73, 95624, 0, 0), (c[(c[f >> 2] | 0) + 288 >> 2] | 0) != 0) : 0) {
	                        while (1) {
	                            n = c[f >> 2] | 0;
	                            if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))break;
	                            a = (d[c[(c[n + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62;
	                            me(c[f >> 2] | 0);
	                            if (!a)break a
	                        }
	                        me(n)
	                    } while (0);
	                    do if ((c[(c[f >> 2] | 0) + 248 >> 2] | 0) > 0) {
	                        if (((qy(c[g >> 2] | 0, 94240) | 0) == 0 ? (qy(c[g >> 2] | 0, 95648) | 0) == 0 : 0) ? (qy(c[g >> 2] | 0, 95656) | 0) == 0 : 0)break;
	                        n = (c[f >> 2] | 0) + 248 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + -1;
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    } while (0);
	                    c[j >> 2] = (c[(c[f >> 2] | 0) + 188 >> 2] | 0) - 1;
	                    while (1) {
	                        if ((c[j >> 2] | 0) < 0)break;
	                        if (qy(c[g >> 2] | 0, c[(c[(c[f >> 2] | 0) + 196 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[j >> 2] = (c[j >> 2] | 0) + -1
	                    }
	                    n = c[f >> 2] | 0;
	                    m = c[g >> 2] | 0;
	                    if ((c[j >> 2] | 0) < 0) {
	                        zo(n, 76, 95664, m, 0);
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    ip(n, m);
	                    if (((qy(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0) | 0) == 0 ? (c[(c[f >> 2] | 0) + 184 >> 2] | 0) != 0 : 0) ? (qy(c[(c[f >> 2] | 0) + 184 >> 2] | 0, c[g >> 2] | 0) | 0) == 0 : 0)zo(c[f >> 2] | 0, 76, 95696, c[g >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0);
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 184 >> 2];
	                    if ((c[h >> 2] | 0) != 0 ? (qy(c[h >> 2] | 0, c[g >> 2] | 0) | 0) != 0 : 0) {
	                        if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0);
	                        jp(c[f >> 2] | 0) | 0;
	                        Co(c[f >> 2] | 0) | 0;
	                        c[k >> 2] = 1
	                    } else c[k >> 2] = 0;
	                    c[e >> 2] = c[k >> 2];
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                zo(c[f >> 2] | 0, 74, 95584, 0, 0);
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function Wo(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 112 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                j = e + 12 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(65 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) <= 90 : 0))k = 3;
	                do if ((k | 0) == 3) {
	                    if (97 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) <= 122 : 0)break;
	                    if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 95 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 58 : 0) {
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } while (0);
	                a:while (1) {
	                    if ((c[h >> 2] | 0) >= 100)break;
	                    if (!(65 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) <= 90 : 0))k = 11;
	                    do if ((k | 0) == 11) {
	                        k = 0;
	                        if (97 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) <= 122 : 0)break;
	                        if (48 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) <= 57 : 0)break;
	                        if (((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) != 58 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) != 45 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) != 95 : 0)break a
	                    } while (0);
	                    if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) >= 65 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0 | 0) <= 90 : 0)a[j + (c[h >> 2] | 0) >> 0] = (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0) + 32; else a[j + (c[h >> 2] | 0) >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (1 + (c[h >> 2] | 0)) >> 0] | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                c[f >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, j, c[h >> 2] | 0) | 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Xo(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 1024 | 0;
	                f = e + 12 | 0;
	                g = e + 16 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = b;
	                c[h >> 2] = 0;
	                if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                c[j >> 2] = ap(c[f >> 2] | 0, k) | 0;
	                a:while (1) {
	                    if (!(9 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 10 | (c[j >> 2] | 0) == 13 | 32 <= (c[j >> 2] | 0)))break;
	                    do if ((c[j >> 2] | 0) == 60 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        b = c[f >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 288 >> 2] | 0) {
	                            l = c[b + 184 >> 2] | 0;
	                            m = (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 | 0;
	                            if (!(uy(l, m, xy(c[(c[f >> 2] | 0) + 184 >> 2] | 0) | 0) | 0))break a;
	                            zo(c[f >> 2] | 0, 76, 95912, c[(c[f >> 2] | 0) + 184 >> 2] | 0, 0);
	                            break
	                        }
	                        if ((d[(c[(c[b + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) >= 65 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) <= 90 : 0)break a;
	                        if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) >= 97 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) <= 122 : 0)break a
	                    } while (0);
	                    if ((c[k >> 2] | 0) == 1) {
	                        b = c[j >> 2] & 255;
	                        m = c[h >> 2] | 0;
	                        c[h >> 2] = m + 1;
	                        a[g + m >> 0] = b
	                    } else {
	                        b = qe(c[k >> 2] | 0, g + (c[h >> 2] | 0) | 0, c[j >> 2] | 0) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + b
	                    }
	                    if ((c[h >> 2] | 0) >= 1e3) {
	                        b = c[c[f >> 2] >> 2] | 0;
	                        if (!(c[(c[c[f >> 2] >> 2] | 0) + 100 >> 2] | 0)) {
	                            if (c[b + 68 >> 2] | 0)Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0)
	                        } else Db[c[b + 100 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                        c[h >> 2] = 0
	                    }
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    b = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        m = b + 28 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        m = b + 32 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                    m = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + (c[k >> 2] | 0);
	                    m = (c[f >> 2] | 0) + 200 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[j >> 2] = ap(c[f >> 2] | 0, k) | 0
	                }
	                do if (!(9 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 10 | (c[j >> 2] | 0) == 13 | 32 <= (c[j >> 2] | 0))) {
	                    if ((c[j >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 292 >> 2] | 0) != 0 : 0)break;
	                    Ao(c[f >> 2] | 0, 9, 95944, c[j >> 2] | 0);
	                    if ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 < (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0)me(c[f >> 2] | 0)
	                } while (0);
	                if (!(c[h >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 212 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                j = c[c[f >> 2] >> 2] | 0;
	                if (c[(c[c[f >> 2] >> 2] | 0) + 100 >> 2] | 0) {
	                    Db[c[j + 100 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                    i = e;
	                    return
	                }
	                if (!(c[j + 68 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function Yo(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 36 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[f >> 2] = b;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 38) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35) {
	                    c[m >> 2] = 0;
	                    c[k >> 2] = io(c[f >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    b = c[k >> 2] | 0;
	                    do if ((c[k >> 2] | 0) >>> 0 >= 128) {
	                        q = c[k >> 2] | 0;
	                        if (b >>> 0 < 2048) {
	                            r = c[m >> 2] | 0;
	                            c[m >> 2] = r + 1;
	                            a[h + r >> 0] = q >>> 6 & 31 | 192;
	                            c[l >> 2] = 0;
	                            break
	                        }
	                        r = c[k >> 2] | 0;
	                        if (q >>> 0 < 65536) {
	                            q = c[m >> 2] | 0;
	                            c[m >> 2] = q + 1;
	                            a[h + q >> 0] = r >>> 12 & 15 | 224;
	                            c[l >> 2] = 6;
	                            break
	                        } else {
	                            q = c[m >> 2] | 0;
	                            c[m >> 2] = q + 1;
	                            a[h + q >> 0] = r >>> 18 & 7 | 240;
	                            c[l >> 2] = 12;
	                            break
	                        }
	                    } else {
	                        r = c[m >> 2] | 0;
	                        c[m >> 2] = r + 1;
	                        a[h + r >> 0] = b;
	                        c[l >> 2] = -6
	                    } while (0);
	                    while (1) {
	                        if ((c[l >> 2] | 0) < 0)break;
	                        b = ((c[k >> 2] | 0) >>> (c[l >> 2] | 0) & 63 | 128) & 255;
	                        r = c[m >> 2] | 0;
	                        c[m >> 2] = r + 1;
	                        a[h + r >> 0] = b;
	                        c[l >> 2] = (c[l >> 2] | 0) - 6
	                    }
	                    a[h + (c[m >> 2] | 0) >> 0] = 0;
	                    ep(c[f >> 2] | 0) | 0;
	                    if (!(c[c[f >> 2] >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    if (!(c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, h, c[m >> 2] | 0);
	                    i = e;
	                    return
	                }
	                c[g >> 2] = ho(c[f >> 2] | 0, j) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    ep(c[f >> 2] | 0) | 0;
	                    if (!(c[c[f >> 2] >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    if (!(c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, 95904, 1);
	                    i = e;
	                    return
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) >>> 0 > 0 : 0) {
	                    c[p >> 2] = 0;
	                    c[n >> 2] = c[c[g >> 2] >> 2];
	                    g = c[n >> 2] | 0;
	                    do if ((c[n >> 2] | 0) >>> 0 >= 128) {
	                        m = c[n >> 2] | 0;
	                        if (g >>> 0 < 2048) {
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[h + l >> 0] = m >>> 6 & 31 | 192;
	                            c[o >> 2] = 0;
	                            break
	                        }
	                        l = c[n >> 2] | 0;
	                        if (m >>> 0 < 65536) {
	                            m = c[p >> 2] | 0;
	                            c[p >> 2] = m + 1;
	                            a[h + m >> 0] = l >>> 12 & 15 | 224;
	                            c[o >> 2] = 6;
	                            break
	                        } else {
	                            m = c[p >> 2] | 0;
	                            c[p >> 2] = m + 1;
	                            a[h + m >> 0] = l >>> 18 & 7 | 240;
	                            c[o >> 2] = 12;
	                            break
	                        }
	                    } else {
	                        l = c[p >> 2] | 0;
	                        c[p >> 2] = l + 1;
	                        a[h + l >> 0] = g;
	                        c[o >> 2] = -6
	                    } while (0);
	                    while (1) {
	                        if ((c[o >> 2] | 0) < 0)break;
	                        g = ((c[n >> 2] | 0) >>> (c[o >> 2] | 0) & 63 | 128) & 255;
	                        l = c[p >> 2] | 0;
	                        c[p >> 2] = l + 1;
	                        a[h + l >> 0] = g;
	                        c[o >> 2] = (c[o >> 2] | 0) - 6
	                    }
	                    a[h + (c[p >> 2] | 0) >> 0] = 0;
	                    ep(c[f >> 2] | 0) | 0;
	                    if (!(c[c[f >> 2] >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    if (!(c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, h, c[p >> 2] | 0);
	                    i = e;
	                    return
	                }
	                ep(c[f >> 2] | 0) | 0;
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, 95904, 1);
	                p = c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0;
	                h = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                f = c[j >> 2] | 0;
	                o = xy(c[j >> 2] | 0) | 0;
	                Db[p & 511](h, f, o);
	                i = e;
	                return
	            }

	            function Zo(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 1040 | 0;
	                f = e + 16 | 0;
	                g = e + 20 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = b;
	                c[h >> 2] = 0;
	                c[l >> 2] = 0;
	                if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                c[j >> 2] = ap(c[f >> 2] | 0, k) | 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) == 60 ? (c[(c[f >> 2] | 0) + 176 >> 2] | 0) != 60 : 0)break;
	                    if ((c[j >> 2] | 0) != 38) {
	                        if (!(c[j >> 2] | 0))break
	                    } else if (!((c[j >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 176 >> 2] | 0) == 38 : 0))break;
	                    b = c[j >> 2] | 0;
	                    if ((c[j >> 2] | 0) < 256)if (9 <= (b | 0) & (c[j >> 2] | 0) <= 10 | (c[j >> 2] | 0) == 13 | 32 <= (c[j >> 2] | 0))m = 16; else m = 15; else if ((!(256 <= (b | 0) & (c[j >> 2] | 0) <= 55295) ? !(57344 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 1114111) : 0)m = 15; else m = 16;
	                    do if ((m | 0) == 15) {
	                        m = 0;
	                        Ao(c[f >> 2] | 0, 9, 95944, c[j >> 2] | 0)
	                    } else if ((m | 0) == 16) {
	                        m = 0;
	                        if ((c[k >> 2] | 0) == 1) {
	                            b = c[j >> 2] & 255;
	                            n = c[h >> 2] | 0;
	                            c[h >> 2] = n + 1;
	                            a[g + n >> 0] = b;
	                            break
	                        } else {
	                            b = qe(c[k >> 2] | 0, g + (c[h >> 2] | 0) | 0, c[j >> 2] | 0) | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + b;
	                            break
	                        }
	                    } while (0);
	                    if ((c[h >> 2] | 0) >= 1e3) {
	                        do if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                            b = (kp(c[f >> 2] | 0, g, c[h >> 2] | 0) | 0) != 0;
	                            n = c[f >> 2] | 0;
	                            if (!b) {
	                                ep(n) | 0;
	                                if (!(c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0))break;
	                                Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                                break
	                            }
	                            b = c[c[f >> 2] >> 2] | 0;
	                            if (c[n + 208 >> 2] | 0) {
	                                if (!(c[b + 68 >> 2] | 0))break;
	                                Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                                break
	                            } else {
	                                if (!(c[b + 72 >> 2] | 0))break;
	                                Db[c[(c[c[f >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                                break
	                            }
	                        } while (0);
	                        c[h >> 2] = 0
	                    }
	                    b = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        n = b + 28 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        n = b + 32 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                    n = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + (c[k >> 2] | 0);
	                    n = (c[f >> 2] | 0) + 200 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + 1;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    if ((c[l >> 2] | 0) > 100) {
	                        c[l >> 2] = 0;
	                        if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                    }
	                    c[j >> 2] = ap(c[f >> 2] | 0, k) | 0;
	                    if (c[j >> 2] | 0)continue;
	                    if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    c[j >> 2] = ap(c[f >> 2] | 0, k) | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    if (c[j >> 2] | 0) {
	                        i = e;
	                        return
	                    }
	                    c[(c[f >> 2] | 0) + 172 >> 2] = -1;
	                    i = e;
	                    return
	                }
	                a[g + (c[h >> 2] | 0) >> 0] = 0;
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 212 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                j = (kp(c[f >> 2] | 0, g, c[h >> 2] | 0) | 0) != 0;
	                k = c[f >> 2] | 0;
	                if (!j) {
	                    ep(k) | 0;
	                    if (!(c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                    i = e;
	                    return
	                }
	                j = c[c[f >> 2] >> 2] | 0;
	                if (c[k + 208 >> 2] | 0) {
	                    if (!(c[j + 68 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                    i = e;
	                    return
	                } else {
	                    if (!(c[j + 72 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    Db[c[(c[c[f >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, g, c[h >> 2] | 0);
	                    i = e;
	                    return
	                }
	            }

	            function _o(a) {
	                a = a | 0;
	                var b = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 52 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 68 >> 2] | 0) != 0 : 0) {
	                    c[(c[(c[e >> 2] | 0) + 448 >> 2] | 0) + 12 >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                    c[(c[(c[e >> 2] | 0) + 448 >> 2] | 0) + 16 >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[c[(c[e >> 2] | 0) + 448 >> 2] >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                    De(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 448 >> 2] | 0);
	                    jp(c[e >> 2] | 0) | 0
	                }
	                if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                    i = b;
	                    return
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13) {
	                    i = b;
	                    return
	                }
	                if (32 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0)) {
	                    i = b;
	                    return
	                }
	                Do(c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function $o(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = b;
	                c[j + 0 >> 2] = 0;
	                c[j + 4 >> 2] = 0;
	                c[j + 8 >> 2] = 0;
	                c[j + 12 >> 2] = 0;
	                c[j + 16 >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        i = e;
	                        return
	                    }
	                    if (c[(c[f >> 2] | 0) + 68 >> 2] | 0) {
	                        c[j + 4 >> 2] = (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                        c[j + 8 >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2]
	                    }
	                    c[k >> 2] = Bo(c[f >> 2] | 0) | 0;
	                    c[g >> 2] = c[(c[f >> 2] | 0) + 184 >> 2];
	                    if ((c[k >> 2] | 0) == -1 | (c[g >> 2] | 0) == 0) {
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 62) {
	                            i = e;
	                            return
	                        }
	                        me(c[f >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    c[h >> 2] = bo(c[g >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0))zo(c[f >> 2] | 0, 801, 94576, c[g >> 2] | 0, 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) == 47 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0) == 62 : 0) {
	                        k = (c[f >> 2] | 0) + 200 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 2;
	                        k = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 2;
	                        k = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 2;
	                        if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0);
	                        Co(c[f >> 2] | 0) | 0;
	                        i = e;
	                        return
	                    }
	                    k = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 62) {
	                        zo(k, 73, 94592, c[g >> 2] | 0, 0);
	                        if (qy(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0) | 0) {
	                            Re(c[f >> 2] | 0) | 0;
	                            Co(c[f >> 2] | 0) | 0
	                        }
	                        if (c[(c[f >> 2] | 0) + 68 >> 2] | 0)dp(c[f >> 2] | 0, j) | 0;
	                        _o(c[f >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    me(k);
	                    if ((c[h >> 2] | 0) != 0 ? (a[(c[h >> 2] | 0) + 7 >> 0] | 0) != 0 : 0) {
	                        if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0);
	                        Co(c[f >> 2] | 0) | 0;
	                        i = e;
	                        return
	                    }
	                    if (!(c[(c[f >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    dp(c[f >> 2] | 0, j) | 0;
	                    i = e;
	                    return
	                }
	                zo(c[f >> 2] | 0, 1, 97568, 0, 0);
	                i = e;
	                return
	            }

	            function ap(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 208 | 0;
	                g = f;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 194 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 16 | 0;
	                q = f + 44 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                if (c[(c[j >> 2] | 0) + 176 >> 2] | 0) {
	                    c[c[k >> 2] >> 2] = 0;
	                    c[h >> 2] = c[(c[j >> 2] | 0) + 176 >> 2];
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 256 >> 2] | 0) != 1) {
	                    c[c[k >> 2] >> 2] = 1;
	                    e = c[j >> 2] | 0;
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) < 128) {
	                        c[h >> 2] = d[c[(c[e + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                        r = c[h >> 2] | 0;
	                        i = f;
	                        return r | 0
	                    }
	                    c[o >> 2] = lp(e) | 0;
	                    e = c[j >> 2] | 0;
	                    do if (c[o >> 2] | 0) {
	                        if (c[(c[e + 36 >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0);
	                        c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] = c[o >> 2];
	                        c[p >> 2] = Dd(c[o >> 2] | 0) | 0;
	                        b = c[j >> 2] | 0;
	                        if (c[p >> 2] | 0) {
	                            se(b, c[p >> 2] | 0) | 0;
	                            break
	                        } else {
	                            zo(b, 81, 96008, c[o >> 2] | 0, 0);
	                            break
	                        }
	                    } else re(e, 10) | 0; while (0);
	                    c[(c[j >> 2] | 0) + 256 >> 2] = 1;
	                    c[h >> 2] = ne(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                a[m >> 0] = a[c[l >> 2] >> 0] | 0;
	                if (!((d[m >> 0] | 0) & 128)) {
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 < (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0 : 0) {
	                        Ao(c[j >> 2] | 0, 9, 95976, 0);
	                        c[c[k >> 2] >> 2] = 1;
	                        c[h >> 2] = 32;
	                        r = c[h >> 2] | 0;
	                        i = f;
	                        return r | 0
	                    }
	                    c[c[k >> 2] >> 2] = 1;
	                    c[h >> 2] = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                if (!(d[(c[l >> 2] | 0) + 1 >> 0] | 0)) {
	                    ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                }
	                a:do if (((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 192 | 0) == 128) {
	                    do if (((d[m >> 0] | 0) & 224 | 0) == 224) {
	                        if (!(d[(c[l >> 2] | 0) + 2 >> 0] | 0)) {
	                            ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                            c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                        }
	                        if (((d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 192 | 0) != 128)break a;
	                        if (((d[m >> 0] | 0) & 240 | 0) != 240) {
	                            c[c[k >> 2] >> 2] = 3;
	                            c[n >> 2] = ((d[c[l >> 2] >> 0] | 0) & 15) << 12;
	                            c[n >> 2] = c[n >> 2] | ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63) << 6;
	                            c[n >> 2] = c[n >> 2] | (d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 63;
	                            break
	                        }
	                        if (!(d[(c[l >> 2] | 0) + 3 >> 0] | 0)) {
	                            ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                            c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                        }
	                        if (((d[m >> 0] | 0) & 248 | 0) != 240)break a;
	                        if (((d[(c[l >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128)break a;
	                        c[c[k >> 2] >> 2] = 4;
	                        c[n >> 2] = ((d[c[l >> 2] >> 0] | 0) & 7) << 18;
	                        c[n >> 2] = c[n >> 2] | ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63) << 12;
	                        c[n >> 2] = c[n >> 2] | ((d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 63) << 6;
	                        c[n >> 2] = c[n >> 2] | (d[(c[l >> 2] | 0) + 3 >> 0] | 0) & 63
	                    } else {
	                        c[c[k >> 2] >> 2] = 2;
	                        c[n >> 2] = ((d[c[l >> 2] >> 0] | 0) & 31) << 6;
	                        c[n >> 2] = c[n >> 2] | (d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63
	                    } while (0);
	                    e = c[n >> 2] | 0;
	                    if ((c[n >> 2] | 0) >>> 0 < 256) {
	                        if (!(9 <= e >>> 0 & (c[n >> 2] | 0) >>> 0 <= 10 | (c[n >> 2] | 0) == 13 | 32 <= (c[n >> 2] | 0) >>> 0))s = 27
	                    } else if ((!(256 <= e >>> 0 & (c[n >> 2] | 0) >>> 0 <= 55295) ? !(57344 <= (c[n >> 2] | 0) >>> 0 & (c[n >> 2] | 0) >>> 0 <= 65533) : 0) ? !(65536 <= (c[n >> 2] | 0) >>> 0 & (c[n >> 2] | 0) >>> 0 <= 1114111) : 0)s = 27;
	                    if ((s | 0) == 27)Ao(c[j >> 2] | 0, 9, 95976, c[n >> 2] | 0);
	                    c[h >> 2] = c[n >> 2];
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                } while (0);
	                n = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4) {
	                    s = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                    l = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                    m = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                    c[g >> 2] = n;
	                    c[g + 4 >> 2] = s;
	                    c[g + 8 >> 2] = l;
	                    c[g + 12 >> 2] = m;
	                    JT(q, 149, 96032, g) | 0
	                } else {
	                    c[g >> 2] = n;
	                    JT(q, 149, 96072, g) | 0
	                }
	                zo(c[j >> 2] | 0, 81, 96088, q, 0);
	                c[(c[j >> 2] | 0) + 256 >> 2] = 10;
	                c[c[k >> 2] >> 2] = 1;
	                c[h >> 2] = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                r = c[h >> 2] | 0;
	                i = f;
	                return r | 0
	            }

	            function bp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((((((WS(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) | 0) == 83 ? (WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0) | 0) == 89 : 0) ? (WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) == 83 : 0) ? (WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) == 84 : 0) ? (WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) == 69 : 0) ? (WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) == 77 : 0) {
	                    b = (c[f >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)zo(c[f >> 2] | 0, 65, 97056, 0, 0)
	                    } while (0);
	                    Fo(c[f >> 2] | 0) | 0;
	                    c[h >> 2] = mp(c[f >> 2] | 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        j = c[h >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    zo(c[f >> 2] | 0, 70, 97088, 0, 0);
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((WS(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) | 0) != 80) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0) | 0) != 85) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) != 66) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) != 76) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) != 73) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((WS(d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) != 67) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                b = (c[f >> 2] | 0) + 200 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 6;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 6;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 6;
	                do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)zo(c[f >> 2] | 0, 65, 97128, 0, 0)
	                } while (0);
	                Fo(c[f >> 2] | 0) | 0;
	                b = np(c[f >> 2] | 0) | 0;
	                c[c[g >> 2] >> 2] = b;
	                if (!(c[c[g >> 2] >> 2] | 0))zo(c[f >> 2] | 0, 71, 97160, 0, 0);
	                Fo(c[f >> 2] | 0) | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34 ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39 : 0) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                c[h >> 2] = mp(c[f >> 2] | 0) | 0;
	                j = c[h >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function cp(b, e, f, g, h, j) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                k = i;
	                i = i + 48 | 0;
	                l = k + 36 | 0;
	                m = k + 32 | 0;
	                n = k + 43 | 0;
	                o = k + 42 | 0;
	                p = k + 41 | 0;
	                q = k + 28 | 0;
	                r = k + 24 | 0;
	                s = k + 20 | 0;
	                t = k + 16 | 0;
	                u = k + 12 | 0;
	                v = k + 8 | 0;
	                w = k + 4 | 0;
	                x = k;
	                y = k + 40 | 0;
	                c[m >> 2] = b;
	                a[n >> 0] = e;
	                a[o >> 0] = f;
	                a[p >> 0] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = j;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                a[y >> 0] = 0;
	                c[u >> 2] = c[(c[m >> 2] | 0) + 36 >> 2];
	                if (!(c[u >> 2] | 0)) {
	                    c[l >> 2] = -1;
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                }
	                c[s >> 2] = (c[(c[u >> 2] | 0) + 16 >> 2] | 0) - (c[(c[u >> 2] | 0) + 12 >> 2] | 0);
	                if ((c[s >> 2] | 0) < 0) {
	                    c[l >> 2] = -1;
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                }
	                if ((c[(c[m >> 2] | 0) + 204 >> 2] | 0) > (c[s >> 2] | 0))c[s >> 2] = c[(c[m >> 2] | 0) + 204 >> 2];
	                j = c[u >> 2] | 0;
	                if (!(c[c[u >> 2] >> 2] | 0)) {
	                    c[v >> 2] = c[j + 12 >> 2];
	                    c[t >> 2] = c[(c[u >> 2] | 0) + 24 >> 2]
	                } else {
	                    c[v >> 2] = Vy(c[(c[j >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    c[t >> 2] = _y(c[(c[c[u >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0
	                }
	                if (!(a[p >> 0] | 0)) {
	                    if (a[o >> 0] | 0)c[t >> 2] = (c[t >> 2] | 0) + -1
	                } else c[t >> 2] = (c[t >> 2] | 0) - 2;
	                a:while (1) {
	                    A = (c[w >> 2] | 0) != 0;
	                    if ((c[s >> 2] | 0) >= (c[t >> 2] | 0)) {
	                        B = 45;
	                        break
	                    }
	                    if (((((!A ? !((c[q >> 2] | 0) != 0 ? 1 : ((c[s >> 2] | 0) + 4 | 0) >= (c[t >> 2] | 0)) : 0) ? (d[(c[v >> 2] | 0) + (c[s >> 2] | 0) >> 0] | 0) == 60 : 0) ? (d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 1) >> 0] | 0) == 33 : 0) ? (d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 2) >> 0] | 0) == 45 : 0) ? (d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 3) >> 0] | 0) == 45 : 0) {
	                        c[w >> 2] = 1;
	                        c[s >> 2] = (c[s >> 2] | 0) + 2
	                    }
	                    do if (c[r >> 2] | 0) {
	                        if ((d[(c[v >> 2] | 0) + (c[s >> 2] | 0) >> 0] | 0) != 34 ? (d[(c[v >> 2] | 0) + (c[s >> 2] | 0) >> 0] | 0) != 39 : 0)if (c[x >> 2] | 0)break; else {
	                            B = 30;
	                            break
	                        }
	                        j = a[(c[v >> 2] | 0) + (c[s >> 2] | 0) >> 0] | 0;
	                        if (!(c[x >> 2] | 0)) {
	                            a[y >> 0] = j;
	                            c[x >> 2] = 1;
	                            break
	                        }
	                        if ((j & 255 | 0) == (a[y >> 0] | 0))c[x >> 2] = 0; else B = 30
	                    } else B = 30; while (0);
	                    do if ((B | 0) == 30) {
	                        B = 0;
	                        j = c[s >> 2] | 0;
	                        if (c[w >> 2] | 0) {
	                            if ((j + 3 | 0) > (c[t >> 2] | 0)) {
	                                B = 32;
	                                break a
	                            }
	                            if ((d[(c[v >> 2] | 0) + (c[s >> 2] | 0) >> 0] | 0) != 45)break;
	                            if ((d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 1) >> 0] | 0) != 45)break;
	                            if ((d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 2) >> 0] | 0) != 62)break;
	                            c[w >> 2] = 0;
	                            c[s >> 2] = (c[s >> 2] | 0) + 2;
	                            break
	                        }
	                        if ((d[(c[v >> 2] | 0) + j >> 0] | 0) == (d[n >> 0] | 0))if (d[p >> 0] | 0) {
	                            if ((d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 1) >> 0] | 0) != (d[o >> 0] | 0))break;
	                            if ((d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 2) >> 0] | 0) != (d[p >> 0] | 0))break; else {
	                                B = 43;
	                                break a
	                            }
	                        } else {
	                            if (!(d[o >> 0] | 0)) {
	                                B = 43;
	                                break a
	                            }
	                            if ((d[(c[v >> 2] | 0) + ((c[s >> 2] | 0) + 1) >> 0] | 0) != (d[o >> 0] | 0))break; else {
	                                B = 43;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                }
	                if ((B | 0) == 32) {
	                    c[l >> 2] = -1;
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                } else if ((B | 0) == 43) {
	                    c[(c[m >> 2] | 0) + 204 >> 2] = 0;
	                    c[l >> 2] = (c[s >> 2] | 0) - ((c[(c[u >> 2] | 0) + 16 >> 2] | 0) - (c[(c[u >> 2] | 0) + 12 >> 2] | 0));
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                } else if ((B | 0) == 45) {
	                    if (!(A | (c[x >> 2] | 0) != 0))c[(c[m >> 2] | 0) + 204 >> 2] = c[s >> 2];
	                    c[l >> 2] = -1;
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                }
	                return 0
	            }

	            function dp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 452 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 456 >> 2] | 0)) {
	                    if (!(c[(c[f >> 2] | 0) + 456 >> 2] | 0))c[(c[f >> 2] | 0) + 456 >> 2] = 5;
	                    b = (c[f >> 2] | 0) + 456 | 0;
	                    c[b >> 2] = c[b >> 2] << 1;
	                    b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 460 >> 2] | 0, (c[(c[f >> 2] | 0) + 456 >> 2] | 0) * 20 | 0) | 0;
	                    c[(c[f >> 2] | 0) + 460 >> 2] = b;
	                    if (!(c[(c[f >> 2] | 0) + 460 >> 2] | 0)) {
	                        xo(c[f >> 2] | 0, 0);
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                b = (c[(c[f >> 2] | 0) + 460 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 452 >> 2] | 0) * 20 | 0) | 0;
	                a = c[g >> 2] | 0;
	                c[b + 0 >> 2] = c[a + 0 >> 2];
	                c[b + 4 >> 2] = c[a + 4 >> 2];
	                c[b + 8 >> 2] = c[a + 8 >> 2];
	                c[b + 12 >> 2] = c[a + 12 >> 2];
	                c[b + 16 >> 2] = c[a + 16 >> 2];
	                c[(c[f >> 2] | 0) + 448 >> 2] = (c[(c[f >> 2] | 0) + 460 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 452 >> 2] | 0) * 20 | 0);
	                a = (c[f >> 2] | 0) + 452 | 0;
	                f = c[a >> 2] | 0;
	                c[a >> 2] = f + 1;
	                c[e >> 2] = f;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function ep(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[f >> 2] = c[(c[e >> 2] | 0) + 184 >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    Qo(c[e >> 2] | 0, 96176);
	                    Ro(c[e >> 2] | 0, 96176);
	                    Uo(c[e >> 2] | 0, 96176) | 0;
	                    if ((c[c[e >> 2] >> 2] | 0) != 0 ? (c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] | 0) != 0 : 0)Db[c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, 96176, 0);
	                    c[d >> 2] = 1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                if (!(c[23702] | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = 0;
	                while (1) {
	                    if (!(c[96184 + (c[g >> 2] << 2) >> 2] | 0)) {
	                        j = 18;
	                        break
	                    }
	                    if (qy(c[f >> 2] | 0, c[96184 + (c[g >> 2] << 2) >> 2] | 0) | 0)break;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if ((j | 0) == 18) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                Qo(c[e >> 2] | 0, 96176);
	                Ro(c[e >> 2] | 0, 96176);
	                Uo(c[e >> 2] | 0, 96176) | 0;
	                if ((c[c[e >> 2] >> 2] | 0) != 0 ? (c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] | 0) != 0 : 0)Db[c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, 96176, 0);
	                c[d >> 2] = 1;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function fp(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 36 | 0;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 16 | 0;
	                n = f + 12 | 0;
	                o = f + 8 | 0;
	                p = f + 4 | 0;
	                q = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[p >> 2] = 0;
	                c[n >> 2] = c[(c[h >> 2] | 0) + 36 >> 2];
	                if (!(c[n >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                c[l >> 2] = (c[(c[n >> 2] | 0) + 16 >> 2] | 0) - (c[(c[n >> 2] | 0) + 12 >> 2] | 0);
	                if ((c[l >> 2] | 0) < 0) {
	                    c[g >> 2] = -1;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 204 >> 2] | 0) > (c[l >> 2] | 0))c[l >> 2] = c[(c[h >> 2] | 0) + 204 >> 2];
	                e = c[n >> 2] | 0;
	                if (!(c[c[n >> 2] >> 2] | 0)) {
	                    c[o >> 2] = c[e + 12 >> 2];
	                    c[m >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                } else {
	                    c[o >> 2] = Vy(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    c[m >> 2] = _y(c[(c[c[n >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0
	                }
	                a:while (1) {
	                    if ((c[l >> 2] | 0) >= (c[m >> 2] | 0)) {
	                        s = 31;
	                        break
	                    }
	                    if ((((((c[p >> 2] | 0) == 0 ? ((c[l >> 2] | 0) + 4 | 0) < (c[m >> 2] | 0) : 0) ? (d[(c[o >> 2] | 0) + (c[l >> 2] | 0) >> 0] | 0 | 0) == 60 : 0) ? (d[(c[o >> 2] | 0) + ((c[l >> 2] | 0) + 1) >> 0] | 0 | 0) == 33 : 0) ? (d[(c[o >> 2] | 0) + ((c[l >> 2] | 0) + 2) >> 0] | 0 | 0) == 45 : 0) ? (d[(c[o >> 2] | 0) + ((c[l >> 2] | 0) + 3) >> 0] | 0 | 0) == 45 : 0) {
	                        c[p >> 2] = 1;
	                        c[l >> 2] = (c[l >> 2] | 0) + 2
	                    }
	                    b:do if (c[p >> 2] | 0) {
	                        if (((c[l >> 2] | 0) + 3 | 0) > (c[m >> 2] | 0)) {
	                            s = 20;
	                            break a
	                        }
	                        if (((d[(c[o >> 2] | 0) + (c[l >> 2] | 0) >> 0] | 0 | 0) == 45 ? (d[(c[o >> 2] | 0) + ((c[l >> 2] | 0) + 1) >> 0] | 0 | 0) == 45 : 0) ? (d[(c[o >> 2] | 0) + ((c[l >> 2] | 0) + 2) >> 0] | 0 | 0) == 62 : 0) {
	                            c[p >> 2] = 0;
	                            c[l >> 2] = (c[l >> 2] | 0) + 2
	                        }
	                    } else {
	                        c[q >> 2] = 0;
	                        while (1) {
	                            if ((c[q >> 2] | 0) >= (c[k >> 2] | 0))break b;
	                            if ((d[(c[o >> 2] | 0) + (c[l >> 2] | 0) >> 0] | 0 | 0) == (d[(c[j >> 2] | 0) + (c[q >> 2] | 0) >> 0] | 0 | 0)) {
	                                s = 28;
	                                break a
	                            }
	                            c[q >> 2] = (c[q >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                if ((s | 0) == 20) {
	                    c[g >> 2] = -1;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                } else if ((s | 0) == 28) {
	                    c[(c[h >> 2] | 0) + 204 >> 2] = 0;
	                    c[g >> 2] = (c[l >> 2] | 0) - ((c[(c[n >> 2] | 0) + 16 >> 2] | 0) - (c[(c[n >> 2] | 0) + 12 >> 2] | 0));
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                } else if ((s | 0) == 31) {
	                    c[(c[h >> 2] | 0) + 204 >> 2] = c[l >> 2];
	                    c[g >> 2] = -1;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                return 0
	            }

	            function gp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    i = e;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 360 >> 2] & 2097152) {
	                    i = e;
	                    return
	                }
	                if (!((c[g >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0) == 0 : 0)) {
	                    i = e;
	                    return
	                }
	                while (1) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 32 ? (d[c[g >> 2] >> 0] | 0 | 0) != 9 : 0)break;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0);
	                b = my(c[g >> 2] | 0) | 0;
	                c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] = b;
	                c[h >> 2] = wd(c[g >> 2] | 0) | 0;
	                do if ((c[h >> 2] | 0) == -1) {
	                    c[j >> 2] = Dd(c[g >> 2] | 0) | 0;
	                    b = c[f >> 2] | 0;
	                    if (c[j >> 2] | 0) {
	                        se(b, c[j >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 256 >> 2] = 1;
	                        break
	                    } else {
	                        zo(b, 32, 94872, c[g >> 2] | 0, 0);
	                        break
	                    }
	                } else {
	                    if (((c[h >> 2] | 0) == 2 | (c[h >> 2] | 0) == 3 | (c[h >> 2] | 0) == 4 | (c[h >> 2] | 0) == 5 ? (c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)zo(c[f >> 2] | 0, 81, 94832, 0, 0); else re(c[f >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 256 >> 2] = 1
	                } while (0);
	                if (!(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 20 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[l >> 2] = (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                Ty(c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[l >> 2] | 0) | 0;
	                c[k >> 2] = Fd(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0, 1) | 0;
	                if ((c[k >> 2] | 0) < 0)zo(c[f >> 2] | 0, 81, 94912, 0, 0);
	                iz(c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function hp(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                a = c[e >> 2] | 0;
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                    me(a);
	                    c[f >> 2] = op(c[e >> 2] | 0, 34) | 0;
	                    g = c[e >> 2] | 0;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34) {
	                        zo(g, 40, 97944, 0, 0);
	                        break
	                    } else {
	                        me(g);
	                        break
	                    }
	                } else {
	                    g = c[e >> 2] | 0;
	                    if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                        c[f >> 2] = op(g, 0) | 0;
	                        if (c[f >> 2] | 0)break;
	                        zo(c[e >> 2] | 0, 41, 97992, 0, 0);
	                        break
	                    }
	                    me(g);
	                    c[f >> 2] = op(c[e >> 2] | 0, 39) | 0;
	                    g = c[e >> 2] | 0;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                        zo(g, 40, 97968, 0, 0);
	                        break
	                    } else {
	                        me(g);
	                        break
	                    }
	                } while (0);
	                i = b;
	                return c[f >> 2] | 0
	            }

	            function ip(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = b;
	                c[g >> 2] = d;
	                c[k >> 2] = pp(c[g >> 2] | 0) | 0;
	                c[j >> 2] = (c[(c[f >> 2] | 0) + 188 >> 2] | 0) - 1;
	                while (1) {
	                    if ((c[j >> 2] | 0) < 0)break;
	                    if (qy(c[g >> 2] | 0, c[(c[(c[f >> 2] | 0) + 196 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0)break;
	                    d = pp(c[(c[(c[f >> 2] | 0) + 196 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0;
	                    if ((d | 0) > (c[k >> 2] | 0)) {
	                        l = 15;
	                        break
	                    }
	                    c[j >> 2] = (c[j >> 2] | 0) + -1
	                }
	                if ((l | 0) == 15) {
	                    i = e;
	                    return
	                }
	                if ((c[j >> 2] | 0) < 0) {
	                    i = e;
	                    return
	                }
	                while (1) {
	                    if (!((qy(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0) | 0) != 0 ^ 1))break;
	                    c[h >> 2] = bo(c[(c[f >> 2] | 0) + 184 >> 2] | 0) | 0;
	                    if ((c[h >> 2] | 0) != 0 ? (a[(c[h >> 2] | 0) + 5 >> 0] | 0) == 3 : 0)zo(c[f >> 2] | 0, 76, 95696, c[g >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0);
	                    if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0);
	                    Co(c[f >> 2] | 0) | 0
	                }
	                i = e;
	                return
	            }

	            function jp(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 452 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                a = (c[e >> 2] | 0) + 452 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                if ((c[(c[e >> 2] | 0) + 452 >> 2] | 0) < 0) {
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 452 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 448 >> 2] = (c[(c[e >> 2] | 0) + 460 >> 2] | 0) + (((c[a + 452 >> 2] | 0) - 1 | 0) * 20 | 0); else c[a + 448 >> 2] = 0;
	                c[d >> 2] = (c[(c[e >> 2] | 0) + 460 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 452 >> 2] | 0) * 20 | 0);
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function kp(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[m >> 2] = 0;
	                a:while (1) {
	                    if ((c[m >> 2] | 0) >= (c[k >> 2] | 0))break;
	                    do if ((d[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0 | 0) != 13) {
	                            p = 7;
	                            break a
	                        }
	                    } while (0);
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                if ((p | 0) == 7) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (!(d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                    c[g >> 2] = 1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (!(c[(c[h >> 2] | 0) + 184 >> 2] | 0)) {
	                    c[g >> 2] = 1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (qy(c[(c[h >> 2] | 0) + 184 >> 2] | 0, 94240) | 0) {
	                    c[g >> 2] = 1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (qy(c[(c[h >> 2] | 0) + 184 >> 2] | 0, 95656) | 0) {
	                    c[g >> 2] = 1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                do if ((((qy(c[(c[h >> 2] | 0) + 184 >> 2] | 0, 95648) | 0) != 0 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[o >> 2] = Nh(c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0, (c[o >> 2] | 0) != 0) : 0) ? (c[(c[o >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                    if ((ty(c[(c[o >> 2] | 0) + 52 >> 2] | 0, 96272) | 0) != 0 ? (ty(c[(c[o >> 2] | 0) + 52 >> 2] | 0, 96304) | 0) != 0 : 0)break;
	                    c[g >> 2] = 1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } while (0);
	                if (!(c[(c[h >> 2] | 0) + 52 >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[n >> 2] = Bi(c[(c[h >> 2] | 0) + 52 >> 2] | 0) | 0;
	                while (1) {
	                    if (c[n >> 2] | 0)r = (c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 8; else r = 0;
	                    s = c[n >> 2] | 0;
	                    if (!r)break;
	                    c[n >> 2] = c[s + 28 >> 2]
	                }
	                b:do if (!s) {
	                    if ((c[(c[(c[h >> 2] | 0) + 52 >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[(c[h >> 2] | 0) + 52 >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                        c[g >> 2] = 0;
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                    c[l >> 2] = 0;
	                    while (1) {
	                        if ((c[l >> 2] | 0) >>> 0 >= 53)break b;
	                        if (qy(c[(c[h >> 2] | 0) + 184 >> 2] | 0, c[96328 + (c[l >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else {
	                    if (hj(c[n >> 2] | 0) | 0) {
	                        c[g >> 2] = 0;
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                    c[l >> 2] = 0;
	                    while (1) {
	                        if ((c[l >> 2] | 0) >>> 0 >= 53)break b;
	                        if (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[96328 + (c[l >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } while (0);
	                c[g >> 2] = 1;
	                q = c[g >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function lp(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                if (((((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0) == 0 : 0) ? (c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                        c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        c[j >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                        if (d[c[j >> 2] >> 0] | 0) {
	                            c[e >> 2] = 0;
	                            k = c[e >> 2] | 0;
	                            i = b;
	                            return k | 0
	                        }
	                        c[h >> 2] = yy(c[g >> 2] | 0, 96136) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            k = c[e >> 2] | 0;
	                            i = b;
	                            return k | 0
	                        }
	                        c[h >> 2] = yy(c[h >> 2] | 0, 96152) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            k = c[e >> 2] | 0;
	                            i = b;
	                            return k | 0
	                        }
	                        c[h >> 2] = yy(c[h >> 2] | 0, 96160) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            k = c[e >> 2] | 0;
	                            i = b;
	                            return k | 0
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 8;
	                        c[g >> 2] = c[h >> 2];
	                        while (1) {
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)l = 1; else m = 21;
	                            do if ((m | 0) == 21) {
	                                m = 0;
	                                if ((d[c[h >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 122 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                if ((d[c[h >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                if ((d[c[h >> 2] >> 0] | 0 | 0) != 45 ? (d[c[h >> 2] >> 0] | 0 | 0) != 95 : 0) {
	                                    if ((d[c[h >> 2] >> 0] | 0 | 0) == 58) {
	                                        l = 1;
	                                        break
	                                    }
	                                    l = (d[c[h >> 2] >> 0] | 0 | 0) == 47
	                                } else l = 1
	                            } while (0);
	                            n = c[h >> 2] | 0;
	                            if (!l)break;
	                            c[h >> 2] = n + 1
	                        }
	                        if ((n | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            k = c[e >> 2] | 0;
	                            i = b;
	                            return k | 0
	                        } else {
	                            c[e >> 2] = ly(c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                            k = c[e >> 2] | 0;
	                            i = b;
	                            return k | 0
	                        }
	                    }
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = b;
	                return k | 0
	            }

	            function mp(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                a = c[e >> 2] | 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                    me(a);
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    while (1) {
	                        if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)h = 7; else if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)j = 0; else h = 7;
	                        if ((h | 0) == 7) {
	                            h = 0;
	                            j = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34
	                        }
	                        k = c[e >> 2] | 0;
	                        if (!j)break;
	                        me(k)
	                    }
	                    if (!(9 <= (d[c[(c[k + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))h = 12;
	                    if (((h | 0) == 12 ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0) {
	                        zo(c[e >> 2] | 0, 44, 97280, 0, 0);
	                        l = c[g >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    c[g >> 2] = ly(c[f >> 2] | 0, (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                    me(c[e >> 2] | 0);
	                    l = c[g >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                k = c[e >> 2] | 0;
	                if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                    zo(k, 43, 97312, 0, 0);
	                    l = c[g >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                me(k);
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)h = 22; else if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)m = 0; else h = 22;
	                    if ((h | 0) == 22) {
	                        h = 0;
	                        m = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39
	                    }
	                    n = c[e >> 2] | 0;
	                    if (!m)break;
	                    me(n)
	                }
	                if (!(9 <= (d[c[(c[n + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))h = 27;
	                if (((h | 0) == 27 ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0) {
	                    zo(c[e >> 2] | 0, 44, 97280, 0, 0);
	                    l = c[g >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                c[g >> 2] = ly(c[f >> 2] | 0, (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                me(c[e >> 2] | 0);
	                l = c[g >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function np(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = b;
	                c[h >> 2] = 0;
	                b = c[f >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) == 34) {
	                    me(b);
	                    c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    while (1) {
	                        j = c[f >> 2] | 0;
	                        if (!(a[198696 + (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) >> 0] | 0))break;
	                        me(j)
	                    }
	                    if ((d[c[(c[j + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 34) {
	                        zo(c[f >> 2] | 0, 44, 97216, 0, 0);
	                        k = c[h >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } else {
	                        c[h >> 2] = ly(c[g >> 2] | 0, (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                        me(c[f >> 2] | 0);
	                        k = c[h >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                }
	                j = c[f >> 2] | 0;
	                if ((d[c[(c[b + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 39) {
	                    zo(j, 43, 97248, 0, 0);
	                    k = c[h >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                me(j);
	                c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    if (d[198696 + (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) >> 0] | 0)l = (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 39; else l = 0;
	                    m = c[f >> 2] | 0;
	                    if (!l)break;
	                    me(m)
	                }
	                if ((d[c[(c[m + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 39) {
	                    zo(c[f >> 2] | 0, 44, 97216, 0, 0);
	                    k = c[h >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[h >> 2] = ly(c[g >> 2] | 0, (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                    me(c[f >> 2] | 0);
	                    k = c[h >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function op(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0;
	                f = i;
	                i = i + 112 | 0;
	                g = f + 96 | 0;
	                h = f + 92 | 0;
	                j = f + 100 | 0;
	                k = f + 88 | 0;
	                l = f + 84 | 0;
	                m = f + 80 | 0;
	                n = f + 76 | 0;
	                o = f + 72 | 0;
	                p = f + 68 | 0;
	                q = f + 64 | 0;
	                r = f + 60 | 0;
	                s = f + 56 | 0;
	                t = f + 52 | 0;
	                u = f + 48 | 0;
	                v = f + 44 | 0;
	                w = f + 40 | 0;
	                x = f + 36 | 0;
	                y = f + 32 | 0;
	                z = f + 28 | 0;
	                A = f + 24 | 0;
	                B = f + 20 | 0;
	                C = f + 16 | 0;
	                D = f + 12 | 0;
	                E = f + 8 | 0;
	                F = f + 4 | 0;
	                G = f;
	                c[h >> 2] = b;
	                a[j >> 0] = e;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[l >> 2] = 100;
	                c[k >> 2] = Cb[c[135752 >> 2] & 511](c[l >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    xo(c[h >> 2] | 0, 97424);
	                    c[g >> 2] = 0;
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                }
	                c[m >> 2] = c[k >> 2];
	                a:while (1) {
	                    if (!(d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                        I = 68;
	                        break
	                    }
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == (d[j >> 0] | 0 | 0)) {
	                        I = 68;
	                        break
	                    }
	                    if ((d[j >> 0] | 0 | 0) == 0 ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62 : 0) {
	                        I = 68;
	                        break
	                    }
	                    if (!(d[j >> 0] | 0)) {
	                        if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 32) {
	                            I = 68;
	                            break
	                        }
	                        if (9 <= (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            I = 68;
	                            break
	                        }
	                        if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13) {
	                            I = 68;
	                            break
	                        }
	                    }
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 38) {
	                        if (((c[m >> 2] | 0) - (c[k >> 2] | 0) | 0) > ((c[l >> 2] | 0) - 100 | 0)) {
	                            c[F >> 2] = (c[m >> 2] | 0) - (c[k >> 2] | 0);
	                            c[l >> 2] = c[l >> 2] << 1;
	                            c[G >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                            if (!(c[G >> 2] | 0)) {
	                                I = 56;
	                                break
	                            }
	                            c[k >> 2] = c[G >> 2];
	                            c[m >> 2] = (c[k >> 2] | 0) + (c[F >> 2] | 0)
	                        }
	                        c[C >> 2] = ap(c[h >> 2] | 0, E) | 0;
	                        e = c[C >> 2] | 0;
	                        do if ((c[C >> 2] | 0) >>> 0 >= 128) {
	                            b = c[C >> 2] | 0;
	                            if (e >>> 0 < 2048) {
	                                J = c[m >> 2] | 0;
	                                c[m >> 2] = J + 1;
	                                a[J >> 0] = b >>> 6 & 31 | 192;
	                                c[D >> 2] = 0;
	                                break
	                            }
	                            J = c[C >> 2] | 0;
	                            if (b >>> 0 < 65536) {
	                                b = c[m >> 2] | 0;
	                                c[m >> 2] = b + 1;
	                                a[b >> 0] = J >>> 12 & 15 | 224;
	                                c[D >> 2] = 6;
	                                break
	                            } else {
	                                b = c[m >> 2] | 0;
	                                c[m >> 2] = b + 1;
	                                a[b >> 0] = J >>> 18 & 7 | 240;
	                                c[D >> 2] = 12;
	                                break
	                            }
	                        } else {
	                            J = c[m >> 2] | 0;
	                            c[m >> 2] = J + 1;
	                            a[J >> 0] = e;
	                            c[D >> 2] = -6
	                        } while (0);
	                        while (1) {
	                            if ((c[D >> 2] | 0) < 0)break;
	                            e = ((c[C >> 2] | 0) >>> (c[D >> 2] | 0) & 63 | 128) & 255;
	                            J = c[m >> 2] | 0;
	                            c[m >> 2] = J + 1;
	                            a[J >> 0] = e;
	                            c[D >> 2] = (c[D >> 2] | 0) - 6
	                        }
	                        me(c[h >> 2] | 0);
	                        continue
	                    }
	                    e = c[h >> 2] | 0;
	                    if ((d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35) {
	                        c[q >> 2] = io(e) | 0;
	                        J = c[q >> 2] | 0;
	                        do if ((c[q >> 2] | 0) >>> 0 >= 128) {
	                            b = c[q >> 2] | 0;
	                            if (J >>> 0 < 2048) {
	                                K = c[m >> 2] | 0;
	                                c[m >> 2] = K + 1;
	                                a[K >> 0] = b >>> 6 & 31 | 192;
	                                c[r >> 2] = 0;
	                                break
	                            }
	                            K = c[q >> 2] | 0;
	                            if (b >>> 0 < 65536) {
	                                b = c[m >> 2] | 0;
	                                c[m >> 2] = b + 1;
	                                a[b >> 0] = K >>> 12 & 15 | 224;
	                                c[r >> 2] = 6;
	                                break
	                            } else {
	                                b = c[m >> 2] | 0;
	                                c[m >> 2] = b + 1;
	                                a[b >> 0] = K >>> 18 & 7 | 240;
	                                c[r >> 2] = 12;
	                                break
	                            }
	                        } else {
	                            K = c[m >> 2] | 0;
	                            c[m >> 2] = K + 1;
	                            a[K >> 0] = J;
	                            c[r >> 2] = -6
	                        } while (0);
	                        while (1) {
	                            if ((c[r >> 2] | 0) < 0)break;
	                            J = ((c[q >> 2] | 0) >>> (c[r >> 2] | 0) & 63 | 128) & 255;
	                            K = c[m >> 2] | 0;
	                            c[m >> 2] = K + 1;
	                            a[K >> 0] = J;
	                            c[r >> 2] = (c[r >> 2] | 0) - 6
	                        }
	                        if (((c[m >> 2] | 0) - (c[k >> 2] | 0) | 0) <= ((c[l >> 2] | 0) - 100 | 0))continue;
	                        c[s >> 2] = (c[m >> 2] | 0) - (c[k >> 2] | 0);
	                        c[l >> 2] = c[l >> 2] << 1;
	                        c[t >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (!(c[t >> 2] | 0)) {
	                            I = 26;
	                            break
	                        }
	                        c[k >> 2] = c[t >> 2];
	                        c[m >> 2] = (c[k >> 2] | 0) + (c[s >> 2] | 0);
	                        continue
	                    }
	                    c[p >> 2] = ho(e, n) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        J = c[m >> 2] | 0;
	                        c[m >> 2] = J + 1;
	                        a[J >> 0] = 38;
	                        if (((c[m >> 2] | 0) - (c[k >> 2] | 0) | 0) <= ((c[l >> 2] | 0) - 100 | 0))continue;
	                        c[u >> 2] = (c[m >> 2] | 0) - (c[k >> 2] | 0);
	                        c[l >> 2] = c[l >> 2] << 1;
	                        c[v >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (!(c[v >> 2] | 0)) {
	                            I = 31;
	                            break
	                        }
	                        c[k >> 2] = c[v >> 2];
	                        c[m >> 2] = (c[k >> 2] | 0) + (c[u >> 2] | 0);
	                        continue
	                    }
	                    J = c[m >> 2] | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        c[m >> 2] = J + 1;
	                        a[J >> 0] = 38;
	                        c[o >> 2] = c[n >> 2];
	                        while (1) {
	                            if (!(d[c[o >> 2] >> 0] | 0))continue a;
	                            if (((c[m >> 2] | 0) - (c[k >> 2] | 0) | 0) > ((c[l >> 2] | 0) - 100 | 0)) {
	                                c[w >> 2] = (c[m >> 2] | 0) - (c[k >> 2] | 0);
	                                c[l >> 2] = c[l >> 2] << 1;
	                                c[x >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                                if (!(c[x >> 2] | 0)) {
	                                    I = 38;
	                                    break a
	                                }
	                                c[k >> 2] = c[x >> 2];
	                                c[m >> 2] = (c[k >> 2] | 0) + (c[w >> 2] | 0)
	                            }
	                            K = c[o >> 2] | 0;
	                            c[o >> 2] = K + 1;
	                            b = a[K >> 0] | 0;
	                            K = c[m >> 2] | 0;
	                            c[m >> 2] = K + 1;
	                            a[K >> 0] = b
	                        }
	                    }
	                    if ((J - (c[k >> 2] | 0) | 0) > ((c[l >> 2] | 0) - 100 | 0)) {
	                        c[A >> 2] = (c[m >> 2] | 0) - (c[k >> 2] | 0);
	                        c[l >> 2] = c[l >> 2] << 1;
	                        c[B >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (!(c[B >> 2] | 0)) {
	                            I = 43;
	                            break
	                        }
	                        c[k >> 2] = c[B >> 2];
	                        c[m >> 2] = (c[k >> 2] | 0) + (c[A >> 2] | 0)
	                    }
	                    c[y >> 2] = c[c[p >> 2] >> 2];
	                    e = c[y >> 2] | 0;
	                    do if ((c[y >> 2] | 0) >>> 0 >= 128) {
	                        b = c[y >> 2] | 0;
	                        if (e >>> 0 < 2048) {
	                            K = c[m >> 2] | 0;
	                            c[m >> 2] = K + 1;
	                            a[K >> 0] = b >>> 6 & 31 | 192;
	                            c[z >> 2] = 0;
	                            break
	                        }
	                        K = c[y >> 2] | 0;
	                        if (b >>> 0 < 65536) {
	                            b = c[m >> 2] | 0;
	                            c[m >> 2] = b + 1;
	                            a[b >> 0] = K >>> 12 & 15 | 224;
	                            c[z >> 2] = 6;
	                            break
	                        } else {
	                            b = c[m >> 2] | 0;
	                            c[m >> 2] = b + 1;
	                            a[b >> 0] = K >>> 18 & 7 | 240;
	                            c[z >> 2] = 12;
	                            break
	                        }
	                    } else {
	                        K = c[m >> 2] | 0;
	                        c[m >> 2] = K + 1;
	                        a[K >> 0] = e;
	                        c[z >> 2] = -6
	                    } while (0);
	                    while (1) {
	                        if ((c[z >> 2] | 0) < 0)continue a;
	                        e = ((c[y >> 2] | 0) >>> (c[z >> 2] | 0) & 63 | 128) & 255;
	                        J = c[m >> 2] | 0;
	                        c[m >> 2] = J + 1;
	                        a[J >> 0] = e;
	                        c[z >> 2] = (c[z >> 2] | 0) - 6
	                    }
	                }
	                if ((I | 0) == 26) {
	                    xo(c[h >> 2] | 0, 98024);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                } else if ((I | 0) == 31) {
	                    xo(c[h >> 2] | 0, 98024);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                } else if ((I | 0) == 38) {
	                    xo(c[h >> 2] | 0, 98024);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                } else if ((I | 0) == 43) {
	                    xo(c[h >> 2] | 0, 98024);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                } else if ((I | 0) == 56) {
	                    xo(c[h >> 2] | 0, 98024);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                } else if ((I | 0) == 68) {
	                    a[c[m >> 2] >> 0] = 0;
	                    c[g >> 2] = c[k >> 2];
	                    H = c[g >> 2] | 0;
	                    i = f;
	                    return H | 0
	                }
	                return 0
	            }

	            function pp(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                while (1) {
	                    if (c[95744 + (c[e >> 2] << 3) >> 2] | 0)f = (qy(c[95744 + (c[e >> 2] << 3) >> 2] | 0, c[d >> 2] | 0) | 0) != 0 ^ 1; else f = 0;
	                    g = c[e >> 2] | 0;
	                    if (!f)break;
	                    c[e >> 2] = g + 1
	                }
	                i = b;
	                return c[95748 + (g << 3) >> 2] | 0
	            }

	            function qp(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                h = b + 16 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                m = b;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[g >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        o = 11;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 120888) | 0) {
	                            o = 11;
	                            break
	                        }
	                        if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 120896) | 0) {
	                            o = 22;
	                            break
	                        }
	                        if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 120904) | 0)break
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                a:do if ((o | 0) == 11) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0))break;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 120896) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 120904) | 0)break a
	                        }
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    } else o = 22
	                } while (0);
	                if ((o | 0) == 22)c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                b:while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        o = 41;
	                        break
	                    }
	                    c:do if (((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 120904) | 0) != 0 : 0) {
	                        c[k >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                        c[h >> 2] = 0;
	                        c[l >> 2] = 0;
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break c;
	                            if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                                c[m >> 2] = c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2];
	                                if ((ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120912) | 0) == 0 ? (ty(c[m >> 2] | 0, 120928) | 0) == 0 : 0)c[l >> 2] = 1; else o = 35;
	                                if (((o | 0) == 35 ? (o = 0, (c[m >> 2] | 0) != 0) : 0) ? (ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120944) | 0) == 0 : 0)c[h >> 2] = c[m >> 2];
	                                if ((c[l >> 2] | 0) != 0 & (c[h >> 2] | 0) != 0)break b
	                            }
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                    } while (0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                if ((o | 0) == 41) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[j >> 2] = wy(c[h >> 2] | 0, 120952) | 0;
	                if (!(c[j >> 2] | 0))c[j >> 2] = wy(c[h >> 2] | 0, 120968) | 0;
	                if (!(c[j >> 2] | 0))c[j >> 2] = wy(c[h >> 2] | 0, 120984) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[j >> 2] = wy(c[h >> 2] | 0, 121e3) | 0;
	                    if (!(c[j >> 2] | 0))c[j >> 2] = wy(c[h >> 2] | 0, 121016) | 0;
	                    if (!(c[j >> 2] | 0))c[j >> 2] = wy(c[h >> 2] | 0, 121032) | 0;
	                    if (c[j >> 2] | 0)c[j >> 2] = (c[j >> 2] | 0) + 9
	                } else c[j >> 2] = (c[j >> 2] | 0) + 8;
	                d:do if (c[j >> 2] | 0)while (1) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) != 32 ? (d[c[j >> 2] >> 0] | 0 | 0) != 9 : 0)break d;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                } while (0);
	                c[e >> 2] = c[j >> 2];
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function rp(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 144 | 0;
	                f = e;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 24 | 0;
	                m = e + 20 | 0;
	                n = e + 16 | 0;
	                o = e + 44 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                a[o >> 0] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    s = c[g >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                if (!(ty(c[j >> 2] | 0, 120888) | 0)) {
	                    c[g >> 2] = -1;
	                    s = c[g >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                if (c[j >> 2] | 0) {
	                    c[f >> 2] = c[j >> 2];
	                    JT(o, 100, 121048, f) | 0;
	                    a[o + 99 >> 0] = 0
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0)) {
	                        t = 15;
	                        break
	                    }
	                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        if (!(ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120888) | 0)) {
	                            t = 15;
	                            break
	                        }
	                        if (!(ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120896) | 0)) {
	                            t = 27;
	                            break
	                        }
	                        if (!(ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120904) | 0)) {
	                            t = 29;
	                            break
	                        }
	                    }
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                do if ((t | 0) == 15) {
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                            if (!(ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120896) | 0))break;
	                            if (!(ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120904) | 0)) {
	                                t = 23;
	                                break
	                            }
	                        }
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                    }
	                    if ((t | 0) == 23) {
	                        c[m >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                        t = 29;
	                        break
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    } else t = 27
	                } while (0);
	                if ((t | 0) == 27 ? (c[m >> 2] = c[k >> 2], (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) {
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    t = 29
	                }
	                a:do if ((t | 0) == 29) {
	                    while (1) {
	                        t = 0;
	                        if (!(c[k >> 2] | 0))break a;
	                        if (((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (ty(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 120904) | 0) == 0 : 0) {
	                            c[p >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                            c[n >> 2] = 0;
	                            c[q >> 2] = 0;
	                            while (1) {
	                                if (!(c[p >> 2] | 0))break;
	                                if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                                    c[r >> 2] = c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2];
	                                    if ((ty(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 120912) | 0) == 0 ? (ty(c[r >> 2] | 0, 120928) | 0) == 0 : 0)c[q >> 2] = 1; else t = 41;
	                                    if (((t | 0) == 41 ? (t = 0, (c[r >> 2] | 0) != 0) : 0) ? (ty(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 120944) | 0) == 0 : 0)c[n >> 2] = c[r >> 2];
	                                    if ((c[q >> 2] | 0) != 0 & (c[n >> 2] | 0) != 0)break
	                                }
	                                c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                            }
	                            if ((c[q >> 2] | 0) != 0 & (c[n >> 2] | 0) != 0)break
	                        }
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                        t = 29
	                    }
	                    c[l >> 2] = c[k >> 2]
	                } while (0);
	                k = c[j >> 2] | 0;
	                do if (!(c[l >> 2] | 0)) {
	                    if ((k | 0) != 0 & (c[m >> 2] | 0) != 0) {
	                        c[l >> 2] = ji(c[h >> 2] | 0, 0, 120904, 0) | 0;
	                        t = c[m >> 2] | 0;
	                        if (!(c[(c[m >> 2] | 0) + 12 >> 2] | 0))zi(t, c[l >> 2] | 0) | 0; else wi(c[t + 12 >> 2] | 0, c[l >> 2] | 0) | 0;
	                        $h(c[l >> 2] | 0, 120912, 120928) | 0;
	                        $h(c[l >> 2] | 0, 120944, o) | 0
	                    }
	                } else {
	                    if (!k) {
	                        Qh(c[l >> 2] | 0);
	                        Rh(c[l >> 2] | 0);
	                        break
	                    }
	                    if (!(yy(c[n >> 2] | 0, c[j >> 2] | 0) | 0))gj(c[l >> 2] | 0, 120944, o) | 0
	                } while (0);
	                c[g >> 2] = 0;
	                s = c[g >> 2] | 0;
	                i = e;
	                return s | 0
	            }

	            function sp(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                while (1) {
	                    if (!(c[121072 + (c[f >> 2] << 2) >> 2] | 0)) {
	                        g = 6;
	                        break
	                    }
	                    if (!(ty(c[121072 + (c[f >> 2] << 2) >> 2] | 0, c[e >> 2] | 0) | 0)) {
	                        g = 4;
	                        break
	                    }
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                if ((g | 0) == 4) {
	                    c[d >> 2] = 1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((g | 0) == 6) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function tp(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                Rf();
	                if (((c[m >> 2] | 0) != 0 ? (c[r >> 2] = wd(c[m >> 2] | 0) | 0, (c[r >> 2] | 0) != 1) : 0) ? (c[p >> 2] = Dd(c[m >> 2] | 0) | 0, (c[p >> 2] | 0) == 0) : 0)Cp(1403, 0, c[m >> 2] | 0);
	                if (!(c[p >> 2] | 0))c[p >> 2] = Dd(121128) | 0;
	                if (!(c[p >> 2] | 0))c[p >> 2] = Dd(121136) | 0;
	                c[o >> 2] = Fk(c[j >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                } else {
	                    up(c[o >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0);
	                    c[q >> 2] = zk(c[o >> 2] | 0) | 0;
	                    c[h >> 2] = c[q >> 2];
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                return 0
	            }

	            function up(b, e, f, g, h) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 24 | 0;
	                l = j + 20 | 0;
	                m = j + 16 | 0;
	                n = j + 12 | 0;
	                o = j + 8 | 0;
	                p = j + 4 | 0;
	                q = j;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = h;
	                Rf();
	                if ((c[m >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    i = j;
	                    return
	                }
	                if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                    i = j;
	                    return
	                }
	                if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 13 ? (c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) {
	                    if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        Dp(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0);
	                        i = j;
	                        return
	                    }
	                    h = c[m >> 2] | 0;
	                    if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                        if (!(c[h + 40 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if (!((c[(c[m >> 2] | 0) + 8 >> 2] | 0) != 75104 ? (c[(c[m >> 2] | 0) + 8 >> 2] | 0) == 75112 : 0))r = 12;
	                        do if ((r | 0) == 12) {
	                            if (c[(c[m >> 2] | 0) + 20 >> 2] | 0) {
	                                if (!(ty(c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 121144) | 0))break;
	                                if (!(ty(c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 121152) | 0))break
	                            }
	                            c[q >> 2] = cd(c[l >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0)) {
	                                i = j;
	                                return
	                            }
	                            Qk(c[k >> 2] | 0, c[q >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                            i = j;
	                            return
	                        } while (0);
	                        Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        i = j;
	                        return
	                    }
	                    q = c[m >> 2] | 0;
	                    if ((c[h + 4 >> 2] | 0) == 8) {
	                        if (!(c[q + 40 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        Qk(c[k >> 2] | 0, 121160) | 0;
	                        Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        Qk(c[k >> 2] | 0, 121168) | 0;
	                        i = j;
	                        return
	                    }
	                    h = c[m >> 2] | 0;
	                    if ((c[q + 4 >> 2] | 0) == 7) {
	                        if (!(c[h + 8 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        Qk(c[k >> 2] | 0, 121176) | 0;
	                        Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (c[(c[m >> 2] | 0) + 40 >> 2] | 0) {
	                            Qk(c[k >> 2] | 0, 121184) | 0;
	                            Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0
	                        }
	                        Qk(c[k >> 2] | 0, 121192) | 0;
	                        i = j;
	                        return
	                    }
	                    if ((c[h + 4 >> 2] | 0) == 5) {
	                        Qk(c[k >> 2] | 0, 121200) | 0;
	                        Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        Qk(c[k >> 2] | 0, 121208) | 0;
	                        i = j;
	                        return
	                    }
	                    h = c[m >> 2] | 0;
	                    if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 4) {
	                        if (!(c[h + 40 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        i = j;
	                        return
	                    }
	                    if (!(c[h + 36 >> 2] | 0))c[p >> 2] = bo(c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0; else c[p >> 2] = 0;
	                    Qk(c[k >> 2] | 0, 121216) | 0;
	                    if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        Qk(c[k >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        Qk(c[k >> 2] | 0, 121224) | 0
	                    }
	                    Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if (c[(c[m >> 2] | 0) + 48 >> 2] | 0)qR(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 48 >> 2] | 0);
	                    if (c[(c[m >> 2] | 0) + 44 >> 2] | 0)Ep(c[k >> 2] | 0, c[l >> 2] | 0, c[(c[m >> 2] | 0) + 44 >> 2] | 0, c[n >> 2] | 0);
	                    if ((c[p >> 2] | 0) != 0 ? (a[(c[p >> 2] | 0) + 7 >> 0] | 0) != 0 : 0) {
	                        Qk(c[k >> 2] | 0, 121192) | 0;
	                        if (!(c[o >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if (a[(c[p >> 2] | 0) + 10 >> 0] | 0) {
	                            i = j;
	                            return
	                        }
	                        if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if ((c[(c[(c[m >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                            i = j;
	                            return
	                        }
	                        if ((c[(c[(c[m >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                            i = j;
	                            return
	                        }
	                        if (!(c[(c[m >> 2] | 0) + 20 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if (!(c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if ((d[c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] >> 0] | 0) == 112) {
	                            i = j;
	                            return
	                        }
	                        Qk(c[k >> 2] | 0, 121232) | 0;
	                        i = j;
	                        return
	                    }
	                    if (!((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[m >> 2] | 0) + 40 >> 2] | 0) != 0 : 0))r = 54;
	                    if ((r | 0) == 54 ? (c[(c[m >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                        do if (c[p >> 2] | 0) {
	                            if (!(a[(c[p >> 2] | 0) + 6 >> 0] | 0)) {
	                                r = 60;
	                                break
	                            }
	                            if (!(py(c[c[p >> 2] >> 2] | 0, 120888) | 0)) {
	                                r = 60;
	                                break
	                            }
	                            if (!(py(c[c[p >> 2] >> 2] | 0, 121240) | 0)) {
	                                r = 60;
	                                break
	                            }
	                            Qk(c[k >> 2] | 0, 121192) | 0
	                        } else r = 60; while (0);
	                        if ((r | 0) == 60) {
	                            Qk(c[k >> 2] | 0, 121248) | 0;
	                            do if (c[(c[m >> 2] | 0) + 36 >> 2] | 0) {
	                                if (!(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                                Qk(c[k >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                Qk(c[k >> 2] | 0, 121224) | 0
	                            } while (0);
	                            Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            Qk(c[k >> 2] | 0, 121192) | 0
	                        }
	                        if (!(c[o >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if (!((c[p >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)) {
	                            i = j;
	                            return
	                        }
	                        if (a[(c[p >> 2] | 0) + 10 >> 0] | 0) {
	                            i = j;
	                            return
	                        }
	                        if ((c[(c[(c[m >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                            i = j;
	                            return
	                        }
	                        if ((c[(c[(c[m >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                            i = j;
	                            return
	                        }
	                        if (!(c[(c[m >> 2] | 0) + 20 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if (!(c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0)) {
	                            i = j;
	                            return
	                        }
	                        if ((d[c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] >> 0] | 0) == 112) {
	                            i = j;
	                            return
	                        }
	                        Qk(c[k >> 2] | 0, 121232) | 0;
	                        i = j;
	                        return
	                    }
	                    Qk(c[k >> 2] | 0, 121192) | 0;
	                    if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[m >> 2] | 0) + 40 >> 2] | 0) != 0 : 0)Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0;
	                    do if (c[(c[m >> 2] | 0) + 12 >> 2] | 0) {
	                        do if ((c[o >> 2] | 0) != 0 & (c[p >> 2] | 0) != 0) {
	                            if (a[(c[p >> 2] | 0) + 10 >> 0] | 0)break;
	                            if ((c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 3)break;
	                            if ((c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 5)break;
	                            if ((c[(c[m >> 2] | 0) + 12 >> 2] | 0) == (c[(c[m >> 2] | 0) + 16 >> 2] | 0))break;
	                            if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0))break;
	                            if ((d[c[(c[m >> 2] | 0) + 8 >> 2] >> 0] | 0) == 112)break;
	                            Qk(c[k >> 2] | 0, 121232) | 0
	                        } while (0);
	                        Fp(c[k >> 2] | 0, c[l >> 2] | 0, c[(c[m >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0);
	                        if (!((c[o >> 2] | 0) != 0 & (c[p >> 2] | 0) != 0))break;
	                        if (a[(c[p >> 2] | 0) + 10 >> 0] | 0)break;
	                        if ((c[(c[(c[m >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 3)break;
	                        if ((c[(c[(c[m >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 5)break;
	                        if ((c[(c[m >> 2] | 0) + 12 >> 2] | 0) == (c[(c[m >> 2] | 0) + 16 >> 2] | 0))break;
	                        if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0))break;
	                        if ((d[c[(c[m >> 2] | 0) + 8 >> 2] >> 0] | 0) == 112)break;
	                        Qk(c[k >> 2] | 0, 121232) | 0
	                    } while (0);
	                    Qk(c[k >> 2] | 0, 121256) | 0;
	                    do if (c[(c[m >> 2] | 0) + 36 >> 2] | 0) {
	                        if (!(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                        Qk(c[k >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        Qk(c[k >> 2] | 0, 121224) | 0
	                    } while (0);
	                    Qk(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    Qk(c[k >> 2] | 0, 121192) | 0;
	                    if (!((c[o >> 2] | 0) != 0 & (c[p >> 2] | 0) != 0)) {
	                        i = j;
	                        return
	                    }
	                    if (a[(c[p >> 2] | 0) + 10 >> 0] | 0) {
	                        i = j;
	                        return
	                    }
	                    if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0)) {
	                        i = j;
	                        return
	                    }
	                    if ((c[(c[(c[m >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                        i = j;
	                        return
	                    }
	                    if ((c[(c[(c[m >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                        i = j;
	                        return
	                    }
	                    if (!(c[(c[m >> 2] | 0) + 20 >> 2] | 0)) {
	                        i = j;
	                        return
	                    }
	                    if (!(c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0)) {
	                        i = j;
	                        return
	                    }
	                    if ((d[c[(c[(c[m >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] >> 0] | 0) == 112) {
	                        i = j;
	                        return
	                    }
	                    Qk(c[k >> 2] | 0, 121232) | 0;
	                    i = j;
	                    return
	                }
	                xp(c[k >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0);
	                i = j;
	                return
	            }

	            function vp(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                tp(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0, 1) | 0;
	                i = e;
	                return
	            }

	            function wp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                Rf();
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    i = f;
	                    return
	                }
	                c[l >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                c[(c[h >> 2] | 0) + 4 >> 2] = 13;
	                if (c[(c[h >> 2] | 0) + 44 >> 2] | 0)Gp(c[g >> 2] | 0, c[h >> 2] | 0, 0);
	                if (c[(c[h >> 2] | 0) + 12 >> 2] | 0)Fp(c[g >> 2] | 0, c[h >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                Qk(c[g >> 2] | 0, 121232) | 0;
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                i = f;
	                return
	            }

	            function xp(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                wp(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 1);
	                i = e;
	                return
	            }

	            function yp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                up(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, 1);
	                i = f;
	                return
	            }

	            function zp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                Rf();
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[k >> 2] = qp(c[g >> 2] | 0) | 0;
	                do if (c[k >> 2] | 0) {
	                    c[m >> 2] = wd(c[k >> 2] | 0) | 0;
	                    if ((c[m >> 2] | 0) == (c[(c[g >> 2] | 0) + 76 >> 2] | 0)) {
	                        c[j >> 2] = Dd(c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 76 >> 2] | 0) != 1) {
	                        c[e >> 2] = -1;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } else {
	                        c[j >> 2] = Dd(c[k >> 2] | 0) | 0;
	                        if (c[j >> 2] | 0)break;
	                        Cp(1403, 0, c[k >> 2] | 0);
	                        break
	                    }
	                } while (0);
	                if (!(c[j >> 2] | 0))c[j >> 2] = Dd(121128) | 0;
	                if (!(c[j >> 2] | 0))c[j >> 2] = Dd(121136) | 0;
	                c[h >> 2] = Fk(c[f >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else {
	                    xp(c[h >> 2] | 0, c[g >> 2] | 0, 0);
	                    c[l >> 2] = zk(c[h >> 2] | 0) | 0;
	                    c[e >> 2] = c[l >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                return 0
	            }

	            function Ap(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                Rf();
	                c[k >> 2] = qp(c[g >> 2] | 0) | 0;
	                do if ((c[k >> 2] | 0) != 0 ? (c[m >> 2] = wd(c[k >> 2] | 0) | 0, (c[m >> 2] | 0) != (c[(c[g >> 2] | 0) + 76 >> 2] | 0)) : 0)if ((c[(c[g >> 2] | 0) + 76 >> 2] | 0) != 1) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else {
	                    c[j >> 2] = Dd(c[k >> 2] | 0) | 0;
	                    if (c[j >> 2] | 0)break;
	                    Cp(1403, 0, c[k >> 2] | 0);
	                    break
	                } while (0);
	                if (!(c[j >> 2] | 0))c[j >> 2] = Dd(121128) | 0;
	                if (!(c[j >> 2] | 0))c[j >> 2] = Dd(121136) | 0;
	                c[h >> 2] = Ek(c[f >> 2] | 0, c[j >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else {
	                    xp(c[h >> 2] | 0, c[g >> 2] | 0, 0);
	                    c[l >> 2] = zk(c[h >> 2] | 0) | 0;
	                    c[e >> 2] = c[l >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                return 0
	            }

	            function Bp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                Rf();
	                if (c[k >> 2] | 0) {
	                    c[p >> 2] = wd(c[k >> 2] | 0) | 0;
	                    do if ((c[p >> 2] | 0) != (c[(c[j >> 2] | 0) + 76 >> 2] | 0))if ((c[(c[j >> 2] | 0) + 76 >> 2] | 0) != 1) {
	                        c[g >> 2] = -1;
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    } else {
	                        c[n >> 2] = Dd(c[k >> 2] | 0) | 0;
	                        if (c[n >> 2] | 0)break;
	                        Cp(1403, 0, c[k >> 2] | 0);
	                        break
	                    } while (0);
	                    rp(c[j >> 2] | 0, c[k >> 2] | 0) | 0
	                } else rp(c[j >> 2] | 0, 121264) | 0;
	                if (!(c[n >> 2] | 0))c[n >> 2] = Dd(121128) | 0;
	                if (!(c[n >> 2] | 0))c[n >> 2] = Dd(121136) | 0;
	                c[m >> 2] = Ek(c[h >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else {
	                    wp(c[m >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                    c[o >> 2] = zk(c[m >> 2] | 0) | 0;
	                    c[g >> 2] = c[o >> 2];
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                return 0
	            }

	            function Cp(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                d = c[f >> 2] | 0;
	                if ((d | 0) == 1402)c[j >> 2] = 121488; else if ((d | 0) == 1401)c[j >> 2] = 121432; else if ((d | 0) == 1400)c[j >> 2] = 121408; else if ((d | 0) == 1403)c[j >> 2] = 121464; else c[j >> 2] = 121512;
	                ce(7, c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function Dp(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 36 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[h + 20 >> 2] = g;
	                if (!(c[l >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                Qk(c[j >> 2] | 0, 121184) | 0;
	                if ((c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    Qk(c[j >> 2] | 0, c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    Qk(c[j >> 2] | 0, 121224) | 0
	                }
	                Qk(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (!(c[(c[l >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if (sp(c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0) {
	                    i = h;
	                    return
	                }
	                c[m >> 2] = _h(c[k >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0, 0) | 0;
	                k = c[j >> 2] | 0;
	                if (!(c[m >> 2] | 0)) {
	                    Qk(k, 121400) | 0;
	                    i = h;
	                    return
	                }
	                Qk(k, 121328) | 0;
	                do if (((c[(c[l >> 2] | 0) + 36 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[l >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) {
	                    if (((ty(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 121336) | 0) != 0 ? (ty(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 121344) | 0) != 0 : 0) ? (ty(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 121352) | 0) != 0 : 0) {
	                        if (ty(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 121360) | 0) {
	                            s = 31;
	                            break
	                        }
	                        if (ty(c[(c[(c[l >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 121368) | 0) {
	                            s = 31;
	                            break
	                        }
	                    }
	                    c[n >> 2] = c[m >> 2];
	                    fz(c[(c[j >> 2] | 0) + 16 >> 2] | 0, 121376) | 0;
	                    a:while (1) {
	                        do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        c[q >> 2] = 0;
	                        c[r >> 2] = wy(c[n >> 2] | 0, 121160) | 0;
	                        if ((c[r >> 2] | 0) != 0 ? (c[q >> 2] = wy(c[n >> 2] | 0, 121168) | 0, (c[q >> 2] | 0) != 0) : 0)a[c[r >> 2] >> 0] = 0;
	                        c[o >> 2] = Fl(c[n >> 2] | 0, 121384) | 0;
	                        k = c[(c[j >> 2] | 0) + 16 >> 2] | 0;
	                        if (c[o >> 2] | 0) {
	                            ez(k, c[o >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[o >> 2] | 0)
	                        } else ez(k, c[n >> 2] | 0) | 0;
	                        if (!(c[q >> 2] | 0))break;
	                        a[c[r >> 2] >> 0] = 60;
	                        c[q >> 2] = (c[q >> 2] | 0) + 3;
	                        a[p >> 0] = a[c[q >> 2] >> 0] | 0;
	                        a[c[q >> 2] >> 0] = 0;
	                        ez(c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[r >> 2] | 0) | 0;
	                        a[c[q >> 2] >> 0] = a[p >> 0] | 0;
	                        c[n >> 2] = c[q >> 2]
	                    }
	                    fz(c[(c[j >> 2] | 0) + 16 >> 2] | 0, 121376) | 0
	                } else s = 31; while (0);
	                if ((s | 0) == 31)gz(c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[m >> 2] | 0) | 0;
	                zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                i = h;
	                return
	            }

	            function Ep(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!((c[j >> 2] | 0) != 0 & (c[j >> 2] | 0) != 0)) {
	                    i = f;
	                    return
	                }
	                do {
	                    Dp(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2]
	                } while ((c[j >> 2] | 0) != 0);
	                i = f;
	                return
	            }

	            function Fp(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (!((c[k >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0)) {
	                    i = g;
	                    return
	                }
	                do {
	                    up(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                } while ((c[k >> 2] | 0) != 0);
	                i = g;
	                return
	            }

	            function Gp(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[e + 4 >> 2] = d;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    Cp(1402, c[g >> 2] | 0, 0);
	                    i = e;
	                    return
	                }
	                Qk(c[f >> 2] | 0, 121272) | 0;
	                Qk(c[f >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (c[(c[h >> 2] | 0) + 52 >> 2] | 0) {
	                    Qk(c[f >> 2] | 0, 121288) | 0;
	                    gz(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    if (c[(c[h >> 2] | 0) + 56 >> 2] | 0) {
	                        Qk(c[f >> 2] | 0, 121184) | 0;
	                        gz(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 56 >> 2] | 0) | 0
	                    }
	                } else if (c[(c[h >> 2] | 0) + 56 >> 2] | 0) {
	                    Qk(c[f >> 2] | 0, 121304) | 0;
	                    gz(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 56 >> 2] | 0) | 0
	                }
	                Qk(c[f >> 2] | 0, 121320) | 0;
	                i = e;
	                return
	            }

	            function Hp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[g >> 2] | 0))c[g >> 2] = c[q >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    Ka(c[g >> 2] | 0, 121688, f | 0) | 0;
	                    i = e;
	                    return
	                }
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= 40)break;
	                    if (!(d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0)) {
	                        k = 18;
	                        break
	                    }
	                    do if ((d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0) {
	                            k = 12;
	                            break
	                        }
	                        if ((d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) != 13)if ((d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) >= 128) {
	                            b = c[g >> 2] | 0;
	                            c[f >> 2] = d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0];
	                            Ka(b | 0, 121696, f | 0) | 0;
	                            break
	                        } else {
	                            fb(d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0, c[g >> 2] | 0) | 0;
	                            break
	                        } else k = 12
	                    } else k = 12; while (0);
	                    if ((k | 0) == 12) {
	                        k = 0;
	                        fb(32, c[g >> 2] | 0) | 0
	                    }
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((k | 0) == 18) {
	                    i = e;
	                    return
	                }
	                Ka(c[g >> 2] | 0, 121704, f | 0) | 0;
	                i = e;
	                return
	            }

	            function Ip(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 160 | 0;
	                f = e + 148 | 0;
	                g = e + 144 | 0;
	                h = e + 140 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                _p(j);
	                c[j >> 2] = c[f >> 2];
	                c[j + 108 >> 2] = c[h >> 2];
	                $p(j, c[g >> 2] | 0);
	                aq(j);
	                i = e;
	                return
	            }

	            function Jp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 160 | 0;
	                e = d + 144 | 0;
	                f = d + 140 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                _p(g);
	                c[g >> 2] = c[e >> 2];
	                bq(g, c[f >> 2] | 0);
	                aq(g);
	                i = d;
	                return
	            }

	            function Kp(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 160 | 0;
	                f = e + 148 | 0;
	                g = e + 144 | 0;
	                h = e + 140 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                _p(j);
	                c[j >> 2] = c[f >> 2];
	                c[j + 108 >> 2] = c[h >> 2];
	                dq(j, c[g >> 2] | 0);
	                aq(j);
	                i = e;
	                return
	            }

	            function Lp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 160 | 0;
	                e = d + 144 | 0;
	                f = d + 140 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0))c[e >> 2] = c[q >> 2];
	                _p(g);
	                b = g + 136 | 0;
	                c[b >> 2] = c[b >> 2] | 1;
	                c[g >> 2] = c[e >> 2];
	                gq(g, c[f >> 2] | 0);
	                aq(g);
	                i = d;
	                return
	            }

	            function Mp(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 160 | 0;
	                e = d + 144 | 0;
	                f = d + 140 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0))c[e >> 2] = c[q >> 2];
	                _p(g);
	                b = g + 136 | 0;
	                c[b >> 2] = c[b >> 2] | 1;
	                c[g >> 2] = c[e >> 2];
	                hq(g, c[f >> 2] | 0);
	                aq(g);
	                i = d;
	                return
	            }

	            function Np(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                switch (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    case 21:
	                    case 13:
	                    case 9:
	                    {
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 20:
	                    case 19:
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    case 12:
	                    case 11:
	                    case 6:
	                    case 10:
	                    case 5:
	                    {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 2:
	                    {
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 8:
	                    case 7:
	                    case 4:
	                    case 3:
	                    {
	                        if (c[(c[e >> 2] | 0) + 40 >> 2] | 0)c[f >> 2] = xy(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                c[d >> 2] = c[f >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Op(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[g >> 2] | 0)) {
	                    Ka(c[f >> 2] | 0, 121712, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                do switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                    case 4:
	                    {
	                        Ka(c[f >> 2] | 0, 121744, e | 0) | 0;
	                        break
	                    }
	                    case 8:
	                    {
	                        Ka(c[f >> 2] | 0, 121776, e | 0) | 0;
	                        break
	                    }
	                    case 12:
	                    {
	                        Ka(c[f >> 2] | 0, 121816, e | 0) | 0;
	                        break
	                    }
	                    case 10:
	                    {
	                        Ka(c[f >> 2] | 0, 121800, e | 0) | 0;
	                        break
	                    }
	                    case 3:
	                    {
	                        Ka(c[f >> 2] | 0, 121736, e | 0) | 0;
	                        break
	                    }
	                    case 13:
	                    {
	                        Ka(c[f >> 2] | 0, 121792, e | 0) | 0;
	                        break
	                    }
	                    case 11:
	                    {
	                        Ka(c[f >> 2] | 0, 121808, e | 0) | 0;
	                        break
	                    }
	                    case 18:
	                    {
	                        Ka(c[f >> 2] | 0, 121824, e | 0) | 0;
	                        break
	                    }
	                    case 6:
	                    {
	                        Ka(c[f >> 2] | 0, 121760, e | 0) | 0;
	                        break
	                    }
	                    case 2:
	                    {
	                        Ka(c[f >> 2] | 0, 121728, e | 0) | 0;
	                        break
	                    }
	                    case 7:
	                    {
	                        Ka(c[f >> 2] | 0, 121768, e | 0) | 0;
	                        break
	                    }
	                    case 1:
	                    {
	                        Ka(c[f >> 2] | 0, 121720, e | 0) | 0;
	                        break
	                    }
	                    case 5:
	                    {
	                        Ka(c[f >> 2] | 0, 121752, e | 0) | 0;
	                        break
	                    }
	                    case 9:
	                    {
	                        Ka(c[f >> 2] | 0, 121784, e | 0) | 0;
	                        break
	                    }
	                    default:
	                        Ka(c[f >> 2] | 0, 121832, e | 0) | 0
	                } while (0);
	                do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                    b = c[f >> 2] | 0;
	                    if (c[(c[g >> 2] | 0) + 44 >> 2] | 0)Ka(b | 0, 121728, e | 0) | 0; else Ka(b | 0, 121720, e | 0) | 0;
	                    b = c[f >> 2] | 0;
	                    if (c[(c[g >> 2] | 0) + 48 >> 2] | 0) {
	                        Ka(b | 0, 121824, e | 0) | 0;
	                        break
	                    } else {
	                        Ka(b | 0, 121720, e | 0) | 0;
	                        break
	                    }
	                } while (0);
	                b = c[f >> 2] | 0;
	                c[e >> 2] = Np(c[g >> 2] | 0) | 0;
	                Ka(b | 0, 121840, e | 0) | 0;
	                a:do switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                    case 1:
	                    {
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                b = c[f >> 2] | 0;
	                                c[e >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                                Ka(b | 0, 121848, e | 0) | 0
	                            }
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 121856, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 6:
	                    {
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 121856, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 121856, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 5:
	                    {
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 121856, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 12:
	                    case 11:
	                    case 10:
	                    case 13:
	                    case 9:
	                    case 8:
	                    case 4:
	                        break;
	                    case 3:
	                    {
	                        if (c[(c[g >> 2] | 0) + 40 >> 2] | 0)Hp(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        break
	                    }
	                    case 7:
	                    {
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 121856, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        c[h >> 2] = c[g >> 2];
	                        b = c[f >> 2] | 0;
	                        a = c[h >> 2] | 0;
	                        if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                            c[e >> 2] = c[a + 8 >> 2];
	                            Ka(b | 0, 121864, e | 0) | 0;
	                            break a
	                        } else {
	                            j = c[(c[h >> 2] | 0) + 8 >> 2] | 0;
	                            c[e >> 2] = c[a + 12 >> 2];
	                            c[e + 4 >> 2] = j;
	                            Ka(b | 0, 121880, e | 0) | 0;
	                            break a
	                        }
	                        break
	                    }
	                    default:
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 121856, e | 0) | 0
	                        }
	                } while (0);
	                Ka(c[f >> 2] | 0, 121896, e | 0) | 0;
	                i = d;
	                return
	            }

	            function Pp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 12 | 0;
	                k = f + 4 | 0;
	                c[h >> 2] = a;
	                c[f + 16 >> 2] = b;
	                c[j >> 2] = d;
	                c[f + 8 >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    l = c[g >> 2] | 0;
	                    i = f;
	                    return l | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    Ka(c[(c[h >> 2] | 0) + 20 >> 2] | 0, 121712, f | 0) | 0;
	                    c[g >> 2] = 0;
	                    l = c[g >> 2] | 0;
	                    i = f;
	                    return l | 0
	                }
	                do if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        Op(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0);
	                        c[g >> 2] = 0;
	                        l = c[g >> 2] | 0;
	                        i = f;
	                        return l | 0
	                    }
	                    if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                        c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    Op(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0);
	                    c[g >> 2] = 0;
	                    l = c[g >> 2] | 0;
	                    i = f;
	                    return l | 0
	                } else m = 7; while (0);
	                if ((m | 0) == 7)c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    Op(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] | 0);
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                c[g >> 2] = 0;
	                l = c[g >> 2] | 0;
	                i = f;
	                return l | 0
	            }

	            function Qp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 12 | 0;
	                l = f + 4 | 0;
	                c[j >> 2] = a;
	                c[f + 16 >> 2] = b;
	                c[k >> 2] = d;
	                c[f + 8 >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    m = c[h >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 121712, g | 0) | 0;
	                    c[h >> 2] = 0;
	                    m = c[h >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[l >> 2] = Xi(c[(c[k >> 2] | 0) + 32 >> 2] | 0, c[k >> 2] | 0) | 0;
	                k = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                if (!(c[l >> 2] | 0))Ka(k | 0, 122072, g | 0) | 0; else {
	                    c[g >> 2] = c[l >> 2];
	                    Ka(k | 0, 122096, g | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                }
	                c[h >> 2] = 0;
	                m = c[h >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function Rp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 8 | 0;
	                c[h >> 2] = a;
	                c[f + 12 >> 2] = b;
	                c[j >> 2] = d;
	                c[f + 4 >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    k = c[g >> 2] | 0;
	                    i = f;
	                    return k | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    Ka(c[(c[h >> 2] | 0) + 20 >> 2] | 0, 121712, f | 0) | 0;
	                    c[g >> 2] = 0;
	                    k = c[g >> 2] | 0;
	                    i = f;
	                    return k | 0
	                }
	                do if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    e = c[(c[h >> 2] | 0) + 20 >> 2] | 0;
	                    d = c[j >> 2] | 0;
	                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        Ip(e, d, 0);
	                        break
	                    } else {
	                        Kp(e, d, 0);
	                        break
	                    }
	                } else l = 7; while (0);
	                if ((l | 0) == 7)Lp(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0);
	                c[g >> 2] = 0;
	                k = c[g >> 2] | 0;
	                i = f;
	                return k | 0
	            }

	            function Sp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 8 | 0;
	                c[j >> 2] = a;
	                c[f + 12 >> 2] = b;
	                c[k >> 2] = d;
	                c[f + 4 >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    l = c[h >> 2] | 0;
	                    i = f;
	                    return l | 0
	                }
	                e = c[j >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ka(c[e + 20 >> 2] | 0, 121712, g | 0) | 0;
	                    c[h >> 2] = 0;
	                    l = c[h >> 2] | 0;
	                    i = f;
	                    return l | 0
	                }
	                d = c[(c[k >> 2] | 0) + 4 >> 2] | 0;
	                do if ((c[(c[e + 4 >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                    b = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                    if ((d | 0) == 13) {
	                        zp(b, c[k >> 2] | 0) | 0;
	                        break
	                    } else {
	                        vp(b, c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0);
	                        break
	                    }
	                } else {
	                    b = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                    if ((d | 0) == 9) {
	                        FR(b, c[k >> 2] | 0) | 0;
	                        break
	                    } else {
	                        zR(b, c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0);
	                        break
	                    }
	                } while (0);
	                Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 121896, g | 0) | 0;
	                c[h >> 2] = 0;
	                l = c[h >> 2] | 0;
	                i = f;
	                return l | 0
	            }

	            function Tp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[f + 12 >> 2] = d;
	                c[f + 8 >> 2] = e;
	                c[l >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (c[(c[h >> 2] | 0) + 4 >> 2] | 0)c[l >> 2] = (c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) == 13 & 1;
	                e = c[j >> 2] | 0;
	                if (c[l >> 2] | 0)c[k >> 2] = so(e, 0) | 0; else c[k >> 2] = gg(e, 0, 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 1)Th(c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                c[(c[h >> 2] | 0) + 16 >> 2] = 1;
	                Nr(c[(c[h >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[c[h >> 2] >> 2] | 0);
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                c[(c[h >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                e = Lr(c[k >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 12 >> 2] = e;
	                e = Jl(c[j >> 2] | 0) | 0;
	                c[c[h >> 2] >> 2] = e;
	                c[g >> 2] = 0;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function Up(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 4 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[g + 8 >> 2] = f;
	                if (!(c[m >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    o = c[j >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                if ((c[l >> 2] | 0) != 0 ? (a[c[l >> 2] >> 0] | 0) != 0 : 0) {
	                    f = c[(c[m >> 2] | 0) + 4 >> 2] | 0;
	                    do if ((f | 0) == 9) {
	                        if ((JR(c[l >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0) | 0) < -1) {
	                            e = c[33976] | 0;
	                            d = c[33980] | 0;
	                            c[h >> 2] = c[l >> 2];
	                            Db[e & 511](d, 122104, h);
	                            c[j >> 2] = -1;
	                            o = c[j >> 2] | 0;
	                            i = g;
	                            return o | 0
	                        }
	                    } else if ((f | 0) == 13) {
	                        if ((Ap(c[l >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0) | 0) < 0) {
	                            d = c[33976] | 0;
	                            e = c[33980] | 0;
	                            c[h >> 2] = c[l >> 2];
	                            Db[d & 511](e, 122104, h);
	                            c[j >> 2] = -1;
	                            o = c[j >> 2] | 0;
	                            i = g;
	                            return o | 0
	                        }
	                    } else {
	                        c[n >> 2] = pb(c[l >> 2] | 0, 122128) | 0;
	                        if (c[n >> 2] | 0) {
	                            zR(c[n >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0);
	                            Xa(c[n >> 2] | 0) | 0;
	                            break
	                        }
	                        e = c[33976] | 0;
	                        d = c[33980] | 0;
	                        c[h >> 2] = c[l >> 2];
	                        Db[e & 511](d, 122104, h);
	                        c[j >> 2] = -1;
	                        o = c[j >> 2] | 0;
	                        i = g;
	                        return o | 0
	                    } while (0);
	                    c[j >> 2] = 0;
	                    o = c[j >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                c[j >> 2] = -1;
	                o = c[j >> 2] | 0;
	                i = g;
	                return o | 0
	            }

	            function Vp(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[g + 8 >> 2] = e;
	                c[g + 4 >> 2] = f;
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    if (!((c[l >> 2] | 0) != 0 ? (a[c[l >> 2] >> 0] | 0) != 0 : 0))c[l >> 2] = c[c[k >> 2] >> 2];
	                    if (!(c[l >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        m = c[j >> 2] | 0;
	                        i = g;
	                        return m | 0
	                    }
	                    f = c[(c[(c[k >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0;
	                    if ((f | 0) == 9) {
	                        if ((JR(c[l >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0) | 0) < 0) {
	                            e = c[33976] | 0;
	                            d = c[33980] | 0;
	                            c[h >> 2] = c[l >> 2];
	                            Db[e & 511](d, 122136, h)
	                        }
	                    } else if ((f | 0) == 13) {
	                        if ((Ap(c[l >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0) | 0) < 0) {
	                            k = c[33976] | 0;
	                            f = c[33980] | 0;
	                            c[h >> 2] = c[l >> 2];
	                            Db[k & 511](f, 122136, h)
	                        }
	                    } else {
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 122160, h);
	                        c[j >> 2] = -1;
	                        m = c[j >> 2] | 0;
	                        i = g;
	                        return m | 0
	                    }
	                    c[j >> 2] = 0;
	                    m = c[j >> 2] | 0;
	                    i = g;
	                    return m | 0
	                }
	                c[j >> 2] = -1;
	                m = c[j >> 2] | 0;
	                i = g;
	                return m | 0
	            }

	            function Wp(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0;
	                g = i;
	                i = i + 96 | 0;
	                h = g + 88 | 0;
	                j = g + 84 | 0;
	                k = g + 80 | 0;
	                l = g + 8 | 0;
	                m = g + 4 | 0;
	                n = g;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[g + 76 >> 2] = e;
	                c[g + 72 >> 2] = f;
	                c[m >> 2] = -1;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    c[l >> 2] = c[o >> 2];
	                    c[l + 4 >> 2] = 203;
	                    c[l + 8 >> 2] = 203;
	                    if ((c[k >> 2] | 0) != 0 ? (a[c[k >> 2] >> 0] | 0) != 0 : 0) {
	                        c[n >> 2] = Wf(0, c[k >> 2] | 0) | 0;
	                        if (c[n >> 2] | 0) {
	                            c[m >> 2] = dn(l, c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[n >> 2] | 0) | 0;
	                            Ph(c[n >> 2] | 0)
	                        }
	                    } else c[m >> 2] = fn(l, c[(c[j >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[h >> 2] = c[m >> 2];
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[h >> 2] = -1;
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function Xp(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 20 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                c[j >> 2] = a;
	                c[f + 24 >> 2] = b;
	                c[k >> 2] = d;
	                c[f + 16 >> 2] = e;
	                c[m >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    o = c[h >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    o = c[h >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[l >> 2] = c[k >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                        if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            c[n >> 2] = 0;
	                            while (1) {
	                                if ((c[n >> 2] | 0) >= (c[m >> 2] | 0))break;
	                                Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 122232, g | 0) | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + 1
	                            }
	                            if ((c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                e = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                                c[g >> 2] = c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                                Ka(e | 0, 121848, g | 0) | 0
	                            }
	                            e = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                            c[g >> 2] = c[(c[l >> 2] | 0) + 8 >> 2];
	                            Ka(e | 0, 122096, g | 0) | 0
	                        }
	                    } else Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 122224, g | 0) | 0;
	                    if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                        if ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                            c[m >> 2] = (c[m >> 2] | 0) + 1;
	                            continue
	                        }
	                        if ((c[l >> 2] | 0) != (c[k >> 2] | 0) ? (c[(c[l >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) {
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                            continue
	                        }
	                        if ((c[l >> 2] | 0) == (c[k >> 2] | 0)) {
	                            c[l >> 2] = 0;
	                            continue
	                        }
	                        while (1) {
	                            if ((c[l >> 2] | 0) == (c[k >> 2] | 0))break;
	                            if (c[(c[l >> 2] | 0) + 20 >> 2] | 0) {
	                                c[l >> 2] = c[(c[l >> 2] | 0) + 20 >> 2];
	                                c[m >> 2] = (c[m >> 2] | 0) + -1
	                            }
	                            if ((c[l >> 2] | 0) != (c[k >> 2] | 0) ? (c[(c[l >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) {
	                                p = 33;
	                                break
	                            }
	                            if (!(c[(c[l >> 2] | 0) + 20 >> 2] | 0)) {
	                                p = 35;
	                                break
	                            }
	                            if ((c[l >> 2] | 0) == (c[k >> 2] | 0)) {
	                                p = 37;
	                                break
	                            }
	                        }
	                        if ((p | 0) == 33) {
	                            p = 0;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                        } else if ((p | 0) == 35) {
	                            p = 0;
	                            c[l >> 2] = 0
	                        } else if ((p | 0) == 37) {
	                            p = 0;
	                            c[l >> 2] = 0
	                        }
	                        if ((c[l >> 2] | 0) != (c[k >> 2] | 0))continue;
	                        c[l >> 2] = 0;
	                        continue
	                    }
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 12 >> 2]
	                }
	                c[h >> 2] = 0;
	                o = c[h >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Yp(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 4 | 0;
	                c[g + 20 >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[g + 8 >> 2] = f;
	                if ((c[l >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    n = c[j >> 2] | 0;
	                    i = g;
	                    return n | 0
	                }
	                c[m >> 2] = Oi(c[l >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    n = c[j >> 2] | 0;
	                    i = g;
	                    return n | 0
	                } else {
	                    l = c[k >> 2] | 0;
	                    c[h >> 2] = c[m >> 2];
	                    JT(l, 499, 121856, h) | 0;
	                    a[(c[k >> 2] | 0) + 499 >> 0] = 48;
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[j >> 2] = 0;
	                    n = c[j >> 2] | 0;
	                    i = g;
	                    return n | 0
	                }
	                return 0
	            }

	            function Zp(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                g = i;
	                i = i + 2080 | 0;
	                h = g;
	                j = g + 72 | 0;
	                k = g + 68 | 0;
	                l = g + 64 | 0;
	                m = g + 60 | 0;
	                n = g + 1580 | 0;
	                o = g + 56 | 0;
	                p = g + 52 | 0;
	                r = g + 1480 | 0;
	                s = g + 1080 | 0;
	                t = g + 48 | 0;
	                u = g + 44 | 0;
	                v = g + 40 | 0;
	                w = g + 36 | 0;
	                x = g + 576 | 0;
	                y = g + 32 | 0;
	                z = g + 28 | 0;
	                A = g + 24 | 0;
	                B = g + 20 | 0;
	                C = g + 76 | 0;
	                D = g + 16 | 0;
	                E = g + 12 | 0;
	                F = g + 8 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                cU(n | 0, 0, 500) | 0;
	                a[n >> 0] = 47;
	                a[n + 1 >> 0] = 32;
	                a[n + 2 >> 0] = 62;
	                a[n + 3 >> 0] = 32;
	                c[o >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    i = g;
	                    return
	                }
	                if (!(c[m >> 2] | 0))c[m >> 2] = c[q >> 2];
	                c[u >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[(c[u >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[u >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                c[(c[u >> 2] | 0) + 24 >> 2] = c[l >> 2];
	                c[(c[u >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                m = my(c[k >> 2] | 0) | 0;
	                c[c[u >> 2] >> 2] = m;
	                c[(c[u >> 2] | 0) + 8 >> 2] = c[(c[u >> 2] | 0) + 4 >> 2];
	                m = Lr(c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0;
	                c[(c[u >> 2] | 0) + 12 >> 2] = m;
	                if (!(c[(c[u >> 2] | 0) + 12 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                    i = g;
	                    return
	                }
	                while (1) {
	                    do if ((c[(c[u >> 2] | 0) + 8 >> 2] | 0) == (c[(c[u >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[h >> 2] = 122248;
	                        JT(n, 500, 122240, h) | 0
	                    } else {
	                        if ((((c[(c[u >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            m = c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0;
	                            c[h >> 2] = c[(c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                            c[h + 4 >> 2] = m;
	                            JT(n, 500, 122256, h) | 0;
	                            break
	                        }
	                        if ((c[(c[u >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                            c[h >> 2] = c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2];
	                            JT(n, 500, 122240, h) | 0;
	                            break
	                        }
	                        JT(n, 500, 122272, h) | 0
	                    } while (0);
	                    a[n + 499 >> 0] = 0;
	                    c[o >> 2] = Cb[c[(c[u >> 2] | 0) + 24 >> 2] & 511](n) | 0;
	                    if (!(c[o >> 2] | 0))break;
	                    c[p >> 2] = c[o >> 2];
	                    while (1) {
	                        if ((a[c[p >> 2] >> 0] | 0) != 32 ? (a[c[p >> 2] >> 0] | 0) != 9 : 0)break;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    c[t >> 2] = 0;
	                    while (1) {
	                        if ((a[c[p >> 2] >> 0] | 0) == 32)break;
	                        if ((a[c[p >> 2] >> 0] | 0) == 9)break;
	                        if ((a[c[p >> 2] >> 0] | 0) == 10)break;
	                        if ((a[c[p >> 2] >> 0] | 0) == 13)break;
	                        if (!(a[c[p >> 2] >> 0] | 0))break;
	                        m = c[p >> 2] | 0;
	                        c[p >> 2] = m + 1;
	                        k = a[m >> 0] | 0;
	                        m = c[t >> 2] | 0;
	                        c[t >> 2] = m + 1;
	                        a[r + m >> 0] = k
	                    }
	                    a[r + (c[t >> 2] | 0) >> 0] = 0;
	                    if (!(c[t >> 2] | 0))continue;
	                    while (1) {
	                        if ((a[c[p >> 2] >> 0] | 0) != 32 ? (a[c[p >> 2] >> 0] | 0) != 9 : 0)break;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    c[t >> 2] = 0;
	                    while (1) {
	                        if ((a[c[p >> 2] >> 0] | 0) == 10)break;
	                        if ((a[c[p >> 2] >> 0] | 0) == 13)break;
	                        if (!(a[c[p >> 2] >> 0] | 0))break;
	                        if (!(a[c[p >> 2] >> 0] | 0))break;
	                        k = c[p >> 2] | 0;
	                        c[p >> 2] = k + 1;
	                        m = a[k >> 0] | 0;
	                        k = c[t >> 2] | 0;
	                        c[t >> 2] = k + 1;
	                        a[s + k >> 0] = m
	                    }
	                    a[s + (c[t >> 2] | 0) >> 0] = 0;
	                    if (!(PT(r, 122280) | 0))break;
	                    if (!(PT(r, 122288) | 0))break;
	                    if (!(PT(r, 122296) | 0))break;
	                    a:do if (PT(r, 122304) | 0) {
	                        if (!(PT(r, 123880) | 0)) {
	                            Wp(c[u >> 2] | 0, s, 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 123896) | 0)) {
	                            Tp(c[u >> 2] | 0, s, 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 123904) | 0)) {
	                            iq(c[u >> 2] | 0, s, 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 123912) | 0)) {
	                            Vp(c[u >> 2] | 0, s, 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 123920) | 0))if (!(a[s >> 0] | 0)) {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 123928, h);
	                            break
	                        } else {
	                            Up(c[u >> 2] | 0, s, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 123976) | 0)) {
	                            jq(c[u >> 2] | 0, s, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 123984) | 0))if (!(a[s >> 0] | 0)) {
	                            ul(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 0);
	                            break
	                        } else {
	                            c[w >> 2] = 0;
	                            c[h >> 2] = w;
	                            bT(s, 123992, h) | 0;
	                            ul(c[(c[u >> 2] | 0) + 20 >> 2] | 0, c[w >> 2] | 0);
	                            break
	                        }
	                        if (!(PT(r, 124e3) | 0)) {
	                            if (Yp(c[u >> 2] | 0, x, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0)break;
	                            m = c[(c[u >> 2] | 0) + 20 >> 2] | 0;
	                            c[h >> 2] = x;
	                            Ka(m | 0, 122096, h | 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 124008) | 0)) {
	                            m = c[u >> 2] | 0;
	                            if (!(a[s >> 0] | 0)) {
	                                Xp(m, 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                                break
	                            }
	                            c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[m + 8 >> 2];
	                            c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                            c[v >> 2] = Rs(s, c[(c[u >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            if (c[v >> 2] | 0) {
	                                b:do switch (c[c[v >> 2] >> 2] | 0) {
	                                    case 8:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 122016, h);
	                                        break
	                                    }
	                                    case 9:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 122040, h);
	                                        break
	                                    }
	                                    case 3:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 121952, h);
	                                        break
	                                    }
	                                    case 4:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 121968, h);
	                                        break
	                                    }
	                                    case 7:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 122e3, h);
	                                        break
	                                    }
	                                    case 0:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 121904, h);
	                                        break
	                                    }
	                                    case 1:
	                                    {
	                                        if (!(c[(c[v >> 2] | 0) + 4 >> 2] | 0))break b;
	                                        c[y >> 2] = 0;
	                                        while (1) {
	                                            if ((c[y >> 2] | 0) >= (c[c[(c[v >> 2] | 0) + 4 >> 2] >> 2] | 0))break b;
	                                            Xp(c[u >> 2] | 0, 0, c[(c[(c[(c[v >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0, 0) | 0;
	                                            c[y >> 2] = (c[y >> 2] | 0) + 1
	                                        }
	                                        break
	                                    }
	                                    case 2:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 121928, h);
	                                        break
	                                    }
	                                    case 5:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 121984, h);
	                                        break
	                                    }
	                                    case 6:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 122e3, h);
	                                        break
	                                    }
	                                    default:
	                                    {
	                                    }
	                                } while (0);
	                                Qq(c[v >> 2] | 0)
	                            } else {
	                                k = c[33976] | 0;
	                                m = c[33980] | 0;
	                                c[h >> 2] = s;
	                                Db[k & 511](m, 121904, h)
	                            }
	                            c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            break
	                        }
	                        if (!(PT(r, 124016) | 0)) {
	                            Qp(c[u >> 2] | 0, 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 124024) | 0)) {
	                            kq(c[u >> 2] | 0, s, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 124032) | 0))if (!(a[s >> 0] | 0)) {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 124040, h);
	                            break
	                        } else {
	                            lq(c[u >> 2] | 0, s, 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 124072) | 0)) {
	                            c[z >> 2] = Pi(c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            mq(c[u >> 2] | 0, 0, c[z >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        if (!(PT(r, 124088) | 0))if (!(a[s >> 0] | 0)) {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 124096, h);
	                            break
	                        } else {
	                            c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                            c[v >> 2] = Rs(s, c[(c[u >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            Rq(c[(c[u >> 2] | 0) + 20 >> 2] | 0, c[v >> 2] | 0, 0);
	                            Qq(c[v >> 2] | 0);
	                            break
	                        }
	                        if (!(PT(r, 124128) | 0)) {
	                            nq(c[u >> 2] | 0, s, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        do if (PT(r, 124136) | 0) {
	                            if (!(PT(r, 124144) | 0))break;
	                            if (!(PT(r, 124152) | 0)) {
	                                m = c[u >> 2] | 0;
	                                if (!(a[s >> 0] | 0)) {
	                                    if (Yp(m, C, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0)break a;
	                                    k = c[(c[u >> 2] | 0) + 20 >> 2] | 0;
	                                    c[h >> 2] = C;
	                                    Ka(k | 0, 122096, h | 0) | 0;
	                                    break a
	                                }
	                                c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[m + 8 >> 2];
	                                c[v >> 2] = Rs(s, c[(c[u >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                if (c[v >> 2] | 0) {
	                                    c:do switch (c[c[v >> 2] >> 2] | 0) {
	                                        case 4:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 121968, h);
	                                            break
	                                        }
	                                        case 5:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 121984, h);
	                                            break
	                                        }
	                                        case 6:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 122e3, h);
	                                            break
	                                        }
	                                        case 7:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 122e3, h);
	                                            break
	                                        }
	                                        case 8:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 122016, h);
	                                            break
	                                        }
	                                        case 9:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 122040, h);
	                                            break
	                                        }
	                                        case 2:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 121928, h);
	                                            break
	                                        }
	                                        case 3:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 121952, h);
	                                            break
	                                        }
	                                        case 0:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 121904, h);
	                                            break
	                                        }
	                                        case 1:
	                                        {
	                                            if (!(c[(c[v >> 2] | 0) + 4 >> 2] | 0))break c;
	                                            c[D >> 2] = 0;
	                                            while (1) {
	                                                if ((c[D >> 2] | 0) >= (c[c[(c[v >> 2] | 0) + 4 >> 2] >> 2] | 0))break c;
	                                                if (!(Yp(c[u >> 2] | 0, C, c[(c[(c[(c[v >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[D >> 2] << 2) >> 2] | 0, 0) | 0)) {
	                                                    k = c[(c[u >> 2] | 0) + 20 >> 2] | 0;
	                                                    c[h >> 2] = C;
	                                                    Ka(k | 0, 122096, h | 0) | 0
	                                                }
	                                                c[D >> 2] = (c[D >> 2] | 0) + 1
	                                            }
	                                            break
	                                        }
	                                        default:
	                                        {
	                                        }
	                                    } while (0);
	                                    Qq(c[v >> 2] | 0)
	                                } else {
	                                    k = c[33976] | 0;
	                                    m = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[k & 511](m, 121904, h)
	                                }
	                                c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                break a
	                            }
	                            if (PT(r, 124160) | 0) {
	                                if (PT(r, 124248) | 0) {
	                                    m = c[33976] | 0;
	                                    k = c[33980] | 0;
	                                    c[h >> 2] = r;
	                                    Db[m & 511](k, 124272, h);
	                                    break a
	                                }
	                                k = c[u >> 2] | 0;
	                                if (!(a[s >> 0] | 0)) {
	                                    Sp(k, 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                                    break a
	                                }
	                                c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[k + 8 >> 2];
	                                c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                                c[v >> 2] = Rs(s, c[(c[u >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                if (c[v >> 2] | 0) {
	                                    d:do switch (c[c[v >> 2] >> 2] | 0) {
	                                        case 2:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 121928, h);
	                                            break
	                                        }
	                                        case 3:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 121952, h);
	                                            break
	                                        }
	                                        case 4:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 121968, h);
	                                            break
	                                        }
	                                        case 5:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 121984, h);
	                                            break
	                                        }
	                                        case 6:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 122e3, h);
	                                            break
	                                        }
	                                        case 7:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 122e3, h);
	                                            break
	                                        }
	                                        case 8:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 122016, h);
	                                            break
	                                        }
	                                        case 9:
	                                        {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 122040, h);
	                                            break
	                                        }
	                                        case 0:
	                                        {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[k & 511](m, 121904, h);
	                                            break
	                                        }
	                                        case 1:
	                                        {
	                                            if (!(c[(c[v >> 2] | 0) + 4 >> 2] | 0))break d;
	                                            c[F >> 2] = 0;
	                                            while (1) {
	                                                if ((c[F >> 2] | 0) >= (c[c[(c[v >> 2] | 0) + 4 >> 2] >> 2] | 0))break d;
	                                                if ((c[t >> 2] | 0) > 0)Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 124256, h | 0) | 0;
	                                                Sp(c[u >> 2] | 0, 0, c[(c[(c[(c[v >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[F >> 2] << 2) >> 2] | 0, 0) | 0;
	                                                c[F >> 2] = (c[F >> 2] | 0) + 1
	                                            }
	                                            break
	                                        }
	                                        default:
	                                        {
	                                        }
	                                    } while (0);
	                                    Qq(c[v >> 2] | 0)
	                                } else {
	                                    m = c[33976] | 0;
	                                    k = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[m & 511](k, 121904, h)
	                                }
	                                c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                break a
	                            }
	                            k = c[u >> 2] | 0;
	                            if (!(a[s >> 0] | 0)) {
	                                c[(c[u >> 2] | 0) + 8 >> 2] = c[k + 4 >> 2];
	                                break a
	                            }
	                            c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[k + 8 >> 2];
	                            c[E >> 2] = ZT(s | 0) | 0;
	                            do if ((c[E >> 2] | 0) >= 2) {
	                                if ((a[s + ((c[E >> 2] | 0) - 1) >> 0] | 0) != 47)break;
	                                a[s + ((c[E >> 2] | 0) - 1) >> 0] = 0
	                            } while (0);
	                            c[v >> 2] = Rs(s, c[(c[u >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            if (c[v >> 2] | 0) {
	                                e:do switch (c[c[v >> 2] >> 2] | 0) {
	                                    case 0:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 121904, h);
	                                        break
	                                    }
	                                    case 1:
	                                    {
	                                        if (!(c[(c[v >> 2] | 0) + 4 >> 2] | 0)) {
	                                            m = c[33976] | 0;
	                                            k = c[33980] | 0;
	                                            c[h >> 2] = s;
	                                            Db[m & 511](k, 124216, h);
	                                            break e
	                                        }
	                                        if ((c[c[(c[v >> 2] | 0) + 4 >> 2] >> 2] | 0) != 1) {
	                                            k = c[33976] | 0;
	                                            m = c[33980] | 0;
	                                            l = c[c[(c[v >> 2] | 0) + 4 >> 2] >> 2] | 0;
	                                            c[h >> 2] = s;
	                                            c[h + 4 >> 2] = l;
	                                            Db[k & 511](m, 124192, h);
	                                            break e
	                                        }
	                                        c[(c[u >> 2] | 0) + 8 >> 2] = c[c[(c[(c[v >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2];
	                                        if (!(c[(c[u >> 2] | 0) + 8 >> 2] | 0))break e;
	                                        if ((c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + 4 >> 2] | 0) != 18)break e;
	                                        Db[c[135904 >> 2] & 511](c[33980] | 0, 124168, h);
	                                        c[(c[u >> 2] | 0) + 8 >> 2] = 0;
	                                        break
	                                    }
	                                    case 2:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 121928, h);
	                                        break
	                                    }
	                                    case 3:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 121952, h);
	                                        break
	                                    }
	                                    case 4:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 121968, h);
	                                        break
	                                    }
	                                    case 5:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 121984, h);
	                                        break
	                                    }
	                                    case 6:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 122e3, h);
	                                        break
	                                    }
	                                    case 7:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 122e3, h);
	                                        break
	                                    }
	                                    case 8:
	                                    {
	                                        m = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[m & 511](k, 122016, h);
	                                        break
	                                    }
	                                    case 9:
	                                    {
	                                        k = c[33976] | 0;
	                                        m = c[33980] | 0;
	                                        c[h >> 2] = s;
	                                        Db[k & 511](m, 122040, h);
	                                        break
	                                    }
	                                    default:
	                                    {
	                                    }
	                                } while (0);
	                                Qq(c[v >> 2] | 0)
	                            } else {
	                                m = c[33976] | 0;
	                                k = c[33980] | 0;
	                                c[h >> 2] = s;
	                                Db[m & 511](k, 121904, h)
	                            }
	                            c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            break a
	                        } while (0);
	                        c[A >> 2] = ((PT(r, 124144) | 0) != 0 ^ 1) & 1;
	                        if (!(a[s >> 0] | 0)) {
	                            k = c[u >> 2] | 0;
	                            m = c[(c[u >> 2] | 0) + 8 >> 2] | 0;
	                            if (c[A >> 2] | 0) {
	                                Rp(k, 0, m, 0) | 0;
	                                break
	                            } else {
	                                Pp(k, 0, m, 0) | 0;
	                                break
	                            }
	                        }
	                        c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                        c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                        c[v >> 2] = Rs(s, c[(c[u >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        if (c[v >> 2] | 0) {
	                            f:do switch (c[c[v >> 2] >> 2] | 0) {
	                                case 1:
	                                {
	                                    if (!(c[(c[v >> 2] | 0) + 4 >> 2] | 0))break f;
	                                    c[B >> 2] = 0;
	                                    while (1) {
	                                        if ((c[B >> 2] | 0) >= (c[c[(c[v >> 2] | 0) + 4 >> 2] >> 2] | 0))break f;
	                                        m = c[u >> 2] | 0;
	                                        k = c[(c[(c[(c[v >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[B >> 2] << 2) >> 2] | 0;
	                                        if (c[A >> 2] | 0)Rp(m, 0, k, 0) | 0; else Pp(m, 0, k, 0) | 0;
	                                        c[B >> 2] = (c[B >> 2] | 0) + 1
	                                    }
	                                    break
	                                }
	                                case 7:
	                                {
	                                    k = c[33976] | 0;
	                                    m = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[k & 511](m, 122e3, h);
	                                    break
	                                }
	                                case 8:
	                                {
	                                    m = c[33976] | 0;
	                                    k = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[m & 511](k, 122016, h);
	                                    break
	                                }
	                                case 9:
	                                {
	                                    k = c[33976] | 0;
	                                    m = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[k & 511](m, 122040, h);
	                                    break
	                                }
	                                case 0:
	                                {
	                                    m = c[33976] | 0;
	                                    k = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[m & 511](k, 121904, h);
	                                    break
	                                }
	                                case 2:
	                                {
	                                    k = c[33976] | 0;
	                                    m = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[k & 511](m, 121928, h);
	                                    break
	                                }
	                                case 3:
	                                {
	                                    m = c[33976] | 0;
	                                    k = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[m & 511](k, 121952, h);
	                                    break
	                                }
	                                case 4:
	                                {
	                                    k = c[33976] | 0;
	                                    m = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[k & 511](m, 121968, h);
	                                    break
	                                }
	                                case 5:
	                                {
	                                    m = c[33976] | 0;
	                                    k = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[m & 511](k, 121984, h);
	                                    break
	                                }
	                                case 6:
	                                {
	                                    k = c[33976] | 0;
	                                    m = c[33980] | 0;
	                                    c[h >> 2] = s;
	                                    Db[k & 511](m, 122e3, h);
	                                    break
	                                }
	                                default:
	                                {
	                                }
	                            } while (0);
	                            Qq(c[v >> 2] | 0)
	                        } else {
	                            m = c[33976] | 0;
	                            k = c[33980] | 0;
	                            c[h >> 2] = s;
	                            Db[m & 511](k, 121904, h)
	                        }
	                        c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0
	                    } else {
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122312, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122360, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122408, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122440, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122488, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122544, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122632, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122712, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122744, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122784, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122824, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122872, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 122936, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123024, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123112, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123192, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123280, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123344, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123416, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123472, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123552, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123584, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123648, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123704, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123752, h | 0) | 0;
	                        Ka(c[(c[u >> 2] | 0) + 20 >> 2] | 0, 123824, h | 0) | 0
	                    } while (0);
	                    jT(c[o >> 2] | 0);
	                    c[o >> 2] = 0
	                }
	                Nr(c[(c[u >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[u >> 2] | 0) + 16 >> 2] | 0)Th(c[(c[u >> 2] | 0) + 4 >> 2] | 0);
	                if (c[c[u >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[u >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                if (!(c[o >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                jT(c[o >> 2] | 0);
	                i = g;
	                return
	            }

	            function _p(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = b;
	                c[(c[e >> 2] | 0) + 108 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 124 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 128 >> 2] = 0;
	                c[c[e >> 2] >> 2] = c[q >> 2];
	                c[(c[e >> 2] | 0) + 112 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 116 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 120 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 132 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 136 >> 2] = 0;
	                c[f >> 2] = 0;
	                while (1) {
	                    if ((c[f >> 2] | 0) >= 100)break;
	                    a[(c[e >> 2] | 0) + 4 + (c[f >> 2] | 0) >> 0] = 32;
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                a[(c[e >> 2] | 0) + 104 >> 0] = 0;
	                i = d;
	                return
	            }

	            function $p(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                oq(c[f >> 2] | 0);
	                b = (c[(c[f >> 2] | 0) + 124 >> 2] | 0) != 0;
	                if (!(c[g >> 2] | 0)) {
	                    if (b) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 127816, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                if (!b ? (Ka(c[c[f >> 2] >> 2] | 0, 127832, e | 0) | 0, pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0), Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0, (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) {
	                    e = (c[f >> 2] | 0) + 108 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + 1;
	                    fq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                    e = (c[f >> 2] | 0) + 108 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + -1
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0))qq(c[f >> 2] | 0, 5015, 127848);
	                rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function aq(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return
	            }

	            function bq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                sq(c[f >> 2] | 0, c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2];
	                    if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))Ka(c[c[f >> 2] >> 2] | 0, 127472, e | 0) | 0;
	                    Wj(c[h >> 2] | 0, 259, c[f >> 2] | 0)
	                } else Ka(c[c[f >> 2] >> 2] | 0, 127504, e | 0) | 0;
	                if ((c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 48 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = c[(c[(c[g >> 2] | 0) + 48 >> 2] | 0) + 48 >> 2];
	                    if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))Ka(c[c[f >> 2] >> 2] | 0, 127536, e | 0) | 0;
	                    Wj(c[j >> 2] | 0, 259, c[f >> 2] | 0);
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                Ka(c[c[f >> 2] >> 2] | 0, 127568, e | 0) | 0;
	                i = d;
	                return
	            }

	            function cq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    $p(c[e >> 2] | 0, c[f >> 2] | 0);
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                }
	                i = d;
	                return
	            }

	            function dq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    oq(c[f >> 2] | 0);
	                    Ka(c[c[f >> 2] >> 2] | 0, 126040, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 116 >> 2] = c[g >> 2];
	                a:do switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                    case 1:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126056, e | 0) | 0;
	                            if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                pq(c[f >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                                Ka(c[c[f >> 2] >> 2] | 0, 126072, e | 0) | 0
	                            }
	                            pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 4:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126168, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 15:
	                    {
	                        vq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 13:
	                    case 9:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))oq(c[f >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126232, e | 0) | 0;
	                        rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 11:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126280, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))oq(c[f >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126080, e | 0) | 0;
	                        rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 16:
	                    {
	                        wq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 5:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            b = c[c[f >> 2] >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 126184, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 17:
	                    {
	                        xq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 8:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126216, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 7:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            b = c[c[f >> 2] >> 2] | 0;
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                            Ka(b | 0, 126208, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 12:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126296, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 14:
	                    {
	                        uq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 19:
	                    {
	                        if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                            i = d;
	                            return
	                        }
	                        oq(c[f >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126312, e | 0) | 0;
	                        i = d;
	                        return
	                    }
	                    case 6:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126200, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 10:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            Ka(c[c[f >> 2] >> 2] | 0, 126264, e | 0) | 0
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        yq(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 20:
	                    {
	                        if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                            i = d;
	                            return
	                        }
	                        oq(c[f >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126328, e | 0) | 0;
	                        i = d;
	                        return
	                    }
	                    case 3:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                            oq(c[f >> 2] | 0);
	                            b = c[c[f >> 2] >> 2] | 0;
	                            if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 75112)Ka(b | 0, 126112, e | 0) | 0; else Ka(b | 0, 126128, e | 0) | 0;
	                            if (!(c[(c[f >> 2] | 0) + 136 >> 2] & 1)) {
	                                Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0;
	                                break a
	                            }
	                            b = c[f >> 2] | 0;
	                            if ((c[(c[g >> 2] | 0) + 40 >> 2] | 0) == ((c[g >> 2] | 0) + 44 | 0)) {
	                                Ka(c[b >> 2] | 0, 126136, e | 0) | 0;
	                                break a
	                            }
	                            a = (CP(c[b + 120 >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0) == 1;
	                            b = c[c[f >> 2] >> 2] | 0;
	                            if (a) {
	                                Ka(b | 0, 126152, e | 0) | 0;
	                                break a
	                            } else {
	                                Ka(b | 0, 121896, e | 0) | 0;
	                                break a
	                            }
	                        }
	                        break
	                    }
	                    default:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))oq(c[f >> 2] | 0);
	                        zq(c[f >> 2] | 0, 5011, 126016, c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                } while (0);
	                if (!(c[(c[g >> 2] | 0) + 32 >> 2] | 0)) {
	                    if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))oq(c[f >> 2] | 0);
	                    Ka(c[c[f >> 2] >> 2] | 0, 126344, e | 0) | 0
	                }
	                b = (c[f >> 2] | 0) + 108 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)Aq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 48 >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)cq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 44 >> 2] | 0);
	                b = c[g >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 5) {
	                    if (((c[b + 4 >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 124 >> 2] | 0) == 0 : 0) {
	                        oq(c[f >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126368, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                    }
	                } else {
	                    c[h >> 2] = ad(c[b + 32 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if (c[h >> 2] | 0)Bq(c[f >> 2] | 0, c[h >> 2] | 0)
	                }
	                h = (c[f >> 2] | 0) + 108 | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + -1;
	                rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function eq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    if (c[b + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    oq(c[f >> 2] | 0);
	                    Ka(c[c[f >> 2] >> 2] | 0, 126040, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                dq(b, c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                    i = d;
	                    return
	                }
	                b = (c[f >> 2] | 0) + 108 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                fq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                g = (c[f >> 2] | 0) + 108 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + -1;
	                i = d;
	                return
	            }

	            function fq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    eq(c[e >> 2] | 0, c[f >> 2] | 0);
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                }
	                i = d;
	                return
	            }

	            function gq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                sq(c[f >> 2] | 0, c[g >> 2] | 0);
	                if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        Ka(c[c[f >> 2] >> 2] | 0, 125424, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                        Ka(c[c[f >> 2] >> 2] | 0, 125432, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 56 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 60 >> 2] | 0) {
	                        Ka(c[c[f >> 2] >> 2] | 0, 125448, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 72 >> 2] | 0) {
	                        Ka(c[c[f >> 2] >> 2] | 0, 125464, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 72 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 40 >> 2] | 0)Ka(c[c[f >> 2] >> 2] | 0, 125472, e | 0) | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 52 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Aq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 52 >> 2] | 0);
	                i = d;
	                return
	            }

	            function hq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    if (c[b + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 125400, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                gq(b, c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = (c[f >> 2] | 0) + 108 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                fq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                g = (c[f >> 2] | 0) + 108 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + -1;
	                i = d;
	                return
	            }

	            function iq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                p = f + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[f + 24 >> 2] = d;
	                c[f + 20 >> 2] = e;
	                c[m >> 2] = YM(c[k >> 2] | 0) | 0;
	                $M(c[m >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                c[l >> 2] = _M(c[m >> 2] | 0) | 0;
	                ZM(c[m >> 2] | 0);
	                if (!(c[l >> 2] | 0)) {
	                    m = c[33976] | 0;
	                    e = c[33980] | 0;
	                    c[g >> 2] = c[k >> 2];
	                    Db[m & 511](e, 124416, g);
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[n >> 2] = eN(c[l >> 2] | 0) | 0;
	                gN(c[n >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                c[p >> 2] = iN(c[n >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0) | 0;
	                do if (c[p >> 2] | 0) {
	                    e = c[o >> 2] | 0;
	                    m = c[c[j >> 2] >> 2] | 0;
	                    if ((c[p >> 2] | 0) > 0) {
	                        c[g >> 2] = m;
	                        Ka(e | 0, 124472, g | 0) | 0;
	                        break
	                    } else {
	                        c[g >> 2] = m;
	                        Ka(e | 0, 124496, g | 0) | 0;
	                        break
	                    }
	                } else {
	                    e = c[o >> 2] | 0;
	                    c[g >> 2] = c[c[j >> 2] >> 2];
	                    Ka(e | 0, 124456, g | 0) | 0
	                } while (0);
	                fN(c[n >> 2] | 0);
	                if (c[l >> 2] | 0)VM(c[l >> 2] | 0);
	                c[h >> 2] = 0;
	                q = c[h >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function jq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[f + 4 >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    m = c[h >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    m = c[h >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    m = c[h >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (((vy(c[k >> 2] | 0, 63) | 0) == 0 ? (vy(c[k >> 2] | 0, 42) | 0) == 0 : 0) ? (vy(c[k >> 2] | 0, 46) | 0) == 0 : 0)vy(c[k >> 2] | 0, 91) | 0;
	                a:while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    e = c[l >> 2] | 0;
	                    if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 8) {
	                        if (wy(c[e + 40 >> 2] | 0, c[k >> 2] | 0) | 0) {
	                            d = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                            c[g >> 2] = Oi(c[l >> 2] | 0) | 0;
	                            Ka(d | 0, 124408, g | 0) | 0;
	                            Pp(c[j >> 2] | 0, 0, c[l >> 2] | 0, 0) | 0
	                        }
	                    } else if ((c[e + 4 >> 2] | 0) == 3 ? (wy(c[(c[l >> 2] | 0) + 40 >> 2] | 0, c[k >> 2] | 0) | 0) != 0 : 0) {
	                        e = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                        c[g >> 2] = Oi(c[(c[l >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        Ka(e | 0, 124408, g | 0) | 0;
	                        Pp(c[j >> 2] | 0, 0, c[(c[l >> 2] | 0) + 20 >> 2] | 0, 0) | 0
	                    }
	                    if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                        if ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                            continue
	                        }
	                        if (c[(c[l >> 2] | 0) + 24 >> 2] | 0) {
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                            continue
	                        }
	                        while (1) {
	                            if (!(c[l >> 2] | 0))continue a;
	                            if (c[(c[l >> 2] | 0) + 20 >> 2] | 0)c[l >> 2] = c[(c[l >> 2] | 0) + 20 >> 2];
	                            n = c[l >> 2] | 0;
	                            if (c[(c[l >> 2] | 0) + 24 >> 2] | 0) {
	                                o = 30;
	                                break
	                            }
	                            if (!(c[n + 20 >> 2] | 0)) {
	                                o = 32;
	                                break
	                            }
	                        }
	                        if ((o | 0) == 30) {
	                            o = 0;
	                            c[l >> 2] = c[n + 24 >> 2];
	                            continue
	                        } else if ((o | 0) == 32) {
	                            o = 0;
	                            c[l >> 2] = 0;
	                            continue
	                        }
	                    }
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 12 >> 2]
	                }
	                c[h >> 2] = 0;
	                m = c[h >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function kq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[f + 12 >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 121712, g | 0) | 0;
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 121712, g | 0) | 0;
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                e = c[l >> 2] | 0;
	                d = c[k >> 2] | 0;
	                c[n >> 2] = Yf(e, d, ZT(c[k >> 2] | 0) | 0, 0, m) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    if (c[(c[l >> 2] | 0) + 12 >> 2] | 0) {
	                        Uh(c[(c[l >> 2] | 0) + 12 >> 2] | 0);
	                        c[(c[l >> 2] | 0) + 12 >> 2] = 0;
	                        c[(c[l >> 2] | 0) + 16 >> 2] = 0
	                    }
	                    yi(c[l >> 2] | 0, c[m >> 2] | 0) | 0
	                } else Ka(c[(c[j >> 2] | 0) + 20 >> 2] | 0, 124376, g | 0) | 0;
	                c[h >> 2] = 0;
	                o = c[h >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function lq(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[h + 28 >> 2] = f;
	                c[h + 24 >> 2] = g;
	                c[n >> 2] = my(c[m >> 2] | 0) | 0;
	                c[q >> 2] = c[n >> 2];
	                while (1) {
	                    if (!(c[q >> 2] | 0)) {
	                        r = 10;
	                        break
	                    }
	                    if (!(d[c[q >> 2] >> 0] | 0)) {
	                        r = 10;
	                        break
	                    }
	                    c[o >> 2] = c[q >> 2];
	                    c[q >> 2] = vy(c[q >> 2] | 0, 61) | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        r = 5;
	                        break
	                    }
	                    m = c[q >> 2] | 0;
	                    c[q >> 2] = m + 1;
	                    a[m >> 0] = 0;
	                    c[p >> 2] = c[q >> 2];
	                    c[q >> 2] = vy(c[q >> 2] | 0, 32) | 0;
	                    if (c[q >> 2] | 0) {
	                        m = c[q >> 2] | 0;
	                        c[q >> 2] = m + 1;
	                        a[m >> 0] = 0
	                    }
	                    if (rr(c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0) {
	                        r = 9;
	                        break
	                    }
	                }
	                if ((r | 0) == 5) {
	                    Ka(c[(c[l >> 2] | 0) + 20 >> 2] | 0, 124040, j | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[k >> 2] = -1;
	                    s = c[k >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else if ((r | 0) == 9) {
	                    q = c[(c[l >> 2] | 0) + 20 >> 2] | 0;
	                    l = c[p >> 2] | 0;
	                    c[j >> 2] = c[o >> 2];
	                    c[j + 4 >> 2] = l;
	                    Ka(q | 0, 124312, j | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[k >> 2] = -1;
	                    s = c[k >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else if ((r | 0) == 10) {
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[k >> 2] = 0;
	                    s = c[k >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                return 0
	            }

	            function mq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 8 | 0;
	                k = f;
	                c[h >> 2] = a;
	                c[f + 12 >> 2] = b;
	                c[j >> 2] = d;
	                c[f + 4 >> 2] = e;
	                if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? !((c[h >> 2] | 0) == 0 ? 1 : (c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 0) : 0) ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 48 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        j = c[(c[h >> 2] | 0) + 12 >> 2] | 0;
	                        e = c[k >> 2] | 0;
	                        if (!(c[(c[k >> 2] | 0) + 12 >> 2] | 0))rr(j, 124296, c[e + 8 >> 2] | 0) | 0; else rr(j, c[e + 12 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    c[g >> 2] = 0;
	                    l = c[g >> 2] | 0;
	                    i = f;
	                    return l | 0
	                }
	                c[g >> 2] = -1;
	                l = c[g >> 2] | 0;
	                i = f;
	                return l | 0
	            }

	            function nq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 8 | 0;
	                h = f + 4 | 0;
	                c[f + 12 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[f >> 2] = e;
	                Wi(c[h >> 2] | 0, c[g >> 2] | 0);
	                i = f;
	                return 0
	            }

	            function oq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                if (c[(c[e >> 2] | 0) + 124 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 108 >> 2] | 0) <= 0) {
	                    i = b;
	                    return
	                }
	                a = c[c[e >> 2] >> 2] | 0;
	                f = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 108 >> 2] | 0) < 50) {
	                    c[d >> 2] = (c[e >> 2] | 0) + 4 + (100 - (c[f + 108 >> 2] << 1));
	                    Ka(a | 0, 121856, d | 0) | 0;
	                    i = b;
	                    return
	                } else {
	                    c[d >> 2] = f + 4;
	                    Ka(a | 0, 121856, d | 0) | 0;
	                    i = b;
	                    return
	                }
	            }

	            function pq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (c[(c[g >> 2] | 0) + 124 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                if (!(c[h >> 2] | 0)) {
	                    Ka(c[c[g >> 2] >> 2] | 0, 121688, f | 0) | 0;
	                    i = e;
	                    return
	                }
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= 40)break;
	                    if (!(d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0)) {
	                        k = 17;
	                        break
	                    }
	                    do if ((d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0) {
	                            k = 11;
	                            break
	                        }
	                        if ((d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) != 13)if ((d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) >= 128) {
	                            b = c[c[g >> 2] >> 2] | 0;
	                            c[f >> 2] = d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0];
	                            Ka(b | 0, 121696, f | 0) | 0;
	                            break
	                        } else {
	                            fb(d[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0, c[c[g >> 2] >> 2] | 0) | 0;
	                            break
	                        } else k = 11
	                    } else k = 11; while (0);
	                    if ((k | 0) == 11) {
	                        k = 0;
	                        fb(32, c[c[g >> 2] >> 2] | 0) | 0
	                    }
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((k | 0) == 17) {
	                    i = e;
	                    return
	                }
	                Ka(c[c[g >> 2] >> 2] | 0, 121704, f | 0) | 0;
	                i = e;
	                return
	            }

	            function qq(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                d = (c[g >> 2] | 0) + 128 | 0;
	                c[d >> 2] = (c[d >> 2] | 0) + 1;
	                d = c[(c[g >> 2] | 0) + 116 >> 2] | 0;
	                g = c[h >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(0, 0, 0, 0, d, 24, g, 2, 0, 0, 0, 0, 0, 0, 0, 121856, f);
	                i = e;
	                return
	            }

	            function rq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0))qq(c[e >> 2] | 0, 5013, 124640);
	                if (c[(c[f >> 2] | 0) + 32 >> 2] | 0) {
	                    c[h >> 2] = c[(c[g >> 2] | 0) + 80 >> 2];
	                    if ((c[h >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 132 >> 2] | 0) == 0 : 0)c[(c[e >> 2] | 0) + 132 >> 2] = 1;
	                    if (!(c[(c[e >> 2] | 0) + 112 >> 2] | 0))c[(c[e >> 2] | 0) + 112 >> 2] = c[g >> 2];
	                    if (!(c[(c[e >> 2] | 0) + 120 >> 2] | 0))c[(c[e >> 2] | 0) + 120 >> 2] = c[h >> 2]
	                } else {
	                    qq(c[e >> 2] | 0, 5014, 124664);
	                    c[h >> 2] = 0
	                }
	                if (((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) != (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 32 >> 2] | 0) : 0) ? (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 124688) | 0) == 0 : 0)qq(c[e >> 2] | 0, 5017, 124704);
	                h = c[f >> 2] | 0;
	                do if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                    g = (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0;
	                    if ((c[h + 4 >> 2] | 0) == 2) {
	                        if (!g)break;
	                        if ((c[f >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 44 >> 2] | 0))break;
	                        qq(c[e >> 2] | 0, 5018, 124744);
	                        break
	                    } else {
	                        if (!g)break;
	                        if ((c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0) == (c[f >> 2] | 0))break;
	                        qq(c[e >> 2] | 0, 5018, 124792);
	                        break
	                    }
	                } else if ((c[(c[h + 28 >> 2] | 0) + 24 >> 2] | 0) != (c[f >> 2] | 0))qq(c[e >> 2] | 0, 5019, 124840); while (0);
	                h = c[f >> 2] | 0;
	                if (!(c[(c[f >> 2] | 0) + 24 >> 2] | 0)) {
	                    if ((((c[h + 20 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] | 0) != (c[f >> 2] | 0) : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)qq(c[e >> 2] | 0, 5020, 124880)
	                } else {
	                    if ((c[(c[h + 24 >> 2] | 0) + 28 >> 2] | 0) != (c[f >> 2] | 0))qq(c[e >> 2] | 0, 5021, 124928);
	                    if ((c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 20 >> 2] | 0) != (c[(c[f >> 2] | 0) + 20 >> 2] | 0))qq(c[e >> 2] | 0, 5029, 124928)
	                }
	                h = c[f >> 2] | 0;
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    c[j >> 2] = c[h + 48 >> 2];
	                    while (1) {
	                        if (!(c[j >> 2] | 0))break;
	                        Cq(c[e >> 2] | 0, c[f >> 2] | 0, c[j >> 2] | 0);
	                        c[j >> 2] = c[c[j >> 2] >> 2]
	                    }
	                    if (c[(c[f >> 2] | 0) + 36 >> 2] | 0)Cq(c[e >> 2] | 0, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0)
	                } else if ((c[h + 4 >> 2] | 0) == 2 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)Cq(c[e >> 2] | 0, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                if ((((((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 15 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 16 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 14 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0)Dq(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0);
	                switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    case 2:
	                    case 1:
	                    {
	                        Eq(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 4:
	                    {
	                        if (!(c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                            i = d;
	                            return
	                        }
	                        Fq(c[e >> 2] | 0, 5037, 125048, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 3:
	                    {
	                        if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 75104) {
	                            i = d;
	                            return
	                        }
	                        if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 75112) {
	                            i = d;
	                            return
	                        }
	                        if ((c[(c[e >> 2] | 0) + 120 >> 2] | 0) != 0 ? (h = c[(c[f >> 2] | 0) + 8 >> 2] | 0, (h | 0) == (AP(c[(c[e >> 2] | 0) + 120 >> 2] | 0, 124968, 7) | 0)) : 0) {
	                            i = d;
	                            return
	                        }
	                        Fq(c[e >> 2] | 0, 5036, 124976, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 7:
	                    {
	                        Eq(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    case 8:
	                    {
	                        if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 75128) {
	                            i = d;
	                            return
	                        }
	                        Fq(c[e >> 2] | 0, 5036, 125008, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    default:
	                    {
	                        i = d;
	                        return
	                    }
	                }
	            }

	            function sq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if (!(c[g >> 2] | 0)) {
	                    if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0))Ka(c[c[f >> 2] >> 2] | 0, 125400, e | 0) | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 116 >> 2] = c[g >> 2];
	                    do switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                        case 3:
	                        {
	                            qq(c[f >> 2] | 0, 5002, 125744);
	                            break a;
	                            break
	                        }
	                        case 5:
	                        {
	                            qq(c[f >> 2] | 0, 5004, 125792);
	                            break a;
	                            break
	                        }
	                        case 10:
	                        {
	                            qq(c[f >> 2] | 0, 5008, 125928);
	                            break a;
	                            break
	                        }
	                        case 12:
	                        {
	                            qq(c[f >> 2] | 0, 5010, 125984);
	                            break a;
	                            break
	                        }
	                        case 4:
	                        {
	                            qq(c[f >> 2] | 0, 5003, 125768);
	                            break a;
	                            break
	                        }
	                        case 13:
	                        {
	                            if (c[(c[f >> 2] | 0) + 124 >> 2] | 0)break a;
	                            Ka(c[c[f >> 2] >> 2] | 0, 125912, e | 0) | 0;
	                            break a;
	                            break
	                        }
	                        case 9:
	                        {
	                            if (c[(c[f >> 2] | 0) + 124 >> 2] | 0)break a;
	                            Ka(c[c[f >> 2] >> 2] | 0, 125896, e | 0) | 0;
	                            break a;
	                            break
	                        }
	                        case 7:
	                        {
	                            qq(c[f >> 2] | 0, 5006, 125848);
	                            break a;
	                            break
	                        }
	                        case 2:
	                        {
	                            qq(c[f >> 2] | 0, 5001, 125712);
	                            break a;
	                            break
	                        }
	                        case 8:
	                        {
	                            qq(c[f >> 2] | 0, 5007, 125872);
	                            break a;
	                            break
	                        }
	                        case 1:
	                        {
	                            qq(c[f >> 2] | 0, 5e3, 125688);
	                            break a;
	                            break
	                        }
	                        case 11:
	                        {
	                            qq(c[f >> 2] | 0, 5009, 125952);
	                            break a;
	                            break
	                        }
	                        case 6:
	                        {
	                            qq(c[f >> 2] | 0, 5005, 125824);
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            zq(c[f >> 2] | 0, 5011, 126016, c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                            break a
	                        }
	                    } while (0)
	                } while (0);
	                i = d;
	                return
	            }

	            function tq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = (c[(c[g >> 2] | 0) + 124 >> 2] | 0) != 0;
	                if (!(c[f >> 2] | 0)) {
	                    if (b) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[g >> 2] >> 2] | 0, 127600, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                if (b) {
	                    i = d;
	                    return
	                }
	                b = c[c[g >> 2] >> 2] | 0;
	                c[e >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                Ka(b | 0, 124408, e | 0) | 0;
	                switch (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                    case 2:
	                    {
	                        Ka(c[c[g >> 2] >> 2] | 0, 127640, e | 0) | 0;
	                        break
	                    }
	                    case 5:
	                    {
	                        Ka(c[c[g >> 2] >> 2] | 0, 127712, e | 0) | 0;
	                        break
	                    }
	                    case 1:
	                    {
	                        Ka(c[c[g >> 2] >> 2] | 0, 127616, e | 0) | 0;
	                        break
	                    }
	                    case 3:
	                    {
	                        Ka(c[c[g >> 2] >> 2] | 0, 127664, e | 0) | 0;
	                        break
	                    }
	                    case 4:
	                    {
	                        Ka(c[c[g >> 2] >> 2] | 0, 127688, e | 0) | 0;
	                        break
	                    }
	                    default:
	                        zq(c[g >> 2] | 0, 5012, 127736, c[(c[f >> 2] | 0) + 48 >> 2] | 0)
	                }
	                if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                    b = c[c[g >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                    Ka(b | 0, 127760, e | 0) | 0
	                }
	                if (c[(c[f >> 2] | 0) + 56 >> 2] | 0) {
	                    b = c[c[g >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 56 >> 2];
	                    Ka(b | 0, 127768, e | 0) | 0
	                }
	                if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                    b = c[c[g >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                    Ka(b | 0, 127784, e | 0) | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                    b = c[c[g >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                    Ka(b | 0, 127800, e | 0) | 0
	                }
	                Ka(c[c[g >> 2] >> 2] | 0, 121896, e | 0) | 0;
	                i = d;
	                return
	            }

	            function uq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                oq(c[f >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 124544, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 14) {
	                    qq(b, 5022, 124568);
	                    i = d;
	                    return
	                }
	                if (!(c[b + 124 >> 2] | 0)) {
	                    b = c[c[f >> 2] >> 2] | 0;
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                        Ka(b | 0, 124592, e | 0) | 0
	                    } else Ka(b | 0, 124600, e | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 52 >> 2] | 0) {
	                        b = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                        Ka(b | 0, 124608, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                        b = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 56 >> 2];
	                        Ka(b | 0, 124624, e | 0) | 0
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                }
	                rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function vq(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 5024 | 0;
	                f = e;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e + 12 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                oq(c[g >> 2] | 0);
	                if (!(c[h >> 2] | 0)) {
	                    if (c[(c[g >> 2] | 0) + 124 >> 2] | 0) {
	                        i = e;
	                        return
	                    }
	                    Ka(c[c[g >> 2] >> 2] | 0, 127304, f | 0) | 0;
	                    i = e;
	                    return
	                }
	                if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 15) {
	                    qq(c[g >> 2] | 0, 5025, 127336);
	                    i = e;
	                    return
	                }
	                d = c[g >> 2] | 0;
	                if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                    if (!(c[d + 124 >> 2] | 0)) {
	                        Ka(c[c[g >> 2] >> 2] | 0, 127376, f | 0) | 0;
	                        pq(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                        Ka(c[c[g >> 2] >> 2] | 0, 126712, f | 0) | 0
	                    }
	                } else qq(d, 5015, 127392);
	                if (!(c[(c[g >> 2] | 0) + 124 >> 2] | 0)) {
	                    switch (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                        case 0:
	                        {
	                            Ka(c[c[g >> 2] >> 2] | 0, 127424, f | 0) | 0;
	                            break
	                        }
	                        case 2:
	                        {
	                            Ka(c[c[g >> 2] >> 2] | 0, 127448, f | 0) | 0;
	                            break
	                        }
	                        case 4:
	                        {
	                            Ka(c[c[g >> 2] >> 2] | 0, 127456, f | 0) | 0;
	                            break
	                        }
	                        case 1:
	                        {
	                            Ka(c[c[g >> 2] >> 2] | 0, 127440, f | 0) | 0;
	                            break
	                        }
	                        case 3:
	                        {
	                            Ka(c[c[g >> 2] >> 2] | 0, 127456, f | 0) | 0;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                        a[j >> 0] = 0;
	                        fm(j, 5e3, c[(c[h >> 2] | 0) + 40 >> 2] | 0, 1);
	                        a[j + 5e3 >> 0] = 0;
	                        d = c[c[g >> 2] >> 2] | 0;
	                        c[f >> 2] = j;
	                        Ka(d | 0, 121856, f | 0) | 0
	                    }
	                    Ka(c[c[g >> 2] >> 2] | 0, 121896, f | 0) | 0
	                }
	                rq(c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function wq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                oq(c[f >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 126928, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 16) {
	                    qq(c[f >> 2] | 0, 5024, 126960);
	                    i = d;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    if (!(c[b + 124 >> 2] | 0)) {
	                        a = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                        Ka(a | 0, 127e3, e | 0) | 0
	                    }
	                } else qq(b, 5015, 127016);
	                b = c[f >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 60 >> 2] | 0) {
	                    if (!(c[b + 124 >> 2] | 0)) {
	                        a = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 60 >> 2];
	                        Ka(a | 0, 127056, e | 0) | 0
	                    }
	                } else qq(b, 5016, 127064);
	                if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                    do switch (c[(c[g >> 2] | 0) + 40 >> 2] | 0) {
	                        case 3:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127128, e | 0) | 0;
	                            break
	                        }
	                        case 8:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127184, e | 0) | 0;
	                            break
	                        }
	                        case 1:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127112, e | 0) | 0;
	                            break
	                        }
	                        case 9:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127200, e | 0) | 0;
	                            break
	                        }
	                        case 2:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127120, e | 0) | 0;
	                            break
	                        }
	                        case 6:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127152, e | 0) | 0;
	                            break
	                        }
	                        case 5:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127144, e | 0) | 0;
	                            break
	                        }
	                        case 10:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127216, e | 0) | 0;
	                            break
	                        }
	                        case 4:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127136, e | 0) | 0;
	                            break
	                        }
	                        case 7:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 127168, e | 0) | 0;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    do if (c[(c[g >> 2] | 0) + 52 >> 2] | 0) {
	                        c[j >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                        c[h >> 2] = 0;
	                        while (1) {
	                            if ((c[h >> 2] | 0) >= 5)break;
	                            b = c[c[f >> 2] >> 2] | 0;
	                            a = c[(c[j >> 2] | 0) + 4 >> 2] | 0;
	                            if (c[h >> 2] | 0) {
	                                c[e >> 2] = a;
	                                Ka(b | 0, 127232, e | 0) | 0
	                            } else {
	                                c[e >> 2] = a;
	                                Ka(b | 0, 127240, e | 0) | 0
	                            }
	                            c[j >> 2] = c[c[j >> 2] >> 2];
	                            if (!(c[j >> 2] | 0))break;
	                            c[h >> 2] = (c[h >> 2] | 0) + 1
	                        }
	                        b = c[c[f >> 2] >> 2] | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            Ka(b | 0, 126712, e | 0) | 0;
	                            break
	                        } else {
	                            Ka(b | 0, 127248, e | 0) | 0;
	                            break
	                        }
	                    } while (0);
	                    j = c[(c[g >> 2] | 0) + 44 >> 2] | 0;
	                    if ((j | 0) == 4)Ka(c[c[f >> 2] >> 2] | 0, 127288, e | 0) | 0; else if ((j | 0) == 2)Ka(c[c[f >> 2] >> 2] | 0, 127256, e | 0) | 0; else if ((j | 0) == 3)Ka(c[c[f >> 2] >> 2] | 0, 127272, e | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 48 >> 2] | 0) {
	                        Ka(c[c[f >> 2] >> 2] | 0, 127296, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 48 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 127296, e | 0) | 0
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                }
	                rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function xq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                oq(c[f >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 126624, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 17) {
	                    qq(c[f >> 2] | 0, 5026, 126656);
	                    i = d;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    if (!(c[b + 124 >> 2] | 0)) {
	                        Ka(c[c[f >> 2] >> 2] | 0, 126696, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126712, e | 0) | 0
	                    }
	                } else qq(b, 5015, 126720);
	                if (!(c[(c[f >> 2] | 0) + 124 >> 2] | 0)) {
	                    switch (c[(c[g >> 2] | 0) + 48 >> 2] | 0) {
	                        case 5:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 126824, e | 0) | 0;
	                            break
	                        }
	                        case 2:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 126768, e | 0) | 0;
	                            break
	                        }
	                        case 4:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 126808, e | 0) | 0;
	                            break
	                        }
	                        case 6:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 126848, e | 0) | 0;
	                            break
	                        }
	                        case 1:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 126752, e | 0) | 0;
	                            break
	                        }
	                        case 3:
	                        {
	                            Ka(c[c[f >> 2] >> 2] | 0, 126792, e | 0) | 0;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    if (c[(c[g >> 2] | 0) + 52 >> 2] | 0) {
	                        oq(c[f >> 2] | 0);
	                        b = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                        Ka(b | 0, 126864, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                        oq(c[f >> 2] | 0);
	                        b = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 56 >> 2];
	                        Ka(b | 0, 126880, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                        oq(c[f >> 2] | 0);
	                        b = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                        Ka(b | 0, 126896, e | 0) | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 40 >> 2] | 0) {
	                        oq(c[f >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 126912, e | 0) | 0;
	                        pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0
	                    }
	                }
	                rq(c[f >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function yq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                oq(c[f >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 125496, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                    qq(c[f >> 2] | 0, 5027, 125520);
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    b = c[f >> 2] | 0;
	                    if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                        Fq(b, 5028, 125560, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                        i = d;
	                        return
	                    } else {
	                        qq(b, 5028, 125600);
	                        i = d;
	                        return
	                    }
	                }
	                if (c[(c[f >> 2] | 0) + 124 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                b = c[c[f >> 2] >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                    Ka(b | 0, 125640, e | 0) | 0
	                } else Ka(b | 0, 125664, e | 0) | 0;
	                pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0;
	                i = d;
	                return
	            }

	            function zq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                e = (c[h >> 2] | 0) + 128 | 0;
	                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                e = c[(c[h >> 2] | 0) + 116 >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, 0, e, 24, h, 2, 0, 0, 0, 0, 0, 0, 0, j, g);
	                i = f;
	                return
	            }

	            function Aq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    yq(c[e >> 2] | 0, c[f >> 2] | 0);
	                    c[f >> 2] = c[c[f >> 2] >> 2]
	                }
	                i = d;
	                return
	            }

	            function Bq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                oq(c[f >> 2] | 0);
	                b = (c[(c[f >> 2] | 0) + 124 >> 2] | 0) != 0;
	                if (!(c[g >> 2] | 0)) {
	                    if (b) {
	                        i = d;
	                        return
	                    }
	                    Ka(c[c[f >> 2] >> 2] | 0, 126384, e | 0) | 0;
	                    i = d;
	                    return
	                }
	                if (b) {
	                    i = d;
	                    return
	                }
	                switch (c[(c[g >> 2] | 0) + 48 >> 2] | 0) {
	                    case 5:
	                    {
	                        Ka(c[c[f >> 2] >> 2] | 0, 126536, e | 0) | 0;
	                        break
	                    }
	                    case 2:
	                    {
	                        Ka(c[c[f >> 2] >> 2] | 0, 126432, e | 0) | 0;
	                        break
	                    }
	                    case 3:
	                    {
	                        Ka(c[c[f >> 2] >> 2] | 0, 126464, e | 0) | 0;
	                        break
	                    }
	                    case 4:
	                    {
	                        Ka(c[c[f >> 2] >> 2] | 0, 126504, e | 0) | 0;
	                        break
	                    }
	                    case 1:
	                    {
	                        Ka(c[c[f >> 2] >> 2] | 0, 126400, e | 0) | 0;
	                        break
	                    }
	                    default:
	                    {
	                        b = c[c[f >> 2] >> 2] | 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 48 >> 2];
	                        Ka(b | 0, 126568, e | 0) | 0
	                    }
	                }
	                b = c[c[f >> 2] >> 2] | 0;
	                c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                Ka(b | 0, 122096, e | 0) | 0;
	                if (c[(c[g >> 2] | 0) + 52 >> 2] | 0) {
	                    oq(c[f >> 2] | 0);
	                    b = c[c[f >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                    Ka(b | 0, 126584, e | 0) | 0
	                }
	                if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                    oq(c[f >> 2] | 0);
	                    b = c[c[f >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 56 >> 2];
	                    Ka(b | 0, 126600, e | 0) | 0
	                }
	                if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                    oq(c[f >> 2] | 0);
	                    b = c[c[f >> 2] >> 2] | 0;
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                    Ka(b | 0, 126616, e | 0) | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                oq(c[f >> 2] | 0);
	                Ka(c[c[f >> 2] >> 2] | 0, 126368, e | 0) | 0;
	                pq(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                Ka(c[c[f >> 2] >> 2] | 0, 121896, e | 0) | 0;
	                i = d;
	                return
	            }

	            function Cq(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = Gq(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                do if ((c[j >> 2] | 0) == -2) {
	                    g = c[f >> 2] | 0;
	                    if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                        qq(g, 5030, 125208);
	                        break
	                    } else {
	                        Fq(g, 5030, 125256, c[(c[h >> 2] | 0) + 12 >> 2] | 0);
	                        break
	                    }
	                } while (0);
	                if ((c[j >> 2] | 0) != -3) {
	                    i = e;
	                    return
	                }
	                j = c[f >> 2] | 0;
	                if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                    qq(j, 5031, 125304);
	                    i = e;
	                    return
	                } else {
	                    Fq(j, 5031, 125352, c[(c[h >> 2] | 0) + 12 >> 2] | 0);
	                    i = e;
	                    return
	                }
	            }

	            function Dq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 124 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (Fy(c[f >> 2] | 0) | 0) {
	                    i = d;
	                    return
	                }
	                Fq(c[e >> 2] | 0, 5032, 125184, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function Eq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[(c[e >> 2] | 0) + 124 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[f >> 2] | 0)) {
	                    qq(c[e >> 2] | 0, 5015, 125088);
	                    i = d;
	                    return
	                }
	                if (Gh(c[f >> 2] | 0, 0) | 0)Fq(c[e >> 2] | 0, 5034, 125104, c[f >> 2] | 0);
	                if (!(c[(c[e >> 2] | 0) + 120 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (CP(c[(c[e >> 2] | 0) + 120 >> 2] | 0, c[f >> 2] | 0) | 0) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 112 >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 112 >> 2] | 0) + 88 >> 2] & 4608 | 0) != 0 : 0) {
	                    i = d;
	                    return
	                }
	                Fq(c[e >> 2] | 0, 5035, 125136, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function Fq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                e = (c[h >> 2] | 0) + 128 | 0;
	                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                e = c[(c[h >> 2] | 0) + 116 >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, 0, e, 24, h, 2, 0, 0, 0, 0, 0, 0, 0, j, g);
	                i = f;
	                return
	            }

	            function Gq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) {
	                    c[e >> 2] = -2;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                a:while (1) {
	                    if (c[f >> 2] | 0)if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 : 0)l = (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 19; else l = 1; else l = 0;
	                    m = c[f >> 2] | 0;
	                    if (!l) {
	                        n = 26;
	                        break
	                    }
	                    if (!((c[m + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0))n = 18;
	                    b:do if ((n | 0) == 18) {
	                        n = 0;
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                        while (1) {
	                            if (!(c[h >> 2] | 0))break b;
	                            if ((c[h >> 2] | 0) == (c[g >> 2] | 0)) {
	                                n = 21;
	                                break a
	                            }
	                            if (qy(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0) {
	                                n = 23;
	                                break a
	                            }
	                            c[h >> 2] = c[c[h >> 2] >> 2]
	                        }
	                    } while (0);
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2]
	                }
	                if ((n | 0) == 21) {
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else if ((n | 0) == 23) {
	                    c[e >> 2] = -2;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else if ((n | 0) == 26) {
	                    do if (m) {
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 13 : 0)break;
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                        if ((c[j >> 2] | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 1;
	                            k = c[e >> 2] | 0;
	                            i = d;
	                            return k | 0
	                        }
	                    } while (0);
	                    c[e >> 2] = -3;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function Hq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 8 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d;
	                l = f;
	                c[l >> 2] = a;
	                c[l + 4 >> 2] = b;
	                b = f;
	                l = Ha(c[b >> 2] | 0, c[b + 4 >> 2] | 0, 0) | 0;
	                c[g >> 2] = 64 - l;
	                c[h >> 2] = ((c[g >> 2] | 0) > 6 ? c[g >> 2] | 0 : 6) - 6;
	                g = f;
	                l = dU(c[g >> 2] | 0, c[g + 4 >> 2] | 0, c[h >> 2] | 0) | 0;
	                c[j >> 2] = l;
	                l = $T(1, 0, c[h >> 2] | 0) | 0;
	                h = XT(l | 0, G | 0, 1, 0) | 0;
	                l = k;
	                c[l >> 2] = h;
	                c[l + 4 >> 2] = G;
	                l = k;
	                k = f;
	                f = c[j >> 2] | 0;
	                if ((c[l >> 2] & c[k >> 2] | 0) != 0 ? 1 : (c[l + 4 >> 2] & c[k + 4 >> 2] | 0) != 0) {
	                    c[e >> 2] = f + 1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else {
	                    c[e >> 2] = f;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function Iq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                Ss(c[e >> 2] | 0, 1, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function Jq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 2112 | 0;
	                e = d + 2096 | 0;
	                f = d + 2092 | 0;
	                g = d + 2088 | 0;
	                h = d + 2076 | 0;
	                j = d + 24 | 0;
	                k = d + 2072 | 0;
	                l = d + 16 | 0;
	                m = d + 8 | 0;
	                n = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[k >> 2] = 0;
	                b = n;
	                c[b >> 2] = 0;
	                c[b + 4 >> 2] = 0;
	                if ((c[f >> 2] | 0) >>> 0 < 64) {
	                    Iq(c[e >> 2] | 0, c[f >> 2] | 0);
	                    i = d;
	                    return
	                }
	                c[g >> 2] = Hq(c[f >> 2] | 0, 0) | 0;
	                c[h >> 2] = d + 2080;
	                c[c[h >> 2] >> 2] = 0;
	                c[(c[h >> 2] | 0) + 4 >> 2] = 0;
	                b = n;
	                a = Ts(c[e >> 2] | 0, c[b >> 2] | 0, c[b + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                b = l;
	                c[b >> 2] = a;
	                c[b + 4 >> 2] = G;
	                b = c[g >> 2] | 0;
	                a = m;
	                c[a >> 2] = b;
	                c[a + 4 >> 2] = ((b | 0) < 0) << 31 >> 31;
	                b = m;
	                a = c[b + 4 >> 2] | 0;
	                o = c[g >> 2] | 0;
	                p = ((o | 0) < 0) << 31 >> 31;
	                if ((a | 0) < (p | 0) | ((a | 0) == (p | 0) ? (c[b >> 2] | 0) >>> 0 < o >>> 0 : 0)) {
	                    o = c[g >> 2] | 0;
	                    b = m;
	                    c[b >> 2] = o;
	                    c[b + 4 >> 2] = ((o | 0) < 0) << 31 >> 31
	                }
	                o = m;
	                b = c[o >> 2] | 0;
	                p = c[o + 4 >> 2] | 0;
	                o = n;
	                a = XT(c[f >> 2] | 0, 0, c[o >> 2] | 0, c[o + 4 >> 2] | 0) | 0;
	                o = G;
	                if ((p | 0) > (o | 0) | (p | 0) == (o | 0) & b >>> 0 > a >>> 0) {
	                    a = n;
	                    b = XT(c[f >> 2] | 0, 0, c[a >> 2] | 0, c[a + 4 >> 2] | 0) | 0;
	                    a = m;
	                    c[a >> 2] = b;
	                    c[a + 4 >> 2] = G
	                }
	                a = m;
	                b = c[a + 4 >> 2] | 0;
	                o = l;
	                p = c[o + 4 >> 2] | 0;
	                if ((b | 0) > (p | 0) | ((b | 0) == (p | 0) ? (c[a >> 2] | 0) >>> 0 > (c[o >> 2] | 0) >>> 0 : 0)) {
	                    Ss((c[e >> 2] | 0) + (c[n >> 2] << 2) | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                    o = m;
	                    a = c[o + 4 >> 2] | 0;
	                    p = l;
	                    c[p >> 2] = c[o >> 2];
	                    c[p + 4 >> 2] = a
	                }
	                a = n;
	                p = c[a + 4 >> 2] | 0;
	                o = j + (c[k >> 2] << 4) | 0;
	                c[o >> 2] = c[a >> 2];
	                c[o + 4 >> 2] = p;
	                p = l;
	                o = c[p + 4 >> 2] | 0;
	                a = j + (c[k >> 2] << 4) + 8 | 0;
	                c[a >> 2] = c[p >> 2];
	                c[a + 4 >> 2] = o;
	                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                o = l;
	                a = n;
	                p = bU(c[a >> 2] | 0, c[a + 4 >> 2] | 0, c[o >> 2] | 0, c[o + 4 >> 2] | 0) | 0;
	                o = n;
	                c[o >> 2] = p;
	                c[o + 4 >> 2] = G;
	                o = n;
	                if ((c[o + 4 >> 2] | 0) == 0 ? (c[o >> 2] | 0) == (c[f >> 2] | 0) : 0) {
	                    while (1) {
	                        if ((c[k >> 2] | 0) <= 1)break;
	                        Us(c[e >> 2] | 0, j, c[k >> 2] | 0, c[h >> 2] | 0);
	                        o = j + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                        p = j + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                        a = p;
	                        b = bU(c[a >> 2] | 0, c[a + 4 >> 2] | 0, c[o >> 2] | 0, c[o + 4 >> 2] | 0) | 0;
	                        o = p;
	                        c[o >> 2] = b;
	                        c[o + 4 >> 2] = G;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    jT(c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 0;
	                    i = d;
	                    return
	                }
	                o = n;
	                b = Ts(c[e >> 2] | 0, c[o >> 2] | 0, c[o + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                o = l;
	                c[o >> 2] = b;
	                c[o + 4 >> 2] = G;
	                o = c[g >> 2] | 0;
	                b = m;
	                c[b >> 2] = o;
	                c[b + 4 >> 2] = ((o | 0) < 0) << 31 >> 31;
	                o = m;
	                b = c[o + 4 >> 2] | 0;
	                p = c[g >> 2] | 0;
	                a = ((p | 0) < 0) << 31 >> 31;
	                if ((b | 0) < (a | 0) | ((b | 0) == (a | 0) ? (c[o >> 2] | 0) >>> 0 < p >>> 0 : 0)) {
	                    p = c[g >> 2] | 0;
	                    o = m;
	                    c[o >> 2] = p;
	                    c[o + 4 >> 2] = ((p | 0) < 0) << 31 >> 31
	                }
	                p = m;
	                o = c[p >> 2] | 0;
	                a = c[p + 4 >> 2] | 0;
	                p = n;
	                b = XT(c[f >> 2] | 0, 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                p = G;
	                if ((a | 0) > (p | 0) | (a | 0) == (p | 0) & o >>> 0 > b >>> 0) {
	                    b = n;
	                    o = XT(c[f >> 2] | 0, 0, c[b >> 2] | 0, c[b + 4 >> 2] | 0) | 0;
	                    b = m;
	                    c[b >> 2] = o;
	                    c[b + 4 >> 2] = G
	                }
	                b = m;
	                o = c[b + 4 >> 2] | 0;
	                p = l;
	                a = c[p + 4 >> 2] | 0;
	                if ((o | 0) > (a | 0) | ((o | 0) == (a | 0) ? (c[b >> 2] | 0) >>> 0 > (c[p >> 2] | 0) >>> 0 : 0)) {
	                    Ss((c[e >> 2] | 0) + (c[n >> 2] << 2) | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                    p = m;
	                    b = c[p + 4 >> 2] | 0;
	                    a = l;
	                    c[a >> 2] = c[p >> 2];
	                    c[a + 4 >> 2] = b
	                }
	                b = n;
	                a = c[b + 4 >> 2] | 0;
	                p = j + (c[k >> 2] << 4) | 0;
	                c[p >> 2] = c[b >> 2];
	                c[p + 4 >> 2] = a;
	                a = l;
	                p = c[a + 4 >> 2] | 0;
	                b = j + (c[k >> 2] << 4) + 8 | 0;
	                c[b >> 2] = c[a >> 2];
	                c[b + 4 >> 2] = p;
	                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                p = l;
	                b = n;
	                a = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                p = n;
	                c[p >> 2] = a;
	                c[p + 4 >> 2] = G;
	                p = n;
	                if ((c[p + 4 >> 2] | 0) == 0 ? (c[p >> 2] | 0) == (c[f >> 2] | 0) : 0) {
	                    while (1) {
	                        if ((c[k >> 2] | 0) <= 1)break;
	                        Us(c[e >> 2] | 0, j, c[k >> 2] | 0, c[h >> 2] | 0);
	                        p = j + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                        a = j + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                        b = a;
	                        o = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                        p = a;
	                        c[p >> 2] = o;
	                        c[p + 4 >> 2] = G;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    jT(c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 0;
	                    i = d;
	                    return
	                }
	                p = n;
	                o = Ts(c[e >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                p = l;
	                c[p >> 2] = o;
	                c[p + 4 >> 2] = G;
	                p = c[g >> 2] | 0;
	                o = m;
	                c[o >> 2] = p;
	                c[o + 4 >> 2] = ((p | 0) < 0) << 31 >> 31;
	                p = m;
	                o = c[p + 4 >> 2] | 0;
	                a = c[g >> 2] | 0;
	                b = ((a | 0) < 0) << 31 >> 31;
	                if ((o | 0) < (b | 0) | ((o | 0) == (b | 0) ? (c[p >> 2] | 0) >>> 0 < a >>> 0 : 0)) {
	                    a = c[g >> 2] | 0;
	                    p = m;
	                    c[p >> 2] = a;
	                    c[p + 4 >> 2] = ((a | 0) < 0) << 31 >> 31
	                }
	                a = m;
	                p = c[a >> 2] | 0;
	                b = c[a + 4 >> 2] | 0;
	                a = n;
	                o = XT(c[f >> 2] | 0, 0, c[a >> 2] | 0, c[a + 4 >> 2] | 0) | 0;
	                a = G;
	                if ((b | 0) > (a | 0) | (b | 0) == (a | 0) & p >>> 0 > o >>> 0) {
	                    o = n;
	                    p = XT(c[f >> 2] | 0, 0, c[o >> 2] | 0, c[o + 4 >> 2] | 0) | 0;
	                    o = m;
	                    c[o >> 2] = p;
	                    c[o + 4 >> 2] = G
	                }
	                o = m;
	                p = c[o + 4 >> 2] | 0;
	                a = l;
	                b = c[a + 4 >> 2] | 0;
	                if ((p | 0) > (b | 0) | ((p | 0) == (b | 0) ? (c[o >> 2] | 0) >>> 0 > (c[a >> 2] | 0) >>> 0 : 0)) {
	                    Ss((c[e >> 2] | 0) + (c[n >> 2] << 2) | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                    a = m;
	                    o = c[a + 4 >> 2] | 0;
	                    b = l;
	                    c[b >> 2] = c[a >> 2];
	                    c[b + 4 >> 2] = o
	                }
	                o = n;
	                b = c[o + 4 >> 2] | 0;
	                a = j + (c[k >> 2] << 4) | 0;
	                c[a >> 2] = c[o >> 2];
	                c[a + 4 >> 2] = b;
	                b = l;
	                a = c[b + 4 >> 2] | 0;
	                o = j + (c[k >> 2] << 4) + 8 | 0;
	                c[o >> 2] = c[b >> 2];
	                c[o + 4 >> 2] = a;
	                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                a = l;
	                o = n;
	                b = bU(c[o >> 2] | 0, c[o + 4 >> 2] | 0, c[a >> 2] | 0, c[a + 4 >> 2] | 0) | 0;
	                a = n;
	                c[a >> 2] = b;
	                c[a + 4 >> 2] = G;
	                a = n;
	                if ((c[a + 4 >> 2] | 0) == 0 ? (c[a >> 2] | 0) == (c[f >> 2] | 0) : 0) {
	                    while (1) {
	                        if ((c[k >> 2] | 0) <= 1)break;
	                        Us(c[e >> 2] | 0, j, c[k >> 2] | 0, c[h >> 2] | 0);
	                        a = j + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                        b = j + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                        o = b;
	                        p = bU(c[o >> 2] | 0, c[o + 4 >> 2] | 0, c[a >> 2] | 0, c[a + 4 >> 2] | 0) | 0;
	                        a = b;
	                        c[a >> 2] = p;
	                        c[a + 4 >> 2] = G;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    jT(c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 0;
	                    i = d;
	                    return
	                }
	                while (1) {
	                    a = (Vs(j, c[k >> 2] | 0) | 0) != 0;
	                    p = c[e >> 2] | 0;
	                    if (!a) {
	                        c[k >> 2] = Ws(p, j, c[k >> 2] | 0, c[h >> 2] | 0, c[f >> 2] | 0) | 0;
	                        continue
	                    }
	                    a = n;
	                    b = Ts(p, c[a >> 2] | 0, c[a + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                    a = l;
	                    c[a >> 2] = b;
	                    c[a + 4 >> 2] = G;
	                    a = c[g >> 2] | 0;
	                    b = m;
	                    c[b >> 2] = a;
	                    c[b + 4 >> 2] = ((a | 0) < 0) << 31 >> 31;
	                    a = m;
	                    b = c[a + 4 >> 2] | 0;
	                    p = c[g >> 2] | 0;
	                    o = ((p | 0) < 0) << 31 >> 31;
	                    if ((b | 0) < (o | 0) | ((b | 0) == (o | 0) ? (c[a >> 2] | 0) >>> 0 < p >>> 0 : 0)) {
	                        p = c[g >> 2] | 0;
	                        a = m;
	                        c[a >> 2] = p;
	                        c[a + 4 >> 2] = ((p | 0) < 0) << 31 >> 31
	                    }
	                    p = m;
	                    a = c[p >> 2] | 0;
	                    o = c[p + 4 >> 2] | 0;
	                    p = n;
	                    b = XT(c[f >> 2] | 0, 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                    p = G;
	                    if ((o | 0) > (p | 0) | (o | 0) == (p | 0) & a >>> 0 > b >>> 0) {
	                        b = n;
	                        a = XT(c[f >> 2] | 0, 0, c[b >> 2] | 0, c[b + 4 >> 2] | 0) | 0;
	                        b = m;
	                        c[b >> 2] = a;
	                        c[b + 4 >> 2] = G
	                    }
	                    b = m;
	                    a = c[b + 4 >> 2] | 0;
	                    p = l;
	                    o = c[p + 4 >> 2] | 0;
	                    if ((a | 0) > (o | 0) | ((a | 0) == (o | 0) ? (c[b >> 2] | 0) >>> 0 > (c[p >> 2] | 0) >>> 0 : 0)) {
	                        Ss((c[e >> 2] | 0) + (c[n >> 2] << 2) | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                        p = m;
	                        b = c[p + 4 >> 2] | 0;
	                        o = l;
	                        c[o >> 2] = c[p >> 2];
	                        c[o + 4 >> 2] = b
	                    }
	                    b = n;
	                    o = c[b + 4 >> 2] | 0;
	                    p = j + (c[k >> 2] << 4) | 0;
	                    c[p >> 2] = c[b >> 2];
	                    c[p + 4 >> 2] = o;
	                    o = l;
	                    p = c[o + 4 >> 2] | 0;
	                    b = j + (c[k >> 2] << 4) + 8 | 0;
	                    c[b >> 2] = c[o >> 2];
	                    c[b + 4 >> 2] = p;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    p = l;
	                    b = n;
	                    o = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                    p = n;
	                    c[p >> 2] = o;
	                    c[p + 4 >> 2] = G;
	                    p = n;
	                    if ((c[p + 4 >> 2] | 0) == 0 ? (c[p >> 2] | 0) == (c[f >> 2] | 0) : 0)break
	                }
	                while (1) {
	                    if ((c[k >> 2] | 0) <= 1)break;
	                    Us(c[e >> 2] | 0, j, c[k >> 2] | 0, c[h >> 2] | 0);
	                    f = j + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                    n = j + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                    l = n;
	                    m = bU(c[l >> 2] | 0, c[l + 4 >> 2] | 0, c[f >> 2] | 0, c[f + 4 >> 2] | 0) | 0;
	                    f = n;
	                    c[f >> 2] = m;
	                    c[f + 4 >> 2] = G;
	                    c[k >> 2] = (c[k >> 2] | 0) + -1
	                }
	                if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                jT(c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                c[(c[h >> 2] | 0) + 4 >> 2] = 0;
	                i = d;
	                return
	            }

	            function Kq() {
	                var a = 0;
	                a = i;
	                if (c[31974] | 0) {
	                    i = a;
	                    return
	                }
	                h[15985] = +Xs();
	                h[15986] = +Ys();
	                h[15984] = +Zs();
	                h[15988] = +_s();
	                c[31974] = 1;
	                i = a;
	                return
	            }

	            function Lq(a) {
	                a = +a;
	                var b = 0, c = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                c = b;
	                h[c >> 3] = a;
	                d = $s(+h[c >> 3]) | 0;
	                i = b;
	                return d | 0
	            }

	            function Mq(a) {
	                a = +a;
	                var b = 0, c = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                c = b;
	                h[c >> 3] = a;
	                d = at(+h[c >> 3]) | 0;
	                i = b;
	                return d | 0
	            }

	            function Nq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[g >> 2] = (c[g >> 2] | 0) < 0 | (c[g >> 2] | 0) > 25 ? 25 : b;
	                b = c[g >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = c[127920 + (c[g >> 2] << 2) >> 2];
	                    Xd(0, 0, 0, 0, 0, 12, b + 1200 - 0 | 0, 2, 0, 0, 0, 0, 0, 0, 0, 127912, e);
	                    i = d;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 8 >> 2] = b;
	                if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                    b = (c[g >> 2] | 0) + 1200 - 0 | 0;
	                    a = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                    h = (c[c[f >> 2] >> 2] | 0) - (c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[e >> 2] = c[127920 + (c[g >> 2] << 2) >> 2];
	                    Xd(0, 0, 0, 0, 0, 12, b, 2, 0, 0, a, 0, 0, h, 0, 127912, e);
	                    i = d;
	                    return
	                }
	                Yd((c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 136 | 0);
	                c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 136 >> 2] = 12;
	                c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 140 >> 2] = (c[g >> 2] | 0) + 1200 - 0;
	                c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 148 >> 2] = 2;
	                h = my(c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 160 >> 2] = h;
	                c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 172 >> 2] = (c[c[f >> 2] >> 2] | 0) - (c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 184 >> 2] = c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 188 >> 2];
	                h = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                if (c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 132 >> 2] | 0) {
	                    Ab[c[h + 132 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 128 >> 2] | 0, (c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 136 | 0);
	                    i = d;
	                    return
	                } else {
	                    a = c[h + 188 >> 2] | 0;
	                    h = (c[g >> 2] | 0) + 1200 - 0 | 0;
	                    b = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                    j = (c[c[f >> 2] >> 2] | 0) - (c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[e >> 2] = c[127920 + (c[g >> 2] << 2) >> 2];
	                    Xd(0, 0, 0, 0, a, 12, h, 2, 0, 0, b, 0, 0, j, 0, 127912, e);
	                    i = d;
	                    return
	                }
	            }

	            function Oq(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f;
	                c[g >> 2] = a;
	                c[f + 8 >> 2] = b;
	                c[f + 4 >> 2] = d;
	                c[h >> 2] = e;
	                Nq(c[g >> 2] | 0, c[h >> 2] | 0);
	                i = f;
	                return
	            }

	            function Pq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                a = (c[(c[d >> 2] | 0) + 20 >> 2] | 0) == 0;
	                c[f >> 2] = 0;
	                a:do if (a)while (1) {
	                    if ((c[f >> 2] | 0) >= (c[c[d >> 2] >> 2] | 0))break a;
	                    c[e >> 2] = (c[(c[d >> 2] | 0) + 8 >> 2] | 0) + ((c[f >> 2] | 0) * 40 | 0);
	                    do if (c[(c[e >> 2] | 0) + 24 >> 2] | 0)if ((c[c[e >> 2] >> 2] | 0) == 12) {
	                        Qq(c[(c[e >> 2] | 0) + 24 >> 2] | 0);
	                        break
	                    } else {
	                        zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 24 >> 2] | 0);
	                        break
	                    } while (0);
	                    if (c[(c[e >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 28 >> 2] | 0);
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                } else {
	                    while (1) {
	                        if ((c[f >> 2] | 0) >= (c[c[d >> 2] >> 2] | 0))break;
	                        c[e >> 2] = (c[(c[d >> 2] | 0) + 8 >> 2] | 0) + ((c[f >> 2] | 0) * 40 | 0);
	                        if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != 0 ? (c[c[e >> 2] >> 2] | 0) == 12 : 0)Qq(c[(c[e >> 2] | 0) + 24 >> 2] | 0);
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    zP(c[(c[d >> 2] | 0) + 20 >> 2] | 0)
	                } while (0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)FQ(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Qq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                do if ((c[c[d >> 2] >> 2] | 0) != 1 ? (c[c[d >> 2] >> 2] | 0) != 9 : 0) {
	                    a = c[d >> 2] | 0;
	                    if ((c[c[d >> 2] >> 2] | 0) == 7) {
	                        if (!(c[a + 28 >> 2] | 0))break;
	                        ev(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                        break
	                    }
	                    if ((c[a >> 2] | 0) == 4 ? (c[(c[d >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0)
	                } else e = 4; while (0);
	                do if ((e | 0) == 4) {
	                    a = c[d >> 2] | 0;
	                    if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                        c[a >> 2] = 9;
	                        if (!(c[(c[d >> 2] | 0) + 4 >> 2] | 0))break;
	                        bt(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                        break
	                    } else {
	                        if (!(c[a + 4 >> 2] | 0))break;
	                        fr(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                        break
	                    }
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Rq(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, j = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f;
	                j = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 24 | 0;
	                c[j >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[n >> 2] = 0;
	                while (1) {
	                    p = o + ((c[n >> 2] << 1) + 1) | 0;
	                    if (!((c[n >> 2] | 0) < 25 ? (c[n >> 2] | 0) < (c[m >> 2] | 0) : 0))break;
	                    a[p >> 0] = 32;
	                    a[o + (c[n >> 2] << 1) >> 0] = 32;
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                }
	                a[p >> 0] = 0;
	                a[o + (c[n >> 2] << 1) >> 0] = 0;
	                n = c[j >> 2] | 0;
	                c[g >> 2] = o;
	                Ka(n | 0, 127912, g | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    Ka(c[j >> 2] | 0, 128024, g | 0) | 0;
	                    i = f;
	                    return
	                }
	                do switch (c[c[l >> 2] >> 2] | 0) {
	                    case 5:
	                    {
	                        n = c[j >> 2] | 0;
	                        c[g >> 2] = c[(c[l >> 2] | 0) + 32 >> 2];
	                        Ka(n | 0, 128360, g | 0) | 0;
	                        ft(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 28 >> 2] | 0, (c[m >> 2] | 0) + 1 | 0);
	                        Ka(c[j >> 2] | 0, 128352, g | 0) | 0;
	                        i = f;
	                        return
	                    }
	                    case 6:
	                    {
	                        do if (c[(c[l >> 2] | 0) + 36 >> 2] | 0) {
	                            if ((c[(c[l >> 2] | 0) + 36 >> 2] | 0) == (c[(c[l >> 2] | 0) + 28 >> 2] | 0) ? (c[(c[l >> 2] | 0) + 32 >> 2] | 0) == (c[(c[l >> 2] | 0) + 40 >> 2] | 0) : 0)break;
	                            Ka(c[j >> 2] | 0, 128456, g | 0) | 0;
	                            n = c[j >> 2] | 0;
	                            c[g >> 2] = o;
	                            Ka(n | 0, 127912, g | 0) | 0;
	                            Ka(c[j >> 2] | 0, 128480, g | 0) | 0;
	                            if ((c[(c[l >> 2] | 0) + 32 >> 2] | 0) >= 0) {
	                                n = c[j >> 2] | 0;
	                                c[g >> 2] = c[(c[l >> 2] | 0) + 32 >> 2];
	                                Ka(n | 0, 128432, g | 0) | 0
	                            }
	                            Ka(c[j >> 2] | 0, 128448, g | 0) | 0;
	                            ft(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 28 >> 2] | 0, (c[m >> 2] | 0) + 1 | 0);
	                            n = c[j >> 2] | 0;
	                            c[g >> 2] = o;
	                            Ka(n | 0, 127912, g | 0) | 0;
	                            Ka(c[j >> 2] | 0, 128488, g | 0) | 0;
	                            if ((c[(c[l >> 2] | 0) + 40 >> 2] | 0) >= 0) {
	                                n = c[j >> 2] | 0;
	                                c[g >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                                Ka(n | 0, 128432, g | 0) | 0
	                            }
	                            Ka(c[j >> 2] | 0, 128448, g | 0) | 0;
	                            ft(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0, (c[m >> 2] | 0) + 1 | 0);
	                            Ka(c[j >> 2] | 0, 128352, g | 0) | 0;
	                            i = f;
	                            return
	                        } while (0);
	                        Ka(c[j >> 2] | 0, 128400, g | 0) | 0;
	                        n = c[j >> 2] | 0;
	                        c[g >> 2] = o;
	                        Ka(n | 0, 127912, g | 0) | 0;
	                        if ((c[(c[l >> 2] | 0) + 32 >> 2] | 0) >= 0) {
	                            n = c[j >> 2] | 0;
	                            c[g >> 2] = c[(c[l >> 2] | 0) + 32 >> 2];
	                            Ka(n | 0, 128432, g | 0) | 0
	                        }
	                        Ka(c[j >> 2] | 0, 128448, g | 0) | 0;
	                        ft(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 28 >> 2] | 0, (c[m >> 2] | 0) + 1 | 0);
	                        i = f;
	                        return
	                    }
	                    case 9:
	                    {
	                        Ka(c[j >> 2] | 0, 128104, g | 0) | 0;
	                        dt(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                    case 0:
	                    {
	                        Ka(c[j >> 2] | 0, 128048, g | 0) | 0;
	                        i = f;
	                        return
	                    }
	                    case 4:
	                    {
	                        Ka(c[j >> 2] | 0, 128328, g | 0) | 0;
	                        Hp(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 24 >> 2] | 0);
	                        Ka(c[j >> 2] | 0, 128352, g | 0) | 0;
	                        i = f;
	                        return
	                    }
	                    case 3:
	                    {
	                        n = Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0;
	                        if ((n | 0) == -1) {
	                            Ka(c[j >> 2] | 0, 128208, g | 0) | 0;
	                            i = f;
	                            return
	                        } else if ((n | 0) == 1) {
	                            Ka(c[j >> 2] | 0, 128176, g | 0) | 0;
	                            i = f;
	                            return
	                        } else {
	                            if (Lq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) {
	                                Ka(c[j >> 2] | 0, 128240, g | 0) | 0;
	                                i = f;
	                                return
	                            }
	                            if (+h[(c[l >> 2] | 0) + 16 >> 3] == 0.0 ? (et(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) != 0 : 0) {
	                                Ka(c[j >> 2] | 0, 128272, g | 0) | 0;
	                                i = f;
	                                return
	                            }
	                            n = c[j >> 2] | 0;
	                            h[k >> 3] = +h[(c[l >> 2] | 0) + 16 >> 3];
	                            c[g >> 2] = c[k >> 2];
	                            c[g + 4 >> 2] = c[k + 4 >> 2];
	                            Ka(n | 0, 128296, g | 0) | 0;
	                            i = f;
	                            return
	                        }
	                        break
	                    }
	                    case 7:
	                    {
	                        Ka(c[j >> 2] | 0, 128496, g | 0) | 0;
	                        gt(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 28 >> 2] | 0, c[m >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                    case 8:
	                    {
	                        Ka(c[j >> 2] | 0, 128528, g | 0) | 0;
	                        i = f;
	                        return
	                    }
	                    case 1:
	                    {
	                        Ka(c[j >> 2] | 0, 128080, g | 0) | 0;
	                        ct(c[j >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                    case 2:
	                    {
	                        Ka(c[j >> 2] | 0, 128136, g | 0) | 0;
	                        n = c[j >> 2] | 0;
	                        if (c[(c[l >> 2] | 0) + 8 >> 2] | 0) {
	                            Ka(n | 0, 128160, g | 0) | 0;
	                            i = f;
	                            return
	                        } else {
	                            Ka(n | 0, 128168, g | 0) | 0;
	                            i = f;
	                            return
	                        }
	                        break
	                    }
	                    default:
	                    {
	                        i = f;
	                        return
	                    }
	                } while (0)
	            }

	            function Sq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) > 0 : 0) {
	                    a = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) <= (c[(c[e >> 2] | 0) + 44 >> 2] | 0)) {
	                        Oq(a, 128552, 2830, 23);
	                        c[d >> 2] = 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    h = a + 20 | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + -1;
	                    h = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 16 >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[h + 20 >> 2] | 0) - 1 << 2) >> 2]; else c[h + 16 >> 2] = 0;
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + (c[(c[e >> 2] | 0) + 20 >> 2] << 2) >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + (c[(c[e >> 2] | 0) + 20 >> 2] << 2) >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Tq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                do if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 24 >> 2] | 0)) {
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) >= 1e6) {
	                        it(0, 128576);
	                        c[(c[f >> 2] | 0) + 8 >> 2] = 15;
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 28 >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] << 1 << 2) | 0;
	                    if (c[h >> 2] | 0) {
	                        b = (c[f >> 2] | 0) + 24 | 0;
	                        c[b >> 2] = c[b >> 2] << 1;
	                        c[(c[f >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                        break
	                    }
	                    it(0, 128616);
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 15;
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + (c[(c[f >> 2] | 0) + 20 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 20 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Uq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Sq(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Oq(c[e >> 2] | 0, 128552, 2896, 10);
	                    if (c[e >> 2] | 0)c[(c[e >> 2] | 0) + 8 >> 2] = 10;
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a = c[f >> 2] | 0;
	                if ((c[c[f >> 2] >> 2] | 0) != 2)c[g >> 2] = Vq(a) | 0; else c[g >> 2] = c[a + 8 >> 2];
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[f >> 2] | 0);
	                c[d >> 2] = c[g >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Vq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                switch (c[c[f >> 2] >> 2] | 0) {
	                    case 2:
	                    {
	                        c[g >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                    case 4:
	                    {
	                        c[g >> 2] = Jr(c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[g >> 2] = Ir(+h[(c[f >> 2] | 0) + 16 >> 3]) | 0;
	                        break
	                    }
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 8:
	                    {
	                        a = c[33976] | 0;
	                        k = c[33980] | 0;
	                        c[d >> 2] = 128552;
	                        c[d + 4 >> 2] = 6066;
	                        Db[a & 511](k, 129064, d);
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    case 9:
	                    case 1:
	                    {
	                        c[g >> 2] = Kr(c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 0:
	                    {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                c[e >> 2] = c[g >> 2];
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function Wq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0.0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 24 | 0;
	                g = b;
	                c[f >> 2] = a;
	                h[g >> 3] = 0.0;
	                if (!(c[f >> 2] | 0)) {
	                    h[e >> 3] = +h[15984];
	                    j = +h[e >> 3];
	                    i = b;
	                    return +j
	                }
	                switch (c[c[f >> 2] >> 2] | 0) {
	                    case 0:
	                    {
	                        h[g >> 3] = +h[15984];
	                        break
	                    }
	                    case 2:
	                    {
	                        h[g >> 3] = +Dr(c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    case 4:
	                    {
	                        h[g >> 3] = +Er(c[(c[f >> 2] | 0) + 24 >> 2] | 0);
	                        break
	                    }
	                    case 3:
	                    {
	                        h[g >> 3] = +h[(c[f >> 2] | 0) + 16 >> 3];
	                        break
	                    }
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 8:
	                    {
	                        a = c[33976] | 0;
	                        k = c[33980] | 0;
	                        c[d >> 2] = 128552;
	                        c[d + 4 >> 2] = 5954;
	                        Db[a & 511](k, 129064, d);
	                        h[g >> 3] = +h[15984];
	                        break
	                    }
	                    case 9:
	                    case 1:
	                    {
	                        h[g >> 3] = +Hr(c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                h[e >> 3] = +h[g >> 3];
	                j = +h[e >> 3];
	                i = b;
	                return +j
	            }

	            function Xq(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                a:while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (a = (c[f >> 2] | 0) + 1 | 0, c[f >> 2] = a, c[(c[g >> 2] | 0) + 40 >> 2] = 0 - a, (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        continue
	                    }
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                        if (!(c[g >> 2] | 0))continue a;
	                        if ((c[g >> 2] | 0) == (c[e >> 2] | 0)) {
	                            j = 12;
	                            break
	                        }
	                        k = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            j = 14;
	                            break
	                        }
	                        if (!k)continue a
	                    }
	                    if ((j | 0) == 12) {
	                        j = 0;
	                        c[g >> 2] = 0;
	                        continue
	                    } else if ((j | 0) == 14) {
	                        j = 0;
	                        c[g >> 2] = c[k + 24 >> 2];
	                        continue
	                    }
	                }
	                c[d >> 2] = c[f >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Yq(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 56 | 0;
	                f = d + 52 | 0;
	                g = d + 48 | 0;
	                h = d + 44 | 0;
	                j = d + 40 | 0;
	                k = d + 36 | 0;
	                l = d + 32 | 0;
	                m = d + 28 | 0;
	                n = d + 24 | 0;
	                o = d + 20 | 0;
	                p = d + 16 | 0;
	                q = d + 12 | 0;
	                r = d + 8 | 0;
	                s = d + 4 | 0;
	                t = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -2;
	                    u = c[e >> 2] | 0;
	                    i = d;
	                    return u | 0
	                }
	                if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    u = c[e >> 2] | 0;
	                    i = d;
	                    return u | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                    c[k >> 2] = 1;
	                    c[m >> 2] = c[f >> 2];
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2]
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                    c[l >> 2] = 1;
	                    c[n >> 2] = c[g >> 2];
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2]
	                }
	                if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                    if ((c[k >> 2] | 0) != (c[l >> 2] | 0))if ((c[l >> 2] | 0) == 1) {
	                        c[e >> 2] = 1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    } else {
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    c[o >> 2] = c[(c[n >> 2] | 0) + 28 >> 2];
	                    while (1) {
	                        if (!(c[o >> 2] | 0)) {
	                            v = 17;
	                            break
	                        }
	                        if ((c[o >> 2] | 0) == (c[m >> 2] | 0)) {
	                            v = 15;
	                            break
	                        }
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 28 >> 2]
	                    }
	                    if ((v | 0) == 15) {
	                        c[e >> 2] = 1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    } else if ((v | 0) == 17) {
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                }
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[f >> 2] | 0) == (c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    if ((c[f >> 2] | 0) == (c[(c[g >> 2] | 0) + 24 >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    if (((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? 0 > (c[(c[f >> 2] | 0) + 40 >> 2] | 0) : 0) ? 0 > (c[(c[g >> 2] | 0) + 40 >> 2] | 0) : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == (c[(c[g >> 2] | 0) + 32 >> 2] | 0) : 0) {
	                        c[q >> 2] = 0 - (c[(c[f >> 2] | 0) + 40 >> 2] | 0);
	                        c[r >> 2] = 0 - (c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        if ((c[q >> 2] | 0) < (c[r >> 2] | 0)) {
	                            c[e >> 2] = 1;
	                            u = c[e >> 2] | 0;
	                            i = d;
	                            return u | 0
	                        }
	                        if ((c[q >> 2] | 0) > (c[r >> 2] | 0)) {
	                            c[e >> 2] = -1;
	                            u = c[e >> 2] | 0;
	                            i = d;
	                            return u | 0
	                        }
	                    }
	                    c[j >> 2] = 0;
	                    c[o >> 2] = c[g >> 2];
	                    while (1) {
	                        w = c[o >> 2] | 0;
	                        if (!(c[(c[o >> 2] | 0) + 20 >> 2] | 0))break;
	                        if ((w | 0) == (c[f >> 2] | 0)) {
	                            v = 41;
	                            break
	                        }
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((v | 0) == 41) {
	                        c[e >> 2] = 1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    c[p >> 2] = w;
	                    c[h >> 2] = 0;
	                    c[o >> 2] = c[f >> 2];
	                    while (1) {
	                        if (!(c[(c[o >> 2] | 0) + 20 >> 2] | 0))break;
	                        if ((c[o >> 2] | 0) == (c[g >> 2] | 0)) {
	                            v = 46;
	                            break
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((v | 0) == 46) {
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    if ((c[p >> 2] | 0) != (c[o >> 2] | 0)) {
	                        c[e >> 2] = -2;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    while (1) {
	                        if ((c[h >> 2] | 0) <= (c[j >> 2] | 0))break;
	                        c[h >> 2] = (c[h >> 2] | 0) + -1;
	                        c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2]
	                    }
	                    while (1) {
	                        if ((c[j >> 2] | 0) <= (c[h >> 2] | 0))break;
	                        c[j >> 2] = (c[j >> 2] | 0) + -1;
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2]
	                    }
	                    while (1) {
	                        x = c[f >> 2] | 0;
	                        if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) == (c[(c[g >> 2] | 0) + 20 >> 2] | 0))break;
	                        c[f >> 2] = c[x + 20 >> 2];
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                        if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                            v = 56;
	                            break
	                        }
	                    }
	                    if ((v | 0) == 56) {
	                        c[e >> 2] = -2;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    if ((x | 0) == (c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    if ((c[f >> 2] | 0) == (c[(c[g >> 2] | 0) + 24 >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    do if (((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? 0 > (c[(c[f >> 2] | 0) + 40 >> 2] | 0) : 0) ? 0 > (c[(c[g >> 2] | 0) + 40 >> 2] | 0) : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == (c[(c[g >> 2] | 0) + 32 >> 2] | 0) : 0) {
	                        c[s >> 2] = 0 - (c[(c[f >> 2] | 0) + 40 >> 2] | 0);
	                        c[t >> 2] = 0 - (c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        if ((c[s >> 2] | 0) < (c[t >> 2] | 0)) {
	                            c[e >> 2] = 1;
	                            u = c[e >> 2] | 0;
	                            i = d;
	                            return u | 0
	                        }
	                        if ((c[s >> 2] | 0) <= (c[t >> 2] | 0))break;
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    } while (0);
	                    c[o >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (!(c[o >> 2] | 0)) {
	                            v = 75;
	                            break
	                        }
	                        if ((c[o >> 2] | 0) == (c[g >> 2] | 0)) {
	                            v = 73;
	                            break
	                        }
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                    }
	                    if ((v | 0) == 73) {
	                        c[e >> 2] = 1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    } else if ((v | 0) == 75) {
	                        c[e >> 2] = -1;
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                }
	                c[e >> 2] = 1;
	                u = c[e >> 2] | 0;
	                i = d;
	                return u | 0
	            }

	            function Zq(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Jq(c[(c[d >> 2] | 0) + 8 >> 2] | 0, c[c[d >> 2] >> 2] | 0);
	                i = b;
	                return
	            }

	            function _q(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                    i = b;
	                    return
	                }
	                if (!(c[c[d >> 2] >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[c[d >> 2] >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function $q(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128632);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                do if (c[e >> 2] | 0) {
	                    a = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a;
	                    if (!(c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                        it(0, 128632);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                    a = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                    j = a + 40 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (j | 0));
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 10;
	                    a = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        c[g >> 2] = a;
	                        j = kt(c[c[g >> 2] >> 2] | 0, c[g >> 2] | 0) | 0;
	                        k = c[f >> 2] | 0;
	                        l = c[k >> 2] | 0;
	                        c[k >> 2] = l + 1;
	                        c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (l << 2) >> 2] = j;
	                        break
	                    } else {
	                        j = c[f >> 2] | 0;
	                        l = c[j >> 2] | 0;
	                        c[j >> 2] = l + 1;
	                        c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (l << 2) >> 2] = a;
	                        break
	                    }
	                } while (0);
	                c[d >> 2] = c[f >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function ar(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                b = (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18;
	                c[h >> 2] = 0;
	                a:do if (b) {
	                    while (1) {
	                        if ((c[h >> 2] | 0) >= (c[c[f >> 2] >> 2] | 0))break a;
	                        if ((c[(c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                            c[j >> 2] = c[g >> 2];
	                            c[k >> 2] = c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                            if ((c[j >> 2] | 0) == (c[k >> 2] | 0)) {
	                                m = 7;
	                                break
	                            }
	                            if (((c[c[j >> 2] >> 2] | 0) != 0 ? (c[c[k >> 2] >> 2] | 0) == (c[c[j >> 2] >> 2] | 0) : 0) ? (qy(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                                m = 11;
	                                break
	                            }
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    if ((m | 0) == 7) {
	                        c[e >> 2] = 1;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else if ((m | 0) == 11) {
	                        c[e >> 2] = 1;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                } else {
	                    while (1) {
	                        if ((c[h >> 2] | 0) >= (c[c[f >> 2] >> 2] | 0))break a;
	                        if ((c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) == (c[g >> 2] | 0))break;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } while (0);
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function br(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((!((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    c[k >> 2] = 0;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >= (c[c[g >> 2] >> 2] | 0))break;
	                        if ((((c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) != 0 ? (c[(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] >> 2] | 0) == (c[h >> 2] | 0) : 0) ? (qy(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                            m = 11;
	                            break
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((m | 0) == 11) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    do if (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                        if ((c[c[g >> 2] >> 2] | 0) == (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >= 1e7) {
	                                it(0, 128680);
	                                c[f >> 2] = -1;
	                                n = c[f >> 2] | 0;
	                                i = e;
	                                return n | 0
	                            }
	                            c[l >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] << 1 << 2) | 0;
	                            if (c[l >> 2] | 0) {
	                                m = (c[g >> 2] | 0) + 4 | 0;
	                                c[m >> 2] = c[m >> 2] << 1;
	                                c[(c[g >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                                break
	                            }
	                            it(0, 128656);
	                            c[f >> 2] = -1;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                    } else {
	                        m = Cb[c[135744 >> 2] & 511](40) | 0;
	                        c[(c[g >> 2] | 0) + 8 >> 2] = m;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            m = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                            k = m + 40 | 0;
	                            do {
	                                c[m >> 2] = 0;
	                                m = m + 4 | 0
	                            } while ((m | 0) < (k | 0));
	                            c[(c[g >> 2] | 0) + 4 >> 2] = 10;
	                            break
	                        }
	                        it(0, 128656);
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } while (0);
	                    l = kt(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    j = c[g >> 2] | 0;
	                    h = c[j >> 2] | 0;
	                    c[j >> 2] = h + 1;
	                    c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (h << 2) >> 2] = l;
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[f >> 2] = -1;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function cr(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    if ((c[h >> 2] | 0) >= (c[c[f >> 2] >> 2] | 0))break;
	                    if ((c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) == (c[g >> 2] | 0)) {
	                        m = 6;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((m | 0) == 6) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                do if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    if ((c[c[f >> 2] >> 2] | 0) == (c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) >= 1e7) {
	                            it(0, 128680);
	                            c[e >> 2] = -1;
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 4 >> 2] << 1 << 2) | 0;
	                        if (c[j >> 2] | 0) {
	                            m = (c[f >> 2] | 0) + 4 | 0;
	                            c[m >> 2] = c[m >> 2] << 1;
	                            c[(c[f >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                            break
	                        }
	                        it(0, 128656);
	                        c[e >> 2] = -1;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                } else {
	                    m = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = m;
	                    if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                        m = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                        h = m + 40 | 0;
	                        do {
	                            c[m >> 2] = 0;
	                            m = m + 4 | 0
	                        } while ((m | 0) < (h | 0));
	                        c[(c[f >> 2] | 0) + 4 >> 2] = 10;
	                        break
	                    }
	                    it(0, 128656);
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } while (0);
	                j = c[g >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    c[k >> 2] = j;
	                    g = kt(c[c[k >> 2] >> 2] | 0, c[k >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    m = c[k >> 2] | 0;
	                    c[k >> 2] = m + 1;
	                    c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (m << 2) >> 2] = g
	                } else {
	                    g = c[f >> 2] | 0;
	                    m = c[g >> 2] | 0;
	                    c[g >> 2] = m + 1;
	                    c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (m << 2) >> 2] = j
	                }
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function dr(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                do if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    if ((c[c[f >> 2] >> 2] | 0) == (c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) >= 1e7) {
	                            it(0, 128680);
	                            c[e >> 2] = -1;
	                            k = c[e >> 2] | 0;
	                            i = d;
	                            return k | 0
	                        }
	                        c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 4 >> 2] << 1 << 2) | 0;
	                        if (c[h >> 2] | 0) {
	                            c[(c[f >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                            b = (c[f >> 2] | 0) + 4 | 0;
	                            c[b >> 2] = c[b >> 2] << 1;
	                            break
	                        }
	                        it(0, 128656);
	                        c[e >> 2] = -1;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                } else {
	                    b = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = b;
	                    if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                        b = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                        a = b + 40 | 0;
	                        do {
	                            c[b >> 2] = 0;
	                            b = b + 4 | 0
	                        } while ((b | 0) < (a | 0));
	                        c[(c[f >> 2] | 0) + 4 >> 2] = 10;
	                        break
	                    }
	                    it(0, 128656);
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } while (0);
	                h = c[g >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    c[j >> 2] = h;
	                    g = kt(c[c[j >> 2] >> 2] | 0, c[j >> 2] | 0) | 0;
	                    j = c[f >> 2] | 0;
	                    b = c[j >> 2] | 0;
	                    c[j >> 2] = b + 1;
	                    c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (b << 2) >> 2] = g
	                } else {
	                    g = c[f >> 2] | 0;
	                    b = c[g >> 2] | 0;
	                    c[g >> 2] = b + 1;
	                    c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (b << 2) >> 2] = h
	                }
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function er(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 40 | 0;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                o = d + 4 | 0;
	                p = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = b;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                if ((b | 0) == 0 ? (c[f >> 2] = $q(0) | 0, (c[f >> 2] | 0) == 0) : 0) {
	                    c[e >> 2] = 0;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                c[k >> 2] = c[c[f >> 2] >> 2];
	                c[h >> 2] = 0;
	                a:while (1) {
	                    if ((c[h >> 2] | 0) >= (c[c[g >> 2] >> 2] | 0)) {
	                        r = 33;
	                        break
	                    }
	                    c[n >> 2] = c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                    c[l >> 2] = 0;
	                    c[j >> 2] = 0;
	                    while (1) {
	                        if ((c[j >> 2] | 0) >= (c[k >> 2] | 0))break;
	                        c[m >> 2] = c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                        if ((c[m >> 2] | 0) == (c[n >> 2] | 0)) {
	                            r = 11;
	                            break
	                        }
	                        if ((((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 18 ? (c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) ? (c[c[m >> 2] >> 2] | 0) == (c[c[n >> 2] >> 2] | 0) : 0) ? (qy(c[(c[m >> 2] | 0) + 12 >> 2] | 0, c[(c[n >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                            r = 16;
	                            break
	                        }
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    if ((r | 0) == 11) {
	                        r = 0;
	                        c[l >> 2] = 1
	                    } else if ((r | 0) == 16) {
	                        r = 0;
	                        c[l >> 2] = 1
	                    }
	                    do if (!(c[l >> 2] | 0)) {
	                        if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                            if ((c[c[f >> 2] >> 2] | 0) == (c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) >= 1e7) {
	                                    r = 25;
	                                    break a
	                                }
	                                c[o >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 4 >> 2] << 1 << 2) | 0;
	                                if (!(c[o >> 2] | 0)) {
	                                    r = 27;
	                                    break a
	                                }
	                                c[(c[f >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                                b = (c[f >> 2] | 0) + 4 | 0;
	                                c[b >> 2] = c[b >> 2] << 1
	                            }
	                        } else {
	                            b = Cb[c[135744 >> 2] & 511](40) | 0;
	                            c[(c[f >> 2] | 0) + 8 >> 2] = b;
	                            if (!(c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                                r = 21;
	                                break a
	                            }
	                            b = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                            a = b + 40 | 0;
	                            do {
	                                c[b >> 2] = 0;
	                                b = b + 4 | 0
	                            } while ((b | 0) < (a | 0));
	                            c[(c[f >> 2] | 0) + 4 >> 2] = 10
	                        }
	                        b = c[n >> 2] | 0;
	                        if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                            c[p >> 2] = b;
	                            a = kt(c[c[p >> 2] >> 2] | 0, c[p >> 2] | 0) | 0;
	                            s = c[f >> 2] | 0;
	                            t = c[s >> 2] | 0;
	                            c[s >> 2] = t + 1;
	                            c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (t << 2) >> 2] = a;
	                            break
	                        } else {
	                            a = c[f >> 2] | 0;
	                            t = c[a >> 2] | 0;
	                            c[a >> 2] = t + 1;
	                            c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (t << 2) >> 2] = b;
	                            break
	                        }
	                    } while (0);
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((r | 0) == 21) {
	                    it(0, 128712);
	                    c[e >> 2] = 0;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                } else if ((r | 0) == 25) {
	                    it(0, 128736);
	                    c[e >> 2] = 0;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                } else if ((r | 0) == 27) {
	                    it(0, 128712);
	                    c[e >> 2] = 0;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                } else if ((r | 0) == 33) {
	                    c[e >> 2] = c[f >> 2];
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                return 0
	            }

	            function fr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[c[d >> 2] >> 2] | 0))break;
	                        if ((c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0) != 0 ? (c[(c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) == 18 : 0)_q(c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function gr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128632);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 1;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    a = $q(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = a;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function hr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128768);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 1;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function ir(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                a = _i(c[d >> 2] | 0) | 0;
	                c[e >> 2] = a;
	                if (!a)c[e >> 2] = my(128928) | 0;
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function jr(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = kr(c[f >> 2] | 0, c[g >> 2] | 0, 0, c[h >> 2] | 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function kr(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                do if (c[h >> 2] | 0) {
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 40 >> 2] | 0)) {
	                        e = Ij(0) | 0;
	                        c[(c[h >> 2] | 0) + 40 >> 2] = e
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 40 >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    e = c[(c[h >> 2] | 0) + 40 >> 2] | 0;
	                    d = c[j >> 2] | 0;
	                    b = c[k >> 2] | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        c[g >> 2] = ck(e, d, b, 0) | 0;
	                        break
	                    } else {
	                        c[g >> 2] = Nj(e, d, b, c[l >> 2] | 0) | 0;
	                        break
	                    }
	                } else c[g >> 2] = -1; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function lr(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 112 >> 2] | 0) != 0 ? (c[j >> 2] = c[(c[f >> 2] | 0) + 112 >> 2], c[k >> 2] = vb[c[j >> 2] & 511](c[(c[f >> 2] | 0) + 116 >> 2] | 0, c[g >> 2] | 0, 0) | 0, c[h >> 2] = c[k >> 2], (c[h >> 2] | 0) != 0) : 0) {
	                    c[e >> 2] = c[h >> 2];
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[e >> 2] = mr(c[f >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function mr(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 112 >> 2] | 0) != 0 ? (c[l >> 2] = c[(c[g >> 2] | 0) + 112 >> 2], c[m >> 2] = vb[c[l >> 2] & 511](c[(c[g >> 2] | 0) + 116 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0, c[k >> 2] = c[m >> 2], (c[k >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else {
	                    c[k >> 2] = Tj(c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function nr(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Kj(c[(c[d >> 2] | 0) + 40 >> 2] | 0, 0);
	                c[(c[d >> 2] | 0) + 40 >> 2] = 0;
	                i = b;
	                return
	            }

	            function or(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = c[f >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 92 >> 2] | 0) {
	                    c[h >> 2] = vb[c[b + 92 >> 2] & 511](c[(c[f >> 2] | 0) + 96 >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = pr(b, c[g >> 2] | 0, 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function pr(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 92 >> 2] | 0) != 0 ? (c[k >> 2] = vb[c[(c[g >> 2] | 0) + 92 >> 2] & 511](c[(c[g >> 2] | 0) + 96 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    k = c[g >> 2] | 0;
	                    c[f >> 2] = lt(k, Tj(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function qr(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Kj(c[(c[d >> 2] | 0) + 16 >> 2] | 0, 260);
	                c[(c[d >> 2] | 0) + 16 >> 2] = 0;
	                i = b;
	                return
	            }

	            function rr(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                do if (c[h >> 2] | 0) {
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 88 >> 2] | 0)) {
	                        e = Ij(10) | 0;
	                        c[(c[h >> 2] | 0) + 88 >> 2] = e
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 88 >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    e = c[(c[h >> 2] | 0) + 88 >> 2] | 0;
	                    b = c[j >> 2] | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = ak(e, b, c[33934] | 0) | 0;
	                        break
	                    } else {
	                        a = my(c[k >> 2] | 0) | 0;
	                        c[g >> 2] = Oj(e, b, a, c[33934] | 0) | 0;
	                        break
	                    }
	                } else c[g >> 2] = -1; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function sr(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (qy(c[g >> 2] | 0, 128800) | 0) {
	                    c[e >> 2] = 128808;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                a:do if (c[(c[f >> 2] | 0) + 56 >> 2] | 0) {
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if ((c[h >> 2] | 0) >= (c[(c[f >> 2] | 0) + 60 >> 2] | 0))break a;
	                        if ((c[(c[(c[f >> 2] | 0) + 56 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) != 0 ? (qy(c[(c[(c[(c[f >> 2] | 0) + 56 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0) | 0) != 0 : 0)break;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 56 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 8 >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[e >> 2] = Rj(c[(c[f >> 2] | 0) + 88 >> 2] | 0, c[g >> 2] | 0) | 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function tr(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Kj(c[(c[d >> 2] | 0) + 88 >> 2] | 0, c[33934] | 0);
	                c[(c[d >> 2] | 0) + 88 >> 2] = 0;
	                i = b;
	                return
	            }

	            function ur(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b;
	                f = b + 8 | 0;
	                h[e >> 3] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128848);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    j = (c[f >> 2] | 0) + 0 | 0;
	                    k = j + 48 | 0;
	                    do {
	                        c[j >> 2] = 0;
	                        j = j + 4 | 0
	                    } while ((j | 0) < (k | 0));
	                    c[c[f >> 2] >> 2] = 3;
	                    h[(c[f >> 2] | 0) + 16 >> 3] = +h[e >> 3];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function vr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128872);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 2;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = (c[e >> 2] | 0) != 0 & 1;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function wr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128904);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 48 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[c[f >> 2] >> 2] = 4;
	                if (c[e >> 2] | 0) {
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = a
	                } else {
	                    a = my(128928) | 0;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = a
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function xr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128904);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 4;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function yr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128904);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 4;
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = a;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function zr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[g >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    it(0, 128936);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                a = (c[g >> 2] | 0) + 0 | 0;
	                k = (c[f >> 2] | 0) + 0 | 0;
	                l = a + 48 | 0;
	                do {
	                    c[a >> 2] = c[k >> 2];
	                    a = a + 4 | 0;
	                    k = k + 4 | 0
	                } while ((a | 0) < (l | 0));
	                switch (c[c[f >> 2] >> 2] | 0) {
	                    case 9:
	                    case 1:
	                    {
	                        k = er(0, c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        c[(c[g >> 2] | 0) + 4 >> 2] = k;
	                        c[(c[g >> 2] | 0) + 8 >> 2] = 0;
	                        break
	                    }
	                    case 0:
	                    {
	                        k = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[d >> 2] = c[c[f >> 2] >> 2];
	                        Db[k & 511](a, 128952, d);
	                        break
	                    }
	                    case 7:
	                    {
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                        d = dv(0, c[h >> 2] | 0) | 0;
	                        c[(c[g >> 2] | 0) + 28 >> 2] = d;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[(c[g >> 2] | 0) + 28 >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                        break
	                    }
	                    case 4:
	                    {
	                        d = my(c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = d;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                c[e >> 2] = c[g >> 2];
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function Ar(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (c[d >> 2] | 0)c[e >> 2] = my(129e3) | 0; else c[e >> 2] = my(129008) | 0;
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Br(b) {
	                b = +b;
	                var d = 0, e = 0, f = 0, g = 0, j = 0;
	                d = i;
	                i = i + 112 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 12 | 0;
	                h[e >> 3] = b;
	                j = Mq(+h[e >> 3]) | 0;
	                do if ((j | 0) == 1)c[f >> 2] = my(129016) | 0; else if ((j | 0) == -1)c[f >> 2] = my(129032) | 0; else {
	                    if (Lq(+h[e >> 3]) | 0) {
	                        c[f >> 2] = my(129048) | 0;
	                        break
	                    }
	                    if (+h[e >> 3] == 0.0 ? (et(+h[e >> 3]) | 0) != 0 : 0) {
	                        c[f >> 2] = my(129056) | 0;
	                        break
	                    }
	                    mt(+h[e >> 3], g, 99);
	                    a[g + 99 >> 0] = 0;
	                    c[f >> 2] = my(g) | 0
	                } while (0);
	                i = d;
	                return c[f >> 2] | 0
	            }

	            function Cr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (((c[e >> 2] | 0) != 0 ? (c[c[e >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((c[c[e >> 2] >> 2] | 0) > 1)Zq(c[e >> 2] | 0);
	                    c[d >> 2] = ir(c[c[(c[e >> 2] | 0) + 8 >> 2] >> 2] | 0) | 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = my(128928) | 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function Dr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 8 | 0;
	                c[e >> 2] = a;
	                if (c[e >> 2] | 0)h[d >> 3] = 1.0; else h[d >> 3] = 0.0;
	                i = b;
	                return +(+h[d >> 3])
	            }

	            function Er(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0.0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                e = +Fr(c[d >> 2] | 0);
	                i = b;
	                return +e
	            }

	            function Fr(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0.0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0.0;
	                b = i;
	                i = i + 80 | 0;
	                e = b + 24 | 0;
	                f = b + 64 | 0;
	                g = b + 60 | 0;
	                j = b + 16 | 0;
	                k = b + 56 | 0;
	                l = b + 52 | 0;
	                m = b + 48 | 0;
	                n = b + 44 | 0;
	                o = b + 40 | 0;
	                p = b + 8 | 0;
	                q = b + 36 | 0;
	                r = b + 32 | 0;
	                s = b;
	                c[f >> 2] = a;
	                c[g >> 2] = c[f >> 2];
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    h[e >> 3] = 0.0;
	                    t = +h[e >> 3];
	                    i = b;
	                    return +t
	                }
	                while (1) {
	                    do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)u = 1; else {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            u = 1;
	                            break
	                        }
	                        u = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    v = c[g >> 2] | 0;
	                    if (!u)break;
	                    c[g >> 2] = v + 1
	                }
	                do if ((d[v >> 0] | 0 | 0) != 46) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0)break;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 45) {
	                        h[e >> 3] = +h[15984];
	                        t = +h[e >> 3];
	                        i = b;
	                        return +t
	                    }
	                } while (0);
	                if ((d[c[g >> 2] >> 0] | 0 | 0) == 45) {
	                    c[l >> 2] = 1;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                h[j >> 3] = 0.0;
	                while (1) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) < 48)break;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) > 57)break;
	                    h[j >> 3] = +h[j >> 3] * 10.0;
	                    c[o >> 2] = (d[c[g >> 2] >> 0] | 0) - 48;
	                    c[k >> 2] = 1;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    h[p >> 3] = +((c[o >> 2] | 0) >>> 0);
	                    h[j >> 3] = +h[j >> 3] + +h[p >> 3]
	                }
	                a:do if ((d[c[g >> 2] >> 0] | 0 | 0) == 46) {
	                    c[r >> 2] = 0;
	                    h[s >> 3] = 0.0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) < 48) {
	                        if (!(c[k >> 2] | 0))w = 24
	                    } else if (!((c[k >> 2] | 0) != 0 ? 1 : (d[c[g >> 2] >> 0] | 0 | 0) <= 57))w = 24;
	                    if ((w | 0) == 24) {
	                        h[e >> 3] = +h[15984];
	                        t = +h[e >> 3];
	                        i = b;
	                        return +t
	                    }
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) < 48)break;
	                        if (!((c[r >> 2] | 0) < 20 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0))break;
	                        c[q >> 2] = (d[c[g >> 2] >> 0] | 0) - 48;
	                        h[s >> 3] = +h[s >> 3] * 10.0 + +(c[q >> 2] | 0);
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    h[s >> 3] = +h[s >> 3] / +h[129232 + (c[r >> 2] << 3) >> 3];
	                    h[j >> 3] = +h[j >> 3] + +h[s >> 3];
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) < 48)break a;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) > 57)break a;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                } while (0);
	                if (!((d[c[g >> 2] >> 0] | 0 | 0) != 101 ? (d[c[g >> 2] >> 0] | 0 | 0) != 69 : 0))w = 34;
	                b:do if ((w | 0) == 34) {
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 45) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) == 43)c[g >> 2] = (c[g >> 2] | 0) + 1
	                    } else {
	                        c[n >> 2] = 1;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) < 48)break b;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) > 57)break b;
	                        c[m >> 2] = ((c[m >> 2] | 0) * 10 | 0) + ((d[c[g >> 2] >> 0] | 0) - 48);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                } while (0);
	                while (1) {
	                    do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)x = 1; else {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            x = 1;
	                            break
	                        }
	                        x = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    y = c[g >> 2] | 0;
	                    if (!x)break;
	                    c[g >> 2] = y + 1
	                }
	                if (d[y >> 0] | 0) {
	                    h[e >> 3] = +h[15984];
	                    t = +h[e >> 3];
	                    i = b;
	                    return +t
	                }
	                if (c[l >> 2] | 0)h[j >> 3] = -+h[j >> 3];
	                if (c[n >> 2] | 0)c[m >> 2] = 0 - (c[m >> 2] | 0);
	                z = +T(10.0, +(+(c[m >> 2] | 0)));
	                h[j >> 3] = +h[j >> 3] * z;
	                h[e >> 3] = +h[j >> 3];
	                t = +h[e >> 3];
	                i = b;
	                return +t
	            }

	            function Gr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0.0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 8 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    h[d >> 3] = +h[15984];
	                    j = +h[d >> 3];
	                    i = b;
	                    return +j
	                }
	                c[f >> 2] = ir(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    h[d >> 3] = +h[15984];
	                    j = +h[d >> 3];
	                    i = b;
	                    return +j
	                } else {
	                    h[g >> 3] = +Er(c[f >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    h[d >> 3] = +h[g >> 3];
	                    j = +h[d >> 3];
	                    i = b;
	                    return +j
	                }
	                return +(0.0)
	            }

	            function Hr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0.0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 8 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    h[d >> 3] = +h[15984];
	                    j = +h[d >> 3];
	                    i = b;
	                    return +j
	                } else {
	                    c[f >> 2] = Cr(c[e >> 2] | 0) | 0;
	                    h[g >> 3] = +Er(c[f >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    h[d >> 3] = +h[g >> 3];
	                    j = +h[d >> 3];
	                    i = b;
	                    return +j
	                }
	                return +(0.0)
	            }

	            function Ir(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b;
	                h[e >> 3] = a;
	                f = (Lq(+h[e >> 3]) | 0) != 0;
	                if (f | +h[e >> 3] == 0.0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[d >> 2] = 1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Jr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (xy(c[e >> 2] | 0) | 0) != 0 : 0)c[d >> 2] = 1; else c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Kr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[c[e >> 2] >> 2] | 0) != 0 : 0)c[d >> 2] = 1; else c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Lr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](204) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 129096);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    cU(c[f >> 2] | 0, 0, 204) | 0;
	                    c[c[f >> 2] >> 2] = c[e >> 2];
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                    e = Ij(0) | 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = e;
	                    c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 52 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 88 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 68 >> 2] = -1;
	                    c[(c[f >> 2] | 0) + 72 >> 2] = -1;
	                    Mr(c[f >> 2] | 0);
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Mr(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                jr(c[d >> 2] | 0, 129592, 261) | 0;
	                jr(c[d >> 2] | 0, 129600, 262) | 0;
	                jr(c[d >> 2] | 0, 129608, 263) | 0;
	                jr(c[d >> 2] | 0, 129616, 264) | 0;
	                jr(c[d >> 2] | 0, 129624, 265) | 0;
	                jr(c[d >> 2] | 0, 129640, 266) | 0;
	                jr(c[d >> 2] | 0, 129008, 267) | 0;
	                jr(c[d >> 2] | 0, 129648, 268) | 0;
	                jr(c[d >> 2] | 0, 129656, 269) | 0;
	                jr(c[d >> 2] | 0, 129664, 270) | 0;
	                jr(c[d >> 2] | 0, 129672, 271) | 0;
	                jr(c[d >> 2] | 0, 129688, 272) | 0;
	                jr(c[d >> 2] | 0, 129696, 273) | 0;
	                jr(c[d >> 2] | 0, 129704, 274) | 0;
	                jr(c[d >> 2] | 0, 129720, 275) | 0;
	                jr(c[d >> 2] | 0, 129736, 276) | 0;
	                jr(c[d >> 2] | 0, 129744, 277) | 0;
	                jr(c[d >> 2] | 0, 129760, 278) | 0;
	                jr(c[d >> 2] | 0, 129768, 279) | 0;
	                jr(c[d >> 2] | 0, 129776, 280) | 0;
	                jr(c[d >> 2] | 0, 129792, 281) | 0;
	                jr(c[d >> 2] | 0, 129808, 282) | 0;
	                jr(c[d >> 2] | 0, 129824, 283) | 0;
	                jr(c[d >> 2] | 0, 129848, 284) | 0;
	                jr(c[d >> 2] | 0, 129864, 285) | 0;
	                jr(c[d >> 2] | 0, 129e3, 286) | 0;
	                jr(c[d >> 2] | 0, 129872, 287) | 0;
	                kr(c[d >> 2] | 0, 129888, 129904, 288) | 0;
	                i = b;
	                return
	            }

	            function Nr(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 200 >> 2] | 0)ht(c[(c[d >> 2] | 0) + 200 >> 2] | 0);
	                tr(c[d >> 2] | 0);
	                nr(c[d >> 2] | 0);
	                qr(c[d >> 2] | 0);
	                Yd((c[d >> 2] | 0) + 136 | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Or(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    it(c[g >> 2] | 0, 129120);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 48 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                b = c[f >> 2] | 0;
	                c[(c[h >> 2] | 0) + 4 >> 2] = b;
	                c[c[h >> 2] >> 2] = b;
	                c[(c[h >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                b = pt() | 0;
	                c[(c[h >> 2] | 0) + 32 >> 2] = b;
	                if (!(c[(c[h >> 2] | 0) + 32 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 28 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 192 >> 2] | 0) != 0 : 0) {
	                    c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 192 >> 2];
	                    yP(c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 20 >> 2] | 0) | 0
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Pr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (!(c[(c[d >> 2] | 0) + 32 >> 2] | 0)) {
	                    e = c[33934] | 0;
	                    f = c[d >> 2] | 0;
	                    zb[e & 511](f);
	                    i = b;
	                    return
	                }
	                if (c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] | 0) {
	                    FQ(c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] | 0);
	                    c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] = 0
	                }
	                Pq(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                e = c[33934] | 0;
	                f = c[d >> 2] | 0;
	                zb[e & 511](f);
	                i = b;
	                return
	            }

	            function Qr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                c[f >> 2] = a;
	                c[l >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    c[g >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    a = c[g >> 2] | 0;
	                    if ((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                        m = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                        if (a)jt(m, c[g >> 2] | 0); else jt(m, c[j >> 2] | 0);
	                        Nq(c[f >> 2] | 0, 10);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if ((a | 0) == (c[j >> 2] | 0)) {
	                        Qq(c[g >> 2] | 0);
	                        c[e >> 2] = 1;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if ((((c[c[j >> 2] >> 2] | 0) != 1 ? (c[c[j >> 2] >> 2] | 0) != 9 : 0) ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) ? (c[c[g >> 2] >> 2] | 0) != 9 : 0) {
	                        c[e >> 2] = tt(c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[c[g >> 2] >> 2] | 0) != 9 : 0) {
	                        c[k >> 2] = c[j >> 2];
	                        c[j >> 2] = c[g >> 2];
	                        c[g >> 2] = c[k >> 2]
	                    }
	                    switch (c[c[j >> 2] >> 2] | 0) {
	                        case 2:
	                        {
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0)c[l >> 2] = 1; else c[l >> 2] = 0;
	                            c[l >> 2] = (c[l >> 2] | 0) == (c[(c[j >> 2] | 0) + 8 >> 2] | 0) & 1;
	                            break
	                        }
	                        case 3:
	                        {
	                            c[l >> 2] = rt(c[f >> 2] | 0, c[g >> 2] | 0, +h[(c[j >> 2] | 0) + 16 >> 3], 0) | 0;
	                            break
	                        }
	                        case 4:
	                        {
	                            c[l >> 2] = st(c[g >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        case 6:
	                        case 5:
	                        case 8:
	                        case 7:
	                        {
	                            k = c[33976] | 0;
	                            a = c[33980] | 0;
	                            c[d >> 2] = 128552;
	                            c[d + 4 >> 2] = 7204;
	                            Db[k & 511](a, 129064, d);
	                            break
	                        }
	                        case 9:
	                        case 1:
	                        {
	                            c[l >> 2] = qt(c[g >> 2] | 0, c[j >> 2] | 0, 0) | 0;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                    c[e >> 2] = c[l >> 2];
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function Rr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                c[f >> 2] = a;
	                c[l >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    c[g >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    a = c[g >> 2] | 0;
	                    if ((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                        m = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                        if (a)jt(m, c[g >> 2] | 0); else jt(m, c[j >> 2] | 0);
	                        Nq(c[f >> 2] | 0, 10);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if ((a | 0) == (c[j >> 2] | 0)) {
	                        jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if ((((c[c[j >> 2] >> 2] | 0) != 1 ? (c[c[j >> 2] >> 2] | 0) != 9 : 0) ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) ? (c[c[g >> 2] >> 2] | 0) != 9 : 0) {
	                        c[e >> 2] = ((tt(c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0) | 0) != 0 ^ 1) & 1;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[c[g >> 2] >> 2] | 0) != 9 : 0) {
	                        c[k >> 2] = c[j >> 2];
	                        c[j >> 2] = c[g >> 2];
	                        c[g >> 2] = c[k >> 2]
	                    }
	                    switch (c[c[j >> 2] >> 2] | 0) {
	                        case 2:
	                        {
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0)c[l >> 2] = 1; else c[l >> 2] = 0;
	                            c[l >> 2] = (c[l >> 2] | 0) != (c[(c[j >> 2] | 0) + 8 >> 2] | 0) & 1;
	                            break
	                        }
	                        case 4:
	                        {
	                            c[l >> 2] = st(c[g >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, 1) | 0;
	                            break
	                        }
	                        case 3:
	                        {
	                            c[l >> 2] = rt(c[f >> 2] | 0, c[g >> 2] | 0, +h[(c[j >> 2] | 0) + 16 >> 3], 1) | 0;
	                            break
	                        }
	                        case 6:
	                        case 5:
	                        case 8:
	                        case 7:
	                        {
	                            k = c[33976] | 0;
	                            a = c[33980] | 0;
	                            c[d >> 2] = 128552;
	                            c[d + 4 >> 2] = 7289;
	                            Db[k & 511](a, 129064, d);
	                            break
	                        }
	                        case 9:
	                        case 1:
	                        {
	                            c[l >> 2] = qt(c[g >> 2] | 0, c[j >> 2] | 0, 1) | 0;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                    c[e >> 2] = c[l >> 2];
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function Sr(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[p >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    c[o >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                        d = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                        if (c[o >> 2] | 0)jt(d, c[o >> 2] | 0); else jt(d, c[p >> 2] | 0);
	                        Nq(c[g >> 2] | 0, 10);
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    if ((((c[c[p >> 2] >> 2] | 0) != 1 ? (c[c[p >> 2] >> 2] | 0) != 9 : 0) ? (c[c[o >> 2] >> 2] | 0) != 1 : 0) ? (c[c[o >> 2] >> 2] | 0) != 9 : 0) {
	                        if ((c[c[o >> 2] >> 2] | 0) != 3) {
	                            Tq(c[g >> 2] | 0, c[o >> 2] | 0) | 0;
	                            Tr(c[g >> 2] | 0, 1);
	                            c[o >> 2] = Sq(c[g >> 2] | 0) | 0
	                        }
	                        if ((c[c[o >> 2] >> 2] | 0) != 3) {
	                            Qq(c[o >> 2] | 0);
	                            Qq(c[p >> 2] | 0);
	                            Nq(c[g >> 2] | 0, 10);
	                            c[f >> 2] = 0;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        }
	                        if ((c[c[p >> 2] >> 2] | 0) != 3) {
	                            Tq(c[g >> 2] | 0, c[p >> 2] | 0) | 0;
	                            Tr(c[g >> 2] | 0, 1);
	                            c[p >> 2] = Sq(c[g >> 2] | 0) | 0
	                        }
	                        if ((c[c[p >> 2] >> 2] | 0) != 3) {
	                            jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[o >> 2] | 0);
	                            jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[p >> 2] | 0);
	                            Nq(c[g >> 2] | 0, 10);
	                            c[f >> 2] = 0;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        }
	                        a:do if ((Lq(+h[(c[o >> 2] | 0) + 16 >> 3]) | 0) == 0 ? (Lq(+h[(c[p >> 2] | 0) + 16 >> 3]) | 0) == 0 : 0) {
	                            c[m >> 2] = Mq(+h[(c[o >> 2] | 0) + 16 >> 3]) | 0;
	                            c[n >> 2] = Mq(+h[(c[p >> 2] | 0) + 16 >> 3]) | 0;
	                            if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                                do if (!((c[m >> 2] | 0) == -1 & (c[n >> 2] | 0) != -1)) {
	                                    if ((c[n >> 2] | 0) == 1 & (c[m >> 2] | 0) != 1)break;
	                                    if ((c[m >> 2] | 0) == 0 & (c[n >> 2] | 0) == 0) {
	                                        c[l >> 2] = +h[(c[o >> 2] | 0) + 16 >> 3] < +h[(c[p >> 2] | 0) + 16 >> 3] & 1;
	                                        break a
	                                    } else {
	                                        c[l >> 2] = 0;
	                                        break a
	                                    }
	                                } while (0);
	                                c[l >> 2] = 1;
	                                break
	                            }
	                            if (!((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) != 0)) {
	                                if ((c[m >> 2] | 0) == -1 | (c[n >> 2] | 0) == 1) {
	                                    c[l >> 2] = 1;
	                                    break
	                                }
	                                if ((c[m >> 2] | 0) == 0 & (c[n >> 2] | 0) == 0) {
	                                    c[l >> 2] = +h[(c[o >> 2] | 0) + 16 >> 3] <= +h[(c[p >> 2] | 0) + 16 >> 3] & 1;
	                                    break
	                                } else {
	                                    c[l >> 2] = 0;
	                                    break
	                                }
	                            }
	                            if (!((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) != 0)) {
	                                if ((c[j >> 2] | 0) != 0 | (c[k >> 2] | 0) != 0)break;
	                                if ((c[m >> 2] | 0) == 1 | (c[n >> 2] | 0) == -1) {
	                                    c[l >> 2] = 1;
	                                    break
	                                }
	                                if ((c[m >> 2] | 0) == 0 & (c[n >> 2] | 0) == 0) {
	                                    c[l >> 2] = +h[(c[o >> 2] | 0) + 16 >> 3] >= +h[(c[p >> 2] | 0) + 16 >> 3] & 1;
	                                    break
	                                } else {
	                                    c[l >> 2] = 0;
	                                    break
	                                }
	                            } else {
	                                do if (!((c[m >> 2] | 0) == 1 & (c[n >> 2] | 0) != 1)) {
	                                    if ((c[n >> 2] | 0) == -1 & (c[m >> 2] | 0) != -1)break;
	                                    if ((c[m >> 2] | 0) == 0 & (c[n >> 2] | 0) == 0) {
	                                        c[l >> 2] = +h[(c[o >> 2] | 0) + 16 >> 3] > +h[(c[p >> 2] | 0) + 16 >> 3] & 1;
	                                        break a
	                                    } else {
	                                        c[l >> 2] = 0;
	                                        break a
	                                    }
	                                } while (0);
	                                c[l >> 2] = 1;
	                                break
	                            }
	                        } else r = 33; while (0);
	                        if ((r | 0) == 33)c[l >> 2] = 0;
	                        jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[o >> 2] | 0);
	                        jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[p >> 2] | 0);
	                        c[f >> 2] = c[l >> 2];
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    if ((c[c[p >> 2] >> 2] | 0) != 1 ? (c[c[p >> 2] >> 2] | 0) != 9 : 0)r = 18; else r = 15;
	                    do if ((r | 0) == 15) {
	                        if ((c[c[o >> 2] >> 2] | 0) != 1 ? (c[c[o >> 2] >> 2] | 0) != 9 : 0) {
	                            r = 18;
	                            break
	                        }
	                        c[l >> 2] = ut(c[j >> 2] | 0, c[k >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0
	                    } while (0);
	                    do if ((r | 0) == 18) {
	                        if ((c[c[o >> 2] >> 2] | 0) != 1 ? (c[c[o >> 2] >> 2] | 0) != 9 : 0) {
	                            c[l >> 2] = vt(c[g >> 2] | 0, ((c[j >> 2] | 0) != 0 ^ 1) & 1, c[k >> 2] | 0, c[p >> 2] | 0, c[o >> 2] | 0) | 0;
	                            break
	                        }
	                        c[l >> 2] = vt(c[g >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0
	                    } while (0);
	                    c[f >> 2] = c[l >> 2];
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[f >> 2] = 0;
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function Tr(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                j = d;
	                k = d + 8 | 0;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    a = c[e >> 2] | 0;
	                    if (!(c[(c[b + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        Tq(a, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 0.0) | 0) | 0;
	                        i = d;
	                        return
	                    } else {
	                        c[k >> 2] = _i(c[(c[a + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        h[j >> 3] = +Fr(c[k >> 2] | 0);
	                        a = c[e >> 2] | 0;
	                        Tq(a, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +h[j >> 3]) | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                }
	                if (!b) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                } else {
	                    c[g >> 2] = Sq(f) | 0;
	                    f = c[e >> 2] | 0;
	                    Tq(f, xt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function Ur(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0.0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[d >> 2] | 0, 1);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    if (Lq(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15984];
	                        i = b;
	                        return
	                    }
	                    if ((Mq(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) == 1) {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15986];
	                        i = b;
	                        return
	                    }
	                    if ((Mq(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) == -1) {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15985];
	                        i = b;
	                        return
	                    }
	                    e = +h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3];
	                    if (!(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] == 0.0)) {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = -e;
	                        i = b;
	                        return
	                    }
	                    if (!(et(e) | 0)) {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15988];
	                        i = b;
	                        return
	                    } else {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = 0.0;
	                        i = b;
	                        return
	                    }
	                }
	                Nq(c[d >> 2] | 0, 11);
	                i = b;
	                return
	            }

	            function Vr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Sq(c[d >> 2] | 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    Nq(c[d >> 2] | 0, 10);
	                    i = b;
	                    return
	                }
	                h[f >> 3] = +Wq(c[e >> 2] | 0);
	                jt(c[(c[d >> 2] | 0) + 12 >> 2] | 0, c[e >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[d >> 2] | 0, 1);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    e = (c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 | 0;
	                    h[e >> 3] = +h[e >> 3] + +h[f >> 3];
	                    i = b;
	                    return
	                }
	                Nq(c[d >> 2] | 0, 11);
	                i = b;
	                return
	            }

	            function Wr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Sq(c[d >> 2] | 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    Nq(c[d >> 2] | 0, 10);
	                    i = b;
	                    return
	                }
	                h[f >> 3] = +Wq(c[e >> 2] | 0);
	                jt(c[(c[d >> 2] | 0) + 12 >> 2] | 0, c[e >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[d >> 2] | 0, 1);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    e = (c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 | 0;
	                    h[e >> 3] = +h[e >> 3] - +h[f >> 3];
	                    i = b;
	                    return
	                }
	                Nq(c[d >> 2] | 0, 11);
	                i = b;
	                return
	            }

	            function Xr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Sq(c[d >> 2] | 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    Nq(c[d >> 2] | 0, 10);
	                    i = b;
	                    return
	                }
	                h[f >> 3] = +Wq(c[e >> 2] | 0);
	                jt(c[(c[d >> 2] | 0) + 12 >> 2] | 0, c[e >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[d >> 2] | 0, 1);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    e = (c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 | 0;
	                    h[e >> 3] = +h[e >> 3] * +h[f >> 3];
	                    i = b;
	                    return
	                }
	                Nq(c[d >> 2] | 0, 11);
	                i = b;
	                return
	            }

	            function Yr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Sq(c[d >> 2] | 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    Nq(c[d >> 2] | 0, 10);
	                    i = b;
	                    return
	                }
	                h[f >> 3] = +Wq(c[e >> 2] | 0);
	                jt(c[(c[d >> 2] | 0) + 12 >> 2] | 0, c[e >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[d >> 2] | 0, 1);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    if ((Lq(+h[f >> 3]) | 0) == 0 ? (Lq(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) == 0 : 0) {
	                        if (+h[f >> 3] == 0.0 ? (et(+h[f >> 3]) | 0) != 0 : 0) {
	                            if (+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] == 0.0) {
	                                h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15984];
	                                i = b;
	                                return
	                            }
	                            if (+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] > 0.0) {
	                                h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15986];
	                                i = b;
	                                return
	                            }
	                            if (!(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] < 0.0)) {
	                                i = b;
	                                return
	                            }
	                            h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15985];
	                            i = b;
	                            return
	                        }
	                        if (!(+h[f >> 3] == 0.0)) {
	                            e = (c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 | 0;
	                            h[e >> 3] = +h[e >> 3] / +h[f >> 3];
	                            i = b;
	                            return
	                        }
	                        if (+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] == 0.0) {
	                            h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15984];
	                            i = b;
	                            return
	                        }
	                        if (+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] > 0.0) {
	                            h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15985];
	                            i = b;
	                            return
	                        }
	                        if (!(+h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] < 0.0)) {
	                            i = b;
	                            return
	                        }
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15986];
	                        i = b;
	                        return
	                    }
	                    h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15984];
	                    i = b;
	                    return
	                }
	                Nq(c[d >> 2] | 0, 11);
	                i = b;
	                return
	            }

	            function Zr(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0.0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 8 | 0;
	                g = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Sq(c[d >> 2] | 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    Nq(c[d >> 2] | 0, 10);
	                    i = b;
	                    return
	                }
	                h[g >> 3] = +Wq(c[e >> 2] | 0);
	                jt(c[(c[d >> 2] | 0) + 12 >> 2] | 0, c[e >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[d >> 2] | 0, 1);
	                if ((c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[d >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    h[f >> 3] = +h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3];
	                    if (+h[g >> 3] == 0.0) {
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15984];
	                        i = b;
	                        return
	                    } else {
	                        j = +uT(+h[f >> 3], +h[g >> 3]);
	                        h[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = j;
	                        i = b;
	                        return
	                    }
	                }
	                Nq(c[d >> 2] | 0, 11);
	                i = b;
	                return
	            }

	            function _r(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                    break
	                } else {
	                    c[e >> 2] = 0;
	                    break
	                } else h = 3; while (0);
	                if ((h | 0) == 3)c[e >> 2] = 0;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function $r(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if (c[g >> 2] | 0) {
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if (!(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    switch (c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) {
	                        case 20:
	                        case 19:
	                        case 18:
	                        case 2:
	                        case 17:
	                        case 16:
	                        case 15:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 14:
	                        case 12:
	                        case 8:
	                        case 7:
	                        case 6:
	                        case 5:
	                        case 4:
	                        case 3:
	                        case 1:
	                        {
	                            c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2];
	                            break a;
	                            break
	                        }
	                        case 21:
	                        case 13:
	                        case 11:
	                        case 10:
	                        case 9:
	                        {
	                            c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2];
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[e >> 2] = 0;
	                            break a
	                        }
	                    }
	                } else h = 3; while (0);
	                if ((h | 0) == 3)c[e >> 2] = 0;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function as(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if (!(c[g >> 2] | 0)) {
	                        if (!(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if ((c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                            b = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                            if ((c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                                c[e >> 2] = c[(c[b >> 2] | 0) + 12 >> 2];
	                                h = c[e >> 2] | 0;
	                                i = d;
	                                return h | 0
	                            } else {
	                                c[e >> 2] = c[(c[b + 4 >> 2] | 0) + 12 >> 2];
	                                h = c[e >> 2] | 0;
	                                i = d;
	                                return h | 0
	                            }
	                        }
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if (((c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) ? (c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2], (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 14) : 0) {
	                        c[e >> 2] = c[g >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if ((c[g >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    while (1) {
	                        if (!(c[(c[g >> 2] | 0) + 24 >> 2] | 0))break;
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 17)continue;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 14) {
	                            j = 24;
	                            break
	                        }
	                    }
	                    if ((j | 0) == 24) {
	                        c[e >> 2] = c[g >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    while (1) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                        if (!(c[g >> 2] | 0)) {
	                            j = 31;
	                            break
	                        }
	                        if ((c[g >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                            j = 27;
	                            break
	                        }
	                        k = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            j = 29;
	                            break
	                        }
	                        if (!k) {
	                            j = 31;
	                            break
	                        }
	                    }
	                    if ((j | 0) == 27) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((j | 0) == 29) {
	                        c[g >> 2] = c[k + 24 >> 2];
	                        c[e >> 2] = c[g >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((j | 0) == 31) {
	                        c[e >> 2] = c[g >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function bs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    b = c[f >> 2] | 0;
	                    if (c[g >> 2] | 0) {
	                        c[e >> 2] = as(b, c[g >> 2] | 0) | 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if (!(c[(c[b + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if ((c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        c[e >> 2] = c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function cs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    a:do if (!(c[h >> 2] | 0)) {
	                        if (!(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[f >> 2] = 0;
	                            l = c[f >> 2] | 0;
	                            i = e;
	                            return l | 0
	                        }
	                        switch (c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) {
	                            case 2:
	                            {
	                                c[j >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                                c[f >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                l = c[f >> 2] | 0;
	                                i = e;
	                                return l | 0
	                            }
	                            case 21:
	                            case 13:
	                            case 11:
	                            case 10:
	                            case 9:
	                            {
	                                c[f >> 2] = 0;
	                                l = c[f >> 2] | 0;
	                                i = e;
	                                return l | 0
	                            }
	                            case 18:
	                            {
	                                c[k >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                                if ((c[c[k >> 2] >> 2] | 0) != 0 ? (c[(c[c[k >> 2] >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                                    c[f >> 2] = c[c[k >> 2] >> 2];
	                                    l = c[f >> 2] | 0;
	                                    i = e;
	                                    return l | 0
	                                }
	                                c[f >> 2] = 0;
	                                l = c[f >> 2] | 0;
	                                i = e;
	                                return l | 0
	                            }
	                            case 17:
	                            case 20:
	                            case 19:
	                            case 16:
	                            case 15:
	                            case 14:
	                            case 12:
	                            case 8:
	                            case 7:
	                            case 6:
	                            case 5:
	                            case 4:
	                            case 3:
	                            case 1:
	                            {
	                                b = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                                if (!(c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0)) {
	                                    c[f >> 2] = c[b >> 2];
	                                    l = c[f >> 2] | 0;
	                                    i = e;
	                                    return l | 0
	                                }
	                                do if ((c[(c[(c[b + 4 >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                    if ((d[c[(c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) != 32 ? (qy(c[(c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 129152) | 0) == 0 : 0)break;
	                                    c[f >> 2] = 0;
	                                    l = c[f >> 2] | 0;
	                                    i = e;
	                                    return l | 0
	                                } while (0);
	                                c[f >> 2] = c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2];
	                                l = c[f >> 2] | 0;
	                                i = e;
	                                return l | 0
	                            }
	                            default:
	                                break a
	                        }
	                    } while (0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function ds(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                a:do if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if (!(c[h >> 2] | 0)) {
	                        if (!(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[f >> 2] = 0;
	                            break
	                        }
	                        switch (c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) {
	                            case 2:
	                            {
	                                c[j >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                                c[f >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                break a;
	                                break
	                            }
	                            case 18:
	                            {
	                                c[k >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                                if ((c[c[k >> 2] >> 2] | 0) != 0 ? (c[(c[c[k >> 2] >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                                    c[f >> 2] = c[c[k >> 2] >> 2];
	                                    break a
	                                }
	                                c[f >> 2] = 0;
	                                break a;
	                                break
	                            }
	                            case 20:
	                            case 19:
	                            case 12:
	                            case 17:
	                            case 16:
	                            case 15:
	                            case 14:
	                            case 8:
	                            case 7:
	                            case 6:
	                            case 5:
	                            case 4:
	                            case 3:
	                            case 1:
	                            {
	                                b = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                                if (!(c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0)) {
	                                    c[f >> 2] = c[b >> 2];
	                                    break a
	                                }
	                                do if ((c[(c[(c[b + 4 >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                    if ((d[c[(c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) != 32 ? (qy(c[(c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 129152) | 0) == 0 : 0)break;
	                                    c[f >> 2] = 0;
	                                    break a
	                                } while (0);
	                                c[f >> 2] = c[(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2];
	                                break a;
	                                break
	                            }
	                            case 21:
	                            case 13:
	                            case 11:
	                            case 10:
	                            case 9:
	                            {
	                                c[f >> 2] = 0;
	                                break a;
	                                break
	                            }
	                            default:
	                            {
	                                c[f >> 2] = 0;
	                                break a
	                            }
	                        }
	                    }
	                    if ((c[h >> 2] | 0) == (c[(c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[f >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        break
	                    }
	                    if ((c[h >> 2] | 0) == (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    switch (c[(c[h >> 2] | 0) + 4 >> 2] | 0) {
	                        case 21:
	                        case 13:
	                        case 11:
	                        case 10:
	                        case 9:
	                        {
	                            c[f >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 18:
	                        {
	                            c[m >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                            if ((c[c[m >> 2] >> 2] | 0) != 0 ? (c[(c[c[m >> 2] >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                                c[f >> 2] = c[c[m >> 2] >> 2];
	                                break a
	                            }
	                            c[f >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 20:
	                        case 19:
	                        case 17:
	                        case 16:
	                        case 15:
	                        case 14:
	                        case 12:
	                        case 8:
	                        case 7:
	                        case 6:
	                        case 5:
	                        case 4:
	                        case 3:
	                        case 1:
	                        {
	                            if (!(c[(c[h >> 2] | 0) + 20 >> 2] | 0)) {
	                                c[f >> 2] = 0;
	                                break a
	                            }
	                            do if ((c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                if ((d[c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) != 32 ? (qy(c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 129152) | 0) == 0 : 0)break;
	                                c[f >> 2] = 0;
	                                break a
	                            } while (0);
	                            c[f >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                            break a;
	                            break
	                        }
	                        case 2:
	                        {
	                            c[l >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                            c[f >> 2] = c[(c[l >> 2] | 0) + 20 >> 2];
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[f >> 2] = 0;
	                            break a
	                        }
	                    }
	                } else n = 3; while (0);
	                if ((n | 0) == 3)c[f >> 2] = 0;
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function es(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    b = c[f >> 2] | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = c[(c[b + 12 >> 2] | 0) + 4 >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else {
	                        c[e >> 2] = ds(b, c[g >> 2] | 0) | 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function fs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[g >> 2] | 0) == (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if (!(c[g >> 2] | 0)) {
	                            c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 24 >> 2];
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        } else {
	                            c[e >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                    }
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function gs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[g >> 2] | 0) == (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if (!(c[g >> 2] | 0)) {
	                            c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 28 >> 2];
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if (((c[(c[g >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) == 14 : 0) ? (c[g >> 2] = c[(c[g >> 2] | 0) + 28 >> 2], (c[g >> 2] | 0) == 0) : 0) {
	                            c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 28 >> 2];
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function hs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if ((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    do if (!(c[g >> 2] | 0)) {
	                        c[g >> 2] = c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                            c[e >> 2] = 0;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        } else {
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 2)break;
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            break
	                        }
	                    } while (0);
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    while (1) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                        if (!(c[g >> 2] | 0)) {
	                            j = 24;
	                            break
	                        }
	                        if ((c[g >> 2] | 0) == (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                            j = 20;
	                            break
	                        }
	                        k = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            j = 22;
	                            break
	                        }
	                        if (!k) {
	                            j = 24;
	                            break
	                        }
	                    }
	                    if ((j | 0) == 20) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((j | 0) == 22) {
	                        c[e >> 2] = c[k + 24 >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((j | 0) == 24) {
	                        c[e >> 2] = c[g >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function is(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if ((c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0) == 0 ? (c[g >> 2] | 0) != (c[32294] | 0) : 0) {
	                        if (c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0);
	                        g = bj(c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0, c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] = g;
	                        c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 124 >> 2] = 0;
	                        a:do if (c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0)while (1) {
	                            if (!(c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0) + (c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 124 >> 2] << 2) >> 2] | 0))break a;
	                            g = (c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 124 | 0;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        } while (0);
	                        c[e >> 2] = c[32294];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    g = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                    if ((c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 124 >> 2] | 0) > 0) {
	                        b = g + 124 | 0;
	                        a = (c[b >> 2] | 0) + -1 | 0;
	                        c[b >> 2] = a;
	                        c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0) + (a << 2) >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if (c[g + 120 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] | 0);
	                    c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 120 >> 2] = 0;
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function js(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if (!(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if (c[g >> 2] | 0) {
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = c[(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) + 44 >> 2];
	                        break
	                    }
	                } else h = 3; while (0);
	                if ((h | 0) == 3)c[e >> 2] = 0;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function ks(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[(c[d >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[c[(c[d >> 2] | 0) + 12 >> 2] >> 2];
	                a = c[d >> 2] | 0;
	                Tq(a, yt(c[(c[d >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[d >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                i = b;
	                return
	            }

	            function ls(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 0 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[(c[f + 12 >> 2] | 0) + 68 >> 2] | 0) >= 0) {
	                    Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] | 0)) | 0) | 0;
	                    i = d;
	                    return
	                } else {
	                    Nq(b, 13);
	                    i = d;
	                    return
	                }
	            }

	            function ms(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 0 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[(c[f + 12 >> 2] | 0) + 72 >> 2] | 0) >= 0) {
	                    Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] | 0)) | 0) | 0;
	                    i = d;
	                    return
	                } else {
	                    Nq(b, 14);
	                    i = d;
	                    return
	                }
	            }

	            function ns(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    do if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[c[g >> 2] >> 2] | 0) != 9 : 0) {
	                            if ((c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                c[j >> 2] = 0;
	                                c[h >> 2] = c[c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2];
	                                a:do if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                                    c[h >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                                    while (1) {
	                                        if (!(c[h >> 2] | 0))break a;
	                                        c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                                    }
	                                } while (0);
	                                b = c[e >> 2] | 0;
	                                Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +(c[j >> 2] | 0)) | 0) | 0;
	                                break
	                            }
	                            b = c[e >> 2] | 0;
	                            Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 0.0) | 0) | 0;
	                            break
	                        }
	                        b = c[e >> 2] | 0;
	                        Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +(c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0)) | 0) | 0
	                    } else k = 12; while (0);
	                    if ((k | 0) == 12) {
	                        b = c[e >> 2] | 0;
	                        Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 0.0) | 0) | 0
	                    }
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function os(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                c[j >> 2] = Sq(f) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Nq(c[e >> 2] | 0, 10);
	                    i = d;
	                    return
	                }
	                if ((c[c[j >> 2] >> 2] | 0) != 1 ? (c[c[j >> 2] >> 2] | 0) != 9 : 0) {
	                    c[j >> 2] = Bt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[h >> 2] = zt(c[c[(c[e >> 2] | 0) + 12 >> 2] >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    f = c[e >> 2] | 0;
	                    Tq(f, At(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0) | 0) | 0;
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                    i = d;
	                    return
	                }
	                c[h >> 2] = $q(0) | 0;
	                a:do if (c[(c[j >> 2] | 0) + 4 >> 2] | 0) {
	                    c[l >> 2] = 0;
	                    while (1) {
	                        if ((c[l >> 2] | 0) >= (c[c[(c[j >> 2] | 0) + 4 >> 2] >> 2] | 0))break a;
	                        c[g >> 2] = ir(c[(c[(c[(c[j >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0;
	                        c[k >> 2] = zt(c[c[(c[e >> 2] | 0) + 12 >> 2] >> 2] | 0, c[g >> 2] | 0) | 0;
	                        c[h >> 2] = er(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        fr(c[k >> 2] | 0);
	                        if (c[g >> 2] | 0)zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                } while (0);
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                j = c[e >> 2] | 0;
	                Tq(j, At(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0) | 0) | 0;
	                i = d;
	                return
	            }

	            function ps(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[g >> 2] | 0)) {
	                    b = c[f >> 2] | 0;
	                    Tq(b, yt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                    c[g >> 2] = 1
	                }
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if ((c[g >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = e;
	                    return
	                }
	                g = c[f >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(g, 23);
	                    i = e;
	                    return
	                }
	                do if (c[g + 16 >> 2] | 0) {
	                    if ((c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[h >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    do if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0) {
	                        c[j >> 2] = 0;
	                        b = c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0;
	                        if ((b | 0) == 7 | (b | 0) == 2 | (b | 0) == 1) {
	                            a = c[f >> 2] | 0;
	                            k = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                            if ((d[c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) == 32) {
	                                Tq(a, Ct(k, 128928) | 0) | 0;
	                                break
	                            } else {
	                                Tq(a, Dt(k, c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                                break
	                            }
	                        } else if ((b | 0) == 18) {
	                            b = c[f >> 2] | 0;
	                            Tq(b, Dt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0) | 0) | 0;
	                            break
	                        } else {
	                            b = c[f >> 2] | 0;
	                            Tq(b, Ct(c[(c[f >> 2] | 0) + 12 >> 2] | 0, 128928) | 0) | 0;
	                            break
	                        }
	                    } else l = 15; while (0);
	                    if ((l | 0) == 15) {
	                        b = c[f >> 2] | 0;
	                        Tq(b, Ct(c[(c[f >> 2] | 0) + 12 >> 2] | 0, 128928) | 0) | 0
	                    }
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                    i = e;
	                    return
	                } while (0);
	                Nq(c[f >> 2] | 0, 11);
	                i = e;
	                return
	            }

	            function qs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[f >> 2] | 0)) {
	                    b = c[e >> 2] | 0;
	                    Tq(b, yt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                    c[f >> 2] = 1
	                }
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0) {
	                        c[h >> 2] = 0;
	                        if (((c[(c[(c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) + -1 | 0) >>> 0 >= 2) {
	                            b = c[e >> 2] | 0;
	                            Tq(b, Ct(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 128928) | 0) | 0;
	                            break
	                        }
	                        b = c[e >> 2] | 0;
	                        a = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                        if (!(c[(c[(c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 36 >> 2] | 0)) {
	                            Tq(b, Ct(a, 128928) | 0) | 0;
	                            break
	                        } else {
	                            Tq(b, Dt(a, c[(c[(c[(c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                            break
	                        }
	                    } else j = 15; while (0);
	                    if ((j | 0) == 15) {
	                        a = c[e >> 2] | 0;
	                        Tq(a, Ct(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 128928) | 0) | 0
	                    }
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function rs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    a = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                    Tq(b, Et(a, ir(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	                if (!b) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                c[g >> 2] = Sq(f) | 0;
	                f = c[e >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    Nq(f, 10);
	                    i = d;
	                    return
	                } else {
	                    Tq(f, Bt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function ss(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = (c[e >> 2] | 0) == 0;
	                if (!(c[f >> 2] | 0)) {
	                    if (b) {
	                        i = d;
	                        return
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 12 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    a = c[e >> 2] | 0;
	                    if (!(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        Tq(a, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 0.0) | 0) | 0;
	                        i = d;
	                        return
	                    } else {
	                        c[h >> 2] = ir(c[(c[a + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        a = c[e >> 2] | 0;
	                        j = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                        Tq(a, wt(j, +(Dy(c[h >> 2] | 0) | 0)) | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                }
	                if (b) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                    c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    f = c[e >> 2] | 0;
	                    b = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                    Tq(f, wt(b, +(Dy(c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0)) | 0) | 0;
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function ts(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[f >> 2] | 0) < 2) {
	                    if (!(c[e >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    b = c[e >> 2] | 0;
	                    if ((c[f >> 2] | 0) != 2) {
	                        Nq(b, 12);
	                        i = d;
	                        return
	                    }
	                    if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                        Nq(c[e >> 2] | 0, 23);
	                        i = d;
	                        return
	                    }
	                }
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                if ((c[g >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) == 4 : 0) {
	                    c[f >> 2] = (c[f >> 2] | 0) + -1;
	                    while (1) {
	                        k = c[e >> 2] | 0;
	                        if ((c[f >> 2] | 0) <= 0) {
	                            l = 23;
	                            break
	                        }
	                        if ((c[k + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                        c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            l = 21;
	                            break
	                        }
	                        if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                            l = 21;
	                            break
	                        }
	                        c[j >> 2] = By(c[(c[h >> 2] | 0) + 24 >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        c[(c[h >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                        c[f >> 2] = (c[f >> 2] | 0) + -1
	                    }
	                    if ((l | 0) == 21) {
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                        Nq(c[e >> 2] | 0, 11);
	                        i = d;
	                        return
	                    } else if ((l | 0) == 23) {
	                        Tq(k, c[g >> 2] | 0) | 0;
	                        i = d;
	                        return
	                    }
	                }
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function us(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 2) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                    c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    if ((c[g >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) == 4 : 0) {
	                        f = (wy(c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0) != 0;
	                        b = c[e >> 2] | 0;
	                        a = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                        if (f)Tq(b, Ft(a, 1) | 0) | 0; else Tq(b, Ft(a, 0) | 0) | 0;
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                    Nq(c[e >> 2] | 0, 11);
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function vs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 2) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                    c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    if ((c[g >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) == 4 : 0) {
	                        c[j >> 2] = xy(c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        f = (sy(c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0, c[j >> 2] | 0) | 0) != 0;
	                        j = c[e >> 2] | 0;
	                        b = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                        if (f)Tq(j, Ft(b, 0) | 0) | 0; else Tq(j, Ft(b, 1) | 0) | 0;
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                    Nq(c[e >> 2] | 0, 11);
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function ws(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 48 | 0;
	                f = d + 44 | 0;
	                g = d + 40 | 0;
	                j = d + 36 | 0;
	                k = d + 32 | 0;
	                l = d + 8 | 0;
	                m = d;
	                n = d + 28 | 0;
	                o = d + 24 | 0;
	                p = d + 20 | 0;
	                q = d + 16 | 0;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                h[l >> 3] = 0.0;
	                if ((c[f >> 2] | 0) < 2) {
	                    if (!(c[e >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    b = c[e >> 2] | 0;
	                    if ((c[f >> 2] | 0) != 2) {
	                        Nq(b, 12);
	                        i = d;
	                        return
	                    }
	                    if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                        Nq(c[e >> 2] | 0, 23);
	                        i = d;
	                        return
	                    }
	                }
	                if ((c[f >> 2] | 0) > 3) {
	                    if (!(c[e >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    b = c[e >> 2] | 0;
	                    if ((c[f >> 2] | 0) != 3) {
	                        Nq(b, 12);
	                        i = d;
	                        return
	                    }
	                    if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 3 | 0)) {
	                        Nq(c[e >> 2] | 0, 23);
	                        i = d;
	                        return
	                    }
	                }
	                do if ((c[f >> 2] | 0) == 3) {
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[e >> 2] | 0, 1);
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                        c[k >> 2] = Sq(c[e >> 2] | 0) | 0;
	                        h[l >> 3] = +h[(c[k >> 2] | 0) + 16 >> 3];
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0);
	                        break
	                    }
	                    Nq(c[e >> 2] | 0, 11);
	                    i = d;
	                    return
	                } while (0);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    c[j >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    h[m >> 3] = +h[(c[j >> 2] | 0) + 16 >> 3];
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                        c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                        c[p >> 2] = Dy(c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        if ((c[f >> 2] | 0) != 3 ? (h[l >> 3] = +(c[p >> 2] | 0), +h[m >> 3] < 1.0) : 0)h[m >> 3] = 1.0;
	                        if ((Mq(+h[m >> 3]) | 0) == 0 ? (Lq(+h[m >> 3] + +h[l >> 3]) | 0) == 0 : 0) {
	                            c[n >> 2] = ~~+h[m >> 3];
	                            if (+(c[n >> 2] | 0) + .5 <= +h[m >> 3])c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            do if ((Mq(+h[l >> 3]) | 0) == 1) {
	                                c[o >> 2] = c[p >> 2];
	                                if ((c[n >> 2] | 0) < 1)c[n >> 2] = 1
	                            } else {
	                                m = (Mq(+h[l >> 3]) | 0) == -1;
	                                if (m | +h[l >> 3] < 0.0) {
	                                    c[o >> 2] = 0;
	                                    break
	                                }
	                                c[o >> 2] = ~~+h[l >> 3];
	                                if (+(c[o >> 2] | 0) + .5 <= +h[l >> 3])c[o >> 2] = (c[o >> 2] | 0) + 1
	                            } while (0);
	                            c[n >> 2] = (c[n >> 2] | 0) - 1;
	                            c[o >> 2] = (c[o >> 2] | 0) + (c[n >> 2] | 0);
	                            if ((c[n >> 2] | 0) < 0)c[n >> 2] = 0;
	                            if ((c[o >> 2] | 0) > (c[p >> 2] | 0))c[o >> 2] = c[p >> 2];
	                            c[o >> 2] = (c[o >> 2] | 0) - (c[n >> 2] | 0);
	                            c[q >> 2] = Ky(c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0
	                        } else c[q >> 2] = 0;
	                        o = c[e >> 2] | 0;
	                        n = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                        if (!(c[q >> 2] | 0))Tq(o, Ct(n, 128928) | 0) | 0; else {
	                            Tq(o, Dt(n, c[q >> 2] | 0) | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0)
	                        }
	                        jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    Nq(c[e >> 2] | 0, 11);
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function xs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 2) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                c[j >> 2] = Ly() | 0;
	                if (c[j >> 2] | 0) {
	                    c[k >> 2] = wy(c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[l >> 2] = (c[k >> 2] | 0) - (c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                        cz(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[l >> 2] | 0) | 0
	                    }
	                    l = c[e >> 2] | 0;
	                    k = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                    Tq(l, Dt(k, Vy(c[j >> 2] | 0) | 0) | 0) | 0;
	                    Ry(c[j >> 2] | 0)
	                }
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                i = d;
	                return
	            }

	            function ys(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 2) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[e >> 2] | 0, 1);
	                c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                c[j >> 2] = Ly() | 0;
	                if (c[j >> 2] | 0) {
	                    c[k >> 2] = wy(c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0) {
	                        f = (c[k >> 2] | 0) - (c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        c[l >> 2] = f + (xy(c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0);
	                        f = c[j >> 2] | 0;
	                        k = (c[(c[g >> 2] | 0) + 24 >> 2] | 0) + (c[l >> 2] | 0) | 0;
	                        b = xy(c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        cz(f, k, b - (c[l >> 2] | 0) | 0) | 0
	                    }
	                    l = c[e >> 2] | 0;
	                    b = c[(c[e >> 2] | 0) + 12 >> 2] | 0;
	                    Tq(l, Dt(b, Vy(c[j >> 2] | 0) | 0) | 0) | 0;
	                    Ry(c[j >> 2] | 0)
	                }
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                i = d;
	                return
	            }

	            function zs(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                m = f + 20 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[h >> 2] | 0)) {
	                    e = c[g >> 2] | 0;
	                    b = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                    Tq(e, Et(b, ir(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0) | 0;
	                    c[h >> 2] = 1
	                }
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                b = c[g >> 2] | 0;
	                if ((c[h >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = f;
	                    return
	                }
	                h = c[g >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(h, 23);
	                    i = f;
	                    return
	                }
	                if ((c[h + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[g >> 2] | 0, 1);
	                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                    c[j >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                    c[l >> 2] = Ly() | 0;
	                    if ((c[l >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                        a:while (1) {
	                            do if ((d[c[k >> 2] >> 0] | 0) != 32) {
	                                if (9 <= (d[c[k >> 2] >> 0] | 0) ? (d[c[k >> 2] >> 0] | 0) <= 10 : 0)break;
	                                if ((d[c[k >> 2] >> 0] | 0) != 13)break a
	                            } while (0);
	                            c[k >> 2] = (c[k >> 2] | 0) + 1
	                        }
	                        a[m >> 0] = 0;
	                        while (1) {
	                            if (!(a[c[k >> 2] >> 0] | 0))break;
	                            do if ((d[c[k >> 2] >> 0] | 0) != 32) {
	                                if (9 <= (d[c[k >> 2] >> 0] | 0) ? (d[c[k >> 2] >> 0] | 0) <= 10 : 0) {
	                                    n = 27;
	                                    break
	                                }
	                                if ((d[c[k >> 2] >> 0] | 0) != 13) {
	                                    if (a[m >> 0] | 0) {
	                                        cz(c[l >> 2] | 0, m, 1) | 0;
	                                        a[m >> 0] = 0
	                                    }
	                                    cz(c[l >> 2] | 0, c[k >> 2] | 0, 1) | 0
	                                } else n = 27
	                            } else n = 27; while (0);
	                            if ((n | 0) == 27) {
	                                n = 0;
	                                a[m >> 0] = 32
	                            }
	                            c[k >> 2] = (c[k >> 2] | 0) + 1
	                        }
	                        k = c[g >> 2] | 0;
	                        m = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                        Tq(k, Dt(m, Vy(c[l >> 2] | 0) | 0) | 0) | 0;
	                        Ry(c[l >> 2] | 0)
	                    }
	                    jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                    i = f;
	                    return
	                }
	                Nq(c[g >> 2] | 0, 11);
	                i = f;
	                return
	            }

	            function As(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 44 | 0;
	                r = f + 8 | 0;
	                s = f + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                e = c[h >> 2] | 0;
	                if ((c[j >> 2] | 0) != 3) {
	                    Nq(e, 12);
	                    i = f;
	                    return
	                }
	                j = c[h >> 2] | 0;
	                if ((c[e + 20 >> 2] | 0) < ((c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 3 | 0)) {
	                    Nq(j, 23);
	                    i = f;
	                    return
	                }
	                if ((c[j + 16 >> 2] | 0) != 0 ? (c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[h >> 2] | 0, 1);
	                c[m >> 2] = Sq(c[h >> 2] | 0) | 0;
	                if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[h >> 2] | 0, 1);
	                c[l >> 2] = Sq(c[h >> 2] | 0) | 0;
	                if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[h >> 2] | 0, 1);
	                c[k >> 2] = Sq(c[h >> 2] | 0) | 0;
	                c[n >> 2] = Ly() | 0;
	                a:do if (c[n >> 2] | 0) {
	                    c[p >> 2] = Dy(c[(c[m >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    c[s >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        j = a[c[s >> 2] >> 0] | 0;
	                        a[q >> 0] = j;
	                        if (!(j << 24 >> 24))break a;
	                        c[o >> 2] = Jy(c[(c[l >> 2] | 0) + 24 >> 2] | 0, c[s >> 2] | 0) | 0;
	                        if ((c[o >> 2] | 0) >= 0) {
	                            if ((c[o >> 2] | 0) < (c[p >> 2] | 0) ? (c[r >> 2] = Iy(c[(c[m >> 2] | 0) + 24 >> 2] | 0, c[o >> 2] | 0) | 0, (c[r >> 2] | 0) != 0) : 0) {
	                                j = c[n >> 2] | 0;
	                                e = c[r >> 2] | 0;
	                                cz(j, e, Gy(c[r >> 2] | 0, 1) | 0) | 0
	                            }
	                        } else {
	                            e = c[n >> 2] | 0;
	                            j = c[s >> 2] | 0;
	                            cz(e, j, Gy(c[s >> 2] | 0, 1) | 0) | 0
	                        }
	                        c[s >> 2] = (c[s >> 2] | 0) + 1;
	                        if (!((d[q >> 0] | 0) & 128))continue;
	                        if (((d[q >> 0] | 0) & 192 | 0) != 192)break;
	                        while (1) {
	                            j = (d[q >> 0] | 0) << 1 & 255;
	                            a[q >> 0] = j;
	                            if (!(j & 128))break;
	                            j = c[s >> 2] | 0;
	                            c[s >> 2] = j + 1;
	                            if (((d[j >> 0] | 0) & 192 | 0) != 128) {
	                                t = 28;
	                                break
	                            }
	                        }
	                        if ((t | 0) == 28) {
	                            t = 0;
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 129184, g)
	                        }
	                        if ((d[q >> 0] | 0) & 128)break a
	                    }
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 129184, g)
	                } while (0);
	                g = c[h >> 2] | 0;
	                q = c[(c[h >> 2] | 0) + 12 >> 2] | 0;
	                Tq(g, Dt(q, Vy(c[n >> 2] | 0) | 0) | 0) | 0;
	                Ry(c[n >> 2] | 0);
	                jt(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0);
	                jt(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0);
	                jt(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                i = f;
	                return
	            }

	            function Bs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                c[g >> 2] = Sq(f) | 0;
	                f = c[e >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    Nq(f, 10);
	                    i = d;
	                    return
	                } else {
	                    c[g >> 2] = Gt(c[f + 12 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    Tq(c[e >> 2] | 0, c[g >> 2] | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function Cs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 2 : 0)Bs(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 2 : 0) {
	                    c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] = ((c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) != 0 ^ 1) & 1;
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function Ds(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 0 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                } else {
	                    Tq(f, Ft(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 1) | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function Es(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 0 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                } else {
	                    Tq(f, Ft(c[(c[e >> 2] | 0) + 12 >> 2] | 0, 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function Fs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[l >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if ((c[g >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = e;
	                    return
	                }
	                g = c[f >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(g, 23);
	                    i = e;
	                    return
	                }
	                if ((c[g + 16 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[f >> 2] | 0, 1);
	                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                    c[h >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    c[j >> 2] = Ti(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    a:do if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                        c[m >> 2] = 0;
	                        while (1) {
	                            n = c[m >> 2] | 0;
	                            if (!(d[(c[k >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0))break;
	                            g = WS(d[(c[k >> 2] | 0) + n >> 0] | 0) | 0;
	                            if ((g | 0) != (WS(d[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0) | 0))break a;
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        }
	                        if ((d[(c[j >> 2] | 0) + n >> 0] | 0 | 0) != 0 ? (d[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0 | 0) != 45 : 0)break;
	                        c[l >> 2] = 1
	                    } while (0);
	                    if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                    h = c[f >> 2] | 0;
	                    Tq(h, Ft(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0) | 0) | 0;
	                    i = e;
	                    return
	                }
	                Nq(c[f >> 2] | 0, 11);
	                i = e;
	                return
	            }

	            function Gs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0.0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                h[k >> 3] = 0.0;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[g >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    a:do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0) {
	                        c[j >> 2] = 0;
	                        while (1) {
	                            if ((c[j >> 2] | 0) >= (c[c[(c[g >> 2] | 0) + 4 >> 2] >> 2] | 0))break a;
	                            l = +Gr(c[(c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0);
	                            h[k >> 3] = +h[k >> 3] + l;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    b = c[e >> 2] | 0;
	                    Tq(b, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +h[k >> 3]) | 0) | 0;
	                    jt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0);
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function Hs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0.0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    h[g >> 3] = +uT(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3], 2147483647.0);
	                    h[g >> 3] = +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] - +h[g >> 3] + +(~~+h[g >> 3] | 0);
	                    if (!(+h[g >> 3] != +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3])) {
	                        i = d;
	                        return
	                    }
	                    j = +h[g >> 3];
	                    if (+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] > 0.0) {
	                        h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = j;
	                        i = d;
	                        return
	                    } else {
	                        h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = j - 1.0;
	                        i = d;
	                        return
	                    }
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function Is(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    h[g >> 3] = +uT(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3], 2147483647.0);
	                    h[g >> 3] = +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] - +h[g >> 3] + +(~~+h[g >> 3] | 0);
	                    if (!(+h[g >> 3] != +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3])) {
	                        i = d;
	                        return
	                    }
	                    if (+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] > 0.0) {
	                        h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[g >> 3] + 1.0;
	                        i = d;
	                        return
	                    }
	                    if (+h[g >> 3] == 0.0 ? +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] < 0.0 : 0) {
	                        h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15988];
	                        i = d;
	                        return
	                    } else {
	                        h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[g >> 3];
	                        i = d;
	                        return
	                    }
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function Js(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0.0, k = 0.0, l = 0.0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[e >> 2] | 0, 1);
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                    if (Lq(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) {
	                        i = d;
	                        return
	                    }
	                    if ((Mq(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) == 1) {
	                        i = d;
	                        return
	                    }
	                    if ((Mq(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3]) | 0) == -1) {
	                        i = d;
	                        return
	                    }
	                    if (+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] == 0.0) {
	                        i = d;
	                        return
	                    }
	                    h[g >> 3] = +uT(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3], 2147483647.0);
	                    h[g >> 3] = +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] - +h[g >> 3] + +(~~+h[g >> 3] | 0);
	                    j = +h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3];
	                    k = +h[g >> 3];
	                    if (!(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] < 0.0)) {
	                        l = +h[g >> 3];
	                        if (j < k + .5) {
	                            h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = l;
	                            i = d;
	                            return
	                        } else {
	                            h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = l + 1.0;
	                            i = d;
	                            return
	                        }
	                    }
	                    l = +h[g >> 3];
	                    if (j < k - .5)h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = l - 1.0; else h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = l;
	                    if (!(+h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] == 0.0)) {
	                        i = d;
	                        return
	                    }
	                    h[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 3] = +h[15988];
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function Ks(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) {
	                    c[g >> 2] = c[c[f >> 2] >> 2];
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)k = 9; else k = 6;
	                    do if ((k | 0) == 6) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                            k = 9;
	                            break
	                        }
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) == 95)k = 9
	                    } while (0);
	                    do if ((k | 0) == 9) {
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        while (1) {
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)l = 1; else k = 12;
	                            do if ((k | 0) == 12) {
	                                k = 0;
	                                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                if ((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 46 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) == 45; else l = 1
	                            } while (0);
	                            m = c[g >> 2] | 0;
	                            if (!l)break;
	                            c[g >> 2] = m + 1
	                        }
	                        if ((((((((d[m >> 0] | 0 | 0) != 32 ? (d[c[g >> 2] >> 0] | 0 | 0) != 62 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 47 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 91 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 93 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 64 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 42 : 0)break;
	                        c[j >> 2] = (c[g >> 2] | 0) - (c[c[f >> 2] >> 2] | 0);
	                        if (!(c[j >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            n = c[e >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        } else {
	                            c[h >> 2] = ly(c[c[f >> 2] >> 2] | 0, c[j >> 2] | 0) | 0;
	                            c[c[f >> 2] >> 2] = c[g >> 2];
	                            c[e >> 2] = c[h >> 2];
	                            n = c[e >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        }
	                    } while (0);
	                    c[e >> 2] = Ht(c[f >> 2] | 0, 0) | 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function Ls(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) {
	                    c[g >> 2] = c[c[f >> 2] >> 2];
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)k = 10; else k = 6;
	                    do if ((k | 0) == 6) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                            k = 10;
	                            break
	                        }
	                        if (!((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0))k = 10
	                    } while (0);
	                    if ((k | 0) == 10) {
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        while (1) {
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)l = 1; else k = 13;
	                            do if ((k | 0) == 13) {
	                                k = 0;
	                                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                if (((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) == 46; else l = 1
	                            } while (0);
	                            m = c[g >> 2] | 0;
	                            if (!l)break;
	                            c[g >> 2] = m + 1
	                        }
	                        if ((d[m >> 0] | 0 | 0) > 0 ? (d[c[g >> 2] >> 0] | 0 | 0) < 128 : 0) {
	                            c[j >> 2] = (c[g >> 2] | 0) - (c[c[f >> 2] >> 2] | 0);
	                            if ((c[j >> 2] | 0) >>> 0 > 5e4) {
	                                c[c[f >> 2] >> 2] = c[g >> 2];
	                                Nq(c[f >> 2] | 0, 7);
	                                c[e >> 2] = 0;
	                                n = c[e >> 2] | 0;
	                                i = b;
	                                return n | 0
	                            } else {
	                                c[h >> 2] = ly(c[c[f >> 2] >> 2] | 0, c[j >> 2] | 0) | 0;
	                                c[c[f >> 2] >> 2] = c[g >> 2];
	                                c[e >> 2] = c[h >> 2];
	                                n = c[e >> 2] | 0;
	                                i = b;
	                                return n | 0
	                            }
	                        }
	                    }
	                    c[e >> 2] = Ht(c[f >> 2] | 0, 1) | 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function Ms(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    if (qy(c[e >> 2] | 0, 129400) | 0) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[e >> 2] | 0, 129408) | 0) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[e >> 2] | 0, 129416) | 0) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[e >> 2] | 0, 129424) | 0) {
	                        c[d >> 2] = 1;
	                        break
	                    } else {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Ns(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                a:do if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0)c[g >> 2] = 0; else switch (c[c[k >> 2] >> 2] | 0) {
	                    case 9:
	                    case 1:
	                    {
	                        if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[g >> 2] = 0;
	                            break a
	                        } else {
	                            c[g >> 2] = (c[c[(c[k >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 & 1;
	                            break a
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        c[g >> 2] = c[(c[k >> 2] | 0) + 8 >> 2];
	                        break a;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[l >> 2] = c[(c[k >> 2] | 0) + 28 >> 2];
	                        if (!(c[l >> 2] | 0)) {
	                            c[g >> 2] = 0;
	                            break a
	                        } else {
	                            c[g >> 2] = (c[c[l >> 2] >> 2] | 0) != 0 & 1;
	                            break a
	                        }
	                        break
	                    }
	                    case 4:
	                    {
	                        if (c[(c[k >> 2] | 0) + 24 >> 2] | 0)m = (d[c[(c[k >> 2] | 0) + 24 >> 2] >> 0] | 0 | 0) != 0; else m = 0;
	                        c[g >> 2] = m & 1;
	                        break a;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[g >> 2] = +h[(c[k >> 2] | 0) + 16 >> 3] == +(c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] | 0) & 1;
	                        break a;
	                        break
	                    }
	                    default:
	                    {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[f >> 2] = 128552;
	                        c[f + 4 >> 2] = 14647;
	                        Db[b & 511](a, 129448, f);
	                        c[g >> 2] = 0;
	                        break a
	                    }
	                } while (0);
	                i = e;
	                return c[g >> 2] | 0
	            }

	            function Os(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[k >> 2] = It(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                Kq();
	                c[j >> 2] = Or(c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                Jt(c[j >> 2] | 0, 1);
	                g = c[j >> 2] | 0;
	                if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                    Pr(g);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                b = c[j >> 2] | 0;
	                if (d[c[g >> 2] >> 0] | 0) {
	                    Oq(b, 128552, 14835, 7);
	                    c[k >> 2] = 0
	                } else {
	                    c[k >> 2] = c[b + 32 >> 2];
	                    c[(c[j >> 2] | 0) + 32 >> 2] = 0
	                }
	                Pr(c[j >> 2] | 0);
	                if (((c[k >> 2] | 0) != 0 ? (j = my(c[h >> 2] | 0) | 0, c[(c[k >> 2] | 0) + 16 >> 2] = j, (c[c[k >> 2] >> 2] | 0) > 1) : 0) ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) >= 0 : 0)Kt(c[k >> 2] | 0, (c[(c[k >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 12 >> 2] | 0) * 40 | 0) | 0);
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Ps(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                Lt(c[e >> 2] | 0, c[f >> 2] | 0, g, 0) | 0;
	                i = d;
	                return c[g >> 2] | 0
	            }

	            function Qs(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[f >> 2] = It(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[(c[e >> 2] | 0) + 4 >> 2] | 0) | 0;
	                a = c[e >> 2] | 0;
	                a:do if (c[f >> 2] | 0) {
	                    if (c[a + 32 >> 2] | 0)Pq(c[(c[e >> 2] | 0) + 32 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                    if (c[c[e >> 2] >> 2] | 0)while (1) {
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))break a;
	                        g = c[e >> 2] | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                } else {
	                    Jt(a, 1);
	                    if ((((c[(c[e >> 2] | 0) + 8 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[c[(c[e >> 2] | 0) + 32 >> 2] >> 2] | 0) > 1 : 0) ? (c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0) >= 0 : 0)Kt(c[(c[e >> 2] | 0) + 32 >> 2] | 0, (c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0) * 40 | 0) | 0)
	                } while (0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                Mt(c[e >> 2] | 0, 0) | 0;
	                i = b;
	                return
	            }

	            function Rs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    Xd(0, 0, 0, 0, 0, 12, 1, 3, 128552, 15056, 0, 0, 0, 0, 0, 129480, f);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                Kq();
	                c[k >> 2] = Or(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                Qs(c[k >> 2] | 0);
	                do if (!(c[(c[k >> 2] | 0) + 16 >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 129504, f);
	                    c[l >> 2] = 0
	                } else {
	                    if (((d[c[c[k >> 2] >> 2] >> 0] | 0 | 0) != 0 ? (c[(c[k >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                        Oq(c[k >> 2] | 0, 128552, 15074, 7);
	                        c[l >> 2] = 0;
	                        break
	                    }
	                    c[l >> 2] = Sq(c[k >> 2] | 0) | 0
	                } while (0);
	                do {
	                    c[m >> 2] = Sq(c[k >> 2] | 0) | 0;
	                    if (c[m >> 2] | 0) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        jt(c[j >> 2] | 0, c[m >> 2] | 0)
	                    }
	                } while ((c[m >> 2] | 0) != 0);
	                if ((c[o >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0) {
	                    m = c[33976] | 0;
	                    j = c[33980] | 0;
	                    c[f >> 2] = c[o >> 2];
	                    Db[m & 511](j, 129544, f)
	                }
	                if (c[(c[k >> 2] | 0) + 8 >> 2] | 0) {
	                    Qq(c[l >> 2] | 0);
	                    c[l >> 2] = 0
	                }
	                Pr(c[k >> 2] | 0);
	                c[g >> 2] = c[l >> 2];
	                p = c[g >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function Ss(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 16 | 0;
	                k = e + 8 | 0;
	                l = e + 24 | 0;
	                m = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = j;
	                c[d >> 2] = c[g >> 2];
	                c[d + 4 >> 2] = 0;
	                while (1) {
	                    d = j;
	                    g = c[d + 4 >> 2] | 0;
	                    if (!((g | 0) < 0 | ((g | 0) == 0 ? (c[d >> 2] | 0) >>> 0 < (c[h >> 2] | 0) >>> 0 : 0)))break;
	                    d = j;
	                    g = XT(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                    if ((Nt(c[(c[f >> 2] | 0) + (g << 2) >> 2] | 0, c[(c[f >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0) > 0) {
	                        c[l >> 2] = c[(c[f >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                        g = Ot(c[f >> 2] | 0, c[l >> 2] | 0, c[j >> 2] | 0) | 0;
	                        d = m;
	                        c[d >> 2] = g;
	                        c[d + 4 >> 2] = G;
	                        d = j;
	                        g = XT(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                        d = k;
	                        c[d >> 2] = g;
	                        c[d + 4 >> 2] = G;
	                        while (1) {
	                            d = k;
	                            g = c[d + 4 >> 2] | 0;
	                            b = m;
	                            a = c[b + 4 >> 2] | 0;
	                            if (!((g | 0) > (a | 0) | ((g | 0) == (a | 0) ? (c[d >> 2] | 0) >>> 0 >= (c[b >> 2] | 0) >>> 0 : 0)))break;
	                            b = c[(c[f >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0;
	                            d = k;
	                            a = bU(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                            c[(c[f >> 2] | 0) + (a << 2) >> 2] = b;
	                            b = k;
	                            a = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, -1, -1) | 0;
	                            b = k;
	                            c[b >> 2] = a;
	                            c[b + 4 >> 2] = G
	                        }
	                        c[(c[f >> 2] | 0) + (c[m >> 2] << 2) >> 2] = c[l >> 2]
	                    }
	                    b = j;
	                    a = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, 1, 0) | 0;
	                    b = j;
	                    c[b >> 2] = a;
	                    c[b + 4 >> 2] = G
	                }
	                i = e;
	                return
	            }

	            function Ts(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 16 | 0;
	                h = f + 32 | 0;
	                j = f + 8 | 0;
	                k = f + 28 | 0;
	                l = f;
	                m = f + 24 | 0;
	                c[h >> 2] = a;
	                a = j;
	                c[a >> 2] = b;
	                c[a + 4 >> 2] = d;
	                c[k >> 2] = e;
	                e = j;
	                d = XT(c[k >> 2] | 0, 0, c[e >> 2] | 0, c[e + 4 >> 2] | 0) | 0;
	                if ((d | 0) == 1 & (G | 0) == 0) {
	                    d = g;
	                    c[d >> 2] = 1;
	                    c[d + 4 >> 2] = 0;
	                    n = g;
	                    o = n;
	                    p = c[o >> 2] | 0;
	                    q = n + 4 | 0;
	                    r = q;
	                    s = c[r >> 2] | 0;
	                    G = s;
	                    i = f;
	                    return p | 0
	                }
	                d = j;
	                e = c[d >> 2] | 0;
	                a = c[d + 4 >> 2] | 0;
	                d = XT(c[k >> 2] | 0, 0, 2, 0) | 0;
	                b = G;
	                if ((a | 0) > (b | 0) | (a | 0) == (b | 0) & e >>> 0 >= d >>> 0) {
	                    if ((Nt(c[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 2) >> 2] | 0, c[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 2) >> 2] | 0) | 0) > 0) {
	                        c[m >> 2] = c[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 2) >> 2];
	                        c[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 2) >> 2] = c[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 2) >> 2];
	                        c[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 2) >> 2] = c[m >> 2]
	                    }
	                    m = g;
	                    c[m >> 2] = 2;
	                    c[m + 4 >> 2] = 0;
	                    n = g;
	                    o = n;
	                    p = c[o >> 2] | 0;
	                    q = n + 4 | 0;
	                    r = q;
	                    s = c[r >> 2] | 0;
	                    G = s;
	                    i = f;
	                    return p | 0
	                }
	                m = j;
	                d = bU(c[m >> 2] | 0, c[m + 4 >> 2] | 0, 2, 0) | 0;
	                m = l;
	                c[m >> 2] = d;
	                c[m + 4 >> 2] = G;
	                m = c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0;
	                d = j;
	                e = bU(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                if ((Nt(m, c[(c[h >> 2] | 0) + (e << 2) >> 2] | 0) | 0) <= 0) {
	                    while (1) {
	                        e = l;
	                        m = c[e >> 2] | 0;
	                        d = c[e + 4 >> 2] | 0;
	                        e = XT(c[k >> 2] | 0, 0, 1, 0) | 0;
	                        if ((m | 0) == (e | 0) & (d | 0) == (G | 0))break;
	                        d = l;
	                        e = XT(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                        if ((Nt(c[(c[h >> 2] | 0) + (e << 2) >> 2] | 0, c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0) > 0)break;
	                        e = l;
	                        d = bU(c[e >> 2] | 0, c[e + 4 >> 2] | 0, 1, 0) | 0;
	                        e = l;
	                        c[e >> 2] = d;
	                        c[e + 4 >> 2] = G
	                    }
	                    e = l;
	                    d = j;
	                    m = XT(c[e >> 2] | 0, c[e + 4 >> 2] | 0, c[d >> 2] | 0, c[d + 4 >> 2] | 0) | 0;
	                    d = g;
	                    c[d >> 2] = m;
	                    c[d + 4 >> 2] = G;
	                    n = g;
	                    o = n;
	                    p = c[o >> 2] | 0;
	                    q = n + 4 | 0;
	                    r = q;
	                    s = c[r >> 2] | 0;
	                    G = s;
	                    i = f;
	                    return p | 0
	                } else {
	                    while (1) {
	                        d = l;
	                        m = c[d >> 2] | 0;
	                        e = c[d + 4 >> 2] | 0;
	                        d = XT(c[k >> 2] | 0, 0, 1, 0) | 0;
	                        if ((m | 0) == (d | 0) & (e | 0) == (G | 0))break;
	                        e = l;
	                        d = XT(c[e >> 2] | 0, c[e + 4 >> 2] | 0, 1, 0) | 0;
	                        if ((Nt(c[(c[h >> 2] | 0) + (d << 2) >> 2] | 0, c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0) <= 0)break;
	                        d = l;
	                        e = bU(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                        d = l;
	                        c[d >> 2] = e;
	                        c[d + 4 >> 2] = G
	                    }
	                    k = c[h >> 2] | 0;
	                    h = j;
	                    d = c[h >> 2] | 0;
	                    e = c[h + 4 >> 2] | 0;
	                    h = l;
	                    m = XT(c[h >> 2] | 0, c[h + 4 >> 2] | 0, 1, 0) | 0;
	                    Pt(k, d, e, m, G);
	                    m = l;
	                    l = j;
	                    j = XT(c[m >> 2] | 0, c[m + 4 >> 2] | 0, c[l >> 2] | 0, c[l + 4 >> 2] | 0) | 0;
	                    l = g;
	                    c[l >> 2] = j;
	                    c[l + 4 >> 2] = G;
	                    n = g;
	                    o = n;
	                    p = c[o >> 2] | 0;
	                    q = n + 4 | 0;
	                    r = q;
	                    s = c[r >> 2] | 0;
	                    G = s;
	                    i = f;
	                    return p | 0
	                }
	                return 0
	            }

	            function Us(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                f = i;
	                i = i + 80 | 0;
	                g = f + 64 | 0;
	                h = f + 60 | 0;
	                j = f + 56 | 0;
	                k = f + 52 | 0;
	                l = f + 40 | 0;
	                m = f + 32 | 0;
	                n = f + 24 | 0;
	                o = f + 48 | 0;
	                p = f + 16 | 0;
	                q = f + 8 | 0;
	                r = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = (c[h >> 2] | 0) + ((c[j >> 2] | 0) - 2 << 4) + 8 | 0;
	                d = c[e + 4 >> 2] | 0;
	                b = l;
	                c[b >> 2] = c[e >> 2];
	                c[b + 4 >> 2] = d;
	                d = (c[h >> 2] | 0) + ((c[j >> 2] | 0) - 1 << 4) + 8 | 0;
	                b = c[d + 4 >> 2] | 0;
	                e = m;
	                c[e >> 2] = c[d >> 2];
	                c[e + 4 >> 2] = b;
	                b = (c[h >> 2] | 0) + ((c[j >> 2] | 0) - 2 << 4) | 0;
	                j = c[b + 4 >> 2] | 0;
	                h = n;
	                c[h >> 2] = c[b >> 2];
	                c[h + 4 >> 2] = j;
	                j = c[k >> 2] | 0;
	                h = l;
	                b = c[h + 4 >> 2] | 0;
	                e = m;
	                d = c[e + 4 >> 2] | 0;
	                a = (b | 0) < (d | 0) | ((b | 0) == (d | 0) ? (c[h >> 2] | 0) >>> 0 < (c[e >> 2] | 0) >>> 0 : 0);
	                e = l;
	                h = c[e + 4 >> 2] | 0;
	                h = m;
	                d = c[h + 4 >> 2] | 0;
	                d = a ? c[e >> 2] | 0 : c[h >> 2] | 0;
	                Qt(j, d);
	                c[o >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                k = l;
	                d = c[k + 4 >> 2] | 0;
	                j = m;
	                h = c[j + 4 >> 2] | 0;
	                e = c[o >> 2] | 0;
	                a = n;
	                b = c[a >> 2] | 0;
	                s = c[a + 4 >> 2] | 0;
	                if ((d | 0) < (h | 0) | ((d | 0) == (h | 0) ? (c[k >> 2] | 0) >>> 0 < (c[j >> 2] | 0) >>> 0 : 0)) {
	                    j = (c[g >> 2] | 0) + (b << 2) | 0;
	                    k = l;
	                    h = mU(c[k >> 2] | 0, c[k + 4 >> 2] | 0, 4, 0) | 0;
	                    eU(e | 0, j | 0, h | 0) | 0;
	                    h = p;
	                    c[h >> 2] = 0;
	                    c[h + 4 >> 2] = 0;
	                    h = n;
	                    j = l;
	                    k = bU(c[h >> 2] | 0, c[h + 4 >> 2] | 0, c[j >> 2] | 0, c[j + 4 >> 2] | 0) | 0;
	                    j = q;
	                    c[j >> 2] = k;
	                    c[j + 4 >> 2] = G;
	                    j = n;
	                    k = c[j + 4 >> 2] | 0;
	                    h = r;
	                    c[h >> 2] = c[j >> 2];
	                    c[h + 4 >> 2] = k;
	                    while (1) {
	                        k = r;
	                        h = c[k >> 2] | 0;
	                        j = c[k + 4 >> 2] | 0;
	                        k = n;
	                        d = l;
	                        a = bU(c[k >> 2] | 0, c[k + 4 >> 2] | 0, c[d >> 2] | 0, c[d + 4 >> 2] | 0) | 0;
	                        d = m;
	                        k = bU(a | 0, G | 0, c[d >> 2] | 0, c[d + 4 >> 2] | 0) | 0;
	                        d = G;
	                        if (!((j | 0) < (d | 0) | (j | 0) == (d | 0) & h >>> 0 < k >>> 0))break;
	                        k = p;
	                        h = c[k + 4 >> 2] | 0;
	                        d = l;
	                        j = c[d + 4 >> 2] | 0;
	                        do if ((h | 0) < (j | 0) | ((h | 0) == (j | 0) ? (c[k >> 2] | 0) >>> 0 < (c[d >> 2] | 0) >>> 0 : 0) ? (a = q, t = c[a >> 2] | 0, u = c[a + 4 >> 2] | 0, a = n, v = l, w = bU(c[a >> 2] | 0, c[a + 4 >> 2] | 0, c[v >> 2] | 0, c[v + 4 >> 2] | 0) | 0, v = m, a = bU(w | 0, G | 0, c[v >> 2] | 0, c[v + 4 >> 2] | 0) | 0, v = G, (u | 0) < (v | 0) | (u | 0) == (v | 0) & t >>> 0 < a >>> 0) : 0)if ((Nt(c[(c[o >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0, c[(c[g >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) | 0) <= 0) {
	                            a = p;
	                            t = c[a >> 2] | 0;
	                            v = bU(t | 0, c[a + 4 >> 2] | 0, 1, 0) | 0;
	                            a = p;
	                            c[a >> 2] = v;
	                            c[a + 4 >> 2] = G;
	                            c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[o >> 2] | 0) + (t << 2) >> 2];
	                            break
	                        } else {
	                            t = q;
	                            a = c[t >> 2] | 0;
	                            v = bU(a | 0, c[t + 4 >> 2] | 0, 1, 0) | 0;
	                            t = q;
	                            c[t >> 2] = v;
	                            c[t + 4 >> 2] = G;
	                            c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[g >> 2] | 0) + (a << 2) >> 2];
	                            break
	                        } else x = 9; while (0);
	                        do if ((x | 0) == 9) {
	                            x = 0;
	                            d = p;
	                            k = c[d + 4 >> 2] | 0;
	                            j = l;
	                            h = c[j + 4 >> 2] | 0;
	                            if ((k | 0) < (h | 0) | ((k | 0) == (h | 0) ? (c[d >> 2] | 0) >>> 0 < (c[j >> 2] | 0) >>> 0 : 0)) {
	                                j = p;
	                                d = c[j >> 2] | 0;
	                                h = bU(d | 0, c[j + 4 >> 2] | 0, 1, 0) | 0;
	                                j = p;
	                                c[j >> 2] = h;
	                                c[j + 4 >> 2] = G;
	                                c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[o >> 2] | 0) + (d << 2) >> 2];
	                                break
	                            } else {
	                                d = q;
	                                j = c[d >> 2] | 0;
	                                h = bU(j | 0, c[d + 4 >> 2] | 0, 1, 0) | 0;
	                                d = q;
	                                c[d >> 2] = h;
	                                c[d + 4 >> 2] = G;
	                                c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[g >> 2] | 0) + (j << 2) >> 2];
	                                break
	                            }
	                        } while (0);
	                        j = r;
	                        d = bU(c[j >> 2] | 0, c[j + 4 >> 2] | 0, 1, 0) | 0;
	                        j = r;
	                        c[j >> 2] = d;
	                        c[j + 4 >> 2] = G
	                    }
	                    i = f;
	                    return
	                } else {
	                    j = l;
	                    d = bU(b | 0, s | 0, c[j >> 2] | 0, c[j + 4 >> 2] | 0) | 0;
	                    j = (c[g >> 2] | 0) + (d << 2) | 0;
	                    d = m;
	                    s = mU(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 4, 0) | 0;
	                    eU(e | 0, j | 0, s | 0) | 0;
	                    s = m;
	                    j = XT(c[s >> 2] | 0, c[s + 4 >> 2] | 0, 1, 0) | 0;
	                    s = p;
	                    c[s >> 2] = j;
	                    c[s + 4 >> 2] = G;
	                    s = n;
	                    j = l;
	                    e = bU(c[s >> 2] | 0, c[s + 4 >> 2] | 0, c[j >> 2] | 0, c[j + 4 >> 2] | 0) | 0;
	                    j = XT(e | 0, G | 0, 1, 0) | 0;
	                    e = q;
	                    c[e >> 2] = j;
	                    c[e + 4 >> 2] = G;
	                    e = n;
	                    j = l;
	                    l = bU(c[e >> 2] | 0, c[e + 4 >> 2] | 0, c[j >> 2] | 0, c[j + 4 >> 2] | 0) | 0;
	                    j = m;
	                    m = bU(l | 0, G | 0, c[j >> 2] | 0, c[j + 4 >> 2] | 0) | 0;
	                    j = XT(m | 0, G | 0, 1, 0) | 0;
	                    m = r;
	                    c[m >> 2] = j;
	                    c[m + 4 >> 2] = G;
	                    while (1) {
	                        m = r;
	                        j = c[m + 4 >> 2] | 0;
	                        l = n;
	                        e = c[l + 4 >> 2] | 0;
	                        if (!((j | 0) > (e | 0) | ((j | 0) == (e | 0) ? (c[m >> 2] | 0) >>> 0 >= (c[l >> 2] | 0) >>> 0 : 0)))break;
	                        l = p;
	                        m = c[l + 4 >> 2] | 0;
	                        do if ((m | 0) > 0 | (m | 0) == 0 & (c[l >> 2] | 0) >>> 0 >= 0 ? (e = q, j = c[e + 4 >> 2] | 0, s = n, d = c[s + 4 >> 2] | 0, (j | 0) > (d | 0) | ((j | 0) == (d | 0) ? (c[e >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0 : 0)) : 0)if ((Nt(c[(c[g >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0, c[(c[o >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) | 0) > 0) {
	                            s = q;
	                            e = c[s >> 2] | 0;
	                            d = bU(e | 0, c[s + 4 >> 2] | 0, -1, -1) | 0;
	                            s = q;
	                            c[s >> 2] = d;
	                            c[s + 4 >> 2] = G;
	                            c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[g >> 2] | 0) + (e << 2) >> 2];
	                            break
	                        } else {
	                            e = p;
	                            s = c[e >> 2] | 0;
	                            d = bU(s | 0, c[e + 4 >> 2] | 0, -1, -1) | 0;
	                            e = p;
	                            c[e >> 2] = d;
	                            c[e + 4 >> 2] = G;
	                            c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[o >> 2] | 0) + (s << 2) >> 2];
	                            break
	                        } else x = 20; while (0);
	                        do if ((x | 0) == 20) {
	                            x = 0;
	                            l = p;
	                            m = c[l + 4 >> 2] | 0;
	                            if ((m | 0) > 0 | (m | 0) == 0 & (c[l >> 2] | 0) >>> 0 >= 0) {
	                                l = p;
	                                m = c[l >> 2] | 0;
	                                s = bU(m | 0, c[l + 4 >> 2] | 0, -1, -1) | 0;
	                                l = p;
	                                c[l >> 2] = s;
	                                c[l + 4 >> 2] = G;
	                                c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[o >> 2] | 0) + (m << 2) >> 2];
	                                break
	                            } else {
	                                m = q;
	                                l = c[m >> 2] | 0;
	                                s = bU(l | 0, c[m + 4 >> 2] | 0, -1, -1) | 0;
	                                m = q;
	                                c[m >> 2] = s;
	                                c[m + 4 >> 2] = G;
	                                c[(c[g >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[(c[g >> 2] | 0) + (l << 2) >> 2];
	                                break
	                            }
	                        } while (0);
	                        l = r;
	                        m = bU(c[l >> 2] | 0, c[l + 4 >> 2] | 0, -1, -1) | 0;
	                        l = r;
	                        c[l >> 2] = m;
	                        c[l + 4 >> 2] = G
	                    }
	                    i = f;
	                    return
	                }
	            }

	            function Vs(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 48 | 0;
	                f = d + 44 | 0;
	                g = d + 40 | 0;
	                h = d + 32 | 0;
	                j = d + 24 | 0;
	                k = d + 16 | 0;
	                l = d + 8 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[g >> 2] | 0) < 2) {
	                    c[e >> 2] = 1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                b = c[g >> 2] | 0;
	                if ((c[g >> 2] | 0) == 2) {
	                    a = (c[f >> 2] | 0) + (b - 2 << 4) + 8 | 0;
	                    o = c[a + 4 >> 2] | 0;
	                    p = l;
	                    c[p >> 2] = c[a >> 2];
	                    c[p + 4 >> 2] = o;
	                    o = (c[f >> 2] | 0) + ((c[g >> 2] | 0) - 1 << 4) + 8 | 0;
	                    p = c[o + 4 >> 2] | 0;
	                    a = m;
	                    c[a >> 2] = c[o >> 2];
	                    c[a + 4 >> 2] = p;
	                    p = l;
	                    l = c[p + 4 >> 2] | 0;
	                    a = m;
	                    m = c[a + 4 >> 2] | 0;
	                    if ((l | 0) < (m | 0) | ((l | 0) == (m | 0) ? (c[p >> 2] | 0) >>> 0 <= (c[a >> 2] | 0) >>> 0 : 0)) {
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } else {
	                        c[e >> 2] = 1;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                }
	                a = (c[f >> 2] | 0) + (b - 3 << 4) + 8 | 0;
	                b = c[a + 4 >> 2] | 0;
	                p = h;
	                c[p >> 2] = c[a >> 2];
	                c[p + 4 >> 2] = b;
	                b = (c[f >> 2] | 0) + ((c[g >> 2] | 0) - 2 << 4) + 8 | 0;
	                p = c[b + 4 >> 2] | 0;
	                a = j;
	                c[a >> 2] = c[b >> 2];
	                c[a + 4 >> 2] = p;
	                p = (c[f >> 2] | 0) + ((c[g >> 2] | 0) - 1 << 4) + 8 | 0;
	                g = c[p + 4 >> 2] | 0;
	                f = k;
	                c[f >> 2] = c[p >> 2];
	                c[f + 4 >> 2] = g;
	                g = h;
	                h = c[g >> 2] | 0;
	                f = c[g + 4 >> 2] | 0;
	                g = j;
	                p = k;
	                a = bU(c[g >> 2] | 0, c[g + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                p = G;
	                if (!((f | 0) < (p | 0) | (f | 0) == (p | 0) & h >>> 0 <= a >>> 0) ? (a = j, j = c[a + 4 >> 2] | 0, h = k, k = c[h + 4 >> 2] | 0, !((j | 0) < (k | 0) | ((j | 0) == (k | 0) ? (c[a >> 2] | 0) >>> 0 <= (c[h >> 2] | 0) >>> 0 : 0))) : 0) {
	                    c[e >> 2] = 1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function Ws(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 40 | 0;
	                j = g + 36 | 0;
	                k = g + 32 | 0;
	                l = g + 28 | 0;
	                m = g + 24 | 0;
	                n = g + 16 | 0;
	                o = g + 8 | 0;
	                p = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                while (1) {
	                    if ((c[k >> 2] | 0) <= 1) {
	                        q = 16;
	                        break
	                    }
	                    if ((c[k >> 2] | 0) == 2 ? (f = (c[j >> 2] | 0) + 8 | 0, e = (c[j >> 2] | 0) + 24 | 0, d = bU(c[f >> 2] | 0, c[f + 4 >> 2] | 0, c[e >> 2] | 0, c[e + 4 >> 2] | 0) | 0, (G | 0) == 0 ? (d | 0) == (c[m >> 2] | 0) : 0) : 0) {
	                        q = 5;
	                        break
	                    }
	                    if ((c[k >> 2] | 0) == 2 ? (d = (c[j >> 2] | 0) + 8 | 0, e = c[d + 4 >> 2] | 0, f = (c[j >> 2] | 0) + 24 | 0, b = c[f + 4 >> 2] | 0, (e | 0) < (b | 0) | ((e | 0) == (b | 0) ? (c[d >> 2] | 0) >>> 0 <= (c[f >> 2] | 0) >>> 0 : 0)) : 0) {
	                        q = 8;
	                        break
	                    }
	                    if ((c[k >> 2] | 0) == 2) {
	                        q = 16;
	                        break
	                    }
	                    f = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 3 << 4) + 8 | 0;
	                    d = c[f + 4 >> 2] | 0;
	                    b = n;
	                    c[b >> 2] = c[f >> 2];
	                    c[b + 4 >> 2] = d;
	                    d = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                    b = c[d + 4 >> 2] | 0;
	                    f = o;
	                    c[f >> 2] = c[d >> 2];
	                    c[f + 4 >> 2] = b;
	                    b = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                    f = c[b + 4 >> 2] | 0;
	                    d = p;
	                    c[d >> 2] = c[b >> 2];
	                    c[d + 4 >> 2] = f;
	                    f = n;
	                    d = c[f >> 2] | 0;
	                    b = c[f + 4 >> 2] | 0;
	                    f = o;
	                    e = p;
	                    a = bU(c[f >> 2] | 0, c[f + 4 >> 2] | 0, c[e >> 2] | 0, c[e + 4 >> 2] | 0) | 0;
	                    e = G;
	                    if (!((b | 0) < (e | 0) | (b | 0) == (e | 0) & d >>> 0 <= a >>> 0)) {
	                        a = o;
	                        d = c[a + 4 >> 2] | 0;
	                        e = p;
	                        b = c[e + 4 >> 2] | 0;
	                        if (!((d | 0) < (b | 0) | ((d | 0) == (b | 0) ? (c[a >> 2] | 0) >>> 0 <= (c[e >> 2] | 0) >>> 0 : 0))) {
	                            q = 16;
	                            break
	                        }
	                        Us(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                        e = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                        a = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                        b = a;
	                        d = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, c[e >> 2] | 0, c[e + 4 >> 2] | 0) | 0;
	                        e = a;
	                        c[e >> 2] = d;
	                        c[e + 4 >> 2] = G;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1;
	                        continue
	                    }
	                    e = n;
	                    d = c[e + 4 >> 2] | 0;
	                    a = p;
	                    b = c[a + 4 >> 2] | 0;
	                    f = c[h >> 2] | 0;
	                    r = c[j >> 2] | 0;
	                    s = c[k >> 2] | 0;
	                    if ((d | 0) < (b | 0) | ((d | 0) == (b | 0) ? (c[e >> 2] | 0) >>> 0 < (c[a >> 2] | 0) >>> 0 : 0)) {
	                        Us(f, r, s - 1 | 0, c[l >> 2] | 0);
	                        a = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                        e = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 3 << 4) + 8 | 0;
	                        b = e;
	                        d = bU(c[b >> 2] | 0, c[b + 4 >> 2] | 0, c[a >> 2] | 0, c[a + 4 >> 2] | 0) | 0;
	                        a = e;
	                        c[a >> 2] = d;
	                        c[a + 4 >> 2] = G;
	                        a = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 4) | 0;
	                        d = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 4) | 0;
	                        c[a + 0 >> 2] = c[d + 0 >> 2];
	                        c[a + 4 >> 2] = c[d + 4 >> 2];
	                        c[a + 8 >> 2] = c[d + 8 >> 2];
	                        c[a + 12 >> 2] = c[d + 12 >> 2];
	                        c[k >> 2] = (c[k >> 2] | 0) + -1;
	                        continue
	                    } else {
	                        Us(f, r, s, c[l >> 2] | 0);
	                        s = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 4) + 8 | 0;
	                        r = (c[j >> 2] | 0) + ((c[k >> 2] | 0) - 2 << 4) + 8 | 0;
	                        f = r;
	                        d = bU(c[f >> 2] | 0, c[f + 4 >> 2] | 0, c[s >> 2] | 0, c[s + 4 >> 2] | 0) | 0;
	                        s = r;
	                        c[s >> 2] = d;
	                        c[s + 4 >> 2] = G;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1;
	                        continue
	                    }
	                }
	                if ((q | 0) == 5) {
	                    Us(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                    p = (c[j >> 2] | 0) + 24 | 0;
	                    n = (c[j >> 2] | 0) + 8 | 0;
	                    o = n;
	                    m = bU(c[o >> 2] | 0, c[o + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                    p = n;
	                    c[p >> 2] = m;
	                    c[p + 4 >> 2] = G;
	                    c[k >> 2] = (c[k >> 2] | 0) + -1;
	                    t = c[k >> 2] | 0;
	                    i = g;
	                    return t | 0
	                } else if ((q | 0) == 8) {
	                    Us(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                    l = (c[j >> 2] | 0) + 24 | 0;
	                    h = (c[j >> 2] | 0) + 8 | 0;
	                    j = h;
	                    p = bU(c[j >> 2] | 0, c[j + 4 >> 2] | 0, c[l >> 2] | 0, c[l + 4 >> 2] | 0) | 0;
	                    l = h;
	                    c[l >> 2] = p;
	                    c[l + 4 >> 2] = G;
	                    c[k >> 2] = (c[k >> 2] | 0) + -1;
	                    t = c[k >> 2] | 0;
	                    i = g;
	                    return t | 0
	                } else if ((q | 0) == 16) {
	                    t = c[k >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                return 0
	            }

	            function Xs() {
	                var a = 0;
	                a = i;
	                if (+h[16480] == 0.0)h[16480] = +Rt(131848);
	                i = a;
	                return +(+h[16480])
	            }

	            function Ys() {
	                var a = 0;
	                a = i;
	                if (+h[16479] == 0.0)h[16479] = -+Xs();
	                i = a;
	                return +(+h[16479])
	            }

	            function Zs() {
	                var a = 0;
	                a = i;
	                if (+h[16478] == 0.0)h[16478] = +zT(128928);
	                i = a;
	                return +(+h[16478])
	            }

	            function _s() {
	                var a = 0, b = 0.0;
	                a = i;
	                b = +Rt(131808);
	                i = a;
	                return +b
	            }

	            function $s(a) {
	                a = +a;
	                var b = 0, c = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                c = b;
	                h[c >> 3] = a;
	                d = St(+h[c >> 3]) | 0;
	                c = G & 2147483647;
	                i = b;
	                return (c >>> 0 > 2146435072 | (c | 0) == 2146435072 & d >>> 0 > 0) & 1 | 0
	            }

	            function at(a) {
	                a = +a;
	                var b = 0, c = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                c = b;
	                h[c >> 3] = a;
	                d = St(+h[c >> 3]) | 0;
	                if (!((d | 0) == 0 & (G & 2147483647 | 0) == 2146435072)) {
	                    e = 0;
	                    i = b;
	                    return e | 0
	                }
	                e = +h[c >> 3] > 0.0 ? 1 : -1;
	                i = b;
	                return e | 0
	            }

	            function bt(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[c[d >> 2] >> 2] | 0))break;
	                        do if (c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0) {
	                            a = c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0;
	                            if ((c[(c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                                _q(a);
	                                break
	                            } else {
	                                Uh(a);
	                                break
	                            }
	                        } while (0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ct(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f + 20 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                while (1) {
	                    n = m + ((c[l >> 2] << 1) + 1) | 0;
	                    if (!((c[l >> 2] | 0) < 25 ? (c[l >> 2] | 0) < (c[k >> 2] | 0) : 0))break;
	                    a[n >> 0] = 32;
	                    a[m + (c[l >> 2] << 1) >> 0] = 32;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a[n >> 0] = 0;
	                a[m + (c[l >> 2] << 1) >> 0] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = m;
	                    Ka(n | 0, 127912, g | 0) | 0;
	                    Ka(c[h >> 2] | 0, 131120, g | 0) | 0;
	                    i = f;
	                    return
	                }
	                if (!(c[j >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                n = c[h >> 2] | 0;
	                c[g >> 2] = c[c[j >> 2] >> 2];
	                Ka(n | 0, 131144, g | 0) | 0;
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >= (c[c[j >> 2] >> 2] | 0))break;
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = m;
	                    Ka(n | 0, 127912, g | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = (c[l >> 2] | 0) + 1;
	                    Ka(n | 0, 130840, g | 0) | 0;
	                    ft(c[h >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0, (c[k >> 2] | 0) + 1 | 0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                i = f;
	                return
	            }

	            function dt(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f + 20 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                while (1) {
	                    n = m + ((c[l >> 2] << 1) + 1) | 0;
	                    if (!((c[l >> 2] | 0) < 25 ? (c[l >> 2] | 0) < (c[k >> 2] | 0) : 0))break;
	                    a[n >> 0] = 32;
	                    a[m + (c[l >> 2] << 1) >> 0] = 32;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a[n >> 0] = 0;
	                a[m + (c[l >> 2] << 1) >> 0] = 0;
	                if (((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) ? (c[c[(c[j >> 2] | 0) + 8 >> 2] >> 2] | 0) != 0 : 0) {
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = m;
	                    Ka(n | 0, 127912, g | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = (c[l >> 2] | 0) + 1;
	                    Ka(n | 0, 130840, g | 0) | 0;
	                    Ut(c[h >> 2] | 0, c[(c[c[(c[j >> 2] | 0) + 8 >> 2] >> 2] | 0) + 12 >> 2] | 0, (c[k >> 2] | 0) + 1 | 0);
	                    i = f;
	                    return
	                }
	                k = c[h >> 2] | 0;
	                c[g >> 2] = m;
	                Ka(k | 0, 127912, g | 0) | 0;
	                Ka(c[h >> 2] | 0, 131096, g | 0) | 0;
	                i = f;
	                return
	            }

	            function et(a) {
	                a = +a;
	                var b = 0, c = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                c = b;
	                h[c >> 3] = a;
	                d = Vt(+h[c >> 3]) | 0;
	                i = b;
	                return d | 0
	            }

	            function ft(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f + 20 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                while (1) {
	                    n = m + ((c[l >> 2] << 1) + 1) | 0;
	                    if (!((c[l >> 2] | 0) < 25 ? (c[l >> 2] | 0) < (c[k >> 2] | 0) : 0))break;
	                    a[n >> 0] = 32;
	                    a[m + (c[l >> 2] << 1) >> 0] = 32;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a[n >> 0] = 0;
	                a[m + (c[l >> 2] << 1) >> 0] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    l = c[h >> 2] | 0;
	                    c[g >> 2] = m;
	                    Ka(l | 0, 127912, g | 0) | 0;
	                    Ka(c[h >> 2] | 0, 131072, g | 0) | 0;
	                    i = f;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    l = c[h >> 2] | 0;
	                    n = c[j >> 2] | 0;
	                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        Ip(l, n, c[k >> 2] | 0);
	                        i = f;
	                        return
	                    } else {
	                        Kp(l, n, c[k >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                }
	                k = c[h >> 2] | 0;
	                c[g >> 2] = m;
	                Ka(k | 0, 127912, g | 0) | 0;
	                Ka(c[h >> 2] | 0, 131088, g | 0) | 0;
	                i = f;
	                return
	            }

	            function gt(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f + 20 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                while (1) {
	                    n = m + ((c[l >> 2] << 1) + 1) | 0;
	                    if (!((c[l >> 2] | 0) < 25 ? (c[l >> 2] | 0) < (c[k >> 2] | 0) : 0))break;
	                    a[n >> 0] = 32;
	                    a[m + (c[l >> 2] << 1) >> 0] = 32;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a[n >> 0] = 0;
	                a[m + (c[l >> 2] << 1) >> 0] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = m;
	                    Ka(n | 0, 127912, g | 0) | 0;
	                    Ka(c[h >> 2] | 0, 131040, g | 0) | 0;
	                    i = f;
	                    return
	                }
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >= (c[c[j >> 2] >> 2] | 0))break;
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = m;
	                    Ka(n | 0, 127912, g | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    c[g >> 2] = (c[l >> 2] | 0) + 1;
	                    Ka(n | 0, 131064, g | 0) | 0;
	                    Rq(c[h >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0, (c[k >> 2] | 0) + 1 | 0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                i = f;
	                return
	            }

	            function ht(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)Wt(c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)Wt(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Wt(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)Wt(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)Wt(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function it(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 224 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d + 16 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = (c[g >> 2] | 0) != 0;
	                if (!(c[f >> 2] | 0))if (b) {
	                    a = c[g >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Xd(0, 0, 0, 0, 0, 12, 2, 3, 0, 0, a, 0, 0, 0, 0, 130976, e);
	                    i = d;
	                    return
	                } else {
	                    Xd(0, 0, 0, 0, 0, 12, 2, 3, 0, 0, 0, 0, 0, 0, 0, 131008, e);
	                    i = d;
	                    return
	                }
	                if (b) {
	                    c[e >> 2] = c[g >> 2];
	                    Cy(h, 200, 130976, e) | 0;
	                    e = my(h) | 0;
	                    c[(c[f >> 2] | 0) + 144 >> 2] = e
	                } else {
	                    e = my(131008) | 0;
	                    c[(c[f >> 2] | 0) + 144 >> 2] = e
	                }
	                c[(c[f >> 2] | 0) + 136 >> 2] = 12;
	                c[(c[f >> 2] | 0) + 140 >> 2] = 2;
	                if (!(c[(c[f >> 2] | 0) + 132 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Ab[c[(c[f >> 2] | 0) + 132 >> 2] & 511](c[(c[f >> 2] | 0) + 128 >> 2] | 0, (c[f >> 2] | 0) + 136 | 0);
	                i = d;
	                return
	            }

	            function jt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[g >> 2] = c[(c[e >> 2] | 0) + 200 >> 2];
	                    a:do switch (c[c[f >> 2] >> 2] | 0) {
	                        case 3:
	                        {
	                            if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 32 >> 2] | 0) : 0) {
	                                l = 35;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 0 ? (e = Xt(10) | 0, c[(c[g >> 2] | 0) + 12 >> 2] = e, (c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 0) : 0) {
	                                l = 54;
	                                break a
	                            }
	                            if ((Yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[f >> 2] | 0, 0) | 0) == -1)l = 54;
	                            break
	                        }
	                        case 7:
	                        {
	                            if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                                ev(c[(c[f >> 2] | 0) + 28 >> 2] | 0);
	                                l = 54
	                            } else l = 54;
	                            break
	                        }
	                        case 2:
	                        {
	                            if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 4 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 28 >> 2] | 0) : 0) {
	                                l = 35;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 0 ? (e = Xt(10) | 0, c[(c[g >> 2] | 0) + 8 >> 2] = e, (c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 0) : 0) {
	                                l = 54;
	                                break a
	                            }
	                            if ((Yt(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[f >> 2] | 0, 0) | 0) == -1)l = 54;
	                            break
	                        }
	                        case 9:
	                        case 1:
	                        {
	                            if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                                e = c[f >> 2] | 0;
	                                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                                    c[e >> 2] = 9;
	                                    bt(c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                                    l = 35;
	                                    break a
	                                }
	                                do if ((c[(c[e + 4 >> 2] | 0) + 4 >> 2] | 0) <= 40) {
	                                    if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 4 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 20 >> 2] | 0) : 0)break;
	                                    if ((c[c[g >> 2] >> 2] | 0) == 0 ? (b = Xt(10) | 0, c[c[g >> 2] >> 2] = b, (c[c[g >> 2] >> 2] | 0) == 0) : 0) {
	                                        l = 54;
	                                        break a
	                                    }
	                                    if ((Yt(c[c[g >> 2] >> 2] | 0, c[f >> 2] | 0, 0) | 0) == -1) {
	                                        l = 54;
	                                        break a
	                                    } else break a
	                                } while (0);
	                                fr(c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                                c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                                l = 35
	                            } else l = 35;
	                            break
	                        }
	                        case 4:
	                        {
	                            if (c[(c[f >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 24 >> 2] | 0) : 0) {
	                                l = 35;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 0 ? (e = Xt(10) | 0, c[(c[g >> 2] | 0) + 4 >> 2] = e, (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 0) : 0) {
	                                l = 54;
	                                break a
	                            }
	                            if ((Yt(c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, 0) | 0) == -1)l = 54;
	                            break
	                        }
	                        default:
	                            l = 54
	                    } while (0);
	                    do if ((l | 0) == 35) {
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 36 >> 2] | 0) : 0) {
	                            l = 54;
	                            break
	                        }
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0 ? (e = Xt(10) | 0, c[(c[g >> 2] | 0) + 16 >> 2] = e, (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0) : 0) {
	                            l = 54;
	                            break
	                        }
	                        if ((Yt(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[f >> 2] | 0, 0) | 0) == -1)l = 54
	                    } while (0);
	                    if ((l | 0) == 54) {
	                        if (c[(c[f >> 2] | 0) + 4 >> 2] | 0)fr(c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        i = d;
	                        return
	                    }
	                    l = c[f >> 2] | 0;
	                    if (!(c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                        m = l + 0 | 0;
	                        n = m + 48 | 0;
	                        do {
	                            c[m >> 2] = 0;
	                            m = m + 4 | 0
	                        } while ((m | 0) < (n | 0));
	                        i = d;
	                        return
	                    }
	                    c[h >> 2] = c[l + 4 >> 2];
	                    b:do if ((c[c[h >> 2] >> 2] | 0) <= 1) {
	                        if (((c[c[h >> 2] >> 2] | 0) == 1 ? (c[c[(c[h >> 2] | 0) + 8 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[h >> 2] | 0) + 8 >> 2] >> 2] | 0) + 4 >> 2] | 0) == 18 : 0)_q(c[c[(c[h >> 2] | 0) + 8 >> 2] >> 2] | 0)
	                    } else {
	                        c[j >> 2] = 0;
	                        while (1) {
	                            if ((c[j >> 2] | 0) >= (c[c[h >> 2] >> 2] | 0))break b;
	                            c[k >> 2] = c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                            if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 18 : 0)_q(c[k >> 2] | 0);
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[c[h >> 2] >> 2] = 0;
	                    m = (c[f >> 2] | 0) + 0 | 0;
	                    n = m + 48 | 0;
	                    do {
	                        c[m >> 2] = 0;
	                        m = m + 4 | 0
	                    } while ((m | 0) < (n | 0));
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    i = d;
	                    return
	                }
	                Qq(c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function kt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) {
	                    if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        c[h >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            it(0, 130952);
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        b = c[h >> 2] | 0;
	                        c[b + 0 >> 2] = 0;
	                        c[b + 4 >> 2] = 0;
	                        c[b + 8 >> 2] = 0;
	                        c[b + 12 >> 2] = 0;
	                        c[b + 16 >> 2] = 0;
	                        c[b + 20 >> 2] = 0;
	                        c[(c[h >> 2] | 0) + 4 >> 2] = 18;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            b = my(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[(c[h >> 2] | 0) + 8 >> 2] = b
	                        }
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                            b = my(c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            c[(c[h >> 2] | 0) + 12 >> 2] = b
	                        }
	                        c[c[h >> 2] >> 2] = c[f >> 2];
	                        c[e >> 2] = c[h >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function lt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if (!(c[g >> 2] | 0))c[e >> 2] = 0; else {
	                    do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                        b = c[c[g >> 2] >> 2] | 0;
	                        if ((b | 0) == 4) {
	                            c[e >> 2] = Dt(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            break a
	                        } else if ((b | 0) == 3) {
	                            c[e >> 2] = wt(c[f >> 2] | 0, +h[(c[g >> 2] | 0) + 16 >> 3]) | 0;
	                            break a
	                        } else if ((b | 0) == 2) {
	                            c[e >> 2] = Ft(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            break a
	                        } else if ((b | 0) == 1) {
	                            b = c[f >> 2] | 0;
	                            c[e >> 2] = At(b, er(0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                            break a
	                        } else break
	                    } while (0);
	                    c[e >> 2] = zr(c[g >> 2] | 0) | 0
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function mt(b, d, e) {
	                b = +b;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, j = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                f = i;
	                i = i + 144 | 0;
	                g = f + 16 | 0;
	                j = f + 8 | 0;
	                l = f + 68 | 0;
	                m = f + 64 | 0;
	                n = f + 100 | 0;
	                o = f + 60 | 0;
	                p = f + 56 | 0;
	                q = f + 52 | 0;
	                r = f + 72 | 0;
	                s = f + 48 | 0;
	                t = f + 44 | 0;
	                u = f + 40 | 0;
	                v = f + 36 | 0;
	                w = f;
	                x = f + 32 | 0;
	                h[j >> 3] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                e = Mq(+h[j >> 3]) | 0;
	                if ((e | 0) == -1) {
	                    if ((c[m >> 2] | 0) <= 10) {
	                        i = f;
	                        return
	                    }
	                    JT(c[l >> 2] | 0, c[m >> 2] | 0, 129032, g) | 0;
	                    i = f;
	                    return
	                } else if ((e | 0) == 1) {
	                    if ((c[m >> 2] | 0) <= 9) {
	                        i = f;
	                        return
	                    }
	                    JT(c[l >> 2] | 0, c[m >> 2] | 0, 129016, g) | 0;
	                    i = f;
	                    return
	                } else {
	                    if (Lq(+h[j >> 3]) | 0) {
	                        if ((c[m >> 2] | 0) <= 4) {
	                            i = f;
	                            return
	                        }
	                        JT(c[l >> 2] | 0, c[m >> 2] | 0, 129048, g) | 0;
	                        i = f;
	                        return
	                    }
	                    if (+h[j >> 3] == 0.0 ? (et(+h[j >> 3]) | 0) != 0 : 0) {
	                        JT(c[l >> 2] | 0, c[m >> 2] | 0, 129056, g) | 0;
	                        i = f;
	                        return
	                    }
	                    b = +h[j >> 3];
	                    if (+h[j >> 3] == +(~~+h[j >> 3] | 0)) {
	                        c[q >> 2] = ~~b;
	                        c[o >> 2] = c[l >> 2];
	                        a:do if (!(c[q >> 2] | 0)) {
	                            e = c[o >> 2] | 0;
	                            c[o >> 2] = e + 1;
	                            a[e >> 0] = 48
	                        } else {
	                            c[g >> 2] = c[q >> 2];
	                            JT(n, 29, 130840, g) | 0;
	                            c[p >> 2] = n;
	                            while (1) {
	                                if (!(a[c[p >> 2] >> 0] | 0))break a;
	                                if (((c[o >> 2] | 0) - (c[l >> 2] | 0) | 0) >= (c[m >> 2] | 0))break a;
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                d = a[e >> 0] | 0;
	                                e = c[o >> 2] | 0;
	                                c[o >> 2] = e + 1;
	                                a[e >> 0] = d
	                            }
	                        } while (0);
	                        if (((c[o >> 2] | 0) - (c[l >> 2] | 0) | 0) < (c[m >> 2] | 0)) {
	                            a[c[o >> 2] >> 0] = 0;
	                            i = f;
	                            return
	                        }
	                        if ((c[m >> 2] | 0) <= 0) {
	                            i = f;
	                            return
	                        }
	                        c[o >> 2] = (c[o >> 2] | 0) + -1;
	                        a[c[o >> 2] >> 0] = 0;
	                        i = f;
	                        return
	                    }
	                    h[w >> 3] = +R(+b);
	                    b:do if ((+h[w >> 3] > 1.0e9 | +h[w >> 3] < 1.0e-05) & +h[w >> 3] != 0.0) {
	                        c[s >> 2] = 21;
	                        c[t >> 2] = 14;
	                        o = c[t >> 2] | 0;
	                        b = +h[j >> 3];
	                        c[g >> 2] = c[s >> 2];
	                        c[g + 4 >> 2] = o;
	                        o = g + 8 | 0;
	                        h[k >> 3] = b;
	                        c[o >> 2] = c[k >> 2];
	                        c[o + 4 >> 2] = c[k + 4 >> 2];
	                        c[x >> 2] = JT(r, 28, 130848, g) | 0;
	                        while (1) {
	                            if ((c[x >> 2] | 0) <= 0)break b;
	                            if ((a[r + (c[x >> 2] | 0) >> 0] | 0) == 101)break b;
	                            c[x >> 2] = (c[x >> 2] | 0) + -1
	                        }
	                    } else {
	                        do if (+h[w >> 3] > 0.0) {
	                            c[s >> 2] = ~~+yT(+h[w >> 3]);
	                            o = 15 - (c[s >> 2] | 0) | 0;
	                            if ((c[s >> 2] | 0) > 0) {
	                                c[t >> 2] = o - 1;
	                                break
	                            } else {
	                                c[t >> 2] = o;
	                                break
	                            }
	                        } else c[t >> 2] = 1; while (0);
	                        b = +h[j >> 3];
	                        c[g >> 2] = c[t >> 2];
	                        o = g + 4 | 0;
	                        h[k >> 3] = b;
	                        c[o >> 2] = c[k >> 2];
	                        c[o + 4 >> 2] = c[k + 4 >> 2];
	                        c[x >> 2] = JT(r, 28, 130856, g) | 0
	                    } while (0);
	                    while (1) {
	                        if ((a[r >> 0] | 0) != 32)break;
	                        c[u >> 2] = r;
	                        while (1) {
	                            g = a[(c[u >> 2] | 0) + 1 >> 0] | 0;
	                            a[c[u >> 2] >> 0] = g;
	                            if (!(g << 24 >> 24))break;
	                            c[u >> 2] = (c[u >> 2] | 0) + 1
	                        }
	                        c[x >> 2] = (c[x >> 2] | 0) + -1
	                    }
	                    c[v >> 2] = r + (c[x >> 2] | 0);
	                    c[u >> 2] = c[v >> 2];
	                    do {
	                        g = (c[u >> 2] | 0) + -1 | 0;
	                        c[u >> 2] = g
	                    } while ((a[g >> 0] | 0) == 48);
	                    if ((a[c[u >> 2] >> 0] | 0) != 46)c[u >> 2] = (c[u >> 2] | 0) + 1;
	                    do {
	                        g = c[v >> 2] | 0;
	                        c[v >> 2] = g + 1;
	                        t = a[g >> 0] | 0;
	                        g = c[u >> 2] | 0;
	                        c[u >> 2] = g + 1;
	                        a[g >> 0] = t
	                    } while ((t << 24 >> 24 | 0) != 0);
	                    c[x >> 2] = (ZT(r | 0) | 0) + 1;
	                    if ((c[x >> 2] | 0) > (c[m >> 2] | 0)) {
	                        a[r + ((c[m >> 2] | 0) - 1) >> 0] = 0;
	                        c[x >> 2] = c[m >> 2]
	                    }
	                    fU(c[l >> 2] | 0, r | 0, c[x >> 2] | 0) | 0;
	                    i = f;
	                    return
	                }
	            }

	            function nt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    b = c[f >> 2] | 0;
	                    Tq(b, yt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                    c[g >> 2] = 1
	                }
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if ((c[g >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = e;
	                    return
	                }
	                g = c[f >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(g, 23);
	                    i = e;
	                    return
	                }
	                do if (c[g + 16 >> 2] | 0) {
	                    if ((c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[h >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    do if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0) {
	                        c[j >> 2] = 0;
	                        if (((c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) + -1 | 0) >>> 0 >= 2) {
	                            b = c[f >> 2] | 0;
	                            Tq(b, yt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0) | 0;
	                            ps(c[f >> 2] | 0, 1);
	                            break
	                        }
	                        if ((d[c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) == 32) {
	                            b = c[f >> 2] | 0;
	                            Tq(b, Ct(c[(c[f >> 2] | 0) + 12 >> 2] | 0, 128928) | 0) | 0;
	                            break
	                        }
	                        if ((c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            c[k >> 2] = Bh(c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, 0, 0) | 0;
	                            if ((c[k >> 2] | 0) == (c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0))c[k >> 2] = my(c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            b = c[f >> 2] | 0;
	                            if (c[k >> 2] | 0) {
	                                Tq(b, Et(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0) | 0) | 0;
	                                break
	                            }
	                            Nq(b, 15);
	                            i = e;
	                            return
	                        }
	                        b = c[f >> 2] | 0;
	                        Tq(b, Dt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) | 0) | 0
	                    } else l = 14; while (0);
	                    if ((l | 0) == 14) {
	                        b = c[f >> 2] | 0;
	                        Tq(b, Ct(c[(c[f >> 2] | 0) + 12 >> 2] | 0, 128928) | 0) | 0
	                    }
	                    jt(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0);
	                    i = e;
	                    return
	                } while (0);
	                Nq(c[f >> 2] | 0, 11);
	                i = e;
	                return
	            }

	            function ot(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                n = f + 24 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                e = c[g >> 2] | 0;
	                if ((c[h >> 2] | 0) != 2) {
	                    Nq(e, 12);
	                    i = f;
	                    return
	                }
	                h = c[g >> 2] | 0;
	                if ((c[e + 20 >> 2] | 0) < ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 2 | 0)) {
	                    Nq(h, 23);
	                    i = f;
	                    return
	                }
	                c[k >> 2] = Uq(h) | 0;
	                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 : 0)rs(c[g >> 2] | 0, 1);
	                c[j >> 2] = Sq(c[g >> 2] | 0) | 0;
	                c[l >> 2] = Ly() | 0;
	                a[n >> 0] = 37;
	                a[n + 3 >> 0] = 0;
	                a:do if (c[l >> 2] | 0) {
	                    c[m >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (!(a[c[m >> 2] >> 0] | 0))break a;
	                        if ((d[c[m >> 2] >> 0] | 0) >= 65 ? (d[c[m >> 2] >> 0] | 0) <= 90 : 0)o = 51; else o = 14;
	                        b:do if ((o | 0) == 14) {
	                            o = 0;
	                            if ((d[c[m >> 2] >> 0] | 0) >= 97 ? (d[c[m >> 2] >> 0] | 0) <= 122 : 0) {
	                                o = 51;
	                                break
	                            }
	                            if ((d[c[m >> 2] >> 0] | 0) >= 48 ? (d[c[m >> 2] >> 0] | 0) <= 57 : 0) {
	                                o = 51;
	                                break
	                            }
	                            if ((((((((d[c[m >> 2] >> 0] | 0) != 45 ? (d[c[m >> 2] >> 0] | 0) != 95 : 0) ? (d[c[m >> 2] >> 0] | 0) != 46 : 0) ? (d[c[m >> 2] >> 0] | 0) != 33 : 0) ? (d[c[m >> 2] >> 0] | 0) != 126 : 0) ? (d[c[m >> 2] >> 0] | 0) != 42 : 0) ? (d[c[m >> 2] >> 0] | 0) != 39 : 0) ? (d[c[m >> 2] >> 0] | 0) != 40 : 0) {
	                                if ((d[c[m >> 2] >> 0] | 0) == 41) {
	                                    o = 51;
	                                    break
	                                }
	                                c:do if ((d[c[m >> 2] >> 0] | 0) == 37) {
	                                    if (!((d[(c[m >> 2] | 0) + 1 >> 0] | 0) >= 65 ? (d[(c[m >> 2] | 0) + 1 >> 0] | 0) <= 70 : 0))o = 30;
	                                    do if ((o | 0) == 30) {
	                                        o = 0;
	                                        if ((d[(c[m >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (d[(c[m >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                        if ((d[(c[m >> 2] | 0) + 1 >> 0] | 0) < 48)break c;
	                                        if ((d[(c[m >> 2] | 0) + 1 >> 0] | 0) > 57)break c
	                                    } while (0);
	                                    if ((d[(c[m >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (d[(c[m >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0) {
	                                        o = 51;
	                                        break b
	                                    }
	                                    if ((d[(c[m >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (d[(c[m >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0) {
	                                        o = 51;
	                                        break b
	                                    }
	                                    if ((d[(c[m >> 2] | 0) + 2 >> 0] | 0) < 48)break;
	                                    if ((d[(c[m >> 2] | 0) + 2 >> 0] | 0) <= 57) {
	                                        o = 51;
	                                        break b
	                                    }
	                                } while (0);
	                                if (!(c[k >> 2] | 0)) {
	                                    if ((d[c[m >> 2] >> 0] | 0) == 59) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 47) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 63) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 58) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 64) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 38) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 61) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 43) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 36) {
	                                        o = 51;
	                                        break
	                                    }
	                                    if ((d[c[m >> 2] >> 0] | 0) == 44) {
	                                        o = 51;
	                                        break
	                                    }
	                                }
	                                h = d[c[m >> 2] >> 0] >> 4;
	                                if ((d[c[m >> 2] >> 0] >> 4 | 0) < 10)a[n + 1 >> 0] = 48 + h; else a[n + 1 >> 0] = 55 + h;
	                                h = d[c[m >> 2] >> 0] & 15;
	                                if ((d[c[m >> 2] >> 0] & 15 | 0) < 10)a[n + 2 >> 0] = 48 + h; else a[n + 2 >> 0] = 55 + h;
	                                cz(c[l >> 2] | 0, n, 3) | 0
	                            } else o = 51
	                        } while (0);
	                        if ((o | 0) == 51) {
	                            o = 0;
	                            cz(c[l >> 2] | 0, c[m >> 2] | 0, 1) | 0
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                } while (0);
	                m = c[g >> 2] | 0;
	                o = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                Tq(m, Dt(o, Vy(c[l >> 2] | 0) | 0) | 0) | 0;
	                Ry(c[l >> 2] | 0);
	                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0);
	                i = f;
	                return
	            }

	            function pt() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    it(0, 130792);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                f = c[d >> 2] | 0;
	                c[f + 0 >> 2] = 0;
	                c[f + 4 >> 2] = 0;
	                c[f + 8 >> 2] = 0;
	                c[f + 12 >> 2] = 0;
	                c[f + 16 >> 2] = 0;
	                c[f + 20 >> 2] = 0;
	                c[f + 24 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 4 >> 2] = 10;
	                c[c[d >> 2] >> 2] = 0;
	                f = Cb[c[135744 >> 2] & 511]((c[(c[d >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0;
	                c[(c[d >> 2] | 0) + 8 >> 2] = f;
	                if (!(c[(c[d >> 2] | 0) + 8 >> 2] | 0)) {
	                    it(0, 130816);
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    cU(c[(c[d >> 2] | 0) + 8 >> 2] | 0, 0, (c[(c[d >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0;
	                    c[(c[d >> 2] | 0) + 12 >> 2] = -1;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function qt(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                h = e + 40 | 0;
	                j = e + 36 | 0;
	                k = e + 32 | 0;
	                l = e + 28 | 0;
	                m = e + 24 | 0;
	                n = e + 20 | 0;
	                o = e + 16 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                s = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[q >> 2] = 0;
	                do if (c[g >> 2] | 0) {
	                    if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[c[g >> 2] >> 2] | 0) != 9 : 0)break;
	                    do if (c[h >> 2] | 0) {
	                        if ((c[c[h >> 2] >> 2] | 0) != 1 ? (c[c[h >> 2] >> 2] | 0) != 9 : 0)break;
	                        c[r >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                        if ((c[r >> 2] | 0) != 0 ? (c[c[r >> 2] >> 2] | 0) > 0 : 0) {
	                            if ((c[s >> 2] | 0) != 0 ? (c[c[s >> 2] >> 2] | 0) > 0 : 0) {
	                                a:do if (!(c[j >> 2] | 0)) {
	                                    c[k >> 2] = 0;
	                                    b:while (1) {
	                                        if ((c[k >> 2] | 0) >= (c[c[r >> 2] >> 2] | 0))break a;
	                                        c[l >> 2] = 0;
	                                        while (1) {
	                                            t = c[k >> 2] | 0;
	                                            if ((c[l >> 2] | 0) >= (c[c[s >> 2] >> 2] | 0))break;
	                                            if ((c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + (t << 2) >> 2] | 0) == (c[(c[(c[s >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0))break b;
	                                            c[l >> 2] = (c[l >> 2] | 0) + 1
	                                        }
	                                        c[k >> 2] = t + 1
	                                    }
	                                    c[f >> 2] = 1;
	                                    u = c[f >> 2] | 0;
	                                    i = e;
	                                    return u | 0
	                                } while (0);
	                                c[o >> 2] = Cb[c[135744 >> 2] & 511](c[c[r >> 2] >> 2] << 2) | 0;
	                                if (!(c[o >> 2] | 0)) {
	                                    it(0, 130768);
	                                    c[f >> 2] = 0;
	                                    u = c[f >> 2] | 0;
	                                    i = e;
	                                    return u | 0
	                                }
	                                c[m >> 2] = Cb[c[135744 >> 2] & 511](c[c[r >> 2] >> 2] << 2) | 0;
	                                if (!(c[m >> 2] | 0)) {
	                                    it(0, 130768);
	                                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                    c[f >> 2] = 0;
	                                    u = c[f >> 2] | 0;
	                                    i = e;
	                                    return u | 0
	                                }
	                                cU(c[o >> 2] | 0, 0, c[c[r >> 2] >> 2] << 2 | 0) | 0;
	                                c[p >> 2] = Cb[c[135744 >> 2] & 511](c[c[s >> 2] >> 2] << 2) | 0;
	                                if (!(c[p >> 2] | 0)) {
	                                    it(0, 130768);
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                    c[f >> 2] = 0;
	                                    u = c[f >> 2] | 0;
	                                    i = e;
	                                    return u | 0
	                                }
	                                c[n >> 2] = Cb[c[135744 >> 2] & 511](c[c[s >> 2] >> 2] << 2) | 0;
	                                if (!(c[n >> 2] | 0)) {
	                                    it(0, 130768);
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                                    c[f >> 2] = 0;
	                                    u = c[f >> 2] | 0;
	                                    i = e;
	                                    return u | 0
	                                }
	                                cU(c[p >> 2] | 0, 0, c[c[s >> 2] >> 2] << 2 | 0) | 0;
	                                c[k >> 2] = 0;
	                                while (1) {
	                                    if ((c[k >> 2] | 0) >= (c[c[r >> 2] >> 2] | 0))break;
	                                    d = Zt(c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0;
	                                    c[(c[m >> 2] | 0) + (c[k >> 2] << 2) >> 2] = d;
	                                    c[l >> 2] = 0;
	                                    while (1) {
	                                        if ((c[l >> 2] | 0) >= (c[c[s >> 2] >> 2] | 0))break;
	                                        if (!(c[k >> 2] | 0)) {
	                                            d = Zt(c[(c[(c[s >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0;
	                                            c[(c[n >> 2] | 0) + (c[l >> 2] << 2) >> 2] = d
	                                        }
	                                        if ((c[(c[m >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) != (c[(c[n >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0)) {
	                                            if (c[j >> 2] | 0) {
	                                                v = 40;
	                                                break
	                                            }
	                                        } else {
	                                            if (!(c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0)) {
	                                                d = _i(c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0;
	                                                c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] = d
	                                            }
	                                            if (!(c[(c[p >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0)) {
	                                                d = _i(c[(c[(c[s >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0;
	                                                c[(c[p >> 2] | 0) + (c[l >> 2] << 2) >> 2] = d
	                                            }
	                                            d = qy(c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, c[(c[p >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0;
	                                            c[q >> 2] = d ^ c[j >> 2];
	                                            if (c[q >> 2] | 0)break
	                                        }
	                                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                                    }
	                                    if ((v | 0) == 40) {
	                                        v = 0;
	                                        c[q >> 2] = 1
	                                    }
	                                    if (c[q >> 2] | 0)break;
	                                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                                }
	                                c[k >> 2] = 0;
	                                while (1) {
	                                    if ((c[k >> 2] | 0) >= (c[c[r >> 2] >> 2] | 0))break;
	                                    if (c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0);
	                                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                                }
	                                c[l >> 2] = 0;
	                                while (1) {
	                                    if ((c[l >> 2] | 0) >= (c[c[s >> 2] >> 2] | 0))break;
	                                    if (c[(c[p >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[p >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0);
	                                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                                }
	                                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                                c[f >> 2] = c[q >> 2];
	                                u = c[f >> 2] | 0;
	                                i = e;
	                                return u | 0
	                            }
	                            c[f >> 2] = 0;
	                            u = c[f >> 2] | 0;
	                            i = e;
	                            return u | 0
	                        }
	                        c[f >> 2] = 0;
	                        u = c[f >> 2] | 0;
	                        i = e;
	                        return u | 0
	                    } while (0);
	                    c[f >> 2] = 0;
	                    u = c[f >> 2] | 0;
	                    i = e;
	                    return u | 0
	                } while (0);
	                c[f >> 2] = 0;
	                u = c[f >> 2] | 0;
	                i = e;
	                return u | 0
	            }

	            function rt(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = +d;
	                e = e | 0;
	                var f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                j = f + 44 | 0;
	                k = f + 40 | 0;
	                l = f + 8 | 0;
	                m = f + 36 | 0;
	                n = f + 32 | 0;
	                o = f + 28 | 0;
	                p = f + 24 | 0;
	                q = f + 20 | 0;
	                r = f + 16 | 0;
	                s = f;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                h[l >> 3] = d;
	                c[m >> 2] = e;
	                c[o >> 2] = 0;
	                do if (c[k >> 2] | 0) {
	                    if ((c[c[k >> 2] >> 2] | 0) != 1 ? (c[c[k >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[p >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    a:do if (c[p >> 2] | 0) {
	                        c[n >> 2] = 0;
	                        b:while (1) {
	                            if ((c[n >> 2] | 0) >= (c[c[p >> 2] >> 2] | 0))break a;
	                            c[q >> 2] = ir(c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0) | 0;
	                            do if (c[q >> 2] | 0) {
	                                e = c[j >> 2] | 0;
	                                Tq(e, Dt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[q >> 2] | 0) | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                Tr(c[j >> 2] | 0, 1);
	                                c[r >> 2] = Sq(c[j >> 2] | 0) | 0;
	                                h[s >> 3] = +h[(c[r >> 2] | 0) + 16 >> 3];
	                                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[r >> 2] | 0);
	                                e = (Lq(+h[s >> 3]) | 0) != 0;
	                                b = (c[m >> 2] | 0) != 0;
	                                if (e) {
	                                    if (!b)break;
	                                    c[o >> 2] = 1;
	                                    break
	                                }
	                                if (!b ? +h[s >> 3] == +h[l >> 3] : 0) {
	                                    t = 12;
	                                    break b
	                                }
	                                if ((c[m >> 2] | 0) != 0 ? +h[s >> 3] != +h[l >> 3] : 0) {
	                                    t = 15;
	                                    break b
	                                }
	                            } while (0);
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        if ((t | 0) == 12) {
	                            c[o >> 2] = 1;
	                            break
	                        } else if ((t | 0) == 15) {
	                            c[o >> 2] = 1;
	                            break
	                        }
	                    } while (0);
	                    c[g >> 2] = c[o >> 2];
	                    u = c[g >> 2] | 0;
	                    i = f;
	                    return u | 0
	                } while (0);
	                c[g >> 2] = 0;
	                u = c[g >> 2] | 0;
	                i = f;
	                return u | 0
	            }

	            function st(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (!((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0)) {
	                    if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[c[g >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[l >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[l >> 2] | 0) != 0 ? (c[c[l >> 2] >> 2] | 0) > 0 : 0) {
	                        c[n >> 2] = _t(c[h >> 2] | 0) | 0;
	                        c[k >> 2] = 0;
	                        a:while (1) {
	                            if ((c[k >> 2] | 0) >= (c[c[l >> 2] >> 2] | 0)) {
	                                o = 28;
	                                break
	                            }
	                            d = Zt(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0;
	                            do if ((d | 0) == (c[n >> 2] | 0)) {
	                                c[m >> 2] = _i(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0;
	                                if ((c[m >> 2] | 0) != 0 ? (qy(c[h >> 2] | 0, c[m >> 2] | 0) | 0) != 0 : 0) {
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    if (c[j >> 2] | 0)break; else {
	                                        o = 14;
	                                        break a
	                                    }
	                                }
	                                if ((c[m >> 2] | 0) == 0 ? (qy(c[h >> 2] | 0, 128928) | 0) != 0 : 0)if (c[j >> 2] | 0)break; else {
	                                    o = 18;
	                                    break a
	                                }
	                                p = (c[m >> 2] | 0) != 0;
	                                if (c[j >> 2] | 0) {
	                                    o = 20;
	                                    break a
	                                }
	                                if (p)zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                            } else if (c[j >> 2] | 0) {
	                                o = 26;
	                                break a
	                            } while (0);
	                            c[k >> 2] = (c[k >> 2] | 0) + 1
	                        }
	                        if ((o | 0) == 14) {
	                            c[f >> 2] = 1;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        } else if ((o | 0) == 18) {
	                            c[f >> 2] = 1;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        } else if ((o | 0) == 20) {
	                            if (p)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            c[f >> 2] = 1;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        } else if ((o | 0) == 26) {
	                            c[f >> 2] = 1;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        } else if ((o | 0) == 28) {
	                            c[f >> 2] = 0;
	                            q = c[f >> 2] | 0;
	                            i = e;
	                            return q | 0
	                        }
	                    }
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                } while (0);
	                c[f >> 2] = 0;
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function tt(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0.0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                a:do switch (c[c[k >> 2] >> 2] | 0) {
	                    case 3:
	                    {
	                        switch (c[c[l >> 2] >> 2] | 0) {
	                            case 4:
	                            {
	                                Tq(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                                Tr(c[j >> 2] | 0, 1);
	                                c[l >> 2] = Sq(c[j >> 2] | 0) | 0;
	                                break
	                            }
	                            case 3:
	                                break;
	                            case 6:
	                            case 5:
	                            case 8:
	                            case 7:
	                            {
	                                e = c[33976] | 0;
	                                b = c[33980] | 0;
	                                c[g >> 2] = 128552;
	                                c[g + 4 >> 2] = 7047;
	                                Db[e & 511](b, 129064, g);
	                                break a;
	                                break
	                            }
	                            case 2:
	                            {
	                                c[m >> 2] = (c[(c[l >> 2] | 0) + 8 >> 2] | 0) == (Ir(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) & 1;
	                                break a;
	                                break
	                            }
	                            default:
	                                break a
	                        }
	                        if ((Lq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == 0 ? (Lq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) == 0 : 0) {
	                            if ((Mq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == 1)if ((Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) == 1) {
	                                c[m >> 2] = 1;
	                                break a
	                            } else {
	                                c[m >> 2] = 0;
	                                break a
	                            }
	                            b = (Mq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == -1;
	                            e = Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0;
	                            if (b)if ((e | 0) == -1) {
	                                c[m >> 2] = 1;
	                                break a
	                            } else {
	                                c[m >> 2] = 0;
	                                break a
	                            }
	                            if ((e | 0) == 1)if ((Mq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == 1) {
	                                c[m >> 2] = 1;
	                                break a
	                            } else {
	                                c[m >> 2] = 0;
	                                break a
	                            }
	                            e = (Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) == -1;
	                            n = +h[(c[k >> 2] | 0) + 16 >> 3];
	                            if (!e) {
	                                c[m >> 2] = n == +h[(c[l >> 2] | 0) + 16 >> 3] & 1;
	                                break a
	                            }
	                            if ((Mq(n) | 0) == -1) {
	                                c[m >> 2] = 1;
	                                break a
	                            } else {
	                                c[m >> 2] = 0;
	                                break a
	                            }
	                        }
	                        c[m >> 2] = 0;
	                        break
	                    }
	                    case 6:
	                    case 5:
	                    case 8:
	                    case 7:
	                    {
	                        e = c[33976] | 0;
	                        b = c[33980] | 0;
	                        c[g >> 2] = 128552;
	                        c[g + 4 >> 2] = 7119;
	                        Db[e & 511](b, 129064, g);
	                        break
	                    }
	                    case 2:
	                    {
	                        switch (c[c[l >> 2] >> 2] | 0) {
	                            case 6:
	                            case 5:
	                            case 8:
	                            case 7:
	                            {
	                                b = c[33976] | 0;
	                                e = c[33980] | 0;
	                                c[g >> 2] = 128552;
	                                c[g + 4 >> 2] = 6990;
	                                Db[b & 511](e, 129064, g);
	                                break a;
	                                break
	                            }
	                            case 3:
	                            {
	                                c[m >> 2] = (c[(c[k >> 2] | 0) + 8 >> 2] | 0) == (Ir(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) & 1;
	                                break a;
	                                break
	                            }
	                            case 2:
	                            {
	                                c[m >> 2] = (c[(c[k >> 2] | 0) + 8 >> 2] | 0) == (c[(c[l >> 2] | 0) + 8 >> 2] | 0) & 1;
	                                break a;
	                                break
	                            }
	                            case 4:
	                            {
	                                if ((c[(c[l >> 2] | 0) + 24 >> 2] | 0) != 0 ? (d[c[(c[l >> 2] | 0) + 24 >> 2] >> 0] | 0 | 0) != 0 : 0)c[m >> 2] = 1; else c[m >> 2] = 0;
	                                c[m >> 2] = (c[(c[k >> 2] | 0) + 8 >> 2] | 0) == (c[m >> 2] | 0) & 1;
	                                break a;
	                                break
	                            }
	                            default:
	                                break a
	                        }
	                        break
	                    }
	                    case 4:
	                    {
	                        switch (c[c[l >> 2] >> 2] | 0) {
	                            case 3:
	                            {
	                                Tq(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                Tr(c[j >> 2] | 0, 1);
	                                c[k >> 2] = Sq(c[j >> 2] | 0) | 0;
	                                if ((Lq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == 0 ? (Lq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) == 0 : 0) {
	                                    if ((Mq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == 1)if ((Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) == 1) {
	                                        c[m >> 2] = 1;
	                                        break a
	                                    } else {
	                                        c[m >> 2] = 0;
	                                        break a
	                                    }
	                                    e = (Mq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == -1;
	                                    b = Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0;
	                                    if (e)if ((b | 0) == -1) {
	                                        c[m >> 2] = 1;
	                                        break a
	                                    } else {
	                                        c[m >> 2] = 0;
	                                        break a
	                                    }
	                                    if ((b | 0) == 1)if ((Mq(+h[(c[k >> 2] | 0) + 16 >> 3]) | 0) == 1) {
	                                        c[m >> 2] = 1;
	                                        break a
	                                    } else {
	                                        c[m >> 2] = 0;
	                                        break a
	                                    }
	                                    b = (Mq(+h[(c[l >> 2] | 0) + 16 >> 3]) | 0) == -1;
	                                    n = +h[(c[k >> 2] | 0) + 16 >> 3];
	                                    if (!b) {
	                                        c[m >> 2] = n == +h[(c[l >> 2] | 0) + 16 >> 3] & 1;
	                                        break a
	                                    }
	                                    if ((Mq(n) | 0) == -1) {
	                                        c[m >> 2] = 1;
	                                        break a
	                                    } else {
	                                        c[m >> 2] = 0;
	                                        break a
	                                    }
	                                }
	                                c[m >> 2] = 0;
	                                break a;
	                                break
	                            }
	                            case 6:
	                            case 5:
	                            case 8:
	                            case 7:
	                            {
	                                b = c[33976] | 0;
	                                e = c[33980] | 0;
	                                c[g >> 2] = 128552;
	                                c[g + 4 >> 2] = 7108;
	                                Db[b & 511](e, 129064, g);
	                                break a;
	                                break
	                            }
	                            case 2:
	                            {
	                                if ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) != 0 ? (d[c[(c[k >> 2] | 0) + 24 >> 2] >> 0] | 0 | 0) != 0 : 0)c[m >> 2] = 1; else c[m >> 2] = 0;
	                                c[m >> 2] = (c[(c[l >> 2] | 0) + 8 >> 2] | 0) == (c[m >> 2] | 0) & 1;
	                                break a;
	                                break
	                            }
	                            case 4:
	                            {
	                                c[m >> 2] = qy(c[(c[k >> 2] | 0) + 24 >> 2] | 0, c[(c[l >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                break a;
	                                break
	                            }
	                            default:
	                                break a
	                        }
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0);
	                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0);
	                i = f;
	                return c[m >> 2] | 0
	            }

	            function ut(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0.0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 52 | 0;
	                j = f + 48 | 0;
	                k = f + 44 | 0;
	                l = f + 40 | 0;
	                m = f + 36 | 0;
	                n = f + 32 | 0;
	                o = f + 28 | 0;
	                p = f + 24 | 0;
	                q = f;
	                r = f + 20 | 0;
	                s = f + 16 | 0;
	                t = f + 12 | 0;
	                u = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[p >> 2] = 0;
	                c[s >> 2] = 0;
	                do if (c[l >> 2] | 0) {
	                    if ((c[c[l >> 2] >> 2] | 0) != 1 ? (c[c[l >> 2] >> 2] | 0) != 9 : 0)break;
	                    do if (c[m >> 2] | 0) {
	                        if ((c[c[m >> 2] >> 2] | 0) != 1 ? (c[c[m >> 2] >> 2] | 0) != 9 : 0)break;
	                        c[t >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                        c[u >> 2] = c[(c[m >> 2] | 0) + 4 >> 2];
	                        if ((c[t >> 2] | 0) != 0 ? (c[c[t >> 2] >> 2] | 0) > 0 : 0) {
	                            if ((c[u >> 2] | 0) != 0 ? (c[c[u >> 2] >> 2] | 0) > 0 : 0) {
	                                c[r >> 2] = Cb[c[135744 >> 2] & 511](c[c[u >> 2] >> 2] << 3) | 0;
	                                if (!(c[r >> 2] | 0)) {
	                                    it(0, 130768);
	                                    Qq(c[l >> 2] | 0);
	                                    Qq(c[m >> 2] | 0);
	                                    c[g >> 2] = 0;
	                                    v = c[g >> 2] | 0;
	                                    i = f;
	                                    return v | 0
	                                }
	                                c[n >> 2] = 0;
	                                while (1) {
	                                    if ((c[n >> 2] | 0) >= (c[c[t >> 2] >> 2] | 0))break;
	                                    h[q >> 3] = +Gr(c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0);
	                                    if (!(Lq(+h[q >> 3]) | 0)) {
	                                        c[o >> 2] = 0;
	                                        while (1) {
	                                            if ((c[o >> 2] | 0) >= (c[c[u >> 2] >> 2] | 0))break;
	                                            if (!(c[p >> 2] | 0)) {
	                                                w = +Gr(c[(c[(c[u >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0);
	                                                h[(c[r >> 2] | 0) + (c[o >> 2] << 3) >> 3] = w
	                                            }
	                                            if (!(Lq(+h[(c[r >> 2] | 0) + (c[o >> 2] << 3) >> 3]) | 0)) {
	                                                do if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0)c[s >> 2] = +h[q >> 3] < +h[(c[r >> 2] | 0) + (c[o >> 2] << 3) >> 3] & 1; else {
	                                                    if (!((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) != 0)) {
	                                                        c[s >> 2] = +h[q >> 3] <= +h[(c[r >> 2] | 0) + (c[o >> 2] << 3) >> 3] & 1;
	                                                        break
	                                                    }
	                                                    if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) != 0) {
	                                                        c[s >> 2] = +h[q >> 3] > +h[(c[r >> 2] | 0) + (c[o >> 2] << 3) >> 3] & 1;
	                                                        break
	                                                    }
	                                                    if ((c[j >> 2] | 0) != 0 | (c[k >> 2] | 0) != 0)break;
	                                                    c[s >> 2] = +h[q >> 3] >= +h[(c[r >> 2] | 0) + (c[o >> 2] << 3) >> 3] & 1
	                                                } while (0);
	                                                if (c[s >> 2] | 0)break
	                                            }
	                                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                                        }
	                                        if (c[s >> 2] | 0)break;
	                                        c[p >> 2] = 1
	                                    }
	                                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                                }
	                                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                Qq(c[l >> 2] | 0);
	                                Qq(c[m >> 2] | 0);
	                                c[g >> 2] = c[s >> 2];
	                                v = c[g >> 2] | 0;
	                                i = f;
	                                return v | 0
	                            }
	                            Qq(c[l >> 2] | 0);
	                            Qq(c[m >> 2] | 0);
	                            c[g >> 2] = 0;
	                            v = c[g >> 2] | 0;
	                            i = f;
	                            return v | 0
	                        }
	                        Qq(c[l >> 2] | 0);
	                        Qq(c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    } while (0);
	                    Qq(c[l >> 2] | 0);
	                    Qq(c[m >> 2] | 0);
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                } while (0);
	                Qq(c[m >> 2] | 0);
	                c[g >> 2] = 0;
	                v = c[g >> 2] | 0;
	                i = f;
	                return v | 0
	            }

	            function vt(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                do if (!((c[o >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0)) {
	                    if ((c[c[n >> 2] >> 2] | 0) != 1 ? (c[c[n >> 2] >> 2] | 0) != 9 : 0)break;
	                    switch (c[c[o >> 2] >> 2] | 0) {
	                        case 9:
	                        case 1:
	                        {
	                            c[j >> 2] = ut(c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                            p = c[j >> 2] | 0;
	                            i = g;
	                            return p | 0
	                        }
	                        case 4:
	                        {
	                            c[j >> 2] = au(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                            p = c[j >> 2] | 0;
	                            i = g;
	                            return p | 0
	                        }
	                        case 2:
	                        {
	                            Tq(c[k >> 2] | 0, c[n >> 2] | 0) | 0;
	                            Bs(c[k >> 2] | 0, 1);
	                            Tq(c[k >> 2] | 0, c[o >> 2] | 0) | 0;
	                            c[j >> 2] = Sr(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                            p = c[j >> 2] | 0;
	                            i = g;
	                            return p | 0
	                        }
	                        case 3:
	                        {
	                            c[j >> 2] = $t(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                            p = c[j >> 2] | 0;
	                            i = g;
	                            return p | 0
	                        }
	                        default:
	                        {
	                            f = c[33976] | 0;
	                            e = c[33980] | 0;
	                            c[h >> 2] = 128552;
	                            c[h + 4 >> 2] = 6705;
	                            Db[f & 511](e, 129064, h);
	                            c[j >> 2] = 0;
	                            p = c[j >> 2] | 0;
	                            i = g;
	                            return p | 0
	                        }
	                    }
	                } while (0);
	                c[j >> 2] = 0;
	                p = c[j >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function wt(a, b) {
	                a = a | 0;
	                b = +b;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                c[f >> 2] = a;
	                h[g >> 3] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                    if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        f = (c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 4 | 0;
	                        a = (c[f >> 2] | 0) + -1 | 0;
	                        c[f >> 2] = a;
	                        c[k >> 2] = c[(c[c[(c[j >> 2] | 0) + 12 >> 2] >> 2] | 0) + (a << 2) >> 2];
	                        c[c[k >> 2] >> 2] = 3;
	                        h[(c[k >> 2] | 0) + 16 >> 3] = +h[g >> 3];
	                        c[e >> 2] = c[k >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        k = (c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                        a = (c[k >> 2] | 0) + -1 | 0;
	                        c[k >> 2] = a;
	                        c[l >> 2] = c[(c[c[(c[j >> 2] | 0) + 16 >> 2] >> 2] | 0) + (a << 2) >> 2];
	                        c[c[l >> 2] >> 2] = 3;
	                        h[(c[l >> 2] | 0) + 16 >> 3] = +h[g >> 3];
	                        c[e >> 2] = c[l >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                }
	                c[e >> 2] = ur(+h[g >> 3]) | 0;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function xt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = wt(c[f >> 2] | 0, 0.0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[c[g >> 2] >> 2] | 0) == 3) {
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = c[f >> 2] | 0;
	                    c[h >> 2] = wt(b, +Wq(c[g >> 2] | 0)) | 0;
	                    jt(c[f >> 2] | 0, c[g >> 2] | 0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function yt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                    if ((c[c[h >> 2] >> 2] | 0) != 0 ? (c[(c[c[h >> 2] >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        b = (c[c[h >> 2] >> 2] | 0) + 4 | 0;
	                        a = (c[b >> 2] | 0) + -1 | 0;
	                        c[b >> 2] = a;
	                        c[j >> 2] = c[(c[c[c[h >> 2] >> 2] >> 2] | 0) + (a << 2) >> 2];
	                        c[c[j >> 2] >> 2] = 1;
	                        c[(c[j >> 2] | 0) + 8 >> 2] = 0;
	                        do if (c[g >> 2] | 0) {
	                            if ((c[(c[(c[j >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                                c[c[(c[(c[j >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2] = c[g >> 2];
	                                c[c[(c[j >> 2] | 0) + 4 >> 2] >> 2] = 1;
	                                break
	                            }
	                            dr(c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0) | 0
	                        } while (0);
	                        c[e >> 2] = c[j >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        j = (c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                        a = (c[j >> 2] | 0) + -1 | 0;
	                        c[j >> 2] = a;
	                        c[k >> 2] = c[(c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) + (a << 2) >> 2];
	                        c[c[k >> 2] >> 2] = 1;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = 0;
	                        a = $q(c[g >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 4 >> 2] = a;
	                        if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[(c[f >> 2] | 0) + 136 >> 2] = 12;
	                            c[(c[f >> 2] | 0) + 140 >> 2] = 2;
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        } else {
	                            c[e >> 2] = c[k >> 2];
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                    }
	                }
	                c[e >> 2] = gr(c[g >> 2] | 0) | 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function zt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[k >> 2] = c[h >> 2];
	                c[n >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[j >> 2] = $q(0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = c[j >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                a:while (1) {
	                    do if ((d[c[k >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                while (1) {
	                    if (!(d[c[k >> 2] >> 0] | 0))break;
	                    while (1) {
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) == 32)break;
	                        if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) == 13)break;
	                        if (!(d[c[k >> 2] >> 0] | 0))break;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    c[l >> 2] = ly(c[h >> 2] | 0, (c[k >> 2] | 0) - (c[h >> 2] | 0) | 0) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[m >> 2] = Hm(c[g >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (c[m >> 2] | 0) {
	                            b = c[m >> 2] | 0;
	                            do if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 2)if ((c[b + 4 >> 2] | 0) == 1) {
	                                c[n >> 2] = c[m >> 2];
	                                break
	                            } else {
	                                c[n >> 2] = 0;
	                                break
	                            } else c[n >> 2] = c[b + 20 >> 2]; while (0);
	                            if (c[n >> 2] | 0)cr(c[j >> 2] | 0, c[n >> 2] | 0) | 0
	                        }
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                    }
	                    while (1) {
	                        do if ((d[c[k >> 2] >> 0] | 0 | 0) == 32)p = 1; else {
	                            if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                p = 1;
	                                break
	                            }
	                            p = (d[c[k >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        q = c[k >> 2] | 0;
	                        if (!p)break;
	                        c[k >> 2] = q + 1
	                    }
	                    c[h >> 2] = q
	                }
	                c[f >> 2] = c[j >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function At(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) ? (c[h >> 2] = c[(c[f >> 2] | 0) + 200 >> 2], (c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0) : 0) ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    f = (c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                    b = (c[f >> 2] | 0) + -1 | 0;
	                    c[f >> 2] = b;
	                    c[j >> 2] = c[(c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                    c[c[j >> 2] >> 2] = 1;
	                    c[(c[j >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                    c[e >> 2] = c[j >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[e >> 2] = hr(c[g >> 2] | 0) | 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function Bt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                c[g >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = Ct(c[g >> 2] | 0, 128928) | 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                switch (c[c[j >> 2] >> 2] | 0) {
	                    case 9:
	                    case 1:
	                    {
	                        c[k >> 2] = Cr(c[(c[j >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[k >> 2] = Br(+h[(c[j >> 2] | 0) + 16 >> 3]) | 0;
	                        break
	                    }
	                    case 6:
	                    case 5:
	                    case 8:
	                    case 7:
	                    {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[e >> 2] = 128552;
	                        c[e + 4 >> 2] = 2680;
	                        Db[b & 511](a, 129064, e);
	                        break
	                    }
	                    case 2:
	                    {
	                        c[k >> 2] = Ar(c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[f >> 2] = c[j >> 2];
	                        l = c[f >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    default:
	                    {
	                    }
	                }
	                jt(c[g >> 2] | 0, c[j >> 2] | 0);
	                j = c[g >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = Ct(j, 128928) | 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[f >> 2] = Et(j, c[k >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Ct(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        f = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 | 0;
	                        b = (c[f >> 2] | 0) + -1 | 0;
	                        c[f >> 2] = b;
	                        c[j >> 2] = c[(c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[j >> 2] >> 2] = 4;
	                        b = my(c[g >> 2] | 0) | 0;
	                        c[(c[j >> 2] | 0) + 24 >> 2] = b;
	                        c[e >> 2] = c[j >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        j = (c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                        b = (c[j >> 2] | 0) + -1 | 0;
	                        c[j >> 2] = b;
	                        c[k >> 2] = c[(c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[k >> 2] >> 2] = 4;
	                        b = my(c[g >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 24 >> 2] = b;
	                        c[e >> 2] = c[k >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[e >> 2] = yr(c[g >> 2] | 0) | 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Dt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        f = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 | 0;
	                        b = (c[f >> 2] | 0) + -1 | 0;
	                        c[f >> 2] = b;
	                        c[j >> 2] = c[(c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[j >> 2] >> 2] = 4;
	                        if (c[g >> 2] | 0) {
	                            b = my(c[g >> 2] | 0) | 0;
	                            c[(c[j >> 2] | 0) + 24 >> 2] = b
	                        } else {
	                            b = my(128928) | 0;
	                            c[(c[j >> 2] | 0) + 24 >> 2] = b
	                        }
	                        c[e >> 2] = c[j >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        j = (c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                        b = (c[j >> 2] | 0) + -1 | 0;
	                        c[j >> 2] = b;
	                        c[k >> 2] = c[(c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[k >> 2] >> 2] = 4;
	                        if (c[g >> 2] | 0) {
	                            b = my(c[g >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 24 >> 2] = b
	                        } else {
	                            b = my(128928) | 0;
	                            c[(c[k >> 2] | 0) + 24 >> 2] = b
	                        }
	                        c[e >> 2] = c[k >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[e >> 2] = wr(c[g >> 2] | 0) | 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Et(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        f = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 | 0;
	                        b = (c[f >> 2] | 0) + -1 | 0;
	                        c[f >> 2] = b;
	                        c[j >> 2] = c[(c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[j >> 2] >> 2] = 4;
	                        c[(c[j >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        c[e >> 2] = c[j >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        j = (c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                        b = (c[j >> 2] | 0) + -1 | 0;
	                        c[j >> 2] = b;
	                        c[k >> 2] = c[(c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[k >> 2] >> 2] = 4;
	                        c[(c[k >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        c[e >> 2] = c[k >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[e >> 2] = xr(c[g >> 2] | 0) | 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Ft(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 200 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        f = (c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 4 | 0;
	                        b = (c[f >> 2] | 0) + -1 | 0;
	                        c[f >> 2] = b;
	                        c[j >> 2] = c[(c[c[(c[h >> 2] | 0) + 8 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[j >> 2] >> 2] = 2;
	                        c[(c[j >> 2] | 0) + 8 >> 2] = (c[g >> 2] | 0) != 0 & 1;
	                        c[e >> 2] = c[j >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        j = (c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 | 0;
	                        b = (c[j >> 2] | 0) + -1 | 0;
	                        c[j >> 2] = b;
	                        c[k >> 2] = c[(c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) + (b << 2) >> 2];
	                        c[c[k >> 2] >> 2] = 2;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = (c[g >> 2] | 0) != 0 & 1;
	                        c[e >> 2] = c[k >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[e >> 2] = vr(c[g >> 2] | 0) | 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Gt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = Ft(c[f >> 2] | 0, 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[c[g >> 2] >> 2] | 0) == 2) {
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = c[f >> 2] | 0;
	                    c[h >> 2] = Ft(b, Vq(c[g >> 2] | 0) | 0) | 0;
	                    jt(c[f >> 2] | 0, c[g >> 2] | 0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function Ht(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                e = i;
	                i = i + 144 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 32 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[k >> 2] = 0;
	                c[m >> 2] = bu(c[g >> 2] | 0, l) | 0;
	                a:do if (!((c[m >> 2] | 0) == 32 | (c[m >> 2] | 0) == 62 | (c[m >> 2] | 0) == 47 | (c[m >> 2] | 0) == 91 | (c[m >> 2] | 0) == 93 | (c[m >> 2] | 0) == 64 | (c[m >> 2] | 0) == 42)) {
	                    d = c[m >> 2] | 0;
	                    if ((c[m >> 2] | 0) < 256) {
	                        if (((!(65 <= (d | 0) & (c[m >> 2] | 0) <= 90) ? !(97 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 122) : 0) ? !(192 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 214) : 0) ? !(216 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 246 | 248 <= (c[m >> 2] | 0)) : 0)p = 8
	                    } else if (!(DQ(d, 199744) | 0))p = 8;
	                    do if ((p | 0) == 8) {
	                        d = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) < 256)if ((d | 0) != 95 & (c[h >> 2] | 0) != 0 & (c[m >> 2] | 0) != 58)break a; else break;
	                        if (!(19968 <= (d | 0) & (c[m >> 2] | 0) <= 40869 | (c[m >> 2] | 0) == 12295) ? (12321 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 12329 ^ 1) & (c[m >> 2] | 0) != 95 & (c[h >> 2] | 0) != 0 & (c[m >> 2] | 0) != 58 : 0)break a
	                    } while (0);
	                    b:do {
	                        if (!((c[m >> 2] | 0) != 32 & (c[m >> 2] | 0) != 62 & (c[m >> 2] | 0) != 47)) {
	                            p = 72;
	                            break
	                        }
	                        d = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) < 256) {
	                            if (((!(65 <= (d | 0) & (c[m >> 2] | 0) <= 90) ? !(97 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 122) : 0) ? !(192 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 214) : 0) ? !(216 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 246 | 248 <= (c[m >> 2] | 0)) : 0)p = 20
	                        } else if (!(DQ(d, 199744) | 0))p = 20;
	                        do if ((p | 0) == 20) {
	                            p = 0;
	                            if ((c[m >> 2] | 0) >= 256) {
	                                if (19968 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 40869 | (c[m >> 2] | 0) == 12295)break;
	                                if (12321 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 12329)break
	                            }
	                            d = c[m >> 2] | 0;
	                            if ((c[m >> 2] | 0) < 256) {
	                                if (48 <= (d | 0) & (c[m >> 2] | 0) <= 57 | (c[m >> 2] | 0) == 46 | (c[m >> 2] | 0) == 45 | (c[m >> 2] | 0) == 95)break
	                            } else {
	                                b = (DQ(d, 200216) | 0) != 0;
	                                if (b | (c[m >> 2] | 0) == 46 | (c[m >> 2] | 0) == 45 | (c[m >> 2] | 0) == 95)break
	                            }
	                            if (!((c[h >> 2] | 0) != 0 & (c[m >> 2] | 0) == 58)) {
	                                if ((c[m >> 2] | 0) >= 256 ? (DQ(c[m >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                                b = c[m >> 2] | 0;
	                                if ((c[m >> 2] | 0) < 256)q = (b | 0) == 183 & 1; else q = DQ(b, 200272) | 0;
	                                if (!q) {
	                                    p = 72;
	                                    break b
	                                }
	                            }
	                        } while (0);
	                        if ((c[l >> 2] | 0) == 1) {
	                            b = c[m >> 2] & 255;
	                            d = c[k >> 2] | 0;
	                            c[k >> 2] = d + 1;
	                            a[j + d >> 0] = b
	                        } else {
	                            b = qe(c[l >> 2] | 0, j + (c[k >> 2] | 0) | 0, c[m >> 2] | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        b = c[g >> 2] | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + (c[l >> 2] | 0);
	                        c[m >> 2] = bu(c[g >> 2] | 0, l) | 0
	                    } while ((c[k >> 2] | 0) < 100);
	                    if ((p | 0) == 72)if (!(c[k >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else {
	                        c[f >> 2] = ly(j, c[k >> 2] | 0) | 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    c[o >> 2] = c[k >> 2] << 1;
	                    if ((c[k >> 2] | 0) > 5e4) {
	                        Nq(c[g >> 2] | 0, 7);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    c[n >> 2] = Cb[c[135752 >> 2] & 511](c[o >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        Nq(c[g >> 2] | 0, 15);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    eU(c[n >> 2] | 0, j | 0, c[k >> 2] | 0) | 0;
	                    while (1) {
	                        b = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) < 256)if (((!(65 <= (b | 0) & (c[m >> 2] | 0) <= 90) ? !(97 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 122) : 0) ? !(192 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 214) : 0) ? !(216 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 246 | 248 <= (c[m >> 2] | 0)) : 0)p = 48; else s = 1; else if (DQ(b, 199744) | 0)s = 1; else p = 48;
	                        do if ((p | 0) == 48) {
	                            p = 0;
	                            if ((c[m >> 2] | 0) >= 256) {
	                                if (19968 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 40869 | (c[m >> 2] | 0) == 12295) {
	                                    s = 1;
	                                    break
	                                }
	                                if (12321 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 12329) {
	                                    s = 1;
	                                    break
	                                }
	                            }
	                            b = c[m >> 2] | 0;
	                            if ((c[m >> 2] | 0) < 256) {
	                                if (48 <= (b | 0) & (c[m >> 2] | 0) <= 57 | (c[m >> 2] | 0) == 46 | (c[m >> 2] | 0) == 45 | (c[m >> 2] | 0) == 95) {
	                                    s = 1;
	                                    break
	                                }
	                            } else {
	                                d = (DQ(b, 200216) | 0) != 0;
	                                if (d | (c[m >> 2] | 0) == 46 | (c[m >> 2] | 0) == 45 | (c[m >> 2] | 0) == 95) {
	                                    s = 1;
	                                    break
	                                }
	                            }
	                            if ((c[h >> 2] | 0) != 0 & (c[m >> 2] | 0) == 58)s = 1; else {
	                                if ((c[m >> 2] | 0) >= 256 ? (DQ(c[m >> 2] | 0, 200144) | 0) != 0 : 0) {
	                                    s = 1;
	                                    break
	                                }
	                                d = c[m >> 2] | 0;
	                                if ((c[m >> 2] | 0) < 256)t = (d | 0) == 183 & 1; else t = DQ(d, 200272) | 0;
	                                s = (t | 0) != 0
	                            }
	                        } while (0);
	                        u = c[k >> 2] | 0;
	                        if (!s) {
	                            p = 71;
	                            break
	                        }
	                        if ((u + 10 | 0) > (c[o >> 2] | 0)) {
	                            if ((c[o >> 2] | 0) > 5e4) {
	                                p = 64;
	                                break
	                            }
	                            c[o >> 2] = c[o >> 2] << 1;
	                            c[n >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0)) {
	                                p = 66;
	                                break
	                            }
	                        }
	                        if ((c[l >> 2] | 0) == 1) {
	                            d = c[m >> 2] & 255;
	                            b = c[k >> 2] | 0;
	                            c[k >> 2] = b + 1;
	                            a[(c[n >> 2] | 0) + b >> 0] = d
	                        } else {
	                            d = qe(c[l >> 2] | 0, (c[n >> 2] | 0) + (c[k >> 2] | 0) | 0, c[m >> 2] | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d
	                        }
	                        d = c[g >> 2] | 0;
	                        c[d >> 2] = (c[d >> 2] | 0) + (c[l >> 2] | 0);
	                        c[m >> 2] = bu(c[g >> 2] | 0, l) | 0
	                    }
	                    if ((p | 0) == 64) {
	                        Nq(c[g >> 2] | 0, 7);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((p | 0) == 66) {
	                        Nq(c[g >> 2] | 0, 15);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((p | 0) == 71) {
	                        a[(c[n >> 2] | 0) + u >> 0] = 0;
	                        c[f >> 2] = c[n >> 2];
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                } while (0);
	                c[f >> 2] = 0;
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function It(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                if (((vy(c[h >> 2] | 0, 91) | 0) == 0 ? (vy(c[h >> 2] | 0, 40) | 0) == 0 : 0) ? (vy(c[h >> 2] | 0, 64) | 0) == 0 : 0) {
	                    c[q >> 2] = vy(c[h >> 2] | 0, 58) | 0;
	                    do if (c[q >> 2] | 0) {
	                        if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) ? (d[(c[q >> 2] | 0) + 1 >> 0] | 0 | 0) != 58 : 0)break;
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } while (0);
	                    if ((c[g >> 2] | 0) != 0 ? (c[l >> 2] = c[(c[g >> 2] | 0) + 192 >> 2], (c[(c[g >> 2] | 0) + 60 >> 2] | 0) > 0) : 0) {
	                        c[m >> 2] = Cb[c[135744 >> 2] & 511]((c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 1 << 1 << 2) | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            it(c[g >> 2] | 0, 130672);
	                            c[f >> 2] = 0;
	                            r = c[f >> 2] | 0;
	                            i = e;
	                            return r | 0
	                        }
	                        c[o >> 2] = 0;
	                        c[p >> 2] = 0;
	                        while (1) {
	                            if ((c[p >> 2] | 0) >= (c[(c[g >> 2] | 0) + 60 >> 2] | 0))break;
	                            c[n >> 2] = c[(c[(c[g >> 2] | 0) + 56 >> 2] | 0) + (c[p >> 2] << 2) >> 2];
	                            q = c[(c[n >> 2] | 0) + 8 >> 2] | 0;
	                            b = c[o >> 2] | 0;
	                            c[o >> 2] = b + 1;
	                            c[(c[m >> 2] | 0) + (b << 2) >> 2] = q;
	                            q = c[(c[n >> 2] | 0) + 12 >> 2] | 0;
	                            b = c[o >> 2] | 0;
	                            c[o >> 2] = b + 1;
	                            c[(c[m >> 2] | 0) + (b << 2) >> 2] = q;
	                            c[p >> 2] = (c[p >> 2] | 0) + 1
	                        }
	                        p = c[o >> 2] | 0;
	                        c[o >> 2] = p + 1;
	                        c[(c[m >> 2] | 0) + (p << 2) >> 2] = 0;
	                        c[(c[m >> 2] | 0) + (c[o >> 2] << 2) >> 2] = 0
	                    }
	                    c[j >> 2] = MQ(c[h >> 2] | 0, c[l >> 2] | 0, 1, c[m >> 2] | 0) | 0;
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    if ((c[j >> 2] | 0) != 0 ? (PQ(c[j >> 2] | 0) | 0) == 1 : 0) {
	                        c[k >> 2] = pt() | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            it(c[g >> 2] | 0, 130704);
	                            c[f >> 2] = 0;
	                            r = c[f >> 2] | 0;
	                            i = e;
	                            return r | 0
	                        }
	                        c[(c[k >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                        c[(c[k >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                        if (c[(c[k >> 2] | 0) + 20 >> 2] | 0)yP(c[(c[k >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        c[f >> 2] = c[k >> 2];
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    EQ(c[j >> 2] | 0)
	                }
	                c[f >> 2] = 0;
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function Jt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                cu(c[f >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    b = c[f >> 2] | 0;
	                    if (!(d[c[c[f >> 2] >> 2] >> 0] | 0))continue;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 111)break;
	                    if ((d[(c[c[f >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 114)break;
	                    c[h >> 2] = c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    b = c[f >> 2] | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    while (1) {
	                        do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                            if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = c[f >> 2] | 0;
	                        if (!j)break;
	                        b = c[f >> 2] | 0;
	                        if (!(d[c[k >> 2] >> 0] | 0))continue;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1
	                    }
	                    cu(k);
	                    if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                        l = 29;
	                        break
	                    }
	                    du(c[(c[f >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0, c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 2, 0, 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        b = c[f >> 2] | 0;
	                        if (!(d[c[c[f >> 2] >> 2] >> 0] | 0))continue;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1
	                    }
	                }
	                if ((l | 0) == 29) {
	                    i = e;
	                    return
	                }
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0) * 40 | 0) >> 2] | 0) == 12) {
	                    i = e;
	                    return
	                }
	                du(c[(c[f >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 18, 0, 0, 0, 0, 0) | 0;
	                i = e;
	                return
	            }

	            function Kt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                do if ((((((((c[c[f >> 2] >> 2] | 0) == 11 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != -1 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) == -1 : 0) ? (c[g >> 2] = (c[(c[e >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) * 40 | 0), (c[c[g >> 2] >> 2] | 0) == 11) : 0) ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 6 : 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) == -1 : 0) ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 1 : 0) ? (c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) {
	                    b = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                    if ((b | 0) == 6 | (b | 0) == 13) {
	                        c[(c[f >> 2] | 0) + 4 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                        c[(c[f >> 2] | 0) + 12 >> 2] = 6;
	                        break
	                    } else if ((b | 0) == 5 | (b | 0) == 4) {
	                        c[(c[f >> 2] | 0) + 4 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                        c[(c[f >> 2] | 0) + 12 >> 2] = 5;
	                        break
	                    } else break
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != -1)Kt(c[e >> 2] | 0, (c[(c[e >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0);
	                if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                    i = d;
	                    return
	                }
	                Kt(c[e >> 2] | 0, (c[(c[e >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0);
	                i = d;
	                return
	            }

	            function Lt(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                q = f + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                if (!(c[k >> 2] | 0)) {
	                    Xd(0, 0, 0, 0, 0, 12, 1, 3, 128552, 14895, 0, 0, 0, 0, 0, 129480, g);
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                Kq();
	                c[32576] = (c[32576] | 0) + 1;
	                if ((c[32576] | 0) > 1)c[32574] = 1;
	                c[n >> 2] = eu(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[o >> 2] = Mt(c[n >> 2] | 0, c[m >> 2] | 0) | 0;
	                do if (c[l >> 2] | 0)if (!(c[(c[n >> 2] | 0) + 16 >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 130312, g);
	                    c[c[l >> 2] >> 2] = 0;
	                    break
	                } else {
	                    j = Sq(c[n >> 2] | 0) | 0;
	                    c[c[l >> 2] >> 2] = j;
	                    break
	                } while (0);
	                do if ((c[(c[n >> 2] | 0) + 20 >> 2] | 0) > 0) {
	                    c[q >> 2] = 0;
	                    do {
	                        c[p >> 2] = Sq(c[n >> 2] | 0) | 0;
	                        if (c[p >> 2] | 0) {
	                            c[q >> 2] = (c[q >> 2] | 0) + 1;
	                            jt(c[k >> 2] | 0, c[p >> 2] | 0)
	                        }
	                    } while ((c[p >> 2] | 0) != 0);
	                    if (c[q >> 2] | 0) {
	                        if (!(c[m >> 2] | 0)) {
	                            if (!(c[l >> 2] | 0))break;
	                            if (!(c[c[l >> 2] >> 2] | 0))break
	                        }
	                        j = c[33976] | 0;
	                        e = c[33980] | 0;
	                        c[g >> 2] = c[q >> 2];
	                        Db[j & 511](e, 130360, g)
	                    }
	                } while (0);
	                if (((c[l >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[c[l >> 2] >> 2] | 0) != 0 : 0) {
	                    Qq(c[c[l >> 2] >> 2] | 0);
	                    c[c[l >> 2] >> 2] = 0
	                }
	                c[(c[n >> 2] | 0) + 32 >> 2] = 0;
	                Pr(c[n >> 2] | 0);
	                c[32576] = (c[32576] | 0) + -1;
	                c[h >> 2] = c[o >> 2];
	                r = c[h >> 2] | 0;
	                i = f;
	                return r | 0
	            }

	            function Mt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                    if (!(c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                        b = Cb[c[135744 >> 2] & 511](40) | 0;
	                        c[(c[g >> 2] | 0) + 28 >> 2] = b;
	                        if (!(c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                            fu(c[g >> 2] | 0, 129952);
	                            zb[c[135736 >> 2] & 511](c[g >> 2] | 0)
	                        }
	                        c[(c[g >> 2] | 0) + 20 >> 2] = 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = 10;
	                        c[(c[g >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[g >> 2] | 0) + 44 >> 2] = 0
	                    }
	                    do if (c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] | 0) {
	                        if (c[h >> 2] | 0) {
	                            c[k >> 2] = gu(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] | 0, 0, 1) | 0;
	                            if ((c[k >> 2] | 0) == -1)break;
	                            c[f >> 2] = c[k >> 2];
	                            m = c[f >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                        c[l >> 2] = 0;
	                        c[k >> 2] = gu(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 24 >> 2] | 0, l, 0) | 0;
	                        if ((c[k >> 2] | 0) != -1 & (c[l >> 2] | 0) != 0) {
	                            Tq(c[g >> 2] | 0, c[l >> 2] | 0) | 0;
	                            c[f >> 2] = 0;
	                            m = c[f >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        } else {
	                            if (!(c[l >> 2] | 0))break;
	                            jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0);
	                            break
	                        }
	                    } while (0);
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                    if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) < 0) {
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 129984, e);
	                        c[f >> 2] = -1;
	                        m = c[f >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    e = c[g >> 2] | 0;
	                    g = (c[(c[j >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) * 40 | 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[f >> 2] = hu(e, g, 0) | 0;
	                        m = c[f >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else {
	                        iu(e, g) | 0;
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                }
	                c[f >> 2] = -1;
	                m = c[f >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function Nt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = ju(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                f = c[g >> 2] | 0;
	                i = d;
	                return ((c[g >> 2] | 0) == -2 ? f : 0 - f | 0) | 0
	            }

	            function Ot(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 32 | 0;
	                g = e + 60 | 0;
	                h = e + 56 | 0;
	                j = e + 52 | 0;
	                k = e + 24 | 0;
	                l = e + 16 | 0;
	                m = e + 8 | 0;
	                n = e + 48 | 0;
	                o = e + 44 | 0;
	                p = e;
	                q = e + 40 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                d = k;
	                c[d >> 2] = 0;
	                c[d + 4 >> 2] = 0;
	                d = m;
	                c[d >> 2] = (c[j >> 2] | 0) - 1;
	                c[d + 4 >> 2] = 0;
	                d = m;
	                j = YT(c[d >> 2] | 0, c[d + 4 >> 2] | 0, 1) | 0;
	                d = l;
	                c[d >> 2] = j;
	                c[d + 4 >> 2] = G;
	                c[n >> 2] = c[(c[g >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                if ((Nt(c[h >> 2] | 0, c[n >> 2] | 0) | 0) < 0) {
	                    d = f;
	                    c[d >> 2] = 0;
	                    c[d + 4 >> 2] = 0;
	                    r = f;
	                    s = r;
	                    t = c[s >> 2] | 0;
	                    u = r + 4 | 0;
	                    v = u;
	                    w = c[v >> 2] | 0;
	                    G = w;
	                    i = e;
	                    return t | 0
	                }
	                if (!(Nt(c[h >> 2] | 0, c[n >> 2] | 0) | 0)) {
	                    d = p;
	                    c[d >> 2] = 1;
	                    c[d + 4 >> 2] = 0;
	                    while (1) {
	                        d = (Nt(c[h >> 2] | 0, c[(c[g >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) | 0) == 0;
	                        j = p;
	                        x = c[j >> 2] | 0;
	                        y = c[j + 4 >> 2] | 0;
	                        if (!d)break;
	                        d = bU(x | 0, y | 0, 1, 0) | 0;
	                        j = p;
	                        c[j >> 2] = d;
	                        c[j + 4 >> 2] = G
	                    }
	                    p = f;
	                    c[p >> 2] = x;
	                    c[p + 4 >> 2] = y;
	                    r = f;
	                    s = r;
	                    t = c[s >> 2] | 0;
	                    u = r + 4 | 0;
	                    v = u;
	                    w = c[v >> 2] | 0;
	                    G = w;
	                    i = e;
	                    return t | 0
	                }
	                c[o >> 2] = c[(c[g >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                while (1) {
	                    c[q >> 2] = Nt(c[h >> 2] | 0, c[o >> 2] | 0) | 0;
	                    if ((c[q >> 2] | 0) < 0) {
	                        y = l;
	                        p = k;
	                        x = XT(c[y >> 2] | 0, c[y + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                        p = G;
	                        y = l;
	                        z = c[y >> 2] | 0;
	                        A = c[y + 4 >> 2] | 0;
	                        if ((p | 0) < 0 | (p | 0) == 0 & x >>> 0 <= 1) {
	                            B = 11;
	                            break
	                        }
	                        x = m;
	                        c[x >> 2] = z;
	                        c[x + 4 >> 2] = A
	                    } else {
	                        if ((c[q >> 2] | 0) <= 0) {
	                            B = 17;
	                            break
	                        }
	                        x = m;
	                        p = l;
	                        y = XT(c[x >> 2] | 0, c[x + 4 >> 2] | 0, c[p >> 2] | 0, c[p + 4 >> 2] | 0) | 0;
	                        p = G;
	                        x = l;
	                        C = c[x >> 2] | 0;
	                        D = c[x + 4 >> 2] | 0;
	                        if ((p | 0) < 0 | (p | 0) == 0 & y >>> 0 <= 1) {
	                            B = 15;
	                            break
	                        }
	                        y = k;
	                        c[y >> 2] = C;
	                        c[y + 4 >> 2] = D;
	                        c[n >> 2] = c[o >> 2]
	                    }
	                    y = k;
	                    p = c[y >> 2] | 0;
	                    x = c[y + 4 >> 2] | 0;
	                    y = m;
	                    j = k;
	                    d = XT(c[y >> 2] | 0, c[y + 4 >> 2] | 0, c[j >> 2] | 0, c[j + 4 >> 2] | 0) | 0;
	                    j = YT(d | 0, G | 0, 1) | 0;
	                    d = bU(p | 0, x | 0, j | 0, G | 0) | 0;
	                    j = l;
	                    c[j >> 2] = d;
	                    c[j + 4 >> 2] = G;
	                    c[o >> 2] = c[(c[g >> 2] | 0) + (c[l >> 2] << 2) >> 2]
	                }
	                if ((B | 0) == 11) {
	                    k = f;
	                    c[k >> 2] = z;
	                    c[k + 4 >> 2] = A;
	                    r = f;
	                    s = r;
	                    t = c[s >> 2] | 0;
	                    u = r + 4 | 0;
	                    v = u;
	                    w = c[v >> 2] | 0;
	                    G = w;
	                    i = e;
	                    return t | 0
	                } else if ((B | 0) == 15) {
	                    A = bU(C | 0, D | 0, 1, 0) | 0;
	                    D = f;
	                    c[D >> 2] = A;
	                    c[D + 4 >> 2] = G;
	                    r = f;
	                    s = r;
	                    t = c[s >> 2] | 0;
	                    u = r + 4 | 0;
	                    v = u;
	                    w = c[v >> 2] | 0;
	                    G = w;
	                    i = e;
	                    return t | 0
	                } else if ((B | 0) == 17) {
	                    while (1) {
	                        B = 0;
	                        D = l;
	                        A = bU(c[D >> 2] | 0, c[D + 4 >> 2] | 0, 1, 0) | 0;
	                        D = l;
	                        c[D >> 2] = A;
	                        c[D + 4 >> 2] = G;
	                        c[o >> 2] = c[(c[g >> 2] | 0) + (A << 2) >> 2];
	                        if (!(Nt(c[h >> 2] | 0, c[o >> 2] | 0) | 0))B = 17; else break
	                    }
	                    B = l;
	                    l = c[B + 4 >> 2] | 0;
	                    o = f;
	                    c[o >> 2] = c[B >> 2];
	                    c[o + 4 >> 2] = l;
	                    r = f;
	                    s = r;
	                    t = c[s >> 2] | 0;
	                    u = r + 4 | 0;
	                    v = u;
	                    w = c[v >> 2] | 0;
	                    G = w;
	                    i = e;
	                    return t | 0
	                }
	                return 0
	            }

	            function Pt(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 8 | 0;
	                k = g;
	                l = g + 16 | 0;
	                c[h >> 2] = a;
	                a = j;
	                c[a >> 2] = b;
	                c[a + 4 >> 2] = d;
	                d = k;
	                c[d >> 2] = e;
	                c[d + 4 >> 2] = f;
	                while (1) {
	                    f = j;
	                    d = c[f + 4 >> 2] | 0;
	                    e = k;
	                    a = c[e + 4 >> 2] | 0;
	                    if ((d | 0) > (a | 0) | ((d | 0) == (a | 0) ? (c[f >> 2] | 0) >>> 0 >= (c[e >> 2] | 0) >>> 0 : 0))break;
	                    c[l >> 2] = c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                    c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2] = c[(c[h >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                    c[(c[h >> 2] | 0) + (c[k >> 2] << 2) >> 2] = c[l >> 2];
	                    e = j;
	                    f = bU(c[e >> 2] | 0, c[e + 4 >> 2] | 0, 1, 0) | 0;
	                    e = j;
	                    c[e >> 2] = f;
	                    c[e + 4 >> 2] = G;
	                    e = k;
	                    f = bU(c[e >> 2] | 0, c[e + 4 >> 2] | 0, -1, -1) | 0;
	                    e = k;
	                    c[e >> 2] = f;
	                    c[e + 4 >> 2] = G
	                }
	                i = g;
	                return
	            }

	            function Qt(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[c[f >> 2] >> 2] | 0) >>> 0 >= (c[g >> 2] | 0) >>> 0) {
	                    i = d;
	                    return
	                }
	                c[h >> 2] = kT(c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] << 2) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    b = c[o >> 2] | 0;
	                    c[e >> 2] = c[g >> 2] << 2;
	                    Ka(b | 0, 131856, e | 0) | 0;
	                    qb(1)
	                }
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                c[c[f >> 2] >> 2] = c[g >> 2];
	                i = d;
	                return
	            }

	            function Rt(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e;
	                j = e + 8 | 0;
	                c[f >> 2] = b;
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= 8)break;
	                    a[g + (d[131816 + (7 - (c[j >> 2] | 0)) >> 0] | 0) >> 0] = a[(c[f >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                i = e;
	                return +(+h[g >> 3])
	            }

	            function St(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b;
	                h[d >> 3] = a;
	                h[e >> 3] = +h[d >> 3];
	                d = e;
	                G = c[d + 4 >> 2] | 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Tt(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                g[d >> 2] = a;
	                g[e >> 2] = +g[d >> 2];
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Ut(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f + 24 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[m >> 2] = 0;
	                while (1) {
	                    o = n + ((c[m >> 2] << 1) + 1) | 0;
	                    if (!((c[m >> 2] | 0) < 25 ? (c[m >> 2] | 0) < (c[k >> 2] | 0) : 0))break;
	                    a[o >> 0] = 32;
	                    a[n + (c[m >> 2] << 1) >> 0] = 32;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                a[o >> 0] = 0;
	                a[n + (c[m >> 2] << 1) >> 0] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    m = c[h >> 2] | 0;
	                    c[g >> 2] = n;
	                    Ka(m | 0, 127912, g | 0) | 0;
	                    Ka(c[h >> 2] | 0, 131072, g | 0) | 0;
	                    i = f;
	                    return
	                }
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    c[l >> 2] = c[j >> 2];
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                    Kp(c[h >> 2] | 0, c[l >> 2] | 0, c[k >> 2] | 0)
	                }
	                i = f;
	                return
	            }

	            function Vt(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 8 | 0;
	                h[d >> 3] = a;
	                ku(+h[d >> 3], e) | 0;
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Wt(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 4 >> 2] | 0))break;
	                    c[f >> 2] = c[(c[c[d >> 2] >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                        if (c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0)
	                    }
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                lu(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Xt(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 130864);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                if ((c[e >> 2] | 0) > 0) {
	                    Yt(c[f >> 2] | 0, 0, c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Yt(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (c[c[g >> 2] >> 2] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) <= (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                        if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) > 5e7) {
	                            it(0, 130904);
	                            c[f >> 2] = -1;
	                            k = c[f >> 2] | 0;
	                            i = e;
	                            return k | 0
	                        }
	                        d = (c[g >> 2] | 0) + 8 | 0;
	                        c[d >> 2] = c[d >> 2] << 1;
	                        d = Hb[c[135760 >> 2] & 511](c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] << 2) | 0;
	                        c[c[g >> 2] >> 2] = d;
	                        if (!(c[c[g >> 2] >> 2] | 0)) {
	                            it(0, 130904);
	                            c[(c[g >> 2] | 0) + 8 >> 2] = 0;
	                            c[f >> 2] = -1;
	                            k = c[f >> 2] | 0;
	                            i = e;
	                            return k | 0
	                        }
	                    }
	                } else {
	                    if ((c[j >> 2] | 0) <= 0)c[j >> 2] = 1;
	                    d = Cb[c[135744 >> 2] & 511](c[j >> 2] << 2) | 0;
	                    c[c[g >> 2] >> 2] = d;
	                    if (c[c[g >> 2] >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 4 >> 2] = 0;
	                        c[(c[g >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                        break
	                    }
	                    it(0, 130864);
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } while (0);
	                j = c[h >> 2] | 0;
	                h = (c[g >> 2] | 0) + 4 | 0;
	                d = c[h >> 2] | 0;
	                c[h >> 2] = d + 1;
	                c[(c[c[g >> 2] >> 2] | 0) + (d << 2) >> 2] = j;
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Zt(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 2;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 9) {
	                    c[j >> 2] = Pi(c[f >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0))c[f >> 2] = c[(c[f >> 2] | 0) + 12 >> 2]; else c[f >> 2] = c[j >> 2];
	                    if (!(c[f >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                }
	                switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    case 2:
	                    {
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 1:
	                    {
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 3:
	                    case 4:
	                    case 7:
	                    case 8:
	                    {
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                        if (!(d[c[h >> 2] >> 0] | 0)) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        } else {
	                            c[e >> 2] = (d[c[h >> 2] >> 0] | 0) + ((d[(c[h >> 2] | 0) + 1 >> 0] | 0) << 8);
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                        if (!(d[c[h >> 2] >> 0] | 0)) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        } else {
	                            c[e >> 2] = (d[c[h >> 2] >> 0] | 0) + ((d[(c[h >> 2] | 0) + 1 >> 0] | 0) << 8);
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                        break
	                    }
	                    default:
	                    {
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                }
	                a:while (1) {
	                    if (!(c[j >> 2] | 0)) {
	                        m = 47;
	                        break
	                    }
	                    switch (c[(c[j >> 2] | 0) + 4 >> 2] | 0) {
	                        case 18:
	                        {
	                            c[h >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                            break
	                        }
	                        case 3:
	                        case 4:
	                        case 7:
	                        case 8:
	                        {
	                            c[h >> 2] = c[(c[j >> 2] | 0) + 40 >> 2];
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    if ((c[h >> 2] | 0) != 0 ? (d[c[h >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                        if ((c[g >> 2] | 0) == 1) {
	                            m = 30;
	                            break
	                        }
	                        if (d[(c[h >> 2] | 0) + 1 >> 0] | 0) {
	                            m = 33;
	                            break
	                        }
	                        c[g >> 2] = 1;
	                        c[k >> 2] = d[c[h >> 2] >> 0]
	                    }
	                    if (((c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 14 : 0) ? (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) {
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        continue
	                    }
	                    if ((c[j >> 2] | 0) == (c[f >> 2] | 0)) {
	                        m = 47;
	                        break
	                    }
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] | 0) {
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                        if (!(c[j >> 2] | 0))continue a;
	                        if ((c[j >> 2] | 0) == (c[f >> 2] | 0)) {
	                            m = 43;
	                            break
	                        }
	                        n = c[j >> 2] | 0;
	                        if (c[(c[j >> 2] | 0) + 24 >> 2] | 0) {
	                            m = 45;
	                            break
	                        }
	                        if (!n)continue a
	                    }
	                    if ((m | 0) == 43) {
	                        m = 0;
	                        c[j >> 2] = 0;
	                        continue
	                    } else if ((m | 0) == 45) {
	                        m = 0;
	                        c[j >> 2] = c[n + 24 >> 2];
	                        continue
	                    }
	                }
	                if ((m | 0) == 30) {
	                    c[e >> 2] = (c[k >> 2] | 0) + ((d[c[h >> 2] >> 0] | 0) << 8);
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } else if ((m | 0) == 33) {
	                    c[e >> 2] = (d[c[h >> 2] >> 0] | 0) + ((d[(c[h >> 2] | 0) + 1 >> 0] | 0) << 8);
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } else if ((m | 0) == 47) {
	                    c[e >> 2] = c[k >> 2];
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                return 0
	            }

	            function _t(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[f >> 2] = a;
	                do if (c[f >> 2] | 0)if (!(d[c[f >> 2] >> 0] | 0)) {
	                    c[e >> 2] = 0;
	                    break
	                } else {
	                    c[e >> 2] = (d[c[f >> 2] >> 0] | 0) + ((d[(c[f >> 2] | 0) + 1 >> 0] | 0) << 8);
	                    break
	                } else c[e >> 2] = 0; while (0);
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function $t(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                do if (!((c[n >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0)) {
	                    if ((c[c[m >> 2] >> 2] | 0) != 1 ? (c[c[m >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[q >> 2] = c[(c[m >> 2] | 0) + 4 >> 2];
	                    a:do if (c[q >> 2] | 0) {
	                        c[o >> 2] = 0;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[c[q >> 2] >> 2] | 0))break a;
	                            c[r >> 2] = ir(c[(c[(c[q >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) | 0;
	                            if ((c[r >> 2] | 0) != 0 ? (f = c[j >> 2] | 0, Tq(f, Dt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[r >> 2] | 0) | 0) | 0, zb[c[135736 >> 2] & 511](c[r >> 2] | 0), Tr(c[j >> 2] | 0, 1), f = c[j >> 2] | 0, Tq(f, lt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0) | 0) | 0, c[p >> 2] = Sr(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0, (c[p >> 2] | 0) != 0) : 0)break a;
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                    jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0);
	                    c[h >> 2] = c[p >> 2];
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                } while (0);
	                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0);
	                c[h >> 2] = 0;
	                s = c[h >> 2] | 0;
	                i = g;
	                return s | 0
	            }

	            function au(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                do if (!((c[n >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0)) {
	                    if ((c[c[m >> 2] >> 2] | 0) != 1 ? (c[c[m >> 2] >> 2] | 0) != 9 : 0)break;
	                    c[q >> 2] = c[(c[m >> 2] | 0) + 4 >> 2];
	                    a:do if (c[q >> 2] | 0) {
	                        c[o >> 2] = 0;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[c[q >> 2] >> 2] | 0))break a;
	                            c[r >> 2] = ir(c[(c[(c[q >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) | 0;
	                            if ((c[r >> 2] | 0) != 0 ? (f = c[j >> 2] | 0, Tq(f, Dt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[r >> 2] | 0) | 0) | 0, zb[c[135736 >> 2] & 511](c[r >> 2] | 0), f = c[j >> 2] | 0, Tq(f, lt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0) | 0) | 0, c[p >> 2] = Sr(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0, (c[p >> 2] | 0) != 0) : 0)break a;
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                    jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0);
	                    c[h >> 2] = c[p >> 2];
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                } while (0);
	                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0);
	                c[h >> 2] = 0;
	                s = c[h >> 2] | 0;
	                i = g;
	                return s | 0
	            }

	            function bu(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 20 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = c[c[h >> 2] >> 2];
	                a[k >> 0] = a[c[m >> 2] >> 0] | 0;
	                if (!((d[k >> 0] | 0) & 128)) {
	                    c[c[j >> 2] >> 2] = 1;
	                    c[g >> 2] = d[c[m >> 2] >> 0];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                a:do if (((d[(c[m >> 2] | 0) + 1 >> 0] | 0) & 192 | 0) == 128) {
	                    do if (((d[k >> 0] | 0) & 224 | 0) == 224) {
	                        if (((d[(c[m >> 2] | 0) + 2 >> 0] | 0) & 192 | 0) != 128)break a;
	                        if (((d[k >> 0] | 0) & 240 | 0) != 240) {
	                            c[c[j >> 2] >> 2] = 3;
	                            c[l >> 2] = ((d[c[m >> 2] >> 0] | 0) & 15) << 12;
	                            c[l >> 2] = c[l >> 2] | ((d[(c[m >> 2] | 0) + 1 >> 0] | 0) & 63) << 6;
	                            c[l >> 2] = c[l >> 2] | (d[(c[m >> 2] | 0) + 2 >> 0] | 0) & 63;
	                            break
	                        }
	                        if (((d[k >> 0] | 0) & 248 | 0) != 240)break a;
	                        if (((d[(c[m >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128)break a;
	                        c[c[j >> 2] >> 2] = 4;
	                        c[l >> 2] = ((d[c[m >> 2] >> 0] | 0) & 7) << 18;
	                        c[l >> 2] = c[l >> 2] | ((d[(c[m >> 2] | 0) + 1 >> 0] | 0) & 63) << 12;
	                        c[l >> 2] = c[l >> 2] | ((d[(c[m >> 2] | 0) + 2 >> 0] | 0) & 63) << 6;
	                        c[l >> 2] = c[l >> 2] | (d[(c[m >> 2] | 0) + 3 >> 0] | 0) & 63
	                    } else {
	                        c[c[j >> 2] >> 2] = 2;
	                        c[l >> 2] = ((d[c[m >> 2] >> 0] | 0) & 31) << 6;
	                        c[l >> 2] = c[l >> 2] | (d[(c[m >> 2] | 0) + 1 >> 0] | 0) & 63
	                    } while (0);
	                    e = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) >>> 0 < 256)if (9 <= e >>> 0 & (c[l >> 2] | 0) >>> 0 <= 10 | (c[l >> 2] | 0) == 13 | 32 <= (c[l >> 2] | 0) >>> 0)o = 19; else o = 18; else if ((!(256 <= e >>> 0 & (c[l >> 2] | 0) >>> 0 <= 55295) ? !(57344 <= (c[l >> 2] | 0) >>> 0 & (c[l >> 2] | 0) >>> 0 <= 65533) : 0) ? !(65536 <= (c[l >> 2] | 0) >>> 0 & (c[l >> 2] | 0) >>> 0 <= 1114111) : 0)o = 18; else o = 19;
	                    if ((o | 0) == 18) {
	                        Nq(c[h >> 2] | 0, 21);
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else if ((o | 0) == 19) {
	                        c[g >> 2] = c[l >> 2];
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                } while (0);
	                c[c[j >> 2] >> 2] = 0;
	                Nq(c[h >> 2] | 0, 20);
	                c[g >> 2] = 0;
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function cu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                mu(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 97) {
	                        g = 27;
	                        break
	                    }
	                    if ((d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 110) {
	                        g = 27;
	                        break
	                    }
	                    if ((d[(c[c[e >> 2] >> 2] | 0) + 2 >> 0] | 0 | 0) != 100) {
	                        g = 27;
	                        break
	                    }
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    a = c[e >> 2] | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 3;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)h = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                h = 1;
	                                break
	                            }
	                            h = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        j = c[e >> 2] | 0;
	                        if (!h)break;
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[j >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    mu(j);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        g = 27;
	                        break
	                    }
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[f >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 1, 0, 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                if ((g | 0) == 27) {
	                    i = b;
	                    return
	                }
	            }

	            function du(a, b, d, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                l = i;
	                i = i + 48 | 0;
	                m = l + 40 | 0;
	                n = l + 36 | 0;
	                o = l + 32 | 0;
	                p = l + 28 | 0;
	                q = l + 24 | 0;
	                r = l + 20 | 0;
	                s = l + 16 | 0;
	                t = l + 12 | 0;
	                u = l + 8 | 0;
	                v = l + 4 | 0;
	                w = l;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[p >> 2] = d;
	                c[q >> 2] = e;
	                c[r >> 2] = f;
	                c[s >> 2] = g;
	                c[t >> 2] = h;
	                c[u >> 2] = j;
	                c[v >> 2] = k;
	                do if ((c[c[n >> 2] >> 2] | 0) >= (c[(c[n >> 2] | 0) + 4 >> 2] | 0)) {
	                    if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) >= 1e6) {
	                        it(0, 130416);
	                        c[m >> 2] = -1;
	                        x = c[m >> 2] | 0;
	                        i = l;
	                        return x | 0
	                    }
	                    k = (c[n >> 2] | 0) + 4 | 0;
	                    c[k >> 2] = c[k >> 2] << 1;
	                    c[w >> 2] = Hb[c[135760 >> 2] & 511](c[(c[n >> 2] | 0) + 8 >> 2] | 0, (c[(c[n >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0;
	                    if (c[w >> 2] | 0) {
	                        c[(c[n >> 2] | 0) + 8 >> 2] = c[w >> 2];
	                        break
	                    }
	                    k = (c[n >> 2] | 0) + 4 | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) / 2 | 0;
	                    it(0, 130416);
	                    c[m >> 2] = -1;
	                    x = c[m >> 2] | 0;
	                    i = l;
	                    return x | 0
	                } while (0);
	                c[(c[n >> 2] | 0) + 12 >> 2] = c[c[n >> 2] >> 2];
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 4 >> 2] = c[o >> 2];
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 8 >> 2] = c[p >> 2];
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) >> 2] = c[q >> 2];
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 12 >> 2] = c[r >> 2];
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 16 >> 2] = c[s >> 2];
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 20 >> 2] = c[t >> 2];
	                do if ((c[(c[n >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[q >> 2] | 0) == 14 | (c[q >> 2] | 0) == 13 | (c[q >> 2] | 0) == 11 : 0) {
	                    t = c[n >> 2] | 0;
	                    if (c[u >> 2] | 0) {
	                        s = AP(c[t + 20 >> 2] | 0, c[u >> 2] | 0, -1) | 0;
	                        c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 24 >> 2] = s;
	                        zb[c[135736 >> 2] & 511](c[u >> 2] | 0)
	                    } else c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[t >> 2] | 0) * 40 | 0) + 24 >> 2] = 0;
	                    t = c[n >> 2] | 0;
	                    if (c[v >> 2] | 0) {
	                        s = AP(c[t + 20 >> 2] | 0, c[v >> 2] | 0, -1) | 0;
	                        c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 28 >> 2] = s;
	                        zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                        break
	                    } else {
	                        c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[t >> 2] | 0) * 40 | 0) + 28 >> 2] = 0;
	                        break
	                    }
	                } else y = 15; while (0);
	                if ((y | 0) == 15) {
	                    c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 24 >> 2] = c[u >> 2];
	                    c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 28 >> 2] = c[v >> 2]
	                }
	                c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[c[n >> 2] >> 2] | 0) * 40 | 0) + 32 >> 2] = 0;
	                v = c[n >> 2] | 0;
	                n = c[v >> 2] | 0;
	                c[v >> 2] = n + 1;
	                c[m >> 2] = n;
	                x = c[m >> 2] | 0;
	                i = l;
	                return x | 0
	            }

	            function eu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    it(c[g >> 2] | 0, 129952);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 48 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                b = Cb[c[135744 >> 2] & 511](40) | 0;
	                c[(c[h >> 2] | 0) + 28 >> 2] = b;
	                if (!(c[(c[h >> 2] | 0) + 28 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    it(c[g >> 2] | 0, 129952);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[(c[h >> 2] | 0) + 20 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 24 >> 2] = 10;
	                    c[(c[h >> 2] | 0) + 16 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                    c[(c[h >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function fu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    it(0, c[f >> 2] | 0);
	                    i = d;
	                    return
	                } else {
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 15;
	                    it(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[f >> 2] | 0);
	                    i = d;
	                    return
	                }
	            }

	            function gu(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 56 | 0;
	                h = f + 52 | 0;
	                j = f + 48 | 0;
	                k = f + 44 | 0;
	                l = f + 40 | 0;
	                m = f + 36 | 0;
	                n = f + 32 | 0;
	                o = f + 28 | 0;
	                p = f + 24 | 0;
	                q = f + 20 | 0;
	                r = f + 16 | 0;
	                s = f + 12 | 0;
	                t = f + 8 | 0;
	                u = f + 4 | 0;
	                v = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[m >> 2] = QQ(c[j >> 2] | 0) | 0;
	                if ((c[m >> 2] | 0) == -1) {
	                    c[g >> 2] = -1;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                if ((c[m >> 2] | 0) == -2)c[m >> 2] = 1e4;
	                c[n >> 2] = RQ(c[j >> 2] | 0) | 0;
	                if ((c[n >> 2] | 0) == -1) {
	                    c[g >> 2] = -1;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[o >> 2] = SQ(c[j >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) < 0) {
	                    c[g >> 2] = -1;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        w = c[g >> 2] | 0;
	                        i = f;
	                        return w | 0
	                    }
	                    e = yt(c[h >> 2] | 0, 0) | 0;
	                    c[c[k >> 2] >> 2] = e;
	                    if (!(c[c[k >> 2] >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        w = c[g >> 2] | 0;
	                        i = f;
	                        return w | 0
	                    }
	                }
	                do if (!(c[n >> 2] | 0)) {
	                    e = (c[l >> 2] | 0) != 0;
	                    if (c[o >> 2] | 0) {
	                        if (!e) {
	                            dr(c[(c[c[k >> 2] >> 2] | 0) + 4 >> 2] | 0, c[c[h >> 2] >> 2] | 0) | 0;
	                            break
	                        }
	                        c[g >> 2] = 1;
	                        w = c[g >> 2] | 0;
	                        i = f;
	                        return w | 0
	                    } else {
	                        if (!e) {
	                            dr(c[(c[c[k >> 2] >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            break
	                        }
	                        c[g >> 2] = 1;
	                        w = c[g >> 2] | 0;
	                        i = f;
	                        return w | 0
	                    }
	                } while (0);
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                n = c[h >> 2] | 0;
	                if (!(c[o >> 2] | 0)) {
	                    if (c[n + 4 >> 2] | 0) {
	                        switch (c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0) {
	                            case 21:
	                            case 13:
	                            case 11:
	                            case 9:
	                            case 1:
	                            {
	                                c[s >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                                break
	                            }
	                            default:
	                            {
	                            }
	                        }
	                        c[t >> 2] = c[s >> 2]
	                    }
	                } else c[s >> 2] = c[n >> 2];
	                if (!(c[s >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[u >> 2] = OQ(c[j >> 2] | 0) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[r >> 2] = LQ(c[u >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) != 0 ? (c[p >> 2] = HQ(c[u >> 2] | 0, 0, 0) | 0, (c[p >> 2] | 0) >= 0 & (c[p >> 2] | 0) == 1) : 0) {
	                    if (!(c[l >> 2] | 0)) {
	                        dr(c[(c[c[k >> 2] >> 2] | 0) + 4 >> 2] | 0, c[s >> 2] | 0) | 0;
	                        x = 40
	                    }
	                } else x = 40;
	                a:do if ((x | 0) == 40) {
	                    c[q >> 2] = 0;
	                    b:while (1) {
	                        if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 18)break;
	                        if ((((c[(c[s >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[q >> 2] | 0) < (c[m >> 2] | 0) : 0) ? (c[(c[(c[s >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) ? (c[s >> 2] = c[(c[s >> 2] | 0) + 12 >> 2], c[q >> 2] = (c[q >> 2] | 0) + 1, (c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 14) : 0)x = 80; else x = 63;
	                        c:do if ((x | 0) == 63) {
	                            x = 0;
	                            if ((c[s >> 2] | 0) == (c[t >> 2] | 0))break b;
	                            while (1) {
	                                if (!(c[(c[s >> 2] | 0) + 24 >> 2] | 0))break;
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2];
	                                if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 17)continue;
	                                if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 14)break c
	                            }
	                            while (1) {
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 20 >> 2];
	                                c[q >> 2] = (c[q >> 2] | 0) + -1;
	                                if (!(c[s >> 2] | 0))break b;
	                                if ((c[s >> 2] | 0) == (c[t >> 2] | 0))break b;
	                                d:do if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 1)c[p >> 2] = KQ(c[u >> 2] | 0) | 0; else {
	                                    if (!(c[r >> 2] | 0))break;
	                                    do if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 3) {
	                                        if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 4)break;
	                                        if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 8)break;
	                                        if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 7)break d
	                                    } while (0);
	                                    c[p >> 2] = KQ(c[u >> 2] | 0) | 0
	                                } while (0);
	                                y = c[s >> 2] | 0;
	                                if (c[(c[s >> 2] | 0) + 24 >> 2] | 0)break;
	                                if (!y) {
	                                    x = 80;
	                                    break c
	                                }
	                            }
	                            c[s >> 2] = c[y + 24 >> 2];
	                            x = 80
	                        } while (0);
	                        if ((x | 0) == 80 ? (x = 0, !((c[s >> 2] | 0) != 0 & (c[q >> 2] | 0) >= 0)) : 0)break;
	                        e:while (1) {
	                            c[v >> 2] = (c[v >> 2] | 0) + 1;
	                            switch (c[(c[s >> 2] | 0) + 4 >> 2] | 0) {
	                                case 7:
	                                case 8:
	                                case 4:
	                                case 3:
	                                case 1:
	                                    break;
	                                default:
	                                    continue b
	                            }
	                            if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                if (c[(c[s >> 2] | 0) + 36 >> 2] | 0)z = c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0; else z = 0;
	                                c[p >> 2] = HQ(c[u >> 2] | 0, c[(c[s >> 2] | 0) + 8 >> 2] | 0, z) | 0
	                            } else {
	                                if (!(c[r >> 2] | 0))continue b;
	                                c[p >> 2] = IQ(c[u >> 2] | 0, 0, 0, c[(c[s >> 2] | 0) + 4 >> 2] | 0) | 0
	                            }
	                            do if ((c[p >> 2] | 0) >= 0 & (c[p >> 2] | 0) == 1) {
	                                if (c[l >> 2] | 0)break a;
	                                if ((dr(c[(c[c[k >> 2] >> 2] | 0) + 4 >> 2] | 0, c[s >> 2] | 0) | 0) >= 0)break;
	                                c[(c[h >> 2] | 0) + 136 >> 2] = 12;
	                                c[(c[h >> 2] | 0) + 140 >> 2] = 2
	                            } while (0);
	                            if ((c[(c[s >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[q >> 2] | 0) < (c[m >> 2] | 0) : 0)continue b;
	                            c[p >> 2] = KQ(c[u >> 2] | 0) | 0;
	                            while (1) {
	                                if (!(c[(c[s >> 2] | 0) + 24 >> 2] | 0))continue b;
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2];
	                                if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 17)continue;
	                                if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 14)continue e
	                            }
	                        }
	                    }
	                    if (c[u >> 2] | 0)GQ(c[u >> 2] | 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                } while (0);
	                if (c[u >> 2] | 0)GQ(c[u >> 2] | 0);
	                c[g >> 2] = 1;
	                w = c[g >> 2] | 0;
	                i = f;
	                return w | 0
	            }

	            function hu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                while (1) {
	                    d = c[c[h >> 2] >> 2] | 0;
	                    if (!d) {
	                        m = 3;
	                        break
	                    } else if ((d | 0) == 11) {
	                        m = 10;
	                        break
	                    } else if ((d | 0) == 12) {
	                        m = 4;
	                        break
	                    } else if ((d | 0) != 18) {
	                        m = 18;
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == -1) {
	                        m = 9;
	                        break
	                    }
	                    c[h >> 2] = (c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0)
	                }
	                do if ((m | 0) == 3)c[f >> 2] = 0; else if ((m | 0) == 4) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = Ns(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[f >> 2] = Vq(c[k >> 2] | 0) | 0;
	                        break
	                    }
	                } else if ((m | 0) == 9)c[f >> 2] = 0; else if ((m | 0) == 10) {
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == -1) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    iu(c[g >> 2] | 0, (c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                    nu(c[g >> 2] | 0, c[h >> 2] | 0, 0, 0, 1) | 0;
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                    c[k >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0))c[f >> 2] = -1; else m = 22
	                } else if ((m | 0) == 18) {
	                    iu(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                    c[k >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0))c[f >> 2] = -1; else m = 22
	                } while (0);
	                do if ((m | 0) == 22) {
	                    if (!(c[k >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    do if ((c[c[k >> 2] >> 2] | 0) != 2)if (c[j >> 2] | 0) {
	                        c[l >> 2] = Ns(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[l >> 2] = Vq(c[k >> 2] | 0) | 0;
	                        break
	                    } else c[l >> 2] = c[(c[k >> 2] | 0) + 8 >> 2]; while (0);
	                    jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0);
	                    c[f >> 2] = c[l >> 2]
	                } while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function iu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0;
	                d = i;
	                i = i + 192 | 0;
	                e = d;
	                f = d + 184 | 0;
	                g = d + 180 | 0;
	                j = d + 176 | 0;
	                k = d + 172 | 0;
	                l = d + 168 | 0;
	                m = d + 164 | 0;
	                n = d + 160 | 0;
	                o = d + 156 | 0;
	                p = d + 152 | 0;
	                q = d + 148 | 0;
	                r = d + 144 | 0;
	                s = d + 140 | 0;
	                t = d + 136 | 0;
	                u = d + 132 | 0;
	                v = d + 128 | 0;
	                w = d + 124 | 0;
	                x = d + 120 | 0;
	                y = d + 116 | 0;
	                z = d + 112 | 0;
	                A = d + 108 | 0;
	                B = d + 104 | 0;
	                C = d + 100 | 0;
	                D = d + 96 | 0;
	                E = d + 92 | 0;
	                F = d + 88 | 0;
	                G = d + 84 | 0;
	                H = d + 80 | 0;
	                I = d + 76 | 0;
	                J = d + 72 | 0;
	                K = d + 68 | 0;
	                L = d + 64 | 0;
	                M = d + 60 | 0;
	                N = d + 56 | 0;
	                O = d + 52 | 0;
	                P = d + 48 | 0;
	                Q = d + 44 | 0;
	                R = d + 40 | 0;
	                S = d + 36 | 0;
	                T = d + 32 | 0;
	                U = d + 28 | 0;
	                V = d + 24 | 0;
	                W = d + 20 | 0;
	                X = d + 16 | 0;
	                Y = d + 12 | 0;
	                Z = d + 8 | 0;
	                c[g >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    _ = c[f >> 2] | 0;
	                    i = d;
	                    return _ | 0
	                }
	                c[n >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                do switch (c[c[j >> 2] >> 2] | 0) {
	                    case 0:
	                    {
	                        c[f >> 2] = 0;
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 8:
	                    {
	                        ks(c[g >> 2] | 0);
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 10:
	                    {
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } else {
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        break
	                    }
	                    case 9:
	                    {
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } else {
	                            b = c[g >> 2] | 0;
	                            Tq(b, yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        break
	                    }
	                    case 11:
	                    {
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == -1) {
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } else {
	                            b = nu(c[g >> 2] | 0, c[j >> 2] | 0, 0, 0, 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b;
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        break
	                    }
	                    case 7:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                            c[p >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                                c[o >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                if (c[(c[o >> 2] | 0) + 4 >> 2] | 0) {
	                                    if ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[p >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0)$ = 78
	                                } else $ = 78;
	                                if (($ | 0) == 78) {
	                                    b = er(c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[(c[p >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                    c[(c[o >> 2] | 0) + 4 >> 2] = b
	                                }
	                                Tq(c[g >> 2] | 0, c[o >> 2] | 0) | 0;
	                                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[p >> 2] | 0);
	                                c[f >> 2] = c[k >> 2];
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                            Nq(c[g >> 2] | 0, 11);
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        Nq(c[g >> 2] | 0, 11);
	                        c[f >> 2] = 0;
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 5:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        do if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                            if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 1) {
	                                Vr(c[g >> 2] | 0);
	                                break
	                            }
	                            if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                                Ur(c[g >> 2] | 0);
	                                break
	                            }
	                            if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 3) {
	                                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 : 0)Tr(c[g >> 2] | 0, 1);
	                                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0)break;
	                                Nq(c[g >> 2] | 0, 11);
	                                c[f >> 2] = 0;
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                        } else Wr(c[g >> 2] | 0); while (0);
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 1:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        Bs(c[g >> 2] | 0, 1);
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                            c[p >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b;
	                            if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                Qq(c[p >> 2] | 0);
	                                c[f >> 2] = 0;
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            } else {
	                                Bs(c[g >> 2] | 0, 1);
	                                c[o >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                b = (c[o >> 2] | 0) + 8 | 0;
	                                c[b >> 2] = c[b >> 2] & c[(c[p >> 2] | 0) + 8 >> 2];
	                                Tq(c[g >> 2] | 0, c[o >> 2] | 0) | 0;
	                                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[p >> 2] | 0);
	                                c[f >> 2] = c[k >> 2];
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                        }
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 2:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        Bs(c[g >> 2] | 0, 1);
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) != 1 : 0) {
	                            c[p >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b;
	                            if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                Qq(c[p >> 2] | 0);
	                                c[f >> 2] = 0;
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            } else {
	                                Bs(c[g >> 2] | 0, 1);
	                                c[o >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                b = (c[o >> 2] | 0) + 8 | 0;
	                                c[b >> 2] = c[b >> 2] | c[(c[p >> 2] | 0) + 8 >> 2];
	                                Tq(c[g >> 2] | 0, c[o >> 2] | 0) | 0;
	                                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[p >> 2] | 0);
	                                c[f >> 2] = c[k >> 2];
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                        }
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 4:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } else {
	                            c[m >> 2] = Sr(c[g >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[(c[j >> 2] | 0) + 16 >> 2] | 0) | 0;
	                            b = c[g >> 2] | 0;
	                            Tq(b, Ft(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0) | 0) | 0;
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        break
	                    }
	                    case 12:
	                    {
	                        Tq(c[g >> 2] | 0, lt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0) | 0;
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 13:
	                    {
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + b
	                        }
	                        b = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                        a = c[j >> 2] | 0;
	                        do if (!(c[(c[j >> 2] | 0) + 28 >> 2] | 0)) {
	                            c[u >> 2] = or(b, c[a + 24 >> 2] | 0) | 0;
	                            aa = c[g >> 2] | 0;
	                            if (c[u >> 2] | 0) {
	                                Tq(aa, c[u >> 2] | 0) | 0;
	                                break
	                            }
	                            c[aa + 8 >> 2] = 5;
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } else {
	                            c[v >> 2] = sr(b, c[a + 28 >> 2] | 0) | 0;
	                            if (!(c[v >> 2] | 0)) {
	                                aa = c[33976] | 0;
	                                ba = c[33980] | 0;
	                                ca = c[(c[j >> 2] | 0) + 28 >> 2] | 0;
	                                c[e >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                                c[e + 4 >> 2] = ca;
	                                Db[aa & 511](ba, 130032, e);
	                                c[(c[g >> 2] | 0) + 8 >> 2] = 19;
	                                c[f >> 2] = c[k >> 2];
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                            c[u >> 2] = pr(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[v >> 2] | 0) | 0;
	                            ba = c[g >> 2] | 0;
	                            if (c[u >> 2] | 0) {
	                                Tq(ba, c[u >> 2] | 0) | 0;
	                                break
	                            }
	                            c[ba + 8 >> 2] = 5;
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } while (0);
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 14:
	                    {
	                        c[A >> 2] = ou(c[g >> 2] | 0) | 0;
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1 ? (a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0, c[k >> 2] = (c[k >> 2] | 0) + a, (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                            pu(c[g >> 2] | 0, c[A >> 2] | 0);
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) < ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) + (c[(c[j >> 2] | 0) + 12 >> 2] | 0) | 0)) {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 130096, e);
	                            c[(c[g >> 2] | 0) + 8 >> 2] = 10;
	                            pu(c[g >> 2] | 0, c[A >> 2] | 0);
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[z >> 2] = 0;
	                        while (1) {
	                            if ((c[z >> 2] | 0) >= (c[(c[j >> 2] | 0) + 12 >> 2] | 0))break;
	                            if (!(c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) - 1 - (c[z >> 2] | 0) << 2) >> 2] | 0)) {
	                                $ = 125;
	                                break
	                            }
	                            c[z >> 2] = (c[z >> 2] | 0) + 1
	                        }
	                        if (($ | 0) == 125) {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 130096, e);
	                            c[(c[g >> 2] | 0) + 8 >> 2] = 10;
	                            pu(c[g >> 2] | 0, c[A >> 2] | 0);
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        do if (c[(c[j >> 2] | 0) + 32 >> 2] | 0)c[w >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]; else {
	                            c[B >> 2] = 0;
	                            a = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                            b = c[j >> 2] | 0;
	                            do if (!(c[(c[j >> 2] | 0) + 28 >> 2] | 0))c[w >> 2] = lr(a, c[b + 24 >> 2] | 0) | 0; else {
	                                c[B >> 2] = sr(a, c[b + 28 >> 2] | 0) | 0;
	                                if (c[B >> 2] | 0) {
	                                    c[w >> 2] = mr(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[B >> 2] | 0) | 0;
	                                    break
	                                }
	                                ba = c[33976] | 0;
	                                aa = c[33980] | 0;
	                                ca = c[(c[j >> 2] | 0) + 28 >> 2] | 0;
	                                c[e >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                                c[e + 4 >> 2] = ca;
	                                Db[ba & 511](aa, 130136, e);
	                                pu(c[g >> 2] | 0, c[A >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 8 >> 2] = 19;
	                                c[f >> 2] = c[k >> 2];
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            } while (0);
	                            if (c[w >> 2] | 0) {
	                                c[(c[j >> 2] | 0) + 32 >> 2] = c[w >> 2];
	                                c[(c[j >> 2] | 0) + 36 >> 2] = c[B >> 2];
	                                break
	                            }
	                            b = c[33976] | 0;
	                            a = c[33980] | 0;
	                            c[e >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                            Db[b & 511](a, 130200, e);
	                            Nq(c[g >> 2] | 0, 9);
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } while (0);
	                        c[x >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 104 >> 2];
	                        c[y >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 108 >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 104 >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 108 >> 2] = c[(c[j >> 2] | 0) + 36 >> 2];
	                        Ab[c[w >> 2] & 511](c[g >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0);
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 104 >> 2] = c[x >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 108 >> 2] = c[y >> 2];
	                        pu(c[g >> 2] | 0, c[A >> 2] | 0);
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 18:
	                    {
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + a
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1 : 0)Zq(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0);
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 19:
	                    {
	                        c[U >> 2] = 0;
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + a
	                        }
	                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        a = (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0;
	                        a:do if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 7) {
	                            if (!a ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 7 : 0) {
	                                c[S >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                c[V >> 2] = c[(c[S >> 2] | 0) + 28 >> 2];
	                                if ((c[V >> 2] | 0) != 0 ? (c[c[V >> 2] >> 2] | 0) != 0 : 0) {
	                                    c[U >> 2] = bv(0) | 0;
	                                    c[X >> 2] = 0;
	                                    while (1) {
	                                        if ((c[X >> 2] | 0) >= (c[c[V >> 2] >> 2] | 0))break a;
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[(c[V >> 2] | 0) + 8 >> 2] | 0) + (c[X >> 2] << 2) >> 2] | 0) + 28 >> 2];
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[c[V >> 2] >> 2];
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = (c[X >> 2] | 0) + 1;
	                                        c[T >> 2] = yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                        Tq(c[g >> 2] | 0, c[T >> 2] | 0) | 0;
	                                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                            b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                            c[k >> 2] = (c[k >> 2] | 0) + b
	                                        }
	                                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)break;
	                                        c[R >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                        b:do if ((c[c[R >> 2] >> 2] | 0) != 7) {
	                                            c[Q >> 2] = av(c[(c[(c[(c[V >> 2] | 0) + 8 >> 2] | 0) + (c[X >> 2] << 2) >> 2] | 0) + 28 >> 2] | 0, c[R >> 2] | 0) | 0;
	                                            if (c[Q >> 2] | 0)cv(c[U >> 2] | 0, c[Q >> 2] | 0)
	                                        } else {
	                                            c[Z >> 2] = c[(c[R >> 2] | 0) + 28 >> 2];
	                                            c[Y >> 2] = 0;
	                                            while (1) {
	                                                if ((c[Y >> 2] | 0) >= (c[c[Z >> 2] >> 2] | 0))break b;
	                                                c[Q >> 2] = Zu(c[(c[(c[(c[V >> 2] | 0) + 8 >> 2] | 0) + (c[X >> 2] << 2) >> 2] | 0) + 28 >> 2] | 0, c[(c[(c[(c[V >> 2] | 0) + 8 >> 2] | 0) + (c[X >> 2] << 2) >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[(c[Z >> 2] | 0) + 8 >> 2] | 0) + (c[Y >> 2] << 2) >> 2] | 0) + 36 >> 2] | 0, c[(c[(c[(c[Z >> 2] | 0) + 8 >> 2] | 0) + (c[Y >> 2] << 2) >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                                if (c[Q >> 2] | 0)cv(c[U >> 2] | 0, c[Q >> 2] | 0);
	                                                c[Y >> 2] = (c[Y >> 2] | 0) + 1
	                                            }
	                                        } while (0);
	                                        if (c[R >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[R >> 2] | 0);
	                                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[T >> 2] | 0)) {
	                                            c[R >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                            jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[R >> 2] | 0)
	                                        }
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                        c[X >> 2] = (c[X >> 2] | 0) + 1
	                                    }
	                                    Qq(c[S >> 2] | 0);
	                                    c[f >> 2] = 0;
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                }
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = 0;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = 0;
	                                b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                c[k >> 2] = (c[k >> 2] | 0) + b;
	                                c[R >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                if (c[R >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[R >> 2] | 0);
	                                Tq(c[g >> 2] | 0, c[S >> 2] | 0) | 0;
	                                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                    c[f >> 2] = 0;
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                } else {
	                                    c[f >> 2] = c[k >> 2];
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                }
	                            }
	                            Nq(c[g >> 2] | 0, 11);
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } else {
	                            if (!a ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                                c[S >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                c[W >> 2] = c[(c[S >> 2] | 0) + 4 >> 2];
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                c[U >> 2] = bv(0) | 0;
	                                if (!(c[W >> 2] | 0))break;
	                                c[X >> 2] = 0;
	                                while (1) {
	                                    if ((c[X >> 2] | 0) >= (c[c[W >> 2] >> 2] | 0))break a;
	                                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[W >> 2] | 0) + 8 >> 2] | 0) + (c[X >> 2] << 2) >> 2];
	                                    c[T >> 2] = yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                    Tq(c[g >> 2] | 0, c[T >> 2] | 0) | 0;
	                                    if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                        b = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                        c[k >> 2] = (c[k >> 2] | 0) + b
	                                    }
	                                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)break;
	                                    c[R >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                    c[Q >> 2] = av(c[(c[(c[W >> 2] | 0) + 8 >> 2] | 0) + (c[X >> 2] << 2) >> 2] | 0, c[R >> 2] | 0) | 0;
	                                    if (c[Q >> 2] | 0)cv(c[U >> 2] | 0, c[Q >> 2] | 0);
	                                    if (c[R >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[R >> 2] | 0);
	                                    if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[T >> 2] | 0)) {
	                                        c[R >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                        jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[R >> 2] | 0)
	                                    }
	                                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                    c[X >> 2] = (c[X >> 2] | 0) + 1
	                                }
	                                Qq(c[S >> 2] | 0);
	                                c[f >> 2] = 0;
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                            Nq(c[g >> 2] | 0, 11);
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        } while (0);
	                        jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[S >> 2] | 0);
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = -1;
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = -1;
	                        a = c[g >> 2] | 0;
	                        Tq(a, hv(c[U >> 2] | 0) | 0) | 0;
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 15:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1 ? (a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0, c[k >> 2] = (c[k >> 2] | 0) + a, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2], c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2], c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2], c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2], (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1 ? (a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0, c[k >> 2] = (c[k >> 2] | 0) + a, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2], c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2], c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2], c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2], (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 17:
	                    case 16:
	                    {
	                        c[F >> 2] = 0;
	                        do if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1 : 0) {
	                            if ((c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) >> 2] | 0) != 18 ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) >> 2] | 0) != 17 : 0)break;
	                            if ((((c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) >> 2] | 0) == 12 ? (c[K >> 2] = c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) + 24 >> 2], (c[K >> 2] | 0) != 0) : 0) ? (c[c[K >> 2] >> 2] | 0) == 3 : 0) ? +h[(c[K >> 2] | 0) + 16 >> 3] == 1.0 : 0) {
	                                c[L >> 2] = 0;
	                                a = qu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, L) | 0;
	                                c[k >> 2] = (c[k >> 2] | 0) + a;
	                                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                    c[f >> 2] = 0;
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                }
	                                if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1 : 0)c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] = 1;
	                                c[f >> 2] = c[k >> 2];
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                        } while (0);
	                        if ((((((((((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) >> 2] | 0) == 18 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) >> 2] | 0) == 18 : 0) ? (c[M >> 2] = c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) + 4 >> 2], (c[M >> 2] | 0) != -1) : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[M >> 2] | 0) * 40 | 0) >> 2] | 0) == 14 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[M >> 2] | 0) * 40 | 0) + 28 >> 2] | 0) == 0 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[M >> 2] | 0) * 40 | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[M >> 2] | 0) * 40 | 0) + 24 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[M >> 2] | 0) * 40 | 0) + 24 >> 2] | 0, 129656) | 0) != 0 : 0) {
	                            c[N >> 2] = 0;
	                            a = ru(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, N) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + a;
	                            if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                c[f >> 2] = 0;
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                            do if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                if ((c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) <= 1)break;
	                                c[c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + ((c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) - 1 << 2) >> 2];
	                                c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] = 1
	                            } while (0);
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + a
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0)) {
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[H >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 7) {
	                            c[O >> 2] = 0;
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 7 : 0) {
	                                c[D >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                c[P >> 2] = c[(c[D >> 2] | 0) + 28 >> 2];
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                if ((c[P >> 2] | 0) != 0 ? (c[c[P >> 2] >> 2] | 0) != 0 : 0) {
	                                    c[O >> 2] = bv(0) | 0;
	                                    c[J >> 2] = 0;
	                                    while (1) {
	                                        if ((c[J >> 2] | 0) >= (c[c[P >> 2] >> 2] | 0)) {
	                                            $ = 214;
	                                            break
	                                        }
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[(c[P >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2] | 0) + 28 >> 2];
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[c[P >> 2] >> 2];
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = (c[J >> 2] | 0) + 1;
	                                        c[E >> 2] = yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                        Tq(c[g >> 2] | 0, c[E >> 2] | 0) | 0;
	                                        if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                            a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                            c[k >> 2] = (c[k >> 2] | 0) + a
	                                        }
	                                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                            $ = 206;
	                                            break
	                                        }
	                                        c[C >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                        if (Ns(c[g >> 2] | 0, c[C >> 2] | 0) | 0) {
	                                            a = c[O >> 2] | 0;
	                                            cv(a, zr(c[(c[(c[P >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2] | 0) | 0)
	                                        }
	                                        if (c[C >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[C >> 2] | 0);
	                                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[E >> 2] | 0)) {
	                                            c[C >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                            jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[C >> 2] | 0)
	                                        }
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                        c[J >> 2] = (c[J >> 2] | 0) + 1
	                                    }
	                                    if (($ | 0) == 206) {
	                                        Qq(c[D >> 2] | 0);
	                                        c[f >> 2] = 0;
	                                        _ = c[f >> 2] | 0;
	                                        i = d;
	                                        return _ | 0
	                                    } else if (($ | 0) == 214) {
	                                        jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[D >> 2] | 0);
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = -1;
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = -1;
	                                        a = c[g >> 2] | 0;
	                                        Tq(a, hv(c[O >> 2] | 0) | 0) | 0;
	                                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[H >> 2];
	                                        c[f >> 2] = c[k >> 2];
	                                        _ = c[f >> 2] | 0;
	                                        i = d;
	                                        return _ | 0
	                                    }
	                                }
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = 0;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = 0;
	                                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                    a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                    c[k >> 2] = (c[k >> 2] | 0) + a
	                                }
	                                c[C >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                if (c[C >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[C >> 2] | 0);
	                                Tq(c[g >> 2] | 0, c[D >> 2] | 0) | 0;
	                                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                    c[f >> 2] = 0;
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                } else {
	                                    c[f >> 2] = c[k >> 2];
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                }
	                            }
	                            Nq(c[g >> 2] | 0, 11);
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                            c[D >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            c[G >> 2] = c[(c[D >> 2] | 0) + 4 >> 2];
	                            c[H >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                            c[I >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            if ((c[G >> 2] | 0) != 0 ? (c[c[G >> 2] >> 2] | 0) != 0 : 0) {
	                                c[E >> 2] = 0;
	                                c[F >> 2] = $q(0) | 0;
	                                c[J >> 2] = 0;
	                                while (1) {
	                                    if ((c[J >> 2] | 0) >= (c[c[G >> 2] >> 2] | 0))break;
	                                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[G >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2];
	                                    if ((c[(c[(c[(c[G >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) != 18 ? (c[(c[(c[(c[G >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[(c[(c[(c[G >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2] | 0) + 32 >> 2];
	                                    do if (!(c[E >> 2] | 0))c[E >> 2] = yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0; else {
	                                        if ((dr(c[(c[E >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) >= 0)break;
	                                        c[(c[g >> 2] | 0) + 8 >> 2] = 15
	                                    } while (0);
	                                    Tq(c[g >> 2] | 0, c[E >> 2] | 0) | 0;
	                                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[c[G >> 2] >> 2];
	                                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = (c[J >> 2] | 0) + 1;
	                                    if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                        a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                        c[k >> 2] = (c[k >> 2] | 0) + a
	                                    }
	                                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                        $ = 234;
	                                        break
	                                    }
	                                    c[C >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                    do if (Ns(c[g >> 2] | 0, c[C >> 2] | 0) | 0) {
	                                        if ((cr(c[F >> 2] | 0, c[(c[(c[G >> 2] | 0) + 8 >> 2] | 0) + (c[J >> 2] << 2) >> 2] | 0) | 0) >= 0)break;
	                                        c[(c[g >> 2] | 0) + 8 >> 2] = 15
	                                    } while (0);
	                                    if (c[C >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[C >> 2] | 0);
	                                    if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[E >> 2] | 0)) {
	                                        Sq(c[g >> 2] | 0) | 0;
	                                        su(c[(c[E >> 2] | 0) + 4 >> 2] | 0, 1)
	                                    } else c[E >> 2] = 0;
	                                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                    c[J >> 2] = (c[J >> 2] | 0) + 1
	                                }
	                                if (($ | 0) == 234) {
	                                    fr(c[F >> 2] | 0);
	                                    Qq(c[D >> 2] | 0);
	                                    c[f >> 2] = 0;
	                                    _ = c[f >> 2] | 0;
	                                    i = d;
	                                    return _ | 0
	                                }
	                                if (c[E >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[E >> 2] | 0);
	                                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[D >> 2] | 0);
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = -1;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = -1;
	                                c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[I >> 2];
	                                a = c[g >> 2] | 0;
	                                Tq(a, At(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[F >> 2] | 0) | 0) | 0
	                            } else $ = 220;
	                            if (($ | 0) == 220 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = 0, Tq(c[g >> 2] | 0, c[D >> 2] | 0) | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[H >> 2], (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                                c[f >> 2] = 0;
	                                _ = c[f >> 2] | 0;
	                                i = d;
	                                return _ | 0
	                            }
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[H >> 2];
	                            c[f >> 2] = c[k >> 2];
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        Nq(c[g >> 2] | 0, 11);
	                        c[f >> 2] = 0;
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 3:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + a;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                        a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + a;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        a = c[g >> 2] | 0;
	                        if (c[(c[j >> 2] | 0) + 12 >> 2] | 0)c[l >> 2] = Qr(a) | 0; else c[l >> 2] = Rr(a) | 0;
	                        a = c[g >> 2] | 0;
	                        Tq(a, Ft(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0) | 0) | 0;
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    case 6:
	                    {
	                        c[r >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[q >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[t >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + a;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[r >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[s >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[t >> 2];
	                        a = iu(c[g >> 2] | 0, (c[(c[n >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + a;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            _ = c[f >> 2] | 0;
	                            i = d;
	                            return _ | 0
	                        }
	                        do if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                            if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 1) {
	                                Yr(c[g >> 2] | 0);
	                                break
	                            }
	                            if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 2)Zr(c[g >> 2] | 0)
	                        } else Xr(c[g >> 2] | 0); while (0);
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                    default:
	                    {
	                        a = c[33976] | 0;
	                        b = c[33980] | 0;
	                        c[e >> 2] = c[c[j >> 2] >> 2];
	                        Db[a & 511](b, 130248, e);
	                        c[(c[g >> 2] | 0) + 8 >> 2] = 10;
	                        c[f >> 2] = c[k >> 2];
	                        _ = c[f >> 2] | 0;
	                        i = d;
	                        return _ | 0
	                    }
	                } while (0);
	                return 0
	            }

	            function ju(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 52 | 0;
	                f = d + 48 | 0;
	                g = d + 44 | 0;
	                h = d + 40 | 0;
	                j = d + 36 | 0;
	                k = d + 32 | 0;
	                l = d + 28 | 0;
	                m = d + 24 | 0;
	                n = d + 20 | 0;
	                o = d + 16 | 0;
	                p = d + 12 | 0;
	                q = d + 8 | 0;
	                r = d + 4 | 0;
	                s = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -2;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                a:do switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    case 2:
	                    {
	                        c[l >> 2] = 1;
	                        c[n >> 2] = c[f >> 2];
	                        c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                        c[k >> 2] = 1;
	                        u = 27;
	                        break
	                    }
	                    case 7:
	                    case 8:
	                    case 4:
	                    case 3:
	                    {
	                        c[n >> 2] = c[f >> 2];
	                        do if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                            while (1) {
	                                c[f >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                    u = 17;
	                                    break
	                                }
	                                if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                                    u = 19;
	                                    break
	                                }
	                            }
	                            if ((u | 0) == 17) {
	                                c[l >> 2] = 3;
	                                break
	                            } else if ((u | 0) == 19) {
	                                c[l >> 2] = 2;
	                                c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                                break
	                            }
	                        } else {
	                            c[l >> 2] = 2;
	                            c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2]
	                        } while (0);
	                        if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? 0 > (c[(c[f >> 2] | 0) + 40 >> 2] | 0) : 0) {
	                            c[k >> 2] = 1;
	                            u = 27;
	                            break a
	                        }
	                        c[f >> 2] = c[n >> 2];
	                        c[l >> 2] = 0;
	                        u = 27;
	                        break
	                    }
	                    case 18:
	                    {
	                        c[e >> 2] = 1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    case 1:
	                    {
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            if ((0 > (c[(c[f >> 2] | 0) + 40 >> 2] | 0) ? 0 > (c[(c[g >> 2] | 0) + 40 >> 2] | 0) : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == (c[(c[g >> 2] | 0) + 32 >> 2] | 0) : 0) {
	                                c[r >> 2] = 0 - (c[(c[f >> 2] | 0) + 40 >> 2] | 0);
	                                c[s >> 2] = 0 - (c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                                if ((c[r >> 2] | 0) < (c[s >> 2] | 0)) {
	                                    c[e >> 2] = 1;
	                                    t = c[e >> 2] | 0;
	                                    i = d;
	                                    return t | 0
	                                }
	                                if ((c[r >> 2] | 0) > (c[s >> 2] | 0)) {
	                                    c[e >> 2] = -1;
	                                    t = c[e >> 2] | 0;
	                                    i = d;
	                                    return t | 0
	                                } else u = 27
	                            }
	                        } else u = 27;
	                        break
	                    }
	                    default:
	                        u = 27
	                } while (0);
	                if ((u | 0) == 27) {
	                    b:do switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                        case 7:
	                        case 8:
	                        case 4:
	                        case 3:
	                        {
	                            c[o >> 2] = c[g >> 2];
	                            do if (c[(c[g >> 2] | 0) + 28 >> 2] | 0) {
	                                while (1) {
	                                    c[g >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                        u = 31;
	                                        break
	                                    }
	                                    if (!(c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                                        u = 33;
	                                        break
	                                    }
	                                }
	                                if ((u | 0) == 31) {
	                                    c[m >> 2] = 3;
	                                    break
	                                } else if ((u | 0) == 33) {
	                                    c[m >> 2] = 2;
	                                    c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                                    break
	                                }
	                            } else {
	                                c[m >> 2] = 2;
	                                c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2]
	                            } while (0);
	                            if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? 0 > (c[(c[g >> 2] | 0) + 40 >> 2] | 0) : 0) {
	                                c[k >> 2] = 1;
	                                break b
	                            }
	                            c[g >> 2] = c[o >> 2];
	                            c[m >> 2] = 0;
	                            break
	                        }
	                        case 2:
	                        {
	                            c[m >> 2] = 1;
	                            c[o >> 2] = c[g >> 2];
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            c[k >> 2] = 1;
	                            break
	                        }
	                        case 18:
	                        {
	                            c[e >> 2] = 1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    c:do if (c[k >> 2] | 0) {
	                        if ((c[f >> 2] | 0) != (c[g >> 2] | 0)) {
	                            d:do if ((c[m >> 2] | 0) == 3 & (c[l >> 2] | 0) > 1) {
	                                c[p >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                                while (1) {
	                                    if (!(c[p >> 2] | 0))break d;
	                                    if ((c[p >> 2] | 0) == (c[g >> 2] | 0))break;
	                                    c[p >> 2] = c[(c[p >> 2] | 0) + 20 >> 2]
	                                }
	                                c[e >> 2] = 1;
	                                t = c[e >> 2] | 0;
	                                i = d;
	                                return t | 0
	                            } while (0);
	                            if (!((c[l >> 2] | 0) == 3 & (c[m >> 2] | 0) > 1))break;
	                            c[p >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            while (1) {
	                                if (!(c[p >> 2] | 0))break c;
	                                if ((c[p >> 2] | 0) == (c[f >> 2] | 0))break;
	                                c[p >> 2] = c[(c[p >> 2] | 0) + 20 >> 2]
	                            }
	                            c[e >> 2] = -1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        }
	                        if ((c[l >> 2] | 0) != (c[m >> 2] | 0))if ((c[l >> 2] | 0) < (c[m >> 2] | 0)) {
	                            c[e >> 2] = 1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        } else {
	                            c[e >> 2] = -1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        }
	                        c[p >> 2] = c[(c[o >> 2] | 0) + 28 >> 2];
	                        while (1) {
	                            if (!(c[p >> 2] | 0)) {
	                                u = 51;
	                                break
	                            }
	                            if ((c[p >> 2] | 0) == (c[n >> 2] | 0)) {
	                                u = 47;
	                                break
	                            }
	                            if ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                u = 49;
	                                break
	                            }
	                            c[p >> 2] = c[(c[p >> 2] | 0) + 28 >> 2]
	                        }
	                        if ((u | 0) == 47) {
	                            c[e >> 2] = 1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        } else if ((u | 0) == 49) {
	                            c[e >> 2] = -1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        } else if ((u | 0) == 51) {
	                            c[e >> 2] = -1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        }
	                    } while (0);
	                    if (((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? 0 > (c[(c[f >> 2] | 0) + 40 >> 2] | 0) : 0) ? 0 > (c[(c[g >> 2] | 0) + 40 >> 2] | 0) : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == (c[(c[g >> 2] | 0) + 32 >> 2] | 0) : 0) {
	                        c[r >> 2] = 0 - (c[(c[f >> 2] | 0) + 40 >> 2] | 0);
	                        c[s >> 2] = 0 - (c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        if ((c[r >> 2] | 0) < (c[s >> 2] | 0)) {
	                            c[e >> 2] = 1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        }
	                        if ((c[r >> 2] | 0) > (c[s >> 2] | 0)) {
	                            c[e >> 2] = -1;
	                            t = c[e >> 2] | 0;
	                            i = d;
	                            return t | 0
	                        }
	                    }
	                }
	                if ((c[f >> 2] | 0) == (c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[f >> 2] | 0) == (c[(c[g >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                c[j >> 2] = 0;
	                c[p >> 2] = c[g >> 2];
	                while (1) {
	                    v = c[p >> 2] | 0;
	                    if (!(c[(c[p >> 2] | 0) + 20 >> 2] | 0))break;
	                    if ((v | 0) == (c[f >> 2] | 0)) {
	                        u = 83;
	                        break
	                    }
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 20 >> 2]
	                }
	                if ((u | 0) == 83) {
	                    c[e >> 2] = 1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                c[q >> 2] = v;
	                c[h >> 2] = 0;
	                c[p >> 2] = c[f >> 2];
	                while (1) {
	                    if (!(c[(c[p >> 2] | 0) + 20 >> 2] | 0))break;
	                    if ((c[p >> 2] | 0) == (c[g >> 2] | 0)) {
	                        u = 88;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 20 >> 2]
	                }
	                if ((u | 0) == 88) {
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[q >> 2] | 0) != (c[p >> 2] | 0)) {
	                    c[e >> 2] = -2;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                while (1) {
	                    if ((c[h >> 2] | 0) <= (c[j >> 2] | 0))break;
	                    c[h >> 2] = (c[h >> 2] | 0) + -1;
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2]
	                }
	                while (1) {
	                    if ((c[j >> 2] | 0) <= (c[h >> 2] | 0))break;
	                    c[j >> 2] = (c[j >> 2] | 0) + -1;
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2]
	                }
	                while (1) {
	                    w = c[f >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) == (c[(c[g >> 2] | 0) + 20 >> 2] | 0))break;
	                    c[f >> 2] = c[w + 20 >> 2];
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                    if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                        u = 98;
	                        break
	                    }
	                }
	                if ((u | 0) == 98) {
	                    c[e >> 2] = -2;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((w | 0) == (c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[f >> 2] | 0) == (c[(c[g >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if (((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? 0 > (c[(c[f >> 2] | 0) + 40 >> 2] | 0) : 0) ? 0 > (c[(c[g >> 2] | 0) + 40 >> 2] | 0) : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == (c[(c[g >> 2] | 0) + 32 >> 2] | 0) : 0) {
	                    c[r >> 2] = 0 - (c[(c[f >> 2] | 0) + 40 >> 2] | 0);
	                    c[s >> 2] = 0 - (c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                    if ((c[r >> 2] | 0) < (c[s >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    if ((c[r >> 2] | 0) > (c[s >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                }
	                c[p >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[p >> 2] | 0)) {
	                        u = 117;
	                        break
	                    }
	                    if ((c[p >> 2] | 0) == (c[g >> 2] | 0)) {
	                        u = 115;
	                        break
	                    }
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                }
	                if ((u | 0) == 115) {
	                    c[e >> 2] = 1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                } else if ((u | 0) == 117) {
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                return 0
	            }

	            function ku(a, b) {
	                a = +a;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d;
	                g = d + 8 | 0;
	                h[f >> 3] = a;
	                c[g >> 2] = b;
	                b = St(+h[f >> 3]) | 0;
	                j = dU(b | 0, G | 0, 63) | 0;
	                c[c[g >> 2] >> 2] = j;
	                j = rT(+h[f >> 3]) | 0;
	                if ((j | 0) == 3)c[e >> 2] = 3; else if ((j | 0) == 2)c[e >> 2] = 4; else if (!j)c[e >> 2] = 1; else if ((j | 0) == 1)c[e >> 2] = 0; else c[e >> 2] = 2;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function lu(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function mu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                tu(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 61) {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 33) {
	                            h = 34;
	                            break
	                        }
	                        if ((d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 61) {
	                            h = 34;
	                            break
	                        }
	                    }
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 61)c[f >> 2] = 1; else c[f >> 2] = 0;
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    if ((c[f >> 2] | 0) == 0 ? (a = c[e >> 2] | 0, (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 0) : 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = c[e >> 2] | 0;
	                        if (!j)break;
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[k >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    tu(k);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        h = 34;
	                        break
	                    }
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 3, c[f >> 2] | 0, 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                if ((h | 0) == 34) {
	                    i = b;
	                    return
	                }
	            }

	            function nu(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0;
	                g = i;
	                i = i + 160 | 0;
	                h = g;
	                j = g + 148 | 0;
	                k = g + 144 | 0;
	                l = g + 140 | 0;
	                m = g + 136 | 0;
	                n = g + 132 | 0;
	                o = g + 128 | 0;
	                p = g + 124 | 0;
	                q = g + 120 | 0;
	                r = g + 116 | 0;
	                s = g + 112 | 0;
	                t = g + 108 | 0;
	                u = g + 104 | 0;
	                v = g + 100 | 0;
	                w = g + 96 | 0;
	                x = g + 92 | 0;
	                y = g + 88 | 0;
	                z = g + 84 | 0;
	                A = g + 80 | 0;
	                B = g + 76 | 0;
	                C = g + 72 | 0;
	                D = g + 68 | 0;
	                E = g + 64 | 0;
	                F = g + 60 | 0;
	                G = g + 56 | 0;
	                H = g + 52 | 0;
	                I = g + 48 | 0;
	                J = g + 44 | 0;
	                K = g + 40 | 0;
	                L = g + 36 | 0;
	                M = g + 32 | 0;
	                N = g + 28 | 0;
	                O = g + 24 | 0;
	                P = g + 20 | 0;
	                Q = g + 16 | 0;
	                R = g + 12 | 0;
	                S = g + 8 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                c[q >> 2] = c[(c[l >> 2] | 0) + 16 >> 2];
	                c[r >> 2] = c[(c[l >> 2] | 0) + 20 >> 2];
	                c[s >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                c[t >> 2] = c[(c[l >> 2] | 0) + 28 >> 2];
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[M >> 2] = 0;
	                c[Q >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[k >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                    c[x >> 2] = Sq(c[k >> 2] | 0) | 0;
	                    if ((c[s >> 2] | 0) != 0 ? (c[u >> 2] = sr(c[Q >> 2] | 0, c[s >> 2] | 0) | 0, (c[u >> 2] | 0) == 0) : 0) {
	                        jt(c[Q >> 2] | 0, c[x >> 2] | 0);
	                        Nq(c[k >> 2] | 0, 19);
	                        c[j >> 2] = 0;
	                        T = c[j >> 2] | 0;
	                        i = g;
	                        return T | 0
	                    }
	                    c[O >> 2] = 289;
	                    do switch (c[p >> 2] | 0) {
	                        case 9:
	                        {
	                            c[m >> 2] = 0;
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 300;
	                            c[O >> 2] = 293;
	                            break
	                        }
	                        case 3:
	                        {
	                            c[m >> 2] = 0;
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 292;
	                            c[O >> 2] = 293;
	                            break
	                        }
	                        case 7:
	                        {
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 298;
	                            break
	                        }
	                        case 11:
	                        {
	                            c[m >> 2] = 0;
	                            c[M >> 2] = 302;
	                            break
	                        }
	                        case 8:
	                        {
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 299;
	                            break
	                        }
	                        case 1:
	                        {
	                            c[m >> 2] = 0;
	                            c[M >> 2] = 290;
	                            break
	                        }
	                        case 12:
	                        {
	                            c[m >> 2] = 0;
	                            c[M >> 2] = 303;
	                            break
	                        }
	                        case 6:
	                        {
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 297;
	                            break
	                        }
	                        case 4:
	                        {
	                            c[n >> 2] = 0;
	                            if (((c[q >> 2] | 0) == 5 | (c[q >> 2] | 0) == 3) & (c[r >> 2] | 0) == 0)c[M >> 2] = 294; else c[M >> 2] = 295;
	                            c[O >> 2] = 293;
	                            break
	                        }
	                        case 13:
	                        {
	                            c[m >> 2] = 0;
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 304;
	                            c[O >> 2] = 293;
	                            break
	                        }
	                        case 2:
	                        {
	                            c[m >> 2] = 0;
	                            c[M >> 2] = 291;
	                            break
	                        }
	                        case 5:
	                        {
	                            c[n >> 2] = 0;
	                            c[M >> 2] = 296;
	                            break
	                        }
	                        case 10:
	                        {
	                            c[m >> 2] = 0;
	                            c[M >> 2] = 301;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    if (!(c[M >> 2] | 0)) {
	                        jt(c[Q >> 2] | 0, c[x >> 2] | 0);
	                        c[j >> 2] = 0;
	                        T = c[j >> 2] | 0;
	                        i = g;
	                        return T | 0
	                    }
	                    c[y >> 2] = c[(c[x >> 2] | 0) + 4 >> 2];
	                    if ((c[y >> 2] | 0) != 0 ? (c[c[y >> 2] >> 2] | 0) > 0 : 0) {
	                        c[F >> 2] = 0;
	                        c[E >> 2] = 0;
	                        c[G >> 2] = 0;
	                        c[H >> 2] = 0;
	                        do if ((c[(c[l >> 2] | 0) + 8 >> 2] | 0) != -1 ? (c[E >> 2] = (c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[l >> 2] | 0) + 8 >> 2] | 0) * 40 | 0), (yu(c[k >> 2] | 0, c[E >> 2] | 0, F) | 0) != 0) : 0)if ((c[(c[E >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            c[E >> 2] = (c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[E >> 2] | 0) + 4 >> 2] | 0) * 40 | 0);
	                            c[G >> 2] = 1;
	                            break
	                        } else {
	                            c[E >> 2] = 0;
	                            c[H >> 2] = 1;
	                            break
	                        } while (0);
	                        if (c[o >> 2] | 0)U = (c[E >> 2] | 0) == 0; else U = 0;
	                        c[L >> 2] = U ? 1 : 0;
	                        c[P >> 2] = c[(c[Q >> 2] | 0) + 4 >> 2];
	                        c[N >> 2] = 305;
	                        c[B >> 2] = 0;
	                        c[C >> 2] = 0;
	                        c[A >> 2] = 0;
	                        c[z >> 2] = 0;
	                        a:while (1) {
	                            if (!((c[A >> 2] | 0) != 0 ? 1 : (c[z >> 2] | 0) < (c[c[y >> 2] >> 2] | 0)))break;
	                            if (c[(c[k >> 2] | 0) + 8 >> 2] | 0)break;
	                            U = c[z >> 2] | 0;
	                            c[z >> 2] = U + 1;
	                            c[(c[Q >> 2] | 0) + 4 >> 2] = c[(c[(c[y >> 2] | 0) + 8 >> 2] | 0) + (U << 2) >> 2];
	                            if ((c[C >> 2] | 0) == 0 ? (c[C >> 2] = $q(0) | 0, (c[C >> 2] | 0) == 0) : 0) {
	                                V = 41;
	                                break
	                            }
	                            c[I >> 2] = 0;
	                            c[D >> 2] = 0;
	                            c[w >> 2] = 0;
	                            b:while (1) {
	                                c[D >> 2] = Hb[c[M >> 2] & 511](c[k >> 2] | 0, c[D >> 2] | 0) | 0;
	                                if (!(c[D >> 2] | 0)) {
	                                    V = 211;
	                                    break
	                                }
	                                do if ((c[m >> 2] | 0) != 0 ? (c[c[m >> 2] >> 2] | 0) != 0 : 0) {
	                                    if ((c[c[m >> 2] >> 2] | 0) == (c[D >> 2] | 0)) {
	                                        V = 211;
	                                        break b
	                                    }
	                                    if ((c[v >> 2] | 0) % 256 | 0)break;
	                                    if ((ju(c[c[m >> 2] >> 2] | 0, c[D >> 2] | 0) | 0) >= 0) {
	                                        V = 211;
	                                        break b
	                                    }
	                                } while (0);
	                                do if ((c[n >> 2] | 0) != 0 ? (c[c[n >> 2] >> 2] | 0) != 0 : 0) {
	                                    if ((c[c[n >> 2] >> 2] | 0) == (c[D >> 2] | 0)) {
	                                        V = 211;
	                                        break b
	                                    }
	                                    if ((c[v >> 2] | 0) % 256 | 0)break;
	                                    if ((ju(c[D >> 2] | 0, c[c[n >> 2] >> 2] | 0) | 0) >= 0) {
	                                        V = 211;
	                                        break b
	                                    }
	                                } while (0);
	                                c[v >> 2] = (c[v >> 2] | 0) + 1;
	                                c:do switch (c[q >> 2] | 0) {
	                                    case 5:
	                                    {
	                                        do if ((c[p >> 2] | 0) == 3) {
	                                            if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) != 2)break c
	                                        } else {
	                                            U = c[(c[D >> 2] | 0) + 4 >> 2] | 0;
	                                            if ((c[p >> 2] | 0) == 9)if ((U | 0) != 18)break c; else break; else if ((U | 0) != 1)break c; else break
	                                        } while (0);
	                                        U = c[(c[D >> 2] | 0) + 4 >> 2] | 0;
	                                        if ((U | 0) == 18) {
	                                            if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) != 18)break c;
	                                            c[S >> 2] = c[D >> 2];
	                                            if (!((c[t >> 2] | 0) != 0 ? (c[(c[S >> 2] | 0) + 12 >> 2] | 0) != 0 : 0))break c;
	                                            if (!(qy(c[(c[S >> 2] | 0) + 12 >> 2] | 0, c[t >> 2] | 0) | 0))break c;
	                                            if (c[H >> 2] | 0) {
	                                                l = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = l;
	                                                if ((l | 0) == (c[F >> 2] | 0)) {
	                                                    V = 197;
	                                                    break b
	                                                } else break c
	                                            }
	                                            c[w >> 2] = 1;
	                                            if ((br(c[C >> 2] | 0, c[(c[Q >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        } else if ((U | 0) == 2) {
	                                            c[R >> 2] = c[D >> 2];
	                                            if (!(qy(c[t >> 2] | 0, c[(c[R >> 2] | 0) + 8 >> 2] | 0) | 0))break c;
	                                            l = c[(c[R >> 2] | 0) + 36 >> 2] | 0;
	                                            if (!(c[s >> 2] | 0)) {
	                                                if ((l | 0) != 0 ? (c[(c[(c[R >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)break c;
	                                                if (c[H >> 2] | 0) {
	                                                    f = (c[I >> 2] | 0) + 1 | 0;
	                                                    c[I >> 2] = f;
	                                                    if ((f | 0) == (c[F >> 2] | 0)) {
	                                                        V = 178;
	                                                        break b
	                                                    } else break c
	                                                }
	                                                if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                                if (c[L >> 2] | 0) {
	                                                    V = 208;
	                                                    break a
	                                                } else break c
	                                            } else {
	                                                if (!l)break c;
	                                                if (!(qy(c[u >> 2] | 0, c[(c[(c[R >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0))break c;
	                                                if (c[H >> 2] | 0) {
	                                                    l = (c[I >> 2] | 0) + 1 | 0;
	                                                    c[I >> 2] = l;
	                                                    if ((l | 0) == (c[F >> 2] | 0)) {
	                                                        V = 187;
	                                                        break b
	                                                    } else break c
	                                                }
	                                                if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                                if (c[L >> 2] | 0) {
	                                                    V = 208;
	                                                    break a
	                                                } else break c
	                                            }
	                                        } else if ((U | 0) == 1) {
	                                            if (!(qy(c[t >> 2] | 0, c[(c[D >> 2] | 0) + 8 >> 2] | 0) | 0))break c;
	                                            U = c[(c[D >> 2] | 0) + 36 >> 2] | 0;
	                                            if (!(c[s >> 2] | 0)) {
	                                                if (U)break c;
	                                                if (c[H >> 2] | 0) {
	                                                    l = (c[I >> 2] | 0) + 1 | 0;
	                                                    c[I >> 2] = l;
	                                                    if ((l | 0) == (c[F >> 2] | 0)) {
	                                                        V = 158;
	                                                        break b
	                                                    } else break c
	                                                }
	                                                if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                                if (c[L >> 2] | 0) {
	                                                    V = 208;
	                                                    break a
	                                                } else break c
	                                            }
	                                            if (!U)break c;
	                                            if (!(qy(c[u >> 2] | 0, c[(c[(c[D >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0))break c;
	                                            if (c[H >> 2] | 0) {
	                                                U = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = U;
	                                                if ((U | 0) == (c[F >> 2] | 0)) {
	                                                    V = 167;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        } else break c;
	                                        break
	                                    }
	                                    case 2:
	                                    {
	                                        if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) == 7) {
	                                            if ((c[t >> 2] | 0) != 0 ? (qy(c[t >> 2] | 0, c[(c[D >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0)break c;
	                                            if (c[H >> 2] | 0) {
	                                                U = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = U;
	                                                if ((U | 0) == (c[F >> 2] | 0)) {
	                                                    V = 95;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            }
	                                        }
	                                        break
	                                    }
	                                    case 1:
	                                    {
	                                        U = c[(c[D >> 2] | 0) + 4 >> 2] | 0;
	                                        if (!(c[r >> 2] | 0)) {
	                                            switch (U | 0) {
	                                                case 18:
	                                                case 3:
	                                                case 4:
	                                                case 8:
	                                                case 7:
	                                                case 2:
	                                                case 1:
	                                                case 21:
	                                                case 13:
	                                                case 9:
	                                                    break;
	                                                default:
	                                                    break c
	                                            }
	                                            if (c[H >> 2] | 0) {
	                                                l = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = l;
	                                                if ((l | 0) == (c[F >> 2] | 0)) {
	                                                    V = 60;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        }
	                                        if ((U | 0) != (c[r >> 2] | 0)) {
	                                            if ((c[r >> 2] | 0) != 3)break c;
	                                            if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) != 4)break c;
	                                            if (c[H >> 2] | 0) {
	                                                U = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = U;
	                                                if ((U | 0) == (c[F >> 2] | 0)) {
	                                                    V = 85;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        }
	                                        U = (c[H >> 2] | 0) != 0;
	                                        if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                                            if (U) {
	                                                l = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = l;
	                                                if ((l | 0) == (c[F >> 2] | 0)) {
	                                                    V = 69;
	                                                    break b
	                                                } else break c
	                                            }
	                                            c[w >> 2] = 1;
	                                            if ((br(c[C >> 2] | 0, c[(c[Q >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        } else {
	                                            if (U) {
	                                                U = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = U;
	                                                if ((U | 0) == (c[F >> 2] | 0)) {
	                                                    V = 76;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        }
	                                        break
	                                    }
	                                    case 0:
	                                    {
	                                        V = 55;
	                                        break a;
	                                        break
	                                    }
	                                    case 4:
	                                    {
	                                        U = c[33976] | 0;
	                                        l = c[33980] | 0;
	                                        c[h >> 2] = 128552;
	                                        c[h + 4 >> 2] = 12457;
	                                        Db[U & 511](l, 129064, h);
	                                        break
	                                    }
	                                    case 3:
	                                    {
	                                        if ((c[p >> 2] | 0) == 3) {
	                                            if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) != 2)break c;
	                                            if (!(c[s >> 2] | 0)) {
	                                                if (c[H >> 2] | 0) {
	                                                    l = (c[I >> 2] | 0) + 1 | 0;
	                                                    c[I >> 2] = l;
	                                                    if ((l | 0) == (c[F >> 2] | 0)) {
	                                                        V = 105;
	                                                        break b
	                                                    } else break c
	                                                }
	                                                if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                                if (c[L >> 2] | 0) {
	                                                    V = 208;
	                                                    break a
	                                                } else break c
	                                            }
	                                            if (!(c[(c[D >> 2] | 0) + 36 >> 2] | 0))break c;
	                                            if (!(qy(c[u >> 2] | 0, c[(c[(c[D >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0))break c;
	                                            if (c[H >> 2] | 0) {
	                                                l = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = l;
	                                                if ((l | 0) == (c[F >> 2] | 0)) {
	                                                    V = 114;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        }
	                                        l = c[(c[D >> 2] | 0) + 4 >> 2] | 0;
	                                        if ((c[p >> 2] | 0) == 9) {
	                                            if ((l | 0) != 18)break c;
	                                            if (c[H >> 2] | 0) {
	                                                U = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = U;
	                                                if ((U | 0) == (c[F >> 2] | 0)) {
	                                                    V = 123;
	                                                    break b
	                                                } else break c
	                                            }
	                                            c[w >> 2] = 1;
	                                            if ((br(c[C >> 2] | 0, c[(c[Q >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        }
	                                        if ((l | 0) != 1)break c;
	                                        if (!(c[s >> 2] | 0)) {
	                                            if (c[H >> 2] | 0) {
	                                                l = (c[I >> 2] | 0) + 1 | 0;
	                                                c[I >> 2] = l;
	                                                if ((l | 0) == (c[F >> 2] | 0)) {
	                                                    V = 132;
	                                                    break b
	                                                } else break c
	                                            }
	                                            if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                            if (c[L >> 2] | 0) {
	                                                V = 208;
	                                                break a
	                                            } else break c
	                                        }
	                                        if (!(c[(c[D >> 2] | 0) + 36 >> 2] | 0))break c;
	                                        if (!(qy(c[u >> 2] | 0, c[(c[(c[D >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0))break c;
	                                        if (c[H >> 2] | 0) {
	                                            l = (c[I >> 2] | 0) + 1 | 0;
	                                            c[I >> 2] = l;
	                                            if ((l | 0) == (c[F >> 2] | 0)) {
	                                                V = 141;
	                                                break b
	                                            } else break c
	                                        }
	                                        if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                        if (c[L >> 2] | 0) {
	                                            V = 208;
	                                            break a
	                                        }
	                                        break
	                                    }
	                                    default:
	                                    {
	                                    }
	                                } while (0);
	                                if (!(c[D >> 2] | 0)) {
	                                    V = 211;
	                                    break
	                                }
	                                if (c[(c[k >> 2] | 0) + 8 >> 2] | 0) {
	                                    V = 211;
	                                    break
	                                }
	                            }
	                            switch (V | 0) {
	                                case 60:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 69:
	                                {
	                                    V = 0;
	                                    c[w >> 2] = 1;
	                                    if ((br(c[C >> 2] | 0, c[(c[Q >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 76:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 85:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 95:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 105:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 114:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 123:
	                                {
	                                    V = 0;
	                                    c[w >> 2] = 1;
	                                    if ((br(c[C >> 2] | 0, c[(c[Q >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 132:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 141:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 158:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 167:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 178:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 187:
	                                {
	                                    V = 0;
	                                    if ((Hb[c[N >> 2] & 511](c[C >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 197:
	                                {
	                                    V = 0;
	                                    c[w >> 2] = 1;
	                                    if ((br(c[C >> 2] | 0, c[(c[Q >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0)c[(c[k >> 2] | 0) + 8 >> 2] = 15;
	                                    break
	                                }
	                                case 211:
	                                {
	                                    V = 0;
	                                    if (c[(c[k >> 2] | 0) + 8 >> 2] | 0)break a;
	                                    if ((c[E >> 2] | 0) != 0 ? (c[c[C >> 2] >> 2] | 0) > 0 : 0) {
	                                        c[J >> 2] = c[c[C >> 2] >> 2];
	                                        l = c[k >> 2] | 0;
	                                        U = c[E >> 2] | 0;
	                                        f = c[C >> 2] | 0;
	                                        e = c[J >> 2] | 0;
	                                        if (c[G >> 2] | 0)c[K >> 2] = zu(l, U, f, e, c[F >> 2] | 0, c[F >> 2] | 0, c[w >> 2] | 0) | 0; else c[K >> 2] = Au(l, U, f, e, c[w >> 2] | 0) | 0;
	                                        if (c[(c[k >> 2] | 0) + 8 >> 2] | 0) {
	                                            V = 218;
	                                            break a
	                                        }
	                                        e = c[C >> 2] | 0;
	                                        if (!(c[K >> 2] | 0)) {
	                                            su(e, c[w >> 2] | 0);
	                                            continue a
	                                        }
	                                        if ((c[e >> 2] | 0) <= 0)continue a;
	                                        do if (!(c[B >> 2] | 0))if ((c[J >> 2] | 0) != (c[K >> 2] | 0)) {
	                                            c[B >> 2] = vb[c[O >> 2] & 511](0, c[C >> 2] | 0, 1) | 0;
	                                            break
	                                        } else {
	                                            c[B >> 2] = c[C >> 2];
	                                            c[C >> 2] = 0;
	                                            break
	                                        } else c[B >> 2] = vb[c[O >> 2] & 511](c[B >> 2] | 0, c[C >> 2] | 0, (c[J >> 2] | 0) != (c[K >> 2] | 0) ? 1 : 0) | 0; while (0);
	                                        if (c[o >> 2] | 0)break a; else continue a
	                                    }
	                                    if ((c[c[C >> 2] >> 2] | 0) <= 0)continue a;
	                                    if (!(c[B >> 2] | 0)) {
	                                        c[B >> 2] = c[C >> 2];
	                                        c[C >> 2] = 0;
	                                        continue a
	                                    } else {
	                                        c[B >> 2] = vb[c[O >> 2] & 511](c[B >> 2] | 0, c[C >> 2] | 0, 0) | 0;
	                                        continue a
	                                    }
	                                    break
	                                }
	                            }
	                            if (!(c[B >> 2] | 0)) {
	                                c[B >> 2] = c[C >> 2];
	                                c[C >> 2] = 0
	                            } else c[B >> 2] = vb[c[O >> 2] & 511](c[B >> 2] | 0, c[C >> 2] | 0, 0) | 0;
	                            if (c[o >> 2] | 0)break
	                        }
	                        do if ((V | 0) == 41)c[v >> 2] = 0; else if ((V | 0) == 55) {
	                            c[v >> 2] = 0;
	                            o = c[33976] | 0;
	                            K = c[33980] | 0;
	                            c[h >> 2] = 128552;
	                            c[h + 4 >> 2] = 12379;
	                            Db[o & 511](K, 129448, h)
	                        } else if ((V | 0) == 208)if (!(c[B >> 2] | 0)) {
	                            c[B >> 2] = c[C >> 2];
	                            c[C >> 2] = 0;
	                            break
	                        } else {
	                            c[B >> 2] = vb[c[O >> 2] & 511](c[B >> 2] | 0, c[C >> 2] | 0, 0) | 0;
	                            break
	                        } else if ((V | 0) == 218)c[v >> 2] = 0; while (0);
	                        if ((c[(c[x >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[x >> 2] | 0) + 28 >> 2] | 0) != 0 : 0) {
	                            c[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] = 1;
	                            c[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 28 >> 2] = c[(c[x >> 2] | 0) + 28 >> 2];
	                            c[(c[x >> 2] | 0) + 28 >> 2] = 0;
	                            c[(c[x >> 2] | 0) + 8 >> 2] = 0
	                        }
	                        jt(c[Q >> 2] | 0, c[x >> 2] | 0);
	                        do if (!(c[B >> 2] | 0)) {
	                            if ((c[C >> 2] | 0) != 0 ? (c[c[C >> 2] >> 2] | 0) == 0 : 0) {
	                                c[B >> 2] = c[C >> 2];
	                                break
	                            }
	                            c[B >> 2] = $q(0) | 0
	                        } while (0);
	                        if ((c[C >> 2] | 0) != 0 ? (c[C >> 2] | 0) != (c[B >> 2] | 0) : 0)fr(c[C >> 2] | 0);
	                        C = c[k >> 2] | 0;
	                        Tq(C, At(c[Q >> 2] | 0, c[B >> 2] | 0) | 0) | 0;
	                        c[(c[Q >> 2] | 0) + 4 >> 2] = c[P >> 2];
	                        c[j >> 2] = c[v >> 2];
	                        T = c[j >> 2] | 0;
	                        i = g;
	                        return T | 0
	                    }
	                    jt(c[Q >> 2] | 0, c[x >> 2] | 0);
	                    x = c[k >> 2] | 0;
	                    Tq(x, At(c[Q >> 2] | 0, 0) | 0) | 0;
	                    c[j >> 2] = 0;
	                    T = c[j >> 2] | 0;
	                    i = g;
	                    return T | 0
	                }
	                Nq(c[k >> 2] | 0, 11);
	                c[j >> 2] = 0;
	                T = c[j >> 2] | 0;
	                i = g;
	                return T | 0
	            }

	            function ou(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[f >> 2] = c[(c[e >> 2] | 0) + 44 >> 2];
	                    c[(c[e >> 2] | 0) + 44 >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function pu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) < (c[(c[e >> 2] | 0) + 44 >> 2] | 0))Oq(c[e >> 2] | 0, 128552, 2808, 23);
	                c[(c[e >> 2] | 0) + 44 >> 2] = c[f >> 2];
	                i = d;
	                return
	            }

	            function qu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[m >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                do switch (c[c[h >> 2] >> 2] | 0) {
	                    case 0:
	                    {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    case 12:
	                    {
	                        Tq(c[g >> 2] | 0, lt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0) | 0;
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    case 7:
	                    {
	                        c[k >> 2] = qu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, c[j >> 2] | 0) | 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) >= 1 : 0) {
	                            if ((c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1)Zq(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0);
	                            c[c[j >> 2] >> 2] = c[c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2]
	                        }
	                        c[l >> 2] = qu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0, c[j >> 2] | 0) | 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                            c[o >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                                c[n >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                d = er(c[(c[n >> 2] | 0) + 4 >> 2] | 0, c[(c[o >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 4 >> 2] = d;
	                                Tq(c[g >> 2] | 0, c[n >> 2] | 0) | 0;
	                                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[o >> 2] | 0);
	                                if ((c[k >> 2] | 0) > (c[l >> 2] | 0))Bu(c[h >> 2] | 0);
	                                c[f >> 2] = (c[k >> 2] | 0) + (c[l >> 2] | 0);
	                                p = c[f >> 2] | 0;
	                                i = e;
	                                return p | 0
	                            }
	                            Nq(c[g >> 2] | 0, 11);
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        Nq(c[g >> 2] | 0, 11);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    case 10:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            d = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            d = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        } else {
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            c[f >> 2] = c[k >> 2];
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            d = qu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, c[j >> 2] | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1 : 0)Zq(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0);
	                        c[f >> 2] = c[k >> 2];
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    case 9:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            d = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            d = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        } else {
	                            d = c[g >> 2] | 0;
	                            Tq(d, yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                            c[f >> 2] = c[k >> 2];
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        break
	                    }
	                    case 11:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == -1) {
	                            c[f >> 2] = c[k >> 2];
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        c[k >> 2] = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        } else {
	                            d = nu(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 0, 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d;
	                            c[f >> 2] = c[k >> 2];
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        break
	                    }
	                    case 8:
	                    {
	                        ks(c[g >> 2] | 0);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    case 17:
	                    {
	                        c[k >> 2] = (Cu(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) + (c[k >> 2] | 0);
	                        c[f >> 2] = c[k >> 2];
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    default:
	                    {
	                        c[f >> 2] = iu(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                } while (0);
	                return 0
	            }

	            function ru(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                h = e + 40 | 0;
	                j = e + 36 | 0;
	                k = e + 32 | 0;
	                l = e + 28 | 0;
	                m = e + 24 | 0;
	                n = e + 20 | 0;
	                o = e + 16 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                s = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                c[m >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                switch (c[c[h >> 2] >> 2] | 0) {
	                    case 0:
	                    {
	                        c[f >> 2] = 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    case 11:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == -1) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        c[k >> 2] = (iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0) + (c[k >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        } else {
	                            d = nu(c[g >> 2] | 0, c[h >> 2] | 0, 0, c[j >> 2] | 0, 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + d;
	                            c[f >> 2] = c[k >> 2];
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        break
	                    }
	                    case 7:
	                    {
	                        c[q >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[p >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[r >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2];
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                        c[k >> 2] = ru(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, c[j >> 2] | 0) | 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) >= 1 : 0) {
	                            if ((c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1)Zq(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0);
	                            c[c[j >> 2] >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + ((c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) - 1 << 2) >> 2]
	                        }
	                        c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[q >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = c[r >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[s >> 2];
	                        c[l >> 2] = ru(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0, c[j >> 2] | 0) | 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                            c[o >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                                c[n >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                s = er(c[(c[n >> 2] | 0) + 4 >> 2] | 0, c[(c[o >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 4 >> 2] = s;
	                                Tq(c[g >> 2] | 0, c[n >> 2] | 0) | 0;
	                                jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[o >> 2] | 0);
	                                if ((c[k >> 2] | 0) > (c[l >> 2] | 0))Bu(c[h >> 2] | 0);
	                                c[f >> 2] = (c[k >> 2] | 0) + (c[l >> 2] | 0);
	                                t = c[f >> 2] | 0;
	                                i = e;
	                                return t | 0
	                            }
	                            Nq(c[g >> 2] | 0, 11);
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        Nq(c[g >> 2] | 0, 11);
	                        c[f >> 2] = 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    case 10:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            l = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + l
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            l = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + l
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        } else {
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            c[f >> 2] = c[k >> 2];
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        break
	                    }
	                    case 9:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            l = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + l
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                            l = iu(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + l
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        } else {
	                            l = c[g >> 2] | 0;
	                            Tq(l, yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                            c[f >> 2] = c[k >> 2];
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        break
	                    }
	                    case 8:
	                    {
	                        ks(c[g >> 2] | 0);
	                        c[f >> 2] = 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    case 12:
	                    {
	                        Tq(c[g >> 2] | 0, lt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0) | 0;
	                        c[f >> 2] = 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    case 18:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                            l = ru(c[g >> 2] | 0, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, c[j >> 2] | 0) | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + l
	                        }
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        if ((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1 : 0)Zq(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0);
	                        c[f >> 2] = c[k >> 2];
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    default:
	                    {
	                        c[f >> 2] = iu(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                }
	                return 0
	            }

	            function su(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[c[e >> 2] >> 2] | 0) <= 0) {
	                    i = d;
	                    return
	                }
	                a:do if (c[f >> 2] | 0) {
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[c[e >> 2] >> 2] | 0))break a;
	                        c[h >> 2] = c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2];
	                        if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 18 : 0)_q(c[h >> 2] | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                } while (0);
	                c[c[e >> 2] >> 2] = 0;
	                i = d;
	                return
	            }

	            function tu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                Du(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 60 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 62 : 0) {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 61 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 62) {
	                            j = 40;
	                            break b
	                        }
	                        if ((d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 61) {
	                            j = 40;
	                            break b
	                        }
	                    } while (0);
	                    c[h >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 60)c[f >> 2] = 1; else c[f >> 2] = 0;
	                    if ((d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 61)c[g >> 2] = 0; else c[g >> 2] = 1;
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    if ((c[g >> 2] | 0) == 0 ? (a = c[e >> 2] | 0, (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 0) : 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)k = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                k = 1;
	                                break
	                            }
	                            k = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        l = c[e >> 2] | 0;
	                        if (!k)break;
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[l >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    Du(l);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        j = 40;
	                        break
	                    }
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 4, c[f >> 2] | 0, c[g >> 2] | 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                if ((j | 0) == 40) {
	                    i = b;
	                    return
	                }
	            }

	            function uu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                a:do if ((c[g >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = Eu(c[c[h >> 2] >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else {
	                        if (!(c[c[h >> 2] >> 2] | 0))break;
	                        eU(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[c[h >> 2] >> 2] << 2 | 0) | 0;
	                        c[c[g >> 2] >> 2] = c[c[h >> 2] >> 2];
	                        break
	                    }
	                } else {
	                    if (!(c[g >> 2] | 0))c[g >> 2] = $q(0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    c[m >> 2] = c[c[g >> 2] >> 2];
	                    c[k >> 2] = 0;
	                    b:while (1) {
	                        if ((c[k >> 2] | 0) >= (c[c[h >> 2] >> 2] | 0))break a;
	                        c[o >> 2] = c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        c:do if (c[o >> 2] | 0) {
	                            c[l >> 2] = 0;
	                            while (1) {
	                                if ((c[l >> 2] | 0) >= (c[m >> 2] | 0))break;
	                                c[n >> 2] = c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                                if ((c[n >> 2] | 0) == (c[o >> 2] | 0))break c;
	                                if ((((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 18 ? (c[(c[o >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) ? (c[c[n >> 2] >> 2] | 0) == (c[c[o >> 2] >> 2] | 0) : 0) ? (qy(c[(c[n >> 2] | 0) + 12 >> 2] | 0, c[(c[o >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                                    s = 20;
	                                    break
	                                }
	                                c[l >> 2] = (c[l >> 2] | 0) + 1
	                            }
	                            if ((s | 0) == 20) {
	                                s = 0;
	                                c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] = 0;
	                                _q(c[o >> 2] | 0);
	                                break
	                            }
	                            if (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                                if ((c[c[g >> 2] >> 2] | 0) >= (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >= 1e7) {
	                                        s = 28;
	                                        break b
	                                    }
	                                    c[p >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] << 1 << 2) | 0;
	                                    if (!(c[p >> 2] | 0)) {
	                                        s = 30;
	                                        break b
	                                    }
	                                    c[(c[g >> 2] | 0) + 8 >> 2] = c[p >> 2];
	                                    d = (c[g >> 2] | 0) + 4 | 0;
	                                    c[d >> 2] = c[d >> 2] << 1
	                                }
	                            } else {
	                                d = Cb[c[135744 >> 2] & 511](40) | 0;
	                                c[(c[g >> 2] | 0) + 8 >> 2] = d;
	                                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                                    s = 24;
	                                    break b
	                                }
	                                d = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                                b = d + 40 | 0;
	                                do {
	                                    c[d >> 2] = 0;
	                                    d = d + 4 | 0
	                                } while ((d | 0) < (b | 0));
	                                c[(c[g >> 2] | 0) + 4 >> 2] = 10
	                            }
	                            d = c[o >> 2] | 0;
	                            if ((c[(c[o >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                                c[q >> 2] = d;
	                                b = kt(c[c[q >> 2] >> 2] | 0, c[q >> 2] | 0) | 0;
	                                a = c[g >> 2] | 0;
	                                t = c[a >> 2] | 0;
	                                c[a >> 2] = t + 1;
	                                c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (t << 2) >> 2] = b;
	                                break
	                            } else {
	                                b = c[g >> 2] | 0;
	                                t = c[b >> 2] | 0;
	                                c[b >> 2] = t + 1;
	                                c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (t << 2) >> 2] = d;
	                                break
	                            }
	                        } while (0);
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((s | 0) == 24) {
	                        it(0, 128712);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 28) {
	                        it(0, 128736);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 30) {
	                        it(0, 128712);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = 0;
	                c[f >> 2] = c[g >> 2];
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function vu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                d = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = d;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                a:do if ((d | 0) == 0 & (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = Eu(c[c[h >> 2] >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else {
	                        if (!(c[c[h >> 2] >> 2] | 0))break;
	                        eU(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[c[h >> 2] >> 2] << 2 | 0) | 0;
	                        c[c[g >> 2] >> 2] = c[c[h >> 2] >> 2];
	                        break
	                    }
	                } else {
	                    if (!(c[g >> 2] | 0))c[g >> 2] = $q(0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    c[k >> 2] = 0;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >= (c[c[h >> 2] >> 2] | 0))break a;
	                        c[l >> 2] = c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        if (c[l >> 2] | 0) {
	                            if (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                                if ((c[c[g >> 2] >> 2] | 0) >= (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >= 1e7) {
	                                        o = 21;
	                                        break
	                                    }
	                                    c[m >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] << 1 << 2) | 0;
	                                    if (!(c[m >> 2] | 0)) {
	                                        o = 23;
	                                        break
	                                    }
	                                    c[(c[g >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                                    b = (c[g >> 2] | 0) + 4 | 0;
	                                    c[b >> 2] = c[b >> 2] << 1
	                                }
	                            } else {
	                                b = Cb[c[135744 >> 2] & 511](40) | 0;
	                                c[(c[g >> 2] | 0) + 8 >> 2] = b;
	                                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                                    o = 17;
	                                    break
	                                }
	                                b = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                                a = b + 40 | 0;
	                                do {
	                                    c[b >> 2] = 0;
	                                    b = b + 4 | 0
	                                } while ((b | 0) < (a | 0));
	                                c[(c[g >> 2] | 0) + 4 >> 2] = 10
	                            }
	                            b = c[l >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            p = c[a >> 2] | 0;
	                            c[a >> 2] = p + 1;
	                            c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (p << 2) >> 2] = b
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((o | 0) == 17) {
	                        it(0, 128712);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 21) {
	                        it(0, 128736);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 23) {
	                        it(0, 128712);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = 0;
	                c[f >> 2] = c[g >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function wu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if (c[g >> 2] | 0) {
	                        switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                            case 20:
	                            case 8:
	                            case 7:
	                            case 4:
	                            case 6:
	                            case 5:
	                            case 3:
	                            case 1:
	                                break;
	                            default:
	                            {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 24 >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            break
	                        }
	                        b = c[(c[g >> 2] | 0) + 24 >> 2] | 0;
	                        if ((c[(c[(c[g >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            c[e >> 2] = b;
	                            break
	                        }
	                        c[g >> 2] = b;
	                        do {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            if (!(c[g >> 2] | 0))break
	                        } while ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1);
	                        c[e >> 2] = c[g >> 2];
	                        break
	                    }
	                    c[g >> 2] = c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                        case 21:
	                        case 13:
	                        case 9:
	                        {
	                            c[e >> 2] = Pi(c[g >> 2] | 0) | 0;
	                            break a;
	                            break
	                        }
	                        case 6:
	                        case 5:
	                        case 11:
	                        case 1:
	                        {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                            if (!(c[g >> 2] | 0)) {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                c[e >> 2] = c[g >> 2];
	                                break a
	                            }
	                            do {
	                                c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                                if (!(c[g >> 2] | 0))break
	                            } while ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1);
	                            c[e >> 2] = c[g >> 2];
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[e >> 2] = 0;
	                            break a
	                        }
	                    }
	                } else h = 3; while (0);
	                if ((h | 0) == 3)c[e >> 2] = 0;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function xu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    do if (!(c[g >> 2] | 0)) {
	                        c[g >> 2] = c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        if (!(c[g >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                            c[(c[f >> 2] | 0) + 40 >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            break
	                        }
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } while (0);
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if ((c[(c[g >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) == 14 : 0)c[g >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    while (1) {
	                        j = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 28 >> 2] | 0) {
	                            k = 23;
	                            break
	                        }
	                        c[g >> 2] = c[j + 20 >> 2];
	                        if (!(c[g >> 2] | 0)) {
	                            k = 17;
	                            break
	                        }
	                        if ((c[g >> 2] | 0) == (c[(c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0) + 12 >> 2] | 0)) {
	                            k = 19;
	                            break
	                        }
	                        l = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) != (c[(c[f >> 2] | 0) + 40 >> 2] | 0)) {
	                            k = 21;
	                            break
	                        }
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[l + 20 >> 2]
	                    }
	                    if ((k | 0) == 17) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((k | 0) == 19) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((k | 0) == 21) {
	                        c[e >> 2] = l;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else if ((k | 0) == 23) {
	                        c[g >> 2] = c[j + 28 >> 2];
	                        while (1) {
	                            m = c[g >> 2] | 0;
	                            if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0))break;
	                            c[g >> 2] = c[m + 16 >> 2]
	                        }
	                        c[e >> 2] = m;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function yu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                if ((c[c[j >> 2] >> 2] | 0) != 16 ? (c[c[j >> 2] >> 2] | 0) != 17 : 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[l >> 2] = (c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) * 40 | 0);
	                if (((((c[l >> 2] | 0) != 0 ? (c[c[l >> 2] >> 2] | 0) == 12 : 0) ? (c[(c[l >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) ? (c[c[(c[l >> 2] | 0) + 24 >> 2] >> 2] | 0) == 3 : 0) ? (c[c[k >> 2] >> 2] = ~~+h[(c[(c[l >> 2] | 0) + 24 >> 2] | 0) + 16 >> 3], +h[(c[(c[l >> 2] | 0) + 24 >> 2] | 0) + 16 >> 3] == +(c[c[k >> 2] >> 2] | 0)) : 0) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[f >> 2] = 0;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function zu(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
	                j = i;
	                i = i + 96 | 0;
	                k = j + 88 | 0;
	                l = j + 84 | 0;
	                m = j + 80 | 0;
	                n = j + 76 | 0;
	                o = j + 72 | 0;
	                p = j + 68 | 0;
	                q = j + 64 | 0;
	                r = j + 60 | 0;
	                s = j + 56 | 0;
	                t = j + 52 | 0;
	                u = j + 48 | 0;
	                v = j + 44 | 0;
	                w = j + 40 | 0;
	                x = j + 36 | 0;
	                y = j + 32 | 0;
	                z = j + 28 | 0;
	                A = j + 24 | 0;
	                B = j + 20 | 0;
	                C = j + 16 | 0;
	                D = j + 12 | 0;
	                E = j + 8 | 0;
	                F = j + 4 | 0;
	                G = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                    c[s >> 2] = c[(c[l >> 2] | 0) + 32 >> 2];
	                    c[o >> 2] = Au(c[l >> 2] | 0, (c[(c[s >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[r >> 2] | 0) | 0;
	                    if (c[(c[l >> 2] | 0) + 8 >> 2] | 0) {
	                        c[k >> 2] = 0;
	                        H = c[k >> 2] | 0;
	                        i = j;
	                        return H | 0
	                    }
	                    if ((c[o >> 2] | 0) <= 0) {
	                        c[k >> 2] = 0;
	                        H = c[k >> 2] | 0;
	                        i = j;
	                        return H | 0
	                    }
	                }
	                if ((c[o >> 2] | 0) < (c[p >> 2] | 0)) {
	                    su(c[n >> 2] | 0, c[r >> 2] | 0);
	                    c[k >> 2] = 0;
	                    H = c[k >> 2] | 0;
	                    i = j;
	                    return H | 0
	                }
	                if ((c[(c[m >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                    c[k >> 2] = c[o >> 2];
	                    H = c[k >> 2] | 0;
	                    i = j;
	                    return H | 0
	                }
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                c[A >> 2] = 0;
	                c[B >> 2] = 0;
	                c[D >> 2] = 0;
	                c[E >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                c[C >> 2] = c[(c[E >> 2] | 0) + 4 >> 2];
	                c[t >> 2] = c[c[E >> 2] >> 2];
	                c[z >> 2] = (c[(c[(c[l >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[m >> 2] | 0) + 8 >> 2] | 0) * 40 | 0);
	                c[u >> 2] = 0;
	                a:while (1) {
	                    if ((c[u >> 2] | 0) >= (c[c[n >> 2] >> 2] | 0))break;
	                    do if (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + (c[u >> 2] << 2) >> 2] | 0) {
	                        c[D >> 2] = c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + (c[u >> 2] << 2) >> 2];
	                        c[(c[E >> 2] | 0) + 4 >> 2] = c[D >> 2];
	                        c[(c[E >> 2] | 0) + 68 >> 2] = c[o >> 2];
	                        m = (c[x >> 2] | 0) + 1 | 0;
	                        c[x >> 2] = m;
	                        c[(c[E >> 2] | 0) + 72 >> 2] = m;
	                        if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) != 18 ? (c[(c[D >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)c[c[E >> 2] >> 2] = c[(c[D >> 2] | 0) + 32 >> 2];
	                        if (c[A >> 2] | 0) {
	                            if ((dr(c[(c[A >> 2] | 0) + 4 >> 2] | 0, c[D >> 2] | 0) | 0) < 0) {
	                                I = 19;
	                                break a
	                            }
	                        } else c[A >> 2] = yt(c[E >> 2] | 0, c[D >> 2] | 0) | 0;
	                        c[F >> 2] = ou(c[l >> 2] | 0) | 0;
	                        Tq(c[l >> 2] | 0, c[A >> 2] | 0) | 0;
	                        c[y >> 2] = hu(c[l >> 2] | 0, c[z >> 2] | 0, 1) | 0;
	                        c[G >> 2] = Sq(c[l >> 2] | 0) | 0;
	                        pu(c[l >> 2] | 0, c[F >> 2] | 0);
	                        if ((c[y >> 2] | 0) == -1 ? 1 : (c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 0) {
	                            I = 21;
	                            break a
	                        }
	                        Tq(c[l >> 2] | 0, c[G >> 2] | 0) | 0;
	                        if (c[y >> 2] | 0)c[v >> 2] = (c[v >> 2] | 0) + 1;
	                        if (((c[y >> 2] | 0) != 0 ? (c[v >> 2] | 0) >= (c[p >> 2] | 0) : 0) ? (c[v >> 2] | 0) <= (c[q >> 2] | 0) : 0) {
	                            c[w >> 2] = (c[w >> 2] | 0) + 1;
	                            if ((c[p >> 2] | 0) == (c[q >> 2] | 0)) {
	                                I = 29;
	                                break a
	                            }
	                            if ((c[v >> 2] | 0) == (c[q >> 2] | 0)) {
	                                I = 33;
	                                break a
	                            }
	                        } else I = 34;
	                        if ((I | 0) == 34 ? (I = 0, c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + (c[u >> 2] << 2) >> 2] = 0, (c[(c[D >> 2] | 0) + 4 >> 2] | 0) == 18) : 0)_q(c[D >> 2] | 0);
	                        if (c[B >> 2] | 0) {
	                            jt(c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[B >> 2] | 0);
	                            c[B >> 2] = 0
	                        }
	                        if ((c[(c[l >> 2] | 0) + 16 >> 2] | 0) == (c[A >> 2] | 0)) {
	                            Sq(c[l >> 2] | 0) | 0;
	                            su(c[(c[A >> 2] | 0) + 4 >> 2] | 0, c[r >> 2] | 0);
	                            break
	                        } else {
	                            c[A >> 2] = 0;
	                            break
	                        }
	                    } while (0);
	                    c[u >> 2] = (c[u >> 2] | 0) + 1
	                }
	                if ((I | 0) == 19)c[(c[l >> 2] | 0) + 8 >> 2] = 15; else if ((I | 0) == 21) {
	                    while (1) {
	                        I = 0;
	                        if ((c[G >> 2] | 0) == (c[A >> 2] | 0))break;
	                        jt(c[E >> 2] | 0, c[G >> 2] | 0);
	                        c[G >> 2] = Sq(c[l >> 2] | 0) | 0;
	                        I = 21
	                    }
	                    su(c[n >> 2] | 0, c[r >> 2] | 0);
	                    c[w >> 2] = 0
	                } else if ((I | 0) == 29) {
	                    if ((c[(c[D >> 2] | 0) + 4 >> 2] | 0) == 18)c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + (c[u >> 2] << 2) >> 2] = 0;
	                    su(c[n >> 2] | 0, c[r >> 2] | 0);
	                    c[c[n >> 2] >> 2] = 1;
	                    c[c[(c[n >> 2] | 0) + 8 >> 2] >> 2] = c[D >> 2]
	                } else if ((I | 0) == 33)Fu(c[n >> 2] | 0, (c[u >> 2] | 0) + 1 | 0, c[r >> 2] | 0);
	                if (c[A >> 2] | 0) {
	                    if ((c[(c[l >> 2] | 0) + 16 >> 2] | 0) == (c[A >> 2] | 0))Sq(c[l >> 2] | 0) | 0;
	                    jt(c[E >> 2] | 0, c[A >> 2] | 0)
	                }
	                if (c[B >> 2] | 0)jt(c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[B >> 2] | 0);
	                c[(c[E >> 2] | 0) + 4 >> 2] = c[C >> 2];
	                c[c[E >> 2] >> 2] = c[t >> 2];
	                c[(c[E >> 2] | 0) + 68 >> 2] = -1;
	                c[(c[E >> 2] | 0) + 72 >> 2] = -1;
	                c[k >> 2] = c[w >> 2];
	                H = c[k >> 2] | 0;
	                i = j;
	                return H | 0
	            }

	            function Au(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                g = i;
	                i = i + 80 | 0;
	                h = g + 68 | 0;
	                j = g + 64 | 0;
	                k = g + 60 | 0;
	                l = g + 56 | 0;
	                m = g + 52 | 0;
	                n = g + 48 | 0;
	                o = g + 44 | 0;
	                p = g + 40 | 0;
	                q = g + 36 | 0;
	                r = g + 32 | 0;
	                s = g + 28 | 0;
	                t = g + 24 | 0;
	                u = g + 20 | 0;
	                v = g + 16 | 0;
	                w = g + 12 | 0;
	                x = g + 8 | 0;
	                y = g + 4 | 0;
	                z = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                    c[o >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                    c[m >> 2] = Au(c[j >> 2] | 0, (c[(c[o >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                        c[h >> 2] = 0;
	                        A = c[h >> 2] | 0;
	                        i = g;
	                        return A | 0
	                    }
	                    if ((c[m >> 2] | 0) <= 0) {
	                        c[h >> 2] = 0;
	                        A = c[h >> 2] | 0;
	                        i = g;
	                        return A | 0
	                    }
	                }
	                if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                    c[h >> 2] = c[m >> 2];
	                    A = c[h >> 2] | 0;
	                    i = g;
	                    return A | 0
	                }
	                c[p >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                c[v >> 2] = 0;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                c[r >> 2] = c[(c[p >> 2] | 0) + 4 >> 2];
	                c[s >> 2] = c[c[p >> 2] >> 2];
	                c[x >> 2] = (c[(c[(c[j >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) * 40 | 0);
	                c[w >> 2] = 0;
	                c[t >> 2] = 0;
	                a:while (1) {
	                    if ((c[t >> 2] | 0) >= (c[c[l >> 2] >> 2] | 0)) {
	                        B = 27;
	                        break
	                    }
	                    do if (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[t >> 2] << 2) >> 2] | 0) {
	                        c[q >> 2] = c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[t >> 2] << 2) >> 2];
	                        c[(c[p >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                        c[(c[p >> 2] | 0) + 68 >> 2] = c[m >> 2];
	                        k = (c[v >> 2] | 0) + 1 | 0;
	                        c[v >> 2] = k;
	                        c[(c[p >> 2] | 0) + 72 >> 2] = k;
	                        if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) != 18 ? (c[(c[q >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)c[c[p >> 2] >> 2] = c[(c[q >> 2] | 0) + 32 >> 2];
	                        if (c[y >> 2] | 0) {
	                            if ((dr(c[(c[y >> 2] | 0) + 4 >> 2] | 0, c[q >> 2] | 0) | 0) < 0) {
	                                B = 16;
	                                break a
	                            }
	                        } else c[y >> 2] = yt(c[p >> 2] | 0, c[q >> 2] | 0) | 0;
	                        Tq(c[j >> 2] | 0, c[y >> 2] | 0) | 0;
	                        c[u >> 2] = hu(c[j >> 2] | 0, c[x >> 2] | 0, 1) | 0;
	                        if ((c[u >> 2] | 0) == -1 ? 1 : (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0) {
	                            B = 18;
	                            break a
	                        }
	                        if (!(c[u >> 2] | 0)) {
	                            c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[t >> 2] << 2) >> 2] = 0;
	                            if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 18)_q(c[q >> 2] | 0)
	                        } else c[w >> 2] = (c[w >> 2] | 0) + 1;
	                        if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) == (c[y >> 2] | 0)) {
	                            Sq(c[j >> 2] | 0) | 0;
	                            su(c[(c[y >> 2] | 0) + 4 >> 2] | 0, c[n >> 2] | 0);
	                            break
	                        } else {
	                            c[y >> 2] = 0;
	                            break
	                        }
	                    } while (0);
	                    c[t >> 2] = (c[t >> 2] | 0) + 1
	                }
	                if ((B | 0) == 16)c[(c[j >> 2] | 0) + 8 >> 2] = 15; else if ((B | 0) == 18) {
	                    su(c[l >> 2] | 0, c[n >> 2] | 0);
	                    c[w >> 2] = 0
	                } else if ((B | 0) == 27 ? (c[y >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) == (c[y >> 2] | 0))Sq(c[j >> 2] | 0) | 0;
	                    jt(c[p >> 2] | 0, c[y >> 2] | 0)
	                }
	                if (c[z >> 2] | 0)jt(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[z >> 2] | 0);
	                c[(c[p >> 2] | 0) + 4 >> 2] = c[r >> 2];
	                c[c[p >> 2] >> 2] = c[s >> 2];
	                c[(c[p >> 2] | 0) + 68 >> 2] = -1;
	                c[(c[p >> 2] | 0) + 72 >> 2] = -1;
	                c[h >> 2] = c[w >> 2];
	                A = c[h >> 2] | 0;
	                i = g;
	                return A | 0
	            }

	            function Bu(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (c[32574] | 0) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = c[(c[d >> 2] | 0) + 4 >> 2];
	                c[(c[d >> 2] | 0) + 4 >> 2] = c[(c[d >> 2] | 0) + 8 >> 2];
	                c[(c[d >> 2] | 0) + 8 >> 2] = c[e >> 2];
	                i = b;
	                return
	            }

	            function Cu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                e = i;
	                i = i + 80 | 0;
	                f = e + 72 | 0;
	                g = e + 68 | 0;
	                h = e + 64 | 0;
	                j = e + 60 | 0;
	                k = e + 56 | 0;
	                l = e + 52 | 0;
	                m = e + 48 | 0;
	                n = e + 44 | 0;
	                o = e + 40 | 0;
	                p = e + 36 | 0;
	                q = e + 32 | 0;
	                r = e + 28 | 0;
	                s = e + 24 | 0;
	                t = e + 20 | 0;
	                u = e + 16 | 0;
	                v = e + 12 | 0;
	                w = e + 8 | 0;
	                x = e + 4 | 0;
	                y = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    z = c[f >> 2] | 0;
	                    i = e;
	                    return z | 0
	                }
	                c[l >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                if ((((((((((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1 : 0) ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) >> 2] | 0) == 18 : 0) ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) >> 2] | 0) == 18 : 0) ? (c[s >> 2] = c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) + 4 >> 2], (c[s >> 2] | 0) != -1) : 0) ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[s >> 2] | 0) * 40 | 0) >> 2] | 0) == 14 : 0) ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[s >> 2] | 0) * 40 | 0) + 28 >> 2] | 0) == 0 : 0) ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[s >> 2] | 0) * 40 | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[s >> 2] | 0) * 40 | 0) + 24 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[s >> 2] | 0) * 40 | 0) + 24 >> 2] | 0, 129656) | 0) != 0 : 0) {
	                    c[t >> 2] = 0;
	                    s = ru(c[g >> 2] | 0, (c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0, t) | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) + s;
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        z = c[f >> 2] | 0;
	                        i = e;
	                        return z | 0
	                    }
	                    if (((((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) > 1 : 0) {
	                        c[c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + ((c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) - 1 << 2) >> 2];
	                        c[c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] = 1;
	                        c[c[j >> 2] >> 2] = c[c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2]
	                    }
	                    c[f >> 2] = c[k >> 2];
	                    z = c[f >> 2] | 0;
	                    i = e;
	                    return z | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                    s = iu(c[g >> 2] | 0, (c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) * 40 | 0) | 0) | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) + s
	                }
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    z = c[f >> 2] | 0;
	                    i = e;
	                    return z | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) == -1) {
	                    c[f >> 2] = c[k >> 2];
	                    z = c[f >> 2] | 0;
	                    i = e;
	                    return z | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[f >> 2] = c[k >> 2];
	                    z = c[f >> 2] | 0;
	                    i = e;
	                    return z | 0
	                }
	                c[p >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7) {
	                    if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                        c[n >> 2] = Sq(c[g >> 2] | 0) | 0;
	                        c[o >> 2] = c[(c[n >> 2] | 0) + 4 >> 2];
	                        c[p >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2];
	                        c[q >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                        if ((c[o >> 2] | 0) != 0 ? (c[c[o >> 2] >> 2] | 0) != 0 : 0) {
	                            c[y >> 2] = 0;
	                            c[x >> 2] = $q(0) | 0;
	                            c[r >> 2] = 0;
	                            while (1) {
	                                if ((c[r >> 2] | 0) >= (c[c[o >> 2] >> 2] | 0))break;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[o >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2];
	                                if ((c[(c[(c[(c[o >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) != 18 ? (c[(c[(c[(c[o >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[(c[(c[(c[o >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) + 32 >> 2];
	                                if (c[y >> 2] | 0) {
	                                    if ((dr(c[(c[y >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) < 0)c[(c[g >> 2] | 0) + 8 >> 2] = 15
	                                } else c[y >> 2] = yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                Tq(c[g >> 2] | 0, c[y >> 2] | 0) | 0;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[c[o >> 2] >> 2];
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = (c[r >> 2] | 0) + 1;
	                                if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                    s = iu(c[g >> 2] | 0, (c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                    c[k >> 2] = (c[k >> 2] | 0) + s
	                                }
	                                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                    A = 85;
	                                    break
	                                }
	                                c[m >> 2] = Sq(c[g >> 2] | 0) | 0;
	                                do if (Ns(c[g >> 2] | 0, c[m >> 2] | 0) | 0) {
	                                    if ((cr(c[x >> 2] | 0, c[(c[(c[o >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) | 0) >= 0)break;
	                                    c[(c[g >> 2] | 0) + 8 >> 2] = 15
	                                } while (0);
	                                if (c[m >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[y >> 2] | 0)) {
	                                    Sq(c[g >> 2] | 0) | 0;
	                                    su(c[(c[y >> 2] | 0) + 4 >> 2] | 0, 1)
	                                } else c[y >> 2] = 0;
	                                c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                                if ((c[c[x >> 2] >> 2] | 0) > 0) {
	                                    A = 95;
	                                    break
	                                }
	                                c[r >> 2] = (c[r >> 2] | 0) + 1
	                            }
	                            if ((A | 0) == 85) {
	                                fr(c[x >> 2] | 0);
	                                Qq(c[n >> 2] | 0);
	                                c[f >> 2] = 0;
	                                z = c[f >> 2] | 0;
	                                i = e;
	                                return z | 0
	                            } else if ((A | 0) == 95)c[c[j >> 2] >> 2] = c[c[(c[x >> 2] | 0) + 8 >> 2] >> 2];
	                            if (c[y >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[y >> 2] | 0);
	                            jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0);
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = -1;
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = -1;
	                            c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] = c[q >> 2];
	                            q = c[g >> 2] | 0;
	                            Tq(q, At(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[x >> 2] | 0) | 0) | 0
	                        } else A = 71;
	                        if ((A | 0) == 71 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = 0, Tq(c[g >> 2] | 0, c[n >> 2] | 0) | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[p >> 2], (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                            c[f >> 2] = 0;
	                            z = c[f >> 2] | 0;
	                            i = e;
	                            return z | 0
	                        }
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                        c[f >> 2] = c[k >> 2];
	                        z = c[f >> 2] | 0;
	                        i = e;
	                        return z | 0
	                    }
	                    Nq(c[g >> 2] | 0, 11);
	                    c[f >> 2] = 0;
	                    z = c[f >> 2] | 0;
	                    i = e;
	                    return z | 0
	                }
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 7 : 0) {
	                    c[n >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    c[w >> 2] = c[(c[n >> 2] | 0) + 28 >> 2];
	                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                    if ((c[w >> 2] | 0) != 0 ? (c[c[w >> 2] >> 2] | 0) != 0 : 0) {
	                        c[v >> 2] = bv(0) | 0;
	                        c[r >> 2] = 0;
	                        while (1) {
	                            if ((c[r >> 2] | 0) >= (c[c[w >> 2] >> 2] | 0))break;
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) + 28 >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = c[c[w >> 2] >> 2];
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = (c[r >> 2] | 0) + 1;
	                            if (c[u >> 2] | 0) {
	                                if ((dr(c[(c[u >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0) < 0)c[(c[g >> 2] | 0) + 8 >> 2] = 15
	                            } else c[u >> 2] = yt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            Tq(c[g >> 2] | 0, c[u >> 2] | 0) | 0;
	                            if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                                x = iu(c[g >> 2] | 0, (c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                                c[k >> 2] = (c[k >> 2] | 0) + x
	                            }
	                            if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                A = 52;
	                                break
	                            }
	                            c[m >> 2] = Sq(c[g >> 2] | 0) | 0;
	                            if (Ns(c[g >> 2] | 0, c[m >> 2] | 0) | 0) {
	                                x = c[v >> 2] | 0;
	                                cv(x, lt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) | 0)
	                            }
	                            if (c[m >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[u >> 2] | 0)) {
	                                Sq(c[g >> 2] | 0) | 0;
	                                su(c[(c[u >> 2] | 0) + 4 >> 2] | 0, 1)
	                            } else c[u >> 2] = 0;
	                            c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                            B = c[r >> 2] | 0;
	                            if ((c[c[v >> 2] >> 2] | 0) > 0) {
	                                A = 61;
	                                break
	                            }
	                            c[r >> 2] = B + 1
	                        }
	                        if ((A | 0) == 52) {
	                            Qq(c[n >> 2] | 0);
	                            c[f >> 2] = 0;
	                            z = c[f >> 2] | 0;
	                            i = e;
	                            return z | 0
	                        } else if ((A | 0) == 61)c[c[j >> 2] >> 2] = c[(c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + (B << 2) >> 2] | 0) + 28 >> 2];
	                        if (c[u >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[u >> 2] | 0);
	                        jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0);
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = -1;
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = -1;
	                        u = c[g >> 2] | 0;
	                        Tq(u, hv(c[v >> 2] | 0) | 0) | 0;
	                        c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                        c[f >> 2] = c[k >> 2];
	                        z = c[f >> 2] | 0;
	                        i = e;
	                        return z | 0
	                    }
	                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = 0;
	                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = 0;
	                    if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != -1) {
	                        p = iu(c[g >> 2] | 0, (c[(c[l >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) * 40 | 0) | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + p
	                    }
	                    c[m >> 2] = Sq(c[g >> 2] | 0) | 0;
	                    if (c[m >> 2] | 0)jt(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0);
	                    Tq(c[g >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        z = c[f >> 2] | 0;
	                        i = e;
	                        return z | 0
	                    } else {
	                        c[f >> 2] = c[k >> 2];
	                        z = c[f >> 2] | 0;
	                        i = e;
	                        return z | 0
	                    }
	                }
	                Nq(c[g >> 2] | 0, 11);
	                c[f >> 2] = 0;
	                z = c[f >> 2] | 0;
	                i = e;
	                return z | 0
	            }

	            function Du(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                Gu(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 43 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 45 : 0) {
	                        h = 30;
	                        break
	                    }
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 43)c[f >> 2] = 1; else c[f >> 2] = 0;
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = c[e >> 2] | 0;
	                        if (!j)break;
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[k >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    Gu(k);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        h = 30;
	                        break
	                    }
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 5, c[f >> 2] | 0, 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                if ((h | 0) == 30) {
	                    i = b;
	                    return
	                }
	            }

	            function Eu(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    it(0, 128632);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                if ((c[e >> 2] | 0) < 10)c[e >> 2] = 10;
	                a = Cb[c[135744 >> 2] & 511](c[e >> 2] << 2) | 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                    it(0, 128632);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    cU(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 0, c[e >> 2] << 2 | 0) | 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Fu(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[c[f >> 2] >> 2] | 0) <= 0) {
	                    i = e;
	                    return
	                }
	                if ((c[g >> 2] | 0) >= (c[c[f >> 2] >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                a:do if (c[h >> 2] | 0) {
	                    c[j >> 2] = c[g >> 2];
	                    while (1) {
	                        if ((c[j >> 2] | 0) >= (c[c[f >> 2] >> 2] | 0))break a;
	                        c[k >> 2] = c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                        if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 18 : 0)_q(c[k >> 2] | 0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                } while (0);
	                c[c[f >> 2] >> 2] = c[g >> 2];
	                i = e;
	                return
	            }

	            function Gu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                Hu(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 42) {
	                        if (((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 100 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 105 : 0) ? (d[(c[c[e >> 2] >> 2] | 0) + 2 >> 0] | 0 | 0) == 118 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 109) {
	                            h = 37;
	                            break b
	                        }
	                        if ((d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 111) {
	                            h = 37;
	                            break b
	                        }
	                        if ((d[(c[c[e >> 2] >> 2] | 0) + 2 >> 0] | 0 | 0) != 100) {
	                            h = 37;
	                            break b
	                        }
	                    } while (0);
	                    c[f >> 2] = -1;
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 42) {
	                        c[f >> 2] = 0;
	                        a = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1
	                    } else {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 100) {
	                            c[f >> 2] = 1;
	                            a = c[e >> 2] | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            break
	                        }
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 109) {
	                            c[f >> 2] = 2;
	                            a = c[e >> 2] | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3
	                        }
	                    } while (0);
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = c[e >> 2] | 0;
	                        if (!j)break;
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[k >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    Hu(k);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        h = 37;
	                        break
	                    }
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 6, c[f >> 2] | 0, 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                if ((h | 0) == 37) {
	                    i = b;
	                    return
	                }
	            }

	            function Hu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 45)break;
	                    c[f >> 2] = 1 - (c[f >> 2] | 0);
	                    c[g >> 2] = 1;
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                Iu(c[e >> 2] | 0);
	                if (!((c[g >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) == 0 : 0)) {
	                    i = b;
	                    return
	                }
	                g = c[(c[e >> 2] | 0) + 32 >> 2] | 0;
	                a = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    du(g, a, -1, 5, 2, 0, 0, 0, 0) | 0;
	                    i = b;
	                    return
	                } else {
	                    du(g, a, -1, 5, 3, 0, 0, 0, 0) | 0;
	                    i = b;
	                    return
	                }
	            }

	            function Iu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                Ju(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 124)break;
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, -1, -1, 9, 0, 0, 0, 0, 0) | 0;
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)g = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                g = 1;
	                                break
	                            }
	                            g = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        h = c[e >> 2] | 0;
	                        if (!g)break;
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[h >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    Ju(h);
	                    du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[f >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 7, 0, 0, 0, 0, 0) | 0;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                i = b;
	                return
	            }

	            function Ju(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 1;
	                c[g >> 2] = 0;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            j = 1;
	                            break
	                        }
	                        j = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    k = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!j)break;
	                    a = c[e >> 2] | 0;
	                    if (!k)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                do if ((k | 0) != 36 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 40 : 0) {
	                    if (48 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                        l = 18;
	                        break
	                    }
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 39 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 34 : 0) {
	                        if (((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46 ? 48 <= (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) : 0) ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0) {
	                            l = 18;
	                            break
	                        }
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 42) {
	                            c[f >> 2] = 1;
	                            break
	                        }
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47) {
	                            c[f >> 2] = 1;
	                            break
	                        }
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 64) {
	                            c[f >> 2] = 1;
	                            break
	                        }
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46) {
	                            c[f >> 2] = 1;
	                            break
	                        }
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)m = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    m = 1;
	                                    break
	                                }
	                                m = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            n = c[e >> 2] | 0;
	                            if (!m)break;
	                            j = c[e >> 2] | 0;
	                            if (!(d[c[n >> 2] >> 0] | 0))continue;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                        c[g >> 2] = Ku(n) | 0;
	                        if ((c[g >> 2] | 0) != 0 ? (wy(c[g >> 2] | 0, 130432) | 0) != 0 : 0) {
	                            c[f >> 2] = 1;
	                            zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                            break
	                        }
	                        if (!(c[g >> 2] | 0)) {
	                            Nq(c[e >> 2] | 0, 7);
	                            i = b;
	                            return
	                        }
	                        c[h >> 2] = xy(c[g >> 2] | 0) | 0;
	                        a:while (1) {
	                            if (!(d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0))break;
	                            if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) == 47) {
	                                l = 41;
	                                break
	                            }
	                            do if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) != 13) {
	                                    l = 46;
	                                    break a
	                                }
	                            } while (0);
	                            c[h >> 2] = (c[h >> 2] | 0) + 1
	                        }
	                        b:do if ((l | 0) == 41)c[f >> 2] = 1; else if ((l | 0) == 46) {
	                            if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) == 58) {
	                                c[f >> 2] = 1;
	                                break
	                            }
	                            if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) == 40)if (Ms(c[g >> 2] | 0) | 0) {
	                                c[f >> 2] = 1;
	                                break
	                            } else {
	                                c[f >> 2] = 0;
	                                break
	                            }
	                            if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) == 91) {
	                                c[f >> 2] = 1;
	                                break
	                            }
	                            do if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) != 60 ? (d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) != 62 : 0) {
	                                if ((d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0 | 0) == 61)break;
	                                c[f >> 2] = 1;
	                                break b
	                            } while (0);
	                            c[f >> 2] = 1
	                        } while (0);
	                        if (!(d[(c[c[e >> 2] >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0))c[f >> 2] = 1;
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0)
	                    } else l = 18
	                } else l = 18; while (0);
	                if ((l | 0) == 18)c[f >> 2] = 0;
	                l = c[e >> 2] | 0;
	                do if (!(c[f >> 2] | 0)) {
	                    Mu(l);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        i = b;
	                        return
	                    }
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        g = c[e >> 2] | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + 2;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    o = 1;
	                                    break
	                                }
	                                o = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            p = c[e >> 2] | 0;
	                            if (!o)break;
	                            g = c[e >> 2] | 0;
	                            if (!(d[c[p >> 2] >> 0] | 0))continue;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        du(c[p + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 11, 6, 1, 0, 0, 0) | 0;
	                        du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 10, 1, 0, 0, 0, 0) | 0;
	                        Nu(c[e >> 2] | 0);
	                        break
	                    }
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47)Nu(c[e >> 2] | 0)
	                } else {
	                    g = c[(c[e >> 2] | 0) + 32 >> 2] | 0;
	                    if ((d[c[l >> 2] >> 0] | 0 | 0) == 47)du(g, -1, -1, 8, 0, 0, 0, 0, 0) | 0; else du(g, -1, -1, 9, 0, 0, 0, 0, 0) | 0;
	                    Lu(c[e >> 2] | 0)
	                } while (0);
	                c:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break c
	                    } while (0);
	                    l = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                i = b;
	                return
	            }

	            function Ku(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[j >> 2] = c[c[e >> 2] >> 2];
	                c[h >> 2] = bu(c[e >> 2] | 0, g) | 0;
	                a:do if (!((c[h >> 2] | 0) == 32 | (c[h >> 2] | 0) == 62 | (c[h >> 2] | 0) == 47)) {
	                    a = c[h >> 2] | 0;
	                    if ((c[h >> 2] | 0) < 256) {
	                        if (((!(65 <= (a | 0) & (c[h >> 2] | 0) <= 90) ? !(97 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 122) : 0) ? !(192 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 214) : 0) ? !(216 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 246 | 248 <= (c[h >> 2] | 0)) : 0)l = 8
	                    } else if (!(DQ(a, 199744) | 0))l = 8;
	                    do if ((l | 0) == 8) {
	                        a = c[h >> 2] | 0;
	                        if ((c[h >> 2] | 0) < 256)if ((a | 0) != 95 & (c[h >> 2] | 0) != 58)break a; else break;
	                        if (!(19968 <= (a | 0) & (c[h >> 2] | 0) <= 40869 | (c[h >> 2] | 0) == 12295) ? (12321 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 12329 ^ 1) & (c[h >> 2] | 0) != 95 & (c[h >> 2] | 0) != 58 : 0)break a
	                    } while (0);
	                    b:while (1) {
	                        if (!((c[h >> 2] | 0) != 32 & (c[h >> 2] | 0) != 62 & (c[h >> 2] | 0) != 47))break;
	                        a = c[h >> 2] | 0;
	                        if ((c[h >> 2] | 0) < 256) {
	                            if (((!(65 <= (a | 0) & (c[h >> 2] | 0) <= 90) ? !(97 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 122) : 0) ? !(192 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 214) : 0) ? !(216 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 246 | 248 <= (c[h >> 2] | 0)) : 0)l = 20
	                        } else if (!(DQ(a, 199744) | 0))l = 20;
	                        do if ((l | 0) == 20) {
	                            l = 0;
	                            if ((c[h >> 2] | 0) >= 256) {
	                                if (19968 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 40869 | (c[h >> 2] | 0) == 12295)break;
	                                if (12321 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 12329)break
	                            }
	                            a = c[h >> 2] | 0;
	                            if ((c[h >> 2] | 0) < 256) {
	                                if (48 <= (a | 0) & (c[h >> 2] | 0) <= 57 | (c[h >> 2] | 0) == 46 | (c[h >> 2] | 0) == 45 | (c[h >> 2] | 0) == 95 | (c[h >> 2] | 0) == 58)break
	                            } else {
	                                m = (DQ(a, 200216) | 0) != 0;
	                                if (m | (c[h >> 2] | 0) == 46 | (c[h >> 2] | 0) == 45 | (c[h >> 2] | 0) == 95 | (c[h >> 2] | 0) == 58)break
	                            }
	                            if ((c[h >> 2] | 0) >= 256 ? (DQ(c[h >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                            m = c[h >> 2] | 0;
	                            if ((c[h >> 2] | 0) < 256)n = (m | 0) == 183 & 1; else n = DQ(m, 200272) | 0;
	                            if (!n)break b
	                        } while (0);
	                        c[f >> 2] = (c[f >> 2] | 0) + (c[g >> 2] | 0);
	                        m = c[e >> 2] | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + (c[g >> 2] | 0);
	                        c[h >> 2] = bu(c[e >> 2] | 0, g) | 0
	                    }
	                    c[k >> 2] = ly(c[j >> 2] | 0, (c[c[e >> 2] >> 2] | 0) - (c[j >> 2] | 0) | 0) | 0;
	                    c[c[e >> 2] >> 2] = c[j >> 2];
	                    c[d >> 2] = c[k >> 2];
	                    o = c[d >> 2] | 0;
	                    i = b;
	                    return o | 0
	                } while (0);
	                c[d >> 2] = 0;
	                o = c[d >> 2] | 0;
	                i = b;
	                return o | 0
	            }

	            function Lu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)f = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            f = 1;
	                            break
	                        }
	                        f = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    g = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!f)break;
	                    a = c[e >> 2] | 0;
	                    if (!g)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                if ((g | 0) != 47) {
	                    Nu(c[e >> 2] | 0);
	                    i = b;
	                    return
	                }
	                while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 47) {
	                        h = 44;
	                        break
	                    }
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        g = c[e >> 2] | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + 2;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    j = 1;
	                                    break
	                                }
	                                j = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            k = c[e >> 2] | 0;
	                            if (!j)break;
	                            g = c[e >> 2] | 0;
	                            if (!(d[c[k >> 2] >> 0] | 0))continue;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        du(c[k + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 11, 6, 1, 0, 0, 0) | 0;
	                        Nu(c[e >> 2] | 0)
	                    } else h = 23;
	                    a:do if ((h | 0) == 23 ? (h = 0, (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47) : 0) {
	                        g = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                l = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            m = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 0;
	                            if (!l)break;
	                            g = c[e >> 2] | 0;
	                            if (!m)continue;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        if (m) {
	                            if (!(65 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 90 : 0))h = 36;
	                            do if ((h | 0) == 36) {
	                                h = 0;
	                                if (97 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 122 : 0)break;
	                                if ((((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 95 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 46 : 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 64 : 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 42 : 0)break a
	                            } while (0);
	                            Nu(c[e >> 2] | 0)
	                        }
	                    } while (0);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        h = 44;
	                        break
	                    }
	                }
	                if ((h | 0) == 44) {
	                    i = b;
	                    return
	                }
	            }

	            function Mu(a) {
	                a = a | 0;
	                var b = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                Ou(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 91)break;
	                    Pu(c[e >> 2] | 0, 1);
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        a = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                }
	                i = b;
	                return
	            }

	            function Nu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)f = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            f = 1;
	                            break
	                        }
	                        f = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    g = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!f)break;
	                    a = c[e >> 2] | 0;
	                    if (!g)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                if ((g | 0) == 47 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                    g = c[e >> 2] | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 2;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)h = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                h = 1;
	                                break
	                            }
	                            h = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        j = c[e >> 2] | 0;
	                        if (!h)break;
	                        g = c[e >> 2] | 0;
	                        if (!(d[c[j >> 2] >> 0] | 0))continue;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    du(c[j + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 11, 6, 1, 0, 0, 0) | 0
	                } else k = 20;
	                a:do if ((k | 0) == 20 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47 : 0) {
	                    j = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        j = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                } while (0);
	                Qu(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                b:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                    } while (0);
	                    j = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                c:while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 47)break;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        j = c[e >> 2] | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 2;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                l = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            m = c[e >> 2] | 0;
	                            if (!l)break;
	                            j = c[e >> 2] | 0;
	                            if (!(d[c[m >> 2] >> 0] | 0))continue;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                        du(c[m + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 11, 6, 1, 0, 0, 0) | 0;
	                        Qu(c[e >> 2] | 0)
	                    } else k = 48;
	                    if ((k | 0) == 48 ? (k = 0, (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47) : 0) {
	                        j = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)n = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    n = 1;
	                                    break
	                                }
	                                n = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            o = c[e >> 2] | 0;
	                            if (!n)break;
	                            j = c[e >> 2] | 0;
	                            if (!(d[c[o >> 2] >> 0] | 0))continue;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                        Qu(o)
	                    }
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue c
	                        } while (0);
	                        j = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                }
	                i = b;
	                return
	            }

	            function Ou(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)f = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            f = 1;
	                            break
	                        }
	                        f = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    g = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!f)break;
	                    a = c[e >> 2] | 0;
	                    if (!g)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                f = c[e >> 2] | 0;
	                a:do if ((g | 0) == 36)Ru(f); else {
	                    a = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if ((d[c[f >> 2] >> 0] | 0 | 0) != 40) {
	                        if (!(48 <= (a | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 57 : 0))h = 34;
	                        do if ((h | 0) == 34) {
	                            if (((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46 ? 48 <= (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) : 0) ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 39 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 34 : 0) {
	                                Uu(c[e >> 2] | 0);
	                                break a
	                            }
	                            Tu(c[e >> 2] | 0);
	                            break a
	                        } while (0);
	                        Su(c[e >> 2] | 0);
	                        break
	                    }
	                    j = c[e >> 2] | 0;
	                    if (a)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)k = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                k = 1;
	                                break
	                            }
	                            k = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        l = c[e >> 2] | 0;
	                        if (!k)break;
	                        j = c[e >> 2] | 0;
	                        if (!(d[c[l >> 2] >> 0] | 0))continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    Jt(l, 1);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        i = b;
	                        return
	                    }
	                    a = c[e >> 2] | 0;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 41) {
	                        Nq(a, 7);
	                        i = b;
	                        return
	                    }
	                    j = c[e >> 2] | 0;
	                    if (d[c[a >> 2] >> 0] | 0)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        j = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                } while (0);
	                b:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                    } while (0);
	                    l = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                i = b;
	                return
	            }

	            function Pu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            j = 1;
	                            break
	                        }
	                        j = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    k = d[c[c[f >> 2] >> 2] >> 0] | 0;
	                    if (!j)break;
	                    b = c[f >> 2] | 0;
	                    if (!k)continue;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                j = c[f >> 2] | 0;
	                if ((k | 0) != 91) {
	                    Nq(j, 6);
	                    i = e;
	                    return
	                }
	                k = c[f >> 2] | 0;
	                if (d[c[j >> 2] >> 0] | 0)c[k >> 2] = (c[k >> 2] | 0) + 1;
	                while (1) {
	                    do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            l = 1;
	                            break
	                        }
	                        l = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    m = c[f >> 2] | 0;
	                    if (!l)break;
	                    k = c[f >> 2] | 0;
	                    if (!(d[c[m >> 2] >> 0] | 0))continue;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                c[(c[m + 32 >> 2] | 0) + 12 >> 2] = -1;
	                m = c[f >> 2] | 0;
	                if (c[g >> 2] | 0)Jt(m, 1); else Jt(m, 0);
	                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 93) {
	                    Nq(c[f >> 2] | 0, 6);
	                    i = e;
	                    return
	                }
	                m = c[(c[f >> 2] | 0) + 32 >> 2] | 0;
	                l = c[h >> 2] | 0;
	                h = c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0;
	                if (c[g >> 2] | 0)du(m, l, h, 17, 0, 0, 0, 0, 0) | 0; else du(m, l, h, 16, 0, 0, 0, 0, 0) | 0;
	                h = c[f >> 2] | 0;
	                if (d[c[c[f >> 2] >> 2] >> 0] | 0)c[h >> 2] = (c[h >> 2] | 0) + 1;
	                a:while (1) {
	                    do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    h = c[f >> 2] | 0;
	                    if (!(d[c[c[f >> 2] >> 2] >> 0] | 0))continue;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                i = e;
	                return
	            }

	            function Qu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b + 32 | 0;
	                f = b + 28 | 0;
	                g = b + 24 | 0;
	                h = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = -1;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            o = 1;
	                            break
	                        }
	                        o = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    p = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!o)break;
	                    a = c[e >> 2] | 0;
	                    if (!p)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                if ((p | 0) == 46 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 46 : 0) {
	                    p = c[e >> 2] | 0;
	                    c[p >> 2] = (c[p >> 2] | 0) + 2;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)q = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                q = 1;
	                                break
	                            }
	                            q = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        r = c[e >> 2] | 0;
	                        if (!q)break;
	                        p = c[e >> 2] | 0;
	                        if (!(d[c[r >> 2] >> 0] | 0))continue;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    du(c[r + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 11, 10, 1, 0, 0, 0) | 0;
	                    i = b;
	                    return
	                }
	                if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46) {
	                    r = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[r >> 2] = (c[r >> 2] | 0) + 1;
	                    a:while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        r = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                    i = b;
	                    return
	                }
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                if (((c[(c[e >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[h >> 2] = Ks(c[e >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) ? (qy(c[h >> 2] | 0, 130440) | 0) != 0 : 0) {
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)s = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                s = 1;
	                                break
	                            }
	                            s = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        t = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                        if (!s)break;
	                        r = c[e >> 2] | 0;
	                        if (!t)continue;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                    s = c[e >> 2] | 0;
	                    if ((t | 0) != 40) {
	                        Nq(s, 7);
	                        i = b;
	                        return
	                    }
	                    t = c[e >> 2] | 0;
	                    if (d[c[s >> 2] >> 0] | 0)c[t >> 2] = (c[t >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)u = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                u = 1;
	                                break
	                            }
	                            u = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        v = c[e >> 2] | 0;
	                        if (!u)break;
	                        t = c[e >> 2] | 0;
	                        if (!(d[c[v >> 2] >> 0] | 0))continue;
	                        c[t >> 2] = (c[t >> 2] | 0) + 1
	                    }
	                    Jt(v, 1);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        i = b;
	                        return
	                    }
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)w = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                w = 1;
	                                break
	                            }
	                            w = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        x = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                        if (!w)break;
	                        v = c[e >> 2] | 0;
	                        if (!x)continue;
	                        c[v >> 2] = (c[v >> 2] | 0) + 1
	                    }
	                    w = c[e >> 2] | 0;
	                    if ((x | 0) != 41) {
	                        Nq(w, 7);
	                        i = b;
	                        return
	                    }
	                    x = c[e >> 2] | 0;
	                    if (d[c[w >> 2] >> 0] | 0)c[x >> 2] = (c[x >> 2] | 0) + 1;
	                    c[f >> 2] = 1
	                } else {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 42)c[l >> 2] = 4; else {
	                        if (!(c[h >> 2] | 0))c[h >> 2] = Ks(c[e >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 64) {
	                                c[l >> 2] = 4;
	                                break
	                            }
	                            x = c[e >> 2] | 0;
	                            if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[x >> 2] = (c[x >> 2] | 0) + 1;
	                            c[l >> 2] = 3;
	                            break
	                        }
	                        c[l >> 2] = Vu(c[h >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[l >> 2] = 4;
	                            break
	                        }
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)y = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    y = 1;
	                                    break
	                                }
	                                y = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            z = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                            if (!y)break;
	                            x = c[e >> 2] | 0;
	                            if (!z)continue;
	                            c[x >> 2] = (c[x >> 2] | 0) + 1
	                        }
	                        if ((z | 0) == 58 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 58 : 0) {
	                            x = c[e >> 2] | 0;
	                            c[x >> 2] = (c[x >> 2] | 0) + 2;
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            c[h >> 2] = 0;
	                            break
	                        }
	                        c[l >> 2] = 4
	                    } while (0);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        i = b;
	                        return
	                    }
	                    c[h >> 2] = Wu(c[e >> 2] | 0, k, m, j, c[h >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 196 >> 2] & 1 | 0) != 0 : 0) ? (sr(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0) | 0) == 0 : 0)Nq(c[e >> 2] | 0, 19)
	                }
	                c[n >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] = -1;
	                b:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                    } while (0);
	                    z = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[z >> 2] = (c[z >> 2] | 0) + 1
	                }
	                while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 91)break;
	                    Pu(c[e >> 2] | 0, 0)
	                }
	                z = c[(c[e >> 2] | 0) + 32 >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    du(z, c[g >> 2] | 0, c[n >> 2] | 0, 19, 0, 0, 0, 0, 0) | 0;
	                    i = b;
	                    return
	                } else {
	                    du(z, c[n >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 11, c[l >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0) | 0;
	                    i = b;
	                    return
	                }
	            }

	            function Ru(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)h = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            h = 1;
	                            break
	                        }
	                        h = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    j = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!h)break;
	                    a = c[e >> 2] | 0;
	                    if (!j)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                h = c[e >> 2] | 0;
	                if ((j | 0) != 36) {
	                    Nq(h, 4);
	                    i = b;
	                    return
	                }
	                j = c[e >> 2] | 0;
	                if (d[c[h >> 2] >> 0] | 0)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                c[f >> 2] = Xu(c[e >> 2] | 0, g) | 0;
	                j = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Nq(j, 4);
	                    i = b;
	                    return
	                }
	                c[(c[j + 32 >> 2] | 0) + 12 >> 2] = -1;
	                du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 13, 0, 0, 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)k = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            k = 1;
	                            break
	                        }
	                        k = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    l = c[e >> 2] | 0;
	                    if (!k)break;
	                    g = c[e >> 2] | 0;
	                    if (!(d[c[l >> 2] >> 0] | 0))continue;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if (!(c[l + 12 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 196 >> 2] & 2)) {
	                    i = b;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 24);
	                i = b;
	                return
	            }

	            function Su(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0.0;
	                b = i;
	                i = i + 64 | 0;
	                e = b + 48 | 0;
	                f = b + 16 | 0;
	                g = b + 44 | 0;
	                j = b + 40 | 0;
	                k = b + 36 | 0;
	                l = b + 32 | 0;
	                m = b + 8 | 0;
	                n = b + 28 | 0;
	                o = b + 24 | 0;
	                p = b;
	                c[e >> 2] = a;
	                h[f >> 3] = 0.0;
	                c[g >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 46) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 57 : 0)break;
	                    Nq(c[e >> 2] | 0, 1);
	                    i = b;
	                    return
	                } while (0);
	                h[f >> 3] = 0.0;
	                while (1) {
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) < 48)break;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) > 57)break;
	                    h[f >> 3] = +h[f >> 3] * 10.0;
	                    c[l >> 2] = (d[c[c[e >> 2] >> 2] >> 0] | 0) - 48;
	                    c[g >> 2] = 1;
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    h[m >> 3] = +((c[l >> 2] | 0) >>> 0);
	                    h[f >> 3] = +h[f >> 3] + +h[m >> 3]
	                }
	                a:do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46) {
	                    c[o >> 2] = 0;
	                    h[p >> 3] = 0.0;
	                    m = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) < 48) {
	                        if (!(c[g >> 2] | 0))q = 18
	                    } else if (!((c[g >> 2] | 0) != 0 ? 1 : (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 57))q = 18;
	                    if ((q | 0) == 18) {
	                        Nq(c[e >> 2] | 0, 1);
	                        i = b;
	                        return
	                    }
	                    while (1) {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) < 48)break;
	                        if (!((c[o >> 2] | 0) < 20 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 57 : 0))break;
	                        c[n >> 2] = (d[c[c[e >> 2] >> 2] >> 0] | 0) - 48;
	                        h[p >> 3] = +h[p >> 3] * 10.0 + +(c[n >> 2] | 0);
	                        c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        m = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    h[p >> 3] = +h[p >> 3] / +h[129232 + (c[o >> 2] << 3) >> 3];
	                    h[f >> 3] = +h[f >> 3] + +h[p >> 3];
	                    while (1) {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) < 48)break a;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) > 57)break a;
	                        m = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                } while (0);
	                if (!((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 101 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 69 : 0)) {
	                    p = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[p >> 2] = (c[p >> 2] | 0) + 1;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 45) {
	                        c[k >> 2] = 1;
	                        p = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[p >> 2] = (c[p >> 2] | 0) + 1
	                    } else if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 43 ? (p = c[e >> 2] | 0, (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 0) : 0)c[p >> 2] = (c[p >> 2] | 0) + 1;
	                    while (1) {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) < 48)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) > 57)break;
	                        c[j >> 2] = ((c[j >> 2] | 0) * 10 | 0) + ((d[c[c[e >> 2] >> 2] >> 0] | 0) - 48);
	                        p = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    if (c[k >> 2] | 0)c[j >> 2] = 0 - (c[j >> 2] | 0);
	                    r = +T(10.0, +(+(c[j >> 2] | 0)));
	                    h[f >> 3] = +h[f >> 3] * r
	                }
	                j = c[(c[e >> 2] | 0) + 32 >> 2] | 0;
	                k = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0;
	                du(j, k, -1, 12, 3, 0, 0, wt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, +h[f >> 3]) | 0, 0) | 0;
	                i = b;
	                return
	            }

	            function Tu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                a = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 34) {
	                    h = c[e >> 2] | 0;
	                    if (a)c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[f >> 2] = c[c[e >> 2] >> 2];
	                    while (1) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)j = 9; else if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) : 0)k = 0; else j = 9;
	                        if ((j | 0) == 9) {
	                            j = 0;
	                            k = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 34
	                        }
	                        l = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                        if (!k)break;
	                        h = c[e >> 2] | 0;
	                        if (!l)continue;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    if (!(9 <= (l | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0))j = 15;
	                    if (((j | 0) == 15 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) : 0) {
	                        Nq(c[e >> 2] | 0, 2);
	                        i = b;
	                        return
	                    }
	                    c[g >> 2] = ly(c[f >> 2] | 0, (c[c[e >> 2] >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                    l = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[l >> 2] = (c[l >> 2] | 0) + 1
	                } else {
	                    l = c[e >> 2] | 0;
	                    if ((a | 0) != 39) {
	                        Nq(l, 3);
	                        i = b;
	                        return
	                    }
	                    a = c[e >> 2] | 0;
	                    if (d[c[l >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[f >> 2] = c[c[e >> 2] >> 2];
	                    while (1) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)j = 28; else if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) : 0)m = 0; else j = 28;
	                        if ((j | 0) == 28) {
	                            j = 0;
	                            m = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 39
	                        }
	                        n = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                        if (!m)break;
	                        a = c[e >> 2] | 0;
	                        if (!n)continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    if (!(9 <= (n | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0))j = 34;
	                    if (((j | 0) == 34 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) : 0) {
	                        Nq(c[e >> 2] | 0, 2);
	                        i = b;
	                        return
	                    }
	                    c[g >> 2] = ly(c[f >> 2] | 0, (c[c[e >> 2] >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                    f = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                if (!(c[g >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                f = c[(c[e >> 2] | 0) + 32 >> 2] | 0;
	                j = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0;
	                du(f, j, -1, 12, 4, 0, 0, Dt(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0) | 0, 0) | 0;
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                i = b;
	                return
	            }

	            function Uu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                c[h >> 2] = 0;
	                c[j >> 2] = 1;
	                c[f >> 2] = Xu(c[e >> 2] | 0, g) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    Nq(c[e >> 2] | 0, 7);
	                    i = b;
	                    return
	                }
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            l = 1;
	                            break
	                        }
	                        l = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    m = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!l)break;
	                    a = c[e >> 2] | 0;
	                    if (!m)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                l = c[e >> 2] | 0;
	                if ((m | 0) != 40) {
	                    Nq(l, 7);
	                    i = b;
	                    return
	                }
	                m = c[e >> 2] | 0;
	                if (d[c[l >> 2] >> 0] | 0)c[m >> 2] = (c[m >> 2] | 0) + 1;
	                a:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    m = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                if (((c[g >> 2] | 0) == 0 ? (d[c[f >> 2] >> 0] | 0 | 0) == 99 : 0) ? (qy(c[f >> 2] | 0, 129608) | 0) != 0 : 0)c[j >> 2] = 0;
	                c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] = -1;
	                b:do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 41) {
	                    c:while (1) {
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))break b;
	                        c[k >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2];
	                        c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] = -1;
	                        Jt(c[e >> 2] | 0, c[j >> 2] | 0);
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                            n = 27;
	                            break
	                        }
	                        du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[k >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, 15, 0, 0, 0, 0, 0) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 41)break b;
	                        o = c[e >> 2] | 0;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 44) {
	                            n = 30;
	                            break
	                        }
	                        m = c[e >> 2] | 0;
	                        if (d[c[o >> 2] >> 0] | 0)c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)continue c
	                            } while (0);
	                            m = c[e >> 2] | 0;
	                            if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        }
	                    }
	                    if ((n | 0) == 27) {
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        i = b;
	                        return
	                    } else if ((n | 0) == 30) {
	                        Nq(o, 7);
	                        i = b;
	                        return
	                    }
	                } while (0);
	                du(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0, -1, 14, c[h >> 2] | 0, 0, 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                g = c[e >> 2] | 0;
	                if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                d:while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break d
	                    } while (0);
	                    g = c[e >> 2] | 0;
	                    if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                i = b;
	                return
	            }

	            function Vu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                switch (d[c[e >> 2] >> 0] | 0 | 0) {
	                    case 110:
	                    {
	                        if (qy(c[e >> 2] | 0, 130600) | 0)c[f >> 2] = 9;
	                        break
	                    }
	                    case 115:
	                    {
	                        if (qy(c[e >> 2] | 0, 130664) | 0)c[f >> 2] = 13;
	                        break
	                    }
	                    case 97:
	                    {
	                        if (qy(c[e >> 2] | 0, 130456) | 0)c[f >> 2] = 1;
	                        if (qy(c[e >> 2] | 0, 130472) | 0)c[f >> 2] = 2;
	                        if (qy(c[e >> 2] | 0, 130496) | 0)c[f >> 2] = 3;
	                        break
	                    }
	                    case 99:
	                    {
	                        if (qy(c[e >> 2] | 0, 130512) | 0)c[f >> 2] = 4;
	                        break
	                    }
	                    case 102:
	                    {
	                        if (qy(c[e >> 2] | 0, 130560) | 0)c[f >> 2] = 7;
	                        if (qy(c[e >> 2] | 0, 130576) | 0)c[f >> 2] = 8;
	                        break
	                    }
	                    case 112:
	                    {
	                        if (qy(c[e >> 2] | 0, 130616) | 0)c[f >> 2] = 10;
	                        if (qy(c[e >> 2] | 0, 130624) | 0)c[f >> 2] = 11;
	                        if (qy(c[e >> 2] | 0, 130640) | 0)c[f >> 2] = 12;
	                        break
	                    }
	                    case 100:
	                    {
	                        if (qy(c[e >> 2] | 0, 130520) | 0)c[f >> 2] = 5;
	                        if (qy(c[e >> 2] | 0, 130536) | 0)c[f >> 2] = 6;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                i = b;
	                return c[f >> 2] | 0
	            }

	            function Wu(a, b, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if ((c[m >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0) {
	                    g = c[33976] | 0;
	                    f = c[33980] | 0;
	                    c[j >> 2] = 128552;
	                    c[j + 4 >> 2] = 11124;
	                    Db[g & 511](f, 129448, j);
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                c[c[n >> 2] >> 2] = 0;
	                c[c[m >> 2] >> 2] = 0;
	                c[c[o >> 2] >> 2] = 0;
	                a:while (1) {
	                    do if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    j = c[l >> 2] | 0;
	                    if (!(d[c[c[l >> 2] >> 2] >> 0] | 0))continue;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((c[p >> 2] | 0) == 0 ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) == 42 : 0) {
	                    j = c[l >> 2] | 0;
	                    if (d[c[c[l >> 2] >> 2] >> 0] | 0)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[c[m >> 2] >> 2] = 3;
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                if (!(c[p >> 2] | 0))c[p >> 2] = Ks(c[l >> 2] | 0) | 0;
	                j = c[l >> 2] | 0;
	                if (!(c[p >> 2] | 0)) {
	                    Nq(j, 7);
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                do if ((d[c[j >> 2] >> 0] | 0 | 0) == 32)s = 1; else {
	                    if (9 <= (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                        s = 1;
	                        break
	                    }
	                    s = (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) == 13
	                } while (0);
	                c[q >> 2] = s & 1;
	                while (1) {
	                    do if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) == 32)t = 1; else {
	                        if (9 <= (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            t = 1;
	                            break
	                        }
	                        t = (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    u = d[c[c[l >> 2] >> 2] >> 0] | 0;
	                    if (!t)break;
	                    s = c[l >> 2] | 0;
	                    if (!u)continue;
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                }
	                if ((u | 0) != 40) {
	                    c[c[m >> 2] >> 2] = 5;
	                    do if ((c[q >> 2] | 0) == 0 ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) == 58 : 0) {
	                        u = c[l >> 2] | 0;
	                        if (d[c[c[l >> 2] >> 2] >> 0] | 0)c[u >> 2] = (c[u >> 2] | 0) + 1;
	                        c[c[o >> 2] >> 2] = c[p >> 2];
	                        u = c[l >> 2] | 0;
	                        if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 42) {
	                            c[p >> 2] = Ks(u) | 0;
	                            if (c[p >> 2] | 0)break;
	                            Nq(c[l >> 2] | 0, 7);
	                            c[k >> 2] = 0;
	                            r = c[k >> 2] | 0;
	                            i = h;
	                            return r | 0
	                        }
	                        t = c[l >> 2] | 0;
	                        if (d[c[u >> 2] >> 0] | 0)c[t >> 2] = (c[t >> 2] | 0) + 1;
	                        c[c[m >> 2] >> 2] = 3;
	                        c[k >> 2] = 0;
	                        r = c[k >> 2] | 0;
	                        i = h;
	                        return r | 0
	                    } while (0);
	                    c[k >> 2] = c[p >> 2];
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                o = c[l >> 2] | 0;
	                if (d[c[c[l >> 2] >> 2] >> 0] | 0)c[o >> 2] = (c[o >> 2] | 0) + 1;
	                do if (qy(c[p >> 2] | 0, 129416) | 0)c[c[n >> 2] >> 2] = 8; else {
	                    if (qy(c[p >> 2] | 0, 129400) | 0) {
	                        c[c[n >> 2] >> 2] = 0;
	                        break
	                    }
	                    if (qy(c[p >> 2] | 0, 129424) | 0) {
	                        c[c[n >> 2] >> 2] = 7;
	                        break
	                    }
	                    if (qy(c[p >> 2] | 0, 129408) | 0) {
	                        c[c[n >> 2] >> 2] = 3;
	                        break
	                    }
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                    Nq(c[l >> 2] | 0, 7);
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                } while (0);
	                c[c[m >> 2] >> 2] = 1;
	                b:while (1) {
	                    do if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                    } while (0);
	                    o = c[l >> 2] | 0;
	                    if (!(d[c[c[l >> 2] >> 2] >> 0] | 0))continue;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                c:do if ((c[c[n >> 2] >> 2] | 0) == 7) {
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                    c[p >> 2] = 0;
	                    if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 41) {
	                        c[p >> 2] = Yu(c[l >> 2] | 0) | 0;
	                        if (c[(c[l >> 2] | 0) + 8 >> 2] | 0) {
	                            c[k >> 2] = 0;
	                            r = c[k >> 2] | 0;
	                            i = h;
	                            return r | 0
	                        }
	                        c[c[m >> 2] >> 2] = 2;
	                        while (1) {
	                            do if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 13)break c
	                            } while (0);
	                            o = c[l >> 2] | 0;
	                            if (!(d[c[c[l >> 2] >> 2] >> 0] | 0))continue;
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                    }
	                } while (0);
	                if ((d[c[c[l >> 2] >> 2] >> 0] | 0 | 0) != 41) {
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                    Nq(c[l >> 2] | 0, 8);
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                } else {
	                    m = c[l >> 2] | 0;
	                    if (d[c[c[l >> 2] >> 2] >> 0] | 0)c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[k >> 2] = c[p >> 2];
	                    r = c[k >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                return 0
	            }

	            function Xu(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[c[g >> 2] >> 2] = 0;
	                c[h >> 2] = Ks(c[f >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 58) {
	                    j = c[h >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                c[c[g >> 2] >> 2] = c[h >> 2];
	                g = c[f >> 2] | 0;
	                if (d[c[c[f >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                c[h >> 2] = Ks(c[f >> 2] | 0) | 0;
	                j = c[h >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function Yu(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                a = d[c[c[f >> 2] >> 2] >> 0] | 0;
	                if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 34) {
	                    j = c[f >> 2] | 0;
	                    if (a)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[g >> 2] = c[c[f >> 2] >> 2];
	                    while (1) {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)k = 9; else if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) : 0)l = 0; else k = 9;
	                        if ((k | 0) == 9) {
	                            k = 0;
	                            l = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 34
	                        }
	                        m = d[c[c[f >> 2] >> 2] >> 0] | 0;
	                        if (!l)break;
	                        j = c[f >> 2] | 0;
	                        if (!m)continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    if (!(9 <= (m | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0))k = 15;
	                    if (((k | 0) == 15 ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) : 0) {
	                        Nq(c[f >> 2] | 0, 2);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    c[h >> 2] = ly(c[g >> 2] | 0, (c[c[f >> 2] >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                    m = c[f >> 2] | 0;
	                    if (d[c[c[f >> 2] >> 2] >> 0] | 0)c[m >> 2] = (c[m >> 2] | 0) + 1
	                } else {
	                    m = c[f >> 2] | 0;
	                    if ((a | 0) != 39) {
	                        Nq(m, 3);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    a = c[f >> 2] | 0;
	                    if (d[c[m >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[g >> 2] = c[c[f >> 2] >> 2];
	                    while (1) {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)k = 28; else if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) : 0)o = 0; else k = 28;
	                        if ((k | 0) == 28) {
	                            k = 0;
	                            o = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 39
	                        }
	                        p = d[c[c[f >> 2] >> 2] >> 0] | 0;
	                        if (!o)break;
	                        a = c[f >> 2] | 0;
	                        if (!p)continue;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    if (!(9 <= (p | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0))k = 34;
	                    if (((k | 0) == 34 ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) : 0) {
	                        Nq(c[f >> 2] | 0, 2);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    c[h >> 2] = ly(c[g >> 2] | 0, (c[c[f >> 2] >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                    g = c[f >> 2] | 0;
	                    if (d[c[c[f >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                c[e >> 2] = c[h >> 2];
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function Zu(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                do if (c[h >> 2] | 0) {
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if ((c[j >> 2] | 0) < 0) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if ((c[l >> 2] | 0) < 0) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    c[m >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        mv(131920);
	                        c[g >> 2] = 0;
	                        break
	                    } else {
	                        e = (c[m >> 2] | 0) + 0 | 0;
	                        d = e + 48 | 0;
	                        do {
	                            c[e >> 2] = 0;
	                            e = e + 4 | 0
	                        } while ((e | 0) < (d | 0));
	                        c[c[m >> 2] >> 2] = 6;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                        c[(c[m >> 2] | 0) + 32 >> 2] = c[j >> 2];
	                        c[(c[m >> 2] | 0) + 36 >> 2] = c[k >> 2];
	                        c[(c[m >> 2] | 0) + 40 >> 2] = c[l >> 2];
	                        nv(c[m >> 2] | 0);
	                        c[g >> 2] = c[m >> 2];
	                        break
	                    }
	                } else c[g >> 2] = 0; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function _u(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    mv(131920);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = (c[h >> 2] | 0) + 0 | 0;
	                    a = b + 48 | 0;
	                    do {
	                        c[b >> 2] = 0;
	                        b = b + 4 | 0
	                    } while ((b | 0) < (a | 0));
	                    c[c[h >> 2] >> 2] = 6;
	                    c[(c[h >> 2] | 0) + 28 >> 2] = c[f >> 2];
	                    c[(c[h >> 2] | 0) + 32 >> 2] = -1;
	                    c[(c[h >> 2] | 0) + 36 >> 2] = c[g >> 2];
	                    c[(c[h >> 2] | 0) + 40 >> 2] = -1;
	                    nv(c[h >> 2] | 0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function $u(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    mv(131920);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 6;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = c[e >> 2];
	                    c[(c[f >> 2] | 0) + 32 >> 2] = -1;
	                    c[(c[f >> 2] | 0) + 36 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = -1;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function av(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                b = c[c[h >> 2] >> 2] | 0;
	                if ((b | 0) == 1)l = 6; else if (!((b | 0) == 6 | (b | 0) == 5)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((l | 0) == 6 ? (c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) <= 0 : 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    mv(131920);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                l = (c[j >> 2] | 0) + 0 | 0;
	                b = l + 48 | 0;
	                do {
	                    c[l >> 2] = 0;
	                    l = l + 4 | 0
	                } while ((l | 0) < (b | 0));
	                c[c[j >> 2] >> 2] = 6;
	                c[(c[j >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                c[(c[j >> 2] | 0) + 32 >> 2] = -1;
	                g = c[c[h >> 2] >> 2] | 0;
	                if ((g | 0) == 1) {
	                    c[(c[j >> 2] | 0) + 36 >> 2] = c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + ((c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) - 1 << 2) >> 2];
	                    c[(c[j >> 2] | 0) + 40 >> 2] = -1
	                } else if ((g | 0) == 5) {
	                    c[(c[j >> 2] | 0) + 36 >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                    c[(c[j >> 2] | 0) + 40 >> 2] = c[(c[h >> 2] | 0) + 32 >> 2]
	                } else if ((g | 0) == 6) {
	                    c[(c[j >> 2] | 0) + 36 >> 2] = c[(c[h >> 2] | 0) + 36 >> 2];
	                    c[(c[j >> 2] | 0) + 40 >> 2] = c[(c[h >> 2] | 0) + 40 >> 2]
	                } else {
	                    h = c[33976] | 0;
	                    g = c[33980] | 0;
	                    c[e >> 2] = 131976;
	                    c[e + 4 >> 2] = 590;
	                    Db[h & 511](g, 131944, e);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                nv(c[j >> 2] | 0);
	                c[f >> 2] = c[j >> 2];
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function bv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    mv(132e3);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                do if (c[e >> 2] | 0) {
	                    a = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a;
	                    if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                        a = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                        h = a + 40 | 0;
	                        do {
	                            c[a >> 2] = 0;
	                            a = a + 4 | 0
	                        } while ((a | 0) < (h | 0));
	                        c[(c[f >> 2] | 0) + 4 >> 2] = 10;
	                        a = c[e >> 2] | 0;
	                        h = c[f >> 2] | 0;
	                        j = c[h >> 2] | 0;
	                        c[h >> 2] = j + 1;
	                        c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (j << 2) >> 2] = a;
	                        break
	                    }
	                    mv(132e3);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } while (0);
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function cv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) >= (c[c[e >> 2] >> 2] | 0))break;
	                    if (ov(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0, c[f >> 2] | 0) | 0) {
	                        j = 5;
	                        break
	                    }
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if ((j | 0) == 5) {
	                    Qq(c[f >> 2] | 0);
	                    i = d;
	                    return
	                }
	                do if (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    if ((c[c[e >> 2] >> 2] | 0) == (c[(c[e >> 2] | 0) + 4 >> 2] | 0)) {
	                        j = (c[e >> 2] | 0) + 4 | 0;
	                        c[j >> 2] = c[j >> 2] << 1;
	                        c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 8 >> 2] | 0, c[(c[e >> 2] | 0) + 4 >> 2] << 2) | 0;
	                        if (c[h >> 2] | 0) {
	                            c[(c[e >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                            break
	                        }
	                        mv(132024);
	                        i = d;
	                        return
	                    }
	                } else {
	                    j = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[e >> 2] | 0) + 8 >> 2] = j;
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        j = (c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 0 | 0;
	                        g = j + 40 | 0;
	                        do {
	                            c[j >> 2] = 0;
	                            j = j + 4 | 0
	                        } while ((j | 0) < (g | 0));
	                        c[(c[e >> 2] | 0) + 4 >> 2] = 10;
	                        break
	                    }
	                    mv(132024);
	                    i = d;
	                    return
	                } while (0);
	                h = c[f >> 2] | 0;
	                f = c[e >> 2] | 0;
	                j = c[f >> 2] | 0;
	                c[f >> 2] = j + 1;
	                c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + (j << 2) >> 2] = h;
	                i = d;
	                return
	            }

	            function dv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = c[f >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    k = c[f >> 2] | 0;
	                    if ((c[h >> 2] | 0) >= (c[c[g >> 2] >> 2] | 0))break;
	                    cv(k, c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0);
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                c[e >> 2] = k;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function ev(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[c[d >> 2] >> 2] | 0))break;
	                        Qq(c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function fv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    mv(132e3);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 48 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[c[h >> 2] >> 2] = 7;
	                b = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    f = bv($u(b) | 0) | 0;
	                    c[(c[h >> 2] | 0) + 28 >> 2] = f
	                } else {
	                    f = bv(_u(b, c[g >> 2] | 0) | 0) | 0;
	                    c[(c[h >> 2] | 0) + 28 >> 2] = f
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function gv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    mv(132e3);
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                k = a + 48 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (k | 0));
	                c[c[f >> 2] >> 2] = 7;
	                if (c[e >> 2] | 0) {
	                    c[h >> 2] = bv(0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        c[d >> 2] = c[f >> 2];
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    c[g >> 2] = 0;
	                    while (1) {
	                        l = c[h >> 2] | 0;
	                        if ((c[g >> 2] | 0) >= (c[c[e >> 2] >> 2] | 0))break;
	                        cv(l, $u(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    c[(c[f >> 2] | 0) + 28 >> 2] = l
	                }
	                c[d >> 2] = c[f >> 2];
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function hv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    mv(132e3);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 48 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 7;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function iv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = Lr(c[g >> 2] | 0) | 0;
	                g = c[k >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = g;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[g + 76 >> 2] = 1;
	                    c[(c[k >> 2] | 0) + 80 >> 2] = c[h >> 2];
	                    c[(c[k >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                    jr(c[k >> 2] | 0, 132048, 306) | 0;
	                    jr(c[k >> 2] | 0, 132064, 307) | 0;
	                    jr(c[k >> 2] | 0, 132072, 308) | 0;
	                    jr(c[k >> 2] | 0, 132088, 309) | 0;
	                    jr(c[k >> 2] | 0, 132104, 310) | 0;
	                    jr(c[k >> 2] | 0, 132120, 311) | 0;
	                    jr(c[k >> 2] | 0, 132136, 312) | 0;
	                    jr(c[k >> 2] | 0, 132144, 313) | 0;
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function jv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 36 | 0;
	                f = d + 32 | 0;
	                g = d + 28 | 0;
	                h = d + 24 | 0;
	                j = d + 20 | 0;
	                k = d + 16 | 0;
	                l = d + 12 | 0;
	                m = d + 8 | 0;
	                n = d + 4 | 0;
	                o = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[m >> 2] = 0;
	                if ((c[e >> 2] | 0) == 0 | (c[e >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                if ((c[f + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                    c[k >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    c[n >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                    c[h >> 2] = c[c[e >> 2] >> 2];
	                    c[m >> 2] = bv(0) | 0;
	                    c[o >> 2] = 0;
	                    while (1) {
	                        if ((c[o >> 2] | 0) >= (c[c[n >> 2] >> 2] | 0))break;
	                        c[c[e >> 2] >> 2] = c[h >> 2];
	                        c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                        c[l >> 2] = gr(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        Tq(c[e >> 2] | 0, c[l >> 2] | 0) | 0;
	                        Qs(c[e >> 2] | 0);
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                            p = 20;
	                            break
	                        }
	                        c[j >> 2] = Sq(c[e >> 2] | 0) | 0;
	                        c[g >> 2] = av(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0, c[j >> 2] | 0) | 0;
	                        if (c[g >> 2] | 0)cv(c[m >> 2] | 0, c[g >> 2] | 0);
	                        if (c[j >> 2] | 0)Qq(c[j >> 2] | 0);
	                        if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) == (c[l >> 2] | 0)) {
	                            c[j >> 2] = Sq(c[e >> 2] | 0) | 0;
	                            Qq(c[j >> 2] | 0)
	                        }
	                        c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                        c[o >> 2] = (c[o >> 2] | 0) + 1
	                    }
	                    if ((p | 0) == 20) {
	                        i = d;
	                        return
	                    }
	                    Qq(c[k >> 2] | 0);
	                    c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = -1;
	                    c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    Tq(k, hv(c[m >> 2] | 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function kv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                Kq();
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                c[h >> 2] = Or(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                c[(c[h >> 2] | 0) + 36 >> 2] = 1;
	                wv(c[h >> 2] | 0);
	                if (((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0) ? (c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7 : 0)xv(c[h >> 2] | 0, 1902, 132152, 0); else c[j >> 2] = Sq(c[h >> 2] | 0) | 0;
	                do {
	                    c[k >> 2] = Sq(c[h >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0) {
	                        do if ((c[k >> 2] | 0) != (c[l >> 2] | 0)) {
	                            if ((c[c[k >> 2] >> 2] | 0) != 1) {
	                                c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                break
	                            }
	                            c[n >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                            if ((c[c[n >> 2] >> 2] | 0) == 1 ? (c[c[(c[n >> 2] | 0) + 8 >> 2] >> 2] | 0) == (c[c[g >> 2] >> 2] | 0) : 0)break;
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        } while (0);
	                        Qq(c[k >> 2] | 0)
	                    }
	                } while ((c[k >> 2] | 0) != 0);
	                if (c[m >> 2] | 0)xv(c[h >> 2] | 0, 1903, 132208, 0);
	                if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                    Qq(c[j >> 2] | 0);
	                    c[j >> 2] = 0
	                }
	                Pr(c[h >> 2] | 0);
	                c[e >> 2] = c[j >> 2];
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function lv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                a:while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        j = 4;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        j = 4;
	                        break
	                    }
	                    if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        if (c[h >> 2] | 0) {
	                            b = c[h >> 2] | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1;
	                            j = 17
	                        } else j = 17
	                    }
	                    b:while (1) {
	                        if ((j | 0) == 17) {
	                            j = 0;
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                j = 24;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                                j = 24;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 9) {
	                                j = 24;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                                j = 24;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 4) {
	                                j = 24;
	                                break a
	                            }
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 5)continue a;
	                            b = c[33976] | 0;
	                            a = c[33980] | 0;
	                            c[e >> 2] = 131976;
	                            c[e + 4 >> 2] = 2362;
	                            Db[b & 511](a, 132256, e)
	                        }
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            j = 17;
	                            continue
	                        }
	                        while (1) {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            if (c[h >> 2] | 0) {
	                                a = c[h >> 2] | 0;
	                                c[a >> 2] = (c[a >> 2] | 0) + -1
	                            }
	                            if (!(c[g >> 2] | 0)) {
	                                j = 13;
	                                break a
	                            }
	                            k = c[g >> 2] | 0;
	                            if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)break;
	                            if (!k) {
	                                j = 17;
	                                continue b
	                            }
	                        }
	                        c[g >> 2] = c[k + 24 >> 2];
	                        j = 17
	                    }
	                }
	                if ((j | 0) == 4) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((j | 0) == 13) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((j | 0) == 24) {
	                    c[f >> 2] = c[g >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function mv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                c[d >> 2] = c[e >> 2];
	                Xd(0, 0, 0, 0, 0, 13, 2, 2, 0, 0, a, 0, 0, 0, 0, 132472, d);
	                i = b;
	                return
	            }

	            function nv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[c[d >> 2] >> 2] | 0) != 6) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 36 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = yv(c[(c[d >> 2] | 0) + 28 >> 2] | 0, c[(c[d >> 2] | 0) + 32 >> 2] | 0, c[(c[d >> 2] | 0) + 36 >> 2] | 0, c[(c[d >> 2] | 0) + 40 >> 2] | 0) | 0;
	                if ((c[e >> 2] | 0) != -1) {
	                    i = b;
	                    return
	                }
	                c[f >> 2] = c[(c[d >> 2] | 0) + 28 >> 2];
	                c[(c[d >> 2] | 0) + 28 >> 2] = c[(c[d >> 2] | 0) + 36 >> 2];
	                c[(c[d >> 2] | 0) + 36 >> 2] = c[f >> 2];
	                c[e >> 2] = c[(c[d >> 2] | 0) + 32 >> 2];
	                c[(c[d >> 2] | 0) + 32 >> 2] = c[(c[d >> 2] | 0) + 40 >> 2];
	                c[(c[d >> 2] | 0) + 40 >> 2] = c[e >> 2];
	                i = b;
	                return
	            }

	            function ov(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) != (c[g >> 2] | 0)) {
	                    if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[c[f >> 2] >> 2] | 0) != (c[c[g >> 2] >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[c[f >> 2] >> 2] | 0) != 6) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 28 >> 2] | 0) != (c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 32 >> 2] | 0) != (c[(c[g >> 2] | 0) + 32 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != (c[(c[g >> 2] | 0) + 36 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != (c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                } else c[e >> 2] = 1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function pv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0)break;
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    do if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                        c[l >> 2] = gv(c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        Qq(c[h >> 2] | 0);
	                        if (c[l >> 2] | 0) {
	                            c[h >> 2] = c[l >> 2];
	                            break
	                        }
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    } while (0);
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                    c[k >> 2] = bv(0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        Qq(c[h >> 2] | 0);
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    }
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[c[j >> 2] >> 2] | 0))break;
	                        b = c[k >> 2] | 0;
	                        cv(b, zv(c[e >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    b = c[e >> 2] | 0;
	                    Tq(b, hv(c[k >> 2] | 0) | 0) | 0;
	                    Qq(c[h >> 2] | 0);
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function qv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0)break;
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    do if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                        c[l >> 2] = gv(c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        Qq(c[h >> 2] | 0);
	                        if (c[l >> 2] | 0) {
	                            c[h >> 2] = c[l >> 2];
	                            break
	                        }
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    } while (0);
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                    c[k >> 2] = bv(0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        Qq(c[h >> 2] | 0);
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    }
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[c[j >> 2] >> 2] | 0))break;
	                        b = c[k >> 2] | 0;
	                        cv(b, Av(c[e >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    b = c[e >> 2] | 0;
	                    Tq(b, hv(c[k >> 2] | 0) | 0) | 0;
	                    Qq(c[h >> 2] | 0);
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function rv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                e = i;
	                i = i + 96 | 0;
	                f = e + 80 | 0;
	                g = e + 76 | 0;
	                j = e + 72 | 0;
	                k = e + 68 | 0;
	                l = e + 64 | 0;
	                m = e + 60 | 0;
	                n = e + 56 | 0;
	                o = e + 52 | 0;
	                p = e + 48 | 0;
	                q = e + 44 | 0;
	                r = e + 40 | 0;
	                s = e + 36 | 0;
	                t = e + 32 | 0;
	                u = e + 28 | 0;
	                v = e + 24 | 0;
	                w = e + 20 | 0;
	                x = e + 16 | 0;
	                y = e + 12 | 0;
	                z = e + 8 | 0;
	                A = e + 4 | 0;
	                B = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[l >> 2] = 0;
	                c[o >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                c[x >> 2] = 0;
	                c[y >> 2] = 0;
	                if ((c[g >> 2] | 0) < 2 | (c[g >> 2] | 0) > 4) {
	                    Nq(c[f >> 2] | 0, 12);
	                    i = e;
	                    return
	                }
	                do if ((c[g >> 2] | 0) >= 4) {
	                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                        c[v >> 2] = Sq(c[f >> 2] | 0) | 0;
	                        if (!(c[v >> 2] | 0))break;
	                        c[y >> 2] = ~~+h[(c[v >> 2] | 0) + 16 >> 3];
	                        break
	                    }
	                    Nq(c[f >> 2] | 0, 11);
	                    i = e;
	                    return
	                } while (0);
	                do if ((c[g >> 2] | 0) >= 3) {
	                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 : 0) {
	                        c[u >> 2] = Sq(c[f >> 2] | 0) | 0;
	                        if (!(c[u >> 2] | 0))break;
	                        c[x >> 2] = ~~+h[(c[u >> 2] | 0) + 16 >> 3];
	                        break
	                    }
	                    Nq(c[f >> 2] | 0, 11);
	                    i = e;
	                    return
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 : 0) {
	                    c[t >> 2] = Sq(c[f >> 2] | 0) | 0;
	                    do if (c[(c[f >> 2] | 0) + 16 >> 2] | 0) {
	                        if ((c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7 ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0)break;
	                        c[q >> 2] = Sq(c[f >> 2] | 0) | 0;
	                        c[s >> 2] = bv(0) | 0;
	                        g = c[q >> 2] | 0;
	                        if (!(c[s >> 2] | 0)) {
	                            Qq(g);
	                            Nq(c[f >> 2] | 0, 15);
	                            i = e;
	                            return
	                        }
	                        a:do if (c[g + 4 >> 2] | 0) {
	                            do if ((c[c[q >> 2] >> 2] | 0) == 1) {
	                                c[z >> 2] = gv(c[(c[q >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                Qq(c[q >> 2] | 0);
	                                if (c[z >> 2] | 0) {
	                                    c[q >> 2] = c[z >> 2];
	                                    break
	                                }
	                                Nq(c[f >> 2] | 0, 15);
	                                i = e;
	                                return
	                            } while (0);
	                            c[r >> 2] = c[(c[q >> 2] | 0) + 28 >> 2];
	                            c[j >> 2] = 0;
	                            while (1) {
	                                if ((c[j >> 2] | 0) >= (c[c[r >> 2] >> 2] | 0))break a;
	                                Bv(c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0, n, k) | 0;
	                                Cv(c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0, o, l) | 0;
	                                Dv(n, k, 0) | 0;
	                                Ev(o, l) | 0;
	                                do {
	                                    c[p >> 2] = c[o >> 2];
	                                    c[m >> 2] = c[l >> 2];
	                                    c[w >> 2] = Fv(c[(c[t >> 2] | 0) + 24 >> 2] | 0, n, k, p, m) | 0;
	                                    if ((c[w >> 2] | 0) == 1) {
	                                        do if (c[u >> 2] | 0) {
	                                            if (Dv(n, k, (c[x >> 2] | 0) - 1 | 0) | 0)break;
	                                            if ((c[v >> 2] | 0) != 0 & (c[y >> 2] | 0) > 0) {
	                                                c[B >> 2] = c[n >> 2];
	                                                c[A >> 2] = (c[k >> 2] | 0) - 1;
	                                                if (Dv(B, A, c[y >> 2] | 0) | 0)break;
	                                                b = c[s >> 2] | 0;
	                                                cv(b, Zu(c[n >> 2] | 0, c[k >> 2] | 0, c[B >> 2] | 0, c[A >> 2] | 0) | 0);
	                                                break
	                                            }
	                                            b = c[s >> 2] | 0;
	                                            a = c[n >> 2] | 0;
	                                            C = c[k >> 2] | 0;
	                                            if ((c[v >> 2] | 0) != 0 & (c[y >> 2] | 0) <= 0) {
	                                                cv(b, Zu(a, C, c[n >> 2] | 0, c[k >> 2] | 0) | 0);
	                                                break
	                                            } else {
	                                                cv(b, Zu(a, C, c[p >> 2] | 0, c[m >> 2] | 0) | 0);
	                                                break
	                                            }
	                                        } else {
	                                            C = c[s >> 2] | 0;
	                                            cv(C, Zu(c[n >> 2] | 0, c[k >> 2] | 0, c[p >> 2] | 0, c[m >> 2] | 0) | 0)
	                                        } while (0);
	                                        c[n >> 2] = c[p >> 2];
	                                        c[k >> 2] = c[m >> 2];
	                                        if (!(d[c[(c[t >> 2] | 0) + 24 >> 2] >> 0] | 0))c[k >> 2] = (c[k >> 2] | 0) + 1
	                                    }
	                                } while ((c[w >> 2] | 0) == 1);
	                                c[j >> 2] = (c[j >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        g = c[f >> 2] | 0;
	                        Tq(g, hv(c[s >> 2] | 0) | 0) | 0;
	                        Qq(c[q >> 2] | 0);
	                        Qq(c[t >> 2] | 0);
	                        if (c[u >> 2] | 0)Qq(c[u >> 2] | 0);
	                        if (!(c[v >> 2] | 0)) {
	                            i = e;
	                            return
	                        }
	                        Qq(c[v >> 2] | 0);
	                        i = e;
	                        return
	                    } while (0);
	                    Nq(c[f >> 2] | 0, 11);
	                    i = e;
	                    return
	                }
	                Nq(c[f >> 2] | 0, 11);
	                i = e;
	                return
	            }

	            function sv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0)break;
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    do if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                        c[g >> 2] = gv(c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        Qq(c[h >> 2] | 0);
	                        if (c[g >> 2] | 0) {
	                            c[h >> 2] = c[g >> 2];
	                            break
	                        }
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    } while (0);
	                    c[k >> 2] = bv(0) | 0;
	                    b = c[h >> 2] | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        Qq(b);
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    }
	                    c[l >> 2] = c[b + 28 >> 2];
	                    a:do if (c[l >> 2] | 0) {
	                        c[m >> 2] = 0;
	                        while (1) {
	                            if ((c[m >> 2] | 0) >= (c[c[l >> 2] >> 2] | 0))break a;
	                            c[g >> 2] = c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                            if (c[g >> 2] | 0) {
	                                c[j >> 2] = 0;
	                                b = c[c[g >> 2] >> 2] | 0;
	                                if ((b | 0) == 5)c[j >> 2] = Gv(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0) | 0; else if ((b | 0) == 6 ? (c[n >> 2] = c[(c[g >> 2] | 0) + 28 >> 2], (c[n >> 2] | 0) != 0) : 0) {
	                                    if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 2)break;
	                                    c[j >> 2] = Gv(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0) | 0
	                                }
	                                if (c[j >> 2] | 0)cv(c[k >> 2] | 0, c[j >> 2] | 0)
	                            }
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        }
	                        Qq(c[h >> 2] | 0);
	                        ev(c[k >> 2] | 0);
	                        Nq(c[e >> 2] | 0, 16);
	                        i = d;
	                        return
	                    } while (0);
	                    Qq(c[h >> 2] | 0);
	                    b = c[e >> 2] | 0;
	                    Tq(b, hv(c[k >> 2] | 0) | 0) | 0;
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function tv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if ((c[f >> 2] | 0) != 1) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 1 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                do if (c[f + 16 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 7 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0)break;
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    do if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                        c[g >> 2] = gv(c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        Qq(c[h >> 2] | 0);
	                        if (c[g >> 2] | 0) {
	                            c[h >> 2] = c[g >> 2];
	                            break
	                        }
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    } while (0);
	                    c[k >> 2] = bv(0) | 0;
	                    b = c[h >> 2] | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        Qq(b);
	                        Nq(c[e >> 2] | 0, 15);
	                        i = d;
	                        return
	                    }
	                    c[l >> 2] = c[b + 28 >> 2];
	                    a:do if (c[l >> 2] | 0) {
	                        c[m >> 2] = 0;
	                        b:while (1) {
	                            if ((c[m >> 2] | 0) >= (c[c[l >> 2] >> 2] | 0))break a;
	                            c[g >> 2] = c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                            if (c[g >> 2] | 0) {
	                                c[j >> 2] = 0;
	                                b = c[c[g >> 2] >> 2] | 0;
	                                do if ((b | 0) == 6) {
	                                    c[n >> 2] = c[(c[g >> 2] | 0) + 36 >> 2];
	                                    if (c[n >> 2] | 0) {
	                                        if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 2)break b;
	                                        c[j >> 2] = Gv(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                        break
	                                    } else {
	                                        if (c[(c[g >> 2] | 0) + 28 >> 2] | 0)break;
	                                        a = c[n >> 2] | 0;
	                                        c[j >> 2] = Gv(a, Hv(c[n >> 2] | 0) | 0) | 0;
	                                        break
	                                    }
	                                } else if ((b | 0) == 5)c[j >> 2] = Gv(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0) | 0; while (0);
	                                if (c[j >> 2] | 0)cv(c[k >> 2] | 0, c[j >> 2] | 0)
	                            }
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        }
	                        Qq(c[h >> 2] | 0);
	                        ev(c[k >> 2] | 0);
	                        Nq(c[e >> 2] | 0, 16);
	                        i = d;
	                        return
	                    } while (0);
	                    Qq(c[h >> 2] | 0);
	                    b = c[e >> 2] | 0;
	                    Tq(b, hv(c[k >> 2] | 0) | 0) | 0;
	                    i = d;
	                    return
	                } while (0);
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function uv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 0 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (!(c[(c[f + 12 >> 2] | 0) + 80 >> 2] | 0)) {
	                    Nq(b, 16);
	                    i = d;
	                    return
	                } else {
	                    Tq(b, fv(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 80 >> 2] | 0, 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function vv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (c[f >> 2] | 0) {
	                    Nq(b, 12);
	                    i = d;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if ((c[b + 20 >> 2] | 0) < ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) + 0 | 0)) {
	                    Nq(f, 23);
	                    i = d;
	                    return
	                }
	                b = c[e >> 2] | 0;
	                if (!(c[(c[f + 12 >> 2] | 0) + 84 >> 2] | 0)) {
	                    Nq(b, 16);
	                    i = d;
	                    return
	                } else {
	                    Tq(b, fv(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 84 >> 2] | 0, 0) | 0) | 0;
	                    i = d;
	                    return
	                }
	            }

	            function wv(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                do if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                    a = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[e >> 2] | 0) + 28 >> 2] = a;
	                    if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                        c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 24 >> 2] = 10;
	                        c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                        break
	                    }
	                    mv(132312);
	                    i = b;
	                    return
	                } while (0);
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)g = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            g = 1;
	                            break
	                        }
	                        g = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    h = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!g)break;
	                    a = c[e >> 2] | 0;
	                    if (!h)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                g = c[e >> 2] | 0;
	                do if ((h | 0) == 47) {
	                    ks(g);
	                    Iv(c[e >> 2] | 0, 0)
	                } else {
	                    c[f >> 2] = Ls(g) | 0;
	                    a = c[e >> 2] | 0;
	                    if (!(c[f >> 2] | 0)) {
	                        Nq(a, 7);
	                        i = b;
	                        return
	                    }
	                    j = c[e >> 2] | 0;
	                    k = c[f >> 2] | 0;
	                    if ((d[c[a >> 2] >> 0] | 0 | 0) != 40) {
	                        Iv(j, k);
	                        break
	                    }
	                    Jv(j, k);
	                    i = b;
	                    return
	                } while (0);
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            l = 1;
	                            break
	                        }
	                        l = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    m = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 0;
	                    if (!l)break;
	                    f = c[e >> 2] | 0;
	                    if (!m)continue;
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                if (!m) {
	                    i = b;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 7);
	                i = b;
	                return
	            }

	            function xv(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 136 >> 2] = 13;
	                    c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 140 >> 2] = c[j >> 2];
	                    c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 148 >> 2] = 2;
	                    e = my(c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 160 >> 2] = e;
	                    c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 172 >> 2] = (c[c[h >> 2] >> 2] | 0) - (c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                    c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 184 >> 2] = c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 188 >> 2];
	                    e = c[(c[h >> 2] | 0) + 12 >> 2] | 0;
	                    if (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 132 >> 2] | 0) {
	                        Ab[c[e + 132 >> 2] & 511](c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 128 >> 2] | 0, (c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 136 | 0);
	                        i = f;
	                        return
	                    } else {
	                        d = c[e + 188 >> 2] | 0;
	                        e = c[j >> 2] | 0;
	                        b = c[l >> 2] | 0;
	                        a = c[(c[h >> 2] | 0) + 4 >> 2] | 0;
	                        m = (c[c[h >> 2] >> 2] | 0) - (c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        h = c[k >> 2] | 0;
	                        c[g >> 2] = c[l >> 2];
	                        Xd(0, 0, 0, 0, d, 13, e, 2, 0, 0, b, a, 0, m, 0, h, g);
	                        i = f;
	                        return
	                    }
	                }
	                h = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                m = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, 0, 0, 13, h, 2, 0, 0, j, 0, 0, 0, 0, m, g);
	                i = f;
	                return
	            }

	            function yv(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                do if (!((c[h >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0)) {
	                    if ((c[h >> 2] | 0) != (c[k >> 2] | 0)) {
	                        c[g >> 2] = Yq(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    if ((c[j >> 2] | 0) < (c[l >> 2] | 0)) {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                    if ((c[j >> 2] | 0) > (c[l >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    } else {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                } else c[g >> 2] = -2; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function zv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) != 0 : 0) {
	                    b = c[c[h >> 2] >> 2] | 0;
	                    if ((b | 0) == 6) {
	                        a = c[(c[h >> 2] | 0) + 28 >> 2] | 0;
	                        if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                            c[f >> 2] = Zu(a, c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[(c[h >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            l = c[f >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        c[j >> 2] = a;
	                        a = c[j >> 2] | 0;
	                        if ((c[j >> 2] | 0) == (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0)) {
	                            g = c[j >> 2] | 0;
	                            c[f >> 2] = Zu(a, 0, g, Lv(c[j >> 2] | 0) | 0) | 0;
	                            l = c[f >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        switch (c[a + 4 >> 2] | 0) {
	                            case 13:
	                            case 12:
	                            case 9:
	                            case 8:
	                            case 7:
	                            case 5:
	                            case 4:
	                            case 3:
	                            case 1:
	                            {
	                                c[k >> 2] = Mv(c[j >> 2] | 0) | 0;
	                                c[j >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                c[f >> 2] = Zu(c[j >> 2] | 0, (c[k >> 2] | 0) - 1 | 0, c[j >> 2] | 0, (c[k >> 2] | 0) + 1 | 0) | 0;
	                                l = c[f >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                            case 2:
	                            {
	                                c[f >> 2] = Zu(c[j >> 2] | 0, 0, c[j >> 2] | 0, Lv(c[j >> 2] | 0) | 0) | 0;
	                                l = c[f >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                            default:
	                            {
	                                c[f >> 2] = 0;
	                                l = c[f >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                        }
	                    } else if ((b | 0) == 5) {
	                        c[f >> 2] = Zu(c[(c[h >> 2] | 0) + 28 >> 2] | 0, c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[(c[h >> 2] | 0) + 28 >> 2] | 0, c[(c[h >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        l = c[f >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else {
	                        h = c[33976] | 0;
	                        b = c[33980] | 0;
	                        c[e >> 2] = 131976;
	                        c[e + 4 >> 2] = 2022;
	                        Db[h & 511](b, 132256, e);
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Av(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                a:do if (!(c[h >> 2] | 0))c[f >> 2] = 0; else {
	                    if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) != 0 : 0) {
	                        b = c[c[h >> 2] >> 2] | 0;
	                        if ((b | 0) == 5) {
	                            c[j >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                            switch (c[(c[j >> 2] | 0) + 4 >> 2] | 0) {
	                                case 4:
	                                case 3:
	                                case 8:
	                                case 7:
	                                {
	                                    a = c[j >> 2] | 0;
	                                    l = c[j >> 2] | 0;
	                                    if (!(c[(c[j >> 2] | 0) + 40 >> 2] | 0)) {
	                                        c[f >> 2] = Zu(a, 0, l, 0) | 0;
	                                        break a
	                                    } else {
	                                        c[f >> 2] = Zu(a, 0, l, xy(c[(c[j >> 2] | 0) + 40 >> 2] | 0) | 0) | 0;
	                                        break a
	                                    }
	                                    break
	                                }
	                                case 13:
	                                case 12:
	                                case 9:
	                                case 5:
	                                case 1:
	                                case 2:
	                                {
	                                    c[f >> 2] = Zu(c[j >> 2] | 0, 0, c[j >> 2] | 0, Lv(c[j >> 2] | 0) | 0) | 0;
	                                    break a;
	                                    break
	                                }
	                                default:
	                                {
	                                    c[f >> 2] = 0;
	                                    break a
	                                }
	                            }
	                        } else if ((b | 0) == 6) {
	                            c[k >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                            b = c[k >> 2] | 0;
	                            if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                                c[f >> 2] = Zu(b, c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[(c[h >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                break
	                            }
	                            switch (c[b + 4 >> 2] | 0) {
	                                case 13:
	                                case 12:
	                                case 9:
	                                case 5:
	                                case 1:
	                                case 2:
	                                {
	                                    c[f >> 2] = Zu(c[k >> 2] | 0, 0, c[k >> 2] | 0, Lv(c[k >> 2] | 0) | 0) | 0;
	                                    break a;
	                                    break
	                                }
	                                case 4:
	                                case 3:
	                                case 8:
	                                case 7:
	                                {
	                                    b = c[k >> 2] | 0;
	                                    l = c[k >> 2] | 0;
	                                    if (!(c[(c[k >> 2] | 0) + 40 >> 2] | 0)) {
	                                        c[f >> 2] = Zu(b, 0, l, 0) | 0;
	                                        break a
	                                    } else {
	                                        c[f >> 2] = Zu(b, 0, l, xy(c[(c[k >> 2] | 0) + 40 >> 2] | 0) | 0) | 0;
	                                        break a
	                                    }
	                                    break
	                                }
	                                default:
	                                {
	                                    c[f >> 2] = 0;
	                                    break a
	                                }
	                            }
	                        } else {
	                            l = c[33976] | 0;
	                            b = c[33980] | 0;
	                            c[e >> 2] = 131976;
	                            c[e + 4 >> 2] = 2167;
	                            Db[l & 511](b, 132256, e);
	                            c[f >> 2] = 0;
	                            break
	                        }
	                    }
	                    c[f >> 2] = 0
	                } while (0);
	                i = d;
	                return c[f >> 2] | 0
	            }

	            function Bv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                d = c[c[g >> 2] >> 2] | 0;
	                if ((d | 0) == 5) {
	                    c[c[h >> 2] >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) <= 0)c[c[j >> 2] >> 2] = 0; else c[c[j >> 2] >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((d | 0) == 6) {
	                    c[c[h >> 2] >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) <= 0)c[c[j >> 2] >> 2] = 0; else c[c[j >> 2] >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function Cv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                d = c[c[g >> 2] >> 2] | 0;
	                if ((d | 0) == 6) {
	                    c[c[h >> 2] >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) <= 0)c[c[j >> 2] >> 2] = 0; else c[c[j >> 2] >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((d | 0) == 5) {
	                    c[c[h >> 2] >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) <= 0)c[c[j >> 2] >> 2] = 0; else c[c[j >> 2] >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function Dv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    o = c[g >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[l >> 2] = c[c[h >> 2] >> 2];
	                if ((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[m >> 2] = c[c[j >> 2] >> 2];
	                    while (1) {
	                        if ((c[k >> 2] | 0) < 0) {
	                            p = 30;
	                            break
	                        }
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            if (((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 13 : 0)break;
	                            d = c[l >> 2] | 0;
	                            if ((c[m >> 2] | 0) > 0) {
	                                c[l >> 2] = Kv(d, c[m >> 2] | 0) | 0;
	                                c[m >> 2] = 0;
	                                continue
	                            } else {
	                                c[l >> 2] = lv(d, 0) | 0;
	                                c[m >> 2] = 0;
	                                continue
	                            }
	                        }
	                        if (!(c[l >> 2] | 0)) {
	                            p = 16;
	                            break
	                        }
	                        if (!(c[m >> 2] | 0))c[m >> 2] = 1;
	                        if (!(c[k >> 2] | 0)) {
	                            p = 20;
	                            break
	                        }
	                        c[n >> 2] = 0;
	                        if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[l >> 2] | 0) + 40 >> 2] | 0) != 0 : 0)c[n >> 2] = xy(c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) > (c[n >> 2] | 0)) {
	                            d = c[33976] | 0;
	                            b = c[33980] | 0;
	                            c[f >> 2] = 131976;
	                            c[f + 4 >> 2] = 2436;
	                            Db[d & 511](b, 131944, f);
	                            c[m >> 2] = c[n >> 2]
	                        }
	                        if (((c[m >> 2] | 0) + (c[k >> 2] | 0) | 0) < (c[n >> 2] | 0))if (((c[m >> 2] | 0) + (c[k >> 2] | 0) | 0) < (c[n >> 2] | 0)) {
	                            p = 29;
	                            break
	                        } else continue; else {
	                            c[k >> 2] = (c[k >> 2] | 0) - ((c[n >> 2] | 0) - (c[m >> 2] | 0));
	                            c[l >> 2] = lv(c[l >> 2] | 0, 0) | 0;
	                            c[m >> 2] = 0;
	                            continue
	                        }
	                    }
	                    if ((p | 0) == 16) {
	                        c[c[h >> 2] >> 2] = 0;
	                        c[c[j >> 2] >> 2] = 0;
	                        c[g >> 2] = -1;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 20) {
	                        c[c[h >> 2] >> 2] = c[l >> 2];
	                        c[c[j >> 2] >> 2] = c[m >> 2];
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 29) {
	                        c[m >> 2] = (c[m >> 2] | 0) + (c[k >> 2] | 0);
	                        c[c[h >> 2] >> 2] = c[l >> 2];
	                        c[c[j >> 2] >> 2] = c[m >> 2];
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 30) {
	                        c[g >> 2] = -1;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                }
	                c[g >> 2] = -1;
	                o = c[g >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Ev(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                if (((c[f >> 2] | 0) != 0 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) ? !((c[g >> 2] | 0) == 0 ? 1 : (c[(c[c[f >> 2] >> 2] | 0) + 4 >> 2] | 0) == 18) : 0) {
	                    c[h >> 2] = c[c[f >> 2] >> 2];
	                    c[j >> 2] = c[c[g >> 2] >> 2];
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) {
	                        if ((c[j >> 2] | 0) > 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 13 : 0)l = 9
	                    } else l = 8;
	                    if ((l | 0) == 8 ? (c[j >> 2] | 0) > 0 : 0)l = 9;
	                    if ((l | 0) == 9)c[h >> 2] = Kv(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break;
	                        m = c[h >> 2] | 0;
	                        if (!(c[(c[h >> 2] | 0) + 16 >> 2] | 0)) {
	                            l = 13;
	                            break
	                        }
	                        c[h >> 2] = c[m + 16 >> 2]
	                    }
	                    do if ((l | 0) == 13) {
	                        if ((c[m + 4 >> 2] | 0) != 1 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                            c[k >> 2] = xy(c[(c[h >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            break
	                        }
	                        c[e >> 2] = -1;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } while (0);
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } else {
	                        c[c[f >> 2] >> 2] = c[h >> 2];
	                        c[c[g >> 2] >> 2] = c[k >> 2];
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                }
	                c[e >> 2] = -1;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function Fv(b, e, f, g, h) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 36 | 0;
	                l = j + 32 | 0;
	                m = j + 28 | 0;
	                n = j + 24 | 0;
	                o = j + 20 | 0;
	                p = j + 16 | 0;
	                q = j + 12 | 0;
	                r = j + 8 | 0;
	                s = j + 4 | 0;
	                t = j;
	                u = j + 40 | 0;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = h;
	                if (!(c[l >> 2] | 0)) {
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                if (((c[m >> 2] | 0) != 0 ? (c[c[m >> 2] >> 2] | 0) != 0 : 0) ? !((c[n >> 2] | 0) == 0 ? 1 : (c[(c[c[m >> 2] >> 2] | 0) + 4 >> 2] | 0) == 18) : 0) {
	                    if ((c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                        c[k >> 2] = -1;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    }
	                    c[q >> 2] = c[c[m >> 2] >> 2];
	                    c[s >> 2] = (c[c[n >> 2] >> 2] | 0) - 1;
	                    a[u >> 0] = a[c[l >> 2] >> 0] | 0;
	                    a:while (1) {
	                        if (!(c[q >> 2] | 0)) {
	                            w = 28;
	                            break
	                        }
	                        b:do if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[q >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                            c[t >> 2] = xy(c[(c[q >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            while (1) {
	                                if ((c[s >> 2] | 0) > (c[t >> 2] | 0))break b;
	                                if (!(d[u >> 0] | 0)) {
	                                    w = 21;
	                                    break a
	                                }
	                                c[r >> 2] = vy((c[(c[q >> 2] | 0) + 40 >> 2] | 0) + (c[s >> 2] | 0) | 0, a[u >> 0] | 0) | 0;
	                                if (!(c[r >> 2] | 0)) {
	                                    c[s >> 2] = (c[t >> 2] | 0) + 1;
	                                    continue
	                                }
	                                c[s >> 2] = (c[r >> 2] | 0) - (c[(c[q >> 2] | 0) + 40 >> 2] | 0);
	                                if (Nv(c[l >> 2] | 0, c[q >> 2] | 0, (c[s >> 2] | 0) + 1 | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0) {
	                                    w = 18;
	                                    break a
	                                }
	                                c[s >> 2] = (c[s >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        if ((c[q >> 2] | 0) == (c[c[o >> 2] >> 2] | 0) ? (c[s >> 2] | 0) >= (c[c[p >> 2] >> 2] | 0) : 0) {
	                            w = 24;
	                            break
	                        }
	                        c[q >> 2] = lv(c[q >> 2] | 0, 0) | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            w = 26;
	                            break
	                        }
	                        c[s >> 2] = 1
	                    }
	                    if ((w | 0) == 18) {
	                        c[c[m >> 2] >> 2] = c[q >> 2];
	                        c[c[n >> 2] >> 2] = (c[s >> 2] | 0) + 1;
	                        c[k >> 2] = 1;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    } else if ((w | 0) == 21) {
	                        c[c[m >> 2] >> 2] = c[q >> 2];
	                        c[c[n >> 2] >> 2] = (c[s >> 2] | 0) + 1;
	                        c[c[o >> 2] >> 2] = c[q >> 2];
	                        c[c[p >> 2] >> 2] = (c[s >> 2] | 0) + 1;
	                        c[k >> 2] = 1;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    } else if ((w | 0) == 24) {
	                        c[k >> 2] = 0;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    } else if ((w | 0) == 26) {
	                        c[k >> 2] = 0;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    } else if ((w | 0) == 28) {
	                        c[k >> 2] = 0;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    }
	                }
	                c[k >> 2] = -1;
	                v = c[k >> 2] | 0;
	                i = j;
	                return v | 0
	            }

	            function Gv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[g >> 2] | 0) < 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    mv(132288);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = (c[h >> 2] | 0) + 0 | 0;
	                    a = b + 48 | 0;
	                    do {
	                        c[b >> 2] = 0;
	                        b = b + 4 | 0
	                    } while ((b | 0) < (a | 0));
	                    c[c[h >> 2] >> 2] = 5;
	                    c[(c[h >> 2] | 0) + 28 >> 2] = c[f >> 2];
	                    c[(c[h >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function Hv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a:do switch (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    case 1:
	                    case 9:
	                    case 13:
	                    {
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[e >> 2] | 0))break a;
	                            if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 1)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                            c[e >> 2] = c[(c[e >> 2] | 0) + 24 >> 2]
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = -1;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    case 5:
	                    case 4:
	                    case 3:
	                    case 8:
	                    case 7:
	                    {
	                        c[f >> 2] = xy(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        break
	                    }
	                    default:
	                    {
	                        c[d >> 2] = -1;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                } while (0);
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Iv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (((c[g >> 2] | 0) == 0 ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 47 : 0) ? (d[(c[c[f >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 49 : 0)xv(c[f >> 2] | 0, 1901, 132432, 0);
	                if ((c[g >> 2] | 0) != 0 ? (b = c[f >> 2] | 0, Tq(b, wr(c[g >> 2] | 0) | 0) | 0, zb[c[135736 >> 2] & 511](c[g >> 2] | 0), os(c[f >> 2] | 0, 1), (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                    i = e;
	                    return
	                }
	                while (1) {
	                    if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) != 47)break;
	                    c[h >> 2] = 0;
	                    g = c[f >> 2] | 0;
	                    if (d[c[c[f >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    while (1) {
	                        if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) < 48)break;
	                        if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) > 57)break;
	                        c[h >> 2] = ((c[h >> 2] | 0) * 10 | 0) + ((d[c[c[f >> 2] >> 2] >> 0] | 0) - 48);
	                        g = c[f >> 2] | 0;
	                        if (!(d[c[c[f >> 2] >> 2] >> 0] | 0))continue;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    Ov(c[f >> 2] | 0, c[h >> 2] | 0)
	                }
	                i = e;
	                return
	            }

	            function Jv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0))c[g >> 2] = Ls(c[f >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    Nq(c[f >> 2] | 0, 7);
	                    i = e;
	                    return
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        l = 25;
	                        break
	                    }
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    Pv(c[f >> 2] | 0, c[g >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 1900 : 0) {
	                        l = 25;
	                        break
	                    }
	                    if (c[(c[f >> 2] | 0) + 16 >> 2] | 0) {
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        b = c[c[h >> 2] >> 2] | 0;
	                        if ((b | 0) == 7) {
	                            c[j >> 2] = c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 28 >> 2];
	                            if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) > 0 : 0) {
	                                l = 25;
	                                break
	                            }
	                        } else if (((b | 0) == 1 ? (c[k >> 2] = c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2], (c[k >> 2] | 0) != 0) : 0) ? (c[c[k >> 2] >> 2] | 0) > 0 : 0) {
	                            l = 25;
	                            break
	                        }
	                        do {
	                            c[h >> 2] = Sq(c[f >> 2] | 0) | 0;
	                            if (c[h >> 2] | 0)Qq(c[h >> 2] | 0)
	                        } while ((c[h >> 2] | 0) != 0)
	                    }
	                    while (1) {
	                        do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 32)m = 1; else {
	                            if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                m = 1;
	                                break
	                            }
	                            m = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        n = c[f >> 2] | 0;
	                        if (!m)break;
	                        b = c[f >> 2] | 0;
	                        if (!(d[c[n >> 2] >> 0] | 0))continue;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1
	                    }
	                    c[g >> 2] = Ls(n) | 0
	                }
	                if ((l | 0) == 25) {
	                    i = e;
	                    return
	                }
	            }

	            function Kv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if ((c[h >> 2] | 0) > (c[g >> 2] | 0)) {
	                            j = 13;
	                            break
	                        }
	                        k = c[f >> 2] | 0;
	                        if (!(c[f >> 2] | 0)) {
	                            j = 7;
	                            break
	                        }
	                        if (!(((c[k + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 13 : 0))j = 11;
	                        if ((j | 0) == 11 ? (j = 0, c[h >> 2] = (c[h >> 2] | 0) + 1, (c[h >> 2] | 0) == (c[g >> 2] | 0)) : 0) {
	                            j = 13;
	                            break
	                        }
	                        c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                    }
	                    if ((j | 0) == 7) {
	                        c[e >> 2] = k;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else if ((j | 0) == 13) {
	                        c[e >> 2] = c[f >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[e >> 2] = c[f >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Lv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                    c[f >> 2] = 0;
	                    while (1) {
	                        if (!(c[e >> 2] | 0))break;
	                        if (!(((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 13 : 0))c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 24 >> 2]
	                    }
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = -1;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Mv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[f >> 2] = 1;
	                    while (1) {
	                        if (!(c[e >> 2] | 0))break;
	                        if (!(((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 13 : 0))c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 28 >> 2]
	                    }
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = -1;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Nv(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 44 | 0;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                t = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if (((c[m >> 2] | 0) != 0 ? (c[c[m >> 2] >> 2] | 0) != 0 : 0) ? !((c[n >> 2] | 0) == 0 ? 1 : (c[(c[c[m >> 2] >> 2] | 0) + 4 >> 2] | 0) == 18) : 0) {
	                        c[o >> 2] = c[k >> 2];
	                        c[p >> 2] = (c[l >> 2] | 0) - 1;
	                        c[r >> 2] = xy(c[j >> 2] | 0) | 0;
	                        while (1) {
	                            if ((c[r >> 2] | 0) <= 0) {
	                                v = 27;
	                                break
	                            }
	                            if ((c[o >> 2] | 0) == (c[c[m >> 2] >> 2] | 0) ? ((c[p >> 2] | 0) + (c[r >> 2] | 0) | 0) > (c[c[n >> 2] >> 2] | 0) : 0) {
	                                v = 14;
	                                break
	                            }
	                            if ((c[(c[o >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[o >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                                c[q >> 2] = xy(c[(c[o >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                if ((c[q >> 2] | 0) >= ((c[p >> 2] | 0) + (c[r >> 2] | 0) | 0)) {
	                                    v = 18;
	                                    break
	                                }
	                                c[t >> 2] = (c[q >> 2] | 0) - (c[p >> 2] | 0);
	                                c[s >> 2] = ((sy((c[(c[o >> 2] | 0) + 40 >> 2] | 0) + (c[p >> 2] | 0) | 0, c[j >> 2] | 0, c[t >> 2] | 0) | 0) != 0 ^ 1) & 1;
	                                if (!(c[s >> 2] | 0)) {
	                                    v = 23;
	                                    break
	                                }
	                                c[j >> 2] = (c[j >> 2] | 0) + (c[t >> 2] | 0);
	                                c[r >> 2] = (c[r >> 2] | 0) - (c[t >> 2] | 0)
	                            }
	                            c[o >> 2] = lv(c[o >> 2] | 0, 0) | 0;
	                            if (!(c[o >> 2] | 0)) {
	                                v = 25;
	                                break
	                            }
	                            c[p >> 2] = 0
	                        }
	                        if ((v | 0) == 14) {
	                            c[h >> 2] = 0;
	                            u = c[h >> 2] | 0;
	                            i = g;
	                            return u | 0
	                        } else if ((v | 0) == 18) {
	                            c[s >> 2] = ((sy((c[(c[o >> 2] | 0) + 40 >> 2] | 0) + (c[p >> 2] | 0) | 0, c[j >> 2] | 0, c[r >> 2] | 0) | 0) != 0 ^ 1) & 1;
	                            if (c[s >> 2] | 0) {
	                                c[c[m >> 2] >> 2] = c[o >> 2];
	                                c[c[n >> 2] >> 2] = (c[p >> 2] | 0) + (c[r >> 2] | 0);
	                                c[h >> 2] = 1;
	                                u = c[h >> 2] | 0;
	                                i = g;
	                                return u | 0
	                            } else {
	                                c[h >> 2] = 0;
	                                u = c[h >> 2] | 0;
	                                i = g;
	                                return u | 0
	                            }
	                        } else if ((v | 0) == 23) {
	                            c[h >> 2] = 0;
	                            u = c[h >> 2] | 0;
	                            i = g;
	                            return u | 0
	                        } else if ((v | 0) == 25) {
	                            c[h >> 2] = 0;
	                            u = c[h >> 2] | 0;
	                            i = g;
	                            return u | 0
	                        } else if ((v | 0) == 27) {
	                            c[h >> 2] = 1;
	                            u = c[h >> 2] | 0;
	                            i = g;
	                            return u | 0
	                        }
	                    }
	                    c[h >> 2] = -1;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                c[h >> 2] = -1;
	                u = c[h >> 2] | 0;
	                i = g;
	                return u | 0
	            }

	            function Ov(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 16 >> 2] >> 2] | 0) == 1 : 0) {
	                    c[h >> 2] = Sq(c[e >> 2] | 0) | 0;
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                    if (!((c[f >> 2] | 0) <= 0 | (c[j >> 2] | 0) == 0) ? (c[c[j >> 2] >> 2] | 0) == 1 : 0) {
	                        c[g >> 2] = Kv(c[c[(c[j >> 2] | 0) + 8 >> 2] >> 2] | 0, c[f >> 2] | 0) | 0;
	                        if (!(c[g >> 2] | 0)) {
	                            Qq(c[h >> 2] | 0);
	                            f = c[e >> 2] | 0;
	                            Tq(f, gr(0) | 0) | 0;
	                            i = d;
	                            return
	                        } else {
	                            c[c[(c[j >> 2] | 0) + 8 >> 2] >> 2] = c[g >> 2];
	                            Tq(c[e >> 2] | 0, c[h >> 2] | 0) | 0;
	                            i = d;
	                            return
	                        }
	                    }
	                    Qq(c[h >> 2] | 0);
	                    h = c[e >> 2] | 0;
	                    Tq(h, gr(0) | 0) | 0;
	                    i = d;
	                    return
	                }
	                Nq(c[e >> 2] | 0, 11);
	                i = d;
	                return
	            }

	            function Pv(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                h = f + 44 | 0;
	                j = f + 40 | 0;
	                k = f + 36 | 0;
	                l = f + 32 | 0;
	                m = f + 28 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 16 | 0;
	                q = f + 12 | 0;
	                r = f + 8 | 0;
	                s = f + 4 | 0;
	                t = f;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                if (!(c[h >> 2] | 0))c[h >> 2] = Ls(c[g >> 2] | 0) | 0;
	                e = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    Nq(e, 7);
	                    i = f;
	                    return
	                }
	                b = c[g >> 2] | 0;
	                if ((d[c[e >> 2] >> 0] | 0 | 0) != 40) {
	                    Nq(b, 7);
	                    i = f;
	                    return
	                }
	                e = c[g >> 2] | 0;
	                if (d[c[b >> 2] >> 0] | 0)c[e >> 2] = (c[e >> 2] | 0) + 1;
	                c[m >> 2] = 1;
	                c[l >> 2] = xy(c[c[g >> 2] >> 2] | 0) | 0;
	                c[l >> 2] = (c[l >> 2] | 0) + 1;
	                c[j >> 2] = Cb[c[135752 >> 2] & 511](c[l >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    mv(132344);
	                    i = f;
	                    return
	                }
	                c[k >> 2] = c[j >> 2];
	                a:while (1) {
	                    if (!(d[c[c[g >> 2] >> 2] >> 0] | 0))break;
	                    do if ((d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 41) {
	                        c[m >> 2] = (c[m >> 2] | 0) + -1;
	                        if (!(c[m >> 2] | 0)) {
	                            u = 15;
	                            break a
	                        }
	                    } else {
	                        if ((d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 40) {
	                            c[m >> 2] = (c[m >> 2] | 0) + 1;
	                            break
	                        }
	                        if ((d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 94) {
	                            if (((d[(c[c[g >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 41 ? (d[(c[c[g >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 40 : 0) ? (d[(c[c[g >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 94 : 0)break;
	                            l = c[g >> 2] | 0;
	                            if (d[c[c[g >> 2] >> 2] >> 0] | 0)c[l >> 2] = (c[l >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    l = a[c[c[g >> 2] >> 2] >> 0] | 0;
	                    e = c[k >> 2] | 0;
	                    c[k >> 2] = e + 1;
	                    a[e >> 0] = l;
	                    l = c[g >> 2] | 0;
	                    if (!(d[c[c[g >> 2] >> 2] >> 0] | 0))continue;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                if ((u | 0) == 15 ? (u = c[g >> 2] | 0, (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) != 0) : 0)c[u >> 2] = (c[u >> 2] | 0) + 1;
	                a[c[k >> 2] >> 0] = 0;
	                if ((c[m >> 2] | 0) != 0 ? (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 0 : 0) {
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    Nq(c[g >> 2] | 0, 16);
	                    i = f;
	                    return
	                }
	                do if (qy(c[h >> 2] | 0, 132368) | 0) {
	                    c[n >> 2] = c[c[g >> 2] >> 2];
	                    c[c[g >> 2] >> 2] = c[j >> 2];
	                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2];
	                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 72 >> 2] = 1;
	                    c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] = 1;
	                    Qs(c[g >> 2] | 0);
	                    c[c[g >> 2] >> 2] = c[n >> 2]
	                } else {
	                    if (qy(c[h >> 2] | 0, 132384) | 0) {
	                        c[o >> 2] = c[c[g >> 2] >> 2];
	                        c[c[g >> 2] >> 2] = c[j >> 2];
	                        m = c[g >> 2] | 0;
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) == 47) {
	                            ks(m);
	                            Iv(c[g >> 2] | 0, 0)
	                        } else {
	                            c[p >> 2] = Ls(m) | 0;
	                            if (c[p >> 2] | 0) {
	                                Iv(c[g >> 2] | 0, c[p >> 2] | 0);
	                                break
	                            }
	                            c[c[g >> 2] >> 2] = c[o >> 2];
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            Nq(c[g >> 2] | 0, 7);
	                            i = f;
	                            return
	                        } while (0);
	                        c[c[g >> 2] >> 2] = c[o >> 2];
	                        break
	                    }
	                    m = (qy(c[h >> 2] | 0, 132392) | 0) != 0;
	                    k = c[g >> 2] | 0;
	                    if (!m) {
	                        xv(k, 1900, 132400, c[h >> 2] | 0);
	                        break
	                    }
	                    c[q >> 2] = c[k >> 2];
	                    c[c[g >> 2] >> 2] = c[j >> 2];
	                    c[r >> 2] = Ks(c[g >> 2] | 0) | 0;
	                    if (!(c[r >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        Nq(c[g >> 2] | 0, 16);
	                        i = f;
	                        return
	                    }
	                    while (1) {
	                        do if ((d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 32)v = 1; else {
	                            if (9 <= (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                v = 1;
	                                break
	                            }
	                            v = (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        w = d[c[c[g >> 2] >> 2] >> 0] | 0;
	                        if (!v)break;
	                        k = c[g >> 2] | 0;
	                        if (!w)continue;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((w | 0) != 61) {
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        Nq(c[g >> 2] | 0, 16);
	                        i = f;
	                        return
	                    }
	                    k = c[g >> 2] | 0;
	                    if (d[c[c[g >> 2] >> 2] >> 0] | 0)c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 32)x = 1; else {
	                            if (9 <= (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                x = 1;
	                                break
	                            }
	                            x = (d[c[c[g >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        y = c[c[g >> 2] >> 2] | 0;
	                        if (!x)break;
	                        k = c[g >> 2] | 0;
	                        if (!(d[y >> 0] | 0))continue;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    c[t >> 2] = yl(y) | 0;
	                    if (!(c[t >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        Nq(c[g >> 2] | 0, 16);
	                        i = f;
	                        return
	                    }
	                    c[s >> 2] = Cl(c[t >> 2] | 0) | 0;
	                    Al(c[t >> 2] | 0);
	                    if (c[s >> 2] | 0) {
	                        rr(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0) | 0;
	                        c[c[g >> 2] >> 2] = c[q >> 2];
	                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    Nq(c[g >> 2] | 0, 15);
	                    i = f;
	                    return
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                i = f;
	                return
	            }

	            function Qv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](72) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Xv(0, c[e >> 2] | 0, 132504);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 72 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = c[e >> 2];
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 52 >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Rv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                while (1) {
	                    f = c[d >> 2] | 0;
	                    if ((c[(c[d >> 2] | 0) + 40 >> 2] | 0) <= 0)break;
	                    Yv(f)
	                }
	                if (c[f + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 8 >> 2] | 0))break;
	                    if (c[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0)Zv(c[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                a:do if (c[(c[d >> 2] | 0) + 32 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 20 >> 2] | 0))break a;
	                        if (c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                } while (0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Sv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 60 >> 2] = c[g >> 2];
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function Tv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = Qv(c[(c[g >> 2] | 0) + 32 >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                    c[(c[k >> 2] | 0) + 68 >> 2] = c[j >> 2];
	                    j = my(c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 64 >> 2] = j;
	                    Sv(c[k >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[l >> 2] = _v(c[k >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[l >> 2] | 0) >= 0 ? (c[(c[k >> 2] | 0) + 52 >> 2] | 0) > 0 : 0)c[l >> 2] = -1;
	                    Rv(c[k >> 2] | 0);
	                    c[f >> 2] = c[l >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[f >> 2] = -1;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Uv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Pi(c[g >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = Tv(c[k >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Vv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = Uv(c[e >> 2] | 0, c[f >> 2] | 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function Wv(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) ? !((c[f >> 2] | 0) == 0 ? 1 : (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0) : 0) {
	                    c[h >> 2] = _v(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[h >> 2] | 0) >= 0 ? (c[(c[f >> 2] | 0) + 52 >> 2] | 0) > 0 : 0)c[h >> 2] = -1;
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = -1;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Xv(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (c[g >> 2] | 0) {
	                    d = (c[g >> 2] | 0) + 52 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1
	                }
	                d = c[g >> 2] | 0;
	                g = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(0, 0, 0, d, g, 11, 2, 2, 0, 0, h, 0, 0, 0, 0, 133840, f);
	                i = e;
	                return
	            }

	            function Yv(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if ((c[(c[d >> 2] | 0) + 40 >> 2] | 0) <= 0) {
	                    i = b;
	                    return
	                }
	                a = (c[d >> 2] | 0) + 40 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[d >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 40 >> 2] | 0) > 0)c[(c[d >> 2] | 0) + 36 >> 2] = c[(c[(c[d >> 2] | 0) + 48 >> 2] | 0) + ((c[a + 40 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 36 >> 2] = 0;
	                c[e >> 2] = c[(c[(c[d >> 2] | 0) + 48 >> 2] | 0) + (c[(c[d >> 2] | 0) + 40 >> 2] << 2) >> 2];
	                c[(c[(c[d >> 2] | 0) + 48 >> 2] | 0) + (c[(c[d >> 2] | 0) + 40 >> 2] << 2) >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function Zv(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)Qq(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function _v(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if (!((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 72 >> 2] | 0) != 0 ? (c[l >> 2] = $v(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 72 >> 2] | 0) | 0, (c[l >> 2] | 0) < 0) : 0) {
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    c[n >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    c[k >> 2] = c[j >> 2];
	                    if ((aw(c[g >> 2] | 0, c[k >> 2] | 0) | 0) == 1)bw(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                    a:while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        if ((c[k >> 2] | 0) == (c[(c[j >> 2] | 0) + 20 >> 2] | 0))break;
	                        if ((((c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) ? (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) {
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                            if (!(aw(c[g >> 2] | 0, c[k >> 2] | 0) | 0))continue;
	                            bw(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            continue
	                        }
	                        d = c[k >> 2] | 0;
	                        if (c[(c[k >> 2] | 0) + 24 >> 2] | 0) {
	                            c[k >> 2] = c[d + 24 >> 2];
	                            if (!(aw(c[g >> 2] | 0, c[k >> 2] | 0) | 0))continue;
	                            bw(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            continue
	                        }
	                        if ((d | 0) == (c[j >> 2] | 0))break;
	                        while (1) {
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                            if (!(c[k >> 2] | 0))continue a;
	                            if ((c[k >> 2] | 0) == (c[(c[j >> 2] | 0) + 20 >> 2] | 0))continue a;
	                            p = c[k >> 2] | 0;
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] | 0)break;
	                            if (!p)continue a
	                        }
	                        c[k >> 2] = c[p + 24 >> 2];
	                        if (!(aw(c[g >> 2] | 0, c[k >> 2] | 0) | 0))continue;
	                        bw(c[g >> 2] | 0, c[k >> 2] | 0) | 0
	                    }
	                    c[m >> 2] = c[n >> 2];
	                    while (1) {
	                        q = c[g >> 2] | 0;
	                        if ((c[m >> 2] | 0) >= (c[(c[g >> 2] | 0) + 8 >> 2] | 0))break;
	                        cw(q, c[m >> 2] | 0) | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    c[m >> 2] = c[q + 4 >> 2];
	                    while (1) {
	                        if ((c[m >> 2] | 0) >= (c[(c[g >> 2] | 0) + 8 >> 2] | 0))break;
	                        if (!(((c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) ? (c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 32 >> 2] | 0) == 0 : 0))dw(c[g >> 2] | 0, c[m >> 2] | 0) | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    if (c[(c[h >> 2] | 0) + 72 >> 2] | 0)Yv(c[g >> 2] | 0);
	                    c[f >> 2] = c[l >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[f >> 2] = -1;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function $v(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[f >> 2] | 0;
	                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) > 40) {
	                    ew(b, 0, 1600, 133640, c[g >> 2] | 0);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[b + 48 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 44 >> 2] = 4, c[(c[f >> 2] | 0) + 40 >> 2] = 0, b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 44 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 48 >> 2] = b, (c[(c[f >> 2] | 0) + 48 >> 2] | 0) == 0) : 0) {
	                    Xv(c[f >> 2] | 0, 0, 133824);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 44 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 44 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 48 >> 2] | 0, c[(c[f >> 2] | 0) + 44 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 48 >> 2] = b, (c[(c[f >> 2] | 0) + 48 >> 2] | 0) == 0) : 0) {
	                    Xv(c[f >> 2] | 0, 0, 133824);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                b = my(c[g >> 2] | 0) | 0;
	                c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + (c[(c[f >> 2] | 0) + 40 >> 2] << 2) >> 2] = b;
	                c[(c[f >> 2] | 0) + 36 >> 2] = b;
	                b = (c[f >> 2] | 0) + 40 | 0;
	                f = c[b >> 2] | 0;
	                c[b >> 2] = f + 1;
	                c[e >> 2] = f;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function aw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (!((qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132728) | 0) == 0 ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132760) | 0) == 0 : 0))l = 9;
	                a:do if ((l | 0) == 9) {
	                    if ((qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132760) | 0) != 0 ? (c[(c[f >> 2] | 0) + 56 >> 2] | 0) == 0 : 0)c[(c[f >> 2] | 0) + 56 >> 2] = 1;
	                    b = (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 133704) | 0) != 0;
	                    a = c[g >> 2] | 0;
	                    if (!b) {
	                        if (!(qy(c[a + 8 >> 2] | 0, 132712) | 0))break;
	                        do if (((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            if ((qy(c[(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132728) | 0) == 0 ? (qy(c[(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132760) | 0) == 0 : 0)break;
	                            if (qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 133704) | 0)break a
	                        } while (0);
	                        ew(c[f >> 2] | 0, c[g >> 2] | 0, 1616, 133784, 132712);
	                        break
	                    }
	                    c[h >> 2] = c[a + 12 >> 2];
	                    c[j >> 2] = 0;
	                    b:while (1) {
	                        if (!(c[h >> 2] | 0))break;
	                        do if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            if ((qy(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132728) | 0) == 0 ? (qy(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132760) | 0) == 0 : 0)break;
	                            if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 133704) | 0) {
	                                l = 20;
	                                break b
	                            }
	                            if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 132712) | 0)c[j >> 2] = (c[j >> 2] | 0) + 1
	                        } while (0);
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2]
	                    }
	                    if ((l | 0) == 20) {
	                        ew(c[f >> 2] | 0, c[g >> 2] | 0, 1614, 133712, 133704);
	                        c[e >> 2] = 0;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    if ((c[j >> 2] | 0) > 1) {
	                        ew(c[f >> 2] | 0, c[g >> 2] | 0, 1615, 133744, 133704);
	                        c[e >> 2] = 0;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    } else {
	                        c[e >> 2] = 1;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                } while (0);
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function bw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                fw(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return 0
	            }

	            function cw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 52 | 0;
	                f = d + 48 | 0;
	                g = d + 44 | 0;
	                h = d + 40 | 0;
	                j = d + 36 | 0;
	                k = d + 32 | 0;
	                l = d + 28 | 0;
	                m = d + 24 | 0;
	                n = d + 20 | 0;
	                o = d + 16 | 0;
	                p = d + 12 | 0;
	                q = d + 8 | 0;
	                r = d + 4 | 0;
	                s = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[o >> 2] = 1;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[g >> 2] | 0) >= 0 ? (c[g >> 2] | 0) < (c[(c[f >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                    c[h >> 2] = c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2];
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    c[j >> 2] = gw(c[f >> 2] | 0, c[h >> 2] | 0, 132616) | 0;
	                    if ((c[j >> 2] | 0) == 0 ? (c[j >> 2] = my(132624) | 0, (c[j >> 2] | 0) == 0) : 0) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    c[k >> 2] = gw(c[f >> 2] | 0, c[h >> 2] | 0, 132632) | 0;
	                    do if (c[k >> 2] | 0) {
	                        if (qy(c[k >> 2] | 0, 132640) | 0) {
	                            c[o >> 2] = 1;
	                            break
	                        }
	                        if (qy(c[k >> 2] | 0, 132648) | 0) {
	                            c[o >> 2] = 0;
	                            break
	                        }
	                        ew(c[f >> 2] | 0, c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1601, 132656, c[k >> 2] | 0);
	                        if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    } while (0);
	                    c[l >> 2] = Xi(c[c[f >> 2] >> 2] | 0, c[h >> 2] | 0) | 0;
	                    b = c[j >> 2] | 0;
	                    if (!(c[l >> 2] | 0))c[n >> 2] = Hl(b, c[(c[c[f >> 2] >> 2] | 0) + 72 >> 2] | 0) | 0; else c[n >> 2] = Hl(b, c[l >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[q >> 2] = Gl(c[l >> 2] | 0) | 0;
	                        c[r >> 2] = Gl(c[j >> 2] | 0) | 0;
	                        c[n >> 2] = Hl(c[r >> 2] | 0, c[q >> 2] | 0) | 0;
	                        if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0)
	                    }
	                    r = c[f >> 2] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        ew(r, c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 132688, 0);
	                        if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    c[m >> 2] = c[r + 64 >> 2];
	                    c[(c[f >> 2] | 0) + 64 >> 2] = c[l >> 2];
	                    r = c[f >> 2] | 0;
	                    q = c[n >> 2] | 0;
	                    b = c[g >> 2] | 0;
	                    if (c[o >> 2] | 0)c[p >> 2] = hw(r, q, b) | 0; else c[p >> 2] = iw(r, q, b) | 0;
	                    c[(c[f >> 2] | 0) + 64 >> 2] = c[m >> 2];
	                    a:do if ((c[p >> 2] | 0) < 0) {
	                        c[s >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[s >> 2] | 0))break a;
	                            do if (((c[(c[s >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[s >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 132712) | 0) != 0 : 0) {
	                                if ((qy(c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132728) | 0) == 0 ? (qy(c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 132760) | 0) == 0 : 0)break;
	                                c[p >> 2] = jw(c[f >> 2] | 0, c[s >> 2] | 0, c[g >> 2] | 0) | 0;
	                                if (!(c[p >> 2] | 0))break a
	                            } while (0);
	                            c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                        }
	                    } while (0);
	                    if ((c[p >> 2] | 0) < 0)ew(c[f >> 2] | 0, c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1604, 132792, c[n >> 2] | 0);
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                    c[e >> 2] = 0;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                c[e >> 2] = -1;
	                t = c[e >> 2] | 0;
	                i = d;
	                return t | 0
	            }

	            function dw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                if ((c[g >> 2] | 0) >= 0 ? (c[g >> 2] | 0) < (c[(c[f >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                    c[h >> 2] = c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2];
	                    if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 28 >> 2] | 0) != 0 : 0) {
	                            b = kw(c[f >> 2] | 0, c[c[f >> 2] >> 2] | 0, c[c[f >> 2] >> 2] | 0, c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 28 >> 2] | 0) | 0;
	                            c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 16 >> 2] = b;
	                            Qq(c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 28 >> 2] | 0);
	                            c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 28 >> 2] = 0
	                        }
	                        c[k >> 2] = c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 16 >> 2];
	                        c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 16 >> 2] = 0;
	                        if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) {
	                            c[m >> 2] = 0;
	                            c[l >> 2] = c[k >> 2];
	                            while (1) {
	                                if (!(c[l >> 2] | 0))break;
	                                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 1)c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                            }
	                            if ((c[m >> 2] | 0) > 1) {
	                                ew(c[f >> 2] | 0, c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1611, 132536, 0);
	                                c[e >> 2] = -1;
	                                n = c[e >> 2] | 0;
	                                i = d;
	                                return n | 0
	                            }
	                        }
	                        a:do if (c[(c[f >> 2] | 0) + 60 >> 2] & 32768) {
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break;
	                                c[j >> 2] = c[k >> 2];
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                                wi(c[h >> 2] | 0, c[j >> 2] | 0) | 0
	                            }
	                            Qh(c[h >> 2] | 0);
	                            Rh(c[h >> 2] | 0)
	                        } else {
	                            c[(c[h >> 2] | 0) + 4 >> 2] = 19;
	                            c[j >> 2] = ji(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                            if (!(c[j >> 2] | 0)) {
	                                ew(c[f >> 2] | 0, c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1609, 132592, 0);
	                                c[e >> 2] = -1;
	                                n = c[e >> 2] | 0;
	                                i = d;
	                                return n | 0
	                            }
	                            c[(c[j >> 2] | 0) + 4 >> 2] = 20;
	                            Xh(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break a;
	                                c[h >> 2] = c[k >> 2];
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                                wi(c[j >> 2] | 0, c[h >> 2] | 0) | 0
	                            }
	                        } while (0);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[e >> 2] = -1;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function ew(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (c[j >> 2] | 0) {
	                    f = (c[j >> 2] | 0) + 52 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                f = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                e = c[m >> 2] | 0;
	                c[h >> 2] = c[n >> 2];
	                Xd(0, 0, 0, f, j, 11, k, 2, 0, 0, l, 0, 0, 0, 0, e, h);
	                i = g;
	                return
	            }

	            function fw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 60 | 0;
	                g = e + 56 | 0;
	                h = e + 52 | 0;
	                j = e + 48 | 0;
	                k = e + 44 | 0;
	                l = e + 40 | 0;
	                m = e + 36 | 0;
	                n = e + 32 | 0;
	                o = e + 28 | 0;
	                p = e + 24 | 0;
	                q = e + 20 | 0;
	                r = e + 16 | 0;
	                s = e + 12 | 0;
	                t = e + 8 | 0;
	                u = e + 4 | 0;
	                v = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[m >> 2] = 0;
	                c[r >> 2] = 1;
	                c[t >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                c[n >> 2] = gw(c[g >> 2] | 0, c[h >> 2] | 0, 132616) | 0;
	                if ((c[n >> 2] | 0) == 0 ? (c[n >> 2] = my(132624) | 0, (c[n >> 2] | 0) == 0) : 0) {
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                if (!((d[c[n >> 2] >> 0] | 0 | 0) != 35 ? (d[c[n >> 2] >> 0] | 0 | 0) != 0 : 0))c[t >> 2] = 1;
	                c[o >> 2] = gw(c[g >> 2] | 0, c[h >> 2] | 0, 132632) | 0;
	                do if (c[o >> 2] | 0) {
	                    if (qy(c[o >> 2] | 0, 132640) | 0) {
	                        c[r >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[o >> 2] | 0, 132648) | 0) {
	                        c[r >> 2] = 0;
	                        break
	                    }
	                    ew(c[g >> 2] | 0, c[h >> 2] | 0, 1601, 132656, c[o >> 2] | 0);
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                } while (0);
	                c[p >> 2] = Xi(c[c[g >> 2] >> 2] | 0, c[h >> 2] | 0) | 0;
	                b = c[n >> 2] | 0;
	                if (!(c[p >> 2] | 0))c[q >> 2] = Hl(b, c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] | 0) | 0; else c[q >> 2] = Hl(b, c[p >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[u >> 2] = Gl(c[p >> 2] | 0) | 0;
	                    c[v >> 2] = Gl(c[n >> 2] | 0) | 0;
	                    c[q >> 2] = Hl(c[v >> 2] | 0, c[u >> 2] | 0) | 0;
	                    if (c[u >> 2] | 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                    if (c[v >> 2] | 0)zb[c[135736 >> 2] & 511](c[v >> 2] | 0)
	                }
	                if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                p = c[g >> 2] | 0;
	                n = c[h >> 2] | 0;
	                if (!(c[q >> 2] | 0)) {
	                    ew(p, n, 1605, 132688, 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                c[m >> 2] = gw(p, n, 133496) | 0;
	                c[k >> 2] = yl(c[q >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    ew(c[g >> 2] | 0, c[h >> 2] | 0, 1605, 132840, c[q >> 2] | 0);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                do if (c[(c[k >> 2] | 0) + 32 >> 2] | 0)if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                    if (!(c[m >> 2] | 0))c[m >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]; else zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 32 >> 2] | 0);
	                    c[(c[k >> 2] | 0) + 32 >> 2] = 0;
	                    break
	                } else {
	                    ew(c[g >> 2] | 0, c[h >> 2] | 0, 1618, 133512, c[q >> 2] | 0);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    Al(c[k >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                } while (0);
	                c[l >> 2] = Cl(c[k >> 2] | 0) | 0;
	                Al(c[k >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                if (!(c[l >> 2] | 0)) {
	                    ew(c[g >> 2] | 0, c[h >> 2] | 0, 1605, 132840, c[q >> 2] | 0);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                do if ((c[t >> 2] | 0) == 1 & (c[r >> 2] | 0) == 1) {
	                    if ((c[m >> 2] | 0) != 0 ? (d[c[m >> 2] >> 0] | 0 | 0) != 0 : 0)break;
	                    ew(c[g >> 2] | 0, c[h >> 2] | 0, 1600, 133584, c[l >> 2] | 0);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                } while (0);
	                a:do if ((c[t >> 2] | 0) == 0 & (c[r >> 2] | 0) == 1) {
	                    c[s >> 2] = 0;
	                    while (1) {
	                        if ((c[s >> 2] | 0) >= (c[(c[g >> 2] | 0) + 40 >> 2] | 0))break a;
	                        if (qy(c[l >> 2] | 0, c[(c[(c[g >> 2] | 0) + 48 >> 2] | 0) + (c[s >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[s >> 2] = (c[s >> 2] | 0) + 1
	                    }
	                    ew(c[g >> 2] | 0, c[h >> 2] | 0, 1600, 133640, c[l >> 2] | 0);
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                } while (0);
	                c[j >> 2] = lw(c[g >> 2] | 0, c[l >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                } else {
	                    c[(c[j >> 2] | 0) + 4 >> 2] = c[m >> 2];
	                    c[(c[j >> 2] | 0) + 8 >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 20 >> 2] = c[r >> 2];
	                    c[(c[j >> 2] | 0) + 24 >> 2] = 1;
	                    zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                    c[f >> 2] = 0;
	                    w = c[f >> 2] | 0;
	                    i = e;
	                    return w | 0
	                }
	                return 0
	            }

	            function gw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = Ui(c[h >> 2] | 0, 132728, c[j >> 2] | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 56 >> 2] | 0) != 0 ? (c[k >> 2] = Ui(c[h >> 2] | 0, 132760, c[j >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Yi(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function hw(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                f = i;
	                i = i + 80 | 0;
	                g = f + 68 | 0;
	                h = f + 64 | 0;
	                j = f + 60 | 0;
	                k = f + 56 | 0;
	                l = f + 52 | 0;
	                m = f + 48 | 0;
	                n = f + 44 | 0;
	                o = f + 40 | 0;
	                p = f + 36 | 0;
	                q = f + 32 | 0;
	                r = f + 28 | 0;
	                s = f + 24 | 0;
	                t = f + 20 | 0;
	                u = f + 16 | 0;
	                v = f + 12 | 0;
	                w = f + 8 | 0;
	                x = f + 4 | 0;
	                y = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[m >> 2] = yl(c[j >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 132840, c[j >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                    c[o >> 2] = c[(c[m >> 2] | 0) + 32 >> 2];
	                    c[(c[m >> 2] | 0) + 32 >> 2] = 0
	                }
	                if (((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[o >> 2] = my(c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0
	                }
	                c[n >> 2] = Cl(c[m >> 2] | 0) | 0;
	                Al(c[m >> 2] | 0);
	                if (!(c[n >> 2] | 0)) {
	                    m = c[h >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 16 >> 2] | 0)ew(m, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 132840, c[j >> 2] | 0); else ew(m, 0, 1605, 132840, c[j >> 2] | 0);
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                do if ((d[c[n >> 2] >> 0] | 0 | 0) != 0 ? (d[c[n >> 2] >> 0] | 0 | 0) != 35 : 0) {
	                    if ((c[c[h >> 2] >> 2] | 0) != 0 ? (qy(c[n >> 2] | 0, c[(c[c[h >> 2] >> 2] | 0) + 72 >> 2] | 0) | 0) != 0 : 0) {
	                        A = 22;
	                        break
	                    }
	                    c[p >> 2] = 0;
	                    while (1) {
	                        if ((c[p >> 2] | 0) >= (c[(c[h >> 2] | 0) + 8 >> 2] | 0))break;
	                        if ((qy(c[n >> 2] | 0, c[c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[p >> 2] << 2) >> 2] >> 2] | 0) | 0) != 0 ? (c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                            A = 27;
	                            break
	                        }
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    if ((A | 0) == 27) {
	                        c[l >> 2] = c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                    c[q >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                    if (c[o >> 2] | 0) {
	                        j = (c[h >> 2] | 0) + 60 | 0;
	                        c[j >> 2] = c[j >> 2] | 2
	                    }
	                    c[l >> 2] = mw(c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                    if (!(c[l >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    }
	                    c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                    if (!(qy(c[n >> 2] | 0, c[(c[l >> 2] | 0) + 72 >> 2] | 0) | 0)) {
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[n >> 2] = my(c[(c[l >> 2] | 0) + 72 >> 2] | 0) | 0
	                    }
	                    c[p >> 2] = (c[k >> 2] | 0) + 1;
	                    while (1) {
	                        if ((c[p >> 2] | 0) >= (c[(c[h >> 2] | 0) + 8 >> 2] | 0))break;
	                        if (qy(c[n >> 2] | 0, c[c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[p >> 2] << 2) >> 2] >> 2] | 0) | 0) {
	                            A = 40;
	                            break
	                        }
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    if ((A | 0) == 40) {
	                        j = (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 24 | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    nw(c[h >> 2] | 0, c[c[h >> 2] >> 2] | 0, c[l >> 2] | 0) | 0;
	                    ow(c[h >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0)
	                } else A = 22; while (0);
	                if ((A | 0) == 22)c[l >> 2] = 0;
	                q = (c[l >> 2] | 0) == 0;
	                do if (!(c[o >> 2] | 0)) {
	                    j = c[h >> 2] | 0;
	                    if (q) {
	                        m = Ki(c[(c[j >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 16 >> 2] = m;
	                        break
	                    } else {
	                        m = pw(j, c[c[h >> 2] >> 2] | 0, c[l >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 16 >> 2] = m;
	                        break
	                    }
	                } else {
	                    if (q)c[s >> 2] = iv(c[c[h >> 2] >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 0) | 0; else c[s >> 2] = iv(c[l >> 2] | 0, 0, 0) | 0;
	                    if (!(c[s >> 2] | 0)) {
	                        ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1612, 133056, 0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    }
	                    c[r >> 2] = kv(c[o >> 2] | 0, c[s >> 2] | 0) | 0;
	                    if (!(c[r >> 2] | 0)) {
	                        ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1612, 133096, c[o >> 2] | 0);
	                        Nr(c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    }
	                    switch (c[c[r >> 2] >> 2] | 0) {
	                        case 9:
	                        case 8:
	                        case 5:
	                        case 4:
	                        case 3:
	                        case 2:
	                        case 0:
	                        {
	                            ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1613, 133136, c[o >> 2] | 0);
	                            Nr(c[s >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                            c[g >> 2] = -1;
	                            z = c[g >> 2] | 0;
	                            i = f;
	                            return z | 0
	                        }
	                        case 1:
	                        {
	                            A = 56;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    do if ((A | 0) == 56) {
	                        if ((c[(c[r >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[r >> 2] | 0) + 4 >> 2] >> 2] | 0) > 0 : 0)break;
	                        Nr(c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    } while (0);
	                    c[t >> 2] = c[(c[r >> 2] | 0) + 4 >> 2];
	                    a:do if (c[t >> 2] | 0) {
	                        c[p >> 2] = 0;
	                        while (1) {
	                            if ((c[p >> 2] | 0) >= (c[c[t >> 2] >> 2] | 0))break a;
	                            b:do if (c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0)switch (c[(c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) {
	                                case 10:
	                                case 11:
	                                case 12:
	                                case 14:
	                                case 15:
	                                case 16:
	                                case 17:
	                                case 19:
	                                case 20:
	                                {
	                                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1613, 133248, c[o >> 2] | 0);
	                                    c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[p >> 2] << 2) >> 2] = 0;
	                                    c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[p >> 2] << 2) >> 2] = 0;
	                                    break b;
	                                    break
	                                }
	                                case 18:
	                                {
	                                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1613, 133208, c[o >> 2] | 0);
	                                    c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[p >> 2] << 2) >> 2] = 0;
	                                    break b;
	                                    break
	                                }
	                                case 2:
	                                {
	                                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1613, 133168, c[o >> 2] | 0);
	                                    c[(c[(c[t >> 2] | 0) + 8 >> 2] | 0) + (c[p >> 2] << 2) >> 2] = 0;
	                                    break b;
	                                    break
	                                }
	                                default:
	                                    break b
	                            } while (0);
	                            c[p >> 2] = (c[p >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    if (!(c[l >> 2] | 0)) {
	                        c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 28 >> 2] = c[r >> 2];
	                        c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 16 >> 2] = 0
	                    } else {
	                        m = kw(c[h >> 2] | 0, c[c[h >> 2] >> 2] | 0, c[l >> 2] | 0, c[r >> 2] | 0) | 0;
	                        c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 16 >> 2] = m;
	                        Qq(c[r >> 2] | 0)
	                    }
	                    Nr(c[s >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0)
	                } while (0);
	                if (((c[l >> 2] | 0) != 0 & (c[n >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 60 >> 2] & 262144 | 0) == 0 : 0) ? (c[(c[l >> 2] | 0) + 88 >> 2] & 262144 | 0) == 0 : 0) {
	                    c[v >> 2] = Ui(c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 133288, 133296) | 0;
	                    do if (!(c[v >> 2] | 0)) {
	                        c[w >> 2] = Il(c[n >> 2] | 0, c[(c[h >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        if (!(c[w >> 2] | 0)) {
	                            ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 133336, c[n >> 2] | 0);
	                            break
	                        }
	                        if (vy(c[w >> 2] | 0, 47) | 0) {
	                            c[v >> 2] = c[w >> 2];
	                            break
	                        } else {
	                            zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                            break
	                        }
	                    } while (0);
	                    if (c[v >> 2] | 0) {
	                        c[u >> 2] = c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 16 >> 2];
	                        while (1) {
	                            if (!(c[u >> 2] | 0))break;
	                            do if ((c[(c[u >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                c[w >> 2] = Xi(c[(c[u >> 2] | 0) + 32 >> 2] | 0, c[u >> 2] | 0) | 0;
	                                if (!(c[w >> 2] | 0)) {
	                                    Wi(c[u >> 2] | 0, c[v >> 2] | 0);
	                                    break
	                                }
	                                l = (qy(c[w >> 2] | 0, c[(c[(c[u >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) | 0) != 0;
	                                o = c[u >> 2] | 0;
	                                if (!l) {
	                                    c[x >> 2] = Ui(o, 133288, 133296) | 0;
	                                    if (c[x >> 2] | 0) {
	                                        c[y >> 2] = Hl(c[x >> 2] | 0, c[v >> 2] | 0) | 0;
	                                        if (!(c[y >> 2] | 0))ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 133376, c[x >> 2] | 0); else {
	                                            Wi(c[u >> 2] | 0, c[y >> 2] | 0);
	                                            zb[c[135736 >> 2] & 511](c[y >> 2] | 0)
	                                        }
	                                        zb[c[135736 >> 2] & 511](c[x >> 2] | 0)
	                                    }
	                                } else Wi(o, c[v >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[w >> 2] | 0)
	                            } while (0);
	                            c[u >> 2] = c[(c[u >> 2] | 0) + 24 >> 2]
	                        }
	                        zb[c[135736 >> 2] & 511](c[v >> 2] | 0)
	                    }
	                }
	                if (((c[k >> 2] | 0) < (c[(c[h >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 24 >> 2] | 0) <= 1 : 0) {
	                    Th(c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 8 >> 2] = 0
	                }
	                zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                c[g >> 2] = 0;
	                z = c[g >> 2] | 0;
	                i = f;
	                return z | 0
	            }

	            function iw(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                f = i;
	                i = i + 80 | 0;
	                g = f + 68 | 0;
	                h = f + 64 | 0;
	                j = f + 60 | 0;
	                k = f + 56 | 0;
	                l = f + 52 | 0;
	                m = f + 48 | 0;
	                n = f + 44 | 0;
	                o = f + 40 | 0;
	                p = f + 36 | 0;
	                q = f + 32 | 0;
	                r = f + 28 | 0;
	                s = f + 24 | 0;
	                t = f + 20 | 0;
	                u = f + 16 | 0;
	                v = f + 12 | 0;
	                w = f + 8 | 0;
	                x = f + 4 | 0;
	                y = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[u >> 2] = 0;
	                c[n >> 2] = yl(c[j >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 132840, c[j >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                if (c[(c[n >> 2] | 0) + 32 >> 2] | 0) {
	                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1606, 132864, c[(c[n >> 2] | 0) + 32 >> 2] | 0);
	                    Al(c[n >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                c[o >> 2] = Cl(c[n >> 2] | 0) | 0;
	                Al(c[n >> 2] | 0);
	                if (!(c[o >> 2] | 0)) {
	                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1605, 132840, c[j >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                if (!(d[c[o >> 2] >> 0] | 0)) {
	                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1607, 132912, 0);
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                c[p >> 2] = 0;
	                while (1) {
	                    if ((c[p >> 2] | 0) >= (c[(c[h >> 2] | 0) + 20 >> 2] | 0)) {
	                        A = 14;
	                        break
	                    }
	                    j = (qy(c[o >> 2] | 0, c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) | 0) != 0;
	                    B = c[p >> 2] | 0;
	                    if (j) {
	                        A = 12;
	                        break
	                    }
	                    c[p >> 2] = B + 1
	                }
	                do if ((A | 0) == 12)c[m >> 2] = Hi(c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + (B << 2) >> 2] | 0, 1) | 0; else if ((A | 0) == 14) {
	                    if ((c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) != 0 ? (c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)c[q >> 2] = Yi(c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 132960) | 0;
	                    do if (c[q >> 2] | 0) {
	                        c[r >> 2] = wd(c[q >> 2] | 0) | 0;
	                        if ((c[r >> 2] | 0) != -1) {
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                            break
	                        }
	                        ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1610, 132976, c[q >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    } while (0);
	                    c[s >> 2] = Be() | 0;
	                    c[t >> 2] = Vk(c[o >> 2] | 0, 0, c[s >> 2] | 0) | 0;
	                    if (!(c[t >> 2] | 0)) {
	                        Ae(c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    }
	                    c[l >> 2] = c[c[t >> 2] >> 2];
	                    if (!(c[l >> 2] | 0)) {
	                        te(c[t >> 2] | 0);
	                        Ae(c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[g >> 2] = -1;
	                        z = c[g >> 2] | 0;
	                        i = f;
	                        return z | 0
	                    }
	                    if (c[(c[l >> 2] | 0) + 12 >> 2] | 0)Hd(c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    j = Cd(c[r >> 2] | 0) | 0;
	                    c[(c[l >> 2] | 0) + 12 >> 2] = j;
	                    c[m >> 2] = li(0) | 0;
	                    while (1) {
	                        if ((Nk(c[l >> 2] | 0, 128) | 0) <= 0) {
	                            A = 41;
	                            break
	                        }
	                        c[w >> 2] = Vy(c[(c[l >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        c[v >> 2] = Zy(c[(c[l >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        c[p >> 2] = 0;
	                        while (1) {
	                            if ((c[p >> 2] | 0) >= (c[v >> 2] | 0)) {
	                                A = 40;
	                                break
	                            }
	                            c[x >> 2] = oe(0, (c[w >> 2] | 0) + (c[p >> 2] | 0) | 0, y) | 0;
	                            j = c[x >> 2] | 0;
	                            if ((c[x >> 2] | 0) < 256) {
	                                if (!(9 <= (j | 0) & (c[x >> 2] | 0) <= 10 | (c[x >> 2] | 0) == 13 | 32 <= (c[x >> 2] | 0)))break
	                            } else if ((!(256 <= (j | 0) & (c[x >> 2] | 0) <= 55295) ? !(57344 <= (c[x >> 2] | 0) & (c[x >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[x >> 2] | 0) & (c[x >> 2] | 0) <= 1114111) : 0)break;
	                            c[u >> 2] = 0;
	                            $i(c[m >> 2] | 0, (c[w >> 2] | 0) + (c[p >> 2] | 0) | 0, c[y >> 2] | 0);
	                            c[p >> 2] = (c[p >> 2] | 0) + (c[y >> 2] | 0)
	                        }
	                        if ((A | 0) == 40) {
	                            A = 0;
	                            Ty(c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[v >> 2] | 0) | 0;
	                            continue
	                        }
	                        if ((c[u >> 2] | 0) != 0 ? 1 : ((c[v >> 2] | 0) - (c[p >> 2] | 0) | 0) >= 4)break;
	                        c[u >> 2] = 1;
	                        Ty(c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[p >> 2] | 0) | 0
	                    }
	                    if ((A | 0) == 41) {
	                        Ae(c[s >> 2] | 0);
	                        qw(c[h >> 2] | 0, c[m >> 2] | 0, c[o >> 2] | 0);
	                        te(c[t >> 2] | 0);
	                        break
	                    }
	                    ew(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0, 1608, 133008, c[o >> 2] | 0);
	                    yk(c[l >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[g >> 2] = -1;
	                    z = c[g >> 2] | 0;
	                    i = f;
	                    return z | 0
	                } while (0);
	                c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                c[g >> 2] = 0;
	                z = c[g >> 2] | 0;
	                i = f;
	                return z | 0
	            }

	            function jw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if ((c[h >> 2] | 0) != 0 ? !((c[g >> 2] | 0) == 0 ? 1 : (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 18) : 0) {
	                    if (c[(c[h >> 2] | 0) + 12 >> 2] | 0) {
	                        c[k >> 2] = Qv(c[c[g >> 2] >> 2] | 0) | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            c[f >> 2] = -1;
	                            m = c[f >> 2] | 0;
	                            i = e;
	                            return m | 0
	                        }
	                        c[(c[k >> 2] | 0) + 68 >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                        d = my(c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 64 >> 2] = d;
	                        Sv(c[k >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        c[l >> 2] = _v(c[k >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) <= 0) {
	                            if ((c[l >> 2] | 0) > 0)c[l >> 2] = 0
	                        } else c[l >> 2] = -1;
	                        Rv(c[k >> 2] | 0);
	                        k = Ji(c[c[g >> 2] >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 16 >> 2] = k
	                    } else {
	                        c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 32 >> 2] = 1
	                    }
	                    c[f >> 2] = c[l >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[f >> 2] = -1;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function kw(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 44 | 0;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 8 | 0;
	                r = f + 4 | 0;
	                s = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!(c[k >> 2] | 0))c[k >> 2] = c[c[h >> 2] >> 2];
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    t = c[g >> 2] | 0;
	                    i = f;
	                    return t | 0
	                }
	                e = c[c[l >> 2] >> 2] | 0;
	                a:do if ((e | 0) == 6) {
	                    c[g >> 2] = sw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    t = c[g >> 2] | 0;
	                    i = f;
	                    return t | 0
	                } else if ((e | 0) == 1) {
	                    c[p >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                    if (!(c[p >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    c[o >> 2] = 0;
	                    while (1) {
	                        if ((c[o >> 2] | 0) >= (c[c[p >> 2] >> 2] | 0))break a;
	                        b:do if (c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) {
	                            switch (c[(c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) {
	                                case 2:
	                                case 18:
	                                case 10:
	                                case 11:
	                                case 12:
	                                case 14:
	                                case 15:
	                                case 16:
	                                case 17:
	                                {
	                                    break b;
	                                    break
	                                }
	                                case 19:
	                                    break;
	                                default:
	                                {
	                                    if (!(c[n >> 2] | 0)) {
	                                        d = rw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) | 0;
	                                        c[n >> 2] = d;
	                                        c[m >> 2] = d;
	                                        break b
	                                    }
	                                    Xh(c[n >> 2] | 0, rw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) | 0) | 0;
	                                    if (!(c[(c[n >> 2] | 0) + 24 >> 2] | 0))break b;
	                                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                                    break b
	                                }
	                            }
	                            c[r >> 2] = c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                            c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[r >> 2] | 0))break b;
	                                switch (c[(c[r >> 2] | 0) + 4 >> 2] | 0) {
	                                    case 8:
	                                    case 7:
	                                    case 6:
	                                    case 5:
	                                    case 1:
	                                    case 4:
	                                    case 3:
	                                        break;
	                                    default:
	                                        break b
	                                }
	                                c[q >> 2] = rw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[r >> 2] | 0) | 0;
	                                if (!(c[n >> 2] | 0)) {
	                                    d = c[q >> 2] | 0;
	                                    c[n >> 2] = d;
	                                    c[m >> 2] = d
	                                } else {
	                                    Xh(c[n >> 2] | 0, c[q >> 2] | 0) | 0;
	                                    c[n >> 2] = c[q >> 2]
	                                }
	                                c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                            }
	                        } while (0);
	                        c[o >> 2] = (c[o >> 2] | 0) + 1
	                    }
	                } else if ((e | 0) == 7) {
	                    c[s >> 2] = c[(c[l >> 2] | 0) + 28 >> 2];
	                    if (!(c[s >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    c[o >> 2] = 0;
	                    while (1) {
	                        if ((c[o >> 2] | 0) >= (c[c[s >> 2] >> 2] | 0))break a;
	                        if (!(c[n >> 2] | 0)) {
	                            d = kw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[(c[(c[s >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) | 0;
	                            c[n >> 2] = d;
	                            c[m >> 2] = d
	                        } else {
	                            d = c[n >> 2] | 0;
	                            Xh(d, kw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[(c[(c[s >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) | 0) | 0
	                        }
	                        c:do if (c[n >> 2] | 0)while (1) {
	                            if (!(c[(c[n >> 2] | 0) + 24 >> 2] | 0))break c;
	                            c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                        } while (0);
	                        c[o >> 2] = (c[o >> 2] | 0) + 1
	                    }
	                } while (0);
	                c[g >> 2] = c[m >> 2];
	                t = c[g >> 2] | 0;
	                i = f;
	                return t | 0
	            }

	            function lw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Xv(c[g >> 2] | 0, c[j >> 2] | 0, 133672);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 36 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                if (!(c[h >> 2] | 0))c[c[k >> 2] >> 2] = 0; else {
	                    d = my(c[h >> 2] | 0) | 0;
	                    c[c[k >> 2] >> 2] = d
	                }
	                c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                c[(c[k >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 16 >> 2] = 0;
	                if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] = 4, d = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 12 >> 2] << 2) | 0, c[(c[g >> 2] | 0) + 16 >> 2] = d, (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0) : 0) {
	                    Xv(c[g >> 2] | 0, c[j >> 2] | 0, 133672);
	                    Zv(c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 12 >> 2] | 0) ? (d = (c[g >> 2] | 0) + 12 | 0, c[d >> 2] = c[d >> 2] << 1, d = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] << 2) | 0, c[(c[g >> 2] | 0) + 16 >> 2] = d, (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0) : 0) {
	                    Xv(c[g >> 2] | 0, c[j >> 2] | 0, 133672);
	                    Zv(c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                j = c[k >> 2] | 0;
	                d = (c[g >> 2] | 0) + 8 | 0;
	                h = c[d >> 2] | 0;
	                c[d >> 2] = h + 1;
	                c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (h << 2) >> 2] = j;
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function mw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                Rf();
	                c[j >> 2] = Be() | 0;
	                b = c[f >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Xv(b, 0, 133464);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[(c[j >> 2] | 0) + 272 >> 2] = c[b + 68 >> 2];
	                if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                    if (c[(c[j >> 2] | 0) + 296 >> 2] | 0)zP(c[(c[j >> 2] | 0) + 296 >> 2] | 0);
	                    c[(c[j >> 2] | 0) + 296 >> 2] = c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2];
	                    yP(c[(c[j >> 2] | 0) + 296 >> 2] | 0) | 0
	                }
	                fg(c[j >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 4) | 0;
	                c[k >> 2] = Vk(c[g >> 2] | 0, 0, c[j >> 2] | 0) | 0;
	                f = c[j >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ae(f);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                Oe(f, c[k >> 2] | 0) | 0;
	                if (!(c[(c[j >> 2] | 0) + 180 >> 2] | 0)) {
	                    k = Rk(c[g >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 180 >> 2] = k
	                }
	                k = (c[j >> 2] | 0) + 276 | 0;
	                c[k >> 2] = c[k >> 2] | 2;
	                Qf(c[j >> 2] | 0) | 0;
	                if (c[(c[j >> 2] | 0) + 12 >> 2] | 0)c[h >> 2] = c[(c[j >> 2] | 0) + 8 >> 2]; else {
	                    c[h >> 2] = 0;
	                    if (c[(c[j >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[j >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[j >> 2] | 0) + 8 >> 2] = 0
	                }
	                Ae(c[j >> 2] | 0);
	                c[e >> 2] = c[h >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function nw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 8 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    c[l >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                    if (!(c[l >> 2] | 0)) {
	                        c[k >> 2] = Pi(c[h >> 2] | 0) | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            c[f >> 2] = -1;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        c[l >> 2] = Oh(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[f >> 2] = -1;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                    }
	                    c[m >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                    if ((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                        c[n + 4 >> 2] = c[g >> 2];
	                        c[n >> 2] = c[h >> 2];
	                        Wj(c[(c[m >> 2] | 0) + 48 >> 2] | 0, 314, n)
	                    }
	                    c[m >> 2] = c[(c[j >> 2] | 0) + 48 >> 2];
	                    if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[o + 4 >> 2] = c[g >> 2], c[o >> 2] = c[h >> 2], (qy(c[(c[l >> 2] | 0) + 52 >> 2] | 0, c[(c[m >> 2] | 0) + 52 >> 2] | 0) | 0) == 0) : 0) ? (qy(c[(c[l >> 2] | 0) + 56 >> 2] | 0, c[(c[m >> 2] | 0) + 56 >> 2] | 0) | 0) == 0 : 0)Wj(c[(c[m >> 2] | 0) + 48 >> 2] | 0, 314, o);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[f >> 2] = 0;
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function ow(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[e + 8 >> 2] = d;
	                c[h >> 2] = Qv(c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 68 >> 2] = c[(c[f >> 2] | 0) + 68 >> 2];
	                c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                c[(c[h >> 2] | 0) + 8 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                d = Cb[c[135744 >> 2] & 511](c[(c[h >> 2] | 0) + 12 >> 2] << 2) | 0;
	                c[(c[h >> 2] | 0) + 16 >> 2] = d;
	                d = c[f >> 2] | 0;
	                if (!(c[(c[h >> 2] | 0) + 16 >> 2] | 0)) {
	                    Xv(d, c[g >> 2] | 0, 133408);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    i = e;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 44 >> 2] = c[d + 44 >> 2];
	                c[(c[h >> 2] | 0) + 40 >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                c[(c[h >> 2] | 0) + 48 >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                d = my(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 64 >> 2] = d;
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= (c[(c[f >> 2] | 0) + 8 >> 2] | 0))break;
	                    c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] = c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                    d = (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 24 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                c[(c[h >> 2] | 0) + 60 >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                d = c[h >> 2] | 0;
	                b = c[g >> 2] | 0;
	                _v(d, b, Pi(c[g >> 2] | 0) | 0) | 0;
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= (c[(c[f >> 2] | 0) + 8 >> 2] | 0))break;
	                    g = (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 24 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + -1;
	                    c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + (c[j >> 2] << 2) >> 2] = 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                c[(c[f >> 2] | 0) + 48 >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                c[(c[f >> 2] | 0) + 44 >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                c[(c[h >> 2] | 0) + 44 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 48 >> 2] = 0;
	                Rv(c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function pw(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[m >> 2] = c[l >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    c[n >> 2] = rw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                    do if (c[n >> 2] | 0) {
	                        l = c[n >> 2] | 0;
	                        if (!(c[o >> 2] | 0)) {
	                            c[p >> 2] = l;
	                            c[o >> 2] = l;
	                            break
	                        } else {
	                            c[(c[p >> 2] | 0) + 24 >> 2] = l;
	                            c[(c[n >> 2] | 0) + 28 >> 2] = c[p >> 2];
	                            c[p >> 2] = c[n >> 2];
	                            break
	                        }
	                    } while (0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                c[g >> 2] = c[o >> 2];
	                q = c[g >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function qw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[(c[f >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[(c[f >> 2] | 0) + 24 >> 2] = 4;
	                    d = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] << 2) | 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = d;
	                    if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                        Xv(c[f >> 2] | 0, 0, 133040);
	                        i = e;
	                        return
	                    }
	                    d = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] << 2) | 0;
	                    c[(c[f >> 2] | 0) + 32 >> 2] = d;
	                    if (!(c[(c[f >> 2] | 0) + 32 >> 2] | 0)) {
	                        Xv(c[f >> 2] | 0, 0, 133040);
	                        i = e;
	                        return
	                    }
	                }
	                if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 24 >> 2] | 0)) {
	                    d = (c[f >> 2] | 0) + 24 | 0;
	                    c[d >> 2] = c[d >> 2] << 1;
	                    d = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 28 >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] << 2) | 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = d;
	                    if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                        Xv(c[f >> 2] | 0, 0, 133040);
	                        i = e;
	                        return
	                    }
	                    d = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 32 >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] << 2) | 0;
	                    c[(c[f >> 2] | 0) + 32 >> 2] = d;
	                    if (!(c[(c[f >> 2] | 0) + 32 >> 2] | 0)) {
	                        Xv(c[f >> 2] | 0, 0, 133040);
	                        i = e;
	                        return
	                    }
	                }
	                c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + (c[(c[f >> 2] | 0) + 20 >> 2] << 2) >> 2] = c[g >> 2];
	                g = my(c[h >> 2] | 0) | 0;
	                c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + (c[(c[f >> 2] | 0) + 20 >> 2] << 2) >> 2] = g;
	                g = (c[f >> 2] | 0) + 20 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + 1;
	                i = e;
	                return
	            }

	            function rw(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 9)c[m >> 2] = pw(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0; else c[m >> 2] = Ii(c[l >> 2] | 0, c[j >> 2] | 0, 1) | 0;
	                c[g >> 2] = c[m >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function sw(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                f = i;
	                i = i + 96 | 0;
	                g = f + 84 | 0;
	                h = f + 80 | 0;
	                j = f + 76 | 0;
	                k = f + 72 | 0;
	                l = f + 68 | 0;
	                m = f + 64 | 0;
	                n = f + 60 | 0;
	                o = f + 56 | 0;
	                p = f + 52 | 0;
	                q = f + 48 | 0;
	                r = f + 44 | 0;
	                s = f + 40 | 0;
	                t = f + 36 | 0;
	                u = f + 32 | 0;
	                v = f + 28 | 0;
	                w = f + 24 | 0;
	                x = f + 20 | 0;
	                y = f + 16 | 0;
	                z = f + 12 | 0;
	                A = f + 8 | 0;
	                B = f + 4 | 0;
	                C = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    D = c[g >> 2] | 0;
	                    i = f;
	                    return D | 0
	                }
	                if ((c[c[l >> 2] >> 2] | 0) != 6) {
	                    c[g >> 2] = 0;
	                    D = c[g >> 2] | 0;
	                    i = f;
	                    return D | 0
	                }
	                c[r >> 2] = c[(c[l >> 2] | 0) + 28 >> 2];
	                if ((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[t >> 2] = c[(c[l >> 2] | 0) + 36 >> 2];
	                    if (!(c[t >> 2] | 0)) {
	                        c[g >> 2] = Ii(c[r >> 2] | 0, c[j >> 2] | 0, 1) | 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    if ((c[(c[t >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    c[s >> 2] = c[r >> 2];
	                    c[u >> 2] = c[(c[l >> 2] | 0) + 32 >> 2];
	                    c[v >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                    a:while (1) {
	                        if (!(c[s >> 2] | 0)) {
	                            E = 65;
	                            break
	                        }
	                        b:while (1) {
	                            if ((c[w >> 2] | 0) < 0) {
	                                while (1) {
	                                    if ((c[w >> 2] | 0) >= 0)break;
	                                    c[q >> 2] = Ii(c[o >> 2] | 0, c[j >> 2] | 0, 2) | 0;
	                                    zi(c[q >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    c[m >> 2] = c[q >> 2];
	                                    c[o >> 2] = c[(c[o >> 2] | 0) + 20 >> 2];
	                                    c[w >> 2] = (c[w >> 2] | 0) + 1
	                                }
	                                c[n >> 2] = c[m >> 2];
	                                c[x >> 2] = 0
	                            }
	                            while (1) {
	                                if ((c[w >> 2] | 0) >= (c[x >> 2] | 0))break;
	                                c[n >> 2] = c[(c[n >> 2] | 0) + 20 >> 2];
	                                c[x >> 2] = (c[x >> 2] | 0) + -1
	                            }
	                            F = c[s >> 2] | 0;
	                            if ((c[s >> 2] | 0) == (c[t >> 2] | 0))break;
	                            do if ((F | 0) != (c[r >> 2] | 0)) {
	                                c[p >> 2] = 0;
	                                switch (c[(c[s >> 2] | 0) + 4 >> 2] | 0) {
	                                    case 2:
	                                    case 20:
	                                    case 19:
	                                    case 17:
	                                    case 6:
	                                    case 16:
	                                    case 15:
	                                    case 14:
	                                        break;
	                                    default:
	                                        c[p >> 2] = Ii(c[s >> 2] | 0, c[j >> 2] | 0, 2) | 0
	                                }
	                                if (c[p >> 2] | 0) {
	                                    l = c[n >> 2] | 0;
	                                    k = c[p >> 2] | 0;
	                                    if ((c[w >> 2] | 0) == (c[x >> 2] | 0))Xh(l, k) | 0; else {
	                                        zi(l, k) | 0;
	                                        c[x >> 2] = c[w >> 2]
	                                    }
	                                    c[n >> 2] = c[p >> 2]
	                                }
	                            } else {
	                                if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                                    c[p >> 2] = Ii(c[s >> 2] | 0, c[j >> 2] | 0, 2) | 0;
	                                    k = c[p >> 2] | 0;
	                                    c[n >> 2] = k;
	                                    c[m >> 2] = k;
	                                    c[o >> 2] = c[(c[s >> 2] | 0) + 20 >> 2];
	                                    if ((c[u >> 2] | 0) > 1) {
	                                        E = 55;
	                                        break b
	                                    } else break
	                                }
	                                c[C >> 2] = c[(c[s >> 2] | 0) + 40 >> 2];
	                                if (!(c[C >> 2] | 0))c[p >> 2] = ni(0, 0) | 0; else {
	                                    if ((c[u >> 2] | 0) > 1) {
	                                        c[C >> 2] = (c[C >> 2] | 0) + ((c[u >> 2] | 0) - 1);
	                                        c[u >> 2] = 0
	                                    }
	                                    c[p >> 2] = li(c[C >> 2] | 0) | 0
	                                }
	                                k = c[p >> 2] | 0;
	                                c[m >> 2] = k;
	                                c[n >> 2] = k;
	                                c[o >> 2] = c[(c[s >> 2] | 0) + 20 >> 2]
	                            } while (0);
	                            c[s >> 2] = lv(c[s >> 2] | 0, w) | 0;
	                            if (!(c[z >> 2] | 0))continue a;
	                            if (!((c[s >> 2] | 0) != 0 ? (c[w >> 2] | 0) < (c[y >> 2] | 0) : 0)) {
	                                E = 65;
	                                break a
	                            }
	                        }
	                        if ((E | 0) == 55) {
	                            E = 0;
	                            c[s >> 2] = uw(c[s >> 2] | 0, (c[u >> 2] | 0) - 1 | 0) | 0;
	                            c[x >> 2] = 1;
	                            c[w >> 2] = 1;
	                            c[u >> 2] = 0;
	                            continue
	                        }
	                        if ((c[F + 4 >> 2] | 0) == 3)break;
	                        c[y >> 2] = c[w >> 2];
	                        c[z >> 2] = 1;
	                        c[p >> 2] = Ii(c[s >> 2] | 0, c[j >> 2] | 0, 2) | 0;
	                        do if (c[m >> 2] | 0) {
	                            k = c[n >> 2] | 0;
	                            l = c[p >> 2] | 0;
	                            if ((c[w >> 2] | 0) == (c[x >> 2] | 0)) {
	                                Xh(k, l) | 0;
	                                break
	                            } else {
	                                zi(k, l) | 0;
	                                c[x >> 2] = c[w >> 2];
	                                break
	                            }
	                        } else {
	                            c[m >> 2] = c[p >> 2];
	                            c[o >> 2] = c[(c[s >> 2] | 0) + 20 >> 2]
	                        } while (0);
	                        c[n >> 2] = c[p >> 2];
	                        if ((c[v >> 2] | 0) > 1) {
	                            c[t >> 2] = uw(c[s >> 2] | 0, (c[v >> 2] | 0) - 1 | 0) | 0;
	                            c[v >> 2] = 0
	                        }
	                        l = c[s >> 2] | 0;
	                        if ((c[u >> 2] | 0) > 1 ? (c[s >> 2] | 0) == (c[r >> 2] | 0) : 0) {
	                            c[s >> 2] = uw(l, (c[u >> 2] | 0) - 1 | 0) | 0;
	                            c[u >> 2] = 0
	                        } else c[s >> 2] = c[l + 12 >> 2];
	                        c[w >> 2] = (c[w >> 2] | 0) + 1
	                    }
	                    if ((E | 0) == 65) {
	                        c[g >> 2] = c[m >> 2];
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    c[A >> 2] = c[(c[s >> 2] | 0) + 40 >> 2];
	                    if (!(c[A >> 2] | 0))c[p >> 2] = ni(0, 0) | 0; else {
	                        c[B >> 2] = c[v >> 2];
	                        if ((c[u >> 2] | 0) > 1 ? (c[s >> 2] | 0) == (c[r >> 2] | 0) : 0) {
	                            c[A >> 2] = (c[A >> 2] | 0) + ((c[u >> 2] | 0) - 1);
	                            c[B >> 2] = (c[B >> 2] | 0) - ((c[u >> 2] | 0) - 1)
	                        } else c[B >> 2] = c[v >> 2];
	                        c[p >> 2] = ni(c[A >> 2] | 0, c[B >> 2] | 0) | 0
	                    }
	                    if (!(c[m >> 2] | 0)) {
	                        c[g >> 2] = c[p >> 2];
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    B = c[n >> 2] | 0;
	                    n = c[p >> 2] | 0;
	                    if ((c[w >> 2] | 0) == (c[x >> 2] | 0))Xh(B, n) | 0; else zi(B, n) | 0;
	                    c[g >> 2] = c[m >> 2];
	                    D = c[g >> 2] | 0;
	                    i = f;
	                    return D | 0
	                }
	                c[g >> 2] = 0;
	                D = c[g >> 2] | 0;
	                i = f;
	                return D | 0
	            }

	            function tw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[e + 16 >> 2] = d;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    i = e;
	                    return
	                }
	                c[l >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                c[k >> 2] = c[c[g >> 2] >> 2];
	                if ((c[l >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    i = e;
	                    return
	                }
	                if (((c[(c[f >> 2] | 0) + 48 >> 2] | 0) + -4 | 0) >>> 0 < 3) {
	                    i = e;
	                    return
	                }
	                c[h >> 2] = _c(c[k >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0) | 0;
	                if (c[h >> 2] | 0) {
	                    if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                        i = e;
	                        return
	                    }
	                    g = my(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 64 >> 2] = g;
	                    i = e;
	                    return
	                }
	                c[j >> 2] = ad(c[k >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                do if ((c[(c[f >> 2] | 0) + 48 >> 2] | 0) == (c[(c[j >> 2] | 0) + 48 >> 2] | 0)) {
	                    if ((c[(c[f >> 2] | 0) + 56 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 56 >> 2] | 0) != 0 : 0) {
	                        if (!(qy(c[(c[f >> 2] | 0) + 56 >> 2] | 0, c[(c[j >> 2] | 0) + 56 >> 2] | 0) | 0))break;
	                        i = e;
	                        return
	                    }
	                    if ((c[(c[f >> 2] | 0) + 52 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                        if (!(qy(c[(c[f >> 2] | 0) + 52 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0) | 0))break;
	                        i = e;
	                        return
	                    }
	                    if (((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (qy(c[(c[f >> 2] | 0) + 40 >> 2] | 0, c[(c[j >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0) {
	                        i = e;
	                        return
	                    }
	                } while (0);
	                switch (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                    case 2:
	                    case 1:
	                    case 6:
	                    case 5:
	                    case 4:
	                    {
	                        i = e;
	                        return
	                    }
	                    default:
	                    {
	                    }
	                }
	                ew(c[l >> 2] | 0, c[f >> 2] | 0, 1602, 133424, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                i = e;
	                return
	            }

	            function uw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if ((c[h >> 2] | 0) > (c[g >> 2] | 0)) {
	                            j = 13;
	                            break
	                        }
	                        k = c[f >> 2] | 0;
	                        if (!(c[f >> 2] | 0)) {
	                            j = 7;
	                            break
	                        }
	                        if (!(((c[k + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 13 : 0))j = 11;
	                        if ((j | 0) == 11 ? (j = 0, c[h >> 2] = (c[h >> 2] | 0) + 1, (c[h >> 2] | 0) == (c[g >> 2] | 0)) : 0) {
	                            j = 13;
	                            break
	                        }
	                        c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                    }
	                    if ((j | 0) == 7) {
	                        c[e >> 2] = k;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else if ((j | 0) == 13) {
	                        c[e >> 2] = c[f >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function vw(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 60 >> 2] | 0)Lw(c[(c[d >> 2] | 0) + 60 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 52 >> 2] | 0, 315);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ww(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                h = b + 16 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                c[h >> 2] = Be() | 0;
	                if (!(c[h >> 2] | 0)) {
	                    if (c[34014] | 0)Db[c[135968 + 88 >> 2] & 511](0, 133880, d);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                c[l >> 2] = Ck(c[f >> 2] | 0, 0) | 0;
	                d = c[h >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    Ae(d);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                c[k >> 2] = ue(d) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ae(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                d = Jl(c[f >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 4 >> 2] = d;
	                c[c[k >> 2] >> 2] = c[l >> 2];
	                iz(c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0) | 0;
	                Oe(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[j >> 2] = Rk(c[f >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[(c[h >> 2] | 0) + 180 >> 2] = c[j >> 2];
	                c[(c[h >> 2] | 0) + 100 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 104 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 276 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 268 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 364 >> 2] = 1;
	                Qf(c[h >> 2] | 0) | 0;
	                if (c[(c[h >> 2] | 0) + 12 >> 2] | 0)c[g >> 2] = c[(c[h >> 2] | 0) + 8 >> 2]; else {
	                    c[g >> 2] = 0;
	                    Th(c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 0
	                }
	                Ae(c[h >> 2] | 0);
	                c[e >> 2] = c[g >> 2];
	                m = c[e >> 2] | 0;
	                i = b;
	                return m | 0
	            }

	            function xw(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[f >> 2] = a;
	                c[g >> 2] = Nw(c[f >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                c[h >> 2] = c[g >> 2];
	                while (1) {
	                    if (((d[c[h >> 2] >> 0] | 0 | 0) != 0 ? (d[c[h >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[h >> 2] >> 0] | 0 | 0) != 60 : 0) {
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)m = 1; else if ((d[c[h >> 2] >> 0] | 0 | 0) >= 97)m = (d[c[h >> 2] >> 0] | 0 | 0) <= 122; else m = 0;
	                        n = m ^ 1
	                    } else n = 0;
	                    o = c[h >> 2] | 0;
	                    if (!n)break;
	                    c[h >> 2] = o + 1
	                }
	                h = c[33474] | 0;
	                do if ((d[o >> 0] | 0 | 0) != 60) {
	                    c[j >> 2] = Ow(2, h) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    c[k >> 2] = Pw(c[j >> 2] | 0, c[g >> 2] | 0, c[f >> 2] | 0, 0) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        vw(c[j >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                } else {
	                    c[j >> 2] = Ow(1, h) | 0;
	                    if (c[j >> 2] | 0) {
	                        n = Qw(1, 0, 0, c[f >> 2] | 0, c[33474] | 0, 0) | 0;
	                        c[(c[j >> 2] | 0) + 60 >> 2] = n;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                c[e >> 2] = c[j >> 2];
	                l = c[e >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function yw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                do if (c[33468] | 0) {
	                    if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                        d = c[33976] | 0;
	                        b = c[33980] | 0;
	                        a = c[k >> 2] | 0;
	                        c[f >> 2] = c[j >> 2];
	                        c[f + 4 >> 2] = a;
	                        Db[d & 511](b, 133904, f);
	                        break
	                    }
	                    b = c[33976] | 0;
	                    d = c[33980] | 0;
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = c[j >> 2];
	                        Db[b & 511](d, 133936, f);
	                        break
	                    } else {
	                        c[f >> 2] = c[k >> 2];
	                        Db[b & 511](d, 133960, f);
	                        break
	                    }
	                } while (0);
	                f = c[h >> 2] | 0;
	                if ((c[c[h >> 2] >> 2] | 0) != 1) {
	                    c[m >> 2] = Uw(f, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    if (c[m >> 2] | 0)c[l >> 2] = my(c[m >> 2] | 0) | 0
	                } else {
	                    m = Rw(c[f + 60 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    c[l >> 2] = m;
	                    c[l >> 2] = (c[l >> 2] | 0) == (-1 | 0) ? 0 : m
	                }
	                c[g >> 2] = c[l >> 2];
	                n = c[g >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function zw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (c[33468] | 0) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[h >> 2];
	                    Db[b & 511](a, 133984, e)
	                }
	                e = c[g >> 2] | 0;
	                if ((c[c[g >> 2] >> 2] | 0) != 1) {
	                    c[k >> 2] = Uw(e, 0, c[h >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0)c[j >> 2] = my(c[k >> 2] | 0) | 0
	                } else {
	                    k = Vw(c[e + 60 >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[j >> 2] = k;
	                    c[j >> 2] = (c[j >> 2] | 0) == (-1 | 0) ? 0 : k
	                }
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Aw() {
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                if (c[33500] | 0) {
	                    i = b;
	                    return
	                }
	                Ww();
	                vx(c[33502] | 0);
	                if (cb(134016) | 0)c[33468] = 1;
	                if ((c[33510] | 0) == 0 ? (k = cb(134048) | 0, c[d >> 2] = k, c[d >> 2] = (c[d >> 2] | 0) == 0 ? 134072 : k, c[h >> 2] = Ow(1, c[33474] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[d >> 2];
	                    c[j >> 2] = (c[h >> 2] | 0) + 60;
	                    while (1) {
	                        if (!(a[c[f >> 2] >> 0] | 0))break;
	                        while (1) {
	                            do if ((a[c[f >> 2] >> 0] | 0) == 32)l = 1; else {
	                                if (9 <= (a[c[f >> 2] >> 0] | 0) ? (a[c[f >> 2] >> 0] | 0) <= 10 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                l = (a[c[f >> 2] >> 0] | 0) == 13
	                            } while (0);
	                            m = c[f >> 2] | 0;
	                            if (!l)break;
	                            c[f >> 2] = m + 1
	                        }
	                        if (!(a[m >> 0] | 0))continue;
	                        c[g >> 2] = c[f >> 2];
	                        while (1) {
	                            if (!(a[c[f >> 2] >> 0] | 0))break;
	                            do if ((a[c[f >> 2] >> 0] | 0) == 32)n = 1; else {
	                                if (9 <= (a[c[f >> 2] >> 0] | 0) ? (a[c[f >> 2] >> 0] | 0) <= 10 : 0) {
	                                    n = 1;
	                                    break
	                                }
	                                n = (a[c[f >> 2] >> 0] | 0) == 13
	                            } while (0);
	                            if (!(n ^ 1))break;
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        c[e >> 2] = ly(c[g >> 2] | 0, (c[f >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                        if (!(c[e >> 2] | 0))continue;
	                        d = Qw(1, 0, 0, c[e >> 2] | 0, c[33474] | 0, 0) | 0;
	                        c[c[j >> 2] >> 2] = d;
	                        if (c[c[j >> 2] >> 2] | 0)c[j >> 2] = c[c[j >> 2] >> 2];
	                        zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                    }
	                    c[33510] = c[h >> 2]
	                }
	                wx(c[33502] | 0);
	                i = b;
	                return
	            }

	            function Bw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[33500] | 0))Ww();
	                vx(c[33502] | 0);
	                if (c[33510] | 0) {
	                    c[f >> 2] = Xw(c[33510] | 0, c[e >> 2] | 0) | 0;
	                    wx(c[33502] | 0);
	                    c[d >> 2] = c[f >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = xw(c[e >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    wx(c[33502] | 0);
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else {
	                    c[33510] = c[g >> 2];
	                    wx(c[33502] | 0);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function Cw(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[f >> 2] = c[e >> 2];
	                a:while (1) {
	                    if (!(a[c[f >> 2] >> 0] | 0))break;
	                    while (1) {
	                        do if ((a[c[f >> 2] >> 0] | 0) == 32)j = 1; else {
	                            if (9 <= (a[c[f >> 2] >> 0] | 0) ? (a[c[f >> 2] >> 0] | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (a[c[f >> 2] >> 0] | 0) == 13
	                        } while (0);
	                        k = c[f >> 2] | 0;
	                        if (!j)break;
	                        c[f >> 2] = k + 1
	                    }
	                    if (a[k >> 0] | 0) {
	                        c[g >> 2] = c[f >> 2];
	                        while (1) {
	                            if (!(a[c[f >> 2] >> 0] | 0))break;
	                            if ((a[c[f >> 2] >> 0] | 0) == 58)break;
	                            do if ((a[c[f >> 2] >> 0] | 0) == 32)l = 1; else {
	                                if (9 <= (a[c[f >> 2] >> 0] | 0) ? (a[c[f >> 2] >> 0] | 0) <= 10 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                l = (a[c[f >> 2] >> 0] | 0) == 13
	                            } while (0);
	                            if (!(l ^ 1))break;
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        c[h >> 2] = ly(c[g >> 2] | 0, (c[f >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                        if (c[h >> 2] | 0) {
	                            Bw(c[h >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0)
	                        }
	                    }
	                    while (1) {
	                        if ((a[c[f >> 2] >> 0] | 0) != 58)continue a;
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                }
	                i = d;
	                return
	            }

	            function Dw() {
	                var a = 0;
	                a = i;
	                i = i + 16 | 0;
	                if (!(c[33500] | 0)) {
	                    i = a;
	                    return
	                }
	                vx(c[33502] | 0);
	                if (c[33468] | 0)Db[c[135904 >> 2] & 511](c[33980] | 0, 134096, a);
	                if (c[33530] | 0)Kj(c[33530] | 0, 316);
	                c[33530] = 0;
	                if (c[33510] | 0)vw(c[33510] | 0);
	                c[33510] = 0;
	                c[33468] = 0;
	                c[33500] = 0;
	                wx(c[33502] | 0);
	                ux(c[33502] | 0);
	                i = a;
	                return
	            }

	            function Ew(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[33500] | 0))Aw();
	                c[g >> 2] = yw(c[33510] | 0, c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return c[g >> 2] | 0
	            }

	            function Fw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[33500] | 0))Aw();
	                c[e >> 2] = zw(c[33510] | 0, c[d >> 2] | 0) | 0;
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Gw() {
	                return c[33534] | 0
	            }

	            function Hw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[33500] | 0))Aw();
	                c[e >> 2] = c[d >> 2];
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Lw(c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function Iw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[33500] | 0))Aw();
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = c[g >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (c[33468] | 0) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[h >> 2];
	                    Db[b & 511](a, 134144, e)
	                }
	                c[k >> 2] = Qw(1, 0, c[h >> 2] | 0, 0, c[33474] | 0, 0) | 0;
	                h = c[g >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = h;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = h;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                while (1) {
	                    if (!(c[c[j >> 2] >> 2] | 0))break;
	                    c[j >> 2] = c[c[j >> 2] >> 2]
	                }
	                c[c[j >> 2] >> 2] = c[k >> 2];
	                c[f >> 2] = c[g >> 2];
	                l = c[f >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Jw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                if (!(c[33500] | 0))Aw();
	                if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                do if (c[33468] | 0) {
	                    if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                        d = c[33976] | 0;
	                        b = c[33980] | 0;
	                        a = c[k >> 2] | 0;
	                        c[f >> 2] = c[j >> 2];
	                        c[f + 4 >> 2] = a;
	                        Db[d & 511](b, 134176, f);
	                        break
	                    }
	                    b = c[33976] | 0;
	                    d = c[33980] | 0;
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = c[j >> 2];
	                        Db[b & 511](d, 134216, f);
	                        break
	                    } else {
	                        c[f >> 2] = c[k >> 2];
	                        Db[b & 511](d, 134248, f);
	                        break
	                    }
	                } while (0);
	                c[l >> 2] = c[h >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[m >> 2] = Rw(c[l >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                if ((c[m >> 2] | 0) != 0 & (c[m >> 2] | 0) != (-1 | 0)) {
	                    c[g >> 2] = c[m >> 2];
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function Kw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[33500] | 0))Aw();
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (c[33468] | 0) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[h >> 2];
	                    Db[b & 511](a, 133984, e)
	                }
	                c[j >> 2] = c[g >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[k >> 2] = Vw(c[j >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) != 0 & (c[k >> 2] | 0) != (-1 | 0)) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Lw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    Mw(c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function Mw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 1) {
	                    i = b;
	                    return
	                }
	                do if (c[33468] | 0) {
	                    if (c[(c[e >> 2] | 0) + 16 >> 2] | 0) {
	                        a = c[33976] | 0;
	                        f = c[33980] | 0;
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        Db[a & 511](f, 135680, d);
	                        break
	                    }
	                    f = c[33976] | 0;
	                    a = c[33980] | 0;
	                    if (c[(c[e >> 2] | 0) + 20 >> 2] | 0) {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        Db[f & 511](a, 135680, d);
	                        break
	                    } else {
	                        Db[f & 511](a, 135704, d);
	                        break
	                    }
	                } while (0);
	                if (c[(c[e >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 24 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function Nw(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 112 | 0;
	                e = d + 100 | 0;
	                f = d + 96 | 0;
	                g = d + 92 | 0;
	                h = d + 88 | 0;
	                j = d + 84 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (($a(c[f >> 2] | 0, k | 0) | 0) < 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                b = La(c[f >> 2] | 0, 0, d | 0) | 0;
	                c[g >> 2] = b;
	                if ((b | 0) < 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[j >> 2] = c[k + 36 >> 2];
	                c[l >> 2] = Cb[c[135752 >> 2] & 511]((c[j >> 2] | 0) + 10 | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    Zw(135656);
	                    Ra(c[g >> 2] | 0) | 0;
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[h >> 2] = eb(c[g >> 2] | 0, c[l >> 2] | 0, c[j >> 2] | 0) | 0;
	                Ra(c[g >> 2] | 0) | 0;
	                if ((c[h >> 2] | 0) < 0) {
	                    zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else {
	                    a[(c[l >> 2] | 0) + (c[h >> 2] | 0) >> 0] = 0;
	                    c[e >> 2] = c[l >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function Ow(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    Zw(135632);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 64 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[c[h >> 2] >> 2] = c[f >> 2];
	                c[(c[h >> 2] | 0) + 44 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 48 >> 2] = 10;
	                c[(c[h >> 2] | 0) + 56 >> 2] = c[g >> 2];
	                if ((c[c[h >> 2] >> 2] | 0) == 2) {
	                    g = Ij(10) | 0;
	                    c[(c[h >> 2] | 0) + 52 >> 2] = g
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Pw(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 60 | 0;
	                j = g + 56 | 0;
	                k = g + 52 | 0;
	                l = g + 48 | 0;
	                m = g + 44 | 0;
	                n = g + 40 | 0;
	                o = g + 36 | 0;
	                p = g + 32 | 0;
	                q = g + 28 | 0;
	                r = g + 24 | 0;
	                s = g + 20 | 0;
	                t = g + 16 | 0;
	                u = g + 12 | 0;
	                v = g + 8 | 0;
	                w = g + 4 | 0;
	                x = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = c[k >> 2];
	                c[o >> 2] = 0;
	                if ((c[n >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    y = c[h >> 2] | 0;
	                    i = g;
	                    return y | 0
	                }
	                c[o >> 2] = my(c[l >> 2] | 0) | 0;
	                a:while (1) {
	                    if (!(c[n >> 2] | 0))break;
	                    while (1) {
	                        if (!(d[c[n >> 2] >> 0] | 0))break a;
	                        while (1) {
	                            do if ((d[c[n >> 2] >> 0] | 0 | 0) == 32)z = 1; else {
	                                if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    z = 1;
	                                    break
	                                }
	                                z = (d[c[n >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            A = c[n >> 2] | 0;
	                            if (!z)break;
	                            c[n >> 2] = A + 1
	                        }
	                        if (!(d[A >> 0] | 0))break a;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) != 45)break;
	                        if ((d[(c[n >> 2] | 0) + 1 >> 0] | 0 | 0) != 45)break;
	                        c[n >> 2] = _w(c[n >> 2] | 0) | 0;
	                        if (!((c[n >> 2] | 0) != 0 & (c[n >> 2] | 0) != 0))break a
	                    }
	                    c[q >> 2] = 0;
	                    c[r >> 2] = 0;
	                    c[s >> 2] = 0;
	                    c[n >> 2] = $w(c[n >> 2] | 0, r) | 0;
	                    if (!(c[r >> 2] | 0))break;
	                    do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    b:while (1) {
	                        do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)break b
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    do if (!(qy(c[r >> 2] | 0, 134936) | 0)) {
	                        if (qy(c[r >> 2] | 0, 134944) | 0) {
	                            c[s >> 2] = 14;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 134952) | 0) {
	                            c[s >> 2] = 20;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 134968) | 0) {
	                            c[s >> 2] = 15;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 134976) | 0) {
	                            c[s >> 2] = 17;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 134984) | 0) {
	                            c[s >> 2] = 18;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 135e3) | 0) {
	                            c[s >> 2] = 19;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 135016) | 0) {
	                            c[s >> 2] = 24;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 135032) | 0) {
	                            c[s >> 2] = 23;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 135048) | 0) {
	                            c[s >> 2] = 22;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 135056) | 0) {
	                            c[s >> 2] = 21;
	                            break
	                        }
	                        if (qy(c[r >> 2] | 0, 135592) | 0) {
	                            zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                            c[n >> 2] = $w(c[n >> 2] | 0, r) | 0;
	                            if (!(c[r >> 2] | 0))break a;
	                            zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                            continue a
	                        }
	                    } else c[s >> 2] = 13; while (0);
	                    zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    c[r >> 2] = 0;
	                    c:do switch (c[s >> 2] | 0) {
	                        case 24:
	                        case 23:
	                        case 22:
	                        case 21:
	                        {
	                            c[n >> 2] = ax(c[n >> 2] | 0, q) | 0;
	                            break
	                        }
	                        case 19:
	                        case 18:
	                        case 17:
	                        case 16:
	                        {
	                            B = 54;
	                            break
	                        }
	                        case 20:
	                        case 13:
	                        case 14:
	                        {
	                            c[n >> 2] = ax(c[n >> 2] | 0, r) | 0;
	                            if (c[n >> 2] | 0) {
	                                do if ((c[s >> 2] | 0) != 13 ? (c[t >> 2] = bx(c[r >> 2] | 0) | 0, (c[t >> 2] | 0) != 0) : 0) {
	                                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                    if (d[c[t >> 2] >> 0] | 0) {
	                                        c[r >> 2] = c[t >> 2];
	                                        break
	                                    } else {
	                                        zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                                        c[r >> 2] = 0;
	                                        break
	                                    }
	                                } while (0);
	                                do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                                    if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                    if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)break c
	                                } while (0);
	                                while (1) {
	                                    do if ((d[c[n >> 2] >> 0] | 0 | 0) == 32)C = 1; else {
	                                        if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                            C = 1;
	                                            break
	                                        }
	                                        C = (d[c[n >> 2] >> 0] | 0 | 0) == 13
	                                    } while (0);
	                                    D = c[n >> 2] | 0;
	                                    if (!C)break;
	                                    c[n >> 2] = D + 1
	                                }
	                                c[n >> 2] = ax(D, q) | 0
	                            }
	                            break
	                        }
	                        case 15:
	                        {
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) == 37) {
	                                c[s >> 2] = 16;
	                                B = 54
	                            } else B = 54;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    d:do if ((B | 0) == 54 ? (B = 0, c[n >> 2] = $w(c[n >> 2] | 0, r) | 0, (c[n >> 2] | 0) != 0) : 0) {
	                        do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)break d
	                        } while (0);
	                        while (1) {
	                            do if ((d[c[n >> 2] >> 0] | 0 | 0) == 32)E = 1; else {
	                                if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    E = 1;
	                                    break
	                                }
	                                E = (d[c[n >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            F = c[n >> 2] | 0;
	                            if (!E)break;
	                            c[n >> 2] = F + 1
	                        }
	                        c[n >> 2] = ax(F, q) | 0
	                    } while (0);
	                    if (!(c[n >> 2] | 0)) {
	                        B = 87;
	                        break
	                    }
	                    do if ((c[s >> 2] | 0) != 21) {
	                        if ((c[s >> 2] | 0) == 14 | (c[s >> 2] | 0) == 13) {
	                            c[u >> 2] = Hl(c[q >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[u >> 2] | 0))break;
	                            c[v >> 2] = Qw(c[s >> 2] | 0, c[r >> 2] | 0, c[u >> 2] | 0, 0, 0, 0) | 0;
	                            c[p >> 2] = Lj(c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[r >> 2] | 0, c[v >> 2] | 0) | 0;
	                            if ((c[p >> 2] | 0) < 0)Mw(c[v >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                            break
	                        }
	                        if ((c[s >> 2] | 0) == 22)if (c[m >> 2] | 0) {
	                            c[w >> 2] = Qw(c[s >> 2] | 0, c[q >> 2] | 0, 0, 0, 0, 0) | 0;
	                            c[p >> 2] = Lj(c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[q >> 2] | 0, c[w >> 2] | 0) | 0;
	                            if ((c[p >> 2] | 0) >= 0)break;
	                            Mw(c[w >> 2] | 0);
	                            break
	                        } else {
	                            c[x >> 2] = Hl(c[q >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[x >> 2] | 0))break;
	                            Xw(c[j >> 2] | 0, c[x >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                            break
	                        }
	                    } else {
	                        if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[o >> 2] = my(c[q >> 2] | 0) | 0
	                    } while (0);
	                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    if (!(c[q >> 2] | 0))continue;
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0)
	                }
	                if ((B | 0) == 87) {
	                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0)
	                }
	                if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                if (!(c[n >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    y = c[h >> 2] | 0;
	                    i = g;
	                    return y | 0
	                } else {
	                    c[h >> 2] = 0;
	                    y = c[h >> 2] | 0;
	                    i = g;
	                    return y | 0
	                }
	                return 0
	            }

	            function Qw(a, b, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 20 | 0;
	                o = j + 16 | 0;
	                p = j + 12 | 0;
	                q = j + 8 | 0;
	                r = j + 4 | 0;
	                s = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[s >> 2] = 0;
	                c[r >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    Zw(135528);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                c[c[r >> 2] >> 2] = 0;
	                c[(c[r >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[r >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[r >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                if ((c[l >> 2] | 0) == 5 | (c[l >> 2] | 0) == 8 ? (c[s >> 2] = bx(c[m >> 2] | 0) | 0, (c[s >> 2] | 0) != 0) : 0)c[m >> 2] = (d[c[s >> 2] >> 0] | 0 | 0) != 0 ? c[s >> 2] | 0 : 0;
	                if (c[m >> 2] | 0) {
	                    l = my(c[m >> 2] | 0) | 0;
	                    c[(c[r >> 2] | 0) + 16 >> 2] = l
	                } else c[(c[r >> 2] | 0) + 16 >> 2] = 0;
	                if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                if (c[n >> 2] | 0) {
	                    s = my(c[n >> 2] | 0) | 0;
	                    c[(c[r >> 2] | 0) + 20 >> 2] = s
	                } else c[(c[r >> 2] | 0) + 20 >> 2] = 0;
	                if (!(c[o >> 2] | 0))c[o >> 2] = c[n >> 2];
	                if (c[o >> 2] | 0) {
	                    n = my(c[o >> 2] | 0) | 0;
	                    c[(c[r >> 2] | 0) + 24 >> 2] = n
	                } else c[(c[r >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[r >> 2] | 0) + 28 >> 2] = c[p >> 2];
	                c[(c[r >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[r >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[r >> 2] | 0) + 40 >> 2] = c[q >> 2];
	                c[k >> 2] = c[r >> 2];
	                t = c[k >> 2] | 0;
	                i = j;
	                return t | 0
	            }

	            function Rw(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((c[k >> 2] | 0) == 0 & (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[o >> 2] = bx(c[k >> 2] | 0) | 0;
	                if (c[o >> 2] | 0)c[k >> 2] = (d[c[o >> 2] >> 0] | 0 | 0) != 0 ? c[o >> 2] | 0 : 0;
	                if (!(sy(c[k >> 2] | 0, 135064, 13) | 0)) {
	                    c[n >> 2] = cx(c[k >> 2] | 0) | 0;
	                    do if (c[33468] | 0) {
	                        e = c[33976] | 0;
	                        b = c[33980] | 0;
	                        if (!(c[n >> 2] | 0)) {
	                            c[g >> 2] = c[k >> 2];
	                            Db[e & 511](b, 135256, g);
	                            break
	                        } else {
	                            c[g >> 2] = c[n >> 2];
	                            Db[e & 511](b, 135296, g);
	                            break
	                        }
	                    } while (0);
	                    c[m >> 2] = Rw(c[j >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[h >> 2] = c[m >> 2];
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (sy(c[l >> 2] | 0, 135064, 13) | 0) {
	                    while (1) {
	                        if (!(c[j >> 2] | 0))break;
	                        if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 1) {
	                            if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0))dx(c[j >> 2] | 0) | 0;
	                            if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                                c[m >> 2] = ex(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                                if (c[m >> 2] | 0)break;
	                                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] | 0) > 50 : 0) {
	                                    q = 40;
	                                    break
	                                }
	                            }
	                        }
	                        c[j >> 2] = c[c[j >> 2] >> 2]
	                    }
	                    if ((q | 0) == 40)c[m >> 2] = 0;
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[h >> 2] = c[m >> 2];
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[n >> 2] = cx(c[l >> 2] | 0) | 0;
	                do if (c[33468] | 0) {
	                    q = c[33976] | 0;
	                    b = c[33980] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[g >> 2] = c[l >> 2];
	                        Db[q & 511](b, 135328, g);
	                        break
	                    } else {
	                        c[g >> 2] = c[n >> 2];
	                        Db[q & 511](b, 135368, g);
	                        break
	                    }
	                } while (0);
	                do if (c[k >> 2] | 0) {
	                    g = (qy(c[k >> 2] | 0, c[n >> 2] | 0) | 0) != 0;
	                    l = c[j >> 2] | 0;
	                    b = c[k >> 2] | 0;
	                    if (g) {
	                        c[m >> 2] = Rw(l, b, 0) | 0;
	                        break
	                    } else {
	                        c[m >> 2] = Rw(l, b, c[n >> 2] | 0) | 0;
	                        break
	                    }
	                } else c[m >> 2] = Rw(c[j >> 2] | 0, c[n >> 2] | 0, 0) | 0; while (0);
	                if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                c[h >> 2] = c[m >> 2];
	                p = c[h >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function Sw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    c[h >> 2] = Rj(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 13) {
	                        c[e >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                        break
	                    } else {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Tw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = bx(c[h >> 2] | 0) | 0;
	                if (c[k >> 2] | 0)c[h >> 2] = (d[c[k >> 2] >> 0] | 0 | 0) != 0 ? c[k >> 2] | 0 : 0;
	                c[j >> 2] = Rj(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                h = (c[k >> 2] | 0) != 0;
	                if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 14) {
	                    if (h)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    if (h)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Uw(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if (!(c[(c[g >> 2] | 0) + 52 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (c[h >> 2] | 0)c[k >> 2] = Tw(c[(c[g >> 2] | 0) + 52 >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (c[j >> 2] | 0)c[k >> 2] = Sw(c[(c[g >> 2] | 0) + 52 >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Vw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(sy(c[h >> 2] | 0, 135064, 13) | 0)) {
	                    c[k >> 2] = cx(c[h >> 2] | 0) | 0;
	                    do if (c[33468] | 0) {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            c[e >> 2] = c[h >> 2];
	                            Db[b & 511](a, 135080, e);
	                            break
	                        } else {
	                            c[e >> 2] = c[k >> 2];
	                            Db[b & 511](a, 135112, e);
	                            break
	                        }
	                    } while (0);
	                    c[j >> 2] = Rw(c[g >> 2] | 0, c[k >> 2] | 0, 0) | 0;
	                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        m = 21;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 1) {
	                        if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0))dx(c[g >> 2] | 0) | 0;
	                        if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[j >> 2] = fx(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                            m = 19;
	                            break
	                        }
	                    }
	                    c[g >> 2] = c[c[g >> 2] >> 2]
	                }
	                if ((m | 0) == 19) {
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 21) {
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Ww() {
	                var a = 0;
	                a = i;
	                if (c[33500] | 0) {
	                    i = a;
	                    return
	                }
	                if (cb(134016) | 0)c[33468] = 1;
	                c[33502] = tx() | 0;
	                c[33500] = 1;
	                i = a;
	                return
	            }

	            function Xw(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                b = c[g >> 2] | 0;
	                do if ((c[c[f >> 2] >> 2] | 0) == 2) {
	                    c[j >> 2] = Nw(b) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[h >> 2] = Pw(c[f >> 2] | 0, c[j >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                    a = (c[h >> 2] | 0) < 0;
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    if (a) {
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                } else {
	                    c[k >> 2] = Qw(1, 0, 0, b, c[33474] | 0, 0) | 0;
	                    c[l >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                    if (!(c[l >> 2] | 0)) {
	                        c[(c[f >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                        break
	                    }
	                    while (1) {
	                        if (!(c[c[l >> 2] >> 2] | 0))break;
	                        c[l >> 2] = c[c[l >> 2] >> 2]
	                    }
	                    c[c[l >> 2] >> 2] = c[k >> 2]
	                } while (0);
	                c[e >> 2] = 0;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function Yw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = c[(c[d >> 2] | 0) + 8 >> 2];
	                while (1) {
	                    if (!(c[e >> 2] | 0))break;
	                    c[f >> 2] = c[c[e >> 2] >> 2];
	                    c[(c[e >> 2] | 0) + 32 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 0;
	                    Mw(c[e >> 2] | 0);
	                    c[e >> 2] = c[f >> 2]
	                }
	                c[(c[d >> 2] | 0) + 32 >> 2] = 0;
	                Mw(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Zw(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                c[d >> 2] = c[e >> 2];
	                Xd(0, 0, 0, 0, 0, 20, 2, 2, 0, 0, a, 0, 0, 0, 0, 135560, d);
	                i = b;
	                return
	            }

	            function _w(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[f >> 2] = a;
	                if ((d[c[f >> 2] >> 0] | 0 | 0) == 45 ? (d[(c[f >> 2] | 0) + 1 >> 0] | 0 | 0) == 45 : 0) {
	                    c[f >> 2] = (c[f >> 2] | 0) + 2;
	                    while (1) {
	                        if (d[c[f >> 2] >> 0] | 0)if ((d[c[f >> 2] >> 0] | 0 | 0) != 45)g = 1; else g = (d[(c[f >> 2] | 0) + 1 >> 0] | 0 | 0) != 45; else g = 0;
	                        h = c[f >> 2] | 0;
	                        if (!g)break;
	                        c[f >> 2] = h + 1
	                    }
	                    if (!(d[h >> 0] | 0)) {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } else {
	                        c[e >> 2] = (c[f >> 2] | 0) + 2;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                }
	                c[e >> 2] = c[f >> 2];
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function $w(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 128 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 20 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[l >> 2] = 0;
	                c[c[j >> 2] >> 2] = 0;
	                c[m >> 2] = d[c[h >> 2] >> 0];
	                e = c[m >> 2] | 0;
	                if ((c[m >> 2] | 0) < 256) {
	                    if (((!(65 <= (e | 0) & (c[m >> 2] | 0) <= 90) ? !(97 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 122) : 0) ? !(192 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 214) : 0) ? !(216 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 246 | 248 <= (c[m >> 2] | 0)) : 0)n = 7
	                } else if (!(DQ(e, 199744) | 0))n = 7;
	                do if ((n | 0) == 7) {
	                    e = c[m >> 2] | 0;
	                    if ((c[m >> 2] | 0) < 256) {
	                        if (!((e | 0) != 95 & (c[m >> 2] | 0) != 58))break
	                    } else {
	                        if (19968 <= (e | 0) & (c[m >> 2] | 0) <= 40869 | (c[m >> 2] | 0) == 12295)break;
	                        if (!((12321 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 12329 ^ 1) & (c[m >> 2] | 0) != 95 & (c[m >> 2] | 0) != 58))break
	                    }
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } while (0);
	                a:while (1) {
	                    e = c[m >> 2] | 0;
	                    if ((c[m >> 2] | 0) < 256) {
	                        if (((!(65 <= (e | 0) & (c[m >> 2] | 0) <= 90) ? !(97 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 122) : 0) ? !(192 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 214) : 0) ? !(216 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 246 | 248 <= (c[m >> 2] | 0)) : 0)n = 18
	                    } else if (!(DQ(e, 199744) | 0))n = 18;
	                    do if ((n | 0) == 18) {
	                        n = 0;
	                        if ((c[m >> 2] | 0) >= 256) {
	                            if (19968 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 40869 | (c[m >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 12329)break
	                        }
	                        e = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) < 256)if (48 <= (e | 0) & (c[m >> 2] | 0) <= 57 | (c[m >> 2] | 0) == 46 | (c[m >> 2] | 0) == 45 | (c[m >> 2] | 0) == 95 | (c[m >> 2] | 0) == 58)break; else {
	                            n = 26;
	                            break a
	                        } else {
	                            b = (DQ(e, 200216) | 0) != 0;
	                            if (b | (c[m >> 2] | 0) == 46 | (c[m >> 2] | 0) == 45 | (c[m >> 2] | 0) == 95 | (c[m >> 2] | 0) == 58)break; else {
	                                n = 26;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    b = c[m >> 2] & 255;
	                    e = c[l >> 2] | 0;
	                    c[l >> 2] = e + 1;
	                    a[k + e >> 0] = b;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[m >> 2] = d[c[h >> 2] >> 0];
	                    if ((c[l >> 2] | 0) >= 100) {
	                        n = 25;
	                        break
	                    }
	                }
	                if ((n | 0) == 25) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } else if ((n | 0) == 26) {
	                    n = ly(k, c[l >> 2] | 0) | 0;
	                    c[c[j >> 2] >> 2] = n;
	                    c[g >> 2] = c[h >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                return 0
	            }

	            function ax(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f + 32 | 0;
	                p = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 50;
	                c[p >> 2] = 0;
	                c[c[j >> 2] >> 2] = 0;
	                e = c[h >> 2] | 0;
	                do if ((d[c[h >> 2] >> 0] | 0 | 0) != 34)if ((d[e >> 0] | 0 | 0) == 39) {
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    a[o >> 0] = 39;
	                    break
	                } else {
	                    a[o >> 0] = 32;
	                    break
	                } else {
	                    c[h >> 2] = e + 1;
	                    a[o >> 0] = 34
	                } while (0);
	                c[k >> 2] = Cb[c[135752 >> 2] & 511](c[n >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Zw(135608);
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                while (1) {
	                    if ((d[198696 + (d[c[h >> 2] >> 0] | 0) >> 0] | 0 | 0) == 0 ? (d[c[h >> 2] >> 0] | 0 | 0) != 63 : 0)break;
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) == (d[o >> 0] | 0 | 0) ? (d[o >> 0] | 0 | 0) != 32 : 0)break;
	                    if ((d[o >> 0] | 0 | 0) == 32) {
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)break;
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) == 13)break
	                    }
	                    if (((c[m >> 2] | 0) + 1 | 0) >= (c[n >> 2] | 0)) {
	                        c[n >> 2] = c[n >> 2] << 1;
	                        c[l >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            r = 19;
	                            break
	                        }
	                        c[k >> 2] = c[l >> 2]
	                    }
	                    e = a[c[h >> 2] >> 0] | 0;
	                    b = c[m >> 2] | 0;
	                    c[m >> 2] = b + 1;
	                    a[(c[k >> 2] | 0) + b >> 0] = e;
	                    c[p >> 2] = (c[p >> 2] | 0) + 1;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((r | 0) == 19) {
	                    Zw(135608);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                a[(c[k >> 2] | 0) + (c[m >> 2] | 0) >> 0] = 0;
	                m = d[c[h >> 2] >> 0] | 0;
	                do if ((d[o >> 0] | 0 | 0) == 32) {
	                    if ((m | 0) != 32) {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 13) {
	                            zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                            c[g >> 2] = 0;
	                            q = c[g >> 2] | 0;
	                            i = f;
	                            return q | 0
	                        }
	                    }
	                } else {
	                    if ((m | 0) == (d[o >> 0] | 0 | 0)) {
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } while (0);
	                c[c[j >> 2] >> 2] = c[k >> 2];
	                c[g >> 2] = c[h >> 2];
	                q = c[g >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function bx(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = b;
	                c[h >> 2] = 1;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[j >> 2] = 1;
	                c[k >> 2] = c[g >> 2];
	                while (1) {
	                    if (!((c[h >> 2] | 0) != 0 ? (d[c[k >> 2] >> 0] | 0 | 0) != 0 : 0))break;
	                    do if ((d[c[k >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            o = 10;
	                            break
	                        }
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) != 13)c[j >> 2] = 0; else o = 10
	                    } else o = 10; while (0);
	                    do if ((o | 0) == 10) {
	                        o = 0;
	                        if ((c[j >> 2] | 0) != 0 ? 1 : (d[c[k >> 2] >> 0] | 0 | 0) != 32) {
	                            c[h >> 2] = 0;
	                            break
	                        } else {
	                            c[j >> 2] = 1;
	                            break
	                        }
	                    } while (0);
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if (!((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) != 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[l >> 2] = my(c[g >> 2] | 0) | 0;
	                c[m >> 2] = c[l >> 2];
	                c[j >> 2] = 0;
	                c[k >> 2] = c[g >> 2];
	                while (1) {
	                    if (!(d[c[k >> 2] >> 0] | 0))break;
	                    do if ((d[c[k >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            o = 22;
	                            break
	                        }
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) != 13) {
	                            if (c[j >> 2] | 0) {
	                                g = c[m >> 2] | 0;
	                                c[m >> 2] = g + 1;
	                                a[g >> 0] = 32;
	                                c[j >> 2] = 0
	                            }
	                            g = a[c[k >> 2] >> 0] | 0;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = g
	                        } else o = 22
	                    } else o = 22; while (0);
	                    if ((o | 0) == 22 ? (o = 0, (c[m >> 2] | 0) != (c[l >> 2] | 0)) : 0)c[j >> 2] = 1;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                a[c[m >> 2] >> 0] = 0;
	                c[f >> 2] = c[l >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function cx(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 2016 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e + 16 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                if (sy(c[g >> 2] | 0, 135064, 13) | 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[g >> 2] = (c[g >> 2] | 0) + 13;
	                a:while (1) {
	                    if ((c[j >> 2] | 0) >>> 0 > 1996 ? 1 : (d[c[g >> 2] >> 0] | 0 | 0) == 0)break;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 43) {
	                        b = c[j >> 2] | 0;
	                        c[j >> 2] = b + 1;
	                        a[h + b >> 0] = 32;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 58) {
	                        b = c[j >> 2] | 0;
	                        c[j >> 2] = b + 1;
	                        a[h + b >> 0] = 47;
	                        b = c[j >> 2] | 0;
	                        c[j >> 2] = b + 1;
	                        a[h + b >> 0] = 47;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 59) {
	                        b = c[j >> 2] | 0;
	                        c[j >> 2] = b + 1;
	                        a[h + b >> 0] = 58;
	                        b = c[j >> 2] | 0;
	                        c[j >> 2] = b + 1;
	                        a[h + b >> 0] = 58;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        continue
	                    }
	                    b = c[g >> 2] | 0;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 37) {
	                        l = a[b >> 0] | 0;
	                        m = c[j >> 2] | 0;
	                        c[j >> 2] = m + 1;
	                        a[h + m >> 0] = l;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((d[b + 1 >> 0] | 0 | 0) == 50 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 66 : 0) {
	                        b = c[j >> 2] | 0;
	                        c[j >> 2] = b + 1;
	                        a[h + b >> 0] = 43
	                    } else n = 15;
	                    do if ((n | 0) == 15) {
	                        n = 0;
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 51 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 65 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 58;
	                            break
	                        }
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 50 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 70 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 47;
	                            break
	                        }
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 51 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 66 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 59;
	                            break
	                        }
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 50 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 55 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 39;
	                            break
	                        }
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 51 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 70 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 63;
	                            break
	                        }
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 50 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 51 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 35;
	                            break
	                        }
	                        if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 50 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 53 : 0) {
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[h + b >> 0] = 37;
	                            break
	                        }
	                        b = a[c[g >> 2] >> 0] | 0;
	                        l = c[j >> 2] | 0;
	                        c[j >> 2] = l + 1;
	                        a[h + l >> 0] = b;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        continue a
	                    } while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 3
	                }
	                a[h + (c[j >> 2] | 0) >> 0] = 0;
	                c[f >> 2] = my(h) | 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function dx(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                vx(c[33502] | 0);
	                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                    wx(c[33502] | 0);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                do if (c[33530] | 0) {
	                    c[g >> 2] = Rj(c[33530] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    a = (c[33468] | 0) != 0;
	                    if (!(c[g >> 2] | 0)) {
	                        if (!a)break;
	                        j = c[33976] | 0;
	                        k = c[33980] | 0;
	                        c[d >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        Db[j & 511](k, 134304, d);
	                        break
	                    }
	                    if (a) {
	                        a = c[33976] | 0;
	                        k = c[33980] | 0;
	                        c[d >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        Db[a & 511](k, 134280, d)
	                    }
	                    k = c[g >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 1)c[(c[f >> 2] | 0) + 8 >> 2] = c[k + 8 >> 2]; else c[(c[f >> 2] | 0) + 8 >> 2] = k;
	                    c[(c[f >> 2] | 0) + 32 >> 2] = 0;
	                    wx(c[33502] | 0);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } while (0);
	                c[g >> 2] = gx(c[(c[f >> 2] | 0) + 28 >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                k = (c[f >> 2] | 0) + 12 | 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[k >> 2] = 2;
	                    wx(c[33502] | 0);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a = c[g >> 2] | 0;
	                if ((c[k >> 2] | 0) == 1)c[(c[f >> 2] | 0) + 8 >> 2] = c[a + 8 >> 2]; else c[(c[f >> 2] | 0) + 8 >> 2] = a;
	                c[(c[g >> 2] | 0) + 32 >> 2] = 1;
	                if (!(c[33530] | 0))c[33530] = Ij(10) | 0;
	                if (c[33530] | 0) {
	                    if (c[33468] | 0) {
	                        a = c[33976] | 0;
	                        k = c[33980] | 0;
	                        c[d >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        Db[a & 511](k, 134336, d)
	                    }
	                    Lj(c[33530] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[g >> 2] | 0) | 0
	                }
	                wx(c[33502] | 0);
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function ex(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                e = i;
	                i = i + 480 | 0;
	                f = e;
	                g = e + 464 | 0;
	                h = e + 460 | 0;
	                j = e + 456 | 0;
	                k = e + 452 | 0;
	                l = e + 448 | 0;
	                m = e + 444 | 0;
	                n = e + 440 | 0;
	                o = e + 436 | 0;
	                p = e + 432 | 0;
	                q = e + 428 | 0;
	                r = e + 424 | 0;
	                s = e + 224 | 0;
	                t = e + 220 | 0;
	                u = e + 216 | 0;
	                v = e + 16 | 0;
	                w = e + 12 | 0;
	                x = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                d = c[h >> 2] | 0;
	                if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) > 50) {
	                    hx(d, 0, 1654, 135136, c[(c[h >> 2] | 0) + 16 >> 2] | 0, 0, 0);
	                    c[g >> 2] = 0;
	                    y = c[g >> 2] | 0;
	                    i = e;
	                    return y | 0
	                }
	                b = d + 36 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                if (c[k >> 2] | 0) {
	                    c[p >> 2] = 0;
	                    c[q >> 2] = 0;
	                    c[m >> 2] = c[h >> 2];
	                    c[n >> 2] = 0;
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break;
	                        b = c[(c[m >> 2] | 0) + 12 >> 2] | 0;
	                        if ((b | 0) == 7) {
	                            c[r >> 2] = xy(c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0;
	                            if ((c[r >> 2] | 0) > (c[q >> 2] | 0) ? (sy(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0, c[r >> 2] | 0) | 0) == 0 : 0) {
	                                c[q >> 2] = c[r >> 2];
	                                c[p >> 2] = c[m >> 2]
	                            }
	                        } else if ((b | 0) == 3)c[o >> 2] = (c[o >> 2] | 0) + 1; else if ((b | 0) == 6) {
	                            if (qy(c[k >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) {
	                                z = 8;
	                                break
	                            }
	                        } else if ((b | 0) == 9 ? (b = c[k >> 2] | 0, d = c[(c[m >> 2] | 0) + 16 >> 2] | 0, (sy(b, d, xy(c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) | 0) == 0) : 0)c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[c[m >> 2] >> 2]
	                    }
	                    if ((z | 0) == 8) {
	                        if (c[33468] | 0) {
	                            r = c[33976] | 0;
	                            d = c[33980] | 0;
	                            b = c[(c[m >> 2] | 0) + 24 >> 2] | 0;
	                            c[f >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                            c[f + 4 >> 2] = b;
	                            Db[r & 511](d, 135400, f)
	                        }
	                        d = (c[h >> 2] | 0) + 36 | 0;
	                        c[d >> 2] = (c[d >> 2] | 0) + -1;
	                        c[g >> 2] = my(c[(c[m >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        y = c[g >> 2] | 0;
	                        i = e;
	                        return y | 0
	                    }
	                    if (c[p >> 2] | 0) {
	                        if (c[33468] | 0) {
	                            d = c[33976] | 0;
	                            r = c[33980] | 0;
	                            c[f >> 2] = c[(c[p >> 2] | 0) + 16 >> 2];
	                            Db[d & 511](r, 135200, f)
	                        }
	                        c[l >> 2] = my(c[(c[p >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[l >> 2] = By(c[l >> 2] | 0, (c[k >> 2] | 0) + (c[q >> 2] | 0) | 0) | 0;
	                        q = (c[h >> 2] | 0) + 36 | 0;
	                        c[q >> 2] = (c[q >> 2] | 0) + -1;
	                        c[g >> 2] = c[l >> 2];
	                        y = c[g >> 2] | 0;
	                        i = e;
	                        return y | 0
	                    }
	                    if (c[n >> 2] | 0) {
	                        c[t >> 2] = 0;
	                        c[m >> 2] = c[h >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0)) {
	                                z = 45;
	                                break
	                            }
	                            if ((c[(c[m >> 2] | 0) + 12 >> 2] | 0) == 9 ? (q = c[k >> 2] | 0, p = c[(c[m >> 2] | 0) + 16 >> 2] | 0, (sy(q, p, xy(c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) | 0) == 0) : 0) {
	                                c[u >> 2] = 0;
	                                while (1) {
	                                    if ((c[u >> 2] | 0) >= (c[t >> 2] | 0))break;
	                                    if (qy(c[(c[m >> 2] | 0) + 24 >> 2] | 0, c[s + (c[u >> 2] << 2) >> 2] | 0) | 0)break;
	                                    c[u >> 2] = (c[u >> 2] | 0) + 1
	                                }
	                                if ((c[u >> 2] | 0) < (c[t >> 2] | 0)) {
	                                    c[m >> 2] = c[c[m >> 2] >> 2];
	                                    continue
	                                }
	                                if ((c[t >> 2] | 0) < 50) {
	                                    p = c[(c[m >> 2] | 0) + 24 >> 2] | 0;
	                                    q = c[t >> 2] | 0;
	                                    c[t >> 2] = q + 1;
	                                    c[s + (q << 2) >> 2] = p
	                                }
	                                if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0))dx(c[m >> 2] | 0) | 0;
	                                if (c[(c[m >> 2] | 0) + 8 >> 2] | 0) {
	                                    if (c[33468] | 0) {
	                                        p = c[33976] | 0;
	                                        q = c[33980] | 0;
	                                        c[f >> 2] = c[(c[m >> 2] | 0) + 24 >> 2];
	                                        Db[p & 511](q, 135440, f)
	                                    }
	                                    c[l >> 2] = Rw(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0, c[k >> 2] | 0) | 0;
	                                    if (c[l >> 2] | 0) {
	                                        z = 43;
	                                        break
	                                    }
	                                }
	                            }
	                            c[m >> 2] = c[c[m >> 2] >> 2]
	                        }
	                        if ((z | 0) == 43) {
	                            s = (c[h >> 2] | 0) + 36 | 0;
	                            c[s >> 2] = (c[s >> 2] | 0) + -1;
	                            c[g >> 2] = c[l >> 2];
	                            y = c[g >> 2] | 0;
	                            i = e;
	                            return y | 0
	                        } else if ((z | 0) == 45) {
	                            s = (c[h >> 2] | 0) + 36 | 0;
	                            c[s >> 2] = (c[s >> 2] | 0) + -1;
	                            c[g >> 2] = -1;
	                            y = c[g >> 2] | 0;
	                            i = e;
	                            return y | 0
	                        }
	                    }
	                }
	                if (c[j >> 2] | 0) {
	                    c[m >> 2] = c[h >> 2];
	                    c[n >> 2] = 0;
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break;
	                        s = c[(c[m >> 2] | 0) + 12 >> 2] | 0;
	                        if ((s | 0) == 8) {
	                            t = c[j >> 2] | 0;
	                            u = c[(c[m >> 2] | 0) + 16 >> 2] | 0;
	                            if ((sy(t, u, xy(c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) | 0) == 0 ? (c[(c[m >> 2] | 0) + 28 >> 2] | 0) == 1 : 0)c[n >> 2] = (c[n >> 2] | 0) + 1
	                        } else if ((s | 0) == 3) {
	                            if (!(c[k >> 2] | 0))c[o >> 2] = (c[o >> 2] | 0) + 1
	                        } else if ((s | 0) == 5 ? (qy(c[j >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) != 0 : 0) {
	                            z = 51;
	                            break
	                        }
	                        c[m >> 2] = c[c[m >> 2] >> 2]
	                    }
	                    if ((z | 0) == 51) {
	                        if (c[33468] | 0) {
	                            s = c[33976] | 0;
	                            u = c[33980] | 0;
	                            c[f >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                            Db[s & 511](u, 135472, f)
	                        }
	                        u = (c[h >> 2] | 0) + 36 | 0;
	                        c[u >> 2] = (c[u >> 2] | 0) + -1;
	                        c[g >> 2] = my(c[(c[m >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        y = c[g >> 2] | 0;
	                        i = e;
	                        return y | 0
	                    }
	                    if (c[n >> 2] | 0) {
	                        c[w >> 2] = 0;
	                        c[m >> 2] = c[h >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0)) {
	                                z = 82;
	                                break
	                            }
	                            if (((c[(c[m >> 2] | 0) + 12 >> 2] | 0) == 8 ? (c[(c[m >> 2] | 0) + 28 >> 2] | 0) == 1 : 0) ? (n = c[j >> 2] | 0, u = c[(c[m >> 2] | 0) + 16 >> 2] | 0, (sy(n, u, xy(c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) | 0) == 0) : 0) {
	                                c[x >> 2] = 0;
	                                while (1) {
	                                    if ((c[x >> 2] | 0) >= (c[w >> 2] | 0))break;
	                                    if (qy(c[(c[m >> 2] | 0) + 24 >> 2] | 0, c[v + (c[x >> 2] << 2) >> 2] | 0) | 0)break;
	                                    c[x >> 2] = (c[x >> 2] | 0) + 1
	                                }
	                                if ((c[x >> 2] | 0) < (c[w >> 2] | 0)) {
	                                    c[m >> 2] = c[c[m >> 2] >> 2];
	                                    continue
	                                }
	                                if ((c[w >> 2] | 0) < 50) {
	                                    u = c[(c[m >> 2] | 0) + 24 >> 2] | 0;
	                                    n = c[w >> 2] | 0;
	                                    c[w >> 2] = n + 1;
	                                    c[v + (n << 2) >> 2] = u
	                                }
	                                if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0))dx(c[m >> 2] | 0) | 0;
	                                if (c[(c[m >> 2] | 0) + 8 >> 2] | 0) {
	                                    if (c[33468] | 0) {
	                                        u = c[33976] | 0;
	                                        n = c[33980] | 0;
	                                        c[f >> 2] = c[(c[m >> 2] | 0) + 24 >> 2];
	                                        Db[u & 511](n, 135496, f)
	                                    }
	                                    c[l >> 2] = Rw(c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0, 0) | 0;
	                                    if (c[l >> 2] | 0) {
	                                        z = 80;
	                                        break
	                                    }
	                                }
	                            }
	                            c[m >> 2] = c[c[m >> 2] >> 2]
	                        }
	                        if ((z | 0) == 80) {
	                            f = (c[h >> 2] | 0) + 36 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + -1;
	                            c[g >> 2] = c[l >> 2];
	                            y = c[g >> 2] | 0;
	                            i = e;
	                            return y | 0
	                        } else if ((z | 0) == 82) {
	                            f = (c[h >> 2] | 0) + 36 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + -1;
	                            c[g >> 2] = -1;
	                            y = c[g >> 2] | 0;
	                            i = e;
	                            return y | 0
	                        }
	                    }
	                }
	                a:do if (c[o >> 2] | 0) {
	                    c[m >> 2] = c[h >> 2];
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break a;
	                        if ((c[(c[m >> 2] | 0) + 12 >> 2] | 0) == 3) {
	                            if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0))dx(c[m >> 2] | 0) | 0;
	                            if (c[(c[m >> 2] | 0) + 8 >> 2] | 0) {
	                                c[l >> 2] = Rw(c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                A = (c[h >> 2] | 0) + 36 | 0;
	                                B = c[A >> 2] | 0;
	                                if (c[l >> 2] | 0) {
	                                    z = 91;
	                                    break
	                                }
	                                if ((B | 0) > 50) {
	                                    z = 93;
	                                    break
	                                }
	                            }
	                        }
	                        c[m >> 2] = c[c[m >> 2] >> 2]
	                    }
	                    if ((z | 0) == 91) {
	                        c[A >> 2] = B + -1;
	                        c[g >> 2] = c[l >> 2];
	                        y = c[g >> 2] | 0;
	                        i = e;
	                        return y | 0
	                    } else if ((z | 0) == 93) {
	                        c[g >> 2] = 0;
	                        y = c[g >> 2] | 0;
	                        i = e;
	                        return y | 0
	                    }
	                } while (0);
	                z = (c[h >> 2] | 0) + 36 | 0;
	                c[z >> 2] = (c[z >> 2] | 0) + -1;
	                c[g >> 2] = 0;
	                y = c[g >> 2] | 0;
	                i = e;
	                return y | 0
	            }

	            function fx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                d = i;
	                i = i + 256 | 0;
	                e = d;
	                f = d + 252 | 0;
	                g = d + 248 | 0;
	                h = d + 244 | 0;
	                j = d + 240 | 0;
	                k = d + 236 | 0;
	                l = d + 232 | 0;
	                m = d + 228 | 0;
	                n = d + 224 | 0;
	                o = d + 220 | 0;
	                p = d + 216 | 0;
	                q = d + 16 | 0;
	                r = d + 8 | 0;
	                s = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                b = c[g >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) > 50) {
	                    hx(b, 0, 1654, 135136, c[(c[g >> 2] | 0) + 16 >> 2] | 0, 0, 0);
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                c[k >> 2] = b;
	                c[l >> 2] = 0;
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    b = c[(c[k >> 2] | 0) + 12 >> 2] | 0;
	                    if ((b | 0) == 10) {
	                        if (qy(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0) {
	                            u = 11;
	                            break
	                        }
	                    } else if ((b | 0) == 12) {
	                        a = c[h >> 2] | 0;
	                        v = c[(c[k >> 2] | 0) + 16 >> 2] | 0;
	                        if (!(sy(a, v, xy(c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0) | 0))c[l >> 2] = (c[l >> 2] | 0) + 1
	                    } else if ((b | 0) == 11) {
	                        c[p >> 2] = xy(c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        if ((c[p >> 2] | 0) > (c[o >> 2] | 0) ? (sy(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0, c[p >> 2] | 0) | 0) == 0 : 0) {
	                            c[o >> 2] = c[p >> 2];
	                            c[n >> 2] = c[k >> 2]
	                        }
	                    } else if ((b | 0) == 3)c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                if ((u | 0) == 11) {
	                    if (c[33468] | 0) {
	                        p = c[33976] | 0;
	                        b = c[33980] | 0;
	                        c[e >> 2] = c[(c[k >> 2] | 0) + 16 >> 2];
	                        Db[p & 511](b, 135176, e)
	                    }
	                    c[f >> 2] = my(c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if (c[n >> 2] | 0) {
	                    if (c[33468] | 0) {
	                        b = c[33976] | 0;
	                        p = c[33980] | 0;
	                        c[e >> 2] = c[(c[n >> 2] | 0) + 16 >> 2];
	                        Db[b & 511](p, 135200, e)
	                    }
	                    c[j >> 2] = my(c[(c[n >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    if (c[j >> 2] | 0)c[j >> 2] = By(c[j >> 2] | 0, (c[h >> 2] | 0) + (c[o >> 2] | 0) | 0) | 0;
	                    c[f >> 2] = c[j >> 2];
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    a:do if (c[m >> 2] | 0) {
	                        c[k >> 2] = c[g >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break a;
	                            if ((c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 3) {
	                                if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))dx(c[k >> 2] | 0) | 0;
	                                if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[j >> 2] = Vw(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0, (c[j >> 2] | 0) != 0) : 0)break
	                            }
	                            c[k >> 2] = c[c[k >> 2] >> 2]
	                        }
	                        c[f >> 2] = c[j >> 2];
	                        t = c[f >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    } while (0);
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                c[r >> 2] = 0;
	                c[k >> 2] = c[g >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0)) {
	                        u = 49;
	                        break
	                    }
	                    if (!((c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 9 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 12 : 0))u = 32;
	                    if ((u | 0) == 32 ? (u = 0, g = c[h >> 2] | 0, m = c[(c[k >> 2] | 0) + 16 >> 2] | 0, (sy(g, m, xy(c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0) | 0) == 0) : 0) {
	                        c[s >> 2] = 0;
	                        while (1) {
	                            if ((c[s >> 2] | 0) >= (c[r >> 2] | 0))break;
	                            if (qy(c[(c[k >> 2] | 0) + 24 >> 2] | 0, c[q + (c[s >> 2] << 2) >> 2] | 0) | 0)break;
	                            c[s >> 2] = (c[s >> 2] | 0) + 1
	                        }
	                        if ((c[s >> 2] | 0) < (c[r >> 2] | 0)) {
	                            c[k >> 2] = c[c[k >> 2] >> 2];
	                            continue
	                        }
	                        if ((c[r >> 2] | 0) < 50) {
	                            m = c[(c[k >> 2] | 0) + 24 >> 2] | 0;
	                            g = c[r >> 2] | 0;
	                            c[r >> 2] = g + 1;
	                            c[q + (g << 2) >> 2] = m
	                        }
	                        if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))dx(c[k >> 2] | 0) | 0;
	                        if (c[(c[k >> 2] | 0) + 8 >> 2] | 0) {
	                            if (c[33468] | 0) {
	                                m = c[33976] | 0;
	                                g = c[33980] | 0;
	                                c[e >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                                Db[m & 511](g, 135232, e)
	                            }
	                            c[j >> 2] = Vw(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0;
	                            if (c[j >> 2] | 0) {
	                                u = 47;
	                                break
	                            }
	                        }
	                    }
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                if ((u | 0) == 47) {
	                    c[f >> 2] = c[j >> 2];
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                } else if ((u | 0) == 49) {
	                    c[f >> 2] = -1;
	                    t = c[f >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                return 0
	            }

	            function gx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d;
	                f = d + 32 | 0;
	                g = d + 28 | 0;
	                h = d + 24 | 0;
	                j = d + 20 | 0;
	                k = d + 16 | 0;
	                l = d + 12 | 0;
	                m = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[m >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[j >> 2] = ww(c[h >> 2] | 0) | 0;
	                b = (c[33468] | 0) != 0;
	                if (!(c[j >> 2] | 0)) {
	                    if (b) {
	                        a = c[33976] | 0;
	                        o = c[33980] | 0;
	                        c[e >> 2] = c[h >> 2];
	                        Db[a & 511](o, 134360, e)
	                    }
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                if (b) {
	                    b = c[33976] | 0;
	                    o = c[33980] | 0;
	                    a = yx() | 0;
	                    p = c[h >> 2] | 0;
	                    c[e >> 2] = a;
	                    c[e + 4 >> 2] = p;
	                    Db[b & 511](o, 134392, e)
	                }
	                c[k >> 2] = Pi(c[j >> 2] | 0) | 0;
	                if (((((c[k >> 2] | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 134128) | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 134416) | 0) != 0 : 0) {
	                    c[m >> 2] = Qw(1, 0, c[h >> 2] | 0, 0, c[g >> 2] | 0, 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        Th(c[j >> 2] | 0);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                    c[l >> 2] = Yi(c[k >> 2] | 0, 134464) | 0;
	                    if (c[l >> 2] | 0) {
	                        do if (!(qy(c[l >> 2] | 0, 134472) | 0))if (qy(c[l >> 2] | 0, 134480) | 0) {
	                            c[g >> 2] = 1;
	                            break
	                        } else {
	                            hx(0, c[k >> 2] | 0, 1652, 134488, c[l >> 2] | 0, 0, 0);
	                            break
	                        } else c[g >> 2] = 2; while (0);
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                    }
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    ix(c[k >> 2] | 0, c[g >> 2] | 0, c[m >> 2] | 0, 0);
	                    Th(c[j >> 2] | 0);
	                    c[f >> 2] = c[m >> 2];
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                hx(0, c[j >> 2] | 0, 1653, 134520, c[h >> 2] | 0, 0, 0);
	                Th(c[j >> 2] | 0);
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function hx(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j;
	                l = j + 36 | 0;
	                m = j + 32 | 0;
	                n = j + 28 | 0;
	                o = j + 24 | 0;
	                p = j + 20 | 0;
	                q = j + 16 | 0;
	                r = j + 12 | 0;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                h = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                g = c[q >> 2] | 0;
	                f = c[r >> 2] | 0;
	                e = c[o >> 2] | 0;
	                o = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                c[k >> 2] = c[p >> 2];
	                c[k + 4 >> 2] = o;
	                c[k + 8 >> 2] = q;
	                Xd(0, 0, 0, h, l, 20, m, 2, 0, 0, n, g, f, 0, 0, e, k);
	                i = j;
	                return
	            }

	            function ix(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if (((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 134416) | 0) != 0 : 0)jx(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                i = f;
	                return
	            }

	            function jx(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                do if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 134552) | 0)) {
	                    e = (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 134480) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 5, 134480, 134616, 134632, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134472) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 6, 134472, 134640, 134632, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134656) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 7, 134656, 134672, 134696, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134712) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 8, 134712, 134728, 134128, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134752) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 9, 134752, 134672, 134128, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134632) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 10, 134632, 134768, 134632, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134776) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 11, 134776, 134792, 134696, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    e = (qy(c[d + 8 >> 2] | 0, 134808) | 0) != 0;
	                    d = c[g >> 2] | 0;
	                    if (e) {
	                        c[m >> 2] = kx(d, 12, 134808, 134792, 134128, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    if (qy(c[d + 8 >> 2] | 0, 134824) | 0)c[m >> 2] = kx(c[g >> 2] | 0, 3, 134824, 0, 134128, c[h >> 2] | 0, c[k >> 2] | 0) | 0
	                } else {
	                    c[o >> 2] = 0;
	                    c[n >> 2] = Yi(c[g >> 2] | 0, 134464) | 0;
	                    if (c[n >> 2] | 0) {
	                        do if (!(qy(c[n >> 2] | 0, 134472) | 0))if (qy(c[n >> 2] | 0, 134480) | 0) {
	                            c[h >> 2] = 1;
	                            break
	                        } else {
	                            hx(c[j >> 2] | 0, c[g >> 2] | 0, 1652, 134488, c[n >> 2] | 0, 0, 0);
	                            break
	                        } else c[h >> 2] = 2; while (0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[o >> 2] = c[h >> 2]
	                    }
	                    c[n >> 2] = Yi(c[g >> 2] | 0, 134560) | 0;
	                    c[l >> 2] = Ui(c[g >> 2] | 0, 134568, 134576) | 0;
	                    c[m >> 2] = Qw(4, c[n >> 2] | 0, c[l >> 2] | 0, 0, c[o >> 2] | 0, c[k >> 2] | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                } while (0);
	                if (c[m >> 2] | 0) {
	                    do if (c[j >> 2] | 0) {
	                        c[(c[m >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                        if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                            c[(c[j >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                            break
	                        }
	                        c[p >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                        while (1) {
	                            if (!(c[c[p >> 2] >> 2] | 0))break;
	                            c[p >> 2] = c[c[p >> 2] >> 2]
	                        }
	                        c[c[p >> 2] >> 2] = c[m >> 2]
	                    } while (0);
	                    if ((c[(c[m >> 2] | 0) + 12 >> 2] | 0) == 4)ix(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0)
	                }
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                i = f;
	                return
	            }

	            function kx(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                j = i;
	                i = i + 80 | 0;
	                k = j;
	                l = j + 64 | 0;
	                m = j + 60 | 0;
	                n = j + 56 | 0;
	                o = j + 52 | 0;
	                p = j + 48 | 0;
	                q = j + 44 | 0;
	                r = j + 40 | 0;
	                s = j + 36 | 0;
	                t = j + 32 | 0;
	                u = j + 28 | 0;
	                v = j + 24 | 0;
	                w = j + 20 | 0;
	                x = j + 16 | 0;
	                y = j + 12 | 0;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = 1;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                c[y >> 2] = 0;
	                if ((c[p >> 2] | 0) != 0 ? (c[v >> 2] = Yi(c[m >> 2] | 0, c[p >> 2] | 0) | 0, (c[v >> 2] | 0) == 0) : 0) {
	                    hx(c[y >> 2] | 0, c[m >> 2] | 0, 1650, 134840, c[o >> 2] | 0, c[p >> 2] | 0, 0);
	                    c[t >> 2] = 0
	                }
	                c[u >> 2] = Yi(c[m >> 2] | 0, c[q >> 2] | 0) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    hx(c[y >> 2] | 0, c[m >> 2] | 0, 1650, 134840, c[o >> 2] | 0, c[q >> 2] | 0, 0);
	                    c[t >> 2] = 0
	                }
	                if (!(c[t >> 2] | 0)) {
	                    if (c[v >> 2] | 0)zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                    if (c[u >> 2] | 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                    c[l >> 2] = 0;
	                    z = c[l >> 2] | 0;
	                    i = j;
	                    return z | 0
	                }
	                c[w >> 2] = Xi(c[(c[m >> 2] | 0) + 32 >> 2] | 0, c[m >> 2] | 0) | 0;
	                c[x >> 2] = Hl(c[u >> 2] | 0, c[w >> 2] | 0) | 0;
	                if (c[x >> 2] | 0) {
	                    do if ((c[33468] | 0) > 1) {
	                        t = c[33976] | 0;
	                        p = c[33980] | 0;
	                        h = c[o >> 2] | 0;
	                        if (c[v >> 2] | 0) {
	                            g = c[v >> 2] | 0;
	                            f = c[x >> 2] | 0;
	                            c[k >> 2] = h;
	                            c[k + 4 >> 2] = g;
	                            c[k + 8 >> 2] = f;
	                            Db[t & 511](p, 134864, k);
	                            break
	                        } else {
	                            f = c[x >> 2] | 0;
	                            c[k >> 2] = h;
	                            c[k + 4 >> 2] = f;
	                            Db[t & 511](p, 134888, k);
	                            break
	                        }
	                    } while (0);
	                    c[y >> 2] = Qw(c[n >> 2] | 0, c[v >> 2] | 0, c[u >> 2] | 0, c[x >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0) | 0
	                } else hx(c[y >> 2] | 0, c[m >> 2] | 0, 1651, 134904, c[o >> 2] | 0, c[q >> 2] | 0, c[u >> 2] | 0);
	                if (c[v >> 2] | 0)zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                if (c[u >> 2] | 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                if (c[w >> 2] | 0)zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                if (c[x >> 2] | 0)zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                c[l >> 2] = c[y >> 2];
	                z = c[l >> 2] | 0;
	                i = j;
	                return z | 0
	            }

	            function lx() {
	                var a = 0;
	                a = i;
	                if (c[33932] | 0) {
	                    i = a;
	                    return
	                }
	                c[33932] = px() | 0;
	                i = a;
	                return
	            }

	            function mx() {
	                var a = 0;
	                a = i;
	                if (c[33932] | 0) {
	                    qx(c[33932] | 0);
	                    c[33932] = 0
	                }
	                xx();
	                i = a;
	                return
	            }

	            function nx(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[33968];
	                c[18774] = 1;
	                c[33968] = c[d >> 2];
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function ox(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[33970];
	                c[18774] = 1;
	                c[33970] = c[d >> 2];
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function px() {
	                var a = 0, b = 0, d = 0, e = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                e = iT(4) | 0;
	                c[d >> 2] = e;
	                if (!e)c[b >> 2] = 0; else c[b >> 2] = c[d >> 2];
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function qx(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                jT(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function rx(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return
	            }

	            function sx(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return
	            }

	            function tx() {
	                var a = 0, b = 0, d = 0, e = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                e = iT(4) | 0;
	                c[d >> 2] = e;
	                if (!e)c[b >> 2] = 0; else c[b >> 2] = c[d >> 2];
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function ux(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                jT(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function vx(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return
	            }

	            function wx(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return
	            }

	            function xx() {
	                return
	            }

	            function yx() {
	                return 0
	            }

	            function zx() {
	                return
	            }

	            function Ax() {
	                return
	            }

	            function Bx(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 40 | 0;
	                l = j + 36 | 0;
	                m = j + 32 | 0;
	                n = j + 28 | 0;
	                o = j + 24 | 0;
	                p = j + 20 | 0;
	                q = j + 16 | 0;
	                r = j + 12 | 0;
	                s = j + 8 | 0;
	                t = j + 4 | 0;
	                u = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[t >> 2] = 0;
	                if ((c[r >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    Ex(136264);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                if ((c[o >> 2] | 0) >>> 0 >= 3) {
	                    Ex(136280);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[t >> 2] = c[o >> 2];
	                o = c[l >> 2] | 0;
	                if (c[(c[r >> 2] | 0) + 12 >> 2] | 0) {
	                    Fx(0, o, 1951, 136312);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[s >> 2] = Gx(o, c[m >> 2] | 0, c[n >> 2] | 0, c[t >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                q = c[l >> 2] | 0;
	                if (!(c[s >> 2] | 0)) {
	                    Fx(0, q, 1950, 136392);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                if ((c[q + 12 >> 2] | 0) != 0 ? (c[u >> 2] = Hx(c[s >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0, (c[u >> 2] | 0) < 0) : 0) {
	                    Ix(136440);
	                    Jx(c[s >> 2] | 0);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[u >> 2] = Ak(c[r >> 2] | 0) | 0;
	                if ((c[u >> 2] | 0) < 0) {
	                    Ix(136472);
	                    Jx(c[s >> 2] | 0);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                } else {
	                    Jx(c[s >> 2] | 0);
	                    c[k >> 2] = c[u >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                return 0
	            }

	            function Cx(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                g = Bx(c[j >> 2] | 0, 317, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                i = h;
	                return g | 0
	            }

	            function Dx(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (!(c[p >> 2] | 0)) {
	                    Ex(136496);
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[c[p >> 2] >> 2] = 0;
	                c[r >> 2] = wk(0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    Lx(136520);
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[q >> 2] = Cx(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[r >> 2] | 0) | 0;
	                if ((c[q >> 2] | 0) < 0) {
	                    Ix(136544);
	                    zk(c[r >> 2] | 0) | 0;
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[q >> 2] = _y(c[(c[r >> 2] | 0) + 16 >> 2] | 0) | 0;
	                if ((c[q >> 2] | 0) > 0) {
	                    o = Vy(c[(c[r >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    n = ly(o, c[q >> 2] | 0) | 0;
	                    c[c[p >> 2] >> 2] = n
	                }
	                zk(c[r >> 2] | 0) | 0;
	                if ((c[q >> 2] | 0) > 0 ? (c[c[p >> 2] >> 2] | 0) == 0 : 0) {
	                    Lx(136576);
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else {
	                    c[j >> 2] = c[q >> 2];
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                return 0
	            }

	            function Ex(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                c[d >> 2] = c[e >> 2];
	                Xd(0, 0, 0, 0, 0, 21, 1, 2, 0, 0, a, 0, 0, 0, 0, 138632, d);
	                i = b;
	                return
	            }

	            function Fx(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 40 >> 2] = c[k >> 2];
	                e = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, h, 21, j, 2, 0, 0, 0, 0, 0, 0, 0, 138624, g);
	                i = f;
	                return
	            }

	            function Gx(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 20 | 0;
	                o = j + 16 | 0;
	                p = j + 12 | 0;
	                q = j + 8 | 0;
	                r = j + 4 | 0;
	                s = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = 0;
	                if ((c[l >> 2] | 0) == 0 | (c[r >> 2] | 0) == 0) {
	                    Ex(138360);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                if (c[(c[r >> 2] | 0) + 12 >> 2] | 0) {
	                    Fx(c[s >> 2] | 0, c[l >> 2] | 0, 1951, 138384);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                if ((c[(c[l >> 2] | 0) + 76 >> 2] | 0) != 1) {
	                    Fx(c[s >> 2] | 0, c[l >> 2] | 0, 1951, 138464);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                c[s >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    Lx(138512);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                h = (c[s >> 2] | 0) + 0 | 0;
	                g = h + 44 | 0;
	                do {
	                    c[h >> 2] = 0;
	                    h = h + 4 | 0
	                } while ((h | 0) < (g | 0));
	                c[c[s >> 2] >> 2] = c[l >> 2];
	                c[(c[s >> 2] | 0) + 12 >> 2] = c[q >> 2];
	                c[(c[s >> 2] | 0) + 4 >> 2] = c[m >> 2];
	                c[(c[s >> 2] | 0) + 8 >> 2] = c[n >> 2];
	                c[(c[s >> 2] | 0) + 16 >> 2] = c[r >> 2];
	                c[(c[s >> 2] | 0) + 24 >> 2] = 1;
	                c[(c[s >> 2] | 0) + 20 >> 2] = 0;
	                r = Mx() | 0;
	                c[(c[s >> 2] | 0) + 28 >> 2] = r;
	                if (!(c[(c[s >> 2] | 0) + 28 >> 2] | 0)) {
	                    Fx(c[s >> 2] | 0, c[l >> 2] | 0, 1952, 138536);
	                    Jx(c[s >> 2] | 0);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                c[(c[s >> 2] | 0) + 32 >> 2] = c[o >> 2];
	                if ((c[(c[s >> 2] | 0) + 32 >> 2] | 0) == 1)c[(c[s >> 2] | 0) + 36 >> 2] = c[p >> 2];
	                c[k >> 2] = c[s >> 2];
	                t = c[k >> 2] | 0;
	                i = j;
	                return t | 0
	            }

	            function Hx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    Ex(136712);
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    if (!((c[g >> 2] | 0) != 0 & (c[h >> 2] | 0) >= 0))break;
	                    c[h >> 2] = Nx(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Ix(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                c[d >> 2] = c[e >> 2];
	                Xd(0, 0, 0, 0, 0, 21, 1, 2, 0, 0, a, 0, 0, 0, 0, 136688, d);
	                i = b;
	                return
	            }

	            function Jx(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    Ex(136640);
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)Ox(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Kx(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!((c[g >> 2] | 0) != 0 & (c[h >> 2] | 0) != 0)) {
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                    c[f >> 2] = ar(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = c[h >> 2] | 0;
	                c[k + 0 >> 2] = c[d + 0 >> 2];
	                c[k + 4 >> 2] = c[d + 4 >> 2];
	                c[k + 8 >> 2] = c[d + 8 >> 2];
	                c[k + 12 >> 2] = c[d + 12 >> 2];
	                c[k + 16 >> 2] = c[d + 16 >> 2];
	                c[k + 20 >> 2] = c[d + 20 >> 2];
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 2 : 0)c[k >> 2] = c[(c[j >> 2] | 0) + 20 >> 2]; else c[k >> 2] = c[j >> 2];
	                c[f >> 2] = ar(c[g >> 2] | 0, k) | 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Lx(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                c[d >> 2] = c[e >> 2];
	                Xd(0, 0, 0, 0, 0, 21, 2, 2, 0, 0, a, 0, 0, 0, 0, 136608, d);
	                i = b;
	                return
	            }

	            function Mx() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    Lx(138592);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    f = c[d >> 2] | 0;
	                    c[f + 0 >> 2] = 0;
	                    c[f + 4 >> 2] = 0;
	                    c[f + 8 >> 2] = 0;
	                    c[f + 12 >> 2] = 0;
	                    c[f + 16 >> 2] = 0;
	                    c[f + 20 >> 2] = 0;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function Nx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    Ex(136736);
	                    c[f >> 2] = -1;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (c[(c[g >> 2] | 0) + 4 >> 2] | 0)p = vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0) | 0; else p = 1;
	                c[k >> 2] = p;
	                a:do switch (c[(c[h >> 2] | 0) + 4 >> 2] | 0) {
	                    case 8:
	                    {
	                        if ((c[k >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            p = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                            if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 2)Qk(p, 136840) | 0; else Qk(p, 136848) | 0;
	                            do if (c[(c[h >> 2] | 0) + 40 >> 2] | 0) {
	                                c[n >> 2] = Qx(c[(c[h >> 2] | 0) + 40 >> 2] | 0, 1) | 0;
	                                if (c[n >> 2] | 0) {
	                                    Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[n >> 2] | 0) | 0;
	                                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                                    break
	                                }
	                                Ix(136856);
	                                c[f >> 2] = -1;
	                                o = c[f >> 2] | 0;
	                                i = e;
	                                return o | 0
	                            } while (0);
	                            p = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                            if (!(c[(c[g >> 2] | 0) + 20 >> 2] | 0)) {
	                                Qk(p, 136888) | 0;
	                                break a
	                            } else {
	                                Qk(p, 136896) | 0;
	                                break a
	                            }
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        Rx(136928, 136736);
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    case 7:
	                    {
	                        if (c[k >> 2] | 0) {
	                            p = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                            if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 2)Qk(p, 136776) | 0; else Qk(p, 136784) | 0;
	                            Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            do if ((c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 ? (d[c[(c[h >> 2] | 0) + 40 >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                                Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 136792) | 0;
	                                c[m >> 2] = Qx(c[(c[h >> 2] | 0) + 40 >> 2] | 0, 2) | 0;
	                                if (c[m >> 2] | 0) {
	                                    Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    break
	                                }
	                                Ix(136800);
	                                c[f >> 2] = -1;
	                                o = c[f >> 2] | 0;
	                                i = e;
	                                return o | 0
	                            } while (0);
	                            p = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                            if (!(c[(c[g >> 2] | 0) + 20 >> 2] | 0)) {
	                                Qk(p, 136824) | 0;
	                                break a
	                            } else {
	                                Qk(p, 136832) | 0;
	                                break a
	                            }
	                        }
	                        break
	                    }
	                    case 3:
	                    case 4:
	                    {
	                        if ((c[k >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                            c[l >> 2] = Qx(c[(c[h >> 2] | 0) + 40 >> 2] | 0, 3) | 0;
	                            if (c[l >> 2] | 0) {
	                                Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                                break a
	                            }
	                            Ix(136752);
	                            c[f >> 2] = -1;
	                            o = c[f >> 2] | 0;
	                            i = e;
	                            return o | 0
	                        }
	                        break
	                    }
	                    case 1:
	                    {
	                        c[j >> 2] = Px(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    case 2:
	                    {
	                        Rx(136904, 136736);
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    case 13:
	                    case 21:
	                    case 11:
	                    case 9:
	                    {
	                        if (c[(c[h >> 2] | 0) + 12 >> 2] | 0) {
	                            c[(c[g >> 2] | 0) + 20 >> 2] = 0;
	                            c[(c[g >> 2] | 0) + 24 >> 2] = 1;
	                            c[j >> 2] = Hx(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0) | 0
	                        }
	                        break
	                    }
	                    case 6:
	                    {
	                        Rx(136976, 136736);
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    case 20:
	                    case 19:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    case 12:
	                    case 10:
	                        break;
	                    case 5:
	                    {
	                        Rx(136952, 136736);
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    default:
	                    {
	                        Sx(c[(c[h >> 2] | 0) + 4 >> 2] | 0, 136736);
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[j >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Ox(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    Ex(136656);
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0) {
	                    cU(c[(c[d >> 2] | 0) + 16 >> 2] | 0, 0, c[(c[d >> 2] | 0) + 12 >> 2] << 2 | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0) {
	                    cU(c[(c[d >> 2] | 0) + 20 >> 2] | 0, 0, c[(c[d >> 2] | 0) + 12 >> 2] << 2 | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0)
	                }
	                a = c[d >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                c[a + 12 >> 2] = 0;
	                c[a + 16 >> 2] = 0;
	                c[a + 20 >> 2] = 0;
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Px(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                h = e + 40 | 0;
	                j = e + 36 | 0;
	                k = e + 32 | 0;
	                l = e + 8 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    if ((Tx(c[g >> 2] | 0, c[h >> 2] | 0) | 0) < 0) {
	                        Ix(137128);
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    ;
	                    c[l + 0 >> 2] = 0;
	                    c[l + 4 >> 2] = 0;
	                    c[l + 8 >> 2] = 0;
	                    c[l + 12 >> 2] = 0;
	                    c[l + 16 >> 2] = 0;
	                    c[l + 20 >> 2] = 0;
	                    Ux(c[(c[g >> 2] | 0) + 28 >> 2] | 0, l);
	                    if (c[j >> 2] | 0) {
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            c[m >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            c[(c[g >> 2] | 0) + 24 >> 2] = 0;
	                            c[(c[g >> 2] | 0) + 20 >> 2] = 1
	                        }
	                        Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137168) | 0;
	                        if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (xy(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 0 : 0) {
	                            Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137176) | 0
	                        }
	                        Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0
	                    }
	                    d = c[g >> 2] | 0;
	                    b = c[h >> 2] | 0;
	                    a = c[j >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 1)c[k >> 2] = Wx(d, b, a) | 0; else c[k >> 2] = Vx(d, b, a) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        Ix(137184);
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    if (c[j >> 2] | 0)Xx(c[(c[g >> 2] | 0) + 28 >> 2] | 0);
	                    c[k >> 2] = Yx(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        Ix(137216);
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    if (c[j >> 2] | 0)Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137248) | 0;
	                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[k >> 2] = Hx(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0) | 0, (c[k >> 2] | 0) < 0) : 0) {
	                        Ix(137256);
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    if (c[j >> 2] | 0) {
	                        Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137288) | 0;
	                        if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (xy(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 0 : 0) {
	                            Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137176) | 0
	                        }
	                        Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137248) | 0;
	                        if (c[m >> 2] | 0) {
	                            c[(c[g >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                            c[(c[g >> 2] | 0) + 20 >> 2] = 2
	                        }
	                    }
	                    Zx(c[(c[g >> 2] | 0) + 28 >> 2] | 0, l);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                Ex(137104);
	                c[f >> 2] = -1;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function Qx(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = c[h >> 2];
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[n >> 2] = 1e3;
	                c[l >> 2] = Cb[c[135752 >> 2] & 511](c[n >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    Lx(137064);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[m >> 2] = c[l >> 2];
	                while (1) {
	                    q = c[m >> 2] | 0;
	                    if (!(d[c[k >> 2] >> 0] | 0)) {
	                        r = 30;
	                        break
	                    }
	                    if ((q - (c[l >> 2] | 0) | 0) > ((c[n >> 2] | 0) - 10 | 0)) {
	                        c[o >> 2] = (c[m >> 2] | 0) - (c[l >> 2] | 0);
	                        c[n >> 2] = c[n >> 2] << 1;
	                        c[l >> 2] = Hb[c[135760 >> 2] & 511](c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            r = 9;
	                            break
	                        }
	                        c[m >> 2] = (c[l >> 2] | 0) + (c[o >> 2] | 0)
	                    }
	                    if ((d[c[k >> 2] >> 0] | 0 | 0) == 60 ? (c[j >> 2] | 0) == 0 | (c[j >> 2] | 0) == 3 : 0) {
	                        h = c[m >> 2] | 0;
	                        c[m >> 2] = h + 1;
	                        a[h >> 0] = 38;
	                        h = c[m >> 2] | 0;
	                        c[m >> 2] = h + 1;
	                        a[h >> 0] = 108;
	                        h = c[m >> 2] | 0;
	                        c[m >> 2] = h + 1;
	                        a[h >> 0] = 116;
	                        h = c[m >> 2] | 0;
	                        c[m >> 2] = h + 1;
	                        a[h >> 0] = 59
	                    } else r = 14;
	                    do if ((r | 0) == 14) {
	                        r = 0;
	                        if ((c[j >> 2] | 0) == 3 ? (d[c[k >> 2] >> 0] | 0 | 0) == 62 : 0) {
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 38;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 103;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 116;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 59;
	                            break
	                        }
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) == 38 ? (c[j >> 2] | 0) == 0 | (c[j >> 2] | 0) == 3 : 0) {
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 38;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 97;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 109;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 112;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 59;
	                            break
	                        }
	                        if ((c[j >> 2] | 0) == 0 ? (d[c[k >> 2] >> 0] | 0 | 0) == 34 : 0) {
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 38;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 113;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 117;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 111;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 116;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 59;
	                            break
	                        }
	                        if ((c[j >> 2] | 0) == 0 ? (d[c[k >> 2] >> 0] | 0 | 0) == 9 : 0) {
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 38;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 35;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 120;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 57;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 59;
	                            break
	                        }
	                        if ((c[j >> 2] | 0) == 0 ? (d[c[k >> 2] >> 0] | 0 | 0) == 10 : 0) {
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 38;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 35;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 120;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 65;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 59;
	                            break
	                        }
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) == 13 ? (c[j >> 2] | 0) == 0 | (c[j >> 2] | 0) == 3 | (c[j >> 2] | 0) == 1 | (c[j >> 2] | 0) == 2 : 0) {
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 38;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 35;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 120;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 68;
	                            h = c[m >> 2] | 0;
	                            c[m >> 2] = h + 1;
	                            a[h >> 0] = 59;
	                            break
	                        }
	                        h = a[c[k >> 2] >> 0] | 0;
	                        e = c[m >> 2] | 0;
	                        c[m >> 2] = e + 1;
	                        a[e >> 0] = h
	                    } while (0);
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((r | 0) == 9) {
	                    Lx(137088);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else if ((r | 0) == 30) {
	                    a[q >> 0] = 0;
	                    c[g >> 2] = c[l >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                return 0
	            }

	            function Rx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[g >> 2] | 0;
	                a = c[g >> 2] | 0;
	                c[e >> 2] = c[f >> 2];
	                c[e + 4 >> 2] = a;
	                Xd(0, 0, 0, 0, 0, 21, 1953, 2, 0, 0, b, 0, 0, 0, 0, 137032, e);
	                i = d;
	                return
	            }

	            function Sx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[g >> 2] | 0;
	                a = c[g >> 2] | 0;
	                c[e >> 2] = c[f >> 2];
	                c[e + 4 >> 2] = a;
	                Xd(0, 0, 0, 0, 0, 21, 1954, 2, 0, 0, b, 0, 0, 0, 0, 136992, e);
	                i = d;
	                return
	            }

	            function Tx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    c[h >> 2] = c[(c[g >> 2] | 0) + 48 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0)) {
	                            k = 17;
	                            break
	                        }
	                        if ((xy(c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0) > 0) {
	                            c[j >> 2] = yl(c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            if (!(c[j >> 2] | 0)) {
	                                k = 8;
	                                break
	                            }
	                            g = (xy(c[c[j >> 2] >> 2] | 0) | 0) == 0;
	                            l = c[c[j >> 2] >> 2] | 0;
	                            if (g) {
	                                k = 10;
	                                break
	                            }
	                            if (((ty(l, 138296) | 0) != 0 ? (ty(c[c[j >> 2] >> 2] | 0, 138304) | 0) != 0 : 0) ? (xy(c[(c[j >> 2] | 0) + 12 >> 2] | 0) | 0) == 0 : 0) {
	                                k = 14;
	                                break
	                            }
	                            Al(c[j >> 2] | 0)
	                        }
	                        c[h >> 2] = c[c[h >> 2] >> 2]
	                    }
	                    if ((k | 0) == 8) {
	                        Ix(138272);
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else if ((k | 0) == 10) {
	                        _x(l);
	                        Al(c[j >> 2] | 0);
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else if ((k | 0) == 14) {
	                        _x(c[c[j >> 2] >> 2] | 0);
	                        Al(c[j >> 2] | 0);
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else if ((k | 0) == 17) {
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                }
	                Ex(137128);
	                c[e >> 2] = -1;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function Ux(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    Ex(138248);
	                    i = d;
	                    return
	                } else {
	                    c[c[f >> 2] >> 2] = c[c[e >> 2] >> 2];
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[(c[f >> 2] | 0) + 8 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    i = d;
	                    return
	                }
	            }

	            function Vx(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[p >> 2] = 0;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    c[n >> 2] = IS(0, 318) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        Ix(138192);
	                        c[f >> 2] = -1;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    c[k >> 2] = c[h >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        c[l >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            c[m >> 2] = cj(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            do if ((c[m >> 2] | 0) == (c[l >> 2] | 0) ? (ay(c[l >> 2] | 0) | 0) == 0 : 0) {
	                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0)break;
	                                c[o >> 2] = by(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                if (c[j >> 2] | 0)cy(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[l >> 2] | 0, c[h >> 2] | 0);
	                                if (!(c[o >> 2] | 0))KS(c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                                if (!(xy(c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0))c[p >> 2] = 1
	                            } while (0);
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 20 >> 2]
	                    }
	                    if (!((c[j >> 2] | 0) == 0 | (c[p >> 2] | 0) != 0) ? (c[34556] = 0, c[34557] = 0, c[34558] = 0, c[34559] = 0, c[34560] = 0, c[34561] = 0, (by(c[(c[g >> 2] | 0) + 28 >> 2] | 0, 138224) | 0) == 0) : 0)dy(138224, c[g >> 2] | 0) | 0;
	                    PS(c[n >> 2] | 0, 319, c[g >> 2] | 0);
	                    MS(c[n >> 2] | 0);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                Ex(138152);
	                c[f >> 2] = -1;
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function Wx(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                h = e + 40 | 0;
	                j = e + 36 | 0;
	                k = e + 32 | 0;
	                l = e + 28 | 0;
	                m = e + 24 | 0;
	                n = e + 20 | 0;
	                o = e + 16 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                s = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != 1) {
	                        Ex(137816);
	                        c[f >> 2] = -1;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    c[l >> 2] = IS(0, 318) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        Ix(137856);
	                        c[f >> 2] = -1;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    a:do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                        c[s >> 2] = 0;
	                        while (1) {
	                            if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + (c[s >> 2] << 2) >> 2] | 0))break a;
	                            c[r >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + (c[s >> 2] << 2) >> 2];
	                            if (!((qy(c[r >> 2] | 0, 137896) | 0) == 0 ? (qy(c[r >> 2] | 0, 137704) | 0) == 0 : 0)) {
	                                c[r >> 2] = 0;
	                                c[q >> 2] = 1
	                            }
	                            c[k >> 2] = cj(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0, c[r >> 2] | 0) | 0;
	                            do if ((c[k >> 2] | 0) != 0 ? (ay(c[k >> 2] | 0) | 0) == 0 : 0) {
	                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0)break;
	                                c[n >> 2] = by(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[k >> 2] | 0) | 0;
	                                if (c[j >> 2] | 0)cy(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0);
	                                if (!(c[n >> 2] | 0))KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0;
	                                if (!(xy(c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0))c[o >> 2] = 1
	                            } while (0);
	                            c[s >> 2] = (c[s >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    s = c[h >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 36 >> 2] | 0)c[k >> 2] = c[s + 36 >> 2]; else {
	                        c[k >> 2] = cj(c[s + 32 >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                        c[p >> 2] = 1
	                    }
	                    if ((c[k >> 2] | 0) != 0 ? (ay(c[k >> 2] | 0) | 0) == 0 : 0) {
	                        do if (c[j >> 2] | 0) {
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0)break;
	                            if (!(ey(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[k >> 2] | 0, c[g >> 2] | 0) | 0))KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0
	                        } while (0);
	                        if (c[j >> 2] | 0)cy(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0);
	                        if (!(xy(c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0))c[o >> 2] = 1
	                    }
	                    c[m >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break;
	                        do if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 ? (ay(c[(c[m >> 2] | 0) + 36 >> 2] | 0) | 0) == 0 : 0) {
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0) {
	                                u = 49;
	                                break
	                            }
	                            c[n >> 2] = ey(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[m >> 2] | 0) + 36 >> 2] | 0, c[g >> 2] | 0) | 0;
	                            cy(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[m >> 2] | 0) + 36 >> 2] | 0, c[h >> 2] | 0);
	                            if ((c[n >> 2] | 0) == 0 & (c[j >> 2] | 0) != 0)KS(c[l >> 2] | 0, c[(c[m >> 2] | 0) + 36 >> 2] | 0) | 0;
	                            if (!(xy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0))c[o >> 2] = 1
	                        } else u = 49; while (0);
	                        if ((((u | 0) == 49 ? (u = 0, (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0) : 0) ? (xy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) == 0 : 0) ? (xy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0)c[p >> 2] = 1;
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                    }
	                    if ((c[j >> 2] | 0) != 0 & (c[p >> 2] | 0) != 0 ^ 1 | (c[o >> 2] | 0) != 0 | (c[q >> 2] | 0) != 0) {
	                        if ((((c[j >> 2] | 0) == 0 | (c[o >> 2] | 0) != 0) ^ 1) & (c[q >> 2] | 0) != 0 ? (c[34484] = 0, c[34485] = 0, c[34486] = 0, c[34487] = 0, c[34488] = 0, c[34489] = 0, (by(c[(c[g >> 2] | 0) + 28 >> 2] | 0, 137936) | 0) == 0) : 0)dy(137936, c[g >> 2] | 0) | 0
	                    } else {
	                        c[34478] = 0;
	                        c[34479] = 0;
	                        c[34480] = 0;
	                        c[34481] = 0;
	                        c[34482] = 0;
	                        c[34483] = 0;
	                        c[n >> 2] = ey(c[(c[g >> 2] | 0) + 28 >> 2] | 0, 137912, c[g >> 2] | 0) | 0;
	                        if (!(c[n >> 2] | 0))dy(137912, c[g >> 2] | 0) | 0
	                    }
	                    PS(c[l >> 2] | 0, 319, c[g >> 2] | 0);
	                    MS(c[l >> 2] | 0);
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                Ex(137816);
	                c[f >> 2] = -1;
	                t = c[f >> 2] | 0;
	                i = e;
	                return t | 0
	            }

	            function Xx(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    Ex(137784);
	                    i = b;
	                    return
	                } else {
	                    c[(c[d >> 2] | 0) + 4 >> 2] = c[(c[d >> 2] | 0) + 8 >> 2];
	                    c[(c[d >> 2] | 0) + 8 >> 2] = c[c[d >> 2] >> 2];
	                    i = b;
	                    return
	                }
	            }

	            function Yx(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 44 | 0;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 24 | 0;
	                m = e + 20 | 0;
	                n = e + 16 | 0;
	                o = e + 12 | 0;
	                p = e + 8 | 0;
	                q = e + 4 | 0;
	                r = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    c[l >> 2] = IS(0, 320) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        Ix(137328);
	                        c[f >> 2] = -1;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                    d = c[(c[g >> 2] | 0) + 32 >> 2] | 0;
	                    a:do if ((d | 0) == 2) {
	                        c[k >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            t = (c[j >> 2] | 0) != 0;
	                            if (!(c[k >> 2] | 0))break;
	                            do if (t ? (gy(c[k >> 2] | 0) | 0) != 0 : 0) {
	                                c[r >> 2] = 0;
	                                if ((c[r >> 2] | 0) == 0 & (c[o >> 2] | 0) == 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 137360) | 0) != 0 : 0) {
	                                    c[o >> 2] = c[k >> 2];
	                                    c[r >> 2] = 1
	                                }
	                                if ((c[r >> 2] | 0) == 0 & (c[p >> 2] | 0) == 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 137368) | 0) != 0 : 0) {
	                                    c[p >> 2] = c[k >> 2];
	                                    c[r >> 2] = 1
	                                }
	                                if ((c[r >> 2] | 0) == 0 & (c[n >> 2] | 0) == 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 137376) | 0) != 0 : 0) {
	                                    c[n >> 2] = c[k >> 2];
	                                    c[r >> 2] = 1
	                                }
	                                if (!(c[r >> 2] | 0)) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0)break;
	                                    KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0
	                                }
	                            } else u = 36; while (0);
	                            do if ((u | 0) == 36) {
	                                u = 0;
	                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0)break;
	                                KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0
	                            } while (0);
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                        if (t) {
	                            if (!(c[o >> 2] | 0))c[o >> 2] = hy(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0, 137360, 137384) | 0;
	                            if (c[o >> 2] | 0)KS(c[l >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[p >> 2] | 0))c[p >> 2] = hy(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0, 137368, 137384) | 0;
	                            if (c[p >> 2] | 0)KS(c[l >> 2] | 0, c[p >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0))c[n >> 2] = hy(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0, 137376, 137384) | 0;
	                            if ((c[n >> 2] | 0) != 0 ? (c[n >> 2] = iy(c[g >> 2] | 0, c[n >> 2] | 0) | 0, (c[n >> 2] | 0) != 0) : 0) {
	                                KS(c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                                c[m >> 2] = c[n >> 2]
	                            }
	                        }
	                    } else if (!d) {
	                        c[k >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break;
	                            if (!((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0))KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                        if ((((c[j >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 20 >> 2] | 0) | 0) == 0 : 0) {
	                            c[q >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                            while (1) {
	                                if (!(c[q >> 2] | 0))break a;
	                                c[k >> 2] = c[(c[q >> 2] | 0) + 44 >> 2];
	                                while (1) {
	                                    if (!(c[k >> 2] | 0))break;
	                                    if ((gy(c[k >> 2] | 0) | 0) != 0 ? (JS(c[l >> 2] | 0, c[k >> 2] | 0) | 0) == 0 : 0)KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0;
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                                }
	                                c[q >> 2] = c[(c[q >> 2] | 0) + 20 >> 2]
	                            }
	                        }
	                    } else if ((d | 0) == 1) {
	                        c[k >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break a;
	                            if (!((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 ? (vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0) == 0 : 0))KS(c[l >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                    } while (0);
	                    PS(c[l >> 2] | 0, 321, c[g >> 2] | 0);
	                    di(c[m >> 2] | 0);
	                    MS(c[l >> 2] | 0);
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                Ex(137216);
	                c[f >> 2] = -1;
	                s = c[f >> 2] | 0;
	                i = e;
	                return s | 0
	            }

	            function Zx(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    Ex(137296);
	                    i = d;
	                    return
	                } else {
	                    c[c[e >> 2] >> 2] = c[c[f >> 2] >> 2];
	                    c[(c[e >> 2] | 0) + 4 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    c[(c[e >> 2] | 0) + 8 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    i = d;
	                    return
	                }
	            }

	            function _x(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                c[d >> 2] = c[e >> 2];
	                Xd(0, 0, 0, 0, 0, 21, 1955, 2, 0, 0, 0, 0, 0, 0, 0, 138312, d);
	                i = b;
	                return
	            }

	            function $x(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) != (c[g >> 2] | 0)) {
	                    if (!(c[f >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    } else {
	                        c[e >> 2] = py(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function ay(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) != 0 ? (qy(c[(c[d >> 2] | 0) + 12 >> 2] | 0, 137776) | 0) != 0 : 0)e = (qy(c[(c[d >> 2] | 0) + 8 >> 2] | 0, 137384) | 0) != 0; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function by(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    Ex(138112);
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)p = c[(c[g >> 2] | 0) + 12 >> 2] | 0; else p = 137704;
	                c[j >> 2] = p;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 : 0)q = c[(c[g >> 2] | 0) + 8 >> 2] | 0; else q = 137704;
	                c[k >> 2] = q;
	                if (ky(c[j >> 2] | 0, 0) | 0)r = (ky(c[k >> 2] | 0, 0) | 0) != 0; else r = 0;
	                c[l >> 2] = r & 1;
	                a:do if (c[(c[f >> 2] | 0) + 16 >> 2] | 0) {
	                    if (c[l >> 2] | 0)s = 0; else s = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                    c[m >> 2] = s;
	                    c[h >> 2] = (c[c[f >> 2] >> 2] | 0) - 1;
	                    while (1) {
	                        if ((c[h >> 2] | 0) < (c[m >> 2] | 0))break a;
	                        c[n >> 2] = c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                        if (c[n >> 2] | 0)t = c[(c[n >> 2] | 0) + 12 >> 2] | 0; else t = 0;
	                        if (ky(c[j >> 2] | 0, t) | 0)break;
	                        c[h >> 2] = (c[h >> 2] | 0) + -1
	                    }
	                    if (c[n >> 2] | 0)u = c[(c[n >> 2] | 0) + 8 >> 2] | 0; else u = 0;
	                    c[e >> 2] = ky(c[k >> 2] | 0, u) | 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                } while (0);
	                c[e >> 2] = c[l >> 2];
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function cy(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                do if (c[f >> 2] | 0) {
	                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)break;
	                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) == 0 : 0)break;
	                    do if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) {
	                        d = Cb[c[135744 >> 2] & 511](64) | 0;
	                        c[(c[f >> 2] | 0) + 16 >> 2] = d;
	                        d = Cb[c[135744 >> 2] & 511](64) | 0;
	                        c[(c[f >> 2] | 0) + 20 >> 2] = d;
	                        if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                            d = (c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 0 | 0;
	                            b = d + 64 | 0;
	                            do {
	                                c[d >> 2] = 0;
	                                d = d + 4 | 0
	                            } while ((d | 0) < (b | 0));
	                            d = (c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 0 | 0;
	                            b = d + 64 | 0;
	                            do {
	                                c[d >> 2] = 0;
	                                d = d + 4 | 0
	                            } while ((d | 0) < (b | 0));
	                            c[(c[f >> 2] | 0) + 12 >> 2] = 16;
	                            break
	                        }
	                        Lx(138088);
	                        i = e;
	                        return
	                    } else l = 13; while (0);
	                    do if ((l | 0) == 13 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) == (c[c[f >> 2] >> 2] | 0) : 0) {
	                        c[k >> 2] = c[(c[f >> 2] | 0) + 12 >> 2] << 1;
	                        c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] << 2) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            Lx(138088);
	                            i = e;
	                            return
	                        }
	                        c[(c[f >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                        c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] << 2) | 0;
	                        if (c[j >> 2] | 0) {
	                            c[(c[f >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                            c[(c[f >> 2] | 0) + 12 >> 2] = c[k >> 2];
	                            break
	                        }
	                        Lx(138088);
	                        i = e;
	                        return
	                    } while (0);
	                    c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[c[f >> 2] >> 2] << 2) >> 2] = c[g >> 2];
	                    c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + (c[c[f >> 2] >> 2] << 2) >> 2] = c[h >> 2];
	                    d = c[f >> 2] | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1;
	                    i = e;
	                    return
	                } while (0);
	                Ex(138056);
	                i = e;
	                return
	            }

	            function dy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    Ex(137960);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                b = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                    Qk(b, 137984) | 0;
	                    Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137992) | 0
	                } else Qk(b, 138e3) | 0;
	                b = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0)gz(c[b + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0; else Qk(b, 138008) | 0;
	                c[e >> 2] = 1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function ey(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    Ex(138016);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)r = c[(c[h >> 2] | 0) + 12 >> 2] | 0; else r = 137704;
	                c[l >> 2] = r;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 : 0)s = c[(c[h >> 2] | 0) + 8 >> 2] | 0; else s = 137704;
	                c[m >> 2] = s;
	                if (ky(c[l >> 2] | 0, 0) | 0)t = (ky(c[m >> 2] | 0, 0) | 0) != 0; else t = 0;
	                c[n >> 2] = t & 1;
	                a:do if (c[(c[g >> 2] | 0) + 16 >> 2] | 0) {
	                    c[o >> 2] = 0;
	                    c[k >> 2] = (c[c[g >> 2] >> 2] | 0) - 1;
	                    while (1) {
	                        if ((c[k >> 2] | 0) < (c[o >> 2] | 0))break a;
	                        c[p >> 2] = c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        if (c[p >> 2] | 0)u = c[(c[p >> 2] | 0) + 12 >> 2] | 0; else u = 0;
	                        if (ky(c[l >> 2] | 0, u) | 0)break;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1
	                    }
	                    if (c[p >> 2] | 0)v = c[(c[p >> 2] | 0) + 8 >> 2] | 0; else v = 0;
	                    if (!(ky(c[m >> 2] | 0, v) | 0)) {
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    if (c[(c[j >> 2] | 0) + 4 >> 2] | 0)w = vb[c[(c[j >> 2] | 0) + 4 >> 2] & 511](c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[p >> 2] | 0, c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0; else w = 1;
	                    c[f >> 2] = w;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                } while (0);
	                c[f >> 2] = c[n >> 2];
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function fy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                do if ((c[f >> 2] | 0) == (c[g >> 2] | 0))c[e >> 2] = 0; else {
	                    if (!(c[f >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    b = c[f >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) == (c[(c[g >> 2] | 0) + 36 >> 2] | 0)) {
	                        c[e >> 2] = py(c[b + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        break
	                    }
	                    if (!(c[b + 36 >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (!(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    c[h >> 2] = py(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0))c[h >> 2] = py(c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[e >> 2] = c[h >> 2]
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function gy(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[(c[d >> 2] | 0) + 36 >> 2] | 0)) {
	                    e = 0;
	                    f = e & 1;
	                    i = b;
	                    return f | 0
	                }
	                e = (ay(c[(c[d >> 2] | 0) + 36 >> 2] | 0) | 0) != 0;
	                f = e & 1;
	                i = b;
	                return f | 0
	            }

	            function hy(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                while (1) {
	                    if (!(c[j >> 2] | 0)) {
	                        n = 9;
	                        break
	                    }
	                    if (c[(c[h >> 2] | 0) + 4 >> 2] | 0)o = vb[c[(c[h >> 2] | 0) + 4 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0) | 0; else o = 1;
	                    if (!((o | 0) != 0 ^ 1)) {
	                        n = 9;
	                        break
	                    }
	                    c[m >> 2] = Ai(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    if (c[m >> 2] | 0) {
	                        n = 7;
	                        break
	                    }
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 20 >> 2]
	                }
	                if ((n | 0) == 7) {
	                    c[g >> 2] = c[m >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else if ((n | 0) == 9) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                return 0
	            }

	            function iy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = _h(c[c[g >> 2] >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        Ix(137528);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    c[k >> 2] = c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 20 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0)) {
	                            q = 23;
	                            break
	                        }
	                        if (c[(c[g >> 2] | 0) + 4 >> 2] | 0)r = vb[c[(c[g >> 2] | 0) + 4 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[(c[k >> 2] | 0) + 20 >> 2] | 0) | 0; else r = 1;
	                        if (!((r | 0) != 0 ^ 1)) {
	                            q = 23;
	                            break
	                        }
	                        c[l >> 2] = Ai(c[k >> 2] | 0, 137376, 137384) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[m >> 2] = _h(c[c[g >> 2] >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                            if (!(c[m >> 2] | 0)) {
	                                q = 13;
	                                break
	                            }
	                            c[o >> 2] = xy(c[m >> 2] | 0) | 0;
	                            if ((c[o >> 2] | 0) > 1 ? (d[(c[m >> 2] | 0) + ((c[o >> 2] | 0) - 2) >> 0] | 0 | 0) == 46 : 0) {
	                                c[n >> 2] = By(c[m >> 2] | 0, 137584) | 0;
	                                if (!(c[n >> 2] | 0)) {
	                                    q = 17;
	                                    break
	                                }
	                                c[m >> 2] = c[n >> 2]
	                            }
	                            c[n >> 2] = Hl(c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                            b = (c[n >> 2] | 0) == 0;
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            if (b) {
	                                q = 20;
	                                break
	                            }
	                            c[j >> 2] = c[n >> 2]
	                        }
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((q | 0) == 13) {
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        Ix(137528);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    } else if ((q | 0) == 17) {
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        Ix(137592);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    } else if ((q | 0) == 20) {
	                        Ix(137648);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    } else if ((q | 0) == 23) {
	                        if ((c[j >> 2] | 0) != 0 ? (qy(c[j >> 2] | 0, 137704) | 0) == 0 : 0) {
	                            c[l >> 2] = ai(0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, 137376, c[j >> 2] | 0) | 0;
	                            h = (c[l >> 2] | 0) == 0;
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            if (h) {
	                                Ix(137712);
	                                c[f >> 2] = 0;
	                                p = c[f >> 2] | 0;
	                                i = e;
	                                return p | 0
	                            } else {
	                                c[f >> 2] = c[l >> 2];
	                                p = c[f >> 2] | 0;
	                                i = e;
	                                return p | 0
	                            }
	                        }
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                }
	                Ex(137496);
	                c[f >> 2] = 0;
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function jy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    Ex(137424);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 136792) | 0;
	                if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (xy(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 0 : 0) {
	                    Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137176) | 0
	                }
	                Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137448) | 0;
	                c[h >> 2] = _h(c[c[g >> 2] >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                do if (c[h >> 2] | 0) {
	                    c[j >> 2] = Qx(c[h >> 2] | 0, 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    if (c[j >> 2] | 0) {
	                        Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        break
	                    }
	                    Ix(137456);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } while (0);
	                Qk(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 137488) | 0;
	                c[e >> 2] = 1;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function ky(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 8 | 0;
	                h = f + 4 | 0;
	                j = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                do if ((c[h >> 2] | 0) != (c[j >> 2] | 0)) {
	                    e = c[j >> 2] | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        c[g >> 2] = (d[e >> 0] | 0) == 0 & 1;
	                        break
	                    }
	                    if (!e) {
	                        c[g >> 2] = (d[c[h >> 2] >> 0] | 0) == 0 & 1;
	                        break
	                    }
	                    while (1) {
	                        e = c[h >> 2] | 0;
	                        c[h >> 2] = e + 1;
	                        if ((d[e >> 0] | 0) != (d[c[j >> 2] >> 0] | 0)) {
	                            k = 8;
	                            break
	                        }
	                        e = c[j >> 2] | 0;
	                        c[j >> 2] = e + 1;
	                        if (!(a[e >> 0] | 0)) {
	                            k = 10;
	                            break
	                        }
	                    }
	                    if ((k | 0) == 8) {
	                        c[g >> 2] = 0;
	                        break
	                    } else if ((k | 0) == 10) {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                } else c[g >> 2] = 1; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function ly(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) < 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = Cb[c[135752 >> 2] & 511]((c[h >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    ie(0, 0);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    eU(c[j >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    a[(c[j >> 2] | 0) + (c[h >> 2] | 0) >> 0] = 0;
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function my(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                while (1) {
	                    if (!(d[c[g >> 2] >> 0] | 0))break;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                c[e >> 2] = ly(c[f >> 2] | 0, (c[g >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                h = c[e >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function ny(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[l >> 2] = Cb[c[135752 >> 2] & 511]((c[j >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    ie(0, 0);
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[j >> 2] | 0)) {
	                        n = 10;
	                        break
	                    }
	                    a[(c[l >> 2] | 0) + (c[k >> 2] | 0) >> 0] = a[(c[h >> 2] | 0) + (c[k >> 2] | 0) >> 0] | 0;
	                    if (!(d[(c[l >> 2] | 0) + (c[k >> 2] | 0) >> 0] | 0)) {
	                        n = 8;
	                        break
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((n | 0) == 8) {
	                    c[g >> 2] = c[l >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else if ((n | 0) == 10) {
	                    a[(c[l >> 2] | 0) + (c[j >> 2] | 0) >> 0] = 0;
	                    c[g >> 2] = c[l >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function oy(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                while (1) {
	                    if (!(a[c[g >> 2] >> 0] | 0))break;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                c[e >> 2] = ny(c[f >> 2] | 0, (c[g >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function py(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                do if ((c[g >> 2] | 0) != (c[h >> 2] | 0)) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                    while (1) {
	                        b = c[g >> 2] | 0;
	                        c[g >> 2] = b + 1;
	                        c[j >> 2] = (d[b >> 0] | 0) - (d[c[h >> 2] >> 0] | 0);
	                        if (c[j >> 2] | 0) {
	                            k = 8;
	                            break
	                        }
	                        b = c[h >> 2] | 0;
	                        c[h >> 2] = b + 1;
	                        if (!(d[b >> 0] | 0)) {
	                            k = 10;
	                            break
	                        }
	                    }
	                    if ((k | 0) == 8) {
	                        c[f >> 2] = c[j >> 2];
	                        break
	                    } else if ((k | 0) == 10) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function qy(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 8 | 0;
	                h = f + 4 | 0;
	                j = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                do if ((c[h >> 2] | 0) != (c[j >> 2] | 0)) {
	                    if (!(c[h >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    while (1) {
	                        e = c[h >> 2] | 0;
	                        c[h >> 2] = e + 1;
	                        if ((d[e >> 0] | 0) != (d[c[j >> 2] >> 0] | 0)) {
	                            k = 8;
	                            break
	                        }
	                        e = c[j >> 2] | 0;
	                        c[j >> 2] = e + 1;
	                        if (!(a[e >> 0] | 0)) {
	                            k = 10;
	                            break
	                        }
	                    }
	                    if ((k | 0) == 8) {
	                        c[g >> 2] = 0;
	                        break
	                    } else if ((k | 0) == 10) {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                } else c[g >> 2] = 1; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function ry(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 16 | 0;
	                h = g + 12 | 0;
	                j = g + 8 | 0;
	                k = g + 4 | 0;
	                l = g;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                f = c[k >> 2] | 0;
	                do if (c[j >> 2] | 0) {
	                    if (!f) {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    if (!(c[l >> 2] | 0)) {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    do {
	                        e = c[j >> 2] | 0;
	                        c[j >> 2] = e + 1;
	                        if ((d[e >> 0] | 0) != (d[c[l >> 2] >> 0] | 0)) {
	                            m = 8;
	                            break
	                        }
	                        e = c[l >> 2] | 0;
	                        c[l >> 2] = e + 1;
	                        if (!(d[e >> 0] | 0))break
	                    } while ((d[c[j >> 2] >> 0] | 0) != 0);
	                    if ((m | 0) == 8) {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    e = c[l >> 2] | 0;
	                    c[l >> 2] = e + 1;
	                    if ((d[e >> 0] | 0) != 58) {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    while (1) {
	                        e = c[k >> 2] | 0;
	                        c[k >> 2] = e + 1;
	                        if ((d[e >> 0] | 0) != (d[c[l >> 2] >> 0] | 0)) {
	                            m = 14;
	                            break
	                        }
	                        e = c[l >> 2] | 0;
	                        c[l >> 2] = e + 1;
	                        if (!(a[e >> 0] | 0)) {
	                            m = 16;
	                            break
	                        }
	                    }
	                    if ((m | 0) == 14) {
	                        c[h >> 2] = 0;
	                        break
	                    } else if ((m | 0) == 16) {
	                        c[h >> 2] = 1;
	                        break
	                    }
	                } else c[h >> 2] = qy(f, c[l >> 2] | 0) | 0; while (0);
	                i = g;
	                return c[h >> 2] | 0
	            }

	            function sy(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if ((c[j >> 2] | 0) > 0) {
	                    if ((c[g >> 2] | 0) == (c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[k >> 2] = QT(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[f >> 2] = c[k >> 2];
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function ty(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                do if ((c[g >> 2] | 0) != (c[h >> 2] | 0)) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                    while (1) {
	                        b = c[g >> 2] | 0;
	                        c[g >> 2] = b + 1;
	                        c[j >> 2] = (d[138656 + (d[b >> 0] | 0) >> 0] | 0) - (d[138656 + (d[c[h >> 2] >> 0] | 0) >> 0] | 0);
	                        if (c[j >> 2] | 0) {
	                            k = 8;
	                            break
	                        }
	                        b = c[h >> 2] | 0;
	                        c[h >> 2] = b + 1;
	                        if (!(d[b >> 0] | 0)) {
	                            k = 10;
	                            break
	                        }
	                    }
	                    if ((k | 0) == 8) {
	                        c[f >> 2] = c[j >> 2];
	                        break
	                    } else if ((k | 0) == 10) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function uy(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                do if ((c[k >> 2] | 0) > 0) {
	                    if ((c[h >> 2] | 0) == (c[j >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if (!(c[h >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                    while (1) {
	                        e = c[h >> 2] | 0;
	                        c[h >> 2] = e + 1;
	                        c[l >> 2] = (d[138656 + (d[e >> 0] | 0) >> 0] | 0) - (d[138656 + (d[c[j >> 2] >> 0] | 0) >> 0] | 0);
	                        if (c[l >> 2] | 0) {
	                            m = 11;
	                            break
	                        }
	                        e = (c[k >> 2] | 0) + -1 | 0;
	                        c[k >> 2] = e;
	                        if (!e) {
	                            m = 11;
	                            break
	                        }
	                        e = c[j >> 2] | 0;
	                        c[j >> 2] = e + 1;
	                        if (!(d[e >> 0] | 0)) {
	                            m = 13;
	                            break
	                        }
	                    }
	                    if ((m | 0) == 11) {
	                        c[g >> 2] = c[l >> 2];
	                        break
	                    } else if ((m | 0) == 13) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                } else c[g >> 2] = 0; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function vy(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 4 | 0;
	                h = f;
	                j = f + 8 | 0;
	                c[h >> 2] = b;
	                a[j >> 0] = e;
	                do if (c[h >> 2] | 0) {
	                    while (1) {
	                        if (!(d[c[h >> 2] >> 0] | 0)) {
	                            k = 7;
	                            break
	                        }
	                        l = c[h >> 2] | 0;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) == (d[j >> 0] | 0 | 0)) {
	                            k = 5;
	                            break
	                        }
	                        c[h >> 2] = l + 1
	                    }
	                    if ((k | 0) == 5) {
	                        c[g >> 2] = l;
	                        break
	                    } else if ((k | 0) == 7) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                } else c[g >> 2] = 0; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function wy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                do if (c[g >> 2] | 0) {
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    c[j >> 2] = xy(c[h >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = c[g >> 2];
	                        break
	                    }
	                    while (1) {
	                        if (!(d[c[g >> 2] >> 0] | 0)) {
	                            k = 12;
	                            break
	                        }
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) == (d[c[h >> 2] >> 0] | 0 | 0) ? (sy(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) == 0 : 0) {
	                            k = 10;
	                            break
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    if ((k | 0) == 10) {
	                        c[f >> 2] = c[g >> 2];
	                        break
	                    } else if ((k | 0) == 12) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function xy(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                while (1) {
	                    if (!(d[c[f >> 2] >> 0] | 0))break;
	                    c[f >> 2] = (c[f >> 2] | 0) + 1;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                c[e >> 2] = c[g >> 2];
	                h = c[e >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function yy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                do if (c[g >> 2] | 0) {
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    c[j >> 2] = xy(c[h >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = c[g >> 2];
	                        break
	                    }
	                    while (1) {
	                        if (!(d[c[g >> 2] >> 0] | 0)) {
	                            k = 12;
	                            break
	                        }
	                        if ((d[138656 + (d[c[g >> 2] >> 0] | 0) >> 0] | 0 | 0) == (d[138656 + (d[c[h >> 2] >> 0] | 0) >> 0] | 0 | 0) ? (uy(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) == 0 : 0) {
	                            k = 10;
	                            break
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    if ((k | 0) == 10) {
	                        c[f >> 2] = c[g >> 2];
	                        break
	                    } else if ((k | 0) == 12) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function zy(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = c[h >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if ((c[k >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = ly(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[l >> 2] = xy(c[h >> 2] | 0) | 0;
	                c[m >> 2] = Hb[c[135760 >> 2] & 511](c[h >> 2] | 0, (c[l >> 2] | 0) + (c[k >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    ie(0, 0);
	                    c[g >> 2] = c[h >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    eU((c[m >> 2] | 0) + (c[l >> 2] | 0) | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    a[(c[m >> 2] | 0) + ((c[l >> 2] | 0) + (c[k >> 2] | 0)) >> 0] = 0;
	                    c[g >> 2] = c[m >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function Ay(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if ((c[k >> 2] | 0) < 0)c[k >> 2] = xy(c[j >> 2] | 0) | 0;
	                e = c[h >> 2] | 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = my(e) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (!e) {
	                    c[g >> 2] = ly(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[l >> 2] = xy(c[h >> 2] | 0) | 0;
	                c[m >> 2] = Cb[c[135744 >> 2] & 511]((c[l >> 2] | 0) + (c[k >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    ie(0, 0);
	                    c[g >> 2] = ly(c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    eU(c[m >> 2] | 0, c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                    eU((c[m >> 2] | 0) + (c[l >> 2] | 0) | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    a[(c[m >> 2] | 0) + ((c[l >> 2] | 0) + (c[k >> 2] | 0)) >> 0] = 0;
	                    c[g >> 2] = c[m >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function By(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[h >> 2];
	                b = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = b;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (!b) {
	                    c[f >> 2] = my(c[h >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                while (1) {
	                    if (!(d[c[j >> 2] >> 0] | 0))break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                c[f >> 2] = zy(c[g >> 2] | 0, c[h >> 2] | 0, (c[j >> 2] | 0) - (c[h >> 2] | 0) | 0) | 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Cy(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 8 | 0;
	                n = g;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[j >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                } else {
	                    c[m >> 2] = f;
	                    c[n >> 2] = LT(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, m) | 0;
	                    a[(c[j >> 2] | 0) + ((c[k >> 2] | 0) - 1) >> 0] = 0;
	                    c[h >> 2] = c[n >> 2];
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                return 0
	            }

	            function Dy(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a:while (1) {
	                    if (!(d[c[f >> 2] >> 0] | 0)) {
	                        j = 19;
	                        break
	                    }
	                    a = (c[f >> 2] | 0) + 1 | 0;
	                    do if ((d[c[f >> 2] >> 0] | 0) & 128) {
	                        if (((d[a >> 0] | 0) & 192 | 0) != 128) {
	                            j = 6;
	                            break a
	                        }
	                        k = (c[f >> 2] | 0) + 2 | 0;
	                        if (((d[c[f >> 2] >> 0] | 0) & 224 | 0) != 224) {
	                            c[f >> 2] = k;
	                            break
	                        }
	                        if (((d[k >> 0] | 0) & 192 | 0) != 128) {
	                            j = 9;
	                            break a
	                        }
	                        k = c[f >> 2] | 0;
	                        if (((d[c[f >> 2] >> 0] | 0) & 240 | 0) != 240) {
	                            c[f >> 2] = k + 3;
	                            break
	                        }
	                        if (((d[k >> 0] | 0) & 248 | 0) != 240) {
	                            j = 13;
	                            break a
	                        }
	                        if (((d[(c[f >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128) {
	                            j = 13;
	                            break a
	                        }
	                        c[f >> 2] = (c[f >> 2] | 0) + 4
	                    } else c[f >> 2] = a; while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if ((j | 0) == 6) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 9) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 13) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 19) {
	                    c[e >> 2] = c[g >> 2];
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function Ey(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                a:do if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[c[h >> 2] >> 2] | 0) >= 1 : 0) {
	                    c[j >> 2] = d[c[g >> 2] >> 0];
	                    b = c[h >> 2] | 0;
	                    do if (c[j >> 2] & 128) {
	                        if ((c[b >> 2] | 0) < 2)break a;
	                        if (((d[(c[g >> 2] | 0) + 1 >> 0] | 0) & 192 | 0) != 128)break a;
	                        a = c[h >> 2] | 0;
	                        if ((c[j >> 2] & 224 | 0) != 224) {
	                            c[a >> 2] = 2;
	                            c[j >> 2] = ((d[c[g >> 2] >> 0] | 0) & 31) << 6;
	                            c[j >> 2] = c[j >> 2] | (d[(c[g >> 2] | 0) + 1 >> 0] | 0) & 63;
	                            break
	                        }
	                        if ((c[a >> 2] | 0) < 3)break a;
	                        if (((d[(c[g >> 2] | 0) + 2 >> 0] | 0) & 192 | 0) != 128)break a;
	                        a = c[h >> 2] | 0;
	                        if ((c[j >> 2] & 240 | 0) != 240) {
	                            c[a >> 2] = 3;
	                            c[j >> 2] = ((d[c[g >> 2] >> 0] | 0) & 15) << 12;
	                            c[j >> 2] = c[j >> 2] | ((d[(c[g >> 2] | 0) + 1 >> 0] | 0) & 63) << 6;
	                            c[j >> 2] = c[j >> 2] | (d[(c[g >> 2] | 0) + 2 >> 0] | 0) & 63;
	                            break
	                        }
	                        if ((c[a >> 2] | 0) < 4)break a;
	                        if ((c[j >> 2] & 248 | 0) != 240)break a;
	                        if (((d[(c[g >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128)break a;
	                        c[c[h >> 2] >> 2] = 4;
	                        c[j >> 2] = ((d[c[g >> 2] >> 0] | 0) & 7) << 18;
	                        c[j >> 2] = c[j >> 2] | ((d[(c[g >> 2] | 0) + 1 >> 0] | 0) & 63) << 12;
	                        c[j >> 2] = c[j >> 2] | ((d[(c[g >> 2] | 0) + 2 >> 0] | 0) & 63) << 6;
	                        c[j >> 2] = c[j >> 2] | (d[(c[g >> 2] | 0) + 3 >> 0] | 0) & 63
	                    } else c[b >> 2] = 1; while (0);
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } while (0);
	                if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = 0;
	                c[f >> 2] = -1;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Fy(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                j = e + 12 | 0;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    b = a[(c[g >> 2] | 0) + (c[h >> 2] | 0) >> 0] | 0;
	                    a[j >> 0] = b;
	                    if (!(b << 24 >> 24)) {
	                        l = 23;
	                        break
	                    }
	                    if (!((d[j >> 0] | 0) & 128)) {
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        continue
	                    }
	                    if (((d[j >> 0] | 0) & 224 | 0) == 192) {
	                        if (((d[(c[g >> 2] | 0) + ((c[h >> 2] | 0) + 1) >> 0] | 0) & 192 | 0) != 128) {
	                            l = 9;
	                            break
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 2;
	                        continue
	                    }
	                    if (((d[j >> 0] | 0) & 240 | 0) == 224) {
	                        if (((d[(c[g >> 2] | 0) + ((c[h >> 2] | 0) + 1) >> 0] | 0) & 192 | 0) != 128) {
	                            l = 14;
	                            break
	                        }
	                        if (((d[(c[g >> 2] | 0) + ((c[h >> 2] | 0) + 2) >> 0] | 0) & 192 | 0) != 128) {
	                            l = 14;
	                            break
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 3;
	                        continue
	                    }
	                    if (((d[j >> 0] | 0) & 248 | 0) != 240) {
	                        l = 22;
	                        break
	                    }
	                    if (((d[(c[g >> 2] | 0) + ((c[h >> 2] | 0) + 1) >> 0] | 0) & 192 | 0) != 128) {
	                        l = 20;
	                        break
	                    }
	                    if (((d[(c[g >> 2] | 0) + ((c[h >> 2] | 0) + 2) >> 0] | 0) & 192 | 0) != 128) {
	                        l = 20;
	                        break
	                    }
	                    if (((d[(c[g >> 2] | 0) + ((c[h >> 2] | 0) + 3) >> 0] | 0) & 192 | 0) != 128) {
	                        l = 20;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 4
	                }
	                if ((l | 0) == 9) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((l | 0) == 14) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((l | 0) == 20) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((l | 0) == 22) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((l | 0) == 23) {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function Gy(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                l = f + 16 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = c[h >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if ((c[j >> 2] | 0) <= 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                a:while (1) {
	                    e = c[j >> 2] | 0;
	                    c[j >> 2] = e + -1;
	                    if ((e | 0) <= 0)break;
	                    if (!(a[c[k >> 2] >> 0] | 0))break;
	                    e = c[k >> 2] | 0;
	                    c[k >> 2] = e + 1;
	                    b = a[e >> 0] | 0;
	                    a[l >> 0] = b;
	                    if (!(b & 128))continue;
	                    while (1) {
	                        b = d[l >> 0] << 1 & 255;
	                        a[l >> 0] = b;
	                        if (!(b & 128))continue a;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        if (!(d[c[k >> 2] >> 0] | 0))continue a
	                    }
	                }
	                c[g >> 2] = (c[k >> 2] | 0) - (c[h >> 2] | 0);
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function Hy(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[l >> 2] = Gy(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[k >> 2] = Cb[c[135752 >> 2] & 511]((c[l >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    d = c[33976] | 0;
	                    b = c[33980] | 0;
	                    c[f >> 2] = (c[j >> 2] | 0) + 1;
	                    Db[d & 511](b, 138912, f);
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    eU(c[k >> 2] | 0, c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                    a[(c[k >> 2] | 0) + (c[l >> 2] | 0) >> 0] = 0;
	                    c[g >> 2] = c[k >> 2];
	                    m = c[g >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function Iy(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 8 | 0;
	                h = f + 4 | 0;
	                j = f;
	                k = f + 12 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                do if (c[h >> 2] | 0) {
	                    if ((c[j >> 2] | 0) < 0) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    a:while (1) {
	                        e = c[j >> 2] | 0;
	                        c[j >> 2] = e + -1;
	                        l = c[h >> 2] | 0;
	                        if (!e) {
	                            m = 14;
	                            break
	                        }
	                        c[h >> 2] = l + 1;
	                        e = a[l >> 0] | 0;
	                        a[k >> 0] = e;
	                        if (!(e & 255)) {
	                            m = 7;
	                            break
	                        }
	                        if (!((d[k >> 0] | 0) & 128))continue;
	                        if (((d[k >> 0] | 0) & 192 | 0) != 192) {
	                            m = 10;
	                            break
	                        }
	                        while (1) {
	                            e = (d[k >> 0] | 0) << 1 & 255;
	                            a[k >> 0] = e;
	                            if (!(e & 128))continue a;
	                            e = c[h >> 2] | 0;
	                            c[h >> 2] = e + 1;
	                            if (((d[e >> 0] | 0) & 192 | 0) != 128) {
	                                m = 13;
	                                break a
	                            }
	                        }
	                    }
	                    if ((m | 0) == 7) {
	                        c[g >> 2] = 0;
	                        break
	                    } else if ((m | 0) == 10) {
	                        c[g >> 2] = 0;
	                        break
	                    } else if ((m | 0) == 13) {
	                        c[g >> 2] = 0;
	                        break
	                    } else if ((m | 0) == 14) {
	                        c[g >> 2] = l;
	                        break
	                    }
	                } else c[g >> 2] = 0; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function Jy(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                m = f + 20 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[l >> 2] = Gy(c[j >> 2] | 0, 1) | 0;
	                c[k >> 2] = 0;
	                a:while (1) {
	                    e = a[c[h >> 2] >> 0] | 0;
	                    a[m >> 0] = e;
	                    if (!(e & 255)) {
	                        o = 14;
	                        break
	                    }
	                    if (!(sy(c[h >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0) | 0)) {
	                        o = 6;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    b:do if ((d[m >> 0] | 0) & 128) {
	                        if (((d[m >> 0] | 0) & 192 | 0) != 192) {
	                            o = 9;
	                            break a
	                        }
	                        while (1) {
	                            e = (d[m >> 0] | 0) << 1 & 255;
	                            a[m >> 0] = e;
	                            if (!(e & 128))break b;
	                            e = c[h >> 2] | 0;
	                            c[h >> 2] = e + 1;
	                            if (((d[e >> 0] | 0) & 192 | 0) != 128) {
	                                o = 12;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((o | 0) == 6) {
	                    c[g >> 2] = c[k >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((o | 0) == 9) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((o | 0) == 12) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((o | 0) == 14) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function Ky(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                n = g + 20 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                do if (c[j >> 2] | 0) {
	                    if ((c[k >> 2] | 0) < 0) {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    if ((c[l >> 2] | 0) < 0) {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    c[m >> 2] = 0;
	                    a:while (1) {
	                        o = c[j >> 2] | 0;
	                        if ((c[m >> 2] | 0) >= (c[k >> 2] | 0)) {
	                            p = 18;
	                            break
	                        }
	                        c[j >> 2] = o + 1;
	                        f = a[o >> 0] | 0;
	                        a[n >> 0] = f;
	                        if (!(f & 255)) {
	                            p = 10;
	                            break
	                        }
	                        b:do if ((d[n >> 0] | 0) & 128) {
	                            if (((d[n >> 0] | 0) & 192 | 0) != 192) {
	                                p = 13;
	                                break a
	                            }
	                            while (1) {
	                                f = (d[n >> 0] | 0) << 1 & 255;
	                                a[n >> 0] = f;
	                                if (!(f & 128))break b;
	                                f = c[j >> 2] | 0;
	                                c[j >> 2] = f + 1;
	                                if (((d[f >> 0] | 0) & 192 | 0) != 128) {
	                                    p = 16;
	                                    break a
	                                }
	                            }
	                        } while (0);
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    if ((p | 0) == 10) {
	                        c[h >> 2] = 0;
	                        break
	                    } else if ((p | 0) == 13) {
	                        c[h >> 2] = 0;
	                        break
	                    } else if ((p | 0) == 16) {
	                        c[h >> 2] = 0;
	                        break
	                    } else if ((p | 0) == 18) {
	                        c[h >> 2] = Hy(o, c[l >> 2] | 0) | 0;
	                        break
	                    }
	                } else c[h >> 2] = 0; while (0);
	                i = g;
	                return c[h >> 2] | 0
	            }

	            function Ly() {
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    lz(0, 138944);
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[(c[e >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 24 >> 2] = c[33950];
	                c[(c[e >> 2] | 0) + 8 >> 2] = c[33950];
	                c[(c[e >> 2] | 0) + 12 >> 2] = c[33948];
	                g = Cb[c[135752 >> 2] & 511](c[(c[e >> 2] | 0) + 24 >> 2] | 0) | 0;
	                c[c[e >> 2] >> 2] = g;
	                g = c[e >> 2] | 0;
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    lz(g, 138944);
	                    zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else {
	                    a[c[g >> 2] >> 0] = 0;
	                    c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                    c[d >> 2] = c[e >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function My(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = b;
	                c[g >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    lz(0, 138944);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[g >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[g >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[g >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[g >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[g >> 2] | 0) + 12 >> 2] = c[33948];
	                if (c[f >> 2] | 0)j = (c[f >> 2] | 0) + 2 | 0; else j = 0;
	                c[(c[g >> 2] | 0) + 24 >> 2] = j;
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                do if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                    j = Cb[c[135752 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    c[c[g >> 2] >> 2] = j;
	                    j = c[g >> 2] | 0;
	                    if (c[c[g >> 2] >> 2] | 0) {
	                        a[c[j >> 2] >> 0] = 0;
	                        break
	                    }
	                    lz(j, 138944);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else c[c[g >> 2] >> 2] = 0; while (0);
	                c[(c[g >> 2] | 0) + 16 >> 2] = 0;
	                c[e >> 2] = c[g >> 2];
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Ny(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    if ((c[(c[e >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 32 >> 2] | 0) {
	                        c[d >> 2] = 0;
	                        break
	                    } else {
	                        c[f >> 2] = c[c[e >> 2] >> 2];
	                        c[c[e >> 2] >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 24 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 4 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 8 >> 2] = 0;
	                        c[d >> 2] = c[f >> 2];
	                        break
	                    }
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Oy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    lz(0, 138944);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[g >> 2] | 0) >>> 0 < 2147483647) {
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                    c[(c[h >> 2] | 0) + 8 >> 2] = c[g >> 2]
	                } else {
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 2147483647;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 2147483647
	                }
	                c[(c[h >> 2] | 0) + 20 >> 2] = c[g >> 2];
	                c[(c[h >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                c[(c[h >> 2] | 0) + 12 >> 2] = 2;
	                c[c[h >> 2] >> 2] = c[f >> 2];
	                c[(c[h >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 28 >> 2] = 0;
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Py(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0))c[d >> 2] = -1; else c[d >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Qy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 2 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 3 : 0) {
	                        b = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) == 0 | (c[g >> 2] | 0) == 1 | (c[g >> 2] | 0) == 4 | (c[g >> 2] | 0) == 2) {
	                            c[(c[f >> 2] | 0) + 12 >> 2] = b;
	                            if (c[(c[f >> 2] | 0) + 28 >> 2] | 0)c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                            c[e >> 2] = 0;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        } else {
	                            if ((b | 0) == 3) {
	                                c[(c[f >> 2] | 0) + 12 >> 2] = 3;
	                                c[(c[f >> 2] | 0) + 16 >> 2] = c[c[f >> 2] >> 2]
	                            }
	                            c[e >> 2] = -1;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                    }
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = -1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Ry(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0); else e = 5;
	                if (((e | 0) == 5 ? (c[c[d >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 2 : 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Sy(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 32 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != (c[(c[e >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != (c[(c[e >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                b = c[e >> 2] | 0;
	                do if ((c[(c[e >> 2] | 0) + 12 >> 2] | 0) == 2)c[b >> 2] = 138960; else {
	                    if ((c[b + 12 >> 2] | 0) == 3 ? (c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                        c[f >> 2] = (c[c[e >> 2] >> 2] | 0) - (c[(c[e >> 2] | 0) + 16 >> 2] | 0);
	                        g = (c[e >> 2] | 0) + 24 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[f >> 2] | 0);
	                        c[c[e >> 2] >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        a[c[c[e >> 2] >> 2] >> 0] = 0;
	                        break
	                    }
	                    a[c[c[e >> 2] >> 2] >> 0] = 0
	                } while (0);
	                f = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[e >> 2] | 0) + 8 >> 2] = c[f + 24 >> 2]; else c[f + 8 >> 2] = 2147483647;
	                f = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647) {
	                    c[(c[e >> 2] | 0) + 4 >> 2] = c[f + 20 >> 2];
	                    i = d;
	                    return
	                } else {
	                    c[f + 4 >> 2] = 2147483647;
	                    i = d;
	                    return
	                }
	            }

	            function Ty(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    if ((c[h >> 2] | 0) >>> 0 > (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0) {
	                        c[f >> 2] = 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    d = (c[g >> 2] | 0) + 20 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) - (c[h >> 2] | 0);
	                    do if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 2)l = 17; else {
	                        if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                            l = 17;
	                            break
	                        }
	                        fU(c[c[g >> 2] >> 2] | 0, (c[c[g >> 2] >> 2] | 0) + (c[h >> 2] | 0) | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        a[(c[c[g >> 2] >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0
	                    } while (0);
	                    if ((((l | 0) == 17 ? (l = c[g >> 2] | 0, c[l >> 2] = (c[l >> 2] | 0) + (c[h >> 2] | 0), l = (c[g >> 2] | 0) + 24 | 0, c[l >> 2] = (c[l >> 2] | 0) - (c[h >> 2] | 0), (c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 3) : 0) ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[j >> 2] = (c[c[g >> 2] >> 2] | 0) - (c[(c[g >> 2] | 0) + 16 >> 2] | 0), (c[j >> 2] | 0) >>> 0 >= (c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0) : 0) {
	                        fU(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        c[c[g >> 2] >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        a[(c[c[g >> 2] >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0;
	                        l = (c[g >> 2] | 0) + 24 | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + (c[j >> 2] | 0)
	                    }
	                    j = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 8 >> 2] = c[j + 24 >> 2]; else c[j + 8 >> 2] = 2147483647;
	                    j = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 4 >> 2] = c[j + 20 >> 2]; else c[j + 4 >> 2] = 2147483647;
	                    c[f >> 2] = c[h >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Uy(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (!((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) < 0)) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[h >> 2] = mz(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (c[(c[f >> 2] | 0) + 32 >> 2] | 0) {
	                        c[e >> 2] = -1;
	                        break
	                    } else {
	                        c[e >> 2] = c[h >> 2];
	                        break
	                    }
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Vy(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    c[d >> 2] = c[c[e >> 2] >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function Wy(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != (c[(c[e >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != (c[(c[e >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[d >> 2] = (c[c[e >> 2] >> 2] | 0) + (c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function Xy(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[h >> 2] | 0) >>> 0 > ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) - (c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0) >>> 0) {
	                        c[f >> 2] = -1;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    d = (c[g >> 2] | 0) + 20 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + (c[h >> 2] | 0);
	                    h = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 8 >> 2] = c[h + 24 >> 2]; else c[h + 8 >> 2] = 2147483647;
	                    h = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 4 >> 2] = c[h + 20 >> 2]; else c[h + 4 >> 2] = 2147483647;
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 > (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0) {
	                        a[(c[c[g >> 2] >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0;
	                        c[f >> 2] = 0;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    } else {
	                        c[f >> 2] = -1;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                }
	                c[f >> 2] = -1;
	                j = c[f >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function Yy(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[h >> 2] | 0) >>> 0 > (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0) {
	                        c[f >> 2] = -1;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    d = (c[g >> 2] | 0) + 20 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) - (c[h >> 2] | 0);
	                    a[(c[c[g >> 2] >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0;
	                    h = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 8 >> 2] = c[h + 24 >> 2]; else c[h + 8 >> 2] = 2147483647;
	                    h = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 4 >> 2] = c[h + 20 >> 2]; else c[h + 4 >> 2] = 2147483647;
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                c[f >> 2] = -1;
	                j = c[f >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function Zy(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != (c[(c[e >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != (c[(c[e >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function _y(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != (c[(c[e >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != (c[(c[e >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function $y(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != (c[(c[e >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != (c[(c[e >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[d >> 2] = (c[(c[e >> 2] | 0) + 24 >> 2] | 0) - (c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function az(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != (c[(c[e >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != (c[(c[e >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[e >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[d >> 2] = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) == 0 & 1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = -1;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function bz(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                    if ((c[h >> 2] | 0) >>> 0 < (c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0) {
	                        c[f >> 2] = 1;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                    d = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                    a:do if ((d | 0) == 4) {
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 4096) {
	                            c[j >> 2] = c[h >> 2];
	                            break
	                        }
	                        c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2] << 1;
	                        while (1) {
	                            if ((c[h >> 2] | 0) >>> 0 <= (c[j >> 2] | 0) >>> 0)break a;
	                            if ((c[j >> 2] | 0) >>> 0 > 2147483647)break;
	                            c[j >> 2] = c[j >> 2] << 1
	                        }
	                        lz(c[g >> 2] | 0, 138968);
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((d | 0) == 0 | (d | 0) == 3) {
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)n = c[(c[g >> 2] | 0) + 24 >> 2] << 1; else n = (c[h >> 2] | 0) + 10 | 0;
	                        c[j >> 2] = n;
	                        while (1) {
	                            if ((c[h >> 2] | 0) >>> 0 <= (c[j >> 2] | 0) >>> 0)break a;
	                            if ((c[j >> 2] | 0) >>> 0 > 2147483647)break;
	                            c[j >> 2] = c[j >> 2] << 1
	                        }
	                        lz(c[g >> 2] | 0, 138968);
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((d | 0) == 1)c[j >> 2] = (c[h >> 2] | 0) + 10; else c[j >> 2] = (c[h >> 2] | 0) + 10; while (0);
	                    do if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                        c[l >> 2] = (c[c[g >> 2] >> 2] | 0) - (c[(c[g >> 2] | 0) + 16 >> 2] | 0);
	                        if ((c[l >> 2] | 0) >>> 0 > (c[j >> 2] | 0) >>> 0) {
	                            fU(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                            c[c[g >> 2] >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                            a[(c[c[g >> 2] >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0;
	                            h = (c[g >> 2] | 0) + 24 | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + (c[l >> 2] | 0);
	                            break
	                        }
	                        c[k >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0, (c[l >> 2] | 0) + (c[j >> 2] | 0) | 0) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[(c[g >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                            c[c[g >> 2] >> 2] = (c[k >> 2] | 0) + (c[l >> 2] | 0);
	                            break
	                        }
	                        lz(c[g >> 2] | 0, 138968);
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else o = 39; while (0);
	                    do if ((o | 0) == 39) {
	                        do if (c[c[g >> 2] >> 2] | 0) {
	                            if (((c[(c[g >> 2] | 0) + 24 >> 2] | 0) - (c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0) >>> 0 < 100) {
	                                c[k >> 2] = Hb[c[135760 >> 2] & 511](c[c[g >> 2] >> 2] | 0, c[j >> 2] | 0) | 0;
	                                break
	                            }
	                            c[k >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0;
	                            if (c[k >> 2] | 0) {
	                                eU(c[k >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[c[g >> 2] >> 2] | 0);
	                                a[(c[k >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0
	                            }
	                        } else c[k >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0; while (0);
	                        if (c[k >> 2] | 0) {
	                            c[c[g >> 2] >> 2] = c[k >> 2];
	                            break
	                        }
	                        lz(c[g >> 2] | 0, 138968);
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } while (0);
	                    c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                    j = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 8 >> 2] = c[j + 24 >> 2]; else c[j + 8 >> 2] = 2147483647;
	                    j = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 4 >> 2] = c[j + 20 >> 2]; else c[j + 4 >> 2] = 2147483647;
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[f >> 2] = 0;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function cz(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!((c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) != (c[(c[h >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[h >> 2] | 0) + 24 >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != (c[(c[h >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[h >> 2] | 0) + 20 >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    if ((c[k >> 2] | 0) < -1) {
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    if ((c[k >> 2] | 0) < 0)c[k >> 2] = xy(c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    c[l >> 2] = (c[(c[h >> 2] | 0) + 20 >> 2] | 0) + (c[k >> 2] | 0) + 2;
	                    if ((c[l >> 2] | 0) >>> 0 > (c[(c[h >> 2] | 0) + 24 >> 2] | 0) >>> 0 ? (bz(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0) {
	                        lz(c[h >> 2] | 0, 138968);
	                        c[g >> 2] = 2;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    fU((c[c[h >> 2] >> 2] | 0) + (c[(c[h >> 2] | 0) + 20 >> 2] | 0) | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    j = (c[h >> 2] | 0) + 20 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[k >> 2] | 0);
	                    a[(c[c[h >> 2] >> 2] | 0) + (c[(c[h >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0;
	                    k = c[h >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[h >> 2] | 0) + 8 >> 2] = c[k + 24 >> 2]; else c[k + 8 >> 2] = 2147483647;
	                    k = c[h >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[h >> 2] | 0) + 4 >> 2] = c[k + 20 >> 2]; else c[k + 4 >> 2] = 2147483647;
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[g >> 2] = -1;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function dz(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) != (c[(c[h >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[h >> 2] | 0) + 24 >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != (c[(c[h >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[h >> 2] | 0) + 20 >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if ((c[k >> 2] | 0) < -1) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if ((c[k >> 2] | 0) < 0)c[k >> 2] = xy(c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) <= 0) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if (((c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[m >> 2] = (c[c[h >> 2] >> 2] | 0) - (c[(c[h >> 2] | 0) + 16 >> 2] | 0), (c[m >> 2] | 0) >>> 0 > (c[k >> 2] | 0) >>> 0) : 0) {
	                        m = c[h >> 2] | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + (0 - (c[k >> 2] | 0));
	                        fU(c[c[h >> 2] >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        m = (c[h >> 2] | 0) + 20 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + (c[k >> 2] | 0);
	                        m = (c[h >> 2] | 0) + 24 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + (c[k >> 2] | 0);
	                        m = c[h >> 2] | 0;
	                        if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[h >> 2] | 0) + 8 >> 2] = c[m + 24 >> 2]; else c[m + 8 >> 2] = 2147483647;
	                        m = c[h >> 2] | 0;
	                        if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[h >> 2] | 0) + 4 >> 2] = c[m + 20 >> 2]; else c[m + 4 >> 2] = 2147483647;
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    c[l >> 2] = (c[(c[h >> 2] | 0) + 20 >> 2] | 0) + (c[k >> 2] | 0) + 2;
	                    if ((c[l >> 2] | 0) >>> 0 > (c[(c[h >> 2] | 0) + 24 >> 2] | 0) >>> 0 ? (bz(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0) {
	                        lz(c[h >> 2] | 0, 138968);
	                        c[g >> 2] = 2;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    fU((c[c[h >> 2] >> 2] | 0) + (c[k >> 2] | 0) | 0, c[c[h >> 2] >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0) | 0;
	                    fU(c[c[h >> 2] >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    j = (c[h >> 2] | 0) + 20 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[k >> 2] | 0);
	                    a[(c[c[h >> 2] >> 2] | 0) + (c[(c[h >> 2] | 0) + 20 >> 2] | 0) >> 0] = 0;
	                    k = c[h >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[h >> 2] | 0) + 8 >> 2] = c[k + 24 >> 2]; else c[k + 8 >> 2] = 2147483647;
	                    k = c[h >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[h >> 2] | 0) + 4 >> 2] = c[k + 20 >> 2]; else c[k + 4 >> 2] = 2147483647;
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[g >> 2] = -1;
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function ez(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) != (c[(c[f >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != (c[(c[f >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else {
	                        c[e >> 2] = cz(c[f >> 2] | 0, c[g >> 2] | 0, -1) | 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = -1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function fz(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    c[j >> 2] = c[h >> 2];
	                    while (1) {
	                        l = c[(c[g >> 2] | 0) + 20 >> 2] | 0;
	                        if (!(a[c[j >> 2] >> 0] | 0))break;
	                        if ((l + 10 | 0) >>> 0 >= (c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 ? (bz(c[g >> 2] | 0, (c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 10 | 0) | 0) == 0 : 0) {
	                            m = 18;
	                            break
	                        }
	                        h = a[c[j >> 2] >> 0] | 0;
	                        d = (c[g >> 2] | 0) + 20 | 0;
	                        b = c[d >> 2] | 0;
	                        c[d >> 2] = b + 1;
	                        a[(c[c[g >> 2] >> 2] | 0) + b >> 0] = h;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    if ((m | 0) == 18) {
	                        lz(c[g >> 2] | 0, 138968);
	                        c[f >> 2] = 2;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    a[(c[c[g >> 2] >> 2] | 0) + l >> 0] = 0;
	                    l = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 8 >> 2] = c[l + 24 >> 2]; else c[l + 8 >> 2] = 2147483647;
	                    l = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[g >> 2] | 0) + 4 >> 2] = c[l + 20 >> 2]; else c[l + 4 >> 2] = 2147483647;
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[f >> 2] = -1;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function gz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    do if (vy(c[h >> 2] | 0, 34) | 0) {
	                        b = (vy(c[h >> 2] | 0, 39) | 0) != 0;
	                        a = c[g >> 2] | 0;
	                        if (!b) {
	                            fz(a, 139e3) | 0;
	                            ez(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                            fz(c[g >> 2] | 0, 139e3) | 0;
	                            break
	                        }
	                        fz(a, 138984) | 0;
	                        a = c[h >> 2] | 0;
	                        c[j >> 2] = a;
	                        c[k >> 2] = a;
	                        while (1) {
	                            if (!(d[c[j >> 2] >> 0] | 0))break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 34) {
	                                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                                continue
	                            }
	                            if ((c[k >> 2] | 0) != (c[j >> 2] | 0))cz(c[g >> 2] | 0, c[k >> 2] | 0, (c[j >> 2] | 0) - (c[k >> 2] | 0) | 0) | 0;
	                            cz(c[g >> 2] | 0, 138992, 6) | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            c[k >> 2] = c[j >> 2]
	                        }
	                        if ((c[k >> 2] | 0) != (c[j >> 2] | 0))cz(c[g >> 2] | 0, c[k >> 2] | 0, (c[j >> 2] | 0) - (c[k >> 2] | 0) | 0) | 0;
	                        fz(c[g >> 2] | 0, 138984) | 0
	                    } else {
	                        fz(c[g >> 2] | 0, 138984) | 0;
	                        ez(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        fz(c[g >> 2] | 0, 138984) | 0
	                    } while (0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = -1;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function hz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) != (c[(c[f >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != (c[(c[f >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    if (((c[g >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 > 0 : 0)c[h >> 2] = cz(c[f >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    lj(c[g >> 2] | 0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                lj(c[g >> 2] | 0);
	                c[e >> 2] = -1;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function iz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) != (c[(c[f >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != (c[(c[f >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    b = c[c[f >> 2] >> 2] | 0;
	                    c[(c[g >> 2] | 0) + 16 >> 2] = b;
	                    c[(c[g >> 2] | 0) + 12 >> 2] = b;
	                    c[(c[g >> 2] | 0) + 20 >> 2] = (c[c[f >> 2] >> 2] | 0) + (c[(c[f >> 2] | 0) + 20 >> 2] | 0);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = -1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function jz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) != (c[(c[f >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != (c[(c[f >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    c[h >> 2] = (c[(c[g >> 2] | 0) + 12 >> 2] | 0) - (c[c[f >> 2] >> 2] | 0);
	                    if ((c[h >> 2] | 0) >>> 0 > (c[(c[f >> 2] | 0) + 24 >> 2] | 0) >>> 0) {
	                        nz(c[f >> 2] | 0, 139008);
	                        c[h >> 2] = 0
	                    }
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = -1;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function kz(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!((c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) != (c[(c[h >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[h >> 2] | 0) + 24 >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != (c[(c[h >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[h >> 2] | 0) + 20 >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                    c[(c[j >> 2] | 0) + 12 >> 2] = (c[c[h >> 2] >> 2] | 0) + (c[k >> 2] | 0);
	                    c[(c[j >> 2] | 0) + 16 >> 2] = (c[(c[j >> 2] | 0) + 12 >> 2] | 0) + (c[l >> 2] | 0);
	                    c[(c[j >> 2] | 0) + 20 >> 2] = (c[c[h >> 2] >> 2] | 0) + (c[(c[h >> 2] | 0) + 20 >> 2] | 0);
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[g >> 2] = -1;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function lz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                ce(29, 2, 0, 0, c[f >> 2] | 0);
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 32 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                c[(c[e >> 2] | 0) + 32 >> 2] = 2;
	                i = d;
	                return
	            }

	            function mz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) != (c[(c[f >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != (c[(c[f >> 2] | 0) + 4 >> 2] | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 2147483647 : 0)c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    b = c[(c[f >> 2] | 0) + 24 >> 2] | 0;
	                    if (((c[(c[f >> 2] | 0) + 20 >> 2] | 0) + (c[g >> 2] | 0) | 0) >>> 0 < (c[(c[f >> 2] | 0) + 24 >> 2] | 0) >>> 0) {
	                        c[e >> 2] = b - (c[(c[f >> 2] | 0) + 20 >> 2] | 0);
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    a = c[f >> 2] | 0;
	                    if (b >>> 0 > (c[g >> 2] | 0) >>> 0)c[h >> 2] = c[a + 24 >> 2] << 1; else c[h >> 2] = (c[a + 20 >> 2] | 0) + (c[g >> 2] | 0) + 100;
	                    do if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                        c[k >> 2] = (c[c[f >> 2] >> 2] | 0) - (c[(c[f >> 2] | 0) + 16 >> 2] | 0);
	                        c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0, (c[k >> 2] | 0) + (c[h >> 2] | 0) | 0) | 0;
	                        if (c[j >> 2] | 0) {
	                            c[(c[f >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                            c[c[f >> 2] >> 2] = (c[j >> 2] | 0) + (c[k >> 2] | 0);
	                            break
	                        }
	                        lz(c[f >> 2] | 0, 138968);
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else m = 22; while (0);
	                    do if ((m | 0) == 22) {
	                        c[j >> 2] = Hb[c[135760 >> 2] & 511](c[c[f >> 2] >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if (c[j >> 2] | 0) {
	                            c[c[f >> 2] >> 2] = c[j >> 2];
	                            break
	                        }
	                        lz(c[f >> 2] | 0, 138968);
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } while (0);
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[h >> 2];
	                    h = c[f >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) >>> 0 < 2147483647)c[(c[f >> 2] | 0) + 8 >> 2] = c[h + 24 >> 2]; else c[h + 8 >> 2] = 2147483647;
	                    h = c[f >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2147483647)c[(c[f >> 2] | 0) + 4 >> 2] = c[h + 20 >> 2]; else c[h + 4 >> 2] = 2147483647;
	                    c[e >> 2] = (c[(c[f >> 2] | 0) + 24 >> 2] | 0) - (c[(c[f >> 2] | 0) + 20 >> 2] | 0);
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function nz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                ce(29, 7e3, 0, 0, c[f >> 2] | 0);
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 32 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                c[(c[e >> 2] | 0) + 32 >> 2] = 7e3;
	                i = d;
	                return
	            }

	            function oz(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 40 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](92) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Qz(0, 139048);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 92 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                c[(c[k >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 4 >> 2] = 1;
	                c[(c[k >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 40 >> 2] = 0;
	                c[c[k >> 2] >> 2] = 0;
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0))c[(c[k >> 2] | 0) + 20 >> 2] = c[c[(c[g >> 2] | 0) + 8 >> 2] >> 2];
	                c[(c[k >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                c[(c[k >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                do if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) > 0) {
	                    j = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 20 >> 2] << 2 << 1) | 0;
	                    c[(c[k >> 2] | 0) + 44 >> 2] = j;
	                    if (c[(c[k >> 2] | 0) + 44 >> 2] | 0) {
	                        cU(c[(c[k >> 2] | 0) + 44 >> 2] | 0, 0, c[(c[g >> 2] | 0) + 20 >> 2] << 2 << 1 | 0) | 0;
	                        c[(c[k >> 2] | 0) + 84 >> 2] = (c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[g >> 2] | 0) + 20 >> 2] << 2);
	                        break
	                    }
	                    Qz(0, 139048);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[(c[k >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[k >> 2] | 0) + 84 >> 2] = 0
	                } while (0);
	                c[(c[k >> 2] | 0) + 48 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 52 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 72 >> 2] = -1;
	                c[(c[k >> 2] | 0) + 80 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 88 >> 2] = 0;
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function pz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0) {
	                    a:do if (c[(c[d >> 2] | 0) + 44 >> 2] | 0) {
	                        c[e >> 2] = 0;
	                        while (1) {
	                            if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 32 >> 2] | 0))break a;
	                            if (c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[e >> 2] << 4) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[e >> 2] << 4) + 12 >> 2] | 0);
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 68 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    while (1) {
	                        if ((c[f >> 2] | 0) >= (c[(c[d >> 2] | 0) + 52 >> 2] | 0))break;
	                        if (c[(c[(c[d >> 2] | 0) + 68 >> 2] | 0) + (c[f >> 2] << 3) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[d >> 2] | 0) + 68 >> 2] | 0) + (c[f >> 2] << 3) >> 2] | 0);
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 68 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 80 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 80 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function qz(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = Rz(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function rz(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 192 | 0;
	                h = g + 32 | 0;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 36 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                if (c[c[j >> 2] >> 2] | 0) {
	                    c[h >> 2] = c[c[j >> 2] >> 2];
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = qz(c[j >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                c[o >> 2] = ZT(c[l >> 2] | 0) | 0;
	                c[p >> 2] = ZT(c[k >> 2] | 0) | 0;
	                if (150 < ((c[o >> 2] | 0) + (c[p >> 2] | 0) + 2 | 0)) {
	                    c[r >> 2] = Cb[c[135752 >> 2] & 511]((c[o >> 2] | 0) + (c[p >> 2] | 0) + 2 | 0) | 0;
	                    if (!(c[r >> 2] | 0)) {
	                        c[c[j >> 2] >> 2] = -1;
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                } else c[r >> 2] = n;
	                eU(c[r >> 2] | 0, c[k >> 2] | 0, c[p >> 2] | 0) | 0;
	                a[(c[r >> 2] | 0) + (c[p >> 2] | 0) >> 0] = 124;
	                eU((c[r >> 2] | 0) + ((c[p >> 2] | 0) + 1) | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0;
	                a[(c[r >> 2] | 0) + ((c[o >> 2] | 0) + (c[p >> 2] | 0) + 1) >> 0] = 0;
	                p = c[j >> 2] | 0;
	                if (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] | 0)c[q >> 2] = Sz(p, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[r >> 2] | 0, c[m >> 2] | 0) | 0; else c[q >> 2] = Rz(p, c[r >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                if ((c[r >> 2] | 0) != (n | 0))zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                c[h >> 2] = c[q >> 2];
	                s = c[h >> 2] | 0;
	                i = g;
	                return s | 0
	            }

	            function sz(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                f = Tz(c[h >> 2] | 0, 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                i = g;
	                return f | 0
	            }

	            function tz(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    q = c[j >> 2] | 0;
	                    i = h;
	                    return q | 0
	                }
	                do if (c[l >> 2] | 0)if (c[c[k >> 2] >> 2] | 0) {
	                    c[c[l >> 2] >> 2] = c[(c[k >> 2] | 0) + 80 >> 2];
	                    break
	                } else {
	                    c[c[l >> 2] >> 2] = 0;
	                    break
	                } while (0);
	                c[j >> 2] = Tz(c[k >> 2] | 0, 1, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                q = c[j >> 2] | 0;
	                i = h;
	                return q | 0
	            }

	            function uz(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[h >> 2] = Uz(c[f >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[(c[h >> 2] | 0) + 20 >> 2] = 0;
	                f = Vz(c[h >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 24 >> 2] = f;
	                c[(c[h >> 2] | 0) + 16 >> 2] = f;
	                Wz(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0) | 0;
	                Xz(c[h >> 2] | 0, 1);
	                if (d[c[(c[h >> 2] | 0) + 4 >> 2] >> 0] | 0) {
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[h >> 2] | 0, 139080)
	                }
	                f = c[h >> 2] | 0;
	                if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                    Zz(f);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[(c[h >> 2] | 0) + 20 >> 2] = c[f + 24 >> 2];
	                c[c[(c[h >> 2] | 0) + 16 >> 2] >> 2] = 1;
	                c[c[(c[h >> 2] | 0) + 20 >> 2] >> 2] = 2;
	                _z(c[h >> 2] | 0);
	                f = c[h >> 2] | 0;
	                if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                    Zz(f);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else {
	                    c[g >> 2] = $z(f) | 0;
	                    Zz(c[h >> 2] | 0);
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function vz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = aA(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function wz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                if ((c[(c[e >> 2] | 0) + 28 >> 2] | 0) != -1) {
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 28 >> 2];
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[f >> 2] = xz() | 0;
	                if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if ((c[h >> 2] | 0) >= (c[(c[f >> 2] | 0) + 48 >> 2] | 0))break;
	                        bA(c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0);
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 52 >> 2] | 0)
	                }
	                c[(c[f >> 2] | 0) + 36 >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                c[(c[f >> 2] | 0) + 40 >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                c[(c[f >> 2] | 0) + 48 >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                c[(c[f >> 2] | 0) + 52 >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                c[(c[f >> 2] | 0) + 68 >> 2] = -1;
	                c[(c[f >> 2] | 0) + 76 >> 2] = c[(c[e >> 2] | 0) + 32 >> 2];
	                c[g >> 2] = cA(c[f >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 52 >> 2] = 0;
	                yz(c[f >> 2] | 0);
	                c[(c[e >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                c[d >> 2] = c[g >> 2];
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function xz() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0, g = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Uz(0) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                c[(c[d >> 2] | 0) + 20 >> 2] = 0;
	                f = Vz(c[d >> 2] | 0) | 0;
	                c[(c[d >> 2] | 0) + 24 >> 2] = f;
	                c[(c[d >> 2] | 0) + 16 >> 2] = f;
	                f = c[d >> 2] | 0;
	                if (!(c[(c[d >> 2] | 0) + 16 >> 2] | 0)) {
	                    yz(f);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                c[c[f + 16 >> 2] >> 2] = 1;
	                f = (Wz(c[d >> 2] | 0, c[(c[d >> 2] | 0) + 16 >> 2] | 0) | 0) < 0;
	                g = c[d >> 2] | 0;
	                if (f) {
	                    bA(c[g + 16 >> 2] | 0);
	                    yz(c[d >> 2] | 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    c[g + 76 >> 2] = 0;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function yz(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Zz(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function zz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 4 >> 2] | 0))break;
	                        bA(c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 12 >> 2] | 0))break;
	                        dA(c[(c[(c[d >> 2] | 0) + 16 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        f = c[33934] | 0;
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                        zb[f & 511](c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[f & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Az(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = (c[e >> 2] | 0) + 76 | 0;
	                c[b >> 2] = c[b >> 2] | c[f >> 2];
	                i = d;
	                return
	            }

	            function Bz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0))c[d >> 2] = 0; else c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Cz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[c[g >> 2] >> 2] = 2;
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function Dz(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[o >> 2] = eA(c[j >> 2] | 0, 5) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[(c[o >> 2] | 0) + 60 >> 2] = c[n >> 2];
	                n = my(c[m >> 2] | 0) | 0;
	                c[(c[o >> 2] | 0) + 20 >> 2] = n;
	                if ((fA(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0) < 0) {
	                    dA(c[o >> 2] | 0);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } else {
	                    c[h >> 2] = c[l >> 2];
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                return 0
	            }

	            function Ez(b, e, f, g, h, j) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                k = i;
	                i = i + 48 | 0;
	                l = k + 40 | 0;
	                m = k + 36 | 0;
	                n = k + 32 | 0;
	                o = k + 28 | 0;
	                p = k + 24 | 0;
	                q = k + 20 | 0;
	                r = k + 16 | 0;
	                s = k + 12 | 0;
	                t = k + 8 | 0;
	                u = k + 4 | 0;
	                v = k;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = j;
	                if ((c[m >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                    c[l >> 2] = 0;
	                    w = c[l >> 2] | 0;
	                    i = k;
	                    return w | 0
	                }
	                c[s >> 2] = eA(c[m >> 2] | 0, 5) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    c[l >> 2] = 0;
	                    w = c[l >> 2] | 0;
	                    i = k;
	                    return w | 0
	                }
	                c[(c[s >> 2] | 0) + 60 >> 2] = c[r >> 2];
	                do if ((c[q >> 2] | 0) != 0 ? (d[c[q >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                    c[t >> 2] = ZT(c[q >> 2] | 0) | 0;
	                    c[u >> 2] = ZT(c[p >> 2] | 0) | 0;
	                    c[v >> 2] = Cb[c[135752 >> 2] & 511]((c[t >> 2] | 0) + (c[u >> 2] | 0) + 2 | 0) | 0;
	                    if (c[v >> 2] | 0) {
	                        eU(c[v >> 2] | 0, c[p >> 2] | 0, c[u >> 2] | 0) | 0;
	                        a[(c[v >> 2] | 0) + (c[u >> 2] | 0) >> 0] = 124;
	                        eU((c[v >> 2] | 0) + ((c[u >> 2] | 0) + 1) | 0, c[q >> 2] | 0, c[t >> 2] | 0) | 0;
	                        a[(c[v >> 2] | 0) + ((c[t >> 2] | 0) + (c[u >> 2] | 0) + 1) >> 0] = 0;
	                        c[(c[s >> 2] | 0) + 20 >> 2] = c[v >> 2];
	                        break
	                    }
	                    dA(c[s >> 2] | 0);
	                    c[l >> 2] = 0;
	                    w = c[l >> 2] | 0;
	                    i = k;
	                    return w | 0
	                } else x = 7; while (0);
	                if ((x | 0) == 7) {
	                    x = my(c[p >> 2] | 0) | 0;
	                    c[(c[s >> 2] | 0) + 20 >> 2] = x
	                }
	                if ((fA(c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[s >> 2] | 0) | 0) < 0) {
	                    dA(c[s >> 2] | 0);
	                    c[l >> 2] = 0;
	                    w = c[l >> 2] | 0;
	                    i = k;
	                    return w | 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    c[l >> 2] = c[(c[m >> 2] | 0) + 24 >> 2];
	                    w = c[l >> 2] | 0;
	                    i = k;
	                    return w | 0
	                } else {
	                    c[l >> 2] = c[o >> 2];
	                    w = c[l >> 2] | 0;
	                    i = k;
	                    return w | 0
	                }
	                return 0
	            }

	            function Fz(b, e, f, g, h, j) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                k = i;
	                i = i + 256 | 0;
	                l = k;
	                m = k + 44 | 0;
	                n = k + 40 | 0;
	                o = k + 36 | 0;
	                p = k + 32 | 0;
	                q = k + 28 | 0;
	                r = k + 24 | 0;
	                s = k + 20 | 0;
	                t = k + 16 | 0;
	                u = k + 48 | 0;
	                v = k + 12 | 0;
	                w = k + 8 | 0;
	                x = k + 4 | 0;
	                c[n >> 2] = b;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = j;
	                if ((c[n >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0 | (c[q >> 2] | 0) == 0) {
	                    c[m >> 2] = 0;
	                    y = c[m >> 2] | 0;
	                    i = k;
	                    return y | 0
	                }
	                c[t >> 2] = eA(c[n >> 2] | 0, 5) | 0;
	                if (!(c[t >> 2] | 0)) {
	                    c[m >> 2] = 0;
	                    y = c[m >> 2] | 0;
	                    i = k;
	                    return y | 0
	                }
	                c[(c[t >> 2] | 0) + 60 >> 2] = c[s >> 2];
	                c[(c[t >> 2] | 0) + 28 >> 2] = 1;
	                do if ((c[r >> 2] | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                    c[v >> 2] = ZT(c[r >> 2] | 0) | 0;
	                    c[w >> 2] = ZT(c[q >> 2] | 0) | 0;
	                    c[x >> 2] = Cb[c[135752 >> 2] & 511]((c[v >> 2] | 0) + (c[w >> 2] | 0) + 2 | 0) | 0;
	                    if (c[x >> 2] | 0) {
	                        eU(c[x >> 2] | 0, c[q >> 2] | 0, c[w >> 2] | 0) | 0;
	                        a[(c[x >> 2] | 0) + (c[w >> 2] | 0) >> 0] = 124;
	                        eU((c[x >> 2] | 0) + ((c[w >> 2] | 0) + 1) | 0, c[r >> 2] | 0, c[v >> 2] | 0) | 0;
	                        a[(c[x >> 2] | 0) + ((c[v >> 2] | 0) + (c[w >> 2] | 0) + 1) >> 0] = 0;
	                        c[(c[t >> 2] | 0) + 20 >> 2] = c[x >> 2];
	                        break
	                    }
	                    dA(c[t >> 2] | 0);
	                    c[m >> 2] = 0;
	                    y = c[m >> 2] | 0;
	                    i = k;
	                    return y | 0
	                } else z = 7; while (0);
	                if ((z | 0) == 7) {
	                    z = my(c[q >> 2] | 0) | 0;
	                    c[(c[t >> 2] | 0) + 20 >> 2] = z
	                }
	                c[l >> 2] = c[(c[t >> 2] | 0) + 20 >> 2];
	                JT(u, 199, 139120, l) | 0;
	                a[u + 199 >> 0] = 0;
	                l = my(u) | 0;
	                c[(c[t >> 2] | 0) + 24 >> 2] = l;
	                if ((fA(c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[t >> 2] | 0) | 0) < 0) {
	                    dA(c[t >> 2] | 0);
	                    c[m >> 2] = 0;
	                    y = c[m >> 2] | 0;
	                    i = k;
	                    return y | 0
	                }
	                t = (c[n >> 2] | 0) + 72 | 0;
	                c[t >> 2] = (c[t >> 2] | 0) + 1;
	                if (!(c[p >> 2] | 0)) {
	                    c[m >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                    y = c[m >> 2] | 0;
	                    i = k;
	                    return y | 0
	                } else {
	                    c[m >> 2] = c[p >> 2];
	                    y = c[m >> 2] | 0;
	                    i = k;
	                    return y | 0
	                }
	                return 0
	            }

	            function Gz(b, e, f, g, h, j, k, l) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                m = i;
	                i = i + 64 | 0;
	                n = m + 52 | 0;
	                o = m + 48 | 0;
	                p = m + 44 | 0;
	                q = m + 40 | 0;
	                r = m + 36 | 0;
	                s = m + 32 | 0;
	                t = m + 28 | 0;
	                u = m + 24 | 0;
	                v = m + 20 | 0;
	                w = m + 16 | 0;
	                x = m + 12 | 0;
	                y = m + 8 | 0;
	                z = m + 4 | 0;
	                A = m;
	                c[o >> 2] = b;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = l;
	                if ((c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0 | (c[r >> 2] | 0) == 0) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                if ((c[t >> 2] | 0) < 0) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                if ((c[u >> 2] | 0) < 1 ? 1 : (c[u >> 2] | 0) < (c[t >> 2] | 0)) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                c[w >> 2] = eA(c[o >> 2] | 0, 5) | 0;
	                if (!(c[w >> 2] | 0)) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                do if ((c[s >> 2] | 0) != 0 ? (d[c[s >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                    c[y >> 2] = ZT(c[s >> 2] | 0) | 0;
	                    c[z >> 2] = ZT(c[r >> 2] | 0) | 0;
	                    c[A >> 2] = Cb[c[135752 >> 2] & 511]((c[y >> 2] | 0) + (c[z >> 2] | 0) + 2 | 0) | 0;
	                    if (c[A >> 2] | 0) {
	                        eU(c[A >> 2] | 0, c[r >> 2] | 0, c[z >> 2] | 0) | 0;
	                        a[(c[A >> 2] | 0) + (c[z >> 2] | 0) >> 0] = 124;
	                        eU((c[A >> 2] | 0) + ((c[z >> 2] | 0) + 1) | 0, c[s >> 2] | 0, c[y >> 2] | 0) | 0;
	                        a[(c[A >> 2] | 0) + ((c[y >> 2] | 0) + (c[z >> 2] | 0) + 1) >> 0] = 0;
	                        c[(c[w >> 2] | 0) + 20 >> 2] = c[A >> 2];
	                        break
	                    }
	                    dA(c[w >> 2] | 0);
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                } else C = 11; while (0);
	                if ((C | 0) == 11) {
	                    C = my(c[r >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 20 >> 2] = C
	                }
	                c[(c[w >> 2] | 0) + 60 >> 2] = c[v >> 2];
	                if (!(c[t >> 2] | 0))c[(c[w >> 2] | 0) + 12 >> 2] = 1; else c[(c[w >> 2] | 0) + 12 >> 2] = c[t >> 2];
	                c[(c[w >> 2] | 0) + 16 >> 2] = c[u >> 2];
	                c[x >> 2] = gA(c[o >> 2] | 0) | 0;
	                c[(c[(c[o >> 2] | 0) + 64 >> 2] | 0) + (c[x >> 2] << 3) >> 2] = c[t >> 2];
	                c[(c[(c[o >> 2] | 0) + 64 >> 2] | 0) + (c[x >> 2] << 3) + 4 >> 2] = c[u >> 2];
	                if (!(c[q >> 2] | 0)) {
	                    c[q >> 2] = Vz(c[o >> 2] | 0) | 0;
	                    Wz(c[o >> 2] | 0, c[q >> 2] | 0) | 0
	                }
	                hA(c[o >> 2] | 0, c[p >> 2] | 0, c[w >> 2] | 0, c[q >> 2] | 0, c[x >> 2] | 0, -1);
	                iA(c[o >> 2] | 0, c[w >> 2] | 0) | 0;
	                c[(c[o >> 2] | 0) + 24 >> 2] = c[q >> 2];
	                if (!(c[q >> 2] | 0))c[q >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                if (!(c[q >> 2] | 0)) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                if (!(c[t >> 2] | 0))jA(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0);
	                c[n >> 2] = c[q >> 2];
	                B = c[n >> 2] | 0;
	                i = m;
	                return B | 0
	            }

	            function Hz(b, e, f, g, h, j, k, l) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                m = i;
	                i = i + 64 | 0;
	                n = m + 52 | 0;
	                o = m + 48 | 0;
	                p = m + 44 | 0;
	                q = m + 40 | 0;
	                r = m + 36 | 0;
	                s = m + 32 | 0;
	                t = m + 28 | 0;
	                u = m + 24 | 0;
	                v = m + 20 | 0;
	                w = m + 16 | 0;
	                x = m + 12 | 0;
	                y = m + 8 | 0;
	                z = m + 4 | 0;
	                A = m;
	                c[o >> 2] = b;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = l;
	                if ((c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0 | (c[r >> 2] | 0) == 0) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                if ((c[t >> 2] | 0) < 1) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                if ((c[u >> 2] | 0) < 1 ? 1 : (c[u >> 2] | 0) < (c[t >> 2] | 0)) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                c[w >> 2] = eA(c[o >> 2] | 0, 5) | 0;
	                if (!(c[w >> 2] | 0)) {
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                }
	                do if ((c[s >> 2] | 0) != 0 ? (d[c[s >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                    c[y >> 2] = ZT(c[s >> 2] | 0) | 0;
	                    c[z >> 2] = ZT(c[r >> 2] | 0) | 0;
	                    c[A >> 2] = Cb[c[135752 >> 2] & 511]((c[y >> 2] | 0) + (c[z >> 2] | 0) + 2 | 0) | 0;
	                    if (c[A >> 2] | 0) {
	                        eU(c[A >> 2] | 0, c[r >> 2] | 0, c[z >> 2] | 0) | 0;
	                        a[(c[A >> 2] | 0) + (c[z >> 2] | 0) >> 0] = 124;
	                        eU((c[A >> 2] | 0) + ((c[z >> 2] | 0) + 1) | 0, c[s >> 2] | 0, c[y >> 2] | 0) | 0;
	                        a[(c[A >> 2] | 0) + ((c[y >> 2] | 0) + (c[z >> 2] | 0) + 1) >> 0] = 0;
	                        c[(c[w >> 2] | 0) + 20 >> 2] = c[A >> 2];
	                        break
	                    }
	                    dA(c[w >> 2] | 0);
	                    c[n >> 2] = 0;
	                    B = c[n >> 2] | 0;
	                    i = m;
	                    return B | 0
	                } else C = 11; while (0);
	                if ((C | 0) == 11) {
	                    C = my(c[r >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 20 >> 2] = C
	                }
	                c[(c[w >> 2] | 0) + 60 >> 2] = c[v >> 2];
	                c[(c[w >> 2] | 0) + 8 >> 2] = 6;
	                c[(c[w >> 2] | 0) + 12 >> 2] = c[t >> 2];
	                c[(c[w >> 2] | 0) + 16 >> 2] = c[u >> 2];
	                c[x >> 2] = gA(c[o >> 2] | 0) | 0;
	                c[(c[(c[o >> 2] | 0) + 64 >> 2] | 0) + (c[x >> 2] << 3) >> 2] = 1;
	                c[(c[(c[o >> 2] | 0) + 64 >> 2] | 0) + (c[x >> 2] << 3) + 4 >> 2] = 1;
	                if (!(c[q >> 2] | 0)) {
	                    c[q >> 2] = Vz(c[o >> 2] | 0) | 0;
	                    Wz(c[o >> 2] | 0, c[q >> 2] | 0) | 0
	                }
	                hA(c[o >> 2] | 0, c[p >> 2] | 0, c[w >> 2] | 0, c[q >> 2] | 0, c[x >> 2] | 0, -1);
	                iA(c[o >> 2] | 0, c[w >> 2] | 0) | 0;
	                c[(c[o >> 2] | 0) + 24 >> 2] = c[q >> 2];
	                c[n >> 2] = c[q >> 2];
	                B = c[n >> 2] | 0;
	                i = m;
	                return B | 0
	            }

	            function Iz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[f >> 2] = Vz(c[e >> 2] | 0) | 0;
	                    Wz(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Jz(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                jA(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0);
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function Kz(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                kA(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function Lz(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = gA(c[g >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) < 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + (c[k >> 2] << 3) >> 2] = c[h >> 2];
	                    c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + (c[k >> 2] << 3) + 4 >> 2] = c[j >> 2];
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Mz(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[l >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                lA(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function Nz(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[l >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                mA(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function Oz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                    _z(c[e >> 2] | 0);
	                    c[f >> 2] = $z(c[e >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Pz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[f >> 2] = cA(c[e >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Qz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (c[f >> 2] | 0) {
	                    c[h >> 2] = c[c[f >> 2] >> 2];
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 2
	                }
	                f = c[g >> 2] | 0;
	                b = c[h >> 2] | 0;
	                c[e >> 2] = c[g >> 2];
	                Xd(0, 0, 0, 0, 0, 14, 2, 3, 0, 0, f, b, 0, 0, 0, 140264, e);
	                i = d;
	                return
	            }

	            function Rz(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0;
	                f = i;
	                i = i + 112 | 0;
	                g = f;
	                h = f + 100 | 0;
	                j = f + 96 | 0;
	                k = f + 92 | 0;
	                l = f + 88 | 0;
	                m = f + 84 | 0;
	                n = f + 80 | 0;
	                p = f + 76 | 0;
	                q = f + 72 | 0;
	                r = f + 68 | 0;
	                s = f + 64 | 0;
	                t = f + 60 | 0;
	                u = f + 56 | 0;
	                v = f + 52 | 0;
	                w = f + 48 | 0;
	                x = f + 44 | 0;
	                y = f + 40 | 0;
	                z = f + 36 | 0;
	                A = f + 32 | 0;
	                B = f + 28 | 0;
	                C = f + 24 | 0;
	                D = f + 20 | 0;
	                E = f + 16 | 0;
	                F = f + 12 | 0;
	                G = f + 8 | 0;
	                H = f + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[r >> 2] = 0;
	                c[s >> 2] = 1;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                }
	                if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                }
	                e = c[j >> 2] | 0;
	                if (c[c[j >> 2] >> 2] | 0) {
	                    c[h >> 2] = c[e >> 2];
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                }
	                if (c[(c[e + 8 >> 2] | 0) + 40 >> 2] | 0) {
	                    c[h >> 2] = Sz(c[j >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                }
	                do if (!(c[k >> 2] | 0)) {
	                    if ((c[c[(c[j >> 2] | 0) + 20 >> 2] >> 2] | 0) != 2) {
	                        c[r >> 2] = 1;
	                        break
	                    }
	                    c[h >> 2] = 1;
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                } while (0);
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 52 >> 2] | 0) > 0 : 0) {
	                    nA(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                    c[k >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) >> 2];
	                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) + 4 >> 2]
	                }
	                a:while (1) {
	                    if (c[c[j >> 2] >> 2] | 0)break;
	                    if (!(c[k >> 2] | 0)) {
	                        if ((c[r >> 2] | 0) != 1)break;
	                        if ((c[c[(c[j >> 2] | 0) + 20 >> 2] >> 2] | 0) == 2)break
	                    }
	                    if (!((c[k >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) == 0 : 0))J = 22;
	                    b:do if ((J | 0) == 22) {
	                        J = 0;
	                        c[(c[j >> 2] | 0) + 28 >> 2] = 0;
	                        c:while (1) {
	                            if ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) >= (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0))break;
	                            c[n >> 2] = (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) * 20 | 0);
	                            if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) >= 0) {
	                                c[p >> 2] = c[c[n >> 2] >> 2];
	                                c[q >> 2] = 0;
	                                d:do if ((c[(c[n >> 2] | 0) + 12 >> 2] | 0) == 1193047) {
	                                    c[q >> 2] = 0;
	                                    if ((c[k >> 2] | 0) == 0 & (c[r >> 2] | 0) != 0) {
	                                        c[q >> 2] = 1;
	                                        break
	                                    }
	                                    if (c[k >> 2] | 0) {
	                                        c[t >> 2] = 0;
	                                        e:while (1) {
	                                            if ((c[t >> 2] | 0) >= (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0))break d;
	                                            c[v >> 2] = (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 28 >> 2] | 0) + ((c[t >> 2] | 0) * 20 | 0);
	                                            do if ((c[(c[v >> 2] | 0) + 8 >> 2] | 0) >= 0) {
	                                                if ((c[v >> 2] | 0) == (c[n >> 2] | 0))break;
	                                                c[w >> 2] = (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[v >> 2] | 0) + 8 >> 2] << 3);
	                                                c[u >> 2] = c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (c[(c[v >> 2] | 0) + 8 >> 2] << 2) >> 2];
	                                                do if ((c[u >> 2] | 0) < (c[(c[w >> 2] | 0) + 4 >> 2] | 0)) {
	                                                    if (!(c[c[v >> 2] >> 2] | 0))break;
	                                                    if (qy(c[k >> 2] | 0, c[(c[c[v >> 2] >> 2] | 0) + 20 >> 2] | 0) | 0) {
	                                                        J = 36;
	                                                        break e
	                                                    }
	                                                } while (0);
	                                                if ((c[u >> 2] | 0) < (c[c[w >> 2] >> 2] | 0))break;
	                                                if ((c[u >> 2] | 0) >= (c[(c[w >> 2] | 0) + 4 >> 2] | 0))break;
	                                                if (!(c[c[v >> 2] >> 2] | 0))break;
	                                                if (qy(c[k >> 2] | 0, c[(c[c[v >> 2] >> 2] | 0) + 20 >> 2] | 0) | 0) {
	                                                    J = 41;
	                                                    break e
	                                                }
	                                            } while (0);
	                                            c[t >> 2] = (c[t >> 2] | 0) + 1
	                                        }
	                                        if ((J | 0) == 36) {
	                                            J = 0;
	                                            c[q >> 2] = 0;
	                                            break
	                                        } else if ((J | 0) == 41) {
	                                            J = 0;
	                                            c[q >> 2] = 1;
	                                            break
	                                        }
	                                    }
	                                } else {
	                                    if ((c[(c[n >> 2] | 0) + 12 >> 2] | 0) == 1193046) {
	                                        c[q >> 2] = 1;
	                                        c[x >> 2] = 0;
	                                        f:while (1) {
	                                            if ((c[x >> 2] | 0) >= (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0))break d;
	                                            c[z >> 2] = (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 28 >> 2] | 0) + ((c[x >> 2] | 0) * 20 | 0);
	                                            do if ((c[(c[z >> 2] | 0) + 8 >> 2] | 0) >= 0) {
	                                                if ((c[z >> 2] | 0) == (c[n >> 2] | 0))break;
	                                                c[A >> 2] = (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[z >> 2] | 0) + 8 >> 2] << 3);
	                                                c[y >> 2] = c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (c[(c[z >> 2] | 0) + 8 >> 2] << 2) >> 2];
	                                                if ((c[y >> 2] | 0) < (c[c[A >> 2] >> 2] | 0))break f;
	                                                if ((c[y >> 2] | 0) > (c[(c[A >> 2] | 0) + 4 >> 2] | 0))break f
	                                            } while (0);
	                                            c[x >> 2] = (c[x >> 2] | 0) + 1
	                                        }
	                                        c[q >> 2] = 0;
	                                        break
	                                    }
	                                    if ((c[(c[n >> 2] | 0) + 12 >> 2] | 0) >= 0) {
	                                        c[B >> 2] = c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (c[(c[n >> 2] | 0) + 12 >> 2] << 2) >> 2];
	                                        c[C >> 2] = (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[n >> 2] | 0) + 12 >> 2] << 3);
	                                        if ((c[B >> 2] | 0) >= (c[c[C >> 2] >> 2] | 0))K = (c[B >> 2] | 0) <= (c[(c[C >> 2] | 0) + 4 >> 2] | 0); else K = 0;
	                                        c[q >> 2] = K & 1;
	                                        break
	                                    }
	                                    if (!(c[p >> 2] | 0)) {
	                                        J = 57;
	                                        break c
	                                    }
	                                    if (!(c[k >> 2] | 0))break;
	                                    c[q >> 2] = oA(c[(c[p >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] | 0) | 0;
	                                    if (c[(c[p >> 2] | 0) + 28 >> 2] | 0) {
	                                        e = ((c[q >> 2] | 0) != 0 ^ 1) & 1;
	                                        c[q >> 2] = e;
	                                        c[q >> 2] = (c[m >> 2] | 0) != 0 ? e : 0
	                                    }
	                                    do if ((c[q >> 2] | 0) == 1) {
	                                        if ((c[(c[n >> 2] | 0) + 8 >> 2] | 0) < 0)break;
	                                        c[E >> 2] = c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (c[(c[n >> 2] | 0) + 8 >> 2] << 2) >> 2];
	                                        c[D >> 2] = (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[n >> 2] | 0) + 8 >> 2] << 3);
	                                        if ((c[E >> 2] | 0) < (c[(c[D >> 2] | 0) + 4 >> 2] | 0))break;
	                                        c[q >> 2] = 0
	                                    } while (0);
	                                    if ((c[q >> 2] | 0) != 1)break;
	                                    if ((c[(c[p >> 2] | 0) + 12 >> 2] | 0) <= 0)break;
	                                    if ((c[(c[p >> 2] | 0) + 16 >> 2] | 0) <= 0)break;
	                                    c[F >> 2] = c[(c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[n >> 2] | 0) + 4 >> 2] << 2) >> 2];
	                                    if ((c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0) > ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 1 | 0)) {
	                                        if ((c[(c[j >> 2] | 0) + 52 >> 2] | 0) <= 0)nA(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                                        pA(c[j >> 2] | 0)
	                                    }
	                                    c[(c[j >> 2] | 0) + 28 >> 2] = 1;
	                                    do {
	                                        if ((c[(c[j >> 2] | 0) + 28 >> 2] | 0) == (c[(c[p >> 2] | 0) + 16 >> 2] | 0))break;
	                                        e = (c[j >> 2] | 0) + 56 | 0;
	                                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                        c[k >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) >> 2];
	                                        c[l >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) + 4 >> 2];
	                                        L = c[j >> 2] | 0;
	                                        if (!(c[k >> 2] | 0)) {
	                                            J = 75;
	                                            break
	                                        }
	                                        if ((c[L + 28 >> 2] | 0) >= (c[(c[p >> 2] | 0) + 12 >> 2] | 0)) {
	                                            c[G >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                                            c[H >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                            c[(c[j >> 2] | 0) + 24 >> 2] = -1;
	                                            c[(c[j >> 2] | 0) + 20 >> 2] = c[F >> 2];
	                                            if ((c[(c[j >> 2] | 0) + 52 >> 2] | 0) <= 0)nA(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                                            pA(c[j >> 2] | 0);
	                                            c[(c[j >> 2] | 0) + 24 >> 2] = c[G >> 2];
	                                            c[(c[j >> 2] | 0) + 20 >> 2] = c[H >> 2]
	                                        }
	                                        c[q >> 2] = qy(c[k >> 2] | 0, c[(c[p >> 2] | 0) + 20 >> 2] | 0) | 0;
	                                        e = (c[j >> 2] | 0) + 28 | 0;
	                                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                                    } while ((c[q >> 2] | 0) == 1);
	                                    if ((J | 0) == 75) {
	                                        J = 0;
	                                        e = L + 56 | 0;
	                                        c[e >> 2] = (c[e >> 2] | 0) + -1
	                                    }
	                                    if ((c[(c[j >> 2] | 0) + 28 >> 2] | 0) < (c[(c[p >> 2] | 0) + 12 >> 2] | 0))c[q >> 2] = 0;
	                                    if ((c[q >> 2] | 0) < 0)c[q >> 2] = 0;
	                                    if (!(c[q >> 2] | 0))break b
	                                } while (0);
	                                if ((c[q >> 2] | 0) == 1) {
	                                    J = 87;
	                                    break
	                                }
	                                if ((c[q >> 2] | 0) < 0) {
	                                    J = 110;
	                                    break
	                                }
	                            }
	                            e = (c[j >> 2] | 0) + 24 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        }
	                        if ((J | 0) == 57) {
	                            J = 0;
	                            Ka(c[o >> 2] | 0, 139424, g | 0) | 0;
	                            c[c[j >> 2] >> 2] = -2
	                        } else if ((J | 0) == 87) {
	                            J = 0;
	                            if (((c[p >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) & (c[l >> 2] | 0) != 0)Jb[c[(c[j >> 2] | 0) + 12 >> 2] & 511](c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[(c[p >> 2] | 0) + 20 >> 2] | 0, c[(c[p >> 2] | 0) + 60 >> 2] | 0, c[l >> 2] | 0);
	                            if ((c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0) > ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 1 | 0)) {
	                                if ((c[(c[j >> 2] | 0) + 52 >> 2] | 0) <= 0)nA(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                                pA(c[j >> 2] | 0)
	                            }
	                            if ((c[(c[n >> 2] | 0) + 8 >> 2] | 0) >= 0) {
	                                e = (c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (c[(c[n >> 2] | 0) + 8 >> 2] << 2) | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1
	                            }
	                            if ((c[(c[n >> 2] | 0) + 12 >> 2] | 0) >= 0 ? (c[(c[n >> 2] | 0) + 12 >> 2] | 0) < 1193046 : 0)c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (c[(c[n >> 2] | 0) + 12 >> 2] << 2) >> 2] = 0;
	                            if ((c[(c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[n >> 2] | 0) + 4 >> 2] << 2) >> 2] | 0) != 0 ? (c[c[(c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[n >> 2] | 0) + 4 >> 2] << 2) >> 2] >> 2] | 0) == 4 : 0) {
	                                if (c[(c[j >> 2] | 0) + 80 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[j >> 2] | 0) + 80 >> 2] | 0);
	                                e = my(c[k >> 2] | 0) | 0;
	                                c[(c[j >> 2] | 0) + 80 >> 2] = e;
	                                c[(c[j >> 2] | 0) + 76 >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                eU(c[(c[j >> 2] | 0) + 84 >> 2] | 0, c[(c[j >> 2] | 0) + 44 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] << 2 | 0) | 0
	                            }
	                            c[(c[j >> 2] | 0) + 20 >> 2] = c[(c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[n >> 2] | 0) + 4 >> 2] << 2) >> 2];
	                            c[(c[j >> 2] | 0) + 24 >> 2] = 0;
	                            do if (c[c[n >> 2] >> 2] | 0) {
	                                if (!(c[(c[j >> 2] | 0) + 68 >> 2] | 0)) {
	                                    c[k >> 2] = 0;
	                                    c[l >> 2] = 0;
	                                    break
	                                }
	                                e = (c[j >> 2] | 0) + 56 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                if ((c[(c[j >> 2] | 0) + 56 >> 2] | 0) < (c[(c[j >> 2] | 0) + 52 >> 2] | 0)) {
	                                    c[k >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) >> 2];
	                                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) + 4 >> 2];
	                                    break
	                                } else {
	                                    c[k >> 2] = 0;
	                                    c[l >> 2] = 0;
	                                    break
	                                }
	                            } while (0);
	                            c[s >> 2] = 1;
	                            continue a
	                        } else if ((J | 0) == 110) {
	                            J = 0;
	                            c[c[j >> 2] >> 2] = -4
	                        }
	                        if ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) == 0 ? (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)continue a
	                    } while (0);
	                    if (((c[s >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[c[(c[j >> 2] | 0) + 20 >> 2] >> 2] | 0) != 4 : 0) {
	                        c[s >> 2] = 0;
	                        if (c[(c[j >> 2] | 0) + 80 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[j >> 2] | 0) + 80 >> 2] | 0);
	                        e = my(c[k >> 2] | 0) | 0;
	                        c[(c[j >> 2] | 0) + 80 >> 2] = e;
	                        c[(c[j >> 2] | 0) + 76 >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                        eU(c[(c[j >> 2] | 0) + 84 >> 2] | 0, c[(c[j >> 2] | 0) + 44 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] << 2 | 0) | 0
	                    }
	                    c[(c[j >> 2] | 0) + 4 >> 2] = 0;
	                    qA(c[j >> 2] | 0);
	                    if (!(c[(c[j >> 2] | 0) + 68 >> 2] | 0))continue;
	                    if (c[c[j >> 2] >> 2] | 0)continue;
	                    c[k >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) >> 2];
	                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 68 >> 2] | 0) + (c[(c[j >> 2] | 0) + 56 >> 2] << 3) + 4 >> 2]
	                }
	                l = c[j >> 2] | 0;
	                if (!(c[c[j >> 2] >> 2] | 0)) {
	                    c[h >> 2] = (c[c[l + 20 >> 2] >> 2] | 0) == 2 & 1;
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                } else {
	                    c[h >> 2] = c[l >> 2];
	                    I = c[h >> 2] | 0;
	                    i = f;
	                    return I | 0
	                }
	                return 0
	            }

	            function Sz(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = c[(c[h >> 2] | 0) + 56 >> 2];
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                    if (!(c[k >> 2] | 0)) {
	                        e = ca(c[m >> 2] | 0, (c[(c[j >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                        if ((c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + (e << 2) >> 2] | 0) == 2) {
	                            c[g >> 2] = 1;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        } else {
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                    }
	                    c[n >> 2] = 0;
	                    while (1) {
	                        if ((c[n >> 2] | 0) >= (c[(c[j >> 2] | 0) + 48 >> 2] | 0))break;
	                        e = ca(c[m >> 2] | 0, (c[(c[j >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                        c[o >> 2] = c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + (e + (c[n >> 2] | 0) + 1 << 2) >> 2];
	                        if (((c[o >> 2] | 0) > 0 ? (c[o >> 2] | 0) <= (c[(c[j >> 2] | 0) + 36 >> 2] | 0) : 0) ? (c[o >> 2] = (c[o >> 2] | 0) + -1, (oA(c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0, c[k >> 2] | 0) | 0) != 0) : 0) {
	                            q = 14;
	                            break
	                        }
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    if ((q | 0) == 14) {
	                        c[(c[h >> 2] | 0) + 56 >> 2] = c[o >> 2];
	                        if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                            q = ca(c[m >> 2] | 0, c[(c[j >> 2] | 0) + 48 >> 2] | 0) | 0;
	                            Jb[c[(c[h >> 2] | 0) + 12 >> 2] & 511](c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0, c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + (q + (c[n >> 2] | 0) << 2) >> 2] | 0, c[l >> 2] | 0)
	                        }
	                        l = ca(c[o >> 2] | 0, (c[(c[j >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                        if ((c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + (l << 2) >> 2] | 0) != 4) {
	                            l = ca(c[o >> 2] | 0, (c[(c[j >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                            if ((c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + (l << 2) >> 2] | 0) == 2) {
	                                c[g >> 2] = 1;
	                                p = c[g >> 2] | 0;
	                                i = f;
	                                return p | 0
	                            } else {
	                                c[g >> 2] = 0;
	                                p = c[g >> 2] | 0;
	                                i = f;
	                                return p | 0
	                            }
	                        }
	                    }
	                    if (c[(c[h >> 2] | 0) + 80 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 80 >> 2] | 0);
	                    l = my(c[k >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 80 >> 2] = l;
	                    c[(c[h >> 2] | 0) + 72 >> 2] = c[m >> 2];
	                    c[c[h >> 2] >> 2] = -1;
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[g >> 2] = -1;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function Tz(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
	                h = i;
	                i = i + 96 | 0;
	                j = h;
	                k = h + 80 | 0;
	                l = h + 76 | 0;
	                m = h + 72 | 0;
	                n = h + 68 | 0;
	                o = h + 64 | 0;
	                p = h + 60 | 0;
	                q = h + 56 | 0;
	                r = h + 52 | 0;
	                s = h + 48 | 0;
	                t = h + 44 | 0;
	                u = h + 40 | 0;
	                v = h + 36 | 0;
	                w = h + 32 | 0;
	                x = h + 28 | 0;
	                y = h + 24 | 0;
	                z = h + 20 | 0;
	                A = h + 16 | 0;
	                B = h + 12 | 0;
	                C = h + 8 | 0;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[s >> 2] = 0;
	                if (!((c[l >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) ? (c[c[n >> 2] >> 2] | 0) > 0 : 0) {
	                    c[r >> 2] = c[c[n >> 2] >> 2];
	                    c[c[n >> 2] >> 2] = 0;
	                    c[c[o >> 2] >> 2] = 0;
	                    a:do if ((c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                        c[t >> 2] = c[(c[l >> 2] | 0) + 8 >> 2];
	                        g = c[l >> 2] | 0;
	                        do if (c[m >> 2] | 0) {
	                            if ((c[g + 72 >> 2] | 0) != -1) {
	                                c[w >> 2] = c[(c[l >> 2] | 0) + 72 >> 2];
	                                break
	                            }
	                            c[k >> 2] = -1;
	                            D = c[k >> 2] | 0;
	                            i = h;
	                            return D | 0
	                        } else c[w >> 2] = c[g + 56 >> 2]; while (0);
	                        do if (c[q >> 2] | 0) {
	                            g = ca(c[w >> 2] | 0, (c[(c[t >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                            f = c[q >> 2] | 0;
	                            if ((c[(c[(c[t >> 2] | 0) + 40 >> 2] | 0) + (g << 2) >> 2] | 0) == 2) {
	                                c[f >> 2] = 1;
	                                break
	                            } else {
	                                c[f >> 2] = 0;
	                                break
	                            }
	                        } while (0);
	                        c[v >> 2] = 0;
	                        while (1) {
	                            if ((c[v >> 2] | 0) >= (c[(c[t >> 2] | 0) + 48 >> 2] | 0))break;
	                            if ((c[s >> 2] | 0) >= (c[r >> 2] | 0))break;
	                            f = ca(c[w >> 2] | 0, (c[(c[t >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                            c[u >> 2] = c[(c[(c[t >> 2] | 0) + 40 >> 2] | 0) + (f + (c[v >> 2] | 0) + 1 << 2) >> 2];
	                            if (((c[u >> 2] | 0) > 0 ? (c[u >> 2] | 0) <= (c[(c[t >> 2] | 0) + 36 >> 2] | 0) : 0) ? (f = ca((c[u >> 2] | 0) - 1 | 0, (c[(c[t >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0, (c[(c[(c[t >> 2] | 0) + 40 >> 2] | 0) + (f << 2) >> 2] | 0) != 4) : 0) {
	                                f = c[(c[(c[t >> 2] | 0) + 52 >> 2] | 0) + (c[v >> 2] << 2) >> 2] | 0;
	                                g = c[s >> 2] | 0;
	                                c[s >> 2] = g + 1;
	                                c[(c[p >> 2] | 0) + (g << 2) >> 2] = f;
	                                f = c[n >> 2] | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                            c[v >> 2] = (c[v >> 2] | 0) + 1
	                        }
	                        c[v >> 2] = 0;
	                        while (1) {
	                            if ((c[v >> 2] | 0) >= (c[(c[t >> 2] | 0) + 48 >> 2] | 0))break a;
	                            if ((c[s >> 2] | 0) >= (c[r >> 2] | 0))break a;
	                            f = ca(c[w >> 2] | 0, (c[(c[t >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0;
	                            c[u >> 2] = c[(c[(c[t >> 2] | 0) + 40 >> 2] | 0) + (f + (c[v >> 2] | 0) + 1 << 2) >> 2];
	                            if (((c[u >> 2] | 0) > 0 ? (c[u >> 2] | 0) <= (c[(c[t >> 2] | 0) + 36 >> 2] | 0) : 0) ? (f = ca((c[u >> 2] | 0) - 1 | 0, (c[(c[t >> 2] | 0) + 48 >> 2] | 0) + 1 | 0) | 0, (c[(c[(c[t >> 2] | 0) + 40 >> 2] | 0) + (f << 2) >> 2] | 0) == 4) : 0) {
	                                f = c[(c[(c[t >> 2] | 0) + 52 >> 2] | 0) + (c[v >> 2] << 2) >> 2] | 0;
	                                g = c[s >> 2] | 0;
	                                c[s >> 2] = g + 1;
	                                c[(c[p >> 2] | 0) + (g << 2) >> 2] = f;
	                                f = c[o >> 2] | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                            c[v >> 2] = (c[v >> 2] | 0) + 1
	                        }
	                    } else E = 31; while (0);
	                    b:do if ((E | 0) == 31) {
	                        do if (c[q >> 2] | 0) {
	                            v = c[q >> 2] | 0;
	                            if ((c[c[(c[l >> 2] | 0) + 20 >> 2] >> 2] | 0) == 2) {
	                                c[v >> 2] = 1;
	                                break
	                            } else {
	                                c[v >> 2] = 0;
	                                break
	                            }
	                        } while (0);
	                        v = c[l >> 2] | 0;
	                        do if (c[m >> 2] | 0) {
	                            if (c[v + 76 >> 2] | 0) {
	                                c[A >> 2] = c[(c[l >> 2] | 0) + 76 >> 2];
	                                break
	                            }
	                            c[k >> 2] = -1;
	                            D = c[k >> 2] | 0;
	                            i = h;
	                            return D | 0
	                        } else {
	                            if (c[v + 20 >> 2] | 0) {
	                                c[A >> 2] = c[(c[l >> 2] | 0) + 20 >> 2];
	                                break
	                            }
	                            c[k >> 2] = -1;
	                            D = c[k >> 2] | 0;
	                            i = h;
	                            return D | 0
	                        } while (0);
	                        c[x >> 2] = 0;
	                        while (1) {
	                            if ((c[x >> 2] | 0) >= (c[(c[A >> 2] | 0) + 24 >> 2] | 0))break;
	                            if ((c[s >> 2] | 0) >= (c[r >> 2] | 0))break;
	                            c[y >> 2] = (c[(c[A >> 2] | 0) + 28 >> 2] | 0) + ((c[x >> 2] | 0) * 20 | 0);
	                            do if (((c[(c[y >> 2] | 0) + 4 >> 2] | 0) >= 0 ? (c[z >> 2] = c[c[y >> 2] >> 2], (c[z >> 2] | 0) != 0) : 0) ? (c[(c[z >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                                if ((c[(c[y >> 2] | 0) + 12 >> 2] | 0) == 1193047) {
	                                    v = c[33976] | 0;
	                                    t = c[33980] | 0;
	                                    c[j >> 2] = 140216;
	                                    c[j + 4 >> 2] = 4289;
	                                    Db[v & 511](t, 140184, j);
	                                    break
	                                }
	                                if ((c[(c[y >> 2] | 0) + 12 >> 2] | 0) == 1193046) {
	                                    t = c[33976] | 0;
	                                    v = c[33980] | 0;
	                                    c[j >> 2] = 140216;
	                                    c[j + 4 >> 2] = 4292;
	                                    Db[t & 511](v, 140184, j);
	                                    break
	                                }
	                                if ((c[(c[y >> 2] | 0) + 8 >> 2] | 0) < 0) {
	                                    if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0))break;
	                                    if (!(c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[y >> 2] | 0) + 4 >> 2] << 2) >> 2] | 0))break;
	                                    if ((c[c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[y >> 2] | 0) + 4 >> 2] << 2) >> 2] >> 2] | 0) == 4)break;
	                                    v = c[z >> 2] | 0;
	                                    if (c[(c[z >> 2] | 0) + 28 >> 2] | 0) {
	                                        t = c[v + 24 >> 2] | 0;
	                                        u = c[s >> 2] | 0;
	                                        c[s >> 2] = u + 1;
	                                        c[(c[p >> 2] | 0) + (u << 2) >> 2] = t
	                                    } else {
	                                        t = c[v + 20 >> 2] | 0;
	                                        v = c[s >> 2] | 0;
	                                        c[s >> 2] = v + 1;
	                                        c[(c[p >> 2] | 0) + (v << 2) >> 2] = t
	                                    }
	                                    t = c[n >> 2] | 0;
	                                    c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    break
	                                }
	                                c[B >> 2] = 0;
	                                t = c[(c[y >> 2] | 0) + 8 >> 2] | 0;
	                                v = c[l >> 2] | 0;
	                                if (c[m >> 2] | 0)c[C >> 2] = c[(c[v + 84 >> 2] | 0) + (t << 2) >> 2]; else c[C >> 2] = c[(c[v + 44 >> 2] | 0) + (t << 2) >> 2];
	                                if (c[(c[l >> 2] | 0) + 8 >> 2] | 0)c[B >> 2] = (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[y >> 2] | 0) + 8 >> 2] << 3);
	                                if ((c[B >> 2] | 0) != 0 ? (c[C >> 2] | 0) >= (c[(c[B >> 2] | 0) + 4 >> 2] | 0) : 0)break;
	                                t = c[z >> 2] | 0;
	                                if (c[(c[z >> 2] | 0) + 28 >> 2] | 0) {
	                                    v = c[t + 24 >> 2] | 0;
	                                    u = c[s >> 2] | 0;
	                                    c[s >> 2] = u + 1;
	                                    c[(c[p >> 2] | 0) + (u << 2) >> 2] = v
	                                } else {
	                                    v = c[t + 20 >> 2] | 0;
	                                    t = c[s >> 2] | 0;
	                                    c[s >> 2] = t + 1;
	                                    c[(c[p >> 2] | 0) + (t << 2) >> 2] = v
	                                }
	                                v = c[n >> 2] | 0;
	                                c[v >> 2] = (c[v >> 2] | 0) + 1
	                            } while (0);
	                            c[x >> 2] = (c[x >> 2] | 0) + 1
	                        }
	                        c[x >> 2] = 0;
	                        while (1) {
	                            if ((c[x >> 2] | 0) >= (c[(c[A >> 2] | 0) + 24 >> 2] | 0))break b;
	                            if ((c[s >> 2] | 0) >= (c[r >> 2] | 0))break b;
	                            c[y >> 2] = (c[(c[A >> 2] | 0) + 28 >> 2] | 0) + ((c[x >> 2] | 0) * 20 | 0);
	                            if ((((((((c[(c[y >> 2] | 0) + 4 >> 2] | 0) >= 0 ? (c[z >> 2] = c[c[y >> 2] >> 2], (c[z >> 2] | 0) != 0) : 0) ? (c[(c[z >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[y >> 2] | 0) + 12 >> 2] | 0) != 1193047 : 0) ? (c[(c[y >> 2] | 0) + 12 >> 2] | 0) != 1193046 : 0) ? (c[(c[y >> 2] | 0) + 8 >> 2] | 0) < 0 : 0) ? (c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[y >> 2] | 0) + 4 >> 2] << 2) >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) + (c[(c[y >> 2] | 0) + 4 >> 2] << 2) >> 2] >> 2] | 0) == 4 : 0) {
	                                v = c[z >> 2] | 0;
	                                if (c[(c[z >> 2] | 0) + 28 >> 2] | 0) {
	                                    t = c[v + 24 >> 2] | 0;
	                                    u = c[s >> 2] | 0;
	                                    c[s >> 2] = u + 1;
	                                    c[(c[p >> 2] | 0) + (u << 2) >> 2] = t
	                                } else {
	                                    t = c[v + 20 >> 2] | 0;
	                                    v = c[s >> 2] | 0;
	                                    c[s >> 2] = v + 1;
	                                    c[(c[p >> 2] | 0) + (v << 2) >> 2] = t
	                                }
	                                t = c[o >> 2] | 0;
	                                c[t >> 2] = (c[t >> 2] | 0) + 1
	                            }
	                            c[x >> 2] = (c[x >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[k >> 2] = 0;
	                    D = c[k >> 2] | 0;
	                    i = h;
	                    return D | 0
	                }
	                c[k >> 2] = -1;
	                D = c[k >> 2] | 0;
	                i = h;
	                return D | 0
	            }

	            function Uz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](80) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 80 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                if (c[e >> 2] | 0) {
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[c[f >> 2] >> 2] = a
	                }
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[c[f >> 2] >> 2];
	                c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 72 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 68 >> 2] = -1;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Vz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Qz(c[e >> 2] | 0, 140160);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    e = (c[f >> 2] | 0) + 0 | 0;
	                    a = e + 44 | 0;
	                    do {
	                        c[e >> 2] = 0;
	                        e = e + 4 | 0
	                    } while ((e | 0) < (a | 0));
	                    c[c[f >> 2] >> 2] = 3;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Wz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = c[f >> 2] | 0;
	                do if (!(c[(c[f >> 2] | 0) + 44 >> 2] | 0)) {
	                    c[b + 44 >> 2] = 4;
	                    a = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 44 >> 2] << 2) | 0;
	                    c[(c[f >> 2] | 0) + 52 >> 2] = a;
	                    if (!(c[(c[f >> 2] | 0) + 52 >> 2] | 0)) {
	                        Qz(c[f >> 2] | 0, 140144);
	                        c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                        c[e >> 2] = -1;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                } else if ((c[b + 48 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 44 >> 2] | 0)) {
	                    a = (c[f >> 2] | 0) + 44 | 0;
	                    c[a >> 2] = c[a >> 2] << 1;
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 52 >> 2] | 0, c[(c[f >> 2] | 0) + 44 >> 2] << 2) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 52 >> 2] = c[h >> 2];
	                        break
	                    }
	                    Qz(c[f >> 2] | 0, 140144);
	                    a = (c[f >> 2] | 0) + 44 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) / 2 | 0;
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[(c[g >> 2] | 0) + 16 >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                h = c[g >> 2] | 0;
	                g = (c[f >> 2] | 0) + 48 | 0;
	                b = c[g >> 2] | 0;
	                c[g >> 2] = b + 1;
	                c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + (b << 2) >> 2] = h;
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Xz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                rA(c[f >> 2] | 0, 0) | 0;
	                if (c[g >> 2] | 0)c[c[(c[f >> 2] | 0) + 24 >> 2] >> 2] = 2;
	                b = c[(c[f >> 2] | 0) + 24 >> 2] | 0;
	                if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 124) {
	                    c[(c[f >> 2] | 0) + 20 >> 2] = b;
	                    i = e;
	                    return
	                }
	                c[j >> 2] = b;
	                while (1) {
	                    if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 124)break;
	                    if (c[(c[f >> 2] | 0) + 8 >> 2] | 0)break;
	                    b = (c[f >> 2] | 0) + 4 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1;
	                    if (!(d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0)) {
	                        k = 9;
	                        break
	                    }
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[h >> 2];
	                    c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                    rA(c[f >> 2] | 0, c[j >> 2] | 0) | 0
	                }
	                if ((k | 0) == 9) {
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[f >> 2] | 0, 139560);
	                    i = e;
	                    return
	                }
	                if (c[g >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                c[(c[f >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                i = e;
	                return
	            }

	            function Yz(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                if (c[f >> 2] | 0) {
	                    c[h >> 2] = c[c[f >> 2] >> 2];
	                    c[j >> 2] = (c[(c[f >> 2] | 0) + 4 >> 2] | 0) - (c[c[f >> 2] >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 1450
	                }
	                f = c[g >> 2] | 0;
	                b = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                c[e >> 2] = c[g >> 2];
	                Xd(0, 0, 0, 0, 0, 14, 1450, 3, 0, 0, f, b, 0, h, 0, 139536, e);
	                i = d;
	                return
	            }

	            function Zz(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                        bA(c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 36 >> 2] | 0))break;
	                        dA(c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function _z(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 32 | 0;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                h = b + 16 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                m = b;
	                c[d >> 2] = a;
	                if (!(c[(c[d >> 2] | 0) + 52 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                sA(c[d >> 2] | 0);
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[g >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    if ((c[g >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) == 5 : 0) {
	                        bA(c[g >> 2] | 0);
	                        c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2] = 0
	                    }
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                c[h >> 2] = 0;
	                c[e >> 2] = (c[(c[d >> 2] | 0) + 48 >> 2] | 0) - 1;
	                while (1) {
	                    if ((c[e >> 2] | 0) < 0)break;
	                    c[g >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    a:do if (c[g >> 2] | 0) {
	                        if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) == 0 ? (c[c[g >> 2] >> 2] | 0) != 2 : 0)c[c[g >> 2] >> 2] = 4;
	                        c[f >> 2] = 0;
	                        while (1) {
	                            if ((c[f >> 2] | 0) >= (c[(c[g >> 2] | 0) + 24 >> 2] | 0))break a;
	                            do if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) >> 2] | 0) == 0 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 4 >> 2] | 0) >= 0 : 0) {
	                                a = (c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) | 0;
	                                if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 4 >> 2] | 0) == (c[e >> 2] | 0)) {
	                                    c[a + 4 >> 2] = -1;
	                                    break
	                                }
	                                if ((c[a + 12 >> 2] | 0) < 0) {
	                                    c[j >> 2] = c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 4 >> 2];
	                                    c[h >> 2] = 1;
	                                    c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 4 >> 2] = -2;
	                                    c[(c[g >> 2] | 0) + 4 >> 2] = 1;
	                                    tA(c[d >> 2] | 0, c[e >> 2] | 0, c[j >> 2] | 0, c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 8 >> 2] | 0);
	                                    c[(c[g >> 2] | 0) + 4 >> 2] = 0
	                                }
	                            } while (0);
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[e >> 2] = (c[e >> 2] | 0) + -1
	                }
	                b:do if (c[h >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break b;
	                        c[g >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                        c:do if (c[g >> 2] | 0) {
	                            c[f >> 2] = 0;
	                            while (1) {
	                                if ((c[f >> 2] | 0) >= (c[(c[g >> 2] | 0) + 24 >> 2] | 0))break c;
	                                c[k >> 2] = (c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0);
	                                if (((c[c[k >> 2] >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) < 0 : 0) ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) >= 0 : 0)c[(c[k >> 2] | 0) + 4 >> 2] = -1;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                } while (0);
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[g >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                c[g >> 2] = c[c[(c[d >> 2] | 0) + 52 >> 2] >> 2];
	                if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 12 >> 2] = 1;
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    c[l >> 2] = 0;
	                    c[(c[g >> 2] | 0) + 12 >> 2] = 2;
	                    c[f >> 2] = 0;
	                    while (1) {
	                        if ((c[f >> 2] | 0) >= (c[(c[g >> 2] | 0) + 24 >> 2] | 0))break;
	                        do if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 4 >> 2] | 0) >= 0) {
	                            if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) >> 2] | 0) == 0 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) < 0 : 0)break;
	                            c[m >> 2] = c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 20 | 0) + 4 >> 2];
	                            if ((c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) != 0 ? (c[(c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                                c[(c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 12 >> 2] = 1;
	                                c[l >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[m >> 2] << 2) >> 2]
	                            }
	                        } while (0);
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    d:do if (!(c[l >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        while (1) {
	                            if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break d;
	                            c[g >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                            if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 1 : 0)break;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        }
	                        c[l >> 2] = c[g >> 2]
	                    } while (0);
	                    c[g >> 2] = c[l >> 2]
	                }
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[g >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                        bA(c[g >> 2] | 0);
	                        c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2] = 0
	                    }
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                i = b;
	                return
	            }

	            function $z(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                b = i;
	                i = i + 80 | 0;
	                d = b + 72 | 0;
	                e = b + 68 | 0;
	                f = b + 64 | 0;
	                g = b + 60 | 0;
	                h = b + 56 | 0;
	                j = b + 52 | 0;
	                k = b + 48 | 0;
	                l = b + 44 | 0;
	                m = b + 40 | 0;
	                n = b + 36 | 0;
	                o = b + 32 | 0;
	                p = b + 28 | 0;
	                q = b + 24 | 0;
	                r = b + 20 | 0;
	                s = b + 16 | 0;
	                t = b + 12 | 0;
	                u = b + 8 | 0;
	                v = b + 4 | 0;
	                w = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](56) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Qz(c[e >> 2] | 0, 139512);
	                    c[d >> 2] = 0;
	                    x = c[d >> 2] | 0;
	                    i = b;
	                    return x | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                y = a + 56 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (y | 0));
	                c[c[f >> 2] >> 2] = c[c[e >> 2] >> 2];
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[(c[e >> 2] | 0) + 48 >> 2];
	                c[(c[f >> 2] | 0) + 8 >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                c[(c[f >> 2] | 0) + 12 >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                c[(c[f >> 2] | 0) + 16 >> 2] = c[(c[e >> 2] | 0) + 40 >> 2];
	                c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 60 >> 2];
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 64 >> 2];
	                c[(c[f >> 2] | 0) + 28 >> 2] = c[(c[e >> 2] | 0) + 68 >> 2];
	                c[(c[f >> 2] | 0) + 32 >> 2] = c[(c[e >> 2] | 0) + 76 >> 2];
	                if ((c[(c[f >> 2] | 0) + 28 >> 2] | 0) == -1)wz(c[f >> 2] | 0) | 0;
	                do if ((((((c[(c[f >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) ? (c[(c[e >> 2] | 0) + 72 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[f >> 2] | 0) + 16 >> 2] >> 2] | 0) + 4 >> 2] | 0) == 5 : 0) {
	                    c[j >> 2] = 0;
	                    c[k >> 2] = 0;
	                    c[l >> 2] = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] << 2) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        Qz(c[e >> 2] | 0, 139512);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        x = c[d >> 2] | 0;
	                        i = b;
	                        return x | 0
	                    }
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                        if (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) {
	                            c[(c[l >> 2] | 0) + (c[g >> 2] << 2) >> 2] = c[j >> 2];
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        } else c[(c[l >> 2] | 0) + (c[g >> 2] << 2) >> 2] = -1;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    c[p >> 2] = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 12 >> 2] << 2) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        Qz(c[e >> 2] | 0, 139512);
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        x = c[d >> 2] | 0;
	                        i = b;
	                        return x | 0
	                    }
	                    c[m >> 2] = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 12 >> 2] << 2) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        Qz(c[e >> 2] | 0, 139512);
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        x = c[d >> 2] | 0;
	                        i = b;
	                        return x | 0
	                    }
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                            z = 44;
	                            break
	                        }
	                        if ((c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) != 5) {
	                            z = 39;
	                            break
	                        }
	                        if ((c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) != 2) {
	                            z = 39;
	                            break
	                        }
	                        c[q >> 2] = c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0) + 20 >> 2];
	                        c[h >> 2] = 0;
	                        while (1) {
	                            if ((c[h >> 2] | 0) >= (c[k >> 2] | 0))break;
	                            a = (qy(c[(c[p >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0, c[q >> 2] | 0) | 0) != 0;
	                            A = c[h >> 2] | 0;
	                            if (a) {
	                                z = 30;
	                                break
	                            }
	                            c[h >> 2] = A + 1
	                        }
	                        if ((z | 0) == 30) {
	                            z = 0;
	                            c[(c[m >> 2] | 0) + (c[g >> 2] << 2) >> 2] = A
	                        }
	                        if ((c[h >> 2] | 0) >= (c[k >> 2] | 0)) {
	                            c[(c[m >> 2] | 0) + (c[g >> 2] << 2) >> 2] = c[k >> 2];
	                            a = my(c[q >> 2] | 0) | 0;
	                            c[(c[p >> 2] | 0) + (c[k >> 2] << 2) >> 2] = a;
	                            if (!(c[(c[p >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0)) {
	                                z = 34;
	                                break
	                            }
	                            c[k >> 2] = (c[k >> 2] | 0) + 1
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    if ((z | 0) == 34) {
	                        c[g >> 2] = 0;
	                        while (1) {
	                            B = c[33934] | 0;
	                            if ((c[g >> 2] | 0) >= (c[k >> 2] | 0))break;
	                            zb[B & 511](c[(c[p >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        zb[B & 511](c[m >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        x = c[d >> 2] | 0;
	                        i = b;
	                        return x | 0
	                    } else if ((z | 0) == 39) {
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        while (1) {
	                            C = c[33934] | 0;
	                            if ((c[g >> 2] | 0) >= (c[k >> 2] | 0))break;
	                            zb[C & 511](c[(c[p >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        zb[C & 511](c[p >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        x = c[d >> 2] | 0;
	                        i = b;
	                        return x | 0
	                    } else if ((z | 0) == 44) {
	                        a = (ca((c[j >> 2] | 0) + 1 | 0, (c[k >> 2] | 0) + 1 | 0) | 0) << 2;
	                        c[n >> 2] = Cb[c[135744 >> 2] & 511](a) | 0;
	                        if (!(c[n >> 2] | 0)) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                            c[d >> 2] = 0;
	                            x = c[d >> 2] | 0;
	                            i = b;
	                            return x | 0
	                        }
	                        cU(c[n >> 2] | 0, 0, (ca((c[j >> 2] | 0) + 1 | 0, (c[k >> 2] | 0) + 1 | 0) | 0) << 2 | 0) | 0;
	                        c[o >> 2] = 0;
	                        c[g >> 2] = 0;
	                        a:while (1) {
	                            if ((c[g >> 2] | 0) >= (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                            c[r >> 2] = c[(c[l >> 2] | 0) + (c[g >> 2] << 2) >> 2];
	                            b:do if ((c[r >> 2] | 0) != -1) {
	                                c[v >> 2] = c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2];
	                                a = ca(c[r >> 2] | 0, (c[k >> 2] | 0) + 1 | 0) | 0;
	                                c[(c[n >> 2] | 0) + (a << 2) >> 2] = c[c[v >> 2] >> 2];
	                                c[h >> 2] = 0;
	                                c:while (1) {
	                                    if ((c[h >> 2] | 0) >= (c[(c[v >> 2] | 0) + 24 >> 2] | 0))break b;
	                                    c[w >> 2] = (c[(c[v >> 2] | 0) + 28 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0);
	                                    do if ((c[(c[w >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                                        if (!(c[c[w >> 2] >> 2] | 0))break;
	                                        c[s >> 2] = c[(c[m >> 2] | 0) + (c[c[c[w >> 2] >> 2] >> 2] << 2) >> 2];
	                                        if ((c[o >> 2] | 0) == 0 ? (c[(c[c[w >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) {
	                                            a = (ca(c[j >> 2] | 0, c[k >> 2] | 0) | 0) << 2;
	                                            c[o >> 2] = Cb[c[135744 >> 2] & 511](a) | 0;
	                                            if (!(c[o >> 2] | 0))break c;
	                                            cU(c[o >> 2] | 0, 0, (ca(c[j >> 2] | 0, c[k >> 2] | 0) | 0) << 2 | 0) | 0
	                                        }
	                                        c[t >> 2] = c[(c[l >> 2] | 0) + (c[(c[w >> 2] | 0) + 4 >> 2] << 2) >> 2];
	                                        a = ca(c[r >> 2] | 0, (c[k >> 2] | 0) + 1 | 0) | 0;
	                                        c[u >> 2] = c[(c[n >> 2] | 0) + (a + (c[s >> 2] | 0) + 1 << 2) >> 2];
	                                        if (c[u >> 2] | 0)if ((c[u >> 2] | 0) != ((c[t >> 2] | 0) + 1 | 0)) {
	                                            z = 59;
	                                            break a
	                                        } else break;
	                                        a = ca(c[r >> 2] | 0, (c[k >> 2] | 0) + 1 | 0) | 0;
	                                        c[(c[n >> 2] | 0) + (a + (c[s >> 2] | 0) + 1 << 2) >> 2] = (c[t >> 2] | 0) + 1;
	                                        if (!(c[o >> 2] | 0))break;
	                                        a = ca(c[r >> 2] | 0, c[k >> 2] | 0) | 0;
	                                        c[(c[o >> 2] | 0) + (a + (c[s >> 2] | 0) << 2) >> 2] = c[(c[c[w >> 2] >> 2] | 0) + 60 >> 2]
	                                    } while (0);
	                                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                                }
	                                Qz(c[e >> 2] | 0, 139512)
	                            } while (0);
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        if ((z | 0) == 59) {
	                            c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                            if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            c[g >> 2] = 0;
	                            while (1) {
	                                D = c[33934] | 0;
	                                if ((c[g >> 2] | 0) >= (c[k >> 2] | 0))break;
	                                zb[D & 511](c[(c[p >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                                c[g >> 2] = (c[g >> 2] | 0) + 1
	                            }
	                            zb[D & 511](c[p >> 2] | 0);
	                            break
	                        }
	                        c[(c[f >> 2] | 0) + 28 >> 2] = 1;
	                        if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                            c[g >> 2] = 0;
	                            while (1) {
	                                if ((c[g >> 2] | 0) >= (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                                bA(c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                                c[g >> 2] = (c[g >> 2] | 0) + 1
	                            }
	                            zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0)
	                        }
	                        c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                        if (c[(c[f >> 2] | 0) + 16 >> 2] | 0) {
	                            c[g >> 2] = 0;
	                            while (1) {
	                                if ((c[g >> 2] | 0) >= (c[(c[f >> 2] | 0) + 12 >> 2] | 0))break;
	                                dA(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                                c[g >> 2] = (c[g >> 2] | 0) + 1
	                            }
	                            zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0)
	                        }
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[n >> 2];
	                        c[(c[f >> 2] | 0) + 44 >> 2] = c[o >> 2];
	                        c[(c[f >> 2] | 0) + 52 >> 2] = c[p >> 2];
	                        c[(c[f >> 2] | 0) + 48 >> 2] = c[k >> 2];
	                        c[(c[f >> 2] | 0) + 36 >> 2] = c[j >> 2];
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        break
	                    }
	                } while (0);
	                c[c[e >> 2] >> 2] = 0;
	                c[(c[e >> 2] | 0) + 48 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 64 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                x = c[d >> 2] | 0;
	                i = b;
	                return x | 0
	            }

	            function aA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                e = i;
	                i = i + 176 | 0;
	                f = e;
	                g = e + 164 | 0;
	                h = e + 160 | 0;
	                j = e + 156 | 0;
	                k = e + 60 | 0;
	                l = e + 56 | 0;
	                m = e + 52 | 0;
	                n = e + 48 | 0;
	                p = e + 44 | 0;
	                q = e + 40 | 0;
	                r = e + 36 | 0;
	                s = e + 32 | 0;
	                t = e + 28 | 0;
	                u = e + 24 | 0;
	                v = e + 20 | 0;
	                w = e + 16 | 0;
	                x = e + 12 | 0;
	                y = e + 8 | 0;
	                z = e + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e + 64;
	                c[m >> 2] = 0;
	                c[(c[k >> 2] | 0) + 64 >> 2] = c[j >> 2];
	                c[(c[k >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 88 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 4 >> 2] = 1;
	                c[(c[k >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 40 >> 2] = 0;
	                c[c[k >> 2] >> 2] = 0;
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                c[(c[k >> 2] | 0) + 20 >> 2] = c[c[(c[h >> 2] | 0) + 8 >> 2] >> 2];
	                c[(c[k >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 48 >> 2] = 0;
	                do if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) > 0) {
	                    j = Cb[c[135744 >> 2] & 511](c[(c[h >> 2] | 0) + 20 >> 2] << 2) | 0;
	                    c[(c[k >> 2] | 0) + 44 >> 2] = j;
	                    if (c[(c[k >> 2] | 0) + 44 >> 2] | 0) {
	                        cU(c[(c[k >> 2] | 0) + 44 >> 2] | 0, 0, c[(c[h >> 2] | 0) + 20 >> 2] << 2 | 0) | 0;
	                        break
	                    }
	                    Qz(0, 139408);
	                    c[g >> 2] = -1;
	                    A = c[g >> 2] | 0;
	                    i = e;
	                    return A | 0
	                } else c[(c[k >> 2] | 0) + 44 >> 2] = 0; while (0);
	                a:while (1) {
	                    if (c[c[k >> 2] >> 2] | 0)break;
	                    if (!(c[(c[k >> 2] | 0) + 20 >> 2] | 0))break;
	                    if (!(d[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[(c[k >> 2] | 0) + 56 >> 2] | 0) >> 0] | 0)) {
	                        if (!(c[(c[k >> 2] | 0) + 20 >> 2] | 0))break;
	                        if ((c[c[(c[k >> 2] | 0) + 20 >> 2] >> 2] | 0) == 2)break
	                    }
	                    c[n >> 2] = 1;
	                    if ((d[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[(c[k >> 2] | 0) + 56 >> 2] | 0) >> 0] | 0 | 0) == 0 ? (c[(c[k >> 2] | 0) + 44 >> 2] | 0) == 0 : 0) {
	                        if ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) < (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0)) {
	                            c[q >> 2] = (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0);
	                            if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) >= 0) {
	                                c[r >> 2] = c[c[q >> 2] >> 2];
	                                if ((c[(c[r >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[r >> 2] | 0) + 16 >> 2] | 0) > 0 : 0)B = 17
	                            } else B = 17
	                        }
	                    } else B = 17;
	                    b:do if ((B | 0) == 17) {
	                        B = 0;
	                        c[(c[k >> 2] | 0) + 28 >> 2] = 0;
	                        c:while (1) {
	                            if ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) >= (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0)) {
	                                B = 88;
	                                break
	                            }
	                            c[q >> 2] = (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0);
	                            d:do if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) >= 0) {
	                                c[r >> 2] = c[c[q >> 2] >> 2];
	                                c[l >> 2] = 0;
	                                c[p >> 2] = 1;
	                                do if ((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >= 0) {
	                                    if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                                        B = 22;
	                                        break a
	                                    }
	                                    c[s >> 2] = c[(c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 12 >> 2] << 2) >> 2];
	                                    c[t >> 2] = (c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[q >> 2] | 0) + 12 >> 2] << 3);
	                                    if ((c[s >> 2] | 0) >= (c[c[t >> 2] >> 2] | 0))C = (c[s >> 2] | 0) <= (c[(c[t >> 2] | 0) + 4 >> 2] | 0); else C = 0;
	                                    c[l >> 2] = C & 1;
	                                    if ((c[l >> 2] | 0) != 0 ? (c[c[t >> 2] >> 2] | 0) != (c[(c[t >> 2] | 0) + 4 >> 2] | 0) : 0)c[p >> 2] = 0
	                                } else {
	                                    if (!(c[r >> 2] | 0)) {
	                                        B = 29;
	                                        break c
	                                    }
	                                    if (!(d[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[(c[k >> 2] | 0) + 56 >> 2] | 0) >> 0] | 0)) {
	                                        if (c[(c[r >> 2] | 0) + 12 >> 2] | 0)break;
	                                        if ((c[(c[r >> 2] | 0) + 16 >> 2] | 0) <= 0)break;
	                                        c[(c[k >> 2] | 0) + 28 >> 2] = 1;
	                                        c[n >> 2] = 0;
	                                        c[l >> 2] = 1;
	                                        break
	                                    }
	                                    c[m >> 2] = oe(0, (c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[(c[k >> 2] | 0) + 56 >> 2] | 0) | 0, n) | 0;
	                                    c[l >> 2] = uA(c[r >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    if (((c[l >> 2] | 0) == 1 ? (c[(c[r >> 2] | 0) + 12 >> 2] | 0) >= 0 : 0) ? (c[(c[r >> 2] | 0) + 16 >> 2] | 0) > 0 : 0) {
	                                        c[u >> 2] = c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[(c[q >> 2] | 0) + 4 >> 2] << 2) >> 2];
	                                        if ((c[(c[q >> 2] | 0) + 8 >> 2] | 0) >= 0) {
	                                            if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                                                B = 38;
	                                                break a
	                                            }
	                                            if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0)) {
	                                                B = 38;
	                                                break a
	                                            }
	                                            if (!(c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0)) {
	                                                B = 38;
	                                                break a
	                                            }
	                                            c[v >> 2] = (c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 3);
	                                            if ((c[(c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 2) >> 2] | 0) >= (c[(c[v >> 2] | 0) + 4 >> 2] | 0))break d;
	                                            j = (c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 2) | 0;
	                                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                                        }
	                                        if ((c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0) > ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 1 | 0))pA(c[k >> 2] | 0);
	                                        c[(c[k >> 2] | 0) + 28 >> 2] = 1;
	                                        do {
	                                            if ((c[(c[k >> 2] | 0) + 28 >> 2] | 0) == (c[(c[r >> 2] | 0) + 16 >> 2] | 0))break;
	                                            j = (c[k >> 2] | 0) + 56 | 0;
	                                            c[j >> 2] = (c[j >> 2] | 0) + (c[n >> 2] | 0);
	                                            if (!(d[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[(c[k >> 2] | 0) + 56 >> 2] | 0) >> 0] | 0)) {
	                                                B = 46;
	                                                break
	                                            }
	                                            if ((c[(c[k >> 2] | 0) + 28 >> 2] | 0) >= (c[(c[r >> 2] | 0) + 12 >> 2] | 0)) {
	                                                c[w >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                                                c[x >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                                                c[(c[k >> 2] | 0) + 24 >> 2] = -1;
	                                                c[(c[k >> 2] | 0) + 20 >> 2] = c[u >> 2];
	                                                pA(c[k >> 2] | 0);
	                                                c[(c[k >> 2] | 0) + 24 >> 2] = c[w >> 2];
	                                                c[(c[k >> 2] | 0) + 20 >> 2] = c[x >> 2]
	                                            }
	                                            c[m >> 2] = oe(0, (c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[(c[k >> 2] | 0) + 56 >> 2] | 0) | 0, n) | 0;
	                                            c[l >> 2] = uA(c[r >> 2] | 0, c[m >> 2] | 0) | 0;
	                                            j = (c[k >> 2] | 0) + 28 | 0;
	                                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                                        } while ((c[l >> 2] | 0) == 1);
	                                        if ((B | 0) == 46) {
	                                            B = 0;
	                                            j = (c[k >> 2] | 0) + 56 | 0;
	                                            c[j >> 2] = (c[j >> 2] | 0) - (c[n >> 2] | 0)
	                                        }
	                                        if ((c[(c[k >> 2] | 0) + 28 >> 2] | 0) < (c[(c[r >> 2] | 0) + 12 >> 2] | 0))c[l >> 2] = 0;
	                                        if ((c[l >> 2] | 0) < 0)c[l >> 2] = 0;
	                                        if (!(c[l >> 2] | 0))break b;
	                                        if ((c[(c[q >> 2] | 0) + 8 >> 2] | 0) < 0)break;
	                                        if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                                            B = 57;
	                                            break a
	                                        }
	                                        j = (c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 2) | 0;
	                                        c[j >> 2] = (c[j >> 2] | 0) + -1;
	                                        break
	                                    }
	                                    if (((c[l >> 2] | 0) == 0 ? (c[(c[r >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[r >> 2] | 0) + 16 >> 2] | 0) > 0 : 0) {
	                                        c[(c[k >> 2] | 0) + 28 >> 2] = 1;
	                                        c[n >> 2] = 0;
	                                        c[l >> 2] = 1
	                                    }
	                                } while (0);
	                                if ((c[l >> 2] | 0) != 1)if ((c[l >> 2] | 0) < 0) {
	                                    B = 86;
	                                    break c
	                                } else break;
	                                if ((c[(c[q >> 2] | 0) + 16 >> 2] | 0) != 1) {
	                                    if (((c[p >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 12 >> 2] | 0) >= 0 : 0) ? (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0) > ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 1 | 0) : 0)B = 70
	                                } else B = 70;
	                                if ((B | 0) == 70) {
	                                    B = 0;
	                                    pA(c[k >> 2] | 0)
	                                }
	                                if ((c[(c[q >> 2] | 0) + 8 >> 2] | 0) < 0)break c;
	                                if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                                    B = 75;
	                                    break a
	                                }
	                                if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0)) {
	                                    B = 75;
	                                    break a
	                                }
	                                if (!(c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0)) {
	                                    B = 75;
	                                    break a
	                                }
	                                c[y >> 2] = (c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 3);
	                                if ((c[(c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 2) >> 2] | 0) < (c[(c[y >> 2] | 0) + 4 >> 2] | 0)) {
	                                    B = 77;
	                                    break c
	                                }
	                            } while (0);
	                            j = (c[k >> 2] | 0) + 24 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                        if ((B | 0) == 29) {
	                            B = 0;
	                            Ka(c[o >> 2] | 0, 139424, f | 0) | 0;
	                            c[c[k >> 2] >> 2] = -2;
	                            B = 88
	                        } else if ((B | 0) == 77) {
	                            B = 0;
	                            j = (c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 8 >> 2] << 2) | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        } else if ((B | 0) == 86) {
	                            B = 0;
	                            c[c[k >> 2] >> 2] = -4;
	                            B = 88
	                        }
	                        if ((B | 0) == 88) {
	                            B = 0;
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] | 0)break;
	                            if (!(c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0))break; else continue a
	                        }
	                        if ((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >= 0 ? (c[(c[q >> 2] | 0) + 12 >> 2] | 0) < 1193046 : 0) {
	                            if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                                B = 81;
	                                break a
	                            }
	                            c[(c[(c[k >> 2] | 0) + 44 >> 2] | 0) + (c[(c[q >> 2] | 0) + 12 >> 2] << 2) >> 2] = 0
	                        }
	                        c[(c[k >> 2] | 0) + 20 >> 2] = c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[(c[q >> 2] | 0) + 4 >> 2] << 2) >> 2];
	                        c[(c[k >> 2] | 0) + 24 >> 2] = 0;
	                        if (!(c[c[q >> 2] >> 2] | 0))continue a;
	                        j = (c[k >> 2] | 0) + 56 | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + (c[n >> 2] | 0);
	                        continue a
	                    } while (0);
	                    c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                    qA(c[k >> 2] | 0)
	                }
	                if ((B | 0) == 22)c[c[k >> 2] >> 2] = -1; else if ((B | 0) == 38)c[c[k >> 2] >> 2] = -1; else if ((B | 0) == 57)c[c[k >> 2] >> 2] = -1; else if ((B | 0) == 75)c[c[k >> 2] >> 2] = -1; else if ((B | 0) == 81)c[c[k >> 2] >> 2] = -1;
	                if (c[(c[k >> 2] | 0) + 40 >> 2] | 0) {
	                    e:do if (c[(c[k >> 2] | 0) + 44 >> 2] | 0) {
	                        c[z >> 2] = 0;
	                        while (1) {
	                            if ((c[z >> 2] | 0) >= (c[(c[k >> 2] | 0) + 32 >> 2] | 0))break e;
	                            if (c[(c[(c[k >> 2] | 0) + 40 >> 2] | 0) + (c[z >> 2] << 4) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[k >> 2] | 0) + 40 >> 2] | 0) + (c[z >> 2] << 4) + 12 >> 2] | 0);
	                            c[z >> 2] = (c[z >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 40 >> 2] | 0)
	                }
	                if (!(c[(c[k >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    A = c[g >> 2] | 0;
	                    i = e;
	                    return A | 0
	                }
	                if (c[(c[k >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 44 >> 2] | 0);
	                if (!(c[c[k >> 2] >> 2] | 0)) {
	                    c[g >> 2] = 1;
	                    A = c[g >> 2] | 0;
	                    i = e;
	                    return A | 0
	                }
	                z = c[k >> 2] | 0;
	                if ((c[c[k >> 2] >> 2] | 0) != -1) {
	                    c[g >> 2] = c[z >> 2];
	                    A = c[g >> 2] | 0;
	                    i = e;
	                    return A | 0
	                }
	                if ((c[z + 88 >> 2] | 0) > 1e7) {
	                    c[g >> 2] = -1;
	                    A = c[g >> 2] | 0;
	                    i = e;
	                    return A | 0
	                } else {
	                    c[g >> 2] = 0;
	                    A = c[g >> 2] | 0;
	                    i = e;
	                    return A | 0
	                }
	                return 0
	            }

	            function bA(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function cA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 40 | 0;
	                e = b + 36 | 0;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                o = b;
	                c[e >> 2] = a;
	                c[n >> 2] = 1;
	                c[o >> 2] = 1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 68 >> 2] | 0) != -1) {
	                    c[d >> 2] = c[a + 68 >> 2];
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                if (c[a + 76 >> 2] & 1)c[o >> 2] = 0;
	                c[f >> 2] = 0;
	                while (1) {
	                    if ((c[f >> 2] | 0) >= (c[(c[e >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[h >> 2] = c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + (c[f >> 2] << 2) >> 2];
	                    a:do if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 24 >> 2] | 0) >= 2 : 0) {
	                        c[g >> 2] = 0;
	                        while (1) {
	                            if ((c[g >> 2] | 0) >= (c[(c[h >> 2] | 0) + 24 >> 2] | 0))break a;
	                            c[j >> 2] = (c[(c[h >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0);
	                            b:do if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1 : 0) {
	                                c[m >> 2] = 0;
	                                while (1) {
	                                    if ((c[m >> 2] | 0) >= (c[g >> 2] | 0))break b;
	                                    c[k >> 2] = (c[(c[h >> 2] | 0) + 28 >> 2] | 0) + ((c[m >> 2] | 0) * 20 | 0);
	                                    do if (((((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != -1 ? (c[c[k >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == (c[(c[k >> 2] | 0) + 4 >> 2] | 0) : 0) ? (vA(c[c[j >> 2] >> 2] | 0, c[c[k >> 2] >> 2] | 0, c[o >> 2] | 0) | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == (c[(c[k >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                                        if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) != (c[(c[k >> 2] | 0) + 12 >> 2] | 0))break;
	                                        c[(c[k >> 2] | 0) + 4 >> 2] = -1
	                                    } while (0);
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                }
	                            } while (0);
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                c[f >> 2] = 0;
	                while (1) {
	                    if ((c[f >> 2] | 0) >= (c[(c[e >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[h >> 2] = c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + (c[f >> 2] << 2) >> 2];
	                    if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 24 >> 2] | 0) >= 2 : 0) {
	                        c[l >> 2] = 0;
	                        c[g >> 2] = 0;
	                        while (1) {
	                            if ((c[g >> 2] | 0) >= (c[(c[h >> 2] | 0) + 24 >> 2] | 0))break;
	                            c[j >> 2] = (c[(c[h >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0);
	                            c:do if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != -1 : 0) {
	                                c[m >> 2] = 0;
	                                while (1) {
	                                    if ((c[m >> 2] | 0) >= (c[g >> 2] | 0))break c;
	                                    c[k >> 2] = (c[(c[h >> 2] | 0) + 28 >> 2] | 0) + ((c[m >> 2] | 0) * 20 | 0);
	                                    do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != -1) {
	                                        o = c[j >> 2] | 0;
	                                        if (c[c[k >> 2] >> 2] | 0) {
	                                            if (!(wA(c[o >> 2] | 0, c[c[k >> 2] >> 2] | 0, 1) | 0))break;
	                                            c[n >> 2] = 0;
	                                            c[(c[j >> 2] | 0) + 16 >> 2] = 1;
	                                            c[(c[k >> 2] | 0) + 16 >> 2] = 1;
	                                            c[l >> 2] = c[j >> 2];
	                                            break
	                                        }
	                                        if ((c[o + 4 >> 2] | 0) != -1 ? (c[n >> 2] = xA(c[e >> 2] | 0, c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + (c[(c[j >> 2] | 0) + 4 >> 2] << 2) >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[c[k >> 2] >> 2] | 0) | 0, (c[n >> 2] | 0) == 0) : 0) {
	                                            c[(c[j >> 2] | 0) + 16 >> 2] = 1;
	                                            c[l >> 2] = c[j >> 2]
	                                        }
	                                    } while (0);
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                }
	                            } while (0);
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        if (c[l >> 2] | 0)c[(c[l >> 2] | 0) + 16 >> 2] = 2
	                    }
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                c[(c[e >> 2] | 0) + 68 >> 2] = c[n >> 2];
	                c[d >> 2] = c[n >> 2];
	                p = c[d >> 2] | 0;
	                i = b;
	                return p | 0
	            }

	            function dA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 52 >> 2] | 0))break;
	                    yA(c[(c[(c[d >> 2] | 0) + 56 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                if (c[(c[d >> 2] | 0) + 56 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 5 ? (c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 5 ? (c[(c[d >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 136 ? (c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function eA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    Qz(c[f >> 2] | 0, 139360);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    f = (c[h >> 2] | 0) + 0 | 0;
	                    b = f + 64 | 0;
	                    do {
	                        c[f >> 2] = 0;
	                        f = f + 4 | 0
	                    } while ((f | 0) < (b | 0));
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 2;
	                    c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 16 >> 2] = 0;
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function fA(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 40 | 0;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                q = f + 4 | 0;
	                r = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[l >> 2] | 0)) {
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[h >> 2] | 0, 139280);
	                    c[g >> 2] = -1;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 4) {
	                    if ((iA(c[h >> 2] | 0, c[l >> 2] | 0) | 0) < 0) {
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = f;
	                        return s | 0
	                    }
	                    if (((c[k >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 44 >> 2] | 0) != (c[k >> 2] | 0) : 0) ? (c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 8 : 0)jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[k >> 2] | 0);
	                    e = c[(c[l >> 2] | 0) + 8 >> 2] | 0;
	                    do if ((e | 0) == 8) {
	                        if (c[k >> 2] | 0)c[p >> 2] = c[k >> 2]; else {
	                            c[p >> 2] = Vz(c[h >> 2] | 0) | 0;
	                            Wz(c[h >> 2] | 0, c[p >> 2] | 0) | 0
	                        }
	                        do if ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 40 >> 2] | 0) == 0 : 0) {
	                            c[q >> 2] = zA(c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0)) {
	                                c[g >> 2] = -1;
	                                s = c[g >> 2] | 0;
	                                i = f;
	                                return s | 0
	                            }
	                            c[(c[q >> 2] | 0) + 8 >> 2] = 2;
	                            c[(c[q >> 2] | 0) + 12 >> 2] = 0;
	                            c[(c[q >> 2] | 0) + 16 >> 2] = 0;
	                            if ((fA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0, 0, c[q >> 2] | 0) | 0) >= 0) {
	                                c[o >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                c[n >> 2] = gA(c[h >> 2] | 0) | 0;
	                                c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + (c[n >> 2] << 3) >> 2] = (c[(c[l >> 2] | 0) + 12 >> 2] | 0) - 1;
	                                c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + (c[n >> 2] << 3) + 4 >> 2] = (c[(c[l >> 2] | 0) + 16 >> 2] | 0) - 1;
	                                lA(c[h >> 2] | 0, c[o >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[n >> 2] | 0);
	                                mA(c[h >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[n >> 2] | 0);
	                                jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0, c[p >> 2] | 0);
	                                break
	                            }
	                            c[g >> 2] = -1;
	                            s = c[g >> 2] | 0;
	                            i = f;
	                            return s | 0
	                        } else t = 26; while (0);
	                        if ((t | 0) == 26 ? (c[n >> 2] = gA(c[h >> 2] | 0) | 0, c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + (c[n >> 2] << 3) >> 2] = (c[(c[l >> 2] | 0) + 12 >> 2] | 0) - 1, c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + (c[n >> 2] << 3) + 4 >> 2] = (c[(c[l >> 2] | 0) + 16 >> 2] | 0) - 1, lA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0, c[n >> 2] | 0), mA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[p >> 2] | 0, c[n >> 2] | 0), (c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0) : 0)jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 40 >> 2] | 0, c[p >> 2] | 0);
	                        c[(c[l >> 2] | 0) + 12 >> 2] = 0;
	                        c[(c[l >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        c[(c[h >> 2] | 0) + 24 >> 2] = c[p >> 2]
	                    } else if ((e | 0) == 4) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0);
	                        jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0)
	                    } else if ((e | 0) == 3) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        d = c[h >> 2] | 0;
	                        b = c[(c[l >> 2] | 0) + 36 >> 2] | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            jA(d, b, 0);
	                            jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0);
	                            break
	                        } else {
	                            jA(d, b, c[k >> 2] | 0);
	                            break
	                        }
	                    } else if ((e | 0) == 5) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        jA(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0)
	                    } while (0);
	                    c[g >> 2] = 0;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                } else {
	                    if (((c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 16 >> 2] | 0) == 0 : 0) ? (c[(c[l >> 2] | 0) + 8 >> 2] | 0) == 8 : 0) {
	                        do if (!(c[k >> 2] | 0)) {
	                            c[k >> 2] = Vz(c[h >> 2] | 0) | 0;
	                            if (c[k >> 2] | 0) {
	                                Wz(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                                break
	                            }
	                            c[g >> 2] = -1;
	                            s = c[g >> 2] | 0;
	                            i = f;
	                            return s | 0
	                        } while (0);
	                        jA(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 24 >> 2] = c[k >> 2];
	                        dA(c[l >> 2] | 0);
	                        c[g >> 2] = 0;
	                        s = c[g >> 2] | 0;
	                        i = f;
	                        return s | 0
	                    }
	                    do if (!(c[k >> 2] | 0)) {
	                        c[k >> 2] = Vz(c[h >> 2] | 0) | 0;
	                        if (c[k >> 2] | 0) {
	                            Wz(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            break
	                        }
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = f;
	                        return s | 0
	                    } while (0);
	                    c[m >> 2] = c[k >> 2];
	                    if (!((c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 4 ? (c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 5 : 0))t = 44;
	                    do if ((t | 0) == 44) {
	                        c[r >> 2] = Vz(c[h >> 2] | 0) | 0;
	                        if (c[r >> 2] | 0) {
	                            Wz(c[h >> 2] | 0, c[r >> 2] | 0) | 0;
	                            jA(c[h >> 2] | 0, c[r >> 2] | 0, c[k >> 2] | 0);
	                            c[k >> 2] = c[r >> 2];
	                            break
	                        }
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = f;
	                        return s | 0
	                    } while (0);
	                    if ((iA(c[h >> 2] | 0, c[l >> 2] | 0) | 0) < 0) {
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = f;
	                        return s | 0
	                    }
	                    hA(c[h >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0, c[k >> 2] | 0, -1, -1);
	                    c[(c[h >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                    m = c[(c[l >> 2] | 0) + 8 >> 2] | 0;
	                    if ((m | 0) == 5) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        hA(c[h >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[k >> 2] | 0, -1, -1)
	                    } else if ((m | 0) == 3) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        jA(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0)
	                    } else if ((m | 0) == 4) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 2;
	                        jA(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                        hA(c[h >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[k >> 2] | 0, -1, -1)
	                    }
	                    c[g >> 2] = 0;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                return 0
	            }

	            function gA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                do if (!(c[(c[e >> 2] | 0) + 56 >> 2] | 0)) {
	                    c[a + 56 >> 2] = 4;
	                    g = Cb[c[135744 >> 2] & 511](c[(c[e >> 2] | 0) + 56 >> 2] << 3) | 0;
	                    c[(c[e >> 2] | 0) + 64 >> 2] = g;
	                    if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                        Qz(c[e >> 2] | 0, 139168);
	                        c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                        c[d >> 2] = -1;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                } else if ((c[a + 60 >> 2] | 0) >= (c[(c[e >> 2] | 0) + 56 >> 2] | 0)) {
	                    g = (c[e >> 2] | 0) + 56 | 0;
	                    c[g >> 2] = c[g >> 2] << 1;
	                    c[f >> 2] = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 64 >> 2] | 0, c[(c[e >> 2] | 0) + 56 >> 2] << 3) | 0;
	                    if (c[f >> 2] | 0) {
	                        c[(c[e >> 2] | 0) + 64 >> 2] = c[f >> 2];
	                        break
	                    }
	                    Qz(c[e >> 2] | 0, 139168);
	                    g = (c[e >> 2] | 0) + 56 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) / 2 | 0;
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } while (0);
	                c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + (c[(c[e >> 2] | 0) + 60 >> 2] << 3) >> 2] = -1;
	                c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + (c[(c[e >> 2] | 0) + 60 >> 2] << 3) + 4 >> 2] = -1;
	                f = (c[e >> 2] | 0) + 60 | 0;
	                e = c[f >> 2] | 0;
	                c[f >> 2] = e + 1;
	                c[d >> 2] = e;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function hA(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                if (!(c[k >> 2] | 0)) {
	                    c[(c[j >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[j >> 2] | 0, 139192);
	                    i = h;
	                    return
	                }
	                if (!(c[m >> 2] | 0)) {
	                    c[(c[j >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[j >> 2] | 0, 139224);
	                    i = h;
	                    return
	                }
	                c[p >> 2] = (c[(c[k >> 2] | 0) + 24 >> 2] | 0) - 1;
	                while (1) {
	                    if ((c[p >> 2] | 0) < 0)break;
	                    c[q >> 2] = (c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[p >> 2] | 0) * 20 | 0);
	                    if ((((c[c[q >> 2] >> 2] | 0) == (c[l >> 2] | 0) ? (c[(c[q >> 2] | 0) + 4 >> 2] | 0) == (c[(c[m >> 2] | 0) + 16 >> 2] | 0) : 0) ? (c[(c[q >> 2] | 0) + 8 >> 2] | 0) == (c[n >> 2] | 0) : 0) ? (c[(c[q >> 2] | 0) + 12 >> 2] | 0) == (c[o >> 2] | 0) : 0) {
	                        s = 20;
	                        break
	                    }
	                    c[p >> 2] = (c[p >> 2] | 0) + -1
	                }
	                if ((s | 0) == 20) {
	                    i = h;
	                    return
	                }
	                s = c[k >> 2] | 0;
	                do if (!(c[(c[k >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[s + 20 >> 2] = 8;
	                    p = Cb[c[135744 >> 2] & 511]((c[(c[k >> 2] | 0) + 20 >> 2] | 0) * 20 | 0) | 0;
	                    c[(c[k >> 2] | 0) + 28 >> 2] = p;
	                    if (!(c[(c[k >> 2] | 0) + 28 >> 2] | 0)) {
	                        Qz(c[j >> 2] | 0, 139256);
	                        c[(c[k >> 2] | 0) + 20 >> 2] = 0;
	                        i = h;
	                        return
	                    }
	                } else if ((c[s + 24 >> 2] | 0) >= (c[(c[k >> 2] | 0) + 20 >> 2] | 0)) {
	                    p = (c[k >> 2] | 0) + 20 | 0;
	                    c[p >> 2] = c[p >> 2] << 1;
	                    c[r >> 2] = Hb[c[135760 >> 2] & 511](c[(c[k >> 2] | 0) + 28 >> 2] | 0, (c[(c[k >> 2] | 0) + 20 >> 2] | 0) * 20 | 0) | 0;
	                    if (c[r >> 2] | 0) {
	                        c[(c[k >> 2] | 0) + 28 >> 2] = c[r >> 2];
	                        break
	                    }
	                    Qz(c[j >> 2] | 0, 139256);
	                    p = (c[k >> 2] | 0) + 20 | 0;
	                    c[p >> 2] = (c[p >> 2] | 0) / 2 | 0;
	                    i = h;
	                    return
	                } while (0);
	                c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0) >> 2] = c[l >> 2];
	                c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0) + 4 >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0) + 8 >> 2] = c[n >> 2];
	                c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0) + 12 >> 2] = c[o >> 2];
	                c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) * 20 | 0) + 16 >> 2] = 0;
	                o = (c[k >> 2] | 0) + 24 | 0;
	                c[o >> 2] = (c[o >> 2] | 0) + 1;
	                AA(c[j >> 2] | 0, c[m >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0);
	                i = h;
	                return
	            }

	            function iA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[b + 8 >> 2] = 1450;
	                    Yz(c[f >> 2] | 0, 139128);
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                a = c[f >> 2] | 0;
	                do if (!(c[b + 32 >> 2] | 0)) {
	                    c[a + 32 >> 2] = 4;
	                    k = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 32 >> 2] << 2) | 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = k;
	                    if (!(c[(c[f >> 2] | 0) + 40 >> 2] | 0)) {
	                        Qz(c[f >> 2] | 0, 139152);
	                        c[(c[f >> 2] | 0) + 32 >> 2] = 0;
	                        c[e >> 2] = -1;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                } else if ((c[a + 36 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 32 >> 2] | 0)) {
	                    k = (c[f >> 2] | 0) + 32 | 0;
	                    c[k >> 2] = c[k >> 2] << 1;
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 40 >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] << 2) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[h >> 2];
	                        break
	                    }
	                    Qz(c[f >> 2] | 0, 139168);
	                    k = (c[f >> 2] | 0) + 32 | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) / 2 | 0;
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[c[g >> 2] >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                h = c[g >> 2] | 0;
	                g = (c[f >> 2] | 0) + 36 | 0;
	                a = c[g >> 2] | 0;
	                c[g >> 2] = a + 1;
	                c[(c[(c[f >> 2] | 0) + 40 >> 2] | 0) + (a << 2) >> 2] = h;
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function jA(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[h >> 2] = Vz(c[f >> 2] | 0) | 0;
	                    Wz(c[f >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[h >> 2]
	                }
	                hA(c[f >> 2] | 0, c[g >> 2] | 0, 0, c[h >> 2] | 0, -1, -1);
	                i = e;
	                return
	            }

	            function kA(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[j >> 2] = Vz(c[g >> 2] | 0) | 0;
	                    Wz(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2]
	                }
	                e = c[g >> 2] | 0;
	                g = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                if (c[k >> 2] | 0) {
	                    hA(e, g, 0, h, -1, 1193047);
	                    i = f;
	                    return
	                } else {
	                    hA(e, g, 0, h, -1, 1193046);
	                    i = f;
	                    return
	                }
	            }

	            function lA(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[j >> 2] = Vz(c[g >> 2] | 0) | 0;
	                    Wz(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2]
	                }
	                hA(c[g >> 2] | 0, c[h >> 2] | 0, 0, c[j >> 2] | 0, c[k >> 2] | 0, -1);
	                i = f;
	                return
	            }

	            function mA(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[j >> 2] = Vz(c[g >> 2] | 0) | 0;
	                    Wz(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2]
	                }
	                hA(c[g >> 2] | 0, c[h >> 2] | 0, 0, c[j >> 2] | 0, -1, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function nA(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = c[f >> 2] | 0;
	                do if (!(c[(c[f >> 2] | 0) + 48 >> 2] | 0)) {
	                    c[d + 48 >> 2] = 4;
	                    b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 48 >> 2] << 3) | 0;
	                    c[(c[f >> 2] | 0) + 68 >> 2] = b;
	                    if (!(c[(c[f >> 2] | 0) + 68 >> 2] | 0)) {
	                        Qz(0, 140240);
	                        c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                        i = e;
	                        return
	                    }
	                } else if (((c[d + 52 >> 2] | 0) + 1 | 0) >= (c[(c[f >> 2] | 0) + 48 >> 2] | 0)) {
	                    b = (c[f >> 2] | 0) + 48 | 0;
	                    c[b >> 2] = c[b >> 2] << 1;
	                    c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 68 >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] << 3) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 68 >> 2] = c[j >> 2];
	                        break
	                    }
	                    Qz(0, 140240);
	                    b = (c[f >> 2] | 0) + 48 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) / 2 | 0;
	                    i = e;
	                    return
	                } while (0);
	                j = my(c[g >> 2] | 0) | 0;
	                c[(c[(c[f >> 2] | 0) + 68 >> 2] | 0) + (c[(c[f >> 2] | 0) + 52 >> 2] << 3) >> 2] = j;
	                c[(c[(c[f >> 2] | 0) + 68 >> 2] | 0) + (c[(c[f >> 2] | 0) + 52 >> 2] << 3) + 4 >> 2] = c[h >> 2];
	                h = (c[f >> 2] | 0) + 52 | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + 1;
	                c[(c[(c[f >> 2] | 0) + 68 >> 2] | 0) + (c[(c[f >> 2] | 0) + 52 >> 2] << 3) >> 2] = 0;
	                c[(c[(c[f >> 2] | 0) + 68 >> 2] | 0) + (c[(c[f >> 2] | 0) + 52 >> 2] << 3) + 4 >> 2] = 0;
	                i = e;
	                return
	            }

	            function oA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[g >> 2] | 0) == (c[h >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                a:do b:do if ((d[c[g >> 2] >> 0] | 0 | 0) != (d[c[h >> 2] >> 0] | 0 | 0)) {
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) == 42) {
	                        c[j >> 2] = c[h >> 2];
	                        c[h >> 2] = c[g >> 2];
	                        c[g >> 2] = c[j >> 2]
	                    }
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        l = 15;
	                        break a
	                    }
	                    if (!(d[c[g >> 2] >> 0] | 0)) {
	                        l = 15;
	                        break a
	                    }
	                    b = c[g >> 2] | 0;
	                    c[g >> 2] = b + 1;
	                    if ((d[b >> 0] | 0 | 0) != 42) {
	                        l = 15;
	                        break a
	                    }
	                    do {
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) == 124)break b;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    } while ((d[c[h >> 2] >> 0] | 0 | 0) != 0)
	                } else {
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                } while (0); while ((d[c[h >> 2] >> 0] | 0 | 0) != 0);
	                if ((l | 0) == 15) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (d[c[g >> 2] >> 0] | 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function pA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if ((c[(c[d >> 2] | 0) + 88 >> 2] | 0) > 1e7) {
	                    i = b;
	                    return
	                }
	                a = (c[d >> 2] | 0) + 88 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                a = c[d >> 2] | 0;
	                do if (c[(c[d >> 2] | 0) + 32 >> 2] | 0) {
	                    if ((c[a + 36 >> 2] | 0) >= (c[(c[d >> 2] | 0) + 32 >> 2] | 0)) {
	                        c[f >> 2] = c[(c[d >> 2] | 0) + 32 >> 2];
	                        g = (c[d >> 2] | 0) + 32 | 0;
	                        c[g >> 2] = c[g >> 2] << 1;
	                        c[e >> 2] = Hb[c[135760 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0, c[(c[d >> 2] | 0) + 32 >> 2] << 4) | 0;
	                        if (c[e >> 2] | 0) {
	                            c[(c[d >> 2] | 0) + 40 >> 2] = c[e >> 2];
	                            c[e >> 2] = (c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[f >> 2] << 4);
	                            cU(c[e >> 2] | 0, 0, (c[(c[d >> 2] | 0) + 32 >> 2] | 0) - (c[f >> 2] | 0) << 4 | 0) | 0;
	                            break
	                        }
	                        Qz(0, 139496);
	                        g = (c[d >> 2] | 0) + 32 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) / 2 | 0;
	                        i = b;
	                        return
	                    }
	                } else {
	                    c[a + 32 >> 2] = 4;
	                    g = Cb[c[135744 >> 2] & 511](c[(c[d >> 2] | 0) + 32 >> 2] << 4) | 0;
	                    c[(c[d >> 2] | 0) + 40 >> 2] = g;
	                    if (c[(c[d >> 2] | 0) + 40 >> 2] | 0) {
	                        cU(c[(c[d >> 2] | 0) + 40 >> 2] | 0, 0, c[(c[d >> 2] | 0) + 32 >> 2] << 4 | 0) | 0;
	                        break
	                    }
	                    Qz(0, 139496);
	                    c[(c[d >> 2] | 0) + 32 >> 2] = 0;
	                    i = b;
	                    return
	                } while (0);
	                c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) >> 2] = c[(c[d >> 2] | 0) + 20 >> 2];
	                c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 4 >> 2] = c[(c[d >> 2] | 0) + 56 >> 2];
	                c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 8 >> 2] = (c[(c[d >> 2] | 0) + 24 >> 2] | 0) + 1;
	                if ((c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] | 0) > 0) {
	                    if ((c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 12 >> 2] | 0) == 0 ? (a = Cb[c[135744 >> 2] & 511](c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] << 2) | 0, c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 12 >> 2] = a, (c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 12 >> 2] | 0) == 0) : 0) {
	                        Qz(0, 139496);
	                        c[c[d >> 2] >> 2] = -5;
	                        i = b;
	                        return
	                    }
	                    eU(c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 12 >> 2] | 0, c[(c[d >> 2] | 0) + 44 >> 2] | 0, c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] << 2 | 0) | 0
	                }
	                a = (c[d >> 2] | 0) + 36 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                i = b;
	                return
	            }

	            function qA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                c[d >> 2] = a;
	                a = c[d >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 36 >> 2] | 0) <= 0) {
	                    c[a >> 2] = -1;
	                    i = b;
	                    return
	                }
	                e = a + 36 | 0;
	                c[e >> 2] = (c[e >> 2] | 0) + -1;
	                c[(c[d >> 2] | 0) + 20 >> 2] = c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) >> 2];
	                c[(c[d >> 2] | 0) + 56 >> 2] = c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 4 >> 2];
	                c[(c[d >> 2] | 0) + 24 >> 2] = c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 8 >> 2];
	                if ((c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] | 0) <= 0) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 12 >> 2] | 0)) {
	                    Ka(c[o >> 2] | 0, 139464, b | 0) | 0;
	                    c[c[d >> 2] >> 2] = -6;
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 44 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                eU(c[(c[d >> 2] | 0) + 44 >> 2] | 0, c[(c[(c[d >> 2] | 0) + 40 >> 2] | 0) + (c[(c[d >> 2] | 0) + 36 >> 2] << 4) + 12 >> 2] | 0, c[(c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] << 2 | 0) | 0;
	                i = b;
	                return
	            }

	            function rA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                c[k >> 2] = BA(c[g >> 2] | 0) | 0;
	                do if (c[k >> 2] | 0) {
	                    b = c[g >> 2] | 0;
	                    a = c[j >> 2] | 0;
	                    if ((d[c[(c[g >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 124 ? (d[c[(c[g >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 41 : 0)l = 0; else l = c[h >> 2] | 0;
	                    if ((fA(b, a, l, c[(c[g >> 2] | 0) + 28 >> 2] | 0) | 0) >= 0) {
	                        c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        c[(c[g >> 2] | 0) + 28 >> 2] = 0;
	                        break
	                    }
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                while (1) {
	                    if (!(c[k >> 2] | 0)) {
	                        n = 17;
	                        break
	                    }
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        n = 17;
	                        break
	                    }
	                    c[k >> 2] = BA(c[g >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0))continue;
	                    l = c[g >> 2] | 0;
	                    a = c[j >> 2] | 0;
	                    if ((d[c[(c[g >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 124 ? (d[c[(c[g >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 41 : 0)o = 0; else o = c[h >> 2] | 0;
	                    if ((fA(l, a, o, c[(c[g >> 2] | 0) + 28 >> 2] | 0) | 0) < 0) {
	                        n = 15;
	                        break
	                    }
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                    c[(c[g >> 2] | 0) + 28 >> 2] = 0
	                }
	                if ((n | 0) == 15) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else if ((n | 0) == 17) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function sA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[j >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    if (((((((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 24 >> 2] | 0) == 1 : 0) ? (c[c[j >> 2] >> 2] | 0) != 5 : 0) ? (c[c[(c[j >> 2] | 0) + 28 >> 2] >> 2] | 0) == 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) >= 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) != (c[e >> 2] | 0) : 0) ? (c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] | 0) < 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0) < 0 : 0) ? (c[h >> 2] = c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2], (c[c[j >> 2] >> 2] | 0) != 1) : 0) {
	                        c[f >> 2] = 0;
	                        while (1) {
	                            if ((c[f >> 2] | 0) >= (c[(c[j >> 2] | 0) + 36 >> 2] | 0))break;
	                            c[k >> 2] = c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + (c[f >> 2] << 2) >> 2] << 2) >> 2];
	                            c[g >> 2] = 0;
	                            while (1) {
	                                if ((c[g >> 2] | 0) >= (c[(c[k >> 2] | 0) + 24 >> 2] | 0))break;
	                                if ((c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) + 4 >> 2] | 0) == (c[e >> 2] | 0)) {
	                                    c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) + 4 >> 2] = -1;
	                                    hA(c[d >> 2] | 0, c[k >> 2] | 0, c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) >> 2] | 0, c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0, c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) + 8 >> 2] | 0, c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) + 12 >> 2] | 0)
	                                }
	                                c[g >> 2] = (c[g >> 2] | 0) + 1
	                            }
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        if ((c[c[j >> 2] >> 2] | 0) == 2)c[c[(c[(c[d >> 2] | 0) + 52 >> 2] | 0) + (c[h >> 2] << 2) >> 2] >> 2] = 2;
	                        c[(c[j >> 2] | 0) + 24 >> 2] = 0;
	                        c[c[j >> 2] >> 2] = 5
	                    }
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                i = b;
	                return
	            }

	            function tA(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[m >> 2] = c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                if (!(c[m >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[n >> 2] = c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                if (!(c[n >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    i = f;
	                    return
	                }
	                if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                    i = f;
	                    return
	                }
	                c[(c[n >> 2] | 0) + 4 >> 2] = 2;
	                if ((c[c[n >> 2] >> 2] | 0) == 2)c[c[m >> 2] >> 2] = 2;
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >= (c[(c[n >> 2] | 0) + 24 >> 2] | 0))break;
	                    do if ((c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 4 >> 2] | 0) >= 0) {
	                        j = c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 4 >> 2] | 0;
	                        if (c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) >> 2] | 0) {
	                            c[p >> 2] = j;
	                            e = c[g >> 2] | 0;
	                            d = c[m >> 2] | 0;
	                            b = c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) >> 2] | 0;
	                            a = c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0;
	                            if ((c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 8 >> 2] | 0) >= 0) {
	                                hA(e, d, b, a, c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 8 >> 2] | 0, -1);
	                                break
	                            } else {
	                                hA(e, d, b, a, c[k >> 2] | 0, -1);
	                                break
	                            }
	                        }
	                        if ((j | 0) != (c[h >> 2] | 0)) {
	                            j = (c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) | 0;
	                            if ((c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) >= 0) {
	                                c[o >> 2] = c[j + 4 >> 2];
	                                hA(c[g >> 2] | 0, c[m >> 2] | 0, 0, c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0, -1, c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 12 >> 2] | 0);
	                                break
	                            }
	                            a = c[g >> 2] | 0;
	                            b = c[h >> 2] | 0;
	                            d = c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 4 >> 2] | 0;
	                            if ((c[j + 8 >> 2] | 0) >= 0) {
	                                tA(a, b, d, c[(c[(c[n >> 2] | 0) + 28 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 8 >> 2] | 0);
	                                break
	                            } else {
	                                tA(a, b, d, c[k >> 2] | 0);
	                                break
	                            }
	                        }
	                    } while (0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                c[(c[n >> 2] | 0) + 4 >> 2] = 0;
	                i = f;
	                return
	            }

	            function uA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[k >> 2] = 0;
	                do if (c[g >> 2] | 0) {
	                    b = c[h >> 2] | 0;
	                    if ((c[h >> 2] | 0) < 256) {
	                        if (!(9 <= (b | 0) & (c[h >> 2] | 0) <= 10 | (c[h >> 2] | 0) == 13 | 32 <= (c[h >> 2] | 0)))break
	                    } else if ((!(256 <= (b | 0) & (c[h >> 2] | 0) <= 55295) ? !(57344 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 1114111) : 0)break;
	                    switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                        case 136:
	                        case 135:
	                        case 134:
	                        case 133:
	                        case 132:
	                        case 131:
	                        case 130:
	                        case 129:
	                        case 128:
	                        case 127:
	                        case 126:
	                        case 125:
	                        case 124:
	                        case 123:
	                        case 122:
	                        case 121:
	                        case 120:
	                        case 119:
	                        case 118:
	                        case 117:
	                        case 116:
	                        case 115:
	                        case 114:
	                        case 113:
	                        case 112:
	                        case 111:
	                        case 110:
	                        case 109:
	                        case 108:
	                        case 107:
	                        case 106:
	                        case 105:
	                        case 104:
	                        case 103:
	                        case 102:
	                        case 101:
	                        case 100:
	                        case 16:
	                        case 15:
	                        case 14:
	                        case 13:
	                        case 12:
	                        case 11:
	                        case 10:
	                        case 9:
	                        case 8:
	                        case 7:
	                        case 6:
	                        {
	                            c[k >> 2] = CA(c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, 0, 0, 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                            if (c[(c[g >> 2] | 0) + 28 >> 2] | 0)c[k >> 2] = ((c[k >> 2] | 0) != 0 ^ 1) & 1;
	                            break
	                        }
	                        case 2:
	                        {
	                            c[f >> 2] = (c[h >> 2] | 0) == (c[(c[g >> 2] | 0) + 32 >> 2] | 0) & 1;
	                            n = c[f >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                        case 3:
	                        {
	                            c[m >> 2] = 0;
	                            c[j >> 2] = 0;
	                            a:while (1) {
	                                if ((c[j >> 2] | 0) >= (c[(c[g >> 2] | 0) + 52 >> 2] | 0)) {
	                                    o = 23;
	                                    break
	                                }
	                                c[l >> 2] = c[(c[(c[g >> 2] | 0) + 56 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                                b = c[l >> 2] | 0;
	                                do if ((c[c[l >> 2] >> 2] | 0) == 2) {
	                                    c[k >> 2] = CA(c[b + 4 >> 2] | 0, c[h >> 2] | 0, 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[(c[l >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                    if (c[k >> 2] | 0) {
	                                        o = 15;
	                                        break a
	                                    }
	                                } else {
	                                    a = (c[b >> 2] | 0) != 0;
	                                    c[k >> 2] = CA(c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[(c[l >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                    p = c[k >> 2] | 0;
	                                    if (a) {
	                                        if (p) {
	                                            o = 19;
	                                            break a
	                                        }
	                                        c[m >> 2] = 1;
	                                        break
	                                    } else {
	                                        if (!p)break;
	                                        c[m >> 2] = 1;
	                                        break
	                                    }
	                                } while (0);
	                                c[j >> 2] = (c[j >> 2] | 0) + 1
	                            }
	                            if ((o | 0) == 15) {
	                                c[f >> 2] = 0;
	                                n = c[f >> 2] | 0;
	                                i = d;
	                                return n | 0
	                            } else if ((o | 0) == 19) {
	                                c[f >> 2] = 0;
	                                n = c[f >> 2] | 0;
	                                i = d;
	                                return n | 0
	                            } else if ((o | 0) == 23) {
	                                c[f >> 2] = c[m >> 2];
	                                n = c[f >> 2] | 0;
	                                i = d;
	                                return n | 0
	                            }
	                            break
	                        }
	                        case 5:
	                        {
	                            Wa(139376, e | 0) | 0;
	                            c[f >> 2] = -1;
	                            n = c[f >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                        case 1:
	                        case 4:
	                        {
	                            c[f >> 2] = -1;
	                            n = c[f >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } while (0);
	                c[f >> 2] = -1;
	                n = c[f >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function vA(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[g >> 2] | 0) == (c[h >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != (c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                do if ((d | 0) == 1)c[k >> 2] = 0; else if ((d | 0) == 2)c[k >> 2] = (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == (c[(c[h >> 2] | 0) + 32 >> 2] | 0) & 1; else if ((d | 0) == 3)c[k >> 2] = 0; else if ((d | 0) == 5) {
	                    b = c[(c[g >> 2] | 0) + 20 >> 2] | 0;
	                    a = c[(c[h >> 2] | 0) + 20 >> 2] | 0;
	                    if (c[j >> 2] | 0) {
	                        c[k >> 2] = qy(b, a) | 0;
	                        break
	                    } else {
	                        c[k >> 2] = (b | 0) == (a | 0) & 1;
	                        break
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function wA(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 1;
	                if ((c[g >> 2] | 0) == (c[h >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 6 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 6 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 > (c[(c[h >> 2] | 0) + 4 >> 2] | 0) >>> 0) {
	                        c[l >> 2] = c[g >> 2];
	                        c[g >> 2] = c[h >> 2];
	                        c[h >> 2] = c[l >> 2]
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != (c[(c[h >> 2] | 0) + 4 >> 2] | 0) ? (c[k >> 2] = DA(c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0, (c[k >> 2] | 0) == 0) : 0) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    l = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                    do if ((l | 0) == 5) {
	                        d = c[(c[g >> 2] | 0) + 20 >> 2] | 0;
	                        b = c[(c[h >> 2] | 0) + 20 >> 2] | 0;
	                        if (c[j >> 2] | 0) {
	                            c[k >> 2] = oA(d, b) | 0;
	                            s = 30;
	                            break
	                        } else {
	                            c[k >> 2] = (d | 0) != (b | 0) & 1;
	                            s = 30;
	                            break
	                        }
	                    } else if ((l | 0) == 2)if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        c[k >> 2] = (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == (c[(c[h >> 2] | 0) + 32 >> 2] | 0) & 1;
	                        s = 30;
	                        break
	                    } else {
	                        b = uA(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        c[k >> 2] = b;
	                        c[k >> 2] = (c[k >> 2] | 0) < 0 ? 1 : b;
	                        s = 30;
	                        break
	                    } else if ((l | 0) == 3)if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                        c[m >> 2] = 0;
	                        a:while (1) {
	                            if ((c[m >> 2] | 0) >= (c[(c[g >> 2] | 0) + 52 >> 2] | 0)) {
	                                s = 29;
	                                break
	                            }
	                            c[n >> 2] = 0;
	                            while (1) {
	                                t = c[m >> 2] | 0;
	                                if ((c[n >> 2] | 0) >= (c[(c[h >> 2] | 0) + 52 >> 2] | 0))break;
	                                c[p >> 2] = c[(c[(c[g >> 2] | 0) + 56 >> 2] | 0) + (t << 2) >> 2];
	                                c[q >> 2] = c[(c[(c[h >> 2] | 0) + 56 >> 2] | 0) + (c[n >> 2] << 2) >> 2];
	                                c[o >> 2] = EA(c[p >> 2] | 0, c[q >> 2] | 0) | 0;
	                                if ((c[o >> 2] | 0) == 1) {
	                                    s = 26;
	                                    break a
	                                }
	                                c[n >> 2] = (c[n >> 2] | 0) + 1
	                            }
	                            c[m >> 2] = t + 1
	                        }
	                        if ((s | 0) == 26) {
	                            c[k >> 2] = 1;
	                            s = 30;
	                            break
	                        } else if ((s | 0) == 29) {
	                            c[k >> 2] = 0;
	                            s = 30;
	                            break
	                        }
	                    } else s = 30; while (0);
	                    if ((s | 0) == 30) {
	                        if ((c[(c[g >> 2] | 0) + 28 >> 2] | 0) != (c[(c[h >> 2] | 0) + 28 >> 2] | 0))c[k >> 2] = ((c[k >> 2] | 0) != 0 ^ 1) & 1;
	                        if (!(c[k >> 2] | 0)) {
	                            c[f >> 2] = 0;
	                            r = c[f >> 2] | 0;
	                            i = e;
	                            return r | 0
	                        }
	                    }
	                    c[f >> 2] = 1;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[f >> 2] = 1;
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function xA(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 40 | 0;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                q = f + 4 | 0;
	                r = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 1;
	                c[r >> 2] = 1;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = c[m >> 2];
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 2) {
	                    c[g >> 2] = c[m >> 2];
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                if (c[(c[h >> 2] | 0) + 76 >> 2] & 1)c[r >> 2] = 0;
	                c[p >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                c[o >> 2] = 0;
	                while (1) {
	                    if ((c[o >> 2] | 0) >= (c[p >> 2] | 0))break;
	                    c[q >> 2] = (c[(c[j >> 2] | 0) + 28 >> 2] | 0) + ((c[o >> 2] | 0) * 20 | 0);
	                    e = c[(c[q >> 2] | 0) + 4 >> 2] | 0;
	                    if (!(c[c[q >> 2] >> 2] | 0)) {
	                        if ((e | 0) >= 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] = 2, c[n >> 2] = xA(c[h >> 2] | 0, c[(c[(c[h >> 2] | 0) + 52 >> 2] | 0) + (c[(c[q >> 2] | 0) + 4 >> 2] << 2) >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0, c[(c[j >> 2] | 0) + 8 >> 2] = 0, (c[n >> 2] | 0) == 0) : 0)c[m >> 2] = 0
	                    } else if ((e | 0) == (c[k >> 2] | 0) ? (wA(c[c[q >> 2] >> 2] | 0, c[l >> 2] | 0, c[r >> 2] | 0) | 0) != 0 : 0) {
	                        c[m >> 2] = 0;
	                        c[(c[q >> 2] | 0) + 16 >> 2] = 1
	                    }
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                c[g >> 2] = c[m >> 2];
	                s = c[g >> 2] | 0;
	                i = f;
	                return s | 0
	            }

	            function yA(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function zA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    Qz(c[f >> 2] | 0, 139320);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 64 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                c[(c[h >> 2] | 0) + 8 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                c[(c[h >> 2] | 0) + 16 >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                a:do if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) > 0) {
	                    b = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 52 >> 2] << 2) | 0;
	                    c[(c[h >> 2] | 0) + 56 >> 2] = b;
	                    b:do if (!(c[(c[h >> 2] | 0) + 56 >> 2] | 0))Qz(c[f >> 2] | 0, 139320); else {
	                        c[j >> 2] = 0;
	                        while (1) {
	                            if ((c[j >> 2] | 0) >= (c[(c[g >> 2] | 0) + 52 >> 2] | 0))break a;
	                            b = FA(c[f >> 2] | 0, c[(c[(c[g >> 2] | 0) + 56 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0;
	                            c[(c[(c[h >> 2] | 0) + 56 >> 2] | 0) + (c[j >> 2] << 2) >> 2] = b;
	                            if (!(c[(c[(c[h >> 2] | 0) + 56 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0))break b;
	                            c[(c[h >> 2] | 0) + 52 >> 2] = (c[j >> 2] | 0) + 1;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    dA(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function AA(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = c[g >> 2] | 0;
	                do if (!(c[(c[g >> 2] | 0) + 32 >> 2] | 0)) {
	                    c[d + 32 >> 2] = 8;
	                    b = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 32 >> 2] << 2) | 0;
	                    c[(c[g >> 2] | 0) + 40 >> 2] = b;
	                    if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                        Qz(c[f >> 2] | 0, 139256);
	                        c[(c[g >> 2] | 0) + 32 >> 2] = 0;
	                        i = e;
	                        return
	                    }
	                } else if ((c[d + 36 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 32 >> 2] | 0)) {
	                    b = (c[g >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = c[b >> 2] << 1;
	                    c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] << 2) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 40 >> 2] = c[j >> 2];
	                        break
	                    }
	                    Qz(c[f >> 2] | 0, 139256);
	                    b = (c[g >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) / 2 | 0;
	                    i = e;
	                    return
	                } while (0);
	                c[(c[(c[g >> 2] | 0) + 40 >> 2] | 0) + (c[(c[g >> 2] | 0) + 36 >> 2] << 2) >> 2] = c[h >> 2];
	                h = (c[g >> 2] | 0) + 36 | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + 1;
	                i = e;
	                return
	            }

	            function BA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                c[f >> 2] = GA(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[e >> 2] | 0, 139592)
	                }
	                HA(c[e >> 2] | 0) | 0;
	                c[d >> 2] = 1;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function CA(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                do switch (c[k >> 2] | 0) {
	                    case 128:
	                    {
	                        c[q >> 2] = HL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 104:
	                    {
	                        c[q >> 2] = mL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 109:
	                    {
	                        c[q >> 2] = sL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 108:
	                    {
	                        c[q >> 2] = rL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 10:
	                    {
	                        c[m >> 2] = ((c[m >> 2] | 0) != 0 ^ 1) & 1;
	                        r = 14;
	                        break
	                    }
	                    case 112:
	                    {
	                        c[q >> 2] = wL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 105:
	                    {
	                        c[q >> 2] = nL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 9:
	                    {
	                        r = 14;
	                        break
	                    }
	                    case 113:
	                    {
	                        c[q >> 2] = xL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 110:
	                    {
	                        c[q >> 2] = uL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 116:
	                    {
	                        c[q >> 2] = AL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 115:
	                    {
	                        c[q >> 2] = zL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 102:
	                    {
	                        c[q >> 2] = lL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[m >> 2] = ((c[m >> 2] | 0) != 0 ^ 1) & 1;
	                        r = 49;
	                        break
	                    }
	                    case 121:
	                    {
	                        c[q >> 2] = EL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 136:
	                    {
	                        c[q >> 2] = fL(c[l >> 2] | 0, c[p >> 2] | 0) | 0;
	                        break
	                    }
	                    case 134:
	                    {
	                        c[q >> 2] = jL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 135:
	                    {
	                        c[q >> 2] = 0;
	                        break
	                    }
	                    case 122:
	                    {
	                        c[q >> 2] = LL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 6:
	                    {
	                        if ((c[l >> 2] | 0) != 10)s = (c[l >> 2] | 0) != 13; else s = 0;
	                        c[q >> 2] = s & 1;
	                        break
	                    }
	                    case 13:
	                    {
	                        r = 47;
	                        break
	                    }
	                    case 111:
	                    {
	                        c[q >> 2] = vL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 11:
	                    {
	                        r = 27;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[m >> 2] = ((c[m >> 2] | 0) != 0 ^ 1) & 1;
	                        r = 27;
	                        break
	                    }
	                    case 107:
	                    {
	                        c[q >> 2] = tL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 123:
	                    {
	                        c[q >> 2] = OL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 7:
	                    {
	                        r = 10;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[m >> 2] = ((c[m >> 2] | 0) != 0 ^ 1) & 1;
	                        r = 10;
	                        break
	                    }
	                    case 2:
	                    {
	                        if ((c[l >> 2] | 0) >= (c[n >> 2] | 0))t = (c[l >> 2] | 0) <= (c[o >> 2] | 0); else t = 0;
	                        c[q >> 2] = t & 1;
	                        break
	                    }
	                    case 133:
	                    {
	                        c[q >> 2] = iL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 118:
	                    {
	                        c[q >> 2] = BL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 124:
	                    {
	                        c[q >> 2] = ML(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 131:
	                    {
	                        c[q >> 2] = gL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 132:
	                    {
	                        c[q >> 2] = hL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 100:
	                    {
	                        c[q >> 2] = kL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 103:
	                    {
	                        c[q >> 2] = oL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[m >> 2] = ((c[m >> 2] | 0) != 0 ^ 1) & 1;
	                        r = 47;
	                        break
	                    }
	                    case 1:
	                    case 3:
	                    case 4:
	                    case 5:
	                    {
	                        c[j >> 2] = -1;
	                        u = c[j >> 2] | 0;
	                        i = h;
	                        return u | 0
	                    }
	                    case 129:
	                    {
	                        c[q >> 2] = IL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 130:
	                    {
	                        c[q >> 2] = KL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 106:
	                    {
	                        c[q >> 2] = qL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 125:
	                    {
	                        c[q >> 2] = NL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 117:
	                    {
	                        c[q >> 2] = FL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 101:
	                    {
	                        c[q >> 2] = pL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 16:
	                    {
	                        r = 49;
	                        break
	                    }
	                    case 126:
	                    {
	                        c[q >> 2] = GL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 127:
	                    {
	                        c[q >> 2] = JL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 120:
	                    {
	                        c[q >> 2] = CL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 119:
	                    {
	                        c[q >> 2] = DL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    case 114:
	                    {
	                        c[q >> 2] = yL(c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                if ((r | 0) == 10) {
	                    if ((c[l >> 2] | 0) == 10 | (c[l >> 2] | 0) == 13 | (c[l >> 2] | 0) == 9)v = 1; else v = (c[l >> 2] | 0) == 32;
	                    c[q >> 2] = v & 1
	                } else if ((r | 0) == 14) {
	                    v = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 256)if (((!(65 <= (v | 0) & (c[l >> 2] | 0) <= 90) ? !(97 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 122) : 0) ? !(192 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 214) : 0) ? !(216 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 246 | 248 <= (c[l >> 2] | 0)) : 0)r = 20; else w = 1; else if (DQ(v, 199744) | 0)w = 1; else r = 20;
	                    do if ((r | 0) == 20) {
	                        v = c[l >> 2] | 0;
	                        if ((c[l >> 2] | 0) < 256) {
	                            if ((v | 0) == 95) {
	                                w = 1;
	                                break
	                            }
	                        } else {
	                            if (19968 <= (v | 0) & (c[l >> 2] | 0) <= 40869 | (c[l >> 2] | 0) == 12295) {
	                                w = 1;
	                                break
	                            }
	                            if (12321 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 12329 | (c[l >> 2] | 0) == 95) {
	                                w = 1;
	                                break
	                            }
	                        }
	                        w = (c[l >> 2] | 0) == 58
	                    } while (0);
	                    c[q >> 2] = w & 1
	                } else if ((r | 0) == 27) {
	                    w = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 256)if (((!(65 <= (w | 0) & (c[l >> 2] | 0) <= 90) ? !(97 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 122) : 0) ? !(192 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 214) : 0) ? !(216 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 246 | 248 <= (c[l >> 2] | 0)) : 0)r = 33; else x = 1; else if (DQ(w, 199744) | 0)x = 1; else r = 33;
	                    do if ((r | 0) == 33) {
	                        if ((c[l >> 2] | 0) >= 256) {
	                            if (19968 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 40869 | (c[l >> 2] | 0) == 12295) {
	                                x = 1;
	                                break
	                            }
	                            if (12321 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 12329) {
	                                x = 1;
	                                break
	                            }
	                        }
	                        w = c[l >> 2] | 0;
	                        if ((c[l >> 2] | 0) < 256) {
	                            if (48 <= (w | 0) & (c[l >> 2] | 0) <= 57 | (c[l >> 2] | 0) == 46 | (c[l >> 2] | 0) == 45 | (c[l >> 2] | 0) == 95 | (c[l >> 2] | 0) == 58) {
	                                x = 1;
	                                break
	                            }
	                        } else {
	                            v = (DQ(w, 200216) | 0) != 0;
	                            if (v | (c[l >> 2] | 0) == 46 | (c[l >> 2] | 0) == 45 | (c[l >> 2] | 0) == 95 | (c[l >> 2] | 0) == 58) {
	                                x = 1;
	                                break
	                            }
	                        }
	                        if ((c[l >> 2] | 0) >= 256 ? (DQ(c[l >> 2] | 0, 200144) | 0) != 0 : 0) {
	                            x = 1;
	                            break
	                        }
	                        v = c[l >> 2] | 0;
	                        if ((c[l >> 2] | 0) < 256)y = (v | 0) == 183 & 1; else y = DQ(v, 200272) | 0;
	                        x = (y | 0) != 0
	                    } while (0);
	                    c[q >> 2] = x & 1
	                } else if ((r | 0) == 47)c[q >> 2] = vL(c[l >> 2] | 0) | 0; else if ((r | 0) == 49) {
	                    c[q >> 2] = yL(c[l >> 2] | 0) | 0;
	                    if (!(c[q >> 2] | 0))c[q >> 2] = LL(c[l >> 2] | 0) | 0;
	                    if (!(c[q >> 2] | 0))c[q >> 2] = gL(c[l >> 2] | 0) | 0
	                }
	                l = c[q >> 2] | 0;
	                if (c[m >> 2] | 0) {
	                    c[j >> 2] = ((l | 0) != 0 ^ 1) & 1;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                } else {
	                    c[j >> 2] = l;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                return 0
	            }

	            function DA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[f >> 2] | 0) == 1 | (c[f >> 2] | 0) == 2 | (c[f >> 2] | 0) == 3 | (c[f >> 2] | 0) == 4 | (c[f >> 2] | 0) == 5 | (c[f >> 2] | 0) == 6)c[e >> 2] = 1; else {
	                    if ((c[g >> 2] | 0) == 1 | (c[g >> 2] | 0) == 2 | (c[g >> 2] | 0) == 3 | (c[g >> 2] | 0) == 4 | (c[g >> 2] | 0) == 5 | (c[g >> 2] | 0) == 6) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) >>> 0 > (c[g >> 2] | 0) >>> 0) {
	                        c[h >> 2] = c[f >> 2];
	                        c[f >> 2] = c[g >> 2];
	                        c[g >> 2] = c[h >> 2]
	                    }
	                    b:do switch (c[f >> 2] | 0) {
	                        case 100:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 105) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 132:
	                        case 133:
	                        case 134:
	                        case 135:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 126:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 130) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 106:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 109) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 13:
	                        {
	                            if ((((((!((c[g >> 2] | 0) == 14 | (c[g >> 2] | 0) == 15) ? !((c[g >> 2] | 0) >>> 0 >= 100 & (c[g >> 2] | 0) >>> 0 <= 105) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 106 & (c[g >> 2] | 0) >>> 0 <= 109) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 114 & (c[g >> 2] | 0) >>> 0 <= 121) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 122 & (c[g >> 2] | 0) >>> 0 <= 125) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 126 & (c[g >> 2] | 0) >>> 0 <= 130) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 131 & (c[g >> 2] | 0) >>> 0 <= 135) : 0)break b;
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 131:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 135) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 15:
	                        {
	                            if ((((((c[g >> 2] | 0) != 14 ? !((c[g >> 2] | 0) >>> 0 >= 106 & (c[g >> 2] | 0) >>> 0 <= 109) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 114 & (c[g >> 2] | 0) >>> 0 <= 121) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 122 & (c[g >> 2] | 0) >>> 0 <= 125) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 126 & (c[g >> 2] | 0) >>> 0 <= 130) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 131 & (c[g >> 2] | 0) >>> 0 <= 135) : 0)break b;
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 7:
	                        {
	                            if ((((((c[g >> 2] | 0) != 8 ? !((c[g >> 2] | 0) >>> 0 >= 100 & (c[g >> 2] | 0) >>> 0 <= 105) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 110 & (c[g >> 2] | 0) >>> 0 <= 113) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 106 & (c[g >> 2] | 0) >>> 0 <= 109) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 114 & (c[g >> 2] | 0) >>> 0 <= 121) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 126 & (c[g >> 2] | 0) >>> 0 <= 130) : 0)break b;
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 125:
	                        case 124:
	                        case 123:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 105:
	                        case 104:
	                        case 103:
	                        case 102:
	                        case 101:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 11:
	                        {
	                            if ((((((c[g >> 2] | 0) != 12 ? !((c[g >> 2] | 0) >>> 0 >= 106 & (c[g >> 2] | 0) >>> 0 <= 109) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 114 & (c[g >> 2] | 0) >>> 0 <= 121) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 122 & (c[g >> 2] | 0) >>> 0 <= 125) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 126 & (c[g >> 2] | 0) >>> 0 <= 130) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 131 & (c[g >> 2] | 0) >>> 0 <= 135) : 0)break b;
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 110:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 113) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 121:
	                        case 120:
	                        case 119:
	                        case 118:
	                        case 117:
	                        case 116:
	                        case 115:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 9:
	                        {
	                            if (((((((c[g >> 2] | 0) != 10 ? !((c[g >> 2] | 0) >>> 0 >= 110 & (c[g >> 2] | 0) >>> 0 <= 113) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 106 & (c[g >> 2] | 0) >>> 0 <= 109) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 122 & (c[g >> 2] | 0) >>> 0 <= 125) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 114 & (c[g >> 2] | 0) >>> 0 <= 121) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 126 & (c[g >> 2] | 0) >>> 0 <= 130) : 0) ? !((c[g >> 2] | 0) >>> 0 >= 131 & (c[g >> 2] | 0) >>> 0 <= 135) : 0)break b;
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 122:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 125) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 114:
	                        {
	                            if ((c[g >> 2] | 0) >>> 0 <= 121) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 130:
	                        case 129:
	                        case 128:
	                        case 127:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 113:
	                        case 112:
	                        case 111:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 109:
	                        case 108:
	                        case 107:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    c[e >> 2] = 1
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function EA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 > (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0) {
	                        c[j >> 2] = c[f >> 2];
	                        c[f >> 2] = c[g >> 2];
	                        c[g >> 2] = c[j >> 2]
	                    }
	                    a:do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 6 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 6 : 0) {
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) {
	                            j = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                                if ((j | 0) != 2) {
	                                    c[h >> 2] = 1;
	                                    break
	                                }
	                                if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                                    c[h >> 2] = 1;
	                                    break
	                                }
	                                c[h >> 2] = 0;
	                                break
	                            }
	                            if ((j | 0) == 2) {
	                                c[l >> 2] = 0;
	                                if ((c[c[f >> 2] >> 2] | 0) == 0 ? (c[c[g >> 2] >> 2] | 0) != 0 : 0)m = 28; else m = 26;
	                                if (((m | 0) == 26 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) ? (c[c[g >> 2] >> 2] | 0) == 0 : 0)m = 28;
	                                if ((m | 0) == 28)c[l >> 2] = 1;
	                                c[k >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                                while (1) {
	                                    if ((c[k >> 2] | 0) > (c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                                        m = 37;
	                                        break
	                                    }
	                                    c[h >> 2] = CA(c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0, 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                    if ((c[h >> 2] | 0) < 0) {
	                                        m = 32;
	                                        break
	                                    }
	                                    if ((c[l >> 2] | 0) == 1 & (c[h >> 2] | 0) == 0) {
	                                        m = 35;
	                                        break
	                                    }
	                                    if ((c[l >> 2] | 0) == 0 & (c[h >> 2] | 0) == 1) {
	                                        m = 35;
	                                        break
	                                    }
	                                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                                }
	                                if ((m | 0) == 32) {
	                                    c[e >> 2] = -1;
	                                    n = c[e >> 2] | 0;
	                                    i = d;
	                                    return n | 0
	                                } else if ((m | 0) == 35) {
	                                    c[e >> 2] = 1;
	                                    n = c[e >> 2] | 0;
	                                    i = d;
	                                    return n | 0
	                                } else if ((m | 0) == 37) {
	                                    c[e >> 2] = 0;
	                                    n = c[e >> 2] | 0;
	                                    i = d;
	                                    return n | 0
	                                }
	                            }
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 136 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 136 : 0) {
	                                do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) >>> 0 >= 100) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 100)break;
	                                    c[h >> 2] = 0;
	                                    switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                                        case 106:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 107) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 108)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 109)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        case 110:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 111) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 112)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 113)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        case 114:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 115) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 116)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 117)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 118)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 119)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 120)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 121)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        case 100:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 101) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 102)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 103)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 104)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 105)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        case 131:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 132) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 133)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 134)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        case 126:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 127) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 128)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 129)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 130)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        case 122:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 123) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 124)break;
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 125)break a
	                                            } while (0);
	                                            c[h >> 2] = 1;
	                                            break a;
	                                            break
	                                        }
	                                        default:
	                                        {
	                                            do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 >= 100) {
	                                                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 >= 136)break;
	                                                c[h >> 2] = 0;
	                                                break a
	                                            } while (0);
	                                            c[e >> 2] = 1;
	                                            n = c[e >> 2] | 0;
	                                            i = d;
	                                            return n | 0
	                                        }
	                                    }
	                                } while (0);
	                                do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 7) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 8)break;
	                                    c[h >> 2] = 0;
	                                    break a
	                                } while (0);
	                                do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 9) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 10)break;
	                                    c[h >> 2] = 0;
	                                    break a
	                                } while (0);
	                                do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 11) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 12)break;
	                                    c[h >> 2] = 0;
	                                    break a
	                                } while (0);
	                                do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 14)break;
	                                    c[h >> 2] = 0;
	                                    break a
	                                } while (0);
	                                do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 15) {
	                                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 16)break;
	                                    c[h >> 2] = 0;
	                                    break a
	                                } while (0);
	                                c[e >> 2] = 1;
	                                n = c[e >> 2] | 0;
	                                i = d;
	                                return n | 0
	                            }
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                                c[h >> 2] = qy(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                break
	                            }
	                            c[e >> 2] = 1;
	                            n = c[e >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } else m = 12; while (0);
	                    if ((m | 0) == 12)c[h >> 2] = 1;
	                    if ((c[c[f >> 2] >> 2] | 0) == 0 ? (c[c[g >> 2] >> 2] | 0) != 0 : 0)m = 105; else m = 103;
	                    if (((m | 0) == 103 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) ? (c[c[g >> 2] >> 2] | 0) == 0 : 0)m = 105;
	                    if ((m | 0) == 105)c[h >> 2] = ((c[h >> 2] | 0) != 0 ^ 1) & 1;
	                    c[e >> 2] = c[h >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[e >> 2] = -1;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function FA(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = IA(c[f >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 ? (b = my(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0, c[(c[h >> 2] | 0) + 16 >> 2] = b, (c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 0) : 0) {
	                    Qz(c[f >> 2] | 0, 139336);
	                    yA(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function GA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b;
	                c[f >> 2] = a;
	                c[g >> 2] = JA(c[f >> 2] | 0) | 0;
	                a = c[f >> 2] | 0;
	                if ((c[g >> 2] | 0) > 0) {
	                    m = eA(a, 2) | 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = m;
	                    if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    } else {
	                        c[g >> 2] = oe(0, c[(c[f >> 2] | 0) + 4 >> 2] | 0, h) | 0;
	                        c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                        g = (c[f >> 2] | 0) + 4 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                        c[e >> 2] = 1;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                }
	                if ((d[c[a + 4 >> 2] >> 0] | 0 | 0) == 124) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                if (!(d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 41) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                a = (c[f >> 2] | 0) + 4 | 0;
	                h = c[a >> 2] | 0;
	                if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 40) {
	                    if (((d[h >> 0] | 0 | 0) != 91 ? (d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 92 : 0) ? (d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 46 : 0) {
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    KA(c[f >> 2] | 0);
	                    c[e >> 2] = 1;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[a >> 2] = h + 1;
	                jA(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0, 0);
	                c[l >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                jA(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0, 0);
	                c[j >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                c[k >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                Xz(c[f >> 2] | 0, 0);
	                h = c[f >> 2] | 0;
	                if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 41) {
	                    a = h + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                } else {
	                    c[h + 8 >> 2] = 1450;
	                    Yz(c[f >> 2] | 0, 139672)
	                }
	                h = eA(c[f >> 2] | 0, 4) | 0;
	                c[(c[f >> 2] | 0) + 28 >> 2] = h;
	                if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                } else {
	                    c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 36 >> 2] = c[j >> 2];
	                    c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 40 >> 2] = c[l >> 2];
	                    c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 44 >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                    c[(c[f >> 2] | 0) + 20 >> 2] = c[k >> 2];
	                    c[e >> 2] = 1;
	                    n = c[e >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                return 0
	            }

	            function HA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[g >> 2] = d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0];
	                if ((c[g >> 2] | 0) == 63 | (c[g >> 2] | 0) == 42 | (c[g >> 2] | 0) == 43) {
	                    do if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                        if ((c[g >> 2] | 0) == 63) {
	                            c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] = 3;
	                            break
	                        }
	                        if ((c[g >> 2] | 0) == 42) {
	                            c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] = 4;
	                            break
	                        }
	                        if ((c[g >> 2] | 0) == 43)c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] = 5
	                    } while (0);
	                    a = (c[f >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                if ((c[g >> 2] | 0) != 123) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                a = (c[f >> 2] | 0) + 4 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                c[g >> 2] = LA(c[f >> 2] | 0) | 0;
	                if ((c[g >> 2] | 0) >= 0)c[h >> 2] = c[g >> 2];
	                do if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 44) {
	                    a = (c[f >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 125) {
	                        c[j >> 2] = 2147483647;
	                        break
	                    }
	                    c[g >> 2] = LA(c[f >> 2] | 0) | 0;
	                    if ((c[g >> 2] | 0) >= 0) {
	                        c[j >> 2] = c[g >> 2];
	                        break
	                    } else {
	                        c[(c[f >> 2] | 0) + 8 >> 2] = 1450;
	                        Yz(c[f >> 2] | 0, 139624);
	                        break
	                    }
	                } while (0);
	                g = c[f >> 2] | 0;
	                if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 125) {
	                    a = g + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                } else {
	                    c[g + 8 >> 2] = 1450;
	                    Yz(c[f >> 2] | 0, 139648)
	                }
	                if (!(c[j >> 2] | 0))c[j >> 2] = c[h >> 2];
	                if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                    c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] = 8;
	                    c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                    c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] = c[j >> 2]
	                }
	                c[e >> 2] = 1;
	                k = c[e >> 2] | 0;
	                i = b;
	                return k | 0
	            }

	            function IA(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    Qz(c[j >> 2] | 0, 139336);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } else {
	                    c[c[o >> 2] >> 2] = c[k >> 2];
	                    c[(c[o >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                    c[(c[o >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                    c[(c[o >> 2] | 0) + 12 >> 2] = c[n >> 2];
	                    c[h >> 2] = c[o >> 2];
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                return 0
	            }

	            function JA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                c[e >> 2] = a;
	                c[f >> 2] = oe(0, c[(c[e >> 2] | 0) + 4 >> 2] | 0, b) | 0;
	                if ((c[f >> 2] | 0) == 46 | (c[f >> 2] | 0) == 92 | (c[f >> 2] | 0) == 63 | (c[f >> 2] | 0) == 42 | (c[f >> 2] | 0) == 43 | (c[f >> 2] | 0) == 40 | (c[f >> 2] | 0) == 41 | (c[f >> 2] | 0) == 124 | (c[f >> 2] | 0) == 91 | (c[f >> 2] | 0) == 93 | (c[f >> 2] | 0) == 0) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function KA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 91) {
	                    NA(a);
	                    i = b;
	                    return
	                }
	                f = a + 4 | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                f = eA(c[e >> 2] | 0, 3) | 0;
	                c[(c[e >> 2] | 0) + 28 >> 2] = f;
	                if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                MA(c[e >> 2] | 0);
	                f = c[e >> 2] | 0;
	                if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 93) {
	                    a = f + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    i = b;
	                    return
	                } else {
	                    c[f + 8 >> 2] = 1450;
	                    Yz(c[e >> 2] | 0, 139704);
	                    i = b;
	                    return
	                }
	            }

	            function LA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                while (1) {
	                    if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) < 48)break;
	                    if ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) > 57)break;
	                    c[g >> 2] = ((c[g >> 2] | 0) * 10 | 0) + ((d[c[(c[f >> 2] | 0) + 4 >> 2] >> 0] | 0) - 48);
	                    c[h >> 2] = 1;
	                    a = (c[f >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                if ((c[h >> 2] | 0) != 1) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else {
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function MA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 93) {
	                        j = 13;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        j = 13;
	                        break
	                    }
	                    a = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 94) {
	                        c[g >> 2] = c[a + 12 >> 2];
	                        k = (c[e >> 2] | 0) + 4 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        c[(c[e >> 2] | 0) + 12 >> 2] = ((c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 ^ 1) & 1;
	                        OA(c[e >> 2] | 0);
	                        c[(c[e >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                        continue
	                    }
	                    if ((d[c[a + 4 >> 2] >> 0] | 0 | 0) == 45 ? (d[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + 1 >> 0] | 0 | 0) == 91 : 0) {
	                        j = 8;
	                        break
	                    }
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 93)continue;
	                    OA(c[e >> 2] | 0)
	                }
	                if ((j | 0) == 8) {
	                    c[h >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                    c[(c[e >> 2] | 0) + 12 >> 2] = 2;
	                    g = (c[e >> 2] | 0) + 4 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    g = (c[e >> 2] | 0) + 4 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    MA(c[e >> 2] | 0);
	                    g = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 93) {
	                        a = g + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[(c[e >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                        l = c[f >> 2] | 0;
	                        m = c[e >> 2] | 0;
	                        n = m + 12 | 0;
	                        c[n >> 2] = l;
	                        i = b;
	                        return
	                    } else {
	                        c[g + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139968);
	                        l = c[f >> 2] | 0;
	                        m = c[e >> 2] | 0;
	                        n = m + 12 | 0;
	                        c[n >> 2] = l;
	                        i = b;
	                        return
	                    }
	                } else if ((j | 0) == 13) {
	                    l = c[f >> 2] | 0;
	                    m = c[e >> 2] | 0;
	                    n = m + 12 | 0;
	                    c[n >> 2] = l;
	                    i = b;
	                    return
	                }
	            }

	            function NA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 46) {
	                    h = c[e >> 2] | 0;
	                    if (c[a + 28 >> 2] | 0) {
	                        if ((c[(c[h + 28 >> 2] | 0) + 4 >> 2] | 0) == 3)PA(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 28 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, 6, 0, 0, 0)
	                    } else {
	                        j = eA(h, 6) | 0;
	                        c[(c[e >> 2] | 0) + 28 >> 2] = j
	                    }
	                    j = (c[e >> 2] | 0) + 4 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    i = b;
	                    return
	                }
	                j = c[e >> 2] | 0;
	                if ((d[c[a + 4 >> 2] >> 0] | 0 | 0) != 92) {
	                    c[j + 8 >> 2] = 1450;
	                    Yz(c[e >> 2] | 0, 139744);
	                    i = b;
	                    return
	                }
	                a = j + 4 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                if ((c[f >> 2] | 0) == 112) {
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    a = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 123) {
	                        c[a + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139776);
	                        i = b;
	                        return
	                    }
	                    j = a + 4 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    QA(c[e >> 2] | 0);
	                    j = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 125) {
	                        c[j + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139792);
	                        i = b;
	                        return
	                    } else {
	                        a = j + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        i = b;
	                        return
	                    }
	                }
	                if ((c[f >> 2] | 0) == 80) {
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    a = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 123) {
	                        c[a + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139776);
	                        i = b;
	                        return
	                    }
	                    j = a + 4 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    QA(c[e >> 2] | 0);
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != 125) {
	                        c[j + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139792);
	                        i = b;
	                        return
	                    } else {
	                        a = j + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        i = b;
	                        return
	                    }
	                }
	                if ((c[f >> 2] | 0) == 110 | (c[f >> 2] | 0) == 114 | (c[f >> 2] | 0) == 116 | (c[f >> 2] | 0) == 92 | (c[f >> 2] | 0) == 124 | (c[f >> 2] | 0) == 46 | (c[f >> 2] | 0) == 63 | (c[f >> 2] | 0) == 42 | (c[f >> 2] | 0) == 43 | (c[f >> 2] | 0) == 40 | (c[f >> 2] | 0) == 41 | (c[f >> 2] | 0) == 123 | (c[f >> 2] | 0) == 125 | (c[f >> 2] | 0) == 45 | (c[f >> 2] | 0) == 91 | (c[f >> 2] | 0) == 93 | (c[f >> 2] | 0) == 94) {
	                    a = c[e >> 2] | 0;
	                    do if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                        j = eA(a, 2) | 0;
	                        c[(c[e >> 2] | 0) + 28 >> 2] = j;
	                        if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                            j = c[f >> 2] | 0;
	                            if ((j | 0) == 116) {
	                                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 32 >> 2] = 9;
	                                break
	                            } else if ((j | 0) == 110) {
	                                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 32 >> 2] = 10;
	                                break
	                            } else if ((j | 0) == 114) {
	                                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 32 >> 2] = 13;
	                                break
	                            } else {
	                                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                                break
	                            }
	                        }
	                    } else if ((c[(c[a + 28 >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                        j = c[f >> 2] | 0;
	                        if ((j | 0) == 110)c[f >> 2] = 10; else if ((j | 0) == 114)c[f >> 2] = 13; else if ((j | 0) == 116)c[f >> 2] = 9;
	                        PA(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 28 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, 2, c[f >> 2] | 0, c[f >> 2] | 0, 0)
	                    } while (0);
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    i = b;
	                    return
	                }
	                if (!((c[f >> 2] | 0) == 115 | (c[f >> 2] | 0) == 83 | (c[f >> 2] | 0) == 105 | (c[f >> 2] | 0) == 73 | (c[f >> 2] | 0) == 99 | (c[f >> 2] | 0) == 67 | (c[f >> 2] | 0) == 100 | (c[f >> 2] | 0) == 68 | (c[f >> 2] | 0) == 119 | (c[f >> 2] | 0) == 87)) {
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[e >> 2] | 0, 139808);
	                    i = b;
	                    return
	                }
	                c[g >> 2] = 7;
	                do switch (c[f >> 2] | 0) {
	                    case 115:
	                    {
	                        c[g >> 2] = 7;
	                        break
	                    }
	                    case 83:
	                    {
	                        c[g >> 2] = 8;
	                        break
	                    }
	                    case 99:
	                    {
	                        c[g >> 2] = 11;
	                        break
	                    }
	                    case 67:
	                    {
	                        c[g >> 2] = 12;
	                        break
	                    }
	                    case 119:
	                    {
	                        c[g >> 2] = 15;
	                        break
	                    }
	                    case 87:
	                    {
	                        c[g >> 2] = 16;
	                        break
	                    }
	                    case 105:
	                    {
	                        c[g >> 2] = 9;
	                        break
	                    }
	                    case 73:
	                    {
	                        c[g >> 2] = 10;
	                        break
	                    }
	                    case 100:
	                    {
	                        c[g >> 2] = 13;
	                        break
	                    }
	                    case 68:
	                    {
	                        c[g >> 2] = 14;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                f = (c[e >> 2] | 0) + 4 | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                f = c[e >> 2] | 0;
	                if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                    a = eA(f, c[g >> 2] | 0) | 0;
	                    c[(c[e >> 2] | 0) + 28 >> 2] = a;
	                    i = b;
	                    return
	                }
	                if ((c[(c[f + 28 >> 2] | 0) + 4 >> 2] | 0) != 3) {
	                    i = b;
	                    return
	                }
	                PA(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 28 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0, 0, 0, 0);
	                i = b;
	                return
	            }

	            function OA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    a = c[e >> 2] | 0;
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 92)NA(a); else RA(a);
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 93) {
	                        f = 10;
	                        break
	                    }
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 94) {
	                        f = 10;
	                        break
	                    }
	                    if ((d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == 45) {
	                        f = 10;
	                        break
	                    }
	                    if (!(d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0)) {
	                        f = 10;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        f = 10;
	                        break
	                    }
	                }
	                if ((f | 0) == 10) {
	                    i = b;
	                    return
	                }
	            }

	            function PA(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 20 | 0;
	                o = j + 16 | 0;
	                p = j + 12 | 0;
	                q = j + 8 | 0;
	                r = j + 4 | 0;
	                s = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                if (!(c[l >> 2] | 0)) {
	                    c[(c[k >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[k >> 2] | 0, 139896);
	                    i = j;
	                    return
	                }
	                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 3) {
	                    c[(c[k >> 2] | 0) + 8 >> 2] = 1450;
	                    Yz(c[k >> 2] | 0, 139920);
	                    i = j;
	                    return
	                }
	                h = c[l >> 2] | 0;
	                do if (!(c[(c[l >> 2] | 0) + 48 >> 2] | 0)) {
	                    c[h + 48 >> 2] = 4;
	                    g = Cb[c[135744 >> 2] & 511](c[(c[l >> 2] | 0) + 48 >> 2] << 2) | 0;
	                    c[(c[l >> 2] | 0) + 56 >> 2] = g;
	                    if (!(c[(c[l >> 2] | 0) + 56 >> 2] | 0)) {
	                        Qz(c[k >> 2] | 0, 139952);
	                        c[(c[l >> 2] | 0) + 48 >> 2] = 0;
	                        i = j;
	                        return
	                    }
	                } else if ((c[h + 52 >> 2] | 0) >= (c[(c[l >> 2] | 0) + 48 >> 2] | 0)) {
	                    g = (c[l >> 2] | 0) + 48 | 0;
	                    c[g >> 2] = c[g >> 2] << 1;
	                    c[s >> 2] = Hb[c[135760 >> 2] & 511](c[(c[l >> 2] | 0) + 56 >> 2] | 0, c[(c[l >> 2] | 0) + 48 >> 2] << 2) | 0;
	                    if (c[s >> 2] | 0) {
	                        c[(c[l >> 2] | 0) + 56 >> 2] = c[s >> 2];
	                        break
	                    }
	                    Qz(c[k >> 2] | 0, 139952);
	                    g = (c[l >> 2] | 0) + 48 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) / 2 | 0;
	                    i = j;
	                    return
	                } while (0);
	                c[r >> 2] = IA(c[k >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    i = j;
	                    return
	                }
	                c[(c[r >> 2] | 0) + 16 >> 2] = c[q >> 2];
	                q = c[r >> 2] | 0;
	                r = (c[l >> 2] | 0) + 52 | 0;
	                p = c[r >> 2] | 0;
	                c[r >> 2] = p + 1;
	                c[(c[(c[l >> 2] | 0) + 56 >> 2] | 0) + (p << 2) >> 2] = q;
	                i = j;
	                return
	            }

	            function QA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                do if ((c[f >> 2] | 0) == 76) {
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                    if ((c[f >> 2] | 0) == 117) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[g >> 2] = 101;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) == 108) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[g >> 2] = 102;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) == 116) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[g >> 2] = 103;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) == 109) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[g >> 2] = 104;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) == 111) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[g >> 2] = 105;
	                        break
	                    } else {
	                        c[g >> 2] = 100;
	                        break
	                    }
	                } else {
	                    if ((c[f >> 2] | 0) == 77) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        if ((c[f >> 2] | 0) == 110) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 107;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 99) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 108;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 101) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 109;
	                            break
	                        } else {
	                            c[g >> 2] = 106;
	                            break
	                        }
	                    }
	                    if ((c[f >> 2] | 0) == 78) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        if ((c[f >> 2] | 0) == 100) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 111;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 108) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 112;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 111) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 113;
	                            break
	                        } else {
	                            c[g >> 2] = 110;
	                            break
	                        }
	                    }
	                    if ((c[f >> 2] | 0) == 80) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        if ((c[f >> 2] | 0) == 99) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 115;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 100) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 116;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 115) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 117;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 101) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 118;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 105) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 119;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 102) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 120;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 111) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 121;
	                            break
	                        } else {
	                            c[g >> 2] = 114;
	                            break
	                        }
	                    }
	                    if ((c[f >> 2] | 0) == 90) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        if ((c[f >> 2] | 0) == 115) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 123;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 108) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 124;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 112) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 125;
	                            break
	                        } else {
	                            c[g >> 2] = 122;
	                            break
	                        }
	                    }
	                    if ((c[f >> 2] | 0) == 83) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        if ((c[f >> 2] | 0) == 109) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 127;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 99) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 128;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 107) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 129;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 111) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 130;
	                            break
	                        } else {
	                            c[g >> 2] = 126;
	                            break
	                        }
	                    }
	                    if ((c[f >> 2] | 0) == 67) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        if ((c[f >> 2] | 0) == 99) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 132;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 102) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 133;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 111) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 134;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == 110) {
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[g >> 2] = 135;
	                            break
	                        } else {
	                            c[g >> 2] = 131;
	                            break
	                        }
	                    }
	                    a = c[e >> 2] | 0;
	                    if ((c[f >> 2] | 0) != 73) {
	                        c[a + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139872);
	                        i = b;
	                        return
	                    }
	                    k = a + 4 | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                    k = c[e >> 2] | 0;
	                    if ((c[f >> 2] | 0) != 115) {
	                        c[k + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 139856);
	                        i = b;
	                        return
	                    }
	                    a = k + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[j >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                    if (!((!((c[f >> 2] | 0) >= 97 & (c[f >> 2] | 0) <= 122) ? !((c[f >> 2] | 0) >= 65 & (c[f >> 2] | 0) <= 90) : 0) ? !((c[f >> 2] | 0) >= 48 & (c[f >> 2] | 0) <= 57 | (c[f >> 2] | 0) == 45) : 0))l = 79;
	                    a:do if ((l | 0) == 79) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        while (1) {
	                            if ((!((c[f >> 2] | 0) >= 97 & (c[f >> 2] | 0) <= 122) ? !((c[f >> 2] | 0) >= 65 & (c[f >> 2] | 0) <= 90) : 0) ? !((c[f >> 2] | 0) >= 48 & (c[f >> 2] | 0) <= 57 | (c[f >> 2] | 0) == 45) : 0)break a;
	                            a = (c[e >> 2] | 0) + 4 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0]
	                        }
	                    } while (0);
	                    c[g >> 2] = 136;
	                    c[h >> 2] = ly(c[j >> 2] | 0, (c[(c[e >> 2] | 0) + 4 >> 2] | 0) - (c[j >> 2] | 0) | 0) | 0
	                } while (0);
	                j = c[e >> 2] | 0;
	                if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                    f = eA(j, c[g >> 2] | 0) | 0;
	                    c[(c[e >> 2] | 0) + 28 >> 2] = f;
	                    if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                    i = b;
	                    return
	                } else {
	                    if ((c[(c[j + 28 >> 2] | 0) + 4 >> 2] | 0) != 3) {
	                        i = b;
	                        return
	                    }
	                    PA(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 28 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0, 0, 0, c[h >> 2] | 0);
	                    i = b;
	                    return
	                }
	            }

	            function RA(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                c[h >> 2] = -1;
	                c[j >> 2] = -1;
	                a = c[e >> 2] | 0;
	                if (!(d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0] | 0)) {
	                    c[a + 8 >> 2] = 1450;
	                    Yz(c[e >> 2] | 0, 14e4);
	                    i = b;
	                    return
	                }
	                c[f >> 2] = d[c[a + 4 >> 2] >> 0];
	                do if ((c[f >> 2] | 0) == 92) {
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                    switch (c[f >> 2] | 0) {
	                        case 93:
	                        case 91:
	                        case 41:
	                        case 40:
	                        case 125:
	                        case 123:
	                        case 43:
	                        case 42:
	                        case 63:
	                        case 94:
	                        case 45:
	                        case 46:
	                        case 124:
	                        case 92:
	                        {
	                            c[h >> 2] = c[f >> 2];
	                            break
	                        }
	                        case 114:
	                        {
	                            c[h >> 2] = 13;
	                            break
	                        }
	                        case 116:
	                        {
	                            c[h >> 2] = 9;
	                            break
	                        }
	                        case 110:
	                        {
	                            c[h >> 2] = 10;
	                            break
	                        }
	                        default:
	                        {
	                            c[(c[e >> 2] | 0) + 8 >> 2] = 1450;
	                            Yz(c[e >> 2] | 0, 140016);
	                            i = b;
	                            return
	                        }
	                    }
	                    c[j >> 2] = c[h >> 2];
	                    c[g >> 2] = 1
	                } else {
	                    a = c[e >> 2] | 0;
	                    if ((c[f >> 2] | 0) != 91 & (c[f >> 2] | 0) != 93) {
	                        k = oe(0, c[a + 4 >> 2] | 0, g) | 0;
	                        c[h >> 2] = k;
	                        c[j >> 2] = k;
	                        break
	                    }
	                    c[a + 8 >> 2] = 1450;
	                    Yz(c[e >> 2] | 0, 140040);
	                    i = b;
	                    return
	                } while (0);
	                if ((((c[h >> 2] | 0) == 45 ? (d[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + 1 >> 0] | 0 | 0) != 93 : 0) ? (d[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + -1 >> 0] | 0 | 0) != 91 : 0) ? (d[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + -1 >> 0] | 0 | 0) != 94 : 0) {
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + (c[g >> 2] | 0);
	                    i = b;
	                    return
	                }
	                a = (c[e >> 2] | 0) + 4 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + (c[g >> 2] | 0);
	                c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                if ((c[f >> 2] | 0) == 45 ? (d[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + 1 >> 0] | 0 | 0) != 93 : 0) {
	                    a = (c[e >> 2] | 0) + 4 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                    do if ((c[f >> 2] | 0) == 92) {
	                        a = (c[e >> 2] | 0) + 4 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[f >> 2] = d[c[(c[e >> 2] | 0) + 4 >> 2] >> 0];
	                        switch (c[f >> 2] | 0) {
	                            case 93:
	                            case 91:
	                            case 41:
	                            case 40:
	                            case 125:
	                            case 123:
	                            case 43:
	                            case 42:
	                            case 63:
	                            case 94:
	                            case 45:
	                            case 46:
	                            case 124:
	                            case 92:
	                            {
	                                c[j >> 2] = c[f >> 2];
	                                break
	                            }
	                            case 110:
	                            {
	                                c[j >> 2] = 10;
	                                break
	                            }
	                            case 114:
	                            {
	                                c[j >> 2] = 13;
	                                break
	                            }
	                            case 116:
	                            {
	                                c[j >> 2] = 9;
	                                break
	                            }
	                            default:
	                            {
	                                c[(c[e >> 2] | 0) + 8 >> 2] = 1450;
	                                Yz(c[e >> 2] | 0, 140016);
	                                i = b;
	                                return
	                            }
	                        }
	                        c[g >> 2] = 1
	                    } else {
	                        a = c[e >> 2] | 0;
	                        if ((c[f >> 2] | 0) != 91 & (c[f >> 2] | 0) != 93) {
	                            c[j >> 2] = oe(0, c[a + 4 >> 2] | 0, g) | 0;
	                            break
	                        }
	                        c[a + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 140064);
	                        i = b;
	                        return
	                    } while (0);
	                    f = (c[e >> 2] | 0) + 4 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + (c[g >> 2] | 0);
	                    g = c[e >> 2] | 0;
	                    if ((c[j >> 2] | 0) < (c[h >> 2] | 0)) {
	                        c[g + 8 >> 2] = 1450;
	                        Yz(c[e >> 2] | 0, 140104);
	                        i = b;
	                        return
	                    } else {
	                        PA(g, c[(c[e >> 2] | 0) + 28 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, 2, c[h >> 2] | 0, c[j >> 2] | 0, 0);
	                        i = b;
	                        return
	                    }
	                }
	                PA(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 28 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, 2, c[h >> 2] | 0, c[j >> 2] | 0, 0);
	                i = b;
	                return
	            }

	            function SA() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0, g = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](40) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    f = (c[d >> 2] | 0) + 0 | 0;
	                    g = f + 40 | 0;
	                    do {
	                        c[f >> 2] = 0;
	                        f = f + 4 | 0
	                    } while ((f | 0) < (g | 0));
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function TA(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)nB(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 36 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 36 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function UA(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)PH(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 36 >> 2] | 0)zz(c[(c[d >> 2] | 0) + 36 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function VA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                a:do if (c[(c[d >> 2] | 0) + 68 >> 2] | 0) {
	                    c[e >> 2] = c[(c[d >> 2] | 0) + 68 >> 2];
	                    while (1) {
	                        if (!(c[e >> 2] | 0))break a;
	                        c[f >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                        UA(c[e >> 2] | 0);
	                        c[e >> 2] = c[f >> 2]
	                    }
	                } while (0);
	                if (c[(c[d >> 2] | 0) + 116 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 116 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 92 >> 2] | 0)pB(c[(c[d >> 2] | 0) + 92 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 96 >> 2] | 0) {
	                    c[h >> 2] = c[(c[d >> 2] | 0) + 96 >> 2];
	                    do {
	                        c[g >> 2] = c[c[h >> 2] >> 2];
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[h >> 2] = c[g >> 2]
	                    } while ((c[h >> 2] | 0) != 0)
	                }
	                if (c[(c[d >> 2] | 0) + 108 >> 2] | 0)zz(c[(c[d >> 2] | 0) + 108 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function WA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 80 >> 2] | 0) {
	                    a = c[33976] | 0;
	                    h = c[33980] | 0;
	                    c[d >> 2] = 140328;
	                    c[d + 4 >> 2] = 4118;
	                    Db[a & 511](h, 140296, d)
	                }
	                if (c[(c[e >> 2] | 0) + 44 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 44 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 32 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 32 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 36 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 40 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 40 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 28 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 28 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 56 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 56 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 76 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 76 >> 2] | 0, 0);
	                if (c[(c[e >> 2] | 0) + 48 >> 2] | 0)Kj(c[(c[e >> 2] | 0) + 48 >> 2] | 0, 322);
	                if (c[(c[e >> 2] | 0) + 64 >> 2] | 0) {
	                    c[f >> 2] = c[(c[e >> 2] | 0) + 64 >> 2];
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                        qB(c[(c[c[f >> 2] >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    oB(c[f >> 2] | 0)
	                }
	                if (c[(c[e >> 2] | 0) + 20 >> 2] | 0)mB(c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                zP(c[(c[e >> 2] | 0) + 60 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function XA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = rB() | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = xP() | 0;
	                    c[(c[f >> 2] | 0) + 80 >> 2] = a;
	                    a = AP(c[(c[f >> 2] | 0) + 80 >> 2] | 0, c[e >> 2] | 0, -1) | 0;
	                    c[(c[f >> 2] | 0) + 44 >> 2] = a;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function YA(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 52 >> 2] | 0) == 0 : 0)Th(c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 92 >> 2] | 0)ZA(c[(c[d >> 2] | 0) + 92 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 28 >> 2] | 0) != 0 : 0) {
	                    sB(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 28 >> 2] = 0;
	                    c[(c[d >> 2] | 0) + 32 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 128 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 128 >> 2] | 0);
	                zP(c[(c[d >> 2] | 0) + 80 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ZA(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 36 | 0;
	                e = b + 32 | 0;
	                f = b + 28 | 0;
	                g = b + 24 | 0;
	                h = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 72 >> 2] | 0)PH(c[(c[d >> 2] | 0) + 72 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 88 >> 2] | 0)YA(c[(c[d >> 2] | 0) + 88 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 128 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 132 >> 2] | 0))break;
	                        c[f >> 2] = c[(c[(c[d >> 2] | 0) + 128 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 128 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 140 >> 2] | 0) {
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[d >> 2] | 0) + 144 >> 2] | 0))break;
	                        tB(c[(c[(c[d >> 2] | 0) + 140 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 140 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 116 >> 2] | 0) {
	                    uB(c[(c[d >> 2] | 0) + 116 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 116 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 120 >> 2] | 0) {
	                    uB(c[(c[d >> 2] | 0) + 120 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 120 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 112 >> 2] | 0) {
	                    c[h >> 2] = c[(c[d >> 2] | 0) + 112 >> 2];
	                    do {
	                        c[j >> 2] = c[c[h >> 2] >> 2];
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[h >> 2] = c[j >> 2]
	                    } while ((c[h >> 2] | 0) != 0)
	                }
	                if (c[(c[d >> 2] | 0) + 164 >> 2] | 0) {
	                    if (c[(c[d >> 2] | 0) + 168 >> 2] | 0)vB(c[d >> 2] | 0);
	                    c[k >> 2] = 0;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >= (c[(c[d >> 2] | 0) + 172 >> 2] | 0))break;
	                        c[l >> 2] = c[(c[(c[d >> 2] | 0) + 164 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 164 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 100 >> 2] | 0) {
	                    c[m >> 2] = 0;
	                    while (1) {
	                        if ((c[m >> 2] | 0) >= (c[(c[d >> 2] | 0) + 104 >> 2] | 0))break;
	                        c[n >> 2] = c[(c[(c[d >> 2] | 0) + 100 >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                        if (!(c[n >> 2] | 0))break;
	                        wB(c[d >> 2] | 0, c[n >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 100 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 180 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 180 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 156 >> 2] | 0)zP(c[(c[d >> 2] | 0) + 156 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function _A(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[f + 24 >> 2] = e;
	                c[m >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (!(c[l >> 2] | 0))c[n >> 2] = 0; else c[n >> 2] = 1;
	                a:do switch (c[c[j >> 2] >> 2] | 0) {
	                    case 1007:
	                    case 1003:
	                    case 1002:
	                    case 1001:
	                    case 1e3:
	                    {
	                        e = c[k >> 2] | 0;
	                        if ((c[c[k >> 2] >> 2] | 0) != 1) {
	                            c[o >> 2] = c[e + 64 >> 2];
	                            if (!(c[o >> 2] | 0)) {
	                                xB(c[l >> 2] | 0, 140360, 140384);
	                                c[h >> 2] = -1;
	                                q = c[h >> 2] | 0;
	                                i = f;
	                                return q | 0
	                            }
	                        } else c[o >> 2] = e;
	                        if ((c[n >> 2] | 0) == 0 ? (c[l >> 2] = XA(140432) | 0, (c[l >> 2] | 0) == 0) : 0) {
	                            c[h >> 2] = -1;
	                            q = c[h >> 2] | 0;
	                            i = f;
	                            return q | 0
	                        }
	                        c[m >> 2] = yB(c[l >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0, c[o >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, (c[j >> 2] | 0) + 32 | 0, 1, 1, 0) | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            if (c[(c[j >> 2] | 0) + 32 >> 2] | 0) {
	                                r = 45;
	                                break a
	                            }
	                            if (c[n >> 2] | 0)xB(c[l >> 2] | 0, 140360, 140632);
	                            e = c[33976] | 0;
	                            d = c[33980] | 0;
	                            c[g >> 2] = 140328;
	                            c[g + 4 >> 2] = 18739;
	                            Db[e & 511](d, 140296, g);
	                            r = 45;
	                            break a
	                        }
	                        if ((c[m >> 2] | 0) < 0) {
	                            if (!(c[n >> 2] | 0)) {
	                                r = 48;
	                                break a
	                            }
	                            d = c[l >> 2] | 0;
	                            e = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                            b = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                            AB(d, 3069, e, 0, 140440, b, zB(c[c[j >> 2] >> 2] | 0) | 0);
	                            r = 48;
	                            break a
	                        }
	                        c[m >> 2] = 1717;
	                        if ((c[n >> 2] | 0) != 0 ? (c[p >> 2] = 0, b = c[l >> 2] | 0, e = c[m >> 2] | 0, d = c[(c[j >> 2] | 0) + 20 >> 2] | 0, a = c[j >> 2] | 0, s = c[(c[j >> 2] | 0) + 8 >> 2] | 0, AB(b, e, d, a, 140552, s, BB(p, c[(c[o >> 2] | 0) + 112 >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0) | 0), (c[p >> 2] | 0) != 0) : 0) {
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                            c[p >> 2] = 0;
	                            r = 45
	                        } else r = 45;
	                        break
	                    }
	                    case 1011:
	                    case 1010:
	                    case 1009:
	                    case 1005:
	                    case 1004:
	                    {
	                        if ((c[c[j >> 2] >> 2] | 0) == 1004) {
	                            s = IH(34) | 0;
	                            c[m >> 2] = VH(s, c[(c[j >> 2] | 0) + 8 >> 2] | 0, (c[j >> 2] | 0) + 32 | 0) | 0
	                        } else {
	                            s = IH(33) | 0;
	                            c[m >> 2] = VH(s, c[(c[j >> 2] | 0) + 8 >> 2] | 0, (c[j >> 2] | 0) + 32 | 0) | 0
	                        }
	                        if (c[m >> 2] | 0)if ((c[m >> 2] | 0) < 0) {
	                            if (!(c[n >> 2] | 0)) {
	                                r = 48;
	                                break a
	                            }
	                            xB(c[l >> 2] | 0, 140360, 140728);
	                            r = 48;
	                            break a
	                        } else {
	                            c[m >> 2] = 1717;
	                            if (!(c[n >> 2] | 0)) {
	                                r = 45;
	                                break a
	                            }
	                            s = c[l >> 2] | 0;
	                            a = c[m >> 2] | 0;
	                            d = c[(c[j >> 2] | 0) + 20 >> 2] | 0;
	                            e = c[k >> 2] | 0;
	                            b = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                            t = zB(c[c[j >> 2] >> 2] | 0) | 0;
	                            CB(s, a, d, e, 140752, b, t, (c[c[j >> 2] >> 2] | 0) != 1004 ? 140808 : 140832, 0);
	                            r = 45;
	                            break a
	                        } else r = 45;
	                        break
	                    }
	                    case 1006:
	                    {
	                        t = uz(c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[(c[j >> 2] | 0) + 36 >> 2] = t;
	                        if ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) == 0 ? (c[m >> 2] = 1756, (c[n >> 2] | 0) != 0) : 0) {
	                            AB(c[l >> 2] | 0, c[m >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] | 0, 140656, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                            r = 45
	                        } else r = 45;
	                        break
	                    }
	                    case 1008:
	                    {
	                        t = (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 140848) | 0) != 0;
	                        b = c[j >> 2] | 0;
	                        if (t) {
	                            c[b + 28 >> 2] = 1;
	                            r = 45;
	                            break a
	                        }
	                        t = (qy(c[b + 8 >> 2] | 0, 140864) | 0) != 0;
	                        b = c[j >> 2] | 0;
	                        if (t) {
	                            c[b + 28 >> 2] = 2;
	                            r = 45;
	                            break a
	                        }
	                        if (qy(c[b + 8 >> 2] | 0, 140872) | 0) {
	                            c[(c[j >> 2] | 0) + 28 >> 2] = 3;
	                            r = 45;
	                            break a
	                        }
	                        c[m >> 2] = 1717;
	                        if (c[n >> 2] | 0) {
	                            AB(c[l >> 2] | 0, c[m >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] | 0, 140888, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                            r = 45
	                        } else r = 45;
	                        break
	                    }
	                    default:
	                        r = 45
	                } while (0);
	                if ((r | 0) == 45) {
	                    if ((c[n >> 2] | 0) == 0 & (c[l >> 2] | 0) != 0)YA(c[l >> 2] | 0);
	                    c[h >> 2] = c[m >> 2];
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else if ((r | 0) == 48) {
	                    if ((c[n >> 2] | 0) == 0 & (c[l >> 2] | 0) != 0)YA(c[l >> 2] | 0);
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                return 0
	            }

	            function $A(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                FH();
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                c[f >> 2] = DB(c[e >> 2] | 0) | 0;
	                a:do if (c[f >> 2] | 0) {
	                    do if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                        a = EB(c[(c[e >> 2] | 0) + 80 >> 2] | 0) | 0;
	                        c[(c[e >> 2] | 0) + 28 >> 2] = a;
	                        if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                            c[(c[e >> 2] | 0) + 32 >> 2] = 1;
	                            break
	                        }
	                        c[d >> 2] = 0;
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } while (0);
	                    c[c[(c[e >> 2] | 0) + 28 >> 2] >> 2] = c[f >> 2];
	                    c[h >> 2] = FB(c[e >> 2] | 0, 0, c[(c[e >> 2] | 0) + 44 >> 2] | 0, c[(c[e >> 2] | 0) + 48 >> 2] | 0, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0, 0, 0, 0, g) | 0;
	                    if ((c[h >> 2] | 0) != -1) {
	                        do if (!(c[h >> 2] | 0)) {
	                            a = c[e >> 2] | 0;
	                            if (!(c[g >> 2] | 0)) {
	                                k = c[e >> 2] | 0;
	                                if (c[a + 44 >> 2] | 0) {
	                                    AB(k, 1757, 0, 0, 140944, c[(c[e >> 2] | 0) + 44 >> 2] | 0, 0);
	                                    break
	                                } else {
	                                    AB(k, 1757, 0, 0, 141e3, 0, 0);
	                                    break
	                                }
	                            } else {
	                                if ((GB(a, c[f >> 2] | 0, c[g >> 2] | 0) | 0) == -1)break a;
	                                if (c[(c[e >> 2] | 0) + 20 >> 2] | 0)break;
	                                c[(c[f >> 2] | 0) + 16 >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                                c[(c[f >> 2] | 0) + 68 >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                                c[(c[e >> 2] | 0) + 36 >> 2] = c[f >> 2];
	                                if ((HB(c[e >> 2] | 0, c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) | 0) == -1)break a; else break
	                            }
	                        } while (0);
	                        if (c[(c[e >> 2] | 0) + 20 >> 2] | 0) {
	                            if (c[f >> 2] | 0) {
	                                WA(c[f >> 2] | 0);
	                                c[f >> 2] = 0
	                            }
	                            if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                                sB(c[(c[e >> 2] | 0) + 28 >> 2] | 0);
	                                c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                                c[(c[e >> 2] | 0) + 32 >> 2] = 0
	                            }
	                        }
	                        c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                        c[d >> 2] = c[f >> 2];
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                } while (0);
	                if (c[f >> 2] | 0) {
	                    WA(c[f >> 2] | 0);
	                    c[f >> 2] = 0
	                }
	                if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                    sB(c[(c[e >> 2] | 0) + 28 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 32 >> 2] = 0
	                }
	                xB(c[e >> 2] | 0, 141048, 141064);
	                c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                c[d >> 2] = 0;
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function aB(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                c[(c[g >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                if (!(c[(c[g >> 2] | 0) + 92 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                bB(c[(c[g >> 2] | 0) + 92 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function bB(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                c[(c[g >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                if (!(c[(c[g >> 2] | 0) + 88 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                aB(c[(c[g >> 2] | 0) + 88 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function cB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                if (!(c[(c[f >> 2] | 0) + 92 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                dB(c[(c[f >> 2] | 0) + 92 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function dB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                if (!(c[(c[f >> 2] | 0) + 88 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                cB(c[(c[f >> 2] | 0) + 88 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function eB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](204) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    IB(0, 141096, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    cU(c[f >> 2] | 0, 0, 204) | 0;
	                    c[c[f >> 2] >> 2] = 2;
	                    a = xP() | 0;
	                    c[(c[f >> 2] | 0) + 156 >> 2] = a;
	                    a = JB() | 0;
	                    c[(c[f >> 2] | 0) + 180 >> 2] = a;
	                    c[(c[f >> 2] | 0) + 20 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function fB(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 48 >> 2] | 0);
	                if (c[f >> 2] | 0) {
	                    b = my(c[f >> 2] | 0) | 0;
	                    c[(c[e >> 2] | 0) + 48 >> 2] = b;
	                    i = d;
	                    return
	                } else {
	                    c[(c[e >> 2] | 0) + 48 >> 2] = 0;
	                    i = d;
	                    return
	                }
	            }

	            function gB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else {
	                    c[d >> 2] = (c[(c[e >> 2] | 0) + 52 >> 2] | 0) == 0 & 1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function hB(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                b = Pi(c[g >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 60 >> 2] = b;
	                b = c[f >> 2] | 0;
	                if (!(c[(c[f >> 2] | 0) + 60 >> 2] | 0)) {
	                    AB(b, 1872, c[g >> 2] | 0, 0, 141128, 0, 0);
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 84 >> 2] = c[b + 60 >> 2];
	                    c[e >> 2] = KB(c[f >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function iB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[l >> 2] = c[c[h >> 2] >> 2];
	                if ((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 108 >> 2] | 0) != -554844497 : 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 116 >> 2] | 0) == 0 : 0) ? (c[(c[l >> 2] | 0) + 120 >> 2] | 0) == 0 : 0) {
	                    if ((c[(c[l >> 2] | 0) + 56 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 60 >> 2] | 0) == 0 : 0)break;
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](152) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                cU(c[k >> 2] | 0, 0, 152) | 0;
	                c[c[k >> 2] >> 2] = -599541215;
	                c[(c[k >> 2] | 0) + 128 >> 2] = -554844497;
	                c[(c[k >> 2] | 0) + 148 >> 2] = c[g >> 2];
	                c[(c[k >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    c[(c[k >> 2] | 0) + 136 >> 2] = 323;
	                    c[(c[k >> 2] | 0) + 140 >> 2] = 324;
	                    c[(c[k >> 2] | 0) + 92 >> 2] = 325;
	                    c[(c[k >> 2] | 0) + 88 >> 2] = 325;
	                    c[(c[k >> 2] | 0) + 120 >> 2] = 326;
	                    c[(c[k >> 2] | 0) + 84 >> 2] = 327;
	                    c[(c[k >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                    c[c[j >> 2] >> 2] = c[g >> 2]
	                } else {
	                    if (c[c[l >> 2] >> 2] | 0)c[(c[k >> 2] | 0) + 20 >> 2] = 328;
	                    if (c[(c[l >> 2] | 0) + 4 >> 2] | 0)c[(c[k >> 2] | 0) + 24 >> 2] = 329;
	                    if (c[(c[l >> 2] | 0) + 8 >> 2] | 0)c[(c[k >> 2] | 0) + 28 >> 2] = 330;
	                    if (c[(c[l >> 2] | 0) + 12 >> 2] | 0)c[(c[k >> 2] | 0) + 32 >> 2] = 331;
	                    if (c[(c[l >> 2] | 0) + 16 >> 2] | 0)c[(c[k >> 2] | 0) + 36 >> 2] = 332;
	                    if (c[(c[l >> 2] | 0) + 20 >> 2] | 0)c[(c[k >> 2] | 0) + 40 >> 2] = 333;
	                    if (c[(c[l >> 2] | 0) + 24 >> 2] | 0)c[(c[k >> 2] | 0) + 44 >> 2] = 334;
	                    if (c[(c[l >> 2] | 0) + 28 >> 2] | 0)c[(c[k >> 2] | 0) + 48 >> 2] = 335;
	                    if (c[(c[l >> 2] | 0) + 32 >> 2] | 0)c[(c[k >> 2] | 0) + 52 >> 2] = 336;
	                    if (c[(c[l >> 2] | 0) + 36 >> 2] | 0)c[(c[k >> 2] | 0) + 56 >> 2] = 337;
	                    if (c[(c[l >> 2] | 0) + 40 >> 2] | 0)c[(c[k >> 2] | 0) + 60 >> 2] = 338;
	                    if (c[(c[l >> 2] | 0) + 44 >> 2] | 0)c[(c[k >> 2] | 0) + 64 >> 2] = 339;
	                    if (c[(c[l >> 2] | 0) + 48 >> 2] | 0)c[(c[k >> 2] | 0) + 68 >> 2] = 340;
	                    if (c[(c[l >> 2] | 0) + 52 >> 2] | 0)c[(c[k >> 2] | 0) + 72 >> 2] = 341;
	                    if (c[(c[l >> 2] | 0) + 76 >> 2] | 0)c[(c[k >> 2] | 0) + 96 >> 2] = 342;
	                    if (c[(c[l >> 2] | 0) + 80 >> 2] | 0)c[(c[k >> 2] | 0) + 100 >> 2] = 343;
	                    if (c[(c[l >> 2] | 0) + 84 >> 2] | 0)c[(c[k >> 2] | 0) + 104 >> 2] = 344;
	                    if (c[(c[l >> 2] | 0) + 88 >> 2] | 0)c[(c[k >> 2] | 0) + 108 >> 2] = 345;
	                    if (c[(c[l >> 2] | 0) + 92 >> 2] | 0)c[(c[k >> 2] | 0) + 112 >> 2] = 346;
	                    if (c[(c[l >> 2] | 0) + 96 >> 2] | 0)c[(c[k >> 2] | 0) + 116 >> 2] = 347;
	                    if (c[(c[l >> 2] | 0) + 104 >> 2] | 0)c[(c[k >> 2] | 0) + 124 >> 2] = 348;
	                    c[(c[k >> 2] | 0) + 88 >> 2] = 349;
	                    do if (c[(c[l >> 2] | 0) + 72 >> 2] | 0) {
	                        if ((c[(c[l >> 2] | 0) + 72 >> 2] | 0) == (c[(c[l >> 2] | 0) + 68 >> 2] | 0)) {
	                            n = 61;
	                            break
	                        }
	                        c[(c[k >> 2] | 0) + 92 >> 2] = 350
	                    } else n = 61; while (0);
	                    if ((n | 0) == 61)c[(c[k >> 2] | 0) + 92 >> 2] = 349;
	                    c[(c[k >> 2] | 0) + 120 >> 2] = 351;
	                    c[(c[k >> 2] | 0) + 84 >> 2] = 352;
	                    c[(c[k >> 2] | 0) + 136 >> 2] = 353;
	                    c[(c[k >> 2] | 0) + 140 >> 2] = 354;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                    c[(c[k >> 2] | 0) + 16 >> 2] = c[c[j >> 2] >> 2];
	                    c[c[j >> 2] >> 2] = c[k >> 2]
	                }
	                c[c[h >> 2] >> 2] = (c[k >> 2] | 0) + 20;
	                c[(c[g >> 2] | 0) + 36 >> 2] = c[c[h >> 2] >> 2];
	                h = (c[g >> 2] | 0) + 152 | 0;
	                c[h >> 2] = c[h >> 2] | 1;
	                pC(c[g >> 2] | 0) | 0;
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function jB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[c[e >> 2] >> 2] | 0) == -599541215 : 0) {
	                    c[c[e >> 2] >> 2] = 0;
	                    qC(c[(c[e >> 2] | 0) + 148 >> 2] | 0);
	                    c[f >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                    c[c[f >> 2] >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        c[c[g >> 2] >> 2] = c[(c[e >> 2] | 0) + 16 >> 2]
	                    }
	                    zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[d >> 2] = -1;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function kB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 196 >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 200 >> 2] = c[h >> 2];
	                i = e;
	                return
	            }

	            function lB(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 40 | 0;
	                j = g + 36 | 0;
	                k = g + 32 | 0;
	                l = g + 28 | 0;
	                m = g + 24 | 0;
	                n = g + 20 | 0;
	                o = g + 16 | 0;
	                p = g + 12 | 0;
	                q = g + 8 | 0;
	                r = g + 4 | 0;
	                s = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                c[q >> 2] = Be() | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                c[p >> 2] = c[c[q >> 2] >> 2];
	                c[c[q >> 2] >> 2] = c[m >> 2];
	                c[(c[q >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                c[(c[q >> 2] | 0) + 280 >> 2] = 1;
	                kB(c[j >> 2] | 0, 355, c[q >> 2] | 0);
	                c[r >> 2] = ve(c[q >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                do if (c[r >> 2] | 0) {
	                    Oe(c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 40 >> 2] = c[q >> 2];
	                    c[(c[j >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                    c[o >> 2] = iB(c[j >> 2] | 0, c[q >> 2] | 0, (c[q >> 2] | 0) + 4 | 0) | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        c[s >> 2] = -1;
	                        break
	                    }
	                    c[(c[j >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                    c[(c[j >> 2] | 0) + 32 >> 2] = c[l >> 2];
	                    c[(c[j >> 2] | 0) + 36 >> 2] = c[c[q >> 2] >> 2];
	                    n = (c[j >> 2] | 0) + 152 | 0;
	                    c[n >> 2] = c[n >> 2] | 1;
	                    c[s >> 2] = KB(c[j >> 2] | 0) | 0;
	                    if ((c[s >> 2] | 0) == 0 ? (c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                        n = c[(c[(c[j >> 2] | 0) + 40 >> 2] | 0) + 84 >> 2] | 0;
	                        c[s >> 2] = n;
	                        c[s >> 2] = (c[s >> 2] | 0) == 0 ? 1 : n
	                    }
	                } else c[s >> 2] = -1; while (0);
	                c[(c[j >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 28 >> 2] = 0;
	                if (c[o >> 2] | 0)jB(c[o >> 2] | 0) | 0;
	                if (c[q >> 2] | 0) {
	                    c[c[q >> 2] >> 2] = c[p >> 2];
	                    Ae(c[q >> 2] | 0)
	                }
	                c[h >> 2] = c[s >> 2];
	                t = c[h >> 2] | 0;
	                i = g;
	                return t | 0
	            }

	            function mB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[c[d >> 2] >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    i = b;
	                    return
	                } else {
	                    do {
	                        c[e >> 2] = c[d >> 2];
	                        c[d >> 2] = c[c[d >> 2] >> 2];
	                        zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                    } while ((c[d >> 2] | 0) != 0);
	                    i = b;
	                    return
	                }
	            }

	            function nB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function oB(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function pB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function qB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 44 >> 2] | 0) {
	                    sC(c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                    oB(c[(c[d >> 2] | 0) + 44 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 48 >> 2] | 0) {
	                    sC(c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                    oB(c[(c[d >> 2] | 0) + 48 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0) {
	                    c[f >> 2] = c[(c[d >> 2] | 0) + 24 >> 2];
	                    do {
	                        c[e >> 2] = c[f >> 2];
	                        c[f >> 2] = c[c[f >> 2] >> 2];
	                        zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                    } while ((c[f >> 2] | 0) != 0)
	                }
	                if ((c[(c[d >> 2] | 0) + 40 >> 2] | 0) == 0 ? (c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)Th(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                if ((c[c[d >> 2] >> 2] | 0) == 1 ? (c[(c[d >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)WA(c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function rB() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](132) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    tC(0, 170240, 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                cU(c[d >> 2] | 0, 0, 132) | 0;
	                c[c[d >> 2] >> 2] = 1;
	                f = JB() | 0;
	                c[(c[d >> 2] | 0) + 128 >> 2] = f;
	                if (!(c[(c[d >> 2] | 0) + 128 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function sB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 24 >> 2] | 0, 356);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)vC(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (!(c[(c[d >> 2] | 0) + 8 >> 2] | 0)) {
	                    e = c[33934] | 0;
	                    f = c[d >> 2] | 0;
	                    zb[e & 511](f);
	                    i = b;
	                    return
	                }
	                zP(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                e = c[33934] | 0;
	                f = c[d >> 2] | 0;
	                zb[e & 511](f);
	                i = b;
	                return
	            }

	            function tB(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)PH(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function uB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[(c[d >> 2] | 0) + 4 >> 2];
	                    if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)GQ(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function vB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[(c[d >> 2] | 0) + 168 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 168 >> 2] | 0))break;
	                    c[f >> 2] = c[(c[(c[d >> 2] | 0) + 164 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                    if (c[(c[f >> 2] | 0) + 32 >> 2] & 1) {
	                        if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                        if (c[(c[f >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0)
	                    }
	                    if ((c[(c[f >> 2] | 0) + 32 >> 2] & 2 | 0) != 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 20 >> 2] | 0);
	                    if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                        PH(c[(c[f >> 2] | 0) + 24 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 24 >> 2] = 0
	                    }
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    g = a + 60 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (g | 0));
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                c[(c[d >> 2] | 0) + 168 >> 2] = 0;
	                i = b;
	                return
	            }

	            function wB(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[(c[f >> 2] | 0) + 76 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 80 >> 2] = 0;
	                b = (c[f >> 2] | 0) + 12 | 0;
	                if (c[(c[f >> 2] | 0) + 32 >> 2] & 1) {
	                    if (c[b >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 12 >> 2] = 0
	                    }
	                    if (c[(c[f >> 2] | 0) + 16 >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 0
	                    }
	                } else {
	                    c[b >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 0
	                }
	                b = (c[f >> 2] | 0) + 20 | 0;
	                if (c[(c[f >> 2] | 0) + 32 >> 2] & 2) {
	                    if (c[b >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 20 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 20 >> 2] = 0
	                    }
	                } else c[b >> 2] = 0;
	                if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                    PH(c[(c[f >> 2] | 0) + 24 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 24 >> 2] = 0
	                }
	                if (c[(c[f >> 2] | 0) + 56 >> 2] | 0) {
	                    wC(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 56 >> 2] = 0
	                }
	                if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                    xC(c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 52 >> 2] = 0
	                }
	                if (c[(c[f >> 2] | 0) + 60 >> 2] | 0) {
	                    pz(c[(c[f >> 2] | 0) + 60 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 60 >> 2] = 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 64 >> 2] | 0);
	                c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 72 >> 2] = 0;
	                i = d;
	                return
	            }

	            function xB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                yC(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0, 0);
	                i = e;
	                return
	            }

	            function yB(a, b, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0;
	                l = i;
	                i = i + 96 | 0;
	                m = l;
	                n = l + 92 | 0;
	                o = l + 88 | 0;
	                p = l + 84 | 0;
	                q = l + 80 | 0;
	                r = l + 76 | 0;
	                s = l + 72 | 0;
	                t = l + 68 | 0;
	                u = l + 64 | 0;
	                v = l + 60 | 0;
	                w = l + 56 | 0;
	                x = l + 52 | 0;
	                y = l + 48 | 0;
	                z = l + 44 | 0;
	                A = l + 40 | 0;
	                B = l + 36 | 0;
	                C = l + 32 | 0;
	                D = l + 28 | 0;
	                E = l + 24 | 0;
	                F = l + 20 | 0;
	                G = l + 16 | 0;
	                H = l + 12 | 0;
	                I = l + 8 | 0;
	                c[o >> 2] = a;
	                c[p >> 2] = b;
	                c[q >> 2] = e;
	                c[r >> 2] = f;
	                c[s >> 2] = g;
	                c[t >> 2] = h;
	                c[u >> 2] = j;
	                c[v >> 2] = k;
	                c[w >> 2] = 0;
	                c[x >> 2] = (c[s >> 2] | 0) != 0 ? 1 : 0;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                if ((c[s >> 2] | 0) != 0 ? (c[c[s >> 2] >> 2] | 0) != 0 : 0) {
	                    PH(c[c[s >> 2] >> 2] | 0);
	                    c[c[s >> 2] >> 2] = 0
	                }
	                if ((c[x >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 2097152 | 0) != 0 : 0)c[x >> 2] = 1;
	                if (!(c[r >> 2] | 0))c[r >> 2] = 142672;
	                if ((c[c[q >> 2] >> 2] | 0) == 1 ? (c[(c[q >> 2] | 0) + 88 >> 2] | 0) == 46 : 0)J = 12; else J = 11;
	                a:do if ((J | 0) == 11)if (!(c[(c[q >> 2] | 0) + 48 >> 2] & 256)) {
	                    if (!(c[(c[q >> 2] | 0) + 48 >> 2] & 64)) {
	                        if (!(c[(c[q >> 2] | 0) + 48 >> 2] & 128))break;
	                        c[I >> 2] = EC(c[q >> 2] | 0) | 0;
	                        if (!(c[I >> 2] | 0)) {
	                            xB(c[o >> 2] | 0, 156240, 156464);
	                            J = 149;
	                            break
	                        }
	                        while (1) {
	                            if (!(c[I >> 2] | 0))break;
	                            k = c[o >> 2] | 0;
	                            j = c[p >> 2] | 0;
	                            h = c[(c[I >> 2] | 0) + 4 >> 2] | 0;
	                            g = c[r >> 2] | 0;
	                            if (c[x >> 2] | 0)c[w >> 2] = yB(k, j, h, g, y, 0, 1, 0) | 0; else c[w >> 2] = yB(k, j, h, g, 0, 0, 1, 0) | 0;
	                            if ((c[w >> 2] | 0) <= 0)break;
	                            c[I >> 2] = c[c[I >> 2] >> 2]
	                        }
	                        do if (c[w >> 2] | 0)if ((c[w >> 2] | 0) < 0) {
	                            xB(c[o >> 2] | 0, 156240, 156504);
	                            J = 149;
	                            break a
	                        } else {
	                            c[w >> 2] = 1826;
	                            break
	                        } while (0);
	                        do if ((c[w >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 134217728 | 0) != 0 : 0) {
	                            do if (!(c[v >> 2] | 0)) {
	                                if ((c[u >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 268435456 | 0) == 0 : 0)break;
	                                c[z >> 2] = zC(c[(c[I >> 2] | 0) + 4 >> 2] | 0, c[r >> 2] | 0) | 0;
	                                if (c[z >> 2] | 0)c[r >> 2] = c[z >> 2];
	                                c[v >> 2] = 1
	                            } while (0);
	                            c[w >> 2] = CC(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, 0, c[r >> 2] | 0, c[y >> 2] | 0, 0, c[t >> 2] | 0) | 0;
	                            if (c[w >> 2] | 0)if ((c[w >> 2] | 0) < 0) {
	                                xB(c[o >> 2] | 0, 156240, 156544);
	                                J = 149;
	                                break a
	                            } else {
	                                c[w >> 2] = 1826;
	                                break
	                            }
	                        } while (0);
	                        if (!((c[t >> 2] | 0) != 0 & (c[w >> 2] | 0) > 0))break;
	                        DC(c[o >> 2] | 0, c[w >> 2] | 0, c[p >> 2] | 0, c[r >> 2] | 0, c[q >> 2] | 0, 1);
	                        break
	                    }
	                    c[E >> 2] = 0;
	                    c[F >> 2] = 0;
	                    c[G >> 2] = 0;
	                    c[H >> 2] = 0;
	                    do if (!(c[v >> 2] | 0)) {
	                        if ((c[u >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 268435456 | 0) == 0 : 0)break;
	                        c[z >> 2] = zC(c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                        if (c[z >> 2] | 0)c[r >> 2] = c[z >> 2];
	                        c[v >> 2] = 1
	                    } while (0);
	                    c[B >> 2] = c[(c[q >> 2] | 0) + 28 >> 2];
	                    c[C >> 2] = c[r >> 2];
	                    while (1) {
	                        do if ((d[c[C >> 2] >> 0] | 0 | 0) == 32)K = 1; else {
	                            if (9 <= (d[c[C >> 2] >> 0] | 0 | 0) ? (d[c[C >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                K = 1;
	                                break
	                            }
	                            K = (d[c[C >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        g = c[C >> 2] | 0;
	                        if (K) {
	                            c[C >> 2] = g + 1;
	                            continue
	                        }
	                        c[D >> 2] = g;
	                        while (1) {
	                            if (d[c[D >> 2] >> 0] | 0) {
	                                do if ((d[c[D >> 2] >> 0] | 0 | 0) == 32)L = 1; else {
	                                    if (9 <= (d[c[D >> 2] >> 0] | 0 | 0) ? (d[c[D >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        L = 1;
	                                        break
	                                    }
	                                    L = (d[c[D >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                M = L ^ 1
	                            } else M = 0;
	                            N = c[D >> 2] | 0;
	                            if (!M)break;
	                            c[D >> 2] = N + 1
	                        }
	                        if ((N | 0) == (c[C >> 2] | 0))break;
	                        c[E >> 2] = ly(c[C >> 2] | 0, (c[D >> 2] | 0) - (c[C >> 2] | 0) | 0) | 0;
	                        c[F >> 2] = (c[F >> 2] | 0) + 1;
	                        g = c[o >> 2] | 0;
	                        h = c[p >> 2] | 0;
	                        j = c[B >> 2] | 0;
	                        k = c[E >> 2] | 0;
	                        f = c[t >> 2] | 0;
	                        if (c[x >> 2] | 0)c[w >> 2] = yB(g, h, j, k, H, f, 0, 1) | 0; else c[w >> 2] = yB(g, h, j, k, 0, f, 0, 1) | 0;
	                        if (c[E >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[E >> 2] | 0);
	                            c[E >> 2] = 0
	                        }
	                        if (c[H >> 2] | 0) {
	                            if (!(c[y >> 2] | 0))c[y >> 2] = c[H >> 2]; else JH(c[G >> 2] | 0, c[H >> 2] | 0) | 0;
	                            c[G >> 2] = c[H >> 2];
	                            c[H >> 2] = 0
	                        }
	                        if (c[w >> 2] | 0) {
	                            J = 92;
	                            break
	                        }
	                        c[C >> 2] = c[D >> 2];
	                        if (!(d[c[C >> 2] >> 0] | 0))break
	                    }
	                    do if ((J | 0) == 92)if ((c[w >> 2] | 0) < 0) {
	                        xB(c[o >> 2] | 0, 156240, 156384);
	                        J = 149;
	                        break a
	                    } else {
	                        c[w >> 2] = 1825;
	                        break
	                    } while (0);
	                    if (c[E >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[E >> 2] | 0);
	                        c[E >> 2] = 0
	                    }
	                    do if (((c[w >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 134217728 | 0) != 0 : 0) ? (c[w >> 2] = CC(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, 0, c[r >> 2] | 0, c[y >> 2] | 0, c[F >> 2] | 0, c[t >> 2] | 0) | 0, (c[w >> 2] | 0) != 0) : 0)if ((c[w >> 2] | 0) < 0) {
	                        xB(c[o >> 2] | 0, 156240, 156424);
	                        J = 149;
	                        break a
	                    } else {
	                        c[w >> 2] = 1825;
	                        break
	                    } while (0);
	                    if ((c[t >> 2] | 0) != 0 & (c[w >> 2] | 0) > 0) {
	                        c[u >> 2] = 1;
	                        do if (!(c[v >> 2] | 0)) {
	                            if ((c[u >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 268435456 | 0) == 0 : 0)break;
	                            c[z >> 2] = zC(c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                            if (c[z >> 2] | 0)c[r >> 2] = c[z >> 2];
	                            c[v >> 2] = 1
	                        } while (0);
	                        DC(c[o >> 2] | 0, c[w >> 2] | 0, c[p >> 2] | 0, c[r >> 2] | 0, c[q >> 2] | 0, 1)
	                    }
	                } else J = 12; while (0);
	                b:do if ((J | 0) == 12) {
	                    do if (!(c[v >> 2] | 0)) {
	                        if ((c[u >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 268435456 | 0) == 0 : 0)break;
	                        c[z >> 2] = zC(c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                        if (c[z >> 2] | 0)c[r >> 2] = c[z >> 2];
	                        c[v >> 2] = 1
	                    } while (0);
	                    F = c[q >> 2] | 0;
	                    if ((c[c[q >> 2] >> 2] | 0) != 1) {
	                        c[A >> 2] = c[F + 64 >> 2];
	                        while (1) {
	                            if (c[A >> 2] | 0)O = (c[c[A >> 2] >> 2] | 0) != 1; else O = 0;
	                            P = c[A >> 2] | 0;
	                            if (!O)break;
	                            c[A >> 2] = c[P + 64 >> 2]
	                        }
	                        if (!P) {
	                            xB(c[o >> 2] | 0, 156240, 156272);
	                            J = 149;
	                            break
	                        }
	                    } else c[A >> 2] = F;
	                    do if ((c[c[o >> 2] >> 2] | 0) == 2) {
	                        E = c[(c[A >> 2] | 0) + 88 >> 2] | 0;
	                        if ((E | 0) == 21) {
	                            c[w >> 2] = BC(c[o >> 2] | 0, c[r >> 2] | 0, y, c[x >> 2] | 0) | 0;
	                            break
	                        } else if ((E | 0) != 28) {
	                            E = c[A >> 2] | 0;
	                            C = c[r >> 2] | 0;
	                            D = c[p >> 2] | 0;
	                            if (c[x >> 2] | 0) {
	                                c[w >> 2] = UH(E, C, y, D) | 0;
	                                break
	                            } else {
	                                c[w >> 2] = UH(E, C, 0, D) | 0;
	                                break
	                            }
	                        } else {
	                            c[w >> 2] = AC(c[o >> 2] | 0, c[(c[o >> 2] | 0) + 20 >> 2] | 0, 0, c[r >> 2] | 0, y, c[x >> 2] | 0) | 0;
	                            break
	                        }
	                    } else {
	                        if ((c[c[o >> 2] >> 2] | 0) != 1) {
	                            D = c[33976] | 0;
	                            C = c[33980] | 0;
	                            c[m >> 2] = 140328;
	                            c[m + 4 >> 2] = 24593;
	                            Db[D & 511](C, 140296, m);
	                            J = 149;
	                            break b
	                        }
	                        if ((c[(c[A >> 2] | 0) + 88 >> 2] | 0) == 28) {
	                            c[w >> 2] = AC(0, c[(c[o >> 2] | 0) + 36 >> 2] | 0, c[p >> 2] | 0, c[r >> 2] | 0, y, c[x >> 2] | 0) | 0;
	                            break
	                        }
	                        C = c[A >> 2] | 0;
	                        D = c[r >> 2] | 0;
	                        E = c[p >> 2] | 0;
	                        if (c[x >> 2] | 0) {
	                            c[w >> 2] = UH(C, D, y, E) | 0;
	                            break
	                        } else {
	                            c[w >> 2] = UH(C, D, 0, E) | 0;
	                            break
	                        }
	                    } while (0);
	                    do if (c[w >> 2] | 0) {
	                        if ((c[w >> 2] | 0) < 0) {
	                            xB(c[o >> 2] | 0, 156240, 156304);
	                            J = 149;
	                            break b
	                        }
	                        if (c[(c[q >> 2] | 0) + 48 >> 2] & 64) {
	                            c[w >> 2] = 1825;
	                            break
	                        } else {
	                            c[w >> 2] = 1824;
	                            break
	                        }
	                    } while (0);
	                    do if (((c[w >> 2] | 0) == 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] & 134217728 | 0) != 0 : 0) ? (c[w >> 2] = CC(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[(c[A >> 2] | 0) + 88 >> 2] | 0, c[r >> 2] | 0, c[y >> 2] | 0, 0, c[t >> 2] | 0) | 0, (c[w >> 2] | 0) != 0) : 0) {
	                        if ((c[w >> 2] | 0) < 0) {
	                            xB(c[o >> 2] | 0, 156240, 156344);
	                            J = 149;
	                            break b
	                        }
	                        if (c[(c[q >> 2] | 0) + 48 >> 2] & 64) {
	                            c[w >> 2] = 1825;
	                            break
	                        } else {
	                            c[w >> 2] = 1824;
	                            break
	                        }
	                    } while (0);
	                    if ((c[t >> 2] | 0) != 0 & (c[w >> 2] | 0) > 0)DC(c[o >> 2] | 0, c[w >> 2] | 0, c[p >> 2] | 0, c[r >> 2] | 0, c[q >> 2] | 0, 1)
	                } while (0);
	                if ((J | 0) == 149) {
	                    if (c[z >> 2] | 0)zb[c[135736 >> 2] & 511](c[z >> 2] | 0);
	                    if (c[y >> 2] | 0)PH(c[y >> 2] | 0);
	                    c[n >> 2] = -1;
	                    Q = c[n >> 2] | 0;
	                    i = l;
	                    return Q | 0
	                }
	                if (c[z >> 2] | 0)zb[c[135736 >> 2] & 511](c[z >> 2] | 0);
	                do if (!(c[w >> 2] | 0)) {
	                    z = c[y >> 2] | 0;
	                    if (c[s >> 2] | 0) {
	                        c[c[s >> 2] >> 2] = z;
	                        break
	                    }
	                    if (z)PH(c[y >> 2] | 0)
	                } else if (c[y >> 2] | 0)PH(c[y >> 2] | 0); while (0);
	                c[n >> 2] = c[w >> 2];
	                Q = c[n >> 2] | 0;
	                i = l;
	                return Q | 0
	            }

	            function zB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do switch (c[e >> 2] | 0) {
	                    case 1e3:
	                    {
	                        c[d >> 2] = 157848;
	                        break
	                    }
	                    case 1010:
	                    {
	                        c[d >> 2] = 157904;
	                        break
	                    }
	                    case 1002:
	                    {
	                        c[d >> 2] = 157816;
	                        break
	                    }
	                    case 1001:
	                    {
	                        c[d >> 2] = 157832;
	                        break
	                    }
	                    case 1003:
	                    {
	                        c[d >> 2] = 157800;
	                        break
	                    }
	                    case 1004:
	                    {
	                        c[d >> 2] = 157936;
	                        break
	                    }
	                    case 1009:
	                    {
	                        c[d >> 2] = 157896;
	                        break
	                    }
	                    case 1005:
	                    {
	                        c[d >> 2] = 157952;
	                        break
	                    }
	                    case 1007:
	                    {
	                        c[d >> 2] = 157880;
	                        break
	                    }
	                    case 1006:
	                    {
	                        c[d >> 2] = 157792;
	                        break
	                    }
	                    case 1011:
	                    {
	                        c[d >> 2] = 157920;
	                        break
	                    }
	                    case 1008:
	                    {
	                        c[d >> 2] = 157864;
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 157968
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function AB(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 24 | 0;
	                l = j + 20 | 0;
	                m = j + 16 | 0;
	                n = j + 12 | 0;
	                o = j + 8 | 0;
	                p = j + 4 | 0;
	                q = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                CB(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, 0, 0);
	                i = j;
	                return
	            }

	            function BB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (c[c[g >> 2] >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[c[g >> 2] >> 2] | 0);
	                    c[c[g >> 2] >> 2] = 0
	                }
	                if (c[h >> 2] | 0) {
	                    d = my(144432) | 0;
	                    c[c[g >> 2] >> 2] = d;
	                    d = By(c[c[g >> 2] >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[c[g >> 2] >> 2] = d;
	                    d = By(c[c[g >> 2] >> 2] | 0, 144440) | 0;
	                    c[c[g >> 2] >> 2] = d
	                }
	                do if (c[j >> 2] | 0) {
	                    if (c[h >> 2] | 0) {
	                        d = By(c[c[g >> 2] >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[c[g >> 2] >> 2] = d;
	                        break
	                    }
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    d = By(c[c[g >> 2] >> 2] | 0, 170232) | 0;
	                    c[c[g >> 2] >> 2] = d
	                } while (0);
	                c[f >> 2] = c[c[g >> 2] >> 2];
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function CB(a, b, d, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                l = i;
	                i = i + 48 | 0;
	                m = l + 36 | 0;
	                n = l + 32 | 0;
	                o = l + 28 | 0;
	                p = l + 24 | 0;
	                q = l + 20 | 0;
	                r = l + 16 | 0;
	                s = l + 12 | 0;
	                t = l + 8 | 0;
	                u = l + 4 | 0;
	                v = l;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = 0;
	                if ((c[o >> 2] | 0) == 0 & (c[p >> 2] | 0) != 0 ? (c[c[m >> 2] >> 2] | 0) == 1 : 0) {
	                    c[o >> 2] = FC(c[p >> 2] | 0) | 0;
	                    GC(v, 0, c[p >> 2] | 0, 0) | 0;
	                    c[v >> 2] = By(c[v >> 2] | 0, 152080) | 0
	                } else HC(v, c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[v >> 2] = By(c[v >> 2] | 0, c[q >> 2] | 0) | 0;
	                c[v >> 2] = By(c[v >> 2] | 0, 142704) | 0;
	                IC(c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[v >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0);
	                if (!(c[v >> 2] | 0)) {
	                    i = l;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                c[v >> 2] = 0;
	                i = l;
	                return
	            }

	            function DB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](84) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tC(c[e >> 2] | 0, 170208, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 84 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[(c[f >> 2] | 0) + 60 >> 2] = c[(c[e >> 2] | 0) + 80 >> 2];
	                    yP(c[(c[f >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function EB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tC(0, 170080, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 36 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                a = JB() | 0;
	                c[(c[f >> 2] | 0) + 12 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                    tC(0, 170120, 0);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = JB() | 0;
	                c[(c[f >> 2] | 0) + 20 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                    tC(0, 170160, 0);
	                    sB(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 8 >> 2] = c[e >> 2];
	                    yP(c[e >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function FB(a, b, d, e, f, g, h, j, k, l) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0;
	                m = i;
	                i = i + 96 | 0;
	                n = m + 88 | 0;
	                o = m + 84 | 0;
	                p = m + 80 | 0;
	                q = m + 76 | 0;
	                r = m + 72 | 0;
	                s = m + 68 | 0;
	                t = m + 64 | 0;
	                u = m + 60 | 0;
	                v = m + 56 | 0;
	                w = m + 52 | 0;
	                x = m + 48 | 0;
	                y = m + 44 | 0;
	                z = m + 40 | 0;
	                A = m + 36 | 0;
	                B = m + 32 | 0;
	                C = m + 28 | 0;
	                D = m + 24 | 0;
	                E = m + 20 | 0;
	                F = m + 16 | 0;
	                G = m + 12 | 0;
	                H = m + 8 | 0;
	                I = m + 4 | 0;
	                J = m;
	                c[o >> 2] = a;
	                c[p >> 2] = b;
	                c[q >> 2] = d;
	                c[r >> 2] = e;
	                c[s >> 2] = f;
	                c[t >> 2] = g;
	                c[u >> 2] = h;
	                c[v >> 2] = j;
	                c[w >> 2] = k;
	                c[x >> 2] = l;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                c[A >> 2] = 0;
	                c[B >> 2] = 0;
	                c[C >> 2] = 0;
	                c[D >> 2] = 0;
	                c[E >> 2] = 0;
	                c[F >> 2] = 0;
	                if (c[x >> 2] | 0)c[c[x >> 2] >> 2] = 0;
	                l = c[p >> 2] | 0;
	                if ((l | 0) == 2)c[C >> 2] = 3050; else if ((l | 0) == 3)c[C >> 2] = 3081; else if ((l | 0) == 0 | (l | 0) == 1)c[C >> 2] = 3082;
	                a:do if (((c[p >> 2] | 0) != 0 ? (c[(c[(c[o >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[o >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) > 0 : 0) {
	                    if (((c[q >> 2] | 0) != 0 ? (c[F >> 2] = JC(c[o >> 2] | 0, c[q >> 2] | 0) | 0, (c[F >> 2] | 0) != 0) : 0) ? (c[(c[(c[o >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) == (c[F >> 2] | 0) : 0) {
	                        AB(c[o >> 2] | 0, c[C >> 2] | 0, c[u >> 2] | 0, 0, 169048, 0, 0);
	                        K = 92;
	                        break
	                    }
	                    c[z >> 2] = KC() | 0;
	                    if (!(c[z >> 2] | 0)) {
	                        c[n >> 2] = -1;
	                        L = c[n >> 2] | 0;
	                        i = m;
	                        return L | 0
	                    }
	                    LC(c[(c[(c[o >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0, c[z >> 2] | 0);
	                    c[(c[z >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                    if ((c[p >> 2] | 0) == 0 | (c[p >> 2] | 0) == 1) {
	                        c[(c[z >> 2] | 0) + 8 >> 2] = c[w >> 2];
	                        if (!(c[q >> 2] | 0)) {
	                            K = 92;
	                            break
	                        }
	                        c[y >> 2] = c[w >> 2]
	                    }
	                    do if (c[F >> 2] | 0) {
	                        if ((c[p >> 2] | 0) == 0 | (c[p >> 2] | 0) == 1 ? (c[(c[F >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) {
	                            if (!(c[q >> 2] | 0))c[q >> 2] = 169104;
	                            if (qy(c[q >> 2] | 0, c[(c[F >> 2] | 0) + 8 >> 2] | 0) | 0)break;
	                            AB(c[o >> 2] | 0, c[C >> 2] | 0, c[u >> 2] | 0, 0, 169128, c[q >> 2] | 0, 0);
	                            K = 92;
	                            break a
	                        }
	                        if (!((c[p >> 2] | 0) == 0 | (c[p >> 2] | 0) == 1) ? (c[(c[F >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            if (!(c[q >> 2] | 0))c[q >> 2] = 169104;
	                            if (!(qy(c[q >> 2] | 0, c[(c[F >> 2] | 0) + 8 >> 2] | 0) | 0)) {
	                                AB(c[o >> 2] | 0, c[C >> 2] | 0, c[u >> 2] | 0, 0, 169216, c[q >> 2] | 0, 0);
	                                K = 92;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    l = (c[F >> 2] | 0) != 0;
	                    do if ((c[p >> 2] | 0) == 0 | (c[p >> 2] | 0) == 1) {
	                        if (l) {
	                            c[(c[z >> 2] | 0) + 12 >> 2] = c[F >> 2];
	                            K = 92;
	                            break a
	                        }
	                        c[F >> 2] = MC(c[o >> 2] | 0, c[w >> 2] | 0, 1) | 0;
	                        if (c[F >> 2] | 0) {
	                            c[(c[z >> 2] | 0) + 12 >> 2] = c[F >> 2];
	                            k = c[q >> 2] | 0;
	                            j = (c[F >> 2] | 0) + 8 | 0;
	                            if (!(c[(c[F >> 2] | 0) + 8 >> 2] | 0)) {
	                                c[j >> 2] = k;
	                                break
	                            }
	                            if (qy(k, c[j >> 2] | 0) | 0) {
	                                K = 92;
	                                break a
	                            }
	                            if (!(c[q >> 2] | 0))c[q >> 2] = 169104;
	                            NC(c[o >> 2] | 0, 3083, c[u >> 2] | 0, 0, 169304, c[q >> 2] | 0, c[w >> 2] | 0, c[(c[F >> 2] | 0) + 8 >> 2] | 0);
	                            K = 92;
	                            break a
	                        }
	                    } else if (l) {
	                        if ((c[(c[F >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[F >> 2] | 0) + 16 >> 2] | 0) != (c[v >> 2] | 0) : 0) {
	                            c[G >> 2] = OC(c[o >> 2] | 0, c[q >> 2] | 0, c[v >> 2] | 0) | 0;
	                            if (c[G >> 2] | 0) {
	                                c[(c[z >> 2] | 0) + 12 >> 2] = c[G >> 2];
	                                K = 92;
	                                break a
	                            } else {
	                                c[F >> 2] = 0;
	                                break
	                            }
	                        }
	                        c[(c[z >> 2] | 0) + 12 >> 2] = c[F >> 2];
	                        K = 92;
	                        break a
	                    } while (0);
	                    if ((c[F >> 2] | 0) != 0 ? (c[(c[F >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)xB(c[o >> 2] | 0, 169448, 169472); else K = 52
	                } else K = 52; while (0);
	                b:do if ((K | 0) == 52) {
	                    do if (c[r >> 2] | 0) {
	                        c[A >> 2] = c[r >> 2];
	                        c[E >> 2] = 1;
	                        if (c[(c[r >> 2] | 0) + 72 >> 2] | 0) {
	                            c[q >> 2] = AP(c[(c[o >> 2] | 0) + 80 >> 2] | 0, c[(c[r >> 2] | 0) + 72 >> 2] | 0, -1) | 0;
	                            K = 73;
	                            break
	                        } else {
	                            c[q >> 2] = 169104;
	                            K = 73;
	                            break
	                        }
	                    } else {
	                        if (!((c[q >> 2] | 0) != 0 | (c[s >> 2] | 0) != 0)) {
	                            PC(c[o >> 2] | 0, 0, 1758, 169640, 0, 0);
	                            break b
	                        }
	                        c[H >> 2] = Be() | 0;
	                        if (!(c[H >> 2] | 0)) {
	                            tC(0, 169552, 0);
	                            break b
	                        }
	                        if ((c[(c[o >> 2] | 0) + 80 >> 2] | 0) != 0 ? (c[(c[H >> 2] | 0) + 296 >> 2] | 0) != 0 : 0) {
	                            zP(c[(c[H >> 2] | 0) + 296 >> 2] | 0);
	                            c[(c[H >> 2] | 0) + 296 >> 2] = c[(c[o >> 2] | 0) + 80 >> 2];
	                            yP(c[(c[H >> 2] | 0) + 296 >> 2] | 0) | 0
	                        }
	                        if (!(c[q >> 2] | 0)) {
	                            if ((c[s >> 2] | 0) != 0 ? (c[A >> 2] = lg(c[H >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0, 0, 0, 2) | 0, c[q >> 2] = 169104, (c[A >> 2] | 0) != 0) : 0) {
	                                G = my(c[q >> 2] | 0) | 0;
	                                c[(c[A >> 2] | 0) + 72 >> 2] = G
	                            }
	                        } else c[A >> 2] = kg(c[H >> 2] | 0, c[q >> 2] | 0, 0, 2) | 0;
	                        do if (!(c[A >> 2] | 0)) {
	                            c[I >> 2] = de() | 0;
	                            if ((c[I >> 2] | 0) != 0 ? (c[c[I >> 2] >> 2] | 0) == 8 : 0)break;
	                            c[D >> 2] = 1;
	                            c[B >> 2] = 3067;
	                            AB(c[o >> 2] | 0, c[B >> 2] | 0, c[u >> 2] | 0, 0, 169600, c[q >> 2] | 0, 0)
	                        } while (0);
	                        Ae(c[H >> 2] | 0);
	                        if (!((c[A >> 2] | 0) == 0 & (c[D >> 2] | 0) != 0))K = 73
	                    } while (0);
	                    c:do if ((K | 0) == 73) {
	                        do if (c[A >> 2] | 0) {
	                            c[J >> 2] = 0;
	                            c[D >> 2] = 1;
	                            c[J >> 2] = Pi(c[A >> 2] | 0) | 0;
	                            G = c[o >> 2] | 0;
	                            if (!(c[J >> 2] | 0)) {
	                                AB(G, 1759, c[u >> 2] | 0, 0, 169720, c[q >> 2] | 0, 0);
	                                break c
	                            }
	                            QC(G, c[J >> 2] | 0);
	                            if ((((c[J >> 2] | 0) != 0 ? (c[(c[J >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[J >> 2] | 0) + 8 >> 2] | 0, 169768) | 0) != 0 : 0) ? (qy(c[(c[(c[J >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                c[y >> 2] = RC(c[o >> 2] | 0, c[J >> 2] | 0, 168888) | 0;
	                                break
	                            }
	                            AB(c[o >> 2] | 0, 1772, c[u >> 2] | 0, 0, 169776, c[q >> 2] | 0, 0);
	                            break c
	                        } while (0);
	                        if ((c[F >> 2] | 0) == 0 & (c[D >> 2] | 0) != 0 ? (c[F >> 2] = SC(c[o >> 2] | 0, c[p >> 2] | 0, c[y >> 2] | 0) | 0, (c[F >> 2] | 0) == 0) : 0)break b;
	                        if (!(c[F >> 2] | 0)) {
	                            K = 92;
	                            break b
	                        }
	                        c[(c[F >> 2] | 0) + 8 >> 2] = c[q >> 2];
	                        c[(c[F >> 2] | 0) + 28 >> 2] = c[D >> 2];
	                        if ((c[A >> 2] | 0) != 0 ? (c[(c[F >> 2] | 0) + 20 >> 2] = c[A >> 2], c[(c[F >> 2] | 0) + 16 >> 2] = c[y >> 2], c[(c[F >> 2] | 0) + 12 >> 2] = c[y >> 2], (c[E >> 2] | 0) != 0) : 0)c[(c[F >> 2] | 0) + 40 >> 2] = 1;
	                        if ((c[p >> 2] | 0) == 0 | (c[p >> 2] | 0) == 1) {
	                            G = (c[F >> 2] | 0) + 36 | 0;
	                            c[G >> 2] = (c[G >> 2] | 0) + 1
	                        }
	                        if (!(c[z >> 2] | 0)) {
	                            K = 92;
	                            break b
	                        }
	                        c[(c[z >> 2] | 0) + 12 >> 2] = c[F >> 2];
	                        K = 92;
	                        break b
	                    } while (0);
	                    if (!((c[A >> 2] | 0) == 0 | (c[E >> 2] | 0) != 0) ? (Th(c[A >> 2] | 0), (c[F >> 2] | 0) != 0) : 0)c[(c[F >> 2] | 0) + 20 >> 2] = 0;
	                    c[n >> 2] = c[(c[o >> 2] | 0) + 16 >> 2];
	                    L = c[n >> 2] | 0;
	                    i = m;
	                    return L | 0
	                } while (0);
	                if ((K | 0) == 92) {
	                    if (c[x >> 2] | 0)c[c[x >> 2] >> 2] = c[F >> 2];
	                    c[n >> 2] = 0;
	                    L = c[n >> 2] | 0;
	                    i = m;
	                    return L | 0
	                }
	                if (!((c[A >> 2] | 0) == 0 | (c[E >> 2] | 0) != 0) ? (Th(c[A >> 2] | 0), (c[F >> 2] | 0) != 0) : 0)c[(c[F >> 2] | 0) + 20 >> 2] = 0;
	                c[n >> 2] = -1;
	                L = c[n >> 2] | 0;
	                i = m;
	                return L | 0
	            }

	            function GB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[o >> 2] = c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2];
	                c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                c[k >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)TC(c[g >> 2] | 0);
	                c[(c[g >> 2] | 0) + 16 >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                c[(c[f >> 2] | 0) + 36 >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 112 >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] = c[h >> 2];
	                if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (qy(c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)c[(c[f >> 2] | 0) + 96 >> 2] = 1;
	                d = (c[h >> 2] | 0) + 32 | 0;
	                c[d >> 2] = (c[d >> 2] | 0) + 1;
	                c[l >> 2] = Pi(c[(c[h >> 2] | 0) + 20 >> 2] | 0) | 0;
	                c[m >> 2] = UC(c[f >> 2] | 0, c[g >> 2] | 0, c[l >> 2] | 0) | 0;
	                if ((((c[m >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[n >> 2] = c[(c[f >> 2] | 0) + 20 >> 2], c[m >> 2] = VC(c[f >> 2] | 0, c[g >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0, (c[m >> 2] | 0) == 0 & (c[m >> 2] | 0) == 0) : 0) ? (c[n >> 2] | 0) != (c[(c[f >> 2] | 0) + 20 >> 2] | 0) : 0)c[m >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                c[(c[g >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                i = e;
	                return c[m >> 2] | 0
	            }

	            function HB(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 40 | 0;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                o = d + 4 | 0;
	                p = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                c[n >> 2] = 0;
	                c[o >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    if (!(c[(c[h >> 2] | 0) + 16 >> 2] | 0))c[(c[h >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                    WC(c[f >> 2] | 0) | 0;
	                    XC(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 84 >> 2] = 0;
	                    c[k >> 2] = c[c[(c[h >> 2] | 0) + 20 >> 2] >> 2];
	                    c[l >> 2] = c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2];
	                    c[m >> 2] = 0;
	                    a:while (1) {
	                        if ((c[m >> 2] | 0) >= (c[l >> 2] | 0)) {
	                            q = 20;
	                            break
	                        }
	                        c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                        switch (c[c[j >> 2] >> 2] | 0) {
	                            case 26:
	                            {
	                                $C(c[j >> 2] | 0, c[f >> 2] | 0) | 0;
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 8:
	                            case 7:
	                            case 6:
	                            {
	                                bD(c[f >> 2] | 0, c[j >> 2] | 0);
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 4:
	                            case 5:
	                            {
	                                ZC(c[j >> 2] | 0, c[f >> 2] | 0);
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 14:
	                            {
	                                YC(c[j >> 2] | 0, c[f >> 2] | 0);
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 15:
	                            {
	                                _C(c[j >> 2] | 0, c[f >> 2] | 0) | 0;
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 2e3:
	                            {
	                                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 16)aD(c[j >> 2] | 0, c[f >> 2] | 0) | 0;
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 2001:
	                            {
	                                dD(c[j >> 2] | 0, c[f >> 2] | 0) | 0;
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            case 24:
	                            case 22:
	                            case 23:
	                            {
	                                cD(c[j >> 2] | 0, c[f >> 2] | 0) | 0;
	                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                    q = 115;
	                                    break a
	                                }
	                                break
	                            }
	                            default:
	                            {
	                            }
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    b:do if ((q | 0) == 20) {
	                        c:do if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                            c[m >> 2] = 0;
	                            while (1) {
	                                if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                g = c[c[j >> 2] >> 2] | 0;
	                                if ((g | 0) == 16) {
	                                    gD(c[j >> 2] | 0, c[f >> 2] | 0) | 0;
	                                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                        q = 115;
	                                        break b
	                                    }
	                                    if (c[(c[f >> 2] | 0) + 20 >> 2] | 0)break c
	                                } else if ((g | 0) == 4 | (g | 0) == 5) {
	                                    eD(c[j >> 2] | 0, c[f >> 2] | 0);
	                                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                        q = 115;
	                                        break b
	                                    }
	                                    if (c[(c[f >> 2] | 0) + 20 >> 2] | 0)break c
	                                } else if ((g | 0) == 17) {
	                                    fD(c[j >> 2] | 0, c[f >> 2] | 0);
	                                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                        q = 115;
	                                        break b
	                                    }
	                                    if (c[(c[f >> 2] | 0) + 20 >> 2] | 0)break c
	                                }
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                c[m >> 2] = 0;
	                                while (1) {
	                                    if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                    c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                    if (((c[c[j >> 2] >> 2] | 0) + -6 | 0) >>> 0 < 2)hD(c[f >> 2] | 0, c[j >> 2] | 0);
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                }
	                                if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                    c[m >> 2] = 0;
	                                    while (1) {
	                                        if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                        c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                        if ((((c[c[j >> 2] >> 2] | 0) == 16 ? (c[(c[j >> 2] | 0) + 36 >> 2] & 1 | 0) == 0 : 0) ? (c[(c[j >> 2] | 0) + 36 >> 2] & 16 | 0) != 0 : 0) ? (iD(c[f >> 2] | 0, c[j >> 2] | 0) | 0, (c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) : 0) {
	                                            q = 115;
	                                            break b
	                                        }
	                                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                                    }
	                                    if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                        c[m >> 2] = 0;
	                                        while (1) {
	                                            if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                            c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                            if ((((c[c[j >> 2] >> 2] | 0) == 4 ? (c[c[j >> 2] >> 2] | 0) != 1 : 0) ? (c[(c[j >> 2] | 0) + 48 >> 2] & 536870912 | 0) == 0 : 0) ? (jD(c[f >> 2] | 0, c[j >> 2] | 0) | 0, (c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) : 0) {
	                                                q = 115;
	                                                break b
	                                            }
	                                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                                        }
	                                        if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                            c[m >> 2] = 0;
	                                            while (1) {
	                                                if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                if (((c[c[j >> 2] >> 2] | 0) == 4 ? (c[(c[j >> 2] | 0) + 92 >> 2] | 0) != 0 : 0) ? (kD(c[f >> 2] | 0, c[j >> 2] | 0) | 0, (c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) : 0) {
	                                                    q = 115;
	                                                    break b
	                                                }
	                                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                                            }
	                                            if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                c[m >> 2] = 0;
	                                                while (1) {
	                                                    if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                    c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                    if ((((c[c[j >> 2] >> 2] | 0) == 4 ? (c[c[j >> 2] >> 2] | 0) != 1 : 0) ? (c[(c[j >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) ? (lD(c[f >> 2] | 0, c[j >> 2] | 0) | 0, (c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) : 0) {
	                                                        q = 115;
	                                                        break b
	                                                    }
	                                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                }
	                                                if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                    c[m >> 2] = 0;
	                                                    while (1) {
	                                                        if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                        c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                        if ((c[c[j >> 2] >> 2] | 0) == 15 ? (mD(c[f >> 2] | 0, c[j >> 2] | 0) | 0, (c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) : 0) {
	                                                            q = 115;
	                                                            break b
	                                                        }
	                                                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                    }
	                                                    if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                        c[m >> 2] = 0;
	                                                        while (1) {
	                                                            if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                            c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                            if (((c[c[j >> 2] >> 2] | 0) == 26 ? (c[(c[j >> 2] | 0) + 28 >> 2] | 0) != 0 : 0) ? (nD(c[f >> 2] | 0, c[j >> 2] | 0) | 0, (c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) : 0) {
	                                                                q = 115;
	                                                                break b
	                                                            }
	                                                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                        }
	                                                        if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                            c[m >> 2] = 0;
	                                                            while (1) {
	                                                                if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                                c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                                do if ((c[c[j >> 2] >> 2] | 0) == 16 ? (c[(c[j >> 2] | 0) + 56 >> 2] | 0) != 0 : 0) {
	                                                                    if ((c[(c[(c[j >> 2] | 0) + 56 >> 2] | 0) + 4 >> 2] | 0) <= 1)break;
	                                                                    oD(c[f >> 2] | 0, c[j >> 2] | 0) | 0;
	                                                                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                                                        q = 115;
	                                                                        break b
	                                                                    }
	                                                                } while (0);
	                                                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                            }
	                                                            if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                                if (c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0)pD(c[f >> 2] | 0) | 0;
	                                                                if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                                    c[m >> 2] = 0;
	                                                                    while (1) {
	                                                                        if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                                        c[j >> 2] = c[(c[c[(c[h >> 2] | 0) + 20 >> 2] >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                                        do if ((c[c[j >> 2] >> 2] | 0) == 5) {
	                                                                            if ((c[c[j >> 2] >> 2] | 0) == 1)break;
	                                                                            if (c[(c[j >> 2] | 0) + 48 >> 2] & 4194304)break;
	                                                                            qD(c[f >> 2] | 0, c[j >> 2] | 0) | 0;
	                                                                            if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                                                                q = 115;
	                                                                                break b
	                                                                            }
	                                                                        } while (0);
	                                                                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                                    }
	                                                                    if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                                        c[k >> 2] = c[c[(c[h >> 2] | 0) + 20 >> 2] >> 2];
	                                                                        c[l >> 2] = c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2];
	                                                                        c[m >> 2] = 0;
	                                                                        while (1) {
	                                                                            if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                                            c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                                            do if ((c[c[j >> 2] >> 2] | 0) == 14) {
	                                                                                c[p >> 2] = c[j >> 2];
	                                                                                if (c[(c[p >> 2] | 0) + 48 >> 2] & 262144)break;
	                                                                                rD(c[p >> 2] | 0, c[f >> 2] | 0);
	                                                                                if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 3069) {
	                                                                                    q = 115;
	                                                                                    break b
	                                                                                }
	                                                                            } while (0);
	                                                                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                                        }
	                                                                        if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                                                            c[m >> 2] = 0;
	                                                                            while (1) {
	                                                                                if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                                                                c[j >> 2] = c[(c[k >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                                                                if ((c[c[j >> 2] >> 2] | 0) == 5)sD(c[j >> 2] | 0, c[f >> 2] | 0);
	                                                                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                                            }
	                                                                            if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0))break b
	                                                                        }
	                                                                    }
	                                                                }
	                                                            }
	                                                        }
	                                                    }
	                                                }
	                                            }
	                                        }
	                                    }
	                                }
	                            }
	                        } while (0);
	                        c[n >> 2] = c[(c[f >> 2] | 0) + 16 >> 2]
	                    } while (0);
	                    if ((q | 0) == 115)c[n >> 2] = -1;
	                    c[(c[h >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                    c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] = 0;
	                    if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                        Kj(c[(c[h >> 2] | 0) + 24 >> 2] | 0, 356);
	                        c[(c[h >> 2] | 0) + 24 >> 2] = 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 28 >> 2] | 0) {
	                        vC(c[(c[h >> 2] | 0) + 28 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 28 >> 2] = 0
	                    }
	                    c[e >> 2] = c[n >> 2];
	                    r = c[e >> 2] | 0;
	                    i = d;
	                    return r | 0
	                }
	                c[e >> 2] = 0;
	                r = c[e >> 2] | 0;
	                i = d;
	                return r | 0
	            }

	            function IB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (c[f >> 2] | 0) {
	                    d = (c[f >> 2] | 0) + 56 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1;
	                    c[(c[f >> 2] | 0) + 52 >> 2] = 1818
	                }
	                ce(17, 2, c[h >> 2] | 0, 0, c[g >> 2] | 0);
	                i = e;
	                return
	            }

	            function JB() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    tC(0, 156200, 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    f = c[d >> 2] | 0;
	                    c[f + 0 >> 2] = 0;
	                    c[f + 4 >> 2] = 0;
	                    c[f + 8 >> 2] = 0;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function KB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if ((pC(c[e >> 2] | 0) | 0) < 0) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[e >> 2] | 0;
	                do if (!(c[(c[e >> 2] | 0) + 24 >> 2] | 0)) {
	                    if (!(c[a + 160 >> 2] | 0)) {
	                        if ((c[(c[e >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                            c[f >> 2] = Qf(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            break
	                        }
	                        xB(c[e >> 2] | 0, 155872, 155888);
	                        c[f >> 2] = -1
	                    }
	                } else c[f >> 2] = tD(a) | 0; while (0);
	                qC(c[e >> 2] | 0);
	                if (!(c[f >> 2] | 0))c[f >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function LB(a, b, e, f, g, h, j, k, l) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                m = i;
	                i = i + 64 | 0;
	                n = m + 56 | 0;
	                o = m + 52 | 0;
	                p = m + 44 | 0;
	                q = m + 40 | 0;
	                r = m + 36 | 0;
	                s = m + 32 | 0;
	                t = m + 24 | 0;
	                u = m + 20 | 0;
	                v = m + 16 | 0;
	                w = m + 12 | 0;
	                x = m + 8 | 0;
	                y = m + 4 | 0;
	                z = m;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[m + 48 >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = j;
	                c[m + 28 >> 2] = k;
	                c[t >> 2] = l;
	                c[u >> 2] = c[n >> 2];
	                n = (c[u >> 2] | 0) + 96 | 0;
	                c[n >> 2] = (c[n >> 2] | 0) + 1;
	                if ((c[(c[u >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[u >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[u >> 2] | 0) + 176 >> 2] | 0) : 0) {
	                    i = m;
	                    return
	                }
	                n = (uD(c[u >> 2] | 0) | 0) == -1;
	                l = c[u >> 2] | 0;
	                a:do if (!n) {
	                    c[w >> 2] = c[l + 108 >> 2];
	                    k = NP(c[(c[u >> 2] | 0) + 40 >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 8 >> 2] = k;
	                    c[(c[w >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                    c[(c[w >> 2] | 0) + 16 >> 2] = c[p >> 2];
	                    k = (c[w >> 2] | 0) + 32 | 0;
	                    c[k >> 2] = c[k >> 2] | 32;
	                    b:do if (c[q >> 2] | 0) {
	                        c[x >> 2] = 0;
	                        c[y >> 2] = 0;
	                        while (1) {
	                            if ((c[x >> 2] | 0) >= (c[q >> 2] | 0))break b;
	                            if (c[(c[w >> 2] | 0) + 64 >> 2] | 0) {
	                                if ((c[(c[w >> 2] | 0) + 72 >> 2] | 0) <= (c[(c[w >> 2] | 0) + 68 >> 2] | 0) ? (k = (c[w >> 2] | 0) + 72 | 0, c[k >> 2] = c[k >> 2] << 1, k = Hb[c[135760 >> 2] & 511](c[(c[w >> 2] | 0) + 64 >> 2] | 0, c[(c[w >> 2] | 0) + 72 >> 2] << 1 << 2) | 0, c[(c[w >> 2] | 0) + 64 >> 2] = k, (c[(c[w >> 2] | 0) + 64 >> 2] | 0) == 0) : 0) {
	                                    A = 14;
	                                    break
	                                }
	                            } else {
	                                k = Cb[c[135744 >> 2] & 511](40) | 0;
	                                c[(c[w >> 2] | 0) + 64 >> 2] = k;
	                                if (!(c[(c[w >> 2] | 0) + 64 >> 2] | 0)) {
	                                    A = 10;
	                                    break
	                                }
	                                c[(c[w >> 2] | 0) + 68 >> 2] = 0;
	                                c[(c[w >> 2] | 0) + 72 >> 2] = 5
	                            }
	                            c[(c[(c[w >> 2] | 0) + 64 >> 2] | 0) + (c[(c[w >> 2] | 0) + 68 >> 2] << 1 << 2) >> 2] = c[(c[r >> 2] | 0) + (c[y >> 2] << 2) >> 2];
	                            if (!(d[c[(c[r >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2] >> 0] | 0))c[(c[(c[w >> 2] | 0) + 64 >> 2] | 0) + ((c[(c[w >> 2] | 0) + 68 >> 2] << 1) + 1 << 2) >> 2] = 0; else c[(c[(c[w >> 2] | 0) + 64 >> 2] | 0) + ((c[(c[w >> 2] | 0) + 68 >> 2] << 1) + 1 << 2) >> 2] = c[(c[r >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2];
	                            k = (c[w >> 2] | 0) + 68 | 0;
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            c[x >> 2] = (c[x >> 2] | 0) + 1;
	                            c[y >> 2] = (c[y >> 2] | 0) + 2
	                        }
	                        if ((A | 0) == 10) {
	                            IB(c[u >> 2] | 0, 144584, 0);
	                            break a
	                        } else if ((A | 0) == 14) {
	                            IB(c[u >> 2] | 0, 144640, 0);
	                            break a
	                        }
	                    } while (0);
	                    c:do if (c[s >> 2] | 0) {
	                        c[y >> 2] = 0;
	                        c[x >> 2] = 0;
	                        while (1) {
	                            if ((c[x >> 2] | 0) >= (c[s >> 2] | 0))break c;
	                            c[z >> 2] = ly(c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 3 << 2) >> 2] | 0, (c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 4 << 2) >> 2] | 0) - (c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 3 << 2) >> 2] | 0) | 0) | 0;
	                            c[v >> 2] = vD(c[u >> 2] | 0, 0, c[(c[w >> 2] | 0) + 8 >> 2] | 0, c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0, c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 2 << 2) >> 2] | 0, 0, c[z >> 2] | 0, 1) | 0;
	                            if ((c[v >> 2] | 0) == -1)break;
	                            c[x >> 2] = (c[x >> 2] | 0) + 1;
	                            c[y >> 2] = (c[y >> 2] | 0) + 5
	                        }
	                        xB(c[u >> 2] | 0, 144504, 144696);
	                        break a
	                    } while (0);
	                    c[v >> 2] = wD(c[u >> 2] | 0) | 0;
	                    if ((c[v >> 2] | 0) != 0 & (c[v >> 2] | 0) == -1) {
	                        xB(c[u >> 2] | 0, 144504, 144744);
	                        break
	                    } else {
	                        i = m;
	                        return
	                    }
	                } else xB(l, 144504, 144544); while (0);
	                c[(c[u >> 2] | 0) + 52 >> 2] = -1;
	                Uf(c[(c[u >> 2] | 0) + 40 >> 2] | 0);
	                i = m;
	                return
	            }

	            function MB(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[f + 12 >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = c[g >> 2];
	                do if ((c[(c[k >> 2] | 0) + 176 >> 2] | 0) != -1) {
	                    g = c[k >> 2] | 0;
	                    if ((c[(c[k >> 2] | 0) + 96 >> 2] | 0) <= (c[(c[k >> 2] | 0) + 176 >> 2] | 0)) {
	                        c[g + 176 >> 2] = -1;
	                        break
	                    }
	                    e = g + 96 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + -1;
	                    i = f;
	                    return
	                } while (0);
	                if (!((qy(c[(c[(c[k >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0) | 0) != 0 ? (qy(c[(c[(c[k >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0))xB(c[k >> 2] | 0, 141632, 141664);
	                c[l >> 2] = xD(c[k >> 2] | 0) | 0;
	                if (!((c[l >> 2] | 0) != 0 & (c[l >> 2] | 0) < 0)) {
	                    i = f;
	                    return
	                }
	                xB(c[k >> 2] | 0, 141632, 141688);
	                c[(c[k >> 2] | 0) + 52 >> 2] = -1;
	                Uf(c[(c[k >> 2] | 0) + 40 >> 2] | 0);
	                i = f;
	                return
	            }

	            function NB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if ((c[(c[j >> 2] | 0) + 96 >> 2] | 0) < 0) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[j >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[j >> 2] | 0) + 176 >> 2] | 0) : 0) {
	                    i = e;
	                    return
	                }
	                if (c[(c[(c[j >> 2] | 0) + 108 >> 2] | 0) + 32 >> 2] & 32) {
	                    f = (c[(c[j >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                    c[f >> 2] = c[f >> 2] ^ 32
	                }
	                if ((yD(c[j >> 2] | 0, 3, c[g >> 2] | 0, c[h >> 2] | 0, 3, 0) | 0) != -1) {
	                    i = e;
	                    return
	                }
	                xB(c[j >> 2] | 0, 141304, 141336);
	                c[(c[j >> 2] | 0) + 52 >> 2] = -1;
	                Uf(c[(c[j >> 2] | 0) + 40 >> 2] | 0);
	                i = e;
	                return
	            }

	            function OB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if ((c[(c[j >> 2] | 0) + 96 >> 2] | 0) < 0) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[j >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[j >> 2] | 0) + 176 >> 2] | 0) : 0) {
	                    i = e;
	                    return
	                }
	                if (c[(c[(c[j >> 2] | 0) + 108 >> 2] | 0) + 32 >> 2] & 32) {
	                    f = (c[(c[j >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                    c[f >> 2] = c[f >> 2] ^ 32
	                }
	                if ((yD(c[j >> 2] | 0, 4, c[g >> 2] | 0, c[h >> 2] | 0, 3, 0) | 0) != -1) {
	                    i = e;
	                    return
	                }
	                xB(c[j >> 2] | 0, 141304, 141336);
	                c[(c[j >> 2] | 0) + 52 >> 2] = -1;
	                Uf(c[(c[j >> 2] | 0) + 40 >> 2] | 0);
	                i = e;
	                return
	            }

	            function PB(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 8 | 0;
	                c[f >> 2] = a;
	                c[d + 12 >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                if ((c[(c[g >> 2] | 0) + 96 >> 2] | 0) < 0) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[g >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 176 >> 2] | 0) : 0) {
	                    i = d;
	                    return
	                }
	                g = c[33976] | 0;
	                f = c[33980] | 0;
	                c[e >> 2] = 140328;
	                c[e + 4 >> 2] = 27281;
	                Db[g & 511](f, 140296, e);
	                i = d;
	                return
	            }

	            function QB(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[c[(c[l >> 2] | 0) + 8 >> 2] >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Jb[c[c[(c[l >> 2] | 0) + 8 >> 2] >> 2] & 511](c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function RB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = Cb[c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 4 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function SB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = Cb[c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function TB(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = Cb[c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] & 511](c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function UB(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[g >> 2];
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                    c[f >> 2] = vb[c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] & 511](c[(c[k >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function VB(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[f >> 2];
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[e >> 2] = Hb[c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 20 >> 2] & 511](c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function WB(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = c[j >> 2];
	                if (!(c[p >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if (!(c[(c[p >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if (!(c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                Gb[c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] & 511](c[(c[p >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0);
	                i = h;
	                return
	            }

	            function XB(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 28 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Jb[c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 28 >> 2] & 511](c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function YB(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 28 | 0;
	                l = j + 24 | 0;
	                m = j + 20 | 0;
	                n = j + 16 | 0;
	                o = j + 12 | 0;
	                p = j + 8 | 0;
	                q = j + 4 | 0;
	                r = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = c[k >> 2];
	                if (((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                    wb[c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + 32 >> 2] & 511](c[(c[r >> 2] | 0) + 16 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0);
	                    i = j;
	                    return
	                }
	                rm(c[q >> 2] | 0);
	                i = j;
	                return
	            }

	            function ZB(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Jb[c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] & 511](c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function _B(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g + 8 | 0;
	                m = g + 4 | 0;
	                n = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = c[h >> 2];
	                if (!(c[n >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if (!(c[(c[n >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if (!(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                xb[c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] & 511](c[(c[n >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                i = g;
	                return
	            }

	            function $B(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[e >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Ab[c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function aC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[d >> 2];
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] & 511](c[(c[e >> 2] | 0) + 16 >> 2] | 0);
	                i = b;
	                return
	            }

	            function bC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[d >> 2];
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 52 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 52 >> 2] & 511](c[(c[e >> 2] | 0) + 16 >> 2] | 0);
	                i = b;
	                return
	            }

	            function cC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 76 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Db[c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 76 >> 2] & 511](c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function dC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[e >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 80 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Ab[c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 80 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function eC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 8 | 0;
	                c[f >> 2] = a;
	                c[d + 12 >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 84 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                g = c[33976] | 0;
	                f = c[33980] | 0;
	                c[e >> 2] = 140328;
	                c[e + 4 >> 2] = 28421;
	                Db[g & 511](f, 140296, e);
	                i = d;
	                return
	            }

	            function fC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 8 | 0;
	                c[f >> 2] = a;
	                c[d + 12 >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 88 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                g = c[33976] | 0;
	                f = c[33980] | 0;
	                c[e >> 2] = 140328;
	                c[e + 4 >> 2] = 28429;
	                Db[g & 511](f, 140296, e);
	                i = d;
	                return
	            }

	            function gC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 8 | 0;
	                c[f >> 2] = a;
	                c[d + 12 >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 92 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                g = c[33976] | 0;
	                f = c[33980] | 0;
	                c[e >> 2] = 140328;
	                c[e + 4 >> 2] = 28437;
	                Db[g & 511](f, 140296, e);
	                i = d;
	                return
	            }

	            function hC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[f >> 2];
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 96 >> 2] | 0) != 0 : 0) {
	                    c[e >> 2] = Hb[c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 96 >> 2] & 511](c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function iC(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 104 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Jb[c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 104 >> 2] & 511](c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function jC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 68 >> 2] | 0) != 0 : 0)Db[c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 68 >> 2] & 511](c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                if (!(c[(c[j >> 2] | 0) + 148 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                NB(c[(c[j >> 2] | 0) + 148 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function kC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] | 0) != 0 : 0)Db[c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] & 511](c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                if (!(c[(c[j >> 2] | 0) + 148 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                NB(c[(c[j >> 2] | 0) + 148 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function lC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 100 >> 2] | 0) != 0 : 0)Db[c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 100 >> 2] & 511](c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                if (!(c[(c[j >> 2] | 0) + 148 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                OB(c[(c[j >> 2] | 0) + 148 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function mC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[e >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 64 >> 2] | 0) != 0 : 0)Ab[c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 64 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[f >> 2] | 0);
	                if (!(c[(c[g >> 2] | 0) + 148 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                PB(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function nC(a, b, d, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                l = i;
	                i = i + 48 | 0;
	                m = l + 36 | 0;
	                n = l + 32 | 0;
	                o = l + 28 | 0;
	                p = l + 24 | 0;
	                q = l + 20 | 0;
	                r = l + 16 | 0;
	                s = l + 12 | 0;
	                t = l + 8 | 0;
	                u = l + 4 | 0;
	                v = l;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = c[m >> 2];
	                if (!(c[v >> 2] | 0)) {
	                    i = l;
	                    return
	                }
	                if ((c[(c[v >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[v >> 2] | 0) + 8 >> 2] | 0) + 116 >> 2] | 0) != 0 : 0)Eb[c[(c[(c[v >> 2] | 0) + 8 >> 2] | 0) + 116 >> 2] & 511](c[(c[v >> 2] | 0) + 16 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0);
	                if (!(c[(c[v >> 2] | 0) + 148 >> 2] | 0)) {
	                    i = l;
	                    return
	                }
	                LB(c[(c[v >> 2] | 0) + 148 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0);
	                i = l;
	                return
	            }

	            function oC(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if ((c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 120 >> 2] | 0) != 0 : 0)Jb[c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 120 >> 2] & 511](c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                if (!(c[(c[l >> 2] | 0) + 148 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                MB(c[(c[l >> 2] | 0) + 148 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function pC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 96 >> 2] = -1;
	                c[(c[e >> 2] | 0) + 176 >> 2] = -1;
	                c[(c[e >> 2] | 0) + 92 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 184 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 188 >> 2] = 0;
	                do if (!(c[(c[e >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[(c[e >> 2] | 0) + 92 >> 2] = 1;
	                    if ((c[(c[e >> 2] | 0) + 88 >> 2] | 0) == 0 ? (zD(c[e >> 2] | 0) | 0) == -1 : 0) {
	                        c[d >> 2] = -1;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    c[f >> 2] = c[(c[e >> 2] | 0) + 88 >> 2];
	                    c[(c[f >> 2] | 0) + 104 >> 2] = 1;
	                    a = DB(c[f >> 2] | 0) | 0;
	                    c[(c[e >> 2] | 0) + 20 >> 2] = a;
	                    if (!(c[(c[e >> 2] | 0) + 20 >> 2] | 0)) {
	                        c[d >> 2] = -1;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    a = EB(c[(c[f >> 2] | 0) + 80 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = a;
	                    if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                        c[c[(c[f >> 2] | 0) + 28 >> 2] >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        c[(c[f >> 2] | 0) + 32 >> 2] = 1;
	                        break
	                    }
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } while (0);
	                Wj(c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] | 0, 357, c[e >> 2] | 0);
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function qC(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[(c[d >> 2] | 0) + 92 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    WA(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 20 >> 2] = 0
	                }
	                BD(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function rC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? !((c[h >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0) : 0) {
	                    if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = 0;
	                    if (c[j >> 2] | 0)c[c[j >> 2] >> 2] = 0;
	                    c[k >> 2] = c[g >> 2];
	                    if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                    if (c[j >> 2] | 0)c[c[j >> 2] >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = -1;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function sC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 4 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[f >> 2] = c[c[d >> 2] >> 2];
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) >= (c[(c[d >> 2] | 0) + 4 >> 2] | 0))break;
	                    c[e >> 2] = c[(c[f >> 2] | 0) + (c[g >> 2] << 2) >> 2];
	                    a:do if (c[e >> 2] | 0)do switch (c[c[e >> 2] >> 2] | 0) {
	                        case 18:
	                        {
	                            KD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 26:
	                        {
	                            DD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 8:
	                        case 7:
	                        case 6:
	                        {
	                            GD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 14:
	                        {
	                            FD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 2e3:
	                        {
	                            LD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 25:
	                        {
	                            if (c[(c[e >> 2] | 0) + 4 >> 2] | 0)mB(c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 5:
	                        case 4:
	                        {
	                            VA(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 15:
	                        {
	                            CD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 17:
	                        {
	                            ID(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 16:
	                        {
	                            HD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 2001:
	                        {
	                            ED(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 24:
	                        case 22:
	                        case 23:
	                        {
	                            JD(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        case 21:
	                        case 2:
	                        {
	                            TA(c[e >> 2] | 0);
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            ND(0, 170280, MD(c[e >> 2] | 0) | 0);
	                            break a
	                        }
	                    } while (0); while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                c[(c[d >> 2] | 0) + 4 >> 2] = 0;
	                i = b;
	                return
	            }

	            function tC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (c[f >> 2] | 0) {
	                    d = (c[f >> 2] | 0) + 20 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1
	                }
	                ce(16, 2, c[h >> 2] | 0, 0, c[g >> 2] | 0);
	                i = e;
	                return
	            }

	            function uC(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function vC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[d >> 2];
	                    c[d >> 2] = c[c[d >> 2] >> 2];
	                    zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                }
	                i = b;
	                return
	            }

	            function wC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    c[g >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    a:do if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                        c[h >> 2] = 0;
	                        while (1) {
	                            if ((c[h >> 2] | 0) >= (c[(c[f >> 2] | 0) + 28 >> 2] | 0))break a;
	                            if (c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0);
	                                c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + (c[h >> 2] << 2) >> 2] = 0
	                            }
	                            c[h >> 2] = (c[h >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    if (c[(c[f >> 2] | 0) + 32 >> 2] | 0) {
	                        b:do if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) == 24) {
	                            c[j >> 2] = 0;
	                            while (1) {
	                                if ((c[j >> 2] | 0) >= (c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0))break b;
	                                c[k >> 2] = c[(c[c[(c[f >> 2] | 0) + 32 >> 2] >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                                zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 4 >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                c[j >> 2] = (c[j >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        oB(c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 32 >> 2] = 0
	                    }
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    if (c[(c[e >> 2] | 0) + 124 >> 2] | 0)c[(c[f >> 2] | 0) + 12 >> 2] = c[(c[e >> 2] | 0) + 124 >> 2];
	                    c[(c[e >> 2] | 0) + 124 >> 2] = c[f >> 2];
	                    c[f >> 2] = c[g >> 2]
	                }
	                i = d;
	                return
	            }

	            function xC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[d >> 2];
	                    c[d >> 2] = c[c[d >> 2] >> 2];
	                    OD(c[e >> 2] | 0)
	                }
	                i = b;
	                return
	            }

	            function yC(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g + 8 | 0;
	                m = g + 4 | 0;
	                n = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[n >> 2] = my(158256) | 0;
	                c[n >> 2] = By(c[n >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[n >> 2] = By(c[n >> 2] | 0, 144448) | 0;
	                c[n >> 2] = By(c[n >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[n >> 2] = By(c[n >> 2] | 0, 142704) | 0;
	                k = c[h >> 2] | 0;
	                if ((c[c[h >> 2] >> 2] | 0) != 2) {
	                    if ((c[k >> 2] | 0) == 1)PD(c[h >> 2] | 0, 3069, 0, c[n >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0)
	                } else PD(k, 1818, 0, c[n >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0);
	                if (!(c[n >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                c[n >> 2] = 0;
	                i = g;
	                return
	            }

	            function zC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = QD(c[f >> 2] | 0) | 0;
	                if ((b | 0) == 3)c[e >> 2] = SH(c[g >> 2] | 0) | 0; else if ((b | 0) == 2)c[e >> 2] = RH(c[g >> 2] | 0) | 0; else c[e >> 2] = 0;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function AC(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 44 | 0;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                t = h + 4 | 0;
	                u = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) {
	                    xB(c[k >> 2] | 0, 157712, 157744);
	                    c[j >> 2] = -1;
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                c[q >> 2] = Fh(c[n >> 2] | 0, 1) | 0;
	                if (c[q >> 2] | 0) {
	                    c[j >> 2] = c[q >> 2];
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                c[r >> 2] = Ch(c[n >> 2] | 0, s) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    if (!(SD(c[l >> 2] | 0, c[n >> 2] | 0, 0) | 0)) {
	                        c[j >> 2] = 1;
	                        v = c[j >> 2] | 0;
	                        i = h;
	                        return v | 0
	                    }
	                    if ((c[p >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0 ? (g = NH(my(c[n >> 2] | 0) | 0, 0) | 0, c[c[o >> 2] >> 2] = g, (c[c[o >> 2] >> 2] | 0) == 0) : 0)c[q >> 2] = -1
	                } else {
	                    c[t >> 2] = 0;
	                    do if (!(c[k >> 2] | 0))if (c[m >> 2] | 0) {
	                        c[u >> 2] = cj(c[(c[m >> 2] | 0) + 32 >> 2] | 0, c[m >> 2] | 0, c[s >> 2] | 0) | 0;
	                        if (!(c[u >> 2] | 0))break;
	                        c[t >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                        break
	                    } else {
	                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        c[j >> 2] = 1;
	                        v = c[j >> 2] | 0;
	                        i = h;
	                        return v | 0
	                    } else c[t >> 2] = RD(c[k >> 2] | 0, c[s >> 2] | 0) | 0; while (0);
	                    if (!(c[t >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        c[j >> 2] = 1;
	                        v = c[j >> 2] | 0;
	                        i = h;
	                        return v | 0
	                    }
	                    if (SD(c[l >> 2] | 0, c[r >> 2] | 0, c[t >> 2] | 0) | 0) {
	                        if ((c[p >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0 ? (p = my(c[r >> 2] | 0) | 0, l = NH(p, my(c[t >> 2] | 0) | 0) | 0, c[c[o >> 2] >> 2] = l, (c[c[o >> 2] >> 2] | 0) == 0) : 0)c[q >> 2] = -1
	                    } else c[q >> 2] = 1;
	                    zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[r >> 2] | 0)
	                }
	                c[j >> 2] = c[q >> 2];
	                v = c[j >> 2] | 0;
	                i = h;
	                return v | 0
	            }

	            function BC(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[p >> 2] = 0;
	                c[m >> 2] = Fh(c[j >> 2] | 0, 1) | 0;
	                if (c[m >> 2] | 0)if ((c[m >> 2] | 0) == -1) {
	                    xB(c[h >> 2] | 0, 157656, 157680);
	                    c[g >> 2] = -1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else {
	                    c[g >> 2] = 1824;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[o >> 2] = Ch(c[j >> 2] | 0, p) | 0;
	                if (!(c[o >> 2] | 0))c[o >> 2] = my(c[j >> 2] | 0) | 0;
	                c[n >> 2] = RD(c[h >> 2] | 0, c[p >> 2] | 0) | 0;
	                if ((c[p >> 2] | 0) != 0 ? (zb[c[135736 >> 2] & 511](c[p >> 2] | 0), (c[n >> 2] | 0) == 0) : 0) {
	                    c[m >> 2] = 1824;
	                    p = c[h >> 2] | 0;
	                    h = c[m >> 2] | 0;
	                    e = IH(21) | 0;
	                    AB(p, h, 0, e, 154112, c[j >> 2] | 0, 0);
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[g >> 2] = c[m >> 2];
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                do if ((c[l >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0)if (c[n >> 2] | 0) {
	                    m = my(c[n >> 2] | 0) | 0;
	                    j = OH(m, c[o >> 2] | 0) | 0;
	                    c[c[k >> 2] >> 2] = j;
	                    break
	                } else {
	                    j = OH(0, c[o >> 2] | 0) | 0;
	                    c[c[k >> 2] >> 2] = j;
	                    break
	                } else zb[c[135736 >> 2] & 511](c[o >> 2] | 0); while (0);
	                c[g >> 2] = 0;
	                q = c[g >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function CC(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
	                k = i;
	                i = i + 80 | 0;
	                l = k + 68 | 0;
	                m = k + 64 | 0;
	                n = k + 60 | 0;
	                o = k + 56 | 0;
	                p = k + 52 | 0;
	                q = k + 48 | 0;
	                r = k + 44 | 0;
	                s = k + 40 | 0;
	                t = k + 36 | 0;
	                u = k + 32 | 0;
	                v = k + 28 | 0;
	                w = k + 24 | 0;
	                x = k + 20 | 0;
	                y = k + 16 | 0;
	                z = k + 12 | 0;
	                A = k + 8 | 0;
	                B = k + 4 | 0;
	                C = k;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[v >> 2] = 0;
	                c[z >> 2] = 0;
	                if ((c[c[o >> 2] >> 2] | 0) == 1) {
	                    c[l >> 2] = 0;
	                    D = c[l >> 2] | 0;
	                    i = k;
	                    return D | 0
	                }
	                a:do if (c[(c[o >> 2] | 0) + 96 >> 2] | 0) {
	                    j = c[o >> 2] | 0;
	                    b:do if (c[(c[o >> 2] | 0) + 48 >> 2] & 256) {
	                        c[w >> 2] = TD(j) | 0;
	                        do if ((c[(c[w >> 2] | 0) + 88 >> 2] | 0) == 1)E = 9; else {
	                            if ((c[c[w >> 2] >> 2] | 0) == 1 ? (c[(c[w >> 2] | 0) + 88 >> 2] | 0) == 46 : 0) {
	                                E = 9;
	                                break
	                            }
	                            c[A >> 2] = 3
	                        } while (0);
	                        if ((E | 0) == 9)c[A >> 2] = QD(c[o >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0))c[p >> 2] = c[p >> 2]; else c[p >> 2] = dI(c[r >> 2] | 0) | 0;
	                        c[u >> 2] = 0;
	                        c[x >> 2] = c[(c[o >> 2] | 0) + 96 >> 2];
	                        while (1) {
	                            if (!(c[x >> 2] | 0))break b;
	                            switch (c[c[(c[x >> 2] | 0) + 4 >> 2] >> 2] | 0) {
	                                case 1010:
	                                case 1011:
	                                case 1009:
	                                {
	                                    c[u >> 2] = aI(c[(c[x >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, z, c[A >> 2] | 0) | 0;
	                                    E = 19;
	                                    break
	                                }
	                                case 1007:
	                                case 1006:
	                                case 1008:
	                                    break;
	                                default:
	                                {
	                                    c[u >> 2] = bI(c[(c[x >> 2] | 0) + 4 >> 2] | 0, c[A >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[A >> 2] | 0) | 0;
	                                    E = 19
	                                }
	                            }
	                            if ((E | 0) == 19) {
	                                E = 0;
	                                if ((c[u >> 2] | 0) < 0) {
	                                    E = 20;
	                                    break
	                                }
	                                if ((c[u >> 2] | 0) > 0) {
	                                    if (!(c[t >> 2] | 0)) {
	                                        E = 24;
	                                        break
	                                    }
	                                    UD(c[m >> 2] | 0, c[u >> 2] | 0, c[n >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[o >> 2] | 0, c[(c[x >> 2] | 0) + 4 >> 2] | 0, 0, 0, 0);
	                                    if (!(c[v >> 2] | 0))c[v >> 2] = c[u >> 2]
	                                }
	                                c[u >> 2] = 0
	                            }
	                            c[x >> 2] = c[c[x >> 2] >> 2]
	                        }
	                        if ((E | 0) == 20) {
	                            xB(c[m >> 2] | 0, 156584, 156608);
	                            c[l >> 2] = -1;
	                            D = c[l >> 2] | 0;
	                            i = k;
	                            return D | 0
	                        } else if ((E | 0) == 24) {
	                            c[l >> 2] = c[u >> 2];
	                            D = c[l >> 2] | 0;
	                            i = k;
	                            return D | 0
	                        }
	                    } else if (!(c[j + 48 >> 2] & 64))break a; while (0);
	                    if (c[(c[o >> 2] | 0) + 48 >> 2] & 64) {
	                        c[u >> 2] = 0;
	                        c[x >> 2] = c[(c[o >> 2] | 0) + 96 >> 2];
	                        while (1) {
	                            if (!(c[x >> 2] | 0))break a;
	                            if (((c[c[(c[x >> 2] | 0) + 4 >> 2] >> 2] | 0) + -1009 | 0) >>> 0 < 3) {
	                                c[u >> 2] = _H(c[(c[x >> 2] | 0) + 4 >> 2] | 0, c[q >> 2] | 0, c[s >> 2] | 0, 0) | 0;
	                                if ((c[u >> 2] | 0) < 0) {
	                                    E = 33;
	                                    break
	                                }
	                                if ((c[u >> 2] | 0) > 0) {
	                                    if (!(c[t >> 2] | 0)) {
	                                        E = 37;
	                                        break
	                                    }
	                                    UD(c[m >> 2] | 0, c[u >> 2] | 0, c[n >> 2] | 0, c[q >> 2] | 0, c[s >> 2] | 0, c[o >> 2] | 0, c[(c[x >> 2] | 0) + 4 >> 2] | 0, 0, 0, 0);
	                                    if (!(c[v >> 2] | 0))c[v >> 2] = c[u >> 2]
	                                }
	                                c[u >> 2] = 0
	                            }
	                            c[x >> 2] = c[c[x >> 2] >> 2]
	                        }
	                        if ((E | 0) == 33) {
	                            xB(c[m >> 2] | 0, 156584, 156648);
	                            c[l >> 2] = -1;
	                            D = c[l >> 2] | 0;
	                            i = k;
	                            return D | 0
	                        } else if ((E | 0) == 37) {
	                            c[l >> 2] = c[u >> 2];
	                            D = c[l >> 2] | 0;
	                            i = k;
	                            return D | 0
	                        }
	                    }
	                } while (0);
	                do if ((c[v >> 2] | 0) >= 0) {
	                    c[B >> 2] = 0;
	                    c[u >> 2] = 0;
	                    c[w >> 2] = c[o >> 2];
	                    c:do {
	                        c[y >> 2] = c[(c[w >> 2] | 0) + 68 >> 2];
	                        while (1) {
	                            if (!(c[y >> 2] | 0))break;
	                            if ((c[c[y >> 2] >> 2] | 0) == 1007) {
	                                c[B >> 2] = 1;
	                                c[u >> 2] = VD(c[(c[y >> 2] | 0) + 32 >> 2] | 0, c[r >> 2] | 0) | 0;
	                                if ((c[u >> 2] | 0) == 1)break;
	                                if ((c[u >> 2] | 0) < 0) {
	                                    E = 48;
	                                    break c
	                                }
	                            }
	                            c[y >> 2] = c[(c[y >> 2] | 0) + 4 >> 2]
	                        }
	                        if ((c[u >> 2] | 0) != 0 | (c[B >> 2] | 0) != 0)break;
	                        c[w >> 2] = c[(c[w >> 2] | 0) + 64 >> 2];
	                        if (!(c[w >> 2] | 0))break
	                    } while ((c[c[w >> 2] >> 2] | 0) != 1);
	                    if ((E | 0) == 48) {
	                        xB(c[m >> 2] | 0, 156584, 156688);
	                        c[l >> 2] = -1;
	                        D = c[l >> 2] | 0;
	                        i = k;
	                        return D | 0
	                    }
	                    if ((c[B >> 2] | 0) != 0 & (c[u >> 2] | 0) == 0) {
	                        c[u >> 2] = 1840;
	                        if (c[t >> 2] | 0) {
	                            UD(c[m >> 2] | 0, c[u >> 2] | 0, c[n >> 2] | 0, c[q >> 2] | 0, 0, c[o >> 2] | 0, 0, 0, 0, 0);
	                            if (c[v >> 2] | 0)break;
	                            c[v >> 2] = c[u >> 2];
	                            break
	                        } else {
	                            c[l >> 2] = c[u >> 2];
	                            D = c[l >> 2] | 0;
	                            i = k;
	                            return D | 0
	                        }
	                    }
	                } while (0);
	                d:do if ((c[v >> 2] | 0) >= 0) {
	                    c[w >> 2] = c[o >> 2];
	                    c[y >> 2] = 0;
	                    e:while (1) {
	                        c[C >> 2] = 0;
	                        c[x >> 2] = c[(c[w >> 2] | 0) + 96 >> 2];
	                        while (1) {
	                            if (!(c[x >> 2] | 0))break;
	                            if ((c[c[(c[x >> 2] | 0) + 4 >> 2] >> 2] | 0) == 1006) {
	                                c[C >> 2] = 1;
	                                c[u >> 2] = vz(c[(c[(c[x >> 2] | 0) + 4 >> 2] | 0) + 36 >> 2] | 0, c[q >> 2] | 0) | 0;
	                                if ((c[u >> 2] | 0) == 1)break;
	                                if ((c[u >> 2] | 0) < 0) {
	                                    E = 65;
	                                    break e
	                                }
	                                c[y >> 2] = c[(c[x >> 2] | 0) + 4 >> 2]
	                            }
	                            c[x >> 2] = c[c[x >> 2] >> 2]
	                        }
	                        if ((c[C >> 2] | 0) != 0 & (c[u >> 2] | 0) != 1)break;
	                        c[w >> 2] = c[(c[w >> 2] | 0) + 64 >> 2];
	                        if (!(c[w >> 2] | 0))break d;
	                        if ((c[c[w >> 2] >> 2] | 0) == 1)break d
	                    }
	                    if ((E | 0) == 65) {
	                        xB(c[m >> 2] | 0, 156584, 156728);
	                        c[l >> 2] = -1;
	                        D = c[l >> 2] | 0;
	                        i = k;
	                        return D | 0
	                    }
	                    c[u >> 2] = 1839;
	                    if (c[t >> 2] | 0) {
	                        UD(c[m >> 2] | 0, c[u >> 2] | 0, c[n >> 2] | 0, c[q >> 2] | 0, 0, c[o >> 2] | 0, c[y >> 2] | 0, 0, 0, 0);
	                        if (c[v >> 2] | 0)break;
	                        c[v >> 2] = c[u >> 2];
	                        break
	                    } else {
	                        c[l >> 2] = c[u >> 2];
	                        D = c[l >> 2] | 0;
	                        i = k;
	                        return D | 0
	                    }
	                } while (0);
	                c[l >> 2] = c[v >> 2];
	                D = c[l >> 2] | 0;
	                i = k;
	                return D | 0
	            }

	            function DC(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 0;
	                HC(p, c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) == 0 ? (WD(c[j >> 2] | 0, c[l >> 2] | 0) | 0) != 2 : 0)c[p >> 2] = By(c[p >> 2] | 0, 154288) | 0; else c[p >> 2] = By(c[p >> 2] | 0, 154256) | 0;
	                g = (XD(c[n >> 2] | 0) | 0) != 0;
	                f = c[p >> 2] | 0;
	                if (g)c[p >> 2] = By(f, 154352) | 0; else c[p >> 2] = By(f, 154336) | 0;
	                do if (!(c[(c[n >> 2] | 0) + 48 >> 2] & 256)) {
	                    if (c[(c[n >> 2] | 0) + 48 >> 2] & 64) {
	                        c[p >> 2] = By(c[p >> 2] | 0, 147936) | 0;
	                        break
	                    }
	                    if (c[(c[n >> 2] | 0) + 48 >> 2] & 128)c[p >> 2] = By(c[p >> 2] | 0, 147952) | 0
	                } else c[p >> 2] = By(c[p >> 2] | 0, 147920) | 0; while (0);
	                if (XD(c[n >> 2] | 0) | 0) {
	                    c[q >> 2] = 0;
	                    c[p >> 2] = By(c[p >> 2] | 0, 143656) | 0;
	                    f = c[p >> 2] | 0;
	                    if (c[(c[n >> 2] | 0) + 88 >> 2] | 0) {
	                        c[p >> 2] = By(f, 154360) | 0;
	                        c[p >> 2] = By(c[p >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0
	                    } else c[p >> 2] = By(f, BB(q, c[(c[n >> 2] | 0) + 112 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                    c[p >> 2] = By(c[p >> 2] | 0, 142568) | 0;
	                    if (c[q >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        c[q >> 2] = 0
	                    }
	                }
	                c[p >> 2] = By(c[p >> 2] | 0, 142704) | 0;
	                if ((c[o >> 2] | 0) == 0 ? (WD(c[j >> 2] | 0, c[l >> 2] | 0) | 0) != 2 : 0)PD(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[p >> 2] | 0, 0, 0); else PD(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[p >> 2] | 0, c[m >> 2] | 0, 0);
	                if (!(c[p >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                c[p >> 2] = 0;
	                i = h;
	                return
	            }

	            function EC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    if (!(c[e >> 2] | 0)) {
	                        f = 7;
	                        break
	                    }
	                    if ((c[c[e >> 2] >> 2] | 0) != 4) {
	                        f = 7;
	                        break
	                    }
	                    g = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 92 >> 2] | 0) {
	                        f = 5;
	                        break
	                    }
	                    c[e >> 2] = c[g + 64 >> 2]
	                }
	                if ((f | 0) == 5) {
	                    c[d >> 2] = c[g + 92 >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((f | 0) == 7) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function FC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do switch (c[c[e >> 2] >> 2] | 0) {
	                    case 21:
	                    case 2:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 32 >> 2];
	                        break
	                    }
	                    case 2e3:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        break
	                    }
	                    case 24:
	                    case 23:
	                    case 22:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 8:
	                    case 7:
	                    case 6:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        break
	                    }
	                    case 25:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    case 26:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    case 4:
	                    case 5:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 0
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function GC(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                h = f + 44 | 0;
	                j = f + 40 | 0;
	                k = f + 36 | 0;
	                l = f + 32 | 0;
	                m = f + 28 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 16 | 0;
	                q = f + 12 | 0;
	                r = f + 8 | 0;
	                s = f + 4 | 0;
	                t = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                c[m >> 2] = 1;
	                if (c[c[g >> 2] >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[c[g >> 2] >> 2] | 0);
	                    c[c[g >> 2] >> 2] = 0
	                }
	                a:do if (c[h >> 2] | 0) {
	                    e = my(c[h >> 2] | 0) | 0;
	                    c[c[g >> 2] >> 2] = e
	                } else {
	                    if (!(c[j >> 2] | 0)) {
	                        c[m >> 2] = 0;
	                        break
	                    }
	                    do switch (c[c[j >> 2] >> 2] | 0) {
	                        case 4:
	                        {
	                            c[o >> 2] = c[j >> 2];
	                            if (c[(c[o >> 2] | 0) + 48 >> 2] & 8) {
	                                e = my(142672) | 0;
	                                c[c[g >> 2] >> 2] = e
	                            } else {
	                                e = my(147912) | 0;
	                                c[c[g >> 2] >> 2] = e
	                            }
	                            do if (!(c[(c[o >> 2] | 0) + 48 >> 2] & 256)) {
	                                if (c[(c[o >> 2] | 0) + 48 >> 2] & 64) {
	                                    e = By(c[c[g >> 2] >> 2] | 0, 147936) | 0;
	                                    c[c[g >> 2] >> 2] = e;
	                                    break
	                                }
	                                e = c[c[g >> 2] >> 2] | 0;
	                                if (c[(c[o >> 2] | 0) + 48 >> 2] & 128) {
	                                    d = By(e, 147952) | 0;
	                                    c[c[g >> 2] >> 2] = d;
	                                    break
	                                } else {
	                                    d = By(e, 147968) | 0;
	                                    c[c[g >> 2] >> 2] = d;
	                                    break
	                                }
	                            } else {
	                                d = By(c[c[g >> 2] >> 2] | 0, 147920) | 0;
	                                c[c[g >> 2] >> 2] = d
	                            } while (0);
	                            if (!(c[(c[o >> 2] | 0) + 48 >> 2] & 8))break a;
	                            d = By(c[c[g >> 2] >> 2] | 0, 143656) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 15:
	                        {
	                            c[r >> 2] = c[j >> 2];
	                            d = my(148032) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 143656) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, BB(l, c[(c[r >> 2] | 0) + 56 >> 2] | 0, c[(c[r >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            if (c[l >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                                c[l >> 2] = 0
	                            }
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 16:
	                        {
	                            ZD(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                            break a;
	                            break
	                        }
	                        case 5:
	                        {
	                            c[p >> 2] = c[j >> 2];
	                            if (c[(c[p >> 2] | 0) + 48 >> 2] & 8) {
	                                d = my(142672) | 0;
	                                c[c[g >> 2] >> 2] = d
	                            } else {
	                                d = my(147912) | 0;
	                                c[c[g >> 2] >> 2] = d
	                            }
	                            d = By(c[c[g >> 2] >> 2] | 0, 147984) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            if (!(c[(c[p >> 2] | 0) + 48 >> 2] & 8))break a;
	                            d = By(c[c[g >> 2] >> 2] | 0, 143656) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 24:
	                        case 23:
	                        case 22:
	                        {
	                            do if ((c[c[j >> 2] >> 2] | 0) != 22)if ((c[c[j >> 2] >> 2] | 0) == 23) {
	                                d = my(148080) | 0;
	                                c[c[g >> 2] >> 2] = d;
	                                break
	                            } else {
	                                d = my(148088) | 0;
	                                c[c[g >> 2] >> 2] = d;
	                                break
	                            } else {
	                                d = my(148064) | 0;
	                                c[c[g >> 2] >> 2] = d
	                            } while (0);
	                            d = By(c[c[g >> 2] >> 2] | 0, c[(c[j >> 2] | 0) + 16 >> 2] | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 14:
	                        {
	                            c[s >> 2] = c[j >> 2];
	                            d = my(148048) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 143656) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, BB(l, c[(c[s >> 2] | 0) + 52 >> 2] | 0, c[(c[s >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 1:
	                        {
	                            c[n >> 2] = c[j >> 2];
	                            do if (!(c[(c[n >> 2] | 0) + 48 >> 2] & 256)) {
	                                if (c[(c[n >> 2] | 0) + 48 >> 2] & 64) {
	                                    d = my(147856) | 0;
	                                    c[c[g >> 2] >> 2] = d;
	                                    break
	                                }
	                                if (c[(c[n >> 2] | 0) + 48 >> 2] & 128) {
	                                    d = my(147872) | 0;
	                                    c[c[g >> 2] >> 2] = d;
	                                    break
	                                } else {
	                                    d = my(147888) | 0;
	                                    c[c[g >> 2] >> 2] = d;
	                                    break
	                                }
	                            } else {
	                                d = my(147832) | 0;
	                                c[c[g >> 2] >> 2] = d
	                            } while (0);
	                            d = By(c[c[g >> 2] >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 17:
	                        {
	                            d = my(148128) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 143656) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, YD(l, c[j >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            if (!(c[l >> 2] | 0))break a;
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 25:
	                        case 8:
	                        case 7:
	                        case 6:
	                        {
	                            d = my(MD(c[j >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 21:
	                        case 2:
	                        {
	                            d = my(_D(c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 148104) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 18:
	                        {
	                            d = my(MD(c[j >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 143656) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, YD(l, c[j >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            if (c[l >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                                c[l >> 2] = 0
	                            }
	                            break
	                        }
	                        case 1011:
	                        case 1010:
	                        case 1009:
	                        case 1008:
	                        case 1007:
	                        case 1006:
	                        case 1005:
	                        case 1004:
	                        case 1003:
	                        case 1002:
	                        case 1001:
	                        case 1e3:
	                        {
	                            d = my(148120) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, zB(c[c[j >> 2] >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            break a;
	                            break
	                        }
	                        case 26:
	                        {
	                            c[q >> 2] = c[j >> 2];
	                            d = my(148e3) | 0;
	                            c[c[g >> 2] >> 2] = d;
	                            d = c[c[g >> 2] >> 2] | 0;
	                            if (!(c[(c[q >> 2] | 0) + 12 >> 2] | 0)) {
	                                e = By(d, 148016) | 0;
	                                c[c[g >> 2] >> 2] = e;
	                                break a
	                            }
	                            e = By(d, 142568) | 0;
	                            c[c[g >> 2] >> 2] = e;
	                            e = By(c[c[g >> 2] >> 2] | 0, YD(l, c[(c[q >> 2] | 0) + 12 >> 2] | 0) | 0) | 0;
	                            c[c[g >> 2] >> 2] = e;
	                            if (c[l >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                                c[l >> 2] = 0
	                            }
	                            e = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[g >> 2] >> 2] = e;
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    c[m >> 2] = 0
	                } while (0);
	                if ((c[m >> 2] | 0) == 0 & (c[k >> 2] | 0) != 0) {
	                    m = c[k >> 2] | 0;
	                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 2)c[t >> 2] = c[m + 20 >> 2]; else c[t >> 2] = m;
	                    m = my(144464) | 0;
	                    c[c[g >> 2] >> 2] = m;
	                    m = c[c[g >> 2] >> 2] | 0;
	                    q = c[t >> 2] | 0;
	                    if (c[(c[t >> 2] | 0) + 36 >> 2] | 0) {
	                        j = By(m, BB(l, c[(c[q + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[t >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                        c[c[g >> 2] >> 2] = j;
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                    } else {
	                        j = By(m, c[q + 8 >> 2] | 0) | 0;
	                        c[c[g >> 2] >> 2] = j
	                    }
	                    j = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                    c[c[g >> 2] >> 2] = j
	                }
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                    j = By(c[c[g >> 2] >> 2] | 0, 148152) | 0;
	                    c[c[g >> 2] >> 2] = j;
	                    j = c[c[g >> 2] >> 2] | 0;
	                    q = c[k >> 2] | 0;
	                    if (c[(c[k >> 2] | 0) + 36 >> 2] | 0) {
	                        m = By(j, BB(l, c[(c[q + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                        c[c[g >> 2] >> 2] = m;
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                    } else {
	                        m = By(j, c[q + 8 >> 2] | 0) | 0;
	                        c[c[g >> 2] >> 2] = m
	                    }
	                    m = By(c[c[g >> 2] >> 2] | 0, 142568) | 0;
	                    c[c[g >> 2] >> 2] = m
	                }
	                if (!(c[l >> 2] | 0)) {
	                    u = c[g >> 2] | 0;
	                    v = c[u >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                c[l >> 2] = 0;
	                u = c[g >> 2] | 0;
	                v = c[u >> 2] | 0;
	                i = f;
	                return v | 0
	            }

	            function HC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = 0;
	                c[c[h >> 2] >> 2] = 0;
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) {
	                    d = my(142672) | 0;
	                    c[c[h >> 2] >> 2] = d;
	                    c[g >> 2] = c[c[h >> 2] >> 2];
	                    p = c[g >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                do if (c[k >> 2] | 0) {
	                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        c[m >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                        d = my(144464) | 0;
	                        c[c[h >> 2] >> 2] = d;
	                        d = c[c[h >> 2] >> 2] | 0;
	                        b = c[m >> 2] | 0;
	                        if (c[(c[m >> 2] | 0) + 36 >> 2] | 0) {
	                            a = By(d, BB(l, c[(c[b + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                            c[c[h >> 2] >> 2] = a
	                        } else {
	                            a = By(d, BB(l, 0, c[b + 8 >> 2] | 0) | 0) | 0;
	                            c[c[h >> 2] >> 2] = a
	                        }
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                        a = By(c[c[h >> 2] >> 2] | 0, 142656) | 0;
	                        c[c[h >> 2] >> 2] = a;
	                        a = By(c[c[h >> 2] >> 2] | 0, 144480) | 0;
	                        c[c[h >> 2] >> 2] = a
	                    } else {
	                        a = my(144464) | 0;
	                        c[c[h >> 2] >> 2] = a
	                    }
	                    a = c[c[h >> 2] >> 2] | 0;
	                    b = c[k >> 2] | 0;
	                    if (c[(c[k >> 2] | 0) + 36 >> 2] | 0) {
	                        d = By(a, BB(l, c[(c[b + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                        c[c[h >> 2] >> 2] = d
	                    } else {
	                        d = By(a, BB(l, 0, c[b + 8 >> 2] | 0) | 0) | 0;
	                        c[c[h >> 2] >> 2] = d
	                    }
	                    if (c[l >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[l >> 2] = 0
	                    }
	                    d = By(c[c[h >> 2] >> 2] | 0, 144496) | 0;
	                    c[c[h >> 2] >> 2] = d
	                } else {
	                    d = c[j >> 2] | 0;
	                    if ((c[c[j >> 2] >> 2] | 0) != 2) {
	                        if ((c[d >> 2] | 0) == 1) {
	                            b = my(142672) | 0;
	                            c[c[h >> 2] >> 2] = b;
	                            break
	                        }
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[f >> 2] = 140328;
	                        c[f + 4 >> 2] = 2246;
	                        Db[b & 511](a, 140296, f);
	                        c[g >> 2] = 0;
	                        p = c[g >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    c[n >> 2] = d;
	                    if ((c[c[(c[n >> 2] | 0) + 108 >> 2] >> 2] | 0) == 2) {
	                        c[o >> 2] = c[(c[(c[n >> 2] | 0) + 100 >> 2] | 0) + (c[(c[n >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                        d = my(144464) | 0;
	                        c[c[h >> 2] >> 2] = d;
	                        d = c[c[h >> 2] >> 2] | 0;
	                        a = By(d, BB(l, c[(c[o >> 2] | 0) + 16 >> 2] | 0, c[(c[o >> 2] | 0) + 12 >> 2] | 0) | 0) | 0;
	                        c[c[h >> 2] >> 2] = a;
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                        a = By(c[c[h >> 2] >> 2] | 0, 142656) | 0;
	                        c[c[h >> 2] >> 2] = a;
	                        a = By(c[c[h >> 2] >> 2] | 0, 144480) | 0;
	                        c[c[h >> 2] >> 2] = a
	                    } else {
	                        a = my(144464) | 0;
	                        c[c[h >> 2] >> 2] = a
	                    }
	                    a = c[c[h >> 2] >> 2] | 0;
	                    d = By(a, BB(l, c[(c[(c[n >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0, c[(c[(c[n >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0) | 0) | 0;
	                    c[c[h >> 2] >> 2] = d;
	                    if (c[l >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[l >> 2] = 0
	                    }
	                    d = By(c[c[h >> 2] >> 2] | 0, 144496) | 0;
	                    c[c[h >> 2] >> 2] = d
	                } while (0);
	                c[g >> 2] = c[c[h >> 2] >> 2];
	                p = c[g >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function IC(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                k = i;
	                i = i + 32 | 0;
	                l = k + 28 | 0;
	                m = k + 24 | 0;
	                n = k + 20 | 0;
	                o = k + 16 | 0;
	                p = k + 12 | 0;
	                q = k + 8 | 0;
	                r = k + 4 | 0;
	                s = k;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = j;
	                $D(c[l >> 2] | 0, 2, c[m >> 2] | 0, c[n >> 2] | 0, 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0);
	                i = k;
	                return
	            }

	            function JC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2];
	                if (!(c[(c[j >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[(c[j >> 2] | 0) + 4 >> 2] | 0)) {
	                        m = 8;
	                        break
	                    }
	                    c[h >> 2] = c[(c[c[j >> 2] >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                    if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) == (c[g >> 2] | 0)) {
	                        m = 6;
	                        break
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((m | 0) == 6) {
	                    c[e >> 2] = c[h >> 2];
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 8) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function KC() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](16) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    tC(0, 170048, 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    f = c[d >> 2] | 0;
	                    c[f + 0 >> 2] = 0;
	                    c[f + 4 >> 2] = 0;
	                    c[f + 8 >> 2] = 0;
	                    c[f + 12 >> 2] = 0;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function LC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[(c[e >> 2] | 0) + 24 >> 2] = c[f >> 2];
	                    i = d;
	                    return
	                }
	                while (1) {
	                    if (!(c[c[g >> 2] >> 2] | 0))break;
	                    c[g >> 2] = c[c[g >> 2] >> 2]
	                }
	                c[c[g >> 2] >> 2] = c[f >> 2];
	                i = d;
	                return
	            }

	            function MC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2];
	                if (!(c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[m >> 2] = 0;
	                while (1) {
	                    if ((c[m >> 2] | 0) >= (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                        o = 14;
	                        break
	                    }
	                    c[k >> 2] = c[(c[c[l >> 2] >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                    if (!((c[(c[k >> 2] | 0) + 20 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0))o = 7;
	                    if ((o | 0) == 7 ? (o = 0, (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == (c[h >> 2] | 0)) : 0) {
	                        if ((c[j >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            o = 12;
	                            break
	                        }
	                        if ((c[j >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) {
	                            o = 12;
	                            break
	                        }
	                    }
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                if ((o | 0) == 12) {
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((o | 0) == 14) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function NC(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                k = i;
	                i = i + 48 | 0;
	                l = k + 32 | 0;
	                m = k + 28 | 0;
	                n = k + 24 | 0;
	                o = k + 16 | 0;
	                p = k + 12 | 0;
	                q = k + 8 | 0;
	                r = k + 4 | 0;
	                s = k;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[k + 20 >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = j;
	                c[s >> 2] = 0;
	                HC(s, c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                c[s >> 2] = By(c[s >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[s >> 2] = By(c[s >> 2] | 0, 142704) | 0;
	                $D(c[l >> 2] | 0, 1, c[m >> 2] | 0, c[n >> 2] | 0, 0, c[s >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, 0);
	                if (!(c[s >> 2] | 0)) {
	                    i = k;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                c[s >> 2] = 0;
	                i = k;
	                return
	            }

	            function OC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2];
	                if (!(c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[m >> 2] = 0;
	                while (1) {
	                    if ((c[m >> 2] | 0) >= (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                        o = 10;
	                        break
	                    }
	                    c[k >> 2] = c[(c[c[l >> 2] >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) == (c[h >> 2] | 0) : 0) ? (c[(c[k >> 2] | 0) + 16 >> 2] | 0) == (c[j >> 2] | 0) : 0) {
	                        o = 8;
	                        break
	                    }
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                if ((o | 0) == 8) {
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((o | 0) == 10) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function PC(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                if (c[k >> 2] | 0) {
	                    g = (c[k >> 2] | 0) + 20 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    c[(c[k >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                    c[q >> 2] = c[(c[k >> 2] | 0) + 8 >> 2];
	                    c[s >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    c[r >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                g = c[r >> 2] | 0;
	                r = c[q >> 2] | 0;
	                q = c[s >> 2] | 0;
	                s = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                f = c[p >> 2] | 0;
	                e = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                c[j >> 2] = c[o >> 2];
	                c[j + 4 >> 2] = n;
	                Xd(g, r, q, s, k, 16, l, 2, 0, 0, m, f, 0, 0, 0, e, j);
	                i = h;
	                return
	            }

	            function QC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = 0;
	                c[h >> 2] = c[f >> 2];
	                a:while (1) {
	                    j = (c[g >> 2] | 0) != 0;
	                    if (!(c[h >> 2] | 0))break;
	                    if (j) {
	                        Qh(c[g >> 2] | 0);
	                        Rh(c[g >> 2] | 0);
	                        c[g >> 2] = 0
	                    }
	                    e = c[(c[h >> 2] | 0) + 4 >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 3)if (((e | 0) == 3 ? (aE(c[(c[h >> 2] | 0) + 40 >> 2] | 0, -1) | 0) != 0 : 0) ? (Vi(c[h >> 2] | 0) | 0) != 1 : 0) {
	                        c[g >> 2] = c[h >> 2];
	                        k = 14
	                    } else k = 14; else if ((e | 0) != 1 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 4 : 0)c[g >> 2] = c[h >> 2]; else k = 14;
	                    if (((((k | 0) == 14 ? (k = 0, (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 6 : 0) {
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                        continue
	                    }
	                    if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                        if (!(c[h >> 2] | 0))continue a;
	                        if ((c[h >> 2] | 0) == (c[f >> 2] | 0)) {
	                            k = 23;
	                            break
	                        }
	                        l = c[h >> 2] | 0;
	                        if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                            k = 25;
	                            break
	                        }
	                        if (!l)continue a
	                    }
	                    if ((k | 0) == 23) {
	                        k = 0;
	                        c[h >> 2] = 0;
	                        continue
	                    } else if ((k | 0) == 25) {
	                        k = 0;
	                        c[h >> 2] = c[l + 24 >> 2];
	                        continue
	                    }
	                }
	                if (!j) {
	                    i = d;
	                    return
	                }
	                Qh(c[g >> 2] | 0);
	                Rh(c[g >> 2] | 0);
	                c[g >> 2] = 0;
	                i = d;
	                return
	            }

	            function RC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = ej(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[l >> 2] = AP(c[(c[g >> 2] | 0) + 80 >> 2] | 0, c[k >> 2] | 0, -1) | 0;
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = c[l >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function SC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                d = c[g >> 2] | 0;
	                if (!(c[c[(c[g >> 2] | 0) + 28 >> 2] >> 2] | 0)) {
	                    xB(d, 169824, 169848);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[m >> 2] = c[c[d + 28 >> 2] >> 2];
	                c[l >> 2] = 56;
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](c[l >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    tC(0, 169880, 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                cU(c[k >> 2] | 0, 0, c[l >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                c[c[k >> 2] >> 2] = c[h >> 2];
	                l = JB() | 0;
	                c[(c[k >> 2] | 0) + 44 >> 2] = l;
	                if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                l = JB() | 0;
	                c[(c[k >> 2] | 0) + 48 >> 2] = l;
	                if (!(c[(c[k >> 2] | 0) + 48 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                do if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) > 0 : 0) {
	                    if (!(c[h >> 2] | 0)) {
	                        xB(c[g >> 2] | 0, 169824, 169960);
	                        qB(c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    if ((c[h >> 2] | 0) == 1) {
	                        l = DB(c[g >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 52 >> 2] = l;
	                        if (c[(c[k >> 2] | 0) + 52 >> 2] | 0) {
	                            c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                            break
	                        }
	                        qB(c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                } else p = 11; while (0);
	                do if ((p | 0) == 11) {
	                    if (!((c[h >> 2] | 0) == 2 | (c[h >> 2] | 0) == 3)) {
	                        c[c[k >> 2] >> 2] = 0;
	                        c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                        c[(c[k >> 2] | 0) + 52 >> 2] = c[m >> 2];
	                        c[(c[m >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                        break
	                    }
	                    xB(c[g >> 2] | 0, 169824, 169912);
	                    qB(c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } while (0);
	                if ((c[h >> 2] | 0) == 0 | (c[h >> 2] | 0) == 1) {
	                    if ((c[(c[m >> 2] | 0) + 48 >> 2] | 0) == 0 ? (h = Jj(5, c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] | 0) | 0, c[(c[m >> 2] | 0) + 48 >> 2] = h, (c[(c[m >> 2] | 0) + 48 >> 2] | 0) == 0) : 0) {
	                        qB(c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    h = c[(c[m >> 2] | 0) + 48 >> 2] | 0;
	                    if (!(c[j >> 2] | 0))c[n >> 2] = Lj(h, 145792, c[k >> 2] | 0) | 0; else c[n >> 2] = Lj(h, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    if (c[n >> 2] | 0) {
	                        xB(c[g >> 2] | 0, 169824, 17e4);
	                        qB(c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                } else {
	                    if ((c[c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] >> 2] | 0) != 0 ? (c[c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] >> 2] | 0) != 1 : 0)c[(c[k >> 2] | 0) + 52 >> 2] = c[(c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 52 >> 2]; else c[(c[k >> 2] | 0) + 52 >> 2] = c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2];
	                    if ((c[(c[m >> 2] | 0) + 64 >> 2] | 0) == 0 ? (n = JB() | 0, c[(c[m >> 2] | 0) + 64 >> 2] = n, (c[(c[m >> 2] | 0) + 64 >> 2] | 0) == 0) : 0) {
	                        qB(c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    bE(c[(c[m >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0) | 0
	                }
	                if ((bE(c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0) | 0) == -1) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } else {
	                    c[f >> 2] = c[k >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                return 0
	            }

	            function TC(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 1) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 1
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 2) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 2
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 4) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 4
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 8) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 8
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 16) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 16
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 32) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 32
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 64) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 64
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] & 128) {
	                    a = (c[d >> 2] | 0) + 24 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 128
	                }
	                if (!(c[(c[d >> 2] | 0) + 24 >> 2] & 256)) {
	                    i = b;
	                    return
	                }
	                a = (c[d >> 2] | 0) + 24 | 0;
	                c[a >> 2] = c[a >> 2] ^ 256;
	                i = b;
	                return
	            }

	            function UC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[n >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                c[m >> 2] = cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                do if ((c[m >> 2] | 0) != -1) {
	                    c[k >> 2] = dE(c[j >> 2] | 0, 168888) | 0;
	                    if (c[k >> 2] | 0) {
	                        d = c[g >> 2] | 0;
	                        b = c[k >> 2] | 0;
	                        c[m >> 2] = eE(d, 0, b, IH(29) | 0, 0) | 0;
	                        if ((c[m >> 2] | 0) == -1)break;
	                        if (c[m >> 2] | 0)c[(c[g >> 2] | 0) + 108 >> 2] = 3037; else o = 6
	                    } else o = 6;
	                    if ((o | 0) == 6) {
	                        c[k >> 2] = dE(c[j >> 2] | 0, 168904) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[l >> 2] = fE(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[m >> 2] = gE(c[l >> 2] | 0, (c[h >> 2] | 0) + 24 | 0, 1) | 0;
	                            if ((c[m >> 2] | 0) == -1)break;
	                            if (c[m >> 2] | 0)hE(c[g >> 2] | 0, 1705, 0, c[k >> 2] | 0, 0, 163568, c[l >> 2] | 0, 0, 0, 0)
	                        }
	                        c[k >> 2] = dE(c[j >> 2] | 0, 168928) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[l >> 2] = fE(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[m >> 2] = gE(c[l >> 2] | 0, (c[h >> 2] | 0) + 24 | 0, 2) | 0;
	                            if ((c[m >> 2] | 0) == -1)break;
	                            if (c[m >> 2] | 0)hE(c[g >> 2] | 0, 1701, 0, c[k >> 2] | 0, 0, 163568, c[l >> 2] | 0, 0, 0, 0)
	                        }
	                        c[k >> 2] = dE(c[j >> 2] | 0, 168952) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[l >> 2] = fE(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[m >> 2] = iE(c[l >> 2] | 0, (c[h >> 2] | 0) + 24 | 0, -1, 4, 8, -1, 16, 32) | 0;
	                            if ((c[m >> 2] | 0) == -1)break;
	                            if (c[m >> 2] | 0)hE(c[g >> 2] | 0, 3037, 0, c[k >> 2] | 0, 0, 168968, c[l >> 2] | 0, 0, 0, 0)
	                        }
	                        c[k >> 2] = dE(c[j >> 2] | 0, 169032) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[l >> 2] = fE(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[m >> 2] = iE(c[l >> 2] | 0, (c[h >> 2] | 0) + 24 | 0, -1, 64, 128, 256, -1, -1) | 0;
	                            if ((c[m >> 2] | 0) == -1)break;
	                            if (c[m >> 2] | 0)hE(c[g >> 2] | 0, 3037, 0, c[k >> 2] | 0, 0, 164576, c[l >> 2] | 0, 0, 0, 0)
	                        }
	                    }
	                    if ((c[n >> 2] | 0) != (c[(c[g >> 2] | 0) + 20 >> 2] | 0))c[m >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    c[f >> 2] = c[m >> 2];
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                } while (0);
	                c[f >> 2] = -1;
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function VC(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[n >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                c[k >> 2] = c[j >> 2];
	                a:while (1) {
	                    if (!((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160960) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0))q = 8;
	                    do if ((q | 0) == 8) {
	                        q = 0;
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160968) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160976) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                        if (!(c[k >> 2] | 0)) {
	                            q = 49;
	                            break a
	                        }
	                        if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0)) {
	                            q = 49;
	                            break a
	                        }
	                        if (!(qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160992) | 0)) {
	                            q = 49;
	                            break a
	                        }
	                        if (!(qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)) {
	                            q = 49;
	                            break a
	                        }
	                    } while (0);
	                    do if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[l >> 2] = jE(c[g >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                        j = c[l >> 2] | 0;
	                        if (!(c[(c[h >> 2] | 0) + 20 >> 2] | 0)) {
	                            c[(c[h >> 2] | 0) + 20 >> 2] = j;
	                            break
	                        } else {
	                            mB(j);
	                            break
	                        }
	                    } else q = 27; while (0);
	                    do if ((q | 0) == 27) {
	                        q = 0;
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160968) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            c[o >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            c[m >> 2] = kE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            if ((c[m >> 2] | 0) == -1) {
	                                q = 97;
	                                break a
	                            }
	                            if (c[(c[g >> 2] | 0) + 108 >> 2] | 0)break a;
	                            if ((c[o >> 2] | 0) != (c[(c[g >> 2] | 0) + 20 >> 2] | 0))break a; else break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160960) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            c[o >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            c[m >> 2] = lE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            if ((c[m >> 2] | 0) == -1) {
	                                q = 97;
	                                break a
	                            }
	                            if (c[(c[g >> 2] | 0) + 108 >> 2] | 0)break a;
	                            if ((c[o >> 2] | 0) != (c[(c[g >> 2] | 0) + 20 >> 2] | 0))break a; else break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160976) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            c[o >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            c[m >> 2] = mE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            if ((c[m >> 2] | 0) == -1) {
	                                q = 97;
	                                break a
	                            }
	                            if (c[(c[g >> 2] | 0) + 108 >> 2] | 0)break a;
	                            if ((c[o >> 2] | 0) != (c[(c[g >> 2] | 0) + 20 >> 2] | 0))break a
	                        }
	                    } while (0);
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                if ((q | 0) == 97) {
	                    c[f >> 2] = -1;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                b:do if ((q | 0) == 49)c:while (1) {
	                    q = 0;
	                    if (!(c[k >> 2] | 0))break b;
	                    if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161008) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        nE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                    } else q = 55;
	                    do if ((q | 0) == 55) {
	                        q = 0;
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            oE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161040) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            pE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, 0, 1) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161048) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            qE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161064) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            rE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            sE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 161088) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            tE(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        uE(c[g >> 2] | 0, 3033, 0, c[(c[k >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] | 0, 0, 161104);
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                    } while (0);
	                    while (1) {
	                        if (!(c[k >> 2] | 0)) {
	                            q = 49;
	                            continue c
	                        }
	                        if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0)) {
	                            q = 49;
	                            continue c
	                        }
	                        if (!(qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160992) | 0)) {
	                            q = 49;
	                            continue c
	                        }
	                        if (!(qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)) {
	                            q = 49;
	                            continue c
	                        }
	                        c[l >> 2] = jE(c[g >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                        o = c[l >> 2] | 0;
	                        if (!(c[(c[h >> 2] | 0) + 20 >> 2] | 0))c[(c[h >> 2] | 0) + 20 >> 2] = o; else mB(o);
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                c[(c[g >> 2] | 0) + 84 >> 2] = 0;
	                if ((c[n >> 2] | 0) != (c[(c[g >> 2] | 0) + 20 >> 2] | 0))c[m >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                c[f >> 2] = c[m >> 2];
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function WC(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 40 | 0;
	                e = b + 36 | 0;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                o = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                a:while (1) {
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    c[h >> 2] = vE(c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[c[j >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                    do if (!(c[h >> 2] | 0)) {
	                        c[l >> 2] = 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)c[m >> 2] = FC(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0; else c[m >> 2] = FC(c[j >> 2] | 0) | 0;
	                        a = c[e >> 2] | 0;
	                        q = c[m >> 2] | 0;
	                        r = MD(c[j >> 2] | 0) | 0;
	                        AB(a, 3081, q, 0, 160712, r, BB(l, c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0);
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                        c[f >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        c[g >> 2] = c[c[g >> 2] >> 2]
	                    } else {
	                        c[k >> 2] = 0;
	                        r = c[c[j >> 2] >> 2] | 0;
	                        do if ((r | 0) == 4 | (r | 0) == 5)if (c[(c[h >> 2] | 0) + 48 >> 2] & 1073741824) {
	                            c[k >> 2] = 1;
	                            break
	                        } else {
	                            q = (c[h >> 2] | 0) + 48 | 0;
	                            c[q >> 2] = c[q >> 2] | 1073741824;
	                            c[(c[j >> 2] | 0) + 64 >> 2] = c[h >> 2];
	                            break
	                        } else if ((r | 0) == 17) {
	                            if (c[(c[h >> 2] | 0) + 28 >> 2] & 2) {
	                                c[k >> 2] = 1;
	                                break
	                            }
	                            q = (c[h >> 2] | 0) + 28 | 0;
	                            c[q >> 2] = c[q >> 2] | 2;
	                            if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                            c[(c[g >> 2] | 0) + 12 >> 2] = c[h >> 2]
	                        } else if ((r | 0) == 16) {
	                            if (c[(c[h >> 2] | 0) + 36 >> 2] & 8) {
	                                c[k >> 2] = 1;
	                                break
	                            }
	                            q = (c[h >> 2] | 0) + 36 | 0;
	                            c[q >> 2] = c[q >> 2] | 8;
	                            q = c[h >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                                c[(c[a + 8 >> 2] | 0) + 4 >> 2] = q;
	                                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                                break
	                            } else {
	                                c[a + 12 >> 2] = q;
	                                break
	                            }
	                        } else {
	                            s = 24;
	                            break a
	                        } while (0);
	                        if (!(c[k >> 2] | 0)) {
	                            c[g >> 2] = c[c[g >> 2] >> 2];
	                            break
	                        }
	                        c[n >> 2] = 0;
	                        r = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)c[o >> 2] = FC(c[r + 8 >> 2] | 0) | 0; else c[o >> 2] = FC(c[r + 4 >> 2] | 0) | 0;
	                        r = c[e >> 2] | 0;
	                        q = c[o >> 2] | 0;
	                        AB(r, 3081, q, 0, 160856, ZD(n, c[h >> 2] | 0) | 0, 0);
	                        if (c[n >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            c[n >> 2] = 0
	                        }
	                        c[f >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        c[g >> 2] = c[c[g >> 2] >> 2]
	                    } while (0);
	                    if (!(c[g >> 2] | 0)) {
	                        s = 34;
	                        break
	                    }
	                }
	                if ((s | 0) == 24) {
	                    xB(c[e >> 2] | 0, 160784, 160816);
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } else if ((s | 0) == 34) {
	                    c[d >> 2] = c[f >> 2];
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                return 0
	            }

	            function XC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 36 | 0;
	                f = d + 32 | 0;
	                g = d + 28 | 0;
	                h = d + 24 | 0;
	                j = d + 20 | 0;
	                k = d + 16 | 0;
	                l = d + 12 | 0;
	                m = d + 8 | 0;
	                n = d + 4 | 0;
	                o = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                if (c[(c[g >> 2] | 0) + 4 >> 2] & 2) {
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                b = (c[g >> 2] | 0) + 4 | 0;
	                c[b >> 2] = c[b >> 2] | 2;
	                c[m >> 2] = 0;
	                while (1) {
	                    if ((c[m >> 2] | 0) >= (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 4 >> 2] | 0))break;
	                    c[h >> 2] = c[(c[c[(c[g >> 2] | 0) + 44 >> 2] >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                    c[k >> 2] = 0;
	                    a:do switch (c[c[h >> 2] >> 2] | 0) {
	                        case 4:
	                        case 5:
	                        {
	                            if (!(c[(c[h >> 2] | 0) + 48 >> 2] & 1073741824)) {
	                                c[l >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                                if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                    c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 28;
	                                    q = 40;
	                                    break a
	                                }
	                                c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 28;
	                                q = 40
	                            }
	                            break
	                        }
	                        case 18:
	                        {
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                            if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 44;
	                                q = 40;
	                                break a
	                            }
	                            c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 44;
	                            q = 40;
	                            break
	                        }
	                        case 14:
	                        {
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                            if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 40;
	                                q = 40;
	                                break a
	                            }
	                            c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 40;
	                            q = 40;
	                            break
	                        }
	                        case 16:
	                        {
	                            if (!(c[(c[h >> 2] | 0) + 36 >> 2] & 8)) {
	                                c[l >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                                if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                    c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 36;
	                                    q = 40;
	                                    break a
	                                }
	                                c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 36;
	                                q = 40
	                            }
	                            break
	                        }
	                        case 24:
	                        case 22:
	                        case 23:
	                        {
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                            if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 76;
	                                q = 40;
	                                break a
	                            }
	                            c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 76;
	                            q = 40;
	                            break
	                        }
	                        case 17:
	                        {
	                            if (!(c[(c[h >> 2] | 0) + 28 >> 2] & 2)) {
	                                c[l >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                                if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                    c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 56;
	                                    q = 40;
	                                    break a
	                                }
	                                c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 56;
	                                q = 40
	                            }
	                            break
	                        }
	                        case 15:
	                        {
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                            if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[g >> 2] >> 2] | 0) != 1 : 0) {
	                                c[k >> 2] = (c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 52 >> 2] | 0) + 32;
	                                q = 40;
	                                break a
	                            }
	                            c[k >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + 32;
	                            q = 40;
	                            break
	                        }
	                        default:
	                            xB(c[f >> 2] | 0, 160568, 160592)
	                    } while (0);
	                    if ((q | 0) == 40) {
	                        q = 0;
	                        if ((c[c[k >> 2] >> 2] | 0) == 0 ? (b = Jj(10, c[(c[f >> 2] | 0) + 80 >> 2] | 0) | 0, c[c[k >> 2] >> 2] = b, (c[c[k >> 2] >> 2] | 0) == 0) : 0) {
	                            q = 42;
	                            break
	                        }
	                        c[j >> 2] = Lj(c[c[k >> 2] >> 2] | 0, c[l >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if ((c[j >> 2] | 0) != 0 ? (c[n >> 2] = 0, b = c[f >> 2] | 0, a = FC(c[h >> 2] | 0) | 0, r = c[h >> 2] | 0, s = MD(c[h >> 2] | 0) | 0, AB(b, 1761, a, r, 160672, s, YD(n, c[h >> 2] | 0) | 0), (c[n >> 2] | 0) != 0) : 0) {
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            c[n >> 2] = 0
	                        }
	                    }
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                if ((q | 0) == 42) {
	                    xB(c[f >> 2] | 0, 160568, 160632);
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                b:do if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                    c[o >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (((c[(c[o >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] & 2 | 0) == 0 : 0) ? (XC(c[f >> 2] | 0, c[(c[o >> 2] | 0) + 12 >> 2] | 0) | 0) == -1 : 0)break;
	                        c[o >> 2] = c[c[o >> 2] >> 2];
	                        if (!(c[o >> 2] | 0))break b
	                    }
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } while (0);
	                c[e >> 2] = 0;
	                p = c[e >> 2] | 0;
	                i = d;
	                return p | 0
	            }

	            function YC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[e >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 48 >> 2] & 256 | 0) != 0 : 0) {
	                    i = d;
	                    return
	                }
	                b = (c[e >> 2] | 0) + 48 | 0;
	                c[b >> 2] = c[b >> 2] | 256;
	                do if ((c[(c[e >> 2] | 0) + 28 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 56 >> 2] | 0) != 0 : 0) {
	                    c[g >> 2] = wE(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        xE(c[f >> 2] | 0, 3004, c[e >> 2] | 0, c[(c[e >> 2] | 0) + 36 >> 2] | 0, 155448, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0, 1, 160528);
	                        break
	                    } else {
	                        c[(c[e >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                        break
	                    }
	                } while (0);
	                do if (c[(c[e >> 2] | 0) + 64 >> 2] | 0) {
	                    c[h >> 2] = yE(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[(c[e >> 2] | 0) + 64 >> 2] | 0, c[(c[e >> 2] | 0) + 68 >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        xE(c[f >> 2] | 0, 3004, c[e >> 2] | 0, 0, 160544, c[(c[e >> 2] | 0) + 64 >> 2] | 0, c[(c[e >> 2] | 0) + 68 >> 2] | 0, 14, 0);
	                        break
	                    }
	                    YC(c[h >> 2] | 0, c[f >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 80 >> 2] = c[h >> 2];
	                    if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0))c[(c[e >> 2] | 0) + 28 >> 2] = c[(c[h >> 2] | 0) + 28 >> 2]
	                } while (0);
	                if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 56 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 64 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                h = IH(45) | 0;
	                c[(c[e >> 2] | 0) + 28 >> 2] = h;
	                i = d;
	                return
	            }

	            function ZC(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 64 >> 2] | 0) == 0 ? (b = wE(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0, c[(c[e >> 2] | 0) + 64 >> 2] = b, (c[(c[e >> 2] | 0) + 64 >> 2] | 0) == 0) : 0) {
	                    xE(c[f >> 2] | 0, 3004, c[e >> 2] | 0, c[(c[e >> 2] | 0) + 36 >> 2] | 0, 151424, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0, 4, 0);
	                    i = d;
	                    return
	                }
	                do if ((c[c[e >> 2] >> 2] | 0) != 4) {
	                    if ((c[c[e >> 2] >> 2] | 0) == 1 ? (c[(c[e >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)break;
	                    if (!(c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    if ((c[c[(c[e >> 2] | 0) + 28 >> 2] >> 2] | 0) != 25) {
	                        i = d;
	                        return
	                    }
	                    if (!(c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    if ((c[c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] >> 2] | 0) != 2e3) {
	                        i = d;
	                        return
	                    }
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] = 0;
	                    c[h >> 2] = AE(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        b = c[f >> 2] | 0;
	                        a = FC(c[(c[e >> 2] | 0) + 28 >> 2] | 0) | 0;
	                        xE(b, 3004, 0, a, 160064, c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                        c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                        i = d;
	                        return
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                        i = d;
	                        return
	                    }
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                    if ((c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) != 8) {
	                        i = d;
	                        return
	                    }
	                    if ((c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 20 >> 2] | 0) == 1) {
	                        i = d;
	                        return
	                    }
	                    a = c[f >> 2] | 0;
	                    AB(a, 3091, FC(c[(c[e >> 2] | 0) + 28 >> 2] | 0) | 0, 0, 160416, 0, 0);
	                    i = d;
	                    return
	                } while (0);
	                if (c[(c[e >> 2] | 0) + 48 >> 2] & 128) {
	                    zE(c[f >> 2] | 0, c[e >> 2] | 0) | 0;
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 48 >> 2] & 64)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 56 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                h = wE(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0;
	                c[(c[e >> 2] | 0) + 28 >> 2] = h;
	                if (c[(c[e >> 2] | 0) + 28 >> 2] | 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 28 >> 2] >> 2] | 0) == 4) {
	                        i = d;
	                        return
	                    }
	                    if ((c[c[(c[e >> 2] | 0) + 28 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        i = d;
	                        return
	                    }
	                }
	                c[(c[e >> 2] | 0) + 28 >> 2] = 0;
	                xE(c[f >> 2] | 0, 3004, c[e >> 2] | 0, c[(c[e >> 2] | 0) + 36 >> 2] | 0, 160400, c[(c[e >> 2] | 0) + 56 >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0, 4, 0);
	                i = d;
	                return
	            }

	            function _C(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[(c[f >> 2] | 0) + 60 >> 2] & 256) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[f >> 2] | 0) + 60 | 0;
	                c[b >> 2] = c[b >> 2] | 256;
	                if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                a:do if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                    c[h >> 2] = wE(c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[(c[f >> 2] | 0) + 28 >> 2] | 0) | 0;
	                    do if (c[h >> 2] | 0) {
	                        if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                            if ((c[c[h >> 2] >> 2] | 0) != 1)break;
	                            if ((c[(c[h >> 2] | 0) + 88 >> 2] | 0) == 45)break
	                        }
	                        c[(c[f >> 2] | 0) + 48 >> 2] = c[h >> 2];
	                        break a
	                    } while (0);
	                    xE(c[g >> 2] | 0, 3004, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0, 155448, c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[(c[f >> 2] | 0) + 28 >> 2] | 0, 4, 0);
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = IH(46) | 0;
	                    c[(c[f >> 2] | 0) + 48 >> 2] = b
	                } while (0);
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function $C(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0) == 2e3 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                    b = BE(c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 12 >> 2] = b;
	                    if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                        xE(c[g >> 2] | 0, 3004, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 20 >> 2] | 0, 160064, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0, 15, 0);
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    } else {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function aD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = CE(c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    xE(c[g >> 2] | 0, 3004, 0, c[(c[f >> 2] | 0) + 20 >> 2] | 0, 160064, c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function bD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    do if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) == 2e3 : 0) {
	                        c[h >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                        c[j >> 2] = AE(c[(c[e >> 2] | 0) + 36 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            f = c[e >> 2] | 0;
	                            b = FC(c[g >> 2] | 0) | 0;
	                            xE(f, 3004, 0, b, 160064, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        }
	                        b = c[j >> 2] | 0;
	                        if ((c[c[j >> 2] >> 2] | 0) != 17) {
	                            c[(c[g >> 2] | 0) + 12 >> 2] = b;
	                            break
	                        }
	                        if (c[b + 12 >> 2] | 0)if ((c[c[(c[j >> 2] | 0) + 12 >> 2] >> 2] | 0) == 8) {
	                            b = c[e >> 2] | 0;
	                            AB(b, 3091, FC(c[g >> 2] | 0) | 0, 0, 160280, 0, 0);
	                            break
	                        } else {
	                            c[(c[g >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                            break
	                        }
	                    } while (0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 8 >> 2]
	                }
	                i = d;
	                return
	            }

	            function cD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[c[f >> 2] >> 2] | 0) != 24) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) {
	                    b = DE(c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = b;
	                    if (!(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0)) {
	                        xE(c[g >> 2] | 0, 3004, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0, 160144, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, 23, 0);
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    if ((c[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] >> 2] | 0) == 24) {
	                        AB(c[g >> 2] | 0, 3080, 0, c[f >> 2] | 0, 160152, 0, 0);
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = 0;
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    if ((c[(c[f >> 2] | 0) + 32 >> 2] | 0) != (c[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2] | 0)) {
	                        c[h >> 2] = 0;
	                        c[j >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                        b = c[g >> 2] | 0;
	                        a = c[f >> 2] | 0;
	                        AB(b, 3080, 0, a, 160184, BB(h, c[(c[j >> 2] | 0) + 20 >> 2] | 0, c[(c[j >> 2] | 0) + 16 >> 2] | 0) | 0, 0);
	                        if (c[h >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            c[h >> 2] = 0
	                        }
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function dD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(BE(c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0) | 0)) {
	                    xE(c[g >> 2] | 0, 3004, 0, c[(c[f >> 2] | 0) + 4 >> 2] | 0, 160064, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0, 15, 0);
	                    c[e >> 2] = 3004;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function eD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[c[e >> 2] >> 2] | 0) == 1) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                EE(c[f >> 2] | 0, c[e >> 2] | 0, c[(c[e >> 2] | 0) + 64 >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function fD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[c[e >> 2] >> 2] | 0) != 17) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = FE(c[e >> 2] | 0, c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[h >> 2] = 0;
	                b = c[f >> 2] | 0;
	                f = FC(c[g >> 2] | 0) | 0;
	                GE(b, 3075, 0, f, 159968, BB(h, c[(c[e >> 2] | 0) + 20 >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0);
	                if (c[h >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[h >> 2] = 0
	                }
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                i = d;
	                return
	            }

	            function gD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[(c[f >> 2] | 0) + 56 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 36 >> 2] & 16)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = HE(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[j >> 2] = 0;
	                b = c[g >> 2] | 0;
	                a = FC(c[h >> 2] | 0) | 0;
	                GE(b, 3073, 0, a, 159912, YD(j, c[f >> 2] | 0) | 0);
	                if (c[j >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    c[j >> 2] = 0
	                }
	                c[(c[h >> 2] | 0) + 4 >> 2] = 0;
	                c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function hD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[d + 8 >> 2] = a;
	                c[e >> 2] = b;
	                c[f >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] | 0) == 17 : 0) {
	                        e = (c[f >> 2] | 0) + 12 | 0;
	                        if (!(c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            c[f >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                            continue
	                        } else {
	                            c[(c[f >> 2] | 0) + 12 >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                            c[f >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                            continue
	                        }
	                    }
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 8 >> 2]
	                }
	                i = d;
	                return
	            }

	            function iD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[g >> 2] | 0) + 56 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] & 1 | 0) == 0 : 0) {
	                    b = (c[g >> 2] | 0) + 36 | 0;
	                    c[b >> 2] = c[b >> 2] | 1;
	                    if ((IE(c[f >> 2] | 0, c[g >> 2] | 0, (c[g >> 2] | 0) + 40 | 0, c[(c[g >> 2] | 0) + 56 >> 2] | 0, 0) | 0) == -1) {
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function jD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[c[g >> 2] >> 2] | 0) != 4) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 536870912 | 0) == 0 : 0) {
	                    b = (c[g >> 2] | 0) + 48 | 0;
	                    c[b >> 2] = c[b >> 2] | 536870912;
	                    b = c[g >> 2] | 0;
	                    do if (c[(c[g >> 2] | 0) + 48 >> 2] & 64) {
	                        if (!(c[b + 28 >> 2] | 0)) {
	                            xB(c[f >> 2] | 0, 153152, 153192);
	                            c[e >> 2] = -1;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                    } else {
	                        a = c[g >> 2] | 0;
	                        if (c[b + 48 >> 2] & 128) {
	                            if (c[a + 92 >> 2] | 0)break;
	                            xB(c[f >> 2] | 0, 153152, 153232);
	                            c[e >> 2] = -1;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if (!(c[a + 64 >> 2] | 0)) {
	                            xB(c[f >> 2] | 0, 153152, 153272);
	                            c[e >> 2] = -1;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if (((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) != 1 ? (c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 536870912 | 0) == 0 : 0) ? (jD(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0) == -1 : 0) {
	                            c[e >> 2] = -1;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        a = c[g >> 2] | 0;
	                        if (c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 256) {
	                            j = a + 48 | 0;
	                            c[j >> 2] = c[j >> 2] | 256;
	                            break
	                        }
	                        j = c[g >> 2] | 0;
	                        if (c[(c[a + 64 >> 2] | 0) + 48 >> 2] & 64) {
	                            a = j + 48 | 0;
	                            c[a >> 2] = c[a >> 2] | 64;
	                            c[(c[g >> 2] | 0) + 28 >> 2] = c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 28 >> 2];
	                            break
	                        }
	                        if (c[(c[j + 64 >> 2] | 0) + 48 >> 2] & 128) {
	                            j = (c[g >> 2] | 0) + 48 | 0;
	                            c[j >> 2] = c[j >> 2] | 128
	                        }
	                    } while (0);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function kD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[(c[g >> 2] | 0) + 48 >> 2] & 128) {
	                    c[e >> 2] = JE(c[f >> 2] | 0, c[g >> 2] | 0, c[(c[g >> 2] | 0) + 92 >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function lD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                if ((c[c[g >> 2] >> 2] | 0) != 4) {
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) {
	                    b = (c[g >> 2] | 0) + 48 | 0;
	                    c[b >> 2] = c[b >> 2] | 4194304;
	                    c[(c[g >> 2] | 0) + 52 >> 2] = 4;
	                    a:do if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                        if ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) != 1 ? (c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0)KE(c[(c[g >> 2] | 0) + 64 >> 2] | 0, c[f >> 2] | 0) | 0;
	                        if ((c[(c[g >> 2] | 0) + 92 >> 2] | 0) != 0 ? (LE(c[f >> 2] | 0, c[g >> 2] | 0) | 0) == -1 : 0) {
	                            c[e >> 2] = -1;
	                            k = c[e >> 2] | 0;
	                            i = d;
	                            return k | 0
	                        }
	                        c[h >> 2] = ME(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if ((c[h >> 2] | 0) != -1) {
	                            do if (!(c[h >> 2] | 0)) {
	                                c[h >> 2] = NE(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                                if ((c[h >> 2] | 0) == -1)break a;
	                                if (!(c[h >> 2] | 0)) {
	                                    c[h >> 2] = OE(c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                                    if ((c[h >> 2] | 0) == -1)break a;
	                                    if (!(c[h >> 2] | 0)) {
	                                        if (!((c[(c[g >> 2] | 0) + 96 >> 2] | 0) == 0 ? (c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 96 >> 2] | 0) == 0 : 0)) {
	                                            c[h >> 2] = PE(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                                            if ((c[h >> 2] | 0) == -1)break a;
	                                            if (c[h >> 2] | 0)break
	                                        }
	                                        c[h >> 2] = QE(c[g >> 2] | 0) | 0;
	                                        if ((c[h >> 2] | 0) == -1)break a;
	                                        if (!(c[h >> 2] | 0))RE(c[g >> 2] | 0)
	                                    }
	                                }
	                            } while (0);
	                            if ((c[j >> 2] | 0) != (c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                                k = c[e >> 2] | 0;
	                                i = d;
	                                return k | 0
	                            } else {
	                                c[e >> 2] = 0;
	                                k = c[e >> 2] | 0;
	                                i = d;
	                                return k | 0
	                            }
	                        }
	                    } else xB(c[f >> 2] | 0, 147168, 147208); while (0);
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function mD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[(c[g >> 2] | 0) + 48 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (c[(c[g >> 2] | 0) + 44 >> 2] | 0) {
	                    b = (SE(c[(c[g >> 2] | 0) + 48 >> 2] | 0, 23) | 0) != 0;
	                    a = c[f >> 2] | 0;
	                    k = c[g >> 2] | 0;
	                    if (b) {
	                        AB(a, 3090, 0, k, 159552, 0, 0);
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[h >> 2] = yB(a, c[k + 52 >> 2] | 0, c[(c[g >> 2] | 0) + 48 >> 2] | 0, c[(c[g >> 2] | 0) + 44 >> 2] | 0, (c[g >> 2] | 0) + 68 | 0, 1, 1, 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        k = c[f >> 2] | 0;
	                        if ((c[h >> 2] | 0) < 0) {
	                            xB(k, 159840, 141832);
	                            c[e >> 2] = -1;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        } else {
	                            AB(k, 3079, 0, c[g >> 2] | 0, 159680, 0, 0);
	                            c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                    }
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function nD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (((c[(c[g >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) == 15 : 0) {
	                    if (((c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 60 >> 2] & 512 | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 16 >> 2] & 1 | 0) == 0 : 0) {
	                        GE(c[f >> 2] | 0, 3078, c[g >> 2] | 0, 0, 159424, 0);
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                        b = (SE(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, 23) | 0) != 0;
	                        a = c[f >> 2] | 0;
	                        k = c[g >> 2] | 0;
	                        if (b) {
	                            AB(a, 3089, 0, k, 159552, 0, 0);
	                            c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        c[h >> 2] = yB(a, c[k + 20 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, c[(c[g >> 2] | 0) + 28 >> 2] | 0, (c[g >> 2] | 0) + 32 | 0, 1, 1, 0) | 0;
	                        if (c[h >> 2] | 0) {
	                            k = c[f >> 2] | 0;
	                            if ((c[h >> 2] | 0) < 0) {
	                                xB(k, 159640, 141832);
	                                c[e >> 2] = -1;
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            } else {
	                                AB(k, 3089, 0, c[g >> 2] | 0, 159680, 0, 0);
	                                c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            }
	                        }
	                    }
	                    if ((c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 60 >> 2] & 1 | 0) == 0 : 0) {
	                        if (!(VD(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2] | 0) | 0))GE(c[f >> 2] | 0, 3078, c[g >> 2] | 0, 0, 159728, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 44 >> 2] | 0);
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function oD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 40 | 0;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                o = d + 4 | 0;
	                p = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[(c[g >> 2] | 0) + 56 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 56 >> 2] | 0) + 4 >> 2] | 0) > 1 : 0) {
	                    c[h >> 2] = c[(c[g >> 2] | 0) + 56 >> 2];
	                    c[n >> 2] = 0;
	                    c[l >> 2] = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) - 1;
	                    b:while (1) {
	                        if ((c[l >> 2] | 0) < 0)break a;
	                        c[j >> 2] = c[(c[c[h >> 2] >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                        c:do if ((c[l >> 2] | 0) > 0) {
	                            c[m >> 2] = (c[l >> 2] | 0) - 1;
	                            while (1) {
	                                if ((c[m >> 2] | 0) < 0) {
	                                    q = 15;
	                                    break c
	                                }
	                                c[k >> 2] = c[(c[c[h >> 2] >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                if ((c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) == (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) : 0)break;
	                                c[m >> 2] = (c[m >> 2] | 0) + -1
	                            }
	                            c[o >> 2] = 0;
	                            b = c[f >> 2] | 0;
	                            a = c[(c[g >> 2] | 0) + 32 >> 2] | 0;
	                            r = c[g >> 2] | 0;
	                            AB(b, 3087, a, r, 152424, ZD(o, c[j >> 2] | 0) | 0, 0);
	                            if (c[o >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                c[o >> 2] = 0
	                            }
	                            if ((TE(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == -1) {
	                                q = 13;
	                                break b
	                            }
	                        } else q = 15; while (0);
	                        if (((q | 0) == 15 ? (q = 0, (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0) != 0) : 0) ? (SE(c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, 23) | 0) != 0 : 0) {
	                            if (c[n >> 2] | 0) {
	                                c[p >> 2] = 0;
	                                r = c[f >> 2] | 0;
	                                a = c[(c[g >> 2] | 0) + 32 >> 2] | 0;
	                                b = c[g >> 2] | 0;
	                                AB(r, 3087, a, b, 152440, ZD(p, c[j >> 2] | 0) | 0, 0);
	                                if (c[p >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                                    c[p >> 2] = 0
	                                }
	                                if ((TE(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == -1) {
	                                    q = 21;
	                                    break
	                                }
	                            }
	                            c[n >> 2] = 1
	                        }
	                        c[l >> 2] = (c[l >> 2] | 0) + -1
	                    }
	                    if ((q | 0) == 13) {
	                        c[e >> 2] = -1;
	                        s = c[e >> 2] | 0;
	                        i = d;
	                        return s | 0
	                    } else if ((q | 0) == 21) {
	                        c[e >> 2] = -1;
	                        s = c[e >> 2] | 0;
	                        i = d;
	                        return s | 0
	                    }
	                } while (0);
	                c[e >> 2] = 0;
	                s = c[e >> 2] | 0;
	                i = d;
	                return s | 0
	            }

	            function pD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                while (1) {
	                    a = c[g >> 2] | 0;
	                    if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))c[g >> 2] = c[a >> 2]; else {
	                        c[h >> 2] = c[a + 4 >> 2];
	                        a = c[c[h >> 2] >> 2] | 0;
	                        if ((a | 0) == 16) {
	                            c[f >> 2] = UE(c[e >> 2] | 0, 1, c[h >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 40 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            if ((c[f >> 2] | 0) == -1) {
	                                k = 8;
	                                break
	                            }
	                        } else if ((a | 0) == 5 | (a | 0) == 4)c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] = 0;
	                        c[g >> 2] = c[c[g >> 2] >> 2]
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        k = 11;
	                        break
	                    }
	                }
	                if ((k | 0) == 8) {
	                    c[d >> 2] = -1;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else if ((k | 0) == 11) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function qD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 40 | 0;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                o = d + 4 | 0;
	                p = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                c[k >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                if ((c[c[g >> 2] >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) {
	                    b = (c[g >> 2] | 0) + 48 | 0;
	                    c[b >> 2] = c[b >> 2] | 4194304;
	                    a:do if (c[k >> 2] | 0) {
	                        if ((c[c[k >> 2] >> 2] | 0) != 1 ? (c[(c[k >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0)KE(c[k >> 2] | 0, c[f >> 2] | 0) | 0;
	                        if (c[(c[k >> 2] | 0) + 48 >> 2] & 8388608) {
	                            c[e >> 2] = 0;
	                            q = c[e >> 2] | 0;
	                            i = d;
	                            return q | 0
	                        }
	                        c[h >> 2] = VE(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if ((c[h >> 2] | 0) != -1) {
	                            b:do if (!(c[h >> 2] | 0)) {
	                                c:do if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) == 4) {
	                                    if (!((c[c[k >> 2] >> 2] | 0) != 5 ? (c[(c[k >> 2] | 0) + 88 >> 2] | 0) != 45 : 0))r = 16;
	                                    if (((r | 0) == 16 ? (c[(c[k >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 48 >> 2] & 4 | 0) != 0 : 0) {
	                                        if (c[(c[g >> 2] | 0) + 104 >> 2] | 0) {
	                                            c[l >> 2] = c[(c[g >> 2] | 0) + 104 >> 2];
	                                            c[(c[g >> 2] | 0) + 104 >> 2] = 0
	                                        } else c[l >> 2] = c[(c[k >> 2] | 0) + 104 >> 2];
	                                        c[m >> 2] = WE(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0, 4, 0, c[(c[g >> 2] | 0) + 112 >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 0) | 0;
	                                        if (!(c[m >> 2] | 0))break a;
	                                        c[c[m >> 2] >> 2] = 4;
	                                        c[(c[m >> 2] | 0) + 64 >> 2] = c[l >> 2];
	                                        c[(c[m >> 2] | 0) + 68 >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                                        c[(c[g >> 2] | 0) + 68 >> 2] = 0;
	                                        c[(c[m >> 2] | 0) + 96 >> 2] = c[(c[g >> 2] | 0) + 96 >> 2];
	                                        c[(c[g >> 2] | 0) + 96 >> 2] = 0;
	                                        c[(c[g >> 2] | 0) + 104 >> 2] = c[m >> 2];
	                                        do if ((c[c[l >> 2] >> 2] | 0) != 1) {
	                                            if (c[(c[l >> 2] | 0) + 48 >> 2] & 4194304)break;
	                                            KE(c[l >> 2] | 0, c[f >> 2] | 0) | 0
	                                        } while (0);
	                                        c[h >> 2] = jD(c[f >> 2] | 0, c[m >> 2] | 0) | 0;
	                                        if ((c[h >> 2] | 0) == -1)break a;
	                                        if (c[h >> 2] | 0)break b;
	                                        c[h >> 2] = lD(c[f >> 2] | 0, c[m >> 2] | 0) | 0;
	                                        if ((c[h >> 2] | 0) == -1)break a;
	                                        if (c[h >> 2] | 0)break b; else break
	                                    }
	                                    if (!((c[c[k >> 2] >> 2] | 0) != 5 ? (c[(c[k >> 2] | 0) + 88 >> 2] | 0) != 45 : 0))r = 31;
	                                    if (((r | 0) == 31 ? (c[(c[k >> 2] | 0) + 52 >> 2] | 0) == 3 : 0) ? (c[(c[g >> 2] | 0) + 48 >> 2] & 4 | 0) != 0 : 0) {
	                                        if ((c[(c[g >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 104 >> 2] | 0) + 64 >> 2] | 0) != 0 : 0)break;
	                                        GE(c[f >> 2] | 0, 3069, c[g >> 2] | 0, 0, 149808, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                                        break a
	                                    }
	                                    if (!((c[c[k >> 2] >> 2] | 0) != 5 ? (c[(c[k >> 2] | 0) + 88 >> 2] | 0) != 45 : 0))r = 38;
	                                    if ((r | 0) == 38 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 2 | 0) != 0 : 0)if (!(c[(c[k >> 2] | 0) + 104 >> 2] | 0)) {
	                                        GE(c[f >> 2] | 0, 3069, c[g >> 2] | 0, 0, 149976, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                                        break a
	                                    } else {
	                                        c[(c[g >> 2] | 0) + 104 >> 2] = c[(c[k >> 2] | 0) + 104 >> 2];
	                                        break
	                                    }
	                                    if ((c[c[k >> 2] >> 2] | 0) != 4) {
	                                        if ((c[c[k >> 2] >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)r = 45
	                                    } else r = 45;
	                                    if ((r | 0) == 45 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 2 | 0) != 0 : 0) {
	                                        c[(c[g >> 2] | 0) + 104 >> 2] = c[k >> 2];
	                                        break
	                                    }
	                                    GE(c[f >> 2] | 0, 3069, c[g >> 2] | 0, 0, 150112, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                                    break a
	                                } else {
	                                    c[n >> 2] = 0;
	                                    c[o >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                                    d:do if (!(c[o >> 2] | 0))r = 55; else {
	                                        do if ((c[c[o >> 2] >> 2] | 0) == 25) {
	                                            if ((c[c[(c[o >> 2] | 0) + 12 >> 2] >> 2] | 0) != 8 ? (c[c[(c[o >> 2] | 0) + 12 >> 2] >> 2] | 0) != 6 : 0) {
	                                                if ((c[c[(c[o >> 2] | 0) + 12 >> 2] >> 2] | 0) != 7)break;
	                                                if (c[(c[o >> 2] | 0) + 16 >> 2] | 0)break
	                                            }
	                                            if (!(c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0)) {
	                                                r = 55;
	                                                break d
	                                            }
	                                        } while (0);
	                                        c[(c[g >> 2] | 0) + 52 >> 2] = 2
	                                    } while (0);
	                                    do if ((r | 0) == 55) {
	                                        if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 1)) {
	                                            c[(c[g >> 2] | 0) + 52 >> 2] = 1;
	                                            break
	                                        }
	                                        if (!((c[o >> 2] | 0) != 0 ? (c[c[(c[o >> 2] | 0) + 12 >> 2] >> 2] | 0) == 6 : 0)) {
	                                            c[o >> 2] = XE(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 1, 1) | 0;
	                                            if (!(c[o >> 2] | 0))break a;
	                                            b = YE(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0, 6, c[(c[g >> 2] | 0) + 36 >> 2] | 0) | 0;
	                                            c[(c[o >> 2] | 0) + 12 >> 2] = b;
	                                            if (!(c[(c[o >> 2] | 0) + 12 >> 2] | 0))break a;
	                                            c[(c[g >> 2] | 0) + 28 >> 2] = c[o >> 2]
	                                        }
	                                        c[n >> 2] = 1;
	                                        c[(c[g >> 2] | 0) + 52 >> 2] = 2
	                                    } while (0);
	                                    b = c[(c[g >> 2] | 0) + 52 >> 2] | 0;
	                                    if (c[(c[g >> 2] | 0) + 48 >> 2] & 4) {
	                                        if ((b | 0) == 1)break;
	                                        if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 1))break;
	                                        c[(c[g >> 2] | 0) + 52 >> 2] = 3;
	                                        break
	                                    }
	                                    a = c[(c[k >> 2] | 0) + 52 >> 2] | 0;
	                                    if ((b | 0) == 1) {
	                                        c[(c[g >> 2] | 0) + 52 >> 2] = a;
	                                        c[(c[g >> 2] | 0) + 28 >> 2] = c[(c[k >> 2] | 0) + 28 >> 2];
	                                        c[(c[g >> 2] | 0) + 104 >> 2] = c[(c[k >> 2] | 0) + 104 >> 2];
	                                        break
	                                    }
	                                    b = (c[(c[g >> 2] | 0) + 48 >> 2] & 1 | 0) != 0;
	                                    if ((a | 0) == 1) {
	                                        if (!b)break;
	                                        c[(c[g >> 2] | 0) + 52 >> 2] = 3;
	                                        break
	                                    }
	                                    if (b)c[(c[g >> 2] | 0) + 52 >> 2] = 3;
	                                    do if ((c[(c[g >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                        if ((c[c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] >> 2] | 0) != 8)break;
	                                        b = c[f >> 2] | 0;
	                                        AB(b, 3091, FC(c[g >> 2] | 0) | 0, 0, 150216, 0, 0);
	                                        break c
	                                    } while (0);
	                                    do if (c[(c[k >> 2] | 0) + 28 >> 2] | 0) {
	                                        if (!(c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0))break;
	                                        if ((c[c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] >> 2] | 0) != 8)break;
	                                        b = c[f >> 2] | 0;
	                                        AB(b, 3091, FC(c[g >> 2] | 0) | 0, 0, 150480, 0, 0);
	                                        break c
	                                    } while (0);
	                                    if (c[n >> 2] | 0) {
	                                        c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] = c[(c[k >> 2] | 0) + 28 >> 2];
	                                        break
	                                    }
	                                    c[p >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                                    c[o >> 2] = XE(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 1, 1) | 0;
	                                    if (!(c[o >> 2] | 0))break a;
	                                    b = YE(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0, 6, c[(c[g >> 2] | 0) + 36 >> 2] | 0) | 0;
	                                    c[(c[o >> 2] | 0) + 12 >> 2] = b;
	                                    if (!(c[(c[o >> 2] | 0) + 12 >> 2] | 0))break a;
	                                    c[(c[g >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                                    b = XE(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0, c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 20 >> 2] | 0) | 0;
	                                    c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] = b;
	                                    if (!(c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0))break a;
	                                    c[o >> 2] = c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                                    c[(c[o >> 2] | 0) + 12 >> 2] = c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2];
	                                    c[(c[o >> 2] | 0) + 8 >> 2] = c[p >> 2]
	                                } while (0);
	                                c[h >> 2] = ZE(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                                if ((c[h >> 2] | 0) == -1)break a;
	                                if (!(c[h >> 2] | 0)) {
	                                    c[h >> 2] = _E(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                                    if ((c[h >> 2] | 0) == -1)break a;
	                                    if (!(c[h >> 2] | 0))if ((c[j >> 2] | 0) != (c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                                        q = c[e >> 2] | 0;
	                                        i = d;
	                                        return q | 0
	                                    } else {
	                                        c[e >> 2] = 0;
	                                        q = c[e >> 2] | 0;
	                                        i = d;
	                                        return q | 0
	                                    }
	                                }
	                            } while (0);
	                            b = (c[g >> 2] | 0) + 48 | 0;
	                            c[b >> 2] = c[b >> 2] | 8388608;
	                            c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            q = c[e >> 2] | 0;
	                            i = d;
	                            return q | 0
	                        }
	                    } else xB(c[f >> 2] | 0, 149776, 147208); while (0);
	                    f = (c[g >> 2] | 0) + 48 | 0;
	                    c[f >> 2] = c[f >> 2] | 8388608;
	                    c[e >> 2] = -1;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                c[e >> 2] = 0;
	                q = c[e >> 2] | 0;
	                i = d;
	                return q | 0
	            }

	            function rD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 48 >> 2] & 262144) {
	                    i = d;
	                    return
	                }
	                b = (c[e >> 2] | 0) + 48 | 0;
	                c[b >> 2] = c[b >> 2] | 262144;
	                if ($E(c[f >> 2] | 0, c[e >> 2] | 0) | 0) {
	                    i = d;
	                    return
	                }
	                aF(c[f >> 2] | 0, c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function sD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[c[f >> 2] >> 2] | 0) != 5) {
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 108 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[f >> 2] | 0) + 52 >> 2] | 0) != 2 ? (c[(c[f >> 2] | 0) + 52 >> 2] | 0) != 3 : 0) {
	                    i = d;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 64 >> 2] = 0;
	                b = xz() | 0;
	                c[(c[g >> 2] | 0) + 64 >> 2] = b;
	                if (!(c[(c[g >> 2] | 0) + 64 >> 2] | 0)) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    Db[b & 511](a, 157984, e);
	                    i = d;
	                    return
	                }
	                e = Bz(c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0;
	                c[(c[g >> 2] | 0) + 76 >> 2] = e;
	                bF(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 28 >> 2] | 0) | 0;
	                Cz(c[(c[g >> 2] | 0) + 64 >> 2] | 0, c[(c[g >> 2] | 0) + 76 >> 2] | 0) | 0;
	                e = Oz(c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 108 >> 2] = e;
	                if (c[(c[f >> 2] | 0) + 108 >> 2] | 0) {
	                    if ((wz(c[(c[f >> 2] | 0) + 108 >> 2] | 0) | 0) != 1)GE(c[g >> 2] | 0, 3070, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0, 158072, 0)
	                } else GE(c[g >> 2] | 0, 3069, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0, 158032, 0);
	                c[(c[g >> 2] | 0) + 76 >> 2] = 0;
	                yz(c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                c[(c[g >> 2] | 0) + 64 >> 2] = 0;
	                i = d;
	                return
	            }

	            function tD(a) {
	                a = a | 0;
	                var b = 0, d = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                h = b + 16 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                m = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                a = c[f >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 84 >> 2] | 0)c[l >> 2] = c[a + 84 >> 2]; else c[l >> 2] = Pi(c[a + 24 >> 2] | 0) | 0;
	                a = c[f >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    AB(a, 1, 0, 0, 141128, 0, 0);
	                    c[d >> 2] = 1;
	                    n = c[d >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[a + 96 >> 2] = -1;
	                c[(c[f >> 2] | 0) + 84 >> 2] = c[l >> 2];
	                c[k >> 2] = c[l >> 2];
	                a:while (1) {
	                    if (!(c[k >> 2] | 0)) {
	                        o = 48;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[f >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 176 >> 2] | 0) : 0)o = 45; else o = 10;
	                    do if ((o | 0) == 10) {
	                        o = 0;
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            a = (c[f >> 2] | 0) + 96 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            if ((uD(c[f >> 2] | 0) | 0) == -1)break a;
	                            c[j >> 2] = c[(c[f >> 2] | 0) + 108 >> 2];
	                            c[(c[j >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                            c[(c[j >> 2] | 0) + 8 >> 2] = e[(c[k >> 2] | 0) + 56 >> 1];
	                            c[(c[j >> 2] | 0) + 12 >> 2] = c[(c[k >> 2] | 0) + 8 >> 2];
	                            if (c[(c[k >> 2] | 0) + 36 >> 2] | 0)c[(c[j >> 2] | 0) + 16 >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2];
	                            a = (c[j >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = c[a >> 2] | 32;
	                            c[(c[f >> 2] | 0) + 168 >> 2] = 0;
	                            if (c[(c[k >> 2] | 0) + 44 >> 2] | 0) {
	                                c[g >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                                do {
	                                    if (c[(c[g >> 2] | 0) + 36 >> 2] | 0)c[m >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2]; else c[m >> 2] = 0;
	                                    a = c[f >> 2] | 0;
	                                    p = c[g >> 2] | 0;
	                                    q = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                                    r = c[(c[g >> 2] | 0) + 8 >> 2] | 0;
	                                    s = c[m >> 2] | 0;
	                                    c[h >> 2] = vD(a, p, q, r, s, 0, _h(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 1) | 0, 1) | 0;
	                                    if ((c[h >> 2] | 0) == -1) {
	                                        o = 20;
	                                        break a
	                                    }
	                                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                                } while ((c[g >> 2] | 0) != 0)
	                            }
	                            c[h >> 2] = wD(c[f >> 2] | 0) | 0;
	                            if (c[h >> 2] | 0)if ((c[h >> 2] | 0) == -1) {
	                                o = 24;
	                                break a
	                            } else break;
	                            if ((c[(c[f >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[f >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 176 >> 2] | 0) : 0)break
	                        } else {
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 6) {
	                                    o = 36;
	                                    break a
	                                }
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                                    o = 36;
	                                    break a
	                                } else break
	                            }
	                            if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] & 32 | 0) != 0 : 0) {
	                                s = (c[j >> 2] | 0) + 32 | 0;
	                                c[s >> 2] = c[s >> 2] ^ 32
	                            }
	                            c[h >> 2] = yD(c[f >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[k >> 2] | 0) + 40 >> 2] | 0, -1, 1, 0) | 0;
	                            if ((c[h >> 2] | 0) < 0) {
	                                o = 33;
	                                break a
	                            }
	                        }
	                        if (c[(c[k >> 2] | 0) + 12 >> 2] | 0) {
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                            continue a
	                        }
	                    } while (0);
	                    while (1) {
	                        if ((o | 0) == 45) {
	                            o = 0;
	                            t = c[k >> 2] | 0;
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] | 0)break;
	                            c[k >> 2] = c[t + 20 >> 2]
	                        }
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                            o = 45;
	                            continue
	                        }
	                        u = c[f >> 2] | 0;
	                        if ((c[k >> 2] | 0) != (c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 4 >> 2] | 0)) {
	                            o = 41;
	                            break a
	                        }
	                        c[h >> 2] = xD(u) | 0;
	                        if ((c[h >> 2] | 0) != 0 & (c[h >> 2] | 0) < 0) {
	                            o = 43;
	                            break a
	                        }
	                        if ((c[k >> 2] | 0) == (c[l >> 2] | 0)) {
	                            o = 48;
	                            break a
	                        } else o = 45
	                    }
	                    c[k >> 2] = c[t + 24 >> 2]
	                }
	                if ((o | 0) == 20)xB(c[f >> 2] | 0, 155912, 144696); else if ((o | 0) == 24)xB(c[f >> 2] | 0, 155912, 144744); else if ((o | 0) == 33)xB(c[f >> 2] | 0, 155936, 141336); else if ((o | 0) == 36)xB(c[f >> 2] | 0, 155936, 155960); else if ((o | 0) == 41)xB(u, 155936, 156168); else if ((o | 0) == 43)xB(c[f >> 2] | 0, 155936, 141688); else if ((o | 0) == 48) {
	                    c[d >> 2] = c[h >> 2];
	                    n = c[d >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[d >> 2] = -1;
	                n = c[d >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function uD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a = cF(c[e >> 2] | 0) | 0;
	                c[(c[e >> 2] | 0) + 108 >> 2] = a;
	                a = c[e >> 2] | 0;
	                if (!(c[(c[e >> 2] | 0) + 108 >> 2] | 0)) {
	                    xB(a, 155592, 155624);
	                    c[d >> 2] = -1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else {
	                    c[a + 168 >> 2] = 0;
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function vD(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                k = i;
	                i = i + 48 | 0;
	                l = k + 36 | 0;
	                m = k + 32 | 0;
	                n = k + 28 | 0;
	                o = k + 24 | 0;
	                p = k + 20 | 0;
	                q = k + 16 | 0;
	                r = k + 12 | 0;
	                s = k + 8 | 0;
	                t = k + 4 | 0;
	                u = k;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = dF(c[m >> 2] | 0) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    xB(c[m >> 2] | 0, 155408, 145304);
	                    c[l >> 2] = -1;
	                    v = c[l >> 2] | 0;
	                    i = k;
	                    return v | 0
	                }
	                c[(c[u >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                c[(c[u >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                c[(c[u >> 2] | 0) + 44 >> 2] = 1;
	                c[(c[u >> 2] | 0) + 12 >> 2] = c[p >> 2];
	                c[(c[u >> 2] | 0) + 16 >> 2] = c[q >> 2];
	                if (c[r >> 2] | 0) {
	                    r = (c[u >> 2] | 0) + 32 | 0;
	                    c[r >> 2] = c[r >> 2] | 1
	                }
	                do if (c[q >> 2] | 0) {
	                    if (qy(c[p >> 2] | 0, 155432) | 0) {
	                        if (!(qy(c[(c[u >> 2] | 0) + 16 >> 2] | 0, c[38860] | 0) | 0))break;
	                        c[(c[u >> 2] | 0) + 48 >> 2] = 2;
	                        break
	                    }
	                    if (qy(c[p >> 2] | 0, 155448) | 0) {
	                        if (!(qy(c[(c[u >> 2] | 0) + 16 >> 2] | 0, c[38860] | 0) | 0))break;
	                        c[(c[u >> 2] | 0) + 48 >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[p >> 2] | 0, 155456) | 0) {
	                        if (!(qy(c[(c[u >> 2] | 0) + 16 >> 2] | 0, c[38860] | 0) | 0))break;
	                        c[(c[u >> 2] | 0) + 48 >> 2] = 3;
	                        break
	                    }
	                    r = (qy(c[p >> 2] | 0, 155472) | 0) != 0;
	                    o = c[(c[u >> 2] | 0) + 16 >> 2] | 0;
	                    if (r) {
	                        if (!(qy(o, c[38860] | 0) | 0))break;
	                        c[(c[u >> 2] | 0) + 48 >> 2] = 4;
	                        break
	                    } else {
	                        if (!(qy(o, c[38876] | 0) | 0))break;
	                        c[(c[u >> 2] | 0) + 48 >> 2] = 5;
	                        break
	                    }
	                } while (0);
	                c[(c[u >> 2] | 0) + 20 >> 2] = c[s >> 2];
	                if (c[t >> 2] | 0) {
	                    t = (c[u >> 2] | 0) + 32 | 0;
	                    c[t >> 2] = c[t >> 2] | 2
	                }
	                if (c[(c[u >> 2] | 0) + 48 >> 2] | 0)c[(c[u >> 2] | 0) + 44 >> 2] = 17;
	                c[l >> 2] = 0;
	                v = c[l >> 2] | 0;
	                i = k;
	                return v | 0
	            }

	            function wD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if ((c[(c[e >> 2] | 0) + 176 >> 2] | 0) != -1 ? (c[(c[e >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[e >> 2] | 0) + 176 >> 2] | 0) : 0)xB(c[e >> 2] | 0, 144776, 144800); else h = 4;
	                a:do if ((h | 0) == 4) {
	                    do if (c[(c[e >> 2] | 0) + 92 >> 2] | 0) {
	                        c[f >> 2] = eF(c[e >> 2] | 0) | 0;
	                        if (!(c[f >> 2] | 0)) {
	                            Wj(c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] | 0, 357, c[e >> 2] | 0);
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == -1)break a;
	                        c[(c[e >> 2] | 0) + 176 >> 2] = 0;
	                        c[d >> 2] = c[f >> 2];
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } while (0);
	                    a = c[e >> 2] | 0;
	                    do if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) > 0) {
	                        c[f >> 2] = fF(a) | 0;
	                        if (c[f >> 2] | 0) {
	                            if ((c[f >> 2] | 0) >= 0)break;
	                            xB(c[e >> 2] | 0, 144776, 144816);
	                            break a
	                        }
	                        if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) != (c[(c[e >> 2] | 0) + 176 >> 2] | 0))if ((c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                            xB(c[e >> 2] | 0, 144776, 144864);
	                            break a
	                        } else h = 19
	                    } else {
	                        k = yE(c[a + 20 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] = k;
	                        if (!(c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] | 0)) {
	                            c[f >> 2] = 1845;
	                            AB(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0, 144944, 0, 0)
	                        } else h = 19
	                    } while (0);
	                    b:do if ((h | 0) == 19) {
	                        do if (c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] | 0) {
	                            if ((c[c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] >> 2] | 0) == 2) {
	                                c[f >> 2] = gF(c[e >> 2] | 0, g) | 0;
	                                if (c[f >> 2] | 0) {
	                                    if ((c[f >> 2] | 0) >= 0)break b;
	                                    xB(c[e >> 2] | 0, 144776, 145016);
	                                    break a
	                                }
	                                a = c[e >> 2] | 0;
	                                if (c[g >> 2] | 0) {
	                                    c[(c[e >> 2] | 0) + 176 >> 2] = c[a + 96 >> 2];
	                                    break b
	                                }
	                                if ((c[c[(c[a + 108 >> 2] | 0) + 44 >> 2] >> 2] | 0) != 14) {
	                                    c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] = 0;
	                                    break
	                                }
	                            }
	                            c[f >> 2] = hF(c[e >> 2] | 0) | 0;
	                            if (c[f >> 2] | 0) {
	                                if ((c[f >> 2] | 0) >= 0)break b;
	                                xB(c[e >> 2] | 0, 144776, 145056);
	                                break a
	                            }
	                        } while (0);
	                        a = c[(c[e >> 2] | 0) + 108 >> 2] | 0;
	                        if (!(c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] | 0)) {
	                            k = a + 32 | 0;
	                            c[k >> 2] = c[k >> 2] | 1024;
	                            c[f >> 2] = 1875;
	                            AB(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0, 145096, 0, 0);
	                            break
	                        }
	                        k = c[e >> 2] | 0;
	                        if (c[(c[a + 28 >> 2] | 0) + 48 >> 2] & 1048576) {
	                            a = (c[k + 108 >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = c[a >> 2] | 1024;
	                            c[f >> 2] = 1876;
	                            AB(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0, 145128, 0, 0);
	                            break
	                        }
	                        if ((c[k + 116 >> 2] | 0) != 0 ? (c[f >> 2] = iF(c[e >> 2] | 0, 1) | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 80 >> 2] = 1, (c[f >> 2] | 0) == -1) : 0) {
	                            xB(c[e >> 2] | 0, 144776, 145160);
	                            break a
	                        }
	                        if ((c[c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] >> 2] | 0) != 5 ? (c[(c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                            if (c[(c[e >> 2] | 0) + 168 >> 2] | 0)c[f >> 2] = kF(c[e >> 2] | 0) | 0
	                        } else h = 40;
	                        do if ((h | 0) == 40) {
	                            if ((c[(c[e >> 2] | 0) + 168 >> 2] | 0) == 0 ? (c[(c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] | 0) + 116 >> 2] | 0) == 0 : 0)break;
	                            c[f >> 2] = jF(c[e >> 2] | 0) | 0
	                        } while (0);
	                        if (c[(c[e >> 2] | 0) + 168 >> 2] | 0)vB(c[e >> 2] | 0);
	                        if ((c[f >> 2] | 0) == -1) {
	                            xB(c[e >> 2] | 0, 144776, 145200);
	                            break a
	                        } else {
	                            c[f >> 2] = 0;
	                            break
	                        }
	                    } while (0);
	                    if (c[f >> 2] | 0)c[(c[e >> 2] | 0) + 176 >> 2] = c[(c[e >> 2] | 0) + 96 >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } while (0);
	                c[d >> 2] = -1;
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function xD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 80 | 0;
	                d = b + 76 | 0;
	                e = b + 72 | 0;
	                f = b + 68 | 0;
	                g = b + 64 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                o = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = c[(c[e >> 2] | 0) + 108 >> 2];
	                if (c[(c[e >> 2] | 0) + 168 >> 2] | 0)vB(c[e >> 2] | 0);
	                a:do if (!(c[(c[g >> 2] | 0) + 32 >> 2] & 512))if ((c[(c[g >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] & 1024 | 0) == 0 : 0) {
	                    if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 3 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 2 : 0)p = 21; else p = 9;
	                    b:do if ((p | 0) == 9 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)if (!(c[(c[g >> 2] | 0) + 32 >> 2] & 256)) {
	                        c[k >> 2] = 10;
	                        if ((c[(c[g >> 2] | 0) + 60 >> 2] | 0) == 0 ? (a = oz(c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 108 >> 2] | 0, 358, c[e >> 2] | 0) | 0, c[(c[g >> 2] | 0) + 60 >> 2] = a, (c[(c[g >> 2] | 0) + 60 >> 2] | 0) == 0) : 0) {
	                            xB(c[e >> 2] | 0, 141728, 141760);
	                            break a
	                        }
	                        if (c[(c[g >> 2] | 0) + 32 >> 2] & 4) {
	                            c[f >> 2] = 0;
	                            p = 21;
	                            break
	                        }
	                        sz(c[(c[g >> 2] | 0) + 60 >> 2] | 0, k, l, h, j) | 0;
	                        c[f >> 2] = qz(c[(c[g >> 2] | 0) + 60 >> 2] | 0, 0, 0) | 0;
	                        do if ((c[f >> 2] | 0) >= 0) {
	                            if ((c[f >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] & 4 | 0) == 0 : 0)break;
	                            c[f >> 2] = 0;
	                            p = 21;
	                            break b
	                        } while (0);
	                        c[f >> 2] = 1;
	                        a = (c[g >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = c[a >> 2] | 256;
	                        mF(c[e >> 2] | 0, 1871, 0, 0, 141800, c[k >> 2] | 0, c[l >> 2] | 0, h);
	                        p = 21
	                    } else p = 21; while (0);
	                    if ((p | 0) == 21 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) == 2 : 0) {
	                        p = 81;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 72 >> 2] | 0) {
	                        PH(c[(c[e >> 2] | 0) + 72 >> 2] | 0);
	                        c[(c[e >> 2] | 0) + 72 >> 2] = 0
	                    }
	                    a = c[g >> 2] | 0;
	                    if (!(c[(c[g >> 2] | 0) + 44 >> 2] | 0)) {
	                        do if ((c[c[a + 28 >> 2] >> 2] | 0) == 4)p = 28; else {
	                            if ((c[c[(c[g >> 2] | 0) + 28 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                                p = 28;
	                                break
	                            }
	                            if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 6 : 0)break;
	                            c[f >> 2] = nF(c[e >> 2] | 0, c[g >> 2] | 0, c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 104 >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0
	                        } while (0);
	                        if ((p | 0) == 28)c[f >> 2] = nF(c[e >> 2] | 0, c[g >> 2] | 0, c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        if ((c[f >> 2] | 0) >= 0) {
	                            p = 81;
	                            break
	                        }
	                        xB(c[e >> 2] | 0, 141728, 141832);
	                        break
	                    }
	                    if (((c[(c[a + 44 >> 2] | 0) + 76 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 32 >> 2] & 32 | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 32 >> 2] & 4 | 0) == 0 : 0) {
	                        if (c[(c[g >> 2] | 0) + 32 >> 2] & 8) {
	                            c[f >> 2] = oF(c[e >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0, (c[g >> 2] | 0) + 24 | 0) | 0;
	                            if (c[f >> 2] | 0) {
	                                if ((c[f >> 2] | 0) >= 0) {
	                                    p = 81;
	                                    break
	                                }
	                                xB(c[e >> 2] | 0, 141728, 141872);
	                                break
	                            }
	                        } else {
	                            do if ((c[c[(c[g >> 2] | 0) + 28 >> 2] >> 2] | 0) == 4)p = 44; else {
	                                if ((c[c[(c[g >> 2] | 0) + 28 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                                    p = 44;
	                                    break
	                                }
	                                if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 6 : 0)break;
	                                c[f >> 2] = nF(c[e >> 2] | 0, c[g >> 2] | 0, c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 104 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) | 0
	                            } while (0);
	                            if ((p | 0) == 44)c[f >> 2] = nF(c[e >> 2] | 0, c[g >> 2] | 0, c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) | 0;
	                            if (c[f >> 2] | 0) {
	                                if ((c[f >> 2] | 0) >= 0) {
	                                    p = 81;
	                                    break
	                                }
	                                xB(c[e >> 2] | 0, 141728, 141832);
	                                break
	                            }
	                        }
	                        if (!(c[(c[e >> 2] | 0) + 80 >> 2] & 1)) {
	                            p = 81;
	                            break
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                            p = 81;
	                            break
	                        }
	                        c[n >> 2] = zC(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) | 0;
	                        if (c[n >> 2] | 0) {
	                            c[m >> 2] = li(c[n >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                        } else c[m >> 2] = li(c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            xB(c[e >> 2] | 0, 141728, 141912);
	                            break
	                        } else {
	                            zi(c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                            p = 81;
	                            break
	                        }
	                    }
	                    if (!(c[(c[g >> 2] | 0) + 32 >> 2] & 4)) {
	                        do if ((c[c[(c[g >> 2] | 0) + 28 >> 2] >> 2] | 0) == 4)p = 63; else {
	                            if ((c[c[(c[g >> 2] | 0) + 28 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                                p = 63;
	                                break
	                            }
	                            if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 6 : 0)break;
	                            c[f >> 2] = nF(c[e >> 2] | 0, c[g >> 2] | 0, c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 104 >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0
	                        } while (0);
	                        if ((p | 0) == 63)c[f >> 2] = nF(c[e >> 2] | 0, c[g >> 2] | 0, c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        if (c[f >> 2] | 0) {
	                            if ((c[f >> 2] | 0) >= 0) {
	                                p = 81;
	                                break
	                            }
	                            xB(c[e >> 2] | 0, 141728, 141832);
	                            break
	                        }
	                        if ((c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] & 8 | 0) != 0 : 0) {
	                            if (c[(c[g >> 2] | 0) + 32 >> 2] & 128) {
	                                c[f >> 2] = 1856;
	                                AB(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0, 141936, 0, 0);
	                                p = 81;
	                                break
	                            }
	                            a = c[g >> 2] | 0;
	                            if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) == 3) {
	                                if (qy(c[a + 20 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) | 0) {
	                                    p = 81;
	                                    break
	                                }
	                                c[f >> 2] = 1857;
	                                AB(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0, 142024, c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0);
	                                p = 81;
	                                break
	                            }
	                            if ((c[(c[a + 28 >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                                p = 81;
	                                break
	                            }
	                            if (!(qy(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) | 0)) {
	                                c[f >> 2] = 1858;
	                                AB(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0, 142096, c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0);
	                                p = 81
	                            } else p = 81
	                        } else p = 81
	                    } else p = 81
	                } else p = 81; else {
	                    c[(c[e >> 2] | 0) + 176 >> 2] = (c[(c[e >> 2] | 0) + 96 >> 2] | 0) - 1;
	                    p = 81
	                } while (0);
	                c:do if ((p | 0) == 81) {
	                    if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) < 0) {
	                        c[d >> 2] = 0;
	                        q = c[d >> 2] | 0;
	                        i = b;
	                        return q | 0
	                    }
	                    if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) == (c[(c[e >> 2] | 0) + 176 >> 2] | 0))c[(c[e >> 2] | 0) + 176 >> 2] = -1;
	                    if ((c[(c[g >> 2] | 0) + 80 >> 2] | 0) != 0 ? (pF(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 96 >> 2] | 0) | 0) == -1 : 0)break;
	                    do if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                        if ((c[(c[e >> 2] | 0) + 184 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 188 >> 2] | 0) == 0 : 0)break;
	                        if ((qF(c[e >> 2] | 0, c[g >> 2] | 0) | 0) == -1)break c
	                    } while (0);
	                    if ((c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 76 >> 2] | 0) != 0 ? (rF(c[e >> 2] | 0) | 0) == -1 : 0)break;
	                    do if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 96 >> 2] | 0) > 0 : 0) {
	                        if ((c[(c[e >> 2] | 0) + 184 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 188 >> 2] | 0) == 0 : 0)break;
	                        if ((sF(c[e >> 2] | 0) | 0) == -1)break c
	                    } while (0);
	                    wB(c[e >> 2] | 0, c[g >> 2] | 0);
	                    m = c[e >> 2] | 0;
	                    if (!(c[(c[e >> 2] | 0) + 96 >> 2] | 0)) {
	                        n = m + 96 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + -1;
	                        c[(c[e >> 2] | 0) + 108 >> 2] = 0;
	                        c[d >> 2] = 0;
	                        q = c[d >> 2] | 0;
	                        i = b;
	                        return q | 0
	                    }
	                    if (c[m + 112 >> 2] | 0) {
	                        c[o >> 2] = c[(c[e >> 2] | 0) + 112 >> 2];
	                        do {
	                            if ((c[(c[o >> 2] | 0) + 8 >> 2] | 0) == (c[(c[e >> 2] | 0) + 96 >> 2] | 0))c[(c[o >> 2] | 0) + 8 >> 2] = -1;
	                            c[o >> 2] = c[c[o >> 2] >> 2]
	                        } while ((c[o >> 2] | 0) != 0)
	                    }
	                    m = (c[e >> 2] | 0) + 96 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + -1;
	                    c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    q = c[d >> 2] | 0;
	                    i = b;
	                    return q | 0
	                } while (0);
	                c[(c[e >> 2] | 0) + 52 >> 2] = -1;
	                c[d >> 2] = -1;
	                q = c[d >> 2] | 0;
	                i = b;
	                return q | 0
	            }

	            function yD(a, b, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 24 | 0;
	                l = j + 20 | 0;
	                m = j + 16 | 0;
	                n = j + 12 | 0;
	                o = j + 8 | 0;
	                p = j + 4 | 0;
	                q = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                if (c[q >> 2] | 0)c[c[q >> 2] >> 2] = 0;
	                h = c[l >> 2] | 0;
	                if (c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 32 >> 2] & 4) {
	                    AB(h, 1848, 0, 0, 141368, 0, 0);
	                    c[k >> 2] = c[(c[l >> 2] | 0) + 52 >> 2];
	                    r = c[k >> 2] | 0;
	                    i = j;
	                    return r | 0
	                }
	                g = c[l >> 2] | 0;
	                if ((c[(c[(c[h + 108 >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) == 1) {
	                    AB(g, 1841, 0, 0, 141456, 0, 0);
	                    c[k >> 2] = c[(c[l >> 2] | 0) + 52 >> 2];
	                    r = c[k >> 2] | 0;
	                    i = j;
	                    return r | 0
	                }
	                if ((c[(c[(c[g + 108 >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) == 2) {
	                    if ((c[m >> 2] | 0) == 3 ? (aE(c[n >> 2] | 0, c[o >> 2] | 0) | 0) != 0 : 0) {
	                        c[k >> 2] = 0;
	                        r = c[k >> 2] | 0;
	                        i = j;
	                        return r | 0
	                    }
	                    AB(c[l >> 2] | 0, 1843, 0, 0, 141528, 0, 0);
	                    c[k >> 2] = c[(c[l >> 2] | 0) + 52 >> 2];
	                    r = c[k >> 2] | 0;
	                    i = j;
	                    return r | 0
	                }
	                if ((c[n >> 2] | 0) != 0 ? (d[c[n >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                    do if ((c[(c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) == 3) {
	                        if ((c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] | 0) + 76 >> 2] | 0) != 0 : 0)break;
	                        c[k >> 2] = 0;
	                        r = c[k >> 2] | 0;
	                        i = j;
	                        return r | 0
	                    } while (0);
	                    do if (!(c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] | 0)) {
	                        m = c[p >> 2] | 0;
	                        if ((m | 0) == 1) {
	                            c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                            break
	                        } else if ((m | 0) == 2) {
	                            c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                            if (c[q >> 2] | 0)c[c[q >> 2] >> 2] = 1;
	                            g = (c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                            c[g >> 2] = c[g >> 2] | 2;
	                            break
	                        } else if ((m | 0) == 3) {
	                            m = c[n >> 2] | 0;
	                            if ((c[o >> 2] | 0) != -1) {
	                                g = ly(m, c[o >> 2] | 0) | 0;
	                                c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] = g
	                            } else {
	                                g = my(m) | 0;
	                                c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] = g
	                            }
	                            g = (c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                            c[g >> 2] = c[g >> 2] | 2;
	                            break
	                        } else break
	                    } else {
	                        if ((c[o >> 2] | 0) < 0)c[o >> 2] = xy(c[n >> 2] | 0) | 0;
	                        g = c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] | 0;
	                        m = c[n >> 2] | 0;
	                        h = c[o >> 2] | 0;
	                        if (c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 32 >> 2] & 2) {
	                            f = zy(g, m, h) | 0;
	                            c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] = f;
	                            break
	                        } else {
	                            f = Ay(g, m, h) | 0;
	                            c[(c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 20 >> 2] = f;
	                            f = (c[(c[l >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                            c[f >> 2] = c[f >> 2] | 2;
	                            break
	                        }
	                    } while (0);
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = j;
	                    return r | 0
	                }
	                c[k >> 2] = 0;
	                r = c[k >> 2] | 0;
	                i = j;
	                return r | 0
	            }

	            function zD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (!(c[(c[e >> 2] | 0) + 88 >> 2] | 0)) {
	                    if (c[(c[e >> 2] | 0) + 20 >> 2] | 0) {
	                        a = tF(140432, c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        c[(c[e >> 2] | 0) + 88 >> 2] = a
	                    } else {
	                        a = XA(140432) | 0;
	                        c[(c[e >> 2] | 0) + 88 >> 2] = a
	                    }
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 88 >> 2] | 0) {
	                        aB(c[a + 88 >> 2] | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                        cB(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                        break
	                    }
	                    xB(a, 141232, 141264);
	                    c[d >> 2] = -1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } while (0);
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function AD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + 76 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Wj(c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + 76 >> 2] | 0, 359, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function BD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 32 | 0;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                h = b + 16 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                m = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[d >> 2] | 0) + 152 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 84 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 160 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 184 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 72 >> 2] | 0) {
	                    PH(c[(c[d >> 2] | 0) + 72 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 72 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 112 >> 2] | 0) {
	                    c[e >> 2] = c[(c[d >> 2] | 0) + 112 >> 2];
	                    do {
	                        c[f >> 2] = c[c[e >> 2] >> 2];
	                        zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                        c[e >> 2] = c[f >> 2]
	                    } while ((c[e >> 2] | 0) != 0);
	                    c[(c[d >> 2] | 0) + 112 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 124 >> 2] | 0) {
	                    c[g >> 2] = c[(c[d >> 2] | 0) + 124 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0))break;
	                        c[h >> 2] = c[g >> 2];
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        vF(c[h >> 2] | 0)
	                    }
	                    c[(c[d >> 2] | 0) + 124 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 128 >> 2] | 0) {
	                    c[j >> 2] = 0;
	                    while (1) {
	                        if ((c[j >> 2] | 0) >= (c[(c[d >> 2] | 0) + 132 >> 2] | 0))break;
	                        c[k >> 2] = c[(c[(c[d >> 2] | 0) + 128 >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                        zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 4 >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 128 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 128 >> 2] = 0;
	                    c[(c[d >> 2] | 0) + 132 >> 2] = 0;
	                    c[(c[d >> 2] | 0) + 136 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 116 >> 2] | 0) {
	                    uB(c[(c[d >> 2] | 0) + 116 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 116 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 168 >> 2] | 0)vB(c[d >> 2] | 0);
	                a:do if (c[(c[d >> 2] | 0) + 100 >> 2] | 0) {
	                    c[l >> 2] = 0;
	                    while (1) {
	                        if ((c[l >> 2] | 0) >= (c[(c[d >> 2] | 0) + 104 >> 2] | 0))break a;
	                        c[m >> 2] = c[(c[(c[d >> 2] | 0) + 100 >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                        if (!(c[m >> 2] | 0))break a;
	                        wB(c[d >> 2] | 0, c[m >> 2] | 0);
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                } while (0);
	                wF(c[(c[d >> 2] | 0) + 180 >> 2] | 0);
	                zP(c[(c[d >> 2] | 0) + 156 >> 2] | 0);
	                l = xP() | 0;
	                c[(c[d >> 2] | 0) + 156 >> 2] = l;
	                if (!(c[(c[d >> 2] | 0) + 48 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 48 >> 2] = 0;
	                i = b;
	                return
	            }

	            function CD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 68 >> 2] | 0)PH(c[(c[d >> 2] | 0) + 68 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function DD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)PH(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ED(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function FD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 84 >> 2] | 0)zz(c[(c[d >> 2] | 0) + 84 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 96 >> 2] | 0)PH(c[(c[d >> 2] | 0) + 96 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function GD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function HD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 56 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 56 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ID(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function JD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)mB(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0) {
	                    if (c[(c[(c[d >> 2] | 0) + 24 >> 2] | 0) + 16 >> 2] | 0)EQ(c[(c[(c[d >> 2] | 0) + 24 >> 2] | 0) + 16 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0) {
	                    c[e >> 2] = c[(c[d >> 2] | 0) + 28 >> 2];
	                    do {
	                        c[f >> 2] = c[e >> 2];
	                        c[e >> 2] = c[c[e >> 2] >> 2];
	                        if (c[(c[f >> 2] | 0) + 16 >> 2] | 0)EQ(c[(c[f >> 2] | 0) + 16 >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0)
	                    } while ((c[e >> 2] | 0) != 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function KD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function LD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function MD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                do if ((c[c[e >> 2] >> 2] | 0) == 1) {
	                    if ((c[a >> 2] | 0) != 5 ? (c[(c[e >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        c[d >> 2] = 143688;
	                        break
	                    }
	                    c[d >> 2] = 143664
	                } else c[d >> 2] = xF(c[a >> 2] | 0) | 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function ND(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                ce(16, 3069, c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function OD(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)oB(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function PD(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                IC(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, 0, 0);
	                i = h;
	                return
	            }

	            function QD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                do if ((c[c[e >> 2] >> 2] | 0) != 1) {
	                    if (c[a + 48 >> 2] & 64) {
	                        c[d >> 2] = 3;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 48 >> 2] & 128) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 48 >> 2] & 256)) {
	                        c[d >> 2] = -1;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 48 >> 2] & 16777216) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 48 >> 2] & 33554432) {
	                        c[d >> 2] = 2;
	                        break
	                    } else {
	                        c[d >> 2] = 3;
	                        break
	                    }
	                } else {
	                    if ((c[a + 88 >> 2] | 0) != 1 ? (c[(c[e >> 2] | 0) + 88 >> 2] | 0) != 46 : 0)if ((c[(c[e >> 2] | 0) + 88 >> 2] | 0) == 2) {
	                        c[d >> 2] = 2;
	                        break
	                    } else {
	                        c[d >> 2] = 3;
	                        break
	                    }
	                    c[d >> 2] = 1
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function RD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[f >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                    c[h >> 2] = c[b + 96 >> 2];
	                    a:while (1) {
	                        if ((c[h >> 2] | 0) < 0) {
	                            o = 14;
	                            break
	                        }
	                        b:do if (c[(c[(c[(c[f >> 2] | 0) + 100 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 68 >> 2] | 0) {
	                            c[k >> 2] = c[(c[(c[f >> 2] | 0) + 100 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                            c[j >> 2] = 0;
	                            while (1) {
	                                if ((c[j >> 2] | 0) >= (c[(c[k >> 2] | 0) + 68 >> 2] << 1 | 0))break b;
	                                if ((c[g >> 2] | 0) == 0 ? (c[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) == 0 : 0) {
	                                    o = 11;
	                                    break a
	                                }
	                                if ((c[g >> 2] | 0) != 0 ? (qy(c[g >> 2] | 0, c[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) | 0) != 0 : 0) {
	                                    o = 11;
	                                    break a
	                                }
	                                c[j >> 2] = (c[j >> 2] | 0) + 2
	                            }
	                        } while (0);
	                        c[h >> 2] = (c[h >> 2] | 0) + -1
	                    }
	                    if ((o | 0) == 11) {
	                        c[e >> 2] = c[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + ((c[j >> 2] | 0) + 1 << 2) >> 2];
	                        p = c[e >> 2] | 0;
	                        i = d;
	                        return p | 0
	                    } else if ((o | 0) == 14) {
	                        c[e >> 2] = 0;
	                        p = c[e >> 2] | 0;
	                        i = d;
	                        return p | 0
	                    }
	                } else {
	                    o = c[f >> 2] | 0;
	                    if (c[b + 160 >> 2] | 0) {
	                        c[l >> 2] = WL(c[o + 160 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[m >> 2] = AP(c[(c[f >> 2] | 0) + 156 >> 2] | 0, c[l >> 2] | 0, -1) | 0;
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[e >> 2] = c[m >> 2];
	                            p = c[e >> 2] | 0;
	                            i = d;
	                            return p | 0
	                        } else {
	                            c[e >> 2] = 0;
	                            p = c[e >> 2] | 0;
	                            i = d;
	                            return p | 0
	                        }
	                    }
	                    if ((c[(c[o + 108 >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                        c[n >> 2] = cj(c[(c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (c[n >> 2] | 0) {
	                            c[e >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                            p = c[e >> 2] | 0;
	                            i = d;
	                            return p | 0
	                        } else {
	                            c[e >> 2] = 0;
	                            p = c[e >> 2] | 0;
	                            i = d;
	                            return p | 0
	                        }
	                    }
	                    xB(c[f >> 2] | 0, 154192, 154224);
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                return 0
	            }

	            function SD(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 44 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 44 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function TD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    if (!(c[e >> 2] | 0)) {
	                        f = 7;
	                        break
	                    }
	                    if ((c[(c[e >> 2] | 0) + 88 >> 2] | 0) == 46) {
	                        f = 5;
	                        break
	                    }
	                    if (c[(c[e >> 2] | 0) + 48 >> 2] & 16384) {
	                        f = 5;
	                        break
	                    }
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 64 >> 2]
	                }
	                if ((f | 0) == 5) {
	                    c[d >> 2] = c[e >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else if ((f | 0) == 7) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function UD(a, b, d, e, f, g, h, j, k, l) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                m = i;
	                i = i + 112 | 0;
	                n = m;
	                o = m + 56 | 0;
	                p = m + 52 | 0;
	                q = m + 48 | 0;
	                r = m + 44 | 0;
	                s = m + 40 | 0;
	                t = m + 36 | 0;
	                u = m + 32 | 0;
	                v = m + 28 | 0;
	                w = m + 24 | 0;
	                x = m + 20 | 0;
	                y = m + 16 | 0;
	                z = m + 12 | 0;
	                A = m + 8 | 0;
	                B = m + 4 | 0;
	                C = m + 85 | 0;
	                D = m + 60 | 0;
	                c[o >> 2] = a;
	                c[p >> 2] = b;
	                c[q >> 2] = d;
	                c[r >> 2] = e;
	                c[s >> 2] = f;
	                c[t >> 2] = g;
	                c[u >> 2] = h;
	                c[v >> 2] = j;
	                c[w >> 2] = k;
	                c[x >> 2] = l;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                c[B >> 2] = WD(c[o >> 2] | 0, c[q >> 2] | 0) | 0;
	                HC(z, c[o >> 2] | 0, c[q >> 2] | 0) | 0;
	                if ((c[p >> 2] | 0) == 1840)c[A >> 2] = 1007; else c[A >> 2] = c[c[u >> 2] >> 2];
	                c[z >> 2] = By(c[z >> 2] | 0, 142560) | 0;
	                c[z >> 2] = By(c[z >> 2] | 0, 148120) | 0;
	                l = c[z >> 2] | 0;
	                c[z >> 2] = By(l, zB(c[A >> 2] | 0) | 0) | 0;
	                c[z >> 2] = By(c[z >> 2] | 0, 156768) | 0;
	                do if (!(c[v >> 2] | 0)) {
	                    if ((c[A >> 2] | 0) == 1009 | (c[A >> 2] | 0) == 1011 | (c[A >> 2] | 0) == 1010) {
	                        l = c[z >> 2] | 0;
	                        if ((c[B >> 2] | 0) == 2)c[z >> 2] = By(l, 156776) | 0; else c[z >> 2] = By(l, 156816) | 0;
	                        c[n >> 2] = ZH(c[u >> 2] | 0) | 0;
	                        JT(C, 24, 156856, n) | 0;
	                        c[n >> 2] = c[s >> 2];
	                        JT(D, 24, 156856, n) | 0;
	                        do if ((c[A >> 2] | 0) != 1009) {
	                            if ((c[A >> 2] | 0) == 1010) {
	                                c[z >> 2] = By(c[z >> 2] | 0, 156912) | 0;
	                                break
	                            }
	                            if ((c[A >> 2] | 0) == 1011)c[z >> 2] = By(c[z >> 2] | 0, 156968) | 0
	                        } else c[z >> 2] = By(c[z >> 2] | 0, 156864) | 0; while (0);
	                        l = c[o >> 2] | 0;
	                        k = c[p >> 2] | 0;
	                        j = c[q >> 2] | 0;
	                        h = c[z >> 2] | 0;
	                        if ((c[B >> 2] | 0) == 2) {
	                            yF(l, k, j, h, c[r >> 2] | 0, D, C);
	                            break
	                        } else {
	                            PD(l, k, j, h, D, C);
	                            break
	                        }
	                    }
	                    if ((c[A >> 2] | 0) == 1007) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157024) | 0;
	                        h = c[o >> 2] | 0;
	                        j = c[p >> 2] | 0;
	                        k = c[q >> 2] | 0;
	                        l = c[z >> 2] | 0;
	                        g = c[r >> 2] | 0;
	                        PD(h, j, k, l, g, zF(c[o >> 2] | 0, y, c[t >> 2] | 0) | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1006) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157080) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1e3) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157136) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1002) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157200) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1001) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157272) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1003) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157320) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1004) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157360) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if ((c[A >> 2] | 0) == 1005) {
	                        c[z >> 2] = By(c[z >> 2] | 0, 157424) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, c[(c[u >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    g = c[z >> 2] | 0;
	                    if ((c[B >> 2] | 0) == 2) {
	                        c[z >> 2] = By(g, 157496) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[r >> 2] | 0, 0);
	                        break
	                    } else {
	                        c[z >> 2] = By(g, 157536) | 0;
	                        PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, 0, 0);
	                        break
	                    }
	                } else {
	                    c[z >> 2] = By(c[z >> 2] | 0, c[v >> 2] | 0) | 0;
	                    c[z >> 2] = By(c[z >> 2] | 0, 142704) | 0;
	                    PD(c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, c[w >> 2] | 0, c[x >> 2] | 0)
	                } while (0);
	                if (!(c[y >> 2] | 0)) {
	                    E = c[33934] | 0;
	                    F = c[z >> 2] | 0;
	                    zb[E & 511](F);
	                    i = m;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[y >> 2] | 0);
	                c[y >> 2] = 0;
	                E = c[33934] | 0;
	                F = c[z >> 2] | 0;
	                zb[E & 511](F);
	                i = m;
	                return
	            }

	            function VD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        n = 20;
	                        break
	                    }
	                    c[h >> 2] = IH(dI(c[f >> 2] | 0) | 0) | 0;
	                    c[j >> 2] = IH(dI(c[g >> 2] | 0) | 0) | 0;
	                    c[k >> 2] = TD(c[h >> 2] | 0) | 0;
	                    c[l >> 2] = TD(c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) != (c[l >> 2] | 0)) {
	                        n = 4;
	                        break
	                    }
	                    do if ((c[(c[k >> 2] | 0) + 88 >> 2] | 0) != 1) {
	                        if ((c[c[k >> 2] >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 88 >> 2] | 0) == 46 : 0) {
	                            n = 8;
	                            break
	                        }
	                        c[m >> 2] = YH(c[f >> 2] | 0, 1, c[g >> 2] | 0, 1) | 0;
	                        if ((c[m >> 2] | 0) == -2) {
	                            n = 11;
	                            break a
	                        }
	                        if (c[m >> 2] | 0) {
	                            n = 13;
	                            break a
	                        }
	                    } else n = 8; while (0);
	                    if ((n | 0) == 8 ? (n = 0, b = LH(c[f >> 2] | 0) | 0, (qy(b, LH(c[g >> 2] | 0) | 0) | 0) == 0) : 0) {
	                        n = 9;
	                        break
	                    }
	                    c[f >> 2] = KH(c[f >> 2] | 0) | 0;
	                    b = (c[f >> 2] | 0) != 0;
	                    o = KH(c[g >> 2] | 0) | 0;
	                    if (!b) {
	                        n = 17;
	                        break
	                    }
	                    c[g >> 2] = o;
	                    if (!(c[g >> 2] | 0)) {
	                        n = 16;
	                        break
	                    }
	                }
	                do if ((n | 0) == 4)c[e >> 2] = 0; else if ((n | 0) == 9)c[e >> 2] = 0; else if ((n | 0) == 11)c[e >> 2] = -1; else if ((n | 0) == 13)c[e >> 2] = 0; else if ((n | 0) == 16)c[e >> 2] = 0; else if ((n | 0) == 17)if (o) {
	                    c[e >> 2] = 0;
	                    break
	                } else {
	                    c[e >> 2] = 1;
	                    break
	                } else if ((n | 0) == 20)c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function WD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[g >> 2] | 0) {
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[c[f >> 2] >> 2] | 0) == 2 ? (c[(c[f >> 2] | 0) + 108 >> 2] | 0) != 0 : 0) {
	                    c[e >> 2] = c[c[(c[f >> 2] | 0) + 108 >> 2] >> 2];
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = -1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function XD(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                switch (c[c[e >> 2] >> 2] | 0) {
	                    case 15:
	                    {
	                        if (c[(c[e >> 2] | 0) + 60 >> 2] & 1)c[d >> 2] = 1; else f = 10;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 4:
	                    case 5:
	                    {
	                        if (c[(c[e >> 2] | 0) + 48 >> 2] & 8)c[d >> 2] = 1; else f = 10;
	                        break
	                    }
	                    case 14:
	                    {
	                        if (c[(c[e >> 2] | 0) + 48 >> 2] & 2)c[d >> 2] = 1; else f = 10;
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 1
	                }
	                if ((f | 0) == 10)c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function YD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = c[e >> 2] | 0;
	                e = AF(c[f >> 2] | 0) | 0;
	                a = BB(b, e, BF(c[f >> 2] | 0) | 0) | 0;
	                i = d;
	                return a | 0
	            }

	            function ZD(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                b = c[c[e >> 2] >> 2] | 0;
	                a = By(b, MD(c[f >> 2] | 0) | 0) | 0;
	                c[c[e >> 2] >> 2] = a;
	                a = By(c[c[e >> 2] >> 2] | 0, 143656) | 0;
	                c[c[e >> 2] >> 2] = a;
	                a = c[c[e >> 2] >> 2] | 0;
	                b = By(a, YD(g, c[f >> 2] | 0) | 0) | 0;
	                c[c[e >> 2] >> 2] = b;
	                b = By(c[c[e >> 2] >> 2] | 0, 142568) | 0;
	                c[c[e >> 2] >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    h = c[e >> 2] | 0;
	                    j = c[h >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                c[g >> 2] = 0;
	                h = c[e >> 2] | 0;
	                j = c[h >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function _D(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a = c[e >> 2] | 0;
	                if ((a | 0) == 1)c[d >> 2] = 148168; else if ((a | 0) == 2)c[d >> 2] = 148176; else if ((a | 0) == 3)c[d >> 2] = 148184; else c[d >> 2] = 148192;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function $D(a, b, d, e, f, g, h, j, k, l) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0;
	                m = i;
	                i = i + 96 | 0;
	                n = m;
	                o = m + 88 | 0;
	                p = m + 84 | 0;
	                q = m + 80 | 0;
	                r = m + 76 | 0;
	                s = m + 72 | 0;
	                t = m + 68 | 0;
	                u = m + 64 | 0;
	                v = m + 60 | 0;
	                w = m + 56 | 0;
	                x = m + 52 | 0;
	                y = m + 48 | 0;
	                z = m + 44 | 0;
	                A = m + 40 | 0;
	                B = m + 36 | 0;
	                C = m + 32 | 0;
	                D = m + 28 | 0;
	                E = m + 24 | 0;
	                F = m + 20 | 0;
	                G = m + 16 | 0;
	                c[o >> 2] = a;
	                c[p >> 2] = b;
	                c[q >> 2] = d;
	                c[r >> 2] = e;
	                c[s >> 2] = f;
	                c[t >> 2] = g;
	                c[u >> 2] = h;
	                c[v >> 2] = j;
	                c[w >> 2] = k;
	                c[x >> 2] = l;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                c[A >> 2] = 0;
	                if (!(c[o >> 2] | 0)) {
	                    i = m;
	                    return
	                }
	                l = c[o >> 2] | 0;
	                if ((c[c[o >> 2] >> 2] | 0) != 2) {
	                    if ((c[l >> 2] | 0) != 1) {
	                        k = c[33976] | 0;
	                        j = c[33980] | 0;
	                        c[n >> 2] = 140328;
	                        c[n + 4 >> 2] = 2125;
	                        Db[k & 511](j, 140296, n);
	                        i = m;
	                        return
	                    }
	                    c[G >> 2] = c[o >> 2];
	                    j = c[G >> 2] | 0;
	                    if ((c[p >> 2] | 0) != 1) {
	                        k = j + 20 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        c[(c[G >> 2] | 0) + 16 >> 2] = c[q >> 2];
	                        c[z >> 2] = c[(c[G >> 2] | 0) + 8 >> 2]
	                    } else c[z >> 2] = c[j + 12 >> 2];
	                    c[y >> 2] = c[(c[G >> 2] | 0) + 24 >> 2];
	                    c[A >> 2] = c[(c[G >> 2] | 0) + 4 >> 2];
	                    G = c[y >> 2] | 0;
	                    j = c[z >> 2] | 0;
	                    k = c[A >> 2] | 0;
	                    h = c[o >> 2] | 0;
	                    g = c[r >> 2] | 0;
	                    f = c[q >> 2] | 0;
	                    e = c[p >> 2] | 0;
	                    d = c[u >> 2] | 0;
	                    b = c[v >> 2] | 0;
	                    a = c[w >> 2] | 0;
	                    H = c[t >> 2] | 0;
	                    I = c[v >> 2] | 0;
	                    J = c[w >> 2] | 0;
	                    K = c[x >> 2] | 0;
	                    c[n >> 2] = c[u >> 2];
	                    c[n + 4 >> 2] = I;
	                    c[n + 8 >> 2] = J;
	                    c[n + 12 >> 2] = K;
	                    Xd(G, j, k, h, g, 16, f, e, 0, 0, d, b, a, 0, 0, H, n);
	                    i = m;
	                    return
	                }
	                c[B >> 2] = l;
	                c[C >> 2] = 0;
	                c[D >> 2] = 0;
	                l = c[B >> 2] | 0;
	                if ((c[p >> 2] | 0) != 1) {
	                    H = l + 56 | 0;
	                    c[H >> 2] = (c[H >> 2] | 0) + 1;
	                    c[(c[B >> 2] | 0) + 52 >> 2] = c[q >> 2];
	                    c[z >> 2] = c[(c[B >> 2] | 0) + 8 >> 2]
	                } else c[z >> 2] = c[l + 12 >> 2];
	                c[y >> 2] = c[(c[B >> 2] | 0) + 16 >> 2];
	                c[A >> 2] = c[(c[B >> 2] | 0) + 4 >> 2];
	                do if (!(c[s >> 2] | 0)) {
	                    if (((c[r >> 2] | 0) == 0 ? (c[(c[B >> 2] | 0) + 96 >> 2] | 0) >= 0 : 0) ? (c[(c[B >> 2] | 0) + 108 >> 2] | 0) != 0 : 0)c[r >> 2] = c[(c[(c[B >> 2] | 0) + 108 >> 2] | 0) + 4 >> 2];
	                    if (((c[r >> 2] | 0) == 0 ? (c[(c[B >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[(c[B >> 2] | 0) + 40 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                        c[C >> 2] = c[(c[(c[(c[B >> 2] | 0) + 40 >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                        c[s >> 2] = c[(c[(c[(c[B >> 2] | 0) + 40 >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                        c[D >> 2] = c[(c[(c[(c[B >> 2] | 0) + 40 >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2]
	                    }
	                } else {
	                    c[r >> 2] = 0;
	                    l = c[B >> 2] | 0;
	                    if (c[(c[B >> 2] | 0) + 24 >> 2] | 0) {
	                        c[C >> 2] = c[(c[l + 24 >> 2] | 0) + 72 >> 2];
	                        break
	                    }
	                    if ((c[l + 40 >> 2] | 0) != 0 ? (c[(c[(c[B >> 2] | 0) + 40 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)c[C >> 2] = c[(c[(c[(c[B >> 2] | 0) + 40 >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2]
	                } while (0);
	                if ((c[(c[B >> 2] | 0) + 196 >> 2] | 0) != 0 ? (c[C >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0 : 0) {
	                    vb[c[(c[B >> 2] | 0) + 196 >> 2] & 511](c[(c[B >> 2] | 0) + 200 >> 2] | 0, F, E) | 0;
	                    if (!(c[C >> 2] | 0))c[C >> 2] = c[F >> 2];
	                    if (!(c[s >> 2] | 0))c[s >> 2] = c[E >> 2]
	                }
	                if ((c[C >> 2] | 0) == 0 ? (c[(c[B >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[C >> 2] = c[(c[B >> 2] | 0) + 48 >> 2];
	                B = c[y >> 2] | 0;
	                y = c[z >> 2] | 0;
	                z = c[A >> 2] | 0;
	                A = c[o >> 2] | 0;
	                o = c[r >> 2] | 0;
	                r = c[q >> 2] | 0;
	                q = c[p >> 2] | 0;
	                p = c[C >> 2] | 0;
	                C = c[s >> 2] | 0;
	                s = c[u >> 2] | 0;
	                E = c[v >> 2] | 0;
	                F = c[w >> 2] | 0;
	                l = c[D >> 2] | 0;
	                D = c[t >> 2] | 0;
	                t = c[v >> 2] | 0;
	                v = c[w >> 2] | 0;
	                w = c[x >> 2] | 0;
	                c[n >> 2] = c[u >> 2];
	                c[n + 4 >> 2] = t;
	                c[n + 8 >> 2] = v;
	                c[n + 12 >> 2] = w;
	                Xd(B, y, z, A, o, 17, r, q, p, C, s, E, F, 0, l, D, n);
	                i = m;
	                return
	            }

	            function aE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                a:do if ((c[h >> 2] | 0) < 0) {
	                    b:while (1) {
	                        if (!(d[c[g >> 2] >> 0] | 0))break a;
	                        do if ((d[c[g >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) != 13)break b
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                } else {
	                    c:while (1) {
	                        if (!((c[h >> 2] | 0) != 0 ? (d[c[g >> 2] >> 0] | 0 | 0) != 0 : 0))break a;
	                        do if ((d[c[g >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) != 13)break c
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        c[h >> 2] = (c[h >> 2] | 0) + -1
	                    }
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                } while (0);
	                c[f >> 2] = 1;
	                j = c[f >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function bE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[c[f >> 2] >> 2] | 0) {
	                    if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) <= (c[(c[f >> 2] | 0) + 4 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 8 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[c[f >> 2] >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] << 2) | 0, c[c[f >> 2] >> 2] = b, (c[c[f >> 2] >> 2] | 0) == 0) : 0) {
	                        tC(0, 142376, 0);
	                        c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                } else {
	                    b = Cb[c[135744 >> 2] & 511](80) | 0;
	                    c[c[f >> 2] >> 2] = b;
	                    if (c[c[f >> 2] >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 8 >> 2] = 20;
	                        break
	                    }
	                    tC(0, 142344, 0);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                b = c[g >> 2] | 0;
	                g = (c[f >> 2] | 0) + 4 | 0;
	                a = c[g >> 2] | 0;
	                c[g >> 2] = a + 1;
	                c[(c[c[f >> 2] >> 2] | 0) + (a << 2) >> 2] = b;
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function cE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = dE(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = CF(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function dE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[h >> 2] | 0)) {
	                        k = 9;
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0) != 0 : 0) {
	                        k = 7;
	                        break
	                    }
	                    c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2]
	                }
	                if ((k | 0) == 7) {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else if ((k | 0) == 9) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function eE(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if ((c[j >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[o >> 2] = fE(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                if (c[n >> 2] | 0)c[c[n >> 2] >> 2] = c[o >> 2];
	                c[h >> 2] = DF(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0, c[m >> 2] | 0) | 0;
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function fE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = _i(c[f >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0))c[g >> 2] = my(142672) | 0;
	                c[h >> 2] = AP(c[(c[e >> 2] | 0) + 80 >> 2] | 0, c[g >> 2] | 0, -1) | 0;
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                i = d;
	                return c[h >> 2] | 0
	            }

	            function gE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (qy(c[g >> 2] | 0, 163536) | 0) {
	                    if (!(c[c[h >> 2] >> 2] & c[j >> 2])) {
	                        d = c[h >> 2] | 0;
	                        c[d >> 2] = c[d >> 2] | c[j >> 2]
	                    }
	                } else if (!(qy(c[g >> 2] | 0, 163552) | 0)) {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function hE(a, b, d, e, f, g, h, j, k, l) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                m = i;
	                i = i + 48 | 0;
	                n = m + 44 | 0;
	                o = m + 40 | 0;
	                p = m + 32 | 0;
	                q = m + 28 | 0;
	                r = m + 24 | 0;
	                s = m + 20 | 0;
	                t = m + 16 | 0;
	                u = m + 12 | 0;
	                v = m + 8 | 0;
	                w = m + 4 | 0;
	                x = m;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[m + 36 >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = l;
	                c[w >> 2] = 0;
	                HC(w, c[n >> 2] | 0, c[p >> 2] | 0) | 0;
	                do if (!(c[t >> 2] | 0)) {
	                    l = (c[(c[p >> 2] | 0) + 4 >> 2] | 0) == 2;
	                    k = c[w >> 2] | 0;
	                    do if (c[q >> 2] | 0) {
	                        if (l)c[w >> 2] = By(k, 154256) | 0; else c[w >> 2] = By(k, 154288) | 0;
	                        j = (XD(c[q >> 2] | 0) | 0) != 0;
	                        h = c[w >> 2] | 0;
	                        if (j)c[w >> 2] = By(h, 154352) | 0; else c[w >> 2] = By(h, 154336) | 0;
	                        do if (!(c[(c[q >> 2] | 0) + 48 >> 2] & 256)) {
	                            if (c[(c[q >> 2] | 0) + 48 >> 2] & 64) {
	                                c[w >> 2] = By(c[w >> 2] | 0, 147936) | 0;
	                                break
	                            }
	                            if (c[(c[q >> 2] | 0) + 48 >> 2] & 128)c[w >> 2] = By(c[w >> 2] | 0, 147952) | 0
	                        } else c[w >> 2] = By(c[w >> 2] | 0, 147920) | 0; while (0);
	                        if (XD(c[q >> 2] | 0) | 0) {
	                            c[x >> 2] = 0;
	                            c[w >> 2] = By(c[w >> 2] | 0, 143656) | 0;
	                            h = c[w >> 2] | 0;
	                            if (c[(c[q >> 2] | 0) + 88 >> 2] | 0) {
	                                c[w >> 2] = By(h, 154360) | 0;
	                                c[w >> 2] = By(c[w >> 2] | 0, c[(c[q >> 2] | 0) + 8 >> 2] | 0) | 0
	                            } else c[w >> 2] = By(h, BB(x, c[(c[q >> 2] | 0) + 112 >> 2] | 0, c[(c[q >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                            c[w >> 2] = By(c[w >> 2] | 0, 161528) | 0;
	                            if (c[x >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                                c[x >> 2] = 0
	                            }
	                        }
	                    } else if (l) {
	                        c[w >> 2] = By(k, 161536) | 0;
	                        break
	                    } else {
	                        c[w >> 2] = By(k, 161568) | 0;
	                        break
	                    } while (0);
	                    k = c[w >> 2] | 0;
	                    if (c[r >> 2] | 0) {
	                        c[w >> 2] = By(k, 161608) | 0;
	                        c[w >> 2] = By(c[w >> 2] | 0, c[r >> 2] | 0) | 0;
	                        c[w >> 2] = By(c[w >> 2] | 0, 161624) | 0
	                    } else c[w >> 2] = By(k, 140352) | 0;
	                    k = c[n >> 2] | 0;
	                    l = c[p >> 2] | 0;
	                    h = c[o >> 2] | 0;
	                    j = c[w >> 2] | 0;
	                    if ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        PC(k, l, h, j, c[s >> 2] | 0, 0);
	                        break
	                    } else {
	                        PC(k, l, h, j, 0, 0);
	                        break
	                    }
	                } else {
	                    c[w >> 2] = By(c[w >> 2] | 0, c[t >> 2] | 0) | 0;
	                    c[w >> 2] = By(c[w >> 2] | 0, 142704) | 0;
	                    EF(c[n >> 2] | 0, c[p >> 2] | 0, c[o >> 2] | 0, 0, 0, 0, c[w >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0, 0, 0, 0)
	                } while (0);
	                if (!(c[w >> 2] | 0)) {
	                    i = m;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                c[w >> 2] = 0;
	                i = m;
	                return
	            }

	            function iE(a, b, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                l = i;
	                i = i + 64 | 0;
	                m = l + 48 | 0;
	                n = l + 44 | 0;
	                o = l + 40 | 0;
	                p = l + 36 | 0;
	                q = l + 32 | 0;
	                r = l + 28 | 0;
	                s = l + 24 | 0;
	                t = l + 20 | 0;
	                u = l + 16 | 0;
	                v = l + 12 | 0;
	                w = l + 8 | 0;
	                x = l + 4 | 0;
	                y = l;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = 0;
	                if ((c[o >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    c[m >> 2] = -1;
	                    z = c[m >> 2] | 0;
	                    i = l;
	                    return z | 0
	                }
	                if (!(d[c[n >> 2] >> 0] | 0)) {
	                    c[m >> 2] = 0;
	                    z = c[m >> 2] | 0;
	                    i = l;
	                    return z | 0
	                }
	                a:do if (qy(c[n >> 2] | 0, 165432) | 0) {
	                    if ((c[p >> 2] | 0) != -1) {
	                        k = c[o >> 2] | 0;
	                        c[k >> 2] = c[k >> 2] | c[p >> 2];
	                        break
	                    }
	                    if ((c[q >> 2] | 0) != -1) {
	                        k = c[o >> 2] | 0;
	                        c[k >> 2] = c[k >> 2] | c[q >> 2]
	                    }
	                    if ((c[r >> 2] | 0) != -1) {
	                        k = c[o >> 2] | 0;
	                        c[k >> 2] = c[k >> 2] | c[r >> 2]
	                    }
	                    if ((c[s >> 2] | 0) != -1) {
	                        k = c[o >> 2] | 0;
	                        c[k >> 2] = c[k >> 2] | c[s >> 2]
	                    }
	                    if ((c[t >> 2] | 0) != -1) {
	                        k = c[o >> 2] | 0;
	                        c[k >> 2] = c[k >> 2] | c[t >> 2]
	                    }
	                    if ((c[u >> 2] | 0) != -1) {
	                        k = c[o >> 2] | 0;
	                        c[k >> 2] = c[k >> 2] | c[u >> 2]
	                    }
	                } else {
	                    c[x >> 2] = c[n >> 2];
	                    while (1) {
	                        do if ((d[c[x >> 2] >> 0] | 0 | 0) == 32)A = 1; else {
	                            if (9 <= (d[c[x >> 2] >> 0] | 0 | 0) ? (d[c[x >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                A = 1;
	                                break
	                            }
	                            A = (d[c[x >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = c[x >> 2] | 0;
	                        if (A) {
	                            c[x >> 2] = k + 1;
	                            continue
	                        }
	                        c[w >> 2] = k;
	                        while (1) {
	                            if (d[c[w >> 2] >> 0] | 0) {
	                                do if ((d[c[w >> 2] >> 0] | 0 | 0) == 32)B = 1; else {
	                                    if (9 <= (d[c[w >> 2] >> 0] | 0 | 0) ? (d[c[w >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        B = 1;
	                                        break
	                                    }
	                                    B = (d[c[w >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                C = B ^ 1
	                            } else C = 0;
	                            D = c[w >> 2] | 0;
	                            if (!C)break;
	                            c[w >> 2] = D + 1
	                        }
	                        if ((D | 0) == (c[x >> 2] | 0))break a;
	                        c[y >> 2] = ly(c[x >> 2] | 0, (c[w >> 2] | 0) - (c[x >> 2] | 0) | 0) | 0;
	                        do if (qy(c[y >> 2] | 0, 165440) | 0) {
	                            if ((c[q >> 2] | 0) == -1) {
	                                c[v >> 2] = 1;
	                                break
	                            }
	                            if (!(c[c[o >> 2] >> 2] & c[q >> 2])) {
	                                k = c[o >> 2] | 0;
	                                c[k >> 2] = c[k >> 2] | c[q >> 2]
	                            }
	                        } else {
	                            if (qy(c[y >> 2] | 0, 165456) | 0) {
	                                if ((c[r >> 2] | 0) == -1) {
	                                    c[v >> 2] = 1;
	                                    break
	                                }
	                                if (c[c[o >> 2] >> 2] & c[r >> 2])break;
	                                k = c[o >> 2] | 0;
	                                c[k >> 2] = c[k >> 2] | c[r >> 2];
	                                break
	                            }
	                            if (qy(c[y >> 2] | 0, 165472) | 0) {
	                                if ((c[s >> 2] | 0) == -1) {
	                                    c[v >> 2] = 1;
	                                    break
	                                }
	                                if (c[c[o >> 2] >> 2] & c[s >> 2])break;
	                                k = c[o >> 2] | 0;
	                                c[k >> 2] = c[k >> 2] | c[s >> 2];
	                                break
	                            }
	                            if (qy(c[y >> 2] | 0, 165488) | 0) {
	                                if ((c[t >> 2] | 0) == -1) {
	                                    c[v >> 2] = 1;
	                                    break
	                                }
	                                if (c[c[o >> 2] >> 2] & c[t >> 2])break;
	                                k = c[o >> 2] | 0;
	                                c[k >> 2] = c[k >> 2] | c[t >> 2];
	                                break
	                            }
	                            if (!(qy(c[y >> 2] | 0, 165496) | 0)) {
	                                c[v >> 2] = 1;
	                                break
	                            }
	                            if ((c[u >> 2] | 0) == -1) {
	                                c[v >> 2] = 1;
	                                break
	                            }
	                            if (!(c[c[o >> 2] >> 2] & c[u >> 2])) {
	                                k = c[o >> 2] | 0;
	                                c[k >> 2] = c[k >> 2] | c[u >> 2]
	                            }
	                        } while (0);
	                        if (c[y >> 2] | 0)zb[c[135736 >> 2] & 511](c[y >> 2] | 0);
	                        c[x >> 2] = c[w >> 2];
	                        if (c[v >> 2] | 0)break a;
	                        if (!(d[c[x >> 2] >> 0] | 0))break
	                    }
	                } while (0);
	                c[m >> 2] = c[v >> 2];
	                z = c[m >> 2] | 0;
	                i = l;
	                return z | 0
	            }

	            function jE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (c[j >> 2] | 0)c[k >> 2] = FF(c[g >> 2] | 0, c[h >> 2] | 0) | 0; else c[k >> 2] = 0;
	                c[m >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0)p = 12; else p = 10;
	                    if (((p | 0) == 10 ? (p = 0, (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0) : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)p = 12;
	                    if ((p | 0) == 12) {
	                        p = 0;
	                        GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                    }
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[h >> 2] | 0, 161384) | 0;
	                c[l >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 168752) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[m >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0))break;
	                            if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 168760) | 0) == 0 : 0)p = 26; else p = 24;
	                            if (((p | 0) == 24 ? (p = 0, (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0) : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)p = 26;
	                            if ((p | 0) == 26) {
	                                p = 0;
	                                GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                            }
	                            c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                        }
	                        j = c[g >> 2] | 0;
	                        d = c[l >> 2] | 0;
	                        HF(j, 0, d, 168760, IH(29) | 0, 0) | 0;
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 168768) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[m >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0))break;
	                            d = c[m >> 2] | 0;
	                            do if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                                if (!(qy(c[d + 8 >> 2] | 0, 168760) | 0))GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                            } else {
	                                if (!(qy(c[(c[d + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)) {
	                                    if (!(qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 168784) | 0))break;
	                                    if (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 168792) | 0)break
	                                }
	                                GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                            } while (0);
	                            c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                        }
	                        c[m >> 2] = IF(c[l >> 2] | 0, 168792, 168784) | 0;
	                        if (c[m >> 2] | 0) {
	                            d = c[g >> 2] | 0;
	                            j = c[m >> 2] | 0;
	                            eE(d, 0, j, IH(17) | 0, 0) | 0
	                        }
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    if (!(c[n >> 2] | 0))uE(c[g >> 2] | 0, 3033, 0, c[h >> 2] | 0, c[l >> 2] | 0, 0, 168832);
	                    c[n >> 2] = 1;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                c[f >> 2] = c[k >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function kE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[o >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    d = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (((qy(c[d + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 162304) | 0) == 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 155456) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[d + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                o = c[g >> 2] | 0;
	                d = c[j >> 2] | 0;
	                b = (HF(o, 0, d, 162304, IH(29) | 0, l) | 0) != 0;
	                d = c[g >> 2] | 0;
	                o = c[j >> 2] | 0;
	                a = IH(29) | 0;
	                if (b) {
	                    hE(d, 3037, 0, o, a, 0, c[l >> 2] | 0, 0, 0, 0);
	                    c[f >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if (HF(d, 0, o, 155456, a, m) | 0) {
	                    a = c[g >> 2] | 0;
	                    o = c[j >> 2] | 0;
	                    d = IH(29) | 0;
	                    hE(a, 3037, 0, o, d, 0, c[m >> 2] | 0, 0, 0, 0);
	                    c[f >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                if (c[k >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[k >> 2] | 0, 0, 161392);
	                c[n >> 2] = c[(c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 12 >> 2];
	                k = c[n >> 2] | 0;
	                if (c[l >> 2] | 0) {
	                    if (qy(k, c[l >> 2] | 0) | 0) {
	                        GE(c[g >> 2] | 0, 3064, 0, c[j >> 2] | 0, 168408, c[n >> 2] | 0);
	                        c[f >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                } else if (!k) {
	                    GE(c[g >> 2] | 0, 3065, 0, c[j >> 2] | 0, 168512, 0);
	                    c[f >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if (c[m >> 2] | 0)c[m >> 2] = JF(c[(c[g >> 2] | 0) + 80 >> 2] | 0, c[m >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[p >> 2] = FB(c[g >> 2] | 0, 1, c[m >> 2] | 0, 0, 0, 0, c[j >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0, q) | 0;
	                if (c[p >> 2] | 0) {
	                    c[f >> 2] = c[p >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if ((c[q >> 2] | 0) == 0 & (c[m >> 2] | 0) != 0)NC(c[g >> 2] | 0, 3084, c[j >> 2] | 0, 0, 168608, c[m >> 2] | 0, 0, 0);
	                if (((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[q >> 2] | 0) + 32 >> 2] | 0) == 0 : 0)c[p >> 2] = KF(c[g >> 2] | 0, c[h >> 2] | 0, c[q >> 2] | 0) | 0;
	                c[f >> 2] = c[p >> 2];
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function lE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = LF(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 2) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function mE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = LF(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 3) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function nE(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 52 | 0;
	                h = f + 48 | 0;
	                j = f + 44 | 0;
	                k = f + 40 | 0;
	                l = f + 36 | 0;
	                m = f + 32 | 0;
	                n = f + 28 | 0;
	                o = f + 24 | 0;
	                p = f + 20 | 0;
	                q = f + 16 | 0;
	                r = f + 12 | 0;
	                s = f + 8 | 0;
	                t = f + 4 | 0;
	                u = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                c[n >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                if (c[l >> 2] | 0) {
	                    c[q >> 2] = dE(c[k >> 2] | 0, 161352) | 0;
	                    e = c[h >> 2] | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        MF(e, 3036, 0, c[k >> 2] | 0, 161352, 0);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    d = c[q >> 2] | 0;
	                    if (eE(e, 0, d, IH(22) | 0, p) | 0) {
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                }
	                d = c[h >> 2] | 0;
	                e = c[j >> 2] | 0;
	                do if (!(c[l >> 2] | 0)) {
	                    c[m >> 2] = WE(d, e, 5, 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[k >> 2] | 0, 0) | 0;
	                    if (c[m >> 2] | 0) {
	                        c[p >> 2] = c[(c[m >> 2] | 0) + 8 >> 2];
	                        c[(c[m >> 2] | 0) + 36 >> 2] = c[k >> 2];
	                        c[c[m >> 2] >> 2] = 5;
	                        break
	                    }
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                } else {
	                    c[m >> 2] = WE(d, e, 5, c[p >> 2] | 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                    if (c[m >> 2] | 0) {
	                        c[(c[m >> 2] | 0) + 36 >> 2] = c[k >> 2];
	                        c[c[m >> 2] >> 2] = 5;
	                        b = (c[m >> 2] | 0) + 48 | 0;
	                        c[b >> 2] = c[b >> 2] | 8;
	                        break
	                    }
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                } while (0);
	                c[(c[m >> 2] | 0) + 112 >> 2] = c[(c[h >> 2] | 0) + 112 >> 2];
	                c[q >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[q >> 2] | 0))break;
	                    p = c[q >> 2] | 0;
	                    do if (!(c[(c[q >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (qy(c[p + 8 >> 2] | 0, 161384) | 0) {
	                            cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                            break
	                        }
	                        if (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 167064) | 0) {
	                            if (!(NF(c[h >> 2] | 0, 0, c[q >> 2] | 0) | 0))break;
	                            e = (c[m >> 2] | 0) + 48 | 0;
	                            c[e >> 2] = c[e >> 2] | 1;
	                            break
	                        }
	                        if (!(c[l >> 2] | 0)) {
	                            GF(c[h >> 2] | 0, 3035, 0, c[q >> 2] | 0);
	                            break
	                        }
	                        if (!(qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161352) | 0)) {
	                            if (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 164512) | 0) {
	                                if (!(NF(c[h >> 2] | 0, 0, c[q >> 2] | 0) | 0))break;
	                                e = (c[m >> 2] | 0) + 48 | 0;
	                                c[e >> 2] = c[e >> 2] | 1048576;
	                                break
	                            }
	                            if (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 164504) | 0) {
	                                c[r >> 2] = fE(c[h >> 2] | 0, c[q >> 2] | 0) | 0;
	                                if (iE(c[r >> 2] | 0, (c[m >> 2] | 0) + 48 | 0, -1, 512, 1024, -1, -1, -1) | 0) {
	                                    hE(c[h >> 2] | 0, 3037, 0, c[q >> 2] | 0, 0, 164528, c[r >> 2] | 0, 0, 0, 0);
	                                    break
	                                } else {
	                                    c[s >> 2] = 1;
	                                    break
	                                }
	                            }
	                            e = (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 164480) | 0) != 0;
	                            d = c[h >> 2] | 0;
	                            b = c[q >> 2] | 0;
	                            if (!e) {
	                                GF(d, 3035, 0, b);
	                                break
	                            }
	                            c[r >> 2] = fE(d, b) | 0;
	                            if (iE(c[r >> 2] | 0, (c[m >> 2] | 0) + 48 | 0, -1, 262144, 524288, -1, -1, -1) | 0) {
	                                hE(c[h >> 2] | 0, 3037, 0, c[q >> 2] | 0, 0, 167072, c[r >> 2] | 0, 0, 0, 0);
	                                break
	                            } else {
	                                c[t >> 2] = 1;
	                                break
	                            }
	                        }
	                    } else if (qy(c[(c[p + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[q >> 2] | 0); while (0);
	                    c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                }
	                if (!(c[t >> 2] | 0)) {
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 128) {
	                        t = (c[m >> 2] | 0) + 48 | 0;
	                        c[t >> 2] = c[t >> 2] | 524288
	                    }
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 64) {
	                        t = (c[m >> 2] | 0) + 48 | 0;
	                        c[t >> 2] = c[t >> 2] | 262144
	                    }
	                }
	                if (!(c[s >> 2] | 0)) {
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 8) {
	                        s = (c[m >> 2] | 0) + 48 | 0;
	                        c[s >> 2] = c[s >> 2] | 1024
	                    }
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 4) {
	                        s = (c[m >> 2] | 0) + 48 | 0;
	                        c[s >> 2] = c[s >> 2] | 512
	                    }
	                }
	                c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    s = jE(c[h >> 2] | 0, c[o >> 2] | 0, 1) | 0;
	                    c[(c[m >> 2] | 0) + 24 >> 2] = s;
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                c[(c[h >> 2] | 0) + 84 >> 2] = c[m >> 2];
	                if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 167120) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    if (c[(c[m >> 2] | 0) + 48 >> 2] & 1) {
	                        s = (c[m >> 2] | 0) + 48 | 0;
	                        c[s >> 2] = c[s >> 2] ^ 1
	                    }
	                    OF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0, u) | 0;
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                } else w = 63;
	                do if ((w | 0) == 63) {
	                    if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 167136) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[(c[m >> 2] | 0) + 52 >> 2] = 1;
	                        PF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0, u) | 0;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    s = IH(45) | 0;
	                    c[(c[m >> 2] | 0) + 64 >> 2] = s;
	                    s = (c[m >> 2] | 0) + 48 | 0;
	                    c[s >> 2] = c[s >> 2] | 4;
	                    if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 161648) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        s = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0, 8, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = s;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                    } else w = 73;
	                    do if ((w | 0) == 73) {
	                        if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 161656) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            s = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0, 7, 1) | 0;
	                            c[(c[m >> 2] | 0) + 28 >> 2] = s;
	                            c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 161664) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            s = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0, 6, 1) | 0;
	                            c[(c[m >> 2] | 0) + 28 >> 2] = s;
	                            c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            s = RF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0) | 0;
	                            c[(c[m >> 2] | 0) + 28 >> 2] = s;
	                            c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                        }
	                    } while (0);
	                    if ((SF(c[h >> 2] | 0, c[j >> 2] | 0, o, (c[m >> 2] | 0) + 116 | 0, 12, 0) | 0) == -1) {
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 163328) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        s = TF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 84 >> 2] = s;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if (c[o >> 2] | 0)uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[o >> 2] | 0, 0, 167152);
	                if ((c[l >> 2] | 0) != 0 ? !((c[u >> 2] | 0) != 0 ? 1 : (c[(c[h >> 2] | 0) + 100 >> 2] | 0) == 0) : 0)GE(c[h >> 2] | 0, 3081, 0, c[k >> 2] | 0, 167288, 0);
	                c[(c[h >> 2] | 0) + 84 >> 2] = c[n >> 2];
	                c[g >> 2] = c[m >> 2];
	                v = c[g >> 2] | 0;
	                i = f;
	                return v | 0
	            }

	            function oE(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 44 | 0;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 8 | 0;
	                r = f + 4 | 0;
	                s = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[r >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    t = c[g >> 2] | 0;
	                    i = f;
	                    return t | 0
	                }
	                if (c[l >> 2] | 0) {
	                    c[q >> 2] = dE(c[k >> 2] | 0, 161352) | 0;
	                    e = c[h >> 2] | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        MF(e, 3036, 0, c[k >> 2] | 0, 161352, 0);
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    d = c[q >> 2] | 0;
	                    if (eE(e, 0, d, IH(22) | 0, p) | 0) {
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 96 >> 2] | 0) {
	                        if (c[(c[h >> 2] | 0) + 100 >> 2] | 0) {
	                            GE(c[h >> 2] | 0, 3081, 0, c[k >> 2] | 0, 165552, 0);
	                            c[g >> 2] = 0;
	                            t = c[g >> 2] | 0;
	                            i = f;
	                            return t | 0
	                        }
	                        c[s >> 2] = QH(c[p >> 2] | 0, c[38526] | 0) | 0;
	                        if (c[s >> 2] | 0) {
	                            c[g >> 2] = c[s >> 2];
	                            t = c[g >> 2] | 0;
	                            i = f;
	                            return t | 0
	                        }
	                    }
	                }
	                s = c[h >> 2] | 0;
	                d = c[j >> 2] | 0;
	                a:do if (c[l >> 2] | 0) {
	                    c[m >> 2] = WE(s, d, 4, c[p >> 2] | 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    c[c[m >> 2] >> 2] = 4;
	                    c[(c[m >> 2] | 0) + 52 >> 2] = 4;
	                    e = (c[m >> 2] | 0) + 48 | 0;
	                    c[e >> 2] = c[e >> 2] | 8;
	                    c[q >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[q >> 2] | 0))break;
	                        e = c[q >> 2] | 0;
	                        if (!(c[(c[q >> 2] | 0) + 36 >> 2] | 0)) {
	                            if (((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161352) | 0) == 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 164504) | 0) == 0 : 0)GF(c[h >> 2] | 0, 3035, 0, c[q >> 2] | 0)
	                        } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[q >> 2] | 0);
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                    }
	                    c[q >> 2] = dE(c[k >> 2] | 0, 164504) | 0;
	                    if (c[q >> 2] | 0) {
	                        c[p >> 2] = RC(c[h >> 2] | 0, c[k >> 2] | 0, 164504) | 0;
	                        if (!(iE(c[p >> 2] | 0, (c[m >> 2] | 0) + 48 | 0, -1, -1, 1024, -1, 2048, 4096) | 0))break;
	                        hE(c[h >> 2] | 0, 3037, c[m >> 2] | 0, c[q >> 2] | 0, 0, 165608, c[p >> 2] | 0, 0, 0, 0);
	                        break
	                    }
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 8) {
	                        e = (c[m >> 2] | 0) + 48 | 0;
	                        c[e >> 2] = c[e >> 2] | 1024
	                    }
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 16) {
	                        e = (c[m >> 2] | 0) + 48 | 0;
	                        c[e >> 2] = c[e >> 2] | 2048
	                    }
	                    if (c[(c[j >> 2] | 0) + 24 >> 2] & 32) {
	                        e = (c[m >> 2] | 0) + 48 | 0;
	                        c[e >> 2] = c[e >> 2] | 4096
	                    }
	                } else {
	                    c[m >> 2] = WE(s, d, 4, 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[k >> 2] | 0, 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    c[c[m >> 2] >> 2] = 4;
	                    c[(c[m >> 2] | 0) + 52 >> 2] = 4;
	                    c[q >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[q >> 2] | 0))break a;
	                        e = c[q >> 2] | 0;
	                        if (!(c[(c[q >> 2] | 0) + 36 >> 2] | 0)) {
	                            if (!(qy(c[e + 8 >> 2] | 0, 161384) | 0))GF(c[h >> 2] | 0, 3035, 0, c[q >> 2] | 0)
	                        } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[q >> 2] | 0);
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                c[(c[m >> 2] | 0) + 112 >> 2] = c[(c[h >> 2] | 0) + 112 >> 2];
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                c[n >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                c[(c[h >> 2] | 0) + 84 >> 2] = c[m >> 2];
	                c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    q = jE(c[h >> 2] | 0, c[o >> 2] | 0, 1) | 0;
	                    c[(c[m >> 2] | 0) + 24 >> 2] = q;
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                do if (c[o >> 2] | 0) {
	                    if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 165456) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        UF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0, 4) | 0;
	                        c[r >> 2] = 1;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 165488) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        VF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0) | 0;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 165496) | 0) != 0 : 0) ? (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        WF(c[h >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0) | 0;
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                    }
	                } else uE(c[h >> 2] | 0, 3034, 0, c[k >> 2] | 0, c[o >> 2] | 0, 0, 165656); while (0);
	                if (c[o >> 2] | 0)uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[o >> 2] | 0, 0, 165656);
	                if ((c[l >> 2] | 0) != 0 ? !((c[r >> 2] | 0) != 0 ? 1 : (c[(c[h >> 2] | 0) + 100 >> 2] | 0) == 0) : 0)GE(c[h >> 2] | 0, 3081, 0, c[k >> 2] | 0, 165704, 0);
	                c[(c[h >> 2] | 0) + 84 >> 2] = c[n >> 2];
	                c[g >> 2] = c[m >> 2];
	                t = c[g >> 2] | 0;
	                i = f;
	                return t | 0
	            }

	            function pE(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0;
	                g = i;
	                i = i + 112 | 0;
	                h = g + 96 | 0;
	                j = g + 92 | 0;
	                k = g + 88 | 0;
	                l = g + 84 | 0;
	                m = g + 80 | 0;
	                n = g + 76 | 0;
	                o = g + 72 | 0;
	                p = g + 68 | 0;
	                q = g + 64 | 0;
	                r = g + 60 | 0;
	                s = g + 56 | 0;
	                t = g + 52 | 0;
	                u = g + 48 | 0;
	                v = g + 44 | 0;
	                w = g + 40 | 0;
	                x = g + 36 | 0;
	                y = g + 32 | 0;
	                z = g + 28 | 0;
	                A = g + 24 | 0;
	                B = g + 20 | 0;
	                C = g + 16 | 0;
	                D = g + 12 | 0;
	                E = g + 8 | 0;
	                F = g + 4 | 0;
	                G = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 0;
	                c[t >> 2] = dE(c[l >> 2] | 0, 161352) | 0;
	                c[s >> 2] = dE(c[l >> 2] | 0, 160064) | 0;
	                if ((c[n >> 2] | 0) != 0 | (c[s >> 2] | 0) == 0) {
	                    if (!(c[t >> 2] | 0)) {
	                        MF(c[j >> 2] | 0, 3036, 0, c[l >> 2] | 0, 161352, 0);
	                        c[h >> 2] = 0;
	                        H = c[h >> 2] | 0;
	                        i = g;
	                        return H | 0
	                    }
	                } else c[w >> 2] = 1;
	                cE(c[j >> 2] | 0, c[l >> 2] | 0, 161384) | 0;
	                c[r >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                if ((((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    c[q >> 2] = jE(c[j >> 2] | 0, c[r >> 2] | 0, 1) | 0;
	                    c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                }
	                if (!(c[n >> 2] | 0)) {
	                    c[u >> 2] = XF(c[j >> 2] | 0, c[l >> 2] | 0, 0, -1, 1, 161744) | 0;
	                    c[v >> 2] = YF(c[j >> 2] | 0, c[l >> 2] | 0, 0, 1073741824, 1, 161768) | 0;
	                    ZF(c[j >> 2] | 0, 0, c[l >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0) | 0;
	                    c[p >> 2] = XE(c[j >> 2] | 0, c[l >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0) | 0;
	                    if (c[p >> 2] | 0)if (c[w >> 2] | 0) {
	                        c[y >> 2] = 0;
	                        c[z >> 2] = 0;
	                        c[A >> 2] = 0;
	                        if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 1;
	                        _F(c[j >> 2] | 0, c[k >> 2] | 0, 0, c[s >> 2] | 0, y, z) | 0;
	                        $F(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[s >> 2] | 0, c[y >> 2] | 0) | 0;
	                        if (c[t >> 2] | 0)aG(c[j >> 2] | 0, 3039, 0, c[t >> 2] | 0, 160064, 161352);
	                        c[s >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[s >> 2] | 0))break;
	                            m = c[s >> 2] | 0;
	                            if (c[(c[s >> 2] | 0) + 36 >> 2] | 0) {
	                                if (qy(c[(c[m + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[j >> 2] | 0, 3035, 0, c[s >> 2] | 0);
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2];
	                                continue
	                            }
	                            if (((((qy(c[m + 8 >> 2] | 0, 160064) | 0) == 0 ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161352) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161808) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161824) | 0) == 0 : 0) {
	                                I = 30;
	                                break
	                            }
	                            c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                        }
	                        if ((I | 0) == 30)bG(c[j >> 2] | 0, 3040, 0, 0, c[s >> 2] | 0, 164392);
	                        if (c[r >> 2] | 0)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[r >> 2] | 0, 0, 161392);
	                        if (!((c[u >> 2] | 0) == 0 & (c[v >> 2] | 0) == 0) ? (c[A >> 2] = cG(c[j >> 2] | 0, 14, c[z >> 2] | 0, c[y >> 2] | 0) | 0, (c[A >> 2] | 0) != 0) : 0) {
	                            c[(c[p >> 2] | 0) + 12 >> 2] = c[A >> 2];
	                            c[(c[p >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                            dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[p >> 2] | 0) | 0;
	                            c[h >> 2] = c[p >> 2];
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        }
	                    } else I = 39
	                } else I = 39;
	                if ((I | 0) == 39 ? (c[B >> 2] = 0, c[F >> 2] = 0, c[G >> 2] = 0, A = c[j >> 2] | 0, y = c[t >> 2] | 0, (eE(A, 0, y, IH(22) | 0, D) | 0) == 0) : 0) {
	                    do if (!(c[n >> 2] | 0)) {
	                        c[s >> 2] = dE(c[l >> 2] | 0, 163528) | 0;
	                        if (!(c[s >> 2] | 0)) {
	                            if (!(c[(c[k >> 2] | 0) + 24 >> 2] & 1))break;
	                            c[B >> 2] = c[(c[j >> 2] | 0) + 112 >> 2];
	                            break
	                        }
	                        c[E >> 2] = fE(c[j >> 2] | 0, c[s >> 2] | 0) | 0;
	                        if (qy(c[E >> 2] | 0, 163536) | 0) {
	                            c[B >> 2] = c[(c[j >> 2] | 0) + 112 >> 2];
	                            break
	                        }
	                        if (!(qy(c[E >> 2] | 0, 163552) | 0))hE(c[j >> 2] | 0, 3037, 0, c[s >> 2] | 0, 0, 163568, c[E >> 2] | 0, 0, 0, 0)
	                    } else c[B >> 2] = c[(c[j >> 2] | 0) + 112 >> 2]; while (0);
	                    c[o >> 2] = eG(c[j >> 2] | 0, c[D >> 2] | 0, c[B >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (c[o >> 2] | 0) {
	                        c[s >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[s >> 2] | 0))break;
	                            B = c[s >> 2] | 0;
	                            do if (!(c[(c[s >> 2] | 0) + 36 >> 2] | 0)) {
	                                if (((((((qy(c[B + 8 >> 2] | 0, 161352) | 0) == 0 ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 155448) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 159128) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 159120) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 164480) | 0) == 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 164488) | 0) == 0 : 0) {
	                                    D = c[(c[s >> 2] | 0) + 8 >> 2] | 0;
	                                    if (!(c[n >> 2] | 0)) {
	                                        if (qy(D, 161808) | 0)break;
	                                        if (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161824) | 0)break;
	                                        if (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 163528) | 0)break;
	                                        GF(c[j >> 2] | 0, 3035, 0, c[s >> 2] | 0);
	                                        break
	                                    } else {
	                                        if (qy(D, 164504) | 0)break;
	                                        if (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 164512) | 0)break;
	                                        if (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 160544) | 0)break;
	                                        GF(c[j >> 2] | 0, 3035, 0, c[s >> 2] | 0);
	                                        break
	                                    }
	                                }
	                            } else if (qy(c[(c[B + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[j >> 2] | 0, 3035, 0, c[s >> 2] | 0); while (0);
	                            c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                        }
	                        do if (c[n >> 2] | 0) {
	                            B = (c[o >> 2] | 0) + 48 | 0;
	                            c[B >> 2] = c[B >> 2] | 2;
	                            B = (c[o >> 2] | 0) + 48 | 0;
	                            c[B >> 2] = c[B >> 2] | 32;
	                            fG(c[j >> 2] | 0, c[k >> 2] | 0, 0, c[l >> 2] | 0, 160544, (c[o >> 2] | 0) + 68 | 0, (c[o >> 2] | 0) + 64 | 0) | 0;
	                            if (gG(c[j >> 2] | 0, c[l >> 2] | 0, 164512, 0) | 0) {
	                                B = (c[o >> 2] | 0) + 48 | 0;
	                                c[B >> 2] = c[B >> 2] | 16
	                            }
	                            c[s >> 2] = dE(c[l >> 2] | 0, 164504) | 0;
	                            if (c[s >> 2] | 0) {
	                                c[E >> 2] = fE(c[j >> 2] | 0, c[s >> 2] | 0) | 0;
	                                if (!(iE(c[E >> 2] | 0, (c[o >> 2] | 0) + 48 | 0, -1, 32768, 65536, -1, -1, -1) | 0))break;
	                                hE(c[j >> 2] | 0, 3037, 0, c[s >> 2] | 0, 0, 164528, c[E >> 2] | 0, 0, 0, 0);
	                                break
	                            }
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] & 4) {
	                                B = (c[o >> 2] | 0) + 48 | 0;
	                                c[B >> 2] = c[B >> 2] | 32768
	                            }
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] & 8) {
	                                B = (c[o >> 2] | 0) + 48 | 0;
	                                c[B >> 2] = c[B >> 2] | 65536
	                            }
	                        } while (0);
	                        c[s >> 2] = dE(c[l >> 2] | 0, 164480) | 0;
	                        if (!(c[s >> 2] | 0)) {
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] & 128) {
	                                B = (c[o >> 2] | 0) + 48 | 0;
	                                c[B >> 2] = c[B >> 2] | 4096
	                            }
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] & 64) {
	                                B = (c[o >> 2] | 0) + 48 | 0;
	                                c[B >> 2] = c[B >> 2] | 2048
	                            }
	                            if (c[(c[k >> 2] | 0) + 24 >> 2] & 256) {
	                                B = (c[o >> 2] | 0) + 48 | 0;
	                                c[B >> 2] = c[B >> 2] | 8192
	                            }
	                        } else {
	                            c[E >> 2] = fE(c[j >> 2] | 0, c[s >> 2] | 0) | 0;
	                            if (iE(c[E >> 2] | 0, (c[o >> 2] | 0) + 48 | 0, -1, 2048, 4096, 8192, -1, -1) | 0)hE(c[j >> 2] | 0, 3037, 0, c[s >> 2] | 0, 0, 164576, c[E >> 2] | 0, 0, 0, 0)
	                        }
	                        if (gG(c[j >> 2] | 0, c[l >> 2] | 0, 164488, 0) | 0) {
	                            E = (c[o >> 2] | 0) + 48 | 0;
	                            c[E >> 2] = c[E >> 2] | 1
	                        }
	                        c[s >> 2] = dE(c[l >> 2] | 0, 155448) | 0;
	                        if (c[s >> 2] | 0) {
	                            _F(c[j >> 2] | 0, c[k >> 2] | 0, 0, c[s >> 2] | 0, (c[o >> 2] | 0) + 60 | 0, (c[o >> 2] | 0) + 56 | 0) | 0;
	                            $F(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[s >> 2] | 0, c[(c[o >> 2] | 0) + 60 >> 2] | 0) | 0
	                        }
	                        E = RC(c[j >> 2] | 0, c[l >> 2] | 0, 159128) | 0;
	                        c[(c[o >> 2] | 0) + 76 >> 2] = E;
	                        c[s >> 2] = dE(c[l >> 2] | 0, 159120) | 0;
	                        do if (c[s >> 2] | 0) {
	                            c[C >> 2] = fE(c[j >> 2] | 0, c[s >> 2] | 0) | 0;
	                            if (c[(c[o >> 2] | 0) + 76 >> 2] | 0) {
	                                aG(c[j >> 2] | 0, 3038, 0, c[s >> 2] | 0, 159128, 159120);
	                                break
	                            } else {
	                                E = (c[o >> 2] | 0) + 48 | 0;
	                                c[E >> 2] = c[E >> 2] | 8;
	                                c[(c[o >> 2] | 0) + 76 >> 2] = c[C >> 2];
	                                break
	                            }
	                        } while (0);
	                        if ((((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 161008) | 0) != 0 : 0) ? (qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            C = c[j >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 56 >> 2] | 0)uE(C, 3041, 0, c[l >> 2] | 0, c[r >> 2] | 0, 164640, 0); else {
	                                s = nE(C, c[k >> 2] | 0, c[r >> 2] | 0, 0) | 0;
	                                c[(c[o >> 2] | 0) + 28 >> 2] = s
	                            }
	                            c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                        } else I = 107;
	                        if (((((I | 0) == 107 ? (c[r >> 2] | 0) != 0 : 0) ? (c[(c[r >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            s = c[j >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 56 >> 2] | 0)uE(s, 3041, 0, c[l >> 2] | 0, c[r >> 2] | 0, 164128, 0); else {
	                                C = oE(s, c[k >> 2] | 0, c[r >> 2] | 0, 0) | 0;
	                                c[(c[o >> 2] | 0) + 28 >> 2] = C
	                            }
	                            c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                        }
	                        while (1) {
	                            if ((((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 164712) | 0) != 0 : 0) ? (qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)J = 1; else I = 119;
	                            a:do if ((I | 0) == 119) {
	                                I = 0;
	                                do if (c[r >> 2] | 0) {
	                                    if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0))break;
	                                    if (!(qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 164720) | 0))break;
	                                    if (qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) {
	                                        J = 1;
	                                        break a
	                                    }
	                                } while (0);
	                                if (c[r >> 2] | 0) {
	                                    if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0)) {
	                                        J = 0;
	                                        break
	                                    }
	                                    if (!(qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 164728) | 0)) {
	                                        J = 0;
	                                        break
	                                    }
	                                    J = (qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0
	                                } else J = 0
	                            } while (0);
	                            K = (c[r >> 2] | 0) != 0;
	                            if (!J)break;
	                            do if (K) {
	                                if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0)) {
	                                    I = 133;
	                                    break
	                                }
	                                if (!(qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 164712) | 0)) {
	                                    I = 133;
	                                    break
	                                }
	                                if (!(qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)) {
	                                    I = 133;
	                                    break
	                                }
	                                c[F >> 2] = hG(c[j >> 2] | 0, c[k >> 2] | 0, c[r >> 2] | 0, 22, c[(c[o >> 2] | 0) + 52 >> 2] | 0) | 0
	                            } else I = 133; while (0);
	                            b:do if ((I | 0) == 133) {
	                                I = 0;
	                                do if (c[r >> 2] | 0) {
	                                    if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0))break;
	                                    if (!(qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 164720) | 0))break;
	                                    if (!(qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break;
	                                    c[F >> 2] = hG(c[j >> 2] | 0, c[k >> 2] | 0, c[r >> 2] | 0, 23, c[(c[o >> 2] | 0) + 52 >> 2] | 0) | 0;
	                                    break b
	                                } while (0);
	                                if (!(c[r >> 2] | 0))break;
	                                if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0))break;
	                                if (!(qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 164728) | 0))break;
	                                if (!(qy(c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break;
	                                c[F >> 2] = hG(c[j >> 2] | 0, c[k >> 2] | 0, c[r >> 2] | 0, 24, c[(c[o >> 2] | 0) + 52 >> 2] | 0) | 0
	                            } while (0);
	                            C = c[F >> 2] | 0;
	                            if (c[G >> 2] | 0)c[(c[G >> 2] | 0) + 8 >> 2] = C; else c[(c[o >> 2] | 0) + 100 >> 2] = C;
	                            c[G >> 2] = c[F >> 2];
	                            c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                        }
	                        if (K)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[r >> 2] | 0, 0, 164736);
	                        c[(c[o >> 2] | 0) + 24 >> 2] = c[q >> 2];
	                        if (c[x >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                            c[x >> 2] = 0
	                        }
	                        r = c[o >> 2] | 0;
	                        if (c[n >> 2] | 0) {
	                            c[h >> 2] = r;
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        } else {
	                            c[(c[p >> 2] | 0) + 12 >> 2] = r;
	                            c[h >> 2] = c[p >> 2];
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        }
	                    }
	                }
	                if (c[x >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                    c[x >> 2] = 0
	                }
	                if (c[q >> 2] | 0) {
	                    if (c[p >> 2] | 0)c[(c[p >> 2] | 0) + 4 >> 2] = 0;
	                    if (c[o >> 2] | 0)c[(c[o >> 2] | 0) + 24 >> 2] = 0;
	                    mB(c[q >> 2] | 0)
	                }
	                c[h >> 2] = 0;
	                H = c[h >> 2] | 0;
	                i = g;
	                return H | 0
	            }

	            function qE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[n >> 2] = dE(c[j >> 2] | 0, 161352) | 0;
	                d = c[g >> 2] | 0;
	                if (!(c[n >> 2] | 0)) {
	                    MF(d, 3036, 0, c[j >> 2] | 0, 161352, 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                b = c[n >> 2] | 0;
	                if (eE(d, 0, b, IH(22) | 0, k) | 0) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                b = (qy(c[k >> 2] | 0, 163840) | 0) != 0;
	                d = c[g >> 2] | 0;
	                if (b) {
	                    b = c[n >> 2] | 0;
	                    hE(d, 3056, 0, b, IH(22) | 0, 0, 0, 163848, 0, 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (qy(c[d + 112 >> 2] | 0, c[38860] | 0) | 0)AB(c[g >> 2] | 0, 3057, c[j >> 2] | 0, 0, 163792, c[38860] | 0, 0);
	                c[l >> 2] = iG(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, c[(c[g >> 2] | 0) + 112 >> 2] | 0, c[j >> 2] | 0, 1) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                k = (c[l >> 2] | 0) + 60 | 0;
	                c[k >> 2] = c[k >> 2] | 1;
	                c[n >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[n >> 2] | 0))break;
	                    k = c[n >> 2] | 0;
	                    if (!(c[(c[n >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (((((qy(c[k + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 159128) | 0) == 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 159120) | 0) == 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161352) | 0) == 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 155448) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[n >> 2] | 0)
	                    } else if (qy(c[(c[k + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[n >> 2] | 0);
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                fG(c[g >> 2] | 0, c[h >> 2] | 0, 0, c[j >> 2] | 0, 155448, (c[l >> 2] | 0) + 28 | 0, (c[l >> 2] | 0) + 24 | 0) | 0;
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                k = RC(c[g >> 2] | 0, c[j >> 2] | 0, 159120) | 0;
	                c[(c[l >> 2] | 0) + 44 >> 2] = k;
	                if (c[(c[l >> 2] | 0) + 44 >> 2] | 0) {
	                    k = (c[l >> 2] | 0) + 60 | 0;
	                    c[k >> 2] = c[k >> 2] | 512
	                }
	                c[n >> 2] = dE(c[j >> 2] | 0, 159128) | 0;
	                do if (c[n >> 2] | 0) {
	                    k = c[g >> 2] | 0;
	                    if (c[(c[l >> 2] | 0) + 60 >> 2] & 512) {
	                        aG(k, 3051, c[l >> 2] | 0, c[n >> 2] | 0, 159128, 159120);
	                        break
	                    } else {
	                        d = fE(k, c[n >> 2] | 0) | 0;
	                        c[(c[l >> 2] | 0) + 44 >> 2] = d;
	                        break
	                    }
	                } while (0);
	                c[m >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    n = jE(c[g >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                    c[(c[l >> 2] | 0) + 32 >> 2] = n;
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    n = c[g >> 2] | 0;
	                    if (c[(c[l >> 2] | 0) + 24 >> 2] | 0)uE(n, 3055, 0, c[j >> 2] | 0, c[m >> 2] | 0, 164128, 0); else {
	                        d = oE(n, c[h >> 2] | 0, c[m >> 2] | 0, 0) | 0;
	                        c[(c[l >> 2] | 0) + 48 >> 2] = d
	                    }
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                if (c[m >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[m >> 2] | 0, 0, 164200);
	                c[f >> 2] = c[l >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function rE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[o >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[n >> 2] = dE(c[j >> 2] | 0, 161352) | 0;
	                d = c[g >> 2] | 0;
	                if (!(c[n >> 2] | 0)) {
	                    MF(d, 3036, 0, c[j >> 2] | 0, 161352, 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                b = c[n >> 2] | 0;
	                if (eE(d, 0, b, IH(22) | 0, k) | 0) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[l >> 2] = jG(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, c[(c[g >> 2] | 0) + 112 >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[n >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[n >> 2] | 0))break;
	                    k = c[n >> 2] | 0;
	                    if (!(c[(c[n >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[k + 8 >> 2] | 0, 161352) | 0) == 0 ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[n >> 2] | 0)
	                    } else if (qy(c[(c[k + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[n >> 2] | 0);
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[m >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    n = jE(c[g >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                    c[(c[l >> 2] | 0) + 24 >> 2] = n;
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                if ((SF(c[g >> 2] | 0, c[h >> 2] | 0, m, (c[l >> 2] | 0) + 56 | 0, 16, o) | 0) == -1) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if (c[o >> 2] | 0) {
	                    o = (c[l >> 2] | 0) + 36 | 0;
	                    c[o >> 2] = c[o >> 2] | 16
	                }
	                if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 163328) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    o = TF(c[g >> 2] | 0, c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[(c[l >> 2] | 0) + 40 >> 2] = o;
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                if (c[m >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[m >> 2] | 0, 0, 163344);
	                c[f >> 2] = c[l >> 2];
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function sE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[m >> 2] = dE(c[j >> 2] | 0, 161352) | 0;
	                d = c[g >> 2] | 0;
	                if (!(c[m >> 2] | 0)) {
	                    MF(d, 3036, 0, c[j >> 2] | 0, 161352, 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                b = c[m >> 2] | 0;
	                if (eE(d, 0, b, IH(22) | 0, n) | 0) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[k >> 2] = kG(c[g >> 2] | 0, c[h >> 2] | 0, c[n >> 2] | 0, c[(c[g >> 2] | 0) + 112 >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[m >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    n = c[m >> 2] | 0;
	                    if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[n + 8 >> 2] | 0, 161352) | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                    } else if (qy(c[(c[n + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    m = jE(c[g >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    c[(c[k >> 2] | 0) + 4 >> 2] = m;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 161648) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    m = QF(c[g >> 2] | 0, c[h >> 2] | 0, c[l >> 2] | 0, 8, 0) | 0;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = m;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                } else p = 28;
	                do if ((p | 0) == 28) {
	                    if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 161656) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        m = QF(c[g >> 2] | 0, c[h >> 2] | 0, c[l >> 2] | 0, 7, 0) | 0;
	                        c[(c[k >> 2] | 0) + 12 >> 2] = m;
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 161664) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        m = QF(c[g >> 2] | 0, c[h >> 2] | 0, c[l >> 2] | 0, 6, 0) | 0;
	                        c[(c[k >> 2] | 0) + 12 >> 2] = m;
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if (c[l >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[l >> 2] | 0, 0, 161680);
	                c[f >> 2] = c[k >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function tE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[k >> 2] = RC(c[g >> 2] | 0, c[j >> 2] | 0, 161352) | 0;
	                d = c[g >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    lG(d, c[j >> 2] | 0, c[m >> 2] | 0, 1723, 161360, 0, 0);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[l >> 2] = mG(d, c[h >> 2] | 0, c[k >> 2] | 0, c[(c[g >> 2] | 0) + 112 >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[m >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    k = jE(c[g >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                    c[(c[l >> 2] | 0) + 8 >> 2] = k;
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                if (c[m >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[m >> 2] | 0, 0, 161392);
	                c[f >> 2] = c[l >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function uE(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 28 | 0;
	                l = j + 24 | 0;
	                m = j + 20 | 0;
	                n = j + 16 | 0;
	                o = j + 12 | 0;
	                p = j + 8 | 0;
	                q = j + 4 | 0;
	                r = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = 0;
	                GC(r, 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                do if (!(c[p >> 2] | 0)) {
	                    m = c[k >> 2] | 0;
	                    h = c[n >> 2] | 0;
	                    g = c[o >> 2] | 0;
	                    f = c[l >> 2] | 0;
	                    e = c[r >> 2] | 0;
	                    if (c[q >> 2] | 0) {
	                        lG(m, h, g, f, 161272, e, c[q >> 2] | 0);
	                        break
	                    } else {
	                        lG(m, h, g, f, 161320, e, 0);
	                        break
	                    }
	                } else lG(c[k >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0, 161256, c[r >> 2] | 0, c[p >> 2] | 0); while (0);
	                if (!(c[r >> 2] | 0)) {
	                    i = j;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                c[r >> 2] = 0;
	                i = j;
	                return
	            }

	            function vE(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                a:do if ((c[(c[h >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    c[n >> 2] = 0;
	                    b:while (1) {
	                        if ((c[n >> 2] | 0) >= (c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 4 >> 2] | 0))break a;
	                        c[m >> 2] = c[(c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) + (c[n >> 2] << 2) >> 2];
	                        do if ((c[c[m >> 2] >> 2] | 0) == (c[j >> 2] | 0)) {
	                            e = c[j >> 2] | 0;
	                            if ((e | 0) == 4 | (e | 0) == 5) {
	                                if ((c[(c[m >> 2] | 0) + 8 >> 2] | 0) != (c[k >> 2] | 0))break;
	                                if ((c[(c[m >> 2] | 0) + 112 >> 2] | 0) == (c[l >> 2] | 0)) {
	                                    q = 11;
	                                    break b
	                                } else break
	                            } else if ((e | 0) == 16) {
	                                if ((c[(c[m >> 2] | 0) + 8 >> 2] | 0) != (c[k >> 2] | 0))break;
	                                if ((c[(c[m >> 2] | 0) + 52 >> 2] | 0) == (c[l >> 2] | 0)) {
	                                    q = 17;
	                                    break b
	                                } else break
	                            } else if ((e | 0) == 17) {
	                                if ((c[(c[m >> 2] | 0) + 16 >> 2] | 0) != (c[k >> 2] | 0))break;
	                                if ((c[(c[m >> 2] | 0) + 20 >> 2] | 0) == (c[l >> 2] | 0)) {
	                                    q = 14;
	                                    break b
	                                } else break
	                            } else {
	                                q = 18;
	                                break b
	                            }
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    if ((q | 0) == 11) {
	                        c[g >> 2] = c[m >> 2];
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((q | 0) == 14) {
	                        c[g >> 2] = c[m >> 2];
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((q | 0) == 17) {
	                        c[g >> 2] = c[m >> 2];
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((q | 0) == 18) {
	                        c[g >> 2] = 0;
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                } while (0);
	                do if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                    c[o >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    n = (c[h >> 2] | 0) + 4 | 0;
	                    c[n >> 2] = c[n >> 2] | 1;
	                    while (1) {
	                        if (((c[(c[o >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] & 1 | 0) == 0 : 0) ? (c[m >> 2] = vE(c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0, (c[m >> 2] | 0) != 0) : 0)break;
	                        c[o >> 2] = c[c[o >> 2] >> 2];
	                        if (!(c[o >> 2] | 0)) {
	                            q = 27;
	                            break
	                        }
	                    }
	                    if ((q | 0) == 27) {
	                        n = (c[h >> 2] | 0) + 4 | 0;
	                        c[n >> 2] = c[n >> 2] ^ 1;
	                        break
	                    }
	                    c[g >> 2] = c[m >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } while (0);
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function wE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if ((c[j >> 2] | 0) != 0 ? (qy(c[j >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    c[k >> 2] = QH(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) == 0 & (c[g >> 2] | 0) != 0)n = 7
	                } else n = 6;
	                if ((n | 0) == 6 ? (c[g >> 2] | 0) != 0 : 0)n = 7;
	                do if ((n | 0) == 7) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 28 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function xE(a, b, d, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                l = i;
	                i = i + 48 | 0;
	                m = l + 40 | 0;
	                n = l + 36 | 0;
	                o = l + 32 | 0;
	                p = l + 28 | 0;
	                q = l + 24 | 0;
	                r = l + 20 | 0;
	                s = l + 16 | 0;
	                t = l + 12 | 0;
	                u = l + 8 | 0;
	                v = l + 4 | 0;
	                w = l;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                GC(v, 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[u >> 2] | 0))c[u >> 2] = xF(c[t >> 2] | 0) | 0;
	                t = c[m >> 2] | 0;
	                m = c[p >> 2] | 0;
	                p = c[n >> 2] | 0;
	                n = c[v >> 2] | 0;
	                o = c[q >> 2] | 0;
	                q = BB(w, c[s >> 2] | 0, c[r >> 2] | 0) | 0;
	                EF(t, m, p, 0, 0, 0, 160072, n, o, q, c[u >> 2] | 0, 0);
	                if (c[v >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                    c[v >> 2] = 0
	                }
	                if (!(c[w >> 2] | 0)) {
	                    i = l;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                c[w >> 2] = 0;
	                i = l;
	                return
	            }

	            function yE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function zE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 92 >> 2];
	                c[j >> 2] = 0;
	                a:while (1) {
	                    if (!(c[h >> 2] | 0))break;
	                    c[m >> 2] = c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2];
	                    c[n >> 2] = c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2];
	                    c[l >> 2] = wE(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    do if (c[l >> 2] | 0) {
	                        if ((c[c[l >> 2] >> 2] | 0) != 4) {
	                            if ((c[c[l >> 2] >> 2] | 0) != 1)break;
	                            if ((c[(c[l >> 2] | 0) + 88 >> 2] | 0) == 45)break
	                        }
	                        c[(c[h >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                        c[j >> 2] = c[h >> 2];
	                        c[h >> 2] = c[c[h >> 2] >> 2];
	                        continue a
	                    } while (0);
	                    xE(c[f >> 2] | 0, 3004, c[g >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 160512, c[m >> 2] | 0, c[n >> 2] | 0, 4, 0);
	                    b = c[c[h >> 2] >> 2] | 0;
	                    if (!(c[j >> 2] | 0))c[(c[g >> 2] | 0) + 92 >> 2] = b; else c[c[j >> 2] >> 2] = b;
	                    c[k >> 2] = c[h >> 2];
	                    c[h >> 2] = c[c[h >> 2] >> 2];
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                }
	                c[l >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0)) {
	                        o = 20;
	                        break
	                    }
	                    c[h >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        o = 15;
	                        break
	                    }
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                    c[c[h >> 2] >> 2] = 0;
	                    k = c[h >> 2] | 0;
	                    if (!(c[j >> 2] | 0))c[(c[g >> 2] | 0) + 92 >> 2] = k; else c[c[j >> 2] >> 2] = k;
	                    c[j >> 2] = c[h >> 2];
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 4 >> 2]
	                }
	                if ((o | 0) == 15) {
	                    tC(c[f >> 2] | 0, 149752, 0);
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((o | 0) == 20) {
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                return 0
	            }

	            function AE(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                e = c[k >> 2] | 0;
	                if ((e | 0) == 17) {
	                    c[h >> 2] = nG(c[j >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((e | 0) == 14) {
	                    c[h >> 2] = yE(c[j >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    m = c[33976] | 0;
	                    l = c[33980] | 0;
	                    c[g >> 2] = 140328;
	                    c[g + 4 >> 2] = 4984;
	                    Db[m & 511](l, 140296, g);
	                    c[h >> 2] = 0;
	                    n = c[h >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function BE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function CE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 36 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function DE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 76 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 76 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function EE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) != 1 : 0) {
	                    if ((c[h >> 2] | 0) == (c[j >> 2] | 0)) {
	                        d = c[g >> 2] | 0;
	                        b = c[h >> 2] | 0;
	                        GE(d, 3009, b, FC(c[h >> 2] | 0) | 0, 160032, 0);
	                        c[f >> 2] = 3009;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    if (c[(c[j >> 2] | 0) + 48 >> 2] & 65536) {
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    } else {
	                        b = (c[j >> 2] | 0) + 48 | 0;
	                        c[b >> 2] = c[b >> 2] | 65536;
	                        c[k >> 2] = EE(c[g >> 2] | 0, c[h >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        h = (c[j >> 2] | 0) + 48 | 0;
	                        c[h >> 2] = c[h >> 2] ^ 65536;
	                        c[f >> 2] = c[k >> 2];
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function FE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                a:while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        l = 14;
	                        break
	                    }
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                    do if (c[j >> 2] | 0) {
	                        b = c[c[j >> 2] >> 2] | 0;
	                        if ((b | 0) == 8 | (b | 0) == 7 | (b | 0) == 6) {
	                            c[h >> 2] = FE(c[f >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            if (c[h >> 2] | 0) {
	                                l = 12;
	                                break a
	                            } else break
	                        } else if ((b | 0) != 17)break;
	                        c[k >> 2] = c[j >> 2];
	                        if ((c[k >> 2] | 0) == (c[f >> 2] | 0)) {
	                            l = 6;
	                            break a
	                        }
	                        if (((c[(c[k >> 2] | 0) + 28 >> 2] & 1 | 0) == 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (b = (c[k >> 2] | 0) + 28 | 0, c[b >> 2] = c[b >> 2] | 1, c[h >> 2] = FE(c[f >> 2] | 0, c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) | 0, b = (c[k >> 2] | 0) + 28 | 0, c[b >> 2] = c[b >> 2] ^ 1, (c[h >> 2] | 0) != 0) : 0) {
	                            l = 10;
	                            break a
	                        }
	                    } while (0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 8 >> 2]
	                }
	                if ((l | 0) == 6) {
	                    c[e >> 2] = c[g >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((l | 0) == 10) {
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((l | 0) == 12) {
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((l | 0) == 14) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function GE(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                oG(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, 0, 0);
	                i = h;
	                return
	            }

	            function HE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >= (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                        m = 14;
	                        break
	                    }
	                    c[j >> 2] = c[(c[c[g >> 2] >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                    if (((c[c[j >> 2] >> 2] | 0) == 2e3 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 16 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        c[h >> 2] = c[(c[j >> 2] | 0) + 4 >> 2];
	                        if ((c[h >> 2] | 0) == (c[f >> 2] | 0)) {
	                            m = 7;
	                            break
	                        }
	                        if ((((c[(c[h >> 2] | 0) + 36 >> 2] & 4 | 0) == 0 ? (c[(c[h >> 2] | 0) + 56 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 36 >> 2] & 16 | 0) != 0 : 0) ? (b = (c[h >> 2] | 0) + 36 | 0, c[b >> 2] = c[b >> 2] | 4, c[k >> 2] = HE(c[f >> 2] | 0, c[(c[h >> 2] | 0) + 56 >> 2] | 0) | 0, b = (c[h >> 2] | 0) + 36 | 0, c[b >> 2] = c[b >> 2] ^ 4, (c[k >> 2] | 0) != 0) : 0) {
	                            m = 12;
	                            break
	                        }
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                if ((m | 0) == 7) {
	                    c[e >> 2] = c[j >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((m | 0) == 12) {
	                    c[e >> 2] = c[k >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((m | 0) == 14) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                return 0
	            }

	            function IE(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 56 | 0;
	                j = g + 52 | 0;
	                k = g + 48 | 0;
	                l = g + 44 | 0;
	                m = g + 40 | 0;
	                n = g + 36 | 0;
	                o = g + 32 | 0;
	                p = g + 28 | 0;
	                q = g + 24 | 0;
	                r = g + 20 | 0;
	                s = g + 16 | 0;
	                t = g + 12 | 0;
	                u = g + 8 | 0;
	                v = g + 4 | 0;
	                w = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[t >> 2] = (c[c[l >> 2] >> 2] | 0) == 0 ? 0 : 1;
	                if (c[n >> 2] | 0)c[(c[n >> 2] | 0) + 4 >> 2] = 0;
	                c[r >> 2] = 0;
	                a:while (1) {
	                    if ((c[r >> 2] | 0) >= (c[(c[m >> 2] | 0) + 4 >> 2] | 0)) {
	                        x = 41;
	                        break
	                    }
	                    c[p >> 2] = c[(c[c[m >> 2] >> 2] | 0) + (c[r >> 2] << 2) >> 2];
	                    b:do if ((c[c[p >> 2] >> 2] | 0) != 2001) {
	                        if ((c[c[p >> 2] >> 2] | 0) == 2e3 ? (c[(c[p >> 2] | 0) + 8 >> 2] | 0) == 16 : 0) {
	                            if (!(c[(c[p >> 2] | 0) + 4 >> 2] | 0)) {
	                                x = 14;
	                                break a
	                            }
	                            c[o >> 2] = c[(c[p >> 2] | 0) + 4 >> 2];
	                            if ((c[(c[o >> 2] | 0) + 36 >> 2] & 1 | 0) == 0 ? (iD(c[j >> 2] | 0, c[o >> 2] | 0) | 0) == -1 : 0) {
	                                x = 17;
	                                break a
	                            }
	                            do if (c[(c[o >> 2] | 0) + 40 >> 2] | 0) {
	                                if (!(c[c[l >> 2] >> 2] | 0)) {
	                                    c[c[l >> 2] >> 2] = c[(c[o >> 2] | 0) + 40 >> 2];
	                                    break
	                                }
	                                if (!(c[t >> 2] | 0)) {
	                                    f = c[j >> 2] | 0;
	                                    e = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                                    c[u >> 2] = qG(f, e, 21, FC(c[k >> 2] | 0) | 0) | 0;
	                                    if (!(c[u >> 2] | 0)) {
	                                        x = 23;
	                                        break a
	                                    }
	                                    if ((rG(c[j >> 2] | 0, c[u >> 2] | 0, c[c[l >> 2] >> 2] | 0) | 0) == -1) {
	                                        x = 25;
	                                        break a
	                                    }
	                                    c[(c[u >> 2] | 0) + 24 >> 2] = c[(c[c[l >> 2] >> 2] | 0) + 24 >> 2];
	                                    c[c[l >> 2] >> 2] = c[u >> 2];
	                                    c[t >> 2] = 1
	                                }
	                                if ((sG(c[j >> 2] | 0, c[c[l >> 2] >> 2] | 0, c[(c[o >> 2] | 0) + 40 >> 2] | 0) | 0) == -1) {
	                                    x = 28;
	                                    break a
	                                }
	                            } while (0);
	                            c[q >> 2] = c[(c[o >> 2] | 0) + 56 >> 2];
	                            if ((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                                c[(c[c[m >> 2] >> 2] | 0) + (c[r >> 2] << 2) >> 2] = c[c[c[q >> 2] >> 2] >> 2];
	                                if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 1)break;
	                                c[s >> 2] = 1;
	                                while (1) {
	                                    if ((c[s >> 2] | 0) >= (c[(c[q >> 2] | 0) + 4 >> 2] | 0))break b;
	                                    c[r >> 2] = (c[r >> 2] | 0) + 1;
	                                    if ((tG(c[m >> 2] | 0, c[(c[c[q >> 2] >> 2] | 0) + (c[s >> 2] << 2) >> 2] | 0, c[r >> 2] | 0) | 0) == -1) {
	                                        x = 38;
	                                        break a
	                                    }
	                                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                                }
	                            }
	                            if ((TE(c[m >> 2] | 0, c[r >> 2] | 0) | 0) == -1) {
	                                x = 32;
	                                break a
	                            }
	                            c[r >> 2] = (c[r >> 2] | 0) + -1
	                        }
	                    } else {
	                        if (!(c[n >> 2] | 0)) {
	                            x = 7;
	                            break a
	                        }
	                        if ((TE(c[m >> 2] | 0, c[r >> 2] | 0) | 0) == -1) {
	                            x = 9;
	                            break a
	                        }
	                        c[r >> 2] = (c[r >> 2] | 0) + -1;
	                        pG(c[n >> 2] | 0, 2, c[p >> 2] | 0) | 0
	                    } while (0);
	                    c[r >> 2] = (c[r >> 2] | 0) + 1
	                }
	                switch (x | 0) {
	                    case 7:
	                    {
	                        xB(c[j >> 2] | 0, 152800, 152840);
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 9:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 14:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 17:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 23:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 25:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 28:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 32:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 38:
	                    {
	                        c[h >> 2] = -1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    case 41:
	                    {
	                        c:do if (((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                            c[r >> 2] = (c[(c[n >> 2] | 0) + 4 >> 2] | 0) - 1;
	                            while (1) {
	                                if ((c[r >> 2] | 0) < 0)break c;
	                                c[v >> 2] = c[(c[c[n >> 2] >> 2] | 0) + (c[r >> 2] << 2) >> 2];
	                                c[s >> 2] = 0;
	                                while (1) {
	                                    if ((c[s >> 2] | 0) >= (c[(c[m >> 2] | 0) + 4 >> 2] | 0))break;
	                                    c[p >> 2] = c[(c[c[m >> 2] >> 2] | 0) + (c[s >> 2] << 2) >> 2];
	                                    if ((c[(c[v >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[v >> 2] | 0) + 12 >> 2] | 0) == (c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) : 0) {
	                                        x = 50;
	                                        break
	                                    }
	                                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                                }
	                                if ((x | 0) == 50) {
	                                    x = 0;
	                                    c[w >> 2] = 0;
	                                    q = c[j >> 2] | 0;
	                                    o = c[(c[v >> 2] | 0) + 4 >> 2] | 0;
	                                    NC(q, 3086, o, 0, 152880, BB(w, c[(c[v >> 2] | 0) + 12 >> 2] | 0, c[(c[v >> 2] | 0) + 8 >> 2] | 0) | 0, 0, 0);
	                                    if (c[w >> 2] | 0) {
	                                        zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                                        c[w >> 2] = 0
	                                    }
	                                    if ((TE(c[n >> 2] | 0, c[r >> 2] | 0) | 0) == -1)break
	                                }
	                                c[r >> 2] = (c[r >> 2] | 0) + -1
	                            }
	                            c[h >> 2] = -1;
	                            y = c[h >> 2] | 0;
	                            i = g;
	                            return y | 0
	                        } while (0);
	                        c[h >> 2] = 0;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                }
	                return 0
	            }

	            function JE(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[j >> 2];
	                a:while (1) {
	                    if (!(c[k >> 2] | 0)) {
	                        n = 14;
	                        break
	                    }
	                    c[l >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    while (1) {
	                        if (!(c[l >> 2] | 0))break;
	                        if ((c[c[l >> 2] >> 2] | 0) == 1)break;
	                        if ((c[l >> 2] | 0) == (c[h >> 2] | 0)) {
	                            n = 7;
	                            break a
	                        }
	                        if (((c[(c[l >> 2] | 0) + 48 >> 2] & 128 | 0) != 0 ? (c[(c[l >> 2] | 0) + 48 >> 2] & 65536 | 0) == 0 : 0) ? (j = (c[l >> 2] | 0) + 48 | 0, c[j >> 2] = c[j >> 2] | 65536, j = c[g >> 2] | 0, d = c[h >> 2] | 0, c[m >> 2] = JE(j, d, EC(c[l >> 2] | 0) | 0) | 0, d = (c[l >> 2] | 0) + 48 | 0, c[d >> 2] = c[d >> 2] ^ 65536, (c[m >> 2] | 0) != 0) : 0) {
	                            n = 11;
	                            break a
	                        }
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 64 >> 2]
	                    }
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                if ((n | 0) == 7) {
	                    GE(c[g >> 2] | 0, 3003, c[h >> 2] | 0, 0, 159872, 0);
	                    c[f >> 2] = 3003;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } else if ((n | 0) == 11) {
	                    c[f >> 2] = c[m >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } else if ((n | 0) == 14) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                return 0
	            }

	            function KE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (!(c[f >> 2] | 0))c[e >> 2] = 0; else {
	                    if ((c[c[g >> 2] >> 2] | 0) != 1) {
	                        xB(c[g >> 2] | 0, 147104, 147128);
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if ((c[c[f >> 2] >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) {
	                        if ((c[c[f >> 2] >> 2] | 0) == 5) {
	                            c[e >> 2] = qD(c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                            break
	                        }
	                        if ((c[c[f >> 2] >> 2] | 0) == 4) {
	                            c[e >> 2] = lD(c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                            break
	                        } else {
	                            c[e >> 2] = 0;
	                            break
	                        }
	                    }
	                    c[e >> 2] = 0
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function LE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 92 >> 2];
	                a:while (1) {
	                    if (!(c[h >> 2] | 0)) {
	                        n = 15;
	                        break
	                    }
	                    if ((c[c[(c[h >> 2] | 0) + 4 >> 2] >> 2] | 0) != 1 ? (c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0)KE(c[(c[h >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                    b:do if (((c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 128 | 0) != 0 ? (c[l >> 2] = EC(c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0, (c[l >> 2] | 0) != 0) : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[l >> 2] | 0) + 4 >> 2], (c[c[l >> 2] >> 2] | 0) != 0) : 0) {
	                        c[j >> 2] = c[c[h >> 2] >> 2];
	                        c[l >> 2] = c[c[l >> 2] >> 2];
	                        c[k >> 2] = c[h >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break b;
	                            c[m >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                            if (!(c[m >> 2] | 0)) {
	                                n = 12;
	                                break a
	                            }
	                            c[(c[m >> 2] | 0) + 4 >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                            c[c[k >> 2] >> 2] = c[m >> 2];
	                            c[k >> 2] = c[m >> 2];
	                            c[c[m >> 2] >> 2] = c[j >> 2];
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                    } while (0);
	                    c[h >> 2] = c[c[h >> 2] >> 2]
	                }
	                if ((n | 0) == 12) {
	                    tC(c[f >> 2] | 0, 149752, 0);
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                } else if ((n | 0) == 15) {
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                return 0
	            }

	            function ME(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                c[j >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    GE(c[f >> 2] | 0, 3008, c[g >> 2] | 0, 0, 149560, 0);
	                    c[e >> 2] = 3008;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                do if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                    if ((c[c[h >> 2] >> 2] | 0) == 1 ? (c[(c[h >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)break;
	                    b = c[f >> 2] | 0;
	                    a = c[g >> 2] | 0;
	                    GE(b, 3008, a, 0, 149584, YD(j, c[h >> 2] | 0) | 0);
	                    if (c[j >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                        c[j >> 2] = 0
	                    }
	                    c[e >> 2] = 3008;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } while (0);
	                if (!((c[(c[g >> 2] | 0) + 48 >> 2] & 64 | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 128 | 0) == 0 : 0))l = 11;
	                do if ((l | 0) == 11 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 4 | 0) == 0 : 0) {
	                    if ((c[c[h >> 2] >> 2] | 0) == 1 ? (c[(c[h >> 2] | 0) + 88 >> 2] | 0) == 46 : 0)break;
	                    if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                        a = c[f >> 2] | 0;
	                        b = c[g >> 2] | 0;
	                        GE(a, 3008, b, 0, 149624, YD(j, c[h >> 2] | 0) | 0);
	                        if (c[j >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            c[j >> 2] = 0
	                        }
	                        c[e >> 2] = 3008;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                } while (0);
	                if (((c[(c[g >> 2] | 0) + 48 >> 2] & 256 | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 128 | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 48 >> 2] & 64 | 0) == 0 : 0) {
	                    GE(c[f >> 2] | 0, 3008, c[g >> 2] | 0, 0, 149728, 0);
	                    c[e >> 2] = 3008;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (!(uG(c[h >> 2] | 0, 1024) | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                l = c[f >> 2] | 0;
	                f = c[g >> 2] | 0;
	                GE(l, 3010, f, 0, 149224, YD(j, c[h >> 2] | 0) | 0);
	                if (c[j >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    c[j >> 2] = 0
	                }
	                c[e >> 2] = 3010;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function NE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                d = i;
	                i = i + 96 | 0;
	                e = d + 80 | 0;
	                f = d + 76 | 0;
	                g = d + 72 | 0;
	                h = d + 68 | 0;
	                j = d + 64 | 0;
	                k = d + 60 | 0;
	                l = d + 56 | 0;
	                m = d + 52 | 0;
	                n = d + 48 | 0;
	                o = d + 44 | 0;
	                p = d + 40 | 0;
	                q = d + 36 | 0;
	                r = d + 32 | 0;
	                s = d + 28 | 0;
	                t = d + 24 | 0;
	                u = d + 20 | 0;
	                v = d + 16 | 0;
	                w = d + 12 | 0;
	                x = d + 8 | 0;
	                y = d + 4 | 0;
	                z = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((c[c[g >> 2] >> 2] | 0) != 4) {
	                    xB(c[f >> 2] | 0, 148320, 148352);
	                    c[e >> 2] = -1;
	                    A = c[e >> 2] | 0;
	                    i = d;
	                    return A | 0
	                }
	                b = c[g >> 2] | 0;
	                a:do if (c[(c[g >> 2] | 0) + 48 >> 2] & 256) {
	                    if (!(c[(c[b + 64 >> 2] | 0) + 48 >> 2] & 256)) {
	                        a = c[f >> 2] | 0;
	                        B = c[g >> 2] | 0;
	                        GE(a, 3011, B, 0, 148400, YD(h, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                        if (c[h >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            c[h >> 2] = 0
	                        }
	                        c[e >> 2] = 3011;
	                        A = c[e >> 2] | 0;
	                        i = d;
	                        return A | 0
	                    }
	                    if (uG(c[(c[g >> 2] | 0) + 64 >> 2] | 0, 1024) | 0) {
	                        B = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        GE(B, 3012, a, 0, 148448, YD(h, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                        if (c[h >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            c[h >> 2] = 0
	                        }
	                        c[e >> 2] = 3012;
	                        A = c[e >> 2] | 0;
	                        i = d;
	                        return A | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 68 >> 2] | 0) {
	                        c[l >> 2] = 1;
	                        c[j >> 2] = TD(c[g >> 2] | 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            xB(c[f >> 2] | 0, 148320, 148512);
	                            c[e >> 2] = -1;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        c[k >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                        do {
	                            if (!(HH(c[j >> 2] | 0, c[c[k >> 2] >> 2] | 0) | 0)) {
	                                c[l >> 2] = 0;
	                                vG(c[f >> 2] | 0, 3013, c[g >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0)
	                            }
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 4 >> 2]
	                        } while ((c[k >> 2] | 0) != 0);
	                        if (!(c[l >> 2] | 0)) {
	                            c[e >> 2] = 3013;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                    }
	                } else {
	                    if (!(c[b + 48 >> 2] & 64)) {
	                        if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 128))break;
	                        c[u >> 2] = c[(c[g >> 2] | 0) + 92 >> 2];
	                        while (1) {
	                            if (!(c[u >> 2] | 0))break;
	                            if ((c[c[(c[u >> 2] | 0) + 4 >> 2] >> 2] | 0) != 1 ? (c[(c[(c[u >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0)KE(c[(c[u >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                            if ((c[(c[(c[u >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 256 | 0) == 0 ? (c[(c[(c[u >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 64 | 0) == 0 : 0) {
	                                C = 91;
	                                break
	                            }
	                            c[u >> 2] = c[c[u >> 2] >> 2]
	                        }
	                        if ((C | 0) == 91) {
	                            a = c[f >> 2] | 0;
	                            B = c[g >> 2] | 0;
	                            GE(a, 3023, B, 0, 149040, YD(h, c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3023;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        B = c[g >> 2] | 0;
	                        if ((c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 88 >> 2] | 0) == 46) {
	                            c[u >> 2] = c[B + 92 >> 2];
	                            while (1) {
	                                if (!(c[u >> 2] | 0)) {
	                                    C = 103;
	                                    break
	                                }
	                                if (uG(c[(c[u >> 2] | 0) + 4 >> 2] | 0, 4096) | 0)break;
	                                c[u >> 2] = c[c[u >> 2] >> 2]
	                            }
	                            if ((C | 0) == 103) {
	                                if (!(c[(c[g >> 2] | 0) + 96 >> 2] | 0))break;
	                                GE(c[f >> 2] | 0, 3025, c[g >> 2] | 0, 0, 149160, 0);
	                                c[e >> 2] = 3025;
	                                A = c[e >> 2] | 0;
	                                i = d;
	                                return A | 0
	                            }
	                            a = c[f >> 2] | 0;
	                            D = c[g >> 2] | 0;
	                            GE(a, 3024, D, 0, 149104, YD(h, c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3024;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        if (!(c[(c[B + 64 >> 2] | 0) + 48 >> 2] & 128)) {
	                            D = c[f >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            GE(D, 3027, a, 0, 149184, YD(h, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3027;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        if (uG(c[(c[g >> 2] | 0) + 64 >> 2] | 0, 1024) | 0) {
	                            a = c[f >> 2] | 0;
	                            D = c[g >> 2] | 0;
	                            GE(a, 3026, D, 0, 149224, YD(h, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3026;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        b:do if (c[(c[g >> 2] | 0) + 92 >> 2] | 0) {
	                            c[u >> 2] = c[(c[g >> 2] | 0) + 92 >> 2];
	                            c[v >> 2] = EC(c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0;
	                            if ((c[u >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0)xB(c[f >> 2] | 0, 148320, 149296);
	                            while (1) {
	                                if (!(c[u >> 2] | 0))break b;
	                                if (c[v >> 2] | 0) {
	                                    if ((c[(c[u >> 2] | 0) + 4 >> 2] | 0) != (c[(c[v >> 2] | 0) + 4 >> 2] | 0) ? (xG(c[f >> 2] | 0, c[(c[u >> 2] | 0) + 4 >> 2] | 0, c[(c[v >> 2] | 0) + 4 >> 2] | 0, 0) | 0) != 0 : 0)break
	                                } else xB(c[f >> 2] | 0, 148320, 149296);
	                                c[u >> 2] = c[c[u >> 2] >> 2];
	                                if (!(c[v >> 2] | 0))continue;
	                                c[v >> 2] = c[c[v >> 2] >> 2]
	                            }
	                            c[w >> 2] = 0;
	                            c[x >> 2] = 0;
	                            D = c[f >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            E = YD(h, c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            F = YD(w, c[(c[v >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            oG(D, 3028, a, 0, 149344, E, F, YD(x, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            if (c[w >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                                c[w >> 2] = 0
	                            }
	                            if (c[x >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                                c[x >> 2] = 0
	                            }
	                            c[e >> 2] = 3028;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        } while (0);
	                        if (!(c[(c[g >> 2] | 0) + 68 >> 2] | 0))break;
	                        c[z >> 2] = 1;
	                        c[y >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                        do {
	                            if ((c[c[y >> 2] >> 2] | 0) != 1006 ? (c[c[y >> 2] >> 2] | 0) != 1007 : 0) {
	                                wG(c[f >> 2] | 0, 3029, c[g >> 2] | 0, c[y >> 2] | 0);
	                                c[z >> 2] = 0
	                            }
	                            c[y >> 2] = c[(c[y >> 2] | 0) + 4 >> 2]
	                        } while ((c[y >> 2] | 0) != 0);
	                        if (c[z >> 2] | 0)break;
	                        c[e >> 2] = 3029;
	                        A = c[e >> 2] | 0;
	                        i = d;
	                        return A | 0
	                    }
	                    c[m >> 2] = 0;
	                    c[m >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    do if (c[m >> 2] | 0) {
	                        if ((c[c[m >> 2] >> 2] | 0) != 4) {
	                            if ((c[c[m >> 2] >> 2] | 0) != 1)break;
	                            if ((c[(c[m >> 2] | 0) + 88 >> 2] | 0) == 45)break
	                        }
	                        if ((c[c[m >> 2] >> 2] | 0) != 1 ? (c[(c[m >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0)KE(c[m >> 2] | 0, c[f >> 2] | 0) | 0;
	                        if ((c[(c[m >> 2] | 0) + 48 >> 2] & 256 | 0) == 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] & 128 | 0) == 0 : 0) {
	                            B = c[f >> 2] | 0;
	                            F = c[g >> 2] | 0;
	                            GE(B, 3015, F, 0, 148584, YD(h, c[m >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3015;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        c:do if (c[(c[m >> 2] | 0) + 48 >> 2] & 128) {
	                            c[n >> 2] = c[(c[m >> 2] | 0) + 92 >> 2];
	                            while (1) {
	                                if (!(c[n >> 2] | 0))break c;
	                                if (!(c[(c[(c[n >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 256))break;
	                                c[n >> 2] = c[c[n >> 2] >> 2]
	                            }
	                            F = c[f >> 2] | 0;
	                            B = c[g >> 2] | 0;
	                            GE(F, 3015, B, 0, 148648, YD(h, c[(c[n >> 2] | 0) + 4 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3015;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        } while (0);
	                        if ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 88 >> 2] | 0) == 46 : 0) {
	                            if (uG(c[m >> 2] | 0, 2048) | 0) {
	                                B = c[f >> 2] | 0;
	                                F = c[g >> 2] | 0;
	                                GE(B, 3016, F, 0, 148736, YD(h, c[m >> 2] | 0) | 0);
	                                if (c[h >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                    c[h >> 2] = 0
	                                }
	                                c[e >> 2] = 3016;
	                                A = c[e >> 2] | 0;
	                                i = d;
	                                return A | 0
	                            }
	                            if (!(c[(c[g >> 2] | 0) + 68 >> 2] | 0))break a;
	                            c[o >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                            while (1) {
	                                if ((c[c[o >> 2] >> 2] | 0) != 1008)break;
	                                c[o >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                                if (!(c[o >> 2] | 0))break a
	                            }
	                            wG(c[f >> 2] | 0, 3017, c[g >> 2] | 0, c[o >> 2] | 0);
	                            c[e >> 2] = 3017;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        if (!(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 64)) {
	                            F = c[f >> 2] | 0;
	                            B = c[g >> 2] | 0;
	                            GE(F, 3018, B, 0, 148792, YD(h, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3018;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        if (uG(c[(c[g >> 2] | 0) + 64 >> 2] | 0, 1024) | 0) {
	                            B = c[f >> 2] | 0;
	                            F = c[g >> 2] | 0;
	                            GE(B, 3019, F, 0, 148832, YD(h, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                            if (c[h >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[h >> 2] = 0
	                            }
	                            c[e >> 2] = 3019;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        }
	                        c[p >> 2] = c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 28 >> 2];
	                        do if (c[p >> 2] | 0) {
	                            if ((c[c[p >> 2] >> 2] | 0) != 4) {
	                                if ((c[c[p >> 2] >> 2] | 0) != 1)break;
	                                if ((c[(c[p >> 2] | 0) + 88 >> 2] | 0) == 45)break
	                            }
	                            if ((c[m >> 2] | 0) != (c[p >> 2] | 0) ? (xG(c[f >> 2] | 0, c[m >> 2] | 0, c[p >> 2] | 0, 0) | 0) != 0 : 0) {
	                                c[q >> 2] = 0;
	                                c[r >> 2] = 0;
	                                F = c[f >> 2] | 0;
	                                B = c[g >> 2] | 0;
	                                E = YD(h, c[m >> 2] | 0) | 0;
	                                a = YD(q, c[p >> 2] | 0) | 0;
	                                oG(F, 3020, B, 0, 148952, E, a, YD(r, c[(c[g >> 2] | 0) + 64 >> 2] | 0) | 0);
	                                if (c[h >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                    c[h >> 2] = 0
	                                }
	                                if (c[q >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                    c[q >> 2] = 0
	                                }
	                                if (c[r >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                    c[r >> 2] = 0
	                                }
	                                c[e >> 2] = 3020;
	                                A = c[e >> 2] | 0;
	                                i = d;
	                                return A | 0
	                            }
	                            if (!(c[(c[g >> 2] | 0) + 68 >> 2] | 0))break a;
	                            c[t >> 2] = 1;
	                            c[s >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                            do {
	                                if (((c[c[s >> 2] >> 2] | 0) + -1006 | 0) >>> 0 >= 6) {
	                                    wG(c[f >> 2] | 0, 3021, c[g >> 2] | 0, c[s >> 2] | 0);
	                                    c[t >> 2] = 0
	                                }
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 4 >> 2]
	                            } while ((c[s >> 2] | 0) != 0);
	                            if (c[t >> 2] | 0)break a;
	                            c[e >> 2] = 3021;
	                            A = c[e >> 2] | 0;
	                            i = d;
	                            return A | 0
	                        } while (0);
	                        xB(c[f >> 2] | 0, 148320, 148904);
	                        c[e >> 2] = -1;
	                        A = c[e >> 2] | 0;
	                        i = d;
	                        return A | 0
	                    } while (0);
	                    xB(c[f >> 2] | 0, 148320, 148544);
	                    c[e >> 2] = -1;
	                    A = c[e >> 2] | 0;
	                    i = d;
	                    return A | 0
	                } while (0);
	                c[e >> 2] = 0;
	                A = c[e >> 2] | 0;
	                i = d;
	                return A | 0
	            }

	            function OE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                c[k >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                do if (c[(c[f >> 2] | 0) + 68 >> 2] | 0) {
	                    c[l >> 2] = c[(c[f >> 2] | 0) + 68 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 92 >> 2] | 0) == 0 ? (yG(c[g >> 2] | 0) | 0) == -1 : 0) {
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[(c[(c[g >> 2] | 0) + 92 >> 2] | 0) + 20 >> 2] = c[(c[g >> 2] | 0) + 36 >> 2];
	                    while (1) {
	                        if (!(c[l >> 2] | 0)) {
	                            n = 9;
	                            break
	                        }
	                        c[h >> 2] = _A(c[l >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if ((c[h >> 2] | 0) == -1)break;
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 4 >> 2]
	                    }
	                    if ((n | 0) == 9) {
	                        c[(c[(c[g >> 2] | 0) + 92 >> 2] | 0) + 20 >> 2] = 0;
	                        break
	                    }
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } while (0);
	                if ((c[j >> 2] | 0) != (c[(c[g >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[e >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function PE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0;
	                d = i;
	                i = i + 112 | 0;
	                e = d + 108 | 0;
	                f = d + 104 | 0;
	                g = d + 100 | 0;
	                h = d + 96 | 0;
	                j = d + 92 | 0;
	                k = d + 88 | 0;
	                l = d + 84 | 0;
	                m = d + 80 | 0;
	                n = d + 76 | 0;
	                o = d + 72 | 0;
	                p = d + 68 | 0;
	                q = d + 64 | 0;
	                r = d + 60 | 0;
	                s = d + 56 | 0;
	                t = d + 52 | 0;
	                u = d + 48 | 0;
	                v = d + 44 | 0;
	                w = d + 40 | 0;
	                x = d + 36 | 0;
	                y = d + 32 | 0;
	                z = d + 28 | 0;
	                A = d + 24 | 0;
	                B = d + 20 | 0;
	                C = d + 16 | 0;
	                D = d + 12 | 0;
	                E = d + 8 | 0;
	                F = d + 4 | 0;
	                G = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                c[l >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                c[A >> 2] = 0;
	                c[B >> 2] = 0;
	                c[C >> 2] = 0;
	                c[D >> 2] = 0;
	                c[E >> 2] = 0;
	                c[F >> 2] = 0;
	                if ((c[(c[g >> 2] | 0) + 96 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 96 >> 2] | 0) == 0 : 0) {
	                    c[e >> 2] = 0;
	                    H = c[e >> 2] | 0;
	                    i = d;
	                    return H | 0
	                }
	                c[l >> 2] = c[(c[g >> 2] | 0) + 96 >> 2];
	                a:do if (c[l >> 2] | 0)while (1) {
	                    if (!(c[c[l >> 2] >> 2] | 0))break a;
	                    c[l >> 2] = c[c[l >> 2] >> 2]
	                } while (0);
	                c[k >> 2] = c[(c[g >> 2] | 0) + 96 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    c[m >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    switch (c[c[m >> 2] >> 2] | 0) {
	                        case 1011:
	                        {
	                            c[s >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1005:
	                        {
	                            c[q >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1009:
	                        {
	                            c[o >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1003:
	                        {
	                            c[w >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1004:
	                        {
	                            c[p >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1001:
	                        {
	                            c[v >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1002:
	                        {
	                            c[u >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1e3:
	                        {
	                            c[t >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1010:
	                        {
	                            c[r >> 2] = c[m >> 2];
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 96 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    c[m >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    switch (c[c[m >> 2] >> 2] | 0) {
	                        case 1002:
	                        {
	                            c[D >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1001:
	                        {
	                            c[E >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1005:
	                        {
	                            c[z >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1004:
	                        {
	                            c[y >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1e3:
	                        {
	                            c[C >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1003:
	                        {
	                            c[F >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1011:
	                        {
	                            c[B >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1010:
	                        {
	                            c[A >> 2] = c[m >> 2];
	                            break
	                        }
	                        case 1009:
	                        {
	                            c[x >> 2] = c[m >> 2];
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                if ((c[o >> 2] | 0) != 0 ? (c[s >> 2] | 0) != 0 | (c[r >> 2] | 0) != 0 : 0)GE(c[f >> 2] | 0, 1717, c[o >> 2] | 0, c[(c[o >> 2] | 0) + 20 >> 2] | 0, 147232, 0);
	                if ((c[u >> 2] | 0) != 0 & (c[w >> 2] | 0) != 0) {
	                    b = c[f >> 2] | 0;
	                    a = c[u >> 2] | 0;
	                    I = c[(c[u >> 2] | 0) + 20 >> 2] | 0;
	                    J = zB(c[c[u >> 2] >> 2] | 0) | 0;
	                    oG(b, 1717, a, I, 147352, J, zB(c[c[w >> 2] >> 2] | 0) | 0, 0)
	                }
	                if ((c[t >> 2] | 0) != 0 & (c[v >> 2] | 0) != 0) {
	                    J = c[f >> 2] | 0;
	                    I = c[t >> 2] | 0;
	                    a = c[(c[t >> 2] | 0) + 20 >> 2] | 0;
	                    b = zB(c[c[t >> 2] >> 2] | 0) | 0;
	                    oG(J, 1717, I, a, 147352, b, zB(c[c[v >> 2] >> 2] | 0) | 0, 0)
	                }
	                if ((c[o >> 2] | 0) != 0 & (c[x >> 2] | 0) != 0) {
	                    c[G >> 2] = XH(c[(c[o >> 2] | 0) + 32 >> 2] | 0, c[(c[x >> 2] | 0) + 32 >> 2] | 0) | 0;
	                    if ((c[G >> 2] | 0) != -2) {
	                        if (c[G >> 2] | 0)zG(c[f >> 2] | 0, c[o >> 2] | 0, c[x >> 2] | 0, 0, 0, 1);
	                        if ((c[G >> 2] | 0) != 0 ? (c[(c[x >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) {
	                            GE(c[f >> 2] | 0, 1717, c[o >> 2] | 0, c[(c[o >> 2] | 0) + 20 >> 2] | 0, 147440, 0);
	                            K = 47
	                        } else K = 47
	                    }
	                } else K = 47;
	                b:do if ((K | 0) == 47) {
	                    if ((c[s >> 2] | 0) != 0 & (c[B >> 2] | 0) != 0) {
	                        c[G >> 2] = XH(c[(c[s >> 2] | 0) + 32 >> 2] | 0, c[(c[B >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if ((c[G >> 2] | 0) == -2)break;
	                        if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[s >> 2] | 0, c[B >> 2] | 0, 1, 1, 1);
	                        if ((c[G >> 2] | 0) != 0 ? (c[(c[B >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)GE(c[f >> 2] | 0, 1717, c[s >> 2] | 0, c[(c[s >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                    }
	                    if ((c[r >> 2] | 0) != 0 & (c[A >> 2] | 0) != 0) {
	                        c[G >> 2] = XH(c[(c[r >> 2] | 0) + 32 >> 2] | 0, c[(c[A >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if ((c[G >> 2] | 0) == -2)break;
	                        if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[r >> 2] | 0, c[A >> 2] | 0, -1, 1, 1);
	                        if ((c[G >> 2] | 0) != 0 ? (c[(c[A >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)GE(c[f >> 2] | 0, 1717, c[r >> 2] | 0, c[(c[r >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                    }
	                    if (!(c[o >> 2] | 0))c[o >> 2] = c[x >> 2];
	                    if (c[o >> 2] | 0) {
	                        if (!(c[s >> 2] | 0))c[s >> 2] = c[B >> 2];
	                        if (c[s >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[o >> 2] | 0) + 32 >> 2] | 0, c[(c[s >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[o >> 2] | 0, c[s >> 2] | 0, 1, 1, 0)
	                        }
	                        if (!(c[r >> 2] | 0))c[r >> 2] = c[A >> 2];
	                        if (c[r >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[o >> 2] | 0) + 32 >> 2] | 0, c[(c[r >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[o >> 2] | 0, c[r >> 2] | 0, -1, 1, 0)
	                        }
	                    }
	                    if (c[u >> 2] | 0) {
	                        if (c[t >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[u >> 2] | 0) + 32 >> 2] | 0, c[(c[t >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[u >> 2] | 0, c[t >> 2] | 0, 1, 1, 0)
	                        }
	                        if (c[D >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[u >> 2] | 0) + 32 >> 2] | 0, c[(c[D >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[u >> 2] | 0, c[D >> 2] | 0, -1, 1, 1);
	                            if ((c[G >> 2] | 0) != 0 ? (c[(c[D >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)GE(c[f >> 2] | 0, 1717, c[u >> 2] | 0, c[(c[u >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                        }
	                        if (c[F >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[u >> 2] | 0) + 32 >> 2] | 0, c[(c[F >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) != -1)zG(c[f >> 2] | 0, c[u >> 2] | 0, c[F >> 2] | 0, -1, 0, 1)
	                        }
	                        if (c[C >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[u >> 2] | 0) + 32 >> 2] | 0, c[(c[C >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[u >> 2] | 0, c[C >> 2] | 0, 1, 1, 1)
	                        }
	                        if (c[E >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[u >> 2] | 0) + 32 >> 2] | 0, c[(c[E >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break;
	                            if ((c[G >> 2] | 0) != 1)zG(c[f >> 2] | 0, c[u >> 2] | 0, c[E >> 2] | 0, 1, 0, 1)
	                        }
	                    }
	                    do if (c[w >> 2] | 0) {
	                        if (c[v >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[(c[v >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[w >> 2] | 0, c[v >> 2] | 0, 1, 1, 0)
	                        }
	                        do if (c[F >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[(c[F >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[w >> 2] | 0, c[F >> 2] | 0, -1, 1, 1);
	                            if (c[G >> 2] | 0) {
	                                if (!(c[(c[F >> 2] | 0) + 24 >> 2] | 0))break;
	                                GE(c[f >> 2] | 0, 1717, c[w >> 2] | 0, c[(c[w >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                            }
	                        } while (0);
	                        if (c[D >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[(c[D >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[w >> 2] | 0, c[D >> 2] | 0, -1, 1, 1)
	                        }
	                        do if (c[C >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[(c[C >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == 1)break;
	                            zG(c[f >> 2] | 0, c[w >> 2] | 0, c[C >> 2] | 0, 1, 0, 1)
	                        } while (0);
	                        if (c[E >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[(c[E >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == 1)break;
	                            zG(c[f >> 2] | 0, c[w >> 2] | 0, c[E >> 2] | 0, 1, 0, 1)
	                        }
	                    } while (0);
	                    do if (c[v >> 2] | 0) {
	                        if (c[u >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[v >> 2] | 0) + 32 >> 2] | 0, c[(c[u >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) != -1)zG(c[f >> 2] | 0, c[v >> 2] | 0, c[u >> 2] | 0, -1, 0, 0)
	                        }
	                        do if (c[E >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[v >> 2] | 0) + 32 >> 2] | 0, c[(c[E >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[v >> 2] | 0, c[E >> 2] | 0, 1, 1, 1);
	                            if (!(c[G >> 2] | 0))break;
	                            if (!(c[(c[E >> 2] | 0) + 24 >> 2] | 0))break;
	                            GE(c[f >> 2] | 0, 1717, c[v >> 2] | 0, c[(c[v >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                        } while (0);
	                        do if (c[D >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[v >> 2] | 0) + 32 >> 2] | 0, c[(c[D >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) != 1)break;
	                            zG(c[f >> 2] | 0, c[v >> 2] | 0, c[D >> 2] | 0, -1, 1, 1)
	                        } while (0);
	                        do if (c[C >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[v >> 2] | 0) + 32 >> 2] | 0, c[(c[C >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) != -1)break;
	                            zG(c[f >> 2] | 0, c[v >> 2] | 0, c[C >> 2] | 0, 1, 1, 1)
	                        } while (0);
	                        if (c[F >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[v >> 2] | 0) + 32 >> 2] | 0, c[(c[F >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == -1)break;
	                            zG(c[f >> 2] | 0, c[v >> 2] | 0, c[F >> 2] | 0, -1, 0, 1)
	                        }
	                    } while (0);
	                    do if (c[t >> 2] | 0) {
	                        if (c[w >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[t >> 2] | 0) + 32 >> 2] | 0, c[(c[w >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) != -1)zG(c[f >> 2] | 0, c[t >> 2] | 0, c[w >> 2] | 0, -1, 0, 0)
	                        }
	                        do if (c[C >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[t >> 2] | 0) + 32 >> 2] | 0, c[(c[C >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == -1)zG(c[f >> 2] | 0, c[t >> 2] | 0, c[C >> 2] | 0, 1, 1, 1);
	                            if (!(c[G >> 2] | 0))break;
	                            if (!(c[(c[C >> 2] | 0) + 24 >> 2] | 0))break;
	                            GE(c[f >> 2] | 0, 1717, c[t >> 2] | 0, c[(c[t >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                        } while (0);
	                        do if (c[D >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[t >> 2] | 0) + 32 >> 2] | 0, c[(c[D >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) != 1)break;
	                            zG(c[f >> 2] | 0, c[t >> 2] | 0, c[D >> 2] | 0, -1, 1, 1)
	                        } while (0);
	                        do if (c[E >> 2] | 0) {
	                            c[G >> 2] = XH(c[(c[t >> 2] | 0) + 32 >> 2] | 0, c[(c[E >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) == -2)break b;
	                            if ((c[G >> 2] | 0) == 1)break;
	                            zG(c[f >> 2] | 0, c[t >> 2] | 0, c[E >> 2] | 0, 1, 0, 1)
	                        } while (0);
	                        if (!(c[F >> 2] | 0))break;
	                        c[G >> 2] = XH(c[(c[t >> 2] | 0) + 32 >> 2] | 0, c[(c[F >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if ((c[G >> 2] | 0) == -2)break b;
	                        if ((c[G >> 2] | 0) == -1)break;
	                        zG(c[f >> 2] | 0, c[t >> 2] | 0, c[F >> 2] | 0, -1, 0, 1)
	                    } while (0);
	                    do if ((c[p >> 2] | 0) != 0 & (c[y >> 2] | 0) != 0) {
	                        c[G >> 2] = XH(c[(c[p >> 2] | 0) + 32 >> 2] | 0, c[(c[y >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if ((c[G >> 2] | 0) == -2)break b;
	                        if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[p >> 2] | 0, c[y >> 2] | 0, -1, 1, 1);
	                        if (c[G >> 2] | 0) {
	                            if (!(c[(c[y >> 2] | 0) + 24 >> 2] | 0))break;
	                            GE(c[f >> 2] | 0, 1717, c[p >> 2] | 0, c[(c[p >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                        }
	                    } while (0);
	                    do if ((c[q >> 2] | 0) != 0 & (c[z >> 2] | 0) != 0) {
	                        c[G >> 2] = XH(c[(c[q >> 2] | 0) + 32 >> 2] | 0, c[(c[z >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if ((c[G >> 2] | 0) == -2)break b;
	                        if ((c[G >> 2] | 0) == 1)zG(c[f >> 2] | 0, c[q >> 2] | 0, c[z >> 2] | 0, -1, 1, 1);
	                        if (!(c[G >> 2] | 0))break;
	                        if (!(c[(c[z >> 2] | 0) + 24 >> 2] | 0))break;
	                        GE(c[f >> 2] | 0, 1717, c[q >> 2] | 0, c[(c[q >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                    } while (0);
	                    if (!(c[p >> 2] | 0))c[p >> 2] = c[y >> 2];
	                    if (!(c[q >> 2] | 0))c[q >> 2] = c[z >> 2];
	                    do if ((c[p >> 2] | 0) != 0 & (c[q >> 2] | 0) != 0) {
	                        c[G >> 2] = XH(c[(c[q >> 2] | 0) + 32 >> 2] | 0, c[(c[p >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if ((c[G >> 2] | 0) == -2)break b;
	                        if ((c[G >> 2] | 0) != 1)break;
	                        zG(c[f >> 2] | 0, c[q >> 2] | 0, c[p >> 2] | 0, -1, 1, 0)
	                    } while (0);
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 96 >> 2];
	                    c:while (1) {
	                        if (!(c[k >> 2] | 0)) {
	                            K = 216;
	                            break
	                        }
	                        c[n >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                        do if ((c[c[n >> 2] >> 2] | 0) != 1006) {
	                            if ((c[c[n >> 2] >> 2] | 0) == 1007)break;
	                            c[j >> 2] = c[(c[g >> 2] | 0) + 96 >> 2];
	                            while (1) {
	                                if (!(c[j >> 2] | 0))break;
	                                c[m >> 2] = c[(c[j >> 2] | 0) + 4 >> 2];
	                                if ((c[c[m >> 2] >> 2] | 0) == (c[c[n >> 2] >> 2] | 0)) {
	                                    K = 201;
	                                    break
	                                }
	                                c[j >> 2] = c[c[j >> 2] >> 2]
	                            }
	                            do if ((K | 0) == 201) {
	                                K = 0;
	                                if ((c[c[m >> 2] >> 2] | 0) != 1008)break;
	                                if ((c[(c[m >> 2] | 0) + 28 >> 2] | 0) < (c[(c[n >> 2] | 0) + 28 >> 2] | 0))GE(c[f >> 2] | 0, 1717, c[m >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0, 147512, 0);
	                                if (!(c[(c[n >> 2] | 0) + 24 >> 2] | 0))break;
	                                if ((c[(c[m >> 2] | 0) + 28 >> 2] | 0) == (c[(c[n >> 2] | 0) + 28 >> 2] | 0))break;
	                                GE(c[f >> 2] | 0, 1717, c[m >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0, 147440, 0)
	                            } while (0);
	                            if (c[j >> 2] | 0)break;
	                            c[j >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                            if (!(c[j >> 2] | 0)) {
	                                K = 210;
	                                break c
	                            }
	                            c[(c[j >> 2] | 0) + 4 >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                            c[c[j >> 2] >> 2] = 0;
	                            b = c[j >> 2] | 0;
	                            if (!(c[l >> 2] | 0))c[(c[g >> 2] | 0) + 96 >> 2] = b; else c[c[l >> 2] >> 2] = b;
	                            c[l >> 2] = c[j >> 2]
	                        } while (0);
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    if ((K | 0) == 210) {
	                        tC(c[f >> 2] | 0, 147616, 0);
	                        c[e >> 2] = -1;
	                        H = c[e >> 2] | 0;
	                        i = d;
	                        return H | 0
	                    } else if ((K | 0) == 216) {
	                        c[e >> 2] = 0;
	                        H = c[e >> 2] | 0;
	                        i = d;
	                        return H | 0
	                    }
	                } while (0);
	                xB(c[f >> 2] | 0, 147656, 147696);
	                c[e >> 2] = -1;
	                H = c[e >> 2] | 0;
	                i = d;
	                return H | 0
	            }

	            function QE(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                a = (c[e >> 2] | 0) + 48 | 0;
	                h = c[a >> 2] | 0;
	                if (c[(c[e >> 2] | 0) + 48 >> 2] & 64) {
	                    c[a >> 2] = h | 67108864;
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                if (h & 128) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                a:do if (c[(c[e >> 2] | 0) + 96 >> 2] | 0) {
	                    c[f >> 2] = c[(c[e >> 2] | 0) + 96 >> 2];
	                    while (1) {
	                        if (!(c[f >> 2] | 0))break a;
	                        k = c[f >> 2] | 0;
	                        if ((c[c[(c[f >> 2] | 0) + 4 >> 2] >> 2] | 0) == 1008)break;
	                        c[f >> 2] = c[k >> 2]
	                    }
	                    h = c[(c[k + 4 >> 2] | 0) + 28 >> 2] | 0;
	                    if ((h | 0) == 2) {
	                        a = (c[e >> 2] | 0) + 48 | 0;
	                        c[a >> 2] = c[a >> 2] | 33554432
	                    } else if ((h | 0) == 1) {
	                        a = (c[e >> 2] | 0) + 48 | 0;
	                        c[a >> 2] = c[a >> 2] | 16777216
	                    } else if ((h | 0) == 3) {
	                        h = (c[e >> 2] | 0) + 48 | 0;
	                        c[h >> 2] = c[h >> 2] | 67108864
	                    } else {
	                        c[d >> 2] = -1;
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } while (0);
	                c[g >> 2] = c[(c[e >> 2] | 0) + 64 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if ((c[(c[g >> 2] | 0) + 88 >> 2] | 0) == 45)break;
	                    l = c[g >> 2] | 0;
	                    if ((c[c[g >> 2] >> 2] | 0) == 1) {
	                        m = 20;
	                        break
	                    }
	                    c[g >> 2] = c[l + 64 >> 2]
	                }
	                do if ((m | 0) == 20) {
	                    if ((c[l + 88 >> 2] | 0) == 2) {
	                        k = (c[e >> 2] | 0) + 48 | 0;
	                        c[k >> 2] = c[k >> 2] | 33554432;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 88 >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 88 >> 2] | 0) != 46 : 0) {
	                        k = (c[e >> 2] | 0) + 48 | 0;
	                        c[k >> 2] = c[k >> 2] | 67108864;
	                        break
	                    }
	                    k = (c[e >> 2] | 0) + 48 | 0;
	                    c[k >> 2] = c[k >> 2] | 16777216
	                } while (0);
	                c[d >> 2] = 0;
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function RE(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                c[e >> 2] = (c[(c[(c[d >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 134217728 | 0) != 0 ? 1 : 0;
	                if (c[e >> 2] | 0) {
	                    c[f >> 2] = (c[(c[(c[d >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 2097152 | 0) != 0 ? 1 : 0;
	                    c[g >> 2] = (c[(c[(c[d >> 2] | 0) + 64 >> 2] | 0) + 48 >> 2] & 268435456 | 0) != 0 ? 1 : 0
	                }
	                a:do if (c[(c[d >> 2] | 0) + 68 >> 2] | 0) {
	                    c[h >> 2] = c[(c[d >> 2] | 0) + 68 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break a;
	                        a = c[c[h >> 2] >> 2] | 0;
	                        if ((a | 0) == 1007) {
	                            c[f >> 2] = 1;
	                            c[g >> 2] = 1;
	                            c[e >> 2] = 1
	                        } else if ((a | 0) == 1006) {
	                            c[g >> 2] = 1;
	                            c[e >> 2] = 1
	                        } else if ((a | 0) != 1008)c[e >> 2] = 1;
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 4 >> 2]
	                    }
	                } while (0);
	                if (c[g >> 2] | 0) {
	                    g = (c[d >> 2] | 0) + 48 | 0;
	                    c[g >> 2] = c[g >> 2] | 268435456
	                }
	                if (c[f >> 2] | 0) {
	                    g = (c[d >> 2] | 0) + 48 | 0;
	                    c[g >> 2] = c[g >> 2] | 2097152
	                }
	                if (c[e >> 2] | 0) {
	                    g = (c[d >> 2] | 0) + 48 | 0;
	                    c[g >> 2] = c[g >> 2] | 134217728
	                }
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) != 0) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 48 >> 2] & 256)) {
	                    i = b;
	                    return
	                }
	                c[j >> 2] = TD(c[d >> 2] | 0) | 0;
	                if ((c[(c[j >> 2] | 0) + 88 >> 2] | 0) == 46) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 88 >> 2] | 0) == 1) {
	                    i = b;
	                    return
	                }
	                j = (c[d >> 2] | 0) + 48 | 0;
	                c[j >> 2] = c[j >> 2] | 2097152;
	                i = b;
	                return
	            }

	            function SE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (!(c[f >> 2] | 0))c[e >> 2] = 0; else {
	                    if ((c[c[f >> 2] >> 2] | 0) != 5 ? (c[(c[f >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        b = c[f >> 2] | 0;
	                        if ((c[c[f >> 2] >> 2] | 0) != 1) {
	                            c[e >> 2] = SE(c[b + 28 >> 2] | 0, c[g >> 2] | 0) | 0;
	                            break
	                        }
	                        if ((c[b + 88 >> 2] | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                        if ((c[(c[f >> 2] | 0) + 88 >> 2] | 0) != 46 ? (c[(c[f >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                            c[e >> 2] = SE(c[(c[f >> 2] | 0) + 28 >> 2] | 0, c[g >> 2] | 0) | 0;
	                            break
	                        }
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[e >> 2] = 0
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function TE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[g >> 2] | 0) < (c[(c[f >> 2] | 0) + 4 >> 2] | 0) : 0) {
	                    do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        zb[c[135736 >> 2] & 511](c[c[f >> 2] >> 2] | 0);
	                        c[c[f >> 2] >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 8 >> 2] = 0
	                    } else {
	                        if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) - 1 | 0) == (c[g >> 2] | 0)) {
	                            b = (c[f >> 2] | 0) + 4 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + -1;
	                            break
	                        }
	                        c[h >> 2] = c[g >> 2];
	                        while (1) {
	                            if ((c[h >> 2] | 0) >= ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) - 1 | 0))break;
	                            c[(c[c[f >> 2] >> 2] | 0) + (c[h >> 2] << 2) >> 2] = c[(c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) + 1 << 2) >> 2];
	                            c[h >> 2] = (c[h >> 2] | 0) + 1
	                        }
	                        b = (c[f >> 2] | 0) + 4 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + -1
	                    } while (0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                AG(152576);
	                c[e >> 2] = -1;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function UE(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0;
	                k = i;
	                i = i + 112 | 0;
	                l = k + 108 | 0;
	                m = k + 104 | 0;
	                n = k + 100 | 0;
	                o = k + 96 | 0;
	                p = k + 92 | 0;
	                q = k + 88 | 0;
	                r = k + 84 | 0;
	                s = k + 80 | 0;
	                t = k + 76 | 0;
	                u = k + 72 | 0;
	                v = k + 68 | 0;
	                w = k + 64 | 0;
	                x = k + 60 | 0;
	                y = k + 56 | 0;
	                z = k + 52 | 0;
	                A = k + 48 | 0;
	                B = k + 44 | 0;
	                C = k + 40 | 0;
	                D = k + 36 | 0;
	                E = k + 32 | 0;
	                F = k + 28 | 0;
	                G = k + 24 | 0;
	                H = k + 20 | 0;
	                I = k + 16 | 0;
	                J = k + 12 | 0;
	                K = k + 8 | 0;
	                L = k + 4 | 0;
	                M = k;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = 0;
	                a:do if (c[q >> 2] | 0) {
	                    c[w >> 2] = 0;
	                    while (1) {
	                        if ((c[w >> 2] | 0) >= (c[(c[q >> 2] | 0) + 4 >> 2] | 0))break a;
	                        c[u >> 2] = c[(c[c[q >> 2] >> 2] | 0) + (c[w >> 2] << 2) >> 2];
	                        c[y >> 2] = 0;
	                        b:do if (c[r >> 2] | 0) {
	                            c[x >> 2] = 0;
	                            while (1) {
	                                if ((c[x >> 2] | 0) >= (c[(c[r >> 2] | 0) + 4 >> 2] | 0))break b;
	                                c[v >> 2] = c[(c[c[r >> 2] >> 2] | 0) + (c[x >> 2] << 2) >> 2];
	                                if ((c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[v >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) == (c[(c[(c[v >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) : 0)break;
	                                c[x >> 2] = (c[x >> 2] | 0) + 1
	                            }
	                            c[y >> 2] = 1;
	                            if ((c[(c[u >> 2] | 0) + 24 >> 2] | 0) == 2 ? (c[(c[v >> 2] | 0) + 24 >> 2] | 0) == 1 : 0) {
	                                c[B >> 2] = 0;
	                                j = c[m >> 2] | 0;
	                                h = FC(c[o >> 2] | 0) | 0;
	                                g = c[o >> 2] | 0;
	                                f = c[u >> 2] | 0;
	                                e = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                                BG(j, 1788, h, g, f, 151312, e, ZD(B, c[p >> 2] | 0) | 0, 0, 0);
	                                if (!(c[B >> 2] | 0))break;
	                                zb[c[135736 >> 2] & 511](c[B >> 2] | 0);
	                                c[B >> 2] = 0;
	                                break
	                            }
	                            if (!(xG(c[m >> 2] | 0, c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, c[(c[(c[v >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, 0) | 0)) {
	                                CG(c[v >> 2] | 0, A, z, 0) | 0;
	                                if (!((c[z >> 2] | 0) != 0 & (c[A >> 2] | 0) == 1))break;
	                                c[F >> 2] = 0;
	                                CG(c[v >> 2] | 0, A, F, 0) | 0;
	                                if ((c[A >> 2] | 0) != 0 ? (c[F >> 2] | 0) == (c[z >> 2] | 0) : 0)break;
	                                c[G >> 2] = 0;
	                                e = c[m >> 2] | 0;
	                                f = FC(c[o >> 2] | 0) | 0;
	                                g = c[o >> 2] | 0;
	                                h = c[u >> 2] | 0;
	                                j = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                                BG(e, 3077, f, g, h, 151576, j, ZD(G, c[p >> 2] | 0) | 0, 0, 0);
	                                if (!(c[G >> 2] | 0))break;
	                                zb[c[135736 >> 2] & 511](c[G >> 2] | 0);
	                                c[G >> 2] = 0;
	                                break
	                            }
	                            c[C >> 2] = 0;
	                            c[D >> 2] = 0;
	                            c[E >> 2] = 0;
	                            j = c[m >> 2] | 0;
	                            h = FC(c[o >> 2] | 0) | 0;
	                            g = c[o >> 2] | 0;
	                            f = c[u >> 2] | 0;
	                            e = ZD(C, c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0) | 0;
	                            d = ZD(D, c[(c[(c[v >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0) | 0;
	                            b = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                            BG(j, 1789, h, g, f, 151448, e, d, b, ZD(E, c[p >> 2] | 0) | 0);
	                            if (c[C >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[C >> 2] | 0);
	                                c[C >> 2] = 0
	                            }
	                            if (c[D >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                                c[D >> 2] = 0
	                            }
	                            if (c[E >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[E >> 2] | 0);
	                                c[E >> 2] = 0
	                            }
	                        } while (0);
	                        do if (!(c[y >> 2] | 0)) {
	                            if ((c[t >> 2] | 0) != 0 ? (DG(c[t >> 2] | 0, c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) | 0) == 0 : 0)break;
	                            c[H >> 2] = 0;
	                            b = c[m >> 2] | 0;
	                            d = FC(c[o >> 2] | 0) | 0;
	                            e = c[o >> 2] | 0;
	                            f = c[u >> 2] | 0;
	                            g = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                            BG(b, 1790, d, e, f, 151680, g, ZD(H, c[p >> 2] | 0) | 0, 0, 0);
	                            if (c[H >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[H >> 2] | 0);
	                                c[H >> 2] = 0
	                            }
	                        } while (0);
	                        c[w >> 2] = (c[w >> 2] | 0) + 1
	                    }
	                } while (0);
	                c:do if (c[r >> 2] | 0) {
	                    c[x >> 2] = 0;
	                    while (1) {
	                        if ((c[x >> 2] | 0) >= (c[(c[r >> 2] | 0) + 4 >> 2] | 0))break c;
	                        c[v >> 2] = c[(c[c[r >> 2] >> 2] | 0) + (c[x >> 2] << 2) >> 2];
	                        if ((c[(c[v >> 2] | 0) + 24 >> 2] | 0) == 1) {
	                            c[y >> 2] = 0;
	                            d:do if (c[q >> 2] | 0) {
	                                c[w >> 2] = 0;
	                                while (1) {
	                                    if ((c[w >> 2] | 0) >= (c[(c[q >> 2] | 0) + 4 >> 2] | 0))break d;
	                                    c[u >> 2] = c[(c[c[q >> 2] >> 2] | 0) + (c[w >> 2] << 2) >> 2];
	                                    if ((c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[v >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[u >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) == (c[(c[(c[v >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) : 0)break;
	                                    c[w >> 2] = (c[w >> 2] | 0) + 1
	                                }
	                                c[y >> 2] = 1
	                            } while (0);
	                            if (!(c[y >> 2] | 0)) {
	                                c[I >> 2] = 0;
	                                c[J >> 2] = 0;
	                                H = c[m >> 2] | 0;
	                                E = c[o >> 2] | 0;
	                                D = ZD(I, c[v >> 2] | 0) | 0;
	                                C = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                                CB(H, 1791, 0, E, 151760, D, C, ZD(J, c[p >> 2] | 0) | 0, 0);
	                                if (c[I >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[I >> 2] | 0);
	                                    c[I >> 2] = 0
	                                }
	                                if (c[J >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[J >> 2] | 0);
	                                    c[J >> 2] = 0
	                                }
	                            }
	                        }
	                        c[x >> 2] = (c[x >> 2] | 0) + 1
	                    }
	                } while (0);
	                do if (c[s >> 2] | 0) {
	                    if (!(c[t >> 2] | 0)) {
	                        c[K >> 2] = 0;
	                        x = c[m >> 2] | 0;
	                        J = c[o >> 2] | 0;
	                        I = MD(c[o >> 2] | 0) | 0;
	                        v = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                        y = MD(c[p >> 2] | 0) | 0;
	                        CB(x, 1797, 0, J, 151832, I, v, y, YD(K, c[p >> 2] | 0) | 0);
	                        if (c[K >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[K >> 2] | 0);
	                            c[K >> 2] = 0
	                        }
	                        c[l >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                        N = c[l >> 2] | 0;
	                        i = k;
	                        return N | 0
	                    }
	                    if ((c[(c[t >> 2] | 0) + 28 >> 2] | 0) == 0 ? (EG(c[s >> 2] | 0, c[t >> 2] | 0) | 0) != 0 : 0) {
	                        c[L >> 2] = 0;
	                        y = c[m >> 2] | 0;
	                        v = c[o >> 2] | 0;
	                        I = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                        J = MD(c[p >> 2] | 0) | 0;
	                        CB(y, 1798, 0, v, 151904, I, J, YD(L, c[p >> 2] | 0) | 0, 0);
	                        if (c[L >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[L >> 2] | 0);
	                            c[L >> 2] = 0
	                        }
	                        c[l >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                        N = c[l >> 2] | 0;
	                        i = k;
	                        return N | 0
	                    }
	                    if ((c[c[p >> 2] >> 2] | 0) == 1 ? (c[(c[p >> 2] | 0) + 88 >> 2] | 0) == 45 : 0)break;
	                    if ((c[(c[s >> 2] | 0) + 24 >> 2] | 0) < (c[(c[t >> 2] | 0) + 24 >> 2] | 0)) {
	                        c[M >> 2] = 0;
	                        J = c[m >> 2] | 0;
	                        I = c[p >> 2] | 0;
	                        v = (c[n >> 2] | 0) == 0 ? 151424 : 151432;
	                        y = MD(c[p >> 2] | 0) | 0;
	                        CB(J, 1799, 0, I, 151984, v, y, YD(M, c[p >> 2] | 0) | 0, 0);
	                        if (c[M >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[M >> 2] | 0);
	                            c[M >> 2] = 0
	                        }
	                        c[l >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                        N = c[l >> 2] | 0;
	                        i = k;
	                        return N | 0
	                    }
	                } while (0);
	                c[l >> 2] = 0;
	                N = c[l >> 2] | 0;
	                i = k;
	                return N | 0
	            }

	            function VE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                    if ((c[c[h >> 2] >> 2] | 0) != 5 ? (c[(c[h >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        c[k >> 2] = 0;
	                        b = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        o = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                        GE(b, 3076, a, o, 153352, BB(k, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0);
	                        if (c[k >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                            c[k >> 2] = 0
	                        }
	                        c[e >> 2] = 3076;
	                        p = c[e >> 2] | 0;
	                        i = d;
	                        return p | 0
	                    }
	                } else {
	                    do if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                        if ((c[c[h >> 2] >> 2] | 0) == 1 ? (c[(c[h >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                            q = 11;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                            if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) == 3 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 4 | 0) != 0 : 0) {
	                                if (!(FG(c[(c[h >> 2] | 0) + 28 >> 2] | 0) | 0)) {
	                                    c[j >> 2] = 3076;
	                                    break
	                                }
	                                if (c[(c[g >> 2] | 0) + 104 >> 2] | 0)break;
	                                c[m >> 2] = 0;
	                                k = c[f >> 2] | 0;
	                                o = c[g >> 2] | 0;
	                                GE(k, 3076, o, 0, 153664, BB(m, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0);
	                                if (c[m >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    c[m >> 2] = 0
	                                }
	                                c[e >> 2] = 3076;
	                                p = c[e >> 2] | 0;
	                                i = d;
	                                return p | 0
	                            }
	                            c[j >> 2] = 3076;
	                            break
	                        }
	                        if (!(c[(c[h >> 2] | 0) + 104 >> 2] | 0)) {
	                            GE(c[f >> 2] | 0, 3069, c[g >> 2] | 0, 0, 153584, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            c[e >> 2] = -1;
	                            p = c[e >> 2] | 0;
	                            i = d;
	                            return p | 0
	                        }
	                    } else q = 11; while (0);
	                    if ((q | 0) == 11 ? (c[(c[g >> 2] | 0) + 48 >> 2] & 2 | 0) == 0 : 0) {
	                        c[l >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        m = c[g >> 2] | 0;
	                        GE(q, 3076, m, 0, 153464, BB(l, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0);
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                        c[e >> 2] = 3076;
	                        p = c[e >> 2] | 0;
	                        i = d;
	                        return p | 0
	                    }
	                    if ((c[j >> 2] | 0) > 0) {
	                        c[n >> 2] = 0;
	                        l = (c[(c[g >> 2] | 0) + 48 >> 2] & 4 | 0) != 0;
	                        m = c[f >> 2] | 0;
	                        f = c[g >> 2] | 0;
	                        g = BB(n, c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (l)GE(m, 3076, f, 0, 153800, g); else GE(m, 3076, f, 0, 153984, g);
	                        if (c[n >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            c[n >> 2] = 0
	                        }
	                    }
	                }
	                c[e >> 2] = c[j >> 2];
	                p = c[e >> 2] | 0;
	                i = d;
	                return p | 0
	            }

	            function WE(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 20 | 0;
	                o = j + 16 | 0;
	                p = j + 12 | 0;
	                q = j + 8 | 0;
	                r = j + 4 | 0;
	                s = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = 0;
	                if ((c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                c[s >> 2] = Cb[c[135744 >> 2] & 511](120) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    tC(c[l >> 2] | 0, 153304, 0);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                m = (c[s >> 2] | 0) + 0 | 0;
	                h = m + 120 | 0;
	                do {
	                    c[m >> 2] = 0;
	                    m = m + 4 | 0
	                } while ((m | 0) < (h | 0));
	                c[c[s >> 2] >> 2] = c[n >> 2];
	                c[(c[s >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                c[(c[s >> 2] | 0) + 112 >> 2] = c[p >> 2];
	                c[(c[s >> 2] | 0) + 36 >> 2] = c[q >> 2];
	                q = c[l >> 2] | 0;
	                if (c[r >> 2] | 0) {
	                    do if (c[q + 100 >> 2] | 0) {
	                        r = GG(c[l >> 2] | 0, c[(c[l >> 2] | 0) + 116 >> 2] | 0, c[s >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                        c[(c[l >> 2] | 0) + 120 >> 2] = r;
	                        if (c[(c[l >> 2] | 0) + 120 >> 2] | 0) {
	                            c[(c[l >> 2] | 0) + 124 >> 2] = 0;
	                            break
	                        }
	                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        c[k >> 2] = 0;
	                        t = c[k >> 2] | 0;
	                        i = j;
	                        return t | 0
	                    } while (0);
	                    dG((c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 44 | 0, 5, c[s >> 2] | 0) | 0
	                } else dG((c[(c[q + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[s >> 2] | 0) | 0;
	                dG((c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[s >> 2] | 0) | 0;
	                c[k >> 2] = c[s >> 2];
	                t = c[k >> 2] | 0;
	                i = j;
	                return t | 0
	            }

	            function XE(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tC(c[h >> 2] | 0, 153120, 0);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    c[c[m >> 2] >> 2] = 25;
	                    c[(c[m >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[m >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                    c[(c[m >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                    c[(c[m >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                    c[(c[m >> 2] | 0) + 8 >> 2] = 0;
	                    c[(c[m >> 2] | 0) + 12 >> 2] = 0;
	                    dG((c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[m >> 2] | 0) | 0;
	                    c[g >> 2] = c[m >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function YE(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tC(c[h >> 2] | 0, 153080, 0);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                j = c[m >> 2] | 0;
	                c[j + 0 >> 2] = 0;
	                c[j + 4 >> 2] = 0;
	                c[j + 8 >> 2] = 0;
	                c[j + 12 >> 2] = 0;
	                c[j + 16 >> 2] = 0;
	                c[c[m >> 2] >> 2] = c[k >> 2];
	                c[(c[m >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                dG((c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[m >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) == 6 | (c[k >> 2] | 0) == 7)dG((c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[m >> 2] | 0) | 0;
	                c[g >> 2] = c[m >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function ZE(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 48 | 0;
	                f = d + 44 | 0;
	                g = d + 40 | 0;
	                h = d + 36 | 0;
	                j = d + 32 | 0;
	                k = d + 28 | 0;
	                l = d + 24 | 0;
	                m = d + 20 | 0;
	                n = d + 16 | 0;
	                o = d + 12 | 0;
	                p = d + 8 | 0;
	                q = d + 4 | 0;
	                r = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[m >> 2] = 0;
	                if (!(c[(c[g >> 2] | 0) + 64 >> 2] | 0)) {
	                    xB(c[f >> 2] | 0, 152632, 152664);
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                c[h >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                if (((c[c[h >> 2] >> 2] | 0) != 1 ? (c[(c[h >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) ? (KE(c[h >> 2] | 0, c[f >> 2] | 0) | 0) == -1 : 0) {
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                c[k >> 2] = c[(c[g >> 2] | 0) + 116 >> 2];
	                c[l >> 2] = c[(c[h >> 2] | 0) + 116 >> 2];
	                do if (c[k >> 2] | 0) {
	                    b = c[f >> 2] | 0;
	                    a = c[g >> 2] | 0;
	                    t = (c[g >> 2] | 0) + 84 | 0;
	                    u = c[k >> 2] | 0;
	                    if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 4)) {
	                        if ((IE(b, a, t, u, 0) | 0) != -1)break;
	                        xB(c[f >> 2] | 0, 152632, 152680);
	                        break
	                    }
	                    if ((IE(b, a, t, u, c[(c[f >> 2] | 0) + 128 >> 2] | 0) | 0) == -1)xB(c[f >> 2] | 0, 152632, 152680);
	                    if (c[(c[(c[f >> 2] | 0) + 128 >> 2] | 0) + 4 >> 2] | 0)c[m >> 2] = c[(c[f >> 2] | 0) + 128 >> 2]
	                } while (0);
	                a:do if (c[l >> 2] | 0) {
	                    if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 4)) {
	                        c[n >> 2] = 0;
	                        while (1) {
	                            if ((c[n >> 2] | 0) >= (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                                v = 45;
	                                break a
	                            }
	                            c[j >> 2] = c[(c[c[l >> 2] >> 2] | 0) + (c[n >> 2] << 2) >> 2];
	                            if (!(c[k >> 2] | 0)) {
	                                u = JB() | 0;
	                                c[(c[g >> 2] | 0) + 116 >> 2] = u;
	                                if (!(c[(c[g >> 2] | 0) + 116 >> 2] | 0))break a;
	                                c[k >> 2] = c[(c[g >> 2] | 0) + 116 >> 2]
	                            }
	                            pG(c[k >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0) | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                    }
	                    if (c[k >> 2] | 0)c[q >> 2] = c[(c[k >> 2] | 0) + 4 >> 2]; else c[q >> 2] = 0;
	                    c[n >> 2] = 0;
	                    while (1) {
	                        if ((c[n >> 2] | 0) >= (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                            v = 45;
	                            break a
	                        }
	                        c[j >> 2] = c[(c[c[l >> 2] >> 2] | 0) + (c[n >> 2] << 2) >> 2];
	                        b:do if (c[m >> 2] | 0) {
	                            c[o >> 2] = 0;
	                            while (1) {
	                                if ((c[o >> 2] | 0) >= (c[(c[m >> 2] | 0) + 4 >> 2] | 0)) {
	                                    v = 28;
	                                    break b
	                                }
	                                c[p >> 2] = c[(c[c[m >> 2] >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                                if ((c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[p >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) == (c[(c[p >> 2] | 0) + 12 >> 2] | 0) : 0)break b;
	                                c[o >> 2] = (c[o >> 2] | 0) + 1
	                            }
	                        } else v = 28; while (0);
	                        c:do if ((v | 0) == 28) {
	                            v = 0;
	                            d:do if (c[q >> 2] | 0) {
	                                c[o >> 2] = 0;
	                                while (1) {
	                                    if ((c[o >> 2] | 0) >= (c[q >> 2] | 0))break d;
	                                    c[r >> 2] = c[(c[c[k >> 2] >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                                    if ((c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[r >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) == (c[(c[(c[r >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) : 0)break c;
	                                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                                }
	                            } while (0);
	                            if (!(c[k >> 2] | 0)) {
	                                u = JB() | 0;
	                                c[(c[g >> 2] | 0) + 116 >> 2] = u;
	                                if (!(c[(c[g >> 2] | 0) + 116 >> 2] | 0))break a;
	                                c[k >> 2] = c[(c[g >> 2] | 0) + 116 >> 2]
	                            }
	                            pG(c[k >> 2] | 0, 2, c[j >> 2] | 0) | 0
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                } else v = 45; while (0);
	                e:do if ((v | 0) == 45) {
	                    if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) {
	                        oB(c[k >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 116 >> 2] = 0
	                    }
	                    do if ((c[(c[g >> 2] | 0) + 48 >> 2] & 2 | 0) != 0 ? (c[(c[h >> 2] | 0) + 84 >> 2] | 0) != 0 : 0)if (c[(c[g >> 2] | 0) + 84 >> 2] | 0)if ((HG(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 84 >> 2] | 0, c[(c[h >> 2] | 0) + 84 >> 2] | 0) | 0) == -1)break e; else break; else {
	                        c[(c[g >> 2] | 0) + 84 >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                        break
	                    } while (0);
	                    c[e >> 2] = 0;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                } while (0);
	                c[e >> 2] = -1;
	                s = c[e >> 2] | 0;
	                i = d;
	                return s | 0
	            }

	            function _E(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = IG(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (c[h >> 2] | 0) {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = c[f >> 2] | 0;
	                f = c[g >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 48 >> 2] & 2)c[h >> 2] = JG(b, f) | 0; else c[h >> 2] = KG(b, f) | 0;
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function $E(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 56 | 0;
	                f = d + 52 | 0;
	                g = d + 48 | 0;
	                h = d + 44 | 0;
	                j = d + 40 | 0;
	                k = d + 36 | 0;
	                l = d + 32 | 0;
	                m = d + 28 | 0;
	                n = d + 24 | 0;
	                o = d + 20 | 0;
	                p = d + 16 | 0;
	                q = d + 12 | 0;
	                r = d + 8 | 0;
	                s = d + 4 | 0;
	                t = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                if (c[(c[g >> 2] | 0) + 80 >> 2] | 0) {
	                    c[k >> 2] = c[(c[g >> 2] | 0) + 80 >> 2];
	                    rD(c[k >> 2] | 0, c[f >> 2] | 0);
	                    if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 2)) {
	                        GE(c[f >> 2] | 0, 3046, c[g >> 2] | 0, 0, 158528, 0);
	                        c[h >> 2] = 3046
	                    }
	                    b = c[k >> 2] | 0;
	                    do if ((c[k >> 2] | 0) != (c[g >> 2] | 0))if (c[b + 80 >> 2] | 0) {
	                        c[l >> 2] = LG(c[k >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[l >> 2] = 0;
	                        break
	                    } else c[l >> 2] = b; while (0);
	                    if (c[l >> 2] | 0) {
	                        c[m >> 2] = 0;
	                        c[n >> 2] = 0;
	                        b = c[f >> 2] | 0;
	                        a = c[l >> 2] | 0;
	                        u = YD(m, c[l >> 2] | 0) | 0;
	                        oG(b, 3049, a, 0, 158608, u, YD(n, c[k >> 2] | 0) | 0, 0);
	                        if (c[m >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            c[m >> 2] = 0
	                        }
	                        if (c[n >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            c[n >> 2] = 0
	                        }
	                        c[h >> 2] = 3049
	                    }
	                    if ((c[j >> 2] | 0) != (c[(c[(c[g >> 2] | 0) + 80 >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[o >> 2] = 0;
	                        if (c[(c[k >> 2] | 0) + 48 >> 2] & 32768)c[o >> 2] = c[o >> 2] | 2;
	                        if (c[(c[k >> 2] | 0) + 48 >> 2] & 65536)c[o >> 2] = c[o >> 2] | 1;
	                        if (MG(c[f >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 28 >> 2] | 0, c[o >> 2] | 0) | 0) {
	                            c[p >> 2] = 0;
	                            c[q >> 2] = 0;
	                            c[r >> 2] = 0;
	                            c[h >> 2] = 3047;
	                            o = c[f >> 2] | 0;
	                            n = c[g >> 2] | 0;
	                            m = YD(p, c[j >> 2] | 0) | 0;
	                            u = YD(q, c[k >> 2] | 0) | 0;
	                            oG(o, 3047, n, 0, 158704, m, u, YD(r, c[(c[k >> 2] | 0) + 28 >> 2] | 0) | 0);
	                            if (c[p >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                                c[p >> 2] = 0
	                            }
	                            if (c[q >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                c[q >> 2] = 0
	                            }
	                            if (c[r >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                c[r >> 2] = 0
	                            }
	                        }
	                    }
	                }
	                do if (c[(c[g >> 2] | 0) + 76 >> 2] | 0) {
	                    if ((c[c[j >> 2] >> 2] | 0) != 4)if ((c[c[j >> 2] >> 2] | 0) == 1 ? (c[(c[j >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)v = 31; else v = 32; else v = 31;
	                    if ((v | 0) == 31 ? (SE(c[j >> 2] | 0, 23) | 0) == 0 : 0)v = 32;
	                    if ((v | 0) == 32) {
	                        if ((c[c[j >> 2] >> 2] | 0) != 5 ? (c[(c[j >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                            v = 38;
	                            break
	                        }
	                        if ((c[(c[j >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[j >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                            v = 38;
	                            break
	                        }
	                        if (!(SE(c[(c[j >> 2] | 0) + 104 >> 2] | 0, 23) | 0)) {
	                            v = 38;
	                            break
	                        }
	                    }
	                    c[h >> 2] = 3048;
	                    GE(c[f >> 2] | 0, 3048, c[g >> 2] | 0, 0, 158848, 0)
	                } else v = 38; while (0);
	                if ((v | 0) == 38 ? (c[(c[g >> 2] | 0) + 76 >> 2] | 0) != 0 : 0) {
	                    c[t >> 2] = 0;
	                    if (!(c[j >> 2] | 0)) {
	                        PC(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 3069, 159008, 0, 0);
	                        c[e >> 2] = -1;
	                        w = c[e >> 2] | 0;
	                        i = d;
	                        return w | 0
	                    }
	                    do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                        v = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 48 >> 2] & 8) {
	                            c[t >> 2] = dj(v, 159120) | 0;
	                            break
	                        } else {
	                            c[t >> 2] = dj(v, 159128) | 0;
	                            break
	                        }
	                    } while (0);
	                    c[s >> 2] = NG(c[f >> 2] | 0, c[t >> 2] | 0, c[j >> 2] | 0, c[(c[g >> 2] | 0) + 76 >> 2] | 0, (c[g >> 2] | 0) + 96 | 0) | 0;
	                    if (c[s >> 2] | 0)if ((c[s >> 2] | 0) < 0) {
	                        xB(c[f >> 2] | 0, 159136, 159168);
	                        c[e >> 2] = -1;
	                        w = c[e >> 2] | 0;
	                        i = d;
	                        return w | 0
	                    } else {
	                        c[e >> 2] = c[s >> 2];
	                        w = c[e >> 2] | 0;
	                        i = d;
	                        return w | 0
	                    }
	                }
	                c[e >> 2] = c[h >> 2];
	                w = c[e >> 2] | 0;
	                i = d;
	                return w | 0
	            }

	            function aF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[(c[f >> 2] | 0) + 80 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 48 >> 2] & 16) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[f >> 2] | 0) + 80 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    c[k >> 2] = 0;
	                    c[l >> 2] = 0;
	                    do if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 8192)) {
	                        c[h >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                        if ((c[h >> 2] | 0) != (c[j >> 2] | 0)) {
	                            if (c[(c[g >> 2] | 0) + 48 >> 2] & 4096)c[k >> 2] = c[k >> 2] | 524288;
	                            if (c[(c[g >> 2] | 0) + 48 >> 2] & 2048)c[k >> 2] = c[k >> 2] | 262144;
	                            while (1) {
	                                if (!(c[j >> 2] | 0))break;
	                                if ((c[j >> 2] | 0) == (c[h >> 2] | 0))break;
	                                if ((c[(c[j >> 2] | 0) + 48 >> 2] & 2 | 0) != 0 ? (c[l >> 2] & 524288 | 0) == 0 : 0)c[l >> 2] = c[l >> 2] | 262144;
	                                if ((c[(c[j >> 2] | 0) + 48 >> 2] & 4 | 0) != 0 ? (c[l >> 2] & 524288 | 0) == 0 : 0)c[l >> 2] = c[l >> 2] | 524288;
	                                c[j >> 2] = c[(c[j >> 2] | 0) + 64 >> 2]
	                            }
	                            c[j >> 2] = c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 64 >> 2];
	                            while (1) {
	                                if (!(c[j >> 2] | 0))break;
	                                if ((c[c[j >> 2] >> 2] | 0) != 5 ? (c[(c[j >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)break;
	                                if ((c[(c[j >> 2] | 0) + 48 >> 2] & 262144 | 0) != 0 ? (c[k >> 2] & 262144 | 0) == 0 : 0)c[k >> 2] = c[k >> 2] | 262144;
	                                if ((c[(c[j >> 2] | 0) + 48 >> 2] & 524288 | 0) != 0 ? (c[k >> 2] & 524288 | 0) == 0 : 0)c[k >> 2] = c[k >> 2] | 524288;
	                                if ((c[j >> 2] | 0) == (c[h >> 2] | 0))break;
	                                c[j >> 2] = c[(c[j >> 2] | 0) + 64 >> 2]
	                            }
	                            if (c[k >> 2] | 0) {
	                                if ((c[k >> 2] & 262144 | 0) != 0 ? (c[l >> 2] & 262144 | 0) != 0 : 0)break;
	                                if ((c[k >> 2] & 524288 | 0) != 0 ? (c[l >> 2] & 524288 | 0) != 0 : 0)break
	                            }
	                        }
	                        OG(c[e >> 2] | 0, c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                        if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 131072)) {
	                            b = (c[g >> 2] | 0) + 48 | 0;
	                            c[b >> 2] = c[b >> 2] | 131072
	                        }
	                    } while (0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 80 >> 2]
	                }
	                i = d;
	                return
	            }

	            function bF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0;
	                d = i;
	                i = i + 128 | 0;
	                e = d + 124 | 0;
	                f = d + 120 | 0;
	                g = d + 116 | 0;
	                h = d + 112 | 0;
	                j = d + 108 | 0;
	                k = d + 104 | 0;
	                l = d + 100 | 0;
	                m = d + 96 | 0;
	                n = d + 92 | 0;
	                o = d + 88 | 0;
	                p = d + 84 | 0;
	                q = d + 80 | 0;
	                r = d + 76 | 0;
	                s = d + 72 | 0;
	                t = d + 68 | 0;
	                u = d + 64 | 0;
	                v = d + 60 | 0;
	                w = d + 56 | 0;
	                x = d + 52 | 0;
	                y = d + 48 | 0;
	                z = d + 44 | 0;
	                A = d + 40 | 0;
	                B = d + 36 | 0;
	                C = d + 32 | 0;
	                D = d + 28 | 0;
	                E = d + 24 | 0;
	                F = d + 20 | 0;
	                G = d + 16 | 0;
	                H = d + 12 | 0;
	                I = d + 8 | 0;
	                J = d + 4 | 0;
	                K = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    xB(c[f >> 2] | 0, 158112, 158144);
	                    c[e >> 2] = 1;
	                    L = c[e >> 2] | 0;
	                    i = d;
	                    return L | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    L = c[e >> 2] | 0;
	                    i = d;
	                    return L | 0
	                }
	                a:do switch (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) {
	                    case 8:
	                    {
	                        c[h >> 2] = 1;
	                        c[I >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                        if (c[I >> 2] | 0) {
	                            c[h >> 2] = 0;
	                            c[G >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                            c[H >> 2] = Iz(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                            Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[H >> 2] | 0) | 0;
	                            c[(c[f >> 2] | 0) + 76 >> 2] = c[H >> 2];
	                            while (1) {
	                                if (!(c[I >> 2] | 0)) {
	                                    M = 103;
	                                    break
	                                }
	                                c[(c[f >> 2] | 0) + 76 >> 2] = c[H >> 2];
	                                c[J >> 2] = c[(c[I >> 2] | 0) + 12 >> 2];
	                                if (!(c[J >> 2] | 0)) {
	                                    M = 93;
	                                    break
	                                }
	                                do if (!(c[(c[J >> 2] | 0) + 48 >> 2] & 131072)) {
	                                    if ((c[(c[I >> 2] | 0) + 16 >> 2] | 0) == 1 ? (c[(c[I >> 2] | 0) + 20 >> 2] | 0) == 1 : 0) {
	                                        Hz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[(c[J >> 2] | 0) + 8 >> 2] | 0, c[(c[J >> 2] | 0) + 52 >> 2] | 0, 1, 1, c[J >> 2] | 0) | 0;
	                                        break
	                                    }
	                                    if ((c[(c[I >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[I >> 2] | 0) + 20 >> 2] | 0) == 1 : 0)Gz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[(c[J >> 2] | 0) + 8 >> 2] | 0, c[(c[J >> 2] | 0) + 52 >> 2] | 0, 0, 1, c[J >> 2] | 0) | 0
	                                } else {
	                                    c[K >> 2] = Lz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[I >> 2] | 0) + 16 >> 2] | 0, c[(c[I >> 2] | 0) + 20 >> 2] | 0) | 0;
	                                    QG(c[f >> 2] | 0, c[I >> 2] | 0, c[K >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0
	                                } while (0);
	                                c[I >> 2] = c[(c[I >> 2] | 0) + 8 >> 2]
	                            }
	                            if ((M | 0) == 93) {
	                                xB(c[f >> 2] | 0, 158112, 158168);
	                                c[e >> 2] = c[h >> 2];
	                                L = c[e >> 2] | 0;
	                                i = d;
	                                return L | 0
	                            } else if ((M | 0) == 103) {
	                                b = Kz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, 0, 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                                if (c[(c[g >> 2] | 0) + 16 >> 2] | 0)break a;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[G >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0;
	                                c[h >> 2] = 1;
	                                break a
	                            }
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        c[m >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        c[k >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                        c[l >> 2] = Iz(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        do if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 1) {
	                            if ((c[(c[m >> 2] | 0) + 28 >> 2] | 0) == 1) {
	                                b = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, 140432, 140432, c[m >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                b = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, 140432, 0, c[m >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                break
	                            }
	                            b = c[m >> 2] | 0;
	                            if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                                c[n >> 2] = c[b + 32 >> 2];
	                                do {
	                                    c[(c[f >> 2] | 0) + 76 >> 2] = c[k >> 2];
	                                    a = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, 0, 140432, c[(c[n >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    c[(c[f >> 2] | 0) + 76 >> 2] = a;
	                                    Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                    c[n >> 2] = c[c[n >> 2] >> 2]
	                                } while ((c[n >> 2] | 0) != 0)
	                            } else {
	                                if (!(c[b + 36 >> 2] | 0))break;
	                                a = Fz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 140432, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = a;
	                                break
	                            }
	                        } else {
	                            if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 1073741824)N = 1073741824; else N = (c[(c[g >> 2] | 0) + 20 >> 2] | 0) - 1 | 0;
	                            c[q >> 2] = N;
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) < 1)O = 0; else O = (c[(c[g >> 2] | 0) + 16 >> 2] | 0) - 1 | 0;
	                            c[r >> 2] = O;
	                            c[o >> 2] = Lz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[r >> 2] | 0, c[q >> 2] | 0) | 0;
	                            c[p >> 2] = Iz(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                            do if ((c[(c[m >> 2] | 0) + 28 >> 2] | 0) != 1) {
	                                a = c[m >> 2] | 0;
	                                if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                                    c[n >> 2] = c[a + 32 >> 2];
	                                    do {
	                                        P = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, 140432, c[(c[n >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                        c[(c[f >> 2] | 0) + 76 >> 2] = P;
	                                        Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[p >> 2] | 0) | 0;
	                                        c[n >> 2] = c[c[n >> 2] >> 2]
	                                    } while ((c[n >> 2] | 0) != 0)
	                                } else {
	                                    if (!(c[a + 36 >> 2] | 0))break;
	                                    P = Fz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[p >> 2] | 0, 140432, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    c[(c[f >> 2] | 0) + 76 >> 2] = P;
	                                    break
	                                }
	                            } else {
	                                P = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, 140432, 140432, c[m >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = P;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[p >> 2] | 0) | 0;
	                                P = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, 140432, 0, c[m >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = P;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[p >> 2] | 0) | 0
	                            } while (0);
	                            Mz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[p >> 2] | 0, c[k >> 2] | 0, c[o >> 2] | 0) | 0;
	                            Nz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[p >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0
	                        } while (0);
	                        if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0)) {
	                            Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                            c[h >> 2] = 1
	                        }
	                        c[(c[f >> 2] | 0) + 76 >> 2] = c[l >> 2];
	                        break
	                    }
	                    case 14:
	                    {
	                        c[h >> 2] = PG(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[h >> 2] = 1;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[h >> 2] = 0;
	                        c[z >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                        c[A >> 2] = Iz(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        b = c[g >> 2] | 0;
	                        b:do if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 1) {
	                            if ((c[b + 20 >> 2] | 0) == 1073741824)Q = 1073741824; else Q = (c[(c[g >> 2] | 0) + 20 >> 2] | 0) - 1 | 0;
	                            c[E >> 2] = Q;
	                            if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) < 1)R = 0; else R = (c[(c[g >> 2] | 0) + 16 >> 2] | 0) - 1 | 0;
	                            c[F >> 2] = R;
	                            c[B >> 2] = Lz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[F >> 2] | 0, c[E >> 2] | 0) | 0;
	                            c[C >> 2] = Iz(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                            c[D >> 2] = Iz(c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                            c[y >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[y >> 2] | 0))break;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = c[D >> 2];
	                                c[j >> 2] = bF(c[f >> 2] | 0, c[y >> 2] | 0) | 0;
	                                if ((c[j >> 2] | 0) == 1)c[h >> 2] = 1;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[C >> 2] | 0) | 0;
	                                c[y >> 2] = c[(c[y >> 2] | 0) + 8 >> 2]
	                            }
	                            Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[z >> 2] | 0, c[D >> 2] | 0) | 0;
	                            Mz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[C >> 2] | 0, c[D >> 2] | 0, c[B >> 2] | 0) | 0;
	                            Nz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[C >> 2] | 0, c[A >> 2] | 0, c[B >> 2] | 0) | 0;
	                            if ((c[h >> 2] | 0) == 1)Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[D >> 2] | 0, c[A >> 2] | 0) | 0
	                        } else {
	                            c[y >> 2] = c[(c[b + 12 >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[y >> 2] | 0))break b;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = c[z >> 2];
	                                c[j >> 2] = bF(c[f >> 2] | 0, c[y >> 2] | 0) | 0;
	                                if ((c[j >> 2] | 0) == 1)c[h >> 2] = 1;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[A >> 2] | 0) | 0;
	                                c[y >> 2] = c[(c[y >> 2] | 0) + 8 >> 2]
	                            }
	                        } while (0);
	                        if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0)) {
	                            Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[z >> 2] | 0, c[A >> 2] | 0) | 0;
	                            c[h >> 2] = 1
	                        }
	                        c[(c[f >> 2] | 0) + 76 >> 2] = c[A >> 2];
	                        break
	                    }
	                    case 6:
	                    {
	                        c[h >> 2] = 1;
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 1 : 0) {
	                            c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[s >> 2] | 0))break a;
	                                c[j >> 2] = bF(c[f >> 2] | 0, c[s >> 2] | 0) | 0;
	                                if ((c[j >> 2] | 0) != 1)c[h >> 2] = 0;
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 8 >> 2]
	                            }
	                        }
	                        c[t >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                        b = c[g >> 2] | 0;
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >= 1073741824) {
	                            P = (c[b + 16 >> 2] | 0) > 1;
	                            S = Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, 0) | 0;
	                            c[(c[f >> 2] | 0) + 76 >> 2] = S;
	                            c[t >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                            if (P) {
	                                c[v >> 2] = Lz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, (c[(c[g >> 2] | 0) + 16 >> 2] | 0) - 1 | 0, 1073741824) | 0;
	                                c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                                while (1) {
	                                    T = c[f >> 2] | 0;
	                                    if (!(c[s >> 2] | 0))break;
	                                    c[j >> 2] = bF(T, c[s >> 2] | 0) | 0;
	                                    if ((c[j >> 2] | 0) != 1)c[h >> 2] = 0;
	                                    c[s >> 2] = c[(c[s >> 2] | 0) + 8 >> 2]
	                                }
	                                c[u >> 2] = c[T + 76 >> 2];
	                                Mz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[u >> 2] | 0, c[t >> 2] | 0, c[v >> 2] | 0) | 0;
	                                P = Nz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[u >> 2] | 0, 0, c[v >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = P;
	                                if ((c[h >> 2] | 0) != 1)break a;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0;
	                                break a
	                            } else {
	                                c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                                while (1) {
	                                    U = c[f >> 2] | 0;
	                                    if (!(c[s >> 2] | 0))break;
	                                    c[j >> 2] = bF(U, c[s >> 2] | 0) | 0;
	                                    if ((c[j >> 2] | 0) != 1)c[h >> 2] = 0;
	                                    c[s >> 2] = c[(c[s >> 2] | 0) + 8 >> 2]
	                                }
	                                Jz(c[U + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[t >> 2] | 0) | 0;
	                                P = Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, 0) | 0;
	                                c[(c[f >> 2] | 0) + 76 >> 2] = P;
	                                if (c[(c[g >> 2] | 0) + 16 >> 2] | 0)break a;
	                                Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0;
	                                c[h >> 2] = 1;
	                                break a
	                            }
	                        }
	                        if ((c[b + 20 >> 2] | 0) <= 1 ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) <= 1 : 0) {
	                            c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                V = c[f >> 2] | 0;
	                                if (!(c[s >> 2] | 0))break;
	                                c[j >> 2] = bF(V, c[s >> 2] | 0) | 0;
	                                if ((c[j >> 2] | 0) != 1)c[h >> 2] = 0;
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 8 >> 2]
	                            }
	                            b = Jz(c[V + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, 0) | 0;
	                            c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                            if (c[(c[g >> 2] | 0) + 16 >> 2] | 0)break a;
	                            Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0;
	                            c[h >> 2] = 1;
	                            break a
	                        }
	                        b = Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, 0) | 0;
	                        c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                        c[t >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                        c[x >> 2] = Lz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, (c[(c[g >> 2] | 0) + 16 >> 2] | 0) - 1 | 0, (c[(c[g >> 2] | 0) + 20 >> 2] | 0) - 1 | 0) | 0;
	                        c[s >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            W = c[f >> 2] | 0;
	                            if (!(c[s >> 2] | 0))break;
	                            c[j >> 2] = bF(W, c[s >> 2] | 0) | 0;
	                            if ((c[j >> 2] | 0) != 1)c[h >> 2] = 0;
	                            c[s >> 2] = c[(c[s >> 2] | 0) + 8 >> 2]
	                        }
	                        c[w >> 2] = c[W + 76 >> 2];
	                        Mz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[w >> 2] | 0, c[t >> 2] | 0, c[x >> 2] | 0) | 0;
	                        b = Nz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[w >> 2] | 0, 0, c[x >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                        if ((c[h >> 2] | 0) == 1 ? 1 : (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0) {
	                            Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0;
	                            c[h >> 2] = 1
	                        }
	                        break
	                    }
	                    default:
	                    {
	                        b = c[f >> 2] | 0;
	                        yC(b, 158112, 158200, MD(c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0, 0);
	                        c[e >> 2] = c[h >> 2];
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                L = c[e >> 2] | 0;
	                i = d;
	                return L | 0
	            }

	            function cF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) > (c[(c[e >> 2] | 0) + 104 >> 2] | 0)) {
	                    xB(a, 155664, 155696);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a:do if (c[a + 100 >> 2] | 0) {
	                    j = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 104 >> 2] | 0) > (c[(c[e >> 2] | 0) + 96 >> 2] | 0)) {
	                        c[f >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[j + 96 >> 2] << 2) >> 2];
	                        break
	                    }
	                    c[g >> 2] = c[j + 104 >> 2];
	                    j = (c[e >> 2] | 0) + 104 | 0;
	                    c[j >> 2] = c[j >> 2] << 1;
	                    j = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 100 >> 2] | 0, c[(c[e >> 2] | 0) + 104 >> 2] << 2) | 0;
	                    c[(c[e >> 2] | 0) + 100 >> 2] = j;
	                    if (!(c[(c[e >> 2] | 0) + 100 >> 2] | 0)) {
	                        IB(c[e >> 2] | 0, 155768, 0);
	                        c[d >> 2] = 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    } else while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[e >> 2] | 0) + 104 >> 2] | 0))break a;
	                        c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[g >> 2] << 2) >> 2] = 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                } else {
	                    j = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[e >> 2] | 0) + 100 >> 2] = j;
	                    j = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 100 >> 2] | 0) {
	                        k = (c[j + 100 >> 2] | 0) + 0 | 0;
	                        l = k + 40 | 0;
	                        do {
	                            c[k >> 2] = 0;
	                            k = k + 4 | 0
	                        } while ((k | 0) < (l | 0));
	                        c[(c[e >> 2] | 0) + 104 >> 2] = 10;
	                        break
	                    }
	                    IB(j, 155728, 0);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } while (0);
	                do if (c[f >> 2] | 0) {
	                    if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                        xB(c[e >> 2] | 0, 155664, 155840);
	                        c[d >> 2] = 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                } else {
	                    c[f >> 2] = Cb[c[135744 >> 2] & 511](84) | 0;
	                    if (c[f >> 2] | 0) {
	                        c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2] = c[f >> 2];
	                        break
	                    }
	                    IB(c[e >> 2] | 0, 155808, 0);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } while (0);
	                k = (c[f >> 2] | 0) + 0 | 0;
	                l = k + 84 | 0;
	                do {
	                    c[k >> 2] = 0;
	                    k = k + 4 | 0
	                } while ((k | 0) < (l | 0));
	                c[c[f >> 2] >> 2] = 1;
	                c[(c[f >> 2] | 0) + 48 >> 2] = c[(c[e >> 2] | 0) + 96 >> 2];
	                c[d >> 2] = c[f >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function dF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                do if (!(c[(c[e >> 2] | 0) + 164 >> 2] | 0)) {
	                    a = Cb[c[135744 >> 2] & 511](4) | 0;
	                    c[(c[e >> 2] | 0) + 164 >> 2] = a;
	                    c[(c[e >> 2] | 0) + 172 >> 2] = 1;
	                    if (!(c[(c[e >> 2] | 0) + 164 >> 2] | 0)) {
	                        IB(c[e >> 2] | 0, 145800, 0);
	                        c[d >> 2] = 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                } else {
	                    a = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) <= (c[(c[e >> 2] | 0) + 168 >> 2] | 0)) {
	                        h = a + 172 | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        h = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 164 >> 2] | 0, c[(c[e >> 2] | 0) + 172 >> 2] << 2) | 0;
	                        c[(c[e >> 2] | 0) + 164 >> 2] = h;
	                        if (c[(c[e >> 2] | 0) + 164 >> 2] | 0)break;
	                        IB(c[e >> 2] | 0, 145832, 0);
	                        c[d >> 2] = 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    h = a + 168 | 0;
	                    a = c[h >> 2] | 0;
	                    c[h >> 2] = a + 1;
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 164 >> 2] | 0) + (a << 2) >> 2];
	                    if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                        xB(c[e >> 2] | 0, 145872, 145904);
	                        c[d >> 2] = 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    } else {
	                        c[c[f >> 2] >> 2] = 2;
	                        c[d >> 2] = c[f >> 2];
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                } while (0);
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    IB(c[e >> 2] | 0, 145928, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 60 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[c[f >> 2] >> 2] = 2;
	                    a = c[f >> 2] | 0;
	                    h = (c[e >> 2] | 0) + 168 | 0;
	                    j = c[h >> 2] | 0;
	                    c[h >> 2] = j + 1;
	                    c[(c[(c[e >> 2] | 0) + 164 >> 2] | 0) + (j << 2) >> 2] = a;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function eF(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b + 32 | 0;
	                f = b + 28 | 0;
	                g = b + 24 | 0;
	                h = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = RG(c[f >> 2] | 0, 3) | 0;
	                if (!(c[n >> 2] | 0))c[n >> 2] = RG(c[f >> 2] | 0, 4) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = b;
	                    return o | 0
	                }
	                c[g >> 2] = c[(c[n >> 2] | 0) + 20 >> 2];
	                do {
	                    if ((c[(c[n >> 2] | 0) + 48 >> 2] | 0) == 3) {
	                        while (1) {
	                            do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)p = 1; else {
	                                if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    p = 1;
	                                    break
	                                }
	                                p = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            q = c[g >> 2] | 0;
	                            if (!p)break;
	                            c[g >> 2] = q + 1
	                        }
	                        c[h >> 2] = q;
	                        while (1) {
	                            if (d[c[h >> 2] >> 0] | 0) {
	                                do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)r = 1; else {
	                                    if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        r = 1;
	                                        break
	                                    }
	                                    r = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                s = r ^ 1
	                            } else s = 0;
	                            t = c[h >> 2] | 0;
	                            if (!s)break;
	                            c[h >> 2] = t + 1
	                        }
	                        if ((t | 0) == (c[g >> 2] | 0))break;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        c[j >> 2] = AP(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 60 >> 2] | 0, c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                        c[g >> 2] = c[h >> 2]
	                    }
	                    while (1) {
	                        do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)u = 1; else {
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                u = 1;
	                                break
	                            }
	                            u = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        v = c[g >> 2] | 0;
	                        if (!u)break;
	                        c[g >> 2] = v + 1
	                    }
	                    c[h >> 2] = v;
	                    while (1) {
	                        if (d[c[h >> 2] >> 0] | 0) {
	                            do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)w = 1; else {
	                                if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    w = 1;
	                                    break
	                                }
	                                w = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            x = w ^ 1
	                        } else x = 0;
	                        y = c[h >> 2] | 0;
	                        if (!x)break;
	                        c[h >> 2] = y + 1
	                    }
	                    if ((y | 0) == (c[g >> 2] | 0)) {
	                        z = 40;
	                        break
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    c[k >> 2] = AP(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 60 >> 2] | 0, c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                    c[g >> 2] = c[h >> 2];
	                    c[m >> 2] = SG(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[(c[n >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    if ((c[m >> 2] | 0) == -1) {
	                        z = 43;
	                        break
	                    }
	                } while ((d[c[g >> 2] >> 0] | 0 | 0) != 0);
	                if ((z | 0) == 40) {
	                    if ((c[(c[n >> 2] | 0) + 48 >> 2] | 0) == 3)NC(c[f >> 2] | 0, 1879, c[(c[n >> 2] | 0) + 4 >> 2] | 0, 0, 155136, 0, 0, 0)
	                } else if ((z | 0) == 43) {
	                    xB(c[f >> 2] | 0, 155224, 155248);
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = b;
	                    return o | 0
	                }
	                c[e >> 2] = c[m >> 2];
	                o = c[e >> 2] | 0;
	                i = b;
	                return o | 0
	            }

	            function fF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 96 | 0;
	                d = b + 80 | 0;
	                e = b + 76 | 0;
	                f = b + 72 | 0;
	                g = b + 68 | 0;
	                h = b + 64 | 0;
	                j = b + 60 | 0;
	                k = b + 56 | 0;
	                l = b + 16 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                o = b;
	                c[e >> 2] = a;
	                c[h >> 2] = 0;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) <= 0) {
	                    xB(a, 154576, 154608);
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + ((c[a + 96 >> 2] | 0) - 1 << 2) >> 2];
	                if (c[(c[f >> 2] | 0) + 32 >> 2] & 32) {
	                    a = (c[f >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = c[a >> 2] ^ 32
	                }
	                a:do if (c[(c[f >> 2] | 0) + 32 >> 2] & 4) {
	                    c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) - 1 << 2) >> 2];
	                    c[h >> 2] = 1848;
	                    AB(c[e >> 2] | 0, c[h >> 2] | 0, 0, 0, 154648, 0, 0);
	                    c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2]
	                } else {
	                    c[g >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 88 >> 2] | 0) == 45) {
	                        a = yE(c[(c[e >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] = a;
	                        do if (!(c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] | 0)) {
	                            c[j >> 2] = RG(c[e >> 2] | 0, 1) | 0;
	                            if (!(c[j >> 2] | 0)) {
	                                a = IH(45) | 0;
	                                c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] = a;
	                                break
	                            }
	                            c[h >> 2] = TG(c[e >> 2] | 0, c[j >> 2] | 0, (c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 | 0, 0) | 0;
	                            if (c[h >> 2] | 0)if ((c[h >> 2] | 0) == -1) {
	                                xB(c[e >> 2] | 0, 154576, 154504);
	                                c[d >> 2] = -1;
	                                p = c[d >> 2] | 0;
	                                i = b;
	                                return p | 0
	                            } else {
	                                c[d >> 2] = c[h >> 2];
	                                p = c[d >> 2] | 0;
	                                i = b;
	                                return p | 0
	                            }
	                        } while (0);
	                        c[d >> 2] = 0;
	                        p = c[d >> 2] | 0;
	                        i = b;
	                        return p | 0
	                    }
	                    b:do switch (c[(c[g >> 2] | 0) + 52 >> 2] | 0) {
	                        case 2:
	                        case 3:
	                        {
	                            c[n >> 2] = 10;
	                            if (!(c[(c[g >> 2] | 0) + 108 >> 2] | 0)) {
	                                xB(c[e >> 2] | 0, 154576, 154808);
	                                c[d >> 2] = -1;
	                                p = c[d >> 2] | 0;
	                                i = b;
	                                return p | 0
	                            }
	                            if (c[(c[f >> 2] | 0) + 32 >> 2] & 256) {
	                                xB(c[e >> 2] | 0, 154576, 154856);
	                                c[d >> 2] = -1;
	                                p = c[d >> 2] | 0;
	                                i = b;
	                                return p | 0
	                            }
	                            c[k >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                            do if (!(c[k >> 2] | 0)) {
	                                c[k >> 2] = oz(c[(c[g >> 2] | 0) + 108 >> 2] | 0, 358, c[e >> 2] | 0) | 0;
	                                if (c[k >> 2] | 0) {
	                                    c[(c[f >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                                    break
	                                }
	                                xB(c[e >> 2] | 0, 154576, 141760);
	                                c[d >> 2] = -1;
	                                p = c[d >> 2] | 0;
	                                i = b;
	                                return p | 0
	                            } while (0);
	                            c[h >> 2] = rz(c[k >> 2] | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0, c[(c[e >> 2] | 0) + 108 >> 2] | 0) | 0;
	                            if ((c[(c[e >> 2] | 0) + 52 >> 2] | 0) == 1818) {
	                                xB(c[e >> 2] | 0, 154576, 154912);
	                                c[d >> 2] = -1;
	                                p = c[d >> 2] | 0;
	                                i = b;
	                                return p | 0
	                            }
	                            if ((c[h >> 2] | 0) < 0) {
	                                tz(c[k >> 2] | 0, 0, n, o, l, m) | 0;
	                                mF(c[e >> 2] | 0, 1871, 0, 0, 154944, c[n >> 2] | 0, c[o >> 2] | 0, l);
	                                c[h >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                                break a
	                            } else {
	                                c[h >> 2] = 0;
	                                break b
	                            }
	                            break
	                        }
	                        case 1:
	                        {
	                            c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) - 1 << 2) >> 2];
	                            c[h >> 2] = 1841;
	                            AB(c[e >> 2] | 0, c[h >> 2] | 0, 0, 0, 154736, 0, 0);
	                            c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                            break a;
	                            break
	                        }
	                        case 6:
	                        case 4:
	                        {
	                            c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) - 1 << 2) >> 2];
	                            if ((c[c[g >> 2] >> 2] | 0) != 5 ? (c[(c[g >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                                c[h >> 2] = 1828;
	                                AB(c[e >> 2] | 0, c[h >> 2] | 0, 0, 0, 155064, 0, 0)
	                            } else {
	                                c[h >> 2] = 1842;
	                                AB(c[e >> 2] | 0, c[h >> 2] | 0, 0, 0, 154976, 0, 0)
	                            }
	                            c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                            c[h >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    c[d >> 2] = c[h >> 2];
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } while (0);
	                c[(c[e >> 2] | 0) + 176 >> 2] = c[(c[e >> 2] | 0) + 96 >> 2];
	                g = (c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                c[g >> 2] = c[g >> 2] | 512;
	                g = (c[f >> 2] | 0) + 32 | 0;
	                c[g >> 2] = c[g >> 2] | 256;
	                c[d >> 2] = c[h >> 2];
	                p = c[d >> 2] | 0;
	                i = b;
	                return p | 0
	            }

	            function gF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2];
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[c[h >> 2] >> 2] | 0) == 2 : 0) {
	                    c[c[g >> 2] >> 2] = 0;
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) == 1) {
	                        c[c[g >> 2] >> 2] = 1;
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    c[j >> 2] = 0;
	                    c[j >> 2] = yE(c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2] = c[j >> 2];
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    j = c[f >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) == 3) {
	                        AB(j, 1845, 0, 0, 154416, 0, 0);
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    if ((c[j + 168 >> 2] | 0) != 0 ? (c[k >> 2] = RG(c[f >> 2] | 0, 1) | 0, (c[k >> 2] | 0) != 0) : 0)if ((TG(c[f >> 2] | 0, c[k >> 2] | 0, (c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 28 | 0, 0) | 0) == -1) {
	                        xB(c[f >> 2] | 0, 154368, 154504);
	                        c[e >> 2] = -1;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else {
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    k = IH(45) | 0;
	                    c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] = k;
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                xB(c[f >> 2] | 0, 154368, 154400);
	                c[e >> 2] = -1;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function hF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 44 >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    AB(c[e >> 2] | 0, 1845, 0, 0, 146200, 0, 0);
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                c[g >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                if (c[(c[f >> 2] | 0) + 48 >> 2] & 16) {
	                    AB(c[e >> 2] | 0, 1846, 0, 0, 146240, 0, 0);
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                a = c[e >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    AB(a, 1875, 0, 0, 145096, 0, 0);
	                    c[d >> 2] = 1875;
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                do if (c[a + 168 >> 2] | 0) {
	                    c[j >> 2] = RG(c[e >> 2] | 0, 2) | 0;
	                    do if (c[j >> 2] | 0) {
	                        c[(c[e >> 2] | 0) + 108 >> 2] = c[j >> 2];
	                        m = c[e >> 2] | 0;
	                        n = IH(15) | 0;
	                        c[h >> 2] = yB(m, 0, n, c[(c[j >> 2] | 0) + 20 >> 2] | 0, (c[j >> 2] | 0) + 24 | 0, 1, 0, 0) | 0;
	                        c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                        if ((c[h >> 2] | 0) < 0) {
	                            xB(c[e >> 2] | 0, 146280, 146312);
	                            c[d >> 2] = -1;
	                            l = c[d >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                        if (!(c[h >> 2] | 0)) {
	                            if (!(c[(c[f >> 2] | 0) + 48 >> 2] & 1)) {
	                                AB(c[e >> 2] | 0, 1847, 0, 0, 146392, 0, 0);
	                                break
	                            }
	                            if (MH(c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0) {
	                                if ((c[(c[f >> 2] | 0) + 48 >> 2] & 8 | 0) != 0 ? (c[(c[f >> 2] | 0) + 76 >> 2] | 0) != 0 : 0) {
	                                    AB(c[e >> 2] | 0, 1849, 0, 0, 146424, 0, 0);
	                                    break
	                                }
	                                n = (c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                                c[n >> 2] = c[n >> 2] | 4
	                            }
	                        }
	                    } while (0);
	                    c[j >> 2] = RG(c[e >> 2] | 0, 1) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[k >> 2] = 0;
	                        c[h >> 2] = TG(c[e >> 2] | 0, c[j >> 2] | 0, k, c[f >> 2] | 0) | 0;
	                        if ((c[h >> 2] | 0) != 0 & (c[h >> 2] | 0) == -1) {
	                            xB(c[e >> 2] | 0, 146280, 146512);
	                            c[d >> 2] = -1;
	                            l = c[d >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        } else {
	                            if (!(c[k >> 2] | 0))break;
	                            n = (c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                            c[n >> 2] = c[n >> 2] | 8;
	                            c[g >> 2] = c[k >> 2];
	                            break
	                        }
	                    }
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 100 >> 2] | 0) != 0 ? (UG(c[e >> 2] | 0, c[f >> 2] | 0) | 0) == -1 : 0) {
	                    c[d >> 2] = -1;
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    AB(c[e >> 2] | 0, 1875, 0, 0, 145096, 0, 0);
	                    c[d >> 2] = 1875;
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } else {
	                    c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                    c[d >> 2] = 0;
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                return 0
	            }

	            function iF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 36 | 0;
	                f = d + 32 | 0;
	                g = d + 28 | 0;
	                h = d + 24 | 0;
	                j = d + 20 | 0;
	                k = d + 16 | 0;
	                l = d + 12 | 0;
	                m = d + 8 | 0;
	                n = d + 4 | 0;
	                o = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = c[(c[f >> 2] | 0) + 96 >> 2];
	                if (!(c[(c[f >> 2] | 0) + 116 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                if ((c[g >> 2] | 0) == 2)c[n >> 2] = (c[n >> 2] | 0) + 1;
	                c[k >> 2] = c[(c[f >> 2] | 0) + 116 >> 2];
	                c[h >> 2] = c[k >> 2];
	                a:while (1) {
	                    if ((c[h >> 2] | 0) == (c[j >> 2] | 0)) {
	                        q = 34;
	                        break
	                    }
	                    b = c[(c[h >> 2] | 0) + 32 >> 2] | 0;
	                    a = c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0;
	                    r = c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0;
	                    if ((c[g >> 2] | 0) == 1)c[l >> 2] = HQ(b, a, r) | 0; else c[l >> 2] = JQ(b, a, r) | 0;
	                    if ((c[l >> 2] | 0) == -1) {
	                        q = 11;
	                        break
	                    }
	                    b:do if (c[l >> 2] | 0) {
	                        if (c[(c[h >> 2] | 0) + 12 >> 2] | 0) {
	                            if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) <= (c[(c[h >> 2] | 0) + 16 >> 2] | 0) ? (r = (c[h >> 2] | 0) + 20 | 0, c[r >> 2] = c[r >> 2] << 1, r = Hb[c[135760 >> 2] & 511](c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] << 2) | 0, c[(c[h >> 2] | 0) + 12 >> 2] = r, (c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 0) : 0) {
	                                q = 19;
	                                break a
	                            }
	                        } else {
	                            r = Cb[c[135744 >> 2] & 511](20) | 0;
	                            c[(c[h >> 2] | 0) + 12 >> 2] = r;
	                            if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                                q = 15;
	                                break a
	                            }
	                            c[(c[h >> 2] | 0) + 20 >> 2] = 5
	                        }
	                        r = c[n >> 2] | 0;
	                        a = (c[h >> 2] | 0) + 16 | 0;
	                        b = c[a >> 2] | 0;
	                        c[a >> 2] = b + 1;
	                        c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + (b << 2) >> 2] = r;
	                        r = c[h >> 2] | 0;
	                        if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                            c[o >> 2] = c[(c[(c[(c[r + 24 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 28 >> 2];
	                            while (1) {
	                                if (!(c[o >> 2] | 0))break b;
	                                if ((VG(c[f >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0, c[o >> 2] | 0, 2) | 0) == -1) {
	                                    q = 24;
	                                    break a
	                                }
	                                c[o >> 2] = c[c[o >> 2] >> 2]
	                            }
	                        }
	                        if ((c[r >> 2] | 0) == 2) {
	                            if ((c[m >> 2] | 0) == 0 ? (c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 32 >> 2] & 16 | 0) == 0 : 0) {
	                                b = (c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 32 | 0;
	                                c[b >> 2] = c[b >> 2] | 16
	                            }
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[j >> 2] = c[k >> 2];
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 116 >> 2];
	                        continue
	                    } else {
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                        continue
	                    }
	                }
	                if ((q | 0) == 11) {
	                    xB(c[f >> 2] | 0, 145960, 145984);
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((q | 0) == 15) {
	                    IB(0, 146008, 0);
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((q | 0) == 19) {
	                    IB(0, 146048, 0);
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((q | 0) == 24) {
	                    c[e >> 2] = -1;
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((q | 0) == 34) {
	                    c[e >> 2] = c[m >> 2];
	                    p = c[e >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                return 0
	            }

	            function jF(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0;
	                b = i;
	                i = i + 128 | 0;
	                e = b;
	                f = b + 100 | 0;
	                g = b + 96 | 0;
	                h = b + 92 | 0;
	                j = b + 88 | 0;
	                k = b + 84 | 0;
	                l = b + 80 | 0;
	                m = b + 76 | 0;
	                n = b + 72 | 0;
	                o = b + 68 | 0;
	                p = b + 64 | 0;
	                q = b + 60 | 0;
	                r = b + 56 | 0;
	                s = b + 52 | 0;
	                t = b + 48 | 0;
	                u = b + 44 | 0;
	                v = b + 40 | 0;
	                w = b + 36 | 0;
	                x = b + 32 | 0;
	                y = b + 28 | 0;
	                z = b + 24 | 0;
	                A = b + 20 | 0;
	                B = b + 16 | 0;
	                C = b + 104 | 0;
	                D = b + 12 | 0;
	                E = b + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = c[(c[(c[g >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2];
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[t >> 2] = 0;
	                c[v >> 2] = 0;
	                c[x >> 2] = 0;
	                c[j >> 2] = c[(c[h >> 2] | 0) + 116 >> 2];
	                c[r >> 2] = c[(c[g >> 2] | 0) + 168 >> 2];
	                if (c[j >> 2] | 0)c[s >> 2] = c[(c[j >> 2] | 0) + 4 >> 2]; else c[s >> 2] = 0;
	                c[o >> 2] = 0;
	                a:while (1) {
	                    if ((c[o >> 2] | 0) >= (c[s >> 2] | 0)) {
	                        F = 26;
	                        break
	                    }
	                    c[q >> 2] = 0;
	                    c[k >> 2] = c[(c[c[j >> 2] >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                    c[l >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    c[p >> 2] = 0;
	                    while (1) {
	                        if ((c[p >> 2] | 0) >= (c[r >> 2] | 0))break;
	                        c[m >> 2] = c[(c[(c[g >> 2] | 0) + 164 >> 2] | 0) + (c[p >> 2] << 2) >> 2];
	                        if ((((c[(c[m >> 2] | 0) + 48 >> 2] | 0) == 0 ? (d[c[(c[m >> 2] | 0) + 12 >> 2] >> 0] | 0 | 0) == (d[c[(c[l >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) : 0) ? (qy(c[(c[m >> 2] | 0) + 12 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 16 >> 2] | 0, c[(c[l >> 2] | 0) + 56 >> 2] | 0) | 0) != 0 : 0) {
	                            F = 12;
	                            break
	                        }
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    if ((F | 0) == 12) {
	                        F = 0;
	                        c[q >> 2] = 1;
	                        c[(c[m >> 2] | 0) + 44 >> 2] = 2;
	                        c[(c[m >> 2] | 0) + 40 >> 2] = c[k >> 2];
	                        c[(c[m >> 2] | 0) + 36 >> 2] = c[l >> 2];
	                        c[(c[m >> 2] | 0) + 28 >> 2] = c[(c[l >> 2] | 0) + 48 >> 2]
	                    }
	                    do if (!(c[q >> 2] | 0)) {
	                        if ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) == 1) {
	                            c[n >> 2] = dF(c[g >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0)) {
	                                F = 17;
	                                break a
	                            }
	                            c[(c[n >> 2] | 0) + 44 >> 2] = 4;
	                            c[(c[n >> 2] | 0) + 40 >> 2] = c[k >> 2];
	                            c[(c[n >> 2] | 0) + 36 >> 2] = c[l >> 2];
	                            break
	                        }
	                        if ((c[(c[k >> 2] | 0) + 24 >> 2] | 0) == 2) {
	                            if ((c[(c[k >> 2] | 0) + 28 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 44 >> 2] | 0) == 0 : 0)break;
	                            c[n >> 2] = dF(c[g >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0)) {
	                                F = 23;
	                                break a
	                            }
	                            c[(c[n >> 2] | 0) + 44 >> 2] = 8;
	                            c[(c[n >> 2] | 0) + 40 >> 2] = c[k >> 2];
	                            c[(c[n >> 2] | 0) + 36 >> 2] = c[l >> 2];
	                            c[(c[n >> 2] | 0) + 28 >> 2] = c[(c[l >> 2] | 0) + 48 >> 2];
	                            c[(c[n >> 2] | 0) + 12 >> 2] = c[(c[l >> 2] | 0) + 8 >> 2];
	                            c[(c[n >> 2] | 0) + 16 >> 2] = c[(c[l >> 2] | 0) + 56 >> 2]
	                        }
	                    } while (0);
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                if ((F | 0) == 17) {
	                    xB(c[g >> 2] | 0, 145272, 145304);
	                    c[f >> 2] = -1;
	                    G = c[f >> 2] | 0;
	                    i = b;
	                    return G | 0
	                } else if ((F | 0) == 23) {
	                    xB(c[g >> 2] | 0, 145272, 145304);
	                    c[f >> 2] = -1;
	                    G = c[f >> 2] | 0;
	                    i = b;
	                    return G | 0
	                } else if ((F | 0) == 26) {
	                    if (!(c[(c[g >> 2] | 0) + 168 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        G = c[f >> 2] | 0;
	                        i = b;
	                        return G | 0
	                    }
	                    b:do if (c[(c[h >> 2] | 0) + 84 >> 2] | 0) {
	                        c[o >> 2] = 0;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[r >> 2] | 0))break b;
	                            c[m >> 2] = c[(c[(c[g >> 2] | 0) + 164 >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                            c:do if ((c[(c[m >> 2] | 0) + 44 >> 2] | 0) == 1 ? (DG(c[(c[h >> 2] | 0) + 84 >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0) == 0 : 0) {
	                                if ((c[(c[(c[h >> 2] | 0) + 84 >> 2] | 0) + 24 >> 2] | 0) == 1) {
	                                    c[(c[m >> 2] | 0) + 44 >> 2] = 13;
	                                    break
	                                }
	                                l = BE(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[m >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[(c[m >> 2] | 0) + 36 >> 2] = l;
	                                if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                                    l = (c[m >> 2] | 0) + 44 | 0;
	                                    if ((c[(c[(c[h >> 2] | 0) + 84 >> 2] | 0) + 24 >> 2] | 0) == 2) {
	                                        c[l >> 2] = 14;
	                                        break
	                                    } else {
	                                        c[l >> 2] = 10;
	                                        break
	                                    }
	                                }
	                                c[(c[m >> 2] | 0) + 44 >> 2] = 2;
	                                c[(c[m >> 2] | 0) + 28 >> 2] = c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 48 >> 2];
	                                if (SE(c[(c[m >> 2] | 0) + 28 >> 2] | 0, 23) | 0) {
	                                    if (c[v >> 2] | 0) {
	                                        c[(c[m >> 2] | 0) + 44 >> 2] = 15;
	                                        l = c[33976] | 0;
	                                        n = c[33980] | 0;
	                                        c[e >> 2] = 140328;
	                                        c[e + 4 >> 2] = 25406;
	                                        Db[l & 511](n, 140296, e);
	                                        break
	                                    }
	                                    c[v >> 2] = (c[v >> 2] | 0) + 1;
	                                    if (c[j >> 2] | 0) {
	                                        c[p >> 2] = 0;
	                                        while (1) {
	                                            if ((c[p >> 2] | 0) >= (c[(c[j >> 2] | 0) + 4 >> 2] | 0))break c;
	                                            if (SE(c[(c[(c[(c[c[j >> 2] >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, 23) | 0)break;
	                                            c[p >> 2] = (c[p >> 2] | 0) + 1
	                                        }
	                                        c[(c[m >> 2] | 0) + 44 >> 2] = 16;
	                                        n = c[33976] | 0;
	                                        l = c[33980] | 0;
	                                        c[e >> 2] = 140328;
	                                        c[e + 4 >> 2] = 25424;
	                                        Db[n & 511](l, 140296, e)
	                                    }
	                                }
	                            } while (0);
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    if (!(c[(c[g >> 2] | 0) + 168 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        G = c[f >> 2] | 0;
	                        i = b;
	                        return G | 0
	                    }
	                    if ((((c[(c[g >> 2] | 0) + 80 >> 2] & 1 | 0) != 0 ? (c[y >> 2] = c[(c[(c[g >> 2] | 0) + 100 >> 2] | 0) + (c[(c[g >> 2] | 0) + 96 >> 2] << 2) >> 2], (c[y >> 2] | 0) != 0) : 0) ? (c[(c[y >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[(c[y >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)c[x >> 2] = c[(c[y >> 2] | 0) + 4 >> 2];
	                    c[o >> 2] = 0;
	                    d:while (1) {
	                        if ((c[o >> 2] | 0) >= (c[(c[g >> 2] | 0) + 168 >> 2] | 0)) {
	                            F = 124;
	                            break
	                        }
	                        c[m >> 2] = c[(c[(c[g >> 2] | 0) + 164 >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                        if (!((c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 2 ? (c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 8 : 0))F = 60;
	                        do if ((F | 0) == 60) {
	                            F = 0;
	                            y = c[m >> 2] | 0;
	                            if (!(c[(c[m >> 2] | 0) + 28 >> 2] | 0)) {
	                                c[y + 44 >> 2] = 6;
	                                break
	                            }
	                            c[(c[g >> 2] | 0) + 108 >> 2] = y;
	                            c[w >> 2] = 0;
	                            c[t >> 2] = 0;
	                            if ((c[(c[g >> 2] | 0) + 116 >> 2] | 0) != 0 ? (c[t >> 2] = iF(c[g >> 2] | 0, 2) | 0, (c[t >> 2] | 0) == -1) : 0) {
	                                F = 64;
	                                break d
	                            }
	                            e:do if ((c[(c[m >> 2] | 0) + 44 >> 2] | 0) == 8) {
	                                if ((c[t >> 2] | 0) != 0 | (c[x >> 2] | 0) != 0) {
	                                    y = c[m >> 2] | 0;
	                                    if (c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 28 >> 2] | 0) {
	                                        c[(c[m >> 2] | 0) + 20 >> 2] = c[(c[y + 40 >> 2] | 0) + 28 >> 2];
	                                        c[(c[m >> 2] | 0) + 24 >> 2] = c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 32 >> 2]
	                                    } else {
	                                        c[(c[m >> 2] | 0) + 20 >> 2] = c[(c[y + 36 >> 2] | 0) + 44 >> 2];
	                                        c[(c[m >> 2] | 0) + 24 >> 2] = c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 68 >> 2]
	                                    }
	                                    if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0)) {
	                                        F = 71;
	                                        break d
	                                    }
	                                    y = WH(c[(c[m >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                    c[(c[m >> 2] | 0) + 24 >> 2] = y;
	                                    if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0)) {
	                                        F = 73;
	                                        break d
	                                    }
	                                }
	                                if (c[x >> 2] | 0) {
	                                    c[A >> 2] = c[(c[m >> 2] | 0) + 20 >> 2];
	                                    c[z >> 2] = zC(c[(c[m >> 2] | 0) + 28 >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0) | 0;
	                                    if (c[z >> 2] | 0)c[A >> 2] = c[z >> 2];
	                                    y = c[x >> 2] | 0;
	                                    if (!(c[(c[m >> 2] | 0) + 16 >> 2] | 0)) {
	                                        if (!($h(y, c[(c[m >> 2] | 0) + 12 >> 2] | 0, c[A >> 2] | 0) | 0)) {
	                                            F = 79;
	                                            break d
	                                        }
	                                    } else {
	                                        c[B >> 2] = Ri(c[y + 32 >> 2] | 0, c[x >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                        if (!(c[B >> 2] | 0)) {
	                                            c[D >> 2] = 0;
	                                            do {
	                                                y = c[D >> 2] | 0;
	                                                c[D >> 2] = y + 1;
	                                                c[e >> 2] = y;
	                                                JT(C, 12, 145464, e) | 0;
	                                                c[B >> 2] = cj(c[(c[x >> 2] | 0) + 32 >> 2] | 0, c[x >> 2] | 0, C) | 0;
	                                                if ((c[D >> 2] | 0) > 1e3) {
	                                                    F = 84;
	                                                    break d
	                                                }
	                                            } while ((c[B >> 2] | 0) != 0);
	                                            c[B >> 2] = Ih(c[(c[g >> 2] | 0) + 84 >> 2] | 0, c[(c[m >> 2] | 0) + 16 >> 2] | 0, C) | 0
	                                        }
	                                        ai(c[x >> 2] | 0, c[B >> 2] | 0, c[(c[m >> 2] | 0) + 12 >> 2] | 0, c[A >> 2] | 0) | 0
	                                    }
	                                    if (c[z >> 2] | 0)zb[c[135736 >> 2] & 511](c[z >> 2] | 0)
	                                }
	                            } else {
	                                if (c[(c[g >> 2] | 0) + 72 >> 2] | 0) {
	                                    PH(c[(c[g >> 2] | 0) + 72 >> 2] | 0);
	                                    c[(c[g >> 2] | 0) + 72 >> 2] = 0
	                                }
	                                do if (c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 60 >> 2] & 512)F = 96; else {
	                                    if ((c[(c[m >> 2] | 0) + 40 >> 2] | 0) != 0 ? (c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 16 >> 2] & 512 | 0) != 0 : 0) {
	                                        F = 96;
	                                        break
	                                    }
	                                    c[w >> 2] = 0
	                                } while (0);
	                                if ((F | 0) == 96) {
	                                    F = 0;
	                                    c[w >> 2] = 1
	                                }
	                                if ((c[t >> 2] | 0) != 0 | (c[w >> 2] | 0) != 0) {
	                                    y = (c[m >> 2] | 0) + 32 | 0;
	                                    c[y >> 2] = c[y >> 2] | 16;
	                                    c[u >> 2] = yB(c[g >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[(c[m >> 2] | 0) + 28 >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0, (c[m >> 2] | 0) + 24 | 0, 1, 1, 0) | 0
	                                } else c[u >> 2] = yB(c[g >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[(c[m >> 2] | 0) + 28 >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0, 0, 1, 0, 0) | 0;
	                                if (c[u >> 2] | 0) {
	                                    if ((c[u >> 2] | 0) == -1) {
	                                        F = 103;
	                                        break d
	                                    }
	                                    c[(c[m >> 2] | 0) + 44 >> 2] = 5;
	                                    break
	                                }
	                                if (c[w >> 2] | 0) {
	                                    if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0)) {
	                                        y = c[33976] | 0;
	                                        p = c[33980] | 0;
	                                        c[e >> 2] = 140328;
	                                        c[e + 4 >> 2] = 25678;
	                                        Db[y & 511](p, 140296, e);
	                                        break
	                                    }
	                                    do if (c[(c[m >> 2] | 0) + 40 >> 2] | 0) {
	                                        if (!(c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 28 >> 2] | 0))break;
	                                        if (!(c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 32 >> 2] | 0)) {
	                                            p = c[33976] | 0;
	                                            y = c[33980] | 0;
	                                            c[e >> 2] = 140328;
	                                            c[e + 4 >> 2] = 25685;
	                                            Db[p & 511](y, 140296, e);
	                                            break e
	                                        }
	                                        c[(c[m >> 2] | 0) + 52 >> 2] = c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 28 >> 2];
	                                        if (VD(c[(c[m >> 2] | 0) + 24 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 40 >> 2] | 0) + 32 >> 2] | 0) | 0)break e;
	                                        c[(c[m >> 2] | 0) + 44 >> 2] = 7;
	                                        break e
	                                    } while (0);
	                                    if (!(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 68 >> 2] | 0)) {
	                                        y = c[33976] | 0;
	                                        p = c[33980] | 0;
	                                        c[e >> 2] = 140328;
	                                        c[e + 4 >> 2] = 25700;
	                                        Db[y & 511](p, 140296, e);
	                                        break
	                                    }
	                                    c[(c[m >> 2] | 0) + 52 >> 2] = c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2];
	                                    if (VD(c[(c[m >> 2] | 0) + 24 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 68 >> 2] | 0) | 0)break;
	                                    c[(c[m >> 2] | 0) + 44 >> 2] = 7
	                                }
	                            } while (0);
	                            p = c[g >> 2] | 0;
	                            if (c[t >> 2] | 0)if ((pF(p, (c[(c[g >> 2] | 0) + 96 >> 2] | 0) + 1 | 0) | 0) == -1) {
	                                F = 120;
	                                break d
	                            } else break;
	                            if (c[p + 116 >> 2] | 0)WG(c[g >> 2] | 0) | 0
	                        } while (0);
	                        c[o >> 2] = (c[o >> 2] | 0) + 1
	                    }
	                    if ((F | 0) == 64)xB(c[g >> 2] | 0, 145272, 145160); else if ((F | 0) == 71)xB(c[g >> 2] | 0, 145272, 145344); else if ((F | 0) == 73)xB(c[g >> 2] | 0, 145272, 145408); else if ((F | 0) == 79) {
	                        xB(c[g >> 2] | 0, 145272, 145440);
	                        if (c[z >> 2] | 0)zb[c[135736 >> 2] & 511](c[z >> 2] | 0)
	                    } else if ((F | 0) == 84) {
	                        xB(c[g >> 2] | 0, 145272, 145472);
	                        if (c[z >> 2] | 0)zb[c[135736 >> 2] & 511](c[z >> 2] | 0)
	                    } else if ((F | 0) == 103)xB(c[g >> 2] | 0, 145272, 145536); else if ((F | 0) == 120)xB(c[g >> 2] | 0, 145272, 145160); else if ((F | 0) == 124) {
	                        c[o >> 2] = 0;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[(c[g >> 2] | 0) + 168 >> 2] | 0))break;
	                            c[m >> 2] = c[(c[(c[g >> 2] | 0) + 164 >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                            f:do if ((((c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 17 ? (c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 2 : 0) ? (c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 13 : 0) ? (c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 14 : 0) {
	                                c[(c[g >> 2] | 0) + 108 >> 2] = c[m >> 2];
	                                switch (c[(c[m >> 2] | 0) + 44 >> 2] | 0) {
	                                    case 6:
	                                    {
	                                        AB(c[g >> 2] | 0, 1862, 0, 0, 145096, 0, 0);
	                                        break f;
	                                        break
	                                    }
	                                    case 4:
	                                    {
	                                        c[E >> 2] = 0;
	                                        c[(c[g >> 2] | 0) + 108 >> 2] = c[(c[(c[g >> 2] | 0) + 100 >> 2] | 0) + (c[(c[g >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                                        AB(c[g >> 2] | 0, 1868, 0, 0, 145592, BB(E, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0, 0);
	                                        if (!(c[E >> 2] | 0))break f;
	                                        zb[c[135736 >> 2] & 511](c[E >> 2] | 0);
	                                        c[E >> 2] = 0;
	                                        break f;
	                                        break
	                                    }
	                                    case 7:
	                                    {
	                                        AB(c[g >> 2] | 0, 1874, 0, 0, 145640, c[(c[m >> 2] | 0) + 20 >> 2] | 0, c[(c[m >> 2] | 0) + 52 >> 2] | 0);
	                                        break f;
	                                        break
	                                    }
	                                    case 10:
	                                    {
	                                        AB(c[g >> 2] | 0, 1878, 0, 0, 145704, 0, 0);
	                                        break f;
	                                        break
	                                    }
	                                    case 1:
	                                    {
	                                        if (c[(c[m >> 2] | 0) + 48 >> 2] | 0)break f;
	                                        F = c[g >> 2] | 0;
	                                        z = c[m >> 2] | 0;
	                                        if (!(c[(c[h >> 2] | 0) + 84 >> 2] | 0)) {
	                                            XG(F, 1866, z, 0);
	                                            break f
	                                        } else {
	                                            XG(F, 1867, z, 0);
	                                            break f
	                                        }
	                                        break
	                                    }
	                                    default:
	                                        break f
	                                }
	                            } while (0);
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                        c[(c[g >> 2] | 0) + 108 >> 2] = c[(c[(c[g >> 2] | 0) + 100 >> 2] | 0) + (c[(c[g >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                        c[f >> 2] = 0;
	                        G = c[f >> 2] | 0;
	                        i = b;
	                        return G | 0
	                    }
	                    c[(c[g >> 2] | 0) + 108 >> 2] = c[(c[(c[g >> 2] | 0) + 100 >> 2] | 0) + (c[(c[g >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                    c[f >> 2] = -1;
	                    G = c[f >> 2] | 0;
	                    i = b;
	                    return G | 0
	                }
	                return 0
	            }

	            function kF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                if (!(c[(c[e >> 2] | 0) + 168 >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    if ((c[h >> 2] | 0) >= (c[(c[e >> 2] | 0) + 168 >> 2] | 0))break;
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 164 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                    if (!(c[(c[f >> 2] | 0) + 48 >> 2] | 0)) {
	                        c[(c[e >> 2] | 0) + 108 >> 2] = c[f >> 2];
	                        XG(c[e >> 2] | 0, 1827, c[f >> 2] | 0, 0);
	                        c[g >> 2] = 1827
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                c[(c[e >> 2] | 0) + 108 >> 2] = c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                c[d >> 2] = c[g >> 2];
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function lF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 4 | 0;
	                h = f;
	                c[f + 12 >> 2] = a;
	                c[f + 8 >> 2] = b;
	                c[g >> 2] = d;
	                c[h >> 2] = e;
	                c[(c[h >> 2] | 0) + 44 >> 2] = c[g >> 2];
	                i = f;
	                return
	            }

	            function mF(a, b, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                l = i;
	                i = i + 64 | 0;
	                m = l + 56 | 0;
	                n = l + 52 | 0;
	                o = l + 48 | 0;
	                p = l + 40 | 0;
	                q = l + 36 | 0;
	                r = l + 32 | 0;
	                s = l + 28 | 0;
	                t = l + 24 | 0;
	                u = l + 20 | 0;
	                v = l + 16 | 0;
	                w = l + 12 | 0;
	                x = l + 8 | 0;
	                y = l + 4 | 0;
	                z = l;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = e;
	                c[l + 44 >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = j;
	                c[s >> 2] = k;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                HC(u, c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[u >> 2] = By(c[u >> 2] | 0, c[p >> 2] | 0) | 0;
	                c[u >> 2] = By(c[u >> 2] | 0, 144352) | 0;
	                if (((c[q >> 2] | 0) + (c[r >> 2] | 0) | 0) <= 0) {
	                    c[u >> 2] = By(c[u >> 2] | 0, 140352) | 0;
	                    A = c[m >> 2] | 0;
	                    B = c[n >> 2] | 0;
	                    C = c[o >> 2] | 0;
	                    D = c[u >> 2] | 0;
	                    PD(A, B, C, D, 0, 0);
	                    E = c[33934] | 0;
	                    F = c[u >> 2] | 0;
	                    zb[E & 511](F);
	                    i = l;
	                    return
	                }
	                if (((c[q >> 2] | 0) + (c[r >> 2] | 0) | 0) > 1)c[t >> 2] = my(144360) | 0; else c[t >> 2] = my(144384) | 0;
	                c[w >> 2] = 0;
	                c[z >> 2] = 0;
	                while (1) {
	                    if ((c[z >> 2] | 0) >= ((c[q >> 2] | 0) + (c[r >> 2] | 0) | 0))break;
	                    c[x >> 2] = c[(c[s >> 2] | 0) + (c[z >> 2] << 2) >> 2];
	                    do if (c[x >> 2] | 0) {
	                        if ((((d[c[x >> 2] >> 0] | 0 | 0) == 110 ? (d[(c[x >> 2] | 0) + 1 >> 0] | 0 | 0) == 111 : 0) ? (d[(c[x >> 2] | 0) + 2 >> 0] | 0 | 0) == 116 : 0) ? (d[(c[x >> 2] | 0) + 3 >> 0] | 0 | 0) == 32 : 0) {
	                            c[x >> 2] = (c[x >> 2] | 0) + 4;
	                            c[t >> 2] = By(c[t >> 2] | 0, 144400) | 0
	                        }
	                        c[v >> 2] = 0;
	                        c[y >> 2] = c[x >> 2];
	                        if ((d[c[y >> 2] >> 0] | 0 | 0) == 42) {
	                            c[v >> 2] = my(140432) | 0;
	                            c[y >> 2] = (c[y >> 2] | 0) + 1
	                        } else {
	                            while (1) {
	                                if (!(d[c[y >> 2] >> 0] | 0))break;
	                                if ((d[c[y >> 2] >> 0] | 0 | 0) == 124)break;
	                                c[y >> 2] = (c[y >> 2] | 0) + 1
	                            }
	                            c[v >> 2] = zy(c[v >> 2] | 0, c[x >> 2] | 0, (c[y >> 2] | 0) - (c[x >> 2] | 0) | 0) | 0
	                        }
	                        if (d[c[y >> 2] >> 0] | 0) {
	                            c[y >> 2] = (c[y >> 2] | 0) + 1;
	                            if (((c[r >> 2] | 0) != 0 ? (d[c[y >> 2] >> 0] | 0 | 0) == 42 : 0) ? (d[c[v >> 2] >> 0] | 0 | 0) == 42 : 0) {
	                                if (!(c[v >> 2] | 0))break;
	                                zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                                c[v >> 2] = 0;
	                                break
	                            }
	                            c[x >> 2] = c[y >> 2];
	                            if ((d[c[y >> 2] >> 0] | 0 | 0) == 42)c[w >> 2] = my(144408) | 0; else {
	                                while (1) {
	                                    if (!(d[c[y >> 2] >> 0] | 0))break;
	                                    c[y >> 2] = (c[y >> 2] | 0) + 1
	                                }
	                                if ((c[z >> 2] | 0) >= (c[q >> 2] | 0))c[w >> 2] = my(144416) | 0; else c[w >> 2] = my(144432) | 0;
	                                c[w >> 2] = zy(c[w >> 2] | 0, c[x >> 2] | 0, (c[y >> 2] | 0) - (c[x >> 2] | 0) | 0) | 0;
	                                c[w >> 2] = By(c[w >> 2] | 0, 144440) | 0
	                            }
	                            c[t >> 2] = By(c[t >> 2] | 0, c[w >> 2] | 0) | 0;
	                            if (c[w >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                                c[w >> 2] = 0
	                            }
	                        }
	                        c[t >> 2] = By(c[t >> 2] | 0, c[v >> 2] | 0) | 0;
	                        if (c[v >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                            c[v >> 2] = 0
	                        }
	                        if ((c[z >> 2] | 0) < ((c[q >> 2] | 0) + (c[r >> 2] | 0) - 1 | 0))c[t >> 2] = By(c[t >> 2] | 0, 144448) | 0
	                    } while (0);
	                    c[z >> 2] = (c[z >> 2] | 0) + 1
	                }
	                c[t >> 2] = By(c[t >> 2] | 0, 144456) | 0;
	                c[u >> 2] = By(c[u >> 2] | 0, c[t >> 2] | 0) | 0;
	                if (!(c[t >> 2] | 0)) {
	                    A = c[m >> 2] | 0;
	                    B = c[n >> 2] | 0;
	                    C = c[o >> 2] | 0;
	                    D = c[u >> 2] | 0;
	                    PD(A, B, C, D, 0, 0);
	                    E = c[33934] | 0;
	                    F = c[u >> 2] | 0;
	                    zb[E & 511](F);
	                    i = l;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                c[t >> 2] = 0;
	                A = c[m >> 2] | 0;
	                B = c[n >> 2] | 0;
	                C = c[o >> 2] | 0;
	                D = c[u >> 2] | 0;
	                PD(A, B, C, D, 0, 0);
	                E = c[33934] | 0;
	                F = c[u >> 2] | 0;
	                zb[E & 511](F);
	                i = l;
	                return
	            }

	            function nF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                e = c[h >> 2] | 0;
	                h = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                if (c[(c[j >> 2] | 0) + 32 >> 2] & 16) {
	                    c[g >> 2] = yB(e, 0, h, k, (c[j >> 2] | 0) + 24 | 0, 1, 1, 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = yB(e, 0, h, k, 0, 1, 0, 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function oF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[l >> 2] = c[(c[g >> 2] | 0) + 108 >> 2];
	                if (!((c[c[(c[l >> 2] | 0) + 28 >> 2] >> 2] | 0) != 5 ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0))m = 3;
	                do if (((m | 0) == 3 ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 4 : 0) ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                    if ((c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) == 3 ? (FG(c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0) | 0) != 0 : 0)break;
	                    c[k >> 2] = 3059;
	                    AB(c[g >> 2] | 0, c[k >> 2] | 0, 0, 0, 144160, 0, 0);
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } while (0);
	                do if ((c[c[(c[l >> 2] | 0) + 28 >> 2] >> 2] | 0) == 4)m = 11; else {
	                    if ((c[c[(c[l >> 2] | 0) + 28 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        m = 11;
	                        break
	                    }
	                    if ((c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 52 >> 2] | 0) != 6 : 0)break;
	                    c[k >> 2] = yB(c[g >> 2] | 0, 0, c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 104 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 1, 1, 0) | 0
	                } while (0);
	                if ((m | 0) == 11)c[k >> 2] = yB(c[g >> 2] | 0, 0, c[(c[l >> 2] | 0) + 28 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 1, 1, 0) | 0;
	                if ((c[k >> 2] | 0) < 0)xB(c[g >> 2] | 0, 144320, 141832);
	                c[f >> 2] = c[k >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function pF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0;
	                d = i;
	                i = i + 128 | 0;
	                e = d + 124 | 0;
	                f = d + 120 | 0;
	                g = d + 116 | 0;
	                h = d + 112 | 0;
	                j = d + 108 | 0;
	                k = d + 104 | 0;
	                l = d + 100 | 0;
	                m = d + 96 | 0;
	                n = d + 92 | 0;
	                o = d + 88 | 0;
	                p = d + 84 | 0;
	                q = d + 80 | 0;
	                r = d + 76 | 0;
	                s = d + 72 | 0;
	                t = d + 68 | 0;
	                u = d + 64 | 0;
	                v = d + 60 | 0;
	                w = d + 56 | 0;
	                x = d + 52 | 0;
	                y = d + 48 | 0;
	                z = d + 44 | 0;
	                A = d + 40 | 0;
	                B = d + 36 | 0;
	                C = d + 32 | 0;
	                D = d + 28 | 0;
	                E = d + 24 | 0;
	                F = d + 20 | 0;
	                G = d + 16 | 0;
	                H = d + 12 | 0;
	                I = d + 8 | 0;
	                J = d + 4 | 0;
	                K = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[m >> 2] = 0;
	                c[n >> 2] = c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 28 >> 2];
	                c[o >> 2] = 0;
	                if (!(c[(c[f >> 2] | 0) + 116 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    L = c[e >> 2] | 0;
	                    i = d;
	                    return L | 0
	                }
	                c[h >> 2] = c[(c[f >> 2] | 0) + 116 >> 2];
	                a:while (1) {
	                    if (!(c[h >> 2] | 0)) {
	                        M = 103;
	                        break
	                    }
	                    c[k >> 2] = KQ(c[(c[h >> 2] | 0) + 32 >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) == -1) {
	                        M = 6;
	                        break
	                    }
	                    do if (c[(c[h >> 2] | 0) + 16 >> 2] | 0) {
	                        c[l >> 2] = c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) - 1 << 2) >> 2];
	                        b = c[h >> 2] | 0;
	                        if ((c[l >> 2] | 0) != (c[g >> 2] | 0)) {
	                            c[h >> 2] = c[b + 4 >> 2];
	                            continue a
	                        }
	                        if ((c[b >> 2] | 0) != 2) {
	                            if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                                c[w >> 2] = 0;
	                                c[y >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                c[z >> 2] = c[(c[(c[y >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2];
	                                c[E >> 2] = c[(c[z >> 2] | 0) + 32 >> 2];
	                                c[B >> 2] = (c[g >> 2] | 0) - (c[(c[y >> 2] | 0) + 4 >> 2] | 0);
	                                do if ((c[(c[y >> 2] | 0) + 24 >> 2] | 0) != 0 ? (c[(c[y >> 2] | 0) + 28 >> 2] | 0) > (c[B >> 2] | 0) : 0) {
	                                    c[w >> 2] = (c[(c[y >> 2] | 0) + 24 >> 2] | 0) + (c[B >> 2] << 2);
	                                    if (!(c[c[w >> 2] >> 2] | 0))if ((c[c[z >> 2] >> 2] | 0) == 23) {
	                                        M = 91;
	                                        break
	                                    } else break;
	                                    c[C >> 2] = 0;
	                                    while (1) {
	                                        if ((c[C >> 2] | 0) >= (c[E >> 2] | 0))break;
	                                        if (!(c[(c[c[w >> 2] >> 2] | 0) + (c[C >> 2] << 2) >> 2] | 0)) {
	                                            M = 61;
	                                            break
	                                        }
	                                        c[C >> 2] = (c[C >> 2] | 0) + 1
	                                    }
	                                    if ((M | 0) == 61) {
	                                        M = 0;
	                                        if ((c[c[z >> 2] >> 2] | 0) == 23) {
	                                            M = 91;
	                                            break
	                                        } else break
	                                    }
	                                    c[A >> 2] = _G(c[f >> 2] | 0, c[y >> 2] | 0) | 0;
	                                    if ((c[c[z >> 2] >> 2] | 0) != 24 ? (c[(c[A >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                                        c[C >> 2] = 0;
	                                        c[k >> 2] = 0;
	                                        do {
	                                            c[H >> 2] = c[(c[(c[c[A >> 2] >> 2] | 0) + (c[C >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                            c[D >> 2] = 0;
	                                            while (1) {
	                                                if ((c[D >> 2] | 0) >= (c[E >> 2] | 0))break;
	                                                c[F >> 2] = c[(c[c[w >> 2] >> 2] | 0) + (c[D >> 2] << 2) >> 2];
	                                                c[G >> 2] = c[(c[H >> 2] | 0) + (c[D >> 2] << 2) >> 2];
	                                                c[k >> 2] = VD(c[(c[F >> 2] | 0) + 4 >> 2] | 0, c[(c[G >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                                if ((c[k >> 2] | 0) == -1) {
	                                                    M = 69;
	                                                    break a
	                                                }
	                                                if (!(c[k >> 2] | 0))break;
	                                                c[D >> 2] = (c[D >> 2] | 0) + 1
	                                            }
	                                            if ((c[k >> 2] | 0) == 1)break;
	                                            c[C >> 2] = (c[C >> 2] | 0) + 1
	                                        } while ((c[C >> 2] | 0) < (c[(c[A >> 2] | 0) + 4 >> 2] | 0));
	                                        if ((c[C >> 2] | 0) != (c[(c[A >> 2] | 0) + 4 >> 2] | 0)) {
	                                            c[I >> 2] = 0;
	                                            c[J >> 2] = 0;
	                                            b = c[f >> 2] | 0;
	                                            a = c[z >> 2] | 0;
	                                            N = $G(c[f >> 2] | 0, I, c[c[w >> 2] >> 2] | 0, c[E >> 2] | 0) | 0;
	                                            AB(b, 1877, 0, a, 143312, N, YG(J, c[z >> 2] | 0) | 0);
	                                            if (c[I >> 2] | 0) {
	                                                zb[c[135736 >> 2] & 511](c[I >> 2] | 0);
	                                                c[I >> 2] = 0
	                                            }
	                                            if (!(c[J >> 2] | 0))break;
	                                            zb[c[135736 >> 2] & 511](c[J >> 2] | 0);
	                                            c[J >> 2] = 0;
	                                            break
	                                        }
	                                    }
	                                    c[x >> 2] = Cb[c[135744 >> 2] & 511](16) | 0;
	                                    if (!(c[x >> 2] | 0)) {
	                                        M = 80;
	                                        break a
	                                    }
	                                    N = c[x >> 2] | 0;
	                                    c[N + 0 >> 2] = 0;
	                                    c[N + 4 >> 2] = 0;
	                                    c[N + 8 >> 2] = 0;
	                                    c[N + 12 >> 2] = 0;
	                                    N = c[f >> 2] | 0;
	                                    if ((c[c[z >> 2] >> 2] | 0) == 24) {
	                                        a = bH(N, c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                        c[(c[x >> 2] | 0) + 12 >> 2] = a;
	                                        if ((c[(c[x >> 2] | 0) + 12 >> 2] | 0) == -1) {
	                                            M = 86;
	                                            break a
	                                        }
	                                    } else {
	                                        if ((aH(N, c[x >> 2] | 0) | 0) == -1) {
	                                            M = 83;
	                                            break a
	                                        }
	                                        c[(c[x >> 2] | 0) + 12 >> 2] = -1
	                                    }
	                                    c[c[x >> 2] >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                                    c[(c[x >> 2] | 0) + 8 >> 2] = c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 8 >> 2];
	                                    c[(c[x >> 2] | 0) + 4 >> 2] = c[c[w >> 2] >> 2];
	                                    c[c[w >> 2] >> 2] = 0;
	                                    if ((bE(c[A >> 2] | 0, c[x >> 2] | 0) | 0) == -1) {
	                                        M = 88;
	                                        break a
	                                    }
	                                } else M = 55; while (0);
	                                if ((M | 0) == 55 ? (M = 0, (c[c[z >> 2] >> 2] | 0) == 23) : 0)M = 91;
	                                if ((M | 0) == 91 ? (M = 0, c[K >> 2] = 0, N = c[f >> 2] | 0, a = c[z >> 2] | 0, AB(N, 1877, 0, a, 143384, YG(K, c[z >> 2] | 0) | 0, 0), (c[K >> 2] | 0) != 0) : 0) {
	                                    zb[c[135736 >> 2] & 511](c[K >> 2] | 0);
	                                    c[K >> 2] = 0
	                                }
	                                if ((c[w >> 2] | 0) != 0 ? (c[c[w >> 2] >> 2] | 0) != 0 : 0) {
	                                    zb[c[135736 >> 2] & 511](c[c[w >> 2] >> 2] | 0);
	                                    c[c[w >> 2] >> 2] = 0
	                                }
	                            }
	                        } else {
	                            if ((c[c[n >> 2] >> 2] | 0) != 5 ? (c[(c[n >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)c[o >> 2] = c[n >> 2]; else M = 13;
	                            do if ((M | 0) == 13) {
	                                M = 0;
	                                if ((c[(c[n >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[n >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                                    c[o >> 2] = 0;
	                                    break
	                                }
	                                c[o >> 2] = c[(c[n >> 2] | 0) + 104 >> 2];
	                                if (!(c[o >> 2] | 0)) {
	                                    M = 16;
	                                    break a
	                                }
	                            } while (0);
	                            if (!(c[o >> 2] | 0)) {
	                                c[p >> 2] = 0;
	                                a = c[f >> 2] | 0;
	                                N = c[(c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
	                                b = c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0;
	                                AB(a, 1877, 0, N, 142904, b, YG(p, c[(c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0);
	                                if (c[p >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                                    c[p >> 2] = 0
	                                }
	                                b = (c[h >> 2] | 0) + 16 | 0;
	                                c[b >> 2] = (c[b >> 2] | 0) + -1;
	                                break
	                            }
	                            if ((c[m >> 2] | 0) == 0 ? (c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                                AB(c[f >> 2] | 0, 1877, 0, c[(c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, 142984, 0, 0);
	                                b = (c[h >> 2] | 0) + 16 | 0;
	                                c[b >> 2] = (c[b >> 2] | 0) + -1;
	                                break
	                            }
	                            c[q >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                            c[s >> 2] = (c[(c[h >> 2] | 0) + 8 >> 2] | 0) - (c[(c[q >> 2] | 0) + 4 >> 2] | 0);
	                            c[t >> 2] = c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2];
	                            b = c[s >> 2] | 0;
	                            b:do if (c[(c[q >> 2] | 0) + 24 >> 2] | 0) {
	                                if ((b | 0) >= (c[(c[q >> 2] | 0) + 28 >> 2] | 0)) {
	                                    c[u >> 2] = c[(c[q >> 2] | 0) + 28 >> 2];
	                                    N = (c[q >> 2] | 0) + 28 | 0;
	                                    c[N >> 2] = c[N >> 2] << 1;
	                                    N = Hb[c[135760 >> 2] & 511](c[(c[q >> 2] | 0) + 24 >> 2] | 0, c[(c[q >> 2] | 0) + 28 >> 2] << 2) | 0;
	                                    c[(c[q >> 2] | 0) + 24 >> 2] = N;
	                                    if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0)) {
	                                        M = 35;
	                                        break a
	                                    }
	                                    while (1) {
	                                        if ((c[u >> 2] | 0) >= (c[(c[q >> 2] | 0) + 28 >> 2] | 0))break b;
	                                        c[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[u >> 2] << 2) >> 2] = 0;
	                                        c[u >> 2] = (c[u >> 2] | 0) + 1
	                                    }
	                                }
	                            } else {
	                                if ((b | 0) > 9)c[(c[q >> 2] | 0) + 28 >> 2] = c[s >> 2] << 1; else c[(c[q >> 2] | 0) + 28 >> 2] = 10;
	                                N = Cb[c[135744 >> 2] & 511](c[(c[q >> 2] | 0) + 28 >> 2] << 2) | 0;
	                                c[(c[q >> 2] | 0) + 24 >> 2] = N;
	                                if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0)) {
	                                    M = 31;
	                                    break a
	                                }
	                                cU(c[(c[q >> 2] | 0) + 24 >> 2] | 0, 0, c[(c[q >> 2] | 0) + 28 >> 2] << 2 | 0) | 0
	                            } while (0);
	                            c[r >> 2] = c[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[s >> 2] << 2) >> 2];
	                            if (c[r >> 2] | 0) {
	                                if (c[(c[r >> 2] | 0) + (c[t >> 2] << 2) >> 2] | 0) {
	                                    c[v >> 2] = 0;
	                                    b = c[f >> 2] | 0;
	                                    N = c[(c[(c[q >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
	                                    a = c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 12 >> 2] | 0;
	                                    AB(b, 1877, 0, N, 143168, a, YG(v, c[(c[(c[q >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0);
	                                    if (c[v >> 2] | 0) {
	                                        zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                                        c[v >> 2] = 0
	                                    }
	                                    a = (c[h >> 2] | 0) + 16 | 0;
	                                    c[a >> 2] = (c[a >> 2] | 0) + -1;
	                                    break
	                                }
	                            } else {
	                                c[r >> 2] = Cb[c[135744 >> 2] & 511](c[(c[(c[(c[q >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2] << 2) | 0;
	                                if (!(c[r >> 2] | 0)) {
	                                    M = 44;
	                                    break a
	                                }
	                                cU(c[r >> 2] | 0, 0, c[(c[(c[(c[q >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2] << 2 | 0) | 0;
	                                c[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[s >> 2] << 2) >> 2] = c[r >> 2]
	                            }
	                            if (!(c[m >> 2] | 0)) {
	                                c[m >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                                if (!(c[m >> 2] | 0)) {
	                                    M = 48;
	                                    break a
	                                }
	                                c[c[m >> 2] >> 2] = c[o >> 2];
	                                c[(c[m >> 2] | 0) + 4 >> 2] = c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 24 >> 2];
	                                c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 24 >> 2] = 0;
	                                if ((ZG(c[f >> 2] | 0, c[m >> 2] | 0) | 0) == -1) {
	                                    M = 50;
	                                    break a
	                                }
	                            }
	                            c[(c[r >> 2] | 0) + (c[t >> 2] << 2) >> 2] = c[m >> 2]
	                        }
	                        a = (c[h >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + -1
	                    } while (0);
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) == (c[g >> 2] | 0) : 0) {
	                        if ((c[(c[f >> 2] | 0) + 116 >> 2] | 0) != (c[h >> 2] | 0))xB(c[f >> 2] | 0, 142760, 143424);
	                        c[j >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                        c[(c[f >> 2] | 0) + 116 >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                        c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[f >> 2] | 0) + 120 >> 2];
	                        c[(c[f >> 2] | 0) + 120 >> 2] = c[h >> 2];
	                        c[h >> 2] = c[j >> 2];
	                        continue
	                    }
	                    c[h >> 2] = c[(c[h >> 2] | 0) + 4 >> 2]
	                }
	                switch (M | 0) {
	                    case 6:
	                    {
	                        xB(c[f >> 2] | 0, 142760, 142792);
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 16:
	                    {
	                        xB(c[f >> 2] | 0, 142760, 142816);
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 31:
	                    {
	                        IB(0, 143088, 0);
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 35:
	                    {
	                        IB(0, 143128, 0);
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 44:
	                    {
	                        IB(0, 143256, 0);
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 48:
	                    {
	                        IB(0, 143288, 0);
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        c[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[s >> 2] << 2) >> 2] = 0;
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 50:
	                    {
	                        tB(c[m >> 2] | 0);
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 69:
	                    {
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 80:
	                    {
	                        IB(0, 143344, 0);
	                        zb[c[135736 >> 2] & 511](c[c[w >> 2] >> 2] | 0);
	                        c[c[w >> 2] >> 2] = 0;
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 83:
	                    {
	                        zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[c[w >> 2] >> 2] | 0);
	                        c[c[w >> 2] >> 2] = 0;
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 86:
	                    {
	                        zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[c[w >> 2] >> 2] | 0);
	                        c[c[w >> 2] >> 2] = 0;
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 88:
	                    {
	                        if ((c[c[z >> 2] >> 2] | 0) == 24) {
	                            zb[c[135736 >> 2] & 511](c[(c[x >> 2] | 0) + 4 >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[x >> 2] | 0)
	                        }
	                        c[e >> 2] = -1;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                    case 103:
	                    {
	                        c[e >> 2] = 0;
	                        L = c[e >> 2] | 0;
	                        i = d;
	                        return L | 0
	                    }
	                }
	                return 0
	            }

	            function qF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                d = i;
	                i = i + 80 | 0;
	                e = d + 64 | 0;
	                f = d + 60 | 0;
	                g = d + 56 | 0;
	                h = d + 52 | 0;
	                j = d + 48 | 0;
	                k = d + 44 | 0;
	                l = d + 40 | 0;
	                m = d + 36 | 0;
	                n = d + 32 | 0;
	                o = d + 28 | 0;
	                p = d + 24 | 0;
	                q = d + 20 | 0;
	                r = d + 16 | 0;
	                s = d + 12 | 0;
	                t = d + 8 | 0;
	                u = d + 4 | 0;
	                v = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[v >> 2] = c[(c[g >> 2] | 0) + 56 >> 2];
	                a:while (1) {
	                    if (!(c[v >> 2] | 0)) {
	                        w = 51;
	                        break
	                    }
	                    if (((c[c[(c[(c[v >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] >> 2] | 0) != 24 ? (c[(c[v >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[(c[v >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        do if (!(c[(c[f >> 2] | 0) + 188 >> 2] | 0)) {
	                            if ((c[(c[(c[v >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) != -1 ? (c[(c[(c[v >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) <= (c[(c[f >> 2] | 0) + 96 >> 2] | 0) : 0)break;
	                            c[v >> 2] = c[(c[v >> 2] | 0) + 8 >> 2];
	                            continue a
	                        } while (0);
	                        c[h >> 2] = cH(c[f >> 2] | 0, c[v >> 2] | 0) | 0;
	                        if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                            c[u >> 2] = c[c[(c[h >> 2] | 0) + 20 >> 2] >> 2];
	                            c[p >> 2] = c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2]
	                        } else {
	                            c[u >> 2] = 0;
	                            c[p >> 2] = 0
	                        }
	                        if (c[(c[h >> 2] | 0) + 8 >> 2] | 0)c[q >> 2] = c[(c[h >> 2] | 0) + 12 >> 2]; else c[q >> 2] = 0;
	                        g = c[(c[v >> 2] | 0) + 32 >> 2] | 0;
	                        if ((c[q >> 2] | 0) == 0 & (c[p >> 2] | 0) == 0) {
	                            c[(c[h >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                            c[(c[h >> 2] | 0) + 16 >> 2] = c[(c[(c[v >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2];
	                            c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[(c[v >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2];
	                            c[c[(c[v >> 2] | 0) + 32 >> 2] >> 2] = 0;
	                            c[(c[(c[v >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] = 0;
	                            c[(c[(c[v >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] = 0
	                        } else {
	                            c[n >> 2] = c[g + 4 >> 2];
	                            c[t >> 2] = c[c[(c[v >> 2] | 0) + 32 >> 2] >> 2];
	                            c[o >> 2] = c[(c[(c[(c[v >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2];
	                            c[k >> 2] = 0;
	                            do {
	                                c[r >> 2] = c[(c[(c[t >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                b:do if (c[p >> 2] | 0) {
	                                    c[l >> 2] = 0;
	                                    while (1) {
	                                        if ((c[o >> 2] | 0) == 1) {
	                                            c[j >> 2] = VD(c[(c[c[r >> 2] >> 2] | 0) + 4 >> 2] | 0, c[(c[c[(c[(c[u >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 4 >> 2] >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                            if ((c[j >> 2] | 0) == -1) {
	                                                w = 52;
	                                                break a
	                                            }
	                                            if ((c[j >> 2] | 0) == 1)break b
	                                        } else {
	                                            c[j >> 2] = 0;
	                                            c[s >> 2] = c[(c[(c[u >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                            c[m >> 2] = 0;
	                                            while (1) {
	                                                if ((c[m >> 2] | 0) >= (c[o >> 2] | 0))break;
	                                                c[j >> 2] = VD(c[(c[(c[r >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[s >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                                if ((c[j >> 2] | 0) == -1) {
	                                                    w = 52;
	                                                    break a
	                                                }
	                                                if (!(c[j >> 2] | 0))break;
	                                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                                            }
	                                            if ((c[j >> 2] | 0) == 1)break b
	                                        }
	                                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                                        if ((c[l >> 2] | 0) >= (c[p >> 2] | 0)) {
	                                            w = 33;
	                                            break
	                                        }
	                                    }
	                                } else w = 33; while (0);
	                                c:do if ((w | 0) == 33) {
	                                    w = 0;
	                                    d:do if (c[q >> 2] | 0) {
	                                        c[l >> 2] = 0;
	                                        e:while (1) {
	                                            f:do if ((c[o >> 2] | 0) == 1) {
	                                                c[j >> 2] = VD(c[(c[c[r >> 2] >> 2] | 0) + 4 >> 2] | 0, c[(c[c[(c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 4 >> 2] >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                                if ((c[j >> 2] | 0) == -1) {
	                                                    w = 52;
	                                                    break a
	                                                }
	                                                if (c[j >> 2] | 0)break e
	                                            } else {
	                                                c[j >> 2] = 0;
	                                                c[s >> 2] = c[(c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                                c[m >> 2] = 0;
	                                                while (1) {
	                                                    if ((c[m >> 2] | 0) >= (c[o >> 2] | 0))break e;
	                                                    c[j >> 2] = VD(c[(c[(c[r >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[s >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                                    if ((c[j >> 2] | 0) == -1) {
	                                                        w = 52;
	                                                        break a
	                                                    }
	                                                    if (!(c[j >> 2] | 0))break f;
	                                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                                }
	                                            } while (0);
	                                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                                            if ((c[l >> 2] | 0) >= (c[q >> 2] | 0))break d
	                                        }
	                                        if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) == 0 ? (g = JB() | 0, c[(c[h >> 2] | 0) + 20 >> 2] = g, (c[(c[h >> 2] | 0) + 20 >> 2] | 0) == 0) : 0) {
	                                            w = 52;
	                                            break a
	                                        }
	                                        if ((bE(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) | 0) == -1) {
	                                            w = 52;
	                                            break a
	                                        }
	                                        c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2] = c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) - 1 << 2) >> 2];
	                                        g = (c[h >> 2] | 0) + 12 | 0;
	                                        c[g >> 2] = (c[g >> 2] | 0) + -1;
	                                        break c
	                                    } while (0);
	                                    if ((dH(c[h >> 2] | 0, c[(c[t >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0) == -1) {
	                                        w = 52;
	                                        break a
	                                    }
	                                } while (0);
	                                c[k >> 2] = (c[k >> 2] | 0) + 1
	                            } while ((c[k >> 2] | 0) < (c[n >> 2] | 0))
	                        }
	                        c[v >> 2] = c[(c[v >> 2] | 0) + 8 >> 2];
	                        continue
	                    }
	                    c[v >> 2] = c[(c[v >> 2] | 0) + 8 >> 2]
	                }
	                if ((w | 0) == 51) {
	                    c[e >> 2] = 0;
	                    x = c[e >> 2] | 0;
	                    i = d;
	                    return x | 0
	                } else if ((w | 0) == 52) {
	                    c[e >> 2] = -1;
	                    x = c[e >> 2] | 0;
	                    i = d;
	                    return x | 0
	                }
	                return 0
	            }

	            function Kb(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + a | 0;
	                i = i + 15 & -16;
	                return b | 0
	            }

	            function Lb() {
	                return i | 0
	            }

	            function Mb(a) {
	                a = a | 0;
	                i = a
	            }

	            function Nb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                if (!r) {
	                    r = a;
	                    s = b
	                }
	            }

	            function Ob(b) {
	                b = b | 0;
	                a[k >> 0] = a[b >> 0];
	                a[k + 1 >> 0] = a[b + 1 >> 0];
	                a[k + 2 >> 0] = a[b + 2 >> 0];
	                a[k + 3 >> 0] = a[b + 3 >> 0]
	            }

	            function Pb(b) {
	                b = b | 0;
	                a[k >> 0] = a[b >> 0];
	                a[k + 1 >> 0] = a[b + 1 >> 0];
	                a[k + 2 >> 0] = a[b + 2 >> 0];
	                a[k + 3 >> 0] = a[b + 3 >> 0];
	                a[k + 4 >> 0] = a[b + 4 >> 0];
	                a[k + 5 >> 0] = a[b + 5 >> 0];
	                a[k + 6 >> 0] = a[b + 6 >> 0];
	                a[k + 7 >> 0] = a[b + 7 >> 0]
	            }

	            function Qb(a) {
	                a = a | 0;
	                G = a
	            }

	            function Rb() {
	                return G | 0
	            }

	            function Sb(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e;
	                g = e + 52 | 0;
	                h = e + 48 | 0;
	                j = e + 44 | 0;
	                k = e + 40 | 0;
	                l = e + 36 | 0;
	                m = e + 32 | 0;
	                n = e + 28 | 0;
	                p = e + 24 | 0;
	                q = e + 20 | 0;
	                r = e + 16 | 0;
	                s = e + 12 | 0;
	                t = e + 8 | 0;
	                u = e + 4 | 0;
	                c[g >> 2] = 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[h >> 2] | 0) <= 1) {
	                    Tb(c[c[j >> 2] >> 2] | 0);
	                    c[g >> 2] = 1;
	                    v = c[g >> 2] | 0;
	                    i = e;
	                    return v | 0
	                }
	                he(20902);
	                c[k >> 2] = 1;
	                a:while (1) {
	                    if ((c[k >> 2] | 0) >= (c[h >> 2] | 0))break;
	                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 144) | 0))break;
	                    b:do if ((a[c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] >> 0] | 0) == 45) {
	                        if ((PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 152) | 0) != 0 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 160) | 0) != 0 : 0) {
	                            if ((PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 176) | 0) != 0 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 184) | 0) != 0 : 0) {
	                                if ((PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 208) | 0) != 0 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 216) | 0) != 0 : 0) {
	                                    if ((PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 232) | 0) != 0 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 248) | 0) != 0 : 0) {
	                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 280) | 0) {
	                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 288) | 0))break;
	                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 296) | 0) {
	                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 304) | 0))break;
	                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 320) | 0) {
	                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 328) | 0))break;
	                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 344) | 0) {
	                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 360) | 0))break;
	                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 376) | 0) {
	                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 392) | 0))break;
	                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 408) | 0) {
	                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 416) | 0))break;
	                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 432) | 0) {
	                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 448) | 0))break;
	                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 464) | 0) {
	                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 472) | 0))break;
	                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 480) | 0) {
	                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 488) | 0))break;
	                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 496) | 0))break;
	                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 520) | 0) {
	                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 536) | 0))break;
	                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 560) | 0) {
	                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 568) | 0))break;
	                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 592) | 0) {
	                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 600) | 0))break;
	                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 616) | 0) {
	                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 624) | 0))break;
	                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 648) | 0) {
	                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 664) | 0))break;
	                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 688) | 0) {
	                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 704) | 0))break;
	                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 728) | 0) {
	                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 744) | 0))break;
	                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 768) | 0) {
	                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 776) | 0))break;
	                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 792) | 0) {
	                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 808) | 0))break;
	                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 832) | 0) {
	                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 848) | 0))break;
	                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 872) | 0) {
	                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 888) | 0))break;
	                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 912) | 0) {
	                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 928) | 0))break;
	                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 952) | 0) {
	                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 960) | 0))break;
	                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 984) | 0) {
	                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 992) | 0))break;
	                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1016) | 0) {
	                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1024) | 0))break;
	                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1040) | 0) {
	                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1048) | 0))break;
	                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1072) | 0) {
	                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1080) | 0))break;
	                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1096) | 0) {
	                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1112) | 0))break;
	                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1136) | 0) {
	                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1144) | 0))break;
	                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1168) | 0) {
	                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1176) | 0))break;
	                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1200) | 0) {
	                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1216) | 0))break;
	                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1240) | 0) {
	                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1256) | 0))break;
	                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1280) | 0) {
	                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1304) | 0))break;
	                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1328) | 0) {
	                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1344) | 0))break;
	                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1360) | 0) {
	                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1376) | 0))break;
	                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1392) | 0) {
	                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1408) | 0))break;
	                                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1432) | 0) {
	                                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1440) | 0))break;
	                                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1456) | 0) {
	                                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1464) | 0))break;
	                                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1488) | 0) {
	                                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1504) | 0))break;
	                                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1528) | 0) {
	                                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1544) | 0))break;
	                                                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1568) | 0) {
	                                                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1584) | 0))break;
	                                                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1608) | 0) {
	                                                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1616) | 0))break;
	                                                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1656) | 0) {
	                                                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1672) | 0))break;
	                                                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1696) | 0) {
	                                                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1704) | 0))break;
	                                                                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1736) | 0) {
	                                                                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1744) | 0))break;
	                                                                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1768) | 0) {
	                                                                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1776) | 0))break;
	                                                                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1792) | 0) {
	                                                                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1800) | 0))break;
	                                                                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1824) | 0) {
	                                                                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1832) | 0))break;
	                                                                                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1856) | 0) {
	                                                                                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1864) | 0))break;
	                                                                                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1880) | 0) {
	                                                                                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1888) | 0))break;
	                                                                                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1904) | 0) {
	                                                                                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1920) | 0))break;
	                                                                                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1944) | 0) {
	                                                                                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1960) | 0))break;
	                                                                                                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1984) | 0) {
	                                                                                                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1992) | 0))break;
	                                                                                                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2016) | 0) {
	                                                                                                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2032) | 0))break;
	                                                                                                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2056) | 0) {
	                                                                                                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2064) | 0))break;
	                                                                                                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2072) | 0) {
	                                                                                                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2088) | 0))break;
	                                                                                                                                                                                                                                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2104) | 0) {
	                                                                                                                                                                                                                                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2120) | 0))break;
	                                                                                                                                                                                                                                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2144) | 0) {
	                                                                                                                                                                                                                                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2152) | 0))break;
	                                                                                                                                                                                                                                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2160) | 0) {
	                                                                                                                                                                                                                                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2176) | 0))break;
	                                                                                                                                                                                                                                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2200) | 0) {
	                                                                                                                                                                                                                                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2208) | 0))break;
	                                                                                                                                                                                                                                                                                    if ((PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2224) | 0) != 0 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2240) | 0) != 0 : 0) {
	                                                                                                                                                                                                                                                                                        w = 206;
	                                                                                                                                                                                                                                                                                        break a
	                                                                                                                                                                                                                                                                                    }
	                                                                                                                                                                                                                                                                                    c[564] = (c[564] | 0) + 1;
	                                                                                                                                                                                                                                                                                    c[68] = c[68] | 131072;
	                                                                                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                                                                                } while (0);
	                                                                                                                                                                                                                                                                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                                                                                c[50] = (c[50] | 0) + 1;
	                                                                                                                                                                                                                                                                                c[554] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                                                                                                                                                                                break b
	                                                                                                                                                                                                                                                                            } while (0);
	                                                                                                                                                                                                                                                                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                                                                            c[548] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                                                                                                                                                                            break b
	                                                                                                                                                                                                                                                                        } while (0);
	                                                                                                                                                                                                                                                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                                                                        Zb(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0);
	                                                                                                                                                                                                                                                                        break b
	                                                                                                                                                                                                                                                                    } while (0);
	                                                                                                                                                                                                                                                                    c[534] = (c[534] | 0) + 1;
	                                                                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                                                                } while (0);
	                                                                                                                                                                                                                                                                c[68] = c[68] & -65537;
	                                                                                                                                                                                                                                                                break b
	                                                                                                                                                                                                                                                            } while (0);
	                                                                                                                                                                                                                                                            c[68] = c[68] | 2048;
	                                                                                                                                                                                                                                                            Tk(199);
	                                                                                                                                                                                                                                                            break b
	                                                                                                                                                                                                                                                        } while (0);
	                                                                                                                                                                                                                                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                                                        c[512] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                                                                                                                                                        c[78] = (c[78] | 0) + 1;
	                                                                                                                                                                                                                                                        break b
	                                                                                                                                                                                                                                                    } while (0);
	                                                                                                                                                                                                                                                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                                                    c[502] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                                                                                                                                                    c[78] = (c[78] | 0) + 1;
	                                                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                                                } while (0);
	                                                                                                                                                                                                                                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                                                c[494] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                                                                                                                                                c[78] = (c[78] | 0) + 1;
	                                                                                                                                                                                                                                                c[68] = c[68] | 2;
	                                                                                                                                                                                                                                                break b
	                                                                                                                                                                                                                                            } while (0);
	                                                                                                                                                                                                                                            c[484] = (c[484] | 0) + 1;
	                                                                                                                                                                                                                                            break b
	                                                                                                                                                                                                                                        } while (0);
	                                                                                                                                                                                                                                        c[474] = (c[474] | 0) + 1;
	                                                                                                                                                                                                                                        break b
	                                                                                                                                                                                                                                    } while (0);
	                                                                                                                                                                                                                                    c[468] = (c[468] | 0) + 1;
	                                                                                                                                                                                                                                    c[68] = c[68] | 512;
	                                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                                } while (0);
	                                                                                                                                                                                                                                c[462] = (c[462] | 0) + 1;
	                                                                                                                                                                                                                                c[50] = (c[50] | 0) + 1;
	                                                                                                                                                                                                                                break b
	                                                                                                                                                                                                                            } while (0);
	                                                                                                                                                                                                                            c[454] = (c[454] | 0) + 1;
	                                                                                                                                                                                                                            break b
	                                                                                                                                                                                                                        } while (0);
	                                                                                                                                                                                                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                        if (!(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0))break b;
	                                                                                                                                                                                                                        c[440] = MT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0;
	                                                                                                                                                                                                                        if ((c[440] | 0) != 1)break b;
	                                                                                                                                                                                                                        c[422] = (c[422] | 0) + 1;
	                                                                                                                                                                                                                        He(0) | 0;
	                                                                                                                                                                                                                        break b
	                                                                                                                                                                                                                    } while (0);
	                                                                                                                                                                                                                    c[422] = (c[422] | 0) + 1;
	                                                                                                                                                                                                                    c[440] = 1;
	                                                                                                                                                                                                                    He(0) | 0;
	                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                } while (0);
	                                                                                                                                                                                                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                                d = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0;
	                                                                                                                                                                                                                c[f >> 2] = 1728;
	                                                                                                                                                                                                                if ((bT(d, 1720, f) | 0) == 1) {
	                                                                                                                                                                                                                    wl(195, 196, 197, 198) | 0;
	                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                } else {
	                                                                                                                                                                                                                    c[432] = 0;
	                                                                                                                                                                                                                    break b
	                                                                                                                                                                                                                }
	                                                                                                                                                                                                            } while (0);
	                                                                                                                                                                                                            c[422] = (c[422] | 0) + 1;
	                                                                                                                                                                                                            He(0) | 0;
	                                                                                                                                                                                                            c[68] = c[68] | 256;
	                                                                                                                                                                                                            break b
	                                                                                                                                                                                                        } while (0);
	                                                                                                                                                                                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                                                                                                        c[408] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                                                                                                        vd(1640, 1648) | 0;
	                                                                                                                                                                                                        break b
	                                                                                                                                                                                                    } while (0);
	                                                                                                                                                                                                    c[400] = (c[400] | 0) + 1;
	                                                                                                                                                                                                    break b
	                                                                                                                                                                                                } while (0);
	                                                                                                                                                                                                c[390] = (c[390] | 0) + 1;
	                                                                                                                                                                                                break b
	                                                                                                                                                                                            } while (0);
	                                                                                                                                                                                            c[380] = (c[380] | 0) + 1;
	                                                                                                                                                                                            c[68] = c[68] | 14;
	                                                                                                                                                                                            break b
	                                                                                                                                                                                        } while (0);
	                                                                                                                                                                                        c[370] = (c[370] | 0) + 1;
	                                                                                                                                                                                        c[68] = c[68] | 14;
	                                                                                                                                                                                        break b
	                                                                                                                                                                                    } while (0);
	                                                                                                                                                                                    c[362] = (c[362] | 0) + 1;
	                                                                                                                                                                                    c[68] = c[68] | 14;
	                                                                                                                                                                                    break b
	                                                                                                                                                                                } while (0);
	                                                                                                                                                                                c[356] = (c[356] | 0) + 1;
	                                                                                                                                                                                c[33952] = 1;
	                                                                                                                                                                                break b
	                                                                                                                                                                            } while (0);
	                                                                                                                                                                            c[33956] = 1;
	                                                                                                                                                                            Ee(1) | 0;
	                                                                                                                                                                            c[68] = c[68] | 128;
	                                                                                                                                                                            break b
	                                                                                                                                                                        } while (0);
	                                                                                                                                                                        c[33956] = 0;
	                                                                                                                                                                        Ee(0) | 0;
	                                                                                                                                                                        c[68] = c[68] | 64;
	                                                                                                                                                                        break b
	                                                                                                                                                                    } while (0);
	                                                                                                                                                                    c[308] = (c[308] | 0) + 1;
	                                                                                                                                                                    c[68] = c[68] | 1024;
	                                                                                                                                                                    c[68] = c[68] | 262144;
	                                                                                                                                                                    break b
	                                                                                                                                                                } while (0);
	                                                                                                                                                                c[308] = (c[308] | 0) + 1;
	                                                                                                                                                                c[68] = c[68] | 1024;
	                                                                                                                                                                c[68] = c[68] | 32768;
	                                                                                                                                                                break b
	                                                                                                                                                            } while (0);
	                                                                                                                                                            c[308] = (c[308] | 0) + 1;
	                                                                                                                                                            c[68] = c[68] | 1024;
	                                                                                                                                                            break b
	                                                                                                                                                        } while (0);
	                                                                                                                                                        c[298] = (c[298] | 0) + 1;
	                                                                                                                                                        break b
	                                                                                                                                                    } while (0);
	                                                                                                                                                    c[290] = (c[290] | 0) + 1;
	                                                                                                                                                    break b
	                                                                                                                                                } while (0);
	                                                                                                                                                c[272] = (c[272] | 0) + 1;
	                                                                                                                                                c[282] = 10;
	                                                                                                                                                break b
	                                                                                                                                            } while (0);
	                                                                                                                                            c[272] = (c[272] | 0) + 1;
	                                                                                                                                            break b
	                                                                                                                                        } while (0);
	                                                                                                                                        if (c[266] | 0) {
	                                                                                                                                            c[266] = (c[266] | 0) * 10;
	                                                                                                                                            break b
	                                                                                                                                        } else {
	                                                                                                                                            c[266] = 100;
	                                                                                                                                            break b
	                                                                                                                                        }
	                                                                                                                                    } while (0);
	                                                                                                                                    c[258] = (c[258] | 0) + 1;
	                                                                                                                                    break b
	                                                                                                                                } while (0);
	                                                                                                                                c[252] = (c[252] | 0) + 1;
	                                                                                                                                break b
	                                                                                                                            } while (0);
	                                                                                                                            c[244] = (c[244] | 0) + 1;
	                                                                                                                            break b
	                                                                                                                        } while (0);
	                                                                                                                        c[236] = (c[236] | 0) + 1;
	                                                                                                                        break b
	                                                                                                                    } while (0);
	                                                                                                                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                    c[226] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                    c[180] = (c[180] | 0) + 1;
	                                                                                                                    c[68] = c[68] | 4;
	                                                                                                                    break b
	                                                                                                                } while (0);
	                                                                                                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                                                                c[216] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                                                                c[180] = (c[180] | 0) + 1;
	                                                                                                                c[68] = c[68] | 4;
	                                                                                                                break b
	                                                                                                            } while (0);
	                                                                                                            c[206] = (c[206] | 0) + 1;
	                                                                                                            c[180] = (c[180] | 0) + 1;
	                                                                                                            c[68] = c[68] | 4;
	                                                                                                            break b
	                                                                                                        } while (0);
	                                                                                                        c[196] = (c[196] | 0) + 1;
	                                                                                                        c[68] = c[68] | 16;
	                                                                                                        break b
	                                                                                                    } while (0);
	                                                                                                    c[180] = (c[180] | 0) + 1;
	                                                                                                    c[190] = (c[190] | 0) + 1;
	                                                                                                    c[68] = c[68] | 8;
	                                                                                                    break b
	                                                                                                } while (0);
	                                                                                                c[180] = (c[180] | 0) + 1;
	                                                                                                c[68] = c[68] | 4;
	                                                                                                break b
	                                                                                            } while (0);
	                                                                                            c[170] = (c[170] | 0) + 1;
	                                                                                            c[68] = c[68] | 4;
	                                                                                            break b
	                                                                                        } while (0);
	                                                                                        c[160] = (c[160] | 0) + 1;
	                                                                                        break b
	                                                                                    } while (0);
	                                                                                    c[152] = (c[152] | 0) + 1;
	                                                                                    break b
	                                                                                } while (0);
	                                                                                c[146] = (c[146] | 0) + 1;
	                                                                                break b
	                                                                            } while (0);
	                                                                            c[138] = (c[138] | 0) + 1;
	                                                                            break b
	                                                                        } while (0);
	                                                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                        c[128] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                                                                        break b
	                                                                    } while (0);
	                                                                    c[50] = (c[50] | 0) + 1;
	                                                                    break b
	                                                                } while (0);
	                                                                Ub(c[c[j >> 2] >> 2] | 0);
	                                                                c[n >> 2] = 1;
	                                                                break b
	                                                            } while (0);
	                                                            c[68] = c[68] | 4096;
	                                                            break b
	                                                        } while (0);
	                                                        c[68] = c[68] | 16384;
	                                                        break b
	                                                    } while (0);
	                                                    c[68] = c[68] | 8192;
	                                                    break b
	                                                } while (0);
	                                                c[84] = (c[84] | 0) + 1;
	                                                c[68] = c[68] | 2097152;
	                                                break b
	                                            } while (0);
	                                            c[78] = (c[78] | 0) + 1;
	                                            c[68] = c[68] | 2;
	                                            break b
	                                        } while (0);
	                                        c[68] = c[68] | 524288;
	                                        break
	                                    }
	                                    c[66] = (c[66] | 0) + 1;
	                                    c[68] = c[68] | 1;
	                                    break
	                                }
	                                c[56] = (c[56] | 0) + 1;
	                                break
	                            }
	                            c[48] = (c[48] | 0) + 1;
	                            c[50] = 1;
	                            break
	                        }
	                        c[42] = (c[42] | 0) + 1
	                    } while (0);
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((w | 0) == 206) {
	                    d = c[o >> 2] | 0;
	                    c[f >> 2] = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                    Ka(d | 0, 2264, f | 0) | 0;
	                    Tb(c[c[j >> 2] >> 2] | 0);
	                    c[g >> 2] = 1;
	                    v = c[g >> 2] | 0;
	                    i = e;
	                    return v | 0
	                }
	                do if ((c[400] | 0) == 0 & (c[390] | 0) != 0) {
	                    c[q >> 2] = cb(2288) | 0;
	                    if (c[q >> 2] | 0) {
	                        Cw(c[q >> 2] | 0);
	                        break
	                    } else {
	                        Ka(c[o >> 2] | 0, 2312, f | 0) | 0;
	                        break
	                    }
	                } while (0);
	                if (c[468] | 0)nQ(1) | 0; else nQ(2) | 0;
	                if (c[484] | 0) {
	                    nx(200) | 0;
	                    ox(201) | 0
	                }
	                c[p >> 2] = cb(2352) | 0;
	                if (c[p >> 2] | 0)c[33988] = c[p >> 2];
	                c[592] = Uk() | 0;
	                Tk(202);
	                Fe(1) | 0;
	                if (c[180] | 0)c[33958] = c[33958] | 2;
	                if (c[190] | 0)c[33958] = c[33958] | 4;
	                if (c[78] | 0)Ge(1) | 0;
	                if (c[196] | 0)c[33954] = 1;
	                if (!((c[138] | 0) == 0 | (c[146] | 0) != 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 2376, f);
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 2440, f);
	                    p = c[33976] | 0;
	                    q = c[33980] | 0;
	                    c[f >> 2] = c[c[j >> 2] >> 2];
	                    Db[p & 511](q, 2488, f);
	                    q = c[33976] | 0;
	                    p = c[33980] | 0;
	                    c[f >> 2] = c[c[j >> 2] >> 2];
	                    Db[q & 511](p, 2536, f)
	                }
	                if ((c[512] | 0) != 0 & (c[474] | 0) == 0 & (c[454] | 0) == 0) {
	                    c[33958] = c[33958] | 1;
	                    c[68] = c[68] | 4;
	                    if (c[252] | 0)bc();
	                    c[r >> 2] = iS(c[512] | 0) | 0;
	                    c[650] = kS(c[r >> 2] | 0) | 0;
	                    if (!(c[650] | 0)) {
	                        p = c[33976] | 0;
	                        q = c[33980] | 0;
	                        c[f >> 2] = c[512];
	                        Db[p & 511](q, 2608, f);
	                        c[662] = 5;
	                        c[512] = 0
	                    }
	                    jS(c[r >> 2] | 0);
	                    if (c[252] | 0)cc(2656, f)
	                }
	                if ((c[494] | 0) != 0 & (c[474] | 0) == 0 & (c[454] | 0) == 0) {
	                    c[33958] = c[33958] | 1;
	                    c[68] = c[68] | 4;
	                    if (c[252] | 0)bc();
	                    c[s >> 2] = YM(c[494] | 0) | 0;
	                    $M(c[s >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                    c[670] = _M(c[s >> 2] | 0) | 0;
	                    if (!(c[670] | 0)) {
	                        r = c[33976] | 0;
	                        q = c[33980] | 0;
	                        c[f >> 2] = c[494];
	                        Db[r & 511](q, 2688, f);
	                        c[662] = 5;
	                        c[494] = 0
	                    }
	                    ZM(c[s >> 2] | 0);
	                    if (c[252] | 0)cc(2656, f)
	                } else if ((c[502] | 0) != 0 & (c[454] | 0) == 0) {
	                    if (c[252] | 0)bc();
	                    c[t >> 2] = XA(c[502] | 0) | 0;
	                    aB(c[t >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                    c[682] = $A(c[t >> 2] | 0) | 0;
	                    if (!(c[682] | 0)) {
	                        s = c[33976] | 0;
	                        q = c[33980] | 0;
	                        c[f >> 2] = c[502];
	                        Db[s & 511](q, 2736, f);
	                        c[662] = 5;
	                        c[502] = 0
	                    }
	                    YA(c[t >> 2] | 0);
	                    if (c[252] | 0)cc(2656, f)
	                }
	                if ((c[548] | 0) != 0 & (c[462] | 0) == 0 ? (c[694] = MQ(c[548] | 0, 0, 0, 0) | 0, (c[694] | 0) == 0) : 0) {
	                    t = c[33976] | 0;
	                    q = c[33980] | 0;
	                    c[f >> 2] = c[548];
	                    Db[t & 511](q, 2784, f);
	                    c[662] = 7;
	                    c[548] = 0
	                }
	                c[k >> 2] = 1;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[h >> 2] | 0))break;
	                    c:do if ((PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1608) | 0) != 0 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1616) | 0) != 0 : 0) {
	                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 480) | 0) {
	                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 488) | 0))break;
	                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 496) | 0))break;
	                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 832) | 0) {
	                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 848) | 0))break;
	                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2144) | 0) {
	                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2152) | 0))break;
	                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 872) | 0) {
	                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 888) | 0))break;
	                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1944) | 0) {
	                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1960) | 0))break;
	                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1696) | 0) {
	                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1704) | 0))break;
	                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1768) | 0) {
	                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1776) | 0))break;
	                                                    do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1984) | 0) {
	                                                        if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 1992) | 0))break;
	                                                        do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2016) | 0) {
	                                                            if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2032) | 0))break;
	                                                            do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2160) | 0) {
	                                                                if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2176) | 0))break;
	                                                                do if (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2200) | 0) {
	                                                                    if (!(PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 2208) | 0))break;
	                                                                    if ((c[252] | 0) != 0 & (c[266] | 0) != 0)bc();
	                                                                    if ((a[c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] >> 0] | 0) == 45 ? (PT(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, 144) | 0) != 0 : 0)break c;
	                                                                    do if (c[266] | 0) {
	                                                                        c[u >> 2] = 0;
	                                                                        c[l >> 2] = 0;
	                                                                        while (1) {
	                                                                            if ((c[l >> 2] | 0) >= (c[266] | 0))break;
	                                                                            do if (c[454] | 0)dc(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0); else {
	                                                                                if (c[474] | 0) {
	                                                                                    ec(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0);
	                                                                                    break
	                                                                                }
	                                                                                if (!(c[u >> 2] | 0))c[u >> 2] = Be() | 0;
	                                                                                fc(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0, c[u >> 2] | 0)
	                                                                            } while (0);
	                                                                            c[l >> 2] = (c[l >> 2] | 0) + 1
	                                                                        }
	                                                                        if (!(c[u >> 2] | 0))break;
	                                                                        Ae(c[u >> 2] | 0)
	                                                                    } else {
	                                                                        c[704] = 0;
	                                                                        do if (!(c[454] | 0)) {
	                                                                            q = c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0;
	                                                                            if (c[474] | 0) {
	                                                                                ec(q);
	                                                                                break
	                                                                            } else {
	                                                                                fc(q, 0);
	                                                                                break
	                                                                            }
	                                                                        } else dc(c[(c[j >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0); while (0);
	                                                                        if (!((c[484] | 0) != 0 & (c[704] | 0) != 0))break;
	                                                                        q = c[o >> 2] | 0;
	                                                                        c[f >> 2] = c[704];
	                                                                        Ka(q | 0, 2824, f | 0) | 0;
	                                                                        c[662] = 8
	                                                                    } while (0);
	                                                                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                                                    if (!((c[252] | 0) != 0 & (c[266] | 0) != 0))break c;
	                                                                    c[f >> 2] = c[266];
	                                                                    cc(2856, f);
	                                                                    break c
	                                                                } while (0);
	                                                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                                break c
	                                                            } while (0);
	                                                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                            break c
	                                                        } while (0);
	                                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                        break c
	                                                    } while (0);
	                                                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                    break c
	                                                } while (0);
	                                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                                break c
	                                            } while (0);
	                                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                            break c
	                                        } while (0);
	                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                        break c
	                                    } while (0);
	                                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                    break c
	                                } while (0);
	                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                break c
	                            } while (0);
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            break c
	                        } while (0);
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    } else w = 257; while (0);
	                    if ((w | 0) == 257) {
	                        w = 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if (c[258] | 0)fc(0, 0);
	                if (!((c[138] | 0) == 0 | (c[146] | 0) != 0))Db[c[135904 >> 2] & 511](c[33980] | 0, 2872, f);
	                if ((((c[m >> 2] | 0) != 0 | (c[258] | 0) != 0) ^ 1) & (c[n >> 2] | 0) == 0)Tb(c[c[j >> 2] >> 2] | 0);
	                if (c[650] | 0)hS(c[650] | 0);
	                if (c[670] | 0)VM(c[670] | 0);
	                if (c[682] | 0)WA(c[682] | 0);
	                XM();
	                if (c[694] | 0)EQ(c[694] | 0);
	                dg();
	                ml();
	                c[g >> 2] = c[662];
	                v = c[g >> 2] | 0;
	                i = e;
	                return v | 0
	            }

	            function Tb(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                c[d >> 2] = c[e >> 2];
	                Wa(56872, d | 0) | 0;
	                Wa(56912, d | 0) | 0;
	                Wa(56976, d | 0) | 0;
	                Wa(57040, d | 0) | 0;
	                Wa(57096, d | 0) | 0;
	                Wa(57136, d | 0) | 0;
	                Wa(57200, d | 0) | 0;
	                Wa(57264, d | 0) | 0;
	                Wa(57328, d | 0) | 0;
	                Wa(57384, d | 0) | 0;
	                Wa(57440, d | 0) | 0;
	                Wa(57504, d | 0) | 0;
	                Wa(57552, d | 0) | 0;
	                Wa(57608, d | 0) | 0;
	                Wa(57672, d | 0) | 0;
	                Wa(57736, d | 0) | 0;
	                Wa(57792, d | 0) | 0;
	                Wa(57832, d | 0) | 0;
	                Wa(57880, d | 0) | 0;
	                Wa(57952, d | 0) | 0;
	                Wa(58016, d | 0) | 0;
	                Wa(58088, d | 0) | 0;
	                Wa(58160, d | 0) | 0;
	                Wa(58192, d | 0) | 0;
	                Wa(58248, d | 0) | 0;
	                Wa(58304, d | 0) | 0;
	                Wa(58352, d | 0) | 0;
	                Wa(58384, d | 0) | 0;
	                Wa(58448, d | 0) | 0;
	                Wa(58496, d | 0) | 0;
	                Wa(58544, d | 0) | 0;
	                Wa(58616, d | 0) | 0;
	                Wa(58648, d | 0) | 0;
	                Wa(58712, d | 0) | 0;
	                Wa(58776, d | 0) | 0;
	                Wa(58824, d | 0) | 0;
	                Wa(58880, d | 0) | 0;
	                Wa(58928, d | 0) | 0;
	                Wa(58984, d | 0) | 0;
	                Wa(59040, d | 0) | 0;
	                Wa(59096, d | 0) | 0;
	                Wa(59144, d | 0) | 0;
	                Wa(59208, d | 0) | 0;
	                Wa(59280, d | 0) | 0;
	                Wa(59344, d | 0) | 0;
	                Wa(59408, d | 0) | 0;
	                Wa(59480, d | 0) | 0;
	                Wa(59536, d | 0) | 0;
	                Wa(59576, d | 0) | 0;
	                Wa(59640, d | 0) | 0;
	                c[d >> 2] = 59736;
	                Wa(59696, d | 0) | 0;
	                Wa(59760, d | 0) | 0;
	                Wa(59800, d | 0) | 0;
	                Wa(59848, d | 0) | 0;
	                Wa(59888, d | 0) | 0;
	                Wa(59952, d | 0) | 0;
	                Wa(60008, d | 0) | 0;
	                Wa(60048, d | 0) | 0;
	                Wa(60120, d | 0) | 0;
	                Wa(60192, d | 0) | 0;
	                Wa(60256, d | 0) | 0;
	                Wa(60312, d | 0) | 0;
	                Wa(60368, d | 0) | 0;
	                Wa(60432, d | 0) | 0;
	                Wa(60496, d | 0) | 0;
	                Wa(60560, d | 0) | 0;
	                Wa(60616, d | 0) | 0;
	                Wa(60680, d | 0) | 0;
	                Wa(60744, d | 0) | 0;
	                Wa(60808, d | 0) | 0;
	                Wa(60856, d | 0) | 0;
	                i = b;
	                return
	            }

	            function Ub(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 8 | 0;
	                c[e >> 2] = a;
	                a = c[o >> 2] | 0;
	                f = c[33946] | 0;
	                c[d >> 2] = c[e >> 2];
	                c[d + 4 >> 2] = f;
	                Ka(a | 0, 56440, d | 0) | 0;
	                Ka(c[o >> 2] | 0, 56472, d | 0) | 0;
	                if (Me(1) | 0)Ka(c[o >> 2] | 0, 56496, d | 0) | 0;
	                if (Me(2) | 0)Ka(c[o >> 2] | 0, 56512, d | 0) | 0;
	                if (Me(3) | 0)Ka(c[o >> 2] | 0, 56520, d | 0) | 0;
	                if (Me(4) | 0)Ka(c[o >> 2] | 0, 56528, d | 0) | 0;
	                if (Me(5) | 0)Ka(c[o >> 2] | 0, 56536, d | 0) | 0;
	                if (Me(6) | 0)Ka(c[o >> 2] | 0, 56544, d | 0) | 0;
	                if (Me(7) | 0)Ka(c[o >> 2] | 0, 56560, d | 0) | 0;
	                if (Me(8) | 0)Ka(c[o >> 2] | 0, 56568, d | 0) | 0;
	                if (Me(9) | 0)Ka(c[o >> 2] | 0, 56576, d | 0) | 0;
	                if (Me(10) | 0)Ka(c[o >> 2] | 0, 56584, d | 0) | 0;
	                if (Me(11) | 0)Ka(c[o >> 2] | 0, 56592, d | 0) | 0;
	                if (Me(12) | 0)Ka(c[o >> 2] | 0, 56608, d | 0) | 0;
	                if (Me(13) | 0)Ka(c[o >> 2] | 0, 56616, d | 0) | 0;
	                if (Me(14) | 0)Ka(c[o >> 2] | 0, 56624, d | 0) | 0;
	                if (Me(15) | 0)Ka(c[o >> 2] | 0, 56632, d | 0) | 0;
	                if (Me(16) | 0)Ka(c[o >> 2] | 0, 56648, d | 0) | 0;
	                if (Me(17) | 0)Ka(c[o >> 2] | 0, 56656, d | 0) | 0;
	                if (Me(18) | 0)Ka(c[o >> 2] | 0, 56672, d | 0) | 0;
	                if (Me(19) | 0)Ka(c[o >> 2] | 0, 56688, d | 0) | 0;
	                if (Me(20) | 0)Ka(c[o >> 2] | 0, 56696, d | 0) | 0;
	                if (Me(21) | 0)Ka(c[o >> 2] | 0, 56712, d | 0) | 0;
	                if (Me(22) | 0)Ka(c[o >> 2] | 0, 56728, d | 0) | 0;
	                if (Me(23) | 0)Ka(c[o >> 2] | 0, 56744, d | 0) | 0;
	                if (Me(24) | 0)Ka(c[o >> 2] | 0, 56760, d | 0) | 0;
	                if (Me(25) | 0)Ka(c[o >> 2] | 0, 56768, d | 0) | 0;
	                if (Me(26) | 0)Ka(c[o >> 2] | 0, 56784, d | 0) | 0;
	                if (Me(27) | 0)Ka(c[o >> 2] | 0, 56800, d | 0) | 0;
	                if (Me(28) | 0)Ka(c[o >> 2] | 0, 56816, d | 0) | 0;
	                if (Me(29) | 0)Ka(c[o >> 2] | 0, 56824, d | 0) | 0;
	                if (Me(30) | 0)Ka(c[o >> 2] | 0, 56840, d | 0) | 0;
	                if (Me(31) | 0)Ka(c[o >> 2] | 0, 56856, d | 0) | 0;
	                if (!(Me(33) | 0)) {
	                    g = c[o >> 2] | 0;
	                    Ka(g | 0, 3760, d | 0) | 0;
	                    i = b;
	                    return
	                }
	                Ka(c[o >> 2] | 0, 56864, d | 0) | 0;
	                g = c[o >> 2] | 0;
	                Ka(g | 0, 3760, d | 0) | 0;
	                i = b;
	                return
	            }

	            function Vb(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ql(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Wb(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = nl(c[e >> 2] | 0) | 0;
	                if ((c[f >> 2] | 0) != 0 ? (e = tl() | 0, (e | 0) > (c[432] | 0)) : 0) {
	                    Vc();
	                    ql(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Xb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = pl(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if ((c[h >> 2] | 0) != 0 ? (g = tl() | 0, (g | 0) > (c[432] | 0)) : 0) {
	                    Vc();
	                    ql(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Yb(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = sl(c[e >> 2] | 0) | 0;
	                if ((c[f >> 2] | 0) != 0 ? (e = tl() | 0, (e | 0) > (c[432] | 0)) : 0) {
	                    Vc();
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Zb(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                while (1) {
	                    if (!(d[c[f >> 2] >> 0] | 0)) {
	                        h = 20;
	                        break
	                    }
	                    if ((c[13962] | 0) >= 64)break;
	                    c[g >> 2] = c[f >> 2];
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)j = 1; else j = (d[c[g >> 2] >> 0] | 0 | 0) == 58;
	                        k = c[g >> 2] | 0;
	                        if (!j)break;
	                        c[g >> 2] = k + 1
	                    }
	                    c[f >> 2] = k;
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) != 0 ? (d[c[g >> 2] >> 0] | 0 | 0) != 32 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) != 58; else l = 0;
	                        m = c[g >> 2] | 0;
	                        if (!l)break;
	                        c[g >> 2] = m + 1
	                    }
	                    if ((m | 0) == (c[f >> 2] | 0))continue;
	                    a = ly(c[f >> 2] | 0, (c[g >> 2] | 0) - (c[f >> 2] | 0) | 0) | 0;
	                    c[55888 + (c[13962] << 2) >> 2] = a;
	                    if (c[55888 + (c[13962] << 2) >> 2] | 0)c[13962] = (c[13962] | 0) + 1;
	                    c[f >> 2] = c[g >> 2]
	                }
	                if ((h | 0) == 20) {
	                    i = b;
	                    return
	                }
	                Ka(c[o >> 2] | 0, 56360, e | 0) | 0;
	                i = b;
	                return
	            }

	            function _b(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                c[d >> 2] = a;
	                a = iT(4) | 0;
	                c[c[d >> 2] >> 2] = a;
	                if (!(c[c[d >> 2] >> 2] | 0)) {
	                    Ka(c[o >> 2] | 0, 56312, b | 0) | 0;
	                    qb(9)
	                } else {
	                    c[c[c[d >> 2] >> 2] >> 2] = -2123209900;
	                    c[704] = (c[704] | 0) + 1;
	                    i = b;
	                    return
	                }
	            }

	            function $b(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[c[d >> 2] >> 2] | 0))Ea(56200, 56224, 3119, 56248);
	                if ((c[c[c[d >> 2] >> 2] >> 2] | 0) == -2123209900) {
	                    jT(c[c[d >> 2] >> 2] | 0);
	                    c[704] = (c[704] | 0) + -1;
	                    i = b;
	                    return
	                } else Ea(56264, 56224, 3120, 56248)
	            }

	            function ac(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f;
	                h = f + 48 | 0;
	                j = f + 44 | 0;
	                k = f + 40 | 0;
	                l = f + 36 | 0;
	                m = f + 32 | 0;
	                n = f + 28 | 0;
	                p = f + 24 | 0;
	                q = f + 20 | 0;
	                r = f + 16 | 0;
	                s = f + 12 | 0;
	                t = f + 8 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                c[p >> 2] = 0;
	                c[r >> 2] = c[j >> 2];
	                c[s >> 2] = c[j >> 2];
	                a:do if ((c[13962] | 0) > 0 & (c[s >> 2] | 0) != 0)while (1) {
	                    if (!(a[c[s >> 2] >> 0] | 0))break a;
	                    if ((a[c[s >> 2] >> 0] | 0) == 47)c[r >> 2] = (c[s >> 2] | 0) + 1;
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                } while (0);
	                if ((c[l >> 2] | 0) != 0 ? (c[c[l >> 2] >> 2] | 0) != 0 : 0) {
	                    c[n >> 2] = c[(c[c[l >> 2] >> 2] | 0) + 84 >> 2];
	                    c[p >> 2] = c[(c[c[l >> 2] >> 2] | 0) + 88 >> 2];
	                    c[(c[c[l >> 2] >> 2] | 0) + 84 >> 2] = 0;
	                    c[(c[c[l >> 2] >> 2] | 0) + 88 >> 2] = 0
	                }
	                if ((c[592] | 0) != 0 ? (c[m >> 2] = vb[c[2368 >> 2] & 511](c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0, (c[m >> 2] | 0) != 0) : 0) {
	                    if (c[n >> 2] | 0)c[(c[c[l >> 2] >> 2] | 0) + 84 >> 2] = c[n >> 2];
	                    if (c[p >> 2] | 0)c[(c[c[l >> 2] >> 2] | 0) + 88 >> 2] = c[p >> 2];
	                    if (c[534] | 0) {
	                        s = c[o >> 2] | 0;
	                        e = (c[k >> 2] | 0) != 0 ? c[k >> 2] | 0 : 55152;
	                        c[g >> 2] = (c[j >> 2] | 0) != 0 ? c[j >> 2] | 0 : 55152;
	                        c[g + 4 >> 2] = e;
	                        Ka(s | 0, 55856, g | 0) | 0
	                    }
	                    c[h >> 2] = c[m >> 2];
	                    u = c[h >> 2] | 0;
	                    i = f;
	                    return u | 0
	                }
	                c[q >> 2] = 0;
	                while (1) {
	                    if ((c[q >> 2] | 0) >= (c[13962] | 0))break;
	                    c[t >> 2] = my(c[55888 + (c[q >> 2] << 2) >> 2] | 0) | 0;
	                    c[t >> 2] = By(c[t >> 2] | 0, 56152) | 0;
	                    c[t >> 2] = By(c[t >> 2] | 0, c[r >> 2] | 0) | 0;
	                    if (c[t >> 2] | 0) {
	                        c[m >> 2] = vb[c[2368 >> 2] & 511](c[t >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (c[m >> 2] | 0) {
	                            v = 22;
	                            break
	                        }
	                        zb[c[135736 >> 2] & 511](c[t >> 2] | 0)
	                    }
	                    c[q >> 2] = (c[q >> 2] | 0) + 1
	                }
	                if ((v | 0) == 22) {
	                    if (c[n >> 2] | 0)c[(c[c[l >> 2] >> 2] | 0) + 84 >> 2] = c[n >> 2];
	                    if (c[p >> 2] | 0)c[(c[c[l >> 2] >> 2] | 0) + 88 >> 2] = c[p >> 2];
	                    if (c[534] | 0) {
	                        v = c[o >> 2] | 0;
	                        q = (c[k >> 2] | 0) != 0 ? c[k >> 2] | 0 : 55152;
	                        c[g >> 2] = c[t >> 2];
	                        c[g + 4 >> 2] = q;
	                        Ka(v | 0, 55856, g | 0) | 0
	                    }
	                    zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                    c[h >> 2] = c[m >> 2];
	                    u = c[h >> 2] | 0;
	                    i = f;
	                    return u | 0
	                }
	                if (c[p >> 2] | 0)c[(c[c[l >> 2] >> 2] | 0) + 88 >> 2] = c[p >> 2];
	                do if (c[n >> 2] | 0) {
	                    c[(c[c[l >> 2] >> 2] | 0) + 84 >> 2] = c[n >> 2];
	                    if (c[j >> 2] | 0) {
	                        p = c[n >> 2] | 0;
	                        m = c[l >> 2] | 0;
	                        c[g >> 2] = c[j >> 2];
	                        Db[p & 511](m, 56160, g);
	                        break
	                    }
	                    if (c[k >> 2] | 0) {
	                        m = c[n >> 2] | 0;
	                        p = c[l >> 2] | 0;
	                        c[g >> 2] = c[k >> 2];
	                        Db[m & 511](p, 56160, g)
	                    }
	                } while (0);
	                c[h >> 2] = 0;
	                u = c[h >> 2] | 0;
	                i = f;
	                return u | 0
	            }

	            function bc() {
	                var a = 0;
	                a = i;
	                mb(55824, 0) | 0;
	                i = a;
	                return
	            }

	            function cc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 8 | 0;
	                c[f >> 2] = a;
	                mb(55816, 0) | 0;
	                c[g >> 2] = (c[13954] | 0) - (c[13956] | 0);
	                c[g >> 2] = (c[g >> 2] | 0) * 1e3;
	                c[g >> 2] = (c[g >> 2] | 0) + (((c[13955] | 0) - (c[13957] | 0) | 0) / 1e3 | 0);
	                c[h >> 2] = b;
	                Ca(c[o >> 2] | 0, c[f >> 2] | 0, h | 0) | 0;
	                h = c[o >> 2] | 0;
	                c[e >> 2] = c[g >> 2];
	                Ka(h | 0, 55832, e | 0) | 0;
	                i = d;
	                return
	            }

	            function dc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 112 | 0;
	                d = b;
	                e = b + 100 | 0;
	                f = b + 96 | 0;
	                g = b + 92 | 0;
	                h = b + 88 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                c[e >> 2] = a;
	                c[h >> 2] = -1;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                a = c[e >> 2] | 0;
	                do if (c[290] | 0) {
	                    if (($a(a | 0, j | 0) | 0) < 0) {
	                        i = b;
	                        return
	                    }
	                    m = La(c[e >> 2] | 0, 0, d | 0) | 0;
	                    c[h >> 2] = m;
	                    if ((m | 0) < 0) {
	                        i = b;
	                        return
	                    }
	                    c[k >> 2] = ob(0, c[j + 36 >> 2] | 0, 1, 1, c[h >> 2] | 0, 0) | 0;
	                    if ((c[k >> 2] | 0) != (-1 | 0)) {
	                        c[f >> 2] = kM(c[k >> 2] | 0, c[j + 36 >> 2] | 0, c[e >> 2] | 0, 0, c[68] | 0) | 0;
	                        break
	                    }
	                    Ra(c[h >> 2] | 0) | 0;
	                    m = c[o >> 2] | 0;
	                    c[d >> 2] = c[e >> 2];
	                    Ka(m | 0, 2920, d | 0) | 0;
	                    c[662] = 4;
	                    i = b;
	                    return
	                } else c[f >> 2] = lM(a, 0, c[68] | 0) | 0; while (0);
	                if ((c[548] | 0) != 0 ? (c[694] = MQ(c[548] | 0, 0, 0, 0) | 0, (c[694] | 0) == 0) : 0) {
	                    a = c[33976] | 0;
	                    m = c[33980] | 0;
	                    c[d >> 2] = c[548];
	                    Db[a & 511](m, 2784, d);
	                    c[662] = 7;
	                    c[548] = 0
	                }
	                if (((c[694] | 0) != 0 ? (c[898] = OQ(c[694] | 0) | 0, (c[898] | 0) != 0) : 0) ? (c[g >> 2] = HQ(c[898] | 0, 0, 0) | 0, (c[g >> 2] | 0) < 0) : 0) {
	                    Ka(c[o >> 2] | 0, 3600, d | 0) | 0;
	                    GQ(c[898] | 0);
	                    c[898] = 0
	                }
	                if (c[f >> 2] | 0) {
	                    if (!(c[196] | 0)) {
	                        if (c[180] | 0)dM(c[f >> 2] | 0, 1, 1) | 0
	                    } else dM(c[f >> 2] | 0, 3, 1) | 0;
	                    if (c[494] | 0) {
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                        c[g >> 2] = gM(c[f >> 2] | 0, c[494] | 0) | 0;
	                        if ((c[g >> 2] | 0) < 0) {
	                            m = c[33976] | 0;
	                            a = c[33980] | 0;
	                            c[d >> 2] = c[494];
	                            Db[m & 511](a, 2688, d);
	                            c[662] = 5;
	                            c[494] = 0
	                        }
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(2656, d)
	                    }
	                    if (c[502] | 0) {
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                        c[g >> 2] = fM(c[f >> 2] | 0, c[502] | 0) | 0;
	                        if ((c[g >> 2] | 0) < 0) {
	                            a = c[33976] | 0;
	                            m = c[33980] | 0;
	                            c[d >> 2] = c[502];
	                            Db[a & 511](m, 55704, d);
	                            c[662] = 5;
	                            c[502] = 0
	                        }
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(2656, d)
	                    }
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    c[g >> 2] = QL(c[f >> 2] | 0) | 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) != 1)break;
	                        if ((c[42] | 0) != 0 | (c[694] | 0) != 0)pc(c[f >> 2] | 0);
	                        c[g >> 2] = QL(c[f >> 2] | 0) | 0
	                    }
	                    do if (!((c[252] | 0) == 0 | (c[266] | 0) != 0)) {
	                        if (c[494] | 0) {
	                            cc(55744, d);
	                            break
	                        }
	                        if (c[196] | 0) {
	                            cc(55744, d);
	                            break
	                        } else {
	                            cc(2952, d);
	                            break
	                        }
	                    } while (0);
	                    if ((c[196] | 0) != 0 ? (hM(c[f >> 2] | 0) | 0) != 1 : 0) {
	                        m = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[d >> 2] = c[e >> 2];
	                        Db[m & 511](a, 3448, d);
	                        c[662] = 3
	                    }
	                    do if ((c[494] | 0) != 0 | (c[502] | 0) != 0) {
	                        a = (hM(c[f >> 2] | 0) | 0) != 1;
	                        m = c[o >> 2] | 0;
	                        n = c[e >> 2] | 0;
	                        if (a) {
	                            c[d >> 2] = n;
	                            Ka(m | 0, 3512, d | 0) | 0;
	                            c[662] = 3;
	                            break
	                        } else {
	                            c[d >> 2] = n;
	                            Ka(m | 0, 3496, d | 0) | 0;
	                            break
	                        }
	                    } while (0);
	                    VL(c[f >> 2] | 0);
	                    if (c[g >> 2] | 0) {
	                        g = c[o >> 2] | 0;
	                        c[d >> 2] = c[e >> 2];
	                        Ka(g | 0, 55768, d | 0) | 0;
	                        c[662] = 1
	                    }
	                } else {
	                    g = c[o >> 2] | 0;
	                    c[d >> 2] = c[e >> 2];
	                    Ka(g | 0, 55792, d | 0) | 0;
	                    c[662] = 1
	                }
	                if (c[898] | 0) {
	                    GQ(c[898] | 0);
	                    c[898] = 0
	                }
	                if (!(c[290] | 0)) {
	                    i = b;
	                    return
	                }
	                yk(c[l >> 2] | 0);
	                Ta(c[k >> 2] | 0, c[j + 36 >> 2] | 0) | 0;
	                Ra(c[h >> 2] | 0) | 0;
	                i = b;
	                return
	            }

	            function ec(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b;
	                e = b + 36 | 0;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                c[e >> 2] = a;
	                c[g >> 2] = 54320;
	                c[h >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[13584] = 0;
	                do if (!(c[50] | 0))if (c[468] | 0) {
	                    c[f >> 2] = c[34];
	                    break
	                } else {
	                    c[f >> 2] = c[13588];
	                    break
	                } else c[f >> 2] = c[13586]; while (0);
	                c[h >> 2] = Ck(c[e >> 2] | 0, 0) | 0;
	                do if (c[h >> 2] | 0) {
	                    if (!(c[682] | 0)) {
	                        c[k >> 2] = Be() | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            yk(c[h >> 2] | 0);
	                            break
	                        }
	                        c[l >> 2] = c[c[k >> 2] >> 2];
	                        c[c[k >> 2] >> 2] = c[f >> 2];
	                        c[(c[k >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                        c[j >> 2] = ve(c[k >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            yk(c[h >> 2] | 0);
	                            break
	                        }
	                        Oe(c[k >> 2] | 0, c[j >> 2] | 0) | 0;
	                        Qf(c[k >> 2] | 0) | 0;
	                        if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))break;
	                        Ka(c[o >> 2] | 0, 54360, d | 0) | 0;
	                        Th(c[(c[k >> 2] | 0) + 8 >> 2] | 0);
	                        c[(c[k >> 2] | 0) + 8 >> 2] = 0;
	                        break
	                    }
	                    c[n >> 2] = eB(c[682] | 0) | 0;
	                    bB(c[n >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                    fB(c[n >> 2] | 0, c[e >> 2] | 0);
	                    c[m >> 2] = lB(c[n >> 2] | 0, c[h >> 2] | 0, 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    do if (!(c[266] | 0)) {
	                        if (!(c[m >> 2] | 0)) {
	                            a = c[o >> 2] | 0;
	                            c[d >> 2] = c[e >> 2];
	                            Ka(a | 0, 3496, d | 0) | 0;
	                            break
	                        }
	                        a = c[o >> 2] | 0;
	                        p = c[e >> 2] | 0;
	                        if ((c[m >> 2] | 0) > 0) {
	                            c[d >> 2] = p;
	                            Ka(a | 0, 3512, d | 0) | 0;
	                            c[662] = 3;
	                            break
	                        } else {
	                            c[d >> 2] = p;
	                            Ka(a | 0, 3536, d | 0) | 0;
	                            c[662] = 3;
	                            break
	                        }
	                    } while (0);
	                    ZA(c[n >> 2] | 0)
	                } while (0);
	                if (!(c[k >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[c[k >> 2] >> 2] = c[l >> 2];
	                Ae(c[k >> 2] | 0);
	                i = b;
	                return
	            }

	            function fc(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0;
	                e = i;
	                i = i + 6512 | 0;
	                f = e;
	                g = e + 1376 | 0;
	                h = e + 1372 | 0;
	                j = e + 1368 | 0;
	                k = e + 1364 | 0;
	                l = e + 1360 | 0;
	                m = e + 1356 | 0;
	                n = e + 1352 | 0;
	                r = e + 2408 | 0;
	                s = e + 1348 | 0;
	                t = e + 1344 | 0;
	                u = e + 1268 | 0;
	                v = e + 1264 | 0;
	                w = e + 1260 | 0;
	                x = e + 1256 | 0;
	                y = e + 1252 | 0;
	                z = e + 1248 | 0;
	                A = e + 1384 | 0;
	                B = e + 1244 | 0;
	                C = e + 1240 | 0;
	                D = e + 1236 | 0;
	                E = e + 1232 | 0;
	                F = e + 1156 | 0;
	                G = e + 1152 | 0;
	                H = e + 1148 | 0;
	                I = e + 1144 | 0;
	                J = e + 120 | 0;
	                K = e + 112 | 0;
	                L = e + 108 | 0;
	                M = e + 104 | 0;
	                N = e + 100 | 0;
	                O = e + 96 | 0;
	                P = e + 92 | 0;
	                Q = e + 88 | 0;
	                R = e + 84 | 0;
	                S = e + 80 | 0;
	                T = e + 76 | 0;
	                U = e + 72 | 0;
	                V = e + 68 | 0;
	                W = e + 64 | 0;
	                X = e + 60 | 0;
	                Y = e + 56 | 0;
	                Z = e + 52 | 0;
	                _ = e + 48 | 0;
	                $ = e + 44 | 0;
	                aa = e + 40 | 0;
	                ba = e + 36 | 0;
	                ca = e + 32 | 0;
	                da = e + 28 | 0;
	                ea = e + 24 | 0;
	                fa = e + 20 | 0;
	                ga = e + 16 | 0;
	                ha = e + 12 | 0;
	                ia = e + 8 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                do if (!(c[g >> 2] | 0)) {
	                    if (c[258] | 0) {
	                        c[j >> 2] = Sh(2888) | 0;
	                        c[l >> 2] = ji(c[j >> 2] | 0, 0, 2896, 0) | 0;
	                        vi(c[l >> 2] | 0, 2904);
	                        Qi(c[j >> 2] | 0, c[l >> 2] | 0) | 0
	                    }
	                } else {
	                    if ((c[152] | 0) != 0 & (c[272] | 0) != 0) {
	                        c[m >> 2] = pb(c[g >> 2] | 0, 2912) | 0;
	                        if (!(c[m >> 2] | 0))break;
	                        c[n >> 2] = Aa(r | 0, 1, 4, c[m >> 2] | 0) | 0;
	                        if ((c[n >> 2] | 0) > 0) {
	                            c[s >> 2] = po(0, 0, r, c[n >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                            fg(c[s >> 2] | 0, c[68] | 0) | 0;
	                            while (1) {
	                                d = Aa(r | 0, 1, c[282] | 0, c[m >> 2] | 0) | 0;
	                                c[n >> 2] = d;
	                                ja = c[s >> 2] | 0;
	                                if ((d | 0) <= 0)break;
	                                oo(ja, r, c[n >> 2] | 0, 0) | 0
	                            }
	                            oo(ja, r, 0, 1) | 0;
	                            c[j >> 2] = c[(c[s >> 2] | 0) + 8 >> 2];
	                            lo(c[s >> 2] | 0)
	                        }
	                        Xa(c[m >> 2] | 0) | 0;
	                        break
	                    }
	                    if ((c[152] | 0) != 0 & (c[290] | 0) != 0) {
	                        if (($a(c[g >> 2] | 0, u | 0) | 0) < 0) {
	                            i = e;
	                            return
	                        }
	                        d = La(c[g >> 2] | 0, 0, f | 0) | 0;
	                        c[t >> 2] = d;
	                        if ((d | 0) < 0) {
	                            i = e;
	                            return
	                        }
	                        c[v >> 2] = ob(0, c[u + 36 >> 2] | 0, 1, 1, c[t >> 2] | 0, 0) | 0;
	                        if ((c[v >> 2] | 0) != (-1 | 0)) {
	                            c[j >> 2] = vo(c[v >> 2] | 0, c[u + 36 >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                            Ta(c[v >> 2] | 0, c[u + 36 >> 2] | 0) | 0;
	                            Ra(c[t >> 2] | 0) | 0;
	                            break
	                        }
	                        Ra(c[t >> 2] | 0) | 0;
	                        d = c[o >> 2] | 0;
	                        c[f >> 2] = c[g >> 2];
	                        Ka(d | 0, 2920, f | 0) | 0;
	                        c[662] = 4;
	                        i = e;
	                        return
	                    }
	                    if (c[152] | 0) {
	                        c[j >> 2] = uo(c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                        break
	                    }
	                    if (c[272] | 0) {
	                        if ((a[c[g >> 2] >> 0] | 0) == 45 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 0 : 0)c[w >> 2] = c[p >> 2]; else c[w >> 2] = pb(c[g >> 2] | 0, 2912) | 0;
	                        if (!(c[w >> 2] | 0))break;
	                        c[z >> 2] = 1024;
	                        c[y >> 2] = Aa(A | 0, 1, 4, c[w >> 2] | 0) | 0;
	                        if ((c[y >> 2] | 0) > 0) {
	                            c[B >> 2] = Tf(0, 0, A, c[y >> 2] | 0, c[g >> 2] | 0) | 0;
	                            fg(c[B >> 2] | 0, c[68] | 0) | 0;
	                            while (1) {
	                                d = Aa(A | 0, 1, c[z >> 2] | 0, c[w >> 2] | 0) | 0;
	                                c[y >> 2] = d;
	                                ka = c[B >> 2] | 0;
	                                if ((d | 0) <= 0)break;
	                                Sf(ka, A, c[y >> 2] | 0, 0) | 0
	                            }
	                            Sf(ka, A, 0, 1) | 0;
	                            c[j >> 2] = c[(c[B >> 2] | 0) + 8 >> 2];
	                            c[x >> 2] = c[(c[B >> 2] | 0) + 12 >> 2];
	                            Ae(c[B >> 2] | 0);
	                            if (!(c[x >> 2] | 0)) {
	                                Th(c[j >> 2] | 0);
	                                c[j >> 2] = 0
	                            }
	                        }
	                        if ((c[w >> 2] | 0) == (c[p >> 2] | 0))break;
	                        Xa(c[w >> 2] | 0) | 0;
	                        break
	                    }
	                    if (c[298] | 0) {
	                        if ((a[c[g >> 2] >> 0] | 0) == 45 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 0 : 0) {
	                            c[j >> 2] = ig(0, 0, 0, c[68] | 0) | 0;
	                            break
	                        }
	                        c[C >> 2] = pb(c[g >> 2] | 0, 2912) | 0;
	                        if (!(c[C >> 2] | 0)) {
	                            c[j >> 2] = 0;
	                            break
	                        }
	                        if (!(c[h >> 2] | 0)) {
	                            c[j >> 2] = jg(204, 205, c[C >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                            break
	                        } else {
	                            c[j >> 2] = mg(c[h >> 2] | 0, 204, 205, c[C >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                            break
	                        }
	                    }
	                    if (c[138] | 0) {
	                        if (!(c[h >> 2] | 0))c[D >> 2] = Be() | 0; else c[D >> 2] = c[h >> 2];
	                        if (!(c[D >> 2] | 0)) {
	                            c[j >> 2] = 0;
	                            break
	                        }
	                        c[(c[c[D >> 2] >> 2] | 0) + 88 >> 2] = 206;
	                        c[(c[c[D >> 2] >> 2] | 0) + 84 >> 2] = 207;
	                        c[(c[D >> 2] | 0) + 112 >> 2] = 208;
	                        c[(c[D >> 2] | 0) + 116 >> 2] = 209;
	                        c[j >> 2] = kg(c[D >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                        if (c[h >> 2] | 0)break;
	                        Ae(c[D >> 2] | 0);
	                        break
	                    }
	                    if (c[290] | 0) {
	                        if (($a(c[g >> 2] | 0, F | 0) | 0) < 0) {
	                            i = e;
	                            return
	                        }
	                        d = La(c[g >> 2] | 0, 0, f | 0) | 0;
	                        c[E >> 2] = d;
	                        if ((d | 0) < 0) {
	                            i = e;
	                            return
	                        }
	                        c[G >> 2] = ob(0, c[F + 36 >> 2] | 0, 1, 1, c[E >> 2] | 0, 0) | 0;
	                        if ((c[G >> 2] | 0) == (-1 | 0)) {
	                            Ra(c[E >> 2] | 0) | 0;
	                            d = c[o >> 2] | 0;
	                            c[f >> 2] = c[g >> 2];
	                            Ka(d | 0, 2920, f | 0) | 0;
	                            c[662] = 4;
	                            i = e;
	                            return
	                        }
	                        if (!(c[h >> 2] | 0))c[j >> 2] = hg(c[G >> 2] | 0, c[F + 36 >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0; else c[j >> 2] = lg(c[h >> 2] | 0, c[G >> 2] | 0, c[F + 36 >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                        Ta(c[G >> 2] | 0, c[F + 36 >> 2] | 0) | 0;
	                        Ra(c[E >> 2] | 0) | 0;
	                        break
	                    }
	                    if (!(c[196] | 0)) {
	                        if (c[h >> 2] | 0) {
	                            c[j >> 2] = kg(c[h >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                            break
	                        }
	                        d = c[g >> 2] | 0;
	                        if (c[468] | 0) {
	                            c[j >> 2] = cg(d) | 0;
	                            break
	                        } else {
	                            c[j >> 2] = gg(d, 0, c[68] | 0) | 0;
	                            break
	                        }
	                    }
	                    c[H >> 2] = 0;
	                    if (!(c[h >> 2] | 0))c[H >> 2] = Be() | 0; else c[H >> 2] = c[h >> 2];
	                    if (!(c[H >> 2] | 0)) {
	                        c[j >> 2] = 0;
	                        break
	                    }
	                    c[j >> 2] = kg(c[H >> 2] | 0, c[g >> 2] | 0, 0, c[68] | 0) | 0;
	                    if (!(c[(c[H >> 2] | 0) + 100 >> 2] | 0))c[662] = 4;
	                    if (!(c[h >> 2] | 0))Ae(c[H >> 2] | 0)
	                } while (0);
	                if (!(c[j >> 2] | 0)) {
	                    c[662] = 1;
	                    i = e;
	                    return
	                }
	                if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(2952, f);
	                if ((c[236] | 0) != 0 ? (c[I >> 2] = Nh(c[j >> 2] | 0) | 0, (c[I >> 2] | 0) != 0) : 0) {
	                    Qh(c[I >> 2] | 0);
	                    Ph(c[I >> 2] | 0)
	                }
	                if (c[308] | 0) {
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    if ((Vv(c[j >> 2] | 0, c[68] | 0) | 0) < 0)c[662] = 1;
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(2960, f)
	                }
	                if (c[554] | 0)mc(c[j >> 2] | 0, c[554] | 0);
	                if (c[48] | 0) {
	                    Xq(c[j >> 2] | 0) | 0;
	                    Zp(c[j >> 2] | 0, c[g >> 2] | 0, 210, c[q >> 2] | 0)
	                }
	                if (c[56] | 0) {
	                    c[k >> 2] = c[j >> 2];
	                    if (c[252] | 0)bc();
	                    c[j >> 2] = Mi(c[j >> 2] | 0, 1) | 0;
	                    if (c[252] | 0)cc(2984, f);
	                    if (c[252] | 0)bc();
	                    Th(c[k >> 2] | 0);
	                    if (c[252] | 0)cc(2992, f)
	                }
	                a:do if ((c[244] | 0) == 0 | (c[152] | 0) != 0) {
	                    if (c[462] | 0)oc(c[j >> 2] | 0)
	                } else if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                    c[M >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (c[M >> 2] | 0)la = (c[(c[M >> 2] | 0) + 16 >> 2] | 0) == 0; else la = 0;
	                        ma = c[M >> 2] | 0;
	                        if (!la)break;
	                        c[M >> 2] = c[ma + 24 >> 2]
	                    }
	                    if (ma) {
	                        c[K >> 2] = hn(c[(c[M >> 2] | 0) + 16 >> 2] | 0, 0, J, 256) | 0;
	                        if ((c[K >> 2] | 0) < 0) {
	                            Ka(c[o >> 2] | 0, 3016, f | 0) | 0;
	                            break
	                        }
	                        k = c[o >> 2] | 0;
	                        if (!(c[K >> 2] | 0)) {
	                            Ka(k | 0, 3056, f | 0) | 0;
	                            break
	                        }
	                        c[f >> 2] = c[K >> 2];
	                        Ka(k | 0, 3096, f | 0) | 0;
	                        c[L >> 2] = 0;
	                        while (1) {
	                            if ((c[L >> 2] | 0) >= (c[K >> 2] | 0))break a;
	                            k = c[o >> 2] | 0;
	                            c[f >> 2] = c[J + (c[L >> 2] << 2) >> 2];
	                            Ka(k | 0, 3144, f | 0) | 0;
	                            c[L >> 2] = (c[L >> 2] | 0) + 1
	                        }
	                    }
	                } while (0);
	                do if (!(c[50] | 0)) {
	                    if (c[42] | 0) {
	                        if (!(c[128] | 0))c[_ >> 2] = c[q >> 2]; else c[_ >> 2] = pb(c[128] | 0, 3160) | 0;
	                        if (!(c[_ >> 2] | 0)) {
	                            L = c[o >> 2] | 0;
	                            c[f >> 2] = c[128];
	                            Ka(L | 0, 3168, f | 0) | 0;
	                            c[662] = 6;
	                            break
	                        }
	                        Mp(c[_ >> 2] | 0, c[j >> 2] | 0);
	                        if (!(c[128] | 0))break;
	                        Xa(c[_ >> 2] | 0) | 0;
	                        break
	                    }
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    do if (!((c[152] | 0) == 0 | (c[160] | 0) != 0)) {
	                        do if (c[788] | 0)Ap((c[128] | 0) != 0 ? c[128] | 0 : 144, c[j >> 2] | 0) | 0; else {
	                            L = (c[440] | 0) == 1;
	                            J = c[128] | 0;
	                            if (c[408] | 0) {
	                                K = (J | 0) != 0 ? c[128] | 0 : 144;
	                                M = c[j >> 2] | 0;
	                                ma = c[408] | 0;
	                                if (L) {
	                                    Bp(K, M, ma, 1) | 0;
	                                    break
	                                } else {
	                                    Bp(K, M, ma, 0) | 0;
	                                    break
	                                }
	                            }
	                            if (L) {
	                                Bp((J | 0) != 0 ? c[128] | 0 : 144, c[j >> 2] | 0, 0, 1) | 0;
	                                break
	                            }
	                            if (!J)c[O >> 2] = c[q >> 2]; else c[O >> 2] = pb(c[128] | 0, 3160) | 0;
	                            if (!(c[O >> 2] | 0)) {
	                                J = c[o >> 2] | 0;
	                                c[f >> 2] = c[128];
	                                Ka(J | 0, 3168, f | 0) | 0;
	                                c[662] = 6;
	                                break
	                            }
	                            if ((zp(c[O >> 2] | 0, c[j >> 2] | 0) | 0) < 0)c[662] = 6;
	                            if (!(c[128] | 0))break;
	                            Xa(c[O >> 2] | 0) | 0
	                        } while (0);
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3192, f)
	                    } else {
	                        if (c[362] | 0) {
	                            c[P >> 2] = 0;
	                            c[Q >> 2] = Dx(c[j >> 2] | 0, 0, 0, 0, 1, P) | 0;
	                            if ((c[Q >> 2] | 0) < 0) {
	                                Ka(c[o >> 2] | 0, 3224, f | 0) | 0;
	                                c[662] = 6;
	                                break
	                            }
	                            if ((Ya(1, c[P >> 2] | 0, c[Q >> 2] | 0) | 0) == -1)Ka(c[o >> 2] | 0, 3200, f | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[P >> 2] | 0);
	                            break
	                        }
	                        if (c[370] | 0) {
	                            c[R >> 2] = 0;
	                            c[S >> 2] = Dx(c[j >> 2] | 0, 0, 2, 0, 1, R) | 0;
	                            if ((c[S >> 2] | 0) < 0) {
	                                Ka(c[o >> 2] | 0, 3224, f | 0) | 0;
	                                c[662] = 6;
	                                break
	                            }
	                            if ((Ya(1, c[R >> 2] | 0, c[S >> 2] | 0) | 0) == -1)Ka(c[o >> 2] | 0, 3200, f | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[R >> 2] | 0);
	                            break
	                        }
	                        if (c[380] | 0) {
	                            c[T >> 2] = 0;
	                            c[U >> 2] = Dx(c[j >> 2] | 0, 0, 1, 0, 1, T) | 0;
	                            if ((c[U >> 2] | 0) < 0) {
	                                Ka(c[o >> 2] | 0, 3224, f | 0) | 0;
	                                c[662] = 6;
	                                break
	                            }
	                            if ((Ya(1, c[T >> 2] | 0, c[U >> 2] | 0) | 0) == -1)Ka(c[o >> 2] | 0, 3200, f | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[T >> 2] | 0);
	                            break
	                        }
	                        if (c[290] | 0) {
	                            J = (c[440] | 0) == 1;
	                            L = c[j >> 2] | 0;
	                            do if (c[408] | 0) {
	                                ma = c[408] | 0;
	                                if (J) {
	                                    AR(L, V, W, ma, 1);
	                                    break
	                                } else {
	                                    DR(L, V, W, ma);
	                                    break
	                                }
	                            } else if (J) {
	                                CR(L, V, W, 1);
	                                break
	                            } else {
	                                BR(L, V, W);
	                                break
	                            } while (0);
	                            if (!(c[V >> 2] | 0)) {
	                                Ka(c[o >> 2] | 0, 3248, f | 0) | 0;
	                                c[662] = 6;
	                                break
	                            }
	                            if ((Ya(1, c[V >> 2] | 0, c[W >> 2] | 0) | 0) == -1)Ka(c[o >> 2] | 0, 3200, f | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[V >> 2] | 0);
	                            break
	                        }
	                        if (c[788] | 0) {
	                            JR((c[128] | 0) != 0 ? c[128] | 0 : 144, c[j >> 2] | 0) | 0;
	                            break
	                        }
	                        if (!(c[816] | 0)) {
	                            c[Z >> 2] = 0;
	                            do if ((c[440] | 0) == 1)c[Z >> 2] = c[Z >> 2] | 1; else {
	                                if ((c[440] | 0) != 2)break;
	                                c[Z >> 2] = c[Z >> 2] | 128
	                            } while (0);
	                            if (c[160] | 0)c[Z >> 2] = c[Z >> 2] | 32;
	                            if (!(c[128] | 0))c[Y >> 2] = rR(1, c[408] | 0, c[Z >> 2] | 0) | 0; else c[Y >> 2] = sR(c[128] | 0, c[408] | 0, c[Z >> 2] | 0) | 0;
	                            if (!(c[Y >> 2] | 0)) {
	                                c[662] = 6;
	                                break
	                            }
	                            if ((tR(c[Y >> 2] | 0, c[j >> 2] | 0) | 0) < 0) {
	                                L = c[o >> 2] | 0;
	                                c[f >> 2] = (c[128] | 0) != 0 ? c[128] | 0 : 144;
	                                Ka(L | 0, 3272, f | 0) | 0;
	                                c[662] = 6
	                            }
	                            wR(c[Y >> 2] | 0) | 0;
	                            break
	                        }
	                        L = (c[440] | 0) == 1;
	                        J = c[128] | 0;
	                        if (c[408] | 0) {
	                            ma = (J | 0) != 0 ? c[128] | 0 : 144;
	                            M = c[j >> 2] | 0;
	                            K = c[408] | 0;
	                            if (L)c[N >> 2] = GR(ma, M, K, 1) | 0; else c[N >> 2] = HR(ma, M, K) | 0;
	                            if ((c[N >> 2] | 0) >= 0)break;
	                            K = c[o >> 2] | 0;
	                            c[f >> 2] = (c[128] | 0) != 0 ? c[128] | 0 : 144;
	                            Ka(K | 0, 3272, f | 0) | 0;
	                            c[662] = 6;
	                            break
	                        }
	                        if (L) {
	                            c[N >> 2] = IR((J | 0) != 0 ? c[128] | 0 : 144, c[j >> 2] | 0, 1) | 0;
	                            if ((c[N >> 2] | 0) >= 0)break;
	                            L = c[o >> 2] | 0;
	                            c[f >> 2] = (c[128] | 0) != 0 ? c[128] | 0 : 144;
	                            Ka(L | 0, 3272, f | 0) | 0;
	                            c[662] = 6;
	                            break
	                        }
	                        if (!J)c[X >> 2] = c[q >> 2]; else c[X >> 2] = pb(c[128] | 0, 3160) | 0;
	                        if (!(c[X >> 2] | 0)) {
	                            J = c[o >> 2] | 0;
	                            c[f >> 2] = c[128];
	                            Ka(J | 0, 3168, f | 0) | 0;
	                            c[662] = 6;
	                            break
	                        }
	                        if ((FR(c[X >> 2] | 0, c[j >> 2] | 0) | 0) < 0)c[662] = 6;
	                        if (!(c[128] | 0))break;
	                        Xa(c[X >> 2] | 0) | 0
	                    } while (0);
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3192, f)
	                } while (0);
	                do if (!((c[216] | 0) != 0 | (c[226] | 0) != 0)) {
	                    if (c[206] | 0) {
	                        X = gm() | 0;
	                        c[ba >> 2] = X;
	                        if (!X) {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 3336, f);
	                            qb(-1)
	                        }
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                        c[c[ba >> 2] >> 2] = c[o >> 2];
	                        c[(c[ba >> 2] | 0) + 4 >> 2] = 203;
	                        c[(c[ba >> 2] | 0) + 8 >> 2] = 203;
	                        if (!(fn(c[ba >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                            X = c[33976] | 0;
	                            N = c[33980] | 0;
	                            c[f >> 2] = c[g >> 2];
	                            Db[X & 511](N, 3448, f);
	                            c[662] = 3
	                        }
	                        if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3480, f);
	                        hm(c[ba >> 2] | 0)
	                    }
	                } else {
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    if (c[216] | 0)c[$ >> 2] = Wf(0, c[216] | 0) | 0; else c[$ >> 2] = Wf(c[226] | 0, 0) | 0;
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3296, f);
	                    if (!(c[$ >> 2] | 0)) {
	                        N = c[33976] | 0;
	                        X = c[33980] | 0;
	                        if (c[216] | 0) {
	                            c[f >> 2] = c[216];
	                            Db[N & 511](X, 3312, f)
	                        } else {
	                            c[f >> 2] = c[226];
	                            Db[N & 511](X, 3312, f)
	                        }
	                        c[662] = 2;
	                        break
	                    }
	                    X = gm() | 0;
	                    c[aa >> 2] = X;
	                    if (!X) {
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 3336, f);
	                        qb(-1)
	                    }
	                    c[c[aa >> 2] >> 2] = c[o >> 2];
	                    c[(c[aa >> 2] | 0) + 4 >> 2] = 203;
	                    c[(c[aa >> 2] | 0) + 8 >> 2] = 203;
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    if (!(dn(c[aa >> 2] | 0, c[j >> 2] | 0, c[$ >> 2] | 0) | 0)) {
	                        X = c[33976] | 0;
	                        N = c[33980] | 0;
	                        Y = c[g >> 2] | 0;
	                        if (c[216] | 0) {
	                            Z = c[216] | 0;
	                            c[f >> 2] = Y;
	                            c[f + 4 >> 2] = Z;
	                            Db[X & 511](N, 3376, f)
	                        } else {
	                            Z = c[226] | 0;
	                            c[f >> 2] = Y;
	                            c[f + 4 >> 2] = Z;
	                            Db[X & 511](N, 3376, f)
	                        }
	                        c[662] = 3
	                    }
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3424, f);
	                    hm(c[aa >> 2] | 0);
	                    Ph(c[$ >> 2] | 0)
	                } while (0);
	                if (c[650] | 0) {
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    if (c[42] | 0)c[ea >> 2] = 4; else c[ea >> 2] = 2;
	                    if (c[50] | 0)c[ea >> 2] = c[ea >> 2] | 1;
	                    c[ca >> 2] = lS(c[650] | 0, c[ea >> 2] | 0) | 0;
	                    c[da >> 2] = nS(c[ca >> 2] | 0, c[j >> 2] | 0) | 0;
	                    do if (c[da >> 2] | 0) {
	                        ea = c[o >> 2] | 0;
	                        $ = c[g >> 2] | 0;
	                        if ((c[da >> 2] | 0) > 0) {
	                            c[f >> 2] = $;
	                            Ka(ea | 0, 3512, f | 0) | 0;
	                            c[662] = 3;
	                            break
	                        } else {
	                            c[f >> 2] = $;
	                            Ka(ea | 0, 3536, f | 0) | 0;
	                            c[662] = 3;
	                            break
	                        }
	                    } else {
	                        ea = c[o >> 2] | 0;
	                        c[f >> 2] = c[g >> 2];
	                        Ka(ea | 0, 3496, f | 0) | 0
	                    } while (0);
	                    mS(c[ca >> 2] | 0);
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3480, f)
	                }
	                if (c[670] | 0) {
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    c[fa >> 2] = eN(c[670] | 0) | 0;
	                    gN(c[fa >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                    c[ga >> 2] = iN(c[fa >> 2] | 0, c[j >> 2] | 0) | 0;
	                    do if (c[ga >> 2] | 0) {
	                        ca = c[o >> 2] | 0;
	                        da = c[g >> 2] | 0;
	                        if ((c[ga >> 2] | 0) > 0) {
	                            c[f >> 2] = da;
	                            Ka(ca | 0, 3512, f | 0) | 0;
	                            c[662] = 3;
	                            break
	                        } else {
	                            c[f >> 2] = da;
	                            Ka(ca | 0, 3536, f | 0) | 0;
	                            c[662] = 3;
	                            break
	                        }
	                    } else {
	                        ca = c[o >> 2] | 0;
	                        c[f >> 2] = c[g >> 2];
	                        Ka(ca | 0, 3496, f | 0) | 0
	                    } while (0);
	                    fN(c[fa >> 2] | 0);
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3480, f)
	                } else if (c[682] | 0) {
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    c[ha >> 2] = eB(c[682] | 0) | 0;
	                    bB(c[ha >> 2] | 0, 203, 203, c[o >> 2] | 0);
	                    c[ia >> 2] = hB(c[ha >> 2] | 0, c[j >> 2] | 0) | 0;
	                    do if (c[ia >> 2] | 0) {
	                        fa = c[o >> 2] | 0;
	                        ga = c[g >> 2] | 0;
	                        if ((c[ia >> 2] | 0) > 0) {
	                            c[f >> 2] = ga;
	                            Ka(fa | 0, 3512, f | 0) | 0;
	                            c[662] = 3;
	                            break
	                        } else {
	                            c[f >> 2] = ga;
	                            Ka(fa | 0, 3536, f | 0) | 0;
	                            c[662] = 3;
	                            break
	                        }
	                    } else {
	                        fa = c[o >> 2] | 0;
	                        c[f >> 2] = c[g >> 2];
	                        Ka(fa | 0, 3496, f | 0) | 0
	                    } while (0);
	                    ZA(c[ha >> 2] | 0);
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3480, f)
	                }
	                if (!((c[356] | 0) == 0 | (c[152] | 0) != 0))Jp(c[o >> 2] | 0, c[j >> 2] | 0);
	                if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                Th(c[j >> 2] | 0);
	                if ((c[252] | 0) == 0 | (c[266] | 0) != 0) {
	                    i = e;
	                    return
	                }
	                cc(3584, f);
	                i = e;
	                return
	            }

	            function gc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = Aa(c[g >> 2] | 0, 1, c[h >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function hc(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) == (c[p >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Xa(c[d >> 2] | 0) | 0;
	                i = b;
	                return
	            }

	            function ic(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                a[4136] = 0;
	                c[l >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                if (((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[l >> 2] = c[(c[(c[k >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                rc(c[l >> 2] | 0);
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54304, g);
	                c[m >> 2] = e;
	                c[n >> 2] = ZT(4136) | 0;
	                LT(4136 + (c[n >> 2] | 0) | 0, 5e4 - (c[n >> 2] | 0) | 0, c[j >> 2] | 0, m) | 0;
	                sc();
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54168, g);
	                tc(c[l >> 2] | 0);
	                sc();
	                i = f;
	                return
	            }

	            function jc(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                a[4136] = 0;
	                c[l >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                if (((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[l >> 2] = c[(c[(c[k >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                rc(c[l >> 2] | 0);
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54280, g);
	                c[m >> 2] = e;
	                c[n >> 2] = ZT(4136) | 0;
	                LT(4136 + (c[n >> 2] | 0) | 0, 5e4 - (c[n >> 2] | 0) | 0, c[j >> 2] | 0, m) | 0;
	                sc();
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54168, g);
	                tc(c[l >> 2] | 0);
	                sc();
	                i = f;
	                return
	            }

	            function kc(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                a[4136] = 0;
	                c[l >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[l >> 2] = c[(c[(c[k >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                rc(c[l >> 2] | 0);
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54256, g);
	                c[n >> 2] = ZT(4136) | 0;
	                c[m >> 2] = e;
	                LT(4136 + (c[n >> 2] | 0) | 0, 5e4 - (c[n >> 2] | 0) | 0, c[j >> 2] | 0, m) | 0;
	                sc();
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54168, g);
	                tc(c[l >> 2] | 0);
	                sc();
	                c[662] = 3;
	                i = f;
	                return
	            }

	            function lc(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                a[4136] = 0;
	                c[l >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[l >> 2] = c[(c[(c[k >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                rc(c[l >> 2] | 0);
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54136, g);
	                c[m >> 2] = e;
	                c[n >> 2] = ZT(4136) | 0;
	                LT(4136 + (c[n >> 2] | 0) | 0, 5e4 - (c[n >> 2] | 0) | 0, c[j >> 2] | 0, m) | 0;
	                sc();
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54168, g);
	                tc(c[l >> 2] | 0);
	                sc();
	                i = f;
	                return
	            }

	            function mc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Lr(c[f >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    Ka(c[o >> 2] | 0, 3912, e | 0) | 0;
	                    c[662] = 9;
	                    i = d;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[f >> 2];
	                c[j >> 2] = Rs(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                Nr(c[h >> 2] | 0);
	                if (!(c[j >> 2] | 0)) {
	                    Ka(c[o >> 2] | 0, 3944, e | 0) | 0;
	                    c[662] = 10;
	                    i = d;
	                    return
	                } else {
	                    qc(c[j >> 2] | 0);
	                    Qq(c[j >> 2] | 0);
	                    i = d;
	                    return
	                }
	            }

	            function nc(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 528 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 20 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[g >> 2] = b;
	                if (c[g >> 2] | 0) {
	                    b = c[q >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Ka(b | 0, 3904, e | 0) | 0
	                }
	                if (!(nb(h | 0, 500, c[p >> 2] | 0) | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                a[h + 500 >> 0] = 0;
	                c[k >> 2] = ZT(h | 0) | 0;
	                c[j >> 2] = iT((c[k >> 2] | 0) + 1 | 0) | 0;
	                if (c[j >> 2] | 0)eU(c[j >> 2] | 0, h | 0, (c[k >> 2] | 0) + 1 | 0) | 0;
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function oc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 128 | 0;
	                d = b;
	                e = b + 116 | 0;
	                f = b + 112 | 0;
	                g = b + 108 | 0;
	                h = b + 104 | 0;
	                j = b + 16 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                c[e >> 2] = a;
	                c[h >> 2] = Pi(c[e >> 2] | 0) | 0;
	                c[l >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                c[k >> 2] = 0;
	                while (1) {
	                    if (!((c[l >> 2] | 0) != 0 & (c[k >> 2] | 0) < 20))break;
	                    h = c[(c[l >> 2] | 0) + 8 >> 2] | 0;
	                    a = c[k >> 2] | 0;
	                    c[k >> 2] = a + 1;
	                    c[j + (a << 2) >> 2] = h;
	                    h = c[(c[l >> 2] | 0) + 12 >> 2] | 0;
	                    a = c[k >> 2] | 0;
	                    c[k >> 2] = a + 1;
	                    c[j + (a << 2) >> 2] = h;
	                    c[l >> 2] = c[c[l >> 2] >> 2]
	                }
	                l = c[k >> 2] | 0;
	                c[k >> 2] = l + 1;
	                c[j + (l << 2) >> 2] = 0;
	                c[j + (c[k >> 2] << 2) >> 2] = 0;
	                if ((c[548] | 0) != 0 ? (c[694] = MQ(c[548] | 0, c[(c[e >> 2] | 0) + 80 >> 2] | 0, 0, j) | 0, (c[694] | 0) == 0) : 0) {
	                    j = c[33976] | 0;
	                    k = c[33980] | 0;
	                    c[d >> 2] = c[548];
	                    Db[j & 511](k, 2784, d);
	                    c[662] = 7;
	                    c[548] = 0
	                }
	                if (((c[694] | 0) != 0 ? (c[898] = OQ(c[694] | 0) | 0, (c[898] | 0) != 0) : 0) ? (c[g >> 2] = HQ(c[898] | 0, 0, 0) | 0, (c[g >> 2] | 0) < 0) : 0) {
	                    Ka(c[o >> 2] | 0, 3600, d | 0) | 0;
	                    GQ(c[898] | 0);
	                    c[898] = 0
	                }
	                c[f >> 2] = jM(c[e >> 2] | 0) | 0;
	                if (c[f >> 2] | 0) {
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))bc();
	                    c[g >> 2] = QL(c[f >> 2] | 0) | 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) != 1)break;
	                        if ((c[42] | 0) != 0 | (c[694] | 0) != 0)pc(c[f >> 2] | 0);
	                        c[g >> 2] = QL(c[f >> 2] | 0) | 0
	                    }
	                    if (!((c[252] | 0) == 0 | (c[266] | 0) != 0))cc(3632, d);
	                    VL(c[f >> 2] | 0);
	                    if (c[g >> 2] | 0) {
	                        Ka(c[o >> 2] | 0, 3656, d | 0) | 0;
	                        c[662] = 1
	                    }
	                } else {
	                    Ka(c[o >> 2] | 0, 3688, d | 0) | 0;
	                    c[662] = 1
	                }
	                if (!(c[898] | 0)) {
	                    i = b;
	                    return
	                }
	                GQ(c[898] | 0);
	                c[898] = 0;
	                i = b;
	                return
	            }

	            function pc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0;
	                b = i;
	                i = i + 64 | 0;
	                d = b;
	                e = b + 48 | 0;
	                f = b + 44 | 0;
	                g = b + 40 | 0;
	                h = b + 36 | 0;
	                j = b + 32 | 0;
	                k = b + 28 | 0;
	                l = b + 24 | 0;
	                m = b + 20 | 0;
	                c[e >> 2] = a;
	                c[h >> 2] = XL(c[e >> 2] | 0) | 0;
	                c[j >> 2] = YL(c[e >> 2] | 0) | 0;
	                do if (c[42] | 0) {
	                    a = _L(c[e >> 2] | 0) | 0;
	                    c[f >> 2] = a;
	                    c[f >> 2] = (c[f >> 2] | 0) == 0 ? 3736 : a;
	                    c[g >> 2] = cM(c[e >> 2] | 0) | 0;
	                    a = aM(c[e >> 2] | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    p = c[f >> 2] | 0;
	                    q = c[j >> 2] | 0;
	                    r = bM(c[e >> 2] | 0) | 0;
	                    c[d >> 2] = a;
	                    c[d + 4 >> 2] = n;
	                    c[d + 8 >> 2] = p;
	                    c[d + 12 >> 2] = q;
	                    c[d + 16 >> 2] = r;
	                    Wa(3744, d | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        Wa(3760, d | 0) | 0;
	                        break
	                    } else {
	                        c[d >> 2] = c[g >> 2];
	                        Wa(3768, d | 0) | 0;
	                        break
	                    }
	                } while (0);
	                if (!(c[694] | 0)) {
	                    i = b;
	                    return
	                }
	                c[k >> 2] = 0;
	                c[l >> 2] = -1;
	                if ((c[h >> 2] | 0) == 1 ? (g = c[694] | 0, c[l >> 2] = NQ(g, eM(c[e >> 2] | 0) | 0) | 0, (c[l >> 2] | 0) != 0) : 0) {
	                    c[k >> 2] = Oi(eM(c[e >> 2] | 0) | 0) | 0;
	                    g = c[548] | 0;
	                    c[d >> 2] = c[k >> 2];
	                    c[d + 4 >> 2] = g;
	                    Wa(3776, d | 0) | 0
	                }
	                do if (c[898] | 0) {
	                    do if ((c[h >> 2] | 0) == 1) {
	                        g = c[898] | 0;
	                        f = ZL(c[e >> 2] | 0) | 0;
	                        c[m >> 2] = HQ(g, f, $L(c[e >> 2] | 0) | 0) | 0;
	                        if ((c[m >> 2] | 0) < 0) {
	                            Ka(c[o >> 2] | 0, 3600, d | 0) | 0;
	                            GQ(c[898] | 0);
	                            c[898] = 0;
	                            break
	                        }
	                        if ((c[m >> 2] | 0) != (c[l >> 2] | 0)) {
	                            if (!(c[k >> 2] | 0))c[k >> 2] = Oi(eM(c[e >> 2] | 0) | 0) | 0;
	                            Ka(c[o >> 2] | 0, 3808, d | 0) | 0;
	                            f = c[o >> 2] | 0;
	                            g = c[548] | 0;
	                            if (c[k >> 2] | 0) {
	                                r = c[k >> 2] | 0;
	                                c[d >> 2] = g;
	                                c[d + 4 >> 2] = r;
	                                Ka(f | 0, 3856, d | 0) | 0;
	                                break
	                            } else {
	                                r = _L(c[e >> 2] | 0) | 0;
	                                c[d >> 2] = g;
	                                c[d + 4 >> 2] = r;
	                                Ka(f | 0, 3856, d | 0) | 0;
	                                break
	                            }
	                        }
	                    } while (0);
	                    if ((c[h >> 2] | 0) != 15 ? !((c[h >> 2] | 0) == 1 & (c[j >> 2] | 0) != 0) : 0)break;
	                    c[m >> 2] = KQ(c[898] | 0) | 0;
	                    if ((c[m >> 2] | 0) < 0) {
	                        Ka(c[o >> 2] | 0, 3880, d | 0) | 0;
	                        GQ(c[898] | 0);
	                        c[898] = 0
	                    }
	                } while (0);
	                if (!(c[k >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                i = b;
	                return
	            }

	            function qc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                j = b + 8 | 0;
	                c[e >> 2] = a;
	                switch (c[c[e >> 2] >> 2] | 0) {
	                    case 4:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                        Wa(3904, d | 0) | 0;
	                        i = b;
	                        return
	                    }
	                    case 3:
	                    {
	                        a = Mq(+h[(c[e >> 2] | 0) + 16 >> 3]) | 0;
	                        if ((a | 0) == -1) {
	                            Wa(4032, d | 0) | 0;
	                            i = b;
	                            return
	                        } else if ((a | 0) != 1)if (Lq(+h[(c[e >> 2] | 0) + 16 >> 3]) | 0) {
	                            Wa(4048, d | 0) | 0;
	                            i = b;
	                            return
	                        } else {
	                            h[k >> 3] = +h[(c[e >> 2] | 0) + 16 >> 3];
	                            c[d >> 2] = c[k >> 2];
	                            c[d + 4 >> 2] = c[k + 4 >> 2];
	                            Wa(4056, d | 0) | 0;
	                            i = b;
	                            return
	                        } else {
	                            Wa(4016, d | 0) | 0;
	                            i = b;
	                            return
	                        }
	                        break
	                    }
	                    case 1:
	                    {
	                        if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[e >> 2] | 0) + 4 >> 2] >> 2] | 0) > 0 : 0) {
	                            c[j >> 2] = rR(1, 0, 0) | 0;
	                            if (!(c[j >> 2] | 0)) {
	                                Ka(c[o >> 2] | 0, 3912, d | 0) | 0;
	                                c[662] = 9;
	                                i = b;
	                                return
	                            }
	                            c[f >> 2] = 0;
	                            while (1) {
	                                if ((c[f >> 2] | 0) >= (c[c[(c[e >> 2] | 0) + 4 >> 2] >> 2] | 0))break;
	                                c[g >> 2] = c[(c[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0) + (c[f >> 2] << 2) >> 2];
	                                uR(c[j >> 2] | 0, c[g >> 2] | 0) | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                            wR(c[j >> 2] | 0) | 0;
	                            i = b;
	                            return
	                        }
	                        Ka(c[o >> 2] | 0, 3976, d | 0) | 0;
	                        c[662] = 10;
	                        i = b;
	                        return
	                    }
	                    case 2:
	                    {
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                            Wa(4e3, d | 0) | 0;
	                            i = b;
	                            return
	                        } else {
	                            Wa(4008, d | 0) | 0;
	                            i = b;
	                            return
	                        }
	                        break
	                    }
	                    case 0:
	                    {
	                        Ka(c[o >> 2] | 0, 4064, d | 0) | 0;
	                        c[662] = 10;
	                        i = b;
	                        return
	                    }
	                    default:
	                    {
	                        Ka(c[o >> 2] | 0, 4096, d | 0) | 0;
	                        c[662] = 10;
	                        i = b;
	                        return
	                    }
	                }
	            }

	            function rc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                c[e >> 2] = a;
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54216, d);
	                c[f >> 2] = ZT(4136) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    sc();
	                    i = b;
	                    return
	                }
	                a = 4136 + (c[f >> 2] | 0) | 0;
	                g = 5e4 - (c[f >> 2] | 0) | 0;
	                f = c[e >> 2] | 0;
	                if (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    h = c[(c[e >> 2] | 0) + 28 >> 2] | 0;
	                    c[d >> 2] = c[f + 4 >> 2];
	                    c[d + 4 >> 2] = h;
	                    JT(a, g, 54224, d) | 0;
	                    sc();
	                    i = b;
	                    return
	                } else {
	                    c[d >> 2] = c[f + 28 >> 2];
	                    JT(a, g, 54232, d) | 0;
	                    sc();
	                    i = b;
	                    return
	                }
	            }

	            function sc() {
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = cd(0, 4136) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    a[4136] = 0;
	                    i = b;
	                    return
	                }
	                f = c[33976] | 0;
	                g = c[33980] | 0;
	                c[d >> 2] = c[e >> 2];
	                Db[f & 511](g, 3904, d);
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                a[4136] = 0;
	                i = b;
	                return
	            }

	            function tc(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54176, e);
	                c[g >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                c[h >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if ((c[g >> 2] | 0) >>> 0 <= (c[h >> 2] | 0) >>> 0)break;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 10 ? (d[c[g >> 2] >> 0] | 0 | 0) != 13 : 0)break;
	                    c[g >> 2] = (c[g >> 2] | 0) + -1
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    a = c[k >> 2] | 0;
	                    c[k >> 2] = a + 1;
	                    if (((a | 0) < 80 ? (c[g >> 2] | 0) >>> 0 > (c[h >> 2] | 0) >>> 0 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 10 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) != 13; else l = 0;
	                    m = c[g >> 2] | 0;
	                    if (!l)break;
	                    c[g >> 2] = m + -1
	                }
	                if (!((d[m >> 0] | 0 | 0) != 10 ? (d[c[g >> 2] >> 0] | 0 | 0) != 13 : 0))c[g >> 2] = (c[g >> 2] | 0) + 1;
	                c[h >> 2] = c[g >> 2];
	                c[k >> 2] = 0;
	                while (1) {
	                    if (((d[c[g >> 2] >> 0] | 0 | 0) != 0 ? (d[c[g >> 2] >> 0] | 0 | 0) != 10 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 13 : 0)n = (c[k >> 2] | 0) < 79; else n = 0;
	                    c[j >> 2] = ZT(4136) | 0;
	                    o = 4136 + (c[j >> 2] | 0) | 0;
	                    p = 5e4 - (c[j >> 2] | 0) | 0;
	                    if (!n)break;
	                    m = c[g >> 2] | 0;
	                    c[g >> 2] = m + 1;
	                    c[e >> 2] = d[m >> 0];
	                    JT(o, p, 54184, e) | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                JT(o, p, 3760, e) | 0;
	                c[g >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 10 ? (d[c[g >> 2] >> 0] | 0 | 0) != 13 : 0)break;
	                    c[g >> 2] = (c[g >> 2] | 0) + -1
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) != (c[h >> 2] | 0)) {
	                        f = c[k >> 2] | 0;
	                        c[k >> 2] = f + 1;
	                        q = (f | 0) < 80
	                    } else q = 0;
	                    c[j >> 2] = ZT(4136) | 0;
	                    r = 4136 + (c[j >> 2] | 0) | 0;
	                    s = 5e4 - (c[j >> 2] | 0) | 0;
	                    if (!q)break;
	                    JT(r, s, 54192, e) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                JT(r, s, 54200, e) | 0;
	                sc();
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 54208, e);
	                i = b;
	                return
	            }

	            function uc(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                c[f + 16 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                e = c[q >> 2] | 0;
	                c[g >> 2] = c[h >> 2];
	                Ka(e | 0, 55552, g | 0) | 0;
	                e = c[q >> 2] | 0;
	                if (!(c[j >> 2] | 0))Ka(e | 0, 54736, g | 0) | 0; else {
	                    c[g >> 2] = c[j >> 2];
	                    Ka(e | 0, 54744, g | 0) | 0
	                }
	                e = c[q >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ka(e | 0, 54752, g | 0) | 0;
	                    i = f;
	                    return
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    Ka(e | 0, 54760, g | 0) | 0;
	                    i = f;
	                    return
	                }
	            }

	            function vc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                c[b + 4 >> 2] = a;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    c[d >> 2] = 0;
	                    e = c[d >> 2] | 0;
	                    i = b;
	                    return e | 0
	                } else {
	                    Ka(c[q >> 2] | 0, 55528, b | 0) | 0;
	                    c[d >> 2] = 0;
	                    e = c[d >> 2] | 0;
	                    i = b;
	                    return e | 0
	                }
	                return 0
	            }

	            function wc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                c[b + 4 >> 2] = a;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    c[d >> 2] = 0;
	                    e = c[d >> 2] | 0;
	                    i = b;
	                    return e | 0
	                } else {
	                    Ka(c[q >> 2] | 0, 55496, b | 0) | 0;
	                    c[d >> 2] = 0;
	                    e = c[d >> 2] | 0;
	                    i = b;
	                    return e | 0
	                }
	                return 0
	            }

	            function xc(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                c[b + 4 >> 2] = a;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    c[d >> 2] = 0;
	                    e = c[d >> 2] | 0;
	                    i = b;
	                    return e | 0
	                } else {
	                    Ka(c[q >> 2] | 0, 55464, b | 0) | 0;
	                    c[d >> 2] = 0;
	                    e = c[d >> 2] | 0;
	                    i = b;
	                    return e | 0
	                }
	                return 0
	            }

	            function yc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 16 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[e + 12 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    c[g >> 2] = 0;
	                    k = c[g >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                Ka(c[q >> 2] | 0, 55424, f | 0) | 0;
	                d = c[q >> 2] | 0;
	                if (c[h >> 2] | 0) {
	                    c[f >> 2] = c[h >> 2];
	                    Ka(d | 0, 3904, f | 0) | 0
	                } else Ka(d | 0, 54192, f | 0) | 0;
	                d = c[q >> 2] | 0;
	                if (c[j >> 2] | 0) {
	                    c[f >> 2] = c[j >> 2];
	                    Ka(d | 0, 55448, f | 0) | 0
	                } else Ka(d | 0, 55456, f | 0) | 0;
	                c[g >> 2] = 0;
	                k = c[g >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function zc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 4 | 0;
	                c[d + 8 >> 2] = a;
	                c[g >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    c[f >> 2] = 0;
	                    h = c[f >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    b = c[q >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Ka(b | 0, 55400, e | 0) | 0;
	                    c[f >> 2] = 0;
	                    h = c[f >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function Ac(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                c[h + 44 >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 55152;
	                if (!(c[m >> 2] | 0))c[m >> 2] = c[p >> 2];
	                if (!(c[n >> 2] | 0))c[n >> 2] = c[p >> 2];
	                if (!(c[o >> 2] | 0))c[o >> 2] = c[p >> 2];
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = h;
	                    return
	                }
	                p = c[q >> 2] | 0;
	                g = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[o >> 2] | 0;
	                c[j >> 2] = c[k >> 2];
	                c[j + 4 >> 2] = g;
	                c[j + 8 >> 2] = l;
	                c[j + 12 >> 2] = m;
	                c[j + 16 >> 2] = n;
	                Ka(p | 0, 55360, j | 0) | 0;
	                i = h;
	                return
	            }

	            function Bc(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                c[f + 24 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                e = c[q >> 2] | 0;
	                d = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                c[g >> 2] = c[h >> 2];
	                c[g + 4 >> 2] = d;
	                c[g + 8 >> 2] = j;
	                Ka(e | 0, 55328, g | 0) | 0;
	                i = f;
	                return
	            }

	            function Cc(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, r = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j;
	                l = j + 40 | 0;
	                m = j + 36 | 0;
	                n = j + 32 | 0;
	                o = j + 28 | 0;
	                p = j + 24 | 0;
	                r = j + 20 | 0;
	                c[j + 44 >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[r >> 2] = h;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = j;
	                    return
	                }
	                h = c[q >> 2] | 0;
	                g = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[o >> 2] | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[k >> 2] = g;
	                    c[k + 4 >> 2] = l;
	                    c[k + 8 >> 2] = m;
	                    c[k + 12 >> 2] = n;
	                    Ka(h | 0, 55232, k | 0) | 0
	                } else {
	                    o = c[p >> 2] | 0;
	                    c[k >> 2] = g;
	                    c[k + 4 >> 2] = l;
	                    c[k + 8 >> 2] = m;
	                    c[k + 12 >> 2] = n;
	                    c[k + 16 >> 2] = o;
	                    Ka(h | 0, 55280, k | 0) | 0
	                }
	                rm(c[r >> 2] | 0);
	                i = j;
	                return
	            }

	            function Dc(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                c[f + 20 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[f + 8 >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                e = c[q >> 2] | 0;
	                d = c[j >> 2] | 0;
	                c[g >> 2] = c[h >> 2];
	                c[g + 4 >> 2] = d;
	                Ka(e | 0, 55200, g | 0) | 0;
	                i = f;
	                return
	            }

	            function Ec(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                c[g + 36 >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 55152;
	                if (!(c[k >> 2] | 0))c[k >> 2] = c[n >> 2];
	                if (!(c[l >> 2] | 0))c[l >> 2] = c[n >> 2];
	                if (!(c[m >> 2] | 0))c[m >> 2] = c[n >> 2];
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = g;
	                    return
	                }
	                n = c[q >> 2] | 0;
	                f = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                c[h >> 2] = c[j >> 2];
	                c[h + 4 >> 2] = f;
	                c[h + 8 >> 2] = k;
	                c[h + 12 >> 2] = l;
	                Ka(n | 0, 55160, h | 0) | 0;
	                i = g;
	                return
	            }

	            function Fc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0;
	                d = i;
	                i = i + 16 | 0;
	                c[d + 8 >> 2] = a;
	                c[d + 4 >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = d;
	                    return
	                }
	                Ka(c[q >> 2] | 0, 55120, d | 0) | 0;
	                i = d;
	                return
	            }

	            function Gc(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b + 4 >> 2] = a;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = b;
	                    return
	                }
	                Ka(c[q >> 2] | 0, 55096, b | 0) | 0;
	                i = b;
	                return
	            }

	            function Hc(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b + 4 >> 2] = a;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = b;
	                    return
	                }
	                Ka(c[q >> 2] | 0, 55072, b | 0) | 0;
	                i = b;
	                return
	            }

	            function Ic(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 4 | 0;
	                c[d + 8 >> 2] = a;
	                c[f >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = d;
	                    return
	                }
	                b = c[q >> 2] | 0;
	                c[e >> 2] = c[f >> 2];
	                Ka(b | 0, 55048, e | 0) | 0;
	                i = d;
	                return
	            }

	            function Jc(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 24 | 0;
	                l = f + 8 | 0;
	                c[f + 20 >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                c[l >> 2] = 0;
	                while (1) {
	                    m = c[l >> 2] | 0;
	                    if (!((c[l >> 2] | 0) < 30 ? (c[l >> 2] | 0) < (c[j >> 2] | 0) : 0))break;
	                    a[k + (c[l >> 2] | 0) >> 0] = a[(c[h >> 2] | 0) + m >> 0] | 0;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a[k + m >> 0] = 0;
	                m = c[q >> 2] | 0;
	                l = c[j >> 2] | 0;
	                c[g >> 2] = k;
	                c[g + 4 >> 2] = l;
	                Ka(m | 0, 55024, g | 0) | 0;
	                i = f;
	                return
	            }

	            function Kc(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 24 | 0;
	                l = f + 8 | 0;
	                c[f + 20 >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                c[l >> 2] = 0;
	                while (1) {
	                    m = c[l >> 2] | 0;
	                    if (!((c[l >> 2] | 0) < 30 ? (c[l >> 2] | 0) < (c[j >> 2] | 0) : 0))break;
	                    a[k + (c[l >> 2] | 0) >> 0] = a[(c[h >> 2] | 0) + m >> 0] | 0;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a[k + m >> 0] = 0;
	                m = c[q >> 2] | 0;
	                l = c[j >> 2] | 0;
	                c[g >> 2] = k;
	                c[g + 4 >> 2] = l;
	                Ka(m | 0, 54984, g | 0) | 0;
	                i = f;
	                return
	            }

	            function Lc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                c[e + 16 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = e;
	                    return
	                }
	                d = c[q >> 2] | 0;
	                b = c[g >> 2] | 0;
	                if (c[h >> 2] | 0) {
	                    g = c[h >> 2] | 0;
	                    c[f >> 2] = b;
	                    c[f + 4 >> 2] = g;
	                    Ka(d | 0, 54904, f | 0) | 0;
	                    i = e;
	                    return
	                } else {
	                    c[f >> 2] = b;
	                    Ka(d | 0, 54944, f | 0) | 0;
	                    i = e;
	                    return
	                }
	            }

	            function Mc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 4 | 0;
	                c[d + 8 >> 2] = a;
	                c[f >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = d;
	                    return
	                }
	                b = c[q >> 2] | 0;
	                c[e >> 2] = c[f >> 2];
	                Ka(b | 0, 54880, e | 0) | 0;
	                i = d;
	                return
	            }

	            function Nc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 8 | 0;
	                c[e + 28 >> 2] = a;
	                c[f >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = e;
	                    return
	                }
	                c[g >> 2] = d;
	                Ka(c[q >> 2] | 0, 54864, e | 0) | 0;
	                Ca(c[q >> 2] | 0, c[f >> 2] | 0, g | 0) | 0;
	                i = e;
	                return
	            }

	            function Oc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 8 | 0;
	                c[e + 28 >> 2] = a;
	                c[f >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = e;
	                    return
	                }
	                c[g >> 2] = d;
	                Ka(c[q >> 2] | 0, 54848, e | 0) | 0;
	                Ca(c[q >> 2] | 0, c[f >> 2] | 0, g | 0) | 0;
	                i = e;
	                return
	            }

	            function Pc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 8 | 0;
	                c[e + 28 >> 2] = a;
	                c[f >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = e;
	                    return
	                }
	                c[g >> 2] = d;
	                Ka(c[q >> 2] | 0, 54824, e | 0) | 0;
	                Ca(c[q >> 2] | 0, c[f >> 2] | 0, g | 0) | 0;
	                i = e;
	                return
	            }

	            function Qc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 4 | 0;
	                c[d + 8 >> 2] = a;
	                c[g >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    c[f >> 2] = 0;
	                    h = c[f >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    b = c[q >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Ka(b | 0, 54792, e | 0) | 0;
	                    c[f >> 2] = 0;
	                    h = c[f >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function Rc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                c[e + 16 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = e;
	                    return
	                }
	                d = c[q >> 2] | 0;
	                b = c[h >> 2] | 0;
	                c[f >> 2] = c[g >> 2];
	                c[f + 4 >> 2] = b;
	                Ka(d | 0, 54768, f | 0) | 0;
	                i = e;
	                return
	            }

	            function Sc(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                c[f + 16 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                e = c[q >> 2] | 0;
	                c[g >> 2] = c[h >> 2];
	                Ka(e | 0, 54712, g | 0) | 0;
	                e = c[q >> 2] | 0;
	                if (!(c[j >> 2] | 0))Ka(e | 0, 54736, g | 0) | 0; else {
	                    c[g >> 2] = c[j >> 2];
	                    Ka(e | 0, 54744, g | 0) | 0
	                }
	                e = c[q >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ka(e | 0, 54752, g | 0) | 0;
	                    i = f;
	                    return
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    Ka(e | 0, 54760, g | 0) | 0;
	                    i = f;
	                    return
	                }
	            }

	            function Tc(a, b, d, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                l = i;
	                i = i + 48 | 0;
	                m = l;
	                n = l + 40 | 0;
	                o = l + 36 | 0;
	                p = l + 32 | 0;
	                r = l + 28 | 0;
	                s = l + 24 | 0;
	                t = l + 20 | 0;
	                u = l + 16 | 0;
	                v = l + 12 | 0;
	                w = l + 8 | 0;
	                c[l + 44 >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[r >> 2] = f;
	                c[s >> 2] = g;
	                c[t >> 2] = h;
	                c[u >> 2] = j;
	                c[v >> 2] = k;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = l;
	                    return
	                }
	                k = c[q >> 2] | 0;
	                c[m >> 2] = c[n >> 2];
	                Ka(k | 0, 54584, m | 0) | 0;
	                k = c[q >> 2] | 0;
	                if (!(c[o >> 2] | 0))Ka(k | 0, 54536, m | 0) | 0; else {
	                    c[m >> 2] = c[o >> 2];
	                    Ka(k | 0, 54544, m | 0) | 0
	                }
	                k = c[q >> 2] | 0;
	                if (!(c[p >> 2] | 0))Ka(k | 0, 54536, m | 0) | 0; else {
	                    c[m >> 2] = c[p >> 2];
	                    Ka(k | 0, 54608, m | 0) | 0
	                }
	                k = c[q >> 2] | 0;
	                c[m >> 2] = c[r >> 2];
	                Ka(k | 0, 54616, m | 0) | 0;
	                a:do if (c[s >> 2] | 0) {
	                    c[w >> 2] = 0;
	                    while (1) {
	                        if ((c[w >> 2] | 0) >= (c[r >> 2] << 1 | 0))break a;
	                        Ka(c[q >> 2] | 0, 54624, m | 0) | 0;
	                        if (c[(c[s >> 2] | 0) + (c[w >> 2] << 2) >> 2] | 0) {
	                            k = c[q >> 2] | 0;
	                            c[m >> 2] = c[(c[s >> 2] | 0) + (c[w >> 2] << 2) >> 2];
	                            Ka(k | 0, 54632, m | 0) | 0
	                        }
	                        c[w >> 2] = (c[w >> 2] | 0) + 1;
	                        k = c[q >> 2] | 0;
	                        c[m >> 2] = c[(c[s >> 2] | 0) + (c[w >> 2] << 2) >> 2];
	                        Ka(k | 0, 54640, m | 0) | 0;
	                        c[w >> 2] = (c[w >> 2] | 0) + 1
	                    }
	                } while (0);
	                s = c[q >> 2] | 0;
	                r = c[u >> 2] | 0;
	                c[m >> 2] = c[t >> 2];
	                c[m + 4 >> 2] = r;
	                Ka(s | 0, 54648, m | 0) | 0;
	                b:do if (c[v >> 2] | 0) {
	                    c[w >> 2] = 0;
	                    while (1) {
	                        if ((c[w >> 2] | 0) >= ((c[t >> 2] | 0) * 5 | 0))break b;
	                        s = c[q >> 2] | 0;
	                        r = c[w >> 2] | 0;
	                        if (c[(c[v >> 2] | 0) + ((c[w >> 2] | 0) + 1 << 2) >> 2] | 0) {
	                            u = c[(c[v >> 2] | 0) + (c[w >> 2] << 2) >> 2] | 0;
	                            c[m >> 2] = c[(c[v >> 2] | 0) + (r + 1 << 2) >> 2];
	                            c[m + 4 >> 2] = u;
	                            Ka(s | 0, 54664, m | 0) | 0
	                        } else {
	                            c[m >> 2] = c[(c[v >> 2] | 0) + (r << 2) >> 2];
	                            Ka(s | 0, 54680, m | 0) | 0
	                        }
	                        s = c[q >> 2] | 0;
	                        r = (c[(c[v >> 2] | 0) + ((c[w >> 2] | 0) + 4 << 2) >> 2] | 0) - (c[(c[v >> 2] | 0) + ((c[w >> 2] | 0) + 3 << 2) >> 2] | 0) | 0;
	                        c[m >> 2] = c[(c[v >> 2] | 0) + ((c[w >> 2] | 0) + 3 << 2) >> 2];
	                        c[m + 4 >> 2] = r;
	                        Ka(s | 0, 54688, m | 0) | 0;
	                        c[w >> 2] = (c[w >> 2] | 0) + 5
	                    }
	                } while (0);
	                Ka(c[q >> 2] | 0, 54704, m | 0) | 0;
	                i = l;
	                return
	            }

	            function Uc(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                c[f + 16 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = f;
	                    return
	                }
	                e = c[q >> 2] | 0;
	                c[g >> 2] = c[h >> 2];
	                Ka(e | 0, 54512, g | 0) | 0;
	                e = c[q >> 2] | 0;
	                if (!(c[j >> 2] | 0))Ka(e | 0, 54536, g | 0) | 0; else {
	                    c[g >> 2] = c[j >> 2];
	                    Ka(e | 0, 54544, g | 0) | 0
	                }
	                e = c[q >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ka(e | 0, 54552, g | 0) | 0;
	                    i = f;
	                    return
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    Ka(e | 0, 54568, g | 0) | 0;
	                    i = f;
	                    return
	                }
	            }

	            function Vc() {
	                var a = 0, b = 0, d = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                d = c[o >> 2] | 0;
	                c[b >> 2] = c[432];
	                Ka(d | 0, 56400, b | 0) | 0;
	                c[662] = 9;
	                i = a;
	                return
	            }

	            function Wc(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[e + 16 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = e;
	                    return
	                }
	                d = c[q >> 2] | 0;
	                c[f >> 2] = c[g >> 2];
	                Ka(d | 0, 60952, f | 0) | 0;
	                a:do if (c[h >> 2] | 0) {
	                    c[j >> 2] = 0;
	                    while (1) {
	                        if (!(c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0))break a;
	                        d = c[q >> 2] | 0;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        c[f >> 2] = c[(c[h >> 2] | 0) + (g << 2) >> 2];
	                        Ka(d | 0, 54680, f | 0) | 0;
	                        if (c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) {
	                            d = c[q >> 2] | 0;
	                            c[f >> 2] = c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2];
	                            Ka(d | 0, 60976, f | 0) | 0
	                        }
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                } while (0);
	                Ka(c[q >> 2] | 0, 54704, f | 0) | 0;
	                i = e;
	                return
	            }

	            function Xc(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 4 | 0;
	                c[d + 8 >> 2] = a;
	                c[f >> 2] = b;
	                c[13584] = (c[13584] | 0) + 1;
	                if (c[50] | 0) {
	                    i = d;
	                    return
	                }
	                b = c[q >> 2] | 0;
	                c[e >> 2] = c[f >> 2];
	                Ka(b | 0, 60928, e | 0) | 0;
	                i = d;
	                return
	            }

	            function Yc(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[f >> 2] = a;
	                do if (!(c[f >> 2] | 0))c[e >> 2] = 0; else {
	                    a = d[c[f >> 2] >> 0] | 0;
	                    if ((a | 0) == 103) {
	                        if (qy(c[f >> 2] | 0, 61072) | 0) {
	                            c[e >> 2] = 61080;
	                            break
	                        }
	                    } else if ((a | 0) == 97) {
	                        if (qy(c[f >> 2] | 0, 61160) | 0) {
	                            c[e >> 2] = 61168;
	                            break
	                        }
	                        if (qy(c[f >> 2] | 0, 61248) | 0) {
	                            c[e >> 2] = 61256;
	                            break
	                        }
	                    } else if ((a | 0) == 108) {
	                        if (qy(c[f >> 2] | 0, 60984) | 0) {
	                            c[e >> 2] = 60992;
	                            break
	                        }
	                    } else if ((a | 0) == 113 ? (qy(c[f >> 2] | 0, 61336) | 0) != 0 : 0) {
	                        c[e >> 2] = 61344;
	                        break
	                    }
	                    c[e >> 2] = 0
	                } while (0);
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Zc(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (!(c[k >> 2] | 0)) {
	                    gd(521, 61424);
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                if (!(c[(c[k >> 2] | 0) + 48 >> 2] | 0)) {
	                    gd(522, 61464);
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[r >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                c[q >> 2] = hd(c[r >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[(c[q >> 2] | 0) + 20 >> 2] = c[r >> 2];
	                c[(c[q >> 2] | 0) + 32 >> 2] = c[(c[r >> 2] | 0) + 32 >> 2];
	                p = c[q >> 2] | 0;
	                o = (c[r >> 2] | 0) + 16 | 0;
	                if (!(c[(c[r >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[o >> 2] = p;
	                    c[(c[r >> 2] | 0) + 12 >> 2] = p
	                } else {
	                    c[(c[o >> 2] | 0) + 24 >> 2] = p;
	                    c[(c[q >> 2] | 0) + 28 >> 2] = c[(c[r >> 2] | 0) + 16 >> 2];
	                    c[(c[r >> 2] | 0) + 16 >> 2] = c[q >> 2]
	                }
	                c[j >> 2] = c[q >> 2];
	                s = c[j >> 2] | 0;
	                i = h;
	                return s | 0
	            }

	            function _c(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (!(c[k >> 2] | 0)) {
	                    gd(521, 61520);
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                if (!(c[(c[k >> 2] | 0) + 44 >> 2] | 0)) {
	                    gd(522, 61560);
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[r >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                c[q >> 2] = hd(c[r >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[(c[q >> 2] | 0) + 20 >> 2] = c[r >> 2];
	                c[(c[q >> 2] | 0) + 32 >> 2] = c[(c[r >> 2] | 0) + 32 >> 2];
	                p = c[q >> 2] | 0;
	                o = (c[r >> 2] | 0) + 16 | 0;
	                if (!(c[(c[r >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[o >> 2] = p;
	                    c[(c[r >> 2] | 0) + 12 >> 2] = p
	                } else {
	                    c[(c[o >> 2] | 0) + 24 >> 2] = p;
	                    c[(c[q >> 2] | 0) + 28 >> 2] = c[(c[r >> 2] | 0) + 16 >> 2];
	                    c[(c[r >> 2] | 0) + 16 >> 2] = c[q >> 2]
	                }
	                c[j >> 2] = c[q >> 2];
	                s = c[j >> 2] | 0;
	                i = h;
	                return s | 0
	            }

	            function $c(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (((c[(c[f >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) ? (c[h >> 2] = c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 60 >> 2], c[j >> 2] = jd(c[h >> 2] | 0, c[g >> 2] | 0) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                    c[e >> 2] = c[j >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 60 >> 2];
	                    c[e >> 2] = jd(c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function ad(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[f >> 2] | 0) {
	                    if (((c[(c[f >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[j >> 2] = c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2], c[h >> 2] = jd(c[j >> 2] | 0, c[g >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                        c[e >> 2] = c[h >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    if ((((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[j >> 2] = c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 48 >> 2], c[h >> 2] = jd(c[j >> 2] | 0, c[g >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                        c[e >> 2] = c[h >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                }
	                c[e >> 2] = Yc(c[g >> 2] | 0) | 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function bd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = kd(c[e >> 2] | 0, c[f >> 2] | 0, 1) | 0;
	                i = d;
	                return b | 0
	            }

	            function cd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = kd(c[e >> 2] | 0, c[f >> 2] | 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function dd(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 211);
	                i = b;
	                return
	            }

	            function ed(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = _j(c[d >> 2] | 0, 212) | 0;
	                i = b;
	                return a | 0
	            }

	            function fd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                switch (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                    case 2:
	                    {
	                        rj(c[e >> 2] | 0, 61616);
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        b = c[e >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                            rj(b, 61648);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                            rj(c[e >> 2] | 0, 61632);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                        } else {
	                            rj(b, 61664);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                        }
	                        rj(c[e >> 2] | 0, 61640);
	                        i = d;
	                        return
	                    }
	                    case 1:
	                    {
	                        rj(c[e >> 2] | 0, 61616);
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 61632);
	                        b = c[e >> 2] | 0;
	                        a = c[f >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 36 >> 2] | 0)sj(b, c[a + 36 >> 2] | 0); else od(b, c[a + 40 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 61640);
	                        i = d;
	                        return
	                    }
	                    case 5:
	                    {
	                        rj(c[e >> 2] | 0, 61688);
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        a = c[e >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                            rj(a, 61648);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                            rj(c[e >> 2] | 0, 61632);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                        } else {
	                            rj(a, 61664);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                        }
	                        rj(c[e >> 2] | 0, 61640);
	                        i = d;
	                        return
	                    }
	                    case 3:
	                    {
	                        rj(c[e >> 2] | 0, 61616);
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        a = c[e >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                            rj(a, 61648);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                            rj(c[e >> 2] | 0, 61632);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                        } else {
	                            rj(a, 61664);
	                            sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                        }
	                        do if (c[(c[f >> 2] | 0) + 40 >> 2] | 0) {
	                            rj(c[e >> 2] | 0, 61680);
	                            a = c[e >> 2] | 0;
	                            b = c[f >> 2] | 0;
	                            if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                                qj(a, c[b + 36 >> 2] | 0);
	                                break
	                            } else {
	                                qj(a, c[b + 40 >> 2] | 0);
	                                break
	                            }
	                        } while (0);
	                        rj(c[e >> 2] | 0, 61640);
	                        i = d;
	                        return
	                    }
	                    case 4:
	                    {
	                        rj(c[e >> 2] | 0, 61688);
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 61632);
	                        b = c[e >> 2] | 0;
	                        a = c[f >> 2] | 0;
	                        if (!(c[(c[f >> 2] | 0) + 36 >> 2] | 0))od(b, c[a + 40 >> 2] | 0); else sj(b, c[a + 36 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 61640);
	                        i = d;
	                        return
	                    }
	                    default:
	                    {
	                        gd(535, 61704);
	                        i = d;
	                        return
	                    }
	                }
	            }

	            function gd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                ce(2, c[e >> 2] | 0, 0, c[f >> 2] | 0, 0);
	                i = d;
	                return
	            }

	            function hd(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                if (c[(c[k >> 2] | 0) + 32 >> 2] | 0)c[q >> 2] = c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                switch (c[m >> 2] | 0) {
	                    case 6:
	                    {
	                        c[j >> 2] = 0;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                    case 3:
	                    case 2:
	                    case 1:
	                    {
	                        if (!(c[(c[k >> 2] | 0) + 48 >> 2] | 0)) {
	                            g = Jj(0, c[q >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 48 >> 2] = g
	                        }
	                        c[r >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                        break
	                    }
	                    case 5:
	                    case 4:
	                    {
	                        if (!(c[(c[k >> 2] | 0) + 60 >> 2] | 0)) {
	                            g = Jj(0, c[q >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 60 >> 2] = g
	                        }
	                        c[r >> 2] = c[(c[k >> 2] | 0) + 60 >> 2];
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                if (!(c[r >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[s >> 2] = id(c[q >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[(c[s >> 2] | 0) + 32 >> 2] = c[(c[k >> 2] | 0) + 32 >> 2];
	                k = (Lj(c[r >> 2] | 0, c[l >> 2] | 0, c[s >> 2] | 0) | 0) != 0;
	                l = c[s >> 2] | 0;
	                if (k) {
	                    pd(l);
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                } else {
	                    c[j >> 2] = l;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                return 0
	            }

	            function id(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = Cb[c[135744 >> 2] & 511](76) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    ld(62016);
	                    c[j >> 2] = 0;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                g = (c[q >> 2] | 0) + 0 | 0;
	                f = g + 76 | 0;
	                do {
	                    c[g >> 2] = 0;
	                    g = g + 4 | 0
	                } while ((g | 0) < (f | 0));
	                c[(c[q >> 2] | 0) + 4 >> 2] = 17;
	                c[(c[q >> 2] | 0) + 72 >> 2] = 0;
	                c[(c[q >> 2] | 0) + 48 >> 2] = c[m >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    m = my(c[l >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 8 >> 2] = m;
	                    if (c[n >> 2] | 0) {
	                        m = my(c[n >> 2] | 0) | 0;
	                        c[(c[q >> 2] | 0) + 52 >> 2] = m
	                    }
	                    if (c[o >> 2] | 0) {
	                        m = my(c[o >> 2] | 0) | 0;
	                        c[(c[q >> 2] | 0) + 56 >> 2] = m
	                    }
	                } else {
	                    m = AP(c[k >> 2] | 0, c[l >> 2] | 0, -1) | 0;
	                    c[(c[q >> 2] | 0) + 8 >> 2] = m;
	                    if (c[n >> 2] | 0) {
	                        m = AP(c[k >> 2] | 0, c[n >> 2] | 0, -1) | 0;
	                        c[(c[q >> 2] | 0) + 52 >> 2] = m
	                    }
	                    if (c[o >> 2] | 0) {
	                        m = AP(c[k >> 2] | 0, c[o >> 2] | 0, -1) | 0;
	                        c[(c[q >> 2] | 0) + 56 >> 2] = m
	                    }
	                }
	                do if (c[p >> 2] | 0) {
	                    m = xy(c[p >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 44 >> 2] = m;
	                    if ((c[k >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 44 >> 2] | 0) < 5 : 0) {
	                        m = AP(c[k >> 2] | 0, c[p >> 2] | 0, c[(c[q >> 2] | 0) + 44 >> 2] | 0) | 0;
	                        c[(c[q >> 2] | 0) + 40 >> 2] = m;
	                        break
	                    }
	                    m = ly(c[p >> 2] | 0, c[(c[q >> 2] | 0) + 44 >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 40 >> 2] = m
	                } else {
	                    c[(c[q >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[q >> 2] | 0) + 40 >> 2] = 0
	                } while (0);
	                c[(c[q >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[q >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[q >> 2] | 0) + 68 >> 2] = 0;
	                c[j >> 2] = c[q >> 2];
	                r = c[j >> 2] | 0;
	                i = h;
	                return r | 0
	            }

	            function jd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = Rj(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function kd(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
	                g = i;
	                i = i + 112 | 0;
	                h = g;
	                j = g + 84 | 0;
	                k = g + 80 | 0;
	                l = g + 76 | 0;
	                m = g + 72 | 0;
	                n = g + 68 | 0;
	                o = g + 64 | 0;
	                p = g + 60 | 0;
	                q = g + 56 | 0;
	                r = g + 52 | 0;
	                s = g + 48 | 0;
	                t = g + 44 | 0;
	                u = g + 40 | 0;
	                v = g + 36 | 0;
	                w = g + 32 | 0;
	                x = g + 28 | 0;
	                y = g + 24 | 0;
	                z = g + 20 | 0;
	                A = g + 99 | 0;
	                B = g + 16 | 0;
	                C = g + 12 | 0;
	                D = g + 8 | 0;
	                E = g + 88 | 0;
	                F = g + 4 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = c[l >> 2];
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    G = c[j >> 2] | 0;
	                    i = g;
	                    return G | 0
	                }
	                if (c[k >> 2] | 0)c[r >> 2] = (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 13 & 1;
	                c[q >> 2] = 1e3;
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](c[q >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    ld(61816);
	                    c[j >> 2] = 0;
	                    G = c[j >> 2] | 0;
	                    i = g;
	                    return G | 0
	                }
	                c[p >> 2] = c[o >> 2];
	                a:while (1) {
	                    H = c[p >> 2] | 0;
	                    if (!(d[c[n >> 2] >> 0] | 0)) {
	                        I = 87;
	                        break
	                    }
	                    c[s >> 2] = H - (c[o >> 2] | 0);
	                    if (((c[s >> 2] | 0) + 100 | 0) >>> 0 > (c[q >> 2] | 0) >>> 0) {
	                        c[u >> 2] = c[q >> 2] << 1;
	                        if ((c[u >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                            I = 88;
	                            break
	                        }
	                        c[t >> 2] = Hb[c[135760 >> 2] & 511](c[o >> 2] | 0, c[u >> 2] | 0) | 0;
	                        if (!(c[t >> 2] | 0)) {
	                            I = 88;
	                            break
	                        }
	                        c[o >> 2] = c[t >> 2];
	                        c[q >> 2] = c[u >> 2];
	                        c[p >> 2] = (c[o >> 2] | 0) + (c[s >> 2] | 0)
	                    }
	                    b:do if ((d[c[n >> 2] >> 0] | 0) == 60) {
	                        if (((((c[r >> 2] | 0) != 0 & (c[m >> 2] | 0) != 0 ? (d[(c[n >> 2] | 0) + 1 >> 0] | 0) == 33 : 0) ? (d[(c[n >> 2] | 0) + 2 >> 0] | 0) == 45 : 0) ? (d[(c[n >> 2] | 0) + 3 >> 0] | 0) == 45 : 0) ? (l = wy(c[n >> 2] | 0, 61856) | 0, c[v >> 2] = l, (l | 0) != 0) : 0) {
	                            while (1) {
	                                l = (c[n >> 2] | 0) != (c[v >> 2] | 0);
	                                f = c[n >> 2] | 0;
	                                c[n >> 2] = f + 1;
	                                e = a[f >> 0] | 0;
	                                f = c[p >> 2] | 0;
	                                c[p >> 2] = f + 1;
	                                a[f >> 0] = e;
	                                if (!l)break;
	                                c[s >> 2] = (c[p >> 2] | 0) - (c[o >> 2] | 0);
	                                if (((c[s >> 2] | 0) + 100 | 0) >>> 0 <= (c[q >> 2] | 0) >>> 0)continue;
	                                c[x >> 2] = c[q >> 2] << 1;
	                                if ((c[x >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                    I = 88;
	                                    break a
	                                }
	                                c[w >> 2] = Hb[c[135760 >> 2] & 511](c[o >> 2] | 0, c[x >> 2] | 0) | 0;
	                                if (!(c[w >> 2] | 0)) {
	                                    I = 88;
	                                    break a
	                                }
	                                c[o >> 2] = c[w >> 2];
	                                c[q >> 2] = c[x >> 2];
	                                c[p >> 2] = (c[o >> 2] | 0) + (c[s >> 2] | 0)
	                            }
	                            l = c[n >> 2] | 0;
	                            c[n >> 2] = l + 1;
	                            e = a[l >> 0] | 0;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = e;
	                            e = c[n >> 2] | 0;
	                            c[n >> 2] = e + 1;
	                            l = a[e >> 0] | 0;
	                            e = c[p >> 2] | 0;
	                            c[p >> 2] = e + 1;
	                            a[e >> 0] = l;
	                            continue a
	                        }
	                        l = c[p >> 2] | 0;
	                        c[p >> 2] = l + 1;
	                        a[l >> 0] = 38;
	                        l = c[p >> 2] | 0;
	                        c[p >> 2] = l + 1;
	                        a[l >> 0] = 108;
	                        l = c[p >> 2] | 0;
	                        c[p >> 2] = l + 1;
	                        a[l >> 0] = 116;
	                        l = c[p >> 2] | 0;
	                        c[p >> 2] = l + 1;
	                        a[l >> 0] = 59
	                    } else {
	                        if ((d[c[n >> 2] >> 0] | 0) == 62) {
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 38;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 103;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 116;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 59;
	                            break
	                        }
	                        if ((d[c[n >> 2] >> 0] | 0) == 38) {
	                            if (((c[r >> 2] | 0) != 0 & (c[m >> 2] | 0) != 0 ? (d[(c[n >> 2] | 0) + 1 >> 0] | 0) == 123 : 0) ? (eT(c[n >> 2] | 0, 125) | 0) != 0 : 0)while (1) {
	                                l = (d[c[n >> 2] >> 0] | 0) != 125;
	                                e = c[n >> 2] | 0;
	                                c[n >> 2] = e + 1;
	                                f = a[e >> 0] | 0;
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[e >> 0] = f;
	                                if (!l)continue a;
	                                c[s >> 2] = (c[p >> 2] | 0) - (c[o >> 2] | 0);
	                                if (((c[s >> 2] | 0) + 100 | 0) >>> 0 <= (c[q >> 2] | 0) >>> 0)continue;
	                                c[z >> 2] = c[q >> 2] << 1;
	                                if ((c[z >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                    I = 88;
	                                    break a
	                                }
	                                c[y >> 2] = Hb[c[135760 >> 2] & 511](c[o >> 2] | 0, c[z >> 2] | 0) | 0;
	                                if (!(c[y >> 2] | 0)) {
	                                    I = 88;
	                                    break a
	                                }
	                                c[o >> 2] = c[y >> 2];
	                                c[q >> 2] = c[z >> 2];
	                                c[p >> 2] = (c[o >> 2] | 0) + (c[s >> 2] | 0)
	                            }
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 38;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 97;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 109;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 112;
	                            l = c[p >> 2] | 0;
	                            c[p >> 2] = l + 1;
	                            a[l >> 0] = 59;
	                            break
	                        }
	                        if (!((d[c[n >> 2] >> 0] | 0) >= 32 ? (d[c[n >> 2] >> 0] | 0) < 128 : 0))I = 40;
	                        do if (((I | 0) == 40 ? (I = 0, (d[c[n >> 2] >> 0] | 0) != 10) : 0) ? (d[c[n >> 2] >> 0] | 0) != 9 : 0) {
	                            if ((c[r >> 2] | 0) != 0 ? (d[c[n >> 2] >> 0] | 0) == 13 : 0)break;
	                            if ((d[c[n >> 2] >> 0] | 0) < 128) {
	                                if (!(9 <= (d[c[n >> 2] >> 0] | 0) ? (d[c[n >> 2] >> 0] | 0) <= 10 : 0))I = 81;
	                                if (((I | 0) == 81 ? (I = 0, (d[c[n >> 2] >> 0] | 0) != 13) : 0) ? 32 > (d[c[n >> 2] >> 0] | 0) : 0)break b;
	                                c[h >> 2] = d[c[n >> 2] >> 0];
	                                JT(E, 11, 61920, h) | 0;
	                                a[E + 10 >> 0] = 0;
	                                c[F >> 2] = E;
	                                while (1) {
	                                    if (!(a[c[F >> 2] >> 0] | 0))break b;
	                                    l = c[F >> 2] | 0;
	                                    c[F >> 2] = l + 1;
	                                    f = a[l >> 0] | 0;
	                                    l = c[p >> 2] | 0;
	                                    c[p >> 2] = l + 1;
	                                    a[l >> 0] = f
	                                }
	                            }
	                            if (c[k >> 2] | 0) {
	                                if ((c[r >> 2] | 0) != 0 ? 1 : (c[(c[k >> 2] | 0) + 60 >> 2] | 0) != 0)I = 49
	                            } else if (c[r >> 2] | 0)I = 49;
	                            if ((I | 0) == 49) {
	                                I = 0;
	                                f = a[c[n >> 2] >> 0] | 0;
	                                l = c[p >> 2] | 0;
	                                c[p >> 2] = l + 1;
	                                a[l >> 0] = f;
	                                break b
	                            }
	                            c[C >> 2] = 0;
	                            c[D >> 2] = 1;
	                            if ((d[c[n >> 2] >> 0] | 0) < 192) {
	                                gd(5032, 61864);
	                                if (c[k >> 2] | 0) {
	                                    f = my(61904) | 0;
	                                    c[(c[k >> 2] | 0) + 60 >> 2] = f
	                                }
	                                c[h >> 2] = d[c[n >> 2] >> 0];
	                                JT(A, 11, 61920, h) | 0;
	                                a[A + 10 >> 0] = 0;
	                                c[B >> 2] = A;
	                                while (1) {
	                                    if (!(a[c[B >> 2] >> 0] | 0))break;
	                                    f = c[B >> 2] | 0;
	                                    c[B >> 2] = f + 1;
	                                    l = a[f >> 0] | 0;
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[f >> 0] = l
	                                }
	                                c[n >> 2] = (c[n >> 2] | 0) + 1;
	                                continue a
	                            }
	                            l = c[n >> 2] | 0;
	                            do if ((d[c[n >> 2] >> 0] | 0) < 224) {
	                                c[C >> 2] = d[l >> 0] & 31;
	                                c[C >> 2] = c[C >> 2] << 6;
	                                c[C >> 2] = c[C >> 2] | d[(c[n >> 2] | 0) + 1 >> 0] & 63;
	                                c[D >> 2] = 2
	                            } else {
	                                f = c[n >> 2] | 0;
	                                if ((d[l >> 0] | 0) < 240) {
	                                    c[C >> 2] = d[f >> 0] & 15;
	                                    c[C >> 2] = c[C >> 2] << 6;
	                                    c[C >> 2] = c[C >> 2] | d[(c[n >> 2] | 0) + 1 >> 0] & 63;
	                                    c[C >> 2] = c[C >> 2] << 6;
	                                    c[C >> 2] = c[C >> 2] | d[(c[n >> 2] | 0) + 2 >> 0] & 63;
	                                    c[D >> 2] = 3;
	                                    break
	                                }
	                                if ((d[f >> 0] | 0) >= 248)break;
	                                c[C >> 2] = d[c[n >> 2] >> 0] & 7;
	                                c[C >> 2] = c[C >> 2] << 6;
	                                c[C >> 2] = c[C >> 2] | d[(c[n >> 2] | 0) + 1 >> 0] & 63;
	                                c[C >> 2] = c[C >> 2] << 6;
	                                c[C >> 2] = c[C >> 2] | d[(c[n >> 2] | 0) + 2 >> 0] & 63;
	                                c[C >> 2] = c[C >> 2] << 6;
	                                c[C >> 2] = c[C >> 2] | d[(c[n >> 2] | 0) + 3 >> 0] & 63;
	                                c[D >> 2] = 4
	                            } while (0);
	                            c:do if ((c[D >> 2] | 0) != 1) {
	                                l = c[C >> 2] | 0;
	                                do if ((c[C >> 2] | 0) < 256) {
	                                    if (!(9 <= (l | 0) & (c[C >> 2] | 0) <= 10 | (c[C >> 2] | 0) == 13 | 32 <= (c[C >> 2] | 0)))break c
	                                } else {
	                                    if (256 <= (l | 0) & (c[C >> 2] | 0) <= 55295)break;
	                                    if (57344 <= (c[C >> 2] | 0) & (c[C >> 2] | 0) <= 65533)break;
	                                    if (!(65536 <= (c[C >> 2] | 0) & (c[C >> 2] | 0) <= 1114111))break c
	                                } while (0);
	                                c[h >> 2] = c[C >> 2];
	                                JT(A, 11, 61968, h) | 0;
	                                a[A + 10 >> 0] = 0;
	                                c[B >> 2] = A;
	                                while (1) {
	                                    if (!(a[c[B >> 2] >> 0] | 0))break;
	                                    l = c[B >> 2] | 0;
	                                    c[B >> 2] = l + 1;
	                                    f = a[l >> 0] | 0;
	                                    l = c[p >> 2] | 0;
	                                    c[p >> 2] = l + 1;
	                                    a[l >> 0] = f
	                                }
	                                c[n >> 2] = (c[n >> 2] | 0) + (c[D >> 2] | 0);
	                                continue a
	                            } while (0);
	                            gd(9, 61928);
	                            if (c[k >> 2] | 0) {
	                                f = my(61904) | 0;
	                                c[(c[k >> 2] | 0) + 60 >> 2] = f
	                            }
	                            c[h >> 2] = d[c[n >> 2] >> 0];
	                            JT(A, 11, 61920, h) | 0;
	                            a[A + 10 >> 0] = 0;
	                            c[B >> 2] = A;
	                            while (1) {
	                                if (!(a[c[B >> 2] >> 0] | 0))break;
	                                f = c[B >> 2] | 0;
	                                c[B >> 2] = f + 1;
	                                l = a[f >> 0] | 0;
	                                f = c[p >> 2] | 0;
	                                c[p >> 2] = f + 1;
	                                a[f >> 0] = l
	                            }
	                            c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            continue a
	                        } while (0);
	                        l = a[c[n >> 2] >> 0] | 0;
	                        f = c[p >> 2] | 0;
	                        c[p >> 2] = f + 1;
	                        a[f >> 0] = l
	                    } while (0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                }
	                if ((I | 0) == 87) {
	                    a[H >> 0] = 0;
	                    c[j >> 2] = c[o >> 2];
	                    G = c[j >> 2] | 0;
	                    i = g;
	                    return G | 0
	                } else if ((I | 0) == 88) {
	                    ld(61976);
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[j >> 2] = 0;
	                    G = c[j >> 2] | 0;
	                    i = g;
	                    return G | 0
	                }
	                return 0
	            }

	            function ld(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ce(2, 2, 0, 0, c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function md(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                c[e >> 2] = a;
	                c[d >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                pd(c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function nd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](76) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    ld(61784);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 76 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 4 >> 2] = 17;
	                c[(c[f >> 2] | 0) + 48 >> 2] = c[(c[e >> 2] | 0) + 48 >> 2];
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 52 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 52 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 56 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 56 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 56 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 40 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 36 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 36 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 36 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 64 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 64 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 64 >> 2] = a
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function od(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                    i = e;
	                    return
	                }
	                b = (vy(c[g >> 2] | 0, 37) | 0) != 0;
	                a = c[f >> 2] | 0;
	                if (!b) {
	                    sj(a, c[g >> 2] | 0);
	                    i = e;
	                    return
	                }
	                pj(a, 61760) | 0;
	                a = c[g >> 2] | 0;
	                c[j >> 2] = a;
	                c[h >> 2] = a;
	                while (1) {
	                    if (!(d[c[j >> 2] >> 0] | 0))break;
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 34) {
	                        if ((c[h >> 2] | 0) != (c[j >> 2] | 0))nj(c[f >> 2] | 0, c[h >> 2] | 0, (c[j >> 2] | 0) - (c[h >> 2] | 0) | 0) | 0;
	                        nj(c[f >> 2] | 0, 61768, 6) | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        c[h >> 2] = c[j >> 2];
	                        continue
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) != 37) {
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((c[h >> 2] | 0) != (c[j >> 2] | 0))nj(c[f >> 2] | 0, c[h >> 2] | 0, (c[j >> 2] | 0) - (c[h >> 2] | 0) | 0) | 0;
	                    nj(c[f >> 2] | 0, 61776, 6) | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[h >> 2] = c[j >> 2]
	                }
	                if ((c[h >> 2] | 0) != (c[j >> 2] | 0))nj(c[f >> 2] | 0, c[h >> 2] | 0, (c[j >> 2] | 0) - (c[h >> 2] | 0) | 0) | 0;
	                pj(c[f >> 2] | 0, 61760) | 0;
	                i = e;
	                return
	            }

	            function pd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                if (((c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 68 >> 2] | 0) == 1 : 0) ? (c[d >> 2] | 0) == (c[(c[(c[d >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0) : 0)Uh(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                a = (c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0;
	                if (c[e >> 2] | 0) {
	                    if (a ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 52 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 52 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 56 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 56 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 64 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 64 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 40 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 40 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 36 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 36 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 36 >> 2] | 0)
	                } else {
	                    if (a)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 56 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 40 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 36 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 36 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function qd(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = c[k >> 2];
	                c[p >> 2] = c[m >> 2];
	                if ((c[k >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[q >> 2] = (c[k >> 2] | 0) + (c[c[l >> 2] >> 2] | 0);
	                c[r >> 2] = (c[m >> 2] | 0) + (c[c[n >> 2] >> 2] | 0);
	                c[s >> 2] = c[r >> 2];
	                a:while (1) {
	                    if ((c[m >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)u = (c[k >> 2] | 0) >>> 0 < ((c[q >> 2] | 0) + -1 | 0) >>> 0; else u = 0;
	                    v = c[m >> 2] | 0;
	                    if (!u)break;
	                    if ((d[v >> 0] | 0 | 0) >= 128) {
	                        g = ((d[c[m >> 2] >> 0] | 0) >> 6 & 31 | 192) & 255;
	                        f = c[k >> 2] | 0;
	                        c[k >> 2] = f + 1;
	                        a[f >> 0] = g;
	                        g = ((d[c[m >> 2] >> 0] | 0) & 63 | 128) & 255;
	                        f = c[k >> 2] | 0;
	                        c[k >> 2] = f + 1;
	                        a[f >> 0] = g;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    if (((c[s >> 2] | 0) - (c[m >> 2] | 0) | 0) > ((c[q >> 2] | 0) - (c[k >> 2] | 0) | 0))c[s >> 2] = (c[m >> 2] | 0) + ((c[q >> 2] | 0) - (c[k >> 2] | 0));
	                    while (1) {
	                        if ((c[m >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0)continue a;
	                        if ((d[c[m >> 2] >> 0] | 0 | 0) >= 128)continue a;
	                        g = c[m >> 2] | 0;
	                        c[m >> 2] = g + 1;
	                        f = a[g >> 0] | 0;
	                        g = c[k >> 2] | 0;
	                        c[k >> 2] = g + 1;
	                        a[g >> 0] = f
	                    }
	                }
	                if ((v >>> 0 < (c[r >> 2] | 0) >>> 0 ? (c[k >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0 : 0) ? (d[c[m >> 2] >> 0] | 0 | 0) < 128 : 0) {
	                    q = c[m >> 2] | 0;
	                    c[m >> 2] = q + 1;
	                    r = a[q >> 0] | 0;
	                    q = c[k >> 2] | 0;
	                    c[k >> 2] = q + 1;
	                    a[q >> 0] = r
	                }
	                c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[o >> 2] | 0);
	                c[c[n >> 2] >> 2] = (c[m >> 2] | 0) - (c[p >> 2] | 0);
	                c[j >> 2] = c[c[l >> 2] >> 2];
	                t = c[j >> 2] | 0;
	                i = h;
	                return t | 0
	            }

	            function rd(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                h = i;
	                i = i + 64 | 0;
	                j = h + 48 | 0;
	                k = h + 44 | 0;
	                l = h + 40 | 0;
	                m = h + 36 | 0;
	                n = h + 32 | 0;
	                o = h + 28 | 0;
	                p = h + 24 | 0;
	                q = h + 20 | 0;
	                r = h + 16 | 0;
	                s = h + 12 | 0;
	                t = h + 8 | 0;
	                u = h + 4 | 0;
	                v = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = c[m >> 2];
	                c[q >> 2] = c[k >> 2];
	                c[r >> 2] = c[m >> 2];
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                if (!(c[m >> 2] | 0)) {
	                    c[c[l >> 2] >> 2] = 0;
	                    c[c[n >> 2] >> 2] = 0;
	                    c[j >> 2] = 0;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                c[s >> 2] = (c[m >> 2] | 0) + (c[c[n >> 2] >> 2] | 0);
	                c[p >> 2] = (c[k >> 2] | 0) + (c[c[l >> 2] >> 2] | 0);
	                a:while (1) {
	                    if ((c[m >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0) {
	                        x = 28;
	                        break
	                    }
	                    g = c[m >> 2] | 0;
	                    c[m >> 2] = g + 1;
	                    c[u >> 2] = d[g >> 0];
	                    g = c[u >> 2] | 0;
	                    do if ((c[u >> 2] | 0) >>> 0 < 128) {
	                        c[t >> 2] = g;
	                        c[v >> 2] = 0
	                    } else {
	                        if (g >>> 0 < 192) {
	                            x = 10;
	                            break a
	                        }
	                        f = c[u >> 2] | 0;
	                        if ((c[u >> 2] | 0) >>> 0 < 224) {
	                            c[t >> 2] = f & 31;
	                            c[v >> 2] = 1;
	                            break
	                        }
	                        e = c[u >> 2] | 0;
	                        if (f >>> 0 < 240) {
	                            c[t >> 2] = e & 15;
	                            c[v >> 2] = 2;
	                            break
	                        }
	                        if (e >>> 0 >= 248) {
	                            x = 17;
	                            break a
	                        }
	                        c[t >> 2] = c[u >> 2] & 7;
	                        c[v >> 2] = 3
	                    } while (0);
	                    if (((c[s >> 2] | 0) - (c[m >> 2] | 0) | 0) < (c[v >> 2] | 0)) {
	                        x = 28;
	                        break
	                    }
	                    while (1) {
	                        if (!(c[v >> 2] | 0))break;
	                        if ((c[m >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0)break;
	                        g = c[m >> 2] | 0;
	                        c[m >> 2] = g + 1;
	                        e = d[g >> 0] | 0;
	                        c[u >> 2] = e;
	                        if ((e & 192 | 0) != 128) {
	                            x = 22;
	                            break a
	                        }
	                        c[t >> 2] = c[t >> 2] << 6;
	                        c[t >> 2] = c[t >> 2] | c[u >> 2] & 63;
	                        c[v >> 2] = (c[v >> 2] | 0) + -1
	                    }
	                    y = c[k >> 2] | 0;
	                    if ((c[t >> 2] | 0) >>> 0 > 255) {
	                        x = 27;
	                        break
	                    }
	                    if (y >>> 0 >= (c[p >> 2] | 0) >>> 0) {
	                        x = 28;
	                        break
	                    }
	                    e = c[t >> 2] & 255;
	                    g = c[k >> 2] | 0;
	                    c[k >> 2] = g + 1;
	                    a[g >> 0] = e;
	                    c[o >> 2] = c[m >> 2]
	                }
	                if ((x | 0) == 10) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 17) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 22) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 27) {
	                    c[c[l >> 2] >> 2] = y - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 28) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = c[c[l >> 2] >> 2];
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                return 0
	            }

	            function sd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((c[h >> 2] | 0) >= 4) {
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 0 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 60 : 0) {
	                        c[f >> 2] = 5;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0) {
	                        c[f >> 2] = 4;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 0 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 60 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0) {
	                        c[f >> 2] = 7;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 0 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 60 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0) {
	                        c[f >> 2] = 8;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 76 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 111 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 167 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 148 : 0) {
	                        c[f >> 2] = 6;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 109 : 0) {
	                        c[f >> 2] = 1;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0) {
	                        c[f >> 2] = 2;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 0 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 60 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 0 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 63 : 0) {
	                        c[f >> 2] = 3;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                }
	                if ((((c[h >> 2] | 0) >= 3 ? (d[c[g >> 2] >> 0] | 0 | 0) == 239 : 0) ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 187 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 191 : 0) {
	                    c[f >> 2] = 1;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((c[h >> 2] | 0) >= 2) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 254 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 255 : 0) {
	                        c[f >> 2] = 3;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 255 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 254 : 0) {
	                        c[f >> 2] = 2;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                }
	                c[f >> 2] = 0;
	                j = c[f >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function td() {
	                var a = 0, b = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                if (!(c[15520] | 0)) {
	                    i = a;
	                    return
	                }
	                c[b >> 2] = 0;
	                while (1) {
	                    if ((c[b >> 2] | 0) >= (c[15522] | 0))break;
	                    if (c[(c[15520] | 0) + (c[b >> 2] << 3) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[15520] | 0) + (c[b >> 2] << 3) >> 2] | 0);
	                    if (c[(c[15520] | 0) + (c[b >> 2] << 3) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[15520] | 0) + (c[b >> 2] << 3) + 4 >> 2] | 0);
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                c[15522] = 0;
	                c[15524] = 0;
	                zb[c[135736 >> 2] & 511](c[15520] | 0);
	                c[15520] = 0;
	                i = a;
	                return
	            }

	            function ud(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 112 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                h = d + 12 | 0;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (!(c[15520] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) >= 99)break;
	                    b = (WS(a[(c[f >> 2] | 0) + (c[g >> 2] | 0) >> 0] | 0) | 0) & 255;
	                    a[h + (c[g >> 2] | 0) >> 0] = b;
	                    if (!(a[h + (c[g >> 2] | 0) >> 0] | 0))break;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                a[h + (c[g >> 2] | 0) >> 0] = 0;
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) >= (c[15522] | 0)) {
	                        k = 14;
	                        break
	                    }
	                    f = (PT(c[(c[15520] | 0) + (c[g >> 2] << 3) + 4 >> 2] | 0, h) | 0) != 0;
	                    l = c[g >> 2] | 0;
	                    if (!f) {
	                        k = 12;
	                        break
	                    }
	                    c[g >> 2] = l + 1
	                }
	                if ((k | 0) == 12) {
	                    c[e >> 2] = c[(c[15520] | 0) + (l << 3) >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else if ((k | 0) == 14) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function vd(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 128 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                k = e + 16 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= 99)break;
	                    d = (WS(a[(c[h >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0) | 0) & 255;
	                    a[k + (c[j >> 2] | 0) >> 0] = d;
	                    if (!(a[k + (c[j >> 2] | 0) >> 0] | 0))break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                a[k + (c[j >> 2] | 0) >> 0] = 0;
	                if (!(c[15520] | 0)) {
	                    c[15522] = 0;
	                    c[15524] = 20;
	                    c[15520] = Cb[c[135744 >> 2] & 511](c[15524] << 3) | 0;
	                    if (!(c[15520] | 0)) {
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } else if ((c[15522] | 0) >= (c[15524] | 0)) {
	                    c[15524] = c[15524] << 1;
	                    c[15520] = Hb[c[135760 >> 2] & 511](c[15520] | 0, c[15524] << 3) | 0
	                }
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= (c[15522] | 0)) {
	                        m = 17;
	                        break
	                    }
	                    if (!(PT(c[(c[15520] | 0) + (c[j >> 2] << 3) + 4 >> 2] | 0, k) | 0)) {
	                        m = 15;
	                        break
	                    }
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((m | 0) == 15) {
	                    zb[c[135736 >> 2] & 511](c[(c[15520] | 0) + (c[j >> 2] << 3) >> 2] | 0);
	                    h = Cb[c[135768 >> 2] & 511](c[g >> 2] | 0) | 0;
	                    c[(c[15520] | 0) + (c[j >> 2] << 3) >> 2] = h;
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((m | 0) == 17) {
	                    m = Cb[c[135768 >> 2] & 511](c[g >> 2] | 0) | 0;
	                    c[(c[15520] | 0) + (c[15522] << 3) >> 2] = m;
	                    m = Cb[c[135768 >> 2] & 511](k) | 0;
	                    c[(c[15520] | 0) + (c[15522] << 3) + 4 >> 2] = m;
	                    c[15522] = (c[15522] | 0) + 1;
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function wd(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 528 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d + 16 | 0;
	                j = d;
	                c[f >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    c[g >> 2] = ud(c[f >> 2] | 0) | 0;
	                    if (c[g >> 2] | 0)c[f >> 2] = c[g >> 2];
	                    c[j >> 2] = 0;
	                    while (1) {
	                        if ((c[j >> 2] | 0) >= 499)break;
	                        b = (WS(a[(c[f >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0) | 0) & 255;
	                        a[h + (c[j >> 2] | 0) >> 0] = b;
	                        if (!(a[h + (c[j >> 2] | 0) >> 0] | 0))break;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    a[h + (c[j >> 2] | 0) >> 0] = 0;
	                    if (!(PT(h, 62104) | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if (!(PT(h, 62112) | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (!(PT(h, 62120) | 0)) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (!(PT(h, 62128) | 0)) {
	                        c[e >> 2] = 2;
	                        break
	                    }
	                    if (!(PT(h, 62136) | 0)) {
	                        c[e >> 2] = 2;
	                        break
	                    }
	                    if (!(PT(h, 62144) | 0)) {
	                        c[e >> 2] = 9;
	                        break
	                    }
	                    if (!(PT(h, 62160) | 0)) {
	                        c[e >> 2] = 9;
	                        break
	                    }
	                    if (!(PT(h, 62168) | 0)) {
	                        c[e >> 2] = 9;
	                        break
	                    }
	                    if (!(PT(h, 62176) | 0)) {
	                        c[e >> 2] = 4;
	                        break
	                    }
	                    if (!(PT(h, 62192) | 0)) {
	                        c[e >> 2] = 4;
	                        break
	                    }
	                    if (!(PT(h, 62200) | 0)) {
	                        c[e >> 2] = 4;
	                        break
	                    }
	                    if (!(PT(h, 62208) | 0)) {
	                        c[e >> 2] = 10;
	                        break
	                    }
	                    if (!(PT(h, 62224) | 0)) {
	                        c[e >> 2] = 10;
	                        break
	                    }
	                    if (!(PT(h, 62240) | 0)) {
	                        c[e >> 2] = 10;
	                        break
	                    }
	                    if (!(PT(h, 62256) | 0)) {
	                        c[e >> 2] = 11;
	                        break
	                    }
	                    if (!(PT(h, 62272) | 0)) {
	                        c[e >> 2] = 11;
	                        break
	                    }
	                    if (!(PT(h, 62288) | 0)) {
	                        c[e >> 2] = 11;
	                        break
	                    }
	                    if (!(PT(h, 62304) | 0)) {
	                        c[e >> 2] = 12;
	                        break
	                    }
	                    if (!(PT(h, 62320) | 0)) {
	                        c[e >> 2] = 13;
	                        break
	                    }
	                    if (!(PT(h, 62336) | 0)) {
	                        c[e >> 2] = 14;
	                        break
	                    }
	                    if (!(PT(h, 62352) | 0)) {
	                        c[e >> 2] = 15;
	                        break
	                    }
	                    if (!(PT(h, 62368) | 0)) {
	                        c[e >> 2] = 16;
	                        break
	                    }
	                    if (!(PT(h, 62384) | 0)) {
	                        c[e >> 2] = 17;
	                        break
	                    }
	                    if (!(PT(h, 62400) | 0)) {
	                        c[e >> 2] = 18;
	                        break
	                    }
	                    if (!(PT(h, 62416) | 0)) {
	                        c[e >> 2] = 19;
	                        break
	                    }
	                    if (!(PT(h, 62432) | 0)) {
	                        c[e >> 2] = 20;
	                        break
	                    }
	                    if (PT(h, 62448) | 0) {
	                        c[e >> 2] = -1;
	                        break
	                    } else {
	                        c[e >> 2] = 21;
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function xd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do switch (c[e >> 2] | 0) {
	                    case 4:
	                    {
	                        c[d >> 2] = 62176;
	                        break
	                    }
	                    case 10:
	                    {
	                        c[d >> 2] = 62208;
	                        break
	                    }
	                    case 20:
	                    {
	                        c[d >> 2] = 62464;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[d >> 2] = 62128;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = 62352;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[d >> 2] = 62304;
	                        break
	                    }
	                    case 6:
	                    {
	                        c[d >> 2] = 62456;
	                        break
	                    }
	                    case 21:
	                    {
	                        c[d >> 2] = 62448;
	                        break
	                    }
	                    case 13:
	                    {
	                        c[d >> 2] = 62320;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[d >> 2] = 62416;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[d >> 2] = 62176;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[d >> 2] = 62176;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = 62112;
	                        break
	                    }
	                    case 9:
	                    {
	                        c[d >> 2] = 62144;
	                        break
	                    }
	                    case 11:
	                    {
	                        c[d >> 2] = 62256;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[d >> 2] = 62176;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = 62384;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = 62336;
	                        break
	                    }
	                    case 18:
	                    {
	                        c[d >> 2] = 62400;
	                        break
	                    }
	                    case -1:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = 62368;
	                        break
	                    }
	                    case 22:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 0:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = 62128;
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 0
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function yd(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 544 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 32 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[p >> 2] = 0;
	                c[m >> 2] = ud(c[h >> 2] | 0) | 0;
	                if (c[m >> 2] | 0)c[h >> 2] = c[m >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    Id(6e3, 62480, 0);
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[o >> 2] = 0;
	                while (1) {
	                    if ((c[o >> 2] | 0) >= 499)break;
	                    m = (WS(a[(c[h >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0) | 0) & 255;
	                    a[n + (c[o >> 2] | 0) >> 0] = m;
	                    if (!(a[n + (c[o >> 2] | 0) >> 0] | 0))break;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                a[n + (c[o >> 2] | 0) >> 0] = 0;
	                c[p >> 2] = Cb[c[135768 >> 2] & 511](n) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    Jd(62520);
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[l >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                    Jd(62520);
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else {
	                    n = c[l >> 2] | 0;
	                    c[n + 0 >> 2] = 0;
	                    c[n + 4 >> 2] = 0;
	                    c[n + 8 >> 2] = 0;
	                    c[n + 12 >> 2] = 0;
	                    c[n + 16 >> 2] = 0;
	                    c[(c[l >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                    c[(c[l >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                    c[c[l >> 2] >> 2] = c[p >> 2];
	                    c[(c[l >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[l >> 2] | 0) + 16 >> 2] = 0;
	                    zd(c[l >> 2] | 0);
	                    c[g >> 2] = c[l >> 2];
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                return 0
	            }

	            function zd(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[15642] | 0))Ad();
	                if ((c[d >> 2] | 0) == 0 | (c[15642] | 0) == 0) {
	                    Id(6001, 62768, 0);
	                    i = b;
	                    return
	                }
	                if ((c[15688] | 0) >= 50) {
	                    Id(6002, 62816, 62888);
	                    i = b;
	                    return
	                } else {
	                    a = c[d >> 2] | 0;
	                    d = c[15688] | 0;
	                    c[15688] = d + 1;
	                    c[(c[15642] | 0) + (d << 2) >> 2] = a;
	                    i = b;
	                    return
	                }
	            }

	            function Ad() {
	                var a = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                e = a + 4 | 0;
	                f = a;
	                b[e >> 1] = 4660;
	                c[f >> 2] = e;
	                if (c[15642] | 0) {
	                    i = a;
	                    return
	                }
	                c[15642] = Cb[c[135744 >> 2] & 511](200) | 0;
	                do if ((d[c[f >> 2] >> 0] | 0 | 0) != 18)if ((d[c[f >> 2] >> 0] | 0 | 0) == 52) {
	                    c[15644] = 1;
	                    break
	                } else {
	                    Id(1, 62584, 0);
	                    break
	                } else c[15644] = 0; while (0);
	                if (!(c[15642] | 0)) {
	                    Jd(62624);
	                    i = a;
	                    return
	                } else {
	                    yd(62112, 213, 213) | 0;
	                    c[15672] = yd(62672, 214, 215) | 0;
	                    c[15678] = yd(62696, 216, 217) | 0;
	                    yd(62128, 214, 218) | 0;
	                    yd(62208, 219, 220) | 0;
	                    yd(62720, 221, 222) | 0;
	                    yd(62728, 221, 222) | 0;
	                    yd(62744, 0, 223) | 0;
	                    i = a;
	                    return
	                }
	            }

	            function Bd() {
	                var a = 0;
	                a = i;
	                td();
	                if (!(c[15642] | 0)) {
	                    i = a;
	                    return
	                }
	                while (1) {
	                    if ((c[15688] | 0) <= 0)break;
	                    c[15688] = (c[15688] | 0) + -1;
	                    if (!(c[(c[15642] | 0) + (c[15688] << 2) >> 2] | 0))continue;
	                    if (c[c[(c[15642] | 0) + (c[15688] << 2) >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[(c[15642] | 0) + (c[15688] << 2) >> 2] >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[(c[15642] | 0) + (c[15688] << 2) >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[15642] | 0);
	                c[15642] = 0;
	                c[15688] = 0;
	                c[15690] = 0;
	                i = a;
	                return
	            }

	            function Cd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[15642] | 0))Ad();
	                a:do switch (c[e >> 2] | 0) {
	                    case 6:
	                    {
	                        c[f >> 2] = Dd(62456) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62912) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62920) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62936) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = c[15672];
	                        break
	                    }
	                    case 9:
	                    {
	                        c[f >> 2] = Dd(62144) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62160) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62168) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 18:
	                    {
	                        c[f >> 2] = Dd(62400) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[d >> 2] = c[15678];
	                        break
	                    }
	                    case 10:
	                    {
	                        c[f >> 2] = Dd(62208) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case -1:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[f >> 2] = Dd(62304) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[f >> 2] = Dd(62176) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62192) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62200) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[f >> 2] = Dd(62336) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[f >> 2] = Dd(62416) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 20:
	                    {
	                        c[f >> 2] = Dd(62944) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62432) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62960) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 11:
	                    {
	                        c[f >> 2] = Dd(62256) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 0:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[f >> 2] = Dd(62384) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[f >> 2] = Dd(62352) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[f >> 2] = Dd(62368) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 13:
	                    {
	                        c[f >> 2] = Dd(62320) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 21:
	                    {
	                        c[f >> 2] = Dd(62448) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[f >> 2] = Dd(62176) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62192) | 0;
	                        if (c[f >> 2] | 0) {
	                            c[d >> 2] = c[f >> 2];
	                            break a
	                        }
	                        c[f >> 2] = Dd(62200) | 0;
	                        if (c[f >> 2] | 0)c[d >> 2] = c[f >> 2]; else g = 63;
	                        break
	                    }
	                    default:
	                        g = 63
	                } while (0);
	                if ((g | 0) == 63)c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Dd(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                d = i;
	                i = i + 144 | 0;
	                e = d + 36 | 0;
	                f = d + 32 | 0;
	                g = d + 28 | 0;
	                h = d + 24 | 0;
	                j = d + 20 | 0;
	                k = d + 16 | 0;
	                l = d + 12 | 0;
	                m = d + 8 | 0;
	                n = d + 40 | 0;
	                o = d + 4 | 0;
	                p = d;
	                c[f >> 2] = b;
	                if (!(c[15642] | 0))Ad();
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = c[15690];
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                if (!(a[c[f >> 2] >> 0] | 0)) {
	                    c[e >> 2] = c[15690];
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                c[h >> 2] = c[f >> 2];
	                c[g >> 2] = ud(c[f >> 2] | 0) | 0;
	                if (c[g >> 2] | 0)c[f >> 2] = c[g >> 2];
	                c[o >> 2] = 0;
	                while (1) {
	                    if ((c[o >> 2] | 0) >= 99)break;
	                    g = (WS(a[(c[f >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0) | 0) & 255;
	                    a[n + (c[o >> 2] | 0) >> 0] = g;
	                    if (!(a[n + (c[o >> 2] | 0) >> 0] | 0))break;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                a[n + (c[o >> 2] | 0) >> 0] = 0;
	                a:do if (c[15642] | 0) {
	                    c[o >> 2] = 0;
	                    while (1) {
	                        if ((c[o >> 2] | 0) >= (c[15688] | 0))break a;
	                        g = (PT(n, c[c[(c[15642] | 0) + (c[o >> 2] << 2) >> 2] >> 2] | 0) | 0) != 0;
	                        r = c[o >> 2] | 0;
	                        if (!g)break;
	                        c[o >> 2] = r + 1
	                    }
	                    c[e >> 2] = c[(c[15642] | 0) + (r << 2) >> 2];
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                } while (0);
	                c[l >> 2] = XS(62112, c[f >> 2] | 0) | 0;
	                c[m >> 2] = XS(c[f >> 2] | 0, 62112) | 0;
	                if ((c[l >> 2] | 0) == (-1 | 0))c[l >> 2] = XS(62112, n) | 0;
	                if ((c[m >> 2] | 0) == (-1 | 0))c[m >> 2] = XS(n, 62112) | 0;
	                if ((c[l >> 2] | 0) != (-1 | 0) & (c[m >> 2] | 0) != (-1 | 0)) {
	                    c[k >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        q = c[e >> 2] | 0;
	                        i = d;
	                        return q | 0
	                    } else {
	                        n = c[k >> 2] | 0;
	                        c[n + 0 >> 2] = 0;
	                        c[n + 4 >> 2] = 0;
	                        c[n + 8 >> 2] = 0;
	                        c[n + 12 >> 2] = 0;
	                        c[n + 16 >> 2] = 0;
	                        n = Cb[c[135768 >> 2] & 511](c[f >> 2] | 0) | 0;
	                        c[c[k >> 2] >> 2] = n;
	                        c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = 0;
	                        c[(c[k >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                        c[(c[k >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                        c[e >> 2] = c[k >> 2];
	                        q = c[e >> 2] | 0;
	                        i = d;
	                        return q | 0
	                    }
	                }
	                if ((c[l >> 2] | 0) != (-1 | 0) | (c[m >> 2] | 0) != (-1 | 0))Id(1, 62976, c[f >> 2] | 0);
	                c[j >> 2] = wd(c[h >> 2] | 0) | 0;
	                if (((c[j >> 2] | 0) != -1 ? (c[p >> 2] = xd(c[j >> 2] | 0) | 0, (c[p >> 2] | 0) != 0) : 0) ? (PT(c[f >> 2] | 0, c[p >> 2] | 0) | 0) != 0 : 0) {
	                    c[e >> 2] = Dd(c[p >> 2] | 0) | 0;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                c[e >> 2] = 0;
	                q = c[e >> 2] | 0;
	                i = d;
	                return q | 0
	            }

	            function Ed(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 112 | 0;
	                g = f;
	                h = f + 56 | 0;
	                j = f + 52 | 0;
	                k = f + 48 | 0;
	                l = f + 44 | 0;
	                m = f + 40 | 0;
	                n = f + 36 | 0;
	                o = f + 32 | 0;
	                p = f + 28 | 0;
	                q = f + 24 | 0;
	                r = f + 20 | 0;
	                s = f + 60 | 0;
	                t = f + 16 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = -2;
	                if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[r >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                    c[q >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                    c[n >> 2] = _y(c[q >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = f;
	                        return u | 0
	                    }
	                    c[m >> 2] = ($y(c[r >> 2] | 0) | 0) - 1;
	                    e = c[n >> 2] | 0;
	                    if ((c[k >> 2] | 0) >= 0) {
	                        if (e >>> 0 > (c[k >> 2] | 0) >>> 0)c[n >> 2] = c[k >> 2]
	                    } else if (e >>> 0 > 180)c[n >> 2] = 180;
	                    if (c[n >> 2] << 1 >>> 0 >= (c[m >> 2] | 0) >>> 0) {
	                        Uy(c[r >> 2] | 0, c[n >> 2] << 1) | 0;
	                        c[m >> 2] = ($y(c[r >> 2] | 0) | 0) - 1
	                    }
	                    if ((c[m >> 2] | 0) >>> 0 > 360)c[m >> 2] = 360;
	                    c[o >> 2] = c[n >> 2];
	                    c[p >> 2] = c[m >> 2];
	                    m = c[(c[j >> 2] | 0) + 12 >> 2] | 0;
	                    if (!(c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        if ((c[m + 12 >> 2] | 0) != 0 ? (n = c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0, j = Wy(c[r >> 2] | 0) | 0, c[l >> 2] = Sd(n, j, p, Vy(c[q >> 2] | 0) | 0, o) | 0, Ty(c[q >> 2] | 0, c[o >> 2] | 0) | 0, Xy(c[r >> 2] | 0, c[p >> 2] | 0) | 0, (c[l >> 2] | 0) == -1) : 0)c[l >> 2] = -3
	                    } else {
	                        j = c[m + 4 >> 2] | 0;
	                        m = Wy(c[r >> 2] | 0) | 0;
	                        n = Vy(c[q >> 2] | 0) | 0;
	                        c[l >> 2] = Fb[j & 511](m, p, n, o) | 0;
	                        Ty(c[q >> 2] | 0, c[o >> 2] | 0) | 0;
	                        Xy(c[r >> 2] | 0, c[p >> 2] | 0) | 0
	                    }
	                    if ((c[l >> 2] | 0) == -2) {
	                        c[t >> 2] = Vy(c[q >> 2] | 0) | 0;
	                        q = d[(c[t >> 2] | 0) + 1 >> 0] | 0;
	                        p = d[(c[t >> 2] | 0) + 2 >> 0] | 0;
	                        r = d[(c[t >> 2] | 0) + 3 >> 0] | 0;
	                        c[g >> 2] = d[c[t >> 2] >> 0];
	                        c[g + 4 >> 2] = q;
	                        c[g + 8 >> 2] = p;
	                        c[g + 12 >> 2] = r;
	                        JT(s, 49, 63016, g) | 0;
	                        a[s + 49 >> 0] = 0;
	                        Id(6003, 63048, s)
	                    }
	                    if ((c[l >> 2] | 0) == -3)c[l >> 2] = 0;
	                    if ((c[l >> 2] | 0) == -1)c[l >> 2] = 0;
	                    c[h >> 2] = c[l >> 2];
	                    u = c[h >> 2] | 0;
	                    i = f;
	                    return u | 0
	                }
	                c[h >> 2] = -1;
	                u = c[h >> 2] | 0;
	                i = f;
	                return u | 0
	            }

	            function Fd(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 112 | 0;
	                g = f;
	                h = f + 56 | 0;
	                j = f + 52 | 0;
	                k = f + 48 | 0;
	                l = f + 44 | 0;
	                m = f + 40 | 0;
	                n = f + 36 | 0;
	                o = f + 32 | 0;
	                p = f + 28 | 0;
	                q = f + 24 | 0;
	                r = f + 20 | 0;
	                s = f + 60 | 0;
	                t = f + 16 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = -2;
	                if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[r >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                    c[q >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                    c[n >> 2] = _y(c[q >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = f;
	                        return u | 0
	                    }
	                    if ((c[n >> 2] | 0) >>> 0 > 65536 & (c[k >> 2] | 0) == 0)c[n >> 2] = 65536;
	                    c[m >> 2] = $y(c[r >> 2] | 0) | 0;
	                    if ((c[m >> 2] | 0) >>> 0 > 0)c[m >> 2] = (c[m >> 2] | 0) + -1;
	                    if (c[n >> 2] << 1 >>> 0 >= (c[m >> 2] | 0) >>> 0 ? (Uy(c[r >> 2] | 0, c[n >> 2] << 1) | 0, c[m >> 2] = $y(c[r >> 2] | 0) | 0, (c[m >> 2] | 0) >>> 0 > 0) : 0)c[m >> 2] = (c[m >> 2] | 0) + -1;
	                    if ((c[m >> 2] | 0) >>> 0 > 131072 & (c[k >> 2] | 0) == 0)c[m >> 2] = 131072;
	                    c[o >> 2] = c[n >> 2];
	                    c[p >> 2] = c[m >> 2];
	                    m = c[(c[j >> 2] | 0) + 12 >> 2] | 0;
	                    if (!(c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0)) {
	                        if ((c[m + 12 >> 2] | 0) != 0 ? (n = c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0, j = Wy(c[r >> 2] | 0) | 0, c[l >> 2] = Sd(n, j, p, Vy(c[q >> 2] | 0) | 0, o) | 0, Ty(c[q >> 2] | 0, c[o >> 2] | 0) | 0, Xy(c[r >> 2] | 0, c[p >> 2] | 0) | 0, (c[l >> 2] | 0) == -1) : 0)c[l >> 2] = -3
	                    } else {
	                        j = c[m + 4 >> 2] | 0;
	                        m = Wy(c[r >> 2] | 0) | 0;
	                        n = Vy(c[q >> 2] | 0) | 0;
	                        c[l >> 2] = Fb[j & 511](m, p, n, o) | 0;
	                        Ty(c[q >> 2] | 0, c[o >> 2] | 0) | 0;
	                        Xy(c[r >> 2] | 0, c[p >> 2] | 0) | 0
	                    }
	                    if ((c[l >> 2] | 0) == -2) {
	                        c[t >> 2] = Vy(c[q >> 2] | 0) | 0;
	                        q = d[(c[t >> 2] | 0) + 1 >> 0] | 0;
	                        r = d[(c[t >> 2] | 0) + 2 >> 0] | 0;
	                        o = d[(c[t >> 2] | 0) + 3 >> 0] | 0;
	                        c[g >> 2] = d[c[t >> 2] >> 0];
	                        c[g + 4 >> 2] = q;
	                        c[g + 8 >> 2] = r;
	                        c[g + 12 >> 2] = o;
	                        JT(s, 49, 63016, g) | 0;
	                        a[s + 49 >> 0] = 0;
	                        Id(6003, 63048, s)
	                    }
	                    if ((c[l >> 2] | 0) == -3)c[l >> 2] = 0;
	                    c[h >> 2] = (c[p >> 2] | 0) != 0 ? c[p >> 2] | 0 : c[l >> 2] | 0;
	                    u = c[h >> 2] | 0;
	                    i = f;
	                    return u | 0
	                }
	                c[h >> 2] = -1;
	                u = c[h >> 2] | 0;
	                i = f;
	                return u | 0
	            }

	            function Gd(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                f = i;
	                i = i + 160 | 0;
	                g = f;
	                h = f + 72 | 0;
	                j = f + 68 | 0;
	                k = f + 64 | 0;
	                l = f + 60 | 0;
	                m = f + 56 | 0;
	                n = f + 52 | 0;
	                o = f + 48 | 0;
	                p = f + 44 | 0;
	                q = f + 40 | 0;
	                r = f + 36 | 0;
	                s = f + 32 | 0;
	                t = f + 28 | 0;
	                u = f + 24 | 0;
	                v = f + 20 | 0;
	                w = f + 16 | 0;
	                x = f + 128 | 0;
	                y = f + 76 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = -2;
	                c[n >> 2] = 0;
	                c[t >> 2] = 0;
	                if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[s >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                    c[r >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                    a:while (1) {
	                        c[m >> 2] = $y(c[s >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) >>> 0 > 0)c[m >> 2] = (c[m >> 2] | 0) + -1;
	                        if (c[k >> 2] | 0) {
	                            z = 10;
	                            break
	                        }
	                        c[o >> 2] = _y(c[r >> 2] | 0) | 0;
	                        if (!(c[o >> 2] | 0)) {
	                            z = 17;
	                            break
	                        }
	                        if ((c[o >> 2] | 0) >>> 0 > 65536)c[o >> 2] = 65536;
	                        if (c[o >> 2] << 2 >>> 0 >= (c[m >> 2] | 0) >>> 0) {
	                            Uy(c[s >> 2] | 0, c[o >> 2] << 2) | 0;
	                            c[m >> 2] = ($y(c[s >> 2] | 0) | 0) - 1
	                        }
	                        if ((c[m >> 2] | 0) >>> 0 > 262144)c[m >> 2] = 262144;
	                        c[p >> 2] = c[o >> 2];
	                        c[q >> 2] = c[m >> 2];
	                        e = c[(c[j >> 2] | 0) + 12 >> 2] | 0;
	                        do if (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) {
	                            b = c[e + 8 >> 2] | 0;
	                            A = Wy(c[s >> 2] | 0) | 0;
	                            B = Vy(c[r >> 2] | 0) | 0;
	                            c[l >> 2] = Fb[b & 511](A, q, B, p) | 0;
	                            if ((c[q >> 2] | 0) > 0) {
	                                Ty(c[r >> 2] | 0, c[p >> 2] | 0) | 0;
	                                Xy(c[s >> 2] | 0, c[q >> 2] | 0) | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + (c[q >> 2] | 0)
	                            }
	                        } else {
	                            if (!(c[e + 16 >> 2] | 0)) {
	                                z = 32;
	                                break a
	                            }
	                            B = c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 16 >> 2] | 0;
	                            A = Wy(c[s >> 2] | 0) | 0;
	                            c[l >> 2] = Sd(B, A, q, Vy(c[r >> 2] | 0) | 0, p) | 0;
	                            Ty(c[r >> 2] | 0, c[p >> 2] | 0) | 0;
	                            Xy(c[s >> 2] | 0, c[q >> 2] | 0) | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + (c[q >> 2] | 0);
	                            if ((c[l >> 2] | 0) == -1)if ((c[q >> 2] | 0) > 0) {
	                                c[t >> 2] = 0;
	                                continue a
	                            } else {
	                                c[l >> 2] = -3;
	                                break
	                            }
	                        } while (0);
	                        if ((c[l >> 2] | 0) >= 0)c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] << 5);
	                        if ((c[l >> 2] | 0) != -2)break;
	                        c[u >> 2] = _y(c[r >> 2] | 0) | 0;
	                        c[v >> 2] = Vy(c[r >> 2] | 0) | 0;
	                        c[w >> 2] = Ey(c[v >> 2] | 0, u) | 0;
	                        if ((c[t >> 2] | 0) != 0 ? (c[q >> 2] | 0) < (c[t >> 2] | 0) : 0) {
	                            z = 38;
	                            break
	                        }
	                        if ((c[w >> 2] | 0) <= 0) {
	                            z = 41;
	                            break
	                        }
	                        c[g >> 2] = c[w >> 2];
	                        c[t >> 2] = JT(x, 20, 63152, g) | 0;
	                        Ty(c[r >> 2] | 0, c[u >> 2] | 0) | 0;
	                        dz(c[r >> 2] | 0, x, -1) | 0
	                    }
	                    if ((z | 0) == 10) {
	                        c[p >> 2] = 0;
	                        c[q >> 2] = c[m >> 2];
	                        m = c[(c[j >> 2] | 0) + 12 >> 2] | 0;
	                        if (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) {
	                            x = c[m + 8 >> 2] | 0;
	                            u = Wy(c[s >> 2] | 0) | 0;
	                            c[l >> 2] = Fb[x & 511](u, q, 0, p) | 0;
	                            if ((c[l >> 2] | 0) > 0)Xy(c[s >> 2] | 0, c[q >> 2] | 0) | 0
	                        } else if (c[m + 16 >> 2] | 0) {
	                            m = c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 16 >> 2] | 0;
	                            c[l >> 2] = Sd(m, Wy(c[s >> 2] | 0) | 0, q, 0, p) | 0;
	                            Xy(c[s >> 2] | 0, c[q >> 2] | 0) | 0
	                        }
	                        c[h >> 2] = 0;
	                        C = c[h >> 2] | 0;
	                        i = f;
	                        return C | 0
	                    } else if ((z | 0) == 17) {
	                        c[h >> 2] = 0;
	                        C = c[h >> 2] | 0;
	                        i = f;
	                        return C | 0
	                    } else if ((z | 0) == 32) {
	                        Id(6004, 63104, 0);
	                        c[h >> 2] = -1;
	                        C = c[h >> 2] | 0;
	                        i = f;
	                        return C | 0
	                    } else if ((z | 0) == 38) {
	                        Yy(c[s >> 2] | 0, c[q >> 2] | 0) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) - (c[q >> 2] | 0);
	                        Ty(c[r >> 2] | 0, (c[t >> 2] | 0) - (c[q >> 2] | 0) | 0) | 0;
	                        c[t >> 2] = 0;
	                        c[l >> 2] = -1
	                    } else if ((z | 0) == 41 ? (z = d[(c[v >> 2] | 0) + 1 >> 0] | 0, t = d[(c[v >> 2] | 0) + 2 >> 0] | 0, q = d[(c[v >> 2] | 0) + 3 >> 0] | 0, c[g >> 2] = d[c[v >> 2] >> 0], c[g + 4 >> 2] = z, c[g + 8 >> 2] = t, c[g + 12 >> 2] = q, JT(y, 49, 63016, g) | 0, a[y + 49 >> 0] = 0, Id(6003, 63160, y), (Py(c[r >> 2] | 0) | 0) != 2) : 0)a[c[v >> 2] >> 0] = 32;
	                    c[h >> 2] = c[l >> 2];
	                    C = c[h >> 2] | 0;
	                    i = f;
	                    return C | 0
	                }
	                c[h >> 2] = -1;
	                C = c[h >> 2] | 0;
	                i = f;
	                return C | 0
	            }

	            function Hd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                c[j >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                a:do if (c[15642] | 0) {
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if ((c[h >> 2] | 0) >= (c[15688] | 0))break a;
	                        if ((c[e >> 2] | 0) == (c[(c[15642] | 0) + (c[h >> 2] << 2) >> 2] | 0))break;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    c[j >> 2] = 1
	                } while (0);
	                do if (!(c[j >> 2] | 0)) {
	                    if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)break;
	                    c[g >> 2] = 1;
	                    if (c[(c[e >> 2] | 0) + 16 >> 2] | 0) {
	                        if (YS(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0)c[f >> 2] = -1;
	                        c[(c[e >> 2] | 0) + 16 >> 2] = 0
	                    }
	                    if (c[(c[e >> 2] | 0) + 12 >> 2] | 0) {
	                        if (YS(c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0)c[f >> 2] = -1;
	                        c[(c[e >> 2] | 0) + 12 >> 2] = 0
	                    }
	                } while (0);
	                if (c[g >> 2] | 0) {
	                    if (c[c[e >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[e >> 2] >> 2] | 0);
	                    c[c[e >> 2] >> 2] = 0;
	                    zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                }
	                c[d >> 2] = c[f >> 2];
	                k = c[d >> 2] | 0;
	                i = b;
	                return k | 0
	            }

	            function Id(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                d = c[g >> 2] | 0;
	                g = c[j >> 2] | 0;
	                b = c[h >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(0, 0, 0, 0, 0, 27, d, 3, 0, 0, g, 0, 0, 0, 0, b, f);
	                i = e;
	                return
	            }

	            function Jd(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ce(27, 2, 0, 0, c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Kd(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if ((c[c[j >> 2] >> 2] | 0) > (c[c[l >> 2] >> 2] | 0))c[m >> 2] = c[c[l >> 2] >> 2]; else c[m >> 2] = c[c[j >> 2] >> 2];
	                if ((c[m >> 2] | 0) < 0) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    eU(c[h >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[c[j >> 2] >> 2] = c[m >> 2];
	                    c[c[l >> 2] >> 2] = c[m >> 2];
	                    c[g >> 2] = c[c[j >> 2] >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function Ld(b, f, g, h) {
	                b = b | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                j = i;
	                i = i + 64 | 0;
	                k = j + 56 | 0;
	                l = j + 52 | 0;
	                m = j + 48 | 0;
	                n = j + 44 | 0;
	                o = j + 40 | 0;
	                p = j + 36 | 0;
	                q = j + 32 | 0;
	                r = j + 28 | 0;
	                s = j + 24 | 0;
	                t = j + 20 | 0;
	                u = j + 16 | 0;
	                v = j + 12 | 0;
	                w = j + 8 | 0;
	                x = j + 4 | 0;
	                y = j;
	                c[l >> 2] = b;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = h;
	                c[p >> 2] = c[l >> 2];
	                c[q >> 2] = c[n >> 2];
	                c[r >> 2] = (c[l >> 2] | 0) + (c[c[m >> 2] >> 2] | 0);
	                c[s >> 2] = c[n >> 2];
	                if (((c[c[o >> 2] >> 2] | 0) % 2 | 0 | 0) == 1) {
	                    h = c[o >> 2] | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + -1
	                }
	                c[w >> 2] = (c[c[o >> 2] >> 2] | 0) / 2 | 0;
	                c[t >> 2] = (c[s >> 2] | 0) + (c[w >> 2] << 1);
	                while (1) {
	                    if ((c[s >> 2] | 0) >>> 0 >= (c[t >> 2] | 0) >>> 0) {
	                        z = 29;
	                        break
	                    }
	                    if (((c[l >> 2] | 0) - (c[p >> 2] | 0) + 5 | 0) >= (c[c[m >> 2] >> 2] | 0)) {
	                        z = 29;
	                        break
	                    }
	                    w = c[s >> 2] | 0;
	                    if (c[15644] | 0) {
	                        c[s >> 2] = w + 2;
	                        c[u >> 2] = e[w >> 1]
	                    } else {
	                        c[x >> 2] = w;
	                        w = c[x >> 2] | 0;
	                        c[x >> 2] = w + 1;
	                        c[u >> 2] = d[w >> 0];
	                        c[u >> 2] = c[u >> 2] | (d[c[x >> 2] >> 0] | 0) << 8;
	                        c[s >> 2] = (c[s >> 2] | 0) + 2
	                    }
	                    if ((c[u >> 2] & 64512 | 0) == 55296) {
	                        if ((c[s >> 2] | 0) >>> 0 >= (c[t >> 2] | 0) >>> 0) {
	                            z = 29;
	                            break
	                        }
	                        w = c[s >> 2] | 0;
	                        if (c[15644] | 0) {
	                            c[s >> 2] = w + 2;
	                            c[v >> 2] = e[w >> 1]
	                        } else {
	                            c[x >> 2] = w;
	                            w = c[x >> 2] | 0;
	                            c[x >> 2] = w + 1;
	                            c[v >> 2] = d[w >> 0];
	                            c[v >> 2] = c[v >> 2] | (d[c[x >> 2] >> 0] | 0) << 8;
	                            c[s >> 2] = (c[s >> 2] | 0) + 2
	                        }
	                        if ((c[v >> 2] & 64512 | 0) != 56320) {
	                            z = 16;
	                            break
	                        }
	                        c[u >> 2] = c[u >> 2] & 1023;
	                        c[u >> 2] = c[u >> 2] << 10;
	                        c[u >> 2] = c[u >> 2] | c[v >> 2] & 1023;
	                        c[u >> 2] = (c[u >> 2] | 0) + 65536
	                    }
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                        z = 29;
	                        break
	                    }
	                    w = c[u >> 2] | 0;
	                    do if ((c[u >> 2] | 0) >>> 0 >= 128) {
	                        h = c[u >> 2] | 0;
	                        if (w >>> 0 < 2048) {
	                            g = c[l >> 2] | 0;
	                            c[l >> 2] = g + 1;
	                            a[g >> 0] = h >>> 6 & 31 | 192;
	                            c[y >> 2] = 0;
	                            break
	                        }
	                        g = c[u >> 2] | 0;
	                        if (h >>> 0 < 65536) {
	                            h = c[l >> 2] | 0;
	                            c[l >> 2] = h + 1;
	                            a[h >> 0] = g >>> 12 & 15 | 224;
	                            c[y >> 2] = 6;
	                            break
	                        } else {
	                            h = c[l >> 2] | 0;
	                            c[l >> 2] = h + 1;
	                            a[h >> 0] = g >>> 18 & 7 | 240;
	                            c[y >> 2] = 12;
	                            break
	                        }
	                    } else {
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = w;
	                        c[y >> 2] = -6
	                    } while (0);
	                    while (1) {
	                        if ((c[y >> 2] | 0) < 0)break;
	                        if ((c[l >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0)break;
	                        w = ((c[u >> 2] | 0) >>> (c[y >> 2] | 0) & 63 | 128) & 255;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = w;
	                        c[y >> 2] = (c[y >> 2] | 0) - 6
	                    }
	                    c[q >> 2] = c[s >> 2]
	                }
	                if ((z | 0) == 16) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[q >> 2] | 0) - (c[n >> 2] | 0);
	                    c[k >> 2] = -2;
	                    A = c[k >> 2] | 0;
	                    i = j;
	                    return A | 0
	                } else if ((z | 0) == 29) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[q >> 2] | 0) - (c[n >> 2] | 0);
	                    c[k >> 2] = c[c[m >> 2] >> 2];
	                    A = c[k >> 2] | 0;
	                    i = j;
	                    return A | 0
	                }
	                return 0
	            }

	            function Md(f, g, h, j) {
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                k = i;
	                i = i + 64 | 0;
	                l = k + 56 | 0;
	                m = k + 52 | 0;
	                n = k + 48 | 0;
	                o = k + 44 | 0;
	                p = k + 40 | 0;
	                q = k + 36 | 0;
	                r = k + 32 | 0;
	                s = k + 28 | 0;
	                t = k + 24 | 0;
	                u = k + 20 | 0;
	                v = k + 16 | 0;
	                w = k + 12 | 0;
	                x = k + 8 | 0;
	                y = k + 4 | 0;
	                z = k;
	                A = k + 62 | 0;
	                B = k + 60 | 0;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = h;
	                c[p >> 2] = j;
	                c[q >> 2] = c[m >> 2];
	                c[r >> 2] = c[o >> 2];
	                c[s >> 2] = c[o >> 2];
	                c[t >> 2] = c[q >> 2];
	                if ((c[q >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                    c[l >> 2] = -1;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    c[c[n >> 2] >> 2] = 0;
	                    c[c[p >> 2] >> 2] = 0;
	                    c[l >> 2] = 0;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                }
	                c[v >> 2] = (c[o >> 2] | 0) + (c[c[p >> 2] >> 2] | 0);
	                c[u >> 2] = (c[q >> 2] | 0) + (((c[c[n >> 2] >> 2] | 0) / 2 | 0) << 1);
	                a:while (1) {
	                    if ((c[o >> 2] | 0) >>> 0 >= (c[v >> 2] | 0) >>> 0) {
	                        D = 34;
	                        break
	                    }
	                    m = c[o >> 2] | 0;
	                    c[o >> 2] = m + 1;
	                    c[x >> 2] = d[m >> 0];
	                    m = c[x >> 2] | 0;
	                    do if ((c[x >> 2] | 0) >>> 0 < 128) {
	                        c[w >> 2] = m;
	                        c[y >> 2] = 0
	                    } else {
	                        if (m >>> 0 < 192) {
	                            D = 10;
	                            break a
	                        }
	                        j = c[x >> 2] | 0;
	                        if ((c[x >> 2] | 0) >>> 0 < 224) {
	                            c[w >> 2] = j & 31;
	                            c[y >> 2] = 1;
	                            break
	                        }
	                        h = c[x >> 2] | 0;
	                        if (j >>> 0 < 240) {
	                            c[w >> 2] = h & 15;
	                            c[y >> 2] = 2;
	                            break
	                        }
	                        if (h >>> 0 >= 248) {
	                            D = 17;
	                            break a
	                        }
	                        c[w >> 2] = c[x >> 2] & 7;
	                        c[y >> 2] = 3
	                    } while (0);
	                    if (((c[v >> 2] | 0) - (c[o >> 2] | 0) | 0) < (c[y >> 2] | 0)) {
	                        D = 34;
	                        break
	                    }
	                    while (1) {
	                        if (!(c[y >> 2] | 0))break;
	                        if ((c[o >> 2] | 0) >>> 0 >= (c[v >> 2] | 0) >>> 0)break;
	                        m = c[o >> 2] | 0;
	                        c[o >> 2] = m + 1;
	                        h = d[m >> 0] | 0;
	                        c[x >> 2] = h;
	                        if ((h & 192 | 0) != 128)break;
	                        c[w >> 2] = c[w >> 2] << 6;
	                        c[w >> 2] = c[w >> 2] | c[x >> 2] & 63;
	                        c[y >> 2] = (c[y >> 2] | 0) + -1
	                    }
	                    do if ((c[w >> 2] | 0) >>> 0 < 65536) {
	                        if ((c[q >> 2] | 0) >>> 0 >= (c[u >> 2] | 0) >>> 0) {
	                            D = 34;
	                            break a
	                        }
	                        if (c[15644] | 0) {
	                            h = c[w >> 2] & 65535;
	                            m = c[q >> 2] | 0;
	                            c[q >> 2] = m + 2;
	                            b[m >> 1] = h;
	                            break
	                        } else {
	                            c[z >> 2] = c[q >> 2];
	                            a[c[z >> 2] >> 0] = c[w >> 2];
	                            a[(c[z >> 2] | 0) + 1 >> 0] = (c[w >> 2] | 0) >>> 8;
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            break
	                        }
	                    } else {
	                        if ((c[w >> 2] | 0) >>> 0 >= 1114112) {
	                            D = 34;
	                            break a
	                        }
	                        if (((c[q >> 2] | 0) + 2 | 0) >>> 0 >= (c[u >> 2] | 0) >>> 0) {
	                            D = 34;
	                            break a
	                        }
	                        c[w >> 2] = (c[w >> 2] | 0) - 65536;
	                        h = (55296 | (c[w >> 2] | 0) >>> 10) & 65535;
	                        if (c[15644] | 0) {
	                            m = c[q >> 2] | 0;
	                            c[q >> 2] = m + 2;
	                            b[m >> 1] = h;
	                            m = (56320 | c[w >> 2] & 1023) & 65535;
	                            j = c[q >> 2] | 0;
	                            c[q >> 2] = j + 2;
	                            b[j >> 1] = m;
	                            break
	                        } else {
	                            b[A >> 1] = h;
	                            c[z >> 2] = c[q >> 2];
	                            a[c[z >> 2] >> 0] = b[A >> 1];
	                            a[(c[z >> 2] | 0) + 1 >> 0] = (e[A >> 1] | 0) >> 8;
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            b[B >> 1] = 56320 | c[w >> 2] & 1023;
	                            c[z >> 2] = c[q >> 2];
	                            a[c[z >> 2] >> 0] = b[B >> 1];
	                            a[(c[z >> 2] | 0) + 1 >> 0] = (e[B >> 1] | 0) >> 8;
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            break
	                        }
	                    } while (0);
	                    c[r >> 2] = c[o >> 2]
	                }
	                if ((D | 0) == 10) {
	                    c[c[n >> 2] >> 2] = (((c[q >> 2] | 0) - (c[t >> 2] | 0) | 0) / 2 | 0) << 1;
	                    c[c[p >> 2] >> 2] = (c[r >> 2] | 0) - (c[s >> 2] | 0);
	                    c[l >> 2] = -2;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                } else if ((D | 0) == 17) {
	                    c[c[n >> 2] >> 2] = (((c[q >> 2] | 0) - (c[t >> 2] | 0) | 0) / 2 | 0) << 1;
	                    c[c[p >> 2] >> 2] = (c[r >> 2] | 0) - (c[s >> 2] | 0);
	                    c[l >> 2] = -2;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                } else if ((D | 0) == 34) {
	                    c[c[n >> 2] >> 2] = (((c[q >> 2] | 0) - (c[t >> 2] | 0) | 0) / 2 | 0) << 1;
	                    c[c[p >> 2] >> 2] = (c[r >> 2] | 0) - (c[s >> 2] | 0);
	                    c[l >> 2] = c[c[n >> 2] >> 2];
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                }
	                return 0
	            }

	            function Nd(b, f, g, h) {
	                b = b | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                j = i;
	                i = i + 64 | 0;
	                k = j + 56 | 0;
	                l = j + 52 | 0;
	                m = j + 48 | 0;
	                n = j + 44 | 0;
	                o = j + 40 | 0;
	                p = j + 36 | 0;
	                q = j + 32 | 0;
	                r = j + 28 | 0;
	                s = j + 24 | 0;
	                t = j + 20 | 0;
	                u = j + 16 | 0;
	                v = j + 12 | 0;
	                w = j + 8 | 0;
	                x = j + 4 | 0;
	                y = j;
	                c[l >> 2] = b;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = h;
	                c[p >> 2] = c[l >> 2];
	                c[q >> 2] = c[n >> 2];
	                c[r >> 2] = (c[l >> 2] | 0) + (c[c[m >> 2] >> 2] | 0);
	                c[s >> 2] = c[n >> 2];
	                if (((c[c[o >> 2] >> 2] | 0) % 2 | 0 | 0) == 1) {
	                    h = c[o >> 2] | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + -1
	                }
	                c[w >> 2] = (c[c[o >> 2] >> 2] | 0) / 2 | 0;
	                c[t >> 2] = (c[s >> 2] | 0) + (c[w >> 2] << 1);
	                while (1) {
	                    if ((c[s >> 2] | 0) >>> 0 >= (c[t >> 2] | 0) >>> 0) {
	                        z = 29;
	                        break
	                    }
	                    w = c[s >> 2] | 0;
	                    if (c[15644] | 0) {
	                        c[x >> 2] = w;
	                        h = c[x >> 2] | 0;
	                        c[x >> 2] = h + 1;
	                        c[u >> 2] = d[h >> 0];
	                        c[u >> 2] = c[u >> 2] << 8;
	                        c[u >> 2] = c[u >> 2] | (d[c[x >> 2] >> 0] | 0);
	                        c[s >> 2] = (c[s >> 2] | 0) + 2
	                    } else {
	                        c[s >> 2] = w + 2;
	                        c[u >> 2] = e[w >> 1]
	                    }
	                    if ((c[u >> 2] & 64512 | 0) == 55296) {
	                        if ((c[s >> 2] | 0) >>> 0 >= (c[t >> 2] | 0) >>> 0) {
	                            z = 10;
	                            break
	                        }
	                        w = c[s >> 2] | 0;
	                        if (c[15644] | 0) {
	                            c[x >> 2] = w;
	                            h = c[x >> 2] | 0;
	                            c[x >> 2] = h + 1;
	                            c[v >> 2] = d[h >> 0];
	                            c[v >> 2] = c[v >> 2] << 8;
	                            c[v >> 2] = c[v >> 2] | (d[c[x >> 2] >> 0] | 0);
	                            c[s >> 2] = (c[s >> 2] | 0) + 2
	                        } else {
	                            c[s >> 2] = w + 2;
	                            c[v >> 2] = e[w >> 1]
	                        }
	                        if ((c[v >> 2] & 64512 | 0) != 56320) {
	                            z = 16;
	                            break
	                        }
	                        c[u >> 2] = c[u >> 2] & 1023;
	                        c[u >> 2] = c[u >> 2] << 10;
	                        c[u >> 2] = c[u >> 2] | c[v >> 2] & 1023;
	                        c[u >> 2] = (c[u >> 2] | 0) + 65536
	                    }
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                        z = 29;
	                        break
	                    }
	                    w = c[u >> 2] | 0;
	                    do if ((c[u >> 2] | 0) >>> 0 >= 128) {
	                        h = c[u >> 2] | 0;
	                        if (w >>> 0 < 2048) {
	                            g = c[l >> 2] | 0;
	                            c[l >> 2] = g + 1;
	                            a[g >> 0] = h >>> 6 & 31 | 192;
	                            c[y >> 2] = 0;
	                            break
	                        }
	                        g = c[u >> 2] | 0;
	                        if (h >>> 0 < 65536) {
	                            h = c[l >> 2] | 0;
	                            c[l >> 2] = h + 1;
	                            a[h >> 0] = g >>> 12 & 15 | 224;
	                            c[y >> 2] = 6;
	                            break
	                        } else {
	                            h = c[l >> 2] | 0;
	                            c[l >> 2] = h + 1;
	                            a[h >> 0] = g >>> 18 & 7 | 240;
	                            c[y >> 2] = 12;
	                            break
	                        }
	                    } else {
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = w;
	                        c[y >> 2] = -6
	                    } while (0);
	                    while (1) {
	                        if ((c[y >> 2] | 0) < 0)break;
	                        if ((c[l >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0)break;
	                        w = ((c[u >> 2] | 0) >>> (c[y >> 2] | 0) & 63 | 128) & 255;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = w;
	                        c[y >> 2] = (c[y >> 2] | 0) - 6
	                    }
	                    c[q >> 2] = c[s >> 2]
	                }
	                if ((z | 0) == 10) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[q >> 2] | 0) - (c[n >> 2] | 0);
	                    c[k >> 2] = -2;
	                    A = c[k >> 2] | 0;
	                    i = j;
	                    return A | 0
	                } else if ((z | 0) == 16) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[q >> 2] | 0) - (c[n >> 2] | 0);
	                    c[k >> 2] = -2;
	                    A = c[k >> 2] | 0;
	                    i = j;
	                    return A | 0
	                } else if ((z | 0) == 29) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[q >> 2] | 0) - (c[n >> 2] | 0);
	                    c[k >> 2] = c[c[m >> 2] >> 2];
	                    A = c[k >> 2] | 0;
	                    i = j;
	                    return A | 0
	                }
	                return 0
	            }

	            function Od(f, g, h, j) {
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                k = i;
	                i = i + 64 | 0;
	                l = k + 56 | 0;
	                m = k + 52 | 0;
	                n = k + 48 | 0;
	                o = k + 44 | 0;
	                p = k + 40 | 0;
	                q = k + 36 | 0;
	                r = k + 32 | 0;
	                s = k + 28 | 0;
	                t = k + 24 | 0;
	                u = k + 20 | 0;
	                v = k + 16 | 0;
	                w = k + 12 | 0;
	                x = k + 8 | 0;
	                y = k + 4 | 0;
	                z = k;
	                A = k + 62 | 0;
	                B = k + 60 | 0;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = h;
	                c[p >> 2] = j;
	                c[q >> 2] = c[m >> 2];
	                c[r >> 2] = c[o >> 2];
	                c[s >> 2] = c[o >> 2];
	                c[t >> 2] = c[q >> 2];
	                if ((c[m >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                    c[l >> 2] = -1;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    c[c[n >> 2] >> 2] = 0;
	                    c[c[p >> 2] >> 2] = 0;
	                    c[l >> 2] = 0;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                }
	                c[v >> 2] = (c[o >> 2] | 0) + (c[c[p >> 2] >> 2] | 0);
	                c[u >> 2] = (c[q >> 2] | 0) + (((c[c[n >> 2] >> 2] | 0) / 2 | 0) << 1);
	                a:while (1) {
	                    if ((c[o >> 2] | 0) >>> 0 >= (c[v >> 2] | 0) >>> 0) {
	                        D = 34;
	                        break
	                    }
	                    m = c[o >> 2] | 0;
	                    c[o >> 2] = m + 1;
	                    c[x >> 2] = d[m >> 0];
	                    m = c[x >> 2] | 0;
	                    do if ((c[x >> 2] | 0) >>> 0 < 128) {
	                        c[w >> 2] = m;
	                        c[y >> 2] = 0
	                    } else {
	                        if (m >>> 0 < 192) {
	                            D = 10;
	                            break a
	                        }
	                        j = c[x >> 2] | 0;
	                        if ((c[x >> 2] | 0) >>> 0 < 224) {
	                            c[w >> 2] = j & 31;
	                            c[y >> 2] = 1;
	                            break
	                        }
	                        h = c[x >> 2] | 0;
	                        if (j >>> 0 < 240) {
	                            c[w >> 2] = h & 15;
	                            c[y >> 2] = 2;
	                            break
	                        }
	                        if (h >>> 0 >= 248) {
	                            D = 17;
	                            break a
	                        }
	                        c[w >> 2] = c[x >> 2] & 7;
	                        c[y >> 2] = 3
	                    } while (0);
	                    if (((c[v >> 2] | 0) - (c[o >> 2] | 0) | 0) < (c[y >> 2] | 0)) {
	                        D = 34;
	                        break
	                    }
	                    while (1) {
	                        if (!(c[y >> 2] | 0))break;
	                        if ((c[o >> 2] | 0) >>> 0 >= (c[v >> 2] | 0) >>> 0)break;
	                        m = c[o >> 2] | 0;
	                        c[o >> 2] = m + 1;
	                        h = d[m >> 0] | 0;
	                        c[x >> 2] = h;
	                        if ((h & 192 | 0) != 128)break;
	                        c[w >> 2] = c[w >> 2] << 6;
	                        c[w >> 2] = c[w >> 2] | c[x >> 2] & 63;
	                        c[y >> 2] = (c[y >> 2] | 0) + -1
	                    }
	                    do if ((c[w >> 2] | 0) >>> 0 < 65536) {
	                        if ((c[q >> 2] | 0) >>> 0 >= (c[u >> 2] | 0) >>> 0) {
	                            D = 34;
	                            break a
	                        }
	                        if (c[15644] | 0) {
	                            c[z >> 2] = c[q >> 2];
	                            a[c[z >> 2] >> 0] = (c[w >> 2] | 0) >>> 8;
	                            a[(c[z >> 2] | 0) + 1 >> 0] = c[w >> 2];
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            break
	                        } else {
	                            h = c[w >> 2] & 65535;
	                            m = c[q >> 2] | 0;
	                            c[q >> 2] = m + 2;
	                            b[m >> 1] = h;
	                            break
	                        }
	                    } else {
	                        if ((c[w >> 2] | 0) >>> 0 >= 1114112) {
	                            D = 34;
	                            break a
	                        }
	                        if (((c[q >> 2] | 0) + 2 | 0) >>> 0 >= (c[u >> 2] | 0) >>> 0) {
	                            D = 34;
	                            break a
	                        }
	                        c[w >> 2] = (c[w >> 2] | 0) - 65536;
	                        h = (55296 | (c[w >> 2] | 0) >>> 10) & 65535;
	                        if (c[15644] | 0) {
	                            b[A >> 1] = h;
	                            c[z >> 2] = c[q >> 2];
	                            a[c[z >> 2] >> 0] = (e[A >> 1] | 0) >> 8;
	                            a[(c[z >> 2] | 0) + 1 >> 0] = b[A >> 1];
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            b[B >> 1] = 56320 | c[w >> 2] & 1023;
	                            c[z >> 2] = c[q >> 2];
	                            a[c[z >> 2] >> 0] = (e[B >> 1] | 0) >> 8;
	                            a[(c[z >> 2] | 0) + 1 >> 0] = b[B >> 1];
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            break
	                        } else {
	                            m = c[q >> 2] | 0;
	                            c[q >> 2] = m + 2;
	                            b[m >> 1] = h;
	                            h = (56320 | c[w >> 2] & 1023) & 65535;
	                            m = c[q >> 2] | 0;
	                            c[q >> 2] = m + 2;
	                            b[m >> 1] = h;
	                            break
	                        }
	                    } while (0);
	                    c[r >> 2] = c[o >> 2]
	                }
	                if ((D | 0) == 10) {
	                    c[c[n >> 2] >> 2] = ((c[q >> 2] | 0) - (c[t >> 2] | 0) | 0) / 2 | 0;
	                    c[c[p >> 2] >> 2] = (c[r >> 2] | 0) - (c[s >> 2] | 0);
	                    c[l >> 2] = -2;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                } else if ((D | 0) == 17) {
	                    c[c[n >> 2] >> 2] = ((c[q >> 2] | 0) - (c[t >> 2] | 0) | 0) / 2 | 0;
	                    c[c[p >> 2] >> 2] = (c[r >> 2] | 0) - (c[s >> 2] | 0);
	                    c[l >> 2] = -2;
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                } else if ((D | 0) == 34) {
	                    c[c[n >> 2] >> 2] = (((c[q >> 2] | 0) - (c[t >> 2] | 0) | 0) / 2 | 0) << 1;
	                    c[c[p >> 2] >> 2] = (c[r >> 2] | 0) - (c[s >> 2] | 0);
	                    c[l >> 2] = c[c[n >> 2] >> 2];
	                    C = c[l >> 2] | 0;
	                    i = k;
	                    return C | 0
	                }
	                return 0
	            }

	            function Pd(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (c[l >> 2] | 0) {
	                    c[h >> 2] = Md(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    n = c[h >> 2] | 0;
	                    i = g;
	                    return n | 0
	                }
	                if ((c[c[k >> 2] >> 2] | 0) >= 2) {
	                    a[c[j >> 2] >> 0] = -1;
	                    a[(c[j >> 2] | 0) + 1 >> 0] = -2;
	                    c[c[k >> 2] >> 2] = 2;
	                    c[c[m >> 2] >> 2] = 0;
	                    c[h >> 2] = 2;
	                    n = c[h >> 2] | 0;
	                    i = g;
	                    return n | 0
	                } else {
	                    c[c[k >> 2] >> 2] = 0;
	                    c[c[m >> 2] >> 2] = 0;
	                    c[h >> 2] = 0;
	                    n = c[h >> 2] | 0;
	                    i = g;
	                    return n | 0
	                }
	                return 0
	            }

	            function Qd(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 40 | 0;
	                k = h + 36 | 0;
	                l = h + 32 | 0;
	                m = h + 28 | 0;
	                n = h + 24 | 0;
	                o = h + 20 | 0;
	                p = h + 16 | 0;
	                q = h + 12 | 0;
	                r = h + 8 | 0;
	                s = h + 4 | 0;
	                t = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = c[k >> 2];
	                c[p >> 2] = c[m >> 2];
	                c[q >> 2] = c[m >> 2];
	                c[r >> 2] = (c[k >> 2] | 0) + (c[c[l >> 2] >> 2] | 0);
	                c[s >> 2] = (c[m >> 2] | 0) + (c[c[n >> 2] >> 2] | 0);
	                while (1) {
	                    if ((c[m >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0) {
	                        u = 8;
	                        break
	                    }
	                    if (((c[k >> 2] | 0) - (c[o >> 2] | 0) + 5 | 0) >= (c[c[l >> 2] >> 2] | 0)) {
	                        u = 8;
	                        break
	                    }
	                    g = c[m >> 2] | 0;
	                    c[m >> 2] = g + 1;
	                    c[t >> 2] = d[g >> 0];
	                    if ((c[k >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                        u = 8;
	                        break
	                    }
	                    if ((c[t >> 2] | 0) >>> 0 >= 128) {
	                        u = 7;
	                        break
	                    }
	                    g = c[t >> 2] & 255;
	                    f = c[k >> 2] | 0;
	                    c[k >> 2] = f + 1;
	                    a[f >> 0] = g;
	                    c[q >> 2] = c[m >> 2]
	                }
	                if ((u | 0) == 7) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[o >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[q >> 2] | 0) - (c[p >> 2] | 0);
	                    c[j >> 2] = -1;
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                } else if ((u | 0) == 8) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[o >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[q >> 2] | 0) - (c[p >> 2] | 0);
	                    c[j >> 2] = c[c[l >> 2] >> 2];
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                return 0
	            }

	            function Rd(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                h = i;
	                i = i + 64 | 0;
	                j = h + 48 | 0;
	                k = h + 44 | 0;
	                l = h + 40 | 0;
	                m = h + 36 | 0;
	                n = h + 32 | 0;
	                o = h + 28 | 0;
	                p = h + 24 | 0;
	                q = h + 20 | 0;
	                r = h + 16 | 0;
	                s = h + 12 | 0;
	                t = h + 8 | 0;
	                u = h + 4 | 0;
	                v = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = c[m >> 2];
	                c[q >> 2] = c[k >> 2];
	                c[r >> 2] = c[m >> 2];
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                if (!(c[m >> 2] | 0)) {
	                    c[c[l >> 2] >> 2] = 0;
	                    c[c[n >> 2] >> 2] = 0;
	                    c[j >> 2] = 0;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                c[s >> 2] = (c[m >> 2] | 0) + (c[c[n >> 2] >> 2] | 0);
	                c[p >> 2] = (c[k >> 2] | 0) + (c[c[l >> 2] >> 2] | 0);
	                a:while (1) {
	                    if ((c[m >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0) {
	                        x = 27;
	                        break
	                    }
	                    g = c[m >> 2] | 0;
	                    c[m >> 2] = g + 1;
	                    c[u >> 2] = d[g >> 0];
	                    g = c[u >> 2] | 0;
	                    do if ((c[u >> 2] | 0) >>> 0 < 128) {
	                        c[t >> 2] = g;
	                        c[v >> 2] = 0
	                    } else {
	                        if (g >>> 0 < 192) {
	                            x = 10;
	                            break a
	                        }
	                        f = c[u >> 2] | 0;
	                        if ((c[u >> 2] | 0) >>> 0 < 224) {
	                            c[t >> 2] = f & 31;
	                            c[v >> 2] = 1;
	                            break
	                        }
	                        e = c[u >> 2] | 0;
	                        if (f >>> 0 < 240) {
	                            c[t >> 2] = e & 15;
	                            c[v >> 2] = 2;
	                            break
	                        }
	                        if (e >>> 0 >= 248) {
	                            x = 17;
	                            break a
	                        }
	                        c[t >> 2] = c[u >> 2] & 7;
	                        c[v >> 2] = 3
	                    } while (0);
	                    if (((c[s >> 2] | 0) - (c[m >> 2] | 0) | 0) < (c[v >> 2] | 0)) {
	                        x = 27;
	                        break
	                    }
	                    while (1) {
	                        if (!(c[v >> 2] | 0))break;
	                        if ((c[m >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0)break;
	                        g = c[m >> 2] | 0;
	                        c[m >> 2] = g + 1;
	                        e = d[g >> 0] | 0;
	                        c[u >> 2] = e;
	                        if ((e & 192 | 0) != 128)break;
	                        c[t >> 2] = c[t >> 2] << 6;
	                        c[t >> 2] = c[t >> 2] | c[u >> 2] & 63;
	                        c[v >> 2] = (c[v >> 2] | 0) + -1
	                    }
	                    y = c[k >> 2] | 0;
	                    if ((c[t >> 2] | 0) >>> 0 >= 128) {
	                        x = 26;
	                        break
	                    }
	                    if (y >>> 0 >= (c[p >> 2] | 0) >>> 0) {
	                        x = 27;
	                        break
	                    }
	                    e = c[t >> 2] & 255;
	                    g = c[k >> 2] | 0;
	                    c[k >> 2] = g + 1;
	                    a[g >> 0] = e;
	                    c[o >> 2] = c[m >> 2]
	                }
	                if ((x | 0) == 10) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 17) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 26) {
	                    c[c[l >> 2] >> 2] = y - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = -2;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                } else if ((x | 0) == 27) {
	                    c[c[l >> 2] >> 2] = (c[k >> 2] | 0) - (c[q >> 2] | 0);
	                    c[c[n >> 2] >> 2] = (c[o >> 2] | 0) - (c[r >> 2] | 0);
	                    c[j >> 2] = c[c[l >> 2] >> 2];
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                return 0
	            }

	            function Sd(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 40 | 0;
	                j = g + 36 | 0;
	                k = g + 32 | 0;
	                l = g + 28 | 0;
	                m = g + 24 | 0;
	                n = g + 20 | 0;
	                o = g + 16 | 0;
	                p = g + 12 | 0;
	                q = g + 8 | 0;
	                r = g + 4 | 0;
	                s = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[q >> 2] = c[m >> 2];
	                c[r >> 2] = c[k >> 2];
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                    c[h >> 2] = -1;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                c[o >> 2] = c[c[n >> 2] >> 2];
	                c[p >> 2] = c[c[l >> 2] >> 2];
	                c[s >> 2] = ZS(c[j >> 2] | 0, q, o, r, p) | 0;
	                r = c[n >> 2] | 0;
	                c[r >> 2] = (c[r >> 2] | 0) - (c[o >> 2] | 0);
	                r = c[l >> 2] | 0;
	                c[r >> 2] = (c[r >> 2] | 0) - (c[p >> 2] | 0);
	                if (!((c[o >> 2] | 0) != 0 | (c[s >> 2] | 0) == -1)) {
	                    c[h >> 2] = 0;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                if ((c[(_a() | 0) >> 2] | 0) == 84) {
	                    c[h >> 2] = -2;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                if ((c[(_a() | 0) >> 2] | 0) == 7) {
	                    c[h >> 2] = -1;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                } else {
	                    c[h >> 2] = -3;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                return 0
	            }

	            function Td(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e;
	                c[e + 20 >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[33980] | 0))c[33980] = c[o >> 2];
	                c[g >> 2] = d;
	                Ca(c[33980] | 0, c[f >> 2] | 0, g | 0) | 0;
	                i = e;
	                return
	            }

	            function Ud(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    c[33976] = 35;
	                    i = b;
	                    return
	                } else {
	                    c[33976] = c[c[d >> 2] >> 2];
	                    i = b;
	                    return
	                }
	            }

	            function Vd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 8 | 0;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                a = c[33976] | 0;
	                f = c[33980] | 0;
	                g = c[e >> 2] | 0;
	                if (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    h = c[(c[e >> 2] | 0) + 28 >> 2] | 0;
	                    c[d >> 2] = c[g + 4 >> 2];
	                    c[d + 4 >> 2] = h;
	                    Db[a & 511](f, 63216, d);
	                    i = b;
	                    return
	                } else {
	                    c[d >> 2] = c[g + 28 >> 2];
	                    Db[a & 511](f, 63224, d);
	                    i = b;
	                    return
	                }
	            }

	            function Wd(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                fe(c[d >> 2] | 0, c[33976] | 0, c[33980] | 0);
	                i = b;
	                return
	            }

	            function Xd(a, b, d, f, g, h, j, k, l, m, n, o, p, q, r, s, t) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                m = m | 0;
	                n = n | 0;
	                o = o | 0;
	                p = p | 0;
	                q = q | 0;
	                r = r | 0;
	                s = s | 0;
	                t = t | 0;
	                var u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0;
	                u = i;
	                i = i + 144 | 0;
	                v = u;
	                w = u + 132 | 0;
	                x = u + 128 | 0;
	                y = u + 124 | 0;
	                z = u + 120 | 0;
	                A = u + 116 | 0;
	                B = u + 112 | 0;
	                C = u + 108 | 0;
	                D = u + 104 | 0;
	                E = u + 100 | 0;
	                F = u + 96 | 0;
	                G = u + 92 | 0;
	                H = u + 88 | 0;
	                I = u + 84 | 0;
	                J = u + 80 | 0;
	                K = u + 76 | 0;
	                L = u + 72 | 0;
	                M = u + 68 | 0;
	                N = u + 64 | 0;
	                O = u + 60 | 0;
	                P = u + 56 | 0;
	                Q = u + 52 | 0;
	                R = u + 48 | 0;
	                S = u + 44 | 0;
	                T = u + 40 | 0;
	                U = u + 36 | 0;
	                V = u + 32 | 0;
	                W = u + 16 | 0;
	                X = u + 12 | 0;
	                Y = u + 8 | 0;
	                Z = u + 4 | 0;
	                c[w >> 2] = a;
	                c[x >> 2] = b;
	                c[y >> 2] = d;
	                c[z >> 2] = f;
	                c[A >> 2] = g;
	                c[B >> 2] = h;
	                c[C >> 2] = j;
	                c[D >> 2] = k;
	                c[E >> 2] = l;
	                c[F >> 2] = m;
	                c[G >> 2] = n;
	                c[H >> 2] = o;
	                c[I >> 2] = p;
	                c[J >> 2] = q;
	                c[K >> 2] = r;
	                c[L >> 2] = s;
	                c[M >> 2] = 0;
	                c[N >> 2] = c[A >> 2];
	                c[O >> 2] = 0;
	                c[P >> 2] = 0;
	                c[Q >> 2] = 136208;
	                c[R >> 2] = 0;
	                if (!(c[C >> 2] | 0)) {
	                    i = u;
	                    return
	                }
	                if ((c[33956] | 0) == 0 & (c[D >> 2] | 0) == 1) {
	                    i = u;
	                    return
	                }
	                if (((((c[B >> 2] | 0) == 1 | (c[B >> 2] | 0) == 5 | (c[B >> 2] | 0) == 4 | (c[B >> 2] | 0) == 3 | (c[B >> 2] | 0) == 8 | (c[B >> 2] | 0) == 23 ? (c[M >> 2] = c[z >> 2], (c[w >> 2] | 0) == 0 & (c[M >> 2] | 0) != 0) : 0) ? (c[c[M >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[M >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497 : 0) ? (c[(c[c[M >> 2] >> 2] | 0) + 124 >> 2] | 0) != 0 : 0) {
	                    c[w >> 2] = c[(c[c[M >> 2] >> 2] | 0) + 124 >> 2];
	                    c[y >> 2] = c[(c[M >> 2] | 0) + 4 >> 2]
	                }
	                if ((c[w >> 2] | 0) == 0 ? (c[w >> 2] = c[33978], (c[w >> 2] | 0) != 0) : 0)c[y >> 2] = c[33982];
	                a:do if (c[L >> 2] | 0) {
	                    c[T >> 2] = -1;
	                    c[O >> 2] = Cb[c[135744 >> 2] & 511](150) | 0;
	                    if (c[O >> 2] | 0) {
	                        c[S >> 2] = 150;
	                        while (1) {
	                            if ((c[S >> 2] | 0) >= 64e3)break a;
	                            c[W >> 2] = t;
	                            c[U >> 2] = LT(c[O >> 2] | 0, c[S >> 2] | 0, c[L >> 2] | 0, W) | 0;
	                            if ((c[U >> 2] | 0) > -1 ? (c[U >> 2] | 0) < (c[S >> 2] | 0) : 0) {
	                                if ((c[T >> 2] | 0) == (c[U >> 2] | 0))break a;
	                                c[T >> 2] = c[U >> 2]
	                            }
	                            if ((c[U >> 2] | 0) > -1)c[S >> 2] = (c[S >> 2] | 0) + ((c[U >> 2] | 0) + 1); else c[S >> 2] = (c[S >> 2] | 0) + 100;
	                            A = Hb[c[135760 >> 2] & 511](c[O >> 2] | 0, c[S >> 2] | 0) | 0;
	                            c[V >> 2] = A;
	                            if (!A)break a;
	                            c[O >> 2] = c[V >> 2]
	                        }
	                    }
	                } else c[O >> 2] = my(63248) | 0; while (0);
	                if (!(c[M >> 2] | 0)) {
	                    if ((c[N >> 2] | 0) != 0 & (c[E >> 2] | 0) == 0) {
	                        if ((c[(c[N >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[N >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) != 0 : 0)c[R >> 2] = c[N >> 2];
	                        c[X >> 2] = 0;
	                        while (1) {
	                            if (!((c[X >> 2] | 0) < 10 & (c[N >> 2] | 0) != 0))break;
	                            if ((c[(c[N >> 2] | 0) + 4 >> 2] | 0) == 1)break;
	                            c[N >> 2] = c[(c[N >> 2] | 0) + 20 >> 2];
	                            c[X >> 2] = (c[X >> 2] | 0) + 1
	                        }
	                        if (((c[R >> 2] | 0) == 0 & (c[N >> 2] | 0) != 0 ? (c[(c[N >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[(c[N >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) != 0 : 0)c[R >> 2] = c[N >> 2];
	                        if ((c[N >> 2] | 0) != 0 ? (c[(c[N >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)c[F >> 2] = e[(c[N >> 2] | 0) + 56 >> 1];
	                        if ((c[F >> 2] | 0) == 0 | (c[F >> 2] | 0) == 65535)c[F >> 2] = Ni(c[N >> 2] | 0) | 0
	                    }
	                } else {
	                    if (!(c[E >> 2] | 0)) {
	                        c[P >> 2] = c[(c[M >> 2] | 0) + 36 >> 2];
	                        if (((c[P >> 2] | 0) != 0 ? (c[(c[P >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[M >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[P >> 2] = c[(c[(c[M >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[M >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                        if (c[P >> 2] | 0) {
	                            c[E >> 2] = c[(c[P >> 2] | 0) + 4 >> 2];
	                            c[F >> 2] = c[(c[P >> 2] | 0) + 28 >> 2];
	                            c[K >> 2] = c[(c[P >> 2] | 0) + 32 >> 2]
	                        }
	                    }
	                    c[Q >> 2] = (c[M >> 2] | 0) + 384
	                }
	                Yd(c[Q >> 2] | 0);
	                c[c[Q >> 2] >> 2] = c[B >> 2];
	                c[(c[Q >> 2] | 0) + 4 >> 2] = c[C >> 2];
	                c[(c[Q >> 2] | 0) + 8 >> 2] = c[O >> 2];
	                c[(c[Q >> 2] | 0) + 12 >> 2] = c[D >> 2];
	                if (!(c[E >> 2] | 0)) {
	                    if (c[R >> 2] | 0) {
	                        c[Y >> 2] = c[R >> 2];
	                        c[Z >> 2] = 0;
	                        b:while (1) {
	                            if (!(c[Y >> 2] | 0))break;
	                            while (1) {
	                                _ = c[Y >> 2] | 0;
	                                if (!(c[(c[Y >> 2] | 0) + 28 >> 2] | 0)) {
	                                    $ = 58;
	                                    break
	                                }
	                                c[Y >> 2] = c[_ + 28 >> 2];
	                                if ((c[(c[Y >> 2] | 0) + 4 >> 2] | 0) != 19)break;
	                                C = (c[Z >> 2] | 0) + -1 | 0;
	                                c[Z >> 2] = C;
	                                if (!((C | 0) >= 0 & (c[Y >> 2] | 0) != 0))break b
	                            }
	                            if (($ | 0) == 58) {
	                                $ = 0;
	                                c[Y >> 2] = c[_ + 20 >> 2];
	                                continue
	                            }
	                            if ((c[(c[Y >> 2] | 0) + 4 >> 2] | 0) != 20)continue;
	                            c[Z >> 2] = (c[Z >> 2] | 0) + 1
	                        }
	                        do if (c[Y >> 2] | 0) {
	                            Z = c[Y >> 2] | 0;
	                            if ((c[(c[Y >> 2] | 0) + 4 >> 2] | 0) == 19) {
	                                c[Z + 4 >> 2] = 1;
	                                _ = Yi(c[Y >> 2] | 0, 63280) | 0;
	                                c[(c[Q >> 2] | 0) + 16 >> 2] = _;
	                                c[(c[Y >> 2] | 0) + 4 >> 2] = 19;
	                                break
	                            } else {
	                                _ = Yi(Z, 63280) | 0;
	                                c[(c[Q >> 2] | 0) + 16 >> 2] = _;
	                                break
	                            }
	                        } else {
	                            _ = my(c[(c[(c[R >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) | 0;
	                            c[(c[Q >> 2] | 0) + 16 >> 2] = _
	                        } while (0);
	                        if (((c[N >> 2] | 0) != 0 ? (c[(c[Q >> 2] | 0) + 16 >> 2] | 0) == 0 : 0) ? (c[(c[N >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                            R = my(c[(c[(c[N >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) | 0;
	                            c[(c[Q >> 2] | 0) + 16 >> 2] = R
	                        }
	                    }
	                } else {
	                    R = my(c[E >> 2] | 0) | 0;
	                    c[(c[Q >> 2] | 0) + 16 >> 2] = R
	                }
	                c[(c[Q >> 2] | 0) + 20 >> 2] = c[F >> 2];
	                if (c[G >> 2] | 0) {
	                    F = my(c[G >> 2] | 0) | 0;
	                    c[(c[Q >> 2] | 0) + 24 >> 2] = F
	                }
	                if (c[H >> 2] | 0) {
	                    F = my(c[H >> 2] | 0) | 0;
	                    c[(c[Q >> 2] | 0) + 28 >> 2] = F
	                }
	                if (c[I >> 2] | 0) {
	                    F = my(c[I >> 2] | 0) | 0;
	                    c[(c[Q >> 2] | 0) + 32 >> 2] = F
	                }
	                c[(c[Q >> 2] | 0) + 36 >> 2] = c[J >> 2];
	                c[(c[Q >> 2] | 0) + 40 >> 2] = c[K >> 2];
	                c[(c[Q >> 2] | 0) + 48 >> 2] = c[N >> 2];
	                c[(c[Q >> 2] | 0) + 44 >> 2] = c[z >> 2];
	                if ((c[Q >> 2] | 0) != 136208)Zd(c[Q >> 2] | 0, 136208) | 0;
	                if (c[w >> 2] | 0) {
	                    Ab[c[w >> 2] & 511](c[y >> 2] | 0, c[Q >> 2] | 0);
	                    i = u;
	                    return
	                }
	                if ((c[M >> 2] | 0) != 0 & (c[x >> 2] | 0) == 0 & (c[33978] | 0) == 0 ? (c[c[M >> 2] >> 2] | 0) != 0 : 0) {
	                    w = c[c[M >> 2] >> 2] | 0;
	                    if ((c[D >> 2] | 0) == 1)c[x >> 2] = c[w + 84 >> 2]; else c[x >> 2] = c[w + 88 >> 2];
	                    c[y >> 2] = c[(c[M >> 2] | 0) + 4 >> 2]
	                } else $ = 87;
	                do if (($ | 0) == 87 ? (c[x >> 2] | 0) == 0 : 0) {
	                    c[x >> 2] = c[33976];
	                    if (c[M >> 2] | 0) {
	                        c[y >> 2] = c[M >> 2];
	                        break
	                    } else {
	                        c[y >> 2] = c[33980];
	                        break
	                    }
	                } while (0);
	                if (!(c[x >> 2] | 0)) {
	                    i = u;
	                    return
	                }
	                if ((c[x >> 2] | 0) == 57 | (c[x >> 2] | 0) == 56 | (c[x >> 2] | 0) == 224 | (c[x >> 2] | 0) == 225) {
	                    ge(c[Q >> 2] | 0, c[M >> 2] | 0, c[O >> 2] | 0, 0, 0);
	                    i = u;
	                    return
	                }
	                if ((c[x >> 2] | 0) == 203 | (c[x >> 2] | 0) == 35) {
	                    ge(c[Q >> 2] | 0, c[M >> 2] | 0, c[O >> 2] | 0, c[x >> 2] | 0, c[y >> 2] | 0);
	                    i = u;
	                    return
	                } else {
	                    M = c[x >> 2] | 0;
	                    x = c[y >> 2] | 0;
	                    c[v >> 2] = c[O >> 2];
	                    Db[M & 511](x, 63288, v);
	                    i = u;
	                    return
	                }
	            }

	            function Yd(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 4 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                a = (c[d >> 2] | 0) + 0 | 0;
	                e = a + 52 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (e | 0));
	                c[(c[d >> 2] | 0) + 4 >> 2] = 0;
	                i = b;
	                return
	            }

	            function Zd(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[h >> 2] = my(c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                c[j >> 2] = my(c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0;
	                c[k >> 2] = my(c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                c[l >> 2] = my(c[(c[f >> 2] | 0) + 28 >> 2] | 0) | 0;
	                c[m >> 2] = my(c[(c[f >> 2] | 0) + 32 >> 2] | 0) | 0;
	                if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[g >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[g >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[g >> 2] | 0) + 32 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 32 >> 2] | 0);
	                c[c[g >> 2] >> 2] = c[c[f >> 2] >> 2];
	                c[(c[g >> 2] | 0) + 4 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                c[(c[g >> 2] | 0) + 12 >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                c[(c[g >> 2] | 0) + 48 >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                c[(c[g >> 2] | 0) + 36 >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                c[(c[g >> 2] | 0) + 40 >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                c[(c[g >> 2] | 0) + 48 >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                c[(c[g >> 2] | 0) + 44 >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                c[(c[g >> 2] | 0) + 24 >> 2] = c[k >> 2];
	                c[(c[g >> 2] | 0) + 28 >> 2] = c[l >> 2];
	                c[(c[g >> 2] | 0) + 32 >> 2] = c[m >> 2];
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function _d(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e;
	                g = e + 60 | 0;
	                h = e + 56 | 0;
	                j = e + 52 | 0;
	                k = e + 48 | 0;
	                l = e + 44 | 0;
	                m = e + 40 | 0;
	                n = e + 36 | 0;
	                o = e + 32 | 0;
	                p = e + 28 | 0;
	                q = e + 24 | 0;
	                r = e + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if (c[j >> 2] | 0) {
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 36 >> 2];
	                    if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) > 1 : 0) {
	                        c[l >> 2] = c[k >> 2];
	                        c[k >> 2] = c[(c[(c[j >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2]
	                    }
	                    Vd(c[k >> 2] | 0)
	                }
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 63360, f);
	                c[o >> 2] = -1;
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](150) | 0;
	                a:do if (c[m >> 2] | 0) {
	                    c[n >> 2] = 150;
	                    while (1) {
	                        if ((c[n >> 2] | 0) >= 64e3)break a;
	                        c[r >> 2] = d;
	                        c[p >> 2] = LT(c[m >> 2] | 0, c[n >> 2] | 0, c[h >> 2] | 0, r) | 0;
	                        if ((c[p >> 2] | 0) > -1 ? (c[p >> 2] | 0) < (c[n >> 2] | 0) : 0) {
	                            if ((c[o >> 2] | 0) == (c[p >> 2] | 0))break a;
	                            c[o >> 2] = c[p >> 2]
	                        }
	                        if ((c[p >> 2] | 0) > -1)c[n >> 2] = (c[n >> 2] | 0) + ((c[p >> 2] | 0) + 1); else c[n >> 2] = (c[n >> 2] | 0) + 100;
	                        g = Hb[c[135760 >> 2] & 511](c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[q >> 2] = g;
	                        if (!g)break a;
	                        c[m >> 2] = c[q >> 2]
	                    }
	                } while (0);
	                q = c[33976] | 0;
	                n = c[33980] | 0;
	                c[f >> 2] = c[m >> 2];
	                Db[q & 511](n, 63288, f);
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Wd(c[k >> 2] | 0);
	                if (!(c[l >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Vd(c[l >> 2] | 0);
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 63368, f);
	                Wd(c[l >> 2] | 0);
	                i = e;
	                return
	            }

	            function $d(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e;
	                g = e + 60 | 0;
	                h = e + 56 | 0;
	                j = e + 52 | 0;
	                k = e + 48 | 0;
	                l = e + 44 | 0;
	                m = e + 40 | 0;
	                n = e + 36 | 0;
	                o = e + 32 | 0;
	                p = e + 28 | 0;
	                q = e + 24 | 0;
	                r = e + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if (c[j >> 2] | 0) {
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 36 >> 2];
	                    if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) > 1 : 0) {
	                        c[l >> 2] = c[k >> 2];
	                        c[k >> 2] = c[(c[(c[j >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2]
	                    }
	                    Vd(c[k >> 2] | 0)
	                }
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 63376, f);
	                c[o >> 2] = -1;
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](150) | 0;
	                a:do if (c[m >> 2] | 0) {
	                    c[n >> 2] = 150;
	                    while (1) {
	                        if ((c[n >> 2] | 0) >= 64e3)break a;
	                        c[r >> 2] = d;
	                        c[p >> 2] = LT(c[m >> 2] | 0, c[n >> 2] | 0, c[h >> 2] | 0, r) | 0;
	                        if ((c[p >> 2] | 0) > -1 ? (c[p >> 2] | 0) < (c[n >> 2] | 0) : 0) {
	                            if ((c[o >> 2] | 0) == (c[p >> 2] | 0))break a;
	                            c[o >> 2] = c[p >> 2]
	                        }
	                        if ((c[p >> 2] | 0) > -1)c[n >> 2] = (c[n >> 2] | 0) + ((c[p >> 2] | 0) + 1); else c[n >> 2] = (c[n >> 2] | 0) + 100;
	                        g = Hb[c[135760 >> 2] & 511](c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[q >> 2] = g;
	                        if (!g)break a;
	                        c[m >> 2] = c[q >> 2]
	                    }
	                } while (0);
	                q = c[33976] | 0;
	                n = c[33980] | 0;
	                c[f >> 2] = c[m >> 2];
	                Db[q & 511](n, 63288, f);
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Wd(c[k >> 2] | 0);
	                if (!(c[l >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Vd(c[l >> 2] | 0);
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 63368, f);
	                Wd(c[l >> 2] | 0);
	                i = e;
	                return
	            }

	            function ae(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f;
	                h = f + 60 | 0;
	                j = f + 56 | 0;
	                k = f + 52 | 0;
	                l = f + 48 | 0;
	                m = f + 44 | 0;
	                n = f + 40 | 0;
	                o = f + 36 | 0;
	                p = f + 32 | 0;
	                q = f + 28 | 0;
	                r = f + 24 | 0;
	                s = f + 8 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                c[l >> 2] = 0;
	                c[n >> 2] = xy(c[j >> 2] | 0) | 0;
	                if ((c[n >> 2] | 0) > 1 ? (a[(c[j >> 2] | 0) + ((c[n >> 2] | 0) - 2) >> 0] | 0) != 58 : 0) {
	                    if (c[k >> 2] | 0) {
	                        c[l >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                        if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[l >> 2] = c[(c[(c[k >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                        if (!(c[15848] | 0))Vd(c[l >> 2] | 0)
	                    }
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 63400, g);
	                    c[15848] = 0
	                } else c[15848] = 1;
	                c[p >> 2] = -1;
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](150) | 0;
	                a:do if (c[m >> 2] | 0) {
	                    c[o >> 2] = 150;
	                    while (1) {
	                        if ((c[o >> 2] | 0) >= 64e3)break a;
	                        c[s >> 2] = e;
	                        c[q >> 2] = LT(c[m >> 2] | 0, c[o >> 2] | 0, c[j >> 2] | 0, s) | 0;
	                        if ((c[q >> 2] | 0) > -1 ? (c[q >> 2] | 0) < (c[o >> 2] | 0) : 0) {
	                            if ((c[p >> 2] | 0) == (c[q >> 2] | 0))break a;
	                            c[p >> 2] = c[q >> 2]
	                        }
	                        if ((c[q >> 2] | 0) > -1)c[o >> 2] = (c[o >> 2] | 0) + ((c[q >> 2] | 0) + 1); else c[o >> 2] = (c[o >> 2] | 0) + 100;
	                        n = Hb[c[135760 >> 2] & 511](c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                        c[r >> 2] = n;
	                        if (!n)break a;
	                        c[m >> 2] = c[r >> 2]
	                    }
	                } while (0);
	                r = c[33976] | 0;
	                o = c[33980] | 0;
	                c[g >> 2] = c[m >> 2];
	                Db[r & 511](o, 63288, g);
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                if (!((c[k >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0)) {
	                    i = f;
	                    return
	                }
	                Wd(c[l >> 2] | 0);
	                i = f;
	                return
	            }

	            function be(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f;
	                h = f + 60 | 0;
	                j = f + 56 | 0;
	                k = f + 52 | 0;
	                l = f + 48 | 0;
	                m = f + 44 | 0;
	                n = f + 40 | 0;
	                o = f + 36 | 0;
	                p = f + 32 | 0;
	                q = f + 28 | 0;
	                r = f + 24 | 0;
	                s = f + 8 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                c[l >> 2] = 0;
	                c[n >> 2] = xy(c[j >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) != 0 & (c[n >> 2] | 0) != 0 ? (a[(c[j >> 2] | 0) + ((c[n >> 2] | 0) - 1) >> 0] | 0) != 58 : 0) {
	                    c[l >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                    if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)c[l >> 2] = c[(c[(c[k >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2];
	                    Vd(c[l >> 2] | 0)
	                }
	                Db[c[135904 >> 2] & 511](c[33980] | 0, 63424, g);
	                c[p >> 2] = -1;
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](150) | 0;
	                a:do if (c[m >> 2] | 0) {
	                    c[o >> 2] = 150;
	                    while (1) {
	                        if ((c[o >> 2] | 0) >= 64e3)break a;
	                        c[s >> 2] = e;
	                        c[q >> 2] = LT(c[m >> 2] | 0, c[o >> 2] | 0, c[j >> 2] | 0, s) | 0;
	                        if ((c[q >> 2] | 0) > -1 ? (c[q >> 2] | 0) < (c[o >> 2] | 0) : 0) {
	                            if ((c[p >> 2] | 0) == (c[q >> 2] | 0))break a;
	                            c[p >> 2] = c[q >> 2]
	                        }
	                        if ((c[q >> 2] | 0) > -1)c[o >> 2] = (c[o >> 2] | 0) + ((c[q >> 2] | 0) + 1); else c[o >> 2] = (c[o >> 2] | 0) + 100;
	                        n = Hb[c[135760 >> 2] & 511](c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                        c[r >> 2] = n;
	                        if (!n)break a;
	                        c[m >> 2] = c[r >> 2]
	                    }
	                } while (0);
	                r = c[33976] | 0;
	                o = c[33980] | 0;
	                c[g >> 2] = c[m >> 2];
	                Db[r & 511](o, 63288, g);
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                if (!(c[k >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Wd(c[l >> 2] | 0);
	                i = f;
	                return
	            }

	            function ce(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if ((c[k >> 2] | 0) != 2) {
	                    f = c[l >> 2] | 0;
	                    e = c[j >> 2] | 0;
	                    d = c[k >> 2] | 0;
	                    k = c[n >> 2] | 0;
	                    b = c[m >> 2] | 0;
	                    c[h >> 2] = c[n >> 2];
	                    Xd(0, 0, 0, 0, f, e, d, 2, 0, 0, k, 0, 0, 0, 0, b, h);
	                    i = g;
	                    return
	                }
	                b = c[l >> 2] | 0;
	                l = c[j >> 2] | 0;
	                if (c[n >> 2] | 0) {
	                    j = c[n >> 2] | 0;
	                    c[h >> 2] = c[n >> 2];
	                    Xd(0, 0, 0, 0, b, l, 2, 3, 0, 0, j, 0, 0, 0, 0, 63296, h);
	                    i = g;
	                    return
	                } else {
	                    Xd(0, 0, 0, 0, b, l, 2, 3, 0, 0, 0, 0, 0, 0, 0, 63328, h);
	                    i = g;
	                    return
	                }
	            }

	            function de() {
	                var a = 0, b = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                if (!(c[34053] | 0))c[b >> 2] = 0; else c[b >> 2] = 136208;
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function ee() {
	                var a = 0;
	                a = i;
	                if (c[34053] | 0)Yd(136208);
	                i = a;
	                return
	            }

	            function fe(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 128 | 0;
	                h = g;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 36 | 0;
	                r = g + 4 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                if (!(c[j >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[m >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                c[n >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if ((c[m >> 2] | 0) >>> 0 <= (c[n >> 2] | 0) >>> 0)break;
	                    if ((d[c[m >> 2] >> 0] | 0 | 0) != 10 ? (d[c[m >> 2] >> 0] | 0 | 0) != 13 : 0)break;
	                    c[m >> 2] = (c[m >> 2] | 0) + -1
	                }
	                c[o >> 2] = 0;
	                while (1) {
	                    f = c[o >> 2] | 0;
	                    c[o >> 2] = f + 1;
	                    if ((f >>> 0 < 80 ? (c[m >> 2] | 0) >>> 0 > (c[n >> 2] | 0) >>> 0 : 0) ? (d[c[m >> 2] >> 0] | 0 | 0) != 10 : 0)s = (d[c[m >> 2] >> 0] | 0 | 0) != 13; else s = 0;
	                    t = c[m >> 2] | 0;
	                    if (!s)break;
	                    c[m >> 2] = t + -1
	                }
	                if (!((d[t >> 0] | 0 | 0) != 10 ? (d[c[m >> 2] >> 0] | 0 | 0) != 13 : 0))c[m >> 2] = (c[m >> 2] | 0) + 1;
	                c[p >> 2] = (c[(c[j >> 2] | 0) + 16 >> 2] | 0) - (c[m >> 2] | 0);
	                c[o >> 2] = 0;
	                c[r >> 2] = q;
	                while (1) {
	                    if (!(d[c[m >> 2] >> 0] | 0))break;
	                    if ((d[c[m >> 2] >> 0] | 0 | 0) == 10)break;
	                    if (!((c[o >> 2] | 0) >>> 0 < 80 ? (d[c[m >> 2] >> 0] | 0 | 0) != 13 : 0))break;
	                    j = c[m >> 2] | 0;
	                    c[m >> 2] = j + 1;
	                    t = a[j >> 0] | 0;
	                    j = c[r >> 2] | 0;
	                    c[r >> 2] = j + 1;
	                    a[j >> 0] = t;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                a[c[r >> 2] >> 0] = 0;
	                m = c[k >> 2] | 0;
	                t = c[l >> 2] | 0;
	                c[h >> 2] = q;
	                Db[m & 511](t, 63808, h);
	                c[o >> 2] = 0;
	                c[r >> 2] = q;
	                while (1) {
	                    if ((c[o >> 2] | 0) >>> 0 < (c[p >> 2] | 0) >>> 0 ? (t = c[o >> 2] | 0, c[o >> 2] = t + 1, t >>> 0 < 79) : 0)u = (d[c[r >> 2] >> 0] | 0 | 0) != 0; else u = 0;
	                    v = c[r >> 2] | 0;
	                    if (!u)break;
	                    if ((d[v >> 0] | 0 | 0) != 9)a[c[r >> 2] >> 0] = 32;
	                    c[r >> 2] = (c[r >> 2] | 0) + 1
	                }
	                c[r >> 2] = v + 1;
	                a[v >> 0] = 94;
	                a[c[r >> 2] >> 0] = 0;
	                r = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                c[h >> 2] = q;
	                Db[r & 511](k, 63808, h);
	                i = g;
	                return
	            }

	            function ge(b, d, e, f, g) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                h = i;
	                i = i + 224 | 0;
	                j = h;
	                k = h + 68 | 0;
	                l = h + 64 | 0;
	                m = h + 60 | 0;
	                n = h + 56 | 0;
	                o = h + 52 | 0;
	                p = h + 48 | 0;
	                q = h + 44 | 0;
	                r = h + 40 | 0;
	                s = h + 36 | 0;
	                t = h + 32 | 0;
	                u = h + 28 | 0;
	                v = h + 24 | 0;
	                w = h + 20 | 0;
	                x = h + 16 | 0;
	                y = h + 12 | 0;
	                z = h + 72 | 0;
	                A = h + 8 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = -1;
	                c[t >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if (!(c[n >> 2] | 0)) {
	                    c[n >> 2] = c[33976];
	                    c[o >> 2] = c[33980]
	                }
	                c[p >> 2] = c[(c[k >> 2] | 0) + 16 >> 2];
	                c[q >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                c[r >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                c[s >> 2] = c[c[k >> 2] >> 2];
	                c[v >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                c[u >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                if (!(c[r >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if ((c[u >> 2] | 0) != 0 ? (c[(c[u >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)c[t >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                do if (c[l >> 2] | 0) {
	                    c[w >> 2] = c[(c[l >> 2] | 0) + 36 >> 2];
	                    if (((c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[l >> 2] | 0) + 40 >> 2] | 0) > 1 : 0) {
	                        c[x >> 2] = c[w >> 2];
	                        c[w >> 2] = c[(c[(c[l >> 2] | 0) + 48 >> 2] | 0) + ((c[(c[l >> 2] | 0) + 40 >> 2] | 0) - 2 << 2) >> 2]
	                    }
	                    if (c[w >> 2] | 0) {
	                        if (c[(c[w >> 2] | 0) + 4 >> 2] | 0) {
	                            u = c[n >> 2] | 0;
	                            r = c[o >> 2] | 0;
	                            g = c[(c[w >> 2] | 0) + 28 >> 2] | 0;
	                            c[j >> 2] = c[(c[w >> 2] | 0) + 4 >> 2];
	                            c[j + 4 >> 2] = g;
	                            Db[u & 511](r, 63216, j);
	                            break
	                        }
	                        if ((c[q >> 2] | 0) != 0 & (c[s >> 2] | 0) == 1) {
	                            r = c[n >> 2] | 0;
	                            u = c[o >> 2] | 0;
	                            c[j >> 2] = c[(c[w >> 2] | 0) + 28 >> 2];
	                            Db[r & 511](u, 63224, j)
	                        }
	                    }
	                } else {
	                    if (c[p >> 2] | 0) {
	                        u = c[n >> 2] | 0;
	                        r = c[o >> 2] | 0;
	                        g = c[q >> 2] | 0;
	                        c[j >> 2] = c[p >> 2];
	                        c[j + 4 >> 2] = g;
	                        Db[u & 511](r, 63216, j);
	                        break
	                    }
	                    if ((c[q >> 2] | 0) != 0 ? (c[s >> 2] | 0) == 1 | (c[s >> 2] | 0) == 17 | (c[s >> 2] | 0) == 16 | (c[s >> 2] | 0) == 4 | (c[s >> 2] | 0) == 18 | (c[s >> 2] | 0) == 19 : 0) {
	                        r = c[n >> 2] | 0;
	                        u = c[o >> 2] | 0;
	                        c[j >> 2] = c[q >> 2];
	                        Db[r & 511](u, 63224, j)
	                    }
	                } while (0);
	                if (c[t >> 2] | 0) {
	                    p = c[n >> 2] | 0;
	                    u = c[o >> 2] | 0;
	                    c[j >> 2] = c[t >> 2];
	                    Db[p & 511](u, 63448, j)
	                }
	                do switch (c[s >> 2] | 0) {
	                    case 29:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63736, j);
	                        break
	                    }
	                    case 30:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63760, j);
	                        break
	                    }
	                    case 20:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63672, j);
	                        break
	                    }
	                    case 5:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63504, j);
	                        break
	                    }
	                    case 1:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63464, j);
	                        break
	                    }
	                    case 13:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63464, j);
	                        break
	                    }
	                    case 18:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63624, j);
	                        break
	                    }
	                    case 19:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63648, j);
	                        break
	                    }
	                    case 14:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63568, j);
	                        break
	                    }
	                    case 26:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63576, j);
	                        break
	                    }
	                    case 23:
	                    case 4:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63488, j);
	                        break
	                    }
	                    case 3:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63472, j);
	                        break
	                    }
	                    case 17:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63584, j);
	                        break
	                    }
	                    case 16:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63608, j);
	                        break
	                    }
	                    case 21:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63688, j);
	                        break
	                    }
	                    case 22:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63696, j);
	                        break
	                    }
	                    case 27:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63704, j);
	                        break
	                    }
	                    case 28:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63720, j);
	                        break
	                    }
	                    case 6:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63520, j);
	                        break
	                    }
	                    case 7:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63528, j);
	                        break
	                    }
	                    case 8:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63536, j);
	                        break
	                    }
	                    case 11:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63544, j);
	                        break
	                    }
	                    case 12:
	                    {
	                        Db[c[n >> 2] & 511](c[o >> 2] | 0, 63560, j);
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                u = c[v >> 2] | 0;
	                if ((u | 0) == 1)Db[c[n >> 2] & 511](c[o >> 2] | 0, 63776, j); else if ((u | 0) == 2)Db[c[n >> 2] & 511](c[o >> 2] | 0, 63792, j); else if ((u | 0) == 3)Db[c[n >> 2] & 511](c[o >> 2] | 0, 63792, j); else if (!u)Db[c[n >> 2] & 511](c[o >> 2] | 0, 63768, j);
	                do if (c[m >> 2] | 0) {
	                    c[y >> 2] = xy(c[m >> 2] | 0) | 0;
	                    if ((c[y >> 2] | 0) > 0 ? (a[(c[m >> 2] | 0) + ((c[y >> 2] | 0) - 1) >> 0] | 0) != 10 : 0) {
	                        u = c[n >> 2] | 0;
	                        v = c[o >> 2] | 0;
	                        c[j >> 2] = c[m >> 2];
	                        Db[u & 511](v, 63808, j);
	                        break
	                    }
	                    v = c[n >> 2] | 0;
	                    u = c[o >> 2] | 0;
	                    c[j >> 2] = c[m >> 2];
	                    Db[v & 511](u, 63288, j)
	                } else {
	                    u = c[n >> 2] | 0;
	                    v = c[o >> 2] | 0;
	                    c[j >> 2] = 63816;
	                    Db[u & 511](v, 63808, j)
	                } while (0);
	                if ((c[l >> 2] | 0) != 0 ? (fe(c[w >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0), (c[x >> 2] | 0) != 0) : 0) {
	                    if (!(c[(c[x >> 2] | 0) + 4 >> 2] | 0)) {
	                        if ((c[q >> 2] | 0) != 0 & (c[s >> 2] | 0) == 1) {
	                            q = c[n >> 2] | 0;
	                            w = c[o >> 2] | 0;
	                            c[j >> 2] = c[(c[x >> 2] | 0) + 28 >> 2];
	                            Db[q & 511](w, 63856, j)
	                        }
	                    } else {
	                        w = c[n >> 2] | 0;
	                        q = c[o >> 2] | 0;
	                        l = c[(c[x >> 2] | 0) + 28 >> 2] | 0;
	                        c[j >> 2] = c[(c[x >> 2] | 0) + 4 >> 2];
	                        c[j + 4 >> 2] = l;
	                        Db[w & 511](q, 63840, j)
	                    }
	                    fe(c[x >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0)
	                }
	                if ((c[s >> 2] | 0) != 12) {
	                    i = h;
	                    return
	                }
	                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if ((c[(c[k >> 2] | 0) + 36 >> 2] | 0) >= 100) {
	                    i = h;
	                    return
	                }
	                s = c[(c[k >> 2] | 0) + 36 >> 2] | 0;
	                if ((s | 0) >= (xy(c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0)) {
	                    i = h;
	                    return
	                }
	                s = c[n >> 2] | 0;
	                x = c[o >> 2] | 0;
	                c[j >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                Db[s & 511](x, 63808, j);
	                c[A >> 2] = 0;
	                while (1) {
	                    B = c[A >> 2] | 0;
	                    if ((c[A >> 2] | 0) >= (c[(c[k >> 2] | 0) + 36 >> 2] | 0))break;
	                    a[z + B >> 0] = 32;
	                    c[A >> 2] = (c[A >> 2] | 0) + 1
	                }
	                c[A >> 2] = B + 1;
	                a[z + B >> 0] = 94;
	                a[z + (c[A >> 2] | 0) >> 0] = 0;
	                A = c[n >> 2] | 0;
	                n = c[o >> 2] | 0;
	                c[j >> 2] = z;
	                Db[A & 511](n, 63808, j);
	                i = h;
	                return
	            }

	            function he(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                c[e >> 2] = a;
	                c[f >> 2] = 20902;
	                Rf();
	                if (((c[f >> 2] | 0) / 1e4 | 0 | 0) != ((c[e >> 2] | 0) / 1e4 | 0 | 0)) {
	                    a = c[33976] | 0;
	                    g = c[33980] | 0;
	                    h = (c[f >> 2] | 0) / 1e4 | 0;
	                    c[d >> 2] = (c[e >> 2] | 0) / 1e4 | 0;
	                    c[d + 4 >> 2] = h;
	                    Db[a & 511](g, 63880, d);
	                    g = c[o >> 2] | 0;
	                    a = (c[f >> 2] | 0) / 1e4 | 0;
	                    c[d >> 2] = (c[e >> 2] | 0) / 1e4 | 0;
	                    c[d + 4 >> 2] = a;
	                    Ka(g | 0, 63880, d | 0) | 0
	                }
	                if (((c[f >> 2] | 0) / 100 | 0 | 0) >= ((c[e >> 2] | 0) / 100 | 0 | 0)) {
	                    i = b;
	                    return
	                }
	                g = c[33976] | 0;
	                a = c[33980] | 0;
	                h = (c[f >> 2] | 0) / 100 | 0;
	                c[d >> 2] = (c[e >> 2] | 0) / 100 | 0;
	                c[d + 4 >> 2] = h;
	                Db[g & 511](a, 63944, d);
	                i = b;
	                return
	            }

	            function ie(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = d;
	                    return
	                }
	                if (c[f >> 2] | 0) {
	                    c[(c[f >> 2] | 0) + 84 >> 2] = 2;
	                    c[(c[f >> 2] | 0) + 172 >> 2] = -1;
	                    c[(c[f >> 2] | 0) + 212 >> 2] = 1
	                }
	                b = c[f >> 2] | 0;
	                if (c[g >> 2] | 0) {
	                    f = c[g >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Xd(0, 0, 0, b, 0, 1, 2, 3, 0, 0, f, 0, 0, 0, 0, 64008, e);
	                    i = d;
	                    return
	                } else {
	                    Xd(0, 0, 0, b, 0, 1, 2, 3, 0, 0, 0, 0, 0, 0, 0, 64040, e);
	                    i = d;
	                    return
	                }
	            }

	            function je(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                f = c[j >> 2] | 0;
	                e = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                d = c[n >> 2] | 0;
	                b = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(0, 0, 0, f, 0, 1, e, 3, 0, 0, k, d, 0, 0, 0, b, h);
	                if (!(c[j >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[(c[j >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[j >> 2] | 0) + 288 >> 2] | 0) {
	                    i = g;
	                    return
	                }
	                c[(c[j >> 2] | 0) + 212 >> 2] = 1;
	                i = g;
	                return
	            }

	            function ke(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) < 0) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[(c[c[f >> 2] >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = (c[(c[f >> 2] | 0) + 16 >> 2] | 0) - (c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                b = _y(c[(c[c[f >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                if (b >>> 0 > ((c[j >> 2] | 0) + 250 | 0) >>> 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[(c[c[f >> 2] >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = Mk(c[c[f >> 2] >> 2] | 0, c[g >> 2] | 0) | 0;
	                c[k >> 2] = Vy(c[(c[c[f >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) != (c[k >> 2] | 0)) {
	                    c[j >> 2] = (c[(c[f >> 2] | 0) + 16 >> 2] | 0) - (c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 12 >> 2] = c[k >> 2];
	                    c[(c[f >> 2] | 0) + 16 >> 2] = (c[k >> 2] | 0) + (c[j >> 2] | 0)
	                }
	                j = Wy(c[(c[c[f >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 20 >> 2] = j;
	                c[e >> 2] = c[h >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function le(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[c[d >> 2] >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 16 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                a = c[(c[d >> 2] | 0) + 16 >> 2] | 0;
	                c[e >> 2] = a - (Vy(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0);
	                if ((c[e >> 2] | 0) >>> 0 > 250) {
	                    c[f >> 2] = Ty(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0, (c[e >> 2] | 0) - 80 | 0) | 0;
	                    if ((c[f >> 2] | 0) >>> 0 > 0) {
	                        e = (c[d >> 2] | 0) + 16 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + (0 - (c[f >> 2] | 0));
	                        e = (c[d >> 2] | 0) + 36 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + (c[f >> 2] | 0)
	                    }
	                    f = Wy(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    c[(c[d >> 2] | 0) + 20 >> 2] = f
	                }
	                if ((_y(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 > 250) {
	                    i = b;
	                    return
	                }
	                Nk(c[c[d >> 2] >> 2] | 0, 500) | 0;
	                c[h >> 2] = Vy(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) != (c[h >> 2] | 0)) {
	                    c[g >> 2] = (c[(c[d >> 2] | 0) + 16 >> 2] | 0) - (c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                    c[(c[d >> 2] | 0) + 16 >> 2] = (c[h >> 2] | 0) + (c[g >> 2] | 0)
	                }
	                g = Wy(c[(c[c[d >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                c[(c[d >> 2] | 0) + 20 >> 2] = g;
	                i = b;
	                return
	            }

	            function me(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 192 | 0;
	                f = e;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 178 | 0;
	                k = e + 16 | 0;
	                l = e + 28 | 0;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                b = d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                do if ((c[(c[g >> 2] | 0) + 256 >> 2] | 0) == 1) {
	                    if (((b | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != 5 : 0) {
	                        Ve(c[g >> 2] | 0) | 0;
	                        break
	                    }
	                    m = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        n = m + 28 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        n = m + 32 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    c[h >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    a[j >> 0] = a[c[h >> 2] >> 0] | 0;
	                    a:do if ((d[j >> 0] | 0) & 128) {
	                        do if ((d[j >> 0] | 0 | 0) != 192) {
	                            if (!(d[(c[h >> 2] | 0) + 1 >> 0] | 0)) {
	                                ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                                c[h >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                            }
	                            if (((d[(c[h >> 2] | 0) + 1 >> 0] | 0) & 192 | 0) == 128) {
	                                if (((d[j >> 0] | 0) & 224 | 0) != 224) {
	                                    n = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                    c[n >> 2] = (c[n >> 2] | 0) + 2;
	                                    break a
	                                }
	                                if (!(d[(c[h >> 2] | 0) + 2 >> 0] | 0)) {
	                                    ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                                    c[h >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                                }
	                                if (((d[(c[h >> 2] | 0) + 2 >> 0] | 0) & 192 | 0) == 128) {
	                                    if (((d[j >> 0] | 0) & 240 | 0) == 240) {
	                                        if (!(d[(c[h >> 2] | 0) + 3 >> 0] | 0)) {
	                                            ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                                            c[h >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                                        }
	                                        if (((d[j >> 0] | 0) & 248 | 0) != 240)break;
	                                        if (((d[(c[h >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128)break;
	                                        n = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                        c[n >> 2] = (c[n >> 2] | 0) + 4;
	                                        c[k >> 2] = ((d[c[h >> 2] >> 0] | 0) & 7) << 18;
	                                        c[k >> 2] = c[k >> 2] | ((d[(c[h >> 2] | 0) + 1 >> 0] | 0) & 63) << 12;
	                                        c[k >> 2] = c[k >> 2] | ((d[(c[h >> 2] | 0) + 2 >> 0] | 0) & 63) << 6;
	                                        c[k >> 2] = c[k >> 2] | (d[(c[h >> 2] | 0) + 3 >> 0] | 0) & 63
	                                    } else {
	                                        n = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                        c[n >> 2] = (c[n >> 2] | 0) + 3;
	                                        c[k >> 2] = ((d[c[h >> 2] >> 0] | 0) & 15) << 12;
	                                        c[k >> 2] = c[k >> 2] | ((d[(c[h >> 2] | 0) + 1 >> 0] | 0) & 63) << 6;
	                                        c[k >> 2] = c[k >> 2] | (d[(c[h >> 2] | 0) + 2 >> 0] | 0) & 63
	                                    }
	                                    if (!((c[k >> 2] | 0) >>> 0 > 55295 & (c[k >> 2] | 0) >>> 0 < 57344) ? !((c[k >> 2] | 0) >>> 0 > 65533 & (c[k >> 2] | 0) >>> 0 < 65536 | (c[k >> 2] | 0) >>> 0 >= 1114112) : 0)break a;
	                                    Ie(c[g >> 2] | 0, 9, 64072, c[k >> 2] | 0);
	                                    break a
	                                }
	                            }
	                        } while (0);
	                        if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 : 0) {
	                            n = d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            m = d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                            o = d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                            c[f >> 2] = d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                            c[f + 4 >> 2] = n;
	                            c[f + 8 >> 2] = m;
	                            c[f + 12 >> 2] = o;
	                            JT(l, 149, 64152, f) | 0;
	                            je(c[g >> 2] | 0, 9, 64192, l, 0)
	                        } else je(c[g >> 2] | 0, 9, 64104, 0, 0);
	                        c[(c[g >> 2] | 0) + 256 >> 2] = 10;
	                        o = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        i = e;
	                        return
	                    } else {
	                        o = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[o >> 2] = (c[o >> 2] | 0) + 1
	                    } while (0);
	                    o = (c[g >> 2] | 0) + 200 | 0;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1;
	                    if (!(d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                } else {
	                    o = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                    if ((b | 0) == 10) {
	                        m = o + 28 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        m = o + 32 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    m = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    m = (c[g >> 2] | 0) + 200 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    if (!(d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                } while (0);
	                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) == 0 : 0)We(c[g >> 2] | 0);
	                if (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                    i = e;
	                    return
	                }
	                if ((ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                    i = e;
	                    return
	                }
	                Ve(c[g >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function ne(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 192 | 0;
	                g = f;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 186 | 0;
	                n = f + 16 | 0;
	                o = f + 36 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                if (!((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        c[h >> 2] = 0;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) >= 32 ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 127 : 0) {
	                        c[c[k >> 2] >> 2] = 1;
	                        c[h >> 2] = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    if ((c[(c[j >> 2] | 0) + 256 >> 2] | 0) != 1) {
	                        c[c[k >> 2] >> 2] = 1;
	                        e = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0;
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                            c[h >> 2] = d[e >> 0];
	                            p = c[h >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                        if ((d[e + 1 >> 0] | 0 | 0) == 10) {
	                            e = (c[j >> 2] | 0) + 200 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1;
	                            e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        }
	                        c[h >> 2] = 10;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    a[m >> 0] = a[c[l >> 2] >> 0] | 0;
	                    if (!((d[m >> 0] | 0) & 128)) {
	                        c[c[k >> 2] >> 2] = 1;
	                        if (!(d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0 > (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 : 0)Ie(c[j >> 2] | 0, 9, 64248, 0);
	                        e = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0;
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                            c[h >> 2] = d[e >> 0];
	                            p = c[h >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                        if ((d[e + 1 >> 0] | 0 | 0) == 10) {
	                            e = (c[j >> 2] | 0) + 200 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1;
	                            e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        }
	                        c[h >> 2] = 10;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    a:do if (((d[m >> 0] | 0) & 64 | 0) != 0 ? (d[m >> 0] | 0 | 0) != 192 : 0) {
	                        if (!(d[(c[l >> 2] | 0) + 1 >> 0] | 0)) {
	                            ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                            c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                        }
	                        if (((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 192 | 0) == 128) {
	                            do if (((d[m >> 0] | 0) & 224 | 0) == 224) {
	                                if (!(d[(c[l >> 2] | 0) + 2 >> 0] | 0)) {
	                                    ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                                }
	                                if (((d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 192 | 0) != 128)break a;
	                                if (((d[m >> 0] | 0) & 240 | 0) != 240) {
	                                    c[c[k >> 2] >> 2] = 3;
	                                    c[n >> 2] = ((d[c[l >> 2] >> 0] | 0) & 15) << 12;
	                                    c[n >> 2] = c[n >> 2] | ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63) << 6;
	                                    c[n >> 2] = c[n >> 2] | (d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 63;
	                                    if ((c[n >> 2] | 0) >>> 0 < 2048)break a; else break
	                                }
	                                if (!(d[(c[l >> 2] | 0) + 3 >> 0] | 0)) {
	                                    ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                                    c[l >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                                }
	                                if (((d[m >> 0] | 0) & 248 | 0) != 240)break a;
	                                if (((d[(c[l >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128)break a;
	                                c[c[k >> 2] >> 2] = 4;
	                                c[n >> 2] = ((d[c[l >> 2] >> 0] | 0) & 7) << 18;
	                                c[n >> 2] = c[n >> 2] | ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63) << 12;
	                                c[n >> 2] = c[n >> 2] | ((d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 63) << 6;
	                                c[n >> 2] = c[n >> 2] | (d[(c[l >> 2] | 0) + 3 >> 0] | 0) & 63;
	                                if ((c[n >> 2] | 0) >>> 0 < 65536)break a
	                            } else {
	                                c[c[k >> 2] >> 2] = 2;
	                                c[n >> 2] = ((d[c[l >> 2] >> 0] | 0) & 31) << 6;
	                                c[n >> 2] = c[n >> 2] | (d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63;
	                                if ((c[n >> 2] | 0) >>> 0 < 128)break a
	                            } while (0);
	                            e = c[n >> 2] | 0;
	                            if ((c[n >> 2] | 0) >>> 0 < 256) {
	                                if (!(9 <= e >>> 0 & (c[n >> 2] | 0) >>> 0 <= 10 | (c[n >> 2] | 0) == 13 | 32 <= (c[n >> 2] | 0) >>> 0))q = 33
	                            } else if ((!(256 <= e >>> 0 & (c[n >> 2] | 0) >>> 0 <= 55295) ? !(57344 <= (c[n >> 2] | 0) >>> 0 & (c[n >> 2] | 0) >>> 0 <= 65533) : 0) ? !(65536 <= (c[n >> 2] | 0) >>> 0 & (c[n >> 2] | 0) >>> 0 <= 1114111) : 0)q = 33;
	                            if ((q | 0) == 33)Ie(c[j >> 2] | 0, 9, 64072, c[n >> 2] | 0);
	                            c[h >> 2] = c[n >> 2];
	                            p = c[h >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                    } while (0);
	                    if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 4) {
	                        c[c[k >> 2] >> 2] = 0;
	                        c[h >> 2] = 0;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else {
	                        n = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                        q = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                        l = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                        c[g >> 2] = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                        c[g + 4 >> 2] = n;
	                        c[g + 8 >> 2] = q;
	                        c[g + 12 >> 2] = l;
	                        JT(o, 149, 64152, g) | 0;
	                        je(c[j >> 2] | 0, 9, 64192, o, 0);
	                        c[(c[j >> 2] | 0) + 256 >> 2] = 10;
	                        c[c[k >> 2] >> 2] = 1;
	                        c[h >> 2] = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                }
	                c[h >> 2] = 0;
	                p = c[h >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function oe(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 192 | 0;
	                h = g;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 186 | 0;
	                o = g + 16 | 0;
	                p = g + 36 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if ((c[m >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[j >> 2] = 0;
	                    q = c[j >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 256 >> 2] | 0) != 1 : 0) {
	                    c[c[m >> 2] >> 2] = 1;
	                    c[j >> 2] = d[c[l >> 2] >> 0];
	                    q = c[j >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                a[n >> 0] = a[c[l >> 2] >> 0] | 0;
	                if (!((d[n >> 0] | 0) & 128)) {
	                    c[c[m >> 2] >> 2] = 1;
	                    c[j >> 2] = d[c[l >> 2] >> 0];
	                    q = c[j >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                a:do if (((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 192 | 0) == 128) {
	                    do if (((d[n >> 0] | 0) & 224 | 0) == 224) {
	                        if (((d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 192 | 0) != 128)break a;
	                        if (((d[n >> 0] | 0) & 240 | 0) != 240) {
	                            c[c[m >> 2] >> 2] = 3;
	                            c[o >> 2] = ((d[c[l >> 2] >> 0] | 0) & 15) << 12;
	                            c[o >> 2] = c[o >> 2] | ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63) << 6;
	                            c[o >> 2] = c[o >> 2] | (d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 63;
	                            break
	                        }
	                        if (((d[n >> 0] | 0) & 248 | 0) != 240)break a;
	                        if (((d[(c[l >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128)break a;
	                        c[c[m >> 2] >> 2] = 4;
	                        c[o >> 2] = ((d[c[l >> 2] >> 0] | 0) & 7) << 18;
	                        c[o >> 2] = c[o >> 2] | ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63) << 12;
	                        c[o >> 2] = c[o >> 2] | ((d[(c[l >> 2] | 0) + 2 >> 0] | 0) & 63) << 6;
	                        c[o >> 2] = c[o >> 2] | (d[(c[l >> 2] | 0) + 3 >> 0] | 0) & 63
	                    } else {
	                        c[c[m >> 2] >> 2] = 2;
	                        c[o >> 2] = ((d[c[l >> 2] >> 0] | 0) & 31) << 6;
	                        c[o >> 2] = c[o >> 2] | (d[(c[l >> 2] | 0) + 1 >> 0] | 0) & 63
	                    } while (0);
	                    f = c[o >> 2] | 0;
	                    if ((c[o >> 2] | 0) >>> 0 < 256) {
	                        if (!(9 <= f >>> 0 & (c[o >> 2] | 0) >>> 0 <= 10 | (c[o >> 2] | 0) == 13 | 32 <= (c[o >> 2] | 0) >>> 0))r = 20
	                    } else if ((!(256 <= f >>> 0 & (c[o >> 2] | 0) >>> 0 <= 55295) ? !(57344 <= (c[o >> 2] | 0) >>> 0 & (c[o >> 2] | 0) >>> 0 <= 65533) : 0) ? !(65536 <= (c[o >> 2] | 0) >>> 0 & (c[o >> 2] | 0) >>> 0 <= 1114111) : 0)r = 20;
	                    if ((r | 0) == 20)Ie(c[k >> 2] | 0, 9, 64072, c[o >> 2] | 0);
	                    c[j >> 2] = c[o >> 2];
	                    q = c[j >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } while (0);
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 : 0) {
	                    o = d[(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                    r = d[(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                    n = d[(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                    c[h >> 2] = d[c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                    c[h + 4 >> 2] = o;
	                    c[h + 8 >> 2] = r;
	                    c[h + 12 >> 2] = n;
	                    JT(p, 149, 64152, h) | 0;
	                    je(c[k >> 2] | 0, 9, 64192, p, 0);
	                    c[c[m >> 2] >> 2] = 1;
	                    c[j >> 2] = d[c[l >> 2] >> 0];
	                    q = c[j >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                c[c[m >> 2] >> 2] = 0;
	                c[j >> 2] = 0;
	                q = c[j >> 2] | 0;
	                i = g;
	                return q | 0
	            }

	            function pe(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[h >> 2] | 0) < 128) {
	                    a[c[g >> 2] >> 0] = c[h >> 2];
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[j >> 2] = c[g >> 2];
	                d = c[h >> 2] | 0;
	                do if ((c[h >> 2] | 0) < 2048) {
	                    b = c[g >> 2] | 0;
	                    c[g >> 2] = b + 1;
	                    a[b >> 0] = d >> 6 | 192;
	                    c[k >> 2] = 0
	                } else {
	                    b = c[h >> 2] | 0;
	                    if ((d | 0) < 65536) {
	                        m = c[g >> 2] | 0;
	                        c[g >> 2] = m + 1;
	                        a[m >> 0] = b >> 12 | 224;
	                        c[k >> 2] = 6;
	                        break
	                    }
	                    m = c[h >> 2] | 0;
	                    if ((b | 0) < 1114112) {
	                        b = c[g >> 2] | 0;
	                        c[g >> 2] = b + 1;
	                        a[b >> 0] = m >> 18 | 240;
	                        c[k >> 2] = 12;
	                        break
	                    }
	                    Ie(0, 9, 64280, m);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } while (0);
	                while (1) {
	                    if ((c[k >> 2] | 0) < 0)break;
	                    d = (c[h >> 2] >> c[k >> 2] & 63 | 128) & 255;
	                    m = c[g >> 2] | 0;
	                    c[g >> 2] = m + 1;
	                    a[m >> 0] = d;
	                    c[k >> 2] = (c[k >> 2] | 0) - 6
	                }
	                c[f >> 2] = (c[g >> 2] | 0) - (c[j >> 2] | 0);
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function qe(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 4 | 0;
	                j = f;
	                c[f + 8 >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                do if (c[h >> 2] | 0)if ((c[j >> 2] | 0) >= 128) {
	                    c[g >> 2] = pe(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    break
	                } else {
	                    a[c[h >> 2] >> 0] = c[j >> 2];
	                    c[g >> 2] = 1;
	                    break
	                } else c[g >> 2] = 0; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function re(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[k >> 2] = -1;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                switch (c[h >> 2] | 0) {
	                    case 1:
	                    {
	                        c[(c[g >> 2] | 0) + 256 >> 2] = 1;
	                        if ((((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 239 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 187 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 191 : 0) {
	                            b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 3
	                        }
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    case 21:
	                    case 20:
	                    case 19:
	                    case 22:
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    case 13:
	                    case 12:
	                    case 11:
	                    case 10:
	                    case 6:
	                    {
	                        c[k >> 2] = 45;
	                        break
	                    }
	                    case -1:
	                    {
	                        je(c[g >> 2] | 0, 31, 64336, 0, 0);
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    case 0:
	                    {
	                        c[(c[g >> 2] | 0) + 256 >> 2] = 1;
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    case 9:
	                    {
	                        c[k >> 2] = 90;
	                        break
	                    }
	                    case 8:
	                    case 7:
	                    case 4:
	                    case 5:
	                    {
	                        c[k >> 2] = 180;
	                        break
	                    }
	                    case 3:
	                    case 2:
	                    {
	                        if (((((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 239 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 187 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 191 : 0) {
	                            b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 3
	                        }
	                        c[k >> 2] = 90;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                c[j >> 2] = Cd(c[h >> 2] | 0) | 0;
	                a:do if (!(c[j >> 2] | 0))do switch (c[h >> 2] | 0) {
	                    case 8:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64456, 0);
	                        break a;
	                        break
	                    }
	                    case 9:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64472, 0);
	                        break a;
	                        break
	                    }
	                    case 7:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64440, 0);
	                        break a;
	                        break
	                    }
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    case 13:
	                    case 12:
	                    case 11:
	                    case 10:
	                    {
	                        if ((((c[(c[g >> 2] | 0) + 40 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                            b = my(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0) | 0;
	                            c[(c[g >> 2] | 0) + 24 >> 2] = b
	                        }
	                        c[(c[g >> 2] | 0) + 256 >> 2] = c[h >> 2];
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    case 19:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64480, 0);
	                        break a;
	                        break
	                    }
	                    case 20:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64496, 0);
	                        break a;
	                        break
	                    }
	                    case 22:
	                    {
	                        c[(c[g >> 2] | 0) + 256 >> 2] = 1;
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    case 4:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64392, 0);
	                        break a;
	                        break
	                    }
	                    case 5:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64416, 0);
	                        break a;
	                        break
	                    }
	                    case 21:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64512, 0);
	                        break a;
	                        break
	                    }
	                    case 6:
	                    {
	                        je(c[g >> 2] | 0, 32, 64360, 64432, 0);
	                        break a;
	                        break
	                    }
	                    default:
	                        break a
	                } while (0); while (0);
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[(c[g >> 2] | 0) + 256 >> 2] = 1;
	                    c[f >> 2] = Je(c[g >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function se(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = Je(c[e >> 2] | 0, c[f >> 2] | 0, -1) | 0;
	                i = d;
	                return b | 0
	            }

	            function te(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 40 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)zb[c[(c[d >> 2] | 0) + 40 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[c[d >> 2] >> 2] | 0)yk(c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ue(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    ie(c[e >> 2] | 0, 64520);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 60 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 28 >> 2] = 1;
	                c[(c[f >> 2] | 0) + 32 >> 2] = 1;
	                c[(c[f >> 2] | 0) + 52 >> 2] = -1;
	                if (c[e >> 2] | 0) {
	                    a = (c[e >> 2] | 0) + 464 | 0;
	                    e = c[a >> 2] | 0;
	                    c[a >> 2] = e + 1;
	                    c[(c[f >> 2] | 0) + 56 >> 2] = e
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function ve(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (c[33952] | 0)Db[c[135904 >> 2] & 511](c[33980] | 0, 64560, e);
	                c[k >> 2] = ue(c[g >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                c[c[k >> 2] >> 2] = c[h >> 2];
	                iz(c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (c[j >> 2] | 0)re(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function we(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[h >> 2] | 0)) {
	                    Le(c[g >> 2] | 0, 64584, 0);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (c[33952] | 0) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                    Db[b & 511](a, 64624, e)
	                }
	                if (c[(c[h >> 2] | 0) + 40 >> 2] | 0) {
	                    c[j >> 2] = ue(c[g >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        k = c[f >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 64 >> 2] | 0) {
	                        e = my(c[(c[h >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        c[(c[j >> 2] | 0) + 4 >> 2] = e
	                    }
	                    c[(c[j >> 2] | 0) + 12 >> 2] = c[(c[h >> 2] | 0) + 40 >> 2];
	                    c[(c[j >> 2] | 0) + 16 >> 2] = c[(c[h >> 2] | 0) + 40 >> 2];
	                    c[(c[j >> 2] | 0) + 24 >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                    c[(c[j >> 2] | 0) + 20 >> 2] = (c[(c[h >> 2] | 0) + 40 >> 2] | 0) + (c[(c[j >> 2] | 0) + 24 >> 2] | 0);
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                switch (c[(c[h >> 2] | 0) + 48 >> 2] | 0) {
	                    case 4:
	                    {
	                        Le(c[g >> 2] | 0, 64720, c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    case 1:
	                    {
	                        Le(c[g >> 2] | 0, 64680, c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    case 6:
	                    {
	                        Le(c[g >> 2] | 0, 64768, c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    case 3:
	                    {
	                        Le(c[g >> 2] | 0, 64656, c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    case 5:
	                    case 2:
	                    {
	                        c[f >> 2] = Vk(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[(c[h >> 2] | 0) + 52 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        k = c[f >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    default:
	                    {
	                    }
	                }
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function xe(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                if (c[33952] | 0) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[h >> 2];
	                    Db[b & 511](a, 64808, e)
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[j >> 2] = Ck(c[h >> 2] | 0, 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    e = c[g >> 2] | 0;
	                    if (!(c[h >> 2] | 0))ik(e, 64840, 0); else ik(e, 64888, c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[k >> 2] = ue(c[g >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[c[k >> 2] >> 2] = c[j >> 2];
	                c[k >> 2] = Sk(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0))c[m >> 2] = my(c[h >> 2] | 0) | 0; else c[m >> 2] = my(c[(c[k >> 2] | 0) + 4 >> 2] | 0) | 0;
	                c[l >> 2] = Rk(c[m >> 2] | 0) | 0;
	                if (c[(c[k >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 4 >> 2] | 0);
	                h = Jl(c[m >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 4 >> 2] = h;
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                iz(c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 180 >> 2] | 0) == 0 : 0) {
	                    m = my(c[l >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 180 >> 2] = m
	                }
	                c[f >> 2] = c[k >> 2];
	                n = c[f >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function ye(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    Le(0, 64928, 0);
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                pQ();
	                if (!(c[(c[e >> 2] | 0) + 296 >> 2] | 0)) {
	                    a = xP() | 0;
	                    c[(c[e >> 2] | 0) + 296 >> 2] = a
	                }
	                if (!(c[(c[e >> 2] | 0) + 296 >> 2] | 0)) {
	                    ie(0, 64960);
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                DP(c[(c[e >> 2] | 0) + 296 >> 2] | 0, 1e7) | 0;
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    a = Cb[c[135744 >> 2] & 511](128) | 0;
	                    c[c[e >> 2] >> 2] = a
	                }
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    ie(0, 64960);
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                oQ(c[c[e >> 2] >> 2] | 0, 2) | 0;
	                c[(c[e >> 2] | 0) + 304 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 300 >> 2] = 0;
	                if (!(c[(c[e >> 2] | 0) + 48 >> 2] | 0)) {
	                    a = Cb[c[135744 >> 2] & 511](20) | 0;
	                    c[(c[e >> 2] | 0) + 48 >> 2] = a;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 5
	                }
	                if (!(c[(c[e >> 2] | 0) + 48 >> 2] | 0)) {
	                    ie(0, 64960);
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                while (1) {
	                    a = Pe(c[e >> 2] | 0) | 0;
	                    c[f >> 2] = a;
	                    if (!a)break;
	                    te(c[f >> 2] | 0)
	                }
	                c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 28 >> 2] = -1;
	                c[(c[e >> 2] | 0) + 88 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 92 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 96 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 172 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 176 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 180 >> 2] = 0;
	                if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                    f = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[e >> 2] | 0) + 64 >> 2] = f;
	                    c[(c[e >> 2] | 0) + 60 >> 2] = 10
	                }
	                if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                    ie(0, 64960);
	                    c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                if (!(c[(c[e >> 2] | 0) + 196 >> 2] | 0)) {
	                    f = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[e >> 2] | 0) + 196 >> 2] = f;
	                    c[(c[e >> 2] | 0) + 192 >> 2] = 10
	                }
	                if (!(c[(c[e >> 2] | 0) + 196 >> 2] | 0)) {
	                    ie(0, 64960);
	                    c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 188 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 192 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 184 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[e >> 2] | 0) + 188 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 184 >> 2] = 0;
	                if (!(c[(c[e >> 2] | 0) + 244 >> 2] | 0)) {
	                    f = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[e >> 2] | 0) + 244 >> 2] = f;
	                    c[(c[e >> 2] | 0) + 240 >> 2] = 10
	                }
	                if (!(c[(c[e >> 2] | 0) + 244 >> 2] | 0)) {
	                    ie(0, 64960);
	                    c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 188 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 192 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 184 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 236 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 240 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 232 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[e >> 2] | 0) + 236 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 240 >> 2] = 10;
	                c[c[(c[e >> 2] | 0) + 244 >> 2] >> 2] = -1;
	                c[(c[e >> 2] | 0) + 232 >> 2] = c[(c[e >> 2] | 0) + 244 >> 2];
	                c[(c[e >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                c[(c[e >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 12 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 356 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 100 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 276 >> 2] = c[33958];
	                if (c[(c[e >> 2] | 0) + 276 >> 2] | 0) {
	                    f = (c[e >> 2] | 0) + 360 | 0;
	                    c[f >> 2] = c[f >> 2] | 4
	                }
	                c[(c[e >> 2] | 0) + 104 >> 2] = c[33954];
	                c[(c[e >> 2] | 0) + 268 >> 2] = c[33960];
	                if (c[(c[e >> 2] | 0) + 268 >> 2] | 0) {
	                    f = (c[e >> 2] | 0) + 360 | 0;
	                    c[f >> 2] = c[f >> 2] | 128
	                }
	                c[(c[e >> 2] | 0) + 280 >> 2] = c[33962];
	                c[(c[e >> 2] | 0) + 208 >> 2] = c[33964];
	                if (!(c[(c[e >> 2] | 0) + 208 >> 2] | 0)) {
	                    c[(c[c[e >> 2] >> 2] | 0) + 72 >> 2] = 65;
	                    f = (c[e >> 2] | 0) + 360 | 0;
	                    c[f >> 2] = c[f >> 2] | 256
	                }
	                c[(c[e >> 2] | 0) + 136 >> 2] = -1412623820;
	                c[(c[e >> 2] | 0) + 108 >> 2] = c[e >> 2];
	                c[(c[e >> 2] | 0) + 112 >> 2] = 224;
	                c[(c[e >> 2] | 0) + 116 >> 2] = 225;
	                if (c[(c[e >> 2] | 0) + 104 >> 2] | 0) {
	                    f = (c[e >> 2] | 0) + 116 | 0;
	                    if (!(c[33956] | 0))c[f >> 2] = 0; else c[f >> 2] = 225;
	                    c[(c[e >> 2] | 0) + 128 >> 2] = 0;
	                    f = (c[e >> 2] | 0) + 360 | 0;
	                    c[f >> 2] = c[f >> 2] | 16
	                }
	                c[(c[e >> 2] | 0) + 16 >> 2] = c[33966];
	                if (c[(c[e >> 2] | 0) + 16 >> 2] | 0) {
	                    f = (c[e >> 2] | 0) + 360 | 0;
	                    c[f >> 2] = c[f >> 2] | 2
	                }
	                c[(c[e >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 200 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 204 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 216 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 84 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 248 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 256 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 284 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 440 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 444 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 468 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 464 >> 2] = 1;
	                ze((c[e >> 2] | 0) + 72 | 0);
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function ze(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[d >> 2] | 0) + 4 >> 2] = 0;
	                c[c[d >> 2] >> 2] = 0;
	                c[(c[d >> 2] | 0) + 8 >> 2] = 0;
	                i = b;
	                return
	            }

	            function Ae(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                while (1) {
	                    a = Pe(c[d >> 2] | 0) | 0;
	                    c[e >> 2] = a;
	                    if (!a)break;
	                    te(c[e >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 244 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 244 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 196 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 196 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 460 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 460 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 224 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 224 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 228 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 228 >> 2] | 0);
	                if ((c[c[d >> 2] >> 2] | 0) != 0 ? (c[c[d >> 2] >> 2] | 0) != 135968 : 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 180 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 180 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 132 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 132 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 300 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 300 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 296 >> 2] | 0)zP(c[(c[d >> 2] | 0) + 296 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 336 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 336 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 344 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 344 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 340 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 340 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 348 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 348 >> 2] | 0, c[33934] | 0);
	                if (c[(c[d >> 2] | 0) + 352 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 352 >> 2] | 0, 0);
	                a:do if (c[(c[d >> 2] | 0) + 372 >> 2] | 0) {
	                    c[f >> 2] = c[(c[d >> 2] | 0) + 372 >> 2];
	                    while (1) {
	                        if (!(c[f >> 2] | 0))break a;
	                        c[g >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[f >> 2] = c[g >> 2]
	                    }
	                } while (0);
	                b:do if (c[(c[d >> 2] | 0) + 380 >> 2] | 0) {
	                    c[h >> 2] = c[(c[d >> 2] | 0) + 380 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break b;
	                        c[j >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[h >> 2] = c[j >> 2]
	                    }
	                } while (0);
	                if (c[(c[d >> 2] | 0) + 392 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 392 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 400 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 400 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 408 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 408 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 412 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 412 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 416 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 416 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 284 >> 2] | 0)Hw(c[(c[d >> 2] | 0) + 284 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Be() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](472) | 0;
	                do if (c[d >> 2] | 0) {
	                    cU(c[d >> 2] | 0, 0, 472) | 0;
	                    e = (ye(c[d >> 2] | 0) | 0) < 0;
	                    f = c[d >> 2] | 0;
	                    if (e) {
	                        Ae(f);
	                        c[b >> 2] = 0;
	                        break
	                    } else {
	                        c[b >> 2] = f;
	                        break
	                    }
	                } else {
	                    ie(0, 65e3);
	                    c[b >> 2] = 0
	                } while (0);
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function Ce(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[l >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[j >> 2] = 1;
	                c[h >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >>> 0 > (c[h >> 2] | 0) >>> 0)break;
	                    if (!((c[l >> 2] | 0) != 0 ^ 1))break;
	                    c[k >> 2] = (c[j >> 2] | 0) + ((((c[h >> 2] | 0) - (c[j >> 2] | 0) | 0) >>> 0) / 2 | 0);
	                    if ((c[g >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (((c[k >> 2] | 0) - 1 | 0) * 20 | 0) >> 2] | 0)) {
	                        c[l >> 2] = 1;
	                        continue
	                    }
	                    b = c[k >> 2] | 0;
	                    if ((c[g >> 2] | 0) >>> 0 < (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (((c[k >> 2] | 0) - 1 | 0) * 20 | 0) >> 2] | 0) >>> 0) {
	                        c[h >> 2] = b - 1;
	                        continue
	                    } else {
	                        c[j >> 2] = b + 1;
	                        continue
	                    }
	                }
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (((c[k >> 2] | 0) - 1 | 0) * 20 | 0) >> 2] | 0) >>> 0 >= (c[g >> 2] | 0) >>> 0 : 0) {
	                    c[e >> 2] = (c[k >> 2] | 0) - 1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[e >> 2] = c[k >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function De(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = Ce((c[e >> 2] | 0) + 72 | 0, c[c[f >> 2] >> 2] | 0) | 0;
	                if (((c[g >> 2] | 0) >>> 0 < (c[(c[e >> 2] | 0) + 76 >> 2] | 0) >>> 0 ? (c[(c[e >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 80 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) >> 2] | 0) == (c[c[f >> 2] >> 2] | 0) : 0) {
	                    b = (c[(c[e >> 2] | 0) + 80 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    c[b + 0 >> 2] = c[a + 0 >> 2];
	                    c[b + 4 >> 2] = c[a + 4 >> 2];
	                    c[b + 8 >> 2] = c[a + 8 >> 2];
	                    c[b + 12 >> 2] = c[a + 12 >> 2];
	                    c[b + 16 >> 2] = c[a + 16 >> 2];
	                    i = d;
	                    return
	                }
	                if (!(((c[(c[e >> 2] | 0) + 76 >> 2] | 0) + 1 | 0) >>> 0 <= (c[(c[e >> 2] | 0) + 72 >> 2] | 0) >>> 0 ? (c[(c[e >> 2] | 0) + 80 >> 2] | 0) != 0 : 0))l = 8;
	                do if ((l | 0) == 8) {
	                    if (!(c[(c[e >> 2] | 0) + 72 >> 2] | 0))c[(c[e >> 2] | 0) + 72 >> 2] = 2;
	                    c[j >> 2] = (c[(c[e >> 2] | 0) + 72 >> 2] << 1) * 20;
	                    if (!(c[(c[e >> 2] | 0) + 80 >> 2] | 0))c[h >> 2] = Cb[c[135744 >> 2] & 511](c[j >> 2] | 0) | 0; else c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 80 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[e >> 2] | 0) + 80 >> 2] = c[h >> 2];
	                        a = (c[e >> 2] | 0) + 72 | 0;
	                        c[a >> 2] = c[a >> 2] << 1;
	                        break
	                    }
	                    ie(c[e >> 2] | 0, 65032);
	                    i = d;
	                    return
	                } while (0);
	                a:do if ((c[g >> 2] | 0) != (c[(c[e >> 2] | 0) + 76 >> 2] | 0)) {
	                    c[k >> 2] = c[(c[e >> 2] | 0) + 76 >> 2];
	                    while (1) {
	                        if ((c[k >> 2] | 0) >>> 0 <= (c[g >> 2] | 0) >>> 0)break a;
	                        h = (c[(c[e >> 2] | 0) + 80 >> 2] | 0) + ((c[k >> 2] | 0) * 20 | 0) | 0;
	                        j = (c[(c[e >> 2] | 0) + 80 >> 2] | 0) + (((c[k >> 2] | 0) - 1 | 0) * 20 | 0) | 0;
	                        c[h + 0 >> 2] = c[j + 0 >> 2];
	                        c[h + 4 >> 2] = c[j + 4 >> 2];
	                        c[h + 8 >> 2] = c[j + 8 >> 2];
	                        c[h + 12 >> 2] = c[j + 12 >> 2];
	                        c[h + 16 >> 2] = c[j + 16 >> 2];
	                        c[k >> 2] = (c[k >> 2] | 0) + -1
	                    }
	                } while (0);
	                k = (c[(c[e >> 2] | 0) + 80 >> 2] | 0) + ((c[g >> 2] | 0) * 20 | 0) | 0;
	                g = c[f >> 2] | 0;
	                c[k + 0 >> 2] = c[g + 0 >> 2];
	                c[k + 4 >> 2] = c[g + 4 >> 2];
	                c[k + 8 >> 2] = c[g + 8 >> 2];
	                c[k + 12 >> 2] = c[g + 12 >> 2];
	                c[k + 16 >> 2] = c[g + 16 >> 2];
	                g = (c[e >> 2] | 0) + 76 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + 1;
	                i = d;
	                return
	            }

	            function Ee(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[33960];
	                c[33960] = c[d >> 2];
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Fe(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[33962];
	                c[33962] = c[d >> 2];
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Ge(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[33966];
	                c[33966] = c[d >> 2];
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function He(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[33964];
	                c[33964] = c[d >> 2];
	                if (!(c[d >> 2] | 0))c[33984] = 1;
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Ie(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = f;
	                    return
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                e = c[h >> 2] | 0;
	                d = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                b = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, 0, 1, d, 3, 0, 0, 0, 0, 0, j, 0, b, g);
	                if (!(c[h >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[h >> 2] | 0) + 288 >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 212 >> 2] = 1;
	                i = f;
	                return
	            }

	            function Je(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = c[g >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                    c[k >> 2] = Ke(d, c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 256 >> 2] = 1;
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    Le(d, 65064, 0);
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Ke(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 4 | 0;
	                p = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                f = c[k >> 2] | 0;
	                if (!(c[c[k >> 2] >> 2] | 0))if (!(c[f + 24 >> 2] | 0)) {
	                    Le(c[j >> 2] | 0, 65184, 0);
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } else {
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)if ((c[(c[c[k >> 2] >> 2] | 0) + 12 >> 2] | 0) == (c[l >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } else {
	                    Hd(c[(c[c[k >> 2] >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    c[(c[c[k >> 2] >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                c[(c[c[k >> 2] >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                do if (!(az(c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0)) {
	                    do if (c[c[l >> 2] >> 2] | 0) {
	                        if ((PT(c[c[l >> 2] >> 2] | 0, 65096) | 0) != 0 ? (PT(c[c[l >> 2] >> 2] | 0, 65112) | 0) != 0 : 0)break;
	                        if ((d[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 255 ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 254 : 0) {
	                            f = (c[k >> 2] | 0) + 16 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2
	                        }
	                    } while (0);
	                    if ((((c[c[l >> 2] >> 2] | 0) != 0 ? (PT(c[c[l >> 2] >> 2] | 0, 65120) | 0) == 0 : 0) ? (d[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 254 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 255 : 0) {
	                        f = (c[k >> 2] | 0) + 16 | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) + 2
	                    }
	                    if (((((c[c[l >> 2] >> 2] | 0) != 0 ? (PT(c[c[l >> 2] >> 2] | 0, 65136) | 0) == 0 : 0) ? (d[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 239 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 187 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 191 : 0) {
	                        f = (c[k >> 2] | 0) + 16 | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) + 3
	                    }
	                    c[o >> 2] = (c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0);
	                    Ty(c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2] | 0, c[o >> 2] | 0) | 0;
	                    c[(c[c[k >> 2] >> 2] | 0) + 20 >> 2] = c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2];
	                    f = Ly() | 0;
	                    c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2] = f;
	                    c[(c[c[k >> 2] >> 2] | 0) + 32 >> 2] = c[o >> 2];
	                    c[p >> 2] = _y(c[(c[c[k >> 2] >> 2] | 0) + 20 >> 2] | 0) | 0;
	                    f = c[c[k >> 2] >> 2] | 0;
	                    if (c[(c[j >> 2] | 0) + 32 >> 2] | 0)c[n >> 2] = Fd(f, 1) | 0; else c[n >> 2] = Ed(f, c[m >> 2] | 0) | 0;
	                    if ((c[n >> 2] | 0) >= 0) {
	                        f = c[p >> 2] | 0;
	                        e = f - (_y(c[(c[c[k >> 2] >> 2] | 0) + 20 >> 2] | 0) | 0) | 0;
	                        f = (c[c[k >> 2] >> 2] | 0) + 32 | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) + e;
	                        iz(c[(c[c[k >> 2] >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    Le(c[j >> 2] | 0, 65144, 0);
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } while (0);
	                c[h >> 2] = 0;
	                q = c[h >> 2] | 0;
	                i = g;
	                return q | 0
	            }

	            function Le(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = e;
	                    return
	                }
	                if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 84 >> 2] = 1;
	                d = c[g >> 2] | 0;
	                b = c[j >> 2] | 0;
	                a = c[h >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(0, 0, 0, d, 0, 1, 1, 3, 0, 0, b, 0, 0, 0, 0, a, f);
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 288 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 212 >> 2] = 1;
	                i = e;
	                return
	            }

	            function Me(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do switch (c[e >> 2] | 0) {
	                    case 21:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 18:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 30:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 29:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 33:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 10:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 28:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 27:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 13:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 20:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 11:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 9:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 24:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 26:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 22:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 23:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 32:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 25:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 6:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    case 31:
	                    {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 0
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Ne(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                if (!((d[c[g >> 2] >> 0] | 0 | 0) == 105 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 45 : 0))k = 5;
	                do if ((k | 0) == 5) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 73 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 45 : 0)break;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 120 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 45 : 0)break;
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 88 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 45 : 0)break;
	                    c[h >> 2] = c[g >> 2];
	                    while (1) {
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)l = 1; else if ((d[c[h >> 2] >> 0] | 0 | 0) >= 97)l = (d[c[h >> 2] >> 0] | 0 | 0) <= 122; else l = 0;
	                        m = c[h >> 2] | 0;
	                        if (!l)break;
	                        c[h >> 2] = m + 1
	                    }
	                    f = (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0;
	                    if ((m - (c[g >> 2] | 0) | 0) >= 4) {
	                        if ((f | 0) <= 8 ? (d[c[h >> 2] >> 0] | 0 | 0) == 0 : 0) {
	                            c[e >> 2] = 1;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        }
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    if ((f | 0) < 2) {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        c[e >> 2] = 1;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) != 45) {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[g >> 2] = c[h >> 2];
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 57 : 0)k = 103; else k = 39;
	                    a:do if ((k | 0) == 39) {
	                        while (1) {
	                            k = 0;
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)n = 1; else if ((d[c[h >> 2] >> 0] | 0 | 0) >= 97)n = (d[c[h >> 2] >> 0] | 0 | 0) <= 122; else n = 0;
	                            o = c[h >> 2] | 0;
	                            if (!n)break;
	                            c[h >> 2] = o + 1;
	                            k = 39
	                        }
	                        do if ((o - (c[g >> 2] | 0) | 0) != 4) {
	                            if (((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) == 2) {
	                                k = 84;
	                                break a
	                            }
	                            if (((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) >= 5 ? ((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) <= 8 : 0)break a;
	                            if (((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) != 3) {
	                                c[e >> 2] = 0;
	                                j = c[e >> 2] | 0;
	                                i = b;
	                                return j | 0
	                            }
	                            if (!(d[c[h >> 2] >> 0] | 0)) {
	                                c[e >> 2] = 1;
	                                j = c[e >> 2] | 0;
	                                i = b;
	                                return j | 0
	                            }
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) != 45) {
	                                c[e >> 2] = 0;
	                                j = c[e >> 2] | 0;
	                                i = b;
	                                return j | 0
	                            }
	                            c[h >> 2] = (c[h >> 2] | 0) + 1;
	                            c[g >> 2] = c[h >> 2];
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                k = 103;
	                                break a
	                            }
	                            while (1) {
	                                if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)p = 1; else k = 59;
	                                do if ((k | 0) == 59) {
	                                    k = 0;
	                                    if ((d[c[h >> 2] >> 0] | 0 | 0) < 97) {
	                                        p = 0;
	                                        break
	                                    }
	                                    p = (d[c[h >> 2] >> 0] | 0 | 0) <= 122
	                                } while (0);
	                                q = c[h >> 2] | 0;
	                                if (!p)break;
	                                c[h >> 2] = q + 1
	                            }
	                            if ((q - (c[g >> 2] | 0) | 0) == 2) {
	                                k = 84;
	                                break a
	                            }
	                            if (((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) >= 5 ? ((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) <= 8 : 0)break a;
	                            if (((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) == 4)break;
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        } while (0);
	                        if (!(d[c[h >> 2] >> 0] | 0)) {
	                            c[e >> 2] = 1;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        }
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 45) {
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        c[g >> 2] = c[h >> 2];
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                            k = 103;
	                            break
	                        }
	                        while (1) {
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)r = 1; else if ((d[c[h >> 2] >> 0] | 0 | 0) >= 97)r = (d[c[h >> 2] >> 0] | 0 | 0) <= 122; else r = 0;
	                            s = c[h >> 2] | 0;
	                            if (!r)break;
	                            c[h >> 2] = s + 1
	                        }
	                        if ((s - (c[g >> 2] | 0) | 0) >= 5 ? ((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) <= 8 : 0)break;
	                        if (((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) != 2) {
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        } else k = 84
	                    } while (0);
	                    do if ((k | 0) == 103) {
	                        if ((((d[(c[h >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 ? (d[(c[h >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[h >> 2] | 0) + 2 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[h >> 2] | 0) + 2 >> 0] | 0 | 0) <= 57 : 0) {
	                            c[h >> 2] = (c[h >> 2] | 0) + 3;
	                            k = 84;
	                            break
	                        }
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } while (0);
	                    do if ((k | 0) == 84) {
	                        if (!(d[c[h >> 2] >> 0] | 0)) {
	                            c[e >> 2] = 1;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        }
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 45) {
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        }
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        c[g >> 2] = c[h >> 2];
	                        while (1) {
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[h >> 2] >> 0] | 0 | 0) <= 90 : 0)t = 1; else if ((d[c[h >> 2] >> 0] | 0 | 0) >= 97)t = (d[c[h >> 2] >> 0] | 0 | 0) <= 122; else t = 0;
	                            u = c[h >> 2] | 0;
	                            if (!t)break;
	                            c[h >> 2] = u + 1
	                        }
	                        if ((u - (c[g >> 2] | 0) | 0) >= 5 ? ((c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) <= 8 : 0)break;
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } while (0);
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        c[e >> 2] = 1;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) != 45) {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } else {
	                        c[e >> 2] = 1;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                } while (0);
	                c[g >> 2] = (c[g >> 2] | 0) + 2;
	                while (1) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0)v = 1; else if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97)v = (d[c[g >> 2] >> 0] | 0 | 0) <= 122; else v = 0;
	                    w = c[g >> 2] | 0;
	                    if (!v)break;
	                    c[g >> 2] = w + 1
	                }
	                c[e >> 2] = (d[w >> 0] | 0 | 0) == 0 & 1;
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function Oe(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 44 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 44 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 48 >> 2] | 0, c[(c[f >> 2] | 0) + 44 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 48 >> 2] = b, (c[(c[f >> 2] | 0) + 48 >> 2] | 0) == 0) : 0) {
	                    ie(c[f >> 2] | 0, 0);
	                    te(c[g >> 2] | 0);
	                    b = (c[f >> 2] | 0) + 44 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) / 2 | 0;
	                    c[g >> 2] = 0;
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + (c[(c[f >> 2] | 0) + 40 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 36 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 40 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Pe(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 40 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 36 >> 2] = c[(c[(c[e >> 2] | 0) + 48 >> 2] | 0) + ((c[a + 40 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 36 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 48 >> 2] | 0) + (c[(c[e >> 2] | 0) + 40 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 48 >> 2] | 0) + (c[(c[e >> 2] | 0) + 40 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Qe(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                do if ((c[(c[f >> 2] | 0) + 56 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 60 >> 2] | 0)) {
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] << 1 << 2) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 64 >> 2] = c[h >> 2];
	                        b = (c[f >> 2] | 0) + 60 | 0;
	                        c[b >> 2] = c[b >> 2] << 1;
	                        break
	                    }
	                    ie(c[f >> 2] | 0, 0);
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 56 >> 2] | 0) >>> 0 > (c[16304] | 0) >>> 0 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                    ng(c[f >> 2] | 0, 1, 65224, c[16304] | 0);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = -1;
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + (c[(c[f >> 2] | 0) + 56 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 52 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 56 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Re(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if ((c[(c[e >> 2] | 0) + 56 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 56 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 56 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 52 >> 2] = c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + ((c[a + 56 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 52 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + (c[(c[e >> 2] | 0) + 56 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + (c[(c[e >> 2] | 0) + 56 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Se(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                do if ((c[(c[f >> 2] | 0) + 188 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 192 >> 2] | 0)) {
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 196 >> 2] | 0, c[(c[f >> 2] | 0) + 192 >> 2] << 1 << 2) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 196 >> 2] = c[h >> 2];
	                        b = (c[f >> 2] | 0) + 192 | 0;
	                        c[b >> 2] = c[b >> 2] << 1;
	                        break
	                    }
	                    ie(c[f >> 2] | 0, 0);
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[(c[(c[f >> 2] | 0) + 196 >> 2] | 0) + (c[(c[f >> 2] | 0) + 188 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 184 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 188 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Te(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 188 >> 2] | 0) > 0 : 0) {
	                    a = (c[e >> 2] | 0) + 188 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + -1;
	                    a = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 184 >> 2] = c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + ((c[a + 188 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 184 >> 2] = 0;
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[(c[e >> 2] | 0) + 188 >> 2] << 2) >> 2];
	                    c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[(c[e >> 2] | 0) + 188 >> 2] << 2) >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Ue(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 1 ? (c[(c[e >> 2] | 0) + 172 >> 2] | 0) != 3 : 0) {
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    while (1) {
	                        do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = c[g >> 2] | 0;
	                        if (!j)break;
	                        a = c[(c[e >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[k >> 0] | 0 | 0) == 10) {
	                            l = a + 28 | 0;
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            l = a + 32 | 0;
	                            c[l >> 2] = (c[l >> 2] | 0) + 1
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        if (d[c[g >> 2] >> 0] | 0)continue;
	                        c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                        c[g >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                    }
	                    c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = k;
	                    m = c[f >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                do {
	                    c[h >> 2] = d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                    while (1) {
	                        if ((c[h >> 2] | 0) != 32 ? !(9 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 10 | (c[h >> 2] | 0) == 13) : 0)break;
	                        me(c[e >> 2] | 0);
	                        c[h >> 2] = d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        if ((c[h >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) > 1 : 0)n = (c[(c[e >> 2] | 0) + 172 >> 2] | 0) != 5; else n = 0;
	                        o = c[e >> 2] | 0;
	                        if (!n)break;
	                        Ve(o) | 0;
	                        c[h >> 2] = d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0]
	                    }
	                    if ((d[c[(c[o + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                    if ((c[h >> 2] | 0) < 256) {
	                        if ((c[h >> 2] | 0) != 32 ? !(9 <= (c[h >> 2] | 0) & (c[h >> 2] | 0) <= 10) : 0)p = (c[h >> 2] | 0) == 13; else p = 1;
	                        q = p & 1
	                    } else q = 0
	                } while ((q | 0) != 0);
	                m = c[f >> 2] | 0;
	                i = b;
	                return m | 0
	            }

	            function Ve(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                c[h >> 2] = b;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) > 1 : 0) {
	                    if (c[33952] | 0) {
	                        b = c[33976] | 0;
	                        j = c[33980] | 0;
	                        c[f >> 2] = c[(c[h >> 2] | 0) + 40 >> 2];
	                        Db[b & 511](j, 65288, f)
	                    }
	                    te(Pe(c[h >> 2] | 0) | 0);
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[h >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0) {
	                        a[g >> 0] = Ve(c[h >> 2] | 0) | 0;
	                        k = a[g >> 0] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    a[g >> 0] = a[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    k = a[g >> 0] | 0;
	                    i = e;
	                    return k | 0
	                }
	                a[g >> 0] = 0;
	                k = a[g >> 0] | 0;
	                i = e;
	                return k | 0
	            }

	            function We(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 24 | 0;
	                m = e + 4 | 0;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 37) {
	                    i = e;
	                    return
	                }
	                switch (c[(c[g >> 2] | 0) + 172 >> 2] | 0) {
	                    case 14:
	                    {
	                        og(c[g >> 2] | 0, 20, 0);
	                        i = e;
	                        return
	                    }
	                    case 3:
	                    {
	                        if ((c[(c[g >> 2] | 0) + 96 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                            i = e;
	                            return
	                        }
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 32) {
	                            i = e;
	                            return
	                        }
	                        if (9 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) <= 10 : 0) {
	                            i = e;
	                            return
	                        }
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 13) {
	                            i = e;
	                            return
	                        }
	                        if (!(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0)) {
	                            i = e;
	                            return
	                        }
	                        break
	                    }
	                    case 15:
	                    case 11:
	                    case 16:
	                    case 13:
	                    case 2:
	                    case 12:
	                    case 7:
	                    case 10:
	                    case 9:
	                    case 6:
	                    case 5:
	                    case 8:
	                    {
	                        i = e;
	                        return
	                    }
	                    case 1:
	                    case 0:
	                    case 4:
	                    {
	                        og(c[g >> 2] | 0, 19, 0);
	                        i = e;
	                        return
	                    }
	                    case -1:
	                    {
	                        og(c[g >> 2] | 0, 18, 0);
	                        i = e;
	                        return
	                    }
	                    default:
	                    {
	                    }
	                }
	                me(c[g >> 2] | 0);
	                c[h >> 2] = Ze(c[g >> 2] | 0) | 0;
	                if (c[33952] | 0) {
	                    b = c[33976] | 0;
	                    n = c[33980] | 0;
	                    c[f >> 2] = c[h >> 2];
	                    Db[b & 511](n, 65408, f)
	                }
	                f = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    og(f, 24, 0);
	                    i = e;
	                    return
	                }
	                n = c[g >> 2] | 0;
	                if ((d[c[(c[f + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 59) {
	                    og(n, 25, 0);
	                    i = e;
	                    return
	                }
	                me(n);
	                if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 96 >> 2] | 0) != 0 : 0)c[j >> 2] = Hb[c[(c[c[g >> 2] >> 2] | 0) + 96 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = e;
	                    return
	                }
	                n = c[g >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    do if ((c[n + 28 >> 2] | 0) == 1)o = 26; else {
	                        if ((c[(c[g >> 2] | 0) + 88 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 92 >> 2] | 0) == 0 : 0) {
	                            o = 26;
	                            break
	                        }
	                        if ((c[(c[g >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 112 >> 2] | 0) != 0 : 0)qg(c[g >> 2] | 0, 27, 65432, c[h >> 2] | 0, 0); else rg(c[g >> 2] | 0, 27, 65432, c[h >> 2] | 0, 0);
	                        c[(c[g >> 2] | 0) + 100 >> 2] = 0
	                    } while (0);
	                    if ((o | 0) == 26)pg(c[g >> 2] | 0, 26, 65432, c[h >> 2] | 0);
	                    sg(c[g >> 2] | 0, 0, 0, 0) | 0;
	                    i = e;
	                    return
	                }
	                if ((c[(c[n + 36 >> 2] | 0) + 40 >> 2] | 0) != 226) {
	                    c[k >> 2] = ug(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    Xe(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 4 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 5 : 0) {
	                    pg(c[g >> 2] | 0, 30, 65464, c[h >> 2] | 0);
	                    i = e;
	                    return
	                }
	                if (((((((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 5 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 2 | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 360 >> 2] & 16 | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 360 >> 2] & 4 | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 360 >> 2] & 8 | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 104 >> 2] | 0) == 0 : 0) {
	                    i = e;
	                    return
	                }
	                c[k >> 2] = we(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                if ((Xe(c[g >> 2] | 0, c[k >> 2] | 0) | 0) < 0) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = e;
	                    return
	                }
	                if (((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 ? (a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0, a[l + 1 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0, a[l + 2 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0, a[l + 3 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0, c[m >> 2] = sd(l, 4) | 0, (c[m >> 2] | 0) != 0) : 0)re(c[g >> 2] | 0, c[m >> 2] | 0) | 0;
	                if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 5) {
	                    i = e;
	                    return
	                }
	                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 63) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 120) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 109) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 108) {
	                    i = e;
	                    return
	                }
	                do if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 13)break;
	                    i = e;
	                    return
	                } while (0);
	                _e(c[g >> 2] | 0);
	                i = e;
	                return
	            }

	            function Xe(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (c[33952] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        l = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0;
	                        c[e >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                        c[e + 4 >> 2] = l;
	                        Db[b & 511](a, 65312, e)
	                    }
	                    a = c[33976] | 0;
	                    b = c[33980] | 0;
	                    l = c[(c[h >> 2] | 0) + 16 >> 2] | 0;
	                    c[e >> 2] = (c[(c[g >> 2] | 0) + 40 >> 2] | 0) + 1;
	                    c[e + 4 >> 2] = l;
	                    Db[a & 511](b, 65328, e)
	                }
	                c[j >> 2] = Oe(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                c[f >> 2] = c[j >> 2];
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function Ye(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                if (((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 38 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) {
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 3;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 3;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 3;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                    a:while (1) {
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 59)break;
	                        a = c[h >> 2] | 0;
	                        c[h >> 2] = a + 1;
	                        if ((a | 0) > 20) {
	                            c[h >> 2] = 0;
	                            if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                            if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                k = 18;
	                                break
	                            }
	                        }
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 57 : 0)c[g >> 2] = (c[g >> 2] << 4) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 48); else k = 22;
	                        do if ((k | 0) == 22) {
	                            k = 0;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) >= 97 ? ((c[h >> 2] | 0) < 20 ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 102 : 0) : 0) {
	                                c[g >> 2] = (c[g >> 2] << 4) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 97) + 10;
	                                break
	                            }
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) < 65) {
	                                k = 28;
	                                break a
	                            }
	                            if (!((c[h >> 2] | 0) < 20 ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 70 : 0)) {
	                                k = 28;
	                                break a
	                            }
	                            c[g >> 2] = (c[g >> 2] << 4) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 65) + 10
	                        } while (0);
	                        if ((c[g >> 2] | 0) >>> 0 > 1114111)c[j >> 2] = c[g >> 2];
	                        me(c[f >> 2] | 0);
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    if ((k | 0) == 18) {
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    } else if ((k | 0) == 28) {
	                        og(c[f >> 2] | 0, 6, 0);
	                        c[g >> 2] = 0
	                    }
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 59) {
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        a = (c[f >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                } else k = 34;
	                do if ((k | 0) == 34) {
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 38 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) {
	                        a = (c[f >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 2;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 2;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 2;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                        if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                        while (1) {
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 59)break;
	                            a = c[h >> 2] | 0;
	                            c[h >> 2] = a + 1;
	                            if ((a | 0) > 20) {
	                                c[h >> 2] = 0;
	                                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    k = 50;
	                                    break
	                                }
	                            }
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) < 48) {
	                                k = 54;
	                                break
	                            }
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) > 57) {
	                                k = 54;
	                                break
	                            }
	                            c[g >> 2] = ((c[g >> 2] | 0) * 10 | 0) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 48);
	                            if ((c[g >> 2] | 0) >>> 0 > 1114111)c[j >> 2] = c[g >> 2];
	                            me(c[f >> 2] | 0);
	                            c[h >> 2] = (c[h >> 2] | 0) + 1
	                        }
	                        if ((k | 0) == 50) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        } else if ((k | 0) == 54) {
	                            og(c[f >> 2] | 0, 7, 0);
	                            c[g >> 2] = 0
	                        }
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 59)break;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        a = (c[f >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        break
	                    }
	                    og(c[f >> 2] | 0, 8, 0)
	                } while (0);
	                h = c[g >> 2] | 0;
	                do if ((c[g >> 2] | 0) >>> 0 < 256)if ((9 <= h >>> 0 & (c[g >> 2] | 0) >>> 0 <= 10 | (c[g >> 2] | 0) == 13 | 32 <= (c[g >> 2] | 0) >>> 0) & (c[j >> 2] | 0) == 0)k = 66; else k = 67; else {
	                    if (!(256 <= h >>> 0 & (c[g >> 2] | 0) >>> 0 <= 55295) ? !(57344 <= (c[g >> 2] | 0) >>> 0 & (c[g >> 2] | 0) >>> 0 <= 65533) : 0)if (65536 <= (c[g >> 2] | 0) >>> 0 & (c[g >> 2] | 0) >>> 0 <= 1114111 & (c[j >> 2] | 0) == 0) {
	                        k = 66;
	                        break
	                    } else {
	                        k = 67;
	                        break
	                    }
	                    if (!(c[j >> 2] | 0))k = 66; else k = 67
	                } while (0);
	                if ((k | 0) == 66) {
	                    c[e >> 2] = c[g >> 2];
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } else if ((k | 0) == 67) {
	                    ng(c[f >> 2] | 0, 9, 65360, c[g >> 2] | 0);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                return 0
	            }

	            function Ze(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)k = 10; else k = 6;
	                do if ((k | 0) == 6) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        k = 10;
	                        break
	                    }
	                    if (!((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0))k = 10
	                } while (0);
	                if ((k | 0) == 10) {
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)l = 1; else k = 13;
	                        do if ((k | 0) == 13) {
	                            k = 0;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                                l = 1;
	                                break
	                            }
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                l = 1;
	                                break
	                            }
	                            if (((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) == 46; else l = 1
	                        } while (0);
	                        m = c[g >> 2] | 0;
	                        if (!l)break;
	                        c[g >> 2] = m + 1
	                    }
	                    if ((d[m >> 0] | 0 | 0) > 0 ? (d[c[g >> 2] >> 0] | 0 | 0) < 128 : 0) {
	                        c[j >> 2] = (c[g >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                        if ((c[j >> 2] | 0) > 5e4 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            og(c[f >> 2] | 0, 110, 65688);
	                            c[e >> 2] = 0;
	                            n = c[e >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        }
	                        c[h >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        g = (c[f >> 2] | 0) + 200 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[j >> 2] | 0);
	                        g = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[j >> 2] | 0);
	                        if (!(c[h >> 2] | 0))ie(c[f >> 2] | 0, 0);
	                        c[e >> 2] = c[h >> 2];
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                }
	                c[e >> 2] = wg(c[f >> 2] | 0) | 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function _e(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                a:do if (((((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 108 : 0) {
	                    do if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    a = (c[e >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 5;
	                    a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 5;
	                    a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 5;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                    do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[e >> 2] | 0, 65, 68456)
	                    } while (0);
	                    Ue(c[e >> 2] | 0) | 0;
	                    c[f >> 2] = Af(c[e >> 2] | 0) | 0;
	                    do if (c[f >> 2] | 0) {
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[e >> 2] | 0, 65, 68496)
	                        }
	                    } else c[f >> 2] = oy(68488) | 0; while (0);
	                    c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 48 >> 2] = c[f >> 2];
	                    c[g >> 2] = Bf(c[e >> 2] | 0) | 0;
	                    if ((c[(c[e >> 2] | 0) + 84 >> 2] | 0) == 32) {
	                        i = b;
	                        return
	                    }
	                    if ((c[g >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 84 >> 2] | 0) == 0 : 0)xg(c[e >> 2] | 0, 101, 68520);
	                    Ue(c[e >> 2] | 0) | 0;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 63 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                        a = (c[e >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 2;
	                        a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 2;
	                        a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 2;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                        if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                            i = b;
	                            return
	                        }
	                        if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                            i = b;
	                            return
	                        }
	                        Ve(c[e >> 2] | 0) | 0;
	                        i = b;
	                        return
	                    }
	                    a = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62;
	                    og(c[e >> 2] | 0, 57, 0);
	                    if (a) {
	                        me(c[e >> 2] | 0);
	                        i = b;
	                        return
	                    }
	                    while (1) {
	                        if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)h = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62; else h = 0;
	                        j = c[e >> 2] | 0;
	                        if (!h)break;
	                        a = (c[j + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    me(j);
	                    i = b;
	                    return
	                } while (0);
	                og(c[e >> 2] | 0, 56, 0);
	                i = b;
	                return
	            }

	            function $e(b, e, f, g, h, j, k) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0;
	                l = i;
	                i = i + 128 | 0;
	                m = l;
	                n = l + 116 | 0;
	                o = l + 112 | 0;
	                p = l + 108 | 0;
	                q = l + 104 | 0;
	                r = l + 100 | 0;
	                s = l + 122 | 0;
	                t = l + 121 | 0;
	                u = l + 120 | 0;
	                v = l + 96 | 0;
	                w = l + 92 | 0;
	                x = l + 88 | 0;
	                y = l + 84 | 0;
	                z = l + 80 | 0;
	                A = l + 76 | 0;
	                B = l + 72 | 0;
	                C = l + 68 | 0;
	                D = l + 64 | 0;
	                E = l + 60 | 0;
	                F = l + 56 | 0;
	                G = l + 52 | 0;
	                H = l + 48 | 0;
	                I = l + 44 | 0;
	                J = l + 40 | 0;
	                K = l + 36 | 0;
	                L = l + 32 | 0;
	                M = l + 28 | 0;
	                N = l + 24 | 0;
	                O = l + 20 | 0;
	                P = l + 16 | 0;
	                Q = l + 12 | 0;
	                R = l + 8 | 0;
	                S = l + 4 | 0;
	                c[o >> 2] = b;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                a[s >> 0] = h;
	                a[t >> 0] = j;
	                a[u >> 0] = k;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                c[y >> 2] = 0;
	                c[z >> 2] = 0;
	                if ((c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0 | (c[q >> 2] | 0) < 0) {
	                    c[n >> 2] = 0;
	                    T = c[n >> 2] | 0;
	                    i = l;
	                    return T | 0
	                }
	                c[A >> 2] = (c[p >> 2] | 0) + (c[q >> 2] | 0);
	                if (!((c[(c[o >> 2] | 0) + 248 >> 2] | 0) > 40 ? (c[(c[o >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0))U = 5;
	                if ((U | 0) == 5 ? (c[(c[o >> 2] | 0) + 248 >> 2] | 0) <= 1024 : 0) {
	                    c[w >> 2] = 300;
	                    c[v >> 2] = Cb[c[135752 >> 2] & 511](c[w >> 2] | 0) | 0;
	                    a:do if (!(c[v >> 2] | 0))U = 88; else {
	                        if ((c[p >> 2] | 0) >>> 0 < (c[A >> 2] | 0) >>> 0)c[C >> 2] = oe(c[o >> 2] | 0, c[p >> 2] | 0, D) | 0; else c[C >> 2] = 0;
	                        while (1) {
	                            if (!(c[C >> 2] | 0))break;
	                            if ((c[C >> 2] | 0) == (d[s >> 0] | 0 | 0))break;
	                            if ((c[C >> 2] | 0) == (d[t >> 0] | 0 | 0))break;
	                            if ((c[C >> 2] | 0) == 0 ? 1 : (c[C >> 2] | 0) == (d[u >> 0] | 0 | 0))break;
	                            if ((c[C >> 2] | 0) == 38 ? (d[(c[p >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) {
	                                c[E >> 2] = yg(c[o >> 2] | 0, p) | 0;
	                                if (c[E >> 2] | 0) {
	                                    q = pe((c[v >> 2] | 0) + (c[x >> 2] | 0) | 0, c[E >> 2] | 0) | 0;
	                                    c[x >> 2] = (c[x >> 2] | 0) + q
	                                }
	                                if (((c[x >> 2] | 0) + 100 | 0) >>> 0 > (c[w >> 2] | 0) >>> 0) {
	                                    c[G >> 2] = (c[w >> 2] << 1) + 100;
	                                    if ((c[G >> 2] | 0) >>> 0 < (c[w >> 2] | 0) >>> 0) {
	                                        U = 88;
	                                        break a
	                                    }
	                                    c[F >> 2] = Hb[c[135760 >> 2] & 511](c[v >> 2] | 0, c[G >> 2] | 0) | 0;
	                                    if (!(c[F >> 2] | 0)) {
	                                        U = 88;
	                                        break a
	                                    }
	                                    c[v >> 2] = c[F >> 2];
	                                    c[w >> 2] = c[G >> 2]
	                                }
	                            } else U = 23;
	                            b:do if ((U | 0) == 23) {
	                                U = 0;
	                                if ((c[C >> 2] | 0) == 38 ? (c[r >> 2] & 1 | 0) != 0 : 0) {
	                                    if (c[33952] | 0) {
	                                        q = c[33976] | 0;
	                                        k = c[33980] | 0;
	                                        c[m >> 2] = c[p >> 2];
	                                        Db[q & 511](k, 65512, m)
	                                    }
	                                    c[B >> 2] = zg(c[o >> 2] | 0, p) | 0;
	                                    if ((c[(c[o >> 2] | 0) + 388 >> 2] | 0) == 89)break a;
	                                    if ((c[(c[o >> 2] | 0) + 388 >> 2] | 0) == 1)break a;
	                                    sg(c[o >> 2] | 0, 0, c[B >> 2] | 0, 0) | 0;
	                                    if (c[B >> 2] | 0) {
	                                        k = (c[o >> 2] | 0) + 440 | 0;
	                                        c[k >> 2] = (c[k >> 2] | 0) + ((c[(c[B >> 2] | 0) + 72 >> 2] | 0) / 2 | 0)
	                                    }
	                                    do if (c[B >> 2] | 0) {
	                                        if ((c[(c[B >> 2] | 0) + 48 >> 2] | 0) != 6)break;
	                                        if (!(c[(c[B >> 2] | 0) + 40 >> 2] | 0)) {
	                                            xg(c[o >> 2] | 0, 1, 65560);
	                                            break b
	                                        }
	                                        k = pe((c[v >> 2] | 0) + (c[x >> 2] | 0) | 0, d[c[(c[B >> 2] | 0) + 40 >> 2] >> 0] | 0) | 0;
	                                        c[x >> 2] = (c[x >> 2] | 0) + k;
	                                        if (((c[x >> 2] | 0) + 100 | 0) >>> 0 <= (c[w >> 2] | 0) >>> 0)break b;
	                                        c[I >> 2] = (c[w >> 2] << 1) + 100;
	                                        if ((c[I >> 2] | 0) >>> 0 < (c[w >> 2] | 0) >>> 0) {
	                                            U = 88;
	                                            break a
	                                        }
	                                        c[H >> 2] = Hb[c[135760 >> 2] & 511](c[v >> 2] | 0, c[I >> 2] | 0) | 0;
	                                        if (!(c[H >> 2] | 0)) {
	                                            U = 88;
	                                            break a
	                                        }
	                                        c[v >> 2] = c[H >> 2];
	                                        c[w >> 2] = c[I >> 2];
	                                        break b
	                                    } while (0);
	                                    do if (c[B >> 2] | 0) {
	                                        if (!(c[(c[B >> 2] | 0) + 40 >> 2] | 0))break;
	                                        k = (c[o >> 2] | 0) + 248 | 0;
	                                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                        c[z >> 2] = af(c[o >> 2] | 0, c[(c[B >> 2] | 0) + 40 >> 2] | 0, c[r >> 2] | 0, 0, 0, 0) | 0;
	                                        k = (c[o >> 2] | 0) + 248 | 0;
	                                        c[k >> 2] = (c[k >> 2] | 0) + -1;
	                                        if (!(c[z >> 2] | 0))break b;
	                                        c[y >> 2] = c[z >> 2];
	                                        while (1) {
	                                            if (!(d[c[y >> 2] >> 0] | 0))break;
	                                            k = c[y >> 2] | 0;
	                                            c[y >> 2] = k + 1;
	                                            q = a[k >> 0] | 0;
	                                            k = c[x >> 2] | 0;
	                                            c[x >> 2] = k + 1;
	                                            a[(c[v >> 2] | 0) + k >> 0] = q;
	                                            if (((c[x >> 2] | 0) + 100 | 0) >>> 0 <= (c[w >> 2] | 0) >>> 0)continue;
	                                            if (sg(c[o >> 2] | 0, c[x >> 2] | 0, c[B >> 2] | 0, 0) | 0)break a;
	                                            c[K >> 2] = (c[w >> 2] << 1) + 100;
	                                            if ((c[K >> 2] | 0) >>> 0 < (c[w >> 2] | 0) >>> 0) {
	                                                U = 88;
	                                                break a
	                                            }
	                                            c[J >> 2] = Hb[c[135760 >> 2] & 511](c[v >> 2] | 0, c[K >> 2] | 0) | 0;
	                                            if (!(c[J >> 2] | 0)) {
	                                                U = 88;
	                                                break a
	                                            }
	                                            c[v >> 2] = c[J >> 2];
	                                            c[w >> 2] = c[K >> 2]
	                                        }
	                                        zb[c[135736 >> 2] & 511](c[z >> 2] | 0);
	                                        c[z >> 2] = 0;
	                                        break b
	                                    } while (0);
	                                    if (!(c[B >> 2] | 0))break;
	                                    c[L >> 2] = xy(c[(c[B >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                    c[M >> 2] = c[(c[B >> 2] | 0) + 8 >> 2];
	                                    q = c[x >> 2] | 0;
	                                    c[x >> 2] = q + 1;
	                                    a[(c[v >> 2] | 0) + q >> 0] = 38;
	                                    if (((c[x >> 2] | 0) + (c[L >> 2] | 0) + 100 | 0) >>> 0 > (c[w >> 2] | 0) >>> 0) {
	                                        c[O >> 2] = (c[w >> 2] << 1) + (c[L >> 2] | 0) + 100;
	                                        if ((c[O >> 2] | 0) >>> 0 < (c[w >> 2] | 0) >>> 0) {
	                                            U = 88;
	                                            break a
	                                        }
	                                        c[N >> 2] = Hb[c[135760 >> 2] & 511](c[v >> 2] | 0, c[O >> 2] | 0) | 0;
	                                        if (!(c[N >> 2] | 0)) {
	                                            U = 88;
	                                            break a
	                                        }
	                                        c[v >> 2] = c[N >> 2];
	                                        c[w >> 2] = c[O >> 2]
	                                    }
	                                    while (1) {
	                                        if ((c[L >> 2] | 0) <= 0)break;
	                                        q = c[M >> 2] | 0;
	                                        c[M >> 2] = q + 1;
	                                        k = a[q >> 0] | 0;
	                                        q = c[x >> 2] | 0;
	                                        c[x >> 2] = q + 1;
	                                        a[(c[v >> 2] | 0) + q >> 0] = k;
	                                        c[L >> 2] = (c[L >> 2] | 0) + -1
	                                    }
	                                    k = c[x >> 2] | 0;
	                                    c[x >> 2] = k + 1;
	                                    a[(c[v >> 2] | 0) + k >> 0] = 59;
	                                    break
	                                }
	                                if ((c[C >> 2] | 0) == 37 ? (c[r >> 2] & 2 | 0) != 0 : 0) {
	                                    if (c[33952] | 0) {
	                                        k = c[33976] | 0;
	                                        q = c[33980] | 0;
	                                        c[m >> 2] = c[p >> 2];
	                                        Db[k & 511](q, 65600, m)
	                                    }
	                                    c[B >> 2] = Ag(c[o >> 2] | 0, p) | 0;
	                                    if ((c[(c[o >> 2] | 0) + 388 >> 2] | 0) == 89)break a;
	                                    sg(c[o >> 2] | 0, 0, c[B >> 2] | 0, 0) | 0;
	                                    if (c[B >> 2] | 0) {
	                                        q = (c[o >> 2] | 0) + 440 | 0;
	                                        c[q >> 2] = (c[q >> 2] | 0) + ((c[(c[B >> 2] | 0) + 72 >> 2] | 0) / 2 | 0)
	                                    }
	                                    if (!(c[B >> 2] | 0))break;
	                                    if (!(c[(c[B >> 2] | 0) + 40 >> 2] | 0))Bg(c[o >> 2] | 0, c[B >> 2] | 0) | 0;
	                                    q = (c[o >> 2] | 0) + 248 | 0;
	                                    c[q >> 2] = (c[q >> 2] | 0) + 1;
	                                    c[z >> 2] = af(c[o >> 2] | 0, c[(c[B >> 2] | 0) + 40 >> 2] | 0, c[r >> 2] | 0, 0, 0, 0) | 0;
	                                    q = (c[o >> 2] | 0) + 248 | 0;
	                                    c[q >> 2] = (c[q >> 2] | 0) + -1;
	                                    if (!(c[z >> 2] | 0))break;
	                                    c[y >> 2] = c[z >> 2];
	                                    while (1) {
	                                        if (!(d[c[y >> 2] >> 0] | 0))break;
	                                        q = c[y >> 2] | 0;
	                                        c[y >> 2] = q + 1;
	                                        k = a[q >> 0] | 0;
	                                        q = c[x >> 2] | 0;
	                                        c[x >> 2] = q + 1;
	                                        a[(c[v >> 2] | 0) + q >> 0] = k;
	                                        if (((c[x >> 2] | 0) + 100 | 0) >>> 0 <= (c[w >> 2] | 0) >>> 0)continue;
	                                        if (sg(c[o >> 2] | 0, c[x >> 2] | 0, c[B >> 2] | 0, 0) | 0)break a;
	                                        c[Q >> 2] = (c[w >> 2] << 1) + 100;
	                                        if ((c[Q >> 2] | 0) >>> 0 < (c[w >> 2] | 0) >>> 0) {
	                                            U = 88;
	                                            break a
	                                        }
	                                        c[P >> 2] = Hb[c[135760 >> 2] & 511](c[v >> 2] | 0, c[Q >> 2] | 0) | 0;
	                                        if (!(c[P >> 2] | 0)) {
	                                            U = 88;
	                                            break a
	                                        }
	                                        c[v >> 2] = c[P >> 2];
	                                        c[w >> 2] = c[Q >> 2]
	                                    }
	                                    zb[c[135736 >> 2] & 511](c[z >> 2] | 0);
	                                    c[z >> 2] = 0;
	                                    break
	                                }
	                                if ((c[D >> 2] | 0) == 1) {
	                                    k = c[C >> 2] & 255;
	                                    q = c[x >> 2] | 0;
	                                    c[x >> 2] = q + 1;
	                                    a[(c[v >> 2] | 0) + q >> 0] = k
	                                } else {
	                                    k = pe((c[v >> 2] | 0) + (c[x >> 2] | 0) | 0, c[C >> 2] | 0) | 0;
	                                    c[x >> 2] = (c[x >> 2] | 0) + k
	                                }
	                                c[p >> 2] = (c[p >> 2] | 0) + (c[D >> 2] | 0);
	                                if (((c[x >> 2] | 0) + 100 | 0) >>> 0 > (c[w >> 2] | 0) >>> 0) {
	                                    c[S >> 2] = (c[w >> 2] << 1) + 100;
	                                    if ((c[S >> 2] | 0) >>> 0 < (c[w >> 2] | 0) >>> 0) {
	                                        U = 88;
	                                        break a
	                                    }
	                                    c[R >> 2] = Hb[c[135760 >> 2] & 511](c[v >> 2] | 0, c[S >> 2] | 0) | 0;
	                                    if (!(c[R >> 2] | 0)) {
	                                        U = 88;
	                                        break a
	                                    }
	                                    c[v >> 2] = c[R >> 2];
	                                    c[w >> 2] = c[S >> 2]
	                                }
	                            } while (0);
	                            if ((c[p >> 2] | 0) >>> 0 < (c[A >> 2] | 0) >>> 0) {
	                                c[C >> 2] = oe(c[o >> 2] | 0, c[p >> 2] | 0, D) | 0;
	                                continue
	                            } else {
	                                c[C >> 2] = 0;
	                                continue
	                            }
	                        }
	                        a[(c[v >> 2] | 0) + (c[x >> 2] | 0) >> 0] = 0;
	                        c[n >> 2] = c[v >> 2];
	                        T = c[n >> 2] | 0;
	                        i = l;
	                        return T | 0
	                    } while (0);
	                    if ((U | 0) == 88)ie(c[o >> 2] | 0, 0);
	                    if (c[z >> 2] | 0)zb[c[135736 >> 2] & 511](c[z >> 2] | 0);
	                    if (c[v >> 2] | 0)zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                    c[n >> 2] = 0;
	                    T = c[n >> 2] | 0;
	                    i = l;
	                    return T | 0
	                }
	                og(c[o >> 2] | 0, 89, 0);
	                c[n >> 2] = 0;
	                T = c[n >> 2] | 0;
	                i = l;
	                return T | 0
	            }

	            function af(b, d, e, f, g, h) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 12 | 0;
	                l = j + 8 | 0;
	                m = j + 4 | 0;
	                n = j;
	                o = j + 18 | 0;
	                p = j + 17 | 0;
	                q = j + 16 | 0;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                a[o >> 0] = f;
	                a[p >> 0] = g;
	                a[q >> 0] = h;
	                if ((c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    c[k >> 2] = 0;
	                    r = c[k >> 2] | 0;
	                    i = j;
	                    return r | 0
	                } else {
	                    h = c[l >> 2] | 0;
	                    l = c[m >> 2] | 0;
	                    g = xy(c[m >> 2] | 0) | 0;
	                    c[k >> 2] = $e(h, l, g, c[n >> 2] | 0, a[o >> 0] | 0, a[p >> 0] | 0, a[q >> 0] | 0) | 0;
	                    r = c[k >> 2] | 0;
	                    i = j;
	                    return r | 0
	                }
	                return 0
	            }

	            function bf(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                g = i;
	                i = i + 176 | 0;
	                h = g + 52 | 0;
	                j = g + 48 | 0;
	                k = g + 44 | 0;
	                l = g + 40 | 0;
	                m = g + 56 | 0;
	                n = g + 36 | 0;
	                o = g + 32 | 0;
	                p = g + 28 | 0;
	                q = g + 24 | 0;
	                r = g + 20 | 0;
	                s = g + 16 | 0;
	                t = g + 12 | 0;
	                u = g + 8 | 0;
	                v = g + 4 | 0;
	                w = g;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 100;
	                c[q >> 2] = 0;
	                c[r >> 2] = c[k >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                }
	                c[c[l >> 2] >> 2] = 0;
	                if (!(c[r >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                }
	                if ((d[c[r >> 2] >> 0] | 0 | 0) == 58) {
	                    c[h >> 2] = my(c[k >> 2] | 0) | 0;
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                }
	                f = c[r >> 2] | 0;
	                c[r >> 2] = f + 1;
	                c[s >> 2] = d[f >> 0];
	                while (1) {
	                    if (!((c[s >> 2] | 0) != 0 & (c[s >> 2] | 0) != 58))break;
	                    if ((c[o >> 2] | 0) >= (c[p >> 2] | 0))break;
	                    f = c[s >> 2] & 255;
	                    e = c[o >> 2] | 0;
	                    c[o >> 2] = e + 1;
	                    a[m + e >> 0] = f;
	                    f = c[r >> 2] | 0;
	                    c[r >> 2] = f + 1;
	                    c[s >> 2] = d[f >> 0]
	                }
	                do if ((c[o >> 2] | 0) >= (c[p >> 2] | 0)) {
	                    c[p >> 2] = c[o >> 2] << 1;
	                    c[n >> 2] = Cb[c[135752 >> 2] & 511](c[p >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        ie(c[j >> 2] | 0, 0);
	                        c[h >> 2] = 0;
	                        x = c[h >> 2] | 0;
	                        i = g;
	                        return x | 0
	                    }
	                    eU(c[n >> 2] | 0, m | 0, c[o >> 2] | 0) | 0;
	                    while (1) {
	                        if (c[s >> 2] | 0)y = (c[s >> 2] | 0) != 58; else y = 0;
	                        z = c[o >> 2] | 0;
	                        if (!y) {
	                            A = 23;
	                            break
	                        }
	                        if ((z + 10 | 0) > (c[p >> 2] | 0)) {
	                            c[p >> 2] = c[p >> 2] << 1;
	                            c[t >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[p >> 2] | 0) | 0;
	                            if (!(c[t >> 2] | 0))break;
	                            c[n >> 2] = c[t >> 2]
	                        }
	                        f = c[s >> 2] & 255;
	                        e = c[o >> 2] | 0;
	                        c[o >> 2] = e + 1;
	                        a[(c[n >> 2] | 0) + e >> 0] = f;
	                        f = c[r >> 2] | 0;
	                        c[r >> 2] = f + 1;
	                        c[s >> 2] = d[f >> 0]
	                    }
	                    if ((A | 0) == 23) {
	                        a[(c[n >> 2] | 0) + z >> 0] = 0;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    ie(c[j >> 2] | 0, 0);
	                    c[h >> 2] = 0;
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                } while (0);
	                if ((c[s >> 2] | 0) == 58 ? (d[c[r >> 2] >> 0] | 0 | 0) == 0 : 0) {
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[c[l >> 2] >> 2] = 0;
	                    c[h >> 2] = my(c[k >> 2] | 0) | 0;
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                }
	                if (!(c[n >> 2] | 0))c[q >> 2] = ly(m, c[o >> 2] | 0) | 0; else {
	                    c[q >> 2] = c[n >> 2];
	                    c[n >> 2] = 0;
	                    c[p >> 2] = 100
	                }
	                do if ((c[s >> 2] | 0) == 58) {
	                    c[s >> 2] = d[c[r >> 2] >> 0];
	                    c[c[l >> 2] >> 2] = c[q >> 2];
	                    if (!(c[s >> 2] | 0)) {
	                        c[h >> 2] = ly(65640, 0) | 0;
	                        x = c[h >> 2] | 0;
	                        i = g;
	                        return x | 0
	                    }
	                    c[o >> 2] = 0;
	                    do if (!((c[s >> 2] | 0) >= 97 & (c[s >> 2] | 0) <= 122) ? !((c[s >> 2] | 0) >= 65 & (c[s >> 2] | 0) <= 90 | (c[s >> 2] | 0) == 95 | (c[s >> 2] | 0) == 58) : 0) {
	                        c[v >> 2] = oe(c[j >> 2] | 0, c[r >> 2] | 0, u) | 0;
	                        z = c[v >> 2] | 0;
	                        if ((c[v >> 2] | 0) < 256) {
	                            if (65 <= (z | 0) & (c[v >> 2] | 0) <= 90)break;
	                            if (97 <= (c[v >> 2] | 0) & (c[v >> 2] | 0) <= 122)break;
	                            if (192 <= (c[v >> 2] | 0) & (c[v >> 2] | 0) <= 214)break;
	                            if (216 <= (c[v >> 2] | 0) & (c[v >> 2] | 0) <= 246 | 248 <= (c[v >> 2] | 0))break
	                        } else if (DQ(z, 199744) | 0)break;
	                        z = c[v >> 2] | 0;
	                        if ((c[v >> 2] | 0) < 256) {
	                            if ((z | 0) == 95)break
	                        } else {
	                            if (19968 <= (z | 0) & (c[v >> 2] | 0) <= 40869 | (c[v >> 2] | 0) == 12295)break;
	                            if (!((12321 <= (c[v >> 2] | 0) & (c[v >> 2] | 0) <= 12329 ^ 1) & (c[v >> 2] | 0) != 95))break
	                        }
	                        pg(c[j >> 2] | 0, 202, 65648, c[k >> 2] | 0)
	                    } while (0);
	                    c[r >> 2] = (c[r >> 2] | 0) + 1;
	                    while (1) {
	                        if (!(c[s >> 2] | 0))break;
	                        if ((c[o >> 2] | 0) >= (c[p >> 2] | 0))break;
	                        z = c[s >> 2] & 255;
	                        t = c[o >> 2] | 0;
	                        c[o >> 2] = t + 1;
	                        a[m + t >> 0] = z;
	                        z = c[r >> 2] | 0;
	                        c[r >> 2] = z + 1;
	                        c[s >> 2] = d[z >> 0]
	                    }
	                    do if ((c[o >> 2] | 0) >= (c[p >> 2] | 0)) {
	                        c[p >> 2] = c[o >> 2] << 1;
	                        c[n >> 2] = Cb[c[135752 >> 2] & 511](c[p >> 2] | 0) | 0;
	                        if (!(c[n >> 2] | 0)) {
	                            ie(c[j >> 2] | 0, 0);
	                            c[h >> 2] = 0;
	                            x = c[h >> 2] | 0;
	                            i = g;
	                            return x | 0
	                        }
	                        eU(c[n >> 2] | 0, m | 0, c[o >> 2] | 0) | 0;
	                        while (1) {
	                            B = c[o >> 2] | 0;
	                            if (!(c[s >> 2] | 0)) {
	                                A = 62;
	                                break
	                            }
	                            if ((B + 10 | 0) > (c[p >> 2] | 0)) {
	                                c[p >> 2] = c[p >> 2] << 1;
	                                c[w >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[p >> 2] | 0) | 0;
	                                if (!(c[w >> 2] | 0))break;
	                                c[n >> 2] = c[w >> 2]
	                            }
	                            z = c[s >> 2] & 255;
	                            t = c[o >> 2] | 0;
	                            c[o >> 2] = t + 1;
	                            a[(c[n >> 2] | 0) + t >> 0] = z;
	                            z = c[r >> 2] | 0;
	                            c[r >> 2] = z + 1;
	                            c[s >> 2] = d[z >> 0]
	                        }
	                        if ((A | 0) == 62) {
	                            a[(c[n >> 2] | 0) + B >> 0] = 0;
	                            break
	                        }
	                        ie(c[j >> 2] | 0, 0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[h >> 2] = 0;
	                        x = c[h >> 2] | 0;
	                        i = g;
	                        return x | 0
	                    } while (0);
	                    if (!(c[n >> 2] | 0)) {
	                        c[q >> 2] = ly(m, c[o >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[q >> 2] = c[n >> 2];
	                        break
	                    }
	                } while (0);
	                c[h >> 2] = c[q >> 2];
	                x = c[h >> 2] | 0;
	                i = g;
	                return x | 0
	            }

	            function cf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                e = i;
	                i = i + 144 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 36 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[m >> 2] = 0;
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[l >> 2] = ne(c[g >> 2] | 0, k) | 0;
	                while (1) {
	                    if (!(Cg(c[g >> 2] | 0, c[l >> 2] | 0) | 0)) {
	                        r = 55;
	                        break
	                    }
	                    b = c[m >> 2] | 0;
	                    c[m >> 2] = b + 1;
	                    if (((b | 0) > 100 ? (c[m >> 2] = 0, (c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0) : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    if ((c[k >> 2] | 0) == 1) {
	                        b = c[l >> 2] & 255;
	                        s = c[j >> 2] | 0;
	                        c[j >> 2] = s + 1;
	                        a[h + s >> 0] = b
	                    } else {
	                        b = pe(h + (c[j >> 2] | 0) | 0, c[l >> 2] | 0) | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + b
	                    }
	                    b = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        s = b + 28 | 0;
	                        c[s >> 2] = (c[s >> 2] | 0) + 1;
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        s = b + 32 | 0;
	                        c[s >> 2] = (c[s >> 2] | 0) + 1
	                    }
	                    s = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[s >> 2] = (c[s >> 2] | 0) + (c[k >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    c[l >> 2] = ne(c[g >> 2] | 0, k) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        c[m >> 2] = 0;
	                        if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                        if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            r = 25;
	                            break
	                        }
	                        c[l >> 2] = ne(c[g >> 2] | 0, k) | 0
	                    }
	                    if ((c[j >> 2] | 0) >= 100) {
	                        r = 28;
	                        break
	                    }
	                }
	                if ((r | 0) == 25) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                } else if ((r | 0) == 28) {
	                    c[o >> 2] = c[j >> 2] << 1;
	                    c[n >> 2] = Cb[c[135752 >> 2] & 511](c[o >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        ie(c[g >> 2] | 0, 0);
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    eU(c[n >> 2] | 0, h | 0, c[j >> 2] | 0) | 0;
	                    while (1) {
	                        if (!(Cg(c[g >> 2] | 0, c[l >> 2] | 0) | 0)) {
	                            r = 54;
	                            break
	                        }
	                        s = c[m >> 2] | 0;
	                        c[m >> 2] = s + 1;
	                        if ((s | 0) > 100) {
	                            c[m >> 2] = 0;
	                            if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                r = 37;
	                                break
	                            }
	                        }
	                        if (((c[j >> 2] | 0) + 10 | 0) > (c[o >> 2] | 0)) {
	                            if ((c[o >> 2] | 0) > 5e4 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                                r = 41;
	                                break
	                            }
	                            c[o >> 2] = c[o >> 2] << 1;
	                            c[p >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[p >> 2] | 0)) {
	                                r = 43;
	                                break
	                            }
	                            c[n >> 2] = c[p >> 2]
	                        }
	                        if ((c[k >> 2] | 0) == 1) {
	                            s = c[l >> 2] & 255;
	                            b = c[j >> 2] | 0;
	                            c[j >> 2] = b + 1;
	                            a[(c[n >> 2] | 0) + b >> 0] = s
	                        } else {
	                            s = pe((c[n >> 2] | 0) + (c[j >> 2] | 0) | 0, c[l >> 2] | 0) | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + s
	                        }
	                        s = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            b = s + 28 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1;
	                            c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            b = s + 32 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1
	                        }
	                        b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + (c[k >> 2] | 0);
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                        c[l >> 2] = ne(c[g >> 2] | 0, k) | 0
	                    }
	                    if ((r | 0) == 37) {
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    } else if ((r | 0) == 41) {
	                        og(c[g >> 2] | 0, 110, 65696);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    } else if ((r | 0) == 43) {
	                        ie(c[g >> 2] | 0, 0);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    } else if ((r | 0) == 54) {
	                        a[(c[n >> 2] | 0) + (c[j >> 2] | 0) >> 0] = 0;
	                        c[f >> 2] = c[n >> 2];
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                } else if ((r | 0) == 55) {
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    if ((c[j >> 2] | 0) > 5e4 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                        og(c[g >> 2] | 0, 110, 65696);
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                    c[f >> 2] = ly(h, c[j >> 2] | 0) | 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                return 0
	            }

	            function df(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                h = f + 44 | 0;
	                j = f + 40 | 0;
	                k = f + 36 | 0;
	                l = f + 32 | 0;
	                m = f + 28 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 53 | 0;
	                q = f + 16 | 0;
	                r = f + 12 | 0;
	                s = f + 8 | 0;
	                t = f + 4 | 0;
	                u = f;
	                v = f + 52 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 100;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                do if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34)a[p >> 0] = 34; else {
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39) {
	                        a[p >> 0] = 39;
	                        break
	                    }
	                    og(c[h >> 2] | 0, 36, 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                } while (0);
	                c[k >> 2] = Cb[c[135752 >> 2] & 511](c[m >> 2] | 0) | 0;
	                e = c[h >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    ie(e, 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[e + 172 >> 2] = 11;
	                c[s >> 2] = c[(c[h >> 2] | 0) + 36 >> 2];
	                if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                me(c[h >> 2] | 0);
	                c[n >> 2] = ne(c[h >> 2] | 0, o) | 0;
	                while (1) {
	                    e = c[n >> 2] | 0;
	                    if ((c[n >> 2] | 0) < 256)if (9 <= (e | 0) & (c[n >> 2] | 0) <= 10 | (c[n >> 2] | 0) == 13 | 32 <= (c[n >> 2] | 0))x = 19; else y = 0; else if ((!(256 <= (e | 0) & (c[n >> 2] | 0) <= 55295) ? !(57344 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 1114111) : 0)y = 0; else x = 19;
	                    do if ((x | 0) == 19) {
	                        x = 0;
	                        if ((c[n >> 2] | 0) == (d[p >> 0] | 0 | 0) ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) == (c[s >> 2] | 0) : 0) {
	                            y = 0;
	                            break
	                        }
	                        y = (c[(c[h >> 2] | 0) + 172 >> 2] | 0) != -1
	                    } while (0);
	                    z = c[l >> 2] | 0;
	                    if (!y)break;
	                    if ((z + 5 | 0) >= (c[m >> 2] | 0)) {
	                        c[m >> 2] = c[m >> 2] << 1;
	                        c[t >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                        if (!(c[t >> 2] | 0)) {
	                            x = 25;
	                            break
	                        }
	                        c[k >> 2] = c[t >> 2]
	                    }
	                    if ((c[o >> 2] | 0) == 1) {
	                        e = c[n >> 2] & 255;
	                        b = c[l >> 2] | 0;
	                        c[l >> 2] = b + 1;
	                        a[(c[k >> 2] | 0) + b >> 0] = e
	                    } else {
	                        e = pe((c[k >> 2] | 0) + (c[l >> 2] | 0) | 0, c[n >> 2] | 0) | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + e
	                    }
	                    e = c[(c[h >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        b = e + 28 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        b = e + 32 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1
	                    }
	                    b = (c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + (c[o >> 2] | 0);
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[h >> 2] | 0);
	                    while (1) {
	                        if (!(d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))A = (c[(c[h >> 2] | 0) + 40 >> 2] | 0) > 1; else A = 0;
	                        B = c[h >> 2] | 0;
	                        if (!A)break;
	                        Ve(B) | 0
	                    }
	                    if ((c[B + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                    c[n >> 2] = ne(c[h >> 2] | 0, o) | 0;
	                    if (c[n >> 2] | 0)continue;
	                    if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                    c[n >> 2] = ne(c[h >> 2] | 0, o) | 0
	                }
	                if ((x | 0) == 25) {
	                    ie(c[h >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                a[(c[k >> 2] | 0) + z >> 0] = 0;
	                if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[r >> 2] = c[k >> 2];
	                while (1) {
	                    if (!(d[c[r >> 2] >> 0] | 0))break;
	                    if ((d[c[r >> 2] >> 0] | 0 | 0) != 37) {
	                        if ((d[c[r >> 2] >> 0] | 0 | 0) == 38 ? (d[(c[r >> 2] | 0) + 1 >> 0] | 0 | 0) != 35 : 0)x = 54
	                    } else x = 54;
	                    if ((x | 0) == 54) {
	                        x = 0;
	                        a[v >> 0] = a[c[r >> 2] >> 0] | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        c[u >> 2] = Dg(c[h >> 2] | 0, r) | 0;
	                        if (!((c[u >> 2] | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) == 59 : 0))ng(c[h >> 2] | 0, 87, 65704, d[v >> 0] | 0);
	                        if (((d[v >> 0] | 0 | 0) == 37 ? (c[(c[h >> 2] | 0) + 216 >> 2] | 0) == 1 : 0) ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) == 1 : 0)og(c[h >> 2] | 0, 88, 0);
	                        if (c[u >> 2] | 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                        if (!(d[c[r >> 2] >> 0] | 0))break
	                    }
	                    c[r >> 2] = (c[r >> 2] | 0) + 1
	                }
	                r = c[h >> 2] | 0;
	                do if ((c[n >> 2] | 0) == (d[p >> 0] | 0 | 0)) {
	                    me(r);
	                    c[q >> 2] = af(c[h >> 2] | 0, c[k >> 2] | 0, 2, 0, 0, 0) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[c[j >> 2] >> 2] = c[k >> 2];
	                        break
	                    } else {
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        break
	                    }
	                } else {
	                    og(r, 37, 0);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                } while (0);
	                c[g >> 2] = c[q >> 2];
	                w = c[g >> 2] | 0;
	                i = f;
	                return w | 0
	            }

	            function ef(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = Eg(c[e >> 2] | 0, 0, 0, 0) | 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function ff(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 40 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 100;
	                c[o >> 2] = c[(c[g >> 2] | 0) + 172 >> 2];
	                c[p >> 2] = 0;
	                if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                b = c[g >> 2] | 0;
	                do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                    me(b);
	                    a[n >> 0] = 34
	                } else {
	                    r = c[g >> 2] | 0;
	                    if ((d[c[(c[b + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39) {
	                        me(r);
	                        a[n >> 0] = 39;
	                        break
	                    }
	                    og(r, 43, 0);
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                } while (0);
	                c[h >> 2] = Cb[c[135752 >> 2] & 511](c[k >> 2] | 0) | 0;
	                b = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    ie(b, 0);
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                c[b + 172 >> 2] = 13;
	                c[l >> 2] = ne(c[g >> 2] | 0, m) | 0;
	                while (1) {
	                    b = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 256)if (9 <= (b | 0) & (c[l >> 2] | 0) <= 10 | (c[l >> 2] | 0) == 13 | 32 <= (c[l >> 2] | 0))t = 18; else u = 0; else if ((!(256 <= (b | 0) & (c[l >> 2] | 0) <= 55295) ? !(57344 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 1114111) : 0)u = 0; else t = 18;
	                    if ((t | 0) == 18) {
	                        t = 0;
	                        u = (c[l >> 2] | 0) != (d[n >> 0] | 0 | 0)
	                    }
	                    v = c[j >> 2] | 0;
	                    if (!u) {
	                        t = 50;
	                        break
	                    }
	                    if ((v + 5 | 0) >= (c[k >> 2] | 0)) {
	                        if ((c[k >> 2] | 0) > 5e4 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            t = 23;
	                            break
	                        }
	                        c[k >> 2] = c[k >> 2] << 1;
	                        c[q >> 2] = Hb[c[135760 >> 2] & 511](c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            t = 25;
	                            break
	                        }
	                        c[h >> 2] = c[q >> 2]
	                    }
	                    c[p >> 2] = (c[p >> 2] | 0) + 1;
	                    if ((c[p >> 2] | 0) > 50) {
	                        if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                        c[p >> 2] = 0;
	                        if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            t = 32;
	                            break
	                        }
	                    }
	                    if ((c[m >> 2] | 0) == 1) {
	                        b = c[l >> 2] & 255;
	                        r = c[j >> 2] | 0;
	                        c[j >> 2] = r + 1;
	                        a[(c[h >> 2] | 0) + r >> 0] = b
	                    } else {
	                        b = pe((c[h >> 2] | 0) + (c[j >> 2] | 0) | 0, c[l >> 2] | 0) | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + b
	                    }
	                    b = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        r = b + 28 | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        r = b + 32 | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                    r = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[r >> 2] = (c[r >> 2] | 0) + (c[m >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    c[l >> 2] = ne(c[g >> 2] | 0, m) | 0;
	                    if (c[l >> 2] | 0)continue;
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                    c[l >> 2] = ne(c[g >> 2] | 0, m) | 0
	                }
	                if ((t | 0) == 23) {
	                    og(c[g >> 2] | 0, 110, 65768);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 172 >> 2] = c[o >> 2];
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                } else if ((t | 0) == 25) {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    ie(c[g >> 2] | 0, 0);
	                    c[(c[g >> 2] | 0) + 172 >> 2] = c[o >> 2];
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                } else if ((t | 0) == 32) {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                } else if ((t | 0) == 50) {
	                    a[(c[h >> 2] | 0) + v >> 0] = 0;
	                    c[(c[g >> 2] | 0) + 172 >> 2] = c[o >> 2];
	                    o = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 256)if (9 <= (o | 0) & (c[l >> 2] | 0) <= 10 | (c[l >> 2] | 0) == 13 | 32 <= (c[l >> 2] | 0))t = 56; else t = 55; else if ((!(256 <= (o | 0) & (c[l >> 2] | 0) <= 55295) ? !(57344 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 1114111) : 0)t = 55; else t = 56;
	                    if ((t | 0) == 55)og(c[g >> 2] | 0, 44, 0); else if ((t | 0) == 56)me(c[g >> 2] | 0);
	                    c[f >> 2] = c[h >> 2];
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                return 0
	            }

	            function gf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 33 | 0;
	                m = e + 32 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 100;
	                c[n >> 2] = 0;
	                c[o >> 2] = c[(c[g >> 2] | 0) + 172 >> 2];
	                if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                b = c[g >> 2] | 0;
	                do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                    me(b);
	                    a[m >> 0] = 34
	                } else {
	                    q = c[g >> 2] | 0;
	                    if ((d[c[(c[b + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39) {
	                        me(q);
	                        a[m >> 0] = 39;
	                        break
	                    }
	                    og(q, 43, 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } while (0);
	                c[h >> 2] = Cb[c[135752 >> 2] & 511](c[k >> 2] | 0) | 0;
	                b = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    ie(b, 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[b + 172 >> 2] = 16;
	                a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                while (1) {
	                    if (d[198696 + (d[l >> 0] | 0) >> 0] | 0)s = (d[l >> 0] | 0 | 0) != (d[m >> 0] | 0 | 0); else s = 0;
	                    t = c[j >> 2] | 0;
	                    if (!s) {
	                        u = 38;
	                        break
	                    }
	                    if ((t + 1 | 0) >= (c[k >> 2] | 0)) {
	                        if ((c[k >> 2] | 0) > 5e4 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            u = 19;
	                            break
	                        }
	                        c[k >> 2] = c[k >> 2] << 1;
	                        c[p >> 2] = Hb[c[135760 >> 2] & 511](c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            u = 21;
	                            break
	                        }
	                        c[h >> 2] = c[p >> 2]
	                    }
	                    b = a[l >> 0] | 0;
	                    q = c[j >> 2] | 0;
	                    c[j >> 2] = q + 1;
	                    a[(c[h >> 2] | 0) + q >> 0] = b;
	                    c[n >> 2] = (c[n >> 2] | 0) + 1;
	                    if ((c[n >> 2] | 0) > 50) {
	                        if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                        c[n >> 2] = 0;
	                        if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            u = 28;
	                            break
	                        }
	                    }
	                    me(c[g >> 2] | 0);
	                    a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    if (d[l >> 0] | 0)continue;
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                    a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0
	                }
	                if ((u | 0) == 19) {
	                    og(c[g >> 2] | 0, 110, 65784);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((u | 0) == 21) {
	                    ie(c[g >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((u | 0) == 28) {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((u | 0) == 38) {
	                    a[(c[h >> 2] | 0) + t >> 0] = 0;
	                    t = c[g >> 2] | 0;
	                    if ((d[l >> 0] | 0 | 0) != (d[m >> 0] | 0 | 0))og(t, 44, 0); else me(t);
	                    c[(c[g >> 2] | 0) + 172 >> 2] = c[o >> 2];
	                    c[f >> 2] = c[h >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                return 0
	            }

	            function hf(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                c[k >> 2] = 0;
	                c[l >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                c[m >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2];
	                if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                do if (!(c[h >> 2] | 0)) {
	                    c[j >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    a:while (1) {
	                        e = c[j >> 2] | 0;
	                        if ((d[c[j >> 2] >> 0] | 0) == 32) {
	                            c[j >> 2] = e + 1;
	                            b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1;
	                            continue
	                        }
	                        if ((d[e >> 0] | 0) == 10)while (1) {
	                            e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1;
	                            c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            if ((d[c[j >> 2] >> 0] | 0) != 10)continue a
	                        }
	                        if ((d[c[j >> 2] >> 0] | 0) == 60) {
	                            q = 15;
	                            break
	                        }
	                        b:while (1) {
	                            c[n >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2];
	                            while (1) {
	                                if (!(a[65800 + (d[c[j >> 2] >> 0] | 0) >> 0] | 0))break;
	                                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                                c[n >> 2] = (c[n >> 2] | 0) + 1
	                            }
	                            c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = c[n >> 2];
	                            if ((d[c[j >> 2] >> 0] | 0) == 10)while (1) {
	                                e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1;
	                                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                                if ((d[c[j >> 2] >> 0] | 0) != 10)continue b
	                            }
	                            r = c[j >> 2] | 0;
	                            if ((d[c[j >> 2] >> 0] | 0) != 93)break;
	                            if ((d[r + 1 >> 0] | 0) == 93 ? (d[(c[j >> 2] | 0) + 2 >> 0] | 0) == 62 : 0) {
	                                q = 36;
	                                break a
	                            }
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        }
	                        c[k >> 2] = r - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                        if ((c[k >> 2] | 0) > 0) {
	                            c:do if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] | 0) != (c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0) : 0) {
	                                do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 32) {
	                                    if (9 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) <= 10 : 0)break;
	                                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 13) {
	                                        q = 53;
	                                        break c
	                                    }
	                                } while (0);
	                                c[p >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                                c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                                e = (Gg(c[g >> 2] | 0, c[p >> 2] | 0, c[k >> 2] | 0, 0) | 0) != 0;
	                                b = c[c[g >> 2] >> 2] | 0;
	                                if (e) {
	                                    if (c[b + 72 >> 2] | 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0, c[k >> 2] | 0)
	                                } else {
	                                    if (c[b + 68 >> 2] | 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0, c[k >> 2] | 0);
	                                    if ((c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] | 0) == -1)c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] = -2
	                                }
	                                c[l >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                                c[m >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2]
	                            } else q = 53; while (0);
	                            if ((q | 0) == 53 ? (q = 0, (c[c[g >> 2] >> 2] | 0) != 0) : 0) {
	                                if (c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0);
	                                c[l >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                                c[m >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2]
	                            }
	                            if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) != 7) {
	                                q = 78;
	                                break
	                            }
	                        }
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                        do if ((d[c[j >> 2] >> 0] | 0) == 13) {
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            b = c[j >> 2] | 0;
	                            if ((d[c[j >> 2] >> 0] | 0) == 10) {
	                                c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = b;
	                                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                                e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1;
	                                break
	                            } else {
	                                c[j >> 2] = b + -1;
	                                q = 62;
	                                break
	                            }
	                        } else q = 62; while (0);
	                        if ((q | 0) == 62) {
	                            q = 0;
	                            if ((d[c[j >> 2] >> 0] | 0) == 60) {
	                                q = 78;
	                                break
	                            }
	                            if ((d[c[j >> 2] >> 0] | 0) == 38) {
	                                q = 78;
	                                break
	                            }
	                            if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                q = 78;
	                                break
	                            }
	                            c[j >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2]
	                        }
	                        if ((d[c[j >> 2] >> 0] | 0) >= 32 ? (d[c[j >> 2] >> 0] | 0) <= 127 : 0)continue;
	                        if ((d[c[j >> 2] >> 0] | 0) != 9) {
	                            q = 76;
	                            break
	                        }
	                    }
	                    if ((q | 0) == 15) {
	                        c[k >> 2] = (c[j >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                        if ((c[k >> 2] | 0) <= 0) {
	                            i = f;
	                            return
	                        }
	                        c[o >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                        if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] | 0) != (c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0) : 0) {
	                            b = (Gg(c[g >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0, 1) | 0) != 0;
	                            e = c[c[g >> 2] >> 2] | 0;
	                            if (b) {
	                                if (!(c[e + 72 >> 2] | 0)) {
	                                    i = f;
	                                    return
	                                }
	                                Db[c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0);
	                                i = f;
	                                return
	                            }
	                            if (c[e + 68 >> 2] | 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0);
	                            if ((c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] | 0) != -1) {
	                                i = f;
	                                return
	                            }
	                            c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] = -2;
	                            i = f;
	                            return
	                        }
	                        if (!(c[c[g >> 2] >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (!(c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0);
	                        i = f;
	                        return
	                    } else if ((q | 0) == 36) {
	                        og(c[g >> 2] | 0, 62, 0);
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                        i = f;
	                        return
	                    } else if ((q | 0) == 76) {
	                        c[k >> 2] = 0;
	                        break
	                    } else if ((q | 0) == 78) {
	                        i = f;
	                        return
	                    }
	                } while (0);
	                c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] = c[l >> 2];
	                c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = c[m >> 2];
	                Hg(c[g >> 2] | 0, c[h >> 2] | 0);
	                i = f;
	                return
	            }

	            function jf(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                if (((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[h >> 2] | 0);
	                c[c[j >> 2] >> 2] = 0;
	                if ((((((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 83 ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 89 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 83 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 77 : 0) {
	                    e = (c[h >> 2] | 0) + 200 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + 6;
	                    e = (c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + 6;
	                    e = (c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + 6;
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[h >> 2] | 0);
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[h >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[h >> 2] | 0) | 0;
	                    do if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[h >> 2] | 0, 65, 66056)
	                    } while (0);
	                    Ue(c[h >> 2] | 0) | 0;
	                    c[l >> 2] = ff(c[h >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0))og(c[h >> 2] | 0, 70, 0)
	                } else n = 23;
	                if (((((((n | 0) == 23 ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 80 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 85 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 66 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 76 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 67 : 0) {
	                    n = (c[h >> 2] | 0) + 200 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + 6;
	                    n = (c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + 6;
	                    n = (c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + 6;
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[h >> 2] | 0);
	                    if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[h >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[h >> 2] | 0) | 0;
	                    do if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[h >> 2] | 0, 65, 66088)
	                    } while (0);
	                    Ue(c[h >> 2] | 0) | 0;
	                    n = gf(c[h >> 2] | 0) | 0;
	                    c[c[j >> 2] >> 2] = n;
	                    if (!(c[c[j >> 2] >> 2] | 0))og(c[h >> 2] | 0, 71, 0);
	                    j = c[h >> 2] | 0;
	                    do if (c[k >> 2] | 0) {
	                        if ((d[c[(c[j + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[h >> 2] | 0, 65, 66120)
	                        }
	                    } else {
	                        if ((c[j + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                        c[m >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        do if ((d[c[m >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[m >> 2] >> 0] | 0 | 0) ? (d[c[m >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[m >> 2] >> 0] | 0 | 0) != 13) {
	                                c[g >> 2] = 0;
	                                o = c[g >> 2] | 0;
	                                i = f;
	                                return o | 0
	                            }
	                        } while (0);
	                        while (1) {
	                            do if ((d[c[m >> 2] >> 0] | 0 | 0) == 32)p = 1; else {
	                                if (9 <= (d[c[m >> 2] >> 0] | 0 | 0) ? (d[c[m >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    p = 1;
	                                    break
	                                }
	                                p = (d[c[m >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            q = c[m >> 2] | 0;
	                            if (!p)break;
	                            c[m >> 2] = q + 1
	                        }
	                        if ((d[q >> 0] | 0 | 0) != 39 ? (d[c[m >> 2] >> 0] | 0 | 0) != 34 : 0) {
	                            c[g >> 2] = 0;
	                            o = c[g >> 2] | 0;
	                            i = f;
	                            return o | 0
	                        }
	                    } while (0);
	                    Ue(c[h >> 2] | 0) | 0;
	                    c[l >> 2] = ff(c[h >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0))og(c[h >> 2] | 0, 70, 0)
	                }
	                c[g >> 2] = c[l >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function kf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                c[h >> 2] = 100;
	                c[j >> 2] = 0;
	                c[m >> 2] = 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 45) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 45) {
	                    i = e;
	                    return
	                }
	                c[k >> 2] = c[(c[f >> 2] | 0) + 172 >> 2];
	                c[(c[f >> 2] | 0) + 172 >> 2] = 5;
	                c[o >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2];
	                b = (c[f >> 2] | 0) + 200 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 4;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 4;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 4;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                if (((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                c[l >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                a:while (1) {
	                    if ((d[c[l >> 2] >> 0] | 0 | 0) == 10)do {
	                        b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    } while ((d[c[l >> 2] >> 0] | 0 | 0) == 10);
	                    b:while (1) {
	                        c[n >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2];
	                        c:while (1) {
	                            if (!((d[c[l >> 2] >> 0] | 0 | 0) > 45 ? (d[c[l >> 2] >> 0] | 0 | 0) <= 127 : 0))q = 23;
	                            do if ((q | 0) == 23) {
	                                q = 0;
	                                if ((d[c[l >> 2] >> 0] | 0 | 0) >= 32 ? (d[c[l >> 2] >> 0] | 0 | 0) < 45 : 0)break;
	                                if ((d[c[l >> 2] >> 0] | 0 | 0) != 9)break c
	                            } while (0);
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = c[n >> 2];
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) == 10)while (1) {
	                            b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1;
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            if ((d[c[l >> 2] >> 0] | 0 | 0) != 10)continue b
	                        }
	                        c[m >> 2] = (c[l >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                        if (((c[m >> 2] | 0) >>> 0 > 0 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                            if (c[g >> 2] | 0) {
	                                if (((c[j >> 2] | 0) + (c[m >> 2] | 0) + 1 | 0) >>> 0 >= (c[h >> 2] | 0) >>> 0) {
	                                    c[h >> 2] = (c[h >> 2] | 0) + ((c[j >> 2] | 0) + (c[m >> 2] | 0) + 100);
	                                    c[p >> 2] = Hb[c[135760 >> 2] & 511](c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                                    if (!(c[p >> 2] | 0)) {
	                                        q = 42;
	                                        break a
	                                    }
	                                    c[g >> 2] = c[p >> 2]
	                                }
	                            } else {
	                                do if ((d[c[l >> 2] >> 0] | 0 | 0) == 45) {
	                                    if ((d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) != 45) {
	                                        q = 36;
	                                        break
	                                    }
	                                    c[h >> 2] = (c[m >> 2] | 0) + 1
	                                } else q = 36; while (0);
	                                if ((q | 0) == 36) {
	                                    q = 0;
	                                    c[h >> 2] = 100 + (c[m >> 2] | 0)
	                                }
	                                c[g >> 2] = Cb[c[135752 >> 2] & 511](c[h >> 2] | 0) | 0;
	                                if (!(c[g >> 2] | 0)) {
	                                    q = 38;
	                                    break a
	                                }
	                                c[j >> 2] = 0
	                            }
	                            eU((c[g >> 2] | 0) + (c[j >> 2] | 0) | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[m >> 2] | 0) | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + (c[m >> 2] | 0);
	                            a[(c[g >> 2] | 0) + (c[j >> 2] | 0) >> 0] = 0
	                        }
	                        if ((c[j >> 2] | 0) >>> 0 > 1e7 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            q = 47;
	                            break a
	                        }
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) == 10) {
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        }
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) == 13) {
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            r = c[l >> 2] | 0;
	                            if ((d[c[l >> 2] >> 0] | 0 | 0) == 10) {
	                                q = 52;
	                                break
	                            }
	                            c[l >> 2] = r + -1
	                        }
	                        if (((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            q = 62;
	                            break a
	                        }
	                        c[l >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) != 45)break;
	                        if ((d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) == 45) {
	                            if ((d[(c[l >> 2] | 0) + 2 >> 0] | 0 | 0) == 62) {
	                                q = 66;
	                                break a
	                            }
	                            b = c[f >> 2] | 0;
	                            if (c[g >> 2] | 0)pg(b, 80, 66248, c[g >> 2] | 0); else pg(b, 80, 66296, 0);
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1
	                        }
	                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1
	                    }
	                    if ((q | 0) == 52) {
	                        q = 0;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = r;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    }
	                    if ((d[c[l >> 2] >> 0] | 0 | 0) >= 32 ? (d[c[l >> 2] >> 0] | 0 | 0) <= 127 : 0)continue;
	                    if ((d[c[l >> 2] >> 0] | 0 | 0) != 9) {
	                        q = 91;
	                        break
	                    }
	                }
	                if ((q | 0) == 38) {
	                    ie(c[f >> 2] | 0, 0);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = c[k >> 2];
	                    i = e;
	                    return
	                } else if ((q | 0) == 42) {
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    ie(c[f >> 2] | 0, 0);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = c[k >> 2];
	                    i = e;
	                    return
	                } else if ((q | 0) == 47) {
	                    pg(c[f >> 2] | 0, 45, 66168, 0);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    i = e;
	                    return
	                } else if ((q | 0) == 62) {
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    i = e;
	                    return
	                } else if ((q | 0) == 66) {
	                    if ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2] | 0) != (c[o >> 2] | 0))xg(c[f >> 2] | 0, 90, 66192);
	                    o = (c[f >> 2] | 0) + 200 | 0;
	                    c[o >> 2] = (c[o >> 2] | 0) + 3;
	                    o = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[o >> 2] = (c[o >> 2] | 0) + 3;
	                    o = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[o >> 2] = (c[o >> 2] | 0) + 3;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    do if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                        o = c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2] | 0;
	                        l = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                        if (c[g >> 2] | 0) {
	                            Ab[o & 511](l, c[g >> 2] | 0);
	                            break
	                        } else {
	                            Ab[o & 511](l, 65640);
	                            break
	                        }
	                    } while (0);
	                    if (c[g >> 2] | 0)zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        i = e;
	                        return
	                    }
	                    c[(c[f >> 2] | 0) + 172 >> 2] = c[k >> 2];
	                    i = e;
	                    return
	                } else if ((q | 0) == 91) {
	                    Ig(c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = c[k >> 2];
	                    i = e;
	                    return
	                }
	            }

	            function lf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[g >> 2] = Ze(c[f >> 2] | 0) | 0;
	                do if (c[g >> 2] | 0) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) != 120 ? (d[c[g >> 2] >> 0] | 0 | 0) != 88 : 0)break;
	                    if ((d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) != 109 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) != 77 : 0)break;
	                    if ((d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) != 108 ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) != 76 : 0)break;
	                    if ((((d[c[g >> 2] >> 0] | 0 | 0) == 120 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[g >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0) {
	                        xg(c[f >> 2] | 0, 64, 66328);
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    if (!(d[(c[g >> 2] | 0) + 3 >> 0] | 0)) {
	                        og(c[f >> 2] | 0, 64, 0);
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if (!(c[66392 + (c[h >> 2] << 2) >> 2] | 0)) {
	                            k = 20;
	                            break
	                        }
	                        if (qy(c[g >> 2] | 0, c[66392 + (c[h >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                    if ((k | 0) == 20) {
	                        rg(c[f >> 2] | 0, 64, 66408, 0, 0);
	                        break
	                    }
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } while (0);
	                if ((c[g >> 2] | 0) != 0 ? (vy(c[g >> 2] | 0, 58) | 0) != 0 : 0)Jg(c[f >> 2] | 0, 205, 66456, c[g >> 2] | 0, 0, 0);
	                c[e >> 2] = c[g >> 2];
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function mf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                h = e + 40 | 0;
	                j = e + 36 | 0;
	                k = e + 32 | 0;
	                l = e + 28 | 0;
	                m = e + 24 | 0;
	                n = e + 20 | 0;
	                o = e + 16 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                s = e;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[j >> 2] = 100;
	                c[o >> 2] = 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 63) {
	                    i = e;
	                    return
	                }
	                c[p >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                c[n >> 2] = c[(c[f >> 2] | 0) + 172 >> 2];
	                c[(c[f >> 2] | 0) + 172 >> 2] = 2;
	                b = (c[f >> 2] | 0) + 200 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 2;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 2;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 2;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                if (((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                c[m >> 2] = lf(c[f >> 2] | 0) | 0;
	                b = c[f >> 2] | 0;
	                do if (c[m >> 2] | 0) {
	                    if ((d[c[(c[b + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 63 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                        if ((c[p >> 2] | 0) != (c[(c[f >> 2] | 0) + 36 >> 2] | 0))xg(c[f >> 2] | 0, 90, 66504);
	                        t = (c[f >> 2] | 0) + 200 | 0;
	                        c[t >> 2] = (c[t >> 2] | 0) + 2;
	                        t = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[t >> 2] = (c[t >> 2] | 0) + 2;
	                        t = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[t >> 2] = (c[t >> 2] | 0) + 2;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                        if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) ? (c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] | 0) != 0 : 0)Db[c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0, 0);
	                        if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            i = e;
	                            return
	                        }
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    }
	                    c[g >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0;
	                    t = c[f >> 2] | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        ie(t, 0);
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    }
	                    c[k >> 2] = d[c[(c[t + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10 | (c[k >> 2] | 0) == 13) : 0)u = 33
	                    } else u = 33;
	                    if ((u | 0) == 33)pg(c[f >> 2] | 0, 65, 66568, c[m >> 2] | 0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    c[k >> 2] = ne(c[f >> 2] | 0, l) | 0;
	                    while (1) {
	                        t = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)if (9 <= (t | 0) & (c[k >> 2] | 0) <= 10 | (c[k >> 2] | 0) == 13 | 32 <= (c[k >> 2] | 0))u = 40; else v = 0; else if ((!(256 <= (t | 0) & (c[k >> 2] | 0) <= 55295) ? !(57344 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 1114111) : 0)v = 0; else u = 40;
	                        if ((u | 0) == 40) {
	                            u = 0;
	                            if ((c[k >> 2] | 0) != 63)v = 1; else v = (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 62
	                        }
	                        w = c[h >> 2] | 0;
	                        if (!v) {
	                            u = 73;
	                            break
	                        }
	                        if ((w + 5 | 0) >>> 0 >= (c[j >> 2] | 0) >>> 0) {
	                            c[r >> 2] = c[j >> 2] << 1;
	                            c[q >> 2] = Hb[c[135760 >> 2] & 511](c[g >> 2] | 0, c[r >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0)) {
	                                u = 45;
	                                break
	                            }
	                            c[g >> 2] = c[q >> 2];
	                            c[j >> 2] = c[r >> 2]
	                        }
	                        c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        if ((c[o >> 2] | 0) > 50) {
	                            if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                            if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                u = 52;
	                                break
	                            }
	                            c[o >> 2] = 0;
	                            if ((c[h >> 2] | 0) >>> 0 > 1e7 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                                u = 55;
	                                break
	                            }
	                        }
	                        if ((c[l >> 2] | 0) == 1) {
	                            t = c[k >> 2] & 255;
	                            x = c[h >> 2] | 0;
	                            c[h >> 2] = x + 1;
	                            a[(c[g >> 2] | 0) + x >> 0] = t
	                        } else {
	                            t = pe((c[g >> 2] | 0) + (c[h >> 2] | 0) | 0, c[k >> 2] | 0) | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + t
	                        }
	                        t = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            x = t + 28 | 0;
	                            c[x >> 2] = (c[x >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            x = t + 32 | 0;
	                            c[x >> 2] = (c[x >> 2] | 0) + 1
	                        }
	                        x = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[x >> 2] = (c[x >> 2] | 0) + (c[l >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        c[k >> 2] = ne(c[f >> 2] | 0, l) | 0;
	                        if (c[k >> 2] | 0)continue;
	                        do if (!(c[(c[f >> 2] | 0) + 292 >> 2] | 0)) {
	                            if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) <= 500)break;
	                            if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 500)break;
	                            Fg(c[f >> 2] | 0)
	                        } while (0);
	                        do if (!(c[(c[f >> 2] | 0) + 292 >> 2] | 0)) {
	                            if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                            vg(c[f >> 2] | 0)
	                        } while (0);
	                        c[k >> 2] = ne(c[f >> 2] | 0, l) | 0
	                    }
	                    if ((u | 0) == 45) {
	                        ie(c[f >> 2] | 0, 0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    } else if ((u | 0) == 52) {
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        i = e;
	                        return
	                    } else if ((u | 0) == 55) {
	                        pg(c[f >> 2] | 0, 47, 66600, c[m >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    } else if ((u | 0) == 73) {
	                        if (w >>> 0 > 1e7 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            pg(c[f >> 2] | 0, 47, 66600, c[m >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                            c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                            i = e;
	                            return
	                        }
	                        a[(c[g >> 2] | 0) + (c[h >> 2] | 0) >> 0] = 0;
	                        do if ((c[k >> 2] | 0) == 63) {
	                            if ((c[p >> 2] | 0) != (c[(c[f >> 2] | 0) + 36 >> 2] | 0))xg(c[f >> 2] | 0, 65, 66504);
	                            x = (c[f >> 2] | 0) + 200 | 0;
	                            c[x >> 2] = (c[x >> 2] | 0) + 2;
	                            x = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[x >> 2] = (c[x >> 2] | 0) + 2;
	                            x = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[x >> 2] = (c[x >> 2] | 0) + 2;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                            do if ((c[n >> 2] | 0) == 1 | (c[n >> 2] | 0) == 0 ? (qy(c[m >> 2] | 0, 66656) | 0) != 0 : 0) {
	                                c[s >> 2] = Gw() | 0;
	                                if (!((c[s >> 2] | 0) == 2 | (c[s >> 2] | 0) == 3))break;
	                                Kg(c[f >> 2] | 0, c[g >> 2] | 0)
	                            } while (0);
	                            if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                                if (!(c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] | 0))break;
	                                Db[c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0, c[g >> 2] | 0)
	                            }
	                        } else pg(c[f >> 2] | 0, 47, 66624, c[m >> 2] | 0); while (0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        break
	                    }
	                } else og(b, 46, 0); while (0);
	                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = e;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                i = e;
	                return
	            }

	            function nf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 78) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 79) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 65) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 73) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) != 79) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 9 >> 0] | 0 | 0) != 78) {
	                    i = b;
	                    return
	                }
	                c[j >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                if (((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[e >> 2] | 0);
	                a = (c[e >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 10;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 10;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 10;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                        xg(c[e >> 2] | 0, 65, 66680);
	                        i = b;
	                        return
	                    }
	                } while (0);
	                Ue(c[e >> 2] | 0) | 0;
	                c[f >> 2] = Ze(c[e >> 2] | 0) | 0;
	                a = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    og(a, 48, 0);
	                    i = b;
	                    return
	                }
	                do if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                        xg(c[e >> 2] | 0, 65, 66720);
	                        i = b;
	                        return
	                    }
	                } while (0);
	                if (vy(c[f >> 2] | 0, 58) | 0)Jg(c[e >> 2] | 0, 205, 66768, c[f >> 2] | 0, 0, 0);
	                Ue(c[e >> 2] | 0) | 0;
	                c[h >> 2] = jf(c[e >> 2] | 0, g, 0) | 0;
	                Ue(c[e >> 2] | 0) | 0;
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62) {
	                    if ((c[j >> 2] | 0) != (c[(c[e >> 2] | 0) + 36 >> 2] | 0))xg(c[e >> 2] | 0, 65, 66816);
	                    me(c[e >> 2] | 0);
	                    if (!(c[c[e >> 2] >> 2] | 0))break;
	                    if (c[(c[e >> 2] | 0) + 212 >> 2] | 0)break;
	                    if (!(c[(c[c[e >> 2] >> 2] | 0) + 28 >> 2] | 0))break;
	                    Jb[c[(c[c[e >> 2] >> 2] | 0) + 28 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0)
	                } else og(c[e >> 2] | 0, 49, 0); while (0);
	                if (c[h >> 2] | 0)zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                i = b;
	                return
	            }

	            function of(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                b = i;
	                i = i + 64 | 0;
	                e = b + 48 | 0;
	                f = b + 44 | 0;
	                g = b + 40 | 0;
	                h = b + 36 | 0;
	                j = b + 32 | 0;
	                k = b + 28 | 0;
	                l = b + 24 | 0;
	                m = b + 20 | 0;
	                n = b + 16 | 0;
	                o = b + 12 | 0;
	                p = b + 8 | 0;
	                q = b + 4 | 0;
	                r = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 69) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 78) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 73) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 89) {
	                    i = b;
	                    return
	                }
	                c[o >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                if (((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[e >> 2] | 0);
	                a = (c[e >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 8;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 8;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 8;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                c[n >> 2] = Ue(c[e >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0))xg(c[e >> 2] | 0, 65, 66880);
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37) {
	                    me(c[e >> 2] | 0);
	                    c[n >> 2] = Ue(c[e >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0))xg(c[e >> 2] | 0, 65, 66920);
	                    c[l >> 2] = 1
	                }
	                c[f >> 2] = Ze(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xg(c[e >> 2] | 0, 68, 66952);
	                    i = b;
	                    return
	                }
	                if (vy(c[f >> 2] | 0, 58) | 0)Jg(c[e >> 2] | 0, 205, 66984, c[f >> 2] | 0, 0, 0);
	                c[n >> 2] = Ue(c[e >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0))xg(c[e >> 2] | 0, 65, 67032);
	                c[(c[e >> 2] | 0) + 172 >> 2] = 10;
	                n = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34;
	                a:do if (c[l >> 2] | 0) {
	                    do if (!n) {
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39)break;
	                        c[h >> 2] = jf(c[e >> 2] | 0, j, 1) | 0;
	                        if ((c[h >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0)og(c[e >> 2] | 0, 84, 0);
	                        if (!(c[h >> 2] | 0))break a;
	                        c[p >> 2] = yl(c[h >> 2] | 0) | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            Lg(c[e >> 2] | 0, 91, 67072, c[h >> 2] | 0);
	                            break a
	                        }
	                        a = c[e >> 2] | 0;
	                        do if (c[(c[p >> 2] | 0) + 32 >> 2] | 0)og(a, 92, 0); else {
	                            if (!(c[a >> 2] | 0))break;
	                            if (c[(c[e >> 2] | 0) + 212 >> 2] | 0)break;
	                            if (!(c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] | 0))break;
	                            Gb[c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, 5, c[j >> 2] | 0, c[h >> 2] | 0, 0)
	                        } while (0);
	                        Al(c[p >> 2] | 0);
	                        break a
	                    } while (0);
	                    c[g >> 2] = df(c[e >> 2] | 0, m) | 0;
	                    if (c[g >> 2] | 0) {
	                        if (!(c[c[e >> 2] >> 2] | 0))break;
	                        if (c[(c[e >> 2] | 0) + 212 >> 2] | 0)break;
	                        if (!(c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] | 0))break;
	                        Gb[c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, 4, 0, 0, c[g >> 2] | 0)
	                    }
	                } else {
	                    do if (!n) {
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39)break;
	                        c[h >> 2] = jf(c[e >> 2] | 0, j, 1) | 0;
	                        if ((c[h >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0)og(c[e >> 2] | 0, 84, 0);
	                        do if (c[h >> 2] | 0) {
	                            c[q >> 2] = yl(c[h >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0)) {
	                                Lg(c[e >> 2] | 0, 91, 67072, c[h >> 2] | 0);
	                                break
	                            }
	                            if (c[(c[q >> 2] | 0) + 32 >> 2] | 0)og(c[e >> 2] | 0, 92, 0);
	                            Al(c[q >> 2] | 0)
	                        } while (0);
	                        do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62) {
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 32)break;
	                            if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13)break;
	                            xg(c[e >> 2] | 0, 65, 67152)
	                        } while (0);
	                        Ue(c[e >> 2] | 0) | 0;
	                        do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 78) {
	                            if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 68)break;
	                            if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 65)break;
	                            if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 84)break;
	                            if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 65)break;
	                            a = (c[e >> 2] | 0) + 200 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 5;
	                            a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 5;
	                            a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 5;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                            do if (!(d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                                if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                                Ve(c[e >> 2] | 0) | 0
	                            } while (0);
	                            do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13)break;
	                                xg(c[e >> 2] | 0, 65, 67184)
	                            } while (0);
	                            Ue(c[e >> 2] | 0) | 0;
	                            c[k >> 2] = Ze(c[e >> 2] | 0) | 0;
	                            if (!(c[c[e >> 2] >> 2] | 0))break a;
	                            if (c[(c[e >> 2] | 0) + 212 >> 2] | 0)break a;
	                            if (!(c[(c[c[e >> 2] >> 2] | 0) + 40 >> 2] | 0))break a;
	                            xb[c[(c[c[e >> 2] >> 2] | 0) + 40 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0);
	                            break a
	                        } while (0);
	                        do if (c[c[e >> 2] >> 2] | 0) {
	                            if (c[(c[e >> 2] | 0) + 212 >> 2] | 0)break;
	                            if (!(c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] | 0))break;
	                            Gb[c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, 2, c[j >> 2] | 0, c[h >> 2] | 0, 0)
	                        } while (0);
	                        if (!(c[(c[e >> 2] | 0) + 16 >> 2] | 0))break a;
	                        if ((c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 ? (qy(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 56 >> 2] | 0, 67096) | 0) == 0 : 0)break a;
	                        do if (!(c[(c[e >> 2] | 0) + 8 >> 2] | 0)) {
	                            a = Sh(67096) | 0;
	                            c[(c[e >> 2] | 0) + 8 >> 2] = a;
	                            a = c[e >> 2] | 0;
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                                c[(c[a + 8 >> 2] | 0) + 92 >> 2] = 64;
	                                break
	                            }
	                            ie(a, 67128);
	                            i = b;
	                            return
	                        } while (0);
	                        if (!(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0)) {
	                            a = Mh(c[(c[e >> 2] | 0) + 8 >> 2] | 0, 67144, 0, 0) | 0;
	                            c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] = a
	                        }
	                        XP(c[e >> 2] | 0, c[f >> 2] | 0, 2, c[j >> 2] | 0, c[h >> 2] | 0, 0);
	                        break a
	                    } while (0);
	                    c[g >> 2] = df(c[e >> 2] | 0, m) | 0;
	                    do if (c[c[e >> 2] >> 2] | 0) {
	                        if (c[(c[e >> 2] | 0) + 212 >> 2] | 0)break;
	                        if (!(c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] | 0))break;
	                        Gb[c[(c[c[e >> 2] >> 2] | 0) + 24 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, 1, 0, 0, c[g >> 2] | 0)
	                    } while (0);
	                    if ((c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 ? (qy(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 56 >> 2] | 0, 67096) | 0) == 0 : 0)break;
	                    do if (!(c[(c[e >> 2] | 0) + 8 >> 2] | 0)) {
	                        a = Sh(67096) | 0;
	                        c[(c[e >> 2] | 0) + 8 >> 2] = a;
	                        a = c[e >> 2] | 0;
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                            c[(c[a + 8 >> 2] | 0) + 92 >> 2] = 64;
	                            break
	                        }
	                        ie(a, 67128);
	                        i = b;
	                        return
	                    } while (0);
	                    if (!(c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0)) {
	                        a = Mh(c[(c[e >> 2] | 0) + 8 >> 2] | 0, 67144, 0, 0) | 0;
	                        c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] = a
	                    }
	                    XP(c[e >> 2] | 0, c[f >> 2] | 0, 1, 0, 0, c[g >> 2] | 0)
	                } while (0);
	                if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = b;
	                    return
	                }
	                Ue(c[e >> 2] | 0) | 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62)pg(c[e >> 2] | 0, 37, 67216, c[f >> 2] | 0); else {
	                    if ((c[o >> 2] | 0) != (c[(c[e >> 2] | 0) + 36 >> 2] | 0))xg(c[e >> 2] | 0, 90, 67264);
	                    me(c[e >> 2] | 0)
	                }
	                do if (c[m >> 2] | 0) {
	                    c[r >> 2] = 0;
	                    o = (c[c[e >> 2] >> 2] | 0) != 0;
	                    do if (c[l >> 2] | 0) {
	                        if (!o)break;
	                        if (!(c[(c[c[e >> 2] >> 2] | 0) + 96 >> 2] | 0))break;
	                        c[r >> 2] = Hb[c[(c[c[e >> 2] >> 2] | 0) + 96 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0) | 0
	                    } else {
	                        do if (o) {
	                            if (!(c[(c[c[e >> 2] >> 2] | 0) + 20 >> 2] | 0))break;
	                            c[r >> 2] = Hb[c[(c[c[e >> 2] >> 2] | 0) + 20 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0) | 0
	                        } while (0);
	                        if (c[r >> 2] | 0)break;
	                        if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != (c[e >> 2] | 0))break;
	                        c[r >> 2] = VP(c[e >> 2] | 0, c[f >> 2] | 0) | 0
	                    } while (0);
	                    if (!(c[r >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        break
	                    }
	                    if (c[(c[r >> 2] | 0) + 36 >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        break
	                    } else {
	                        c[(c[r >> 2] | 0) + 36 >> 2] = c[m >> 2];
	                        break
	                    }
	                } while (0);
	                if (c[g >> 2] | 0)zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                if (c[h >> 2] | 0)zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                if (!(c[j >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                i = b;
	                return
	            }

	            function pf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[c[h >> 2] >> 2] = 0;
	                if (((((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 35 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 82 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 81 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 85 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 82 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) == 68 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 9;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 9;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 9;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 2;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 35 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 77 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 80 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 76 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 68 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 3;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[j >> 2] = 1;
	                if ((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 35 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 70 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 88 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 68 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[j >> 2] = 4;
	                    do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[g >> 2] | 0, 65, 67328)
	                    } while (0);
	                    Ue(c[g >> 2] | 0) | 0
	                }
	                c[k >> 2] = ef(c[g >> 2] | 0) | 0;
	                c[(c[g >> 2] | 0) + 172 >> 2] = 3;
	                if (!(c[k >> 2] | 0))xg(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 84 >> 2] | 0, 67360); else c[c[h >> 2] >> 2] = c[k >> 2];
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function qf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                a = c[f >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 40) {
	                    og(a, 48, 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                if (((c[a + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                a:while (1) {
	                    me(c[f >> 2] | 0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    c[g >> 2] = Ze(c[f >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        n = 8;
	                        break
	                    }
	                    c[l >> 2] = c[h >> 2];
	                    while (1) {
	                        if (!(c[l >> 2] | 0))break;
	                        if (qy(c[g >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0) | 0) {
	                            n = 12;
	                            break
	                        }
	                        c[l >> 2] = c[c[l >> 2] >> 2]
	                    }
	                    if ((n | 0) == 12 ? (n = 0, qg(c[f >> 2] | 0, 541, 67448, c[g >> 2] | 0, 0), (CP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, c[g >> 2] | 0) | 0) == 0) : 0)zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    do if (!(c[l >> 2] | 0)) {
	                        c[k >> 2] = qm(c[g >> 2] | 0) | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            n = 17;
	                            break a
	                        }
	                        a = c[k >> 2] | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            c[j >> 2] = a;
	                            c[h >> 2] = a;
	                            break
	                        } else {
	                            c[c[j >> 2] >> 2] = a;
	                            c[j >> 2] = c[k >> 2];
	                            break
	                        }
	                    } while (0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 124) {
	                        n = 22;
	                        break
	                    }
	                }
	                if ((n | 0) == 8) {
	                    xg(c[f >> 2] | 0, 68, 67408);
	                    rm(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } else if ((n | 0) == 17) {
	                    rm(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } else if ((n | 0) == 22) {
	                    n = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 41) {
	                        og(n, 49, 0);
	                        rm(c[h >> 2] | 0);
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = b;
	                        return m | 0
	                    } else {
	                        me(n);
	                        c[e >> 2] = c[h >> 2];
	                        m = c[e >> 2] | 0;
	                        i = b;
	                        return m | 0
	                    }
	                }
	                return 0
	            }

	            function rf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                a = c[f >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 40) {
	                    og(a, 50, 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                if (((c[a + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                a:while (1) {
	                    me(c[f >> 2] | 0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    c[g >> 2] = cf(c[f >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        n = 8;
	                        break
	                    }
	                    c[l >> 2] = c[h >> 2];
	                    while (1) {
	                        if (!(c[l >> 2] | 0))break;
	                        if (qy(c[g >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0) | 0) {
	                            n = 12;
	                            break
	                        }
	                        c[l >> 2] = c[c[l >> 2] >> 2]
	                    }
	                    if ((n | 0) == 12 ? (n = 0, qg(c[f >> 2] | 0, 541, 67512, c[g >> 2] | 0, 0), (CP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, c[g >> 2] | 0) | 0) == 0) : 0)zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    do if (!(c[l >> 2] | 0)) {
	                        c[k >> 2] = qm(c[g >> 2] | 0) | 0;
	                        if (!(CP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, c[g >> 2] | 0) | 0))zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        if (!(c[k >> 2] | 0)) {
	                            n = 19;
	                            break a
	                        }
	                        a = c[k >> 2] | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            c[j >> 2] = a;
	                            c[h >> 2] = a;
	                            break
	                        } else {
	                            c[c[j >> 2] >> 2] = a;
	                            c[j >> 2] = c[k >> 2];
	                            break
	                        }
	                    } while (0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 124) {
	                        n = 24;
	                        break
	                    }
	                }
	                if ((n | 0) == 8) {
	                    og(c[f >> 2] | 0, 67, 0);
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } else if ((n | 0) == 19) {
	                    rm(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } else if ((n | 0) == 24) {
	                    n = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 41) {
	                        og(n, 51, 0);
	                        c[e >> 2] = c[h >> 2];
	                        m = c[e >> 2] | 0;
	                        i = b;
	                        return m | 0
	                    } else {
	                        me(n);
	                        c[e >> 2] = c[h >> 2];
	                        m = c[e >> 2] | 0;
	                        i = b;
	                        return m | 0
	                    }
	                }
	                return 0
	            }

	            function sf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 78 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 79 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 65 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 79 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 78 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                            xg(c[g >> 2] | 0, 65, 67576);
	                            c[f >> 2] = 0;
	                            j = c[f >> 2] | 0;
	                            i = e;
	                            return j | 0
	                        }
	                    } while (0);
	                    Ue(c[g >> 2] | 0) | 0;
	                    b = qf(c[g >> 2] | 0) | 0;
	                    c[c[h >> 2] >> 2] = b;
	                    if (!(c[c[h >> 2] >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    } else {
	                        c[f >> 2] = 10;
	                        j = c[f >> 2] | 0;
	                        i = e;
	                        return j | 0
	                    }
	                }
	                b = rf(c[g >> 2] | 0) | 0;
	                c[c[h >> 2] >> 2] = b;
	                if (!(c[c[h >> 2] >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                } else {
	                    c[f >> 2] = 9;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                return 0
	            }

	            function tf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                if (((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 67 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 65 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 65 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 5;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 5;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 5;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 1;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 73 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 82 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 70 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 83 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 4;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if (((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 73 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 82 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 70 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 5;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 5;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 5;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 3;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 73 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 68 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 2;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 69 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 78 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 89 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 6;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 5;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 69 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 78 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 73 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 83 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 6;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if ((((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 78 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 77 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 79 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 75 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 78 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 83 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 8;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 8;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                if (((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 78 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 77 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 79 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 75 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 78 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 7;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 7;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 7;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    c[f >> 2] = 7;
	                    j = c[f >> 2] | 0;
	                    i = e;
	                    return j | 0
	                }
	                c[f >> 2] = sf(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                j = c[f >> 2] | 0;
	                i = e;
	                return j | 0
	            }

	            function uf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b + 32 | 0;
	                f = b + 28 | 0;
	                g = b + 24 | 0;
	                h = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[e >> 2] = a;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 65) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 76) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 73) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 83) {
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) != 84) {
	                    i = b;
	                    return
	                }
	                c[j >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                a = (c[e >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[e >> 2] | 0, 65, 67616)
	                } while (0);
	                Ue(c[e >> 2] | 0) | 0;
	                c[f >> 2] = Ze(c[e >> 2] | 0) | 0;
	                a = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xg(a, 68, 67656);
	                    i = b;
	                    return
	                }
	                Ue(a) | 0;
	                if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[e >> 2] | 0);
	                a:while (1) {
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break;
	                    if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                    c[k >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    c[n >> 2] = 0;
	                    if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[e >> 2] | 0);
	                    c[h >> 2] = 0;
	                    c[g >> 2] = Ze(c[e >> 2] | 0) | 0;
	                    o = c[e >> 2] | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        p = 31;
	                        break
	                    }
	                    do if (!(c[o + 292 >> 2] | 0)) {
	                        if (((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                        vg(c[e >> 2] | 0)
	                    } while (0);
	                    do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                            p = 39;
	                            break a
	                        }
	                    } while (0);
	                    Ue(c[e >> 2] | 0) | 0;
	                    c[l >> 2] = tf(c[e >> 2] | 0, h) | 0;
	                    if ((c[l >> 2] | 0) <= 0)break;
	                    do if (!(c[(c[e >> 2] | 0) + 292 >> 2] | 0)) {
	                        if (((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                        vg(c[e >> 2] | 0)
	                    } while (0);
	                    do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                            p = 48;
	                            break a
	                        }
	                    } while (0);
	                    Ue(c[e >> 2] | 0) | 0;
	                    c[m >> 2] = pf(c[e >> 2] | 0, n) | 0;
	                    if ((c[m >> 2] | 0) <= 0) {
	                        p = 51;
	                        break
	                    }
	                    if ((c[l >> 2] | 0) != 1 & (c[n >> 2] | 0) != 0)Mg(c[n >> 2] | 0, c[n >> 2] | 0) | 0;
	                    do if (!(c[(c[e >> 2] | 0) + 292 >> 2] | 0)) {
	                        if (((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                        vg(c[e >> 2] | 0)
	                    } while (0);
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62) {
	                        do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                                p = 65;
	                                break a
	                            }
	                        } while (0);
	                        Ue(c[e >> 2] | 0) | 0
	                    }
	                    q = c[e >> 2] | 0;
	                    if ((c[k >> 2] | 0) == (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0)) {
	                        p = 71;
	                        break
	                    }
	                    do if (c[q >> 2] | 0) {
	                        if (c[(c[e >> 2] | 0) + 212 >> 2] | 0) {
	                            p = 79;
	                            break
	                        }
	                        if (!(c[(c[c[e >> 2] >> 2] | 0) + 32 >> 2] | 0)) {
	                            p = 79;
	                            break
	                        }
	                        wb[c[(c[c[e >> 2] >> 2] | 0) + 32 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[h >> 2] | 0)
	                    } else p = 79; while (0);
	                    do if ((p | 0) == 79) {
	                        p = 0;
	                        if (!(c[h >> 2] | 0))break;
	                        rm(c[h >> 2] | 0)
	                    } while (0);
	                    if (((c[n >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 324 >> 2] | 0) != 0 : 0) & (c[m >> 2] | 0) != 3 & (c[m >> 2] | 0) != 2)Ng(c[e >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[n >> 2] | 0);
	                    if (c[(c[e >> 2] | 0) + 324 >> 2] | 0)Og(c[e >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[l >> 2] | 0);
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[(c[e >> 2] | 0) + 292 >> 2] | 0)continue;
	                    if (((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)continue;
	                    vg(c[e >> 2] | 0)
	                }
	                if ((p | 0) == 31)xg(o, 68, 67688); else if ((p | 0) == 39)xg(c[e >> 2] | 0, 65, 67720); else if ((p | 0) == 48) {
	                    xg(c[e >> 2] | 0, 65, 67768);
	                    if (c[h >> 2] | 0)rm(c[h >> 2] | 0)
	                } else if ((p | 0) == 51) {
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[h >> 2] | 0)rm(c[h >> 2] | 0)
	                } else if ((p | 0) == 65) {
	                    xg(c[e >> 2] | 0, 65, 67816);
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[h >> 2] | 0)rm(c[h >> 2] | 0)
	                } else if ((p | 0) == 71) {
	                    og(q, 1, 67872);
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[h >> 2] | 0)rm(c[h >> 2] | 0)
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62) {
	                    i = b;
	                    return
	                }
	                if ((c[j >> 2] | 0) != (c[(c[e >> 2] | 0) + 36 >> 2] | 0))qg(c[e >> 2] | 0, 90, 67904, 0, 0);
	                me(c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function vf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[m >> 2] = 0;
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                do if (((((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 35 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 80 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 67 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 65 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 65 : 0) {
	                    b = (c[g >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 7;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 7;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 7;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[g >> 2] | 0) | 0;
	                    Ue(c[g >> 2] | 0) | 0;
	                    if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                    b = c[g >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 41) {
	                        if ((c[b + 104 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2] | 0) != (c[h >> 2] | 0) : 0)qg(c[g >> 2] | 0, 90, 67976, 0, 0);
	                        me(c[g >> 2] | 0);
	                        c[j >> 2] = im(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0, 1) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            c[f >> 2] = 0;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 42) {
	                            c[(c[j >> 2] | 0) + 4 >> 2] = 3;
	                            me(c[g >> 2] | 0)
	                        }
	                        c[f >> 2] = c[j >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    if (!((d[c[(c[b + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 40 ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 124 : 0))o = 31;
	                    if ((o | 0) == 31 ? (b = im(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0, 1) | 0, c[k >> 2] = b, c[j >> 2] = b, (c[j >> 2] | 0) == 0) : 0) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    while (1) {
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 124)p = (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != -1; else p = 0;
	                        q = c[g >> 2] | 0;
	                        if (!p) {
	                            o = 54;
	                            break
	                        }
	                        me(q);
	                        b = (c[m >> 2] | 0) == 0;
	                        a = im(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0, 4) | 0;
	                        if (b) {
	                            c[j >> 2] = a;
	                            if (!(c[j >> 2] | 0)) {
	                                o = 38;
	                                break
	                            }
	                            c[(c[j >> 2] | 0) + 12 >> 2] = c[k >> 2];
	                            if (c[k >> 2] | 0)c[(c[k >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                            c[k >> 2] = c[j >> 2]
	                        } else {
	                            c[l >> 2] = a;
	                            if (!(c[l >> 2] | 0)) {
	                                o = 43;
	                                break
	                            }
	                            a = im(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0, 2) | 0;
	                            c[(c[l >> 2] | 0) + 12 >> 2] = a;
	                            if (c[(c[l >> 2] | 0) + 12 >> 2] | 0)c[(c[(c[l >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                            c[(c[k >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                            if (c[l >> 2] | 0)c[(c[l >> 2] | 0) + 20 >> 2] = c[k >> 2];
	                            c[k >> 2] = c[l >> 2]
	                        }
	                        Ue(c[g >> 2] | 0) | 0;
	                        c[m >> 2] = Ze(c[g >> 2] | 0) | 0;
	                        r = c[g >> 2] | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            o = 50;
	                            break
	                        }
	                        Ue(r) | 0;
	                        if (c[(c[g >> 2] | 0) + 292 >> 2] | 0)continue;
	                        if (((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)continue;
	                        vg(c[g >> 2] | 0)
	                    }
	                    if ((o | 0) == 38) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 43) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 50) {
	                        xg(r, 68, 68048);
	                        lm(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 54) {
	                        if ((d[c[(c[q + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 41 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 42 : 0) {
	                            do if (c[m >> 2] | 0) {
	                                a = im(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0, 2) | 0;
	                                c[(c[k >> 2] | 0) + 16 >> 2] = a;
	                                if (!(c[(c[k >> 2] | 0) + 16 >> 2] | 0))break;
	                                c[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 20 >> 2] = c[k >> 2]
	                            } while (0);
	                            if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 4 >> 2] = 3;
	                            do if (c[(c[g >> 2] | 0) + 104 >> 2] | 0) {
	                                if ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2] | 0) == (c[h >> 2] | 0))break;
	                                qg(c[g >> 2] | 0, 90, 67976, 0, 0)
	                            } while (0);
	                            a = (c[g >> 2] | 0) + 200 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 2;
	                            a = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 2;
	                            a = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 2;
	                            if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                            if (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)break;
	                            if ((ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                            Ve(c[g >> 2] | 0) | 0;
	                            break
	                        }
	                        lm(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0);
	                        og(c[g >> 2] | 0, 52, 0);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                } else o = 70; while (0);
	                if ((o | 0) == 70)og(c[g >> 2] | 0, 69, 0);
	                c[f >> 2] = c[j >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function wf(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                c[m >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2];
	                c[c[k >> 2] >> 2] = 0;
	                e = c[h >> 2] | 0;
	                if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 40) {
	                    pg(e, 54, 68104, c[j >> 2] | 0);
	                    c[g >> 2] = -1;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                me(e);
	                if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[g >> 2] = -1;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                Ue(c[h >> 2] | 0) | 0;
	                if (((((((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 35 ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 80 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 67 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 65 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 65 : 0) {
	                    c[l >> 2] = vf(c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[n >> 2] = 3
	                } else {
	                    c[l >> 2] = Pg(c[h >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                    c[n >> 2] = 4
	                }
	                Ue(c[h >> 2] | 0) | 0;
	                c[c[k >> 2] >> 2] = c[l >> 2];
	                c[g >> 2] = c[n >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function xf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[f >> 2] = a;
	                c[h >> 2] = -1;
	                c[j >> 2] = 0;
	                a:do if (((((((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 76 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 77 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 69 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 78 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) == 84 : 0) {
	                    c[k >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 9;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 9;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 9;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[f >> 2] | 0, 65, 68152)
	                    } while (0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    c[g >> 2] = Ze(c[f >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        xg(c[f >> 2] | 0, 68, 68184);
	                        c[e >> 2] = -1;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    while (1) {
	                        if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))m = (c[(c[f >> 2] | 0) + 40 >> 2] | 0) > 1; else m = 0;
	                        n = c[f >> 2] | 0;
	                        if (!m)break;
	                        Ve(n) | 0
	                    }
	                    do if ((d[c[(c[n + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[f >> 2] | 0, 65, 68232)
	                    } while (0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    do if ((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 69 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 77 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 80 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 84 : 0) {
	                        if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 89) {
	                            o = 42;
	                            break
	                        }
	                        a = (c[f >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 5;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 5;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 5;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        do if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                            if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                            Ve(c[f >> 2] | 0) | 0
	                        } while (0);
	                        c[h >> 2] = 1
	                    } else o = 42; while (0);
	                    b:do if ((o | 0) == 42) {
	                        do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 65 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 78 : 0) {
	                            if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 89)break;
	                            a = (c[f >> 2] | 0) + 200 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                            do if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                                if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                                Ve(c[f >> 2] | 0) | 0
	                            } while (0);
	                            c[h >> 2] = 2;
	                            break b
	                        } while (0);
	                        a = c[f >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 40) {
	                            c[h >> 2] = wf(a, c[g >> 2] | 0, j) | 0;
	                            break
	                        }
	                        do if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37) {
	                            if (c[(c[f >> 2] | 0) + 96 >> 2] | 0) {
	                                o = 57;
	                                break
	                            }
	                            if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 1) {
	                                o = 57;
	                                break
	                            }
	                            xg(c[f >> 2] | 0, 21, 68272)
	                        } else o = 57; while (0);
	                        if ((o | 0) == 57)xg(c[f >> 2] | 0, 54, 68336);
	                        c[e >> 2] = -1;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    } while (0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    while (1) {
	                        if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))p = (c[(c[f >> 2] | 0) + 40 >> 2] | 0) > 1; else p = 0;
	                        q = c[f >> 2] | 0;
	                        if (!p)break;
	                        Ve(q) | 0
	                    }
	                    Ue(q) | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62) {
	                        og(c[f >> 2] | 0, 73, 0);
	                        if (!(c[j >> 2] | 0))break;
	                        lm(c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0);
	                        break
	                    }
	                    if ((c[k >> 2] | 0) != (c[(c[f >> 2] | 0) + 36 >> 2] | 0))xg(c[f >> 2] | 0, 90, 68392);
	                    me(c[f >> 2] | 0);
	                    do if (c[c[f >> 2] >> 2] | 0) {
	                        if (c[(c[f >> 2] | 0) + 212 >> 2] | 0)break;
	                        if (!(c[(c[c[f >> 2] >> 2] | 0) + 36 >> 2] | 0))break;
	                        if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 20 >> 2] = 0;
	                        Jb[c[(c[c[f >> 2] >> 2] | 0) + 36 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0);
	                        if (!(c[j >> 2] | 0))break a;
	                        if (c[(c[j >> 2] | 0) + 20 >> 2] | 0)break a;
	                        lm(c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0);
	                        break a
	                    } while (0);
	                    if (c[j >> 2] | 0)lm(c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0)
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                l = c[e >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function yf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[e >> 2] | 0);
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60) {
	                    a = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0;
	                    if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                        if ((d[a + 1 >> 0] | 0 | 0) != 63)break;
	                        mf(c[e >> 2] | 0);
	                        break
	                    }
	                    f = d[a + 2 >> 0] | 0;
	                    if ((f | 0) == 78) {
	                        nf(c[e >> 2] | 0);
	                        break
	                    } else if ((f | 0) == 65) {
	                        uf(c[e >> 2] | 0);
	                        break
	                    } else if ((f | 0) == 45) {
	                        kf(c[e >> 2] | 0);
	                        break
	                    } else if ((f | 0) == 69) {
	                        f = c[e >> 2] | 0;
	                        if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 76) {
	                            xf(f) | 0;
	                            break
	                        }
	                        if ((d[(c[(c[f + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 78)break;
	                        of(c[e >> 2] | 0);
	                        break
	                    } else break
	                } while (0);
	                if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 1 : 0)zf(c[e >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 96 >> 2] | 0) {
	                    g = c[e >> 2] | 0;
	                    h = g + 172 | 0;
	                    c[h >> 2] = 3;
	                    i = b;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) <= 1) {
	                    g = c[e >> 2] | 0;
	                    h = g + 172 | 0;
	                    c[h >> 2] = 3;
	                    i = b;
	                    return
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    g = c[e >> 2] | 0;
	                    h = g + 172 | 0;
	                    c[h >> 2] = 3;
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    g = c[e >> 2] | 0;
	                    h = g + 172 | 0;
	                    c[h >> 2] = 3;
	                    i = b;
	                    return
	                }
	                if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 91) {
	                    g = c[e >> 2] | 0;
	                    h = g + 172 | 0;
	                    c[h >> 2] = 3;
	                    i = b;
	                    return
	                }
	                Qg(c[e >> 2] | 0);
	                g = c[e >> 2] | 0;
	                h = g + 172 | 0;
	                c[h >> 2] = 3;
	                i = b;
	                return
	            }

	            function zf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 37) {
	                    i = b;
	                    return
	                }
	                me(c[e >> 2] | 0);
	                c[f >> 2] = Ze(c[e >> 2] | 0) | 0;
	                a = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xg(a, 68, 68904);
	                    i = b;
	                    return
	                }
	                j = c[e >> 2] | 0;
	                if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 59) {
	                    og(j, 23, 0);
	                    i = b;
	                    return
	                }
	                me(j);
	                j = (c[e >> 2] | 0) + 440 | 0;
	                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                if ((c[c[e >> 2] >> 2] | 0) != 0 ? (c[(c[c[e >> 2] >> 2] | 0) + 96 >> 2] | 0) != 0 : 0)c[g >> 2] = Hb[c[(c[c[e >> 2] >> 2] | 0) + 96 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0) | 0;
	                if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = b;
	                    return
	                }
	                a:do if (c[g >> 2] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 4 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 5 : 0) {
	                        rg(c[e >> 2] | 0, 27, 68936, c[f >> 2] | 0, 0);
	                        break
	                    }
	                    j = c[e >> 2] | 0;
	                    a = c[g >> 2] | 0;
	                    if ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 40 >> 2] | 0) != 226) {
	                        c[h >> 2] = ug(j, a) | 0;
	                        if ((Xe(c[e >> 2] | 0, c[h >> 2] | 0) | 0) >= 0)break;
	                        i = b;
	                        return
	                    }
	                    c[h >> 2] = we(j, a) | 0;
	                    if ((Xe(c[e >> 2] | 0, c[h >> 2] | 0) | 0) < 0) {
	                        i = b;
	                        return
	                    }
	                    if ((((((c[(c[g >> 2] | 0) + 48 >> 2] | 0) == 5 ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 108 : 0) {
	                        do if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        _e(c[e >> 2] | 0);
	                        if ((c[(c[e >> 2] | 0) + 84 >> 2] | 0) == 32) {
	                            c[(c[e >> 2] | 0) + 172 >> 2] = -1;
	                            i = b;
	                            return
	                        }
	                    }
	                } else {
	                    do if ((c[(c[e >> 2] | 0) + 28 >> 2] | 0) == 1)k = 14; else {
	                        if ((c[(c[e >> 2] | 0) + 88 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 92 >> 2] | 0) == 0 : 0) {
	                            k = 14;
	                            break
	                        }
	                        rg(c[e >> 2] | 0, 27, 65432, c[f >> 2] | 0, 0);
	                        c[(c[e >> 2] | 0) + 100 >> 2] = 0
	                    } while (0);
	                    if ((k | 0) == 14)pg(c[e >> 2] | 0, 26, 65432, c[f >> 2] | 0);
	                    sg(c[e >> 2] | 0, 0, 0, 0) | 0
	                } while (0);
	                c[(c[e >> 2] | 0) + 92 >> 2] = 1;
	                i = b;
	                return
	            }

	            function Af(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                do if (((((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 118 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 101 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 114 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 115 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 105 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 111 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 110 : 0) {
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 7;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 7;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 7;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 61) {
	                        og(a, 75, 0);
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                    me(a);
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                        me(a);
	                        c[g >> 2] = Lf(c[f >> 2] | 0) | 0;
	                        j = c[f >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34) {
	                            og(j, 34, 0);
	                            break
	                        } else {
	                            me(j);
	                            break
	                        }
	                    }
	                    j = c[f >> 2] | 0;
	                    if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                        og(j, 33, 0);
	                        break
	                    }
	                    me(j);
	                    c[g >> 2] = Lf(c[f >> 2] | 0) | 0;
	                    j = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                        og(j, 34, 0);
	                        break
	                    } else {
	                        me(j);
	                        break
	                    }
	                } while (0);
	                c[e >> 2] = c[g >> 2];
	                h = c[e >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Bf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                Ue(c[f >> 2] | 0) | 0;
	                a:do if ((((((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 101 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 99 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 111 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 100 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 105 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 103 : 0) {
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 8;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 8;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 8;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 61) {
	                        og(a, 75, 0);
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    me(a);
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                        me(a);
	                        c[g >> 2] = Mf(c[f >> 2] | 0) | 0;
	                        k = c[f >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34) {
	                            og(k, 34, 0);
	                            break
	                        } else {
	                            me(k);
	                            break
	                        }
	                    } else {
	                        k = c[f >> 2] | 0;
	                        if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                            og(k, 33, 0);
	                            break
	                        }
	                        me(k);
	                        c[g >> 2] = Mf(c[f >> 2] | 0) | 0;
	                        k = c[f >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                            og(k, 34, 0);
	                            break
	                        } else {
	                            me(k);
	                            break
	                        }
	                    } while (0);
	                    if (c[(c[f >> 2] | 0) + 360 >> 2] & 2097152) {
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    do if (c[g >> 2] | 0) {
	                        if ((ty(c[g >> 2] | 0, 69608) | 0) != 0 ? (ty(c[g >> 2] | 0, 69616) | 0) != 0 : 0)break;
	                        do if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) == 0 ? (c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) {
	                            if (c[(c[c[(c[f >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] | 0)break;
	                            xg(c[f >> 2] | 0, 81, 69624)
	                        } while (0);
	                        if (c[(c[f >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        break a
	                    } while (0);
	                    do if (c[g >> 2] | 0) {
	                        if ((ty(c[g >> 2] | 0, 69672) | 0) != 0 ? (ty(c[g >> 2] | 0, 69680) | 0) != 0 : 0)break;
	                        if (c[(c[f >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        break a
	                    } while (0);
	                    if (c[g >> 2] | 0) {
	                        if (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0);
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] = c[g >> 2];
	                        c[h >> 2] = Dd(c[g >> 2] | 0) | 0;
	                        a = c[f >> 2] | 0;
	                        if (c[h >> 2] | 0) {
	                            se(a, c[h >> 2] | 0) | 0;
	                            break
	                        }
	                        pg(a, 32, 69688, c[g >> 2] | 0);
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                } while (0);
	                c[e >> 2] = c[g >> 2];
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function Cf(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g + 24 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = f;
	                Rg(c[h >> 2] | 0);
	                if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                if (((c[(c[h >> 2] | 0) + 24 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 : 0) ? (a[l >> 0] = a[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0, a[l + 1 >> 0] = a[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0, a[l + 2 >> 0] = a[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0, a[l + 3 >> 0] = a[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0, c[m >> 2] = sd(l, 4) | 0, (c[m >> 2] | 0) != 0) : 0)re(c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                if ((((((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 108 : 0) ? (_e(c[h >> 2] | 0), (c[(c[h >> 2] | 0) + 84 >> 2] | 0) == 32) : 0) {
	                    c[(c[h >> 2] | 0) + 172 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                do if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0)) {
	                    m = Sh(68488) | 0;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = m;
	                    m = c[h >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                        c[(c[m + 8 >> 2] | 0) + 92 >> 2] = 64;
	                        break
	                    }
	                    ie(m, 67128);
	                    i = g;
	                    return
	                } while (0);
	                if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) == 0 : 0)Oh(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 172 >> 2] = 3;
	                c[(c[h >> 2] | 0) + 96 >> 2] = 1;
	                a:while (1) {
	                    if (!((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0))p = 25;
	                    do if ((p | 0) == 25) {
	                        p = 0;
	                        if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0)break;
	                        if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 37 ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32 : 0) {
	                            if (9 <= (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)break a
	                        }
	                    } while (0);
	                    c[n >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    c[o >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                    if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                    if (((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 91 : 0)Qg(c[h >> 2] | 0); else p = 39;
	                    b:do if ((p | 0) == 39) {
	                        p = 0;
	                        do if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                                k = c[h >> 2] | 0;
	                                if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37) {
	                                    zf(k);
	                                    break b
	                                } else {
	                                    yf(k);
	                                    break b
	                                }
	                            }
	                        } while (0);
	                        me(c[h >> 2] | 0)
	                    } while (0);
	                    while (1) {
	                        if (!(d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))q = (c[(c[h >> 2] | 0) + 40 >> 2] | 0) > 1; else q = 0;
	                        r = c[h >> 2] | 0;
	                        if (!q)break;
	                        Ve(r) | 0
	                    }
	                    if ((c[(c[r + 36 >> 2] | 0) + 16 >> 2] | 0) != (c[n >> 2] | 0))continue;
	                    if ((c[o >> 2] | 0) == (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0)) {
	                        p = 53;
	                        break
	                    }
	                }
	                if ((p | 0) == 53)og(c[h >> 2] | 0, 60, 0);
	                if (!(d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                    i = g;
	                    return
	                }
	                og(c[h >> 2] | 0, 60, 0);
	                i = g;
	                return
	            }

	            function Df(e) {
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
	                f = i;
	                i = i + 112 | 0;
	                g = f;
	                h = f + 84 | 0;
	                j = f + 80 | 0;
	                k = f + 76 | 0;
	                l = f + 72 | 0;
	                m = f + 68 | 0;
	                n = f + 64 | 0;
	                o = f + 60 | 0;
	                p = f + 88 | 0;
	                q = f + 56 | 0;
	                r = f + 52 | 0;
	                s = f + 48 | 0;
	                t = f + 44 | 0;
	                u = f + 40 | 0;
	                v = f + 36 | 0;
	                w = f + 32 | 0;
	                x = f + 28 | 0;
	                y = f + 24 | 0;
	                z = f + 20 | 0;
	                A = f + 16 | 0;
	                B = f + 12 | 0;
	                C = f + 8 | 0;
	                D = f + 4 | 0;
	                c[h >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 38) {
	                    i = f;
	                    return
	                }
	                if ((d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35) {
	                    c[o >> 2] = 0;
	                    c[q >> 2] = d[(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0];
	                    c[r >> 2] = Ye(c[h >> 2] | 0) | 0;
	                    if (!(c[r >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    if ((c[(c[h >> 2] | 0) + 256 >> 2] | 0) == 1) {
	                        e = pe(p + (c[o >> 2] | 0) | 0, c[r >> 2] | 0) | 0;
	                        c[o >> 2] = (c[o >> 2] | 0) + e;
	                        a[p + (c[o >> 2] | 0) >> 0] = 0;
	                        if (!(c[c[h >> 2] >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (!(c[(c[c[h >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (c[(c[h >> 2] | 0) + 212 >> 2] | 0) {
	                            i = f;
	                            return
	                        }
	                        Db[c[(c[c[h >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, p, c[o >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                    if ((c[r >> 2] | 0) <= 255) {
	                        a[p >> 0] = c[r >> 2];
	                        a[p + 1 >> 0] = 0;
	                        if (!(c[c[h >> 2] >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (!(c[(c[c[h >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (c[(c[h >> 2] | 0) + 212 >> 2] | 0) {
	                            i = f;
	                            return
	                        }
	                        Db[c[(c[c[h >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, p, 1);
	                        i = f;
	                        return
	                    }
	                    o = c[r >> 2] | 0;
	                    if ((c[q >> 2] | 0) == 120 | (c[q >> 2] | 0) == 88) {
	                        c[g >> 2] = o;
	                        JT(p, 10, 68560, g) | 0
	                    } else {
	                        c[g >> 2] = o;
	                        JT(p, 10, 68568, g) | 0
	                    }
	                    if (!(c[c[h >> 2] >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    if (!(c[(c[c[h >> 2] >> 2] | 0) + 64 >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    if (c[(c[h >> 2] | 0) + 212 >> 2] | 0) {
	                        i = f;
	                        return
	                    }
	                    Ab[c[(c[c[h >> 2] >> 2] | 0) + 64 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, p);
	                    i = f;
	                    return
	                }
	                c[j >> 2] = Ef(c[h >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[l >> 2] = c[(c[j >> 2] | 0) + 72 >> 2];
	                if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 6 : 0) {
	                    do if (!(c[(c[j >> 2] | 0) + 72 >> 2] | 0)) {
	                        if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 2 ? (c[(c[h >> 2] | 0) + 360 >> 2] & 18 | 0) == 0 : 0) {
	                            E = 76;
	                            break
	                        }
	                        c[s >> 2] = c[(c[h >> 2] | 0) + 440 >> 2];
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == (c[h >> 2] | 0))c[t >> 2] = 0; else c[t >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                        do if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 1)if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 2) {
	                            p = (c[h >> 2] | 0) + 248 | 0;
	                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                            c[n >> 2] = Tg(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0, c[c[h >> 2] >> 2] | 0, c[t >> 2] | 0, c[(c[h >> 2] | 0) + 248 >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, m) | 0;
	                            p = (c[h >> 2] | 0) + 248 | 0;
	                            c[p >> 2] = (c[p >> 2] | 0) + -1;
	                            break
	                        } else {
	                            c[n >> 2] = 88;
	                            Lg(c[h >> 2] | 0, 1, 68576, 0);
	                            break
	                        } else {
	                            p = (c[h >> 2] | 0) + 248 | 0;
	                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                            c[n >> 2] = Sg(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 40 >> 2] | 0, c[t >> 2] | 0, m) | 0;
	                            p = (c[h >> 2] | 0) + 248 | 0;
	                            c[p >> 2] = (c[p >> 2] | 0) + -1
	                        } while (0);
	                        c[(c[j >> 2] | 0) + 72 >> 2] = (c[(c[h >> 2] | 0) + 440 >> 2] | 0) - (c[s >> 2] | 0) + 1 << 1;
	                        if ((c[(c[j >> 2] | 0) + 40 >> 2] | 0) != 0 ? (vy(c[(c[j >> 2] | 0) + 40 >> 2] | 0, 60) | 0) != 0 : 0) {
	                            p = (c[j >> 2] | 0) + 72 | 0;
	                            c[p >> 2] = c[p >> 2] | 1
	                        }
	                        p = c[h >> 2] | 0;
	                        if ((c[n >> 2] | 0) == 89) {
	                            og(p, 89, 0);
	                            Uh(c[m >> 2] | 0);
	                            i = f;
	                            return
	                        }
	                        if (sg(p, 0, c[j >> 2] | 0, 0) | 0) {
	                            Uh(c[m >> 2] | 0);
	                            i = f;
	                            return
	                        }
	                        a:do if (!((c[n >> 2] | 0) == 0 & (c[m >> 2] | 0) != 0)) {
	                            if ((c[n >> 2] | 0) != 0 & (c[n >> 2] | 0) != 27) {
	                                pg(c[h >> 2] | 0, 26, 68608, c[(c[j >> 2] | 0) + 8 >> 2] | 0);
	                                sg(c[h >> 2] | 0, 0, c[j >> 2] | 0, 0) | 0;
	                                break
	                            }
	                            if (c[m >> 2] | 0) {
	                                Uh(c[m >> 2] | 0);
	                                c[m >> 2] = 0
	                            }
	                        } else {
	                            if (!((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 1 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 2 : 0))E = 51;
	                            if ((E | 0) == 51 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                                c[(c[j >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                                if (!(c[(c[h >> 2] | 0) + 16 >> 2] | 0)) {
	                                    c[(c[j >> 2] | 0) + 68 >> 2] = 1;
	                                    while (1) {
	                                        if (!(c[m >> 2] | 0))break a;
	                                        c[(c[m >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                                        ri(c[m >> 2] | 0, c[(c[j >> 2] | 0) + 32 >> 2] | 0);
	                                        if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0))c[(c[j >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                                        c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                                    }
	                                }
	                                if (!((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 3 ? (c[(c[m >> 2] | 0) + 24 >> 2] | 0) == 0 : 0))E = 55;
	                                do if ((E | 0) == 55) {
	                                    if ((c[(c[h >> 2] | 0) + 436 >> 2] | 0) == 5)break;
	                                    c[(c[j >> 2] | 0) + 68 >> 2] = 0;
	                                    while (1) {
	                                        if (!(c[m >> 2] | 0))break;
	                                        c[(c[m >> 2] | 0) + 20 >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                                        c[(c[m >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                                        if (!(c[(c[m >> 2] | 0) + 24 >> 2] | 0))c[(c[j >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                                        c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                                    }
	                                    c[m >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                                    if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 2)break a;
	                                    Ug(c[j >> 2] | 0, c[m >> 2] | 0, 0);
	                                    break a
	                                } while (0);
	                                c[(c[m >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                                c[m >> 2] = 0;
	                                c[(c[j >> 2] | 0) + 68 >> 2] = 1;
	                                break
	                            }
	                            Uh(c[m >> 2] | 0);
	                            c[m >> 2] = 0
	                        } while (0);
	                        if (!(c[(c[j >> 2] | 0) + 72 >> 2] | 0))c[(c[j >> 2] | 0) + 72 >> 2] = 2
	                    } else E = 76; while (0);
	                    if ((E | 0) == 76 ? (c[(c[j >> 2] | 0) + 72 >> 2] | 0) != 1 : 0) {
	                        s = (c[h >> 2] | 0) + 440 | 0;
	                        c[s >> 2] = (c[s >> 2] | 0) + ((c[(c[j >> 2] | 0) + 72 >> 2] | 0) / 2 | 0)
	                    }
	                    if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0)) {
	                        if (c[l >> 2] | 0) {
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == (c[h >> 2] | 0))c[u >> 2] = 0; else c[u >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                            do if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 1)if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 2) {
	                                l = (c[h >> 2] | 0) + 248 | 0;
	                                c[l >> 2] = (c[l >> 2] | 0) + 1;
	                                c[n >> 2] = Tg(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0, c[c[h >> 2] >> 2] | 0, c[u >> 2] | 0, c[(c[h >> 2] | 0) + 248 >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, 0) | 0;
	                                l = (c[h >> 2] | 0) + 248 | 0;
	                                c[l >> 2] = (c[l >> 2] | 0) + -1;
	                                break
	                            } else {
	                                c[n >> 2] = 88;
	                                Lg(c[h >> 2] | 0, 1, 68576, 0);
	                                break
	                            } else {
	                                l = (c[h >> 2] | 0) + 248 | 0;
	                                c[l >> 2] = (c[l >> 2] | 0) + 1;
	                                c[n >> 2] = Sg(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 40 >> 2] | 0, c[u >> 2] | 0, 0) | 0;
	                                l = (c[h >> 2] | 0) + 248 | 0;
	                                c[l >> 2] = (c[l >> 2] | 0) + -1
	                            } while (0);
	                            if ((c[n >> 2] | 0) == 89) {
	                                og(c[h >> 2] | 0, 89, 0);
	                                i = f;
	                                return
	                            }
	                        }
	                        if (!(c[c[h >> 2] >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (!(c[(c[c[h >> 2] >> 2] | 0) + 64 >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                        if (c[(c[h >> 2] | 0) + 16 >> 2] | 0) {
	                            i = f;
	                            return
	                        }
	                        if (c[(c[h >> 2] | 0) + 212 >> 2] | 0) {
	                            i = f;
	                            return
	                        }
	                        Ab[c[(c[c[h >> 2] >> 2] | 0) + 64 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                    if ((((c[c[h >> 2] >> 2] | 0) != 0 ? (c[(c[c[h >> 2] >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 0 : 0) ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                        Ab[c[(c[c[h >> 2] >> 2] | 0) + 64 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0);
	                        i = f;
	                        return
	                    }
	                    if ((c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        i = f;
	                        return
	                    }
	                    if (!(c[(c[h >> 2] | 0) + 52 >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    if ((c[m >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 68 >> 2] | 0) == 0 : 0)E = 107; else E = 106;
	                    do if ((E | 0) == 106)if ((c[(c[h >> 2] | 0) + 436 >> 2] | 0) != 5) {
	                        if ((c[m >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) <= 0 : 0) {
	                            c[D >> 2] = AP(c[(c[h >> 2] | 0) + 296 >> 2] | 0, 68640, -1) | 0;
	                            if ((c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 3)c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] = c[D >> 2];
	                            do if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) != (c[(c[j >> 2] | 0) + 12 >> 2] | 0)) {
	                                if ((c[(c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 3)break;
	                                c[(c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] = c[D >> 2]
	                            } while (0);
	                            yi(c[(c[h >> 2] | 0) + 52 >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            break
	                        }
	                        c[y >> 2] = 0;
	                        c[C >> 2] = 0;
	                        n = (c[h >> 2] | 0) + 468 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + ((c[(c[j >> 2] | 0) + 44 >> 2] | 0) + 5);
	                        if (sg(c[h >> 2] | 0, 0, c[j >> 2] | 0, c[(c[h >> 2] | 0) + 468 >> 2] | 0) | 0) {
	                            i = f;
	                            return
	                        }
	                        c[z >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        c[(c[j >> 2] | 0) + 12 >> 2] = 0;
	                        c[B >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                        c[(c[j >> 2] | 0) + 16 >> 2] = 0;
	                        while (1) {
	                            if (!(c[z >> 2] | 0))break;
	                            c[A >> 2] = c[(c[z >> 2] | 0) + 24 >> 2];
	                            c[(c[z >> 2] | 0) + 24 >> 2] = 0;
	                            c[(c[z >> 2] | 0) + 20 >> 2] = 0;
	                            c[y >> 2] = Ii(c[z >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 1) | 0;
	                            if (c[y >> 2] | 0) {
	                                if (!(c[c[y >> 2] >> 2] | 0))c[c[y >> 2] >> 2] = c[c[z >> 2] >> 2];
	                                if (!(c[C >> 2] | 0))c[C >> 2] = c[z >> 2];
	                                zi(c[j >> 2] | 0, c[y >> 2] | 0) | 0;
	                                zi(c[(c[h >> 2] | 0) + 52 >> 2] | 0, c[z >> 2] | 0) | 0
	                            }
	                            if ((c[z >> 2] | 0) == (c[B >> 2] | 0))break;
	                            c[z >> 2] = c[A >> 2]
	                        }
	                        if (!(c[(c[j >> 2] | 0) + 68 >> 2] | 0))c[(c[j >> 2] | 0) + 68 >> 2] = 1;
	                        if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 2)Ug(c[j >> 2] | 0, c[C >> 2] | 0, c[y >> 2] | 0)
	                    } else E = 107; while (0);
	                    if ((E | 0) == 107) {
	                        c[v >> 2] = 0;
	                        c[x >> 2] = 0;
	                        y = (c[h >> 2] | 0) + 468 | 0;
	                        c[y >> 2] = (c[y >> 2] | 0) + ((c[(c[j >> 2] | 0) + 44 >> 2] | 0) + 5);
	                        if (sg(c[h >> 2] | 0, 0, c[j >> 2] | 0, c[(c[h >> 2] | 0) + 468 >> 2] | 0) | 0) {
	                            i = f;
	                            return
	                        }
	                        c[w >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[w >> 2] | 0))break;
	                            c[v >> 2] = Ii(c[w >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 1) | 0;
	                            if (c[v >> 2] | 0) {
	                                if (!(c[c[v >> 2] >> 2] | 0))c[c[v >> 2] >> 2] = c[c[w >> 2] >> 2];
	                                if (!(c[x >> 2] | 0))c[x >> 2] = c[v >> 2];
	                                c[v >> 2] = zi(c[(c[h >> 2] | 0) + 52 >> 2] | 0, c[v >> 2] | 0) | 0
	                            }
	                            if ((c[w >> 2] | 0) == (c[(c[j >> 2] | 0) + 16 >> 2] | 0)) {
	                                E = 117;
	                                break
	                            }
	                            c[w >> 2] = c[(c[w >> 2] | 0) + 24 >> 2]
	                        }
	                        if ((((E | 0) == 117 ? ((c[v >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 436 >> 2] | 0) == 5 : 0) : 0) ? (c[(c[v >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[v >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)b[(c[v >> 2] | 0) + 58 >> 1] = 1;
	                        if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 2)Ug(c[j >> 2] | 0, c[x >> 2] | 0, c[v >> 2] | 0)
	                    }
	                    c[(c[h >> 2] | 0) + 264 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 260 >> 2] = 0;
	                    i = f;
	                    return
	                }
	                c[k >> 2] = c[(c[j >> 2] | 0) + 40 >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[c[h >> 2] >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[c[h >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (c[(c[h >> 2] | 0) + 212 >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                j = c[(c[c[h >> 2] >> 2] | 0) + 68 >> 2] | 0;
	                v = c[(c[h >> 2] | 0) + 4 >> 2] | 0;
	                h = c[k >> 2] | 0;
	                x = xy(c[k >> 2] | 0) | 0;
	                Db[j & 511](v, h, x);
	                i = f;
	                return
	            }

	            function Ef(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 38) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                me(c[f >> 2] | 0);
	                c[g >> 2] = Ze(c[f >> 2] | 0) | 0;
	                a = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    xg(a, 68, 68648);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                k = c[f >> 2] | 0;
	                if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 59) {
	                    og(k, 23, 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                me(k);
	                if ((c[(c[f >> 2] | 0) + 360 >> 2] & 1048576 | 0) == 0 ? (c[h >> 2] = Yc(c[g >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                k = (c[f >> 2] | 0) + 440 | 0;
	                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                if (c[c[f >> 2] >> 2] | 0) {
	                    if (c[(c[c[f >> 2] >> 2] | 0) + 20 >> 2] | 0)c[h >> 2] = Hb[c[(c[c[f >> 2] >> 2] | 0) + 20 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (((c[h >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 1 : 0) ? (c[(c[f >> 2] | 0) + 360 >> 2] & 1048576 | 0) != 0 : 0)c[h >> 2] = Yc(c[g >> 2] | 0) | 0;
	                    if (((c[h >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 1 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == (c[f >> 2] | 0) : 0)c[h >> 2] = VP(c[f >> 2] | 0, c[g >> 2] | 0) | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                do if (c[h >> 2] | 0) {
	                    k = c[f >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) == 3) {
	                        pg(k, 28, 68712, c[g >> 2] | 0);
	                        break
	                    }
	                    if ((c[k + 172 >> 2] | 0) == 12 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) == 2 : 0) {
	                        pg(c[f >> 2] | 0, 29, 68752, c[g >> 2] | 0);
	                        break
	                    }
	                    if (((c[h >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 172 >> 2] | 0) == 12 : 0) ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) != 6 : 0) {
	                        if ((c[(c[h >> 2] | 0) + 72 >> 2] & 1 | 0) == 0 ? (c[(c[h >> 2] | 0) + 72 >> 2] | 0) != 0 : 0)break;
	                        if (!(c[(c[h >> 2] | 0) + 40 >> 2] | 0))break;
	                        if (!(vy(c[(c[h >> 2] | 0) + 40 >> 2] | 0, 60) | 0))break;
	                        pg(c[f >> 2] | 0, 38, 68800, c[g >> 2] | 0);
	                        break
	                    }
	                    if (((c[(c[h >> 2] | 0) + 48 >> 2] | 0) + -4 | 0) >>> 0 < 2)pg(c[f >> 2] | 0, 30, 68856, c[g >> 2] | 0)
	                } else {
	                    do if ((c[(c[f >> 2] | 0) + 28 >> 2] | 0) != 1) {
	                        if ((c[(c[f >> 2] | 0) + 88 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 92 >> 2] | 0) == 0 : 0) {
	                            l = 30;
	                            break
	                        }
	                        Lg(c[f >> 2] | 0, 27, 68680, c[g >> 2] | 0);
	                        if (((c[(c[f >> 2] | 0) + 216 >> 2] | 0) == 0 ? (c[c[f >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[f >> 2] >> 2] | 0) + 64 >> 2] | 0) != 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 64 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0)
	                    } else l = 30; while (0);
	                    if ((l | 0) == 30)pg(c[f >> 2] | 0, 26, 68680, c[g >> 2] | 0);
	                    sg(c[f >> 2] | 0, 0, c[h >> 2] | 0, 0) | 0;
	                    c[(c[f >> 2] | 0) + 100 >> 2] = 0
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function Ff(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                a = (c[e >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                Ue(c[e >> 2] | 0) | 0;
	                c[f >> 2] = Ze(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0))xg(c[e >> 2] | 0, 68, 68984);
	                c[(c[e >> 2] | 0) + 220 >> 2] = c[f >> 2];
	                Ue(c[e >> 2] | 0) | 0;
	                c[h >> 2] = jf(c[e >> 2] | 0, g, 1) | 0;
	                if ((c[h >> 2] | 0) != 0 | (c[g >> 2] | 0) != 0)c[(c[e >> 2] | 0) + 88 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 224 >> 2] = c[h >> 2];
	                c[(c[e >> 2] | 0) + 228 >> 2] = c[g >> 2];
	                Ue(c[e >> 2] | 0) | 0;
	                if (((c[c[e >> 2] >> 2] | 0) != 0 ? (c[c[c[e >> 2] >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Jb[c[c[c[e >> 2] >> 2] >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = b;
	                    return
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 91) {
	                    i = b;
	                    return
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62)og(c[e >> 2] | 0, 61, 0);
	                me(c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function Gf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[c[h >> 2] >> 2] = 0;
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                c[j >> 2] = Ze(c[g >> 2] | 0) | 0;
	                b = c[g >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    xg(b, 68, 69032);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                Ue(b) | 0;
	                b = c[g >> 2] | 0;
	                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 61) {
	                    pg(b, 41, 69064, c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                me(b);
	                Ue(c[g >> 2] | 0) | 0;
	                c[k >> 2] = ef(c[g >> 2] | 0) | 0;
	                c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                if (((c[(c[g >> 2] | 0) + 268 >> 2] | 0) != 0 ? (qy(c[j >> 2] | 0, 69112) | 0) != 0 : 0) ? (Ne(c[k >> 2] | 0) | 0) == 0 : 0)rg(c[g >> 2] | 0, 98, 69128, c[k >> 2] | 0, 0);
	                do if (qy(c[j >> 2] | 0, 69168) | 0) {
	                    if (qy(c[k >> 2] | 0, 69184) | 0) {
	                        c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] = 0;
	                        break
	                    }
	                    b = (qy(c[k >> 2] | 0, 69192) | 0) != 0;
	                    a = c[g >> 2] | 0;
	                    if (b) {
	                        c[c[a + 232 >> 2] >> 2] = 1;
	                        break
	                    } else {
	                        rg(a, 102, 69208, c[k >> 2] | 0, 0);
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[k >> 2];
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Hf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b + 44 | 0;
	                f = b + 40 | 0;
	                g = b + 36 | 0;
	                h = b + 32 | 0;
	                j = b + 28 | 0;
	                k = b + 24 | 0;
	                l = b + 20 | 0;
	                m = b + 16 | 0;
	                n = b + 12 | 0;
	                o = b + 8 | 0;
	                p = b + 4 | 0;
	                q = b;
	                c[f >> 2] = a;
	                c[k >> 2] = c[(c[f >> 2] | 0) + 300 >> 2];
	                c[l >> 2] = 0;
	                c[m >> 2] = c[(c[f >> 2] | 0) + 304 >> 2];
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    c[e >> 2] = 0;
	                    r = c[e >> 2] | 0;
	                    i = b;
	                    return r | 0
	                }
	                a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                a = (c[f >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                c[g >> 2] = Ze(c[f >> 2] | 0) | 0;
	                a = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    xg(a, 68, 69280);
	                    c[e >> 2] = 0;
	                    r = c[e >> 2] | 0;
	                    i = b;
	                    return r | 0
	                }
	                Ue(a) | 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                while (1) {
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break;
	                    if (!(9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))s = 15;
	                    if (((s | 0) == 15 ? (s = 0, (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) : 0) ? 32 > (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)break;
	                    if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                    c[o >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    c[p >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                    c[h >> 2] = Gf(c[f >> 2] | 0, j) | 0;
	                    a:do if (!((c[h >> 2] | 0) != 0 & (c[j >> 2] | 0) != 0)) {
	                        if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0)
	                    } else {
	                        c[n >> 2] = 0;
	                        while (1) {
	                            if ((c[n >> 2] | 0) >= (c[l >> 2] | 0))break;
	                            if (qy(c[(c[k >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0, c[h >> 2] | 0) | 0) {
	                                s = 22;
	                                break
	                            }
	                            c[n >> 2] = (c[n >> 2] | 0) + 2
	                        }
	                        if ((s | 0) == 22) {
	                            s = 0;
	                            Vg(c[f >> 2] | 0, 0, c[h >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            break
	                        }
	                        do if (c[k >> 2] | 0) {
	                            if (((c[l >> 2] | 0) + 4 | 0) > (c[m >> 2] | 0)) {
	                                c[m >> 2] = c[m >> 2] << 1;
	                                c[q >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[m >> 2] << 2) | 0;
	                                if (c[q >> 2] | 0) {
	                                    c[k >> 2] = c[q >> 2];
	                                    c[(c[f >> 2] | 0) + 300 >> 2] = c[k >> 2];
	                                    c[(c[f >> 2] | 0) + 304 >> 2] = c[m >> 2];
	                                    break
	                                }
	                                ie(c[f >> 2] | 0, 0);
	                                if (!(c[j >> 2] | 0))break a;
	                                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                break a
	                            }
	                        } else {
	                            c[m >> 2] = 22;
	                            c[k >> 2] = Cb[c[135744 >> 2] & 511](c[m >> 2] << 2) | 0;
	                            if (c[k >> 2] | 0) {
	                                c[(c[f >> 2] | 0) + 300 >> 2] = c[k >> 2];
	                                c[(c[f >> 2] | 0) + 304 >> 2] = c[m >> 2];
	                                break
	                            }
	                            ie(c[f >> 2] | 0, 0);
	                            if (!(c[j >> 2] | 0))break a;
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            break a
	                        } while (0);
	                        a = c[h >> 2] | 0;
	                        t = c[l >> 2] | 0;
	                        c[l >> 2] = t + 1;
	                        c[(c[k >> 2] | 0) + (t << 2) >> 2] = a;
	                        a = c[j >> 2] | 0;
	                        t = c[l >> 2] | 0;
	                        c[l >> 2] = t + 1;
	                        c[(c[k >> 2] | 0) + (t << 2) >> 2] = a;
	                        c[(c[k >> 2] | 0) + (c[l >> 2] << 2) >> 2] = 0;
	                        c[(c[k >> 2] | 0) + ((c[l >> 2] | 0) + 1 << 2) >> 2] = 0
	                    } while (0);
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break;
	                    do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[f >> 2] | 0, 65, 69320)
	                    } while (0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    if ((c[p >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) ? ((c[h >> 2] | 0) == 0 ? (c[o >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) : 0) & (c[j >> 2] | 0) == 0 : 0) {
	                        s = 50;
	                        break
	                    }
	                    if (((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                    if (c[(c[f >> 2] | 0) + 292 >> 2] | 0)continue;
	                    if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)continue;
	                    vg(c[f >> 2] | 0)
	                }
	                if ((s | 0) == 50)xg(c[f >> 2] | 0, 1, 69352);
	                do if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 56 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                    s = c[(c[c[f >> 2] >> 2] | 0) + 56 >> 2] | 0;
	                    j = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                    o = c[g >> 2] | 0;
	                    if ((c[l >> 2] | 0) > 0) {
	                        Db[s & 511](j, o, c[k >> 2] | 0);
	                        break
	                    } else {
	                        Db[s & 511](j, o, 0);
	                        break
	                    }
	                } while (0);
	                b:do if (c[k >> 2] | 0) {
	                    c[n >> 2] = 1;
	                    while (1) {
	                        if ((c[n >> 2] | 0) >= (c[l >> 2] | 0))break b;
	                        if (c[(c[k >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 2
	                    }
	                } while (0);
	                c[e >> 2] = c[g >> 2];
	                r = c[e >> 2] | 0;
	                i = b;
	                return r | 0
	            }

	            function If(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 44 | 0;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 24 | 0;
	                m = e + 20 | 0;
	                n = e + 16 | 0;
	                o = e + 12 | 0;
	                p = e + 8 | 0;
	                q = e + 4 | 0;
	                r = e;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[j >> 2] = 100;
	                c[q >> 2] = 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 91) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 67) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 68) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 65) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 84) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 65) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) != 91) {
	                    i = e;
	                    return
	                }
	                b = (c[f >> 2] | 0) + 200 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 9;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 9;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 9;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 172 >> 2] = 8;
	                c[k >> 2] = ne(c[f >> 2] | 0, l) | 0;
	                b = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (!(9 <= (b | 0) & (c[k >> 2] | 0) <= 10 | (c[k >> 2] | 0) == 13 | 32 <= (c[k >> 2] | 0)))s = 20
	                } else if ((!(256 <= (b | 0) & (c[k >> 2] | 0) <= 55295) ? !(57344 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 1114111) : 0)s = 20;
	                if ((s | 0) == 20) {
	                    og(c[f >> 2] | 0, 63, 0);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = 7;
	                    i = e;
	                    return
	                }
	                b = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                    t = b + 28 | 0;
	                    c[t >> 2] = (c[t >> 2] | 0) + 1;
	                    c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                } else {
	                    t = b + 32 | 0;
	                    c[t >> 2] = (c[t >> 2] | 0) + 1
	                }
	                t = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[t >> 2] = (c[t >> 2] | 0) + (c[l >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                c[m >> 2] = ne(c[f >> 2] | 0, n) | 0;
	                t = c[m >> 2] | 0;
	                if ((c[m >> 2] | 0) < 256) {
	                    if (!(9 <= (t | 0) & (c[m >> 2] | 0) <= 10 | (c[m >> 2] | 0) == 13 | 32 <= (c[m >> 2] | 0)))s = 31
	                } else if ((!(256 <= (t | 0) & (c[m >> 2] | 0) <= 55295) ? !(57344 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 1114111) : 0)s = 31;
	                if ((s | 0) == 31) {
	                    og(c[f >> 2] | 0, 63, 0);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = 7;
	                    i = e;
	                    return
	                }
	                t = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                    b = t + 28 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1;
	                    c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                } else {
	                    b = t + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + (c[n >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                c[o >> 2] = ne(c[f >> 2] | 0, p) | 0;
	                c[g >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    ie(c[f >> 2] | 0, 0);
	                    i = e;
	                    return
	                }
	                while (1) {
	                    b = c[o >> 2] | 0;
	                    do if ((c[o >> 2] | 0) < 256)if (9 <= (b | 0) & (c[o >> 2] | 0) <= 10 | (c[o >> 2] | 0) == 13 | 32 <= (c[o >> 2] | 0))s = 44; else u = 0; else {
	                        if (256 <= (b | 0) & (c[o >> 2] | 0) <= 55295) {
	                            s = 44;
	                            break
	                        }
	                        if (57344 <= (c[o >> 2] | 0) & (c[o >> 2] | 0) <= 65533) {
	                            s = 44;
	                            break
	                        }
	                        if (65536 <= (c[o >> 2] | 0) & (c[o >> 2] | 0) <= 1114111)s = 44; else u = 0
	                    } while (0);
	                    do if ((s | 0) == 44) {
	                        s = 0;
	                        if ((c[k >> 2] | 0) != 93 | (c[m >> 2] | 0) != 93) {
	                            u = 1;
	                            break
	                        }
	                        u = (c[o >> 2] | 0) != 62
	                    } while (0);
	                    v = c[h >> 2] | 0;
	                    if (!u) {
	                        s = 70;
	                        break
	                    }
	                    if ((v + 5 | 0) >= (c[j >> 2] | 0)) {
	                        if ((c[j >> 2] | 0) > 1e7 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            s = 50;
	                            break
	                        }
	                        c[r >> 2] = Hb[c[135760 >> 2] & 511](c[g >> 2] | 0, c[j >> 2] << 1) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            s = 52;
	                            break
	                        }
	                        c[g >> 2] = c[r >> 2];
	                        c[j >> 2] = c[j >> 2] << 1
	                    }
	                    if ((c[l >> 2] | 0) == 1) {
	                        b = c[k >> 2] & 255;
	                        t = c[h >> 2] | 0;
	                        c[h >> 2] = t + 1;
	                        a[(c[g >> 2] | 0) + t >> 0] = b
	                    } else {
	                        b = pe((c[g >> 2] | 0) + (c[h >> 2] | 0) | 0, c[k >> 2] | 0) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + b
	                    }
	                    c[k >> 2] = c[m >> 2];
	                    c[l >> 2] = c[n >> 2];
	                    c[m >> 2] = c[o >> 2];
	                    c[n >> 2] = c[p >> 2];
	                    c[q >> 2] = (c[q >> 2] | 0) + 1;
	                    if ((c[q >> 2] | 0) > 50) {
	                        do if (!(c[(c[f >> 2] | 0) + 292 >> 2] | 0)) {
	                            if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                            vg(c[f >> 2] | 0)
	                        } while (0);
	                        if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            s = 62;
	                            break
	                        }
	                        c[q >> 2] = 0
	                    }
	                    b = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        t = b + 28 | 0;
	                        c[t >> 2] = (c[t >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        t = b + 32 | 0;
	                        c[t >> 2] = (c[t >> 2] | 0) + 1
	                    }
	                    t = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[t >> 2] = (c[t >> 2] | 0) + (c[p >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    c[o >> 2] = ne(c[f >> 2] | 0, p) | 0
	                }
	                if ((s | 0) == 50) {
	                    pg(c[f >> 2] | 0, 63, 69400, 0);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    i = e;
	                    return
	                } else if ((s | 0) == 52) {
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    ie(c[f >> 2] | 0, 0);
	                    i = e;
	                    return
	                } else if ((s | 0) == 62) {
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    i = e;
	                    return
	                } else if ((s | 0) == 70) {
	                    a[(c[g >> 2] | 0) + v >> 0] = 0;
	                    c[(c[f >> 2] | 0) + 172 >> 2] = 7;
	                    v = c[f >> 2] | 0;
	                    if ((c[o >> 2] | 0) != 62) {
	                        pg(v, 63, 69432, c[g >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    o = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[v + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        v = o + 28 | 0;
	                        c[v >> 2] = (c[v >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        v = o + 32 | 0;
	                        c[v >> 2] = (c[v >> 2] | 0) + 1
	                    }
	                    v = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[v >> 2] = (c[v >> 2] | 0) + (c[p >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    do if (c[c[f >> 2] >> 2] | 0) {
	                        if (c[(c[f >> 2] | 0) + 212 >> 2] | 0)break;
	                        p = c[c[f >> 2] >> 2] | 0;
	                        if (c[(c[c[f >> 2] >> 2] | 0) + 100 >> 2] | 0) {
	                            Db[c[p + 100 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                            break
	                        }
	                        if (!(c[p + 68 >> 2] | 0))break;
	                        Db[c[(c[c[f >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0)
	                    } while (0);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    i = e;
	                    return
	                }
	            }

	            function Jf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[e >> 2] | 0);
	                while (1) {
	                    if (!(d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                        j = 45;
	                        break
	                    }
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        j = 45;
	                        break
	                    }
	                    if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        j = 45;
	                        break
	                    }
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    c[g >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                    c[h >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[h >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0)mf(c[e >> 2] | 0); else j = 11;
	                    do if ((j | 0) == 11) {
	                        j = 0;
	                        if (((((((((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 91 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 67 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 65 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 84 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 65 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) == 91 : 0) {
	                            If(c[e >> 2] | 0);
	                            break
	                        }
	                        if ((((d[c[h >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0) {
	                            kf(c[e >> 2] | 0);
	                            c[(c[e >> 2] | 0) + 172 >> 2] = 7;
	                            break
	                        }
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) == 60) {
	                            Kf(c[e >> 2] | 0);
	                            break
	                        }
	                        a = c[e >> 2] | 0;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) == 38) {
	                            Df(a);
	                            break
	                        } else {
	                            hf(a, 0);
	                            break
	                        }
	                    } while (0);
	                    if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[e >> 2] | 0);
	                    while (1) {
	                        if (!(d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))k = (c[(c[e >> 2] | 0) + 40 >> 2] | 0) > 1; else k = 0;
	                        l = c[e >> 2] | 0;
	                        if (!k)break;
	                        Ve(l) | 0
	                    }
	                    if (((c[l + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[e >> 2] | 0);
	                    if ((c[g >> 2] | 0) != (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0))continue;
	                    if ((c[f >> 2] | 0) == (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0)) {
	                        j = 44;
	                        break
	                    }
	                }
	                if ((j | 0) == 44) {
	                    og(c[e >> 2] | 0, 1, 69472);
	                    c[(c[e >> 2] | 0) + 172 >> 2] = -1;
	                    i = b;
	                    return
	                } else if ((j | 0) == 45) {
	                    i = b;
	                    return
	                }
	            }

	            function Kf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 64 | 0;
	                e = b + 48 | 0;
	                f = b + 44 | 0;
	                g = b + 40 | 0;
	                h = b + 36 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[l >> 2] = 0;
	                c[n >> 2] = c[(c[e >> 2] | 0) + 328 >> 2];
	                if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) >>> 0 > (c[16304] | 0) >>> 0 ? (c[(c[e >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                    ng(c[e >> 2] | 0, 1, 65224, c[16304] | 0);
	                    c[(c[e >> 2] | 0) + 172 >> 2] = -1;
	                    i = b;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 68 >> 2] | 0) {
	                    c[j + 4 >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                    c[j + 8 >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2]
	                }
	                a = c[e >> 2] | 0;
	                do if (c[(c[e >> 2] | 0) + 236 >> 2] | 0) {
	                    o = c[e >> 2] | 0;
	                    if ((c[c[a + 232 >> 2] >> 2] | 0) == -2) {
	                        Xg(o, -1) | 0;
	                        break
	                    } else {
	                        Xg(o, c[c[(c[e >> 2] | 0) + 232 >> 2] >> 2] | 0) | 0;
	                        break
	                    }
	                } else Xg(a, -1) | 0; while (0);
	                c[k >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                a = c[e >> 2] | 0;
	                if (c[(c[e >> 2] | 0) + 324 >> 2] | 0)c[f >> 2] = Yg(a, g, h, l) | 0; else c[f >> 2] = Hf(a) | 0;
	                if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = b;
	                    return
	                }
	                a = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Zg(a) | 0;
	                    i = b;
	                    return
	                }
	                Se(a, c[f >> 2] | 0) | 0;
	                c[m >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                if (((((c[(c[e >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 52 >> 2] | 0) == (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) : 0) {
	                    a = an((c[e >> 2] | 0) + 108 | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    o = (c[e >> 2] | 0) + 100 | 0;
	                    c[o >> 2] = c[o >> 2] & a
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                    a = (c[e >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 2;
	                    a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 2;
	                    a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 2;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                    a = (c[c[e >> 2] >> 2] | 0) != 0;
	                    if (c[(c[e >> 2] | 0) + 324 >> 2] | 0) {
	                        if ((a ? (c[(c[c[e >> 2] >> 2] | 0) + 120 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Jb[c[(c[c[e >> 2] >> 2] | 0) + 120 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0)
	                    } else if ((a ? (c[(c[c[e >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Ab[c[(c[c[e >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0);
	                    Te(c[e >> 2] | 0) | 0;
	                    Zg(c[e >> 2] | 0) | 0;
	                    if ((c[n >> 2] | 0) != (c[(c[e >> 2] | 0) + 328 >> 2] | 0))_g(c[e >> 2] | 0, (c[(c[e >> 2] | 0) + 328 >> 2] | 0) - (c[n >> 2] | 0) | 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    c[j + 12 >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                    c[j + 16 >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[j >> 2] = c[m >> 2];
	                    De(c[e >> 2] | 0, j);
	                    i = b;
	                    return
	                }
	                a = c[e >> 2] | 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62) {
	                    $g(a, 73, 69512, c[f >> 2] | 0, c[k >> 2] | 0, 0);
	                    Re(c[e >> 2] | 0) | 0;
	                    Te(c[e >> 2] | 0) | 0;
	                    Zg(c[e >> 2] | 0) | 0;
	                    if ((c[n >> 2] | 0) != (c[(c[e >> 2] | 0) + 328 >> 2] | 0))_g(c[e >> 2] | 0, (c[(c[e >> 2] | 0) + 328 >> 2] | 0) - (c[n >> 2] | 0) | 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 68 >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    c[j + 12 >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                    c[j + 16 >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[j >> 2] = c[m >> 2];
	                    De(c[e >> 2] | 0, j);
	                    i = b;
	                    return
	                }
	                o = (c[a + 36 >> 2] | 0) + 32 | 0;
	                c[o >> 2] = (c[o >> 2] | 0) + 1;
	                o = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[o >> 2] = (c[o >> 2] | 0) + 1;
	                o = (c[e >> 2] | 0) + 200 | 0;
	                c[o >> 2] = (c[o >> 2] | 0) + 1;
	                if (!(d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                Jf(c[e >> 2] | 0);
	                if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    i = b;
	                    return
	                }
	                if (!(9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))p = 55;
	                if (((p | 0) == 55 ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 : 0) ? 32 > (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0) {
	                    $g(c[e >> 2] | 0, 77, 69560, c[f >> 2] | 0, c[k >> 2] | 0, 0);
	                    Re(c[e >> 2] | 0) | 0;
	                    Te(c[e >> 2] | 0) | 0;
	                    Zg(c[e >> 2] | 0) | 0;
	                    if ((c[n >> 2] | 0) == (c[(c[e >> 2] | 0) + 328 >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    _g(c[e >> 2] | 0, (c[(c[e >> 2] | 0) + 328 >> 2] | 0) - (c[n >> 2] | 0) | 0) | 0;
	                    i = b;
	                    return
	                }
	                f = c[e >> 2] | 0;
	                if (c[(c[e >> 2] | 0) + 324 >> 2] | 0) {
	                    ah(f, c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, (c[(c[e >> 2] | 0) + 328 >> 2] | 0) - (c[n >> 2] | 0) | 0, c[l >> 2] | 0);
	                    Te(c[e >> 2] | 0) | 0
	                } else Wg(f, c[k >> 2] | 0);
	                if (!(c[m >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 68 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[j + 12 >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                c[j + 16 >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                c[j >> 2] = c[m >> 2];
	                De(c[e >> 2] | 0, j);
	                i = b;
	                return
	            }

	            function Lf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e + 24 | 0;
	                m = e;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 10;
	                c[h >> 2] = Cb[c[135752 >> 2] & 511](c[k >> 2] | 0) | 0;
	                b = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    ie(b, 0);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                a[l >> 0] = a[c[(c[b + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                if ((d[l >> 0] | 0 | 0) >= 48 ? (d[l >> 0] | 0 | 0) <= 57 : 0) {
	                    b = a[l >> 0] | 0;
	                    o = c[j >> 2] | 0;
	                    c[j >> 2] = o + 1;
	                    a[(c[h >> 2] | 0) + o >> 0] = b;
	                    me(c[g >> 2] | 0);
	                    a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    if ((d[l >> 0] | 0 | 0) != 46) {
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    b = a[l >> 0] | 0;
	                    o = c[j >> 2] | 0;
	                    c[j >> 2] = o + 1;
	                    a[(c[h >> 2] | 0) + o >> 0] = b;
	                    me(c[g >> 2] | 0);
	                    a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    while (1) {
	                        if ((d[l >> 0] | 0 | 0) >= 48)p = (d[l >> 0] | 0 | 0) <= 57; else p = 0;
	                        q = c[j >> 2] | 0;
	                        if (!p) {
	                            r = 17;
	                            break
	                        }
	                        if ((q + 1 | 0) >= (c[k >> 2] | 0)) {
	                            c[k >> 2] = c[k >> 2] << 1;
	                            c[m >> 2] = Hb[c[135760 >> 2] & 511](c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            if (!(c[m >> 2] | 0)) {
	                                r = 14;
	                                break
	                            }
	                            c[h >> 2] = c[m >> 2]
	                        }
	                        b = a[l >> 0] | 0;
	                        o = c[j >> 2] | 0;
	                        c[j >> 2] = o + 1;
	                        a[(c[h >> 2] | 0) + o >> 0] = b;
	                        me(c[g >> 2] | 0);
	                        a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0
	                    }
	                    if ((r | 0) == 14) {
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        ie(c[g >> 2] | 0, 0);
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((r | 0) == 17) {
	                        a[(c[h >> 2] | 0) + q >> 0] = 0;
	                        c[f >> 2] = c[h >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                }
	                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function Mf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e + 24 | 0;
	                m = e;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 10;
	                a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                if ((d[l >> 0] | 0 | 0) >= 97 ? (d[l >> 0] | 0 | 0) <= 122 : 0)n = 5; else n = 3;
	                do if ((n | 0) == 3) {
	                    if ((d[l >> 0] | 0 | 0) >= 65 ? (d[l >> 0] | 0 | 0) <= 90 : 0) {
	                        n = 5;
	                        break
	                    }
	                    og(c[g >> 2] | 0, 79, 0)
	                } while (0);
	                do if ((n | 0) == 5) {
	                    c[h >> 2] = Cb[c[135752 >> 2] & 511](c[k >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        ie(c[g >> 2] | 0, 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    b = a[l >> 0] | 0;
	                    p = c[j >> 2] | 0;
	                    c[j >> 2] = p + 1;
	                    a[(c[h >> 2] | 0) + p >> 0] = b;
	                    me(c[g >> 2] | 0);
	                    a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    while (1) {
	                        if ((d[l >> 0] | 0 | 0) >= 97 ? (d[l >> 0] | 0 | 0) <= 122 : 0)q = 1; else n = 10;
	                        do if ((n | 0) == 10) {
	                            n = 0;
	                            if ((d[l >> 0] | 0 | 0) >= 65 ? (d[l >> 0] | 0 | 0) <= 90 : 0) {
	                                q = 1;
	                                break
	                            }
	                            if ((d[l >> 0] | 0 | 0) >= 48 ? (d[l >> 0] | 0 | 0) <= 57 : 0) {
	                                q = 1;
	                                break
	                            }
	                            if ((d[l >> 0] | 0 | 0) != 46 ? (d[l >> 0] | 0 | 0) != 95 : 0)q = (d[l >> 0] | 0 | 0) == 45; else q = 1
	                        } while (0);
	                        r = c[j >> 2] | 0;
	                        if (!q) {
	                            n = 31;
	                            break
	                        }
	                        if ((r + 1 | 0) >= (c[k >> 2] | 0)) {
	                            c[k >> 2] = c[k >> 2] << 1;
	                            c[m >> 2] = Hb[c[135760 >> 2] & 511](c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            if (!(c[m >> 2] | 0))break;
	                            c[h >> 2] = c[m >> 2]
	                        }
	                        b = a[l >> 0] | 0;
	                        p = c[j >> 2] | 0;
	                        c[j >> 2] = p + 1;
	                        a[(c[h >> 2] | 0) + p >> 0] = b;
	                        me(c[g >> 2] | 0);
	                        a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                        if (d[l >> 0] | 0)continue;
	                        if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                        if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                        a[l >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0
	                    }
	                    if ((n | 0) == 31) {
	                        a[(c[h >> 2] | 0) + r >> 0] = 0;
	                        break
	                    }
	                    ie(c[g >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } while (0);
	                c[f >> 2] = c[h >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Nf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = -2;
	                Ue(c[f >> 2] | 0) | 0;
	                do if ((((((((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 115 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 116 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 97 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 100 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 97 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) == 111 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 9 >> 0] | 0 | 0) == 101 : 0) {
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 10;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 10;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 10;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 61) {
	                        og(a, 75, 0);
	                        c[e >> 2] = c[g >> 2];
	                        h = c[e >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                    me(a);
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39) {
	                        me(a);
	                        do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 110 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 111 : 0) {
	                            c[g >> 2] = 0;
	                            j = (c[f >> 2] | 0) + 200 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 2;
	                            j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 2;
	                            j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 2;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                            if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)break;
	                            if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                            Ve(c[f >> 2] | 0) | 0
	                        } else k = 26; while (0);
	                        a:do if ((k | 0) == 26) {
	                            do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 121) {
	                                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 101)break;
	                                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 115)break;
	                                c[g >> 2] = 1;
	                                j = (c[f >> 2] | 0) + 200 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                                if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)break a;
	                                if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break a;
	                                Ve(c[f >> 2] | 0) | 0;
	                                break a
	                            } while (0);
	                            og(c[f >> 2] | 0, 78, 0)
	                        } while (0);
	                        j = c[f >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 39) {
	                            og(j, 34, 0);
	                            break
	                        } else {
	                            me(j);
	                            break
	                        }
	                    }
	                    j = c[f >> 2] | 0;
	                    if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34) {
	                        og(j, 33, 0);
	                        break
	                    }
	                    me(j);
	                    do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 110 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 111 : 0) {
	                        c[g >> 2] = 0;
	                        j = (c[f >> 2] | 0) + 200 | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 2;
	                        j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 2;
	                        j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 2;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)break;
	                        if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                        Ve(c[f >> 2] | 0) | 0
	                    } else k = 46; while (0);
	                    b:do if ((k | 0) == 46) {
	                        do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 121) {
	                            if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 101)break;
	                            if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 115)break;
	                            c[g >> 2] = 1;
	                            a = (c[f >> 2] | 0) + 200 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 3;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                            if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)break b;
	                            if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break b;
	                            Ve(c[f >> 2] | 0) | 0;
	                            break b
	                        } while (0);
	                        og(c[f >> 2] | 0, 78, 0)
	                    } while (0);
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 34) {
	                        og(a, 34, 0);
	                        break
	                    } else {
	                        me(a);
	                        break
	                    }
	                } while (0);
	                c[e >> 2] = c[g >> 2];
	                h = c[e >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Of(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 52 >> 2] = -2;
	                a = (c[e >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 5;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 5;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 5;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0;
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)xg(c[e >> 2] | 0, 65, 69720)
	                } while (0);
	                Ue(c[e >> 2] | 0) | 0;
	                c[f >> 2] = Af(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0))og(c[e >> 2] | 0, 96, 0); else {
	                    do if (!(qy(c[f >> 2] | 0, 68488) | 0)) {
	                        if (c[(c[e >> 2] | 0) + 360 >> 2] & 131072) {
	                            pg(c[e >> 2] | 0, 108, 69752, c[f >> 2] | 0);
	                            break
	                        }
	                        if ((d[c[f >> 2] >> 0] | 0 | 0) == 49 ? (d[(c[f >> 2] | 0) + 1 >> 0] | 0 | 0) == 46 : 0) {
	                            rg(c[e >> 2] | 0, 97, 69752, c[f >> 2] | 0, 0);
	                            break
	                        }
	                        pg(c[e >> 2] | 0, 108, 69752, c[f >> 2] | 0)
	                    } while (0);
	                    if (c[(c[e >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 20 >> 2] = c[f >> 2]
	                }
	                do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 63 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                            f = (c[e >> 2] | 0) + 200 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2;
	                            f = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2;
	                            f = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                            if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                                i = b;
	                                return
	                            }
	                            if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                                i = b;
	                                return
	                            }
	                            Ve(c[e >> 2] | 0) | 0;
	                            i = b;
	                            return
	                        }
	                        xg(c[e >> 2] | 0, 65, 69784)
	                    }
	                } while (0);
	                Bf(c[e >> 2] | 0) | 0;
	                if ((c[(c[e >> 2] | 0) + 84 >> 2] | 0) == 32) {
	                    i = b;
	                    return
	                }
	                do if ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0) != 0 ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32 : 0) {
	                    if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 63 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                            f = (c[e >> 2] | 0) + 200 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2;
	                            f = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2;
	                            f = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 2;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                            if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                                i = b;
	                                return
	                            }
	                            if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                                i = b;
	                                return
	                            }
	                            Ve(c[e >> 2] | 0) | 0;
	                            i = b;
	                            return
	                        }
	                        xg(c[e >> 2] | 0, 65, 69784)
	                    }
	                } while (0);
	                if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[e >> 2] | 0);
	                Ue(c[e >> 2] | 0) | 0;
	                f = Nf(c[e >> 2] | 0) | 0;
	                c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 52 >> 2] = f;
	                Ue(c[e >> 2] | 0) | 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 63 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                    f = (c[e >> 2] | 0) + 200 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + 2;
	                    f = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + 2;
	                    f = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + 2;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[e >> 2] | 0);
	                    if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                        i = b;
	                        return
	                    }
	                    if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                        i = b;
	                        return
	                    }
	                    Ve(c[e >> 2] | 0) | 0;
	                    i = b;
	                    return
	                }
	                f = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62;
	                og(c[e >> 2] | 0, 57, 0);
	                if (f) {
	                    me(c[e >> 2] | 0);
	                    i = b;
	                    return
	                }
	                while (1) {
	                    if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)g = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62; else g = 0;
	                    h = c[e >> 2] | 0;
	                    if (!g)break;
	                    f = (c[h + 36 >> 2] | 0) + 16 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                me(h);
	                i = b;
	                return
	            }

	            function Pf(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a:while (1) {
	                    if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        f = 22;
	                        break
	                    }
	                    if (!((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0))f = 5;
	                    do if ((f | 0) == 5) {
	                        f = 0;
	                        if ((((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0)break;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                                f = 22;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) {
	                        mf(c[e >> 2] | 0);
	                        continue
	                    }
	                    do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                            kf(c[e >> 2] | 0);
	                            continue a
	                        }
	                    } while (0);
	                    me(c[e >> 2] | 0)
	                }
	                if ((f | 0) == 22) {
	                    i = b;
	                    return
	                }
	            }

	            function Qf(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e + 12 | 0;
	                j = e;
	                c[g >> 2] = b;
	                Rf();
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    Rg(c[g >> 2] | 0);
	                    if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)Ab[c[(c[c[g >> 2] >> 2] | 0) + 44 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, 136080);
	                    if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    if (((c[(c[g >> 2] | 0) + 24 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 : 0) ? (a[h >> 0] = a[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0, a[h + 1 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0, a[h + 2 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0, a[h + 3 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0, c[j >> 2] = sd(h, 4) | 0, (c[j >> 2] | 0) != 0) : 0)re(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if (!(d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))og(c[g >> 2] | 0, 4, 0);
	                    if ((((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 35 ? (c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    a:do if (((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 108 : 0) {
	                        do if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 13) {
	                                l = 34;
	                                break a
	                            }
	                        } while (0);
	                        Of(c[g >> 2] | 0);
	                        if ((c[(c[g >> 2] | 0) + 84 >> 2] | 0) != 32) {
	                            c[(c[g >> 2] | 0) + 28 >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 52 >> 2];
	                            Ue(c[g >> 2] | 0) | 0;
	                            break
	                        }
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } else l = 34; while (0);
	                    if ((l | 0) == 34) {
	                        l = oy(68488) | 0;
	                        c[(c[g >> 2] | 0) + 20 >> 2] = l
	                    }
	                    if (((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 48 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                    if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    if ((((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[g >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[g >> 2] | 0) + 36 >> 2] >> 2] | 0) + 24 >> 2] | 0) >= 0 : 0)c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 36 >> 2] = c[(c[c[(c[g >> 2] | 0) + 36 >> 2] >> 2] | 0) + 24 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    Pf(c[g >> 2] | 0);
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    do if ((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 79 : 0) {
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 67)break;
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 84)break;
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 89)break;
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 80)break;
	                        if ((d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) != 69)break;
	                        c[(c[g >> 2] | 0) + 216 >> 2] = 1;
	                        Ff(c[g >> 2] | 0);
	                        do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 91) {
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 3;
	                            bh(c[g >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) != -1)break;
	                            c[f >> 2] = -1;
	                            k = c[f >> 2] | 0;
	                            i = e;
	                            return k | 0
	                        } while (0);
	                        c[(c[g >> 2] | 0) + 216 >> 2] = 2;
	                        do if (c[c[g >> 2] >> 2] | 0) {
	                            if (!(c[(c[c[g >> 2] >> 2] | 0) + 104 >> 2] | 0))break;
	                            if (c[(c[g >> 2] | 0) + 212 >> 2] | 0)break;
	                            Jb[c[(c[c[g >> 2] >> 2] | 0) + 104 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[(c[g >> 2] | 0) + 220 >> 2] | 0, c[(c[g >> 2] | 0) + 228 >> 2] | 0, c[(c[g >> 2] | 0) + 224 >> 2] | 0)
	                        } while (0);
	                        if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) != -1) {
	                            c[(c[g >> 2] | 0) + 216 >> 2] = 0;
	                            ch(c[g >> 2] | 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 4;
	                            Pf(c[g >> 2] | 0);
	                            break
	                        }
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } while (0);
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                    l = c[g >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60)xg(l, 4, 69808); else {
	                        c[l + 172 >> 2] = 7;
	                        Kf(c[g >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 172 >> 2] = 14;
	                        Pf(c[g >> 2] | 0);
	                        if (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)og(c[g >> 2] | 0, 5, 0);
	                        c[(c[g >> 2] | 0) + 172 >> 2] = -1
	                    }
	                    do if (c[c[g >> 2] >> 2] | 0) {
	                        if (!(c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] | 0))break;
	                        zb[c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0)
	                    } while (0);
	                    do if (c[(c[g >> 2] | 0) + 8 >> 2] | 0) {
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 56 >> 2] | 0, 67096) | 0))break;
	                        Th(c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 8 >> 2] = 0
	                    } while (0);
	                    do if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                        if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0))break;
	                        l = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 92 | 0;
	                        c[l >> 2] = c[l >> 2] | 1;
	                        if (c[(c[g >> 2] | 0) + 100 >> 2] | 0) {
	                            l = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 92 | 0;
	                            c[l >> 2] = c[l >> 2] | 8
	                        }
	                        if (c[(c[g >> 2] | 0) + 356 >> 2] | 0) {
	                            l = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 92 | 0;
	                            c[l >> 2] = c[l >> 2] | 2
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 360 >> 2] & 131072))break;
	                        l = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 92 | 0;
	                        c[l >> 2] = c[l >> 2] | 4
	                    } while (0);
	                    if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } else {
	                        c[(c[g >> 2] | 0) + 100 >> 2] = 0;
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                }
	                c[f >> 2] = -1;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Rf() {
	                var a = 0;
	                a = i;
	                if (c[17532] | 0) {
	                    i = a;
	                    return
	                }
	                zx();
	                lx();
	                if ((c[33976] | 0) == 35 | (c[33976] | 0) == 0)Ud(0);
	                ll() | 0;
	                tP() | 0;
	                Ad();
	                pQ();
	                tk();
	                uk();
	                ao();
	                rQ();
	                Kq();
	                Aw();
	                c[17532] = 1;
	                i = a;
	                return
	            }

	            function Sf(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0;
	                g = i;
	                i = i + 96 | 0;
	                h = g;
	                j = g + 80 | 0;
	                k = g + 76 | 0;
	                l = g + 72 | 0;
	                m = g + 68 | 0;
	                n = g + 64 | 0;
	                o = g + 60 | 0;
	                p = g + 56 | 0;
	                q = g + 52 | 0;
	                r = g + 48 | 0;
	                s = g + 44 | 0;
	                t = g + 40 | 0;
	                u = g + 36 | 0;
	                v = g + 32 | 0;
	                w = g + 28 | 0;
	                x = g + 24 | 0;
	                y = g + 20 | 0;
	                z = g + 16 | 0;
	                A = g + 12 | 0;
	                B = g + 8 | 0;
	                C = g + 4 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = 1;
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                }
	                if ((c[(c[k >> 2] | 0) + 84 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 212 >> 2] | 0) == 1 : 0) {
	                    c[j >> 2] = c[(c[k >> 2] | 0) + 84 >> 2];
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                }
	                if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[j >> 2] = -1;
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                }
	                if (!(c[(c[k >> 2] | 0) + 172 >> 2] | 0))Rg(c[k >> 2] | 0);
	                if (!((c[m >> 2] | 0) > 0 & (c[l >> 2] | 0) != 0 ^ 1 | (c[n >> 2] | 0) != 0) ? (a[(c[l >> 2] | 0) + ((c[m >> 2] | 0) - 1) >> 0] | 0) == 13 : 0) {
	                    c[o >> 2] = 1;
	                    c[m >> 2] = (c[m >> 2] | 0) + -1
	                }
	                while (1) {
	                    if ((((c[m >> 2] | 0) > 0 & (c[l >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) != -1 : 0) {
	                        c[s >> 2] = jz(c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[t >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                        c[q >> 2] = _y(c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        do if ((((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            c[v >> 2] = 45;
	                            do if ((yy(c[c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] >> 2] | 0, 69608) | 0) == 0 ? (yy(c[c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] >> 2] | 0, 69616) | 0) == 0 : 0) {
	                                if ((yy(c[c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] >> 2] | 0, 69848) | 0) == 0 ? (yy(c[c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 12 >> 2] >> 2] | 0, 69856) | 0) == 0 : 0)break;
	                                c[v >> 2] = 180
	                            } else E = 23; while (0);
	                            if ((E | 0) == 23) {
	                                E = 0;
	                                c[v >> 2] = 90
	                            }
	                            if ((c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 32 >> 2] | 0) >>> 0 < (c[v >> 2] | 0) >>> 0)c[v >> 2] = (c[v >> 2] | 0) - (c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 32 >> 2] | 0);
	                            if ((c[m >> 2] | 0) >>> 0 > (c[v >> 2] | 0) >>> 0) {
	                                c[p >> 2] = (c[m >> 2] | 0) - (c[v >> 2] | 0);
	                                c[m >> 2] = c[v >> 2];
	                                break
	                            } else {
	                                c[p >> 2] = 0;
	                                break
	                            }
	                        } while (0);
	                        c[u >> 2] = Lk(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0, c[m >> 2] | 0, c[l >> 2] | 0) | 0;
	                        F = c[k >> 2] | 0;
	                        if ((c[u >> 2] | 0) < 0) {
	                            E = 33;
	                            break
	                        }
	                        kz(c[(c[c[F + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0) | 0
	                    } else E = 35;
	                    if (((((((E | 0) == 35 ? (E = 0, (c[(c[k >> 2] | 0) + 172 >> 2] | 0) != -1) : 0) ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[w >> 2] = c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2], (c[(c[w >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) ? (c[(c[w >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[w >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                        c[y >> 2] = jz(c[(c[w >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[z >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                        c[x >> 2] = Fd(c[w >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if ((c[x >> 2] | 0) < 0) {
	                            E = 42;
	                            break
	                        }
	                        kz(c[(c[w >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0, c[y >> 2] | 0, c[z >> 2] | 0) | 0
	                    }
	                    f = c[k >> 2] | 0;
	                    do if (c[p >> 2] | 0)dh(f, 0) | 0; else {
	                        if ((c[f + 36 >> 2] | 0) != 0 ? (c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0)c[r >> 2] = _y(c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        if (!((c[n >> 2] | 0) != 0 | (c[r >> 2] | 0) >>> 0 > 1e7 | (c[q >> 2] | 0) == 0 | (c[r >> 2] | 0) == 0) ? (eh(c[k >> 2] | 0, (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) + (c[q >> 2] | 0) | 0, (c[r >> 2] | 0) - (c[q >> 2] | 0) | 0) | 0) == 0 : 0)break;
	                        dh(c[k >> 2] | 0, c[n >> 2] | 0) | 0
	                    } while (0);
	                    G = c[k >> 2] | 0;
	                    if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        E = 53;
	                        break
	                    }
	                    do if (c[G + 36 >> 2] | 0) {
	                        if (((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) <= 1e7 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) <= 1e7 : 0)break;
	                        if (!(c[(c[k >> 2] | 0) + 360 >> 2] & 524288)) {
	                            og(c[k >> 2] | 0, 1, 69896);
	                            c[(c[k >> 2] | 0) + 172 >> 2] = -1
	                        }
	                    } while (0);
	                    if ((c[(c[k >> 2] | 0) + 84 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 212 >> 2] | 0) == 1 : 0) {
	                        E = 61;
	                        break
	                    }
	                    if (!(c[p >> 2] | 0)) {
	                        E = 64;
	                        break
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + (c[m >> 2] | 0);
	                    c[m >> 2] = c[p >> 2];
	                    c[p >> 2] = 0
	                }
	                if ((E | 0) == 33) {
	                    c[F + 84 >> 2] = -1;
	                    c[(c[k >> 2] | 0) + 212 >> 2] = 1;
	                    c[j >> 2] = -1;
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                } else if ((E | 0) == 42) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 69864, h);
	                    c[j >> 2] = 81;
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                } else if ((E | 0) == 53) {
	                    c[j >> 2] = c[G + 84 >> 2];
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                } else if ((E | 0) == 61) {
	                    c[j >> 2] = c[(c[k >> 2] | 0) + 84 >> 2];
	                    D = c[j >> 2] | 0;
	                    i = g;
	                    return D | 0
	                } else if ((E | 0) == 64) {
	                    if (((c[o >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) {
	                        c[A >> 2] = jz(c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[B >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                        Lk(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0, 1, 69920) | 0;
	                        kz(c[(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0, c[A >> 2] | 0, c[B >> 2] | 0) | 0
	                    }
	                    if (c[n >> 2] | 0) {
	                        c[C >> 2] = 0;
	                        do if (c[(c[k >> 2] | 0) + 36 >> 2] | 0) {
	                            n = c[(c[k >> 2] | 0) + 36 >> 2] | 0;
	                            if (!(c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0)) {
	                                c[C >> 2] = (c[n + 24 >> 2] | 0) - ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                                break
	                            } else {
	                                B = _y(c[(c[n >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[C >> 2] = B - ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                                break
	                            }
	                        } while (0);
	                        if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) != -1 ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) != 14 : 0)og(c[k >> 2] | 0, 5, 0);
	                        if ((c[C >> 2] | 0) > 0 ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) == 14 : 0)og(c[k >> 2] | 0, 5, 0);
	                        if (((c[(c[k >> 2] | 0) + 172 >> 2] | 0) != -1 ? (c[c[k >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[k >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zb[c[(c[c[k >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[k >> 2] | 0) + 4 >> 2] | 0);
	                        c[(c[k >> 2] | 0) + 172 >> 2] = -1
	                    }
	                    if (!(c[(c[k >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[j >> 2] = c[(c[k >> 2] | 0) + 84 >> 2];
	                        D = c[j >> 2] | 0;
	                        i = g;
	                        return D | 0
	                    } else {
	                        c[j >> 2] = 0;
	                        D = c[j >> 2] | 0;
	                        i = g;
	                        return D | 0
	                    }
	                }
	                return 0
	            }

	            function Tf(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 44 | 0;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                t = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[r >> 2] = 0;
	                if ((c[l >> 2] | 0) != 0 & (c[m >> 2] | 0) >= 4)c[r >> 2] = sd(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                c[q >> 2] = vk(c[r >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                c[o >> 2] = Be() | 0;
	                if (!(c[o >> 2] | 0)) {
	                    ie(0, 69928);
	                    yk(c[q >> 2] | 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                c[(c[o >> 2] | 0) + 364 >> 2] = 1;
	                f = Cb[c[135744 >> 2] & 511]((c[(c[o >> 2] | 0) + 192 >> 2] | 0) * 3 << 2) | 0;
	                c[(c[o >> 2] | 0) + 344 >> 2] = f;
	                if (!(c[(c[o >> 2] | 0) + 344 >> 2] | 0)) {
	                    ie(c[o >> 2] | 0, 0);
	                    yk(c[q >> 2] | 0);
	                    Ae(c[o >> 2] | 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                if (c[j >> 2] | 0) {
	                    if ((c[c[o >> 2] >> 2] | 0) != 135968)zb[c[135736 >> 2] & 511](c[c[o >> 2] >> 2] | 0);
	                    f = Cb[c[135744 >> 2] & 511](128) | 0;
	                    c[c[o >> 2] >> 2] = f;
	                    f = c[o >> 2] | 0;
	                    if (!(c[c[o >> 2] >> 2] | 0)) {
	                        ie(f, 0);
	                        yk(c[q >> 2] | 0);
	                        Ae(c[o >> 2] | 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                    e = (c[f >> 2] | 0) + 0 | 0;
	                    f = e + 128 | 0;
	                    do {
	                        c[e >> 2] = 0;
	                        e = e + 4 | 0
	                    } while ((e | 0) < (f | 0));
	                    d = c[c[o >> 2] >> 2] | 0;
	                    b = c[j >> 2] | 0;
	                    if ((c[(c[j >> 2] | 0) + 108 >> 2] | 0) == -554844497) {
	                        e = d + 0 | 0;
	                        v = b + 0 | 0;
	                        f = e + 128 | 0;
	                        do {
	                            c[e >> 2] = c[v >> 2];
	                            e = e + 4 | 0;
	                            v = v + 4 | 0
	                        } while ((e | 0) < (f | 0))
	                    } else {
	                        e = d + 0 | 0;
	                        v = b + 0 | 0;
	                        f = e + 112 | 0;
	                        do {
	                            c[e >> 2] = c[v >> 2];
	                            e = e + 4 | 0;
	                            v = v + 4 | 0
	                        } while ((e | 0) < (f | 0))
	                    }
	                    if (c[k >> 2] | 0)c[(c[o >> 2] | 0) + 4 >> 2] = c[k >> 2]
	                }
	                if (!(c[n >> 2] | 0))c[(c[o >> 2] | 0) + 180 >> 2] = 0; else {
	                    k = Rk(c[n >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 180 >> 2] = k
	                }
	                c[p >> 2] = ue(c[o >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    Ae(c[o >> 2] | 0);
	                    yk(c[q >> 2] | 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                if (c[n >> 2] | 0) {
	                    k = Jl(c[n >> 2] | 0) | 0;
	                    c[(c[p >> 2] | 0) + 4 >> 2] = k;
	                    if (!(c[(c[p >> 2] | 0) + 4 >> 2] | 0)) {
	                        Ae(c[o >> 2] | 0);
	                        yk(c[q >> 2] | 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                } else c[(c[p >> 2] | 0) + 4 >> 2] = 0;
	                c[c[p >> 2] >> 2] = c[q >> 2];
	                iz(c[(c[c[p >> 2] >> 2] | 0) + 16 >> 2] | 0, c[p >> 2] | 0) | 0;
	                Oe(c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                p = c[o >> 2] | 0;
	                if (!((c[m >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0)) {
	                    if ((c[p + 36 >> 2] | 0) != 0 ? (c[c[(c[o >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) {
	                        c[s >> 2] = jz(c[(c[c[(c[o >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[o >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[t >> 2] = (c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                        Lk(c[c[(c[o >> 2] | 0) + 36 >> 2] >> 2] | 0, c[m >> 2] | 0, c[l >> 2] | 0) | 0;
	                        kz(c[(c[c[(c[o >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[o >> 2] | 0) + 36 >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0) | 0
	                    }
	                } else c[p + 256 >> 2] = 0;
	                if (c[r >> 2] | 0)re(c[o >> 2] | 0, c[r >> 2] | 0) | 0;
	                c[h >> 2] = c[o >> 2];
	                u = c[h >> 2] | 0;
	                i = g;
	                return u | 0
	            }

	            function Uf(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[d >> 2] | 0) + 172 >> 2] = -1;
	                c[(c[d >> 2] | 0) + 84 >> 2] = 111;
	                c[(c[d >> 2] | 0) + 212 >> 2] = 1;
	                if (!(c[(c[d >> 2] | 0) + 36 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[(c[d >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = 65640;
	                c[(c[(c[d >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] = c[(c[(c[d >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                i = b;
	                return
	            }

	            function Vf(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[m >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[l >> 2] = Be() | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                d = (c[l >> 2] | 0) + 360 | 0;
	                c[d >> 2] = c[d >> 2] | 4;
	                if (c[g >> 2] | 0) {
	                    if (c[c[l >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[l >> 2] >> 2] | 0);
	                    c[c[l >> 2] >> 2] = c[g >> 2];
	                    c[(c[l >> 2] | 0) + 4 >> 2] = c[l >> 2]
	                }
	                c[o >> 2] = Jl(c[j >> 2] | 0) | 0;
	                d = c[l >> 2] | 0;
	                if ((c[j >> 2] | 0) != 0 & (c[o >> 2] | 0) == 0) {
	                    Ae(d);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                if ((c[d >> 2] | 0) != 0 ? (c[(c[c[l >> 2] >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)c[m >> 2] = vb[c[(c[c[l >> 2] >> 2] | 0) + 16 >> 2] & 511](c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    if (c[g >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                    Ae(c[l >> 2] | 0);
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                if ((Xe(c[l >> 2] | 0, c[m >> 2] | 0) | 0) < 0) {
	                    if (c[g >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                    Ae(c[l >> 2] | 0);
	                    if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                if (((c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4) {
	                    c[n >> 2] = sd(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, 4) | 0;
	                    re(c[l >> 2] | 0, c[n >> 2] | 0) | 0
	                }
	                if (!(c[(c[m >> 2] | 0) + 4 >> 2] | 0))c[(c[m >> 2] | 0) + 4 >> 2] = c[o >> 2]; else zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                c[(c[m >> 2] | 0) + 28 >> 2] = 1;
	                c[(c[m >> 2] | 0) + 32 >> 2] = 1;
	                c[(c[m >> 2] | 0) + 12 >> 2] = c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[(c[m >> 2] | 0) + 16 >> 2] = c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[(c[m >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[l >> 2] | 0) + 216 >> 2] = 2;
	                m = Sh(68488) | 0;
	                c[(c[l >> 2] | 0) + 8 >> 2] = m;
	                m = c[l >> 2] | 0;
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    ie(m, 67128);
	                    if (c[g >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                    Ae(c[l >> 2] | 0);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[(c[m + 8 >> 2] | 0) + 92 >> 2] = 64;
	                m = Mh(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 69960, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] = m;
	                Cf(c[l >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0);
	                if (c[(c[l >> 2] | 0) + 8 >> 2] | 0) {
	                    a:do if (c[(c[l >> 2] | 0) + 12 >> 2] | 0) {
	                        c[k >> 2] = c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2];
	                        c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] = 0;
	                        if (c[k >> 2] | 0) {
	                            c[(c[k >> 2] | 0) + 32 >> 2] = 0;
	                            c[p >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[p >> 2] | 0))break a;
	                                c[(c[p >> 2] | 0) + 32 >> 2] = 0;
	                                c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                            }
	                        }
	                    } else c[k >> 2] = 0; while (0);
	                    Th(c[(c[l >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[l >> 2] | 0) + 8 >> 2] = 0
	                }
	                if (c[g >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                Ae(c[l >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function Wf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = Vf(0, c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function Xf(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                h = i;
	                i = i + 64 | 0;
	                j = h + 44 | 0;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                t = h + 48 | 0;
	                u = h + 4 | 0;
	                v = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                if (!((c[(c[k >> 2] | 0) + 248 >> 2] | 0) > 40 ? (c[(c[k >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0))x = 5;
	                if ((x | 0) == 5 ? (c[(c[k >> 2] | 0) + 248 >> 2] | 0) <= 1024 : 0) {
	                    if (c[n >> 2] | 0)c[c[n >> 2] >> 2] = 0;
	                    if ((c[l >> 2] | 0) == 0 & (c[m >> 2] | 0) == 0) {
	                        c[j >> 2] = -1;
	                        w = c[j >> 2] | 0;
	                        i = h;
	                        return w | 0
	                    }
	                    if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        w = c[j >> 2] | 0;
	                        i = h;
	                        return w | 0
	                    }
	                    c[o >> 2] = fh(c[l >> 2] | 0, c[m >> 2] | 0, 0, c[k >> 2] | 0) | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        w = c[j >> 2] | 0;
	                        i = h;
	                        return w | 0
	                    }
	                    c[r >> 2] = c[c[o >> 2] >> 2];
	                    c[c[o >> 2] >> 2] = c[c[k >> 2] >> 2];
	                    Rg(c[o >> 2] | 0);
	                    c[p >> 2] = Sh(68488) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        Ae(c[o >> 2] | 0);
	                        c[j >> 2] = -1;
	                        w = c[j >> 2] | 0;
	                        i = h;
	                        return w | 0
	                    }
	                    c[(c[p >> 2] | 0) + 92 >> 2] = 64;
	                    if (c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 80 >> 2] | 0) {
	                        c[(c[p >> 2] | 0) + 80 >> 2] = c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 80 >> 2];
	                        yP(c[(c[p >> 2] | 0) + 80 >> 2] | 0) | 0
	                    }
	                    if (c[(c[k >> 2] | 0) + 8 >> 2] | 0) {
	                        c[(c[p >> 2] | 0) + 44 >> 2] = c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2];
	                        c[(c[p >> 2] | 0) + 48 >> 2] = c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2]
	                    }
	                    if (c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] | 0) {
	                        m = my(c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] | 0) | 0;
	                        c[(c[p >> 2] | 0) + 72 >> 2] = m
	                    }
	                    c[q >> 2] = ji(c[p >> 2] | 0, 0, 69968, 0) | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        c[c[o >> 2] >> 2] = c[r >> 2];
	                        Ae(c[o >> 2] | 0);
	                        c[(c[p >> 2] | 0) + 44 >> 2] = 0;
	                        c[(c[p >> 2] | 0) + 48 >> 2] = 0;
	                        Th(c[p >> 2] | 0);
	                        c[j >> 2] = -1;
	                        w = c[j >> 2] | 0;
	                        i = h;
	                        return w | 0
	                    }
	                    zi(c[p >> 2] | 0, c[q >> 2] | 0) | 0;
	                    Qe(c[o >> 2] | 0, c[(c[p >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))c[(c[o >> 2] | 0) + 8 >> 2] = c[p >> 2]; else {
	                        c[(c[o >> 2] | 0) + 8 >> 2] = c[(c[k >> 2] | 0) + 8 >> 2];
	                        c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 32 >> 2] = c[(c[k >> 2] | 0) + 8 >> 2]
	                    }
	                    if ((c[(c[o >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[o >> 2] | 0);
	                    if (((c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 ? (a[t >> 0] = a[c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0, a[t + 1 >> 0] = a[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0, a[t + 2 >> 0] = a[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0, a[t + 3 >> 0] = a[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0, c[u >> 2] = sd(t, 4) | 0, (c[u >> 2] | 0) != 0) : 0)re(c[o >> 2] | 0, c[u >> 2] | 0) | 0;
	                    a:do if (((d[c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) {
	                        if ((d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 109)break;
	                        if ((d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 108)break;
	                        do if ((d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        _e(c[o >> 2] | 0);
	                        if (!(qy(c[(c[k >> 2] | 0) + 20 >> 2] | 0, 68488) | 0))break;
	                        if (qy(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 48 >> 2] | 0, 68488) | 0)break;
	                        xg(c[o >> 2] | 0, 109, 69984)
	                    } while (0);
	                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[k >> 2] | 0))c[(c[o >> 2] | 0) + 4 >> 2] = c[o >> 2]; else c[(c[o >> 2] | 0) + 4 >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    c[(c[o >> 2] | 0) + 172 >> 2] = 7;
	                    c[(c[o >> 2] | 0) + 104 >> 2] = c[(c[k >> 2] | 0) + 104 >> 2];
	                    c[(c[o >> 2] | 0) + 100 >> 2] = c[(c[k >> 2] | 0) + 100 >> 2];
	                    c[(c[o >> 2] | 0) + 276 >> 2] = c[(c[k >> 2] | 0) + 276 >> 2];
	                    c[(c[o >> 2] | 0) + 248 >> 2] = (c[(c[k >> 2] | 0) + 248 >> 2] | 0) + 1;
	                    c[(c[o >> 2] | 0) + 16 >> 2] = c[(c[k >> 2] | 0) + 16 >> 2];
	                    if (c[(c[o >> 2] | 0) + 104 >> 2] | 0) {
	                        c[(c[o >> 2] | 0) + 112 >> 2] = c[(c[k >> 2] | 0) + 112 >> 2];
	                        c[(c[o >> 2] | 0) + 116 >> 2] = c[(c[k >> 2] | 0) + 116 >> 2]
	                    } else {
	                        c[(c[o >> 2] | 0) + 112 >> 2] = 0;
	                        c[(c[o >> 2] | 0) + 116 >> 2] = 0
	                    }
	                    c[(c[o >> 2] | 0) + 132 >> 2] = 0;
	                    c[(c[o >> 2] | 0) + 124 >> 2] = 0;
	                    c[(c[o >> 2] | 0) + 128 >> 2] = 0;
	                    c[(c[o >> 2] | 0) + 120 >> 2] = 0;
	                    if (c[(c[o >> 2] | 0) + 296 >> 2] | 0)zP(c[(c[o >> 2] | 0) + 296 >> 2] | 0);
	                    c[(c[o >> 2] | 0) + 296 >> 2] = c[(c[k >> 2] | 0) + 296 >> 2];
	                    u = AP(c[(c[o >> 2] | 0) + 296 >> 2] | 0, 70032, 3) | 0;
	                    c[(c[o >> 2] | 0) + 312 >> 2] = u;
	                    u = AP(c[(c[o >> 2] | 0) + 296 >> 2] | 0, 70040, 5) | 0;
	                    c[(c[o >> 2] | 0) + 316 >> 2] = u;
	                    u = AP(c[(c[o >> 2] | 0) + 296 >> 2] | 0, 70048, 36) | 0;
	                    c[(c[o >> 2] | 0) + 320 >> 2] = u;
	                    c[(c[o >> 2] | 0) + 364 >> 2] = c[(c[k >> 2] | 0) + 364 >> 2];
	                    c[(c[o >> 2] | 0) + 348 >> 2] = c[(c[k >> 2] | 0) + 348 >> 2];
	                    c[(c[o >> 2] | 0) + 352 >> 2] = c[(c[k >> 2] | 0) + 352 >> 2];
	                    c[(c[o >> 2] | 0) + 280 >> 2] = c[(c[k >> 2] | 0) + 280 >> 2];
	                    Jf(c[o >> 2] | 0);
	                    c[(c[k >> 2] | 0) + 104 >> 2] = c[(c[o >> 2] | 0) + 104 >> 2];
	                    c[(c[k >> 2] | 0) + 100 >> 2] = c[(c[o >> 2] | 0) + 100 >> 2];
	                    do if ((d[c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60) {
	                        if ((d[(c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 47) {
	                            x = 57;
	                            break
	                        }
	                        og(c[o >> 2] | 0, 85, 0)
	                    } else x = 57; while (0);
	                    do if ((x | 0) == 57) {
	                        if (!(d[c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))break;
	                        og(c[o >> 2] | 0, 86, 0)
	                    } while (0);
	                    if ((c[(c[o >> 2] | 0) + 52 >> 2] | 0) != (c[(c[p >> 2] | 0) + 12 >> 2] | 0))og(c[o >> 2] | 0, 85, 0);
	                    do if (!(c[(c[o >> 2] | 0) + 12 >> 2] | 0))if (!(c[(c[o >> 2] | 0) + 84 >> 2] | 0)) {
	                        c[s >> 2] = 1;
	                        break
	                    } else {
	                        c[s >> 2] = c[(c[o >> 2] | 0) + 84 >> 2];
	                        break
	                    } else {
	                        if (c[n >> 2] | 0) {
	                            c[v >> 2] = c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                            c[c[n >> 2] >> 2] = c[v >> 2];
	                            while (1) {
	                                if (!(c[v >> 2] | 0))break;
	                                c[(c[v >> 2] | 0) + 20 >> 2] = 0;
	                                c[v >> 2] = c[(c[v >> 2] | 0) + 24 >> 2]
	                            }
	                            c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] = 0
	                        }
	                        c[s >> 2] = 0
	                    } while (0);
	                    c[c[o >> 2] >> 2] = c[r >> 2];
	                    c[(c[o >> 2] | 0) + 296 >> 2] = 0;
	                    c[(c[o >> 2] | 0) + 348 >> 2] = 0;
	                    c[(c[o >> 2] | 0) + 352 >> 2] = 0;
	                    Ae(c[o >> 2] | 0);
	                    c[(c[p >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[p >> 2] | 0) + 48 >> 2] = 0;
	                    Th(c[p >> 2] | 0);
	                    c[j >> 2] = c[s >> 2];
	                    w = c[j >> 2] | 0;
	                    i = h;
	                    return w | 0
	                }
	                c[j >> 2] = 89;
	                w = c[j >> 2] | 0;
	                i = h;
	                return w | 0
	            }

	            function Yf(a, b, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                h = i;
	                i = i + 64 | 0;
	                j = h + 60 | 0;
	                k = h + 56 | 0;
	                l = h + 52 | 0;
	                m = h + 48 | 0;
	                n = h + 44 | 0;
	                o = h + 40 | 0;
	                p = h + 36 | 0;
	                q = h + 32 | 0;
	                r = h + 28 | 0;
	                s = h + 24 | 0;
	                t = h + 20 | 0;
	                u = h + 16 | 0;
	                v = h + 12 | 0;
	                w = h + 8 | 0;
	                x = h + 4 | 0;
	                y = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[q >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                if ((c[o >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) < 0) {
	                    c[j >> 2] = 1;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                }
	                switch (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                    case 13:
	                    case 9:
	                    case 8:
	                    case 7:
	                    case 5:
	                    case 4:
	                    case 3:
	                    case 2:
	                    case 1:
	                        break;
	                    default:
	                    {
	                        c[j >> 2] = 1;
	                        z = c[j >> 2] | 0;
	                        i = h;
	                        return z | 0
	                    }
	                }
	                while (1) {
	                    if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 9 : 0)A = (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 13; else A = 0;
	                    B = c[k >> 2] | 0;
	                    if (!A)break;
	                    c[k >> 2] = c[B + 20 >> 2]
	                }
	                if (!B) {
	                    c[j >> 2] = 1;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                }
	                B = c[k >> 2] | 0;
	                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1)c[q >> 2] = c[B + 32 >> 2]; else c[q >> 2] = B;
	                if (!(c[q >> 2] | 0)) {
	                    c[j >> 2] = 1;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                }
	                do if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 9)c[p >> 2] = Zf(c[l >> 2] | 0, c[m >> 2] | 0) | 0; else {
	                    if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                        c[p >> 2] = no(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                        c[n >> 2] = c[n >> 2] | 8192;
	                        break
	                    }
	                    c[j >> 2] = 1;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                } while (0);
	                if (!(c[p >> 2] | 0)) {
	                    c[j >> 2] = 2;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                }
	                if (c[(c[q >> 2] | 0) + 80 >> 2] | 0) {
	                    if (c[(c[p >> 2] | 0) + 296 >> 2] | 0)zP(c[(c[p >> 2] | 0) + 296 >> 2] | 0);
	                    c[(c[p >> 2] | 0) + 296 >> 2] = c[(c[q >> 2] | 0) + 80 >> 2]
	                } else c[n >> 2] = c[n >> 2] | 4096;
	                do if (c[(c[q >> 2] | 0) + 60 >> 2] | 0) {
	                    if (c[(c[p >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[p >> 2] | 0) + 24 >> 2] | 0);
	                    m = my(c[(c[q >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    c[(c[p >> 2] | 0) + 24 >> 2] = m;
	                    c[v >> 2] = Dd(c[(c[q >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    if (c[v >> 2] | 0) {
	                        se(c[p >> 2] | 0, c[v >> 2] | 0) | 0;
	                        break
	                    }
	                    c[j >> 2] = 32;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                } while (0);
	                gh(c[p >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                Rg(c[p >> 2] | 0);
	                c[(c[p >> 2] | 0) + 8 >> 2] = c[q >> 2];
	                c[(c[p >> 2] | 0) + 172 >> 2] = 7;
	                c[r >> 2] = oi(0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    Ae(c[p >> 2] | 0);
	                    c[j >> 2] = 2;
	                    z = c[j >> 2] | 0;
	                    i = h;
	                    return z | 0
	                }
	                zi(c[k >> 2] | 0, c[r >> 2] | 0) | 0;
	                a:do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    Qe(c[p >> 2] | 0, c[k >> 2] | 0) | 0;
	                    c[s >> 2] = c[k >> 2];
	                    while (1) {
	                        if (!(c[s >> 2] | 0))break a;
	                        if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 1)break a;
	                        c[w >> 2] = c[(c[s >> 2] | 0) + 48 >> 2];
	                        while (1) {
	                            if (!(c[w >> 2] | 0))break;
	                            if (c[(c[p >> 2] | 0) + 296 >> 2] | 0) {
	                                c[x >> 2] = AP(c[(c[p >> 2] | 0) + 296 >> 2] | 0, c[(c[w >> 2] | 0) + 12 >> 2] | 0, -1) | 0;
	                                c[y >> 2] = AP(c[(c[p >> 2] | 0) + 296 >> 2] | 0, c[(c[w >> 2] | 0) + 8 >> 2] | 0, -1) | 0
	                            } else {
	                                c[x >> 2] = c[(c[w >> 2] | 0) + 12 >> 2];
	                                c[y >> 2] = c[(c[w >> 2] | 0) + 8 >> 2]
	                            }
	                            if (!(hh(c[p >> 2] | 0, c[x >> 2] | 0) | 0)) {
	                                ih(c[p >> 2] | 0, c[x >> 2] | 0, c[y >> 2] | 0) | 0;
	                                c[t >> 2] = (c[t >> 2] | 0) + 1
	                            }
	                            c[w >> 2] = c[c[w >> 2] >> 2]
	                        }
	                        c[s >> 2] = c[(c[s >> 2] | 0) + 20 >> 2]
	                    }
	                } while (0);
	                if (!((c[(c[p >> 2] | 0) + 104 >> 2] | 0) == 0 ? (c[(c[p >> 2] | 0) + 16 >> 2] | 0) == 0 : 0)) {
	                    w = (c[p >> 2] | 0) + 276 | 0;
	                    c[w >> 2] = c[w >> 2] | 8
	                }
	                w = c[p >> 2] | 0;
	                if ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 13)jo(w); else Jf(w);
	                _g(c[p >> 2] | 0, c[t >> 2] | 0) | 0;
	                if ((d[c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0)og(c[p >> 2] | 0, 85, 0); else C = 60;
	                if ((C | 0) == 60 ? (d[c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 0 : 0)og(c[p >> 2] | 0, 86, 0);
	                if ((c[(c[p >> 2] | 0) + 52 >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 52 >> 2] | 0) != (c[k >> 2] | 0) : 0) {
	                    og(c[p >> 2] | 0, 85, 0);
	                    c[(c[p >> 2] | 0) + 12 >> 2] = 0
	                }
	                do if (!(c[(c[p >> 2] | 0) + 12 >> 2] | 0))if (!(c[(c[p >> 2] | 0) + 84 >> 2] | 0)) {
	                    c[u >> 2] = 1;
	                    break
	                } else {
	                    c[u >> 2] = c[(c[p >> 2] | 0) + 84 >> 2];
	                    break
	                } else c[u >> 2] = 0; while (0);
	                c[s >> 2] = c[(c[r >> 2] | 0) + 24 >> 2];
	                c[(c[r >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 16 >> 2] = c[r >> 2];
	                if (c[s >> 2] | 0)c[(c[s >> 2] | 0) + 28 >> 2] = 0;
	                c[c[o >> 2] >> 2] = c[s >> 2];
	                while (1) {
	                    if (!(c[s >> 2] | 0))break;
	                    c[(c[s >> 2] | 0) + 20 >> 2] = 0;
	                    c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                }
	                Qh(c[r >> 2] | 0);
	                Rh(c[r >> 2] | 0);
	                if (c[u >> 2] | 0) {
	                    Uh(c[c[o >> 2] >> 2] | 0);
	                    c[c[o >> 2] >> 2] = 0
	                }
	                if (c[(c[q >> 2] | 0) + 80 >> 2] | 0)c[(c[p >> 2] | 0) + 296 >> 2] = 0;
	                Ae(c[p >> 2] | 0);
	                c[j >> 2] = c[u >> 2];
	                z = c[j >> 2] | 0;
	                i = h;
	                return z | 0
	            }

	            function Zf(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if ((c[g >> 2] | 0) <= 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = Be() | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[k >> 2] = Hk(c[f >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                g = c[h >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ae(g);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = ue(g) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    yk(c[k >> 2] | 0);
	                    Ae(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[(c[j >> 2] | 0) + 4 >> 2] = 0;
	                    c[c[j >> 2] >> 2] = c[k >> 2];
	                    iz(c[(c[c[j >> 2] >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    Oe(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[e >> 2] = c[h >> 2];
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function _f(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = $f(c[d >> 2] | 0, 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function $f(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                c[h >> 2] = Be() | 0;
	                if (!(c[h >> 2] | 0)) {
	                    ie(0, 70088);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (c[g >> 2] | 0)gh(c[h >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                c[(c[h >> 2] | 0) + 280 >> 2] = 1;
	                c[j >> 2] = Vk(c[f >> 2] | 0, 0, c[h >> 2] | 0) | 0;
	                g = c[h >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Ae(g);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                Oe(g, c[j >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[k >> 2] = Rk(c[f >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[(c[h >> 2] | 0) + 180 >> 2] = c[k >> 2];
	                c[e >> 2] = c[h >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function ag(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                Rf();
	                c[n >> 2] = _f(c[j >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (c[h >> 2] | 0) {
	                    if (c[c[n >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[n >> 2] >> 2] | 0);
	                    c[c[n >> 2] >> 2] = c[h >> 2]
	                }
	                Rg(c[n >> 2] | 0);
	                if (c[l >> 2] | 0)c[(c[n >> 2] | 0) + 272 >> 2] = c[l >> 2];
	                if (!(c[(c[n >> 2] | 0) + 180 >> 2] | 0)) {
	                    l = Rk(c[j >> 2] | 0) | 0;
	                    c[(c[n >> 2] | 0) + 180 >> 2] = l
	                }
	                c[(c[n >> 2] | 0) + 288 >> 2] = c[k >> 2];
	                Qf(c[n >> 2] | 0) | 0;
	                do if ((c[k >> 2] | 0) != 0 ? 1 : (c[(c[n >> 2] | 0) + 12 >> 2] | 0) != 0) {
	                    c[m >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                    if (c[m >> 2] | 0)if ((c[(c[c[(c[n >> 2] | 0) + 36 >> 2] >> 2] | 0) + 24 >> 2] | 0) > 0) {
	                        c[(c[m >> 2] | 0) + 36 >> 2] = 9;
	                        break
	                    } else {
	                        c[(c[m >> 2] | 0) + 36 >> 2] = c[(c[c[(c[n >> 2] | 0) + 36 >> 2] >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                } else {
	                    c[m >> 2] = 0;
	                    Th(c[(c[n >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[n >> 2] | 0) + 8 >> 2] = 0
	                } while (0);
	                if (c[h >> 2] | 0)c[c[n >> 2] >> 2] = 0;
	                Ae(c[n >> 2] | 0);
	                c[g >> 2] = c[m >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function bg(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = ag(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function cg(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = bg(0, c[d >> 2] | 0, 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function dg() {
	                var a = 0;
	                a = i;
	                if (!(c[17532] | 0)) {
	                    i = a;
	                    return
	                }
	                Bd();
	                Dw();
	                wP();
	                jk();
	                kk();
	                GH();
	                XM();
	                ee();
	                mx();
	                Ax();
	                vl();
	                c[17532] = 0;
	                i = a;
	                return
	            }

	            function eg(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[f >> 2] = c[(c[d >> 2] | 0) + 296 >> 2];
	                while (1) {
	                    a = Pe(c[d >> 2] | 0) | 0;
	                    c[e >> 2] = a;
	                    if (!a)break;
	                    te(c[e >> 2] | 0)
	                }
	                c[(c[d >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 236 >> 2] = 0;
	                e = c[d >> 2] | 0;
	                if (c[(c[d >> 2] | 0) + 244 >> 2] | 0) {
	                    c[c[e + 244 >> 2] >> 2] = -1;
	                    c[(c[d >> 2] | 0) + 232 >> 2] = c[(c[d >> 2] | 0) + 244 >> 2]
	                } else c[e + 232 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 52 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 188 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 184 >> 2] = 0;
	                do if (c[(c[d >> 2] | 0) + 20 >> 2] | 0) {
	                    if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 20 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0)
	                } while (0);
	                c[(c[d >> 2] | 0) + 20 >> 2] = 0;
	                do if (c[(c[d >> 2] | 0) + 24 >> 2] | 0) {
	                    if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 24 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0)
	                } while (0);
	                c[(c[d >> 2] | 0) + 24 >> 2] = 0;
	                do if (c[(c[d >> 2] | 0) + 180 >> 2] | 0) {
	                    if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 180 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 180 >> 2] | 0)
	                } while (0);
	                c[(c[d >> 2] | 0) + 180 >> 2] = 0;
	                do if (c[(c[d >> 2] | 0) + 224 >> 2] | 0) {
	                    if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 224 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 224 >> 2] | 0)
	                } while (0);
	                c[(c[d >> 2] | 0) + 224 >> 2] = 0;
	                do if (c[(c[d >> 2] | 0) + 228 >> 2] | 0) {
	                    if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 228 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 228 >> 2] | 0)
	                } while (0);
	                c[(c[d >> 2] | 0) + 228 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 28 >> 2] = -1;
	                c[(c[d >> 2] | 0) + 88 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 92 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 96 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 172 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 176 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 12 >> 2] = 1;
	                c[(c[d >> 2] | 0) + 356 >> 2] = 1;
	                c[(c[d >> 2] | 0) + 212 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 100 >> 2] = 1;
	                c[(c[d >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 200 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 204 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 216 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 84 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 248 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 256 >> 2] = 1;
	                c[(c[d >> 2] | 0) + 284 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 440 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 444 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 468 >> 2] = 0;
	                ze((c[d >> 2] | 0) + 72 | 0);
	                if (c[(c[d >> 2] | 0) + 348 >> 2] | 0) {
	                    Kj(c[(c[d >> 2] | 0) + 348 >> 2] | 0, c[33934] | 0);
	                    c[(c[d >> 2] | 0) + 348 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 352 >> 2] | 0) {
	                    Kj(c[(c[d >> 2] | 0) + 352 >> 2] | 0, 0);
	                    c[(c[d >> 2] | 0) + 352 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 284 >> 2] | 0)Hw(c[(c[d >> 2] | 0) + 284 >> 2] | 0);
	                if (!(c[(c[d >> 2] | 0) + 388 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Yd((c[d >> 2] | 0) + 384 | 0);
	                i = b;
	                return
	            }

	            function fg(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = gh(c[e >> 2] | 0, c[f >> 2] | 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function gg(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                Rf();
	                c[k >> 2] = $f(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = jh(c[k >> 2] | 0, 0, c[h >> 2] | 0, c[j >> 2] | 0, 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function hg(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                Rf();
	                c[o >> 2] = Zf(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } else {
	                    c[h >> 2] = jh(c[o >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                return 0
	            }

	            function ig(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                Rf();
	                c[n >> 2] = Gk(c[h >> 2] | 0, 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[(c[n >> 2] | 0) + 8 >> 2] = 0;
	                c[m >> 2] = Be() | 0;
	                if (!(c[m >> 2] | 0)) {
	                    yk(c[n >> 2] | 0);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[o >> 2] = ve(c[m >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    yk(c[n >> 2] | 0);
	                    Ae(c[m >> 2] | 0);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else {
	                    Oe(c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                    c[g >> 2] = jh(c[m >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                return 0
	            }

	            function jg(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                Rf();
	                c[r >> 2] = Kk(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    if (c[l >> 2] | 0)Cb[c[l >> 2] & 511](c[m >> 2] | 0) | 0;
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[q >> 2] = Be() | 0;
	                if (!(c[q >> 2] | 0)) {
	                    yk(c[r >> 2] | 0);
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[s >> 2] = ve(c[q >> 2] | 0, c[r >> 2] | 0, 0) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    yk(c[r >> 2] | 0);
	                    Ae(c[q >> 2] | 0);
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                } else {
	                    Oe(c[q >> 2] | 0, c[s >> 2] | 0) | 0;
	                    c[j >> 2] = jh(c[q >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, 0) | 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                return 0
	            }

	            function kg(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                Rf();
	                eg(c[h >> 2] | 0);
	                c[m >> 2] = Vk(c[j >> 2] | 0, 0, c[h >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    Oe(c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[g >> 2] = jh(c[h >> 2] | 0, 0, c[k >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function lg(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                Rf();
	                eg(c[k >> 2] | 0);
	                c[q >> 2] = Hk(c[l >> 2] | 0, c[m >> 2] | 0, 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[r >> 2] = ve(c[k >> 2] | 0, c[q >> 2] | 0, 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    yk(c[q >> 2] | 0);
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else {
	                    Oe(c[k >> 2] | 0, c[r >> 2] | 0) | 0;
	                    c[j >> 2] = jh(c[k >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, 1) | 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                return 0
	            }

	            function mg(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 36 | 0;
	                l = j + 32 | 0;
	                m = j + 28 | 0;
	                n = j + 24 | 0;
	                o = j + 20 | 0;
	                p = j + 16 | 0;
	                q = j + 12 | 0;
	                r = j + 8 | 0;
	                s = j + 4 | 0;
	                t = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                if (!(c[m >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                Rf();
	                eg(c[l >> 2] | 0);
	                c[s >> 2] = Kk(c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, 0) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    if (c[n >> 2] | 0)Cb[c[n >> 2] & 511](c[o >> 2] | 0) | 0;
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                c[t >> 2] = ve(c[l >> 2] | 0, c[s >> 2] | 0, 0) | 0;
	                if (!(c[t >> 2] | 0)) {
	                    yk(c[s >> 2] | 0);
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                } else {
	                    Oe(c[l >> 2] | 0, c[t >> 2] | 0) | 0;
	                    c[k >> 2] = jh(c[l >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, 1) | 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                return 0
	            }

	            function ng(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = f;
	                    return
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                e = c[h >> 2] | 0;
	                d = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                b = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, 0, 1, d, 3, 0, 0, 0, 0, 0, j, 0, b, g);
	                if (!(c[h >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[h >> 2] | 0) + 288 >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 212 >> 2] = 1;
	                i = f;
	                return
	            }

	            function og(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 160 | 0;
	                f = e;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e + 20 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                cU(l | 0, 0, 129) | 0;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = e;
	                    return
	                }
	                do switch (c[h >> 2] | 0) {
	                    case 69:
	                    {
	                        c[k >> 2] = 74048;
	                        break
	                    }
	                    case 33:
	                    {
	                        c[k >> 2] = 74696;
	                        break
	                    }
	                    case 55:
	                    {
	                        c[k >> 2] = 74128;
	                        break
	                    }
	                    case 34:
	                    {
	                        c[k >> 2] = 74656;
	                        break
	                    }
	                    case 71:
	                    {
	                        c[k >> 2] = 73600;
	                        break
	                    }
	                    case 89:
	                    {
	                        c[k >> 2] = 73240;
	                        break
	                    }
	                    case 52:
	                    {
	                        c[k >> 2] = 74008;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[k >> 2] = 73136;
	                        break
	                    }
	                    case 67:
	                    {
	                        c[k >> 2] = 73920;
	                        break
	                    }
	                    case 79:
	                    {
	                        c[k >> 2] = 74736;
	                        break
	                    }
	                    case 38:
	                    {
	                        c[k >> 2] = 73392;
	                        break
	                    }
	                    case 82:
	                    {
	                        c[k >> 2] = 74504;
	                        break
	                    }
	                    case 50:
	                    {
	                        c[k >> 2] = 73872;
	                        break
	                    }
	                    case 73:
	                    {
	                        c[k >> 2] = 74232;
	                        break
	                    }
	                    case 18:
	                    {
	                        c[k >> 2] = 73104;
	                        break
	                    }
	                    case 80:
	                    {
	                        c[k >> 2] = 73648;
	                        break
	                    }
	                    case 49:
	                    {
	                        c[k >> 2] = 73776;
	                        break
	                    }
	                    case 44:
	                    {
	                        c[k >> 2] = 73472;
	                        break
	                    }
	                    case 85:
	                    {
	                        c[k >> 2] = 74880;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[k >> 2] = 74808;
	                        break
	                    }
	                    case 48:
	                    {
	                        c[k >> 2] = 73744;
	                        break
	                    }
	                    case 84:
	                    {
	                        c[k >> 2] = 73824;
	                        break
	                    }
	                    case 46:
	                    {
	                        c[k >> 2] = 73696;
	                        break
	                    }
	                    case 110:
	                    {
	                        c[k >> 2] = 75e3;
	                        break
	                    }
	                    case 74:
	                    {
	                        c[k >> 2] = 74616;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[k >> 2] = 73032;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[k >> 2] = 73064;
	                        break
	                    }
	                    case 88:
	                    {
	                        c[k >> 2] = 73312;
	                        break
	                    }
	                    case 70:
	                    {
	                        c[k >> 2] = 73560;
	                        break
	                    }
	                    case 25:
	                    {
	                        c[k >> 2] = 73208;
	                        break
	                    }
	                    case 20:
	                    {
	                        c[k >> 2] = 73160;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[k >> 2] = 74832;
	                        break
	                    }
	                    case 61:
	                    {
	                        c[k >> 2] = 74584;
	                        break
	                    }
	                    case 54:
	                    {
	                        c[k >> 2] = 74088;
	                        break
	                    }
	                    case 78:
	                    {
	                        c[k >> 2] = 74768;
	                        break
	                    }
	                    case 62:
	                    {
	                        c[k >> 2] = 73520;
	                        break
	                    }
	                    case 96:
	                    {
	                        c[k >> 2] = 74960;
	                        break
	                    }
	                    case 23:
	                    {
	                        c[k >> 2] = 74552;
	                        break
	                    }
	                    case 36:
	                    {
	                        c[k >> 2] = 73280;
	                        break
	                    }
	                    case 6:
	                    {
	                        c[k >> 2] = 72992;
	                        break
	                    }
	                    case 51:
	                    {
	                        c[k >> 2] = 73960;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[k >> 2] = 73088;
	                        break
	                    }
	                    case 56:
	                    {
	                        c[k >> 2] = 74424;
	                        break
	                    }
	                    case 75:
	                    {
	                        c[k >> 2] = 74640;
	                        break
	                    }
	                    case 60:
	                    {
	                        c[k >> 2] = 74288;
	                        break
	                    }
	                    case 83:
	                    {
	                        c[k >> 2] = 74248;
	                        break
	                    }
	                    case 57:
	                    {
	                        c[k >> 2] = 74464;
	                        break
	                    }
	                    case 21:
	                    {
	                        c[k >> 2] = 74168;
	                        break
	                    }
	                    case 95:
	                    {
	                        c[k >> 2] = 74328;
	                        break
	                    }
	                    case 59:
	                    {
	                        c[k >> 2] = 74384;
	                        break
	                    }
	                    case 64:
	                    {
	                        c[k >> 2] = 73728;
	                        break
	                    }
	                    case 43:
	                    {
	                        c[k >> 2] = 73440;
	                        break
	                    }
	                    case 24:
	                    {
	                        c[k >> 2] = 73184;
	                        break
	                    }
	                    case 92:
	                    {
	                        c[k >> 2] = 73848;
	                        break
	                    }
	                    case 37:
	                    {
	                        c[k >> 2] = 73280;
	                        break
	                    }
	                    case 86:
	                    {
	                        c[k >> 2] = 74912;
	                        break
	                    }
	                    case 39:
	                    {
	                        c[k >> 2] = 73360;
	                        break
	                    }
	                    default:
	                        c[k >> 2] = 75040
	                } while (0);
	                d = c[k >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = d;
	                    JT(l, 128, 75072, f) | 0
	                } else {
	                    c[f >> 2] = d;
	                    JT(l, 128, 75080, f) | 0
	                }
	                if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 84 >> 2] = c[h >> 2];
	                d = c[g >> 2] | 0;
	                k = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(0, 0, 0, d, 0, 1, k, 3, 0, 0, h, 0, 0, 0, 0, l, f);
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 288 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 212 >> 2] = 1;
	                i = e;
	                return
	            }

	            function pg(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = f;
	                    return
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                e = c[h >> 2] | 0;
	                d = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                b = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, 0, 1, d, 3, 0, 0, j, 0, 0, 0, 0, b, g);
	                if (!(c[h >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[h >> 2] | 0) + 288 >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 212 >> 2] = 1;
	                i = f;
	                return
	            }

	            function qg(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2], (c[c[j >> 2] >> 2] | 0) != 0) : 0) ? (c[(c[c[j >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497 : 0)c[o >> 2] = c[(c[c[j >> 2] >> 2] | 0) + 124 >> 2];
	                f = c[o >> 2] | 0;
	                o = c[j >> 2] | 0;
	                if (c[j >> 2] | 0) {
	                    e = c[o + 112 >> 2] | 0;
	                    d = c[(c[j >> 2] | 0) + 108 >> 2] | 0;
	                    b = c[j >> 2] | 0;
	                    a = c[k >> 2] | 0;
	                    p = c[m >> 2] | 0;
	                    q = c[n >> 2] | 0;
	                    r = c[l >> 2] | 0;
	                    s = c[n >> 2] | 0;
	                    c[h >> 2] = c[m >> 2];
	                    c[h + 4 >> 2] = s;
	                    Xd(f, e, d, b, 0, 4, a, 2, 0, 0, p, q, 0, 0, 0, r, h);
	                    c[(c[j >> 2] | 0) + 100 >> 2] = 0;
	                    i = g;
	                    return
	                } else {
	                    j = c[k >> 2] | 0;
	                    k = c[m >> 2] | 0;
	                    r = c[n >> 2] | 0;
	                    q = c[l >> 2] | 0;
	                    l = c[n >> 2] | 0;
	                    c[h >> 2] = c[m >> 2];
	                    c[h + 4 >> 2] = l;
	                    Xd(f, 0, 0, o, 0, 4, j, 2, 0, 0, k, r, 0, 0, 0, q, h);
	                    i = g;
	                    return
	                }
	            }

	            function rg(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[j >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497 : 0)c[o >> 2] = c[(c[c[j >> 2] >> 2] | 0) + 124 >> 2];
	                f = c[o >> 2] | 0;
	                o = c[j >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    e = c[k >> 2] | 0;
	                    d = c[m >> 2] | 0;
	                    b = c[n >> 2] | 0;
	                    a = c[l >> 2] | 0;
	                    p = c[n >> 2] | 0;
	                    c[h >> 2] = c[m >> 2];
	                    c[h + 4 >> 2] = p;
	                    Xd(f, 0, 0, o, 0, 1, e, 1, 0, 0, d, b, 0, 0, 0, a, h);
	                    i = g;
	                    return
	                }
	                if (c[o >> 2] | 0)q = c[(c[c[j >> 2] >> 2] | 0) + 84 >> 2] | 0; else q = 0;
	                o = c[(c[j >> 2] | 0) + 4 >> 2] | 0;
	                a = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                b = c[n >> 2] | 0;
	                d = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(f, q, o, a, 0, 1, j, 1, 0, 0, k, b, 0, 0, 0, d, h);
	                i = g;
	                return
	            }

	            function sg(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                    if ((c[(c[h >> 2] | 0) + 388 >> 2] | 0) == 89) {
	                        c[g >> 2] = 1;
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    if (((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 48 >> 2] | 0) != 6 : 0) ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 72 >> 2] | 0) == 0 : 0) ? (c[n >> 2] = c[(c[h >> 2] | 0) + 440 >> 2], c[(c[k >> 2] | 0) + 72 >> 2] = 1, c[o >> 2] = af(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 40 >> 2] | 0, 1, 0, 0, 0) | 0, c[(c[k >> 2] | 0) + 72 >> 2] = (c[(c[h >> 2] | 0) + 440 >> 2] | 0) - (c[n >> 2] | 0) + 1 << 1, (c[o >> 2] | 0) != 0) : 0) {
	                        if (vy(c[o >> 2] | 0, 60) | 0) {
	                            n = (c[k >> 2] | 0) + 72 | 0;
	                            c[n >> 2] = c[n >> 2] | 1
	                        }
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[o >> 2] = 0
	                    }
	                    do if (c[l >> 2] | 0) {
	                        if ((c[l >> 2] | 0) >>> 0 < 1e7) {
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                        if (c[(c[h >> 2] | 0) + 36 >> 2] | 0)c[m >> 2] = (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                        c[m >> 2] = (c[m >> 2] | 0) + (c[(c[h >> 2] | 0) + 444 >> 2] | 0);
	                        if ((c[l >> 2] | 0) >>> 0 < ((c[m >> 2] | 0) * 10 | 0) >>> 0) {
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                    } else {
	                        if (c[j >> 2] | 0) {
	                            if ((c[j >> 2] | 0) >>> 0 < 1e3) {
	                                c[g >> 2] = 0;
	                                p = c[g >> 2] | 0;
	                                i = f;
	                                return p | 0
	                            }
	                            if (c[(c[h >> 2] | 0) + 36 >> 2] | 0)c[m >> 2] = (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                            c[m >> 2] = (c[m >> 2] | 0) + (c[(c[h >> 2] | 0) + 444 >> 2] | 0);
	                            if ((c[j >> 2] | 0) >>> 0 >= ((c[m >> 2] | 0) * 10 | 0) >>> 0)break;
	                            if (((c[(c[h >> 2] | 0) + 440 >> 2] | 0) * 3 | 0) >>> 0 >= ((c[m >> 2] | 0) * 10 | 0) >>> 0)break;
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                        if (c[k >> 2] | 0) {
	                            c[j >> 2] = (c[(c[k >> 2] | 0) + 72 >> 2] | 0) / 2 | 0;
	                            if (c[(c[h >> 2] | 0) + 36 >> 2] | 0)c[m >> 2] = (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                            c[m >> 2] = (c[m >> 2] | 0) + (c[(c[h >> 2] | 0) + 444 >> 2] | 0);
	                            if (((c[j >> 2] | 0) * 3 | 0) >>> 0 >= ((c[m >> 2] | 0) * 10 | 0) >>> 0)break;
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        } else {
	                            if (!((c[(c[h >> 2] | 0) + 388 >> 2] | 0) != 26 ? (c[(c[h >> 2] | 0) + 388 >> 2] | 0) != 27 : 0))q = 36;
	                            if ((q | 0) == 36 ? (c[(c[h >> 2] | 0) + 440 >> 2] | 0) >>> 0 > 1e4 : 0)break;
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = f;
	                            return p | 0
	                        }
	                    } while (0);
	                    og(c[h >> 2] | 0, 89, 0);
	                    c[g >> 2] = 1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function tg(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ug(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[j >> 2] | 0)) {
	                    og(c[h >> 2] | 0, 1, 72912);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                if (c[33952] | 0) {
	                    d = c[33976] | 0;
	                    b = c[33980] | 0;
	                    c[f >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                    Db[d & 511](b, 72952, f)
	                }
	                c[k >> 2] = ue(c[h >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[m >> 2] = (xy(c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0) + 5;
	                c[l >> 2] = Cb[c[135752 >> 2] & 511](c[m >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    ie(c[h >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else {
	                    a[c[l >> 2] >> 0] = 32;
	                    a[(c[l >> 2] | 0) + 1 >> 0] = 37;
	                    a[(c[l >> 2] | 0) + ((c[m >> 2] | 0) - 3) >> 0] = 59;
	                    a[(c[l >> 2] | 0) + ((c[m >> 2] | 0) - 2) >> 0] = 32;
	                    a[(c[l >> 2] | 0) + ((c[m >> 2] | 0) - 1) >> 0] = 0;
	                    eU((c[l >> 2] | 0) + 2 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, (c[m >> 2] | 0) - 5 | 0) | 0;
	                    c[(c[k >> 2] | 0) + 40 >> 2] = 226;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                    c[(c[k >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                    c[(c[k >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                    c[(c[k >> 2] | 0) + 20 >> 2] = (c[l >> 2] | 0) + (c[m >> 2] | 0);
	                    c[g >> 2] = c[k >> 2];
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function vg(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                c[g >> 2] = (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                if ((((c[f >> 2] | 0) >>> 0 > 1e7 | (c[g >> 2] | 0) >>> 0 > 1e7 ? (c[c[(c[e >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[e >> 2] | 0) + 36 >> 2] >> 2] | 0) + 4 >> 2] | 0) != 227 : 0) ? (c[(c[e >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                    og(c[e >> 2] | 0, 1, 69896);
	                    c[(c[e >> 2] | 0) + 172 >> 2] = -1
	                }
	                ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                if (!(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                    i = b;
	                    return
	                }
	                if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                    i = b;
	                    return
	                }
	                Ve(c[e >> 2] | 0) | 0;
	                i = b;
	                return
	            }

	            function wg(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                c[k >> 2] = 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                c[j >> 2] = ne(c[f >> 2] | 0, h) | 0;
	                a = (c[j >> 2] | 0) == 32 | (c[j >> 2] | 0) == 62 | (c[j >> 2] | 0) == 47;
	                a:do if (!(c[(c[f >> 2] | 0) + 360 >> 2] & 131072)) {
	                    do if (!a) {
	                        if (((((((((((((!((c[j >> 2] | 0) >= 97 & (c[j >> 2] | 0) <= 122) ? !((c[j >> 2] | 0) >= 65 & (c[j >> 2] | 0) <= 90 | (c[j >> 2] | 0) == 95 | (c[j >> 2] | 0) == 58) : 0) ? !((c[j >> 2] | 0) >= 192 & (c[j >> 2] | 0) <= 214) : 0) ? !((c[j >> 2] | 0) >= 216 & (c[j >> 2] | 0) <= 246) : 0) ? !((c[j >> 2] | 0) >= 248 & (c[j >> 2] | 0) <= 767) : 0) ? !((c[j >> 2] | 0) >= 880 & (c[j >> 2] | 0) <= 893) : 0) ? !((c[j >> 2] | 0) >= 895 & (c[j >> 2] | 0) <= 8191) : 0) ? !((c[j >> 2] | 0) >= 8204 & (c[j >> 2] | 0) <= 8205) : 0) ? !((c[j >> 2] | 0) >= 8304 & (c[j >> 2] | 0) <= 8591) : 0) ? !((c[j >> 2] | 0) >= 11264 & (c[j >> 2] | 0) <= 12271) : 0) ? !((c[j >> 2] | 0) >= 12289 & (c[j >> 2] | 0) <= 55295) : 0) ? !((c[j >> 2] | 0) >= 63744 & (c[j >> 2] | 0) <= 64975) : 0) ? !((c[j >> 2] | 0) >= 65008 & (c[j >> 2] | 0) <= 65533) : 0) ? !((c[j >> 2] | 0) >= 65536 & (c[j >> 2] | 0) <= 983039) : 0)break;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                        m = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            n = m + 28 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            n = m + 32 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        n = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + (c[h >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        c[j >> 2] = ne(c[f >> 2] | 0, h) | 0;
	                        while (1) {
	                            if (!((c[j >> 2] | 0) != 32 & (c[j >> 2] | 0) != 62 & (c[j >> 2] | 0) != 47))break a;
	                            do if (((((((!((c[j >> 2] | 0) >= 97 & (c[j >> 2] | 0) <= 122) ? !((c[j >> 2] | 0) >= 65 & (c[j >> 2] | 0) <= 90) : 0) ? !((c[j >> 2] | 0) >= 48 & (c[j >> 2] | 0) <= 57 | (c[j >> 2] | 0) == 95 | (c[j >> 2] | 0) == 58 | (c[j >> 2] | 0) == 45 | (c[j >> 2] | 0) == 46 | (c[j >> 2] | 0) == 183) : 0) ? !((c[j >> 2] | 0) >= 192 & (c[j >> 2] | 0) <= 214) : 0) ? !((c[j >> 2] | 0) >= 216 & (c[j >> 2] | 0) <= 246) : 0) ? !((c[j >> 2] | 0) >= 248 & (c[j >> 2] | 0) <= 767) : 0) ? !((c[j >> 2] | 0) >= 768 & (c[j >> 2] | 0) <= 879) : 0) ? !((c[j >> 2] | 0) >= 880 & (c[j >> 2] | 0) <= 893) : 0) {
	                                if ((c[j >> 2] | 0) >= 895 & (c[j >> 2] | 0) <= 8191)break;
	                                if ((c[j >> 2] | 0) >= 8204 & (c[j >> 2] | 0) <= 8205)break;
	                                if ((c[j >> 2] | 0) >= 8255 & (c[j >> 2] | 0) <= 8256)break;
	                                if ((c[j >> 2] | 0) >= 8304 & (c[j >> 2] | 0) <= 8591)break;
	                                if ((c[j >> 2] | 0) >= 11264 & (c[j >> 2] | 0) <= 12271)break;
	                                if ((c[j >> 2] | 0) >= 12289 & (c[j >> 2] | 0) <= 55295)break;
	                                if ((c[j >> 2] | 0) >= 63744 & (c[j >> 2] | 0) <= 64975)break;
	                                if ((c[j >> 2] | 0) >= 65008 & (c[j >> 2] | 0) <= 65533)break;
	                                if (!((c[j >> 2] | 0) >= 65536 & (c[j >> 2] | 0) <= 983039))break a
	                            } while (0);
	                            n = c[k >> 2] | 0;
	                            c[k >> 2] = n + 1;
	                            if ((n | 0) > 100) {
	                                c[k >> 2] = 0;
	                                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1)break
	                            }
	                            c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                            n = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                                m = n + 28 | 0;
	                                c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                            } else {
	                                m = n + 32 | 0;
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            m = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[m >> 2] = (c[m >> 2] | 0) + (c[h >> 2] | 0);
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                            c[j >> 2] = ne(c[f >> 2] | 0, h) | 0
	                        }
	                        c[e >> 2] = 0;
	                        l = c[e >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    } while (0);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } else {
	                    b:do if (!a) {
	                        m = c[j >> 2] | 0;
	                        if ((c[j >> 2] | 0) < 256) {
	                            if (((!(65 <= (m | 0) & (c[j >> 2] | 0) <= 90) ? !(97 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 122) : 0) ? !(192 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 214) : 0) ? !(216 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 246 | 248 <= (c[j >> 2] | 0)) : 0)o = 66
	                        } else if (!(DQ(m, 199744) | 0))o = 66;
	                        do if ((o | 0) == 66) {
	                            m = c[j >> 2] | 0;
	                            if ((c[j >> 2] | 0) < 256)if ((m | 0) != 95 & (c[j >> 2] | 0) != 58)break b; else break;
	                            if (!(19968 <= (m | 0) & (c[j >> 2] | 0) <= 40869 | (c[j >> 2] | 0) == 12295) ? (12321 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 12329 ^ 1) & (c[j >> 2] | 0) != 95 & (c[j >> 2] | 0) != 58 : 0)break b
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                        m = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            n = m + 28 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            n = m + 32 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        n = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + (c[h >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        c[j >> 2] = ne(c[f >> 2] | 0, h) | 0;
	                        while (1) {
	                            if (!((c[j >> 2] | 0) != 32 & (c[j >> 2] | 0) != 62 & (c[j >> 2] | 0) != 47))break a;
	                            n = c[j >> 2] | 0;
	                            if ((c[j >> 2] | 0) < 256) {
	                                if (((!(65 <= (n | 0) & (c[j >> 2] | 0) <= 90) ? !(97 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 122) : 0) ? !(192 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 214) : 0) ? !(216 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 246 | 248 <= (c[j >> 2] | 0)) : 0)o = 84
	                            } else if (!(DQ(n, 199744) | 0))o = 84;
	                            do if ((o | 0) == 84) {
	                                o = 0;
	                                if ((c[j >> 2] | 0) >= 256) {
	                                    if (19968 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 40869 | (c[j >> 2] | 0) == 12295)break;
	                                    if (12321 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 12329)break
	                                }
	                                n = c[j >> 2] | 0;
	                                if ((c[j >> 2] | 0) < 256) {
	                                    if (48 <= (n | 0) & (c[j >> 2] | 0) <= 57 | (c[j >> 2] | 0) == 46 | (c[j >> 2] | 0) == 45 | (c[j >> 2] | 0) == 95 | (c[j >> 2] | 0) == 58)break
	                                } else {
	                                    m = (DQ(n, 200216) | 0) != 0;
	                                    if (m | (c[j >> 2] | 0) == 46 | (c[j >> 2] | 0) == 45 | (c[j >> 2] | 0) == 95 | (c[j >> 2] | 0) == 58)break
	                                }
	                                if ((c[j >> 2] | 0) >= 256 ? (DQ(c[j >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                                m = c[j >> 2] | 0;
	                                if ((c[j >> 2] | 0) < 256)p = (m | 0) == 183 & 1; else p = DQ(m, 200272) | 0;
	                                if (!p)break a
	                            } while (0);
	                            m = c[k >> 2] | 0;
	                            c[k >> 2] = m + 1;
	                            if ((m | 0) > 100) {
	                                c[k >> 2] = 0;
	                                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                                if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    o = 101;
	                                    break
	                                }
	                            }
	                            c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                            m = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                                n = m + 28 | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + 1;
	                                c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                            } else {
	                                n = m + 32 | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + 1
	                            }
	                            n = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + (c[h >> 2] | 0);
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                            c[j >> 2] = ne(c[f >> 2] | 0, h) | 0;
	                            if (c[j >> 2] | 0)continue;
	                            c[k >> 2] = 0;
	                            if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                            if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                o = 112;
	                                break
	                            }
	                            c[j >> 2] = ne(c[f >> 2] | 0, h) | 0
	                        }
	                        if ((o | 0) == 101) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        } else if ((o | 0) == 112) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                    } while (0);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } while (0);
	                if ((c[g >> 2] | 0) > 5e4 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                    og(c[f >> 2] | 0, 110, 65688);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + -1 >> 0] | 0 | 0) == 13 : 0) {
	                    c[e >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (0 - ((c[g >> 2] | 0) + 1)) | 0, c[g >> 2] | 0) | 0;
	                    l = c[e >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                c[e >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (0 - (c[g >> 2] | 0)) | 0, c[g >> 2] | 0) | 0;
	                l = c[e >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function xg(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = e;
	                    return
	                }
	                if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 84 >> 2] = c[h >> 2];
	                d = c[g >> 2] | 0;
	                b = c[h >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(0, 0, 0, d, 0, 1, b, 3, 0, 0, 0, 0, 0, 0, 0, 72848, f);
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 288 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 212 >> 2] = 1;
	                i = e;
	                return
	            }

	            function yg(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 24 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[c[j >> 2] >> 2];
	                    a[l >> 0] = a[c[k >> 2] >> 0] | 0;
	                    if (((d[l >> 0] | 0 | 0) == 38 ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) ? (d[(c[k >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) {
	                        c[k >> 2] = (c[k >> 2] | 0) + 3;
	                        a[l >> 0] = a[c[k >> 2] >> 0] | 0;
	                        a:while (1) {
	                            if ((d[l >> 0] | 0 | 0) == 59)break;
	                            if ((d[l >> 0] | 0 | 0) >= 48 ? (d[l >> 0] | 0 | 0) <= 57 : 0)c[m >> 2] = (c[m >> 2] << 4) + ((d[l >> 0] | 0) - 48); else o = 12;
	                            do if ((o | 0) == 12) {
	                                o = 0;
	                                if ((d[l >> 0] | 0 | 0) >= 97 ? (d[l >> 0] | 0 | 0) <= 102 : 0) {
	                                    c[m >> 2] = (c[m >> 2] << 4) + ((d[l >> 0] | 0) - 97) + 10;
	                                    break
	                                }
	                                if ((d[l >> 0] | 0 | 0) < 65) {
	                                    o = 18;
	                                    break a
	                                }
	                                if ((d[l >> 0] | 0 | 0) > 70) {
	                                    o = 18;
	                                    break a
	                                }
	                                c[m >> 2] = (c[m >> 2] << 4) + ((d[l >> 0] | 0) - 65) + 10
	                            } while (0);
	                            if ((c[m >> 2] | 0) >>> 0 > 1114111)c[n >> 2] = c[m >> 2];
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            a[l >> 0] = a[c[k >> 2] >> 0] | 0
	                        }
	                        if ((o | 0) == 18) {
	                            og(c[h >> 2] | 0, 6, 0);
	                            c[m >> 2] = 0
	                        }
	                        if ((d[l >> 0] | 0 | 0) == 59)c[k >> 2] = (c[k >> 2] | 0) + 1
	                    } else o = 24;
	                    do if ((o | 0) == 24) {
	                        if ((d[l >> 0] | 0 | 0) == 38 ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) {
	                            c[k >> 2] = (c[k >> 2] | 0) + 2;
	                            a[l >> 0] = a[c[k >> 2] >> 0] | 0;
	                            while (1) {
	                                if ((d[l >> 0] | 0 | 0) == 59)break;
	                                if ((d[l >> 0] | 0 | 0) < 48) {
	                                    o = 31;
	                                    break
	                                }
	                                if ((d[l >> 0] | 0 | 0) > 57) {
	                                    o = 31;
	                                    break
	                                }
	                                c[m >> 2] = ((c[m >> 2] | 0) * 10 | 0) + ((d[l >> 0] | 0) - 48);
	                                if ((c[m >> 2] | 0) >>> 0 > 1114111)c[n >> 2] = c[m >> 2];
	                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                a[l >> 0] = a[c[k >> 2] >> 0] | 0
	                            }
	                            if ((o | 0) == 31) {
	                                og(c[h >> 2] | 0, 7, 0);
	                                c[m >> 2] = 0
	                            }
	                            if ((d[l >> 0] | 0 | 0) != 59)break;
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            break
	                        }
	                        og(c[h >> 2] | 0, 8, 0);
	                        c[g >> 2] = 0;
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } while (0);
	                    c[c[j >> 2] >> 2] = c[k >> 2];
	                    k = c[m >> 2] | 0;
	                    do if ((c[m >> 2] | 0) >>> 0 < 256)if ((9 <= k >>> 0 & (c[m >> 2] | 0) >>> 0 <= 10 | (c[m >> 2] | 0) == 13 | 32 <= (c[m >> 2] | 0) >>> 0) & (c[n >> 2] | 0) == 0)o = 43; else o = 44; else {
	                        if (!(256 <= k >>> 0 & (c[m >> 2] | 0) >>> 0 <= 55295) ? !(57344 <= (c[m >> 2] | 0) >>> 0 & (c[m >> 2] | 0) >>> 0 <= 65533) : 0)if (65536 <= (c[m >> 2] | 0) >>> 0 & (c[m >> 2] | 0) >>> 0 <= 1114111 & (c[n >> 2] | 0) == 0) {
	                            o = 43;
	                            break
	                        } else {
	                            o = 44;
	                            break
	                        }
	                        if (!(c[n >> 2] | 0))o = 43; else o = 44
	                    } while (0);
	                    if ((o | 0) == 43) {
	                        c[g >> 2] = c[m >> 2];
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((o | 0) == 44) {
	                        ng(c[h >> 2] | 0, 9, 72856, c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                }
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function zg(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f + 24 | 0;
	                n = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) {
	                    c[l >> 2] = c[c[j >> 2] >> 2];
	                    a[m >> 0] = a[c[l >> 2] >> 0] | 0;
	                    if ((d[m >> 0] | 0 | 0) != 38) {
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    c[k >> 2] = Dg(c[h >> 2] | 0, l) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        xg(c[h >> 2] | 0, 68, 72152);
	                        c[c[j >> 2] >> 2] = c[l >> 2];
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    if ((d[c[l >> 2] >> 0] | 0 | 0) != 59) {
	                        og(c[h >> 2] | 0, 23, 0);
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        c[c[j >> 2] >> 2] = c[l >> 2];
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    if ((c[(c[h >> 2] | 0) + 360 >> 2] & 1048576 | 0) == 0 ? (c[n >> 2] = Yc(c[k >> 2] | 0) | 0, (c[n >> 2] | 0) != 0) : 0) {
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        c[c[j >> 2] >> 2] = c[l >> 2];
	                        c[g >> 2] = c[n >> 2];
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    m = (c[h >> 2] | 0) + 440 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    if (c[c[h >> 2] >> 2] | 0) {
	                        if (c[(c[c[h >> 2] >> 2] | 0) + 20 >> 2] | 0)c[n >> 2] = Hb[c[(c[c[h >> 2] >> 2] | 0) + 20 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if ((c[n >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 360 >> 2] & 1048576 | 0) != 0 : 0)c[n >> 2] = Yc(c[k >> 2] | 0) | 0;
	                        if ((c[n >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == (c[h >> 2] | 0) : 0)c[n >> 2] = VP(c[h >> 2] | 0, c[k >> 2] | 0) | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    do if (c[n >> 2] | 0) {
	                        m = c[h >> 2] | 0;
	                        if ((c[(c[n >> 2] | 0) + 48 >> 2] | 0) == 3) {
	                            pg(m, 28, 68712, c[k >> 2] | 0);
	                            break
	                        }
	                        if ((c[m + 172 >> 2] | 0) == 12 ? (c[(c[n >> 2] | 0) + 48 >> 2] | 0) == 2 : 0) {
	                            pg(c[h >> 2] | 0, 29, 68752, c[k >> 2] | 0);
	                            break
	                        }
	                        if (((((c[n >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == 12 : 0) ? (c[(c[n >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 48 >> 2] | 0) != 6 : 0) ? (vy(c[(c[n >> 2] | 0) + 40 >> 2] | 0, 60) | 0) != 0 : 0) {
	                            pg(c[h >> 2] | 0, 38, 68800, c[k >> 2] | 0);
	                            break
	                        }
	                        if (((c[(c[n >> 2] | 0) + 48 >> 2] | 0) + -4 | 0) >>> 0 < 2)pg(c[h >> 2] | 0, 30, 68856, c[k >> 2] | 0)
	                    } else {
	                        do if ((c[(c[h >> 2] | 0) + 28 >> 2] | 0) == 1)p = 28; else {
	                            if ((c[(c[h >> 2] | 0) + 88 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 92 >> 2] | 0) == 0 : 0) {
	                                p = 28;
	                                break
	                            }
	                            Lg(c[h >> 2] | 0, 27, 68680, c[k >> 2] | 0)
	                        } while (0);
	                        if ((p | 0) == 28)pg(c[h >> 2] | 0, 26, 68680, c[k >> 2] | 0);
	                        sg(c[h >> 2] | 0, 0, c[n >> 2] | 0, 0) | 0
	                    } while (0);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[c[j >> 2] >> 2] = c[l >> 2];
	                    c[g >> 2] = c[n >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[g >> 2] = 0;
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Ag(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 24 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[c[j >> 2] >> 2];
	                    a[l >> 0] = a[c[k >> 2] >> 0] | 0;
	                    if ((d[l >> 0] | 0 | 0) != 37) {
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    c[m >> 2] = Dg(c[h >> 2] | 0, k) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        xg(c[h >> 2] | 0, 68, 71904);
	                        c[c[j >> 2] >> 2] = c[k >> 2];
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    a[l >> 0] = a[c[k >> 2] >> 0] | 0;
	                    if ((d[l >> 0] | 0 | 0) != 59) {
	                        og(c[h >> 2] | 0, 23, 0);
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[c[j >> 2] >> 2] = c[k >> 2];
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    l = (c[h >> 2] | 0) + 440 | 0;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    if ((c[c[h >> 2] >> 2] | 0) != 0 ? (c[(c[c[h >> 2] >> 2] | 0) + 96 >> 2] | 0) != 0 : 0)c[n >> 2] = Hb[c[(c[c[h >> 2] >> 2] | 0) + 96 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                    if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    if (c[n >> 2] | 0) {
	                        if ((c[(c[n >> 2] | 0) + 48 >> 2] | 0) != 4 ? (c[(c[n >> 2] | 0) + 48 >> 2] | 0) != 5 : 0)rg(c[h >> 2] | 0, 27, 71944, c[m >> 2] | 0, 0)
	                    } else {
	                        do if ((c[(c[h >> 2] | 0) + 28 >> 2] | 0) == 1)p = 19; else {
	                            if ((c[(c[h >> 2] | 0) + 88 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 92 >> 2] | 0) == 0 : 0) {
	                                p = 19;
	                                break
	                            }
	                            rg(c[h >> 2] | 0, 27, 65432, c[m >> 2] | 0, 0);
	                            c[(c[h >> 2] | 0) + 100 >> 2] = 0
	                        } while (0);
	                        if ((p | 0) == 19)pg(c[h >> 2] | 0, 26, 65432, c[m >> 2] | 0);
	                        sg(c[h >> 2] | 0, 0, 0, 0) | 0
	                    }
	                    c[(c[h >> 2] | 0) + 92 >> 2] = 1;
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[c[j >> 2] >> 2] = c[k >> 2];
	                    c[g >> 2] = c[n >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[g >> 2] = 0;
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Bg(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[o >> 2] = 0;
	                do if (!((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0)) {
	                    if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 5 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 2 : 0)break;
	                    if (!(c[(c[j >> 2] | 0) + 40 >> 2] | 0)) {
	                        if (c[33952] | 0) {
	                            b = c[33976] | 0;
	                            a = c[33980] | 0;
	                            c[f >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                            Db[b & 511](a, 72024, f)
	                        }
	                        c[l >> 2] = kj() | 0;
	                        a = c[h >> 2] | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            og(a, 1, 71984);
	                            c[g >> 2] = -1;
	                            p = c[g >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        c[k >> 2] = we(a, c[j >> 2] | 0) | 0;
	                        a = c[h >> 2] | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            og(a, 1, 72064);
	                            lj(c[l >> 2] | 0);
	                            c[g >> 2] = -1;
	                            p = c[g >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((Xe(a, c[k >> 2] | 0) | 0) < 0) {
	                            lj(c[l >> 2] | 0);
	                            c[g >> 2] = -1;
	                            p = c[g >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                        if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                        c[n >> 2] = ne(c[h >> 2] | 0, m) | 0;
	                        while (1) {
	                            if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != (c[k >> 2] | 0)) {
	                                q = 46;
	                                break
	                            }
	                            if ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 >= (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0) {
	                                q = 46;
	                                break
	                            }
	                            a = c[n >> 2] | 0;
	                            if ((c[n >> 2] | 0) < 256)if (9 <= (a | 0) & (c[n >> 2] | 0) <= 10 | (c[n >> 2] | 0) == 13)r = 1; else r = 32 <= (c[n >> 2] | 0); else if (!(256 <= (a | 0) & (c[n >> 2] | 0) <= 55295) ? !(57344 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 65533) : 0)if (65536 <= (c[n >> 2] | 0))r = (c[n >> 2] | 0) <= 1114111; else r = 0; else r = 1;
	                            if (!(r & 1)) {
	                                q = 46;
	                                break
	                            }
	                            nj(c[l >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[m >> 2] | 0) | 0;
	                            a = c[o >> 2] | 0;
	                            c[o >> 2] = a + 1;
	                            if ((a | 0) > 100) {
	                                c[o >> 2] = 0;
	                                if ((c[(c[h >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                                if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    q = 33;
	                                    break
	                                }
	                            }
	                            a = c[(c[h >> 2] | 0) + 36 >> 2] | 0;
	                            if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                                b = a + 28 | 0;
	                                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                                c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                            } else {
	                                b = a + 32 | 0;
	                                c[b >> 2] = (c[b >> 2] | 0) + 1
	                            }
	                            b = (c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + (c[m >> 2] | 0);
	                            if ((d[c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[h >> 2] | 0);
	                            c[n >> 2] = ne(c[h >> 2] | 0, m) | 0;
	                            if (c[n >> 2] | 0)continue;
	                            c[o >> 2] = 0;
	                            do if (!(c[(c[h >> 2] | 0) + 292 >> 2] | 0)) {
	                                if (((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                                vg(c[h >> 2] | 0)
	                            } while (0);
	                            if ((c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                q = 44;
	                                break
	                            }
	                            c[n >> 2] = ne(c[h >> 2] | 0, m) | 0
	                        }
	                        if ((q | 0) == 33) {
	                            lj(c[l >> 2] | 0);
	                            c[g >> 2] = -1;
	                            p = c[g >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        } else if ((q | 0) == 44) {
	                            lj(c[l >> 2] | 0);
	                            c[g >> 2] = -1;
	                            p = c[g >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        } else if ((q | 0) == 46) {
	                            if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) == (c[k >> 2] | 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 >= (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0 : 0)Ve(c[h >> 2] | 0) | 0; else q = 49;
	                            do if ((q | 0) == 49) {
	                                b = c[n >> 2] | 0;
	                                if ((c[n >> 2] | 0) < 256) {
	                                    if (9 <= (b | 0) & (c[n >> 2] | 0) <= 10 | (c[n >> 2] | 0) == 13 | 32 <= (c[n >> 2] | 0))break
	                                } else {
	                                    if (256 <= (b | 0) & (c[n >> 2] | 0) <= 55295)break;
	                                    if (57344 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 65533)break;
	                                    if (65536 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 1114111)break
	                                }
	                                ng(c[h >> 2] | 0, 9, 72104, c[n >> 2] | 0);
	                                lj(c[l >> 2] | 0);
	                                c[g >> 2] = -1;
	                                p = c[g >> 2] | 0;
	                                i = e;
	                                return p | 0
	                            } while (0);
	                            c[(c[j >> 2] | 0) + 40 >> 2] = c[c[l >> 2] >> 2];
	                            c[c[l >> 2] >> 2] = 0;
	                            lj(c[l >> 2] | 0);
	                            c[g >> 2] = 0;
	                            p = c[g >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        }
	                    }
	                } while (0);
	                og(c[h >> 2] | 0, 1, 71984);
	                c[g >> 2] = -1;
	                p = c[g >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function Cg(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[g >> 2] | 0;
	                a:do if (!(c[(c[f >> 2] | 0) + 360 >> 2] & 131072)) {
	                    if ((b | 0) != 32 & (c[g >> 2] | 0) != 62 & (c[g >> 2] | 0) != 47) {
	                        if ((((((((((((((((!((c[g >> 2] | 0) >= 97 & (c[g >> 2] | 0) <= 122) ? !((c[g >> 2] | 0) >= 65 & (c[g >> 2] | 0) <= 90) : 0) ? !((c[g >> 2] | 0) >= 48 & (c[g >> 2] | 0) <= 57 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58 | (c[g >> 2] | 0) == 45 | (c[g >> 2] | 0) == 46 | (c[g >> 2] | 0) == 183) : 0) ? !((c[g >> 2] | 0) >= 192 & (c[g >> 2] | 0) <= 214) : 0) ? !((c[g >> 2] | 0) >= 216 & (c[g >> 2] | 0) <= 246) : 0) ? !((c[g >> 2] | 0) >= 248 & (c[g >> 2] | 0) <= 767) : 0) ? !((c[g >> 2] | 0) >= 768 & (c[g >> 2] | 0) <= 879) : 0) ? !((c[g >> 2] | 0) >= 880 & (c[g >> 2] | 0) <= 893) : 0) ? !((c[g >> 2] | 0) >= 895 & (c[g >> 2] | 0) <= 8191) : 0) ? !((c[g >> 2] | 0) >= 8204 & (c[g >> 2] | 0) <= 8205) : 0) ? !((c[g >> 2] | 0) >= 8255 & (c[g >> 2] | 0) <= 8256) : 0) ? !((c[g >> 2] | 0) >= 8304 & (c[g >> 2] | 0) <= 8591) : 0) ? !((c[g >> 2] | 0) >= 11264 & (c[g >> 2] | 0) <= 12271) : 0) ? !((c[g >> 2] | 0) >= 12289 & (c[g >> 2] | 0) <= 55295) : 0) ? !((c[g >> 2] | 0) >= 63744 & (c[g >> 2] | 0) <= 64975) : 0) ? !((c[g >> 2] | 0) >= 65008 & (c[g >> 2] | 0) <= 65533) : 0) ? !((c[g >> 2] | 0) >= 65536 & (c[g >> 2] | 0) <= 983039) : 0)break;
	                        c[e >> 2] = 1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                } else {
	                    a = c[g >> 2] | 0;
	                    if ((b | 0) < 256) {
	                        if (((!(65 <= (a | 0) & (c[g >> 2] | 0) <= 90) ? !(97 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 122) : 0) ? !(192 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 214) : 0) ? !(216 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 246 | 248 <= (c[g >> 2] | 0)) : 0)j = 27
	                    } else if (!(DQ(a, 199744) | 0))j = 27;
	                    do if ((j | 0) == 27) {
	                        if ((c[g >> 2] | 0) >= 256) {
	                            if (19968 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 40869 | (c[g >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 12329)break
	                        }
	                        a = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 256) {
	                            if (48 <= (a | 0) & (c[g >> 2] | 0) <= 57 | (c[g >> 2] | 0) == 46 | (c[g >> 2] | 0) == 45 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58)break
	                        } else {
	                            k = (DQ(a, 200216) | 0) != 0;
	                            if (k | (c[g >> 2] | 0) == 46 | (c[g >> 2] | 0) == 45 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58)break
	                        }
	                        if ((c[g >> 2] | 0) >= 256 ? (DQ(c[g >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        k = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 256)if ((k | 0) == 183)break; else break a; else if (DQ(k, 200272) | 0)break; else break a
	                    } while (0);
	                    c[e >> 2] = 1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Dg(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 160 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 40 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[k >> 2] = c[c[h >> 2] >> 2];
	                c[l >> 2] = 0;
	                c[n >> 2] = oe(c[g >> 2] | 0, c[k >> 2] | 0, m) | 0;
	                if (!(kh(c[g >> 2] | 0, c[n >> 2] | 0) | 0)) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if ((c[m >> 2] | 0) == 1) {
	                    d = c[n >> 2] & 255;
	                    b = c[l >> 2] | 0;
	                    c[l >> 2] = b + 1;
	                    a[j + b >> 0] = d
	                } else {
	                    d = pe(j + (c[l >> 2] | 0) | 0, c[n >> 2] | 0) | 0;
	                    c[l >> 2] = (c[l >> 2] | 0) + d
	                }
	                c[k >> 2] = (c[k >> 2] | 0) + (c[m >> 2] | 0);
	                c[n >> 2] = oe(c[g >> 2] | 0, c[k >> 2] | 0, m) | 0;
	                do {
	                    if (!(Cg(c[g >> 2] | 0, c[n >> 2] | 0) | 0)) {
	                        s = 28;
	                        break
	                    }
	                    if ((c[m >> 2] | 0) == 1) {
	                        d = c[n >> 2] & 255;
	                        b = c[l >> 2] | 0;
	                        c[l >> 2] = b + 1;
	                        a[j + b >> 0] = d
	                    } else {
	                        d = pe(j + (c[l >> 2] | 0) | 0, c[n >> 2] | 0) | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + d
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + (c[m >> 2] | 0);
	                    c[n >> 2] = oe(c[g >> 2] | 0, c[k >> 2] | 0, m) | 0
	                } while ((c[l >> 2] | 0) < 100);
	                if ((s | 0) == 28) {
	                    if ((c[l >> 2] | 0) > 5e4 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                        og(c[g >> 2] | 0, 110, 70920);
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    c[c[h >> 2] >> 2] = c[k >> 2];
	                    c[f >> 2] = ly(j, c[l >> 2] | 0) | 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[p >> 2] = c[l >> 2] << 1;
	                c[o >> 2] = Cb[c[135752 >> 2] & 511](c[p >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    ie(c[g >> 2] | 0, 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                eU(c[o >> 2] | 0, j | 0, c[l >> 2] | 0) | 0;
	                while (1) {
	                    j = (Cg(c[g >> 2] | 0, c[n >> 2] | 0) | 0) != 0;
	                    t = c[l >> 2] | 0;
	                    if (!j) {
	                        s = 27;
	                        break
	                    }
	                    if ((t + 10 | 0) > (c[p >> 2] | 0)) {
	                        if ((c[l >> 2] | 0) > 5e4 ? (c[(c[g >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            s = 19;
	                            break
	                        }
	                        c[p >> 2] = c[p >> 2] << 1;
	                        c[q >> 2] = Hb[c[135760 >> 2] & 511](c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            s = 21;
	                            break
	                        }
	                        c[o >> 2] = c[q >> 2]
	                    }
	                    if ((c[m >> 2] | 0) == 1) {
	                        j = c[n >> 2] & 255;
	                        d = c[l >> 2] | 0;
	                        c[l >> 2] = d + 1;
	                        a[(c[o >> 2] | 0) + d >> 0] = j
	                    } else {
	                        j = pe((c[o >> 2] | 0) + (c[l >> 2] | 0) | 0, c[n >> 2] | 0) | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + j
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + (c[m >> 2] | 0);
	                    c[n >> 2] = oe(c[g >> 2] | 0, c[k >> 2] | 0, m) | 0
	                }
	                if ((s | 0) == 19) {
	                    og(c[g >> 2] | 0, 110, 70920);
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((s | 0) == 21) {
	                    ie(c[g >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((s | 0) == 27) {
	                    a[(c[o >> 2] | 0) + t >> 0] = 0;
	                    c[c[h >> 2] >> 2] = c[k >> 2];
	                    c[f >> 2] = c[o >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                return 0
	            }

	            function Eg(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0;
	                h = i;
	                i = i + 96 | 0;
	                j = h + 84 | 0;
	                k = h + 80 | 0;
	                l = h + 76 | 0;
	                m = h + 72 | 0;
	                n = h + 68 | 0;
	                o = h + 88 | 0;
	                p = h + 64 | 0;
	                q = h + 60 | 0;
	                r = h + 56 | 0;
	                s = h + 52 | 0;
	                t = h + 48 | 0;
	                u = h + 44 | 0;
	                v = h + 40 | 0;
	                w = h + 36 | 0;
	                x = h + 32 | 0;
	                y = h + 28 | 0;
	                z = h + 24 | 0;
	                A = h + 20 | 0;
	                B = h + 16 | 0;
	                C = h + 12 | 0;
	                D = h + 8 | 0;
	                E = h + 4 | 0;
	                F = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                a[o >> 0] = 0;
	                c[p >> 2] = 0;
	                c[t >> 2] = 0;
	                if ((c[(c[k >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[k >> 2] | 0);
	                c[p >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[u >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                c[v >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2];
	                if ((d[c[p >> 2] >> 0] | 0 | 0) != 34 ? (d[c[p >> 2] >> 0] | 0 | 0) != 39 : 0) {
	                    og(c[k >> 2] | 0, 39, 0);
	                    c[j >> 2] = 0;
	                    G = c[j >> 2] | 0;
	                    i = h;
	                    return G | 0
	                }
	                c[(c[k >> 2] | 0) + 172 >> 2] = 12;
	                g = c[p >> 2] | 0;
	                c[p >> 2] = g + 1;
	                a[o >> 0] = a[g >> 0] | 0;
	                c[v >> 2] = (c[v >> 2] | 0) + 1;
	                c[r >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                c[q >> 2] = c[p >> 2];
	                if ((c[p >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                    c[w >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                    if ((c[(c[k >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[k >> 2] | 0);
	                    if ((c[w >> 2] | 0) != (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[x >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) - (c[w >> 2] | 0);
	                        c[q >> 2] = (c[q >> 2] | 0) + (c[x >> 2] | 0);
	                        c[p >> 2] = (c[p >> 2] | 0) + (c[x >> 2] | 0)
	                    }
	                    c[r >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2]
	                }
	                do if (c[n >> 2] | 0) {
	                    while (1) {
	                        if ((c[p >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                            H = 35;
	                            break
	                        }
	                        if ((d[c[p >> 2] >> 0] | 0 | 0) == (d[o >> 0] | 0 | 0)) {
	                            H = 35;
	                            break
	                        }
	                        if ((((d[c[p >> 2] >> 0] | 0 | 0) != 32 ? (d[c[p >> 2] >> 0] | 0 | 0) != 9 : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) != 10 : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) != 13 : 0) {
	                            H = 35;
	                            break
	                        }
	                        if ((d[c[p >> 2] >> 0] | 0 | 0) == 10) {
	                            c[u >> 2] = (c[u >> 2] | 0) + 1;
	                            c[v >> 2] = 1
	                        } else c[v >> 2] = (c[v >> 2] | 0) + 1;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1;
	                        c[q >> 2] = c[p >> 2];
	                        if ((c[p >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)continue;
	                        c[y >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                        if ((c[(c[k >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[k >> 2] | 0);
	                        if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            H = 29;
	                            break
	                        }
	                        if ((c[y >> 2] | 0) != (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                            c[z >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) - (c[y >> 2] | 0);
	                            c[q >> 2] = (c[q >> 2] | 0) + (c[z >> 2] | 0);
	                            c[p >> 2] = (c[p >> 2] | 0) + (c[z >> 2] | 0)
	                        }
	                        c[r >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                        if (((c[p >> 2] | 0) - (c[q >> 2] | 0) | 0) <= 1e7)continue;
	                        if (!(c[(c[k >> 2] | 0) + 360 >> 2] & 524288)) {
	                            H = 34;
	                            break
	                        }
	                    }
	                    if ((H | 0) == 29) {
	                        c[j >> 2] = 0;
	                        G = c[j >> 2] | 0;
	                        i = h;
	                        return G | 0
	                    } else if ((H | 0) == 34) {
	                        xg(c[k >> 2] | 0, 40, 71720);
	                        c[j >> 2] = 0;
	                        G = c[j >> 2] | 0;
	                        i = h;
	                        return G | 0
	                    } else if ((H | 0) == 35) {
	                        while (1) {
	                            H = 0;
	                            if ((c[p >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                                H = 54;
	                                break
	                            }
	                            if ((d[c[p >> 2] >> 0] | 0 | 0) == (d[o >> 0] | 0 | 0)) {
	                                H = 54;
	                                break
	                            }
	                            if ((d[c[p >> 2] >> 0] | 0 | 0) < 32) {
	                                H = 54;
	                                break
	                            }
	                            if ((d[c[p >> 2] >> 0] | 0 | 0) > 127) {
	                                H = 54;
	                                break
	                            }
	                            if ((d[c[p >> 2] >> 0] | 0 | 0) == 38) {
	                                H = 54;
	                                break
	                            }
	                            if ((d[c[p >> 2] >> 0] | 0 | 0) == 60) {
	                                H = 54;
	                                break
	                            }
	                            c[v >> 2] = (c[v >> 2] | 0) + 1;
	                            x = c[p >> 2] | 0;
	                            c[p >> 2] = x + 1;
	                            if ((d[x >> 0] | 0 | 0) == 32 ? (d[c[p >> 2] >> 0] | 0 | 0) == 32 : 0) {
	                                H = 54;
	                                break
	                            }
	                            if ((c[p >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0) {
	                                H = 35;
	                                continue
	                            }
	                            c[A >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                            if ((c[(c[k >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[k >> 2] | 0);
	                            if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                H = 48;
	                                break
	                            }
	                            if ((c[A >> 2] | 0) != (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                                c[B >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) - (c[A >> 2] | 0);
	                                c[q >> 2] = (c[q >> 2] | 0) + (c[B >> 2] | 0);
	                                c[p >> 2] = (c[p >> 2] | 0) + (c[B >> 2] | 0)
	                            }
	                            c[r >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                            if (((c[p >> 2] | 0) - (c[q >> 2] | 0) | 0) <= 1e7) {
	                                H = 35;
	                                continue
	                            }
	                            if (!(c[(c[k >> 2] | 0) + 360 >> 2] & 524288)) {
	                                H = 53;
	                                break
	                            } else H = 35
	                        }
	                        if ((H | 0) == 48) {
	                            c[j >> 2] = 0;
	                            G = c[j >> 2] | 0;
	                            i = h;
	                            return G | 0
	                        } else if ((H | 0) == 53) {
	                            xg(c[k >> 2] | 0, 40, 71720);
	                            c[j >> 2] = 0;
	                            G = c[j >> 2] | 0;
	                            i = h;
	                            return G | 0
	                        } else if ((H | 0) == 54) {
	                            c[s >> 2] = c[p >> 2];
	                            while (1) {
	                                if ((d[(c[s >> 2] | 0) + -1 >> 0] | 0 | 0) != 32)break;
	                                if ((c[s >> 2] | 0) >>> 0 <= (c[q >> 2] | 0) >>> 0)break;
	                                c[s >> 2] = (c[s >> 2] | 0) + -1
	                            }
	                            while (1) {
	                                if ((c[p >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0 ? (d[c[p >> 2] >> 0] | 0 | 0) != (d[o >> 0] | 0 | 0) : 0)if (((d[c[p >> 2] >> 0] | 0 | 0) != 32 ? (d[c[p >> 2] >> 0] | 0 | 0) != 9 : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) != 10 : 0)I = (d[c[p >> 2] >> 0] | 0 | 0) == 13; else I = 1; else I = 0;
	                                J = c[p >> 2] | 0;
	                                if (!I) {
	                                    H = 79;
	                                    break
	                                }
	                                if ((d[J >> 0] | 0 | 0) == 10) {
	                                    c[u >> 2] = (c[u >> 2] | 0) + 1;
	                                    c[v >> 2] = 1
	                                } else c[v >> 2] = (c[v >> 2] | 0) + 1;
	                                c[p >> 2] = (c[p >> 2] | 0) + 1;
	                                if ((c[p >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)continue;
	                                c[C >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                                if ((c[(c[k >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[k >> 2] | 0);
	                                if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    H = 73;
	                                    break
	                                }
	                                if ((c[C >> 2] | 0) != (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                                    c[D >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) - (c[C >> 2] | 0);
	                                    c[q >> 2] = (c[q >> 2] | 0) + (c[D >> 2] | 0);
	                                    c[p >> 2] = (c[p >> 2] | 0) + (c[D >> 2] | 0);
	                                    c[s >> 2] = (c[s >> 2] | 0) + (c[D >> 2] | 0)
	                                }
	                                c[r >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                                if (((c[p >> 2] | 0) - (c[q >> 2] | 0) | 0) <= 1e7)continue;
	                                if (!(c[(c[k >> 2] | 0) + 360 >> 2] & 524288)) {
	                                    H = 78;
	                                    break
	                                }
	                            }
	                            if ((H | 0) == 73) {
	                                c[j >> 2] = 0;
	                                G = c[j >> 2] | 0;
	                                i = h;
	                                return G | 0
	                            } else if ((H | 0) == 78) {
	                                xg(c[k >> 2] | 0, 40, 71720);
	                                c[j >> 2] = 0;
	                                G = c[j >> 2] | 0;
	                                i = h;
	                                return G | 0
	                            } else if ((H | 0) == 79) {
	                                if ((J - (c[q >> 2] | 0) | 0) > 1e7 ? (c[(c[k >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                                    xg(c[k >> 2] | 0, 40, 71720);
	                                    c[j >> 2] = 0;
	                                    G = c[j >> 2] | 0;
	                                    i = h;
	                                    return G | 0
	                                }
	                                if ((d[c[p >> 2] >> 0] | 0 | 0) != (d[o >> 0] | 0 | 0)) {
	                                    H = 113;
	                                    break
	                                } else break
	                            }
	                        }
	                    }
	                } else {
	                    while (1) {
	                        if (((((c[p >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0 ? (d[c[p >> 2] >> 0] | 0 | 0) != (d[o >> 0] | 0 | 0) : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) >= 32 : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 127 : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) != 38 : 0)K = (d[c[p >> 2] >> 0] | 0 | 0) != 60; else K = 0;
	                        L = c[p >> 2] | 0;
	                        if (!K) {
	                            H = 101;
	                            break
	                        }
	                        c[p >> 2] = L + 1;
	                        c[v >> 2] = (c[v >> 2] | 0) + 1;
	                        if ((c[p >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)continue;
	                        c[E >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                        if ((c[(c[k >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[k >> 2] | 0);
	                        if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            H = 95;
	                            break
	                        }
	                        if ((c[E >> 2] | 0) != (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)) {
	                            c[F >> 2] = (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) - (c[E >> 2] | 0);
	                            c[q >> 2] = (c[q >> 2] | 0) + (c[F >> 2] | 0);
	                            c[p >> 2] = (c[p >> 2] | 0) + (c[F >> 2] | 0)
	                        }
	                        c[r >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                        if (((c[p >> 2] | 0) - (c[q >> 2] | 0) | 0) <= 1e7)continue;
	                        if (!(c[(c[k >> 2] | 0) + 360 >> 2] & 524288)) {
	                            H = 100;
	                            break
	                        }
	                    }
	                    if ((H | 0) == 95) {
	                        c[j >> 2] = 0;
	                        G = c[j >> 2] | 0;
	                        i = h;
	                        return G | 0
	                    } else if ((H | 0) == 100) {
	                        xg(c[k >> 2] | 0, 40, 71720);
	                        c[j >> 2] = 0;
	                        G = c[j >> 2] | 0;
	                        i = h;
	                        return G | 0
	                    } else if ((H | 0) == 101) {
	                        c[s >> 2] = L;
	                        if (((c[p >> 2] | 0) - (c[q >> 2] | 0) | 0) > 1e7 ? (c[(c[k >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            xg(c[k >> 2] | 0, 40, 71720);
	                            c[j >> 2] = 0;
	                            G = c[j >> 2] | 0;
	                            i = h;
	                            return G | 0
	                        }
	                        if ((d[c[p >> 2] >> 0] | 0 | 0) != (d[o >> 0] | 0 | 0)) {
	                            H = 113;
	                            break
	                        } else break
	                    }
	                } while (0);
	                if ((H | 0) == 113) {
	                    if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 1;
	                    c[j >> 2] = lh(c[k >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                    G = c[j >> 2] | 0;
	                    i = h;
	                    return G | 0
	                }
	                c[p >> 2] = (c[p >> 2] | 0) + 1;
	                c[v >> 2] = (c[v >> 2] | 0) + 1;
	                if (c[l >> 2] | 0) {
	                    c[c[l >> 2] >> 2] = (c[s >> 2] | 0) - (c[q >> 2] | 0);
	                    c[t >> 2] = c[q >> 2]
	                } else {
	                    if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 1;
	                    c[t >> 2] = ly(c[q >> 2] | 0, (c[s >> 2] | 0) - (c[q >> 2] | 0) | 0) | 0
	                }
	                c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[p >> 2];
	                c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] = c[u >> 2];
	                c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = c[v >> 2];
	                if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 0;
	                c[j >> 2] = c[t >> 2];
	                G = c[j >> 2] | 0;
	                i = h;
	                return G | 0
	            }

	            function Fg(a) {
	                a = a | 0;
	                var b = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                le(c[(c[e >> 2] | 0) + 36 >> 2] | 0);
	                if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                    i = b;
	                    return
	                }
	                if ((ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                    i = b;
	                    return
	                }
	                Ve(c[e >> 2] | 0) | 0;
	                i = b;
	                return
	            }

	            function Gg(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 4 | 0;
	                p = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if ((c[(c[c[j >> 2] >> 2] | 0) + 72 >> 2] | 0) == (c[(c[c[j >> 2] >> 2] | 0) + 68 >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                if (((c[(c[j >> 2] | 0) + 232 >> 2] | 0) != 0 ? (c[c[(c[j >> 2] | 0) + 232 >> 2] >> 2] | 0) != 1 : 0) ? (c[c[(c[j >> 2] | 0) + 232 >> 2] >> 2] | 0) != -2 : 0) {
	                    a:do if (!(c[m >> 2] | 0)) {
	                        c[n >> 2] = 0;
	                        b:while (1) {
	                            if ((c[n >> 2] | 0) >= (c[l >> 2] | 0))break a;
	                            do if ((d[(c[k >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[(c[k >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[k >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[(c[k >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0 | 0) != 13)break b
	                            } while (0);
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = g;
	                        return q | 0
	                    } while (0);
	                    if (!(c[(c[j >> 2] | 0) + 52 >> 2] | 0)) {
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = g;
	                        return q | 0
	                    }
	                    if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                        c[o >> 2] = Qm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (!(c[o >> 2] | 0)) {
	                            c[h >> 2] = 1;
	                            q = c[h >> 2] | 0;
	                            i = g;
	                            return q | 0
	                        }
	                        if ((c[o >> 2] | 0) == 1) {
	                            c[h >> 2] = 0;
	                            q = c[h >> 2] | 0;
	                            i = g;
	                            return q | 0
	                        }
	                    }
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60 ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 : 0) {
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = g;
	                        return q | 0
	                    }
	                    if (((c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 12 >> 2] | 0) == 0 ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = g;
	                        return q | 0
	                    }
	                    c[p >> 2] = Bi(c[(c[j >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        if ((c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                            c[h >> 2] = 0;
	                            q = c[h >> 2] | 0;
	                            i = g;
	                            return q | 0
	                        }
	                    } else {
	                        if (hj(c[p >> 2] | 0) | 0) {
	                            c[h >> 2] = 0;
	                            q = c[h >> 2] | 0;
	                            i = g;
	                            return q | 0
	                        }
	                        if ((c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 12 >> 2] | 0) != 0 ? (hj(c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                            c[h >> 2] = 0;
	                            q = c[h >> 2] | 0;
	                            i = g;
	                            return q | 0
	                        }
	                    }
	                    c[h >> 2] = 1;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                c[h >> 2] = 0;
	                q = c[h >> 2] | 0;
	                i = g;
	                return q | 0
	            }

	            function Hg(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 336 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 24 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                c[k >> 2] = 0;
	                c[n >> 2] = 0;
	                if (((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                c[l >> 2] = ne(c[g >> 2] | 0, m) | 0;
	                while (1) {
	                    if (!((c[l >> 2] | 0) != 60 & (c[l >> 2] | 0) != 38)) {
	                        o = 49;
	                        break
	                    }
	                    e = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 256)if (9 <= (e | 0) & (c[l >> 2] | 0) <= 10 | (c[l >> 2] | 0) == 13)p = 1; else p = 32 <= (c[l >> 2] | 0); else if (!(256 <= (e | 0) & (c[l >> 2] | 0) <= 55295) ? !(57344 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 65533) : 0)if (65536 <= (c[l >> 2] | 0))p = (c[l >> 2] | 0) <= 1114111; else p = 0; else p = 1;
	                    if (!(p & 1)) {
	                        o = 49;
	                        break
	                    }
	                    if (((c[l >> 2] | 0) == 93 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 93 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 62 : 0) {
	                        if (c[h >> 2] | 0) {
	                            o = 49;
	                            break
	                        }
	                        og(c[g >> 2] | 0, 62, 0)
	                    }
	                    if ((c[m >> 2] | 0) == 1) {
	                        e = c[l >> 2] & 255;
	                        b = c[k >> 2] | 0;
	                        c[k >> 2] = b + 1;
	                        a[j + b >> 0] = e
	                    } else {
	                        e = pe(j + (c[k >> 2] | 0) | 0, c[l >> 2] | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + e
	                    }
	                    if ((c[k >> 2] | 0) >= 300) {
	                        a[j + (c[k >> 2] | 0) >> 0] = 0;
	                        do if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                            e = (Gg(c[g >> 2] | 0, j, c[k >> 2] | 0, 0) | 0) != 0;
	                            b = c[c[g >> 2] >> 2] | 0;
	                            if (e) {
	                                if (!(c[b + 72 >> 2] | 0))break;
	                                Db[c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, j, c[k >> 2] | 0);
	                                break
	                            }
	                            if (c[b + 68 >> 2] | 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, j, c[k >> 2] | 0);
	                            if ((c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0) != (c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] | 0) ? (c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] | 0) == -1 : 0)c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] = -2
	                        } while (0);
	                        c[k >> 2] = 0;
	                        if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) != 7) {
	                            o = 71;
	                            break
	                        }
	                    }
	                    c[n >> 2] = (c[n >> 2] | 0) + 1;
	                    if ((c[n >> 2] | 0) > 50) {
	                        if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                        c[n >> 2] = 0;
	                        if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            o = 71;
	                            break
	                        }
	                    }
	                    b = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        e = b + 28 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        e = b + 32 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + (c[m >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[g >> 2] | 0);
	                    c[l >> 2] = ne(c[g >> 2] | 0, m) | 0
	                }
	                if ((o | 0) == 49) {
	                    do if (((c[k >> 2] | 0) != 0 ? (a[j + (c[k >> 2] | 0) >> 0] = 0, (c[c[g >> 2] >> 2] | 0) != 0) : 0) ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                        n = (Gg(c[g >> 2] | 0, j, c[k >> 2] | 0, 0) | 0) != 0;
	                        h = c[c[g >> 2] >> 2] | 0;
	                        if (n) {
	                            if (!(c[h + 72 >> 2] | 0))break;
	                            Db[c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, j, c[k >> 2] | 0);
	                            break
	                        }
	                        if (c[h + 68 >> 2] | 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, j, c[k >> 2] | 0);
	                        if ((c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0) != (c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] | 0) ? (c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] | 0) == -1 : 0)c[c[(c[g >> 2] | 0) + 232 >> 2] >> 2] = -2
	                    } while (0);
	                    if (!(c[l >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    k = c[l >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 256) {
	                        if (9 <= (k | 0) & (c[l >> 2] | 0) <= 10 | (c[l >> 2] | 0) == 13 | 32 <= (c[l >> 2] | 0)) {
	                            i = f;
	                            return
	                        }
	                    } else {
	                        if (256 <= (k | 0) & (c[l >> 2] | 0) <= 55295) {
	                            i = f;
	                            return
	                        }
	                        if (57344 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 65533) {
	                            i = f;
	                            return
	                        }
	                        if (65536 <= (c[l >> 2] | 0) & (c[l >> 2] | 0) <= 1114111) {
	                            i = f;
	                            return
	                        }
	                    }
	                    ng(c[g >> 2] | 0, 9, 72816, c[l >> 2] | 0);
	                    l = c[(c[g >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        k = l + 28 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        k = l + 32 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    k = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[k >> 2] = (c[k >> 2] | 0) + (c[m >> 2] | 0);
	                    if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 37) {
	                        i = f;
	                        return
	                    }
	                    We(c[g >> 2] | 0);
	                    i = f;
	                    return
	                } else if ((o | 0) == 71) {
	                    i = f;
	                    return
	                }
	            }

	            function Ig(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                h = i;
	                i = i + 64 | 0;
	                j = h + 52 | 0;
	                k = h + 48 | 0;
	                l = h + 44 | 0;
	                m = h + 40 | 0;
	                n = h + 36 | 0;
	                o = h + 32 | 0;
	                p = h + 28 | 0;
	                q = h + 24 | 0;
	                r = h + 20 | 0;
	                s = h + 16 | 0;
	                t = h + 12 | 0;
	                u = h + 8 | 0;
	                v = h + 4 | 0;
	                w = h;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = g;
	                c[t >> 2] = 0;
	                c[u >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2];
	                if ((c[k >> 2] | 0) == 0 ? (c[l >> 2] = 0, c[m >> 2] = 100, c[k >> 2] = Cb[c[135752 >> 2] & 511](c[m >> 2] | 0) | 0, (c[k >> 2] | 0) == 0) : 0) {
	                    ie(c[j >> 2] | 0, 0);
	                    i = h;
	                    return
	                }
	                if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                c[n >> 2] = ne(c[j >> 2] | 0, o) | 0;
	                if (c[n >> 2] | 0) {
	                    g = c[n >> 2] | 0;
	                    if ((c[n >> 2] | 0) < 256) {
	                        if (!(9 <= (g | 0) & (c[n >> 2] | 0) <= 10 | (c[n >> 2] | 0) == 13 | 32 <= (c[n >> 2] | 0)))x = 13
	                    } else if ((!(256 <= (g | 0) & (c[n >> 2] | 0) <= 55295) ? !(57344 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[n >> 2] | 0) & (c[n >> 2] | 0) <= 1114111) : 0)x = 13;
	                    if ((x | 0) == 13) {
	                        ng(c[j >> 2] | 0, 9, 72648, c[n >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        i = h;
	                        return
	                    }
	                    g = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        f = g + 28 | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        f = g + 32 | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    f = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + (c[o >> 2] | 0);
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[j >> 2] | 0);
	                    c[p >> 2] = ne(c[j >> 2] | 0, q) | 0;
	                    if (c[p >> 2] | 0) {
	                        f = c[p >> 2] | 0;
	                        if ((c[p >> 2] | 0) < 256) {
	                            if (!(9 <= (f | 0) & (c[p >> 2] | 0) <= 10 | (c[p >> 2] | 0) == 13 | 32 <= (c[p >> 2] | 0)))x = 25
	                        } else if ((!(256 <= (f | 0) & (c[p >> 2] | 0) <= 55295) ? !(57344 <= (c[p >> 2] | 0) & (c[p >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[p >> 2] | 0) & (c[p >> 2] | 0) <= 1114111) : 0)x = 25;
	                        if ((x | 0) == 25) {
	                            ng(c[j >> 2] | 0, 9, 72648, c[n >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                            i = h;
	                            return
	                        }
	                        f = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            g = f + 28 | 0;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1;
	                            c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            g = f + 32 | 0;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        g = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[q >> 2] | 0);
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[j >> 2] | 0);
	                        c[r >> 2] = ne(c[j >> 2] | 0, s) | 0;
	                        if (c[r >> 2] | 0) {
	                            while (1) {
	                                g = c[r >> 2] | 0;
	                                if ((c[r >> 2] | 0) < 256) {
	                                    if (!(9 <= (g | 0) & (c[r >> 2] | 0) <= 10 | (c[r >> 2] | 0) == 13 | 32 <= (c[r >> 2] | 0))) {
	                                        x = 70;
	                                        break
	                                    }
	                                } else if ((!(256 <= (g | 0) & (c[r >> 2] | 0) <= 55295) ? !(57344 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 1114111) : 0) {
	                                    x = 70;
	                                    break
	                                }
	                                if (!((c[r >> 2] | 0) != 62 | (c[p >> 2] | 0) != 45 | (c[n >> 2] | 0) != 45)) {
	                                    x = 70;
	                                    break
	                                }
	                                if ((c[p >> 2] | 0) == 45 & (c[n >> 2] | 0) == 45)og(c[j >> 2] | 0, 80, 0);
	                                if ((c[l >> 2] | 0) >>> 0 > 1e7 ? (c[(c[j >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                                    x = 42;
	                                    break
	                                }
	                                if (((c[l >> 2] | 0) + 5 | 0) >>> 0 >= (c[m >> 2] | 0) >>> 0) {
	                                    c[w >> 2] = c[m >> 2] << 1;
	                                    c[v >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[w >> 2] | 0) | 0;
	                                    if (!(c[v >> 2] | 0)) {
	                                        x = 45;
	                                        break
	                                    }
	                                    c[k >> 2] = c[v >> 2];
	                                    c[m >> 2] = c[w >> 2]
	                                }
	                                if ((c[o >> 2] | 0) == 1) {
	                                    g = c[n >> 2] & 255;
	                                    f = c[l >> 2] | 0;
	                                    c[l >> 2] = f + 1;
	                                    a[(c[k >> 2] | 0) + f >> 0] = g
	                                } else {
	                                    g = pe((c[k >> 2] | 0) + (c[l >> 2] | 0) | 0, c[n >> 2] | 0) | 0;
	                                    c[l >> 2] = (c[l >> 2] | 0) + g
	                                }
	                                c[n >> 2] = c[p >> 2];
	                                c[o >> 2] = c[q >> 2];
	                                c[p >> 2] = c[r >> 2];
	                                c[q >> 2] = c[s >> 2];
	                                c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                if ((c[t >> 2] | 0) >>> 0 > 50) {
	                                    do if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0)) {
	                                        if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                                        vg(c[j >> 2] | 0)
	                                    } while (0);
	                                    c[t >> 2] = 0;
	                                    if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                        x = 55;
	                                        break
	                                    }
	                                }
	                                g = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                                    f = g + 28 | 0;
	                                    c[f >> 2] = (c[f >> 2] | 0) + 1;
	                                    c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                                } else {
	                                    f = g + 32 | 0;
	                                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                                }
	                                f = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + (c[s >> 2] | 0);
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[j >> 2] | 0);
	                                c[r >> 2] = ne(c[j >> 2] | 0, s) | 0;
	                                if (c[r >> 2] | 0)continue;
	                                do if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0)) {
	                                    if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) <= 500)break;
	                                    if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 500)break;
	                                    Fg(c[j >> 2] | 0)
	                                } while (0);
	                                do if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0)) {
	                                    if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                                    vg(c[j >> 2] | 0)
	                                } while (0);
	                                c[r >> 2] = ne(c[j >> 2] | 0, s) | 0
	                            }
	                            if ((x | 0) == 42) {
	                                pg(c[j >> 2] | 0, 45, 66168, 0);
	                                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                i = h;
	                                return
	                            } else if ((x | 0) == 45) {
	                                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                ie(c[j >> 2] | 0, 0);
	                                i = h;
	                                return
	                            } else if ((x | 0) == 55) {
	                                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                i = h;
	                                return
	                            } else if ((x | 0) == 70) {
	                                a[(c[k >> 2] | 0) + (c[l >> 2] | 0) >> 0] = 0;
	                                do if (c[r >> 2] | 0) {
	                                    l = c[r >> 2] | 0;
	                                    if ((c[r >> 2] | 0) < 256) {
	                                        if (!(9 <= (l | 0) & (c[r >> 2] | 0) <= 10 | (c[r >> 2] | 0) == 13 | 32 <= (c[r >> 2] | 0)))x = 77
	                                    } else if ((!(256 <= (l | 0) & (c[r >> 2] | 0) <= 55295) ? !(57344 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 1114111) : 0)x = 77;
	                                    if ((x | 0) == 77) {
	                                        ng(c[j >> 2] | 0, 9, 72648, c[r >> 2] | 0);
	                                        break
	                                    }
	                                    if ((c[u >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2] | 0))xg(c[j >> 2] | 0, 90, 72736);
	                                    me(c[j >> 2] | 0);
	                                    if (((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Ab[c[(c[c[j >> 2] >> 2] | 0) + 80 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0)
	                                } else pg(c[j >> 2] | 0, 45, 72696, c[k >> 2] | 0); while (0);
	                                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                i = h;
	                                return
	                            }
	                        }
	                    }
	                }
	                pg(c[j >> 2] | 0, 45, 72792, 0);
	                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                i = h;
	                return
	            }

	            function Jg(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = h;
	                    return
	                }
	                if (c[k >> 2] | 0)c[(c[k >> 2] | 0) + 84 >> 2] = c[l >> 2];
	                g = c[k >> 2] | 0;
	                f = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                e = c[o >> 2] | 0;
	                d = c[p >> 2] | 0;
	                b = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                o = c[p >> 2] | 0;
	                c[j >> 2] = c[n >> 2];
	                c[j + 4 >> 2] = m;
	                c[j + 8 >> 2] = o;
	                Xd(0, 0, 0, g, 0, 3, f, 2, 0, 0, l, e, d, 0, 0, b, j);
	                if (!(c[k >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                c[(c[k >> 2] | 0) + 356 >> 2] = 0;
	                i = h;
	                return
	            }

	            function Kg(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                m = f + 20 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                c[j >> 2] = 0;
	                c[k >> 2] = c[h >> 2];
	                while (1) {
	                    do if ((d[c[k >> 2] >> 0] | 0 | 0) == 32)n = 1; else {
	                        if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            n = 1;
	                            break
	                        }
	                        n = (d[c[k >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    o = c[k >> 2] | 0;
	                    if (!n)break;
	                    c[k >> 2] = o + 1
	                }
	                do if (!(sy(o, 72576, 7) | 0)) {
	                    c[k >> 2] = (c[k >> 2] | 0) + 7;
	                    while (1) {
	                        do if ((d[c[k >> 2] >> 0] | 0 | 0) == 32)p = 1; else {
	                            if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                p = 1;
	                                break
	                            }
	                            p = (d[c[k >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        q = c[k >> 2] | 0;
	                        if (!p)break;
	                        c[k >> 2] = q + 1
	                    }
	                    if ((d[q >> 0] | 0 | 0) != 61) {
	                        i = f;
	                        return
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[k >> 2] >> 0] | 0 | 0) == 32)r = 1; else {
	                            if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                r = 1;
	                                break
	                            }
	                            r = (d[c[k >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        s = c[k >> 2] | 0;
	                        if (!r)break;
	                        c[k >> 2] = s + 1
	                    }
	                    a[m >> 0] = a[s >> 0] | 0;
	                    if ((d[m >> 0] | 0 | 0) != 39 ? (d[m >> 0] | 0 | 0) != 34 : 0)break;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    c[l >> 2] = c[k >> 2];
	                    while (1) {
	                        if (d[c[k >> 2] >> 0] | 0)t = (d[c[k >> 2] >> 0] | 0 | 0) != (d[m >> 0] | 0 | 0); else t = 0;
	                        u = c[k >> 2] | 0;
	                        if (!t)break;
	                        c[k >> 2] = u + 1
	                    }
	                    if (d[u >> 0] | 0) {
	                        c[j >> 2] = ly(c[l >> 2] | 0, (c[k >> 2] | 0) - (c[l >> 2] | 0) | 0) | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[k >> 2] >> 0] | 0 | 0) == 32)v = 1; else {
	                                if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    v = 1;
	                                    break
	                                }
	                                v = (d[c[k >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            w = c[k >> 2] | 0;
	                            if (!v)break;
	                            c[k >> 2] = w + 1
	                        }
	                        if (!(d[w >> 0] | 0)) {
	                            if (!(c[j >> 2] | 0)) {
	                                i = f;
	                                return
	                            }
	                            n = Iw(c[(c[g >> 2] | 0) + 284 >> 2] | 0, c[j >> 2] | 0) | 0;
	                            c[(c[g >> 2] | 0) + 284 >> 2] = n;
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            i = f;
	                            return
	                        }
	                    }
	                } while (0);
	                rg(c[g >> 2] | 0, 93, 72584, c[h >> 2] | 0, 0);
	                if (!(c[j >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                i = f;
	                return
	            }

	            function Lg(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = f;
	                    return
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                e = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                d = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, 0, 1, h, 2, 0, 0, j, 0, 0, 0, 0, d, g);
	                i = f;
	                return
	            }

	            function Mg(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 8 | 0;
	                h = f + 4 | 0;
	                j = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    k = c[g >> 2] | 0;
	                    i = f;
	                    return k | 0
	                }
	                while (1) {
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) != 32)break;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                while (1) {
	                    if (!(d[c[h >> 2] >> 0] | 0))break;
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        e = c[h >> 2] | 0;
	                        c[h >> 2] = e + 1;
	                        b = a[e >> 0] | 0;
	                        e = c[j >> 2] | 0;
	                        c[j >> 2] = e + 1;
	                        a[e >> 0] = b;
	                        continue
	                    }
	                    while (1) {
	                        l = c[h >> 2] | 0;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 32)break;
	                        c[h >> 2] = l + 1
	                    }
	                    if (!(d[l >> 0] | 0))continue;
	                    b = c[j >> 2] | 0;
	                    c[j >> 2] = b + 1;
	                    a[b >> 0] = 32
	                }
	                a[c[j >> 2] >> 0] = 0;
	                if ((c[j >> 2] | 0) == (c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    k = c[g >> 2] | 0;
	                    i = f;
	                    return k | 0
	                } else {
	                    c[g >> 2] = c[j >> 2];
	                    k = c[g >> 2] | 0;
	                    i = f;
	                    return k | 0
	                }
	                return 0
	            }

	            function Ng(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if ((c[(c[g >> 2] | 0) + 352 >> 2] | 0) != 0 ? (Tj(c[(c[g >> 2] | 0) + 352 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                    i = f;
	                    return
	                }
	                if (!((c[(c[g >> 2] | 0) + 348 >> 2] | 0) == 0 ? (e = Jj(10, c[(c[g >> 2] | 0) + 296 >> 2] | 0) | 0, c[(c[g >> 2] | 0) + 348 >> 2] = e, (c[(c[g >> 2] | 0) + 348 >> 2] | 0) == 0) : 0))q = 5;
	                do if ((q | 0) == 5) {
	                    c[n >> 2] = Dh(c[h >> 2] | 0, m) | 0;
	                    e = c[(c[g >> 2] | 0) + 296 >> 2] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[n >> 2] = AP(e, c[h >> 2] | 0, -1) | 0;
	                        c[o >> 2] = 0
	                    } else {
	                        c[n >> 2] = AP(e, c[n >> 2] | 0, -1) | 0;
	                        c[o >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, c[h >> 2] | 0, c[m >> 2] | 0) | 0
	                    }
	                    c[l >> 2] = Tj(c[(c[g >> 2] | 0) + 348 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        c[l >> 2] = Cb[c[135744 >> 2] & 511](108) | 0;
	                        if (!(c[l >> 2] | 0))break;
	                        c[c[l >> 2] >> 2] = 0;
	                        c[(c[l >> 2] | 0) + 4 >> 2] = 4;
	                        if ((Qj(c[(c[g >> 2] | 0) + 348 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0, 0) | 0) < 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            break
	                        }
	                    } else if ((c[c[l >> 2] >> 2] | 0) >= (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[p >> 2] = Hb[c[135760 >> 2] & 511](c[l >> 2] | 0, 28 + ((c[(c[l >> 2] | 0) + 4 >> 2] << 1) * 5 << 2) | 0) | 0;
	                        if (!(c[p >> 2] | 0))break;
	                        c[l >> 2] = c[p >> 2];
	                        e = (c[l >> 2] | 0) + 4 | 0;
	                        c[e >> 2] = c[e >> 2] << 1;
	                        if ((Qj(c[(c[g >> 2] | 0) + 348 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0, 0) | 0) < 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            break
	                        }
	                    }
	                    c[n >> 2] = Dh(c[j >> 2] | 0, m) | 0;
	                    e = c[(c[g >> 2] | 0) + 296 >> 2] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[n >> 2] = AP(e, c[j >> 2] | 0, -1) | 0;
	                        c[o >> 2] = 0
	                    } else {
	                        c[n >> 2] = AP(e, c[n >> 2] | 0, -1) | 0;
	                        c[o >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0) | 0
	                    }
	                    c[(c[l >> 2] | 0) + 8 + ((c[c[l >> 2] >> 2] | 0) * 5 << 2) >> 2] = c[n >> 2];
	                    c[(c[l >> 2] | 0) + 8 + (((c[c[l >> 2] >> 2] | 0) * 5 | 0) + 1 << 2) >> 2] = c[o >> 2];
	                    c[m >> 2] = xy(c[k >> 2] | 0) | 0;
	                    c[k >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[(c[l >> 2] | 0) + 8 + (((c[c[l >> 2] >> 2] | 0) * 5 | 0) + 2 << 2) >> 2] = c[k >> 2];
	                    c[(c[l >> 2] | 0) + 8 + (((c[c[l >> 2] >> 2] | 0) * 5 | 0) + 3 << 2) >> 2] = (c[k >> 2] | 0) + (c[m >> 2] | 0);
	                    e = (c[l >> 2] | 0) + 8 + (((c[c[l >> 2] >> 2] | 0) * 5 | 0) + 4 << 2) | 0;
	                    if (c[(c[g >> 2] | 0) + 96 >> 2] | 0)c[e >> 2] = 72560; else c[e >> 2] = 0;
	                    e = c[l >> 2] | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + 1;
	                    i = f;
	                    return
	                } while (0);
	                ie(c[g >> 2] | 0, 0);
	                i = f;
	                return
	            }

	            function Og(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if ((c[(c[g >> 2] | 0) + 352 >> 2] | 0) == 0 ? (e = Jj(10, c[(c[g >> 2] | 0) + 296 >> 2] | 0) | 0, c[(c[g >> 2] | 0) + 352 >> 2] = e, (c[(c[g >> 2] | 0) + 352 >> 2] | 0) == 0) : 0) {
	                    ie(c[g >> 2] | 0, 0);
	                    i = f;
	                    return
	                }
	                if (Tj(c[(c[g >> 2] | 0) + 352 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) {
	                    i = f;
	                    return
	                }
	                Nj(c[(c[g >> 2] | 0) + 352 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                i = f;
	                return
	            }

	            function Pg(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 44 | 0;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 48 | 0;
	                s = g + 8 | 0;
	                t = g + 4 | 0;
	                u = g;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                a[r >> 0] = 0;
	                if ((c[l >> 2] | 0) > 128) {
	                    if ((c[l >> 2] | 0) > 2048 ? 1 : (c[(c[j >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0)v = 4
	                } else if ((c[l >> 2] | 0) > 2048)v = 4;
	                if ((v | 0) == 4) {
	                    ng(c[j >> 2] | 0, 55, 72424, c[l >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                }
	                Ue(c[j >> 2] | 0) | 0;
	                if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                f = c[j >> 2] | 0;
	                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 40) {
	                    c[s >> 2] = c[(c[f + 36 >> 2] | 0) + 56 >> 2];
	                    me(c[j >> 2] | 0);
	                    Ue(c[j >> 2] | 0) | 0;
	                    e = Pg(c[j >> 2] | 0, c[s >> 2] | 0, (c[l >> 2] | 0) + 1 | 0) | 0;
	                    c[m >> 2] = e;
	                    c[n >> 2] = e;
	                    Ue(c[j >> 2] | 0) | 0;
	                    if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0)
	                } else {
	                    c[q >> 2] = Ze(f) | 0;
	                    f = c[j >> 2] | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        og(f, 54, 0);
	                        c[h >> 2] = 0;
	                        w = c[h >> 2] | 0;
	                        i = g;
	                        return w | 0
	                    }
	                    e = im(c[f + 8 >> 2] | 0, c[q >> 2] | 0, 2) | 0;
	                    c[m >> 2] = e;
	                    c[n >> 2] = e;
	                    e = c[j >> 2] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        ie(e, 0);
	                        c[h >> 2] = 0;
	                        w = c[h >> 2] | 0;
	                        i = g;
	                        return w | 0
	                    }
	                    if ((c[e + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                    do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 63) {
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 42) {
	                            c[(c[n >> 2] | 0) + 4 >> 2] = 3;
	                            me(c[j >> 2] | 0);
	                            break
	                        }
	                        e = (c[n >> 2] | 0) + 4 | 0;
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 43) {
	                            c[e >> 2] = 4;
	                            me(c[j >> 2] | 0);
	                            break
	                        } else {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                    } else {
	                        c[(c[n >> 2] | 0) + 4 >> 2] = 2;
	                        me(c[j >> 2] | 0)
	                    } while (0);
	                    if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0)
	                }
	                Ue(c[j >> 2] | 0) | 0;
	                if (((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[j >> 2] | 0);
	                a:while (1) {
	                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 41) {
	                        v = 117;
	                        break
	                    }
	                    if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        v = 117;
	                        break
	                    }
	                    do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 44) {
	                        if (d[r >> 0] | 0) {
	                            if ((d[r >> 0] | 0 | 0) != (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0)) {
	                                v = 39;
	                                break a
	                            }
	                        } else a[r >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                        me(c[j >> 2] | 0);
	                        c[p >> 2] = im(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 3) | 0;
	                        x = c[o >> 2] | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            v = 46;
	                            break a
	                        }
	                        if (!x) {
	                            c[(c[p >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                            if (c[m >> 2] | 0)c[(c[m >> 2] | 0) + 20 >> 2] = c[p >> 2];
	                            e = c[p >> 2] | 0;
	                            c[n >> 2] = e;
	                            c[m >> 2] = e;
	                            break
	                        }
	                        c[(c[n >> 2] | 0) + 16 >> 2] = c[p >> 2];
	                        if (c[p >> 2] | 0)c[(c[p >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                        c[(c[p >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                        if (c[o >> 2] | 0)c[(c[o >> 2] | 0) + 20 >> 2] = c[p >> 2];
	                        c[n >> 2] = c[p >> 2];
	                        c[o >> 2] = 0
	                    } else {
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 124) {
	                            v = 85;
	                            break a
	                        }
	                        if (d[r >> 0] | 0) {
	                            if ((d[r >> 0] | 0 | 0) != (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0)) {
	                                v = 63;
	                                break a
	                            }
	                        } else a[r >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                        me(c[j >> 2] | 0);
	                        c[p >> 2] = im(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 4) | 0;
	                        y = c[o >> 2] | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            v = 70;
	                            break a
	                        }
	                        if (!y) {
	                            c[(c[p >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                            if (c[m >> 2] | 0)c[(c[m >> 2] | 0) + 20 >> 2] = c[p >> 2];
	                            e = c[p >> 2] | 0;
	                            c[n >> 2] = e;
	                            c[m >> 2] = e;
	                            break
	                        }
	                        c[(c[n >> 2] | 0) + 16 >> 2] = c[p >> 2];
	                        if (c[p >> 2] | 0)c[(c[p >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                        c[(c[p >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                        if (c[o >> 2] | 0)c[(c[o >> 2] | 0) + 20 >> 2] = c[p >> 2];
	                        c[n >> 2] = c[p >> 2];
	                        c[o >> 2] = 0
	                    } while (0);
	                    if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                    Ue(c[j >> 2] | 0) | 0;
	                    if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                    e = c[j >> 2] | 0;
	                    do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 40) {
	                        c[q >> 2] = Ze(e) | 0;
	                        z = c[j >> 2] | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            v = 100;
	                            break a
	                        }
	                        c[o >> 2] = im(c[z + 8 >> 2] | 0, c[q >> 2] | 0, 2) | 0;
	                        if (!(c[o >> 2] | 0)) {
	                            v = 104;
	                            break a
	                        }
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 63) {
	                            c[(c[o >> 2] | 0) + 4 >> 2] = 2;
	                            me(c[j >> 2] | 0);
	                            break
	                        }
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 42) {
	                            c[(c[o >> 2] | 0) + 4 >> 2] = 3;
	                            me(c[j >> 2] | 0);
	                            break
	                        }
	                        f = (c[o >> 2] | 0) + 4 | 0;
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 43) {
	                            c[f >> 2] = 4;
	                            me(c[j >> 2] | 0);
	                            break
	                        } else {
	                            c[f >> 2] = 1;
	                            break
	                        }
	                    } else {
	                        c[t >> 2] = c[(c[e + 36 >> 2] | 0) + 56 >> 2];
	                        me(c[j >> 2] | 0);
	                        Ue(c[j >> 2] | 0) | 0;
	                        c[o >> 2] = Pg(c[j >> 2] | 0, c[t >> 2] | 0, (c[l >> 2] | 0) + 1 | 0) | 0;
	                        Ue(c[j >> 2] | 0) | 0
	                    } while (0);
	                    Ue(c[j >> 2] | 0) | 0;
	                    if (c[(c[j >> 2] | 0) + 292 >> 2] | 0)continue;
	                    if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)continue;
	                    vg(c[j >> 2] | 0)
	                }
	                if ((v | 0) == 39) {
	                    ng(c[j >> 2] | 0, 66, 72504, d[r >> 0] | 0);
	                    if ((c[o >> 2] | 0) != 0 ? (c[o >> 2] | 0) != (c[m >> 2] | 0) : 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0);
	                    if (c[m >> 2] | 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 46) {
	                    if ((x | 0) != 0 ? (c[o >> 2] | 0) != (c[m >> 2] | 0) : 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0);
	                    lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 63) {
	                    ng(c[j >> 2] | 0, 66, 72504, d[r >> 0] | 0);
	                    if ((c[o >> 2] | 0) != 0 ? (c[o >> 2] | 0) != (c[m >> 2] | 0) : 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0);
	                    if (c[m >> 2] | 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 70) {
	                    if ((y | 0) != 0 ? (c[o >> 2] | 0) != (c[m >> 2] | 0) : 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0);
	                    if (c[m >> 2] | 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 85) {
	                    og(c[j >> 2] | 0, 55, 0);
	                    if ((c[o >> 2] | 0) != 0 ? (c[o >> 2] | 0) != (c[m >> 2] | 0) : 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0);
	                    if (c[m >> 2] | 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 100) {
	                    og(z, 54, 0);
	                    if (c[m >> 2] | 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 104) {
	                    if (c[m >> 2] | 0)lm(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0);
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                } else if ((v | 0) == 117) {
	                    if ((c[n >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 16 >> 2] = c[o >> 2], (c[o >> 2] | 0) != 0) : 0)c[(c[o >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                    if ((c[(c[j >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2] | 0) != (c[k >> 2] | 0) : 0)qg(c[j >> 2] | 0, 90, 67976, 0, 0);
	                    me(c[j >> 2] | 0);
	                    do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 63) {
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 42) {
	                            b:do if (c[m >> 2] | 0) {
	                                c[(c[m >> 2] | 0) + 4 >> 2] = 3;
	                                c[n >> 2] = c[m >> 2];
	                                while (1) {
	                                    if (!(c[n >> 2] | 0))break b;
	                                    if ((c[c[n >> 2] >> 2] | 0) != 4)break b;
	                                    do if (c[(c[n >> 2] | 0) + 12 >> 2] | 0) {
	                                        if ((c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 3 : 0)break;
	                                        c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 1
	                                    } while (0);
	                                    do if (c[(c[n >> 2] | 0) + 16 >> 2] | 0) {
	                                        if ((c[(c[(c[n >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[n >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 3 : 0)break;
	                                        c[(c[(c[n >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] = 1
	                                    } while (0);
	                                    c[n >> 2] = c[(c[n >> 2] | 0) + 16 >> 2]
	                                }
	                            } while (0);
	                            me(c[j >> 2] | 0);
	                            break
	                        }
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 43) {
	                            if (c[m >> 2] | 0) {
	                                c[u >> 2] = 0;
	                                if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 3 : 0)c[(c[m >> 2] | 0) + 4 >> 2] = 4; else c[(c[m >> 2] | 0) + 4 >> 2] = 3;
	                                while (1) {
	                                    if (!(c[n >> 2] | 0))break;
	                                    if ((c[c[n >> 2] >> 2] | 0) != 4)break;
	                                    do if (c[(c[n >> 2] | 0) + 12 >> 2] | 0) {
	                                        if ((c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 3 : 0)break;
	                                        c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] = 1;
	                                        c[u >> 2] = 1
	                                    } while (0);
	                                    do if (c[(c[n >> 2] | 0) + 16 >> 2] | 0) {
	                                        if ((c[(c[(c[n >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[n >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 3 : 0)break;
	                                        c[(c[(c[n >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] = 1;
	                                        c[u >> 2] = 1
	                                    } while (0);
	                                    c[n >> 2] = c[(c[n >> 2] | 0) + 16 >> 2]
	                                }
	                                if (c[u >> 2] | 0)c[(c[m >> 2] | 0) + 4 >> 2] = 3
	                            }
	                            me(c[j >> 2] | 0)
	                        }
	                    } else {
	                        do if (c[m >> 2] | 0) {
	                            if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 4 ? (c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) {
	                                c[(c[m >> 2] | 0) + 4 >> 2] = 2;
	                                break
	                            }
	                            c[(c[m >> 2] | 0) + 4 >> 2] = 3
	                        } while (0);
	                        me(c[j >> 2] | 0)
	                    } while (0);
	                    c[h >> 2] = c[m >> 2];
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                }
	                return 0
	            }

	            function Qg(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 56 >> 2];
	                a = (c[f >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 3;
	                a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 3;
	                a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 3;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                Ue(c[f >> 2] | 0) | 0;
	                if (((((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 73 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 78 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 67 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 76 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 85 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) == 69 : 0) {
	                    a = (c[f >> 2] | 0) + 200 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 7;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 7;
	                    a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 7;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    Ue(c[f >> 2] | 0) | 0;
	                    a = c[f >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 91)og(a, 83, 0); else {
	                        if ((c[(c[a + 36 >> 2] | 0) + 56 >> 2] | 0) != (c[g >> 2] | 0))qg(c[f >> 2] | 0, 90, 72192, 0, 0);
	                        me(c[f >> 2] | 0)
	                    }
	                    if (c[33952] | 0) {
	                        if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                            a = c[33976] | 0;
	                            n = c[33980] | 0;
	                            o = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0;
	                            c[e >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                            c[e + 4 >> 2] = o;
	                            Db[a & 511](n, 65312, e)
	                        }
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 72264, e)
	                    }
	                    while (1) {
	                        if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))break;
	                        if (((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 93 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 93 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 62 : 0)break;
	                        if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                        c[h >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        c[j >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                        do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60) {
	                            if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                                p = 37;
	                                break
	                            }
	                            if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 91) {
	                                p = 37;
	                                break
	                            }
	                            Qg(c[f >> 2] | 0)
	                        } else p = 37; while (0);
	                        a:do if ((p | 0) == 37) {
	                            p = 0;
	                            do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13)break;
	                                n = c[f >> 2] | 0;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37) {
	                                    zf(n);
	                                    break a
	                                } else {
	                                    yf(n);
	                                    break a
	                                }
	                            } while (0);
	                            me(c[f >> 2] | 0)
	                        } while (0);
	                        while (1) {
	                            if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))q = (c[(c[f >> 2] | 0) + 40 >> 2] | 0) > 1; else q = 0;
	                            r = c[f >> 2] | 0;
	                            if (!q)break;
	                            Ve(r) | 0
	                        }
	                        if ((c[(c[r + 36 >> 2] | 0) + 16 >> 2] | 0) != (c[h >> 2] | 0))continue;
	                        if ((c[j >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0)) {
	                            p = 51;
	                            break
	                        }
	                    }
	                    if ((p | 0) == 51)og(c[f >> 2] | 0, 60, 0);
	                    if (c[33952] | 0) {
	                        if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                            j = c[33976] | 0;
	                            h = c[33980] | 0;
	                            r = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0;
	                            c[e >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                            c[e + 4 >> 2] = r;
	                            Db[j & 511](h, 65312, e)
	                        }
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 72304, e)
	                    }
	                } else p = 57;
	                do if ((p | 0) == 57) {
	                    if ((((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 73 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 71 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 78 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 79 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 82 : 0) ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 69 : 0) {
	                        c[m >> 2] = 0;
	                        h = (c[f >> 2] | 0) + 200 | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + 6;
	                        h = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + 6;
	                        h = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + 6;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                        Ue(c[f >> 2] | 0) | 0;
	                        h = c[f >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 91)og(h, 83, 0); else {
	                            if ((c[(c[h + 36 >> 2] | 0) + 56 >> 2] | 0) != (c[g >> 2] | 0))qg(c[f >> 2] | 0, 90, 72192, 0, 0);
	                            me(c[f >> 2] | 0)
	                        }
	                        if (c[33952] | 0) {
	                            if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                                h = c[33976] | 0;
	                                j = c[33980] | 0;
	                                r = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0;
	                                c[e >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                                c[e + 4 >> 2] = r;
	                                Db[h & 511](j, 65312, e)
	                            }
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 72344, e)
	                        }
	                        c[k >> 2] = c[(c[f >> 2] | 0) + 212 >> 2];
	                        c[l >> 2] = c[(c[f >> 2] | 0) + 172 >> 2];
	                        if (!(c[(c[f >> 2] | 0) + 288 >> 2] | 0))c[(c[f >> 2] | 0) + 212 >> 2] = 1;
	                        c[(c[f >> 2] | 0) + 172 >> 2] = 15;
	                        b:while (1) {
	                            if ((c[m >> 2] | 0) < 0)break;
	                            if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))break;
	                            if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                            do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60) {
	                                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33)break;
	                                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 91)break;
	                                c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                j = (c[f >> 2] | 0) + 200 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                                if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)continue b;
	                                if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)continue b;
	                                Ve(c[f >> 2] | 0) | 0;
	                                continue b
	                            } while (0);
	                            do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 93) {
	                                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 93)break;
	                                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 62)break;
	                                j = (c[m >> 2] | 0) + -1 | 0;
	                                c[m >> 2] = j;
	                                if ((j | 0) < 0)continue b;
	                                j = (c[f >> 2] | 0) + 200 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                j = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + 3;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                                if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)continue b;
	                                if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)continue b;
	                                Ve(c[f >> 2] | 0) | 0;
	                                continue b
	                            } while (0);
	                            me(c[f >> 2] | 0)
	                        }
	                        c[(c[f >> 2] | 0) + 212 >> 2] = c[k >> 2];
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[l >> 2];
	                        if (!(c[33952] | 0))break;
	                        if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                            j = c[33976] | 0;
	                            h = c[33980] | 0;
	                            r = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0;
	                            c[e >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                            c[e + 4 >> 2] = r;
	                            Db[j & 511](h, 65312, e)
	                        }
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 72384, e);
	                        break
	                    }
	                    og(c[f >> 2] | 0, 95, 0)
	                } while (0);
	                if ((((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[f >> 2] | 0);
	                e = c[f >> 2] | 0;
	                if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                    og(e, 59, 0);
	                    i = b;
	                    return
	                }
	                if ((c[(c[e + 36 >> 2] | 0) + 56 >> 2] | 0) != (c[g >> 2] | 0))qg(c[f >> 2] | 0, 90, 72192, 0, 0);
	                g = (c[f >> 2] | 0) + 200 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + 3;
	                g = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + 3;
	                g = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[g >> 2] = (c[g >> 2] | 0) + 3;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                if (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                    i = b;
	                    return
	                }
	                if ((ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0) {
	                    i = b;
	                    return
	                }
	                Ve(c[f >> 2] | 0) | 0;
	                i = b;
	                return
	            }

	            function Rg(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                do if ((c[c[d >> 2] >> 2] | 0) != 0 ? (c[(c[c[d >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497 : 0) {
	                    if ((c[(c[c[d >> 2] >> 2] | 0) + 116 >> 2] | 0) == 0 ? (c[(c[c[d >> 2] >> 2] | 0) + 120 >> 2] | 0) == 0 : 0)break;
	                    c[(c[d >> 2] | 0) + 324 >> 2] = 1
	                } while (0);
	                a = AP(c[(c[d >> 2] | 0) + 296 >> 2] | 0, 70032, 3) | 0;
	                c[(c[d >> 2] | 0) + 312 >> 2] = a;
	                a = AP(c[(c[d >> 2] | 0) + 296 >> 2] | 0, 70040, 5) | 0;
	                c[(c[d >> 2] | 0) + 316 >> 2] = a;
	                a = AP(c[(c[d >> 2] | 0) + 296 >> 2] | 0, 70048, 36) | 0;
	                c[(c[d >> 2] | 0) + 320 >> 2] = a;
	                if (((c[(c[d >> 2] | 0) + 312 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 316 >> 2] | 0) != 0 : 0) ? (c[(c[d >> 2] | 0) + 320 >> 2] | 0) != 0 : 0) {
	                    i = b;
	                    return
	                }
	                ie(c[d >> 2] | 0, 0);
	                i = b;
	                return
	            }

	            function Sg(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 56 | 0;
	                j = g + 52 | 0;
	                k = g + 48 | 0;
	                l = g + 44 | 0;
	                m = g + 40 | 0;
	                n = g + 36 | 0;
	                o = g + 32 | 0;
	                p = g + 28 | 0;
	                q = g + 24 | 0;
	                r = g + 20 | 0;
	                s = g + 16 | 0;
	                t = g + 12 | 0;
	                u = g + 8 | 0;
	                v = g + 4 | 0;
	                w = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[o >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                c[u >> 2] = 0;
	                if (!((c[(c[j >> 2] | 0) + 248 >> 2] | 0) > 40 ? (c[(c[j >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0))x = 3;
	                if ((x | 0) == 3 ? (c[(c[j >> 2] | 0) + 248 >> 2] | 0) <= 1024 : 0) {
	                    if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[h >> 2] = 1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    c[t >> 2] = xy(c[k >> 2] | 0) | 0;
	                    c[n >> 2] = Zf(c[k >> 2] | 0, c[t >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[h >> 2] = 27;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    if (c[l >> 2] | 0)c[(c[n >> 2] | 0) + 4 >> 2] = c[l >> 2]; else c[(c[n >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                    if (c[(c[n >> 2] | 0) + 296 >> 2] | 0)zP(c[(c[n >> 2] | 0) + 296 >> 2] | 0);
	                    c[(c[n >> 2] | 0) + 296 >> 2] = c[(c[j >> 2] | 0) + 296 >> 2];
	                    l = AP(c[(c[n >> 2] | 0) + 296 >> 2] | 0, 70032, 3) | 0;
	                    c[(c[n >> 2] | 0) + 312 >> 2] = l;
	                    l = AP(c[(c[n >> 2] | 0) + 296 >> 2] | 0, 70040, 5) | 0;
	                    c[(c[n >> 2] | 0) + 316 >> 2] = l;
	                    l = AP(c[(c[n >> 2] | 0) + 296 >> 2] | 0, 70048, 36) | 0;
	                    c[(c[n >> 2] | 0) + 320 >> 2] = l;
	                    c[v >> 2] = 0;
	                    while (1) {
	                        z = c[n >> 2] | 0;
	                        if ((c[v >> 2] | 0) >= (c[(c[j >> 2] | 0) + 328 >> 2] | 0))break;
	                        ih(z, c[(c[(c[j >> 2] | 0) + 336 >> 2] | 0) + (c[v >> 2] << 2) >> 2] | 0, c[(c[(c[j >> 2] | 0) + 336 >> 2] | 0) + ((c[v >> 2] | 0) + 1 << 2) >> 2] | 0) | 0;
	                        c[v >> 2] = (c[v >> 2] | 0) + 2
	                    }
	                    c[q >> 2] = c[z >> 2];
	                    c[c[n >> 2] >> 2] = c[c[j >> 2] >> 2];
	                    Rg(c[n >> 2] | 0);
	                    c[(c[n >> 2] | 0) + 16 >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                    c[(c[n >> 2] | 0) + 360 >> 2] = c[(c[j >> 2] | 0) + 360 >> 2];
	                    c[(c[n >> 2] | 0) + 272 >> 2] = c[(c[j >> 2] | 0) + 272 >> 2];
	                    do if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[o >> 2] = Sh(68488) | 0;
	                        if (c[o >> 2] | 0) {
	                            c[(c[o >> 2] | 0) + 92 >> 2] = 64;
	                            c[(c[o >> 2] | 0) + 80 >> 2] = c[(c[n >> 2] | 0) + 296 >> 2];
	                            yP(c[(c[o >> 2] | 0) + 80 >> 2] | 0) | 0;
	                            c[(c[n >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                            break
	                        }
	                        c[c[n >> 2] >> 2] = c[q >> 2];
	                        c[(c[n >> 2] | 0) + 296 >> 2] = 0;
	                        Ae(c[n >> 2] | 0);
	                        c[h >> 2] = 1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    } else {
	                        c[(c[n >> 2] | 0) + 8 >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                        c[r >> 2] = c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2];
	                        c[s >> 2] = c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2]
	                    } while (0);
	                    c[p >> 2] = ji(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 0, 69968, 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        c[c[n >> 2] >> 2] = c[q >> 2];
	                        c[(c[n >> 2] | 0) + 296 >> 2] = 0;
	                        Ae(c[n >> 2] | 0);
	                        if (c[o >> 2] | 0)Th(c[o >> 2] | 0);
	                        c[h >> 2] = 1;
	                        y = c[h >> 2] | 0;
	                        i = g;
	                        return y | 0
	                    }
	                    c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] = 0;
	                    zi(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[p >> 2] | 0) | 0;
	                    Qe(c[n >> 2] | 0, c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    c[(c[n >> 2] | 0) + 172 >> 2] = 7;
	                    c[(c[n >> 2] | 0) + 248 >> 2] = (c[(c[j >> 2] | 0) + 248 >> 2] | 0) + 1;
	                    c[(c[n >> 2] | 0) + 104 >> 2] = 0;
	                    c[(c[n >> 2] | 0) + 276 >> 2] = c[(c[j >> 2] | 0) + 276 >> 2];
	                    if (!((c[(c[j >> 2] | 0) + 104 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 0 : 0)) {
	                        p = (c[n >> 2] | 0) + 276 | 0;
	                        c[p >> 2] = c[p >> 2] | 8
	                    }
	                    c[(c[n >> 2] | 0) + 364 >> 2] = c[(c[j >> 2] | 0) + 364 >> 2];
	                    c[(c[n >> 2] | 0) + 348 >> 2] = c[(c[j >> 2] | 0) + 348 >> 2];
	                    c[(c[n >> 2] | 0) + 352 >> 2] = c[(c[j >> 2] | 0) + 352 >> 2];
	                    Jf(c[n >> 2] | 0);
	                    if ((d[c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0)og(c[n >> 2] | 0, 85, 0); else x = 34;
	                    if ((x | 0) == 34 ? (d[c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 0 : 0)og(c[n >> 2] | 0, 86, 0);
	                    if ((c[(c[n >> 2] | 0) + 52 >> 2] | 0) != (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0))og(c[n >> 2] | 0, 85, 0);
	                    do if (!(c[(c[n >> 2] | 0) + 12 >> 2] | 0))if (!(c[(c[n >> 2] | 0) + 84 >> 2] | 0)) {
	                        c[u >> 2] = 1;
	                        break
	                    } else {
	                        c[u >> 2] = c[(c[n >> 2] | 0) + 84 >> 2];
	                        break
	                    } else c[u >> 2] = 0; while (0);
	                    if ((c[m >> 2] | 0) != 0 & (c[u >> 2] | 0) == 0) {
	                        c[w >> 2] = c[(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                        c[c[m >> 2] >> 2] = c[w >> 2];
	                        while (1) {
	                            if (!(c[w >> 2] | 0))break;
	                            do if (c[(c[j >> 2] | 0) + 104 >> 2] | 0) {
	                                if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0))break;
	                                if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0))break;
	                                if (!(c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0))break;
	                                if ((c[(c[w >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                                m = bn((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[w >> 2] | 0) | 0;
	                                x = (c[j >> 2] | 0) + 100 | 0;
	                                c[x >> 2] = c[x >> 2] & m
	                            } while (0);
	                            c[(c[w >> 2] | 0) + 20 >> 2] = 0;
	                            c[w >> 2] = c[(c[w >> 2] | 0) + 24 >> 2]
	                        }
	                        c[(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] = 0
	                    }
	                    if (c[(c[n >> 2] | 0) + 8 >> 2] | 0) {
	                        Rh(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0);
	                        c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] = c[r >> 2];
	                        c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] = c[s >> 2]
	                    }
	                    if (c[j >> 2] | 0) {
	                        s = (c[j >> 2] | 0) + 440 | 0;
	                        c[s >> 2] = (c[s >> 2] | 0) + (c[(c[n >> 2] | 0) + 440 >> 2] | 0)
	                    }
	                    if (c[(c[n >> 2] | 0) + 388 >> 2] | 0)Zd((c[n >> 2] | 0) + 384 | 0, (c[j >> 2] | 0) + 384 | 0) | 0;
	                    c[c[n >> 2] >> 2] = c[q >> 2];
	                    c[(c[n >> 2] | 0) + 296 >> 2] = 0;
	                    c[(c[n >> 2] | 0) + 348 >> 2] = 0;
	                    c[(c[n >> 2] | 0) + 352 >> 2] = 0;
	                    Ae(c[n >> 2] | 0);
	                    if (c[o >> 2] | 0)Th(c[o >> 2] | 0);
	                    c[h >> 2] = c[u >> 2];
	                    y = c[h >> 2] | 0;
	                    i = g;
	                    return y | 0
	                }
	                c[h >> 2] = 89;
	                y = c[h >> 2] | 0;
	                i = g;
	                return y | 0
	            }

	            function Tg(b, e, f, g, h, j, k, l) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                m = i;
	                i = i + 80 | 0;
	                n = m + 60 | 0;
	                o = m + 56 | 0;
	                p = m + 52 | 0;
	                q = m + 48 | 0;
	                r = m + 44 | 0;
	                s = m + 40 | 0;
	                t = m + 36 | 0;
	                u = m + 32 | 0;
	                v = m + 28 | 0;
	                w = m + 24 | 0;
	                x = m + 20 | 0;
	                y = m + 16 | 0;
	                z = m + 12 | 0;
	                A = m + 8 | 0;
	                B = m + 64 | 0;
	                C = m + 4 | 0;
	                D = m;
	                c[o >> 2] = b;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = l;
	                c[z >> 2] = 0;
	                c[A >> 2] = 0;
	                if ((c[s >> 2] | 0) > 40) {
	                    if (!((c[p >> 2] | 0) != 0 ? !((c[s >> 2] | 0) > 1024 ? 1 : (c[(c[p >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0) : 0))E = 5
	                } else if ((c[s >> 2] | 0) > 1024)E = 5;
	                if ((E | 0) == 5) {
	                    c[n >> 2] = 89;
	                    F = c[n >> 2] | 0;
	                    i = m;
	                    return F | 0
	                }
	                if (c[v >> 2] | 0)c[c[v >> 2] >> 2] = 0;
	                if ((c[t >> 2] | 0) == 0 & (c[u >> 2] | 0) == 0) {
	                    c[n >> 2] = 1;
	                    F = c[n >> 2] | 0;
	                    i = m;
	                    return F | 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    c[n >> 2] = 1;
	                    F = c[n >> 2] | 0;
	                    i = m;
	                    return F | 0
	                }
	                c[w >> 2] = fh(c[t >> 2] | 0, c[u >> 2] | 0, 0, c[p >> 2] | 0) | 0;
	                if (!(c[w >> 2] | 0)) {
	                    c[n >> 2] = 27;
	                    F = c[n >> 2] | 0;
	                    i = m;
	                    return F | 0
	                }
	                c[(c[w >> 2] | 0) + 4 >> 2] = c[w >> 2];
	                if (c[p >> 2] | 0) {
	                    c[(c[w >> 2] | 0) + 272 >> 2] = c[(c[p >> 2] | 0) + 272 >> 2];
	                    c[(c[w >> 2] | 0) + 276 >> 2] = c[(c[p >> 2] | 0) + 276 >> 2];
	                    c[(c[w >> 2] | 0) + 104 >> 2] = c[(c[p >> 2] | 0) + 104 >> 2];
	                    c[(c[w >> 2] | 0) + 96 >> 2] = c[(c[p >> 2] | 0) + 96 >> 2];
	                    c[(c[w >> 2] | 0) + 68 >> 2] = c[(c[p >> 2] | 0) + 68 >> 2];
	                    c[(c[w >> 2] | 0) + 72 >> 2] = c[(c[p >> 2] | 0) + 72 >> 2];
	                    c[(c[w >> 2] | 0) + 76 >> 2] = c[(c[p >> 2] | 0) + 76 >> 2];
	                    c[(c[w >> 2] | 0) + 80 >> 2] = c[(c[p >> 2] | 0) + 80 >> 2]
	                } else {
	                    c[(c[w >> 2] | 0) + 272 >> 2] = 0;
	                    c[(c[w >> 2] | 0) + 104 >> 2] = 0;
	                    c[(c[w >> 2] | 0) + 96 >> 2] = 2;
	                    c[(c[w >> 2] | 0) + 276 >> 2] = 0
	                }
	                if ((c[q >> 2] | 0) != 0 ? (c[z >> 2] = c[c[w >> 2] >> 2], c[c[w >> 2] >> 2] = c[q >> 2], (c[r >> 2] | 0) != 0) : 0)c[(c[w >> 2] | 0) + 4 >> 2] = c[r >> 2];
	                Rg(c[w >> 2] | 0);
	                c[x >> 2] = Sh(68488) | 0;
	                if (!(c[x >> 2] | 0)) {
	                    c[(c[w >> 2] | 0) + 72 >> 2] = 0;
	                    c[(c[w >> 2] | 0) + 76 >> 2] = 0;
	                    c[(c[w >> 2] | 0) + 80 >> 2] = 0;
	                    Ae(c[w >> 2] | 0);
	                    c[n >> 2] = 1;
	                    F = c[n >> 2] | 0;
	                    i = m;
	                    return F | 0
	                }
	                c[(c[x >> 2] | 0) + 92 >> 2] = 64;
	                c[(c[x >> 2] | 0) + 44 >> 2] = c[(c[o >> 2] | 0) + 44 >> 2];
	                c[(c[x >> 2] | 0) + 48 >> 2] = c[(c[o >> 2] | 0) + 48 >> 2];
	                c[(c[x >> 2] | 0) + 80 >> 2] = c[(c[o >> 2] | 0) + 80 >> 2];
	                yP(c[(c[x >> 2] | 0) + 80 >> 2] | 0) | 0;
	                if (c[(c[o >> 2] | 0) + 72 >> 2] | 0) {
	                    r = my(c[(c[o >> 2] | 0) + 72 >> 2] | 0) | 0;
	                    c[(c[x >> 2] | 0) + 72 >> 2] = r
	                }
	                c[y >> 2] = ji(c[x >> 2] | 0, 0, 69968, 0) | 0;
	                if (!(c[y >> 2] | 0)) {
	                    if (c[q >> 2] | 0)c[c[w >> 2] >> 2] = c[z >> 2];
	                    c[(c[w >> 2] | 0) + 72 >> 2] = 0;
	                    c[(c[w >> 2] | 0) + 76 >> 2] = 0;
	                    c[(c[w >> 2] | 0) + 80 >> 2] = 0;
	                    Ae(c[w >> 2] | 0);
	                    c[(c[x >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[x >> 2] | 0) + 48 >> 2] = 0;
	                    Th(c[x >> 2] | 0);
	                    c[n >> 2] = 1;
	                    F = c[n >> 2] | 0;
	                    i = m;
	                    return F | 0
	                }
	                zi(c[x >> 2] | 0, c[y >> 2] | 0) | 0;
	                Qe(c[w >> 2] | 0, c[(c[x >> 2] | 0) + 12 >> 2] | 0) | 0;
	                c[(c[w >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                c[(c[y >> 2] | 0) + 32 >> 2] = c[o >> 2];
	                if ((c[(c[w >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[w >> 2] | 0);
	                if (((c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 ? (a[B >> 0] = a[c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0, a[B + 1 >> 0] = a[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0, a[B + 2 >> 0] = a[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0, a[B + 3 >> 0] = a[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0, c[C >> 2] = sd(B, 4) | 0, (c[C >> 2] | 0) != 0) : 0)re(c[w >> 2] | 0, c[C >> 2] | 0) | 0;
	                a:do if (((((d[c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) ? (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) ? (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 108 : 0) {
	                    do if ((d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    _e(c[w >> 2] | 0)
	                } while (0);
	                c[(c[w >> 2] | 0) + 172 >> 2] = 7;
	                c[(c[w >> 2] | 0) + 248 >> 2] = c[s >> 2];
	                Jf(c[w >> 2] | 0);
	                if ((d[c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0)og(c[w >> 2] | 0, 85, 0); else E = 47;
	                if ((E | 0) == 47 ? (d[c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 0 : 0)og(c[w >> 2] | 0, 86, 0);
	                if ((c[(c[w >> 2] | 0) + 52 >> 2] | 0) != (c[(c[x >> 2] | 0) + 12 >> 2] | 0))og(c[w >> 2] | 0, 85, 0);
	                do if (!(c[(c[w >> 2] | 0) + 12 >> 2] | 0))if (!(c[(c[w >> 2] | 0) + 84 >> 2] | 0)) {
	                    c[A >> 2] = 1;
	                    break
	                } else {
	                    c[A >> 2] = c[(c[w >> 2] | 0) + 84 >> 2];
	                    break
	                } else {
	                    if (c[v >> 2] | 0) {
	                        c[D >> 2] = c[(c[(c[x >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                        c[c[v >> 2] >> 2] = c[D >> 2];
	                        while (1) {
	                            if (!(c[D >> 2] | 0))break;
	                            c[(c[D >> 2] | 0) + 20 >> 2] = 0;
	                            c[D >> 2] = c[(c[D >> 2] | 0) + 24 >> 2]
	                        }
	                        c[(c[(c[x >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] = 0
	                    }
	                    c[A >> 2] = 0
	                } while (0);
	                if (c[p >> 2] | 0) {
	                    D = (c[p >> 2] | 0) + 440 | 0;
	                    c[D >> 2] = (c[D >> 2] | 0) + (c[(c[w >> 2] | 0) + 440 >> 2] | 0)
	                }
	                if (c[(c[w >> 2] | 0) + 36 >> 2] | 0) {
	                    D = (c[p >> 2] | 0) + 444 | 0;
	                    c[D >> 2] = (c[D >> 2] | 0) + (c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0);
	                    D = (c[p >> 2] | 0) + 444 | 0;
	                    c[D >> 2] = (c[D >> 2] | 0) + ((c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))
	                }
	                if (c[(c[w >> 2] | 0) + 388 >> 2] | 0)Zd((c[w >> 2] | 0) + 384 | 0, (c[p >> 2] | 0) + 384 | 0) | 0;
	                if (c[q >> 2] | 0)c[c[w >> 2] >> 2] = c[z >> 2];
	                c[(c[p >> 2] | 0) + 72 >> 2] = c[(c[w >> 2] | 0) + 72 >> 2];
	                c[(c[p >> 2] | 0) + 76 >> 2] = c[(c[w >> 2] | 0) + 76 >> 2];
	                c[(c[p >> 2] | 0) + 80 >> 2] = c[(c[w >> 2] | 0) + 80 >> 2];
	                c[(c[w >> 2] | 0) + 72 >> 2] = 0;
	                c[(c[w >> 2] | 0) + 76 >> 2] = 0;
	                c[(c[w >> 2] | 0) + 80 >> 2] = 0;
	                Ae(c[w >> 2] | 0);
	                c[(c[x >> 2] | 0) + 44 >> 2] = 0;
	                c[(c[x >> 2] | 0) + 48 >> 2] = 0;
	                Th(c[x >> 2] | 0);
	                c[n >> 2] = c[A >> 2];
	                F = c[n >> 2] | 0;
	                i = m;
	                return F | 0
	            }

	            function Ug(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[17530] | 0)) {
	                    i = e;
	                    return
	                }
	                Db[c[70120 >> 2] & 511](c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function Vg(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = e;
	                    return
	                }
	                if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 84 >> 2] = 42;
	                d = c[g >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    b = c[j >> 2] | 0;
	                    c[f >> 2] = c[j >> 2];
	                    Xd(0, 0, 0, d, 0, 1, 42, 3, 0, 0, b, 0, 0, 0, 0, 71848, f)
	                } else {
	                    b = c[h >> 2] | 0;
	                    a = c[j >> 2] | 0;
	                    k = c[j >> 2] | 0;
	                    c[f >> 2] = c[h >> 2];
	                    c[f + 4 >> 2] = k;
	                    Xd(0, 0, 0, d, 0, 1, 42, 3, 0, 0, b, a, 0, 0, 0, 71872, f)
	                }
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 288 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 212 >> 2] = 1;
	                i = e;
	                return
	            }

	            function Wg(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                    b = (c[f >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 2;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[f >> 2] | 0) | 0;
	                    c[h >> 2] = mh(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0) | 0;
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                    Ue(c[f >> 2] | 0) | 0;
	                    if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)j = 19; else if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)j = 20; else j = 19;
	                    if ((j | 0) == 19)if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62) {
	                        b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        b = (c[f >> 2] | 0) + 200 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        if (!(d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                    } else j = 20;
	                    if ((j | 0) == 20)og(c[f >> 2] | 0, 73, 0);
	                    if ((c[h >> 2] | 0) != 1) {
	                        if (!(c[h >> 2] | 0))c[h >> 2] = 70752;
	                        $g(c[f >> 2] | 0, 76, 70768, c[(c[f >> 2] | 0) + 184 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0)
	                    }
	                    if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[(c[f >> 2] | 0) + 184 >> 2] | 0);
	                    Te(c[f >> 2] | 0) | 0;
	                    Zg(c[f >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                xg(c[f >> 2] | 0, 74, 71816);
	                i = e;
	                return
	            }

	            function Xg(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[(c[f >> 2] | 0) + 236 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 240 >> 2] | 0)) {
	                    b = (c[f >> 2] | 0) + 240 | 0;
	                    c[b >> 2] = c[b >> 2] << 1;
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 244 >> 2] | 0, c[(c[f >> 2] | 0) + 240 >> 2] << 2) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 244 >> 2] = c[h >> 2];
	                        break
	                    }
	                    ie(c[f >> 2] | 0, 0);
	                    b = (c[f >> 2] | 0) + 240 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) / 2 | 0;
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[(c[(c[f >> 2] | 0) + 244 >> 2] | 0) + (c[(c[f >> 2] | 0) + 236 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 232 >> 2] = (c[(c[f >> 2] | 0) + 244 >> 2] | 0) + (c[(c[f >> 2] | 0) + 236 >> 2] << 2);
	                g = (c[f >> 2] | 0) + 236 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Yg(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0;
	                g = i;
	                i = i + 144 | 0;
	                h = g + 132 | 0;
	                j = g + 128 | 0;
	                k = g + 124 | 0;
	                l = g + 120 | 0;
	                m = g + 116 | 0;
	                n = g + 112 | 0;
	                o = g + 108 | 0;
	                p = g + 104 | 0;
	                q = g + 100 | 0;
	                r = g + 96 | 0;
	                s = g + 92 | 0;
	                t = g + 88 | 0;
	                u = g + 84 | 0;
	                v = g + 80 | 0;
	                w = g + 76 | 0;
	                x = g + 72 | 0;
	                y = g + 68 | 0;
	                z = g + 64 | 0;
	                A = g + 60 | 0;
	                B = g + 56 | 0;
	                C = g + 52 | 0;
	                D = g + 48 | 0;
	                E = g + 44 | 0;
	                F = g + 40 | 0;
	                G = g + 36 | 0;
	                H = g + 32 | 0;
	                I = g + 28 | 0;
	                J = g + 24 | 0;
	                K = g + 20 | 0;
	                L = g + 16 | 0;
	                M = g + 12 | 0;
	                N = g + 8 | 0;
	                O = g + 4 | 0;
	                P = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[t >> 2] = c[(c[j >> 2] | 0) + 300 >> 2];
	                c[u >> 2] = c[(c[j >> 2] | 0) + 304 >> 2];
	                c[G >> 2] = c[(c[j >> 2] | 0) + 328 >> 2];
	                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                    c[h >> 2] = 0;
	                    Q = c[h >> 2] | 0;
	                    i = g;
	                    return Q | 0
	                }
	                f = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                f = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                f = (c[j >> 2] | 0) + 200 | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                if (!(d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                a:while (1) {
	                    if (((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 : 0) ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)Fg(c[j >> 2] | 0);
	                    c[E >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                    c[F >> 2] = (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                    c[C >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[D >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2];
	                    c[w >> 2] = 0;
	                    c[v >> 2] = 0;
	                    c[x >> 2] = 0;
	                    c[A >> 2] = 0;
	                    c[B >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 328 >> 2] = c[G >> 2];
	                    c[n >> 2] = nh(c[j >> 2] | 0, o) | 0;
	                    R = c[j >> 2] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        S = 10;
	                        break
	                    }
	                    c[c[m >> 2] >> 2] = (c[(c[R + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) - (c[F >> 2] | 0);
	                    Ue(c[j >> 2] | 0) | 0;
	                    if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                    b:do if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) == (c[E >> 2] | 0)) {
	                        c:while (1) {
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break a;
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break a;
	                            if (!(9 <= (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))S = 20;
	                            if (((S | 0) == 20 ? (S = 0, (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) : 0) ? 32 > (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)break a;
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1)break a;
	                            c[H >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                            c[I >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                            c[J >> 2] = -1;
	                            c[K >> 2] = 0;
	                            c[p >> 2] = oh(c[j >> 2] | 0, c[o >> 2] | 0, c[n >> 2] | 0, q, s, J, K) | 0;
	                            if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != (c[E >> 2] | 0))break;
	                            d:do if ((c[p >> 2] | 0) != 0 & (c[s >> 2] | 0) != 0) {
	                                if ((c[J >> 2] | 0) < 0)c[J >> 2] = xy(c[s >> 2] | 0) | 0;
	                                if ((c[q >> 2] | 0) == 0 ? (c[p >> 2] | 0) == (c[(c[j >> 2] | 0) + 316 >> 2] | 0) : 0) {
	                                    c[L >> 2] = AP(c[(c[j >> 2] | 0) + 296 >> 2] | 0, c[s >> 2] | 0, c[J >> 2] | 0) | 0;
	                                    if (!(c[L >> 2] | 0)) {
	                                        S = 32;
	                                        break a
	                                    }
	                                    do if (d[c[L >> 2] >> 0] | 0) {
	                                        c[M >> 2] = yl(c[L >> 2] | 0) | 0;
	                                        if (!(c[M >> 2] | 0))Jg(c[j >> 2] | 0, 99, 71016, c[L >> 2] | 0, 0, 0); else {
	                                            if (!(c[c[M >> 2] >> 2] | 0))ph(c[j >> 2] | 0, 100, 71048, c[L >> 2] | 0, 0, 0);
	                                            Al(c[M >> 2] | 0)
	                                        }
	                                        if ((c[L >> 2] | 0) == (c[(c[j >> 2] | 0) + 320 >> 2] | 0)) {
	                                            if ((c[p >> 2] | 0) == (c[(c[j >> 2] | 0) + 312 >> 2] | 0))break;
	                                            Jg(c[j >> 2] | 0, 200, 71080, 0, 0, 0);
	                                            break
	                                        }
	                                        if ((c[J >> 2] | 0) != 29) {
	                                            S = 47;
	                                            break
	                                        }
	                                        if (!(qy(c[L >> 2] | 0, 71136) | 0)) {
	                                            S = 47;
	                                            break
	                                        }
	                                        Jg(c[j >> 2] | 0, 200, 71168, 0, 0, 0)
	                                    } else S = 47; while (0);
	                                    do if ((S | 0) == 47) {
	                                        S = 0;
	                                        c[z >> 2] = 1;
	                                        while (1) {
	                                            if ((c[z >> 2] | 0) > (c[A >> 2] | 0))break;
	                                            if (!(c[(c[(c[j >> 2] | 0) + 336 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] << 1) << 2) >> 2] | 0))break;
	                                            c[z >> 2] = (c[z >> 2] | 0) + 1
	                                        }
	                                        f = c[j >> 2] | 0;
	                                        if ((c[z >> 2] | 0) <= (c[A >> 2] | 0)) {
	                                            Vg(f, 0, c[p >> 2] | 0);
	                                            break
	                                        }
	                                        if ((ih(f, 0, c[L >> 2] | 0) | 0) <= 0)break;
	                                        c[A >> 2] = (c[A >> 2] | 0) + 1
	                                    } while (0);
	                                    if (c[K >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break a;
	                                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break a;
	                                    do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                                        if (9 <= (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                                            S = 64;
	                                            break a
	                                        }
	                                    } while (0);
	                                    Ue(c[j >> 2] | 0) | 0;
	                                    continue c
	                                }
	                                if ((c[q >> 2] | 0) != (c[(c[j >> 2] | 0) + 316 >> 2] | 0)) {
	                                    if (!((c[t >> 2] | 0) != 0 ? ((c[w >> 2] | 0) + 5 | 0) <= (c[u >> 2] | 0) : 0))S = 108;
	                                    do if ((S | 0) == 108) {
	                                        S = 0;
	                                        if ((qh(c[j >> 2] | 0, (c[w >> 2] | 0) + 5 | 0) | 0) >= 0) {
	                                            c[u >> 2] = c[(c[j >> 2] | 0) + 304 >> 2];
	                                            c[t >> 2] = c[(c[j >> 2] | 0) + 300 >> 2];
	                                            break
	                                        }
	                                        if (d[(c[s >> 2] | 0) + (c[J >> 2] | 0) >> 0] | 0)break d;
	                                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                                        break d
	                                    } while (0);
	                                    f = c[K >> 2] | 0;
	                                    e = c[v >> 2] | 0;
	                                    c[v >> 2] = e + 1;
	                                    c[(c[(c[j >> 2] | 0) + 340 >> 2] | 0) + (e << 2) >> 2] = f;
	                                    f = c[p >> 2] | 0;
	                                    e = c[w >> 2] | 0;
	                                    c[w >> 2] = e + 1;
	                                    c[(c[t >> 2] | 0) + (e << 2) >> 2] = f;
	                                    f = c[q >> 2] | 0;
	                                    e = c[w >> 2] | 0;
	                                    c[w >> 2] = e + 1;
	                                    c[(c[t >> 2] | 0) + (e << 2) >> 2] = f;
	                                    f = c[w >> 2] | 0;
	                                    c[w >> 2] = f + 1;
	                                    c[(c[t >> 2] | 0) + (f << 2) >> 2] = 0;
	                                    f = c[s >> 2] | 0;
	                                    e = c[w >> 2] | 0;
	                                    c[w >> 2] = e + 1;
	                                    c[(c[t >> 2] | 0) + (e << 2) >> 2] = f;
	                                    c[s >> 2] = (c[s >> 2] | 0) + (c[J >> 2] | 0);
	                                    f = c[s >> 2] | 0;
	                                    e = c[w >> 2] | 0;
	                                    c[w >> 2] = e + 1;
	                                    c[(c[t >> 2] | 0) + (e << 2) >> 2] = f;
	                                    if (!(c[K >> 2] | 0))break;
	                                    c[B >> 2] = 1;
	                                    break
	                                }
	                                c[N >> 2] = AP(c[(c[j >> 2] | 0) + 296 >> 2] | 0, c[s >> 2] | 0, c[J >> 2] | 0) | 0;
	                                f = c[N >> 2] | 0;
	                                e = c[(c[j >> 2] | 0) + 320 >> 2] | 0;
	                                e:do if ((c[p >> 2] | 0) == (c[(c[j >> 2] | 0) + 312 >> 2] | 0)) {
	                                    if ((f | 0) == (e | 0))break;
	                                    Jg(c[j >> 2] | 0, 200, 71216, 0, 0, 0)
	                                } else {
	                                    b = c[p >> 2] | 0;
	                                    a = c[j >> 2] | 0;
	                                    if ((f | 0) == (e | 0)) {
	                                        if ((b | 0) == (c[a + 312 >> 2] | 0))break;
	                                        Jg(c[j >> 2] | 0, 200, 71264, 0, 0, 0);
	                                        break
	                                    }
	                                    if ((b | 0) == (c[a + 316 >> 2] | 0)) {
	                                        Jg(c[j >> 2] | 0, 200, 71312, 0, 0, 0);
	                                        break
	                                    }
	                                    do if ((c[J >> 2] | 0) == 29) {
	                                        if (!(qy(c[N >> 2] | 0, 71136) | 0))break;
	                                        Jg(c[j >> 2] | 0, 200, 71168, 0, 0, 0);
	                                        break e
	                                    } while (0);
	                                    do if (c[N >> 2] | 0) {
	                                        if (!(d[c[N >> 2] >> 0] | 0))break;
	                                        c[O >> 2] = yl(c[N >> 2] | 0) | 0;
	                                        a = c[j >> 2] | 0;
	                                        if (!(c[O >> 2] | 0))Jg(a, 99, 71408, c[p >> 2] | 0, c[N >> 2] | 0, 0); else {
	                                            do if (c[a + 268 >> 2] | 0) {
	                                                if (c[c[O >> 2] >> 2] | 0)break;
	                                                ph(c[j >> 2] | 0, 100, 71448, c[p >> 2] | 0, c[N >> 2] | 0, 0)
	                                            } while (0);
	                                            Al(c[O >> 2] | 0)
	                                        }
	                                        c[z >> 2] = 1;
	                                        while (1) {
	                                            if ((c[z >> 2] | 0) > (c[A >> 2] | 0))break;
	                                            if ((c[(c[(c[j >> 2] | 0) + 336 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] << 1) << 2) >> 2] | 0) == (c[p >> 2] | 0))break;
	                                            c[z >> 2] = (c[z >> 2] | 0) + 1
	                                        }
	                                        a = c[j >> 2] | 0;
	                                        if ((c[z >> 2] | 0) <= (c[A >> 2] | 0)) {
	                                            Vg(a, c[q >> 2] | 0, c[p >> 2] | 0);
	                                            break e
	                                        }
	                                        if ((ih(a, c[p >> 2] | 0, c[N >> 2] | 0) | 0) <= 0)break e;
	                                        c[A >> 2] = (c[A >> 2] | 0) + 1;
	                                        break e
	                                    } while (0);
	                                    Jg(c[j >> 2] | 0, 200, 71360, c[p >> 2] | 0, 0, 0)
	                                } while (0);
	                                if (c[K >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break a;
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break a;
	                                do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                                    if (9 <= (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                                        S = 104;
	                                        break a
	                                    }
	                                } while (0);
	                                Ue(c[j >> 2] | 0) | 0;
	                                if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != (c[E >> 2] | 0))break b; else continue c
	                            } else if ((c[s >> 2] | 0) != 0 ? (d[(c[s >> 2] | 0) + (c[J >> 2] | 0) >> 0] | 0 | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0); while (0);
	                            if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1)break a;
	                            if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != (c[E >> 2] | 0))break b;
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break a;
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break a;
	                            do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) {
	                                    S = 129;
	                                    break a
	                                }
	                            } while (0);
	                            Ue(c[j >> 2] | 0) | 0;
	                            if ((c[I >> 2] | 0) == (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) ? ((c[p >> 2] | 0) == 0 ? (c[H >> 2] | 0) == (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) : 0) & (c[s >> 2] | 0) == 0 : 0) {
	                                S = 132;
	                                break a
	                            }
	                            do if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0)) {
	                                if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                                vg(c[j >> 2] | 0)
	                            } while (0);
	                            if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != (c[E >> 2] | 0))break b
	                        }
	                        if ((c[s >> 2] | 0) != 0 & (c[K >> 2] | 0) != 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        c[s >> 2] = 0
	                    } while (0);
	                    f:do if (c[B >> 2] | 0) {
	                        c[y >> 2] = 3;
	                        c[z >> 2] = 0;
	                        while (1) {
	                            if ((c[z >> 2] | 0) >= (c[v >> 2] | 0))break f;
	                            if ((c[(c[(c[j >> 2] | 0) + 340 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) != 0 ? (c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0);
	                            c[y >> 2] = (c[y >> 2] | 0) + 5;
	                            c[z >> 2] = (c[z >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) + (c[F >> 2] | 0);
	                    c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] = c[C >> 2];
	                    c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = c[D >> 2];
	                    if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 1) {
	                        S = 219;
	                        break
	                    }
	                }
	                if ((S | 0) == 10) {
	                    xg(R, 68, 70952);
	                    c[h >> 2] = 0;
	                    Q = c[h >> 2] | 0;
	                    i = g;
	                    return Q | 0
	                } else if ((S | 0) == 32) {
	                    ie(c[j >> 2] | 0, 70984);
	                    if ((c[s >> 2] | 0) != 0 & (c[K >> 2] | 0) != 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                    c[h >> 2] = 0;
	                    Q = c[h >> 2] | 0;
	                    i = g;
	                    return Q | 0
	                } else if ((S | 0) == 64)xg(c[j >> 2] | 0, 65, 69320); else if ((S | 0) == 104)xg(c[j >> 2] | 0, 65, 69320); else if ((S | 0) == 129)xg(c[j >> 2] | 0, 65, 69320); else if ((S | 0) == 132)og(c[j >> 2] | 0, 1, 69352); else if ((S | 0) == 219) {
	                    c[h >> 2] = 0;
	                    Q = c[h >> 2] | 0;
	                    i = g;
	                    return Q | 0
	                }
	                g:do if ((c[(c[j >> 2] | 0) + 348 >> 2] | 0) != 0 ? (c[P >> 2] = Tj(c[(c[j >> 2] | 0) + 348 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0, (c[P >> 2] | 0) != 0) : 0) {
	                    c[y >> 2] = 0;
	                    h:while (1) {
	                        if ((c[y >> 2] | 0) >= (c[c[P >> 2] >> 2] | 0))break g;
	                        c[p >> 2] = c[(c[P >> 2] | 0) + 8 + ((c[y >> 2] | 0) * 5 << 2) >> 2];
	                        c[q >> 2] = c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 1 << 2) >> 2];
	                        do if ((c[q >> 2] | 0) == 0 ? (c[p >> 2] | 0) == (c[(c[j >> 2] | 0) + 316 >> 2] | 0) : 0) {
	                            c[z >> 2] = 1;
	                            while (1) {
	                                if ((c[z >> 2] | 0) > (c[A >> 2] | 0))break;
	                                if (!(c[(c[(c[j >> 2] | 0) + 336 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] << 1) << 2) >> 2] | 0))break;
	                                c[z >> 2] = (c[z >> 2] | 0) + 1
	                            }
	                            if (((c[z >> 2] | 0) > (c[A >> 2] | 0) ? (c[r >> 2] = hh(c[j >> 2] | 0, 0) | 0, (c[r >> 2] | 0) != (c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 2 << 2) >> 2] | 0)) : 0) ? (ih(c[j >> 2] | 0, 0, c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 2 << 2) >> 2] | 0) | 0) > 0 : 0)c[A >> 2] = (c[A >> 2] | 0) + 1
	                        } else {
	                            if ((c[q >> 2] | 0) == (c[(c[j >> 2] | 0) + 316 >> 2] | 0)) {
	                                c[z >> 2] = 1;
	                                while (1) {
	                                    if ((c[z >> 2] | 0) > (c[A >> 2] | 0))break;
	                                    if ((c[(c[(c[j >> 2] | 0) + 336 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] << 1) << 2) >> 2] | 0) == (c[p >> 2] | 0))break;
	                                    c[z >> 2] = (c[z >> 2] | 0) + 1
	                                }
	                                if ((c[z >> 2] | 0) <= (c[A >> 2] | 0))break;
	                                c[r >> 2] = hh(c[j >> 2] | 0, c[p >> 2] | 0) | 0;
	                                if ((c[r >> 2] | 0) == (c[(c[P >> 2] | 0) + 16 >> 2] | 0))break;
	                                if ((ih(c[j >> 2] | 0, c[p >> 2] | 0, c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 2 << 2) >> 2] | 0) | 0) <= 0)break;
	                                c[A >> 2] = (c[A >> 2] | 0) + 1;
	                                break
	                            }
	                            c[z >> 2] = 0;
	                            while (1) {
	                                if ((c[z >> 2] | 0) >= (c[w >> 2] | 0))break;
	                                if ((c[p >> 2] | 0) == (c[(c[t >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) ? (c[q >> 2] | 0) == (c[(c[t >> 2] | 0) + ((c[z >> 2] | 0) + 1 << 2) >> 2] | 0) : 0)break;
	                                c[z >> 2] = (c[z >> 2] | 0) + 5
	                            }
	                            if ((c[z >> 2] | 0) >= (c[w >> 2] | 0)) {
	                                if (!((c[t >> 2] | 0) != 0 ? ((c[w >> 2] | 0) + 5 | 0) <= (c[u >> 2] | 0) : 0)) {
	                                    if ((qh(c[j >> 2] | 0, (c[w >> 2] | 0) + 5 | 0) | 0) < 0)break h;
	                                    c[u >> 2] = c[(c[j >> 2] | 0) + 304 >> 2];
	                                    c[t >> 2] = c[(c[j >> 2] | 0) + 300 >> 2]
	                                }
	                                s = c[p >> 2] | 0;
	                                K = c[w >> 2] | 0;
	                                c[w >> 2] = K + 1;
	                                c[(c[t >> 2] | 0) + (K << 2) >> 2] = s;
	                                s = c[q >> 2] | 0;
	                                K = c[w >> 2] | 0;
	                                c[w >> 2] = K + 1;
	                                c[(c[t >> 2] | 0) + (K << 2) >> 2] = s;
	                                if (!(c[q >> 2] | 0)) {
	                                    s = c[w >> 2] | 0;
	                                    c[w >> 2] = s + 1;
	                                    c[(c[t >> 2] | 0) + (s << 2) >> 2] = 0
	                                } else {
	                                    s = hh(c[j >> 2] | 0, c[q >> 2] | 0) | 0;
	                                    K = c[w >> 2] | 0;
	                                    c[w >> 2] = K + 1;
	                                    c[(c[t >> 2] | 0) + (K << 2) >> 2] = s
	                                }
	                                s = c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 2 << 2) >> 2] | 0;
	                                K = c[w >> 2] | 0;
	                                c[w >> 2] = K + 1;
	                                c[(c[t >> 2] | 0) + (K << 2) >> 2] = s;
	                                s = c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 3 << 2) >> 2] | 0;
	                                K = c[w >> 2] | 0;
	                                c[w >> 2] = K + 1;
	                                c[(c[t >> 2] | 0) + (K << 2) >> 2] = s;
	                                if ((c[(c[j >> 2] | 0) + 28 >> 2] | 0) == 1 ? (c[(c[P >> 2] | 0) + 8 + (((c[y >> 2] | 0) * 5 | 0) + 4 << 2) >> 2] | 0) != 0 : 0)qg(c[j >> 2] | 0, 538, 71488, c[p >> 2] | 0, c[n >> 2] | 0);
	                                c[x >> 2] = (c[x >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        c[y >> 2] = (c[y >> 2] | 0) + 1
	                    }
	                    c[h >> 2] = 0;
	                    Q = c[h >> 2] | 0;
	                    i = g;
	                    return Q | 0
	                } while (0);
	                c[y >> 2] = 0;
	                while (1) {
	                    if ((c[y >> 2] | 0) >= (c[w >> 2] | 0))break;
	                    if (c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2] | 0) {
	                        c[r >> 2] = hh(c[j >> 2] | 0, c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0))Jg(c[j >> 2] | 0, 201, 71552, c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2] | 0, c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0, c[n >> 2] | 0);
	                        c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 2 << 2) >> 2] = c[r >> 2]
	                    } else c[r >> 2] = 0;
	                    c[z >> 2] = 0;
	                    while (1) {
	                        if ((c[z >> 2] | 0) >= (c[y >> 2] | 0))break;
	                        if ((c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0) == (c[(c[t >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0)) {
	                            if ((c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2] | 0) == (c[(c[t >> 2] | 0) + ((c[z >> 2] | 0) + 1 << 2) >> 2] | 0)) {
	                                S = 189;
	                                break
	                            }
	                            if ((c[r >> 2] | 0) != 0 ? (c[(c[t >> 2] | 0) + ((c[z >> 2] | 0) + 2 << 2) >> 2] | 0) == (c[r >> 2] | 0) : 0) {
	                                S = 192;
	                                break
	                            }
	                        }
	                        c[z >> 2] = (c[z >> 2] | 0) + 5
	                    }
	                    if ((S | 0) == 189) {
	                        S = 0;
	                        Vg(c[j >> 2] | 0, c[(c[t >> 2] | 0) + ((c[y >> 2] | 0) + 1 << 2) >> 2] | 0, c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0)
	                    } else if ((S | 0) == 192) {
	                        S = 0;
	                        Jg(c[j >> 2] | 0, 203, 71608, c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0, c[r >> 2] | 0, 0)
	                    }
	                    c[y >> 2] = (c[y >> 2] | 0) + 5
	                }
	                c[r >> 2] = hh(c[j >> 2] | 0, c[o >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) != 0 & (c[r >> 2] | 0) == 0)Jg(c[j >> 2] | 0, 201, 71656, c[o >> 2] | 0, c[n >> 2] | 0, 0);
	                c[c[k >> 2] >> 2] = c[o >> 2];
	                c[c[l >> 2] >> 2] = c[r >> 2];
	                do if (((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 116 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                    l = c[(c[c[j >> 2] >> 2] | 0) + 116 >> 2] | 0;
	                    k = c[(c[j >> 2] | 0) + 4 >> 2] | 0;
	                    S = c[n >> 2] | 0;
	                    p = c[o >> 2] | 0;
	                    P = c[r >> 2] | 0;
	                    if ((c[A >> 2] | 0) > 0) {
	                        Eb[l & 511](k, S, p, P, c[A >> 2] | 0, (c[(c[j >> 2] | 0) + 336 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[A >> 2] << 1) << 2) | 0, (c[w >> 2] | 0) / 5 | 0, c[x >> 2] | 0, c[t >> 2] | 0);
	                        break
	                    } else {
	                        Eb[l & 511](k, S, p, P, 0, 0, (c[w >> 2] | 0) / 5 | 0, c[x >> 2] | 0, c[t >> 2] | 0);
	                        break
	                    }
	                } while (0);
	                i:do if (c[B >> 2] | 0) {
	                    c[y >> 2] = 3;
	                    c[z >> 2] = 0;
	                    while (1) {
	                        if ((c[z >> 2] | 0) >= (c[v >> 2] | 0))break i;
	                        if ((c[(c[(c[j >> 2] | 0) + 340 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) != 0 ? (c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[t >> 2] | 0) + (c[y >> 2] << 2) >> 2] | 0);
	                        c[y >> 2] = (c[y >> 2] | 0) + 5;
	                        c[z >> 2] = (c[z >> 2] | 0) + 1
	                    }
	                } while (0);
	                c[h >> 2] = c[n >> 2];
	                Q = c[h >> 2] | 0;
	                i = g;
	                return Q | 0
	            }

	            function Zg(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 236 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 236 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 236 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 232 >> 2] = (c[(c[e >> 2] | 0) + 244 >> 2] | 0) + ((c[a + 236 >> 2] | 0) - 1 << 2); else c[(c[e >> 2] | 0) + 232 >> 2] = c[a + 244 >> 2];
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 244 >> 2] | 0) + (c[(c[e >> 2] | 0) + 236 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 244 >> 2] | 0) + (c[(c[e >> 2] | 0) + 236 >> 2] << 2) >> 2] = -1;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function _g(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[(c[g >> 2] | 0) + 336 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 328 >> 2] | 0) < (c[h >> 2] | 0)) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = c[h >> 2];
	                    Db[b & 511](a, 70928, e);
	                    c[h >> 2] = c[(c[g >> 2] | 0) + 328 >> 2]
	                }
	                if ((c[(c[g >> 2] | 0) + 328 >> 2] | 0) <= 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= (c[h >> 2] | 0))break;
	                    e = (c[g >> 2] | 0) + 328 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + -1;
	                    c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + (c[(c[g >> 2] | 0) + 328 >> 2] << 2) >> 2] = 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                c[f >> 2] = c[h >> 2];
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function $g(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = h;
	                    return
	                }
	                if (c[k >> 2] | 0)c[(c[k >> 2] | 0) + 84 >> 2] = c[l >> 2];
	                g = c[k >> 2] | 0;
	                f = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                e = c[p >> 2] | 0;
	                d = c[o >> 2] | 0;
	                b = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                o = c[p >> 2] | 0;
	                c[j >> 2] = c[n >> 2];
	                c[j + 4 >> 2] = m;
	                c[j + 8 >> 2] = o;
	                Xd(0, 0, 0, g, 0, 1, f, 3, 0, 0, l, e, 0, d, 0, b, j);
	                if (!(c[k >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                c[(c[k >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[k >> 2] | 0) + 288 >> 2] | 0) {
	                    i = h;
	                    return
	                }
	                c[(c[k >> 2] | 0) + 212 >> 2] = 1;
	                i = h;
	                return
	            }

	            function ah(a, b, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                k = i;
	                i = i + 32 | 0;
	                l = k + 24 | 0;
	                m = k + 20 | 0;
	                n = k + 16 | 0;
	                o = k + 12 | 0;
	                p = k + 8 | 0;
	                q = k + 4 | 0;
	                r = k;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = h;
	                c[q >> 2] = j;
	                if ((c[(c[l >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[l >> 2] | 0);
	                if ((d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                    j = (c[l >> 2] | 0) + 200 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 2;
	                    j = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 2;
	                    j = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + 2;
	                    if ((d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[l >> 2] | 0);
	                    if ((d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[l >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[l >> 2] | 0) | 0;
	                    do if ((c[q >> 2] | 0) > 0 ? (sy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[(c[l >> 2] | 0) + 184 >> 2] | 0, c[q >> 2] | 0) | 0) == 0 : 0) {
	                        j = c[q >> 2] | 0;
	                        if ((d[(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (c[q >> 2] | 0) >> 0] | 0 | 0) == 62) {
	                            h = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + (j + 1);
	                            h = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + ((c[q >> 2] | 0) + 1);
	                            break
	                        } else {
	                            h = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + j;
	                            j = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + (c[q >> 2] | 0);
	                            c[r >> 2] = 1;
	                            s = 20;
	                            break
	                        }
	                    } else s = 17; while (0);
	                    do if ((s | 0) == 17) {
	                        q = c[l >> 2] | 0;
	                        j = c[(c[l >> 2] | 0) + 184 >> 2] | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            c[r >> 2] = mh(q, j) | 0;
	                            s = 20;
	                            break
	                        } else {
	                            c[r >> 2] = rh(q, j, c[m >> 2] | 0) | 0;
	                            s = 20;
	                            break
	                        }
	                    } while (0);
	                    if ((s | 0) == 20) {
	                        if ((c[(c[l >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[l >> 2] | 0);
	                        if ((c[(c[l >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            i = k;
	                            return
	                        }
	                        Ue(c[l >> 2] | 0) | 0;
	                        if (9 <= (d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)s = 28; else if ((d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)s = 29; else s = 28;
	                        if ((s | 0) == 28)if ((d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62) {
	                            j = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            j = (c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            j = (c[l >> 2] | 0) + 200 | 0;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1;
	                            if (!(d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[l >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                        } else s = 29;
	                        if ((s | 0) == 29)og(c[l >> 2] | 0, 73, 0);
	                        if ((c[r >> 2] | 0) != 1) {
	                            if (!(c[r >> 2] | 0))c[r >> 2] = 70752;
	                            if ((c[o >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)c[o >> 2] = e[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 56 >> 1];
	                            $g(c[l >> 2] | 0, 76, 70768, c[(c[l >> 2] | 0) + 184 >> 2] | 0, c[o >> 2] | 0, c[r >> 2] | 0)
	                        }
	                    }
	                    if (((c[c[l >> 2] >> 2] | 0) != 0 ? (c[(c[c[l >> 2] >> 2] | 0) + 120 >> 2] | 0) != 0 : 0) ? (c[(c[l >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Jb[c[(c[c[l >> 2] >> 2] | 0) + 120 >> 2] & 511](c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[(c[l >> 2] | 0) + 184 >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0);
	                    Zg(c[l >> 2] | 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        i = k;
	                        return
	                    }
	                    _g(c[l >> 2] | 0, c[p >> 2] | 0) | 0;
	                    i = k;
	                    return
	                }
	                og(c[l >> 2] | 0, 74, 0);
	                i = k;
	                return
	            }

	            function bh(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 91) {
	                    c[(c[e >> 2] | 0) + 172 >> 2] = 3;
	                    me(c[e >> 2] | 0);
	                    while (1) {
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 93)break;
	                        if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                        c[f >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        c[g >> 2] = c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                        Ue(c[e >> 2] | 0) | 0;
	                        yf(c[e >> 2] | 0);
	                        zf(c[e >> 2] | 0);
	                        while (1) {
	                            if (!(d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))h = (c[(c[e >> 2] | 0) + 40 >> 2] | 0) > 1; else h = 0;
	                            j = c[e >> 2] | 0;
	                            if (!h)break;
	                            Ve(j) | 0
	                        }
	                        if ((c[(c[j + 36 >> 2] | 0) + 16 >> 2] | 0) != (c[f >> 2] | 0))continue;
	                        if ((c[g >> 2] | 0) == (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0)) {
	                            k = 12;
	                            break
	                        }
	                    }
	                    if ((k | 0) == 12)og(c[e >> 2] | 0, 1, 70688);
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 93) {
	                        me(c[e >> 2] | 0);
	                        Ue(c[e >> 2] | 0) | 0
	                    }
	                }
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62) {
	                    l = c[e >> 2] | 0;
	                    me(l);
	                    i = b;
	                    return
	                }
	                og(c[e >> 2] | 0, 61, 0);
	                l = c[e >> 2] | 0;
	                me(l);
	                i = b;
	                return
	            }

	            function ch(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[(c[d >> 2] | 0) + 352 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Xj(c[(c[d >> 2] | 0) + 352 >> 2] | 0, 228, c[d >> 2] | 0);
	                if ($j(c[(c[d >> 2] | 0) + 352 >> 2] | 0) | 0) {
	                    i = b;
	                    return
	                }
	                Kj(c[(c[d >> 2] | 0) + 352 >> 2] | 0, 0);
	                c[(c[d >> 2] | 0) + 352 >> 2] = 0;
	                i = b;
	                return
	            }

	            function dh(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0;
	                f = i;
	                i = i + 288 | 0;
	                g = f;
	                h = f + 124 | 0;
	                j = f + 120 | 0;
	                k = f + 116 | 0;
	                l = f + 112 | 0;
	                m = f + 108 | 0;
	                n = f + 104 | 0;
	                o = f + 285 | 0;
	                p = f + 284 | 0;
	                q = f + 100 | 0;
	                r = f + 96 | 0;
	                s = f + 92 | 0;
	                t = f + 88 | 0;
	                u = f + 280 | 0;
	                v = f + 84 | 0;
	                w = f + 80 | 0;
	                x = f + 76 | 0;
	                y = f + 72 | 0;
	                z = f + 68 | 0;
	                A = f + 64 | 0;
	                B = f + 60 | 0;
	                C = f + 56 | 0;
	                D = f + 52 | 0;
	                E = f + 48 | 0;
	                F = f + 44 | 0;
	                G = f + 40 | 0;
	                H = f + 36 | 0;
	                I = f + 32 | 0;
	                J = f + 28 | 0;
	                K = f + 24 | 0;
	                L = f + 278 | 0;
	                M = f + 20 | 0;
	                N = f + 16 | 0;
	                O = f + 128 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                if (!(c[(c[j >> 2] | 0) + 36 >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    P = c[h >> 2] | 0;
	                    i = f;
	                    return P | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 4096 : 0) {
	                    Fg(c[j >> 2] | 0);
	                    c[(c[j >> 2] | 0) + 204 >> 2] = 0
	                }
	                th(c[j >> 2] | 0, q, r);
	                a:while (1) {
	                    if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        Q = 407;
	                        break
	                    }
	                    if ((c[(c[j >> 2] | 0) + 84 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 1 : 0) {
	                        Q = 10;
	                        break
	                    }
	                    while (1) {
	                        if (!(d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))R = (c[(c[j >> 2] | 0) + 40 >> 2] | 0) > 1; else R = 0;
	                        S = c[j >> 2] | 0;
	                        if (!R)break;
	                        Ve(S) | 0
	                    }
	                    if (!(c[S + 36 >> 2] | 0)) {
	                        Q = 407;
	                        break
	                    }
	                    e = c[j >> 2] | 0;
	                    if (!(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0))c[m >> 2] = (c[(c[e + 36 >> 2] | 0) + 24 >> 2] | 0) - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)); else {
	                        if (((c[e + 172 >> 2] | 0) != 0 ? (c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (az(c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 20 >> 2] | 0) | 0) == 0 : 0) {
	                            c[s >> 2] = jz(c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0) | 0;
	                            c[t >> 2] = (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                            Lk(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0, 0, 65640) | 0;
	                            kz(c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0) | 0
	                        }
	                        e = _y(c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        c[m >> 2] = e - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))
	                    }
	                    if ((c[m >> 2] | 0) < 1) {
	                        Q = 407;
	                        break
	                    }
	                    do switch (c[(c[j >> 2] | 0) + 172 >> 2] | 0) {
	                        case 1:
	                        {
	                            Ue(c[j >> 2] | 0) | 0;
	                            e = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                            if (!(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0))c[m >> 2] = (c[e + 24 >> 2] | 0) - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)); else {
	                                b = _y(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[m >> 2] = b - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))
	                            }
	                            if ((c[m >> 2] | 0) < 2) {
	                                Q = 407;
	                                break a
	                            }
	                            a[o >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[p >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 63 : 0) {
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 63, 62, 0) | 0) < 0 : 0) {
	                                    Q = 265;
	                                    break a
	                                }
	                                mf(c[j >> 2] | 0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 1;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                                continue a
	                            }
	                            if ((((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0) {
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 45, 45, 62) | 0) < 0 : 0) {
	                                    Q = 274;
	                                    break a
	                                }
	                                kf(c[j >> 2] | 0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 1;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                                continue a
	                            }
	                            do if ((((((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 68 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 79 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) == 67 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) == 84 : 0) {
	                                if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 89)break;
	                                if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 80)break;
	                                if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) != 69)break;
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 62, 0, 0) | 0) < 0 : 0) {
	                                    Q = 288;
	                                    break a
	                                }
	                                c[(c[j >> 2] | 0) + 216 >> 2] = 1;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 0;
	                                c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                                Ff(c[j >> 2] | 0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                b = c[j >> 2] | 0;
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 91) {
	                                    c[b + 172 >> 2] = 3;
	                                    continue a
	                                }
	                                c[b + 216 >> 2] = 2;
	                                do if (c[c[j >> 2] >> 2] | 0) {
	                                    if (c[(c[j >> 2] | 0) + 212 >> 2] | 0)break;
	                                    if (!(c[(c[c[j >> 2] >> 2] | 0) + 104 >> 2] | 0))break;
	                                    Jb[c[(c[c[j >> 2] >> 2] | 0) + 104 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[j >> 2] | 0) + 220 >> 2] | 0, c[(c[j >> 2] | 0) + 228 >> 2] | 0, c[(c[j >> 2] | 0) + 224 >> 2] | 0)
	                                } while (0);
	                                c[(c[j >> 2] | 0) + 216 >> 2] = 0;
	                                ch(c[j >> 2] | 0);
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 4;
	                                continue a
	                            } while (0);
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 & (c[m >> 2] | 0) < 9 : 0) {
	                                Q = 407;
	                                break a
	                            }
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 6;
	                            c[(c[j >> 2] | 0) + 292 >> 2] = 6;
	                            th(c[j >> 2] | 0, q, r);
	                            continue a;
	                            break
	                        }
	                        case 9:
	                        {
	                            if ((c[m >> 2] | 0) < 2) {
	                                Q = 407;
	                                break a
	                            }
	                            do if (!(c[k >> 2] | 0)) {
	                                if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0))if ((uh(c[j >> 2] | 0, 62, 0, 0) | 0) < 0) {
	                                    Q = 407;
	                                    break a
	                                } else break;
	                                if (!(c[r >> 2] | 0)) {
	                                    Q = 407;
	                                    break a
	                                }
	                                if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                                    Q = 407;
	                                    break a
	                                }
	                            } while (0);
	                            b = c[j >> 2] | 0;
	                            if (c[(c[j >> 2] | 0) + 324 >> 2] | 0) {
	                                ah(b, c[(c[(c[j >> 2] | 0) + 344 >> 2] | 0) + (((c[(c[j >> 2] | 0) + 188 >> 2] | 0) * 3 | 0) - 3 << 2) >> 2] | 0, c[(c[(c[j >> 2] | 0) + 344 >> 2] | 0) + (((c[(c[j >> 2] | 0) + 188 >> 2] | 0) * 3 | 0) - 2 << 2) >> 2] | 0, 0, c[(c[(c[j >> 2] | 0) + 344 >> 2] | 0) + (((c[(c[j >> 2] | 0) + 188 >> 2] | 0) * 3 | 0) - 1 << 2) >> 2] | 0, 0);
	                                wh(c[j >> 2] | 0) | 0
	                            } else Wg(b, 0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1)continue a;
	                            b = (c[j >> 2] | 0) + 172 | 0;
	                            if (!(c[(c[j >> 2] | 0) + 188 >> 2] | 0)) {
	                                c[b >> 2] = 14;
	                                continue a
	                            } else {
	                                c[b >> 2] = 7;
	                                continue a
	                            }
	                            break
	                        }
	                        case 8:
	                        {
	                            c[D >> 2] = uh(c[j >> 2] | 0, 93, 93, 62) | 0;
	                            if ((c[D >> 2] | 0) < 0) {
	                                Q = 207;
	                                break a
	                            }
	                            c[G >> 2] = xh(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[D >> 2] | 0) | 0;
	                            if ((c[G >> 2] | 0) < 0) {
	                                Q = 231;
	                                break a
	                            }
	                            if ((c[G >> 2] | 0) != (c[D >> 2] | 0)) {
	                                Q = 231;
	                                break a
	                            }
	                            if ((((c[D >> 2] | 0) == 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[j >> 2] >> 2] | 0) + 100 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                                if (((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) >= 9 ? (QT((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + -9 | 0, 70176, 9) | 0) == 0 : 0)Db[c[(c[c[j >> 2] >> 2] | 0) + 100 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, 65640, 0)
	                            } else Q = 238;
	                            do if (((Q | 0) == 238 ? (Q = 0, (c[D >> 2] | 0) > 0 ? (c[c[j >> 2] >> 2] | 0) != 0 : 0) : 0) ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                                b = c[c[j >> 2] >> 2] | 0;
	                                if (c[(c[c[j >> 2] >> 2] | 0) + 100 >> 2] | 0) {
	                                    Db[c[b + 100 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[D >> 2] | 0);
	                                    break
	                                }
	                                if (c[b + 68 >> 2] | 0)Db[c[(c[c[j >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[D >> 2] | 0)
	                            } while (0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                Q = 407;
	                                break a
	                            }
	                            c[H >> 2] = 0;
	                            while (1) {
	                                T = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                                if ((c[H >> 2] | 0) >= ((c[D >> 2] | 0) + 3 | 0))break;
	                                b = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                                if ((T | 0) == 10) {
	                                    e = b + 28 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                    c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                                } else {
	                                    e = b + 32 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                                }
	                                e = (c[j >> 2] | 0) + 200 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                c[H >> 2] = (c[H >> 2] | 0) + 1
	                            }
	                            if ((T | 0) == 37)We(c[j >> 2] | 0);
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[j >> 2] | 0) | 0;
	                            c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                            continue a;
	                            break
	                        }
	                        case 0:
	                        {
	                            e = c[m >> 2] | 0;
	                            if (!(c[(c[j >> 2] | 0) + 256 >> 2] | 0)) {
	                                if ((e | 0) < 4) {
	                                    Q = 407;
	                                    break a
	                                }
	                                a[u >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                                a[u + 1 >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                                a[u + 2 >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                                a[u + 3 >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                                c[v >> 2] = sd(u, 4) | 0;
	                                re(c[j >> 2] | 0, c[v >> 2] | 0) | 0;
	                                continue a
	                            }
	                            if ((e | 0) < 2) {
	                                Q = 407;
	                                break a
	                            }
	                            a[o >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[p >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if (!(d[o >> 0] | 0)) {
	                                Q = 30;
	                                break a
	                            }
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 63 : 0) {
	                                if ((c[m >> 2] | 0) < 5) {
	                                    Q = 39;
	                                    break a
	                                }
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 63, 62, 0) | 0) < 0 : 0) {
	                                    Q = 42;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)Ab[c[(c[c[j >> 2] >> 2] | 0) + 44 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, 136080);
	                                b:do if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 120) {
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 109)break;
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 108)break;
	                                    do if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 32) {
	                                        if (9 <= (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) <= 10 : 0)break;
	                                        if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 13)break b
	                                    } while (0);
	                                    c[l >> 2] = (c[l >> 2] | 0) + 5;
	                                    Of(c[j >> 2] | 0);
	                                    U = c[j >> 2] | 0;
	                                    if ((c[(c[j >> 2] | 0) + 84 >> 2] | 0) == 32) {
	                                        Q = 54;
	                                        break a
	                                    }
	                                    c[(c[j >> 2] | 0) + 28 >> 2] = c[(c[U + 36 >> 2] | 0) + 52 >> 2];
	                                    do if (!(c[(c[j >> 2] | 0) + 24 >> 2] | 0)) {
	                                        if (!(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0))break;
	                                        e = my(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0) | 0;
	                                        c[(c[j >> 2] | 0) + 24 >> 2] = e
	                                    } while (0);
	                                    do if (c[c[j >> 2] >> 2] | 0) {
	                                        if (!(c[(c[c[j >> 2] >> 2] | 0) + 48 >> 2] | 0))break;
	                                        if (c[(c[j >> 2] | 0) + 212 >> 2] | 0)break;
	                                        zb[c[(c[c[j >> 2] >> 2] | 0) + 48 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0)
	                                    } while (0);
	                                    c[(c[j >> 2] | 0) + 172 >> 2] = 1;
	                                    continue a
	                                } while (0);
	                                e = oy(68488) | 0;
	                                c[(c[j >> 2] | 0) + 20 >> 2] = e;
	                                do if (c[c[j >> 2] >> 2] | 0) {
	                                    if (!(c[(c[c[j >> 2] >> 2] | 0) + 48 >> 2] | 0))break;
	                                    if (c[(c[j >> 2] | 0) + 212 >> 2] | 0)break;
	                                    zb[c[(c[c[j >> 2] >> 2] | 0) + 48 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0)
	                                } while (0);
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 1;
	                                continue a
	                            }
	                            if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)Ab[c[(c[c[j >> 2] >> 2] | 0) + 44 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, 136080);
	                            e = oy(68488) | 0;
	                            c[(c[j >> 2] | 0) + 20 >> 2] = e;
	                            e = c[j >> 2] | 0;
	                            if (!(c[(c[j >> 2] | 0) + 20 >> 2] | 0)) {
	                                ie(e, 0);
	                                continue a
	                            }
	                            if (((c[e >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)zb[c[(c[c[j >> 2] >> 2] | 0) + 48 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 1;
	                            continue a;
	                            break
	                        }
	                        case 7:
	                        {
	                            if ((c[m >> 2] | 0) < 2 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                                Q = 407;
	                                break a
	                            }
	                            a[o >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[p >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            c[A >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                            c[B >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2];
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 47 : 0) {
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 9;
	                                continue a
	                            }
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 63 : 0) {
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 63, 62, 0) | 0) < 0 : 0) {
	                                    Q = 147;
	                                    break a
	                                }
	                                mf(c[j >> 2] | 0);
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1
	                            } else Q = 149;
	                            do if ((Q | 0) == 149) {
	                                Q = 0;
	                                if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) != 33 : 0) {
	                                    c[(c[j >> 2] | 0) + 172 >> 2] = 6;
	                                    continue a
	                                }
	                                if ((((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0) {
	                                    if ((c[m >> 2] | 0) < 4) {
	                                        Q = 407;
	                                        break a
	                                    }
	                                    e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + 4;
	                                    c[C >> 2] = uh(c[j >> 2] | 0, 45, 45, 62) | 0;
	                                    e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + -4;
	                                    V = c[j >> 2] | 0;
	                                    if ((c[k >> 2] | 0) == 0 & (c[C >> 2] | 0) < 0) {
	                                        Q = 158;
	                                        break a
	                                    }
	                                    kf(V);
	                                    c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                                    c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                    break
	                                }
	                                do if ((((d[o >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 91 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 67 : 0) {
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0 | 0) != 68)break;
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0 | 0) != 65)break;
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0 | 0) != 84)break;
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0 | 0) != 65)break;
	                                    if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0 | 0) != 91)break;
	                                    e = (c[j >> 2] | 0) + 200 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + 9;
	                                    e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + 9;
	                                    e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                                    c[e >> 2] = (c[e >> 2] | 0) + 9;
	                                    if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[j >> 2] | 0);
	                                    do if (!(d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                                        if ((ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                                        Ve(c[j >> 2] | 0) | 0
	                                    } while (0);
	                                    c[(c[j >> 2] | 0) + 172 >> 2] = 8;
	                                    continue a
	                                } while (0);
	                                if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 & (c[m >> 2] | 0) < 9 : 0) {
	                                    Q = 407;
	                                    break a
	                                }
	                                if ((d[o >> 0] | 0 | 0) == 38) {
	                                    if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 59, 0, 0) | 0) < 0 : 0) {
	                                        Q = 407;
	                                        break a
	                                    }
	                                    Df(c[j >> 2] | 0);
	                                    break
	                                }
	                                do if (!(((c[m >> 2] | 0) < 300 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) ^ 1 | (c[k >> 2] | 0) != 0)) {
	                                    if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0))if ((uh(c[j >> 2] | 0, 60, 0, 0) | 0) < 0) {
	                                        Q = 407;
	                                        break a
	                                    } else break;
	                                    if (!(c[q >> 2] | 0)) {
	                                        Q = 407;
	                                        break a
	                                    }
	                                    if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 > (c[q >> 2] | 0) >>> 0) {
	                                        Q = 407;
	                                        break a
	                                    }
	                                } while (0);
	                                c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                                hf(c[j >> 2] | 0, 0)
	                            } while (0);
	                            while (1) {
	                                if (d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)break;
	                                if ((c[(c[j >> 2] | 0) + 40 >> 2] | 0) <= 1)break;
	                                Ve(c[j >> 2] | 0) | 0
	                            }
	                            if ((c[B >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0))continue a;
	                            if ((c[A >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0))continue a;
	                            og(c[j >> 2] | 0, 1, 69472);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = -1;
	                            continue a;
	                            break
	                        }
	                        case 6:
	                        {
	                            c[x >> 2] = 0;
	                            c[y >> 2] = 0;
	                            c[z >> 2] = c[(c[j >> 2] | 0) + 328 >> 2];
	                            if ((c[m >> 2] | 0) < 2 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                                Q = 407;
	                                break a
	                            }
	                            a[o >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            if ((d[o >> 0] | 0 | 0) != 60) {
	                                Q = 81;
	                                break a
	                            }
	                            do if (!(c[k >> 2] | 0)) {
	                                if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0))if ((uh(c[j >> 2] | 0, 62, 0, 0) | 0) < 0) {
	                                    Q = 407;
	                                    break a
	                                } else break;
	                                if (!(c[r >> 2] | 0)) {
	                                    Q = 407;
	                                    break a
	                                }
	                                if ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                                    Q = 407;
	                                    break a
	                                }
	                            } while (0);
	                            e = c[j >> 2] | 0;
	                            do if (c[(c[j >> 2] | 0) + 236 >> 2] | 0) {
	                                b = c[j >> 2] | 0;
	                                if ((c[c[e + 232 >> 2] >> 2] | 0) == -2) {
	                                    Xg(b, -1) | 0;
	                                    break
	                                } else {
	                                    Xg(b, c[c[(c[j >> 2] | 0) + 232 >> 2] >> 2] | 0) | 0;
	                                    break
	                                }
	                            } else Xg(e, -1) | 0; while (0);
	                            e = c[j >> 2] | 0;
	                            if (c[(c[j >> 2] | 0) + 324 >> 2] | 0)c[w >> 2] = Yg(e, x, y, n) | 0; else c[w >> 2] = Hf(e) | 0;
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                Q = 407;
	                                break a
	                            }
	                            W = c[j >> 2] | 0;
	                            if (!(c[w >> 2] | 0)) {
	                                Q = 99;
	                                break a
	                            }
	                            do if (((c[W + 104 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                if (!(c[(c[j >> 2] | 0) + 52 >> 2] | 0))break;
	                                if ((c[(c[j >> 2] | 0) + 52 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0))break;
	                                e = an((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                b = (c[j >> 2] | 0) + 100 | 0;
	                                c[b >> 2] = c[b >> 2] & e
	                            } while (0);
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0) {
	                                e = (c[j >> 2] | 0) + 200 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 2;
	                                e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 2;
	                                e = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 2;
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[j >> 2] | 0);
	                                do if (!(d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                                    if ((ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0) > 0)break;
	                                    Ve(c[j >> 2] | 0) | 0
	                                } while (0);
	                                e = (c[c[j >> 2] >> 2] | 0) != 0;
	                                do if (c[(c[j >> 2] | 0) + 324 >> 2] | 0) {
	                                    do if (e) {
	                                        if (!(c[(c[c[j >> 2] >> 2] | 0) + 120 >> 2] | 0))break;
	                                        if (c[(c[j >> 2] | 0) + 212 >> 2] | 0)break;
	                                        Jb[c[(c[c[j >> 2] >> 2] | 0) + 120 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[w >> 2] | 0, c[x >> 2] | 0, c[y >> 2] | 0)
	                                    } while (0);
	                                    if (((c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] | 0) | 0) <= 0)break;
	                                    _g(c[j >> 2] | 0, (c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] | 0) | 0) | 0
	                                } else {
	                                    if (!e)break;
	                                    if (!(c[(c[c[j >> 2] >> 2] | 0) + 60 >> 2] | 0))break;
	                                    if (c[(c[j >> 2] | 0) + 212 >> 2] | 0)break;
	                                    Ab[c[(c[c[j >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[w >> 2] | 0)
	                                } while (0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                Zg(c[j >> 2] | 0) | 0;
	                                e = (c[j >> 2] | 0) + 172 | 0;
	                                if (!(c[(c[j >> 2] | 0) + 188 >> 2] | 0))c[e >> 2] = 14; else c[e >> 2] = 7;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                continue a
	                            }
	                            e = c[j >> 2] | 0;
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)me(e); else {
	                                pg(e, 73, 70136, c[w >> 2] | 0);
	                                Re(c[j >> 2] | 0) | 0;
	                                Zg(c[j >> 2] | 0) | 0
	                            }
	                            e = c[j >> 2] | 0;
	                            b = c[w >> 2] | 0;
	                            if (c[(c[j >> 2] | 0) + 324 >> 2] | 0)vh(e, b, c[x >> 2] | 0, c[y >> 2] | 0, (c[(c[j >> 2] | 0) + 328 >> 2] | 0) - (c[z >> 2] | 0) | 0) | 0; else Se(e, b) | 0;
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                            continue a;
	                            break
	                        }
	                        case 4:
	                        {
	                            Ue(c[j >> 2] | 0) | 0;
	                            b = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                            if (!(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0))c[m >> 2] = (c[b + 24 >> 2] | 0) - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)); else {
	                                e = _y(c[(c[b >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[m >> 2] = e - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))
	                            }
	                            if ((c[m >> 2] | 0) < 2) {
	                                Q = 407;
	                                break a
	                            }
	                            a[o >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[p >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 63 : 0) {
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 63, 62, 0) | 0) < 0 : 0) {
	                                    Q = 308;
	                                    break a
	                                }
	                                mf(c[j >> 2] | 0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 4;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                continue a
	                            }
	                            if ((((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0) {
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 45, 45, 62) | 0) < 0 : 0) {
	                                    Q = 317;
	                                    break a
	                                }
	                                kf(c[j >> 2] | 0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 4;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                continue a
	                            }
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 & (c[m >> 2] | 0) < 4 : 0) {
	                                Q = 407;
	                                break a
	                            }
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 6;
	                            if (!(c[(c[j >> 2] | 0) + 292 >> 2] | 0))c[(c[j >> 2] | 0) + 292 >> 2] = 6;
	                            th(c[j >> 2] | 0, q, r);
	                            continue a;
	                            break
	                        }
	                        case 14:
	                        {
	                            Ue(c[j >> 2] | 0) | 0;
	                            e = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                            if (!(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0))c[m >> 2] = (c[e + 24 >> 2] | 0) - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0)); else {
	                                b = _y(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[m >> 2] = b - ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))
	                            }
	                            if ((c[m >> 2] | 0) < 2) {
	                                Q = 407;
	                                break a
	                            }
	                            a[o >> 0] = a[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[p >> 0] = a[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 63 : 0) {
	                                if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 63, 62, 0) | 0) < 0 : 0) {
	                                    Q = 333;
	                                    break a
	                                }
	                                mf(c[j >> 2] | 0);
	                                if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                    Q = 407;
	                                    break a
	                                }
	                                c[(c[j >> 2] | 0) + 172 >> 2] = 14;
	                                c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                                continue a
	                            }
	                            if ((d[o >> 0] | 0 | 0) != 60) {
	                                Q = 345;
	                                break a
	                            }
	                            if ((d[p >> 0] | 0 | 0) != 33) {
	                                Q = 345;
	                                break a
	                            }
	                            if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 45) {
	                                Q = 345;
	                                break a
	                            }
	                            if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 45) {
	                                Q = 345;
	                                break a
	                            }
	                            if ((c[k >> 2] | 0) == 0 ? (uh(c[j >> 2] | 0, 45, 45, 62) | 0) < 0 : 0) {
	                                Q = 342;
	                                break a
	                            }
	                            kf(c[j >> 2] | 0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                Q = 407;
	                                break a
	                            }
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 14;
	                            c[(c[j >> 2] | 0) + 292 >> 2] = 1;
	                            continue a;
	                            break
	                        }
	                        case 3:
	                        {
	                            a[L >> 0] = 0;
	                            c[I >> 2] = (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                            if ((c[I >> 2] | 0) < 0) {
	                                Q = 351;
	                                break a
	                            }
	                            if ((c[(c[j >> 2] | 0) + 204 >> 2] | 0) > (c[I >> 2] | 0))c[I >> 2] = c[(c[j >> 2] | 0) + 204 >> 2];
	                            c[K >> 2] = Vy(c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                            c[M >> 2] = _y(c[(c[c[(c[j >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0;
	                            c:while (1) {
	                                if ((c[I >> 2] | 0) >>> 0 >= (c[M >> 2] | 0) >>> 0) {
	                                    Q = 389;
	                                    break a
	                                }
	                                d:do if (d[L >> 0] | 0) {
	                                    if ((d[(c[K >> 2] | 0) + (c[I >> 2] | 0) >> 0] | 0 | 0) == (d[L >> 0] | 0 | 0))a[L >> 0] = 0
	                                } else {
	                                    do if ((((d[L >> 0] | 0 | 0) == 0 ? (d[(c[K >> 2] | 0) + (c[I >> 2] | 0) >> 0] | 0 | 0) == 60 : 0) ? (c[N >> 2] = 0, ((c[I >> 2] | 0) + 4 | 0) >>> 0 < (c[M >> 2] | 0) >>> 0) : 0) ? (d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + 1) >> 0] | 0 | 0) == 33 : 0) {
	                                        if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + 2) >> 0] | 0 | 0) != 45)break;
	                                        if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + 3) >> 0] | 0 | 0) != 45)break;
	                                        e:while (1) {
	                                            if (((c[I >> 2] | 0) + 3 | 0) >>> 0 >= (c[M >> 2] | 0) >>> 0)break;
	                                            do if ((d[(c[K >> 2] | 0) + (c[I >> 2] | 0) >> 0] | 0 | 0) == 45) {
	                                                if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + 1) >> 0] | 0 | 0) != 45)break;
	                                                if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + 2) >> 0] | 0 | 0) == 62) {
	                                                    Q = 369;
	                                                    break e
	                                                }
	                                            } while (0);
	                                            c[I >> 2] = (c[I >> 2] | 0) + 1
	                                        }
	                                        if ((Q | 0) == 369) {
	                                            Q = 0;
	                                            c[N >> 2] = 1;
	                                            c[I >> 2] = (c[I >> 2] | 0) + 2
	                                        }
	                                        if (c[N >> 2] | 0)break d; else {
	                                            Q = 389;
	                                            break a
	                                        }
	                                    } while (0);
	                                    if ((d[(c[K >> 2] | 0) + (c[I >> 2] | 0) >> 0] | 0 | 0) == 34) {
	                                        a[L >> 0] = 34;
	                                        break
	                                    }
	                                    if ((d[(c[K >> 2] | 0) + (c[I >> 2] | 0) >> 0] | 0 | 0) == 39) {
	                                        a[L >> 0] = 39;
	                                        break
	                                    }
	                                    if ((d[(c[K >> 2] | 0) + (c[I >> 2] | 0) >> 0] | 0 | 0) == 93) {
	                                        if (((c[I >> 2] | 0) + 1 | 0) >>> 0 >= (c[M >> 2] | 0) >>> 0) {
	                                            Q = 389;
	                                            break a
	                                        }
	                                        if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + 1) >> 0] | 0 | 0) == 93) {
	                                            c[I >> 2] = (c[I >> 2] | 0) + 1;
	                                            break
	                                        }
	                                        c[J >> 2] = 1;
	                                        while (1) {
	                                            if (((c[I >> 2] | 0) + (c[J >> 2] | 0) | 0) >>> 0 >= (c[M >> 2] | 0) >>> 0) {
	                                                Q = 389;
	                                                break a
	                                            }
	                                            if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + (c[J >> 2] | 0)) >> 0] | 0 | 0) == 62)break c;
	                                            do if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + (c[J >> 2] | 0)) >> 0] | 0 | 0) != 32) {
	                                                if (9 <= (d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + (c[J >> 2] | 0)) >> 0] | 0 | 0) ? (d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + (c[J >> 2] | 0)) >> 0] | 0 | 0) <= 10 : 0)break;
	                                                if ((d[(c[K >> 2] | 0) + ((c[I >> 2] | 0) + (c[J >> 2] | 0)) >> 0] | 0 | 0) != 13)break d
	                                            } while (0);
	                                            c[J >> 2] = (c[J >> 2] | 0) + 1
	                                        }
	                                    }
	                                } while (0);
	                                c[I >> 2] = (c[I >> 2] | 0) + 1
	                            }
	                            c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                            bh(c[j >> 2] | 0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                Q = 407;
	                                break a
	                            }
	                            c[(c[j >> 2] | 0) + 216 >> 2] = 2;
	                            if (((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) ? (c[(c[c[j >> 2] >> 2] | 0) + 104 >> 2] | 0) != 0 : 0)Jb[c[(c[c[j >> 2] >> 2] | 0) + 104 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[j >> 2] | 0) + 220 >> 2] | 0, c[(c[j >> 2] | 0) + 228 >> 2] | 0, c[(c[j >> 2] | 0) + 224 >> 2] | 0);
	                            c[(c[j >> 2] | 0) + 216 >> 2] = 0;
	                            ch(c[j >> 2] | 0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                Q = 407;
	                                break a
	                            }
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 4;
	                            c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 5:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70192, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                            continue a;
	                            break
	                        }
	                        case 15:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70232, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 3;
	                            continue a;
	                            break
	                        }
	                        case 2:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70272, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                            continue a;
	                            break
	                        }
	                        case 10:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70312, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 3;
	                            continue a;
	                            break
	                        }
	                        case 11:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70360, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 7;
	                            continue a;
	                            break
	                        }
	                        case 12:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70408, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 6;
	                            continue a;
	                            break
	                        }
	                        case 13:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70456, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 6;
	                            continue a;
	                            break
	                        }
	                        case 16:
	                        {
	                            Db[c[135904 >> 2] & 511](c[33980] | 0, 70504, g);
	                            c[(c[j >> 2] | 0) + 172 >> 2] = 6;
	                            continue a;
	                            break
	                        }
	                        case -1:
	                        {
	                            Q = 407;
	                            break a;
	                            break
	                        }
	                        default:
	                            continue a
	                    } while (0)
	                }
	                switch (Q | 0) {
	                    case 10:
	                    {
	                        c[h >> 2] = 0;
	                        P = c[h >> 2] | 0;
	                        i = f;
	                        return P | 0
	                    }
	                    case 30:
	                    {
	                        if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)Ab[c[(c[c[j >> 2] >> 2] | 0) + 44 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, 136080);
	                        og(c[j >> 2] | 0, 4, 0);
	                        c[(c[j >> 2] | 0) + 172 >> 2] = -1;
	                        if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                            zb[c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0);
	                            Q = 407
	                        } else Q = 407;
	                        break
	                    }
	                    case 39:
	                    {
	                        c[h >> 2] = c[l >> 2];
	                        P = c[h >> 2] | 0;
	                        i = f;
	                        return P | 0
	                    }
	                    case 42:
	                    {
	                        c[h >> 2] = c[l >> 2];
	                        P = c[h >> 2] | 0;
	                        i = f;
	                        return P | 0
	                    }
	                    case 54:
	                    {
	                        c[U + 172 >> 2] = -1;
	                        c[h >> 2] = 0;
	                        P = c[h >> 2] | 0;
	                        i = f;
	                        return P | 0
	                    }
	                    case 81:
	                    {
	                        og(c[j >> 2] | 0, 4, 0);
	                        c[(c[j >> 2] | 0) + 172 >> 2] = -1;
	                        if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                            zb[c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0);
	                            Q = 407
	                        } else Q = 407;
	                        break
	                    }
	                    case 99:
	                    {
	                        Zg(W) | 0;
	                        c[(c[j >> 2] | 0) + 172 >> 2] = -1;
	                        if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                            zb[c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0);
	                            Q = 407
	                        } else Q = 407;
	                        break
	                    }
	                    case 147:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 2;
	                        Q = 407;
	                        break
	                    }
	                    case 158:
	                    {
	                        c[V + 292 >> 2] = 5;
	                        Q = 407;
	                        break
	                    }
	                    case 207:
	                    {
	                        if ((c[m >> 2] | 0) >= 302) {
	                            c[E >> 2] = xh(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, 300) | 0;
	                            if ((c[E >> 2] | 0) < 0) {
	                                c[E >> 2] = 0 - (c[E >> 2] | 0);
	                                V = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[V >> 2] = (c[V >> 2] | 0) + (c[E >> 2] | 0);
	                                Q = 408;
	                                break
	                            }
	                            do if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) {
	                                V = c[c[j >> 2] >> 2] | 0;
	                                if (c[(c[c[j >> 2] >> 2] | 0) + 100 >> 2] | 0) {
	                                    Db[c[V + 100 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[E >> 2] | 0);
	                                    break
	                                }
	                                if (c[V + 68 >> 2] | 0)Db[c[(c[c[j >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[E >> 2] | 0)
	                            } while (0);
	                            if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) != -1) {
	                                c[F >> 2] = 0;
	                                while (1) {
	                                    X = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                                    if ((c[F >> 2] | 0) >= (c[E >> 2] | 0))break;
	                                    V = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                                    if ((X | 0) == 10) {
	                                        W = V + 28 | 0;
	                                        c[W >> 2] = (c[W >> 2] | 0) + 1;
	                                        c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                                    } else {
	                                        W = V + 32 | 0;
	                                        c[W >> 2] = (c[W >> 2] | 0) + 1
	                                    }
	                                    W = (c[j >> 2] | 0) + 200 | 0;
	                                    c[W >> 2] = (c[W >> 2] | 0) + 1;
	                                    W = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                    c[W >> 2] = (c[W >> 2] | 0) + 1;
	                                    c[F >> 2] = (c[F >> 2] | 0) + 1
	                                }
	                                if ((X | 0) == 37)We(c[j >> 2] | 0);
	                                if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[j >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[j >> 2] | 0) | 0;
	                                c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                                Q = 407
	                            } else Q = 407
	                        } else Q = 407;
	                        break
	                    }
	                    case 231:
	                    {
	                        c[G >> 2] = 0 - (c[G >> 2] | 0);
	                        X = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[X >> 2] = (c[X >> 2] | 0) + (c[G >> 2] | 0);
	                        Q = 408;
	                        break
	                    }
	                    case 265:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 2;
	                        Q = 407;
	                        break
	                    }
	                    case 274:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 5;
	                        Q = 407;
	                        break
	                    }
	                    case 288:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 3;
	                        Q = 407;
	                        break
	                    }
	                    case 308:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 2;
	                        Q = 407;
	                        break
	                    }
	                    case 317:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 5;
	                        Q = 407;
	                        break
	                    }
	                    case 333:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 2;
	                        Q = 407;
	                        break
	                    }
	                    case 342:
	                    {
	                        c[(c[j >> 2] | 0) + 292 >> 2] = 5;
	                        Q = 407;
	                        break
	                    }
	                    case 345:
	                    {
	                        if ((d[o >> 0] | 0 | 0) == 60 ? (d[p >> 0] | 0 | 0) == 33 & (c[m >> 2] | 0) < 4 : 0) {
	                            Q = 407;
	                            break
	                        }
	                        og(c[j >> 2] | 0, 5, 0);
	                        c[(c[j >> 2] | 0) + 172 >> 2] = -1;
	                        if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                            zb[c[(c[c[j >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0);
	                            Q = 407
	                        } else Q = 407;
	                        break
	                    }
	                    case 351:
	                    {
	                        c[h >> 2] = 0;
	                        P = c[h >> 2] | 0;
	                        i = f;
	                        return P | 0
	                    }
	                    case 389:
	                    {
	                        if (!(d[L >> 0] | 0)) {
	                            c[(c[j >> 2] | 0) + 204 >> 2] = c[I >> 2];
	                            Q = 407;
	                            break
	                        } else {
	                            c[(c[j >> 2] | 0) + 204 >> 2] = 0;
	                            Q = 407;
	                            break
	                        }
	                        break
	                    }
	                }
	                if ((Q | 0) == 407) {
	                    c[h >> 2] = c[l >> 2];
	                    P = c[h >> 2] | 0;
	                    i = f;
	                    return P | 0
	                } else if ((Q | 0) == 408) {
	                    Q = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                    l = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                    I = d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                    c[g >> 2] = d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                    c[g + 4 >> 2] = Q;
	                    c[g + 8 >> 2] = l;
	                    c[g + 12 >> 2] = I;
	                    JT(O, 149, 70552, g) | 0;
	                    je(c[j >> 2] | 0, 9, 70592, O, 0);
	                    c[h >> 2] = 0;
	                    P = c[h >> 2] | 0;
	                    i = f;
	                    return P | 0
	                }
	                return 0
	            }

	            function eh(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) < 0)) {
	                    if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == 6)if (NT(c[h >> 2] | 0, 62, c[j >> 2] | 0) | 0) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 5)if (NT(c[h >> 2] | 0, 62, c[j >> 2] | 0) | 0) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == 8)if (NT(c[h >> 2] | 0, 62, c[j >> 2] | 0) | 0) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 2)if (NT(c[h >> 2] | 0, 62, c[j >> 2] | 0) | 0) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == 9)if (NT(c[h >> 2] | 0, 62, c[j >> 2] | 0) | 0) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) != 3 ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != 3 : 0) {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                    if (NT(c[h >> 2] | 0, 62, c[j >> 2] | 0) | 0) {
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                } else c[f >> 2] = -1; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function fh(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[o >> 2] = 0;
	                c[m >> 2] = Be() | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (c[l >> 2] | 0) {
	                    c[(c[m >> 2] | 0) + 360 >> 2] = c[(c[l >> 2] | 0) + 360 >> 2];
	                    c[(c[m >> 2] | 0) + 272 >> 2] = c[(c[l >> 2] | 0) + 272 >> 2]
	                }
	                c[p >> 2] = Hl(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[n >> 2] = Vk(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                    k = c[m >> 2] | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        Ae(k);
	                        c[g >> 2] = 0;
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                    Oe(k, c[n >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[o >> 2] = Rk(c[h >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[(c[m >> 2] | 0) + 180 >> 2] = c[o >> 2]
	                } else {
	                    c[n >> 2] = Vk(c[p >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        Ae(c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                    Oe(c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[o >> 2] = Rk(c[p >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 180 >> 2] | 0) == 0 : 0)c[(c[m >> 2] | 0) + 180 >> 2] = c[o >> 2];
	                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                }
	                c[g >> 2] = c[m >> 2];
	                q = c[g >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function gh(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (c[j >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                    d = my(c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 24 >> 2] = d
	                }
	                d = (c[g >> 2] | 0) + 288 | 0;
	                if (c[h >> 2] & 1) {
	                    c[d >> 2] = 1;
	                    c[h >> 2] = (c[h >> 2] | 0) - 1;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 1
	                } else c[d >> 2] = 0;
	                d = (c[g >> 2] | 0) + 276 | 0;
	                if (c[h >> 2] & 4) {
	                    c[d >> 2] = 2;
	                    c[h >> 2] = (c[h >> 2] | 0) - 4;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 4
	                } else c[d >> 2] = 0;
	                if (c[h >> 2] & 8) {
	                    d = (c[g >> 2] | 0) + 276 | 0;
	                    c[d >> 2] = c[d >> 2] | 4;
	                    c[h >> 2] = (c[h >> 2] | 0) - 8;
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 8
	                }
	                d = (c[g >> 2] | 0) + 16 | 0;
	                if (c[h >> 2] & 2) {
	                    c[d >> 2] = 1;
	                    c[h >> 2] = (c[h >> 2] | 0) - 2;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 2
	                } else c[d >> 2] = 0;
	                d = (c[g >> 2] | 0) + 268 | 0;
	                if (c[h >> 2] & 128) {
	                    c[d >> 2] = 1;
	                    c[h >> 2] = (c[h >> 2] | 0) - 128;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 128
	                } else c[d >> 2] = 0;
	                d = (c[g >> 2] | 0) + 208 | 0;
	                if (c[h >> 2] & 256) {
	                    c[d >> 2] = 0;
	                    c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] = 65;
	                    c[h >> 2] = (c[h >> 2] | 0) - 256;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 256
	                } else c[d >> 2] = 1;
	                d = (c[g >> 2] | 0) + 104 | 0;
	                if (c[h >> 2] & 16) {
	                    c[d >> 2] = 1;
	                    if (c[h >> 2] & 64)c[(c[g >> 2] | 0) + 116 >> 2] = 0;
	                    if (c[h >> 2] & 32)c[(c[g >> 2] | 0) + 112 >> 2] = 0;
	                    c[h >> 2] = (c[h >> 2] | 0) - 16;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 16
	                } else c[d >> 2] = 0;
	                if (c[h >> 2] & 64) {
	                    c[(c[c[g >> 2] >> 2] | 0) + 84 >> 2] = 0;
	                    c[h >> 2] = (c[h >> 2] | 0) - 64
	                }
	                if (c[h >> 2] & 32) {
	                    c[(c[c[g >> 2] >> 2] | 0) + 88 >> 2] = 0;
	                    c[(c[c[g >> 2] >> 2] | 0) + 92 >> 2] = 0;
	                    c[h >> 2] = (c[h >> 2] | 0) - 32
	                }
	                if (c[h >> 2] & 512) {
	                    c[(c[c[g >> 2] >> 2] | 0) + 56 >> 2] = 50;
	                    c[(c[c[g >> 2] >> 2] | 0) + 60 >> 2] = 51;
	                    c[(c[c[g >> 2] >> 2] | 0) + 116 >> 2] = 0;
	                    c[(c[c[g >> 2] >> 2] | 0) + 120 >> 2] = 0;
	                    c[(c[c[g >> 2] >> 2] | 0) + 108 >> 2] = 1;
	                    c[h >> 2] = (c[h >> 2] | 0) - 512;
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 512
	                }
	                d = (c[g >> 2] | 0) + 364 | 0;
	                if (c[h >> 2] & 4096) {
	                    c[d >> 2] = 0;
	                    c[h >> 2] = (c[h >> 2] | 0) - 4096;
	                    j = (c[g >> 2] | 0) + 360 | 0;
	                    c[j >> 2] = c[j >> 2] | 4096
	                } else c[d >> 2] = 1;
	                if (c[h >> 2] & 16384) {
	                    c[(c[c[g >> 2] >> 2] | 0) + 100 >> 2] = 0;
	                    c[h >> 2] = (c[h >> 2] | 0) - 16384;
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 16384
	                }
	                if (c[h >> 2] & 8192) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 8192;
	                    c[h >> 2] = (c[h >> 2] | 0) - 8192
	                }
	                if (c[h >> 2] & 2048) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 2048;
	                    c[h >> 2] = (c[h >> 2] | 0) - 2048
	                }
	                if (c[h >> 2] & 65536) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 65536;
	                    c[h >> 2] = (c[h >> 2] | 0) - 65536
	                }
	                if (c[h >> 2] & 131072) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 131072;
	                    c[h >> 2] = (c[h >> 2] | 0) - 131072
	                }
	                if (c[h >> 2] & 262144) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 262144;
	                    c[h >> 2] = (c[h >> 2] | 0) - 262144
	                }
	                do if (c[h >> 2] & 524288) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 524288;
	                    c[h >> 2] = (c[h >> 2] | 0) - 524288;
	                    if (!(c[(c[g >> 2] | 0) + 296 >> 2] | 0))break;
	                    DP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, 0) | 0
	                } while (0);
	                if (c[h >> 2] & 1048576) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 1048576;
	                    c[h >> 2] = (c[h >> 2] | 0) - 1048576
	                }
	                if (c[h >> 2] & 2097152) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 2097152;
	                    c[h >> 2] = (c[h >> 2] | 0) - 2097152
	                }
	                if (c[h >> 2] & 4194304) {
	                    d = (c[g >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = c[d >> 2] | 4194304;
	                    c[h >> 2] = (c[h >> 2] | 0) - 4194304
	                }
	                c[(c[g >> 2] | 0) + 280 >> 2] = 1;
	                c[f >> 2] = c[h >> 2];
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function hh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                b = c[g >> 2] | 0;
	                if ((c[h >> 2] | 0) == (c[(c[g >> 2] | 0) + 312 >> 2] | 0)) {
	                    c[f >> 2] = c[b + 320 >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = (c[b + 328 >> 2] | 0) - 2;
	                while (1) {
	                    if ((c[j >> 2] | 0) < 0) {
	                        l = 11;
	                        break
	                    }
	                    if ((c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) == (c[h >> 2] | 0))break;
	                    c[j >> 2] = (c[j >> 2] | 0) - 2
	                }
	                if ((l | 0) == 11) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((c[h >> 2] | 0) == 0 ? (d[c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + ((c[j >> 2] | 0) + 1 << 2) >> 2] >> 0] | 0 | 0) == 0 : 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[f >> 2] = c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + ((c[j >> 2] | 0) + 1 << 2) >> 2];
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function ih(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                a:do if (c[(c[g >> 2] | 0) + 360 >> 2] & 8192) {
	                    c[k >> 2] = (c[(c[g >> 2] | 0) + 328 >> 2] | 0) - 2;
	                    while (1) {
	                        if ((c[k >> 2] | 0) < 0)break a;
	                        m = c[k >> 2] | 0;
	                        if ((c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) == (c[h >> 2] | 0))break;
	                        c[k >> 2] = m - 2
	                    }
	                    if ((c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + (m + 1 << 2) >> 2] | 0) == (c[j >> 2] | 0)) {
	                        c[f >> 2] = -2;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                } while (0);
	                do if ((c[(c[g >> 2] | 0) + 332 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 336 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 328 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 332 >> 2] | 0)) {
	                        m = (c[g >> 2] | 0) + 332 | 0;
	                        c[m >> 2] = c[m >> 2] << 1;
	                        c[l >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 336 >> 2] | 0, c[(c[g >> 2] | 0) + 332 >> 2] << 2) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[(c[g >> 2] | 0) + 336 >> 2] = c[l >> 2];
	                            break
	                        }
	                        ie(c[g >> 2] | 0, 0);
	                        m = (c[g >> 2] | 0) + 332 | 0;
	                        c[m >> 2] = (c[m >> 2] | 0) / 2 | 0;
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                } else o = 10; while (0);
	                if ((o | 0) == 10 ? (c[(c[g >> 2] | 0) + 332 >> 2] = 10, c[(c[g >> 2] | 0) + 328 >> 2] = 0, o = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 332 >> 2] << 2) | 0, c[(c[g >> 2] | 0) + 336 >> 2] = o, (c[(c[g >> 2] | 0) + 336 >> 2] | 0) == 0) : 0) {
	                    ie(c[g >> 2] | 0, 0);
	                    c[(c[g >> 2] | 0) + 332 >> 2] = 0;
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                o = c[h >> 2] | 0;
	                h = (c[g >> 2] | 0) + 328 | 0;
	                l = c[h >> 2] | 0;
	                c[h >> 2] = l + 1;
	                c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + (l << 2) >> 2] = o;
	                o = c[j >> 2] | 0;
	                j = (c[g >> 2] | 0) + 328 | 0;
	                l = c[j >> 2] | 0;
	                c[j >> 2] = l + 1;
	                c[(c[(c[g >> 2] | 0) + 336 >> 2] | 0) + (l << 2) >> 2] = o;
	                c[f >> 2] = c[(c[g >> 2] | 0) + 328 >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function jh(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                gh(c[h >> 2] | 0, c[l >> 2] | 0, c[k >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) != 0 ? (c[o >> 2] = Dd(c[k >> 2] | 0) | 0, (c[o >> 2] | 0) != 0) : 0)se(c[h >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) {
	                    o = my(c[j >> 2] | 0) | 0;
	                    c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = o
	                }
	                Qf(c[h >> 2] | 0) | 0;
	                if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 288 >> 2] | 0) == 0 : 0) {
	                    c[n >> 2] = 0;
	                    if (c[(c[h >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[h >> 2] | 0) + 8 >> 2] | 0)
	                } else c[n >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                c[(c[h >> 2] | 0) + 8 >> 2] = 0;
	                if (c[m >> 2] | 0) {
	                    p = c[n >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                Ae(c[h >> 2] | 0);
	                p = c[n >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function kh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[g >> 2] | 0;
	                a:do if (!(c[(c[f >> 2] | 0) + 360 >> 2] & 131072)) {
	                    if ((b | 0) != 32 & (c[g >> 2] | 0) != 62 & (c[g >> 2] | 0) != 47) {
	                        if (((((((((((((!((c[g >> 2] | 0) >= 97 & (c[g >> 2] | 0) <= 122) ? !((c[g >> 2] | 0) >= 65 & (c[g >> 2] | 0) <= 90 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58) : 0) ? !((c[g >> 2] | 0) >= 192 & (c[g >> 2] | 0) <= 214) : 0) ? !((c[g >> 2] | 0) >= 216 & (c[g >> 2] | 0) <= 246) : 0) ? !((c[g >> 2] | 0) >= 248 & (c[g >> 2] | 0) <= 767) : 0) ? !((c[g >> 2] | 0) >= 880 & (c[g >> 2] | 0) <= 893) : 0) ? !((c[g >> 2] | 0) >= 895 & (c[g >> 2] | 0) <= 8191) : 0) ? !((c[g >> 2] | 0) >= 8204 & (c[g >> 2] | 0) <= 8205) : 0) ? !((c[g >> 2] | 0) >= 8304 & (c[g >> 2] | 0) <= 8591) : 0) ? !((c[g >> 2] | 0) >= 11264 & (c[g >> 2] | 0) <= 12271) : 0) ? !((c[g >> 2] | 0) >= 12289 & (c[g >> 2] | 0) <= 55295) : 0) ? !((c[g >> 2] | 0) >= 63744 & (c[g >> 2] | 0) <= 64975) : 0) ? !((c[g >> 2] | 0) >= 65008 & (c[g >> 2] | 0) <= 65533) : 0) ? !((c[g >> 2] | 0) >= 65536 & (c[g >> 2] | 0) <= 983039) : 0)break;
	                        c[e >> 2] = 1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                } else {
	                    a = c[g >> 2] | 0;
	                    if ((b | 0) < 256) {
	                        if (((!(65 <= (a | 0) & (c[g >> 2] | 0) <= 90) ? !(97 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 122) : 0) ? !(192 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 214) : 0) ? !(216 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 246 | 248 <= (c[g >> 2] | 0)) : 0)j = 24
	                    } else if (!(DQ(a, 199744) | 0))j = 24;
	                    do if ((j | 0) == 24) {
	                        a = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 256)if ((a | 0) == 95 | (c[g >> 2] | 0) == 58)break; else break a;
	                        if (!(19968 <= (a | 0) & (c[g >> 2] | 0) <= 40869 | (c[g >> 2] | 0) == 12295) ? !(12321 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 12329 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58) : 0)break a
	                    } while (0);
	                    c[e >> 2] = 1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function lh(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0;
	                g = i;
	                i = i + 144 | 0;
	                h = g + 136 | 0;
	                j = g + 132 | 0;
	                k = g + 128 | 0;
	                l = g + 124 | 0;
	                m = g + 140 | 0;
	                n = g + 120 | 0;
	                o = g + 116 | 0;
	                p = g + 112 | 0;
	                q = g + 108 | 0;
	                r = g + 104 | 0;
	                s = g + 100 | 0;
	                t = g + 96 | 0;
	                u = g + 92 | 0;
	                v = g + 88 | 0;
	                w = g + 84 | 0;
	                x = g + 80 | 0;
	                y = g + 76 | 0;
	                z = g + 72 | 0;
	                A = g + 68 | 0;
	                B = g + 64 | 0;
	                C = g + 60 | 0;
	                D = g + 56 | 0;
	                E = g + 52 | 0;
	                F = g + 48 | 0;
	                G = g + 44 | 0;
	                H = g + 40 | 0;
	                I = g + 36 | 0;
	                J = g + 32 | 0;
	                K = g + 28 | 0;
	                L = g + 24 | 0;
	                M = g + 20 | 0;
	                N = g + 16 | 0;
	                O = g + 12 | 0;
	                P = g + 8 | 0;
	                Q = g + 4 | 0;
	                R = g;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                a[m >> 0] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                f = c[j >> 2] | 0;
	                do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 34) {
	                    c[f + 172 >> 2] = 12;
	                    a[m >> 0] = 34;
	                    me(c[j >> 2] | 0)
	                } else {
	                    if ((d[c[(c[f + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 39) {
	                        a[m >> 0] = 39;
	                        c[(c[j >> 2] | 0) + 172 >> 2] = 12;
	                        me(c[j >> 2] | 0);
	                        break
	                    }
	                    og(c[j >> 2] | 0, 39, 0);
	                    c[h >> 2] = 0;
	                    S = c[h >> 2] | 0;
	                    i = g;
	                    return S | 0
	                } while (0);
	                c[q >> 2] = 100;
	                c[n >> 2] = Cb[c[135752 >> 2] & 511](c[q >> 2] | 0) | 0;
	                a:do if (c[n >> 2] | 0) {
	                    c[r >> 2] = ne(c[j >> 2] | 0, s) | 0;
	                    b:while (1) {
	                        if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == (d[m >> 0] | 0 | 0))break;
	                        f = c[r >> 2] | 0;
	                        do if ((c[r >> 2] | 0) < 256) {
	                            if (!((9 <= (f | 0) & (c[r >> 2] | 0) <= 10 | (c[r >> 2] | 0) == 13 | 32 <= (c[r >> 2] | 0)) & (c[r >> 2] | 0) != 60))break b
	                        } else {
	                            if (!(256 <= (f | 0) & (c[r >> 2] | 0) <= 55295) ? !(57344 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 65533) : 0)if (65536 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 1114111 & (c[r >> 2] | 0) != 60)break; else break b;
	                            if ((c[r >> 2] | 0) == 60)break b
	                        } while (0);
	                        if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                        if ((c[p >> 2] | 0) >>> 0 > 1e7 ? (c[(c[j >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            T = 18;
	                            break
	                        }
	                        if (!(c[r >> 2] | 0))break;
	                        do if ((c[r >> 2] | 0) == 38) {
	                            c[t >> 2] = 0;
	                            f = c[j >> 2] | 0;
	                            if ((d[(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35) {
	                                c[w >> 2] = Ye(f) | 0;
	                                if ((c[w >> 2] | 0) != 38) {
	                                    if (!(c[w >> 2] | 0))break;
	                                    if (((c[p >> 2] | 0) + 10 | 0) >>> 0 > (c[q >> 2] | 0) >>> 0) {
	                                        c[C >> 2] = (c[q >> 2] << 1) + 10;
	                                        if ((c[C >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[B >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[C >> 2] | 0) | 0;
	                                        if (!(c[B >> 2] | 0)) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[n >> 2] = c[B >> 2];
	                                        c[q >> 2] = c[C >> 2]
	                                    }
	                                    e = qe(0, (c[n >> 2] | 0) + (c[p >> 2] | 0) | 0, c[w >> 2] | 0) | 0;
	                                    c[p >> 2] = (c[p >> 2] | 0) + e;
	                                    break
	                                }
	                                e = ((c[p >> 2] | 0) + 10 | 0) >>> 0 > (c[q >> 2] | 0) >>> 0;
	                                if (c[(c[j >> 2] | 0) + 16 >> 2] | 0) {
	                                    if (e) {
	                                        c[y >> 2] = (c[q >> 2] << 1) + 10;
	                                        if ((c[y >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[x >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[y >> 2] | 0) | 0;
	                                        if (!(c[x >> 2] | 0)) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[n >> 2] = c[x >> 2];
	                                        c[q >> 2] = c[y >> 2]
	                                    }
	                                    b = c[p >> 2] | 0;
	                                    c[p >> 2] = b + 1;
	                                    a[(c[n >> 2] | 0) + b >> 0] = 38;
	                                    break
	                                } else {
	                                    if (e) {
	                                        c[A >> 2] = (c[q >> 2] << 1) + 10;
	                                        if ((c[A >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[z >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[A >> 2] | 0) | 0;
	                                        if (!(c[z >> 2] | 0)) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[n >> 2] = c[z >> 2];
	                                        c[q >> 2] = c[A >> 2]
	                                    }
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = 38;
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = 35;
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = 51;
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = 56;
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = 59;
	                                    break
	                                }
	                            }
	                            c[v >> 2] = Ef(f) | 0;
	                            f = (c[j >> 2] | 0) + 440 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + 1;
	                            if (c[v >> 2] | 0) {
	                                f = (c[j >> 2] | 0) + 440 | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + (c[(c[v >> 2] | 0) + 68 >> 2] | 0)
	                            }
	                            if ((c[v >> 2] | 0) != 0 ? (c[(c[v >> 2] | 0) + 48 >> 2] | 0) == 6 : 0) {
	                                if (((c[p >> 2] | 0) + 10 | 0) >>> 0 > (c[q >> 2] | 0) >>> 0) {
	                                    c[E >> 2] = (c[q >> 2] << 1) + 10;
	                                    if ((c[E >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[D >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[E >> 2] | 0) | 0;
	                                    if (!(c[D >> 2] | 0)) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[n >> 2] = c[D >> 2];
	                                    c[q >> 2] = c[E >> 2]
	                                }
	                                if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 0 ? (d[c[(c[v >> 2] | 0) + 40 >> 2] >> 0] | 0 | 0) == 38 : 0) {
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[(c[n >> 2] | 0) + f >> 0] = 38;
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[(c[n >> 2] | 0) + f >> 0] = 35;
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[(c[n >> 2] | 0) + f >> 0] = 51;
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[(c[n >> 2] | 0) + f >> 0] = 56;
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[(c[n >> 2] | 0) + f >> 0] = 59;
	                                    break
	                                }
	                                f = a[c[(c[v >> 2] | 0) + 40 >> 2] >> 0] | 0;
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[(c[n >> 2] | 0) + e >> 0] = f;
	                                break
	                            }
	                            if ((c[v >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                                if ((c[(c[v >> 2] | 0) + 48 >> 2] | 0) == 6) {
	                                    if (((c[p >> 2] | 0) + 10 | 0) >>> 0 > (c[q >> 2] | 0) >>> 0) {
	                                        c[I >> 2] = (c[q >> 2] << 1) + 10;
	                                        if ((c[I >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[H >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[I >> 2] | 0) | 0;
	                                        if (!(c[H >> 2] | 0)) {
	                                            T = 138;
	                                            break a
	                                        }
	                                        c[n >> 2] = c[H >> 2];
	                                        c[q >> 2] = c[I >> 2]
	                                    }
	                                    if (!(c[(c[v >> 2] | 0) + 40 >> 2] | 0))break;
	                                    f = a[c[(c[v >> 2] | 0) + 40 >> 2] >> 0] | 0;
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = f;
	                                    break
	                                }
	                                c[o >> 2] = af(c[j >> 2] | 0, c[(c[v >> 2] | 0) + 40 >> 2] | 0, 1, 0, 0, 0) | 0;
	                                if (!(c[o >> 2] | 0))break;
	                                c[u >> 2] = c[o >> 2];
	                                while (1) {
	                                    if (!(d[c[u >> 2] >> 0] | 0))break;
	                                    do if ((d[c[u >> 2] >> 0] | 0 | 0) == 13)T = 61; else {
	                                        if ((d[c[u >> 2] >> 0] | 0 | 0) == 10) {
	                                            T = 61;
	                                            break
	                                        }
	                                        if ((d[c[u >> 2] >> 0] | 0 | 0) == 9) {
	                                            T = 61;
	                                            break
	                                        }
	                                        f = c[u >> 2] | 0;
	                                        c[u >> 2] = f + 1;
	                                        e = a[f >> 0] | 0;
	                                        f = c[p >> 2] | 0;
	                                        c[p >> 2] = f + 1;
	                                        a[(c[n >> 2] | 0) + f >> 0] = e
	                                    } while (0);
	                                    if ((T | 0) == 61) {
	                                        T = 0;
	                                        e = c[p >> 2] | 0;
	                                        c[p >> 2] = e + 1;
	                                        a[(c[n >> 2] | 0) + e >> 0] = 32;
	                                        c[u >> 2] = (c[u >> 2] | 0) + 1
	                                    }
	                                    if (((c[p >> 2] | 0) + 10 | 0) >>> 0 <= (c[q >> 2] | 0) >>> 0)continue;
	                                    c[G >> 2] = (c[q >> 2] << 1) + 10;
	                                    if ((c[G >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[F >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[G >> 2] | 0) | 0;
	                                    if (!(c[F >> 2] | 0)) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[n >> 2] = c[F >> 2];
	                                    c[q >> 2] = c[G >> 2]
	                                }
	                                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                c[o >> 2] = 0;
	                                break
	                            }
	                            if (c[v >> 2] | 0) {
	                                c[J >> 2] = xy(c[(c[v >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[K >> 2] = c[(c[v >> 2] | 0) + 8 >> 2];
	                                do if (((c[(c[v >> 2] | 0) + 48 >> 2] | 0) != 6 ? (c[(c[v >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[v >> 2] | 0) + 72 >> 2] | 0) == 0 : 0) {
	                                    c[L >> 2] = c[(c[j >> 2] | 0) + 440 >> 2];
	                                    c[o >> 2] = af(c[j >> 2] | 0, c[(c[v >> 2] | 0) + 40 >> 2] | 0, 1, 0, 0, 0) | 0;
	                                    c[(c[v >> 2] | 0) + 72 >> 2] = (c[(c[j >> 2] | 0) + 440 >> 2] | 0) - (c[L >> 2] | 0) + 1 << 1;
	                                    if (!(c[o >> 2] | 0))break;
	                                    if (vy(c[o >> 2] | 0, 60) | 0) {
	                                        e = (c[v >> 2] | 0) + 72 | 0;
	                                        c[e >> 2] = c[e >> 2] | 1
	                                    }
	                                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                    c[o >> 2] = 0
	                                } while (0);
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[(c[n >> 2] | 0) + e >> 0] = 38;
	                                while (1) {
	                                    if (((c[p >> 2] | 0) + (c[J >> 2] | 0) + 10 | 0) >>> 0 <= (c[q >> 2] | 0) >>> 0)break;
	                                    c[N >> 2] = (c[q >> 2] << 1) + (c[J >> 2] | 0) + 10;
	                                    if ((c[N >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[M >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[N >> 2] | 0) | 0;
	                                    if (!(c[M >> 2] | 0)) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[n >> 2] = c[M >> 2];
	                                    c[q >> 2] = c[N >> 2]
	                                }
	                                while (1) {
	                                    if ((c[J >> 2] | 0) <= 0)break;
	                                    e = c[K >> 2] | 0;
	                                    c[K >> 2] = e + 1;
	                                    f = a[e >> 0] | 0;
	                                    e = c[p >> 2] | 0;
	                                    c[p >> 2] = e + 1;
	                                    a[(c[n >> 2] | 0) + e >> 0] = f;
	                                    c[J >> 2] = (c[J >> 2] | 0) + -1
	                                }
	                                f = c[p >> 2] | 0;
	                                c[p >> 2] = f + 1;
	                                a[(c[n >> 2] | 0) + f >> 0] = 59
	                            }
	                        } else {
	                            if ((c[r >> 2] | 0) == 32 | (c[r >> 2] | 0) == 13 | (c[r >> 2] | 0) == 10 | (c[r >> 2] | 0) == 9) {
	                                if (!((c[p >> 2] | 0) == 0 & (c[l >> 2] | 0) != 0)) {
	                                    c:do if (!((c[l >> 2] | 0) != 0 & (c[t >> 2] | 0) != 0)) {
	                                        f = c[p >> 2] | 0;
	                                        if ((c[s >> 2] | 0) == 1) {
	                                            c[p >> 2] = f + 1;
	                                            a[(c[n >> 2] | 0) + f >> 0] = 32
	                                        } else {
	                                            e = pe((c[n >> 2] | 0) + f | 0, 32) | 0;
	                                            c[p >> 2] = (c[p >> 2] | 0) + e
	                                        }
	                                        while (1) {
	                                            if (((c[p >> 2] | 0) + 10 | 0) >>> 0 <= (c[q >> 2] | 0) >>> 0)break c;
	                                            c[P >> 2] = (c[q >> 2] << 1) + 10;
	                                            if ((c[P >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                                T = 138;
	                                                break a
	                                            }
	                                            c[O >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[P >> 2] | 0) | 0;
	                                            if (!(c[O >> 2] | 0)) {
	                                                T = 138;
	                                                break a
	                                            }
	                                            c[n >> 2] = c[O >> 2];
	                                            c[q >> 2] = c[P >> 2]
	                                        }
	                                    } while (0);
	                                    c[t >> 2] = 1
	                                }
	                            } else {
	                                c[t >> 2] = 0;
	                                if ((c[s >> 2] | 0) == 1) {
	                                    e = c[r >> 2] & 255;
	                                    f = c[p >> 2] | 0;
	                                    c[p >> 2] = f + 1;
	                                    a[(c[n >> 2] | 0) + f >> 0] = e
	                                } else {
	                                    e = pe((c[n >> 2] | 0) + (c[p >> 2] | 0) | 0, c[r >> 2] | 0) | 0;
	                                    c[p >> 2] = (c[p >> 2] | 0) + e
	                                }
	                                if (((c[p >> 2] | 0) + 10 | 0) >>> 0 > (c[q >> 2] | 0) >>> 0) {
	                                    c[R >> 2] = (c[q >> 2] << 1) + 10;
	                                    if ((c[R >> 2] | 0) >>> 0 < (c[q >> 2] | 0) >>> 0) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[Q >> 2] = Hb[c[135760 >> 2] & 511](c[n >> 2] | 0, c[R >> 2] | 0) | 0;
	                                    if (!(c[Q >> 2] | 0)) {
	                                        T = 138;
	                                        break a
	                                    }
	                                    c[n >> 2] = c[Q >> 2];
	                                    c[q >> 2] = c[R >> 2]
	                                }
	                            }
	                            e = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                                f = e + 28 | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                                c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                            } else {
	                                f = e + 32 | 0;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                            f = (c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + (c[s >> 2] | 0);
	                            if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[j >> 2] | 0)
	                        } while (0);
	                        if ((c[(c[j >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[j >> 2] | 0);
	                        c[r >> 2] = ne(c[j >> 2] | 0, s) | 0
	                    }
	                    if ((T | 0) == 18) {
	                        xg(c[j >> 2] | 0, 40, 71720);
	                        T = 138;
	                        break
	                    }
	                    if ((c[(c[j >> 2] | 0) + 172 >> 2] | 0) != -1) {
	                        d:do if ((c[t >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0 & (c[p >> 2] | 0) >>> 0 > 0)do {
	                            if ((d[(c[n >> 2] | 0) + ((c[p >> 2] | 0) - 1) >> 0] | 0 | 0) != 32)break d;
	                            c[p >> 2] = (c[p >> 2] | 0) + -1
	                        } while ((c[p >> 2] | 0) >>> 0 > 0); while (0);
	                        a[(c[n >> 2] | 0) + (c[p >> 2] | 0) >> 0] = 0;
	                        f = c[j >> 2] | 0;
	                        e:do if ((d[c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60)og(f, 38, 0); else {
	                            if ((d[c[(c[f + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == (d[m >> 0] | 0 | 0)) {
	                                me(c[j >> 2] | 0);
	                                break
	                            }
	                            do if (c[r >> 2] | 0) {
	                                e = c[r >> 2] | 0;
	                                if ((c[r >> 2] | 0) < 256) {
	                                    if (9 <= (e | 0) & (c[r >> 2] | 0) <= 10 | (c[r >> 2] | 0) == 13 | 32 <= (c[r >> 2] | 0))break
	                                } else {
	                                    if (256 <= (e | 0) & (c[r >> 2] | 0) <= 55295)break;
	                                    if (57344 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 65533)break;
	                                    if (65536 <= (c[r >> 2] | 0) & (c[r >> 2] | 0) <= 1114111)break
	                                }
	                                xg(c[j >> 2] | 0, 9, 71752);
	                                break e
	                            } while (0);
	                            xg(c[j >> 2] | 0, 40, 71792)
	                        } while (0);
	                        if ((c[p >> 2] | 0) >>> 0 >= 2147483647) {
	                            xg(c[j >> 2] | 0, 40, 71720);
	                            T = 138;
	                            break
	                        }
	                        if (c[k >> 2] | 0)c[c[k >> 2] >> 2] = c[p >> 2];
	                        c[h >> 2] = c[n >> 2];
	                        S = c[h >> 2] | 0;
	                        i = g;
	                        return S | 0
	                    }
	                } else T = 138; while (0);
	                if ((T | 0) == 138)ie(c[j >> 2] | 0, 0);
	                if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                c[h >> 2] = 0;
	                S = c[h >> 2] | 0;
	                i = g;
	                return S | 0
	            }

	            function mh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[h >> 2];
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                if ((c[(c[g >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    if (!(d[c[k >> 2] >> 0] | 0))break;
	                    if ((d[c[k >> 2] >> 0] | 0 | 0) != (d[c[j >> 2] >> 0] | 0 | 0))break;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    b = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                a:do if (!(d[c[j >> 2] >> 0] | 0)) {
	                    do if ((d[c[k >> 2] >> 0] | 0 | 0) != 62 ? (d[c[k >> 2] >> 0] | 0 | 0) != 32 : 0) {
	                        if (9 <= (d[c[k >> 2] >> 0] | 0 | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[k >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[l >> 2] = Ze(c[g >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) == (c[h >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = c[l >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function nh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[g >> 2] | 0);
	                c[j >> 2] = yh(c[g >> 2] | 0) | 0;
	                b = (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 58;
	                if (!(c[j >> 2] | 0)) {
	                    if (b ? (c[j >> 2] = Ze(c[g >> 2] | 0) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        Jg(c[g >> 2] | 0, 202, 70824, c[j >> 2] | 0, 0, 0);
	                        c[c[h >> 2] >> 2] = 0;
	                        c[f >> 2] = c[j >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                do if (b) {
	                    me(c[g >> 2] | 0);
	                    c[k >> 2] = c[j >> 2];
	                    c[j >> 2] = yh(c[g >> 2] | 0) | 0;
	                    a = c[g >> 2] | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        Jg(a, 202, 70856, c[k >> 2] | 0, 0, 0);
	                        c[j >> 2] = cf(c[g >> 2] | 0) | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Bh(65640, c[k >> 2] | 0, 0, 0) | 0; else {
	                            c[l >> 2] = Bh(c[j >> 2] | 0, c[k >> 2] | 0, 0, 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0)
	                        }
	                        c[k >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, c[l >> 2] | 0, -1) | 0;
	                        if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[c[h >> 2] >> 2] = 0;
	                        c[f >> 2] = c[k >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 58) {
	                        c[c[h >> 2] >> 2] = c[k >> 2];
	                        break
	                    }
	                    Jg(c[g >> 2] | 0, 202, 70888, c[k >> 2] | 0, c[j >> 2] | 0, 0);
	                    me(c[g >> 2] | 0);
	                    c[m >> 2] = Ze(c[g >> 2] | 0) | 0;
	                    if (c[m >> 2] | 0) {
	                        c[m >> 2] = Bh(c[m >> 2] | 0, c[j >> 2] | 0, 0, 0) | 0;
	                        c[j >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, c[m >> 2] | 0, -1) | 0;
	                        if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[c[h >> 2] >> 2] = c[k >> 2];
	                        c[f >> 2] = c[j >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else {
	                        c[m >> 2] = Bh(65640, c[j >> 2] | 0, 0, 0) | 0;
	                        c[j >> 2] = AP(c[(c[g >> 2] | 0) + 296 >> 2] | 0, c[m >> 2] | 0, -1) | 0;
	                        if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[c[h >> 2] >> 2] = c[k >> 2];
	                        c[f >> 2] = c[j >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                } else c[c[h >> 2] >> 2] = 0; while (0);
	                c[f >> 2] = c[j >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function oh(a, b, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                k = i;
	                i = i + 64 | 0;
	                l = k + 52 | 0;
	                m = k + 48 | 0;
	                n = k + 44 | 0;
	                o = k + 40 | 0;
	                p = k + 36 | 0;
	                q = k + 32 | 0;
	                r = k + 28 | 0;
	                s = k + 24 | 0;
	                t = k + 20 | 0;
	                u = k + 16 | 0;
	                v = k + 12 | 0;
	                w = k + 8 | 0;
	                x = k + 4 | 0;
	                y = k;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = j;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[c[q >> 2] >> 2] = 0;
	                if ((c[(c[m >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[m >> 2] | 0);
	                c[t >> 2] = nh(c[m >> 2] | 0, c[p >> 2] | 0) | 0;
	                j = c[m >> 2] | 0;
	                if (!(c[t >> 2] | 0)) {
	                    xg(j, 68, 69032);
	                    c[l >> 2] = 0;
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                }
	                if ((c[j + 352 >> 2] | 0) != 0 ? (c[x >> 2] = Vj(c[(c[m >> 2] | 0) + 352 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[c[p >> 2] >> 2] | 0, c[t >> 2] | 0) | 0, (c[x >> 2] | 0) != 0) : 0)c[w >> 2] = 1;
	                Ue(c[m >> 2] | 0) | 0;
	                x = c[m >> 2] | 0;
	                if ((d[c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 61) {
	                    pg(x, 41, 69064, c[t >> 2] | 0);
	                    c[l >> 2] = 0;
	                    z = c[l >> 2] | 0;
	                    i = k;
	                    return z | 0
	                }
	                me(x);
	                Ue(c[m >> 2] | 0) | 0;
	                c[u >> 2] = Eg(c[m >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, c[w >> 2] | 0) | 0;
	                if ((((c[w >> 2] | 0) != 0 ? (c[c[s >> 2] >> 2] | 0) != 0 : 0) ? (c[y >> 2] = zh(c[m >> 2] | 0, c[u >> 2] | 0, c[r >> 2] | 0) | 0, (c[y >> 2] | 0) != 0) : 0) ? (c[y >> 2] | 0) != (c[u >> 2] | 0) : 0) {
	                    zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                    c[u >> 2] = c[y >> 2]
	                }
	                c[(c[m >> 2] | 0) + 172 >> 2] = 7;
	                if ((c[c[p >> 2] >> 2] | 0) == (c[(c[m >> 2] | 0) + 312 >> 2] | 0)) {
	                    if (((c[(c[m >> 2] | 0) + 268 >> 2] | 0) != 0 ? (qy(c[t >> 2] | 0, 71704) | 0) != 0 : 0) ? (c[v >> 2] = ly(c[u >> 2] | 0, c[c[r >> 2] >> 2] | 0) | 0, (Ne(c[v >> 2] | 0) | 0) == 0) : 0)rg(c[m >> 2] | 0, 98, 69128, c[v >> 2] | 0, 0);
	                    do if (qy(c[t >> 2] | 0, 71712) | 0) {
	                        c[v >> 2] = ly(c[u >> 2] | 0, c[c[r >> 2] >> 2] | 0) | 0;
	                        if (qy(c[v >> 2] | 0, 69184) | 0) {
	                            c[c[(c[m >> 2] | 0) + 232 >> 2] >> 2] = 0;
	                            break
	                        }
	                        p = (qy(c[v >> 2] | 0, 69192) | 0) != 0;
	                        y = c[m >> 2] | 0;
	                        if (p) {
	                            c[c[y + 232 >> 2] >> 2] = 1;
	                            break
	                        } else {
	                            rg(y, 102, 69208, c[v >> 2] | 0, 0);
	                            break
	                        }
	                    } while (0);
	                    if (c[v >> 2] | 0)zb[c[135736 >> 2] & 511](c[v >> 2] | 0)
	                }
	                c[c[q >> 2] >> 2] = c[u >> 2];
	                c[l >> 2] = c[t >> 2];
	                z = c[l >> 2] | 0;
	                i = k;
	                return z | 0
	            }

	            function ph(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = h;
	                    return
	                }
	                g = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                f = c[o >> 2] | 0;
	                e = c[p >> 2] | 0;
	                d = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                o = c[p >> 2] | 0;
	                c[j >> 2] = c[n >> 2];
	                c[j + 4 >> 2] = m;
	                c[j + 8 >> 2] = o;
	                Xd(0, 0, 0, g, 0, 3, k, 1, 0, 0, l, f, e, 0, 0, d, j);
	                i = h;
	                return
	            }

	            function qh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[(c[f >> 2] | 0) + 300 >> 2] | 0)) {
	                    c[k >> 2] = 55;
	                    c[h >> 2] = Cb[c[135744 >> 2] & 511](c[k >> 2] << 2) | 0;
	                    if ((c[h >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 300 >> 2] = c[h >> 2], c[j >> 2] = Cb[c[135744 >> 2] & 511](((c[k >> 2] | 0) / 5 | 0) << 2) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        c[(c[f >> 2] | 0) + 340 >> 2] = c[j >> 2];
	                        c[(c[f >> 2] | 0) + 304 >> 2] = c[k >> 2];
	                        l = 9
	                    } else l = 10
	                } else if (((c[g >> 2] | 0) + 5 | 0) > (c[(c[f >> 2] | 0) + 304 >> 2] | 0)) {
	                    c[k >> 2] = (c[g >> 2] | 0) + 5 << 1;
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 300 >> 2] | 0, c[k >> 2] << 2) | 0;
	                    if ((c[h >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 300 >> 2] = c[h >> 2], c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 340 >> 2] | 0, ((c[k >> 2] | 0) / 5 | 0) << 2) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        c[(c[f >> 2] | 0) + 340 >> 2] = c[j >> 2];
	                        c[(c[f >> 2] | 0) + 304 >> 2] = c[k >> 2];
	                        l = 9
	                    } else l = 10
	                } else l = 9;
	                if ((l | 0) == 9) {
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 304 >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((l | 0) == 10) {
	                    ie(c[f >> 2] | 0, 0);
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function rh(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                e = c[h >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = mh(e, c[j >> 2] | 0) | 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((c[e + 292 >> 2] | 0) == 0 ? ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[h >> 2] | 0);
	                c[m >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[l >> 2] = c[k >> 2];
	                while (1) {
	                    if (!(d[c[m >> 2] >> 0] | 0))break;
	                    if ((d[c[m >> 2] >> 0] | 0 | 0) != (d[c[l >> 2] >> 0] | 0 | 0))break;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                a:do if ((d[c[l >> 2] >> 0] | 0 | 0) == 0 ? (d[c[m >> 2] >> 0] | 0 | 0) == 58 : 0) {
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[l >> 2] = c[j >> 2];
	                    while (1) {
	                        if (!(d[c[m >> 2] >> 0] | 0))break;
	                        if ((d[c[m >> 2] >> 0] | 0 | 0) != (d[c[l >> 2] >> 0] | 0 | 0))break;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                    if (!(d[c[l >> 2] >> 0] | 0)) {
	                        do if ((d[c[m >> 2] >> 0] | 0 | 0) != 62 ? (d[c[m >> 2] >> 0] | 0 | 0) != 32 : 0) {
	                            if (9 <= (d[c[m >> 2] >> 0] | 0 | 0) ? (d[c[m >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[m >> 2] >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                        c[g >> 2] = 1;
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                } while (0);
	                c[n >> 2] = nh(c[h >> 2] | 0, o) | 0;
	                if ((c[n >> 2] | 0) == (c[j >> 2] | 0) ? (c[k >> 2] | 0) == (c[o >> 2] | 0) : 0) {
	                    c[g >> 2] = 1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[g >> 2] = c[n >> 2];
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function sh(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g + 8 | 0;
	                m = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[g + 4 >> 2] = f;
	                c[m >> 2] = c[j >> 2];
	                if ((c[h >> 2] | 0) != 1) {
	                    i = g;
	                    return
	                }
	                ck(c[(c[m >> 2] | 0) + 352 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                i = g;
	                return
	            }

	            function th(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 70648, f);
	                    i = f;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                    c[k >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2];
	                    c[k >> 2] = (c[k >> 2] | 0) + -1;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >>> 0 >= (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) >>> 0)l = (d[c[k >> 2] >> 0] | 0 | 0) != 60; else l = 0;
	                        m = c[k >> 2] | 0;
	                        if (!l)break;
	                        c[k >> 2] = m + -1
	                    }
	                    if (m >>> 0 < (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) >>> 0) {
	                        c[c[h >> 2] >> 2] = 0;
	                        c[c[j >> 2] >> 2] = 0;
	                        i = f;
	                        return
	                    }
	                    c[c[h >> 2] >> 2] = c[k >> 2];
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >>> 0 < (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0)n = (d[c[k >> 2] >> 0] | 0 | 0) != 62; else n = 0;
	                        o = c[k >> 2] | 0;
	                        if (!n)break;
	                        m = c[k >> 2] | 0;
	                        if ((d[o >> 0] | 0 | 0) == 39) {
	                            c[k >> 2] = m + 1;
	                            while (1) {
	                                if ((c[k >> 2] | 0) >>> 0 < (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0)p = (d[c[k >> 2] >> 0] | 0 | 0) != 39; else p = 0;
	                                q = c[k >> 2] | 0;
	                                if (!p)break;
	                                c[k >> 2] = q + 1
	                            }
	                            if (q >>> 0 >= (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0)continue;
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            continue
	                        } else {
	                            l = (d[m >> 0] | 0 | 0) == 34;
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            if (!l)continue;
	                            while (1) {
	                                if ((c[k >> 2] | 0) >>> 0 < (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0)r = (d[c[k >> 2] >> 0] | 0 | 0) != 34; else r = 0;
	                                s = c[k >> 2] | 0;
	                                if (!r)break;
	                                c[k >> 2] = s + 1
	                            }
	                            if (s >>> 0 >= (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0)continue;
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            continue
	                        }
	                    }
	                    if (o >>> 0 < (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) >>> 0) {
	                        c[c[j >> 2] >> 2] = c[k >> 2];
	                        i = f;
	                        return
	                    }
	                    c[k >> 2] = c[c[h >> 2] >> 2];
	                    c[k >> 2] = (c[k >> 2] | 0) + -1;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >>> 0 >= (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) >>> 0)t = (d[c[k >> 2] >> 0] | 0 | 0) != 62; else t = 0;
	                        u = c[k >> 2] | 0;
	                        if (!t)break;
	                        c[k >> 2] = u + -1
	                    }
	                    if (u >>> 0 >= (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) >>> 0) {
	                        c[c[j >> 2] >> 2] = c[k >> 2];
	                        i = f;
	                        return
	                    } else {
	                        c[c[j >> 2] >> 2] = 0;
	                        i = f;
	                        return
	                    }
	                }
	                c[c[h >> 2] >> 2] = 0;
	                c[c[j >> 2] >> 2] = 0;
	                i = f;
	                return
	            }

	            function uh(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 26 | 0;
	                m = h + 25 | 0;
	                n = h + 24 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[k >> 2] = b;
	                a[l >> 0] = e;
	                a[m >> 0] = f;
	                a[n >> 0] = g;
	                c[q >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                if (!(c[q >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[o >> 2] = (c[(c[q >> 2] | 0) + 16 >> 2] | 0) - (c[(c[q >> 2] | 0) + 12 >> 2] | 0);
	                if ((c[o >> 2] | 0) < 0) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                if ((c[(c[k >> 2] | 0) + 204 >> 2] | 0) > (c[o >> 2] | 0))c[o >> 2] = c[(c[k >> 2] | 0) + 204 >> 2];
	                g = c[q >> 2] | 0;
	                if (!(c[c[q >> 2] >> 2] | 0)) {
	                    c[r >> 2] = c[g + 12 >> 2];
	                    c[p >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                } else {
	                    c[r >> 2] = Vy(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    c[p >> 2] = _y(c[(c[c[q >> 2] >> 2] | 0) + 16 >> 2] | 0) | 0
	                }
	                if (!(a[n >> 0] | 0)) {
	                    if (a[m >> 0] | 0)c[p >> 2] = (c[p >> 2] | 0) + -1
	                } else c[p >> 2] = (c[p >> 2] | 0) - 2;
	                a:while (1) {
	                    t = c[o >> 2] | 0;
	                    if ((c[o >> 2] | 0) >= (c[p >> 2] | 0)) {
	                        u = 23;
	                        break
	                    }
	                    do if ((d[(c[r >> 2] | 0) + t >> 0] | 0) == (d[l >> 0] | 0))if (d[n >> 0] | 0) {
	                        if ((d[(c[r >> 2] | 0) + ((c[o >> 2] | 0) + 1) >> 0] | 0) != (d[m >> 0] | 0))break;
	                        if ((d[(c[r >> 2] | 0) + ((c[o >> 2] | 0) + 2) >> 0] | 0) != (d[n >> 0] | 0))break; else {
	                            u = 21;
	                            break a
	                        }
	                    } else {
	                        if (!(d[m >> 0] | 0)) {
	                            u = 21;
	                            break a
	                        }
	                        if ((d[(c[r >> 2] | 0) + ((c[o >> 2] | 0) + 1) >> 0] | 0) != (d[m >> 0] | 0))break; else {
	                            u = 21;
	                            break a
	                        }
	                    } while (0);
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                if ((u | 0) == 21) {
	                    c[(c[k >> 2] | 0) + 204 >> 2] = 0;
	                    c[j >> 2] = (c[o >> 2] | 0) - ((c[(c[q >> 2] | 0) + 16 >> 2] | 0) - (c[(c[q >> 2] | 0) + 12 >> 2] | 0));
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else if ((u | 0) == 23) {
	                    c[(c[k >> 2] | 0) + 204 >> 2] = t;
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                return 0
	            }

	            function vh(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 4 | 0;
	                p = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                a:do if ((c[(c[j >> 2] | 0) + 188 >> 2] | 0) >= (c[(c[j >> 2] | 0) + 192 >> 2] | 0)) {
	                    f = (c[j >> 2] | 0) + 192 | 0;
	                    c[f >> 2] = c[f >> 2] << 1;
	                    c[o >> 2] = Hb[c[135760 >> 2] & 511](c[(c[j >> 2] | 0) + 196 >> 2] | 0, c[(c[j >> 2] | 0) + 192 >> 2] << 2) | 0;
	                    do if (c[o >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 196 >> 2] = c[o >> 2];
	                        c[p >> 2] = Hb[c[135760 >> 2] & 511](c[(c[j >> 2] | 0) + 344 >> 2] | 0, (c[(c[j >> 2] | 0) + 192 >> 2] | 0) * 3 << 2) | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            f = (c[j >> 2] | 0) + 192 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) / 2 | 0;
	                            break
	                        } else {
	                            c[(c[j >> 2] | 0) + 344 >> 2] = c[p >> 2];
	                            break a
	                        }
	                    } else {
	                        f = (c[j >> 2] | 0) + 192 | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) / 2 | 0
	                    } while (0);
	                    ie(c[j >> 2] | 0, 0);
	                    c[h >> 2] = -1;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } while (0);
	                c[(c[(c[j >> 2] | 0) + 196 >> 2] | 0) + (c[(c[j >> 2] | 0) + 188 >> 2] << 2) >> 2] = c[k >> 2];
	                c[(c[j >> 2] | 0) + 184 >> 2] = c[k >> 2];
	                c[(c[(c[j >> 2] | 0) + 344 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 188 >> 2] | 0) * 3 << 2) >> 2] = c[l >> 2];
	                c[(c[(c[j >> 2] | 0) + 344 >> 2] | 0) + (((c[(c[j >> 2] | 0) + 188 >> 2] | 0) * 3 | 0) + 1 << 2) >> 2] = c[m >> 2];
	                c[(c[(c[j >> 2] | 0) + 344 >> 2] | 0) + (((c[(c[j >> 2] | 0) + 188 >> 2] | 0) * 3 | 0) + 2 << 2) >> 2] = c[n >> 2];
	                n = (c[j >> 2] | 0) + 188 | 0;
	                j = c[n >> 2] | 0;
	                c[n >> 2] = j + 1;
	                c[h >> 2] = j;
	                q = c[h >> 2] | 0;
	                i = g;
	                return q | 0
	            }

	            function wh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 188 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 184 >> 2] = c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + ((c[a + 188 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 184 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[(c[e >> 2] | 0) + 188 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[(c[e >> 2] | 0) + 188 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function xh(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f + 20 | 0;
	                m = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) <= 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    o = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) >= (c[j >> 2] | 0)) {
	                        p = 53;
	                        break
	                    }
	                    a[l >> 0] = a[(c[h >> 2] | 0) + o >> 0] | 0;
	                    e = d[l >> 0] | 0;
	                    if (!((d[l >> 0] | 0) & 128)) {
	                        if ((e | 0) >= 32) {
	                            c[k >> 2] = (c[k >> 2] | 0) + 1;
	                            continue
	                        }
	                        if (((d[l >> 0] | 0 | 0) != 10 ? (d[l >> 0] | 0 | 0) != 13 : 0) ? (d[l >> 0] | 0 | 0) != 9 : 0) {
	                            p = 12;
	                            break
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((e & 224 | 0) == 192) {
	                        q = c[k >> 2] | 0;
	                        if (((c[k >> 2] | 0) + 2 | 0) > (c[j >> 2] | 0)) {
	                            p = 15;
	                            break
	                        }
	                        r = c[k >> 2] | 0;
	                        if (((d[(c[h >> 2] | 0) + (q + 1) >> 0] | 0) & 192 | 0) != 128) {
	                            p = 17;
	                            break
	                        }
	                        c[m >> 2] = ((d[(c[h >> 2] | 0) + r >> 0] | 0) & 31) << 6;
	                        c[m >> 2] = c[m >> 2] | (d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 1) >> 0] | 0) & 63;
	                        e = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) < 256) {
	                            if (!(9 <= (e | 0) & (c[m >> 2] | 0) <= 10 | (c[m >> 2] | 0) == 13 | 32 <= (c[m >> 2] | 0))) {
	                                p = 23;
	                                break
	                            }
	                        } else if ((!(256 <= (e | 0) & (c[m >> 2] | 0) <= 55295) ? !(57344 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 1114111) : 0) {
	                            p = 23;
	                            break
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 2;
	                        continue
	                    }
	                    if (((d[l >> 0] | 0) & 240 | 0) == 224) {
	                        s = c[k >> 2] | 0;
	                        if (((c[k >> 2] | 0) + 3 | 0) > (c[j >> 2] | 0)) {
	                            p = 27;
	                            break
	                        }
	                        if (((d[(c[h >> 2] | 0) + (s + 1) >> 0] | 0) & 192 | 0) != 128) {
	                            p = 30;
	                            break
	                        }
	                        if (((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 2) >> 0] | 0) & 192 | 0) != 128) {
	                            p = 30;
	                            break
	                        }
	                        c[m >> 2] = ((d[(c[h >> 2] | 0) + (c[k >> 2] | 0) >> 0] | 0) & 15) << 12;
	                        c[m >> 2] = c[m >> 2] | ((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 1) >> 0] | 0) & 63) << 6;
	                        c[m >> 2] = c[m >> 2] | (d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 2) >> 0] | 0) & 63;
	                        e = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) < 256) {
	                            if (!(9 <= (e | 0) & (c[m >> 2] | 0) <= 10 | (c[m >> 2] | 0) == 13 | 32 <= (c[m >> 2] | 0))) {
	                                p = 36;
	                                break
	                            }
	                        } else if ((!(256 <= (e | 0) & (c[m >> 2] | 0) <= 55295) ? !(57344 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 1114111) : 0) {
	                            p = 36;
	                            break
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 3;
	                        continue
	                    }
	                    t = c[k >> 2] | 0;
	                    if (((d[l >> 0] | 0) & 248 | 0) != 240) {
	                        p = 52;
	                        break
	                    }
	                    u = c[k >> 2] | 0;
	                    if ((t + 4 | 0) > (c[j >> 2] | 0)) {
	                        p = 40;
	                        break
	                    }
	                    if (((d[(c[h >> 2] | 0) + (u + 1) >> 0] | 0) & 192 | 0) != 128) {
	                        p = 44;
	                        break
	                    }
	                    if (((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 2) >> 0] | 0) & 192 | 0) != 128) {
	                        p = 44;
	                        break
	                    }
	                    if (((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 3) >> 0] | 0) & 192 | 0) != 128) {
	                        p = 44;
	                        break
	                    }
	                    c[m >> 2] = ((d[(c[h >> 2] | 0) + (c[k >> 2] | 0) >> 0] | 0) & 7) << 18;
	                    c[m >> 2] = c[m >> 2] | ((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 1) >> 0] | 0) & 63) << 12;
	                    c[m >> 2] = c[m >> 2] | ((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 2) >> 0] | 0) & 63) << 6;
	                    c[m >> 2] = c[m >> 2] | (d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) + 3) >> 0] | 0) & 63;
	                    e = c[m >> 2] | 0;
	                    if ((c[m >> 2] | 0) < 256) {
	                        if (!(9 <= (e | 0) & (c[m >> 2] | 0) <= 10 | (c[m >> 2] | 0) == 13 | 32 <= (c[m >> 2] | 0))) {
	                            p = 50;
	                            break
	                        }
	                    } else if ((!(256 <= (e | 0) & (c[m >> 2] | 0) <= 55295) ? !(57344 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[m >> 2] | 0) & (c[m >> 2] | 0) <= 1114111) : 0) {
	                        p = 50;
	                        break
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 4
	                }
	                switch (p | 0) {
	                    case 12:
	                    {
	                        c[g >> 2] = 0 - (c[k >> 2] | 0);
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 15:
	                    {
	                        c[g >> 2] = q;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 17:
	                    {
	                        c[g >> 2] = 0 - r;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 23:
	                    {
	                        c[g >> 2] = 0 - (c[k >> 2] | 0);
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 27:
	                    {
	                        c[g >> 2] = s;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 30:
	                    {
	                        c[g >> 2] = 0 - (c[k >> 2] | 0);
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 36:
	                    {
	                        c[g >> 2] = 0 - (c[k >> 2] | 0);
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 40:
	                    {
	                        c[g >> 2] = u;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 44:
	                    {
	                        c[g >> 2] = 0 - (c[k >> 2] | 0);
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 50:
	                    {
	                        c[g >> 2] = 0 - (c[k >> 2] | 0);
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 52:
	                    {
	                        c[g >> 2] = 0 - t;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 53:
	                    {
	                        c[g >> 2] = o;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                }
	                return 0
	            }

	            function yh(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)k = 6; else k = 3;
	                do if ((k | 0) == 3) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        k = 6;
	                        break
	                    }
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 95)k = 6
	                } while (0);
	                if ((k | 0) == 6) {
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)l = 1; else k = 9;
	                        do if ((k | 0) == 9) {
	                            k = 0;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                                l = 1;
	                                break
	                            }
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                l = 1;
	                                break
	                            }
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 45 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) == 46; else l = 1
	                        } while (0);
	                        m = c[g >> 2] | 0;
	                        if (!l)break;
	                        c[g >> 2] = m + 1
	                    }
	                    if ((d[m >> 0] | 0 | 0) > 0 ? (d[c[g >> 2] >> 0] | 0 | 0) < 128 : 0) {
	                        c[j >> 2] = (c[g >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                        if ((c[j >> 2] | 0) > 5e4 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            og(c[f >> 2] | 0, 110, 70920);
	                            c[e >> 2] = 0;
	                            n = c[e >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        }
	                        c[h >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        g = (c[f >> 2] | 0) + 200 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[j >> 2] | 0);
	                        g = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[j >> 2] | 0);
	                        if (!(c[h >> 2] | 0))ie(c[f >> 2] | 0, 0);
	                        c[e >> 2] = c[h >> 2];
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                }
	                c[e >> 2] = Ah(c[f >> 2] | 0) | 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function zh(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[l >> 2] = c[c[k >> 2] >> 2];
	                if ((c[l >> 2] | 0) <= 0) {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[o >> 2] = c[j >> 2];
	                while (1) {
	                    if ((d[c[o >> 2] >> 0] | 0 | 0) != 32)break;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                while (1) {
	                    if (!(d[c[o >> 2] >> 0] | 0))break;
	                    e = (d[c[o >> 2] >> 0] | 0 | 0) == 32;
	                    c[o >> 2] = (c[o >> 2] | 0) + 1;
	                    if (!e)continue;
	                    if ((d[c[o >> 2] >> 0] | 0 | 0) == 32) {
	                        r = 12;
	                        break
	                    }
	                    if (!(d[c[o >> 2] >> 0] | 0)) {
	                        r = 12;
	                        break
	                    }
	                }
	                if ((r | 0) == 12)c[n >> 2] = 1;
	                if (c[n >> 2] | 0) {
	                    c[p >> 2] = ly((c[j >> 2] | 0) + (c[m >> 2] | 0) | 0, (c[l >> 2] | 0) - (c[m >> 2] | 0) + 1 | 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        ie(c[h >> 2] | 0, 0);
	                        c[g >> 2] = 0;
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    } else {
	                        Mg(c[p >> 2] | 0, c[p >> 2] | 0) | 0;
	                        h = ZT(c[p >> 2] | 0) | 0;
	                        c[c[k >> 2] >> 2] = h;
	                        c[g >> 2] = c[p >> 2];
	                        q = c[g >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                } else if (c[m >> 2] | 0) {
	                    p = c[k >> 2] | 0;
	                    c[p >> 2] = (c[p >> 2] | 0) - (c[m >> 2] | 0);
	                    fU(c[j >> 2] | 0, (c[j >> 2] | 0) + (c[m >> 2] | 0) | 0, 1 + (c[c[k >> 2] >> 2] | 0) | 0) | 0;
	                    c[g >> 2] = c[j >> 2];
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else {
	                    c[g >> 2] = 0;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                return 0
	            }

	            function Ah(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                c[k >> 2] = 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                c[l >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[j >> 2] = ne(c[f >> 2] | 0, h) | 0;
	                if (!((c[j >> 2] | 0) == 32 | (c[j >> 2] | 0) == 62 | (c[j >> 2] | 0) == 47) ? (a = (kh(c[f >> 2] | 0, c[j >> 2] | 0) | 0) == 0, !(a | (c[j >> 2] | 0) == 58)) : 0) {
	                    while (1) {
	                        if (!((c[j >> 2] | 0) != 32 & (c[j >> 2] | 0) != 62 & (c[j >> 2] | 0) != 47)) {
	                            m = 30;
	                            break
	                        }
	                        a = (Cg(c[f >> 2] | 0, c[j >> 2] | 0) | 0) != 0;
	                        if (!(a & (c[j >> 2] | 0) != 58)) {
	                            m = 30;
	                            break
	                        }
	                        a = c[k >> 2] | 0;
	                        c[k >> 2] = a + 1;
	                        if ((a | 0) > 100) {
	                            if ((c[g >> 2] | 0) > 5e4 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                                m = 12;
	                                break
	                            }
	                            c[k >> 2] = 0;
	                            if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                            if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                                m = 17;
	                                break
	                            }
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                        a = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            n = a + 28 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            n = a + 32 | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        n = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + (c[h >> 2] | 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 37)We(c[f >> 2] | 0);
	                        c[l >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        c[j >> 2] = ne(c[f >> 2] | 0, h) | 0;
	                        if (c[j >> 2] | 0)continue;
	                        c[k >> 2] = 0;
	                        if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)vg(c[f >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            m = 28;
	                            break
	                        }
	                        c[l >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                        c[j >> 2] = ne(c[f >> 2] | 0, h) | 0
	                    }
	                    if ((m | 0) == 12) {
	                        og(c[f >> 2] | 0, 110, 70920);
	                        c[e >> 2] = 0;
	                        o = c[e >> 2] | 0;
	                        i = b;
	                        return o | 0
	                    } else if ((m | 0) == 17) {
	                        c[e >> 2] = 0;
	                        o = c[e >> 2] | 0;
	                        i = b;
	                        return o | 0
	                    } else if ((m | 0) == 28) {
	                        c[e >> 2] = 0;
	                        o = c[e >> 2] | 0;
	                        i = b;
	                        return o | 0
	                    } else if ((m | 0) == 30) {
	                        if ((c[g >> 2] | 0) > 5e4 ? (c[(c[f >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                            og(c[f >> 2] | 0, 110, 70920);
	                            c[e >> 2] = 0;
	                            o = c[e >> 2] | 0;
	                            i = b;
	                            return o | 0
	                        }
	                        c[e >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, (c[l >> 2] | 0) + (0 - (c[g >> 2] | 0)) | 0, c[g >> 2] | 0) | 0;
	                        o = c[e >> 2] | 0;
	                        i = b;
	                        return o | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                o = c[e >> 2] | 0;
	                i = b;
	                return o | 0
	            }

	            function Bh(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 4 | 0;
	                p = g;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                f = c[j >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = f;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                c[n >> 2] = ZT(f | 0) | 0;
	                c[o >> 2] = ZT(c[k >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) != 0 ? (c[m >> 2] | 0) >= ((c[n >> 2] | 0) + (c[o >> 2] | 0) + 2 | 0) : 0)c[p >> 2] = c[l >> 2]; else r = 7;
	                if ((r | 0) == 7 ? (c[p >> 2] = Cb[c[135752 >> 2] & 511]((c[n >> 2] | 0) + (c[o >> 2] | 0) + 2 | 0) | 0, (c[p >> 2] | 0) == 0) : 0) {
	                    tj(75136);
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                eU(c[p >> 2] | 0, c[k >> 2] | 0, c[o >> 2] | 0) | 0;
	                a[(c[p >> 2] | 0) + (c[o >> 2] | 0) >> 0] = 58;
	                eU((c[p >> 2] | 0) + ((c[o >> 2] | 0) + 1) | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                a[(c[p >> 2] | 0) + ((c[n >> 2] | 0) + (c[o >> 2] | 0) + 1) >> 0] = 0;
	                c[h >> 2] = c[p >> 2];
	                q = c[h >> 2] | 0;
	                i = g;
	                return q | 0
	            }

	            function Ch(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[c[h >> 2] >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((d[c[g >> 2] >> 0] | 0 | 0) == 58) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                while (1) {
	                    if (d[(c[g >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0)m = (d[(c[g >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) != 58; else m = 0;
	                    n = c[j >> 2] | 0;
	                    if (!m)break;
	                    c[j >> 2] = n + 1
	                }
	                if (!(d[(c[g >> 2] | 0) + n >> 0] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                n = ly(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[c[h >> 2] >> 2] = n;
	                if (!(c[c[h >> 2] >> 2] | 0)) {
	                    tj(75152);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = my((c[g >> 2] | 0) + ((c[j >> 2] | 0) + 1) | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                tj(75152);
	                if (c[c[h >> 2] >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[c[h >> 2] >> 2] | 0);
	                    c[c[h >> 2] >> 2] = 0
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Dh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                do if (c[g >> 2] | 0) {
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) == 58) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    while (1) {
	                        if (d[(c[g >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0)k = (d[(c[g >> 2] | 0) + (c[j >> 2] | 0) >> 0] | 0 | 0) != 58; else k = 0;
	                        l = c[j >> 2] | 0;
	                        if (!k)break;
	                        c[j >> 2] = l + 1
	                    }
	                    if (!(d[(c[g >> 2] | 0) + l >> 0] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    } else {
	                        c[c[h >> 2] >> 2] = c[j >> 2];
	                        c[f >> 2] = (c[g >> 2] | 0) + ((c[j >> 2] | 0) + 1);
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function Eh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                a:do if (c[h >> 2] | 0)while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                } while (0);
	                if ((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0)n = 14; else n = 11;
	                do if ((n | 0) == 11) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        n = 14;
	                        break
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 95)n = 14
	                } while (0);
	                if ((n | 0) == 14) {
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    b:while (1) {
	                        if (!((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0))n = 17;
	                        do if ((n | 0) == 17) {
	                            n = 0;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0)break;
	                            if (((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 46 : 0)break b
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    c:do if (c[h >> 2] | 0)while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break c
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    } while (0);
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                }
	                c[j >> 2] = c[g >> 2];
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                d:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)o = (c[k >> 2] | 0) == 13; else o = 1;
	                        p = o & 1
	                    } else p = 0;
	                    if (!p)break d;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                p = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (((!(65 <= (p | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 47
	                } else if (!(DQ(p, 199744) | 0))n = 47;
	                do if ((n | 0) == 47) {
	                    p = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((p | 0) == 95)break
	                    } else {
	                        if (19968 <= (p | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                        if (!((12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329 ^ 1) & (c[k >> 2] | 0) != 95))break
	                    }
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                e:while (1) {
	                    p = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (p | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 59
	                    } else if (!(DQ(p, 199744) | 0))n = 59;
	                    do if ((n | 0) == 59) {
	                        n = 0;
	                        if ((c[k >> 2] | 0) >= 256) {
	                            if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                        }
	                        p = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (48 <= (p | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        } else {
	                            o = (DQ(p, 200216) | 0) != 0;
	                            if (o | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        }
	                        if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        o = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)q = (o | 0) == 183 & 1; else q = DQ(o, 200272) | 0;
	                        if (!q)break e
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                }
	                f:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)r = (c[k >> 2] | 0) == 13; else r = 1;
	                        s = r & 1
	                    } else s = 0;
	                    if (!s)break f;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function Fh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                a:do if (c[h >> 2] | 0)while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                } while (0);
	                if ((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0)n = 14; else n = 11;
	                do if ((n | 0) == 11) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        n = 14;
	                        break
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 95)n = 14
	                } while (0);
	                b:do if ((n | 0) == 14) {
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0)o = 1; else n = 17;
	                        do if ((n | 0) == 17) {
	                            n = 0;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                                o = 1;
	                                break
	                            }
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                o = 1;
	                                break
	                            }
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0)o = (d[c[j >> 2] >> 0] | 0 | 0) == 46; else o = 1
	                        } while (0);
	                        p = c[j >> 2] | 0;
	                        if (!o)break;
	                        c[j >> 2] = p + 1
	                    }
	                    c:do if ((d[p >> 0] | 0 | 0) == 58) {
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        if (!((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0))n = 29;
	                        do if ((n | 0) == 29) {
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 95)break b
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        while (1) {
	                            if (!((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0))n = 35;
	                            do if ((n | 0) == 35) {
	                                n = 0;
	                                if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0)break;
	                                if ((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0)break;
	                                if (((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 46 : 0)break c
	                            } while (0);
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    d:do if (c[h >> 2] | 0)while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break d
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    } while (0);
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                } while (0);
	                c[j >> 2] = c[g >> 2];
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                e:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)q = (c[k >> 2] | 0) == 13; else q = 1;
	                        r = q & 1
	                    } else r = 0;
	                    if (!r)break e;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                r = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (((!(65 <= (r | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 65
	                } else if (!(DQ(r, 199744) | 0))n = 65;
	                do if ((n | 0) == 65) {
	                    r = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((r | 0) == 95)break
	                    } else {
	                        if (19968 <= (r | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                        if (!((12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329 ^ 1) & (c[k >> 2] | 0) != 95))break
	                    }
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                f:while (1) {
	                    r = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (r | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 77
	                    } else if (!(DQ(r, 199744) | 0))n = 77;
	                    do if ((n | 0) == 77) {
	                        n = 0;
	                        if ((c[k >> 2] | 0) >= 256) {
	                            if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                        }
	                        r = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (48 <= (r | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        } else {
	                            q = (DQ(r, 200216) | 0) != 0;
	                            if (q | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        }
	                        if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        q = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)s = (q | 0) == 183 & 1; else s = DQ(q, 200272) | 0;
	                        if (!s)break f
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                }
	                g:do if ((c[k >> 2] | 0) == 58) {
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                    s = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (s | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 97
	                    } else if (!(DQ(s, 199744) | 0))n = 97;
	                    do if ((n | 0) == 97) {
	                        s = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if ((s | 0) == 95)break
	                        } else {
	                            if (19968 <= (s | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (!((12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329 ^ 1) & (c[k >> 2] | 0) != 95))break
	                        }
	                        c[f >> 2] = 1;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                    while (1) {
	                        s = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (((!(65 <= (s | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 109
	                        } else if (!(DQ(s, 199744) | 0))n = 109;
	                        do if ((n | 0) == 109) {
	                            n = 0;
	                            if ((c[k >> 2] | 0) >= 256) {
	                                if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                                if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                            }
	                            s = c[k >> 2] | 0;
	                            if ((c[k >> 2] | 0) < 256) {
	                                if (48 <= (s | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                            } else {
	                                q = (DQ(s, 200216) | 0) != 0;
	                                if (q | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                            }
	                            if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                            q = c[k >> 2] | 0;
	                            if ((c[k >> 2] | 0) < 256)t = (q | 0) == 183 & 1; else t = DQ(q, 200272) | 0;
	                            if (!t)break g
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                        c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                    }
	                } while (0);
	                h:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)u = (c[k >> 2] | 0) == 13; else u = 1;
	                        v = u & 1
	                    } else v = 0;
	                    if (!v)break h;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function Gh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                a:do if (c[h >> 2] | 0)while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                } while (0);
	                if ((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0)n = 15; else n = 11;
	                do if ((n | 0) == 11) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        n = 15;
	                        break
	                    }
	                    if (!((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 58 : 0))n = 15
	                } while (0);
	                if ((n | 0) == 15) {
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    b:while (1) {
	                        if (!((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0))n = 18;
	                        do if ((n | 0) == 18) {
	                            n = 0;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0)break;
	                            if ((((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 46 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 58 : 0)break b
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    c:do if (c[h >> 2] | 0)while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break c
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    } while (0);
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                }
	                c[j >> 2] = c[g >> 2];
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                d:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)o = (c[k >> 2] | 0) == 13; else o = 1;
	                        p = o & 1
	                    } else p = 0;
	                    if (!p)break d;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                p = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (((!(65 <= (p | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 49
	                } else if (!(DQ(p, 199744) | 0))n = 49;
	                do if ((n | 0) == 49) {
	                    p = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (!((p | 0) != 95 & (c[k >> 2] | 0) != 58))break
	                    } else {
	                        if (19968 <= (p | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                        if (!((12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329 ^ 1) & (c[k >> 2] | 0) != 95 & (c[k >> 2] | 0) != 58))break
	                    }
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                e:while (1) {
	                    p = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (p | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 61
	                    } else if (!(DQ(p, 199744) | 0))n = 61;
	                    do if ((n | 0) == 61) {
	                        n = 0;
	                        if ((c[k >> 2] | 0) >= 256) {
	                            if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                        }
	                        p = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (48 <= (p | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 58 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        } else {
	                            o = (DQ(p, 200216) | 0) != 0;
	                            if (o | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 58 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        }
	                        if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        o = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)q = (o | 0) == 183 & 1; else q = DQ(o, 200272) | 0;
	                        if (!q)break e
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                }
	                f:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)r = (c[k >> 2] | 0) == 13; else r = 1;
	                        s = r & 1
	                    } else s = 0;
	                    if (!s)break f;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function Hh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                a:do if (c[h >> 2] | 0)while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                } while (0);
	                if ((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0)n = 19; else n = 11;
	                do if ((n | 0) == 11) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        n = 19;
	                        break
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                        n = 19;
	                        break
	                    }
	                    if (!((((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 46 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 58 : 0))n = 19
	                } while (0);
	                if ((n | 0) == 19) {
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    b:while (1) {
	                        if (!((d[c[j >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 122 : 0))n = 22;
	                        do if ((n | 0) == 22) {
	                            n = 0;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 90 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0)break;
	                            if ((((d[c[j >> 2] >> 0] | 0 | 0) != 95 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 46 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 58 : 0)break b
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    c:do if (c[h >> 2] | 0)while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break c
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    } while (0);
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                }
	                c[j >> 2] = c[g >> 2];
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                d:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)o = (c[k >> 2] | 0) == 13; else o = 1;
	                        p = o & 1
	                    } else p = 0;
	                    if (!p)break d;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                p = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (((!(65 <= (p | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 53
	                } else if (!(DQ(p, 199744) | 0))n = 53;
	                do if ((n | 0) == 53) {
	                    if ((c[k >> 2] | 0) >= 256) {
	                        if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                        if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                    }
	                    p = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (48 <= (p | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 58 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                    } else {
	                        o = (DQ(p, 200216) | 0) != 0;
	                        if (o | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 58 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                    }
	                    if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                    o = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((o | 0) == 183)break
	                    } else if (DQ(o, 200272) | 0)break;
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0;
	                e:while (1) {
	                    o = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (o | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)n = 72
	                    } else if (!(DQ(o, 199744) | 0))n = 72;
	                    do if ((n | 0) == 72) {
	                        n = 0;
	                        if ((c[k >> 2] | 0) >= 256) {
	                            if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                        }
	                        o = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (48 <= (o | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 58 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        } else {
	                            p = (DQ(o, 200216) | 0) != 0;
	                            if (p | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 58 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        }
	                        if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        p = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)q = (p | 0) == 183 & 1; else q = DQ(p, 200272) | 0;
	                        if (!q)break e
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                }
	                f:do if (c[h >> 2] | 0)while (1) {
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10) : 0)r = (c[k >> 2] | 0) == 13; else r = 1;
	                        s = r & 1
	                    } else s = 0;
	                    if (!s)break f;
	                    c[j >> 2] = (c[j >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[j >> 2] | 0, l) | 0
	                } while (0);
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function Ih(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (((c[j >> 2] | 0) != 0 ? (qy(c[j >> 2] | 0, 75168) | 0) != 0 : 0) ? (qy(c[h >> 2] | 0, 75176) | 0) != 0 : 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    tj(75216);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                d = c[k >> 2] | 0;
	                c[d + 0 >> 2] = 0;
	                c[d + 4 >> 2] = 0;
	                c[d + 8 >> 2] = 0;
	                c[d + 12 >> 2] = 0;
	                c[d + 16 >> 2] = 0;
	                c[d + 20 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 4 >> 2] = 18;
	                if (c[h >> 2] | 0) {
	                    d = my(c[h >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 8 >> 2] = d
	                }
	                if (c[j >> 2] | 0) {
	                    d = my(c[j >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = d
	                }
	                do if (c[g >> 2] | 0) {
	                    if (!(c[(c[g >> 2] | 0) + 48 >> 2] | 0)) {
	                        c[(c[g >> 2] | 0) + 48 >> 2] = c[k >> 2];
	                        break
	                    }
	                    c[l >> 2] = c[(c[g >> 2] | 0) + 48 >> 2];
	                    if (!((c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 : 0))n = 19;
	                    if ((n | 0) == 19 ? (qy(c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0) == 0 : 0) {
	                        do {
	                            if (!(c[c[l >> 2] >> 2] | 0)) {
	                                n = 26;
	                                break
	                            }
	                            c[l >> 2] = c[c[l >> 2] >> 2];
	                            if ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)break
	                        } while ((qy(c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0) == 0);
	                        if ((n | 0) == 26) {
	                            c[c[l >> 2] >> 2] = c[k >> 2];
	                            break
	                        }
	                        Jh(c[k >> 2] | 0);
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                    Jh(c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Jh(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Kh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) {
	                    i = d;
	                    return
	                }
	                c[(c[e >> 2] | 0) + 36 >> 2] = c[f >> 2];
	                i = d;
	                return
	            }

	            function Lh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!((c[d >> 2] | 0) != 0 & (c[d >> 2] | 0) != 0)) {
	                    i = b;
	                    return
	                }
	                do {
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    Jh(c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                } while ((c[d >> 2] | 0) != 0);
	                i = b;
	                return
	            }

	            function Mh(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tj(75240);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                e = (c[m >> 2] | 0) + 0 | 0;
	                d = e + 64 | 0;
	                do {
	                    c[e >> 2] = 0;
	                    e = e + 4 | 0
	                } while ((e | 0) < (d | 0));
	                c[(c[m >> 2] | 0) + 4 >> 2] = 14;
	                if (c[j >> 2] | 0) {
	                    e = my(c[j >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 8 >> 2] = e
	                }
	                if (c[k >> 2] | 0) {
	                    e = my(c[k >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 52 >> 2] = e
	                }
	                if (c[l >> 2] | 0) {
	                    e = my(c[l >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 56 >> 2] = e
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 48 >> 2] = c[m >> 2];
	                c[(c[m >> 2] | 0) + 32 >> 2] = c[h >> 2];
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[m >> 2] | 0);
	                c[g >> 2] = c[m >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function Nh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        h = 8;
	                        break
	                    }
	                    j = c[f >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                        h = 6;
	                        break
	                    }
	                    c[f >> 2] = c[j + 24 >> 2]
	                }
	                if ((h | 0) == 6) {
	                    c[d >> 2] = j;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else if ((h | 0) == 8) {
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 44 >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Oh(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) != 0 ? (Nh(c[h >> 2] | 0) | 0) != 0 : 0) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tj(75256);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                e = (c[m >> 2] | 0) + 0 | 0;
	                d = e + 64 | 0;
	                do {
	                    c[e >> 2] = 0;
	                    e = e + 4 | 0
	                } while ((e | 0) < (d | 0));
	                c[(c[m >> 2] | 0) + 4 >> 2] = 14;
	                if ((c[j >> 2] | 0) != 0 ? (e = my(c[j >> 2] | 0) | 0, c[(c[m >> 2] | 0) + 8 >> 2] = e, (c[(c[m >> 2] | 0) + 8 >> 2] | 0) == 0) : 0) {
	                    tj(75256);
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((c[k >> 2] | 0) != 0 ? (e = my(c[k >> 2] | 0) | 0, c[(c[m >> 2] | 0) + 52 >> 2] = e, (c[(c[m >> 2] | 0) + 52 >> 2] | 0) == 0) : 0) {
	                    tj(75256);
	                    if (c[(c[m >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[m >> 2] | 0) + 8 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((c[l >> 2] | 0) != 0 ? (e = my(c[l >> 2] | 0) | 0, c[(c[m >> 2] | 0) + 56 >> 2] = e, (c[(c[m >> 2] | 0) + 56 >> 2] | 0) == 0) : 0) {
	                    tj(75256);
	                    if (c[(c[m >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[m >> 2] | 0) + 8 >> 2] | 0);
	                    if (c[(c[m >> 2] | 0) + 52 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[m >> 2] | 0) + 52 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                do if (c[h >> 2] | 0) {
	                    c[(c[h >> 2] | 0) + 44 >> 2] = c[m >> 2];
	                    c[(c[m >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                    c[(c[m >> 2] | 0) + 32 >> 2] = c[h >> 2];
	                    if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[(c[h >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                        c[(c[h >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                        break
	                    }
	                    e = c[(c[h >> 2] | 0) + 12 >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                        c[n >> 2] = e;
	                        c[(c[n >> 2] | 0) + 28 >> 2] = c[m >> 2];
	                        c[(c[m >> 2] | 0) + 24 >> 2] = c[n >> 2];
	                        c[(c[h >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                        break
	                    }
	                    c[o >> 2] = e;
	                    while (1) {
	                        if (c[o >> 2] | 0)q = (c[(c[o >> 2] | 0) + 4 >> 2] | 0) != 1; else q = 0;
	                        r = c[o >> 2] | 0;
	                        if (!q)break;
	                        c[o >> 2] = c[r + 24 >> 2]
	                    }
	                    if (!r) {
	                        c[(c[m >> 2] | 0) + 28 >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                        c[(c[(c[m >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                        c[(c[m >> 2] | 0) + 24 >> 2] = 0;
	                        c[(c[h >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                        break
	                    }
	                    c[(c[m >> 2] | 0) + 24 >> 2] = c[o >> 2];
	                    c[(c[m >> 2] | 0) + 28 >> 2] = c[(c[o >> 2] | 0) + 28 >> 2];
	                    e = c[m >> 2] | 0;
	                    if (!(c[(c[m >> 2] | 0) + 28 >> 2] | 0))c[(c[h >> 2] | 0) + 12 >> 2] = e; else c[(c[(c[m >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = e;
	                    c[(c[o >> 2] | 0) + 28 >> 2] = c[m >> 2]
	                } while (0);
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[m >> 2] | 0);
	                c[g >> 2] = c[m >> 2];
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function Ph(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[d >> 2] | 0);
	                a:do if (c[(c[d >> 2] | 0) + 12 >> 2] | 0) {
	                    c[g >> 2] = c[(c[d >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0))break a;
	                        c[f >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        if ((((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 12 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 15 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 16 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) {
	                            Qh(c[g >> 2] | 0);
	                            Rh(c[g >> 2] | 0)
	                        }
	                        c[g >> 2] = c[f >> 2]
	                    }
	                } while (0);
	                do if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                } while (0);
	                do if (c[(c[d >> 2] | 0) + 56 >> 2] | 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 56 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0)
	                } while (0);
	                do if (c[(c[d >> 2] | 0) + 52 >> 2] | 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 52 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0)
	                } while (0);
	                if (c[(c[d >> 2] | 0) + 36 >> 2] | 0)ym(c[(c[d >> 2] | 0) + 36 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0)nm(c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 44 >> 2] | 0)um(c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 48 >> 2] | 0)dd(c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 60 >> 2] | 0)dd(c[(c[d >> 2] | 0) + 60 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Qh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 14 ? (c[e >> 2] = c[(c[d >> 2] | 0) + 32 >> 2], (c[e >> 2] | 0) != 0) : 0) {
	                    if ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) == (c[d >> 2] | 0))c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    if ((c[(c[e >> 2] | 0) + 48 >> 2] | 0) == (c[d >> 2] | 0))c[(c[e >> 2] | 0) + 48 >> 2] = 0
	                }
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 17 ? (c[f >> 2] = c[(c[d >> 2] | 0) + 32 >> 2], (c[f >> 2] | 0) != 0) : 0) {
	                    if (c[(c[f >> 2] | 0) + 44 >> 2] | 0) {
	                        e = Rj(c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if ((e | 0) == (c[d >> 2] | 0))ak(c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                        e = Rj(c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 60 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if ((e | 0) == (c[d >> 2] | 0))ak(c[(c[(c[f >> 2] | 0) + 44 >> 2] | 0) + 60 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0, 0) | 0
	                    }
	                    if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                        e = Rj(c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 48 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if ((e | 0) == (c[d >> 2] | 0))ak(c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 48 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                        e = Rj(c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 60 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if ((e | 0) == (c[d >> 2] | 0))ak(c[(c[(c[f >> 2] | 0) + 48 >> 2] | 0) + 60 >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0, 0) | 0
	                    }
	                }
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0) {
	                    c[g >> 2] = c[(c[d >> 2] | 0) + 20 >> 2];
	                    f = c[g >> 2] | 0;
	                    if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                        if ((c[f + 44 >> 2] | 0) == (c[d >> 2] | 0))c[(c[g >> 2] | 0) + 44 >> 2] = c[(c[d >> 2] | 0) + 24 >> 2]
	                    } else {
	                        if ((c[f + 12 >> 2] | 0) == (c[d >> 2] | 0))c[(c[g >> 2] | 0) + 12 >> 2] = c[(c[d >> 2] | 0) + 24 >> 2];
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) == (c[d >> 2] | 0))c[(c[g >> 2] | 0) + 16 >> 2] = c[(c[d >> 2] | 0) + 28 >> 2]
	                    }
	                    c[(c[d >> 2] | 0) + 20 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)c[(c[(c[d >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = c[(c[d >> 2] | 0) + 28 >> 2];
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)c[(c[(c[d >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = c[(c[d >> 2] | 0) + 24 >> 2];
	                c[(c[d >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 24 >> 2] = 0;
	                i = b;
	                return
	            }

	            function Rh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                a = c[d >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                    Ph(a);
	                    i = b;
	                    return
	                }
	                g = c[d >> 2] | 0;
	                if ((c[a + 4 >> 2] | 0) == 18) {
	                    Jh(g);
	                    i = b;
	                    return
	                }
	                if ((c[g + 4 >> 2] | 0) == 2) {
	                    ei(c[d >> 2] | 0);
	                    i = b;
	                    return
	                }
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[d >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                do if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                    c[f >> 2] = c[d >> 2];
	                    do if (c[(c[f >> 2] | 0) + 56 >> 2] | 0) {
	                        if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0) | 0) != 0 : 0)break;
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 56 >> 2] | 0)
	                    } while (0);
	                    if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                        if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0) | 0) != 0 : 0)break;
	                        zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 52 >> 2] | 0)
	                    }
	                } while (0);
	                if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 5 : 0)Uh(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (!(((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))h = 27;
	                if ((h | 0) == 27 ? (c[(c[d >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)di(c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                do if (((((((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[d >> 2] | 0) + 40 >> 2] | 0) != ((c[d >> 2] | 0) + 44 | 0) : 0) ? (c[(c[d >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0)
	                } while (0);
	                do if ((((c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                } while (0);
	                if (!(((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))h = 49;
	                if ((h | 0) == 49 ? (c[(c[d >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)Lh(c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Sh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[e >> 2] = (c[e >> 2] | 0) == 0 ? 75288 : a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](96) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tj(75296);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 96 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 4 >> 2] = 9;
	                a = my(c[e >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 56 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 56 >> 2] | 0)) {
	                    tj(75296);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[f >> 2] | 0) + 40 >> 2] = -1;
	                c[(c[f >> 2] | 0) + 36 >> 2] = -1;
	                c[(c[f >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                c[(c[f >> 2] | 0) + 88 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 92 >> 2] = 32;
	                c[(c[f >> 2] | 0) + 76 >> 2] = 1;
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[f >> 2] | 0);
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Th(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[d >> 2] = a;
	                c[g >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[d >> 2] | 0)c[g >> 2] = c[(c[d >> 2] | 0) + 80 >> 2];
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[d >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)Dm(c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 64 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 68 >> 2] | 0)Jm(c[(c[d >> 2] | 0) + 68 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 68 >> 2] = 0;
	                c[e >> 2] = c[(c[d >> 2] | 0) + 48 >> 2];
	                c[f >> 2] = c[(c[d >> 2] | 0) + 44 >> 2];
	                if ((c[f >> 2] | 0) == (c[e >> 2] | 0))c[e >> 2] = 0;
	                if (c[e >> 2] | 0) {
	                    Qh(c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 48 >> 2] = 0;
	                    Ph(c[e >> 2] | 0)
	                }
	                if (c[f >> 2] | 0) {
	                    Qh(c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 44 >> 2] = 0;
	                    Ph(c[f >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)Uh(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)Lh(c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                do if (c[(c[d >> 2] | 0) + 56 >> 2] | 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[d >> 2] | 0) + 56 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0)
	                } while (0);
	                do if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                } while (0);
	                do if (c[(c[d >> 2] | 0) + 60 >> 2] | 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[d >> 2] | 0) + 60 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 60 >> 2] | 0)
	                } while (0);
	                do if (c[(c[d >> 2] | 0) + 72 >> 2] | 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[d >> 2] | 0) + 72 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 72 >> 2] | 0)
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zP(c[g >> 2] | 0);
	                i = b;
	                return
	            }

	            function Uh(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[f >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                a = c[d >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    Lh(a);
	                    i = b;
	                    return
	                }
	                if (((c[a + 4 >> 2] | 0) != 9 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 21 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)c[f >> 2] = c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                    while (1) {
	                        if (!(c[d >> 2] | 0))break;
	                        c[e >> 2] = c[(c[d >> 2] | 0) + 24 >> 2];
	                        if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 14) {
	                            if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[d >> 2] | 0);
	                            if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 5 : 0)Uh(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                            if (!(((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))g = 20;
	                            if ((g | 0) == 20 ? (g = 0, (c[(c[d >> 2] | 0) + 44 >> 2] | 0) != 0) : 0)di(c[(c[d >> 2] | 0) + 44 >> 2] | 0);
	                            do if (((((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[d >> 2] | 0) + 40 >> 2] | 0) != ((c[d >> 2] | 0) + 44 | 0) : 0) {
	                                if (!(c[(c[d >> 2] | 0) + 40 >> 2] | 0))break;
	                                if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0)break;
	                                zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0)
	                            } while (0);
	                            if (!(((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))g = 34;
	                            if ((g | 0) == 34 ? (g = 0, (c[(c[d >> 2] | 0) + 48 >> 2] | 0) != 0) : 0)Lh(c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                            do if (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) {
	                                if (!(c[(c[d >> 2] | 0) + 8 >> 2] | 0))break;
	                                if ((c[f >> 2] | 0) != 0 ? (CP(c[f >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                                zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                            } while (0);
	                            zb[c[135736 >> 2] & 511](c[d >> 2] | 0)
	                        }
	                        c[d >> 2] = c[e >> 2]
	                    }
	                    i = b;
	                    return
	                }
	                Th(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Vh(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                g = i;
	                i = i + 80 | 0;
	                h = g + 60 | 0;
	                j = g + 56 | 0;
	                k = g + 52 | 0;
	                l = g + 48 | 0;
	                m = g + 44 | 0;
	                n = g + 40 | 0;
	                o = g + 36 | 0;
	                p = g + 32 | 0;
	                q = g + 28 | 0;
	                r = g + 24 | 0;
	                s = g + 20 | 0;
	                t = g + 16 | 0;
	                u = g + 12 | 0;
	                v = g + 8 | 0;
	                w = g + 74 | 0;
	                x = g + 4 | 0;
	                y = g + 64 | 0;
	                z = g;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[q >> 2] = c[k >> 2];
	                c[r >> 2] = (c[q >> 2] | 0) + (c[l >> 2] | 0);
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    A = c[h >> 2] | 0;
	                    i = g;
	                    return A | 0
	                }
	                c[u >> 2] = My(0) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    A = c[h >> 2] | 0;
	                    i = g;
	                    return A | 0
	                }
	                Qy(c[u >> 2] | 0, 4) | 0;
	                c[s >> 2] = c[q >> 2];
	                a:while (1) {
	                    if ((c[q >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)B = (d[c[q >> 2] >> 0] | 0 | 0) != 0; else B = 0;
	                    C = c[q >> 2] | 0;
	                    if (!B) {
	                        D = 87;
	                        break
	                    }
	                    if ((d[C >> 0] | 0 | 0) != 38) {
	                        c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        continue
	                    }
	                    c[v >> 2] = 0;
	                    if ((c[q >> 2] | 0) != (c[s >> 2] | 0) ? (cz(c[u >> 2] | 0, c[s >> 2] | 0, (c[q >> 2] | 0) - (c[s >> 2] | 0) | 0) | 0) != 0 : 0)break;
	                    c[s >> 2] = c[q >> 2];
	                    if ((((c[q >> 2] | 0) + 2 | 0) >>> 0 < (c[r >> 2] | 0) >>> 0 ? (d[(c[q >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) ? (d[(c[q >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) {
	                        c[q >> 2] = (c[q >> 2] | 0) + 3;
	                        if ((c[q >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)a[w >> 0] = a[c[q >> 2] >> 0] | 0; else a[w >> 0] = 0;
	                        b:while (1) {
	                            if ((d[w >> 0] | 0 | 0) == 59)break;
	                            if ((d[w >> 0] | 0 | 0) >= 48 ? (d[w >> 0] | 0 | 0) <= 57 : 0)c[v >> 2] = (c[v >> 2] << 4) + ((d[w >> 0] | 0) - 48); else D = 22;
	                            do if ((D | 0) == 22) {
	                                D = 0;
	                                if ((d[w >> 0] | 0 | 0) >= 97 ? (d[w >> 0] | 0 | 0) <= 102 : 0) {
	                                    c[v >> 2] = (c[v >> 2] << 4) + ((d[w >> 0] | 0) - 97) + 10;
	                                    break
	                                }
	                                if ((d[w >> 0] | 0 | 0) < 65) {
	                                    D = 28;
	                                    break b
	                                }
	                                if ((d[w >> 0] | 0 | 0) > 70) {
	                                    D = 28;
	                                    break b
	                                }
	                                c[v >> 2] = (c[v >> 2] << 4) + ((d[w >> 0] | 0) - 65) + 10
	                            } while (0);
	                            c[q >> 2] = (c[q >> 2] | 0) + 1;
	                            if ((c[q >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0) {
	                                a[w >> 0] = a[c[q >> 2] >> 0] | 0;
	                                continue
	                            } else {
	                                a[w >> 0] = 0;
	                                continue
	                            }
	                        }
	                        if ((D | 0) == 28) {
	                            D = 0;
	                            uj(1300, c[j >> 2] | 0, 0);
	                            c[v >> 2] = 0
	                        }
	                        if ((d[w >> 0] | 0 | 0) == 59)c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        c[s >> 2] = c[q >> 2]
	                    } else D = 35;
	                    do if ((D | 0) == 35) {
	                        D = 0;
	                        if (((c[q >> 2] | 0) + 1 | 0) >>> 0 < (c[r >> 2] | 0) >>> 0 ? (d[(c[q >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) {
	                            c[q >> 2] = (c[q >> 2] | 0) + 2;
	                            if ((c[q >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0)a[w >> 0] = a[c[q >> 2] >> 0] | 0; else a[w >> 0] = 0;
	                            while (1) {
	                                if ((d[w >> 0] | 0 | 0) == 59)break;
	                                if ((d[w >> 0] | 0 | 0) < 48) {
	                                    D = 44;
	                                    break
	                                }
	                                if ((d[w >> 0] | 0 | 0) > 57) {
	                                    D = 44;
	                                    break
	                                }
	                                c[v >> 2] = ((c[v >> 2] | 0) * 10 | 0) + ((d[w >> 0] | 0) - 48);
	                                c[q >> 2] = (c[q >> 2] | 0) + 1;
	                                if ((c[q >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0) {
	                                    a[w >> 0] = a[c[q >> 2] >> 0] | 0;
	                                    continue
	                                } else {
	                                    a[w >> 0] = 0;
	                                    continue
	                                }
	                            }
	                            if ((D | 0) == 44) {
	                                D = 0;
	                                uj(1301, c[j >> 2] | 0, 0);
	                                c[v >> 2] = 0
	                            }
	                            if ((d[w >> 0] | 0 | 0) == 59)c[q >> 2] = (c[q >> 2] | 0) + 1;
	                            c[s >> 2] = c[q >> 2];
	                            break
	                        }
	                        c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        c[s >> 2] = c[q >> 2];
	                        while (1) {
	                            if ((c[q >> 2] | 0) >>> 0 < (c[r >> 2] | 0) >>> 0 ? (d[c[q >> 2] >> 0] | 0 | 0) != 0 : 0)E = (d[c[q >> 2] >> 0] | 0 | 0) != 59; else E = 0;
	                            F = c[q >> 2] | 0;
	                            if (!E)break;
	                            c[q >> 2] = F + 1
	                        }
	                        if (F >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                            D = 58;
	                            break a
	                        }
	                        if (!(d[c[q >> 2] >> 0] | 0)) {
	                            D = 58;
	                            break a
	                        }
	                        if ((c[q >> 2] | 0) != (c[s >> 2] | 0)) {
	                            c[p >> 2] = ly(c[s >> 2] | 0, (c[q >> 2] | 0) - (c[s >> 2] | 0) | 0) | 0;
	                            c[t >> 2] = ad(c[j >> 2] | 0, c[p >> 2] | 0) | 0;
	                            if ((c[t >> 2] | 0) != 0 ? (c[(c[t >> 2] | 0) + 48 >> 2] | 0) == 6 : 0) {
	                                if (ez(c[u >> 2] | 0, c[(c[t >> 2] | 0) + 40 >> 2] | 0) | 0)break a
	                            } else D = 63;
	                            do if ((D | 0) == 63) {
	                                D = 0;
	                                do if (!(az(c[u >> 2] | 0) | 0)) {
	                                    c[o >> 2] = Wh(c[j >> 2] | 0, 0) | 0;
	                                    if (!(c[o >> 2] | 0)) {
	                                        D = 65;
	                                        break a
	                                    }
	                                    k = Ny(c[u >> 2] | 0) | 0;
	                                    c[(c[o >> 2] | 0) + 40 >> 2] = k;
	                                    if (!(c[n >> 2] | 0)) {
	                                        k = c[o >> 2] | 0;
	                                        c[m >> 2] = k;
	                                        c[n >> 2] = k;
	                                        break
	                                    } else {
	                                        c[n >> 2] = Xh(c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                                        break
	                                    }
	                                } while (0);
	                                c[o >> 2] = Yh(c[j >> 2] | 0, c[p >> 2] | 0) | 0;
	                                if (!(c[o >> 2] | 0)) {
	                                    D = 71;
	                                    break a
	                                }
	                                c:do if (c[t >> 2] | 0) {
	                                    if (c[(c[t >> 2] | 0) + 12 >> 2] | 0)break;
	                                    k = Zh(c[j >> 2] | 0, c[(c[o >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                    c[(c[t >> 2] | 0) + 12 >> 2] = k;
	                                    c[(c[t >> 2] | 0) + 68 >> 2] = 1;
	                                    c[x >> 2] = c[(c[t >> 2] | 0) + 12 >> 2];
	                                    while (1) {
	                                        if (!(c[x >> 2] | 0))break c;
	                                        c[(c[x >> 2] | 0) + 20 >> 2] = c[t >> 2];
	                                        c[(c[t >> 2] | 0) + 16 >> 2] = c[x >> 2];
	                                        c[x >> 2] = c[(c[x >> 2] | 0) + 24 >> 2]
	                                    }
	                                } while (0);
	                                if (!(c[n >> 2] | 0)) {
	                                    k = c[o >> 2] | 0;
	                                    c[m >> 2] = k;
	                                    c[n >> 2] = k;
	                                    break
	                                } else {
	                                    c[n >> 2] = Xh(c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                                    break
	                                }
	                            } while (0);
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                        }
	                        c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        c[s >> 2] = c[q >> 2]
	                    } while (0);
	                    if (!(c[v >> 2] | 0))continue;
	                    c[z >> 2] = pe(y, c[v >> 2] | 0) | 0;
	                    a[y + (c[z >> 2] | 0) >> 0] = 0;
	                    if (ez(c[u >> 2] | 0, y) | 0)break;
	                    c[v >> 2] = 0
	                }
	                do if ((D | 0) == 58)uj(1302, c[j >> 2] | 0, c[s >> 2] | 0); else if ((D | 0) == 65) {
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                } else if ((D | 0) == 71) {
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                } else if ((D | 0) == 87) {
	                    if ((C | 0) != (c[s >> 2] | 0) ? (cz(c[u >> 2] | 0, c[s >> 2] | 0, (c[q >> 2] | 0) - (c[s >> 2] | 0) | 0) | 0) != 0 : 0)break;
	                    if (az(c[u >> 2] | 0) | 0) {
	                        if (c[m >> 2] | 0)break;
	                        c[m >> 2] = Wh(c[j >> 2] | 0, 75312) | 0;
	                        break
	                    }
	                    c[o >> 2] = Wh(c[j >> 2] | 0, 0) | 0;
	                    if (c[o >> 2] | 0) {
	                        v = Ny(c[u >> 2] | 0) | 0;
	                        c[(c[o >> 2] | 0) + 40 >> 2] = v;
	                        if (!(c[n >> 2] | 0)) {
	                            v = c[o >> 2] | 0;
	                            c[m >> 2] = v;
	                            c[n >> 2] = v;
	                            break
	                        } else {
	                            c[n >> 2] = Xh(c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                            break
	                        }
	                    }
	                } while (0);
	                Ry(c[u >> 2] | 0);
	                c[h >> 2] = c[m >> 2];
	                A = c[h >> 2] | 0;
	                i = g;
	                return A | 0
	            }

	            function Wh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = li(c[f >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    h = c[g >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[g >> 2] | 0) + 32 >> 2] = c[e >> 2];
	                h = c[g >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Xh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        Qh(c[g >> 2] | 0);
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                            b = c[f >> 2] | 0;
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                                ui(b, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                                Rh(c[g >> 2] | 0);
	                                c[e >> 2] = c[f >> 2];
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            }
	                            if (((c[b + 24 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                                c[h >> 2] = my(c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                c[h >> 2] = By(c[h >> 2] | 0, c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                vi(c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[h >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                Rh(c[g >> 2] | 0);
	                                c[e >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            }
	                        } else if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                            c[e >> 2] = vj(c[f >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != (c[(c[f >> 2] | 0) + 32 >> 2] | 0))ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                        c[(c[g >> 2] | 0) + 28 >> 2] = c[f >> 2];
	                        c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)c[(c[(c[g >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] | 0) == (c[f >> 2] | 0) : 0)c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Yh(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    tj(75424);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                b = (c[j >> 2] | 0) + 0 | 0;
	                a = b + 60 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[j >> 2] | 0) + 4 >> 2] = 5;
	                c[(c[j >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                b = c[h >> 2] | 0;
	                do if ((d[c[h >> 2] >> 0] | 0 | 0) == 38) {
	                    c[h >> 2] = b + 1;
	                    c[l >> 2] = xy(c[h >> 2] | 0) | 0;
	                    a = c[h >> 2] | 0;
	                    n = c[l >> 2] | 0;
	                    if ((d[(c[h >> 2] | 0) + ((c[l >> 2] | 0) - 1) >> 0] | 0 | 0) == 59) {
	                        o = ly(a, n - 1 | 0) | 0;
	                        c[(c[j >> 2] | 0) + 8 >> 2] = o;
	                        break
	                    } else {
	                        o = ly(a, n) | 0;
	                        c[(c[j >> 2] | 0) + 8 >> 2] = o;
	                        break
	                    }
	                } else {
	                    o = my(b) | 0;
	                    c[(c[j >> 2] | 0) + 8 >> 2] = o
	                } while (0);
	                c[k >> 2] = ad(c[g >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[(c[j >> 2] | 0) + 40 >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                    c[(c[j >> 2] | 0) + 12 >> 2] = c[k >> 2];
	                    c[(c[j >> 2] | 0) + 16 >> 2] = c[k >> 2]
	                }
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[j >> 2] | 0);
	                c[f >> 2] = c[j >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Zh(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                f = i;
	                i = i + 80 | 0;
	                g = f + 52 | 0;
	                h = f + 48 | 0;
	                j = f + 44 | 0;
	                k = f + 40 | 0;
	                l = f + 36 | 0;
	                m = f + 32 | 0;
	                n = f + 28 | 0;
	                o = f + 24 | 0;
	                p = f + 20 | 0;
	                q = f + 16 | 0;
	                r = f + 12 | 0;
	                s = f + 8 | 0;
	                t = f + 66 | 0;
	                u = f + 4 | 0;
	                v = f + 56 | 0;
	                w = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[o >> 2] = c[j >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    x = c[g >> 2] | 0;
	                    i = f;
	                    return x | 0
	                }
	                c[r >> 2] = My(0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    x = c[g >> 2] | 0;
	                    i = f;
	                    return x | 0
	                }
	                Qy(c[r >> 2] | 0, 4) | 0;
	                c[p >> 2] = c[o >> 2];
	                a:while (1) {
	                    y = c[o >> 2] | 0;
	                    if (!(d[c[o >> 2] >> 0] | 0)) {
	                        z = 70;
	                        break
	                    }
	                    if ((d[y >> 0] | 0 | 0) != 38) {
	                        c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        continue
	                    }
	                    c[s >> 2] = 0;
	                    if ((c[o >> 2] | 0) != (c[p >> 2] | 0) ? (cz(c[r >> 2] | 0, c[p >> 2] | 0, (c[o >> 2] | 0) - (c[p >> 2] | 0) | 0) | 0) != 0 : 0)break;
	                    c[p >> 2] = c[o >> 2];
	                    if ((d[(c[o >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 ? (d[(c[o >> 2] | 0) + 2 >> 0] | 0 | 0) == 120 : 0) {
	                        c[o >> 2] = (c[o >> 2] | 0) + 3;
	                        a[t >> 0] = a[c[o >> 2] >> 0] | 0;
	                        b:while (1) {
	                            if ((d[t >> 0] | 0 | 0) == 59)break;
	                            if ((d[t >> 0] | 0 | 0) >= 48 ? (d[t >> 0] | 0 | 0) <= 57 : 0)c[s >> 2] = (c[s >> 2] << 4) + ((d[t >> 0] | 0) - 48); else z = 17;
	                            do if ((z | 0) == 17) {
	                                z = 0;
	                                if ((d[t >> 0] | 0 | 0) >= 97 ? (d[t >> 0] | 0 | 0) <= 102 : 0) {
	                                    c[s >> 2] = (c[s >> 2] << 4) + ((d[t >> 0] | 0) - 97) + 10;
	                                    break
	                                }
	                                if ((d[t >> 0] | 0 | 0) < 65) {
	                                    z = 23;
	                                    break b
	                                }
	                                if ((d[t >> 0] | 0 | 0) > 70) {
	                                    z = 23;
	                                    break b
	                                }
	                                c[s >> 2] = (c[s >> 2] << 4) + ((d[t >> 0] | 0) - 65) + 10
	                            } while (0);
	                            c[o >> 2] = (c[o >> 2] | 0) + 1;
	                            a[t >> 0] = a[c[o >> 2] >> 0] | 0
	                        }
	                        if ((z | 0) == 23) {
	                            z = 0;
	                            uj(1300, c[h >> 2] | 0, 0);
	                            c[s >> 2] = 0
	                        }
	                        if ((d[t >> 0] | 0 | 0) == 59)c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        c[p >> 2] = c[o >> 2]
	                    } else z = 28;
	                    do if ((z | 0) == 28) {
	                        z = 0;
	                        j = c[o >> 2] | 0;
	                        if ((d[(c[o >> 2] | 0) + 1 >> 0] | 0 | 0) == 35) {
	                            c[o >> 2] = j + 2;
	                            a[t >> 0] = a[c[o >> 2] >> 0] | 0;
	                            while (1) {
	                                if ((d[t >> 0] | 0 | 0) == 59)break;
	                                if ((d[t >> 0] | 0 | 0) < 48) {
	                                    z = 34;
	                                    break
	                                }
	                                if ((d[t >> 0] | 0 | 0) > 57) {
	                                    z = 34;
	                                    break
	                                }
	                                c[s >> 2] = ((c[s >> 2] | 0) * 10 | 0) + ((d[t >> 0] | 0) - 48);
	                                c[o >> 2] = (c[o >> 2] | 0) + 1;
	                                a[t >> 0] = a[c[o >> 2] >> 0] | 0
	                            }
	                            if ((z | 0) == 34) {
	                                z = 0;
	                                uj(1301, c[h >> 2] | 0, 0);
	                                c[s >> 2] = 0
	                            }
	                            if ((d[t >> 0] | 0 | 0) == 59)c[o >> 2] = (c[o >> 2] | 0) + 1;
	                            c[p >> 2] = c[o >> 2];
	                            break
	                        }
	                        c[o >> 2] = j + 1;
	                        c[p >> 2] = c[o >> 2];
	                        while (1) {
	                            if (d[c[o >> 2] >> 0] | 0)A = (d[c[o >> 2] >> 0] | 0 | 0) != 59; else A = 0;
	                            B = c[o >> 2] | 0;
	                            if (!A)break;
	                            c[o >> 2] = B + 1
	                        }
	                        if (!(d[B >> 0] | 0)) {
	                            z = 44;
	                            break a
	                        }
	                        if ((c[o >> 2] | 0) != (c[p >> 2] | 0)) {
	                            c[n >> 2] = ly(c[p >> 2] | 0, (c[o >> 2] | 0) - (c[p >> 2] | 0) | 0) | 0;
	                            c[q >> 2] = ad(c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                            if ((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 48 >> 2] | 0) == 6 : 0) {
	                                if (ez(c[r >> 2] | 0, c[(c[q >> 2] | 0) + 40 >> 2] | 0) | 0)break a
	                            } else z = 49;
	                            do if ((z | 0) == 49) {
	                                z = 0;
	                                do if (!(az(c[r >> 2] | 0) | 0)) {
	                                    c[m >> 2] = Wh(c[h >> 2] | 0, 0) | 0;
	                                    j = Ny(c[r >> 2] | 0) | 0;
	                                    c[(c[m >> 2] | 0) + 40 >> 2] = j;
	                                    if (!(c[l >> 2] | 0)) {
	                                        j = c[m >> 2] | 0;
	                                        c[k >> 2] = j;
	                                        c[l >> 2] = j;
	                                        break
	                                    } else {
	                                        c[l >> 2] = Xh(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                                        break
	                                    }
	                                } while (0);
	                                c[m >> 2] = Yh(c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                                if (!(c[m >> 2] | 0)) {
	                                    z = 54;
	                                    break a
	                                }
	                                c:do if ((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                                    j = Zh(c[h >> 2] | 0, c[(c[m >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 12 >> 2] = j;
	                                    c[(c[q >> 2] | 0) + 68 >> 2] = 1;
	                                    c[u >> 2] = c[(c[q >> 2] | 0) + 12 >> 2];
	                                    while (1) {
	                                        if (!(c[u >> 2] | 0))break c;
	                                        c[(c[u >> 2] | 0) + 20 >> 2] = c[q >> 2];
	                                        c[u >> 2] = c[(c[u >> 2] | 0) + 24 >> 2]
	                                    }
	                                } while (0);
	                                if (!(c[l >> 2] | 0)) {
	                                    j = c[m >> 2] | 0;
	                                    c[k >> 2] = j;
	                                    c[l >> 2] = j;
	                                    break
	                                } else {
	                                    c[l >> 2] = Xh(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    break
	                                }
	                            } while (0);
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                        }
	                        c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        c[p >> 2] = c[o >> 2]
	                    } while (0);
	                    if (!(c[s >> 2] | 0))continue;
	                    c[w >> 2] = pe(v, c[s >> 2] | 0) | 0;
	                    a[v + (c[w >> 2] | 0) >> 0] = 0;
	                    if (ez(c[r >> 2] | 0, v) | 0)break;
	                    c[s >> 2] = 0
	                }
	                do if ((z | 0) == 44)uj(1302, c[h >> 2] | 0, c[p >> 2] | 0); else if ((z | 0) == 54) {
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                } else if ((z | 0) == 70) {
	                    if ((c[k >> 2] | 0) == 0 ? 1 : (y | 0) != (c[p >> 2] | 0))cz(c[r >> 2] | 0, c[p >> 2] | 0, (c[o >> 2] | 0) - (c[p >> 2] | 0) | 0) | 0;
	                    if (!(az(c[r >> 2] | 0) | 0)) {
	                        c[m >> 2] = Wh(c[h >> 2] | 0, 0) | 0;
	                        s = Ny(c[r >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 40 >> 2] = s;
	                        if (!(c[l >> 2] | 0)) {
	                            s = c[m >> 2] | 0;
	                            c[k >> 2] = s;
	                            c[l >> 2] = s;
	                            break
	                        } else {
	                            c[l >> 2] = Xh(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                            break
	                        }
	                    }
	                } while (0);
	                Ry(c[r >> 2] | 0);
	                c[g >> 2] = c[k >> 2];
	                x = c[g >> 2] | 0;
	                i = f;
	                return x | 0
	            }

	            function _h(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 36 | 0;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 16 | 0;
	                n = f + 12 | 0;
	                o = f + 8 | 0;
	                p = f + 4 | 0;
	                q = f;
	                r = f + 40 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[j >> 2];
	                c[m >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 2 : 0)c[o >> 2] = 1; else c[o >> 2] = 0;
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    do if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                        if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                            if (!(c[k >> 2] | 0)) {
	                                a[r >> 0] = 38;
	                                a[r + 1 >> 0] = 0;
	                                c[m >> 2] = zy(c[m >> 2] | 0, r, 1) | 0;
	                                c[m >> 2] = By(c[m >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                a[r >> 0] = 59;
	                                a[r + 1 >> 0] = 0;
	                                c[m >> 2] = zy(c[m >> 2] | 0, r, 1) | 0;
	                                break
	                            }
	                            c[n >> 2] = ad(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0)) {
	                                c[m >> 2] = By(c[m >> 2] | 0, c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                break
	                            }
	                            c[q >> 2] = _h(c[h >> 2] | 0, c[(c[n >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                            if (c[q >> 2] | 0) {
	                                c[m >> 2] = By(c[m >> 2] | 0, c[q >> 2] | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[q >> 2] | 0)
	                            }
	                        }
	                    } else t = 10; while (0);
	                    do if ((t | 0) == 10) {
	                        t = 0;
	                        if (c[k >> 2] | 0) {
	                            c[m >> 2] = By(c[m >> 2] | 0, c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            break
	                        }
	                        j = c[h >> 2] | 0;
	                        e = c[(c[l >> 2] | 0) + 40 >> 2] | 0;
	                        if (c[o >> 2] | 0)c[p >> 2] = bd(j, e) | 0; else c[p >> 2] = cd(j, e) | 0;
	                        if (c[p >> 2] | 0) {
	                            c[m >> 2] = By(c[m >> 2] | 0, c[p >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                        }
	                    } while (0);
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                c[g >> 2] = c[m >> 2];
	                s = c[g >> 2] | 0;
	                i = f;
	                return s | 0
	            }

	            function $h(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = wj(c[g >> 2] | 0, 0, c[h >> 2] | 0, c[j >> 2] | 0, 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function ai(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = wj(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function bi(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = wj(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function ci(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    tj(75320);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 48 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                c[(c[k >> 2] | 0) + 4 >> 2] = 2;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                    d = AP(c[(c[g >> 2] | 0) + 80 >> 2] | 0, c[h >> 2] | 0, -1) | 0;
	                    c[(c[k >> 2] | 0) + 8 >> 2] = d
	                } else {
	                    d = my(c[h >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 8 >> 2] = d
	                }
	                c[(c[k >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                a:do if (c[j >> 2] | 0) {
	                    d = Zh(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = d;
	                    c[(c[k >> 2] | 0) + 16 >> 2] = 0;
	                    c[l >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[l >> 2] | 0))break a;
	                        c[(c[l >> 2] | 0) + 20 >> 2] = c[k >> 2];
	                        if (!(c[(c[l >> 2] | 0) + 24 >> 2] | 0))c[(c[k >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[k >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function di(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!((c[d >> 2] | 0) != 0 & (c[d >> 2] | 0) != 0)) {
	                    i = b;
	                    return
	                }
	                do {
	                    c[e >> 2] = c[(c[d >> 2] | 0) + 24 >> 2];
	                    ei(c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                } while ((c[d >> 2] | 0) != 0);
	                i = b;
	                return
	            }

	            function ei(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[d >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 40 >> 2] | 0) == 2 : 0)Gm(c[(c[d >> 2] | 0) + 32 >> 2] | 0, c[d >> 2] | 0) | 0;
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)Uh(c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                do if (c[(c[d >> 2] | 0) + 8 >> 2] | 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0)
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function fi(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if (!(c[(c[e >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 44 >> 2];
	                if ((c[f >> 2] | 0) == (c[e >> 2] | 0)) {
	                    c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 44 >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                    if (c[(c[e >> 2] | 0) + 24 >> 2] | 0)c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = 0;
	                    ei(c[e >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        h = 15;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) == (c[e >> 2] | 0))break;
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                }
	                if ((h | 0) == 15) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                if (c[(c[f >> 2] | 0) + 24 >> 2] | 0)c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = c[f >> 2];
	                ei(c[e >> 2] | 0);
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function gi(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    tj(75344);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 60 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                c[(c[k >> 2] | 0) + 4 >> 2] = 7;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                    d = AP(c[(c[g >> 2] | 0) + 80 >> 2] | 0, c[h >> 2] | 0, -1) | 0;
	                    c[(c[k >> 2] | 0) + 8 >> 2] = d
	                } else {
	                    d = my(c[h >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 8 >> 2] = d
	                }
	                if (c[j >> 2] | 0) {
	                    d = my(c[j >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 40 >> 2] = d
	                }
	                c[(c[k >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[k >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function hi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    tj(75360);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 60 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[h >> 2] | 0) + 4 >> 2] = 1;
	                b = my(c[g >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 8 >> 2] = b;
	                c[(c[h >> 2] | 0) + 36 >> 2] = c[f >> 2];
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[h >> 2] | 0);
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function ii(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    tj(75360);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 60 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[h >> 2] | 0) + 4 >> 2] = 1;
	                c[(c[h >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                c[(c[h >> 2] | 0) + 36 >> 2] = c[f >> 2];
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[h >> 2] | 0);
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function ji(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                    e = c[h >> 2] | 0;
	                    c[l >> 2] = ii(e, AP(c[(c[g >> 2] | 0) + 80 >> 2] | 0, c[j >> 2] | 0, -1) | 0) | 0
	                } else c[l >> 2] = hi(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    n = c[l >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[(c[l >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    n = c[l >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                j = Zh(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[(c[l >> 2] | 0) + 12 >> 2] = j;
	                if (!(c[l >> 2] | 0)) {
	                    n = c[l >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                if (!(c[m >> 2] | 0)) {
	                    c[(c[l >> 2] | 0) + 16 >> 2] = 0;
	                    n = c[l >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                while (1) {
	                    j = (c[(c[m >> 2] | 0) + 24 >> 2] | 0) != 0;
	                    c[(c[m >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                    o = c[m >> 2] | 0;
	                    if (!j)break;
	                    c[m >> 2] = c[o + 24 >> 2]
	                }
	                c[(c[l >> 2] | 0) + 16 >> 2] = o;
	                n = c[l >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function ki(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = ii(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                do if (c[l >> 2] | 0) {
	                    c[(c[l >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                    if ((c[k >> 2] | 0) != 0 ? (h = Zh(c[g >> 2] | 0, c[k >> 2] | 0) | 0, c[(c[l >> 2] | 0) + 12 >> 2] = h, (c[l >> 2] | 0) != 0) : 0) {
	                        c[m >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                        if (!(c[m >> 2] | 0)) {
	                            c[(c[l >> 2] | 0) + 16 >> 2] = 0;
	                            break
	                        }
	                        while (1) {
	                            h = (c[(c[m >> 2] | 0) + 24 >> 2] | 0) != 0;
	                            c[(c[m >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                            n = c[m >> 2] | 0;
	                            if (!h)break;
	                            c[m >> 2] = c[n + 24 >> 2]
	                        }
	                        c[(c[l >> 2] | 0) + 16 >> 2] = n
	                    }
	                } else if ((c[j >> 2] | 0) != 0 & (c[g >> 2] | 0) != 0 ? (CP(c[(c[g >> 2] | 0) + 80 >> 2] | 0, c[j >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0); while (0);
	                i = f;
	                return c[l >> 2] | 0
	            }

	            function li(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tj(75376);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 60 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 4 >> 2] = 3;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 75104;
	                if (c[e >> 2] | 0) {
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = a
	                }
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[f >> 2] | 0);
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function mi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    tj(75392);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                b = (c[j >> 2] | 0) + 0 | 0;
	                a = b + 60 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[j >> 2] | 0) + 4 >> 2] = 5;
	                c[(c[j >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                g = c[h >> 2] | 0;
	                do if ((d[c[h >> 2] >> 0] | 0 | 0) == 38) {
	                    c[h >> 2] = g + 1;
	                    c[k >> 2] = xy(c[h >> 2] | 0) | 0;
	                    b = c[h >> 2] | 0;
	                    a = c[k >> 2] | 0;
	                    if ((d[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 1) >> 0] | 0 | 0) == 59) {
	                        m = ly(b, a - 1 | 0) | 0;
	                        c[(c[j >> 2] | 0) + 8 >> 2] = m;
	                        break
	                    } else {
	                        m = ly(b, a) | 0;
	                        c[(c[j >> 2] | 0) + 8 >> 2] = m;
	                        break
	                    }
	                } else {
	                    m = my(g) | 0;
	                    c[(c[j >> 2] | 0) + 8 >> 2] = m
	                } while (0);
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[j >> 2] | 0);
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function ni(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    tj(75376);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 60 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[h >> 2] | 0) + 4 >> 2] = 3;
	                c[(c[h >> 2] | 0) + 8 >> 2] = 75104;
	                if (c[f >> 2] | 0) {
	                    b = ly(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 40 >> 2] = b
	                }
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[h >> 2] | 0);
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function oi(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tj(75448);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 60 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 4 >> 2] = 8;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 75128;
	                if (c[e >> 2] | 0) {
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = a
	                }
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[f >> 2] | 0);
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function pi(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    tj(75472);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 60 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                c[(c[k >> 2] | 0) + 4 >> 2] = 4;
	                c[(c[k >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                if (c[h >> 2] | 0) {
	                    g = ly(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 40 >> 2] = g
	                }
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[k >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function qi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = oi(c[f >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    h = c[g >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[g >> 2] | 0) + 32 >> 2] = c[e >> 2];
	                h = c[g >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function ri(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 32 >> 2] | 0) == (c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                a:do if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    c[g >> 2] = c[(c[e >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0))break a;
	                        c[(c[g >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                        si(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[f >> 2] | 0);
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)si(c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[f >> 2] | 0);
	                c[(c[e >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                i = d;
	                return
	            }

	            function si(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[e >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != (c[f >> 2] | 0))ri(c[g >> 2] | 0, c[f >> 2] | 0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                i = d;
	                return
	            }

	            function ti(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                do if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    e = c[(c[h >> 2] | 0) + 32 >> 2] | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[m >> 2] = ji(e, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[m >> 2] = ji(e, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        break
	                    }
	                } else {
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 11) {
	                            c[m >> 2] = ji(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                            break
	                        }
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    e = c[h >> 2] | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[m >> 2] = ji(e, 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[m >> 2] = ji(e, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        break
	                    }
	                } while (0);
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[(c[m >> 2] | 0) + 4 >> 2] = 1;
	                c[(c[m >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                c[(c[m >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                    c[(c[h >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                    c[(c[h >> 2] | 0) + 16 >> 2] = c[m >> 2]
	                } else {
	                    c[n >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                    c[(c[n >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                    c[(c[m >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                    c[(c[h >> 2] | 0) + 16 >> 2] = c[m >> 2]
	                }
	                c[g >> 2] = c[m >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function ui(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = xy(c[f >> 2] | 0) | 0;
	                $i(c[e >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0);
	                i = d;
	                return
	            }

	            function vi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                switch (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    case 8:
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 4:
	                    case 3:
	                    {
	                        do if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) != ((c[e >> 2] | 0) + 44 | 0) : 0) {
	                            if (((c[(c[e >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (CP(c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0, c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0)break;
	                            zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 40 >> 2] | 0)
	                        } while (0);
	                        if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)Uh(c[(c[e >> 2] | 0) + 12 >> 2] | 0);
	                        c[(c[e >> 2] | 0) + 12 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                        if (c[f >> 2] | 0) {
	                            b = my(c[f >> 2] | 0) | 0;
	                            c[(c[e >> 2] | 0) + 40 >> 2] = b
	                        } else c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                        c[(c[e >> 2] | 0) + 48 >> 2] = 0;
	                        i = d;
	                        return
	                    }
	                    case 2:
	                    case 1:
	                    case 11:
	                    {
	                        if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)Uh(c[(c[e >> 2] | 0) + 12 >> 2] | 0);
	                        b = Zh(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[f >> 2] | 0) | 0;
	                        c[(c[e >> 2] | 0) + 12 >> 2] = b;
	                        if (!(c[e >> 2] | 0)) {
	                            i = d;
	                            return
	                        }
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        if (!(c[g >> 2] | 0)) {
	                            c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                            i = d;
	                            return
	                        }
	                        while (1) {
	                            b = (c[(c[g >> 2] | 0) + 24 >> 2] | 0) != 0;
	                            c[(c[g >> 2] | 0) + 20 >> 2] = c[e >> 2];
	                            h = c[g >> 2] | 0;
	                            if (!b)break;
	                            c[g >> 2] = c[h + 24 >> 2]
	                        }
	                        c[(c[e >> 2] | 0) + 16 >> 2] = h;
	                        i = d;
	                        return
	                    }
	                    default:
	                    {
	                        i = d;
	                        return
	                    }
	                }
	            }

	            function wi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        Qh(c[g >> 2] | 0);
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                                c[h >> 2] = my(c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                c[h >> 2] = By(c[h >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                vi(c[f >> 2] | 0, c[h >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                Rh(c[g >> 2] | 0);
	                                c[e >> 2] = c[f >> 2];
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            }
	                            if (((c[(c[f >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                                ui(c[(c[f >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                                Rh(c[g >> 2] | 0);
	                                c[e >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            }
	                        } else if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                            c[e >> 2] = vj(c[(c[f >> 2] | 0) + 28 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != (c[(c[f >> 2] | 0) + 32 >> 2] | 0))ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                        c[(c[g >> 2] | 0) + 24 >> 2] = c[f >> 2];
	                        c[(c[g >> 2] | 0) + 28 >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                        c[(c[f >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                        if (c[(c[g >> 2] | 0) + 28 >> 2] | 0)c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0) == (c[f >> 2] | 0) : 0)c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function xi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        if (((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0)c[f >> 2] = c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2]; else k = 15;
	                        a:do if ((k | 0) == 15)while (1) {
	                            k = 0;
	                            if (!(c[(c[f >> 2] | 0) + 24 >> 2] | 0))break a;
	                            c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                            k = 15
	                        } while (0);
	                        Qh(c[g >> 2] | 0);
	                        if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) == (c[(c[g >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                            ui(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                            Rh(c[g >> 2] | 0);
	                            c[e >> 2] = c[f >> 2];
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                            c[e >> 2] = vj(c[f >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            j = c[e >> 2] | 0;
	                            i = d;
	                            return j | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != (c[(c[f >> 2] | 0) + 32 >> 2] | 0))ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                        c[(c[g >> 2] | 0) + 28 >> 2] = c[f >> 2];
	                        c[(c[g >> 2] | 0) + 24 >> 2] = 0;
	                        c[(c[g >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                        c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function yi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        b = c[g >> 2] | 0;
	                        if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0))c[(c[f >> 2] | 0) + 12 >> 2] = b; else {
	                            do if (((c[b + 4 >> 2] | 0) == 3 ? (c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                                ui(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                                a = c[g >> 2] | 0;
	                                if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                                    c[h >> 2] = a;
	                                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                                    Rh(c[h >> 2] | 0);
	                                    break
	                                }
	                                Rh(a);
	                                c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                                j = c[e >> 2] | 0;
	                                i = d;
	                                return j | 0
	                            } while (0);
	                            c[h >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            c[(c[h >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                            c[(c[g >> 2] | 0) + 28 >> 2] = c[h >> 2]
	                        }
	                        while (1) {
	                            h = (c[(c[g >> 2] | 0) + 24 >> 2] | 0) != 0;
	                            c[(c[g >> 2] | 0) + 20 >> 2] = c[f >> 2];
	                            k = (c[(c[g >> 2] | 0) + 32 >> 2] | 0) != (c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                            if (!h)break;
	                            if (k)ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                        }
	                        if (k)ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function zi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                            if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3 ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) == (c[(c[g >> 2] | 0) + 8 >> 2] | 0) : 0) {
	                                ui(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                                Rh(c[g >> 2] | 0);
	                                c[e >> 2] = c[f >> 2];
	                                l = c[e >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                            if ((((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[g >> 2] | 0) + 8 >> 2] | 0) : 0) ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != (c[g >> 2] | 0) : 0) {
	                                ui(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                                Rh(c[g >> 2] | 0);
	                                c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                                l = c[e >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                        }
	                        c[h >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                        c[(c[g >> 2] | 0) + 20 >> 2] = c[f >> 2];
	                        if ((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != (c[(c[f >> 2] | 0) + 32 >> 2] | 0))ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        if ((c[h >> 2] | 0) == (c[f >> 2] | 0)) {
	                            c[e >> 2] = c[g >> 2];
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3 ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[f >> 2] | 0) != (c[g >> 2] | 0) : 0) {
	                            ui(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                            Rh(c[g >> 2] | 0);
	                            c[e >> 2] = c[f >> 2];
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        b = c[f >> 2] | 0;
	                        do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 2)if (!(c[b + 12 >> 2] | 0)) {
	                            c[(c[f >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                            c[(c[f >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                            break
	                        } else {
	                            c[h >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            c[(c[h >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                            c[(c[g >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                            c[(c[f >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                            break
	                        } else {
	                            if ((c[b + 4 >> 2] | 0) != 1) {
	                                c[e >> 2] = 0;
	                                l = c[e >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                            if (c[(c[f >> 2] | 0) + 44 >> 2] | 0) {
	                                a = c[f >> 2] | 0;
	                                m = c[(c[g >> 2] | 0) + 8 >> 2] | 0;
	                                if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0))c[j >> 2] = Ai(a, m, 0) | 0; else c[j >> 2] = Ai(a, m, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                do if ((c[j >> 2] | 0) != 0 ? (c[j >> 2] | 0) != (c[g >> 2] | 0) : 0) {
	                                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 16)break;
	                                    Qh(c[j >> 2] | 0);
	                                    ei(c[j >> 2] | 0)
	                                } while (0);
	                                if ((c[j >> 2] | 0) == (c[g >> 2] | 0)) {
	                                    c[e >> 2] = c[g >> 2];
	                                    l = c[e >> 2] | 0;
	                                    i = d;
	                                    return l | 0
	                                }
	                            }
	                            if (!(c[(c[f >> 2] | 0) + 44 >> 2] | 0)) {
	                                c[(c[f >> 2] | 0) + 44 >> 2] = c[g >> 2];
	                                break
	                            }
	                            c[k >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                            while (1) {
	                                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0))break;
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                            }
	                            c[(c[k >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                            c[(c[g >> 2] | 0) + 28 >> 2] = c[k >> 2]
	                        } while (0);
	                        c[e >> 2] = c[g >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Ai(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = xj(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, c[18946] | 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function Bi(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function Ci(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        b = c[f >> 2] | 0;
	                        if ((c[g >> 2] | 0) == (c[f >> 2] | 0)) {
	                            c[e >> 2] = b;
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if ((c[b + 4 >> 2] | 0) == 2 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) {
	                            c[e >> 2] = c[f >> 2];
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 2 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) {
	                            c[e >> 2] = c[f >> 2];
	                            h = c[e >> 2] | 0;
	                            i = d;
	                            return h | 0
	                        }
	                        Qh(c[g >> 2] | 0);
	                        ri(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                        c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)c[(c[(c[g >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                        c[(c[g >> 2] | 0) + 28 >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                        if (c[(c[g >> 2] | 0) + 28 >> 2] | 0)c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                        do if (c[(c[g >> 2] | 0) + 20 >> 2] | 0) {
	                            b = c[(c[g >> 2] | 0) + 20 >> 2] | 0;
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                                if ((c[b + 44 >> 2] | 0) != (c[f >> 2] | 0))break;
	                                c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 44 >> 2] = c[g >> 2];
	                                break
	                            }
	                            if ((c[b + 12 >> 2] | 0) == (c[f >> 2] | 0))c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                            if ((c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] | 0) == (c[f >> 2] | 0))c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] = c[g >> 2]
	                        } while (0);
	                        c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 24 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                        c[e >> 2] = c[f >> 2];
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    Qh(c[f >> 2] | 0);
	                    c[e >> 2] = c[f >> 2];
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Di(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0)if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    c[f >> 2] = Ih(0, c[(c[e >> 2] | 0) + 8 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    break
	                } else {
	                    c[d >> 2] = 0;
	                    break
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function Ei(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                c[f >> 2] = 0;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[g >> 2] = Di(c[d >> 2] | 0) | 0;
	                    a = c[g >> 2] | 0;
	                    if (!(c[f >> 2] | 0)) {
	                        c[f >> 2] = a;
	                        c[e >> 2] = a
	                    } else {
	                        c[c[f >> 2] >> 2] = a;
	                        c[f >> 2] = c[g >> 2]
	                    }
	                    c[d >> 2] = c[c[d >> 2] >> 2]
	                }
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Fi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = yj(0, c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function Gi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        m = 11;
	                        break
	                    }
	                    c[k >> 2] = Fi(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        m = 6;
	                        break
	                    }
	                    b = c[k >> 2] | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[j >> 2] = b;
	                        c[h >> 2] = b
	                    } else {
	                        c[(c[j >> 2] | 0) + 24 >> 2] = b;
	                        c[(c[k >> 2] | 0) + 28 >> 2] = c[j >> 2];
	                        c[j >> 2] = c[k >> 2]
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                if ((m | 0) == 6) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 11) {
	                    c[e >> 2] = c[h >> 2];
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Hi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = zj(c[e >> 2] | 0, 0, 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return c[g >> 2] | 0
	            }

	            function Ii(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = zj(c[f >> 2] | 0, c[g >> 2] | 0, 0, c[h >> 2] | 0) | 0;
	                i = e;
	                return c[j >> 2] | 0
	            }

	            function Ji(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = Aj(c[f >> 2] | 0, c[e >> 2] | 0, 0) | 0;
	                i = d;
	                return c[g >> 2] | 0
	            }

	            function Ki(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Aj(c[d >> 2] | 0, 0, 0) | 0;
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function Li(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 32 | 0;
	                e = b + 28 | 0;
	                f = b + 24 | 0;
	                g = b + 20 | 0;
	                h = b + 16 | 0;
	                j = b + 12 | 0;
	                k = b + 8 | 0;
	                l = b + 4 | 0;
	                m = b;
	                c[e >> 2] = a;
	                c[h >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    n = c[d >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[f >> 2] = Mh(0, c[(c[e >> 2] | 0) + 8 >> 2] | 0, c[(c[e >> 2] | 0) + 52 >> 2] | 0, c[(c[e >> 2] | 0) + 56 >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    n = c[d >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                if (c[(c[e >> 2] | 0) + 48 >> 2] | 0) {
	                    a = ed(c[(c[e >> 2] | 0) + 48 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 48 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 36 >> 2] | 0) {
	                    a = zm(c[(c[e >> 2] | 0) + 36 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 36 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 40 >> 2] | 0) {
	                    a = om(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 44 >> 2] | 0) {
	                    a = vm(c[(c[e >> 2] | 0) + 44 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 44 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 60 >> 2] | 0) {
	                    a = ed(c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 60 >> 2] = a
	                }
	                c[g >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    c[j >> 2] = 0;
	                    e = c[g >> 2] | 0;
	                    a:do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 17) {
	                        a = c[g >> 2] | 0;
	                        if ((c[e + 4 >> 2] | 0) == 15) {
	                            c[l >> 2] = a;
	                            c[j >> 2] = Mm(c[f >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 48 >> 2] | 0) | 0;
	                            break
	                        }
	                        o = c[g >> 2] | 0;
	                        if ((c[a + 4 >> 2] | 0) == 16) {
	                            c[m >> 2] = o;
	                            c[j >> 2] = Nm(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 60 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[m >> 2] | 0) + 56 >> 2] | 0) | 0;
	                            break
	                        }
	                        if ((c[o + 4 >> 2] | 0) == 8)c[j >> 2] = Hi(c[g >> 2] | 0, 0) | 0
	                    } else {
	                        c[k >> 2] = e;
	                        switch (c[(c[k >> 2] | 0) + 48 >> 2] | 0) {
	                            case 3:
	                            case 2:
	                            case 1:
	                            {
	                                c[j >> 2] = Bj(c[f >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                break a;
	                                break
	                            }
	                            case 5:
	                            case 4:
	                            {
	                                c[j >> 2] = Cj(c[f >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                break a;
	                                break
	                            }
	                            default:
	                                break a
	                        }
	                    } while (0);
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    e = c[j >> 2] | 0;
	                    if (!(c[h >> 2] | 0))c[(c[f >> 2] | 0) + 12 >> 2] = e; else c[(c[h >> 2] | 0) + 24 >> 2] = e;
	                    c[(c[j >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                    c[(c[j >> 2] | 0) + 20 >> 2] = c[f >> 2];
	                    c[(c[j >> 2] | 0) + 24 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                    c[h >> 2] = c[j >> 2];
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                c[d >> 2] = c[f >> 2];
	                n = c[d >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function Mi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = Sh(c[(c[f >> 2] | 0) + 56 >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                    b = Cb[c[135768 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = b
	                }
	                if (c[(c[f >> 2] | 0) + 60 >> 2] | 0) {
	                    b = my(c[(c[f >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 60 >> 2] = b
	                }
	                if (c[(c[f >> 2] | 0) + 72 >> 2] | 0) {
	                    b = my(c[(c[f >> 2] | 0) + 72 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 72 >> 2] = b
	                }
	                c[(c[h >> 2] | 0) + 76 >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                c[(c[h >> 2] | 0) + 36 >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                c[(c[h >> 2] | 0) + 40 >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                b = c[h >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = b;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[b + 16 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                do if (c[(c[f >> 2] | 0) + 44 >> 2] | 0) {
	                    b = Li(c[(c[f >> 2] | 0) + 44 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 44 >> 2] = b;
	                    b = c[h >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 44 >> 2] | 0) {
	                        ri(c[b + 44 >> 2] | 0, c[h >> 2] | 0);
	                        c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                        break
	                    }
	                    Th(b);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } while (0);
	                if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                    b = Ei(c[(c[f >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 52 >> 2] = b
	                }
	                a:do if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                    b = Aj(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 12 >> 2] = b;
	                    c[(c[h >> 2] | 0) + 16 >> 2] = 0;
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[j >> 2] | 0))break a;
	                        if (!(c[(c[j >> 2] | 0) + 24 >> 2] | 0))c[(c[h >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function Ni(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = Dj(c[d >> 2] | 0, 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function Oi(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                e = i;
	                i = i + 176 | 0;
	                f = e;
	                g = e + 64 | 0;
	                h = e + 60 | 0;
	                j = e + 56 | 0;
	                k = e + 52 | 0;
	                l = e + 48 | 0;
	                m = e + 44 | 0;
	                n = e + 40 | 0;
	                o = e + 36 | 0;
	                p = e + 32 | 0;
	                q = e + 28 | 0;
	                r = e + 24 | 0;
	                s = e + 68 | 0;
	                t = e + 20 | 0;
	                u = e + 16 | 0;
	                c[h >> 2] = b;
	                c[m >> 2] = 0;
	                c[t >> 2] = 0;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    c[o >> 2] = 500;
	                    c[m >> 2] = Cb[c[135752 >> 2] & 511](c[o >> 2] | 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        tj(75488);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    }
	                    c[p >> 2] = Cb[c[135752 >> 2] & 511](c[o >> 2] | 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        tj(75488);
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    }
	                    a[c[m >> 2] >> 0] = 0;
	                    c[j >> 2] = c[h >> 2];
	                    while (1) {
	                        c[r >> 2] = 75312;
	                        c[q >> 2] = 75512;
	                        c[t >> 2] = 0;
	                        a:do if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                            if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                c[u >> 2] = 0;
	                                c[q >> 2] = 75520;
	                                c[r >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                                do if (c[(c[j >> 2] | 0) + 36 >> 2] | 0)if (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) {
	                                    h = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                                    c[f >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                                    c[f + 4 >> 2] = h;
	                                    JT(s, 99, 75528, f) | 0;
	                                    a[s + 99 >> 0] = 0;
	                                    c[r >> 2] = s;
	                                    break
	                                } else {
	                                    c[u >> 2] = 1;
	                                    c[r >> 2] = 75536;
	                                    break
	                                } while (0);
	                                c[l >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                c[k >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                                while (1) {
	                                    if (!(c[k >> 2] | 0))break;
	                                    do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                        if (!(c[u >> 2] | 0)) {
	                                            if (!(qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0))break;
	                                            if ((c[(c[k >> 2] | 0) + 36 >> 2] | 0) != (c[(c[j >> 2] | 0) + 36 >> 2] | 0)) {
	                                                if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0))break;
	                                                if (!(c[(c[j >> 2] | 0) + 36 >> 2] | 0))break;
	                                                if (!(qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0))break
	                                            }
	                                        }
	                                        c[t >> 2] = (c[t >> 2] | 0) + 1
	                                    } while (0);
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 28 >> 2]
	                                }
	                                if (c[t >> 2] | 0) {
	                                    c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    break
	                                }
	                                c[k >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                                while (1) {
	                                    if (!((c[k >> 2] | 0) != 0 & (c[t >> 2] | 0) == 0))break;
	                                    b:do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                        do if (!(c[u >> 2] | 0)) {
	                                            if (!(qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0))break b;
	                                            if ((c[(c[k >> 2] | 0) + 36 >> 2] | 0) == (c[(c[j >> 2] | 0) + 36 >> 2] | 0))break;
	                                            if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0))break b;
	                                            if (!(c[(c[j >> 2] | 0) + 36 >> 2] | 0))break b;
	                                            if (!(qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0))break b
	                                        } while (0);
	                                        c[t >> 2] = (c[t >> 2] | 0) + 1
	                                    } while (0);
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                                }
	                                if (!(c[t >> 2] | 0))break;
	                                c[t >> 2] = 1;
	                                break
	                            }
	                            if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 8) {
	                                c[q >> 2] = 75520;
	                                c[r >> 2] = 75544;
	                                c[l >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                c[k >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                                while (1) {
	                                    if (!(c[k >> 2] | 0))break;
	                                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 8)c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 28 >> 2]
	                                }
	                                if (c[t >> 2] | 0) {
	                                    c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    break
	                                }
	                                c[k >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                                while (1) {
	                                    if (!((c[k >> 2] | 0) != 0 & (c[t >> 2] | 0) == 0))break;
	                                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 8)c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                                }
	                                if (!(c[t >> 2] | 0))break;
	                                c[t >> 2] = 1;
	                                break
	                            }
	                            if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                                if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 7) {
	                                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 2) {
	                                        c[l >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                        break
	                                    }
	                                    c[q >> 2] = 75600;
	                                    c[r >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                                    if (c[(c[j >> 2] | 0) + 36 >> 2] | 0) {
	                                        h = c[j >> 2] | 0;
	                                        if (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) {
	                                            b = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                                            c[f >> 2] = c[(c[h + 36 >> 2] | 0) + 12 >> 2];
	                                            c[f + 4 >> 2] = b;
	                                            JT(s, 99, 75528, f) | 0
	                                        } else {
	                                            c[f >> 2] = c[h + 8 >> 2];
	                                            JT(s, 99, 75608, f) | 0
	                                        }
	                                        a[s + 99 >> 0] = 0;
	                                        c[r >> 2] = s
	                                    }
	                                    c[l >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                    break
	                                }
	                                c[q >> 2] = 75520;
	                                c[f >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                                JT(s, 99, 75568, f) | 0;
	                                a[s + 99 >> 0] = 0;
	                                c[r >> 2] = s;
	                                c[l >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                                c[k >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                                while (1) {
	                                    if (!(c[k >> 2] | 0))break;
	                                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 7 ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 28 >> 2]
	                                }
	                                if (c[t >> 2] | 0) {
	                                    c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                    break
	                                }
	                                c[k >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                                while (1) {
	                                    if (!((c[k >> 2] | 0) != 0 & (c[t >> 2] | 0) == 0))break;
	                                    do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 7) {
	                                        if (!(qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0))break;
	                                        c[t >> 2] = (c[t >> 2] | 0) + 1
	                                    } while (0);
	                                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                                }
	                                if (!(c[t >> 2] | 0))break;
	                                c[t >> 2] = 1;
	                                break
	                            }
	                            c[q >> 2] = 75520;
	                            c[r >> 2] = 75560;
	                            c[l >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                            c[k >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break;
	                                if (!((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 4 : 0))c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 28 >> 2]
	                            }
	                            if (c[t >> 2] | 0) {
	                                c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                break
	                            }
	                            c[k >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break a;
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 3)break;
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 4)break;
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                            }
	                            c[t >> 2] = 1
	                        } else w = 11; while (0);
	                        if ((w | 0) == 11) {
	                            w = 0;
	                            if ((d[c[m >> 2] >> 0] | 0 | 0) == 47) {
	                                w = 110;
	                                break
	                            }
	                            c[q >> 2] = 75520;
	                            c[l >> 2] = 0
	                        }
	                        h = (xy(c[m >> 2] | 0) | 0) + 120 | 0;
	                        if (h >>> 0 > (c[o >> 2] | 0) >>> 0) {
	                            h = c[o >> 2] << 1;
	                            c[o >> 2] = h + (xy(c[m >> 2] | 0) | 0) + 120;
	                            c[n >> 2] = Hb[c[135760 >> 2] & 511](c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0)) {
	                                w = 102;
	                                break
	                            }
	                            c[m >> 2] = c[n >> 2];
	                            c[n >> 2] = Hb[c[135760 >> 2] & 511](c[p >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (!(c[n >> 2] | 0)) {
	                                w = 104;
	                                break
	                            }
	                            c[p >> 2] = c[n >> 2]
	                        }
	                        h = c[p >> 2] | 0;
	                        b = c[o >> 2] | 0;
	                        x = c[q >> 2] | 0;
	                        y = c[r >> 2] | 0;
	                        if (!(c[t >> 2] | 0)) {
	                            z = c[m >> 2] | 0;
	                            c[f >> 2] = x;
	                            c[f + 4 >> 2] = y;
	                            c[f + 8 >> 2] = z;
	                            JT(h, b, 75616, f) | 0
	                        } else {
	                            z = c[t >> 2] | 0;
	                            A = c[m >> 2] | 0;
	                            c[f >> 2] = x;
	                            c[f + 4 >> 2] = y;
	                            c[f + 8 >> 2] = z;
	                            c[f + 12 >> 2] = A;
	                            JT(h, b, 75624, f) | 0
	                        }
	                        b = c[m >> 2] | 0;
	                        h = c[o >> 2] | 0;
	                        c[f >> 2] = c[p >> 2];
	                        JT(b, h, 75608, f) | 0;
	                        c[j >> 2] = c[l >> 2];
	                        if (!(c[j >> 2] | 0)) {
	                            w = 110;
	                            break
	                        }
	                    }
	                    if ((w | 0) == 102) {
	                        tj(75488);
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    } else if ((w | 0) == 104) {
	                        tj(75488);
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    } else if ((w | 0) == 110) {
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        c[g >> 2] = c[m >> 2];
	                        v = c[g >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    }
	                }
	                c[g >> 2] = 0;
	                v = c[g >> 2] | 0;
	                i = e;
	                return v | 0
	            }

	            function Pi(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    h = c[f >> 2] | 0;
	                    if (!(c[f >> 2] | 0)) {
	                        j = 8;
	                        break
	                    }
	                    k = c[f >> 2] | 0;
	                    if ((c[h + 4 >> 2] | 0) == 1) {
	                        j = 6;
	                        break
	                    }
	                    c[f >> 2] = c[k + 24 >> 2]
	                }
	                if ((j | 0) == 6) {
	                    c[d >> 2] = k;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else if ((j | 0) == 8) {
	                    c[d >> 2] = h;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Qi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    Qh(c[g >> 2] | 0);
	                    ri(c[g >> 2] | 0, c[f >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 20 >> 2] = c[f >> 2];
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break;
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1)break;
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2]
	                    }
	                    do if (!(c[h >> 2] | 0))if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[(c[f >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                        c[(c[f >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        break
	                    } else {
	                        xi(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break
	                    } else Ci(c[h >> 2] | 0, c[g >> 2] | 0) | 0; while (0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Ri(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = c[h >> 2];
	                if ((c[h >> 2] | 0) != 0 ? !((c[j >> 2] | 0) == 0 ? 1 : (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 18) : 0) {
	                    if (qy(c[j >> 2] | 0, 75176) | 0) {
	                        if ((c[g >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                            c[k >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                            if (!(c[k >> 2] | 0)) {
	                                tj(75760);
	                                c[f >> 2] = 0;
	                                n = c[f >> 2] | 0;
	                                i = e;
	                                return n | 0
	                            } else {
	                                d = c[k >> 2] | 0;
	                                c[d + 0 >> 2] = 0;
	                                c[d + 4 >> 2] = 0;
	                                c[d + 8 >> 2] = 0;
	                                c[d + 12 >> 2] = 0;
	                                c[d + 16 >> 2] = 0;
	                                c[d + 20 >> 2] = 0;
	                                c[(c[k >> 2] | 0) + 4 >> 2] = 18;
	                                d = my(75176) | 0;
	                                c[(c[k >> 2] | 0) + 8 >> 2] = d;
	                                d = my(75168) | 0;
	                                c[(c[k >> 2] | 0) + 12 >> 2] = d;
	                                c[c[k >> 2] >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                                c[(c[h >> 2] | 0) + 48 >> 2] = c[k >> 2];
	                                c[f >> 2] = c[k >> 2];
	                                n = c[f >> 2] | 0;
	                                i = e;
	                                return n | 0
	                            }
	                        }
	                        if ((c[g >> 2] | 0) == 0 ? (c[g >> 2] = c[(c[h >> 2] | 0) + 32 >> 2], (c[g >> 2] | 0) == 0) : 0) {
	                            c[f >> 2] = 0;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                        d = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 52 >> 2] | 0)) {
	                            c[f >> 2] = Ej(d) | 0;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        } else {
	                            c[f >> 2] = c[d + 52 >> 2];
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                    }
	                    c[m >> 2] = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 2 & 1;
	                    a:while (1) {
	                        if (!(c[h >> 2] | 0)) {
	                            o = 41;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                            o = 21;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 6) {
	                            o = 21;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                            o = 21;
	                            break
	                        }
	                        do if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            c[k >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break;
	                                do if (((c[j >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                                    if ((c[m >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)break;
	                                    if ((Fj(c[g >> 2] | 0, c[l >> 2] | 0, c[h >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0) == 1) {
	                                        o = 30;
	                                        break a
	                                    }
	                                } while (0);
	                                c[k >> 2] = c[c[k >> 2] >> 2]
	                            }
	                            if ((((c[l >> 2] | 0) != (c[h >> 2] | 0) ? (c[k >> 2] = c[(c[h >> 2] | 0) + 36 >> 2], (c[k >> 2] | 0) != 0) : 0) ? ((c[j >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                                if ((c[m >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)break;
	                                if ((Fj(c[g >> 2] | 0, c[l >> 2] | 0, c[h >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0) == 1) {
	                                    o = 39;
	                                    break a
	                                }
	                            }
	                        } while (0);
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((o | 0) == 21) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 30) {
	                        c[f >> 2] = c[k >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 39) {
	                        c[f >> 2] = c[k >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((o | 0) == 41) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                }
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function Si(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (c[j >> 2] | 0)p = c[(c[j >> 2] | 0) + 8 >> 2] | 0; else p = 0;
	                c[m >> 2] = xj(c[h >> 2] | 0, c[k >> 2] | 0, p, 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = wj(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if ((c[(c[m >> 2] | 0) + 40 >> 2] | 0) == 2) {
	                    Gm(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 40 >> 2] = 2
	                }
	                if (c[(c[m >> 2] | 0) + 12 >> 2] | 0)Uh(c[(c[m >> 2] | 0) + 12 >> 2] | 0);
	                c[(c[m >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[m >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[m >> 2] | 0) + 36 >> 2] = c[j >> 2];
	                a:do if (c[l >> 2] | 0) {
	                    if ((Fy(c[l >> 2] | 0) | 0) == 0 ? (uj(1303, c[(c[h >> 2] | 0) + 32 >> 2] | 0, 0), (c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0) : 0) {
	                        j = my(75792) | 0;
	                        c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 60 >> 2] = j
	                    }
	                    j = Wh(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[l >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 12 >> 2] = j;
	                    c[(c[m >> 2] | 0) + 16 >> 2] = 0;
	                    c[n >> 2] = c[(c[m >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[n >> 2] | 0))break a;
	                        c[(c[n >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                        if (!(c[(c[n >> 2] | 0) + 24 >> 2] | 0))c[(c[m >> 2] | 0) + 16 >> 2] = c[n >> 2];
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if ((c[(c[m >> 2] | 0) + 40 >> 2] | 0) == 2)Cm(0, c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                c[g >> 2] = c[m >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Ti(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    while (1) {
	                        if (!(c[e >> 2] | 0)) {
	                            g = 8;
	                            break
	                        }
	                        c[f >> 2] = Ui(c[e >> 2] | 0, 75640, 75176) | 0;
	                        if (c[f >> 2] | 0) {
	                            g = 6;
	                            break
	                        }
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((g | 0) == 6) {
	                        c[d >> 2] = c[f >> 2];
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    } else if ((g | 0) == 8) {
	                        c[d >> 2] = 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                }
	                c[d >> 2] = 0;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Ui(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = xj(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[18946] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = Gj(c[k >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Vi(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    while (1) {
	                        if (!(c[e >> 2] | 0)) {
	                            g = 11;
	                            break
	                        }
	                        c[f >> 2] = Ui(c[e >> 2] | 0, 75648, 75176) | 0;
	                        if (c[f >> 2] | 0) {
	                            if (qy(c[f >> 2] | 0, 75664) | 0) {
	                                g = 7;
	                                break
	                            }
	                            a = (qy(c[f >> 2] | 0, 75656) | 0) != 0;
	                            zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                            if (a) {
	                                g = 9;
	                                break
	                            }
	                        }
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((g | 0) == 7) {
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[d >> 2] = 1;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    } else if ((g | 0) == 9) {
	                        c[d >> 2] = 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    } else if ((g | 0) == 11) {
	                        c[d >> 2] = -1;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                }
	                c[d >> 2] = -1;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Wi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                switch (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    case 9:
	                    case 21:
	                    case 13:
	                    {
	                        c[j >> 2] = c[e >> 2];
	                        if (c[(c[j >> 2] | 0) + 72 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[j >> 2] | 0) + 72 >> 2] | 0);
	                        if (!(c[f >> 2] | 0)) {
	                            c[(c[j >> 2] | 0) + 72 >> 2] = 0;
	                            i = d;
	                            return
	                        } else {
	                            b = Kl(c[f >> 2] | 0) | 0;
	                            c[(c[j >> 2] | 0) + 72 >> 2] = b;
	                            i = d;
	                            return
	                        }
	                        break
	                    }
	                    case 20:
	                    case 19:
	                    case 18:
	                    case 6:
	                    case 5:
	                    case 7:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    case 12:
	                    case 11:
	                    case 10:
	                    case 8:
	                    case 4:
	                    case 3:
	                    {
	                        i = d;
	                        return
	                    }
	                    default:
	                    {
	                        c[g >> 2] = Ri(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[e >> 2] | 0, 75176) | 0;
	                        if (!(c[g >> 2] | 0)) {
	                            i = d;
	                            return
	                        }
	                        c[h >> 2] = Kl(c[f >> 2] | 0) | 0;
	                        b = c[e >> 2] | 0;
	                        e = c[g >> 2] | 0;
	                        if (c[h >> 2] | 0) {
	                            Si(b, e, 75680, c[h >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            i = d;
	                            return
	                        } else {
	                            Si(b, e, 75680, c[f >> 2] | 0) | 0;
	                            i = d;
	                            return
	                        }
	                    }
	                }
	            }

	            function Xi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 & (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (!(c[f >> 2] | 0))c[f >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 13 : 0) {
	                    c[g >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0)) {
	                            n = 22;
	                            break
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                            n = 22;
	                            break
	                        }
	                        b = c[g >> 2] | 0;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                            c[g >> 2] = c[b + 24 >> 2];
	                            continue
	                        }
	                        a = (ty(c[b + 8 >> 2] | 0, 75688) | 0) != 0;
	                        b = c[g >> 2] | 0;
	                        if (!a) {
	                            c[g >> 2] = c[b + 12 >> 2];
	                            continue
	                        }
	                        a = (ty(c[b + 8 >> 2] | 0, 75696) | 0) != 0;
	                        b = c[g >> 2] | 0;
	                        if (!a) {
	                            c[g >> 2] = c[b + 12 >> 2];
	                            continue
	                        }
	                        a = (ty(c[b + 8 >> 2] | 0, 75680) | 0) != 0;
	                        o = c[g >> 2] | 0;
	                        if (!a) {
	                            n = 20;
	                            break
	                        }
	                        c[g >> 2] = c[o + 24 >> 2]
	                    }
	                    if ((n | 0) == 20) {
	                        c[e >> 2] = Yi(o, 75704) | 0;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else if ((n | 0) == 22) {
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        n = 38;
	                        break
	                    }
	                    p = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                        n = 25;
	                        break
	                    }
	                    if ((c[p + 4 >> 2] | 0) == 1 ? (c[j >> 2] = Ui(c[g >> 2] | 0, 75680, 75176) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        if (c[h >> 2] | 0) {
	                            c[k >> 2] = Hl(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                            o = (c[k >> 2] | 0) != 0;
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            if (!o) {
	                                n = 31;
	                                break
	                            }
	                            c[h >> 2] = c[k >> 2]
	                        } else c[h >> 2] = c[j >> 2];
	                        if (!(sy(c[h >> 2] | 0, 75712, 7) | 0)) {
	                            n = 36;
	                            break
	                        }
	                        if (!(sy(c[h >> 2] | 0, 75720, 6) | 0)) {
	                            n = 36;
	                            break
	                        }
	                        if (!(sy(c[h >> 2] | 0, 75728, 4) | 0)) {
	                            n = 36;
	                            break
	                        }
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2]
	                }
	                if ((n | 0) == 25) {
	                    c[l >> 2] = p;
	                    c[e >> 2] = my(c[(c[l >> 2] | 0) + 64 >> 2] | 0) | 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((n | 0) == 31) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((n | 0) == 36) {
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((n | 0) == 38) {
	                    if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 72 >> 2] | 0) != 0 : 0)if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = my(c[(c[f >> 2] | 0) + 72 >> 2] | 0) | 0;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else {
	                        c[k >> 2] = Hl(c[h >> 2] | 0, c[(c[f >> 2] | 0) + 72 >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[e >> 2] = c[k >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function Yi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = dj(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = Gj(c[h >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function Zi(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                a:do switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                    case 1:
	                    case 11:
	                    {
	                        c[h >> 2] = c[g >> 2];
	                        b:while (1) {
	                            if (!(c[h >> 2] | 0))break a;
	                            b = c[(c[h >> 2] | 0) + 4 >> 2] | 0;
	                            if ((b | 0) == 5)Zi(c[f >> 2] | 0, c[h >> 2] | 0) | 0; else if ((b | 0) == 3 | (b | 0) == 4 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0)ez(c[f >> 2] | 0, c[(c[h >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) {
	                                c[h >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                                continue
	                            }
	                            if ((c[h >> 2] | 0) == (c[g >> 2] | 0))break a;
	                            if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                                c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                continue
	                            }
	                            while (1) {
	                                c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                                if (!(c[h >> 2] | 0))continue b;
	                                if ((c[h >> 2] | 0) == (c[g >> 2] | 0)) {
	                                    o = 19;
	                                    break
	                                }
	                                p = c[h >> 2] | 0;
	                                if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                                    o = 21;
	                                    break
	                                }
	                                if (!p)continue b
	                            }
	                            if ((o | 0) == 19) {
	                                o = 0;
	                                c[h >> 2] = 0;
	                                continue
	                            } else if ((o | 0) == 21) {
	                                o = 0;
	                                c[h >> 2] = c[p + 24 >> 2];
	                                continue
	                            }
	                        }
	                        break
	                    }
	                    case 3:
	                    case 4:
	                    {
	                        ez(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 9:
	                    case 21:
	                    case 13:
	                    {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[g >> 2] | 0))break a;
	                            if (!(((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 4 : 0))Zi(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        ez(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[j >> 2] = c[g >> 2];
	                        c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break a;
	                            b = c[f >> 2] | 0;
	                            a = c[k >> 2] | 0;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 3)ez(b, c[a + 40 >> 2] | 0) | 0; else Zi(b, a) | 0;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                        break
	                    }
	                    case 7:
	                    case 8:
	                    {
	                        ez(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[l >> 2] = ad(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[e >> 2] = -1;
	                            n = c[e >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                        c[m >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0))break a;
	                            Zi(c[f >> 2] | 0, c[m >> 2] | 0) | 0;
	                            c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                        }
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function _i(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 36 | 0;
	                e = b + 32 | 0;
	                f = b + 28 | 0;
	                g = b + 24 | 0;
	                h = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[e >> 2] = a;
	                a:do if (!(c[e >> 2] | 0))c[d >> 2] = 0; else do switch (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    case 13:
	                    case 21:
	                    case 9:
	                    {
	                        c[l >> 2] = Ly() | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[d >> 2] = 0;
	                            break a
	                        } else {
	                            Zi(c[l >> 2] | 0, c[e >> 2] | 0) | 0;
	                            c[m >> 2] = Ny(c[l >> 2] | 0) | 0;
	                            Ry(c[l >> 2] | 0);
	                            c[d >> 2] = c[m >> 2];
	                            break a
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = Gj(c[e >> 2] | 0) | 0;
	                        break a;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[h >> 2] = ad(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[d >> 2] = 0;
	                            break a
	                        }
	                        c[j >> 2] = Ly() | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            c[d >> 2] = 0;
	                            break a
	                        } else {
	                            Zi(c[j >> 2] | 0, c[e >> 2] | 0) | 0;
	                            c[k >> 2] = Ny(c[j >> 2] | 0) | 0;
	                            Ry(c[j >> 2] | 0);
	                            c[d >> 2] = c[k >> 2];
	                            break a
	                        }
	                        break
	                    }
	                    case 1:
	                    case 11:
	                    {
	                        c[f >> 2] = My(64) | 0;
	                        if (!(c[f >> 2] | 0)) {
	                            c[d >> 2] = 0;
	                            break a
	                        } else {
	                            Zi(c[f >> 2] | 0, c[e >> 2] | 0) | 0;
	                            c[g >> 2] = Ny(c[f >> 2] | 0) | 0;
	                            Ry(c[f >> 2] | 0);
	                            c[d >> 2] = c[g >> 2];
	                            break a
	                        }
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = 0;
	                        break a;
	                        break
	                    }
	                    case 3:
	                    case 4:
	                    {
	                        if (c[(c[e >> 2] | 0) + 40 >> 2] | 0) {
	                            c[d >> 2] = my(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[d >> 2] = 0;
	                            break a
	                        }
	                        break
	                    }
	                    case 18:
	                    {
	                        c[n >> 2] = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[d >> 2] = c[n >> 2];
	                        break a;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = 0;
	                        break a;
	                        break
	                    }
	                    case 20:
	                    case 19:
	                    case 14:
	                    case 12:
	                    case 10:
	                    case 6:
	                    {
	                        c[d >> 2] = 0;
	                        break a;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = 0;
	                        break a;
	                        break
	                    }
	                    case 7:
	                    case 8:
	                    {
	                        if (c[(c[e >> 2] | 0) + 40 >> 2] | 0) {
	                            c[d >> 2] = my(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[d >> 2] = 0;
	                            break a
	                        }
	                        break
	                    }
	                    default:
	                    {
	                        c[d >> 2] = 0;
	                        break a
	                    }
	                } while (0); while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function $i(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[f >> 2] | 0) == 0 | (c[h >> 2] | 0) <= 0) {
	                    i = e;
	                    return
	                }
	                switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    case 8:
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 4:
	                    case 3:
	                    case 12:
	                    {
	                        if (!(c[g >> 2] | 0)) {
	                            i = e;
	                            return
	                        }
	                        do if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != ((c[f >> 2] | 0) + 44 | 0)) {
	                            if (((c[(c[f >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (CP(c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0)break;
	                            d = zy(c[(c[f >> 2] | 0) + 40 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                            c[(c[f >> 2] | 0) + 40 >> 2] = d;
	                            i = e;
	                            return
	                        } while (0);
	                        d = Ay(c[(c[f >> 2] | 0) + 40 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 40 >> 2] = d;
	                        c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                        c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                        i = e;
	                        return
	                    }
	                    case 1:
	                    case 11:
	                    {
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        c[k >> 2] = ni(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            i = e;
	                            return
	                        }
	                        c[l >> 2] = zi(c[f >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if (!((c[j >> 2] | 0) != 0 ? (c[l >> 2] | 0) == (c[k >> 2] | 0) : 0)) {
	                            i = e;
	                            return
	                        }
	                        if ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) != (c[k >> 2] | 0)) {
	                            i = e;
	                            return
	                        }
	                        aj(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        i = e;
	                        return
	                    }
	                    default:
	                    {
	                        i = e;
	                        return
	                    }
	                }
	            }

	            function aj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = c[g >> 2] | 0;
	                do if (c[f >> 2] | 0) {
	                    a = c[f >> 2] | 0;
	                    if (!b) {
	                        c[e >> 2] = a;
	                        break
	                    }
	                    if ((c[a + 4 >> 2] | 0) != 3) {
	                        c[e >> 2] = c[f >> 2];
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 3) {
	                        c[e >> 2] = c[f >> 2];
	                        break
	                    }
	                    a = c[f >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != (c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[e >> 2] = a;
	                        break
	                    } else {
	                        ui(a, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                        Qh(c[g >> 2] | 0);
	                        Rh(c[g >> 2] | 0);
	                        c[e >> 2] = c[f >> 2];
	                        break
	                    }
	                } else c[e >> 2] = b; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function bj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[d + 24 >> 2] = a;
	                c[f >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 10;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    a:while (1) {
	                        if (!(c[f >> 2] | 0)) {
	                            m = 24;
	                            break
	                        }
	                        b:do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            c[g >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                            while (1) {
	                                if (!(c[g >> 2] | 0))break b;
	                                if (!(c[h >> 2] | 0)) {
	                                    c[h >> 2] = Cb[c[135744 >> 2] & 511]((c[k >> 2] | 0) + 1 << 2) | 0;
	                                    if (!(c[h >> 2] | 0)) {
	                                        m = 10;
	                                        break a
	                                    }
	                                    c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2] = 0
	                                }
	                                c[l >> 2] = 0;
	                                while (1) {
	                                    if ((c[l >> 2] | 0) >= (c[j >> 2] | 0))break;
	                                    if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == (c[(c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0))break;
	                                    if (qy(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 12 >> 2] | 0) | 0)break;
	                                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                                }
	                                if ((c[l >> 2] | 0) >= (c[j >> 2] | 0)) {
	                                    if ((c[j >> 2] | 0) >= (c[k >> 2] | 0) ? (c[k >> 2] = c[k >> 2] << 1, c[h >> 2] = Hb[c[135760 >> 2] & 511](c[h >> 2] | 0, (c[k >> 2] | 0) + 1 << 2) | 0, (c[h >> 2] | 0) == 0) : 0) {
	                                        m = 20;
	                                        break a
	                                    }
	                                    b = c[g >> 2] | 0;
	                                    a = c[j >> 2] | 0;
	                                    c[j >> 2] = a + 1;
	                                    c[(c[h >> 2] | 0) + (a << 2) >> 2] = b;
	                                    c[(c[h >> 2] | 0) + (c[j >> 2] << 2) >> 2] = 0
	                                }
	                                c[g >> 2] = c[c[g >> 2] >> 2]
	                            }
	                        } while (0);
	                        c[f >> 2] = c[(c[f >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((m | 0) == 10) {
	                        tj(75736);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } else if ((m | 0) == 20) {
	                        tj(75736);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    } else if ((m | 0) == 24) {
	                        c[e >> 2] = c[h >> 2];
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function cj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = c[h >> 2];
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if ((c[j >> 2] | 0) != 0 ? (qy(c[j >> 2] | 0, 75168) | 0) != 0 : 0) {
	                        if ((c[g >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                            c[k >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                            if (!(c[k >> 2] | 0)) {
	                                tj(75760);
	                                c[f >> 2] = 0;
	                                m = c[f >> 2] | 0;
	                                i = e;
	                                return m | 0
	                            } else {
	                                d = c[k >> 2] | 0;
	                                c[d + 0 >> 2] = 0;
	                                c[d + 4 >> 2] = 0;
	                                c[d + 8 >> 2] = 0;
	                                c[d + 12 >> 2] = 0;
	                                c[d + 16 >> 2] = 0;
	                                c[d + 20 >> 2] = 0;
	                                c[(c[k >> 2] | 0) + 4 >> 2] = 18;
	                                d = my(75176) | 0;
	                                c[(c[k >> 2] | 0) + 8 >> 2] = d;
	                                d = my(75168) | 0;
	                                c[(c[k >> 2] | 0) + 12 >> 2] = d;
	                                c[c[k >> 2] >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                                c[(c[h >> 2] | 0) + 48 >> 2] = c[k >> 2];
	                                c[f >> 2] = c[k >> 2];
	                                m = c[f >> 2] | 0;
	                                i = e;
	                                return m | 0
	                            }
	                        }
	                        if ((c[g >> 2] | 0) == 0 ? (c[g >> 2] = c[(c[h >> 2] | 0) + 32 >> 2], (c[g >> 2] | 0) == 0) : 0) {
	                            c[f >> 2] = 0;
	                            m = c[f >> 2] | 0;
	                            i = e;
	                            return m | 0
	                        }
	                        d = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 52 >> 2] | 0)) {
	                            c[f >> 2] = Ej(d) | 0;
	                            m = c[f >> 2] | 0;
	                            i = e;
	                            return m | 0
	                        } else {
	                            c[f >> 2] = c[d + 52 >> 2];
	                            m = c[f >> 2] | 0;
	                            i = e;
	                            return m | 0
	                        }
	                    }
	                    a:while (1) {
	                        if (!(c[h >> 2] | 0)) {
	                            n = 43;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                            n = 21;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 6) {
	                            n = 21;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                            n = 21;
	                            break
	                        }
	                        if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                            c[k >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break;
	                                if (((c[j >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                    n = 27;
	                                    break a
	                                }
	                                if ((((c[j >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                                    n = 31;
	                                    break a
	                                }
	                                c[k >> 2] = c[c[k >> 2] >> 2]
	                            }
	                            if ((c[l >> 2] | 0) != (c[h >> 2] | 0) ? (c[k >> 2] = c[(c[h >> 2] | 0) + 36 >> 2], (c[k >> 2] | 0) != 0) : 0) {
	                                if (((c[j >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                    n = 37;
	                                    break
	                                }
	                                if ((((c[j >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                                    n = 41;
	                                    break
	                                }
	                            }
	                        }
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2]
	                    }
	                    if ((n | 0) == 21) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((n | 0) == 27) {
	                        c[f >> 2] = c[k >> 2];
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((n | 0) == 31) {
	                        c[f >> 2] = c[k >> 2];
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((n | 0) == 37) {
	                        c[f >> 2] = c[k >> 2];
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((n | 0) == 41) {
	                        c[f >> 2] = c[k >> 2];
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else if ((n | 0) == 43) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                }
	                c[f >> 2] = 0;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function dj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? !((c[g >> 2] | 0) == 0 ? 1 : (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1) : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break;
	                        b = (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0) != 0;
	                        l = c[h >> 2] | 0;
	                        if (b) {
	                            m = 7;
	                            break
	                        }
	                        c[h >> 2] = c[l + 24 >> 2]
	                    }
	                    if ((m | 0) == 7) {
	                        c[e >> 2] = l;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                    if (!(c[18946] | 0)) {
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                    c[j >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                    if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                        c[k >> 2] = Fm(c[(c[j >> 2] | 0) + 44 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if ((c[k >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[k >> 2] = Fm(c[(c[j >> 2] | 0) + 48 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                            c[e >> 2] = c[k >> 2];
	                            n = c[e >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                    }
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[e >> 2] = 0;
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function ej(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = xj(c[f >> 2] | 0, c[g >> 2] | 0, 0, c[18946] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = Gj(c[h >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function fj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = xj(c[f >> 2] | 0, c[g >> 2] | 0, 0, 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    Qh(c[h >> 2] | 0);
	                    ei(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function gj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    c[l >> 2] = Dh(c[h >> 2] | 0, k) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[n >> 2] = ly(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        c[m >> 2] = cj(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        if (c[m >> 2] | 0) {
	                            c[f >> 2] = Si(c[g >> 2] | 0, c[m >> 2] | 0, c[l >> 2] | 0, c[j >> 2] | 0) | 0;
	                            o = c[f >> 2] | 0;
	                            i = e;
	                            return o | 0
	                        }
	                    }
	                    c[f >> 2] = Si(c[g >> 2] | 0, 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[f >> 2] = 0;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function hj(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0)if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                    c[d >> 2] = 1;
	                    break
	                } else {
	                    c[d >> 2] = 0;
	                    break
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function ij(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                a:while (1) {
	                    if (!(d[c[g >> 2] >> 0] | 0)) {
	                        j = 16;
	                        break
	                    }
	                    do if ((d[c[g >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) != 13) {
	                            j = 14;
	                            break a
	                        }
	                    } while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if ((j | 0) == 14) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 16) {
	                    c[e >> 2] = 1;
	                    h = c[e >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function jj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 7 : 0) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                do if ((c[(c[g >> 2] | 0) + 40 >> 2] | 0) == ((c[g >> 2] | 0) + 44 | 0))l = 12; else {
	                    if (((c[(c[g >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (CP(c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0) {
	                        l = 12;
	                        break
	                    }
	                    d = zy(c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 40 >> 2] = d
	                } while (0);
	                if ((l | 0) == 12) {
	                    l = Ay(c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[g >> 2] | 0) + 40 >> 2] = l
	                }
	                c[(c[g >> 2] | 0) + 44 >> 2] = 0;
	                if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function kj() {
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    tj(75808);
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[(c[e >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 8 >> 2] = c[33950];
	                c[(c[e >> 2] | 0) + 12 >> 2] = c[33948];
	                g = Cb[c[135752 >> 2] & 511](c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                c[c[e >> 2] >> 2] = g;
	                if (!(c[c[e >> 2] >> 2] | 0)) {
	                    tj(75808);
	                    zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else {
	                    a[c[c[e >> 2] >> 2] >> 0] = 0;
	                    c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                    c[d >> 2] = c[e >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function lj(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[d >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0); else e = 5;
	                if (((e | 0) == 5 ? (c[c[d >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 2 : 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function mj(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[k >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if ((c[h >> 2] | 0) >>> 0 < (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0) {
	                    c[f >> 2] = 1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                d = c[(c[g >> 2] | 0) + 12 >> 2] | 0;
	                a:do if ((d | 0) == 4) {
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) >>> 0 < 4096) {
	                        c[j >> 2] = c[h >> 2];
	                        break
	                    }
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 8 >> 2] << 1;
	                    while (1) {
	                        if ((c[h >> 2] | 0) >>> 0 <= (c[j >> 2] | 0) >>> 0)break a;
	                        if ((c[j >> 2] | 0) >>> 0 > 2147483647)break;
	                        c[j >> 2] = c[j >> 2] << 1
	                    }
	                    tj(75824);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else if ((d | 0) == 1)c[j >> 2] = (c[h >> 2] | 0) + 10; else if ((d | 0) == 0 | (d | 0) == 3) {
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)n = c[(c[g >> 2] | 0) + 8 >> 2] << 1; else n = (c[h >> 2] | 0) + 10 | 0;
	                    c[j >> 2] = n;
	                    while (1) {
	                        if ((c[h >> 2] | 0) >>> 0 <= (c[j >> 2] | 0) >>> 0)break a;
	                        if ((c[j >> 2] | 0) >>> 0 > 2147483647)break;
	                        c[j >> 2] = c[j >> 2] << 1
	                    }
	                    tj(75824);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else c[j >> 2] = (c[h >> 2] | 0) + 10; while (0);
	                do if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 3 ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                    c[l >> 2] = (c[c[g >> 2] >> 2] | 0) - (c[(c[g >> 2] | 0) + 16 >> 2] | 0);
	                    if ((c[l >> 2] | 0) >>> 0 > (c[j >> 2] | 0) >>> 0) {
	                        fU(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        c[c[g >> 2] >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        a[(c[c[g >> 2] >> 2] | 0) + (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >> 0] = 0;
	                        h = (c[g >> 2] | 0) + 8 | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + (c[l >> 2] | 0);
	                        break
	                    }
	                    c[k >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0, (c[l >> 2] | 0) + (c[j >> 2] | 0) | 0) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                        c[c[g >> 2] >> 2] = (c[k >> 2] | 0) + (c[l >> 2] | 0);
	                        break
	                    }
	                    tj(75824);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else o = 32; while (0);
	                do if ((o | 0) == 32) {
	                    do if (c[c[g >> 2] >> 2] | 0) {
	                        if (((c[(c[g >> 2] | 0) + 8 >> 2] | 0) - (c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) >>> 0 < 100) {
	                            c[k >> 2] = Hb[c[135760 >> 2] & 511](c[c[g >> 2] >> 2] | 0, c[j >> 2] | 0) | 0;
	                            break
	                        }
	                        c[k >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0;
	                        if (c[k >> 2] | 0) {
	                            eU(c[k >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[c[g >> 2] >> 2] | 0);
	                            a[(c[k >> 2] | 0) + (c[(c[g >> 2] | 0) + 4 >> 2] | 0) >> 0] = 0
	                        }
	                    } else c[k >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0; while (0);
	                    if (c[k >> 2] | 0) {
	                        c[c[g >> 2] >> 2] = c[k >> 2];
	                        break
	                    }
	                    tj(75824);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                c[f >> 2] = 1;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function nj(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                do if ((c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0)c[g >> 2] = -1; else {
	                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if ((c[k >> 2] | 0) < -1) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if ((c[k >> 2] | 0) < 0)c[k >> 2] = xy(c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    c[l >> 2] = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) + (c[k >> 2] | 0) + 2;
	                    if ((c[l >> 2] | 0) >>> 0 > (c[(c[h >> 2] | 0) + 8 >> 2] | 0) >>> 0 ? (mj(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0) {
	                        tj(75824);
	                        c[g >> 2] = 2;
	                        break
	                    }
	                    fU((c[c[h >> 2] >> 2] | 0) + (c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                    e = (c[h >> 2] | 0) + 4 | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + (c[k >> 2] | 0);
	                    a[(c[c[h >> 2] >> 2] | 0) + (c[(c[h >> 2] | 0) + 4 >> 2] | 0) >> 0] = 0;
	                    c[g >> 2] = 0
	                } while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function oj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    } else {
	                        c[e >> 2] = nj(c[f >> 2] | 0, c[g >> 2] | 0, -1) | 0;
	                        break
	                    }
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function pj(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = c[h >> 2];
	                while (1) {
	                    l = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                    if (!(a[c[j >> 2] >> 0] | 0)) {
	                        m = 13;
	                        break
	                    }
	                    if ((l + 10 | 0) >>> 0 >= (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 ? (mj(c[g >> 2] | 0, (c[(c[g >> 2] | 0) + 4 >> 2] | 0) + 10 | 0) | 0) == 0 : 0) {
	                        m = 11;
	                        break
	                    }
	                    h = a[c[j >> 2] >> 0] | 0;
	                    d = (c[g >> 2] | 0) + 4 | 0;
	                    b = c[d >> 2] | 0;
	                    c[d >> 2] = b + 1;
	                    a[(c[c[g >> 2] >> 2] | 0) + b >> 0] = h;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((m | 0) == 11) {
	                    tj(75824);
	                    c[f >> 2] = 2;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else if ((m | 0) == 13) {
	                    a[(c[c[g >> 2] >> 2] | 0) + l >> 0] = 0;
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function qj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                    i = d;
	                    return
	                }
	                oj(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function rj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                    i = d;
	                    return
	                }
	                pj(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function sj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) == 2) {
	                    i = e;
	                    return
	                }
	                if (!(vy(c[g >> 2] | 0, 34) | 0)) {
	                    pj(c[f >> 2] | 0, 75840) | 0;
	                    oj(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    pj(c[f >> 2] | 0, 75840) | 0;
	                    i = e;
	                    return
	                }
	                b = (vy(c[g >> 2] | 0, 39) | 0) != 0;
	                a = c[f >> 2] | 0;
	                if (!b) {
	                    pj(a, 75856) | 0;
	                    oj(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    pj(c[f >> 2] | 0, 75856) | 0;
	                    i = e;
	                    return
	                }
	                pj(a, 75840) | 0;
	                a = c[g >> 2] | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = a;
	                while (1) {
	                    if (!(d[c[h >> 2] >> 0] | 0))break;
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) != 34) {
	                        c[h >> 2] = (c[h >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((c[j >> 2] | 0) != (c[h >> 2] | 0))nj(c[f >> 2] | 0, c[j >> 2] | 0, (c[h >> 2] | 0) - (c[j >> 2] | 0) | 0) | 0;
	                    nj(c[f >> 2] | 0, 75848, 6) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[j >> 2] = c[h >> 2]
	                }
	                if ((c[j >> 2] | 0) != (c[h >> 2] | 0))nj(c[f >> 2] | 0, c[j >> 2] | 0, (c[h >> 2] | 0) - (c[j >> 2] | 0) | 0) | 0;
	                pj(c[f >> 2] | 0, 75840) | 0;
	                i = e;
	                return
	            }

	            function tj(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ce(2, 2, 0, 0, c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function uj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                d = c[f >> 2] | 0;
	                if ((d | 0) == 1302)c[j >> 2] = 76032; else if ((d | 0) == 1300)c[j >> 2] = 75952; else if ((d | 0) == 1301)c[j >> 2] = 75992; else if ((d | 0) == 1303)c[j >> 2] = 76072; else c[j >> 2] = 76096;
	                ce(2, c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function vj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (((c[h >> 2] | 0) != 0 ? !((c[j >> 2] | 0) == 0 ? 1 : (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 2) : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 2 : 0)break;
	                    d = c[(c[h >> 2] | 0) + 20 >> 2] | 0;
	                    b = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                    if (!(c[(c[j >> 2] | 0) + 36 >> 2] | 0))c[k >> 2] = Ai(d, b, 0) | 0; else c[k >> 2] = Ai(d, b, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if ((c[(c[j >> 2] | 0) + 32 >> 2] | 0) != (c[(c[h >> 2] | 0) + 32 >> 2] | 0))ri(c[j >> 2] | 0, c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                    c[(c[j >> 2] | 0) + 20 >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                    c[(c[j >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                    if (c[g >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        c[(c[g >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                        if (c[(c[j >> 2] | 0) + 24 >> 2] | 0)c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = c[j >> 2]
	                    } else {
	                        c[(c[j >> 2] | 0) + 24 >> 2] = c[h >> 2];
	                        c[(c[h >> 2] | 0) + 28 >> 2] = c[j >> 2]
	                    }
	                    if ((c[(c[j >> 2] | 0) + 28 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 44 >> 2] = c[j >> 2];
	                    if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 16 : 0)fi(c[k >> 2] | 0) | 0;
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } while (0);
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function wj(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) {
	                    do if ((c[n >> 2] | 0) == 1) {
	                        if ((c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 ? (CP(c[(c[(c[j >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0, c[l >> 2] | 0) | 0) != 0 : 0)break;
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                    } while (0);
	                    c[h >> 2] = 0;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](48) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    do if ((c[n >> 2] | 0) == 1) {
	                        if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (CP(c[(c[(c[j >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2] | 0, c[l >> 2] | 0) | 0) != 0 : 0)break;
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                    } while (0);
	                    tj(75320);
	                    c[h >> 2] = 0;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                f = (c[o >> 2] | 0) + 0 | 0;
	                e = f + 48 | 0;
	                do {
	                    c[f >> 2] = 0;
	                    f = f + 4 | 0
	                } while ((f | 0) < (e | 0));
	                c[(c[o >> 2] | 0) + 4 >> 2] = 2;
	                c[(c[o >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                if (c[j >> 2] | 0) {
	                    c[p >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                    c[(c[o >> 2] | 0) + 32 >> 2] = c[p >> 2]
	                }
	                c[(c[o >> 2] | 0) + 36 >> 2] = c[k >> 2];
	                do if (!(c[n >> 2] | 0)) {
	                    if ((c[p >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                        k = AP(c[(c[p >> 2] | 0) + 80 >> 2] | 0, c[l >> 2] | 0, -1) | 0;
	                        c[(c[o >> 2] | 0) + 8 >> 2] = k;
	                        break
	                    }
	                    k = my(c[l >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 8 >> 2] = k
	                } else c[(c[o >> 2] | 0) + 8 >> 2] = c[l >> 2]; while (0);
	                a:do if (c[m >> 2] | 0) {
	                    if ((Fy(c[m >> 2] | 0) | 0) == 0 ? (uj(1303, c[p >> 2] | 0, 0), (c[p >> 2] | 0) != 0) : 0) {
	                        l = my(75792) | 0;
	                        c[(c[p >> 2] | 0) + 60 >> 2] = l
	                    }
	                    l = Wh(c[p >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 12 >> 2] = l;
	                    c[(c[o >> 2] | 0) + 16 >> 2] = 0;
	                    c[q >> 2] = c[(c[o >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[q >> 2] | 0))break a;
	                        c[(c[q >> 2] | 0) + 20 >> 2] = c[o >> 2];
	                        if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0))c[(c[o >> 2] | 0) + 16 >> 2] = c[q >> 2];
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                do if (c[j >> 2] | 0) {
	                    if (!(c[(c[j >> 2] | 0) + 44 >> 2] | 0)) {
	                        c[(c[j >> 2] | 0) + 44 >> 2] = c[o >> 2];
	                        break
	                    }
	                    c[r >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[(c[r >> 2] | 0) + 24 >> 2] | 0))break;
	                        c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                    }
	                    c[(c[r >> 2] | 0) + 24 >> 2] = c[o >> 2];
	                    c[(c[o >> 2] | 0) + 28 >> 2] = c[r >> 2]
	                } while (0);
	                if ((c[m >> 2] | 0) != 0 & (c[j >> 2] | 0) != 0 ? (Em(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[j >> 2] | 0, c[o >> 2] | 0) | 0) == 1 : 0)Cm(0, c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[o >> 2] | 0);
	                c[h >> 2] = c[o >> 2];
	                s = c[h >> 2] | 0;
	                i = g;
	                return s | 0
	            }

	            function xj(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 44 | 0;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 8 | 0;
	                r = f + 4 | 0;
	                s = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) != 0 ? !((c[j >> 2] | 0) == 0 ? 1 : (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 1) : 0) {
	                    a:do if (c[(c[h >> 2] | 0) + 44 >> 2] | 0) {
	                        c[m >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                        if (!(c[k >> 2] | 0)) {
	                            while (1) {
	                                if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0)break;
	                                c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2];
	                                if (!(c[m >> 2] | 0))break a
	                            }
	                            c[g >> 2] = c[m >> 2];
	                            t = c[g >> 2] | 0;
	                            i = f;
	                            return t | 0
	                        }
	                        while (1) {
	                            if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                                if ((c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) == (c[k >> 2] | 0))break;
	                                if (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0) | 0)break
	                            }
	                            c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2];
	                            if (!(c[m >> 2] | 0))break a
	                        }
	                        c[g >> 2] = c[m >> 2];
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    } while (0);
	                    if (!(c[l >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                        c[n >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                        c[o >> 2] = 0;
	                        c[q >> 2] = 0;
	                        do if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            c[q >> 2] = my(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            c[q >> 2] = By(c[q >> 2] | 0, 75864) | 0;
	                            c[q >> 2] = By(c[q >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            if (c[q >> 2] | 0) {
	                                c[p >> 2] = c[q >> 2];
	                                break
	                            }
	                            c[g >> 2] = 0;
	                            t = c[g >> 2] | 0;
	                            i = f;
	                            return t | 0
	                        } else u = 25; while (0);
	                        if ((u | 0) == 25)c[p >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                        if (!(c[k >> 2] | 0)) {
	                            c[o >> 2] = Nm(c[(c[n >> 2] | 0) + 44 >> 2] | 0, c[p >> 2] | 0, c[j >> 2] | 0, 0) | 0;
	                            if ((c[o >> 2] | 0) == 0 ? (c[(c[n >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[o >> 2] = Nm(c[(c[n >> 2] | 0) + 48 >> 2] | 0, c[p >> 2] | 0, c[j >> 2] | 0, 0) | 0
	                        } else {
	                            c[r >> 2] = bj(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0) | 0;
	                            if (!(c[r >> 2] | 0)) {
	                                if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                c[g >> 2] = 0;
	                                t = c[g >> 2] | 0;
	                                i = f;
	                                return t | 0
	                            }
	                            c[s >> 2] = c[r >> 2];
	                            while (1) {
	                                if (!(c[c[s >> 2] >> 2] | 0))break;
	                                if (qy(c[(c[c[s >> 2] >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0) | 0) {
	                                    c[o >> 2] = Nm(c[(c[n >> 2] | 0) + 44 >> 2] | 0, c[p >> 2] | 0, c[j >> 2] | 0, c[(c[c[s >> 2] >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                    if (c[o >> 2] | 0)break;
	                                    if ((c[(c[n >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[o >> 2] = Nm(c[(c[n >> 2] | 0) + 48 >> 2] | 0, c[p >> 2] | 0, c[j >> 2] | 0, c[(c[c[s >> 2] >> 2] | 0) + 12 >> 2] | 0) | 0, (c[o >> 2] | 0) != 0) : 0)break
	                                }
	                                c[s >> 2] = (c[s >> 2] | 0) + 4
	                            }
	                            zb[c[135736 >> 2] & 511](c[r >> 2] | 0)
	                        }
	                        if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        if ((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                            c[g >> 2] = c[o >> 2];
	                            t = c[g >> 2] | 0;
	                            i = f;
	                            return t | 0
	                        }
	                    }
	                    c[g >> 2] = 0;
	                    t = c[g >> 2] | 0;
	                    i = f;
	                    return t | 0
	                }
	                c[g >> 2] = 0;
	                t = c[g >> 2] | 0;
	                i = f;
	                return t | 0
	            }

	            function yj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                do if (!(c[h >> 2] | 0)) {
	                    if (c[g >> 2] | 0) {
	                        c[k >> 2] = ci(c[g >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                        break
	                    }
	                    d = c[j >> 2] | 0;
	                    if (c[(c[j >> 2] | 0) + 20 >> 2] | 0) {
	                        c[k >> 2] = ci(c[(c[d + 20 >> 2] | 0) + 32 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                        break
	                    }
	                    b = c[j >> 2] | 0;
	                    if (c[d + 12 >> 2] | 0) {
	                        c[k >> 2] = ci(c[(c[b + 12 >> 2] | 0) + 32 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0) | 0;
	                        break
	                    } else {
	                        c[k >> 2] = ci(0, c[b + 8 >> 2] | 0, 0) | 0;
	                        break
	                    }
	                } else c[k >> 2] = ci(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0) | 0; while (0);
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[(c[k >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                do if ((c[h >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    c[l >> 2] = cj(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    if (c[l >> 2] | 0)if (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) {
	                        c[(c[k >> 2] | 0) + 36 >> 2] = c[l >> 2];
	                        break
	                    } else {
	                        g = Hj(c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 36 >> 2] = g;
	                        break
	                    }
	                    c[l >> 2] = cj(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[m >> 2] = c[h >> 2];
	                        c[n >> 2] = 0;
	                        while (1) {
	                            r = c[m >> 2] | 0;
	                            if (!(c[(c[m >> 2] | 0) + 20 >> 2] | 0))break;
	                            c[n >> 2] = r;
	                            c[m >> 2] = c[(c[m >> 2] | 0) + 20 >> 2]
	                        }
	                        if ((r | 0) == (c[(c[h >> 2] | 0) + 32 >> 2] | 0))c[m >> 2] = c[n >> 2];
	                        g = Ih(c[m >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 36 >> 2] = g
	                    }
	                } else c[(c[k >> 2] | 0) + 36 >> 2] = 0; while (0);
	                a:do if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                    l = Aj(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[(c[k >> 2] | 0) + 32 >> 2] | 0, c[k >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = l;
	                    c[(c[k >> 2] | 0) + 16 >> 2] = 0;
	                    c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[o >> 2] | 0))break a;
	                        if (!(c[(c[o >> 2] | 0) + 24 >> 2] | 0))c[(c[k >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if (((((((c[h >> 2] | 0) != 0 & (c[j >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 32 >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (Em(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) ? (c[p >> 2] = _h(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0, 1) | 0, (c[p >> 2] | 0) != 0) : 0) {
	                    Cm(0, c[(c[h >> 2] | 0) + 32 >> 2] | 0, c[p >> 2] | 0, c[k >> 2] | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                }
	                c[f >> 2] = c[k >> 2];
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function zj(a, d, e, f) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = a;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                switch (c[(c[j >> 2] | 0) + 4 >> 2] | 0) {
	                    case 18:
	                    {
	                        c[h >> 2] = Ei(c[j >> 2] | 0) | 0;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                    case 10:
	                    case 12:
	                    case 14:
	                    case 15:
	                    case 16:
	                    case 17:
	                    {
	                        c[h >> 2] = 0;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                    case 2:
	                    {
	                        c[h >> 2] = yj(c[k >> 2] | 0, c[l >> 2] | 0, c[j >> 2] | 0) | 0;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                    case 9:
	                    case 13:
	                    case 21:
	                    {
	                        c[h >> 2] = Mi(c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                    default:
	                    {
	                        c[n >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                        if (!(c[n >> 2] | 0)) {
	                            tj(75936);
	                            c[h >> 2] = 0;
	                            s = c[h >> 2] | 0;
	                            i = g;
	                            return s | 0
	                        }
	                        f = (c[n >> 2] | 0) + 0 | 0;
	                        e = f + 60 | 0;
	                        do {
	                            c[f >> 2] = 0;
	                            f = f + 4 | 0
	                        } while ((f | 0) < (e | 0));
	                        c[(c[n >> 2] | 0) + 4 >> 2] = c[(c[j >> 2] | 0) + 4 >> 2];
	                        c[(c[n >> 2] | 0) + 32 >> 2] = c[k >> 2];
	                        c[(c[n >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                        do if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 75104) {
	                            if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 75112) {
	                                c[(c[n >> 2] | 0) + 8 >> 2] = 75112;
	                                break
	                            }
	                            if ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 75128) {
	                                c[(c[n >> 2] | 0) + 8 >> 2] = 75128;
	                                break
	                            }
	                            if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                                    f = AP(c[(c[k >> 2] | 0) + 80 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                                    c[(c[n >> 2] | 0) + 8 >> 2] = f;
	                                    break
	                                }
	                                f = my(c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 8 >> 2] = f
	                            }
	                        } else c[(c[n >> 2] | 0) + 8 >> 2] = 75104; while (0);
	                        if (((((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) {
	                            f = my(c[(c[j >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            c[(c[n >> 2] | 0) + 40 >> 2] = f
	                        } else t = 27;
	                        if ((t | 0) == 27 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)b[(c[n >> 2] | 0) + 56 >> 1] = b[(c[j >> 2] | 0) + 56 >> 1] | 0;
	                        if (c[l >> 2] | 0) {
	                            if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[n >> 2] | 0);
	                            c[o >> 2] = zi(c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                            if ((c[o >> 2] | 0) != (c[n >> 2] | 0)) {
	                                c[h >> 2] = c[o >> 2];
	                                s = c[h >> 2] | 0;
	                                i = g;
	                                return s | 0
	                            }
	                        }
	                        do if (c[m >> 2] | 0) {
	                            if (!((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 19 : 0))t = 37;
	                            if ((t | 0) == 37 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                                o = Ei(c[(c[j >> 2] | 0) + 48 >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 48 >> 2] = o
	                            }
	                            do if (c[(c[j >> 2] | 0) + 36 >> 2] | 0) {
	                                c[p >> 2] = cj(c[k >> 2] | 0, c[n >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                if (c[p >> 2] | 0) {
	                                    c[(c[n >> 2] | 0) + 36 >> 2] = c[p >> 2];
	                                    break
	                                }
	                                c[p >> 2] = cj(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[j >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                if (!(c[p >> 2] | 0)) {
	                                    o = Hj(c[k >> 2] | 0, c[n >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0) | 0;
	                                    c[(c[n >> 2] | 0) + 36 >> 2] = o;
	                                    break
	                                }
	                                c[q >> 2] = c[n >> 2];
	                                while (1) {
	                                    u = c[q >> 2] | 0;
	                                    if (!(c[(c[q >> 2] | 0) + 20 >> 2] | 0))break;
	                                    c[q >> 2] = c[u + 20 >> 2]
	                                }
	                                o = Ih(u, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 36 >> 2] = o
	                            } while (0);
	                            if (!((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 19 : 0))t = 50;
	                            if ((t | 0) == 50 ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                                o = Gi(c[n >> 2] | 0, c[(c[j >> 2] | 0) + 44 >> 2] | 0) | 0;
	                                c[(c[n >> 2] | 0) + 44 >> 2] = o
	                            }
	                            if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                                if ((c[k >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) == (c[k >> 2] | 0) : 0)c[(c[n >> 2] | 0) + 12 >> 2] = c[(c[j >> 2] | 0) + 12 >> 2]; else {
	                                    o = ad(c[k >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                    c[(c[n >> 2] | 0) + 12 >> 2] = o
	                                }
	                                c[(c[n >> 2] | 0) + 16 >> 2] = c[(c[n >> 2] | 0) + 12 >> 2];
	                                break
	                            }
	                            if (((c[m >> 2] | 0) != 2 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (o = Aj(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0, c[n >> 2] | 0) | 0, c[(c[n >> 2] | 0) + 12 >> 2] = o, (c[n >> 2] | 0) != 0) : 0) {
	                                c[r >> 2] = c[(c[n >> 2] | 0) + 12 >> 2];
	                                if (!(c[r >> 2] | 0)) {
	                                    c[(c[n >> 2] | 0) + 16 >> 2] = 0;
	                                    break
	                                }
	                                while (1) {
	                                    o = (c[(c[r >> 2] | 0) + 24 >> 2] | 0) != 0;
	                                    c[(c[r >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                                    v = c[r >> 2] | 0;
	                                    if (!o)break;
	                                    c[r >> 2] = c[v + 24 >> 2]
	                                }
	                                c[(c[n >> 2] | 0) + 16 >> 2] = v
	                            }
	                        } while (0);
	                        if ((c[l >> 2] | 0) == 0 & (c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[n >> 2] | 0);
	                        c[h >> 2] = c[n >> 2];
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                }
	                return 0
	            }

	            function Aj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                a:while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        n = 19;
	                        break
	                    }
	                    do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                        if (!(c[h >> 2] | 0)) {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            continue a
	                        }
	                        if (c[(c[h >> 2] | 0) + 44 >> 2] | 0) {
	                            c[m >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                            zi(c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                            break
	                        }
	                        c[m >> 2] = Li(c[g >> 2] | 0) | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            n = 8;
	                            break a
	                        }
	                        c[(c[m >> 2] | 0) + 32 >> 2] = c[h >> 2];
	                        c[(c[m >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                        c[(c[h >> 2] | 0) + 44 >> 2] = c[m >> 2];
	                        zi(c[j >> 2] | 0, c[m >> 2] | 0) | 0
	                    } else c[m >> 2] = zj(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 1) | 0; while (0);
	                    if (!(c[m >> 2] | 0)) {
	                        n = 13;
	                        break
	                    }
	                    if (c[k >> 2] | 0) {
	                        if ((c[l >> 2] | 0) != (c[m >> 2] | 0)) {
	                            c[(c[l >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                            c[(c[m >> 2] | 0) + 28 >> 2] = c[l >> 2];
	                            c[l >> 2] = c[m >> 2]
	                        }
	                    } else {
	                        c[(c[m >> 2] | 0) + 28 >> 2] = 0;
	                        d = c[m >> 2] | 0;
	                        c[l >> 2] = d;
	                        c[k >> 2] = d
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                if ((n | 0) == 8) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } else if ((n | 0) == 13) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } else if ((n | 0) == 19) {
	                    c[f >> 2] = c[k >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                return 0
	            }

	            function Bj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                    c[e >> 2] = Rj(c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Cj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                    c[e >> 2] = Rj(c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Dj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = -1;
	                if ((c[h >> 2] | 0) >= 5) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                a:do if ((((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 7 : 0) {
	                    do if (c[(c[g >> 2] | 0) + 28 >> 2] | 0) {
	                        if ((((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) != 3 : 0) ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) != 7 : 0)break;
	                        c[j >> 2] = Dj(c[(c[g >> 2] | 0) + 28 >> 2] | 0, (c[h >> 2] | 0) + 1 | 0) | 0;
	                        break a
	                    } while (0);
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)c[j >> 2] = Dj(c[(c[g >> 2] | 0) + 20 >> 2] | 0, (c[h >> 2] | 0) + 1 | 0) | 0
	                } else l = 9; while (0);
	                if ((l | 0) == 9) {
	                    do if ((e[(c[g >> 2] | 0) + 56 >> 1] | 0 | 0) == 65535) {
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3 ? (c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                            c[j >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                            break
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            c[j >> 2] = Dj(c[(c[g >> 2] | 0) + 12 >> 2] | 0, (c[h >> 2] | 0) + 1 | 0) | 0;
	                            break
	                        }
	                        l = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            c[j >> 2] = Dj(c[l + 24 >> 2] | 0, (c[h >> 2] | 0) + 1 | 0) | 0;
	                            break
	                        }
	                        if (c[l + 28 >> 2] | 0)c[j >> 2] = Dj(c[(c[g >> 2] | 0) + 28 >> 2] | 0, (c[h >> 2] | 0) + 1 | 0) | 0
	                    } while (0);
	                    if ((c[j >> 2] | 0) == -1 | (c[j >> 2] | 0) == 65535)c[j >> 2] = e[(c[g >> 2] | 0) + 56 >> 1]
	                }
	                c[f >> 2] = c[j >> 2];
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function Ej(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if (c[(c[e >> 2] | 0) + 52 >> 2] | 0) {
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tj(75904);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = c[f >> 2] | 0;
	                    c[a + 0 >> 2] = 0;
	                    c[a + 4 >> 2] = 0;
	                    c[a + 8 >> 2] = 0;
	                    c[a + 12 >> 2] = 0;
	                    c[a + 16 >> 2] = 0;
	                    c[a + 20 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 18;
	                    a = my(75176) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a;
	                    a = my(75168) | 0;
	                    c[(c[f >> 2] | 0) + 12 >> 2] = a;
	                    c[(c[e >> 2] | 0) + 52 >> 2] = c[f >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Fj(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[f + 16 >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                a:while (1) {
	                    if (c[h >> 2] | 0)m = (c[h >> 2] | 0) != (c[j >> 2] | 0); else m = 0;
	                    n = c[h >> 2] | 0;
	                    if (!m) {
	                        o = 19;
	                        break
	                    }
	                    if ((c[n + 4 >> 2] | 0) == 5) {
	                        o = 8;
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 6) {
	                        o = 8;
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                        o = 8;
	                        break
	                    }
	                    b:do if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        c[l >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break b;
	                            if ((c[k >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                                o = 13;
	                                break a
	                            }
	                            if (((c[k >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0) | 0) != 0 : 0) {
	                                o = 16;
	                                break a
	                            }
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                    } while (0);
	                    c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2]
	                }
	                if ((o | 0) == 8) {
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else if ((o | 0) == 13) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else if ((o | 0) == 16) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else if ((o | 0) == 19)if ((n | 0) != (c[j >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } else {
	                    c[g >> 2] = 1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                return 0
	            }

	            function Gj(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 2)if ((c[a + 4 >> 2] | 0) == 16) {
	                    c[d >> 2] = my(c[(c[e >> 2] | 0) + 48 >> 2] | 0) | 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if (c[a + 12 >> 2] | 0) {
	                    do if (!(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0)) {
	                        if ((c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 4 : 0)break;
	                        c[d >> 2] = my(c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    } while (0);
	                    c[f >> 2] = _h(c[(c[e >> 2] | 0) + 32 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                    if (c[f >> 2] | 0) {
	                        c[d >> 2] = c[f >> 2];
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                }
	                c[d >> 2] = my(75312) | 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Hj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 96 | 0;
	                f = e;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 32 | 0;
	                n = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[n >> 2] = 1;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 18 : 0) {
	                        c[l >> 2] = Ri(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[g >> 2] = c[l >> 2];
	                            o = c[g >> 2] | 0;
	                            i = e;
	                            return o | 0
	                        }
	                        if (!(c[(c[k >> 2] | 0) + 12 >> 2] | 0))JT(m, 50, 75656, f) | 0; else {
	                            c[f >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                            JT(m, 50, 75872, f) | 0
	                        }
	                        c[l >> 2] = cj(c[h >> 2] | 0, c[j >> 2] | 0, m) | 0;
	                        while (1) {
	                            if (!(c[l >> 2] | 0)) {
	                                p = 20;
	                                break
	                            }
	                            if ((c[n >> 2] | 0) > 1e3) {
	                                p = 15;
	                                break
	                            }
	                            if (!(c[(c[k >> 2] | 0) + 12 >> 2] | 0)) {
	                                d = c[n >> 2] | 0;
	                                c[n >> 2] = d + 1;
	                                c[f >> 2] = d;
	                                JT(m, 50, 75880, f) | 0
	                            } else {
	                                d = c[(c[k >> 2] | 0) + 12 >> 2] | 0;
	                                b = c[n >> 2] | 0;
	                                c[n >> 2] = b + 1;
	                                c[f >> 2] = d;
	                                c[f + 4 >> 2] = b;
	                                JT(m, 50, 75896, f) | 0
	                            }
	                            c[l >> 2] = cj(c[h >> 2] | 0, c[j >> 2] | 0, m) | 0
	                        }
	                        if ((p | 0) == 15) {
	                            c[g >> 2] = 0;
	                            o = c[g >> 2] | 0;
	                            i = e;
	                            return o | 0
	                        } else if ((p | 0) == 20) {
	                            c[l >> 2] = Ih(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, m) | 0;
	                            c[g >> 2] = c[l >> 2];
	                            o = c[g >> 2] | 0;
	                            i = e;
	                            return o | 0
	                        }
	                    }
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[g >> 2] = 0;
	                o = c[g >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Ij(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[e >> 2] = (c[e >> 2] | 0) <= 0 ? 256 : a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                do if (c[f >> 2] | 0) {
	                    c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    a = Cb[c[135744 >> 2] & 511]((c[e >> 2] | 0) * 24 | 0) | 0;
	                    c[c[f >> 2] >> 2] = a;
	                    if (!(c[c[f >> 2] >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        break
	                    }
	                    cU(c[c[f >> 2] >> 2] | 0, 0, (c[e >> 2] | 0) * 24 | 0) | 0;
	                    a = vP() | 0;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = a;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } while (0);
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Jj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = Ij(c[e >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    h = c[g >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[g >> 2] | 0) + 12 >> 2] = c[f >> 2];
	                yP(c[f >> 2] | 0) | 0;
	                h = c[g >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Kj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[k >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[c[e >> 2] >> 2] | 0) {
	                    c[l >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if (!((c[l >> 2] | 0) > 0 ? (c[g >> 2] | 0) < (c[(c[e >> 2] | 0) + 4 >> 2] | 0) : 0))break;
	                        c[h >> 2] = (c[c[e >> 2] >> 2] | 0) + ((c[g >> 2] | 0) * 24 | 0);
	                        a:do if (c[(c[h >> 2] | 0) + 20 >> 2] | 0) {
	                            c[k >> 2] = 1;
	                            while (1) {
	                                if (!(c[h >> 2] | 0))break a;
	                                c[j >> 2] = c[c[h >> 2] >> 2];
	                                if ((c[f >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)Ab[c[f >> 2] & 511](c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                                if (!(c[(c[e >> 2] | 0) + 12 >> 2] | 0)) {
	                                    if (c[(c[h >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                                    if (c[(c[h >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                                    if (c[(c[h >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 12 >> 2] | 0)
	                                }
	                                c[(c[h >> 2] | 0) + 16 >> 2] = 0;
	                                if (!(c[k >> 2] | 0))zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[l >> 2] = (c[l >> 2] | 0) + -1;
	                                c[k >> 2] = 0;
	                                c[h >> 2] = c[j >> 2]
	                            }
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[c[e >> 2] >> 2] | 0)
	                }
	                if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)zP(c[(c[e >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function Lj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = Mj(c[f >> 2] | 0, c[g >> 2] | 0, 0, 0, c[h >> 2] | 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function Mj(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 36 | 0;
	                j = g + 32 | 0;
	                k = g + 28 | 0;
	                l = g + 24 | 0;
	                m = g + 20 | 0;
	                n = g + 16 | 0;
	                o = g + 12 | 0;
	                p = g + 8 | 0;
	                q = g + 4 | 0;
	                r = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                    if ((CP(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0) | 0) == 0 ? (c[k >> 2] = AP(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0, -1) | 0, (c[k >> 2] | 0) == 0) : 0) {
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                    if (((c[l >> 2] | 0) != 0 ? (CP(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0) ? (c[l >> 2] = AP(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0, -1) | 0, (c[l >> 2] | 0) == 0) : 0) {
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                    if (((c[m >> 2] | 0) != 0 ? (CP(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0) | 0) == 0 : 0) ? (c[m >> 2] = AP(c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0, -1) | 0, (c[m >> 2] | 0) == 0) : 0) {
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                }
	                c[o >> 2] = dk(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                do if (c[(c[c[j >> 2] >> 2] | 0) + ((c[o >> 2] | 0) * 24 | 0) + 20 >> 2] | 0) {
	                    f = (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0;
	                    c[r >> 2] = (c[c[j >> 2] >> 2] | 0) + ((c[o >> 2] | 0) * 24 | 0);
	                    if (f) {
	                        while (1) {
	                            t = (c[(c[r >> 2] | 0) + 4 >> 2] | 0) == (c[k >> 2] | 0);
	                            if (!(c[c[r >> 2] >> 2] | 0))break;
	                            if ((t ? (c[(c[r >> 2] | 0) + 8 >> 2] | 0) == (c[l >> 2] | 0) : 0) ? (c[(c[r >> 2] | 0) + 12 >> 2] | 0) == (c[m >> 2] | 0) : 0) {
	                                u = 22;
	                                break
	                            }
	                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                            c[r >> 2] = c[c[r >> 2] >> 2]
	                        }
	                        if ((u | 0) == 22) {
	                            c[h >> 2] = -1;
	                            s = c[h >> 2] | 0;
	                            i = g;
	                            return s | 0
	                        }
	                        if (!t)break;
	                        if ((c[(c[r >> 2] | 0) + 8 >> 2] | 0) != (c[l >> 2] | 0))break;
	                        if ((c[(c[r >> 2] | 0) + 12 >> 2] | 0) != (c[m >> 2] | 0))break;
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    } else {
	                        while (1) {
	                            f = (c[c[r >> 2] >> 2] | 0) != 0;
	                            v = (qy(c[(c[r >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0) | 0) != 0;
	                            if (!f)break;
	                            if ((v ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[r >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0) | 0) != 0 : 0) {
	                                u = 32;
	                                break
	                            }
	                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                            c[r >> 2] = c[c[r >> 2] >> 2]
	                        }
	                        if ((u | 0) == 32) {
	                            c[h >> 2] = -1;
	                            s = c[h >> 2] | 0;
	                            i = g;
	                            return s | 0
	                        }
	                        if (!v)break;
	                        if (!(qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0))break;
	                        if (!(qy(c[(c[r >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0) | 0))break;
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                } else c[r >> 2] = 0; while (0);
	                if (c[r >> 2] | 0) {
	                    c[q >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        c[h >> 2] = -1;
	                        s = c[h >> 2] | 0;
	                        i = g;
	                        return s | 0
	                    }
	                } else c[q >> 2] = (c[c[j >> 2] >> 2] | 0) + ((c[o >> 2] | 0) * 24 | 0);
	                o = c[k >> 2] | 0;
	                if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                    c[(c[q >> 2] | 0) + 4 >> 2] = o;
	                    c[(c[q >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                    c[(c[q >> 2] | 0) + 12 >> 2] = c[m >> 2]
	                } else {
	                    k = my(o) | 0;
	                    c[(c[q >> 2] | 0) + 4 >> 2] = k;
	                    k = my(c[l >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 8 >> 2] = k;
	                    k = my(c[m >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 12 >> 2] = k
	                }
	                c[(c[q >> 2] | 0) + 16 >> 2] = c[n >> 2];
	                c[c[q >> 2] >> 2] = 0;
	                c[(c[q >> 2] | 0) + 20 >> 2] = 1;
	                if (c[r >> 2] | 0)c[c[r >> 2] >> 2] = c[q >> 2];
	                q = (c[j >> 2] | 0) + 8 | 0;
	                c[q >> 2] = (c[q >> 2] | 0) + 1;
	                if ((c[p >> 2] | 0) >>> 0 > 8)ek(c[j >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] << 3) | 0;
	                c[h >> 2] = 0;
	                s = c[h >> 2] | 0;
	                i = g;
	                return s | 0
	            }

	            function Nj(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = Mj(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 0, c[k >> 2] | 0) | 0;
	                i = f;
	                return e | 0
	            }

	            function Oj(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = Pj(c[g >> 2] | 0, c[h >> 2] | 0, 0, 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                i = f;
	                return e | 0
	            }

	            function Pj(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                if (c[(c[k >> 2] | 0) + 12 >> 2] | 0) {
	                    if ((CP(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0) | 0) == 0 ? (c[l >> 2] = AP(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0, -1) | 0, (c[l >> 2] | 0) == 0) : 0) {
	                        c[j >> 2] = -1;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                    if (((c[m >> 2] | 0) != 0 ? (CP(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0) | 0) == 0 : 0) ? (c[m >> 2] = AP(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0, -1) | 0, (c[m >> 2] | 0) == 0) : 0) {
	                        c[j >> 2] = -1;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                    if (((c[n >> 2] | 0) != 0 ? (CP(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0) | 0) == 0 : 0) ? (c[n >> 2] = AP(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0, -1) | 0, (c[n >> 2] | 0) == 0) : 0) {
	                        c[j >> 2] = -1;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                }
	                c[q >> 2] = dk(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                do if (c[(c[c[k >> 2] >> 2] | 0) + ((c[q >> 2] | 0) * 24 | 0) + 20 >> 2] | 0) {
	                    g = (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0;
	                    c[s >> 2] = (c[c[k >> 2] >> 2] | 0) + ((c[q >> 2] | 0) * 24 | 0);
	                    if (g) {
	                        while (1) {
	                            u = (c[(c[s >> 2] | 0) + 4 >> 2] | 0) == (c[l >> 2] | 0);
	                            if (!(c[c[s >> 2] >> 2] | 0))break;
	                            if ((u ? (c[(c[s >> 2] | 0) + 8 >> 2] | 0) == (c[m >> 2] | 0) : 0) ? (c[(c[s >> 2] | 0) + 12 >> 2] | 0) == (c[n >> 2] | 0) : 0) {
	                                v = 22;
	                                break
	                            }
	                            c[s >> 2] = c[c[s >> 2] >> 2]
	                        }
	                        if ((v | 0) == 22) {
	                            if (c[p >> 2] | 0)Ab[c[p >> 2] & 511](c[(c[s >> 2] | 0) + 16 >> 2] | 0, c[(c[s >> 2] | 0) + 4 >> 2] | 0);
	                            c[(c[s >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                            c[j >> 2] = 0;
	                            t = c[j >> 2] | 0;
	                            i = h;
	                            return t | 0
	                        }
	                        if (!u)break;
	                        if ((c[(c[s >> 2] | 0) + 8 >> 2] | 0) != (c[m >> 2] | 0))break;
	                        if ((c[(c[s >> 2] | 0) + 12 >> 2] | 0) != (c[n >> 2] | 0))break;
	                        if (c[p >> 2] | 0)Ab[c[p >> 2] & 511](c[(c[s >> 2] | 0) + 16 >> 2] | 0, c[(c[s >> 2] | 0) + 4 >> 2] | 0);
	                        c[(c[s >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                        c[j >> 2] = 0;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    } else {
	                        while (1) {
	                            g = (c[c[s >> 2] >> 2] | 0) != 0;
	                            w = (qy(c[(c[s >> 2] | 0) + 4 >> 2] | 0, c[l >> 2] | 0) | 0) != 0;
	                            if (!g)break;
	                            if ((w ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0) | 0) != 0 : 0) {
	                                v = 36;
	                                break
	                            }
	                            c[s >> 2] = c[c[s >> 2] >> 2]
	                        }
	                        if ((v | 0) == 36) {
	                            if (c[p >> 2] | 0)Ab[c[p >> 2] & 511](c[(c[s >> 2] | 0) + 16 >> 2] | 0, c[(c[s >> 2] | 0) + 4 >> 2] | 0);
	                            c[(c[s >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                            c[j >> 2] = 0;
	                            t = c[j >> 2] | 0;
	                            i = h;
	                            return t | 0
	                        }
	                        if (!w)break;
	                        if (!(qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0))break;
	                        if (!(qy(c[(c[s >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0) | 0))break;
	                        if (c[p >> 2] | 0)Ab[c[p >> 2] & 511](c[(c[s >> 2] | 0) + 16 >> 2] | 0, c[(c[s >> 2] | 0) + 4 >> 2] | 0);
	                        c[(c[s >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                        c[j >> 2] = 0;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                } else c[s >> 2] = 0; while (0);
	                if (c[s >> 2] | 0) {
	                    c[r >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                    if (!(c[r >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                } else c[r >> 2] = (c[c[k >> 2] >> 2] | 0) + ((c[q >> 2] | 0) * 24 | 0);
	                q = c[l >> 2] | 0;
	                if (c[(c[k >> 2] | 0) + 12 >> 2] | 0) {
	                    c[(c[r >> 2] | 0) + 4 >> 2] = q;
	                    c[(c[r >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                    c[(c[r >> 2] | 0) + 12 >> 2] = c[n >> 2]
	                } else {
	                    l = my(q) | 0;
	                    c[(c[r >> 2] | 0) + 4 >> 2] = l;
	                    l = my(c[m >> 2] | 0) | 0;
	                    c[(c[r >> 2] | 0) + 8 >> 2] = l;
	                    l = my(c[n >> 2] | 0) | 0;
	                    c[(c[r >> 2] | 0) + 12 >> 2] = l
	                }
	                c[(c[r >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                c[c[r >> 2] >> 2] = 0;
	                c[(c[r >> 2] | 0) + 20 >> 2] = 1;
	                o = (c[k >> 2] | 0) + 8 | 0;
	                c[o >> 2] = (c[o >> 2] | 0) + 1;
	                if (c[s >> 2] | 0)c[c[s >> 2] >> 2] = c[r >> 2];
	                c[j >> 2] = 0;
	                t = c[j >> 2] | 0;
	                i = h;
	                return t | 0
	            }

	            function Qj(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                f = Pj(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                i = g;
	                return f | 0
	            }

	            function Rj(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = Sj(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function Sj(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[m >> 2] = dk(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                if (!(c[(c[c[h >> 2] >> 2] | 0) + ((c[m >> 2] | 0) * 24 | 0) + 20 >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                a:do if (c[(c[h >> 2] | 0) + 12 >> 2] | 0) {
	                    c[n >> 2] = (c[c[h >> 2] >> 2] | 0) + ((c[m >> 2] | 0) * 24 | 0);
	                    while (1) {
	                        if (!(c[n >> 2] | 0))break a;
	                        if (((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == (c[j >> 2] | 0) ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) == (c[k >> 2] | 0) : 0) ? (c[(c[n >> 2] | 0) + 12 >> 2] | 0) == (c[l >> 2] | 0) : 0)break;
	                        c[n >> 2] = c[c[n >> 2] >> 2]
	                    }
	                    c[g >> 2] = c[(c[n >> 2] | 0) + 16 >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } while (0);
	                c[n >> 2] = (c[c[h >> 2] >> 2] | 0) + ((c[m >> 2] | 0) * 24 | 0);
	                while (1) {
	                    if (!(c[n >> 2] | 0)) {
	                        p = 22;
	                        break
	                    }
	                    if (((qy(c[(c[n >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 12 >> 2] | 0, c[l >> 2] | 0) | 0) != 0 : 0) {
	                        p = 20;
	                        break
	                    }
	                    c[n >> 2] = c[c[n >> 2] >> 2]
	                }
	                if ((p | 0) == 20) {
	                    c[g >> 2] = c[(c[n >> 2] | 0) + 16 >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } else if ((p | 0) == 22) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                return 0
	            }

	            function Tj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = Sj(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function Uj(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 36 | 0;
	                l = j + 32 | 0;
	                m = j + 28 | 0;
	                n = j + 24 | 0;
	                o = j + 20 | 0;
	                p = j + 16 | 0;
	                q = j + 12 | 0;
	                r = j + 8 | 0;
	                s = j + 4 | 0;
	                t = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                if (!(c[l >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                if (!(c[n >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                c[s >> 2] = fk(c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                if (!(c[(c[c[l >> 2] >> 2] | 0) + ((c[s >> 2] | 0) * 24 | 0) + 20 >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                c[t >> 2] = (c[c[l >> 2] >> 2] | 0) + ((c[s >> 2] | 0) * 24 | 0);
	                while (1) {
	                    if (!(c[t >> 2] | 0)) {
	                        v = 14;
	                        break
	                    }
	                    if (((ry(c[m >> 2] | 0, c[n >> 2] | 0, c[(c[t >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (ry(c[o >> 2] | 0, c[p >> 2] | 0, c[(c[t >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) ? (ry(c[q >> 2] | 0, c[r >> 2] | 0, c[(c[t >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                        v = 12;
	                        break
	                    }
	                    c[t >> 2] = c[c[t >> 2] >> 2]
	                }
	                if ((v | 0) == 12) {
	                    c[k >> 2] = c[(c[t >> 2] | 0) + 16 >> 2];
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                } else if ((v | 0) == 14) {
	                    c[k >> 2] = 0;
	                    u = c[k >> 2] | 0;
	                    i = j;
	                    return u | 0
	                }
	                return 0
	            }

	            function Vj(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                f = Uj(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, 0, 0) | 0;
	                i = g;
	                return f | 0
	            }

	            function Wj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j + 4 >> 2] = c[h >> 2];
	                c[j >> 2] = c[g >> 2];
	                Xj(c[f >> 2] | 0, 229, j);
	                i = e;
	                return
	            }

	            function Xj(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    i = e;
	                    return
	                }
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                    a:do if (c[(c[c[f >> 2] >> 2] | 0) + ((c[j >> 2] | 0) * 24 | 0) + 20 >> 2] | 0) {
	                        c[l >> 2] = (c[c[f >> 2] >> 2] | 0) + ((c[j >> 2] | 0) * 24 | 0);
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break a;
	                            c[m >> 2] = c[c[l >> 2] >> 2];
	                            c[k >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                            if ((c[g >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)xb[c[g >> 2] & 511](c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[h >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0);
	                            if ((c[k >> 2] | 0) == (c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                                c[l >> 2] = c[m >> 2];
	                                continue
	                            }
	                            if ((c[l >> 2] | 0) != ((c[c[f >> 2] >> 2] | 0) + ((c[j >> 2] | 0) * 24 | 0) | 0)) {
	                                c[l >> 2] = c[m >> 2];
	                                continue
	                            }
	                            if (!(c[(c[c[f >> 2] >> 2] | 0) + ((c[j >> 2] | 0) * 24 | 0) + 20 >> 2] | 0))c[l >> 2] = 0;
	                            if ((c[(c[c[f >> 2] >> 2] | 0) + ((c[j >> 2] | 0) * 24 | 0) >> 2] | 0) == (c[m >> 2] | 0))continue;
	                            c[l >> 2] = (c[c[f >> 2] >> 2] | 0) + ((c[j >> 2] | 0) * 24 | 0)
	                        }
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                i = e;
	                return
	            }

	            function Yj(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                Zj(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0);
	                i = h;
	                return
	            }

	            function Zj(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 32 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                if ((c[j >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    i = h;
	                    return
	                }
	                if (!(c[c[j >> 2] >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                c[p >> 2] = 0;
	                while (1) {
	                    if ((c[p >> 2] | 0) >= (c[(c[j >> 2] | 0) + 4 >> 2] | 0))break;
	                    a:do if (c[(c[c[j >> 2] >> 2] | 0) + ((c[p >> 2] | 0) * 24 | 0) + 20 >> 2] | 0) {
	                        c[q >> 2] = (c[c[j >> 2] >> 2] | 0) + ((c[p >> 2] | 0) * 24 | 0);
	                        while (1) {
	                            if (!(c[q >> 2] | 0))break a;
	                            c[r >> 2] = c[c[q >> 2] >> 2];
	                            if (!((c[k >> 2] | 0) != 0 ? (qy(c[k >> 2] | 0, c[(c[q >> 2] | 0) + 4 >> 2] | 0) | 0) == 0 : 0))s = 10;
	                            do if ((s | 0) == 10) {
	                                s = 0;
	                                if ((c[l >> 2] | 0) != 0 ? (qy(c[l >> 2] | 0, c[(c[q >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0)break;
	                                if ((c[m >> 2] | 0) != 0 ? (qy(c[m >> 2] | 0, c[(c[q >> 2] | 0) + 12 >> 2] | 0) | 0) == 0 : 0)break;
	                                if (c[(c[q >> 2] | 0) + 16 >> 2] | 0)xb[c[n >> 2] & 511](c[(c[q >> 2] | 0) + 16 >> 2] | 0, c[o >> 2] | 0, c[(c[q >> 2] | 0) + 4 >> 2] | 0, c[(c[q >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 12 >> 2] | 0)
	                            } while (0);
	                            c[q >> 2] = c[r >> 2]
	                        }
	                    } while (0);
	                    c[p >> 2] = (c[p >> 2] | 0) + 1
	                }
	                i = h;
	                return
	            }

	            function _j(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[l >> 2] = Ij(c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                a:do if (c[c[f >> 2] >> 2] | 0) {
	                    c[h >> 2] = 0;
	                    while (1) {
	                        if ((c[h >> 2] | 0) >= (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break a;
	                        b:do if (c[(c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) + 20 >> 2] | 0) {
	                            c[j >> 2] = (c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0);
	                            while (1) {
	                                if (!(c[j >> 2] | 0))break b;
	                                c[k >> 2] = c[c[j >> 2] >> 2];
	                                b = c[l >> 2] | 0;
	                                a = c[(c[j >> 2] | 0) + 4 >> 2] | 0;
	                                n = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                                o = c[(c[j >> 2] | 0) + 12 >> 2] | 0;
	                                Mj(b, a, n, o, Hb[c[g >> 2] & 511](c[(c[j >> 2] | 0) + 16 >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0) | 0) | 0;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                        } while (0);
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                } while (0);
	                c[(c[l >> 2] | 0) + 8 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                c[e >> 2] = c[l >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function $j(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0))c[d >> 2] = -1; else c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function ak(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = bk(c[f >> 2] | 0, c[g >> 2] | 0, 0, 0, c[h >> 2] | 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function bk(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 32 | 0;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                p = g + 4 | 0;
	                q = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[q >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[o >> 2] = dk(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                if (!(c[(c[c[j >> 2] >> 2] | 0) + ((c[o >> 2] | 0) * 24 | 0) + 20 >> 2] | 0)) {
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[p >> 2] = (c[c[j >> 2] >> 2] | 0) + ((c[o >> 2] | 0) * 24 | 0);
	                while (1) {
	                    if (!(c[p >> 2] | 0)) {
	                        s = 27;
	                        break
	                    }
	                    if (((qy(c[(c[p >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0) | 0) != 0 ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0) | 0) != 0 : 0)break;
	                    c[q >> 2] = c[p >> 2];
	                    c[p >> 2] = c[c[p >> 2] >> 2]
	                }
	                if ((s | 0) == 27) {
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                if ((c[n >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)Ab[c[n >> 2] & 511](c[(c[p >> 2] | 0) + 16 >> 2] | 0, c[(c[p >> 2] | 0) + 4 >> 2] | 0);
	                c[(c[p >> 2] | 0) + 16 >> 2] = 0;
	                if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0)) {
	                    if (c[(c[p >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[p >> 2] | 0) + 4 >> 2] | 0);
	                    if (c[(c[p >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[p >> 2] | 0) + 8 >> 2] | 0);
	                    if (c[(c[p >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[p >> 2] | 0) + 12 >> 2] | 0)
	                }
	                n = c[c[p >> 2] >> 2] | 0;
	                do if (!(c[q >> 2] | 0)) {
	                    s = c[p >> 2] | 0;
	                    if (!n) {
	                        c[s + 20 >> 2] = 0;
	                        break
	                    } else {
	                        c[p >> 2] = c[s >> 2];
	                        s = (c[c[j >> 2] >> 2] | 0) + ((c[o >> 2] | 0) * 24 | 0) | 0;
	                        m = c[p >> 2] | 0;
	                        c[s + 0 >> 2] = c[m + 0 >> 2];
	                        c[s + 4 >> 2] = c[m + 4 >> 2];
	                        c[s + 8 >> 2] = c[m + 8 >> 2];
	                        c[s + 12 >> 2] = c[m + 12 >> 2];
	                        c[s + 16 >> 2] = c[m + 16 >> 2];
	                        c[s + 20 >> 2] = c[m + 20 >> 2];
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        break
	                    }
	                } else {
	                    c[c[q >> 2] >> 2] = n;
	                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                } while (0);
	                p = (c[j >> 2] | 0) + 8 | 0;
	                c[p >> 2] = (c[p >> 2] | 0) + -1;
	                c[h >> 2] = 0;
	                r = c[h >> 2] | 0;
	                i = g;
	                return r | 0
	            }

	            function ck(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = bk(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 0, c[k >> 2] | 0) | 0;
	                i = f;
	                return e | 0
	            }

	            function dk(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 16 | 0;
	                k = h + 12 | 0;
	                l = h + 8 | 0;
	                m = h + 4 | 0;
	                n = h;
	                o = h + 20 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = g;
	                c[n >> 2] = 0;
	                c[n >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                a:do if (c[k >> 2] | 0) {
	                    c[n >> 2] = (c[n >> 2] | 0) + ((d[c[k >> 2] >> 0] | 0) * 30 | 0);
	                    while (1) {
	                        g = c[k >> 2] | 0;
	                        c[k >> 2] = g + 1;
	                        f = a[g >> 0] | 0;
	                        a[o >> 0] = f;
	                        if (!(f << 24 >> 24))break a;
	                        c[n >> 2] = c[n >> 2] ^ (c[n >> 2] << 5) + ((c[n >> 2] | 0) >>> 3) + (a[o >> 0] | 0)
	                    }
	                } while (0);
	                c[n >> 2] = c[n >> 2] ^ (c[n >> 2] << 5) + ((c[n >> 2] | 0) >>> 3);
	                b:do if (c[l >> 2] | 0)while (1) {
	                    k = c[l >> 2] | 0;
	                    c[l >> 2] = k + 1;
	                    f = a[k >> 0] | 0;
	                    a[o >> 0] = f;
	                    if (!(f << 24 >> 24))break b;
	                    c[n >> 2] = c[n >> 2] ^ (c[n >> 2] << 5) + ((c[n >> 2] | 0) >>> 3) + (a[o >> 0] | 0)
	                } while (0);
	                c[n >> 2] = c[n >> 2] ^ (c[n >> 2] << 5) + ((c[n >> 2] | 0) >>> 3);
	                if (!(c[m >> 2] | 0)) {
	                    p = c[n >> 2] | 0;
	                    q = c[j >> 2] | 0;
	                    r = q + 4 | 0;
	                    s = c[r >> 2] | 0;
	                    t = (p >>> 0) % (s >>> 0) | 0;
	                    i = h;
	                    return t | 0
	                }
	                while (1) {
	                    l = c[m >> 2] | 0;
	                    c[m >> 2] = l + 1;
	                    f = a[l >> 0] | 0;
	                    a[o >> 0] = f;
	                    if (!(f << 24 >> 24))break;
	                    c[n >> 2] = c[n >> 2] ^ (c[n >> 2] << 5) + ((c[n >> 2] | 0) >>> 3) + (a[o >> 0] | 0)
	                }
	                p = c[n >> 2] | 0;
	                q = c[j >> 2] | 0;
	                r = q + 4 | 0;
	                s = c[r >> 2] | 0;
	                t = (p >>> 0) % (s >>> 0) | 0;
	                i = h;
	                return t | 0
	            }

	            function ek(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                if ((c[g >> 2] | 0) < 8) {
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                if ((c[g >> 2] | 0) > 16384) {
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                c[j >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                c[n >> 2] = c[c[f >> 2] >> 2];
	                if (!(c[n >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                b = Cb[c[135744 >> 2] & 511]((c[g >> 2] | 0) * 24 | 0) | 0;
	                c[c[f >> 2] >> 2] = b;
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    c[c[f >> 2] >> 2] = c[n >> 2];
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                cU(c[c[f >> 2] >> 2] | 0, 0, (c[g >> 2] | 0) * 24 | 0) | 0;
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[j >> 2] | 0))break;
	                    if (c[(c[n >> 2] | 0) + ((c[k >> 2] | 0) * 24 | 0) + 20 >> 2] | 0) {
	                        c[h >> 2] = dk(c[f >> 2] | 0, c[(c[n >> 2] | 0) + ((c[k >> 2] | 0) * 24 | 0) + 4 >> 2] | 0, c[(c[n >> 2] | 0) + ((c[k >> 2] | 0) * 24 | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + ((c[k >> 2] | 0) * 24 | 0) + 12 >> 2] | 0) | 0;
	                        g = (c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) | 0;
	                        b = (c[n >> 2] | 0) + ((c[k >> 2] | 0) * 24 | 0) | 0;
	                        c[g + 0 >> 2] = c[b + 0 >> 2];
	                        c[g + 4 >> 2] = c[b + 4 >> 2];
	                        c[g + 8 >> 2] = c[b + 8 >> 2];
	                        c[g + 12 >> 2] = c[b + 12 >> 2];
	                        c[g + 16 >> 2] = c[b + 16 >> 2];
	                        c[g + 20 >> 2] = c[b + 20 >> 2];
	                        c[(c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) >> 2] = 0
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[j >> 2] | 0))break;
	                    c[l >> 2] = c[(c[n >> 2] | 0) + ((c[k >> 2] | 0) * 24 | 0) >> 2];
	                    while (1) {
	                        if (!(c[l >> 2] | 0))break;
	                        c[m >> 2] = c[c[l >> 2] >> 2];
	                        c[h >> 2] = dk(c[f >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        b = (c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) | 0;
	                        if (!(c[(c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) + 20 >> 2] | 0)) {
	                            g = c[l >> 2] | 0;
	                            c[b + 0 >> 2] = c[g + 0 >> 2];
	                            c[b + 4 >> 2] = c[g + 4 >> 2];
	                            c[b + 8 >> 2] = c[g + 8 >> 2];
	                            c[b + 12 >> 2] = c[g + 12 >> 2];
	                            c[b + 16 >> 2] = c[g + 16 >> 2];
	                            c[b + 20 >> 2] = c[g + 20 >> 2];
	                            c[(c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) >> 2] = 0;
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                        } else {
	                            c[c[l >> 2] >> 2] = c[b >> 2];
	                            c[(c[c[f >> 2] >> 2] | 0) + ((c[h >> 2] | 0) * 24 | 0) >> 2] = c[l >> 2]
	                        }
	                        c[l >> 2] = c[m >> 2]
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                c[e >> 2] = 0;
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function fk(b, e, f, g, h, j, k) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                l = i;
	                i = i + 48 | 0;
	                m = l + 28 | 0;
	                n = l + 24 | 0;
	                o = l + 20 | 0;
	                p = l + 16 | 0;
	                q = l + 12 | 0;
	                r = l + 8 | 0;
	                s = l + 4 | 0;
	                t = l;
	                u = l + 32 | 0;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = j;
	                c[s >> 2] = k;
	                c[t >> 2] = 0;
	                c[t >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                if (c[n >> 2] | 0)c[t >> 2] = (c[t >> 2] | 0) + ((d[c[n >> 2] >> 0] | 0) * 30 | 0); else c[t >> 2] = (c[t >> 2] | 0) + ((d[c[o >> 2] >> 0] | 0) * 30 | 0);
	                if (c[n >> 2] | 0) {
	                    while (1) {
	                        k = c[n >> 2] | 0;
	                        c[n >> 2] = k + 1;
	                        j = a[k >> 0] | 0;
	                        a[u >> 0] = j;
	                        v = c[t >> 2] | 0;
	                        w = (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3) | 0;
	                        if (!(j << 24 >> 24))break;
	                        c[t >> 2] = v ^ w + (a[u >> 0] | 0)
	                    }
	                    c[t >> 2] = v ^ w + 58
	                }
	                a:do if (c[o >> 2] | 0)while (1) {
	                    w = c[o >> 2] | 0;
	                    c[o >> 2] = w + 1;
	                    v = a[w >> 0] | 0;
	                    a[u >> 0] = v;
	                    if (!(v << 24 >> 24))break a;
	                    c[t >> 2] = c[t >> 2] ^ (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3) + (a[u >> 0] | 0)
	                } while (0);
	                c[t >> 2] = c[t >> 2] ^ (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3);
	                if (c[p >> 2] | 0) {
	                    while (1) {
	                        o = c[p >> 2] | 0;
	                        c[p >> 2] = o + 1;
	                        v = a[o >> 0] | 0;
	                        a[u >> 0] = v;
	                        x = c[t >> 2] | 0;
	                        y = (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3) | 0;
	                        if (!(v << 24 >> 24))break;
	                        c[t >> 2] = x ^ y + (a[u >> 0] | 0)
	                    }
	                    c[t >> 2] = x ^ y + 58
	                }
	                b:do if (c[q >> 2] | 0)while (1) {
	                    y = c[q >> 2] | 0;
	                    c[q >> 2] = y + 1;
	                    x = a[y >> 0] | 0;
	                    a[u >> 0] = x;
	                    if (!(x << 24 >> 24))break b;
	                    c[t >> 2] = c[t >> 2] ^ (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3) + (a[u >> 0] | 0)
	                } while (0);
	                c[t >> 2] = c[t >> 2] ^ (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3);
	                if (c[r >> 2] | 0) {
	                    while (1) {
	                        q = c[r >> 2] | 0;
	                        c[r >> 2] = q + 1;
	                        x = a[q >> 0] | 0;
	                        a[u >> 0] = x;
	                        z = c[t >> 2] | 0;
	                        A = (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3) | 0;
	                        if (!(x << 24 >> 24))break;
	                        c[t >> 2] = z ^ A + (a[u >> 0] | 0)
	                    }
	                    c[t >> 2] = z ^ A + 58
	                }
	                if (!(c[s >> 2] | 0)) {
	                    B = c[t >> 2] | 0;
	                    C = c[m >> 2] | 0;
	                    D = C + 4 | 0;
	                    E = c[D >> 2] | 0;
	                    F = (B >>> 0) % (E >>> 0) | 0;
	                    i = l;
	                    return F | 0
	                }
	                while (1) {
	                    A = c[s >> 2] | 0;
	                    c[s >> 2] = A + 1;
	                    z = a[A >> 0] | 0;
	                    a[u >> 0] = z;
	                    if (!(z << 24 >> 24))break;
	                    c[t >> 2] = c[t >> 2] ^ (c[t >> 2] << 5) + ((c[t >> 2] | 0) >>> 3) + (a[u >> 0] | 0)
	                }
	                B = c[t >> 2] | 0;
	                C = c[m >> 2] | 0;
	                D = C + 4 | 0;
	                E = c[D >> 2] | 0;
	                F = (B >>> 0) % (E >>> 0) | 0;
	                i = l;
	                return F | 0
	            }

	            function gk(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[g + 8 >> 2] = e;
	                c[g + 4 >> 2] = f;
	                c[l >> 2] = c[j >> 2];
	                Db[c[c[l >> 2] >> 2] & 511](c[h >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[k >> 2] | 0);
	                i = g;
	                return
	            }

	            function hk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                do if (!(c[g >> 2] | 0)) {
	                    if (!(c[(_a() | 0) >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 13) {
	                        c[g >> 2] = 1501;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 11) {
	                        c[g >> 2] = 1502;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 9) {
	                        c[g >> 2] = 1503;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 74) {
	                        c[g >> 2] = 1504;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 16) {
	                        c[g >> 2] = 1505;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 125) {
	                        c[g >> 2] = 1506;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 10) {
	                        c[g >> 2] = 1507;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 35) {
	                        c[g >> 2] = 1508;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 33) {
	                        c[g >> 2] = 1509;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 17) {
	                        c[g >> 2] = 1510;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 14) {
	                        c[g >> 2] = 1511;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 27) {
	                        c[g >> 2] = 1512;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 115) {
	                        c[g >> 2] = 1513;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 4) {
	                        c[g >> 2] = 1514;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 22) {
	                        c[g >> 2] = 1515;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 5) {
	                        c[g >> 2] = 1516;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 21) {
	                        c[g >> 2] = 1517;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 24) {
	                        c[g >> 2] = 1518;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 31) {
	                        c[g >> 2] = 1519;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 90) {
	                        c[g >> 2] = 1520;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 36) {
	                        c[g >> 2] = 1521;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 23) {
	                        c[g >> 2] = 1522;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 19) {
	                        c[g >> 2] = 1523;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 2) {
	                        c[g >> 2] = 1524;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 8) {
	                        c[g >> 2] = 1525;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 37) {
	                        c[g >> 2] = 1526;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 12) {
	                        c[g >> 2] = 1527;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 28) {
	                        c[g >> 2] = 1528;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 38) {
	                        c[g >> 2] = 1529;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 20) {
	                        c[g >> 2] = 1530;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 39) {
	                        c[g >> 2] = 1531;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 95) {
	                        c[g >> 2] = 1532;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 25) {
	                        c[g >> 2] = 1533;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 6) {
	                        c[g >> 2] = 1534;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 1) {
	                        c[g >> 2] = 1535;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 32) {
	                        c[g >> 2] = 1536;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 34) {
	                        c[g >> 2] = 1537;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 30) {
	                        c[g >> 2] = 1538;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 29) {
	                        c[g >> 2] = 1539;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 3) {
	                        c[g >> 2] = 1540;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 110) {
	                        c[g >> 2] = 1541;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 18) {
	                        c[g >> 2] = 1542;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 88) {
	                        c[g >> 2] = 1550;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 106) {
	                        c[g >> 2] = 1551;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 111) {
	                        c[g >> 2] = 1552;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 110) {
	                        c[g >> 2] = 1541;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 101) {
	                        c[g >> 2] = 1553;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 98) {
	                        c[g >> 2] = 1554;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 115) {
	                        c[g >> 2] = 1513;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 114) {
	                        c[g >> 2] = 1555;
	                        break
	                    }
	                    if ((c[(_a() | 0) >> 2] | 0) == 97) {
	                        c[g >> 2] = 1556;
	                        break
	                    } else {
	                        c[g >> 2] = 1500;
	                        break
	                    }
	                } while (0);
	                c[j >> 2] = 0;
	                if ((c[g >> 2] | 0) >= 1500)c[j >> 2] = (c[g >> 2] | 0) - 1500;
	                if ((c[j >> 2] | 0) >>> 0 < 57) {
	                    k = c[f >> 2] | 0;
	                    l = c[g >> 2] | 0;
	                    m = c[j >> 2] | 0;
	                    n = 76128 + (m << 2) | 0;
	                    o = c[n >> 2] | 0;
	                    p = c[h >> 2] | 0;
	                    ce(k, l, 0, o, p);
	                    i = e;
	                    return
	                }
	                c[j >> 2] = 0;
	                k = c[f >> 2] | 0;
	                l = c[g >> 2] | 0;
	                m = c[j >> 2] | 0;
	                n = 76128 + (m << 2) | 0;
	                o = c[n >> 2] | 0;
	                p = c[h >> 2] | 0;
	                ce(k, l, 0, o, p);
	                i = e;
	                return
	            }

	            function ik(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[g >> 2];
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 2;
	                if (((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = e;
	                    return
	                }
	                if ((c[k >> 2] | 0) != 0 ? (c[c[k >> 2] >> 2] | 0) != 0 : 0) {
	                    g = c[c[k >> 2] >> 2] | 0;
	                    if (c[(c[k >> 2] | 0) + 104 >> 2] | 0) {
	                        c[m >> 2] = c[g + 88 >> 2];
	                        c[o >> 2] = 2
	                    } else {
	                        c[m >> 2] = c[g + 84 >> 2];
	                        c[o >> 2] = 1
	                    }
	                    if ((c[(c[c[k >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497)c[l >> 2] = c[(c[c[k >> 2] >> 2] | 0) + 124 >> 2];
	                    c[n >> 2] = c[(c[k >> 2] | 0) + 4 >> 2]
	                }
	                g = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[k >> 2] | 0;
	                k = c[o >> 2] | 0;
	                o = c[j >> 2] | 0;
	                d = c[h >> 2] | 0;
	                c[f >> 2] = c[j >> 2];
	                Xd(g, l, m, n, 0, 8, 1549, k, 0, 0, o, 0, 0, 0, 0, d, f);
	                i = e;
	                return
	            }

	            function jk() {
	                var a = 0, b = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                if (!(c[19090] | 0)) {
	                    i = a;
	                    return
	                }
	                c[b >> 2] = (c[19092] | 0) - 1;
	                while (1) {
	                    if ((c[b >> 2] | 0) < 0)break;
	                    c[76376 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[76380 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[76384 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[76388 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + -1
	                }
	                c[19092] = 0;
	                c[19090] = 0;
	                i = a;
	                return
	            }

	            function kk() {
	                var a = 0, b = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                if (!(c[19154] | 0)) {
	                    i = a;
	                    return
	                }
	                c[b >> 2] = (c[19156] | 0) - 1;
	                while (1) {
	                    if ((c[b >> 2] | 0) < 0)break;
	                    c[76632 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[76636 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[76640 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[76644 + (c[b >> 2] << 4) >> 2] = 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + -1
	                }
	                c[19156] = 0;
	                c[19154] = 0;
	                i = a;
	                return
	            }

	            function lk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 96 | 0;
	                d = b + 80 | 0;
	                e = b + 76 | 0;
	                f = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    if (($a(c[e >> 2] | 0, f | 0) | 0) == -1) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if ((c[f + 12 >> 2] & 61440 | 0) == 16384) {
	                        c[d >> 2] = 2;
	                        break
	                    } else {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function mk() {
	                return 0
	            }

	            function nk(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return 1
	            }

	            function ok(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[f >> 2] = Yk(c[d >> 2] | 0) | 0;
	                if (c[f >> 2] | 0) {
	                    g = c[f >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[e >> 2] = El(c[d >> 2] | 0, 0, 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    g = c[f >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Yk(c[e >> 2] | 0) | 0;
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                g = c[f >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function pk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Aa(c[h >> 2] | 0, 1, c[j >> 2] | 0, c[g >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) < 0)Zk(0, 76872);
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function qk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[f >> 2] = c[e >> 2];
	                if ((c[f >> 2] | 0) != (c[q >> 2] | 0) ? (c[f >> 2] | 0) != (c[o >> 2] | 0) : 0) {
	                    if ((c[f >> 2] | 0) == (c[p >> 2] | 0)) {
	                        c[d >> 2] = 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                    a = (Xa(c[e >> 2] | 0) | 0) == -1;
	                    c[g >> 2] = a ? -1 : 0;
	                    if ((c[g >> 2] | 0) < 0)Zk(0, 76896);
	                    c[d >> 2] = c[g >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = Ga(c[f >> 2] | 0) | 0;
	                if ((c[g >> 2] | 0) < 0)Zk(0, 76880);
	                c[d >> 2] = 0;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function rk(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[19092] | 0) >= 15) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[76376 + (c[19092] << 4) >> 2] = c[h >> 2];
	                    c[76380 + (c[19092] << 4) >> 2] = c[j >> 2];
	                    c[76384 + (c[19092] << 4) >> 2] = c[k >> 2];
	                    c[76388 + (c[19092] << 4) >> 2] = c[l >> 2];
	                    c[19090] = 1;
	                    l = c[19092] | 0;
	                    c[19092] = l + 1;
	                    c[g >> 2] = l;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function sk(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[19156] | 0) >= 15) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[76632 + (c[19156] << 4) >> 2] = c[h >> 2];
	                    c[76636 + (c[19156] << 4) >> 2] = c[j >> 2];
	                    c[76640 + (c[19156] << 4) >> 2] = c[k >> 2];
	                    c[76644 + (c[19156] << 4) >> 2] = c[l >> 2];
	                    c[19154] = 1;
	                    l = c[19156] | 0;
	                    c[19156] = l + 1;
	                    c[g >> 2] = l;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function tk() {
	                var a = 0;
	                a = i;
	                if (c[19090] | 0) {
	                    i = a;
	                    return
	                }
	                rk(230, 231, 232, 233) | 0;
	                c[19090] = 1;
	                i = a;
	                return
	            }

	            function uk() {
	                var a = 0;
	                a = i;
	                if (c[19154] | 0) {
	                    i = a;
	                    return
	                }
	                sk(230, 234, 235, 233) | 0;
	                c[19154] = 1;
	                i = a;
	                return
	            }

	            function vk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    al(76912);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 36 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                a = My(c[33950] << 1) | 0;
	                c[(c[f >> 2] | 0) + 16 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 16 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                Qy(c[(c[f >> 2] | 0) + 16 >> 2] | 0, 0) | 0;
	                a = Cd(c[e >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 12 >> 2] = a;
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                    a = My(c[33950] << 1) | 0;
	                    c[(c[f >> 2] | 0) + 20 >> 2] = a
	                } else c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[c[f >> 2] >> 2] = 0;
	                c[(c[f >> 2] | 0) + 24 >> 2] = -1;
	                c[(c[f >> 2] | 0) + 32 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function wk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    al(76936);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                c[a + 12 >> 2] = 0;
	                c[a + 16 >> 2] = 0;
	                c[a + 20 >> 2] = 0;
	                c[a + 24 >> 2] = 0;
	                c[a + 28 >> 2] = 0;
	                a = Ly() | 0;
	                c[(c[f >> 2] | 0) + 16 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 16 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if ((Py(c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0) == 1)Qy(c[(c[f >> 2] | 0) + 16 >> 2] | 0, 0) | 0;
	                c[(c[f >> 2] | 0) + 12 >> 2] = c[e >> 2];
	                do if (c[e >> 2] | 0) {
	                    a = My(4e3) | 0;
	                    c[(c[f >> 2] | 0) + 20 >> 2] = a;
	                    if (c[(c[f >> 2] | 0) + 20 >> 2] | 0) {
	                        Gd(c[f >> 2] | 0, 1) | 0;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else c[(c[f >> 2] | 0) + 20 >> 2] = 0; while (0);
	                c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[c[f >> 2] >> 2] = 0;
	                c[(c[f >> 2] | 0) + 24 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function xk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    al(76936);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                c[a + 12 >> 2] = 0;
	                c[a + 16 >> 2] = 0;
	                c[a + 20 >> 2] = 0;
	                c[a + 24 >> 2] = 0;
	                c[a + 28 >> 2] = 0;
	                a = Ly() | 0;
	                c[(c[f >> 2] | 0) + 16 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 16 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                Qy(c[(c[f >> 2] | 0) + 16 >> 2] | 0, 3) | 0;
	                c[(c[f >> 2] | 0) + 12 >> 2] = c[e >> 2];
	                do if (c[e >> 2] | 0) {
	                    a = My(4e3) | 0;
	                    c[(c[f >> 2] | 0) + 20 >> 2] = a;
	                    if (c[(c[f >> 2] | 0) + 20 >> 2] | 0) {
	                        Gd(c[f >> 2] | 0, 1) | 0;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else c[(c[f >> 2] | 0) + 20 >> 2] = 0; while (0);
	                c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[c[f >> 2] >> 2] = 0;
	                c[(c[f >> 2] | 0) + 24 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function yk(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0) {
	                    Ry(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 20 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)Hd(c[(c[d >> 2] | 0) + 12 >> 2] | 0) | 0;
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Cb[c[(c[d >> 2] | 0) + 8 >> 2] & 511](c[c[d >> 2] >> 2] | 0) | 0;
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0) {
	                    Ry(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 16 >> 2] = 0
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function zk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                if (c[(c[e >> 2] | 0) + 4 >> 2] | 0)Ak(c[e >> 2] | 0) | 0;
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0)c[g >> 2] = Cb[c[(c[e >> 2] | 0) + 8 >> 2] & 511](c[c[e >> 2] >> 2] | 0) | 0;
	                c[f >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                if (c[(c[e >> 2] | 0) + 20 >> 2] | 0) {
	                    Ry(c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 20 >> 2] = 0
	                }
	                if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)Hd(c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0;
	                if (c[(c[e >> 2] | 0) + 16 >> 2] | 0) {
	                    Ry(c[(c[e >> 2] | 0) + 16 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 16 >> 2] = 0
	                }
	                if (c[(c[e >> 2] | 0) + 28 >> 2] | 0)c[g >> 2] = -1;
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                c[d >> 2] = (c[g >> 2] | 0) == 0 ? c[f >> 2] | 0 : c[g >> 2] | 0;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Ak(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                    a:do if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        while (1) {
	                            c[f >> 2] = Gd(c[e >> 2] | 0, 0) | 0;
	                            if ((c[f >> 2] | 0) < 0)break;
	                            if (!(c[f >> 2] | 0))break a
	                        }
	                        Zk(1544, 0);
	                        c[(c[e >> 2] | 0) + 28 >> 2] = 1544;
	                        c[d >> 2] = -1;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    } while (0);
	                    if (((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        f = c[(c[e >> 2] | 0) + 4 >> 2] | 0;
	                        a = c[c[e >> 2] >> 2] | 0;
	                        j = Vy(c[(c[e >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        k = _y(c[(c[e >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        c[g >> 2] = vb[f & 511](a, j, k) | 0;
	                        if ((c[g >> 2] | 0) >= 0)Ty(c[(c[e >> 2] | 0) + 20 >> 2] | 0, c[g >> 2] | 0) | 0
	                    } else l = 14;
	                    if (((l | 0) == 14 ? (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (l = c[(c[e >> 2] | 0) + 4 >> 2] | 0, k = c[c[e >> 2] >> 2] | 0, j = Vy(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0, a = _y(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0, c[g >> 2] = vb[l & 511](k, j, a) | 0, (c[g >> 2] | 0) >= 0) : 0)Ty(c[(c[e >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[g >> 2] | 0) < 0) {
	                        Zk(1545, 0);
	                        c[(c[e >> 2] | 0) + 28 >> 2] = 1545;
	                        c[d >> 2] = c[g >> 2];
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    } else {
	                        a = (c[e >> 2] | 0) + 24 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + (c[g >> 2] | 0);
	                        c[d >> 2] = c[g >> 2];
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                }
	                c[d >> 2] = -1;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Bk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (!(c[19090] | 0))tk();
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                a:do if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = (c[19092] | 0) - 1;
	                    while (1) {
	                        if ((c[j >> 2] | 0) < 0)break a;
	                        if (((c[76376 + (c[j >> 2] << 4) >> 2] | 0) != 0 ? (Cb[c[76376 + (c[j >> 2] << 4) >> 2] & 511](c[f >> 2] | 0) | 0) != 0 : 0) ? (c[k >> 2] = Cb[c[76376 + (c[j >> 2] << 4) + 4 >> 2] & 511](c[f >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break a;
	                        c[j >> 2] = (c[j >> 2] | 0) + -1
	                    }
	                } while (0);
	                if (!(c[k >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = vk(c[g >> 2] | 0) | 0;
	                if (c[h >> 2] | 0) {
	                    c[c[h >> 2] >> 2] = c[k >> 2];
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[76384 + (c[j >> 2] << 4) >> 2];
	                    c[(c[h >> 2] | 0) + 8 >> 2] = c[76388 + (c[j >> 2] << 4) >> 2]
	                } else Cb[c[76376 + (c[j >> 2] << 4) + 12 >> 2] & 511](c[k >> 2] | 0) | 0;
	                c[e >> 2] = c[h >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Ck(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[33972] | 0) {
	                    c[e >> 2] = Hb[c[135888 >> 2] & 511](c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = Bk(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function Dk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[e + 20 >> 2] = d;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!(c[19154] | 0))uk();
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[k >> 2] = yl(c[g >> 2] | 0) | 0;
	                if (c[k >> 2] | 0) {
	                    if (!((c[c[k >> 2] >> 2] | 0) != 0 ? (qy(c[c[k >> 2] >> 2] | 0, 76960) | 0) == 0 : 0))c[n >> 2] = El(c[g >> 2] | 0, 0, 0) | 0;
	                    Al(c[k >> 2] | 0)
	                }
	                if (c[n >> 2] | 0) {
	                    c[l >> 2] = (c[19156] | 0) - 1;
	                    while (1) {
	                        if ((c[l >> 2] | 0) < 0)break;
	                        if (((c[76632 + (c[l >> 2] << 4) >> 2] | 0) != 0 ? (Cb[c[76632 + (c[l >> 2] << 4) >> 2] & 511](c[n >> 2] | 0) | 0) != 0 : 0) ? (c[m >> 2] = Cb[c[76632 + (c[l >> 2] << 4) + 4 >> 2] & 511](c[n >> 2] | 0) | 0, (c[m >> 2] | 0) != 0) : 0)break;
	                        c[l >> 2] = (c[l >> 2] | 0) + -1
	                    }
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                }
	                a:do if (!(c[m >> 2] | 0)) {
	                    c[l >> 2] = (c[19156] | 0) - 1;
	                    while (1) {
	                        if ((c[l >> 2] | 0) < 0)break a;
	                        if (((c[76632 + (c[l >> 2] << 4) >> 2] | 0) != 0 ? (Cb[c[76632 + (c[l >> 2] << 4) >> 2] & 511](c[g >> 2] | 0) | 0) != 0 : 0) ? (c[m >> 2] = Cb[c[76632 + (c[l >> 2] << 4) + 4 >> 2] & 511](c[g >> 2] | 0) | 0, (c[m >> 2] | 0) != 0) : 0)break a;
	                        c[l >> 2] = (c[l >> 2] | 0) + -1
	                    }
	                } while (0);
	                if (!(c[m >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[j >> 2] = xk(c[h >> 2] | 0) | 0;
	                if (c[j >> 2] | 0) {
	                    c[c[j >> 2] >> 2] = c[m >> 2];
	                    c[(c[j >> 2] | 0) + 4 >> 2] = c[76640 + (c[l >> 2] << 4) >> 2];
	                    c[(c[j >> 2] | 0) + 8 >> 2] = c[76644 + (c[l >> 2] << 4) >> 2]
	                }
	                c[f >> 2] = c[j >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Ek(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (c[33974] | 0) {
	                    c[f >> 2] = vb[c[135896 >> 2] & 511](c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = Dk(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function Fk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[19154] | 0))uk();
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = xk(c[g >> 2] | 0) | 0;
	                if (c[h >> 2] | 0) {
	                    c[c[h >> 2] >> 2] = c[f >> 2];
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 235;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 236
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Gk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) < 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = vk(c[g >> 2] | 0) | 0;
	                if (c[h >> 2] | 0) {
	                    c[c[h >> 2] >> 2] = c[f >> 2];
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 237;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 238
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Hk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[h >> 2] | 0) <= 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = vk(c[j >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) != 0 ? (c[c[k >> 2] >> 2] = c[g >> 2], c[(c[k >> 2] | 0) + 4 >> 2] = 227, c[(c[k >> 2] | 0) + 8 >> 2] = 0, c[l >> 2] = cz(c[(c[k >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0, (c[l >> 2] | 0) != 0) : 0) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Ik(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[h >> 2] | 0) <= 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    al(76912);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 36 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                d = Oy(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 16 >> 2] = d;
	                if (!(c[(c[k >> 2] | 0) + 16 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = Cd(c[j >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 12 >> 2] = d;
	                if (c[(c[k >> 2] | 0) + 12 >> 2] | 0) {
	                    d = My(c[33950] << 1) | 0;
	                    c[(c[k >> 2] | 0) + 20 >> 2] = d
	                } else c[(c[k >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 24 >> 2] = -1;
	                c[c[k >> 2] >> 2] = c[g >> 2];
	                c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 8 >> 2] = 0;
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Jk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) < 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = xk(c[g >> 2] | 0) | 0;
	                if (c[h >> 2] | 0) {
	                    c[c[h >> 2] >> 2] = c[f >> 2];
	                    c[(c[h >> 2] | 0) + 4 >> 2] = 239;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = 0
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Kk(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = vk(c[l >> 2] | 0) | 0;
	                if (c[m >> 2] | 0) {
	                    c[c[m >> 2] >> 2] = c[k >> 2];
	                    c[(c[m >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    c[(c[m >> 2] | 0) + 8 >> 2] = c[j >> 2]
	                }
	                c[g >> 2] = c[m >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function Lk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) < 0) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                    do if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[k >> 2] = c[h >> 2];
	                        c[l >> 2] = cz(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[f >> 2] = -1;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                    } else {
	                        if (!(c[(c[g >> 2] | 0) + 20 >> 2] | 0)) {
	                            d = Ly() | 0;
	                            c[(c[g >> 2] | 0) + 20 >> 2] = d
	                        }
	                        c[l >> 2] = cz(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[f >> 2] = -1;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                        c[m >> 2] = _y(c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        c[k >> 2] = Fd(c[g >> 2] | 0, 1) | 0;
	                        if ((c[k >> 2] | 0) >= 0) {
	                            d = c[m >> 2] | 0;
	                            b = d - (_y(c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0) | 0;
	                            d = (c[g >> 2] | 0) + 32 | 0;
	                            c[d >> 2] = (c[d >> 2] | 0) + b;
	                            break
	                        }
	                        Zk(1544, 0);
	                        c[(c[g >> 2] | 0) + 28 >> 2] = 1544;
	                        c[f >> 2] = -1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } while (0);
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[f >> 2] = -1;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function Mk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                    if ((c[g >> 2] | 0) <= 4e3 & (c[g >> 2] | 0) != 4)c[g >> 2] = 4e3;
	                    if (($y(c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 <= 0) {
	                        Zk(1548, 0);
	                        c[(c[f >> 2] | 0) + 28 >> 2] = 1548;
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    if ((Uy(c[(c[f >> 2] | 0) + 16 >> 2] | 0, (c[g >> 2] | 0) + 1 | 0) | 0) < 0) {
	                        al(76968);
	                        c[(c[f >> 2] | 0) + 28 >> 2] = 2;
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[h >> 2] = Wy(c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    if (!(c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                        Zk(1547, 0);
	                        c[(c[f >> 2] | 0) + 28 >> 2] = 1547;
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[j >> 2] = vb[c[(c[f >> 2] | 0) + 4 >> 2] & 511](c[c[f >> 2] >> 2] | 0, c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[j >> 2] | 0) <= 0)c[(c[f >> 2] | 0) + 4 >> 2] = 240;
	                    if ((c[j >> 2] | 0) < 0) {
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[g >> 2] = c[j >> 2];
	                    do if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                        if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                            b = Ly() | 0;
	                            c[(c[f >> 2] | 0) + 20 >> 2] = b
	                        }
	                        c[j >> 2] = cz(c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (c[j >> 2] | 0) {
	                            c[e >> 2] = -1;
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                        c[l >> 2] = _y(c[(c[f >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        c[k >> 2] = Fd(c[f >> 2] | 0, 1) | 0;
	                        if ((c[k >> 2] | 0) >= 0) {
	                            b = c[l >> 2] | 0;
	                            a = b - (_y(c[(c[f >> 2] | 0) + 20 >> 2] | 0) | 0) | 0;
	                            b = (c[f >> 2] | 0) + 32 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + a;
	                            break
	                        }
	                        Zk(1544, 0);
	                        c[(c[f >> 2] | 0) + 28 >> 2] = 1544;
	                        c[e >> 2] = -1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } else {
	                        c[k >> 2] = c[g >> 2];
	                        Xy(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[k >> 2] | 0) | 0
	                    } while (0);
	                    c[e >> 2] = c[k >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[e >> 2] = -1;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function Nk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                    b = c[f >> 2] | 0;
	                    if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                        c[e >> 2] = Mk(b, c[g >> 2] | 0) | 0;
	                        break
	                    }
	                    if ((Py(c[b + 16 >> 2] | 0) | 0) == 2) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                } else h = 3; while (0);
	                if ((h | 0) == 3)c[e >> 2] = -1;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Ok(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                    if ((c[h >> 2] | 0) < 0) {
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 28 >> 2] | 0) {
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    while (1) {
	                        d = c[h >> 2] | 0;
	                        c[n >> 2] = d;
	                        c[n >> 2] = (c[n >> 2] | 0) > 16e3 ? 16e3 : d;
	                        d = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                            if (!(c[d + 20 >> 2] | 0)) {
	                                b = Ly() | 0;
	                                c[(c[g >> 2] | 0) + 20 >> 2] = b
	                            }
	                            c[l >> 2] = cz(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                            if (c[l >> 2] | 0) {
	                                p = 12;
	                                break
	                            }
	                            if ((_y(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 < 4e3 ? (c[n >> 2] | 0) == (c[h >> 2] | 0) : 0) {
	                                p = 32;
	                                break
	                            }
	                            c[l >> 2] = Gd(c[g >> 2] | 0, 0) | 0;
	                            if ((c[l >> 2] | 0) < 0 & (c[l >> 2] | 0) != -3) {
	                                p = 16;
	                                break
	                            }
	                            c[k >> 2] = _y(c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0
	                        } else {
	                            c[l >> 2] = cz(c[d + 16 >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                            if (c[l >> 2] | 0) {
	                                p = 19;
	                                break
	                            }
	                            c[k >> 2] = _y(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0
	                        }
	                        c[j >> 2] = (c[j >> 2] | 0) + (c[n >> 2] | 0);
	                        c[h >> 2] = (c[h >> 2] | 0) - (c[n >> 2] | 0);
	                        if ((c[k >> 2] | 0) < 4e3 & (c[h >> 2] | 0) <= 0) {
	                            p = 32;
	                            break
	                        }
	                        if (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                            d = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                            b = c[c[g >> 2] >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                                q = Vy(c[a + 20 >> 2] | 0) | 0;
	                                c[l >> 2] = vb[d & 511](b, q, c[k >> 2] | 0) | 0;
	                                if ((c[l >> 2] | 0) >= 0)Ty(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[l >> 2] | 0) | 0
	                            } else {
	                                q = Vy(c[a + 16 >> 2] | 0) | 0;
	                                c[l >> 2] = vb[d & 511](b, q, c[k >> 2] | 0) | 0;
	                                if ((c[l >> 2] | 0) >= 0)Ty(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[l >> 2] | 0) | 0
	                            }
	                            if ((c[l >> 2] | 0) < 0) {
	                                p = 29;
	                                break
	                            }
	                            q = (c[g >> 2] | 0) + 24 | 0;
	                            c[q >> 2] = (c[q >> 2] | 0) + (c[l >> 2] | 0)
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + (c[k >> 2] | 0);
	                        if ((c[h >> 2] | 0) <= 0) {
	                            p = 32;
	                            break
	                        }
	                    }
	                    if ((p | 0) == 12) {
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 16) {
	                        Zk(1544, 0);
	                        c[(c[g >> 2] | 0) + 28 >> 2] = 1544;
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 19) {
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 29) {
	                        Zk(1546, 0);
	                        c[(c[g >> 2] | 0) + 28 >> 2] = 1546;
	                        c[f >> 2] = c[l >> 2];
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else if ((p | 0) == 32) {
	                        c[f >> 2] = c[m >> 2];
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                }
	                c[f >> 2] = -1;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Pk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((((c[g >> 2] | 0) != 0 ? !((c[h >> 2] | 0) == 0 ? 1 : (c[(c[g >> 2] | 0) + 28 >> 2] | 0) != 0) : 0) ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (Py(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0) != 2 : 0) {
	                    c[p >> 2] = ZT(c[h >> 2] | 0) | 0;
	                    if ((c[p >> 2] | 0) < 0) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    if (c[(c[g >> 2] | 0) + 28 >> 2] | 0) {
	                        c[f >> 2] = -1;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    if (!(c[j >> 2] | 0))c[j >> 2] = 241;
	                    while (1) {
	                        c[n >> 2] = c[m >> 2];
	                        c[q >> 2] = c[p >> 2];
	                        c[o >> 2] = ($y(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0) - 1;
	                        d = c[g >> 2] | 0;
	                        if ((c[o >> 2] | 0) < 40) {
	                            if ((Uy(c[d + 16 >> 2] | 0, 100) | 0) < 0) {
	                                s = 14;
	                                break
	                            }
	                            c[n >> 2] = -1
	                        } else {
	                            if (c[d + 12 >> 2] | 0) {
	                                if (!(c[(c[g >> 2] | 0) + 20 >> 2] | 0)) {
	                                    d = Ly() | 0;
	                                    c[(c[g >> 2] | 0) + 20 >> 2] = d
	                                }
	                                d = c[j >> 2] | 0;
	                                b = Wy(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[l >> 2] = Fb[d & 511](b, o, c[h >> 2] | 0, q) | 0;
	                                if ((c[l >> 2] | 0) < 0 | (c[o >> 2] | 0) == 0) {
	                                    s = 20;
	                                    break
	                                }
	                                Xy(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[o >> 2] | 0) | 0;
	                                if ((_y(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 < 4e3 ? (c[q >> 2] | 0) == (c[p >> 2] | 0) : 0) {
	                                    s = 44;
	                                    break
	                                }
	                                c[l >> 2] = Gd(c[g >> 2] | 0, 0) | 0;
	                                if ((c[l >> 2] | 0) < 0 & (c[l >> 2] | 0) != -3) {
	                                    s = 24;
	                                    break
	                                }
	                                c[k >> 2] = _y(c[(c[g >> 2] | 0) + 20 >> 2] | 0) | 0
	                            } else {
	                                b = c[j >> 2] | 0;
	                                d = Wy(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[l >> 2] = Fb[b & 511](d, o, c[h >> 2] | 0, q) | 0;
	                                if ((c[l >> 2] | 0) < 0 | (c[o >> 2] | 0) == 0) {
	                                    s = 27;
	                                    break
	                                }
	                                Xy(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[o >> 2] | 0) | 0;
	                                c[k >> 2] = _y(c[(c[g >> 2] | 0) + 16 >> 2] | 0) | 0
	                            }
	                            c[h >> 2] = (c[h >> 2] | 0) + (c[q >> 2] | 0);
	                            c[p >> 2] = (c[p >> 2] | 0) - (c[q >> 2] | 0);
	                            if ((c[k >> 2] | 0) < 4e3 & (c[p >> 2] | 0) <= 0) {
	                                s = 44;
	                                break
	                            }
	                            d = c[g >> 2] | 0;
	                            if (!(c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                                if (($y(c[d + 16 >> 2] | 0) | 0) >>> 0 < 4e3)Uy(c[(c[g >> 2] | 0) + 16 >> 2] | 0, 4e3) | 0
	                            } else {
	                                b = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                                a = c[c[g >> 2] >> 2] | 0;
	                                t = c[g >> 2] | 0;
	                                if (c[d + 12 >> 2] | 0) {
	                                    d = Vy(c[t + 20 >> 2] | 0) | 0;
	                                    c[l >> 2] = vb[b & 511](a, d, c[k >> 2] | 0) | 0;
	                                    if ((c[l >> 2] | 0) >= 0)Ty(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[l >> 2] | 0) | 0
	                                } else {
	                                    d = Vy(c[t + 16 >> 2] | 0) | 0;
	                                    c[l >> 2] = vb[b & 511](a, d, c[k >> 2] | 0) | 0;
	                                    if ((c[l >> 2] | 0) >= 0)Ty(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[l >> 2] | 0) | 0
	                                }
	                                if ((c[l >> 2] | 0) < 0) {
	                                    s = 37;
	                                    break
	                                }
	                                d = (c[g >> 2] | 0) + 24 | 0;
	                                c[d >> 2] = (c[d >> 2] | 0) + (c[l >> 2] | 0)
	                            }
	                            c[m >> 2] = (c[m >> 2] | 0) + (c[k >> 2] | 0)
	                        }
	                        if ((c[p >> 2] | 0) <= 0) {
	                            s = 44;
	                            break
	                        }
	                        if ((c[n >> 2] | 0) == (c[m >> 2] | 0)) {
	                            s = 44;
	                            break
	                        }
	                    }
	                    if ((s | 0) == 14) {
	                        c[f >> 2] = -1;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 20) {
	                        c[f >> 2] = -1;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 24) {
	                        Zk(1544, 0);
	                        c[(c[g >> 2] | 0) + 28 >> 2] = 1544;
	                        c[f >> 2] = -1;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 27) {
	                        c[f >> 2] = -1;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 37) {
	                        Zk(1546, 0);
	                        c[(c[g >> 2] | 0) + 28 >> 2] = 1546;
	                        c[f >> 2] = c[l >> 2];
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    } else if ((s | 0) == 44) {
	                        c[f >> 2] = c[m >> 2];
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                }
	                c[f >> 2] = -1;
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function Qk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    c[h >> 2] = ZT(c[g >> 2] | 0) | 0;
	                    if ((c[h >> 2] | 0) > 0) {
	                        c[e >> 2] = Ok(c[f >> 2] | 0, c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[e >> 2] = c[h >> 2];
	                        break
	                    }
	                } else j = 3; while (0);
	                if ((j | 0) == 3)c[e >> 2] = -1;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Rk(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 1040 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d + 16 | 0;
	                j = d;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                if (!(c[19090] | 0))tk();
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                aU(h | 0, c[f >> 2] | 0, 1023) | 0;
	                a[h + 1023 >> 0] = 0;
	                c[j >> 2] = h + (ZT(h | 0) | 0);
	                while (1) {
	                    if ((c[j >> 2] | 0) >>> 0 <= h >>> 0)break;
	                    if ((a[c[j >> 2] >> 0] | 0) == 47)break;
	                    c[j >> 2] = (c[j >> 2] | 0) + -1
	                }
	                if ((a[c[j >> 2] >> 0] | 0) != 47) {
	                    if (za(h | 0, 1024) | 0) {
	                        a[h + 1023 >> 0] = 0;
	                        c[g >> 2] = Cb[c[135768 >> 2] & 511](h) | 0
	                    }
	                } else {
	                    if ((c[j >> 2] | 0) == (h | 0))a[h + 1 >> 0] = 0; else a[c[j >> 2] >> 0] = 0;
	                    c[g >> 2] = Cb[c[135768 >> 2] & 511](h) | 0
	                }
	                c[e >> 2] = c[g >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function Sk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                c[d + 4 >> 2] = a;
	                c[e >> 2] = b;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Tk(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                c[19248] = c[d >> 2];
	                i = b;
	                return
	            }

	            function Uk() {
	                return c[19248] | 0
	            }

	            function Vk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? (hl(c[g >> 2] | 0) | 0) == 0 : 0) {
	                    c[k >> 2] = Jl(c[g >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        al(77e3);
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else {
	                        c[l >> 2] = vb[c[76992 >> 2] & 511](c[k >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        c[f >> 2] = c[l >> 2];
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                }
	                c[f >> 2] = vb[c[76992 >> 2] & 511](c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Wk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                c[l >> 2] = il(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0))c[l >> 2] = c[g >> 2];
	                do if (c[l >> 2] | 0) {
	                    if ((uy(c[l >> 2] | 0, 77032, 6) | 0) != 0 ? (uy(c[l >> 2] | 0, 77040, 7) | 0) != 0 : 0)break;
	                    Zk(1543, c[l >> 2] | 0);
	                    if ((c[l >> 2] | 0) != (c[g >> 2] | 0))zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[k >> 2] = Xk(c[l >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) != (c[g >> 2] | 0))zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Xk(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 360 >> 2] & 2048 | 0) != 0 : 0) {
	                    c[m >> 2] = c[(c[j >> 2] | 0) + 360 >> 2];
	                    d = (c[j >> 2] | 0) + 360 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) - 2048;
	                    c[k >> 2] = Wk(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 360 >> 2] = c[m >> 2];
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[l >> 2] = il(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0))c[l >> 2] = c[g >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    if (!(c[h >> 2] | 0))c[h >> 2] = 77048;
	                    ik(c[j >> 2] | 0, 77056, c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[k >> 2] = xe(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) != 0 ? (c[l >> 2] | 0) != (c[g >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function Yk(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                if (!(PT(c[e >> 2] | 0, 77176) | 0)) {
	                    c[g >> 2] = c[p >> 2];
	                    c[d >> 2] = c[g >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a = (uy(c[e >> 2] | 0, 77096, 17) | 0) != 0;
	                j = c[e >> 2] | 0;
	                do if (a) {
	                    k = (uy(j, 77120, 8) | 0) != 0;
	                    l = c[e >> 2] | 0;
	                    if (!k) {
	                        c[f >> 2] = l + 7;
	                        break
	                    }
	                    if (!(uy(l, 77192, 6) | 0))c[f >> 2] = (c[e >> 2] | 0) + 5
	                } else c[f >> 2] = j + 16; while (0);
	                if (!(lk(c[f >> 2] | 0) | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = pb(c[f >> 2] | 0, 77200) | 0;
	                if (!(c[g >> 2] | 0))Zk(0, c[f >> 2] | 0);
	                c[d >> 2] = c[g >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function Zk(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                hk(8, c[e >> 2] | 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function _k(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if (!(PT(c[e >> 2] | 0, 77176) | 0)) {
	                    c[g >> 2] = c[q >> 2];
	                    c[d >> 2] = c[g >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a = (uy(c[e >> 2] | 0, 77096, 17) | 0) != 0;
	                j = c[e >> 2] | 0;
	                do if (a) {
	                    k = (uy(j, 77120, 8) | 0) != 0;
	                    l = c[e >> 2] | 0;
	                    if (k) {
	                        c[f >> 2] = l;
	                        break
	                    } else {
	                        c[f >> 2] = l + 7;
	                        break
	                    }
	                } else c[f >> 2] = j + 16; while (0);
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[g >> 2] = pb(c[f >> 2] | 0, 77184) | 0;
	                if (!(c[g >> 2] | 0))Zk(0, c[f >> 2] | 0);
	                c[d >> 2] = c[g >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function $k(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = ib(c[h >> 2] | 0, c[j >> 2] | 0, 1, c[g >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) == 0 ? (Sa(c[g >> 2] | 0) | 0) != 0 : 0) {
	                    Zk(0, 77160);
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = ca(c[k >> 2] | 0, c[j >> 2] | 0) | 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function al(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ce(8, 2, 0, 0, c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function bl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (Ga(c[e >> 2] | 0) | 0) == -1;
	                c[f >> 2] = a ? -1 : 0;
	                if ((c[f >> 2] | 0) < 0)Zk(0, 76880);
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function cl(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = eb(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) >= 0) {
	                    k = c[j >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                Zk(0, 77152);
	                k = c[j >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function dl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = Ra(c[d >> 2] | 0) | 0;
	                if ((c[e >> 2] | 0) < 0)Zk(0, 77144);
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function el(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                if ((c[h >> 2] | 0) > 0 ? (c[j >> 2] = Ya(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0, (c[j >> 2] | 0) < 0) : 0)Zk(0, 77136);
	                i = e;
	                return c[j >> 2] | 0
	            }

	            function fl(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0;
	                e = i;
	                i = i + 16 | 0;
	                c[e + 8 >> 2] = a;
	                c[e + 4 >> 2] = b;
	                c[e >> 2] = d;
	                i = e;
	                return 0
	            }

	            function gl(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = g;
	                c[n >> 2] = c[j >> 2];
	                c[o >> 2] = c[l >> 2];
	                c[p >> 2] = (c[j >> 2] | 0) + (c[c[k >> 2] >> 2] | 0);
	                c[q >> 2] = (c[l >> 2] | 0) + (c[c[m >> 2] >> 2] | 0);
	                a:while (1) {
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[q >> 2] | 0) >>> 0)break;
	                    if ((c[j >> 2] | 0) >>> 0 >= (c[p >> 2] | 0) >>> 0)break;
	                    do if ((d[c[l >> 2] >> 0] | 0 | 0) == 60) {
	                        if (((c[p >> 2] | 0) - (c[j >> 2] | 0) | 0) < 4)break a;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 38;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 108;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 116;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 59
	                    } else {
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) == 62) {
	                            if (((c[p >> 2] | 0) - (c[j >> 2] | 0) | 0) < 4)break a;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 38;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 103;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 116;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 59;
	                            break
	                        }
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) == 38) {
	                            if (((c[p >> 2] | 0) - (c[j >> 2] | 0) | 0) < 5)break a;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 38;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 97;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 109;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 112;
	                            g = c[j >> 2] | 0;
	                            c[j >> 2] = g + 1;
	                            a[g >> 0] = 59;
	                            break
	                        }
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) != 13) {
	                            g = a[c[l >> 2] >> 0] | 0;
	                            f = c[j >> 2] | 0;
	                            c[j >> 2] = f + 1;
	                            a[f >> 0] = g;
	                            break
	                        }
	                        if (((c[p >> 2] | 0) - (c[j >> 2] | 0) | 0) < 5)break a;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 38;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 35;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 49;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 51;
	                        g = c[j >> 2] | 0;
	                        c[j >> 2] = g + 1;
	                        a[g >> 0] = 59
	                    } while (0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                c[c[k >> 2] >> 2] = (c[j >> 2] | 0) - (c[n >> 2] | 0);
	                c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[o >> 2] | 0);
	                i = h;
	                return 0
	            }

	            function hl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (uy(c[e >> 2] | 0, 77096, 17) | 0) != 0;
	                h = c[e >> 2] | 0;
	                do if (a) {
	                    j = (uy(h, 77120, 8) | 0) != 0;
	                    k = c[e >> 2] | 0;
	                    if (j) {
	                        c[f >> 2] = k;
	                        break
	                    } else {
	                        c[f >> 2] = k + 7;
	                        break
	                    }
	                } else c[f >> 2] = h + 16; while (0);
	                c[d >> 2] = lk(c[f >> 2] | 0) | 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function il(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                c[k >> 2] = Gw() | 0;
	                if (!(c[k >> 2] | 0)) {
	                    m = c[j >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (hl(c[f >> 2] | 0) | 0) {
	                    m = c[j >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 284 >> 2] | 0) != 0 : 0) ? (c[k >> 2] | 0) == 3 | (c[k >> 2] | 0) == 2 : 0)c[j >> 2] = Jw(c[(c[h >> 2] | 0) + 284 >> 2] | 0, c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) == 0 ? (c[k >> 2] | 0) == 3 | (c[k >> 2] | 0) == 1 : 0)c[j >> 2] = Ew(c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) == 0 & (c[f >> 2] | 0) != 0)c[j >> 2] = my(c[f >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    m = c[j >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (hl(c[j >> 2] | 0) | 0) {
	                    m = c[j >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[l >> 2] = 0;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 284 >> 2] | 0) != 0 : 0) ? (c[k >> 2] | 0) == 3 | (c[k >> 2] | 0) == 2 : 0)c[l >> 2] = Kw(c[(c[h >> 2] | 0) + 284 >> 2] | 0, c[j >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) == 0 ? (c[k >> 2] | 0) == 3 | (c[k >> 2] | 0) == 1 : 0)c[l >> 2] = Fw(c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    m = c[j >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                c[j >> 2] = c[l >> 2];
	                m = c[j >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function jl() {
	                var a = 0, b = 0, d = 0, e = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                d = c[33976] | 0;
	                e = c[33980] | 0;
	                c[b >> 2] = c[19636];
	                Db[d & 511](e, 78496, b);
	                i = a;
	                return
	            }

	            function kl(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                if (!(c[19638] | 0))ll() | 0;
	                c[l >> 2] = iT(24 + (c[h >> 2] | 0) | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 78560, f);
	                    ml();
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[c[l >> 2] >> 2] = 23205;
	                c[(c[l >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                c[(c[l >> 2] | 0) + 4 >> 2] = 1;
	                c[(c[l >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                c[(c[l >> 2] | 0) + 20 >> 2] = c[k >> 2];
	                rx(c[19650] | 0);
	                k = (c[19652] | 0) + 1 | 0;
	                c[19652] = k;
	                c[(c[l >> 2] | 0) + 8 >> 2] = k;
	                c[19654] = (c[19654] | 0) + (c[h >> 2] | 0);
	                c[19656] = (c[19656] | 0) + 1;
	                if ((c[19654] | 0) >>> 0 > (c[19658] | 0) >>> 0)c[19658] = c[19654];
	                sx(c[19650] | 0);
	                if ((c[19636] | 0) == (c[(c[l >> 2] | 0) + 8 >> 2] | 0))jl();
	                c[m >> 2] = (c[l >> 2] | 0) + 24;
	                if ((c[19660] | 0) == (c[m >> 2] | 0)) {
	                    l = c[33976] | 0;
	                    k = c[33980] | 0;
	                    j = c[h >> 2] | 0;
	                    c[f >> 2] = c[19660];
	                    c[f + 4 >> 2] = j;
	                    Db[l & 511](k, 78648, f);
	                    jl()
	                }
	                c[g >> 2] = c[m >> 2];
	                n = c[g >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function ll() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0, g = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                d = a + 8 | 0;
	                e = a + 4 | 0;
	                if (c[19638] | 0) {
	                    c[d >> 2] = -1;
	                    f = c[d >> 2] | 0;
	                    i = a;
	                    return f | 0
	                }
	                c[19638] = 1;
	                c[19650] = px() | 0;
	                c[e >> 2] = cb(78864) | 0;
	                if (c[e >> 2] | 0) {
	                    g = c[e >> 2] | 0;
	                    c[b >> 2] = 78544;
	                    bT(g, 78888, b) | 0
	                }
	                c[e >> 2] = cb(78896) | 0;
	                if (c[e >> 2] | 0) {
	                    g = c[e >> 2] | 0;
	                    c[b >> 2] = 78640;
	                    bT(g, 78912, b) | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = a;
	                return f | 0
	            }

	            function ml() {
	                return
	            }

	            function nl(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = kl(c[d >> 2] | 0, 78672, 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function ol(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = kl(c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (!(c[19638] | 0))ll() | 0;
	                c[n >> 2] = (c[j >> 2] | 0) + -24;
	                c[p >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                if ((c[19636] | 0) == (c[p >> 2] | 0))jl();
	                e = c[n >> 2] | 0;
	                do if ((c[c[n >> 2] >> 2] | 0) != 23205)xl(e); else {
	                    c[e >> 2] = -23206;
	                    rx(c[19650] | 0);
	                    c[19654] = (c[19654] | 0) - (c[(c[n >> 2] | 0) + 12 >> 2] | 0);
	                    c[19656] = (c[19656] | 0) + -1;
	                    sx(c[19650] | 0);
	                    c[o >> 2] = kT(c[n >> 2] | 0, 24 + (c[k >> 2] | 0) | 0) | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        jT(c[n >> 2] | 0);
	                        break
	                    }
	                    c[n >> 2] = c[o >> 2];
	                    if ((c[19660] | 0) == (c[j >> 2] | 0)) {
	                        d = c[33976] | 0;
	                        b = c[33980] | 0;
	                        a = c[(c[n >> 2] | 0) + 12 >> 2] | 0;
	                        r = c[k >> 2] | 0;
	                        c[g >> 2] = c[19660];
	                        c[g + 4 >> 2] = a;
	                        c[g + 8 >> 2] = r;
	                        Db[d & 511](b, 78680, g);
	                        jl()
	                    }
	                    c[c[n >> 2] >> 2] = 23205;
	                    c[(c[n >> 2] | 0) + 8 >> 2] = c[p >> 2];
	                    c[(c[n >> 2] | 0) + 4 >> 2] = 2;
	                    c[(c[n >> 2] | 0) + 12 >> 2] = c[k >> 2];
	                    c[(c[n >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                    c[(c[n >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                    rx(c[19650] | 0);
	                    c[19654] = (c[19654] | 0) + (c[k >> 2] | 0);
	                    c[19656] = (c[19656] | 0) + 1;
	                    if ((c[19654] | 0) >>> 0 > (c[19658] | 0) >>> 0)c[19658] = c[19654];
	                    sx(c[19650] | 0);
	                    c[h >> 2] = (c[n >> 2] | 0) + 24;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } while (0);
	                c[h >> 2] = 0;
	                q = c[h >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function pl(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = ol(c[e >> 2] | 0, c[f >> 2] | 0, 78672, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function ql(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                do if ((c[e >> 2] | 0) == (-1 | 0))Db[c[135904 >> 2] & 511](c[33980] | 0, 78712, d); else {
	                    if ((c[19660] | 0) == (c[e >> 2] | 0)) {
	                        a = c[33976] | 0;
	                        h = c[33980] | 0;
	                        c[d >> 2] = c[19660];
	                        Db[a & 511](h, 78752, d);
	                        jl()
	                    }
	                    c[g >> 2] = c[e >> 2];
	                    c[f >> 2] = (c[e >> 2] | 0) + -24;
	                    if ((c[c[f >> 2] >> 2] | 0) != 23205) {
	                        xl(c[f >> 2] | 0);
	                        break
	                    }
	                    if ((c[19636] | 0) == (c[(c[f >> 2] | 0) + 8 >> 2] | 0))jl();
	                    c[c[f >> 2] >> 2] = -23206;
	                    cU(c[g >> 2] | 0, -1, c[(c[f >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    rx(c[19650] | 0);
	                    c[19654] = (c[19654] | 0) - (c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                    c[19656] = (c[19656] | 0) + -1;
	                    sx(c[19650] | 0);
	                    jT(c[f >> 2] | 0);
	                    i = b;
	                    return
	                } while (0);
	                f = c[33976] | 0;
	                g = c[33980] | 0;
	                c[d >> 2] = c[e >> 2];
	                Db[f & 511](g, 78768, d);
	                jl();
	                i = b;
	                return
	            }

	            function rl(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[m >> 2] = (ZT(c[h >> 2] | 0) | 0) + 1;
	                if (!(c[19638] | 0))ll() | 0;
	                c[n >> 2] = iT(24 + (c[m >> 2] | 0) | 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[c[n >> 2] >> 2] = 23205;
	                c[(c[n >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                c[(c[n >> 2] | 0) + 4 >> 2] = 3;
	                c[(c[n >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                c[(c[n >> 2] | 0) + 20 >> 2] = c[k >> 2];
	                rx(c[19650] | 0);
	                k = (c[19652] | 0) + 1 | 0;
	                c[19652] = k;
	                c[(c[n >> 2] | 0) + 8 >> 2] = k;
	                c[19654] = (c[19654] | 0) + (c[m >> 2] | 0);
	                c[19656] = (c[19656] | 0) + 1;
	                if ((c[19654] | 0) >>> 0 > (c[19658] | 0) >>> 0)c[19658] = c[19654];
	                sx(c[19650] | 0);
	                c[l >> 2] = (c[n >> 2] | 0) + 24;
	                if ((c[19636] | 0) == (c[(c[n >> 2] | 0) + 8 >> 2] | 0))jl();
	                gU(c[l >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[19660] | 0) == (c[l >> 2] | 0)) {
	                    h = c[33976] | 0;
	                    n = c[33980] | 0;
	                    c[f >> 2] = c[19660];
	                    Db[h & 511](n, 78792, f);
	                    jl()
	                }
	                c[g >> 2] = c[l >> 2];
	                o = c[g >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function sl(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = rl(c[d >> 2] | 0, 78672, 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function tl() {
	                return c[19654] | 0
	            }

	            function ul(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                c[f >> 2] = a;
	                c[d + 8 >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                f = c[19658] | 0;
	                c[e >> 2] = c[19654];
	                c[e + 4 >> 2] = f;
	                Ka(b | 0, 78816, e | 0) | 0;
	                i = d;
	                return
	            }

	            function vl() {
	                var a = 0;
	                a = i;
	                if (!(c[19638] | 0)) {
	                    i = a;
	                    return
	                }
	                qx(c[19650] | 0);
	                c[19650] = 0;
	                c[19638] = 0;
	                i = a;
	                return
	            }

	            function wl(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                do if (c[h >> 2] | 0) {
	                    if (!(c[j >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                    if (!(c[l >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        break
	                    } else {
	                        c[33934] = c[h >> 2];
	                        c[33936] = c[j >> 2];
	                        c[33938] = c[j >> 2];
	                        c[33940] = c[k >> 2];
	                        c[33942] = c[l >> 2];
	                        c[g >> 2] = 0;
	                        break
	                    }
	                } else c[g >> 2] = -1; while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function xl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                a = c[33976] | 0;
	                f = c[33980] | 0;
	                c[d >> 2] = c[e >> 2];
	                Db[a & 511](f, 78920, d);
	                i = b;
	                return
	            }

	            function yl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[f >> 2] = zl() | 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[g >> 2] = Ll(c[f >> 2] | 0, c[e >> 2] | 0) | 0, (c[g >> 2] | 0) != 0) : 0) {
	                    Al(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[d >> 2] = c[f >> 2];
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function zl() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0, g = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    Ml(78960);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    f = (c[d >> 2] | 0) + 0 | 0;
	                    g = f + 44 | 0;
	                    do {
	                        c[f >> 2] = 0;
	                        f = f + 4 | 0
	                    } while ((f | 0) < (g | 0));
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function Al(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Bl(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = Ll(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function Cl(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0;
	                e = i;
	                i = i + 112 | 0;
	                f = e;
	                g = e + 100 | 0;
	                h = e + 96 | 0;
	                j = e + 92 | 0;
	                k = e + 88 | 0;
	                l = e + 84 | 0;
	                m = e + 80 | 0;
	                n = e + 76 | 0;
	                o = e + 72 | 0;
	                p = e + 68 | 0;
	                q = e + 64 | 0;
	                r = e + 60 | 0;
	                s = e + 56 | 0;
	                t = e + 52 | 0;
	                u = e + 48 | 0;
	                v = e + 44 | 0;
	                w = e + 40 | 0;
	                x = e + 36 | 0;
	                y = e + 32 | 0;
	                z = e + 28 | 0;
	                A = e + 24 | 0;
	                B = e + 20 | 0;
	                C = e + 16 | 0;
	                D = e + 12 | 0;
	                E = e + 8 | 0;
	                F = e + 4 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    G = c[g >> 2] | 0;
	                    i = e;
	                    return G | 0
	                }
	                c[n >> 2] = 80;
	                c[j >> 2] = Cb[c[135752 >> 2] & 511]((c[n >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Ml(78984);
	                    c[g >> 2] = 0;
	                    G = c[g >> 2] | 0;
	                    i = e;
	                    return G | 0
	                }
	                c[m >> 2] = 0;
	                a:do if (c[c[h >> 2] >> 2] | 0) {
	                    c[l >> 2] = c[c[h >> 2] >> 2];
	                    while (1) {
	                        H = (c[m >> 2] | 0) >= (c[n >> 2] | 0);
	                        if (!(a[c[l >> 2] >> 0] | 0))break;
	                        if (H) {
	                            c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                            if (!(c[k >> 2] | 0))break a;
	                            c[j >> 2] = c[k >> 2]
	                        }
	                        b = c[l >> 2] | 0;
	                        c[l >> 2] = b + 1;
	                        I = a[b >> 0] | 0;
	                        b = c[m >> 2] | 0;
	                        c[m >> 2] = b + 1;
	                        a[(c[j >> 2] | 0) + b >> 0] = I
	                    }
	                    if (H) {
	                        c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                        if (!(c[k >> 2] | 0))break;
	                        c[j >> 2] = c[k >> 2]
	                    }
	                    I = c[m >> 2] | 0;
	                    c[m >> 2] = I + 1;
	                    a[(c[j >> 2] | 0) + I >> 0] = 58;
	                    J = 16
	                } else J = 16; while (0);
	                b:do if ((J | 0) == 16) {
	                    H = c[h >> 2] | 0;
	                    c:do if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        d:do if ((c[H + 12 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 20 >> 2] | 0) != -1 : 0) {
	                            if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0)) {
	                                if (!(c[c[h >> 2] >> 2] | 0))break;
	                                if (((c[m >> 2] | 0) + 3 | 0) < (c[n >> 2] | 0))break;
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2];
	                                break
	                            }
	                            if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                            I = c[m >> 2] | 0;
	                            c[m >> 2] = I + 1;
	                            a[(c[j >> 2] | 0) + I >> 0] = 47;
	                            I = c[m >> 2] | 0;
	                            c[m >> 2] = I + 1;
	                            a[(c[j >> 2] | 0) + I >> 0] = 47;
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                            e:while (1) {
	                                if (!(a[c[l >> 2] >> 0] | 0))break d;
	                                if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                    c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                    if (!(c[k >> 2] | 0))break b;
	                                    c[j >> 2] = c[k >> 2]
	                                }
	                                if (!((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0))J = 113;
	                                do if ((J | 0) == 113) {
	                                    J = 0;
	                                    if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) {
	                                        if ((a[c[l >> 2] >> 0] | 0) == 46)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 33)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 126)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 42)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 39)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 40)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 41)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 36)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 44)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 59)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 58)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 64)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 38)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 61)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 43)break;
	                                        I = c[l >> 2] | 0;
	                                        c[l >> 2] = I + 1;
	                                        c[u >> 2] = d[I >> 0];
	                                        c[v >> 2] = (c[u >> 2] | 0) / 16 | 0;
	                                        c[w >> 2] = (c[u >> 2] | 0) % 16 | 0;
	                                        I = c[m >> 2] | 0;
	                                        c[m >> 2] = I + 1;
	                                        a[(c[j >> 2] | 0) + I >> 0] = 37;
	                                        I = (c[v >> 2] | 0) + ((c[v >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                        b = c[m >> 2] | 0;
	                                        c[m >> 2] = b + 1;
	                                        a[(c[j >> 2] | 0) + b >> 0] = I;
	                                        I = (c[w >> 2] | 0) + ((c[w >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                        b = c[m >> 2] | 0;
	                                        c[m >> 2] = b + 1;
	                                        a[(c[j >> 2] | 0) + b >> 0] = I;
	                                        continue e
	                                    }
	                                } while (0);
	                                I = c[l >> 2] | 0;
	                                c[l >> 2] = I + 1;
	                                b = a[I >> 0] | 0;
	                                I = c[m >> 2] | 0;
	                                c[m >> 2] = I + 1;
	                                a[(c[j >> 2] | 0) + I >> 0] = b
	                            }
	                        } else J = 53; while (0);
	                        if ((J | 0) == 53) {
	                            if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                            b = c[m >> 2] | 0;
	                            c[m >> 2] = b + 1;
	                            a[(c[j >> 2] | 0) + b >> 0] = 47;
	                            b = c[m >> 2] | 0;
	                            c[m >> 2] = b + 1;
	                            a[(c[j >> 2] | 0) + b >> 0] = 47;
	                            if (c[(c[h >> 2] | 0) + 16 >> 2] | 0) {
	                                c[l >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                                f:while (1) {
	                                    K = ((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0);
	                                    if (!(a[c[l >> 2] >> 0] | 0))break;
	                                    if (K) {
	                                        c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                        if (!(c[k >> 2] | 0))break b;
	                                        c[j >> 2] = c[k >> 2]
	                                    }
	                                    if (!((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0))J = 64;
	                                    do if ((J | 0) == 64) {
	                                        J = 0;
	                                        if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) {
	                                            if ((a[c[l >> 2] >> 0] | 0) == 46)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 33)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 126)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 42)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 39)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 40)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 41)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 59)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 58)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 38)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 61)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 43)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 36)break;
	                                            if ((a[c[l >> 2] >> 0] | 0) == 44)break;
	                                            b = c[l >> 2] | 0;
	                                            c[l >> 2] = b + 1;
	                                            c[r >> 2] = d[b >> 0];
	                                            c[s >> 2] = (c[r >> 2] | 0) / 16 | 0;
	                                            c[t >> 2] = (c[r >> 2] | 0) % 16 | 0;
	                                            b = c[m >> 2] | 0;
	                                            c[m >> 2] = b + 1;
	                                            a[(c[j >> 2] | 0) + b >> 0] = 37;
	                                            b = (c[s >> 2] | 0) + ((c[s >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                            I = c[m >> 2] | 0;
	                                            c[m >> 2] = I + 1;
	                                            a[(c[j >> 2] | 0) + I >> 0] = b;
	                                            b = (c[t >> 2] | 0) + ((c[t >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                            I = c[m >> 2] | 0;
	                                            c[m >> 2] = I + 1;
	                                            a[(c[j >> 2] | 0) + I >> 0] = b;
	                                            continue f
	                                        }
	                                    } while (0);
	                                    b = c[l >> 2] | 0;
	                                    c[l >> 2] = b + 1;
	                                    I = a[b >> 0] | 0;
	                                    b = c[m >> 2] | 0;
	                                    c[m >> 2] = b + 1;
	                                    a[(c[j >> 2] | 0) + b >> 0] = I
	                                }
	                                if (K) {
	                                    c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                    if (!(c[k >> 2] | 0))break b;
	                                    c[j >> 2] = c[k >> 2]
	                                }
	                                I = c[m >> 2] | 0;
	                                c[m >> 2] = I + 1;
	                                a[(c[j >> 2] | 0) + I >> 0] = 64
	                            }
	                            if (c[(c[h >> 2] | 0) + 12 >> 2] | 0) {
	                                c[l >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                                while (1) {
	                                    if (!(a[c[l >> 2] >> 0] | 0))break;
	                                    if ((c[m >> 2] | 0) >= (c[n >> 2] | 0)) {
	                                        c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                        if (!(c[k >> 2] | 0))break b;
	                                        c[j >> 2] = c[k >> 2]
	                                    }
	                                    I = c[l >> 2] | 0;
	                                    c[l >> 2] = I + 1;
	                                    b = a[I >> 0] | 0;
	                                    I = c[m >> 2] | 0;
	                                    c[m >> 2] = I + 1;
	                                    a[(c[j >> 2] | 0) + I >> 0] = b
	                                }
	                                if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) > 0) {
	                                    if (((c[m >> 2] | 0) + 10 | 0) >= (c[n >> 2] | 0)) {
	                                        c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                        if (!(c[k >> 2] | 0))break b;
	                                        c[j >> 2] = c[k >> 2]
	                                    }
	                                    b = (c[j >> 2] | 0) + (c[m >> 2] | 0) | 0;
	                                    I = (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0;
	                                    c[f >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                                    L = JT(b, I, 79e3, f) | 0;
	                                    c[m >> 2] = (c[m >> 2] | 0) + L
	                                }
	                            }
	                        }
	                        g:do if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                            do if ((c[c[h >> 2] >> 2] | 0) != 0 ? (a[c[l >> 2] >> 0] | 0) == 47 : 0) {
	                                if (!((a[(c[l >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[l >> 2] | 0) + 1 >> 0] | 0) <= 122 : 0)) {
	                                    if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) < 65)break;
	                                    if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) > 90)break
	                                }
	                                if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) == 58 ? (qy(c[c[h >> 2] >> 2] | 0, 79008) | 0) != 0 : 0) {
	                                    if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                        c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                        if (!(c[k >> 2] | 0))break b;
	                                        c[j >> 2] = c[k >> 2]
	                                    }
	                                    L = c[l >> 2] | 0;
	                                    c[l >> 2] = L + 1;
	                                    I = a[L >> 0] | 0;
	                                    L = c[m >> 2] | 0;
	                                    c[m >> 2] = L + 1;
	                                    a[(c[j >> 2] | 0) + L >> 0] = I;
	                                    I = c[l >> 2] | 0;
	                                    c[l >> 2] = I + 1;
	                                    L = a[I >> 0] | 0;
	                                    I = c[m >> 2] | 0;
	                                    c[m >> 2] = I + 1;
	                                    a[(c[j >> 2] | 0) + I >> 0] = L;
	                                    L = c[l >> 2] | 0;
	                                    c[l >> 2] = L + 1;
	                                    I = a[L >> 0] | 0;
	                                    L = c[m >> 2] | 0;
	                                    c[m >> 2] = L + 1;
	                                    a[(c[j >> 2] | 0) + L >> 0] = I
	                                }
	                            } while (0);
	                            h:while (1) {
	                                if (!(a[c[l >> 2] >> 0] | 0))break g;
	                                if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                    c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                    if (!(c[k >> 2] | 0))break b;
	                                    c[j >> 2] = c[k >> 2]
	                                }
	                                if (!((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0))J = 159;
	                                do if ((J | 0) == 159) {
	                                    J = 0;
	                                    if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                                    if (((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) ? (a[c[l >> 2] >> 0] | 0) != 46 : 0) {
	                                        if ((a[c[l >> 2] >> 0] | 0) == 33)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 126)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 42)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 39)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 40)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 41)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 47)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 59)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 64)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 38)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 61)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 43)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 36)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 44)break;
	                                        I = c[l >> 2] | 0;
	                                        c[l >> 2] = I + 1;
	                                        c[x >> 2] = d[I >> 0];
	                                        c[y >> 2] = (c[x >> 2] | 0) / 16 | 0;
	                                        c[z >> 2] = (c[x >> 2] | 0) % 16 | 0;
	                                        I = c[m >> 2] | 0;
	                                        c[m >> 2] = I + 1;
	                                        a[(c[j >> 2] | 0) + I >> 0] = 37;
	                                        I = (c[y >> 2] | 0) + ((c[y >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                        L = c[m >> 2] | 0;
	                                        c[m >> 2] = L + 1;
	                                        a[(c[j >> 2] | 0) + L >> 0] = I;
	                                        I = (c[z >> 2] | 0) + ((c[z >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                        L = c[m >> 2] | 0;
	                                        c[m >> 2] = L + 1;
	                                        a[(c[j >> 2] | 0) + L >> 0] = I;
	                                        continue h
	                                    }
	                                } while (0);
	                                I = c[l >> 2] | 0;
	                                c[l >> 2] = I + 1;
	                                L = a[I >> 0] | 0;
	                                I = c[m >> 2] | 0;
	                                c[m >> 2] = I + 1;
	                                a[(c[j >> 2] | 0) + I >> 0] = L
	                            }
	                        } while (0);
	                        if (c[(c[h >> 2] | 0) + 40 >> 2] | 0) {
	                            if (((c[m >> 2] | 0) + 1 | 0) >= (c[n >> 2] | 0)) {
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                            L = c[m >> 2] | 0;
	                            c[m >> 2] = L + 1;
	                            a[(c[j >> 2] | 0) + L >> 0] = 63;
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 40 >> 2];
	                            while (1) {
	                                if (!(a[c[l >> 2] >> 0] | 0))break c;
	                                if (((c[m >> 2] | 0) + 1 | 0) >= (c[n >> 2] | 0)) {
	                                    c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                    if (!(c[k >> 2] | 0))break b;
	                                    c[j >> 2] = c[k >> 2]
	                                }
	                                L = c[l >> 2] | 0;
	                                c[l >> 2] = L + 1;
	                                I = a[L >> 0] | 0;
	                                L = c[m >> 2] | 0;
	                                c[m >> 2] = L + 1;
	                                a[(c[j >> 2] | 0) + L >> 0] = I
	                            }
	                        }
	                        if (c[(c[h >> 2] | 0) + 28 >> 2] | 0) {
	                            if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                            I = c[m >> 2] | 0;
	                            c[m >> 2] = I + 1;
	                            a[(c[j >> 2] | 0) + I >> 0] = 63;
	                            c[l >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                            i:while (1) {
	                                if (!(a[c[l >> 2] >> 0] | 0))break c;
	                                if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                    c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                    if (!(c[k >> 2] | 0))break b;
	                                    c[j >> 2] = c[k >> 2]
	                                }
	                                if (!((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0))J = 203;
	                                do if ((J | 0) == 203) {
	                                    J = 0;
	                                    if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) {
	                                        if ((a[c[l >> 2] >> 0] | 0) == 46)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 33)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 126)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 42)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 39)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 40)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 41)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 59)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 47)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 63)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 58)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 64)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 38)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 61)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 43)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 36)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 44)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 91)break;
	                                        if ((a[c[l >> 2] >> 0] | 0) == 93)break;
	                                        I = c[l >> 2] | 0;
	                                        c[l >> 2] = I + 1;
	                                        c[A >> 2] = d[I >> 0];
	                                        c[B >> 2] = (c[A >> 2] | 0) / 16 | 0;
	                                        c[C >> 2] = (c[A >> 2] | 0) % 16 | 0;
	                                        I = c[m >> 2] | 0;
	                                        c[m >> 2] = I + 1;
	                                        a[(c[j >> 2] | 0) + I >> 0] = 37;
	                                        I = (c[B >> 2] | 0) + ((c[B >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                        L = c[m >> 2] | 0;
	                                        c[m >> 2] = L + 1;
	                                        a[(c[j >> 2] | 0) + L >> 0] = I;
	                                        I = (c[C >> 2] | 0) + ((c[C >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                        L = c[m >> 2] | 0;
	                                        c[m >> 2] = L + 1;
	                                        a[(c[j >> 2] | 0) + L >> 0] = I;
	                                        continue i
	                                    }
	                                } while (0);
	                                I = c[l >> 2] | 0;
	                                c[l >> 2] = I + 1;
	                                L = a[I >> 0] | 0;
	                                I = c[m >> 2] | 0;
	                                c[m >> 2] = I + 1;
	                                a[(c[j >> 2] | 0) + I >> 0] = L
	                            }
	                        }
	                    } else {
	                        c[l >> 2] = c[H + 4 >> 2];
	                        j:while (1) {
	                            if (!(a[c[l >> 2] >> 0] | 0))break c;
	                            if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                            do if ((((((((((a[c[l >> 2] >> 0] | 0) != 59 ? (a[c[l >> 2] >> 0] | 0) != 47 : 0) ? (a[c[l >> 2] >> 0] | 0) != 63 : 0) ? (a[c[l >> 2] >> 0] | 0) != 58 : 0) ? (a[c[l >> 2] >> 0] | 0) != 64 : 0) ? (a[c[l >> 2] >> 0] | 0) != 38 : 0) ? (a[c[l >> 2] >> 0] | 0) != 61 : 0) ? (a[c[l >> 2] >> 0] | 0) != 43 : 0) ? (a[c[l >> 2] >> 0] | 0) != 36 : 0) ? (a[c[l >> 2] >> 0] | 0) != 44 : 0) {
	                                if ((a[c[l >> 2] >> 0] | 0) == 91)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 93)break;
	                                if ((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0)break;
	                                if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                                if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 45)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 95)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 46)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 33)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 126)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 42)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 39)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 40)break;
	                                if ((a[c[l >> 2] >> 0] | 0) == 41)break;
	                                L = c[l >> 2] | 0;
	                                c[l >> 2] = L + 1;
	                                c[o >> 2] = d[L >> 0];
	                                c[p >> 2] = (c[o >> 2] | 0) / 16 | 0;
	                                c[q >> 2] = (c[o >> 2] | 0) % 16 | 0;
	                                L = c[m >> 2] | 0;
	                                c[m >> 2] = L + 1;
	                                a[(c[j >> 2] | 0) + L >> 0] = 37;
	                                L = (c[p >> 2] | 0) + ((c[p >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                I = c[m >> 2] | 0;
	                                c[m >> 2] = I + 1;
	                                a[(c[j >> 2] | 0) + I >> 0] = L;
	                                L = (c[q >> 2] | 0) + ((c[q >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                I = c[m >> 2] | 0;
	                                c[m >> 2] = I + 1;
	                                a[(c[j >> 2] | 0) + I >> 0] = L;
	                                continue j
	                            } while (0);
	                            L = c[l >> 2] | 0;
	                            c[l >> 2] = L + 1;
	                            I = a[L >> 0] | 0;
	                            L = c[m >> 2] | 0;
	                            c[m >> 2] = L + 1;
	                            a[(c[j >> 2] | 0) + L >> 0] = I
	                        }
	                    } while (0);
	                    k:do if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                        if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                            c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                            if (!(c[k >> 2] | 0))break b;
	                            c[j >> 2] = c[k >> 2]
	                        }
	                        H = c[m >> 2] | 0;
	                        c[m >> 2] = H + 1;
	                        a[(c[j >> 2] | 0) + H >> 0] = 35;
	                        c[l >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                        l:while (1) {
	                            if (!(a[c[l >> 2] >> 0] | 0))break k;
	                            if (((c[m >> 2] | 0) + 3 | 0) >= (c[n >> 2] | 0)) {
	                                c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                                if (!(c[k >> 2] | 0))break b;
	                                c[j >> 2] = c[k >> 2]
	                            }
	                            if (!((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0))J = 241;
	                            do if ((J | 0) == 241) {
	                                J = 0;
	                                if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                                if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                                if (((((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) ? (a[c[l >> 2] >> 0] | 0) != 46 : 0) ? (a[c[l >> 2] >> 0] | 0) != 33 : 0) ? (a[c[l >> 2] >> 0] | 0) != 126 : 0) {
	                                    if ((a[c[l >> 2] >> 0] | 0) == 42)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 39)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 40)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 41)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 59)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 47)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 63)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 58)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 64)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 38)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 61)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 43)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 36)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 44)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 91)break;
	                                    if ((a[c[l >> 2] >> 0] | 0) == 93)break;
	                                    H = c[l >> 2] | 0;
	                                    c[l >> 2] = H + 1;
	                                    c[D >> 2] = d[H >> 0];
	                                    c[E >> 2] = (c[D >> 2] | 0) / 16 | 0;
	                                    c[F >> 2] = (c[D >> 2] | 0) % 16 | 0;
	                                    H = c[m >> 2] | 0;
	                                    c[m >> 2] = H + 1;
	                                    a[(c[j >> 2] | 0) + H >> 0] = 37;
	                                    H = (c[E >> 2] | 0) + ((c[E >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                    I = c[m >> 2] | 0;
	                                    c[m >> 2] = I + 1;
	                                    a[(c[j >> 2] | 0) + I >> 0] = H;
	                                    H = (c[F >> 2] | 0) + ((c[F >> 2] | 0) > 9 ? 55 : 48) & 255;
	                                    I = c[m >> 2] | 0;
	                                    c[m >> 2] = I + 1;
	                                    a[(c[j >> 2] | 0) + I >> 0] = H;
	                                    continue l
	                                }
	                            } while (0);
	                            H = c[l >> 2] | 0;
	                            c[l >> 2] = H + 1;
	                            I = a[H >> 0] | 0;
	                            H = c[m >> 2] | 0;
	                            c[m >> 2] = H + 1;
	                            a[(c[j >> 2] | 0) + H >> 0] = I
	                        }
	                    } while (0);
	                    if ((c[m >> 2] | 0) >= (c[n >> 2] | 0)) {
	                        c[k >> 2] = Nl(c[j >> 2] | 0, n) | 0;
	                        if (!(c[k >> 2] | 0))break;
	                        c[j >> 2] = c[k >> 2]
	                    }
	                    a[(c[j >> 2] | 0) + (c[m >> 2] | 0) >> 0] = 0;
	                    c[g >> 2] = c[j >> 2];
	                    G = c[g >> 2] | 0;
	                    i = e;
	                    return G | 0
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                c[g >> 2] = 0;
	                G = c[g >> 2] | 0;
	                i = e;
	                return G | 0
	            }

	            function Dl(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[g >> 2] = c[f >> 2];
	                while (1) {
	                    m = c[g >> 2] | 0;
	                    if ((a[c[g >> 2] >> 0] | 0) != 47)break;
	                    c[g >> 2] = m + 1
	                }
	                if (!(a[m >> 0] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = c[g >> 2];
	                a:while (1) {
	                    if (!(a[c[g >> 2] >> 0] | 0))break;
	                    if ((a[c[g >> 2] >> 0] | 0) == 46 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 47 : 0) {
	                        c[g >> 2] = (c[g >> 2] | 0) + 2;
	                        while (1) {
	                            if ((a[c[g >> 2] >> 0] | 0) != 47)continue a;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                    }
	                    if ((a[c[g >> 2] >> 0] | 0) == 46 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 0 : 0)break;
	                    while (1) {
	                        if ((a[c[g >> 2] >> 0] | 0) == 47)break;
	                        if (!(a[c[g >> 2] >> 0] | 0))break a;
	                        m = c[g >> 2] | 0;
	                        c[g >> 2] = m + 1;
	                        b = a[m >> 0] | 0;
	                        m = c[h >> 2] | 0;
	                        c[h >> 2] = m + 1;
	                        a[m >> 0] = b
	                    }
	                    do {
	                        if ((a[c[g >> 2] >> 0] | 0) == 47)n = (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 47; else n = 0;
	                        o = c[g >> 2] | 0;
	                        c[g >> 2] = o + 1
	                    } while (n);
	                    b = a[o >> 0] | 0;
	                    m = c[h >> 2] | 0;
	                    c[h >> 2] = m + 1;
	                    a[m >> 0] = b
	                }
	                a[c[h >> 2] >> 0] = 0;
	                c[g >> 2] = c[f >> 2];
	                while (1) {
	                    p = c[g >> 2] | 0;
	                    if ((a[c[g >> 2] >> 0] | 0) != 47)break;
	                    c[g >> 2] = p + 1
	                }
	                if (!(a[p >> 0] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                b:while (1) {
	                    c[j >> 2] = c[g >> 2];
	                    while (1) {
	                        if ((a[c[j >> 2] >> 0] | 0) != 47)q = (a[c[j >> 2] >> 0] | 0) != 0; else q = 0;
	                        r = c[j >> 2] | 0;
	                        if (!q)break;
	                        c[j >> 2] = r + 1
	                    }
	                    if (!(a[r >> 0] | 0))break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    if (!(((a[c[g >> 2] >> 0] | 0) == 46 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 46 : 0) ? (c[j >> 2] | 0) == ((c[g >> 2] | 0) + 3 | 0) : 0))s = 38;
	                    do if (((s | 0) == 38 ? (s = 0, (a[c[j >> 2] >> 0] | 0) == 46) : 0) ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) == 46 : 0) {
	                        if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) != 47 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) != 0 : 0)break;
	                        t = c[g >> 2] | 0;
	                        if (!(a[(c[j >> 2] | 0) + 2 >> 0] | 0)) {
	                            s = 44;
	                            break b
	                        }
	                        c[k >> 2] = t;
	                        c[j >> 2] = (c[j >> 2] | 0) + 3;
	                        do {
	                            p = c[j >> 2] | 0;
	                            c[j >> 2] = p + 1;
	                            o = a[p >> 0] | 0;
	                            p = c[k >> 2] | 0;
	                            c[k >> 2] = p + 1;
	                            a[p >> 0] = o
	                        } while ((o << 24 >> 24 | 0) != 0);
	                        c[j >> 2] = c[g >> 2];
	                        do {
	                            if ((c[j >> 2] | 0) >>> 0 <= (c[f >> 2] | 0) >>> 0)break;
	                            o = (c[j >> 2] | 0) + -1 | 0;
	                            c[j >> 2] = o
	                        } while ((a[o >> 0] | 0) == 47);
	                        if ((c[j >> 2] | 0) == (c[f >> 2] | 0))continue b;
	                        c[g >> 2] = c[j >> 2];
	                        while (1) {
	                            if ((c[g >> 2] | 0) >>> 0 <= (c[f >> 2] | 0) >>> 0)continue b;
	                            if ((a[(c[g >> 2] | 0) + -1 >> 0] | 0) == 47)continue b;
	                            c[g >> 2] = (c[g >> 2] | 0) + -1
	                        }
	                    } while (0);
	                    c[g >> 2] = c[j >> 2]
	                }
	                if ((s | 0) == 44)a[t >> 0] = 0;
	                a[c[h >> 2] >> 0] = 0;
	                if ((a[c[f >> 2] >> 0] | 0) == 47) {
	                    c[g >> 2] = c[f >> 2];
	                    while (1) {
	                        if (((a[c[g >> 2] >> 0] | 0) == 47 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 46 : 0) ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) == 46 : 0)if ((a[(c[g >> 2] | 0) + 3 >> 0] | 0) == 47)u = 1; else u = (a[(c[g >> 2] | 0) + 3 >> 0] | 0) == 0; else u = 0;
	                        v = c[g >> 2] | 0;
	                        if (!u)break;
	                        c[g >> 2] = v + 3
	                    }
	                    if ((v | 0) != (c[f >> 2] | 0)) {
	                        c[h >> 2] = c[f >> 2];
	                        while (1) {
	                            if (!(a[c[g >> 2] >> 0] | 0))break;
	                            f = c[g >> 2] | 0;
	                            c[g >> 2] = f + 1;
	                            v = a[f >> 0] | 0;
	                            f = c[h >> 2] | 0;
	                            c[h >> 2] = f + 1;
	                            a[f >> 0] = v
	                        }
	                        a[c[h >> 2] >> 0] = 0
	                    }
	                }
	                c[e >> 2] = 0;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function El(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if ((c[j >> 2] | 0) <= 0)c[j >> 2] = ZT(c[h >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) < 0) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[l >> 2] = Cb[c[135752 >> 2] & 511]((c[j >> 2] | 0) + 1 | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        Ml(79016);
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                } else c[l >> 2] = c[k >> 2];
	                c[n >> 2] = c[h >> 2];
	                c[m >> 2] = c[l >> 2];
	                while (1) {
	                    if ((c[j >> 2] | 0) <= 0)break;
	                    if ((((c[j >> 2] | 0) > 2 ? (a[c[n >> 2] >> 0] | 0) == 37 : 0) ? (Ol(a[(c[n >> 2] | 0) + 1 >> 0] | 0) | 0) != 0 : 0) ? (Ol(a[(c[n >> 2] | 0) + 2 >> 0] | 0) | 0) != 0 : 0) {
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        if ((a[c[n >> 2] >> 0] | 0) >= 48 ? (a[c[n >> 2] >> 0] | 0) <= 57 : 0)a[c[m >> 2] >> 0] = (a[c[n >> 2] >> 0] | 0) - 48; else p = 20;
	                        do if ((p | 0) == 20) {
	                            p = 0;
	                            if ((a[c[n >> 2] >> 0] | 0) >= 97 ? (a[c[n >> 2] >> 0] | 0) <= 102 : 0) {
	                                a[c[m >> 2] >> 0] = (a[c[n >> 2] >> 0] | 0) - 97 + 10;
	                                break
	                            }
	                            if ((a[c[n >> 2] >> 0] | 0) >= 65 ? (a[c[n >> 2] >> 0] | 0) <= 70 : 0)a[c[m >> 2] >> 0] = (a[c[n >> 2] >> 0] | 0) - 65 + 10
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        if ((a[c[n >> 2] >> 0] | 0) >= 48 ? (a[c[n >> 2] >> 0] | 0) <= 57 : 0)a[c[m >> 2] >> 0] = (a[c[m >> 2] >> 0] << 4) + ((a[c[n >> 2] >> 0] | 0) - 48); else p = 29;
	                        do if ((p | 0) == 29) {
	                            p = 0;
	                            if ((a[c[n >> 2] >> 0] | 0) >= 97 ? (a[c[n >> 2] >> 0] | 0) <= 102 : 0) {
	                                a[c[m >> 2] >> 0] = (a[c[m >> 2] >> 0] << 4) + ((a[c[n >> 2] >> 0] | 0) - 97) + 10;
	                                break
	                            }
	                            if ((a[c[n >> 2] >> 0] | 0) >= 65 ? (a[c[n >> 2] >> 0] | 0) <= 70 : 0)a[c[m >> 2] >> 0] = (a[c[m >> 2] >> 0] << 4) + ((a[c[n >> 2] >> 0] | 0) - 65) + 10
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[j >> 2] = (c[j >> 2] | 0) - 3;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        continue
	                    }
	                    h = c[n >> 2] | 0;
	                    c[n >> 2] = h + 1;
	                    k = a[h >> 0] | 0;
	                    h = c[m >> 2] | 0;
	                    c[m >> 2] = h + 1;
	                    a[h >> 0] = k;
	                    c[j >> 2] = (c[j >> 2] | 0) + -1
	                }
	                a[c[m >> 2] >> 0] = 0;
	                c[g >> 2] = c[l >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Fl(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 33 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                q = f + 32 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                e = c[h >> 2] | 0;
	                if (!(d[c[h >> 2] >> 0] | 0)) {
	                    c[g >> 2] = my(e) | 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                c[o >> 2] = xy(e) | 0;
	                if ((c[o >> 2] | 0) <= 0) {
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                c[o >> 2] = (c[o >> 2] | 0) + 20;
	                c[k >> 2] = Cb[c[135752 >> 2] & 511](c[o >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ml(79040);
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                c[n >> 2] = c[h >> 2];
	                c[p >> 2] = 0;
	                a:while (1) {
	                    if (!(d[c[n >> 2] >> 0] | 0)) {
	                        s = 40;
	                        break
	                    }
	                    if (((c[o >> 2] | 0) - (c[p >> 2] | 0) | 0) <= 3) {
	                        c[m >> 2] = Nl(c[k >> 2] | 0, o) | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            s = 13;
	                            break
	                        }
	                        c[k >> 2] = c[m >> 2]
	                    }
	                    a[l >> 0] = a[c[n >> 2] >> 0] | 0;
	                    do if ((d[l >> 0] | 0 | 0) != 64) {
	                        if ((d[l >> 0] | 0 | 0) >= 97 ? (d[l >> 0] | 0 | 0) <= 122 : 0)break;
	                        if ((d[l >> 0] | 0 | 0) >= 65 ? (d[l >> 0] | 0 | 0) <= 90 : 0)break;
	                        if ((d[l >> 0] | 0 | 0) >= 48 ? (d[l >> 0] | 0 | 0) <= 57 : 0)break;
	                        if ((((((((d[l >> 0] | 0 | 0) != 45 ? (d[l >> 0] | 0 | 0) != 95 : 0) ? (d[l >> 0] | 0 | 0) != 46 : 0) ? (d[l >> 0] | 0 | 0) != 33 : 0) ? (d[l >> 0] | 0 | 0) != 126 : 0) ? (d[l >> 0] | 0 | 0) != 42 : 0) ? (d[l >> 0] | 0 | 0) != 39 : 0) ? (d[l >> 0] | 0 | 0) != 40 : 0) {
	                            if ((d[l >> 0] | 0 | 0) == 41)break;
	                            if (vy(c[j >> 2] | 0, a[l >> 0] | 0) | 0)break;
	                            h = c[p >> 2] | 0;
	                            c[p >> 2] = h + 1;
	                            a[(c[k >> 2] | 0) + h >> 0] = 37;
	                            a[q >> 0] = (d[l >> 0] | 0) >> 4;
	                            h = d[q >> 0] | 0;
	                            if ((d[q >> 0] | 0 | 0) <= 9) {
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[(c[k >> 2] | 0) + e >> 0] = 48 + h
	                            } else {
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[(c[k >> 2] | 0) + e >> 0] = 65 + h - 10
	                            }
	                            a[q >> 0] = (d[l >> 0] | 0) & 15;
	                            h = d[q >> 0] | 0;
	                            if ((d[q >> 0] | 0 | 0) <= 9) {
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[(c[k >> 2] | 0) + e >> 0] = 48 + h
	                            } else {
	                                e = c[p >> 2] | 0;
	                                c[p >> 2] = e + 1;
	                                a[(c[k >> 2] | 0) + e >> 0] = 65 + h - 10
	                            }
	                            c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            continue a
	                        }
	                    } while (0);
	                    h = c[n >> 2] | 0;
	                    c[n >> 2] = h + 1;
	                    e = a[h >> 0] | 0;
	                    h = c[p >> 2] | 0;
	                    c[p >> 2] = h + 1;
	                    a[(c[k >> 2] | 0) + h >> 0] = e
	                }
	                if ((s | 0) == 13) {
	                    Ml(79040);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                } else if ((s | 0) == 40) {
	                    a[(c[k >> 2] | 0) + (c[p >> 2] | 0) >> 0] = 0;
	                    c[g >> 2] = c[k >> 2];
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                return 0
	            }

	            function Gl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b + 28 | 0;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                c[j >> 2] = zl() | 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] = 1, c[k >> 2] = Bl(c[j >> 2] | 0, c[f >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0) {
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                }
	                c[g >> 2] = 0;
	                do if (c[c[j >> 2] >> 2] | 0) {
	                    c[h >> 2] = Fl(c[c[j >> 2] >> 2] | 0, 79064) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, 79072) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        break
	                    }
	                    Ml(79040);
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } while (0);
	                do if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                    c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 79080) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[g >> 2] = By(c[g >> 2] | 0, 79088) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        break
	                    }
	                    Ml(79040);
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } while (0);
	                do if (c[(c[j >> 2] | 0) + 16 >> 2] | 0) {
	                    c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 16 >> 2] | 0, 79096) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[g >> 2] = By(c[g >> 2] | 0, 79088) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, 79104) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        break
	                    }
	                    Ml(79040);
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } while (0);
	                if (c[(c[j >> 2] | 0) + 12 >> 2] | 0) {
	                    c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 12 >> 2] | 0, 79080) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        Ml(79040);
	                        Al(c[j >> 2] | 0);
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = b;
	                        return m | 0
	                    }
	                    if (!(c[(c[j >> 2] | 0) + 16 >> 2] | 0))c[g >> 2] = By(c[g >> 2] | 0, 79088) | 0;
	                    c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0)
	                }
	                if (c[(c[j >> 2] | 0) + 20 >> 2] | 0) {
	                    c[d >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                    JT(l, 10, 79112, d) | 0;
	                    c[g >> 2] = By(c[g >> 2] | 0, 79072) | 0;
	                    c[g >> 2] = By(c[g >> 2] | 0, l) | 0
	                }
	                do if (c[(c[j >> 2] | 0) + 24 >> 2] | 0) {
	                    c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 24 >> 2] | 0, 79120) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        break
	                    }
	                    Ml(79040);
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } while (0);
	                do if (!(c[(c[j >> 2] | 0) + 40 >> 2] | 0)) {
	                    if (c[(c[j >> 2] | 0) + 28 >> 2] | 0) {
	                        c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 28 >> 2] | 0, 79144) | 0;
	                        if (c[h >> 2] | 0) {
	                            c[g >> 2] = By(c[g >> 2] | 0, 79136) | 0;
	                            c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                            break
	                        }
	                        Ml(79040);
	                        Al(c[j >> 2] | 0);
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = b;
	                        return m | 0
	                    }
	                } else {
	                    c[g >> 2] = By(c[g >> 2] | 0, 79136) | 0;
	                    c[g >> 2] = By(c[g >> 2] | 0, c[(c[j >> 2] | 0) + 40 >> 2] | 0) | 0
	                } while (0);
	                do if (c[(c[j >> 2] | 0) + 4 >> 2] | 0) {
	                    c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 4 >> 2] | 0, 79160) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        break
	                    }
	                    Ml(79040);
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } while (0);
	                do if (c[(c[j >> 2] | 0) + 32 >> 2] | 0) {
	                    c[h >> 2] = Fl(c[(c[j >> 2] | 0) + 32 >> 2] | 0, 79168) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[g >> 2] = By(c[g >> 2] | 0, 79168) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        break
	                    }
	                    Ml(79040);
	                    Al(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = b;
	                    return m | 0
	                } while (0);
	                Al(c[j >> 2] | 0);
	                c[e >> 2] = c[g >> 2];
	                m = c[e >> 2] | 0;
	                i = b;
	                return m | 0
	            }

	            function Hl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[f >> 2] = b;
	                c[g >> 2] = d;
	                c[h >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                do if (c[f >> 2] | 0) {
	                    if (!(a[c[f >> 2] >> 0] | 0)) {
	                        c[j >> 2] = 0;
	                        r = 7;
	                        break
	                    }
	                    c[o >> 2] = zl() | 0;
	                    if (c[o >> 2] | 0) {
	                        c[j >> 2] = Bl(c[o >> 2] | 0, c[f >> 2] | 0) | 0;
	                        r = 7
	                    }
	                } else {
	                    c[j >> 2] = -1;
	                    r = 7
	                } while (0);
	                a:do if ((r | 0) == 7 ? (c[j >> 2] | 0) == 0 : 0) {
	                    if ((c[o >> 2] | 0) != 0 ? (c[c[o >> 2] >> 2] | 0) != 0 : 0) {
	                        c[h >> 2] = my(c[f >> 2] | 0) | 0;
	                        break
	                    }
	                    if (!(c[g >> 2] | 0))c[j >> 2] = -1; else {
	                        c[p >> 2] = zl() | 0;
	                        if (!(c[p >> 2] | 0))break;
	                        c[j >> 2] = Bl(c[p >> 2] | 0, c[g >> 2] | 0) | 0
	                    }
	                    d = c[o >> 2] | 0;
	                    if (c[j >> 2] | 0) {
	                        if (!d)break;
	                        c[h >> 2] = Cl(c[o >> 2] | 0) | 0;
	                        break
	                    }
	                    if (!d) {
	                        if (c[(c[p >> 2] | 0) + 32 >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[(c[p >> 2] | 0) + 32 >> 2] | 0);
	                            c[(c[p >> 2] | 0) + 32 >> 2] = 0
	                        }
	                        c[h >> 2] = Cl(c[p >> 2] | 0) | 0;
	                        break
	                    }
	                    c[q >> 2] = zl() | 0;
	                    if (c[q >> 2] | 0) {
	                        if ((((c[c[o >> 2] >> 2] | 0) == 0 ? (c[(c[o >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) ? (c[(c[o >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                            if (c[c[p >> 2] >> 2] | 0) {
	                                d = Cb[c[135768 >> 2] & 511](c[c[p >> 2] >> 2] | 0) | 0;
	                                c[c[q >> 2] >> 2] = d
	                            }
	                            if (!(c[(c[p >> 2] | 0) + 8 >> 2] | 0)) {
	                                if (c[(c[p >> 2] | 0) + 12 >> 2] | 0) {
	                                    d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 12 >> 2] = d;
	                                    if (c[(c[p >> 2] | 0) + 16 >> 2] | 0) {
	                                        d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                        c[(c[q >> 2] | 0) + 16 >> 2] = d
	                                    }
	                                    c[(c[q >> 2] | 0) + 20 >> 2] = c[(c[p >> 2] | 0) + 20 >> 2]
	                                }
	                            } else {
	                                d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 8 >> 2] = d
	                            }
	                            if (c[(c[p >> 2] | 0) + 24 >> 2] | 0) {
	                                d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 24 >> 2] = d
	                            }
	                            do if (c[(c[o >> 2] | 0) + 40 >> 2] | 0) {
	                                d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 40 >> 2] = d
	                            } else {
	                                if (c[(c[o >> 2] | 0) + 28 >> 2] | 0) {
	                                    d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 28 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 28 >> 2] = d;
	                                    break
	                                }
	                                if (c[(c[p >> 2] | 0) + 40 >> 2] | 0) {
	                                    d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 40 >> 2] = d;
	                                    break
	                                }
	                                if (!(c[(c[p >> 2] | 0) + 28 >> 2] | 0))break;
	                                d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 28 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 28 >> 2] = d
	                            } while (0);
	                            if (c[(c[o >> 2] | 0) + 32 >> 2] | 0) {
	                                d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 32 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 32 >> 2] = d
	                            }
	                        } else r = 47;
	                        b:do if ((r | 0) == 47) {
	                            if (c[c[o >> 2] >> 2] | 0) {
	                                c[h >> 2] = Cl(c[o >> 2] | 0) | 0;
	                                break a
	                            }
	                            if (c[c[p >> 2] >> 2] | 0) {
	                                d = Cb[c[135768 >> 2] & 511](c[c[p >> 2] >> 2] | 0) | 0;
	                                c[c[q >> 2] >> 2] = d
	                            }
	                            if (!(c[(c[o >> 2] | 0) + 40 >> 2] | 0)) {
	                                if (c[(c[o >> 2] | 0) + 28 >> 2] | 0) {
	                                    d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 28 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 28 >> 2] = d
	                                }
	                            } else {
	                                d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 40 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 40 >> 2] = d
	                            }
	                            if (c[(c[o >> 2] | 0) + 32 >> 2] | 0) {
	                                d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 32 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 32 >> 2] = d
	                            }
	                            if ((c[(c[o >> 2] | 0) + 8 >> 2] | 0) == 0 ? (c[(c[o >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                                if (!(c[(c[p >> 2] | 0) + 8 >> 2] | 0)) {
	                                    if (c[(c[p >> 2] | 0) + 12 >> 2] | 0) {
	                                        d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                        c[(c[q >> 2] | 0) + 12 >> 2] = d;
	                                        if (c[(c[p >> 2] | 0) + 16 >> 2] | 0) {
	                                            d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                            c[(c[q >> 2] | 0) + 16 >> 2] = d
	                                        }
	                                        c[(c[q >> 2] | 0) + 20 >> 2] = c[(c[p >> 2] | 0) + 20 >> 2]
	                                    }
	                                } else {
	                                    d = Cb[c[135768 >> 2] & 511](c[(c[p >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 8 >> 2] = d
	                                }
	                                do if (c[(c[o >> 2] | 0) + 24 >> 2] | 0) {
	                                    if ((a[c[(c[o >> 2] | 0) + 24 >> 2] >> 0] | 0) != 47)break;
	                                    d = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 24 >> 2] = d;
	                                    break b
	                                } while (0);
	                                c[k >> 2] = 2;
	                                if (c[(c[o >> 2] | 0) + 24 >> 2] | 0) {
	                                    d = ZT(c[(c[o >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                    c[k >> 2] = (c[k >> 2] | 0) + d
	                                }
	                                if (c[(c[p >> 2] | 0) + 24 >> 2] | 0) {
	                                    d = ZT(c[(c[p >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                    c[k >> 2] = (c[k >> 2] | 0) + d
	                                }
	                                d = Cb[c[135752 >> 2] & 511](c[k >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 24 >> 2] = d;
	                                if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0)) {
	                                    Ml(79176);
	                                    break a
	                                }
	                                a[c[(c[q >> 2] | 0) + 24 >> 2] >> 0] = 0;
	                                c[m >> 2] = 0;
	                                c[n >> 2] = 0;
	                                c:do if (c[(c[p >> 2] | 0) + 24 >> 2] | 0)d:while (1) {
	                                    if (!(a[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0))break c;
	                                    while (1) {
	                                        if (a[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0)s = (a[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0) != 47; else s = 0;
	                                        t = c[m >> 2] | 0;
	                                        if (!s)break;
	                                        c[m >> 2] = t + 1
	                                    }
	                                    if (!(a[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + t >> 0] | 0))break c;
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                    while (1) {
	                                        if ((c[n >> 2] | 0) >= (c[m >> 2] | 0))continue d;
	                                        a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] = a[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0;
	                                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                                    }
	                                } while (0);
	                                a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] = 0;
	                                e:do if (c[(c[o >> 2] | 0) + 24 >> 2] | 0) {
	                                    if (!(a[c[(c[o >> 2] | 0) + 24 >> 2] >> 0] | 0))break;
	                                    c[l >> 2] = 0;
	                                    do if (!(c[n >> 2] | 0)) {
	                                        if (!(c[(c[p >> 2] | 0) + 12 >> 2] | 0))break;
	                                        d = c[n >> 2] | 0;
	                                        c[n >> 2] = d + 1;
	                                        a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + d >> 0] = 47
	                                    } while (0);
	                                    while (1) {
	                                        if (!(a[(c[(c[o >> 2] | 0) + 24 >> 2] | 0) + (c[l >> 2] | 0) >> 0] | 0))break e;
	                                        d = c[l >> 2] | 0;
	                                        c[l >> 2] = d + 1;
	                                        b = a[(c[(c[o >> 2] | 0) + 24 >> 2] | 0) + d >> 0] | 0;
	                                        d = c[n >> 2] | 0;
	                                        c[n >> 2] = d + 1;
	                                        a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + d >> 0] = b
	                                    }
	                                } while (0);
	                                a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] = 0;
	                                Dl(c[(c[q >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                break
	                            }
	                            b = c[33942] | 0;
	                            d = c[o >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 8 >> 2] | 0) {
	                                u = Cb[b & 511](c[d + 8 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 8 >> 2] = u
	                            } else {
	                                u = Cb[b & 511](c[d + 12 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 12 >> 2] = u;
	                                if (c[(c[o >> 2] | 0) + 16 >> 2] | 0) {
	                                    u = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                    c[(c[q >> 2] | 0) + 16 >> 2] = u
	                                }
	                                c[(c[q >> 2] | 0) + 20 >> 2] = c[(c[o >> 2] | 0) + 20 >> 2]
	                            }
	                            if (c[(c[o >> 2] | 0) + 24 >> 2] | 0) {
	                                u = Cb[c[135768 >> 2] & 511](c[(c[o >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                c[(c[q >> 2] | 0) + 24 >> 2] = u
	                            }
	                        } while (0);
	                        c[h >> 2] = Cl(c[q >> 2] | 0) | 0
	                    }
	                } while (0);
	                if (c[o >> 2] | 0)Al(c[o >> 2] | 0);
	                if (c[p >> 2] | 0)Al(c[p >> 2] | 0);
	                if (!(c[q >> 2] | 0)) {
	                    v = c[h >> 2] | 0;
	                    i = e;
	                    return v | 0
	                }
	                Al(c[q >> 2] | 0);
	                v = c[h >> 2] | 0;
	                i = e;
	                return v | 0
	            }

	            function Il(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 56 | 0;
	                h = f + 52 | 0;
	                j = f + 48 | 0;
	                k = f + 44 | 0;
	                l = f + 40 | 0;
	                m = f + 36 | 0;
	                n = f + 32 | 0;
	                o = f + 28 | 0;
	                p = f + 24 | 0;
	                q = f + 20 | 0;
	                r = f + 16 | 0;
	                s = f + 12 | 0;
	                t = f + 8 | 0;
	                u = f + 4 | 0;
	                v = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[v >> 2] = 0;
	                if ((c[h >> 2] | 0) != 0 ? (d[c[h >> 2] >> 0] | 0) != 0 : 0) {
	                    c[q >> 2] = zl() | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        w = c[g >> 2] | 0;
	                        i = f;
	                        return w | 0
	                    }
	                    if ((d[c[h >> 2] >> 0] | 0) != 46) {
	                        c[l >> 2] = Bl(c[q >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0))x = 9
	                    } else {
	                        e = my(c[h >> 2] | 0) | 0;
	                        c[(c[q >> 2] | 0) + 24 >> 2] = e;
	                        x = 9
	                    }
	                    a:do if ((x | 0) == 9) {
	                        if ((c[j >> 2] | 0) != 0 ? (d[c[j >> 2] >> 0] | 0) != 0 : 0) {
	                            c[r >> 2] = zl() | 0;
	                            if (!(c[r >> 2] | 0))break;
	                            if ((d[c[j >> 2] >> 0] | 0) != 46) {
	                                c[l >> 2] = Bl(c[r >> 2] | 0, c[j >> 2] | 0) | 0;
	                                if (c[l >> 2] | 0)break
	                            } else {
	                                e = my(c[j >> 2] | 0) | 0;
	                                c[(c[r >> 2] | 0) + 24 >> 2] = e
	                            }
	                            do if (c[c[q >> 2] >> 2] | 0) {
	                                if (((c[c[r >> 2] >> 2] | 0) != 0 ? (py(c[c[r >> 2] >> 2] | 0, c[c[q >> 2] >> 2] | 0) | 0) == 0 : 0) ? (py(c[(c[r >> 2] | 0) + 12 >> 2] | 0, c[(c[q >> 2] | 0) + 12 >> 2] | 0) | 0) == 0 : 0)break;
	                                c[k >> 2] = my(c[h >> 2] | 0) | 0;
	                                break a
	                            } while (0);
	                            if (qy(c[(c[r >> 2] | 0) + 24 >> 2] | 0, c[(c[q >> 2] | 0) + 24 >> 2] | 0) | 0) {
	                                c[k >> 2] = my(79160) | 0;
	                                break
	                            }
	                            e = c[(c[q >> 2] | 0) + 24 >> 2] | 0;
	                            if (!(c[(c[r >> 2] | 0) + 24 >> 2] | 0)) {
	                                c[k >> 2] = my(e) | 0;
	                                break
	                            }
	                            if (!e) {
	                                c[(c[q >> 2] | 0) + 24 >> 2] = 79208;
	                                c[v >> 2] = 1
	                            }
	                            if (!(c[(c[r >> 2] | 0) + 24 >> 2] | 0)) {
	                                if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0))break;
	                                c[t >> 2] = c[(c[q >> 2] | 0) + 24 >> 2];
	                                if ((d[c[t >> 2] >> 0] | 0) == 47)c[t >> 2] = (c[t >> 2] | 0) + 1;
	                                c[k >> 2] = Fl(c[t >> 2] | 0, 79216) | 0;
	                                break
	                            }
	                            c[s >> 2] = c[(c[r >> 2] | 0) + 24 >> 2];
	                            if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0)) {
	                                c[m >> 2] = 0;
	                                while (1) {
	                                    if (!(d[(c[s >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0))break;
	                                    if ((d[(c[s >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0) == 47)c[o >> 2] = (c[o >> 2] | 0) + 1;
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                }
	                                c[t >> 2] = 0;
	                                c[p >> 2] = 1
	                            } else {
	                                do if ((a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0) == 46) {
	                                    if ((a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + ((c[n >> 2] | 0) + 1) >> 0] | 0) != 47)break;
	                                    c[n >> 2] = (c[n >> 2] | 0) + 2
	                                } while (0);
	                                do if ((d[c[s >> 2] >> 0] | 0) == 46) {
	                                    if ((d[(c[s >> 2] | 0) + 1 >> 0] | 0) != 47) {
	                                        x = 45;
	                                        break
	                                    }
	                                    c[s >> 2] = (c[s >> 2] | 0) + 2
	                                } else x = 45; while (0);
	                                do if ((x | 0) == 45) {
	                                    if ((d[c[s >> 2] >> 0] | 0) != 47)break;
	                                    if ((a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0) == 47)break;
	                                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                                } while (0);
	                                while (1) {
	                                    if ((d[(c[s >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0) == (a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0))y = (d[(c[s >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0) != 0; else y = 0;
	                                    z = c[n >> 2] | 0;
	                                    if (!y)break;
	                                    c[n >> 2] = z + 1
	                                }
	                                if ((d[(c[s >> 2] | 0) + z >> 0] | 0) == (a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0)) {
	                                    c[k >> 2] = my(79160) | 0;
	                                    break
	                                }
	                                c[m >> 2] = c[n >> 2];
	                                e = c[m >> 2] | 0;
	                                do if ((c[m >> 2] | 0) > 0 ? (a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0) == 47 : 0)c[m >> 2] = e + -1; else {
	                                    if (!((c[m >> 2] | 0) > 1 ? (a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + e >> 0] | 0) == 0 : 0))break;
	                                    if ((a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + ((c[m >> 2] | 0) - 1) >> 0] | 0) != 47)break;
	                                    c[m >> 2] = (c[m >> 2] | 0) - 2
	                                } while (0);
	                                while (1) {
	                                    if ((c[m >> 2] | 0) <= 0)break;
	                                    if ((a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0) == 47)break;
	                                    c[m >> 2] = (c[m >> 2] | 0) + -1
	                                }
	                                if (!(c[m >> 2] | 0))c[t >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]; else {
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                                    c[t >> 2] = (c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[m >> 2] | 0)
	                                }
	                                b:do if ((d[(c[s >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0) != (a[(c[(c[q >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] | 0) >> 0] | 0))while (1) {
	                                    if (!(d[(c[s >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0))break b;
	                                    if ((d[(c[s >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0) == 47)c[o >> 2] = (c[o >> 2] | 0) + 1;
	                                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                                } while (0);
	                                c[p >> 2] = (xy(c[t >> 2] | 0) | 0) + 1
	                            }
	                            if (!(c[o >> 2] | 0)) {
	                                if (!(c[t >> 2] | 0))break;
	                                c[k >> 2] = Fl(c[t >> 2] | 0, 79216) | 0;
	                                break
	                            }
	                            c[k >> 2] = Cb[c[135744 >> 2] & 511]((c[p >> 2] | 0) + ((c[o >> 2] | 0) * 3 | 0) | 0) | 0;
	                            if (!(c[k >> 2] | 0)) {
	                                Ml(79224);
	                                break
	                            }
	                            c[u >> 2] = c[k >> 2];
	                            while (1) {
	                                if ((c[o >> 2] | 0) <= 0)break;
	                                e = c[u >> 2] | 0;
	                                c[u >> 2] = e + 1;
	                                a[e >> 0] = 46;
	                                e = c[u >> 2] | 0;
	                                c[u >> 2] = e + 1;
	                                a[e >> 0] = 46;
	                                e = c[u >> 2] | 0;
	                                c[u >> 2] = e + 1;
	                                a[e >> 0] = 47;
	                                c[o >> 2] = (c[o >> 2] | 0) + -1
	                            }
	                            c:do if (c[t >> 2] | 0) {
	                                do if ((c[p >> 2] | 0) > 0 ? (c[u >> 2] | 0) >>> 0 > (c[k >> 2] | 0) >>> 0 : 0) {
	                                    if ((d[c[t >> 2] >> 0] | 0) != 47)break;
	                                    if ((d[(c[u >> 2] | 0) + -1 >> 0] | 0) != 47)break;
	                                    eU(c[u >> 2] | 0, (c[t >> 2] | 0) + 1 | 0, (c[p >> 2] | 0) - 1 | 0) | 0;
	                                    a[(c[u >> 2] | 0) + ((c[p >> 2] | 0) - 2) >> 0] = 0;
	                                    break c
	                                } while (0);
	                                eU(c[u >> 2] | 0, c[t >> 2] | 0, c[p >> 2] | 0) | 0;
	                                a[(c[u >> 2] | 0) + ((c[p >> 2] | 0) - 1) >> 0] = 0
	                            } else a[(c[u >> 2] | 0) + ((c[p >> 2] | 0) - 1) >> 0] = 0; while (0);
	                            c[u >> 2] = c[k >> 2];
	                            c[k >> 2] = Fl(c[u >> 2] | 0, 79216) | 0;
	                            zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                            break
	                        }
	                        c[k >> 2] = my(c[h >> 2] | 0) | 0
	                    } while (0);
	                    if (c[v >> 2] | 0)c[(c[q >> 2] | 0) + 24 >> 2] = 0;
	                    if (c[q >> 2] | 0)Al(c[q >> 2] | 0);
	                    if (c[r >> 2] | 0)Al(c[r >> 2] | 0);
	                    c[g >> 2] = c[k >> 2];
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                c[g >> 2] = 0;
	                w = c[g >> 2] | 0;
	                i = f;
	                return w | 0
	            }

	            function Jl(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e + 32 | 0;
	                o = e;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if (((d[c[g >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[g >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) ? (d[(c[g >> 2] | 0) + 2 >> 0] | 0 | 0) != 47 : 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                b = yl(c[g >> 2] | 0) | 0;
	                c[h >> 2] = b;
	                if (b) {
	                    Al(c[h >> 2] | 0);
	                    c[f >> 2] = my(c[g >> 2] | 0) | 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[k >> 2] = wy(c[g >> 2] | 0, 79248) | 0;
	                a:do if ((c[k >> 2] | 0) != 0 ? (c[l >> 2] = (c[k >> 2] | 0) - (c[g >> 2] | 0), !((c[l >> 2] | 0) <= 0 | (c[l >> 2] | 0) > 20)) : 0) {
	                    c[m >> 2] = 0;
	                    while (1) {
	                        if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                        a[n >> 0] = a[(c[g >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0;
	                        if (!((d[n >> 0] | 0 | 0) >= 97 ? (d[n >> 0] | 0 | 0) <= 122 : 0)) {
	                            if ((d[n >> 0] | 0 | 0) < 65)break a;
	                            if ((d[n >> 0] | 0 | 0) > 90)break a
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    c[o >> 2] = Fl(c[g >> 2] | 0, 79256) | 0;
	                    if ((c[o >> 2] | 0) != 0 ? (c[h >> 2] = yl(c[o >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                        Al(c[h >> 2] | 0);
	                        c[f >> 2] = c[o >> 2];
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                } while (0);
	                c[j >> 2] = my(c[g >> 2] | 0) | 0;
	                c[f >> 2] = c[j >> 2];
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function Kl(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 64 | 0;
	                d = b + 60 | 0;
	                e = b + 56 | 0;
	                f = b + 52 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                a = yl(c[e >> 2] | 0) | 0;
	                c[f >> 2] = a;
	                if (a) {
	                    Al(c[f >> 2] | 0);
	                    c[d >> 2] = my(c[e >> 2] | 0) | 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[j >> 2] = Jl(c[e >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                } else {
	                    e = g + 0 | 0;
	                    f = e + 44 | 0;
	                    do {
	                        c[e >> 2] = 0;
	                        e = e + 4 | 0
	                    } while ((e | 0) < (f | 0));
	                    c[g + 24 >> 2] = c[j >> 2];
	                    c[h >> 2] = Cl(g) | 0;
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    c[d >> 2] = c[h >> 2];
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                return 0
	            }

	            function Ll(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                Pl(c[f >> 2] | 0);
	                c[h >> 2] = Ql(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if ((c[h >> 2] | 0) != 0 ? (Pl(c[f >> 2] | 0), c[h >> 2] = Rl(c[f >> 2] | 0, c[g >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                    Pl(c[f >> 2] | 0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Ml(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                e = b + 4 | 0;
	                c[e >> 2] = a;
	                if (c[e >> 2] | 0) {
	                    a = c[e >> 2] | 0;
	                    c[d >> 2] = c[e >> 2];
	                    Xd(0, 0, 0, 0, 0, 30, 2, 3, 0, 0, a, 0, 0, 0, 0, 79320, d);
	                    i = b;
	                    return
	                } else {
	                    Xd(0, 0, 0, 0, 0, 30, 2, 3, 0, 0, 0, 0, 0, 0, 0, 79352, d);
	                    i = b;
	                    return
	                }
	            }

	            function Nl(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[c[g >> 2] >> 2] | 0) > 1048576) {
	                    Ml(79272);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[j >> 2] = c[c[g >> 2] >> 2] << 1;
	                c[h >> 2] = Hb[c[135760 >> 2] & 511](c[f >> 2] | 0, (c[j >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    Ml(78984);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else {
	                    c[c[g >> 2] >> 2] = c[j >> 2];
	                    c[e >> 2] = c[h >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function Ol(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 4 | 0;
	                a[f >> 0] = b;
	                if (!((a[f >> 0] | 0) >= 48 ? (a[f >> 0] | 0) <= 57 : 0))g = 3;
	                do if ((g | 0) == 3) {
	                    if ((a[f >> 0] | 0) >= 97 ? (a[f >> 0] | 0) <= 102 : 0)break;
	                    if ((a[f >> 0] | 0) >= 65 ? (a[f >> 0] | 0) <= 70 : 0)break;
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                c[e >> 2] = 1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function Pl(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                c[c[d >> 2] >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 12 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 16 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 24 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 32 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 4 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 8 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 28 >> 2] = 0;
	                if (c[(c[d >> 2] | 0) + 40 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                c[(c[d >> 2] | 0) + 40 >> 2] = 0;
	                i = b;
	                return
	            }

	            function Ql(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = Sl(c[g >> 2] | 0, h) | 0;
	                do if (!(c[j >> 2] | 0)) {
	                    if ((a[c[h >> 2] >> 0] | 0) != 58) {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[j >> 2] = Tl(c[g >> 2] | 0, h) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = c[j >> 2];
	                        break
	                    }
	                    if ((a[c[h >> 2] >> 0] | 0) == 63 ? (c[h >> 2] = (c[h >> 2] | 0) + 1, c[j >> 2] = Ul(c[g >> 2] | 0, h) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        c[f >> 2] = c[j >> 2];
	                        break
	                    }
	                    if ((a[c[h >> 2] >> 0] | 0) == 35 ? (c[h >> 2] = (c[h >> 2] | 0) + 1, c[j >> 2] = Vl(c[g >> 2] | 0, h) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        c[f >> 2] = c[j >> 2];
	                        break
	                    }
	                    if (a[c[h >> 2] >> 0] | 0) {
	                        Pl(c[g >> 2] | 0);
	                        c[f >> 2] = 1;
	                        break
	                    } else {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                } else c[f >> 2] = c[j >> 2]; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function Rl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((a[c[h >> 2] >> 0] | 0) == 47 ? (a[(c[h >> 2] | 0) + 1 >> 0] | 0) == 47 : 0) {
	                    c[h >> 2] = (c[h >> 2] | 0) + 2;
	                    c[j >> 2] = Wl(c[g >> 2] | 0, h) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = c[j >> 2];
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    c[j >> 2] = Xl(c[g >> 2] | 0, h) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = c[j >> 2];
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                } else l = 7;
	                a:do if ((l | 0) == 7) {
	                    if ((a[c[h >> 2] >> 0] | 0) == 47) {
	                        c[j >> 2] = Yl(c[g >> 2] | 0, h) | 0;
	                        if (!(c[j >> 2] | 0))break;
	                        c[f >> 2] = c[j >> 2];
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    if (!((a[c[h >> 2] >> 0] | 0) >= 97 ? (a[c[h >> 2] >> 0] | 0) <= 122 : 0))l = 12;
	                    b:do if ((l | 0) == 12) {
	                        if ((a[c[h >> 2] >> 0] | 0) >= 65 ? (a[c[h >> 2] >> 0] | 0) <= 90 : 0)break;
	                        if ((a[c[h >> 2] >> 0] | 0) >= 48 ? (a[c[h >> 2] >> 0] | 0) <= 57 : 0)break;
	                        if ((((a[c[h >> 2] >> 0] | 0) != 45 ? (a[c[h >> 2] >> 0] | 0) != 46 : 0) ? (a[c[h >> 2] >> 0] | 0) != 95 : 0) ? (a[c[h >> 2] >> 0] | 0) != 126 : 0) {
	                            c:do if ((a[c[h >> 2] >> 0] | 0) == 37) {
	                                if (!((a[(c[h >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[h >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))l = 23;
	                                do if ((l | 0) == 23) {
	                                    if ((a[(c[h >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[h >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                    if ((a[(c[h >> 2] | 0) + 1 >> 0] | 0) < 65)break c;
	                                    if ((a[(c[h >> 2] | 0) + 1 >> 0] | 0) > 70)break c
	                                } while (0);
	                                if ((a[(c[h >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[h >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break b;
	                                if ((a[(c[h >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[h >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0)break b;
	                                if ((a[(c[h >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[h >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0)break b
	                            } while (0);
	                            if ((((((((a[c[h >> 2] >> 0] | 0) != 33 ? (a[c[h >> 2] >> 0] | 0) != 36 : 0) ? (a[c[h >> 2] >> 0] | 0) != 38 : 0) ? (a[c[h >> 2] >> 0] | 0) != 40 : 0) ? (a[c[h >> 2] >> 0] | 0) != 41 : 0) ? (a[c[h >> 2] >> 0] | 0) != 42 : 0) ? (a[c[h >> 2] >> 0] | 0) != 43 : 0) ? (a[c[h >> 2] >> 0] | 0) != 44 : 0) {
	                                if ((a[c[h >> 2] >> 0] | 0) == 59)break;
	                                if ((a[c[h >> 2] >> 0] | 0) == 61)break;
	                                if ((a[c[h >> 2] >> 0] | 0) == 39)break;
	                                if ((a[c[h >> 2] >> 0] | 0) == 58)break;
	                                if ((a[c[h >> 2] >> 0] | 0) == 64)break;
	                                if (!(c[g >> 2] | 0))break a;
	                                if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 24 >> 2] = 0;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    c[j >> 2] = Zl(c[g >> 2] | 0, h) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[f >> 2] = c[j >> 2];
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                } while (0);
	                if ((a[c[h >> 2] >> 0] | 0) == 63 ? (c[h >> 2] = (c[h >> 2] | 0) + 1, c[j >> 2] = Ul(c[g >> 2] | 0, h) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((a[c[h >> 2] >> 0] | 0) == 35 ? (c[h >> 2] = (c[h >> 2] | 0) + 1, c[j >> 2] = Vl(c[g >> 2] | 0, h) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (a[c[h >> 2] >> 0] | 0) {
	                    Pl(c[g >> 2] | 0);
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function Sl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                if (!((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0))l = 5;
	                do if ((l | 0) == 5) {
	                    if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0)break;
	                    c[f >> 2] = 2;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } while (0);
	                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                a:while (1) {
	                    if (!((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0))l = 11;
	                    do if ((l | 0) == 11) {
	                        l = 0;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0)break;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0)break;
	                        if (((a[c[j >> 2] >> 0] | 0) != 43 ? (a[c[j >> 2] >> 0] | 0) != 45 : 0) ? (a[c[j >> 2] >> 0] | 0) != 46 : 0)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if (c[g >> 2] | 0) {
	                    if (c[c[g >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[g >> 2] >> 2] | 0);
	                    l = ly(c[c[h >> 2] >> 2] | 0, (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0) | 0;
	                    c[c[g >> 2] >> 2] = l
	                }
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Tl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                if ((a[c[j >> 2] >> 0] | 0) == 47 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) == 47 : 0) {
	                    c[j >> 2] = (c[j >> 2] | 0) + 2;
	                    c[k >> 2] = Wl(c[g >> 2] | 0, j) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[f >> 2] = c[k >> 2];
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))c[(c[g >> 2] | 0) + 20 >> 2] = -1;
	                    c[k >> 2] = Xl(c[g >> 2] | 0, j) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[f >> 2] = c[k >> 2];
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    } else {
	                        c[c[h >> 2] >> 2] = c[j >> 2];
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                }
	                a:do if ((a[c[j >> 2] >> 0] | 0) == 47) {
	                    c[k >> 2] = Yl(c[g >> 2] | 0, j) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[f >> 2] = c[k >> 2];
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } else {
	                    if (!((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0))m = 15;
	                    b:do if ((m | 0) == 15) {
	                        if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0)break;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0)break;
	                        if ((((a[c[j >> 2] >> 0] | 0) != 45 ? (a[c[j >> 2] >> 0] | 0) != 46 : 0) ? (a[c[j >> 2] >> 0] | 0) != 95 : 0) ? (a[c[j >> 2] >> 0] | 0) != 126 : 0) {
	                            c:do if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                                if (!((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))m = 26;
	                                do if ((m | 0) == 26) {
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) < 65)break c;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) > 70)break c
	                                } while (0);
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break b;
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0)break b;
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0)break b
	                            } while (0);
	                            if ((((((((a[c[j >> 2] >> 0] | 0) != 33 ? (a[c[j >> 2] >> 0] | 0) != 36 : 0) ? (a[c[j >> 2] >> 0] | 0) != 38 : 0) ? (a[c[j >> 2] >> 0] | 0) != 40 : 0) ? (a[c[j >> 2] >> 0] | 0) != 41 : 0) ? (a[c[j >> 2] >> 0] | 0) != 42 : 0) ? (a[c[j >> 2] >> 0] | 0) != 43 : 0) ? (a[c[j >> 2] >> 0] | 0) != 44 : 0) {
	                                if ((a[c[j >> 2] >> 0] | 0) == 59)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 61)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 39)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 58)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 64)break;
	                                if (!(c[g >> 2] | 0))break a;
	                                if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 24 >> 2] = 0;
	                                break a
	                            }
	                        }
	                    } while (0);
	                    c[k >> 2] = _l(c[g >> 2] | 0, j) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[f >> 2] = c[k >> 2];
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Ul(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                a:while (1) {
	                    if (!((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0))l = 6;
	                    b:do if ((l | 0) == 6) {
	                        l = 0;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0)break;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0)break;
	                        if ((((a[c[j >> 2] >> 0] | 0) != 45 ? (a[c[j >> 2] >> 0] | 0) != 46 : 0) ? (a[c[j >> 2] >> 0] | 0) != 95 : 0) ? (a[c[j >> 2] >> 0] | 0) != 126 : 0) {
	                            c:do if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                                if (!((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))l = 17;
	                                do if ((l | 0) == 17) {
	                                    l = 0;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) < 65)break c;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) > 70)break c
	                                } while (0);
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break b;
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0)break b;
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0)break b
	                            } while (0);
	                            if (((((((((a[c[j >> 2] >> 0] | 0) != 33 ? (a[c[j >> 2] >> 0] | 0) != 36 : 0) ? (a[c[j >> 2] >> 0] | 0) != 38 : 0) ? (a[c[j >> 2] >> 0] | 0) != 40 : 0) ? (a[c[j >> 2] >> 0] | 0) != 41 : 0) ? (a[c[j >> 2] >> 0] | 0) != 42 : 0) ? (a[c[j >> 2] >> 0] | 0) != 43 : 0) ? (a[c[j >> 2] >> 0] | 0) != 44 : 0) ? (a[c[j >> 2] >> 0] | 0) != 59 : 0) {
	                                if ((a[c[j >> 2] >> 0] | 0) == 61)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 39)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 58)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 64)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 47)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 63)break;
	                                if (!(c[g >> 2] | 0))break a;
	                                if (!(c[(c[g >> 2] | 0) + 36 >> 2] & 1))break a;
	                                if ((a[c[j >> 2] >> 0] | 0) == 123)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 125)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 124)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 92)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 94)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 91)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 93)break;
	                                if ((a[c[j >> 2] >> 0] | 0) != 96)break a
	                            }
	                        }
	                    } while (0);
	                    d = c[j >> 2] | 0;
	                    if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                        c[j >> 2] = d + 3;
	                        continue
	                    } else {
	                        c[j >> 2] = d + 1;
	                        continue
	                    }
	                }
	                if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 28 >> 2] | 0);
	                    l = c[c[h >> 2] >> 2] | 0;
	                    d = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 36 >> 2] & 2) {
	                        b = ly(l, d) | 0;
	                        c[(c[g >> 2] | 0) + 28 >> 2] = b
	                    } else {
	                        b = El(l, d, 0) | 0;
	                        c[(c[g >> 2] | 0) + 28 >> 2] = b
	                    }
	                    if (c[(c[g >> 2] | 0) + 40 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                    b = ly(c[c[h >> 2] >> 2] | 0, (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0) | 0;
	                    c[(c[g >> 2] | 0) + 40 >> 2] = b
	                }
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Vl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                a:while (1) {
	                    if (!((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0))l = 6;
	                    b:do if ((l | 0) == 6) {
	                        l = 0;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0)break;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0)break;
	                        if ((((a[c[j >> 2] >> 0] | 0) != 45 ? (a[c[j >> 2] >> 0] | 0) != 46 : 0) ? (a[c[j >> 2] >> 0] | 0) != 95 : 0) ? (a[c[j >> 2] >> 0] | 0) != 126 : 0) {
	                            c:do if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                                if (!((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))l = 17;
	                                do if ((l | 0) == 17) {
	                                    l = 0;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) < 65)break c;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) > 70)break c
	                                } while (0);
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break b;
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0)break b;
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0)break b
	                            } while (0);
	                            if (((((((((a[c[j >> 2] >> 0] | 0) != 33 ? (a[c[j >> 2] >> 0] | 0) != 36 : 0) ? (a[c[j >> 2] >> 0] | 0) != 38 : 0) ? (a[c[j >> 2] >> 0] | 0) != 40 : 0) ? (a[c[j >> 2] >> 0] | 0) != 41 : 0) ? (a[c[j >> 2] >> 0] | 0) != 42 : 0) ? (a[c[j >> 2] >> 0] | 0) != 43 : 0) ? (a[c[j >> 2] >> 0] | 0) != 44 : 0) ? (a[c[j >> 2] >> 0] | 0) != 59 : 0) {
	                                if ((a[c[j >> 2] >> 0] | 0) == 61)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 39)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 58)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 64)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 47)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 63)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 91)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 93)break;
	                                if (!(c[g >> 2] | 0))break a;
	                                if (!(c[(c[g >> 2] | 0) + 36 >> 2] & 1))break a;
	                                if ((a[c[j >> 2] >> 0] | 0) == 123)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 125)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 124)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 92)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 94)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 91)break;
	                                if ((a[c[j >> 2] >> 0] | 0) == 93)break;
	                                if ((a[c[j >> 2] >> 0] | 0) != 96)break a
	                            }
	                        }
	                    } while (0);
	                    d = c[j >> 2] | 0;
	                    if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                        c[j >> 2] = d + 3;
	                        continue
	                    } else {
	                        c[j >> 2] = d + 1;
	                        continue
	                    }
	                }
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 32 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 32 >> 2] | 0);
	                    l = c[c[h >> 2] >> 2] | 0;
	                    d = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 36 >> 2] & 2) {
	                        b = ly(l, d) | 0;
	                        c[(c[g >> 2] | 0) + 32 >> 2] = b;
	                        break
	                    } else {
	                        b = El(l, d, 0) | 0;
	                        c[(c[g >> 2] | 0) + 32 >> 2] = b;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function Wl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = $l(c[g >> 2] | 0, j) | 0;
	                if ((c[k >> 2] | 0) == 0 ? (a[c[j >> 2] >> 0] | 0) == 64 : 0)c[j >> 2] = (c[j >> 2] | 0) + 1; else c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = am(c[g >> 2] | 0, j) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((a[c[j >> 2] >> 0] | 0) == 58 ? (c[j >> 2] = (c[j >> 2] | 0) + 1, c[k >> 2] = bm(c[g >> 2] | 0, j) | 0, (c[k >> 2] | 0) != 0) : 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Xl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                while (1) {
	                    if ((a[c[j >> 2] >> 0] | 0) != 47)break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[k >> 2] = cm(j, 0, 1) | 0;
	                    if (c[k >> 2] | 0) {
	                        l = 4;
	                        break
	                    }
	                }
	                if ((l | 0) == 4) {
	                    c[f >> 2] = c[k >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                    k = c[g >> 2] | 0;
	                    if ((c[c[h >> 2] >> 2] | 0) == (c[j >> 2] | 0)) {
	                        c[k + 24 >> 2] = 0;
	                        break
	                    }
	                    l = c[c[h >> 2] >> 2] | 0;
	                    d = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[k + 36 >> 2] & 2) {
	                        k = ly(l, d) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    } else {
	                        k = El(l, d, 0) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function Yl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                if ((a[c[j >> 2] >> 0] | 0) != 47) {
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                c[k >> 2] = cm(j, 0, 0) | 0;
	                a:do if (!(c[k >> 2] | 0)) {
	                    do {
	                        if ((a[c[j >> 2] >> 0] | 0) != 47)break a;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        c[k >> 2] = cm(j, 0, 1) | 0
	                    } while ((c[k >> 2] | 0) == 0);
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } while (0);
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                    k = c[g >> 2] | 0;
	                    if ((c[j >> 2] | 0) == (c[c[h >> 2] >> 2] | 0)) {
	                        c[k + 24 >> 2] = 0;
	                        break
	                    }
	                    d = c[c[h >> 2] >> 2] | 0;
	                    b = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[k + 36 >> 2] & 2) {
	                        k = ly(d, b) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    } else {
	                        k = El(d, b, 0) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Zl(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = cm(j, 58, 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                while (1) {
	                    if ((a[c[j >> 2] >> 0] | 0) != 47)break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[k >> 2] = cm(j, 0, 1) | 0;
	                    if (c[k >> 2] | 0) {
	                        m = 5;
	                        break
	                    }
	                }
	                if ((m | 0) == 5) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                    k = c[g >> 2] | 0;
	                    if ((c[j >> 2] | 0) == (c[c[h >> 2] >> 2] | 0)) {
	                        c[k + 24 >> 2] = 0;
	                        break
	                    }
	                    m = c[c[h >> 2] >> 2] | 0;
	                    d = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[k + 36 >> 2] & 2) {
	                        k = ly(m, d) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    } else {
	                        k = El(m, d, 0) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function _l(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = cm(j, 0, 0) | 0;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                while (1) {
	                    if ((a[c[j >> 2] >> 0] | 0) != 47)break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[k >> 2] = cm(j, 0, 1) | 0;
	                    if (c[k >> 2] | 0) {
	                        m = 5;
	                        break
	                    }
	                }
	                if ((m | 0) == 5) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                    k = c[g >> 2] | 0;
	                    if ((c[j >> 2] | 0) == (c[c[h >> 2] >> 2] | 0)) {
	                        c[k + 24 >> 2] = 0;
	                        break
	                    }
	                    m = c[c[h >> 2] >> 2] | 0;
	                    d = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[k + 36 >> 2] & 2) {
	                        k = ly(m, d) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    } else {
	                        k = El(m, d, 0) | 0;
	                        c[(c[g >> 2] | 0) + 24 >> 2] = k;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function $l(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                while (1) {
	                    if ((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0)k = 1; else l = 4;
	                    a:do if ((l | 0) == 4) {
	                        l = 0;
	                        if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0) {
	                            k = 1;
	                            break
	                        }
	                        if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0) {
	                            k = 1;
	                            break
	                        }
	                        if ((((a[c[j >> 2] >> 0] | 0) != 45 ? (a[c[j >> 2] >> 0] | 0) != 46 : 0) ? (a[c[j >> 2] >> 0] | 0) != 95 : 0) ? (a[c[j >> 2] >> 0] | 0) != 126 : 0) {
	                            b:do if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                                if (!((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))l = 15;
	                                do if ((l | 0) == 15) {
	                                    l = 0;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) < 65)break b;
	                                    if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) > 70)break b
	                                } while (0);
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0) {
	                                    k = 1;
	                                    break a
	                                }
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0) {
	                                    k = 1;
	                                    break a
	                                }
	                                if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0) {
	                                    k = 1;
	                                    break a
	                                }
	                            } while (0);
	                            if ((((((((((a[c[j >> 2] >> 0] | 0) != 33 ? (a[c[j >> 2] >> 0] | 0) != 36 : 0) ? (a[c[j >> 2] >> 0] | 0) != 38 : 0) ? (a[c[j >> 2] >> 0] | 0) != 40 : 0) ? (a[c[j >> 2] >> 0] | 0) != 41 : 0) ? (a[c[j >> 2] >> 0] | 0) != 42 : 0) ? (a[c[j >> 2] >> 0] | 0) != 43 : 0) ? (a[c[j >> 2] >> 0] | 0) != 44 : 0) ? (a[c[j >> 2] >> 0] | 0) != 59 : 0) ? (a[c[j >> 2] >> 0] | 0) != 61 : 0) {
	                                if ((a[c[j >> 2] >> 0] | 0) == 39) {
	                                    k = 1;
	                                    break
	                                }
	                                k = (a[c[j >> 2] >> 0] | 0) == 58
	                            } else k = 1
	                        } else k = 1
	                    } while (0);
	                    m = a[c[j >> 2] >> 0] | 0;
	                    if (!k)break;
	                    d = c[j >> 2] | 0;
	                    if ((m | 0) == 37) {
	                        c[j >> 2] = d + 3;
	                        continue
	                    } else {
	                        c[j >> 2] = d + 1;
	                        continue
	                    }
	                }
	                if ((m | 0) != 64) {
	                    c[f >> 2] = 1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 16 >> 2] | 0);
	                    m = c[c[h >> 2] >> 2] | 0;
	                    k = (c[j >> 2] | 0) - (c[c[h >> 2] >> 2] | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 36 >> 2] & 2) {
	                        l = ly(m, k) | 0;
	                        c[(c[g >> 2] | 0) + 16 >> 2] = l;
	                        break
	                    } else {
	                        l = El(m, k, 0) | 0;
	                        c[(c[g >> 2] | 0) + 16 >> 2] = l;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function am(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = c[j >> 2];
	                d = c[j >> 2] | 0;
	                a:do if ((a[c[j >> 2] >> 0] | 0) == 91) {
	                    c[j >> 2] = d + 1;
	                    while (1) {
	                        if ((a[c[j >> 2] >> 0] | 0) != 93)l = (a[c[j >> 2] >> 0] | 0) != 0; else l = 0;
	                        m = c[j >> 2] | 0;
	                        if (!l)break;
	                        c[j >> 2] = m + 1
	                    }
	                    if ((a[m >> 0] | 0) == 93) {
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        break
	                    }
	                    c[f >> 2] = 1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else {
	                    if ((a[d >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0) {
	                        if (((((((dm(j) | 0) == 0 ? (a[c[j >> 2] >> 0] | 0) == 46 : 0) ? (c[j >> 2] = (c[j >> 2] | 0) + 1, (dm(j) | 0) == 0) : 0) ? (a[c[j >> 2] >> 0] | 0) == 46 : 0) ? (dm(j) | 0) == 0 : 0) ? (a[c[j >> 2] >> 0] | 0) == 46 : 0) ? (dm(j) | 0) == 0 : 0)break;
	                        c[j >> 2] = c[c[h >> 2] >> 2]
	                    }
	                    while (1) {
	                        if (!((a[c[j >> 2] >> 0] | 0) >= 97 ? (a[c[j >> 2] >> 0] | 0) <= 122 : 0))o = 22;
	                        b:do if ((o | 0) == 22) {
	                            o = 0;
	                            if ((a[c[j >> 2] >> 0] | 0) >= 65 ? (a[c[j >> 2] >> 0] | 0) <= 90 : 0)break;
	                            if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0)break;
	                            if ((((a[c[j >> 2] >> 0] | 0) != 45 ? (a[c[j >> 2] >> 0] | 0) != 46 : 0) ? (a[c[j >> 2] >> 0] | 0) != 95 : 0) ? (a[c[j >> 2] >> 0] | 0) != 126 : 0) {
	                                c:do if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                                    if (!((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))o = 33;
	                                    do if ((o | 0) == 33) {
	                                        o = 0;
	                                        if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                        if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) < 65)break c;
	                                        if ((a[(c[j >> 2] | 0) + 1 >> 0] | 0) > 70)break c
	                                    } while (0);
	                                    if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break b;
	                                    if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0)break b;
	                                    if ((a[(c[j >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[j >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0)break b
	                                } while (0);
	                                if (((((((a[c[j >> 2] >> 0] | 0) != 33 ? (a[c[j >> 2] >> 0] | 0) != 36 : 0) ? (a[c[j >> 2] >> 0] | 0) != 38 : 0) ? (a[c[j >> 2] >> 0] | 0) != 40 : 0) ? (a[c[j >> 2] >> 0] | 0) != 41 : 0) ? (a[c[j >> 2] >> 0] | 0) != 42 : 0) ? (a[c[j >> 2] >> 0] | 0) != 43 : 0) {
	                                    if ((a[c[j >> 2] >> 0] | 0) == 44)break;
	                                    if ((a[c[j >> 2] >> 0] | 0) == 59)break;
	                                    if ((a[c[j >> 2] >> 0] | 0) == 61)break;
	                                    if ((a[c[j >> 2] >> 0] | 0) != 39)break a
	                                }
	                            }
	                        } while (0);
	                        b = c[j >> 2] | 0;
	                        if ((a[c[j >> 2] >> 0] | 0) == 37) {
	                            c[j >> 2] = b + 3;
	                            continue
	                        } else {
	                            c[j >> 2] = b + 1;
	                            continue
	                        }
	                    }
	                } while (0);
	                do if (c[g >> 2] | 0) {
	                    if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 8 >> 2] = 0;
	                    if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                    o = c[g >> 2] | 0;
	                    if ((c[j >> 2] | 0) == (c[k >> 2] | 0)) {
	                        c[o + 12 >> 2] = 0;
	                        break
	                    }
	                    d = c[k >> 2] | 0;
	                    m = (c[j >> 2] | 0) - (c[k >> 2] | 0) | 0;
	                    if (c[o + 36 >> 2] & 2) {
	                        o = ly(d, m) | 0;
	                        c[(c[g >> 2] | 0) + 12 >> 2] = o;
	                        break
	                    } else {
	                        o = El(d, m, 0) | 0;
	                        c[(c[g >> 2] | 0) + 12 >> 2] = o;
	                        break
	                    }
	                } while (0);
	                c[c[h >> 2] >> 2] = c[j >> 2];
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function bm(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                if ((a[c[j >> 2] >> 0] | 0) >= 48 ? (a[c[j >> 2] >> 0] | 0) <= 57 : 0) {
	                    if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 20 >> 2] = 0;
	                    while (1) {
	                        if ((a[c[j >> 2] >> 0] | 0) < 48)break;
	                        if ((a[c[j >> 2] >> 0] | 0) > 57)break;
	                        if (c[g >> 2] | 0)c[(c[g >> 2] | 0) + 20 >> 2] = ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) * 10 | 0) + ((a[c[j >> 2] >> 0] | 0) - 48);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    c[c[h >> 2] >> 2] = c[j >> 2];
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[f >> 2] = 1;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function cm(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 16 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = b;
	                a[j >> 0] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[c[h >> 2] >> 2];
	                if (!((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0))m = 3;
	                a:do if ((m | 0) == 3) {
	                    if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0)break;
	                    if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0)break;
	                    if ((((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 46 : 0) ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) ? (a[c[l >> 2] >> 0] | 0) != 126 : 0) {
	                        b:do if ((a[c[l >> 2] >> 0] | 0) == 37) {
	                            if (!((a[(c[l >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[l >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))m = 14;
	                            do if ((m | 0) == 14) {
	                                if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[l >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) < 65)break b;
	                                if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) > 70)break b
	                            } while (0);
	                            if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[l >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break a;
	                            if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[l >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0)break a;
	                            if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[l >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0)break a
	                        } while (0);
	                        if (((((((((((a[c[l >> 2] >> 0] | 0) != 33 ? (a[c[l >> 2] >> 0] | 0) != 36 : 0) ? (a[c[l >> 2] >> 0] | 0) != 38 : 0) ? (a[c[l >> 2] >> 0] | 0) != 40 : 0) ? (a[c[l >> 2] >> 0] | 0) != 41 : 0) ? (a[c[l >> 2] >> 0] | 0) != 42 : 0) ? (a[c[l >> 2] >> 0] | 0) != 43 : 0) ? (a[c[l >> 2] >> 0] | 0) != 44 : 0) ? (a[c[l >> 2] >> 0] | 0) != 59 : 0) ? (a[c[l >> 2] >> 0] | 0) != 61 : 0) ? (a[c[l >> 2] >> 0] | 0) != 39 : 0) {
	                            if ((a[c[l >> 2] >> 0] | 0) == 58)break;
	                            if ((a[c[l >> 2] >> 0] | 0) == 64)break;
	                            if (c[k >> 2] | 0) {
	                                c[g >> 2] = 0;
	                                n = c[g >> 2] | 0;
	                                i = f;
	                                return n | 0
	                            } else {
	                                c[g >> 2] = 1;
	                                n = c[g >> 2] | 0;
	                                i = f;
	                                return n | 0
	                            }
	                        }
	                    }
	                } while (0);
	                while (1) {
	                    if ((a[c[l >> 2] >> 0] | 0) >= 97 ? (a[c[l >> 2] >> 0] | 0) <= 122 : 0)m = 76; else m = 42;
	                    c:do if ((m | 0) == 42) {
	                        m = 0;
	                        if ((a[c[l >> 2] >> 0] | 0) >= 65 ? (a[c[l >> 2] >> 0] | 0) <= 90 : 0) {
	                            m = 76;
	                            break
	                        }
	                        if ((a[c[l >> 2] >> 0] | 0) >= 48 ? (a[c[l >> 2] >> 0] | 0) <= 57 : 0) {
	                            m = 76;
	                            break
	                        }
	                        if ((((a[c[l >> 2] >> 0] | 0) != 45 ? (a[c[l >> 2] >> 0] | 0) != 46 : 0) ? (a[c[l >> 2] >> 0] | 0) != 95 : 0) ? (a[c[l >> 2] >> 0] | 0) != 126 : 0) {
	                            d:do if ((a[c[l >> 2] >> 0] | 0) == 37) {
	                                if (!((a[(c[l >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[l >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0))m = 53;
	                                do if ((m | 0) == 53) {
	                                    m = 0;
	                                    if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) >= 97 ? (a[(c[l >> 2] | 0) + 1 >> 0] | 0) <= 102 : 0)break;
	                                    if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) < 65)break d;
	                                    if ((a[(c[l >> 2] | 0) + 1 >> 0] | 0) > 70)break d
	                                } while (0);
	                                if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[l >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0) {
	                                    m = 76;
	                                    break c
	                                }
	                                if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) >= 97 ? (a[(c[l >> 2] | 0) + 2 >> 0] | 0) <= 102 : 0) {
	                                    m = 76;
	                                    break c
	                                }
	                                if ((a[(c[l >> 2] | 0) + 2 >> 0] | 0) >= 65 ? (a[(c[l >> 2] | 0) + 2 >> 0] | 0) <= 70 : 0) {
	                                    m = 76;
	                                    break c
	                                }
	                            } while (0);
	                            if (((((((((a[c[l >> 2] >> 0] | 0) != 33 ? (a[c[l >> 2] >> 0] | 0) != 36 : 0) ? (a[c[l >> 2] >> 0] | 0) != 38 : 0) ? (a[c[l >> 2] >> 0] | 0) != 40 : 0) ? (a[c[l >> 2] >> 0] | 0) != 41 : 0) ? (a[c[l >> 2] >> 0] | 0) != 42 : 0) ? (a[c[l >> 2] >> 0] | 0) != 43 : 0) ? (a[c[l >> 2] >> 0] | 0) != 44 : 0) ? (a[c[l >> 2] >> 0] | 0) != 59 : 0) {
	                                if ((a[c[l >> 2] >> 0] | 0) == 61) {
	                                    m = 76;
	                                    break
	                                }
	                                if ((a[c[l >> 2] >> 0] | 0) == 39) {
	                                    m = 76;
	                                    break
	                                }
	                                if ((a[c[l >> 2] >> 0] | 0) == 58) {
	                                    m = 76;
	                                    break
	                                }
	                                if ((a[c[l >> 2] >> 0] | 0) != 64)o = 0; else m = 76
	                            } else m = 76
	                        } else m = 76
	                    } while (0);
	                    if ((m | 0) == 76) {
	                        m = 0;
	                        o = (a[c[l >> 2] >> 0] | 0) != (a[j >> 0] | 0)
	                    }
	                    p = c[l >> 2] | 0;
	                    if (!o)break;
	                    k = c[l >> 2] | 0;
	                    if ((a[p >> 0] | 0) == 37) {
	                        c[l >> 2] = k + 3;
	                        continue
	                    } else {
	                        c[l >> 2] = k + 1;
	                        continue
	                    }
	                }
	                c[c[h >> 2] >> 2] = p;
	                c[g >> 2] = 0;
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function dm(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = b;
	                c[g >> 2] = c[c[f >> 2] >> 2];
	                if ((a[c[g >> 2] >> 0] | 0) >= 48 ? (a[c[g >> 2] >> 0] | 0) <= 57 : 0) {
	                    a:do if ((a[(c[g >> 2] | 0) + 1 >> 0] | 0) >= 48 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0) {
	                        do if (((a[c[g >> 2] >> 0] | 0) != 48 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) >= 48 : 0) ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0) {
	                            if ((a[(c[g >> 2] | 0) + 2 >> 0] | 0) >= 48 ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0)break;
	                            c[g >> 2] = (c[g >> 2] | 0) + 2;
	                            break a
	                        } while (0);
	                        if (((((a[c[g >> 2] >> 0] | 0) == 49 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) >= 48 : 0) ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) <= 57 : 0) ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) >= 48 : 0) ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0) {
	                            c[g >> 2] = (c[g >> 2] | 0) + 3;
	                            break
	                        }
	                        if (((((a[c[g >> 2] >> 0] | 0) == 50 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) >= 48 : 0) ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) <= 52 : 0) ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) >= 48 : 0) ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) <= 57 : 0) {
	                            c[g >> 2] = (c[g >> 2] | 0) + 3;
	                            break
	                        }
	                        if ((((a[c[g >> 2] >> 0] | 0) == 50 ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) == 53 : 0) ? (a[(c[g >> 2] | 0) + 2 >> 0] | 0) >= 48 : 0) ? (a[(c[g >> 2] | 0) + 1 >> 0] | 0) <= 53 : 0) {
	                            c[g >> 2] = (c[g >> 2] | 0) + 3;
	                            break
	                        }
	                        c[e >> 2] = 1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else j = 6; while (0);
	                    if ((j | 0) == 6)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    c[c[f >> 2] >> 2] = c[g >> 2];
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[e >> 2] = 1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function em(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 5024 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                j = e + 16 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 15) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 4) {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (c[(c[h >> 2] | 0) + 52 >> 2] | 0)if (wz(c[(c[h >> 2] | 0) + 52 >> 2] | 0) | 0) {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[(c[g >> 2] | 0) + 36 >> 2] = 0;
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                d = xz() | 0;
	                c[(c[g >> 2] | 0) + 56 >> 2] = d;
	                d = c[g >> 2] | 0;
	                if (!(c[(c[g >> 2] | 0) + 56 >> 2] | 0)) {
	                    jn(d, c[h >> 2] | 0, 1, 79384, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                b = Bz(c[d + 56 >> 2] | 0) | 0;
	                c[(c[g >> 2] | 0) + 60 >> 2] = b;
	                kn(c[(c[h >> 2] | 0) + 40 >> 2] | 0, c[g >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                Cz(c[(c[g >> 2] | 0) + 56 >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0) | 0;
	                b = Oz(c[(c[g >> 2] | 0) + 56 >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 52 >> 2] = b;
	                if ((wz(c[(c[h >> 2] | 0) + 52 >> 2] | 0) | 0) != 1) {
	                    a[j >> 0] = 0;
	                    fm(j, 5e3, c[(c[h >> 2] | 0) + 40 >> 2] | 0, 1);
	                    jn(c[g >> 2] | 0, c[h >> 2] | 0, 505, 79424, c[(c[h >> 2] | 0) + 8 >> 2] | 0, j, 0);
	                    c[(c[g >> 2] | 0) + 36 >> 2] = 0;
	                    c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                    yz(c[(c[g >> 2] | 0) + 56 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 56 >> 2] = 0;
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                    yz(c[(c[g >> 2] | 0) + 56 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 56 >> 2] = 0;
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function fm(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                if (!(c[k >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[m >> 2] = ZT(c[h >> 2] | 0) | 0;
	                if (((c[j >> 2] | 0) - (c[m >> 2] | 0) | 0) < 50) {
	                    if (((c[j >> 2] | 0) - (c[m >> 2] | 0) | 0) <= 4) {
	                        i = g;
	                        return
	                    }
	                    if ((a[(c[h >> 2] | 0) + ((c[m >> 2] | 0) - 1) >> 0] | 0) == 46) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79624) | 0;
	                    i = g;
	                    return
	                }
	                if (c[l >> 2] | 0)_T(c[h >> 2] | 0, 79632) | 0;
	                f = c[c[k >> 2] >> 2] | 0;
	                do if ((f | 0) == 4) {
	                    if ((c[c[(c[k >> 2] | 0) + 12 >> 2] >> 2] | 0) != 4 ? (c[c[(c[k >> 2] | 0) + 12 >> 2] >> 2] | 0) != 3 : 0)fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0, 0); else fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0, 1);
	                    c[m >> 2] = ZT(c[h >> 2] | 0) | 0;
	                    if (((c[j >> 2] | 0) - (c[m >> 2] | 0) | 0) >= 50) {
	                        _T(c[h >> 2] | 0, 79664) | 0;
	                        if (!((c[c[(c[k >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3 ? (c[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0))n = 41;
	                        if ((n | 0) == 41 ? (c[c[(c[k >> 2] | 0) + 16 >> 2] >> 2] | 0) != 2 : 0) {
	                            fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0, 1);
	                            break
	                        }
	                        fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0, 0);
	                        break
	                    }
	                    if (((c[j >> 2] | 0) - (c[m >> 2] | 0) | 0) <= 4) {
	                        i = g;
	                        return
	                    }
	                    if ((a[(c[h >> 2] | 0) + ((c[m >> 2] | 0) - 1) >> 0] | 0) == 46) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79624) | 0;
	                    i = g;
	                    return
	                } else if ((f | 0) == 1)_T(c[h >> 2] | 0, 79640) | 0; else if ((f | 0) == 3) {
	                    if ((c[c[(c[k >> 2] | 0) + 12 >> 2] >> 2] | 0) != 4 ? (c[c[(c[k >> 2] | 0) + 12 >> 2] >> 2] | 0) != 3 : 0)fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0, 0); else fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0, 1);
	                    c[m >> 2] = ZT(c[h >> 2] | 0) | 0;
	                    if (((c[j >> 2] | 0) - (c[m >> 2] | 0) | 0) >= 50) {
	                        _T(c[h >> 2] | 0, 79656) | 0;
	                        if (!((c[c[(c[k >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4 ? (c[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0))n = 28;
	                        if ((n | 0) == 28 ? (c[c[(c[k >> 2] | 0) + 16 >> 2] >> 2] | 0) != 2 : 0) {
	                            fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0, 1);
	                            break
	                        }
	                        fm(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0, 0);
	                        break
	                    }
	                    if (((c[j >> 2] | 0) - (c[m >> 2] | 0) | 0) <= 4) {
	                        i = g;
	                        return
	                    }
	                    if ((a[(c[h >> 2] | 0) + ((c[m >> 2] | 0) - 1) >> 0] | 0) == 46) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79624) | 0;
	                    i = g;
	                    return
	                } else if ((f | 0) == 2) {
	                    do if (c[(c[k >> 2] | 0) + 24 >> 2] | 0) {
	                        e = (c[j >> 2] | 0) - (c[m >> 2] | 0) | 0;
	                        d = (e | 0) < ((xy(c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0) + 10 | 0);
	                        e = c[h >> 2] | 0;
	                        if (!d) {
	                            _T(e | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            _T(c[h >> 2] | 0, 79648) | 0;
	                            break
	                        }
	                        _T(e | 0, 79624) | 0;
	                        i = g;
	                        return
	                    } while (0);
	                    e = (c[j >> 2] | 0) - (c[m >> 2] | 0) | 0;
	                    if ((e | 0) < ((xy(c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) + 10 | 0)) {
	                        _T(c[h >> 2] | 0, 79624) | 0;
	                        i = g;
	                        return
	                    } else {
	                        if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))break;
	                        _T(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        break
	                    }
	                } while (0);
	                if (c[l >> 2] | 0)_T(c[h >> 2] | 0, 79672) | 0;
	                l = c[(c[k >> 2] | 0) + 4 >> 2] | 0;
	                if ((l | 0) == 3) {
	                    _T(c[h >> 2] | 0, 79688) | 0;
	                    i = g;
	                    return
	                } else if ((l | 0) == 4) {
	                    _T(c[h >> 2] | 0, 79696) | 0;
	                    i = g;
	                    return
	                } else if ((l | 0) == 2) {
	                    _T(c[h >> 2] | 0, 79680) | 0;
	                    i = g;
	                    return
	                } else {
	                    i = g;
	                    return
	                }
	            }

	            function gm() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0, g = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                e = Cb[c[135744 >> 2] & 511](64) | 0;
	                c[d >> 2] = e;
	                if (!e) {
	                    ln(0, 79472);
	                    c[b >> 2] = 0;
	                    f = c[b >> 2] | 0;
	                    i = a;
	                    return f | 0
	                } else {
	                    e = (c[d >> 2] | 0) + 0 | 0;
	                    g = e + 64 | 0;
	                    do {
	                        c[e >> 2] = 0;
	                        e = e + 4 | 0
	                    } while ((e | 0) < (g | 0));
	                    c[b >> 2] = c[d >> 2];
	                    f = c[b >> 2] | 0;
	                    i = a;
	                    return f | 0
	                }
	                return 0
	            }

	            function hm(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                if (!(c[(c[d >> 2] | 0) + 24 >> 2] | 0)) {
	                    e = c[33934] | 0;
	                    f = c[d >> 2] | 0;
	                    zb[e & 511](f);
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                e = c[33934] | 0;
	                f = c[d >> 2] | 0;
	                zb[e & 511](f);
	                i = b;
	                return
	            }

	            function im(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if (c[g >> 2] | 0)c[l >> 2] = c[(c[g >> 2] | 0) + 80 >> 2];
	                g = c[j >> 2] | 0;
	                if ((g | 0) == 4 | (g | 0) == 3 | (g | 0) == 1) {
	                    if (c[h >> 2] | 0)mn(0, 1, 79528, 0)
	                } else if ((g | 0) == 2) {
	                    if (!(c[h >> 2] | 0))mn(0, 1, 79488, 0)
	                } else {
	                    mn(0, 1, 79568, 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    ln(0, 79472);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                g = c[k >> 2] | 0;
	                c[g + 0 >> 2] = 0;
	                c[g + 4 >> 2] = 0;
	                c[g + 8 >> 2] = 0;
	                c[g + 12 >> 2] = 0;
	                c[g + 16 >> 2] = 0;
	                c[g + 20 >> 2] = 0;
	                c[g + 24 >> 2] = 0;
	                c[c[k >> 2] >> 2] = c[j >> 2];
	                c[(c[k >> 2] | 0) + 4 >> 2] = 1;
	                do if (c[h >> 2] | 0) {
	                    c[n >> 2] = Dh(c[h >> 2] | 0, m) | 0;
	                    j = (c[l >> 2] | 0) == 0;
	                    if (!(c[n >> 2] | 0))if (j) {
	                        g = my(c[h >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = g;
	                        break
	                    } else {
	                        g = AP(c[l >> 2] | 0, c[h >> 2] | 0, -1) | 0;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = g;
	                        break
	                    } else if (j) {
	                        j = ly(c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 24 >> 2] = j;
	                        j = my(c[n >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = j;
	                        break
	                    } else {
	                        j = AP(c[l >> 2] | 0, c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 24 >> 2] = j;
	                        j = AP(c[l >> 2] | 0, c[n >> 2] | 0, -1) | 0;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = j;
	                        break
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function jm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[l >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (c[f >> 2] | 0)c[l >> 2] = c[(c[f >> 2] | 0) + 80 >> 2];
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    ln(0, 79472);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                b = c[h >> 2] | 0;
	                c[b + 0 >> 2] = 0;
	                c[b + 4 >> 2] = 0;
	                c[b + 8 >> 2] = 0;
	                c[b + 12 >> 2] = 0;
	                c[b + 16 >> 2] = 0;
	                c[b + 20 >> 2] = 0;
	                c[b + 24 >> 2] = 0;
	                c[c[h >> 2] >> 2] = c[c[g >> 2] >> 2];
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                do if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)if (c[l >> 2] | 0) {
	                    b = AP(c[l >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = b;
	                    break
	                } else {
	                    b = my(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = b;
	                    break
	                } while (0);
	                do if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)if (c[l >> 2] | 0) {
	                    b = AP(c[l >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0, -1) | 0;
	                    c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                    break
	                } else {
	                    b = my(c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                    break
	                } while (0);
	                if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                    b = jm(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 12 >> 2] = b
	                }
	                if (c[(c[h >> 2] | 0) + 12 >> 2] | 0)c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                a:do if (c[(c[g >> 2] | 0) + 16 >> 2] | 0) {
	                    c[j >> 2] = c[h >> 2];
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0))break a;
	                        c[k >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                        if (!(c[k >> 2] | 0))break;
	                        b = c[k >> 2] | 0;
	                        c[b + 0 >> 2] = 0;
	                        c[b + 4 >> 2] = 0;
	                        c[b + 8 >> 2] = 0;
	                        c[b + 12 >> 2] = 0;
	                        c[b + 16 >> 2] = 0;
	                        c[b + 20 >> 2] = 0;
	                        c[b + 24 >> 2] = 0;
	                        c[c[k >> 2] >> 2] = c[c[g >> 2] >> 2];
	                        c[(c[k >> 2] | 0) + 4 >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                        c[(c[j >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                        do if (c[(c[g >> 2] | 0) + 8 >> 2] | 0)if (c[l >> 2] | 0) {
	                            b = AP(c[l >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                            c[(c[k >> 2] | 0) + 8 >> 2] = b;
	                            break
	                        } else {
	                            b = my(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 8 >> 2] = b;
	                            break
	                        } while (0);
	                        do if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)if (c[l >> 2] | 0) {
	                            b = AP(c[l >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0, -1) | 0;
	                            c[(c[k >> 2] | 0) + 24 >> 2] = b;
	                            break
	                        } else {
	                            b = my(c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 24 >> 2] = b;
	                            break
	                        } while (0);
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                            b = jm(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 12 >> 2] = b
	                        }
	                        if (c[(c[k >> 2] | 0) + 12 >> 2] | 0)c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] = c[h >> 2];
	                        c[j >> 2] = c[k >> 2];
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 16 >> 2]
	                    }
	                    ln(0, 79472);
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function km(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = jm(0, c[d >> 2] | 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function lm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[h >> 2] = 0;
	                if (c[e >> 2] | 0)c[h >> 2] = c[(c[e >> 2] | 0) + 80 >> 2];
	                while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        j = 20;
	                        break
	                    }
	                    c[g >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                    if (((c[c[f >> 2] >> 2] | 0) + -1 | 0) >>> 0 >= 4)break;
	                    if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)lm(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                    b = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0;
	                    if (c[h >> 2] | 0) {
	                        if (b ? (CP(c[h >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 24 >> 2] | 0) != 0 ? (CP(c[h >> 2] | 0, c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] | 0)
	                    } else {
	                        if (b)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                        if (c[(c[f >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] | 0)
	                    }
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[f >> 2] = c[g >> 2]
	                }
	                if ((j | 0) == 20) {
	                    i = d;
	                    return
	                }
	                mn(0, 1, 79568, 0);
	                i = d;
	                return
	            }

	            function mm(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 44 | 0;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                t = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[q >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                f = c[m >> 2] | 0;
	                if ((f | 0) == 1) {
	                    if (c[n >> 2] | 0) {
	                        mn(c[j >> 2] | 0, 1, 79704, 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                } else if ((f | 0) == 4) {
	                    if (!(c[n >> 2] | 0)) {
	                        mn(c[j >> 2] | 0, 1, 79848, 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                } else if ((f | 0) == 3) {
	                    if (!(c[n >> 2] | 0)) {
	                        mn(c[j >> 2] | 0, 1, 79800, 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                } else if ((f | 0) == 2) {
	                    if (c[n >> 2] | 0) {
	                        mn(c[j >> 2] | 0, 1, 79752, 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                } else {
	                    mn(c[j >> 2] | 0, 1, 79896, 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                c[s >> 2] = Ch(c[l >> 2] | 0, r) | 0;
	                if (c[s >> 2] | 0)c[l >> 2] = c[s >> 2];
	                c[p >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                if (!(c[p >> 2] | 0)) {
	                    c[t >> 2] = 0;
	                    if (c[(c[k >> 2] | 0) + 32 >> 2] | 0)c[t >> 2] = c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                    c[p >> 2] = Jj(0, c[t >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 40 >> 2] = c[p >> 2]
	                }
	                if (!(c[p >> 2] | 0)) {
	                    ln(c[j >> 2] | 0, 79944);
	                    if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                if ((((c[(c[k >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) ? (c[o >> 2] = Tj(c[(c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) + 40 >> 2] | 0, c[l >> 2] | 0, c[r >> 2] | 0) | 0, (c[o >> 2] | 0) != 0) : 0) ? (c[(c[o >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) {
	                    c[q >> 2] = c[(c[o >> 2] | 0) + 44 >> 2];
	                    c[(c[o >> 2] | 0) + 44 >> 2] = 0;
	                    ck(c[(c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) + 40 >> 2] | 0, c[l >> 2] | 0, c[r >> 2] | 0, 0) | 0;
	                    nn(c[o >> 2] | 0)
	                }
	                c[o >> 2] = Tj(c[p >> 2] | 0, c[l >> 2] | 0, c[r >> 2] | 0) | 0;
	                do if (!(c[o >> 2] | 0)) {
	                    c[o >> 2] = Cb[c[135744 >> 2] & 511](56) | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        ln(c[j >> 2] | 0, 79472);
	                        if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                    t = (c[o >> 2] | 0) + 0 | 0;
	                    f = t + 56 | 0;
	                    do {
	                        c[t >> 2] = 0;
	                        t = t + 4 | 0
	                    } while ((t | 0) < (f | 0));
	                    c[(c[o >> 2] | 0) + 4 >> 2] = 15;
	                    t = my(c[l >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 8 >> 2] = t;
	                    if (!(c[(c[o >> 2] | 0) + 8 >> 2] | 0)) {
	                        ln(c[j >> 2] | 0, 79472);
	                        if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    } else {
	                        c[(c[o >> 2] | 0) + 48 >> 2] = c[r >> 2];
	                        if (!(Nj(c[p >> 2] | 0, c[l >> 2] | 0, c[r >> 2] | 0, c[o >> 2] | 0) | 0)) {
	                            c[(c[o >> 2] | 0) + 44 >> 2] = c[q >> 2];
	                            break
	                        }
	                        jn(c[j >> 2] | 0, c[k >> 2] | 0, 509, 79992, c[l >> 2] | 0, 0, 0);
	                        nn(c[o >> 2] | 0);
	                        if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        c[h >> 2] = 0;
	                        u = c[h >> 2] | 0;
	                        i = g;
	                        return u | 0
	                    }
	                } else {
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (!(c[r >> 2] | 0))break;
	                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                        c[r >> 2] = 0;
	                        break
	                    }
	                    jn(c[j >> 2] | 0, c[k >> 2] | 0, 509, 79992, c[l >> 2] | 0, 0, 0);
	                    if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                } while (0);
	                c[(c[o >> 2] | 0) + 36 >> 2] = c[m >> 2];
	                do if (c[j >> 2] | 0) {
	                    if ((c[(c[j >> 2] | 0) + 28 >> 2] | 0) != -1412623820 ? (c[(c[j >> 2] | 0) + 28 >> 2] | 0) != -1412623819 : 0) {
	                        v = 63;
	                        break
	                    }
	                    c[(c[o >> 2] | 0) + 40 >> 2] = c[n >> 2];
	                    if (c[n >> 2] | 0)c[(c[n >> 2] | 0) + 20 >> 2] = 1
	                } else v = 63; while (0);
	                if ((v | 0) == 63) {
	                    v = jm(c[(c[k >> 2] | 0) + 32 >> 2] | 0, c[n >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 40 >> 2] = v
	                }
	                c[(c[o >> 2] | 0) + 20 >> 2] = c[k >> 2];
	                c[(c[o >> 2] | 0) + 32 >> 2] = c[(c[k >> 2] | 0) + 32 >> 2];
	                v = c[o >> 2] | 0;
	                n = (c[k >> 2] | 0) + 16 | 0;
	                if (!(c[(c[k >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[n >> 2] = v;
	                    c[(c[k >> 2] | 0) + 12 >> 2] = v
	                } else {
	                    c[(c[n >> 2] | 0) + 24 >> 2] = v;
	                    c[(c[o >> 2] | 0) + 28 >> 2] = c[(c[k >> 2] | 0) + 16 >> 2];
	                    c[(c[k >> 2] | 0) + 16 >> 2] = c[o >> 2]
	                }
	                if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                c[h >> 2] = c[o >> 2];
	                u = c[h >> 2] | 0;
	                i = g;
	                return u | 0
	            }

	            function nm(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 242);
	                i = b;
	                return
	            }

	            function om(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = _j(c[d >> 2] | 0, 243) | 0;
	                i = b;
	                return a | 0
	            }

	            function pm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                b = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                if ((b | 0) == 3) {
	                    rj(c[e >> 2] | 0, 80024);
	                    if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 79648)
	                    }
	                    qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                    rj(c[e >> 2] | 0, 80064);
	                    pn(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0, 1);
	                    rj(c[e >> 2] | 0, 80072);
	                    i = d;
	                    return
	                } else if ((b | 0) == 4) {
	                    rj(c[e >> 2] | 0, 80024);
	                    if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 79648)
	                    }
	                    qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                    rj(c[e >> 2] | 0, 80064);
	                    pn(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0, 1);
	                    rj(c[e >> 2] | 0, 80072);
	                    i = d;
	                    return
	                } else if ((b | 0) == 1) {
	                    rj(c[e >> 2] | 0, 80024);
	                    if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 79648)
	                    }
	                    qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                    rj(c[e >> 2] | 0, 80040);
	                    i = d;
	                    return
	                } else if ((b | 0) == 2) {
	                    rj(c[e >> 2] | 0, 80024);
	                    if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                        qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                        rj(c[e >> 2] | 0, 79648)
	                    }
	                    qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                    rj(c[e >> 2] | 0, 80056);
	                    i = d;
	                    return
	                } else {
	                    mn(0, 1, 80080, 0);
	                    i = d;
	                    return
	                }
	            }

	            function qm(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    ln(0, 79472);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                if (c[e >> 2] | 0) {
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = a
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function rm(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)rm(c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function sm(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = qm(c[(c[e >> 2] | 0) + 4 >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if (c[c[e >> 2] >> 2] | 0) {
	                    a = sm(c[c[e >> 2] >> 2] | 0) | 0;
	                    c[c[f >> 2] >> 2] = a
	                } else c[c[f >> 2] >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function tm(a, b, d, e, f, g, h, j, k) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                l = i;
	                i = i + 64 | 0;
	                m = l + 56 | 0;
	                n = l + 52 | 0;
	                o = l + 48 | 0;
	                p = l + 44 | 0;
	                q = l + 40 | 0;
	                r = l + 36 | 0;
	                s = l + 32 | 0;
	                t = l + 28 | 0;
	                u = l + 24 | 0;
	                v = l + 20 | 0;
	                w = l + 16 | 0;
	                x = l + 12 | 0;
	                y = l + 8 | 0;
	                z = l + 4 | 0;
	                A = l;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[p >> 2] = d;
	                c[q >> 2] = e;
	                c[r >> 2] = f;
	                c[s >> 2] = g;
	                c[t >> 2] = h;
	                c[u >> 2] = j;
	                c[v >> 2] = k;
	                c[z >> 2] = 0;
	                if (!(c[o >> 2] | 0)) {
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                if (!(c[q >> 2] | 0)) {
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                if (!(c[p >> 2] | 0)) {
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                if (c[(c[o >> 2] | 0) + 32 >> 2] | 0)c[z >> 2] = c[(c[(c[o >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                if (((c[s >> 2] | 0) + -1 | 0) >>> 0 >= 10) {
	                    mn(c[n >> 2] | 0, 1, 80136, 0);
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                if (((c[u >> 2] | 0) != 0 ? (qn(c[(c[o >> 2] | 0) + 32 >> 2] | 0, c[s >> 2] | 0, c[u >> 2] | 0) | 0) == 0 : 0) ? (jn(c[n >> 2] | 0, c[o >> 2] | 0, 500, 80192, c[p >> 2] | 0, c[q >> 2] | 0, c[u >> 2] | 0), c[u >> 2] = 0, (c[n >> 2] | 0) != 0) : 0)c[(c[n >> 2] | 0) + 36 >> 2] = 0;
	                if (((((c[(c[o >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[o >> 2] | 0) + 32 >> 2] | 0) + 48 >> 2] | 0) == (c[o >> 2] | 0) : 0) ? (c[(c[(c[o >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[o >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) ? (c[w >> 2] = Sj(c[(c[(c[(c[o >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) + 44 >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[p >> 2] | 0) | 0, (c[w >> 2] | 0) != 0) : 0) {
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                c[x >> 2] = c[(c[o >> 2] | 0) + 44 >> 2];
	                if (!(c[x >> 2] | 0)) {
	                    c[x >> 2] = Jj(0, c[z >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 44 >> 2] = c[x >> 2]
	                }
	                if (!(c[x >> 2] | 0)) {
	                    ln(c[n >> 2] | 0, 80240);
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                c[w >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[w >> 2] | 0)) {
	                    ln(c[n >> 2] | 0, 79472);
	                    rm(c[v >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                k = (c[w >> 2] | 0) + 0 | 0;
	                j = k + 64 | 0;
	                do {
	                    c[k >> 2] = 0;
	                    k = k + 4 | 0
	                } while ((k | 0) < (j | 0));
	                c[(c[w >> 2] | 0) + 4 >> 2] = 16;
	                c[(c[w >> 2] | 0) + 40 >> 2] = c[s >> 2];
	                c[(c[w >> 2] | 0) + 32 >> 2] = c[(c[o >> 2] | 0) + 32 >> 2];
	                if (c[z >> 2] | 0) {
	                    k = AP(c[z >> 2] | 0, c[q >> 2] | 0, -1) | 0;
	                    c[(c[w >> 2] | 0) + 8 >> 2] = k;
	                    k = AP(c[z >> 2] | 0, c[r >> 2] | 0, -1) | 0;
	                    c[(c[w >> 2] | 0) + 56 >> 2] = k;
	                    k = AP(c[z >> 2] | 0, c[p >> 2] | 0, -1) | 0;
	                    c[(c[w >> 2] | 0) + 60 >> 2] = k
	                } else {
	                    k = my(c[q >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 8 >> 2] = k;
	                    k = my(c[r >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 56 >> 2] = k;
	                    k = my(c[p >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 60 >> 2] = k
	                }
	                c[(c[w >> 2] | 0) + 44 >> 2] = c[t >> 2];
	                c[(c[w >> 2] | 0) + 52 >> 2] = c[v >> 2];
	                do if (c[u >> 2] | 0)if (c[z >> 2] | 0) {
	                    v = AP(c[z >> 2] | 0, c[u >> 2] | 0, -1) | 0;
	                    c[(c[w >> 2] | 0) + 48 >> 2] = v;
	                    break
	                } else {
	                    v = my(c[u >> 2] | 0) | 0;
	                    c[(c[w >> 2] | 0) + 48 >> 2] = v;
	                    break
	                } while (0);
	                if ((Mj(c[x >> 2] | 0, c[(c[w >> 2] | 0) + 8 >> 2] | 0, c[(c[w >> 2] | 0) + 56 >> 2] | 0, c[(c[w >> 2] | 0) + 60 >> 2] | 0, c[w >> 2] | 0) | 0) < 0) {
	                    rn(c[n >> 2] | 0, c[o >> 2] | 0, 501, 80288, c[q >> 2] | 0, c[p >> 2] | 0, 0);
	                    sn(c[w >> 2] | 0);
	                    c[m >> 2] = 0;
	                    B = c[m >> 2] | 0;
	                    i = l;
	                    return B | 0
	                }
	                c[y >> 2] = tn(c[o >> 2] | 0, c[p >> 2] | 0, 1) | 0;
	                a:do if (c[y >> 2] | 0) {
	                    if (((c[s >> 2] | 0) == 2 ? (un(0, c[y >> 2] | 0, 1) | 0) != 0 : 0) ? (jn(c[n >> 2] | 0, c[o >> 2] | 0, 520, 80336, c[p >> 2] | 0, c[q >> 2] | 0, 0), (c[n >> 2] | 0) != 0) : 0)c[(c[n >> 2] | 0) + 36 >> 2] = 0;
	                    do if (!(qy(c[(c[w >> 2] | 0) + 8 >> 2] | 0, 80392) | 0)) {
	                        if ((c[(c[w >> 2] | 0) + 56 >> 2] | 0) != 0 ? (qy(c[(c[w >> 2] | 0) + 56 >> 2] | 0, 80392) | 0) != 0 : 0)break;
	                        c[A >> 2] = c[(c[y >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[A >> 2] | 0))break;
	                            if (!(qy(c[(c[A >> 2] | 0) + 8 >> 2] | 0, 80392) | 0)) {
	                                if (!(c[(c[w >> 2] | 0) + 56 >> 2] | 0))break;
	                                if (!(qy(c[(c[w >> 2] | 0) + 56 >> 2] | 0, 80392) | 0))break
	                            }
	                            if (!(c[(c[A >> 2] | 0) + 36 >> 2] | 0))break;
	                            c[A >> 2] = c[(c[A >> 2] | 0) + 36 >> 2]
	                        }
	                        if (c[A >> 2] | 0) {
	                            c[(c[w >> 2] | 0) + 36 >> 2] = c[(c[A >> 2] | 0) + 36 >> 2];
	                            c[(c[A >> 2] | 0) + 36 >> 2] = c[w >> 2];
	                            break a
	                        } else {
	                            c[(c[w >> 2] | 0) + 36 >> 2] = c[(c[y >> 2] | 0) + 44 >> 2];
	                            c[(c[y >> 2] | 0) + 44 >> 2] = c[w >> 2];
	                            break a
	                        }
	                    } while (0);
	                    c[(c[w >> 2] | 0) + 36 >> 2] = c[(c[y >> 2] | 0) + 44 >> 2];
	                    c[(c[y >> 2] | 0) + 44 >> 2] = c[w >> 2]
	                } while (0);
	                c[(c[w >> 2] | 0) + 20 >> 2] = c[o >> 2];
	                y = c[w >> 2] | 0;
	                A = (c[o >> 2] | 0) + 16 | 0;
	                if (!(c[(c[o >> 2] | 0) + 16 >> 2] | 0)) {
	                    c[A >> 2] = y;
	                    c[(c[o >> 2] | 0) + 12 >> 2] = y
	                } else {
	                    c[(c[A >> 2] | 0) + 24 >> 2] = y;
	                    c[(c[w >> 2] | 0) + 28 >> 2] = c[(c[o >> 2] | 0) + 16 >> 2];
	                    c[(c[o >> 2] | 0) + 16 >> 2] = c[w >> 2]
	                }
	                c[m >> 2] = c[w >> 2];
	                B = c[m >> 2] | 0;
	                i = l;
	                return B | 0
	            }

	            function um(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 244);
	                i = b;
	                return
	            }

	            function vm(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = _j(c[d >> 2] | 0, 245) | 0;
	                i = b;
	                return a | 0
	            }

	            function wm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                rj(c[e >> 2] | 0, 80400);
	                qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0);
	                rj(c[e >> 2] | 0, 80064);
	                if (c[(c[f >> 2] | 0) + 56 >> 2] | 0) {
	                    qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0);
	                    rj(c[e >> 2] | 0, 79648)
	                }
	                qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                do switch (c[(c[f >> 2] | 0) + 40 >> 2] | 0) {
	                    case 9:
	                    {
	                        rj(c[e >> 2] | 0, 80504);
	                        wn(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                        break
	                    }
	                    case 5:
	                    {
	                        rj(c[e >> 2] | 0, 80448);
	                        break
	                    }
	                    case 6:
	                    {
	                        rj(c[e >> 2] | 0, 80456);
	                        break
	                    }
	                    case 7:
	                    {
	                        rj(c[e >> 2] | 0, 80472);
	                        break
	                    }
	                    case 2:
	                    {
	                        rj(c[e >> 2] | 0, 80424);
	                        break
	                    }
	                    case 10:
	                    {
	                        rj(c[e >> 2] | 0, 80512);
	                        wn(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                        break
	                    }
	                    case 4:
	                    {
	                        rj(c[e >> 2] | 0, 80440);
	                        break
	                    }
	                    case 8:
	                    {
	                        rj(c[e >> 2] | 0, 80488);
	                        break
	                    }
	                    case 1:
	                    {
	                        rj(c[e >> 2] | 0, 80416);
	                        break
	                    }
	                    case 3:
	                    {
	                        rj(c[e >> 2] | 0, 80432);
	                        break
	                    }
	                    default:
	                        mn(0, 1, 80136, 0)
	                } while (0);
	                b = c[(c[f >> 2] | 0) + 44 >> 2] | 0;
	                if ((b | 0) == 2)rj(c[e >> 2] | 0, 80528); else if ((b | 0) == 3)rj(c[e >> 2] | 0, 80544); else if ((b | 0) == 4)rj(c[e >> 2] | 0, 80560); else if ((b | 0) != 1)mn(0, 1, 80568, 0);
	                if (c[(c[f >> 2] | 0) + 48 >> 2] | 0) {
	                    rj(c[e >> 2] | 0, 80064);
	                    sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0)
	                }
	                rj(c[e >> 2] | 0, 80072);
	                i = d;
	                return
	            }

	            function xm(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 32 | 0;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                p = g + 4 | 0;
	                q = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                if ((c[m >> 2] | 0) == 0 & (c[n >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[p >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                if (!(c[p >> 2] | 0)) {
	                    c[q >> 2] = 0;
	                    if (c[(c[k >> 2] | 0) + 32 >> 2] | 0)c[q >> 2] = c[(c[(c[k >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                    f = Jj(0, c[q >> 2] | 0) | 0;
	                    c[p >> 2] = f;
	                    c[(c[k >> 2] | 0) + 36 >> 2] = f
	                }
	                if (!(c[p >> 2] | 0)) {
	                    ln(c[j >> 2] | 0, 80624);
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    ln(c[j >> 2] | 0, 79472);
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                j = c[o >> 2] | 0;
	                c[j + 0 >> 2] = 0;
	                c[j + 4 >> 2] = 0;
	                c[j + 8 >> 2] = 0;
	                j = my(c[l >> 2] | 0) | 0;
	                c[c[o >> 2] >> 2] = j;
	                if (c[n >> 2] | 0) {
	                    j = my(c[n >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 8 >> 2] = j
	                }
	                if (c[m >> 2] | 0) {
	                    j = my(c[m >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 4 >> 2] = j
	                }
	                if (Lj(c[p >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0) {
	                    mn(0, 526, 80672, c[l >> 2] | 0);
	                    xn(c[o >> 2] | 0);
	                    c[h >> 2] = 0;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                } else {
	                    c[h >> 2] = c[o >> 2];
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                return 0
	            }

	            function ym(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 246);
	                i = b;
	                return
	            }

	            function zm(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = _j(c[d >> 2] | 0, 247) | 0;
	                i = b;
	                return a | 0
	            }

	            function Am(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                rj(c[e >> 2] | 0, 80712);
	                qj(c[e >> 2] | 0, c[c[f >> 2] >> 2] | 0);
	                b = c[e >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    rj(b, 80728);
	                    sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                    if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                        rj(c[e >> 2] | 0, 80064);
	                        sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0)
	                    }
	                } else {
	                    rj(b, 80744);
	                    sj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0)
	                }
	                rj(c[e >> 2] | 0, 80760);
	                i = d;
	                return
	            }

	            function Bm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                Wj(c[f >> 2] | 0, 248, c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function Cm(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[n >> 2] = c[(c[j >> 2] | 0) + 64 >> 2];
	                if (!(c[n >> 2] | 0)) {
	                    e = Jj(0, c[(c[j >> 2] | 0) + 80 >> 2] | 0) | 0;
	                    c[n >> 2] = e;
	                    c[(c[j >> 2] | 0) + 64 >> 2] = e
	                }
	                if (!(c[n >> 2] | 0)) {
	                    ln(c[h >> 2] | 0, 80768);
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    ln(c[h >> 2] | 0, 79472);
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                e = my(c[k >> 2] | 0) | 0;
	                c[(c[m >> 2] | 0) + 4 >> 2] = e;
	                c[(c[m >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    if (c[(c[j >> 2] | 0) + 80 >> 2] | 0) {
	                        e = AP(c[(c[j >> 2] | 0) + 80 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                        c[(c[m >> 2] | 0) + 12 >> 2] = e
	                    } else {
	                        e = my(c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 12 >> 2] = e
	                    }
	                    c[(c[m >> 2] | 0) + 8 >> 2] = 0
	                } else {
	                    c[(c[m >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                    c[(c[m >> 2] | 0) + 12 >> 2] = 0
	                }
	                e = Ni(c[(c[l >> 2] | 0) + 20 >> 2] | 0) | 0;
	                c[(c[m >> 2] | 0) + 16 >> 2] = e;
	                if ((Lj(c[n >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0) | 0) < 0) {
	                    jn(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 20 >> 2] | 0, 513, 80808, c[k >> 2] | 0, 0, 0);
	                    An(c[m >> 2] | 0);
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                if (c[l >> 2] | 0)c[(c[l >> 2] | 0) + 40 >> 2] = 2;
	                c[g >> 2] = c[m >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Dm(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 249);
	                i = b;
	                return
	            }

	            function Em(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 128 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 78 | 0;
	                m = e + 28 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (PT(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 80832) | 0) == 0 : 0) ? (PT(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, 80840) | 0) == 0 : 0) {
	                        c[f >> 2] = 1;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    if (!(c[g >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    if (((c[(c[g >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                        do if (!(qy(80832, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0)) {
	                            if (qy(80848, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0) {
	                                if (!(c[h >> 2] | 0))break;
	                                if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 80856) | 0)break
	                            }
	                            c[f >> 2] = 0;
	                            p = c[f >> 2] | 0;
	                            i = e;
	                            return p | 0
	                        } while (0);
	                        c[f >> 2] = 1;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    c[k >> 2] = 0;
	                    if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)q = Bh(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, l, 50) | 0; else q = c[(c[h >> 2] | 0) + 8 >> 2] | 0;
	                    c[n >> 2] = q;
	                    if ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)r = Bh(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, m, 50) | 0; else r = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                    c[o >> 2] = r;
	                    if (((c[n >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0 ? (c[k >> 2] = Fm(c[(c[g >> 2] | 0) + 44 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0, (c[k >> 2] | 0) == 0) : 0) ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[k >> 2] = Fm(c[(c[g >> 2] | 0) + 48 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) != (m | 0) ? (c[o >> 2] | 0) != (c[(c[j >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    if ((c[n >> 2] | 0) != (l | 0) ? (c[n >> 2] | 0) != (c[(c[h >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) == 2 : 0) {
	                        c[f >> 2] = 1;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[f >> 2] = 0;
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function Fm(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 44 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[k >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[m >> 2] = Ch(c[j >> 2] | 0, n) | 0;
	                g = c[k >> 2] | 0;
	                if (c[m >> 2] | 0) {
	                    c[l >> 2] = Sj(g, c[m >> 2] | 0, c[n >> 2] | 0, c[h >> 2] | 0) | 0;
	                    if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                } else c[l >> 2] = Sj(g, c[j >> 2] | 0, 0, c[h >> 2] | 0) | 0;
	                c[f >> 2] = c[l >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Gm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = c[(c[f >> 2] | 0) + 64 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[k >> 2] = _h(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = Rj(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == (c[g >> 2] | 0) : 0) {
	                    ak(c[h >> 2] | 0, c[k >> 2] | 0, 249) | 0;
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 40 >> 2] = 0;
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                c[e >> 2] = -1;
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function Hm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 64 >> 2];
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[j >> 2] = Rj(c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[e >> 2] = c[f >> 2];
	                        break
	                    } else {
	                        c[e >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Im(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[n >> 2] = c[(c[j >> 2] | 0) + 68 >> 2];
	                if (!(c[n >> 2] | 0)) {
	                    e = Jj(0, c[(c[j >> 2] | 0) + 80 >> 2] | 0) | 0;
	                    c[n >> 2] = e;
	                    c[(c[j >> 2] | 0) + 68 >> 2] = e
	                }
	                if (!(c[n >> 2] | 0)) {
	                    ln(c[h >> 2] | 0, 80864);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    ln(c[h >> 2] | 0, 79472);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                e = my(c[k >> 2] | 0) | 0;
	                c[(c[m >> 2] | 0) + 4 >> 2] = e;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    h = my(c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 12 >> 2] = h;
	                    c[(c[m >> 2] | 0) + 8 >> 2] = 0
	                } else {
	                    c[(c[m >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[m >> 2] | 0) + 8 >> 2] = c[l >> 2]
	                }
	                h = Ni(c[(c[l >> 2] | 0) + 20 >> 2] | 0) | 0;
	                c[(c[m >> 2] | 0) + 16 >> 2] = h;
	                h = Rj(c[n >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[o >> 2] = h;
	                do if (!h) {
	                    l = IS(250, 251) | 0;
	                    c[o >> 2] = l;
	                    if (!l) {
	                        mn(0, 1, 80904, 0);
	                        break
	                    }
	                    if ((Lj(c[n >> 2] | 0, c[k >> 2] | 0, c[o >> 2] | 0) | 0) < 0) {
	                        MS(c[o >> 2] | 0);
	                        mn(0, 1, 80952, 0)
	                    } else q = 22
	                } else q = 22; while (0);
	                do if ((q | 0) == 22) {
	                    if (LS(c[o >> 2] | 0, c[m >> 2] | 0) | 0) {
	                        mn(0, 1, 80952, 0);
	                        break
	                    }
	                    c[g >> 2] = c[m >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } while (0);
	                if (c[m >> 2] | 0) {
	                    if (c[(c[m >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[m >> 2] | 0) + 4 >> 2] | 0);
	                    if (c[(c[m >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[m >> 2] | 0) + 12 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                }
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function Jm(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 252);
	                i = b;
	                return
	            }

	            function Km(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[g >> 2] | 0) == 0 ? (c[g >> 2] = c[(c[j >> 2] | 0) + 32 >> 2], (c[g >> 2] | 0) == 0) : 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = Fm(c[(c[g >> 2] | 0) + 44 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[k >> 2] = Fm(c[(c[g >> 2] | 0) + 48 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                do if (c[k >> 2] | 0) {
	                    if ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) != 3 ? (c[(c[k >> 2] | 0) + 40 >> 2] | 0) != 4 : 0)break;
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } while (0);
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Lm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[h >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                c[k >> 2] = Ch(c[g >> 2] | 0, l) | 0;
	                if (c[k >> 2] | 0)c[g >> 2] = c[k >> 2];
	                c[j >> 2] = Tj(c[h >> 2] | 0, c[g >> 2] | 0, c[l >> 2] | 0) | 0;
	                if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                c[e >> 2] = c[j >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function Mm(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[k >> 2] = c[(c[g >> 2] | 0) + 40 >> 2];
	                    c[f >> 2] = Tj(c[k >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function Nm(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (!(c[(c[h >> 2] | 0) + 44 >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    c[m >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                    c[g >> 2] = Sj(c[m >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[j >> 2] | 0) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function Om(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0)if (!(c[(c[f >> 2] | 0) + 36 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    break
	                } else {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                    c[e >> 2] = Rj(c[h >> 2] | 0, c[g >> 2] | 0) | 0;
	                    break
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Pm(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[h >> 2] | 0) != 0 ? !((c[j >> 2] | 0) == 0 ? 1 : (c[(c[h >> 2] | 0) + 44 >> 2] | 0) == 0) : 0) {
	                    c[k >> 2] = Om(c[(c[h >> 2] | 0) + 44 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[k >> 2] = Om(c[(c[h >> 2] | 0) + 48 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) == 0 & (c[g >> 2] | 0) != 0) {
	                        jn(c[g >> 2] | 0, c[h >> 2] | 0, 537, 81e3, c[j >> 2] | 0, 0, 0);
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    } else {
	                        c[f >> 2] = 1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                }
	                c[f >> 2] = -1;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Qm(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    c[h >> 2] = Lm(c[(c[f >> 2] | 0) + 44 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[h >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[h >> 2] = Lm(c[(c[f >> 2] | 0) + 48 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    switch (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                        case 4:
	                        {
	                            c[e >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 0:
	                        {
	                            c[e >> 2] = -1;
	                            break a;
	                            break
	                        }
	                        case 3:
	                        case 2:
	                        case 1:
	                        {
	                            c[e >> 2] = 1;
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[e >> 2] = 1;
	                            break a
	                        }
	                    }
	                } else j = 3; while (0);
	                if ((j | 0) == 3)c[e >> 2] = -1;
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function Rm(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                c[e + 12 >> 2] = a;
	                c[e + 8 >> 2] = b;
	                c[e + 4 >> 2] = d;
	                c[f >> 2] = 1;
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function Sm(b, e, f, g, h) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                j = i;
	                i = i + 112 | 0;
	                k = j + 44 | 0;
	                l = j + 40 | 0;
	                m = j + 36 | 0;
	                n = j + 32 | 0;
	                o = j + 28 | 0;
	                p = j + 24 | 0;
	                q = j + 20 | 0;
	                r = j + 16 | 0;
	                s = j + 12 | 0;
	                t = j + 8 | 0;
	                u = j + 4 | 0;
	                v = j + 48 | 0;
	                w = j;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = h;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                if (!(c[n >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                if (!(c[p >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                if ((c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[w >> 2] = Bh(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, v, 50) | 0;
	                    if (!(c[w >> 2] | 0)) {
	                        c[k >> 2] = 0;
	                        x = c[k >> 2] | 0;
	                        i = j;
	                        return x | 0
	                    }
	                    c[t >> 2] = Fm(c[(c[m >> 2] | 0) + 44 >> 2] | 0, c[w >> 2] | 0, c[o >> 2] | 0) | 0;
	                    if (((c[t >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[t >> 2] = Fm(c[(c[m >> 2] | 0) + 48 >> 2] | 0, c[w >> 2] | 0, c[o >> 2] | 0) | 0, (c[t >> 2] | 0) != 0) : 0)c[u >> 2] = 1;
	                    if ((c[w >> 2] | 0) != (v | 0) ? (c[w >> 2] | 0) != (c[(c[n >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[w >> 2] | 0)
	                }
	                if ((c[t >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)c[t >> 2] = Fm(c[(c[m >> 2] | 0) + 44 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (((c[t >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[t >> 2] = Fm(c[(c[m >> 2] | 0) + 48 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0) | 0, (c[t >> 2] | 0) != 0) : 0)c[u >> 2] = 1;
	                if (!(c[t >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                if ((c[(c[t >> 2] | 0) + 40 >> 2] | 0) == 1) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                c[q >> 2] = my(c[p >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[k >> 2] = 0;
	                    x = c[k >> 2] | 0;
	                    i = j;
	                    return x | 0
	                }
	                c[s >> 2] = c[p >> 2];
	                c[r >> 2] = c[q >> 2];
	                while (1) {
	                    if ((d[c[s >> 2] >> 0] | 0 | 0) != 32)break;
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                }
	                while (1) {
	                    if (!(d[c[s >> 2] >> 0] | 0))break;
	                    if ((d[c[s >> 2] >> 0] | 0 | 0) != 32) {
	                        t = c[s >> 2] | 0;
	                        c[s >> 2] = t + 1;
	                        w = a[t >> 0] | 0;
	                        t = c[r >> 2] | 0;
	                        c[r >> 2] = t + 1;
	                        a[t >> 0] = w;
	                        continue
	                    }
	                    while (1) {
	                        y = c[s >> 2] | 0;
	                        if ((d[c[s >> 2] >> 0] | 0 | 0) != 32)break;
	                        c[s >> 2] = y + 1
	                    }
	                    if (!(d[y >> 0] | 0))continue;
	                    w = c[r >> 2] | 0;
	                    c[r >> 2] = w + 1;
	                    a[w >> 0] = 32
	                }
	                a[c[r >> 2] >> 0] = 0;
	                if (((c[u >> 2] | 0) == 1 ? (c[(c[m >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (qy(c[p >> 2] | 0, c[q >> 2] | 0) | 0) == 0 : 0) {
	                    jn(c[l >> 2] | 0, c[n >> 2] | 0, 530, 81032, c[o >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[(c[l >> 2] | 0) + 36 >> 2] = 0
	                }
	                c[k >> 2] = c[q >> 2];
	                x = c[k >> 2] | 0;
	                i = j;
	                return x | 0
	            }

	            function Tm(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 96 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h + 40 | 0;
	                t = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[r >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                if (!(c[m >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                if (!(c[n >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                if ((c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    c[t >> 2] = Bh(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, s, 50) | 0;
	                    if (!(c[t >> 2] | 0)) {
	                        c[j >> 2] = 0;
	                        u = c[j >> 2] | 0;
	                        i = h;
	                        return u | 0
	                    }
	                    if ((c[t >> 2] | 0) != (s | 0) ? (c[t >> 2] | 0) != (c[(c[l >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[t >> 2] | 0)
	                }
	                c[r >> 2] = Fm(c[(c[k >> 2] | 0) + 44 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0;
	                if ((c[r >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[r >> 2] = Fm(c[(c[k >> 2] | 0) + 48 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                if ((c[(c[r >> 2] | 0) + 40 >> 2] | 0) == 1) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                c[o >> 2] = my(c[n >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                c[q >> 2] = c[n >> 2];
	                c[p >> 2] = c[o >> 2];
	                while (1) {
	                    if ((d[c[q >> 2] >> 0] | 0 | 0) != 32)break;
	                    c[q >> 2] = (c[q >> 2] | 0) + 1
	                }
	                while (1) {
	                    if (!(d[c[q >> 2] >> 0] | 0))break;
	                    if ((d[c[q >> 2] >> 0] | 0 | 0) != 32) {
	                        n = c[q >> 2] | 0;
	                        c[q >> 2] = n + 1;
	                        r = a[n >> 0] | 0;
	                        n = c[p >> 2] | 0;
	                        c[p >> 2] = n + 1;
	                        a[n >> 0] = r;
	                        continue
	                    }
	                    while (1) {
	                        v = c[q >> 2] | 0;
	                        if ((d[c[q >> 2] >> 0] | 0 | 0) != 32)break;
	                        c[q >> 2] = v + 1
	                    }
	                    if (!(d[v >> 0] | 0))continue;
	                    r = c[p >> 2] | 0;
	                    c[p >> 2] = r + 1;
	                    a[r >> 0] = 32
	                }
	                a[c[p >> 2] >> 0] = 0;
	                c[j >> 2] = c[o >> 2];
	                u = c[j >> 2] | 0;
	                i = h;
	                return u | 0
	            }

	            function Um(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 1;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if (c[(c[j >> 2] | 0) + 48 >> 2] | 0) {
	                    c[l >> 2] = qn(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 40 >> 2] | 0, c[(c[j >> 2] | 0) + 48 >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0))jn(c[g >> 2] | 0, c[j >> 2] | 0, 500, 81120, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 60 >> 2] | 0, 0);
	                    c[k >> 2] = c[k >> 2] & c[l >> 2]
	                }
	                if (((c[(c[j >> 2] | 0) + 40 >> 2] | 0) == 2 ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 3 : 0) ? (c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 2 : 0) {
	                    jn(c[g >> 2] | 0, c[j >> 2] | 0, 512, 81184, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 60 >> 2] | 0, 0);
	                    c[k >> 2] = 0
	                }
	                do if ((c[(c[j >> 2] | 0) + 40 >> 2] | 0) == 2) {
	                    c[n >> 2] = Lm(c[(c[h >> 2] | 0) + 44 >> 2] | 0, c[(c[j >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[m >> 2] = 0;
	                        if (c[(c[h >> 2] | 0) + 44 >> 2] | 0) {
	                            c[o >> 2] = c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 44 >> 2];
	                            Yj(c[o >> 2] | 0, 0, 0, c[(c[j >> 2] | 0) + 60 >> 2] | 0, 253, m)
	                        }
	                    } else c[m >> 2] = un(0, c[n >> 2] | 0, 0) | 0;
	                    if ((c[m >> 2] | 0) > 1) {
	                        Jn(c[g >> 2] | 0, c[j >> 2] | 0, 514, 81256, c[(c[j >> 2] | 0) + 60 >> 2] | 0, c[m >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0);
	                        break
	                    }
	                    if (c[(c[h >> 2] | 0) + 48 >> 2] | 0) {
	                        c[p >> 2] = 0;
	                        c[n >> 2] = Lm(c[(c[h >> 2] | 0) + 48 >> 2] | 0, c[(c[j >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        if (c[n >> 2] | 0)c[p >> 2] = un(0, c[n >> 2] | 0, 0) | 0;
	                        if ((c[p >> 2] | 0) > 1) {
	                            Jn(c[g >> 2] | 0, c[j >> 2] | 0, 514, 81328, c[(c[j >> 2] | 0) + 60 >> 2] | 0, c[p >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        if (((c[p >> 2] | 0) + (c[m >> 2] | 0) | 0) > 1)jn(c[g >> 2] | 0, c[j >> 2] | 0, 514, 81400, c[(c[j >> 2] | 0) + 60 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0)
	                    }
	                } while (0);
	                if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 52 >> 2] | 0) != 0 : 0) {
	                    c[q >> 2] = c[(c[j >> 2] | 0) + 52 >> 2];
	                    while (1) {
	                        if (!(c[q >> 2] | 0))break;
	                        if (qy(c[(c[q >> 2] | 0) + 4 >> 2] | 0, c[(c[j >> 2] | 0) + 48 >> 2] | 0) | 0)break;
	                        c[q >> 2] = c[c[q >> 2] >> 2]
	                    }
	                    if (!(c[q >> 2] | 0)) {
	                        jn(c[g >> 2] | 0, c[j >> 2] | 0, 502, 81480, c[(c[j >> 2] | 0) + 48 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 60 >> 2] | 0);
	                        c[k >> 2] = 0
	                    }
	                }
	                c[f >> 2] = c[k >> 2];
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function Vm(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 1;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 1;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                a:do if ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) == 3) {
	                    c[m >> 2] = c[(c[j >> 2] | 0) + 40 >> 2];
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break a;
	                        if ((c[c[m >> 2] >> 2] | 0) != 4)break a;
	                        if (!(c[(c[m >> 2] | 0) + 12 >> 2] | 0))break a;
	                        b:do if ((c[c[(c[m >> 2] | 0) + 12 >> 2] >> 2] | 0) == 2) {
	                            c[o >> 2] = c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2];
	                            c[n >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                            while (1) {
	                                if (!(c[n >> 2] | 0))break b;
	                                q = c[n >> 2] | 0;
	                                if ((c[c[n >> 2] >> 2] | 0) == 2)break;
	                                if (!(c[q + 12 >> 2] | 0))break b;
	                                if ((c[c[(c[n >> 2] | 0) + 12 >> 2] >> 2] | 0) != 2)break b;
	                                if ((qy(c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0) | 0) != 0 ? (qy(c[(c[(c[n >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) | 0) != 0 : 0) {
	                                    d = c[g >> 2] | 0;
	                                    b = c[j >> 2] | 0;
	                                    a = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                                    if (!(c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0))jn(d, b, 503, 81672, a, c[o >> 2] | 0, 0); else jn(d, b, 503, 81728, a, c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0, c[o >> 2] | 0);
	                                    c[k >> 2] = 0
	                                }
	                                c[n >> 2] = c[(c[n >> 2] | 0) + 16 >> 2]
	                            }
	                            if ((qy(c[q + 8 >> 2] | 0, c[o >> 2] | 0) | 0) != 0 ? (qy(c[(c[n >> 2] | 0) + 24 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) | 0) != 0 : 0) {
	                                a = c[g >> 2] | 0;
	                                b = c[j >> 2] | 0;
	                                d = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                                if (!(c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0))jn(a, b, 503, 81560, d, c[o >> 2] | 0, 0); else jn(a, b, 503, 81616, d, c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0, c[o >> 2] | 0);
	                                c[k >> 2] = 0
	                            }
	                        } while (0);
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 16 >> 2]
	                    }
	                } while (0);
	                c[l >> 2] = Lm(c[(c[h >> 2] | 0) + 44 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                do if ((c[l >> 2] | 0) != 0 ? (c[l >> 2] | 0) != (c[j >> 2] | 0) : 0) {
	                    if ((c[(c[l >> 2] | 0) + 48 >> 2] | 0) != (c[(c[j >> 2] | 0) + 48 >> 2] | 0) ? (qy(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[(c[j >> 2] | 0) + 48 >> 2] | 0) | 0) == 0 : 0)break;
	                    if (c[(c[l >> 2] | 0) + 36 >> 2] | 0) {
	                        jn(c[g >> 2] | 0, c[j >> 2] | 0, 509, 79992, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[k >> 2] = 0
	                    }
	                } while (0);
	                c[l >> 2] = Lm(c[(c[h >> 2] | 0) + 48 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                do if ((c[l >> 2] | 0) != 0 ? (c[l >> 2] | 0) != (c[j >> 2] | 0) : 0) {
	                    if ((c[(c[l >> 2] | 0) + 48 >> 2] | 0) != (c[(c[j >> 2] | 0) + 48 >> 2] | 0) ? (qy(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[(c[j >> 2] | 0) + 48 >> 2] | 0) | 0) == 0 : 0)break;
	                    if (c[(c[l >> 2] | 0) + 36 >> 2] | 0) {
	                        jn(c[g >> 2] | 0, c[j >> 2] | 0, 509, 79992, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[k >> 2] = 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function Wm(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                g = i;
	                i = i + 112 | 0;
	                h = g + 48 | 0;
	                j = g + 44 | 0;
	                k = g + 40 | 0;
	                l = g + 36 | 0;
	                m = g + 32 | 0;
	                n = g + 28 | 0;
	                o = g + 24 | 0;
	                p = g + 20 | 0;
	                q = g + 16 | 0;
	                r = g + 52 | 0;
	                s = g + 12 | 0;
	                t = g + 8 | 0;
	                u = g + 4 | 0;
	                v = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                c[q >> 2] = 1;
	                if (!(c[k >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                }
	                if ((c[(c[k >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                }
	                if ((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        if ((c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            c[s >> 2] = Bh(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, r, 50) | 0;
	                            if (!(c[s >> 2] | 0)) {
	                                c[h >> 2] = 0;
	                                w = c[h >> 2] | 0;
	                                i = g;
	                                return w | 0
	                            }
	                            f = c[(c[k >> 2] | 0) + 44 >> 2] | 0;
	                            e = c[s >> 2] | 0;
	                            d = c[(c[m >> 2] | 0) + 8 >> 2] | 0;
	                            if (c[(c[m >> 2] | 0) + 36 >> 2] | 0) {
	                                c[o >> 2] = Nm(f, e, d, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                if ((c[o >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[o >> 2] = Nm(c[(c[k >> 2] | 0) + 48 >> 2] | 0, c[s >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0
	                            } else {
	                                c[o >> 2] = Fm(f, e, d) | 0;
	                                if ((c[o >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[o >> 2] = Fm(c[(c[k >> 2] | 0) + 48 >> 2] | 0, c[s >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0
	                            }
	                            if ((c[s >> 2] | 0) != (r | 0) ? (c[s >> 2] | 0) != (c[(c[l >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0)
	                        }
	                        do if (!(c[o >> 2] | 0)) {
	                            s = c[(c[k >> 2] | 0) + 44 >> 2] | 0;
	                            r = c[(c[l >> 2] | 0) + 8 >> 2] | 0;
	                            d = c[(c[m >> 2] | 0) + 8 >> 2] | 0;
	                            if (c[(c[m >> 2] | 0) + 36 >> 2] | 0) {
	                                c[o >> 2] = Nm(s, r, d, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                if (c[o >> 2] | 0)break;
	                                if (!(c[(c[k >> 2] | 0) + 48 >> 2] | 0))break;
	                                c[o >> 2] = Nm(c[(c[k >> 2] | 0) + 48 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                break
	                            } else {
	                                c[o >> 2] = Fm(s, r, d) | 0;
	                                if (c[o >> 2] | 0)break;
	                                if (!(c[(c[k >> 2] | 0) + 48 >> 2] | 0))break;
	                                c[o >> 2] = Fm(c[(c[k >> 2] | 0) + 48 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                break
	                            }
	                        } while (0);
	                        if (!(c[o >> 2] | 0)) {
	                            jn(c[j >> 2] | 0, c[l >> 2] | 0, 533, 81784, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0);
	                            c[h >> 2] = 0;
	                            w = c[h >> 2] | 0;
	                            i = g;
	                            return w | 0
	                        }
	                        c[(c[m >> 2] | 0) + 40 >> 2] = c[(c[o >> 2] | 0) + 40 >> 2];
	                        c[p >> 2] = qn(c[k >> 2] | 0, c[(c[o >> 2] | 0) + 40 >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            jn(c[j >> 2] | 0, c[l >> 2] | 0, 502, 81832, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0);
	                            c[q >> 2] = 0
	                        }
	                        if ((c[(c[o >> 2] | 0) + 44 >> 2] | 0) == 4 ? (qy(c[n >> 2] | 0, c[(c[o >> 2] | 0) + 48 >> 2] | 0) | 0) == 0 : 0) {
	                            jn(c[j >> 2] | 0, c[l >> 2] | 0, 500, 81888, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 48 >> 2] | 0);
	                            c[q >> 2] = 0
	                        }
	                        if ((c[(c[o >> 2] | 0) + 40 >> 2] | 0) == 2 ? (Cm(c[j >> 2] | 0, c[k >> 2] | 0, c[n >> 2] | 0, c[m >> 2] | 0) | 0) == 0 : 0)c[q >> 2] = 0;
	                        if (!((c[(c[o >> 2] | 0) + 40 >> 2] | 0) != 3 ? (c[(c[o >> 2] | 0) + 40 >> 2] | 0) != 4 : 0))x = 46;
	                        if ((x | 0) == 46 ? (Im(c[j >> 2] | 0, c[k >> 2] | 0, c[n >> 2] | 0, c[m >> 2] | 0) | 0) == 0 : 0)c[q >> 2] = 0;
	                        if ((c[(c[o >> 2] | 0) + 40 >> 2] | 0) == 10) {
	                            c[t >> 2] = c[(c[o >> 2] | 0) + 52 >> 2];
	                            c[u >> 2] = Om(c[(c[k >> 2] | 0) + 44 >> 2] | 0, c[n >> 2] | 0) | 0;
	                            if (!(c[u >> 2] | 0))c[u >> 2] = Om(c[(c[k >> 2] | 0) + 48 >> 2] | 0, c[n >> 2] | 0) | 0;
	                            if (!(c[u >> 2] | 0)) {
	                                jn(c[j >> 2] | 0, c[l >> 2] | 0, 537, 81952, c[n >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0);
	                                c[q >> 2] = 0
	                            }
	                            while (1) {
	                                if (!(c[t >> 2] | 0))break;
	                                if (qy(c[(c[t >> 2] | 0) + 4 >> 2] | 0, c[n >> 2] | 0) | 0)break;
	                                c[t >> 2] = c[c[t >> 2] >> 2]
	                            }
	                            if (!(c[t >> 2] | 0)) {
	                                jn(c[j >> 2] | 0, c[l >> 2] | 0, 527, 82016, c[n >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0);
	                                c[q >> 2] = 0
	                            }
	                        }
	                        if ((c[(c[o >> 2] | 0) + 40 >> 2] | 0) == 9) {
	                            c[v >> 2] = c[(c[o >> 2] | 0) + 52 >> 2];
	                            while (1) {
	                                if (!(c[v >> 2] | 0))break;
	                                if (qy(c[(c[v >> 2] | 0) + 4 >> 2] | 0, c[n >> 2] | 0) | 0)break;
	                                c[v >> 2] = c[c[v >> 2] >> 2]
	                            }
	                            if (!(c[v >> 2] | 0)) {
	                                jn(c[j >> 2] | 0, c[l >> 2] | 0, 502, 82096, c[n >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0);
	                                c[q >> 2] = 0
	                            }
	                        }
	                        if ((c[(c[o >> 2] | 0) + 44 >> 2] | 0) == 4 ? (qy(c[(c[o >> 2] | 0) + 48 >> 2] | 0, c[n >> 2] | 0) | 0) == 0 : 0) {
	                            jn(c[j >> 2] | 0, c[l >> 2] | 0, 502, 82168, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 48 >> 2] | 0);
	                            c[q >> 2] = 0
	                        }
	                        l = Kn(c[j >> 2] | 0, c[k >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 40 >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[q >> 2] = c[q >> 2] & l;
	                        c[h >> 2] = c[q >> 2];
	                        w = c[h >> 2] | 0;
	                        i = g;
	                        return w | 0
	                    }
	                    c[h >> 2] = 0;
	                    w = c[h >> 2] | 0;
	                    i = g;
	                    return w | 0
	                }
	                c[h >> 2] = 0;
	                w = c[h >> 2] | 0;
	                i = g;
	                return w | 0
	            }

	            function Xm(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                h = i;
	                i = i + 112 | 0;
	                j = h + 52 | 0;
	                k = h + 48 | 0;
	                l = h + 44 | 0;
	                m = h + 40 | 0;
	                n = h + 36 | 0;
	                o = h + 32 | 0;
	                p = h + 28 | 0;
	                q = h + 24 | 0;
	                r = h + 20 | 0;
	                s = h + 16 | 0;
	                t = h + 56 | 0;
	                u = h + 12 | 0;
	                v = h + 8 | 0;
	                w = h + 4 | 0;
	                x = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                c[s >> 2] = 1;
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    y = c[j >> 2] | 0;
	                    i = h;
	                    return y | 0
	                }
	                if ((c[(c[l >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[j >> 2] = 0;
	                    y = c[j >> 2] | 0;
	                    i = h;
	                    return y | 0
	                }
	                if ((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        if (c[n >> 2] | 0) {
	                            c[u >> 2] = Bh(c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[n >> 2] | 0, t, 50) | 0;
	                            if (!(c[u >> 2] | 0)) {
	                                ln(c[k >> 2] | 0, 82216);
	                                c[j >> 2] = 0;
	                                y = c[j >> 2] | 0;
	                                i = h;
	                                return y | 0
	                            }
	                            n = c[(c[l >> 2] | 0) + 44 >> 2] | 0;
	                            g = c[u >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 12 >> 2] | 0) {
	                                c[q >> 2] = Nm(n, g, c[(c[o >> 2] | 0) + 12 >> 2] | 0, 80392) | 0;
	                                if ((c[q >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[q >> 2] = Nm(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[u >> 2] | 0, c[(c[o >> 2] | 0) + 12 >> 2] | 0, 80392) | 0
	                            } else {
	                                c[q >> 2] = Fm(n, g, 80392) | 0;
	                                if ((c[q >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[q >> 2] = Fm(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[u >> 2] | 0, 80392) | 0
	                            }
	                            if ((c[u >> 2] | 0) != (t | 0) ? (c[u >> 2] | 0) != (c[(c[m >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0)
	                        }
	                        do if (!(c[q >> 2] | 0)) {
	                            u = c[(c[l >> 2] | 0) + 44 >> 2] | 0;
	                            t = c[(c[m >> 2] | 0) + 8 >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 12 >> 2] | 0) {
	                                c[q >> 2] = Nm(u, t, c[(c[o >> 2] | 0) + 12 >> 2] | 0, 80392) | 0;
	                                if (c[q >> 2] | 0)break;
	                                if (!(c[(c[l >> 2] | 0) + 48 >> 2] | 0))break;
	                                c[q >> 2] = Nm(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 12 >> 2] | 0, 80392) | 0;
	                                break
	                            } else {
	                                c[q >> 2] = Fm(u, t, 80392) | 0;
	                                if (c[q >> 2] | 0)break;
	                                if (!(c[(c[l >> 2] | 0) + 48 >> 2] | 0))break;
	                                c[q >> 2] = Fm(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 80392) | 0;
	                                break
	                            }
	                        } while (0);
	                        if (!(c[q >> 2] | 0)) {
	                            t = c[k >> 2] | 0;
	                            u = c[m >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(t, u, 533, 82240, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0); else jn(t, u, 533, 82296, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[j >> 2] = 0;
	                            y = c[j >> 2] | 0;
	                            i = h;
	                            return y | 0
	                        }
	                        c[r >> 2] = qn(c[l >> 2] | 0, c[(c[q >> 2] | 0) + 40 >> 2] | 0, c[p >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            r = c[k >> 2] | 0;
	                            u = c[m >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(r, u, 516, 82352, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0); else jn(r, u, 516, 82416, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[s >> 2] = 0
	                        }
	                        if ((c[(c[q >> 2] | 0) + 44 >> 2] | 0) == 4 ? (qy(c[p >> 2] | 0, c[(c[q >> 2] | 0) + 48 >> 2] | 0) | 0) == 0 : 0) {
	                            u = c[k >> 2] | 0;
	                            r = c[m >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(u, r, 500, 82472, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 48 >> 2] | 0); else jn(u, r, 500, 82544, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 48 >> 2] | 0, 0);
	                            c[s >> 2] = 0
	                        }
	                        if ((c[(c[q >> 2] | 0) + 40 >> 2] | 0) == 2 ? (Cm(c[k >> 2] | 0, c[l >> 2] | 0, c[p >> 2] | 0, c[o >> 2] | 0) | 0) == 0 : 0)c[s >> 2] = 0;
	                        if (!((c[(c[q >> 2] | 0) + 40 >> 2] | 0) != 3 ? (c[(c[q >> 2] | 0) + 40 >> 2] | 0) != 4 : 0))z = 54;
	                        if ((z | 0) == 54 ? (Im(c[k >> 2] | 0, c[l >> 2] | 0, c[p >> 2] | 0, c[o >> 2] | 0) | 0) == 0 : 0)c[s >> 2] = 0;
	                        if ((c[(c[q >> 2] | 0) + 40 >> 2] | 0) == 10) {
	                            c[v >> 2] = c[(c[q >> 2] | 0) + 52 >> 2];
	                            c[w >> 2] = Om(c[(c[l >> 2] | 0) + 44 >> 2] | 0, c[p >> 2] | 0) | 0;
	                            if (!(c[w >> 2] | 0))c[w >> 2] = Om(c[(c[l >> 2] | 0) + 48 >> 2] | 0, c[p >> 2] | 0) | 0;
	                            if (!(c[w >> 2] | 0)) {
	                                w = c[k >> 2] | 0;
	                                z = c[m >> 2] | 0;
	                                r = c[p >> 2] | 0;
	                                if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(w, z, 537, 82608, r, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0); else jn(w, z, 537, 82680, r, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0);
	                                c[s >> 2] = 0
	                            }
	                            while (1) {
	                                if (!(c[v >> 2] | 0))break;
	                                if (qy(c[(c[v >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0) | 0)break;
	                                c[v >> 2] = c[c[v >> 2] >> 2]
	                            }
	                            if (!(c[v >> 2] | 0)) {
	                                v = c[k >> 2] | 0;
	                                r = c[m >> 2] | 0;
	                                z = c[p >> 2] | 0;
	                                if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(v, r, 527, 82752, z, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0); else jn(v, r, 527, 82832, z, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0);
	                                c[s >> 2] = 0
	                            }
	                        }
	                        if ((c[(c[q >> 2] | 0) + 40 >> 2] | 0) == 9) {
	                            c[x >> 2] = c[(c[q >> 2] | 0) + 52 >> 2];
	                            while (1) {
	                                if (!(c[x >> 2] | 0))break;
	                                if (qy(c[(c[x >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0) | 0)break;
	                                c[x >> 2] = c[c[x >> 2] >> 2]
	                            }
	                            if (!(c[x >> 2] | 0)) {
	                                x = c[k >> 2] | 0;
	                                z = c[m >> 2] | 0;
	                                r = c[p >> 2] | 0;
	                                if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(x, z, 502, 82912, r, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0); else jn(x, z, 502, 82992, r, c[(c[m >> 2] | 0) + 8 >> 2] | 0, 0);
	                                c[s >> 2] = 0
	                            }
	                        }
	                        if ((c[(c[q >> 2] | 0) + 44 >> 2] | 0) == 4 ? (qy(c[(c[q >> 2] | 0) + 48 >> 2] | 0, c[p >> 2] | 0) | 0) == 0 : 0) {
	                            r = c[k >> 2] | 0;
	                            z = c[m >> 2] | 0;
	                            if (c[(c[o >> 2] | 0) + 12 >> 2] | 0)jn(r, z, 508, 83064, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 48 >> 2] | 0); else jn(r, z, 508, 83120, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 48 >> 2] | 0, 0);
	                            c[s >> 2] = 0
	                        }
	                        m = c[k >> 2] | 0;
	                        k = c[l >> 2] | 0;
	                        if (c[(c[o >> 2] | 0) + 12 >> 2] | 0) {
	                            l = Kn(m, k, c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[q >> 2] | 0) + 40 >> 2] | 0, c[p >> 2] | 0) | 0;
	                            c[s >> 2] = c[s >> 2] & l
	                        } else {
	                            l = Kn(m, k, 80392, c[(c[q >> 2] | 0) + 40 >> 2] | 0, c[p >> 2] | 0) | 0;
	                            c[s >> 2] = c[s >> 2] & l
	                        }
	                        c[j >> 2] = c[s >> 2];
	                        y = c[j >> 2] | 0;
	                        i = h;
	                        return y | 0
	                    }
	                    c[j >> 2] = 0;
	                    y = c[j >> 2] | 0;
	                    i = h;
	                    return y | 0
	                }
	                c[j >> 2] = 0;
	                y = c[j >> 2] | 0;
	                i = h;
	                return y | 0
	            }

	            function Ym(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 36 | 0;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 16 | 0;
	                n = f + 12 | 0;
	                o = f + 8 | 0;
	                p = f + 4 | 0;
	                q = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 1;
	                c[o >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                }
	                do if (((c[(c[h >> 2] | 0) + 44 >> 2] | 0) > 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[p >> 2] = c[(c[h >> 2] | 0) + 40 >> 2], (c[c[p >> 2] >> 2] | 0) != 0) : 0) {
	                    c[q >> 2] = c[c[p >> 2] >> 2];
	                    e = c[(c[q >> 2] | 0) + 36 >> 2] | 0;
	                    if ((e | 0) == 4) {
	                        if (!(c[(c[p >> 2] | 0) + 8 >> 2] | 0))break;
	                        c[m >> 2] = qz(c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                        if ((c[m >> 2] | 0) < 0) {
	                            jn(c[h >> 2] | 0, c[(c[p >> 2] | 0) + 4 >> 2] | 0, 504, 83352, c[(c[(c[p >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0, 0);
	                            c[m >> 2] = 0;
	                            break
	                        } else {
	                            c[m >> 2] = 1;
	                            break
	                        }
	                    } else if ((e | 0) == 1) {
	                        jn(c[h >> 2] | 0, c[(c[p >> 2] | 0) + 4 >> 2] | 0, 528, 83168, c[(c[(c[p >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[m >> 2] = 0;
	                        break
	                    } else if ((e | 0) == 3) {
	                        if ((c[(c[q >> 2] | 0) + 40 >> 2] | 0) != 0 ? (c[c[(c[q >> 2] | 0) + 40 >> 2] >> 2] | 0) == 1 : 0) {
	                            jn(c[h >> 2] | 0, c[(c[p >> 2] | 0) + 4 >> 2] | 0, 529, 83224, c[(c[(c[p >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[m >> 2] = 0;
	                            break
	                        }
	                        c[m >> 2] = Ln(c[h >> 2] | 0, c[(c[q >> 2] | 0) + 40 >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) == 1)break;
	                        jn(c[h >> 2] | 0, c[(c[p >> 2] | 0) + 4 >> 2] | 0, 515, 83288, c[l >> 2] | 0, c[(c[(c[p >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0);
	                        break
	                    } else if (!e) {
	                        c[m >> 2] = 0;
	                        break
	                    } else break
	                } while (0);
	                c[n >> 2] = Mn(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, o) | 0;
	                Nn(c[h >> 2] | 0, c[n >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[g >> 2] = c[m >> 2];
	                r = c[g >> 2] | 0;
	                i = f;
	                return r | 0
	            }

	            function Zm(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = 1;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((c[k >> 2] | 0) <= 0) {
	                    c[g >> 2] = c[l >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                a:do if (((c[(c[h >> 2] | 0) + 44 >> 2] | 0) > 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (c[m >> 2] = c[(c[h >> 2] | 0) + 40 >> 2], (c[c[m >> 2] >> 2] | 0) != 0) : 0) {
	                    c[n >> 2] = c[c[m >> 2] >> 2];
	                    e = c[(c[n >> 2] | 0) + 36 >> 2] | 0;
	                    if ((e | 0) == 1) {
	                        jn(c[h >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 528, 83168, c[(c[(c[m >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[l >> 2] = 0;
	                        break
	                    } else if (!e) {
	                        c[l >> 2] = 0;
	                        break
	                    } else if ((e | 0) == 4) {
	                        if ((c[k >> 2] | 0) <= 0)break;
	                        c[o >> 2] = 0;
	                        b:while (1) {
	                            if ((c[o >> 2] | 0) >= (c[k >> 2] | 0))break a;
	                            do if ((d[(c[j >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[(c[j >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[j >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[(c[j >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) != 13)break b
	                            } while (0);
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                        jn(c[h >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 504, 83416, c[(c[(c[m >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[l >> 2] = 0;
	                        break
	                    } else break
	                } while (0);
	                c[g >> 2] = c[l >> 2];
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function _m(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[f + 20 >> 2] = b;
	                c[f + 16 >> 2] = d;
	                c[f + 12 >> 2] = e;
	                c[j >> 2] = 1;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 44 >> 2] | 0) > 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 40 >> 2];
	                    do if (((c[c[k >> 2] >> 2] | 0) != 0 ? (c[l >> 2] = c[c[k >> 2] >> 2], (c[(c[l >> 2] | 0) + 36 >> 2] | 0) == 4) : 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        c[j >> 2] = qz(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            jn(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0, 504, 83480, c[(c[(c[k >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            break
	                        } else {
	                            c[j >> 2] = 1;
	                            break
	                        }
	                    } while (0);
	                    On(c[h >> 2] | 0) | 0
	                }
	                c[g >> 2] = c[j >> 2];
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function $m(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
	                f = i;
	                i = i + 144 | 0;
	                g = f + 80 | 0;
	                h = f + 76 | 0;
	                j = f + 72 | 0;
	                k = f + 68 | 0;
	                l = f + 64 | 0;
	                m = f + 60 | 0;
	                n = f + 56 | 0;
	                o = f + 52 | 0;
	                p = f + 48 | 0;
	                q = f + 44 | 0;
	                r = f + 40 | 0;
	                s = f + 36 | 0;
	                t = f + 84 | 0;
	                u = f + 32 | 0;
	                v = f + 28 | 0;
	                w = f + 24 | 0;
	                x = f + 20 | 0;
	                y = f + 16 | 0;
	                z = f + 12 | 0;
	                A = f + 8 | 0;
	                B = f + 4 | 0;
	                C = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                c[p >> 2] = 1;
	                c[s >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    D = c[g >> 2] | 0;
	                    i = f;
	                    return D | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[g >> 2] = 0;
	                    D = c[g >> 2] | 0;
	                    i = f;
	                    return D | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    D = c[g >> 2] | 0;
	                    i = f;
	                    return D | 0
	                }
	                do switch (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                    case 8:
	                    case 7:
	                    case 5:
	                    case 4:
	                    {
	                        c[g >> 2] = 1;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 6:
	                    {
	                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83680, 0, 0, 0);
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 11:
	                    case 10:
	                    case 9:
	                    {
	                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83744, 0, 0, 0);
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 20:
	                    case 19:
	                    {
	                        c[g >> 2] = 1;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 1:
	                    {
	                        c[l >> 2] = Mn(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, s) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[g >> 2] = 0;
	                            D = c[g >> 2] | 0;
	                            i = f;
	                            return D | 0
	                        }
	                        a:do if (!(c[(c[h >> 2] | 0) + 44 >> 2] | 0)) {
	                            e = c[(c[l >> 2] | 0) + 36 >> 2] | 0;
	                            if (!e) {
	                                jn(c[h >> 2] | 0, c[k >> 2] | 0, 534, 83832, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                c[g >> 2] = 0;
	                                D = c[g >> 2] | 0;
	                                i = f;
	                                return D | 0
	                            } else if ((e | 0) == 4) {
	                                b:do if ((c[s >> 2] | 0) == 1 ? (c[(c[j >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                                    c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                                    while (1) {
	                                        if (!(c[o >> 2] | 0))break b;
	                                        if ((c[(c[o >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                                            c[v >> 2] = c[(c[o >> 2] | 0) + 40 >> 2];
	                                            while (1) {
	                                                do if ((d[c[v >> 2] >> 0] | 0 | 0) == 32)E = 1; else {
	                                                    if (9 <= (d[c[v >> 2] >> 0] | 0 | 0) ? (d[c[v >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                                        E = 1;
	                                                        break
	                                                    }
	                                                    E = (d[c[v >> 2] >> 0] | 0 | 0) == 13
	                                                } while (0);
	                                                F = c[v >> 2] | 0;
	                                                if (!E)break;
	                                                c[v >> 2] = F + 1
	                                            }
	                                            if (!(d[F >> 0] | 0))break
	                                        }
	                                        c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                                    }
	                                    jn(c[h >> 2] | 0, c[k >> 2] | 0, 532, 83904, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                    c[p >> 2] = 0
	                                } while (0);
	                                c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                                c[m >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                                c[q >> 2] = Qn(c[h >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0, 1, c[k >> 2] | 0) | 0;
	                                if ((c[q >> 2] | 0) > 0)break;
	                                c[p >> 2] = c[q >> 2];
	                                break
	                            } else if ((e | 0) == 3) {
	                                if ((c[(c[l >> 2] | 0) + 40 >> 2] | 0) != 0 ? (c[c[(c[l >> 2] | 0) + 40 >> 2] >> 2] | 0) == 1 : 0) {
	                                    c[p >> 2] = Pn(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                    if (c[p >> 2] | 0)break;
	                                    jn(c[h >> 2] | 0, c[k >> 2] | 0, 529, 83224, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                    break
	                                }
	                                c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                                c:while (1) {
	                                    if (!(c[o >> 2] | 0))break a;
	                                    do if ((c[(c[o >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                        c[r >> 2] = c[(c[o >> 2] | 0) + 8 >> 2];
	                                        if ((c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                            c[u >> 2] = Bh(c[(c[o >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, t, 50) | 0;
	                                            if (!(c[u >> 2] | 0))break c;
	                                            c[m >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                                            d:while (1) {
	                                                if (!(c[m >> 2] | 0))break;
	                                                b = c[m >> 2] | 0;
	                                                e:do if ((c[c[m >> 2] >> 2] | 0) == 2) {
	                                                    if (qy(c[b + 8 >> 2] | 0, c[u >> 2] | 0) | 0)break d
	                                                } else {
	                                                    do if ((c[b >> 2] | 0) == 4) {
	                                                        if (!(c[(c[m >> 2] | 0) + 12 >> 2] | 0))break;
	                                                        if ((c[c[(c[m >> 2] | 0) + 12 >> 2] >> 2] | 0) != 2)break;
	                                                        if (qy(c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0, c[u >> 2] | 0) | 0)break d; else break e
	                                                    } while (0);
	                                                    if ((c[c[m >> 2] >> 2] | 0) != 4) {
	                                                        G = 53;
	                                                        break d
	                                                    }
	                                                    if (!(c[(c[m >> 2] | 0) + 12 >> 2] | 0)) {
	                                                        G = 53;
	                                                        break d
	                                                    }
	                                                    if ((c[c[(c[m >> 2] | 0) + 12 >> 2] >> 2] | 0) != 1) {
	                                                        G = 53;
	                                                        break d
	                                                    }
	                                                } while (0);
	                                                c[m >> 2] = c[(c[m >> 2] | 0) + 16 >> 2]
	                                            }
	                                            if ((G | 0) == 53) {
	                                                G = 0;
	                                                mn(0, 519, 83864, 0)
	                                            }
	                                            if ((c[u >> 2] | 0) != (t | 0) ? (c[u >> 2] | 0) != (c[(c[o >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                                            if (c[m >> 2] | 0)break
	                                        }
	                                        c[m >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                                        f:while (1) {
	                                            if (!(c[m >> 2] | 0))break;
	                                            b = c[m >> 2] | 0;
	                                            g:do if ((c[c[m >> 2] >> 2] | 0) == 2) {
	                                                if (qy(c[b + 8 >> 2] | 0, c[r >> 2] | 0) | 0)break f
	                                            } else {
	                                                do if ((c[b >> 2] | 0) == 4) {
	                                                    if (!(c[(c[m >> 2] | 0) + 12 >> 2] | 0))break;
	                                                    if ((c[c[(c[m >> 2] | 0) + 12 >> 2] >> 2] | 0) != 2)break;
	                                                    if (qy(c[(c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0, c[r >> 2] | 0) | 0)break f; else break g
	                                                } while (0);
	                                                if ((c[c[m >> 2] >> 2] | 0) != 4) {
	                                                    G = 70;
	                                                    break f
	                                                }
	                                                if (!(c[(c[m >> 2] | 0) + 12 >> 2] | 0)) {
	                                                    G = 70;
	                                                    break f
	                                                }
	                                                if ((c[c[(c[m >> 2] | 0) + 12 >> 2] >> 2] | 0) != 1) {
	                                                    G = 70;
	                                                    break f
	                                                }
	                                            } while (0);
	                                            c[m >> 2] = c[(c[m >> 2] | 0) + 16 >> 2]
	                                        }
	                                        if ((G | 0) == 70) {
	                                            G = 0;
	                                            mn(c[h >> 2] | 0, 519, 83864, 0)
	                                        }
	                                        if (!(c[m >> 2] | 0)) {
	                                            jn(c[h >> 2] | 0, c[k >> 2] | 0, 515, 83288, c[r >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0);
	                                            c[p >> 2] = 0
	                                        }
	                                    } while (0);
	                                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                                }
	                                c[g >> 2] = 0;
	                                D = c[g >> 2] | 0;
	                                i = f;
	                                return D | 0
	                            } else if ((e | 0) == 1) {
	                                if (!(c[(c[k >> 2] | 0) + 12 >> 2] | 0))break;
	                                jn(c[h >> 2] | 0, c[k >> 2] | 0, 528, 83168, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                c[p >> 2] = 0;
	                                break
	                            } else break
	                        } while (0);
	                        c[n >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[n >> 2] | 0))break;
	                            h:do if ((c[(c[n >> 2] | 0) + 44 >> 2] | 0) == 2) {
	                                c[w >> 2] = -1;
	                                i:do if ((c[(c[n >> 2] | 0) + 56 >> 2] | 0) == 0 ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 80392) | 0) != 0 : 0) {
	                                    c[x >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                                    while (1) {
	                                        if (!(c[x >> 2] | 0))break i;
	                                        if (!(c[(c[x >> 2] | 0) + 12 >> 2] | 0))break h;
	                                        c[x >> 2] = c[c[x >> 2] >> 2]
	                                    }
	                                } else G = 100; while (0);
	                                j:do if ((G | 0) == 100) {
	                                    G = 0;
	                                    b = (qy(c[(c[n >> 2] | 0) + 56 >> 2] | 0, 80392) | 0) != 0;
	                                    a = c[k >> 2] | 0;
	                                    if (b) {
	                                        c[y >> 2] = c[a + 48 >> 2];
	                                        while (1) {
	                                            if (!(c[y >> 2] | 0))break j;
	                                            if (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[y >> 2] | 0) + 12 >> 2] | 0) | 0)break h;
	                                            c[y >> 2] = c[c[y >> 2] >> 2]
	                                        }
	                                    }
	                                    c[z >> 2] = c[a + 44 >> 2];
	                                    while (1) {
	                                        if (!(c[z >> 2] | 0))break j;
	                                        do if (qy(c[(c[z >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0) {
	                                            if (!(c[(c[n >> 2] | 0) + 56 >> 2] | 0))break h;
	                                            c[A >> 2] = c[(c[z >> 2] | 0) + 36 >> 2];
	                                            if (!(c[A >> 2] | 0))c[A >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                                            if (!(c[A >> 2] | 0)) {
	                                                if ((c[w >> 2] | 0) >= 0)break;
	                                                c[w >> 2] = 0;
	                                                break
	                                            }
	                                            if (qy(c[(c[A >> 2] | 0) + 12 >> 2] | 0, c[(c[n >> 2] | 0) + 56 >> 2] | 0) | 0)break h;
	                                            if ((c[w >> 2] | 0) >= 1)break;
	                                            c[w >> 2] = 1
	                                        } while (0);
	                                        c[z >> 2] = c[(c[z >> 2] | 0) + 24 >> 2]
	                                    }
	                                } while (0);
	                                if ((c[w >> 2] | 0) == -1) {
	                                    a = c[h >> 2] | 0;
	                                    b = c[k >> 2] | 0;
	                                    H = c[(c[k >> 2] | 0) + 8 >> 2] | 0;
	                                    I = c[n >> 2] | 0;
	                                    if (!(c[(c[n >> 2] | 0) + 56 >> 2] | 0)) {
	                                        jn(a, b, 518, 83984, H, c[I + 8 >> 2] | 0, 0);
	                                        c[p >> 2] = 0;
	                                        break
	                                    } else {
	                                        jn(a, b, 518, 84024, H, c[I + 56 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0);
	                                        c[p >> 2] = 0;
	                                        break
	                                    }
	                                }
	                                if (!(c[w >> 2] | 0)) {
	                                    rn(c[h >> 2] | 0, c[k >> 2] | 0, 524, 84072, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 56 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0);
	                                    break
	                                }
	                                if ((c[w >> 2] | 0) == 1)rn(c[h >> 2] | 0, c[k >> 2] | 0, 506, 84128, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 56 >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0)
	                            } else if ((c[(c[n >> 2] | 0) + 44 >> 2] | 0) == 4) {
	                                if ((c[(c[n >> 2] | 0) + 56 >> 2] | 0) == 0 ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 80392) | 0) != 0 : 0) {
	                                    c[B >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                                    while (1) {
	                                        if (!(c[B >> 2] | 0))break h;
	                                        if (!(c[(c[B >> 2] | 0) + 12 >> 2] | 0))break;
	                                        c[B >> 2] = c[c[B >> 2] >> 2]
	                                    }
	                                    if (qy(c[(c[n >> 2] | 0) + 48 >> 2] | 0, c[(c[B >> 2] | 0) + 8 >> 2] | 0) | 0)break;
	                                    jn(c[h >> 2] | 0, c[k >> 2] | 0, 507, 84192, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                    c[p >> 2] = 0;
	                                    break
	                                }
	                                if (qy(c[(c[n >> 2] | 0) + 56 >> 2] | 0, 80392) | 0) {
	                                    c[C >> 2] = c[(c[k >> 2] | 0) + 48 >> 2];
	                                    while (1) {
	                                        if (!(c[C >> 2] | 0))break h;
	                                        if (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[C >> 2] | 0) + 12 >> 2] | 0) | 0)break;
	                                        c[C >> 2] = c[c[C >> 2] >> 2]
	                                    }
	                                    if (!(qy(c[(c[n >> 2] | 0) + 48 >> 2] | 0, c[(c[C >> 2] | 0) + 8 >> 2] | 0) | 0)) {
	                                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 508, 84264, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[C >> 2] | 0) + 12 >> 2] | 0, 0);
	                                        c[p >> 2] = 0
	                                    }
	                                }
	                            } while (0);
	                            c[n >> 2] = c[(c[n >> 2] | 0) + 36 >> 2]
	                        }
	                        c[g >> 2] = c[p >> 2];
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 3:
	                    {
	                        if (c[(c[k >> 2] | 0) + 12 >> 2] | 0) {
	                            jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83584, 0, 0, 0);
	                            c[g >> 2] = 0;
	                            D = c[g >> 2] | 0;
	                            i = f;
	                            return D | 0
	                        }
	                        if (c[(c[k >> 2] | 0) + 36 >> 2] | 0) {
	                            jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83616, 0, 0, 0);
	                            c[g >> 2] = 0;
	                            D = c[g >> 2] | 0;
	                            i = f;
	                            return D | 0
	                        }
	                        if (!(c[(c[k >> 2] | 0) + 40 >> 2] | 0)) {
	                            jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83648, 0, 0, 0);
	                            c[g >> 2] = 0;
	                            D = c[g >> 2] | 0;
	                            i = f;
	                            return D | 0
	                        } else {
	                            c[g >> 2] = 1;
	                            D = c[g >> 2] | 0;
	                            i = f;
	                            return D | 0
	                        }
	                        break
	                    }
	                    case 2:
	                    {
	                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83552, 0, 0, 0);
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 13:
	                    {
	                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83776, 0, 0, 0);
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    case 12:
	                    {
	                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83712, 0, 0, 0);
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                    default:
	                    {
	                        jn(c[h >> 2] | 0, c[k >> 2] | 0, 1, 83808, 0, 0, 0);
	                        c[g >> 2] = 0;
	                        D = c[g >> 2] | 0;
	                        i = f;
	                        return D | 0
	                    }
	                } while (0);
	                return 0
	            }

	            function an(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 80 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d + 24 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[h >> 2] = Pi(c[g >> 2] | 0) | 0;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    do if (((c[(c[g >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0) {
	                        if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            c[l >> 2] = Bh(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, k, 50) | 0;
	                            if (!(c[l >> 2] | 0)) {
	                                ln(c[f >> 2] | 0, 0);
	                                c[e >> 2] = 0;
	                                m = c[e >> 2] | 0;
	                                i = d;
	                                return m | 0
	                            }
	                            c[j >> 2] = qy(c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0;
	                            if ((c[l >> 2] | 0) != (k | 0) ? (c[l >> 2] | 0) != (c[(c[h >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            if ((c[j >> 2] | 0) == 1)break
	                        }
	                        if ((qy(c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0, 84352) | 0) != 0 ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 84360) | 0) != 0 : 0)break;
	                        jn(c[f >> 2] | 0, c[h >> 2] | 0, 531, 84368, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0, 0);
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } while (0);
	                    c[e >> 2] = 1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                mn(c[f >> 2] | 0, 525, 84328, 0);
	                c[e >> 2] = 0;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function bn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[o >> 2] = 1;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if (((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 19 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                    if (!(c[h >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                        c[f >> 2] = 1;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    d = $m(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[o >> 2] = c[o >> 2] & d;
	                    a:do if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            c[n >> 2] = _h(c[h >> 2] | 0, c[(c[l >> 2] | 0) + 12 >> 2] | 0, 0) | 0;
	                            d = Wm(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0) | 0;
	                            c[o >> 2] = c[o >> 2] & d;
	                            if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                        }
	                        c[m >> 2] = c[(c[j >> 2] | 0) + 48 >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0))break a;
	                            d = c[g >> 2] | 0;
	                            b = c[h >> 2] | 0;
	                            a = c[j >> 2] | 0;
	                            if (!(c[(c[j >> 2] | 0) + 36 >> 2] | 0)) {
	                                q = Xm(d, b, a, 0, c[m >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[o >> 2] = c[o >> 2] & q
	                            } else {
	                                q = Xm(d, b, a, c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, c[m >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[o >> 2] = c[o >> 2] & q
	                            }
	                            c[m >> 2] = c[c[m >> 2] >> 2]
	                        }
	                    } while (0);
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        j = bn(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        c[o >> 2] = c[o >> 2] & j;
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                    }
	                    c[f >> 2] = c[o >> 2];
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[f >> 2] = 1;
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function cn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                b = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    mn(b, 521, 84416, 0);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else {
	                    c[j >> 2] = c[b + 28 >> 2];
	                    c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                    c[h >> 2] = c[(c[g >> 2] | 0) + 68 >> 2];
	                    c[(c[f >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                    c[(c[f >> 2] | 0) + 36 >> 2] = 1;
	                    Wj(c[h >> 2] | 0, 254, c[f >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 28 >> 2] = c[j >> 2];
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function dn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[l >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                c[m >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                c[(c[h >> 2] | 0) + 48 >> 2] = c[j >> 2];
	                c[(c[h >> 2] | 0) + 44 >> 2] = 0;
	                c[k >> 2] = an(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[(c[h >> 2] | 0) + 48 >> 2] = c[l >> 2];
	                    c[(c[h >> 2] | 0) + 44 >> 2] = c[m >> 2];
	                    c[f >> 2] = c[k >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (c[(c[h >> 2] | 0) + 64 >> 2] | 0) {
	                    Dm(c[(c[h >> 2] | 0) + 64 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 64 >> 2] = 0
	                }
	                if (c[(c[h >> 2] | 0) + 68 >> 2] | 0) {
	                    Jm(c[(c[h >> 2] | 0) + 68 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 68 >> 2] = 0
	                }
	                c[n >> 2] = Pi(c[h >> 2] | 0) | 0;
	                c[k >> 2] = bn(c[g >> 2] | 0, c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                n = cn(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                c[k >> 2] = c[k >> 2] & n;
	                c[(c[h >> 2] | 0) + 48 >> 2] = c[l >> 2];
	                c[(c[h >> 2] | 0) + 44 >> 2] = c[m >> 2];
	                c[f >> 2] = c[k >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function en(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[(c[f >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 36 >> 2] = 1;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                    Wj(c[j >> 2] | 0, 255, c[f >> 2] | 0)
	                }
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                    Wj(c[k >> 2] | 0, 256, c[f >> 2] | 0)
	                }
	                c[h >> 2] = c[(c[g >> 2] | 0) + 48 >> 2];
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                    Wj(c[j >> 2] | 0, 255, c[f >> 2] | 0)
	                }
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                    Wj(c[k >> 2] | 0, 256, c[f >> 2] | 0)
	                }
	                c[e >> 2] = c[(c[f >> 2] | 0) + 36 >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function fn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    mn(c[f >> 2] | 0, 522, 84456, 0);
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                do if (c[(c[g >> 2] | 0) + 44 >> 2] | 0) {
	                    if ((c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 56 >> 2] | 0) == 0 ? (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 52 >> 2] | 0) == 0 : 0)break;
	                    if (!(c[(c[g >> 2] | 0) + 48 >> 2] | 0)) {
	                        if (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 56 >> 2] | 0) {
	                            c[k >> 2] = Hl(c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 56 >> 2] | 0, c[(c[g >> 2] | 0) + 72 >> 2] | 0) | 0;
	                            if (!(c[k >> 2] | 0)) {
	                                mn(c[f >> 2] | 0, 517, 84472, c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 56 >> 2] | 0);
	                                c[e >> 2] = 0;
	                                l = c[e >> 2] | 0;
	                                i = d;
	                                return l | 0
	                            }
	                        } else c[k >> 2] = 0;
	                        b = Wf(c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 52 >> 2] | 0, c[k >> 2] | 0) | 0;
	                        c[(c[g >> 2] | 0) + 48 >> 2] = b;
	                        if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                        if (!(c[(c[g >> 2] | 0) + 48 >> 2] | 0)) {
	                            b = c[f >> 2] | 0;
	                            a = c[(c[g >> 2] | 0) + 44 >> 2] | 0;
	                            if (c[(c[(c[g >> 2] | 0) + 44 >> 2] | 0) + 56 >> 2] | 0)mn(b, 517, 84520, c[a + 56 >> 2] | 0); else mn(b, 517, 84520, c[a + 52 >> 2] | 0);
	                            c[e >> 2] = 0;
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                    }
	                } while (0);
	                if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                    Dm(c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 64 >> 2] = 0
	                }
	                if (c[(c[g >> 2] | 0) + 68 >> 2] | 0) {
	                    Jm(c[(c[g >> 2] | 0) + 68 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 68 >> 2] = 0
	                }
	                c[h >> 2] = en(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (an(c[f >> 2] | 0, c[g >> 2] | 0) | 0) {
	                    c[j >> 2] = Pi(c[g >> 2] | 0) | 0;
	                    k = bn(c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[h >> 2] = c[h >> 2] & k;
	                    k = cn(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    c[h >> 2] = c[h >> 2] & k;
	                    c[e >> 2] = c[h >> 2];
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function gn(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if ((c[c[k >> 2] >> 2] | 0) >= (c[l >> 2] | 0)) {
	                    c[g >> 2] = c[c[k >> 2] >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                e = c[c[h >> 2] >> 2] | 0;
	                do if ((e | 0) == 4) {
	                    gn(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    gn(c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0
	                } else if ((e | 0) == 2) {
	                    c[m >> 2] = 0;
	                    while (1) {
	                        o = c[(c[h >> 2] | 0) + 8 >> 2] | 0;
	                        if ((c[m >> 2] | 0) >= (c[c[k >> 2] >> 2] | 0)) {
	                            p = 17;
	                            break
	                        }
	                        if (qy(o, c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    if ((p | 0) == 17) {
	                        d = c[k >> 2] | 0;
	                        b = c[d >> 2] | 0;
	                        c[d >> 2] = b + 1;
	                        c[(c[j >> 2] | 0) + (b << 2) >> 2] = o;
	                        break
	                    }
	                    c[g >> 2] = c[c[k >> 2] >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((e | 0) == 1) {
	                    c[m >> 2] = 0;
	                    while (1) {
	                        if ((c[m >> 2] | 0) >= (c[c[k >> 2] >> 2] | 0)) {
	                            p = 11;
	                            break
	                        }
	                        if (qy(79640, c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) | 0)break;
	                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                    }
	                    if ((p | 0) == 11) {
	                        b = c[k >> 2] | 0;
	                        d = c[b >> 2] | 0;
	                        c[b >> 2] = d + 1;
	                        c[(c[j >> 2] | 0) + (d << 2) >> 2] = 79640;
	                        break
	                    }
	                    c[g >> 2] = c[c[k >> 2] >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((e | 0) == 3) {
	                    gn(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    gn(c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0
	                } while (0);
	                c[g >> 2] = c[c[k >> 2] >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function hn(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                f = i;
	                i = i + 1168 | 0;
	                g = f + 1160 | 0;
	                h = f + 1156 | 0;
	                j = f + 1152 | 0;
	                k = f + 1148 | 0;
	                l = f + 1144 | 0;
	                m = f + 1080 | 0;
	                n = f + 1072 | 0;
	                o = f + 48 | 0;
	                p = f + 44 | 0;
	                q = f + 40 | 0;
	                r = f + 36 | 0;
	                s = f + 32 | 0;
	                t = f + 28 | 0;
	                u = f + 24 | 0;
	                v = f + 20 | 0;
	                w = f + 16 | 0;
	                x = f + 12 | 0;
	                y = f + 8 | 0;
	                z = f + 4 | 0;
	                A = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                cU(o | 0, 0, 1024) | 0;
	                c[p >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    B = c[g >> 2] | 0;
	                    i = f;
	                    return B | 0
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    B = c[g >> 2] | 0;
	                    i = f;
	                    return B | 0
	                }
	                if ((c[l >> 2] | 0) <= 0) {
	                    c[g >> 2] = -1;
	                    B = c[g >> 2] | 0;
	                    i = f;
	                    return B | 0
	                }
	                e = m + 0 | 0;
	                d = e + 64 | 0;
	                do {
	                    c[e >> 2] = 0;
	                    e = e + 4 | 0
	                } while ((e | 0) < (d | 0));
	                c[m + 4 >> 2] = 257;
	                c[n >> 2] = 0;
	                c[s >> 2] = (c[h >> 2] | 0) != 0 ? c[h >> 2] | 0 : c[j >> 2] | 0;
	                c[t >> 2] = c[(c[s >> 2] | 0) + 20 >> 2];
	                c[z >> 2] = Lm(c[(c[(c[t >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0, c[(c[t >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if ((c[z >> 2] | 0) == 0 ? (c[(c[(c[t >> 2] | 0) + 32 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[z >> 2] = Lm(c[(c[(c[t >> 2] | 0) + 32 >> 2] | 0) + 48 >> 2] | 0, c[(c[t >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (!(c[z >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    B = c[g >> 2] | 0;
	                    i = f;
	                    return B | 0
	                }
	                if (c[h >> 2] | 0)C = c[(c[h >> 2] | 0) + 24 >> 2] | 0; else C = 0;
	                c[v >> 2] = C;
	                if (c[j >> 2] | 0)D = c[(c[j >> 2] | 0) + 28 >> 2] | 0; else D = 0;
	                c[w >> 2] = D;
	                c[x >> 2] = c[(c[t >> 2] | 0) + 12 >> 2];
	                c[y >> 2] = c[(c[t >> 2] | 0) + 16 >> 2];
	                c[u >> 2] = ji(c[(c[s >> 2] | 0) + 32 >> 2] | 0, 0, 84568, 0) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    B = c[g >> 2] | 0;
	                    i = f;
	                    return B | 0
	                }
	                c[(c[u >> 2] | 0) + 20 >> 2] = c[t >> 2];
	                c[(c[u >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                c[(c[u >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                c[r >> 2] = c[(c[u >> 2] | 0) + 8 >> 2];
	                s = c[u >> 2] | 0;
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 24 >> 2] = s; else c[(c[t >> 2] | 0) + 12 >> 2] = s;
	                s = c[u >> 2] | 0;
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 28 >> 2] = s; else c[(c[t >> 2] | 0) + 16 >> 2] = s;
	                c[p >> 2] = gn(c[(c[z >> 2] | 0) + 40 >> 2] | 0, o, p, 256) | 0;
	                c[q >> 2] = 0;
	                while (1) {
	                    if ((c[q >> 2] | 0) >= (c[p >> 2] | 0))break;
	                    c[(c[u >> 2] | 0) + 8 >> 2] = c[o + (c[q >> 2] << 2) >> 2];
	                    if ($m(m, c[(c[t >> 2] | 0) + 32 >> 2] | 0, c[t >> 2] | 0) | 0) {
	                        c[A >> 2] = 0;
	                        while (1) {
	                            if ((c[A >> 2] | 0) >= (c[n >> 2] | 0))break;
	                            if (qy(c[o + (c[q >> 2] << 2) >> 2] | 0, c[(c[k >> 2] | 0) + (c[A >> 2] << 2) >> 2] | 0) | 0)break;
	                            c[A >> 2] = (c[A >> 2] | 0) + 1
	                        }
	                        z = c[o + (c[q >> 2] << 2) >> 2] | 0;
	                        s = c[n >> 2] | 0;
	                        c[n >> 2] = s + 1;
	                        c[(c[k >> 2] | 0) + (s << 2) >> 2] = z;
	                        if ((c[n >> 2] | 0) >= (c[l >> 2] | 0))break
	                    }
	                    c[q >> 2] = (c[q >> 2] | 0) + 1
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 24 >> 2] = c[v >> 2];
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 28 >> 2] = c[w >> 2];
	                c[(c[t >> 2] | 0) + 12 >> 2] = c[x >> 2];
	                c[(c[t >> 2] | 0) + 16 >> 2] = c[y >> 2];
	                c[(c[u >> 2] | 0) + 8 >> 2] = c[r >> 2];
	                Rh(c[u >> 2] | 0);
	                c[g >> 2] = c[n >> 2];
	                B = c[g >> 2] | 0;
	                i = f;
	                return B | 0
	            }

	            function jn(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                j = i;
	                i = i + 64 | 0;
	                k = j;
	                l = j + 56 | 0;
	                m = j + 52 | 0;
	                n = j + 48 | 0;
	                o = j + 44 | 0;
	                p = j + 40 | 0;
	                q = j + 36 | 0;
	                r = j + 32 | 0;
	                s = j + 28 | 0;
	                t = j + 24 | 0;
	                u = j + 20 | 0;
	                v = j + 16 | 0;
	                w = j + 12 | 0;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                do if (c[l >> 2] | 0) {
	                    c[t >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                    c[v >> 2] = c[c[l >> 2] >> 2];
	                    if ((c[(c[l >> 2] | 0) + 28 >> 2] | 0) != -1412623820 ? (c[(c[l >> 2] | 0) + 28 >> 2] | 0) != -1412623819 : 0)break;
	                    c[w >> 2] = (c[l >> 2] | 0) - (c[c[l >> 2] >> 2] | 0);
	                    if ((c[w >> 2] | 0) > 0 & (c[w >> 2] | 0) < 250)c[u >> 2] = c[c[l >> 2] >> 2]
	                } while (0);
	                l = c[s >> 2] | 0;
	                s = c[t >> 2] | 0;
	                t = c[v >> 2] | 0;
	                v = c[u >> 2] | 0;
	                u = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                w = c[p >> 2] | 0;
	                h = c[r >> 2] | 0;
	                g = c[o >> 2] | 0;
	                o = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                c[k >> 2] = c[p >> 2];
	                c[k + 4 >> 2] = o;
	                c[k + 8 >> 2] = q;
	                Xd(l, s, t, v, u, 23, m, 2, 0, 0, n, w, h, 0, 0, g, k);
	                i = j;
	                return
	            }

	            function kn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 112 | 0;
	                f = e + 44 | 0;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 48 | 0;
	                m = e + 24 | 0;
	                n = e + 20 | 0;
	                o = e + 16 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                s = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    jn(c[h >> 2] | 0, 0, 1, 85712, c[j >> 2] | 0, 0, 0);
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                d = c[c[g >> 2] >> 2] | 0;
	                do if ((d | 0) == 2) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                    c[m >> 2] = Bh(c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0, l, 50) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        ln(c[h >> 2] | 0, 85800);
	                        c[f >> 2] = 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    b = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                    if ((b | 0) == 4) {
	                        a = Dz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, 0, c[m >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 60 >> 2] = a;
	                        Dz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, c[m >> 2] | 0, 0) | 0
	                    } else if ((b | 0) == 1) {
	                        a = Dz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, 0, c[m >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 60 >> 2] = a
	                    } else if ((b | 0) == 2) {
	                        a = Dz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, 0, c[m >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 60 >> 2] = a;
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[k >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0
	                    } else if ((b | 0) == 3) {
	                        b = Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 60 >> 2] = b;
	                        Dz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, c[m >> 2] | 0, 0) | 0
	                    }
	                    if ((c[m >> 2] | 0) != (l | 0) ? (c[m >> 2] | 0) != (c[(c[g >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                } else if ((d | 0) == 4) {
	                    c[s >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[s >> 2] | 0) == 4 | (c[s >> 2] | 0) == 3) {
	                        b = Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 60 >> 2] = b
	                    }
	                    c[q >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                    c[r >> 2] = Iz(c[(c[h >> 2] | 0) + 56 >> 2] | 0) | 0;
	                    do {
	                        c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                        kn(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, c[r >> 2] | 0) | 0;
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        if ((c[c[g >> 2] >> 2] | 0) != 4)break
	                    } while ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1);
	                    c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                    kn(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0, c[r >> 2] | 0) | 0;
	                    b = Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[r >> 2] | 0, 0) | 0;
	                    c[(c[h >> 2] | 0) + 60 >> 2] = b;
	                    b = c[s >> 2] | 0;
	                    if ((b | 0) == 3) {
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[q >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[r >> 2] | 0, c[q >> 2] | 0) | 0;
	                        break
	                    } else if ((b | 0) == 4) {
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[r >> 2] | 0, c[q >> 2] | 0) | 0;
	                        break
	                    } else if ((b | 0) == 2) {
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[q >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        break
	                    } else break
	                } else if ((d | 0) == 1) {
	                    jn(c[h >> 2] | 0, 0, 1, 85760, c[j >> 2] | 0, 0, 0);
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                } else if ((d | 0) == 3) {
	                    c[n >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                    c[p >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    if ((c[p >> 2] | 0) != 1) {
	                        b = Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 60 >> 2] = b;
	                        c[n >> 2] = c[(c[h >> 2] | 0) + 60 >> 2]
	                    }
	                    do {
	                        kn(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 16 >> 2];
	                        if ((c[c[g >> 2] >> 2] | 0) != 3)break
	                    } while ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1);
	                    kn(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[o >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                    b = Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[o >> 2] | 0, 0) | 0;
	                    c[(c[h >> 2] | 0) + 60 >> 2] = b;
	                    b = c[p >> 2] | 0;
	                    if ((b | 0) == 3) {
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[n >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[o >> 2] | 0, c[n >> 2] | 0) | 0;
	                        break
	                    } else if ((b | 0) == 2) {
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[n >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        break
	                    } else if ((b | 0) == 4) {
	                        Jz(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[o >> 2] | 0, c[n >> 2] | 0) | 0;
	                        break
	                    } else break
	                } else {
	                    mn(c[h >> 2] | 0, 1, 85824, c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                } while (0);
	                c[f >> 2] = 1;
	                t = c[f >> 2] | 0;
	                i = e;
	                return t | 0
	            }

	            function ln(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                do if (c[f >> 2] | 0) {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    c[k >> 2] = c[c[f >> 2] >> 2];
	                    if ((c[(c[f >> 2] | 0) + 28 >> 2] | 0) != -1412623820 ? (c[(c[f >> 2] | 0) + 28 >> 2] | 0) != -1412623819 : 0)break;
	                    c[l >> 2] = (c[f >> 2] | 0) - (c[c[f >> 2] >> 2] | 0);
	                    if ((c[l >> 2] | 0) > 0 & (c[l >> 2] | 0) < 250)c[j >> 2] = c[c[f >> 2] >> 2]
	                } while (0);
	                f = c[h >> 2] | 0;
	                h = c[k >> 2] | 0;
	                k = c[j >> 2] | 0;
	                if (c[g >> 2] | 0) {
	                    j = c[g >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Xd(0, f, h, k, 0, 23, 2, 3, 0, 0, j, 0, 0, 0, 0, 85648, e);
	                    i = d;
	                    return
	                } else {
	                    Xd(0, f, h, k, 0, 23, 2, 3, 0, 0, 0, 0, 0, 0, 0, 85680, e);
	                    i = d;
	                    return
	                }
	            }

	            function mn(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 16 | 0;
	                n = f + 12 | 0;
	                o = f + 8 | 0;
	                p = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                do if (c[h >> 2] | 0) {
	                    c[m >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                    c[o >> 2] = c[c[h >> 2] >> 2];
	                    if ((c[(c[h >> 2] | 0) + 28 >> 2] | 0) != -1412623820 ? (c[(c[h >> 2] | 0) + 28 >> 2] | 0) != -1412623819 : 0)break;
	                    c[p >> 2] = (c[h >> 2] | 0) - (c[c[h >> 2] >> 2] | 0);
	                    if ((c[p >> 2] | 0) > 0 & (c[p >> 2] | 0) < 250)c[n >> 2] = c[c[h >> 2] >> 2]
	                } while (0);
	                h = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                o = c[n >> 2] | 0;
	                n = c[j >> 2] | 0;
	                if (c[l >> 2] | 0) {
	                    j = c[l >> 2] | 0;
	                    p = c[k >> 2] | 0;
	                    c[g >> 2] = c[l >> 2];
	                    Xd(0, h, m, o, 0, 23, n, 2, 0, 0, j, 0, 0, 0, 0, p, g);
	                    i = f;
	                    return
	                } else {
	                    c[g >> 2] = c[k >> 2];
	                    Xd(0, h, m, o, 0, 23, n, 2, 0, 0, 0, 0, 0, 0, 0, 85640, g);
	                    i = f;
	                    return
	                }
	            }

	            function nn(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Qh(c[d >> 2] | 0);
	                lm(c[(c[d >> 2] | 0) + 32 >> 2] | 0, c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)zz(c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function on(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](56) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    ln(0, 79472);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 56 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 4 >> 2] = 15;
	                c[(c[f >> 2] | 0) + 36 >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a
	                } else c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                if (c[(c[e >> 2] | 0) + 48 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 48 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 48 >> 2] = a
	                } else c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                a = km(c[(c[e >> 2] | 0) + 40 >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 40 >> 2] = a;
	                c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function pn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (c[h >> 2] | 0)rj(c[f >> 2] | 0, 79632);
	                d = c[c[g >> 2] >> 2] | 0;
	                a:do if ((d | 0) == 1)rj(c[f >> 2] | 0, 79640); else if ((d | 0) == 4) {
	                    if ((c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) != 4 ? (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) != 3 : 0)pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 0); else pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 1);
	                    rj(c[f >> 2] | 0, 79664);
	                    do if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) != 3) {
	                        if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 4 ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 1 : 0)break;
	                        pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0, 0);
	                        break a
	                    } while (0);
	                    pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0, 1)
	                } else if ((d | 0) == 2) {
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                        qj(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                        rj(c[f >> 2] | 0, 79648)
	                    }
	                    qj(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0)
	                } else if ((d | 0) == 3) {
	                    if ((c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) != 4 ? (c[c[(c[g >> 2] | 0) + 12 >> 2] >> 2] | 0) != 3 : 0)pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 0); else pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 1);
	                    rj(c[f >> 2] | 0, 79656);
	                    do if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) != 4) {
	                        if ((c[c[(c[g >> 2] | 0) + 16 >> 2] >> 2] | 0) == 3 ? (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 1 : 0)break;
	                        pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0, 0);
	                        break a
	                    } while (0);
	                    pn(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 16 >> 2] | 0, 1)
	                } else mn(0, 1, 79568, 0); while (0);
	                if (c[h >> 2] | 0)rj(c[f >> 2] | 0, 79672);
	                h = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                if ((h | 0) == 2) {
	                    rj(c[f >> 2] | 0, 79680);
	                    i = e;
	                    return
	                } else if ((h | 0) == 3) {
	                    rj(c[f >> 2] | 0, 79688);
	                    i = e;
	                    return
	                } else if ((h | 0) == 4) {
	                    rj(c[f >> 2] | 0, 79696);
	                    i = e;
	                    return
	                } else {
	                    i = e;
	                    return
	                }
	            }

	            function qn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                switch (c[h >> 2] | 0) {
	                    case 10:
	                    case 2:
	                    case 3:
	                    case 5:
	                    {
	                        c[f >> 2] = En(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[f >> 2] = Gn(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 4:
	                    case 6:
	                    {
	                        c[f >> 2] = Fn(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 9:
	                    case 8:
	                    {
	                        c[f >> 2] = Hn(c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    default:
	                        c[f >> 2] = 1
	                }
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function rn(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                j = i;
	                i = i + 64 | 0;
	                k = j;
	                l = j + 56 | 0;
	                m = j + 52 | 0;
	                n = j + 48 | 0;
	                o = j + 44 | 0;
	                p = j + 40 | 0;
	                q = j + 36 | 0;
	                r = j + 32 | 0;
	                s = j + 28 | 0;
	                t = j + 24 | 0;
	                u = j + 20 | 0;
	                v = j + 16 | 0;
	                w = j + 12 | 0;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                do if (c[l >> 2] | 0) {
	                    c[t >> 2] = c[(c[l >> 2] | 0) + 8 >> 2];
	                    c[v >> 2] = c[c[l >> 2] >> 2];
	                    if ((c[(c[l >> 2] | 0) + 28 >> 2] | 0) != -1412623820 ? (c[(c[l >> 2] | 0) + 28 >> 2] | 0) != -1412623819 : 0)break;
	                    c[w >> 2] = (c[l >> 2] | 0) - (c[c[l >> 2] >> 2] | 0);
	                    if ((c[w >> 2] | 0) > 0 & (c[w >> 2] | 0) < 250)c[u >> 2] = c[c[l >> 2] >> 2]
	                } while (0);
	                l = c[s >> 2] | 0;
	                s = c[t >> 2] | 0;
	                t = c[v >> 2] | 0;
	                v = c[u >> 2] | 0;
	                u = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                w = c[p >> 2] | 0;
	                h = c[r >> 2] | 0;
	                g = c[o >> 2] | 0;
	                o = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                c[k >> 2] = c[p >> 2];
	                c[k + 4 >> 2] = o;
	                c[k + 8 >> 2] = q;
	                Xd(l, s, t, v, u, 23, m, 1, 0, 0, n, w, h, 0, 0, g, k);
	                i = j;
	                return
	            }

	            function sn(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2]; else c[e >> 2] = 0;
	                Qh(c[d >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)rm(c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                a = (c[(c[d >> 2] | 0) + 60 >> 2] | 0) != 0;
	                if (c[e >> 2] | 0) {
	                    if (a ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 60 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 60 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 56 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 56 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0);
	                    if ((c[(c[d >> 2] | 0) + 48 >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 48 >> 2] | 0) | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0)
	                } else {
	                    if (a)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 60 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 48 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 48 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 56 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function tn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[o >> 2] = 0;
	                    if (c[(c[g >> 2] | 0) + 32 >> 2] | 0)c[o >> 2] = c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 80 >> 2];
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                    c[k >> 2] = c[(c[g >> 2] | 0) + 40 >> 2];
	                    if (!(c[k >> 2] | 0)) {
	                        c[k >> 2] = Jj(0, c[o >> 2] | 0) | 0;
	                        c[(c[g >> 2] | 0) + 40 >> 2] = c[k >> 2]
	                    }
	                    if (!(c[k >> 2] | 0)) {
	                        ln(0, 85552);
	                        c[f >> 2] = 0;
	                        p = c[f >> 2] | 0;
	                        i = e;
	                        return p | 0
	                    }
	                }
	                c[k >> 2] = c[(c[g >> 2] | 0) + 40 >> 2];
	                c[m >> 2] = Ch(c[h >> 2] | 0, n) | 0;
	                if (c[m >> 2] | 0)c[h >> 2] = c[m >> 2];
	                c[l >> 2] = Tj(c[k >> 2] | 0, c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                do if ((c[l >> 2] | 0) == 0 & (c[j >> 2] | 0) != 0) {
	                    c[l >> 2] = Cb[c[135744 >> 2] & 511](56) | 0;
	                    if (c[l >> 2] | 0) {
	                        g = (c[l >> 2] | 0) + 0 | 0;
	                        o = g + 56 | 0;
	                        do {
	                            c[g >> 2] = 0;
	                            g = g + 4 | 0
	                        } while ((g | 0) < (o | 0));
	                        c[(c[l >> 2] | 0) + 4 >> 2] = 15;
	                        g = my(c[h >> 2] | 0) | 0;
	                        c[(c[l >> 2] | 0) + 8 >> 2] = g;
	                        g = my(c[n >> 2] | 0) | 0;
	                        c[(c[l >> 2] | 0) + 48 >> 2] = g;
	                        c[(c[l >> 2] | 0) + 36 >> 2] = 0;
	                        Nj(c[k >> 2] | 0, c[h >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                        break
	                    }
	                    ln(0, 79472);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                } while (0);
	                if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                c[f >> 2] = c[l >> 2];
	                p = c[f >> 2] | 0;
	                i = e;
	                return p | 0
	            }

	            function un(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    if ((c[(c[k >> 2] | 0) + 40 >> 2] | 0) == 2 ? (c[l >> 2] = (c[l >> 2] | 0) + 1, (c[l >> 2] | 0) > 1 & (c[j >> 2] | 0) != 0) : 0)jn(c[g >> 2] | 0, c[h >> 2] | 0, 520, 85584, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 36 >> 2]
	                }
	                c[f >> 2] = c[l >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function vn(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    ln(0, 79472);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 64 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 4 >> 2] = 16;
	                c[(c[f >> 2] | 0) + 40 >> 2] = c[(c[e >> 2] | 0) + 40 >> 2];
	                c[(c[f >> 2] | 0) + 44 >> 2] = c[(c[e >> 2] | 0) + 44 >> 2];
	                a = sm(c[(c[e >> 2] | 0) + 52 >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 52 >> 2] = a;
	                if (c[(c[e >> 2] | 0) + 60 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 60 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 56 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 56 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 56 >> 2] = a
	                }
	                if (c[(c[e >> 2] | 0) + 48 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 48 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 48 >> 2] = a
	                }
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function wn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                qj(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 4 >> 2] | 0);
	                b = c[e >> 2] | 0;
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    rj(b, 79672);
	                    i = d;
	                    return
	                } else {
	                    rj(b, 79664);
	                    wn(c[e >> 2] | 0, c[c[f >> 2] >> 2] | 0);
	                    i = d;
	                    return
	                }
	            }

	            function xn(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[c[d >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function yn(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    ln(0, 79472);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                if (c[c[e >> 2] >> 2] | 0) {
	                    a = my(c[c[e >> 2] >> 2] | 0) | 0;
	                    c[c[f >> 2] >> 2] = a
	                } else c[c[f >> 2] >> 2] = 0;
	                if (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = a
	                } else c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                    a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a
	                } else c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function zn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                Am(c[f >> 2] | 0, c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function An(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 80 >> 2];
	                do if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0)
	                } while (0);
	                do if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0)
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function Bn(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = OS(c[d >> 2] | 0) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                i = b;
	                return
	            }

	            function Cn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0;
	                d = i;
	                i = i + 16 | 0;
	                c[d + 4 >> 2] = a;
	                c[d >> 2] = b;
	                i = d;
	                return 0
	            }

	            function Dn(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                MS(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function En(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = c[g >> 2];
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                if (!(Vn(c[f >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                while (1) {
	                    if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0))break;
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                }
	                if (c[j >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Fn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = c[g >> 2];
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                if (!(Vn(c[f >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                while (1) {
	                    if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0))break;
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                }
	                a:while (1) {
	                    if ((c[j >> 2] | 0) != 32)break;
	                    while (1) {
	                        if ((c[j >> 2] | 0) != 32)break;
	                        c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                    }
	                    if (!(Vn(c[f >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                        m = 12;
	                        break
	                    }
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                    while (1) {
	                        if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0))continue a;
	                        c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                    }
	                }
	                if ((m | 0) == 12) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if (c[j >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Gn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = c[g >> 2];
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                while (1) {
	                    if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0))break;
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                }
	                if (c[j >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function Hn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = c[g >> 2];
	                c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                while (1) {
	                    if ((c[j >> 2] | 0) < 256) {
	                        if ((c[j >> 2] | 0) != 32 ? !(9 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 10) : 0)m = (c[j >> 2] | 0) == 13; else m = 1;
	                        n = m & 1
	                    } else n = 0;
	                    if (!n)break;
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                }
	                if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                while (1) {
	                    if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0))break;
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                }
	                a:while (1) {
	                    if ((c[j >> 2] | 0) != 32) {
	                        o = 25;
	                        break
	                    }
	                    while (1) {
	                        if ((c[j >> 2] | 0) != 32)break;
	                        c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                    }
	                    if (!(c[j >> 2] | 0)) {
	                        o = 19;
	                        break
	                    }
	                    if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0)) {
	                        o = 21;
	                        break
	                    }
	                    c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0);
	                    while (1) {
	                        if (!(Wn(c[f >> 2] | 0, c[j >> 2] | 0) | 0))continue a;
	                        c[j >> 2] = oe(0, c[h >> 2] | 0, k) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + (c[k >> 2] | 0)
	                    }
	                }
	                if ((o | 0) == 19) {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((o | 0) == 21) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((o | 0) == 25)if (c[j >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function In(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[e >> 2] = d;
	                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 2) {
	                    i = e;
	                    return
	                }
	                f = c[g >> 2] | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + 1;
	                i = e;
	                return
	            }

	            function Jn(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                j = i;
	                i = i + 64 | 0;
	                k = j;
	                l = j + 56 | 0;
	                m = j + 52 | 0;
	                n = j + 48 | 0;
	                o = j + 44 | 0;
	                p = j + 40 | 0;
	                q = j + 36 | 0;
	                r = j + 32 | 0;
	                s = j + 28 | 0;
	                t = j + 24 | 0;
	                u = j + 20 | 0;
	                v = j + 16 | 0;
	                w = j + 12 | 0;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                do if (c[l >> 2] | 0) {
	                    c[t >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                    c[v >> 2] = c[c[l >> 2] >> 2];
	                    if ((c[(c[l >> 2] | 0) + 28 >> 2] | 0) != -1412623820 ? (c[(c[l >> 2] | 0) + 28 >> 2] | 0) != -1412623819 : 0)break;
	                    c[w >> 2] = (c[l >> 2] | 0) - (c[c[l >> 2] >> 2] | 0);
	                    if ((c[w >> 2] | 0) > 0 & (c[w >> 2] | 0) < 250)c[u >> 2] = c[c[l >> 2] >> 2]
	                } while (0);
	                l = c[s >> 2] | 0;
	                s = c[t >> 2] | 0;
	                t = c[v >> 2] | 0;
	                v = c[u >> 2] | 0;
	                u = c[m >> 2] | 0;
	                m = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                w = c[r >> 2] | 0;
	                h = c[q >> 2] | 0;
	                g = c[o >> 2] | 0;
	                o = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                c[k >> 2] = c[p >> 2];
	                c[k + 4 >> 2] = o;
	                c[k + 8 >> 2] = q;
	                Xd(l, s, t, v, u, 23, m, 2, 0, 0, n, w, 0, h, 0, g, k);
	                i = j;
	                return
	            }

	            function Kn(b, e, f, g, h) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                j = i;
	                i = i + 64 | 0;
	                k = j + 48 | 0;
	                l = j + 44 | 0;
	                m = j + 40 | 0;
	                n = j + 36 | 0;
	                o = j + 32 | 0;
	                p = j + 28 | 0;
	                q = j + 24 | 0;
	                r = j + 20 | 0;
	                s = j + 16 | 0;
	                t = j + 12 | 0;
	                u = j + 8 | 0;
	                v = j + 52 | 0;
	                w = j + 4 | 0;
	                x = j;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = h;
	                c[q >> 2] = 1;
	                h = c[o >> 2] | 0;
	                do if ((h | 0) == 5) {
	                    c[r >> 2] = ad(c[m >> 2] | 0, c[p >> 2] | 0) | 0;
	                    if ((c[r >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                        c[(c[m >> 2] | 0) + 40 >> 2] = 0;
	                        c[r >> 2] = ad(c[m >> 2] | 0, c[p >> 2] | 0) | 0
	                    }
	                    if (!(c[r >> 2] | 0)) {
	                        jn(c[l >> 2] | 0, c[m >> 2] | 0, 535, 85248, c[n >> 2] | 0, c[p >> 2] | 0, 0);
	                        c[q >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[r >> 2] | 0) + 48 >> 2] | 0) != 3) {
	                        jn(c[l >> 2] | 0, c[m >> 2] | 0, 511, 85304, c[n >> 2] | 0, c[p >> 2] | 0, 0);
	                        c[q >> 2] = 0
	                    }
	                } else if ((h | 0) == 10) {
	                    c[x >> 2] = Om(c[(c[m >> 2] | 0) + 44 >> 2] | 0, c[p >> 2] | 0) | 0;
	                    if ((c[x >> 2] | 0) == 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)c[x >> 2] = Om(c[(c[m >> 2] | 0) + 48 >> 2] | 0, c[p >> 2] | 0) | 0;
	                    if (!(c[x >> 2] | 0)) {
	                        jn(c[l >> 2] | 0, c[m >> 2] | 0, 537, 85488, c[n >> 2] | 0, c[p >> 2] | 0, 0);
	                        c[q >> 2] = 0
	                    }
	                } else if ((h | 0) == 6) {
	                    c[t >> 2] = 0;
	                    c[s >> 2] = my(c[p >> 2] | 0) | 0;
	                    if (!(c[s >> 2] | 0)) {
	                        c[k >> 2] = 0;
	                        y = c[k >> 2] | 0;
	                        i = j;
	                        return y | 0
	                    }
	                    c[u >> 2] = c[s >> 2];
	                    a:while (1) {
	                        if (!(d[c[u >> 2] >> 0] | 0))break;
	                        c[t >> 2] = c[u >> 2];
	                        while (1) {
	                            if (d[c[u >> 2] >> 0] | 0) {
	                                do if ((d[c[u >> 2] >> 0] | 0 | 0) == 32)z = 1; else {
	                                    if (9 <= (d[c[u >> 2] >> 0] | 0 | 0) ? (d[c[u >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        z = 1;
	                                        break
	                                    }
	                                    z = (d[c[u >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                A = z ^ 1
	                            } else A = 0;
	                            B = c[u >> 2] | 0;
	                            if (!A)break;
	                            c[u >> 2] = B + 1
	                        }
	                        a[v >> 0] = a[B >> 0] | 0;
	                        a[c[u >> 2] >> 0] = 0;
	                        c[w >> 2] = ad(c[m >> 2] | 0, c[t >> 2] | 0) | 0;
	                        if (c[w >> 2] | 0) {
	                            if ((c[(c[w >> 2] | 0) + 48 >> 2] | 0) != 3) {
	                                jn(c[l >> 2] | 0, c[m >> 2] | 0, 511, 85424, c[n >> 2] | 0, c[t >> 2] | 0, 0);
	                                c[q >> 2] = 0
	                            }
	                        } else {
	                            jn(c[l >> 2] | 0, c[m >> 2] | 0, 535, 85368, c[n >> 2] | 0, c[t >> 2] | 0, 0);
	                            c[q >> 2] = 0
	                        }
	                        if (!(d[v >> 0] | 0))break;
	                        a[c[u >> 2] >> 0] = a[v >> 0] | 0;
	                        while (1) {
	                            do if ((d[c[u >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[u >> 2] >> 0] | 0 | 0) ? (d[c[u >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[u >> 2] >> 0] | 0 | 0) != 13)continue a
	                            } while (0);
	                            c[u >> 2] = (c[u >> 2] | 0) + 1
	                        }
	                    }
	                    zb[c[135736 >> 2] & 511](c[s >> 2] | 0)
	                } while (0);
	                c[k >> 2] = c[q >> 2];
	                y = c[k >> 2] | 0;
	                i = j;
	                return y | 0
	            }

	            function Ln(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = Dh(c[j >> 2] | 0, l) | 0;
	                a:do if (!(c[k >> 2] | 0)) {
	                    b:while (1) {
	                        if (!(c[h >> 2] | 0))break a;
	                        d = c[h >> 2] | 0;
	                        do if ((c[c[h >> 2] >> 2] | 0) == 2) {
	                            if ((c[d + 24 >> 2] | 0) == 0 ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) {
	                                m = 6;
	                                break b
	                            }
	                        } else {
	                            if (((c[d >> 2] | 0) == 4 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) == 2 : 0) {
	                                if (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0)break;
	                                if (qy(c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) {
	                                    m = 12;
	                                    break b
	                                } else break
	                            }
	                            if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                                m = 16;
	                                break b
	                            }
	                            if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                                m = 16;
	                                break b
	                            }
	                            if ((c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) != 1) {
	                                m = 16;
	                                break b
	                            }
	                        } while (0);
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 16 >> 2]
	                    }
	                    if ((m | 0) == 6) {
	                        c[f >> 2] = 1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((m | 0) == 12) {
	                        c[f >> 2] = 1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((m | 0) == 16) {
	                        mn(0, 519, 83864, 0);
	                        break
	                    }
	                } else {
	                    c:while (1) {
	                        if (!(c[h >> 2] | 0))break a;
	                        d = c[h >> 2] | 0;
	                        do if ((c[c[h >> 2] >> 2] | 0) == 2) {
	                            if (((c[d + 24 >> 2] | 0) != 0 ? (sy(c[(c[h >> 2] | 0) + 24 >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0) ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0) | 0) != 0 : 0) {
	                                m = 23;
	                                break c
	                            }
	                        } else {
	                            if (((c[d >> 2] | 0) == 4 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) == 2 : 0) {
	                                if (!(c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0))break;
	                                if (sy(c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0) | 0)break;
	                                if (qy(c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0) | 0) {
	                                    m = 30;
	                                    break c
	                                } else break
	                            }
	                            if ((c[c[h >> 2] >> 2] | 0) != 4) {
	                                m = 34;
	                                break c
	                            }
	                            if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                                m = 34;
	                                break c
	                            }
	                            if ((c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) != 1) {
	                                m = 34;
	                                break c
	                            }
	                        } while (0);
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 16 >> 2]
	                    }
	                    if ((m | 0) == 23) {
	                        c[f >> 2] = 1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((m | 0) == 30) {
	                        c[f >> 2] = 1;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    } else if ((m | 0) == 34) {
	                        mn(c[g >> 2] | 0, 519, 83864, 0);
	                        break
	                    }
	                } while (0);
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function Mn(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if (!((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                    if ((c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0)c[n >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2];
	                    if ((((c[n >> 2] | 0) != 0 ? (c[m >> 2] = Mm(c[(c[j >> 2] | 0) + 44 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[n >> 2] | 0) | 0, (c[m >> 2] | 0) == 0) : 0) ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[m >> 2] = Mm(c[(c[j >> 2] | 0) + 48 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[n >> 2] | 0) | 0, (c[m >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0) : 0)c[c[l >> 2] >> 2] = 1;
	                    if ((((c[m >> 2] | 0) == 0 ? (c[m >> 2] = Lm(c[(c[j >> 2] | 0) + 44 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0, (c[m >> 2] | 0) == 0) : 0) ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[m >> 2] = Lm(c[(c[j >> 2] | 0) + 48 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0, (c[m >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0) : 0)c[c[l >> 2] >> 2] = 1;
	                    if (!(c[m >> 2] | 0))jn(c[h >> 2] | 0, c[k >> 2] | 0, 534, 83832, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                    c[g >> 2] = c[m >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[g >> 2] = 0;
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function Nn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!((c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 0 : 0))l = 3;
	                if ((l | 0) == 3 ? (c[(c[g >> 2] | 0) + 48 >> 2] = 10, l = Cb[c[135744 >> 2] & 511]((c[(c[g >> 2] | 0) + 48 >> 2] | 0) * 12 | 0) | 0, c[(c[g >> 2] | 0) + 52 >> 2] = l, (c[(c[g >> 2] | 0) + 52 >> 2] | 0) == 0) : 0) {
	                    ln(c[g >> 2] | 0, 79472);
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 48 >> 2] | 0)) {
	                    c[k >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 52 >> 2] | 0, (c[(c[g >> 2] | 0) + 48 >> 2] << 1) * 12 | 0) | 0;
	                    l = c[g >> 2] | 0;
	                    if (c[k >> 2] | 0) {
	                        d = l + 48 | 0;
	                        c[d >> 2] = c[d >> 2] << 1;
	                        c[(c[g >> 2] | 0) + 52 >> 2] = c[k >> 2];
	                        break
	                    }
	                    ln(l, 85184);
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                c[(c[g >> 2] | 0) + 40 >> 2] = (c[(c[g >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) * 12 | 0);
	                c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) >> 2] = c[h >> 2];
	                c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) + 4 >> 2] = c[j >> 2];
	                do if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 4 : 0) {
	                    if (!(c[(c[h >> 2] | 0) + 52 >> 2] | 0))em(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    if (c[(c[h >> 2] | 0) + 52 >> 2] | 0) {
	                        k = oz(c[(c[h >> 2] | 0) + 52 >> 2] | 0, 0, 0) | 0;
	                        c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) + 8 >> 2] = k;
	                        break
	                    } else {
	                        c[(c[(c[g >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[g >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) + 8 >> 2] = 0;
	                        jn(c[g >> 2] | 0, c[h >> 2] | 0, 1, 85200, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        break
	                    }
	                } while (0);
	                j = (c[g >> 2] | 0) + 44 | 0;
	                g = c[j >> 2] | 0;
	                c[j >> 2] = g + 1;
	                c[f >> 2] = g;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function On(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) < 1) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 44 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) >> 2];
	                c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) >> 2] = 0;
	                c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) + 4 >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) == 4 : 0)pz(c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) + 8 >> 2] | 0);
	                c[(c[(c[e >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) * 12 | 0) + 8 >> 2] = 0;
	                f = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 44 >> 2] | 0) >= 1)c[(c[e >> 2] | 0) + 40 >> 2] = (c[(c[e >> 2] | 0) + 52 >> 2] | 0) + (((c[f + 44 >> 2] | 0) - 1 | 0) * 12 | 0); else c[f + 40 >> 2] = 0;
	                c[d >> 2] = c[(c[e >> 2] | 0) + 44 >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Pn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 1;
	                if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    c[m >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                    c[l >> 2] = c[m >> 2];
	                    a:while (1) {
	                        if (!(c[l >> 2] | 0))break;
	                        switch (c[(c[l >> 2] | 0) + 4 >> 2] | 0) {
	                            case 4:
	                            case 3:
	                            case 7:
	                            case 8:
	                                break;
	                            case 5:
	                            {
	                                if ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                    Xn(c[g >> 2] | 0, c[l >> 2] | 0) | 0;
	                                    c[l >> 2] = c[(c[(c[l >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                                    continue a
	                                }
	                                break
	                            }
	                            default:
	                            {
	                                n = 10;
	                                break a
	                            }
	                        }
	                        c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (c[l >> 2] | 0)continue a;
	                            c[l >> 2] = Yn(c[g >> 2] | 0) | 0;
	                            if (!(c[l >> 2] | 0))continue a;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                        }
	                    }
	                    if ((n | 0) == 10)c[k >> 2] = 0;
	                    c[(c[g >> 2] | 0) + 20 >> 2] = 0;
	                    c[(c[g >> 2] | 0) + 16 >> 2] = 0;
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[(c[g >> 2] | 0) + 24 >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 24 >> 2] = 0
	                    }
	                    c[f >> 2] = c[k >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[f >> 2] = 0;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function Qn(b, d, e, f, g) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                h = i;
	                i = i + 10112 | 0;
	                j = h + 44 | 0;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                t = h + 4 | 0;
	                u = h + 10048 | 0;
	                v = h;
	                w = h + 5048 | 0;
	                x = h + 48 | 0;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 1;
	                if ((c[m >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    y = c[j >> 2] | 0;
	                    i = h;
	                    return y | 0
	                }
	                c[r >> 2] = c[(c[m >> 2] | 0) + 40 >> 2];
	                c[s >> 2] = c[(c[m >> 2] | 0) + 8 >> 2];
	                if (!(c[(c[m >> 2] | 0) + 52 >> 2] | 0))c[p >> 2] = em(c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                if (!(c[(c[m >> 2] | 0) + 52 >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    y = c[j >> 2] | 0;
	                    i = h;
	                    return y | 0
	                }
	                if (!(wz(c[(c[m >> 2] | 0) + 52 >> 2] | 0) | 0)) {
	                    c[j >> 2] = -1;
	                    y = c[j >> 2] | 0;
	                    i = h;
	                    return y | 0
	                }
	                c[(c[k >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 24 >> 2] = 0;
	                c[t >> 2] = oz(c[(c[m >> 2] | 0) + 52 >> 2] | 0, 0, 0) | 0;
	                if (c[t >> 2] | 0) {
	                    c[q >> 2] = c[l >> 2];
	                    a:while (1) {
	                        if (!(c[q >> 2] | 0)) {
	                            z = 31;
	                            break
	                        }
	                        m = c[(c[q >> 2] | 0) + 4 >> 2] | 0;
	                        do if ((m | 0) == 3) {
	                            if (!(ij(c[q >> 2] | 0) | 0)) {
	                                z = 17;
	                                break a
	                            }
	                        } else if ((m | 0) == 1) {
	                            if ((c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                c[v >> 2] = Bh(c[(c[q >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, u, 50) | 0;
	                                if (!(c[v >> 2] | 0)) {
	                                    z = 22;
	                                    break a
	                                }
	                                c[p >> 2] = qz(c[t >> 2] | 0, c[v >> 2] | 0, 0) | 0;
	                                if ((c[v >> 2] | 0) == (u | 0))break;
	                                if ((c[v >> 2] | 0) == (c[(c[q >> 2] | 0) + 8 >> 2] | 0))break;
	                                zb[c[135736 >> 2] & 511](c[v >> 2] | 0);
	                                break
	                            }
	                            c[p >> 2] = qz(c[t >> 2] | 0, c[(c[q >> 2] | 0) + 8 >> 2] | 0, 0) | 0
	                        } else if ((m | 0) == 4) {
	                            z = 18;
	                            break a
	                        } else if (((m | 0) == 5 ? (c[(c[q >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[q >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            Xn(c[k >> 2] | 0, c[q >> 2] | 0) | 0;
	                            c[q >> 2] = c[(c[(c[q >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                            continue a
	                        } while (0);
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (c[q >> 2] | 0)continue a;
	                            c[q >> 2] = Yn(c[k >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0))continue a;
	                            c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                        }
	                    }
	                    if ((z | 0) == 17)c[p >> 2] = 0; else if ((z | 0) == 18)c[p >> 2] = 0; else if ((z | 0) == 22)c[p >> 2] = -1; else if ((z | 0) == 31)c[p >> 2] = qz(c[t >> 2] | 0, 0, 0) | 0;
	                    pz(c[t >> 2] | 0)
	                }
	                if ((c[n >> 2] | 0) != 0 & (c[p >> 2] | 0) != 1 & (c[p >> 2] | 0) != -3) {
	                    do if (c[k >> 2] | 0) {
	                        a[w >> 0] = 0;
	                        fm(w, 5e3, c[r >> 2] | 0, 1);
	                        a[x >> 0] = 0;
	                        Zn(x, 5e3, c[l >> 2] | 0, 1);
	                        n = c[k >> 2] | 0;
	                        t = c[o >> 2] | 0;
	                        if (c[s >> 2] | 0) {
	                            jn(n, t, 504, 84936, c[s >> 2] | 0, w, x);
	                            break
	                        } else {
	                            jn(n, t, 504, 85008, w, x, 0);
	                            break
	                        }
	                    } else {
	                        t = c[k >> 2] | 0;
	                        n = c[o >> 2] | 0;
	                        if (c[s >> 2] | 0) {
	                            jn(t, n, 504, 85072, c[s >> 2] | 0, 0, 0);
	                            break
	                        } else {
	                            jn(t, n, 504, 85120, 0, 0, 0);
	                            break
	                        }
	                    } while (0);
	                    c[p >> 2] = 0
	                }
	                if ((c[p >> 2] | 0) == -3)c[p >> 2] = 1;
	                c[(c[k >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 16 >> 2] = 0;
	                if (c[(c[k >> 2] | 0) + 24 >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + 24 >> 2] | 0);
	                    c[(c[k >> 2] | 0) + 24 >> 2] = 0
	                }
	                c[j >> 2] = c[p >> 2];
	                y = c[j >> 2] | 0;
	                i = h;
	                return y | 0
	            }

	            function Rn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = c[g >> 2];
	                c[j + 4 >> 2] = c[h >> 2];
	                PS(c[f >> 2] | 0, 258, j);
	                i = e;
	                return
	            }

	            function Sn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[e + 16 >> 2] = d;
	                c[k >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                d = c[(c[f >> 2] | 0) + 40 >> 2] | 0;
	                a:do if ((d | 0) == 5 | (d | 0) == 6 | (d | 0) == 10) {
	                    if (((c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[h >> 2] = Kn(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] | 0) | 0, (c[h >> 2] | 0) == 0) : 0) ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) == 1 : 0)c[(c[g >> 2] | 0) + 36 >> 2] = 0;
	                    if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                        c[l >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break a;
	                            c[h >> 2] = Kn(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0, c[(c[l >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            if ((c[h >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) == 1 : 0)c[(c[g >> 2] | 0) + 36 >> 2] = 0;
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                    }
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 10) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                if (!(c[(c[f >> 2] | 0) + 60 >> 2] | 0)) {
	                    mn(c[g >> 2] | 0, 1, 84584, c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                    i = e;
	                    return
	                }
	                if (c[j >> 2] | 0)c[k >> 2] = Lm(c[(c[j >> 2] | 0) + 44 >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) == 0 & (c[j >> 2] | 0) != 0)c[k >> 2] = Lm(c[(c[j >> 2] | 0) + 48 >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0) | 0;
	                if (((c[k >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 14 : 0)c[k >> 2] = Lm(c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    jn(c[g >> 2] | 0, 0, 534, 84640, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0, 0);
	                    i = e;
	                    return
	                }
	                if ((c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 1) {
	                    i = e;
	                    return
	                }
	                jn(c[g >> 2] | 0, 0, 510, 84696, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0, 0);
	                c[(c[g >> 2] | 0) + 36 >> 2] = 0;
	                i = e;
	                return
	            }

	            function Tn(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[e + 8 >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 3) {
	                    i = e;
	                    return
	                }
	                c[h >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = Pm(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) == 1) {
	                    i = e;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 36 >> 2] = 0;
	                i = e;
	                return
	            }

	            function Un(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                d = i;
	                i = i + 16 | 0;
	                c[d + 4 >> 2] = a;
	                c[d >> 2] = b;
	                i = d;
	                return
	            }

	            function Vn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 92 >> 2] & 4 | 0) != 0 : 0) {
	                    b = c[g >> 2] | 0;
	                    if ((c[g >> 2] | 0) < 256) {
	                        if (((!(65 <= (b | 0) & (c[g >> 2] | 0) <= 90) ? !(97 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 122) : 0) ? !(192 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 214) : 0) ? !(216 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 246 | 248 <= (c[g >> 2] | 0)) : 0)h = 24
	                    } else if (!(DQ(b, 199744) | 0))h = 24;
	                    do if ((h | 0) == 24) {
	                        b = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 256)if ((b | 0) == 95 | (c[g >> 2] | 0) == 58)break; else break a;
	                        if (!(19968 <= (b | 0) & (c[g >> 2] | 0) <= 40869 | (c[g >> 2] | 0) == 12295) ? !(12321 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 12329 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58) : 0)break a
	                    } while (0);
	                    c[e >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else h = 3; while (0);
	                do if ((h | 0) == 3) {
	                    if (((((((((((((!((c[g >> 2] | 0) >= 97 & (c[g >> 2] | 0) <= 122) ? !((c[g >> 2] | 0) >= 65 & (c[g >> 2] | 0) <= 90 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58) : 0) ? !((c[g >> 2] | 0) >= 192 & (c[g >> 2] | 0) <= 214) : 0) ? !((c[g >> 2] | 0) >= 216 & (c[g >> 2] | 0) <= 246) : 0) ? !((c[g >> 2] | 0) >= 248 & (c[g >> 2] | 0) <= 767) : 0) ? !((c[g >> 2] | 0) >= 880 & (c[g >> 2] | 0) <= 893) : 0) ? !((c[g >> 2] | 0) >= 895 & (c[g >> 2] | 0) <= 8191) : 0) ? !((c[g >> 2] | 0) >= 8204 & (c[g >> 2] | 0) <= 8205) : 0) ? !((c[g >> 2] | 0) >= 8304 & (c[g >> 2] | 0) <= 8591) : 0) ? !((c[g >> 2] | 0) >= 11264 & (c[g >> 2] | 0) <= 12271) : 0) ? !((c[g >> 2] | 0) >= 12289 & (c[g >> 2] | 0) <= 55295) : 0) ? !((c[g >> 2] | 0) >= 63744 & (c[g >> 2] | 0) <= 64975) : 0) ? !((c[g >> 2] | 0) >= 65008 & (c[g >> 2] | 0) <= 65533) : 0) ? !((c[g >> 2] | 0) >= 65536 & (c[g >> 2] | 0) <= 983039) : 0)break;
	                    c[e >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Wn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 92 >> 2] & 4 | 0) != 0 : 0) {
	                    b = c[g >> 2] | 0;
	                    if ((c[g >> 2] | 0) < 256) {
	                        if (((!(65 <= (b | 0) & (c[g >> 2] | 0) <= 90) ? !(97 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 122) : 0) ? !(192 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 214) : 0) ? !(216 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 246 | 248 <= (c[g >> 2] | 0)) : 0)h = 27
	                    } else if (!(DQ(b, 199744) | 0))h = 27;
	                    do if ((h | 0) == 27) {
	                        if ((c[g >> 2] | 0) >= 256) {
	                            if (19968 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 40869 | (c[g >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 12329)break
	                        }
	                        b = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 256) {
	                            if (48 <= (b | 0) & (c[g >> 2] | 0) <= 57 | (c[g >> 2] | 0) == 46 | (c[g >> 2] | 0) == 45 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58)break
	                        } else {
	                            a = (DQ(b, 200216) | 0) != 0;
	                            if (a | (c[g >> 2] | 0) == 46 | (c[g >> 2] | 0) == 45 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58)break
	                        }
	                        if ((c[g >> 2] | 0) >= 256 ? (DQ(c[g >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        a = c[g >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 256)if ((a | 0) == 183)break; else break a; else if (DQ(a, 200272) | 0)break; else break a
	                    } while (0);
	                    c[e >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else h = 3; while (0);
	                do if ((h | 0) == 3) {
	                    if ((((((((((((((((!((c[g >> 2] | 0) >= 97 & (c[g >> 2] | 0) <= 122) ? !((c[g >> 2] | 0) >= 65 & (c[g >> 2] | 0) <= 90) : 0) ? !((c[g >> 2] | 0) >= 48 & (c[g >> 2] | 0) <= 57 | (c[g >> 2] | 0) == 95 | (c[g >> 2] | 0) == 58 | (c[g >> 2] | 0) == 45 | (c[g >> 2] | 0) == 46 | (c[g >> 2] | 0) == 183) : 0) ? !((c[g >> 2] | 0) >= 192 & (c[g >> 2] | 0) <= 214) : 0) ? !((c[g >> 2] | 0) >= 216 & (c[g >> 2] | 0) <= 246) : 0) ? !((c[g >> 2] | 0) >= 248 & (c[g >> 2] | 0) <= 767) : 0) ? !((c[g >> 2] | 0) >= 768 & (c[g >> 2] | 0) <= 879) : 0) ? !((c[g >> 2] | 0) >= 880 & (c[g >> 2] | 0) <= 893) : 0) ? !((c[g >> 2] | 0) >= 895 & (c[g >> 2] | 0) <= 8191) : 0) ? !((c[g >> 2] | 0) >= 8204 & (c[g >> 2] | 0) <= 8205) : 0) ? !((c[g >> 2] | 0) >= 8255 & (c[g >> 2] | 0) <= 8256) : 0) ? !((c[g >> 2] | 0) >= 8304 & (c[g >> 2] | 0) <= 8591) : 0) ? !((c[g >> 2] | 0) >= 11264 & (c[g >> 2] | 0) <= 12271) : 0) ? !((c[g >> 2] | 0) >= 12289 & (c[g >> 2] | 0) <= 55295) : 0) ? !((c[g >> 2] | 0) >= 63744 & (c[g >> 2] | 0) <= 64975) : 0) ? !((c[g >> 2] | 0) >= 65008 & (c[g >> 2] | 0) <= 65533) : 0) ? !((c[g >> 2] | 0) >= 65536 & (c[g >> 2] | 0) <= 983039) : 0)break;
	                    c[e >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Xn(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) <= 0 ? (c[(c[f >> 2] | 0) + 20 >> 2] = 4, b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 20 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 24 >> 2] = b, (c[(c[f >> 2] | 0) + 24 >> 2] | 0) == 0) : 0) {
	                    ln(c[f >> 2] | 0, 79472);
	                    c[(c[f >> 2] | 0) + 20 >> 2] = 0;
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                do if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[(c[f >> 2] | 0) + 20 >> 2] << 1 << 2) | 0;
	                    b = c[f >> 2] | 0;
	                    if (c[h >> 2] | 0) {
	                        a = b + 20 | 0;
	                        c[a >> 2] = c[a >> 2] << 1;
	                        c[(c[f >> 2] | 0) + 24 >> 2] = c[h >> 2];
	                        break
	                    }
	                    ln(b, 85184);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + (c[(c[f >> 2] | 0) + 16 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 16 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function Yn(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 12 >> 2] = c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + ((c[a + 16 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 12 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[(c[e >> 2] | 0) + 16 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[(c[e >> 2] | 0) + 16 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Zn(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g + 8 | 0;
	                m = g + 4 | 0;
	                n = g;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                if (!(c[k >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if (c[l >> 2] | 0)_T(c[h >> 2] | 0, 79632) | 0;
	                c[m >> 2] = c[k >> 2];
	                a:while (1) {
	                    if (!(c[m >> 2] | 0)) {
	                        o = 30;
	                        break
	                    }
	                    c[n >> 2] = ZT(c[h >> 2] | 0) | 0;
	                    if (((c[j >> 2] | 0) - (c[n >> 2] | 0) | 0) < 50) {
	                        o = 7;
	                        break
	                    }
	                    switch (c[(c[m >> 2] | 0) + 4 >> 2] | 0) {
	                        case 3:
	                        {
	                            if (!(ij(c[m >> 2] | 0) | 0))o = 25;
	                            break
	                        }
	                        case 1:
	                        {
	                            if ((c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                k = (c[j >> 2] | 0) - (c[n >> 2] | 0) | 0;
	                                if ((k | 0) < ((xy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) + 10 | 0)) {
	                                    o = 14;
	                                    break a
	                                }
	                                _T(c[h >> 2] | 0, c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                _T(c[h >> 2] | 0, 79648) | 0
	                            }
	                            if (((c[j >> 2] | 0) - (c[n >> 2] | 0) | 0) < ((xy(c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0) + 10 | 0)) {
	                                o = 19;
	                                break a
	                            }
	                            _T(c[h >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            if (c[(c[m >> 2] | 0) + 24 >> 2] | 0)_T(c[h >> 2] | 0, 80064) | 0;
	                            break
	                        }
	                        case 18:
	                        case 12:
	                        case 11:
	                        case 10:
	                        case 13:
	                        case 21:
	                        case 9:
	                        case 2:
	                        {
	                            _T(c[h >> 2] | 0, 85176) | 0;
	                            if (c[(c[m >> 2] | 0) + 24 >> 2] | 0)_T(c[h >> 2] | 0, 80064) | 0;
	                            break
	                        }
	                        case 5:
	                        case 4:
	                        {
	                            o = 25;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    if ((o | 0) == 25 ? (o = 0, _T(c[h >> 2] | 0, 85168) | 0, (c[(c[m >> 2] | 0) + 24 >> 2] | 0) != 0) : 0)_T(c[h >> 2] | 0, 80064) | 0;
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                if ((o | 0) == 7) {
	                    if (((c[j >> 2] | 0) - (c[n >> 2] | 0) | 0) <= 4) {
	                        i = g;
	                        return
	                    }
	                    if ((a[(c[h >> 2] | 0) + ((c[n >> 2] | 0) - 1) >> 0] | 0) == 46) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79624) | 0;
	                    i = g;
	                    return
	                } else if ((o | 0) == 14) {
	                    if (((c[j >> 2] | 0) - (c[n >> 2] | 0) | 0) <= 4) {
	                        i = g;
	                        return
	                    }
	                    if ((a[(c[h >> 2] | 0) + ((c[n >> 2] | 0) - 1) >> 0] | 0) == 46) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79624) | 0;
	                    i = g;
	                    return
	                } else if ((o | 0) == 19) {
	                    if (((c[j >> 2] | 0) - (c[n >> 2] | 0) | 0) <= 4) {
	                        i = g;
	                        return
	                    }
	                    if ((a[(c[h >> 2] | 0) + ((c[n >> 2] | 0) - 1) >> 0] | 0) == 46) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79624) | 0;
	                    i = g;
	                    return
	                } else if ((o | 0) == 30) {
	                    if (!(c[l >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    _T(c[h >> 2] | 0, 79672) | 0;
	                    i = g;
	                    return
	                }
	            }

	            function _n(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                $n(c[e >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                i = d;
	                return 1
	            }

	            function $n(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 40 | 0;
	                j = g + 36 | 0;
	                k = g + 32 | 0;
	                l = g + 28 | 0;
	                m = g + 24 | 0;
	                n = g + 20 | 0;
	                o = g + 16 | 0;
	                p = g + 12 | 0;
	                q = g + 45 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                t = g;
	                u = g + 44 | 0;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[k >> 2] = f;
	                if (!(c[h >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) {
	                    i = g;
	                    return
	                }
	                c[m >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                if (!(c[m >> 2] | 0)) {
	                    c[o >> 2] = 0;
	                    c[n >> 2] = my(c[k >> 2] | 0) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[(c[j >> 2] | 0) + 36 >> 2] = 0;
	                        i = g;
	                        return
	                    }
	                    c[p >> 2] = c[n >> 2];
	                    a:while (1) {
	                        if (!(d[c[p >> 2] >> 0] | 0))break;
	                        c[o >> 2] = c[p >> 2];
	                        while (1) {
	                            if (d[c[p >> 2] >> 0] | 0) {
	                                do if ((d[c[p >> 2] >> 0] | 0 | 0) == 32)v = 1; else {
	                                    if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        v = 1;
	                                        break
	                                    }
	                                    v = (d[c[p >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                w = v ^ 1
	                            } else w = 0;
	                            x = c[p >> 2] | 0;
	                            if (!w)break;
	                            c[p >> 2] = x + 1
	                        }
	                        a[q >> 0] = a[x >> 0] | 0;
	                        a[c[p >> 2] >> 0] = 0;
	                        c[l >> 2] = Hm(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[o >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            Jn(c[j >> 2] | 0, 0, 536, 84752, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[o >> 2] | 0);
	                            c[(c[j >> 2] | 0) + 36 >> 2] = 0
	                        }
	                        if (!(d[q >> 0] | 0))break;
	                        a[c[p >> 2] >> 0] = a[q >> 0] | 0;
	                        while (1) {
	                            do if ((d[c[p >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[p >> 2] >> 0] | 0 | 0) != 13)continue a
	                            } while (0);
	                            c[p >> 2] = (c[p >> 2] | 0) + 1
	                        }
	                    }
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    i = g;
	                    return
	                }
	                if ((c[(c[m >> 2] | 0) + 40 >> 2] | 0) == 3) {
	                    c[l >> 2] = Hm(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[k >> 2] | 0) | 0;
	                    if (c[l >> 2] | 0) {
	                        i = g;
	                        return
	                    }
	                    jn(c[j >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0, 536, 84808, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0, 0);
	                    c[(c[j >> 2] | 0) + 36 >> 2] = 0;
	                    i = g;
	                    return
	                }
	                if ((c[(c[m >> 2] | 0) + 40 >> 2] | 0) != 4) {
	                    i = g;
	                    return
	                }
	                c[s >> 2] = 0;
	                c[r >> 2] = my(c[k >> 2] | 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    ln(c[j >> 2] | 0, 84864);
	                    c[(c[j >> 2] | 0) + 36 >> 2] = 0;
	                    i = g;
	                    return
	                }
	                c[t >> 2] = c[r >> 2];
	                b:while (1) {
	                    if (!(d[c[t >> 2] >> 0] | 0))break;
	                    c[s >> 2] = c[t >> 2];
	                    while (1) {
	                        if (d[c[t >> 2] >> 0] | 0) {
	                            do if ((d[c[t >> 2] >> 0] | 0 | 0) == 32)y = 1; else {
	                                if (9 <= (d[c[t >> 2] >> 0] | 0 | 0) ? (d[c[t >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    y = 1;
	                                    break
	                                }
	                                y = (d[c[t >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            z = y ^ 1
	                        } else z = 0;
	                        A = c[t >> 2] | 0;
	                        if (!z)break;
	                        c[t >> 2] = A + 1
	                    }
	                    a[u >> 0] = a[A >> 0] | 0;
	                    a[c[t >> 2] >> 0] = 0;
	                    c[l >> 2] = Hm(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[s >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        jn(c[j >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0, 536, 84880, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[s >> 2] | 0, 0);
	                        c[(c[j >> 2] | 0) + 36 >> 2] = 0
	                    }
	                    if (!(d[u >> 0] | 0))break;
	                    a[c[t >> 2] >> 0] = a[u >> 0] | 0;
	                    while (1) {
	                        do if ((d[c[t >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[t >> 2] >> 0] | 0 | 0) ? (d[c[t >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[t >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        c[t >> 2] = (c[t >> 2] | 0) + 1
	                    }
	                }
	                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                i = g;
	                return
	            }

	            function ao() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = 0;
	                if (c[21466] | 0) {
	                    i = a;
	                    return
	                }
	                c[b >> 2] = 0;
	                while (1) {
	                    if ((c[b >> 2] | 0) >= 100)break;
	                    c[85872 + (c[b >> 2] << 2) >> 2] = 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                c[b >> 2] = 0;
	                a:while (1) {
	                    if (!((c[b >> 2] | 0) < 99 ? (c[86272 + (c[d >> 2] << 2) >> 2] | 0) != 0 : 0))break;
	                    e = 86272 + (c[d >> 2] << 2) | 0;
	                    f = c[b >> 2] | 0;
	                    c[b >> 2] = f + 1;
	                    c[85872 + (f << 2) >> 2] = e;
	                    while (1) {
	                        e = (c[86272 + (c[d >> 2] << 2) >> 2] | 0) != 0;
	                        c[d >> 2] = (c[d >> 2] | 0) + 1;
	                        if (!e)continue a
	                    }
	                }
	                c[21466] = 1;
	                i = a;
	                return
	            }

	            function bo(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                while (1) {
	                    if ((c[f >> 2] | 0) >>> 0 >= 92) {
	                        g = 6;
	                        break
	                    }
	                    a = (ty(c[e >> 2] | 0, c[87848 + ((c[f >> 2] | 0) * 36 | 0) >> 2] | 0) | 0) != 0;
	                    h = c[f >> 2] | 0;
	                    if (!a) {
	                        g = 4;
	                        break
	                    }
	                    c[f >> 2] = h + 1
	                }
	                if ((g | 0) == 4) {
	                    c[d >> 2] = 87848 + (h * 36 | 0);
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else if ((g | 0) == 6) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function co(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                while (1) {
	                    if ((c[f >> 2] | 0) >>> 0 >= 253) {
	                        g = 6;
	                        break
	                    }
	                    a = (qy(c[e >> 2] | 0, c[91164 + ((c[f >> 2] | 0) * 12 | 0) >> 2] | 0) | 0) != 0;
	                    h = c[f >> 2] | 0;
	                    if (a) {
	                        g = 4;
	                        break
	                    }
	                    c[f >> 2] = h + 1
	                }
	                if ((g | 0) == 4) {
	                    c[d >> 2] = 91160 + (h * 12 | 0);
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else if ((g | 0) == 6) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function eo(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                while (1) {
	                    if ((c[f >> 2] | 0) >>> 0 >= 253)break;
	                    g = c[f >> 2] | 0;
	                    if ((c[91160 + ((c[f >> 2] | 0) * 12 | 0) >> 2] | 0) >>> 0 >= (c[e >> 2] | 0) >>> 0) {
	                        h = 4;
	                        break
	                    }
	                    c[f >> 2] = g + 1
	                }
	                if ((h | 0) == 4 ? (c[91160 + (g * 12 | 0) >> 2] | 0) >>> 0 <= (c[e >> 2] | 0) >>> 0 : 0) {
	                    c[d >> 2] = 91160 + ((c[f >> 2] | 0) * 12 | 0);
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[d >> 2] = 0;
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function fo(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                h = i;
	                i = i + 96 | 0;
	                j = h;
	                k = h + 64 | 0;
	                l = h + 60 | 0;
	                m = h + 56 | 0;
	                n = h + 52 | 0;
	                o = h + 48 | 0;
	                p = h + 44 | 0;
	                q = h + 40 | 0;
	                r = h + 36 | 0;
	                s = h + 32 | 0;
	                t = h + 28 | 0;
	                u = h + 24 | 0;
	                v = h + 20 | 0;
	                w = h + 16 | 0;
	                x = h + 12 | 0;
	                y = h + 8 | 0;
	                z = h + 4 | 0;
	                A = h + 72 | 0;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = c[n >> 2];
	                c[r >> 2] = c[l >> 2];
	                c[s >> 2] = c[n >> 2];
	                if ((c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0) {
	                    c[k >> 2] = -1;
	                    B = c[k >> 2] | 0;
	                    i = h;
	                    return B | 0
	                }
	                if (!(c[n >> 2] | 0)) {
	                    c[c[m >> 2] >> 2] = 0;
	                    c[c[o >> 2] >> 2] = 0;
	                    c[k >> 2] = 0;
	                    B = c[k >> 2] | 0;
	                    i = h;
	                    return B | 0
	                }
	                c[t >> 2] = (c[n >> 2] | 0) + (c[c[o >> 2] >> 2] | 0);
	                c[q >> 2] = (c[l >> 2] | 0) + (c[c[m >> 2] >> 2] | 0);
	                a:while (1) {
	                    if ((c[n >> 2] | 0) >>> 0 >= (c[t >> 2] | 0) >>> 0) {
	                        C = 32;
	                        break
	                    }
	                    g = c[n >> 2] | 0;
	                    c[n >> 2] = g + 1;
	                    c[v >> 2] = d[g >> 0];
	                    g = c[v >> 2] | 0;
	                    do if ((c[v >> 2] | 0) >>> 0 < 128) {
	                        c[u >> 2] = g;
	                        c[w >> 2] = 0
	                    } else {
	                        if (g >>> 0 < 192) {
	                            C = 10;
	                            break a
	                        }
	                        f = c[v >> 2] | 0;
	                        if ((c[v >> 2] | 0) >>> 0 < 224) {
	                            c[u >> 2] = f & 31;
	                            c[w >> 2] = 1;
	                            break
	                        }
	                        e = c[v >> 2] | 0;
	                        if (f >>> 0 < 240) {
	                            c[u >> 2] = e & 15;
	                            c[w >> 2] = 2;
	                            break
	                        }
	                        if (e >>> 0 >= 248) {
	                            C = 17;
	                            break a
	                        }
	                        c[u >> 2] = c[v >> 2] & 7;
	                        c[w >> 2] = 3
	                    } while (0);
	                    if (((c[t >> 2] | 0) - (c[n >> 2] | 0) | 0) < (c[w >> 2] | 0)) {
	                        C = 32;
	                        break
	                    }
	                    while (1) {
	                        if (!(c[w >> 2] | 0))break;
	                        if ((c[n >> 2] | 0) >>> 0 >= (c[t >> 2] | 0) >>> 0)break;
	                        g = c[n >> 2] | 0;
	                        c[n >> 2] = g + 1;
	                        e = d[g >> 0] | 0;
	                        c[v >> 2] = e;
	                        if ((e & 192 | 0) != 128)break;
	                        c[u >> 2] = c[u >> 2] << 6;
	                        c[u >> 2] = c[u >> 2] | c[v >> 2] & 63;
	                        c[w >> 2] = (c[w >> 2] | 0) + -1
	                    }
	                    if ((c[u >> 2] | 0) >>> 0 < 128) {
	                        if (((c[l >> 2] | 0) + 1 | 0) >>> 0 >= (c[q >> 2] | 0) >>> 0) {
	                            C = 32;
	                            break
	                        }
	                        e = c[u >> 2] & 255;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = e
	                    } else {
	                        c[y >> 2] = eo(c[u >> 2] | 0) | 0;
	                        if (!(c[y >> 2] | 0)) {
	                            c[j >> 2] = c[u >> 2];
	                            JT(A, 16, 94200, j) | 0;
	                            c[z >> 2] = A
	                        } else c[z >> 2] = c[(c[y >> 2] | 0) + 4 >> 2];
	                        c[x >> 2] = ZT(c[z >> 2] | 0) | 0;
	                        if (((c[l >> 2] | 0) + 2 + (c[x >> 2] | 0) | 0) >>> 0 >= (c[q >> 2] | 0) >>> 0) {
	                            C = 32;
	                            break
	                        }
	                        e = c[l >> 2] | 0;
	                        c[l >> 2] = e + 1;
	                        a[e >> 0] = 38;
	                        eU(c[l >> 2] | 0, c[z >> 2] | 0, c[x >> 2] | 0) | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + (c[x >> 2] | 0);
	                        e = c[l >> 2] | 0;
	                        c[l >> 2] = e + 1;
	                        a[e >> 0] = 59
	                    }
	                    c[p >> 2] = c[n >> 2]
	                }
	                if ((C | 0) == 10) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[r >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[p >> 2] | 0) - (c[s >> 2] | 0);
	                    c[k >> 2] = -2;
	                    B = c[k >> 2] | 0;
	                    i = h;
	                    return B | 0
	                } else if ((C | 0) == 17) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[r >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[p >> 2] | 0) - (c[s >> 2] | 0);
	                    c[k >> 2] = -2;
	                    B = c[k >> 2] | 0;
	                    i = h;
	                    return B | 0
	                } else if ((C | 0) == 32) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[r >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[p >> 2] | 0) - (c[s >> 2] | 0);
	                    c[k >> 2] = 0;
	                    B = c[k >> 2] | 0;
	                    i = h;
	                    return B | 0
	                }
	                return 0
	            }

	            function go(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](96) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    xo(0, 94208);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 96 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[(c[h >> 2] | 0) + 4 >> 2] = 13;
	                c[(c[h >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 44 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 32 >> 2] = c[h >> 2];
	                c[(c[h >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 48 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 52 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 40 >> 2] = 1;
	                c[(c[h >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 68 >> 2] = 0;
	                c[c[h >> 2] >> 2] = 0;
	                c[(c[h >> 2] | 0) + 76 >> 2] = 1;
	                c[(c[h >> 2] | 0) + 92 >> 2] = 160;
	                if ((c[g >> 2] | 0) != 0 | (c[f >> 2] | 0) != 0)Oh(c[h >> 2] | 0, 94240, c[g >> 2] | 0, c[f >> 2] | 0) | 0;
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function ho(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[k >> 2] = 0;
	                if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = 0;
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    do if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 38) {
	                        me(c[g >> 2] | 0);
	                        c[j >> 2] = yo(c[g >> 2] | 0) | 0;
	                        b = c[g >> 2] | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            zo(b, 68, 94336, 0, 0);
	                            break
	                        }
	                        if ((c[b + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                        if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 59) {
	                            zo(c[g >> 2] | 0, 23, 94368, 0, 0);
	                            if (!(c[h >> 2] | 0))break;
	                            c[c[h >> 2] >> 2] = c[j >> 2];
	                            break
	                        }
	                        if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = c[j >> 2];
	                        c[k >> 2] = co(c[j >> 2] | 0) | 0;
	                        if (c[k >> 2] | 0)me(c[g >> 2] | 0)
	                    } while (0);
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function io(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    do if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 38 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) {
	                        if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 120 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 88 : 0) {
	                            h = 23;
	                            break
	                        }
	                        a = (c[f >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 3;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 3;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 3;
	                        a:while (1) {
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 59)break;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 57 : 0)c[g >> 2] = (c[g >> 2] << 4) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 48); else h = 13;
	                            do if ((h | 0) == 13) {
	                                h = 0;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 102 : 0) {
	                                    c[g >> 2] = (c[g >> 2] << 4) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 97) + 10;
	                                    break
	                                }
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) < 65) {
	                                    h = 19;
	                                    break a
	                                }
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) > 70) {
	                                    h = 19;
	                                    break a
	                                }
	                                c[g >> 2] = (c[g >> 2] << 4) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 65) + 10
	                            } while (0);
	                            me(c[f >> 2] | 0)
	                        }
	                        if ((h | 0) == 19)zo(c[f >> 2] | 0, 6, 94448, 0, 0);
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 59)me(c[f >> 2] | 0)
	                    } else h = 23; while (0);
	                    do if ((h | 0) == 23) {
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 38 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 35 : 0) {
	                            a = (c[f >> 2] | 0) + 200 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 2;
	                            a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 2;
	                            a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 2;
	                            while (1) {
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 59)break;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) < 48) {
	                                    h = 30;
	                                    break
	                                }
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) > 57) {
	                                    h = 30;
	                                    break
	                                }
	                                c[g >> 2] = ((c[g >> 2] | 0) * 10 | 0) + ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) - 48);
	                                me(c[f >> 2] | 0)
	                            }
	                            if ((h | 0) == 30)zo(c[f >> 2] | 0, 7, 94448, 0, 0);
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 59)break;
	                            me(c[f >> 2] | 0);
	                            break
	                        }
	                        zo(c[f >> 2] | 0, 8, 94488, 0, 0)
	                    } while (0);
	                    a = c[g >> 2] | 0;
	                    if ((c[g >> 2] | 0) < 256)if (9 <= (a | 0) & (c[g >> 2] | 0) <= 10 | (c[g >> 2] | 0) == 13 | 32 <= (c[g >> 2] | 0))h = 39; else h = 40; else if ((!(256 <= (a | 0) & (c[g >> 2] | 0) <= 55295) ? !(57344 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[g >> 2] | 0) & (c[g >> 2] | 0) <= 1114111) : 0)h = 40; else h = 39;
	                    if ((h | 0) == 39) {
	                        c[e >> 2] = c[g >> 2];
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } else if ((h | 0) == 40) {
	                        Ao(c[f >> 2] | 0, 9, 94528, c[g >> 2] | 0);
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                }
	                zo(c[f >> 2] | 0, 1, 94408, 0, 0);
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function jo(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                Eo(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function ko(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 16 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                Rf();
	                rQ();
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    c[(c[g >> 2] | 0) + 32 >> 2] = 1;
	                    c[(c[g >> 2] | 0) + 280 >> 2] = 1;
	                    if ((c[(c[g >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[g >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)Ab[c[(c[c[g >> 2] >> 2] | 0) + 44 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, 136080);
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) == 0 ? ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 4 : 0) {
	                        if (c[(c[g >> 2] | 0) + 176 >> 2] | 0)l = -1; else l = d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                        a[h >> 0] = l;
	                        a[h + 1 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                        a[h + 2 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0;
	                        a[h + 3 >> 0] = a[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0;
	                        c[j >> 2] = sd(h, 4) | 0;
	                        if (c[j >> 2] | 0)re(c[g >> 2] | 0, c[j >> 2] | 0) | 0
	                    }
	                    Fo(c[g >> 2] | 0) | 0;
	                    if (!(d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))zo(c[g >> 2] | 0, 4, 94672, 0, 0);
	                    if (((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 48 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                    while (1) {
	                        if ((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0)m = 1; else if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60)m = (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63; else m = 0;
	                        n = c[g >> 2] | 0;
	                        if (!m)break;
	                        Go(n);
	                        Ho(c[g >> 2] | 0);
	                        Fo(c[g >> 2] | 0) | 0
	                    }
	                    if (((((((((d[c[(c[n + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) == 68 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) == 79 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) == 67 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) == 84 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0) | 0) == 89 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0) | 0) == 80 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0) | 0) == 69 : 0)Io(c[g >> 2] | 0);
	                    Fo(c[g >> 2] | 0) | 0;
	                    while (1) {
	                        if ((((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0)o = 1; else if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60)o = (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63; else o = 0;
	                        p = c[g >> 2] | 0;
	                        if (!o)break;
	                        Go(p);
	                        Ho(c[g >> 2] | 0);
	                        Fo(c[g >> 2] | 0) | 0
	                    }
	                    Eo(p);
	                    if (!(d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))Do(c[g >> 2] | 0);
	                    if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                    if (((c[(c[g >> 2] | 0) + 360 >> 2] & 4 | 0) == 0 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[k >> 2] = Nh(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0, (c[k >> 2] | 0) == 0) : 0) {
	                        k = Oh(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 94240, 94296, 94248) | 0;
	                        c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] = k
	                    }
	                    if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    } else {
	                        c[f >> 2] = -1;
	                        q = c[f >> 2] | 0;
	                        i = e;
	                        return q | 0
	                    }
	                }
	                zo(c[g >> 2] | 0, 1, 94632, 0, 0);
	                c[f >> 2] = 1;
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function lo(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Ae(c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function mo() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](472) | 0;
	                do if (c[d >> 2] | 0) {
	                    cU(c[d >> 2] | 0, 0, 472) | 0;
	                    e = (Jo(c[d >> 2] | 0) | 0) < 0;
	                    f = c[d >> 2] | 0;
	                    if (e) {
	                        lo(f);
	                        c[b >> 2] = 0;
	                        break
	                    } else {
	                        c[b >> 2] = f;
	                        break
	                    }
	                } else {
	                    xo(0, 94696);
	                    c[b >> 2] = 0
	                } while (0);
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function no(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    if ((c[g >> 2] | 0) <= 0) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[h >> 2] = mo() | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[k >> 2] = Hk(c[f >> 2] | 0, c[g >> 2] | 0, 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[j >> 2] = ue(c[h >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        Ae(c[h >> 2] | 0);
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[(c[j >> 2] | 0) + 4 >> 2] = 0;
	                        c[c[j >> 2] >> 2] = c[k >> 2];
	                        iz(c[(c[k >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        Oe(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[e >> 2] = c[h >> 2];
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function oo(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 44 | 0;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 8 | 0;
	                r = f + 4 | 0;
	                s = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    do if ((((c[k >> 2] | 0) > 0 & (c[j >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[h >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) != -1 : 0) {
	                        c[m >> 2] = jz(c[(c[c[(c[h >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[n >> 2] = (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                        c[o >> 2] = Lk(c[c[(c[h >> 2] | 0) + 36 >> 2] >> 2] | 0, c[k >> 2] | 0, c[j >> 2] | 0) | 0;
	                        e = c[h >> 2] | 0;
	                        if ((c[o >> 2] | 0) >= 0) {
	                            kz(c[(c[c[e + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                            break
	                        }
	                        c[e + 84 >> 2] = -1;
	                        c[(c[h >> 2] | 0) + 212 >> 2] = 1;
	                        c[g >> 2] = -1;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    } else u = 11; while (0);
	                    do if (((((((u | 0) == 11 ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) != -1 : 0) ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[h >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) ? (c[p >> 2] = c[c[(c[h >> 2] | 0) + 36 >> 2] >> 2], (c[(c[p >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) ? (c[(c[p >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[p >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                        c[r >> 2] = jz(c[(c[p >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0) | 0;
	                        c[s >> 2] = (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                        c[q >> 2] = Fd(c[p >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[q >> 2] | 0) >= 0) {
	                            kz(c[(c[p >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0) | 0;
	                            break
	                        }
	                        zo(c[h >> 2] | 0, 81, 94760, 0, 0);
	                        c[g >> 2] = 81;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    } while (0);
	                    Ko(c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                    if (c[l >> 2] | 0) {
	                        if (((c[(c[h >> 2] | 0) + 172 >> 2] | 0) != -1 ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) != 14 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) != 1 : 0) {
	                            c[(c[h >> 2] | 0) + 84 >> 2] = 5;
	                            c[(c[h >> 2] | 0) + 12 >> 2] = 0
	                        }
	                        if (((c[(c[h >> 2] | 0) + 172 >> 2] | 0) != -1 ? (c[c[h >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[h >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zb[c[(c[c[h >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 172 >> 2] = -1
	                    }
	                    c[g >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                    t = c[g >> 2] | 0;
	                    i = f;
	                    return t | 0
	                }
	                zo(c[h >> 2] | 0, 1, 94728, 0, 0);
	                c[g >> 2] = 1;
	                t = c[g >> 2] | 0;
	                i = f;
	                return t | 0
	            }

	            function po(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 44 | 0;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                t = h + 4 | 0;
	                u = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                Rf();
	                c[s >> 2] = vk(c[p >> 2] | 0) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    c[j >> 2] = 0;
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                c[q >> 2] = mo() | 0;
	                if (!(c[q >> 2] | 0)) {
	                    yk(c[s >> 2] | 0);
	                    c[j >> 2] = 0;
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                if (!((c[p >> 2] | 0) != 1 ? (c[(c[s >> 2] | 0) + 12 >> 2] | 0) == 0 : 0))c[(c[q >> 2] | 0) + 256 >> 2] = 1;
	                do if (c[k >> 2] | 0) {
	                    if ((c[c[q >> 2] >> 2] | 0) != 136096)zb[c[135736 >> 2] & 511](c[c[q >> 2] >> 2] | 0);
	                    p = Cb[c[135744 >> 2] & 511](128) | 0;
	                    c[c[q >> 2] >> 2] = p;
	                    if (!(c[c[q >> 2] >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        c[j >> 2] = 0;
	                        v = c[j >> 2] | 0;
	                        i = h;
	                        return v | 0
	                    } else {
	                        p = (c[c[q >> 2] >> 2] | 0) + 0 | 0;
	                        g = (c[k >> 2] | 0) + 0 | 0;
	                        f = p + 128 | 0;
	                        do {
	                            c[p >> 2] = c[g >> 2];
	                            p = p + 4 | 0;
	                            g = g + 4 | 0
	                        } while ((p | 0) < (f | 0));
	                        if (!(c[l >> 2] | 0))break;
	                        c[(c[q >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                        break
	                    }
	                } while (0);
	                if (!(c[o >> 2] | 0))c[(c[q >> 2] | 0) + 180 >> 2] = 0; else {
	                    l = Rk(c[o >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 180 >> 2] = l
	                }
	                c[r >> 2] = Lo(c[q >> 2] | 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    Ae(c[q >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                    c[j >> 2] = 0;
	                    v = c[j >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                if (!(c[o >> 2] | 0))c[(c[r >> 2] | 0) + 4 >> 2] = 0; else {
	                    l = Jl(c[o >> 2] | 0) | 0;
	                    c[(c[r >> 2] | 0) + 4 >> 2] = l
	                }
	                c[c[r >> 2] >> 2] = c[s >> 2];
	                iz(c[(c[s >> 2] | 0) + 16 >> 2] | 0, c[r >> 2] | 0) | 0;
	                Oe(c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                if (((c[n >> 2] | 0) > 0 & (c[m >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[c[(c[q >> 2] | 0) + 36 >> 2] >> 2] | 0) != 0 : 0) {
	                    c[t >> 2] = jz(c[(c[c[(c[q >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[q >> 2] | 0) + 36 >> 2] | 0) | 0;
	                    c[u >> 2] = (c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                    Lk(c[c[(c[q >> 2] | 0) + 36 >> 2] >> 2] | 0, c[n >> 2] | 0, c[m >> 2] | 0) | 0;
	                    kz(c[(c[c[(c[q >> 2] | 0) + 36 >> 2] >> 2] | 0) + 16 >> 2] | 0, c[(c[q >> 2] | 0) + 36 >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0) | 0
	                }
	                c[(c[q >> 2] | 0) + 292 >> 2] = 1;
	                c[j >> 2] = c[q >> 2];
	                v = c[j >> 2] | 0;
	                i = h;
	                return v | 0
	            }

	            function qo(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                o = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[n >> 2] = 94776;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                c[j >> 2] = mo() | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                c[l >> 2] = Jl(c[g >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    if (c[34014] | 0)Db[c[135968 + 88 >> 2] & 511](0, 94792, e);
	                    Ae(c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                c[k >> 2] = Vk(c[l >> 2] | 0, 0, c[j >> 2] | 0) | 0;
	                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                l = c[j >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    Ae(l);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                Oe(l, c[k >> 2] | 0) | 0;
	                if (((c[h >> 2] | 0) != 0 ? (c[o >> 2] = ZT(c[h >> 2] | 0) | 0, (c[o >> 2] | 0) >>> 0 < 1e3) : 0) ? (k = c[33938] | 0, l = xy(c[n >> 2] | 0) | 0, c[m >> 2] = Cb[k & 511](l + (c[o >> 2] | 0) + 1 | 0) | 0, (c[m >> 2] | 0) != 0) : 0) {
	                    gU(c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    _T(c[m >> 2] | 0, c[h >> 2] | 0) | 0;
	                    Mo(c[j >> 2] | 0, c[m >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                }
	                c[f >> 2] = c[j >> 2];
	                p = c[f >> 2] | 0;
	                i = d;
	                return p | 0
	            }

	            function ro(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[o >> 2] = 0;
	                Rf();
	                c[n >> 2] = qo(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (c[k >> 2] | 0) {
	                    c[o >> 2] = c[c[n >> 2] >> 2];
	                    c[c[n >> 2] >> 2] = c[k >> 2];
	                    c[(c[n >> 2] | 0) + 4 >> 2] = c[l >> 2]
	                }
	                ko(c[n >> 2] | 0) | 0;
	                c[m >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                if (c[k >> 2] | 0) {
	                    c[c[n >> 2] >> 2] = c[o >> 2];
	                    c[(c[n >> 2] | 0) + 4 >> 2] = 0
	                }
	                lo(c[n >> 2] | 0);
	                c[g >> 2] = c[m >> 2];
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function so(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = ro(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function to(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if (c[g >> 2] & 64) {
	                    c[(c[c[f >> 2] >> 2] | 0) + 84 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 116 >> 2] = 0;
	                    c[g >> 2] = (c[g >> 2] | 0) - 64;
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 64
	                }
	                if (c[g >> 2] & 32) {
	                    c[(c[c[f >> 2] >> 2] | 0) + 88 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 112 >> 2] = 0;
	                    c[(c[c[f >> 2] >> 2] | 0) + 92 >> 2] = 0;
	                    c[g >> 2] = (c[g >> 2] | 0) - 32;
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 32
	                }
	                b = (c[f >> 2] | 0) + 268 | 0;
	                if (c[g >> 2] & 128) {
	                    c[b >> 2] = 1;
	                    c[g >> 2] = (c[g >> 2] | 0) - 128;
	                    a = (c[f >> 2] | 0) + 360 | 0;
	                    c[a >> 2] = c[a >> 2] | 128
	                } else c[b >> 2] = 0;
	                b = (c[f >> 2] | 0) + 208 | 0;
	                if (c[g >> 2] & 256) {
	                    c[b >> 2] = 0;
	                    c[(c[c[f >> 2] >> 2] | 0) + 72 >> 2] = 65;
	                    c[g >> 2] = (c[g >> 2] | 0) - 256;
	                    a = (c[f >> 2] | 0) + 360 | 0;
	                    c[a >> 2] = c[a >> 2] | 256
	                } else c[b >> 2] = 1;
	                b = (c[f >> 2] | 0) + 288 | 0;
	                if (c[g >> 2] & 1) {
	                    c[b >> 2] = 1;
	                    c[g >> 2] = (c[g >> 2] | 0) - 1
	                } else c[b >> 2] = 0;
	                if (c[g >> 2] & 65536) {
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 65536;
	                    c[g >> 2] = (c[g >> 2] | 0) - 65536
	                }
	                if (c[g >> 2] & 524288) {
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 524288;
	                    c[g >> 2] = (c[g >> 2] | 0) - 524288
	                }
	                if (c[g >> 2] & 4) {
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 4;
	                    c[g >> 2] = (c[g >> 2] | 0) - 4
	                }
	                if (c[g >> 2] & 2097152) {
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 2097152;
	                    c[g >> 2] = (c[g >> 2] | 0) - 2097152
	                }
	                if (c[g >> 2] & 8192) {
	                    b = (c[f >> 2] | 0) + 360 | 0;
	                    c[b >> 2] = c[b >> 2] | 8192;
	                    c[g >> 2] = (c[g >> 2] | 0) - 8192
	                }
	                c[(c[f >> 2] | 0) + 364 >> 2] = 0;
	                c[e >> 2] = c[g >> 2];
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function uo(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                Rf();
	                c[k >> 2] = qo(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = No(c[k >> 2] | 0, 0, 0, c[j >> 2] | 0, 0) | 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function vo(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                Rf();
	                c[o >> 2] = Zf(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                rQ();
	                if (c[c[o >> 2] >> 2] | 0) {
	                    k = (c[c[o >> 2] >> 2] | 0) + 0 | 0;
	                    j = 136096 | 0;
	                    f = k + 112 | 0;
	                    do {
	                        c[k >> 2] = c[j >> 2];
	                        k = k + 4 | 0;
	                        j = j + 4 | 0
	                    } while ((k | 0) < (f | 0))
	                }
	                c[h >> 2] = No(c[o >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function wo(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                if (!(c[21466] | 0))ao();
	                c[j >> 2] = 0;
	                while (1) {
	                    if ((c[j >> 2] | 0) >= 100)break;
	                    c[k >> 2] = c[85872 + (c[j >> 2] << 2) >> 2];
	                    if (!(c[k >> 2] | 0)) {
	                        l = 6;
	                        break
	                    }
	                    if (qy(c[c[k >> 2] >> 2] | 0, c[f >> 2] | 0) | 0)break;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((l | 0) == 6) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[h >> 2] = ((c[k >> 2] | 0) - 86272 | 0) / 4 | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + 1;
	                while (1) {
	                    if (!(c[86272 + (c[h >> 2] << 2) >> 2] | 0)) {
	                        l = 14;
	                        break
	                    }
	                    if (qy(c[86272 + (c[h >> 2] << 2) >> 2] | 0, c[g >> 2] | 0) | 0) {
	                        l = 12;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((l | 0) == 12) {
	                    c[e >> 2] = 1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((l | 0) == 14) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function xo(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = d;
	                    return
	                }
	                if (c[f >> 2] | 0) {
	                    c[(c[f >> 2] | 0) + 84 >> 2] = 2;
	                    c[(c[f >> 2] | 0) + 172 >> 2] = -1;
	                    c[(c[f >> 2] | 0) + 212 >> 2] = 1
	                }
	                b = c[f >> 2] | 0;
	                if (c[g >> 2] | 0) {
	                    f = c[g >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Xd(0, 0, 0, b, 0, 1, 2, 3, 0, 0, f, 0, 0, 0, 0, 98040, e);
	                    i = d;
	                    return
	                } else {
	                    Xd(0, 0, 0, b, 0, 1, 2, 3, 0, 0, 0, 0, 0, 0, 0, 98072, e);
	                    i = d;
	                    return
	                }
	            }

	            function yo(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                c[g >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)k = 10; else k = 6;
	                do if ((k | 0) == 6) {
	                    if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                        k = 10;
	                        break
	                    }
	                    if (!((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0))k = 10
	                } while (0);
	                if ((k | 0) == 10) {
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    while (1) {
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) >= 97 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 122 : 0)l = 1; else k = 13;
	                        do if ((k | 0) == 13) {
	                            k = 0;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                                l = 1;
	                                break
	                            }
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[g >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                                l = 1;
	                                break
	                            }
	                            if (((d[c[g >> 2] >> 0] | 0 | 0) != 95 ? (d[c[g >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[g >> 2] >> 0] | 0 | 0) != 58 : 0)l = (d[c[g >> 2] >> 0] | 0 | 0) == 46; else l = 1
	                        } while (0);
	                        m = c[g >> 2] | 0;
	                        if (!l)break;
	                        c[g >> 2] = m + 1
	                    }
	                    if ((d[m >> 0] | 0 | 0) > 0 ? (d[c[g >> 2] >> 0] | 0 | 0) < 128 : 0) {
	                        c[j >> 2] = (c[g >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
	                        c[h >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                        g = (c[f >> 2] | 0) + 200 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[j >> 2] | 0);
	                        g = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[j >> 2] | 0);
	                        c[e >> 2] = c[h >> 2];
	                        n = c[e >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                }
	                c[e >> 2] = Oo(c[f >> 2] | 0) | 0;
	                n = c[e >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function zo(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                f = c[j >> 2] | 0;
	                e = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                d = c[n >> 2] | 0;
	                b = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(0, 0, 0, f, 0, 5, e, 2, 0, 0, k, d, 0, 0, 0, b, h);
	                if (!(c[j >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[(c[j >> 2] | 0) + 12 >> 2] = 0;
	                i = g;
	                return
	            }

	            function Ao(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = f;
	                    return
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                e = c[h >> 2] | 0;
	                d = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                b = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, 0, 5, d, 2, 0, 0, 0, 0, 0, j, 0, b, g);
	                if (!(c[h >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[h >> 2] | 0) + 12 >> 2] = 0;
	                i = f;
	                return
	            }

	            function Bo(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                b = i;
	                i = i + 64 | 0;
	                e = b + 52 | 0;
	                f = b + 48 | 0;
	                g = b + 44 | 0;
	                h = b + 40 | 0;
	                j = b + 36 | 0;
	                k = b + 32 | 0;
	                l = b + 28 | 0;
	                m = b + 24 | 0;
	                n = b + 20 | 0;
	                o = b + 16 | 0;
	                p = b + 12 | 0;
	                q = b + 8 | 0;
	                r = b + 4 | 0;
	                s = b;
	                c[f >> 2] = a;
	                c[l >> 2] = 0;
	                c[n >> 2] = 0;
	                c[p >> 2] = 0;
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = b;
	                        return t | 0
	                    }
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 60) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = b;
	                        return t | 0
	                    }
	                    me(c[f >> 2] | 0);
	                    c[k >> 2] = c[(c[f >> 2] | 0) + 300 >> 2];
	                    c[m >> 2] = c[(c[f >> 2] | 0) + 304 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    c[g >> 2] = Po(c[f >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        zo(c[f >> 2] | 0, 68, 97520, 0, 0);
	                        while (1) {
	                            if (!(9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))u = 15;
	                            if (((u | 0) == 15 ? (u = 0, (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) : 0) ? 32 > (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)break;
	                            if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break;
	                            if ((c[(c[f >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                            me(c[f >> 2] | 0)
	                        }
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = b;
	                        return t | 0
	                    }
	                    if (qy(c[g >> 2] | 0, 96200) | 0)c[n >> 2] = 1;
	                    Qo(c[f >> 2] | 0, c[g >> 2] | 0);
	                    Ro(c[f >> 2] | 0, c[g >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 188 >> 2] | 0) > 0 ? (qy(c[g >> 2] | 0, 94240) | 0) != 0 : 0) {
	                        zo(c[f >> 2] | 0, 800, 97656, c[g >> 2] | 0, 0);
	                        c[p >> 2] = 1;
	                        a = (c[f >> 2] | 0) + 248 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    if ((c[(c[f >> 2] | 0) + 188 >> 2] | 0) != 1 ? (qy(c[g >> 2] | 0, 95656) | 0) != 0 : 0) {
	                        zo(c[f >> 2] | 0, 800, 97704, c[g >> 2] | 0, 0);
	                        c[p >> 2] = 1;
	                        a = (c[f >> 2] | 0) + 248 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    a:do if (qy(c[g >> 2] | 0, 95648) | 0) {
	                        c[q >> 2] = 0;
	                        while (1) {
	                            if ((c[q >> 2] | 0) >= (c[(c[f >> 2] | 0) + 188 >> 2] | 0))break a;
	                            if (qy(c[(c[(c[f >> 2] | 0) + 196 >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0, 95648) | 0) {
	                                zo(c[f >> 2] | 0, 800, 97752, c[g >> 2] | 0, 0);
	                                c[p >> 2] = 1;
	                                a = (c[f >> 2] | 0) + 248 | 0;
	                                c[a >> 2] = (c[a >> 2] | 0) + 1
	                            }
	                            c[q >> 2] = (c[q >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    Fo(c[f >> 2] | 0) | 0;
	                    while (1) {
	                        if (!(9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))u = 38;
	                        if (((u | 0) == 38 ? (u = 0, (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13) : 0) ? 32 > (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)break;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break;
	                        c[r >> 2] = c[(c[f >> 2] | 0) + 200 >> 2];
	                        if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                        c[h >> 2] = So(c[f >> 2] | 0, j) | 0;
	                        b:do if (c[h >> 2] | 0) {
	                            c[o >> 2] = 0;
	                            while (1) {
	                                if ((c[o >> 2] | 0) >= (c[l >> 2] | 0))break;
	                                if (qy(c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0, c[h >> 2] | 0) | 0) {
	                                    u = 50;
	                                    break
	                                }
	                                c[o >> 2] = (c[o >> 2] | 0) + 2
	                            }
	                            if ((u | 0) == 50) {
	                                u = 0;
	                                zo(c[f >> 2] | 0, 42, 97800, c[h >> 2] | 0, 0);
	                                if (!(c[j >> 2] | 0))break;
	                                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                break
	                            }
	                            do if (!(c[k >> 2] | 0)) {
	                                c[m >> 2] = 22;
	                                c[k >> 2] = Cb[c[135744 >> 2] & 511](c[m >> 2] << 2) | 0;
	                                if (c[k >> 2] | 0) {
	                                    c[(c[f >> 2] | 0) + 300 >> 2] = c[k >> 2];
	                                    c[(c[f >> 2] | 0) + 304 >> 2] = c[m >> 2];
	                                    break
	                                }
	                                xo(c[f >> 2] | 0, 0);
	                                if (!(c[j >> 2] | 0))break b;
	                                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                break b
	                            } else {
	                                if (((c[l >> 2] | 0) + 4 | 0) <= (c[m >> 2] | 0))break;
	                                c[m >> 2] = c[m >> 2] << 1;
	                                c[s >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, c[m >> 2] << 2) | 0;
	                                if (c[s >> 2] | 0) {
	                                    c[k >> 2] = c[s >> 2];
	                                    c[(c[f >> 2] | 0) + 300 >> 2] = c[k >> 2];
	                                    c[(c[f >> 2] | 0) + 304 >> 2] = c[m >> 2];
	                                    break
	                                }
	                                xo(c[f >> 2] | 0, 0);
	                                if (!(c[j >> 2] | 0))break b;
	                                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                break b
	                            } while (0);
	                            q = c[h >> 2] | 0;
	                            a = c[l >> 2] | 0;
	                            c[l >> 2] = a + 1;
	                            c[(c[k >> 2] | 0) + (a << 2) >> 2] = q;
	                            q = c[j >> 2] | 0;
	                            a = c[l >> 2] | 0;
	                            c[l >> 2] = a + 1;
	                            c[(c[k >> 2] | 0) + (a << 2) >> 2] = q;
	                            c[(c[k >> 2] | 0) + (c[l >> 2] << 2) >> 2] = 0;
	                            c[(c[k >> 2] | 0) + ((c[l >> 2] | 0) + 1 << 2) >> 2] = 0
	                        } else {
	                            if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            while (1) {
	                                if (!(9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0))u = 68;
	                                do if ((u | 0) == 68) {
	                                    u = 0;
	                                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13)break;
	                                    if (32 > (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0))break b
	                                } while (0);
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 32)break b;
	                                if (9 <= (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break b;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 13)break b;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 62)break b;
	                                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)break b;
	                                me(c[f >> 2] | 0)
	                            }
	                        } while (0);
	                        Fo(c[f >> 2] | 0) | 0;
	                        if ((c[r >> 2] | 0) == (c[(c[f >> 2] | 0) + 200 >> 2] | 0)) {
	                            u = 79;
	                            break
	                        }
	                    }
	                    if ((u | 0) == 79)zo(c[f >> 2] | 0, 1, 97824, 0, 0);
	                    if ((c[n >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0)To(c[f >> 2] | 0, c[k >> 2] | 0);
	                    do if (((c[p >> 2] | 0) == 0 ? (Uo(c[f >> 2] | 0, c[g >> 2] | 0) | 0, (c[c[f >> 2] >> 2] | 0) != 0) : 0) ? (c[(c[c[f >> 2] >> 2] | 0) + 56 >> 2] | 0) != 0 : 0) {
	                        n = c[(c[c[f >> 2] >> 2] | 0) + 56 >> 2] | 0;
	                        u = c[(c[f >> 2] | 0) + 4 >> 2] | 0;
	                        r = c[g >> 2] | 0;
	                        if (c[l >> 2] | 0) {
	                            Db[n & 511](u, r, c[k >> 2] | 0);
	                            break
	                        } else {
	                            Db[n & 511](u, r, 0);
	                            break
	                        }
	                    } while (0);
	                    c:do if (c[k >> 2] | 0) {
	                        c[o >> 2] = 1;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[l >> 2] | 0))break c;
	                            if (c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0);
	                            c[o >> 2] = (c[o >> 2] | 0) + 2
	                        }
	                    } while (0);
	                    c[e >> 2] = c[p >> 2];
	                    t = c[e >> 2] | 0;
	                    i = b;
	                    return t | 0
	                }
	                zo(c[f >> 2] | 0, 1, 97616, 0, 0);
	                c[e >> 2] = -1;
	                t = c[e >> 2] | 0;
	                i = b;
	                return t | 0
	            }

	            function Co(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 188 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) < 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 184 >> 2] = c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + ((c[a + 188 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 184 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[(c[e >> 2] | 0) + 188 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[(c[e >> 2] | 0) + 188 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Do(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[(c[d >> 2] | 0) + 188 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = (c[(c[d >> 2] | 0) + 188 >> 2] | 0) - 1;
	                while (1) {
	                    if ((c[e >> 2] | 0) < 0)break;
	                    if ((c[c[d >> 2] >> 2] | 0) != 0 ? (c[(c[c[d >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[d >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0, c[(c[d >> 2] | 0) + 184 >> 2] | 0);
	                    Co(c[d >> 2] | 0) | 0;
	                    c[e >> 2] = (c[e >> 2] | 0) + -1
	                }
	                i = b;
	                return
	            }

	            function Eo(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                c[f >> 2] = my(c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0;
	                c[g >> 2] = c[(c[e >> 2] | 0) + 188 >> 2];
	                a:while (1) {
	                    c[j >> 2] = c[(c[e >> 2] | 0) + 200 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    if ((c[(c[e >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                        if (!(Vo(c[e >> 2] | 0) | 0))continue;
	                        if ((c[f >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 188 >> 2] | 0) != 0 : 0)continue;
	                        if (c[f >> 2] | 0)zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[f >> 2] = my(c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0;
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 188 >> 2];
	                        continue
	                    }
	                    b:do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60) {
	                        if (!(65 <= (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) <= 90 : 0))k = 17;
	                        do if ((k | 0) == 17) {
	                            k = 0;
	                            if (97 <= (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) <= 122 : 0)break;
	                            if ((d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 95 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 58 : 0)break b
	                        } while (0);
	                        c[h >> 2] = Wo(c[e >> 2] | 0) | 0;
	                        a = c[e >> 2] | 0;
	                        if (c[h >> 2] | 0) {
	                            if (!(c[a + 184 >> 2] | 0))break;
	                            if ((wo(c[h >> 2] | 0, c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0) != 1)break;
	                            Qo(c[e >> 2] | 0, c[h >> 2] | 0);
	                            continue a
	                        }
	                        zo(a, 68, 97520, 0, 0);
	                        while (1) {
	                            if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)k = 27; else if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13 ? 32 > (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) : 0)l = 0; else k = 27;
	                            if ((k | 0) == 27) {
	                                k = 0;
	                                l = (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62
	                            }
	                            m = c[e >> 2] | 0;
	                            if (!l)break;
	                            me(m)
	                        }
	                        _o(m);
	                        if (c[f >> 2] | 0)zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[f >> 2] = my(c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0;
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 188 >> 2];
	                        continue a
	                    } while (0);
	                    if (((c[(c[e >> 2] | 0) + 188 >> 2] | 0) > 0 ? (c[g >> 2] | 0) >= (c[(c[e >> 2] | 0) + 188 >> 2] | 0) : 0) ? (qy(c[f >> 2] | 0, c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0) == 0 : 0) {
	                        _o(c[e >> 2] | 0);
	                        if (c[f >> 2] | 0)zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        c[f >> 2] = my(c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0;
	                        c[g >> 2] = c[(c[e >> 2] | 0) + 188 >> 2];
	                        continue
	                    }
	                    do if (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) {
	                        if ((qy(c[f >> 2] | 0, 94992) | 0) == 0 ? (qy(c[f >> 2] | 0, 95e3) | 0) == 0 : 0) {
	                            k = 46;
	                            break
	                        }
	                        Xo(c[e >> 2] | 0)
	                    } else k = 46; while (0);
	                    if ((k | 0) == 46) {
	                        k = 0;
	                        if (((((((((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) == 68 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) == 79 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) == 67 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) == 84 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0) | 0) == 89 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0) | 0) == 80 : 0) ? (WS(d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0) | 0) == 69 : 0) {
	                            zo(c[e >> 2] | 0, 800, 95008, 95040, 0);
	                            Io(c[e >> 2] | 0)
	                        }
	                        if ((((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 33 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) == 45 : 0) ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) == 45 : 0)Go(c[e >> 2] | 0); else k = 61;
	                        do if ((k | 0) == 61) {
	                            k = 0;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60 ? (d[(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 63 : 0) {
	                                Ho(c[e >> 2] | 0);
	                                break
	                            }
	                            a = c[e >> 2] | 0;
	                            if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 60) {
	                                $o(a);
	                                if (c[f >> 2] | 0)zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                                c[f >> 2] = my(c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0;
	                                c[g >> 2] = c[(c[e >> 2] | 0) + 188 >> 2];
	                                break
	                            }
	                            n = c[e >> 2] | 0;
	                            if ((d[c[(c[a + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 38) {
	                                Yo(n);
	                                break
	                            }
	                            o = c[e >> 2] | 0;
	                            if (!(d[c[(c[n + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0)) {
	                                k = 71;
	                                break a
	                            }
	                            Zo(o)
	                        } while (0);
	                        if ((c[j >> 2] | 0) == (c[(c[e >> 2] | 0) + 200 >> 2] | 0)) {
	                            k = 74;
	                            break
	                        }
	                    }
	                    if (c[(c[e >> 2] | 0) + 292 >> 2] | 0)continue;
	                    if (((c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)continue;
	                    ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                }
	                if ((k | 0) == 71)Do(o); else if ((k | 0) == 74 ? (c[(c[e >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zo(c[e >> 2] | 0, 1, 95064, 0, 0);
	                if (!(c[f >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = b;
	                return
	            }

	            function Fo(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                a:while (1) {
	                    do if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 0 ? (ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0) <= 0 : 0)Ve(c[e >> 2] | 0) | 0; else {
	                        a = c[(c[e >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            g = a + 28 | 0;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1;
	                            c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            g = a + 32 | 0;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        g = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        g = (c[e >> 2] | 0) + 200 | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        if (!(d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0))ke(c[(c[e >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                    }
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                i = b;
	                return c[f >> 2] | 0
	            }

	            function Go(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 44 | 0;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 24 | 0;
	                m = e + 20 | 0;
	                n = e + 16 | 0;
	                o = e + 12 | 0;
	                p = e + 8 | 0;
	                q = e + 4 | 0;
	                r = e;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                c[j >> 2] = 100;
	                if (c[(c[f >> 2] | 0) + 176 >> 2] | 0)s = -1; else s = d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                if ((s | 0) != 60) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 33) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0 | 0) != 45) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0 | 0) != 45) {
	                    i = e;
	                    return
	                }
	                c[q >> 2] = c[(c[f >> 2] | 0) + 172 >> 2];
	                c[(c[f >> 2] | 0) + 172 >> 2] = 5;
	                if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                s = (c[f >> 2] | 0) + 200 | 0;
	                c[s >> 2] = (c[s >> 2] | 0) + 4;
	                s = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[s >> 2] = (c[s >> 2] | 0) + 4;
	                s = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[s >> 2] = (c[s >> 2] | 0) + 4;
	                c[g >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0;
	                s = c[f >> 2] | 0;
	                if (!(c[g >> 2] | 0)) {
	                    xo(s, 97424);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = c[q >> 2];
	                    i = e;
	                    return
	                }
	                c[k >> 2] = ap(s, l) | 0;
	                s = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                    b = s + 28 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1;
	                    c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                } else {
	                    b = s + 32 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + (c[l >> 2] | 0);
	                b = (c[f >> 2] | 0) + 200 | 0;
	                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                c[m >> 2] = ap(c[f >> 2] | 0, n) | 0;
	                b = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                    s = b + 28 | 0;
	                    c[s >> 2] = (c[s >> 2] | 0) + 1;
	                    c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                } else {
	                    s = b + 32 | 0;
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                }
	                c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                s = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[s >> 2] = (c[s >> 2] | 0) + (c[n >> 2] | 0);
	                s = (c[f >> 2] | 0) + 200 | 0;
	                c[s >> 2] = (c[s >> 2] | 0) + 1;
	                c[o >> 2] = ap(c[f >> 2] | 0, p) | 0;
	                c[h >> 2] = 0;
	                while (1) {
	                    s = c[o >> 2] | 0;
	                    if ((c[o >> 2] | 0) < 256)if (9 <= (s | 0) & (c[o >> 2] | 0) <= 10 | (c[o >> 2] | 0) == 13 | 32 <= (c[o >> 2] | 0))t = 24; else u = 0; else if ((!(256 <= (s | 0) & (c[o >> 2] | 0) <= 55295) ? !(57344 <= (c[o >> 2] | 0) & (c[o >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[o >> 2] | 0) & (c[o >> 2] | 0) <= 1114111) : 0)u = 0; else t = 24;
	                    if ((t | 0) == 24) {
	                        t = 0;
	                        if ((c[o >> 2] | 0) != 62 | (c[m >> 2] | 0) != 45)u = 1; else u = (c[k >> 2] | 0) != 45
	                    }
	                    v = c[h >> 2] | 0;
	                    if (!u)break;
	                    if ((v + 5 | 0) >= (c[j >> 2] | 0)) {
	                        c[j >> 2] = c[j >> 2] << 1;
	                        c[r >> 2] = Hb[c[135760 >> 2] & 511](c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            t = 29;
	                            break
	                        }
	                        c[g >> 2] = c[r >> 2]
	                    }
	                    if ((c[l >> 2] | 0) == 1) {
	                        s = c[k >> 2] & 255;
	                        b = c[h >> 2] | 0;
	                        c[h >> 2] = b + 1;
	                        a[(c[g >> 2] | 0) + b >> 0] = s
	                    } else {
	                        s = qe(c[l >> 2] | 0, (c[g >> 2] | 0) + (c[h >> 2] | 0) | 0, c[k >> 2] | 0) | 0;
	                        c[h >> 2] = (c[h >> 2] | 0) + s
	                    }
	                    c[k >> 2] = c[m >> 2];
	                    c[l >> 2] = c[n >> 2];
	                    c[m >> 2] = c[o >> 2];
	                    c[n >> 2] = c[p >> 2];
	                    s = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                    if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                        b = s + 28 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                    } else {
	                        b = s + 32 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1
	                    }
	                    c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                    b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + (c[p >> 2] | 0);
	                    b = (c[f >> 2] | 0) + 200 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1;
	                    c[o >> 2] = ap(c[f >> 2] | 0, p) | 0;
	                    if (c[o >> 2] | 0)continue;
	                    if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                    c[o >> 2] = ap(c[f >> 2] | 0, p) | 0
	                }
	                if ((t | 0) == 29) {
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    xo(c[f >> 2] | 0, 97456);
	                    c[(c[f >> 2] | 0) + 172 >> 2] = c[q >> 2];
	                    i = e;
	                    return
	                }
	                a[(c[g >> 2] | 0) + v >> 0] = 0;
	                v = c[o >> 2] | 0;
	                if ((c[o >> 2] | 0) < 256)if (9 <= (v | 0) & (c[o >> 2] | 0) <= 10 | (c[o >> 2] | 0) == 13 | 32 <= (c[o >> 2] | 0))t = 51; else t = 50; else if ((!(256 <= (v | 0) & (c[o >> 2] | 0) <= 55295) ? !(57344 <= (c[o >> 2] | 0) & (c[o >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[o >> 2] | 0) & (c[o >> 2] | 0) <= 1114111) : 0)t = 50; else t = 51;
	                if ((t | 0) == 50) {
	                    zo(c[f >> 2] | 0, 45, 97480, c[g >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0)
	                } else if ((t | 0) == 51) {
	                    me(c[f >> 2] | 0);
	                    if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Ab[c[(c[c[f >> 2] >> 2] | 0) + 80 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0)
	                }
	                c[(c[f >> 2] | 0) + 172 >> 2] = c[q >> 2];
	                i = e;
	                return
	            }

	            function Ho(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[j >> 2] = 100;
	                c[o >> 2] = 0;
	                if (c[(c[f >> 2] | 0) + 176 >> 2] | 0)q = -1; else q = d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                if ((q | 0) != 60) {
	                    i = e;
	                    return
	                }
	                if ((d[(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) != 63) {
	                    i = e;
	                    return
	                }
	                c[n >> 2] = c[(c[f >> 2] | 0) + 172 >> 2];
	                c[(c[f >> 2] | 0) + 172 >> 2] = 2;
	                q = (c[f >> 2] | 0) + 200 | 0;
	                c[q >> 2] = (c[q >> 2] | 0) + 2;
	                q = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[q >> 2] = (c[q >> 2] | 0) + 2;
	                q = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[q >> 2] = (c[q >> 2] | 0) + 2;
	                if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 500 : 0)le(c[(c[f >> 2] | 0) + 36 >> 2] | 0);
	                c[m >> 2] = yo(c[f >> 2] | 0) | 0;
	                q = c[f >> 2] | 0;
	                if (c[m >> 2] | 0) {
	                    if (c[q + 176 >> 2] | 0)r = -1; else r = d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    if ((r | 0) == 62) {
	                        r = (c[f >> 2] | 0) + 200 | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        r = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        r = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) ? (c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] | 0) != 0 : 0)Db[c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0, 0);
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    }
	                    c[g >> 2] = Cb[c[135752 >> 2] & 511](c[j >> 2] | 0) | 0;
	                    r = c[f >> 2] | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        xo(r, 0);
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    }
	                    c[k >> 2] = d[c[(c[r + 36 >> 2] | 0) + 16 >> 2] >> 0];
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((c[k >> 2] | 0) != 32 ? !(9 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 10 | (c[k >> 2] | 0) == 13) : 0)s = 22
	                    } else s = 22;
	                    if ((s | 0) == 22)zo(c[f >> 2] | 0, 65, 97328, c[m >> 2] | 0, 0);
	                    Fo(c[f >> 2] | 0) | 0;
	                    c[k >> 2] = ap(c[f >> 2] | 0, l) | 0;
	                    while (1) {
	                        r = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)if (9 <= (r | 0) & (c[k >> 2] | 0) <= 10 | (c[k >> 2] | 0) == 13 | 32 <= (c[k >> 2] | 0))s = 29; else t = 0; else if ((!(256 <= (r | 0) & (c[k >> 2] | 0) <= 55295) ? !(57344 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 1114111) : 0)t = 0; else s = 29;
	                        if ((s | 0) == 29) {
	                            s = 0;
	                            t = (c[k >> 2] | 0) != 62
	                        }
	                        u = c[h >> 2] | 0;
	                        if (!t)break;
	                        if ((u + 5 | 0) >= (c[j >> 2] | 0)) {
	                            c[j >> 2] = c[j >> 2] << 1;
	                            c[p >> 2] = Hb[c[135760 >> 2] & 511](c[g >> 2] | 0, c[j >> 2] | 0) | 0;
	                            if (!(c[p >> 2] | 0)) {
	                                s = 33;
	                                break
	                            }
	                            c[g >> 2] = c[p >> 2]
	                        }
	                        c[o >> 2] = (c[o >> 2] | 0) + 1;
	                        if ((c[o >> 2] | 0) > 50) {
	                            if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                            c[o >> 2] = 0
	                        }
	                        if ((c[l >> 2] | 0) == 1) {
	                            r = c[k >> 2] & 255;
	                            b = c[h >> 2] | 0;
	                            c[h >> 2] = b + 1;
	                            a[(c[g >> 2] | 0) + b >> 0] = r
	                        } else {
	                            r = qe(c[l >> 2] | 0, (c[g >> 2] | 0) + (c[h >> 2] | 0) | 0, c[k >> 2] | 0) | 0;
	                            c[h >> 2] = (c[h >> 2] | 0) + r
	                        }
	                        r = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            b = r + 28 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            b = r + 32 | 0;
	                            c[b >> 2] = (c[b >> 2] | 0) + 1
	                        }
	                        c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                        b = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + (c[l >> 2] | 0);
	                        b = (c[f >> 2] | 0) + 200 | 0;
	                        c[b >> 2] = (c[b >> 2] | 0) + 1;
	                        c[k >> 2] = ap(c[f >> 2] | 0, l) | 0;
	                        if (c[k >> 2] | 0)continue;
	                        do if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0) > 500) {
	                            if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 500)break;
	                            le(c[(c[f >> 2] | 0) + 36 >> 2] | 0)
	                        } while (0);
	                        do if (!(c[(c[f >> 2] | 0) + 292 >> 2] | 0)) {
	                            if (((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) >= 250)break;
	                            ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0
	                        } while (0);
	                        c[k >> 2] = ap(c[f >> 2] | 0, l) | 0
	                    }
	                    if ((s | 0) == 33) {
	                        xo(c[f >> 2] | 0, 0);
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                        i = e;
	                        return
	                    }
	                    a[(c[g >> 2] | 0) + u >> 0] = 0;
	                    u = c[f >> 2] | 0;
	                    if ((c[k >> 2] | 0) == 62) {
	                        k = u + 200 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        k = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        k = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + 1;
	                        if (((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 212 >> 2] | 0) == 0 : 0) ? (c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] | 0) != 0 : 0)Db[c[(c[c[f >> 2] >> 2] | 0) + 76 >> 2] & 511](c[(c[f >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0, c[g >> 2] | 0)
	                    } else zo(u, 47, 97360, c[m >> 2] | 0, 0);
	                    zb[c[135736 >> 2] & 511](c[g >> 2] | 0)
	                } else zo(q, 46, 97392, 0, 0);
	                c[(c[f >> 2] | 0) + 172 >> 2] = c[n >> 2];
	                i = e;
	                return
	            }

	            function Io(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                a = (c[e >> 2] | 0) + 200 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                a = (c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 9;
	                Fo(c[e >> 2] | 0) | 0;
	                c[f >> 2] = yo(c[e >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0))zo(c[e >> 2] | 0, 68, 96976, 0, 0);
	                Fo(c[e >> 2] | 0) | 0;
	                c[h >> 2] = bp(c[e >> 2] | 0, g) | 0;
	                Fo(c[e >> 2] | 0) | 0;
	                if ((d[c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 62)zo(c[e >> 2] | 0, 61, 97024, 0, 0);
	                me(c[e >> 2] | 0);
	                if (((c[c[e >> 2] >> 2] | 0) != 0 ? (c[c[c[e >> 2] >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)Jb[c[c[c[e >> 2] >> 2] >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                if (c[h >> 2] | 0)zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                i = b;
	                return
	            }

	            function Jo(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                cU(c[e >> 2] | 0, 0, 472) | 0;
	                a = xP() | 0;
	                c[(c[e >> 2] | 0) + 296 >> 2] = a;
	                if (!(c[(c[e >> 2] | 0) + 296 >> 2] | 0)) {
	                    xo(0, 96936);
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](128) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xo(0, 96936);
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 128 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                j = Cb[c[135744 >> 2] & 511](20) | 0;
	                c[(c[e >> 2] | 0) + 48 >> 2] = j;
	                if (!(c[(c[e >> 2] | 0) + 48 >> 2] | 0)) {
	                    xo(0, 96936);
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 44 >> 2] = 5;
	                c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 28 >> 2] = -1;
	                c[(c[e >> 2] | 0) + 172 >> 2] = 0;
	                j = Cb[c[135744 >> 2] & 511](40) | 0;
	                c[(c[e >> 2] | 0) + 64 >> 2] = j;
	                if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                    xo(0, 96936);
	                    c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 60 >> 2] = 10;
	                c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                j = Cb[c[135744 >> 2] & 511](40) | 0;
	                c[(c[e >> 2] | 0) + 196 >> 2] = j;
	                if (!(c[(c[e >> 2] | 0) + 196 >> 2] | 0)) {
	                    xo(0, 96936);
	                    c[(c[e >> 2] | 0) + 188 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 192 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 184 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 52 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                    c[(c[e >> 2] | 0) + 36 >> 2] = 0;
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[(c[e >> 2] | 0) + 188 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 192 >> 2] = 10;
	                c[(c[e >> 2] | 0) + 184 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 460 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 452 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 456 >> 2] = 0;
	                if (!(c[f >> 2] | 0))c[c[e >> 2] >> 2] = 136096; else {
	                    c[c[e >> 2] >> 2] = c[f >> 2];
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    f = 136096 | 0;
	                    h = a + 112 | 0;
	                    do {
	                        c[a >> 2] = c[f >> 2];
	                        a = a + 4 | 0;
	                        f = f + 4 | 0
	                    } while ((a | 0) < (h | 0))
	                }
	                c[(c[e >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                c[(c[e >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 12 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 280 >> 2] = c[33962];
	                c[(c[e >> 2] | 0) + 32 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 136 >> 2] = -1412623820;
	                c[(c[e >> 2] | 0) + 108 >> 2] = c[e >> 2];
	                c[(c[e >> 2] | 0) + 112 >> 2] = 224;
	                c[(c[e >> 2] | 0) + 116 >> 2] = 225;
	                c[(c[e >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 104 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 200 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 204 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 284 >> 2] = 0;
	                ze((c[e >> 2] | 0) + 72 | 0);
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function Ko(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                f = i;
	                i = i + 80 | 0;
	                g = f + 60 | 0;
	                h = f + 56 | 0;
	                j = f + 52 | 0;
	                k = f + 48 | 0;
	                l = f + 44 | 0;
	                m = f + 69 | 0;
	                n = f + 68 | 0;
	                o = f + 24 | 0;
	                p = f + 20 | 0;
	                q = f + 16 | 0;
	                r = f + 12 | 0;
	                s = f + 8 | 0;
	                t = f + 66 | 0;
	                u = f + 4 | 0;
	                v = f + 64 | 0;
	                w = f;
	                c[g >> 2] = b;
	                c[h >> 2] = e;
	                c[j >> 2] = 0;
	                c[l >> 2] = 0;
	                a:while (1) {
	                    c[k >> 2] = c[(c[g >> 2] | 0) + 36 >> 2];
	                    if (!(c[k >> 2] | 0))break;
	                    e = c[k >> 2] | 0;
	                    if (!(c[c[k >> 2] >> 2] | 0))c[l >> 2] = (c[e + 24 >> 2] | 0) - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0)); else {
	                        b = _y(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        c[l >> 2] = b - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0))
	                    }
	                    if (((((c[l >> 2] | 0) == 0 & (c[h >> 2] | 0) != 0 ? (Do(c[g >> 2] | 0), (c[(c[g >> 2] | 0) + 188 >> 2] | 0) == 0) : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != -1 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] = -1, (c[c[g >> 2] >> 2] | 0) != 0) : 0) ? (c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                    if ((c[l >> 2] | 0) < 1)break;
	                    a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    b = c[g >> 2] | 0;
	                    if (!(d[m >> 0] | 0)) {
	                        e = b + 200 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                        e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                        e = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                        continue
	                    }
	                    do switch (c[b + 172 >> 2] | 0) {
	                        case 1:
	                        {
	                            Fo(c[g >> 2] | 0) | 0;
	                            e = c[k >> 2] | 0;
	                            if (!(c[c[k >> 2] >> 2] | 0))c[l >> 2] = (c[e + 24 >> 2] | 0) - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0)); else {
	                                x = _y(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[l >> 2] = x - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0))
	                            }
	                            if ((c[l >> 2] | 0) < 1)break a;
	                            if ((c[l >> 2] | 0) < 2) {
	                                if (!(c[h >> 2] | 0))break a;
	                                a[n >> 0] = 32
	                            } else a[n >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            if ((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) == 45 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) == 45 : 0) {
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 45, 45, 62, 1, 1) | 0) < 0 : 0)break a;
	                                Go(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 1;
	                                continue a
	                            }
	                            if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 63 : 0) {
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                                Ho(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 1;
	                                continue a
	                            }
	                            do if (((((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) == 68 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) == 79 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) == 67 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) == 84 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0) | 0) == 89 : 0) {
	                                if ((WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0) | 0) != 80)break;
	                                if ((WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0) | 0) != 69)break;
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                                Io(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 4;
	                                continue a
	                            } while (0);
	                            if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 & (c[l >> 2] | 0) < 9 : 0)break a;
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 6;
	                            continue a;
	                            break
	                        }
	                        case 9:
	                        {
	                            if ((c[l >> 2] | 0) < 2)break a;
	                            if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                            Vo(c[g >> 2] | 0) | 0;
	                            x = (c[g >> 2] | 0) + 172 | 0;
	                            if (!(c[(c[g >> 2] | 0) + 188 >> 2] | 0))c[x >> 2] = 14; else c[x >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 8:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95104, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 3:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95144, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 7:
	                        {
	                            if (c[(c[g >> 2] | 0) + 176 >> 2] | 0) {
	                                a[t + 0 >> 0] = 0;
	                                a[t + 1 >> 0] = 0;
	                                a[t >> 0] = c[(c[g >> 2] | 0) + 176 >> 2];
	                                ep(c[g >> 2] | 0) | 0;
	                                if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0) != 0 : 0)Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, t, 1);
	                                c[(c[g >> 2] | 0) + 176 >> 2] = 0;
	                                c[(c[g >> 2] | 0) + 204 >> 2] = 0
	                            }
	                            if (((c[l >> 2] | 0) == 1 & (c[h >> 2] | 0) != 0 ? (a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0, (d[m >> 0] | 0) != 60) : 0) ? (d[m >> 0] | 0) != 38 : 0) {
	                                b:do if (c[c[g >> 2] >> 2] | 0) {
	                                    do if ((d[m >> 0] | 0) != 32) {
	                                        if (9 <= (d[m >> 0] | 0) ? (d[m >> 0] | 0) <= 10 : 0)break;
	                                        if ((d[m >> 0] | 0) != 13) {
	                                            ep(c[g >> 2] | 0) | 0;
	                                            if (!(c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] | 0))break b;
	                                            Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, m, 1);
	                                            break b
	                                        }
	                                    } while (0);
	                                    x = c[c[g >> 2] >> 2] | 0;
	                                    if (c[(c[g >> 2] | 0) + 208 >> 2] | 0) {
	                                        if (!(c[x + 68 >> 2] | 0))break;
	                                        Db[c[(c[c[g >> 2] >> 2] | 0) + 68 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, m, 1);
	                                        break
	                                    } else {
	                                        if (!(c[x + 72 >> 2] | 0))break;
	                                        Db[c[(c[c[g >> 2] >> 2] | 0) + 72 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, m, 1);
	                                        break
	                                    }
	                                } while (0);
	                                c[(c[g >> 2] | 0) + 176 >> 2] = 0;
	                                c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                                x = (c[k >> 2] | 0) + 16 | 0;
	                                c[x >> 2] = (c[x >> 2] | 0) + 1;
	                                continue a
	                            }
	                            if ((c[l >> 2] | 0) < 2)break a;
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[n >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            c[s >> 2] = c[(c[g >> 2] | 0) + 200 >> 2];
	                            c:do if ((qy(c[(c[g >> 2] | 0) + 184 >> 2] | 0, 94992) | 0) == 0 ? (qy(c[(c[g >> 2] | 0) + 184 >> 2] | 0, 95e3) | 0) == 0 : 0) {
	                                do if ((((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) == 68 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) == 79 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) == 67 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) == 84 : 0) {
	                                    if ((WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0) | 0) != 89)break;
	                                    if ((WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0) | 0) != 80)break;
	                                    if ((WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0) | 0) != 69)break;
	                                    if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                                    zo(c[g >> 2] | 0, 800, 95008, 95040, 0);
	                                    Io(c[g >> 2] | 0);
	                                    break c
	                                } while (0);
	                                if ((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) == 45 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) == 45 : 0) {
	                                    if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 45, 45, 62, 1, 1) | 0) < 0 : 0)break a;
	                                    Go(c[g >> 2] | 0);
	                                    c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                                    break
	                                }
	                                if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 63 : 0) {
	                                    if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                                    Ho(c[g >> 2] | 0);
	                                    c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                                    break
	                                }
	                                if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 & (c[l >> 2] | 0) < 4 : 0)break a;
	                                if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 47 : 0) {
	                                    c[(c[g >> 2] | 0) + 172 >> 2] = 9;
	                                    c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                                    continue a
	                                }
	                                if ((d[m >> 0] | 0) == 60) {
	                                    c[(c[g >> 2] | 0) + 172 >> 2] = 6;
	                                    c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                                    continue a
	                                }
	                                x = (c[h >> 2] | 0) != 0;
	                                if ((d[m >> 0] | 0) == 38) {
	                                    if (!x ? (fp(c[g >> 2] | 0, 95048, 4) | 0) < 0 : 0)break a;
	                                    Yo(c[g >> 2] | 0);
	                                    break
	                                } else {
	                                    if (!x ? (fp(c[g >> 2] | 0, 95056, 2) | 0) < 0 : 0)break a;
	                                    c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                                    Zo(c[g >> 2] | 0);
	                                    break
	                                }
	                            } else y = 187; while (0);
	                            if ((y | 0) == 187) {
	                                y = 0;
	                                if (!(c[h >> 2] | 0)) {
	                                    c[u >> 2] = cp(c[g >> 2] | 0, 60, 47, 0, 0, 0) | 0;
	                                    if ((c[u >> 2] | 0) < 0)break a;
	                                    a[v >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + ((c[u >> 2] | 0) + 2) >> 0] | 0;
	                                    if (!(d[v >> 0] | 0))break a
	                                }
	                                Xo(c[g >> 2] | 0);
	                                if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 47 : 0) {
	                                    c[(c[g >> 2] | 0) + 172 >> 2] = 9;
	                                    c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                                    continue a
	                                }
	                            }
	                            if ((c[s >> 2] | 0) != (c[(c[g >> 2] | 0) + 200 >> 2] | 0))continue a;
	                            if (c[(c[g >> 2] | 0) + 52 >> 2] | 0)zo(c[g >> 2] | 0, 1, 95064, 0, 0);
	                            me(c[g >> 2] | 0);
	                            continue a;
	                            break
	                        }
	                        case 6:
	                        {
	                            if ((c[l >> 2] | 0) < 1)break a;
	                            if ((c[l >> 2] | 0) < 2) {
	                                if (!(c[h >> 2] | 0))break a;
	                                a[n >> 0] = 32
	                            } else a[n >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            if ((d[m >> 0] | 0) != 60) {
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                                continue a
	                            }
	                            if ((d[n >> 0] | 0) == 47) {
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 9;
	                                c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                                continue a
	                            }
	                            if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                            if (c[(c[g >> 2] | 0) + 68 >> 2] | 0) {
	                                c[o + 4 >> 2] = (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 36 >> 2] | 0) + ((c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0));
	                                c[o + 8 >> 2] = c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2]
	                            }
	                            c[q >> 2] = Bo(c[g >> 2] | 0) | 0;
	                            c[p >> 2] = c[(c[g >> 2] | 0) + 184 >> 2];
	                            if ((c[q >> 2] | 0) == -1 | (c[p >> 2] | 0) == 0) {
	                                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 62)continue a;
	                                me(c[g >> 2] | 0);
	                                continue a
	                            }
	                            c[r >> 2] = bo(c[p >> 2] | 0) | 0;
	                            if (!(c[r >> 2] | 0))zo(c[g >> 2] | 0, 801, 94576, c[p >> 2] | 0, 0);
	                            if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) == 47 ? (d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0) == 62 : 0) {
	                                x = (c[g >> 2] | 0) + 200 | 0;
	                                c[x >> 2] = (c[x >> 2] | 0) + 2;
	                                x = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                                c[x >> 2] = (c[x >> 2] | 0) + 2;
	                                x = (c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 32 | 0;
	                                c[x >> 2] = (c[x >> 2] | 0) + 2;
	                                do if (c[c[g >> 2] >> 2] | 0) {
	                                    if (!(c[(c[c[g >> 2] >> 2] | 0) + 60 >> 2] | 0))break;
	                                    Ab[c[(c[c[g >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0)
	                                } while (0);
	                                Co(c[g >> 2] | 0) | 0;
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                                continue a
	                            }
	                            x = c[g >> 2] | 0;
	                            if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) != 62) {
	                                zo(x, 73, 94592, c[p >> 2] | 0, 0);
	                                if (qy(c[p >> 2] | 0, c[(c[g >> 2] | 0) + 184 >> 2] | 0) | 0) {
	                                    Re(c[g >> 2] | 0) | 0;
	                                    Co(c[g >> 2] | 0) | 0
	                                }
	                                if (c[(c[g >> 2] | 0) + 68 >> 2] | 0)dp(c[g >> 2] | 0, o) | 0;
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                                continue a
	                            }
	                            me(x);
	                            if ((c[r >> 2] | 0) != 0 ? (a[(c[r >> 2] | 0) + 7 >> 0] | 0) != 0 : 0) {
	                                do if (c[c[g >> 2] >> 2] | 0) {
	                                    if (!(c[(c[c[g >> 2] >> 2] | 0) + 60 >> 2] | 0))break;
	                                    Ab[c[(c[c[g >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0)
	                                } while (0);
	                                Co(c[g >> 2] | 0) | 0
	                            }
	                            if (c[(c[g >> 2] | 0) + 68 >> 2] | 0)dp(c[g >> 2] | 0, o) | 0;
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            continue a;
	                            break
	                        }
	                        case 0:
	                        {
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            do if ((d[m >> 0] | 0) != 32) {
	                                if (9 <= (d[m >> 0] | 0) ? (d[m >> 0] | 0) <= 10 : 0) {
	                                    y = 20;
	                                    break
	                                }
	                                if ((d[m >> 0] | 0) == 13)y = 20
	                            } else y = 20; while (0);
	                            do if ((y | 0) == 20) {
	                                y = 0;
	                                Fo(c[g >> 2] | 0) | 0;
	                                x = c[k >> 2] | 0;
	                                if (!(c[c[k >> 2] >> 2] | 0)) {
	                                    c[l >> 2] = (c[x + 24 >> 2] | 0) - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0));
	                                    break
	                                } else {
	                                    e = _y(c[(c[x >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                    c[l >> 2] = e - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0));
	                                    break
	                                }
	                            } while (0);
	                            if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)Ab[c[(c[c[g >> 2] >> 2] | 0) + 44 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0, 136080);
	                            if (((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 212 >> 2] | 0) == 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 48 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[n >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if (((((((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) | 0) == 68 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) | 0) == 79 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 0] | 0) | 0) == 67 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 5 >> 0] | 0) | 0) == 84 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 6 >> 0] | 0) | 0) == 89 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 7 >> 0] | 0) | 0) == 80 : 0) ? (WS(d[(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 8 >> 0] | 0) | 0) == 69 : 0) {
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                                Io(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 4;
	                                continue a
	                            }
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 1;
	                            continue a;
	                            break
	                        }
	                        case 14:
	                        {
	                            e = c[k >> 2] | 0;
	                            if (!(c[c[k >> 2] >> 2] | 0))c[l >> 2] = (c[e + 24 >> 2] | 0) - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0)); else {
	                                x = _y(c[(c[e >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[l >> 2] = x - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0))
	                            }
	                            if ((c[l >> 2] | 0) < 1)break a;
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            if ((d[m >> 0] | 0) == 32) {
	                                y = 105;
	                                break a
	                            }
	                            if (9 <= (d[m >> 0] | 0) ? (d[m >> 0] | 0) <= 10 : 0) {
	                                y = 105;
	                                break a
	                            }
	                            if ((d[m >> 0] | 0) == 13) {
	                                y = 105;
	                                break a
	                            }
	                            if ((c[l >> 2] | 0) < 2)break a;
	                            a[n >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if ((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) == 45 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) == 45 : 0) {
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 45, 45, 62, 1, 1) | 0) < 0 : 0)break a;
	                                Go(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 14;
	                                continue a
	                            }
	                            if ((d[m >> 0] | 0) != 60) {
	                                y = 119;
	                                break a
	                            }
	                            if ((d[n >> 0] | 0) != 63) {
	                                y = 119;
	                                break a
	                            }
	                            if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                            Ho(c[g >> 2] | 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 14;
	                            continue a;
	                            break
	                        }
	                        case 4:
	                        {
	                            Fo(c[g >> 2] | 0) | 0;
	                            x = c[k >> 2] | 0;
	                            if (!(c[c[k >> 2] >> 2] | 0))c[l >> 2] = (c[x + 24 >> 2] | 0) - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0)); else {
	                                e = _y(c[(c[x >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[l >> 2] = e - ((c[(c[k >> 2] | 0) + 16 >> 2] | 0) - (c[(c[k >> 2] | 0) + 12 >> 2] | 0))
	                            }
	                            if ((c[l >> 2] | 0) < 2)break a;
	                            a[m >> 0] = a[c[(c[k >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                            a[n >> 0] = a[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0;
	                            if ((((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 2 >> 0] | 0) == 45 : 0) ? (d[(c[(c[k >> 2] | 0) + 16 >> 2] | 0) + 3 >> 0] | 0) == 45 : 0) {
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 45, 45, 62, 1, 1) | 0) < 0 : 0)break a;
	                                Go(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 4;
	                                continue a
	                            }
	                            if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 63 : 0) {
	                                if ((c[h >> 2] | 0) == 0 ? (cp(c[g >> 2] | 0, 62, 0, 0, 0, 1) | 0) < 0 : 0)break a;
	                                Ho(c[g >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 172 >> 2] = 4;
	                                continue a
	                            }
	                            if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 & (c[l >> 2] | 0) < 4 : 0)break a;
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 6;
	                            continue a;
	                            break
	                        }
	                        case 5:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95184, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 2:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95224, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 10:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95264, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 11:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95312, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 12:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95360, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 6;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 13:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95408, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 15:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95472, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case 16:
	                        {
	                            zo(c[g >> 2] | 0, 1, 95528, 0, 0);
	                            c[(c[g >> 2] | 0) + 172 >> 2] = 7;
	                            c[(c[g >> 2] | 0) + 204 >> 2] = 0;
	                            continue a;
	                            break
	                        }
	                        case -1:
	                        {
	                            break a;
	                            break
	                        }
	                        default:
	                            continue a
	                    } while (0)
	                }
	                do if ((y | 0) == 105)Zo(c[g >> 2] | 0); else if ((y | 0) == 119) {
	                    if ((d[m >> 0] | 0) == 60 ? (d[n >> 0] | 0) == 33 & (c[l >> 2] | 0) < 4 : 0)break;
	                    c[(c[g >> 2] | 0) + 84 >> 2] = 5;
	                    c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[g >> 2] | 0) + 172 >> 2] = -1;
	                    if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0)
	                } while (0);
	                if (((((c[l >> 2] | 0) == 0 & (c[h >> 2] | 0) != 0 ? (Do(c[g >> 2] | 0), (c[(c[g >> 2] | 0) + 188 >> 2] | 0) == 0) : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != -1 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] = -1, (c[c[g >> 2] >> 2] | 0) != 0) : 0) ? (c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] | 0) != 0 : 0)zb[c[(c[c[g >> 2] >> 2] | 0) + 52 >> 2] & 511](c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[g >> 2] | 0) + 360 >> 2] & 4) {
	                    z = c[j >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    z = c[j >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                if (((c[h >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != -1 : 0) ? (c[(c[g >> 2] | 0) + 172 >> 2] | 0) != 14 : 0) {
	                    z = c[j >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                c[w >> 2] = Nh(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (c[w >> 2] | 0) {
	                    z = c[j >> 2] | 0;
	                    i = f;
	                    return z | 0
	                }
	                w = Oh(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 94240, 94296, 94248) | 0;
	                c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] = w;
	                z = c[j >> 2] | 0;
	                i = f;
	                return z | 0
	            }

	            function Lo(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xo(c[e >> 2] | 0, 94952);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    e = (c[f >> 2] | 0) + 0 | 0;
	                    a = e + 60 | 0;
	                    do {
	                        c[e >> 2] = 0;
	                        e = e + 4 | 0
	                    } while ((e | 0) < (a | 0));
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                    c[c[f >> 2] >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = 1;
	                    c[(c[f >> 2] | 0) + 32 >> 2] = 1;
	                    c[c[f >> 2] >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 36 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 24 >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function Mo(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[h >> 2] = yy(c[g >> 2] | 0, 94816) | 0;
	                if (c[h >> 2] | 0)c[h >> 2] = (c[h >> 2] | 0) + 7;
	                a:do if (c[h >> 2] | 0) {
	                    do if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[h >> 2] = yy(c[g >> 2] | 0, 94824) | 0
	                } while (0);
	                if (!(c[h >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((d[c[h >> 2] >> 0] | 0 | 0) != 61) {
	                    i = e;
	                    return
	                }
	                c[h >> 2] = (c[h >> 2] | 0) + 1;
	                gp(c[f >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function No(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                to(c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                c[(c[h >> 2] | 0) + 32 >> 2] = 1;
	                if ((c[k >> 2] | 0) != 0 ? (c[o >> 2] = Dd(c[k >> 2] | 0) | 0, (c[o >> 2] | 0) != 0) : 0) {
	                    se(c[h >> 2] | 0, c[o >> 2] | 0) | 0;
	                    if (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] | 0);
	                    o = my(c[k >> 2] | 0) | 0;
	                    c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 44 >> 2] = o
	                }
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) {
	                    o = my(c[j >> 2] | 0) | 0;
	                    c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = o
	                }
	                ko(c[h >> 2] | 0) | 0;
	                c[n >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                c[(c[h >> 2] | 0) + 8 >> 2] = 0;
	                if (c[m >> 2] | 0) {
	                    p = c[n >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                if (((c[n >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 364 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 80 >> 2] | 0) == (c[(c[h >> 2] | 0) + 296 >> 2] | 0) : 0)c[(c[h >> 2] | 0) + 296 >> 2] = 0;
	                Ae(c[h >> 2] | 0);
	                p = c[n >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function Oo(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                c[k >> 2] = 0;
	                if ((c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0 ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                c[j >> 2] = ap(c[f >> 2] | 0, h) | 0;
	                a:do if (!((c[j >> 2] | 0) == 32 | (c[j >> 2] | 0) == 62 | (c[j >> 2] | 0) == 47)) {
	                    a = c[j >> 2] | 0;
	                    if ((c[j >> 2] | 0) < 256) {
	                        if (((!(65 <= (a | 0) & (c[j >> 2] | 0) <= 90) ? !(97 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 122) : 0) ? !(192 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 214) : 0) ? !(216 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 246 | 248 <= (c[j >> 2] | 0)) : 0)l = 11
	                    } else if (!(DQ(a, 199744) | 0))l = 11;
	                    do if ((l | 0) == 11) {
	                        a = c[j >> 2] | 0;
	                        if ((c[j >> 2] | 0) < 256)if ((a | 0) != 95 & (c[j >> 2] | 0) != 58)break a; else break;
	                        if (!(19968 <= (a | 0) & (c[j >> 2] | 0) <= 40869 | (c[j >> 2] | 0) == 12295) ? (12321 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 12329 ^ 1) & (c[j >> 2] | 0) != 95 & (c[j >> 2] | 0) != 58 : 0)break a
	                    } while (0);
	                    b:while (1) {
	                        if (!((c[j >> 2] | 0) != 32 & (c[j >> 2] | 0) != 62 & (c[j >> 2] | 0) != 47))break;
	                        a = c[j >> 2] | 0;
	                        if ((c[j >> 2] | 0) < 256) {
	                            if (((!(65 <= (a | 0) & (c[j >> 2] | 0) <= 90) ? !(97 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 122) : 0) ? !(192 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 214) : 0) ? !(216 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 246 | 248 <= (c[j >> 2] | 0)) : 0)l = 23
	                        } else if (!(DQ(a, 199744) | 0))l = 23;
	                        do if ((l | 0) == 23) {
	                            l = 0;
	                            if ((c[j >> 2] | 0) >= 256) {
	                                if (19968 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 40869 | (c[j >> 2] | 0) == 12295)break;
	                                if (12321 <= (c[j >> 2] | 0) & (c[j >> 2] | 0) <= 12329)break
	                            }
	                            a = c[j >> 2] | 0;
	                            if ((c[j >> 2] | 0) < 256) {
	                                if (48 <= (a | 0) & (c[j >> 2] | 0) <= 57 | (c[j >> 2] | 0) == 46 | (c[j >> 2] | 0) == 45 | (c[j >> 2] | 0) == 95 | (c[j >> 2] | 0) == 58)break
	                            } else {
	                                m = (DQ(a, 200216) | 0) != 0;
	                                if (m | (c[j >> 2] | 0) == 46 | (c[j >> 2] | 0) == 45 | (c[j >> 2] | 0) == 95 | (c[j >> 2] | 0) == 58)break
	                            }
	                            if ((c[j >> 2] | 0) >= 256 ? (DQ(c[j >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                            m = c[j >> 2] | 0;
	                            if ((c[j >> 2] | 0) < 256)n = (m | 0) == 183 & 1; else n = DQ(m, 200272) | 0;
	                            if (!n)break b
	                        } while (0);
	                        m = c[k >> 2] | 0;
	                        c[k >> 2] = m + 1;
	                        if (((m | 0) > 100 ? (c[k >> 2] = 0, (c[(c[f >> 2] | 0) + 292 >> 2] | 0) == 0) : 0) ? ((c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 20 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0) < 250 : 0)ke(c[(c[f >> 2] | 0) + 36 >> 2] | 0, 250) | 0;
	                        c[g >> 2] = (c[g >> 2] | 0) + (c[h >> 2] | 0);
	                        m = c[(c[f >> 2] | 0) + 36 >> 2] | 0;
	                        if ((d[c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 10) {
	                            a = m + 28 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] = 1
	                        } else {
	                            a = m + 32 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1
	                        }
	                        c[(c[f >> 2] | 0) + 176 >> 2] = 0;
	                        a = (c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + (c[h >> 2] | 0);
	                        a = (c[f >> 2] | 0) + 200 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[j >> 2] = ap(c[f >> 2] | 0, h) | 0
	                    }
	                    c[e >> 2] = AP(c[(c[f >> 2] | 0) + 296 >> 2] | 0, (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (0 - (c[g >> 2] | 0)) | 0, c[g >> 2] | 0) | 0;
	                    o = c[e >> 2] | 0;
	                    i = b;
	                    return o | 0
	                } while (0);
	                c[e >> 2] = 0;
	                o = c[e >> 2] | 0;
	                i = b;
	                return o | 0
	            }

	            function Po(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 112 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                j = e + 12 | 0;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(65 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 90 : 0))k = 3;
	                do if ((k | 0) == 3) {
	                    if (97 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 122 : 0)break;
	                    if (((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 95 ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 58 : 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 46 : 0) {
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } while (0);
	                while (1) {
	                    do if ((c[h >> 2] | 0) < 100) {
	                        if (65 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 90 : 0) {
	                            m = 1;
	                            break
	                        }
	                        if (97 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 122 : 0) {
	                            m = 1;
	                            break
	                        }
	                        if (48 <= (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                            m = 1;
	                            break
	                        }
	                        if (((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 58 ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) != 95 : 0)m = (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 46; else m = 1
	                    } else m = 0; while (0);
	                    n = c[g >> 2] | 0;
	                    if (!m)break;
	                    if ((d[c[(c[n + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) >= 65 ? (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) <= 90 : 0)a[j + (c[h >> 2] | 0) >> 0] = (d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0) + 32; else a[j + (c[h >> 2] | 0) >> 0] = d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    me(c[g >> 2] | 0)
	                }
	                c[f >> 2] = AP(c[n + 296 >> 2] | 0, j, c[h >> 2] | 0) | 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function Qo(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    if (!(c[(c[e >> 2] | 0) + 184 >> 2] | 0))break;
	                    if (!(wo(c[f >> 2] | 0, c[(c[e >> 2] | 0) + 184 >> 2] | 0) | 0))break;
	                    if ((c[c[e >> 2] >> 2] | 0) != 0 ? (c[(c[c[e >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[e >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[(c[e >> 2] | 0) + 184 >> 2] | 0);
	                    Co(c[e >> 2] | 0) | 0
	                }
	                if (!(c[f >> 2] | 0)) {
	                    Do(c[e >> 2] | 0);
	                    i = d;
	                    return
	                }
	                while (1) {
	                    if (c[f >> 2] | 0) {
	                        g = 20;
	                        break
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 184 >> 2] | 0)) {
	                        g = 20;
	                        break
	                    }
	                    if (((qy(c[(c[e >> 2] | 0) + 184 >> 2] | 0, 95656) | 0) == 0 ? (qy(c[(c[e >> 2] | 0) + 184 >> 2] | 0, 95648) | 0) == 0 : 0) ? (qy(c[(c[e >> 2] | 0) + 184 >> 2] | 0, 94240) | 0) == 0 : 0) {
	                        g = 20;
	                        break
	                    }
	                    if ((c[c[e >> 2] >> 2] | 0) != 0 ? (c[(c[c[e >> 2] >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)Ab[c[(c[c[e >> 2] >> 2] | 0) + 60 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[(c[e >> 2] | 0) + 184 >> 2] | 0);
	                    Co(c[e >> 2] | 0) | 0
	                }
	                if ((g | 0) == 20) {
	                    i = d;
	                    return
	                }
	            }

	            function Ro(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!((c[23702] | 0) != 0 ? (c[(c[e >> 2] | 0) + 360 >> 2] & 8192 | 0) == 0 : 0)) {
	                    i = d;
	                    return
	                }
	                if (qy(c[f >> 2] | 0, 94240) | 0) {
	                    i = d;
	                    return
	                }
	                if (((c[(c[e >> 2] | 0) + 188 >> 2] | 0) <= 0 ? (Uo(c[e >> 2] | 0, 94240) | 0, (c[c[e >> 2] >> 2] | 0) != 0) : 0) ? (c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] | 0) != 0 : 0)Db[c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, 94240, 0);
	                if (qy(c[f >> 2] | 0, 95648) | 0) {
	                    i = d;
	                    return
	                }
	                if (qy(c[f >> 2] | 0, 95656) | 0) {
	                    i = d;
	                    return
	                }
	                do if ((c[(c[e >> 2] | 0) + 188 >> 2] | 0) <= 1) {
	                    if ((((((qy(c[f >> 2] | 0, 94992) | 0) == 0 ? (qy(c[f >> 2] | 0, 95e3) | 0) == 0 : 0) ? (qy(c[f >> 2] | 0, 96200) | 0) == 0 : 0) ? (qy(c[f >> 2] | 0, 96208) | 0) == 0 : 0) ? (qy(c[f >> 2] | 0, 96216) | 0) == 0 : 0) ? (qy(c[f >> 2] | 0, 96224) | 0) == 0 : 0)break;
	                    if ((c[(c[e >> 2] | 0) + 32 >> 2] | 0) >= 3) {
	                        i = d;
	                        return
	                    }
	                    Uo(c[e >> 2] | 0, 95656) | 0;
	                    if (!(c[c[e >> 2] >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    if (!(c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    Db[c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, 95656, 0);
	                    i = d;
	                    return
	                } while (0);
	                if (qy(c[f >> 2] | 0, 96232) | 0) {
	                    i = d;
	                    return
	                }
	                if (qy(c[f >> 2] | 0, 96248) | 0) {
	                    i = d;
	                    return
	                }
	                if (qy(c[f >> 2] | 0, 96256) | 0) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 32 >> 2] | 0) >= 10) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) >= (c[(c[e >> 2] | 0) + 188 >> 2] | 0)) {
	                        h = 29;
	                        break
	                    }
	                    if (qy(c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0, 95648) | 0) {
	                        h = 32;
	                        break
	                    }
	                    if (qy(c[(c[(c[e >> 2] | 0) + 196 >> 2] | 0) + (c[g >> 2] << 2) >> 2] | 0, 95656) | 0) {
	                        h = 32;
	                        break
	                    }
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                if ((h | 0) == 29) {
	                    Uo(c[e >> 2] | 0, 95648) | 0;
	                    if (!(c[c[e >> 2] >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    if (!(c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    Db[c[(c[c[e >> 2] >> 2] | 0) + 56 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, 95648, 0);
	                    i = d;
	                    return
	                } else if ((h | 0) == 32) {
	                    i = d;
	                    return
	                }
	            }

	            function So(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[k >> 2] = 0;
	                c[c[h >> 2] >> 2] = 0;
	                c[j >> 2] = Po(c[g >> 2] | 0) | 0;
	                b = c[g >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    zo(b, 68, 97912, 0, 0);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                Fo(b) | 0;
	                if ((d[c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 61) {
	                    me(c[g >> 2] | 0);
	                    Fo(c[g >> 2] | 0) | 0;
	                    c[k >> 2] = hp(c[g >> 2] | 0) | 0
	                }
	                c[c[h >> 2] >> 2] = c[k >> 2];
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function To(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = 0;
	                b = c[g >> 2] | 0;
	                c[g >> 2] = b + 1;
	                c[h >> 2] = c[(c[f >> 2] | 0) + (b << 2) >> 2];
	                while (1) {
	                    if (!(c[h >> 2] | 0))break;
	                    b = c[g >> 2] | 0;
	                    c[g >> 2] = b + 1;
	                    c[j >> 2] = c[(c[f >> 2] | 0) + (b << 2) >> 2];
	                    if (((c[j >> 2] | 0) != 0 ? (ty(c[h >> 2] | 0, 97872) | 0) == 0 : 0) ? (ty(c[j >> 2] | 0, 97888) | 0) == 0 : 0)c[k >> 2] = 1; else m = 8;
	                    do if ((m | 0) == 8) {
	                        m = 0;
	                        if ((c[j >> 2] | 0) != 0 ? (ty(c[h >> 2] | 0, 94816) | 0) == 0 : 0) {
	                            gp(c[e >> 2] | 0, c[j >> 2] | 0);
	                            break
	                        }
	                        if ((c[j >> 2] | 0) != 0 ? (ty(c[h >> 2] | 0, 97904) | 0) == 0 : 0)c[l >> 2] = c[j >> 2]
	                    } while (0);
	                    b = c[g >> 2] | 0;
	                    c[g >> 2] = b + 1;
	                    c[h >> 2] = c[(c[f >> 2] | 0) + (b << 2) >> 2]
	                }
	                if (!((c[k >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0)) {
	                    i = d;
	                    return
	                }
	                Mo(c[e >> 2] | 0, c[l >> 2] | 0);
	                i = d;
	                return
	            }

	            function Uo(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 32 >> 2] | 0) < 3 ? (qy(c[g >> 2] | 0, 95656) | 0) != 0 : 0)c[(c[f >> 2] | 0) + 32 >> 2] = 3;
	                if ((c[(c[f >> 2] | 0) + 32 >> 2] | 0) < 10 ? (qy(c[g >> 2] | 0, 95648) | 0) != 0 : 0)c[(c[f >> 2] | 0) + 32 >> 2] = 10;
	                if ((c[(c[f >> 2] | 0) + 188 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 192 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 192 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 196 >> 2] | 0, c[(c[f >> 2] | 0) + 192 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 196 >> 2] = b, (c[(c[f >> 2] | 0) + 196 >> 2] | 0) == 0) : 0) {
	                    xo(c[f >> 2] | 0, 0);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[(c[f >> 2] | 0) + 196 >> 2] | 0) + (c[(c[f >> 2] | 0) + 188 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 184 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 188 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function rF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
	                b = i;
	                i = i + 80 | 0;
	                d = b + 64 | 0;
	                e = b + 60 | 0;
	                f = b + 56 | 0;
	                g = b + 52 | 0;
	                h = b + 48 | 0;
	                j = b + 44 | 0;
	                k = b + 40 | 0;
	                l = b + 36 | 0;
	                m = b + 32 | 0;
	                n = b + 28 | 0;
	                o = b + 24 | 0;
	                p = b + 20 | 0;
	                q = b + 16 | 0;
	                r = b + 12 | 0;
	                s = b + 8 | 0;
	                t = b + 4 | 0;
	                u = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 56 >> 2];
	                a:while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        v = 48;
	                        break
	                    }
	                    b:do if (((c[(c[f >> 2] | 0) + 20 >> 2] | 0) == 24 ? (c[(c[f >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        c[q >> 2] = 0;
	                        c[m >> 2] = c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2];
	                        c[g >> 2] = c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 52 >> 2];
	                        while (1) {
	                            if (!(c[g >> 2] | 0))break;
	                            if ((c[(c[(c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == (c[(c[g >> 2] | 0) + 4 >> 2] | 0))break;
	                            c[g >> 2] = c[c[g >> 2] >> 2]
	                        }
	                        if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)w = (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) != 0; else w = 0;
	                        c[n >> 2] = w ? 1 : 0;
	                        c[h >> 2] = 0;
	                        while (1) {
	                            if ((c[h >> 2] | 0) >= (c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0))break b;
	                            c[l >> 2] = 0;
	                            c[q >> 2] = c[(c[c[(c[f >> 2] | 0) + 32 >> 2] >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                            c:do if (c[g >> 2] | 0) {
	                                c[o >> 2] = c[(c[q >> 2] | 0) + 4 >> 2];
	                                c[j >> 2] = 0;
	                                while (1) {
	                                    if ((c[j >> 2] | 0) >= (c[(c[g >> 2] | 0) + 12 >> 2] | 0))break;
	                                    c[p >> 2] = c[(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                    c[k >> 2] = 0;
	                                    while (1) {
	                                        if ((c[k >> 2] | 0) >= (c[m >> 2] | 0))break;
	                                        c[l >> 2] = VD(c[(c[(c[p >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                        if (!(c[l >> 2] | 0))break;
	                                        if ((c[l >> 2] | 0) == -1) {
	                                            v = 22;
	                                            break a
	                                        }
	                                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                                    }
	                                    if ((c[l >> 2] | 0) == 1)break;
	                                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                                }
	                                if ((c[l >> 2] | 0) == 0 & (c[n >> 2] | 0) != 0) {
	                                    c[j >> 2] = 0;
	                                    while (1) {
	                                        if ((c[j >> 2] | 0) >= (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0))break c;
	                                        c[p >> 2] = c[(c[(c[c[(c[g >> 2] | 0) + 20 >> 2] >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                        c[k >> 2] = 0;
	                                        while (1) {
	                                            if ((c[k >> 2] | 0) >= (c[m >> 2] | 0))break;
	                                            c[l >> 2] = VD(c[(c[(c[p >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[o >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                            if (!(c[l >> 2] | 0))break;
	                                            if ((c[l >> 2] | 0) == -1) {
	                                                v = 33;
	                                                break a
	                                            }
	                                            c[k >> 2] = (c[k >> 2] | 0) + 1
	                                        }
	                                        if ((c[l >> 2] | 0) == 1)break;
	                                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                                    }
	                                    c[r >> 2] = 0;
	                                    c[s >> 2] = 0;
	                                    a = c[e >> 2] | 0;
	                                    x = c[q >> 2] | 0;
	                                    y = c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
	                                    z = $G(c[e >> 2] | 0, r, c[(c[q >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                    eH(a, 1877, x, y, 142400, z, YD(s, c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0);
	                                    if (c[r >> 2] | 0) {
	                                        zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                        c[r >> 2] = 0
	                                    }
	                                    if (c[s >> 2] | 0) {
	                                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                                        c[s >> 2] = 0
	                                    }
	                                }
	                            } while (0);
	                            if (!(c[l >> 2] | 0)) {
	                                c[t >> 2] = 0;
	                                c[u >> 2] = 0;
	                                z = c[e >> 2] | 0;
	                                y = c[q >> 2] | 0;
	                                x = c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
	                                a = $G(c[e >> 2] | 0, t, c[(c[q >> 2] | 0) + 4 >> 2] | 0, c[m >> 2] | 0) | 0;
	                                eH(z, 1877, y, x, 142464, a, YD(u, c[(c[(c[f >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0);
	                                if (c[t >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                                    c[t >> 2] = 0
	                                }
	                                if (c[u >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                                    c[u >> 2] = 0
	                                }
	                            }
	                            c[h >> 2] = (c[h >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 8 >> 2]
	                }
	                if ((v | 0) == 22) {
	                    c[d >> 2] = -1;
	                    A = c[d >> 2] | 0;
	                    i = b;
	                    return A | 0
	                } else if ((v | 0) == 33) {
	                    c[d >> 2] = -1;
	                    A = c[d >> 2] | 0;
	                    i = b;
	                    return A | 0
	                } else if ((v | 0) == 48) {
	                    c[d >> 2] = 0;
	                    A = c[d >> 2] | 0;
	                    i = b;
	                    return A | 0
	                }
	                return 0
	            }

	            function sF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                b = i;
	                i = i + 80 | 0;
	                d = b + 64 | 0;
	                e = b + 60 | 0;
	                f = b + 56 | 0;
	                g = b + 52 | 0;
	                h = b + 48 | 0;
	                j = b + 44 | 0;
	                k = b + 40 | 0;
	                l = b + 36 | 0;
	                m = b + 32 | 0;
	                n = b + 28 | 0;
	                o = b + 24 | 0;
	                p = b + 20 | 0;
	                q = b + 16 | 0;
	                r = b + 12 | 0;
	                s = b + 8 | 0;
	                t = b + 4 | 0;
	                u = b;
	                c[e >> 2] = a;
	                c[h >> 2] = 0;
	                c[k >> 2] = 0;
	                c[r >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + 52 >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    v = c[d >> 2] | 0;
	                    i = b;
	                    return v | 0
	                }
	                c[g >> 2] = (c[(c[(c[e >> 2] | 0) + 100 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) - 1 << 2) >> 2] | 0) + 52;
	                a:while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        w = 87;
	                        break
	                    }
	                    if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                        if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0)w = 8
	                    } else w = 8;
	                    b:do if ((w | 0) == 8) {
	                        w = 0;
	                        c:do if (!(c[(c[e >> 2] | 0) + 188 >> 2] | 0)) {
	                            c[n >> 2] = c[(c[e >> 2] | 0) + 112 >> 2];
	                            while (1) {
	                                x = c[n >> 2] | 0;
	                                if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                                c[n >> 2] = c[x >> 2];
	                                if (!(c[n >> 2] | 0))break c
	                            }
	                            if ((c[x + 8 >> 2] | 0) == -1)break b;
	                            if ((c[(c[n >> 2] | 0) + 8 >> 2] | 0) >= (c[(c[e >> 2] | 0) + 96 >> 2] | 0))break b
	                        } while (0);
	                        if (c[g >> 2] | 0)c[h >> 2] = c[c[g >> 2] >> 2];
	                        while (1) {
	                            if (!(c[h >> 2] | 0))break;
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == (c[(c[f >> 2] | 0) + 4 >> 2] | 0))break;
	                            c[h >> 2] = c[c[h >> 2] >> 2]
	                        }
	                        if (!(c[h >> 2] | 0)) {
	                            c[h >> 2] = fH(c[(c[f >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            if (!(c[h >> 2] | 0))break a;
	                            do if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                                if (!(c[(c[e >> 2] | 0) + 192 >> 2] | 0)) {
	                                    c[(c[h >> 2] | 0) + 8 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                                    c[(c[h >> 2] | 0) + 16 >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                                    c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                                    c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                                    c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                                    break
	                                }
	                                a = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 12 >> 2] << 2) | 0;
	                                c[(c[h >> 2] | 0) + 8 >> 2] = a;
	                                if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0)) {
	                                    w = 76;
	                                    break a
	                                }
	                                c[(c[h >> 2] | 0) + 16 >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                                c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                                eU(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] << 2 | 0) | 0
	                            } while (0);
	                            if (c[(c[f >> 2] | 0) + 20 >> 2] | 0) {
	                                if (c[(c[h >> 2] | 0) + 20 >> 2] | 0)oB(c[(c[h >> 2] | 0) + 20 >> 2] | 0);
	                                c[(c[h >> 2] | 0) + 20 >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                                c[(c[f >> 2] | 0) + 20 >> 2] = 0
	                            }
	                            if (!(c[g >> 2] | 0))break;
	                            if (!(c[c[g >> 2] >> 2] | 0)) {
	                                c[c[g >> 2] >> 2] = c[h >> 2];
	                                break
	                            } else {
	                                c[c[h >> 2] >> 2] = c[c[g >> 2] >> 2];
	                                c[c[g >> 2] >> 2] = c[h >> 2];
	                                break
	                            }
	                        }
	                        c[t >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                        if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                            c[u >> 2] = c[(c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2];
	                            c[l >> 2] = c[c[(c[h >> 2] | 0) + 20 >> 2] >> 2]
	                        } else {
	                            c[l >> 2] = 0;
	                            c[u >> 2] = 0
	                        }
	                        c[m >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                        c[s >> 2] = c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 32 >> 2];
	                        c[o >> 2] = 0;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[(c[f >> 2] | 0) + 12 >> 2] | 0))break b;
	                            c[j >> 2] = c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                            do if (c[j >> 2] | 0) {
	                                if (c[u >> 2] | 0) {
	                                    c[p >> 2] = 0;
	                                    d:while (1) {
	                                        if ((c[p >> 2] | 0) >= (c[u >> 2] | 0))break;
	                                        e:do if ((c[s >> 2] | 0) == 1) {
	                                            c[r >> 2] = VD(c[(c[c[(c[j >> 2] | 0) + 4 >> 2] >> 2] | 0) + 4 >> 2] | 0, c[(c[c[(c[(c[l >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 4 >> 2] >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                            if ((c[r >> 2] | 0) == -1)break a;
	                                            if (c[r >> 2] | 0)break;
	                                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                                            continue d
	                                        } else {
	                                            c[k >> 2] = c[(c[l >> 2] | 0) + (c[p >> 2] << 2) >> 2];
	                                            c[q >> 2] = 0;
	                                            while (1) {
	                                                if ((c[q >> 2] | 0) >= (c[s >> 2] | 0))break e;
	                                                c[r >> 2] = VD(c[(c[(c[(c[j >> 2] | 0) + 4 >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[(c[k >> 2] | 0) + 4 >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                                if ((c[r >> 2] | 0) == -1)break a;
	                                                if (!(c[r >> 2] | 0))break e;
	                                                c[q >> 2] = (c[q >> 2] | 0) + 1
	                                            }
	                                        } while (0);
	                                        if ((c[r >> 2] | 0) == 1)break;
	                                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                                    }
	                                    if (!((c[t >> 2] | 0) != 0 ? (c[p >> 2] | 0) == (c[u >> 2] | 0) : 0))break
	                                } else if (!(c[t >> 2] | 0))break;
	                                c[p >> 2] = 0;
	                                f:while (1) {
	                                    if ((c[p >> 2] | 0) >= (c[t >> 2] | 0))break;
	                                    c[k >> 2] = c[(c[m >> 2] | 0) + (c[p >> 2] << 2) >> 2];
	                                    g:do if ((c[s >> 2] | 0) == 1) {
	                                        c[r >> 2] = VD(c[(c[c[(c[j >> 2] | 0) + 4 >> 2] >> 2] | 0) + 4 >> 2] | 0, c[(c[c[(c[k >> 2] | 0) + 4 >> 2] >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                        if ((c[r >> 2] | 0) == -1)break a;
	                                        if (!(c[r >> 2] | 0)) {
	                                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                                            continue f
	                                        }
	                                    } else {
	                                        c[q >> 2] = 0;
	                                        while (1) {
	                                            if ((c[q >> 2] | 0) >= (c[s >> 2] | 0))break g;
	                                            c[r >> 2] = VD(c[(c[(c[(c[j >> 2] | 0) + 4 >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[(c[k >> 2] | 0) + 4 >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                            if ((c[r >> 2] | 0) == -1)break a;
	                                            if (!(c[r >> 2] | 0))break g;
	                                            c[q >> 2] = (c[q >> 2] | 0) + 1
	                                        }
	                                    } while (0);
	                                    if ((c[r >> 2] | 0) == 1)break;
	                                    c[p >> 2] = (c[p >> 2] | 0) + 1
	                                }
	                                if ((c[p >> 2] | 0) != (c[t >> 2] | 0)) {
	                                    c[t >> 2] = (c[t >> 2] | 0) + -1;
	                                    a = (c[h >> 2] | 0) + 12 | 0;
	                                    c[a >> 2] = (c[a >> 2] | 0) + -1;
	                                    c[(c[m >> 2] | 0) + (c[p >> 2] << 2) >> 2] = c[(c[m >> 2] | 0) + (c[t >> 2] << 2) >> 2];
	                                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) != (c[t >> 2] | 0))c[(c[m >> 2] | 0) + (c[t >> 2] << 2) >> 2] = c[(c[m >> 2] | 0) + (c[(c[h >> 2] | 0) + 12 >> 2] << 2) >> 2];
	                                    if ((c[(c[h >> 2] | 0) + 20 >> 2] | 0) == 0 ? (a = JB() | 0, c[(c[h >> 2] | 0) + 20 >> 2] = a, (c[(c[h >> 2] | 0) + 20 >> 2] | 0) == 0) : 0)break a;
	                                    bE(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[k >> 2] | 0) | 0;
	                                    break
	                                }
	                                if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                                    if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) >= (c[(c[h >> 2] | 0) + 16 >> 2] | 0) ? (a = (c[h >> 2] | 0) + 16 | 0, c[a >> 2] = c[a >> 2] << 1, a = Hb[c[135760 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] << 2) | 0, c[(c[h >> 2] | 0) + 8 >> 2] = a, (c[(c[h >> 2] | 0) + 8 >> 2] | 0) == 0) : 0) {
	                                        w = 68;
	                                        break a
	                                    }
	                                } else {
	                                    a = Cb[c[135744 >> 2] & 511](40) | 0;
	                                    c[(c[h >> 2] | 0) + 8 >> 2] = a;
	                                    if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0)) {
	                                        w = 64;
	                                        break a
	                                    }
	                                    c[(c[h >> 2] | 0) + 16 >> 2] = 1
	                                }
	                                c[m >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                                a = c[j >> 2] | 0;
	                                y = (c[h >> 2] | 0) + 12 | 0;
	                                z = c[y >> 2] | 0;
	                                c[y >> 2] = z + 1;
	                                c[(c[m >> 2] | 0) + (z << 2) >> 2] = a
	                            } while (0);
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[f >> 2] = c[c[f >> 2] >> 2]
	                }
	                if ((w | 0) == 64)IB(0, 142168, 0); else if ((w | 0) == 68)IB(0, 142208, 0); else if ((w | 0) == 76) {
	                    IB(0, 142256, 0);
	                    OD(c[h >> 2] | 0)
	                } else if ((w | 0) == 87) {
	                    c[d >> 2] = 0;
	                    v = c[d >> 2] | 0;
	                    i = b;
	                    return v | 0
	                }
	                c[d >> 2] = -1;
	                v = c[d >> 2] | 0;
	                i = b;
	                return v | 0
	            }

	            function tF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = rB() | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[(c[h >> 2] | 0) + 80 >> 2] = c[g >> 2];
	                yP(c[g >> 2] | 0) | 0;
	                if (c[f >> 2] | 0) {
	                    b = AP(c[g >> 2] | 0, c[f >> 2] | 0, -1) | 0;
	                    c[(c[h >> 2] | 0) + 44 >> 2] = b
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function uF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    IB(c[f >> 2] | 0, 141168, 0);
	                    i = d;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 8 >> 2] = -1;
	                c[(c[g >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                c[c[g >> 2] >> 2] = 0;
	                if (!(c[(c[f >> 2] | 0) + 112 >> 2] | 0))c[(c[f >> 2] | 0) + 112 >> 2] = c[g >> 2]; else {
	                    c[c[g >> 2] >> 2] = c[(c[f >> 2] | 0) + 112 >> 2];
	                    c[(c[f >> 2] | 0) + 112 >> 2] = c[g >> 2]
	                }
	                if (c[(c[f >> 2] | 0) + 184 >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if ((c[c[e >> 2] >> 2] | 0) != 24) {
	                    i = d;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 184 >> 2] = 1;
	                i = d;
	                return
	            }

	            function vF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[(c[d >> 2] | 0) + 8 >> 2];
	                    if (c[(c[d >> 2] | 0) + 24 >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        while (1) {
	                            if ((c[f >> 2] | 0) >= (c[(c[d >> 2] | 0) + 28 >> 2] | 0))break;
	                            if (c[(c[(c[d >> 2] | 0) + 24 >> 2] | 0) + (c[f >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[d >> 2] | 0) + 24 >> 2] | 0) + (c[f >> 2] << 2) >> 2] | 0);
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0)
	                    }
	                    if (c[(c[d >> 2] | 0) + 32 >> 2] | 0) {
	                        a:do if ((c[(c[d >> 2] | 0) + 20 >> 2] | 0) == 24) {
	                            c[g >> 2] = 0;
	                            while (1) {
	                                if ((c[g >> 2] | 0) >= (c[(c[(c[d >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0))break a;
	                                c[h >> 2] = c[(c[c[(c[d >> 2] | 0) + 32 >> 2] >> 2] | 0) + (c[g >> 2] << 2) >> 2];
	                                zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 4 >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                                c[g >> 2] = (c[g >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        oB(c[(c[d >> 2] | 0) + 32 >> 2] | 0)
	                    }
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function wF(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (c[c[d >> 2] >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                    c[c[d >> 2] >> 2] = 0
	                }
	                c[(c[d >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 8 >> 2] = 0;
	                i = b;
	                return
	            }

	            function xF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do switch (c[e >> 2] | 0) {
	                    case 18:
	                    {
	                        c[d >> 2] = 143832;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = 143776;
	                        break
	                    }
	                    case 24:
	                    {
	                        c[d >> 2] = 144e3;
	                        break
	                    }
	                    case 6:
	                    {
	                        c[d >> 2] = 143856;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[d >> 2] = 143904;
	                        break
	                    }
	                    case 22:
	                    {
	                        c[d >> 2] = 143944;
	                        break
	                    }
	                    case 23:
	                    {
	                        c[d >> 2] = 143976;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = 143800;
	                        break
	                    }
	                    case 26:
	                    {
	                        c[d >> 2] = 143736;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = 143712;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = 143688;
	                        break
	                    }
	                    case 2e3:
	                    {
	                        c[d >> 2] = 144048;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[d >> 2] = 143880;
	                        break
	                    }
	                    case 2001:
	                    {
	                        c[d >> 2] = 144088;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[d >> 2] = 143688;
	                        break
	                    }
	                    case 25:
	                    {
	                        c[d >> 2] = 143928;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[d >> 2] = 143664;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = 144032;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = 143752;
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 144136
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function yF(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 24 | 0;
	                l = j + 20 | 0;
	                m = j + 16 | 0;
	                n = j + 12 | 0;
	                o = j + 8 | 0;
	                p = j + 4 | 0;
	                q = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                $D(c[k >> 2] | 0, 2, c[l >> 2] | 0, c[m >> 2] | 0, 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, 0);
	                i = j;
	                return
	            }

	            function zF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                c[o >> 2] = 0;
	                if (c[c[h >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[h >> 2] >> 2] | 0);
	                c[c[h >> 2] >> 2] = 0;
	                a:while (1) {
	                    c[l >> 2] = QD(c[(c[j >> 2] | 0) + 64 >> 2] | 0) | 0;
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 68 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        if ((c[c[k >> 2] >> 2] | 0) == 1007) {
	                            c[o >> 2] = 1;
	                            c[n >> 2] = gH(c[(c[k >> 2] | 0) + 32 >> 2] | 0, c[l >> 2] | 0, m) | 0;
	                            if ((c[n >> 2] | 0) == -1)break a;
	                            if (!(c[c[h >> 2] >> 2] | 0)) {
	                                d = my(142568) | 0;
	                                c[c[h >> 2] >> 2] = d
	                            } else {
	                                d = By(c[c[h >> 2] >> 2] | 0, 157648) | 0;
	                                c[c[h >> 2] >> 2] = d
	                            }
	                            d = By(c[c[h >> 2] >> 2] | 0, c[m >> 2] | 0) | 0;
	                            c[c[h >> 2] >> 2] = d;
	                            d = By(c[c[h >> 2] >> 2] | 0, 142568) | 0;
	                            c[c[h >> 2] >> 2] = d;
	                            if (c[m >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                c[m >> 2] = 0
	                            }
	                        }
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 4 >> 2]
	                    }
	                    if (c[o >> 2] | 0) {
	                        p = 20;
	                        break
	                    }
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 64 >> 2];
	                    if (!(c[j >> 2] | 0)) {
	                        p = 20;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 1) {
	                        p = 20;
	                        break
	                    }
	                }
	                if ((p | 0) == 20) {
	                    c[f >> 2] = c[c[h >> 2] >> 2];
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                xB(c[g >> 2] | 0, 157568, 157600);
	                if (c[c[h >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[h >> 2] >> 2] | 0);
	                c[c[h >> 2] >> 2] = 0;
	                c[f >> 2] = 0;
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function AF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do switch (c[c[e >> 2] >> 2] | 0) {
	                    case 14:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                        break
	                    }
	                    case 2e3:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 56 >> 2];
	                        break
	                    }
	                    case 18:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        break
	                    }
	                    case 26:
	                    {
	                        if (c[(c[e >> 2] | 0) + 12 >> 2] | 0)c[d >> 2] = AF(c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0; else f = 13;
	                        break
	                    }
	                    case 24:
	                    case 22:
	                    case 23:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = 142520;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 52 >> 2];
	                        break
	                    }
	                    case 5:
	                    case 4:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 112 >> 2];
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        break
	                    }
	                    default:
	                        f = 13
	                } while (0);
	                if ((f | 0) == 13)c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function BF(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a:do switch (c[c[e >> 2] >> 2] | 0) {
	                    case 17:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        break
	                    }
	                    case 18:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                    case 5:
	                    case 4:
	                    case 1:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                    case 2e3:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        break
	                    }
	                    case 26:
	                    {
	                        if (c[(c[e >> 2] | 0) + 12 >> 2] | 0) {
	                            c[d >> 2] = BF(c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[d >> 2] = 0;
	                            break a
	                        }
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                        break
	                    }
	                    case 24:
	                    case 22:
	                    case 23:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 0
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function CF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[j >> 2] = hH(c[g >> 2] | 0) | 0;
	                c[h >> 2] = Eh(c[j >> 2] | 0, 1) | 0;
	                do if (!(c[h >> 2] | 0)) {
	                    if ((c[(c[g >> 2] | 0) + 40 >> 2] | 0) != 2) {
	                        c[l >> 2] = SH(c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                            c[j >> 2] = c[l >> 2]
	                        }
	                        c[k >> 2] = Cm(0, c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[j >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            c[h >> 2] = 3037;
	                            b = c[f >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            n = IH(23) | 0;
	                            hE(b, 3037, 0, a, n, 0, 0, 161408, c[j >> 2] | 0, 0);
	                            break
	                        } else {
	                            c[(c[g >> 2] | 0) + 40 >> 2] = 2;
	                            break
	                        }
	                    }
	                } else if ((c[h >> 2] | 0) > 0) {
	                    c[h >> 2] = 3037;
	                    n = c[f >> 2] | 0;
	                    a = c[g >> 2] | 0;
	                    b = IH(23) | 0;
	                    hE(n, 3037, 0, a, b, 0, 0, 161456, c[j >> 2] | 0, 0)
	                } while (0);
	                if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                c[e >> 2] = c[h >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function DF(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                if ((c[c[n >> 2] >> 2] | 0) != 1) {
	                    xB(c[j >> 2] | 0, 162480, 162512);
	                    c[h >> 2] = -1;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                switch (c[(c[n >> 2] | 0) + 88 >> 2] | 0) {
	                    case 17:
	                    case 16:
	                    case 29:
	                    case 21:
	                    case 22:
	                        break;
	                    default:
	                    {
	                        xB(c[j >> 2] | 0, 162480, 162552);
	                        c[h >> 2] = -1;
	                        p = c[h >> 2] | 0;
	                        i = g;
	                        return p | 0
	                    }
	                }
	                c[o >> 2] = TH(c[n >> 2] | 0, c[m >> 2] | 0, 0, c[l >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) < 0) {
	                    xB(c[j >> 2] | 0, 162480, 162624);
	                    c[h >> 2] = -1;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                if ((c[o >> 2] | 0) > 0) {
	                    if (c[(c[n >> 2] | 0) + 48 >> 2] & 64)c[o >> 2] = 1825; else c[o >> 2] = 1824;
	                    hE(c[j >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0, 0, c[m >> 2] | 0, 0, 0, 0)
	                }
	                c[h >> 2] = c[o >> 2];
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function EF(a, b, d, e, f, g, h, j, k, l, m, n) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                m = m | 0;
	                n = n | 0;
	                var o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
	                o = i;
	                i = i + 80 | 0;
	                p = o;
	                q = o + 76 | 0;
	                r = o + 72 | 0;
	                s = o + 68 | 0;
	                t = o + 64 | 0;
	                u = o + 60 | 0;
	                v = o + 56 | 0;
	                w = o + 52 | 0;
	                x = o + 48 | 0;
	                y = o + 44 | 0;
	                z = o + 40 | 0;
	                A = o + 36 | 0;
	                B = o + 32 | 0;
	                C = o + 28 | 0;
	                D = o + 24 | 0;
	                E = o + 20 | 0;
	                c[q >> 2] = a;
	                c[r >> 2] = b;
	                c[s >> 2] = d;
	                c[t >> 2] = e;
	                c[u >> 2] = f;
	                c[v >> 2] = g;
	                c[w >> 2] = h;
	                c[x >> 2] = j;
	                c[y >> 2] = k;
	                c[z >> 2] = l;
	                c[A >> 2] = m;
	                c[B >> 2] = n;
	                c[C >> 2] = 0;
	                c[D >> 2] = 0;
	                c[E >> 2] = 0;
	                if (c[q >> 2] | 0) {
	                    n = (c[q >> 2] | 0) + 20 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + 1;
	                    c[(c[q >> 2] | 0) + 16 >> 2] = c[s >> 2];
	                    c[C >> 2] = c[(c[q >> 2] | 0) + 8 >> 2];
	                    c[E >> 2] = c[(c[q >> 2] | 0) + 4 >> 2];
	                    c[D >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                }
	                n = c[D >> 2] | 0;
	                D = c[C >> 2] | 0;
	                C = c[E >> 2] | 0;
	                E = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                r = c[s >> 2] | 0;
	                s = c[t >> 2] | 0;
	                t = c[u >> 2] | 0;
	                u = c[v >> 2] | 0;
	                v = c[w >> 2] | 0;
	                w = c[y >> 2] | 0;
	                y = c[z >> 2] | 0;
	                z = c[A >> 2] | 0;
	                A = c[B >> 2] | 0;
	                c[p >> 2] = c[x >> 2];
	                c[p + 4 >> 2] = w;
	                c[p + 8 >> 2] = y;
	                c[p + 12 >> 2] = z;
	                c[p + 16 >> 2] = A;
	                Xd(n, D, C, E, q, 16, r, 2, 0, 0, s, t, u, 0, 0, v, p);
	                i = o;
	                return
	            }

	            function FF(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    tC(c[f >> 2] | 0, 168864, c[g >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    f = c[h >> 2] | 0;
	                    c[f + 0 >> 2] = 0;
	                    c[f + 4 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function GF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[f + 12 >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                HC(k, c[g >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0) | 0;
	                e = c[g >> 2] | 0;
	                g = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                d = c[k >> 2] | 0;
	                IC(e, g, h, 163216, d, iH(l, c[(c[j >> 2] | 0) + 36 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0, 0, 0);
	                if (c[k >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[k >> 2] = 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                c[l >> 2] = 0;
	                i = f;
	                return
	            }

	            function HF(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if ((c[k >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0) {
	                    if (c[p >> 2] | 0)c[c[p >> 2] >> 2] = 0;
	                    c[j >> 2] = -1;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                if ((c[c[o >> 2] >> 2] | 0) != 1) {
	                    if (c[p >> 2] | 0)c[c[p >> 2] >> 2] = 0;
	                    PC(c[k >> 2] | 0, c[m >> 2] | 0, 3069, 168672, c[(c[o >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[j >> 2] = -1;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                c[q >> 2] = dE(c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                if (c[q >> 2] | 0) {
	                    c[j >> 2] = eE(c[k >> 2] | 0, c[l >> 2] | 0, c[q >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                if (c[p >> 2] | 0)c[c[p >> 2] >> 2] = 0;
	                c[j >> 2] = 0;
	                r = c[j >> 2] | 0;
	                i = h;
	                return r | 0
	            }

	            function IF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0)) {
	                        m = 10;
	                        break
	                    }
	                    if (((c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0) != 0 : 0) {
	                        m = 8;
	                        break
	                    }
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                if ((m | 0) == 8) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((m | 0) == 10) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function JF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (c[h >> 2] | 0) {
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = c[h >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    c[m >> 2] = 0;
	                    c[k >> 2] = Xi(c[(c[j >> 2] | 0) + 32 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    d = c[h >> 2] | 0;
	                    if (!(c[k >> 2] | 0))c[l >> 2] = Hl(d, c[(c[(c[j >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) | 0; else {
	                        c[l >> 2] = Hl(d, c[k >> 2] | 0) | 0;
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                    }
	                    if (c[l >> 2] | 0) {
	                        c[m >> 2] = AP(c[g >> 2] | 0, c[l >> 2] | 0, -1) | 0;
	                        zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[f >> 2] = c[m >> 2];
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                }
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function KF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (c[(c[j >> 2] | 0) + 32 >> 2] | 0) {
	                    xB(c[g >> 2] | 0, 168128, 168152);
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                d = c[g >> 2] | 0;
	                if (!(c[(c[j >> 2] | 0) + 20 >> 2] | 0)) {
	                    xB(d, 168128, 168176);
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (!(c[d + 28 >> 2] | 0)) {
	                    xB(c[g >> 2] | 0, 168128, 155336);
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = tF(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 80 >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[(c[k >> 2] | 0) + 28 >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                c[(c[k >> 2] | 0) + 36 >> 2] = c[h >> 2];
	                aB(c[k >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                cB(c[k >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0);
	                c[(c[k >> 2] | 0) + 40 >> 2] = c[(c[g >> 2] | 0) + 40 >> 2];
	                c[l >> 2] = GB(c[k >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (c[l >> 2] | 0)c[(c[g >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                j = (c[g >> 2] | 0) + 20 | 0;
	                c[j >> 2] = (c[j >> 2] | 0) + (c[(c[k >> 2] | 0) + 20 >> 2] | 0);
	                c[(c[g >> 2] | 0) + 40 >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                c[(c[k >> 2] | 0) + 28 >> 2] = 0;
	                YA(c[k >> 2] | 0);
	                c[f >> 2] = c[l >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function LF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 40 | 0;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                q = f + 4 | 0;
	                r = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                c[o >> 2] = jH(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, n, c[l >> 2] | 0) | 0;
	                if (c[o >> 2] | 0) {
	                    c[g >> 2] = c[o >> 2];
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                c[o >> 2] = FB(c[h >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0, 0, 0, 0, c[k >> 2] | 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0, 0, r) | 0;
	                if (c[o >> 2] | 0) {
	                    c[g >> 2] = c[o >> 2];
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                a:do if ((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    e = c[(c[h >> 2] | 0) + 112 >> 2] | 0;
	                    do if (c[(c[r >> 2] | 0) + 12 >> 2] | 0) {
	                        if (!e) {
	                            AB(c[h >> 2] | 0, 3050, c[k >> 2] | 0, 0, 167648, c[n >> 2] | 0, 0);
	                            break
	                        }
	                        if (qy(c[(c[r >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0) | 0)break a;
	                        oG(c[h >> 2] | 0, 3050, 0, c[k >> 2] | 0, 167792, c[(c[r >> 2] | 0) + 12 >> 2] | 0, c[n >> 2] | 0, c[(c[h >> 2] | 0) + 112 >> 2] | 0)
	                    } else {
	                        if (!e)break a;
	                        c[p >> 2] = 1;
	                        if ((c[(c[r >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            AB(c[h >> 2] | 0, 3050, c[k >> 2] | 0, 0, 167912, c[n >> 2] | 0, 0);
	                            break
	                        }
	                        c[(c[r >> 2] | 0) + 16 >> 2] = c[(c[h >> 2] | 0) + 112 >> 2];
	                        break a
	                    } while (0);
	                    c[g >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                } else t = 9; while (0);
	                do if ((t | 0) == 9)if ((c[l >> 2] | 0) == 2) {
	                    c[o >> 2] = 3050;
	                    AB(c[h >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0, 0, 167544, c[n >> 2] | 0, 0);
	                    break
	                } else {
	                    c[o >> 2] = 3081;
	                    AB(c[h >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0, 0, 167592, c[n >> 2] | 0, 0);
	                    break
	                } while (0);
	                if (((c[r >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) ? (c[(c[r >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    do if (c[p >> 2] | 0)if (!(c[(c[j >> 2] | 0) + 24 >> 2] & 512)) {
	                        n = (c[j >> 2] | 0) + 24 | 0;
	                        c[n >> 2] = c[n >> 2] | 512;
	                        break
	                    } else {
	                        c[q >> 2] = 1;
	                        break
	                    } while (0);
	                    KF(c[h >> 2] | 0, c[j >> 2] | 0, c[r >> 2] | 0) | 0;
	                    if (!((c[p >> 2] | 0) == 0 | (c[q >> 2] | 0) != 0)) {
	                        q = (c[j >> 2] | 0) + 24 | 0;
	                        c[q >> 2] = c[q >> 2] ^ 512
	                    }
	                }
	                c[m >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((c[l >> 2] | 0) != 3) {
	                    if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                } else {
	                    c[(c[h >> 2] | 0) + 116 >> 2] = c[r >> 2];
	                    c[(c[h >> 2] | 0) + 100 >> 2] = 1;
	                    b:while (1) {
	                        if (!((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0))t = 37;
	                        do if ((t | 0) == 37) {
	                            t = 0;
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161008) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if (!(c[m >> 2] | 0))break b;
	                            if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0))break b;
	                            if (!(qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161064) | 0))break b;
	                            if (!(qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break b
	                        } while (0);
	                        if (!((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0))t = 57;
	                        do if ((t | 0) == 57) {
	                            t = 0;
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                oE(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                                break
	                            }
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161008) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                nE(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0, 1) | 0;
	                                break
	                            }
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                sE(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                                break
	                            }
	                            if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161064) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)rE(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0) | 0
	                        } while (0);
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                    }
	                    c[(c[h >> 2] | 0) + 116 >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 100 >> 2] = 0
	                }
	                do if (c[m >> 2] | 0) {
	                    c[o >> 2] = 3033;
	                    j = c[h >> 2] | 0;
	                    t = c[o >> 2] | 0;
	                    r = c[k >> 2] | 0;
	                    q = c[m >> 2] | 0;
	                    if ((c[l >> 2] | 0) == 3) {
	                        uE(j, t, 0, r, q, 0, 168056);
	                        break
	                    } else {
	                        uE(j, t, 0, r, q, 0, 161392);
	                        break
	                    }
	                } while (0);
	                c[g >> 2] = c[o >> 2];
	                s = c[g >> 2] | 0;
	                i = f;
	                return s | 0
	            }

	            function MF(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 0;
	                GC(p, 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                l = c[j >> 2] | 0;
	                j = c[m >> 2] | 0;
	                m = c[k >> 2] | 0;
	                k = c[p >> 2] | 0;
	                if (c[o >> 2] | 0)PC(l, j, m, 161256, k, c[o >> 2] | 0); else PC(l, j, m, 163272, k, c[n >> 2] | 0);
	                if (!(c[p >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                c[p >> 2] = 0;
	                i = h;
	                return
	            }

	            function NF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[j >> 2] = _i(c[h >> 2] | 0) | 0;
	                do if (!(qy(c[j >> 2] | 0, 165504) | 0)) {
	                    if (qy(c[j >> 2] | 0, 165512) | 0) {
	                        c[k >> 2] = 0;
	                        break
	                    }
	                    if (qy(c[j >> 2] | 0, 161736) | 0) {
	                        c[k >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[j >> 2] | 0, 165520) | 0) {
	                        c[k >> 2] = 0;
	                        break
	                    } else {
	                        d = c[f >> 2] | 0;
	                        b = c[g >> 2] | 0;
	                        a = c[h >> 2] | 0;
	                        l = IH(15) | 0;
	                        hE(d, 1714, b, a, l, 0, c[j >> 2] | 0, 0, 0, 0);
	                        break
	                    }
	                } else c[k >> 2] = 1; while (0);
	                if (!(c[j >> 2] | 0)) {
	                    m = c[k >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                m = c[k >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function OF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[c[l >> 2] >> 2] = 0;
	                c[m >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                c[(c[m >> 2] | 0) + 52 >> 2] = 4;
	                c[o >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    e = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (!(qy(c[e + 8 >> 2] | 0, 161384) | 0))GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                c[n >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    o = c[m >> 2] | 0;
	                    kH(o, jE(c[h >> 2] | 0, c[n >> 2] | 0, 1) | 0) | 0;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                if (!(c[n >> 2] | 0))uE(c[h >> 2] | 0, 3034, 0, c[k >> 2] | 0, 0, 0, 167392);
	                if (!(c[n >> 2] | 0))uE(c[h >> 2] | 0, 3034, 0, c[k >> 2] | 0, 0, 0, 167392);
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 165456) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    UF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 9) | 0;
	                    c[c[l >> 2] >> 2] = 1;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                } else q = 25;
	                if (((((q | 0) == 25 ? (c[n >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 165440) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    lH(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 9) | 0;
	                    c[c[l >> 2] >> 2] = 1;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                if (c[n >> 2] | 0)uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[n >> 2] | 0, 0, 167392);
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function PF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[c[l >> 2] >> 2] = 0;
	                c[m >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                c[o >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    e = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 167064) | 0) == 0 : 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                if ((gG(c[h >> 2] | 0, c[k >> 2] | 0, 167064, 0) | 0) != 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] & 1 | 0) == 0 : 0) {
	                    o = (c[m >> 2] | 0) + 48 | 0;
	                    c[o >> 2] = c[o >> 2] | 1
	                }
	                c[n >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    o = c[m >> 2] | 0;
	                    kH(o, jE(c[h >> 2] | 0, c[n >> 2] | 0, 1) | 0) | 0;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                if (!(c[n >> 2] | 0))uE(c[h >> 2] | 0, 3034, 0, c[k >> 2] | 0, 0, 0, 167392);
	                if (!(c[n >> 2] | 0))uE(c[h >> 2] | 0, 3034, 0, c[k >> 2] | 0, 0, 0, 167392);
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 165456) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    UF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 10) | 0;
	                    c[c[l >> 2] >> 2] = 1;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                } else q = 29;
	                if (((((q | 0) == 29 ? (c[n >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 165440) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    lH(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 10) | 0;
	                    c[c[l >> 2] >> 2] = 1;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                if (c[n >> 2] | 0)uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[n >> 2] | 0, 0, 167392);
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function QF(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                g = i;
	                i = i + 80 | 0;
	                h = g + 76 | 0;
	                j = g + 72 | 0;
	                k = g + 68 | 0;
	                l = g + 64 | 0;
	                m = g + 60 | 0;
	                n = g + 56 | 0;
	                o = g + 52 | 0;
	                p = g + 48 | 0;
	                q = g + 44 | 0;
	                r = g + 40 | 0;
	                s = g + 36 | 0;
	                t = g + 32 | 0;
	                u = g + 28 | 0;
	                v = g + 24 | 0;
	                w = g + 20 | 0;
	                x = g + 16 | 0;
	                y = g + 12 | 0;
	                z = g + 8 | 0;
	                A = g + 4 | 0;
	                B = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[s >> 2] = 1;
	                c[t >> 2] = 1;
	                c[v >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    C = c[h >> 2] | 0;
	                    i = g;
	                    return C | 0
	                }
	                c[o >> 2] = YE(c[j >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0, c[l >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    C = c[h >> 2] | 0;
	                    i = g;
	                    return C | 0
	                }
	                a:do if (c[n >> 2] | 0) {
	                    f = c[j >> 2] | 0;
	                    e = c[l >> 2] | 0;
	                    if ((c[m >> 2] | 0) == 8) {
	                        c[s >> 2] = XF(f, e, 0, 1, 1, 161728) | 0;
	                        c[t >> 2] = YF(c[j >> 2] | 0, c[l >> 2] | 0, 1, 1, 1, 161736) | 0
	                    } else {
	                        c[s >> 2] = XF(f, e, 0, -1, 1, 161744) | 0;
	                        c[t >> 2] = YF(c[j >> 2] | 0, c[l >> 2] | 0, 0, 1073741824, 1, 161768) | 0
	                    }
	                    ZF(c[j >> 2] | 0, 0, c[l >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0) | 0;
	                    c[p >> 2] = XE(c[j >> 2] | 0, c[l >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        c[h >> 2] = 0;
	                        C = c[h >> 2] | 0;
	                        i = g;
	                        return C | 0
	                    }
	                    c[(c[p >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                    c[r >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[r >> 2] | 0))break a;
	                        e = c[r >> 2] | 0;
	                        if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0)) {
	                            if (((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 161808) | 0) == 0 : 0) ? (qy(c[(c[r >> 2] | 0) + 8 >> 2] | 0, 161824) | 0) == 0 : 0)GF(c[j >> 2] | 0, 3035, 0, c[r >> 2] | 0)
	                        } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[j >> 2] | 0, 3035, 0, c[r >> 2] | 0);
	                        c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                    }
	                } else {
	                    c[r >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[r >> 2] | 0))break a;
	                        e = c[r >> 2] | 0;
	                        if (!(c[(c[r >> 2] | 0) + 36 >> 2] | 0)) {
	                            if (!(qy(c[e + 8 >> 2] | 0, 161384) | 0))GF(c[j >> 2] | 0, 3035, 0, c[r >> 2] | 0)
	                        } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[j >> 2] | 0, 3035, 0, c[r >> 2] | 0);
	                        c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                cE(c[j >> 2] | 0, c[l >> 2] | 0, 161384) | 0;
	                c[q >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    r = jE(c[j >> 2] | 0, c[q >> 2] | 0, 1) | 0;
	                    c[(c[o >> 2] | 0) + 4 >> 2] = r;
	                    c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                }
	                if ((c[m >> 2] | 0) == 8) {
	                    c[x >> 2] = 0;
	                    while (1) {
	                        if (!(c[q >> 2] | 0))break;
	                        if (!(c[(c[q >> 2] | 0) + 36 >> 2] | 0))break;
	                        if (!(qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161040) | 0))break;
	                        if (!(qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break;
	                        c[w >> 2] = pE(c[j >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0, u, 0) | 0;
	                        if (c[w >> 2] | 0) {
	                            if (c[u >> 2] | 0)c[v >> 2] = (c[v >> 2] | 0) + 1;
	                            if ((c[(c[w >> 2] | 0) + 16 >> 2] | 0) > 1) {
	                                GE(c[j >> 2] | 0, 3091, 0, c[q >> 2] | 0, 161840, 0);
	                                c[(c[w >> 2] | 0) + 16 >> 2] = 1
	                            }
	                            if ((c[(c[w >> 2] | 0) + 20 >> 2] | 0) > 1) {
	                                GE(c[j >> 2] | 0, 3091, 0, c[q >> 2] | 0, 161888, 0);
	                                c[(c[w >> 2] | 0) + 20 >> 2] = 1
	                            }
	                            m = c[w >> 2] | 0;
	                            if (!(c[x >> 2] | 0))c[(c[o >> 2] | 0) + 12 >> 2] = m; else c[(c[x >> 2] | 0) + 8 >> 2] = m;
	                            c[x >> 2] = c[w >> 2]
	                        }
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                    }
	                    if (c[q >> 2] | 0)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[q >> 2] | 0, 0, 161936)
	                } else {
	                    c[y >> 2] = 0;
	                    c[z >> 2] = 0;
	                    while (1) {
	                        if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161040) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)D = 1; else E = 59;
	                        do if ((E | 0) == 59) {
	                            E = 0;
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                D = 1;
	                                break
	                            }
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161976) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                D = 1;
	                                break
	                            }
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161656) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                D = 1;
	                                break
	                            }
	                            if (((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161664) | 0) != 0 : 0)D = (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0; else D = 0
	                        } while (0);
	                        F = (c[q >> 2] | 0) != 0;
	                        if (!D)break;
	                        if (((F ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161040) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            c[y >> 2] = pE(c[j >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0, u, 0) | 0;
	                            if ((c[y >> 2] | 0) != 0 & (c[u >> 2] | 0) != 0)c[v >> 2] = (c[v >> 2] | 0) + 1
	                        } else E = 82;
	                        do if ((E | 0) == 82) {
	                            E = 0;
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                c[y >> 2] = RF(c[j >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0) | 0;
	                                if (c[y >> 2] | 0)c[v >> 2] = (c[v >> 2] | 0) + 1;
	                                if (!(c[(c[j >> 2] | 0) + 100 >> 2] | 0))break;
	                                if (!(c[(c[j >> 2] | 0) + 120 >> 2] | 0))break;
	                                if (!((c[y >> 2] | 0) != 0 ? (c[c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 4 >> 2] >> 2] | 0) == 17 : 0))break;
	                                if (!(c[(c[y >> 2] | 0) + 12 >> 2] | 0))break;
	                                if ((c[(c[(c[y >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 16 >> 2] | 0))break;
	                                if ((c[(c[(c[y >> 2] | 0) + 12 >> 2] | 0) + 16 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 20 >> 2] | 0))break;
	                                do if (c[(c[j >> 2] | 0) + 124 >> 2] | 0) {
	                                    c[A >> 2] = 0;
	                                    w = c[j >> 2] | 0;
	                                    x = c[q >> 2] | 0;
	                                    AB(w, 3081, x, 0, 161984, BB(A, c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 16 >> 2] | 0) | 0, 0);
	                                    if (c[A >> 2] | 0) {
	                                        zb[c[135736 >> 2] & 511](c[A >> 2] | 0);
	                                        c[A >> 2] = 0
	                                    }
	                                    c[y >> 2] = 0
	                                } else {
	                                    if ((c[(c[y >> 2] | 0) + 16 >> 2] | 0) == 1 ? (c[(c[y >> 2] | 0) + 20 >> 2] | 0) == 1 : 0)break;
	                                    c[B >> 2] = 0;
	                                    x = c[j >> 2] | 0;
	                                    w = c[q >> 2] | 0;
	                                    AB(x, 3081, w, 0, 162096, BB(B, c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 16 >> 2] | 0) | 0, 0);
	                                    if (c[B >> 2] | 0) {
	                                        zb[c[135736 >> 2] & 511](c[B >> 2] | 0);
	                                        c[B >> 2] = 0
	                                    }
	                                    c[y >> 2] = 0
	                                } while (0);
	                                c[(c[(c[j >> 2] | 0) + 120 >> 2] | 0) + 8 >> 2] = c[y >> 2];
	                                w = (c[j >> 2] | 0) + 124 | 0;
	                                c[w >> 2] = (c[w >> 2] | 0) + 1;
	                                break
	                            }
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161976) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                c[y >> 2] = mH(c[j >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0) | 0;
	                                break
	                            }
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161656) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                c[y >> 2] = QF(c[j >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0, 7, 1) | 0;
	                                break
	                            }
	                            if ((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161664) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)c[y >> 2] = QF(c[j >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0, 6, 1) | 0
	                        } while (0);
	                        if (c[y >> 2] | 0) {
	                            w = c[y >> 2] | 0;
	                            if (!(c[z >> 2] | 0))c[(c[o >> 2] | 0) + 12 >> 2] = w; else c[(c[z >> 2] | 0) + 8 >> 2] = w;
	                            c[z >> 2] = c[y >> 2]
	                        }
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                    }
	                    if (F)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[q >> 2] | 0, 0, 162240)
	                }
	                if ((c[t >> 2] | 0) == 0 & (c[s >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    C = c[h >> 2] | 0;
	                    i = g;
	                    return C | 0
	                }
	                if (c[v >> 2] | 0)dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[o >> 2] | 0) | 0;
	                if (c[n >> 2] | 0) {
	                    c[h >> 2] = c[p >> 2];
	                    C = c[h >> 2] | 0;
	                    i = g;
	                    return C | 0
	                } else {
	                    c[h >> 2] = c[o >> 2];
	                    C = c[h >> 2] | 0;
	                    i = g;
	                    return C | 0
	                }
	                return 0
	            }

	            function RF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[m >> 2] = dE(c[j >> 2] | 0, 160064) | 0;
	                d = c[g >> 2] | 0;
	                if (!(c[m >> 2] | 0)) {
	                    MF(d, 3036, 0, c[j >> 2] | 0, 160064, 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if (_F(d, c[h >> 2] | 0, 0, c[m >> 2] | 0, o, n) | 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                $F(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[p >> 2] = XF(c[g >> 2] | 0, c[j >> 2] | 0, 0, -1, 1, 161744) | 0;
	                c[q >> 2] = YF(c[g >> 2] | 0, c[j >> 2] | 0, 0, 1073741824, 1, 161768) | 0;
	                c[m >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    h = c[m >> 2] | 0;
	                    if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((((qy(c[h + 8 >> 2] | 0, 160064) | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161824) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161808) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                    } else if (qy(c[(c[h + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[k >> 2] = XE(c[g >> 2] | 0, c[j >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                m = cG(c[g >> 2] | 0, 17, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 12 >> 2] = m;
	                ZF(c[g >> 2] | 0, c[k >> 2] | 0, c[j >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0) | 0;
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    m = jE(c[g >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    c[(c[k >> 2] | 0) + 4 >> 2] = m;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if (c[l >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[l >> 2] | 0, 0, 161392);
	                if ((c[p >> 2] | 0) == 0 & (c[q >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else {
	                    c[f >> 2] = c[k >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                return 0
	            }

	            function SF(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                while (1) {
	                    if (!((((c[c[m >> 2] >> 2] | 0) != 0 ? (c[(c[c[m >> 2] >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[c[m >> 2] >> 2] | 0) + 8 >> 2] | 0, 161048) | 0) != 0 : 0) ? (qy(c[(c[(c[c[m >> 2] >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)) {
	                        if (!(c[c[m >> 2] >> 2] | 0)) {
	                            r = 24;
	                            break
	                        }
	                        if (!(c[(c[c[m >> 2] >> 2] | 0) + 36 >> 2] | 0)) {
	                            r = 24;
	                            break
	                        }
	                        if (!(qy(c[(c[c[m >> 2] >> 2] | 0) + 8 >> 2] | 0, 161064) | 0)) {
	                            r = 24;
	                            break
	                        }
	                        if (!(qy(c[(c[(c[c[m >> 2] >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)) {
	                            r = 24;
	                            break
	                        }
	                    }
	                    if ((((c[c[m >> 2] >> 2] | 0) != 0 ? (c[(c[c[m >> 2] >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[c[m >> 2] >> 2] | 0) + 8 >> 2] | 0, 161048) | 0) != 0 : 0) ? (qy(c[(c[(c[c[m >> 2] >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)c[q >> 2] = nH(c[k >> 2] | 0, c[l >> 2] | 0, c[c[m >> 2] >> 2] | 0, c[c[n >> 2] >> 2] | 0, c[o >> 2] | 0) | 0; else r = 15;
	                    if ((r | 0) == 15 ? (r = 0, c[q >> 2] = oH(c[k >> 2] | 0, c[l >> 2] | 0, c[c[m >> 2] >> 2] | 0) | 0, (c[q >> 2] | 0) != 0 & (c[p >> 2] | 0) != 0) : 0)c[c[p >> 2] >> 2] = 1;
	                    if (c[q >> 2] | 0) {
	                        if ((c[c[n >> 2] >> 2] | 0) == 0 ? (g = JB() | 0, c[c[n >> 2] >> 2] = g, (c[c[n >> 2] >> 2] | 0) == 0) : 0) {
	                            r = 20;
	                            break
	                        }
	                        if ((pG(c[c[n >> 2] >> 2] | 0, 2, c[q >> 2] | 0) | 0) == -1) {
	                            r = 22;
	                            break
	                        }
	                    }
	                    c[c[m >> 2] >> 2] = c[(c[c[m >> 2] >> 2] | 0) + 24 >> 2]
	                }
	                if ((r | 0) == 20) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else if ((r | 0) == 22) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else if ((r | 0) == 24) {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                return 0
	            }

	            function TF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[k >> 2] = qG(c[g >> 2] | 0, c[h >> 2] | 0, 21, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[m >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    d = c[m >> 2] | 0;
	                    if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (((qy(c[d + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 162304) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 162320) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                    } else if (qy(c[(c[d + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                if (pH(c[g >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0, c[j >> 2] | 0) | 0) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    h = jE(c[g >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    c[(c[k >> 2] | 0) + 8 >> 2] = h;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if (c[l >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[l >> 2] | 0, 0, 161392);
	                c[f >> 2] = c[k >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function UF(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 52 | 0;
	                h = f + 48 | 0;
	                j = f + 44 | 0;
	                k = f + 40 | 0;
	                l = f + 36 | 0;
	                m = f + 32 | 0;
	                n = f + 28 | 0;
	                o = f + 24 | 0;
	                p = f + 20 | 0;
	                q = f + 16 | 0;
	                r = f + 12 | 0;
	                s = f + 8 | 0;
	                t = f + 4 | 0;
	                u = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                c[m >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                e = (c[m >> 2] | 0) + 48 | 0;
	                c[e >> 2] = c[e >> 2] | 4;
	                c[o >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    e = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 151424) | 0) == 0 : 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                do if (!(fG(c[h >> 2] | 0, c[j >> 2] | 0, 0, c[k >> 2] | 0, 151424, (c[m >> 2] | 0) + 60 | 0, (c[m >> 2] | 0) + 56 | 0) | 0)) {
	                    if ((c[(c[m >> 2] | 0) + 56 >> 2] | 0) == 0 ? (c[c[m >> 2] >> 2] | 0) == 5 : 0) {
	                        MF(c[h >> 2] | 0, 3036, 0, c[k >> 2] | 0, 151424, 0);
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 100 >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 48 >> 2] & 8 | 0) != 0 : 0) {
	                        if (!(c[(c[m >> 2] | 0) + 56 >> 2] | 0)) {
	                            MF(c[h >> 2] | 0, 3036, 0, c[k >> 2] | 0, 151424, 0);
	                            break
	                        }
	                        if ((qy(c[(c[m >> 2] | 0) + 56 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 ? (qy(c[(c[m >> 2] | 0) + 60 >> 2] | 0, c[(c[m >> 2] | 0) + 112 >> 2] | 0) | 0) != 0 : 0)break;
	                        c[p >> 2] = 0;
	                        c[q >> 2] = 0;
	                        o = c[h >> 2] | 0;
	                        e = c[k >> 2] | 0;
	                        d = BB(p, c[(c[m >> 2] | 0) + 60 >> 2] | 0, c[(c[m >> 2] | 0) + 56 >> 2] | 0) | 0;
	                        oG(o, 3081, 0, e, 166112, d, BB(q, c[(c[m >> 2] | 0) + 112 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0, 0);
	                        if (c[p >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                            c[p >> 2] = 0
	                        }
	                        if (c[q >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                            c[q >> 2] = 0
	                        }
	                        c[(c[m >> 2] | 0) + 56 >> 2] = 0;
	                        c[(c[m >> 2] | 0) + 60 >> 2] = 0
	                    }
	                } while (0);
	                c[n >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    q = c[m >> 2] | 0;
	                    kH(q, jE(c[h >> 2] | 0, c[n >> 2] | 0, 1) | 0) | 0;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                do if ((c[l >> 2] | 0) == 4) {
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        q = c[h >> 2] | 0;
	                        if (c[(c[m >> 2] | 0) + 56 >> 2] | 0)uE(q, 3005, 0, c[k >> 2] | 0, c[n >> 2] | 0, 166232, 0); else {
	                            p = oE(q, c[j >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                            c[(c[m >> 2] | 0) + 64 >> 2] = p
	                        }
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if (!(c[(c[m >> 2] | 0) + 56 >> 2] | 0))uE(c[h >> 2] | 0, 3005, 0, c[k >> 2] | 0, c[n >> 2] | 0, 166304, 0)
	                } else {
	                    if ((c[l >> 2] | 0) != 10) {
	                        if (!((c[l >> 2] | 0) == 9 & (c[n >> 2] | 0) != 0))break;
	                        if (!(c[(c[n >> 2] | 0) + 36 >> 2] | 0))break;
	                        if (!(qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161024) | 0))break;
	                        if (!(qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break;
	                        p = oE(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                        c[(c[m >> 2] | 0) + 104 >> 2] = p;
	                        if (c[(c[m >> 2] | 0) + 104 >> 2] | 0) {
	                            c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161648) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        p = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 8, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = p;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161656) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        p = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 7, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = p;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161664) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        p = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 6, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = p;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        p = RF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = p;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                a:do if ((c[l >> 2] | 0) == 4 | (c[l >> 2] | 0) == 9) {
	                    c[s >> 2] = 0;
	                    b:while (1) {
	                        if (!((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157848) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0))w = 77;
	                        c:do if ((w | 0) == 77) {
	                            w = 0;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157832) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157816) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157800) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157936) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157952) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157792) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157880) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157864) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)break;
	                            do if ((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                                if (!(qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157896) | 0))break;
	                                if (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)break c
	                            } while (0);
	                            do if (c[n >> 2] | 0) {
	                                if (!(c[(c[n >> 2] | 0) + 36 >> 2] | 0))break;
	                                if (!(qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157904) | 0))break;
	                                if (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)break c
	                            } while (0);
	                            if (!(c[n >> 2] | 0))break b;
	                            if (!(c[(c[n >> 2] | 0) + 36 >> 2] | 0))break b;
	                            if (!(qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 157920) | 0))break b;
	                            if (!(qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break b
	                        } while (0);
	                        c[r >> 2] = qH(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if (c[r >> 2] | 0) {
	                            p = c[r >> 2] | 0;
	                            if (!(c[s >> 2] | 0))c[(c[m >> 2] | 0) + 68 >> 2] = p; else c[(c[s >> 2] | 0) + 4 >> 2] = p;
	                            c[s >> 2] = c[r >> 2];
	                            c[(c[s >> 2] | 0) + 4 >> 2] = 0
	                        }
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                    if (c[(c[m >> 2] | 0) + 68 >> 2] | 0) {
	                        c[u >> 2] = 0;
	                        c[r >> 2] = c[(c[m >> 2] | 0) + 68 >> 2];
	                        while (1) {
	                            c[t >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                            if (!(c[t >> 2] | 0))break;
	                            c[(c[t >> 2] | 0) + 4 >> 2] = c[r >> 2];
	                            c[c[t >> 2] >> 2] = 0;
	                            p = c[t >> 2] | 0;
	                            if (!(c[u >> 2] | 0))c[(c[m >> 2] | 0) + 96 >> 2] = p; else c[c[u >> 2] >> 2] = p;
	                            c[u >> 2] = c[t >> 2];
	                            c[r >> 2] = c[(c[r >> 2] | 0) + 4 >> 2];
	                            if (!(c[r >> 2] | 0))break a
	                        }
	                        tC(c[h >> 2] | 0, 166376, 0);
	                        zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                } while (0);
	                if ((c[c[m >> 2] >> 2] | 0) == 5) {
	                    if ((SF(c[h >> 2] | 0, c[j >> 2] | 0, n, (c[m >> 2] | 0) + 116 | 0, 12, 0) | 0) == -1) {
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 163328) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        t = TF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 84 >> 2] = t;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                }
	                do if (c[n >> 2] | 0) {
	                    if ((c[l >> 2] | 0) == 10) {
	                        uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[n >> 2] | 0, 0, 166400);
	                        break
	                    }
	                    t = c[h >> 2] | 0;
	                    m = c[k >> 2] | 0;
	                    j = c[n >> 2] | 0;
	                    if ((c[l >> 2] | 0) == 9) {
	                        uE(t, 3033, 0, m, j, 0, 166504);
	                        break
	                    } else {
	                        uE(t, 3033, 0, m, j, 0, 166752);
	                        break
	                    }
	                } while (0);
	                c[g >> 2] = 0;
	                v = c[g >> 2] | 0;
	                i = f;
	                return v | 0
	            }

	            function VF(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[k >> 2] = c[(c[g >> 2] | 0) + 84 >> 2];
	                d = (c[k >> 2] | 0) + 48 | 0;
	                c[d >> 2] = c[d >> 2] | 64;
	                d = IH(46) | 0;
	                c[(c[k >> 2] | 0) + 64 >> 2] = d;
	                c[m >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    d = c[m >> 2] | 0;
	                    if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[d + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160400) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                    } else if (qy(c[(c[d + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                fG(c[g >> 2] | 0, c[h >> 2] | 0, 0, c[j >> 2] | 0, 160400, (c[k >> 2] | 0) + 60 | 0, (c[k >> 2] | 0) + 56 | 0) | 0;
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    m = c[k >> 2] | 0;
	                    kH(m, jE(c[g >> 2] | 0, c[l >> 2] | 0, 1) | 0) | 0;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    m = c[g >> 2] | 0;
	                    if (c[(c[k >> 2] | 0) + 56 >> 2] | 0)GE(m, 3e3, 0, c[j >> 2] | 0, 165952, 0); else {
	                        d = oE(m, c[h >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                        c[(c[k >> 2] | 0) + 28 >> 2] = d
	                    }
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                } else o = 25;
	                if ((o | 0) == 25 ? (c[(c[k >> 2] | 0) + 56 >> 2] | 0) == 0 : 0)GE(c[g >> 2] | 0, 3e3, 0, c[j >> 2] | 0, 166032, 0);
	                if (c[l >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[l >> 2] | 0, 0, 164200);
	                if (((c[(c[k >> 2] | 0) + 56 >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 28 >> 2] | 0) == 0 : 0) ? (dE(c[j >> 2] | 0, 160400) | 0) == 0 : 0)GE(c[g >> 2] | 0, 3e3, 0, c[j >> 2] | 0, 166032, 0);
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function WF(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                f = i;
	                i = i + 80 | 0;
	                g = f + 64 | 0;
	                h = f + 60 | 0;
	                j = f + 56 | 0;
	                k = f + 52 | 0;
	                l = f + 48 | 0;
	                m = f + 44 | 0;
	                n = f + 40 | 0;
	                o = f + 36 | 0;
	                p = f + 32 | 0;
	                q = f + 28 | 0;
	                r = f + 24 | 0;
	                s = f + 20 | 0;
	                t = f + 16 | 0;
	                u = f + 12 | 0;
	                v = f + 8 | 0;
	                w = f + 4 | 0;
	                x = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[m >> 2] = 0;
	                c[o >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    y = c[g >> 2] | 0;
	                    i = f;
	                    return y | 0
	                }
	                c[l >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                e = (c[l >> 2] | 0) + 48 | 0;
	                c[e >> 2] = c[e >> 2] | 128;
	                e = IH(46) | 0;
	                c[(c[l >> 2] | 0) + 64 >> 2] = e;
	                c[n >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[n >> 2] | 0))break;
	                    e = c[n >> 2] | 0;
	                    if (!(c[(c[n >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 160512) | 0) == 0 : 0)GF(c[h >> 2] | 0, 3035, 0, c[n >> 2] | 0)
	                    } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[n >> 2] | 0);
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                c[n >> 2] = dE(c[k >> 2] | 0, 160512) | 0;
	                a:do if (c[n >> 2] | 0) {
	                    c[u >> 2] = 0;
	                    c[o >> 2] = fE(c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                    c[(c[l >> 2] | 0) + 56 >> 2] = c[o >> 2];
	                    while (1) {
	                        do if ((d[c[o >> 2] >> 0] | 0 | 0) == 32)z = 1; else {
	                            if (9 <= (d[c[o >> 2] >> 0] | 0 | 0) ? (d[c[o >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                z = 1;
	                                break
	                            }
	                            z = (d[c[o >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        e = c[o >> 2] | 0;
	                        if (z) {
	                            c[o >> 2] = e + 1;
	                            continue
	                        }
	                        c[p >> 2] = e;
	                        while (1) {
	                            if (d[c[p >> 2] >> 0] | 0) {
	                                do if ((d[c[p >> 2] >> 0] | 0 | 0) == 32)A = 1; else {
	                                    if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        A = 1;
	                                        break
	                                    }
	                                    A = (d[c[p >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                B = A ^ 1
	                            } else B = 0;
	                            C = c[p >> 2] | 0;
	                            if (!B)break;
	                            c[p >> 2] = C + 1
	                        }
	                        if ((C | 0) == (c[o >> 2] | 0))break a;
	                        c[q >> 2] = ly(c[o >> 2] | 0, (c[p >> 2] | 0) - (c[o >> 2] | 0) | 0) | 0;
	                        if (!(rH(c[h >> 2] | 0, c[j >> 2] | 0, 0, c[n >> 2] | 0, c[q >> 2] | 0, s, r) | 0)) {
	                            c[t >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                            if (!(c[t >> 2] | 0)) {
	                                D = 32;
	                                break
	                            }
	                            c[(c[t >> 2] | 0) + 4 >> 2] = 0;
	                            c[c[t >> 2] >> 2] = 0;
	                            e = c[t >> 2] | 0;
	                            if (!(c[u >> 2] | 0))c[(c[l >> 2] | 0) + 92 >> 2] = e; else c[c[u >> 2] >> 2] = e;
	                            c[u >> 2] = c[t >> 2];
	                            c[v >> 2] = cG(c[h >> 2] | 0, 4, c[r >> 2] | 0, c[s >> 2] | 0) | 0;
	                            if (!(c[v >> 2] | 0))break;
	                            c[(c[t >> 2] | 0) + 4 >> 2] = c[v >> 2]
	                        }
	                        if (c[q >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                            c[q >> 2] = 0
	                        }
	                        c[o >> 2] = c[p >> 2];
	                        if (!(d[c[o >> 2] >> 0] | 0))break a
	                    }
	                    if ((D | 0) == 32) {
	                        tC(c[h >> 2] | 0, 165784, 0);
	                        c[g >> 2] = -1;
	                        y = c[g >> 2] | 0;
	                        i = f;
	                        return y | 0
	                    }
	                    if (c[q >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        c[q >> 2] = 0
	                    }
	                    c[g >> 2] = -1;
	                    y = c[g >> 2] | 0;
	                    i = f;
	                    return y | 0
	                } while (0);
	                c[m >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    q = c[l >> 2] | 0;
	                    kH(q, jE(c[h >> 2] | 0, c[m >> 2] | 0, 1) | 0) | 0;
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                b:do if ((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    c[x >> 2] = 0;
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break b;
	                        if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0))break b;
	                        if (!(qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161024) | 0))break b;
	                        if (!(qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break b;
	                        c[w >> 2] = oE(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0, 0) | 0;
	                        if (c[w >> 2] | 0) {
	                            q = c[w >> 2] | 0;
	                            if (!(c[x >> 2] | 0)) {
	                                c[(c[l >> 2] | 0) + 28 >> 2] = q;
	                                c[x >> 2] = c[w >> 2]
	                            } else {
	                                c[(c[x >> 2] | 0) + 4 >> 2] = q;
	                                c[x >> 2] = c[w >> 2]
	                            }
	                            c[(c[x >> 2] | 0) + 4 >> 2] = 0
	                        }
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if (c[m >> 2] | 0)uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[m >> 2] | 0, 0, 165832);
	                if ((c[n >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 28 >> 2] | 0) == 0 : 0)GE(c[h >> 2] | 0, 3007, 0, c[k >> 2] | 0, 165864, 0);
	                c[g >> 2] = 0;
	                y = c[g >> 2] | 0;
	                i = f;
	                return y | 0
	            }

	            function XF(a, b, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 40 | 0;
	                l = j + 36 | 0;
	                m = j + 32 | 0;
	                n = j + 28 | 0;
	                o = j + 24 | 0;
	                p = j + 20 | 0;
	                q = j + 16 | 0;
	                r = j + 12 | 0;
	                s = j + 8 | 0;
	                t = j + 4 | 0;
	                u = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[t >> 2] = 0;
	                c[u >> 2] = dE(c[m >> 2] | 0, 161824) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    c[k >> 2] = c[p >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[r >> 2] = fE(c[l >> 2] | 0, c[u >> 2] | 0) | 0;
	                c[s >> 2] = c[r >> 2];
	                while (1) {
	                    do if ((d[c[s >> 2] >> 0] | 0 | 0) == 32)w = 1; else {
	                        if (9 <= (d[c[s >> 2] >> 0] | 0 | 0) ? (d[c[s >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            w = 1;
	                            break
	                        }
	                        w = (d[c[s >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    x = c[s >> 2] | 0;
	                    if (!w)break;
	                    c[s >> 2] = x + 1
	                }
	                if (!(d[x >> 0] | 0)) {
	                    hE(c[l >> 2] | 0, 3037, 0, c[u >> 2] | 0, 0, c[q >> 2] | 0, c[r >> 2] | 0, 0, 0, 0);
	                    c[k >> 2] = c[p >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                while (1) {
	                    if ((d[c[s >> 2] >> 0] | 0 | 0) < 48)break;
	                    if ((d[c[s >> 2] >> 0] | 0 | 0) > 57)break;
	                    c[t >> 2] = ((c[t >> 2] | 0) * 10 | 0) + ((d[c[s >> 2] >> 0] | 0) - 48);
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                }
	                while (1) {
	                    do if ((d[c[s >> 2] >> 0] | 0 | 0) == 32)y = 1; else {
	                        if (9 <= (d[c[s >> 2] >> 0] | 0 | 0) ? (d[c[s >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            y = 1;
	                            break
	                        }
	                        y = (d[c[s >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    z = c[s >> 2] | 0;
	                    if (!y)break;
	                    c[s >> 2] = z + 1
	                }
	                do if ((d[z >> 0] | 0 | 0) == 0 ? (c[t >> 2] | 0) >= (c[n >> 2] | 0) : 0) {
	                    if ((c[o >> 2] | 0) != -1 ? (c[t >> 2] | 0) > (c[o >> 2] | 0) : 0)break;
	                    c[k >> 2] = c[t >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                } while (0);
	                hE(c[l >> 2] | 0, 3037, 0, c[u >> 2] | 0, 0, c[q >> 2] | 0, c[r >> 2] | 0, 0, 0, 0);
	                c[k >> 2] = c[p >> 2];
	                v = c[k >> 2] | 0;
	                i = j;
	                return v | 0
	            }

	            function YF(a, b, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 40 | 0;
	                l = j + 36 | 0;
	                m = j + 32 | 0;
	                n = j + 28 | 0;
	                o = j + 24 | 0;
	                p = j + 20 | 0;
	                q = j + 16 | 0;
	                r = j + 12 | 0;
	                s = j + 8 | 0;
	                t = j + 4 | 0;
	                u = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[t >> 2] = 0;
	                c[u >> 2] = dE(c[m >> 2] | 0, 161808) | 0;
	                if (!(c[u >> 2] | 0)) {
	                    c[k >> 2] = c[p >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[r >> 2] = fE(c[l >> 2] | 0, c[u >> 2] | 0) | 0;
	                if (qy(c[r >> 2] | 0, 163200) | 0)if ((c[o >> 2] | 0) != 1073741824) {
	                    hE(c[l >> 2] | 0, 3037, 0, c[u >> 2] | 0, 0, c[q >> 2] | 0, c[r >> 2] | 0, 0, 0, 0);
	                    c[k >> 2] = c[p >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                } else {
	                    c[k >> 2] = 1073741824;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[s >> 2] = c[r >> 2];
	                while (1) {
	                    do if ((d[c[s >> 2] >> 0] | 0 | 0) == 32)w = 1; else {
	                        if (9 <= (d[c[s >> 2] >> 0] | 0 | 0) ? (d[c[s >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            w = 1;
	                            break
	                        }
	                        w = (d[c[s >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    x = c[s >> 2] | 0;
	                    if (!w)break;
	                    c[s >> 2] = x + 1
	                }
	                if (!(d[x >> 0] | 0)) {
	                    hE(c[l >> 2] | 0, 3037, 0, c[u >> 2] | 0, 0, c[q >> 2] | 0, c[r >> 2] | 0, 0, 0, 0);
	                    c[k >> 2] = c[p >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                while (1) {
	                    if ((d[c[s >> 2] >> 0] | 0 | 0) < 48)break;
	                    if ((d[c[s >> 2] >> 0] | 0 | 0) > 57)break;
	                    c[t >> 2] = ((c[t >> 2] | 0) * 10 | 0) + ((d[c[s >> 2] >> 0] | 0) - 48);
	                    c[s >> 2] = (c[s >> 2] | 0) + 1
	                }
	                while (1) {
	                    do if ((d[c[s >> 2] >> 0] | 0 | 0) == 32)y = 1; else {
	                        if (9 <= (d[c[s >> 2] >> 0] | 0 | 0) ? (d[c[s >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            y = 1;
	                            break
	                        }
	                        y = (d[c[s >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    z = c[s >> 2] | 0;
	                    if (!y)break;
	                    c[s >> 2] = z + 1
	                }
	                do if ((d[z >> 0] | 0 | 0) == 0 ? (c[t >> 2] | 0) >= (c[n >> 2] | 0) : 0) {
	                    if ((c[o >> 2] | 0) != -1 ? (c[t >> 2] | 0) > (c[o >> 2] | 0) : 0)break;
	                    c[k >> 2] = c[t >> 2];
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                } while (0);
	                hE(c[l >> 2] | 0, 3037, 0, c[u >> 2] | 0, 0, c[q >> 2] | 0, c[r >> 2] | 0, 0, 0, 0);
	                c[k >> 2] = c[p >> 2];
	                v = c[k >> 2] | 0;
	                i = j;
	                return v | 0
	            }

	            function ZF(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 16 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[j >> 2] = a;
	                c[g + 12 >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if ((c[m >> 2] | 0) == 0 & (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    n = c[h >> 2] | 0;
	                    i = g;
	                    return n | 0
	                }
	                if ((c[m >> 2] | 0) != 1073741824) {
	                    if ((c[m >> 2] | 0) < 1) {
	                        f = c[j >> 2] | 0;
	                        bG(f, 3044, 0, 0, dE(c[k >> 2] | 0, 161808) | 0, 163048);
	                        c[h >> 2] = 3044;
	                        n = c[h >> 2] | 0;
	                        i = g;
	                        return n | 0
	                    }
	                    if ((c[l >> 2] | 0) > (c[m >> 2] | 0)) {
	                        m = c[j >> 2] | 0;
	                        bG(m, 3043, 0, 0, dE(c[k >> 2] | 0, 161824) | 0, 163096);
	                        c[h >> 2] = 3043;
	                        n = c[h >> 2] | 0;
	                        i = g;
	                        return n | 0
	                    }
	                }
	                c[h >> 2] = 0;
	                n = c[h >> 2] | 0;
	                i = g;
	                return n | 0
	            }

	            function _F(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = fE(c[j >> 2] | 0, c[m >> 2] | 0) | 0;
	                g = rH(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[p >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                i = h;
	                return g | 0
	            }

	            function $F(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[g + 20 >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (qy(c[(c[j >> 2] | 0) + 112 >> 2] | 0, c[m >> 2] | 0) | 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                if (qy(c[38526] | 0, c[m >> 2] | 0) | 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                a:do if (c[(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 24 >> 2] | 0) {
	                    c[n >> 2] = c[(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (!((c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 1 : 0))q = 9;
	                        if ((q | 0) == 9 ? (q = 0, (qy(c[m >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0) != 0) : 0)break;
	                        c[n >> 2] = c[c[n >> 2] >> 2];
	                        if (!(c[n >> 2] | 0))break a
	                    }
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } while (0);
	                if (c[l >> 2] | 0)r = c[l >> 2] | 0; else r = c[k >> 2] | 0;
	                c[o >> 2] = r;
	                r = c[j >> 2] | 0;
	                j = c[o >> 2] | 0;
	                if (!(c[m >> 2] | 0))AB(r, 3004, j, 0, 162704, 0, 0); else AB(r, 3004, j, 0, 162824, c[m >> 2] | 0, 0);
	                c[h >> 2] = 3004;
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function aG(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 0;
	                GC(p, 0, c[l >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0) | 0;
	                EF(c[j >> 2] | 0, c[m >> 2] | 0, c[k >> 2] | 0, 0, 0, 0, 164296, c[p >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, 0, 0);
	                if (!(c[p >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                c[p >> 2] = 0;
	                i = h;
	                return
	            }

	            function bG(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 0;
	                do if (c[l >> 2] | 0) {
	                    g = c[l >> 2] | 0;
	                    if (!(c[c[l >> 2] >> 2] | 0)) {
	                        GC(g, 0, c[m >> 2] | 0, c[(c[n >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        c[p >> 2] = c[c[l >> 2] >> 2];
	                        break
	                    } else {
	                        c[p >> 2] = c[g >> 2];
	                        break
	                    }
	                } else GC(p, 0, c[m >> 2] | 0, c[(c[n >> 2] | 0) + 20 >> 2] | 0) | 0; while (0);
	                m = c[j >> 2] | 0;
	                if (!(c[n >> 2] | 0))EF(m, 0, c[k >> 2] | 0, 0, 0, 0, 163160, c[p >> 2] | 0, 163192, c[o >> 2] | 0, 0, 0); else EF(m, c[n >> 2] | 0, c[k >> 2] | 0, 0, 0, 0, 163160, c[p >> 2] | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0, 0, 0);
	                if (!((c[l >> 2] | 0) == 0 & (c[p >> 2] | 0) != 0)) {
	                    i = h;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                c[p >> 2] = 0;
	                i = h;
	                return
	            }

	            function cG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tC(c[h >> 2] | 0, 162672, 0);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    c[(c[m >> 2] | 0) + 20 >> 2] = 0;
	                    c[c[m >> 2] >> 2] = 2e3;
	                    c[(c[m >> 2] | 0) + 12 >> 2] = c[k >> 2];
	                    c[(c[m >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                    c[(c[m >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[m >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                    dG((c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[m >> 2] | 0) | 0;
	                    c[g >> 2] = c[m >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function dG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[c[g >> 2] >> 2] | 0) == 0 ? (d = JB() | 0, c[c[g >> 2] >> 2] = d, (c[c[g >> 2] >> 2] | 0) == 0) : 0) {
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                pG(c[c[g >> 2] >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function eG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](104) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    tC(c[j >> 2] | 0, 165528, 0);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                f = (c[o >> 2] | 0) + 0 | 0;
	                e = f + 104 | 0;
	                do {
	                    c[f >> 2] = 0;
	                    f = f + 4 | 0
	                } while ((f | 0) < (e | 0));
	                c[c[o >> 2] >> 2] = 14;
	                c[(c[o >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                c[(c[o >> 2] | 0) + 52 >> 2] = c[l >> 2];
	                c[(c[o >> 2] | 0) + 36 >> 2] = c[m >> 2];
	                m = c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0;
	                if (c[n >> 2] | 0)dG(m + 44 | 0, 5, c[o >> 2] | 0) | 0; else dG(m + 48 | 0, 10, c[o >> 2] | 0) | 0;
	                dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[o >> 2] | 0) | 0;
	                c[h >> 2] = c[o >> 2];
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function fG(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 20 | 0;
	                o = j + 16 | 0;
	                p = j + 12 | 0;
	                q = j + 8 | 0;
	                r = j + 4 | 0;
	                s = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = dE(c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    c[c[r >> 2] >> 2] = 0;
	                    c[c[q >> 2] >> 2] = 0;
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                } else {
	                    c[k >> 2] = _F(c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[s >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0) | 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                return 0
	            }

	            function gG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = RC(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[g >> 2] = c[l >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                do if (!(qy(c[m >> 2] | 0, 165504) | 0)) {
	                    if (qy(c[m >> 2] | 0, 165512) | 0) {
	                        c[l >> 2] = 0;
	                        break
	                    }
	                    if (qy(c[m >> 2] | 0, 161736) | 0) {
	                        c[l >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[m >> 2] | 0, 165520) | 0) {
	                        c[l >> 2] = 0;
	                        break
	                    } else {
	                        e = c[h >> 2] | 0;
	                        d = dE(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        b = IH(15) | 0;
	                        hE(e, 1714, 0, d, b, 0, c[m >> 2] | 0, 0, 0, 0);
	                        break
	                    }
	                } else c[l >> 2] = 1; while (0);
	                c[g >> 2] = c[l >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function hG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 44 | 0;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                t = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[q >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[q >> 2] | 0))break;
	                    f = c[q >> 2] | 0;
	                    do if (!(c[(c[q >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[f + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 161352) | 0) == 0 : 0) {
	                            if ((c[m >> 2] | 0) == 24 ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 160144) | 0) != 0 : 0)break;
	                            GF(c[j >> 2] | 0, 3035, 0, c[q >> 2] | 0)
	                        }
	                    } else if (qy(c[(c[f + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[j >> 2] | 0, 3035, 0, c[q >> 2] | 0); while (0);
	                    c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                }
	                c[q >> 2] = dE(c[l >> 2] | 0, 161352) | 0;
	                f = c[j >> 2] | 0;
	                if (!(c[q >> 2] | 0)) {
	                    MF(f, 3036, 0, c[l >> 2] | 0, 161352, 0);
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                e = c[q >> 2] | 0;
	                if (eE(f, 0, e, IH(22) | 0, r) | 0) {
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                c[o >> 2] = sH(c[j >> 2] | 0, c[k >> 2] | 0, c[r >> 2] | 0, c[n >> 2] | 0, c[m >> 2] | 0, c[l >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                cE(c[j >> 2] | 0, c[l >> 2] | 0, 161384) | 0;
	                do if ((c[m >> 2] | 0) == 24) {
	                    c[q >> 2] = dE(c[l >> 2] | 0, 160144) | 0;
	                    n = c[j >> 2] | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        MF(n, 3036, 0, c[l >> 2] | 0, 160144, 0);
	                        break
	                    }
	                    r = cG(n, 23, 0, 0) | 0;
	                    c[(c[o >> 2] | 0) + 36 >> 2] = r;
	                    if (c[(c[o >> 2] | 0) + 36 >> 2] | 0) {
	                        _F(c[j >> 2] | 0, c[k >> 2] | 0, 0, c[q >> 2] | 0, (c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 | 0, (c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 12 | 0) | 0;
	                        $F(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[q >> 2] | 0, c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                        break
	                    }
	                    c[h >> 2] = 0;
	                    u = c[h >> 2] | 0;
	                    i = g;
	                    return u | 0
	                } while (0);
	                c[p >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                if ((((c[p >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    q = jE(c[j >> 2] | 0, c[p >> 2] | 0, 1) | 0;
	                    c[(c[o >> 2] | 0) + 4 >> 2] = q;
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                }
	                if (!(c[p >> 2] | 0))uE(c[j >> 2] | 0, 3034, 0, c[l >> 2] | 0, c[p >> 2] | 0, 164808, 164840);
	                a:do if ((((c[p >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 164880) | 0) != 0 : 0) ? (qy(c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    q = tH(c[j >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, 0) | 0;
	                    c[(c[o >> 2] | 0) + 24 >> 2] = q;
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2];
	                    if ((((c[p >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 164896) | 0) != 0 : 0) ? (qy(c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)while (1) {
	                        c[s >> 2] = tH(c[j >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, 1) | 0;
	                        if (c[s >> 2] | 0) {
	                            c[(c[s >> 2] | 0) + 8 >> 2] = c[(c[o >> 2] | 0) + 32 >> 2];
	                            q = (c[o >> 2] | 0) + 32 | 0;
	                            c[q >> 2] = (c[q >> 2] | 0) + 1;
	                            q = c[s >> 2] | 0;
	                            if (c[t >> 2] | 0)c[c[t >> 2] >> 2] = q; else c[(c[o >> 2] | 0) + 28 >> 2] = q;
	                            c[t >> 2] = c[s >> 2]
	                        }
	                        c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2];
	                        if (!(c[p >> 2] | 0))break a;
	                        if (!(c[(c[p >> 2] | 0) + 36 >> 2] | 0))break a;
	                        if (!(qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 164896) | 0))break a;
	                        if (!(qy(c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0))break a
	                    }
	                    uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[p >> 2] | 0, 0, 164840)
	                } while (0);
	                if (c[p >> 2] | 0)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[p >> 2] | 0, 0, 164840);
	                c[h >> 2] = c[o >> 2];
	                u = c[h >> 2] | 0;
	                i = g;
	                return u | 0
	            }

	            function iG(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[j >> 2] = 0;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                c[q >> 2] = Cb[c[135744 >> 2] & 511](76) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    tC(c[k >> 2] | 0, 164272, 0);
	                    c[j >> 2] = 0;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                l = (c[q >> 2] | 0) + 0 | 0;
	                g = l + 76 | 0;
	                do {
	                    c[l >> 2] = 0;
	                    l = l + 4 | 0
	                } while ((l | 0) < (g | 0));
	                c[c[q >> 2] >> 2] = 15;
	                c[(c[q >> 2] | 0) + 52 >> 2] = c[o >> 2];
	                c[(c[q >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                c[(c[q >> 2] | 0) + 56 >> 2] = c[n >> 2];
	                n = c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0;
	                if (c[p >> 2] | 0)dG(n + 44 | 0, 5, c[q >> 2] | 0) | 0; else dG(n + 48 | 0, 10, c[q >> 2] | 0) | 0;
	                dG((c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[q >> 2] | 0) | 0;
	                c[j >> 2] = c[q >> 2];
	                r = c[j >> 2] | 0;
	                i = h;
	                return r | 0
	            }

	            function jG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 12 | 0;
	                l = g + 8 | 0;
	                m = g + 4 | 0;
	                n = g;
	                c[j >> 2] = a;
	                c[g + 16 >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                c[n >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    tC(c[j >> 2] | 0, 164360, 0);
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                f = (c[n >> 2] | 0) + 0 | 0;
	                e = f + 60 | 0;
	                do {
	                    c[f >> 2] = 0;
	                    f = f + 4 | 0
	                } while ((f | 0) < (e | 0));
	                c[c[n >> 2] >> 2] = 16;
	                c[(c[n >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                c[(c[n >> 2] | 0) + 52 >> 2] = c[l >> 2];
	                c[(c[n >> 2] | 0) + 32 >> 2] = c[m >> 2];
	                m = (c[n >> 2] | 0) + 36 | 0;
	                c[m >> 2] = c[m >> 2] | 2;
	                do if (c[(c[j >> 2] | 0) + 100 >> 2] | 0) {
	                    m = GG(c[j >> 2] | 0, c[(c[j >> 2] | 0) + 116 >> 2] | 0, c[n >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 120 >> 2] = m;
	                    if (c[(c[j >> 2] | 0) + 120 >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 124 >> 2] = 0;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                } while (0);
	                dG((c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 44 | 0, 5, c[n >> 2] | 0) | 0;
	                dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[n >> 2] | 0) | 0;
	                c[h >> 2] = c[n >> 2];
	                o = c[h >> 2] | 0;
	                i = g;
	                return o | 0
	            }

	            function kG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    tC(c[j >> 2] | 0, 163256, 0);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                k = c[o >> 2] | 0;
	                c[k + 0 >> 2] = 0;
	                c[k + 4 >> 2] = 0;
	                c[k + 8 >> 2] = 0;
	                c[k + 12 >> 2] = 0;
	                c[k + 16 >> 2] = 0;
	                c[k + 20 >> 2] = 0;
	                c[k + 24 >> 2] = 0;
	                c[k + 28 >> 2] = 0;
	                c[(c[o >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                c[c[o >> 2] >> 2] = 17;
	                c[(c[o >> 2] | 0) + 24 >> 2] = c[n >> 2];
	                c[(c[o >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                do if (c[(c[j >> 2] | 0) + 100 >> 2] | 0) {
	                    n = GG(c[j >> 2] | 0, c[(c[j >> 2] | 0) + 116 >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 120 >> 2] = n;
	                    if (c[(c[j >> 2] | 0) + 120 >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 124 >> 2] = 0;
	                        break
	                    }
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } while (0);
	                dG((c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 44 | 0, 5, c[o >> 2] | 0) | 0;
	                dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[o >> 2] | 0) | 0;
	                c[h >> 2] = c[o >> 2];
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function lG(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 24 | 0;
	                l = j + 20 | 0;
	                m = j + 16 | 0;
	                n = j + 12 | 0;
	                o = j + 8 | 0;
	                p = j + 4 | 0;
	                q = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                h = c[k >> 2] | 0;
	                if (c[m >> 2] | 0) {
	                    PC(h, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0);
	                    i = j;
	                    return
	                } else {
	                    PC(h, c[l >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0);
	                    i = j;
	                    return
	                }
	            }

	            function mG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[g + 4 >> 2] = f;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                c[n >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    tC(c[j >> 2] | 0, 161632, 0);
	                    c[h >> 2] = 0;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                } else {
	                    k = c[n >> 2] | 0;
	                    c[k + 0 >> 2] = 0;
	                    c[k + 4 >> 2] = 0;
	                    c[k + 8 >> 2] = 0;
	                    c[k + 12 >> 2] = 0;
	                    c[k + 16 >> 2] = 0;
	                    c[c[n >> 2] >> 2] = 18;
	                    c[(c[n >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                    c[(c[n >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                    dG((c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 44 | 0, 5, c[n >> 2] | 0) | 0;
	                    c[h >> 2] = c[n >> 2];
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                }
	                return 0
	            }

	            function nG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if (c[g >> 2] | 0) {
	                    if ((qy(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 ? (c[k >> 2] = Rj(c[(c[g >> 2] | 0) + 56 >> 2] | 0, c[h >> 2] | 0) | 0, (c[k >> 2] | 0) != 0) : 0)break;
	                    if (($j(c[(c[g >> 2] | 0) + 48 >> 2] | 0) | 0) > 1) {
	                        d = c[(c[g >> 2] | 0) + 48 >> 2] | 0;
	                        if (!(c[j >> 2] | 0))c[l >> 2] = Rj(d, 145792) | 0; else c[l >> 2] = Rj(d, c[j >> 2] | 0) | 0;
	                        if (c[l >> 2] | 0)c[k >> 2] = Rj(c[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 56 >> 2] | 0, c[h >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function oG(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                k = i;
	                i = i + 48 | 0;
	                l = k + 36 | 0;
	                m = k + 32 | 0;
	                n = k + 28 | 0;
	                o = k + 24 | 0;
	                p = k + 20 | 0;
	                q = k + 16 | 0;
	                r = k + 12 | 0;
	                s = k + 8 | 0;
	                t = k + 4 | 0;
	                u = k;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = j;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                GC(t, 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[u >> 2] = my(147824) | 0;
	                c[u >> 2] = By(c[u >> 2] | 0, c[p >> 2] | 0) | 0;
	                c[u >> 2] = By(c[u >> 2] | 0, 142704) | 0;
	                if ((c[o >> 2] | 0) == 0 & (c[n >> 2] | 0) != 0)c[o >> 2] = FC(c[n >> 2] | 0) | 0;
	                EF(c[l >> 2] | 0, c[o >> 2] | 0, c[m >> 2] | 0, 0, 0, 0, c[u >> 2] | 0, c[t >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, 0);
	                if (c[t >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                    c[t >> 2] = 0
	                }
	                if (!(c[u >> 2] | 0)) {
	                    i = k;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                c[u >> 2] = 0;
	                i = k;
	                return
	            }

	            function pG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (c[c[g >> 2] >> 2] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) <= (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (d = (c[g >> 2] | 0) + 8 | 0, c[d >> 2] = c[d >> 2] << 1, d = Hb[c[135760 >> 2] & 511](c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] << 2) | 0, c[c[g >> 2] >> 2] = d, (c[c[g >> 2] >> 2] | 0) == 0) : 0) {
	                        tC(0, 142376, 0);
	                        c[(c[g >> 2] | 0) + 8 >> 2] = 0;
	                        c[f >> 2] = -1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                } else {
	                    if ((c[h >> 2] | 0) <= 0)c[h >> 2] = 1;
	                    d = Cb[c[135744 >> 2] & 511](c[h >> 2] << 2) | 0;
	                    c[c[g >> 2] >> 2] = d;
	                    if (c[c[g >> 2] >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                        break
	                    }
	                    tC(0, 142344, 0);
	                    c[f >> 2] = -1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } while (0);
	                h = c[j >> 2] | 0;
	                j = (c[g >> 2] | 0) + 4 | 0;
	                d = c[j >> 2] | 0;
	                c[j >> 2] = d + 1;
	                c[(c[c[g >> 2] >> 2] | 0) + (d << 2) >> 2] = h;
	                c[f >> 2] = 0;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function qG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tC(c[h >> 2] | 0, 153064, 0);
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    j = (c[m >> 2] | 0) + 0 | 0;
	                    e = j + 44 | 0;
	                    do {
	                        c[j >> 2] = 0;
	                        j = j + 4 | 0
	                    } while ((j | 0) < (e | 0));
	                    c[c[m >> 2] >> 2] = c[k >> 2];
	                    c[(c[m >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                    dG((c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[m >> 2] | 0) | 0;
	                    c[g >> 2] = c[m >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function rG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[(c[h >> 2] | 0) + 28 >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                c[k >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                c[m >> 2] = 0;
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    c[l >> 2] = uH(c[g >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        o = 6;
	                        break
	                    }
	                    c[(c[l >> 2] | 0) + 4 >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    d = c[l >> 2] | 0;
	                    if (!(c[m >> 2] | 0))c[(c[h >> 2] | 0) + 32 >> 2] = d; else c[c[m >> 2] >> 2] = d;
	                    c[m >> 2] = c[l >> 2];
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                if ((o | 0) == 6) {
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                if (c[(c[h >> 2] | 0) + 36 >> 2] | 0)nB(c[(c[h >> 2] | 0) + 36 >> 2] | 0);
	                do if (c[(c[j >> 2] | 0) + 36 >> 2] | 0) {
	                    o = uH(c[g >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 36 >> 2] = o;
	                    if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                        c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                        break
	                    }
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else c[(c[h >> 2] | 0) + 36 >> 2] = 0; while (0);
	                c[f >> 2] = 0;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function sG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (((c[(c[h >> 2] | 0) + 28 >> 2] | 0) == (c[(c[j >> 2] | 0) + 28 >> 2] | 0) ? ((c[(c[h >> 2] | 0) + 32 >> 2] | 0) == 0 | 0) == ((c[(c[j >> 2] | 0) + 32 >> 2] | 0) == 0 | 0) : 0) ? ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 0 | 0) == ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) == 0 | 0) : 0) {
	                    if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) : 0)break;
	                    if (!(c[(c[h >> 2] | 0) + 32 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    c[o >> 2] = 0;
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        c[o >> 2] = 0;
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                                s = 12;
	                                break
	                            }
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                        if ((s | 0) == 12) {
	                            s = 0;
	                            c[o >> 2] = 1
	                        }
	                        if (!(c[o >> 2] | 0))break;
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    if (c[o >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                } while (0);
	                if ((c[(c[h >> 2] | 0) + 28 >> 2] | 0) != (c[(c[j >> 2] | 0) + 28 >> 2] | 0) ? (c[(c[h >> 2] | 0) + 28 >> 2] | 0) != 0 : 0)if ((rG(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) == -1) {
	                    c[f >> 2] = -1;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                if (!((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0))s = 26;
	                do if ((s | 0) == 26) {
	                    if ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)break;
	                    if ((c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                        c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                        c[m >> 2] = 0;
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break;
	                            c[q >> 2] = 0;
	                            c[l >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                            while (1) {
	                                if (!(c[l >> 2] | 0))break;
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                                    s = 57;
	                                    break
	                                }
	                                c[l >> 2] = c[c[l >> 2] >> 2]
	                            }
	                            if ((s | 0) == 57) {
	                                s = 0;
	                                c[q >> 2] = 1
	                            }
	                            if (c[q >> 2] | 0) {
	                                c[m >> 2] = c[k >> 2];
	                                c[k >> 2] = c[c[k >> 2] >> 2];
	                                continue
	                            }
	                            o = c[c[k >> 2] >> 2] | 0;
	                            if (!(c[m >> 2] | 0))c[(c[h >> 2] | 0) + 32 >> 2] = o; else c[c[m >> 2] >> 2] = o;
	                            c[n >> 2] = c[c[k >> 2] >> 2];
	                            zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                            c[k >> 2] = c[n >> 2]
	                        }
	                        c[f >> 2] = 0;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    if (((((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        PC(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, 1793, 153008, 0, 0);
	                        c[f >> 2] = 1793;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                    if ((((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0)c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } while (0);
	                if (!(c[(c[h >> 2] | 0) + 32 >> 2] | 0)) {
	                    c[p >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                    if ((rG(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0) == -1) {
	                        c[f >> 2] = -1;
	                        r = c[f >> 2] | 0;
	                        i = e;
	                        return r | 0
	                    }
	                } else c[p >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                c[m >> 2] = 0;
	                c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0)) {
	                        s = 35;
	                        break
	                    }
	                    c[m >> 2] = c[k >> 2];
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                if ((s | 0) == 35) {
	                    s = c[c[k >> 2] >> 2] | 0;
	                    if (!(c[m >> 2] | 0))c[(c[h >> 2] | 0) + 32 >> 2] = s; else c[c[m >> 2] >> 2] = s;
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                }
	                a:do if (c[p >> 2] | 0) {
	                    c[m >> 2] = 0;
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break a;
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[p >> 2] | 0))break;
	                        c[m >> 2] = c[k >> 2];
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    s = c[c[k >> 2] >> 2] | 0;
	                    if (!(c[m >> 2] | 0))c[(c[h >> 2] | 0) + 32 >> 2] = s; else c[c[m >> 2] >> 2] = s;
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                } while (0);
	                c[f >> 2] = 0;
	                r = c[f >> 2] | 0;
	                i = e;
	                return r | 0
	            }

	            function tG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (c[c[g >> 2] >> 2] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) <= (c[(c[g >> 2] | 0) + 4 >> 2] | 0) ? (d = (c[g >> 2] | 0) + 8 | 0, c[d >> 2] = c[d >> 2] << 1, d = Hb[c[135760 >> 2] & 511](c[c[g >> 2] >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] << 2) | 0, c[c[g >> 2] >> 2] = d, (c[c[g >> 2] >> 2] | 0) == 0) : 0) {
	                        tC(0, 142376, 0);
	                        c[(c[g >> 2] | 0) + 8 >> 2] = 0;
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } else {
	                    d = Cb[c[135744 >> 2] & 511](80) | 0;
	                    c[c[g >> 2] >> 2] = d;
	                    if (c[c[g >> 2] >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 8 >> 2] = 20;
	                        break
	                    }
	                    tC(0, 142344, 0);
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } while (0);
	                if ((c[j >> 2] | 0) >= (c[(c[g >> 2] | 0) + 4 >> 2] | 0)) {
	                    d = c[h >> 2] | 0;
	                    b = (c[g >> 2] | 0) + 4 | 0;
	                    a = c[b >> 2] | 0;
	                    c[b >> 2] = a + 1;
	                    c[(c[c[g >> 2] >> 2] | 0) + (a << 2) >> 2] = d
	                } else {
	                    c[k >> 2] = c[(c[g >> 2] | 0) + 4 >> 2];
	                    while (1) {
	                        if ((c[k >> 2] | 0) <= (c[j >> 2] | 0))break;
	                        c[(c[c[g >> 2] >> 2] | 0) + (c[k >> 2] << 2) >> 2] = c[(c[c[g >> 2] >> 2] | 0) + ((c[k >> 2] | 0) - 1 << 2) >> 2];
	                        c[k >> 2] = (c[k >> 2] | 0) + -1
	                    }
	                    c[(c[c[g >> 2] >> 2] | 0) + (c[j >> 2] << 2) >> 2] = c[h >> 2];
	                    h = (c[g >> 2] | 0) + 4 | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function uG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0)if (c[(c[f >> 2] | 0) + 48 >> 2] & c[g >> 2]) {
	                    c[e >> 2] = 1;
	                    break
	                } else {
	                    c[e >> 2] = 0;
	                    break
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function vG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                GC(n, 0, c[k >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0) | 0;
	                f = c[h >> 2] | 0;
	                h = c[(c[k >> 2] | 0) + 36 >> 2] | 0;
	                k = c[j >> 2] | 0;
	                j = c[n >> 2] | 0;
	                e = zB(c[c[m >> 2] >> 2] | 0) | 0;
	                EF(f, h, k, 0, 0, 0, 149488, j, e, GC(o, 0, c[l >> 2] | 0, 0) | 0, 0, 0);
	                if (c[n >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[n >> 2] = 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                c[o >> 2] = 0;
	                i = g;
	                return
	            }

	            function wG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                GC(l, 0, c[j >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0) | 0;
	                e = c[g >> 2] | 0;
	                g = c[(c[j >> 2] | 0) + 36 >> 2] | 0;
	                j = c[h >> 2] | 0;
	                h = c[l >> 2] | 0;
	                PC(e, g, j, 149448, h, zB(c[c[k >> 2] >> 2] | 0) | 0);
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                c[l >> 2] = 0;
	                i = f;
	                return
	            }

	            function xG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[j >> 2] | 0) == (c[k >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (((c[c[j >> 2] >> 2] | 0) != 1 ? (c[(c[j >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) ? (KE(c[j >> 2] | 0, c[h >> 2] | 0) | 0) == -1 : 0) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (((c[c[k >> 2] >> 2] | 0) != 1 ? (c[(c[k >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) ? (KE(c[k >> 2] | 0, c[h >> 2] | 0) | 0) == -1 : 0) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if ((c[l >> 2] & 1 | 0) == 0 ? (uG(c[(c[j >> 2] | 0) + 64 >> 2] | 0, 1024) | 0) == 0 : 0) {
	                    if ((c[(c[j >> 2] | 0) + 64 >> 2] | 0) == (c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if (!((c[c[(c[j >> 2] | 0) + 64 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[j >> 2] | 0) + 64 >> 2] | 0) + 88 >> 2] | 0) == 45 : 0))o = 18;
	                    if ((o | 0) == 18 ? (xG(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0) {
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    do if ((c[c[k >> 2] >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 88 >> 2] | 0) == 46 : 0) {
	                        if ((c[(c[j >> 2] | 0) + 48 >> 2] & 64 | 0) == 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] & 128 | 0) == 0 : 0)break;
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } while (0);
	                    a:do if (c[(c[k >> 2] | 0) + 48 >> 2] & 128) {
	                        c[m >> 2] = c[(c[k >> 2] | 0) + 92 >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0))break a;
	                            if (((c[c[(c[m >> 2] | 0) + 4 >> 2] >> 2] | 0) != 1 ? (c[(c[(c[m >> 2] | 0) + 4 >> 2] | 0) + 48 >> 2] & 4194304 | 0) == 0 : 0) ? (KE(c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0) | 0) == -1 : 0) {
	                                o = 31;
	                                break
	                            }
	                            if (!(xG(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[l >> 2] | 0) | 0)) {
	                                o = 33;
	                                break
	                            }
	                            c[m >> 2] = c[c[m >> 2] >> 2]
	                        }
	                        if ((o | 0) == 31) {
	                            c[g >> 2] = -1;
	                            n = c[g >> 2] | 0;
	                            i = f;
	                            return n | 0
	                        } else if ((o | 0) == 33) {
	                            c[g >> 2] = 0;
	                            n = c[g >> 2] | 0;
	                            i = f;
	                            return n | 0
	                        }
	                    } while (0);
	                    c[g >> 2] = 3032;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[g >> 2] = 3031;
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function yG(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (!(c[(c[e >> 2] | 0) + 92 >> 2] | 0)) {
	                    a = eB(0) | 0;
	                    c[(c[e >> 2] | 0) + 92 >> 2] = a;
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 92 >> 2] | 0) {
	                        bB(c[a + 92 >> 2] | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0, c[(c[e >> 2] | 0) + 12 >> 2] | 0, c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                        dB(c[(c[e >> 2] | 0) + 92 >> 2] | 0, c[(c[e >> 2] | 0) + 24 >> 2] | 0, c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                        break
	                    }
	                    PC(a, 0, 3069, 148224, 0, 0);
	                    c[d >> 2] = -1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } while (0);
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function zG(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = 0;
	                c[p >> 2] = my(142568) | 0;
	                g = c[p >> 2] | 0;
	                c[p >> 2] = By(g, zB(c[c[k >> 2] >> 2] | 0) | 0) | 0;
	                c[p >> 2] = By(c[p >> 2] | 0, 147720) | 0;
	                if (!(c[m >> 2] | 0))c[p >> 2] = By(c[p >> 2] | 0, 147736) | 0;
	                g = c[p >> 2] | 0;
	                if ((c[m >> 2] | 0) == 1)c[p >> 2] = By(g, 147752) | 0; else c[p >> 2] = By(g, 147768) | 0;
	                if (c[n >> 2] | 0)c[p >> 2] = By(c[p >> 2] | 0, 147784) | 0;
	                c[p >> 2] = By(c[p >> 2] | 0, 143656) | 0;
	                n = c[p >> 2] | 0;
	                c[p >> 2] = By(n, zB(c[c[l >> 2] >> 2] | 0) | 0) | 0;
	                l = c[p >> 2] | 0;
	                if (c[o >> 2] | 0)c[p >> 2] = By(l, 147800) | 0; else c[p >> 2] = By(l, 142568) | 0;
	                GE(c[j >> 2] | 0, 1717, c[k >> 2] | 0, 0, c[p >> 2] | 0, 0);
	                if (!(c[p >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                i = h;
	                return
	            }

	            function AG(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ce(16, 2, 0, 0, c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function BG(a, b, d, e, f, g, h, j, k, l) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                m = i;
	                i = i + 48 | 0;
	                n = m + 44 | 0;
	                o = m + 40 | 0;
	                p = m + 36 | 0;
	                q = m + 32 | 0;
	                r = m + 28 | 0;
	                s = m + 24 | 0;
	                t = m + 20 | 0;
	                u = m + 16 | 0;
	                v = m + 12 | 0;
	                w = m + 8 | 0;
	                x = m + 4 | 0;
	                y = m;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[p >> 2] = d;
	                c[q >> 2] = e;
	                c[r >> 2] = f;
	                c[s >> 2] = g;
	                c[t >> 2] = h;
	                c[u >> 2] = j;
	                c[v >> 2] = k;
	                c[w >> 2] = l;
	                c[x >> 2] = 0;
	                c[y >> 2] = 0;
	                GC(y, 0, c[q >> 2] | 0, 0) | 0;
	                c[y >> 2] = By(c[y >> 2] | 0, 144448) | 0;
	                q = c[y >> 2] | 0;
	                c[y >> 2] = By(q, GC(x, 0, c[r >> 2] | 0, 0) | 0) | 0;
	                if (c[x >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                    c[x >> 2] = 0
	                }
	                c[y >> 2] = By(c[y >> 2] | 0, 152080) | 0;
	                c[y >> 2] = By(c[y >> 2] | 0, c[s >> 2] | 0) | 0;
	                c[y >> 2] = By(c[y >> 2] | 0, 142704) | 0;
	                IC(c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[y >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[w >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[y >> 2] | 0);
	                i = m;
	                return
	            }

	            function CG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[c[j >> 2] >> 2] = 0;
	                c[c[k >> 2] >> 2] = 0;
	                if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = 0;
	                e = c[h >> 2] | 0;
	                if (c[(c[h >> 2] | 0) + 28 >> 2] | 0) {
	                    c[c[k >> 2] >> 2] = c[e + 28 >> 2];
	                    if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                    if (c[(c[h >> 2] | 0) + 16 >> 2] & 1)c[c[j >> 2] >> 2] = 1;
	                    c[g >> 2] = 1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if ((c[e + 12 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    c[c[k >> 2] >> 2] = c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 44 >> 2];
	                    if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 68 >> 2];
	                    if (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 60 >> 2] & 512)c[c[j >> 2] >> 2] = 1;
	                    c[g >> 2] = 1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[g >> 2] = 0;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function DG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = c[f >> 2] | 0;
	                a:do if (!(c[(c[f >> 2] | 0) + 32 >> 2] | 0)) {
	                    if ((c[b + 36 >> 2] | 0) != 0 & (c[g >> 2] | 0) != 0 ? (qy(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0) | 0) == 0 : 0) {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                } else {
	                    c[h >> 2] = c[b + 32 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break a;
	                        if (qy(c[(c[h >> 2] | 0) + 4 >> 2] | 0, c[g >> 2] | 0) | 0)break;
	                        c[h >> 2] = c[c[h >> 2] >> 2]
	                    }
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[e >> 2] = 1;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function EG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[(c[g >> 2] | 0) + 28 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) : 0) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                do if (c[(c[f >> 2] | 0) + 32 >> 2] | 0) {
	                    if (!(c[(c[g >> 2] | 0) + 32 >> 2] | 0)) {
	                        if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0))break;
	                        c[l >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0)) {
	                                n = 27;
	                                break
	                            }
	                            if ((c[(c[l >> 2] | 0) + 4 >> 2] | 0) == (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0)) {
	                                n = 25;
	                                break
	                            }
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                        if ((n | 0) == 25) {
	                            c[e >> 2] = 1;
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        } else if ((n | 0) == 27) {
	                            c[e >> 2] = 0;
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                    }
	                    c[k >> 2] = 0;
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                    while (1) {
	                        if (!(c[h >> 2] | 0))break;
	                        c[k >> 2] = 0;
	                        c[j >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                        while (1) {
	                            if (!(c[j >> 2] | 0))break;
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == (c[(c[j >> 2] | 0) + 4 >> 2] | 0)) {
	                                n = 14;
	                                break
	                            }
	                            c[j >> 2] = c[c[j >> 2] >> 2]
	                        }
	                        if ((n | 0) == 14) {
	                            n = 0;
	                            c[k >> 2] = 1
	                        }
	                        if (!(c[k >> 2] | 0)) {
	                            n = 17;
	                            break
	                        }
	                        c[h >> 2] = c[c[h >> 2] >> 2]
	                    }
	                    if ((n | 0) == 17) {
	                        c[e >> 2] = 1;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    if (c[k >> 2] | 0) {
	                        c[e >> 2] = 0;
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                } while (0);
	                c[e >> 2] = 1;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function FG(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if (!(((c[c[(c[e >> 2] | 0) + 12 >> 2] >> 2] | 0) != 6 ? (c[c[(c[e >> 2] | 0) + 12 >> 2] >> 2] | 0) != 7 : 0) ? (c[c[(c[e >> 2] | 0) + 12 >> 2] >> 2] | 0) != 8 : 0))f = 8;
	                    if ((f | 0) == 8 ? (vH(c[e >> 2] | 0) | 0) == 0 : 0) {
	                        c[d >> 2] = 1;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 1;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function GG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    tC(c[j >> 2] | 0, 153320, 0);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                f = c[o >> 2] | 0;
	                c[f + 0 >> 2] = 0;
	                c[f + 4 >> 2] = 0;
	                c[f + 8 >> 2] = 0;
	                c[f + 12 >> 2] = 0;
	                c[f + 16 >> 2] = 0;
	                c[f + 20 >> 2] = 0;
	                c[f + 24 >> 2] = 0;
	                c[(c[o >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                c[(c[o >> 2] | 0) + 24 >> 2] = c[k >> 2];
	                c[(c[o >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                c[(c[o >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                n = c[o >> 2] | 0;
	                m = c[(c[j >> 2] | 0) + 28 >> 2] | 0;
	                if (!(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0))c[m + 28 >> 2] = n; else c[c[m + 32 >> 2] >> 2] = n;
	                c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 32 >> 2] = c[o >> 2];
	                c[h >> 2] = c[o >> 2];
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function HG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 44 | 0;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 24 | 0;
	                m = e + 20 | 0;
	                n = e + 16 | 0;
	                o = e + 12 | 0;
	                p = e + 8 | 0;
	                q = e + 4 | 0;
	                r = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if (((c[(c[h >> 2] | 0) + 28 >> 2] | 0) == (c[(c[j >> 2] | 0) + 28 >> 2] | 0) ? ((c[(c[h >> 2] | 0) + 32 >> 2] | 0) == 0 | 0) == ((c[(c[j >> 2] | 0) + 32 >> 2] | 0) == 0 | 0) : 0) ? ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 0 | 0) == ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) == 0 | 0) : 0) {
	                    if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) : 0)break;
	                    if (!(c[(c[h >> 2] | 0) + 32 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                    c[n >> 2] = 0;
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        c[n >> 2] = 0;
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                                t = 12;
	                                break
	                            }
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                        if ((t | 0) == 12) {
	                            t = 0;
	                            c[n >> 2] = 1
	                        }
	                        if (!(c[n >> 2] | 0))break;
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    if (c[n >> 2] | 0) {
	                        c[f >> 2] = 0;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                } while (0);
	                n = c[h >> 2] | 0;
	                if ((c[(c[h >> 2] | 0) + 28 >> 2] | 0) != (c[(c[j >> 2] | 0) + 28 >> 2] | 0)) {
	                    if (!(c[n + 28 >> 2] | 0)) {
	                        c[(c[h >> 2] | 0) + 28 >> 2] = 1;
	                        if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                            nB(c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 32 >> 2] = 0
	                        }
	                        if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 36 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 36 >> 2] = 0
	                        }
	                    }
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                if ((c[n + 32 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                    c[p >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0)) {
	                            t = 40;
	                            break
	                        }
	                        c[o >> 2] = 0;
	                        c[l >> 2] = c[p >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[(c[l >> 2] | 0) + 4 >> 2] | 0)) {
	                                t = 33;
	                                break
	                            }
	                            c[l >> 2] = c[c[l >> 2] >> 2]
	                        }
	                        if ((t | 0) == 33) {
	                            t = 0;
	                            c[o >> 2] = 1
	                        }
	                        if (!(c[o >> 2] | 0)) {
	                            c[m >> 2] = uH(c[g >> 2] | 0) | 0;
	                            if (!(c[m >> 2] | 0)) {
	                                t = 37;
	                                break
	                            }
	                            c[(c[m >> 2] | 0) + 4 >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                            c[c[m >> 2] >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                            c[(c[h >> 2] | 0) + 32 >> 2] = c[m >> 2]
	                        }
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    if ((t | 0) == 37) {
	                        c[f >> 2] = -1;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    } else if ((t | 0) == 40) {
	                        c[f >> 2] = 0;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                }
	                if (((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) : 0) {
	                    c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = 0;
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                }
	                if (!(((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0))t = 48;
	                do if ((t | 0) == 48) {
	                    if (((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)break;
	                    if (!(((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) != 0 : 0))t = 87;
	                    do if ((t | 0) == 87) {
	                        if (((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[h >> 2] | 0) + 32 >> 2] | 0) != 0 : 0)break;
	                        c[f >> 2] = 0;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    } while (0);
	                    if (c[(c[h >> 2] | 0) + 32 >> 2] | 0)c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2]; else c[k >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))break;
	                        if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0)) {
	                            t = 95;
	                            break
	                        }
	                        c[k >> 2] = c[c[k >> 2] >> 2]
	                    }
	                    if ((t | 0) == 95) {
	                        c[(c[h >> 2] | 0) + 28 >> 2] = 1;
	                        if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                            nB(c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 32 >> 2] = 0
	                        }
	                        if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 36 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 36 >> 2] = 0
	                        }
	                        c[f >> 2] = 0;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                    do if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                            nB(c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 32 >> 2] = 0
	                        }
	                        m = uH(c[g >> 2] | 0) | 0;
	                        c[(c[h >> 2] | 0) + 36 >> 2] = m;
	                        if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                            c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = 0;
	                            break
	                        }
	                        c[f >> 2] = -1;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    } while (0);
	                    c[f >> 2] = 0;
	                    s = c[f >> 2] | 0;
	                    i = e;
	                    return s | 0
	                } while (0);
	                c[r >> 2] = 0;
	                if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                    c[l >> 2] = c[(c[j >> 2] | 0) + 36 >> 2]
	                } else {
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                    c[l >> 2] = c[(c[h >> 2] | 0) + 36 >> 2]
	                }
	                c[q >> 2] = 0;
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    if (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == (c[(c[l >> 2] | 0) + 4 >> 2] | 0))c[q >> 2] = 1
	                    } else c[r >> 2] = 1;
	                    if ((c[q >> 2] | 0) != 0 & (c[r >> 2] | 0) != 0)break;
	                    c[k >> 2] = c[c[k >> 2] >> 2]
	                }
	                do if ((c[q >> 2] | 0) != 0 & (c[r >> 2] | 0) != 0) {
	                    c[(c[h >> 2] | 0) + 28 >> 2] = 1;
	                    if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                        nB(c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 32 >> 2] = 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 36 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 36 >> 2] = 0
	                    }
	                } else {
	                    if (!((c[q >> 2] | 0) == 0 | (c[r >> 2] | 0) != 0)) {
	                        if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                            nB(c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 32 >> 2] = 0
	                        }
	                        if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 0 ? (k = uH(c[g >> 2] | 0) | 0, c[(c[h >> 2] | 0) + 36 >> 2] = k, (c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 0) : 0) {
	                            c[f >> 2] = -1;
	                            s = c[f >> 2] | 0;
	                            i = e;
	                            return s | 0
	                        }
	                        c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = 0;
	                        break
	                    }
	                    if ((c[q >> 2] | 0) == 0 & (c[r >> 2] | 0) != 0) {
	                        PC(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, 1794, 152712, 0, 0);
	                        c[f >> 2] = 1794;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                    if (!((c[q >> 2] | 0) != 0 | (c[r >> 2] | 0) != 0) ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) {
	                        if (c[(c[h >> 2] | 0) + 32 >> 2] | 0) {
	                            nB(c[(c[h >> 2] | 0) + 32 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 32 >> 2] = 0
	                        }
	                        k = uH(c[g >> 2] | 0) | 0;
	                        c[(c[h >> 2] | 0) + 36 >> 2] = k;
	                        if (c[(c[h >> 2] | 0) + 36 >> 2] | 0) {
	                            c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                            break
	                        }
	                        c[f >> 2] = -1;
	                        s = c[f >> 2] | 0;
	                        i = e;
	                        return s | 0
	                    }
	                } while (0);
	                c[f >> 2] = 0;
	                s = c[f >> 2] | 0;
	                i = e;
	                return s | 0
	            }

	            function IG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 40 | 0;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                o = d + 4 | 0;
	                p = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                    if ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) != 4) {
	                        if ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) != 1)break;
	                        if ((c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 88 >> 2] | 0) == 45)break
	                    }
	                    if (!(c[(c[g >> 2] | 0) + 48 >> 2] & 2)) {
	                        AB(c[f >> 2] | 0, 3076, 0, c[g >> 2] | 0, 152344, 0, 0);
	                        c[e >> 2] = 3076;
	                        q = c[e >> 2] | 0;
	                        i = d;
	                        return q | 0
	                    }
	                } while (0);
	                a:do if ((c[(c[g >> 2] | 0) + 116 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 116 >> 2] | 0) + 4 >> 2] | 0) > 1 : 0) {
	                    c[h >> 2] = c[(c[g >> 2] | 0) + 116 >> 2];
	                    c[n >> 2] = 0;
	                    c[l >> 2] = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) - 1;
	                    b:while (1) {
	                        if ((c[l >> 2] | 0) < 0)break a;
	                        c[j >> 2] = c[(c[c[h >> 2] >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                        c:do if ((c[l >> 2] | 0) > 0) {
	                            c[m >> 2] = (c[l >> 2] | 0) - 1;
	                            while (1) {
	                                if ((c[m >> 2] | 0) < 0) {
	                                    r = 20;
	                                    break c
	                                }
	                                c[k >> 2] = c[(c[c[h >> 2] >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                if ((c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) == (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0) ? (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) == (c[(c[(c[k >> 2] | 0) + 12 >> 2] | 0) + 56 >> 2] | 0) : 0)break;
	                                c[m >> 2] = (c[m >> 2] | 0) + -1
	                            }
	                            c[o >> 2] = 0;
	                            b = c[f >> 2] | 0;
	                            a = c[g >> 2] | 0;
	                            AB(b, 3087, 0, a, 152424, ZD(o, c[j >> 2] | 0) | 0, 0);
	                            if (c[o >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                c[o >> 2] = 0
	                            }
	                            if ((TE(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == -1)break b
	                        } else r = 20; while (0);
	                        if (((r | 0) == 20 ? (r = 0, (c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0) != 0) : 0) ? (SE(c[(c[(c[j >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] | 0, 23) | 0) != 0 : 0) {
	                            if (c[n >> 2] | 0) {
	                                c[p >> 2] = 0;
	                                a = c[f >> 2] | 0;
	                                b = c[g >> 2] | 0;
	                                AB(a, 3087, 0, b, 152440, ZD(p, c[j >> 2] | 0) | 0, 0);
	                                if (c[p >> 2] | 0) {
	                                    zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                                    c[p >> 2] = 0
	                                }
	                                if ((TE(c[h >> 2] | 0, c[l >> 2] | 0) | 0) == -1)break
	                            }
	                            c[n >> 2] = 1
	                        }
	                        c[l >> 2] = (c[l >> 2] | 0) + -1
	                    }
	                    c[e >> 2] = -1;
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                } while (0);
	                c[e >> 2] = 0;
	                q = c[e >> 2] | 0;
	                i = d;
	                return q | 0
	            }

	            function JG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                if ((c[c[h >> 2] >> 2] | 0) != 5 ? (c[(c[h >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 104 >> 2] | 0) != (c[h >> 2] | 0)) {
	                        GE(c[f >> 2] | 0, 3063, c[g >> 2] | 0, 0, 152296, 0);
	                        c[e >> 2] = 3063;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 48 >> 2] & 512) {
	                        GE(c[f >> 2] | 0, 3063, c[g >> 2] | 0, 0, 152088, 0);
	                        c[e >> 2] = 3063;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                } else k = 3;
	                do if ((k | 0) == 3) {
	                    if (c[(c[h >> 2] | 0) + 48 >> 2] & 512) {
	                        GE(c[f >> 2] | 0, 3063, c[g >> 2] | 0, 0, 152088, 0);
	                        c[e >> 2] = 3063;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    if ((c[(c[g >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 104 >> 2] | 0) == (c[(c[h >> 2] | 0) + 104 >> 2] | 0) : 0)break;
	                    if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) == 1 ? (c[(c[h >> 2] | 0) + 52 >> 2] | 0) == 1 : 0)break;
	                    if (!(c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                        GE(c[f >> 2] | 0, 3063, c[g >> 2] | 0, 0, 152152, 0);
	                        c[e >> 2] = 3063;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 1) {
	                        if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) == (c[(c[h >> 2] | 0) + 52 >> 2] | 0)) {
	                            if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) == 3)break;
	                            if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) == 2)break
	                        }
	                        GE(c[f >> 2] | 0, 3063, c[g >> 2] | 0, 0, 152200, 0);
	                        c[e >> 2] = 3063;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                } while (0);
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function KG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                if ((c[c[h >> 2] >> 2] | 0) != 5 ? (c[(c[h >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                    AB(c[f >> 2] | 0, 1787, c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[g >> 2] | 0, 150744, 0, 0);
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                b = c[f >> 2] | 0;
	                if (c[(c[h >> 2] | 0) + 48 >> 2] & 1024) {
	                    AB(b, 1787, c[(c[g >> 2] | 0) + 36 >> 2] | 0, c[g >> 2] | 0, 150784, 0, 0);
	                    c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if ((UE(b, 0, c[g >> 2] | 0, c[h >> 2] | 0, c[(c[g >> 2] | 0) + 116 >> 2] | 0, c[(c[h >> 2] | 0) + 116 >> 2] | 0, c[(c[g >> 2] | 0) + 84 >> 2] | 0, c[(c[h >> 2] | 0) + 84 >> 2] | 0) | 0) == -1) {
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                do if ((c[(c[h >> 2] | 0) + 88 >> 2] | 0) != 45) {
	                    if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                        if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) == 1) {
	                            if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) == 1)break;
	                            if (!((c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 2 ? (c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 3 : 0))n = 28;
	                            if ((n | 0) == 28 ? (FG(c[(c[h >> 2] | 0) + 28 >> 2] | 0) | 0) != 0 : 0)break;
	                            GE(c[f >> 2] | 0, 1787, c[g >> 2] | 0, 0, 151040, 0);
	                            c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 2 ? (c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 3 : 0) {
	                            GE(c[f >> 2] | 0, 1787, c[g >> 2] | 0, 0, 151256, 0);
	                            c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                        if ((c[(c[g >> 2] | 0) + 52 >> 2] | 0) != 3)break;
	                        if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) == 3)break;
	                        GE(c[f >> 2] | 0, 1787, c[g >> 2] | 0, 0, 151160, 0);
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[h >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                        if ((c[(c[h >> 2] | 0) + 52 >> 2] | 0) == 3 ? (FG(c[(c[h >> 2] | 0) + 28 >> 2] | 0) | 0) != 0 : 0)break;
	                        GE(c[f >> 2] | 0, 1787, c[g >> 2] | 0, 0, 150936, 0);
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                    c[j >> 2] = xG(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 104 >> 2] | 0, c[(c[h >> 2] | 0) + 104 >> 2] | 0, 0) | 0;
	                    if (c[j >> 2] | 0) {
	                        c[k >> 2] = 0;
	                        c[l >> 2] = 0;
	                        if ((c[j >> 2] | 0) == -1) {
	                            c[e >> 2] = -1;
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                        b = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        o = ZD(k, c[(c[g >> 2] | 0) + 104 >> 2] | 0) | 0;
	                        AB(b, 1787, 0, a, 150848, o, ZD(l, c[(c[h >> 2] | 0) + 104 >> 2] | 0) | 0);
	                        if (c[k >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                            c[k >> 2] = 0
	                        }
	                        if (c[l >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                            c[l >> 2] = 0
	                        }
	                        c[e >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    }
	                } while (0);
	                c[e >> 2] = 0;
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function LG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[(c[g >> 2] | 0) + 80 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = c[g >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 80 >> 2] | 0) == (c[f >> 2] | 0)) {
	                    c[e >> 2] = b;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (c[(c[b + 80 >> 2] | 0) + 48 >> 2] & 512) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = (c[(c[g >> 2] | 0) + 80 >> 2] | 0) + 48 | 0;
	                    c[b >> 2] = c[b >> 2] | 512;
	                    c[h >> 2] = LG(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 80 >> 2] | 0) | 0;
	                    f = (c[(c[g >> 2] | 0) + 80 >> 2] | 0) + 48 | 0;
	                    c[f >> 2] = c[f >> 2] ^ 512;
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function MG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                do if ((c[c[j >> 2] >> 2] | 0) != 4) {
	                    if ((c[c[j >> 2] >> 2] | 0) == 1 ? (c[(c[j >> 2] | 0) + 88 >> 2] | 0) != 45 : 0)break;
	                    c[g >> 2] = wH(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } while (0);
	                c[g >> 2] = xG(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function NG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if (!((c[c[l >> 2] >> 2] | 0) != 5 ? (c[(c[l >> 2] | 0) + 88 >> 2] | 0) != 45 : 0))p = 3;
	                do if (((p | 0) == 3 ? (c[(c[l >> 2] | 0) + 52 >> 2] | 0) != 4 : 0) ? (c[(c[l >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                    if ((c[(c[l >> 2] | 0) + 52 >> 2] | 0) == 3 ? (FG(c[(c[l >> 2] | 0) + 28 >> 2] | 0) | 0) != 0 : 0)break;
	                    GE(c[j >> 2] | 0, 3059, c[l >> 2] | 0, c[(c[l >> 2] | 0) + 36 >> 2] | 0, 159240, 0);
	                    c[h >> 2] = 3059;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } while (0);
	                do if ((c[c[l >> 2] >> 2] | 0) == 4)p = 11; else {
	                    if ((c[c[l >> 2] >> 2] | 0) == 1 ? (c[(c[l >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        p = 11;
	                        break
	                    }
	                    if ((c[(c[l >> 2] | 0) + 52 >> 2] | 0) != 4 ? (c[(c[l >> 2] | 0) + 52 >> 2] | 0) != 6 : 0) {
	                        c[h >> 2] = c[o >> 2];
	                        q = c[h >> 2] | 0;
	                        i = g;
	                        return q | 0
	                    }
	                    c[o >> 2] = yB(c[j >> 2] | 0, c[k >> 2] | 0, c[(c[l >> 2] | 0) + 104 >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, 1, 1, 0) | 0
	                } while (0);
	                if ((p | 0) == 11)c[o >> 2] = yB(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, 1, 1, 0) | 0;
	                if ((c[o >> 2] | 0) < 0)xB(c[j >> 2] | 0, 159384, 141832);
	                c[h >> 2] = c[o >> 2];
	                q = c[h >> 2] | 0;
	                i = g;
	                return q | 0
	            }

	            function OG(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = xH(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0))c[k >> 2] = yH(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((bE(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0) | 0) == -1) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function PG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] & 131072)) {
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                    if (c[(c[j >> 2] | 0) + 48 >> 2] & 16) {
	                        c[e >> 2] = 0;
	                        o = c[e >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    }
	                    do if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 1) {
	                        c[k >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                        b = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 76 >> 2] = b
	                    } else {
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) >= 1073741824 ? (c[(c[g >> 2] | 0) + 16 >> 2] | 0) < 2 : 0) {
	                            c[k >> 2] = c[(c[f >> 2] | 0) + 76 >> 2];
	                            b = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[j >> 2] | 0) | 0;
	                            c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                            b = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[j >> 2] | 0) | 0;
	                            c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                            break
	                        }
	                        if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) == 1073741824)p = 1073741824; else p = (c[(c[g >> 2] | 0) + 20 >> 2] | 0) - 1 | 0;
	                        c[m >> 2] = p;
	                        if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) < 1)q = 0; else q = (c[(c[g >> 2] | 0) + 16 >> 2] | 0) - 1 | 0;
	                        c[n >> 2] = q;
	                        c[k >> 2] = Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, 0) | 0;
	                        c[l >> 2] = Lz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[n >> 2] | 0, c[m >> 2] | 0) | 0;
	                        b = Ez(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 76 >> 2] = b;
	                        Mz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        b = Nz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0, 0, c[l >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 76 >> 2] = b
	                    } while (0);
	                    if (!(c[(c[g >> 2] | 0) + 16 >> 2] | 0)) {
	                        Jz(c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[(c[f >> 2] | 0) + 76 >> 2] | 0) | 0;
	                        c[h >> 2] = 1
	                    }
	                } else c[h >> 2] = QG(c[f >> 2] | 0, c[g >> 2] | 0, -1, 0) | 0;
	                c[e >> 2] = c[h >> 2];
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function QG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 56 | 0;
	                h = f + 52 | 0;
	                j = f + 48 | 0;
	                k = f + 44 | 0;
	                l = f + 40 | 0;
	                m = f + 36 | 0;
	                n = f + 32 | 0;
	                o = f + 28 | 0;
	                p = f + 24 | 0;
	                q = f + 20 | 0;
	                r = f + 16 | 0;
	                s = f + 12 | 0;
	                t = f + 8 | 0;
	                u = f + 4 | 0;
	                v = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[s >> 2] = 0;
	                c[o >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                c[m >> 2] = c[(c[h >> 2] | 0) + 76 >> 2];
	                if (!(c[l >> 2] | 0))c[l >> 2] = Iz(c[(c[h >> 2] | 0) + 64 >> 2] | 0) | 0;
	                c[q >> 2] = xH(c[h >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    e = c[h >> 2] | 0;
	                    d = FC(c[j >> 2] | 0) | 0;
	                    PC(e, d, 3069, 158280, c[(c[o >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[g >> 2] = 0;
	                    w = c[g >> 2] | 0;
	                    i = f;
	                    return w | 0
	                }
	                a:do if ((c[k >> 2] | 0) >= 0) {
	                    c[n >> 2] = Mz(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[m >> 2] | 0, 0, c[k >> 2] | 0) | 0;
	                    Ez(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0;
	                    c[r >> 2] = 0;
	                    while (1) {
	                        if ((c[r >> 2] | 0) >= (c[(c[(c[q >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0))break a;
	                        c[p >> 2] = c[(c[c[(c[q >> 2] | 0) + 4 >> 2] >> 2] | 0) + (c[r >> 2] << 2) >> 2];
	                        Ez(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 52 >> 2] | 0, c[p >> 2] | 0) | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                } else {
	                    if ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) == 1) {
	                        d = c[(c[h >> 2] | 0) + 64 >> 2] | 0;
	                        e = Ez(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[m >> 2] | 0, 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0;
	                        Jz(d, e, c[l >> 2] | 0) | 0;
	                        c[r >> 2] = 0;
	                        while (1) {
	                            if ((c[r >> 2] | 0) >= (c[(c[(c[q >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0))break a;
	                            c[p >> 2] = c[(c[c[(c[q >> 2] | 0) + 4 >> 2] >> 2] | 0) + (c[r >> 2] << 2) >> 2];
	                            c[n >> 2] = Ez(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[m >> 2] | 0, 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 52 >> 2] | 0, c[p >> 2] | 0) | 0;
	                            Jz(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                            c[r >> 2] = (c[r >> 2] | 0) + 1
	                        }
	                    }
	                    if ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) == 1073741824)x = 1073741824; else x = (c[(c[j >> 2] | 0) + 20 >> 2] | 0) - 1 | 0;
	                    c[u >> 2] = x;
	                    if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) < 1)y = 0; else y = (c[(c[j >> 2] | 0) + 16 >> 2] | 0) - 1 | 0;
	                    c[v >> 2] = y;
	                    c[k >> 2] = Lz(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[v >> 2] | 0, c[u >> 2] | 0) | 0;
	                    c[t >> 2] = Iz(c[(c[h >> 2] | 0) + 64 >> 2] | 0) | 0;
	                    e = c[(c[h >> 2] | 0) + 64 >> 2] | 0;
	                    d = Ez(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[m >> 2] | 0, 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0;
	                    Jz(e, d, c[t >> 2] | 0) | 0;
	                    c[r >> 2] = 0;
	                    while (1) {
	                        if ((c[r >> 2] | 0) >= (c[(c[(c[q >> 2] | 0) + 4 >> 2] | 0) + 4 >> 2] | 0))break;
	                        c[p >> 2] = c[(c[c[(c[q >> 2] | 0) + 4 >> 2] >> 2] | 0) + (c[r >> 2] << 2) >> 2];
	                        d = c[(c[h >> 2] | 0) + 64 >> 2] | 0;
	                        e = Ez(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[m >> 2] | 0, 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 52 >> 2] | 0, c[p >> 2] | 0) | 0;
	                        Jz(d, e, c[t >> 2] | 0) | 0;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                    Mz(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, c[m >> 2] | 0, c[k >> 2] | 0) | 0;
	                    Nz(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[t >> 2] | 0, c[l >> 2] | 0, c[k >> 2] | 0) | 0
	                } while (0);
	                if (!(c[(c[j >> 2] | 0) + 16 >> 2] | 0)) {
	                    Jz(c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[m >> 2] | 0, c[l >> 2] | 0) | 0;
	                    c[s >> 2] = 1
	                }
	                c[(c[h >> 2] | 0) + 76 >> 2] = c[l >> 2];
	                c[g >> 2] = c[s >> 2];
	                w = c[g >> 2] | 0;
	                i = f;
	                return w | 0
	            }

	            function RG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[(c[f >> 2] | 0) + 168 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    if ((c[h >> 2] | 0) >= (c[(c[f >> 2] | 0) + 168 >> 2] | 0)) {
	                        l = 8;
	                        break
	                    }
	                    c[j >> 2] = c[(c[(c[f >> 2] | 0) + 164 >> 2] | 0) + (c[h >> 2] << 2) >> 2];
	                    if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) == (c[g >> 2] | 0)) {
	                        l = 6;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((l | 0) == 6) {
	                    c[e >> 2] = c[j >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else if ((l | 0) == 8) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function SG(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 32 | 0;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                p = g + 4 | 0;
	                q = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                c[q >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                f = c[j >> 2] | 0;
	                if (!(c[(c[j >> 2] | 0) + 88 >> 2] | 0)) {
	                    xB(f, 155272, 155304);
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[p >> 2] = c[f + 88 >> 2];
	                f = c[p >> 2] | 0;
	                if (!(c[(c[p >> 2] | 0) + 28 >> 2] | 0)) {
	                    xB(f, 155272, 155336);
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[n >> 2] = JF(c[f + 80 >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                c[o >> 2] = FB(c[p >> 2] | 0, 1, c[n >> 2] | 0, 0, 0, 0, c[l >> 2] | 0, 0, c[m >> 2] | 0, q) | 0;
	                if (c[o >> 2] | 0) {
	                    c[h >> 2] = c[o >> 2];
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                if (!(c[q >> 2] | 0)) {
	                    NC(c[j >> 2] | 0, 1879, c[l >> 2] | 0, 0, 155352, c[n >> 2] | 0, 0, 0);
	                    c[h >> 2] = c[o >> 2];
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                if ((c[q >> 2] | 0) != 0 ? (c[(c[(c[p >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) == 0 : 0)c[(c[(c[p >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] = c[q >> 2];
	                if (((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[q >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    c[(c[p >> 2] | 0) + 20 >> 2] = 0;
	                    c[(c[p >> 2] | 0) + 16 >> 2] = 0;
	                    c[(c[p >> 2] | 0) + 48 >> 2] = c[(c[q >> 2] | 0) + 20 >> 2];
	                    c[o >> 2] = GB(c[p >> 2] | 0, c[k >> 2] | 0, c[q >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) == -1) {
	                        c[(c[p >> 2] | 0) + 48 >> 2] = 0;
	                        c[(c[p >> 2] | 0) + 48 >> 2] = 0;
	                        c[h >> 2] = -1;
	                        r = c[h >> 2] | 0;
	                        i = g;
	                        return r | 0
	                    }
	                    if ((c[o >> 2] | 0) == 0 ? (c[(c[p >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)c[o >> 2] = c[(c[p >> 2] | 0) + 16 >> 2];
	                    k = c[p >> 2] | 0;
	                    if (!(c[(c[p >> 2] | 0) + 20 >> 2] | 0)) {
	                        HB(k, c[q >> 2] | 0) | 0;
	                        c[o >> 2] = c[(c[p >> 2] | 0) + 16 >> 2];
	                        if ((c[o >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 52 >> 2] | 0) == 0 : 0)c[(c[j >> 2] | 0) + 52 >> 2] = c[o >> 2];
	                        q = (c[j >> 2] | 0) + 56 | 0;
	                        c[q >> 2] = (c[q >> 2] | 0) + (c[(c[p >> 2] | 0) + 20 >> 2] | 0)
	                    } else {
	                        q = (c[j >> 2] | 0) + 56 | 0;
	                        c[q >> 2] = (c[q >> 2] | 0) + (c[k + 20 >> 2] | 0)
	                    }
	                    c[(c[p >> 2] | 0) + 48 >> 2] = 0;
	                    c[h >> 2] = c[o >> 2];
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[h >> 2] = 0;
	                r = c[h >> 2] | 0;
	                i = g;
	                return r | 0
	            }

	            function TG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 40 | 0;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                q = f + 4 | 0;
	                r = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                c[c[k >> 2] >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    s = c[g >> 2] | 0;
	                    i = f;
	                    return s | 0
	                }
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[(c[h >> 2] | 0) + 108 >> 2] = c[j >> 2];
	                c[m >> 2] = zH(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0, n, o) | 0;
	                do if (c[m >> 2] | 0) {
	                    if ((c[m >> 2] | 0) < 0) {
	                        xB(c[h >> 2] | 0, 146768, 146808);
	                        c[(c[h >> 2] | 0) + 108 >> 2] = c[(c[(c[h >> 2] | 0) + 100 >> 2] | 0) + (c[(c[h >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                        c[g >> 2] = -1;
	                        s = c[g >> 2] | 0;
	                        i = f;
	                        return s | 0
	                    }
	                } else {
	                    j = wE(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[o >> 2] | 0, c[n >> 2] | 0) | 0;
	                    c[c[k >> 2] >> 2] = j;
	                    if (!(c[c[k >> 2] >> 2] | 0)) {
	                        c[p >> 2] = 0;
	                        j = c[h >> 2] | 0;
	                        e = IH(21) | 0;
	                        AB(j, 1851, 0, e, 146880, BB(p, c[n >> 2] | 0, c[o >> 2] | 0) | 0, 0);
	                        if (c[p >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                            c[p >> 2] = 0
	                        }
	                        c[m >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                        break
	                    }
	                    if (c[l >> 2] | 0) {
	                        c[q >> 2] = 0;
	                        if (!((c[(c[l >> 2] | 0) + 48 >> 2] & 2048 | 0) == 0 ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 48 >> 2] & 262144 | 0) == 0 : 0))c[q >> 2] = c[q >> 2] | 2;
	                        if (!((c[(c[l >> 2] | 0) + 48 >> 2] & 4096 | 0) == 0 ? (c[(c[(c[l >> 2] | 0) + 28 >> 2] | 0) + 48 >> 2] & 524288 | 0) == 0 : 0))c[q >> 2] = c[q >> 2] | 1;
	                        if (MG(c[h >> 2] | 0, c[c[k >> 2] >> 2] | 0, c[(c[l >> 2] | 0) + 28 >> 2] | 0, c[q >> 2] | 0) | 0) {
	                            c[r >> 2] = 0;
	                            e = c[h >> 2] | 0;
	                            AB(e, 1852, 0, 0, 146968, BB(r, c[(c[c[k >> 2] >> 2] | 0) + 112 >> 2] | 0, c[(c[c[k >> 2] >> 2] | 0) + 8 >> 2] | 0) | 0, 0);
	                            if (c[r >> 2] | 0) {
	                                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                c[r >> 2] = 0
	                            }
	                            c[m >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                            c[c[k >> 2] >> 2] = 0
	                        }
	                    }
	                } while (0);
	                c[(c[h >> 2] | 0) + 108 >> 2] = c[(c[(c[h >> 2] | 0) + 100 >> 2] | 0) + (c[(c[h >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                c[g >> 2] = c[m >> 2];
	                s = c[g >> 2] | 0;
	                i = f;
	                return s | 0
	            }

	            function UG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = c[(c[g >> 2] | 0) + 100 >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                if (c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 56 >> 2] | 0) {
	                    xB(c[f >> 2] | 0, 146584, 146616);
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                a:while (1) {
	                    do if ((c[c[k >> 2] >> 2] | 0) == 24 ? (c[l >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2], (c[l >> 2] | 0) != 0) : 0) {
	                        c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 76 >> 2] = 1;
	                        c[m >> 2] = c[(c[f >> 2] | 0) + 112 >> 2];
	                        while (1) {
	                            if (!(c[m >> 2] | 0))break;
	                            if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == (c[l >> 2] | 0))break;
	                            c[m >> 2] = c[c[m >> 2] >> 2]
	                        }
	                        if (!(c[m >> 2] | 0)) {
	                            o = 12;
	                            break a
	                        }
	                        if ((c[(c[m >> 2] | 0) + 8 >> 2] | 0) != -1 ? (c[(c[f >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[m >> 2] | 0) + 8 >> 2] | 0) : 0)break;
	                        c[(c[m >> 2] | 0) + 8 >> 2] = c[(c[f >> 2] | 0) + 96 >> 2]
	                    } while (0);
	                    c[m >> 2] = c[(c[f >> 2] | 0) + 112 >> 2];
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break;
	                        if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == (c[k >> 2] | 0))break;
	                        c[m >> 2] = c[c[m >> 2] >> 2]
	                    }
	                    p = c[f >> 2] | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        o = 21;
	                        break
	                    }
	                    if (c[p + 124 >> 2] | 0) {
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 124 >> 2];
	                        c[(c[f >> 2] | 0) + 124 >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                        c[(c[h >> 2] | 0) + 12 >> 2] = 0
	                    } else {
	                        c[h >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            o = 25;
	                            break
	                        }
	                        g = (c[h >> 2] | 0) + 0 | 0;
	                        b = g + 36 | 0;
	                        do {
	                            c[g >> 2] = 0;
	                            g = g + 4 | 0
	                        } while ((g | 0) < (b | 0))
	                    }
	                    g = c[h >> 2] | 0;
	                    if (!(c[j >> 2] | 0))c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + 56 >> 2] = g; else c[(c[j >> 2] | 0) + 8 >> 2] = g;
	                    c[j >> 2] = c[h >> 2];
	                    c[c[h >> 2] >> 2] = 0;
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[f >> 2] | 0) + 96 >> 2];
	                    c[(c[h >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                    c[(c[h >> 2] | 0) + 20 >> 2] = c[c[(c[m >> 2] | 0) + 4 >> 2] >> 2];
	                    if ((VG(c[f >> 2] | 0, c[h >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0, 1) | 0) == -1) {
	                        o = 31;
	                        break
	                    }
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 8 >> 2];
	                    if (!(c[k >> 2] | 0)) {
	                        o = 33;
	                        break
	                    }
	                }
	                if ((o | 0) == 12) {
	                    xB(c[f >> 2] | 0, 146584, 146672);
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((o | 0) == 21) {
	                    xB(p, 146584, 146672);
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((o | 0) == 25) {
	                    IB(c[f >> 2] | 0, 146736, 0);
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((o | 0) == 31) {
	                    c[e >> 2] = -1;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((o | 0) == 33) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                return 0
	            }

	            function VG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                do if (c[(c[h >> 2] | 0) + 120 >> 2] | 0) {
	                    c[m >> 2] = c[(c[h >> 2] | 0) + 120 >> 2];
	                    c[(c[h >> 2] | 0) + 120 >> 2] = c[(c[m >> 2] | 0) + 4 >> 2];
	                    c[(c[m >> 2] | 0) + 4 >> 2] = 0
	                } else {
	                    c[m >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                    if (c[m >> 2] | 0) {
	                        e = (c[m >> 2] | 0) + 0 | 0;
	                        d = e + 36 | 0;
	                        do {
	                            c[e >> 2] = 0;
	                            e = e + 4 | 0
	                        } while ((e | 0) < (d | 0));
	                        break
	                    }
	                    IB(0, 146088, 0);
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } while (0);
	                if (c[(c[h >> 2] | 0) + 116 >> 2] | 0)c[(c[m >> 2] | 0) + 4 >> 2] = c[(c[h >> 2] | 0) + 116 >> 2];
	                c[(c[h >> 2] | 0) + 116 >> 2] = c[m >> 2];
	                if (c[(c[m >> 2] | 0) + 32 >> 2] | 0)GQ(c[(c[m >> 2] | 0) + 32 >> 2] | 0);
	                e = OQ(c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0;
	                c[(c[m >> 2] | 0) + 32 >> 2] = e;
	                if (!(c[(c[m >> 2] | 0) + 32 >> 2] | 0)) {
	                    xB(c[h >> 2] | 0, 146120, 146152);
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else {
	                    c[c[m >> 2] >> 2] = c[l >> 2];
	                    c[(c[m >> 2] | 0) + 8 >> 2] = c[(c[h >> 2] | 0) + 96 >> 2];
	                    c[(c[m >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                    c[(c[m >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                    c[(c[m >> 2] | 0) + 16 >> 2] = 0;
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function WG(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[(c[e >> 2] | 0) + 116 >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[f >> 2] = c[(c[e >> 2] | 0) + 116 >> 2];
	                while (1) {
	                    c[g >> 2] = KQ(c[(c[f >> 2] | 0) + 32 >> 2] | 0) | 0;
	                    if ((c[g >> 2] | 0) == -1) {
	                        j = 5;
	                        break
	                    }
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                    if (!(c[f >> 2] | 0)) {
	                        j = 7;
	                        break
	                    }
	                }
	                if ((j | 0) == 5) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 7) {
	                    c[d >> 2] = 0;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function XG(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                HC(l, c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[l >> 2] = By(c[l >> 2] | 0, 145232) | 0;
	                e = c[g >> 2] | 0;
	                g = c[h >> 2] | 0;
	                h = c[k >> 2] | 0;
	                d = c[l >> 2] | 0;
	                PD(e, g, h, d, AH(m, c[j >> 2] | 0, c[k >> 2] | 0) | 0, 0);
	                if (c[m >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[m >> 2] = 0
	                }
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                c[l >> 2] = 0;
	                i = f;
	                return
	            }

	            function YG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = ZD(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function ZG(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[(c[f >> 2] | 0) + 140 >> 2] | 0) {
	                    if ((c[(c[f >> 2] | 0) + 148 >> 2] | 0) <= (c[(c[f >> 2] | 0) + 144 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 148 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 140 >> 2] | 0, c[(c[f >> 2] | 0) + 148 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 140 >> 2] = b, (c[(c[f >> 2] | 0) + 140 >> 2] | 0) == 0) : 0) {
	                        IB(c[f >> 2] | 0, 143616, 0);
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                } else {
	                    b = Cb[c[135744 >> 2] & 511](160) | 0;
	                    c[(c[f >> 2] | 0) + 140 >> 2] = b;
	                    b = c[f >> 2] | 0;
	                    if (c[(c[f >> 2] | 0) + 140 >> 2] | 0) {
	                        c[b + 148 >> 2] = 40;
	                        break
	                    }
	                    IB(b, 143576, 0);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                b = c[g >> 2] | 0;
	                g = (c[f >> 2] | 0) + 144 | 0;
	                a = c[g >> 2] | 0;
	                c[g >> 2] = a + 1;
	                c[(c[(c[f >> 2] | 0) + 140 >> 2] | 0) + (a << 2) >> 2] = b;
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function _G(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                c[d + 4 >> 2] = a;
	                c[e >> 2] = b;
	                if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                    b = JB() | 0;
	                    c[(c[e >> 2] | 0) + 32 >> 2] = b
	                }
	                i = d;
	                return c[(c[e >> 2] | 0) + 32 >> 2] | 0
	            }

	            function $G(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[n >> 2] = 0;
	                e = my(142560) | 0;
	                c[c[h >> 2] >> 2] = e;
	                c[l >> 2] = 0;
	                while (1) {
	                    o = c[c[h >> 2] >> 2] | 0;
	                    if ((c[l >> 2] | 0) >= (c[k >> 2] | 0))break;
	                    e = By(o, 142568) | 0;
	                    c[c[h >> 2] >> 2] = e;
	                    e = c[(c[(c[j >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0;
	                    c[m >> 2] = gH(e, QD(c[c[(c[j >> 2] | 0) + (c[l >> 2] << 2) >> 2] >> 2] | 0) | 0, n) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        e = By(c[c[h >> 2] >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[c[h >> 2] >> 2] = e
	                    } else {
	                        xB(c[g >> 2] | 0, 142576, 142608);
	                        e = By(c[c[h >> 2] >> 2] | 0, 142648) | 0;
	                        c[c[h >> 2] >> 2] = e
	                    }
	                    e = c[c[h >> 2] >> 2] | 0;
	                    if ((c[l >> 2] | 0) < ((c[k >> 2] | 0) - 1 | 0)) {
	                        d = By(e, 142656) | 0;
	                        c[c[h >> 2] >> 2] = d
	                    } else {
	                        d = By(e, 142568) | 0;
	                        c[c[h >> 2] >> 2] = d
	                    }
	                    if (c[n >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[n >> 2] = 0
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                l = By(o, 142664) | 0;
	                c[c[h >> 2] >> 2] = l;
	                i = f;
	                return c[c[h >> 2] >> 2] | 0
	            }

	            function aH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[(c[f >> 2] | 0) + 128 >> 2] | 0) {
	                    if ((c[(c[f >> 2] | 0) + 136 >> 2] | 0) <= (c[(c[f >> 2] | 0) + 132 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 136 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 128 >> 2] | 0, c[(c[f >> 2] | 0) + 136 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 128 >> 2] = b, (c[(c[f >> 2] | 0) + 128 >> 2] | 0) == 0) : 0) {
	                        IB(c[f >> 2] | 0, 143528, 0);
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                } else {
	                    b = Cb[c[135744 >> 2] & 511](80) | 0;
	                    c[(c[f >> 2] | 0) + 128 >> 2] = b;
	                    b = c[f >> 2] | 0;
	                    if (c[(c[f >> 2] | 0) + 128 >> 2] | 0) {
	                        c[b + 136 >> 2] = 20;
	                        break
	                    }
	                    IB(b, 143488, 0);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                b = c[g >> 2] | 0;
	                g = (c[f >> 2] | 0) + 132 | 0;
	                a = c[g >> 2] | 0;
	                c[g >> 2] = a + 1;
	                c[(c[(c[f >> 2] | 0) + 128 >> 2] | 0) + (a << 2) >> 2] = b;
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function bH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[h >> 2] = AP(c[(c[g >> 2] | 0) + 156 >> 2] | 0, c[h >> 2] | 0, -1) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if ((c[j >> 2] | 0) != 0 ? (c[j >> 2] = AP(c[(c[g >> 2] | 0) + 156 >> 2] | 0, c[j >> 2] | 0, -1) | 0, (c[j >> 2] | 0) == 0) : 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[(c[(c[g >> 2] | 0) + 180 >> 2] | 0) + 4 >> 2] | 0)) {
	                        m = 12;
	                        break
	                    }
	                    if ((c[(c[c[(c[g >> 2] | 0) + 180 >> 2] >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) == (c[h >> 2] | 0) ? (c[(c[c[(c[g >> 2] | 0) + 180 >> 2] >> 2] | 0) + ((c[k >> 2] | 0) + 1 << 2) >> 2] | 0) == (c[j >> 2] | 0) : 0) {
	                        m = 10;
	                        break
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 2
	                }
	                if ((m | 0) == 10) {
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((m | 0) == 12) {
	                    c[k >> 2] = c[(c[(c[g >> 2] | 0) + 180 >> 2] | 0) + 4 >> 2];
	                    bE(c[(c[g >> 2] | 0) + 180 >> 2] | 0, c[h >> 2] | 0) | 0;
	                    bE(c[(c[g >> 2] | 0) + 180 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function cH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[(c[f >> 2] | 0) + 100 >> 2] | 0) + (c[(c[g >> 2] | 0) + 4 >> 2] << 2) >> 2];
	                if (!(c[(c[h >> 2] | 0) + 52 >> 2] | 0)) {
	                    f = fH(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 52 >> 2] = f;
	                    if (!(c[(c[h >> 2] | 0) + 52 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    } else {
	                        c[e >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                }
	                c[j >> 2] = 0;
	                c[j >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                while (1) {
	                    l = c[j >> 2] | 0;
	                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == (c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0)) {
	                        m = 7;
	                        break
	                    }
	                    if (!(c[l >> 2] | 0)) {
	                        m = 9;
	                        break
	                    }
	                    c[j >> 2] = c[c[j >> 2] >> 2];
	                    if (!(c[j >> 2] | 0)) {
	                        m = 13;
	                        break
	                    }
	                }
	                if ((m | 0) == 7) {
	                    c[e >> 2] = l;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else if ((m | 0) == 9) {
	                    l = fH(c[(c[(c[g >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                    c[c[j >> 2] >> 2] = l;
	                    if (!(c[c[j >> 2] >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    } else {
	                        c[e >> 2] = c[c[j >> 2] >> 2];
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                } else if ((m | 0) == 13) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function dH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                b = (c[f >> 2] | 0) + 16 | 0;
	                if (!(c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                    c[b >> 2] = 10;
	                    a = Cb[c[135744 >> 2] & 511](40) | 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = a;
	                    if (!(c[(c[f >> 2] | 0) + 8 >> 2] | 0)) {
	                        IB(0, 142256, 0);
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                } else if ((c[b >> 2] | 0) <= (c[(c[f >> 2] | 0) + 12 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 16 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[(c[f >> 2] | 0) + 16 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 8 >> 2] = b, (c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 0) : 0) {
	                    IB(0, 142712, 0);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                b = c[g >> 2] | 0;
	                g = (c[f >> 2] | 0) + 12 | 0;
	                a = c[g >> 2] | 0;
	                c[g >> 2] = a + 1;
	                c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + (a << 2) >> 2] = b;
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function eH(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 16 | 0;
	                o = j + 12 | 0;
	                p = j + 8 | 0;
	                q = j + 4 | 0;
	                r = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[j + 20 >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = h;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[q >> 2] = my(142688) | 0;
	                c[q >> 2] = By(c[q >> 2] | 0, c[n >> 2] | 0) | 0;
	                c[q >> 2] = By(c[q >> 2] | 0, 142704) | 0;
	                n = c[k >> 2] | 0;
	                h = c[l >> 2] | 0;
	                l = c[(c[m >> 2] | 0) + 8 >> 2] | 0;
	                g = c[q >> 2] | 0;
	                f = BB(r, c[(c[c[(c[k >> 2] | 0) + 180 >> 2] >> 2] | 0) + ((c[(c[m >> 2] | 0) + 12 >> 2] | 0) + 1 << 2) >> 2] | 0, c[(c[c[(c[k >> 2] | 0) + 180 >> 2] >> 2] | 0) + (c[(c[m >> 2] | 0) + 12 >> 2] << 2) >> 2] | 0) | 0;
	                $D(n, 2, h, 0, l, g, f, c[o >> 2] | 0, c[p >> 2] | 0, 0);
	                if (c[r >> 2] | 0) {
	                    zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    c[r >> 2] = 0
	                }
	                if (!(c[q >> 2] | 0)) {
	                    i = j;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                c[q >> 2] = 0;
	                i = j;
	                return
	            }

	            function fH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    IB(0, 142304, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = c[f >> 2] | 0;
	                    c[a + 0 >> 2] = 0;
	                    c[a + 4 >> 2] = 0;
	                    c[a + 8 >> 2] = 0;
	                    c[a + 12 >> 2] = 0;
	                    c[a + 16 >> 2] = 0;
	                    c[a + 20 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function gH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[n >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                d = (KH(c[g >> 2] | 0) | 0) != 0;
	                c[k >> 2] = d ? 1 : 0;
	                c[c[j >> 2] >> 2] = 0;
	                while (1) {
	                    c[m >> 2] = 0;
	                    c[l >> 2] = dI(c[g >> 2] | 0) | 0;
	                    d = c[l >> 2] | 0;
	                    if ((d | 0) == 46 | (d | 0) == 2 | (d | 0) == 1) {
	                        c[m >> 2] = LH(c[g >> 2] | 0) | 0;
	                        if (c[m >> 2] | 0) {
	                            if ((c[h >> 2] | 0) != 3) {
	                                if ((c[h >> 2] | 0) == 2)c[n >> 2] = RH(c[m >> 2] | 0) | 0
	                            } else c[n >> 2] = SH(c[m >> 2] | 0) | 0;
	                            if (c[n >> 2] | 0)c[m >> 2] = c[n >> 2]
	                        }
	                    } else {
	                        d = (cI(c[g >> 2] | 0, n) | 0) == -1;
	                        p = c[n >> 2] | 0;
	                        if (d)break;
	                        c[m >> 2] = p
	                    }
	                    d = c[m >> 2] | 0;
	                    do if (!(c[c[j >> 2] >> 2] | 0)) {
	                        if (d) {
	                            b = my(c[m >> 2] | 0) | 0;
	                            c[c[j >> 2] >> 2] = b;
	                            break
	                        }
	                        if (!(c[k >> 2] | 0)) {
	                            b = my(142672) | 0;
	                            c[c[j >> 2] >> 2] = b
	                        }
	                    } else if (d) {
	                        b = By(c[c[j >> 2] >> 2] | 0, 142680) | 0;
	                        c[c[j >> 2] >> 2] = b;
	                        b = By(c[c[j >> 2] >> 2] | 0, c[m >> 2] | 0) | 0;
	                        c[c[j >> 2] >> 2] = b
	                    } while (0);
	                    if (c[n >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[n >> 2] = 0
	                    }
	                    c[g >> 2] = KH(c[g >> 2] | 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        q = 26;
	                        break
	                    }
	                }
	                if ((q | 0) == 26) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (p)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                if (c[c[j >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[j >> 2] >> 2] | 0);
	                if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                c[f >> 2] = -1;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function hH(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = _i(c[d >> 2] | 0) | 0;
	                i = b;
	                return a | 0
	            }

	            function iH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                d = c[g >> 2] | 0;
	                if (c[h >> 2] | 0) {
	                    c[f >> 2] = BB(d, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = BB(d, 0, c[j >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function jH(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 32 | 0;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                p = g + 4 | 0;
	                q = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    c[h >> 2] = -1;
	                    r = c[h >> 2] | 0;
	                    i = g;
	                    return r | 0
	                }
	                c[c[m >> 2] >> 2] = 0;
	                c[o >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    k = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[k + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 155456) | 0) == 0 : 0)GF(c[j >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[k + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[j >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[j >> 2] | 0, c[l >> 2] | 0, 161384) | 0;
	                c[o >> 2] = dE(c[l >> 2] | 0, 155456) | 0;
	                do if (c[o >> 2] | 0) {
	                    c[p >> 2] = 0;
	                    c[q >> 2] = 0;
	                    k = c[j >> 2] | 0;
	                    f = c[o >> 2] | 0;
	                    e = IH(29) | 0;
	                    if (!(eE(k, 0, f, e, c[m >> 2] | 0) | 0)) {
	                        c[p >> 2] = Xi(c[(c[l >> 2] | 0) + 32 >> 2] | 0, c[l >> 2] | 0) | 0;
	                        e = c[c[m >> 2] >> 2] | 0;
	                        if (!(c[p >> 2] | 0))c[q >> 2] = Hl(e, c[(c[(c[l >> 2] | 0) + 32 >> 2] | 0) + 72 >> 2] | 0) | 0; else {
	                            c[q >> 2] = Hl(e, c[p >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                        }
	                        e = c[j >> 2] | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            xB(e, 168224, 168256);
	                            c[h >> 2] = -1;
	                            r = c[h >> 2] | 0;
	                            i = g;
	                            return r | 0
	                        }
	                        f = AP(c[e + 80 >> 2] | 0, c[q >> 2] | 0, -1) | 0;
	                        c[c[m >> 2] >> 2] = f;
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        if (!(qy(c[c[m >> 2] >> 2] | 0, c[(c[j >> 2] | 0) + 44 >> 2] | 0) | 0)) {
	                            c[h >> 2] = 0;
	                            r = c[h >> 2] | 0;
	                            i = g;
	                            return r | 0
	                        }
	                        f = c[j >> 2] | 0;
	                        e = c[l >> 2] | 0;
	                        k = c[c[m >> 2] >> 2] | 0;
	                        if ((c[n >> 2] | 0) == 3) {
	                            GE(f, 3081, 0, e, 168304, k);
	                            break
	                        } else {
	                            GE(f, 3050, 0, e, 168360, k);
	                            break
	                        }
	                    }
	                } else MF(c[j >> 2] | 0, 3036, 0, c[l >> 2] | 0, 155456, 0); while (0);
	                c[h >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                r = c[h >> 2] | 0;
	                i = g;
	                return r | 0
	            }

	            function kH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
	                d = i;
	                i = i + 96 | 0;
	                e = d + 88 | 0;
	                f = d + 84 | 0;
	                g = d + 80 | 0;
	                h = d + 76 | 0;
	                j = d + 72 | 0;
	                k = d + 68 | 0;
	                l = d + 64 | 0;
	                m = d + 60 | 0;
	                n = d + 56 | 0;
	                o = d + 52 | 0;
	                p = d + 48 | 0;
	                q = d + 44 | 0;
	                r = d + 40 | 0;
	                s = d + 36 | 0;
	                t = d + 32 | 0;
	                u = d + 28 | 0;
	                v = d + 24 | 0;
	                w = d + 20 | 0;
	                x = d + 16 | 0;
	                y = d + 12 | 0;
	                z = d + 8 | 0;
	                A = d + 4 | 0;
	                B = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    C = c[e >> 2] | 0;
	                    i = d;
	                    return C | 0
	                }
	                do switch (c[c[f >> 2] >> 2] | 0) {
	                    case 16:
	                    {
	                        c[q >> 2] = c[f >> 2];
	                        c[r >> 2] = c[(c[q >> 2] | 0) + 24 >> 2];
	                        if (!(c[(c[q >> 2] | 0) + 24 >> 2] | 0)) {
	                            c[(c[q >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[r >> 2] = c[(c[q >> 2] | 0) + 24 >> 2];
	                        if (c[c[r >> 2] >> 2] | 0)c[r >> 2] = c[c[r >> 2] >> 2];
	                        c[c[r >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 2:
	                    case 21:
	                    {
	                        c[m >> 2] = c[f >> 2];
	                        c[n >> 2] = c[(c[m >> 2] | 0) + 8 >> 2];
	                        if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0)) {
	                            c[(c[m >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[n >> 2] = c[(c[m >> 2] | 0) + 8 >> 2];
	                        if (c[c[n >> 2] >> 2] | 0)c[n >> 2] = c[c[n >> 2] >> 2];
	                        c[c[n >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 18:
	                    {
	                        c[s >> 2] = c[f >> 2];
	                        c[t >> 2] = c[(c[s >> 2] | 0) + 8 >> 2];
	                        if (!(c[(c[s >> 2] | 0) + 8 >> 2] | 0)) {
	                            c[(c[s >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[t >> 2] = c[(c[s >> 2] | 0) + 8 >> 2];
	                        if (c[c[t >> 2] >> 2] | 0)c[t >> 2] = c[c[t >> 2] >> 2];
	                        c[c[t >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 5:
	                    case 4:
	                    {
	                        c[w >> 2] = c[f >> 2];
	                        c[x >> 2] = c[(c[w >> 2] | 0) + 24 >> 2];
	                        if (!(c[(c[w >> 2] | 0) + 24 >> 2] | 0)) {
	                            c[(c[w >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[x >> 2] = c[(c[w >> 2] | 0) + 24 >> 2];
	                        if (c[c[x >> 2] >> 2] | 0)c[x >> 2] = c[c[x >> 2] >> 2];
	                        c[c[x >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 1011:
	                    case 1010:
	                    case 1009:
	                    case 1008:
	                    case 1007:
	                    case 1006:
	                    case 1005:
	                    case 1004:
	                    case 1003:
	                    case 1002:
	                    case 1001:
	                    case 1e3:
	                    {
	                        c[u >> 2] = c[f >> 2];
	                        c[v >> 2] = c[(c[u >> 2] | 0) + 16 >> 2];
	                        if (!(c[(c[u >> 2] | 0) + 16 >> 2] | 0)) {
	                            c[(c[u >> 2] | 0) + 16 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[v >> 2] = c[(c[u >> 2] | 0) + 16 >> 2];
	                        if (c[c[v >> 2] >> 2] | 0)c[v >> 2] = c[c[v >> 2] >> 2];
	                        c[c[v >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 17:
	                    {
	                        c[y >> 2] = c[f >> 2];
	                        c[z >> 2] = c[(c[y >> 2] | 0) + 4 >> 2];
	                        if (!(c[(c[y >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[(c[y >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[z >> 2] = c[(c[y >> 2] | 0) + 4 >> 2];
	                        if (c[c[z >> 2] >> 2] | 0)c[z >> 2] = c[c[z >> 2] >> 2];
	                        c[c[z >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 15:
	                    {
	                        c[k >> 2] = c[f >> 2];
	                        c[l >> 2] = c[(c[k >> 2] | 0) + 32 >> 2];
	                        if (!(c[(c[k >> 2] | 0) + 32 >> 2] | 0)) {
	                            c[(c[k >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[l >> 2] = c[(c[k >> 2] | 0) + 32 >> 2];
	                        if (c[c[l >> 2] >> 2] | 0)c[l >> 2] = c[c[l >> 2] >> 2];
	                        c[c[l >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 22:
	                    case 24:
	                    case 23:
	                    case 25:
	                    {
	                        c[o >> 2] = c[f >> 2];
	                        c[p >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                        if (!(c[(c[o >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[(c[o >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[p >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                        if (c[c[p >> 2] >> 2] | 0)c[p >> 2] = c[c[p >> 2] >> 2];
	                        c[c[p >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 8:
	                    case 7:
	                    case 6:
	                    {
	                        c[A >> 2] = c[f >> 2];
	                        c[B >> 2] = c[(c[A >> 2] | 0) + 4 >> 2];
	                        if (!(c[(c[A >> 2] | 0) + 4 >> 2] | 0)) {
	                            c[(c[A >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[B >> 2] = c[(c[A >> 2] | 0) + 4 >> 2];
	                        if (c[c[B >> 2] >> 2] | 0)c[B >> 2] = c[c[B >> 2] >> 2];
	                        c[c[B >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    case 14:
	                    {
	                        c[h >> 2] = c[f >> 2];
	                        c[j >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                        if (!(c[(c[h >> 2] | 0) + 24 >> 2] | 0)) {
	                            c[(c[h >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                            c[e >> 2] = c[g >> 2];
	                            C = c[e >> 2] | 0;
	                            i = d;
	                            return C | 0
	                        }
	                        c[j >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                        if (c[c[j >> 2] >> 2] | 0)c[j >> 2] = c[c[j >> 2] >> 2];
	                        c[c[j >> 2] >> 2] = c[g >> 2];
	                        break
	                    }
	                    default:
	                        GE(0, 3069, 0, 0, 165080, 0)
	                } while (0);
	                c[e >> 2] = c[g >> 2];
	                C = c[e >> 2] | 0;
	                i = d;
	                return C | 0
	            }

	            function lH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[m >> 2] = c[(c[h >> 2] | 0) + 84 >> 2];
	                e = (c[m >> 2] | 0) + 48 | 0;
	                c[e >> 2] = c[e >> 2] | 2;
	                c[o >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    e = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 151424) | 0) == 0 : 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                if ((fG(c[h >> 2] | 0, c[j >> 2] | 0, 0, c[k >> 2] | 0, 151424, (c[m >> 2] | 0) + 60 | 0, (c[m >> 2] | 0) + 56 | 0) | 0) == 0 ? (c[(c[m >> 2] | 0) + 56 >> 2] | 0) == 0 : 0)MF(c[h >> 2] | 0, 3036, 0, c[k >> 2] | 0, 151424, 0);
	                c[n >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    o = c[m >> 2] | 0;
	                    kH(o, jE(c[h >> 2] | 0, c[n >> 2] | 0, 1) | 0) | 0;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                do if ((c[l >> 2] | 0) == 10) {
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161648) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        o = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 8, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = o;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161656) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        o = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 7, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = o;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161664) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        o = QF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 6, 1) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = o;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 161080) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        o = RF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 28 >> 2] = o;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if (c[n >> 2] | 0) {
	                    if ((SF(c[h >> 2] | 0, c[j >> 2] | 0, n, (c[m >> 2] | 0) + 116 | 0, 13, 0) | 0) == -1) {
	                        c[g >> 2] = 0;
	                        p = c[g >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 163328) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        m = TF(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                        c[(c[(c[h >> 2] | 0) + 84 >> 2] | 0) + 84 >> 2] = m;
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                }
	                do if (c[n >> 2] | 0) {
	                    m = c[h >> 2] | 0;
	                    j = c[k >> 2] | 0;
	                    o = c[n >> 2] | 0;
	                    if ((c[l >> 2] | 0) == 10) {
	                        uE(m, 3033, 0, j, o, 0, 167440);
	                        break
	                    } else {
	                        uE(m, 3033, 0, j, o, 0, 163344);
	                        break
	                    }
	                } while (0);
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function mH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[q >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[p >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[p >> 2] | 0))break;
	                    d = c[p >> 2] | 0;
	                    if (!(c[(c[p >> 2] | 0) + 36 >> 2] | 0)) {
	                        if (((((qy(c[d + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 161824) | 0) == 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 161808) | 0) == 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 162304) | 0) == 0 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 162320) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[p >> 2] | 0)
	                    } else if (qy(c[(c[d + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[p >> 2] | 0);
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[o >> 2] = YF(c[g >> 2] | 0, c[j >> 2] | 0, 0, 1073741824, 1, 161768) | 0;
	                c[n >> 2] = XF(c[g >> 2] | 0, c[j >> 2] | 0, 0, -1, 1, 161744) | 0;
	                ZF(c[g >> 2] | 0, 0, c[j >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[m >> 2] = qG(c[g >> 2] | 0, c[h >> 2] | 0, 2, c[j >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                pH(c[g >> 2] | 0, c[h >> 2] | 0, c[m >> 2] | 0, c[j >> 2] | 0) | 0;
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    c[q >> 2] = jE(c[g >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if (c[l >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[l >> 2] | 0, 0, 161392);
	                if ((c[n >> 2] | 0) == 0 & (c[o >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[k >> 2] = XE(c[g >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else {
	                    c[(c[k >> 2] | 0) + 4 >> 2] = c[q >> 2];
	                    c[(c[k >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                    c[f >> 2] = c[k >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                return 0
	            }

	            function nH(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
	                g = i;
	                i = i + 112 | 0;
	                h = g + 96 | 0;
	                j = g + 92 | 0;
	                k = g + 88 | 0;
	                l = g + 84 | 0;
	                m = g + 80 | 0;
	                n = g + 76 | 0;
	                o = g + 72 | 0;
	                p = g + 68 | 0;
	                q = g + 64 | 0;
	                r = g + 60 | 0;
	                s = g + 56 | 0;
	                t = g + 52 | 0;
	                u = g + 48 | 0;
	                v = g + 44 | 0;
	                w = g + 40 | 0;
	                x = g + 36 | 0;
	                y = g + 32 | 0;
	                z = g + 28 | 0;
	                A = g + 24 | 0;
	                B = g + 20 | 0;
	                C = g + 16 | 0;
	                D = g + 12 | 0;
	                E = g + 8 | 0;
	                F = g + 4 | 0;
	                G = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                c[y >> 2] = 2;
	                c[A >> 2] = 0;
	                c[B >> 2] = 0;
	                if ((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                c[t >> 2] = dE(c[l >> 2] | 0, 160064) | 0;
	                do if (c[t >> 2] | 0) {
	                    if (_F(c[j >> 2] | 0, c[k >> 2] | 0, 0, c[t >> 2] | 0, u, v) | 0) {
	                        c[h >> 2] = 0;
	                        H = c[h >> 2] | 0;
	                        i = g;
	                        return H | 0
	                    }
	                    if (!($F(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0) | 0)) {
	                        c[x >> 2] = 1;
	                        break
	                    }
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                } while (0);
	                c[z >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                c[t >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[t >> 2] | 0))break;
	                    a:do if (!(c[(c[t >> 2] | 0) + 36 >> 2] | 0)) {
	                        f = c[(c[t >> 2] | 0) + 8 >> 2] | 0;
	                        do if (c[x >> 2] | 0)if (!(qy(f, 161384) | 0))if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 160064) | 0)break a; else break; else {
	                            CF(c[j >> 2] | 0, c[t >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            if (qy(f, 161352) | 0)break a;
	                            if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) {
	                                CF(c[j >> 2] | 0, c[t >> 2] | 0) | 0;
	                                break a
	                            }
	                            if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 155448) | 0) {
	                                _F(c[j >> 2] | 0, c[k >> 2] | 0, 0, c[t >> 2] | 0, u, v) | 0;
	                                break a
	                            }
	                            if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 163528) | 0) {
	                                c[A >> 2] = 1;
	                                c[o >> 2] = fE(c[j >> 2] | 0, c[t >> 2] | 0) | 0;
	                                if (qy(c[o >> 2] | 0, 163536) | 0) {
	                                    c[q >> 2] = c[(c[j >> 2] | 0) + 112 >> 2];
	                                    break a
	                                }
	                                if (qy(c[o >> 2] | 0, 163552) | 0)break a;
	                                hE(c[j >> 2] | 0, 3037, 0, c[t >> 2] | 0, 0, 163568, c[o >> 2] | 0, 0, 0, 0);
	                                break a
	                            }
	                        } while (0);
	                        if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 163600) | 0) {
	                            c[o >> 2] = fE(c[j >> 2] | 0, c[t >> 2] | 0) | 0;
	                            if (qy(c[o >> 2] | 0, 163608) | 0) {
	                                c[y >> 2] = 2;
	                                break
	                            }
	                            if (qy(c[o >> 2] | 0, 163624) | 0) {
	                                c[y >> 2] = 0;
	                                break
	                            }
	                            if (qy(c[o >> 2] | 0, 163640) | 0) {
	                                c[y >> 2] = 1;
	                                break
	                            } else {
	                                hE(c[j >> 2] | 0, 1774, 0, c[t >> 2] | 0, 0, 163656, c[o >> 2] | 0, 0, 0, 0);
	                                break
	                            }
	                        }
	                        if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 159128) | 0) {
	                            f = c[j >> 2] | 0;
	                            e = c[t >> 2] | 0;
	                            if (c[w >> 2] | 0) {
	                                aG(f, 3051, 0, e, 159128, 159120);
	                                break
	                            } else {
	                                c[w >> 2] = fE(f, e) | 0;
	                                c[B >> 2] = 1;
	                                break
	                            }
	                        }
	                        if (qy(c[(c[t >> 2] | 0) + 8 >> 2] | 0, 159120) | 0) {
	                            e = c[j >> 2] | 0;
	                            f = c[t >> 2] | 0;
	                            if (c[w >> 2] | 0) {
	                                aG(e, 3051, 0, f, 159128, 159120);
	                                break
	                            } else {
	                                c[w >> 2] = fE(e, f) | 0;
	                                c[B >> 2] = 2;
	                                break
	                            }
	                        } else I = 43
	                    } else if (qy(c[(c[(c[t >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)I = 43; while (0);
	                    if ((I | 0) == 43) {
	                        I = 0;
	                        GF(c[j >> 2] | 0, 3035, 0, c[t >> 2] | 0)
	                    }
	                    c[t >> 2] = c[(c[t >> 2] | 0) + 24 >> 2]
	                }
	                if ((c[B >> 2] | 0) == 1 & (c[y >> 2] | 0) != 2)hE(c[j >> 2] | 0, 3052, 0, c[l >> 2] | 0, 0, 163656, 0, 163696, 0, 0);
	                if ((c[z >> 2] | 0) != (c[(c[j >> 2] | 0) + 20 >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                if (c[x >> 2] | 0) {
	                    if (c[y >> 2] | 0) {
	                        c[r >> 2] = BH(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            c[h >> 2] = 0;
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        }
	                        dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[r >> 2] | 0) | 0;
	                        c[(c[r >> 2] | 0) + 24 >> 2] = c[y >> 2];
	                        c[D >> 2] = cG(c[j >> 2] | 0, 15, c[v >> 2] | 0, c[u >> 2] | 0) | 0;
	                        if (!(c[D >> 2] | 0)) {
	                            c[h >> 2] = 0;
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        }
	                        c[(c[r >> 2] | 0) + 12 >> 2] = c[D >> 2];
	                        if (c[w >> 2] | 0)c[(c[r >> 2] | 0) + 28 >> 2] = c[w >> 2];
	                        if ((c[B >> 2] | 0) == 2) {
	                            D = (c[r >> 2] | 0) + 16 | 0;
	                            c[D >> 2] = c[D >> 2] | 1
	                        }
	                    }
	                } else {
	                    if ((c[A >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 24 >> 2] & 2 | 0) != 0 : 0)c[q >> 2] = c[(c[j >> 2] | 0) + 112 >> 2];
	                    if (qy(c[q >> 2] | 0, c[38860] | 0) | 0)AB(c[j >> 2] | 0, 3057, c[l >> 2] | 0, 0, 163792, c[38860] | 0, 0);
	                    c[t >> 2] = dE(c[l >> 2] | 0, 161352) | 0;
	                    A = c[j >> 2] | 0;
	                    if (!(c[t >> 2] | 0)) {
	                        MF(A, 3036, 0, c[l >> 2] | 0, 161352, 0);
	                        c[h >> 2] = 0;
	                        H = c[h >> 2] | 0;
	                        i = g;
	                        return H | 0
	                    }
	                    D = c[t >> 2] | 0;
	                    if (eE(A, 0, D, IH(22) | 0, p) | 0) {
	                        c[h >> 2] = 0;
	                        H = c[h >> 2] | 0;
	                        i = g;
	                        return H | 0
	                    }
	                    if (qy(c[p >> 2] | 0, 163840) | 0) {
	                        D = c[j >> 2] | 0;
	                        A = c[t >> 2] | 0;
	                        hE(D, 3056, 0, A, IH(22) | 0, 0, 0, 163848, 0, 0);
	                        c[h >> 2] = 0;
	                        H = c[h >> 2] | 0;
	                        i = g;
	                        return H | 0
	                    }
	                    if (c[y >> 2] | 0) {
	                        c[r >> 2] = BH(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            c[h >> 2] = 0;
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        }
	                        c[(c[r >> 2] | 0) + 24 >> 2] = c[y >> 2];
	                        c[C >> 2] = iG(c[j >> 2] | 0, c[k >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                        if (!(c[C >> 2] | 0)) {
	                            c[h >> 2] = 0;
	                            H = c[h >> 2] | 0;
	                            i = g;
	                            return H | 0
	                        }
	                        if (c[v >> 2] | 0) {
	                            c[(c[C >> 2] | 0) + 24 >> 2] = c[v >> 2];
	                            c[(c[C >> 2] | 0) + 28 >> 2] = c[u >> 2]
	                        }
	                        c[(c[r >> 2] | 0) + 12 >> 2] = c[C >> 2];
	                        if ((c[w >> 2] | 0) != 0 ? (c[(c[C >> 2] | 0) + 44 >> 2] = c[w >> 2], (c[B >> 2] | 0) == 2) : 0) {
	                            B = (c[C >> 2] | 0) + 60 | 0;
	                            c[B >> 2] = c[B >> 2] | 512
	                        }
	                    }
	                }
	                c[s >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                B = (c[s >> 2] | 0) != 0;
	                if (c[y >> 2] | 0) {
	                    if (((B ? (c[(c[s >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        y = jE(c[j >> 2] | 0, c[s >> 2] | 0, 1) | 0;
	                        c[(c[r >> 2] | 0) + 4 >> 2] = y;
	                        c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                    }
	                    y = (c[s >> 2] | 0) != 0;
	                    do if (c[x >> 2] | 0) {
	                        if (y) {
	                            if ((((c[s >> 2] | 0) != 0 ? (c[(c[s >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                                uE(c[j >> 2] | 0, 3054, 0, c[l >> 2] | 0, c[s >> 2] | 0, 0, 161392);
	                                break
	                            }
	                            uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[s >> 2] | 0, 0, 161392)
	                        }
	                    } else {
	                        if (((y ? (c[(c[s >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 161024) | 0) != 0 : 0) ? (qy(c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                            C = c[j >> 2] | 0;
	                            if (c[(c[(c[r >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0)uE(C, 3055, 0, c[l >> 2] | 0, c[s >> 2] | 0, 164128, 0); else {
	                                w = oE(C, c[k >> 2] | 0, c[s >> 2] | 0, 0) | 0;
	                                c[(c[(c[r >> 2] | 0) + 12 >> 2] | 0) + 48 >> 2] = w
	                            }
	                            c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                        }
	                        if (c[s >> 2] | 0)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[s >> 2] | 0, 0, 164200)
	                    } while (0);
	                    c[h >> 2] = c[r >> 2];
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                if (((B ? (c[(c[s >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[s >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    jE(c[j >> 2] | 0, c[s >> 2] | 0, 0) | 0;
	                    c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                }
	                if (c[s >> 2] | 0)uE(c[j >> 2] | 0, 3033, 0, c[l >> 2] | 0, c[s >> 2] | 0, 0, 161392);
	                if ((c[n >> 2] | 0) == 16) {
	                    NC(c[j >> 2] | 0, 3086, c[l >> 2] | 0, 0, 163904, 0, 0, 0);
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                if ((c[n >> 2] | 0) == 13) {
	                    NC(c[j >> 2] | 0, 3086, c[l >> 2] | 0, 0, 163992, 0, 0, 0);
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                if (!(c[x >> 2] | 0)) {
	                    c[v >> 2] = c[p >> 2];
	                    c[u >> 2] = c[q >> 2]
	                }
	                b:do if (c[m >> 2] | 0) {
	                    c[F >> 2] = 0;
	                    while (1) {
	                        if ((c[F >> 2] | 0) >= (c[(c[m >> 2] | 0) + 4 >> 2] | 0))break b;
	                        c[r >> 2] = c[(c[c[m >> 2] >> 2] | 0) + (c[F >> 2] << 2) >> 2];
	                        if (((c[c[r >> 2] >> 2] | 0) == 2001 ? (c[v >> 2] | 0) == (c[(c[r >> 2] | 0) + 8 >> 2] | 0) : 0) ? (c[u >> 2] | 0) == (c[(c[r >> 2] | 0) + 12 >> 2] | 0) : 0)break;
	                        c[F >> 2] = (c[F >> 2] | 0) + 1
	                    }
	                    c[G >> 2] = 0;
	                    q = c[j >> 2] | 0;
	                    p = c[l >> 2] | 0;
	                    NC(q, 3086, p, 0, 164072, BB(G, c[u >> 2] | 0, c[v >> 2] | 0) | 0, 0, 0);
	                    if (c[G >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[G >> 2] | 0);
	                        c[G >> 2] = 0
	                    }
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                } while (0);
	                c[E >> 2] = CH(c[j >> 2] | 0) | 0;
	                if (!(c[E >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    H = c[h >> 2] | 0;
	                    i = g;
	                    return H | 0
	                }
	                c[(c[E >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                c[(c[E >> 2] | 0) + 8 >> 2] = c[v >> 2];
	                c[(c[E >> 2] | 0) + 12 >> 2] = c[u >> 2];
	                if (c[x >> 2] | 0)dG((c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[E >> 2] | 0) | 0;
	                c[h >> 2] = c[E >> 2];
	                H = c[h >> 2] | 0;
	                i = g;
	                return H | 0
	            }

	            function oH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[m >> 2] = dE(c[j >> 2] | 0, 160064) | 0;
	                d = c[g >> 2] | 0;
	                if (!(c[m >> 2] | 0)) {
	                    MF(d, 3036, 0, c[j >> 2] | 0, 160064, 0);
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                _F(d, c[h >> 2] | 0, 0, c[m >> 2] | 0, n, o) | 0;
	                if ($F(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0) {
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                c[m >> 2] = c[(c[j >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    h = c[m >> 2] | 0;
	                    if (!(c[(c[m >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[h + 8 >> 2] | 0, 160064) | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 161384) | 0) == 0 : 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0)
	                    } else if (qy(c[(c[h + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[g >> 2] | 0, 3035, 0, c[m >> 2] | 0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    jE(c[g >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if (c[l >> 2] | 0)uE(c[g >> 2] | 0, 3033, 0, c[j >> 2] | 0, c[l >> 2] | 0, 0, 161392);
	                do if (((((c[(c[g >> 2] | 0) + 100 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 120 >> 2] | 0) != 0 : 0) ? (c[c[(c[(c[g >> 2] | 0) + 120 >> 2] | 0) + 4 >> 2] >> 2] | 0) == 16 : 0) ? (c[o >> 2] | 0) == (c[(c[(c[g >> 2] | 0) + 120 >> 2] | 0) + 16 >> 2] | 0) : 0) ? (c[n >> 2] | 0) == (c[(c[(c[g >> 2] | 0) + 120 >> 2] | 0) + 20 >> 2] | 0) : 0)if (c[(c[g >> 2] | 0) + 124 >> 2] | 0) {
	                    c[p >> 2] = 0;
	                    l = c[g >> 2] | 0;
	                    m = c[j >> 2] | 0;
	                    AB(l, 3081, m, 0, 163408, BB(p, c[n >> 2] | 0, c[o >> 2] | 0) | 0, 0);
	                    if (c[p >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        c[p >> 2] = 0
	                    }
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                } else {
	                    m = (c[g >> 2] | 0) + 124 | 0;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[k >> 2] = cG(c[g >> 2] | 0, 16, c[o >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[(c[k >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                        c[(c[(c[g >> 2] | 0) + 120 >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                        break
	                    }
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                } else r = 35; while (0);
	                do if ((r | 0) == 35) {
	                    c[k >> 2] = cG(c[g >> 2] | 0, 16, c[o >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[(c[k >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                        dG((c[(c[g >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    c[f >> 2] = 0;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                } while (0);
	                c[f >> 2] = c[k >> 2];
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function pH(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 56 | 0;
	                j = g + 52 | 0;
	                k = g + 44 | 0;
	                l = g + 40 | 0;
	                m = g + 36 | 0;
	                n = g + 32 | 0;
	                o = g + 28 | 0;
	                p = g + 24 | 0;
	                q = g + 20 | 0;
	                r = g + 16 | 0;
	                s = g + 12 | 0;
	                t = g + 8 | 0;
	                u = g + 4 | 0;
	                v = g;
	                c[j >> 2] = a;
	                c[g + 48 >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[p >> 2] = 0;
	                c[s >> 2] = 0;
	                c[m >> 2] = RC(c[j >> 2] | 0, c[l >> 2] | 0, 162320) | 0;
	                do if ((c[m >> 2] | 0) != 0 ? (qy(c[m >> 2] | 0, 148184) | 0) == 0 : 0) {
	                    if (qy(c[m >> 2] | 0, 148168) | 0) {
	                        c[(c[k >> 2] | 0) + 24 >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[m >> 2] | 0, 148176) | 0) {
	                        c[(c[k >> 2] | 0) + 24 >> 2] = 2;
	                        break
	                    } else {
	                        hE(c[j >> 2] | 0, 3037, 0, c[l >> 2] | 0, 0, 162336, c[m >> 2] | 0, 0, 0, 0);
	                        c[(c[k >> 2] | 0) + 24 >> 2] = 3;
	                        c[p >> 2] = 3037;
	                        break
	                    }
	                } else w = 3; while (0);
	                if ((w | 0) == 3)c[(c[k >> 2] | 0) + 24 >> 2] = 3;
	                c[t >> 2] = dE(c[l >> 2] | 0, 162304) | 0;
	                c[n >> 2] = fE(c[j >> 2] | 0, c[t >> 2] | 0) | 0;
	                a:do if ((c[t >> 2] | 0) != 0 ? (qy(c[n >> 2] | 0, 162360) | 0) == 0 : 0) {
	                    if (qy(c[n >> 2] | 0, 144400) | 0) {
	                        l = uH(c[j >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 36 >> 2] = l;
	                        if (c[(c[k >> 2] | 0) + 36 >> 2] | 0) {
	                            c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = c[(c[j >> 2] | 0) + 112 >> 2];
	                            break
	                        }
	                        c[h >> 2] = -1;
	                        x = c[h >> 2] | 0;
	                        i = g;
	                        return x | 0
	                    }
	                    c[v >> 2] = c[n >> 2];
	                    while (1) {
	                        do if ((d[c[v >> 2] >> 0] | 0 | 0) == 32)y = 1; else {
	                            if (9 <= (d[c[v >> 2] >> 0] | 0 | 0) ? (d[c[v >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                y = 1;
	                                break
	                            }
	                            y = (d[c[v >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        l = c[v >> 2] | 0;
	                        if (y) {
	                            c[v >> 2] = l + 1;
	                            continue
	                        }
	                        c[u >> 2] = l;
	                        while (1) {
	                            if (d[c[u >> 2] >> 0] | 0) {
	                                do if ((d[c[u >> 2] >> 0] | 0 | 0) == 32)z = 1; else {
	                                    if (9 <= (d[c[u >> 2] >> 0] | 0 | 0) ? (d[c[u >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        z = 1;
	                                        break
	                                    }
	                                    z = (d[c[u >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                A = z ^ 1
	                            } else A = 0;
	                            B = c[u >> 2] | 0;
	                            if (!A)break;
	                            c[u >> 2] = B + 1
	                        }
	                        if ((B | 0) == (c[v >> 2] | 0))break a;
	                        c[q >> 2] = ly(c[v >> 2] | 0, (c[u >> 2] | 0) - (c[v >> 2] | 0) | 0) | 0;
	                        if ((qy(c[q >> 2] | 0, 144400) | 0) == 0 ? (qy(c[q >> 2] | 0, 162360) | 0) == 0 : 0) {
	                            do if (!(qy(c[q >> 2] | 0, 162448) | 0))if (qy(c[q >> 2] | 0, 162472) | 0) {
	                                c[o >> 2] = 0;
	                                break
	                            } else {
	                                l = c[j >> 2] | 0;
	                                m = c[t >> 2] | 0;
	                                f = c[q >> 2] | 0;
	                                DF(l, 0, m, f, IH(29) | 0) | 0;
	                                c[o >> 2] = AP(c[(c[j >> 2] | 0) + 80 >> 2] | 0, c[q >> 2] | 0, -1) | 0;
	                                break
	                            } else c[o >> 2] = c[(c[j >> 2] | 0) + 112 >> 2]; while (0);
	                            c[r >> 2] = c[(c[k >> 2] | 0) + 32 >> 2];
	                            while (1) {
	                                if (!(c[r >> 2] | 0))break;
	                                if ((c[o >> 2] | 0) == (c[(c[r >> 2] | 0) + 4 >> 2] | 0))break;
	                                c[r >> 2] = c[c[r >> 2] >> 2]
	                            }
	                            if (!(c[r >> 2] | 0)) {
	                                c[r >> 2] = uH(c[j >> 2] | 0) | 0;
	                                if (!(c[r >> 2] | 0))break;
	                                c[(c[r >> 2] | 0) + 4 >> 2] = c[o >> 2];
	                                c[c[r >> 2] >> 2] = 0;
	                                if (c[(c[k >> 2] | 0) + 32 >> 2] | 0) {
	                                    if (c[s >> 2] | 0)c[c[s >> 2] >> 2] = c[r >> 2]
	                                } else c[(c[k >> 2] | 0) + 32 >> 2] = c[r >> 2];
	                                c[s >> 2] = c[r >> 2]
	                            }
	                        } else {
	                            hE(c[j >> 2] | 0, 1792, 0, c[t >> 2] | 0, 0, 162368, c[q >> 2] | 0, 0, 0, 0);
	                            c[p >> 2] = 1792
	                        }
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        c[v >> 2] = c[u >> 2];
	                        if (!(d[c[v >> 2] >> 0] | 0))break a
	                    }
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                    c[h >> 2] = -1;
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                } else w = 11; while (0);
	                if ((w | 0) == 11)c[(c[k >> 2] | 0) + 28 >> 2] = 1;
	                c[h >> 2] = c[p >> 2];
	                x = c[h >> 2] | 0;
	                i = g;
	                return x | 0
	            }

	            function qH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[k >> 2] = SA() | 0;
	                if (!(c[k >> 2] | 0)) {
	                    tC(c[g >> 2] | 0, 166944, c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[(c[k >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                c[m >> 2] = RC(c[g >> 2] | 0, c[j >> 2] | 0, 166968) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    lG(c[g >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0, 1708, 166976, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                    UA(c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157848) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0)c[c[k >> 2] >> 2] = 1e3; else p = 12;
	                do if ((p | 0) == 12) {
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157832) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1001;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157816) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1002;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157800) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1003;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157936) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1004;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157952) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1005;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157792) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1006;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157880) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1007;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157864) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1008;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157896) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1009;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157904) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1010;
	                        break
	                    }
	                    if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 157920) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                        c[c[k >> 2] >> 2] = 1011;
	                        break
	                    }
	                    lG(c[g >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0, 1741, 167e3, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                    UA(c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } while (0);
	                cE(c[g >> 2] | 0, c[j >> 2] | 0, 161384) | 0;
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                if ((((c[c[k >> 2] >> 2] | 0) != 1006 ? (c[c[k >> 2] >> 2] | 0) != 1007 : 0) ? (c[n >> 2] = RC(c[g >> 2] | 0, c[j >> 2] | 0, 159120) | 0, (c[n >> 2] | 0) != 0) : 0) ? (qy(c[n >> 2] | 0, 165504) | 0) != 0 : 0)c[(c[k >> 2] | 0) + 24 >> 2] = 1;
	                c[l >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                if ((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    n = jE(c[g >> 2] | 0, c[l >> 2] | 0, 1) | 0;
	                    c[(c[k >> 2] | 0) + 16 >> 2] = n;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                if (c[l >> 2] | 0)lG(c[g >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0, 1740, 167024, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                c[f >> 2] = c[k >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function rH(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 44 | 0;
	                l = j + 40 | 0;
	                m = j + 36 | 0;
	                n = j + 32 | 0;
	                o = j + 28 | 0;
	                p = j + 24 | 0;
	                q = j + 20 | 0;
	                r = j + 16 | 0;
	                s = j + 12 | 0;
	                t = j + 8 | 0;
	                u = j + 4 | 0;
	                v = j;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[c[q >> 2] >> 2] = 0;
	                c[c[r >> 2] >> 2] = 0;
	                c[v >> 2] = Fh(c[p >> 2] | 0, 1) | 0;
	                if ((c[v >> 2] | 0) > 0) {
	                    h = c[l >> 2] | 0;
	                    g = c[n >> 2] | 0;
	                    f = c[o >> 2] | 0;
	                    e = IH(21) | 0;
	                    hE(h, 3037, g, f, e, 0, c[p >> 2] | 0, 0, 0, 0);
	                    c[c[r >> 2] >> 2] = c[p >> 2];
	                    c[k >> 2] = c[(c[l >> 2] | 0) + 16 >> 2];
	                    w = c[k >> 2] | 0;
	                    i = j;
	                    return w | 0
	                }
	                if ((c[v >> 2] | 0) < 0) {
	                    c[k >> 2] = -1;
	                    w = c[k >> 2] | 0;
	                    i = j;
	                    return w | 0
	                }
	                if (eT(c[p >> 2] | 0, 58) | 0) {
	                    v = Dh(c[p >> 2] | 0, u) | 0;
	                    c[c[r >> 2] >> 2] = v;
	                    v = AP(c[(c[l >> 2] | 0) + 80 >> 2] | 0, c[c[r >> 2] >> 2] | 0, -1) | 0;
	                    c[c[r >> 2] >> 2] = v;
	                    c[s >> 2] = AP(c[(c[l >> 2] | 0) + 80 >> 2] | 0, c[p >> 2] | 0, c[u >> 2] | 0) | 0;
	                    c[t >> 2] = cj(c[(c[o >> 2] | 0) + 32 >> 2] | 0, c[(c[o >> 2] | 0) + 20 >> 2] | 0, c[s >> 2] | 0) | 0;
	                    s = c[l >> 2] | 0;
	                    if (!(c[t >> 2] | 0)) {
	                        u = c[n >> 2] | 0;
	                        n = c[o >> 2] | 0;
	                        v = IH(21) | 0;
	                        hE(s, 3037, u, n, v, 0, c[p >> 2] | 0, 162952, c[p >> 2] | 0, 0);
	                        c[k >> 2] = c[(c[l >> 2] | 0) + 16 >> 2];
	                        w = c[k >> 2] | 0;
	                        i = j;
	                        return w | 0
	                    } else {
	                        v = AP(c[s + 80 >> 2] | 0, c[(c[t >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                        c[c[q >> 2] >> 2] = v;
	                        c[k >> 2] = 0;
	                        w = c[k >> 2] | 0;
	                        i = j;
	                        return w | 0
	                    }
	                }
	                c[t >> 2] = cj(c[(c[o >> 2] | 0) + 32 >> 2] | 0, c[(c[o >> 2] | 0) + 20 >> 2] | 0, 0) | 0;
	                if (!(c[t >> 2] | 0)) {
	                    if (c[(c[m >> 2] | 0) + 24 >> 2] & 512)c[c[q >> 2] >> 2] = c[(c[l >> 2] | 0) + 112 >> 2]
	                } else {
	                    m = AP(c[(c[l >> 2] | 0) + 80 >> 2] | 0, c[(c[t >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                    c[c[q >> 2] >> 2] = m
	                }
	                m = AP(c[(c[l >> 2] | 0) + 80 >> 2] | 0, c[p >> 2] | 0, -1) | 0;
	                c[c[r >> 2] >> 2] = m;
	                c[k >> 2] = 0;
	                w = c[k >> 2] | 0;
	                i = j;
	                return w | 0
	            }

	            function sH(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 4 | 0;
	                q = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    c[j >> 2] = 0;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                c[q >> 2] = Cb[c[135744 >> 2] & 511](40) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    tC(c[k >> 2] | 0, 165384, 0);
	                    c[j >> 2] = 0;
	                    r = c[j >> 2] | 0;
	                    i = h;
	                    return r | 0
	                }
	                l = (c[q >> 2] | 0) + 0 | 0;
	                g = l + 40 | 0;
	                do {
	                    c[l >> 2] = 0;
	                    l = l + 4 | 0
	                } while ((l | 0) < (g | 0));
	                c[(c[q >> 2] | 0) + 20 >> 2] = c[n >> 2];
	                c[(c[q >> 2] | 0) + 16 >> 2] = c[m >> 2];
	                c[c[q >> 2] >> 2] = c[o >> 2];
	                c[(c[q >> 2] | 0) + 12 >> 2] = c[p >> 2];
	                dG((c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 44 | 0, 5, c[q >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) == 24)dG((c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 20 | 0, 10, c[q >> 2] | 0) | 0;
	                c[j >> 2] = c[q >> 2];
	                r = c[j >> 2] | 0;
	                i = h;
	                return r | 0
	            }

	            function tH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[n >> 2] = 0;
	                c[o >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[o >> 2] | 0))break;
	                    e = c[o >> 2] | 0;
	                    if (!(c[(c[o >> 2] | 0) + 36 >> 2] | 0)) {
	                        if ((qy(c[e + 8 >> 2] | 0, 161384) | 0) == 0 ? (qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, 164904) | 0) == 0 : 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0)
	                    } else if (qy(c[(c[e + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0)GF(c[h >> 2] | 0, 3035, 0, c[o >> 2] | 0);
	                    c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    tC(c[h >> 2] | 0, 164912, 0);
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                e = c[m >> 2] | 0;
	                c[e + 0 >> 2] = 0;
	                c[e + 4 >> 2] = 0;
	                c[e + 8 >> 2] = 0;
	                c[e + 12 >> 2] = 0;
	                c[e + 16 >> 2] = 0;
	                c[o >> 2] = dE(c[k >> 2] | 0, 164904) | 0;
	                e = c[h >> 2] | 0;
	                if (c[o >> 2] | 0) {
	                    d = fE(e, c[o >> 2] | 0) | 0;
	                    c[(c[m >> 2] | 0) + 12 >> 2] = d;
	                    if ((DH(c[h >> 2] | 0, c[j >> 2] | 0, c[m >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0) | 0) == -1)PC(c[h >> 2] | 0, c[o >> 2] | 0, 3069, 164976, 0, 0)
	                } else MF(e, 3036, 0, c[k >> 2] | 0, 161352, 0);
	                cE(c[h >> 2] | 0, c[k >> 2] | 0, 161384) | 0;
	                c[n >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 160992) | 0) != 0 : 0) ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[38526] | 0) | 0) != 0 : 0) {
	                    e = c[j >> 2] | 0;
	                    kH(e, jE(c[h >> 2] | 0, c[n >> 2] | 0, 1) | 0) | 0;
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                if (c[n >> 2] | 0)uE(c[h >> 2] | 0, 3033, 0, c[k >> 2] | 0, c[n >> 2] | 0, 0, 161392);
	                c[g >> 2] = c[m >> 2];
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function uH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tC(c[e >> 2] | 0, 152760, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[c[f >> 2] >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function vH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                    if ((c[c[(c[e >> 2] | 0) + 12 >> 2] >> 2] | 0) != 7) {
	                        c[j >> 2] = 0;
	                        c[k >> 2] = c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                        if (!(c[k >> 2] | 0)) {
	                            c[d >> 2] = 0;
	                            l = c[d >> 2] | 0;
	                            i = b;
	                            return l | 0
	                        }
	                        do {
	                            if ((c[c[(c[k >> 2] | 0) + 12 >> 2] >> 2] | 0) != 14 ? (c[c[(c[k >> 2] | 0) + 12 >> 2] >> 2] | 0) != 2 : 0) {
	                                a = vH(c[k >> 2] | 0) | 0;
	                                c[j >> 2] = (c[j >> 2] | 0) + a
	                            } else c[j >> 2] = (c[j >> 2] | 0) + (c[(c[k >> 2] | 0) + 16 >> 2] | 0);
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 8 >> 2]
	                        } while ((c[k >> 2] | 0) != 0);
	                        c[d >> 2] = ca(c[(c[e >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        l = c[d >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    c[f >> 2] = -1;
	                    c[h >> 2] = c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                    if (!(c[h >> 2] | 0)) {
	                        c[d >> 2] = 0;
	                        l = c[d >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                    while (1) {
	                        if (!(c[h >> 2] | 0)) {
	                            m = 17;
	                            break
	                        }
	                        if ((c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) != 14 ? (c[c[(c[h >> 2] | 0) + 12 >> 2] >> 2] | 0) != 2 : 0)c[g >> 2] = vH(c[h >> 2] | 0) | 0; else c[g >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                        if (!(c[g >> 2] | 0)) {
	                            m = 13;
	                            break
	                        }
	                        if ((c[f >> 2] | 0) == -1 ? 1 : (c[f >> 2] | 0) > (c[g >> 2] | 0))c[f >> 2] = c[g >> 2];
	                        c[h >> 2] = c[(c[h >> 2] | 0) + 8 >> 2]
	                    }
	                    if ((m | 0) == 13) {
	                        c[d >> 2] = 0;
	                        l = c[d >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    } else if ((m | 0) == 17) {
	                        c[d >> 2] = ca(c[(c[e >> 2] | 0) + 16 >> 2] | 0, c[f >> 2] | 0) | 0;
	                        l = c[d >> 2] | 0;
	                        i = b;
	                        return l | 0
	                    }
	                }
	                c[d >> 2] = 0;
	                l = c[d >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function wH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = EH(c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (c[m >> 2] | 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                if (!((c[l >> 2] & 2 | 0) != 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] & 2 | 0) != 0 : 0))o = 4;
	                do if ((o | 0) == 4) {
	                    if ((c[l >> 2] & 1 | 0) != 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] & 4 | 0) != 0 : 0)break;
	                    if ((c[(c[j >> 2] | 0) + 64 >> 2] | 0) == (c[k >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if ((c[c[(c[j >> 2] | 0) + 64 >> 2] >> 2] | 0) == 1 ? (c[(c[(c[j >> 2] | 0) + 64 >> 2] | 0) + 88 >> 2] | 0) == 45 : 0) {
	                        c[g >> 2] = 1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if ((c[c[(c[j >> 2] | 0) + 64 >> 2] >> 2] | 0) != 5 ? (c[(c[(c[j >> 2] | 0) + 64 >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) {
	                        c[g >> 2] = xG(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    c[g >> 2] = wH(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } while (0);
	                c[g >> 2] = 1;
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function xH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = Tj(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function yH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] | 0) == 0 ? (b = Jj(10, c[(c[f >> 2] | 0) + 80 >> 2] | 0) | 0, c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = b, (c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] | 0) == 0) : 0) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](8) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    tC(0, 158408, 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = c[h >> 2] | 0;
	                c[b + 0 >> 2] = 0;
	                c[b + 4 >> 2] = 0;
	                c[c[h >> 2] >> 2] = c[g >> 2];
	                b = JB() | 0;
	                c[(c[h >> 2] | 0) + 4 >> 2] = b;
	                if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                    uC(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (Nj(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 52 >> 2] | 0, c[h >> 2] | 0) | 0) {
	                    xB(c[f >> 2] | 0, 158456, 158480);
	                    uC(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function zH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[c[k >> 2] >> 2] = 0;
	                c[c[l >> 2] >> 2] = 0;
	                c[m >> 2] = Fh(c[j >> 2] | 0, 1) | 0;
	                if ((c[m >> 2] | 0) == -1) {
	                    c[g >> 2] = -1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((c[m >> 2] | 0) > 0) {
	                    m = c[h >> 2] | 0;
	                    e = c[j >> 2] | 0;
	                    DC(m, 1824, 0, e, IH(21) | 0, 1);
	                    c[g >> 2] = 1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[n >> 2] = 0;
	                c[n >> 2] = Ch(c[j >> 2] | 0, o) | 0;
	                e = c[(c[h >> 2] | 0) + 156 >> 2] | 0;
	                if (!(c[n >> 2] | 0)) {
	                    m = AP(e, c[j >> 2] | 0, -1) | 0;
	                    c[c[l >> 2] >> 2] = m
	                } else {
	                    m = AP(e, c[n >> 2] | 0, -1) | 0;
	                    c[c[l >> 2] >> 2] = m;
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                }
	                n = RD(c[h >> 2] | 0, c[o >> 2] | 0) | 0;
	                c[c[k >> 2] >> 2] = n;
	                if ((c[o >> 2] | 0) != 0 ? (zb[c[135736 >> 2] & 511](c[o >> 2] | 0), (c[c[k >> 2] >> 2] | 0) == 0) : 0) {
	                    k = c[h >> 2] | 0;
	                    h = IH(21) | 0;
	                    AB(k, 1824, 0, h, 154112, c[j >> 2] | 0, 0);
	                    c[g >> 2] = 2;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[g >> 2] = 0;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function AH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (c[j >> 2] | 0) {
	                    d = c[g >> 2] | 0;
	                    b = c[j >> 2] | 0;
	                    if (c[(c[j >> 2] | 0) + 36 >> 2] | 0) {
	                        c[f >> 2] = BB(d, c[(c[b + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } else {
	                        c[f >> 2] = BB(d, 0, c[b + 8 >> 2] | 0) | 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                } else if (c[h >> 2] | 0) {
	                    c[f >> 2] = BB(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function BH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    tC(c[f >> 2] | 0, 164272, 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    b = (c[h >> 2] | 0) + 0 | 0;
	                    a = b + 36 | 0;
	                    do {
	                        c[b >> 2] = 0;
	                        b = b + 4 | 0
	                    } while ((b | 0) < (a | 0));
	                    c[c[h >> 2] >> 2] = 26;
	                    c[(c[h >> 2] | 0) + 20 >> 2] = c[g >> 2];
	                    dG((c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[h >> 2] | 0) | 0;
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function CH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    tC(c[e >> 2] | 0, 164232, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = c[f >> 2] | 0;
	                    c[a + 0 >> 2] = 0;
	                    c[a + 4 >> 2] = 0;
	                    c[a + 8 >> 2] = 0;
	                    c[a + 12 >> 2] = 0;
	                    c[a + 16 >> 2] = 0;
	                    c[c[f >> 2] >> 2] = 2001;
	                    dG((c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) + 48 | 0, 10, c[f >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function DH(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 40 | 0;
	                j = g + 36 | 0;
	                k = g + 32 | 0;
	                l = g + 28 | 0;
	                m = g + 24 | 0;
	                n = g + 20 | 0;
	                o = g + 16 | 0;
	                p = g + 12 | 0;
	                q = g + 8 | 0;
	                r = g + 4 | 0;
	                s = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (!(c[l >> 2] | 0)) {
	                    PC(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0, 3069, 165168, 0, 0);
	                    c[h >> 2] = -1;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                if (!(c[m >> 2] | 0))c[o >> 2] = c[(c[k >> 2] | 0) + 12 >> 2]; else c[o >> 2] = c[m >> 2];
	                if (!(c[(c[l >> 2] | 0) + 12 >> 2] | 0)) {
	                    GE(c[j >> 2] | 0, 3037, 0, c[o >> 2] | 0, 165248, 0);
	                    c[h >> 2] = 3037;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                if (!(c[m >> 2] | 0))c[q >> 2] = 0; else c[q >> 2] = bj(c[(c[m >> 2] | 0) + 32 >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0) | 0;
	                if (c[q >> 2] | 0) {
	                    c[s >> 2] = 0;
	                    c[r >> 2] = 0;
	                    while (1) {
	                        if (!(c[(c[q >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0))break;
	                        c[s >> 2] = (c[s >> 2] | 0) + 1;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                    c[p >> 2] = Cb[c[135744 >> 2] & 511]((c[s >> 2] << 1) + 1 << 2) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        tC(c[j >> 2] | 0, 165304, 0);
	                        zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        c[h >> 2] = -1;
	                        t = c[h >> 2] | 0;
	                        i = g;
	                        return t | 0
	                    }
	                    c[r >> 2] = 0;
	                    while (1) {
	                        if ((c[r >> 2] | 0) >= (c[s >> 2] | 0))break;
	                        c[(c[p >> 2] | 0) + (c[r >> 2] << 1 << 2) >> 2] = c[(c[(c[q >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) + 8 >> 2];
	                        c[(c[p >> 2] | 0) + ((c[r >> 2] << 1) + 1 << 2) >> 2] = c[(c[(c[q >> 2] | 0) + (c[r >> 2] << 2) >> 2] | 0) + 12 >> 2];
	                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                    }
	                    c[(c[p >> 2] | 0) + (c[s >> 2] << 1 << 2) >> 2] = 0;
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0)
	                }
	                q = c[(c[l >> 2] | 0) + 12 >> 2] | 0;
	                s = c[p >> 2] | 0;
	                if (c[n >> 2] | 0) {
	                    n = MQ(q, 0, 4, s) | 0;
	                    c[(c[l >> 2] | 0) + 16 >> 2] = n
	                } else {
	                    n = MQ(q, 0, 2, s) | 0;
	                    c[(c[l >> 2] | 0) + 16 >> 2] = n
	                }
	                if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                if (!(c[(c[l >> 2] | 0) + 16 >> 2] | 0)) {
	                    GE(c[j >> 2] | 0, 3037, 0, c[o >> 2] | 0, 165336, c[(c[l >> 2] | 0) + 12 >> 2] | 0);
	                    c[h >> 2] = 3037;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                } else {
	                    c[h >> 2] = 0;
	                    t = c[h >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                return 0
	            }

	            function EH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = (c[f >> 2] | 0) == (c[g >> 2] | 0) & 1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function FH() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 8 | 0;
	                d = a + 4 | 0;
	                e = a;
	                if (c[42590] | 0) {
	                    i = a;
	                    return
	                }
	                c[42592] = Ij(40) | 0;
	                c[42596] = eI(170376, 45, 0) | 0;
	                c[(c[42596] | 0) + 64 >> 2] = c[42596];
	                c[(c[42596] | 0) + 52 >> 2] = 3;
	                c[(c[42596] | 0) + 52 >> 2] = 3;
	                c[b >> 2] = fI() | 0;
	                if (!(c[b >> 2] | 0)) {
	                    i = a;
	                    return
	                }
	                c[(c[42596] | 0) + 28 >> 2] = c[b >> 2];
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    gI(0, 170392);
	                    i = a;
	                    return
	                }
	                f = c[d >> 2] | 0;
	                c[f + 0 >> 2] = 0;
	                c[f + 4 >> 2] = 0;
	                c[f + 8 >> 2] = 0;
	                c[f + 12 >> 2] = 0;
	                c[f + 16 >> 2] = 0;
	                c[c[d >> 2] >> 2] = 6;
	                c[(c[b >> 2] | 0) + 12 >> 2] = c[d >> 2];
	                c[b >> 2] = fI() | 0;
	                if (!(c[b >> 2] | 0)) {
	                    i = a;
	                    return
	                }
	                c[(c[b >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[b >> 2] | 0) + 20 >> 2] = 1073741824;
	                c[(c[d >> 2] | 0) + 12 >> 2] = c[b >> 2];
	                c[e >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    gI(0, 170432);
	                    i = a;
	                    return
	                }
	                d = (c[e >> 2] | 0) + 0 | 0;
	                f = d + 44 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (f | 0));
	                c[c[e >> 2] >> 2] = 2;
	                c[(c[e >> 2] | 0) + 28 >> 2] = 1;
	                c[(c[e >> 2] | 0) + 24 >> 2] = 2;
	                c[(c[b >> 2] | 0) + 12 >> 2] = c[e >> 2];
	                c[e >> 2] = Cb[c[135744 >> 2] & 511](44) | 0;
	                if (!(c[e >> 2] | 0)) {
	                    gI(0, 170464);
	                    i = a;
	                    return
	                } else {
	                    d = (c[e >> 2] | 0) + 0 | 0;
	                    f = d + 44 | 0;
	                    do {
	                        c[d >> 2] = 0;
	                        d = d + 4 | 0
	                    } while ((d | 0) < (f | 0));
	                    c[(c[e >> 2] | 0) + 28 >> 2] = 1;
	                    c[(c[e >> 2] | 0) + 24 >> 2] = 2;
	                    c[(c[42596] | 0) + 84 >> 2] = c[e >> 2];
	                    c[42634] = eI(170520, 46, c[42596] | 0) | 0;
	                    c[42638] = eI(170544, 1, c[42634] | 0) | 0;
	                    c[42642] = eI(170560, 3, c[42634] | 0) | 0;
	                    c[42646] = eI(170576, 10, c[42634] | 0) | 0;
	                    c[42652] = eI(170592, 11, c[42634] | 0) | 0;
	                    c[42656] = eI(170616, 4, c[42634] | 0) | 0;
	                    c[42660] = eI(170632, 8, c[42634] | 0) | 0;
	                    c[42666] = eI(170648, 9, c[42634] | 0) | 0;
	                    c[42670] = eI(170672, 6, c[42634] | 0) | 0;
	                    c[42676] = eI(170688, 7, c[42634] | 0) | 0;
	                    c[42680] = eI(170712, 5, c[42634] | 0) | 0;
	                    c[42686] = eI(170728, 12, c[42634] | 0) | 0;
	                    c[42690] = eI(170752, 13, c[42634] | 0) | 0;
	                    c[42694] = eI(170768, 14, c[42634] | 0) | 0;
	                    c[42698] = eI(170784, 15, c[42634] | 0) | 0;
	                    c[42702] = eI(170800, 29, c[42634] | 0) | 0;
	                    c[42708] = eI(170816, 43, c[42634] | 0) | 0;
	                    c[42714] = eI(170840, 44, c[42634] | 0) | 0;
	                    c[42720] = eI(170864, 28, c[42634] | 0) | 0;
	                    c[42724] = eI(170888, 21, c[42634] | 0) | 0;
	                    c[42728] = eI(170904, 30, c[42642] | 0) | 0;
	                    c[42736] = eI(170920, 31, c[42728] | 0) | 0;
	                    c[42742] = eI(170952, 32, c[42736] | 0) | 0;
	                    c[42746] = eI(170976, 37, c[42728] | 0) | 0;
	                    c[42750] = eI(170992, 35, c[42746] | 0) | 0;
	                    c[42754] = eI(171008, 39, c[42750] | 0) | 0;
	                    c[42758] = eI(171024, 41, c[42754] | 0) | 0;
	                    c[42766] = eI(171040, 33, c[42728] | 0) | 0;
	                    c[42772] = eI(171072, 38, c[42766] | 0) | 0;
	                    c[42778] = eI(171096, 36, c[42772] | 0) | 0;
	                    c[42784] = eI(171120, 40, c[42778] | 0) | 0;
	                    c[42790] = eI(171144, 42, c[42784] | 0) | 0;
	                    c[42796] = eI(171168, 34, c[42766] | 0) | 0;
	                    c[42804] = eI(171192, 2, c[42638] | 0) | 0;
	                    c[42808] = eI(171224, 16, c[42804] | 0) | 0;
	                    c[42814] = eI(171240, 17, c[42808] | 0) | 0;
	                    c[42818] = eI(171264, 20, c[42808] | 0) | 0;
	                    c[42822] = eI(171280, 18, c[42808] | 0) | 0;
	                    c[42826] = eI(171296, 22, c[42818] | 0) | 0;
	                    c[42830] = eI(171312, 23, c[42826] | 0) | 0;
	                    c[42834] = eI(171328, 24, c[42826] | 0) | 0;
	                    c[42838] = eI(171344, 26, c[42826] | 0) | 0;
	                    c[42844] = eI(171360, 27, c[42634] | 0) | 0;
	                    c[(c[42844] | 0) + 28 >> 2] = c[42838];
	                    c[42848] = eI(171384, 25, c[42634] | 0) | 0;
	                    c[(c[42848] | 0) + 28 >> 2] = c[42834];
	                    c[42854] = eI(171400, 19, c[42634] | 0) | 0;
	                    c[(c[42854] | 0) + 28 >> 2] = c[42822];
	                    c[42590] = 1;
	                    i = a;
	                    return
	                }
	            }

	            function GH() {
	                var a = 0, b = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                if (!(c[42590] | 0)) {
	                    i = a;
	                    return
	                }
	                TA(c[(c[42596] | 0) + 84 >> 2] | 0);
	                c[b >> 2] = c[(c[42596] | 0) + 28 >> 2];
	                TA(c[(c[(c[(c[b >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[(c[(c[b >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[(c[b >> 2] | 0) + 12 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[b >> 2] | 0);
	                c[(c[42596] | 0) + 28 >> 2] = 0;
	                Kj(c[42592] | 0, 360);
	                c[42590] = 0;
	                i = a;
	                return
	            }

	            function HH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                a:do if (!(c[f >> 2] | 0))c[e >> 2] = -1; else {
	                    if ((c[c[f >> 2] >> 2] | 0) != 1) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    switch (c[(c[f >> 2] | 0) + 88 >> 2] | 0) {
	                        case 15:
	                        {
	                            if ((c[g >> 2] | 0) == 1006 | (c[g >> 2] | 0) == 1008) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 3:
	                        {
	                            if ((c[g >> 2] | 0) == 1004 | (c[g >> 2] | 0) == 1005 | (c[g >> 2] | 0) == 1006 | (c[g >> 2] | 0) == 1008 | (c[g >> 2] | 0) == 1007 | (c[g >> 2] | 0) == 1002 | (c[g >> 2] | 0) == 1003 | (c[g >> 2] | 0) == 1e3 | (c[g >> 2] | 0) == 1001) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 14:
	                        case 13:
	                        case 12:
	                        case 11:
	                        case 10:
	                        case 9:
	                        case 8:
	                        case 7:
	                        case 6:
	                        case 5:
	                        case 4:
	                        {
	                            if ((c[g >> 2] | 0) == 1006 | (c[g >> 2] | 0) == 1007 | (c[g >> 2] | 0) == 1008 | (c[g >> 2] | 0) == 1002 | (c[g >> 2] | 0) == 1003 | (c[g >> 2] | 0) == 1e3 | (c[g >> 2] | 0) == 1001) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 43:
	                        case 44:
	                        case 29:
	                        case 21:
	                        case 28:
	                        case 1:
	                        {
	                            if ((c[g >> 2] | 0) == 1009 | (c[g >> 2] | 0) == 1011 | (c[g >> 2] | 0) == 1010 | (c[g >> 2] | 0) == 1006 | (c[g >> 2] | 0) == 1007 | (c[g >> 2] | 0) == 1008) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        default:
	                        {
	                            c[e >> 2] = 0;
	                            break a
	                        }
	                    }
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function IH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[42590] | 0))FH();
	                do switch (c[e >> 2] | 0) {
	                    case 46:
	                    {
	                        c[d >> 2] = c[42634];
	                        break
	                    }
	                    case 38:
	                    {
	                        c[d >> 2] = c[42772];
	                        break
	                    }
	                    case 23:
	                    {
	                        c[d >> 2] = c[42830];
	                        break
	                    }
	                    case 22:
	                    {
	                        c[d >> 2] = c[42826];
	                        break
	                    }
	                    case 3:
	                    {
	                        c[d >> 2] = c[42642];
	                        break
	                    }
	                    case 34:
	                    {
	                        c[d >> 2] = c[42796];
	                        break
	                    }
	                    case 36:
	                    {
	                        c[d >> 2] = c[42778];
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = c[42808];
	                        break
	                    }
	                    case 37:
	                    {
	                        c[d >> 2] = c[42746];
	                        break
	                    }
	                    case 44:
	                    {
	                        c[d >> 2] = c[42714];
	                        break
	                    }
	                    case 26:
	                    {
	                        c[d >> 2] = c[42838];
	                        break
	                    }
	                    case 29:
	                    {
	                        c[d >> 2] = c[42702];
	                        break
	                    }
	                    case 32:
	                    {
	                        c[d >> 2] = c[42742];
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = c[42698];
	                        break
	                    }
	                    case 10:
	                    {
	                        c[d >> 2] = c[42646];
	                        break
	                    }
	                    case 18:
	                    {
	                        c[d >> 2] = c[42822];
	                        break
	                    }
	                    case 8:
	                    {
	                        c[d >> 2] = c[42660];
	                        break
	                    }
	                    case 5:
	                    {
	                        c[d >> 2] = c[42680];
	                        break
	                    }
	                    case 12:
	                    {
	                        c[d >> 2] = c[42686];
	                        break
	                    }
	                    case 24:
	                    {
	                        c[d >> 2] = c[42834];
	                        break
	                    }
	                    case 11:
	                    {
	                        c[d >> 2] = c[42652];
	                        break
	                    }
	                    case 30:
	                    {
	                        c[d >> 2] = c[42728];
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = c[42638];
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = c[42814];
	                        break
	                    }
	                    case 21:
	                    {
	                        c[d >> 2] = c[42724];
	                        break
	                    }
	                    case 28:
	                    {
	                        c[d >> 2] = c[42720];
	                        break
	                    }
	                    case 35:
	                    {
	                        c[d >> 2] = c[42750];
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = c[42804];
	                        break
	                    }
	                    case 6:
	                    {
	                        c[d >> 2] = c[42670];
	                        break
	                    }
	                    case 27:
	                    {
	                        c[d >> 2] = c[42844];
	                        break
	                    }
	                    case 39:
	                    {
	                        c[d >> 2] = c[42754];
	                        break
	                    }
	                    case 33:
	                    {
	                        c[d >> 2] = c[42766];
	                        break
	                    }
	                    case 42:
	                    {
	                        c[d >> 2] = c[42790];
	                        break
	                    }
	                    case 4:
	                    {
	                        c[d >> 2] = c[42656];
	                        break
	                    }
	                    case 41:
	                    {
	                        c[d >> 2] = c[42758];
	                        break
	                    }
	                    case 9:
	                    {
	                        c[d >> 2] = c[42666];
	                        break
	                    }
	                    case 31:
	                    {
	                        c[d >> 2] = c[42736];
	                        break
	                    }
	                    case 45:
	                    {
	                        c[d >> 2] = c[42596];
	                        break
	                    }
	                    case 40:
	                    {
	                        c[d >> 2] = c[42784];
	                        break
	                    }
	                    case 43:
	                    {
	                        c[d >> 2] = c[42708];
	                        break
	                    }
	                    case 19:
	                    {
	                        c[d >> 2] = c[42854];
	                        break
	                    }
	                    case 7:
	                    {
	                        c[d >> 2] = c[42676];
	                        break
	                    }
	                    case 13:
	                    {
	                        c[d >> 2] = c[42690];
	                        break
	                    }
	                    case 20:
	                    {
	                        c[d >> 2] = c[42818];
	                        break
	                    }
	                    case 25:
	                    {
	                        c[d >> 2] = c[42848];
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = c[42694];
	                        break
	                    }
	                    default:
	                        c[d >> 2] = 0
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function JH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function KH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0))c[d >> 2] = 0; else c[d >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function LH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a:do if (!(c[e >> 2] | 0))c[d >> 2] = 0; else switch (c[c[e >> 2] >> 2] | 0) {
	                    case 29:
	                    case 26:
	                    case 24:
	                    case 23:
	                    case 22:
	                    case 20:
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 46:
	                    case 2:
	                    case 1:
	                    {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                        break a;
	                        break
	                    }
	                    default:
	                    {
	                        c[d >> 2] = 0;
	                        break a
	                    }
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function MH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[c[e >> 2] >> 2] | 0) == 15 : 0) {
	                    c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                c[d >> 2] = 0;
	                f = c[d >> 2] | 0;
	                i = b;
	                return f | 0
	            }

	            function NH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = hI(28) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[(c[h >> 2] | 0) + 8 >> 2] = c[f >> 2];
	                if (c[g >> 2] | 0)c[(c[h >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function OH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = hI(21) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[(c[h >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                    c[(c[h >> 2] | 0) + 12 >> 2] = c[f >> 2];
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function PH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    switch (c[c[d >> 2] >> 2] | 0) {
	                        case 46:
	                        case 29:
	                        case 27:
	                        case 26:
	                        case 25:
	                        case 24:
	                        case 23:
	                        case 22:
	                        case 20:
	                        case 19:
	                        case 18:
	                        case 17:
	                        case 16:
	                        case 2:
	                        case 1:
	                        {
	                            if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        case 21:
	                        case 28:
	                        {
	                            if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                            if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        case 44:
	                        {
	                            if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        case 43:
	                        {
	                            if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    }
	                    c[e >> 2] = c[d >> 2];
	                    c[d >> 2] = c[(c[d >> 2] | 0) + 4 >> 2];
	                    zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                }
	                i = b;
	                return
	            }

	            function QH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[42590] | 0))FH();
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } else {
	                    c[e >> 2] = Tj(c[42592] | 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                return 0
	            }

	            function RH(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = b;
	                c[h >> 2] = c[g >> 2];
	                c[j >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                while (1) {
	                    if (((d[c[h >> 2] >> 0] | 0 | 0) != 0 ? (d[c[h >> 2] >> 0] | 0 | 0) != 13 : 0) ? (d[c[h >> 2] >> 0] | 0 | 0) != 9 : 0)m = (d[c[h >> 2] >> 0] | 0 | 0) != 10; else m = 0;
	                    n = c[h >> 2] | 0;
	                    if (!m)break;
	                    c[h >> 2] = n + 1
	                }
	                if (!(d[n >> 0] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[j >> 2] = my(c[g >> 2] | 0) | 0;
	                c[k >> 2] = (c[j >> 2] | 0) + ((c[h >> 2] | 0) - (c[g >> 2] | 0));
	                do {
	                    if (!(((d[c[k >> 2] >> 0] | 0 | 0) != 13 ? (d[c[k >> 2] >> 0] | 0 | 0) != 9 : 0) ? (d[c[k >> 2] >> 0] | 0 | 0) != 10 : 0))a[c[k >> 2] >> 0] = 32;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                } while ((d[c[k >> 2] >> 0] | 0 | 0) != 0);
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function SH(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = b;
	                c[h >> 2] = c[g >> 2];
	                c[m >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                while (1) {
	                    do if (d[c[h >> 2] >> 0] | 0)if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            o = 1;
	                            break
	                        }
	                        o = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                    } else o = 0; while (0);
	                    p = c[h >> 2] | 0;
	                    if (!o)break;
	                    c[h >> 2] = p + 1
	                }
	                c[j >> 2] = p;
	                while (1) {
	                    if (!(d[c[j >> 2] >> 0] | 0))break;
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 32) {
	                        if ((d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) == 32) {
	                            q = 17;
	                            break
	                        }
	                        if (9 <= (d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) ? (d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) <= 10 : 0) {
	                            q = 17;
	                            break
	                        }
	                        if ((d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) == 13) {
	                            q = 17;
	                            break
	                        }
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 10) {
	                        q = 21;
	                        break
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 9) {
	                        q = 21;
	                        break
	                    }
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 13) {
	                        q = 21;
	                        break
	                    }
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                if ((q | 0) == 17)c[m >> 2] = (c[j >> 2] | 0) - (c[h >> 2] | 0); else if ((q | 0) == 21)c[m >> 2] = (c[j >> 2] | 0) - (c[h >> 2] | 0);
	                if (!(c[m >> 2] | 0)) {
	                    c[k >> 2] = c[j >> 2];
	                    c[j >> 2] = (c[j >> 2] | 0) + -1;
	                    while (1) {
	                        do if ((c[j >> 2] | 0) >>> 0 > (c[h >> 2] | 0) >>> 0)if ((d[c[j >> 2] >> 0] | 0 | 0) == 32)r = 1; else {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                r = 1;
	                                break
	                            }
	                            r = (d[c[j >> 2] >> 0] | 0 | 0) == 13
	                        } else r = 0; while (0);
	                        s = c[j >> 2] | 0;
	                        if (!r)break;
	                        c[j >> 2] = s + -1
	                    }
	                    c[j >> 2] = s + 1;
	                    if ((c[h >> 2] | 0) == (c[g >> 2] | 0) ? (c[k >> 2] | 0) == (c[j >> 2] | 0) : 0) {
	                        c[f >> 2] = 0;
	                        n = c[f >> 2] | 0;
	                        i = e;
	                        return n | 0
	                    }
	                    c[f >> 2] = ly(c[h >> 2] | 0, (c[j >> 2] | 0) - (c[h >> 2] | 0) | 0) | 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[h >> 2] = my(c[h >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[l >> 2] = (c[h >> 2] | 0) + (c[m >> 2] | 0);
	                c[j >> 2] = c[l >> 2];
	                a:while (1) {
	                    if (!(d[c[j >> 2] >> 0] | 0))break;
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13) {
	                            m = c[j >> 2] | 0;
	                            c[j >> 2] = m + 1;
	                            k = a[m >> 0] | 0;
	                            m = c[l >> 2] | 0;
	                            c[l >> 2] = m + 1;
	                            a[m >> 0] = k;
	                            continue a
	                        }
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) == 32)t = 1; else {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                t = 1;
	                                break
	                            }
	                            t = (d[c[j >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        u = c[j >> 2] | 0;
	                        if (!t)break;
	                        c[j >> 2] = u + 1
	                    }
	                    if (!(d[u >> 0] | 0))continue;
	                    k = c[l >> 2] | 0;
	                    c[l >> 2] = k + 1;
	                    a[k >> 0] = 32
	                }
	                a[c[l >> 2] >> 0] = 0;
	                c[f >> 2] = c[h >> 2];
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function TH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = iI(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, 0, 0, 1, 1, 0) | 0;
	                i = f;
	                return e | 0
	            }

	            function UH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = iI(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, 1, 0, 1, 0, 1) | 0;
	                i = f;
	                return e | 0
	            }

	            function VH(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = TH(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function WH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                a:while (1) {
	                    if (!(c[e >> 2] | 0)) {
	                        j = 20;
	                        break
	                    }
	                    switch (c[c[e >> 2] >> 2] | 0) {
	                        case 43:
	                        {
	                            c[h >> 2] = jI(c[e >> 2] | 0) | 0;
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                                a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 8 >> 2] = a
	                            }
	                            break
	                        }
	                        case 29:
	                        case 18:
	                        case 26:
	                        case 24:
	                        case 23:
	                        case 22:
	                        case 20:
	                        case 17:
	                        case 16:
	                        case 2:
	                        case 1:
	                        case 46:
	                        {
	                            c[h >> 2] = jI(c[e >> 2] | 0) | 0;
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                                a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 8 >> 2] = a
	                            }
	                            break
	                        }
	                        case 19:
	                        case 27:
	                        case 25:
	                        case 45:
	                        {
	                            j = 4;
	                            break a;
	                            break
	                        }
	                        case 28:
	                        case 21:
	                        {
	                            c[h >> 2] = jI(c[e >> 2] | 0) | 0;
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                                a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 8 >> 2] = a
	                            }
	                            if (c[(c[e >> 2] | 0) + 12 >> 2] | 0) {
	                                a = my(c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 12 >> 2] = a
	                            }
	                            break
	                        }
	                        case 44:
	                        {
	                            c[h >> 2] = jI(c[e >> 2] | 0) | 0;
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                                a = my(c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 8 >> 2] = a
	                            }
	                            break
	                        }
	                        default:
	                            c[h >> 2] = jI(c[e >> 2] | 0) | 0
	                    }
	                    a = c[h >> 2] | 0;
	                    if (!(c[f >> 2] | 0))c[f >> 2] = a; else c[(c[g >> 2] | 0) + 4 >> 2] = a;
	                    c[g >> 2] = c[h >> 2];
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 4 >> 2]
	                }
	                if ((j | 0) == 4) {
	                    PH(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                } else if ((j | 0) == 20) {
	                    c[d >> 2] = c[f >> 2];
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                return 0
	            }

	            function XH(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -2;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                do if ((c[c[f >> 2] >> 2] | 0) != 1)if ((c[c[f >> 2] >> 2] | 0) == 2) {
	                    c[h >> 2] = 2;
	                    break
	                } else {
	                    c[h >> 2] = 3;
	                    break
	                } else c[h >> 2] = 1; while (0);
	                do if ((c[c[g >> 2] >> 2] | 0) != 1)if ((c[c[g >> 2] >> 2] | 0) == 2) {
	                    c[j >> 2] = 2;
	                    break
	                } else {
	                    c[j >> 2] = 3;
	                    break
	                } else c[j >> 2] = 1; while (0);
	                c[e >> 2] = kI(c[c[f >> 2] >> 2] | 0, c[f >> 2] | 0, 0, c[h >> 2] | 0, c[c[g >> 2] >> 2] | 0, c[g >> 2] | 0, 0, c[j >> 2] | 0) | 0;
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function YH(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = -2;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = kI(c[c[h >> 2] >> 2] | 0, c[h >> 2] | 0, 0, c[j >> 2] | 0, c[c[k >> 2] >> 2] | 0, c[k >> 2] | 0, 0, c[l >> 2] | 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function ZH(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else {
	                    c[d >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function _H(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                do if ((c[c[h >> 2] >> 2] | 0) == 1009) {
	                    if ((c[k >> 2] | 0) != (c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0)) {
	                        if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2];
	                        c[g >> 2] = 1830;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                } else {
	                    if ((c[c[h >> 2] >> 2] | 0) == 1011) {
	                        if ((c[k >> 2] | 0) >>> 0 >= (c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) >>> 0)break;
	                        if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2];
	                        c[g >> 2] = 1831;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    if ((c[c[h >> 2] >> 2] | 0) != 1010) {
	                        c[g >> 2] = $H(0, c[h >> 2] | 0, c[j >> 2] | 0, 0) | 0;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    if ((c[k >> 2] | 0) >>> 0 > (c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) >>> 0) {
	                        if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = c[(c[(c[h >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2];
	                        c[g >> 2] = 1832;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                } while (0);
	                c[g >> 2] = 0;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function $H(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (c[l >> 2] | 0) {
	                    c[g >> 2] = lI(c[j >> 2] | 0, 0, c[c[l >> 2] >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (c[h >> 2] | 0) {
	                    c[g >> 2] = lI(c[j >> 2] | 0, 0, c[(c[h >> 2] | 0) + 88 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, 0) | 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } else {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                return 0
	            }

	            function aI(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                g = mI(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                i = h;
	                return g | 0
	            }

	            function bI(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                g = lI(c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                i = h;
	                return g | 0
	            }

	            function cI(d, f) {
	                d = d | 0;
	                f = f | 0;
	                var j = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, S = 0, T = 0, U = 0, V = 0, W = 0.0;
	                j = i;
	                i = i + 512 | 0;
	                l = j + 16 | 0;
	                m = j + 148 | 0;
	                n = j + 144 | 0;
	                o = j + 140 | 0;
	                p = j + 120 | 0;
	                q = j + 116 | 0;
	                r = j + 112 | 0;
	                s = j + 108 | 0;
	                t = j + 104 | 0;
	                u = j + 100 | 0;
	                v = j + 80 | 0;
	                w = j + 76 | 0;
	                x = j + 400 | 0;
	                y = j + 72 | 0;
	                z = j + 68 | 0;
	                A = j + 64 | 0;
	                B = j + 60 | 0;
	                C = j + 56 | 0;
	                D = j + 8 | 0;
	                E = j;
	                F = j + 368 | 0;
	                G = j + 332 | 0;
	                H = j + 302 | 0;
	                I = j + 52 | 0;
	                J = j + 272 | 0;
	                K = j + 48 | 0;
	                L = j + 222 | 0;
	                M = j + 44 | 0;
	                N = j + 192 | 0;
	                O = j + 152 | 0;
	                c[n >> 2] = d;
	                c[o >> 2] = f;
	                if ((c[o >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    c[m >> 2] = -1;
	                    P = c[m >> 2] | 0;
	                    i = j;
	                    return P | 0
	                }
	                c[c[o >> 2] >> 2] = 0;
	                a:do switch (c[c[n >> 2] >> 2] | 0) {
	                    case 9:
	                    {
	                        f = c[(c[n >> 2] | 0) + 8 >> 2] | 0;
	                        if ((c[(c[n >> 2] | 0) + 8 >> 2] | 0) < 0) {
	                            d = R(f | 0) | 0;
	                            S = c[(c[n >> 2] | 0) + 12 >> 2] & 15;
	                            c[l >> 2] = d;
	                            c[l + 4 >> 2] = S;
	                            JT(G, 35, 171648, l) | 0
	                        } else {
	                            S = c[(c[n >> 2] | 0) + 12 >> 2] & 15;
	                            c[l >> 2] = f;
	                            c[l + 4 >> 2] = S;
	                            JT(G, 35, 171664, l) | 0
	                        }
	                        S = my(G) | 0;
	                        c[c[o >> 2] >> 2] = S;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[l >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                        JT(F, 30, 171608, l) | 0;
	                        S = my(F) | 0;
	                        c[c[o >> 2] >> 2] = S;
	                        break
	                    }
	                    case 2:
	                    {
	                        if (!(c[(c[n >> 2] | 0) + 8 >> 2] | 0)) {
	                            S = my(171424) | 0;
	                            c[c[o >> 2] >> 2] = S;
	                            break a
	                        }
	                        S = RH(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[c[o >> 2] >> 2] = S;
	                        if (!(c[c[o >> 2] >> 2] | 0)) {
	                            S = my(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[o >> 2] >> 2] = S
	                        }
	                        break
	                    }
	                    case 3:
	                    {
	                        if (((e[(c[n >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535 | 0) == 1 ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                            S = my(171448) | 0;
	                            c[c[o >> 2] >> 2] = S;
	                            break a
	                        }
	                        S = (c[n >> 2] | 0) + 8 | 0;
	                        c[p + 0 >> 2] = c[S + 0 >> 2];
	                        c[p + 4 >> 2] = c[S + 4 >> 2];
	                        c[p + 8 >> 2] = c[S + 8 >> 2];
	                        c[p + 12 >> 2] = c[S + 12 >> 2];
	                        c[p + 16 >> 2] = c[S + 16 >> 2];
	                        c[r >> 2] = 0;
	                        c[q >> 2] = ((e[p + 16 >> 1] | 0) >>> 8 & 65535) + 2;
	                        if (b[p + 16 >> 1] & 1)c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        if (!(((e[p + 16 >> 1] | 0) >>> 1 & 127 | 0) != 0 ? ((e[p + 16 >> 1] | 0) >>> 1 & 127 | 0) != ((e[p + 16 >> 1] | 0) >>> 8 & 65535 | 0) : 0))c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        c[r >> 2] = Cb[c[135744 >> 2] & 511](c[q >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            c[m >> 2] = -1;
	                            P = c[m >> 2] | 0;
	                            i = j;
	                            return P | 0
	                        }
	                        c[s >> 2] = c[r >> 2];
	                        if (b[p + 16 >> 1] & 1) {
	                            S = c[s >> 2] | 0;
	                            c[s >> 2] = S + 1;
	                            a[S >> 0] = 45
	                        }
	                        if (((e[p + 16 >> 1] | 0) >>> 1 & 127 | 0) == ((e[p + 16 >> 1] | 0) >>> 8 & 65535 | 0)) {
	                            S = c[s >> 2] | 0;
	                            c[s >> 2] = S + 1;
	                            a[S >> 0] = 48;
	                            S = c[s >> 2] | 0;
	                            c[s >> 2] = S + 1;
	                            a[S >> 0] = 46
	                        }
	                        do if (!(c[p + 8 >> 2] | 0)) {
	                            S = c[s >> 2] | 0;
	                            f = (c[q >> 2] | 0) - ((c[s >> 2] | 0) - (c[r >> 2] | 0)) | 0;
	                            if (c[p + 4 >> 2] | 0) {
	                                d = c[p >> 2] | 0;
	                                c[l >> 2] = c[p + 4 >> 2];
	                                c[l + 4 >> 2] = d;
	                                JT(S, f, 171472, l) | 0;
	                                break
	                            } else {
	                                c[l >> 2] = c[p >> 2];
	                                JT(S, f, 171480, l) | 0;
	                                break
	                            }
	                        } else {
	                            f = c[s >> 2] | 0;
	                            S = (c[q >> 2] | 0) - ((c[s >> 2] | 0) - (c[r >> 2] | 0)) | 0;
	                            d = c[p + 4 >> 2] | 0;
	                            T = c[p >> 2] | 0;
	                            c[l >> 2] = c[p + 8 >> 2];
	                            c[l + 4 >> 2] = d;
	                            c[l + 8 >> 2] = T;
	                            JT(f, S, 171456, l) | 0
	                        } while (0);
	                        do if ((e[p + 16 >> 1] | 0) >>> 1 & 127) {
	                            if (((e[p + 16 >> 1] | 0) >>> 1 & 127 | 0) != ((e[p + 16 >> 1] | 0) >>> 8 & 65535 | 0)) {
	                                c[t >> 2] = ((e[p + 16 >> 1] | 0) >>> 8 & 65535) - ((e[p + 16 >> 1] | 0) >>> 1 & 127);
	                                fU((c[s >> 2] | 0) + (c[t >> 2] | 0) + 1 | 0, (c[s >> 2] | 0) + (c[t >> 2] | 0) | 0, ((e[p + 16 >> 1] | 0) >>> 1 & 127) + 1 | 0) | 0;
	                                a[(c[s >> 2] | 0) + (c[t >> 2] | 0) >> 0] = 46;
	                                break
	                            }
	                            c[u >> 2] = 0;
	                            while (1) {
	                                U = c[u >> 2] | 0;
	                                if (!(a[(c[s >> 2] | 0) + (c[u >> 2] | 0) >> 0] | 0))break;
	                                c[u >> 2] = U + 1
	                            }
	                            if (U >>> 0 < ((e[p + 16 >> 1] | 0) >>> 8 & 65535) >>> 0) {
	                                fU((c[s >> 2] | 0) + (((e[p + 16 >> 1] | 0) >>> 8 & 65535) - (c[u >> 2] | 0)) | 0, c[s >> 2] | 0, (c[u >> 2] | 0) + 1 | 0) | 0;
	                                cU(c[s >> 2] | 0, 48, ((e[p + 16 >> 1] | 0) >>> 8 & 65535) - (c[u >> 2] | 0) | 0) | 0
	                            }
	                        } else {
	                            c[s >> 2] = (c[r >> 2] | 0) + (c[q >> 2] | 0) + -1;
	                            S = c[s >> 2] | 0;
	                            c[s >> 2] = S + -1;
	                            a[S >> 0] = 0;
	                            S = c[s >> 2] | 0;
	                            c[s >> 2] = S + -1;
	                            a[S >> 0] = 48;
	                            S = c[s >> 2] | 0;
	                            c[s >> 2] = S + -1;
	                            a[S >> 0] = 46
	                        } while (0);
	                        c[c[o >> 2] >> 2] = c[r >> 2];
	                        break
	                    }
	                    case 7:
	                    {
	                        S = Cb[c[135744 >> 2] & 511](8) | 0;
	                        c[c[o >> 2] >> 2] = S;
	                        if (c[c[o >> 2] >> 2] | 0) {
	                            S = c[c[o >> 2] >> 2] | 0;
	                            f = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31;
	                            c[l >> 2] = c[(c[n >> 2] | 0) + 12 >> 2] & 15;
	                            c[l + 4 >> 2] = f;
	                            JT(S, 8, 171632, l) | 0;
	                            break a
	                        }
	                        c[m >> 2] = -1;
	                        P = c[m >> 2] | 0;
	                        i = j;
	                        return P | 0
	                    }
	                    case 15:
	                    {
	                        if (c[(c[n >> 2] | 0) + 8 >> 2] | 0) {
	                            S = my(171528) | 0;
	                            c[c[o >> 2] >> 2] = S;
	                            break a
	                        } else {
	                            S = my(171536) | 0;
	                            c[c[o >> 2] >> 2] = S;
	                            break a
	                        }
	                        break
	                    }
	                    case 5:
	                    {
	                        S = Cb[c[135744 >> 2] & 511](6) | 0;
	                        c[c[o >> 2] >> 2] = S;
	                        if (c[c[o >> 2] >> 2] | 0) {
	                            S = c[c[o >> 2] >> 2] | 0;
	                            c[l >> 2] = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31;
	                            JT(S, 6, 171624, l) | 0;
	                            break a
	                        }
	                        c[m >> 2] = -1;
	                        P = c[m >> 2] | 0;
	                        i = j;
	                        return P | 0
	                    }
	                    case 42:
	                    case 40:
	                    case 38:
	                    case 36:
	                    case 35:
	                    case 39:
	                    case 41:
	                    case 37:
	                    case 33:
	                    case 32:
	                    case 31:
	                    case 34:
	                    case 30:
	                    {
	                        if (((e[(c[n >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535 | 0) == 1 ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                            S = my(171488) | 0;
	                            c[c[o >> 2] >> 2] = S;
	                            break a
	                        }
	                        S = (c[n >> 2] | 0) + 8 | 0;
	                        c[v + 0 >> 2] = c[S + 0 >> 2];
	                        c[v + 4 >> 2] = c[S + 4 >> 2];
	                        c[v + 8 >> 2] = c[S + 8 >> 2];
	                        c[v + 12 >> 2] = c[S + 12 >> 2];
	                        c[v + 16 >> 2] = c[S + 16 >> 2];
	                        c[w >> 2] = ((e[v + 16 >> 1] | 0) >>> 8 & 65535) + 1;
	                        if (b[v + 16 >> 1] & 1)c[w >> 2] = (c[w >> 2] | 0) + 1;
	                        S = Cb[c[135744 >> 2] & 511](c[w >> 2] | 0) | 0;
	                        c[c[o >> 2] >> 2] = S;
	                        if (!(c[c[o >> 2] >> 2] | 0)) {
	                            c[m >> 2] = -1;
	                            P = c[m >> 2] | 0;
	                            i = j;
	                            return P | 0
	                        }
	                        if (c[v + 8 >> 2] | 0) {
	                            S = c[c[o >> 2] >> 2] | 0;
	                            f = c[w >> 2] | 0;
	                            T = c[v + 8 >> 2] | 0;
	                            d = c[v + 4 >> 2] | 0;
	                            V = c[v >> 2] | 0;
	                            if (b[v + 16 >> 1] & 1) {
	                                c[l >> 2] = T;
	                                c[l + 4 >> 2] = d;
	                                c[l + 8 >> 2] = V;
	                                JT(S, f, 171496, l) | 0;
	                                break a
	                            } else {
	                                c[l >> 2] = T;
	                                c[l + 4 >> 2] = d;
	                                c[l + 8 >> 2] = V;
	                                JT(S, f, 171456, l) | 0;
	                                break a
	                            }
	                        }
	                        f = (b[v + 16 >> 1] & 1 | 0) != 0;
	                        S = c[c[o >> 2] >> 2] | 0;
	                        V = c[w >> 2] | 0;
	                        if (c[v + 4 >> 2] | 0) {
	                            d = c[v + 4 >> 2] | 0;
	                            T = c[v >> 2] | 0;
	                            if (f) {
	                                c[l >> 2] = d;
	                                c[l + 4 >> 2] = T;
	                                JT(S, V, 171512, l) | 0;
	                                break a
	                            } else {
	                                c[l >> 2] = d;
	                                c[l + 4 >> 2] = T;
	                                JT(S, V, 171472, l) | 0;
	                                break a
	                            }
	                        } else {
	                            T = c[v >> 2] | 0;
	                            if (f) {
	                                c[l >> 2] = T;
	                                JT(S, V, 171520, l) | 0;
	                                break a
	                            } else {
	                                c[l >> 2] = T;
	                                JT(S, V, 171480, l) | 0;
	                                break a
	                            }
	                        }
	                        break
	                    }
	                    case 12:
	                    {
	                        c[B >> 2] = 0;
	                        c[C >> 2] = 0;
	                        h[D >> 3] = 0.0;
	                        c[y >> 2] = ~~+Q(+(+(R(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0) / 12.0)) >>> 0;
	                        V = R(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[z >> 2] = V - ((c[y >> 2] | 0) * 12 | 0);
	                        c[A >> 2] = ~~+Q(+(+R(+(+h[(c[n >> 2] | 0) + 16 >> 3])) / 86400.0)) >>> 0;
	                        W = +R(+(+h[(c[n >> 2] | 0) + 16 >> 3]));
	                        h[E >> 3] = W - +(((c[A >> 2] | 0) * 86400 | 0) >>> 0);
	                        if (+h[E >> 3] > 0.0 ? (c[B >> 2] = ~~+Q(+(+h[E >> 3] / 3600.0)) >>> 0, h[E >> 3] = +h[E >> 3] - +(((c[B >> 2] | 0) * 3600 | 0) >>> 0), +h[E >> 3] > 0.0) : 0) {
	                            c[C >> 2] = ~~+Q(+(+h[E >> 3] / 60.0)) >>> 0;
	                            h[D >> 3] = +h[E >> 3] - +(((c[C >> 2] | 0) * 60 | 0) >>> 0)
	                        }
	                        if ((c[(c[n >> 2] | 0) + 8 >> 2] | 0) >= 0 ? !(+h[(c[n >> 2] | 0) + 16 >> 3] < 0.0) : 0) {
	                            V = c[z >> 2] | 0;
	                            S = c[A >> 2] | 0;
	                            T = c[B >> 2] | 0;
	                            f = c[C >> 2] | 0;
	                            W = +h[D >> 3];
	                            c[l >> 2] = c[y >> 2];
	                            c[l + 4 >> 2] = V;
	                            c[l + 8 >> 2] = S;
	                            c[l + 12 >> 2] = T;
	                            c[l + 16 >> 2] = f;
	                            f = l + 20 | 0;
	                            h[k >> 3] = W;
	                            c[f >> 2] = c[k >> 2];
	                            c[f + 4 >> 2] = c[k + 4 >> 2];
	                            JT(x, 100, 171576, l) | 0
	                        } else {
	                            f = c[z >> 2] | 0;
	                            T = c[A >> 2] | 0;
	                            S = c[B >> 2] | 0;
	                            V = c[C >> 2] | 0;
	                            W = +h[D >> 3];
	                            c[l >> 2] = c[y >> 2];
	                            c[l + 4 >> 2] = f;
	                            c[l + 8 >> 2] = T;
	                            c[l + 12 >> 2] = S;
	                            c[l + 16 >> 2] = V;
	                            V = l + 20 | 0;
	                            h[k >> 3] = W;
	                            c[V >> 2] = c[k >> 2];
	                            c[V + 4 >> 2] = c[k + 4 >> 2];
	                            JT(x, 100, 171544, l) | 0
	                        }
	                        V = my(x) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 10:
	                    {
	                        do if (b[(c[n >> 2] | 0) + 24 >> 1] & 1) {
	                            c[K >> 2] = nI(c[n >> 2] | 0, 0.0) | 0;
	                            if (c[K >> 2] | 0) {
	                                V = c[(c[K >> 2] | 0) + 12 >> 2] & 15;
	                                S = (c[(c[K >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31;
	                                c[l >> 2] = c[(c[K >> 2] | 0) + 8 >> 2];
	                                c[l + 4 >> 2] = V;
	                                c[l + 8 >> 2] = S;
	                                JT(J, 30, 171728, l) | 0;
	                                PH(c[K >> 2] | 0);
	                                break
	                            }
	                            c[m >> 2] = -1;
	                            P = c[m >> 2] | 0;
	                            i = j;
	                            return P | 0
	                        } else {
	                            S = c[(c[n >> 2] | 0) + 12 >> 2] & 15;
	                            V = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31;
	                            c[l >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                            c[l + 4 >> 2] = S;
	                            c[l + 8 >> 2] = V;
	                            JT(J, 30, 171752, l) | 0
	                        } while (0);
	                        V = my(J) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 29:
	                    case 28:
	                    case 26:
	                    case 24:
	                    case 23:
	                    case 22:
	                    case 20:
	                    case 18:
	                    case 17:
	                    case 16:
	                    {
	                        if (!(c[(c[n >> 2] | 0) + 8 >> 2] | 0)) {
	                            c[m >> 2] = -1;
	                            P = c[m >> 2] | 0;
	                            i = j;
	                            return P | 0
	                        } else {
	                            V = SH(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            if (c[c[o >> 2] >> 2] | 0)break a;
	                            V = my(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            break a
	                        }
	                        break
	                    }
	                    case 4:
	                    {
	                        do if (b[(c[n >> 2] | 0) + 24 >> 1] & 1) {
	                            c[I >> 2] = nI(c[n >> 2] | 0, 0.0) | 0;
	                            if (c[I >> 2] | 0) {
	                                V = (c[(c[I >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63;
	                                W = +h[(c[I >> 2] | 0) + 16 >> 3];
	                                c[l >> 2] = (c[(c[I >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31;
	                                c[l + 4 >> 2] = V;
	                                V = l + 8 | 0;
	                                h[k >> 3] = W;
	                                c[V >> 2] = c[k >> 2];
	                                c[V + 4 >> 2] = c[k + 4 >> 2];
	                                JT(H, 30, 171680, l) | 0;
	                                PH(c[I >> 2] | 0);
	                                break
	                            }
	                            c[m >> 2] = -1;
	                            P = c[m >> 2] | 0;
	                            i = j;
	                            return P | 0
	                        } else {
	                            V = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63;
	                            W = +h[(c[n >> 2] | 0) + 16 >> 3];
	                            c[l >> 2] = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31;
	                            c[l + 4 >> 2] = V;
	                            V = l + 8 | 0;
	                            h[k >> 3] = W;
	                            c[V >> 2] = c[k >> 2];
	                            c[V + 4 >> 2] = c[k + 4 >> 2];
	                            JT(H, 30, 171704, l) | 0
	                        } while (0);
	                        V = my(H) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 6:
	                    {
	                        V = Cb[c[135744 >> 2] & 511](6) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        if (c[c[o >> 2] >> 2] | 0) {
	                            V = c[c[o >> 2] >> 2] | 0;
	                            c[l >> 2] = c[(c[n >> 2] | 0) + 12 >> 2] & 15;
	                            JT(V, 6, 171616, l) | 0;
	                            break a
	                        }
	                        c[m >> 2] = -1;
	                        P = c[m >> 2] | 0;
	                        i = j;
	                        return P | 0
	                    }
	                    case 43:
	                    {
	                        V = my(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 44:
	                    {
	                        V = my(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 13:
	                    {
	                        h[k >> 3] = +g[(c[n >> 2] | 0) + 8 >> 2];
	                        c[l >> 2] = c[k >> 2];
	                        c[l + 4 >> 2] = c[k + 4 >> 2];
	                        JT(N, 30, 171848, l) | 0;
	                        V = my(N) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 14:
	                    {
	                        h[k >> 3] = +h[(c[n >> 2] | 0) + 8 >> 3];
	                        c[l >> 2] = c[k >> 2];
	                        c[l + 4 >> 2] = c[k + 4 >> 2];
	                        JT(O, 40, 171848, l) | 0;
	                        V = my(O) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 11:
	                    {
	                        do if (b[(c[n >> 2] | 0) + 24 >> 1] & 1) {
	                            c[M >> 2] = nI(c[n >> 2] | 0, 0.0) | 0;
	                            if (c[M >> 2] | 0) {
	                                V = c[(c[M >> 2] | 0) + 12 >> 2] & 15;
	                                S = (c[(c[M >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31;
	                                T = (c[(c[M >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31;
	                                f = (c[(c[M >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63;
	                                W = +h[(c[M >> 2] | 0) + 16 >> 3];
	                                c[l >> 2] = c[(c[M >> 2] | 0) + 8 >> 2];
	                                c[l + 4 >> 2] = V;
	                                c[l + 8 >> 2] = S;
	                                c[l + 12 >> 2] = T;
	                                c[l + 16 >> 2] = f;
	                                f = l + 20 | 0;
	                                h[k >> 3] = W;
	                                c[f >> 2] = c[k >> 2];
	                                c[f + 4 >> 2] = c[k + 4 >> 2];
	                                JT(L, 50, 171768, l) | 0;
	                                PH(c[M >> 2] | 0);
	                                break
	                            }
	                            c[m >> 2] = -1;
	                            P = c[m >> 2] | 0;
	                            i = j;
	                            return P | 0
	                        } else {
	                            f = c[(c[n >> 2] | 0) + 12 >> 2] & 15;
	                            T = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31;
	                            S = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31;
	                            V = (c[(c[n >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63;
	                            W = +h[(c[n >> 2] | 0) + 16 >> 3];
	                            c[l >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                            c[l + 4 >> 2] = f;
	                            c[l + 8 >> 2] = T;
	                            c[l + 12 >> 2] = S;
	                            c[l + 16 >> 2] = V;
	                            V = l + 20 | 0;
	                            h[k >> 3] = W;
	                            c[V >> 2] = c[k >> 2];
	                            c[V + 4 >> 2] = c[k + 4 >> 2];
	                            JT(L, 50, 171808, l) | 0
	                        } while (0);
	                        V = my(L) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        break
	                    }
	                    case 1:
	                    {
	                        if (!(c[(c[n >> 2] | 0) + 8 >> 2] | 0)) {
	                            V = my(171424) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            break a
	                        } else {
	                            V = my(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            break a
	                        }
	                        break
	                    }
	                    case 21:
	                    {
	                        if (c[(c[n >> 2] | 0) + 12 >> 2] | 0) {
	                            V = my(171432) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            V = By(c[c[o >> 2] >> 2] | 0, c[(c[n >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            V = By(c[c[o >> 2] >> 2] | 0, 171440) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            V = By(c[c[o >> 2] >> 2] | 0, c[(c[n >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            c[c[o >> 2] >> 2] = V;
	                            break a
	                        }
	                        V = my(c[(c[n >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        c[m >> 2] = 0;
	                        P = c[m >> 2] | 0;
	                        i = j;
	                        return P | 0
	                    }
	                    default:
	                    {
	                        V = my(171856) | 0;
	                        c[c[o >> 2] >> 2] = V;
	                        c[m >> 2] = 1;
	                        P = c[m >> 2] | 0;
	                        i = j;
	                        return P | 0
	                    }
	                } while (0);
	                if (!(c[c[o >> 2] >> 2] | 0)) {
	                    c[m >> 2] = -1;
	                    P = c[m >> 2] | 0;
	                    i = j;
	                    return P | 0
	                } else {
	                    c[m >> 2] = 0;
	                    P = c[m >> 2] | 0;
	                    i = j;
	                    return P | 0
	                }
	                return 0
	            }

	            function dI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0))c[d >> 2] = 0; else c[d >> 2] = c[c[e >> 2] >> 2];
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function eI(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](120) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    gI(0, 172376);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                d = (c[k >> 2] | 0) + 0 | 0;
	                b = d + 120 | 0;
	                do {
	                    c[d >> 2] = 0;
	                    d = d + 4 | 0
	                } while ((d | 0) < (b | 0));
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                c[(c[k >> 2] | 0) + 112 >> 2] = 172416;
	                c[c[k >> 2] >> 2] = 1;
	                c[(c[k >> 2] | 0) + 64 >> 2] = c[j >> 2];
	                c[(c[k >> 2] | 0) + 52 >> 2] = 6;
	                switch (c[h >> 2] | 0) {
	                    case 28:
	                    case 21:
	                    case 44:
	                    case 43:
	                    case 29:
	                    case 15:
	                    case 14:
	                    case 13:
	                    case 12:
	                    case 5:
	                    case 7:
	                    case 6:
	                    case 9:
	                    case 8:
	                    case 4:
	                    case 11:
	                    case 10:
	                    case 3:
	                    case 1:
	                    {
	                        j = (c[k >> 2] | 0) + 48 | 0;
	                        c[j >> 2] = c[j >> 2] | 16384;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                switch (c[h >> 2] | 0) {
	                    case 46:
	                    case 45:
	                        break;
	                    case 27:
	                    case 19:
	                    case 25:
	                    {
	                        j = (c[k >> 2] | 0) + 48 | 0;
	                        c[j >> 2] = c[j >> 2] | 64;
	                        j = oI(1) | 0;
	                        c[(c[k >> 2] | 0) + 68 >> 2] = j;
	                        j = (c[k >> 2] | 0) + 48 | 0;
	                        c[j >> 2] = c[j >> 2] | 134217728;
	                        break
	                    }
	                    default:
	                    {
	                        j = (c[k >> 2] | 0) + 48 | 0;
	                        c[j >> 2] = c[j >> 2] | 256
	                    }
	                }
	                Nj(c[42592] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 172416, c[k >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 88 >> 2] = c[h >> 2];
	                c[f >> 2] = c[k >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function fI() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = 0;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    gI(0, 172344);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    f = c[d >> 2] | 0;
	                    c[f + 0 >> 2] = 0;
	                    c[f + 4 >> 2] = 0;
	                    c[f + 8 >> 2] = 0;
	                    c[f + 12 >> 2] = 0;
	                    c[f + 16 >> 2] = 0;
	                    c[f + 20 >> 2] = 0;
	                    c[f + 24 >> 2] = 0;
	                    c[c[d >> 2] >> 2] = 25;
	                    c[(c[d >> 2] | 0) + 16 >> 2] = 1;
	                    c[(c[d >> 2] | 0) + 20 >> 2] = 1;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function gI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                ce(15, 2, c[e >> 2] | 0, 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function hI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = c[f >> 2] | 0;
	                    c[a + 0 >> 2] = 0;
	                    c[a + 4 >> 2] = 0;
	                    c[a + 8 >> 2] = 0;
	                    c[a + 12 >> 2] = 0;
	                    c[a + 16 >> 2] = 0;
	                    c[a + 20 >> 2] = 0;
	                    c[a + 24 >> 2] = 0;
	                    c[a + 28 >> 2] = 0;
	                    c[c[f >> 2] >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function iI(e, f, j, k, l, m, n, o, p) {
	                e = e | 0;
	                f = f | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                m = m | 0;
	                n = n | 0;
	                o = o | 0;
	                p = p | 0;
	                var q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0, Ca = 0, Da = 0, Ea = 0, Fa = 0, Ga = 0, Ha = 0, Ia = 0, Ja = 0, Ka = 0, La = 0, Ma = 0, Na = 0, Oa = 0, Pa = 0, Qa = 0, Ra = 0, Sa = 0, Ta = 0, Ua = 0, Va = 0, Wa = 0, Xa = 0, Ya = 0, Za = 0, _a = 0, $a = 0, ab = 0;
	                q = i;
	                i = i + 352 | 0;
	                r = q;
	                s = q + 316 | 0;
	                t = q + 312 | 0;
	                u = q + 308 | 0;
	                v = q + 304 | 0;
	                w = q + 300 | 0;
	                x = q + 296 | 0;
	                y = q + 292 | 0;
	                z = q + 288 | 0;
	                A = q + 284 | 0;
	                B = q + 280 | 0;
	                C = q + 276 | 0;
	                D = q + 272 | 0;
	                E = q + 268 | 0;
	                F = q + 264 | 0;
	                G = q + 260 | 0;
	                H = q + 256 | 0;
	                I = q + 252 | 0;
	                J = q + 248 | 0;
	                K = q + 244 | 0;
	                L = q + 240 | 0;
	                M = q + 320 | 0;
	                N = q + 236 | 0;
	                O = q + 232 | 0;
	                P = q + 228 | 0;
	                Q = q + 224 | 0;
	                R = q + 220 | 0;
	                S = q + 216 | 0;
	                T = q + 212 | 0;
	                U = q + 208 | 0;
	                V = q + 204 | 0;
	                W = q + 200 | 0;
	                X = q + 196 | 0;
	                Y = q + 192 | 0;
	                Z = q + 188 | 0;
	                _ = q + 184 | 0;
	                $ = q + 180 | 0;
	                aa = q + 176 | 0;
	                ba = q + 172 | 0;
	                ca = q + 168 | 0;
	                da = q + 164 | 0;
	                ea = q + 160 | 0;
	                fa = q + 156 | 0;
	                ga = q + 152 | 0;
	                ha = q + 148 | 0;
	                ia = q + 144 | 0;
	                ja = q + 140 | 0;
	                ka = q + 136 | 0;
	                la = q + 132 | 0;
	                ma = q + 128 | 0;
	                na = q + 124 | 0;
	                oa = q + 120 | 0;
	                pa = q + 116 | 0;
	                qa = q + 112 | 0;
	                ra = q + 108 | 0;
	                sa = q + 104 | 0;
	                ta = q + 100 | 0;
	                ua = q + 96 | 0;
	                va = q + 92 | 0;
	                wa = q + 88 | 0;
	                xa = q + 84 | 0;
	                ya = q + 80 | 0;
	                za = q + 76 | 0;
	                Aa = q + 72 | 0;
	                Ba = q + 68 | 0;
	                Ca = q + 64 | 0;
	                Da = q + 60 | 0;
	                Ea = q + 56 | 0;
	                Fa = q + 52 | 0;
	                Ga = q + 48 | 0;
	                Ha = q + 44 | 0;
	                Ia = q + 40 | 0;
	                Ja = q + 36 | 0;
	                Ka = q + 32 | 0;
	                La = q + 28 | 0;
	                Ma = q + 24 | 0;
	                Na = q + 20 | 0;
	                Oa = q + 16 | 0;
	                Pa = q + 12 | 0;
	                Qa = q + 8 | 0;
	                c[t >> 2] = e;
	                c[u >> 2] = f;
	                c[v >> 2] = j;
	                c[w >> 2] = k;
	                c[x >> 2] = l;
	                c[y >> 2] = m;
	                c[z >> 2] = n;
	                c[A >> 2] = o;
	                c[B >> 2] = p;
	                c[D >> 2] = 0;
	                c[E >> 2] = 0;
	                if (!(c[42590] | 0))FH();
	                if (!(c[t >> 2] | 0)) {
	                    c[s >> 2] = -1;
	                    Ra = c[s >> 2] | 0;
	                    i = q;
	                    return Ra | 0
	                }
	                if (!(c[u >> 2] | 0))c[u >> 2] = 171424;
	                if (c[v >> 2] | 0)c[c[v >> 2] >> 2] = 0;
	                if ((((c[x >> 2] | 0) == 0 & (c[u >> 2] | 0) != 0 ? (c[(c[t >> 2] | 0) + 88 >> 2] | 0) != 1 : 0) ? (c[(c[t >> 2] | 0) + 88 >> 2] | 0) != 45 : 0) ? (c[(c[t >> 2] | 0) + 88 >> 2] | 0) != 46 : 0) {
	                    x = c[u >> 2] | 0;
	                    if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 2)c[D >> 2] = RH(x) | 0; else c[D >> 2] = SH(x) | 0;
	                    if (c[D >> 2] | 0)c[u >> 2] = c[D >> 2]
	                }
	                a:do switch (c[(c[t >> 2] | 0) + 88 >> 2] | 0) {
	                    case 11:
	                    case 10:
	                    case 9:
	                    case 8:
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 4:
	                    {
	                        c[E >> 2] = qI(c[(c[t >> 2] | 0) + 88 >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[z >> 2] | 0) | 0;
	                        Sa = 571;
	                        break
	                    }
	                    case 14:
	                    case 13:
	                    {
	                        c[O >> 2] = c[u >> 2];
	                        c[P >> 2] = 0;
	                        c[Q >> 2] = 0;
	                        c[R >> 2] = 0;
	                        b:do if (c[z >> 2] | 0)while (1) {
	                            do if ((d[c[O >> 2] >> 0] | 0) != 32) {
	                                if (9 <= (d[c[O >> 2] >> 0] | 0) ? (d[c[O >> 2] >> 0] | 0) <= 10 : 0)break;
	                                if ((d[c[O >> 2] >> 0] | 0) != 13)break b
	                            } while (0);
	                            c[O >> 2] = (c[O >> 2] | 0) + 1
	                        } while (0);
	                        if (((d[c[O >> 2] >> 0] | 0) == 78 ? (d[(c[O >> 2] | 0) + 1 >> 0] | 0) == 97 : 0) ? (d[(c[O >> 2] | 0) + 2 >> 0] | 0) == 78 : 0) {
	                            c[O >> 2] = (c[O >> 2] | 0) + 3;
	                            if (d[c[O >> 2] >> 0] | 0) {
	                                Sa = 577;
	                                break a
	                            }
	                            if (!(c[v >> 2] | 0)) {
	                                Sa = 580;
	                                break a
	                            }
	                            do if ((c[t >> 2] | 0) == (c[42690] | 0)) {
	                                c[C >> 2] = hI(13) | 0;
	                                if (c[C >> 2] | 0) {
	                                    g[(c[C >> 2] | 0) + 8 >> 2] = +h[15984];
	                                    break
	                                } else {
	                                    PH(c[C >> 2] | 0);
	                                    Sa = 583;
	                                    break a
	                                }
	                            } else {
	                                c[C >> 2] = hI(14) | 0;
	                                if (c[C >> 2] | 0) {
	                                    h[(c[C >> 2] | 0) + 8 >> 3] = +h[15984];
	                                    break
	                                } else {
	                                    PH(c[C >> 2] | 0);
	                                    Sa = 583;
	                                    break a
	                                }
	                            } while (0);
	                            c[c[v >> 2] >> 2] = c[C >> 2];
	                            Sa = 580;
	                            break a
	                        }
	                        if ((d[c[O >> 2] >> 0] | 0) == 45) {
	                            c[P >> 2] = 1;
	                            c[O >> 2] = (c[O >> 2] | 0) + 1
	                        }
	                        if (((d[c[O >> 2] >> 0] | 0) == 73 ? (d[(c[O >> 2] | 0) + 1 >> 0] | 0) == 78 : 0) ? (d[(c[O >> 2] | 0) + 2 >> 0] | 0) == 70 : 0) {
	                            c[O >> 2] = (c[O >> 2] | 0) + 3;
	                            if (d[c[O >> 2] >> 0] | 0) {
	                                Sa = 577;
	                                break a
	                            }
	                            if (!(c[v >> 2] | 0)) {
	                                Sa = 580;
	                                break a
	                            }
	                            do if ((c[t >> 2] | 0) == (c[42690] | 0)) {
	                                c[C >> 2] = hI(13) | 0;
	                                if (!(c[C >> 2] | 0)) {
	                                    PH(c[C >> 2] | 0);
	                                    Sa = 583;
	                                    break a
	                                }
	                                if (c[P >> 2] | 0) {
	                                    g[(c[C >> 2] | 0) + 8 >> 2] = +h[15986];
	                                    break
	                                } else {
	                                    g[(c[C >> 2] | 0) + 8 >> 2] = +h[15985];
	                                    break
	                                }
	                            } else {
	                                c[C >> 2] = hI(14) | 0;
	                                if (!(c[C >> 2] | 0)) {
	                                    PH(c[C >> 2] | 0);
	                                    Sa = 583;
	                                    break a
	                                }
	                                if (c[P >> 2] | 0) {
	                                    h[(c[C >> 2] | 0) + 8 >> 3] = +h[15986];
	                                    break
	                                } else {
	                                    h[(c[C >> 2] | 0) + 8 >> 3] = +h[15985];
	                                    break
	                                }
	                            } while (0);
	                            c[c[v >> 2] >> 2] = c[C >> 2];
	                            Sa = 580;
	                            break a
	                        }
	                        if ((c[P >> 2] | 0) == 0 ? (d[c[O >> 2] >> 0] | 0) == 43 : 0)c[O >> 2] = (c[O >> 2] | 0) + 1;
	                        if (((d[c[O >> 2] >> 0] | 0) != 0 ? (d[c[O >> 2] >> 0] | 0) != 43 : 0) ? (d[c[O >> 2] >> 0] | 0) != 45 : 0) {
	                            while (1) {
	                                if ((d[c[O >> 2] >> 0] | 0) >= 48)Ta = (d[c[O >> 2] >> 0] | 0) <= 57; else Ta = 0;
	                                Ua = c[O >> 2] | 0;
	                                if (!Ta)break;
	                                c[O >> 2] = Ua + 1;
	                                c[Q >> 2] = (c[Q >> 2] | 0) + 1
	                            }
	                            c:do if ((d[Ua >> 0] | 0) == 46) {
	                                c[O >> 2] = (c[O >> 2] | 0) + 1;
	                                while (1) {
	                                    if ((d[c[O >> 2] >> 0] | 0) < 48)break c;
	                                    if ((d[c[O >> 2] >> 0] | 0) > 57)break c;
	                                    c[O >> 2] = (c[O >> 2] | 0) + 1;
	                                    c[R >> 2] = (c[R >> 2] | 0) + 1
	                                }
	                            } while (0);
	                            if (!((c[Q >> 2] | 0) == 0 & (c[R >> 2] | 0) == 0)) {
	                                if (!((d[c[O >> 2] >> 0] | 0) != 101 ? (d[c[O >> 2] >> 0] | 0) != 69 : 0))Sa = 168;
	                                d:do if ((Sa | 0) == 168) {
	                                    c[O >> 2] = (c[O >> 2] | 0) + 1;
	                                    if (!((d[c[O >> 2] >> 0] | 0) != 45 ? (d[c[O >> 2] >> 0] | 0) != 43 : 0))c[O >> 2] = (c[O >> 2] | 0) + 1;
	                                    while (1) {
	                                        if ((d[c[O >> 2] >> 0] | 0) < 48)break d;
	                                        if ((d[c[O >> 2] >> 0] | 0) > 57)break d;
	                                        c[O >> 2] = (c[O >> 2] | 0) + 1
	                                    }
	                                } while (0);
	                                e:do if (c[z >> 2] | 0)while (1) {
	                                    do if ((d[c[O >> 2] >> 0] | 0) != 32) {
	                                        if (9 <= (d[c[O >> 2] >> 0] | 0) ? (d[c[O >> 2] >> 0] | 0) <= 10 : 0)break;
	                                        if ((d[c[O >> 2] >> 0] | 0) != 13)break e
	                                    } while (0);
	                                    c[O >> 2] = (c[O >> 2] | 0) + 1
	                                } while (0);
	                                if (!(d[c[O >> 2] >> 0] | 0))if (c[v >> 2] | 0)if ((c[t >> 2] | 0) == (c[42690] | 0)) {
	                                    c[C >> 2] = hI(13) | 0;
	                                    if (!(c[C >> 2] | 0)) {
	                                        Sa = 583;
	                                        break a
	                                    }
	                                    x = c[u >> 2] | 0;
	                                    c[r >> 2] = (c[C >> 2] | 0) + 8;
	                                    p = (bT(x, 172216, r) | 0) == 1;
	                                    x = c[C >> 2] | 0;
	                                    if (p) {
	                                        c[c[v >> 2] >> 2] = x;
	                                        Sa = 580;
	                                        break a
	                                    } else {
	                                        PH(x);
	                                        Sa = 577;
	                                        break a
	                                    }
	                                } else {
	                                    c[C >> 2] = hI(14) | 0;
	                                    if (!(c[C >> 2] | 0)) {
	                                        Sa = 583;
	                                        break a
	                                    }
	                                    x = c[u >> 2] | 0;
	                                    c[r >> 2] = (c[C >> 2] | 0) + 8;
	                                    p = (bT(x, 172224, r) | 0) == 1;
	                                    x = c[C >> 2] | 0;
	                                    if (p) {
	                                        c[c[v >> 2] >> 2] = x;
	                                        Sa = 580;
	                                        break a
	                                    } else {
	                                        PH(x);
	                                        Sa = 577;
	                                        break a
	                                    }
	                                } else Sa = 580; else Sa = 577
	                            } else Sa = 577
	                        } else Sa = 577;
	                        break
	                    }
	                    case 2:
	                    {
	                        f:do if (c[z >> 2] | 0) {
	                            if (c[A >> 2] | 0) {
	                                x = c[u >> 2] | 0;
	                                if ((c[y >> 2] | 0) == 3)c[D >> 2] = SH(x) | 0; else c[D >> 2] = RH(x) | 0;
	                                if (c[D >> 2] | 0)c[u >> 2] = c[D >> 2]
	                            }
	                        } else {
	                            c[G >> 2] = c[u >> 2];
	                            while (1) {
	                                if (!(d[c[G >> 2] >> 0] | 0))break f;
	                                if ((d[c[G >> 2] >> 0] | 0) == 13) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((d[c[G >> 2] >> 0] | 0) == 10) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((d[c[G >> 2] >> 0] | 0) == 9) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                c[G >> 2] = (c[G >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        if (c[v >> 2] | 0) {
	                            c[C >> 2] = hI(2) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580;
	                        break
	                    }
	                    case 46:
	                    case 45:
	                    {
	                        if ((c[B >> 2] | 0) != 0 & (c[v >> 2] | 0) != 0) {
	                            c[C >> 2] = hI(46) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[H >> 2] = c[u >> 2];
	                        c[N >> 2] = M;
	                        if ((c[H >> 2] | 0) != 0 ? (d[c[H >> 2] >> 0] | 0) != 0 : 0) {
	                            g:do if (c[z >> 2] | 0)while (1) {
	                                do if ((d[c[H >> 2] >> 0] | 0) != 32) {
	                                    if (9 <= (d[c[H >> 2] >> 0] | 0) ? (d[c[H >> 2] >> 0] | 0) <= 10 : 0)break;
	                                    if ((d[c[H >> 2] >> 0] | 0) != 13)break g
	                                } while (0);
	                                c[H >> 2] = (c[H >> 2] | 0) + 1
	                            } while (0);
	                            c[J >> 2] = 0;
	                            if ((d[c[H >> 2] >> 0] | 0) != 45) {
	                                if ((d[c[H >> 2] >> 0] | 0) == 43)c[H >> 2] = (c[H >> 2] | 0) + 1
	                            } else {
	                                c[J >> 2] = 1;
	                                c[H >> 2] = (c[H >> 2] | 0) + 1
	                            }
	                            if (d[c[H >> 2] >> 0] | 0) {
	                                c[I >> 2] = 0;
	                                c[K >> 2] = -1;
	                                c[L >> 2] = 0;
	                                while (1) {
	                                    Va = c[H >> 2] | 0;
	                                    if ((d[c[H >> 2] >> 0] | 0) != 48)break;
	                                    c[H >> 2] = Va + 1;
	                                    c[L >> 2] = 1
	                                }
	                                h:do if (d[Va >> 0] | 0) {
	                                    while (1) {
	                                        if ((d[c[H >> 2] >> 0] | 0) < 48)break;
	                                        if ((d[c[H >> 2] >> 0] | 0) > 57)break;
	                                        x = c[H >> 2] | 0;
	                                        c[H >> 2] = x + 1;
	                                        p = a[x >> 0] | 0;
	                                        x = c[N >> 2] | 0;
	                                        c[N >> 2] = x + 1;
	                                        a[x >> 0] = p;
	                                        c[I >> 2] = (c[I >> 2] | 0) + 1;
	                                        if ((c[I >> 2] | 0) >>> 0 >= 24)break h
	                                    }
	                                    if ((d[c[H >> 2] >> 0] | 0) == 46) {
	                                        c[H >> 2] = (c[H >> 2] | 0) + 1;
	                                        c[K >> 2] = c[I >> 2];
	                                        do {
	                                            if ((d[c[H >> 2] >> 0] | 0) < 48)break;
	                                            if ((d[c[H >> 2] >> 0] | 0) > 57)break;
	                                            p = c[H >> 2] | 0;
	                                            c[H >> 2] = p + 1;
	                                            x = a[p >> 0] | 0;
	                                            p = c[N >> 2] | 0;
	                                            c[N >> 2] = p + 1;
	                                            a[p >> 0] = x;
	                                            c[I >> 2] = (c[I >> 2] | 0) + 1
	                                        } while ((c[I >> 2] | 0) >>> 0 < 24);
	                                        if (!((c[I >> 2] | 0) != 0 | (c[L >> 2] | 0) != 0)) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                    }
	                                } while (0);
	                                i:do if (c[z >> 2] | 0)while (1) {
	                                    do if ((d[c[H >> 2] >> 0] | 0) != 32) {
	                                        if (9 <= (d[c[H >> 2] >> 0] | 0) ? (d[c[H >> 2] >> 0] | 0) <= 10 : 0)break;
	                                        if ((d[c[H >> 2] >> 0] | 0) != 13)break i
	                                    } while (0);
	                                    c[H >> 2] = (c[H >> 2] | 0) + 1
	                                } while (0);
	                                if (!(d[c[H >> 2] >> 0] | 0))if ((c[v >> 2] | 0) != 0 ? (c[C >> 2] = hI(3) | 0, (c[C >> 2] | 0) != 0) : 0) {
	                                    if (c[I >> 2] | 0) {
	                                        j:do if ((c[K >> 2] | 0) != -1)while (1) {
	                                            if ((c[I >> 2] | 0) == (c[K >> 2] | 0))break j;
	                                            if ((d[(c[N >> 2] | 0) + -1 >> 0] | 0) != 48)break j;
	                                            c[N >> 2] = (c[N >> 2] | 0) + -1;
	                                            c[I >> 2] = (c[I >> 2] | 0) + -1
	                                        } while (0);
	                                        if (c[I >> 2] | 0) {
	                                            a[c[N >> 2] >> 0] = 0;
	                                            c[N >> 2] = M;
	                                            pI(N, (c[C >> 2] | 0) + 8 | 0, (c[C >> 2] | 0) + 12 | 0, (c[C >> 2] | 0) + 16 | 0) | 0
	                                        }
	                                    }
	                                    x = (c[C >> 2] | 0) + 24 | 0;
	                                    b[x >> 1] = b[x >> 1] & -2 | c[J >> 2] & 1;
	                                    do if (c[I >> 2] | 0) {
	                                        x = (c[C >> 2] | 0) + 24 | 0;
	                                        b[x >> 1] = b[x >> 1] & 255 | (c[I >> 2] & 255) << 8 & 65535;
	                                        if ((c[K >> 2] | 0) == -1) {
	                                            x = (c[C >> 2] | 0) + 24 | 0;
	                                            b[x >> 1] = b[x >> 1] & -255;
	                                            break
	                                        } else {
	                                            x = (c[C >> 2] | 0) + 24 | 0;
	                                            b[x >> 1] = b[x >> 1] & -255 | ((c[I >> 2] | 0) - (c[K >> 2] | 0) & 127) << 1 & 65535;
	                                            break
	                                        }
	                                    } else {
	                                        x = (c[C >> 2] | 0) + 24 | 0;
	                                        b[x >> 1] = b[x >> 1] & 255 | 256
	                                    } while (0);
	                                    c[c[v >> 2] >> 2] = c[C >> 2];
	                                    Sa = 580
	                                } else Sa = 580; else Sa = 577
	                            } else Sa = 577
	                        } else Sa = 577;
	                        break
	                    }
	                    case 1:
	                    {
	                        k:do if (!(c[z >> 2] | 0)) {
	                            c[F >> 2] = c[u >> 2];
	                            if ((c[y >> 2] | 0) == 2)while (1) {
	                                if (!(d[c[F >> 2] >> 0] | 0))break k;
	                                if ((d[c[F >> 2] >> 0] | 0) == 13) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((d[c[F >> 2] >> 0] | 0) == 10) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((d[c[F >> 2] >> 0] | 0) == 9) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                c[F >> 2] = (c[F >> 2] | 0) + 1
	                            }
	                            if ((c[y >> 2] | 0) == 3)while (1) {
	                                if (!(d[c[F >> 2] >> 0] | 0))break k;
	                                if ((d[c[F >> 2] >> 0] | 0) == 13) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((d[c[F >> 2] >> 0] | 0) == 10) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((d[c[F >> 2] >> 0] | 0) == 9) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                x = (d[c[F >> 2] >> 0] | 0) == 32;
	                                c[F >> 2] = (c[F >> 2] | 0) + 1;
	                                if (!x)continue;
	                                if ((d[c[F >> 2] >> 0] | 0) == 32) {
	                                    Sa = 577;
	                                    break a
	                                }
	                            }
	                        } while (0);
	                        if ((c[B >> 2] | 0) != 0 & (c[v >> 2] | 0) != 0) {
	                            if (c[A >> 2] | 0) {
	                                if ((c[y >> 2] | 0) != 3) {
	                                    if ((c[y >> 2] | 0) == 2)c[D >> 2] = RH(c[u >> 2] | 0) | 0
	                                } else c[D >> 2] = SH(c[u >> 2] | 0) | 0;
	                                if (c[D >> 2] | 0)c[u >> 2] = c[D >> 2]
	                            }
	                            c[C >> 2] = hI(1) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[E >> 2] = rI(c[t >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[z >> 2] | 0) | 0;
	                        Sa = 571;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[S >> 2] = c[u >> 2];
	                        do if (c[z >> 2] | 0) {
	                            while (1) {
	                                do if ((d[c[S >> 2] >> 0] | 0) == 32)Wa = 1; else {
	                                    if (9 <= (d[c[S >> 2] >> 0] | 0) ? (d[c[S >> 2] >> 0] | 0) <= 10 : 0) {
	                                        Wa = 1;
	                                        break
	                                    }
	                                    Wa = (d[c[S >> 2] >> 0] | 0) == 13
	                                } while (0);
	                                Xa = c[S >> 2] | 0;
	                                if (!Wa)break;
	                                c[S >> 2] = Xa + 1
	                            }
	                            do if ((d[Xa >> 0] | 0) == 48) {
	                                c[E >> 2] = 0;
	                                c[S >> 2] = (c[S >> 2] | 0) + 1
	                            } else {
	                                if ((d[c[S >> 2] >> 0] | 0) == 49) {
	                                    c[E >> 2] = 1;
	                                    c[S >> 2] = (c[S >> 2] | 0) + 1;
	                                    break
	                                }
	                                x = c[S >> 2] | 0;
	                                if ((d[c[S >> 2] >> 0] | 0) == 116) {
	                                    c[S >> 2] = x + 1;
	                                    p = c[S >> 2] | 0;
	                                    c[S >> 2] = p + 1;
	                                    if ((d[p >> 0] | 0) != 114) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    p = c[S >> 2] | 0;
	                                    c[S >> 2] = p + 1;
	                                    if ((d[p >> 0] | 0) != 117) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    p = c[S >> 2] | 0;
	                                    c[S >> 2] = p + 1;
	                                    if ((d[p >> 0] | 0) != 101) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    c[E >> 2] = 1;
	                                    break
	                                }
	                                if ((d[x >> 0] | 0) != 102) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                c[S >> 2] = (c[S >> 2] | 0) + 1;
	                                x = c[S >> 2] | 0;
	                                c[S >> 2] = x + 1;
	                                if ((d[x >> 0] | 0) != 97) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                x = c[S >> 2] | 0;
	                                c[S >> 2] = x + 1;
	                                if ((d[x >> 0] | 0) != 108) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                x = c[S >> 2] | 0;
	                                c[S >> 2] = x + 1;
	                                if ((d[x >> 0] | 0) != 115) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                x = c[S >> 2] | 0;
	                                c[S >> 2] = x + 1;
	                                if ((d[x >> 0] | 0) != 101) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                c[E >> 2] = 0
	                            } while (0);
	                            if (d[c[S >> 2] >> 0] | 0) {
	                                while (1) {
	                                    do if ((d[c[S >> 2] >> 0] | 0) == 32)Ya = 1; else {
	                                        if (9 <= (d[c[S >> 2] >> 0] | 0) ? (d[c[S >> 2] >> 0] | 0) <= 10 : 0) {
	                                            Ya = 1;
	                                            break
	                                        }
	                                        Ya = (d[c[S >> 2] >> 0] | 0) == 13
	                                    } while (0);
	                                    Za = c[S >> 2] | 0;
	                                    if (!Ya)break;
	                                    c[S >> 2] = Za + 1
	                                }
	                                if (d[Za >> 0] | 0) {
	                                    Sa = 577;
	                                    break a
	                                }
	                            }
	                        } else {
	                            if ((d[c[S >> 2] >> 0] | 0) == 48 ? (d[(c[S >> 2] | 0) + 1 >> 0] | 0) == 0 : 0) {
	                                c[E >> 2] = 0;
	                                break
	                            }
	                            if ((d[c[S >> 2] >> 0] | 0) == 49 ? (d[(c[S >> 2] | 0) + 1 >> 0] | 0) == 0 : 0) {
	                                c[E >> 2] = 1;
	                                break
	                            }
	                            if (((((d[c[S >> 2] >> 0] | 0) == 116 ? (d[(c[S >> 2] | 0) + 1 >> 0] | 0) == 114 : 0) ? (d[(c[S >> 2] | 0) + 2 >> 0] | 0) == 117 : 0) ? (d[(c[S >> 2] | 0) + 3 >> 0] | 0) == 101 : 0) ? (d[(c[S >> 2] | 0) + 4 >> 0] | 0) == 0 : 0) {
	                                c[E >> 2] = 1;
	                                break
	                            }
	                            if ((d[c[S >> 2] >> 0] | 0) != 102) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[(c[S >> 2] | 0) + 1 >> 0] | 0) != 97) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[(c[S >> 2] | 0) + 2 >> 0] | 0) != 108) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[(c[S >> 2] | 0) + 3 >> 0] | 0) != 115) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[(c[S >> 2] | 0) + 4 >> 0] | 0) != 101) {
	                                Sa = 577;
	                                break a
	                            }
	                            if (d[(c[S >> 2] | 0) + 5 >> 0] | 0) {
	                                Sa = 577;
	                                break a
	                            }
	                            c[E >> 2] = 0
	                        } while (0);
	                        if (c[v >> 2] | 0) {
	                            c[C >> 2] = hI(15) | 0;
	                            if (c[C >> 2] | 0) {
	                                c[(c[C >> 2] | 0) + 8 >> 2] = c[E >> 2];
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[T >> 2] = c[u >> 2];
	                        l:do if (!(c[z >> 2] | 0))while (1) {
	                            if (!(d[c[T >> 2] >> 0] | 0))break l;
	                            if ((d[c[T >> 2] >> 0] | 0) == 13) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[c[T >> 2] >> 0] | 0) == 10) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[c[T >> 2] >> 0] | 0) == 9) {
	                                Sa = 577;
	                                break a
	                            }
	                            x = (d[c[T >> 2] >> 0] | 0) == 32;
	                            c[T >> 2] = (c[T >> 2] | 0) + 1;
	                            if (!x)continue;
	                            if (!(d[c[T >> 2] >> 0] | 0)) {
	                                Sa = 577;
	                                break a
	                            }
	                            if ((d[c[T >> 2] >> 0] | 0) == 32) {
	                                Sa = 577;
	                                break a
	                            }
	                        } while (0);
	                        if (c[v >> 2] | 0) {
	                            c[C >> 2] = hI(16) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580;
	                        break
	                    }
	                    case 17:
	                    {
	                        if ((c[z >> 2] | 0) != 0 ? (c[D >> 2] = SH(c[u >> 2] | 0) | 0, (c[D >> 2] | 0) != 0) : 0)c[u >> 2] = c[D >> 2];
	                        if ((Ne(c[u >> 2] | 0) | 0) == 1)if (c[v >> 2] | 0) {
	                            c[C >> 2] = hI(17) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580; else Sa = 577;
	                        break
	                    }
	                    case 18:
	                    {
	                        if (!(Hh(c[u >> 2] | 0, 1) | 0))if (c[v >> 2] | 0) {
	                            c[C >> 2] = hI(18) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 583
	                        } else Sa = 580; else Sa = 577;
	                        break
	                    }
	                    case 20:
	                    {
	                        c[E >> 2] = Gh(c[u >> 2] | 0, 1) | 0;
	                        if ((c[E >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0 & (c[u >> 2] | 0) != 0) {
	                            c[C >> 2] = hI(20) | 0;
	                            if (c[C >> 2] | 0) {
	                                c[U >> 2] = c[u >> 2];
	                                while (1) {
	                                    do if ((d[c[U >> 2] >> 0] | 0) == 32)_a = 1; else {
	                                        if (9 <= (d[c[U >> 2] >> 0] | 0) ? (d[c[U >> 2] >> 0] | 0) <= 10 : 0) {
	                                            _a = 1;
	                                            break
	                                        }
	                                        _a = (d[c[U >> 2] >> 0] | 0) == 13
	                                    } while (0);
	                                    $a = c[U >> 2] | 0;
	                                    if (!_a)break;
	                                    c[U >> 2] = $a + 1
	                                }
	                                c[V >> 2] = $a;
	                                while (1) {
	                                    if (!(d[c[V >> 2] >> 0] | 0))break;
	                                    do if ((d[c[V >> 2] >> 0] | 0) == 32)ab = 1; else {
	                                        if (9 <= (d[c[V >> 2] >> 0] | 0) ? (d[c[V >> 2] >> 0] | 0) <= 10 : 0) {
	                                            ab = 1;
	                                            break
	                                        }
	                                        ab = (d[c[V >> 2] >> 0] | 0) == 13
	                                    } while (0);
	                                    if (!(ab ^ 1))break;
	                                    c[V >> 2] = (c[V >> 2] | 0) + 1
	                                }
	                                x = ly(c[U >> 2] | 0, (c[V >> 2] | 0) - (c[U >> 2] | 0) | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 571
	                            } else Sa = 583
	                        } else Sa = 571;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[E >> 2] = sI(c[42822] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[w >> 2] | 0) | 0;
	                        if ((c[E >> 2] | 0) > 0) {
	                            c[E >> 2] = 0;
	                            Sa = 571;
	                            break a
	                        } else {
	                            c[E >> 2] = 1;
	                            Sa = 571;
	                            break a
	                        }
	                        break
	                    }
	                    case 21:
	                    {
	                        c[W >> 2] = 0;
	                        c[X >> 2] = 0;
	                        c[E >> 2] = Fh(c[u >> 2] | 0, 1) | 0;
	                        if (c[E >> 2] | 0)Sa = 571; else {
	                            if (c[w >> 2] | 0) {
	                                c[X >> 2] = Ch(c[u >> 2] | 0, Y) | 0;
	                                c[Z >> 2] = cj(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[w >> 2] | 0, c[Y >> 2] | 0) | 0;
	                                if ((c[Z >> 2] | 0) == 0 & (c[Y >> 2] | 0) != 0) {
	                                    zb[c[135736 >> 2] & 511](c[Y >> 2] | 0);
	                                    if (!(c[X >> 2] | 0)) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    zb[c[135736 >> 2] & 511](c[X >> 2] | 0);
	                                    Sa = 577;
	                                    break a
	                                }
	                                if (c[Z >> 2] | 0)c[W >> 2] = c[(c[Z >> 2] | 0) + 8 >> 2];
	                                if (c[Y >> 2] | 0)zb[c[135736 >> 2] & 511](c[Y >> 2] | 0)
	                            }
	                            if (!(c[v >> 2] | 0)) {
	                                if (!(c[X >> 2] | 0)) {
	                                    Sa = 571;
	                                    break a
	                                }
	                                zb[c[135736 >> 2] & 511](c[X >> 2] | 0);
	                                Sa = 571;
	                                break a
	                            }
	                            c[C >> 2] = hI(21) | 0;
	                            x = (c[X >> 2] | 0) != 0;
	                            if (!(c[C >> 2] | 0)) {
	                                if (!x) {
	                                    Sa = 583;
	                                    break a
	                                }
	                                zb[c[135736 >> 2] & 511](c[X >> 2] | 0);
	                                Sa = 583;
	                                break a
	                            }
	                            if (x)c[(c[C >> 2] | 0) + 8 >> 2] = c[X >> 2]; else {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x
	                            }
	                            if (c[W >> 2] | 0) {
	                                x = my(c[W >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 12 >> 2] = x
	                            }
	                            c[c[v >> 2] >> 2] = c[C >> 2];
	                            Sa = 571
	                        }
	                        break
	                    }
	                    case 23:
	                    {
	                        c[E >> 2] = Eh(c[u >> 2] | 0, 1) | 0;
	                        if ((c[E >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0) {
	                            c[C >> 2] = hI(23) | 0;
	                            if (!(c[C >> 2] | 0)) {
	                                Sa = 583;
	                                break a
	                            }
	                            x = my(c[u >> 2] | 0) | 0;
	                            c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                            c[c[v >> 2] >> 2] = c[C >> 2]
	                        }
	                        if (((c[E >> 2] | 0) == 0 & (c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) ? (c[_ >> 2] = c[w >> 2], (c[(c[_ >> 2] | 0) + 40 >> 2] | 0) != 2) : 0) {
	                            c[aa >> 2] = tI(c[u >> 2] | 0) | 0;
	                            x = c[(c[w >> 2] | 0) + 32 >> 2] | 0;
	                            if (c[aa >> 2] | 0) {
	                                c[$ >> 2] = Cm(0, x, c[aa >> 2] | 0, c[_ >> 2] | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[aa >> 2] | 0)
	                            } else c[$ >> 2] = Cm(0, x, c[u >> 2] | 0, c[_ >> 2] | 0) | 0;
	                            if (!(c[$ >> 2] | 0)) {
	                                c[E >> 2] = 2;
	                                Sa = 571;
	                                break a
	                            } else {
	                                c[(c[_ >> 2] | 0) + 40 >> 2] = 2;
	                                Sa = 571;
	                                break a
	                            }
	                        } else Sa = 571;
	                        break
	                    }
	                    case 22:
	                    {
	                        c[E >> 2] = Eh(c[u >> 2] | 0, 1) | 0;
	                        if ((c[E >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0) {
	                            c[C >> 2] = hI(22) | 0;
	                            if (c[C >> 2] | 0) {
	                                x = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 571
	                            } else Sa = 583
	                        } else Sa = 571;
	                        break
	                    }
	                    case 24:
	                    {
	                        c[E >> 2] = Eh(c[u >> 2] | 0, 1) | 0;
	                        if ((c[E >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0) {
	                            c[C >> 2] = hI(24) | 0;
	                            if (!(c[C >> 2] | 0)) {
	                                Sa = 583;
	                                break a
	                            }
	                            x = my(c[u >> 2] | 0) | 0;
	                            c[(c[C >> 2] | 0) + 8 >> 2] = x;
	                            c[c[v >> 2] >> 2] = c[C >> 2]
	                        }
	                        if ((c[E >> 2] | 0) == 0 & (c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                            c[ba >> 2] = c[w >> 2];
	                            c[ca >> 2] = tI(c[u >> 2] | 0) | 0;
	                            x = c[(c[w >> 2] | 0) + 32 >> 2] | 0;
	                            if (c[ca >> 2] | 0) {
	                                Im(0, x, c[ca >> 2] | 0, c[ba >> 2] | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[ca >> 2] | 0)
	                            } else Im(0, x, c[u >> 2] | 0, c[ba >> 2] | 0) | 0;
	                            c[(c[ba >> 2] | 0) + 40 >> 2] = 3;
	                            Sa = 571
	                        } else Sa = 571;
	                        break
	                    }
	                    case 25:
	                    {
	                        c[E >> 2] = sI(c[42834] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[w >> 2] | 0) | 0;
	                        if ((c[E >> 2] | 0) < 0)c[E >> 2] = 2; else c[E >> 2] = 0;
	                        if ((c[E >> 2] | 0) == 0 & (c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                            c[da >> 2] = c[w >> 2];
	                            c[(c[da >> 2] | 0) + 40 >> 2] = 4;
	                            Sa = 571
	                        } else Sa = 571;
	                        break
	                    }
	                    case 26:
	                    {
	                        c[E >> 2] = Eh(c[u >> 2] | 0, 1) | 0;
	                        if (!((c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 32 >> 2] | 0) != 0 : 0))c[E >> 2] = 3;
	                        do if (!(c[E >> 2] | 0)) {
	                            c[ea >> 2] = tI(c[u >> 2] | 0) | 0;
	                            x = c[(c[w >> 2] | 0) + 32 >> 2] | 0;
	                            if (c[ea >> 2] | 0) {
	                                c[fa >> 2] = ad(x, c[ea >> 2] | 0) | 0;
	                                zb[c[135736 >> 2] & 511](c[ea >> 2] | 0)
	                            } else c[fa >> 2] = ad(x, c[u >> 2] | 0) | 0;
	                            if ((c[fa >> 2] | 0) != 0 ? (c[(c[fa >> 2] | 0) + 48 >> 2] | 0) == 3 : 0)break;
	                            c[E >> 2] = 4
	                        } while (0);
	                        if ((c[E >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0) {
	                            x = c[33976] | 0;
	                            p = c[33980] | 0;
	                            c[r >> 2] = 171992;
	                            c[r + 4 >> 2] = 2831;
	                            Db[x & 511](p, 171960, r)
	                        }
	                        if ((c[E >> 2] | 0) == 0 & (c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                            c[ga >> 2] = c[w >> 2];
	                            c[(c[ga >> 2] | 0) + 40 >> 2] = 5;
	                            Sa = 571
	                        } else Sa = 571;
	                        break
	                    }
	                    case 27:
	                    {
	                        if ((c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                            c[E >> 2] = sI(c[42838] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[w >> 2] | 0) | 0;
	                            if ((c[E >> 2] | 0) <= 0)c[E >> 2] = 1; else c[E >> 2] = 0;
	                            if (!((c[E >> 2] | 0) == 0 & (c[w >> 2] | 0) != 0)) {
	                                Sa = 571;
	                                break a
	                            }
	                            if ((c[(c[w >> 2] | 0) + 4 >> 2] | 0) != 2) {
	                                Sa = 571;
	                                break a
	                            }
	                            c[ha >> 2] = c[w >> 2];
	                            c[(c[ha >> 2] | 0) + 40 >> 2] = 6;
	                            Sa = 571;
	                            break a
	                        }
	                        if (c[D >> 2] | 0)zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                        c[s >> 2] = 3;
	                        Ra = c[s >> 2] | 0;
	                        i = q;
	                        return Ra | 0
	                    }
	                    case 28:
	                    {
	                        c[ia >> 2] = 0;
	                        c[ja >> 2] = 0;
	                        c[E >> 2] = Fh(c[u >> 2] | 0, 1) | 0;
	                        if ((c[E >> 2] | 0) == 0 & (c[w >> 2] | 0) != 0) {
	                            c[ja >> 2] = Ch(c[u >> 2] | 0, ka) | 0;
	                            do if (c[ka >> 2] | 0) {
	                                c[la >> 2] = cj(c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[w >> 2] | 0, c[ka >> 2] | 0) | 0;
	                                if (!(c[la >> 2] | 0)) {
	                                    c[E >> 2] = 1;
	                                    break
	                                }
	                                if (c[v >> 2] | 0)c[ia >> 2] = my(c[(c[la >> 2] | 0) + 8 >> 2] | 0) | 0
	                            } while (0);
	                            if ((c[ja >> 2] | 0) != 0 ? (c[v >> 2] | 0) == 0 | (c[E >> 2] | 0) != 0 : 0)zb[c[135736 >> 2] & 511](c[ja >> 2] | 0);
	                            if (c[ka >> 2] | 0)zb[c[135736 >> 2] & 511](c[ka >> 2] | 0)
	                        }
	                        if (!((c[w >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 32 >> 2] | 0) != 0 : 0))c[E >> 2] = 3;
	                        do if (!(c[E >> 2] | 0)) {
	                            c[E >> 2] = Pm(0, c[(c[w >> 2] | 0) + 32 >> 2] | 0, c[u >> 2] | 0) | 0;
	                            if ((c[E >> 2] | 0) == 1) {
	                                c[E >> 2] = 0;
	                                break
	                            } else {
	                                c[E >> 2] = 1;
	                                break
	                            }
	                        } while (0);
	                        if ((c[E >> 2] | 0) == 0 & (c[v >> 2] | 0) != 0) {
	                            c[C >> 2] = hI(28) | 0;
	                            p = (c[ja >> 2] | 0) != 0;
	                            if (!(c[C >> 2] | 0)) {
	                                if (p)zb[c[135736 >> 2] & 511](c[ja >> 2] | 0);
	                                if (!(c[ia >> 2] | 0)) {
	                                    Sa = 583;
	                                    break a
	                                }
	                                zb[c[135736 >> 2] & 511](c[ia >> 2] | 0);
	                                Sa = 583;
	                                break a
	                            }
	                            if (p)c[(c[C >> 2] | 0) + 8 >> 2] = c[ja >> 2]; else {
	                                p = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = p
	                            }
	                            if (c[ia >> 2] | 0)c[(c[C >> 2] | 0) + 12 >> 2] = c[ia >> 2];
	                            c[c[v >> 2] >> 2] = c[C >> 2];
	                            Sa = 571
	                        } else Sa = 571;
	                        break
	                    }
	                    case 29:
	                    {
	                        if (d[c[u >> 2] >> 0] | 0) {
	                            if ((c[z >> 2] | 0) != 0 ? (c[D >> 2] = SH(c[u >> 2] | 0) | 0, (c[D >> 2] | 0) != 0) : 0)c[u >> 2] = c[D >> 2];
	                            c[na >> 2] = my(c[u >> 2] | 0) | 0;
	                            c[oa >> 2] = c[na >> 2];
	                            while (1) {
	                                if (!(a[c[oa >> 2] >> 0] | 0))break;
	                                do if ((((((((d[c[oa >> 2] >> 0] | 0) >= 32 ? (d[c[oa >> 2] >> 0] | 0) < 127 : 0) ? (d[c[oa >> 2] >> 0] | 0) != 32 : 0) ? (d[c[oa >> 2] >> 0] | 0) != 60 : 0) ? (d[c[oa >> 2] >> 0] | 0) != 62 : 0) ? (d[c[oa >> 2] >> 0] | 0) != 34 : 0) ? (d[c[oa >> 2] >> 0] | 0) != 123 : 0) ? (d[c[oa >> 2] >> 0] | 0) != 125 : 0) {
	                                    if ((d[c[oa >> 2] >> 0] | 0) == 124) {
	                                        Sa = 409;
	                                        break
	                                    }
	                                    if ((d[c[oa >> 2] >> 0] | 0) == 92) {
	                                        Sa = 409;
	                                        break
	                                    }
	                                    if ((d[c[oa >> 2] >> 0] | 0) == 94) {
	                                        Sa = 409;
	                                        break
	                                    }
	                                    if ((d[c[oa >> 2] >> 0] | 0) == 96) {
	                                        Sa = 409;
	                                        break
	                                    }
	                                    if ((d[c[oa >> 2] >> 0] | 0) == 39)Sa = 409
	                                } else Sa = 409; while (0);
	                                if ((Sa | 0) == 409) {
	                                    Sa = 0;
	                                    a[c[oa >> 2] >> 0] = 95
	                                }
	                                c[oa >> 2] = (c[oa >> 2] | 0) + 1
	                            }
	                            c[ma >> 2] = yl(c[na >> 2] | 0) | 0;
	                            zb[c[135736 >> 2] & 511](c[na >> 2] | 0);
	                            if (!(c[ma >> 2] | 0)) {
	                                Sa = 577;
	                                break a
	                            }
	                            Al(c[ma >> 2] | 0)
	                        }
	                        if (c[v >> 2] | 0) {
	                            c[C >> 2] = hI(29) | 0;
	                            if (!(c[C >> 2] | 0))Sa = 583; else {
	                                p = my(c[u >> 2] | 0) | 0;
	                                c[(c[C >> 2] | 0) + 8 >> 2] = p;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            }
	                        } else Sa = 580;
	                        break
	                    }
	                    case 43:
	                    {
	                        c[pa >> 2] = c[u >> 2];
	                        c[ta >> 2] = 0;
	                        if (c[pa >> 2] | 0) {
	                            m:do if (c[z >> 2] | 0)while (1) {
	                                do if ((d[c[pa >> 2] >> 0] | 0) != 32) {
	                                    if (9 <= (d[c[pa >> 2] >> 0] | 0) ? (d[c[pa >> 2] >> 0] | 0) <= 10 : 0)break;
	                                    if ((d[c[pa >> 2] >> 0] | 0) != 13)break m
	                                } while (0);
	                                c[pa >> 2] = (c[pa >> 2] | 0) + 1
	                            } while (0);
	                            c[qa >> 2] = c[pa >> 2];
	                            n:while (1) {
	                                if (!((d[c[pa >> 2] >> 0] | 0) >= 48 ? (d[c[pa >> 2] >> 0] | 0) <= 57 : 0))Sa = 426;
	                                do if ((Sa | 0) == 426) {
	                                    Sa = 0;
	                                    if ((d[c[pa >> 2] >> 0] | 0) >= 65 ? (d[c[pa >> 2] >> 0] | 0) <= 70 : 0)break;
	                                    if ((d[c[pa >> 2] >> 0] | 0) < 97)break n;
	                                    if ((d[c[pa >> 2] >> 0] | 0) > 102)break n
	                                } while (0);
	                                c[ta >> 2] = (c[ta >> 2] | 0) + 1;
	                                c[pa >> 2] = (c[pa >> 2] | 0) + 1
	                            }
	                            o:do if (c[z >> 2] | 0)while (1) {
	                                do if ((d[c[pa >> 2] >> 0] | 0) != 32) {
	                                    if (9 <= (d[c[pa >> 2] >> 0] | 0) ? (d[c[pa >> 2] >> 0] | 0) <= 10 : 0)break;
	                                    if ((d[c[pa >> 2] >> 0] | 0) != 13)break o
	                                } while (0);
	                                c[pa >> 2] = (c[pa >> 2] | 0) + 1
	                            } while (0);
	                            if ((d[c[pa >> 2] >> 0] | 0) == 0 ? ((c[ta >> 2] | 0) % 2 | 0 | 0) == 0 : 0)if (c[v >> 2] | 0) {
	                                c[C >> 2] = hI(43) | 0;
	                                if (!(c[C >> 2] | 0))Sa = 583; else {
	                                    c[pa >> 2] = ly(c[qa >> 2] | 0, c[ta >> 2] | 0) | 0;
	                                    if (!(c[pa >> 2] | 0)) {
	                                        gI(c[w >> 2] | 0, 172232);
	                                        zb[c[135736 >> 2] & 511](c[C >> 2] | 0);
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    c[sa >> 2] = (c[ta >> 2] | 0) / 2 | 0;
	                                    c[ra >> 2] = c[pa >> 2];
	                                    while (1) {
	                                        p = c[ta >> 2] | 0;
	                                        c[ta >> 2] = p + -1;
	                                        if ((p | 0) <= 0)break;
	                                        if ((d[c[ra >> 2] >> 0] | 0) >= 97)a[c[ra >> 2] >> 0] = (d[c[ra >> 2] >> 0] | 0) - 32;
	                                        c[ra >> 2] = (c[ra >> 2] | 0) + 1
	                                    }
	                                    c[(c[C >> 2] | 0) + 8 >> 2] = c[pa >> 2];
	                                    c[(c[C >> 2] | 0) + 12 >> 2] = c[sa >> 2];
	                                    c[c[v >> 2] >> 2] = c[C >> 2];
	                                    Sa = 580
	                                }
	                            } else Sa = 580; else Sa = 577
	                        } else Sa = 577;
	                        break
	                    }
	                    case 44:
	                    {
	                        c[ua >> 2] = c[u >> 2];
	                        c[xa >> 2] = 0;
	                        c[ya >> 2] = 0;
	                        if (c[ua >> 2] | 0) {
	                            while (1) {
	                                if (!(a[c[ua >> 2] >> 0] | 0))break;
	                                c[za >> 2] = uI(a[c[ua >> 2] >> 0] | 0) | 0;
	                                if ((c[za >> 2] | 0) >= 0) {
	                                    if ((c[za >> 2] | 0) >= 64)break;
	                                    c[xa >> 2] = (c[xa >> 2] | 0) + 1
	                                }
	                                c[ua >> 2] = (c[ua >> 2] | 0) + 1
	                            }
	                            while (1) {
	                                if (!(a[c[ua >> 2] >> 0] | 0))break;
	                                c[Aa >> 2] = uI(a[c[ua >> 2] >> 0] | 0) | 0;
	                                if ((c[Aa >> 2] | 0) >= 0 & (c[Aa >> 2] | 0) < 64) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if ((c[Aa >> 2] | 0) == 64)c[ya >> 2] = (c[ya >> 2] | 0) + 1;
	                                c[ua >> 2] = (c[ua >> 2] | 0) + 1
	                            }
	                            c[wa >> 2] = ((c[xa >> 2] | 0) / 4 | 0) * 3;
	                            do if (!(c[ya >> 2] | 0)) {
	                                if ((c[xa >> 2] | 0) % 4 | 0) {
	                                    Sa = 577;
	                                    break a
	                                }
	                            } else {
	                                if ((c[ya >> 2] | 0) == 1) {
	                                    if (((c[xa >> 2] | 0) % 4 | 0 | 0) != 3) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    c[Ba >> 2] = uI(a[c[ua >> 2] >> 0] | 0) | 0;
	                                    while (1) {
	                                        if (!((c[Ba >> 2] | 0) < 0 | (c[Ba >> 2] | 0) > 63))break;
	                                        c[ua >> 2] = (c[ua >> 2] | 0) + -1;
	                                        c[Ba >> 2] = uI(a[c[ua >> 2] >> 0] | 0) | 0
	                                    }
	                                    if (c[Ba >> 2] & -61) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    c[wa >> 2] = (c[wa >> 2] | 0) + 2;
	                                    break
	                                }
	                                if ((c[ya >> 2] | 0) != 2) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                if (((c[xa >> 2] | 0) % 4 | 0 | 0) != 2) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                c[Ca >> 2] = uI(a[c[ua >> 2] >> 0] | 0) | 0;
	                                while (1) {
	                                    if (!((c[Ca >> 2] | 0) < 0 | (c[Ca >> 2] | 0) > 63))break;
	                                    c[ua >> 2] = (c[ua >> 2] | 0) + -1;
	                                    c[Ca >> 2] = uI(a[c[ua >> 2] >> 0] | 0) | 0
	                                }
	                                if (c[Ca >> 2] & -49) {
	                                    Sa = 577;
	                                    break a
	                                }
	                                c[wa >> 2] = (c[wa >> 2] | 0) + 1
	                            } while (0);
	                            if (c[v >> 2] | 0) {
	                                c[C >> 2] = hI(44) | 0;
	                                if (!(c[C >> 2] | 0))Sa = 583; else {
	                                    c[va >> 2] = Cb[c[135752 >> 2] & 511]((c[xa >> 2] | 0) + (c[ya >> 2] | 0) + 1 | 0) | 0;
	                                    if (!(c[va >> 2] | 0)) {
	                                        gI(c[w >> 2] | 0, 172256);
	                                        zb[c[135736 >> 2] & 511](c[C >> 2] | 0);
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    c[(c[C >> 2] | 0) + 8 >> 2] = c[va >> 2];
	                                    c[ua >> 2] = c[u >> 2];
	                                    while (1) {
	                                        if (!(a[c[ua >> 2] >> 0] | 0))break;
	                                        if ((uI(a[c[ua >> 2] >> 0] | 0) | 0) >= 0) {
	                                            a[c[va >> 2] >> 0] = a[c[ua >> 2] >> 0] | 0;
	                                            c[va >> 2] = (c[va >> 2] | 0) + 1
	                                        }
	                                        c[ua >> 2] = (c[ua >> 2] | 0) + 1
	                                    }
	                                    a[c[va >> 2] >> 0] = 0;
	                                    c[(c[C >> 2] | 0) + 12 >> 2] = c[wa >> 2];
	                                    c[c[v >> 2] >> 2] = c[C >> 2];
	                                    Sa = 580
	                                }
	                            } else Sa = 580
	                        } else Sa = 577;
	                        break
	                    }
	                    case 33:
	                    case 32:
	                    case 31:
	                    case 34:
	                    case 30:
	                    {
	                        c[Da >> 2] = c[u >> 2];
	                        c[Ha >> 2] = 0;
	                        if (c[Da >> 2] | 0) {
	                            p:do if (c[z >> 2] | 0)while (1) {
	                                do if ((d[c[Da >> 2] >> 0] | 0) != 32) {
	                                    if (9 <= (d[c[Da >> 2] >> 0] | 0) ? (d[c[Da >> 2] >> 0] | 0) <= 10 : 0)break;
	                                    if ((d[c[Da >> 2] >> 0] | 0) != 13)break p
	                                } while (0);
	                                c[Da >> 2] = (c[Da >> 2] | 0) + 1
	                            } while (0);
	                            if ((d[c[Da >> 2] >> 0] | 0) != 45) {
	                                if ((d[c[Da >> 2] >> 0] | 0) == 43)c[Da >> 2] = (c[Da >> 2] | 0) + 1
	                            } else {
	                                c[Ha >> 2] = 1;
	                                c[Da >> 2] = (c[Da >> 2] | 0) + 1
	                            }
	                            c[E >> 2] = pI(Da, Ea, Fa, Ga) | 0;
	                            if ((c[E >> 2] | 0) >= 0) {
	                                q:do if (c[z >> 2] | 0)while (1) {
	                                    do if ((d[c[Da >> 2] >> 0] | 0) != 32) {
	                                        if (9 <= (d[c[Da >> 2] >> 0] | 0) ? (d[c[Da >> 2] >> 0] | 0) <= 10 : 0)break;
	                                        if ((d[c[Da >> 2] >> 0] | 0) != 13)break q
	                                    } while (0);
	                                    c[Da >> 2] = (c[Da >> 2] | 0) + 1
	                                } while (0);
	                                if (!(d[c[Da >> 2] >> 0] | 0)) {
	                                    do if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 31) {
	                                        if ((c[Ha >> 2] | 0) == 0 ? (c[Ga >> 2] | 0) != 0 | (c[Fa >> 2] | 0) != 0 | (c[Ea >> 2] | 0) != 0 : 0) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                    } else {
	                                        if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 34) {
	                                            if ((c[Ha >> 2] | 0) == 1) {
	                                                Sa = 577;
	                                                break a
	                                            }
	                                            if ((c[Ga >> 2] | 0) == 0 & (c[Fa >> 2] | 0) == 0 & (c[Ea >> 2] | 0) == 0) {
	                                                Sa = 577;
	                                                break a
	                                            } else break
	                                        }
	                                        if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 32) {
	                                            if (!(c[Ha >> 2] | 0)) {
	                                                Sa = 577;
	                                                break a
	                                            }
	                                            if ((c[Ga >> 2] | 0) == 0 & (c[Fa >> 2] | 0) == 0 & (c[Ea >> 2] | 0) == 0) {
	                                                Sa = 577;
	                                                break a
	                                            } else break
	                                        } else {
	                                            if (!((c[Ha >> 2] | 0) == 1 ? (c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 33 : 0))break;
	                                            if ((c[Ga >> 2] | 0) != 0 | (c[Fa >> 2] | 0) != 0 | (c[Ea >> 2] | 0) != 0) {
	                                                Sa = 577;
	                                                break a
	                                            } else break
	                                        }
	                                    } while (0);
	                                    if ((c[v >> 2] | 0) != 0 ? (c[C >> 2] = hI(c[(c[t >> 2] | 0) + 88 >> 2] | 0) | 0, (c[C >> 2] | 0) != 0) : 0) {
	                                        if (!(c[E >> 2] | 0))c[E >> 2] = (c[E >> 2] | 0) + 1;
	                                        c[(c[C >> 2] | 0) + 8 >> 2] = c[Ea >> 2];
	                                        c[(c[C >> 2] | 0) + 12 >> 2] = c[Fa >> 2];
	                                        c[(c[C >> 2] | 0) + 16 >> 2] = c[Ga >> 2];
	                                        p = (c[C >> 2] | 0) + 24 | 0;
	                                        b[p >> 1] = b[p >> 1] & -2 | c[Ha >> 2] & 1;
	                                        p = (c[C >> 2] | 0) + 24 | 0;
	                                        b[p >> 1] = b[p >> 1] & -255;
	                                        p = (c[C >> 2] | 0) + 24 | 0;
	                                        b[p >> 1] = b[p >> 1] & 255 | (c[E >> 2] & 255) << 8 & 65535;
	                                        c[c[v >> 2] >> 2] = c[C >> 2];
	                                        Sa = 580
	                                    } else Sa = 580
	                                } else Sa = 577
	                            } else Sa = 577
	                        } else Sa = 577;
	                        break
	                    }
	                    case 35:
	                    case 39:
	                    case 41:
	                    case 37:
	                    {
	                        c[Ia >> 2] = c[u >> 2];
	                        c[Ma >> 2] = 0;
	                        if (c[Ia >> 2] | 0) {
	                            if ((d[c[Ia >> 2] >> 0] | 0) != 45) {
	                                if ((d[c[Ia >> 2] >> 0] | 0) == 43)c[Ia >> 2] = (c[Ia >> 2] | 0) + 1
	                            } else {
	                                c[Ma >> 2] = 1;
	                                c[Ia >> 2] = (c[Ia >> 2] | 0) + 1
	                            }
	                            c[E >> 2] = pI(Ia, Ja, Ka, La) | 0;
	                            if ((c[E >> 2] | 0) >= 0 ? (d[c[Ia >> 2] >> 0] | 0) == 0 : 0) {
	                                do if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 37) {
	                                    if ((c[La >> 2] | 0) >>> 0 >= 922) {
	                                        if ((c[La >> 2] | 0) >>> 0 > 922) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ka >> 2] | 0) >>> 0 >= 33720368) {
	                                            if ((c[Ka >> 2] | 0) >>> 0 > 33720368) {
	                                                Sa = 577;
	                                                break a
	                                            }
	                                            if ((c[Ma >> 2] | 0) == 0 & (c[Ja >> 2] | 0) >>> 0 > 54775807) {
	                                                Sa = 577;
	                                                break a
	                                            }
	                                            if ((c[Ma >> 2] | 0) == 1 & (c[Ja >> 2] | 0) >>> 0 > 54775808) {
	                                                Sa = 577;
	                                                break a
	                                            }
	                                        }
	                                    }
	                                } else {
	                                    if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 35) {
	                                        if (c[La >> 2] | 0) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ka >> 2] | 0) >>> 0 < 21)break;
	                                        if ((c[Ka >> 2] | 0) >>> 0 > 21) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ma >> 2] | 0) == 0 & (c[Ja >> 2] | 0) >>> 0 > 47483647) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ma >> 2] | 0) == 1 & (c[Ja >> 2] | 0) >>> 0 > 47483648) {
	                                            Sa = 577;
	                                            break a
	                                        } else break
	                                    }
	                                    if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 39) {
	                                        if ((c[Ka >> 2] | 0) != 0 | (c[La >> 2] | 0) != 0) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ma >> 2] | 0) == 1 & (c[Ja >> 2] | 0) >>> 0 > 32768) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ma >> 2] | 0) == 0 & (c[Ja >> 2] | 0) >>> 0 > 32767) {
	                                            Sa = 577;
	                                            break a
	                                        } else break
	                                    }
	                                    if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 41) {
	                                        if ((c[Ka >> 2] | 0) != 0 | (c[La >> 2] | 0) != 0) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ma >> 2] | 0) == 1 & (c[Ja >> 2] | 0) >>> 0 > 128) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                        if ((c[Ma >> 2] | 0) == 0 & (c[Ja >> 2] | 0) >>> 0 > 127) {
	                                            Sa = 577;
	                                            break a
	                                        }
	                                    }
	                                } while (0);
	                                if ((c[v >> 2] | 0) != 0 ? (c[C >> 2] = hI(c[(c[t >> 2] | 0) + 88 >> 2] | 0) | 0, (c[C >> 2] | 0) != 0) : 0) {
	                                    c[(c[C >> 2] | 0) + 8 >> 2] = c[Ja >> 2];
	                                    c[(c[C >> 2] | 0) + 12 >> 2] = c[Ka >> 2];
	                                    c[(c[C >> 2] | 0) + 16 >> 2] = c[La >> 2];
	                                    p = (c[C >> 2] | 0) + 24 | 0;
	                                    b[p >> 1] = b[p >> 1] & -2 | c[Ma >> 2] & 1;
	                                    p = (c[C >> 2] | 0) + 24 | 0;
	                                    b[p >> 1] = b[p >> 1] & -255;
	                                    p = (c[C >> 2] | 0) + 24 | 0;
	                                    b[p >> 1] = b[p >> 1] & 255 | (c[E >> 2] & 255) << 8 & 65535;
	                                    c[c[v >> 2] >> 2] = c[C >> 2];
	                                    Sa = 580
	                                } else Sa = 580
	                            } else Sa = 577
	                        } else Sa = 577;
	                        break
	                    }
	                    case 42:
	                    case 40:
	                    case 38:
	                    case 36:
	                    {
	                        c[Na >> 2] = c[u >> 2];
	                        if (((c[Na >> 2] | 0) != 0 ? (c[E >> 2] = pI(Na, Oa, Pa, Qa) | 0, (c[E >> 2] | 0) >= 0) : 0) ? (d[c[Na >> 2] >> 0] | 0) == 0 : 0) {
	                            do if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 38) {
	                                if ((c[Qa >> 2] | 0) >>> 0 >= 1844) {
	                                    if ((c[Qa >> 2] | 0) >>> 0 > 1844) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    if ((c[Pa >> 2] | 0) >>> 0 >= 67440737 ? (c[Pa >> 2] | 0) >>> 0 > 67440737 | (c[Oa >> 2] | 0) >>> 0 > 9551615 : 0) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                }
	                            } else {
	                                if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 36) {
	                                    if (c[Qa >> 2] | 0) {
	                                        Sa = 577;
	                                        break a
	                                    }
	                                    if ((c[Pa >> 2] | 0) >>> 0 < 42)break;
	                                    if ((c[Pa >> 2] | 0) >>> 0 > 42 | (c[Oa >> 2] | 0) >>> 0 > 94967295) {
	                                        Sa = 577;
	                                        break a
	                                    } else break
	                                }
	                                if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 40)if ((c[Pa >> 2] | 0) != 0 | (c[Qa >> 2] | 0) != 0 | (c[Oa >> 2] | 0) >>> 0 > 65535) {
	                                    Sa = 577;
	                                    break a
	                                } else break;
	                                if ((c[(c[t >> 2] | 0) + 88 >> 2] | 0) == 42 ? (c[Pa >> 2] | 0) != 0 | (c[Qa >> 2] | 0) != 0 | (c[Oa >> 2] | 0) >>> 0 > 255 : 0) {
	                                    Sa = 577;
	                                    break a
	                                }
	                            } while (0);
	                            if ((c[v >> 2] | 0) != 0 ? (c[C >> 2] = hI(c[(c[t >> 2] | 0) + 88 >> 2] | 0) | 0, (c[C >> 2] | 0) != 0) : 0) {
	                                c[(c[C >> 2] | 0) + 8 >> 2] = c[Oa >> 2];
	                                c[(c[C >> 2] | 0) + 12 >> 2] = c[Pa >> 2];
	                                c[(c[C >> 2] | 0) + 16 >> 2] = c[Qa >> 2];
	                                p = (c[C >> 2] | 0) + 24 | 0;
	                                b[p >> 1] = b[p >> 1] & -2;
	                                p = (c[C >> 2] | 0) + 24 | 0;
	                                b[p >> 1] = b[p >> 1] & -255;
	                                p = (c[C >> 2] | 0) + 24 | 0;
	                                b[p >> 1] = b[p >> 1] & 255 | (c[E >> 2] & 255) << 8 & 65535;
	                                c[c[v >> 2] >> 2] = c[C >> 2];
	                                Sa = 580
	                            } else Sa = 580
	                        } else Sa = 577;
	                        break
	                    }
	                    case 0:
	                    {
	                        Sa = 583;
	                        break
	                    }
	                    default:
	                        Sa = 571
	                } while (0);
	                if ((Sa | 0) == 571) {
	                    if (c[D >> 2] | 0)zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                    c[s >> 2] = c[E >> 2];
	                    Ra = c[s >> 2] | 0;
	                    i = q;
	                    return Ra | 0
	                } else if ((Sa | 0) == 577) {
	                    if (c[D >> 2] | 0)zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                    c[s >> 2] = 1;
	                    Ra = c[s >> 2] | 0;
	                    i = q;
	                    return Ra | 0
	                } else if ((Sa | 0) == 580) {
	                    if (c[D >> 2] | 0)zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                    c[s >> 2] = 0;
	                    Ra = c[s >> 2] | 0;
	                    i = q;
	                    return Ra | 0
	                } else if ((Sa | 0) == 583) {
	                    if (c[D >> 2] | 0)zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                    c[s >> 2] = -1;
	                    Ra = c[s >> 2] | 0;
	                    i = q;
	                    return Ra | 0
	                }
	                return 0
	            }

	            function jI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = hI(c[c[e >> 2] >> 2] | 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = c[f >> 2] | 0;
	                    h = c[e >> 2] | 0;
	                    c[a + 0 >> 2] = c[h + 0 >> 2];
	                    c[a + 4 >> 2] = c[h + 4 >> 2];
	                    c[a + 8 >> 2] = c[h + 8 >> 2];
	                    c[a + 12 >> 2] = c[h + 12 >> 2];
	                    c[a + 16 >> 2] = c[h + 16 >> 2];
	                    c[a + 20 >> 2] = c[h + 20 >> 2];
	                    c[a + 24 >> 2] = c[h + 24 >> 2];
	                    c[a + 28 >> 2] = c[h + 28 >> 2];
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function kI(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                k = i;
	                i = i + 64 | 0;
	                l = k;
	                m = k + 56 | 0;
	                n = k + 52 | 0;
	                o = k + 48 | 0;
	                p = k + 44 | 0;
	                q = k + 40 | 0;
	                r = k + 36 | 0;
	                s = k + 32 | 0;
	                t = k + 28 | 0;
	                u = k + 24 | 0;
	                v = k + 20 | 0;
	                w = k + 16 | 0;
	                x = k + 12 | 0;
	                y = k + 8 | 0;
	                c[n >> 2] = a;
	                c[o >> 2] = b;
	                c[p >> 2] = d;
	                c[q >> 2] = e;
	                c[r >> 2] = f;
	                c[s >> 2] = g;
	                c[t >> 2] = h;
	                c[u >> 2] = j;
	                a:do switch (c[n >> 2] | 0) {
	                    case 11:
	                    case 10:
	                    case 9:
	                    case 8:
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 4:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) == 11 | (c[r >> 2] | 0) == 4 | (c[r >> 2] | 0) == 5 | (c[r >> 2] | 0) == 6 | (c[r >> 2] | 0) == 7 | (c[r >> 2] | 0) == 8 | (c[r >> 2] | 0) == 10 | (c[r >> 2] | 0) == 9) {
	                            c[m >> 2] = xI(c[o >> 2] | 0, c[s >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        break
	                    }
	                    case 12:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) == 12) {
	                            c[m >> 2] = wI(c[o >> 2] | 0, c[s >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        break
	                    }
	                    case 28:
	                    case 21:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if (!((c[r >> 2] | 0) == 21 | (c[r >> 2] | 0) == 28)) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((qy(c[(c[o >> 2] | 0) + 8 >> 2] | 0, c[(c[s >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 ? (qy(c[(c[o >> 2] | 0) + 12 >> 2] | 0, c[(c[s >> 2] | 0) + 12 >> 2] | 0) | 0) != 0 : 0) {
	                            c[m >> 2] = 0;
	                            break a
	                        }
	                        c[m >> 2] = 2;
	                        break
	                    }
	                    case 3:
	                    case 42:
	                    case 41:
	                    case 40:
	                    case 39:
	                    case 38:
	                    case 37:
	                    case 36:
	                    case 35:
	                    case 34:
	                    case 33:
	                    case 32:
	                    case 31:
	                    case 30:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) == (c[n >> 2] | 0)) {
	                            c[m >> 2] = vI(c[o >> 2] | 0, c[s >> 2] | 0) | 0;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) == 3 | (c[r >> 2] | 0) == 30 | (c[r >> 2] | 0) == 31 | (c[r >> 2] | 0) == 32 | (c[r >> 2] | 0) == 33 | (c[r >> 2] | 0) == 34 | (c[r >> 2] | 0) == 35 | (c[r >> 2] | 0) == 36 | (c[r >> 2] | 0) == 37 | (c[r >> 2] | 0) == 38 | (c[r >> 2] | 0) == 39 | (c[r >> 2] | 0) == 40 | (c[r >> 2] | 0) == 41 | (c[r >> 2] | 0) == 42) {
	                            c[m >> 2] = vI(c[o >> 2] | 0, c[s >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        break
	                    }
	                    case 14:
	                    case 13:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) == 13 | (c[r >> 2] | 0) == 14) {
	                            c[m >> 2] = DI(c[o >> 2] | 0, c[s >> 2] | 0) | 0;
	                            break a
	                        } else {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        break
	                    }
	                    case 44:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) != 44) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        j = (c[o >> 2] | 0) + 8 | 0;
	                        if ((c[(c[o >> 2] | 0) + 12 >> 2] | 0) != (c[(c[s >> 2] | 0) + 12 >> 2] | 0))if ((c[j + 4 >> 2] | 0) >>> 0 > (c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 0) {
	                            c[m >> 2] = 1;
	                            break a
	                        } else {
	                            c[m >> 2] = -1;
	                            break a
	                        }
	                        c[y >> 2] = py(c[j >> 2] | 0, c[(c[s >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if ((c[y >> 2] | 0) > 0) {
	                            c[m >> 2] = 1;
	                            break a
	                        }
	                        if (!(c[y >> 2] | 0)) {
	                            c[m >> 2] = 0;
	                            break a
	                        } else {
	                            c[m >> 2] = -1;
	                            break a
	                        }
	                        break
	                    }
	                    case 29:
	                    case 26:
	                    case 24:
	                    case 23:
	                    case 22:
	                    case 20:
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 2:
	                    case 1:
	                    case 46:
	                    {
	                        if (!(c[o >> 2] | 0))c[v >> 2] = c[p >> 2]; else c[v >> 2] = c[(c[o >> 2] | 0) + 8 >> 2];
	                        if (!(c[s >> 2] | 0))c[w >> 2] = c[t >> 2]; else c[w >> 2] = c[(c[s >> 2] | 0) + 8 >> 2];
	                        if ((c[r >> 2] | 0) == 21) {
	                            j = c[33976] | 0;
	                            h = c[33980] | 0;
	                            c[l >> 2] = 171992;
	                            c[l + 4 >> 2] = 4781;
	                            Db[j & 511](h, 171960, l);
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        do if ((c[r >> 2] | 0) == 46 | (c[r >> 2] | 0) == 1 | (c[r >> 2] | 0) == 2 | (c[r >> 2] | 0) == 16 | (c[r >> 2] | 0) == 17 | (c[r >> 2] | 0) == 18 | (c[r >> 2] | 0) == 20 | (c[r >> 2] | 0) == 22 | (c[r >> 2] | 0) == 23 | (c[r >> 2] | 0) == 24 | (c[r >> 2] | 0) == 26 | (c[r >> 2] | 0) == 29) {
	                            if ((c[q >> 2] | 0) == 1) {
	                                if ((c[u >> 2] | 0) == 1)if (qy(c[v >> 2] | 0, c[w >> 2] | 0) | 0) {
	                                    c[m >> 2] = 0;
	                                    break a
	                                } else {
	                                    c[m >> 2] = 2;
	                                    break a
	                                }
	                                if ((c[u >> 2] | 0) == 2) {
	                                    c[m >> 2] = yI(c[v >> 2] | 0, c[w >> 2] | 0, 0) | 0;
	                                    break a
	                                }
	                                if ((c[u >> 2] | 0) != 3)break;
	                                c[m >> 2] = zI(c[v >> 2] | 0, c[w >> 2] | 0, 0) | 0;
	                                break a
	                            }
	                            if ((c[q >> 2] | 0) == 2) {
	                                if ((c[u >> 2] | 0) == 1) {
	                                    c[m >> 2] = yI(c[w >> 2] | 0, c[v >> 2] | 0, 1) | 0;
	                                    break a
	                                }
	                                if ((c[u >> 2] | 0) == 2) {
	                                    c[m >> 2] = AI(c[v >> 2] | 0, c[w >> 2] | 0) | 0;
	                                    break a
	                                }
	                                if ((c[u >> 2] | 0) != 3)break;
	                                c[m >> 2] = BI(c[v >> 2] | 0, c[w >> 2] | 0, 0) | 0;
	                                break a
	                            }
	                            if ((c[q >> 2] | 0) != 3) {
	                                c[m >> 2] = -2;
	                                break a
	                            }
	                            if ((c[u >> 2] | 0) == 1) {
	                                c[m >> 2] = zI(c[w >> 2] | 0, c[v >> 2] | 0, 1) | 0;
	                                break a
	                            }
	                            if ((c[u >> 2] | 0) == 2) {
	                                c[m >> 2] = BI(c[w >> 2] | 0, c[v >> 2] | 0, 1) | 0;
	                                break a
	                            }
	                            if ((c[u >> 2] | 0) == 3) {
	                                c[m >> 2] = CI(c[v >> 2] | 0, c[w >> 2] | 0) | 0;
	                                break a
	                            }
	                        } while (0);
	                        c[m >> 2] = -2;
	                        break
	                    }
	                    case 45:
	                    case 0:
	                    {
	                        c[m >> 2] = -2;
	                        break
	                    }
	                    case 19:
	                    case 27:
	                    case 25:
	                    {
	                        h = c[33976] | 0;
	                        j = c[33980] | 0;
	                        c[l >> 2] = 171992;
	                        c[l + 4 >> 2] = 4906;
	                        Db[h & 511](j, 171960, l);
	                        z = 102;
	                        break
	                    }
	                    case 43:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) != 43) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        j = (c[o >> 2] | 0) + 8 | 0;
	                        if ((c[(c[o >> 2] | 0) + 12 >> 2] | 0) == (c[(c[s >> 2] | 0) + 12 >> 2] | 0)) {
	                            c[x >> 2] = py(c[j >> 2] | 0, c[(c[s >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            if ((c[x >> 2] | 0) > 0) {
	                                c[m >> 2] = 1;
	                                break a
	                            }
	                            if (!(c[x >> 2] | 0)) {
	                                c[m >> 2] = 0;
	                                break a
	                            }
	                        } else if ((c[j + 4 >> 2] | 0) >>> 0 > (c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 0) {
	                            c[m >> 2] = 1;
	                            break a
	                        }
	                        c[m >> 2] = -1;
	                        break
	                    }
	                    case 15:
	                    {
	                        if ((c[o >> 2] | 0) == 0 | (c[s >> 2] | 0) == 0) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[r >> 2] | 0) != 15) {
	                            c[m >> 2] = -2;
	                            break a
	                        }
	                        if ((c[(c[o >> 2] | 0) + 8 >> 2] | 0) == (c[(c[s >> 2] | 0) + 8 >> 2] | 0)) {
	                            c[m >> 2] = 0;
	                            break a
	                        }
	                        if (!(c[(c[o >> 2] | 0) + 8 >> 2] | 0)) {
	                            c[m >> 2] = -1;
	                            break a
	                        } else {
	                            c[m >> 2] = 1;
	                            break a
	                        }
	                        break
	                    }
	                    default:
	                        z = 102
	                } while (0);
	                if ((z | 0) == 102)c[m >> 2] = -2;
	                i = k;
	                return c[m >> 2] | 0
	            }

	            function lI(a, b, d, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j;
	                l = j + 40 | 0;
	                m = j + 36 | 0;
	                n = j + 32 | 0;
	                o = j + 28 | 0;
	                p = j + 24 | 0;
	                q = j + 20 | 0;
	                r = j + 16 | 0;
	                s = j + 12 | 0;
	                t = j + 8 | 0;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                a:do if (!(c[m >> 2] | 0))c[l >> 2] = -1; else {
	                    b:do switch (c[c[m >> 2] >> 2] | 0) {
	                        case 1008:
	                        {
	                            c[l >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 1006:
	                        {
	                            if (!(c[p >> 2] | 0)) {
	                                c[l >> 2] = -1;
	                                break a
	                            }
	                            c[s >> 2] = vz(c[(c[m >> 2] | 0) + 36 >> 2] | 0, c[p >> 2] | 0) | 0;
	                            if ((c[s >> 2] | 0) == 1) {
	                                c[l >> 2] = 0;
	                                break a
	                            }
	                            if (!(c[s >> 2] | 0)) {
	                                c[l >> 2] = 1839;
	                                break a
	                            } else {
	                                c[l >> 2] = c[s >> 2];
	                                break a
	                            }
	                            break
	                        }
	                        case 1007:
	                        {
	                            h = c[m >> 2] | 0;
	                            if (!(c[r >> 2] | 0)) {
	                                if ((c[h + 8 >> 2] | 0) != 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[p >> 2] | 0) | 0) != 0 : 0) {
	                                    c[l >> 2] = 0;
	                                    break a
	                                }
	                            } else {
	                                c[s >> 2] = EI(c[c[h + 32 >> 2] >> 2] | 0, c[(c[m >> 2] | 0) + 32 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[q >> 2] | 0, c[p >> 2] | 0, c[r >> 2] | 0) | 0;
	                                if ((c[s >> 2] | 0) == -2) {
	                                    c[l >> 2] = -1;
	                                    break a
	                                }
	                                if (!(c[s >> 2] | 0)) {
	                                    c[l >> 2] = 0;
	                                    break a
	                                }
	                            }
	                            c[l >> 2] = 1840;
	                            break a;
	                            break
	                        }
	                        case 1011:
	                        case 1010:
	                        {
	                            u = 43;
	                            break
	                        }
	                        case 1009:
	                        {
	                            if ((c[o >> 2] | 0) == 21 | (c[o >> 2] | 0) == 28) {
	                                c[l >> 2] = 0;
	                                break a
	                            } else u = 43;
	                            break
	                        }
	                        case 1005:
	                        case 1004:
	                        {
	                            do if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                                if ((c[c[(c[m >> 2] | 0) + 32 >> 2] >> 2] | 0) != 34 ? (c[c[(c[m >> 2] | 0) + 32 >> 2] >> 2] | 0) != 33 : 0)break;
	                                if (!((e[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 24 >> 1] | 0) >>> 1 & 127)) {
	                                    c:do if (c[q >> 2] | 0) {
	                                        do if ((((((((((c[c[q >> 2] >> 2] | 0) != 3 ? (c[c[q >> 2] >> 2] | 0) != 30 : 0) ? (c[c[q >> 2] >> 2] | 0) != 31 : 0) ? (c[c[q >> 2] >> 2] | 0) != 32 : 0) ? (c[c[q >> 2] >> 2] | 0) != 33 : 0) ? (c[c[q >> 2] >> 2] | 0) != 34 : 0) ? (c[c[q >> 2] >> 2] | 0) != 35 : 0) ? (c[c[q >> 2] >> 2] | 0) != 36 : 0) ? (c[c[q >> 2] >> 2] | 0) != 37 : 0) ? (c[c[q >> 2] >> 2] | 0) != 38 : 0) {
	                                            if ((c[c[q >> 2] >> 2] | 0) == 39)break;
	                                            if ((c[c[q >> 2] >> 2] | 0) == 40)break;
	                                            if ((c[c[q >> 2] >> 2] | 0) == 41)break;
	                                            if ((c[c[q >> 2] >> 2] | 0) != 42)break c
	                                        } while (0);
	                                        if ((c[c[m >> 2] >> 2] | 0) == 1004) {
	                                            if (((e[(c[q >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535) >>> 0 <= (c[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) >>> 0)break b;
	                                            c[l >> 2] = 1837;
	                                            break a
	                                        }
	                                        if ((c[c[m >> 2] >> 2] | 0) != 1005)break b;
	                                        if (((e[(c[q >> 2] | 0) + 24 >> 1] | 0) >>> 1 & 127) >>> 0 <= (c[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0) >>> 0)break b;
	                                        c[l >> 2] = 1838;
	                                        break a
	                                    } while (0);
	                                    c[l >> 2] = -1;
	                                    break a
	                                }
	                            } while (0);
	                            c[l >> 2] = -1;
	                            break a;
	                            break
	                        }
	                        case 1e3:
	                        {
	                            c[s >> 2] = XH(c[q >> 2] | 0, c[(c[m >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[s >> 2] | 0) == -2) {
	                                c[l >> 2] = -1;
	                                break a
	                            }
	                            if ((c[s >> 2] | 0) == 1 | (c[s >> 2] | 0) == 0) {
	                                c[l >> 2] = 0;
	                                break a
	                            } else {
	                                c[l >> 2] = 1833;
	                                break a
	                            }
	                            break
	                        }
	                        case 1002:
	                        {
	                            c[s >> 2] = XH(c[q >> 2] | 0, c[(c[m >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[s >> 2] | 0) == -2) {
	                                c[l >> 2] = -1;
	                                break a
	                            }
	                            if ((c[s >> 2] | 0) == -1 | (c[s >> 2] | 0) == 0) {
	                                c[l >> 2] = 0;
	                                break a
	                            } else {
	                                c[l >> 2] = 1834;
	                                break a
	                            }
	                            break
	                        }
	                        case 1001:
	                        {
	                            c[s >> 2] = XH(c[q >> 2] | 0, c[(c[m >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[s >> 2] | 0) == -2) {
	                                c[l >> 2] = -1;
	                                break a
	                            }
	                            if ((c[s >> 2] | 0) == 1) {
	                                c[l >> 2] = 0;
	                                break a
	                            } else {
	                                c[l >> 2] = 1835;
	                                break a
	                            }
	                            break
	                        }
	                        case 1003:
	                        {
	                            c[s >> 2] = XH(c[q >> 2] | 0, c[(c[m >> 2] | 0) + 32 >> 2] | 0) | 0;
	                            if ((c[s >> 2] | 0) == -2) {
	                                c[l >> 2] = -1;
	                                break a
	                            }
	                            if ((c[s >> 2] | 0) == -1) {
	                                c[l >> 2] = 0;
	                                break a
	                            } else {
	                                c[l >> 2] = 1836;
	                                break a
	                            }
	                            break
	                        }
	                        default:
	                        {
	                            h = c[33976] | 0;
	                            g = c[33980] | 0;
	                            c[k >> 2] = 171992;
	                            c[k + 4 >> 2] = 5498;
	                            Db[h & 511](g, 171960, k)
	                        }
	                    } while (0);
	                    d:do if ((u | 0) == 43) {
	                        c[t >> 2] = 0;
	                        if ((c[o >> 2] | 0) == 21 | (c[o >> 2] | 0) == 28) {
	                            c[l >> 2] = 0;
	                            break a
	                        }
	                        do if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                            if ((c[c[(c[m >> 2] | 0) + 32 >> 2] >> 2] | 0) != 3 ? (c[c[(c[m >> 2] | 0) + 32 >> 2] >> 2] | 0) != 33 : 0)break;
	                            if (!((e[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 24 >> 1] | 0) >>> 1 & 127)) {
	                                if ((c[q >> 2] | 0) != 0 ? (c[c[q >> 2] >> 2] | 0) == 43 : 0)c[t >> 2] = c[(c[q >> 2] | 0) + 12 >> 2]; else u = 53;
	                                e:do if ((u | 0) == 53) {
	                                    if ((c[q >> 2] | 0) != 0 ? (c[c[q >> 2] >> 2] | 0) == 44 : 0) {
	                                        c[t >> 2] = c[(c[q >> 2] | 0) + 12 >> 2];
	                                        break
	                                    }
	                                    switch (c[o >> 2] | 0) {
	                                        case 29:
	                                        case 23:
	                                        case 22:
	                                        case 20:
	                                        case 18:
	                                        case 17:
	                                        case 16:
	                                        case 24:
	                                        {
	                                            if (!(c[p >> 2] | 0))break e;
	                                            c[t >> 2] = FI(c[p >> 2] | 0) | 0;
	                                            break e;
	                                            break
	                                        }
	                                        case 2:
	                                        case 1:
	                                        {
	                                            if (!(c[r >> 2] | 0)) {
	                                                g = c[p >> 2] | 0;
	                                                if ((c[o >> 2] | 0) == 1) {
	                                                    c[t >> 2] = Dy(g) | 0;
	                                                    break e
	                                                } else {
	                                                    c[t >> 2] = FI(g) | 0;
	                                                    break e
	                                                }
	                                            }
	                                            if (!(c[p >> 2] | 0))break e;
	                                            g = c[p >> 2] | 0;
	                                            if ((c[r >> 2] | 0) == 3) {
	                                                c[t >> 2] = FI(g) | 0;
	                                                break e
	                                            } else {
	                                                c[t >> 2] = Dy(g) | 0;
	                                                break e
	                                            }
	                                            break
	                                        }
	                                        default:
	                                        {
	                                            g = c[33976] | 0;
	                                            h = c[33980] | 0;
	                                            c[k >> 2] = 171992;
	                                            c[k + 4 >> 2] = 5447;
	                                            Db[g & 511](h, 171960, k);
	                                            break e
	                                        }
	                                    }
	                                } while (0);
	                                if ((c[c[m >> 2] >> 2] | 0) == 1009) {
	                                    if ((c[t >> 2] | 0) == (c[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0))break d;
	                                    c[l >> 2] = 1830;
	                                    break a
	                                }
	                                h = c[t >> 2] | 0;
	                                g = c[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0;
	                                if ((c[c[m >> 2] >> 2] | 0) == 1011) {
	                                    if (h >>> 0 >= g >>> 0)break d;
	                                    c[l >> 2] = 1831;
	                                    break a
	                                } else {
	                                    if (h >>> 0 <= g >>> 0)break d;
	                                    c[l >> 2] = 1832;
	                                    break a
	                                }
	                            }
	                        } while (0);
	                        c[l >> 2] = -1;
	                        break a
	                    } while (0);
	                    c[l >> 2] = 0
	                } while (0);
	                i = j;
	                return c[l >> 2] | 0
	            }

	            function mI(a, b, d, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j;
	                l = j + 36 | 0;
	                m = j + 32 | 0;
	                n = j + 28 | 0;
	                o = j + 24 | 0;
	                p = j + 20 | 0;
	                q = j + 16 | 0;
	                r = j + 12 | 0;
	                s = j + 8 | 0;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = 0;
	                if ((c[q >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0) {
	                    c[l >> 2] = -1;
	                    t = c[l >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                c[c[q >> 2] >> 2] = 0;
	                if (((c[c[m >> 2] >> 2] | 0) != 1009 ? (c[c[m >> 2] >> 2] | 0) != 1010 : 0) ? (c[c[m >> 2] >> 2] | 0) != 1011 : 0) {
	                    c[l >> 2] = -1;
	                    t = c[l >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                do if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                    if ((c[c[(c[m >> 2] | 0) + 32 >> 2] >> 2] | 0) != 3 ? (c[c[(c[m >> 2] | 0) + 32 >> 2] >> 2] | 0) != 33 : 0)break;
	                    if (!((e[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 24 >> 1] | 0) >>> 1 & 127)) {
	                        if ((c[p >> 2] | 0) != 0 ? (c[c[p >> 2] >> 2] | 0) == 43 : 0)c[s >> 2] = c[(c[p >> 2] | 0) + 12 >> 2]; else u = 15;
	                        a:do if ((u | 0) == 15) {
	                            if ((c[p >> 2] | 0) != 0 ? (c[c[p >> 2] >> 2] | 0) == 44 : 0) {
	                                c[s >> 2] = c[(c[p >> 2] | 0) + 12 >> 2];
	                                break
	                            }
	                            switch (c[n >> 2] | 0) {
	                                case 28:
	                                case 21:
	                                {
	                                    c[l >> 2] = 0;
	                                    t = c[l >> 2] | 0;
	                                    i = j;
	                                    return t | 0
	                                }
	                                case 29:
	                                case 23:
	                                case 22:
	                                case 20:
	                                case 18:
	                                case 17:
	                                case 16:
	                                case 24:
	                                {
	                                    if (!(c[o >> 2] | 0))break a;
	                                    c[s >> 2] = FI(c[o >> 2] | 0) | 0;
	                                    break a;
	                                    break
	                                }
	                                case 2:
	                                case 1:
	                                {
	                                    if (!(c[r >> 2] | 0)) {
	                                        h = c[o >> 2] | 0;
	                                        if ((c[n >> 2] | 0) == 1) {
	                                            c[s >> 2] = Dy(h) | 0;
	                                            break a
	                                        } else {
	                                            c[s >> 2] = FI(h) | 0;
	                                            break a
	                                        }
	                                    }
	                                    if (!(c[o >> 2] | 0))break a;
	                                    h = c[o >> 2] | 0;
	                                    if ((c[r >> 2] | 0) == 3) {
	                                        c[s >> 2] = FI(h) | 0;
	                                        break a
	                                    } else {
	                                        c[s >> 2] = Dy(h) | 0;
	                                        break a
	                                    }
	                                    break
	                                }
	                                default:
	                                {
	                                    h = c[33976] | 0;
	                                    g = c[33980] | 0;
	                                    c[k >> 2] = 171992;
	                                    c[k + 4 >> 2] = 5207;
	                                    Db[h & 511](g, 171960, k);
	                                    break a
	                                }
	                            }
	                        } while (0);
	                        c[c[q >> 2] >> 2] = c[s >> 2];
	                        do if ((c[c[m >> 2] >> 2] | 0) == 1009) {
	                            if ((c[s >> 2] | 0) != (c[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0)) {
	                                c[l >> 2] = 1830;
	                                t = c[l >> 2] | 0;
	                                i = j;
	                                return t | 0
	                            }
	                        } else {
	                            g = c[s >> 2] | 0;
	                            h = c[(c[(c[m >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0;
	                            if ((c[c[m >> 2] >> 2] | 0) == 1011) {
	                                if (g >>> 0 >= h >>> 0)break;
	                                c[l >> 2] = 1831;
	                                t = c[l >> 2] | 0;
	                                i = j;
	                                return t | 0
	                            } else {
	                                if (g >>> 0 <= h >>> 0)break;
	                                c[l >> 2] = 1832;
	                                t = c[l >> 2] | 0;
	                                i = j;
	                                return t | 0
	                            }
	                        } while (0);
	                        c[l >> 2] = 0;
	                        t = c[l >> 2] | 0;
	                        i = j;
	                        return t | 0
	                    }
	                } while (0);
	                c[l >> 2] = -1;
	                t = c[l >> 2] | 0;
	                i = j;
	                return t | 0
	            }

	            function nI(a, d) {
	                a = a | 0;
	                d = +d;
	                var e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                j = e;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                c[g >> 2] = a;
	                h[j >> 3] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (!(((c[c[g >> 2] >> 2] | 0) != 4 ? (c[c[g >> 2] >> 2] | 0) != 11 : 0) ? (c[c[g >> 2] >> 2] | 0) != 10 : 0))n = 6;
	                if ((n | 0) == 6 ? ((b[(c[g >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) != 0 : 0) {
	                    c[k >> 2] = hI(12) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                    n = (c[k >> 2] | 0) + 16 | 0;
	                    h[n >> 3] = +h[n >> 3] - +h[j >> 3];
	                    c[l >> 2] = GI(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    } else {
	                        PH(c[k >> 2] | 0);
	                        c[f >> 2] = c[l >> 2];
	                        m = c[f >> 2] | 0;
	                        i = e;
	                        return m | 0
	                    }
	                }
	                c[f >> 2] = jI(c[g >> 2] | 0) | 0;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function oI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = SA() | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[c[f >> 2] >> 2] = 1011;
	                a = hI(33) | 0;
	                c[(c[f >> 2] | 0) + 32 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 32 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function pI(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 44 | 0;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                t = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[r >> 2] = c[c[j >> 2] >> 2];
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                if ((d[c[r >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[r >> 2] >> 0] | 0 | 0) <= 57 : 0) {
	                    while (1) {
	                        u = c[r >> 2] | 0;
	                        if ((d[c[r >> 2] >> 0] | 0 | 0) != 48)break;
	                        c[r >> 2] = u + 1
	                    }
	                    c[q >> 2] = u;
	                    while (1) {
	                        if ((d[c[q >> 2] >> 0] | 0 | 0) != 0 ? (d[c[q >> 2] >> 0] | 0 | 0) >= 48 : 0)v = (d[c[q >> 2] >> 0] | 0 | 0) <= 57; else v = 0;
	                        w = c[t >> 2] | 0;
	                        if (!v)break;
	                        c[t >> 2] = w + 1;
	                        c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        c[s >> 2] = (c[s >> 2] | 0) + 1
	                    }
	                    if ((w | 0) > 24) {
	                        c[c[j >> 2] >> 2] = c[q >> 2];
	                        c[h >> 2] = -1;
	                        x = c[h >> 2] | 0;
	                        i = g;
	                        return x | 0
	                    }
	                    while (1) {
	                        if ((c[t >> 2] | 0) <= 16)break;
	                        q = (c[p >> 2] | 0) * 10 | 0;
	                        w = c[r >> 2] | 0;
	                        c[r >> 2] = w + 1;
	                        c[p >> 2] = q + ((d[w >> 0] | 0) - 48);
	                        c[t >> 2] = (c[t >> 2] | 0) + -1
	                    }
	                    while (1) {
	                        if ((c[t >> 2] | 0) <= 8)break;
	                        w = (c[o >> 2] | 0) * 10 | 0;
	                        q = c[r >> 2] | 0;
	                        c[r >> 2] = q + 1;
	                        c[o >> 2] = w + ((d[q >> 0] | 0) - 48);
	                        c[t >> 2] = (c[t >> 2] | 0) + -1
	                    }
	                    while (1) {
	                        if ((c[t >> 2] | 0) <= 0)break;
	                        q = (c[n >> 2] | 0) * 10 | 0;
	                        w = c[r >> 2] | 0;
	                        c[r >> 2] = w + 1;
	                        c[n >> 2] = q + ((d[w >> 0] | 0) - 48);
	                        c[t >> 2] = (c[t >> 2] | 0) + -1
	                    }
	                    c[c[j >> 2] >> 2] = c[r >> 2];
	                    c[c[k >> 2] >> 2] = c[n >> 2];
	                    c[c[l >> 2] >> 2] = c[o >> 2];
	                    c[c[m >> 2] >> 2] = c[p >> 2];
	                    c[h >> 2] = c[s >> 2];
	                    x = c[h >> 2] | 0;
	                    i = g;
	                    return x | 0
	                }
	                c[h >> 2] = -2;
	                x = c[h >> 2] | 0;
	                i = g;
	                return x | 0
	            }

	            function qI(a, e, f, g) {
	                a = a | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 24 | 0;
	                n = j + 20 | 0;
	                o = j + 16 | 0;
	                p = j + 12 | 0;
	                q = j + 8 | 0;
	                r = j + 4 | 0;
	                s = j;
	                c[l >> 2] = a;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[r >> 2] = c[m >> 2];
	                if (!(c[m >> 2] | 0)) {
	                    c[k >> 2] = -1;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                a:do if (c[o >> 2] | 0)while (1) {
	                    do if ((d[c[r >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[r >> 2] >> 0] | 0 | 0) ? (d[c[r >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[r >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[r >> 2] = (c[r >> 2] | 0) + 1
	                } while (0);
	                if (((d[c[r >> 2] >> 0] | 0 | 0) != 45 ? (d[c[r >> 2] >> 0] | 0 | 0) < 48 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) > 57 : 0) {
	                    c[k >> 2] = 1;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                c[p >> 2] = hI(0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[k >> 2] = -1;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                }
	                b:do if ((d[c[r >> 2] >> 0] | 0 | 0) == 45 ? (d[(c[r >> 2] | 0) + 1 >> 0] | 0 | 0) == 45 : 0) {
	                    c[r >> 2] = (c[r >> 2] | 0) + 2;
	                    if ((d[c[r >> 2] >> 0] | 0 | 0) == 45) {
	                        if ((c[l >> 2] | 0) == 6)break;
	                        c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        c[q >> 2] = HI((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                        if (c[q >> 2] | 0)break;
	                        if ((((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 90 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 43 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 45 : 0)break;
	                        c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                        if (c[q >> 2] | 0)break;
	                        if (d[c[r >> 2] >> 0] | 0)break;
	                        c[c[p >> 2] >> 2] = 5;
	                        u = 123;
	                        break
	                    }
	                    c[q >> 2] = JI((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        if ((d[c[r >> 2] >> 0] | 0 | 0) == 45) {
	                            c[s >> 2] = c[r >> 2];
	                            c[r >> 2] = (c[r >> 2] | 0) + 1;
	                            c[q >> 2] = HI((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                            do if (!(c[q >> 2] | 0)) {
	                                if ((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) == 58 : 0)break;
	                                if (((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 100 | 0 | 0) != 0 : 0)u = 35; else if ((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 400 | 0) {
	                                    if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31) >>> 0 > (c[171912 + ((c[(c[p >> 2] | 0) + 12 >> 2] & 15) - 1 << 2) >> 2] | 0) >>> 0)break
	                                } else u = 35;
	                                if ((u | 0) == 35 ? ((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31) >>> 0 > (c[171864 + ((c[(c[p >> 2] | 0) + 12 >> 2] & 15) - 1 << 2) >> 2] | 0) >>> 0 : 0)break;
	                                if ((((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 90 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 43 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 45 : 0)break b;
	                                c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                                if (c[q >> 2] | 0)break b;
	                                if (d[c[r >> 2] >> 0] | 0)break b;
	                                c[c[p >> 2] >> 2] = 7;
	                                u = 123;
	                                break b
	                            } while (0);
	                            c[r >> 2] = c[s >> 2]
	                        }
	                        if ((((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 90 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 43 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 45 : 0)break;
	                        c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                        if ((c[q >> 2] | 0) == 0 ? (d[c[r >> 2] >> 0] | 0 | 0) == 0 : 0) {
	                            c[c[p >> 2] >> 2] = 6;
	                            u = 123
	                        }
	                    }
	                } else u = 52; while (0);
	                c:do if ((u | 0) == 52) {
	                    do if (((d[c[r >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[r >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (c[q >> 2] = KI((c[p >> 2] | 0) + 8 | 0, r) | 0, (c[q >> 2] | 0) == 0) : 0) {
	                        if ((((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 90 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 43 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 45 : 0)break;
	                        c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            if (d[c[r >> 2] >> 0] | 0)break c;
	                            c[c[p >> 2] >> 2] = 4;
	                            u = 123;
	                            break c
	                        }
	                    } while (0);
	                    c[r >> 2] = c[m >> 2];
	                    c[q >> 2] = LI((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                    if (!(c[q >> 2] | 0)) {
	                        if (!((((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 90 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 43 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 45 : 0))u = 67;
	                        if ((u | 0) == 67 ? (c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0, (c[q >> 2] | 0) == 0) : 0) {
	                            if (d[c[r >> 2] >> 0] | 0)break;
	                            c[c[p >> 2] >> 2] = 8;
	                            u = 123;
	                            break
	                        }
	                        if ((d[c[r >> 2] >> 0] | 0 | 0) == 45 ? (c[r >> 2] = (c[r >> 2] | 0) + 1, c[q >> 2] = JI((c[p >> 2] | 0) + 8 | 0, r) | 0, (c[q >> 2] | 0) == 0) : 0) {
	                            if (!((((d[c[r >> 2] >> 0] | 0 | 0) != 0 ? (d[c[r >> 2] >> 0] | 0 | 0) != 90 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 43 : 0) ? (d[c[r >> 2] >> 0] | 0 | 0) != 45 : 0))u = 76;
	                            if ((u | 0) == 76 ? (c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0, (c[q >> 2] | 0) == 0) : 0) {
	                                if (d[c[r >> 2] >> 0] | 0)break;
	                                c[c[p >> 2] >> 2] = 9;
	                                u = 123;
	                                break
	                            }
	                            if (((((d[c[r >> 2] >> 0] | 0 | 0) == 45 ? (c[r >> 2] = (c[r >> 2] | 0) + 1, c[q >> 2] = HI((c[p >> 2] | 0) + 8 | 0, r) | 0, (c[q >> 2] | 0) == 0) : 0) ? (c[(c[p >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[p >> 2] | 0) + 12 >> 2] & 15 | 0) >= 1 : 0) ? (c[(c[p >> 2] | 0) + 12 >> 2] & 15 | 0) <= 12 : 0) {
	                                if (((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 100 | 0 | 0) != 0 : 0)u = 87; else if ((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 400 | 0) {
	                                    if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31) >>> 0 > (c[171912 + ((c[(c[p >> 2] | 0) + 12 >> 2] & 15) - 1 << 2) >> 2] | 0) >>> 0)break
	                                } else u = 87;
	                                if ((u | 0) == 87 ? ((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31) >>> 0 > (c[171864 + ((c[(c[p >> 2] | 0) + 12 >> 2] & 15) - 1 << 2) >> 2] | 0) >>> 0 : 0)break;
	                                do if (d[c[r >> 2] >> 0] | 0) {
	                                    if ((d[c[r >> 2] >> 0] | 0 | 0) == 90) {
	                                        u = 93;
	                                        break
	                                    }
	                                    if ((d[c[r >> 2] >> 0] | 0 | 0) == 43) {
	                                        u = 93;
	                                        break
	                                    }
	                                    if ((d[c[r >> 2] >> 0] | 0 | 0) == 45)u = 93
	                                } else u = 93; while (0);
	                                do if ((u | 0) == 93) {
	                                    c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                                    if (c[q >> 2] | 0)break;
	                                    if (d[c[r >> 2] >> 0] | 0)break c;
	                                    c[c[p >> 2] >> 2] = 10;
	                                    u = 123;
	                                    break c
	                                } while (0);
	                                if ((d[c[r >> 2] >> 0] | 0 | 0) == 84) {
	                                    c[r >> 2] = (c[r >> 2] | 0) + 1;
	                                    c[q >> 2] = KI((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                                    if (c[q >> 2] | 0)break;
	                                    c[q >> 2] = II((c[p >> 2] | 0) + 8 | 0, r) | 0;
	                                    d:do if (c[o >> 2] | 0)while (1) {
	                                        do if ((d[c[r >> 2] >> 0] | 0 | 0) != 32) {
	                                            if (9 <= (d[c[r >> 2] >> 0] | 0 | 0) ? (d[c[r >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                            if ((d[c[r >> 2] >> 0] | 0 | 0) != 13)break d
	                                        } while (0);
	                                        c[r >> 2] = (c[r >> 2] | 0) + 1
	                                    } while (0);
	                                    if (c[q >> 2] | 0)break;
	                                    if (d[c[r >> 2] >> 0] | 0)break;
	                                    if (!(c[(c[p >> 2] | 0) + 8 >> 2] | 0))break;
	                                    if ((c[(c[p >> 2] | 0) + 12 >> 2] & 15 | 0) < 1)break;
	                                    if ((c[(c[p >> 2] | 0) + 12 >> 2] & 15 | 0) > 12)break;
	                                    if (((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 100 | 0 | 0) != 0 : 0)u = 112; else u = 111;
	                                    do if ((u | 0) == 111) {
	                                        if (!((c[(c[p >> 2] | 0) + 8 >> 2] | 0) % 400 | 0)) {
	                                            u = 112;
	                                            break
	                                        }
	                                        if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31) >>> 0 > (c[171912 + ((c[(c[p >> 2] | 0) + 12 >> 2] & 15) - 1 << 2) >> 2] | 0) >>> 0)break c
	                                    } while (0);
	                                    if ((u | 0) == 112 ? ((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31) >>> 0 > (c[171864 + ((c[(c[p >> 2] | 0) + 12 >> 2] & 15) - 1 << 2) >> 2] | 0) >>> 0 : 0)break;
	                                    if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31 | 0) < 0)break;
	                                    if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31 | 0) > 23)break;
	                                    if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63 | 0) < 0)break;
	                                    if (((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63 | 0) > 59)break;
	                                    if (!(+h[(c[p >> 2] | 0) + 16 >> 3] >= 0.0))break;
	                                    if (!(+h[(c[p >> 2] | 0) + 16 >> 3] < 60.0))break;
	                                    if (((b[(c[p >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) <= -840)break;
	                                    if (((b[(c[p >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) >= 840)break;
	                                    c[c[p >> 2] >> 2] = 11;
	                                    u = 123
	                                }
	                            }
	                        }
	                    }
	                } while (0);
	                do if ((u | 0) == 123) {
	                    if ((c[l >> 2] | 0) != 0 ? (c[l >> 2] | 0) != (c[c[p >> 2] >> 2] | 0) : 0)break;
	                    r = c[p >> 2] | 0;
	                    if (c[n >> 2] | 0)c[c[n >> 2] >> 2] = r; else PH(r);
	                    c[k >> 2] = 0;
	                    t = c[k >> 2] | 0;
	                    i = j;
	                    return t | 0
	                } while (0);
	                if (c[p >> 2] | 0)PH(c[p >> 2] | 0);
	                c[k >> 2] = 1;
	                t = c[k >> 2] | 0;
	                i = j;
	                return t | 0
	            }

	            function rI(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 64 | 0;
	                j = g + 52 | 0;
	                k = g + 44 | 0;
	                l = g + 40 | 0;
	                m = g + 36 | 0;
	                n = g + 32 | 0;
	                o = g + 28 | 0;
	                p = g + 24 | 0;
	                q = g + 20 | 0;
	                r = g + 8 | 0;
	                s = g + 16 | 0;
	                t = g;
	                c[g + 48 >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = c[k >> 2];
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[s >> 2] = 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                a:do if (c[m >> 2] | 0)while (1) {
	                    do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                } while (0);
	                if ((d[c[n >> 2] >> 0] | 0 | 0) == 45) {
	                    c[p >> 2] = 1;
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                }
	                k = c[n >> 2] | 0;
	                c[n >> 2] = k + 1;
	                if ((d[k >> 0] | 0 | 0) != 80) {
	                    c[j >> 2] = 1;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                if (!(d[c[n >> 2] >> 0] | 0)) {
	                    c[j >> 2] = 1;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                c[o >> 2] = hI(12) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                b:while (1) {
	                    if (!(d[c[n >> 2] >> 0] | 0)) {
	                        v = 55;
	                        break
	                    }
	                    if ((c[q >> 2] | 0) >>> 0 >= 6) {
	                        v = 61;
	                        break
	                    }
	                    k = c[q >> 2] | 0;
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) != 84) {
	                        if ((k | 0) == 3) {
	                            v = 61;
	                            break
	                        }
	                    } else {
	                        if (k >>> 0 > 3) {
	                            v = 22;
	                            break
	                        }
	                        c[q >> 2] = 3;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                    h[r >> 3] = 0.0;
	                    c:do if ((d[c[n >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[n >> 2] >> 0] | 0 | 0) <= 57 : 0)while (1) {
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) < 48)break c;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) > 57)break c;
	                        h[r >> 3] = +h[r >> 3] * 10.0 + +((d[c[n >> 2] >> 0] | 0) - 48 | 0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    } else v = 26; while (0);
	                    if ((v | 0) == 26) {
	                        v = 0;
	                        c[s >> 2] = -1
	                    }
	                    d:do if ((c[s >> 2] | 0) == 0 ? (d[c[n >> 2] >> 0] | 0 | 0) == 46 : 0) {
	                        h[t >> 3] = 1.0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[n >> 2] >> 0] | 0 | 0) <= 57 : 0)c[s >> 2] = 1; else c[s >> 2] = -1;
	                        while (1) {
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) < 48)break d;
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) > 57)break d;
	                            h[t >> 3] = +h[t >> 3] / 10.0;
	                            h[r >> 3] = +h[r >> 3] + +((d[c[n >> 2] >> 0] | 0) - 48 | 0) * +h[t >> 3];
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    if ((c[s >> 2] | 0) == -1) {
	                        v = 61;
	                        break
	                    }
	                    if (!(d[c[n >> 2] >> 0] | 0)) {
	                        v = 61;
	                        break
	                    }
	                    while (1) {
	                        if ((c[q >> 2] | 0) >>> 0 >= 6)break;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) == (d[172280 + (c[q >> 2] | 0) >> 0] | 0 | 0)) {
	                            v = 43;
	                            break
	                        }
	                        k = (c[q >> 2] | 0) + 1 | 0;
	                        c[q >> 2] = k;
	                        if ((k | 0) == 3 | (c[q >> 2] | 0) == 6) {
	                            v = 61;
	                            break b
	                        }
	                    }
	                    do if ((v | 0) == 43) {
	                        v = 0;
	                        if ((c[s >> 2] | 0) != 0 & (c[q >> 2] | 0) >>> 0 < 5) {
	                            v = 61;
	                            break b
	                        }
	                        k = c[q >> 2] | 0;
	                        if ((k | 0) == 1) {
	                            f = (c[o >> 2] | 0) + 8 | 0;
	                            c[f >> 2] = (c[f >> 2] | 0) + ~~+h[r >> 3];
	                            break
	                        } else if (!k) {
	                            c[(c[o >> 2] | 0) + 8 >> 2] = ~~+h[r >> 3] * 12;
	                            break
	                        } else {
	                            k = (c[o >> 2] | 0) + 16 | 0;
	                            h[k >> 3] = +h[k >> 3] + +h[r >> 3] * +h[172288 + (c[q >> 2] << 3) >> 3];
	                            c[q >> 2] = (c[q >> 2] | 0) + 1;
	                            break
	                        }
	                    } while (0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1;
	                    if (!(c[m >> 2] | 0))continue;
	                    while (1) {
	                        do if ((d[c[n >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        c[n >> 2] = (c[n >> 2] | 0) + 1
	                    }
	                }
	                if ((v | 0) == 22) {
	                    c[j >> 2] = 1;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                } else if ((v | 0) == 55) {
	                    if (c[p >> 2] | 0) {
	                        c[(c[o >> 2] | 0) + 8 >> 2] = 0 - (c[(c[o >> 2] | 0) + 8 >> 2] | 0);
	                        c[(c[o >> 2] | 0) + 12 >> 2] = 0 - (c[(c[o >> 2] | 0) + 12 >> 2] | 0);
	                        h[(c[o >> 2] | 0) + 16 >> 3] = -+h[(c[o >> 2] | 0) + 16 >> 3]
	                    }
	                    p = c[o >> 2] | 0;
	                    if (c[l >> 2] | 0)c[c[l >> 2] >> 2] = p; else PH(p);
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                } else if ((v | 0) == 61) {
	                    if (c[o >> 2] | 0)PH(c[o >> 2] | 0);
	                    c[j >> 2] = 1;
	                    u = c[j >> 2] | 0;
	                    i = g;
	                    return u | 0
	                }
	                return 0
	            }

	            function sI(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[o >> 2] = my(c[l >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                if (c[m >> 2] | 0)c[c[m >> 2] >> 2] = 0;
	                c[p >> 2] = c[o >> 2];
	                a:while (1) {
	                    do if ((d[c[p >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[p >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    m = c[p >> 2] | 0;
	                    c[p >> 2] = m + 1;
	                    a[m >> 0] = 0
	                }
	                b:while (1) {
	                    if (!(d[c[p >> 2] >> 0] | 0))break;
	                    do if ((d[c[p >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[p >> 2] >> 0] | 0 | 0) != 13) {
	                            c[r >> 2] = (c[r >> 2] | 0) + 1;
	                            c[p >> 2] = (c[p >> 2] | 0) + 1;
	                            while (1) {
	                                if (!(d[c[p >> 2] >> 0] | 0))continue b;
	                                do if ((d[c[p >> 2] >> 0] | 0 | 0) == 32)u = 1; else {
	                                    if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        u = 1;
	                                        break
	                                    }
	                                    u = (d[c[p >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                if (!(u ^ 1))continue b;
	                                c[p >> 2] = (c[p >> 2] | 0) + 1
	                            }
	                        }
	                    } while (0);
	                    a[c[p >> 2] >> 0] = 0;
	                    c[p >> 2] = (c[p >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[p >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[p >> 2] >> 0] | 0 | 0) ? (d[c[p >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[p >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        m = c[p >> 2] | 0;
	                        c[p >> 2] = m + 1;
	                        a[m >> 0] = 0
	                    }
	                }
	                if (!(c[r >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                    c[j >> 2] = c[r >> 2];
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[q >> 2] = c[p >> 2];
	                c[p >> 2] = c[o >> 2];
	                while (1) {
	                    if (d[c[p >> 2] >> 0] | 0)break;
	                    if ((c[p >> 2] | 0) == (c[q >> 2] | 0))break;
	                    c[p >> 2] = (c[p >> 2] | 0) + 1
	                }
	                c:while (1) {
	                    if ((c[p >> 2] | 0) == (c[q >> 2] | 0))break;
	                    c[s >> 2] = TH(c[k >> 2] | 0, c[p >> 2] | 0, 0, c[n >> 2] | 0) | 0;
	                    if (c[s >> 2] | 0)break;
	                    while (1) {
	                        if (!(d[c[p >> 2] >> 0] | 0))break;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        if (d[c[p >> 2] >> 0] | 0)continue c;
	                        if ((c[p >> 2] | 0) == (c[q >> 2] | 0))continue c;
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                }
	                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                if (!(c[s >> 2] | 0)) {
	                    c[j >> 2] = c[r >> 2];
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                } else {
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                return 0
	            }

	            function tI(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[f >> 2] = a;
	                c[g >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                while (1) {
	                    do if (d[c[g >> 2] >> 0] | 0)if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            l = 1;
	                            break
	                        }
	                        l = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                    } else l = 0; while (0);
	                    m = c[g >> 2] | 0;
	                    if (!l)break;
	                    c[g >> 2] = m + 1
	                }
	                c[h >> 2] = m;
	                while (1) {
	                    n = c[h >> 2] | 0;
	                    if (!(d[c[h >> 2] >> 0] | 0))break;
	                    c[h >> 2] = n + 1
	                }
	                c[j >> 2] = n;
	                c[h >> 2] = (c[h >> 2] | 0) + -1;
	                while (1) {
	                    do if ((c[h >> 2] | 0) >>> 0 > (c[g >> 2] | 0) >>> 0)if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            o = 1;
	                            break
	                        }
	                        o = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                    } else o = 0; while (0);
	                    p = c[h >> 2] | 0;
	                    if (!o)break;
	                    c[h >> 2] = p + -1
	                }
	                c[h >> 2] = p + 1;
	                if ((c[g >> 2] | 0) == (c[f >> 2] | 0) ? (c[j >> 2] | 0) == (c[h >> 2] | 0) : 0) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[e >> 2] = ly(c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                k = c[e >> 2] | 0;
	                i = b;
	                return k | 0
	            }

	            function uI(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 4 | 0;
	                a[g >> 0] = b;
	                if (65 <= (d[g >> 0] | 0 | 0) ? (d[g >> 0] | 0 | 0) <= 90 : 0)c[f >> 2] = (d[g >> 0] | 0) - 65; else h = 4;
	                do if ((h | 0) == 4) {
	                    if (97 <= (d[g >> 0] | 0 | 0) ? (d[g >> 0] | 0 | 0) <= 122 : 0) {
	                        c[f >> 2] = (d[g >> 0] | 0) - 97 + 26;
	                        break
	                    }
	                    if (48 <= (d[g >> 0] | 0 | 0) ? (d[g >> 0] | 0 | 0) <= 57 : 0) {
	                        c[f >> 2] = (d[g >> 0] | 0) - 48 + 52;
	                        break
	                    }
	                    if (43 == (d[g >> 0] | 0 | 0)) {
	                        c[f >> 2] = 62;
	                        break
	                    }
	                    if (47 == (d[g >> 0] | 0 | 0)) {
	                        c[f >> 2] = 63;
	                        break
	                    }
	                    if (61 == (d[g >> 0] | 0 | 0)) {
	                        c[f >> 2] = 64;
	                        break
	                    } else {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                } while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function vI(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                h = f + 44 | 0;
	                j = f + 40 | 0;
	                k = f + 36 | 0;
	                l = f + 32 | 0;
	                m = f + 28 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 16 | 0;
	                q = f + 12 | 0;
	                r = f + 8 | 0;
	                s = f + 4 | 0;
	                t = f;
	                c[h >> 2] = a;
	                c[j >> 2] = d;
	                c[l >> 2] = 1;
	                a:do if (b[(c[h >> 2] | 0) + 24 >> 1] & 1) {
	                    if (((c[(c[h >> 2] | 0) + 8 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 0 : 0) {
	                        u = 11;
	                        break
	                    }
	                    do if (b[(c[j >> 2] | 0) + 24 >> 1] & 1) {
	                        if (((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 0 : 0)break;
	                        c[l >> 2] = -1;
	                        break a
	                    } while (0);
	                    c[g >> 2] = -1;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                } else u = 11; while (0);
	                do if ((u | 0) == 11 ? (b[(c[j >> 2] | 0) + 24 >> 1] & 1 | 0) != 0 : 0) {
	                    if (((c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 0 : 0)break;
	                    c[g >> 2] = 1;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                } while (0);
	                c[m >> 2] = ((e[(c[h >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535) - ((e[(c[h >> 2] | 0) + 24 >> 1] | 0) >>> 1 & 127);
	                c[n >> 2] = ((e[(c[j >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535) - ((e[(c[j >> 2] | 0) + 24 >> 1] | 0) >>> 1 & 127);
	                if ((c[m >> 2] | 0) == 1 ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                    if ((c[n >> 2] | 0) != 1) {
	                        c[g >> 2] = 0 - (c[l >> 2] | 0);
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    if (c[(c[j >> 2] | 0) + 8 >> 2] | 0) {
	                        c[g >> 2] = 0 - (c[l >> 2] | 0);
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    } else {
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                }
	                if ((c[n >> 2] | 0) == 1 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                    if ((c[m >> 2] | 0) != 1) {
	                        c[g >> 2] = c[l >> 2];
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 8 >> 2] | 0) {
	                        c[g >> 2] = c[l >> 2];
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    } else {
	                        c[g >> 2] = 0;
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                }
	                if ((c[m >> 2] | 0) > (c[n >> 2] | 0)) {
	                    c[g >> 2] = c[l >> 2];
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                if ((c[n >> 2] | 0) > (c[m >> 2] | 0)) {
	                    c[g >> 2] = 0 - (c[l >> 2] | 0);
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                c[o >> 2] = ((e[(c[h >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535) - ((e[(c[j >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535);
	                if ((c[o >> 2] | 0) < 0) {
	                    c[k >> 2] = c[h >> 2];
	                    c[p >> 2] = c[(c[j >> 2] | 0) + 16 >> 2];
	                    c[q >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                    c[r >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                    c[o >> 2] = 0 - (c[o >> 2] | 0);
	                    c[l >> 2] = 0 - (c[l >> 2] | 0)
	                } else {
	                    c[k >> 2] = c[j >> 2];
	                    c[p >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                    c[q >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                    c[r >> 2] = c[(c[h >> 2] | 0) + 8 >> 2]
	                }
	                while (1) {
	                    if ((c[o >> 2] | 0) <= 8)break;
	                    c[r >> 2] = c[q >> 2];
	                    c[q >> 2] = c[p >> 2];
	                    c[p >> 2] = 0;
	                    c[o >> 2] = (c[o >> 2] | 0) - 8
	                }
	                while (1) {
	                    w = c[p >> 2] | 0;
	                    if ((c[o >> 2] | 0) <= 0)break;
	                    c[s >> 2] = ca((w >>> 0) % 10 | 0, 1e8) | 0;
	                    c[p >> 2] = ((c[p >> 2] | 0) >>> 0) / 10 | 0;
	                    c[t >> 2] = ca(((c[q >> 2] | 0) >>> 0) % 10 | 0, 1e8) | 0;
	                    c[q >> 2] = (((c[q >> 2] | 0) + (c[s >> 2] | 0) | 0) >>> 0) / 10 | 0;
	                    c[r >> 2] = (((c[r >> 2] | 0) + (c[t >> 2] | 0) | 0) >>> 0) / 10 | 0;
	                    c[o >> 2] = (c[o >> 2] | 0) + -1
	                }
	                if (w >>> 0 > (c[(c[k >> 2] | 0) + 16 >> 2] | 0) >>> 0) {
	                    c[g >> 2] = c[l >> 2];
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                if ((c[p >> 2] | 0) == (c[(c[k >> 2] | 0) + 16 >> 2] | 0)) {
	                    if ((c[q >> 2] | 0) >>> 0 > (c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 0) {
	                        c[g >> 2] = c[l >> 2];
	                        v = c[g >> 2] | 0;
	                        i = f;
	                        return v | 0
	                    }
	                    if ((c[q >> 2] | 0) == (c[(c[k >> 2] | 0) + 12 >> 2] | 0)) {
	                        if ((c[r >> 2] | 0) >>> 0 > (c[(c[k >> 2] | 0) + 8 >> 2] | 0) >>> 0) {
	                            c[g >> 2] = c[l >> 2];
	                            v = c[g >> 2] | 0;
	                            i = f;
	                            return v | 0
	                        }
	                        if ((c[r >> 2] | 0) == (c[(c[k >> 2] | 0) + 8 >> 2] | 0))if (((e[(c[h >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535 | 0) == ((e[(c[j >> 2] | 0) + 24 >> 1] | 0) >>> 8 & 65535 | 0)) {
	                            c[g >> 2] = 0;
	                            v = c[g >> 2] | 0;
	                            i = f;
	                            return v | 0
	                        } else {
	                            c[g >> 2] = c[l >> 2];
	                            v = c[g >> 2] | 0;
	                            i = f;
	                            return v | 0
	                        }
	                    }
	                }
	                c[g >> 2] = 0 - (c[l >> 2] | 0);
	                v = c[g >> 2] | 0;
	                i = f;
	                return v | 0
	            }

	            function wI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 52 | 0;
	                f = d + 48 | 0;
	                g = d + 44 | 0;
	                j = d + 40 | 0;
	                k = d + 36 | 0;
	                l = d + 32 | 0;
	                m = d;
	                n = d + 28 | 0;
	                o = d + 24 | 0;
	                p = d + 20 | 0;
	                q = d + 16 | 0;
	                r = d + 12 | 0;
	                s = d + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[n >> 2] = 1;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -2;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                c[k >> 2] = (c[(c[f >> 2] | 0) + 8 >> 2] | 0) - (c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                h[m >> 3] = +h[(c[f >> 2] | 0) + 16 >> 3] - +h[(c[g >> 2] | 0) + 16 >> 3];
	                c[j >> 2] = ~~(+h[m >> 3] / 86400.0);
	                h[m >> 3] = +h[m >> 3] - +(c[j >> 2] | 0) * 86400.0;
	                c[l >> 2] = (c[(c[f >> 2] | 0) + 12 >> 2] | 0) - (c[(c[g >> 2] | 0) + 12 >> 2] | 0) + (c[j >> 2] | 0);
	                if (!(c[k >> 2] | 0)) {
	                    if (c[l >> 2] | 0)if ((c[l >> 2] | 0) < 0) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    } else {
	                        c[e >> 2] = 1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    if (+h[m >> 3] == 0.0) {
	                        c[e >> 2] = 0;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                    if (+h[m >> 3] < 0.0) {
	                        c[e >> 2] = -1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    } else {
	                        c[e >> 2] = 1;
	                        t = c[e >> 2] | 0;
	                        i = d;
	                        return t | 0
	                    }
	                }
	                j = c[l >> 2] | 0;
	                do if ((c[k >> 2] | 0) > 0) {
	                    if (!((j | 0) >= 0 & +h[m >> 3] >= 0.0)) {
	                        c[o >> 2] = c[k >> 2];
	                        c[p >> 2] = 0 - (c[l >> 2] | 0);
	                        break
	                    }
	                    c[e >> 2] = 1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                } else {
	                    if (!((j | 0) <= 0 & +h[m >> 3] <= 0.0)) {
	                        c[n >> 2] = -1;
	                        c[o >> 2] = 0 - (c[k >> 2] | 0);
	                        c[p >> 2] = c[l >> 2];
	                        break
	                    }
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                } while (0);
	                c[q >> 2] = (c[o >> 2] | 0) / 12 | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[r >> 2] = 0;
	                    c[s >> 2] = 0
	                } else {
	                    c[s >> 2] = ((((c[q >> 2] | 0) + 3 | 0) / 4 | 0) * 366 | 0) + ((((c[q >> 2] | 0) - 1 | 0) % 4 | 0) * 365 | 0);
	                    c[r >> 2] = (c[s >> 2] | 0) - 1
	                }
	                c[o >> 2] = (c[o >> 2] | 0) % 12 | 0;
	                c[r >> 2] = (c[r >> 2] | 0) + (c[172120 + (c[o >> 2] << 2) >> 2] | 0);
	                c[s >> 2] = (c[s >> 2] | 0) + (c[172168 + (c[o >> 2] << 2) >> 2] | 0);
	                if ((c[s >> 2] | 0) == (c[r >> 2] | 0) ? (c[s >> 2] | 0) == (c[p >> 2] | 0) : 0) {
	                    c[e >> 2] = 0;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[s >> 2] | 0) < (c[p >> 2] | 0)) {
	                    c[e >> 2] = 0 - (c[n >> 2] | 0);
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if ((c[r >> 2] | 0) > (c[p >> 2] | 0)) {
	                    c[e >> 2] = c[n >> 2];
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                } else {
	                    c[e >> 2] = 2;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                return 0
	            }

	            function xI(e, f) {
	                e = e | 0;
	                f = f | 0;
	                var g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
	                g = i;
	                i = i + 96 | 0;
	                j = g + 76 | 0;
	                k = g + 72 | 0;
	                l = g + 68 | 0;
	                m = g + 83 | 0;
	                n = g + 82 | 0;
	                o = g + 81 | 0;
	                p = g + 80 | 0;
	                q = g + 64 | 0;
	                r = g + 60 | 0;
	                s = g + 56 | 0;
	                t = g + 52 | 0;
	                u = g + 48 | 0;
	                v = g + 44 | 0;
	                w = g + 40 | 0;
	                x = g + 36 | 0;
	                y = g + 16 | 0;
	                z = g + 32 | 0;
	                A = g + 8 | 0;
	                B = g + 28 | 0;
	                C = g + 24 | 0;
	                D = g;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[j >> 2] = -2;
	                    E = c[j >> 2] | 0;
	                    i = g;
	                    return E | 0
	                }
	                f = (b[(c[l >> 2] | 0) + 24 >> 1] & 1 | 0) != 0;
	                do if (b[(c[k >> 2] | 0) + 24 >> 1] & 1) {
	                    if (!f) {
	                        c[q >> 2] = nI(c[k >> 2] | 0, 0.0) | 0;
	                        e = MI(c[q >> 2] | 0) | 0;
	                        c[u >> 2] = e + ((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                        c[s >> 2] = nI(c[l >> 2] | 0, 50400.0) | 0;
	                        e = MI(c[s >> 2] | 0) | 0;
	                        c[w >> 2] = e + ((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                        if ((c[u >> 2] | 0) < (c[w >> 2] | 0)) {
	                            PH(c[q >> 2] | 0);
	                            PH(c[s >> 2] | 0);
	                            c[j >> 2] = -1;
	                            E = c[j >> 2] | 0;
	                            i = g;
	                            return E | 0
	                        }
	                        e = c[q >> 2] | 0;
	                        if ((c[u >> 2] | 0) != (c[w >> 2] | 0)) {
	                            PH(e);
	                            PH(c[s >> 2] | 0);
	                            break
	                        }
	                        h[y >> 3] = +((((c[e + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[q >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[q >> 2] | 0) + 16 >> 3] - (+((((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[s >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[s >> 2] | 0) + 16 >> 3]);
	                        if (+h[y >> 3] < 0.0) {
	                            PH(c[q >> 2] | 0);
	                            PH(c[s >> 2] | 0);
	                            c[j >> 2] = -1;
	                            E = c[j >> 2] | 0;
	                            i = g;
	                            return E | 0
	                        }
	                        c[z >> 2] = 0;
	                        c[t >> 2] = nI(c[l >> 2] | 0, -50400.0) | 0;
	                        e = MI(c[t >> 2] | 0) | 0;
	                        c[x >> 2] = e + ((c[(c[t >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                        do if ((c[u >> 2] | 0) <= (c[x >> 2] | 0)) {
	                            if ((c[u >> 2] | 0) == (c[x >> 2] | 0)) {
	                                h[y >> 3] = +((((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[q >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[q >> 2] | 0) + 16 >> 3] - (+((((c[(c[t >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[t >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[t >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[t >> 2] | 0) + 16 >> 3]);
	                                if (+h[y >> 3] > 0.0) {
	                                    c[z >> 2] = 1;
	                                    break
	                                } else {
	                                    c[z >> 2] = 2;
	                                    break
	                                }
	                            }
	                        } else c[z >> 2] = 1; while (0);
	                        PH(c[q >> 2] | 0);
	                        PH(c[s >> 2] | 0);
	                        PH(c[t >> 2] | 0);
	                        if (c[z >> 2] | 0) {
	                            c[j >> 2] = c[z >> 2];
	                            E = c[j >> 2] | 0;
	                            i = g;
	                            return E | 0
	                        }
	                    }
	                } else if (f) {
	                    c[s >> 2] = nI(c[l >> 2] | 0, 0.0) | 0;
	                    e = MI(c[s >> 2] | 0) | 0;
	                    c[w >> 2] = e + ((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                    c[q >> 2] = nI(c[k >> 2] | 0, -50400.0) | 0;
	                    e = MI(c[q >> 2] | 0) | 0;
	                    c[u >> 2] = e + ((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                    if ((c[u >> 2] | 0) < (c[w >> 2] | 0)) {
	                        PH(c[q >> 2] | 0);
	                        PH(c[s >> 2] | 0);
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    e = c[q >> 2] | 0;
	                    if ((c[u >> 2] | 0) != (c[w >> 2] | 0)) {
	                        PH(e);
	                        PH(c[s >> 2] | 0);
	                        break
	                    }
	                    h[A >> 3] = +((((c[e + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[q >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[q >> 2] | 0) + 16 >> 3] - (+((((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[s >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[s >> 2] | 0) + 16 >> 3]);
	                    if (+h[A >> 3] < 0.0) {
	                        PH(c[q >> 2] | 0);
	                        PH(c[s >> 2] | 0);
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    c[B >> 2] = 0;
	                    c[r >> 2] = nI(c[k >> 2] | 0, 50400.0) | 0;
	                    e = MI(c[r >> 2] | 0) | 0;
	                    c[v >> 2] = e + ((c[(c[r >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                    do if ((c[v >> 2] | 0) <= (c[w >> 2] | 0)) {
	                        if ((c[v >> 2] | 0) == (c[w >> 2] | 0)) {
	                            h[A >> 3] = +((((c[(c[r >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[r >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[r >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[r >> 2] | 0) + 16 >> 3] - (+((((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[s >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[s >> 2] | 0) + 16 >> 3]);
	                            if (+h[A >> 3] > 0.0) {
	                                c[B >> 2] = 1;
	                                break
	                            } else {
	                                c[B >> 2] = 2;
	                                break
	                            }
	                        }
	                    } else c[B >> 2] = 1; while (0);
	                    PH(c[q >> 2] | 0);
	                    PH(c[s >> 2] | 0);
	                    PH(c[r >> 2] | 0);
	                    if (c[B >> 2] | 0) {
	                        c[j >> 2] = c[B >> 2];
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                } while (0);
	                if ((c[c[k >> 2] >> 2] | 0) == (c[c[l >> 2] >> 2] | 0)) {
	                    c[C >> 2] = 0;
	                    c[s >> 2] = nI(c[l >> 2] | 0, 0.0) | 0;
	                    B = MI(c[s >> 2] | 0) | 0;
	                    c[w >> 2] = B + ((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                    c[q >> 2] = nI(c[k >> 2] | 0, 0.0) | 0;
	                    B = MI(c[q >> 2] | 0) | 0;
	                    c[u >> 2] = B + ((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31);
	                    do if ((c[u >> 2] | 0) >= (c[w >> 2] | 0)) {
	                        if ((c[u >> 2] | 0) > (c[w >> 2] | 0)) {
	                            c[C >> 2] = 1;
	                            break
	                        }
	                        h[D >> 3] = +((((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[q >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[q >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[q >> 2] | 0) + 16 >> 3] - (+((((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31) * 3600 | 0) + (((c[(c[s >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63) * 60 | 0) + (((b[(c[s >> 2] | 0) + 24 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0) | 0) + +h[(c[s >> 2] | 0) + 16 >> 3]);
	                        if (+h[D >> 3] < 0.0) {
	                            c[C >> 2] = -1;
	                            break
	                        }
	                        if (+h[D >> 3] > 0.0)c[C >> 2] = 1
	                    } else c[C >> 2] = -1; while (0);
	                    PH(c[q >> 2] | 0);
	                    PH(c[s >> 2] | 0);
	                    c[j >> 2] = c[C >> 2];
	                    E = c[j >> 2] | 0;
	                    i = g;
	                    return E | 0
	                }
	                switch (c[c[k >> 2] >> 2] | 0) {
	                    case 6:
	                    {
	                        a[m >> 0] = 2;
	                        break
	                    }
	                    case 5:
	                    {
	                        a[m >> 0] = 3;
	                        break
	                    }
	                    case 9:
	                    {
	                        a[m >> 0] = 3;
	                        break
	                    }
	                    case 7:
	                    {
	                        a[m >> 0] = 6;
	                        break
	                    }
	                    case 4:
	                    {
	                        a[m >> 0] = 8;
	                        break
	                    }
	                    case 11:
	                    {
	                        a[m >> 0] = 15;
	                        break
	                    }
	                    case 10:
	                    {
	                        a[m >> 0] = 7;
	                        break
	                    }
	                    case 8:
	                    {
	                        a[m >> 0] = 1;
	                        break
	                    }
	                    default:
	                        a[m >> 0] = 0
	                }
	                switch (c[c[l >> 2] >> 2] | 0) {
	                    case 11:
	                    {
	                        a[n >> 0] = 15;
	                        break
	                    }
	                    case 10:
	                    {
	                        a[n >> 0] = 7;
	                        break
	                    }
	                    case 8:
	                    {
	                        a[n >> 0] = 1;
	                        break
	                    }
	                    case 6:
	                    {
	                        a[n >> 0] = 2;
	                        break
	                    }
	                    case 5:
	                    {
	                        a[n >> 0] = 3;
	                        break
	                    }
	                    case 9:
	                    {
	                        a[n >> 0] = 3;
	                        break
	                    }
	                    case 7:
	                    {
	                        a[n >> 0] = 6;
	                        break
	                    }
	                    case 4:
	                    {
	                        a[n >> 0] = 8;
	                        break
	                    }
	                    default:
	                        a[n >> 0] = 0
	                }
	                a[o >> 0] = (d[m >> 0] | 0) ^ (d[n >> 0] | 0);
	                a[p >> 0] = (d[m >> 0] | 0) & (d[n >> 0] | 0);
	                if ((d[o >> 0] | 0) & 1) {
	                    c[j >> 2] = 2;
	                    E = c[j >> 2] | 0;
	                    i = g;
	                    return E | 0
	                }
	                if ((d[p >> 0] | 0) & 1) {
	                    if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) < (c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) > (c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[j >> 2] = 1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                }
	                if ((d[o >> 0] | 0) & 2) {
	                    c[j >> 2] = 2;
	                    E = c[j >> 2] | 0;
	                    i = g;
	                    return E | 0
	                }
	                if ((d[p >> 0] | 0) & 2) {
	                    if ((c[(c[k >> 2] | 0) + 12 >> 2] & 15 | 0) < (c[(c[l >> 2] | 0) + 12 >> 2] & 15 | 0)) {
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if ((c[(c[k >> 2] | 0) + 12 >> 2] & 15 | 0) > (c[(c[l >> 2] | 0) + 12 >> 2] & 15 | 0)) {
	                        c[j >> 2] = 1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                }
	                if ((d[o >> 0] | 0) & 4) {
	                    c[j >> 2] = 2;
	                    E = c[j >> 2] | 0;
	                    i = g;
	                    return E | 0
	                }
	                if ((d[p >> 0] | 0) & 4) {
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31 | 0) < ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31 | 0)) {
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31 | 0) > ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 4 & 31 | 0)) {
	                        c[j >> 2] = 1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                }
	                if ((d[o >> 0] | 0) & 8) {
	                    c[j >> 2] = 2;
	                    E = c[j >> 2] | 0;
	                    i = g;
	                    return E | 0
	                }
	                if ((d[p >> 0] | 0) & 8) {
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31 | 0) < ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31 | 0)) {
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31 | 0) > ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 9 & 31 | 0)) {
	                        c[j >> 2] = 1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63 | 0) < ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63 | 0)) {
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if (((c[(c[k >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63 | 0) > ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 14 & 63 | 0)) {
	                        c[j >> 2] = 1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if (+h[(c[k >> 2] | 0) + 16 >> 3] < +h[(c[l >> 2] | 0) + 16 >> 3]) {
	                        c[j >> 2] = -1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                    if (+h[(c[k >> 2] | 0) + 16 >> 3] > +h[(c[l >> 2] | 0) + 16 >> 3]) {
	                        c[j >> 2] = 1;
	                        E = c[j >> 2] | 0;
	                        i = g;
	                        return E | 0
	                    }
	                }
	                c[j >> 2] = 0;
	                E = c[j >> 2] | 0;
	                i = g;
	                return E | 0
	            }

	            function yI(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                while (1) {
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        m = 24;
	                        break
	                    }
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        m = 24;
	                        break
	                    }
	                    if (((d[c[j >> 2] >> 0] | 0 | 0) != 9 ? (d[c[j >> 2] >> 0] | 0 | 0) != 10 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 13 : 0) {
	                        c[l >> 2] = (d[c[h >> 2] >> 0] | 0) - (d[c[j >> 2] >> 0] | 0);
	                        if ((c[l >> 2] | 0) < 0) {
	                            m = 16;
	                            break
	                        }
	                        if ((c[l >> 2] | 0) > 0) {
	                            m = 20;
	                            break
	                        }
	                    } else m = 7;
	                    if ((m | 0) == 7 ? (m = 0, (d[c[h >> 2] >> 0] | 0 | 0) != 32) : 0) {
	                        m = 8;
	                        break
	                    }
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                do if ((m | 0) == 8) {
	                    l = (c[k >> 2] | 0) != 0;
	                    if (((d[c[h >> 2] >> 0] | 0) - 32 | 0) < 0)if (l) {
	                        c[g >> 2] = 1;
	                        break
	                    } else {
	                        c[g >> 2] = -1;
	                        break
	                    } else if (l) {
	                        c[g >> 2] = -1;
	                        break
	                    } else {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                } else if ((m | 0) == 16)if (c[k >> 2] | 0) {
	                    c[g >> 2] = 1;
	                    break
	                } else {
	                    c[g >> 2] = -1;
	                    break
	                } else if ((m | 0) == 20)if (c[k >> 2] | 0) {
	                    c[g >> 2] = -1;
	                    break
	                } else {
	                    c[g >> 2] = 1;
	                    break
	                } else if ((m | 0) == 24) {
	                    if (d[c[h >> 2] >> 0] | 0)if (c[k >> 2] | 0) {
	                        c[g >> 2] = -1;
	                        break
	                    } else {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    if (c[k >> 2] | 0) {
	                        c[g >> 2] = 1;
	                        break
	                    } else {
	                        c[g >> 2] = -1;
	                        break
	                    }
	                } while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function zI(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                a:while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        m = 35;
	                        break
	                    }
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        m = 35;
	                        break
	                    }
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13) {
	                            e = c[h >> 2] | 0;
	                            c[h >> 2] = e + 1;
	                            b = d[e >> 0] | 0;
	                            e = c[j >> 2] | 0;
	                            c[j >> 2] = e + 1;
	                            c[l >> 2] = b - (d[e >> 0] | 0);
	                            if ((c[l >> 2] | 0) < 0) {
	                                m = 28;
	                                break b
	                            }
	                            if ((c[l >> 2] | 0) > 0) {
	                                m = 32;
	                                break b
	                            } else continue b
	                        }
	                    } while (0);
	                    n = c[h >> 2] | 0;
	                    if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        m = 14;
	                        break
	                    }
	                    c[h >> 2] = n + 1;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                }
	                do if ((m | 0) == 14) {
	                    l = (c[k >> 2] | 0) != 0;
	                    if (((d[n >> 0] | 0) - 32 | 0) < 0)if (l) {
	                        c[g >> 2] = 1;
	                        break
	                    } else {
	                        c[g >> 2] = -1;
	                        break
	                    } else if (l) {
	                        c[g >> 2] = -1;
	                        break
	                    } else {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                } else if ((m | 0) == 28)if (c[k >> 2] | 0) {
	                    c[g >> 2] = 1;
	                    break
	                } else {
	                    c[g >> 2] = -1;
	                    break
	                } else if ((m | 0) == 32)if (c[k >> 2] | 0) {
	                    c[g >> 2] = -1;
	                    break
	                } else {
	                    c[g >> 2] = 1;
	                    break
	                } else if ((m | 0) == 35) {
	                    if (d[c[h >> 2] >> 0] | 0)if (c[k >> 2] | 0) {
	                        c[g >> 2] = -1;
	                        break
	                    } else {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                    if (d[c[j >> 2] >> 0] | 0) {
	                        while (1) {
	                            do if ((d[c[j >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                                if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    o = 1;
	                                    break
	                                }
	                                o = (d[c[j >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            p = c[j >> 2] | 0;
	                            if (!o)break;
	                            c[j >> 2] = p + 1
	                        }
	                        if (d[p >> 0] | 0)if (c[k >> 2] | 0) {
	                            c[g >> 2] = 1;
	                            break
	                        } else {
	                            c[g >> 2] = -1;
	                            break
	                        }
	                    }
	                    c[g >> 2] = 0
	                } while (0);
	                i = f;
	                return c[g >> 2] | 0
	            }

	            function AI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                a:while (1) {
	                    if (!(d[c[g >> 2] >> 0] | 0)) {
	                        k = 27;
	                        break
	                    }
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        k = 27;
	                        break
	                    }
	                    do if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            k = 8;
	                            break
	                        }
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 13) {
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) == 32) {
	                                k = 19;
	                                break a
	                            }
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                k = 19;
	                                break a
	                            }
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) == 13) {
	                                k = 19;
	                                break a
	                            }
	                            c[j >> 2] = (d[c[g >> 2] >> 0] | 0) - (d[c[h >> 2] >> 0] | 0);
	                            if ((c[j >> 2] | 0) < 0) {
	                                k = 23;
	                                break a
	                            }
	                            if ((c[j >> 2] | 0) > 0) {
	                                k = 25;
	                                break a
	                            }
	                        } else k = 8
	                    } else k = 8; while (0);
	                    do if ((k | 0) == 8 ? (k = 0, (d[c[g >> 2] >> 0] | 0 | 0) != 32) : 0) {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) != 13) {
	                            k = 12;
	                            break a
	                        }
	                    } while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((k | 0) == 12)if (((d[c[g >> 2] >> 0] | 0) - 32 | 0) < 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((k | 0) == 19)if ((32 - (d[c[h >> 2] >> 0] | 0) | 0) < 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((k | 0) == 23) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((k | 0) == 25) {
	                    c[f >> 2] = 1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else if ((k | 0) == 27) {
	                    if (d[c[g >> 2] >> 0] | 0) {
	                        c[f >> 2] = 1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    if (d[c[h >> 2] >> 0] | 0) {
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    } else {
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                }
	                return 0
	            }

	            function BI(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                a:while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        m = 45;
	                        break
	                    }
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        m = 45;
	                        break
	                    }
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13) {
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) == 32) {
	                                m = 34;
	                                break b
	                            }
	                            if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                m = 34;
	                                break b
	                            }
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) == 13) {
	                                m = 34;
	                                break b
	                            }
	                            e = c[h >> 2] | 0;
	                            c[h >> 2] = e + 1;
	                            b = d[e >> 0] | 0;
	                            e = c[j >> 2] | 0;
	                            c[j >> 2] = e + 1;
	                            c[l >> 2] = b - (d[e >> 0] | 0);
	                            if ((c[l >> 2] | 0) < 0) {
	                                m = 42;
	                                break b
	                            }
	                            if ((c[l >> 2] | 0) > 0) {
	                                m = 44;
	                                break b
	                            } else continue b
	                        }
	                    } while (0);
	                    do if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 13) {
	                            m = 17;
	                            break b
	                        }
	                    } while (0);
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)continue b
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                }
	                if ((m | 0) == 17) {
	                    l = (c[k >> 2] | 0) != 0;
	                    if (((d[c[h >> 2] >> 0] | 0) - 32 | 0) < 0)if (l) {
	                        c[g >> 2] = 1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else if (l) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else {
	                        c[g >> 2] = 1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                } else if ((m | 0) == 34) {
	                    l = (c[k >> 2] | 0) != 0;
	                    if ((32 - (d[c[j >> 2] >> 0] | 0) | 0) < 0)if (l) {
	                        c[g >> 2] = 1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else if (l) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else {
	                        c[g >> 2] = 1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                } else if ((m | 0) == 42) {
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((m | 0) == 44) {
	                    c[g >> 2] = 1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((m | 0) == 45) {
	                    if (d[c[h >> 2] >> 0] | 0)if (c[k >> 2] | 0) {
	                        c[g >> 2] = -1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    } else {
	                        c[g >> 2] = 1;
	                        n = c[g >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    if (d[c[j >> 2] >> 0] | 0) {
	                        while (1) {
	                            do if ((d[c[j >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                                if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    o = 1;
	                                    break
	                                }
	                                o = (d[c[j >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            p = c[j >> 2] | 0;
	                            if (!o)break;
	                            c[j >> 2] = p + 1
	                        }
	                        if (d[p >> 0] | 0)if (c[k >> 2] | 0) {
	                            c[g >> 2] = 1;
	                            n = c[g >> 2] | 0;
	                            i = f;
	                            return n | 0
	                        } else {
	                            c[g >> 2] = -1;
	                            n = c[g >> 2] | 0;
	                            i = f;
	                            return n | 0
	                        }
	                    }
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function CI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                a:while (1) {
	                    do if ((d[c[g >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    do if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 13)break b
	                    } while (0);
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                c:while (1) {
	                    if (d[c[g >> 2] >> 0] | 0)k = (d[c[h >> 2] >> 0] | 0 | 0) != 0; else k = 0;
	                    l = d[c[g >> 2] >> 0] | 0;
	                    if (!k) {
	                        m = 38;
	                        break
	                    }
	                    do if ((l | 0) != 32) {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) != 13) {
	                            b = c[g >> 2] | 0;
	                            c[g >> 2] = b + 1;
	                            a = d[b >> 0] | 0;
	                            b = c[h >> 2] | 0;
	                            c[h >> 2] = b + 1;
	                            c[j >> 2] = a - (d[b >> 0] | 0);
	                            if ((c[j >> 2] | 0) < 0) {
	                                m = 35;
	                                break c
	                            }
	                            if ((c[j >> 2] | 0) > 0) {
	                                m = 37;
	                                break c
	                            } else continue c
	                        }
	                    } while (0);
	                    do if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[h >> 2] >> 0] | 0 | 0) != 13) {
	                            m = 23;
	                            break c
	                        }
	                    } while (0);
	                    d:while (1) {
	                        do if ((d[c[g >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) != 13)break d
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        do if ((d[c[h >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[h >> 2] >> 0] | 0 | 0) != 13)continue c
	                        } while (0);
	                        c[h >> 2] = (c[h >> 2] | 0) + 1
	                    }
	                }
	                if ((m | 0) == 23) {
	                    c[j >> 2] = (d[c[g >> 2] >> 0] | 0) - (d[c[h >> 2] >> 0] | 0);
	                    c[f >> 2] = c[j >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((m | 0) == 35) {
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((m | 0) == 37) {
	                    c[f >> 2] = 1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((m | 0) == 38) {
	                    if (l) {
	                        while (1) {
	                            do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                                if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    o = 1;
	                                    break
	                                }
	                                o = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            p = c[g >> 2] | 0;
	                            if (!o)break;
	                            c[g >> 2] = p + 1
	                        }
	                        if (d[p >> 0] | 0) {
	                            c[f >> 2] = 1;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                    }
	                    if (d[c[h >> 2] >> 0] | 0) {
	                        while (1) {
	                            do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)q = 1; else {
	                                if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    q = 1;
	                                    break
	                                }
	                                q = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            r = c[h >> 2] | 0;
	                            if (!q)break;
	                            c[h >> 2] = r + 1
	                        }
	                        if (d[r >> 0] | 0) {
	                            c[f >> 2] = -1;
	                            n = c[f >> 2] | 0;
	                            i = e;
	                            return n | 0
	                        }
	                    }
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function DI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 8 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[j >> 2] = b;
	                a:do if (!((c[f >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0)) {
	                    b = c[f >> 2] | 0;
	                    do if ((c[c[f >> 2] >> 2] | 0) != 14)if ((c[b >> 2] | 0) == 13) {
	                        h[k >> 3] = +g[(c[f >> 2] | 0) + 8 >> 2];
	                        break
	                    } else {
	                        c[e >> 2] = -2;
	                        break a
	                    } else h[k >> 3] = +h[b + 8 >> 3]; while (0);
	                    b = c[j >> 2] | 0;
	                    do if ((c[c[j >> 2] >> 2] | 0) != 14)if ((c[b >> 2] | 0) == 13) {
	                        h[l >> 3] = +g[(c[j >> 2] | 0) + 8 >> 2];
	                        break
	                    } else {
	                        c[e >> 2] = -2;
	                        break a
	                    } else h[l >> 3] = +h[b + 8 >> 3]; while (0);
	                    b = (Lq(+h[k >> 3]) | 0) != 0;
	                    a = (Lq(+h[l >> 3]) | 0) != 0;
	                    if (b)if (a) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (a) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    a = +h[l >> 3] == +h[15985];
	                    if (+h[k >> 3] == +h[15985])if (a) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (a) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    a = +h[l >> 3] == +h[15986];
	                    if (+h[k >> 3] == +h[15986])if (a) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (a) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (+h[k >> 3] < +h[l >> 3]) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    if (+h[k >> 3] > +h[l >> 3]) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (+h[k >> 3] == +h[l >> 3]) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = 2;
	                        break
	                    }
	                } else c[e >> 2] = -2; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function EI(a, b, d, e, f, g, h, j) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                k = i;
	                i = i + 32 | 0;
	                l = k + 28 | 0;
	                m = k + 24 | 0;
	                n = k + 20 | 0;
	                o = k + 16 | 0;
	                p = k + 12 | 0;
	                q = k + 8 | 0;
	                r = k + 4 | 0;
	                s = k;
	                c[l >> 2] = a;
	                c[m >> 2] = b;
	                c[n >> 2] = d;
	                c[o >> 2] = e;
	                c[p >> 2] = f;
	                c[q >> 2] = g;
	                c[r >> 2] = h;
	                c[s >> 2] = j;
	                j = kI(c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0) | 0;
	                i = k;
	                return j | 0
	            }

	            function FI(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[g >> 2] = c[f >> 2];
	                a:while (1) {
	                    do if ((d[c[g >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[g >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if (!(d[c[g >> 2] >> 0] | 0)) {
	                        k = 36;
	                        break
	                    }
	                    f = c[g >> 2] | 0;
	                    c:do if (!((d[c[g >> 2] >> 0] | 0) & 128)) {
	                        do if ((d[f >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[g >> 2] >> 0] | 0 | 0) != 13) {
	                                c[g >> 2] = (c[g >> 2] | 0) + 1;
	                                break c
	                            }
	                        } while (0);
	                        while (1) {
	                            do if ((d[c[g >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                                if (9 <= (d[c[g >> 2] >> 0] | 0 | 0) ? (d[c[g >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                l = (d[c[g >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            m = c[g >> 2] | 0;
	                            if (!l)break;
	                            c[g >> 2] = m + 1
	                        }
	                        if (!(d[m >> 0] | 0)) {
	                            k = 36;
	                            break b
	                        }
	                    } else {
	                        if (((d[f + 1 >> 0] | 0) & 192 | 0) != 128) {
	                            k = 12;
	                            break b
	                        }
	                        a = (c[g >> 2] | 0) + 2 | 0;
	                        if (((d[c[g >> 2] >> 0] | 0) & 224 | 0) != 224) {
	                            c[g >> 2] = a;
	                            break
	                        }
	                        if (((d[a >> 0] | 0) & 192 | 0) != 128) {
	                            k = 15;
	                            break b
	                        }
	                        a = c[g >> 2] | 0;
	                        if (((d[c[g >> 2] >> 0] | 0) & 240 | 0) != 240) {
	                            c[g >> 2] = a + 3;
	                            break
	                        }
	                        if (((d[a >> 0] | 0) & 248 | 0) != 240) {
	                            k = 19;
	                            break b
	                        }
	                        if (((d[(c[g >> 2] | 0) + 3 >> 0] | 0) & 192 | 0) != 128) {
	                            k = 19;
	                            break b
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + 4
	                    } while (0);
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((k | 0) == 12) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else if ((k | 0) == 15) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else if ((k | 0) == 19) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                } else if ((k | 0) == 36) {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function GI(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0.0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                j = e + 40 | 0;
	                k = e + 36 | 0;
	                l = e + 32 | 0;
	                m = e + 28 | 0;
	                n = e + 24 | 0;
	                o = e + 20 | 0;
	                p = e + 16 | 0;
	                q = e + 12 | 0;
	                r = e + 8 | 0;
	                s = e + 4 | 0;
	                t = e;
	                c[g >> 2] = a;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    u = c[f >> 2] | 0;
	                    i = e;
	                    return u | 0
	                }
	                c[k >> 2] = hI(c[c[g >> 2] >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    u = c[f >> 2] | 0;
	                    i = e;
	                    return u | 0
	                }
	                c[l >> 2] = jI(c[g >> 2] | 0) | 0;
	                g = c[k >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    PH(g);
	                    c[f >> 2] = 0;
	                    u = c[f >> 2] | 0;
	                    i = e;
	                    return u | 0
	                }
	                c[p >> 2] = g + 8;
	                c[q >> 2] = (c[l >> 2] | 0) + 8;
	                c[r >> 2] = (c[j >> 2] | 0) + 8;
	                if (!(c[(c[q >> 2] | 0) + 4 >> 2] & 15)) {
	                    j = (c[q >> 2] | 0) + 4 | 0;
	                    c[j >> 2] = c[j >> 2] & -16 | 1
	                }
	                j = (c[r >> 2] | 0) + 8 | 0;
	                h[j >> 3] = +h[j >> 3] - +(((b[(c[q >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) * 60 | 0);
	                j = (c[q >> 2] | 0) + 16 | 0;
	                b[j >> 1] = b[j >> 1] & -8191;
	                if (!((c[(c[q >> 2] | 0) + 4 >> 2] | 0) >>> 4 & 31)) {
	                    j = (c[q >> 2] | 0) + 4 | 0;
	                    c[j >> 2] = c[j >> 2] & -497 | 16
	                }
	                c[m >> 2] = (c[(c[q >> 2] | 0) + 4 >> 2] & 15) + (c[c[r >> 2] >> 2] | 0);
	                j = ~~(+((c[m >> 2] | 0) - 1 | 0) - +Q(+(+((c[m >> 2] | 0) - 1 | 0) / 12.0)) * 12.0 + 1.0) >>> 0;
	                g = (c[p >> 2] | 0) + 4 | 0;
	                c[g >> 2] = c[g >> 2] & -16 | j & 15;
	                c[m >> 2] = ~~+Q(+(+((c[m >> 2] | 0) - 1 | 0) / 12.0));
	                c[c[p >> 2] >> 2] = (c[c[q >> 2] >> 2] | 0) + (c[m >> 2] | 0);
	                do if (!(c[c[p >> 2] >> 2] | 0)) {
	                    j = c[p >> 2] | 0;
	                    g = c[j >> 2] | 0;
	                    if ((c[c[q >> 2] >> 2] | 0) > 0) {
	                        c[j >> 2] = g + -1;
	                        break
	                    } else {
	                        c[j >> 2] = g + 1;
	                        break
	                    }
	                } while (0);
	                g = (c[p >> 2] | 0) + 16 | 0;
	                b[g >> 1] = b[g >> 1] & -8191 | ((b[(c[q >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 & 4095) << 1 & 65535;
	                g = (c[p >> 2] | 0) + 16 | 0;
	                b[g >> 1] = b[g >> 1] & -2 | b[(c[q >> 2] | 0) + 16 >> 1] & 1;
	                h[(c[p >> 2] | 0) + 8 >> 3] = +h[(c[q >> 2] | 0) + 8 >> 3] + +h[(c[r >> 2] | 0) + 8 >> 3];
	                c[m >> 2] = ~~+Q(+(+(~~+h[(c[p >> 2] | 0) + 8 >> 3] | 0) / 60.0));
	                if (+h[(c[p >> 2] | 0) + 8 >> 3] != 0.0) {
	                    v = +h[(c[p >> 2] | 0) + 8 >> 3] - +Q(+(+h[(c[p >> 2] | 0) + 8 >> 3] / 60.0)) * 60.0;
	                    h[(c[p >> 2] | 0) + 8 >> 3] = v
	                }
	                c[m >> 2] = (c[m >> 2] | 0) + ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) >>> 14 & 63);
	                g = ~~(+(c[m >> 2] | 0) - +Q(+(+(c[m >> 2] | 0) / 60.0)) * 60.0) >>> 0;
	                j = (c[p >> 2] | 0) + 4 | 0;
	                c[j >> 2] = c[j >> 2] & -1032193 | (g & 63) << 14;
	                c[m >> 2] = ~~+Q(+(+(c[m >> 2] | 0) / 60.0));
	                c[m >> 2] = (c[m >> 2] | 0) + ((c[(c[q >> 2] | 0) + 4 >> 2] | 0) >>> 9 & 31);
	                g = ~~(+(c[m >> 2] | 0) - +Q(+(+(c[m >> 2] | 0) / 24.0)) * 24.0) >>> 0;
	                j = (c[p >> 2] | 0) + 4 | 0;
	                c[j >> 2] = c[j >> 2] & -15873 | (g & 31) << 9;
	                c[m >> 2] = ~~+Q(+(+(c[m >> 2] | 0) / 24.0));
	                if (((c[c[p >> 2] >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 4 >> 2] & 15 | 0) >= 1 : 0) ? (c[(c[p >> 2] | 0) + 4 >> 2] & 15 | 0) <= 12 : 0) {
	                    g = (c[(c[q >> 2] | 0) + 4 >> 2] | 0) >>> 4 & 31;
	                    if (((c[c[p >> 2] >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[c[p >> 2] >> 2] | 0) % 100 | 0 | 0) != 0 : 0)w = 23; else if (!((c[c[p >> 2] >> 2] | 0) % 400 | 0))w = 23; else x = c[171912 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0;
	                    if ((w | 0) == 23)x = c[171864 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0;
	                    if (g >>> 0 > x >>> 0) {
	                        if (((c[c[p >> 2] >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[c[p >> 2] >> 2] | 0) % 100 | 0 | 0) != 0 : 0)w = 29; else if (!((c[c[p >> 2] >> 2] | 0) % 400 | 0))w = 29; else y = c[171912 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0;
	                        if ((w | 0) == 29)y = c[171864 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0;
	                        c[n >> 2] = y
	                    } else w = 32
	                } else w = 32;
	                do if ((w | 0) == 32)if (((c[(c[q >> 2] | 0) + 4 >> 2] | 0) >>> 4 & 31 | 0) < 1) {
	                    c[n >> 2] = 1;
	                    break
	                } else {
	                    c[n >> 2] = (c[(c[q >> 2] | 0) + 4 >> 2] | 0) >>> 4 & 31;
	                    break
	                } while (0);
	                c[n >> 2] = (c[n >> 2] | 0) + ((c[(c[r >> 2] | 0) + 4 >> 2] | 0) + (c[m >> 2] | 0));
	                while (1) {
	                    r = c[p >> 2] | 0;
	                    if ((c[n >> 2] | 0) < 1) {
	                        c[s >> 2] = ~~(+((c[r + 4 >> 2] & 15) - 1 - 1 | 0) - +Q(+(+((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 - 1 | 0) / 12.0)) * 12.0 + 1.0);
	                        c[t >> 2] = (c[c[p >> 2] >> 2] | 0) + ~~+Q(+(+((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 - 1 | 0) / 12.0));
	                        if (!(c[t >> 2] | 0))c[t >> 2] = (c[t >> 2] | 0) + -1;
	                        if ((c[s >> 2] | 0) < 1)c[s >> 2] = 1;
	                        if ((c[s >> 2] | 0) > 12)c[s >> 2] = 12;
	                        if (((c[t >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[t >> 2] | 0) % 100 | 0 | 0) != 0 : 0)w = 46; else if (!((c[t >> 2] | 0) % 400 | 0))w = 46; else z = c[171912 + ((c[s >> 2] | 0) - 1 << 2) >> 2] | 0;
	                        if ((w | 0) == 46) {
	                            w = 0;
	                            z = c[171864 + ((c[s >> 2] | 0) - 1 << 2) >> 2] | 0
	                        }
	                        c[n >> 2] = (c[n >> 2] | 0) + z;
	                        c[m >> 2] = -1
	                    } else {
	                        if (!(c[r >> 2] | 0))break;
	                        if ((c[(c[p >> 2] | 0) + 4 >> 2] & 15 | 0) < 1)break;
	                        if ((c[(c[p >> 2] | 0) + 4 >> 2] & 15 | 0) > 12)break;
	                        r = c[n >> 2] | 0;
	                        if (((c[c[p >> 2] >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[c[p >> 2] >> 2] | 0) % 100 | 0 | 0) != 0 : 0)w = 55; else if (!((c[c[p >> 2] >> 2] | 0) % 400 | 0))w = 55; else A = c[171912 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0;
	                        if ((w | 0) == 55) {
	                            w = 0;
	                            A = c[171864 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0
	                        }
	                        if ((r | 0) <= (A | 0))break;
	                        r = c[n >> 2] | 0;
	                        if (((c[c[p >> 2] >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[c[p >> 2] >> 2] | 0) % 100 | 0 | 0) != 0 : 0)w = 61; else if (!((c[c[p >> 2] >> 2] | 0) % 400 | 0))w = 61; else B = c[171912 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0;
	                        if ((w | 0) == 61) {
	                            w = 0;
	                            B = c[171864 + ((c[(c[p >> 2] | 0) + 4 >> 2] & 15) - 1 << 2) >> 2] | 0
	                        }
	                        c[n >> 2] = r - B;
	                        c[m >> 2] = 1
	                    }
	                    c[o >> 2] = (c[(c[p >> 2] | 0) + 4 >> 2] & 15) + (c[m >> 2] | 0);
	                    r = ~~(+((c[o >> 2] | 0) - 1 | 0) - +Q(+(+((c[o >> 2] | 0) - 1 | 0) / 12.0)) * 12.0 + 1.0) >>> 0;
	                    q = (c[p >> 2] | 0) + 4 | 0;
	                    c[q >> 2] = c[q >> 2] & -16 | r & 15;
	                    r = (c[c[p >> 2] >> 2] | 0) + (~~+Q(+(+((c[o >> 2] | 0) - 1 | 0) / 12.0)) >>> 0) | 0;
	                    c[c[p >> 2] >> 2] = r;
	                    if (c[c[p >> 2] >> 2] | 0)continue;
	                    r = c[p >> 2] | 0;
	                    q = c[r >> 2] | 0;
	                    if ((c[o >> 2] | 0) < 1) {
	                        c[r >> 2] = q + -1;
	                        continue
	                    } else {
	                        c[r >> 2] = q + 1;
	                        continue
	                    }
	                }
	                o = (c[p >> 2] | 0) + 4 | 0;
	                c[o >> 2] = c[o >> 2] & -497 | (c[n >> 2] & 31) << 4;
	                do if ((c[c[k >> 2] >> 2] | 0) != 11) {
	                    if ((((c[(c[p >> 2] | 0) + 4 >> 2] | 0) >>> 9 & 31 | 0) == 0 ? ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) >>> 14 & 63 | 0) == 0 : 0) ? !(+h[(c[p >> 2] | 0) + 8 >> 3] != 0.0) : 0) {
	                        if ((c[c[k >> 2] >> 2] | 0) == 10)break;
	                        if ((c[(c[p >> 2] | 0) + 4 >> 2] & 15 | 0) != 1 ? ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) >>> 4 & 31 | 0) != 1 : 0) {
	                            c[c[k >> 2] >> 2] = 10;
	                            break
	                        }
	                        if ((c[c[k >> 2] >> 2] | 0) == 9)break;
	                        if ((c[(c[p >> 2] | 0) + 4 >> 2] & 15 | 0) == 1)break;
	                        c[c[k >> 2] >> 2] = 9;
	                        break
	                    }
	                    c[c[k >> 2] >> 2] = 11
	                } while (0);
	                PH(c[l >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                u = c[f >> 2] | 0;
	                i = e;
	                return u | 0
	            }

	            function HI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if ((((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)c[l >> 2] = (((d[c[j >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[j >> 2] | 0) + 1 >> 0] | 0) - 48); else c[k >> 2] = 1;
	                c[j >> 2] = (c[j >> 2] | 0) + 2;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if ((c[l >> 2] | 0) >>> 0 >= 1 & (c[l >> 2] | 0) >>> 0 <= 31) {
	                    k = (c[g >> 2] | 0) + 4 | 0;
	                    c[k >> 2] = c[k >> 2] & -497 | (c[l >> 2] & 31) << 4;
	                    c[c[h >> 2] >> 2] = c[j >> 2];
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = 2;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function II(a, e) {
	                a = a | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = e;
	                c[l >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[k >> 2] = c[c[j >> 2] >> 2];
	                e = d[c[k >> 2] >> 0] | 0;
	                do if ((e | 0) == 45 | (e | 0) == 43) {
	                    c[m >> 2] = 0;
	                    c[n >> 2] = 0;
	                    c[m >> 2] = (d[c[k >> 2] >> 0] | 0 | 0) == 45 & 1;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    if ((((d[c[k >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[k >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)c[n >> 2] = (((d[c[k >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[k >> 2] | 0) + 1 >> 0] | 0) - 48); else c[l >> 2] = 1;
	                    c[k >> 2] = (c[k >> 2] | 0) + 2;
	                    if (c[l >> 2] | 0) {
	                        c[g >> 2] = c[l >> 2];
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    if (!((c[n >> 2] | 0) >= 0 & (c[n >> 2] | 0) <= 23)) {
	                        c[g >> 2] = 2;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    if ((d[c[k >> 2] >> 0] | 0 | 0) != 58) {
	                        c[g >> 2] = 1;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    a = (c[h >> 2] | 0) + 16 | 0;
	                    b[a >> 1] = b[a >> 1] & -8191 | ((c[n >> 2] | 0) * 60 & 4095) << 1 & 65535;
	                    if ((((d[c[k >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[k >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)c[n >> 2] = (((d[c[k >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[k >> 2] | 0) + 1 >> 0] | 0) - 48); else c[l >> 2] = 1;
	                    c[k >> 2] = (c[k >> 2] | 0) + 2;
	                    if (c[l >> 2] | 0) {
	                        c[g >> 2] = c[l >> 2];
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    if (!((c[n >> 2] | 0) >= 0 & (c[n >> 2] | 0) <= 59)) {
	                        c[g >> 2] = 2;
	                        o = c[g >> 2] | 0;
	                        i = f;
	                        return o | 0
	                    }
	                    a = (c[h >> 2] | 0) + 16 | 0;
	                    b[a >> 1] = b[a >> 1] & -8191 | (((b[a >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) + (c[n >> 2] | 0) & 4095) << 1 & 65535;
	                    if (c[m >> 2] | 0) {
	                        a = (c[h >> 2] | 0) + 16 | 0;
	                        b[a >> 1] = b[a >> 1] & -8191 | (0 - ((b[(c[h >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16) & 4095) << 1 & 65535
	                    }
	                    if (((b[(c[h >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) > -840 ? ((b[(c[h >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) < 840 : 0) {
	                        a = (c[h >> 2] | 0) + 16 | 0;
	                        b[a >> 1] = b[a >> 1] & -2 | 1;
	                        break
	                    }
	                    c[g >> 2] = 2;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } else if (!e) {
	                    a = (c[h >> 2] | 0) + 16 | 0;
	                    b[a >> 1] = b[a >> 1] & -2;
	                    a = (c[h >> 2] | 0) + 16 | 0;
	                    b[a >> 1] = b[a >> 1] & -8191
	                } else if ((e | 0) == 90) {
	                    a = (c[h >> 2] | 0) + 16 | 0;
	                    b[a >> 1] = b[a >> 1] & -2 | 1;
	                    a = (c[h >> 2] | 0) + 16 | 0;
	                    b[a >> 1] = b[a >> 1] & -8191;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                } else {
	                    c[g >> 2] = 1;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } while (0);
	                c[c[j >> 2] >> 2] = c[k >> 2];
	                c[g >> 2] = 0;
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function JI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if ((((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[j >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)c[l >> 2] = (((d[c[j >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[j >> 2] | 0) + 1 >> 0] | 0) - 48); else c[k >> 2] = 1;
	                c[j >> 2] = (c[j >> 2] | 0) + 2;
	                if (c[k >> 2] | 0) {
	                    c[f >> 2] = c[k >> 2];
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if ((c[l >> 2] | 0) >>> 0 >= 1 & (c[l >> 2] | 0) >>> 0 <= 12) {
	                    k = (c[g >> 2] | 0) + 4 | 0;
	                    c[k >> 2] = c[k >> 2] & -16 | c[l >> 2] & 15;
	                    c[c[h >> 2] >> 2] = c[j >> 2];
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = 2;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function KI(a, e) {
	                a = a | 0;
	                e = e | 0;
	                var f = 0, g = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f;
	                c[j >> 2] = a;
	                c[k >> 2] = e;
	                c[l >> 2] = c[c[k >> 2] >> 2];
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((((d[c[l >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[l >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)c[n >> 2] = (((d[c[l >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) - 48); else c[m >> 2] = 1;
	                c[l >> 2] = (c[l >> 2] | 0) + 2;
	                if (c[m >> 2] | 0) {
	                    c[g >> 2] = c[m >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if ((d[c[l >> 2] >> 0] | 0 | 0) != 58) {
	                    c[g >> 2] = 1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (!((c[n >> 2] | 0) >= 0 & (c[n >> 2] | 0) <= 23)) {
	                    c[g >> 2] = 2;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[l >> 2] = (c[l >> 2] | 0) + 1;
	                e = (c[j >> 2] | 0) + 4 | 0;
	                c[e >> 2] = c[e >> 2] & -15873 | (c[n >> 2] & 31) << 9;
	                if ((((d[c[l >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[l >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)c[n >> 2] = (((d[c[l >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) - 48); else c[m >> 2] = 1;
	                c[l >> 2] = (c[l >> 2] | 0) + 2;
	                if (c[m >> 2] | 0) {
	                    c[g >> 2] = c[m >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (!((c[n >> 2] | 0) >= 0 & (c[n >> 2] | 0) <= 59)) {
	                    c[g >> 2] = 2;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                e = (c[j >> 2] | 0) + 4 | 0;
	                c[e >> 2] = c[e >> 2] & -1032193 | (c[n >> 2] & 63) << 14;
	                if ((d[c[l >> 2] >> 0] | 0 | 0) != 58) {
	                    c[g >> 2] = 1;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[l >> 2] = (c[l >> 2] | 0) + 1;
	                if ((((d[c[l >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[l >> 2] >> 0] | 0 | 0) <= 57 : 0) ? (d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) >= 48 : 0) ? (d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) <= 57 : 0)h[(c[j >> 2] | 0) + 8 >> 3] = +((((d[c[l >> 2] >> 0] | 0) - 48 | 0) * 10 | 0) + ((d[(c[l >> 2] | 0) + 1 >> 0] | 0) - 48) | 0); else c[m >> 2] = 1;
	                c[l >> 2] = (c[l >> 2] | 0) + 2;
	                a:do if ((c[m >> 2] | 0) == 0 ? (d[c[l >> 2] >> 0] | 0 | 0) == 46 : 0) {
	                    h[o >> 3] = 1.0;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    if (!((d[c[l >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[l >> 2] >> 0] | 0 | 0) <= 57 : 0))c[m >> 2] = 1;
	                    while (1) {
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) < 48)break a;
	                        if ((d[c[l >> 2] >> 0] | 0 | 0) > 57)break a;
	                        h[o >> 3] = +h[o >> 3] / 10.0;
	                        n = (c[j >> 2] | 0) + 8 | 0;
	                        h[n >> 3] = +h[n >> 3] + +((d[c[l >> 2] >> 0] | 0) - 48 | 0) * +h[o >> 3];
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                } while (0);
	                if (c[m >> 2] | 0) {
	                    c[g >> 2] = c[m >> 2];
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                if (((+h[(c[j >> 2] | 0) + 8 >> 3] >= 0.0 ? +h[(c[j >> 2] | 0) + 8 >> 3] < 60.0 : 0) ? ((b[(c[j >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) > -840 : 0) ? ((b[(c[j >> 2] | 0) + 16 >> 1] << 3 & 65535) << 16 >> 16 >> 4 << 16 >> 16 | 0) < 840 : 0) {
	                    c[c[k >> 2] >> 2] = c[l >> 2];
	                    c[g >> 2] = 0;
	                    p = c[g >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[g >> 2] = 2;
	                p = c[g >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function LI(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[c[h >> 2] >> 2];
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                if (!((d[c[j >> 2] >> 0] | 0 | 0) >= 48 ? (d[c[j >> 2] >> 0] | 0 | 0) <= 57 : 0))n = 3;
	                if (((n | 0) == 3 ? (d[c[j >> 2] >> 0] | 0 | 0) != 45 : 0) ? (d[c[j >> 2] >> 0] | 0 | 0) != 43 : 0) {
	                    c[f >> 2] = -1;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if ((d[c[j >> 2] >> 0] | 0 | 0) == 45) {
	                    c[l >> 2] = 1;
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                c[k >> 2] = c[j >> 2];
	                while (1) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) < 48)break;
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) > 57)break;
	                    c[c[g >> 2] >> 2] = ((c[c[g >> 2] >> 2] | 0) * 10 | 0) + ((d[c[j >> 2] >> 0] | 0) - 48);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                do if ((c[m >> 2] | 0) >= 4) {
	                    if ((c[m >> 2] | 0) > 4 ? (d[c[k >> 2] >> 0] | 0 | 0) == 48 : 0)break;
	                    if (c[l >> 2] | 0)c[c[g >> 2] >> 2] = 0 - (c[c[g >> 2] >> 2] | 0);
	                    if (c[c[g >> 2] >> 2] | 0) {
	                        c[c[h >> 2] >> 2] = c[j >> 2];
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else {
	                        c[f >> 2] = 2;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                } while (0);
	                c[f >> 2] = 1;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function MI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                a = c[(c[d >> 2] | 0) + 12 >> 2] & 15;
	                c[f >> 2] = a;
	                c[f >> 2] = (c[f >> 2] | 0) <= 0 ? 1 : a;
	                a = c[(c[d >> 2] | 0) + 8 >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) <= 0) {
	                    g = (a * 365 | 0) + ((((c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 1 | 0) / 4 | 0) - (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 1 | 0) / 100 | 0) + (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) + 1 | 0) / 400 | 0)) | 0;
	                    if (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) % 100 | 0 | 0) != 0 : 0)h = 5; else if (!((c[(c[d >> 2] | 0) + 8 >> 2] | 0) % 400 | 0))h = 5; else j = c[172072 + ((c[f >> 2] | 0) - 1 << 2) >> 2] | 0;
	                    if ((h | 0) == 5)j = c[172024 + ((c[f >> 2] | 0) - 1 << 2) >> 2] | 0;
	                    c[e >> 2] = g + (j + 0);
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                } else {
	                    j = ((a - 1 | 0) * 365 | 0) + ((((c[(c[d >> 2] | 0) + 8 >> 2] | 0) - 1 | 0) / 4 | 0) - (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) - 1 | 0) / 100 | 0) + (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) - 1 | 0) / 400 | 0)) | 0;
	                    if (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) % 4 | 0 | 0) == 0 ? ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) % 100 | 0 | 0) != 0 : 0)h = 11; else if (!((c[(c[d >> 2] | 0) + 8 >> 2] | 0) % 400 | 0))h = 11; else l = c[172072 + ((c[f >> 2] | 0) - 1 << 2) >> 2] | 0;
	                    if ((h | 0) == 11)l = c[172024 + ((c[f >> 2] | 0) - 1 << 2) >> 2] | 0;
	                    c[e >> 2] = j + (l + 0);
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                return 0
	            }

	            function NI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65792)e = (c[d >> 2] | 0) <= 65855; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function OI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 64256)e = (c[d >> 2] | 0) <= 64335; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function PI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1536)e = (c[d >> 2] | 0) <= 1791; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function QI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 64336)e = (c[d >> 2] | 0) <= 65023; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function RI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65136)e = (c[d >> 2] | 0) <= 65279; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function SI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1328)e = (c[d >> 2] | 0) <= 1423; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function TI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8592)e = (c[d >> 2] | 0) <= 8703; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function UI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 0)e = (c[d >> 2] | 0) <= 127; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function VI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 2432)e = (c[d >> 2] | 0) <= 2559; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function WI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9600)e = (c[d >> 2] | 0) <= 9631; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function XI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12544)e = (c[d >> 2] | 0) <= 12591; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function YI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12704)e = (c[d >> 2] | 0) <= 12735; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function ZI(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9472)e = (c[d >> 2] | 0) <= 9599; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function _I(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 10240)e = (c[d >> 2] | 0) <= 10495; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function $I(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5952)e = (c[d >> 2] | 0) <= 5983; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function aJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 118784)e = (c[d >> 2] | 0) <= 119039; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function bJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 13056)e = (c[d >> 2] | 0) <= 13311; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function cJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65072)e = (c[d >> 2] | 0) <= 65103; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function dJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 63744)e = (c[d >> 2] | 0) <= 64255; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function eJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 194560)e = (c[d >> 2] | 0) <= 195103; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function fJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 11904)e = (c[d >> 2] | 0) <= 12031; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function gJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12288)e = (c[d >> 2] | 0) <= 12351; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function hJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 19968)e = (c[d >> 2] | 0) <= 40959; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function iJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 13312)e = (c[d >> 2] | 0) <= 19903; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function jJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 131072)e = (c[d >> 2] | 0) <= 173791; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function kJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5024)e = (c[d >> 2] | 0) <= 5119; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function lJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 768)e = (c[d >> 2] | 0) <= 879; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function mJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8400)e = (c[d >> 2] | 0) <= 8447; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function nJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65056)e = (c[d >> 2] | 0) <= 65071; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function oJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8400)e = (c[d >> 2] | 0) <= 8447; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function pJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9216)e = (c[d >> 2] | 0) <= 9279; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function qJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8352)e = (c[d >> 2] | 0) <= 8399; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function rJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 67584)e = (c[d >> 2] | 0) <= 67647; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function sJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1024)e = (c[d >> 2] | 0) <= 1279; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function tJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1280)e = (c[d >> 2] | 0) <= 1327; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function uJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 66560)e = (c[d >> 2] | 0) <= 66639; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function vJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 2304)e = (c[d >> 2] | 0) <= 2431; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function wJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9984)e = (c[d >> 2] | 0) <= 10175; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function xJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9312)e = (c[d >> 2] | 0) <= 9471; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function yJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12800)e = (c[d >> 2] | 0) <= 13055; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function zJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 4608)e = (c[d >> 2] | 0) <= 4991; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function AJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8192)e = (c[d >> 2] | 0) <= 8303; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function BJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9632)e = (c[d >> 2] | 0) <= 9727; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function CJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 4256)e = (c[d >> 2] | 0) <= 4351; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function DJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 66352)e = (c[d >> 2] | 0) <= 66383; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function EJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 880)e = (c[d >> 2] | 0) <= 1023; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function FJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 7936)e = (c[d >> 2] | 0) <= 8191; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function GJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 880)e = (c[d >> 2] | 0) <= 1023; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function HJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 2688)e = (c[d >> 2] | 0) <= 2815; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function IJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 2560)e = (c[d >> 2] | 0) <= 2687; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function JJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65280)e = (c[d >> 2] | 0) <= 65519; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function KJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12592)e = (c[d >> 2] | 0) <= 12687; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function LJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 4352)e = (c[d >> 2] | 0) <= 4607; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function MJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 44032)e = (c[d >> 2] | 0) <= 55215; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function NJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5920)e = (c[d >> 2] | 0) <= 5951; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function OJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1424)e = (c[d >> 2] | 0) <= 1535; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function PJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 56192)e = (c[d >> 2] | 0) <= 56319; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function QJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 55296)e = (c[d >> 2] | 0) <= 56191; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function RJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12352)e = (c[d >> 2] | 0) <= 12447; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function SJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 592)e = (c[d >> 2] | 0) <= 687; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function TJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12272)e = (c[d >> 2] | 0) <= 12287; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function UJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12688)e = (c[d >> 2] | 0) <= 12703; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function VJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12032)e = (c[d >> 2] | 0) <= 12255; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function WJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3200)e = (c[d >> 2] | 0) <= 3327; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function XJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12448)e = (c[d >> 2] | 0) <= 12543; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function YJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 12784)e = (c[d >> 2] | 0) <= 12799; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function ZJ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 6016)e = (c[d >> 2] | 0) <= 6143; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function _J(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 6624)e = (c[d >> 2] | 0) <= 6655; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function $J(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3712)e = (c[d >> 2] | 0) <= 3839; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function aK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 128)e = (c[d >> 2] | 0) <= 255; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function bK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 256)e = (c[d >> 2] | 0) <= 383; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function cK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 384)e = (c[d >> 2] | 0) <= 591; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function dK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 7680)e = (c[d >> 2] | 0) <= 7935; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function eK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8448)e = (c[d >> 2] | 0) <= 8527; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function fK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 6400)e = (c[d >> 2] | 0) <= 6479; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function gK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65664)e = (c[d >> 2] | 0) <= 65791; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function hK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65536)e = (c[d >> 2] | 0) <= 65663; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function iK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 56320)e = (c[d >> 2] | 0) <= 57343; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function jK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3328)e = (c[d >> 2] | 0) <= 3455; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function kK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 119808)e = (c[d >> 2] | 0) <= 120831; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function lK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8704)e = (c[d >> 2] | 0) <= 8959; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function mK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 10176)e = (c[d >> 2] | 0) <= 10223; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function nK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 10624)e = (c[d >> 2] | 0) <= 10751; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function oK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9728)e = (c[d >> 2] | 0) <= 9983; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function pK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 11008)e = (c[d >> 2] | 0) <= 11263; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function qK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8960)e = (c[d >> 2] | 0) <= 9215; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function rK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 6144)e = (c[d >> 2] | 0) <= 6319; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function sK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 119040)e = (c[d >> 2] | 0) <= 119295; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function tK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 4096)e = (c[d >> 2] | 0) <= 4255; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function uK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8528)e = (c[d >> 2] | 0) <= 8591; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function vK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5760)e = (c[d >> 2] | 0) <= 5791; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function wK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 66304)e = (c[d >> 2] | 0) <= 66351; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function xK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 9280)e = (c[d >> 2] | 0) <= 9311; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function yK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 2816)e = (c[d >> 2] | 0) <= 2943; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function zK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 66688)e = (c[d >> 2] | 0) <= 66735; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function AK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 7424)e = (c[d >> 2] | 0) <= 7551; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function BK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!((c[d >> 2] | 0) >= 57344 & (c[d >> 2] | 0) <= 63743) ? !((c[d >> 2] | 0) >= 983040 & (c[d >> 2] | 0) <= 1048575) : 0)if ((c[d >> 2] | 0) >= 1048576)e = (c[d >> 2] | 0) <= 1114111; else e = 0; else e = 1;
	                i = b;
	                return e & 1 | 0
	            }

	            function CK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 57344)e = (c[d >> 2] | 0) <= 63743; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function DK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5792)e = (c[d >> 2] | 0) <= 5887; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function EK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 66640)e = (c[d >> 2] | 0) <= 66687; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function FK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3456)e = (c[d >> 2] | 0) <= 3583; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function GK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65104)e = (c[d >> 2] | 0) <= 65135; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function HK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 688)e = (c[d >> 2] | 0) <= 767; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function IK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65520)e = (c[d >> 2] | 0) <= 65535; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function JK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 8304)e = (c[d >> 2] | 0) <= 8351; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function KK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 10224)e = (c[d >> 2] | 0) <= 10239; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function LK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 10496)e = (c[d >> 2] | 0) <= 10623; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function MK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 10752)e = (c[d >> 2] | 0) <= 11007; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function NK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 983040)e = (c[d >> 2] | 0) <= 1048575; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function OK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1048576)e = (c[d >> 2] | 0) <= 1114111; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function PK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1792)e = (c[d >> 2] | 0) <= 1871; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function QK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5888)e = (c[d >> 2] | 0) <= 5919; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function RK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5984)e = (c[d >> 2] | 0) <= 6015; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function SK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 917504)e = (c[d >> 2] | 0) <= 917631; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function TK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 6480)e = (c[d >> 2] | 0) <= 6527; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function UK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 119552)e = (c[d >> 2] | 0) <= 119647; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function VK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 2944)e = (c[d >> 2] | 0) <= 3071; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function WK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3072)e = (c[d >> 2] | 0) <= 3199; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function XK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 1920)e = (c[d >> 2] | 0) <= 1983; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function YK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3584)e = (c[d >> 2] | 0) <= 3711; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function ZK(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 3840)e = (c[d >> 2] | 0) <= 4095; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function _K(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 66432)e = (c[d >> 2] | 0) <= 66463; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function $K(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 5120)e = (c[d >> 2] | 0) <= 5759; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function aL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 65024)e = (c[d >> 2] | 0) <= 65039; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function bL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 917760)e = (c[d >> 2] | 0) <= 917999; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function cL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 42128)e = (c[d >> 2] | 0) <= 42191; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function dL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 40960)e = (c[d >> 2] | 0) <= 42127; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function eL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) >= 19904)e = (c[d >> 2] | 0) <= 19967; else e = 0;
	                i = b;
	                return e & 1 | 0
	            }

	            function fL(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = PL(172456, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = Cb[c[h >> 2] & 511](c[f >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function gL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172464) | 0;
	                i = b;
	                return a | 0
	            }

	            function hL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!((c[d >> 2] | 0) >= 0 & (c[d >> 2] | 0) <= 31))if ((c[d >> 2] | 0) >= 127)e = (c[d >> 2] | 0) <= 159; else e = 0; else e = 1;
	                i = b;
	                return e & 1 | 0
	            }

	            function iL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172480) | 0;
	                i = b;
	                return a | 0
	            }

	            function jL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) == 57344 | (c[d >> 2] | 0) == 63743 | (c[d >> 2] | 0) == 983040 | (c[d >> 2] | 0) == 1048573 | (c[d >> 2] | 0) == 1048576) {
	                    e = 1;
	                    f = e & 1;
	                    i = b;
	                    return f | 0
	                }
	                e = (c[d >> 2] | 0) == 1114109;
	                f = e & 1;
	                i = b;
	                return f | 0
	            }

	            function kL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172496) | 0;
	                i = b;
	                return a | 0
	            }

	            function lL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172512) | 0;
	                i = b;
	                return a | 0
	            }

	            function mL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172528) | 0;
	                i = b;
	                return a | 0
	            }

	            function nL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172544) | 0;
	                i = b;
	                return a | 0
	            }

	            function oL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172560) | 0;
	                i = b;
	                return a | 0
	            }

	            function pL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172576) | 0;
	                i = b;
	                return a | 0
	            }

	            function qL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172592) | 0;
	                i = b;
	                return a | 0
	            }

	            function rL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172608) | 0;
	                i = b;
	                return a | 0
	            }

	            function sL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!((c[d >> 2] | 0) >= 1160 & (c[d >> 2] | 0) <= 1161 | (c[d >> 2] | 0) == 1758) ? !((c[d >> 2] | 0) >= 8413 & (c[d >> 2] | 0) <= 8416) : 0)if ((c[d >> 2] | 0) >= 8418)e = (c[d >> 2] | 0) <= 8420; else e = 0; else e = 1;
	                i = b;
	                return e & 1 | 0
	            }

	            function tL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172624) | 0;
	                i = b;
	                return a | 0
	            }

	            function uL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172640) | 0;
	                i = b;
	                return a | 0
	            }

	            function vL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172656) | 0;
	                i = b;
	                return a | 0
	            }

	            function wL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (((!((c[d >> 2] | 0) >= 5870 & (c[d >> 2] | 0) <= 5872) ? !((c[d >> 2] | 0) >= 8544 & (c[d >> 2] | 0) <= 8579 | (c[d >> 2] | 0) == 12295) : 0) ? !((c[d >> 2] | 0) >= 12321 & (c[d >> 2] | 0) <= 12329) : 0) ? !((c[d >> 2] | 0) >= 12344 & (c[d >> 2] | 0) <= 12346) : 0)e = (c[d >> 2] | 0) == 66378; else e = 1;
	                i = b;
	                return e & 1 | 0
	            }

	            function xL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172672) | 0;
	                i = b;
	                return a | 0
	            }

	            function yL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172688) | 0;
	                i = b;
	                return a | 0
	            }

	            function zL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((((c[d >> 2] | 0) != 95 ? !((c[d >> 2] | 0) >= 8255 & (c[d >> 2] | 0) <= 8256 | (c[d >> 2] | 0) == 8276 | (c[d >> 2] | 0) == 12539) : 0) ? !((c[d >> 2] | 0) >= 65075 & (c[d >> 2] | 0) <= 65076) : 0) ? !((c[d >> 2] | 0) >= 65101 & (c[d >> 2] | 0) <= 65103 | (c[d >> 2] | 0) == 65343) : 0)e = (c[d >> 2] | 0) == 65381; else e = 1;
	                i = b;
	                return e & 1 | 0
	            }

	            function AL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172704) | 0;
	                i = b;
	                return a | 0
	            }

	            function BL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172720) | 0;
	                i = b;
	                return a | 0
	            }

	            function CL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) == 187 | (c[d >> 2] | 0) == 8217 | (c[d >> 2] | 0) == 8221) {
	                    e = 1;
	                    f = e & 1;
	                    i = b;
	                    return f | 0
	                }
	                e = (c[d >> 2] | 0) == 8250;
	                f = e & 1;
	                i = b;
	                return f | 0
	            }

	            function DL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!((c[d >> 2] | 0) == 171 | (c[d >> 2] | 0) == 8216) ? !((c[d >> 2] | 0) >= 8219 & (c[d >> 2] | 0) <= 8220 | (c[d >> 2] | 0) == 8223) : 0)e = (c[d >> 2] | 0) == 8249; else e = 1;
	                i = b;
	                return e & 1 | 0
	            }

	            function EL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172736) | 0;
	                i = b;
	                return a | 0
	            }

	            function FL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172752) | 0;
	                i = b;
	                return a | 0
	            }

	            function GL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172768) | 0;
	                i = b;
	                return a | 0
	            }

	            function HL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172784) | 0;
	                i = b;
	                return a | 0
	            }

	            function IL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172800) | 0;
	                i = b;
	                return a | 0
	            }

	            function JL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172816) | 0;
	                i = b;
	                return a | 0
	            }

	            function KL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172832) | 0;
	                i = b;
	                return a | 0
	            }

	            function LL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                a = DQ(c[d >> 2] | 0, 172848) | 0;
	                i = b;
	                return a | 0
	            }

	            function ML(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                i = b;
	                return (c[d >> 2] | 0) == 8232 | 0
	            }

	            function NL(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                i = b;
	                return (c[d >> 2] | 0) == 8233 | 0
	            }

	            function OL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if ((c[d >> 2] | 0) == 32 | (c[d >> 2] | 0) == 160 | (c[d >> 2] | 0) == 5760 | (c[d >> 2] | 0) == 6158) {
	                    e = 1;
	                    f = e & 1;
	                    i = b;
	                    return f | 0
	                }
	                if ((c[d >> 2] | 0) >= 8192 & (c[d >> 2] | 0) <= 8202 | (c[d >> 2] | 0) == 8239 | (c[d >> 2] | 0) == 8287) {
	                    e = 1;
	                    f = e & 1;
	                    i = b;
	                    return f | 0
	                }
	                e = (c[d >> 2] | 0) == 12288;
	                f = e & 1;
	                i = b;
	                return f | 0
	            }

	            function PL(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[h >> 2] = 0;
	                c[j >> 2] = (c[(c[f >> 2] | 0) + 4 >> 2] | 0) - 1;
	                c[m >> 2] = c[c[f >> 2] >> 2];
	                while (1) {
	                    if ((c[h >> 2] | 0) > (c[j >> 2] | 0)) {
	                        o = 10;
	                        break
	                    }
	                    c[k >> 2] = ((c[h >> 2] | 0) + (c[j >> 2] | 0) | 0) / 2 | 0;
	                    f = PT(c[g >> 2] | 0, c[(c[m >> 2] | 0) + (c[k >> 2] << 3) >> 2] | 0) | 0;
	                    c[l >> 2] = f;
	                    if (!f) {
	                        o = 6;
	                        break
	                    }
	                    f = c[k >> 2] | 0;
	                    if ((c[l >> 2] | 0) < 0) {
	                        c[j >> 2] = f - 1;
	                        continue
	                    } else {
	                        c[h >> 2] = f + 1;
	                        continue
	                    }
	                }
	                if ((o | 0) == 6) {
	                    c[e >> 2] = c[(c[m >> 2] | 0) + (c[k >> 2] << 3) + 4 >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                } else if ((o | 0) == 10) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                return 0
	            }

	            function QL(a) {
	                a = a | 0;
	                var b = 0, d = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 36 | 0;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                o = b;
	                c[f >> 2] = a;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                c[(c[f >> 2] | 0) + 68 >> 2] = 0;
	                a = c[f >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                    c[d >> 2] = mM(a) | 0;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                if (!(c[a + 20 >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                a = c[f >> 2] | 0;
	                if (!(c[c[f >> 2] >> 2] | 0)) {
	                    c[a >> 2] = 1;
	                    do {
	                        c[g >> 2] = nM(c[f >> 2] | 0) | 0;
	                        q = c[f >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 0) {
	                            r = 10;
	                            break
	                        }
	                        if (c[(c[q + 20 >> 2] | 0) + 52 >> 2] | 0)break;
	                        if ((c[c[f >> 2] >> 2] | 0) == 3)break
	                    } while ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 5);
	                    if ((r | 0) == 10) {
	                        c[q >> 2] = 2;
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 6;
	                        c[d >> 2] = -1;
	                        p = c[d >> 2] | 0;
	                        i = b;
	                        return p | 0
	                    }
	                    q = (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) != 0;
	                    do if (!(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 52 >> 2] | 0)) {
	                        if (q)c[(c[f >> 2] | 0) + 64 >> 2] = c[(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2];
	                        s = c[f >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 64 >> 2] | 0) {
	                            c[s + 16 >> 2] = 1;
	                            break
	                        }
	                        c[s >> 2] = 2;
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 6;
	                        c[d >> 2] = -1;
	                        p = c[d >> 2] | 0;
	                        i = b;
	                        return p | 0
	                    } else {
	                        if (q)c[(c[f >> 2] | 0) + 64 >> 2] = c[(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2];
	                        if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0))c[(c[f >> 2] | 0) + 64 >> 2] = c[c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 64 >> 2] >> 2];
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 1
	                    } while (0);
	                    c[(c[f >> 2] | 0) + 72 >> 2] = 0;
	                    c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 436 >> 2] = 5;
	                    r = 108
	                } else {
	                    c[j >> 2] = c[a + 16 >> 2];
	                    c[h >> 2] = c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 56 >> 2];
	                    c[k >> 2] = c[(c[f >> 2] | 0) + 64 >> 2]
	                }
	                a:while (1) {
	                    if ((r | 0) == 108) {
	                        r = 0;
	                        do if ((c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                            if ((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 4 : 0)break;
	                            if (!(RL(c[f >> 2] | 0) | 0)) {
	                                r = 113;
	                                break a
	                            }
	                        } while (0);
	                        do if ((((c[(c[f >> 2] | 0) + 156 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            if ((qy(c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 187376) | 0) == 0 ? (qy(c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 187408) | 0) == 0 : 0)break;
	                            if (!(c[(c[f >> 2] | 0) + 164 >> 2] | 0)) {
	                                a = Qv(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 164 >> 2] = a;
	                                Sv(c[(c[f >> 2] | 0) + 164 >> 2] | 0, c[(c[f >> 2] | 0) + 188 >> 2] & -32769) | 0
	                            }
	                            if (!(RL(c[f >> 2] | 0) | 0)) {
	                                r = 123;
	                                break a
	                            }
	                            Wv(c[(c[f >> 2] | 0) + 164 >> 2] | 0, c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0
	                        } while (0);
	                        if ((c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 19 : 0) {
	                            a = (c[f >> 2] | 0) + 168 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            continue
	                        }
	                        if ((c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 20 : 0) {
	                            a = (c[f >> 2] | 0) + 168 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + -1;
	                            continue
	                        }
	                        if ((((c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 5 : 0) ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 16 >> 2] | 0) == 1 : 0) {
	                            if (((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[c[(c[f >> 2] | 0) + 20 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[f >> 2] | 0) + 20 >> 2] >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                                a = Hb[c[(c[c[(c[f >> 2] | 0) + 20 >> 2] >> 2] | 0) + 20 >> 2] & 511](c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] = a
	                            }
	                            if (((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 17 : 0) ? (c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                qM(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0;
	                                c[(c[f >> 2] | 0) + 64 >> 2] = c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2]
	                            }
	                        } else r = 143;
	                        if (((((r | 0) == 143 ? (r = 0, (c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0) : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 5 : 0) ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0)rM(c[f >> 2] | 0);
	                        if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                            r = 153;
	                            break
	                        }
	                        if ((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 17) {
	                            r = 153;
	                            break
	                        }
	                        if (!(c[(c[f >> 2] | 0) + 92 >> 2] | 0)) {
	                            r = 153;
	                            break
	                        }
	                        if ((c[(c[(c[f >> 2] | 0) + 92 >> 2] | 0) + 12 >> 2] | 0) != (c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                            r = 153;
	                            break
	                        }
	                        a = sM(c[f >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 64 >> 2] = a;
	                        a = (c[f >> 2] | 0) + 72 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1
	                    }
	                    if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                        r = 28;
	                        break
	                    }
	                    b:while (1) {
	                        if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0))break;
	                        if (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 24 >> 2] | 0)break;
	                        if ((c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 56 >> 2] | 0) != (c[h >> 2] | 0))break;
	                        do if (((c[j >> 2] | 0) != 4 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                            if (((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0)break;
	                            if (((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 14 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 13 : 0)break b
	                        } while (0);
	                        if (((c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 52 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 52 >> 2] | 0) != (c[(c[f >> 2] | 0) + 64 >> 2] | 0) : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 52 >> 2] | 0) != (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 20 >> 2] | 0) : 0)break;
	                        if ((c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 172 >> 2] | 0) == -1)break;
	                        c[g >> 2] = nM(c[f >> 2] | 0) | 0;
	                        t = c[f >> 2] | 0;
	                        if ((c[g >> 2] | 0) < 0) {
	                            r = 48;
	                            break a
	                        }
	                        if (!(c[t + 64 >> 2] | 0))break a
	                    }
	                    if (((((c[j >> 2] | 0) != 4 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 14 : 0) {
	                        c[(c[f >> 2] | 0) + 64 >> 2] = c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2];
	                        a = (c[f >> 2] | 0) + 72 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + 1;
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 1;
	                        r = 108;
	                        continue
	                    }
	                    a = (c[j >> 2] | 0) == 1;
	                    if (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 24 >> 2] | 0) {
	                        if ((((a ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? ((e[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 58 >> 1] | 0) & 1 | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 168 >> 2] | 0) <= 0 : 0) {
	                            c[(c[f >> 2] | 0) + 16 >> 2] = 2;
	                            r = 108;
	                            continue
	                        }
	                        if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)oM(c[f >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 184 >> 2] | 0) > 0 ? ((e[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 58 >> 1] | 0) & 4 | 0) != 0 : 0) {
	                            q = (c[f >> 2] | 0) + 184 | 0;
	                            c[q >> 2] = (c[q >> 2] | 0) + -1
	                        }
	                        c[(c[f >> 2] | 0) + 64 >> 2] = c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 24 >> 2];
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 1;
	                        if (c[(c[f >> 2] | 0) + 184 >> 2] | 0) {
	                            r = 108;
	                            continue
	                        }
	                        if (c[(c[f >> 2] | 0) + 168 >> 2] | 0) {
	                            r = 108;
	                            continue
	                        }
	                        if (c[(c[f >> 2] | 0) + 96 >> 2] | 0) {
	                            r = 108;
	                            continue
	                        }
	                        if (!(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 28 >> 2] | 0)) {
	                            r = 108;
	                            continue
	                        }
	                        if ((c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                            r = 108;
	                            continue
	                        }
	                        c[l >> 2] = c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 28 >> 2];
	                        if ((e[(c[l >> 2] | 0) + 58 >> 1] | 0) & 2) {
	                            r = 108;
	                            continue
	                        }
	                        Qh(c[l >> 2] | 0);
	                        pM(c[f >> 2] | 0, c[l >> 2] | 0);
	                        r = 108;
	                        continue
	                    }
	                    if (((a ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? ((e[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 58 >> 1] | 0) & 1 | 0) == 0 : 0) {
	                        c[(c[f >> 2] | 0) + 16 >> 2] = 2;
	                        r = 108;
	                        continue
	                    }
	                    if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0)oM(c[f >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 184 >> 2] | 0) > 0 ? ((e[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 58 >> 1] | 0) & 4 | 0) != 0 : 0) {
	                        a = (c[f >> 2] | 0) + 184 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + -1
	                    }
	                    c[(c[f >> 2] | 0) + 64 >> 2] = c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 20 >> 2];
	                    if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                        r = 91;
	                        break
	                    }
	                    if ((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 9) {
	                        r = 91;
	                        break
	                    }
	                    if ((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 21) {
	                        r = 91;
	                        break
	                    }
	                    if ((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                        r = 91;
	                        break
	                    }
	                    do if ((((c[(c[f >> 2] | 0) + 184 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 168 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 96 >> 2] | 0) == 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                        if ((e[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 16 >> 2] | 0) + 58 >> 1] | 0) & 2)break;
	                        c[m >> 2] = c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 16 >> 2];
	                        Qh(c[m >> 2] | 0);
	                        pM(c[f >> 2] | 0, c[m >> 2] | 0)
	                    } while (0);
	                    a = (c[f >> 2] | 0) + 72 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + -1;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 4;
	                    r = 108
	                }
	                if ((r | 0) == 28)if ((c[c[f >> 2] >> 2] | 0) == 3) {
	                    c[d >> 2] = 0;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } else {
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } else if ((r | 0) == 48) {
	                    c[t >> 2] = 2;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 6;
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } else if ((r | 0) == 91) {
	                    if ((c[c[f >> 2] >> 2] | 0) != 3 ? (c[g >> 2] = Sf(c[(c[f >> 2] | 0) + 20 >> 2] | 0, 187368, 0, 1) | 0, c[(c[f >> 2] | 0) + 16 >> 2] = 5, (c[g >> 2] | 0) != 0) : 0) {
	                        c[d >> 2] = -1;
	                        p = c[d >> 2] | 0;
	                        i = b;
	                        return p | 0
	                    }
	                    c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 72 >> 2] = -1;
	                    if ((((((c[k >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 184 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 168 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 96 >> 2] | 0) == 0 : 0) ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 14 : 0) ? ((e[(c[k >> 2] | 0) + 58 >> 1] | 0) & 2 | 0) == 0 : 0) {
	                        Qh(c[k >> 2] | 0);
	                        pM(c[f >> 2] | 0, c[k >> 2] | 0)
	                    }
	                } else if ((r | 0) == 113) {
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } else if ((r | 0) == 123) {
	                    c[d >> 2] = -1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } else if ((r | 0) == 153) {
	                    do if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                        c[n >> 2] = c[(c[f >> 2] | 0) + 64 >> 2];
	                        if (((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 2 : 0) ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 4 : 0) {
	                            tM(c[f >> 2] | 0);
	                            break
	                        }
	                        if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 4 : 0)break;
	                        r = c[f >> 2] | 0;
	                        k = c[(c[n >> 2] | 0) + 40 >> 2] | 0;
	                        uM(r, k, xy(c[(c[n >> 2] | 0) + 40 >> 2] | 0) | 0)
	                    } while (0);
	                    c:do if (((c[(c[f >> 2] | 0) + 172 >> 2] | 0) > 0 ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 2 : 0) ? (c[(c[f >> 2] | 0) + 16 >> 2] | 0) != 4 : 0) {
	                        c[o >> 2] = 0;
	                        while (1) {
	                            if ((c[o >> 2] | 0) >= (c[(c[f >> 2] | 0) + 172 >> 2] | 0))break c;
	                            if ((NQ(c[(c[(c[f >> 2] | 0) + 180 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0, c[(c[f >> 2] | 0) + 64 >> 2] | 0) | 0) == 1)break;
	                            c[o >> 2] = (c[o >> 2] | 0) + 1
	                        }
	                        SL(c[f >> 2] | 0) | 0
	                    } while (0);
	                    if (((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 4 ? (c[(c[f >> 2] | 0) + 148 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 140 >> 2] | 0) != 0 : 0) {
	                        o = ((gB(c[(c[f >> 2] | 0) + 140 >> 2] | 0) | 0) != 0 ^ 1) & 1;
	                        c[(c[f >> 2] | 0) + 148 >> 2] = o
	                    }
	                    c[d >> 2] = 1;
	                    p = c[d >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                c[(c[f >> 2] | 0) + 16 >> 2] = 5;
	                c[d >> 2] = 0;
	                p = c[d >> 2] | 0;
	                i = b;
	                return p | 0
	            }

	            function RL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                        c[d >> 2] = c[a + 64 >> 2];
	                        break
	                    }
	                    if (!(c[a + 20 >> 2] | 0)) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if ((vM(c[e >> 2] | 0) | 0) < 0) {
	                        c[d >> 2] = 0;
	                        break
	                    } else {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 64 >> 2];
	                        break
	                    }
	                } else f = 3; while (0);
	                if ((f | 0) == 3)c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function SL(a) {
	                a = a | 0;
	                var d = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[g >> 2] = a;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                a = c[g >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 68 >> 2] | 0)c[h >> 2] = c[a + 68 >> 2]; else c[h >> 2] = c[a + 64 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 14 : 0) {
	                    a = (c[h >> 2] | 0) + 58 | 0;
	                    b[a >> 1] = e[a >> 1] | 0 | 2;
	                    a = (c[h >> 2] | 0) + 58 | 0;
	                    b[a >> 1] = e[a >> 1] | 0 | 4
	                }
	                a = (c[g >> 2] | 0) + 184 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + 1;
	                c[j >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        a = (c[j >> 2] | 0) + 58 | 0;
	                        b[a >> 1] = e[a >> 1] | 0 | 2
	                    }
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 20 >> 2]
	                }
	                c[f >> 2] = c[h >> 2];
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function TL(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](196) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187440, e);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                cU(c[j >> 2] | 0, 0, 196) | 0;
	                c[(c[j >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 104 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 100 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 96 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                b = My(100) | 0;
	                c[(c[j >> 2] | 0) + 84 >> 2] = b;
	                if (!(c[(c[j >> 2] | 0) + 84 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187440, e);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                b = Cb[c[135744 >> 2] & 511](128) | 0;
	                c[(c[j >> 2] | 0) + 24 >> 2] = b;
	                b = c[j >> 2] | 0;
	                if (!(c[(c[j >> 2] | 0) + 24 >> 2] | 0)) {
	                    Ry(c[b + 84 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187440, e);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                oQ(c[b + 24 >> 2] | 0, 2) | 0;
	                c[(c[j >> 2] | 0) + 32 >> 2] = c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 56 >> 2];
	                c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 56 >> 2] = 361;
	                c[(c[j >> 2] | 0) + 36 >> 2] = c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 60 >> 2];
	                c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 60 >> 2] = 362;
	                b = c[j >> 2] | 0;
	                if ((c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 108 >> 2] | 0) == -554844497) {
	                    c[(c[j >> 2] | 0) + 40 >> 2] = c[(c[b + 24 >> 2] | 0) + 116 >> 2];
	                    c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 116 >> 2] = 363;
	                    c[(c[j >> 2] | 0) + 44 >> 2] = c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 120 >> 2];
	                    c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 120 >> 2] = 364
	                } else {
	                    c[b + 40 >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 44 >> 2] = 0
	                }
	                c[(c[j >> 2] | 0) + 48 >> 2] = c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 68 >> 2];
	                c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 68 >> 2] = 365;
	                c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 72 >> 2] = 365;
	                c[(c[j >> 2] | 0) + 52 >> 2] = c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 100 >> 2];
	                c[(c[(c[j >> 2] | 0) + 24 >> 2] | 0) + 100 >> 2] = 366;
	                c[c[j >> 2] >> 2] = 0;
	                c[(c[j >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 68 >> 2] = 0;
	                if ((_y(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 < 4)Nk(c[g >> 2] | 0, 4) | 0;
	                g = (_y(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 >= 4;
	                b = c[(c[j >> 2] | 0) + 24 >> 2] | 0;
	                if (g) {
	                    g = Vy(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    a = Tf(b, 0, g, 4, c[h >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 20 >> 2] = a;
	                    c[(c[j >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 60 >> 2] = 4
	                } else {
	                    a = Tf(b, 0, 0, 0, c[h >> 2] | 0) | 0;
	                    c[(c[j >> 2] | 0) + 20 >> 2] = a;
	                    c[(c[j >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 60 >> 2] = 0
	                }
	                if (!(c[(c[j >> 2] | 0) + 20 >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187440, e);
	                    Ry(c[(c[j >> 2] | 0) + 84 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[(c[j >> 2] | 0) + 24 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else {
	                    c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 436 >> 2] = 5;
	                    c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 272 >> 2] = c[j >> 2];
	                    c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 280 >> 2] = 1;
	                    c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 364 >> 2] = 1;
	                    c[(c[j >> 2] | 0) + 12 >> 2] = 2;
	                    c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 308 >> 2] = 1;
	                    c[(c[j >> 2] | 0) + 88 >> 2] = c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2];
	                    c[(c[j >> 2] | 0) + 156 >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 176 >> 2] = 0;
	                    c[(c[j >> 2] | 0) + 180 >> 2] = 0;
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function UL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                e = b + 12 | 0;
	                f = b + 8 | 0;
	                g = b + 4 | 0;
	                h = b;
	                c[e >> 2] = a;
	                c[h >> 2] = 0;
	                c[f >> 2] = Ck(c[e >> 2] | 0, 0) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                c[g >> 2] = TL(c[f >> 2] | 0, c[e >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    yk(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    j = c[d >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                f = (c[g >> 2] | 0) + 12 | 0;
	                c[f >> 2] = c[f >> 2] | 1;
	                if (!(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 180 >> 2] | 0))c[h >> 2] = Rk(c[e >> 2] | 0) | 0;
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 180 >> 2] | 0) == 0 : 0) {
	                    e = my(c[h >> 2] | 0) | 0;
	                    c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 180 >> 2] = e
	                }
	                if (c[h >> 2] | 0)zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                c[d >> 2] = c[g >> 2];
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function VL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 116 >> 2] | 0) {
	                    VM(c[(c[d >> 2] | 0) + 116 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 116 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 120 >> 2] | 0) {
	                    if (!(c[(c[d >> 2] | 0) + 124 >> 2] | 0))fN(c[(c[d >> 2] | 0) + 120 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 120 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 152 >> 2] | 0) {
	                    jB(c[(c[d >> 2] | 0) + 152 >> 2] | 0) | 0;
	                    c[(c[d >> 2] | 0) + 152 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 140 >> 2] | 0) {
	                    if (!(c[(c[d >> 2] | 0) + 144 >> 2] | 0))ZA(c[(c[d >> 2] | 0) + 140 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 140 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 136 >> 2] | 0) {
	                    WA(c[(c[d >> 2] | 0) + 136 >> 2] | 0);
	                    c[(c[d >> 2] | 0) + 136 >> 2] = 0
	                }
	                if (c[(c[d >> 2] | 0) + 164 >> 2] | 0)Rv(c[(c[d >> 2] | 0) + 164 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 180 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 172 >> 2] | 0))break;
	                        if (c[(c[(c[d >> 2] | 0) + 180 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0)EQ(c[(c[(c[d >> 2] | 0) + 180 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 180 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 76 >> 2] | 0)Rh(c[(c[d >> 2] | 0) + 76 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0) {
	                    if ((c[(c[d >> 2] | 0) + 88 >> 2] | 0) == (c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2] | 0))c[(c[d >> 2] | 0) + 88 >> 2] = 0;
	                    if (c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) {
	                        if (!(c[(c[d >> 2] | 0) + 80 >> 2] | 0))CM(c[d >> 2] | 0, c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0);
	                        c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] = 0
	                    }
	                    if ((c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 160 >> 2] | 0) != 0 ? (c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 156 >> 2] | 0) > 0 : 0) {
	                        zb[c[135736 >> 2] & 511](c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 160 >> 2] | 0);
	                        c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 160 >> 2] = 0;
	                        c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 156 >> 2] = 0
	                    }
	                    if (c[(c[d >> 2] | 0) + 12 >> 2] & 2)Ae(c[(c[d >> 2] | 0) + 20 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 12 >> 2] & 1 | 0) != 0 : 0)yk(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 84 >> 2] | 0)Ry(c[(c[d >> 2] | 0) + 84 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 104 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 104 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 88 >> 2] | 0)zP(c[(c[d >> 2] | 0) + 88 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function WL(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[h >> 2] = cj(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 32 >> 2] | 0, c[(c[f >> 2] | 0) + 64 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = my(c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function XL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                a:do if (!(c[e >> 2] | 0))c[d >> 2] = -1; else {
	                    if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0)c[f >> 2] = c[a + 68 >> 2]; else c[f >> 2] = c[a + 64 >> 2];
	                    do switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                        case 7:
	                        {
	                            c[d >> 2] = 7;
	                            break a;
	                            break
	                        }
	                        case 2:
	                        case 18:
	                        {
	                            c[d >> 2] = 2;
	                            break a;
	                            break
	                        }
	                        case 1:
	                        {
	                            if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 2 ? (c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 4 : 0) {
	                                c[d >> 2] = 1;
	                                break a
	                            }
	                            c[d >> 2] = 15;
	                            break a;
	                            break
	                        }
	                        case 5:
	                        {
	                            c[d >> 2] = 5;
	                            break a;
	                            break
	                        }
	                        case 12:
	                        {
	                            c[d >> 2] = 12;
	                            break a;
	                            break
	                        }
	                        case 21:
	                        case 13:
	                        case 9:
	                        {
	                            c[d >> 2] = 9;
	                            break a;
	                            break
	                        }
	                        case 6:
	                        {
	                            c[d >> 2] = 6;
	                            break a;
	                            break
	                        }
	                        case 11:
	                        {
	                            c[d >> 2] = 11;
	                            break a;
	                            break
	                        }
	                        case 3:
	                        {
	                            if (!(ij(c[(c[e >> 2] | 0) + 64 >> 2] | 0) | 0)) {
	                                c[d >> 2] = 3;
	                                break a
	                            }
	                            if (Vi(c[(c[e >> 2] | 0) + 64 >> 2] | 0) | 0) {
	                                c[d >> 2] = 14;
	                                break a
	                            } else {
	                                c[d >> 2] = 13;
	                                break a
	                            }
	                            break
	                        }
	                        case 14:
	                        case 10:
	                        {
	                            c[d >> 2] = 10;
	                            break a;
	                            break
	                        }
	                        case 4:
	                        {
	                            c[d >> 2] = 4;
	                            break a;
	                            break
	                        }
	                        case 20:
	                        case 19:
	                        case 17:
	                        case 16:
	                        case 15:
	                        {
	                            c[d >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 8:
	                        {
	                            c[d >> 2] = 8;
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[d >> 2] = -1;
	                            break a
	                        }
	                    } while (0)
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function YL(a) {
	                a = a | 0;
	                var b = 0, d = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                f = b;
	                c[f >> 2] = a;
	                do if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if (c[(c[f >> 2] | 0) + 68 >> 2] | 0) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if (c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 16 >> 2] | 0) == 2) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 168 >> 2] | 0) > 0) {
	                        c[d >> 2] = 1;
	                        break
	                    } else {
	                        c[d >> 2] = ((e[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 58 >> 1] | 0) & 1 | 0) != 0 & 1;
	                        break
	                    }
	                } else g = 3; while (0);
	                if ((g | 0) == 3)c[d >> 2] = -1;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function ZL(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0)c[f >> 2] = c[a + 68 >> 2]; else c[f >> 2] = c[a + 64 >> 2];
	                    a = c[f >> 2] | 0;
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        c[g >> 2] = a;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187480, -1) | 0;
	                            h = c[d >> 2] | 0;
	                            i = b;
	                            return h | 0
	                        } else {
	                            c[d >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                            h = c[d >> 2] | 0;
	                            i = b;
	                            return h | 0
	                        }
	                    }
	                    if ((c[a + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) {
	                        c[d >> 2] = _L(c[e >> 2] | 0) | 0;
	                        h = c[d >> 2] | 0;
	                        i = b;
	                        return h | 0
	                    }
	                    c[d >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                c[d >> 2] = 0;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function _L(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                a:do if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0)c[f >> 2] = c[a + 68 >> 2]; else c[f >> 2] = c[a + 64 >> 2];
	                    do switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                        case 20:
	                        case 19:
	                        case 17:
	                        case 16:
	                        case 15:
	                        {
	                            c[d >> 2] = 0;
	                            break a;
	                            break
	                        }
	                        case 11:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187584, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 18:
	                        {
	                            c[g >> 2] = c[f >> 2];
	                            a = c[(c[e >> 2] | 0) + 88 >> 2] | 0;
	                            if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                                c[d >> 2] = AP(a, 187480, -1) | 0;
	                                break a
	                            } else {
	                                c[d >> 2] = BP(a, 187480, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 21:
	                        case 13:
	                        case 9:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187568, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 4:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187536, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 2:
	                        case 1:
	                        {
	                            if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                c[d >> 2] = BP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                break a
	                            }
	                            c[d >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                            break a;
	                            break
	                        }
	                        case 12:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 5:
	                        case 6:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 3:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187528, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 8:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187552, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 7:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                            break a;
	                            break
	                        }
	                        case 14:
	                        case 10:
	                        {
	                            c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[d >> 2] = 0;
	                            break a
	                        }
	                    } while (0)
	                } else h = 3; while (0);
	                if ((h | 0) == 3)c[d >> 2] = 0;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function $L(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0)c[f >> 2] = c[a + 68 >> 2]; else c[f >> 2] = c[a + 64 >> 2];
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, 187488, -1) | 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 2 : 0) {
	                        c[d >> 2] = 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                    if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                        c[d >> 2] = AP(c[(c[e >> 2] | 0) + 88 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, -1) | 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    } else {
	                        c[d >> 2] = 0;
	                        g = c[d >> 2] | 0;
	                        i = b;
	                        return g | 0
	                    }
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function aM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (!(c[e >> 2] | 0))c[d >> 2] = -1; else {
	                    if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    a = c[e >> 2] | 0;
	                    if (!(c[(c[e >> 2] | 0) + 68 >> 2] | 0)) {
	                        c[d >> 2] = c[a + 72 >> 2];
	                        break
	                    }
	                    if ((c[(c[a + 68 >> 2] | 0) + 4 >> 2] | 0) != 2 ? (c[(c[(c[e >> 2] | 0) + 68 >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                        c[d >> 2] = (c[(c[e >> 2] | 0) + 72 >> 2] | 0) + 2;
	                        break
	                    }
	                    c[d >> 2] = (c[(c[e >> 2] | 0) + 72 >> 2] | 0) + 1
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function bM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                a:do if (!(c[e >> 2] | 0))c[d >> 2] = -1; else {
	                    if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0)c[f >> 2] = c[a + 68 >> 2]; else c[f >> 2] = c[a + 64 >> 2];
	                    switch (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                        case 18:
	                        case 8:
	                        case 7:
	                        case 4:
	                        case 3:
	                        case 2:
	                        {
	                            c[d >> 2] = 1;
	                            break a;
	                            break
	                        }
	                        default:
	                        {
	                            c[d >> 2] = 0;
	                            break a
	                        }
	                    }
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function cM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                if (!(c[(c[f >> 2] | 0) + 64 >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = b;
	                    return j | 0
	                }
	                a = c[f >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 68 >> 2] | 0)c[g >> 2] = c[a + 68 >> 2]; else c[g >> 2] = c[a + 64 >> 2];
	                switch (c[(c[g >> 2] | 0) + 4 >> 2] | 0) {
	                    case 8:
	                    case 7:
	                    case 4:
	                    case 3:
	                    {
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 40 >> 2];
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    case 2:
	                    {
	                        c[h >> 2] = c[g >> 2];
	                        if (((c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 3 : 0) ? (c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                            c[e >> 2] = c[(c[(c[h >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2];
	                            j = c[e >> 2] | 0;
	                            i = b;
	                            return j | 0
	                        }
	                        if (!(c[(c[f >> 2] | 0) + 84 >> 2] | 0)) {
	                            h = My(100) | 0;
	                            c[(c[f >> 2] | 0) + 84 >> 2] = h;
	                            if (!(c[(c[f >> 2] | 0) + 84 >> 2] | 0)) {
	                                Db[c[135904 >> 2] & 511](c[33980] | 0, 187608, d);
	                                c[e >> 2] = 0;
	                                j = c[e >> 2] | 0;
	                                i = b;
	                                return j | 0
	                            }
	                        } else Sy(c[(c[f >> 2] | 0) + 84 >> 2] | 0);
	                        Zi(c[(c[f >> 2] | 0) + 84 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        c[e >> 2] = Vy(c[(c[f >> 2] | 0) + 84 >> 2] | 0) | 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    case 18:
	                    {
	                        c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                    default:
	                    {
	                        c[e >> 2] = 0;
	                        j = c[e >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                }
	                return 0
	            }

	            function dM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[h >> 2];
	                a:do if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[l >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                    h = c[k >> 2] | 0;
	                    if ((h | 0) == 4) {
	                        d = (c[l >> 2] | 0) + 16 | 0;
	                        if (c[j >> 2] | 0)c[d >> 2] = 1; else c[d >> 2] = 0;
	                        c[f >> 2] = 0;
	                        break
	                    } else if ((h | 0) == 2) {
	                        d = (c[l >> 2] | 0) + 276 | 0;
	                        b = c[d >> 2] | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            if (b & 4) {
	                                a = (c[l >> 2] | 0) + 276 | 0;
	                                c[a >> 2] = (c[a >> 2] | 0) - 4
	                            }
	                        } else c[d >> 2] = b | 4;
	                        c[f >> 2] = 0;
	                        break
	                    } else if ((h | 0) == 1) {
	                        b = (c[l >> 2] | 0) + 276 | 0;
	                        do if (c[j >> 2] | 0) {
	                            if (!(c[b >> 2] | 0))if (c[c[g >> 2] >> 2] | 0) {
	                                c[f >> 2] = -1;
	                                break a
	                            } else {
	                                c[(c[l >> 2] | 0) + 276 >> 2] = 2;
	                                break
	                            }
	                        } else c[b >> 2] = 0; while (0);
	                        c[f >> 2] = 0;
	                        break
	                    } else if ((h | 0) == 3) {
	                        b = (c[l >> 2] | 0) + 104 | 0;
	                        if (c[j >> 2] | 0) {
	                            c[b >> 2] = 1;
	                            c[(c[g >> 2] | 0) + 8 >> 2] = 1
	                        } else c[b >> 2] = 0;
	                        c[f >> 2] = 0;
	                        break
	                    } else {
	                        c[f >> 2] = -1;
	                        break
	                    }
	                } else m = 3; while (0);
	                if ((m | 0) == 3)c[f >> 2] = -1;
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function eM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0) {
	                        c[d >> 2] = c[a + 68 >> 2];
	                        break
	                    } else {
	                        c[d >> 2] = c[a + 64 >> 2];
	                        break
	                    }
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function fM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = HM(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function gM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = IM(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function hM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (!(c[e >> 2] | 0))c[d >> 2] = -1; else {
	                    a = c[e >> 2] | 0;
	                    if ((c[(c[e >> 2] | 0) + 8 >> 2] | 0) == 2) {
	                        c[d >> 2] = (c[a + 128 >> 2] | 0) == 0 & 1;
	                        break
	                    }
	                    f = c[e >> 2] | 0;
	                    if ((c[a + 8 >> 2] | 0) == 4) {
	                        c[d >> 2] = (c[f + 148 >> 2] | 0) == 0 & 1;
	                        break
	                    }
	                    if ((c[f + 20 >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 104 >> 2] | 0) == 1 : 0) {
	                        c[d >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 100 >> 2];
	                        break
	                    }
	                    c[d >> 2] = 0
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function iM(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g;
	                j = g + 40 | 0;
	                k = g + 36 | 0;
	                l = g + 32 | 0;
	                m = g + 28 | 0;
	                n = g + 24 | 0;
	                o = g + 20 | 0;
	                p = g + 16 | 0;
	                q = g + 12 | 0;
	                r = g + 8 | 0;
	                s = g + 4 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                if (!(c[k >> 2] | 0)) {
	                    if (c[l >> 2] | 0)yk(c[l >> 2] | 0);
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                c[o >> 2] = c[o >> 2] | 65536;
	                c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 96 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 188 >> 2] = c[o >> 2];
	                c[(c[k >> 2] | 0) + 8 >> 2] = 0;
	                if (((c[l >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 28 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 12 >> 2] & 1 | 0) != 0 : 0) {
	                    yk(c[(c[k >> 2] | 0) + 28 >> 2] | 0);
	                    c[(c[k >> 2] | 0) + 28 >> 2] = 0;
	                    f = (c[k >> 2] | 0) + 12 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) - 1
	                }
	                if (c[l >> 2] | 0) {
	                    c[(c[k >> 2] | 0) + 28 >> 2] = c[l >> 2];
	                    f = (c[k >> 2] | 0) + 12 | 0;
	                    c[f >> 2] = c[f >> 2] | 1
	                }
	                if (!(c[(c[k >> 2] | 0) + 84 >> 2] | 0)) {
	                    f = My(100) | 0;
	                    c[(c[k >> 2] | 0) + 84 >> 2] = f
	                }
	                if (!(c[(c[k >> 2] | 0) + 84 >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187608, h);
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                    f = Cb[c[135744 >> 2] & 511](128) | 0;
	                    c[(c[k >> 2] | 0) + 24 >> 2] = f
	                }
	                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187608, h);
	                    c[j >> 2] = -1;
	                    t = c[j >> 2] | 0;
	                    i = g;
	                    return t | 0
	                }
	                oQ(c[(c[k >> 2] | 0) + 24 >> 2] | 0, 2) | 0;
	                c[(c[k >> 2] | 0) + 32 >> 2] = c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 56 >> 2];
	                c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 56 >> 2] = 361;
	                c[(c[k >> 2] | 0) + 36 >> 2] = c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 60 >> 2];
	                c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 60 >> 2] = 362;
	                f = c[k >> 2] | 0;
	                if ((c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 108 >> 2] | 0) == -554844497) {
	                    c[(c[k >> 2] | 0) + 40 >> 2] = c[(c[f + 24 >> 2] | 0) + 116 >> 2];
	                    c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 116 >> 2] = 363;
	                    c[(c[k >> 2] | 0) + 44 >> 2] = c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 120 >> 2];
	                    c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 120 >> 2] = 364
	                } else {
	                    c[f + 40 >> 2] = 0;
	                    c[(c[k >> 2] | 0) + 44 >> 2] = 0
	                }
	                c[(c[k >> 2] | 0) + 48 >> 2] = c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 68 >> 2];
	                c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 68 >> 2] = 365;
	                c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 72 >> 2] = 365;
	                c[(c[k >> 2] | 0) + 52 >> 2] = c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 100 >> 2];
	                c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 100 >> 2] = 366;
	                c[c[k >> 2] >> 2] = 0;
	                c[(c[k >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 68 >> 2] = 0;
	                if (c[l >> 2] | 0) {
	                    if ((_y(c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 < 4)Nk(c[l >> 2] | 0, 4) | 0;
	                    do if (!(c[(c[k >> 2] | 0) + 20 >> 2] | 0)) {
	                        l = (_y(c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) | 0) >>> 0 >= 4;
	                        f = c[(c[k >> 2] | 0) + 24 >> 2] | 0;
	                        if (l) {
	                            l = Vy(c[(c[(c[k >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) | 0;
	                            e = Tf(f, 0, l, 4, c[m >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 20 >> 2] = e;
	                            c[(c[k >> 2] | 0) + 56 >> 2] = 0;
	                            c[(c[k >> 2] | 0) + 60 >> 2] = 4;
	                            break
	                        } else {
	                            e = Tf(f, 0, 0, 0, c[m >> 2] | 0) | 0;
	                            c[(c[k >> 2] | 0) + 20 >> 2] = e;
	                            c[(c[k >> 2] | 0) + 56 >> 2] = 0;
	                            c[(c[k >> 2] | 0) + 60 >> 2] = 0;
	                            break
	                        }
	                    } else {
	                        c[r >> 2] = 0;
	                        eg(c[(c[k >> 2] | 0) + 20 >> 2] | 0);
	                        c[q >> 2] = vk(c[r >> 2] | 0) | 0;
	                        if (!(c[q >> 2] | 0)) {
	                            c[j >> 2] = -1;
	                            t = c[j >> 2] | 0;
	                            i = g;
	                            return t | 0
	                        }
	                        c[p >> 2] = ue(c[(c[k >> 2] | 0) + 20 >> 2] | 0) | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            yk(c[q >> 2] | 0);
	                            c[j >> 2] = -1;
	                            t = c[j >> 2] | 0;
	                            i = g;
	                            return t | 0
	                        }
	                        if (!(c[m >> 2] | 0))c[(c[p >> 2] | 0) + 4 >> 2] = 0; else {
	                            e = Jl(c[m >> 2] | 0) | 0;
	                            c[(c[p >> 2] | 0) + 4 >> 2] = e
	                        }
	                        c[c[p >> 2] >> 2] = c[q >> 2];
	                        iz(c[(c[q >> 2] | 0) + 16 >> 2] | 0, c[p >> 2] | 0) | 0;
	                        Oe(c[(c[k >> 2] | 0) + 20 >> 2] | 0, c[p >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 60 >> 2] = 0
	                    } while (0);
	                    if (!(c[(c[k >> 2] | 0) + 20 >> 2] | 0)) {
	                        Db[c[135904 >> 2] & 511](c[33980] | 0, 187608, h);
	                        c[j >> 2] = -1;
	                        t = c[j >> 2] | 0;
	                        i = g;
	                        return t | 0
	                    }
	                }
	                h = c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2] | 0;
	                do if (c[(c[k >> 2] | 0) + 88 >> 2] | 0) {
	                    p = c[(c[k >> 2] | 0) + 88 >> 2] | 0;
	                    q = (c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 296 | 0;
	                    if (!h) {
	                        c[q >> 2] = p;
	                        break
	                    }
	                    if ((p | 0) != (c[q >> 2] | 0)) {
	                        zP(c[(c[k >> 2] | 0) + 88 >> 2] | 0);
	                        c[(c[k >> 2] | 0) + 88 >> 2] = c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2]
	                    }
	                } else {
	                    if (!h) {
	                        q = xP() | 0;
	                        c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2] = q
	                    }
	                    c[(c[k >> 2] | 0) + 88 >> 2] = c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2]
	                } while (0);
	                c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 272 >> 2] = c[k >> 2];
	                c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 280 >> 2] = 1;
	                c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 364 >> 2] = 1;
	                c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 308 >> 2] = 1;
	                c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 436 >> 2] = 5;
	                if (c[(c[k >> 2] | 0) + 164 >> 2] | 0) {
	                    Rv(c[(c[k >> 2] | 0) + 164 >> 2] | 0);
	                    c[(c[k >> 2] | 0) + 164 >> 2] = 0
	                }
	                h = (c[k >> 2] | 0) + 156 | 0;
	                if (c[o >> 2] & 1024) {
	                    c[h >> 2] = 1;
	                    q = AP(c[(c[k >> 2] | 0) + 88 >> 2] | 0, 187696, -1) | 0;
	                    c[(c[k >> 2] | 0) + 160 >> 2] = q;
	                    c[o >> 2] = (c[o >> 2] | 0) - 1024
	                } else c[h >> 2] = 0;
	                c[(c[k >> 2] | 0) + 168 >> 2] = 0;
	                if (!(c[(c[k >> 2] | 0) + 180 >> 2] | 0)) {
	                    c[(c[k >> 2] | 0) + 172 >> 2] = 0;
	                    c[(c[k >> 2] | 0) + 176 >> 2] = 0
	                }
	                while (1) {
	                    if ((c[(c[k >> 2] | 0) + 172 >> 2] | 0) <= 0)break;
	                    h = (c[k >> 2] | 0) + 172 | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + -1;
	                    if (!(c[(c[(c[k >> 2] | 0) + 180 >> 2] | 0) + (c[(c[k >> 2] | 0) + 172 >> 2] << 2) >> 2] | 0))continue;
	                    EQ(c[(c[(c[k >> 2] | 0) + 180 >> 2] | 0) + (c[(c[k >> 2] | 0) + 172 >> 2] << 2) >> 2] | 0);
	                    c[(c[(c[k >> 2] | 0) + 180 >> 2] | 0) + (c[(c[k >> 2] | 0) + 172 >> 2] << 2) >> 2] = 0
	                }
	                if (c[o >> 2] & 16)c[(c[k >> 2] | 0) + 8 >> 2] = 1;
	                fg(c[(c[k >> 2] | 0) + 20 >> 2] | 0, c[o >> 2] | 0) | 0;
	                if ((c[n >> 2] | 0) != 0 ? (c[s >> 2] = Dd(c[n >> 2] | 0) | 0, (c[s >> 2] | 0) != 0) : 0)se(c[(c[k >> 2] | 0) + 20 >> 2] | 0, c[s >> 2] | 0) | 0;
	                if (((c[m >> 2] | 0) != 0 ? (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) {
	                    s = my(c[m >> 2] | 0) | 0;
	                    c[(c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] = s
	                }
	                c[(c[k >> 2] | 0) + 4 >> 2] = 0;
	                c[j >> 2] = 0;
	                t = c[j >> 2] | 0;
	                i = g;
	                return t | 0
	            }

	            function jM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](196) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187440, b);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    cU(c[f >> 2] | 0, 0, 196) | 0;
	                    c[(c[f >> 2] | 0) + 96 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                    c[c[f >> 2] >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 68 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 12 >> 2] = 2;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                    e = xP() | 0;
	                    c[(c[f >> 2] | 0) + 88 >> 2] = e;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function kM(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 4 | 0;
	                p = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = Ik(c[j >> 2] | 0, c[k >> 2] | 0, 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                c[o >> 2] = TL(c[p >> 2] | 0, c[l >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0)) {
	                    yk(c[p >> 2] | 0);
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                } else {
	                    p = (c[o >> 2] | 0) + 12 | 0;
	                    c[p >> 2] = c[p >> 2] | 1;
	                    iM(c[o >> 2] | 0, 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    c[h >> 2] = c[o >> 2];
	                    q = c[h >> 2] | 0;
	                    i = g;
	                    return q | 0
	                }
	                return 0
	            }

	            function lM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = UL(c[g >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    iM(c[k >> 2] | 0, 0, 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[f >> 2] = c[k >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function mM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) == 2) {
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                a:while (1) {
	                    a = c[e >> 2] | 0;
	                    do if (!(c[(c[e >> 2] | 0) + 64 >> 2] | 0)) {
	                        g = c[e >> 2] | 0;
	                        if (!(c[(c[a + 4 >> 2] | 0) + 12 >> 2] | 0)) {
	                            h = 5;
	                            break a
	                        }
	                        c[(c[e >> 2] | 0) + 64 >> 2] = c[(c[g + 4 >> 2] | 0) + 12 >> 2];
	                        c[(c[e >> 2] | 0) + 16 >> 2] = 0
	                    } else {
	                        if ((((c[a + 16 >> 2] | 0) != 4 ? (c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 14 : 0) ? (c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                            j = c[(c[e >> 2] | 0) + 64 >> 2] | 0;
	                            if (c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 12 >> 2] | 0) {
	                                c[(c[e >> 2] | 0) + 64 >> 2] = c[j + 12 >> 2];
	                                k = (c[e >> 2] | 0) + 72 | 0;
	                                c[k >> 2] = (c[k >> 2] | 0) + 1;
	                                c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                                break
	                            }
	                            if ((c[j + 4 >> 2] | 0) == 2) {
	                                c[(c[e >> 2] | 0) + 16 >> 2] = 4;
	                                break
	                            }
	                        }
	                        j = c[(c[e >> 2] | 0) + 64 >> 2] | 0;
	                        if (c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 24 >> 2] | 0) {
	                            c[(c[e >> 2] | 0) + 64 >> 2] = c[j + 24 >> 2];
	                            c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                            break
	                        }
	                        k = c[e >> 2] | 0;
	                        if (!(c[j + 20 >> 2] | 0)) {
	                            c[k + 16 >> 2] = 2;
	                            break
	                        }
	                        if ((c[(c[(c[k + 64 >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 9) {
	                            h = 20;
	                            break a
	                        }
	                        if ((c[(c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 13) {
	                            h = 20;
	                            break a
	                        }
	                        c[(c[e >> 2] | 0) + 64 >> 2] = c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 20 >> 2];
	                        k = (c[e >> 2] | 0) + 72 | 0;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1;
	                        c[(c[e >> 2] | 0) + 16 >> 2] = 4
	                    } while (0);
	                    if ((c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) == 19)continue;
	                    if ((c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 4 >> 2] | 0) != 20) {
	                        h = 25;
	                        break
	                    }
	                }
	                if ((h | 0) == 5) {
	                    c[g + 16 >> 2] = 2;
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else if ((h | 0) == 20) {
	                    c[(c[e >> 2] | 0) + 16 >> 2] = 2;
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else if ((h | 0) == 25) {
	                    c[d >> 2] = 1;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function nM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 28 >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) {
	                    c[j >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                    c[(c[e >> 2] | 0) + 16 >> 2] = -1;
	                    c[f >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 16 >> 2];
	                    c[k >> 2] = Py(c[f >> 2] | 0) | 0;
	                    a:do {
	                        if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) != -1)break;
	                        a = _y(c[f >> 2] | 0) | 0;
	                        do if (a >>> 0 < ((c[(c[e >> 2] | 0) + 60 >> 2] | 0) + 512 | 0) >>> 0) {
	                            if ((c[c[e >> 2] >> 2] | 0) == 3)break a;
	                            c[g >> 2] = Nk(c[(c[e >> 2] | 0) + 28 >> 2] | 0, 4096) | 0;
	                            if ((c[g >> 2] | 0) == 0 & (c[k >> 2] | 0) == 2) {
	                                l = _y(c[f >> 2] | 0) | 0;
	                                if ((l | 0) != (c[(c[e >> 2] | 0) + 60 >> 2] | 0))break;
	                                c[c[e >> 2] >> 2] = 3;
	                                c[(c[e >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                                break
	                            }
	                            if ((c[g >> 2] | 0) >= 0)if (!(c[g >> 2] | 0)) {
	                                m = 16;
	                                break a
	                            } else break;
	                            c[c[e >> 2] >> 2] = 3;
	                            c[(c[e >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                            if (c[j >> 2] | 0) {
	                                m = 14;
	                                break a
	                            }
	                            if (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) {
	                                m = 14;
	                                break a
	                            }
	                        } while (0);
	                        a = _y(c[f >> 2] | 0) | 0;
	                        if (a >>> 0 < ((c[(c[e >> 2] | 0) + 60 >> 2] | 0) + 512 | 0) >>> 0) {
	                            m = 21;
	                            break
	                        }
	                        a = c[(c[e >> 2] | 0) + 20 >> 2] | 0;
	                        l = Vy(c[f >> 2] | 0) | 0;
	                        c[g >> 2] = Sf(a, l + (c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0, 512, 0) | 0;
	                        l = (c[e >> 2] | 0) + 60 | 0;
	                        c[l >> 2] = (c[l >> 2] | 0) + 512;
	                        if (c[g >> 2] | 0)c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] = 0
	                    } while ((c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0) != 0);
	                    if ((m | 0) == 14) {
	                        c[d >> 2] = c[g >> 2];
	                        n = c[d >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    } else if ((m | 0) == 16)c[c[e >> 2] >> 2] = 3; else if ((m | 0) == 21 ? (m = _y(c[f >> 2] | 0) | 0, c[h >> 2] = m - (c[(c[e >> 2] | 0) + 60 >> 2] | 0), m = c[(c[e >> 2] | 0) + 20 >> 2] | 0, l = Vy(c[f >> 2] | 0) | 0, c[g >> 2] = Sf(m, l + (c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0, c[h >> 2] | 0, 0) | 0, l = (c[e >> 2] | 0) + 60 | 0, c[l >> 2] = (c[l >> 2] | 0) + (c[h >> 2] | 0), (c[g >> 2] | 0) != 0) : 0)c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] = 0;
	                    do if ((c[c[e >> 2] >> 2] | 0) == 1) {
	                        if ((((c[k >> 2] | 0) != 2 ? (c[(c[e >> 2] | 0) + 60 >> 2] | 0) >>> 0 >= 4096 : 0) ? (l = _y(c[f >> 2] | 0) | 0, (l - (c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0) >>> 0 <= 512) : 0) ? (c[g >> 2] = Ty(c[f >> 2] | 0, c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0, (c[g >> 2] | 0) >= 0) : 0) {
	                            l = (c[e >> 2] | 0) + 60 | 0;
	                            c[l >> 2] = (c[l >> 2] | 0) - (c[g >> 2] | 0)
	                        }
	                    } else if (((c[c[e >> 2] >> 2] | 0) == 3 ? (c[(c[e >> 2] | 0) + 16 >> 2] | 0) != 5 : 0) ? (l = _y(c[f >> 2] | 0) | 0, c[h >> 2] = l - (c[(c[e >> 2] | 0) + 60 >> 2] | 0), l = c[(c[e >> 2] | 0) + 20 >> 2] | 0, m = Vy(c[f >> 2] | 0) | 0, c[g >> 2] = Sf(l, m + (c[(c[e >> 2] | 0) + 60 >> 2] | 0) | 0, c[h >> 2] | 0, 1) | 0, m = _y(c[f >> 2] | 0) | 0, c[(c[e >> 2] | 0) + 60 >> 2] = m, c[(c[e >> 2] | 0) + 16 >> 2] = 5, (c[g >> 2] | 0) != 0) : 0) {
	                        if (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0) {
	                            c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] = 0;
	                            break
	                        }
	                        c[d >> 2] = -1;
	                        n = c[d >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    } while (0);
	                    c[(c[e >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                    if (!(c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[c[e >> 2] >> 2] = 3;
	                        c[d >> 2] = -1;
	                        n = c[d >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    } else {
	                        c[d >> 2] = 0;
	                        n = c[d >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                }
	                c[d >> 2] = -1;
	                n = c[d >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function oM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[(c[d >> 2] | 0) + 64 >> 2];
	                do if (((c[(c[d >> 2] | 0) + 8 >> 2] | 0) == 1 ? (c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 104 >> 2] | 0) == 1 : 0) {
	                    if ((c[(c[e >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        c[f >> 2] = my(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        c[f >> 2] = By(c[f >> 2] | 0, 187520) | 0;
	                        c[f >> 2] = By(c[f >> 2] | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        a = _m((c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 108 | 0, c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                        h = (c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 100 | 0;
	                        c[h >> 2] = c[h >> 2] & a;
	                        if (!(c[f >> 2] | 0))break;
	                        zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                        break
	                    }
	                    a = _m((c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 108 | 0, c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[e >> 2] | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    h = (c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 100 | 0;
	                    c[h >> 2] = c[h >> 2] & a
	                } while (0);
	                if ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 2) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 120 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 132 >> 2] | 0) {
	                    if ((c[e >> 2] | 0) != (c[(c[d >> 2] | 0) + 132 >> 2] | 0)) {
	                        i = b;
	                        return
	                    }
	                    c[(c[d >> 2] | 0) + 132 >> 2] = 0;
	                    i = b;
	                    return
	                } else {
	                    c[g >> 2] = cN(c[(c[d >> 2] | 0) + 120 >> 2] | 0, c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[e >> 2] | 0) | 0;
	                    if ((c[g >> 2] | 0) == 1) {
	                        i = b;
	                        return
	                    }
	                    g = (c[d >> 2] | 0) + 128 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    i = b;
	                    return
	                }
	            }

	            function pM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)c[g >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2]; else c[g >> 2] = 0;
	                b = c[f >> 2] | 0;
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                    Ph(b);
	                    i = d;
	                    return
	                }
	                a = c[f >> 2] | 0;
	                if ((c[b + 4 >> 2] | 0) == 18) {
	                    Jh(a);
	                    i = d;
	                    return
	                }
	                if ((c[a + 4 >> 2] | 0) == 2) {
	                    MM(c[e >> 2] | 0, c[f >> 2] | 0);
	                    i = d;
	                    return
	                }
	                if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                    if ((c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0) == (c[f >> 2] | 0))NM(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 12 >> 2] = 0
	                }
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[f >> 2] | 0);
	                if (!(((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))h = 21;
	                if ((h | 0) == 21 ? (c[(c[f >> 2] | 0) + 44 >> 2] | 0) != 0 : 0)OM(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 44 >> 2] | 0);
	                do if ((((((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != ((c[f >> 2] | 0) + 44 | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 40 >> 2] | 0)
	                } while (0);
	                if (!(((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))h = 35;
	                if ((h | 0) == 35 ? (c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0 : 0)Lh(c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                do if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0)
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    if (c[e >> 2] | 0)h = 46
	                } else if ((c[e >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3 : 0)h = 46;
	                if (((h | 0) == 46 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 368 >> 2] | 0) < 100 : 0) {
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 372 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 372 >> 2] = c[f >> 2];
	                    h = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 368 | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1;
	                    i = d;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function qM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[(c[g >> 2] | 0) + 100 >> 2] | 0) <= 0 ? (c[(c[g >> 2] | 0) + 100 >> 2] = 10, b = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 100 >> 2] << 2) | 0, c[(c[g >> 2] | 0) + 104 >> 2] = b, (c[(c[g >> 2] | 0) + 104 >> 2] | 0) == 0) : 0) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187648, e);
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[(c[g >> 2] | 0) + 96 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 100 >> 2] | 0) ? (b = (c[g >> 2] | 0) + 100 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 104 >> 2] | 0, c[(c[g >> 2] | 0) + 100 >> 2] << 2) | 0, c[(c[g >> 2] | 0) + 104 >> 2] = b, (c[(c[g >> 2] | 0) + 104 >> 2] | 0) == 0) : 0) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187672, e);
	                    c[f >> 2] = 0;
	                    j = c[f >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[(c[(c[g >> 2] | 0) + 104 >> 2] | 0) + (c[(c[g >> 2] | 0) + 96 >> 2] << 2) >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 92 >> 2] = c[h >> 2];
	                h = (c[g >> 2] | 0) + 96 | 0;
	                g = c[h >> 2] | 0;
	                c[h >> 2] = g + 1;
	                c[f >> 2] = g;
	                j = c[f >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function rM(a) {
	                a = a | 0;
	                var b = 0, d = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[d >> 2] = a;
	                c[f >> 2] = c[(c[d >> 2] | 0) + 64 >> 2];
	                c[g >> 2] = c[(c[d >> 2] | 0) + 64 >> 2];
	                c[h >> 2] = c[(c[d >> 2] | 0) + 20 >> 2];
	                a:while (1) {
	                    a = c[g >> 2] | 0;
	                    do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 5) {
	                        if (((c[a + 12 >> 2] | 0) == 0 ? (c[c[h >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[h >> 2] >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                            k = Hb[c[(c[c[h >> 2] >> 2] | 0) + 20 >> 2] & 511](c[h >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            c[(c[g >> 2] | 0) + 12 >> 2] = k
	                        }
	                        if (((c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) == 17 : 0) ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                            qM(c[d >> 2] | 0, c[g >> 2] | 0) | 0;
	                            c[g >> 2] = c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2];
	                            break
	                        }
	                        if ((c[g >> 2] | 0) == (c[f >> 2] | 0)) {
	                            l = 41;
	                            break a
	                        }
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        l = 18
	                    } else {
	                        k = c[g >> 2] | 0;
	                        if ((c[a + 4 >> 2] | 0) == 1) {
	                            c[(c[d >> 2] | 0) + 64 >> 2] = k;
	                            tM(c[d >> 2] | 0);
	                            l = 18;
	                            break
	                        }
	                        if ((c[k + 4 >> 2] | 0) != 3 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                            l = 18;
	                            break
	                        }
	                        k = c[d >> 2] | 0;
	                        m = c[(c[g >> 2] | 0) + 40 >> 2] | 0;
	                        uM(k, m, xy(c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0);
	                        l = 18
	                    } while (0);
	                    b:do if ((l | 0) == 18) {
	                        l = 0;
	                        a = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                            c[g >> 2] = c[a + 12 >> 2];
	                            break
	                        }
	                        if ((c[a + 4 >> 2] | 0) == 1)oM(c[d >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                            break
	                        }
	                        while (1) {
	                            c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                            if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                c:do if (!(c[(c[d >> 2] | 0) + 96 >> 2] | 0))while (1) {
	                                    a = c[(c[g >> 2] | 0) + 16 >> 2] | 0;
	                                    c[j >> 2] = a;
	                                    if (!a)break c;
	                                    if ((e[(c[j >> 2] | 0) + 58 >> 1] | 0) & 2)break c;
	                                    Qh(c[j >> 2] | 0);
	                                    pM(c[d >> 2] | 0, c[j >> 2] | 0)
	                                } while (0);
	                                c[(c[d >> 2] | 0) + 64 >> 2] = c[g >> 2];
	                                oM(c[d >> 2] | 0)
	                            }
	                            if (((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 17 ? (c[(c[d >> 2] | 0) + 92 >> 2] | 0) != 0 : 0) ? (c[(c[(c[d >> 2] | 0) + 92 >> 2] | 0) + 12 >> 2] | 0) == (c[g >> 2] | 0) : 0)c[g >> 2] = sM(c[d >> 2] | 0) | 0;
	                            if ((c[g >> 2] | 0) == (c[f >> 2] | 0))break b;
	                            n = c[g >> 2] | 0;
	                            if (c[(c[g >> 2] | 0) + 24 >> 2] | 0)break;
	                            if (!n)break b;
	                            if ((c[g >> 2] | 0) == (c[f >> 2] | 0))break b
	                        }
	                        c[g >> 2] = c[n + 24 >> 2]
	                    } while (0);
	                    if (!(c[g >> 2] | 0)) {
	                        l = 41;
	                        break
	                    }
	                    if ((c[g >> 2] | 0) == (c[f >> 2] | 0)) {
	                        l = 41;
	                        break
	                    }
	                }
	                if ((l | 0) == 41) {
	                    c[(c[d >> 2] | 0) + 64 >> 2] = c[f >> 2];
	                    i = b;
	                    return
	                }
	            }

	            function sM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 96 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 96 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 92 >> 2] = c[(c[(c[e >> 2] | 0) + 104 >> 2] | 0) + ((c[a + 96 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 92 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 104 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 104 >> 2] | 0) + (c[(c[e >> 2] | 0) + 96 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function tM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                c[e >> 2] = a;
	                c[f >> 2] = c[(c[e >> 2] | 0) + 64 >> 2];
	                do if (((c[(c[e >> 2] | 0) + 8 >> 2] | 0) == 1 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 104 >> 2] | 0) == 1 : 0) {
	                    if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        c[g >> 2] = my(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, 187520) | 0;
	                        c[g >> 2] = By(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        a = Ym((c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 108 | 0, c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        j = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 100 | 0;
	                        c[j >> 2] = c[j >> 2] & a;
	                        if (!(c[g >> 2] | 0))break;
	                        zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        break
	                    }
	                    a = Ym((c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 108 | 0, c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[f >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    j = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 100 | 0;
	                    c[j >> 2] = c[j >> 2] & a
	                } while (0);
	                if ((c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 2) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 120 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 132 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                c[h >> 2] = aN(c[(c[e >> 2] | 0) + 120 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[f >> 2] | 0) | 0;
	                do if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = RL(c[e >> 2] | 0) | 0;
	                    if (!(c[f >> 2] | 0)) {
	                        Wa(187736, d | 0) | 0;
	                        c[h >> 2] = -1;
	                        break
	                    } else {
	                        c[h >> 2] = dN(c[(c[e >> 2] | 0) + 120 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[f >> 2] | 0) | 0;
	                        c[(c[e >> 2] | 0) + 132 >> 2] = c[f >> 2];
	                        break
	                    }
	                } while (0);
	                if ((c[h >> 2] | 0) == 1) {
	                    i = b;
	                    return
	                }
	                h = (c[e >> 2] | 0) + 128 | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + 1;
	                i = b;
	                return
	            }

	            function uM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 1 ? (c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 104 >> 2] | 0) == 1 : 0) {
	                    d = Zm((c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 108 | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    b = (c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 100 | 0;
	                    c[b >> 2] = c[b >> 2] & d
	                }
	                if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 2) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[f >> 2] | 0) + 120 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 132 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = bN(c[(c[f >> 2] | 0) + 120 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[j >> 2] | 0) == 1) {
	                    i = e;
	                    return
	                }
	                j = (c[f >> 2] | 0) + 128 | 0;
	                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                i = e;
	                return
	            }

	            function vM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                do if (((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    while (1) {
	                        if ((c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 172 >> 2] | 0) == -1) {
	                            g = 6;
	                            break
	                        }
	                        if (PM(c[(c[e >> 2] | 0) + 64 >> 2] | 0) | 0) {
	                            g = 8;
	                            break
	                        }
	                        if ((c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 56 >> 2] | 0) < (c[(c[e >> 2] | 0) + 72 >> 2] | 0)) {
	                            g = 10;
	                            break
	                        }
	                        if ((c[c[e >> 2] >> 2] | 0) == 3) {
	                            g = 12;
	                            break
	                        }
	                        c[f >> 2] = nM(c[e >> 2] | 0) | 0;
	                        h = c[e >> 2] | 0;
	                        if ((c[f >> 2] | 0) < 0) {
	                            g = 14;
	                            break
	                        }
	                        if ((c[h >> 2] | 0) == 3) {
	                            g = 16;
	                            break
	                        }
	                    }
	                    if ((g | 0) == 6) {
	                        c[d >> 2] = 1;
	                        break
	                    } else if ((g | 0) == 8) {
	                        c[d >> 2] = 1;
	                        break
	                    } else if ((g | 0) == 10) {
	                        c[d >> 2] = 1;
	                        break
	                    } else if ((g | 0) == 12) {
	                        c[d >> 2] = 1;
	                        break
	                    } else if ((g | 0) == 14) {
	                        c[h >> 2] = 2;
	                        c[d >> 2] = -1;
	                        break
	                    } else if ((g | 0) == 16) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                } else g = 4; while (0);
	                if ((g | 0) == 4)c[d >> 2] = -1;
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function wM(a, e, f) {
	                a = a | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 16 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                l = g + 4 | 0;
	                m = g;
	                c[h >> 2] = a;
	                c[j >> 2] = e;
	                c[k >> 2] = f;
	                c[l >> 2] = c[h >> 2];
	                c[m >> 2] = c[(c[l >> 2] | 0) + 272 >> 2];
	                if (((((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (Db[c[(c[m >> 2] | 0) + 32 >> 2] & 511](c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0), (c[(c[l >> 2] | 0) + 52 >> 2] | 0) != 0) : 0) ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (d[c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 : 0) ? (d[(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)b[(c[(c[l >> 2] | 0) + 52 >> 2] | 0) + 58 >> 1] = 1;
	                if (!(c[m >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[(c[m >> 2] | 0) + 16 >> 2] = 1;
	                i = g;
	                return
	            }

	            function xM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[e >> 2];
	                c[h >> 2] = c[(c[g >> 2] | 0) + 272 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Ab[c[(c[h >> 2] | 0) + 36 >> 2] & 511](c[e >> 2] | 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function yM(a, e, f, g, h, j, k, l, m) {
	                a = a | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                m = m | 0;
	                var n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                n = i;
	                i = i + 48 | 0;
	                o = n + 40 | 0;
	                p = n + 36 | 0;
	                q = n + 32 | 0;
	                r = n + 28 | 0;
	                s = n + 24 | 0;
	                t = n + 20 | 0;
	                u = n + 16 | 0;
	                v = n + 12 | 0;
	                w = n + 8 | 0;
	                x = n + 4 | 0;
	                y = n;
	                c[o >> 2] = a;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = l;
	                c[w >> 2] = m;
	                c[x >> 2] = c[o >> 2];
	                c[y >> 2] = c[(c[x >> 2] | 0) + 272 >> 2];
	                if (((((((c[y >> 2] | 0) != 0 ? (c[(c[y >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (Eb[c[(c[y >> 2] | 0) + 40 >> 2] & 511](c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0, c[v >> 2] | 0, c[w >> 2] | 0), (c[(c[x >> 2] | 0) + 52 >> 2] | 0) != 0) : 0) ? (c[(c[x >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[(c[x >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) != 0 : 0) ? (d[c[(c[(c[x >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] >> 0] | 0 | 0) == 47 : 0) ? (d[(c[(c[(c[x >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + 1 >> 0] | 0 | 0) == 62 : 0)b[(c[(c[x >> 2] | 0) + 52 >> 2] | 0) + 58 >> 1] = 1;
	                if (!(c[y >> 2] | 0)) {
	                    i = n;
	                    return
	                }
	                c[(c[y >> 2] | 0) + 16 >> 2] = 1;
	                i = n;
	                return
	            }

	            function zM(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                c[m >> 2] = c[(c[l >> 2] | 0) + 272 >> 2];
	                if (!(c[m >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[m >> 2] | 0) + 44 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Jb[c[(c[m >> 2] | 0) + 44 >> 2] & 511](c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function AM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                c[k >> 2] = c[(c[j >> 2] | 0) + 272 >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[k >> 2] | 0) + 48 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Db[c[(c[k >> 2] | 0) + 48 >> 2] & 511](c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function BM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                c[k >> 2] = c[(c[j >> 2] | 0) + 272 >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[k >> 2] | 0) + 52 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                Db[c[(c[k >> 2] | 0) + 52 >> 2] & 511](c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function CM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[f >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 64 >> 2] | 0)QM(c[(c[f >> 2] | 0) + 64 >> 2] | 0);
	                c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                if (c[(c[f >> 2] | 0) + 68 >> 2] | 0)Jm(c[(c[f >> 2] | 0) + 68 >> 2] | 0);
	                c[(c[f >> 2] | 0) + 68 >> 2] = 0;
	                c[g >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                c[h >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                if ((c[h >> 2] | 0) == (c[g >> 2] | 0))c[g >> 2] = 0;
	                if (c[g >> 2] | 0) {
	                    Qh(c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                    Ph(c[g >> 2] | 0)
	                }
	                if (c[h >> 2] | 0) {
	                    Qh(c[(c[f >> 2] | 0) + 44 >> 2] | 0);
	                    c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                    Ph(c[h >> 2] | 0)
	                }
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)NM(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 56 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 56 >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 60 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 60 >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 52 >> 2] | 0)Lh(c[(c[f >> 2] | 0) + 52 >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 72 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 72 >> 2] | 0);
	                if (c[(c[f >> 2] | 0) + 80 >> 2] | 0)zP(c[(c[f >> 2] | 0) + 80 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function DM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                c[l >> 2] = d;
	                c[k >> 2] = RM(c[h >> 2] | 0, l) | 0;
	                if (c[(c[j >> 2] | 0) + 108 >> 2] | 0)Jb[c[(c[j >> 2] | 0) + 108 >> 2] & 511](c[(c[j >> 2] | 0) + 112 >> 2] | 0, c[k >> 2] | 0, 2, 0); else {
	                    j = c[g >> 2] | 0;
	                    c[f >> 2] = c[k >> 2];
	                    JM(j, 187728, f)
	                }
	                if (!(c[k >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                i = e;
	                return
	            }

	            function EM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = c[g >> 2];
	                c[l >> 2] = d;
	                c[k >> 2] = RM(c[h >> 2] | 0, l) | 0;
	                if (c[(c[j >> 2] | 0) + 108 >> 2] | 0)Jb[c[(c[j >> 2] | 0) + 108 >> 2] & 511](c[(c[j >> 2] | 0) + 112 >> 2] | 0, c[k >> 2] | 0, 1, 0); else {
	                    j = c[g >> 2] | 0;
	                    c[f >> 2] = c[k >> 2];
	                    KM(j, 187728, f)
	                }
	                if (!(c[k >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                i = e;
	                return
	            }

	            function FM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[e >> 2];
	                e = c[g >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 192 >> 2] | 0) {
	                    Ab[c[e + 192 >> 2] & 511](c[(c[g >> 2] | 0) + 112 >> 2] | 0, c[f >> 2] | 0);
	                    i = d;
	                    return
	                } else {
	                    LM(e, c[f >> 2] | 0);
	                    i = d;
	                    return
	                }
	            }

	            function GM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? !((c[h >> 2] | 0) == 0 & (c[j >> 2] | 0) == 0) : 0) {
	                    if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = 0;
	                    if (c[j >> 2] | 0)c[c[j >> 2] >> 2] = 0;
	                    c[k >> 2] = c[g >> 2];
	                    if ((c[(c[k >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                        if (c[h >> 2] | 0)c[c[h >> 2] >> 2] = c[(c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                        if (c[j >> 2] | 0)c[c[j >> 2] >> 2] = c[(c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    if (!(c[(c[k >> 2] | 0) + 64 >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    c[m >> 2] = 0;
	                    do if (c[j >> 2] | 0) {
	                        c[l >> 2] = Ni(c[(c[k >> 2] | 0) + 64 >> 2] | 0) | 0;
	                        if ((c[l >> 2] | 0) > 0) {
	                            c[c[j >> 2] >> 2] = c[l >> 2];
	                            break
	                        } else {
	                            c[m >> 2] = -1;
	                            break
	                        }
	                    } while (0);
	                    do if (c[h >> 2] | 0) {
	                        c[n >> 2] = c[(c[(c[k >> 2] | 0) + 64 >> 2] | 0) + 32 >> 2];
	                        if ((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 72 >> 2] | 0) != 0 : 0) {
	                            c[c[h >> 2] >> 2] = c[(c[n >> 2] | 0) + 72 >> 2];
	                            break
	                        }
	                        c[m >> 2] = -1
	                    } while (0);
	                    c[f >> 2] = c[m >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[f >> 2] = -1;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function HM(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[f + 4 >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                do if ((c[j >> 2] | 0) != 0 | (c[k >> 2] | 0) != 0) {
	                    if ((c[c[h >> 2] >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)break;
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } while (0);
	                if (c[(c[h >> 2] | 0) + 152 >> 2] | 0) {
	                    jB(c[(c[h >> 2] | 0) + 152 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 152 >> 2] = 0
	                }
	                if (c[(c[h >> 2] | 0) + 140 >> 2] | 0) {
	                    if (!(c[(c[h >> 2] | 0) + 144 >> 2] | 0))ZA(c[(c[h >> 2] | 0) + 140 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 140 >> 2] = 0
	                }
	                c[(c[h >> 2] | 0) + 144 >> 2] = 0;
	                if (c[(c[h >> 2] | 0) + 136 >> 2] | 0) {
	                    WA(c[(c[h >> 2] | 0) + 136 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 136 >> 2] = 0
	                }
	                if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (c[j >> 2] | 0) {
	                    c[l >> 2] = XA(c[j >> 2] | 0) | 0;
	                    if (c[(c[h >> 2] | 0) + 108 >> 2] | 0)aB(c[l >> 2] | 0, 367, 368, c[h >> 2] | 0);
	                    j = $A(c[l >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 136 >> 2] = j;
	                    YA(c[l >> 2] | 0);
	                    if (!(c[(c[h >> 2] | 0) + 136 >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    l = eB(c[(c[h >> 2] | 0) + 136 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 140 >> 2] = l;
	                    l = c[h >> 2] | 0;
	                    if (!(c[(c[h >> 2] | 0) + 140 >> 2] | 0)) {
	                        WA(c[l + 136 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 136 >> 2] = 0;
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    j = iB(c[l + 140 >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0, (c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 | 0) | 0;
	                    c[(c[h >> 2] | 0) + 152 >> 2] = j;
	                    if (!(c[(c[h >> 2] | 0) + 152 >> 2] | 0)) {
	                        WA(c[(c[h >> 2] | 0) + 136 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 136 >> 2] = 0;
	                        ZA(c[(c[h >> 2] | 0) + 140 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 140 >> 2] = 0;
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                } else {
	                    c[(c[h >> 2] | 0) + 140 >> 2] = c[k >> 2];
	                    c[(c[h >> 2] | 0) + 144 >> 2] = 1;
	                    k = iB(c[(c[h >> 2] | 0) + 140 >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0, (c[(c[h >> 2] | 0) + 20 >> 2] | 0) + 4 | 0) | 0;
	                    c[(c[h >> 2] | 0) + 152 >> 2] = k;
	                    if (!(c[(c[h >> 2] | 0) + 152 >> 2] | 0)) {
	                        c[(c[h >> 2] | 0) + 140 >> 2] = 0;
	                        c[(c[h >> 2] | 0) + 144 >> 2] = 0;
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                }
	                kB(c[(c[h >> 2] | 0) + 140 >> 2] | 0, 369, c[h >> 2] | 0);
	                if (c[(c[h >> 2] | 0) + 108 >> 2] | 0)bB(c[(c[h >> 2] | 0) + 140 >> 2] | 0, 367, 368, c[h >> 2] | 0);
	                if (c[(c[h >> 2] | 0) + 192 >> 2] | 0)dB(c[(c[h >> 2] | 0) + 140 >> 2] | 0, 370, c[h >> 2] | 0);
	                c[(c[h >> 2] | 0) + 148 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 8 >> 2] = 4;
	                c[g >> 2] = 0;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function IM(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[f + 4 >> 2] = e;
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if ((c[j >> 2] | 0) != 0 & (c[k >> 2] | 0) != 0) {
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                do if ((c[j >> 2] | 0) != 0 | (c[k >> 2] | 0) != 0) {
	                    if ((c[c[h >> 2] >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)break;
	                    c[g >> 2] = -1;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                } while (0);
	                if (c[(c[h >> 2] | 0) + 120 >> 2] | 0) {
	                    if (!(c[(c[h >> 2] | 0) + 124 >> 2] | 0))fN(c[(c[h >> 2] | 0) + 120 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 120 >> 2] = 0
	                }
	                c[(c[h >> 2] | 0) + 124 >> 2] = 0;
	                if (c[(c[h >> 2] | 0) + 116 >> 2] | 0) {
	                    VM(c[(c[h >> 2] | 0) + 116 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 116 >> 2] = 0
	                }
	                if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                if (c[j >> 2] | 0) {
	                    c[l >> 2] = YM(c[j >> 2] | 0) | 0;
	                    if (c[(c[h >> 2] | 0) + 108 >> 2] | 0)$M(c[l >> 2] | 0, 367, 368, c[h >> 2] | 0);
	                    if (c[(c[h >> 2] | 0) + 192 >> 2] | 0)hN(c[(c[h >> 2] | 0) + 120 >> 2] | 0, 370, c[h >> 2] | 0);
	                    j = _M(c[l >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 116 >> 2] = j;
	                    ZM(c[l >> 2] | 0);
	                    if (!(c[(c[h >> 2] | 0) + 116 >> 2] | 0)) {
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                    l = eN(c[(c[h >> 2] | 0) + 116 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 120 >> 2] = l;
	                    if (!(c[(c[h >> 2] | 0) + 120 >> 2] | 0)) {
	                        VM(c[(c[h >> 2] | 0) + 116 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 116 >> 2] = 0;
	                        c[g >> 2] = -1;
	                        m = c[g >> 2] | 0;
	                        i = f;
	                        return m | 0
	                    }
	                } else {
	                    c[(c[h >> 2] | 0) + 120 >> 2] = c[k >> 2];
	                    c[(c[h >> 2] | 0) + 124 >> 2] = 1
	                }
	                if (c[(c[h >> 2] | 0) + 108 >> 2] | 0)gN(c[(c[h >> 2] | 0) + 120 >> 2] | 0, 367, 368, c[h >> 2] | 0);
	                if (c[(c[h >> 2] | 0) + 192 >> 2] | 0)hN(c[(c[h >> 2] | 0) + 120 >> 2] | 0, 370, c[h >> 2] | 0);
	                c[(c[h >> 2] | 0) + 128 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 132 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 8 >> 2] = 2;
	                c[g >> 2] = 0;
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function JM(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 8 | 0;
	                k = f;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[k >> 2] = xy(c[h >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) <= 1) {
	                    i = f;
	                    return
	                }
	                if ((a[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 2) >> 0] | 0) == 58) {
	                    i = f;
	                    return
	                }
	                c[j >> 2] = e;
	                e = c[g >> 2] | 0;
	                SM(e, 2, RM(c[h >> 2] | 0, j) | 0);
	                i = f;
	                return
	            }

	            function KM(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 8 | 0;
	                k = f;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[k >> 2] = xy(c[h >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if ((a[(c[h >> 2] | 0) + ((c[k >> 2] | 0) - 1) >> 0] | 0) == 58) {
	                    i = f;
	                    return
	                }
	                c[j >> 2] = e;
	                e = c[g >> 2] | 0;
	                SM(e, 1, RM(c[h >> 2] | 0, j) | 0);
	                i = f;
	                return
	            }

	            function LM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[e >> 2];
	                c[h >> 2] = c[(c[g >> 2] | 0) + 272 >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[h >> 2] | 0) + 192 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Ab[c[(c[h >> 2] | 0) + 192 >> 2] & 511](c[(c[h >> 2] | 0) + 112 >> 2] | 0, c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function MM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)c[g >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2]; else c[g >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[f >> 2] | 0);
	                do if ((c[(c[f >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 32 >> 2] | 0) + 48 >> 2] | 0) == 0 : 0)break;
	                    if (Em(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 32 >> 2] | 0, c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[f >> 2] | 0) | 0)TM(c[(c[(c[f >> 2] | 0) + 20 >> 2] | 0) + 32 >> 2] | 0, c[f >> 2] | 0) | 0
	                } while (0);
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)NM(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                do if (c[(c[f >> 2] | 0) + 8 >> 2] | 0) {
	                    if ((c[g >> 2] | 0) != 0 ? (CP(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0)
	                } while (0);
	                if (((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 376 >> 2] | 0) < 100 : 0) {
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 380 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 380 >> 2] = c[f >> 2];
	                    g = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 376 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    i = d;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function NM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0 : 0)c[h >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 296 >> 2]; else c[h >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                b = c[f >> 2] | 0;
	                if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                    Lh(b);
	                    i = d;
	                    return
	                }
	                if ((c[b + 4 >> 2] | 0) != 9 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    while (1) {
	                        if (!(c[f >> 2] | 0))break;
	                        c[g >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        do if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 14) {
	                            if ((c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) {
	                                if ((c[(c[(c[f >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0) == (c[f >> 2] | 0))NM(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                                c[(c[f >> 2] | 0) + 12 >> 2] = 0
	                            }
	                            if ((c[18774] | 0) != 0 & (c[33970] | 0) != 0)zb[c[135880 >> 2] & 511](c[f >> 2] | 0);
	                            if (!(((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))j = 23;
	                            if ((j | 0) == 23 ? (j = 0, (c[(c[f >> 2] | 0) + 44 >> 2] | 0) != 0) : 0)OM(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 44 >> 2] | 0);
	                            do if ((((((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != ((c[f >> 2] | 0) + 44 | 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) {
	                                if ((c[h >> 2] | 0) != 0 ? (CP(c[h >> 2] | 0, c[(c[f >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0)break;
	                                zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 40 >> 2] | 0)
	                            } while (0);
	                            if (!(((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0))j = 37;
	                            if ((j | 0) == 37 ? (j = 0, (c[(c[f >> 2] | 0) + 48 >> 2] | 0) != 0) : 0)Lh(c[(c[f >> 2] | 0) + 48 >> 2] | 0);
	                            do if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                if ((c[h >> 2] | 0) != 0 ? (CP(c[h >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                                zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0)
	                            } while (0);
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                if (c[e >> 2] | 0)j = 48
	                            } else if ((c[e >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 3 : 0)j = 48;
	                            if (((j | 0) == 48 ? (j = 0, (c[(c[e >> 2] | 0) + 20 >> 2] | 0) != 0) : 0) ? (c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 368 >> 2] | 0) < 100 : 0) {
	                                c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 372 >> 2];
	                                c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 372 >> 2] = c[f >> 2];
	                                b = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) + 368 | 0;
	                                c[b >> 2] = (c[b >> 2] | 0) + 1;
	                                break
	                            }
	                            zb[c[135736 >> 2] & 511](c[f >> 2] | 0)
	                        } while (0);
	                        c[f >> 2] = c[g >> 2]
	                    }
	                    i = d;
	                    return
	                }
	                Th(c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function OM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    c[g >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                    MM(c[e >> 2] | 0, c[f >> 2] | 0);
	                    c[f >> 2] = c[g >> 2]
	                }
	                i = d;
	                return
	            }

	            function PM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    if (c[(c[e >> 2] | 0) + 24 >> 2] | 0) {
	                        c[d >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                        break
	                    }
	                    while (1) {
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        if (!(c[e >> 2] | 0)) {
	                            f = 9;
	                            break
	                        }
	                        g = c[e >> 2] | 0;
	                        if (c[(c[e >> 2] | 0) + 24 >> 2] | 0) {
	                            f = 7;
	                            break
	                        }
	                        if (!g) {
	                            f = 9;
	                            break
	                        }
	                    }
	                    if ((f | 0) == 7) {
	                        c[d >> 2] = c[g + 24 >> 2];
	                        break
	                    } else if ((f | 0) == 9) {
	                        c[d >> 2] = c[e >> 2];
	                        break
	                    }
	                } else c[d >> 2] = 0; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function QM(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                Kj(c[d >> 2] | 0, 371);
	                i = b;
	                return
	            }

	            function RM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d;
	                f = d + 48 | 0;
	                g = d + 44 | 0;
	                h = d + 40 | 0;
	                j = d + 36 | 0;
	                k = d + 32 | 0;
	                l = d + 28 | 0;
	                m = d + 24 | 0;
	                n = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[m >> 2] = 0;
	                while (1) {
	                    c[n >> 2] = c[c[h >> 2] >> 2];
	                    c[k >> 2] = LT(c[m >> 2] | 0, c[j >> 2] | 0, c[g >> 2] | 0, n) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        o = 3;
	                        break
	                    }
	                    if ((c[j >> 2] | 0) == 64e3 ? 1 : (c[k >> 2] | 0) < (c[j >> 2] | 0)) {
	                        o = 15;
	                        break
	                    }
	                    if ((c[k >> 2] | 0) < 64e3)c[j >> 2] = (c[k >> 2] | 0) + 1; else c[j >> 2] = 64e3;
	                    b = Hb[c[135760 >> 2] & 511](c[m >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[l >> 2] = b;
	                    if (!b) {
	                        o = 11;
	                        break
	                    }
	                    c[m >> 2] = c[l >> 2]
	                }
	                if ((o | 0) == 3) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187704, e);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((o | 0) == 11) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187672, e);
	                    if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                } else if ((o | 0) == 15) {
	                    c[f >> 2] = c[m >> 2];
	                    p = c[f >> 2] | 0;
	                    i = d;
	                    return p | 0
	                }
	                return 0
	            }

	            function SM(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                c[k >> 2] = c[(c[j >> 2] | 0) + 272 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (c[(c[k >> 2] | 0) + 108 >> 2] | 0)Jb[c[(c[k >> 2] | 0) + 108 >> 2] & 511](c[(c[k >> 2] | 0) + 112 >> 2] | 0, c[h >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function TM(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (!(c[f >> 2] | 0))c[e >> 2] = -1; else {
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 64 >> 2];
	                    if (!(c[h >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    c[k >> 2] = _h(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                    c[j >> 2] = Rj(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == (c[g >> 2] | 0) : 0) {
	                        c[(c[j >> 2] | 0) + 12 >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                        c[(c[j >> 2] | 0) + 8 >> 2] = 0;
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    c[e >> 2] = -1
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function UM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)c[e >> 2] = c[(c[(c[d >> 2] | 0) + 20 >> 2] | 0) + 80 >> 2];
	                do if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                    if ((c[e >> 2] | 0) != 0 ? (CP(c[e >> 2] | 0, c[(c[d >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0)
	                } while (0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function VM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)jN(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)kN(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)lN(c[(c[d >> 2] | 0) + 28 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 36 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 32 >> 2] | 0))break;
	                        mN(c[(c[(c[d >> 2] | 0) + 36 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 36 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function WM() {
	                var a = 0, b = 0, d = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                if (c[46940] | 0) {
	                    c[b >> 2] = 0;
	                    d = c[b >> 2] | 0;
	                    i = a;
	                    return d | 0
	                }
	                c[46942] = Ij(10) | 0;
	                if (!(c[46942] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 187776, a);
	                    c[b >> 2] = -1;
	                    d = c[b >> 2] | 0;
	                    i = a;
	                    return d | 0
	                } else {
	                    sN(187824, 0, 372, 373, 374, 375, 376) | 0;
	                    sN(c[46968] | 0, 0, 377, 378, 379, 0, 0) | 0;
	                    c[46940] = 1;
	                    c[b >> 2] = 0;
	                    d = c[b >> 2] | 0;
	                    i = a;
	                    return d | 0
	                }
	                return 0
	            }

	            function XM() {
	                var a = 0;
	                a = i;
	                GH();
	                if (!(c[46940] | 0)) {
	                    i = a;
	                    return
	                }
	                Kj(c[46942] | 0, 380);
	                c[46940] = 0;
	                i = a;
	                return
	            }

	            function YM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](148) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xN(0, 187880);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    cU(c[f >> 2] | 0, 0, 148) | 0;
	                    a = my(c[e >> 2] | 0) | 0;
	                    c[(c[f >> 2] | 0) + 68 >> 2] = a;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[33976];
	                    c[c[f >> 2] >> 2] = c[33980];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function ZM(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 68 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 68 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 96 >> 2] | 0)yN(c[(c[d >> 2] | 0) + 96 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 56 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 56 >> 2] | 0, 0);
	                if (c[(c[d >> 2] | 0) + 60 >> 2] | 0)kN(c[(c[d >> 2] | 0) + 60 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)lN(c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 108 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 108 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 124 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 124 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 84 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 76 >> 2] | 0))break;
	                        mN(c[(c[(c[d >> 2] | 0) + 84 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 84 >> 2] | 0)
	                }
	                if ((c[(c[d >> 2] | 0) + 72 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 144 >> 2] | 0) != 0 : 0)Th(c[(c[d >> 2] | 0) + 72 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function _M(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                WM() | 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                a = c[e >> 2] | 0;
	                do if (c[(c[e >> 2] | 0) + 68 >> 2] | 0) {
	                    c[g >> 2] = gg(c[a + 68 >> 2] | 0, 0, 0) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        zN(c[e >> 2] | 0, 0, 1065, 187904, c[(c[e >> 2] | 0) + 68 >> 2] | 0, 0);
	                        c[d >> 2] = 0;
	                        k = c[d >> 2] | 0;
	                        i = b;
	                        return k | 0
	                    }
	                } else {
	                    l = c[e >> 2] | 0;
	                    if (c[a + 88 >> 2] | 0) {
	                        c[g >> 2] = hg(c[l + 88 >> 2] | 0, c[(c[e >> 2] | 0) + 92 >> 2] | 0, 0, 0, 0) | 0;
	                        if (c[g >> 2] | 0) {
	                            m = my(187992) | 0;
	                            c[(c[g >> 2] | 0) + 72 >> 2] = m;
	                            m = my(187992) | 0;
	                            c[(c[e >> 2] | 0) + 68 >> 2] = m;
	                            break
	                        }
	                        zN(c[e >> 2] | 0, 0, 1065, 187944, 0, 0);
	                        c[d >> 2] = 0;
	                        k = c[d >> 2] | 0;
	                        i = b;
	                        return k | 0
	                    } else {
	                        m = c[e >> 2] | 0;
	                        if (c[l + 72 >> 2] | 0) {
	                            c[g >> 2] = c[m + 72 >> 2];
	                            break
	                        }
	                        zN(m, 0, 1022, 188016, 0, 0);
	                        c[d >> 2] = 0;
	                        k = c[d >> 2] | 0;
	                        i = b;
	                        return k | 0
	                    }
	                } while (0);
	                c[(c[e >> 2] | 0) + 72 >> 2] = c[g >> 2];
	                c[g >> 2] = AN(c[e >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[g >> 2] | 0)) {
	                    Th(c[(c[e >> 2] | 0) + 72 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 72 >> 2] = 0;
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[h >> 2] = Pi(c[g >> 2] | 0) | 0;
	                a = c[e >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    if (c[(c[e >> 2] | 0) + 68 >> 2] | 0)n = c[(c[e >> 2] | 0) + 68 >> 2] | 0; else n = 188088;
	                    zN(a, c[g >> 2] | 0, 1022, 188056, n, 0);
	                    Th(c[(c[e >> 2] | 0) + 72 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 72 >> 2] = 0;
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[f >> 2] = BN(a, c[h >> 2] | 0) | 0;
	                h = c[e >> 2] | 0;
	                if (!(c[f >> 2] | 0)) {
	                    Th(c[h + 72 >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 72 >> 2] = 0;
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                if (c[h + 56 >> 2] | 0)Wj(c[(c[e >> 2] | 0) + 56 >> 2] | 0, 381, c[e >> 2] | 0);
	                h = c[f >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 36 >> 2] | 0) > 0) {
	                    VM(h);
	                    c[(c[e >> 2] | 0) + 72 >> 2] = 0;
	                    Th(c[g >> 2] | 0);
	                    c[d >> 2] = 0;
	                    k = c[d >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                if ((c[h + 4 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    if ((c[c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] >> 2] | 0) != 20 ? (c[j >> 2] = DN(c[e >> 2] | 0, 0) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                        c[c[j >> 2] >> 2] = 20;
	                        c[(c[j >> 2] | 0) + 24 >> 2] = c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2];
	                        c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] = c[j >> 2]
	                    }
	                    EN(c[e >> 2] | 0, c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0) | 0
	                }
	                c[(c[f >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                c[(c[e >> 2] | 0) + 72 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 60 >> 2];
	                c[(c[e >> 2] | 0) + 60 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 28 >> 2] = c[(c[e >> 2] | 0) + 64 >> 2];
	                c[(c[e >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 32 >> 2] = c[(c[e >> 2] | 0) + 76 >> 2];
	                c[(c[f >> 2] | 0) + 36 >> 2] = c[(c[e >> 2] | 0) + 84 >> 2];
	                c[(c[e >> 2] | 0) + 84 >> 2] = 0;
	                if ((c[(c[e >> 2] | 0) + 128 >> 2] | 0) == 1)c[(c[f >> 2] | 0) + 12 >> 2] = 1;
	                c[d >> 2] = c[f >> 2];
	                k = c[d >> 2] | 0;
	                i = b;
	                return k | 0
	            }

	            function $M(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                c[c[g >> 2] >> 2] = c[k >> 2];
	                i = f;
	                return
	            }

	            function aN(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[e + 24 >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 1;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                do if (!(c[(c[g >> 2] | 0) + 84 >> 2] | 0)) {
	                    c[k >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                    if (!(c[k >> 2] | 0)) {
	                        FN(c[g >> 2] | 0, 34, 0, 0, 0);
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    c[l >> 2] = c[(c[k >> 2] | 0) + 4 >> 2];
	                    if ((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                        c[n >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                        d = c[n >> 2] | 0;
	                        if (!(c[(c[n >> 2] | 0) + 52 >> 2] | 0)) {
	                            c[(c[g >> 2] | 0) + 108 >> 2] = d;
	                            c[f >> 2] = 0;
	                            o = c[f >> 2] | 0;
	                            i = e;
	                            return o | 0
	                        }
	                        c[m >> 2] = oz(c[d + 52 >> 2] | 0, 382, c[g >> 2] | 0) | 0;
	                        if (c[m >> 2] | 0) {
	                            HN(c[g >> 2] | 0, c[m >> 2] | 0) | 0;
	                            break
	                        }
	                        c[f >> 2] = -1;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    FN(c[g >> 2] | 0, 34, 0, 0, 0);
	                    c[f >> 2] = -1;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                } while (0);
	                c[(c[g >> 2] | 0) + 104 >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 100 >> 2] = 0;
	                m = c[(c[g >> 2] | 0) + 84 >> 2] | 0;
	                n = c[(c[h >> 2] | 0) + 8 >> 2] | 0;
	                if (c[(c[h >> 2] | 0) + 36 >> 2] | 0)c[j >> 2] = rz(m, n, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0; else c[j >> 2] = qz(m, n, c[g >> 2] | 0) | 0;
	                n = c[g >> 2] | 0;
	                do if ((c[j >> 2] | 0) >= 0) {
	                    if (!(c[n + 100 >> 2] | 0)) {
	                        c[j >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 100 >> 2] | 0) < 0) {
	                        c[j >> 2] = -1;
	                        break
	                    } else {
	                        c[j >> 2] = 1;
	                        break
	                    }
	                } else FN(n, 38, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0, 0); while (0);
	                c[f >> 2] = c[j >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function bN(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[f + 4 >> 2] = e;
	                c[k >> 2] = 1;
	                if ((c[h >> 2] | 0) != 0 ? !((c[j >> 2] | 0) == 0 ? 1 : (c[(c[h >> 2] | 0) + 84 >> 2] | 0) == 0) : 0) {
	                    a:while (1) {
	                        if (!(d[c[j >> 2] >> 0] | 0))break;
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                        } while (0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    if (!(d[c[j >> 2] >> 0] | 0)) {
	                        c[g >> 2] = 1;
	                        l = c[g >> 2] | 0;
	                        i = f;
	                        return l | 0
	                    }
	                    c[k >> 2] = qz(c[(c[h >> 2] | 0) + 84 >> 2] | 0, 188096, c[h >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        FN(c[h >> 2] | 0, 39, 188104, 0, 0);
	                        c[g >> 2] = -1;
	                        l = c[g >> 2] | 0;
	                        i = f;
	                        return l | 0
	                    } else {
	                        c[g >> 2] = 1;
	                        l = c[g >> 2] | 0;
	                        i = f;
	                        return l | 0
	                    }
	                }
	                c[g >> 2] = -1;
	                l = c[g >> 2] | 0;
	                i = f;
	                return l | 0
	            }

	            function cN(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[e + 12 >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? !((c[h >> 2] | 0) == 0 ? 1 : (c[(c[g >> 2] | 0) + 84 >> 2] | 0) == 0) : 0) {
	                    c[k >> 2] = IN(c[g >> 2] | 0) | 0;
	                    c[j >> 2] = qz(c[k >> 2] | 0, 0, 0) | 0;
	                    do if (c[j >> 2] | 0)if ((c[j >> 2] | 0) < 0) {
	                        c[j >> 2] = -1;
	                        break
	                    } else {
	                        c[j >> 2] = 1;
	                        break
	                    } else {
	                        FN(c[g >> 2] | 0, 22, 188112, 0, 0);
	                        c[j >> 2] = -1
	                    } while (0);
	                    pz(c[k >> 2] | 0);
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = -1;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function dN(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[e + 12 >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) != 0 ? !((c[h >> 2] | 0) == 0 ? 1 : (c[(c[g >> 2] | 0) + 108 >> 2] | 0) == 0) : 0) {
	                    c[k >> 2] = JN(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                    c[(c[k >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    c[(c[g >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                    c[(c[g >> 2] | 0) + 40 >> 2] = 0;
	                    c[j >> 2] = KN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 108 >> 2] | 0) | 0;
	                    if ((c[j >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 40 >> 2] | 0) == 0 : 0)c[j >> 2] = 1; else c[j >> 2] = -1;
	                    LN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                c[f >> 2] = -1;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function eN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](116) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    MN(0, 188120);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 116 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[(c[f >> 2] | 0) + 20 >> 2] = c[e >> 2];
	                c[(c[f >> 2] | 0) + 4 >> 2] = c[33976];
	                c[c[f >> 2] >> 2] = c[33980];
	                c[(c[f >> 2] | 0) + 48 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 52 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 56 >> 2] = 0;
	                if (c[e >> 2] | 0)c[(c[f >> 2] | 0) + 36 >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 68 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 80 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 40 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function fN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 64 >> 2] | 0)NN(0, c[(c[d >> 2] | 0) + 64 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 68 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[c[(c[d >> 2] | 0) + 68 >> 2] >> 2] | 0))break;
	                        LN(0, c[(c[(c[(c[d >> 2] | 0) + 68 >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    NN(0, c[(c[d >> 2] | 0) + 68 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 80 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 72 >> 2] | 0))break;
	                        NN(0, c[(c[(c[d >> 2] | 0) + 80 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 80 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 56 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 56 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 96 >> 2] | 0) {
	                    c[f >> 2] = IN(c[d >> 2] | 0) | 0;
	                    while (1) {
	                        if (!(c[f >> 2] | 0))break;
	                        pz(c[f >> 2] | 0);
	                        c[f >> 2] = IN(c[d >> 2] | 0) | 0
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 96 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function gN(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[(c[g >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                c[(c[g >> 2] | 0) + 8 >> 2] = c[j >> 2];
	                c[c[g >> 2] >> 2] = c[k >> 2];
	                c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                i = f;
	                return
	            }

	            function hN(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 12 >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                c[c[f >> 2] >> 2] = c[h >> 2];
	                i = e;
	                return
	            }

	            function iN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[g >> 2];
	                c[h >> 2] = ON(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                PN(c[g >> 2] | 0);
	                if ((c[h >> 2] | 0) == -1) {
	                    c[e >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function jN(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)jN(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)jN(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 28 >> 2] | 0, 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 24 >> 2] | 0, 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function kN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    yN(c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function lN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    QN(c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function mN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((((c[c[d >> 2] >> 2] | 0) == 7 ? (c[(c[d >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[e >> 2] = c[(c[d >> 2] | 0) + 20 >> 2], (c[e >> 2] | 0) != 0) : 0) ? (c[(c[e >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)Ab[c[(c[e >> 2] | 0) + 24 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0, c[(c[d >> 2] | 0) + 36 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[c[d >> 2] >> 2] | 0) == 19 : 0)RN(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                if ((c[(c[d >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[c[d >> 2] >> 2] | 0) == 17 : 0)Kj(c[(c[d >> 2] | 0) + 20 >> 2] | 0, 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)zz(c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function nN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[d + 8 >> 2] = a;
	                c[f >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    c[g >> 2] = QH(c[f >> 2] | 0, 196728) | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    } else {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function oN(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[g + 24 >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                do if (!((c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0)) {
	                    c[n >> 2] = QH(c[j >> 2] | 0, 196728) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[h >> 2] = -1;
	                        break
	                    }
	                    c[o >> 2] = TH(c[n >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    if ((c[o >> 2] | 0) == 2) {
	                        c[h >> 2] = 2;
	                        break
	                    }
	                    if (!(c[o >> 2] | 0)) {
	                        c[h >> 2] = 1;
	                        break
	                    }
	                    if ((c[o >> 2] | 0) > 0) {
	                        c[h >> 2] = 0;
	                        break
	                    } else {
	                        c[h >> 2] = -1;
	                        break
	                    }
	                } else c[h >> 2] = -1; while (0);
	                i = g;
	                return c[h >> 2] | 0
	            }

	            function pN(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 44 | 0;
	                l = j + 36 | 0;
	                m = j + 32 | 0;
	                n = j + 28 | 0;
	                o = j + 24 | 0;
	                p = j + 20 | 0;
	                q = j + 16 | 0;
	                r = j + 12 | 0;
	                s = j + 8 | 0;
	                t = j + 4 | 0;
	                u = j;
	                c[j + 40 >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                if ((c[l >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[s >> 2] = QH(c[l >> 2] | 0, 196728) | 0;
	                if (!(c[s >> 2] | 0)) {
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                if (!(c[o >> 2] | 0)) {
	                    c[r >> 2] = TH(c[s >> 2] | 0, c[m >> 2] | 0, t, c[n >> 2] | 0) | 0;
	                    if (c[r >> 2] | 0) {
	                        c[k >> 2] = -1;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    }
	                    if (!(c[t >> 2] | 0)) {
	                        c[k >> 2] = -1;
	                        v = c[k >> 2] | 0;
	                        i = j;
	                        return v | 0
	                    }
	                } else c[t >> 2] = c[o >> 2];
	                c[r >> 2] = TH(c[s >> 2] | 0, c[p >> 2] | 0, u, c[q >> 2] | 0) | 0;
	                q = c[t >> 2] | 0;
	                if (c[r >> 2] | 0) {
	                    if ((q | 0) != (c[o >> 2] | 0))PH(c[t >> 2] | 0);
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[r >> 2] = XH(q, c[u >> 2] | 0) | 0;
	                if ((c[t >> 2] | 0) != (c[o >> 2] | 0))PH(c[t >> 2] | 0);
	                PH(c[u >> 2] | 0);
	                if ((c[r >> 2] | 0) == -2) {
	                    c[k >> 2] = -1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                if (!(c[r >> 2] | 0)) {
	                    c[k >> 2] = 1;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                } else {
	                    c[k >> 2] = 0;
	                    v = c[k >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                return 0
	            }

	            function qN(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 28 | 0;
	                l = h + 24 | 0;
	                m = h + 20 | 0;
	                n = h + 16 | 0;
	                o = h + 12 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[h + 32 >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                if ((c[k >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[q >> 2] = QH(c[k >> 2] | 0, 196728) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[p >> 2] = SA() | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                do if (qy(c[l >> 2] | 0, 196768) | 0)c[c[p >> 2] >> 2] = 1e3; else {
	                    if (qy(c[l >> 2] | 0, 196784) | 0) {
	                        c[c[p >> 2] >> 2] = 1001;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196800) | 0) {
	                        c[c[p >> 2] >> 2] = 1002;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196816) | 0) {
	                        c[c[p >> 2] >> 2] = 1003;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196832) | 0) {
	                        c[c[p >> 2] >> 2] = 1004;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196848) | 0) {
	                        c[c[p >> 2] >> 2] = 1005;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196864) | 0) {
	                        c[c[p >> 2] >> 2] = 1006;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196872) | 0) {
	                        c[c[p >> 2] >> 2] = 1007;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196888) | 0) {
	                        c[c[p >> 2] >> 2] = 1008;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196904) | 0) {
	                        c[c[p >> 2] >> 2] = 1009;
	                        break
	                    }
	                    if (qy(c[l >> 2] | 0, 196912) | 0) {
	                        c[c[p >> 2] >> 2] = 1010;
	                        break
	                    }
	                    g = (qy(c[l >> 2] | 0, 196928) | 0) != 0;
	                    f = c[p >> 2] | 0;
	                    if (g) {
	                        c[f >> 2] = 1011;
	                        break
	                    }
	                    UA(f);
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } while (0);
	                c[(c[p >> 2] | 0) + 8 >> 2] = c[m >> 2];
	                c[r >> 2] = _A(c[p >> 2] | 0, c[q >> 2] | 0, 0, c[k >> 2] | 0) | 0;
	                if (c[r >> 2] | 0) {
	                    UA(c[p >> 2] | 0);
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                c[r >> 2] = $H(c[q >> 2] | 0, c[p >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                UA(c[p >> 2] | 0);
	                if (c[r >> 2] | 0) {
	                    c[j >> 2] = -1;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                } else {
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                return 0
	            }

	            function rN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d;
	                c[d + 4 >> 2] = a;
	                c[e >> 2] = b;
	                PH(c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function sN(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j;
	                l = j + 40 | 0;
	                m = j + 36 | 0;
	                n = j + 32 | 0;
	                o = j + 28 | 0;
	                p = j + 24 | 0;
	                q = j + 20 | 0;
	                r = j + 16 | 0;
	                s = j + 12 | 0;
	                t = j + 8 | 0;
	                u = j + 4 | 0;
	                c[m >> 2] = a;
	                c[n >> 2] = b;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                if ((c[46942] | 0) == 0 | (c[m >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0 | (c[q >> 2] | 0) == 0) {
	                    c[l >> 2] = -1;
	                    v = c[l >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                if (Rj(c[46942] | 0, c[m >> 2] | 0) | 0) {
	                    h = c[33976] | 0;
	                    g = c[33980] | 0;
	                    c[k >> 2] = c[m >> 2];
	                    Db[h & 511](g, 196944, k);
	                    c[l >> 2] = -1;
	                    v = c[l >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                c[t >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[t >> 2] | 0)) {
	                    MN(0, 196992);
	                    c[l >> 2] = -1;
	                    v = c[l >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                g = c[t >> 2] | 0;
	                c[g + 0 >> 2] = 0;
	                c[g + 4 >> 2] = 0;
	                c[g + 8 >> 2] = 0;
	                c[g + 12 >> 2] = 0;
	                c[g + 16 >> 2] = 0;
	                c[g + 20 >> 2] = 0;
	                c[g + 24 >> 2] = 0;
	                g = my(c[m >> 2] | 0) | 0;
	                c[c[t >> 2] >> 2] = g;
	                c[(c[t >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                c[(c[t >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                c[(c[t >> 2] | 0) + 16 >> 2] = c[q >> 2];
	                c[(c[t >> 2] | 0) + 12 >> 2] = c[p >> 2];
	                c[(c[t >> 2] | 0) + 20 >> 2] = c[r >> 2];
	                c[(c[t >> 2] | 0) + 24 >> 2] = c[s >> 2];
	                c[u >> 2] = Lj(c[46942] | 0, c[m >> 2] | 0, c[t >> 2] | 0) | 0;
	                if ((c[u >> 2] | 0) < 0) {
	                    u = c[33976] | 0;
	                    s = c[33980] | 0;
	                    c[k >> 2] = c[m >> 2];
	                    Db[u & 511](s, 197016, k);
	                    wN(c[t >> 2] | 0, c[m >> 2] | 0);
	                    c[l >> 2] = -1;
	                    v = c[l >> 2] | 0;
	                    i = j;
	                    return v | 0
	                } else {
	                    c[l >> 2] = 0;
	                    v = c[l >> 2] | 0;
	                    i = j;
	                    return v | 0
	                }
	                return 0
	            }

	            function tN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d;
	                c[d + 4 >> 2] = a;
	                c[f >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    if (qy(c[f >> 2] | 0, 196712) | 0) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[f >> 2] | 0, 196720) | 0) {
	                        c[e >> 2] = 1;
	                        break
	                    } else {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function uN(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 20 | 0;
	                j = g + 12 | 0;
	                k = g + 8 | 0;
	                c[g + 16 >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[g + 4 >> 2] = e;
	                c[g >> 2] = f;
	                do if (c[k >> 2] | 0) {
	                    if (qy(c[j >> 2] | 0, 196712) | 0) {
	                        c[h >> 2] = 1;
	                        break
	                    }
	                    if (qy(c[j >> 2] | 0, 196720) | 0) {
	                        c[h >> 2] = 1;
	                        break
	                    } else {
	                        c[h >> 2] = 0;
	                        break
	                    }
	                } else c[h >> 2] = -1; while (0);
	                i = g;
	                return c[h >> 2] | 0
	            }

	            function vN(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 32 | 0;
	                l = j + 28 | 0;
	                m = j + 16 | 0;
	                n = j + 8 | 0;
	                o = j + 4 | 0;
	                p = j;
	                c[j + 36 >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[j + 24 >> 2] = e;
	                c[j + 20 >> 2] = f;
	                c[m >> 2] = g;
	                c[j + 12 >> 2] = h;
	                c[n >> 2] = -1;
	                if (qy(c[k >> 2] | 0, 196712) | 0) {
	                    c[n >> 2] = qy(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    q = c[n >> 2] | 0;
	                    i = j;
	                    return q | 0
	                }
	                if (!(qy(c[k >> 2] | 0, 196720) | 0)) {
	                    q = c[n >> 2] | 0;
	                    i = j;
	                    return q | 0
	                }
	                if (qy(c[l >> 2] | 0, c[m >> 2] | 0) | 0) {
	                    c[n >> 2] = 1;
	                    q = c[n >> 2] | 0;
	                    i = j;
	                    return q | 0
	                }
	                c[o >> 2] = SN(0, c[l >> 2] | 0) | 0;
	                c[p >> 2] = SN(0, c[m >> 2] | 0) | 0;
	                do if (!((c[o >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0))if (qy(c[o >> 2] | 0, c[p >> 2] | 0) | 0) {
	                    c[n >> 2] = 1;
	                    break
	                } else {
	                    c[n >> 2] = 0;
	                    break
	                } else c[n >> 2] = -1; while (0);
	                if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                if (!(c[p >> 2] | 0)) {
	                    q = c[n >> 2] | 0;
	                    i = j;
	                    return q | 0
	                }
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                q = c[n >> 2] | 0;
	                i = j;
	                return q | 0
	            }

	            function wN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                c[e >> 2] = a;
	                c[d >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (c[c[e >> 2] >> 2] | 0)zb[c[135736 >> 2] & 511](c[c[e >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function xN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (c[f >> 2] | 0) {
	                    b = c[f >> 2] | 0;
	                    if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)c[h >> 2] = c[b + 12 >> 2]; else c[j >> 2] = c[b + 4 >> 2];
	                    c[k >> 2] = c[c[f >> 2] >> 2];
	                    b = (c[f >> 2] | 0) + 36 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                b = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                if (c[g >> 2] | 0) {
	                    k = c[g >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Xd(b, h, j, 0, 0, 18, 2, 3, 0, 0, k, 0, 0, 0, 0, 189400, e);
	                    i = d;
	                    return
	                } else {
	                    Xd(b, h, j, 0, 0, 18, 2, 3, 0, 0, 0, 0, 0, 0, 0, 189432, e);
	                    i = d;
	                    return
	                }
	            }

	            function yN(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)TN(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function zN(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                if (c[k >> 2] | 0) {
	                    g = c[k >> 2] | 0;
	                    if (c[(c[k >> 2] | 0) + 12 >> 2] | 0)c[q >> 2] = c[g + 12 >> 2]; else c[r >> 2] = c[g + 4 >> 2];
	                    c[s >> 2] = c[c[k >> 2] >> 2];
	                    g = (c[k >> 2] | 0) + 36 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                g = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                r = c[s >> 2] | 0;
	                s = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                k = c[p >> 2] | 0;
	                f = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                c[j >> 2] = c[o >> 2];
	                c[j + 4 >> 2] = n;
	                Xd(g, q, r, 0, s, 18, l, 2, 0, 0, m, k, 0, 0, 0, f, j);
	                i = h;
	                return
	            }

	            function AN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Pi(c[g >> 2] | 0) | 0;
	                b = c[f >> 2] | 0;
	                if (!(c[h >> 2] | 0)) {
	                    zN(b, c[g >> 2] | 0, 1022, 188056, c[(c[f >> 2] | 0) + 68 >> 2] | 0, 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    UN(b, c[h >> 2] | 0);
	                    c[e >> 2] = c[g >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function BN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[h >> 2] = VN(c[f >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[j >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190264) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                    b = WN(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 4 >> 2] = b;
	                    if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        VM(c[h >> 2] | 0);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                } else {
	                    b = XN(c[f >> 2] | 0) | 0;
	                    c[m >> 2] = b;
	                    c[(c[h >> 2] | 0) + 4 >> 2] = b;
	                    if (!(c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        VM(c[h >> 2] | 0);
	                        c[e >> 2] = 0;
	                        n = c[e >> 2] | 0;
	                        i = d;
	                        return n | 0
	                    }
	                    c[c[m >> 2] >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                    do if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                        c[l >> 2] = c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2];
	                        if (!(c[l >> 2] | 0)) {
	                            c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] = c[m >> 2];
	                            break
	                        }
	                        while (1) {
	                            if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0))break;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 8 >> 2]
	                        }
	                        c[(c[l >> 2] | 0) + 8 >> 2] = c[m >> 2]
	                    } while (0);
	                    c[k >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                    c[(c[f >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                    YN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (c[k >> 2] | 0)c[(c[f >> 2] | 0) + 24 >> 2] = c[k >> 2]
	                }
	                c[(c[f >> 2] | 0) + 44 >> 2] = c[j >> 2];
	                if ((c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0) != 0 ? (ZN(c[f >> 2] | 0, c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0, 0) | 0, (c[(c[f >> 2] | 0) + 32 >> 2] & 128 | 0) == 0) : 0) {
	                    _N(c[f >> 2] | 0, c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0, 0);
	                    while (1) {
	                        if (!(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0))break;
	                        if ((c[c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] >> 2] | 0) != -1)break;
	                        if (!(c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0) + 32 >> 2] | 0))break;
	                        c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] = c[(c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2]
	                    }
	                    $N(c[f >> 2] | 0, c[(c[(c[h >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] | 0, 16, -1) | 0
	                }
	                c[e >> 2] = c[h >> 2];
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function CN(a, e, f) {
	                a = a | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 60 | 0;
	                j = g + 56 | 0;
	                k = g + 48 | 0;
	                l = g + 44 | 0;
	                m = g + 40 | 0;
	                n = g + 36 | 0;
	                o = g + 32 | 0;
	                p = g + 28 | 0;
	                q = g + 24 | 0;
	                r = g + 20 | 0;
	                s = g + 16 | 0;
	                t = g + 12 | 0;
	                u = g + 8 | 0;
	                v = g + 4 | 0;
	                w = g;
	                c[h >> 2] = a;
	                c[j >> 2] = e;
	                c[g + 52 >> 2] = f;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[v >> 2] = 0;
	                c[w >> 2] = 1;
	                if (c[(c[j >> 2] | 0) + 36 >> 2] | 0) {
	                    i = g;
	                    return
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    c[u >> 2] = (c[u >> 2] | 0) + 1;
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                }
	                c[n >> 2] = Cb[c[135744 >> 2] & 511](c[u >> 2] << 2) | 0;
	                a:do if (c[n >> 2] | 0) {
	                    c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        x = c[33936] | 0;
	                        if (!(c[k >> 2] | 0))break;
	                        u = Cb[x & 511](12) | 0;
	                        c[(c[n >> 2] | 0) + (c[t >> 2] << 2) >> 2] = u;
	                        if (!(c[(c[n >> 2] | 0) + (c[t >> 2] << 2) >> 2] | 0))break a;
	                        if ((c[c[k >> 2] >> 2] | 0) == 3)c[v >> 2] = (c[v >> 2] | 0) + 1;
	                        c[c[(c[n >> 2] | 0) + (c[t >> 2] << 2) >> 2] >> 2] = c[k >> 2];
	                        u = aO(c[j >> 2] | 0, c[k >> 2] | 0, 0) | 0;
	                        c[(c[(c[n >> 2] | 0) + (c[t >> 2] << 2) >> 2] | 0) + 4 >> 2] = u;
	                        u = aO(c[j >> 2] | 0, c[k >> 2] | 0, 1) | 0;
	                        c[(c[(c[n >> 2] | 0) + (c[t >> 2] << 2) >> 2] | 0) + 8 >> 2] = u;
	                        c[t >> 2] = (c[t >> 2] | 0) + 1;
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                    }
	                    c[m >> 2] = Cb[x & 511](16) | 0;
	                    if (c[m >> 2] | 0) {
	                        u = c[m >> 2] | 0;
	                        c[u + 0 >> 2] = 0;
	                        c[u + 4 >> 2] = 0;
	                        c[u + 8 >> 2] = 0;
	                        c[u + 12 >> 2] = 0;
	                        c[c[m >> 2] >> 2] = c[t >> 2];
	                        u = Ij(c[t >> 2] | 0) | 0;
	                        c[(c[m >> 2] | 0) + 4 >> 2] = u;
	                        c[p >> 2] = 0;
	                        while (1) {
	                            if ((c[p >> 2] | 0) >= (c[t >> 2] | 0))break;
	                            c[o >> 2] = c[(c[n >> 2] | 0) + (c[p >> 2] << 2) >> 2];
	                            c[q >> 2] = (c[p >> 2] | 0) + 1;
	                            while (1) {
	                                if ((c[q >> 2] | 0) >= (c[t >> 2] | 0))break;
	                                if (c[(c[n >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) {
	                                    c[r >> 2] = bO(c[j >> 2] | 0, c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[n >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0) | 0;
	                                    if (!(c[r >> 2] | 0))zN(c[j >> 2] | 0, c[(c[h >> 2] | 0) + 4 >> 2] | 0, 1021, 190104, 0, 0);
	                                    c[r >> 2] = bO(c[j >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[n >> 2] | 0) + (c[q >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                    if (!(c[r >> 2] | 0))zN(c[j >> 2] | 0, c[(c[h >> 2] | 0) + 4 >> 2] | 0, 1001, 190152, 0, 0)
	                                }
	                                c[q >> 2] = (c[q >> 2] | 0) + 1
	                            }
	                            c[l >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                            b:do if ((c[l >> 2] | 0) != 0 ? (c[c[l >> 2] >> 2] | 0) != 0 : 0)while (1) {
	                                if (!(c[c[l >> 2] >> 2] | 0))break b;
	                                do if ((c[c[c[l >> 2] >> 2] >> 2] | 0) == 3) {
	                                    c[s >> 2] = Nj(c[(c[m >> 2] | 0) + 4 >> 2] | 0, 188096, 0, (c[p >> 2] | 0) + 1 | 0) | 0;
	                                    if (c[s >> 2] | 0)c[w >> 2] = -1
	                                } else {
	                                    if ((c[c[c[l >> 2] >> 2] >> 2] | 0) == 4 ? (c[(c[c[l >> 2] >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                        if ((c[(c[c[l >> 2] >> 2] | 0) + 12 >> 2] | 0) != 0 ? (d[c[(c[c[l >> 2] >> 2] | 0) + 12 >> 2] >> 0] | 0) != 0 : 0)c[s >> 2] = Nj(c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[(c[c[l >> 2] >> 2] | 0) + 8 >> 2] | 0, c[(c[c[l >> 2] >> 2] | 0) + 12 >> 2] | 0, (c[p >> 2] | 0) + 1 | 0) | 0; else c[s >> 2] = Nj(c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[(c[c[l >> 2] >> 2] | 0) + 8 >> 2] | 0, 0, (c[p >> 2] | 0) + 1 | 0) | 0;
	                                        if (!(c[s >> 2] | 0))break;
	                                        c[w >> 2] = -1;
	                                        break
	                                    }
	                                    if ((c[c[c[l >> 2] >> 2] >> 2] | 0) != 4) {
	                                        c[w >> 2] = -1;
	                                        break
	                                    }
	                                    if ((c[(c[c[l >> 2] >> 2] | 0) + 12 >> 2] | 0) != 0 ? (d[c[(c[c[l >> 2] >> 2] | 0) + 12 >> 2] >> 0] | 0) != 0 : 0)c[s >> 2] = Nj(c[(c[m >> 2] | 0) + 4 >> 2] | 0, 189536, c[(c[c[l >> 2] >> 2] | 0) + 12 >> 2] | 0, (c[p >> 2] | 0) + 1 | 0) | 0; else c[s >> 2] = Nj(c[(c[m >> 2] | 0) + 4 >> 2] | 0, 189536, 0, (c[p >> 2] | 0) + 1 | 0) | 0;
	                                    if (c[(c[c[l >> 2] >> 2] | 0) + 40 >> 2] | 0)c[w >> 2] = 2;
	                                    if (c[s >> 2] | 0)c[w >> 2] = -1
	                                } while (0);
	                                c[l >> 2] = (c[l >> 2] | 0) + 4
	                            } else y = 48; while (0);
	                            if ((y | 0) == 48) {
	                                y = 0;
	                                c[w >> 2] = 0
	                            }
	                            c[p >> 2] = (c[p >> 2] | 0) + 1
	                        }
	                        c[(c[m >> 2] | 0) + 12 >> 2] = c[n >> 2];
	                        c[(c[h >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                        if (c[v >> 2] | 0) {
	                            u = (c[h >> 2] | 0) + 50 | 0;
	                            b[u >> 1] = b[u >> 1] | 8
	                        }
	                        if ((c[w >> 2] | 0) == 1)c[(c[m >> 2] | 0) + 8 >> 2] = 1;
	                        if ((c[w >> 2] | 0) != 2) {
	                            i = g;
	                            return
	                        }
	                        c[(c[m >> 2] | 0) + 8 >> 2] = 3;
	                        i = g;
	                        return
	                    }
	                } while (0);
	                xN(c[j >> 2] | 0, 190192);
	                if (c[n >> 2] | 0) {
	                    c[p >> 2] = 0;
	                    while (1) {
	                        if ((c[p >> 2] | 0) >= (c[t >> 2] | 0))break;
	                        if (c[(c[n >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) {
	                            if (c[(c[(c[n >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[(c[n >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[(c[n >> 2] | 0) + (c[p >> 2] << 2) >> 2] | 0)
	                        }
	                        c[p >> 2] = (c[p >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0)
	                }
	                RN(c[m >> 2] | 0);
	                i = g;
	                return
	            }

	            function DN(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                d = (c[g >> 2] | 0) + 80 | 0;
	                do if (!(c[(c[g >> 2] | 0) + 80 >> 2] | 0)) {
	                    c[d >> 2] = 16;
	                    c[(c[g >> 2] | 0) + 76 >> 2] = 0;
	                    a = Cb[c[135744 >> 2] & 511](c[(c[g >> 2] | 0) + 80 >> 2] << 2) | 0;
	                    c[(c[g >> 2] | 0) + 84 >> 2] = a;
	                    if (!(c[(c[g >> 2] | 0) + 84 >> 2] | 0)) {
	                        xN(c[g >> 2] | 0, 190080);
	                        c[f >> 2] = 0;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } else if ((c[d >> 2] | 0) <= (c[(c[g >> 2] | 0) + 76 >> 2] | 0)) {
	                    a = (c[g >> 2] | 0) + 80 | 0;
	                    c[a >> 2] = c[a >> 2] << 1;
	                    c[k >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 84 >> 2] | 0, c[(c[g >> 2] | 0) + 80 >> 2] << 2) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                        break
	                    }
	                    xN(c[g >> 2] | 0, 190080);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } while (0);
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](56) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    xN(c[g >> 2] | 0, 190080);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    k = (c[j >> 2] | 0) + 0 | 0;
	                    d = k + 56 | 0;
	                    do {
	                        c[k >> 2] = 0;
	                        k = k + 4 | 0
	                    } while ((k | 0) < (d | 0));
	                    k = c[j >> 2] | 0;
	                    d = (c[g >> 2] | 0) + 76 | 0;
	                    a = c[d >> 2] | 0;
	                    c[d >> 2] = a + 1;
	                    c[(c[(c[g >> 2] | 0) + 84 >> 2] | 0) + (a << 2) >> 2] = k;
	                    c[(c[j >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    b[(c[j >> 2] | 0) + 48 >> 1] = -1;
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function EN(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                if (!((c[c[h >> 2] >> 2] | 0) != 20 ? (c[c[h >> 2] >> 2] | 0) != 4 : 0))m = 5;
	                if (((m | 0) == 5 ? (c[j >> 2] = cO(c[h >> 2] | 0) | 0, (b[(c[h >> 2] | 0) + 50 >> 1] & 64 | 0) != 0) : 0) ? (b[(c[h >> 2] | 0) + 48 >> 1] | 0) != -25 : 0) {
	                    c[(c[g >> 2] | 0) + 132 >> 2] = 0;
	                    c[j >> 2] = dO(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    c[f >> 2] = c[j >> 2];
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                a:do switch (c[c[h >> 2] >> 2] | 0) {
	                    case 4:
	                    case 0:
	                    case 7:
	                    case 6:
	                    case 8:
	                    case 5:
	                    case 3:
	                    {
	                        c[j >> 2] = 0;
	                        break
	                    }
	                    case 13:
	                    case 12:
	                    case 11:
	                    case 20:
	                    case 10:
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    {
	                        c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break a;
	                            c[j >> 2] = EN(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                            if (c[j >> 2] | 0)break a;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                        }
	                        break
	                    }
	                    case -1:
	                    {
	                        c[j >> 2] = EN(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 1:
	                    case 19:
	                    case 9:
	                    case 2:
	                    {
	                        c[j >> 2] = 0;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                c[f >> 2] = c[j >> 2];
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function FN(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                if (!(c[h >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if (c[(c[h >> 2] | 0) + 28 >> 2] & 8) {
	                    i = g;
	                    return
	                }
	                if ((c[(c[h >> 2] | 0) + 28 >> 2] & 1 | 0) != 0 ? (c[(c[h >> 2] | 0) + 28 >> 2] & 2 | 0) == 0 : 0) {
	                    gO(c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    i = g;
	                    return
	                }
	                if (c[(c[h >> 2] | 0) + 48 >> 2] | 0)eO(c[h >> 2] | 0);
	                if (c[(c[h >> 2] | 0) + 60 >> 2] | 0) {
	                    c[n >> 2] = c[c[(c[h >> 2] | 0) + 60 >> 2] >> 2];
	                    c[o >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2]
	                } else {
	                    c[o >> 2] = 0;
	                    c[n >> 2] = 0
	                }
	                if ((c[n >> 2] | 0) == 0 & (c[o >> 2] | 0) == 0)c[n >> 2] = c[(c[h >> 2] | 0) + 104 >> 2];
	                fO(c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0);
	                i = g;
	                return
	            }

	            function GN(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g;
	                j = g + 52 | 0;
	                k = g + 48 | 0;
	                l = g + 44 | 0;
	                m = g + 40 | 0;
	                n = g + 36 | 0;
	                p = g + 32 | 0;
	                q = g + 28 | 0;
	                r = g + 24 | 0;
	                s = g + 20 | 0;
	                t = g + 16 | 0;
	                u = g + 12 | 0;
	                v = g + 8 | 0;
	                w = g + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = c[m >> 2];
	                c[p >> 2] = c[l >> 2];
	                c[t >> 2] = 0;
	                if (!(c[n >> 2] | 0)) {
	                    l = c[o >> 2] | 0;
	                    c[h >> 2] = c[k >> 2];
	                    Ka(l | 0, 189616, h | 0) | 0;
	                    i = g;
	                    return
	                }
	                c[s >> 2] = c[(c[n >> 2] | 0) + 104 >> 2];
	                c[(c[n >> 2] | 0) + 100 >> 2] = 1;
	                if (!(c[p >> 2] | 0)) {
	                    if ((d[c[k >> 2] >> 0] | 0 | 0) == 35) {
	                        i = g;
	                        return
	                    }
	                    l = c[o >> 2] | 0;
	                    c[h >> 2] = c[k >> 2];
	                    Ka(l | 0, 189648, h | 0) | 0;
	                    if ((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 40 >> 2] | 0) == 0 : 0)c[(c[n >> 2] | 0) + 40 >> 2] = 37;
	                    c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                if ((c[n >> 2] | 0) == 0 | (c[p >> 2] | 0) == 0) {
	                    l = c[o >> 2] | 0;
	                    c[h >> 2] = c[k >> 2];
	                    Ka(l | 0, 189680, h | 0) | 0;
	                    if ((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 40 >> 2] | 0) == 0 : 0)c[(c[n >> 2] | 0) + 40 >> 2] = 37;
	                    c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                if ((c[c[p >> 2] >> 2] | 0) != 4) {
	                    l = c[o >> 2] | 0;
	                    c[h >> 2] = c[k >> 2];
	                    Ka(l | 0, 189712, h | 0) | 0;
	                    if (!(c[(c[n >> 2] | 0) + 40 >> 2] | 0))c[(c[n >> 2] | 0) + 40 >> 2] = 37;
	                    c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                if ((c[(c[s >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                    FN(c[n >> 2] | 0, 23, 0, 0, 0);
	                    if (!(c[(c[n >> 2] | 0) + 28 >> 2] & 1))eO(c[n >> 2] | 0);
	                    c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                if (!(c[(c[p >> 2] | 0) + 52 >> 2] | 0)) {
	                    c[(c[n >> 2] | 0) + 100 >> 2] = 0;
	                    c[(c[n >> 2] | 0) + 108 >> 2] = c[p >> 2];
	                    i = g;
	                    return
	                }
	                c[j >> 2] = oz(c[(c[p >> 2] | 0) + 52 >> 2] | 0, 382, c[n >> 2] | 0) | 0;
	                h = c[n >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[h + 100 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                HN(h, c[j >> 2] | 0) | 0;
	                c[q >> 2] = JN(c[n >> 2] | 0, c[s >> 2] | 0) | 0;
	                j = c[n >> 2] | 0;
	                if (!(c[q >> 2] | 0)) {
	                    c[j + 100 >> 2] = -1;
	                    i = g;
	                    return
	                }
	                c[r >> 2] = c[j + 60 >> 2];
	                c[(c[n >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                if ((c[(c[p >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[t >> 2] = hO(c[n >> 2] | 0, c[(c[p >> 2] | 0) + 36 >> 2] | 0) | 0, (c[t >> 2] | 0) != 0) : 0) {
	                    c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                    FN(c[n >> 2] | 0, 24, c[(c[s >> 2] | 0) + 8 >> 2] | 0, 0, 0)
	                }
	                s = c[n >> 2] | 0;
	                if (!(c[(c[n >> 2] | 0) + 60 >> 2] | 0)) {
	                    if (c[s + 64 >> 2] | 0) {
	                        c[v >> 2] = -1;
	                        c[u >> 2] = c[(c[n >> 2] | 0) + 28 >> 2];
	                        c[w >> 2] = 0;
	                        while (1) {
	                            if ((c[w >> 2] | 0) >= (c[c[(c[n >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                            c[q >> 2] = c[(c[(c[(c[n >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[w >> 2] << 2) >> 2];
	                            c[(c[n >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                            c[(c[(c[n >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = 0;
	                            if (!(iO(c[n >> 2] | 0, 0) | 0)) {
	                                x = 39;
	                                break
	                            }
	                            c[w >> 2] = (c[w >> 2] | 0) + 1
	                        }
	                        if ((x | 0) == 39)c[v >> 2] = 0;
	                        if (c[v >> 2] | 0) {
	                            x = (c[n >> 2] | 0) + 28 | 0;
	                            c[x >> 2] = c[x >> 2] | 1;
	                            jO(c[n >> 2] | 0)
	                        }
	                        c[w >> 2] = 0;
	                        while (1) {
	                            y = c[n >> 2] | 0;
	                            if ((c[w >> 2] | 0) >= (c[c[(c[n >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                            LN(y, c[(c[(c[(c[n >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[w >> 2] << 2) >> 2] | 0);
	                            c[w >> 2] = (c[w >> 2] | 0) + 1
	                        }
	                        NN(y, c[(c[n >> 2] | 0) + 64 >> 2] | 0);
	                        c[(c[n >> 2] | 0) + 64 >> 2] = 0;
	                        if ((c[t >> 2] | 0) == 0 & (c[v >> 2] | 0) == -1)c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                        c[(c[n >> 2] | 0) + 28 >> 2] = c[u >> 2]
	                    }
	                } else {
	                    c[(c[s + 60 >> 2] | 0) + 4 >> 2] = 0;
	                    c[t >> 2] = iO(c[n >> 2] | 0, 1) | 0;
	                    if (c[t >> 2] | 0)c[(c[n >> 2] | 0) + 100 >> 2] = -1;
	                    LN(c[n >> 2] | 0, c[(c[n >> 2] | 0) + 60 >> 2] | 0)
	                }
	                if ((c[(c[n >> 2] | 0) + 100 >> 2] | 0) == -1 ? (c[(c[n >> 2] | 0) + 28 >> 2] & 1 | 0) == 0 : 0)eO(c[n >> 2] | 0);
	                c[(c[n >> 2] | 0) + 60 >> 2] = c[r >> 2];
	                i = g;
	                return
	            }

	            function HN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 96 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 92 >> 2] = 10, b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 92 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 96 >> 2] = b, (c[(c[f >> 2] | 0) + 96 >> 2] | 0) == 0) : 0) {
	                    MN(c[f >> 2] | 0, 189544);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 88 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 92 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 92 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 96 >> 2] | 0, c[(c[f >> 2] | 0) + 92 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 96 >> 2] = b, (c[(c[f >> 2] | 0) + 96 >> 2] | 0) == 0) : 0) {
	                    MN(c[f >> 2] | 0, 189544);
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                b = c[g >> 2] | 0;
	                a = (c[f >> 2] | 0) + 88 | 0;
	                j = c[a >> 2] | 0;
	                c[a >> 2] = j + 1;
	                c[(c[(c[f >> 2] | 0) + 96 >> 2] | 0) + (j << 2) >> 2] = b;
	                c[(c[f >> 2] | 0) + 84 >> 2] = c[g >> 2];
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function IN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 88 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 88 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 96 >> 2] | 0) + (c[(c[e >> 2] | 0) + 88 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 96 >> 2] | 0) + (c[(c[e >> 2] | 0) + 88 >> 2] << 2) >> 2] = 0;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 88 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 84 >> 2] = c[(c[(c[e >> 2] | 0) + 96 >> 2] | 0) + ((c[a + 88 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 84 >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function JN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 128 | 0;
	                e = d + 112 | 0;
	                f = d + 108 | 0;
	                g = d + 104 | 0;
	                h = d + 100 | 0;
	                j = d + 96 | 0;
	                k = d + 16 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[l >> 2] = 0;
	                c[m >> 2] = 0;
	                a:do if (!(c[g >> 2] | 0)) {
	                    c[m >> 2] = Pi(c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        o = c[e >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    }
	                } else {
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[j >> 2] | 0))break a;
	                        if ((c[l >> 2] | 0) < 20) {
	                            b = c[j >> 2] | 0;
	                            a = c[l >> 2] | 0;
	                            c[l >> 2] = a + 1;
	                            c[k + (a << 2) >> 2] = b
	                        } else c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                if ((c[(c[f >> 2] | 0) + 68 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 68 >> 2] >> 2] | 0) > 0 : 0) {
	                    b = c[(c[f >> 2] | 0) + 68 >> 2] | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + -1;
	                    c[h >> 2] = c[(c[(c[(c[f >> 2] | 0) + 68 >> 2] | 0) + 8 >> 2] | 0) + (c[c[(c[f >> 2] | 0) + 68 >> 2] >> 2] << 2) >> 2]
	                } else p = 13;
	                do if ((p | 0) == 13) {
	                    c[h >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                    if (c[h >> 2] | 0) {
	                        b = c[h >> 2] | 0;
	                        c[b + 0 >> 2] = 0;
	                        c[b + 4 >> 2] = 0;
	                        c[b + 8 >> 2] = 0;
	                        c[b + 12 >> 2] = 0;
	                        c[b + 16 >> 2] = 0;
	                        c[b + 20 >> 2] = 0;
	                        c[b + 24 >> 2] = 0;
	                        c[b + 28 >> 2] = 0;
	                        break
	                    }
	                    MN(c[f >> 2] | 0, 189568);
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                } while (0);
	                c[(c[h >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[h >> 2] | 0) + 24 >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[c[h >> 2] >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[m >> 2]
	                } else {
	                    c[c[h >> 2] >> 2] = c[g >> 2];
	                    c[(c[h >> 2] | 0) + 4 >> 2] = c[(c[g >> 2] | 0) + 12 >> 2]
	                }
	                c[(c[h >> 2] | 0) + 8 >> 2] = 0;
	                b:do if ((c[l >> 2] | 0) > 0) {
	                    do if (!(c[(c[h >> 2] | 0) + 28 >> 2] | 0)) {
	                        if ((c[l >> 2] | 0) < 4)c[(c[h >> 2] | 0) + 12 >> 2] = 4; else c[(c[h >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                        m = Cb[c[135744 >> 2] & 511](c[(c[h >> 2] | 0) + 12 >> 2] << 2) | 0;
	                        c[(c[h >> 2] | 0) + 28 >> 2] = m;
	                        if (!(c[(c[h >> 2] | 0) + 28 >> 2] | 0)) {
	                            MN(c[f >> 2] | 0, 189568);
	                            c[e >> 2] = c[h >> 2];
	                            o = c[e >> 2] | 0;
	                            i = d;
	                            return o | 0
	                        }
	                    } else if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) < (c[l >> 2] | 0)) {
	                        c[n >> 2] = Hb[c[135760 >> 2] & 511](c[(c[h >> 2] | 0) + 28 >> 2] | 0, c[l >> 2] << 2) | 0;
	                        if (c[n >> 2] | 0) {
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                            c[(c[h >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                            break
	                        }
	                        MN(c[f >> 2] | 0, 189568);
	                        c[e >> 2] = c[h >> 2];
	                        o = c[e >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    } while (0);
	                    c[(c[h >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                    if ((c[l >> 2] | 0) < 20) {
	                        eU(c[(c[h >> 2] | 0) + 28 >> 2] | 0, k | 0, c[l >> 2] << 2 | 0) | 0;
	                        break
	                    }
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                    c[l >> 2] = 0;
	                    while (1) {
	                        if (!(c[j >> 2] | 0))break b;
	                        m = c[j >> 2] | 0;
	                        p = c[l >> 2] | 0;
	                        c[l >> 2] = p + 1;
	                        c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + (p << 2) >> 2] = m;
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2]
	                    }
	                } while (0);
	                c[(c[h >> 2] | 0) + 16 >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                c[e >> 2] = c[h >> 2];
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function KN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d;
	                f = d + 44 | 0;
	                g = d + 40 | 0;
	                h = d + 36 | 0;
	                j = d + 32 | 0;
	                k = d + 28 | 0;
	                l = d + 24 | 0;
	                m = d + 20 | 0;
	                n = d + 16 | 0;
	                o = d + 12 | 0;
	                p = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if ((c[(c[g >> 2] | 0) + 60 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = 189496;
	                    c[e + 4 >> 2] = 10608;
	                    Db[b & 511](a, 189464, e);
	                    LN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 60 >> 2] = 0
	                }
	                if ((c[(c[g >> 2] | 0) + 64 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) != 1 : 0) {
	                    c[j >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                    c[(c[g >> 2] | 0) + 64 >> 2] = 0;
	                    c[k >> 2] = 0;
	                    c[m >> 2] = 0;
	                    c[p >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                    a = (c[g >> 2] | 0) + 28 | 0;
	                    c[a >> 2] = c[a >> 2] | 1;
	                    c[l >> 2] = 0;
	                    while (1) {
	                        if ((c[l >> 2] | 0) >= (c[c[j >> 2] >> 2] | 0))break;
	                        c[(c[g >> 2] | 0) + 60 >> 2] = c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (c[l >> 2] << 2) >> 2];
	                        c[(c[g >> 2] | 0) + 64 >> 2] = 0;
	                        c[o >> 2] = kO(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if ((c[(c[g >> 2] | 0) + 60 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                            a = c[33976] | 0;
	                            b = c[33980] | 0;
	                            c[e >> 2] = 189496;
	                            c[e + 4 >> 2] = 10645;
	                            Db[a & 511](b, 189464, e);
	                            LN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                            c[(c[g >> 2] | 0) + 60 >> 2] = 0
	                        }
	                        b = c[g >> 2] | 0;
	                        a:do if (c[o >> 2] | 0) {
	                            a = c[g >> 2] | 0;
	                            if (c[b + 60 >> 2] | 0) {
	                                LN(a, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                                break
	                            }
	                            if (c[a + 64 >> 2] | 0) {
	                                c[n >> 2] = 0;
	                                while (1) {
	                                    q = c[g >> 2] | 0;
	                                    if ((c[n >> 2] | 0) >= (c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                    LN(q, c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0);
	                                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                                }
	                                NN(q, c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                                c[(c[g >> 2] | 0) + 64 >> 2] = 0
	                            }
	                        } else {
	                            a = c[k >> 2] | 0;
	                            if (!(c[b + 64 >> 2] | 0)) {
	                                r = c[g >> 2] | 0;
	                                if (a) {
	                                    lO(r, c[k >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0) | 0;
	                                    c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                                    break
	                                } else {
	                                    s = c[r + 60 >> 2] | 0;
	                                    r = c[m >> 2] | 0;
	                                    c[m >> 2] = r + 1;
	                                    c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (r << 2) >> 2] = s;
	                                    c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                                    break
	                                }
	                            }
	                            if (!a) {
	                                c[k >> 2] = c[(c[g >> 2] | 0) + 64 >> 2];
	                                c[(c[g >> 2] | 0) + 64 >> 2] = 0;
	                                c[n >> 2] = 0;
	                                while (1) {
	                                    if ((c[n >> 2] | 0) >= (c[m >> 2] | 0))break a;
	                                    lO(c[g >> 2] | 0, c[k >> 2] | 0, c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0) | 0;
	                                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                                }
	                            }
	                            c[n >> 2] = 0;
	                            while (1) {
	                                t = c[g >> 2] | 0;
	                                if ((c[n >> 2] | 0) >= (c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                lO(t, c[k >> 2] | 0, c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0) | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + 1
	                            }
	                            NN(t, c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                            c[(c[g >> 2] | 0) + 64 >> 2] = 0
	                        } while (0);
	                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                    c[(c[g >> 2] | 0) + 28 >> 2] = c[p >> 2];
	                    do if (!(c[k >> 2] | 0)) {
	                        p = c[m >> 2] | 0;
	                        if ((c[m >> 2] | 0) > 1) {
	                            c[c[j >> 2] >> 2] = p;
	                            c[(c[g >> 2] | 0) + 64 >> 2] = c[j >> 2];
	                            c[o >> 2] = 0;
	                            break
	                        }
	                        if ((p | 0) == 1) {
	                            c[(c[g >> 2] | 0) + 60 >> 2] = c[c[(c[j >> 2] | 0) + 8 >> 2] >> 2];
	                            NN(c[g >> 2] | 0, c[j >> 2] | 0);
	                            c[o >> 2] = 0;
	                            break
	                        }
	                        c[o >> 2] = -1;
	                        NN(c[g >> 2] | 0, c[j >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                            NN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                            c[(c[g >> 2] | 0) + 64 >> 2] = 0
	                        }
	                    } else {
	                        NN(c[g >> 2] | 0, c[j >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 64 >> 2] = c[k >> 2];
	                        c[o >> 2] = 0
	                    } while (0);
	                    if ((c[(c[g >> 2] | 0) + 60 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                        k = c[33976] | 0;
	                        j = c[33980] | 0;
	                        c[e >> 2] = 189496;
	                        c[e + 4 >> 2] = 10711;
	                        Db[k & 511](j, 189464, e);
	                        LN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                        c[(c[g >> 2] | 0) + 60 >> 2] = 0
	                    }
	                    c[f >> 2] = c[o >> 2];
	                    u = c[f >> 2] | 0;
	                    i = d;
	                    return u | 0
	                }
	                if (c[(c[g >> 2] | 0) + 64 >> 2] | 0) {
	                    c[(c[g >> 2] | 0) + 60 >> 2] = c[c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] >> 2];
	                    NN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 64 >> 2] = 0
	                }
	                c[o >> 2] = kO(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if ((c[(c[g >> 2] | 0) + 60 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                    h = c[33976] | 0;
	                    j = c[33980] | 0;
	                    c[e >> 2] = 189496;
	                    c[e + 4 >> 2] = 10620;
	                    Db[h & 511](j, 189464, e);
	                    LN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 60 >> 2] = 0
	                }
	                if ((c[(c[g >> 2] | 0) + 64 >> 2] | 0) != 0 ? (c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) == 1 : 0) {
	                    c[(c[g >> 2] | 0) + 60 >> 2] = c[c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] >> 2];
	                    NN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 64 >> 2] = 0
	                }
	                c[f >> 2] = c[o >> 2];
	                u = c[f >> 2] | 0;
	                i = d;
	                return u | 0
	            }

	            function LN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 68 >> 2] | 0) == 0 : 0) {
	                    b = mO(c[e >> 2] | 0, 40) | 0;
	                    c[(c[e >> 2] | 0) + 68 >> 2] = b
	                }
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 68 >> 2] | 0) != 0 : 0) {
	                    nO(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 68 >> 2] | 0, c[f >> 2] | 0) | 0;
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 28 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 28 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function MN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                if (c[f >> 2] | 0) {
	                    b = c[f >> 2] | 0;
	                    if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)c[h >> 2] = c[b + 12 >> 2]; else c[j >> 2] = c[b + 4 >> 2];
	                    c[k >> 2] = c[c[f >> 2] >> 2];
	                    b = (c[f >> 2] | 0) + 16 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + 1
	                }
	                b = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                if (c[g >> 2] | 0) {
	                    k = c[g >> 2] | 0;
	                    c[e >> 2] = c[g >> 2];
	                    Xd(b, h, j, 0, 0, 19, 2, 3, 0, 0, k, 0, 0, 0, 0, 189400, e);
	                    i = d;
	                    return
	                } else {
	                    Xd(b, h, j, 0, 0, 19, 2, 3, 0, 0, 0, 0, 0, 0, 0, 189432, e);
	                    i = d;
	                    return
	                }
	            }

	            function NN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 80 >> 2] | 0) == 0 : 0) {
	                    c[(c[e >> 2] | 0) + 76 >> 2] = 40;
	                    c[(c[e >> 2] | 0) + 72 >> 2] = 0;
	                    b = Cb[c[135744 >> 2] & 511](c[(c[e >> 2] | 0) + 76 >> 2] << 2) | 0;
	                    c[(c[e >> 2] | 0) + 80 >> 2] = b;
	                    if (!(c[(c[e >> 2] | 0) + 80 >> 2] | 0))MN(c[e >> 2] | 0, 189384)
	                } else h = 6;
	                do if (((h | 0) == 6 ? (c[e >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 72 >> 2] | 0) >= (c[(c[e >> 2] | 0) + 76 >> 2] | 0) : 0) {
	                    c[g >> 2] = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 80 >> 2] | 0, c[(c[e >> 2] | 0) + 76 >> 2] << 1 << 2) | 0;
	                    if (c[g >> 2] | 0) {
	                        c[(c[e >> 2] | 0) + 80 >> 2] = c[g >> 2];
	                        b = (c[e >> 2] | 0) + 76 | 0;
	                        c[b >> 2] = c[b >> 2] << 1;
	                        break
	                    }
	                    MN(c[e >> 2] | 0, 189384);
	                    zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    i = d;
	                    return
	                } while (0);
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) {
	                    g = c[f >> 2] | 0;
	                    h = (c[e >> 2] | 0) + 72 | 0;
	                    b = c[h >> 2] | 0;
	                    c[h >> 2] = b + 1;
	                    c[(c[(c[e >> 2] | 0) + 80 >> 2] | 0) + (b << 2) >> 2] = g;
	                    i = d;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[(c[f >> 2] | 0) + 8 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = d;
	                return
	            }

	            function ON(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                d = i;
	                i = i + 112 | 0;
	                e = d + 100 | 0;
	                f = d + 96 | 0;
	                g = d + 92 | 0;
	                h = d + 88 | 0;
	                j = d + 84 | 0;
	                k = d + 80 | 0;
	                l = d + 76 | 0;
	                m = d + 72 | 0;
	                n = d + 68 | 0;
	                o = d + 64 | 0;
	                p = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) != 0 ? !((c[g >> 2] | 0) == 0 ? 1 : (c[(c[f >> 2] | 0) + 20 >> 2] | 0) == 0) : 0) {
	                    c[(c[f >> 2] | 0) + 40 >> 2] = 0;
	                    c[j >> 2] = c[(c[f >> 2] | 0) + 20 >> 2];
	                    c[k >> 2] = c[(c[j >> 2] | 0) + 4 >> 2];
	                    j = c[f >> 2] | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        FN(j, 34, 0, 0, 0);
	                        c[e >> 2] = -1;
	                        q = c[e >> 2] | 0;
	                        i = d;
	                        return q | 0
	                    }
	                    c[l >> 2] = JN(j, 0) | 0;
	                    c[(c[f >> 2] | 0) + 60 >> 2] = c[l >> 2];
	                    c[h >> 2] = KN(c[f >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    if ((c[(c[f >> 2] | 0) + 60 >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        c[l >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                        c[m >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                        c[m >> 2] = oO(c[f >> 2] | 0, c[m >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) != 0 & (c[h >> 2] | 0) != -1) {
	                            FN(c[f >> 2] | 0, 35, 0, 0, 0);
	                            c[h >> 2] = -1
	                        }
	                    } else r = 10;
	                    if ((r | 0) == 10 ? (c[(c[f >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) {
	                        c[o >> 2] = -1;
	                        c[n >> 2] = 0;
	                        while (1) {
	                            if ((c[n >> 2] | 0) >= (c[c[(c[f >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                            c[l >> 2] = c[(c[(c[(c[f >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[n >> 2] << 2) >> 2];
	                            c[m >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                            c[m >> 2] = oO(c[f >> 2] | 0, c[m >> 2] | 0) | 0;
	                            if (!(c[m >> 2] | 0))c[o >> 2] = 0;
	                            LN(c[f >> 2] | 0, c[l >> 2] | 0);
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                        if ((c[o >> 2] | 0) == -1 & (c[h >> 2] | 0) != -1) {
	                            FN(c[f >> 2] | 0, 35, 0, 0, 0);
	                            c[h >> 2] = -1
	                        }
	                    }
	                    if (c[(c[f >> 2] | 0) + 60 >> 2] | 0) {
	                        LN(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 60 >> 2] | 0);
	                        c[(c[f >> 2] | 0) + 60 >> 2] = 0
	                    }
	                    if (c[h >> 2] | 0)eO(c[f >> 2] | 0);
	                    if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) == 1) {
	                        o = p + 0 | 0;
	                        n = o + 64 | 0;
	                        do {
	                            c[o >> 2] = 0;
	                            o = o + 4 | 0
	                        } while ((o | 0) < (n | 0));
	                        c[p + 36 >> 2] = 1;
	                        c[p + 4 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                        c[p + 8 >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                        c[p >> 2] = c[c[f >> 2] >> 2];
	                        if ((cn(p, c[g >> 2] | 0) | 0) != 1)c[h >> 2] = -1
	                    }
	                    if ((c[h >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 0 : 0)c[h >> 2] = -1;
	                    c[e >> 2] = c[h >> 2];
	                    q = c[e >> 2] | 0;
	                    i = d;
	                    return q | 0
	                }
	                c[e >> 2] = -1;
	                q = c[e >> 2] | 0;
	                i = d;
	                return q | 0
	            }

	            function PN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (((c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 1)c[(c[d >> 2] | 0) + 52 >> 2] = 0;
	                c[e >> 2] = c[(c[d >> 2] | 0) + 12 >> 2];
	                a:while (1) {
	                    if (!(c[e >> 2] | 0))break;
	                    if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[e >> 2] | 0) + 52 >> 2] = 0, (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) {
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 12 >> 2];
	                        continue
	                    }
	                    if (c[(c[e >> 2] | 0) + 24 >> 2] | 0) {
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                        if (!(c[e >> 2] | 0))continue a;
	                        if ((c[e >> 2] | 0) == (c[d >> 2] | 0)) {
	                            f = 16;
	                            break
	                        }
	                        g = c[e >> 2] | 0;
	                        if (c[(c[e >> 2] | 0) + 24 >> 2] | 0) {
	                            f = 18;
	                            break
	                        }
	                        if (!g)continue a
	                    }
	                    if ((f | 0) == 16) {
	                        f = 0;
	                        c[e >> 2] = 0;
	                        continue
	                    } else if ((f | 0) == 18) {
	                        f = 0;
	                        c[e >> 2] = c[g + 24 >> 2];
	                        continue
	                    }
	                }
	                i = b;
	                return
	            }

	            function QN(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)VM(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function RN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    while (1) {
	                        if ((c[f >> 2] | 0) >= (c[c[d >> 2] >> 2] | 0))break;
	                        c[e >> 2] = c[(c[(c[d >> 2] | 0) + 12 >> 2] | 0) + (c[f >> 2] << 2) >> 2];
	                        if (c[e >> 2] | 0) {
	                            if (c[(c[e >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 8 >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[e >> 2] | 0)
	                        }
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)Kj(c[(c[d >> 2] | 0) + 4 >> 2] | 0, 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function SN(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[m >> 2] = c[j >> 2];
	                while (1) {
	                    p = c[m >> 2] | 0;
	                    if (!(d[c[m >> 2] >> 0] | 0))break;
	                    c[m >> 2] = p + 1
	                }
	                c[n >> 2] = p - (c[j >> 2] | 0);
	                c[k >> 2] = Cb[c[135752 >> 2] & 511]((c[n >> 2] | 0) + 1 | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    MN(c[h >> 2] | 0, 189544);
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[l >> 2] = c[k >> 2];
	                a:while (1) {
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13)break a
	                    } while (0);
	                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                }
	                b:while (1) {
	                    if (!(d[c[j >> 2] >> 0] | 0))break;
	                    do if ((d[c[j >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[j >> 2] >> 0] | 0 | 0) != 13) {
	                            h = c[j >> 2] | 0;
	                            c[j >> 2] = h + 1;
	                            n = a[h >> 0] | 0;
	                            h = c[l >> 2] | 0;
	                            c[l >> 2] = h + 1;
	                            a[h >> 0] = n;
	                            continue b
	                        }
	                    } while (0);
	                    while (1) {
	                        do if ((d[c[j >> 2] >> 0] | 0 | 0) == 32)q = 1; else {
	                            if (9 <= (d[c[j >> 2] >> 0] | 0 | 0) ? (d[c[j >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                q = 1;
	                                break
	                            }
	                            q = (d[c[j >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        r = c[j >> 2] | 0;
	                        if (!q)break;
	                        c[j >> 2] = r + 1
	                    }
	                    if (!(d[r >> 0] | 0))break;
	                    n = c[l >> 2] | 0;
	                    c[l >> 2] = n + 1;
	                    a[n >> 0] = 32
	                }
	                a[c[l >> 2] >> 0] = 0;
	                c[g >> 2] = c[k >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function TN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 36 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 32 >> 2] | 0))break;
	                        mN(c[(c[(c[d >> 2] | 0) + 36 >> 2] | 0) + (c[e >> 2] << 2) >> 2] | 0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 36 >> 2] | 0)
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function UN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0;
	                d = i;
	                i = i + 144 | 0;
	                e = d + 128 | 0;
	                f = d + 124 | 0;
	                g = d + 120 | 0;
	                h = d + 116 | 0;
	                j = d + 112 | 0;
	                k = d + 108 | 0;
	                l = d + 104 | 0;
	                m = d + 100 | 0;
	                n = d + 96 | 0;
	                o = d + 92 | 0;
	                p = d + 88 | 0;
	                q = d + 84 | 0;
	                r = d + 80 | 0;
	                s = d + 76 | 0;
	                t = d + 72 | 0;
	                u = d + 68 | 0;
	                v = d + 64 | 0;
	                w = d + 60 | 0;
	                x = d + 56 | 0;
	                y = d + 52 | 0;
	                z = d + 48 | 0;
	                A = d + 44 | 0;
	                B = d + 40 | 0;
	                C = d + 36 | 0;
	                D = d + 32 | 0;
	                E = d + 28 | 0;
	                F = d + 24 | 0;
	                G = d + 20 | 0;
	                H = d + 16 | 0;
	                I = d + 12 | 0;
	                J = d + 8 | 0;
	                K = d + 4 | 0;
	                L = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[h >> 2] = 0;
	                c[g >> 2] = c[f >> 2];
	                a:while (1) {
	                    M = (c[h >> 2] | 0) != 0;
	                    if (!(c[g >> 2] | 0))break;
	                    if (M) {
	                        Qh(c[h >> 2] | 0);
	                        Rh(c[h >> 2] | 0);
	                        c[h >> 2] = 0
	                    }
	                    b = c[g >> 2] | 0;
	                    b:do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        if ((c[b + 4 >> 2] | 0) != 3 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                            c[h >> 2] = c[g >> 2];
	                            break
	                        }
	                        if (sO(c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0) {
	                            if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                                if (qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 189888) | 0) {
	                                    N = 158;
	                                    break
	                                }
	                                if (qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 190064) | 0) {
	                                    N = 158;
	                                    break
	                                }
	                                c[h >> 2] = c[g >> 2];
	                                N = 158;
	                                break
	                            }
	                            c[h >> 2] = c[g >> 2]
	                        } else N = 158
	                    } else {
	                        if ((c[b + 36 >> 2] | 0) != 0 ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                            pO(c[e >> 2] | 0, c[g >> 2] | 0);
	                            a = (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189936) | 0) != 0;
	                            O = c[g >> 2] | 0;
	                            c:do if (a) {
	                                c[k >> 2] = Yi(O, 192672) | 0;
	                                d:do if (!(c[k >> 2] | 0)) {
	                                    c[o >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                                    while (1) {
	                                        if (!(c[o >> 2] | 0))break d;
	                                        if ((c[(c[o >> 2] | 0) + 4 >> 2] | 0) != 1)break d;
	                                        c[k >> 2] = Yi(c[o >> 2] | 0, 192672) | 0;
	                                        if (c[k >> 2] | 0)break d;
	                                        c[o >> 2] = c[(c[o >> 2] | 0) + 20 >> 2]
	                                    }
	                                } while (0);
	                                c[j >> 2] = Yi(c[g >> 2] | 0, 195400) | 0;
	                                if (!(c[j >> 2] | 0)) {
	                                    zN(c[e >> 2] | 0, c[g >> 2] | 0, 1052, 195408, 0, 0);
	                                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                    c[h >> 2] = c[g >> 2];
	                                    break b
	                                }
	                                c[p >> 2] = yl(c[j >> 2] | 0) | 0;
	                                if (!(c[p >> 2] | 0)) {
	                                    zN(c[e >> 2] | 0, c[g >> 2] | 0, 1041, 195464, c[j >> 2] | 0, 0);
	                                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                    if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                    c[h >> 2] = c[g >> 2];
	                                    break b
	                                }
	                                if (c[(c[p >> 2] | 0) + 32 >> 2] | 0) {
	                                    zN(c[e >> 2] | 0, c[g >> 2] | 0, 1041, 195504, c[j >> 2] | 0, 0);
	                                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                    Al(c[p >> 2] | 0);
	                                    if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                    c[h >> 2] = c[g >> 2];
	                                    break b
	                                }
	                                Al(c[p >> 2] | 0);
	                                c[l >> 2] = Xi(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0) | 0;
	                                c[m >> 2] = Hl(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                                if (!(c[m >> 2] | 0)) {
	                                    zN(c[e >> 2] | 0, c[g >> 2] | 0, 1041, 195552, c[j >> 2] | 0, 0);
	                                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                    if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                    if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                                    c[h >> 2] = c[g >> 2];
	                                    break b
	                                }
	                                if (c[j >> 2] | 0)zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                                if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                                c[n >> 2] = qO(c[e >> 2] | 0, c[m >> 2] | 0, c[k >> 2] | 0) | 0;
	                                if (!(c[n >> 2] | 0)) {
	                                    zN(c[e >> 2] | 0, c[g >> 2] | 0, 1032, 195600, c[m >> 2] | 0, 0);
	                                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    c[h >> 2] = c[g >> 2];
	                                    break b
	                                } else {
	                                    if (c[k >> 2] | 0)zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                    zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                    c[(c[g >> 2] | 0) + 52 >> 2] = c[n >> 2];
	                                    break
	                                }
	                            } else {
	                                P = (qy(c[O + 8 >> 2] | 0, 195024) | 0) != 0;
	                                Q = c[g >> 2] | 0;
	                                if (P) {
	                                    c[q >> 2] = Yi(Q, 195400) | 0;
	                                    if (!(c[q >> 2] | 0)) {
	                                        zN(c[e >> 2] | 0, c[g >> 2] | 0, 1052, 195632, 0, 0);
	                                        c[h >> 2] = c[g >> 2];
	                                        break b
	                                    }
	                                    c[s >> 2] = Xi(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0) | 0;
	                                    c[t >> 2] = Hl(c[q >> 2] | 0, c[s >> 2] | 0) | 0;
	                                    if (!(c[t >> 2] | 0)) {
	                                        zN(c[e >> 2] | 0, c[g >> 2] | 0, 1041, 195680, c[q >> 2] | 0, 0);
	                                        if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                        if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                                        c[h >> 2] = c[g >> 2];
	                                        break b
	                                    }
	                                    if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                    if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                                    c[r >> 2] = Yi(c[g >> 2] | 0, 192672) | 0;
	                                    e:do if (!(c[r >> 2] | 0)) {
	                                        c[v >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                                        while (1) {
	                                            if (!(c[v >> 2] | 0))break e;
	                                            if ((c[(c[v >> 2] | 0) + 4 >> 2] | 0) != 1)break e;
	                                            c[r >> 2] = Yi(c[v >> 2] | 0, 192672) | 0;
	                                            if (c[r >> 2] | 0)break e;
	                                            c[v >> 2] = c[(c[v >> 2] | 0) + 20 >> 2]
	                                        }
	                                    } while (0);
	                                    c[u >> 2] = rO(c[e >> 2] | 0, c[t >> 2] | 0, c[g >> 2] | 0, c[r >> 2] | 0) | 0;
	                                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                    if (!(c[u >> 2] | 0)) {
	                                        zN(c[e >> 2] | 0, c[g >> 2] | 0, 1043, 195720, c[t >> 2] | 0, 0);
	                                        zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                                        c[h >> 2] = c[g >> 2];
	                                        break b
	                                    } else {
	                                        zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                                        c[(c[g >> 2] | 0) + 52 >> 2] = c[u >> 2];
	                                        break
	                                    }
	                                }
	                                if ((qy(c[Q + 8 >> 2] | 0, 189864) | 0) == 0 ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189904) | 0) == 0 : 0) {
	                                    if (((qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 192176) | 0) == 0 ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 193592) | 0) == 0 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189888) | 0) == 0 : 0) {
	                                        do if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189848) | 0) {
	                                            if ((c[g >> 2] | 0) == (c[f >> 2] | 0))break;
	                                            c[G >> 2] = c[(c[e >> 2] | 0) + 32 >> 2];
	                                            do if (c[(c[g >> 2] | 0) + 20 >> 2] | 0) {
	                                                if (!(qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 193584) | 0))break;
	                                                P = (c[e >> 2] | 0) + 32 | 0;
	                                                c[P >> 2] = c[P >> 2] | 256;
	                                                UN(c[e >> 2] | 0, c[g >> 2] | 0);
	                                                c[(c[e >> 2] | 0) + 32 >> 2] = c[G >> 2];
	                                                break b
	                                            } while (0);
	                                            if (!(c[(c[g >> 2] | 0) + 20 >> 2] | 0))break c;
	                                            if (!(qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 193592) | 0))break c;
	                                            P = (c[e >> 2] | 0) + 32 | 0;
	                                            c[P >> 2] = c[P >> 2] | 512;
	                                            UN(c[e >> 2] | 0, c[g >> 2] | 0);
	                                            c[(c[e >> 2] | 0) + 32 >> 2] = c[G >> 2];
	                                            break b
	                                        } while (0);
	                                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 193584) | 0))break;
	                                        Q = c[e >> 2] | 0;
	                                        if (c[(c[e >> 2] | 0) + 32 >> 2] & 256) {
	                                            zN(Q, c[g >> 2] | 0, 1066, 195896, 0, 0);
	                                            break
	                                        }
	                                        if (!(c[Q + 32 >> 2] & 512))break;
	                                        zN(c[e >> 2] | 0, c[g >> 2] | 0, 1084, 195952, 0, 0);
	                                        break
	                                    }
	                                    do if (!(dj(c[g >> 2] | 0, 192672) | 0)) {
	                                        c[B >> 2] = 0;
	                                        c[A >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                                        while (1) {
	                                            if (!(c[A >> 2] | 0))break;
	                                            if ((c[(c[A >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                                            c[B >> 2] = Yi(c[A >> 2] | 0, 192672) | 0;
	                                            if (c[B >> 2] | 0)break;
	                                            c[A >> 2] = c[(c[A >> 2] | 0) + 20 >> 2]
	                                        }
	                                        Q = c[g >> 2] | 0;
	                                        if (!(c[B >> 2] | 0)) {
	                                            gj(Q, 192672, 188112) | 0;
	                                            break
	                                        } else {
	                                            gj(Q, 192672, c[B >> 2] | 0) | 0;
	                                            zb[c[135736 >> 2] & 511](c[B >> 2] | 0);
	                                            break
	                                        }
	                                    } while (0);
	                                    if ((qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 192176) | 0) != 0 ? (c[C >> 2] = _i(c[g >> 2] | 0) | 0, (c[C >> 2] | 0) != 0) : 0) {
	                                        c[D >> 2] = Ch(c[C >> 2] | 0, E) | 0;
	                                        if (c[D >> 2] | 0) {
	                                            c[F >> 2] = cj(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[g >> 2] | 0, c[E >> 2] | 0) | 0;
	                                            if (!(c[F >> 2] | 0))zN(c[e >> 2] | 0, c[g >> 2] | 0, 1097, 195792, c[E >> 2] | 0, 0); else {
	                                                gj(c[g >> 2] | 0, 192672, c[(c[F >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                                vi(c[g >> 2] | 0, c[D >> 2] | 0)
	                                            }
	                                            zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                                            zb[c[135736 >> 2] & 511](c[E >> 2] | 0)
	                                        }
	                                        zb[c[135736 >> 2] & 511](c[C >> 2] | 0)
	                                    }
	                                    if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 193592) | 0))break;
	                                    if (!(c[(c[e >> 2] | 0) + 32 >> 2] & 512))break;
	                                    zN(c[e >> 2] | 0, c[g >> 2] | 0, 1085, 195840, 0, 0);
	                                    break
	                                }
	                                c[y >> 2] = 0;
	                                c[w >> 2] = Yi(c[g >> 2] | 0, 192176) | 0;
	                                if (c[w >> 2] | 0) {
	                                    Q = c[g >> 2] | 0;
	                                    if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                                        c[z >> 2] = ji(c[Q + 32 >> 2] | 0, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 192176, 0) | 0;
	                                        if (c[z >> 2] | 0) {
	                                            wi(c[(c[g >> 2] | 0) + 12 >> 2] | 0, c[z >> 2] | 0) | 0;
	                                            c[y >> 2] = li(c[w >> 2] | 0) | 0;
	                                            zi(c[z >> 2] | 0, c[y >> 2] | 0) | 0;
	                                            c[y >> 2] = c[z >> 2]
	                                        }
	                                    } else c[y >> 2] = ti(Q, c[(c[g >> 2] | 0) + 36 >> 2] | 0, 192176, c[w >> 2] | 0) | 0;
	                                    if (!(c[y >> 2] | 0))zN(c[e >> 2] | 0, c[g >> 2] | 0, 1008, 195752, c[w >> 2] | 0, 0);
	                                    fj(c[g >> 2] | 0, 192176) | 0;
	                                    zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                                    c[x >> 2] = Yi(c[g >> 2] | 0, 192672) | 0;
	                                    if (!(c[x >> 2] | 0)) {
	                                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189904) | 0))break;
	                                        gj(c[y >> 2] | 0, 192672, 188112) | 0;
	                                        break
	                                    }
	                                    if (c[y >> 2] | 0)gj(c[y >> 2] | 0, 192672, c[x >> 2] | 0) | 0;
	                                    zb[c[135736 >> 2] & 511](c[x >> 2] | 0)
	                                }
	                            } while (0);
	                            if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 196008) | 0)) {
	                                N = 158;
	                                break
	                            }
	                            c[H >> 2] = Yi(c[g >> 2] | 0, 192672) | 0;
	                            c[I >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                            c[J >> 2] = c[g >> 2];
	                            while (1) {
	                                R = (c[H >> 2] | 0) != 0;
	                                if (!(c[I >> 2] | 0))break;
	                                if (R ? (dj(c[I >> 2] | 0, 192672) | 0) == 0 : 0)gj(c[I >> 2] | 0, 192672, c[H >> 2] | 0) | 0;
	                                c[K >> 2] = c[(c[I >> 2] | 0) + 24 >> 2];
	                                Qh(c[I >> 2] | 0);
	                                c[J >> 2] = Xh(c[J >> 2] | 0, c[I >> 2] | 0) | 0;
	                                c[I >> 2] = c[K >> 2]
	                            }
	                            if (R)zb[c[135736 >> 2] & 511](c[H >> 2] | 0);
	                            if ((c[(c[g >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                                c[L >> 2] = (c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 48;
	                                while (1) {
	                                    if (!(c[c[L >> 2] >> 2] | 0))break;
	                                    c[L >> 2] = c[c[L >> 2] >> 2]
	                                }
	                                c[c[L >> 2] >> 2] = c[(c[g >> 2] | 0) + 48 >> 2];
	                                c[(c[g >> 2] | 0) + 48 >> 2] = 0
	                            }
	                            c[h >> 2] = c[g >> 2];
	                            break
	                        }
	                        do if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                            if (((qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 192176) | 0) == 0 ? (qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 189888) | 0) == 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 190064) | 0) == 0 : 0)break;
	                            zN(c[e >> 2] | 0, c[g >> 2] | 0, 1035, 195352, c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 0)
	                        } while (0);
	                        c[h >> 2] = c[g >> 2]
	                    } while (0);
	                    if (((((N | 0) == 158 ? (N = 0, (c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0) : 0) ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 5 : 0) ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 6 : 0) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        continue
	                    }
	                    if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                        if (!(c[g >> 2] | 0))continue a;
	                        if ((c[g >> 2] | 0) == (c[f >> 2] | 0)) {
	                            N = 167;
	                            break
	                        }
	                        S = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                            N = 169;
	                            break
	                        }
	                        if (!S)continue a
	                    }
	                    if ((N | 0) == 167) {
	                        N = 0;
	                        c[g >> 2] = 0;
	                        continue
	                    } else if ((N | 0) == 169) {
	                        N = 0;
	                        c[g >> 2] = c[S + 24 >> 2];
	                        continue
	                    }
	                }
	                if (!M) {
	                    i = d;
	                    return
	                }
	                Qh(c[h >> 2] | 0);
	                Rh(c[h >> 2] | 0);
	                c[h >> 2] = 0;
	                i = d;
	                return
	            }

	            function VN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](40) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xN(c[e >> 2] | 0, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    e = (c[f >> 2] | 0) + 0 | 0;
	                    a = e + 40 | 0;
	                    do {
	                        c[e >> 2] = 0;
	                        e = e + 4 | 0
	                    } while ((e | 0) < (a | 0));
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function WN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = XN(c[f >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[c[h >> 2] >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                do if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                    c[j >> 2] = c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2];
	                    if (!(c[j >> 2] | 0)) {
	                        c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                        break
	                    }
	                    while (1) {
	                        if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0))break;
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 8 >> 2]
	                    }
	                    c[(c[j >> 2] | 0) + 8 >> 2] = c[h >> 2]
	                } while (0);
	                c[k >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[h >> 2];
	                tO(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[h >> 2];
	                j = c[f >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 24 >> 2] | 0) {
	                    if (!(c[(c[j + 24 >> 2] | 0) + 12 >> 2] | 0))zN(c[f >> 2] | 0, c[g >> 2] | 0, 1039, 194360, 0, 0)
	                } else zN(j, c[g >> 2] | 0, 1036, 194320, 0, 0);
	                uO(c[f >> 2] | 0, c[h >> 2] | 0);
	                if (c[(c[h >> 2] | 0) + 24 >> 2] | 0)Wj(c[(c[h >> 2] | 0) + 24 >> 2] | 0, 383, c[f >> 2] | 0);
	                if (c[(c[h >> 2] | 0) + 28 >> 2] | 0)Wj(c[(c[h >> 2] | 0) + 28 >> 2] | 0, 384, c[f >> 2] | 0);
	                c[(c[f >> 2] | 0) + 24 >> 2] = c[k >> 2];
	                c[e >> 2] = c[h >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function XN(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    xN(c[e >> 2] | 0, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    e = c[f >> 2] | 0;
	                    c[e + 0 >> 2] = 0;
	                    c[e + 4 >> 2] = 0;
	                    c[e + 8 >> 2] = 0;
	                    c[e + 12 >> 2] = 0;
	                    c[e + 16 >> 2] = 0;
	                    c[e + 20 >> 2] = 0;
	                    c[e + 24 >> 2] = 0;
	                    c[e + 28 >> 2] = 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function YN(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1106, 191968, 0, 0);
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                do if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189824) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                    c[j >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[e >> 2] = -1;
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    } else {
	                        c[c[j >> 2] >> 2] = 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))break;
	                        zN(c[f >> 2] | 0, c[g >> 2] | 0, 1024, 191992, 0, 0);
	                        break
	                    }
	                } else m = 12; while (0);
	                do if ((m | 0) == 12) {
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189832) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[j >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            c[e >> 2] = -1;
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        } else {
	                            c[c[j >> 2] >> 2] = 1;
	                            if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1055, 192024, 0, 0);
	                            break
	                        }
	                    }
	                    c[j >> 2] = xO(c[f >> 2] | 0, c[g >> 2] | 0, 1) | 0
	                } while (0);
	                if (c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 12 >> 2] | 0) {
	                    c[k >> 2] = c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[(c[k >> 2] | 0) + 32 >> 2] | 0))break;
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                    }
	                    c[(c[k >> 2] | 0) + 32 >> 2] = c[j >> 2]
	                } else c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                if (c[g >> 2] | 0) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1105, 192064, 0, 0);
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else {
	                    c[e >> 2] = c[h >> 2];
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function ZN(a, d, e) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                a:while (1) {
	                    if (!((c[l >> 2] | 0) == 0 & (c[j >> 2] | 0) != 0)) {
	                        m = 13;
	                        break
	                    }
	                    do if ((c[c[j >> 2] >> 2] | 0) != 11 ? (c[c[j >> 2] >> 2] | 0) != 13 : 0) {
	                        e = c[h >> 2] | 0;
	                        d = c[(c[j >> 2] | 0) + 24 >> 2] | 0;
	                        a = c[k >> 2] | 0;
	                        if ((c[c[j >> 2] >> 2] | 0) == 4) {
	                            c[l >> 2] = ZN(e, d, a + 1 | 0) | 0;
	                            break
	                        } else {
	                            c[l >> 2] = ZN(e, d, a) | 0;
	                            break
	                        }
	                    } else m = 5; while (0);
	                    do if ((m | 0) == 5) {
	                        m = 0;
	                        a = c[k >> 2] | 0;
	                        if ((b[(c[j >> 2] | 0) + 48 >> 1] | 0) != -1)if ((a | 0) == (b[(c[j >> 2] | 0) + 48 >> 1] | 0)) {
	                            m = 8;
	                            break a
	                        } else break; else {
	                            b[(c[j >> 2] | 0) + 48 >> 1] = a;
	                            c[l >> 2] = ZN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[k >> 2] | 0) | 0;
	                            b[(c[j >> 2] | 0) + 48 >> 1] = -2;
	                            break
	                        }
	                    } while (0);
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                }
	                if ((m | 0) == 8) {
	                    zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1099, 191928, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[g >> 2] = -1;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                } else if ((m | 0) == 13) {
	                    c[g >> 2] = c[l >> 2];
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                return 0
	            }

	            function _N(a, d, e) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                a:while (1) {
	                    if (!(c[h >> 2] | 0)) {
	                        o = 87;
	                        break
	                    }
	                    b:do if ((c[c[h >> 2] >> 2] | 0) != 11 ? (c[c[h >> 2] >> 2] | 0) != 13 : 0) {
	                        if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[j >> 2];
	                            if (c[j >> 2] | 0) {
	                                if ((c[c[j >> 2] >> 2] | 0) == 9) {
	                                    o = 15;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 8) {
	                                    o = 15;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 18) {
	                                    o = 15;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 19) {
	                                    o = 15;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 16) {
	                                    o = 15;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 15) {
	                                    o = 15;
	                                    break a
	                                }
	                            }
	                            if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) == 17 : 0) {
	                                c[k >> 2] = yO(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                break
	                            }
	                            c[k >> 2] = c[h >> 2];
	                            break
	                        }
	                        e = (c[c[h >> 2] >> 2] | 0) == 0;
	                        c[(c[h >> 2] | 0) + 28 >> 2] = c[j >> 2];
	                        if (e) {
	                            if (c[j >> 2] | 0) {
	                                if ((c[c[j >> 2] >> 2] | 0) == 16) {
	                                    o = 24;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 15) {
	                                    o = 24;
	                                    break a
	                                }
	                            }
	                            do if (c[j >> 2] | 0) {
	                                if ((c[c[j >> 2] >> 2] | 0) != 18 ? (c[c[j >> 2] >> 2] | 0) != 19 : 0)break;
	                                c[k >> 2] = yO(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                break b
	                            } while (0);
	                            c[k >> 2] = c[h >> 2];
	                            break
	                        }
	                        if (c[(c[h >> 2] | 0) + 24 >> 2] | 0)_N(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0, c[h >> 2] | 0);
	                        if ((c[c[h >> 2] >> 2] | 0) != 7 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)_N(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 36 >> 2] | 0, c[h >> 2] | 0);
	                        if (c[(c[h >> 2] | 0) + 40 >> 2] | 0)_N(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0);
	                        c:do if ((c[c[h >> 2] >> 2] | 0) == 4) {
	                            while (1) {
	                                if (!(c[(c[h >> 2] | 0) + 24 >> 2] | 0))break;
	                                c[l >> 2] = zO(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                if ((c[l >> 2] | 0) != 1)break;
	                                c[m >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                c[(c[h >> 2] | 0) + 24 >> 2] = c[(c[m >> 2] | 0) + 32 >> 2];
	                                c[(c[m >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 36 >> 2];
	                                c[(c[h >> 2] | 0) + 36 >> 2] = c[m >> 2]
	                            }
	                            c[n >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[n >> 2] | 0))break c;
	                                if (!(c[(c[n >> 2] | 0) + 32 >> 2] | 0))break c;
	                                c[m >> 2] = c[(c[n >> 2] | 0) + 32 >> 2];
	                                c[l >> 2] = zO(c[g >> 2] | 0, c[m >> 2] | 0) | 0;
	                                e = c[m >> 2] | 0;
	                                if ((c[l >> 2] | 0) == 1) {
	                                    c[(c[n >> 2] | 0) + 32 >> 2] = c[e + 32 >> 2];
	                                    c[(c[m >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 36 >> 2];
	                                    c[(c[h >> 2] | 0) + 36 >> 2] = c[m >> 2];
	                                    continue
	                                } else {
	                                    c[n >> 2] = e;
	                                    continue
	                                }
	                            }
	                        } while (0);
	                        if (!((c[c[h >> 2] >> 2] | 0) != 18 ? (c[c[h >> 2] >> 2] | 0) != 19 : 0))o = 49;
	                        do if ((o | 0) == 49) {
	                            o = 0;
	                            e = c[h >> 2] | 0;
	                            if (!(c[(c[h >> 2] | 0) + 24 >> 2] | 0)) {
	                                c[e >> 2] = 0;
	                                break
	                            }
	                            if (!(c[(c[e + 24 >> 2] | 0) + 32 >> 2] | 0)) {
	                                if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) == 0) {
	                                    c[c[h >> 2] >> 2] = -1;
	                                    break
	                                }
	                                e = c[h >> 2] | 0;
	                                if (!(c[k >> 2] | 0)) {
	                                    c[(c[j >> 2] | 0) + 24 >> 2] = c[e + 24 >> 2];
	                                    c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                                    c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                    break
	                                } else {
	                                    c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 32 >> 2] = c[e + 32 >> 2];
	                                    c[(c[k >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                    c[h >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                                    break
	                                }
	                            }
	                        } while (0);
	                        if (((c[c[h >> 2] >> 2] | 0) == 2 ? (c[(c[h >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) ? (c[c[(c[h >> 2] | 0) + 24 >> 2] >> 2] | 0) == 1 : 0) {
	                            c[k >> 2] = yO(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                            break
	                        }
	                        if ((c[c[h >> 2] >> 2] | 0) == 1) {
	                            if (c[j >> 2] | 0) {
	                                if ((c[c[j >> 2] >> 2] | 0) == 9) {
	                                    o = 69;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 8) {
	                                    o = 69;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 18) {
	                                    o = 69;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 19) {
	                                    o = 69;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 16) {
	                                    o = 69;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 15) {
	                                    o = 69;
	                                    break a
	                                }
	                            }
	                            if ((c[j >> 2] | 0) != 0 ? (c[c[j >> 2] >> 2] | 0) == 17 : 0) {
	                                c[k >> 2] = yO(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                break
	                            }
	                            c[k >> 2] = c[h >> 2];
	                            break
	                        } else {
	                            if (c[c[h >> 2] >> 2] | 0) {
	                                c[k >> 2] = c[h >> 2];
	                                break
	                            }
	                            if (c[j >> 2] | 0) {
	                                if ((c[c[j >> 2] >> 2] | 0) == 16) {
	                                    o = 78;
	                                    break a
	                                }
	                                if ((c[c[j >> 2] >> 2] | 0) == 15) {
	                                    o = 78;
	                                    break a
	                                }
	                            }
	                            d:do if (c[j >> 2] | 0) {
	                                do if ((c[c[j >> 2] >> 2] | 0) != 18) {
	                                    if ((c[c[j >> 2] >> 2] | 0) == 19)break;
	                                    if ((c[c[j >> 2] >> 2] | 0) != 17)break d
	                                } while (0);
	                                c[k >> 2] = yO(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                                break b
	                            } while (0);
	                            c[k >> 2] = c[h >> 2];
	                            break
	                        }
	                    } else o = 5; while (0);
	                    if ((o | 0) == 5 ? (o = 0, (b[(c[h >> 2] | 0) + 48 >> 1] | 0) != -3) : 0) {
	                        b[(c[h >> 2] | 0) + 48 >> 1] = -3;
	                        _N(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0, c[h >> 2] | 0)
	                    }
	                    c[h >> 2] = c[(c[h >> 2] | 0) + 32 >> 2]
	                }
	                if ((o | 0) == 15) {
	                    c[c[j >> 2] >> 2] = 1;
	                    i = f;
	                    return
	                } else if ((o | 0) == 24) {
	                    c[c[j >> 2] >> 2] = 0;
	                    i = f;
	                    return
	                } else if ((o | 0) == 69) {
	                    c[c[j >> 2] >> 2] = 1;
	                    i = f;
	                    return
	                } else if ((o | 0) == 78) {
	                    c[c[j >> 2] >> 2] = 0;
	                    i = f;
	                    return
	                } else if ((o | 0) == 87) {
	                    i = f;
	                    return
	                }
	            }

	            function $N(a, d, e, f) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 4 | 0;
	                p = g;
	                c[h >> 2] = a;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[p >> 2] = 0;
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    c[n >> 2] = 0;
	                    do if ((c[c[j >> 2] >> 2] | 0) != 11 ? (c[c[j >> 2] >> 2] | 0) != 13 : 0) {
	                        if ((c[c[j >> 2] >> 2] | 0) == 4) {
	                            AO(c[h >> 2] | 0, c[j >> 2] | 0);
	                            if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1070, 190416, 0, 0);
	                            if (c[k >> 2] & 4)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1079, 190472, 0, 0);
	                            if (c[k >> 2] & 1)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1068, 190520, 0, 0);
	                            if (c[k >> 2] & 1)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1068, 190520, 0, 0);
	                            c[m >> 2] = 0;
	                            c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                            if (c[n >> 2] | 0)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1015, 190576, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                            c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                            if ((c[n >> 2] | 0) == -1) {
	                                zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1016, 190632, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0);
	                                break
	                            } else {
	                                c[n >> 2] = 2;
	                                break
	                            }
	                        }
	                        if ((c[c[j >> 2] >> 2] | 0) == 9) {
	                            if (c[k >> 2] & 1)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1067, 190672, 0, 0);
	                            if (c[k >> 2] & 4)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1078, 190720, 0, 0);
	                            if (c[k >> 2] & 32)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1086, 190768, 0, 0);
	                            if (c[k >> 2] & 64)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1087, 190824, 0, 0);
	                            if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1069, 190888, 0, 0);
	                            if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1088, 190936, 0, 0);
	                            do if ((c[k >> 2] & 2 | 0) == 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                                f = c[h >> 2] | 0;
	                                e = c[(c[j >> 2] | 0) + 4 >> 2] | 0;
	                                if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0)) {
	                                    zN(f, e, 1e3, 190984, 0, 0);
	                                    break
	                                } else {
	                                    zN(f, e, 1056, 191040, 0, 0);
	                                    break
	                                }
	                            } while (0);
	                            c[m >> 2] = c[k >> 2] | 1;
	                            $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                            c[n >> 2] = 0;
	                            break
	                        }
	                        if ((c[c[j >> 2] >> 2] | 0) != 16 ? (c[c[j >> 2] >> 2] | 0) != 15 : 0) {
	                            if ((c[c[j >> 2] >> 2] | 0) == 8) {
	                                if (c[k >> 2] & 4)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1081, 191192, 0, 0);
	                                if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1074, 191232, 0, 0);
	                                if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1093, 191280, 0, 0);
	                                c[m >> 2] = c[k >> 2] | 4;
	                                c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                break
	                            }
	                            if ((c[c[j >> 2] >> 2] | 0) == 18) {
	                                if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1072, 191320, 0, 0);
	                                if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1091, 191368, 0, 0);
	                                e = c[k >> 2] | 0;
	                                if (c[k >> 2] & 2)c[m >> 2] = e | 32; else c[m >> 2] = e;
	                                c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                AO(c[h >> 2] | 0, c[j >> 2] | 0);
	                                break
	                            }
	                            if ((c[c[j >> 2] >> 2] | 0) == 19) {
	                                if (c[k >> 2] & 4)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1080, 191408, 0, 0);
	                                if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1073, 191456, 0, 0);
	                                if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1073, 191512, 0, 0);
	                                e = c[k >> 2] | 0;
	                                if (c[k >> 2] & 2)c[m >> 2] = e | 64; else c[m >> 2] = e;
	                                c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                break
	                            }
	                            e = c[j >> 2] | 0;
	                            if ((c[c[j >> 2] >> 2] | 0) == 2) {
	                                if ((c[e + 28 >> 2] | 0) != 0 ? (c[c[(c[j >> 2] | 0) + 28 >> 2] >> 2] | 0) == 5 : 0)c[m >> 2] = c[k >> 2] | 8; else c[m >> 2] = c[k >> 2];
	                                c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                break
	                            }
	                            if ((c[e >> 2] | 0) == 5) {
	                                if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1089, 191560, 0, 0);
	                                $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[k >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                c[n >> 2] = 1;
	                                break
	                            }
	                            if ((c[c[j >> 2] >> 2] | 0) == 7) {
	                                if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1096, 191600, 0, 0);
	                                $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[k >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                c[n >> 2] = 1;
	                                break
	                            }
	                            if ((c[c[j >> 2] >> 2] | 0) == 3) {
	                                if (c[k >> 2] & 4)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1083, 191640, 0, 0);
	                                if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1077, 191680, 0, 0);
	                                if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1095, 191728, 0, 0);
	                                c[n >> 2] = 2;
	                                break
	                            }
	                            if (c[c[j >> 2] >> 2] | 0) {
	                                e = c[h >> 2] | 0;
	                                f = c[j >> 2] | 0;
	                                if ((c[c[j >> 2] >> 2] | 0) == 17) {
	                                    CO(e, f);
	                                    c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[k >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                    break
	                                } else {
	                                    c[n >> 2] = $N(e, c[f + 24 >> 2] | 0, c[k >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                                    break
	                                }
	                            }
	                            if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1071, 191768, 0, 0);
	                            if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1090, 191816, 0, 0);
	                            c[n >> 2] = 0;
	                            break
	                        }
	                        if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1075, 191096, 0, 0);
	                        if (c[k >> 2] & 16)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1094, 191144, 0, 0);
	                        c[m >> 2] = c[k >> 2] | 2;
	                        c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[m >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                        c[n >> 2] = BO(c[n >> 2] | 0, c[n >> 2] | 0) | 0
	                    } else q = 5; while (0);
	                    do if ((q | 0) == 5) {
	                        q = 0;
	                        if (c[k >> 2] & 8)zN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0, 1076, 190272, 0, 0);
	                        do if (!(c[(c[j >> 2] | 0) + 24 >> 2] | 0)) {
	                            f = c[h >> 2] | 0;
	                            e = c[(c[j >> 2] | 0) + 4 >> 2] | 0;
	                            if ((c[c[j >> 2] >> 2] | 0) == 13) {
	                                zN(f, e, 1101, 190320, 0, 0);
	                                break
	                            }
	                            if (c[(c[j >> 2] | 0) + 8 >> 2] | 0)r = c[(c[j >> 2] | 0) + 8 >> 2] | 0; else r = 190408;
	                            zN(f, e, 1101, 190368, r, 0)
	                        } while (0);
	                        e = (c[j >> 2] | 0) + 48 | 0;
	                        if ((b[(c[j >> 2] | 0) + 48 >> 1] | 0) > -4) {
	                            b[e >> 1] = -4;
	                            c[n >> 2] = $N(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[k >> 2] | 0, c[c[j >> 2] >> 2] | 0) | 0;
	                            b[(c[j >> 2] | 0) + 48 >> 1] = (c[n >> 2] | 0) - 15;
	                            break
	                        }
	                        if ((b[e >> 1] | 0) == -4) {
	                            c[n >> 2] = 2;
	                            break
	                        } else {
	                            c[n >> 2] = (b[(c[j >> 2] | 0) + 48 >> 1] | 0) + 15;
	                            break
	                        }
	                    } while (0);
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                    if ((c[l >> 2] | 0) == 18) {
	                        c[p >> 2] = BO(c[p >> 2] | 0, c[n >> 2] | 0) | 0;
	                        continue
	                    }
	                    if ((c[l >> 2] | 0) == 19) {
	                        c[o >> 2] = BO(c[p >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if ((c[o >> 2] | 0) == -1)continue;
	                        c[o >> 2] = DO(c[p >> 2] | 0, c[n >> 2] | 0) | 0;
	                        continue
	                    }
	                    if ((c[l >> 2] | 0) == 17) {
	                        c[p >> 2] = DO(c[p >> 2] | 0, c[n >> 2] | 0) | 0;
	                        continue
	                    }
	                    if ((c[l >> 2] | 0) == 8) {
	                        c[p >> 2] = 1;
	                        continue
	                    }
	                    if ((c[l >> 2] | 0) != 2) {
	                        c[p >> 2] = BO(c[p >> 2] | 0, c[n >> 2] | 0) | 0;
	                        continue
	                    }
	                    if ((c[n >> 2] | 0) == -1) {
	                        c[p >> 2] = -1;
	                        continue
	                    } else {
	                        c[p >> 2] = 1;
	                        continue
	                    }
	                }
	                i = g;
	                return c[p >> 2] | 0
	            }

	            function aO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 40 | 0;
	                g = e + 36 | 0;
	                h = e + 32 | 0;
	                j = e + 28 | 0;
	                k = e + 24 | 0;
	                l = e + 20 | 0;
	                m = e + 16 | 0;
	                n = e + 12 | 0;
	                o = e + 8 | 0;
	                p = e + 4 | 0;
	                q = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                c[l >> 2] = 0;
	                c[m >> 2] = c[h >> 2];
	                a:while (1) {
	                    if (!(c[m >> 2] | 0)) {
	                        s = 41;
	                        break
	                    }
	                    if (!(c[j >> 2] | 0))if ((c[c[m >> 2] >> 2] | 0) != 4 ? (c[c[m >> 2] >> 2] | 0) != 3 : 0)s = 8; else s = 10; else s = 8;
	                    do if ((s | 0) == 8) {
	                        s = 0;
	                        if ((c[j >> 2] | 0) == 1 ? (c[c[m >> 2] >> 2] | 0) == 9 : 0) {
	                            s = 10;
	                            break
	                        }
	                        if ((((((((((c[c[m >> 2] >> 2] | 0) != 17 ? (c[c[m >> 2] >> 2] | 0) != 19 : 0) ? (c[c[m >> 2] >> 2] | 0) != 18 : 0) ? (c[c[m >> 2] >> 2] | 0) != 16 : 0) ? (c[c[m >> 2] >> 2] | 0) != 15 : 0) ? (c[c[m >> 2] >> 2] | 0) != 14 : 0) ? (c[c[m >> 2] >> 2] | 0) != 13 : 0) ? (c[c[m >> 2] >> 2] | 0) != 11 : 0) ? (c[c[m >> 2] >> 2] | 0) != 10 : 0) ? (c[c[m >> 2] >> 2] | 0) != 12 : 0)break;
	                        if (c[(c[m >> 2] | 0) + 24 >> 2] | 0) {
	                            c[l >> 2] = c[m >> 2];
	                            c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2];
	                            c[n >> 2] = c[m >> 2];
	                            while (1) {
	                                if (!(c[n >> 2] | 0))continue a;
	                                c[(c[n >> 2] | 0) + 28 >> 2] = c[l >> 2];
	                                c[n >> 2] = c[(c[n >> 2] | 0) + 32 >> 2]
	                            }
	                        }
	                    } while (0);
	                    if ((s | 0) == 10) {
	                        s = 0;
	                        if (!(c[k >> 2] | 0)) {
	                            c[p >> 2] = 10;
	                            c[k >> 2] = Cb[c[135744 >> 2] & 511]((c[p >> 2] | 0) + 1 << 2) | 0;
	                            if (!(c[k >> 2] | 0)) {
	                                s = 12;
	                                break
	                            }
	                        } else if ((c[p >> 2] | 0) <= (c[o >> 2] | 0)) {
	                            c[p >> 2] = c[p >> 2] << 1;
	                            c[q >> 2] = Hb[c[135760 >> 2] & 511](c[k >> 2] | 0, (c[p >> 2] | 0) + 1 << 2) | 0;
	                            if (!(c[q >> 2] | 0)) {
	                                s = 15;
	                                break
	                            }
	                            c[k >> 2] = c[q >> 2]
	                        }
	                        d = c[m >> 2] | 0;
	                        b = c[o >> 2] | 0;
	                        c[o >> 2] = b + 1;
	                        c[(c[k >> 2] | 0) + (b << 2) >> 2] = d;
	                        c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2] = 0
	                    }
	                    if ((c[m >> 2] | 0) == (c[h >> 2] | 0)) {
	                        s = 41;
	                        break
	                    }
	                    if (c[(c[m >> 2] | 0) + 32 >> 2] | 0) {
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 32 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 28 >> 2];
	                        if (!(c[m >> 2] | 0))continue a;
	                        if ((c[m >> 2] | 0) == (c[h >> 2] | 0)) {
	                            s = 37;
	                            break a
	                        }
	                        t = c[m >> 2] | 0;
	                        if (c[(c[m >> 2] | 0) + 32 >> 2] | 0)break;
	                        if (!t)continue a
	                    }
	                    c[m >> 2] = c[t + 32 >> 2]
	                }
	                if ((s | 0) == 12) {
	                    xN(c[g >> 2] | 0, 190240);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((s | 0) == 15) {
	                    xN(c[g >> 2] | 0, 190240);
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[f >> 2] = 0;
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((s | 0) == 37) {
	                    c[f >> 2] = c[k >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                } else if ((s | 0) == 41) {
	                    c[f >> 2] = c[k >> 2];
	                    r = c[f >> 2] | 0;
	                    i = e;
	                    return r | 0
	                }
	                return 0
	            }

	            function bO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[e + 12 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[h >> 2];
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 1;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if ((c[c[g >> 2] >> 2] | 0) != 0 ? (c[c[h >> 2] >> 2] | 0) != 0 : 0) {
	                    a:while (1) {
	                        if (!(c[c[g >> 2] >> 2] | 0)) {
	                            l = 12;
	                            break
	                        }
	                        while (1) {
	                            if (!(c[c[h >> 2] >> 2] | 0))break;
	                            if (!(EO(c[c[g >> 2] >> 2] | 0, c[c[h >> 2] >> 2] | 0) | 0)) {
	                                l = 9;
	                                break a
	                            }
	                            c[h >> 2] = (c[h >> 2] | 0) + 4
	                        }
	                        c[h >> 2] = c[j >> 2];
	                        c[g >> 2] = (c[g >> 2] | 0) + 4
	                    }
	                    if ((l | 0) == 9) {
	                        c[f >> 2] = 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } else if ((l | 0) == 12) {
	                        c[f >> 2] = 1;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                }
	                c[f >> 2] = 1;
	                k = c[f >> 2] | 0;
	                i = e;
	                return k | 0
	            }

	            function cO(a) {
	                a = a | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = -1;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if ((c[c[f >> 2] >> 2] | 0) != 4 ? (b[(c[f >> 2] | 0) + 50 >> 1] & 64 | 0) != 0 : 0) {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                if ((c[c[f >> 2] >> 2] | 0) != 4 ? (b[(c[f >> 2] | 0) + 50 >> 1] & 128 | 0) != 0 : 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                a:do switch (c[c[f >> 2] >> 2] | 0) {
	                    case 1:
	                    case 7:
	                    case 6:
	                    case 8:
	                    case 5:
	                    case 19:
	                    case 9:
	                    case 2:
	                    {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    case 13:
	                    case 12:
	                    case 11:
	                    {
	                        if ((b[(c[f >> 2] | 0) + 48 >> 1] | 0) == -20) {
	                            c[e >> 2] = 1;
	                            l = c[e >> 2] | 0;
	                            i = d;
	                            return l | 0
	                        }
	                        b[(c[f >> 2] | 0) + 48 >> 1] = -20;
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[j >> 2] | 0))break a;
	                            c[g >> 2] = cO(c[j >> 2] | 0) | 0;
	                            if ((c[g >> 2] | 0) != 1)break a;
	                            c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                        }
	                        break
	                    }
	                    case 4:
	                    {
	                        if ((b[(c[f >> 2] | 0) + 50 >> 1] & 128 | 0) == 0 ? (b[(c[f >> 2] | 0) + 50 >> 1] & 64 | 0) == 0 : 0) {
	                            c[h >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[h >> 2] | 0))break;
	                                c[g >> 2] = cO(c[h >> 2] | 0) | 0;
	                                if ((c[g >> 2] | 0) != 1)break;
	                                c[h >> 2] = c[(c[h >> 2] | 0) + 32 >> 2]
	                            }
	                            if (!(c[g >> 2] | 0)) {
	                                a = (c[f >> 2] | 0) + 50 | 0;
	                                b[a >> 1] = b[a >> 1] & -65;
	                                a = (c[f >> 2] | 0) + 50 | 0;
	                                b[a >> 1] = b[a >> 1] | 128
	                            }
	                            if ((c[g >> 2] | 0) == 1 ? (a = (c[f >> 2] | 0) + 50 | 0, m = b[a >> 1] & 128, b[a >> 1] = m, m << 16 >> 16 == 0) : 0) {
	                                m = (c[f >> 2] | 0) + 50 | 0;
	                                b[m >> 1] = b[m >> 1] | 64
	                            }
	                        }
	                        if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0)c[g >> 2] = 1; else c[g >> 2] = 0;
	                        c[e >> 2] = c[g >> 2];
	                        l = c[e >> 2] | 0;
	                        i = d;
	                        return l | 0
	                    }
	                    case 10:
	                    case 18:
	                    case 17:
	                    case 16:
	                    case 15:
	                    case 14:
	                    case 20:
	                    {
	                        c[k >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break a;
	                            c[g >> 2] = cO(c[k >> 2] | 0) | 0;
	                            if ((c[g >> 2] | 0) != 1)break a;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                        }
	                        break
	                    }
	                    case -1:
	                    {
	                        c[g >> 2] = cO(c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 0:
	                    case 3:
	                    {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                if (!(c[g >> 2] | 0)) {
	                    k = (c[f >> 2] | 0) + 50 | 0;
	                    b[k >> 1] = b[k >> 1] | 128
	                }
	                if ((c[g >> 2] | 0) == 1) {
	                    k = (c[f >> 2] | 0) + 50 | 0;
	                    b[k >> 1] = b[k >> 1] | 64
	                }
	                c[e >> 2] = c[g >> 2];
	                l = c[e >> 2] | 0;
	                i = d;
	                return l | 0
	            }

	            function dO(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
	                e = i;
	                i = i + 80 | 0;
	                f = e;
	                g = e + 64 | 0;
	                h = e + 60 | 0;
	                j = e + 56 | 0;
	                k = e + 52 | 0;
	                l = e + 48 | 0;
	                m = e + 44 | 0;
	                n = e + 40 | 0;
	                p = e + 36 | 0;
	                q = e + 32 | 0;
	                r = e + 28 | 0;
	                s = e + 24 | 0;
	                t = e + 20 | 0;
	                u = e + 16 | 0;
	                v = e + 12 | 0;
	                w = e + 8 | 0;
	                x = e + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[g >> 2] = -1;
	                    y = c[g >> 2] | 0;
	                    i = e;
	                    return y | 0
	                }
	                a:do switch (c[c[j >> 2] >> 2] | 0) {
	                    case -1:
	                    {
	                        c[k >> 2] = dO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[s >> 2] = c[(c[h >> 2] | 0) + 136 >> 2];
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            z = c[h >> 2] | 0;
	                            if (!(c[l >> 2] | 0))break;
	                            dO(z, c[l >> 2] | 0) | 0;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                        }
	                        Jz(c[z + 132 >> 2] | 0, c[s >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[v >> 2] = 0;
	                        c[w >> 2] = c[(c[h >> 2] | 0) + 136 >> 2];
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break;
	                            c[(c[h >> 2] | 0) + 136 >> 2] = c[w >> 2];
	                            c[k >> 2] = dO(c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                            if (c[k >> 2] | 0)break;
	                            d = c[h >> 2] | 0;
	                            if (!(c[v >> 2] | 0))c[v >> 2] = c[d + 136 >> 2]; else Jz(c[d + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, c[v >> 2] | 0) | 0;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                        }
	                        c[(c[h >> 2] | 0) + 136 >> 2] = c[v >> 2];
	                        break
	                    }
	                    case 20:
	                    {
	                        if ((cO(c[j >> 2] | 0) | 0) == 1 ? (b[(c[j >> 2] | 0) + 48 >> 1] | 0) != -25 : 0) {
	                            c[m >> 2] = c[(c[h >> 2] | 0) + 132 >> 2];
	                            c[n >> 2] = c[(c[h >> 2] | 0) + 136 >> 2];
	                            b[(c[j >> 2] | 0) + 48 >> 1] = -25;
	                            c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                            d = xz() | 0;
	                            c[(c[h >> 2] | 0) + 132 >> 2] = d;
	                            if (!(c[(c[h >> 2] | 0) + 132 >> 2] | 0)) {
	                                c[g >> 2] = -1;
	                                y = c[g >> 2] | 0;
	                                i = e;
	                                return y | 0
	                            }
	                            Az(c[(c[h >> 2] | 0) + 132 >> 2] | 0, 1);
	                            d = Bz(c[(c[h >> 2] | 0) + 132 >> 2] | 0) | 0;
	                            c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                            while (1) {
	                                A = c[h >> 2] | 0;
	                                if (!(c[l >> 2] | 0))break;
	                                dO(A, c[l >> 2] | 0) | 0;
	                                c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                            }
	                            Cz(c[A + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0) | 0;
	                            if (Pz(c[(c[h >> 2] | 0) + 132 >> 2] | 0) | 0) {
	                                d = Oz(c[(c[h >> 2] | 0) + 132 >> 2] | 0) | 0;
	                                c[(c[j >> 2] | 0) + 52 >> 2] = d
	                            }
	                            yz(c[(c[h >> 2] | 0) + 132 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 136 >> 2] = c[n >> 2];
	                            c[(c[h >> 2] | 0) + 132 >> 2] = c[m >> 2]
	                        }
	                        break
	                    }
	                    case 3:
	                    {
	                        d = Jz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                        c[x >> 2] = c[(c[h >> 2] | 0) + 136 >> 2];
	                        dO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        Dz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, 188096, 0) | 0;
	                        d = Jz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[x >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                        break
	                    }
	                    case 10:
	                    case 18:
	                    case 13:
	                    case 12:
	                    case 11:
	                    {
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break a;
	                            c[k >> 2] = dO(c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                            if (c[k >> 2] | 0)break a;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                        }
	                        break
	                    }
	                    case 0:
	                    {
	                        d = Jz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                        break
	                    }
	                    case 4:
	                    {
	                        if ((c[(c[h >> 2] | 0) + 132 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                            d = Ez(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[j >> 2] | 0) | 0;
	                            c[(c[h >> 2] | 0) + 136 >> 2] = d
	                        }
	                        if ((b[(c[j >> 2] | 0) + 50 >> 1] & 64 | 0) != 0 ? (b[(c[j >> 2] | 0) + 48 >> 1] | 0) != -25 : 0) {
	                            c[p >> 2] = c[(c[h >> 2] | 0) + 132 >> 2];
	                            c[q >> 2] = c[(c[h >> 2] | 0) + 136 >> 2];
	                            b[(c[j >> 2] | 0) + 48 >> 1] = -25;
	                            c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                            d = xz() | 0;
	                            c[(c[h >> 2] | 0) + 132 >> 2] = d;
	                            if (!(c[(c[h >> 2] | 0) + 132 >> 2] | 0)) {
	                                c[g >> 2] = -1;
	                                y = c[g >> 2] | 0;
	                                i = e;
	                                return y | 0
	                            }
	                            Az(c[(c[h >> 2] | 0) + 132 >> 2] | 0, 1);
	                            d = Bz(c[(c[h >> 2] | 0) + 132 >> 2] | 0) | 0;
	                            c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                            while (1) {
	                                B = c[h >> 2] | 0;
	                                if (!(c[l >> 2] | 0))break;
	                                dO(B, c[l >> 2] | 0) | 0;
	                                c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                            }
	                            Cz(c[B + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0) | 0;
	                            d = Oz(c[(c[h >> 2] | 0) + 132 >> 2] | 0) | 0;
	                            c[(c[j >> 2] | 0) + 52 >> 2] = d;
	                            if (!(wz(c[(c[j >> 2] | 0) + 52 >> 2] | 0) | 0)) {
	                                zz(c[(c[j >> 2] | 0) + 52 >> 2] | 0);
	                                c[(c[j >> 2] | 0) + 52 >> 2] = 0
	                            }
	                            yz(c[(c[h >> 2] | 0) + 132 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 136 >> 2] = c[q >> 2];
	                            c[(c[h >> 2] | 0) + 132 >> 2] = c[p >> 2];
	                            break a
	                        }
	                        c[r >> 2] = c[(c[h >> 2] | 0) + 132 >> 2];
	                        c[k >> 2] = EN(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[h >> 2] | 0) + 132 >> 2] = c[r >> 2];
	                        break
	                    }
	                    case 7:
	                    case 6:
	                    case 8:
	                    case 5:
	                    case 1:
	                    case 19:
	                    case 9:
	                    case 2:
	                    {
	                        d = c[o >> 2] | 0;
	                        c[f >> 2] = FO(c[j >> 2] | 0) | 0;
	                        Ka(d | 0, 189768, f | 0) | 0;
	                        break
	                    }
	                    case 15:
	                    {
	                        d = Jz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                        c[t >> 2] = c[(c[h >> 2] | 0) + 136 >> 2];
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            C = c[h >> 2] | 0;
	                            if (!(c[l >> 2] | 0))break;
	                            dO(C, c[l >> 2] | 0) | 0;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                        }
	                        Jz(c[C + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, c[t >> 2] | 0) | 0;
	                        d = Jz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[t >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            D = c[h >> 2] | 0;
	                            if (!(c[l >> 2] | 0))break;
	                            dO(D, c[l >> 2] | 0) | 0;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                        }
	                        c[u >> 2] = c[D + 136 >> 2];
	                        c[l >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            E = c[h >> 2] | 0;
	                            if (!(c[l >> 2] | 0))break;
	                            dO(E, c[l >> 2] | 0) | 0;
	                            c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                        }
	                        Jz(c[E + 132 >> 2] | 0, c[(c[h >> 2] | 0) + 136 >> 2] | 0, c[u >> 2] | 0) | 0;
	                        d = Jz(c[(c[h >> 2] | 0) + 132 >> 2] | 0, c[u >> 2] | 0, 0) | 0;
	                        c[(c[h >> 2] | 0) + 136 >> 2] = d;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                c[g >> 2] = c[k >> 2];
	                y = c[g >> 2] | 0;
	                i = e;
	                return y | 0
	            }

	            function eO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 20 | 0;
	                e = b + 16 | 0;
	                f = b + 12 | 0;
	                g = b + 8 | 0;
	                h = b + 4 | 0;
	                j = b;
	                c[d >> 2] = a;
	                c[e >> 2] = 0;
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[e >> 2] | 0) >= (c[(c[d >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[h >> 2] = (c[(c[d >> 2] | 0) + 56 >> 2] | 0) + ((c[e >> 2] | 0) * 24 | 0);
	                    a:do if ((c[g >> 2] | 0) < 5) {
	                        c[f >> 2] = 0;
	                        while (1) {
	                            if ((c[f >> 2] | 0) >= (c[e >> 2] | 0))break;
	                            c[j >> 2] = (c[(c[d >> 2] | 0) + 56 >> 2] | 0) + ((c[f >> 2] | 0) * 24 | 0);
	                            if ((((c[c[h >> 2] >> 2] | 0) == (c[c[j >> 2] >> 2] | 0) ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) == (c[(c[j >> 2] | 0) + 8 >> 2] | 0) : 0) ? (qy(c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[(c[j >> 2] | 0) + 16 >> 2] | 0) | 0) != 0 : 0) ? (qy(c[(c[h >> 2] | 0) + 20 >> 2] | 0, c[(c[j >> 2] | 0) + 20 >> 2] | 0) | 0) != 0 : 0)break a;
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        fO(c[d >> 2] | 0, c[c[h >> 2] >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    } while (0);
	                    if (c[(c[h >> 2] | 0) + 4 >> 2] & 1) {
	                        if (c[(c[h >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 16 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 16 >> 2] = 0;
	                        if (c[(c[h >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 20 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 20 >> 2] = 0;
	                        c[(c[h >> 2] | 0) + 4 >> 2] = 0
	                    }
	                    c[e >> 2] = (c[e >> 2] | 0) + 1
	                }
	                c[(c[d >> 2] | 0) + 48 >> 2] = 0;
	                i = b;
	                return
	            }

	            function fO(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                if (c[(c[j >> 2] | 0) + 28 >> 2] & 8) {
	                    i = h;
	                    return
	                }
	                c[p >> 2] = GO(c[k >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if (!(c[(c[j >> 2] | 0) + 40 >> 2] | 0))c[(c[j >> 2] | 0) + 40 >> 2] = c[k >> 2];
	                HO(c[j >> 2] | 0, (c[m >> 2] | 0) == 0 ? c[l >> 2] | 0 : c[m >> 2] | 0, c[k >> 2] | 0, c[p >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                i = h;
	                return
	            }

	            function gO(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                do if (!(c[(c[j >> 2] | 0) + 56 >> 2] | 0)) {
	                    c[(c[j >> 2] | 0) + 52 >> 2] = 8;
	                    c[(c[j >> 2] | 0) + 48 >> 2] = 0;
	                    f = Cb[c[135744 >> 2] & 511]((c[(c[j >> 2] | 0) + 52 >> 2] | 0) * 24 | 0) | 0;
	                    c[(c[j >> 2] | 0) + 56 >> 2] = f;
	                    f = c[j >> 2] | 0;
	                    if (c[(c[j >> 2] | 0) + 56 >> 2] | 0) {
	                        c[f + 44 >> 2] = 0;
	                        break
	                    }
	                    MN(f, 189752);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } while (0);
	                do if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) >= (c[(c[j >> 2] | 0) + 52 >> 2] | 0)) {
	                    f = (c[j >> 2] | 0) + 52 | 0;
	                    c[f >> 2] = c[f >> 2] << 1;
	                    f = Hb[c[135760 >> 2] & 511](c[(c[j >> 2] | 0) + 56 >> 2] | 0, (c[(c[j >> 2] | 0) + 52 >> 2] | 0) * 24 | 0) | 0;
	                    c[(c[j >> 2] | 0) + 56 >> 2] = f;
	                    f = c[j >> 2] | 0;
	                    if (c[(c[j >> 2] | 0) + 56 >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 44 >> 2] = (c[(c[j >> 2] | 0) + 56 >> 2] | 0) + (((c[f + 48 >> 2] | 0) - 1 | 0) * 24 | 0);
	                        break
	                    }
	                    MN(f, 189752);
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } while (0);
	                if ((((c[(c[j >> 2] | 0) + 44 >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0) == (c[c[(c[j >> 2] | 0) + 60 >> 2] >> 2] | 0) : 0) ? (c[c[(c[j >> 2] | 0) + 44 >> 2] >> 2] | 0) == (c[k >> 2] | 0) : 0) {
	                    c[h >> 2] = c[(c[j >> 2] | 0) + 48 >> 2];
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                }
	                c[o >> 2] = (c[(c[j >> 2] | 0) + 56 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) * 24 | 0);
	                c[c[o >> 2] >> 2] = c[k >> 2];
	                k = c[l >> 2] | 0;
	                if (c[n >> 2] | 0) {
	                    n = my(k) | 0;
	                    c[(c[o >> 2] | 0) + 16 >> 2] = n;
	                    n = my(c[m >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 20 >> 2] = n;
	                    c[(c[o >> 2] | 0) + 4 >> 2] = 1
	                } else {
	                    c[(c[o >> 2] | 0) + 16 >> 2] = k;
	                    c[(c[o >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                    c[(c[o >> 2] | 0) + 4 >> 2] = 0
	                }
	                if (c[(c[j >> 2] | 0) + 60 >> 2] | 0) {
	                    c[(c[o >> 2] | 0) + 8 >> 2] = c[c[(c[j >> 2] | 0) + 60 >> 2] >> 2];
	                    c[(c[o >> 2] | 0) + 12 >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2]
	                } else {
	                    c[(c[o >> 2] | 0) + 8 >> 2] = 0;
	                    c[(c[o >> 2] | 0) + 12 >> 2] = 0
	                }
	                c[(c[j >> 2] | 0) + 44 >> 2] = c[o >> 2];
	                o = (c[j >> 2] | 0) + 48 | 0;
	                j = c[o >> 2] | 0;
	                c[o >> 2] = j + 1;
	                c[h >> 2] = j;
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function hO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = c[g >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    if ((c[c[l >> 2] >> 2] | 0) == 9) {
	                        if (IO(c[f >> 2] | 0, c[l >> 2] | 0) | 0)c[h >> 2] = -1
	                    } else c[k >> 2] = 1;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                }
	                if (!(c[k >> 2] | 0)) {
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[l >> 2] = c[g >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0)) {
	                        n = 20;
	                        break
	                    }
	                    if ((c[c[l >> 2] >> 2] | 0) != 9) {
	                        if ((c[(c[f >> 2] | 0) + 60 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 64 >> 2] | 0) == 0 : 0) {
	                            n = 17;
	                            break
	                        }
	                        c[j >> 2] = KN(c[f >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[j >> 2] | 0) < 0)c[h >> 2] = -1;
	                        if ((c[j >> 2] | 0) == -1) {
	                            n = 20;
	                            break
	                        }
	                    }
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 32 >> 2]
	                }
	                if ((n | 0) == 17) {
	                    FN(c[f >> 2] | 0, 6, 0, 0, 0);
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } else if ((n | 0) == 20) {
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                return 0
	            }

	            function iO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = c[(c[f >> 2] | 0) + 60 >> 2];
	                if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 0 ? (b = oO(c[f >> 2] | 0, c[(c[j >> 2] | 0) + 4 >> 2] | 0) | 0, c[(c[j >> 2] | 0) + 4 >> 2] = b, (c[(c[j >> 2] | 0) + 4 >> 2] | 0) != 0) : 0) {
	                    if (c[g >> 2] | 0)FN(c[f >> 2] | 0, 26, c[(c[c[j >> 2] >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[j >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    if ((c[h >> 2] | 0) >= (c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                        l = 13;
	                        break
	                    }
	                    if (c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0)break;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                if ((l | 0) == 13) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (c[g >> 2] | 0)FN(c[f >> 2] | 0, 27, c[(c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + (c[h >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0, c[(c[c[j >> 2] >> 2] | 0) + 8 >> 2] | 0, 0);
	                c[e >> 2] = -1 - (c[h >> 2] | 0);
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function jO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[d >> 2] | 0) + 64 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[c[(c[d >> 2] | 0) + 64 >> 2] >> 2] | 0) <= 0) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = JO(c[d >> 2] | 0) | 0;
	                if ((c[e >> 2] | 0) < 0) {
	                    i = b;
	                    return
	                }
	                if ((c[e >> 2] | 0) >= (c[c[(c[d >> 2] | 0) + 64 >> 2] >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[d >> 2] | 0) + 60 >> 2] = c[(c[(c[(c[d >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[e >> 2] << 2) >> 2];
	                iO(c[d >> 2] | 0, 1) | 0;
	                i = b;
	                return
	            }

	            function kO(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0;
	                e = i;
	                i = i + 144 | 0;
	                f = e;
	                g = e + 136 | 0;
	                h = e + 132 | 0;
	                j = e + 128 | 0;
	                k = e + 124 | 0;
	                l = e + 120 | 0;
	                m = e + 116 | 0;
	                n = e + 112 | 0;
	                o = e + 108 | 0;
	                p = e + 104 | 0;
	                q = e + 100 | 0;
	                r = e + 96 | 0;
	                s = e + 92 | 0;
	                t = e + 88 | 0;
	                u = e + 84 | 0;
	                v = e + 80 | 0;
	                w = e + 76 | 0;
	                x = e + 72 | 0;
	                y = e + 68 | 0;
	                z = e + 64 | 0;
	                A = e + 60 | 0;
	                B = e + 56 | 0;
	                C = e + 52 | 0;
	                D = e + 48 | 0;
	                E = e + 44 | 0;
	                F = e + 40 | 0;
	                G = e + 36 | 0;
	                H = e + 32 | 0;
	                I = e + 28 | 0;
	                J = e + 24 | 0;
	                K = e + 20 | 0;
	                L = e + 16 | 0;
	                M = e + 12 | 0;
	                N = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[q >> 2] = 0;
	                d = c[h >> 2] | 0;
	                if (!(c[j >> 2] | 0)) {
	                    FN(d, 7, 0, 0, 0);
	                    c[g >> 2] = -1;
	                    O = c[g >> 2] | 0;
	                    i = e;
	                    return O | 0
	                }
	                if (c[d + 60 >> 2] | 0)c[k >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2]; else c[k >> 2] = 0;
	                d = (c[h >> 2] | 0) + 32 | 0;
	                c[d >> 2] = (c[d >> 2] | 0) + 1;
	                a:do switch (c[c[j >> 2] >> 2] | 0) {
	                    case 1:
	                    {
	                        c[l >> 2] = -1;
	                        break
	                    }
	                    case 3:
	                    {
	                        while (1) {
	                            if (c[k >> 2] | 0)if (((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 7 : 0)P = (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 4; else P = 1; else P = 0;
	                            Q = c[k >> 2] | 0;
	                            if (!P)break;
	                            c[k >> 2] = c[Q + 24 >> 2]
	                        }
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = Q;
	                        break
	                    }
	                    case 0:
	                    {
	                        c[k >> 2] = oO(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        c[l >> 2] = 0;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[p >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                        c[l >> 2] = OO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0))if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) > (c[p >> 2] | 0)) {
	                            KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            R = 124
	                        } else R = 124;
	                        break
	                    }
	                    case 15:
	                    {
	                        R = 124;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[p >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                        c[o >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                        d = (c[h >> 2] | 0) + 28 | 0;
	                        c[d >> 2] = c[d >> 2] | 1;
	                        c[q >> 2] = PO(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                        c[l >> 2] = OO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        d = c[h >> 2] | 0;
	                        if (c[l >> 2] | 0) {
	                            if (c[d + 60 >> 2] | 0)LN(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                            c[l >> 2] = 0;
	                            if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) <= (c[p >> 2] | 0))break a;
	                            KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            break a
	                        }
	                        a = c[h >> 2] | 0;
	                        do if (c[d + 64 >> 2] | 0)lO(a, c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[q >> 2] | 0) | 0; else {
	                            S = mO(a, 1) | 0;
	                            c[(c[h >> 2] | 0) + 64 >> 2] = S;
	                            S = c[h >> 2] | 0;
	                            if (c[(c[h >> 2] | 0) + 64 >> 2] | 0) {
	                                lO(S, c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[q >> 2] | 0) | 0;
	                                lO(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 64 >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                                break
	                            }
	                            LN(S, c[q >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                            c[l >> 2] = -1;
	                            if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) <= (c[p >> 2] | 0))break a;
	                            KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            break a
	                        } while (0);
	                        c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                        c[l >> 2] = 0;
	                        if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) > (c[p >> 2] | 0))KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                        break
	                    }
	                    case 4:
	                    {
	                        c[p >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                        c[k >> 2] = oO(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            FN(c[h >> 2] | 0, 22, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[l >> 2] = -1;
	                            if (c[(c[h >> 2] | 0) + 28 >> 2] & 1)break a;
	                            eO(c[h >> 2] | 0);
	                            break a
	                        }
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                            FN(c[h >> 2] | 0, 23, 0, 0, 0);
	                            c[l >> 2] = -1;
	                            if (c[(c[h >> 2] | 0) + 28 >> 2] & 1)break a;
	                            eO(c[h >> 2] | 0);
	                            break a
	                        }
	                        a = c[h >> 2] | 0;
	                        if ((c[(c[k >> 2] | 0) + 52 >> 2] | 0) == (c[j >> 2] | 0)) {
	                            d = oO(a, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = d;
	                            if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) > (c[p >> 2] | 0))KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            if (!(c[(c[h >> 2] | 0) + 48 >> 2] | 0))break a;
	                            while (1) {
	                                if (!(c[(c[h >> 2] | 0) + 44 >> 2] | 0))break a;
	                                if (!((c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) == 13 ? (qy(c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 20 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0))R = 30;
	                                do if ((R | 0) == 30) {
	                                    R = 0;
	                                    if ((c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) == 19 ? (qy(c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                                    if ((c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) != 22 ? (c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) != 23 : 0)break a
	                                } while (0);
	                                LO(c[h >> 2] | 0)
	                            }
	                        }
	                        c[l >> 2] = MO(a, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if ((c[l >> 2] | 0) <= 0) {
	                            c[l >> 2] = -1;
	                            if (c[(c[h >> 2] | 0) + 28 >> 2] & 1)break a;
	                            eO(c[h >> 2] | 0);
	                            break a
	                        }
	                        c[l >> 2] = 0;
	                        b:do if (c[(c[h >> 2] | 0) + 48 >> 2] | 0) {
	                            if ((c[(c[h >> 2] | 0) + 48 >> 2] | 0) > (c[p >> 2] | 0))KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            while (1) {
	                                if (!(c[(c[h >> 2] | 0) + 44 >> 2] | 0))break b;
	                                if (!((c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) == 13 ? (qy(c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 20 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0))R = 44;
	                                do if ((R | 0) == 44) {
	                                    R = 0;
	                                    if ((c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) == 19 ? (qy(c[(c[(c[h >> 2] | 0) + 44 >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                                    if ((c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) != 22 ? (c[c[(c[h >> 2] | 0) + 44 >> 2] >> 2] | 0) != 23 : 0)break b
	                                } while (0);
	                                LO(c[h >> 2] | 0)
	                            }
	                        } while (0);
	                        c[p >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                        c[o >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                        if (c[(c[h >> 2] | 0) + 28 >> 2] & 4) {
	                            a = (c[h >> 2] | 0) + 28 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) - 4
	                        }
	                        c[r >> 2] = JN(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        if (!(c[r >> 2] | 0)) {
	                            c[l >> 2] = -1;
	                            if (c[(c[h >> 2] | 0) + 28 >> 2] & 1)break a;
	                            eO(c[h >> 2] | 0);
	                            break a
	                        }
	                        c[q >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                        c[(c[h >> 2] | 0) + 60 >> 2] = c[r >> 2];
	                        if ((c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[n >> 2] = hO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0) | 0, (c[n >> 2] | 0) != 0) : 0) {
	                            c[l >> 2] = -1;
	                            FN(c[h >> 2] | 0, 24, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0)
	                        }
	                        do if (c[(c[j >> 2] | 0) + 52 >> 2] | 0) {
	                            c[t >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                            c[u >> 2] = c[(c[h >> 2] | 0) + 64 >> 2];
	                            c[s >> 2] = JN(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                            c[(c[h >> 2] | 0) + 60 >> 2] = c[s >> 2];
	                            c[(c[h >> 2] | 0) + 64 >> 2] = 0;
	                            c[n >> 2] = NO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            c[v >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2];
	                            c[(c[h >> 2] | 0) + 60 >> 2] = c[t >> 2];
	                            c[(c[h >> 2] | 0) + 64 >> 2] = c[u >> 2];
	                            LN(c[h >> 2] | 0, c[s >> 2] | 0);
	                            if (c[n >> 2] | 0)c[l >> 2] = -1;
	                            if (!(c[(c[h >> 2] | 0) + 64 >> 2] | 0)) {
	                                c[r >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                                if (c[(c[h >> 2] | 0) + 60 >> 2] | 0)c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[v >> 2];
	                                if (!(c[l >> 2] | 0))c[l >> 2] = iO(c[h >> 2] | 0, 1) | 0;
	                                LN(c[h >> 2] | 0, c[r >> 2] | 0);
	                                break
	                            }
	                            c[n >> 2] = -1;
	                            c[m >> 2] = 0;
	                            while (1) {
	                                if ((c[m >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                c[r >> 2] = c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                c[(c[h >> 2] | 0) + 60 >> 2] = c[r >> 2];
	                                c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[v >> 2];
	                                if (!(iO(c[h >> 2] | 0, 0) | 0)) {
	                                    R = 64;
	                                    break
	                                }
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            if ((R | 0) == 64)c[n >> 2] = 0;
	                            if (c[n >> 2] | 0) {
	                                a = (c[h >> 2] | 0) + 28 | 0;
	                                c[a >> 2] = c[a >> 2] | 1;
	                                jO(c[h >> 2] | 0)
	                            }
	                            c[m >> 2] = 0;
	                            while (1) {
	                                T = c[h >> 2] | 0;
	                                if ((c[m >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                LN(T, c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0);
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            NN(T, c[(c[h >> 2] | 0) + 64 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                            c[(c[h >> 2] | 0) + 64 >> 2] = 0;
	                            if ((c[l >> 2] | 0) == 0 & (c[n >> 2] | 0) == -1)c[l >> 2] = -1
	                        } else {
	                            do if ((c[(c[j >> 2] | 0) + 24 >> 2] | 0) != 0 ? (c[n >> 2] = OO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0, (c[n >> 2] | 0) != 0) : 0) {
	                                c[l >> 2] = -1;
	                                if (!(c[(c[h >> 2] | 0) + 60 >> 2] | 0)) {
	                                    c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                                    FN(c[h >> 2] | 0, 25, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                    c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                                    break
	                                } else {
	                                    FN(c[h >> 2] | 0, 25, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                    break
	                                }
	                            } while (0);
	                            if (!(c[(c[h >> 2] | 0) + 64 >> 2] | 0)) {
	                                c[r >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                                if (!(c[l >> 2] | 0))c[l >> 2] = iO(c[h >> 2] | 0, 1) | 0;
	                                LN(c[h >> 2] | 0, c[r >> 2] | 0);
	                                break
	                            }
	                            c[n >> 2] = -1;
	                            c[m >> 2] = 0;
	                            while (1) {
	                                if ((c[m >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                c[r >> 2] = c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                c[(c[h >> 2] | 0) + 60 >> 2] = c[r >> 2];
	                                if (!(iO(c[h >> 2] | 0, 0) | 0)) {
	                                    R = 87;
	                                    break
	                                }
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            if ((R | 0) == 87)c[n >> 2] = 0;
	                            if (c[n >> 2] | 0) {
	                                a = (c[h >> 2] | 0) + 28 | 0;
	                                c[a >> 2] = c[a >> 2] | 1;
	                                jO(c[h >> 2] | 0)
	                            }
	                            c[m >> 2] = 0;
	                            while (1) {
	                                U = c[h >> 2] | 0;
	                                if ((c[m >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                LN(U, c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0);
	                                c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2] = 0;
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            NN(U, c[(c[h >> 2] | 0) + 64 >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                            c[(c[h >> 2] | 0) + 64 >> 2] = 0;
	                            if ((c[l >> 2] | 0) == 0 & (c[n >> 2] | 0) == -1)c[l >> 2] = -1
	                        } while (0);
	                        if (!(c[l >> 2] | 0))c[(c[k >> 2] | 0) + 52 >> 2] = c[j >> 2];
	                        c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                        c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                        if (c[q >> 2] | 0) {
	                            a = oO(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            c[(c[q >> 2] | 0) + 4 >> 2] = a
	                        }
	                        a = c[h >> 2] | 0;
	                        if (c[l >> 2] | 0) {
	                            if (c[a + 28 >> 2] & 1)break a;
	                            eO(c[h >> 2] | 0);
	                            c[l >> 2] = 0;
	                            break a
	                        } else {
	                            if ((c[a + 48 >> 2] | 0) <= (c[p >> 2] | 0))break a;
	                            KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            break a
	                        }
	                        break
	                    }
	                    case 18:
	                    case 10:
	                    {
	                        c[l >> 2] = OO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[l >> 2] = QO(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 9:
	                    {
	                        c[l >> 2] = IO(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 13:
	                    case 12:
	                    case 11:
	                    case -1:
	                    case 20:
	                    {
	                        c[l >> 2] = KN(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[F >> 2] = 0;
	                        c[E >> 2] = c[k >> 2];
	                        while (1) {
	                            if (!(c[E >> 2] | 0))break;
	                            if ((c[(c[E >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                R = 222;
	                                break
	                            }
	                            if (!((c[(c[E >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[E >> 2] | 0) + 4 >> 2] | 0) != 4 : 0))c[F >> 2] = By(c[F >> 2] | 0, c[(c[E >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            c[E >> 2] = c[(c[E >> 2] | 0) + 24 >> 2]
	                        }
	                        if ((R | 0) == 222) {
	                            FN(c[h >> 2] | 0, 28, c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[l >> 2] = -1
	                        }
	                        a = c[F >> 2] | 0;
	                        if ((c[l >> 2] | 0) == -1) {
	                            if (!a)break a;
	                            zb[c[135736 >> 2] & 511](c[F >> 2] | 0);
	                            break a
	                        }
	                        if ((a | 0) == 0 ? (c[F >> 2] = my(188112) | 0, (c[F >> 2] | 0) == 0) : 0) {
	                            MN(c[h >> 2] | 0, 189544);
	                            c[l >> 2] = -1;
	                            break a
	                        }
	                        c[l >> 2] = RO(c[h >> 2] | 0, c[F >> 2] | 0, c[j >> 2] | 0, c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        if ((c[l >> 2] | 0) != -1) {
	                            if (!(c[l >> 2] | 0))c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = 0
	                        } else FN(c[h >> 2] | 0, 31, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        if (c[F >> 2] | 0)zb[c[135736 >> 2] & 511](c[F >> 2] | 0);
	                        break
	                    }
	                    case 7:
	                    {
	                        c[G >> 2] = 0;
	                        c[I >> 2] = c[k >> 2];
	                        while (1) {
	                            if (!(c[I >> 2] | 0))break;
	                            if ((c[(c[I >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                R = 242;
	                                break
	                            }
	                            if (!((c[(c[I >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[I >> 2] | 0) + 4 >> 2] | 0) != 4 : 0))c[G >> 2] = By(c[G >> 2] | 0, c[(c[I >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            c[I >> 2] = c[(c[I >> 2] | 0) + 24 >> 2]
	                        }
	                        if ((R | 0) == 242) {
	                            FN(c[h >> 2] | 0, 29, c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[l >> 2] = -1
	                        }
	                        a = c[G >> 2] | 0;
	                        if ((c[l >> 2] | 0) == -1) {
	                            if (!a)break a;
	                            zb[c[135736 >> 2] & 511](c[G >> 2] | 0);
	                            break a
	                        }
	                        if ((a | 0) == 0 ? (c[G >> 2] = my(188112) | 0, (c[G >> 2] | 0) == 0) : 0) {
	                            MN(c[h >> 2] | 0, 189544);
	                            c[l >> 2] = -1;
	                            break a
	                        }
	                        c[H >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[G >> 2];
	                        c[l >> 2] = SO(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[H >> 2];
	                        if ((c[l >> 2] | 0) != -1) {
	                            if (!(c[l >> 2] | 0))c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = 0
	                        } else FN(c[h >> 2] | 0, 32, c[(c[j >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        if (c[G >> 2] | 0)zb[c[135736 >> 2] & 511](c[G >> 2] | 0);
	                        break
	                    }
	                    case 8:
	                    {
	                        c[J >> 2] = 0;
	                        c[K >> 2] = c[k >> 2];
	                        while (1) {
	                            if (!(c[K >> 2] | 0))break;
	                            if ((c[(c[K >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                R = 262;
	                                break
	                            }
	                            if (!((c[(c[K >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[K >> 2] | 0) + 4 >> 2] | 0) != 4 : 0))c[J >> 2] = By(c[J >> 2] | 0, c[(c[K >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            c[K >> 2] = c[(c[K >> 2] | 0) + 24 >> 2]
	                        }
	                        if ((R | 0) == 262) {
	                            FN(c[h >> 2] | 0, 30, c[(c[(c[k >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                            c[l >> 2] = -1
	                        }
	                        a = c[J >> 2] | 0;
	                        if ((c[l >> 2] | 0) == -1) {
	                            if (!a)break a;
	                            zb[c[135736 >> 2] & 511](c[J >> 2] | 0);
	                            break a
	                        }
	                        if ((a | 0) == 0 ? (c[J >> 2] = my(188112) | 0, (c[J >> 2] | 0) == 0) : 0) {
	                            MN(c[h >> 2] | 0, 189544);
	                            c[l >> 2] = -1;
	                            break a
	                        }
	                        c[N >> 2] = xy(c[J >> 2] | 0) | 0;
	                        c[L >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                        c[M >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[J >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = (c[J >> 2] | 0) + (c[N >> 2] | 0);
	                        c[l >> 2] = SO(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[L >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = c[M >> 2];
	                        if ((c[l >> 2] | 0) != -1) {
	                            if ((c[l >> 2] | 0) == 0 & (c[k >> 2] | 0) != 0)c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        } else FN(c[h >> 2] | 0, 33, 0, 0, 0);
	                        if (c[J >> 2] | 0)zb[c[135736 >> 2] & 511](c[J >> 2] | 0);
	                        break
	                    }
	                    case 6:
	                    case 2:
	                    {
	                        a = c[33976] | 0;
	                        d = c[33980] | 0;
	                        c[f >> 2] = 189496;
	                        c[f + 4 >> 2] = 10569;
	                        Db[a & 511](d, 189464, f);
	                        c[l >> 2] = -1;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[B >> 2] = 0;
	                        c[C >> 2] = 0;
	                        c[k >> 2] = oO(c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                        c[p >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                        if ((b[(c[j >> 2] | 0) + 50 >> 1] & 16 | 0) != 0 ? ((c[k >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) : 0) {
	                            c[D >> 2] = c[(c[j >> 2] | 0) + 20 >> 2];
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                    d = c[D >> 2] | 0;
	                                    a = c[(c[k >> 2] | 0) + 8 >> 2] | 0;
	                                    if (c[(c[k >> 2] | 0) + 36 >> 2] | 0) {
	                                        c[B >> 2] = Tj(d, a, c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                        if (!(c[B >> 2] | 0))c[B >> 2] = Tj(c[D >> 2] | 0, 189536, c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0
	                                    } else c[B >> 2] = Tj(d, a, 0) | 0;
	                                    if (!(c[B >> 2] | 0))c[B >> 2] = Tj(c[D >> 2] | 0, 189536, 0) | 0
	                                }
	                            } else c[B >> 2] = Tj(c[D >> 2] | 0, 188096, 0) | 0;
	                            if (!(c[B >> 2] | 0)) {
	                                c[l >> 2] = -1;
	                                FN(c[h >> 2] | 0, 38, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                break a
	                            } else {
	                                c[l >> 2] = KN(c[h >> 2] | 0, c[B >> 2] | 0) | 0;
	                                break a
	                            }
	                        }
	                        c[B >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        c[o >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                        a = (c[h >> 2] | 0) + 28 | 0;
	                        c[a >> 2] = c[a >> 2] | 1;
	                        while (1) {
	                            if (!(c[B >> 2] | 0))break;
	                            c[q >> 2] = PO(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                            c[l >> 2] = KN(c[h >> 2] | 0, c[B >> 2] | 0) | 0;
	                            do if (!(c[l >> 2] | 0)) {
	                                if (!(c[C >> 2] | 0))c[C >> 2] = mO(c[h >> 2] | 0, 1) | 0;
	                                a = c[h >> 2] | 0;
	                                if (c[(c[h >> 2] | 0) + 60 >> 2] | 0) {
	                                    lO(a, c[C >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                                    break
	                                }
	                                if (c[a + 64 >> 2] | 0) {
	                                    c[m >> 2] = 0;
	                                    while (1) {
	                                        V = c[h >> 2] | 0;
	                                        if ((c[m >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                        lO(V, c[C >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) | 0;
	                                        c[m >> 2] = (c[m >> 2] | 0) + 1
	                                    }
	                                    NN(V, c[(c[h >> 2] | 0) + 64 >> 2] | 0);
	                                    c[(c[h >> 2] | 0) + 64 >> 2] = 0
	                                }
	                            } else LN(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0); while (0);
	                            c[(c[h >> 2] | 0) + 60 >> 2] = c[q >> 2];
	                            c[B >> 2] = c[(c[B >> 2] | 0) + 32 >> 2]
	                        }
	                        a = c[h >> 2] | 0;
	                        if (c[C >> 2] | 0) {
	                            LN(a, c[q >> 2] | 0);
	                            c[(c[h >> 2] | 0) + 64 >> 2] = c[C >> 2];
	                            c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                            c[l >> 2] = 0
	                        } else c[a + 64 >> 2] = 0;
	                        c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                        a = c[h >> 2] | 0;
	                        if (c[l >> 2] | 0) {
	                            if (c[a + 28 >> 2] & 1)break a;
	                            eO(c[h >> 2] | 0);
	                            break a
	                        } else {
	                            if ((c[a + 48 >> 2] | 0) <= (c[p >> 2] | 0))break a;
	                            KO(c[h >> 2] | 0, c[p >> 2] | 0);
	                            break a
	                        }
	                        break
	                    }
	                    default:
	                    {
	                    }
	                } while (0);
	                do if ((R | 0) == 124) {
	                    c[x >> 2] = 0;
	                    c[y >> 2] = 0;
	                    c[p >> 2] = c[(c[h >> 2] | 0) + 48 >> 2];
	                    c[y >> 2] = mO(c[h >> 2] | 0, 1) | 0;
	                    if (!(c[y >> 2] | 0)) {
	                        c[l >> 2] = -1;
	                        break
	                    }
	                    c:do if (c[(c[h >> 2] | 0) + 60 >> 2] | 0) {
	                        C = c[h >> 2] | 0;
	                        q = c[y >> 2] | 0;
	                        lO(C, q, PO(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0) | 0
	                    } else {
	                        c[A >> 2] = 0;
	                        while (1) {
	                            if ((c[A >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break c;
	                            q = c[h >> 2] | 0;
	                            C = c[y >> 2] | 0;
	                            lO(q, C, PO(c[h >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[A >> 2] << 2) >> 2] | 0) | 0) | 0;
	                            c[A >> 2] = (c[A >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[o >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                    C = (c[h >> 2] | 0) + 28 | 0;
	                    c[C >> 2] = c[C >> 2] | 1;
	                    d:do {
	                        c[w >> 2] = 0;
	                        c[z >> 2] = c[c[y >> 2] >> 2];
	                        C = c[h >> 2] | 0;
	                        e:do if (!(c[(c[h >> 2] | 0) + 64 >> 2] | 0)) {
	                            c[l >> 2] = OO(C, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            if (c[l >> 2] | 0) {
	                                LN(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0);
	                                c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                                break
	                            }
	                            c[z >> 2] = c[c[y >> 2] >> 2];
	                            q = c[h >> 2] | 0;
	                            if (c[(c[h >> 2] | 0) + 60 >> 2] | 0) {
	                                c[n >> 2] = lO(q, c[y >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                                if ((c[n >> 2] | 0) != 1)break;
	                                c[w >> 2] = 1;
	                                break
	                            }
	                            if (c[q + 64 >> 2] | 0) {
	                                c[A >> 2] = 0;
	                                while (1) {
	                                    if ((c[A >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                    c[n >> 2] = lO(c[h >> 2] | 0, c[y >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[A >> 2] << 2) >> 2] | 0) | 0;
	                                    if ((c[n >> 2] | 0) == 1)c[w >> 2] = 1;
	                                    c[A >> 2] = (c[A >> 2] | 0) + 1
	                                }
	                                q = c[h >> 2] | 0;
	                                if (!(c[x >> 2] | 0))c[x >> 2] = c[q + 64 >> 2]; else NN(q, c[(c[h >> 2] | 0) + 64 >> 2] | 0);
	                                c[(c[h >> 2] | 0) + 64 >> 2] = 0
	                            }
	                        } else {
	                            c[x >> 2] = c[C + 64 >> 2];
	                            c[m >> 2] = 0;
	                            while (1) {
	                                if ((c[m >> 2] | 0) >= (c[c[x >> 2] >> 2] | 0))break e;
	                                c[(c[h >> 2] | 0) + 60 >> 2] = c[(c[(c[x >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                                c[(c[h >> 2] | 0) + 64 >> 2] = 0;
	                                c[l >> 2] = OO(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 24 >> 2] | 0) | 0;
	                                q = (c[(c[h >> 2] | 0) + 60 >> 2] | 0) != 0;
	                                do if (!(c[l >> 2] | 0)) {
	                                    B = c[h >> 2] | 0;
	                                    if (q) {
	                                        c[n >> 2] = lO(B, c[y >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0) | 0;
	                                        c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                                        if ((c[n >> 2] | 0) != 1)break;
	                                        c[w >> 2] = 1;
	                                        break
	                                    }
	                                    if (c[B + 64 >> 2] | 0) {
	                                        c[A >> 2] = 0;
	                                        while (1) {
	                                            W = c[h >> 2] | 0;
	                                            if ((c[A >> 2] | 0) >= (c[c[(c[h >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                            c[n >> 2] = lO(W, c[y >> 2] | 0, c[(c[(c[(c[h >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[A >> 2] << 2) >> 2] | 0) | 0;
	                                            if ((c[n >> 2] | 0) == 1)c[w >> 2] = 1;
	                                            c[A >> 2] = (c[A >> 2] | 0) + 1
	                                        }
	                                        NN(W, c[(c[h >> 2] | 0) + 64 >> 2] | 0);
	                                        c[(c[h >> 2] | 0) + 64 >> 2] = 0
	                                    }
	                                } else if (q) {
	                                    LN(c[h >> 2] | 0, c[(c[h >> 2] | 0) + 60 >> 2] | 0);
	                                    c[(c[h >> 2] | 0) + 60 >> 2] = 0
	                                } while (0);
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        do if (c[w >> 2] | 0) {
	                            if (((c[c[y >> 2] >> 2] | 0) - (c[z >> 2] | 0) | 0) == 1) {
	                                C = PO(c[h >> 2] | 0, c[(c[(c[y >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) | 0;
	                                c[(c[h >> 2] | 0) + 60 >> 2] = C;
	                                break
	                            }
	                            if ((c[x >> 2] | 0) == 0 ? (mO(c[h >> 2] | 0, (c[c[y >> 2] >> 2] | 0) - (c[z >> 2] | 0) | 0) | 0, c[x >> 2] = c[(c[h >> 2] | 0) + 64 >> 2], (c[x >> 2] | 0) == 0) : 0) {
	                                R = 169;
	                                break d
	                            }
	                            c[c[x >> 2] >> 2] = 0;
	                            c[m >> 2] = c[z >> 2];
	                            while (1) {
	                                if ((c[m >> 2] | 0) >= (c[c[y >> 2] >> 2] | 0))break;
	                                C = c[h >> 2] | 0;
	                                q = c[x >> 2] | 0;
	                                lO(C, q, PO(c[h >> 2] | 0, c[(c[(c[y >> 2] | 0) + 8 >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) | 0) | 0;
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            c[(c[h >> 2] | 0) + 64 >> 2] = c[x >> 2]
	                        } while (0)
	                    } while ((c[w >> 2] | 0) == 1);
	                    if ((R | 0) == 169)c[w >> 2] = 0;
	                    if (c[x >> 2] | 0)NN(c[h >> 2] | 0, c[x >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 64 >> 2] = c[y >> 2];
	                    c[(c[h >> 2] | 0) + 28 >> 2] = c[o >> 2];
	                    c[l >> 2] = 0
	                } while (0);
	                o = (c[h >> 2] | 0) + 32 | 0;
	                c[o >> 2] = (c[o >> 2] | 0) + -1;
	                c[g >> 2] = c[l >> 2];
	                O = c[g >> 2] | 0;
	                i = e;
	                return O | 0
	            }

	            function lO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if ((c[j >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                do if ((c[c[h >> 2] >> 2] | 0) >= (c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[m >> 2] = c[(c[h >> 2] | 0) + 4 >> 2] << 1;
	                    c[l >> 2] = Hb[c[135760 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] << 2) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[(c[h >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                        c[(c[h >> 2] | 0) + 4 >> 2] = c[m >> 2];
	                        break
	                    }
	                    MN(c[g >> 2] | 0, 189520);
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } while (0);
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[c[h >> 2] >> 2] | 0)) {
	                        o = 12;
	                        break
	                    }
	                    if (TO(c[g >> 2] | 0, c[j >> 2] | 0, c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) | 0) {
	                        o = 10;
	                        break
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((o | 0) == 10) {
	                    LN(c[g >> 2] | 0, c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((o | 0) == 12) {
	                    o = c[j >> 2] | 0;
	                    j = c[h >> 2] | 0;
	                    g = c[j >> 2] | 0;
	                    c[j >> 2] = g + 1;
	                    c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (g << 2) >> 2] = o;
	                    c[f >> 2] = 1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function mO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 80 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 72 >> 2] | 0) > 0 : 0) {
	                    b = (c[f >> 2] | 0) + 72 | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + -1;
	                    c[h >> 2] = c[(c[(c[f >> 2] | 0) + 80 >> 2] | 0) + (c[(c[f >> 2] | 0) + 72 >> 2] << 2) >> 2];
	                    c[c[h >> 2] >> 2] = 0;
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if ((c[g >> 2] | 0) < 16)c[g >> 2] = 16;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](12 + ((c[g >> 2] | 0) - 1 << 2) | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    MN(c[f >> 2] | 0, 189568);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[c[h >> 2] >> 2] = 0;
	                c[(c[h >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                b = Cb[c[135744 >> 2] & 511](c[g >> 2] << 2) | 0;
	                c[(c[h >> 2] | 0) + 8 >> 2] = b;
	                if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0)) {
	                    MN(c[f >> 2] | 0, 189568);
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function nO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                do if ((c[c[h >> 2] >> 2] | 0) >= (c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[l >> 2] = c[(c[h >> 2] | 0) + 4 >> 2] << 1;
	                    c[k >> 2] = Hb[c[135760 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] << 2) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[(c[h >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                        c[(c[h >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                        break
	                    }
	                    MN(c[g >> 2] | 0, 189520);
	                    c[f >> 2] = -1;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } while (0);
	                g = c[j >> 2] | 0;
	                j = c[h >> 2] | 0;
	                l = c[j >> 2] | 0;
	                c[j >> 2] = l + 1;
	                c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + (l << 2) >> 2] = g;
	                c[f >> 2] = 1;
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function oO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    do if (c[f >> 2] | 0)if ((((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 8 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 7 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 19 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 20 : 0) {
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                            g = 0;
	                            break
	                        }
	                        if (!(c[(c[e >> 2] | 0) + 28 >> 2] & 4))g = (sO(c[(c[f >> 2] | 0) + 40 >> 2] | 0) | 0) != 0; else g = 1
	                    } else g = 1; else g = 0; while (0);
	                    h = c[f >> 2] | 0;
	                    if (!g)break;
	                    c[f >> 2] = c[h + 24 >> 2]
	                }
	                i = d;
	                return h | 0
	            }

	            function pO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 44 >> 2];
	                while (1) {
	                    if (!(c[h >> 2] | 0))break;
	                    c[j >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                    if (!((c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) == 0 : 0))m = 5;
	                    do if ((m | 0) == 5) {
	                        m = 0;
	                        if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 192176) | 0) {
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189864) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189904) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189928) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189952) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190064) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 195016) | 0)break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1034, 196520, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 192784) | 0) {
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189888) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 192360) | 0)break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1034, 196520, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 195400) | 0) {
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189936) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 195024) | 0)break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1034, 196520, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 194568) | 0) {
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190048) | 0)break;
	                            if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 195016) | 0)break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1034, 196520, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        if (!(qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 193160) | 0)) {
	                            if (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 192672) | 0)break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1113, 196680, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        c[k >> 2] = _h(c[(c[g >> 2] | 0) + 32 >> 2] | 0, c[(c[h >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                        if (c[k >> 2] | 0) {
	                            do if (d[c[k >> 2] >> 0] | 0) {
	                                c[l >> 2] = yl(c[k >> 2] | 0) | 0;
	                                if (!(c[l >> 2] | 0)) {
	                                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1050, 196560, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0);
	                                    break
	                                }
	                                if (!(c[c[l >> 2] >> 2] | 0))zN(c[f >> 2] | 0, c[g >> 2] | 0, 1118, 196600, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0);
	                                if (c[(c[l >> 2] | 0) + 32 >> 2] | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1117, 196640, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0);
	                                Al(c[l >> 2] | 0)
	                            } while (0);
	                            zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                        }
	                    } while (0);
	                    c[h >> 2] = c[j >> 2]
	                }
	                i = e;
	                return
	            }

	            function qO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                c[n >> 2] = 0;
	                while (1) {
	                    if ((c[n >> 2] | 0) >= (c[(c[g >> 2] | 0) + 100 >> 2] | 0))break;
	                    if (qy(c[(c[(c[(c[g >> 2] | 0) + 108 >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0) | 0) {
	                        o = 4;
	                        break
	                    }
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                }
	                if ((o | 0) == 4) {
	                    zN(c[g >> 2] | 0, 0, 1033, 196408, c[h >> 2] | 0, 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[l >> 2] = gg(c[h >> 2] | 0, 0, 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    zN(c[g >> 2] | 0, 0, 1065, 196056, c[h >> 2] | 0, 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    zN(c[g >> 2] | 0, c[l >> 2] | 0, 2, 196456, c[h >> 2] | 0, 0);
	                    Th(c[l >> 2] | 0);
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                o = c[k >> 2] | 0;
	                c[o + 0 >> 2] = 0;
	                c[o + 4 >> 2] = 0;
	                c[o + 8 >> 2] = 0;
	                c[o + 12 >> 2] = 0;
	                c[o + 16 >> 2] = 0;
	                c[o + 20 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                o = my(c[h >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 4 >> 2] = o;
	                c[c[k >> 2] >> 2] = c[(c[g >> 2] | 0) + 60 >> 2];
	                c[(c[k >> 2] | 0) + 20 >> 2] = 1;
	                c[(c[g >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                if (((c[j >> 2] | 0) != 0 ? (c[m >> 2] = Pi(c[l >> 2] | 0) | 0, (c[m >> 2] | 0) != 0) : 0) ? (dj(c[m >> 2] | 0, 192672) | 0) == 0 : 0)gj(c[m >> 2] | 0, 192672, c[j >> 2] | 0) | 0;
	                UO(c[g >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[l >> 2] = AN(c[g >> 2] | 0, c[l >> 2] | 0) | 0;
	                j = c[g >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[j + 96 >> 2] = 0;
	                    c[f >> 2] = 0;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                } else {
	                    VO(j) | 0;
	                    c[f >> 2] = c[k >> 2];
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                return 0
	            }

	            function rO(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                h = f + 44 | 0;
	                j = f + 40 | 0;
	                k = f + 36 | 0;
	                l = f + 32 | 0;
	                m = f + 28 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 16 | 0;
	                q = f + 12 | 0;
	                r = f + 8 | 0;
	                s = f + 4 | 0;
	                t = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[o >> 2] = 0;
	                while (1) {
	                    if ((c[o >> 2] | 0) >= (c[(c[h >> 2] | 0) + 116 >> 2] | 0))break;
	                    if (qy(c[(c[(c[(c[h >> 2] | 0) + 124 >> 2] | 0) + (c[o >> 2] << 2) >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0) | 0) {
	                        u = 4;
	                        break
	                    }
	                    c[o >> 2] = (c[o >> 2] | 0) + 1
	                }
	                if ((u | 0) == 4) {
	                    zN(c[h >> 2] | 0, 0, 1044, 196016, c[j >> 2] | 0, 0);
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                c[n >> 2] = gg(c[j >> 2] | 0, 0, 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    zN(c[h >> 2] | 0, c[k >> 2] | 0, 1065, 196056, c[j >> 2] | 0, 0);
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    xN(c[h >> 2] | 0, 196088);
	                    Th(c[n >> 2] | 0);
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                o = c[m >> 2] | 0;
	                c[o + 0 >> 2] = 0;
	                c[o + 4 >> 2] = 0;
	                c[o + 8 >> 2] = 0;
	                c[o + 12 >> 2] = 0;
	                c[o + 16 >> 2] = 0;
	                c[(c[m >> 2] | 0) + 8 >> 2] = c[n >> 2];
	                o = my(c[j >> 2] | 0) | 0;
	                c[(c[m >> 2] | 0) + 4 >> 2] = o;
	                c[c[m >> 2] >> 2] = c[(c[h >> 2] | 0) + 64 >> 2];
	                c[(c[h >> 2] | 0) + 64 >> 2] = c[m >> 2];
	                if (((c[l >> 2] | 0) != 0 ? (c[p >> 2] = Pi(c[n >> 2] | 0) | 0, (c[p >> 2] | 0) != 0) : 0) ? (dj(c[p >> 2] | 0, 192672) | 0) == 0 : 0)gj(c[p >> 2] | 0, 192672, c[l >> 2] | 0) | 0;
	                WO(c[h >> 2] | 0, c[m >> 2] | 0) | 0;
	                c[n >> 2] = AN(c[h >> 2] | 0, c[n >> 2] | 0) | 0;
	                l = c[h >> 2] | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[l + 112 >> 2] = 0;
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                XO(l) | 0;
	                c[p >> 2] = Pi(c[n >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    zN(c[h >> 2] | 0, c[k >> 2] | 0, 1022, 196112, c[j >> 2] | 0, 0);
	                    c[g >> 2] = 0;
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                if (((((c[p >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[p >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 190264) | 0) != 0 : 0) ? (qy(c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                    c[q >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[q >> 2] | 0))break;
	                        if (((((c[q >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 190048) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                            c[r >> 2] = 0;
	                            c[r >> 2] = YO(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[p >> 2] | 0) + 12 >> 2] | 0, 0) | 0;
	                            if (!(c[r >> 2] | 0))zN(c[h >> 2] | 0, c[k >> 2] | 0, 1107, 196216, c[j >> 2] | 0, 0)
	                        } else u = 33;
	                        do if ((((((u | 0) == 33 ? (u = 0, (c[q >> 2] | 0) != 0) : 0) ? (c[(c[q >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[q >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[q >> 2] | 0) + 8 >> 2] | 0, 195016) | 0) != 0 : 0) ? (qy(c[(c[(c[q >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                            c[s >> 2] = Yi(c[q >> 2] | 0, 192176) | 0;
	                            if (!(c[s >> 2] | 0)) {
	                                zN(c[h >> 2] | 0, c[k >> 2] | 0, 1053, 196288, c[j >> 2] | 0, 0);
	                                break
	                            }
	                            ZO(c[s >> 2] | 0);
	                            c[t >> 2] = YO(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[p >> 2] | 0) + 12 >> 2] | 0, c[s >> 2] | 0) | 0;
	                            if (!(c[t >> 2] | 0))zN(c[h >> 2] | 0, c[k >> 2] | 0, 1013, 196336, c[j >> 2] | 0, c[s >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[s >> 2] | 0)
	                        } while (0);
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 24 >> 2]
	                    }
	                    c[g >> 2] = c[m >> 2];
	                    v = c[g >> 2] | 0;
	                    i = f;
	                    return v | 0
	                }
	                zN(c[h >> 2] | 0, c[k >> 2] | 0, 1038, 196160, c[j >> 2] | 0, 0);
	                c[g >> 2] = 0;
	                v = c[g >> 2] | 0;
	                i = f;
	                return v | 0
	            }

	            function sO(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    g = c[e >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a:while (1) {
	                    if (!(d[c[f >> 2] >> 0] | 0)) {
	                        h = 10;
	                        break
	                    }
	                    do if ((d[c[f >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[f >> 2] >> 0] | 0 | 0) ? (d[c[f >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[f >> 2] >> 0] | 0 | 0) != 13) {
	                            h = 8;
	                            break a
	                        }
	                    } while (0);
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                if ((h | 0) == 8) {
	                    c[e >> 2] = 0;
	                    g = c[e >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else if ((h | 0) == 10) {
	                    c[e >> 2] = 1;
	                    g = c[e >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function tO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1037, 194984, 0, 0);
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    do if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190048) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        b = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(b, a, 1106, 191968, 0, 0);
	                            break
	                        }
	                        c[j >> 2] = YN(b, c[a + 12 >> 2] | 0) | 0;
	                        if (c[j >> 2] | 0)c[h >> 2] = -1
	                    } else l = 13; while (0);
	                    do if ((l | 0) == 13) {
	                        l = 0;
	                        if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 195016) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                            c[j >> 2] = _O(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            if (!(c[j >> 2] | 0))break;
	                            c[h >> 2] = -1;
	                            break
	                        }
	                        if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 195024) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                            c[j >> 2] = $O(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            if (!(c[j >> 2] | 0))break;
	                            c[h >> 2] = -1;
	                            break
	                        }
	                        zN(c[f >> 2] | 0, c[g >> 2] | 0, 1036, 195032, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                        c[h >> 2] = -1
	                    } while (0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                c[e >> 2] = c[h >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function uO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d + 32 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = -1;
	                c[l >> 2] = 0;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[h >> 2] | 0) + 32 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[m >> 2] = c[h >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    if (((c[(c[m >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[(c[m >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[(c[m >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 190048) | 0) != 0 : 0)c[j >> 2] = Yi(c[(c[(c[m >> 2] | 0) + 4 >> 2] | 0) + 20 >> 2] | 0, 194568) | 0; else {
	                        c[j >> 2] = 0;
	                        zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1107, 194784, 0, 0)
	                    }
	                    do if (!(c[j >> 2] | 0))if (!(c[l >> 2] | 0)) {
	                        c[l >> 2] = 1;
	                        break
	                    } else {
	                        zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1054, 194928, 0, 0);
	                        break
	                    } else {
	                        do if (qy(c[j >> 2] | 0, 190016) | 0) {
	                            if ((c[k >> 2] | 0) == -1) {
	                                c[k >> 2] = 1;
	                                break
	                            }
	                            if (!(c[k >> 2] | 0))zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1104, 194832, 0, 0)
	                        } else {
	                            if (!(qy(c[j >> 2] | 0, 190032) | 0)) {
	                                zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1114, 194880, c[j >> 2] | 0, 0);
	                                break
	                            }
	                            if ((c[k >> 2] | 0) == -1) {
	                                c[k >> 2] = 0;
	                                break
	                            }
	                            if ((c[k >> 2] | 0) == 1)zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1104, 194832, 0, 0)
	                        } while (0);
	                        zb[c[135736 >> 2] & 511](c[j >> 2] | 0)
	                    } while (0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 32 >> 2]
	                }
	                if ((c[k >> 2] | 0) == -1)c[k >> 2] = 0;
	                c[m >> 2] = DN(c[f >> 2] | 0, c[(c[h >> 2] | 0) + 4 >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                h = c[m >> 2] | 0;
	                if (!(c[k >> 2] | 0))c[h >> 2] = 19; else c[h >> 2] = 17;
	                c[(c[m >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                c[(c[g >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                if (c[k >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[f >> 2] | 0) + 56 >> 2] | 0)) {
	                    k = Ij(10) | 0;
	                    c[(c[f >> 2] | 0) + 56 >> 2] = k
	                }
	                if (!(c[(c[f >> 2] | 0) + 56 >> 2] | 0)) {
	                    zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1046, 194736, 0, 0);
	                    i = d;
	                    return
	                }
	                k = (c[f >> 2] | 0) + 52 | 0;
	                g = c[k >> 2] | 0;
	                c[k >> 2] = g + 1;
	                c[e >> 2] = g;
	                JT(n, 32, 192704, e) | 0;
	                if ((Lj(c[(c[f >> 2] | 0) + 56 >> 2] | 0, n, c[m >> 2] | 0) | 0) >= 0) {
	                    i = d;
	                    return
	                }
	                zN(c[f >> 2] | 0, c[(c[m >> 2] | 0) + 4 >> 2] | 0, 1046, 192720, n, 0);
	                i = d;
	                return
	            }

	            function vO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 80 | 0;
	                f = e;
	                g = e + 40 | 0;
	                h = e + 36 | 0;
	                j = e + 32 | 0;
	                k = e + 28 | 0;
	                l = e + 24 | 0;
	                m = e + 20 | 0;
	                n = e + 16 | 0;
	                o = e + 12 | 0;
	                p = e + 8 | 0;
	                q = e + 4 | 0;
	                r = e + 48 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = -1;
	                c[m >> 2] = 0;
	                if (!(c[(c[g >> 2] | 0) + 44 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[n >> 2] = c[g >> 2];
	                while (1) {
	                    if (!(c[n >> 2] | 0))break;
	                    c[k >> 2] = Yi(c[(c[n >> 2] | 0) + 4 >> 2] | 0, 194568) | 0;
	                    do if (!(c[k >> 2] | 0))if (!(c[m >> 2] | 0)) {
	                        c[m >> 2] = 1;
	                        break
	                    } else {
	                        zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1054, 194680, c[j >> 2] | 0, 0);
	                        break
	                    } else {
	                        do if (qy(c[k >> 2] | 0, 190016) | 0) {
	                            if ((c[l >> 2] | 0) == -1) {
	                                c[l >> 2] = 1;
	                                break
	                            }
	                            if (!(c[l >> 2] | 0))zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1010, 194576, c[j >> 2] | 0, 0)
	                        } else {
	                            if (!(qy(c[k >> 2] | 0, 190032) | 0)) {
	                                zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1114, 194632, c[j >> 2] | 0, c[k >> 2] | 0);
	                                break
	                            }
	                            if ((c[l >> 2] | 0) == -1) {
	                                c[l >> 2] = 0;
	                                break
	                            }
	                            if ((c[l >> 2] | 0) == 1)zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1010, 194576, c[j >> 2] | 0, 0)
	                        } while (0);
	                        zb[c[135736 >> 2] & 511](c[k >> 2] | 0)
	                    } while (0);
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 44 >> 2]
	                }
	                if ((c[l >> 2] | 0) == -1)c[l >> 2] = 0;
	                c[n >> 2] = DN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                k = c[n >> 2] | 0;
	                if (!(c[l >> 2] | 0))c[k >> 2] = 19; else c[k >> 2] = 17;
	                c[p >> 2] = c[g >> 2];
	                c[o >> 2] = 0;
	                while (1) {
	                    if (!(c[p >> 2] | 0))break;
	                    if (c[(c[p >> 2] | 0) + 24 >> 2] | 0) {
	                        if (c[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + 32 >> 2] | 0) {
	                            c[q >> 2] = DN(c[h >> 2] | 0, c[(c[(c[p >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0))break;
	                            c[c[q >> 2] >> 2] = 18;
	                            c[(c[q >> 2] | 0) + 24 >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                        } else c[q >> 2] = c[(c[p >> 2] | 0) + 24 >> 2];
	                        k = c[q >> 2] | 0;
	                        if (!(c[o >> 2] | 0))c[(c[n >> 2] | 0) + 24 >> 2] = k; else c[(c[o >> 2] | 0) + 32 >> 2] = k;
	                        c[o >> 2] = c[q >> 2]
	                    }
	                    c[(c[p >> 2] | 0) + 24 >> 2] = c[n >> 2];
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 44 >> 2]
	                }
	                c[(c[g >> 2] | 0) + 24 >> 2] = c[n >> 2];
	                if (c[l >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[h >> 2] | 0) + 56 >> 2] | 0)) {
	                    l = Ij(10) | 0;
	                    c[(c[h >> 2] | 0) + 56 >> 2] = l
	                }
	                if (!(c[(c[h >> 2] | 0) + 56 >> 2] | 0)) {
	                    zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1046, 194736, 0, 0);
	                    i = e;
	                    return
	                }
	                l = (c[h >> 2] | 0) + 52 | 0;
	                p = c[l >> 2] | 0;
	                c[l >> 2] = p + 1;
	                c[f >> 2] = p;
	                JT(r, 32, 192704, f) | 0;
	                if ((Lj(c[(c[h >> 2] | 0) + 56 >> 2] | 0, r, c[n >> 2] | 0) | 0) >= 0) {
	                    i = e;
	                    return
	                }
	                zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1046, 192720, r, 0);
	                i = e;
	                return
	            }

	            function wO(a, d, e) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                if (b[(c[g >> 2] | 0) + 50 >> 1] & 256) {
	                    i = f;
	                    return
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1, 194400, c[j >> 2] | 0, 0);
	                    i = f;
	                    return
	                }
	                if (c[(c[g >> 2] | 0) + 24 >> 2] | 0) {
	                    zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1, 194456, c[j >> 2] | 0, 0);
	                    i = f;
	                    return
	                }
	                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                    zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1101, 194520, c[j >> 2] | 0, 0);
	                    i = f;
	                    return
	                }
	                c[l >> 2] = Rj(c[(c[k >> 2] | 0) + 24 >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    zN(c[h >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1101, 194520, c[j >> 2] | 0, 0);
	                    i = f;
	                    return
	                }
	                c[m >> 2] = c[g >> 2];
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    c[(c[m >> 2] | 0) + 24 >> 2] = c[l >> 2];
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 44 >> 2]
	                }
	                i = f;
	                return
	            }

	            function xO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[m >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189864) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[l >> 2] = aP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            d = c[l >> 2] | 0;
	                            c[k >> 2] = d;
	                            c[j >> 2] = d
	                        } else {
	                            if (((c[h >> 2] | 0) == 1 ? (c[c[j >> 2] >> 2] | 0) == 4 : 0) ? (c[j >> 2] | 0) == (c[k >> 2] | 0) : 0) {
	                                c[j >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                                c[c[j >> 2] >> 2] = 18;
	                                c[(c[j >> 2] | 0) + 24 >> 2] = c[k >> 2]
	                            }
	                            c[(c[k >> 2] | 0) + 32 >> 2] = c[l >> 2];
	                            c[k >> 2] = c[l >> 2]
	                        }
	                        c[(c[l >> 2] | 0) + 28 >> 2] = c[m >> 2]
	                    } else n = 16;
	                    do if ((n | 0) == 16 ? (n = 0, c[l >> 2] = bP(c[f >> 2] | 0, c[g >> 2] | 0) | 0, (c[l >> 2] | 0) != 0) : 0) {
	                        d = c[l >> 2] | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            c[k >> 2] = d;
	                            c[j >> 2] = d;
	                            break
	                        } else {
	                            c[(c[k >> 2] | 0) + 32 >> 2] = d;
	                            c[k >> 2] = c[l >> 2];
	                            break
	                        }
	                    } while (0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                i = e;
	                return c[j >> 2] | 0
	            }

	            function yO(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 8 | 0;
	                h = f + 4 | 0;
	                j = f;
	                c[f + 12 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                do if (!(c[j >> 2] | 0)) {
	                    if (!(c[h >> 2] | 0)) {
	                        c[c[g >> 2] >> 2] = -1;
	                        c[j >> 2] = c[g >> 2];
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 24 >> 2] | 0) == (c[g >> 2] | 0)) {
	                        c[(c[h >> 2] | 0) + 24 >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 36 >> 2] | 0) == (c[g >> 2] | 0)) {
	                        c[(c[h >> 2] | 0) + 36 >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                        break
	                    }
	                    if ((c[(c[h >> 2] | 0) + 40 >> 2] | 0) == (c[g >> 2] | 0))c[(c[h >> 2] | 0) + 40 >> 2] = c[(c[g >> 2] | 0) + 32 >> 2]
	                } else c[(c[j >> 2] | 0) + 32 >> 2] = c[(c[g >> 2] | 0) + 32 >> 2]; while (0);
	                i = f;
	                return c[j >> 2] | 0
	            }

	            function zO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                    c[e >> 2] = -1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                c[h >> 2] = 0;
	                c[j >> 2] = c[g >> 2];
	                a:while (1) {
	                    if (!(c[j >> 2] | 0)) {
	                        m = 36;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 4) {
	                        m = 12;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 3) {
	                        m = 12;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 5) {
	                        m = 12;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 6) {
	                        m = 12;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 8) {
	                        m = 12;
	                        break
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 7) {
	                        m = 12;
	                        break
	                    }
	                    if (!(c[c[j >> 2] >> 2] | 0)) {
	                        m = 12;
	                        break
	                    }
	                    if (!((((((((((c[c[j >> 2] >> 2] | 0) != 17 ? (c[c[j >> 2] >> 2] | 0) != 19 : 0) ? (c[c[j >> 2] >> 2] | 0) != 18 : 0) ? (c[c[j >> 2] >> 2] | 0) != 16 : 0) ? (c[c[j >> 2] >> 2] | 0) != 15 : 0) ? (c[c[j >> 2] >> 2] | 0) != 14 : 0) ? (c[c[j >> 2] >> 2] | 0) != 13 : 0) ? (c[c[j >> 2] >> 2] | 0) != 12 : 0) ? (c[c[j >> 2] >> 2] | 0) != 11 : 0) ? (c[c[j >> 2] >> 2] | 0) != 10 : 0))m = 23;
	                    if ((m | 0) == 23 ? (m = 0, (c[(c[j >> 2] | 0) + 24 >> 2] | 0) != 0) : 0) {
	                        c[h >> 2] = c[j >> 2];
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2];
	                        c[k >> 2] = c[j >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))continue a;
	                            c[(c[k >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                        }
	                    }
	                    if ((c[j >> 2] | 0) == (c[g >> 2] | 0)) {
	                        m = 36;
	                        break
	                    }
	                    if (c[(c[j >> 2] | 0) + 32 >> 2] | 0) {
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2];
	                        continue
	                    }
	                    while (1) {
	                        c[j >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                        if (!(c[j >> 2] | 0))continue a;
	                        if ((c[j >> 2] | 0) == (c[g >> 2] | 0)) {
	                            m = 32;
	                            break a
	                        }
	                        n = c[j >> 2] | 0;
	                        if (c[(c[j >> 2] | 0) + 32 >> 2] | 0)break;
	                        if (!n)continue a
	                    }
	                    c[j >> 2] = c[n + 32 >> 2]
	                }
	                if ((m | 0) == 12) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 32) {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 36) {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function AO(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[f >> 2] = a;
	                c[g >> 2] = d;
	                c[k >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[c[g >> 2] >> 2] | 0) != 18 ? (c[c[g >> 2] >> 2] | 0) != 4 : 0) {
	                    i = e;
	                    return
	                }
	                if (b[(c[g >> 2] | 0) + 50 >> 1] & 32) {
	                    i = e;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = c[(c[g >> 2] | 0) + 36 >> 2];
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                }
	                c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    c[k >> 2] = (c[k >> 2] | 0) + 1;
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                }
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](c[k >> 2] << 2) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    xN(c[f >> 2] | 0, 191880);
	                    i = e;
	                    return
	                }
	                c[l >> 2] = 0;
	                c[j >> 2] = c[(c[g >> 2] | 0) + 36 >> 2];
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    d = aO(c[f >> 2] | 0, c[j >> 2] | 0, 1) | 0;
	                    c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] = d;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                }
	                c[j >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    d = aO(c[f >> 2] | 0, c[j >> 2] | 0, 1) | 0;
	                    c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] = d;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                }
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >= (c[k >> 2] | 0))break;
	                    a:do if (c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0) {
	                        c[m >> 2] = 0;
	                        while (1) {
	                            if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break a;
	                            if ((c[(c[h >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) != 0 ? (c[n >> 2] = bO(c[f >> 2] | 0, c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0, c[(c[h >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) | 0, (c[n >> 2] | 0) == 0) : 0)zN(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] | 0, 1040, 191896, 0, 0);
	                            c[m >> 2] = (c[m >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >= (c[k >> 2] | 0))break;
	                    if (c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + (c[l >> 2] << 2) >> 2] | 0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                h = (c[g >> 2] | 0) + 50 | 0;
	                b[h >> 1] = b[h >> 1] | 32;
	                i = e;
	                return
	            }

	            function BO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (!((c[f >> 2] | 0) == -1 | (c[g >> 2] | 0) == -1)) {
	                    b = c[g >> 2] | 0;
	                    if (!(c[f >> 2] | 0)) {
	                        c[e >> 2] = b;
	                        break
	                    }
	                    a = c[f >> 2] | 0;
	                    if (!b) {
	                        c[e >> 2] = a;
	                        break
	                    }
	                    if ((a | 0) == 2 & (c[g >> 2] | 0) == 2) {
	                        c[e >> 2] = 2;
	                        break
	                    } else {
	                        c[e >> 2] = -1;
	                        break
	                    }
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function CO(a, e) {
	                a = a | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 52 | 0;
	                h = f + 48 | 0;
	                j = f + 44 | 0;
	                k = f + 40 | 0;
	                l = f + 36 | 0;
	                m = f + 32 | 0;
	                n = f + 28 | 0;
	                o = f + 24 | 0;
	                p = f + 20 | 0;
	                q = f + 16 | 0;
	                r = f + 12 | 0;
	                s = f + 8 | 0;
	                t = f + 4 | 0;
	                u = f;
	                c[g >> 2] = a;
	                c[h >> 2] = e;
	                c[l >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 1;
	                if (!(c[h >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if ((c[c[h >> 2] >> 2] | 0) != 17) {
	                    i = f;
	                    return
	                }
	                if (b[(c[h >> 2] | 0) + 50 >> 1] & 32) {
	                    i = f;
	                    return
	                }
	                if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                c[p >> 2] = cP(c[h >> 2] | 0) | 0;
	                c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                }
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](c[l >> 2] << 2) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    xN(c[g >> 2] | 0, 191856);
	                    i = f;
	                    return
	                }
	                c[m >> 2] = 0;
	                if (!(c[p >> 2] | 0))c[r >> 2] = Ij(10) | 0; else c[s >> 2] = 0;
	                c[k >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    p = aO(c[g >> 2] | 0, c[k >> 2] | 0, 0) | 0;
	                    c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] = p;
	                    a:do if ((c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) != 0 ? (c[c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] >> 2] | 0) != 0 : 0) {
	                        if ((c[s >> 2] | 0) == 1) {
	                            c[t >> 2] = c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2];
	                            while (1) {
	                                if (!((c[s >> 2] | 0) == 1 ? (c[c[t >> 2] >> 2] | 0) != 0 : 0))break a;
	                                do if ((c[c[c[t >> 2] >> 2] >> 2] | 0) == 3) {
	                                    c[u >> 2] = Nj(c[r >> 2] | 0, 188096, 0, c[k >> 2] | 0) | 0;
	                                    if (c[u >> 2] | 0)c[s >> 2] = -1
	                                } else {
	                                    if ((c[c[c[t >> 2] >> 2] >> 2] | 0) == 4 ? (c[(c[c[t >> 2] >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                                        do if (!(c[(c[c[t >> 2] >> 2] | 0) + 12 >> 2] | 0))v = 28; else {
	                                            if (!(d[c[(c[c[t >> 2] >> 2] | 0) + 12 >> 2] >> 0] | 0)) {
	                                                v = 28;
	                                                break
	                                            }
	                                            c[u >> 2] = Nj(c[r >> 2] | 0, c[(c[c[t >> 2] >> 2] | 0) + 8 >> 2] | 0, c[(c[c[t >> 2] >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0) | 0
	                                        } while (0);
	                                        if ((v | 0) == 28) {
	                                            v = 0;
	                                            c[u >> 2] = Nj(c[r >> 2] | 0, c[(c[c[t >> 2] >> 2] | 0) + 8 >> 2] | 0, 0, c[k >> 2] | 0) | 0
	                                        }
	                                        if (!(c[u >> 2] | 0))break;
	                                        c[s >> 2] = -1;
	                                        break
	                                    }
	                                    if ((c[c[c[t >> 2] >> 2] >> 2] | 0) != 4) {
	                                        c[s >> 2] = -1;
	                                        break
	                                    }
	                                    do if (!(c[(c[c[t >> 2] >> 2] | 0) + 12 >> 2] | 0))v = 35; else {
	                                        if (!(d[c[(c[c[t >> 2] >> 2] | 0) + 12 >> 2] >> 0] | 0)) {
	                                            v = 35;
	                                            break
	                                        }
	                                        c[u >> 2] = Nj(c[r >> 2] | 0, 189536, c[(c[c[t >> 2] >> 2] | 0) + 12 >> 2] | 0, c[k >> 2] | 0) | 0
	                                    } while (0);
	                                    if ((v | 0) == 35) {
	                                        v = 0;
	                                        c[u >> 2] = Nj(c[r >> 2] | 0, 189536, 0, c[k >> 2] | 0) | 0
	                                    }
	                                    if (c[u >> 2] | 0)c[s >> 2] = -1
	                                } while (0);
	                                c[t >> 2] = (c[t >> 2] | 0) + 4
	                            }
	                        }
	                    } else v = 17; while (0);
	                    if ((v | 0) == 17) {
	                        v = 0;
	                        c[s >> 2] = 0
	                    }
	                    c[m >> 2] = (c[m >> 2] | 0) + 1;
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 32 >> 2]
	                }
	                c[m >> 2] = 0;
	                while (1) {
	                    if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                    b:do if (c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0) {
	                        c[n >> 2] = 0;
	                        while (1) {
	                            if ((c[n >> 2] | 0) >= (c[m >> 2] | 0))break b;
	                            if ((c[(c[j >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0) != 0 ? (c[o >> 2] = bO(c[g >> 2] | 0, c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0, c[(c[j >> 2] | 0) + (c[n >> 2] << 2) >> 2] | 0) | 0, (c[o >> 2] | 0) == 0) : 0)c[q >> 2] = 1;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                c[m >> 2] = 0;
	                while (1) {
	                    if ((c[m >> 2] | 0) >= (c[l >> 2] | 0))break;
	                    if (c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[j >> 2] | 0) + (c[m >> 2] << 2) >> 2] | 0);
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                if (c[q >> 2] | 0) {
	                    q = (c[h >> 2] | 0) + 50 | 0;
	                    b[q >> 1] = b[q >> 1] | 4
	                }
	                if ((c[s >> 2] | 0) != 1) {
	                    if (c[r >> 2] | 0)Kj(c[r >> 2] | 0, 0)
	                } else {
	                    s = (c[h >> 2] | 0) + 50 | 0;
	                    b[s >> 1] = b[s >> 1] | 16;
	                    c[(c[h >> 2] | 0) + 20 >> 2] = c[r >> 2]
	                }
	                r = (c[h >> 2] | 0) + 50 | 0;
	                b[r >> 1] = b[r >> 1] | 32;
	                i = f;
	                return
	            }

	            function DO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (!((c[f >> 2] | 0) == -1 | (c[g >> 2] | 0) == -1)) {
	                    if ((c[f >> 2] | 0) == 1 | (c[g >> 2] | 0) == 1) {
	                        c[e >> 2] = 1;
	                        break
	                    }
	                    if ((c[f >> 2] | 0) == 2 | (c[g >> 2] | 0) == 2) {
	                        c[e >> 2] = 2;
	                        break
	                    } else {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function EO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 240 | 0;
	                f = e;
	                g = e + 224 | 0;
	                h = e + 220 | 0;
	                j = e + 216 | 0;
	                k = e + 212 | 0;
	                l = e + 152 | 0;
	                m = e + 128 | 0;
	                n = e + 8 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = 1;
	                b = n + 0 | 0;
	                a = b + 116 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[n + 28 >> 2] = 9;
	                do if ((c[c[h >> 2] >> 2] | 0) != 4 ? (c[c[h >> 2] >> 2] | 0) != 9 : 0) {
	                    if ((c[c[h >> 2] >> 2] | 0) != 3) {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        if ((c[c[h >> 2] >> 2] | 0) == 2) {
	                            c[f >> 2] = 189496;
	                            c[f + 4 >> 2] = 3822;
	                            Db[b & 511](a, 189464, f);
	                            c[k >> 2] = 0;
	                            break
	                        } else {
	                            c[f >> 2] = 189496;
	                            c[f + 4 >> 2] = 3824;
	                            Db[b & 511](a, 189464, f);
	                            c[k >> 2] = 0;
	                            break
	                        }
	                    }
	                    if ((c[c[j >> 2] >> 2] | 0) == 3) {
	                        c[g >> 2] = 0;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    } else {
	                        c[g >> 2] = 1;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                } else p = 3; while (0);
	                do if ((p | 0) == 3) {
	                    if ((c[c[j >> 2] >> 2] | 0) == 3) {
	                        c[g >> 2] = 1;
	                        o = c[g >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    if (c[(c[h >> 2] | 0) + 8 >> 2] | 0)c[l + 8 >> 2] = c[(c[h >> 2] | 0) + 8 >> 2]; else c[l + 8 >> 2] = c[47556];
	                    do if (c[(c[h >> 2] | 0) + 12 >> 2] | 0) {
	                        a = l + 36 | 0;
	                        if (!(d[c[(c[h >> 2] | 0) + 12 >> 2] >> 0] | 0)) {
	                            c[a >> 2] = 0;
	                            break
	                        } else {
	                            c[a >> 2] = m;
	                            c[m + 8 >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                            break
	                        }
	                    } else c[l + 36 >> 2] = 0; while (0);
	                    if (!(MO(n, c[j >> 2] | 0, l) | 0)) {
	                        c[k >> 2] = 1;
	                        break
	                    }
	                    if (c[(c[h >> 2] | 0) + 40 >> 2] | 0) {
	                        c[k >> 2] = EO(c[(c[h >> 2] | 0) + 40 >> 2] | 0, c[j >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[k >> 2] = 0;
	                        break
	                    }
	                } while (0);
	                if (!(c[k >> 2] | 0)) {
	                    c[g >> 2] = c[k >> 2];
	                    o = c[g >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if ((c[c[j >> 2] >> 2] | 0) != 4 ? (c[c[j >> 2] >> 2] | 0) != 9 : 0) {
	                    a = c[33976] | 0;
	                    b = c[33980] | 0;
	                    c[f >> 2] = 189496;
	                    c[f + 4 >> 2] = 3855;
	                    Db[a & 511](b, 189464, f);
	                    c[k >> 2] = 0
	                } else p = 29;
	                do if ((p | 0) == 29) {
	                    if (c[(c[j >> 2] | 0) + 8 >> 2] | 0)c[l + 8 >> 2] = c[(c[j >> 2] | 0) + 8 >> 2]; else c[l + 8 >> 2] = c[47556];
	                    c[l + 36 >> 2] = m;
	                    do if (c[(c[j >> 2] | 0) + 12 >> 2] | 0)if (!(d[c[(c[j >> 2] | 0) + 12 >> 2] >> 0] | 0)) {
	                        c[l + 36 >> 2] = 0;
	                        break
	                    } else {
	                        c[m + 8 >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        break
	                    } else c[m + 8 >> 2] = c[47556]; while (0);
	                    if (!(MO(n, c[h >> 2] | 0, l) | 0)) {
	                        c[k >> 2] = 1;
	                        break
	                    }
	                    if (c[(c[j >> 2] | 0) + 40 >> 2] | 0) {
	                        c[k >> 2] = EO(c[(c[j >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0) | 0;
	                        break
	                    } else {
	                        c[k >> 2] = 0;
	                        break
	                    }
	                } while (0);
	                c[g >> 2] = c[k >> 2];
	                o = c[g >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function FO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                a:do if (!(c[e >> 2] | 0))c[d >> 2] = 189816; else do switch (c[c[e >> 2] >> 2] | 0) {
	                    case 10:
	                    {
	                        c[d >> 2] = 189920;
	                        break a;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[d >> 2] = 189872;
	                        break a;
	                        break
	                    }
	                    case 17:
	                    {
	                        c[d >> 2] = 190016;
	                        break a;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[d >> 2] = 19e4;
	                        break a;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[d >> 2] = 189896;
	                        break a;
	                        break
	                    }
	                    case 13:
	                    {
	                        c[d >> 2] = 189952;
	                        break a;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[d >> 2] = 189936;
	                        break a;
	                        break
	                    }
	                    case 6:
	                    {
	                        c[d >> 2] = 190064;
	                        break a;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[d >> 2] = 189848;
	                        break a;
	                        break
	                    }
	                    case 19:
	                    {
	                        c[d >> 2] = 190032;
	                        break a;
	                        break
	                    }
	                    case 0:
	                    {
	                        c[d >> 2] = 189824;
	                        break a;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[d >> 2] = 189984;
	                        break a;
	                        break
	                    }
	                    case 18:
	                    {
	                        c[d >> 2] = 190024;
	                        break a;
	                        break
	                    }
	                    case 11:
	                    {
	                        c[d >> 2] = 189928;
	                        break a;
	                        break
	                    }
	                    case 20:
	                    {
	                        c[d >> 2] = 190048;
	                        break a;
	                        break
	                    }
	                    case 9:
	                    {
	                        c[d >> 2] = 189904;
	                        break a;
	                        break
	                    }
	                    case -1:
	                    {
	                        c[d >> 2] = 190056;
	                        break a;
	                        break
	                    }
	                    case 3:
	                    {
	                        c[d >> 2] = 189856;
	                        break a;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[d >> 2] = 189832;
	                        break a;
	                        break
	                    }
	                    case 14:
	                    {
	                        c[d >> 2] = 189968;
	                        break a;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[d >> 2] = 189888;
	                        break a;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[d >> 2] = 189864;
	                        break a;
	                        break
	                    }
	                    default:
	                    {
	                        c[d >> 2] = 190072;
	                        break a
	                    }
	                } while (0); while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function GO(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 1024 | 0;
	                g = f;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 24 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (!(c[k >> 2] | 0))c[k >> 2] = 188112;
	                if (!(c[l >> 2] | 0))c[l >> 2] = 188112;
	                a[m >> 0] = 0;
	                do switch (c[j >> 2] | 0) {
	                    case 34:
	                    {
	                        c[h >> 2] = oy(189280) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 6:
	                    {
	                        c[h >> 2] = oy(188288) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 11:
	                    {
	                        c[h >> 2] = oy(188440) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 19:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188712, g) | 0;
	                        break
	                    }
	                    case 13:
	                    {
	                        e = c[l >> 2] | 0;
	                        c[g >> 2] = c[k >> 2];
	                        c[g + 4 >> 2] = e;
	                        JT(m, 1e3, 188504, g) | 0;
	                        break
	                    }
	                    case 12:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188472, g) | 0;
	                        break
	                    }
	                    case 27:
	                    {
	                        e = c[l >> 2] | 0;
	                        c[g >> 2] = c[k >> 2];
	                        c[g + 4 >> 2] = e;
	                        JT(m, 1e3, 188992, g) | 0;
	                        break
	                    }
	                    case 4:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188232, g) | 0;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188376, g) | 0;
	                        break
	                    }
	                    case 23:
	                    {
	                        c[h >> 2] = oy(188832) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 37:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188352, g) | 0;
	                        break
	                    }
	                    case 29:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 189112, g) | 0;
	                        break
	                    }
	                    case 21:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188752, g) | 0;
	                        break
	                    }
	                    case 28:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 189072, g) | 0;
	                        break
	                    }
	                    case 0:
	                    {
	                        c[h >> 2] = 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 17:
	                    {
	                        e = c[l >> 2] | 0;
	                        c[g >> 2] = c[k >> 2];
	                        c[g + 4 >> 2] = e;
	                        JT(m, 1e3, 188576, g) | 0;
	                        break
	                    }
	                    case 35:
	                    {
	                        c[h >> 2] = oy(189304) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 32:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 189224, g) | 0;
	                        break
	                    }
	                    case 25:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188912, g) | 0;
	                        break
	                    }
	                    case 36:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 189032, g) | 0;
	                        break
	                    }
	                    case 15:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188536, g) | 0;
	                        break
	                    }
	                    case 39:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188664, g) | 0;
	                        break
	                    }
	                    case 7:
	                    {
	                        c[h >> 2] = oy(188320) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 33:
	                    {
	                        c[h >> 2] = oy(189256) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 30:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 189152, g) | 0;
	                        break
	                    }
	                    case 38:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188624, g) | 0;
	                        break
	                    }
	                    case 5:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188256, g) | 0;
	                        break
	                    }
	                    case 22:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188792, g) | 0;
	                        break
	                    }
	                    case 1:
	                    {
	                        c[h >> 2] = oy(188144) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 10:
	                    {
	                        c[h >> 2] = oy(188400) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                    case 31:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 189192, g) | 0;
	                        break
	                    }
	                    case 3:
	                    {
	                        e = c[l >> 2] | 0;
	                        c[g >> 2] = c[k >> 2];
	                        c[g + 4 >> 2] = e;
	                        JT(m, 1e3, 188192, g) | 0;
	                        break
	                    }
	                    case 2:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188160, g) | 0;
	                        break
	                    }
	                    case 24:
	                    {
	                        c[g >> 2] = c[k >> 2];
	                        JT(m, 1e3, 188864, g) | 0;
	                        break
	                    }
	                    case 26:
	                    {
	                        e = c[l >> 2] | 0;
	                        c[g >> 2] = c[k >> 2];
	                        c[g + 4 >> 2] = e;
	                        JT(m, 1e3, 188952, g) | 0;
	                        break
	                    }
	                    default:
	                    {
	                        c[h >> 2] = oy(189336) | 0;
	                        n = c[h >> 2] | 0;
	                        i = f;
	                        return n | 0
	                    }
	                } while (0);
	                if (!(a[m >> 0] | 0)) {
	                    c[g >> 2] = c[j >> 2];
	                    JT(m, 1e3, 189360, g) | 0
	                }
	                a[m + 999 >> 0] = 0;
	                c[h >> 2] = my(m) | 0;
	                n = c[h >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function HO(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                if (c[k >> 2] | 0) {
	                    g = c[k >> 2] | 0;
	                    if (c[(c[k >> 2] | 0) + 12 >> 2] | 0)c[q >> 2] = c[g + 12 >> 2]; else c[r >> 2] = c[g + 4 >> 2];
	                    c[s >> 2] = c[c[k >> 2] >> 2];
	                    g = (c[k >> 2] | 0) + 16 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                g = c[q >> 2] | 0;
	                q = c[r >> 2] | 0;
	                r = c[s >> 2] | 0;
	                s = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                k = c[p >> 2] | 0;
	                f = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                c[j >> 2] = c[o >> 2];
	                c[j + 4 >> 2] = n;
	                Xd(g, q, r, 0, s, 19, l, 2, 0, 0, m, k, 0, 0, 0, f, j);
	                i = h;
	                return
	            }

	            function IO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 16 >> 2] | 0) <= 0) {
	                    c[f >> 2] = -1;
	                    q = c[f >> 2] | 0;
	                    i = e;
	                    return q | 0
	                }
	                b = (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0;
	                c[k >> 2] = 0;
	                do if (b) {
	                    while (1) {
	                        if ((c[k >> 2] | 0) >= (c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 8 >> 2] | 0))break;
	                        c[o >> 2] = c[(c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 28 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        if ((c[o >> 2] | 0) != 0 ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) {
	                            if (!((c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 ? (d[c[(c[h >> 2] | 0) + 12 >> 2] >> 0] | 0 | 0) != 0 : 0))r = 9;
	                            if ((r | 0) == 9 ? (r = 0, (c[(c[o >> 2] | 0) + 36 >> 2] | 0) == 0) : 0) {
	                                r = 12;
	                                break
	                            }
	                            if ((c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[(c[h >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) {
	                                r = 12;
	                                break
	                            }
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((r | 0) == 12)c[n >> 2] = c[o >> 2];
	                    if (!(c[n >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        break
	                    }
	                    c[l >> 2] = _h(c[(c[n >> 2] | 0) + 32 >> 2] | 0, c[(c[n >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                    c[m >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                    c[p >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = 0;
	                    c[j >> 2] = dP(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    if (c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0)c[l >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                    if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                    if (!(c[j >> 2] | 0)) {
	                        c[(c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 28 >> 2] | 0) + (c[k >> 2] << 2) >> 2] = 0;
	                        a = (c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + -1
	                    }
	                } else {
	                    while (1) {
	                        if ((c[k >> 2] | 0) >= (c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 8 >> 2] | 0))break;
	                        c[o >> 2] = c[(c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 28 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        if ((c[o >> 2] | 0) != 0 ? (eP(c[g >> 2] | 0, c[h >> 2] | 0, c[o >> 2] | 0) | 0) == 1 : 0) {
	                            r = 25;
	                            break
	                        }
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((r | 0) == 25)c[n >> 2] = c[o >> 2];
	                    if (!(c[n >> 2] | 0)) {
	                        c[j >> 2] = -1;
	                        break
	                    }
	                    c[l >> 2] = _h(c[(c[n >> 2] | 0) + 32 >> 2] | 0, c[(c[n >> 2] | 0) + 12 >> 2] | 0, 1) | 0;
	                    c[m >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                    c[p >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                    c[j >> 2] = dP(c[g >> 2] | 0, c[(c[h >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    if (c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0)c[l >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                    if (c[l >> 2] | 0)zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                    if (!(c[j >> 2] | 0)) {
	                        c[(c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 28 >> 2] | 0) + (c[k >> 2] << 2) >> 2] = 0;
	                        a = (c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + -1
	                    }
	                } while (0);
	                c[f >> 2] = c[j >> 2];
	                q = c[f >> 2] | 0;
	                i = e;
	                return q | 0
	            }

	            function JO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                c[j >> 2] = -1;
	                c[k >> 2] = 1e6;
	                if (((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 64 >> 2] | 0) != 0 : 0) ? (c[c[(c[e >> 2] | 0) + 64 >> 2] >> 2] | 0) > 0 : 0) {
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[c[(c[e >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                        c[f >> 2] = c[(c[(c[(c[e >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[g >> 2] << 2) >> 2];
	                        do if (c[f >> 2] | 0) {
	                            if (c[(c[f >> 2] | 0) + 4 >> 2] | 0) {
	                                if (!((c[j >> 2] | 0) == -1 | (c[k >> 2] | 0) > 1e5))break;
	                                c[k >> 2] = 1e5;
	                                c[j >> 2] = c[g >> 2];
	                                break
	                            }
	                            c[h >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                            if ((c[j >> 2] | 0) != -1 ? (c[k >> 2] | 0) <= (c[h >> 2] | 0) : 0)break;
	                            c[k >> 2] = c[h >> 2];
	                            c[j >> 2] = c[g >> 2]
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    c[d >> 2] = c[j >> 2];
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                }
	                c[d >> 2] = -1;
	                l = c[d >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function KO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                while (1) {
	                    if ((c[g >> 2] | 0) >= (c[(c[e >> 2] | 0) + 48 >> 2] | 0))break;
	                    c[h >> 2] = (c[(c[e >> 2] | 0) + 56 >> 2] | 0) + ((c[g >> 2] | 0) * 24 | 0);
	                    if (c[(c[h >> 2] | 0) + 4 >> 2] & 1) {
	                        if (c[(c[h >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 16 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 16 >> 2] = 0;
	                        if (c[(c[h >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 20 >> 2] | 0);
	                        c[(c[h >> 2] | 0) + 20 >> 2] = 0;
	                        c[(c[h >> 2] | 0) + 4 >> 2] = 0
	                    }
	                    c[g >> 2] = (c[g >> 2] | 0) + 1
	                }
	                c[(c[e >> 2] | 0) + 48 >> 2] = c[f >> 2];
	                if ((c[(c[e >> 2] | 0) + 48 >> 2] | 0) > 0) {
	                    i = d;
	                    return
	                }
	                c[(c[e >> 2] | 0) + 44 >> 2] = 0;
	                i = d;
	                return
	            }

	            function LO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                a = c[d >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 48 >> 2] | 0) <= 0) {
	                    c[a + 44 >> 2] = 0;
	                    i = b;
	                    return
	                }
	                f = a + 48 | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + -1;
	                f = c[d >> 2] | 0;
	                if ((c[(c[d >> 2] | 0) + 48 >> 2] | 0) > 0)c[(c[d >> 2] | 0) + 44 >> 2] = (c[(c[d >> 2] | 0) + 56 >> 2] | 0) + (((c[f + 48 >> 2] | 0) - 1 | 0) * 24 | 0); else c[f + 44 >> 2] = 0;
	                c[e >> 2] = (c[(c[d >> 2] | 0) + 56 >> 2] | 0) + ((c[(c[d >> 2] | 0) + 48 >> 2] | 0) * 24 | 0);
	                if (!(c[(c[e >> 2] | 0) + 4 >> 2] & 1)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[e >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 16 >> 2] | 0);
	                c[(c[e >> 2] | 0) + 16 >> 2] = 0;
	                if (c[(c[e >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 4 >> 2] = 0;
	                i = b;
	                return
	            }

	            function MO(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 36 | 0;
	                j = f + 32 | 0;
	                k = f + 28 | 0;
	                l = f + 24 | 0;
	                m = f + 20 | 0;
	                n = f + 16 | 0;
	                o = f + 12 | 0;
	                p = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = 0;
	                c[n >> 2] = 0;
	                if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0) {
	                    FN(c[j >> 2] | 0, 13, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[h >> 2] = 0;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if ((c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 ? (d[c[(c[k >> 2] | 0) + 12 >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                    if (!(c[(c[l >> 2] | 0) + 36 >> 2] | 0)) {
	                        FN(c[j >> 2] | 0, 15, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                    if (!(qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0) | 0)) {
	                        FN(c[j >> 2] | 0, 17, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 12 >> 2] | 0, 0);
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                } else {
	                    if (((c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                        FN(c[j >> 2] | 0, 19, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                    if ((c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        FN(c[j >> 2] | 0, 19, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    }
	                }
	                if (!(c[(c[k >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[h >> 2] = 1;
	                    q = c[h >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[k >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                do if ((c[c[k >> 2] >> 2] | 0) == 2) {
	                    if (c[j >> 2] | 0) {
	                        c[n >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                        e = (c[j >> 2] | 0) + 28 | 0;
	                        c[e >> 2] = c[e >> 2] | 1
	                    }
	                    c[o >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (!(c[o >> 2] | 0)) {
	                            r = 33;
	                            break
	                        }
	                        c[m >> 2] = MO(c[j >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) == 1) {
	                            r = 25;
	                            break
	                        }
	                        if ((c[m >> 2] | 0) < 0) {
	                            r = 29;
	                            break
	                        }
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 32 >> 2]
	                    }
	                    if ((r | 0) == 25) {
	                        if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        c[h >> 2] = 0;
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    } else if ((r | 0) == 29) {
	                        if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        c[h >> 2] = c[m >> 2];
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    } else if ((r | 0) == 33) {
	                        c[m >> 2] = 1;
	                        if (!(c[j >> 2] | 0))break;
	                        c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        break
	                    }
	                } else {
	                    if ((c[c[k >> 2] >> 2] | 0) != 17) {
	                        e = c[33976] | 0;
	                        b = c[33980] | 0;
	                        c[g >> 2] = 189496;
	                        c[g + 4 >> 2] = 9708;
	                        Db[e & 511](b, 189464, g);
	                        c[m >> 2] = -1;
	                        break
	                    }
	                    if (c[j >> 2] | 0) {
	                        c[n >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                        b = (c[j >> 2] | 0) + 28 | 0;
	                        c[b >> 2] = c[b >> 2] | 1
	                    }
	                    c[p >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                    while (1) {
	                        s = c[j >> 2] | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            r = 49;
	                            break
	                        }
	                        c[m >> 2] = MO(s, c[p >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) == 1) {
	                            r = 41;
	                            break
	                        }
	                        if ((c[m >> 2] | 0) < 0) {
	                            r = 45;
	                            break
	                        }
	                        c[p >> 2] = c[(c[p >> 2] | 0) + 32 >> 2]
	                    }
	                    if ((r | 0) == 41) {
	                        if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        c[h >> 2] = 1;
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    } else if ((r | 0) == 45) {
	                        if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        c[h >> 2] = c[m >> 2];
	                        q = c[h >> 2] | 0;
	                        i = f;
	                        return q | 0
	                    } else if ((r | 0) == 49) {
	                        do if (s) {
	                            b = c[j >> 2] | 0;
	                            if (c[m >> 2] | 0) {
	                                if (c[b + 28 >> 2] & 1)break;
	                                eO(c[j >> 2] | 0);
	                                break
	                            } else {
	                                if ((c[b + 48 >> 2] | 0) <= 0)break;
	                                KO(c[j >> 2] | 0, 0);
	                                break
	                            }
	                        } while (0);
	                        c[m >> 2] = 0;
	                        if (!(c[j >> 2] | 0))break;
	                        c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        break
	                    }
	                } while (0);
	                c[h >> 2] = c[m >> 2];
	                q = c[h >> 2] | 0;
	                i = f;
	                return q | 0
	            }

	            function NO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                c[n >> 2] = c[(c[g >> 2] | 0) + 112 >> 2];
	                c[k >> 2] = oz(c[h >> 2] | 0, 385, c[g >> 2] | 0) | 0;
	                c[(c[g >> 2] | 0) + 112 >> 2] = 0;
	                c[l >> 2] = c[j >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                    j = c[(c[l >> 2] | 0) + 4 >> 2] | 0;
	                    if ((j | 0) == 1) {
	                        h = c[k >> 2] | 0;
	                        d = c[(c[l >> 2] | 0) + 8 >> 2] | 0;
	                        if (c[(c[l >> 2] | 0) + 36 >> 2] | 0)c[m >> 2] = rz(h, d, c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0; else c[m >> 2] = qz(h, d, c[g >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) < 0)FN(c[g >> 2] | 0, 38, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0, 0)
	                    } else if (((j | 0) == 4 | (j | 0) == 3 ? (ij(c[l >> 2] | 0) | 0) == 0 : 0) ? (c[m >> 2] = qz(c[k >> 2] | 0, 188096, c[g >> 2] | 0) | 0, (c[m >> 2] | 0) < 0) : 0)FN(c[g >> 2] | 0, 39, c[(c[(c[l >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                    if ((c[m >> 2] | 0) < 0)break;
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                c[m >> 2] = qz(c[k >> 2] | 0, 0, 0) | 0;
	                do if ((c[m >> 2] | 0) != 1) {
	                    if (c[m >> 2] | 0) {
	                        c[m >> 2] = -1;
	                        break
	                    }
	                    FN(c[g >> 2] | 0, 22, 188112, 0, 0);
	                    c[m >> 2] = -1;
	                    if (!(c[(c[g >> 2] | 0) + 28 >> 2] & 1))eO(c[g >> 2] | 0)
	                } else {
	                    c[m >> 2] = 0;
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = 0
	                } while (0);
	                pz(c[k >> 2] | 0);
	                if ((c[m >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 112 >> 2] | 0) != 0 : 0)c[m >> 2] = c[(c[g >> 2] | 0) + 112 >> 2];
	                c[(c[g >> 2] | 0) + 112 >> 2] = c[n >> 2];
	                c[f >> 2] = c[m >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function OO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    FN(c[f >> 2] | 0, 37, 189592, 0, 0);
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        l = 11;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 60 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 64 >> 2] | 0) == 0 : 0) {
	                        l = 8;
	                        break
	                    }
	                    c[j >> 2] = KN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[j >> 2] | 0) < 0)c[h >> 2] = -1;
	                    if ((c[j >> 2] | 0) == -1) {
	                        l = 11;
	                        break
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 32 >> 2]
	                }
	                if ((l | 0) == 8) {
	                    FN(c[f >> 2] | 0, 6, 0, 0, 0);
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else if ((l | 0) == 11) {
	                    c[e >> 2] = c[h >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function PO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 68 >> 2] | 0) != 0 ? (c[c[(c[f >> 2] | 0) + 68 >> 2] >> 2] | 0) > 0 : 0) {
	                    b = c[(c[f >> 2] | 0) + 68 >> 2] | 0;
	                    c[b >> 2] = (c[b >> 2] | 0) + -1;
	                    c[h >> 2] = c[(c[(c[(c[f >> 2] | 0) + 68 >> 2] | 0) + 8 >> 2] | 0) + (c[c[(c[f >> 2] | 0) + 68 >> 2] >> 2] << 2) >> 2]
	                } else n = 6;
	                do if ((n | 0) == 6) {
	                    c[h >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                    if (c[h >> 2] | 0) {
	                        b = c[h >> 2] | 0;
	                        c[b + 0 >> 2] = 0;
	                        c[b + 4 >> 2] = 0;
	                        c[b + 8 >> 2] = 0;
	                        c[b + 12 >> 2] = 0;
	                        c[b + 16 >> 2] = 0;
	                        c[b + 20 >> 2] = 0;
	                        c[b + 24 >> 2] = 0;
	                        c[b + 28 >> 2] = 0;
	                        break
	                    }
	                    MN(c[f >> 2] | 0, 189568);
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                } while (0);
	                c[k >> 2] = c[(c[h >> 2] | 0) + 28 >> 2];
	                c[j >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                n = c[h >> 2] | 0;
	                b = c[g >> 2] | 0;
	                c[n + 0 >> 2] = c[b + 0 >> 2];
	                c[n + 4 >> 2] = c[b + 4 >> 2];
	                c[n + 8 >> 2] = c[b + 8 >> 2];
	                c[n + 12 >> 2] = c[b + 12 >> 2];
	                c[n + 16 >> 2] = c[b + 16 >> 2];
	                c[n + 20 >> 2] = c[b + 20 >> 2];
	                c[n + 24 >> 2] = c[b + 24 >> 2];
	                c[n + 28 >> 2] = c[b + 28 >> 2];
	                c[(c[h >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                c[(c[h >> 2] | 0) + 12 >> 2] = c[j >> 2];
	                if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) > 0) {
	                    do if (!(c[(c[h >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        j = Cb[c[135744 >> 2] & 511](c[(c[h >> 2] | 0) + 12 >> 2] << 2) | 0;
	                        c[(c[h >> 2] | 0) + 28 >> 2] = j;
	                        if (!(c[(c[h >> 2] | 0) + 28 >> 2] | 0)) {
	                            MN(c[f >> 2] | 0, 189568);
	                            c[(c[h >> 2] | 0) + 8 >> 2] = 0;
	                            c[e >> 2] = c[h >> 2];
	                            m = c[e >> 2] | 0;
	                            i = d;
	                            return m | 0
	                        }
	                    } else if ((c[(c[h >> 2] | 0) + 12 >> 2] | 0) < (c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[l >> 2] = Hb[c[135760 >> 2] & 511](c[(c[h >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] << 2) | 0;
	                        if (c[l >> 2] | 0) {
	                            c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                            c[(c[h >> 2] | 0) + 28 >> 2] = c[l >> 2];
	                            break
	                        }
	                        MN(c[f >> 2] | 0, 189568);
	                        c[(c[h >> 2] | 0) + 8 >> 2] = 0;
	                        c[e >> 2] = c[h >> 2];
	                        m = c[e >> 2] | 0;
	                        i = d;
	                        return m | 0
	                    } while (0);
	                    eU(c[(c[h >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 28 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] << 2 | 0) | 0
	                }
	                c[e >> 2] = c[h >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function QO(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0;
	                e = i;
	                i = i + 96 | 0;
	                f = e + 88 | 0;
	                g = e + 84 | 0;
	                h = e + 80 | 0;
	                j = e + 76 | 0;
	                k = e + 72 | 0;
	                l = e + 68 | 0;
	                m = e + 64 | 0;
	                n = e + 60 | 0;
	                o = e + 56 | 0;
	                p = e + 52 | 0;
	                q = e + 48 | 0;
	                r = e + 44 | 0;
	                s = e + 40 | 0;
	                t = e + 36 | 0;
	                u = e + 32 | 0;
	                v = e + 28 | 0;
	                w = e + 24 | 0;
	                x = e + 20 | 0;
	                y = e + 16 | 0;
	                z = e + 12 | 0;
	                A = e + 8 | 0;
	                B = e + 4 | 0;
	                C = e;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                c[m >> 2] = c[(c[g >> 2] | 0) + 48 >> 2];
	                c[q >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                c[w >> 2] = 0;
	                c[x >> 2] = 0;
	                if (!(c[(c[h >> 2] | 0) + 20 >> 2] | 0)) {
	                    FN(c[g >> 2] | 0, 10, 0, 0, 0);
	                    c[f >> 2] = -1;
	                    D = c[f >> 2] | 0;
	                    i = e;
	                    return D | 0
	                }
	                c[p >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                c[l >> 2] = c[c[p >> 2] >> 2];
	                c[n >> 2] = c[(c[g >> 2] | 0) + 28 >> 2];
	                if ((b[(c[h >> 2] | 0) + 50 >> 1] & 8 | 0) != 0 ? (h = (c[g >> 2] | 0) + 28 | 0, c[h >> 2] = c[h >> 2] | 4, (c[l >> 2] | 0) == 2) : 0) {
	                    if (c[(c[g >> 2] | 0) + 60 >> 2] | 0) {
	                        h = oO(c[g >> 2] | 0, c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = h
	                    }
	                    h = c[g >> 2] | 0;
	                    d = c[(c[p >> 2] | 0) + 12 >> 2] | 0;
	                    if ((c[c[c[c[(c[p >> 2] | 0) + 12 >> 2] >> 2] >> 2] >> 2] | 0) == 3)c[j >> 2] = KN(h, c[c[d + 4 >> 2] >> 2] | 0) | 0; else c[j >> 2] = KN(h, c[c[d >> 2] >> 2] | 0) | 0;
	                    if ((c[j >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 60 >> 2] | 0) != 0 : 0) {
	                        d = oO(c[g >> 2] | 0, c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = d
	                    }
	                    c[(c[g >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                    c[f >> 2] = c[j >> 2];
	                    D = c[f >> 2] | 0;
	                    i = e;
	                    return D | 0
	                }
	                c[w >> 2] = Cb[c[135744 >> 2] & 511](c[l >> 2] << 2) | 0;
	                if (!(c[w >> 2] | 0)) {
	                    MN(c[g >> 2] | 0, 189544);
	                    c[f >> 2] = -1;
	                    D = c[f >> 2] | 0;
	                    i = e;
	                    return D | 0
	                }
	                cU(c[w >> 2] | 0, 0, c[l >> 2] << 2 | 0) | 0;
	                c[x >> 2] = Cb[c[135744 >> 2] & 511](c[l >> 2] << 2) | 0;
	                if (!(c[x >> 2] | 0)) {
	                    MN(c[g >> 2] | 0, 189544);
	                    c[f >> 2] = -1;
	                    D = c[f >> 2] | 0;
	                    i = e;
	                    return D | 0
	                }
	                cU(c[x >> 2] | 0, 0, c[l >> 2] << 2 | 0) | 0;
	                c[r >> 2] = c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2];
	                c[r >> 2] = oO(c[g >> 2] | 0, c[r >> 2] | 0) | 0;
	                c[s >> 2] = c[r >> 2];
	                while (1) {
	                    if (!(c[r >> 2] | 0))break;
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[r >> 2];
	                    do if ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 8 >> 2] & 1 | 0) != 0 : 0) {
	                        c[y >> 2] = 0;
	                        if ((c[(c[r >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[r >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                            if ((c[(c[r >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                d = c[(c[p >> 2] | 0) + 4 >> 2] | 0;
	                                h = c[(c[r >> 2] | 0) + 8 >> 2] | 0;
	                                if (c[(c[r >> 2] | 0) + 36 >> 2] | 0) {
	                                    c[y >> 2] = Tj(d, h, c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                    if (!(c[y >> 2] | 0))c[y >> 2] = Tj(c[(c[p >> 2] | 0) + 4 >> 2] | 0, 189536, c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0
	                                } else c[y >> 2] = Tj(d, h, 0) | 0;
	                                if (!(c[y >> 2] | 0))c[y >> 2] = Tj(c[(c[p >> 2] | 0) + 4 >> 2] | 0, 189536, 0) | 0
	                            }
	                        } else c[y >> 2] = Tj(c[(c[p >> 2] | 0) + 4 >> 2] | 0, 188096, 0) | 0;
	                        if (!(c[y >> 2] | 0)) {
	                            c[k >> 2] = c[l >> 2];
	                            break
	                        }
	                        c[k >> 2] = (c[y >> 2] | 0) - 1;
	                        if ((c[(c[p >> 2] | 0) + 8 >> 2] & 2 | 0) != 0 ? (c[q >> 2] = c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + (c[k >> 2] << 2) >> 2], (gP(c[r >> 2] | 0, c[(c[q >> 2] | 0) + 4 >> 2] | 0) | 0) == 0) : 0)c[k >> 2] = c[l >> 2]
	                    } else E = 37; while (0);
	                    a:do if ((E | 0) == 37) {
	                        E = 0;
	                        c[k >> 2] = 0;
	                        while (1) {
	                            if ((c[k >> 2] | 0) >= (c[l >> 2] | 0))break a;
	                            c[q >> 2] = c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                            if ((c[q >> 2] | 0) != 0 ? (gP(c[r >> 2] | 0, c[(c[q >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0)break a;
	                            c[k >> 2] = (c[k >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    if ((c[k >> 2] | 0) >= (c[l >> 2] | 0))break;
	                    h = c[r >> 2] | 0;
	                    d = c[k >> 2] | 0;
	                    if (c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) {
	                        c[(c[(c[x >> 2] | 0) + (d << 2) >> 2] | 0) + 24 >> 2] = h;
	                        c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] = c[r >> 2]
	                    } else {
	                        c[(c[w >> 2] | 0) + (d << 2) >> 2] = h;
	                        c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] = c[r >> 2]
	                    }
	                    h = c[r >> 2] | 0;
	                    if (c[(c[r >> 2] | 0) + 24 >> 2] | 0)c[u >> 2] = c[h + 24 >> 2]; else c[u >> 2] = h;
	                    c[r >> 2] = oO(c[g >> 2] | 0, c[(c[r >> 2] | 0) + 24 >> 2] | 0) | 0
	                }
	                do if (!(c[j >> 2] | 0)) {
	                    c[v >> 2] = c[r >> 2];
	                    c[o >> 2] = c[(c[g >> 2] | 0) + 60 >> 2];
	                    c[k >> 2] = 0;
	                    while (1) {
	                        if ((c[k >> 2] | 0) >= (c[l >> 2] | 0))break;
	                        y = PO(c[g >> 2] | 0, c[o >> 2] | 0) | 0;
	                        c[(c[g >> 2] | 0) + 60 >> 2] = y;
	                        if (!(c[(c[g >> 2] | 0) + 60 >> 2] | 0)) {
	                            E = 55;
	                            break
	                        }
	                        c[q >> 2] = c[(c[(c[p >> 2] | 0) + 12 >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        if (c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) {
	                            c[t >> 2] = c[(c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 24 >> 2];
	                            c[(c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 24 >> 2] = 0
	                        }
	                        c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[(c[w >> 2] | 0) + (c[k >> 2] << 2) >> 2];
	                        c[j >> 2] = KN(c[g >> 2] | 0, c[c[q >> 2] >> 2] | 0) | 0;
	                        if (c[j >> 2] | 0)break;
	                        y = c[g >> 2] | 0;
	                        if (c[(c[g >> 2] | 0) + 60 >> 2] | 0) {
	                            c[r >> 2] = c[(c[y + 60 >> 2] | 0) + 4 >> 2];
	                            c[r >> 2] = oO(c[g >> 2] | 0, c[r >> 2] | 0) | 0;
	                            LN(c[g >> 2] | 0, c[o >> 2] | 0);
	                            c[o >> 2] = c[(c[g >> 2] | 0) + 60 >> 2];
	                            c[(c[g >> 2] | 0) + 60 >> 2] = 0;
	                            if (c[r >> 2] | 0) {
	                                E = 61;
	                                break
	                            }
	                        } else {
	                            if (!(c[y + 64 >> 2] | 0)) {
	                                E = 89;
	                                break
	                            }
	                            c[A >> 2] = 0;
	                            c[B >> 2] = -1;
	                            c[C >> 2] = -1;
	                            c[z >> 2] = 0;
	                            b:while (1) {
	                                if ((c[z >> 2] | 0) >= (c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                c[r >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) + 4 >> 2];
	                                c[r >> 2] = oO(c[g >> 2] | 0, c[r >> 2] | 0) | 0;
	                                y = (c[A >> 2] | 0) == 0;
	                                do if (!(c[r >> 2] | 0)) {
	                                    if (y) {
	                                        c[C >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) + 16 >> 2];
	                                        c[B >> 2] = c[z >> 2]
	                                    }
	                                    c[A >> 2] = 1;
	                                    if ((c[(c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) + 16 >> 2] | 0) <= (c[C >> 2] | 0)) {
	                                        c[C >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) + 16 >> 2];
	                                        c[B >> 2] = c[z >> 2]
	                                    }
	                                    if (!(c[C >> 2] | 0))break b
	                                } else if (y) {
	                                    h = c[(c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) + 16 >> 2] | 0;
	                                    if ((c[C >> 2] | 0) == -1) {
	                                        c[C >> 2] = h;
	                                        c[B >> 2] = c[z >> 2];
	                                        break
	                                    }
	                                    if ((h | 0) > (c[C >> 2] | 0))break;
	                                    c[C >> 2] = c[(c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0) + 16 >> 2];
	                                    c[B >> 2] = c[z >> 2]
	                                } while (0);
	                                c[z >> 2] = (c[z >> 2] | 0) + 1
	                            }
	                            do if ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) > 0) {
	                                LN(c[g >> 2] | 0, c[o >> 2] | 0);
	                                if ((c[B >> 2] | 0) != -1) {
	                                    c[o >> 2] = c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[B >> 2] << 2) >> 2];
	                                    c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[B >> 2] << 2) >> 2] = 0;
	                                    break
	                                } else {
	                                    c[o >> 2] = c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) - 1 << 2) >> 2];
	                                    c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + ((c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0) - 1 << 2) >> 2] = 0;
	                                    y = c[(c[g >> 2] | 0) + 64 >> 2] | 0;
	                                    c[y >> 2] = (c[y >> 2] | 0) + -1;
	                                    break
	                                }
	                            } while (0);
	                            c[z >> 2] = 0;
	                            while (1) {
	                                F = c[g >> 2] | 0;
	                                if ((c[z >> 2] | 0) >= (c[c[(c[g >> 2] | 0) + 64 >> 2] >> 2] | 0))break;
	                                LN(F, c[(c[(c[(c[g >> 2] | 0) + 64 >> 2] | 0) + 8 >> 2] | 0) + (c[z >> 2] << 2) >> 2] | 0);
	                                c[z >> 2] = (c[z >> 2] | 0) + 1
	                            }
	                            NN(F, c[(c[g >> 2] | 0) + 64 >> 2] | 0);
	                            c[(c[g >> 2] | 0) + 64 >> 2] = 0;
	                            if (!(c[A >> 2] | 0)) {
	                                E = 85;
	                                break
	                            }
	                        }
	                        if (c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0)c[(c[(c[x >> 2] | 0) + (c[k >> 2] << 2) >> 2] | 0) + 24 >> 2] = c[t >> 2];
	                        c[k >> 2] = (c[k >> 2] | 0) + 1
	                    }
	                    if ((E | 0) == 55)c[j >> 2] = -1; else if ((E | 0) == 61) {
	                        FN(c[g >> 2] | 0, 12, c[(c[r >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[j >> 2] = -1;
	                        c[(c[g >> 2] | 0) + 60 >> 2] = c[o >> 2];
	                        break
	                    } else if ((E | 0) == 85) {
	                        y = c[g >> 2] | 0;
	                        if (!(c[r >> 2] | 0))FN(y, 12, 189560, 0, 0); else FN(y, 12, c[(c[r >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        c[j >> 2] = -1;
	                        c[(c[g >> 2] | 0) + 60 >> 2] = c[o >> 2];
	                        break
	                    } else if ((E | 0) == 89)c[j >> 2] = -1;
	                    if (c[(c[g >> 2] | 0) + 60 >> 2] | 0)LN(c[g >> 2] | 0, c[(c[g >> 2] | 0) + 60 >> 2] | 0);
	                    c[(c[g >> 2] | 0) + 60 >> 2] = c[o >> 2];
	                    c[(c[(c[g >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] = c[v >> 2];
	                    if (c[j >> 2] | 0) {
	                        FN(c[g >> 2] | 0, 11, 0, 0, 0);
	                        c[j >> 2] = -1
	                    }
	                } else {
	                    FN(c[g >> 2] | 0, 11, 0, 0, 0);
	                    c[j >> 2] = -1
	                } while (0);
	                c[(c[g >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                c[r >> 2] = c[u >> 2];
	                while (1) {
	                    if (!(c[r >> 2] | 0))break;
	                    if ((c[r >> 2] | 0) == (c[s >> 2] | 0))break;
	                    if (!(c[(c[r >> 2] | 0) + 28 >> 2] | 0))break;
	                    c[(c[(c[r >> 2] | 0) + 28 >> 2] | 0) + 24 >> 2] = c[r >> 2];
	                    c[r >> 2] = c[(c[r >> 2] | 0) + 28 >> 2]
	                }
	                if ((c[j >> 2] | 0) == 0 ? (c[(c[g >> 2] | 0) + 48 >> 2] | 0) > (c[m >> 2] | 0) : 0)KO(c[g >> 2] | 0, c[m >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                c[f >> 2] = c[j >> 2];
	                D = c[f >> 2] | 0;
	                i = e;
	                return D | 0
	            }

	            function RO(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 44 | 0;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 8 | 0;
	                r = f + 4 | 0;
	                s = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[p >> 2] = 0;
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) {
	                    c[o >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                    do if (c[(c[o >> 2] | 0) + 12 >> 2] | 0) {
	                        if ((c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[c[(c[k >> 2] | 0) + 36 >> 2] >> 2] | 0) == 6 : 0) {
	                            c[m >> 2] = Ib[c[(c[o >> 2] | 0) + 12 >> 2] & 511](c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0, p, c[l >> 2] | 0) | 0;
	                            break
	                        }
	                        c[m >> 2] = Ib[c[(c[o >> 2] | 0) + 12 >> 2] & 511](c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0, 0, c[l >> 2] | 0) | 0
	                    } else c[m >> 2] = -1; while (0);
	                    if ((c[m >> 2] | 0) < 0) {
	                        FN(c[h >> 2] | 0, 2, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                        if ((c[p >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)Ab[c[(c[o >> 2] | 0) + 24 >> 2] & 511](c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0);
	                        c[g >> 2] = -1;
	                        t = c[g >> 2] | 0;
	                        i = f;
	                        return t | 0
	                    }
	                    do if ((c[m >> 2] | 0) != 1) {
	                        l = c[h >> 2] | 0;
	                        if ((c[m >> 2] | 0) == 2) {
	                            FN(l, 4, c[j >> 2] | 0, 0, 1);
	                            break
	                        } else {
	                            FN(l, 3, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0, 1);
	                            c[m >> 2] = -1;
	                            break
	                        }
	                    } else c[m >> 2] = 0; while (0);
	                    c[q >> 2] = c[(c[k >> 2] | 0) + 36 >> 2];
	                    while (1) {
	                        if (!((c[m >> 2] | 0) == 0 & (c[q >> 2] | 0) != 0))break;
	                        if ((c[c[q >> 2] >> 2] | 0) != 6)break;
	                        if ((c[(c[o >> 2] | 0) + 20 >> 2] | 0) != 0 ? (c[n >> 2] = Bb[c[(c[o >> 2] | 0) + 20 >> 2] & 511](c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 8 >> 2] | 0, c[(c[q >> 2] | 0) + 16 >> 2] | 0, c[j >> 2] | 0, c[p >> 2] | 0) | 0, (c[n >> 2] | 0) != 0) : 0)c[m >> 2] = -1;
	                        c[q >> 2] = c[(c[q >> 2] | 0) + 32 >> 2]
	                    }
	                    if ((c[m >> 2] | 0) == 0 ? (c[(c[k >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) {
	                        c[r >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                        c[s >> 2] = c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = 0;
	                        c[m >> 2] = SO(c[h >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[r >> 2];
	                        c[(c[(c[h >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = c[s >> 2]
	                    }
	                    if ((c[p >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 24 >> 2] | 0) != 0 : 0)Ab[c[(c[o >> 2] | 0) + 24 >> 2] & 511](c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[p >> 2] | 0);
	                    c[g >> 2] = c[m >> 2];
	                    t = c[g >> 2] | 0;
	                    i = f;
	                    return t | 0
	                }
	                c[g >> 2] = -1;
	                t = c[g >> 2] | 0;
	                i = f;
	                return t | 0
	            }

	            function SO(b, e) {
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0;
	                f = i;
	                i = i + 96 | 0;
	                g = f;
	                h = f + 92 | 0;
	                j = f + 88 | 0;
	                k = f + 84 | 0;
	                l = f + 80 | 0;
	                m = f + 76 | 0;
	                n = f + 72 | 0;
	                o = f + 68 | 0;
	                p = f + 64 | 0;
	                q = f + 60 | 0;
	                r = f + 56 | 0;
	                s = f + 52 | 0;
	                t = f + 48 | 0;
	                u = f + 44 | 0;
	                v = f + 40 | 0;
	                w = f + 36 | 0;
	                x = f + 32 | 0;
	                y = f + 28 | 0;
	                z = f + 24 | 0;
	                A = f + 20 | 0;
	                B = f + 16 | 0;
	                C = f + 12 | 0;
	                D = f + 8 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = 0;
	                c[n >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                a:do switch (c[c[k >> 2] >> 2] | 0) {
	                    case 17:
	                    {
	                        c[s >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                        c[m >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                        e = (c[j >> 2] | 0) + 28 | 0;
	                        c[e >> 2] = c[e >> 2] | 1;
	                        c[t >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                        while (1) {
	                            if (!(c[s >> 2] | 0))break;
	                            c[l >> 2] = SO(c[j >> 2] | 0, c[s >> 2] | 0) | 0;
	                            if (!(c[l >> 2] | 0))break;
	                            c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[t >> 2];
	                            c[s >> 2] = c[(c[s >> 2] | 0) + 32 >> 2]
	                        }
	                        c[(c[j >> 2] | 0) + 28 >> 2] = c[m >> 2];
	                        e = c[j >> 2] | 0;
	                        if (c[l >> 2] | 0) {
	                            if (c[e + 28 >> 2] & 1)break a;
	                            eO(c[j >> 2] | 0);
	                            break a
	                        } else {
	                            if ((c[e + 48 >> 2] | 0) <= 0)break a;
	                            KO(c[j >> 2] | 0, 0);
	                            break a
	                        }
	                        break
	                    }
	                    case 5:
	                    {
	                        c[l >> 2] = RO(c[j >> 2] | 0, c[n >> 2] | 0, c[k >> 2] | 0, c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0))hP(c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 16:
	                    {
	                        c[l >> 2] = iP(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0))E = 78;
	                        break
	                    }
	                    case 15:
	                    {
	                        E = 78;
	                        break
	                    }
	                    case 8:
	                    {
	                        c[u >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                        c[v >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                        c[w >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2];
	                        c[x >> 2] = my(c[v >> 2] | 0) | 0;
	                        if (!(c[x >> 2] | 0))c[x >> 2] = my(188112) | 0;
	                        if (!(c[x >> 2] | 0)) {
	                            FN(c[j >> 2] | 0, 6, 0, 0, 0);
	                            c[h >> 2] = -1;
	                            F = c[h >> 2] | 0;
	                            i = f;
	                            return F | 0
	                        }
	                        c[y >> 2] = c[x >> 2];
	                        b:while (1) {
	                            G = c[y >> 2] | 0;
	                            if (!(d[c[y >> 2] >> 0] | 0))break;
	                            do if ((d[G >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[y >> 2] >> 0] | 0 | 0) ? (d[c[y >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[y >> 2] >> 0] | 0 | 0) != 13) {
	                                    c[y >> 2] = (c[y >> 2] | 0) + 1;
	                                    continue b
	                                }
	                            } while (0);
	                            a[c[y >> 2] >> 0] = 0;
	                            c[y >> 2] = (c[y >> 2] | 0) + 1;
	                            while (1) {
	                                do if ((d[c[y >> 2] >> 0] | 0 | 0) != 32) {
	                                    if (9 <= (d[c[y >> 2] >> 0] | 0 | 0) ? (d[c[y >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                    if ((d[c[y >> 2] >> 0] | 0 | 0) != 13)continue b
	                                } while (0);
	                                e = c[y >> 2] | 0;
	                                c[y >> 2] = e + 1;
	                                a[e >> 0] = 0
	                            }
	                        }
	                        c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = G;
	                        c[y >> 2] = c[x >> 2];
	                        while (1) {
	                            if (!(d[c[y >> 2] >> 0] | 0))H = (c[y >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0); else H = 0;
	                            I = c[y >> 2] | 0;
	                            if (!H)break;
	                            c[y >> 2] = I + 1
	                        }
	                        c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = I;
	                        while (1) {
	                            if (!(c[u >> 2] | 0))break;
	                            if ((c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0) == (c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0))c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = 0;
	                            c[l >> 2] = SO(c[j >> 2] | 0, c[u >> 2] | 0) | 0;
	                            if (c[l >> 2] | 0)break;
	                            c[u >> 2] = c[(c[u >> 2] | 0) + 32 >> 2]
	                        }
	                        if (((c[l >> 2] | 0) == 0 ? (c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0) != (c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0) : 0) {
	                            FN(c[j >> 2] | 0, 8, c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0, 0, 0);
	                            c[l >> 2] = -1
	                        }
	                        zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                        c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[v >> 2];
	                        c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = c[w >> 2];
	                        break
	                    }
	                    case 7:
	                    {
	                        do if (!(qy(c[n >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0)) {
	                            if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0)) {
	                                c[q >> 2] = SN(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                c[r >> 2] = SN(c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                                if (!(!((c[q >> 2] | 0) == 0 | (c[r >> 2] | 0) == 0) ? (qy(c[q >> 2] | 0, c[r >> 2] | 0) | 0) != 0 : 0))c[l >> 2] = -1;
	                                if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                                if (!(c[r >> 2] | 0))break;
	                                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                                break
	                            }
	                            c[p >> 2] = c[(c[k >> 2] | 0) + 20 >> 2];
	                            if ((c[p >> 2] | 0) != 0 ? (c[(c[p >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)c[l >> 2] = ub[c[(c[p >> 2] | 0) + 16 >> 2] & 511](c[(c[p >> 2] | 0) + 4 >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[k >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[k >> 2] | 0) + 36 >> 2] | 0, c[n >> 2] | 0, c[c[(c[j >> 2] | 0) + 60 >> 2] >> 2] | 0) | 0; else c[l >> 2] = -1;
	                            if ((c[l >> 2] | 0) < 0) {
	                                FN(c[j >> 2] | 0, 5, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0, 0);
	                                c[h >> 2] = -1;
	                                F = c[h >> 2] | 0;
	                                i = f;
	                                return F | 0
	                            }
	                            if ((c[l >> 2] | 0) == 1) {
	                                c[l >> 2] = 0;
	                                break
	                            } else {
	                                c[l >> 2] = -1;
	                                break
	                            }
	                        } while (0);
	                        if (!(c[l >> 2] | 0))hP(c[j >> 2] | 0) | 0;
	                        break
	                    }
	                    case 0:
	                    {
	                        if ((c[n >> 2] | 0) != 0 ? (d[c[n >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                            c[o >> 2] = 0;
	                            while (1) {
	                                do if ((d[(c[n >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) == 32)J = 1; else {
	                                    if (9 <= (d[(c[n >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[n >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0) {
	                                        J = 1;
	                                        break
	                                    }
	                                    J = (d[(c[n >> 2] | 0) + (c[o >> 2] | 0) >> 0] | 0 | 0) == 13
	                                } while (0);
	                                K = c[o >> 2] | 0;
	                                if (!J)break;
	                                c[o >> 2] = K + 1
	                            }
	                            if (d[(c[n >> 2] | 0) + K >> 0] | 0)c[l >> 2] = -1
	                        }
	                        break
	                    }
	                    case 18:
	                    case 10:
	                    {
	                        c[D >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[D >> 2] | 0))break a;
	                            c[l >> 2] = SO(c[j >> 2] | 0, c[D >> 2] | 0) | 0;
	                            if (c[l >> 2] | 0)break;
	                            c[l >> 2] = 0;
	                            c[D >> 2] = c[(c[D >> 2] | 0) + 32 >> 2]
	                        }
	                        c[l >> 2] = -1;
	                        break
	                    }
	                    case 13:
	                    case 11:
	                    {
	                        e = c[j >> 2] | 0;
	                        if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                            FN(e, 7, 0, 0, 0);
	                            c[l >> 2] = -1;
	                            break a
	                        } else {
	                            c[l >> 2] = SO(e, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            break a
	                        }
	                        break
	                    }
	                    case 3:
	                        break;
	                    case 2:
	                    {
	                        c[C >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[C >> 2] | 0))break a;
	                            c[l >> 2] = SO(c[j >> 2] | 0, c[C >> 2] | 0) | 0;
	                            if (!(c[l >> 2] | 0))break;
	                            c[l >> 2] = 0;
	                            c[C >> 2] = c[(c[C >> 2] | 0) + 32 >> 2]
	                        }
	                        c[l >> 2] = -1;
	                        break
	                    }
	                    case 14:
	                    {
	                        if ((c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0) != 0 ? (d[c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                            c[m >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                            e = (c[j >> 2] | 0) + 28 | 0;
	                            c[e >> 2] = c[e >> 2] | 1;
	                            c[B >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                            c[l >> 2] = SO(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            c[(c[j >> 2] | 0) + 28 >> 2] = c[m >> 2];
	                            if (!(c[l >> 2] | 0)) {
	                                if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) <= 0)break a;
	                                KO(c[j >> 2] | 0, 0);
	                                break a
	                            }
	                            c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[B >> 2];
	                            if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) > 0)KO(c[j >> 2] | 0, 0);
	                            c[l >> 2] = 0;
	                            break a
	                        }
	                        c[l >> 2] = 0;
	                        break
	                    }
	                    default:
	                    {
	                        e = c[33976] | 0;
	                        b = c[33980] | 0;
	                        c[g >> 2] = 189496;
	                        c[g + 4 >> 2] = 8982;
	                        Db[e & 511](b, 189464, g);
	                        c[l >> 2] = -1
	                    }
	                } while (0);
	                do if ((E | 0) == 78) {
	                    if ((c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] | 0) != 0 ? (d[c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                        c[m >> 2] = c[(c[j >> 2] | 0) + 28 >> 2];
	                        g = (c[j >> 2] | 0) + 28 | 0;
	                        c[g >> 2] = c[g >> 2] | 1;
	                        c[z >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                        c[A >> 2] = 0;
	                        while (1) {
	                            if (!(c[z >> 2] | 0))break;
	                            if ((c[z >> 2] | 0) == (c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0))break;
	                            if ((c[A >> 2] | 0) == (c[z >> 2] | 0))break;
	                            c[A >> 2] = c[z >> 2];
	                            c[l >> 2] = iP(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                            if (c[l >> 2] | 0) {
	                                E = 86;
	                                break
	                            }
	                            c[z >> 2] = c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2]
	                        }
	                        if ((E | 0) == 86) {
	                            c[(c[(c[j >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[A >> 2];
	                            c[l >> 2] = 0
	                        }
	                        c[(c[j >> 2] | 0) + 28 >> 2] = c[m >> 2];
	                        if ((c[(c[j >> 2] | 0) + 48 >> 2] | 0) <= 0)break;
	                        KO(c[j >> 2] | 0, 0);
	                        break
	                    }
	                    c[l >> 2] = 0
	                } while (0);
	                c[h >> 2] = c[l >> 2];
	                F = c[h >> 2] | 0;
	                i = f;
	                return F | 0
	            }

	            function TO(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[e + 12 >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                do if (!((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0)) {
	                    if ((c[g >> 2] | 0) == (c[h >> 2] | 0)) {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                    if ((c[c[g >> 2] >> 2] | 0) != (c[c[h >> 2] >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != (c[(c[h >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 16 >> 2] | 0) != (c[(c[h >> 2] | 0) + 16 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != (c[(c[h >> 2] | 0) + 8 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 24 >> 2] | 0) != (c[(c[h >> 2] | 0) + 24 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 20 >> 2] | 0) != (c[(c[h >> 2] | 0) + 20 >> 2] | 0) ? (qy(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[h >> 2] | 0) + 20 >> 2] | 0) | 0) == 0 : 0) {
	                        c[f >> 2] = 0;
	                        break
	                    }
	                    c[j >> 2] = 0;
	                    while (1) {
	                        if ((c[j >> 2] | 0) >= (c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                            k = 23;
	                            break
	                        }
	                        if ((c[(c[(c[g >> 2] | 0) + 28 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0) != (c[(c[(c[h >> 2] | 0) + 28 >> 2] | 0) + (c[j >> 2] << 2) >> 2] | 0)) {
	                            k = 21;
	                            break
	                        }
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    if ((k | 0) == 21) {
	                        c[f >> 2] = 0;
	                        break
	                    } else if ((k | 0) == 23) {
	                        c[f >> 2] = 1;
	                        break
	                    }
	                } else c[f >> 2] = 0; while (0);
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function UO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 108 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 104 >> 2] = 4, c[(c[f >> 2] | 0) + 100 >> 2] = 0, b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 104 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 108 >> 2] = b, (c[(c[f >> 2] | 0) + 108 >> 2] | 0) == 0) : 0) {
	                    xN(c[f >> 2] | 0, 196496);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 100 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 104 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 104 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 108 >> 2] | 0, c[(c[f >> 2] | 0) + 104 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 108 >> 2] = b, (c[(c[f >> 2] | 0) + 108 >> 2] | 0) == 0) : 0) {
	                    xN(c[f >> 2] | 0, 196496);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[(c[f >> 2] | 0) + 108 >> 2] | 0) + (c[(c[f >> 2] | 0) + 100 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 96 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 100 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function VO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 100 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 100 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 100 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 96 >> 2] = c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + ((c[a + 100 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 96 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + (c[(c[e >> 2] | 0) + 100 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 108 >> 2] | 0) + (c[(c[e >> 2] | 0) + 100 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function WO(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[(c[f >> 2] | 0) + 124 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 120 >> 2] = 4, c[(c[f >> 2] | 0) + 116 >> 2] = 0, b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 120 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 124 >> 2] = b, (c[(c[f >> 2] | 0) + 124 >> 2] | 0) == 0) : 0) {
	                    xN(c[f >> 2] | 0, 196088);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                if ((c[(c[f >> 2] | 0) + 116 >> 2] | 0) >= (c[(c[f >> 2] | 0) + 120 >> 2] | 0) ? (b = (c[f >> 2] | 0) + 120 | 0, c[b >> 2] = c[b >> 2] << 1, b = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 124 >> 2] | 0, c[(c[f >> 2] | 0) + 120 >> 2] << 2) | 0, c[(c[f >> 2] | 0) + 124 >> 2] = b, (c[(c[f >> 2] | 0) + 124 >> 2] | 0) == 0) : 0) {
	                    xN(c[f >> 2] | 0, 196088);
	                    c[e >> 2] = 0;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                c[(c[(c[f >> 2] | 0) + 124 >> 2] | 0) + (c[(c[f >> 2] | 0) + 116 >> 2] << 2) >> 2] = c[g >> 2];
	                c[(c[f >> 2] | 0) + 112 >> 2] = c[g >> 2];
	                g = (c[f >> 2] | 0) + 116 | 0;
	                f = c[g >> 2] | 0;
	                c[g >> 2] = f + 1;
	                c[e >> 2] = f;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function XO(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 116 >> 2] | 0) <= 0) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[e >> 2] | 0) + 116 | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = c[e >> 2] | 0;
	                if ((c[(c[e >> 2] | 0) + 116 >> 2] | 0) > 0)c[(c[e >> 2] | 0) + 112 >> 2] = c[(c[(c[e >> 2] | 0) + 124 >> 2] | 0) + ((c[a + 116 >> 2] | 0) - 1 << 2) >> 2]; else c[a + 112 >> 2] = 0;
	                c[f >> 2] = c[(c[(c[e >> 2] | 0) + 124 >> 2] | 0) + (c[(c[e >> 2] | 0) + 116 >> 2] << 2) >> 2];
	                c[(c[(c[e >> 2] | 0) + 124 >> 2] | 0) + (c[(c[e >> 2] | 0) + 116 >> 2] << 2) >> 2] = 0;
	                c[d >> 2] = c[f >> 2];
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function YO(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 36 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[g >> 2] = a;
	                c[f + 32 >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = 0;
	                c[l >> 2] = c[h >> 2];
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    c[m >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                    if (((((c[j >> 2] | 0) == 0 & (c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 190048) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[k >> 2] = 1;
	                        Qh(c[l >> 2] | 0);
	                        Rh(c[l >> 2] | 0)
	                    } else q = 9;
	                    do if ((q | 0) == 9) {
	                        q = 0;
	                        if (((((c[j >> 2] | 0) != 0 & (c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 195016) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                            c[n >> 2] = Yi(c[l >> 2] | 0, 192176) | 0;
	                            ZO(c[n >> 2] | 0);
	                            if (!(c[n >> 2] | 0))break;
	                            if (qy(c[j >> 2] | 0, c[n >> 2] | 0) | 0) {
	                                c[k >> 2] = 1;
	                                Qh(c[l >> 2] | 0);
	                                Rh(c[l >> 2] | 0)
	                            }
	                            zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            break
	                        }
	                        if ((((((((((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 195024) | 0) != 0 : 0) ? (qy(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) ? (c[o >> 2] = 0, c[p >> 2] = c[(c[l >> 2] | 0) + 52 >> 2], (c[p >> 2] | 0) != 0) : 0) ? (c[(c[p >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (qy(c[(c[(c[(c[p >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) + 8 >> 2] | 0, 190264) | 0) != 0 : 0) ? (h = c[g >> 2] | 0, e = c[o >> 2] | 0, d = c[(Pi(c[(c[p >> 2] | 0) + 8 >> 2] | 0) | 0) + 12 >> 2] | 0, (YO(h, e, d, c[j >> 2] | 0) | 0) == 1) : 0)c[k >> 2] = 1
	                    } while (0);
	                    c[l >> 2] = c[m >> 2]
	                }
	                i = f;
	                return c[k >> 2] | 0
	            }

	            function ZO(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = b;
	                c[g >> 2] = c[f >> 2];
	                c[h >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                while (1) {
	                    do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                        if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            j = 1;
	                            break
	                        }
	                        j = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    k = c[h >> 2] | 0;
	                    if (!j)break;
	                    c[h >> 2] = k + 1
	                }
	                if ((k | 0) == (c[g >> 2] | 0)) {
	                    while (1) {
	                        if (d[c[h >> 2] >> 0] | 0) {
	                            do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                                if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    l = 1;
	                                    break
	                                }
	                                l = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            m = l ^ 1
	                        } else m = 0;
	                        k = c[h >> 2] | 0;
	                        if (m) {
	                            c[h >> 2] = k + 1;
	                            continue
	                        }
	                        if (!(d[k >> 0] | 0)) {
	                            n = 46;
	                            break
	                        }
	                        c[g >> 2] = c[h >> 2];
	                        while (1) {
	                            do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                                if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    o = 1;
	                                    break
	                                }
	                                o = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            p = c[h >> 2] | 0;
	                            if (!o)break;
	                            c[h >> 2] = p + 1
	                        }
	                        if (!(d[p >> 0] | 0))break
	                    }
	                    if ((n | 0) == 46) {
	                        i = e;
	                        return
	                    }
	                    a[c[g >> 2] >> 0] = 0;
	                    i = e;
	                    return
	                }
	                while (1) {
	                    if (d[c[h >> 2] >> 0] | 0) {
	                        do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)q = 1; else {
	                            if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                q = 1;
	                                break
	                            }
	                            q = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        r = q ^ 1
	                    } else r = 0;
	                    p = c[h >> 2] | 0;
	                    if (r) {
	                        c[h >> 2] = p + 1;
	                        o = a[p >> 0] | 0;
	                        m = c[g >> 2] | 0;
	                        c[g >> 2] = m + 1;
	                        a[m >> 0] = o;
	                        continue
	                    }
	                    if (!(d[p >> 0] | 0)) {
	                        n = 36;
	                        break
	                    }
	                    while (1) {
	                        do if ((d[c[h >> 2] >> 0] | 0 | 0) == 32)s = 1; else {
	                            if (9 <= (d[c[h >> 2] >> 0] | 0 | 0) ? (d[c[h >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                s = 1;
	                                break
	                            }
	                            s = (d[c[h >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        t = c[h >> 2] | 0;
	                        if (!s)break;
	                        c[h >> 2] = t + 1
	                    }
	                    if (!(d[t >> 0] | 0)) {
	                        n = 44;
	                        break
	                    }
	                    p = c[h >> 2] | 0;
	                    c[h >> 2] = p + 1;
	                    o = a[p >> 0] | 0;
	                    p = c[g >> 2] | 0;
	                    c[g >> 2] = p + 1;
	                    a[p >> 0] = o
	                }
	                if ((n | 0) == 36) {
	                    a[c[g >> 2] >> 0] = 0;
	                    i = e;
	                    return
	                } else if ((n | 0) == 44) {
	                    a[c[g >> 2] >> 0] = 0;
	                    i = e;
	                    return
	                }
	            }

	            function _O(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[h >> 2] = Yi(c[g >> 2] | 0, 192176) | 0;
	                do if (c[h >> 2] | 0) {
	                    ZO(c[h >> 2] | 0);
	                    if (Eh(c[h >> 2] | 0, 0) | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1049, 195200, c[h >> 2] | 0, 0);
	                    c[l >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[e >> 2] = -1;
	                        o = c[e >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    }
	                    c[c[l >> 2] >> 2] = 10;
	                    c[(c[l >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                    b = c[f >> 2] | 0;
	                    if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))zN(b, c[g >> 2] | 0, 1012, 195240, 0, 0); else {
	                        c[m >> 2] = c[b + 44 >> 2];
	                        c[(c[f >> 2] | 0) + 44 >> 2] = c[h >> 2];
	                        b = xO(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0, 0) | 0;
	                        c[(c[l >> 2] | 0) + 24 >> 2] = b;
	                        c[(c[f >> 2] | 0) + 44 >> 2] = c[m >> 2]
	                    }
	                    if (!(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 24 >> 2] | 0)) {
	                        b = Ij(10) | 0;
	                        c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 24 >> 2] = b
	                    }
	                    b = c[f >> 2] | 0;
	                    if (!(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 24 >> 2] | 0)) {
	                        zN(b, c[g >> 2] | 0, 1011, 195264, 0, 0);
	                        c[j >> 2] = -1;
	                        break
	                    }
	                    c[k >> 2] = Lj(c[(c[b + 24 >> 2] | 0) + 24 >> 2] | 0, c[h >> 2] | 0, c[l >> 2] | 0) | 0;
	                    if ((c[k >> 2] | 0) < 0) {
	                        c[n >> 2] = Rj(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 24 >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if (!(c[n >> 2] | 0)) {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1011, 195304, c[h >> 2] | 0, 0);
	                            c[j >> 2] = -1;
	                            break
	                        }
	                        while (1) {
	                            if (!(c[(c[n >> 2] | 0) + 44 >> 2] | 0))break;
	                            c[n >> 2] = c[(c[n >> 2] | 0) + 44 >> 2]
	                        }
	                        c[(c[n >> 2] | 0) + 44 >> 2] = c[l >> 2]
	                    }
	                } else zN(c[f >> 2] | 0, c[g >> 2] | 0, 1014, 195176, 0, 0); while (0);
	                c[e >> 2] = c[j >> 2];
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function $O(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[k >> 2] = 0;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1042, 195072, 0, 0);
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[j >> 2] = Pi(c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1022, 195104, 0, 0);
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if (!(qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 190264) | 0)) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1038, 195136, 0, 0);
	                    c[e >> 2] = -1;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[l >> 2] = tO(c[f >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0) | 0, (c[l >> 2] | 0) != 0) : 0)c[k >> 2] = -1;
	                if ((c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[l >> 2] = tO(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0, (c[l >> 2] | 0) != 0) : 0)c[k >> 2] = -1;
	                c[e >> 2] = c[k >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function aP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[c[h >> 2] >> 2] = 4;
	                c[(c[h >> 2] | 0) + 28 >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                c[l >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                b = c[f >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    zN(b, c[g >> 2] | 0, 1017, 194024, 0, 0);
	                    c[e >> 2] = c[h >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[j >> 2] = jP(b, c[l >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (c[j >> 2] | 0)c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                b = c[f >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    zN(b, c[g >> 2] | 0, 1020, 194080, 0, 0);
	                    c[e >> 2] = c[h >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                c[m >> 2] = c[b + 44 >> 2];
	                c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                c[k >> 2] = 0;
	                while (1) {
	                    if (!(c[l >> 2] | 0))break;
	                    c[j >> 2] = bP(c[f >> 2] | 0, c[l >> 2] | 0) | 0;
	                    a:do if (c[j >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                        switch (c[c[j >> 2] >> 2] | 0) {
	                            case 20:
	                            {
	                                zN(c[f >> 2] | 0, c[g >> 2] | 0, 1018, 194128, 0, 0);
	                                break a;
	                                break
	                            }
	                            case 9:
	                            {
	                                c[(c[j >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 36 >> 2];
	                                c[(c[h >> 2] | 0) + 36 >> 2] = c[j >> 2];
	                                break a;
	                                break
	                            }
	                            case 19:
	                            case 18:
	                            case 17:
	                            case 14:
	                            case 16:
	                            case 15:
	                            case 10:
	                            case 12:
	                            case 13:
	                            case 11:
	                            case 8:
	                            case 7:
	                            case 5:
	                            case 4:
	                            case 3:
	                            case 1:
	                            case 0:
	                            {
	                                if (!(c[k >> 2] | 0)) {
	                                    b = c[j >> 2] | 0;
	                                    c[k >> 2] = b;
	                                    c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                                    break a
	                                }
	                                do if ((c[c[k >> 2] >> 2] | 0) == 4 ? (c[(c[h >> 2] | 0) + 24 >> 2] | 0) == (c[k >> 2] | 0) : 0) {
	                                    b = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                                    c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                                    if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                                        c[c[(c[h >> 2] | 0) + 24 >> 2] >> 2] = 18;
	                                        c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 24 >> 2] = c[k >> 2];
	                                        break
	                                    } else {
	                                        c[(c[h >> 2] | 0) + 24 >> 2] = c[k >> 2];
	                                        break
	                                    }
	                                } while (0);
	                                c[(c[k >> 2] | 0) + 32 >> 2] = c[j >> 2];
	                                c[k >> 2] = c[j >> 2];
	                                break a;
	                                break
	                            }
	                            case -1:
	                            {
	                                zN(c[f >> 2] | 0, c[g >> 2] | 0, 1018, 194272, 0, 0);
	                                break a;
	                                break
	                            }
	                            case 6:
	                            {
	                                zN(c[f >> 2] | 0, c[g >> 2] | 0, 1018, 194176, 0, 0);
	                                break a;
	                                break
	                            }
	                            case 2:
	                            {
	                                zN(c[f >> 2] | 0, c[g >> 2] | 0, 1018, 194224, 0, 0);
	                                break a;
	                                break
	                            }
	                            default:
	                                break a
	                        }
	                    } while (0);
	                    c[l >> 2] = c[(c[l >> 2] | 0) + 24 >> 2]
	                }
	                c[(c[f >> 2] | 0) + 44 >> 2] = c[m >> 2];
	                c[e >> 2] = c[h >> 2];
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function bP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 44 | 0;
	                f = d + 40 | 0;
	                g = d + 36 | 0;
	                h = d + 32 | 0;
	                j = d + 28 | 0;
	                k = d + 24 | 0;
	                l = d + 20 | 0;
	                m = d + 16 | 0;
	                n = d + 12 | 0;
	                o = d + 8 | 0;
	                p = d + 4 | 0;
	                q = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    r = c[e >> 2] | 0;
	                    i = d;
	                    return r | 0
	                }
	                if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189864) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0)c[h >> 2] = aP(c[f >> 2] | 0, c[g >> 2] | 0) | 0; else s = 9;
	                a:do if ((s | 0) == 9) {
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189904) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = kP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189824) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        } else {
	                            c[c[h >> 2] >> 2] = 0;
	                            if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1025, 192096, 0, 0);
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189856) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        } else {
	                            c[c[h >> 2] >> 2] = 3;
	                            if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1109, 192128, 0, 0);
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189984) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 15;
	                        b = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(b, a, 1023, 192152, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        } else {
	                            t = xO(b, c[a + 12 >> 2] | 0, 1) | 0;
	                            c[(c[h >> 2] | 0) + 24 >> 2] = t;
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 19e4) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 16;
	                        t = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(t, a, 1023, 192152, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        } else {
	                            b = xO(t, c[a + 12 >> 2] | 0, 1) | 0;
	                            c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189968) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 14;
	                        b = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(b, a, 1023, 192152, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        } else {
	                            t = xO(b, c[a + 12 >> 2] | 0, 1) | 0;
	                            c[(c[h >> 2] | 0) + 24 >> 2] = t;
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190016) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 17;
	                        t = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(t, a, 1023, 192152, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        } else {
	                            b = xO(t, c[a + 12 >> 2] | 0, 0) | 0;
	                            c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190024) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 18;
	                        b = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(b, a, 1023, 192152, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        } else {
	                            t = xO(b, c[a + 12 >> 2] | 0, 0) | 0;
	                            c[(c[h >> 2] | 0) + 24 >> 2] = t;
	                            break
	                        }
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189928) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 11;
	                        t = Yi(c[g >> 2] | 0, 192176) | 0;
	                        c[(c[h >> 2] | 0) + 8 >> 2] = t;
	                        do if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0))zN(c[f >> 2] | 0, c[g >> 2] | 0, 1102, 192184, 0, 0); else {
	                            ZO(c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                            if (!(Eh(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0) | 0))break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1100, 192208, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0)
	                        } while (0);
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1103, 192240, 0, 0);
	                        if (!(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0)) {
	                            t = Ij(10) | 0;
	                            c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = t
	                        }
	                        t = c[f >> 2] | 0;
	                        if (!(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0)) {
	                            zN(t, c[g >> 2] | 0, 1098, 192264, 0, 0);
	                            c[h >> 2] = 0;
	                            break
	                        }
	                        c[j >> 2] = Lj(c[(c[t + 24 >> 2] | 0) + 28 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if ((c[j >> 2] | 0) >= 0)break;
	                        c[k >> 2] = Rj(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[(c[h >> 2] | 0) + 44 >> 2] = c[(c[k >> 2] | 0) + 44 >> 2];
	                            c[(c[k >> 2] | 0) + 44 >> 2] = c[h >> 2];
	                            break
	                        }
	                        t = c[f >> 2] | 0;
	                        a = c[g >> 2] | 0;
	                        if (c[(c[h >> 2] | 0) + 8 >> 2] | 0)zN(t, a, 1098, 192304, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0); else zN(t, a, 1098, 192336, 0, 0);
	                        c[h >> 2] = 0;
	                        break
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 192360) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = lP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189888) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = mP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break
	                    }
	                    if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189896) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 8;
	                        a = c[f >> 2] | 0;
	                        t = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(a, t, 1023, 192152, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                            break
	                        } else {
	                            b = xO(a, c[t + 12 >> 2] | 0, 0) | 0;
	                            c[(c[h >> 2] | 0) + 24 >> 2] = b;
	                            break
	                        }
	                    }
	                    do if ((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190032) | 0) != 0 : 0) {
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0))break;
	                        c[h >> 2] = nP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break a
	                    } while (0);
	                    do if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189936) | 0))break;
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0))break;
	                        c[h >> 2] = oP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        break a
	                    } while (0);
	                    do if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189832) | 0))break;
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0))break;
	                        c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        } else {
	                            c[c[h >> 2] >> 2] = 1;
	                            if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0))break a;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1055, 192368, 0, 0);
	                            break a
	                        }
	                    } while (0);
	                    do if (c[g >> 2] | 0) {
	                        if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0))break;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 190264) | 0))break;
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0))break;
	                        c[n >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                        c[m >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        c[(c[f >> 2] | 0) + 28 >> 2] = c[m >> 2];
	                        c[l >> 2] = WN(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        if (c[m >> 2] | 0) {
	                            c[(c[f >> 2] | 0) + 24 >> 2] = c[m >> 2];
	                            c[(c[f >> 2] | 0) + 28 >> 2] = c[n >> 2]
	                        }
	                        if (c[l >> 2] | 0) {
	                            c[h >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                            break a
	                        } else {
	                            c[h >> 2] = 0;
	                            break a
	                        }
	                    } while (0);
	                    do if (c[g >> 2] | 0) {
	                        if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0))break;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189952) | 0))break;
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0))break;
	                        b = c[f >> 2] | 0;
	                        t = c[g >> 2] | 0;
	                        if (!(c[(c[f >> 2] | 0) + 28 >> 2] | 0)) {
	                            zN(b, t, 1063, 192424, 0, 0);
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[h >> 2] = DN(b, t) | 0;
	                        if (!(c[h >> 2] | 0)) {
	                            c[e >> 2] = 0;
	                            r = c[e >> 2] | 0;
	                            i = d;
	                            return r | 0
	                        }
	                        c[c[h >> 2] >> 2] = 13;
	                        t = Yi(c[g >> 2] | 0, 192176) | 0;
	                        c[(c[h >> 2] | 0) + 8 >> 2] = t;
	                        do if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0))zN(c[f >> 2] | 0, c[g >> 2] | 0, 1062, 192472, 0, 0); else {
	                            ZO(c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                            if (!(Eh(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0) | 0))break;
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1061, 192496, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0)
	                        } while (0);
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1064, 192536, 0, 0);
	                        if (!(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0)) {
	                            t = Ij(10) | 0;
	                            c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] = t
	                        }
	                        if (!(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0)) {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1060, 192264, 0, 0);
	                            c[h >> 2] = 0;
	                            break a
	                        }
	                        if (!(c[(c[h >> 2] | 0) + 8 >> 2] | 0))break a;
	                        c[o >> 2] = Lj(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0;
	                        if ((c[o >> 2] | 0) >= 0)break a;
	                        c[p >> 2] = Rj(c[(c[(c[f >> 2] | 0) + 28 >> 2] | 0) + 28 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (!(c[p >> 2] | 0)) {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1060, 192560, c[(c[h >> 2] | 0) + 8 >> 2] | 0, 0);
	                            c[h >> 2] = 0;
	                            break a
	                        } else {
	                            c[(c[h >> 2] | 0) + 44 >> 2] = c[(c[p >> 2] | 0) + 44 >> 2];
	                            c[(c[p >> 2] | 0) + 44 >> 2] = c[h >> 2];
	                            break a
	                        }
	                    } while (0);
	                    do if (c[g >> 2] | 0) {
	                        if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0))break;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 192608) | 0))break;
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0))break;
	                        t = c[f >> 2] | 0;
	                        b = c[g >> 2] | 0;
	                        if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(t, b, 1023, 192616, 0, 0);
	                            c[h >> 2] = 0;
	                            break a
	                        }
	                        c[h >> 2] = nP(t, b) | 0;
	                        if (!(c[h >> 2] | 0))break a;
	                        do if (c[(c[h >> 2] | 0) + 24 >> 2] | 0) {
	                            if (!(c[(c[(c[h >> 2] | 0) + 24 >> 2] | 0) + 32 >> 2] | 0))break;
	                            c[q >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                            if (!(c[q >> 2] | 0))break;
	                            c[c[q >> 2] >> 2] = 18;
	                            c[(c[q >> 2] | 0) + 24 >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                            c[(c[h >> 2] | 0) + 24 >> 2] = c[q >> 2]
	                        } while (0);
	                        c[q >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (c[q >> 2] | 0) {
	                            c[c[q >> 2] >> 2] = 3;
	                            c[(c[q >> 2] | 0) + 32 >> 2] = c[(c[h >> 2] | 0) + 24 >> 2];
	                            c[(c[h >> 2] | 0) + 24 >> 2] = c[q >> 2];
	                            break a
	                        }
	                        c[e >> 2] = c[h >> 2];
	                        r = c[e >> 2] | 0;
	                        i = d;
	                        return r | 0
	                    } while (0);
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1115, 192632, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0);
	                    c[h >> 2] = 0
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                r = c[e >> 2] | 0;
	                i = d;
	                return r | 0
	            }

	            function cP(a) {
	                a = a | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (b[(c[f >> 2] | 0) + 50 >> 1] & 1) {
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                if (b[(c[f >> 2] | 0) + 50 >> 1] & 2) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                a:do switch (c[c[f >> 2] >> 2] | 0) {
	                    case 16:
	                    case 13:
	                    case 12:
	                    case 11:
	                    case 10:
	                    case -1:
	                    {
	                        c[g >> 2] = cP(c[(c[f >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        break
	                    }
	                    case 9:
	                    case 8:
	                    case 7:
	                    case 6:
	                    case 5:
	                    case 4:
	                    case 1:
	                    case 2:
	                    {
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    case 3:
	                    case 0:
	                    {
	                        c[g >> 2] = 1;
	                        break
	                    }
	                    case 18:
	                    case 19:
	                    case 20:
	                    {
	                        c[j >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[j >> 2] | 0))break;
	                            c[g >> 2] = cP(c[j >> 2] | 0) | 0;
	                            if ((c[g >> 2] | 0) != 1)break a;
	                            c[j >> 2] = c[(c[j >> 2] | 0) + 32 >> 2]
	                        }
	                        c[e >> 2] = 1;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                    case 17:
	                    {
	                        c[h >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[h >> 2] | 0))break;
	                            c[g >> 2] = cP(c[h >> 2] | 0) | 0;
	                            if (c[g >> 2] | 0)break a;
	                            c[h >> 2] = c[(c[h >> 2] | 0) + 32 >> 2]
	                        }
	                        c[g >> 2] = 0;
	                        break
	                    }
	                    default:
	                    {
	                        c[e >> 2] = -1;
	                        k = c[e >> 2] | 0;
	                        i = d;
	                        return k | 0
	                    }
	                } while (0);
	                if (!(c[g >> 2] | 0)) {
	                    h = (c[f >> 2] | 0) + 50 | 0;
	                    b[h >> 1] = b[h >> 1] | 2
	                }
	                if ((c[g >> 2] | 0) == 1) {
	                    h = (c[f >> 2] | 0) + 50 | 0;
	                    b[h >> 1] = b[h >> 1] | 1
	                }
	                c[e >> 2] = c[g >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function dP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        h = 5;
	                        break
	                    }
	                    c[g >> 2] = SO(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                    if (c[g >> 2] | 0) {
	                        h = 5;
	                        break
	                    }
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 32 >> 2]
	                }
	                if ((h | 0) == 5) {
	                    i = d;
	                    return c[g >> 2] | 0
	                }
	                return 0
	            }

	            function eP(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 16 | 0;
	                n = f + 12 | 0;
	                o = f + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0) {
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                do if (c[(c[k >> 2] | 0) + 12 >> 2] | 0) {
	                    e = c[(c[l >> 2] | 0) + 36 >> 2] | 0;
	                    if (!(d[c[(c[k >> 2] | 0) + 12 >> 2] >> 0] | 0)) {
	                        if (!e)break;
	                        c[h >> 2] = 0;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                    if ((e | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 12 >> 2] | 0, c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                    c[h >> 2] = 0;
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                } while (0);
	                if (!(c[(c[k >> 2] | 0) + 40 >> 2] | 0)) {
	                    c[h >> 2] = 1;
	                    p = c[h >> 2] | 0;
	                    i = f;
	                    return p | 0
	                }
	                c[k >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                e = c[k >> 2] | 0;
	                a:do if ((c[c[k >> 2] >> 2] | 0) == 2) {
	                    c[n >> 2] = c[e + 24 >> 2];
	                    while (1) {
	                        if (!(c[n >> 2] | 0))break a;
	                        c[m >> 2] = eP(c[j >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) == 1) {
	                            q = 17;
	                            break
	                        }
	                        if ((c[m >> 2] | 0) < 0) {
	                            q = 19;
	                            break
	                        }
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 32 >> 2]
	                    }
	                    if ((q | 0) == 17) {
	                        c[h >> 2] = 0;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((q | 0) == 19) {
	                        c[h >> 2] = c[m >> 2];
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                } else {
	                    if ((c[e >> 2] | 0) != 17) {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[g >> 2] = 189496;
	                        c[g + 4 >> 2] = 9070;
	                        Db[b & 511](a, 189464, g);
	                        break
	                    }
	                    c[o >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                    while (1) {
	                        if (!(c[o >> 2] | 0)) {
	                            q = 29;
	                            break
	                        }
	                        c[m >> 2] = eP(c[j >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) == 1) {
	                            q = 25;
	                            break
	                        }
	                        if ((c[m >> 2] | 0) < 0) {
	                            q = 27;
	                            break
	                        }
	                        c[o >> 2] = c[(c[o >> 2] | 0) + 32 >> 2]
	                    }
	                    if ((q | 0) == 25) {
	                        c[h >> 2] = 1;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((q | 0) == 27) {
	                        c[h >> 2] = c[m >> 2];
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    } else if ((q | 0) == 29) {
	                        c[h >> 2] = 0;
	                        p = c[h >> 2] | 0;
	                        i = f;
	                        return p | 0
	                    }
	                } while (0);
	                c[h >> 2] = 1;
	                p = c[h >> 2] | 0;
	                i = f;
	                return p | 0
	            }

	            function fP(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                p = g + 4 | 0;
	                c[g + 28 >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = c[l >> 2];
	                c[n >> 2] = c[k >> 2];
	                if (!(c[m >> 2] | 0)) {
	                    k = c[o >> 2] | 0;
	                    c[h >> 2] = c[j >> 2];
	                    Ka(k | 0, 189616, h | 0) | 0;
	                    i = g;
	                    return
	                }
	                if (!(c[n >> 2] | 0)) {
	                    if ((d[c[j >> 2] >> 0] | 0 | 0) == 35) {
	                        i = g;
	                        return
	                    }
	                    k = c[o >> 2] | 0;
	                    c[h >> 2] = c[j >> 2];
	                    Ka(k | 0, 189648, h | 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    if (c[(c[m >> 2] | 0) + 40 >> 2] | 0) {
	                        i = g;
	                        return
	                    }
	                    c[(c[m >> 2] | 0) + 40 >> 2] = 37;
	                    i = g;
	                    return
	                }
	                if ((c[m >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0) {
	                    k = c[o >> 2] | 0;
	                    c[h >> 2] = c[j >> 2];
	                    Ka(k | 0, 189680, h | 0) | 0;
	                    if (!(c[m >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    if (c[(c[m >> 2] | 0) + 40 >> 2] | 0) {
	                        i = g;
	                        return
	                    }
	                    c[(c[m >> 2] | 0) + 40 >> 2] = 37;
	                    i = g;
	                    return
	                }
	                if ((c[c[n >> 2] >> 2] | 0) != 4) {
	                    k = c[o >> 2] | 0;
	                    c[h >> 2] = c[j >> 2];
	                    Ka(k | 0, 189712, h | 0) | 0;
	                    if (c[(c[m >> 2] | 0) + 40 >> 2] | 0) {
	                        i = g;
	                        return
	                    }
	                    c[(c[m >> 2] | 0) + 40 >> 2] = 37;
	                    i = g;
	                    return
	                } else {
	                    c[p >> 2] = KN(c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    c[(c[m >> 2] | 0) + 112 >> 2] = c[p >> 2];
	                    i = g;
	                    return
	                }
	            }

	            function gP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                b = c[j >> 2] | 0;
	                c[j >> 2] = b + 1;
	                c[h >> 2] = c[(c[g >> 2] | 0) + (b << 2) >> 2];
	                a:while (1) {
	                    if (!(c[h >> 2] | 0)) {
	                        m = 14;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[c[h >> 2] >> 2] | 0) == 4 : 0) {
	                        c[k >> 2] = MO(0, c[h >> 2] | 0, c[f >> 2] | 0) | 0;
	                        if ((c[k >> 2] | 0) == 1) {
	                            m = 8;
	                            break
	                        }
	                    } else m = 9;
	                    do if ((m | 0) == 9) {
	                        m = 0;
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 4 : 0)break;
	                        if ((c[c[h >> 2] >> 2] | 0) == 3) {
	                            m = 12;
	                            break a
	                        }
	                    } while (0);
	                    b = c[j >> 2] | 0;
	                    c[j >> 2] = b + 1;
	                    c[h >> 2] = c[(c[g >> 2] | 0) + (b << 2) >> 2]
	                }
	                if ((m | 0) == 8) {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 12) {
	                    c[e >> 2] = 1;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                } else if ((m | 0) == 14) {
	                    c[e >> 2] = 0;
	                    l = c[e >> 2] | 0;
	                    i = d;
	                    return l | 0
	                }
	                return 0
	            }

	            function hP(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[f >> 2] = a;
	                c[g >> 2] = c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2];
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) {
	                    while (1) {
	                        if (!(d[c[g >> 2] >> 0] | 0))break;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        if ((c[g >> 2] | 0) != (c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0))h = (d[c[g >> 2] >> 0] | 0 | 0) == 0; else h = 0;
	                        j = c[g >> 2] | 0;
	                        if (!h)break;
	                        c[g >> 2] = j + 1
	                    }
	                    if ((j | 0) == (c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] | 0))c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = 0; else c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = c[g >> 2];
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = b;
	                    return k | 0
	                }
	                c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 20 >> 2] = 0;
	                c[(c[(c[f >> 2] | 0) + 60 >> 2] | 0) + 24 >> 2] = 0;
	                c[e >> 2] = 0;
	                k = c[e >> 2] | 0;
	                i = b;
	                return k | 0
	            }

	            function iP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = 0;
	                while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        h = 5;
	                        break
	                    }
	                    c[g >> 2] = SO(c[e >> 2] | 0, c[f >> 2] | 0) | 0;
	                    if (c[g >> 2] | 0) {
	                        h = 5;
	                        break
	                    }
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 32 >> 2]
	                }
	                if ((h | 0) == 5) {
	                    i = d;
	                    return c[g >> 2] | 0
	                }
	                return 0
	            }

	            function jP(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 32 | 0;
	                h = f + 28 | 0;
	                j = f + 24 | 0;
	                k = f + 20 | 0;
	                l = f + 16 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = c[k >> 2];
	                if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 192176) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0)q = 16; else q = 6;
	                do if ((q | 0) == 6) {
	                    if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 193584) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        q = 16;
	                        break
	                    }
	                    if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 193592) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0)q = 16
	                } while (0);
	                do if (((q | 0) == 16 ? (c[c[k >> 2] >> 2] | 0) != 4 : 0) ? (c[c[k >> 2] >> 2] | 0) != 9 : 0) {
	                    c[l >> 2] = DN(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        c[g >> 2] = 0;
	                        r = c[g >> 2] | 0;
	                        i = f;
	                        return r | 0
	                    }
	                    c[(c[l >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                    e = c[l >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 32 >> 2] & 1) {
	                        c[e >> 2] = 9;
	                        break
	                    } else {
	                        c[e >> 2] = 4;
	                        break
	                    }
	                } while (0);
	                if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 192176) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                    c[n >> 2] = _i(c[j >> 2] | 0) | 0;
	                    ZO(c[n >> 2] | 0);
	                    do if (Eh(c[n >> 2] | 0, 0) | 0) {
	                        e = c[h >> 2] | 0;
	                        b = c[j >> 2] | 0;
	                        if (c[(c[j >> 2] | 0) + 20 >> 2] | 0) {
	                            zN(e, b, 1019, 193600, c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, c[n >> 2] | 0);
	                            break
	                        } else {
	                            zN(e, b, 1019, 193640, c[n >> 2] | 0, 0);
	                            break
	                        }
	                    } while (0);
	                    c[(c[l >> 2] | 0) + 8 >> 2] = c[n >> 2];
	                    c[n >> 2] = Yi(c[j >> 2] | 0, 192672) | 0;
	                    c[(c[l >> 2] | 0) + 12 >> 2] = c[n >> 2];
	                    if (((c[n >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 32 >> 2] & 1 | 0) != 0 : 0) ? (qy(c[n >> 2] | 0, 193672) | 0) != 0 : 0)zN(c[h >> 2] | 0, c[j >> 2] | 0, 1122, 193704, c[n >> 2] | 0, 0);
	                    if ((((c[n >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 32 >> 2] & 1 | 0) != 0 : 0) ? (d[c[n >> 2] >> 0] | 0 | 0) == 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 193752) | 0) != 0 : 0)zN(c[h >> 2] | 0, c[j >> 2] | 0, 1121, 193760, c[n >> 2] | 0, 0)
	                } else q = 39;
	                a:do if ((q | 0) == 39) {
	                    if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 193584) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 0;
	                        c[(c[l >> 2] | 0) + 12 >> 2] = 0;
	                        if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0))break;
	                        n = pP(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0, (c[c[k >> 2] >> 2] | 0) == 9 & 1) | 0;
	                        c[(c[l >> 2] | 0) + 40 >> 2] = n;
	                        break
	                    }
	                    if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 193592) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[(c[l >> 2] | 0) + 8 >> 2] = 0;
	                        n = Yi(c[j >> 2] | 0, 192672) | 0;
	                        c[(c[l >> 2] | 0) + 12 >> 2] = n;
	                        if (!(c[(c[l >> 2] | 0) + 12 >> 2] | 0))zN(c[h >> 2] | 0, c[j >> 2] | 0, 1057, 193808, 0, 0);
	                        if (((c[(c[h >> 2] | 0) + 32 >> 2] & 1 | 0) != 0 ? (c[(c[l >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (qy(c[(c[l >> 2] | 0) + 12 >> 2] | 0, 193672) | 0) != 0 : 0)zN(c[h >> 2] | 0, c[j >> 2] | 0, 1122, 193704, c[(c[l >> 2] | 0) + 12 >> 2] | 0, 0);
	                        if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0))break;
	                        n = pP(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 12 >> 2] | 0, (c[c[k >> 2] >> 2] | 0) == 9 & 1) | 0;
	                        c[(c[l >> 2] | 0) + 40 >> 2] = n;
	                        break
	                    }
	                    if (((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 190016) | 0) != 0 : 0) ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                        c[p >> 2] = 0;
	                        c[l >> 2] = DN(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[g >> 2] = 0;
	                            r = c[g >> 2] | 0;
	                            i = f;
	                            return r | 0
	                        }
	                        c[(c[l >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                        c[c[l >> 2] >> 2] = 17;
	                        if (!(c[(c[j >> 2] | 0) + 12 >> 2] | 0)) {
	                            zN(c[h >> 2] | 0, c[j >> 2] | 0, 1007, 193840, 0, 0);
	                            break
	                        }
	                        c[o >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[o >> 2] | 0))break a;
	                            c[m >> 2] = jP(c[h >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0) | 0;
	                            do if (c[m >> 2] | 0) {
	                                n = c[m >> 2] | 0;
	                                if (!(c[p >> 2] | 0)) {
	                                    c[(c[l >> 2] | 0) + 40 >> 2] = n;
	                                    c[p >> 2] = n;
	                                    break
	                                } else {
	                                    c[(c[p >> 2] | 0) + 32 >> 2] = n;
	                                    c[p >> 2] = c[m >> 2];
	                                    break
	                                }
	                            } while (0);
	                            c[o >> 2] = c[(c[o >> 2] | 0) + 24 >> 2]
	                        }
	                    }
	                    if (!(c[j >> 2] | 0))s = 193928; else s = c[(c[j >> 2] | 0) + 8 >> 2] | 0;
	                    zN(c[h >> 2] | 0, c[j >> 2] | 0, 1006, 193872, s, 0);
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                } while (0);
	                do if ((c[l >> 2] | 0) != (c[k >> 2] | 0)) {
	                    if (!(c[(c[k >> 2] | 0) + 40 >> 2] | 0)) {
	                        c[(c[k >> 2] | 0) + 40 >> 2] = c[l >> 2];
	                        break
	                    }
	                    c[m >> 2] = c[(c[k >> 2] | 0) + 40 >> 2];
	                    while (1) {
	                        if (!(c[(c[m >> 2] | 0) + 32 >> 2] | 0))break;
	                        c[m >> 2] = c[(c[m >> 2] | 0) + 32 >> 2]
	                    }
	                    c[(c[m >> 2] | 0) + 32 >> 2] = c[l >> 2]
	                } while (0);
	                c[g >> 2] = c[l >> 2];
	                r = c[g >> 2] | 0;
	                i = f;
	                return r | 0
	            }

	            function kP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 24 | 0;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                k = d + 4 | 0;
	                l = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[c[h >> 2] >> 2] = 9;
	                c[(c[h >> 2] | 0) + 28 >> 2] = c[(c[f >> 2] | 0) + 48 >> 2];
	                c[k >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                b = c[f >> 2] | 0;
	                if (!(c[k >> 2] | 0)) {
	                    zN(b, c[g >> 2] | 0, 1004, 193408, 0, 0);
	                    c[e >> 2] = c[h >> 2];
	                    m = c[e >> 2] | 0;
	                    i = d;
	                    return m | 0
	                }
	                c[l >> 2] = c[b + 32 >> 2];
	                b = (c[f >> 2] | 0) + 32 | 0;
	                c[b >> 2] = c[b >> 2] | 1;
	                c[j >> 2] = jP(c[f >> 2] | 0, c[k >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (c[j >> 2] | 0)c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                if (c[k >> 2] | 0) {
	                    c[j >> 2] = bP(c[f >> 2] | 0, c[k >> 2] | 0) | 0;
	                    a:do if (c[j >> 2] | 0)switch (c[c[j >> 2] >> 2] | 0) {
	                        case -1:
	                        {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1005, 193496, 0, 0);
	                            break a;
	                            break
	                        }
	                        case 2:
	                        case 6:
	                        case 20:
	                        {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1003, 193464, 0, 0);
	                            break a;
	                            break
	                        }
	                        case 9:
	                        case 19:
	                        case 18:
	                        case 17:
	                        case 14:
	                        case 15:
	                        case 16:
	                        case 10:
	                        case 12:
	                        case 13:
	                        case 11:
	                        case 8:
	                        case 7:
	                        case 5:
	                        case 4:
	                        case 3:
	                        case 1:
	                        case 0:
	                        {
	                            c[(c[h >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                            c[(c[j >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                            break a;
	                            break
	                        }
	                        default:
	                            break a
	                    } while (0);
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                if (c[k >> 2] | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1002, 193544, 0, 0);
	                c[(c[f >> 2] | 0) + 32 >> 2] = c[l >> 2];
	                c[e >> 2] = c[h >> 2];
	                m = c[e >> 2] | 0;
	                i = d;
	                return m | 0
	            }

	            function lP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 56 | 0;
	                f = d + 52 | 0;
	                g = d + 48 | 0;
	                h = d + 44 | 0;
	                j = d + 40 | 0;
	                k = d + 36 | 0;
	                l = d + 32 | 0;
	                m = d + 28 | 0;
	                n = d + 24 | 0;
	                o = d + 20 | 0;
	                p = d + 16 | 0;
	                q = d + 12 | 0;
	                r = d + 8 | 0;
	                s = d + 4 | 0;
	                t = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[l >> 2] = 0;
	                c[n >> 2] = Yi(c[g >> 2] | 0, 192784) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1110, 193184, 0, 0);
	                    c[e >> 2] = 0;
	                    u = c[e >> 2] | 0;
	                    i = d;
	                    return u | 0
	                }
	                ZO(c[n >> 2] | 0);
	                if (Eh(c[n >> 2] | 0, 0) | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1112, 193208, c[n >> 2] | 0, 0);
	                c[o >> 2] = qP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0))c[o >> 2] = my(192832) | 0;
	                c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    c[e >> 2] = 0;
	                    u = c[e >> 2] | 0;
	                    i = d;
	                    return u | 0
	                }
	                c[c[h >> 2] >> 2] = 5;
	                c[(c[h >> 2] | 0) + 8 >> 2] = c[n >> 2];
	                c[(c[h >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                c[m >> 2] = Rj(c[46942] | 0, c[o >> 2] | 0) | 0;
	                do if (c[m >> 2] | 0) {
	                    c[(c[h >> 2] | 0) + 20 >> 2] = c[m >> 2];
	                    if (!(c[(c[m >> 2] | 0) + 8 >> 2] | 0)) {
	                        zN(c[f >> 2] | 0, c[g >> 2] | 0, 1026, 192912, c[o >> 2] | 0, 0);
	                        break
	                    }
	                    c[q >> 2] = Hb[c[(c[m >> 2] | 0) + 8 >> 2] & 511](c[(c[m >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if ((c[q >> 2] | 0) != 1) {
	                        zN(c[f >> 2] | 0, c[g >> 2] | 0, 1111, 192968, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[o >> 2] | 0);
	                        break
	                    }
	                    if (qy(c[o >> 2] | 0, 187824) | 0) {
	                        if ((qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 193248) | 0) == 0 ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 193256) | 0) == 0 : 0)break;
	                        c[(c[f >> 2] | 0) + 128 >> 2] = 1
	                    }
	                } else {
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1116, 192872, c[o >> 2] | 0, 0);
	                    c[(c[h >> 2] | 0) + 20 >> 2] = 0
	                } while (0);
	                c[p >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                a:while (1) {
	                    if (!(c[p >> 2] | 0))break;
	                    if (!(qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 190064) | 0))break;
	                    q = (qy(c[o >> 2] | 0, 192832) | 0) != 0;
	                    m = c[f >> 2] | 0;
	                    n = c[g >> 2] | 0;
	                    if (q) {
	                        zN(m, n, 1058, 193264, c[o >> 2] | 0, 0);
	                        c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2];
	                        while (1) {
	                            if (!(c[p >> 2] | 0))continue a;
	                            if (!(qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 190064) | 0))continue a;
	                            c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                        }
	                    }
	                    c[k >> 2] = DN(m, n) | 0;
	                    if (c[k >> 2] | 0) {
	                        c[c[k >> 2] >> 2] = 6;
	                        q = Yi(c[p >> 2] | 0, 192176) | 0;
	                        c[(c[k >> 2] | 0) + 8 >> 2] = q;
	                        if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))zN(c[f >> 2] | 0, c[g >> 2] | 0, 1059, 193320, 0, 0);
	                        q = _i(c[p >> 2] | 0) | 0;
	                        c[(c[k >> 2] | 0) + 16 >> 2] = q;
	                        q = c[k >> 2] | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[l >> 2] = q;
	                            c[(c[h >> 2] | 0) + 36 >> 2] = q
	                        } else {
	                            c[(c[l >> 2] | 0) + 32 >> 2] = q;
	                            c[l >> 2] = c[k >> 2]
	                        }
	                    }
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                }
	                if ((c[p >> 2] | 0) != 0 ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 189848) | 0) != 0 : 0) {
	                    c[t >> 2] = 0;
	                    c[j >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[e >> 2] = c[h >> 2];
	                        u = c[e >> 2] | 0;
	                        i = d;
	                        return u | 0
	                    }
	                    c[c[j >> 2] >> 2] = 2;
	                    c[r >> 2] = c[(c[p >> 2] | 0) + 12 >> 2];
	                    c[(c[h >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                    if (!(c[r >> 2] | 0))zN(c[f >> 2] | 0, c[p >> 2] | 0, 1030, 193344, 0, 0);
	                    while (1) {
	                        if (!(c[r >> 2] | 0))break;
	                        c[s >> 2] = bP(c[f >> 2] | 0, c[r >> 2] | 0) | 0;
	                        do if (c[s >> 2] | 0) {
	                            g = c[s >> 2] | 0;
	                            if (!(c[t >> 2] | 0)) {
	                                c[t >> 2] = g;
	                                c[(c[j >> 2] | 0) + 24 >> 2] = g;
	                                break
	                            } else {
	                                c[(c[t >> 2] | 0) + 32 >> 2] = g;
	                                c[t >> 2] = c[s >> 2];
	                                break
	                            }
	                        } while (0);
	                        c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                    }
	                    c[p >> 2] = c[(c[p >> 2] | 0) + 24 >> 2]
	                }
	                if (c[p >> 2] | 0)zN(c[f >> 2] | 0, c[p >> 2] | 0, 1009, 193368, c[(c[p >> 2] | 0) + 8 >> 2] | 0, 0);
	                c[e >> 2] = c[h >> 2];
	                u = c[e >> 2] | 0;
	                i = d;
	                return u | 0
	            }

	            function mP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[m >> 2] = 0;
	                c[h >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                c[c[h >> 2] >> 2] = 7;
	                c[k >> 2] = Yi(c[g >> 2] | 0, 192784) | 0;
	                do if (c[k >> 2] | 0) {
	                    ZO(c[k >> 2] | 0);
	                    if (Eh(c[k >> 2] | 0, 0) | 0)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1112, 192792, c[k >> 2] | 0, 0);
	                    c[l >> 2] = qP(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0))c[l >> 2] = my(192832) | 0;
	                    c[(c[h >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                    c[(c[h >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                    c[j >> 2] = Rj(c[46942] | 0, c[l >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        zN(c[f >> 2] | 0, c[g >> 2] | 0, 1116, 192872, c[l >> 2] | 0, 0);
	                        c[(c[h >> 2] | 0) + 20 >> 2] = 0;
	                        break
	                    }
	                    c[(c[h >> 2] | 0) + 20 >> 2] = c[j >> 2];
	                    if (!(c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                        zN(c[f >> 2] | 0, c[g >> 2] | 0, 1026, 192912, c[l >> 2] | 0, 0);
	                        break
	                    }
	                    c[m >> 2] = Hb[c[(c[j >> 2] | 0) + 8 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if ((c[m >> 2] | 0) != 1)zN(c[f >> 2] | 0, c[g >> 2] | 0, 1111, 192968, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0)
	                } while (0);
	                do if (!(c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                    l = my(188112) | 0;
	                    c[(c[h >> 2] | 0) + 16 >> 2] = l
	                } else {
	                    if (!((c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 4 : 0))p = 18;
	                    if ((p | 0) == 18 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 24 >> 2] | 0) == 0 : 0) {
	                        if (!(c[h >> 2] | 0))break;
	                        l = _i(c[g >> 2] | 0) | 0;
	                        c[(c[h >> 2] | 0) + 16 >> 2] = l;
	                        if (!(c[(c[h >> 2] | 0) + 16 >> 2] | 0)) {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1120, 193080, 0, 0);
	                            break
	                        }
	                        if (!(c[j >> 2] | 0))break;
	                        if (!((c[m >> 2] | 0) == 1 ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0))break;
	                        c[n >> 2] = 0;
	                        c[m >> 2] = Ib[c[(c[j >> 2] | 0) + 12 >> 2] & 511](c[(c[j >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[(c[h >> 2] | 0) + 16 >> 2] | 0, n, c[g >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) != 1) {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1051, 193112, c[(c[h >> 2] | 0) + 16 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0);
	                            break
	                        }
	                        if (!(c[n >> 2] | 0))break;
	                        c[(c[h >> 2] | 0) + 36 >> 2] = c[n >> 2];
	                        break
	                    }
	                    zN(c[f >> 2] | 0, c[g >> 2] | 0, 1108, 193024, 0, 0)
	                } while (0);
	                c[e >> 2] = c[h >> 2];
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function nP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d + 32 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[j >> 2] = DN(c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                c[c[j >> 2] >> 2] = 19;
	                if (!(c[(c[g >> 2] | 0) + 56 >> 2] | 0)) {
	                    b = Ij(10) | 0;
	                    c[(c[g >> 2] | 0) + 56 >> 2] = b
	                }
	                if (c[(c[g >> 2] | 0) + 56 >> 2] | 0) {
	                    b = (c[g >> 2] | 0) + 52 | 0;
	                    a = c[b >> 2] | 0;
	                    c[b >> 2] = a + 1;
	                    c[e >> 2] = a;
	                    JT(n, 32, 192704, e) | 0;
	                    if ((Lj(c[(c[g >> 2] | 0) + 56 >> 2] | 0, n, c[j >> 2] | 0) | 0) < 0)zN(c[g >> 2] | 0, c[h >> 2] | 0, 1045, 192720, n, 0)
	                } else xN(c[g >> 2] | 0, 192680);
	                c[m >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                if (!(c[m >> 2] | 0))zN(c[g >> 2] | 0, c[h >> 2] | 0, 1048, 192752, 0, 0);
	                while (1) {
	                    if (!(c[m >> 2] | 0))break;
	                    if (((((c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 189864) | 0) != 0 : 0) ? (qy(c[(c[(c[m >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0)c[l >> 2] = aP(c[g >> 2] | 0, c[m >> 2] | 0) | 0; else c[l >> 2] = bP(c[g >> 2] | 0, c[m >> 2] | 0) | 0;
	                    do if (c[l >> 2] | 0) {
	                        c[(c[l >> 2] | 0) + 28 >> 2] = c[j >> 2];
	                        h = c[l >> 2] | 0;
	                        if (!(c[k >> 2] | 0)) {
	                            c[k >> 2] = h;
	                            c[(c[j >> 2] | 0) + 24 >> 2] = h;
	                            break
	                        } else {
	                            c[(c[k >> 2] | 0) + 32 >> 2] = h;
	                            c[k >> 2] = c[l >> 2];
	                            break
	                        }
	                    } while (0);
	                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                }
	                c[f >> 2] = c[j >> 2];
	                o = c[f >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function oP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 36 | 0;
	                f = d + 32 | 0;
	                g = d + 28 | 0;
	                h = d + 24 | 0;
	                j = d + 20 | 0;
	                k = d + 16 | 0;
	                l = d + 12 | 0;
	                m = d + 8 | 0;
	                n = d + 4 | 0;
	                o = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[m >> 2] = 0;
	                c[h >> 2] = c[(c[g >> 2] | 0) + 52 >> 2];
	                if (c[h >> 2] | 0) {
	                    c[o >> 2] = DN(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        p = c[e >> 2] | 0;
	                        i = d;
	                        return p | 0
	                    }
	                    c[c[o >> 2] >> 2] = 12;
	                    if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                        c[j >> 2] = Pi(c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (!(c[j >> 2] | 0)) {
	                            zN(c[f >> 2] | 0, c[g >> 2] | 0, 1031, 188056, c[(c[f >> 2] | 0) + 68 >> 2] | 0, 0);
	                            c[e >> 2] = 0;
	                            p = c[e >> 2] | 0;
	                            i = d;
	                            return p | 0
	                        }
	                        c[l >> 2] = Yi(c[j >> 2] | 0, 192672) | 0;
	                        if (!(c[l >> 2] | 0)) {
	                            c[k >> 2] = c[g >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break;
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                                c[l >> 2] = Yi(c[k >> 2] | 0, 192672) | 0;
	                                if (c[l >> 2] | 0)break;
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 20 >> 2]
	                            }
	                            if (c[l >> 2] | 0) {
	                                gj(c[j >> 2] | 0, 192672, c[l >> 2] | 0) | 0;
	                                c[m >> 2] = 1;
	                                zb[c[135736 >> 2] & 511](c[l >> 2] | 0)
	                            }
	                        } else zb[c[135736 >> 2] & 511](c[l >> 2] | 0);
	                        c[n >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                        l = (c[f >> 2] | 0) + 32 | 0;
	                        c[l >> 2] = c[l >> 2] | 128;
	                        l = BN(c[f >> 2] | 0, c[j >> 2] | 0) | 0;
	                        c[(c[h >> 2] | 0) + 16 >> 2] = l;
	                        c[(c[f >> 2] | 0) + 32 >> 2] = c[n >> 2];
	                        if (((c[(c[h >> 2] | 0) + 16 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 12 >> 2] = c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2], (c[(c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 28 >> 2] | 0) != 0) : 0)rP(c[f >> 2] | 0, c[(c[(c[h >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                        if ((c[m >> 2] | 0) == 1)fj(c[j >> 2] | 0, 192672) | 0
	                    }
	                    c[(c[o >> 2] | 0) + 24 >> 2] = c[(c[h >> 2] | 0) + 12 >> 2]
	                } else c[o >> 2] = 0;
	                c[e >> 2] = c[o >> 2];
	                p = c[e >> 2] | 0;
	                i = d;
	                return p | 0
	            }

	            function pP(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if (((((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[h >> 2] | 0) + 8 >> 2] | 0, 189848) | 0) != 0 : 0) ? (qy(c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0) {
	                    if (c[(c[h >> 2] | 0) + 24 >> 2] | 0)zN(c[g >> 2] | 0, c[h >> 2] | 0, 1029, 193968, 0, 0);
	                    d = c[g >> 2] | 0;
	                    b = c[h >> 2] | 0;
	                    if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                        zN(d, b, 1027, 193344, 0, 0);
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    c[k >> 2] = DN(d, b) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = e;
	                        return o | 0
	                    }
	                    c[c[k >> 2] >> 2] = 2;
	                    c[n >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[n >> 2] | 0))break;
	                        c[l >> 2] = DN(c[g >> 2] | 0, c[n >> 2] | 0) | 0;
	                        if (!(c[l >> 2] | 0))break;
	                        b = c[l >> 2] | 0;
	                        if (c[j >> 2] | 0)c[b >> 2] = 9; else c[b >> 2] = 4;
	                        if (jP(c[g >> 2] | 0, c[n >> 2] | 0, c[l >> 2] | 0) | 0) {
	                            b = c[l >> 2] | 0;
	                            if (!(c[m >> 2] | 0))c[(c[k >> 2] | 0) + 24 >> 2] = b; else c[(c[m >> 2] | 0) + 32 >> 2] = b;
	                            c[m >> 2] = c[l >> 2]
	                        }
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                    }
	                    c[f >> 2] = c[k >> 2];
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                zN(c[g >> 2] | 0, c[h >> 2] | 0, 1028, 193936, 0, 0);
	                c[f >> 2] = 0;
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function qP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[e + 12 >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 192360) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0)l = 13; else l = 8;
	                if ((((((l | 0) == 8 ? (c[g >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 189888) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[46968] | 0) | 0) != 0 : 0)l = 13;
	                if ((l | 0) == 13 ? (c[h >> 2] = Yi(c[g >> 2] | 0, 193160) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                    if (!(d[c[h >> 2] >> 0] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[f >> 2] = 0;
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                    c[j >> 2] = Fl(c[h >> 2] | 0, 193176) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[f >> 2] = c[h >> 2];
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    } else {
	                        zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                        c[f >> 2] = c[j >> 2];
	                        k = c[f >> 2] | 0;
	                        i = e;
	                        return k | 0
	                    }
	                }
	                c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0)) {
	                        l = 29;
	                        break
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        l = 29;
	                        break
	                    }
	                    c[h >> 2] = Yi(c[g >> 2] | 0, 193160) | 0;
	                    if (c[h >> 2] | 0)break;
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 20 >> 2]
	                }
	                if ((l | 0) == 29) {
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                if (!(d[c[h >> 2] >> 0] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                c[j >> 2] = Fl(c[h >> 2] | 0, 193176) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[f >> 2] = c[h >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                } else {
	                    zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                    c[f >> 2] = c[j >> 2];
	                    k = c[f >> 2] | 0;
	                    i = e;
	                    return k | 0
	                }
	                return 0
	            }

	            function rP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) ? (c[(c[f >> 2] | 0) + 24 >> 2] | 0) != 0 : 0) {
	                    if (!(c[(c[g >> 2] | 0) + 28 >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                    if (!(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0)) {
	                        b = Ij(10) | 0;
	                        c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] = b
	                    }
	                    if (!(c[(c[(c[f >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0)) {
	                        zN(c[f >> 2] | 0, 0, 1098, 192264, 0, 0);
	                        c[e >> 2] = -1;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    } else {
	                        Wj(c[(c[g >> 2] | 0) + 28 >> 2] | 0, 386, c[f >> 2] | 0);
	                        c[e >> 2] = 0;
	                        h = c[e >> 2] | 0;
	                        i = d;
	                        return h | 0
	                    }
	                }
	                c[e >> 2] = -1;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function sP(a, d, e) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = c[h >> 2];
	                c[l >> 2] = c[g >> 2];
	                g = (c[l >> 2] | 0) + 50 | 0;
	                b[g >> 1] = b[g >> 1] | 256;
	                c[m >> 2] = Lj(c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                if ((c[m >> 2] | 0) >= 0) {
	                    i = f;
	                    return
	                }
	                c[n >> 2] = Rj(c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 28 >> 2] | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (c[n >> 2] | 0) {
	                    c[(c[l >> 2] | 0) + 44 >> 2] = c[(c[n >> 2] | 0) + 44 >> 2];
	                    c[(c[n >> 2] | 0) + 44 >> 2] = c[l >> 2];
	                    i = f;
	                    return
	                }
	                n = c[k >> 2] | 0;
	                if (c[(c[l >> 2] | 0) + 8 >> 2] | 0) {
	                    zN(n, 0, 1098, 192304, c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0);
	                    i = f;
	                    return
	                } else {
	                    zN(n, 0, 1098, 192336, 0, 0);
	                    i = f;
	                    return
	                }
	            }

	            function tP() {
	                return 0
	            }

	            function uP() {
	                var a = 0, b = 0, d = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                do if (!(c[49266] | 0)) {
	                    d = tx() | 0;
	                    c[49268] = d;
	                    if (!d) {
	                        c[b >> 2] = 0;
	                        break
	                    } else {
	                        vx(c[49268] | 0);
	                        c[49270] = jb(0) | 0;
	                        ET(197080) | 0;
	                        c[49266] = 1;
	                        wx(c[49268] | 0);
	                        c[b >> 2] = 1;
	                        break
	                    }
	                } else c[b >> 2] = 1; while (0);
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function vP() {
	                var a = 0, b = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a;
	                if (!(c[49266] | 0))uP() | 0;
	                vx(c[49268] | 0);
	                c[b >> 2] = ET(197080) | 0;
	                wx(c[49268] | 0);
	                i = a;
	                return c[b >> 2] | 0
	            }

	            function wP() {
	                var a = 0;
	                a = i;
	                if (!(c[49266] | 0)) {
	                    i = a;
	                    return
	                }
	                ux(c[49268] | 0);
	                c[49266] = 0;
	                i = a;
	                return
	            }

	            function xP() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                if ((c[49266] | 0) == 0 ? (uP() | 0) == 0 : 0) {
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                do if (c[d >> 2] | 0) {
	                    c[c[d >> 2] >> 2] = 1;
	                    c[(c[d >> 2] | 0) + 28 >> 2] = 0;
	                    c[(c[d >> 2] | 0) + 8 >> 2] = 128;
	                    c[(c[d >> 2] | 0) + 12 >> 2] = 0;
	                    f = Cb[c[135744 >> 2] & 511](2560) | 0;
	                    c[(c[d >> 2] | 0) + 4 >> 2] = f;
	                    c[(c[d >> 2] | 0) + 16 >> 2] = 0;
	                    c[(c[d >> 2] | 0) + 20 >> 2] = 0;
	                    if (!(c[(c[d >> 2] | 0) + 4 >> 2] | 0)) {
	                        zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                        break
	                    }
	                    cU(c[(c[d >> 2] | 0) + 4 >> 2] | 0, 0, 2560) | 0;
	                    f = vP() | 0;
	                    c[(c[d >> 2] | 0) + 24 >> 2] = f;
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } while (0);
	                c[b >> 2] = 0;
	                e = c[b >> 2] | 0;
	                i = a;
	                return e | 0
	            }

	            function yP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if ((c[49266] | 0) == 0 ? (uP() | 0) == 0 : 0)c[d >> 2] = -1; else f = 4;
	                do if ((f | 0) == 4)if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    break
	                } else {
	                    vx(c[49268] | 0);
	                    a = c[e >> 2] | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    wx(c[49268] | 0);
	                    c[d >> 2] = 0;
	                    break
	                } while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function zP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[d >> 2] = a;
	                c[h >> 2] = 0;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[49266] | 0) == 0 ? (uP() | 0) == 0 : 0) {
	                    i = b;
	                    return
	                }
	                vx(c[49268] | 0);
	                a = c[d >> 2] | 0;
	                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                a = (c[c[d >> 2] >> 2] | 0) > 0;
	                wx(c[49268] | 0);
	                if (a) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)zP(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0) {
	                    c[e >> 2] = 0;
	                    while (1) {
	                        if ((c[e >> 2] | 0) >>> 0 >= (c[(c[d >> 2] | 0) + 8 >> 2] | 0) >>> 0)break;
	                        if ((c[(c[d >> 2] | 0) + 12 >> 2] | 0) >>> 0 <= 0)break;
	                        c[f >> 2] = (c[(c[d >> 2] | 0) + 4 >> 2] | 0) + ((c[e >> 2] | 0) * 20 | 0);
	                        a:do if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                            c[h >> 2] = 1;
	                            while (1) {
	                                if (!(c[f >> 2] | 0))break a;
	                                c[g >> 2] = c[c[f >> 2] >> 2];
	                                if (!(c[h >> 2] | 0))zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                                a = (c[d >> 2] | 0) + 12 | 0;
	                                c[a >> 2] = (c[a >> 2] | 0) + -1;
	                                c[h >> 2] = 0;
	                                c[f >> 2] = c[g >> 2]
	                            }
	                        } while (0);
	                        c[e >> 2] = (c[e >> 2] | 0) + 1
	                    }
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 4 >> 2] | 0)
	                }
	                c[j >> 2] = c[(c[d >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    if (!(c[j >> 2] | 0))break;
	                    c[k >> 2] = c[c[j >> 2] >> 2];
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    c[j >> 2] = c[k >> 2]
	                }
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function AP(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 48 | 0;
	                g = e + 44 | 0;
	                h = e + 40 | 0;
	                j = e + 36 | 0;
	                k = e + 32 | 0;
	                l = e + 28 | 0;
	                m = e + 24 | 0;
	                n = e + 20 | 0;
	                o = e + 16 | 0;
	                p = e + 12 | 0;
	                q = e + 8 | 0;
	                r = e + 4 | 0;
	                s = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                if ((c[j >> 2] | 0) < 0)c[q >> 2] = ZT(c[h >> 2] | 0) | 0; else c[q >> 2] = c[j >> 2];
	                j = c[q >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 28 >> 2] | 0) >>> 0 > 0) {
	                    if ((c[q >> 2] | 0) >>> 0 > 1073741823 ? 1 : j >>> 0 >= (c[(c[g >> 2] | 0) + 28 >> 2] | 0) >>> 0)u = 9
	                } else if (j >>> 0 > 1073741823)u = 9;
	                if ((u | 0) == 9) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                j = c[h >> 2] | 0;
	                d = c[q >> 2] | 0;
	                b = c[(c[g >> 2] | 0) + 24 >> 2] | 0;
	                if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 128)v = EP(j, d, b) | 0; else v = FP(j, d, b) | 0;
	                c[l >> 2] = v;
	                c[k >> 2] = ((c[l >> 2] | 0) >>> 0) % ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0;
	                if (c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + ((c[k >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) {
	                    c[o >> 2] = (c[(c[g >> 2] | 0) + 4 >> 2] | 0) + ((c[k >> 2] | 0) * 20 | 0);
	                    while (1) {
	                        w = (c[(c[o >> 2] | 0) + 16 >> 2] | 0) == (c[l >> 2] | 0);
	                        if (!(c[c[o >> 2] >> 2] | 0))break;
	                        if ((w ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (OT(c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, c[q >> 2] | 0) | 0) == 0 : 0) {
	                            u = 20;
	                            break
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        c[o >> 2] = c[c[o >> 2] >> 2]
	                    }
	                    if ((u | 0) == 20) {
	                        c[f >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                    if ((w ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (OT(c[(c[o >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, c[q >> 2] | 0) | 0) == 0 : 0) {
	                        c[f >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                } else c[o >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 20 >> 2] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 128 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) != 128 : 0)u = 31; else u = 29;
	                    do if ((u | 0) == 29) {
	                        if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 128 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) == 128 : 0) {
	                            u = 31;
	                            break
	                        }
	                        c[r >> 2] = c[l >> 2]
	                    } while (0);
	                    if ((u | 0) == 31) {
	                        w = c[h >> 2] | 0;
	                        v = c[q >> 2] | 0;
	                        b = c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0;
	                        if ((c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) == 128)x = EP(w, v, b) | 0; else x = FP(w, v, b) | 0;
	                        c[r >> 2] = x
	                    }
	                    c[k >> 2] = ((c[r >> 2] | 0) >>> 0) % ((c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0;
	                    if (c[(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) + ((c[k >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) {
	                        c[s >> 2] = (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) + ((c[k >> 2] | 0) * 20 | 0);
	                        while (1) {
	                            y = (c[(c[s >> 2] | 0) + 16 >> 2] | 0) == (c[r >> 2] | 0);
	                            if (!(c[c[s >> 2] >> 2] | 0))break;
	                            if ((y ? (c[(c[s >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (OT(c[(c[s >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, c[q >> 2] | 0) | 0) == 0 : 0) {
	                                u = 42;
	                                break
	                            }
	                            c[m >> 2] = (c[m >> 2] | 0) + 1;
	                            c[s >> 2] = c[c[s >> 2] >> 2]
	                        }
	                        if ((u | 0) == 42) {
	                            c[f >> 2] = c[(c[s >> 2] | 0) + 4 >> 2];
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                        if ((y ? (c[(c[s >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (OT(c[(c[s >> 2] | 0) + 4 >> 2] | 0, c[h >> 2] | 0, c[q >> 2] | 0) | 0) == 0 : 0) {
	                            c[f >> 2] = c[(c[s >> 2] | 0) + 4 >> 2];
	                            t = c[f >> 2] | 0;
	                            i = e;
	                            return t | 0
	                        }
	                    }
	                    c[k >> 2] = ((c[l >> 2] | 0) >>> 0) % ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0
	                }
	                c[p >> 2] = GP(c[g >> 2] | 0, c[h >> 2] | 0, c[q >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                if (c[o >> 2] | 0) {
	                    c[n >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        t = c[f >> 2] | 0;
	                        i = e;
	                        return t | 0
	                    }
	                } else c[n >> 2] = (c[(c[g >> 2] | 0) + 4 >> 2] | 0) + ((c[k >> 2] | 0) * 20 | 0);
	                c[(c[n >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                c[(c[n >> 2] | 0) + 8 >> 2] = c[q >> 2];
	                c[c[n >> 2] >> 2] = 0;
	                c[(c[n >> 2] | 0) + 12 >> 2] = 1;
	                c[(c[n >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                if (c[o >> 2] | 0)c[c[o >> 2] >> 2] = c[n >> 2];
	                n = (c[g >> 2] | 0) + 12 | 0;
	                c[n >> 2] = (c[n >> 2] | 0) + 1;
	                if (((c[m >> 2] | 0) >>> 0 > 3 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 <= 2730 : 0) ? (HP(c[g >> 2] | 0, (c[(c[g >> 2] | 0) + 8 >> 2] | 0) * 6 | 0) | 0) != 0 : 0) {
	                    c[f >> 2] = 0;
	                    t = c[f >> 2] | 0;
	                    i = e;
	                    return t | 0
	                }
	                c[f >> 2] = c[p >> 2];
	                t = c[f >> 2] | 0;
	                i = e;
	                return t | 0
	            }

	            function BP(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                e = i;
	                i = i + 64 | 0;
	                f = e + 56 | 0;
	                g = e + 52 | 0;
	                h = e + 48 | 0;
	                j = e + 44 | 0;
	                k = e + 40 | 0;
	                l = e + 36 | 0;
	                m = e + 32 | 0;
	                n = e + 28 | 0;
	                o = e + 24 | 0;
	                p = e + 20 | 0;
	                q = e + 16 | 0;
	                r = e + 12 | 0;
	                s = e + 8 | 0;
	                t = e + 4 | 0;
	                u = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[m >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    v = c[f >> 2] | 0;
	                    i = e;
	                    return v | 0
	                }
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = AP(c[g >> 2] | 0, c[j >> 2] | 0, -1) | 0;
	                    v = c[f >> 2] | 0;
	                    i = e;
	                    return v | 0
	                }
	                d = ZT(c[j >> 2] | 0) | 0;
	                c[q >> 2] = d;
	                c[s >> 2] = d;
	                c[r >> 2] = ZT(c[h >> 2] | 0) | 0;
	                c[q >> 2] = (c[q >> 2] | 0) + (1 + (c[r >> 2] | 0));
	                d = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 128;
	                do if (!(c[h >> 2] | 0)) {
	                    b = c[j >> 2] | 0;
	                    a = c[s >> 2] | 0;
	                    w = c[(c[g >> 2] | 0) + 24 >> 2] | 0;
	                    if (d) {
	                        x = EP(b, a, w) | 0;
	                        break
	                    } else {
	                        x = FP(b, a, w) | 0;
	                        break
	                    }
	                } else {
	                    w = c[h >> 2] | 0;
	                    a = c[r >> 2] | 0;
	                    b = c[j >> 2] | 0;
	                    y = c[s >> 2] | 0;
	                    z = c[(c[g >> 2] | 0) + 24 >> 2] | 0;
	                    if (d) {
	                        x = IP(w, a, b, y, z) | 0;
	                        break
	                    } else {
	                        x = JP(w, a, b, y, z) | 0;
	                        break
	                    }
	                } while (0);
	                c[k >> 2] = x;
	                c[l >> 2] = ((c[k >> 2] | 0) >>> 0) % ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0;
	                if (c[(c[(c[g >> 2] | 0) + 4 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) {
	                    c[o >> 2] = (c[(c[g >> 2] | 0) + 4 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0);
	                    while (1) {
	                        A = (c[(c[o >> 2] | 0) + 16 >> 2] | 0) == (c[k >> 2] | 0);
	                        if (!(c[c[o >> 2] >> 2] | 0))break;
	                        if ((A ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (ry(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[o >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0) {
	                            B = 19;
	                            break
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + 1;
	                        c[o >> 2] = c[c[o >> 2] >> 2]
	                    }
	                    if ((B | 0) == 19) {
	                        c[f >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                        v = c[f >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    }
	                    if ((A ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (ry(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[o >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0) {
	                        c[f >> 2] = c[(c[o >> 2] | 0) + 4 >> 2];
	                        v = c[f >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    }
	                } else c[o >> 2] = 0;
	                if (c[(c[g >> 2] | 0) + 20 >> 2] | 0) {
	                    if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 128 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) != 128 : 0)B = 30; else B = 28;
	                    do if ((B | 0) == 28) {
	                        if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 128 ? (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) == 128 : 0) {
	                            B = 30;
	                            break
	                        }
	                        c[t >> 2] = c[k >> 2]
	                    } while (0);
	                    if ((B | 0) == 30) {
	                        A = (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) == 128;
	                        do if (!(c[h >> 2] | 0)) {
	                            x = c[j >> 2] | 0;
	                            d = c[s >> 2] | 0;
	                            z = c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0;
	                            if (A) {
	                                C = EP(x, d, z) | 0;
	                                break
	                            } else {
	                                C = FP(x, d, z) | 0;
	                                break
	                            }
	                        } else {
	                            z = c[h >> 2] | 0;
	                            d = c[r >> 2] | 0;
	                            x = c[j >> 2] | 0;
	                            y = c[s >> 2] | 0;
	                            b = c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 24 >> 2] | 0;
	                            if (A) {
	                                C = IP(z, d, x, y, b) | 0;
	                                break
	                            } else {
	                                C = JP(z, d, x, y, b) | 0;
	                                break
	                            }
	                        } while (0);
	                        c[t >> 2] = C
	                    }
	                    c[l >> 2] = ((c[t >> 2] | 0) >>> 0) % ((c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0;
	                    if (c[(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) {
	                        c[u >> 2] = (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 4 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0);
	                        while (1) {
	                            D = (c[(c[u >> 2] | 0) + 16 >> 2] | 0) == (c[t >> 2] | 0);
	                            if (!(c[c[u >> 2] >> 2] | 0))break;
	                            if ((D ? (c[(c[u >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (ry(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0) {
	                                B = 45;
	                                break
	                            }
	                            c[m >> 2] = (c[m >> 2] | 0) + 1;
	                            c[u >> 2] = c[c[u >> 2] >> 2]
	                        }
	                        if ((B | 0) == 45) {
	                            c[f >> 2] = c[(c[u >> 2] | 0) + 4 >> 2];
	                            v = c[f >> 2] | 0;
	                            i = e;
	                            return v | 0
	                        }
	                        if ((D ? (c[(c[u >> 2] | 0) + 8 >> 2] | 0) == (c[q >> 2] | 0) : 0) ? (ry(c[h >> 2] | 0, c[j >> 2] | 0, c[(c[u >> 2] | 0) + 4 >> 2] | 0) | 0) != 0 : 0) {
	                            c[f >> 2] = c[(c[u >> 2] | 0) + 4 >> 2];
	                            v = c[f >> 2] | 0;
	                            i = e;
	                            return v | 0
	                        }
	                    }
	                    c[l >> 2] = ((c[k >> 2] | 0) >>> 0) % ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0
	                }
	                c[p >> 2] = KP(c[g >> 2] | 0, c[h >> 2] | 0, c[r >> 2] | 0, c[j >> 2] | 0, c[s >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    v = c[f >> 2] | 0;
	                    i = e;
	                    return v | 0
	                }
	                if (c[o >> 2] | 0) {
	                    c[n >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                    if (!(c[n >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        v = c[f >> 2] | 0;
	                        i = e;
	                        return v | 0
	                    }
	                } else c[n >> 2] = (c[(c[g >> 2] | 0) + 4 >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0);
	                c[(c[n >> 2] | 0) + 4 >> 2] = c[p >> 2];
	                c[(c[n >> 2] | 0) + 8 >> 2] = c[q >> 2];
	                c[c[n >> 2] >> 2] = 0;
	                c[(c[n >> 2] | 0) + 12 >> 2] = 1;
	                c[(c[n >> 2] | 0) + 16 >> 2] = c[k >> 2];
	                if (c[o >> 2] | 0)c[c[o >> 2] >> 2] = c[n >> 2];
	                n = (c[g >> 2] | 0) + 12 | 0;
	                c[n >> 2] = (c[n >> 2] | 0) + 1;
	                if ((c[m >> 2] | 0) >>> 0 > 3 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) >>> 0 <= 2730 : 0)HP(c[g >> 2] | 0, (c[(c[g >> 2] | 0) + 8 >> 2] | 0) * 6 | 0) | 0;
	                c[f >> 2] = c[p >> 2];
	                v = c[f >> 2] | 0;
	                i = e;
	                return v | 0
	            }

	            function CP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    if (!(c[h >> 2] | 0))break;
	                    if ((c[g >> 2] | 0) >>> 0 >= ((c[h >> 2] | 0) + 20 | 0) >>> 0 ? (c[g >> 2] | 0) >>> 0 <= (c[(c[h >> 2] | 0) + 4 >> 2] | 0) >>> 0 : 0) {
	                        k = 7;
	                        break
	                    }
	                    c[h >> 2] = c[c[h >> 2] >> 2]
	                }
	                if ((k | 0) == 7) {
	                    c[e >> 2] = 1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                if (c[(c[f >> 2] | 0) + 20 >> 2] | 0) {
	                    c[e >> 2] = CP(c[(c[f >> 2] | 0) + 20 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function DP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    c[h >> 2] = c[(c[f >> 2] | 0) + 28 >> 2];
	                    c[(c[f >> 2] | 0) + 28 >> 2] = c[g >> 2];
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function EP(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 16 | 0;
	                h = f + 12 | 0;
	                j = f + 8 | 0;
	                k = f + 4 | 0;
	                l = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = c[k >> 2];
	                if (!(c[h >> 2] | 0)) {
	                    c[g >> 2] = 0;
	                    m = c[g >> 2] | 0;
	                    i = f;
	                    return m | 0
	                }
	                c[l >> 2] = d[c[h >> 2] >> 0];
	                c[l >> 2] = c[l >> 2] << 5;
	                if ((c[j >> 2] | 0) > 10) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + ((c[j >> 2] | 0) - 1) >> 0] | 0);
	                    c[j >> 2] = 10
	                }
	                switch (c[j >> 2] | 0) {
	                    case 7:
	                    {
	                        n = 9;
	                        break
	                    }
	                    case 6:
	                    {
	                        n = 10;
	                        break
	                    }
	                    case 9:
	                    {
	                        n = 7;
	                        break
	                    }
	                    case 3:
	                    {
	                        n = 13;
	                        break
	                    }
	                    case 8:
	                    {
	                        n = 8;
	                        break
	                    }
	                    case 10:
	                    {
	                        c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 9 >> 0] | 0);
	                        n = 7;
	                        break
	                    }
	                    case 2:
	                    {
	                        n = 14;
	                        break
	                    }
	                    case 4:
	                    {
	                        n = 12;
	                        break
	                    }
	                    case 5:
	                    {
	                        n = 11;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                if ((n | 0) == 7) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 8 >> 0] | 0);
	                    n = 8
	                }
	                if ((n | 0) == 8) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 7 >> 0] | 0);
	                    n = 9
	                }
	                if ((n | 0) == 9) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 6 >> 0] | 0);
	                    n = 10
	                }
	                if ((n | 0) == 10) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 5 >> 0] | 0);
	                    n = 11
	                }
	                if ((n | 0) == 11) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 4 >> 0] | 0);
	                    n = 12
	                }
	                if ((n | 0) == 12) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 3 >> 0] | 0);
	                    n = 13
	                }
	                if ((n | 0) == 13) {
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 2 >> 0] | 0);
	                    n = 14
	                }
	                if ((n | 0) == 14)c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + 1 >> 0] | 0);
	                c[g >> 2] = c[l >> 2];
	                m = c[g >> 2] | 0;
	                i = f;
	                return m | 0
	            }

	            function FP(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                if ((c[j >> 2] | 0) <= 0 | (c[h >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    n = c[g >> 2] | 0;
	                    i = f;
	                    return n | 0
	                }
	                c[l >> 2] = c[k >> 2];
	                c[m >> 2] = 0;
	                while (1) {
	                    if ((c[m >> 2] | 0) >= (c[j >> 2] | 0))break;
	                    c[l >> 2] = (c[l >> 2] | 0) + (d[(c[h >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0);
	                    c[l >> 2] = (c[l >> 2] | 0) + (c[l >> 2] << 10);
	                    c[l >> 2] = c[l >> 2] ^ (c[l >> 2] | 0) >>> 6;
	                    c[m >> 2] = (c[m >> 2] | 0) + 1
	                }
	                c[l >> 2] = (c[l >> 2] | 0) + (c[l >> 2] << 3);
	                c[l >> 2] = c[l >> 2] ^ (c[l >> 2] | 0) >>> 11;
	                c[l >> 2] = (c[l >> 2] | 0) + (c[l >> 2] << 15);
	                c[g >> 2] = c[l >> 2];
	                n = c[g >> 2] | 0;
	                i = f;
	                return n | 0
	            }

	            function GP(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[l >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                while (1) {
	                    p = c[l >> 2] | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        q = 7;
	                        break
	                    }
	                    if (((c[p + 8 >> 2] | 0) - (c[(c[l >> 2] | 0) + 4 >> 2] | 0) | 0) >>> 0 > (c[k >> 2] | 0) >>> 0)break;
	                    if ((c[(c[l >> 2] | 0) + 12 >> 2] | 0) >>> 0 > (c[n >> 2] | 0) >>> 0)c[n >> 2] = c[(c[l >> 2] | 0) + 12 >> 2];
	                    c[o >> 2] = (c[o >> 2] | 0) + (c[(c[l >> 2] | 0) + 12 >> 2] | 0);
	                    c[l >> 2] = c[c[l >> 2] >> 2]
	                }
	                do if ((q | 0) == 7 ? (p | 0) == 0 : 0) {
	                    if ((c[(c[h >> 2] | 0) + 28 >> 2] | 0) >>> 0 > 0 ? (c[o >> 2] | 0) >>> 0 > (c[(c[h >> 2] | 0) + 28 >> 2] | 0) >>> 0 : 0) {
	                        c[g >> 2] = 0;
	                        r = c[g >> 2] | 0;
	                        i = f;
	                        return r | 0
	                    }
	                    if (!(c[n >> 2] | 0))c[n >> 2] = 1e3; else c[n >> 2] = c[n >> 2] << 2;
	                    if ((c[n >> 2] | 0) >>> 0 < c[k >> 2] << 2 >>> 0)c[n >> 2] = c[k >> 2] << 2;
	                    c[l >> 2] = Cb[c[135744 >> 2] & 511](24 + (c[n >> 2] | 0) | 0) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[(c[l >> 2] | 0) + 12 >> 2] = c[n >> 2];
	                        c[(c[l >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[l >> 2] | 0) + 4 >> 2] = (c[l >> 2] | 0) + 20;
	                        c[(c[l >> 2] | 0) + 8 >> 2] = (c[l >> 2] | 0) + 20 + (c[n >> 2] | 0);
	                        c[c[l >> 2] >> 2] = c[(c[h >> 2] | 0) + 16 >> 2];
	                        c[(c[h >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                        break
	                    }
	                    c[g >> 2] = 0;
	                    r = c[g >> 2] | 0;
	                    i = f;
	                    return r | 0
	                } while (0);
	                c[m >> 2] = c[(c[l >> 2] | 0) + 4 >> 2];
	                eU(c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                j = (c[l >> 2] | 0) + 4 | 0;
	                c[j >> 2] = (c[j >> 2] | 0) + (c[k >> 2] | 0);
	                k = (c[l >> 2] | 0) + 4 | 0;
	                j = c[k >> 2] | 0;
	                c[k >> 2] = j + 1;
	                a[j >> 0] = 0;
	                j = (c[l >> 2] | 0) + 16 | 0;
	                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                c[g >> 2] = c[m >> 2];
	                r = c[g >> 2] | 0;
	                i = f;
	                return r | 0
	            }

	            function HP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 48 | 0;
	                f = d + 44 | 0;
	                g = d + 40 | 0;
	                h = d + 36 | 0;
	                j = d + 32 | 0;
	                k = d + 28 | 0;
	                l = d + 24 | 0;
	                m = d + 20 | 0;
	                n = d + 16 | 0;
	                o = d + 12 | 0;
	                p = d + 8 | 0;
	                q = d + 4 | 0;
	                r = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[p >> 2] = 0;
	                c[q >> 2] = 1;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                if ((c[g >> 2] | 0) >>> 0 < 8) {
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                if ((c[g >> 2] | 0) >>> 0 > 16384) {
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                c[k >> 2] = c[(c[f >> 2] | 0) + 8 >> 2];
	                c[o >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                if (!(c[o >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                if ((c[k >> 2] | 0) == 128)c[q >> 2] = 0;
	                b = Cb[c[135744 >> 2] & 511]((c[g >> 2] | 0) * 20 | 0) | 0;
	                c[(c[f >> 2] | 0) + 4 >> 2] = b;
	                if (!(c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[o >> 2];
	                    c[e >> 2] = -1;
	                    s = c[e >> 2] | 0;
	                    i = d;
	                    return s | 0
	                }
	                cU(c[(c[f >> 2] | 0) + 4 >> 2] | 0, 0, (c[g >> 2] | 0) * 20 | 0) | 0;
	                c[(c[f >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[k >> 2] | 0) >>> 0)break;
	                    do if (c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 12 >> 2] | 0) {
	                        if (c[q >> 2] | 0)c[j >> 2] = c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 16 >> 2]; else {
	                            g = c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 4 >> 2] | 0;
	                            b = c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 8 >> 2] | 0;
	                            a = c[(c[f >> 2] | 0) + 24 >> 2] | 0;
	                            if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 128)t = EP(g, b, a) | 0; else t = FP(g, b, a) | 0;
	                            c[j >> 2] = t
	                        }
	                        c[h >> 2] = ((c[j >> 2] | 0) >>> 0) % ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0;
	                        if (!(c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) + 12 >> 2] | 0)) {
	                            a = (c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) | 0;
	                            b = (c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) | 0;
	                            c[a + 0 >> 2] = c[b + 0 >> 2];
	                            c[a + 4 >> 2] = c[b + 4 >> 2];
	                            c[a + 8 >> 2] = c[b + 8 >> 2];
	                            c[a + 12 >> 2] = c[b + 12 >> 2];
	                            c[a + 16 >> 2] = c[b + 16 >> 2];
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) >> 2] = 0;
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) + 16 >> 2] = c[j >> 2];
	                            break
	                        }
	                        c[r >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                        if (c[r >> 2] | 0) {
	                            c[(c[r >> 2] | 0) + 4 >> 2] = c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 4 >> 2];
	                            c[(c[r >> 2] | 0) + 8 >> 2] = c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) + 8 >> 2];
	                            c[(c[r >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                            c[c[r >> 2] >> 2] = c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) >> 2];
	                            c[(c[r >> 2] | 0) + 12 >> 2] = 1;
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) >> 2] = c[r >> 2];
	                            break
	                        } else {
	                            c[p >> 2] = -1;
	                            break
	                        }
	                    } while (0);
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                c[l >> 2] = 0;
	                while (1) {
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[k >> 2] | 0) >>> 0)break;
	                    c[m >> 2] = c[(c[o >> 2] | 0) + ((c[l >> 2] | 0) * 20 | 0) >> 2];
	                    while (1) {
	                        if (!(c[m >> 2] | 0))break;
	                        c[n >> 2] = c[c[m >> 2] >> 2];
	                        if (c[q >> 2] | 0)c[j >> 2] = c[(c[m >> 2] | 0) + 16 >> 2]; else {
	                            r = c[(c[m >> 2] | 0) + 4 >> 2] | 0;
	                            t = c[(c[m >> 2] | 0) + 8 >> 2] | 0;
	                            b = c[(c[f >> 2] | 0) + 24 >> 2] | 0;
	                            if ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) == 128)u = EP(r, t, b) | 0; else u = FP(r, t, b) | 0;
	                            c[j >> 2] = u
	                        }
	                        c[h >> 2] = ((c[j >> 2] | 0) >>> 0) % ((c[(c[f >> 2] | 0) + 8 >> 2] | 0) >>> 0) | 0;
	                        b = (c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) | 0;
	                        if (!(c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) + 12 >> 2] | 0)) {
	                            t = c[m >> 2] | 0;
	                            c[b + 0 >> 2] = c[t + 0 >> 2];
	                            c[b + 4 >> 2] = c[t + 4 >> 2];
	                            c[b + 8 >> 2] = c[t + 8 >> 2];
	                            c[b + 12 >> 2] = c[t + 12 >> 2];
	                            c[b + 16 >> 2] = c[t + 16 >> 2];
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) >> 2] = 0;
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) + 12 >> 2] = 1;
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) + 16 >> 2] = c[j >> 2];
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                        } else {
	                            c[c[m >> 2] >> 2] = c[b >> 2];
	                            c[(c[m >> 2] | 0) + 16 >> 2] = c[j >> 2];
	                            c[(c[(c[f >> 2] | 0) + 4 >> 2] | 0) + ((c[h >> 2] | 0) * 20 | 0) >> 2] = c[m >> 2]
	                        }
	                        c[m >> 2] = c[n >> 2]
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                }
	                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                c[e >> 2] = c[p >> 2];
	                s = c[e >> 2] | 0;
	                i = d;
	                return s | 0
	            }

	            function IP(a, b, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 20 | 0;
	                k = h + 16 | 0;
	                l = h + 12 | 0;
	                m = h + 8 | 0;
	                n = h + 4 | 0;
	                o = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = c[n >> 2];
	                if (!(c[k >> 2] | 0))c[o >> 2] = (c[o >> 2] | 0) + 1740; else c[o >> 2] = (c[o >> 2] | 0) + ((d[c[j >> 2] >> 0] | 0) * 30 | 0);
	                if ((c[m >> 2] | 0) > 10 ? (c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + ((c[m >> 2] | 0) - ((c[k >> 2] | 0) + 2)) >> 0] | 0), c[m >> 2] = 10, (c[k >> 2] | 0) > 10) : 0)c[k >> 2] = 10;
	                switch (c[k >> 2] | 0) {
	                    case 9:
	                    {
	                        p = 9;
	                        break
	                    }
	                    case 10:
	                    {
	                        c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 9 >> 0] | 0);
	                        p = 9;
	                        break
	                    }
	                    case 5:
	                    {
	                        p = 13;
	                        break
	                    }
	                    case 1:
	                    {
	                        p = 17;
	                        break
	                    }
	                    case 2:
	                    {
	                        p = 16;
	                        break
	                    }
	                    case 8:
	                    {
	                        p = 10;
	                        break
	                    }
	                    case 4:
	                    {
	                        p = 14;
	                        break
	                    }
	                    case 3:
	                    {
	                        p = 15;
	                        break
	                    }
	                    case 7:
	                    {
	                        p = 11;
	                        break
	                    }
	                    case 6:
	                    {
	                        p = 12;
	                        break
	                    }
	                    default:
	                    {
	                    }
	                }
	                if ((p | 0) == 9) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 8 >> 0] | 0);
	                    p = 10
	                }
	                if ((p | 0) == 10) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 7 >> 0] | 0);
	                    p = 11
	                }
	                if ((p | 0) == 11) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 6 >> 0] | 0);
	                    p = 12
	                }
	                if ((p | 0) == 12) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 5 >> 0] | 0);
	                    p = 13
	                }
	                if ((p | 0) == 13) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 4 >> 0] | 0);
	                    p = 14
	                }
	                if ((p | 0) == 14) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 3 >> 0] | 0);
	                    p = 15
	                }
	                if ((p | 0) == 15) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 2 >> 0] | 0);
	                    p = 16
	                }
	                if ((p | 0) == 16) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + 1 >> 0] | 0);
	                    p = 17
	                }
	                if ((p | 0) == 17)c[o >> 2] = (c[o >> 2] | 0) + (d[c[j >> 2] >> 0] | 0);
	                c[m >> 2] = (c[m >> 2] | 0) - (c[k >> 2] | 0);
	                if ((c[m >> 2] | 0) > 0) {
	                    c[o >> 2] = (c[o >> 2] | 0) + 58;
	                    c[m >> 2] = (c[m >> 2] | 0) + -1
	                }
	                switch (c[m >> 2] | 0) {
	                    case 10:
	                    {
	                        c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 9 >> 0] | 0);
	                        p = 22;
	                        break
	                    }
	                    case 3:
	                    {
	                        p = 28;
	                        break
	                    }
	                    case 1:
	                        break;
	                    case 9:
	                    {
	                        p = 22;
	                        break
	                    }
	                    case 5:
	                    {
	                        p = 26;
	                        break
	                    }
	                    case 8:
	                    {
	                        p = 23;
	                        break
	                    }
	                    case 6:
	                    {
	                        p = 25;
	                        break
	                    }
	                    case 7:
	                    {
	                        p = 24;
	                        break
	                    }
	                    case 2:
	                    {
	                        p = 29;
	                        break
	                    }
	                    case 4:
	                    {
	                        p = 27;
	                        break
	                    }
	                    default:
	                    {
	                        q = c[o >> 2] | 0;
	                        i = h;
	                        return q | 0
	                    }
	                }
	                if ((p | 0) == 22) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 8 >> 0] | 0);
	                    p = 23
	                }
	                if ((p | 0) == 23) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 7 >> 0] | 0);
	                    p = 24
	                }
	                if ((p | 0) == 24) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 6 >> 0] | 0);
	                    p = 25
	                }
	                if ((p | 0) == 25) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 5 >> 0] | 0);
	                    p = 26
	                }
	                if ((p | 0) == 26) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 4 >> 0] | 0);
	                    p = 27
	                }
	                if ((p | 0) == 27) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 3 >> 0] | 0);
	                    p = 28
	                }
	                if ((p | 0) == 28) {
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 2 >> 0] | 0);
	                    p = 29
	                }
	                if ((p | 0) == 29)c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + 1 >> 0] | 0);
	                c[o >> 2] = (c[o >> 2] | 0) + (d[c[l >> 2] >> 0] | 0);
	                q = c[o >> 2] | 0;
	                i = h;
	                return q | 0
	            }

	            function JP(a, b, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                h = i;
	                i = i + 32 | 0;
	                j = h + 24 | 0;
	                k = h + 20 | 0;
	                l = h + 16 | 0;
	                m = h + 12 | 0;
	                n = h + 8 | 0;
	                o = h + 4 | 0;
	                p = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[o >> 2] = c[n >> 2];
	                c[p >> 2] = 0;
	                while (1) {
	                    if ((c[p >> 2] | 0) >= (c[k >> 2] | 0))break;
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[j >> 2] | 0) + (c[p >> 2] | 0) >> 0] | 0);
	                    c[o >> 2] = (c[o >> 2] | 0) + (c[o >> 2] << 10);
	                    c[o >> 2] = c[o >> 2] ^ (c[o >> 2] | 0) >>> 6;
	                    c[p >> 2] = (c[p >> 2] | 0) + 1
	                }
	                c[o >> 2] = (c[o >> 2] | 0) + 58;
	                c[o >> 2] = (c[o >> 2] | 0) + (c[o >> 2] << 10);
	                c[o >> 2] = c[o >> 2] ^ (c[o >> 2] | 0) >>> 6;
	                c[p >> 2] = 0;
	                while (1) {
	                    if ((c[p >> 2] | 0) >= (c[m >> 2] | 0))break;
	                    c[o >> 2] = (c[o >> 2] | 0) + (d[(c[l >> 2] | 0) + (c[p >> 2] | 0) >> 0] | 0);
	                    c[o >> 2] = (c[o >> 2] | 0) + (c[o >> 2] << 10);
	                    c[o >> 2] = c[o >> 2] ^ (c[o >> 2] | 0) >>> 6;
	                    c[p >> 2] = (c[p >> 2] | 0) + 1
	                }
	                c[o >> 2] = (c[o >> 2] | 0) + (c[o >> 2] << 3);
	                c[o >> 2] = c[o >> 2] ^ (c[o >> 2] | 0) >>> 11;
	                c[o >> 2] = (c[o >> 2] | 0) + (c[o >> 2] << 15);
	                i = h;
	                return c[o >> 2] | 0
	            }

	            function KP(b, d, e, f, g) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                g = c[k >> 2] | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[j >> 2] = GP(g, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[p >> 2] = c[g + 16 >> 2];
	                while (1) {
	                    u = c[p >> 2] | 0;
	                    if (!(c[p >> 2] | 0)) {
	                        v = 9;
	                        break
	                    }
	                    if (((c[u + 8 >> 2] | 0) - (c[(c[p >> 2] | 0) + 4 >> 2] | 0) | 0) >>> 0 > ((c[o >> 2] | 0) + (c[m >> 2] | 0) + 1 | 0) >>> 0)break;
	                    if ((c[(c[p >> 2] | 0) + 12 >> 2] | 0) >>> 0 > (c[r >> 2] | 0) >>> 0)c[r >> 2] = c[(c[p >> 2] | 0) + 12 >> 2];
	                    c[s >> 2] = (c[s >> 2] | 0) + (c[(c[p >> 2] | 0) + 12 >> 2] | 0);
	                    c[p >> 2] = c[c[p >> 2] >> 2]
	                }
	                do if ((v | 0) == 9 ? (u | 0) == 0 : 0) {
	                    if ((c[(c[k >> 2] | 0) + 28 >> 2] | 0) >>> 0 > 0 ? (c[s >> 2] | 0) >>> 0 > (c[(c[k >> 2] | 0) + 28 >> 2] | 0) >>> 0 : 0) {
	                        c[j >> 2] = 0;
	                        t = c[j >> 2] | 0;
	                        i = h;
	                        return t | 0
	                    }
	                    if (!(c[r >> 2] | 0))c[r >> 2] = 1e3; else c[r >> 2] = c[r >> 2] << 2;
	                    if ((c[r >> 2] | 0) >>> 0 < (c[o >> 2] | 0) + (c[m >> 2] | 0) + 1 << 2 >>> 0)c[r >> 2] = (c[o >> 2] | 0) + (c[m >> 2] | 0) + 1 << 2;
	                    c[p >> 2] = Cb[c[135744 >> 2] & 511](24 + (c[r >> 2] | 0) | 0) | 0;
	                    if (c[p >> 2] | 0) {
	                        c[(c[p >> 2] | 0) + 12 >> 2] = c[r >> 2];
	                        c[(c[p >> 2] | 0) + 16 >> 2] = 0;
	                        c[(c[p >> 2] | 0) + 4 >> 2] = (c[p >> 2] | 0) + 20;
	                        c[(c[p >> 2] | 0) + 8 >> 2] = (c[p >> 2] | 0) + 20 + (c[r >> 2] | 0);
	                        c[c[p >> 2] >> 2] = c[(c[k >> 2] | 0) + 16 >> 2];
	                        c[(c[k >> 2] | 0) + 16 >> 2] = c[p >> 2];
	                        break
	                    }
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                } while (0);
	                c[q >> 2] = c[(c[p >> 2] | 0) + 4 >> 2];
	                eU(c[(c[p >> 2] | 0) + 4 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                l = (c[p >> 2] | 0) + 4 | 0;
	                c[l >> 2] = (c[l >> 2] | 0) + (c[m >> 2] | 0);
	                m = (c[p >> 2] | 0) + 4 | 0;
	                l = c[m >> 2] | 0;
	                c[m >> 2] = l + 1;
	                a[l >> 0] = 58;
	                eU(c[(c[p >> 2] | 0) + 4 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                n = (c[p >> 2] | 0) + 4 | 0;
	                c[n >> 2] = (c[n >> 2] | 0) + (c[o >> 2] | 0);
	                o = (c[p >> 2] | 0) + 4 | 0;
	                n = c[o >> 2] | 0;
	                c[o >> 2] = n + 1;
	                a[n >> 0] = 0;
	                n = (c[p >> 2] | 0) + 16 | 0;
	                c[n >> 2] = (c[n >> 2] | 0) + 1;
	                c[j >> 2] = c[q >> 2];
	                t = c[j >> 2] | 0;
	                i = h;
	                return t | 0
	            }

	            function LP(a) {
	                a = a | 0;
	                var b = 0;
	                b = i;
	                i = i + 16 | 0;
	                c[b >> 2] = a;
	                i = b;
	                return 0
	            }

	            function MP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function NP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function OP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function PP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] | 0) == 1 & 1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function QP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 & 1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function RP(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[e >> 2];
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    c[d >> 2] = (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0) != 0 & 1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[d >> 2] = 0;
	                g = c[d >> 2] | 0;
	                i = b;
	                return g | 0
	            }

	            function SP(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[m >> 2] = Nh(c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                do if (c[m >> 2] | 0)if (c[(c[l >> 2] | 0) + 32 >> 2] | 0) {
	                    i = f;
	                    return
	                } else {
	                    Qh(c[m >> 2] | 0);
	                    Ph(c[m >> 2] | 0);
	                    c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] = 0;
	                    break
	                } while (0);
	                m = Oh(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] = m;
	                if (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                sQ(c[l >> 2] | 0, 197088);
	                i = f;
	                return
	            }

	            function TP(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 64 | 0;
	                g = f + 48 | 0;
	                h = f + 44 | 0;
	                j = f + 40 | 0;
	                k = f + 36 | 0;
	                l = f + 32 | 0;
	                m = f + 28 | 0;
	                n = f + 24 | 0;
	                o = f + 20 | 0;
	                p = f + 16 | 0;
	                q = f + 12 | 0;
	                r = f + 8 | 0;
	                s = f + 4 | 0;
	                t = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!((c[j >> 2] | 0) != 0 | (c[k >> 2] | 0) != 0)) {
	                    i = f;
	                    return
	                }
	                if ((c[(c[l >> 2] | 0) + 104 >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 276 >> 2] | 0) == 0 : 0) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[q >> 2] = 0;
	                if ((c[c[l >> 2] >> 2] | 0) != 0 ? (c[(c[c[l >> 2] >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)c[q >> 2] = vb[c[(c[c[l >> 2] >> 2] | 0) + 16 >> 2] & 511](c[(c[l >> 2] | 0) + 4 >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                Mh(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                c[m >> 2] = c[(c[l >> 2] | 0) + 36 >> 2];
	                c[n >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                c[o >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                c[p >> 2] = c[(c[l >> 2] | 0) + 48 >> 2];
	                c[s >> 2] = c[(c[l >> 2] | 0) + 256 >> 2];
	                c[t >> 2] = c[(c[l >> 2] | 0) + 24 >> 2];
	                c[(c[l >> 2] | 0) + 24 >> 2] = 0;
	                h = Cb[c[135744 >> 2] & 511](20) | 0;
	                c[(c[l >> 2] | 0) + 48 >> 2] = h;
	                h = c[l >> 2] | 0;
	                if (!(c[(c[l >> 2] | 0) + 48 >> 2] | 0)) {
	                    sQ(h, 197112);
	                    c[(c[l >> 2] | 0) + 36 >> 2] = c[m >> 2];
	                    c[(c[l >> 2] | 0) + 40 >> 2] = c[n >> 2];
	                    c[(c[l >> 2] | 0) + 44 >> 2] = c[o >> 2];
	                    c[(c[l >> 2] | 0) + 48 >> 2] = c[p >> 2];
	                    c[(c[l >> 2] | 0) + 256 >> 2] = c[s >> 2];
	                    c[(c[l >> 2] | 0) + 24 >> 2] = c[t >> 2];
	                    i = f;
	                    return
	                }
	                c[h + 40 >> 2] = 0;
	                c[(c[l >> 2] | 0) + 44 >> 2] = 5;
	                c[(c[l >> 2] | 0) + 36 >> 2] = 0;
	                Xe(c[l >> 2] | 0, c[q >> 2] | 0) | 0;
	                if ((c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 24 >> 2] | 0) >= 4) {
	                    c[r >> 2] = sd(c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0, 4) | 0;
	                    re(c[l >> 2] | 0, c[r >> 2] | 0) | 0
	                }
	                if (!(c[(c[q >> 2] | 0) + 4 >> 2] | 0)) {
	                    r = Jl(c[k >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 4 >> 2] = r
	                }
	                c[(c[q >> 2] | 0) + 28 >> 2] = 1;
	                c[(c[q >> 2] | 0) + 32 >> 2] = 1;
	                c[(c[q >> 2] | 0) + 12 >> 2] = c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[(c[q >> 2] | 0) + 16 >> 2] = c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2];
	                c[(c[q >> 2] | 0) + 40 >> 2] = 0;
	                Cf(c[l >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0);
	                while (1) {
	                    u = c[l >> 2] | 0;
	                    if ((c[(c[l >> 2] | 0) + 40 >> 2] | 0) <= 1)break;
	                    Ve(u) | 0
	                }
	                te(c[u + 36 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[(c[l >> 2] | 0) + 48 >> 2] | 0);
	                c[(c[l >> 2] | 0) + 36 >> 2] = c[m >> 2];
	                c[(c[l >> 2] | 0) + 40 >> 2] = c[n >> 2];
	                c[(c[l >> 2] | 0) + 44 >> 2] = c[o >> 2];
	                c[(c[l >> 2] | 0) + 48 >> 2] = c[p >> 2];
	                c[(c[l >> 2] | 0) + 256 >> 2] = c[s >> 2];
	                do if (c[(c[l >> 2] | 0) + 24 >> 2] | 0) {
	                    if ((c[(c[l >> 2] | 0) + 296 >> 2] | 0) != 0 ? (CP(c[(c[l >> 2] | 0) + 296 >> 2] | 0, c[(c[l >> 2] | 0) + 24 >> 2] | 0) | 0) != 0 : 0)break;
	                    zb[c[135736 >> 2] & 511](c[(c[l >> 2] | 0) + 24 >> 2] | 0)
	                } while (0);
	                c[(c[l >> 2] | 0) + 24 >> 2] = c[t >> 2];
	                i = f;
	                return
	            }

	            function UP(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = c[g >> 2];
	                c[n >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = e;
	                    return o | 0
	                }
	                if (c[(c[k >> 2] | 0) + 36 >> 2] | 0)c[n >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                if (!(c[n >> 2] | 0))c[n >> 2] = c[(c[k >> 2] | 0) + 180 >> 2];
	                c[m >> 2] = Hl(c[j >> 2] | 0, c[n >> 2] | 0) | 0;
	                c[l >> 2] = Vk(c[m >> 2] | 0, c[h >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (c[m >> 2] | 0)zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                c[f >> 2] = c[l >> 2];
	                o = c[f >> 2] | 0;
	                i = e;
	                return o | 0
	            }

	            function VP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 28 | 0;
	                f = d + 24 | 0;
	                g = d + 20 | 0;
	                h = d + 16 | 0;
	                j = d + 12 | 0;
	                k = d + 8 | 0;
	                l = d + 4 | 0;
	                m = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[f >> 2];
	                c[j >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                if ((c[(c[h >> 2] | 0) + 216 >> 2] | 0) == 0 ? (c[j >> 2] = Yc(c[g >> 2] | 0) | 0, (c[j >> 2] | 0) != 0) : 0) {
	                    c[e >> 2] = c[j >> 2];
	                    n = c[e >> 2] | 0;
	                    i = d;
	                    return n | 0
	                }
	                do if ((c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                    f = c[(c[h >> 2] | 0) + 8 >> 2] | 0;
	                    if ((c[(c[h >> 2] | 0) + 216 >> 2] | 0) == 2) {
	                        c[f + 40 >> 2] = 0;
	                        c[j >> 2] = ad(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] = 1;
	                        break
	                    }
	                    c[j >> 2] = ad(f, c[g >> 2] | 0) | 0;
	                    if (!(c[j >> 2] | 0)) {
	                        c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] = 0;
	                        c[j >> 2] = ad(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                        if (c[j >> 2] | 0)tQ(c[h >> 2] | 0, 103, 197136, c[g >> 2] | 0, 0);
	                        c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] = 1
	                    }
	                } else o = 14; while (0);
	                if ((o | 0) == 14)c[j >> 2] = ad(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                do if (c[j >> 2] | 0) {
	                    if ((c[(c[h >> 2] | 0) + 104 >> 2] | 0) == 0 ? (c[(c[h >> 2] | 0) + 16 >> 2] | 0) == 0 : 0)break;
	                    if ((c[(c[j >> 2] | 0) + 12 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 48 >> 2] | 0) == 2 : 0) {
	                        c[m >> 2] = c[(c[h >> 2] | 0) + 440 >> 2];
	                        c[k >> 2] = Xf(c[h >> 2] | 0, c[(c[j >> 2] | 0) + 64 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, l) | 0;
	                        if (c[k >> 2] | 0) {
	                            tQ(c[h >> 2] | 0, 104, 197208, c[g >> 2] | 0, 0);
	                            c[(c[h >> 2] | 0) + 104 >> 2] = 0;
	                            c[e >> 2] = 0;
	                            n = c[e >> 2] | 0;
	                            i = d;
	                            return n | 0
	                        }
	                        yi(c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                        c[(c[j >> 2] | 0) + 68 >> 2] = 1;
	                        if (((c[(c[j >> 2] | 0) + 72 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 72 >> 2] = (c[(c[h >> 2] | 0) + 440 >> 2] | 0) - (c[m >> 2] | 0) + 1 << 1, (c[(c[j >> 2] | 0) + 40 >> 2] | 0) != 0) : 0) ? (vy(c[(c[j >> 2] | 0) + 40 >> 2] | 0, 60) | 0) != 0 : 0) {
	                            o = (c[j >> 2] | 0) + 72 | 0;
	                            c[o >> 2] = c[o >> 2] | 1
	                        }
	                    }
	                } while (0);
	                c[e >> 2] = c[j >> 2];
	                n = c[e >> 2] | 0;
	                i = d;
	                return n | 0
	            }

	            function WP(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else {
	                    c[j >> 2] = $c(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    c[e >> 2] = c[j >> 2];
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function XP(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 64 | 0;
	                j = h;
	                k = h + 48 | 0;
	                l = h + 44 | 0;
	                m = h + 40 | 0;
	                n = h + 36 | 0;
	                o = h + 32 | 0;
	                p = h + 28 | 0;
	                q = h + 24 | 0;
	                r = h + 20 | 0;
	                s = h + 16 | 0;
	                t = h + 12 | 0;
	                u = h + 8 | 0;
	                v = h + 4 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[r >> 2] = c[k >> 2];
	                if (!(c[k >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                k = c[r >> 2] | 0;
	                if ((c[(c[r >> 2] | 0) + 216 >> 2] | 0) == 1) {
	                    c[q >> 2] = _c(c[k + 8 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                    if ((c[q >> 2] | 0) == 0 ? (c[(c[r >> 2] | 0) + 268 >> 2] | 0) != 0 : 0)uQ(c[r >> 2] | 0, 107, 197240, c[l >> 2] | 0);
	                    if (!(c[q >> 2] | 0)) {
	                        i = h;
	                        return
	                    }
	                    if (!((c[o >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 64 >> 2] | 0) == 0 : 0)) {
	                        i = h;
	                        return
	                    }
	                    c[t >> 2] = 0;
	                    if (c[(c[r >> 2] | 0) + 36 >> 2] | 0)c[t >> 2] = c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                    if (!(c[t >> 2] | 0))c[t >> 2] = c[(c[r >> 2] | 0) + 180 >> 2];
	                    c[s >> 2] = Hl(c[o >> 2] | 0, c[t >> 2] | 0) | 0;
	                    c[(c[q >> 2] | 0) + 64 >> 2] = c[s >> 2];
	                    i = h;
	                    return
	                }
	                s = c[r >> 2] | 0;
	                if ((c[k + 216 >> 2] | 0) != 2) {
	                    tQ(s, 104, 197352, c[l >> 2] | 0, 0);
	                    i = h;
	                    return
	                }
	                c[q >> 2] = Zc(c[s + 8 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0) | 0;
	                if ((((c[q >> 2] | 0) == 0 ? (c[(c[r >> 2] | 0) + 268 >> 2] | 0) != 0 : 0) ? (c[c[r >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[r >> 2] >> 2] | 0) + 84 >> 2] | 0) != 0 : 0) {
	                    p = c[(c[c[r >> 2] >> 2] | 0) + 84 >> 2] | 0;
	                    n = c[(c[r >> 2] | 0) + 4 >> 2] | 0;
	                    c[j >> 2] = c[l >> 2];
	                    Db[p & 511](n, 197296, j)
	                }
	                if (!(c[q >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                if (!((c[o >> 2] | 0) != 0 ? (c[(c[q >> 2] | 0) + 64 >> 2] | 0) == 0 : 0)) {
	                    i = h;
	                    return
	                }
	                c[v >> 2] = 0;
	                if (c[(c[r >> 2] | 0) + 36 >> 2] | 0)c[v >> 2] = c[(c[(c[r >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                if (!(c[v >> 2] | 0))c[v >> 2] = c[(c[r >> 2] | 0) + 180 >> 2];
	                c[u >> 2] = Hl(c[o >> 2] | 0, c[v >> 2] | 0) | 0;
	                c[(c[q >> 2] | 0) + 64 >> 2] = c[u >> 2];
	                i = h;
	                return
	            }

	            function YP(a, b, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                j = i;
	                i = i + 48 | 0;
	                k = j + 44 | 0;
	                l = j + 40 | 0;
	                m = j + 36 | 0;
	                n = j + 32 | 0;
	                o = j + 28 | 0;
	                p = j + 24 | 0;
	                q = j + 20 | 0;
	                r = j + 16 | 0;
	                s = j + 12 | 0;
	                t = j + 8 | 0;
	                u = j + 4 | 0;
	                v = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = h;
	                c[r >> 2] = c[k >> 2];
	                c[t >> 2] = 0;
	                c[u >> 2] = 0;
	                if (!(c[r >> 2] | 0)) {
	                    i = j;
	                    return
	                }
	                if (!(c[(c[r >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = j;
	                    return
	                }
	                k = (qy(c[m >> 2] | 0, 197408) | 0) != 0;
	                if (k & (c[n >> 2] | 0) != 2) {
	                    c[v >> 2] = c[(c[r >> 2] | 0) + 100 >> 2];
	                    vQ(c[r >> 2] | 0, 540, 197416, 0, 0);
	                    c[(c[r >> 2] | 0) + 100 >> 2] = c[v >> 2]
	                }
	                c[t >> 2] = bf(c[r >> 2] | 0, c[m >> 2] | 0, u) | 0;
	                c[(c[r >> 2] | 0) + 144 >> 2] = 1;
	                m = c[r >> 2] | 0;
	                do if ((c[(c[r >> 2] | 0) + 216 >> 2] | 0) == 1)c[s >> 2] = tm(m + 108 | 0, c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0, c[l >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0) | 0; else {
	                    v = c[r >> 2] | 0;
	                    if ((c[m + 216 >> 2] | 0) == 2) {
	                        c[s >> 2] = tm(v + 108 | 0, c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[l >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0) | 0;
	                        break
	                    }
	                    tQ(v, 1, 197456, c[t >> 2] | 0, 0);
	                    rm(c[q >> 2] | 0);
	                    i = j;
	                    return
	                } while (0);
	                if (!(c[(c[r >> 2] | 0) + 144 >> 2] | 0))c[(c[r >> 2] | 0) + 100 >> 2] = 0;
	                if ((((c[s >> 2] | 0) != 0 ? (c[(c[r >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[r >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[(c[r >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    q = Um((c[r >> 2] | 0) + 108 | 0, c[(c[r >> 2] | 0) + 8 >> 2] | 0, c[s >> 2] | 0) | 0;
	                    s = (c[r >> 2] | 0) + 100 | 0;
	                    c[s >> 2] = c[s >> 2] & q
	                }
	                if (c[u >> 2] | 0)zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                if (!(c[t >> 2] | 0)) {
	                    i = j;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[t >> 2] | 0);
	                i = j;
	                return
	            }

	            function ZP(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                c[m >> 2] = 0;
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                g = c[l >> 2] | 0;
	                do if ((c[(c[l >> 2] | 0) + 216 >> 2] | 0) == 1)c[m >> 2] = mm(g + 108 | 0, c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0; else {
	                    e = c[l >> 2] | 0;
	                    if ((c[g + 216 >> 2] | 0) == 2) {
	                        c[m >> 2] = mm(e + 108 | 0, c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    tQ(e, 1, 197520, c[h >> 2] | 0, 0);
	                    i = f;
	                    return
	                } while (0);
	                if (!(c[m >> 2] | 0))c[(c[l >> 2] | 0) + 100 >> 2] = 0;
	                if (!(c[(c[l >> 2] | 0) + 104 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                h = Vm((c[l >> 2] | 0) + 108 | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0;
	                m = (c[l >> 2] | 0) + 100 | 0;
	                c[m >> 2] = c[m >> 2] & h;
	                i = f;
	                return
	            }

	            function _P(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[l >> 2] = c[g >> 2];
	                c[m >> 2] = 0;
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                g = c[l >> 2] | 0;
	                if ((c[j >> 2] | 0) == 0 & (c[k >> 2] | 0) == 0) {
	                    tQ(g, 105, 197576, c[h >> 2] | 0, 0);
	                    i = f;
	                    return
	                }
	                e = c[l >> 2] | 0;
	                do if ((c[g + 216 >> 2] | 0) == 1)c[m >> 2] = xm(e + 108 | 0, c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0; else {
	                    d = c[l >> 2] | 0;
	                    if ((c[e + 216 >> 2] | 0) == 2) {
	                        c[m >> 2] = xm(d + 108 | 0, c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                        break
	                    }
	                    tQ(d, 105, 197640, c[h >> 2] | 0, 0);
	                    i = f;
	                    return
	                } while (0);
	                if (!(c[m >> 2] | 0))c[(c[l >> 2] | 0) + 100 >> 2] = 0;
	                if (!(c[(c[l >> 2] | 0) + 104 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 12 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                h = Rm((c[l >> 2] | 0) + 108 | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0;
	                m = (c[l >> 2] | 0) + 100 | 0;
	                c[m >> 2] = c[m >> 2] & h;
	                i = f;
	                return
	            }

	            function $P(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g;
	                j = g + 44 | 0;
	                k = g + 40 | 0;
	                l = g + 36 | 0;
	                m = g + 32 | 0;
	                n = g + 28 | 0;
	                o = g + 24 | 0;
	                p = g + 20 | 0;
	                q = g + 16 | 0;
	                r = g + 12 | 0;
	                s = g + 8 | 0;
	                t = g + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[p >> 2] = c[j >> 2];
	                if (!(c[j >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                j = c[p >> 2] | 0;
	                if ((c[(c[p >> 2] | 0) + 216 >> 2] | 0) == 1) {
	                    c[o >> 2] = _c(c[j + 8 >> 2] | 0, c[k >> 2] | 0, 3, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if ((((c[o >> 2] | 0) == 0 ? (c[(c[p >> 2] | 0) + 268 >> 2] | 0) != 0 : 0) ? (c[c[p >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[p >> 2] >> 2] | 0) + 84 >> 2] | 0) != 0 : 0) {
	                        f = c[(c[c[p >> 2] >> 2] | 0) + 84 >> 2] | 0;
	                        e = c[(c[p >> 2] | 0) + 4 >> 2] | 0;
	                        c[h >> 2] = c[k >> 2];
	                        Db[f & 511](e, 197240, h)
	                    }
	                    if (!(c[o >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    if (!((c[m >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 64 >> 2] | 0) == 0 : 0)) {
	                        i = g;
	                        return
	                    }
	                    c[r >> 2] = 0;
	                    if (c[(c[p >> 2] | 0) + 36 >> 2] | 0)c[r >> 2] = c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                    if (!(c[r >> 2] | 0))c[r >> 2] = c[(c[p >> 2] | 0) + 180 >> 2];
	                    c[q >> 2] = Hl(c[m >> 2] | 0, c[r >> 2] | 0) | 0;
	                    c[(c[o >> 2] | 0) + 64 >> 2] = c[q >> 2];
	                    i = g;
	                    return
	                }
	                q = c[p >> 2] | 0;
	                if ((c[j + 216 >> 2] | 0) != 2) {
	                    tQ(q, 1, 197696, c[k >> 2] | 0, 0);
	                    i = g;
	                    return
	                }
	                c[o >> 2] = Zc(c[q + 8 >> 2] | 0, c[k >> 2] | 0, 3, c[l >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                if ((((c[o >> 2] | 0) == 0 ? (c[(c[p >> 2] | 0) + 268 >> 2] | 0) != 0 : 0) ? (c[c[p >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[p >> 2] >> 2] | 0) + 84 >> 2] | 0) != 0 : 0) {
	                    n = c[(c[c[p >> 2] >> 2] | 0) + 84 >> 2] | 0;
	                    l = c[(c[p >> 2] | 0) + 4 >> 2] | 0;
	                    c[h >> 2] = c[k >> 2];
	                    Db[n & 511](l, 197296, h)
	                }
	                if (!(c[o >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if (!((c[m >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 64 >> 2] | 0) == 0 : 0)) {
	                    i = g;
	                    return
	                }
	                c[t >> 2] = 0;
	                if (c[(c[p >> 2] | 0) + 36 >> 2] | 0)c[t >> 2] = c[(c[(c[p >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2];
	                if (!(c[t >> 2] | 0))c[t >> 2] = c[(c[p >> 2] | 0) + 180 >> 2];
	                c[s >> 2] = Hl(c[m >> 2] | 0, c[t >> 2] | 0) | 0;
	                c[(c[o >> 2] | 0) + 64 >> 2] = c[s >> 2];
	                i = g;
	                return
	            }

	            function aQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0;
	                d = i;
	                i = i + 16 | 0;
	                c[d + 4 >> 2] = a;
	                c[d >> 2] = b;
	                i = d;
	                return
	            }

	            function bQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[d >> 2];
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                d = c[e >> 2] | 0;
	                do if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                    a = Sh(c[d + 20 >> 2] | 0) | 0;
	                    c[(c[e >> 2] | 0) + 8 >> 2] = a;
	                    c[f >> 2] = a;
	                    if (!(c[f >> 2] | 0)) {
	                        sQ(c[e >> 2] | 0, 197760);
	                        i = b;
	                        return
	                    }
	                    c[(c[f >> 2] | 0) + 92 >> 2] = 0;
	                    if (c[(c[e >> 2] | 0) + 360 >> 2] & 131072) {
	                        a = (c[f >> 2] | 0) + 92 | 0;
	                        c[a >> 2] = c[a >> 2] | 4
	                    }
	                    c[(c[f >> 2] | 0) + 88 >> 2] = c[(c[e >> 2] | 0) + 360 >> 2];
	                    if (c[(c[e >> 2] | 0) + 24 >> 2] | 0) {
	                        a = my(c[(c[e >> 2] | 0) + 24 >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 60 >> 2] = a
	                    } else c[(c[f >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 40 >> 2] = c[(c[e >> 2] | 0) + 28 >> 2];
	                    if ((c[f >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 364 >> 2] | 0) != 0 : 0) {
	                        c[(c[f >> 2] | 0) + 80 >> 2] = c[(c[e >> 2] | 0) + 296 >> 2];
	                        yP(c[(c[f >> 2] | 0) + 80 >> 2] | 0) | 0
	                    }
	                } else {
	                    if (!(c[d + 8 >> 2] | 0)) {
	                        a = go(0, 0) | 0;
	                        c[(c[e >> 2] | 0) + 8 >> 2] = a
	                    }
	                    a = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        c[(c[a + 8 >> 2] | 0) + 92 >> 2] = 128;
	                        c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 88 >> 2] = c[(c[e >> 2] | 0) + 360 >> 2];
	                        break
	                    }
	                    sQ(a, 197760);
	                    i = b;
	                    return
	                } while (0);
	                if (!(c[(c[e >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 36 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                d = Kl(c[(c[(c[e >> 2] | 0) + 36 >> 2] | 0) + 4 >> 2] | 0) | 0;
	                c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] = d;
	                if (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 72 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                sQ(c[e >> 2] | 0, 197760);
	                i = b;
	                return
	            }

	            function cQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[d >> 2];
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((((c[(c[e >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    d = cn((c[e >> 2] | 0) + 108 | 0, c[(c[e >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    a = (c[e >> 2] | 0) + 100 | 0;
	                    c[a >> 2] = c[a >> 2] & d
	                }
	                if (((c[(c[e >> 2] | 0) + 24 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 60 >> 2] | 0) == 0 : 0) {
	                    c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 60 >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                    c[(c[e >> 2] | 0) + 24 >> 2] = 0
	                }
	                if ((((((c[(c[e >> 2] | 0) + 48 >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) > 0 : 0) ? (c[c[(c[e >> 2] | 0) + 48 >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[(c[e >> 2] | 0) + 48 >> 2] >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) ? (c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 60 >> 2] | 0) == 0 : 0) {
	                    d = my(c[(c[c[(c[e >> 2] | 0) + 48 >> 2] >> 2] | 0) + 44 >> 2] | 0) | 0;
	                    c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 60 >> 2] = d
	                }
	                if (!(c[(c[e >> 2] | 0) + 256 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 76 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                c[(c[(c[e >> 2] | 0) + 8 >> 2] | 0) + 76 >> 2] = c[(c[e >> 2] | 0) + 256 >> 2];
	                i = b;
	                return
	            }

	            function dQ(a, e, f) {
	                a = a | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 48 | 0;
	                j = g + 44 | 0;
	                k = g + 40 | 0;
	                l = g + 36 | 0;
	                m = g + 32 | 0;
	                n = g + 28 | 0;
	                o = g + 24 | 0;
	                p = g + 20 | 0;
	                q = g + 16 | 0;
	                r = g + 12 | 0;
	                s = g + 8 | 0;
	                t = g + 4 | 0;
	                u = g;
	                c[h >> 2] = a;
	                c[j >> 2] = e;
	                c[k >> 2] = f;
	                c[l >> 2] = c[h >> 2];
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    i = g;
	                    return
	                }
	                if (!(c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[n >> 2] = c[(c[l >> 2] | 0) + 52 >> 2];
	                do if ((c[(c[l >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    if (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) {
	                        if (c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 36 >> 2] | 0)break;
	                        if (c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 40 >> 2] | 0)break;
	                        if (c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 44 >> 2] | 0)break;
	                        if (c[(c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] | 0)break
	                    }
	                    vQ(c[l >> 2] | 0, 94, 197784, 0, 0);
	                    c[(c[l >> 2] | 0) + 104 >> 2] = 0
	                } while (0);
	                c[p >> 2] = bf(c[l >> 2] | 0, c[j >> 2] | 0, q) | 0;
	                c[m >> 2] = ki(c[(c[l >> 2] | 0) + 8 >> 2] | 0, 0, c[p >> 2] | 0, 0) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                    sQ(c[l >> 2] | 0, 197824);
	                    i = g;
	                    return
	                }
	                if (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2] | 0) {
	                    if (!(c[n >> 2] | 0))c[n >> 2] = c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 12 >> 2]
	                } else zi(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0) | 0;
	                c[(c[l >> 2] | 0) + 264 >> 2] = -1;
	                do if ((c[(c[l >> 2] | 0) + 280 >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)if ((c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0) < 65535) {
	                    b[(c[m >> 2] | 0) + 56 >> 1] = c[(c[(c[l >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    break
	                } else {
	                    b[(c[m >> 2] | 0) + 56 >> 1] = -1;
	                    break
	                } while (0);
	                Qe(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                do if (c[n >> 2] | 0) {
	                    j = c[n >> 2] | 0;
	                    h = c[m >> 2] | 0;
	                    if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        zi(j, h) | 0;
	                        break
	                    } else {
	                        xi(j, h) | 0;
	                        break
	                    }
	                } while (0);
	                do if (!(c[(c[l >> 2] | 0) + 32 >> 2] | 0)) {
	                    if ((c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) == 0 ? (c[(c[(c[l >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0) == 0 : 0)break;
	                    wQ(c[l >> 2] | 0, c[p >> 2] | 0, c[q >> 2] | 0, c[k >> 2] | 0)
	                } while (0);
	                if ((c[k >> 2] | 0) != 0 ? (c[t >> 2] = 0, p = c[t >> 2] | 0, c[t >> 2] = p + 1, c[r >> 2] = c[(c[k >> 2] | 0) + (p << 2) >> 2], p = c[t >> 2] | 0, c[t >> 2] = p + 1, c[s >> 2] = c[(c[k >> 2] | 0) + (p << 2) >> 2], ((c[r >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) & (c[s >> 2] | 0) != 0) : 0)do {
	                    if (((((d[c[r >> 2] >> 0] | 0 | 0) == 120 ? (d[(c[r >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[r >> 2] | 0) + 2 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[r >> 2] | 0) + 3 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[r >> 2] | 0) + 4 >> 0] | 0 | 0) == 115 : 0)xQ(c[l >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, c[q >> 2] | 0);
	                    p = c[t >> 2] | 0;
	                    c[t >> 2] = p + 1;
	                    c[r >> 2] = c[(c[k >> 2] | 0) + (p << 2) >> 2];
	                    p = c[t >> 2] | 0;
	                    c[t >> 2] = p + 1;
	                    c[s >> 2] = c[(c[k >> 2] | 0) + (p << 2) >> 2]
	                } while ((c[r >> 2] | 0) != 0 & (c[s >> 2] | 0) != 0);
	                c[o >> 2] = cj(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[m >> 2] | 0, c[q >> 2] | 0) | 0;
	                if ((c[o >> 2] | 0) == 0 & (c[n >> 2] | 0) != 0)c[o >> 2] = cj(c[(c[l >> 2] | 0) + 8 >> 2] | 0, c[n >> 2] | 0, c[q >> 2] | 0) | 0;
	                if ((c[q >> 2] | 0) != 0 & (c[o >> 2] | 0) == 0) {
	                    c[o >> 2] = Ih(c[m >> 2] | 0, 0, c[q >> 2] | 0) | 0;
	                    yQ(c[l >> 2] | 0, 201, 197848, c[q >> 2] | 0, 0)
	                }
	                do if ((c[o >> 2] | 0) != 0 ? (c[(c[o >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if ((d[c[(c[o >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) == 0 ? (c[(c[o >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)break;
	                    Kh(c[m >> 2] | 0, c[o >> 2] | 0)
	                } while (0);
	                a:do if (c[k >> 2] | 0) {
	                    c[t >> 2] = 0;
	                    o = c[t >> 2] | 0;
	                    c[t >> 2] = o + 1;
	                    c[r >> 2] = c[(c[k >> 2] | 0) + (o << 2) >> 2];
	                    o = c[t >> 2] | 0;
	                    c[t >> 2] = o + 1;
	                    c[s >> 2] = c[(c[k >> 2] | 0) + (o << 2) >> 2];
	                    if (c[(c[l >> 2] | 0) + 32 >> 2] | 0)while (1) {
	                        if (!(c[r >> 2] | 0))break a;
	                        xQ(c[l >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, 0);
	                        o = c[t >> 2] | 0;
	                        c[t >> 2] = o + 1;
	                        c[r >> 2] = c[(c[k >> 2] | 0) + (o << 2) >> 2];
	                        o = c[t >> 2] | 0;
	                        c[t >> 2] = o + 1;
	                        c[s >> 2] = c[(c[k >> 2] | 0) + (o << 2) >> 2]
	                    }
	                    while (1) {
	                        if (!((c[r >> 2] | 0) != 0 & (c[s >> 2] | 0) != 0))break a;
	                        do if ((d[c[r >> 2] >> 0] | 0 | 0) == 120 ? (d[(c[r >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) {
	                            if ((d[(c[r >> 2] | 0) + 2 >> 0] | 0 | 0) != 108) {
	                                v = 60;
	                                break
	                            }
	                            if ((d[(c[r >> 2] | 0) + 3 >> 0] | 0 | 0) != 110) {
	                                v = 60;
	                                break
	                            }
	                            if ((d[(c[r >> 2] | 0) + 4 >> 0] | 0 | 0) != 115)v = 60
	                        } else v = 60; while (0);
	                        if ((v | 0) == 60) {
	                            v = 0;
	                            xQ(c[l >> 2] | 0, c[r >> 2] | 0, c[s >> 2] | 0, 0)
	                        }
	                        o = c[t >> 2] | 0;
	                        c[t >> 2] = o + 1;
	                        c[r >> 2] = c[(c[k >> 2] | 0) + (o << 2) >> 2];
	                        o = c[t >> 2] | 0;
	                        c[t >> 2] = o + 1;
	                        c[s >> 2] = c[(c[k >> 2] | 0) + (o << 2) >> 2]
	                    }
	                } while (0);
	                if ((c[(c[l >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 136 >> 2] | 0) == -1412623820 : 0) {
	                    c[u >> 2] = en((c[l >> 2] | 0) + 108 | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if ((c[u >> 2] | 0) <= 0)c[(c[l >> 2] | 0) + 100 >> 2] = 0;
	                    if ((c[u >> 2] | 0) < 0)c[(c[l >> 2] | 0) + 12 >> 2] = 0;
	                    u = an((c[l >> 2] | 0) + 108 | 0, c[(c[l >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    k = (c[l >> 2] | 0) + 100 | 0;
	                    c[k >> 2] = c[k >> 2] & u;
	                    c[(c[l >> 2] | 0) + 136 >> 2] = -1412623819
	                }
	                if (!(c[q >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                i = g;
	                return
	            }

	            function eQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[d + 8 >> 2] = b;
	                c[f >> 2] = c[e >> 2];
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 68 >> 2] | 0) != 0 : 0) {
	                    c[(c[(c[f >> 2] | 0) + 448 >> 2] | 0) + 12 >> 2] = (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                    c[(c[(c[f >> 2] | 0) + 448 >> 2] | 0) + 16 >> 2] = c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[c[(c[f >> 2] | 0) + 448 >> 2] >> 2] = c[g >> 2];
	                    De(c[f >> 2] | 0, c[(c[f >> 2] | 0) + 448 >> 2] | 0)
	                }
	                c[(c[f >> 2] | 0) + 264 >> 2] = -1;
	                if ((((c[(c[f >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[f >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[f >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[f >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    e = $m((c[f >> 2] | 0) + 108 | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                    g = (c[f >> 2] | 0) + 100 | 0;
	                    c[g >> 2] = c[g >> 2] & e
	                }
	                Re(c[f >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function fQ(a, d, e, f, g, h, j, k, l) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0;
	                m = i;
	                i = i + 96 | 0;
	                n = m + 84 | 0;
	                o = m + 80 | 0;
	                p = m + 76 | 0;
	                q = m + 72 | 0;
	                r = m + 68 | 0;
	                s = m + 64 | 0;
	                t = m + 60 | 0;
	                u = m + 56 | 0;
	                v = m + 52 | 0;
	                w = m + 48 | 0;
	                x = m + 44 | 0;
	                y = m + 40 | 0;
	                z = m + 36 | 0;
	                A = m + 32 | 0;
	                B = m + 28 | 0;
	                C = m + 24 | 0;
	                D = m + 20 | 0;
	                E = m + 16 | 0;
	                F = m + 12 | 0;
	                G = m + 8 | 0;
	                H = m + 4 | 0;
	                I = m;
	                c[n >> 2] = a;
	                c[o >> 2] = d;
	                c[p >> 2] = e;
	                c[q >> 2] = f;
	                c[r >> 2] = g;
	                c[s >> 2] = h;
	                c[t >> 2] = j;
	                c[u >> 2] = k;
	                c[v >> 2] = l;
	                c[w >> 2] = c[n >> 2];
	                c[z >> 2] = 0;
	                c[D >> 2] = 0;
	                if (!(c[n >> 2] | 0)) {
	                    i = m;
	                    return
	                }
	                c[y >> 2] = c[(c[w >> 2] | 0) + 52 >> 2];
	                do if ((c[(c[w >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0) == 0 : 0) {
	                    if (c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) {
	                        if (c[(c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 36 >> 2] | 0)break;
	                        if (c[(c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 40 >> 2] | 0)break;
	                        if (c[(c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 44 >> 2] | 0)break;
	                        if (c[(c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) + 48 >> 2] | 0)break
	                    }
	                    vQ(c[w >> 2] | 0, 522, 197784, 0, 0);
	                    c[(c[w >> 2] | 0) + 104 >> 2] = 0
	                } while (0);
	                do if ((c[p >> 2] | 0) != 0 & (c[q >> 2] | 0) == 0) {
	                    if (!(c[(c[w >> 2] | 0) + 364 >> 2] | 0)) {
	                        c[D >> 2] = Bh(c[o >> 2] | 0, c[p >> 2] | 0, 0, 0) | 0;
	                        break
	                    }
	                    c[G >> 2] = BP(c[(c[w >> 2] | 0) + 296 >> 2] | 0, c[p >> 2] | 0, c[o >> 2] | 0) | 0;
	                    if (c[G >> 2] | 0)c[o >> 2] = c[G >> 2]
	                } while (0);
	                G = c[w >> 2] | 0;
	                if (c[(c[w >> 2] | 0) + 372 >> 2] | 0) {
	                    c[x >> 2] = c[G + 372 >> 2];
	                    c[(c[w >> 2] | 0) + 372 >> 2] = c[(c[x >> 2] | 0) + 24 >> 2];
	                    n = (c[w >> 2] | 0) + 368 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + -1;
	                    n = (c[x >> 2] | 0) + 0 | 0;
	                    l = n + 60 | 0;
	                    do {
	                        c[n >> 2] = 0;
	                        n = n + 4 | 0
	                    } while ((n | 0) < (l | 0));
	                    c[(c[x >> 2] | 0) + 4 >> 2] = 1;
	                    if (!(c[(c[w >> 2] | 0) + 364 >> 2] | 0)) {
	                        if (!(c[D >> 2] | 0)) {
	                            n = my(c[o >> 2] | 0) | 0;
	                            c[(c[x >> 2] | 0) + 8 >> 2] = n
	                        } else c[(c[x >> 2] | 0) + 8 >> 2] = c[D >> 2];
	                        if (!(c[(c[x >> 2] | 0) + 8 >> 2] | 0)) {
	                            sQ(c[w >> 2] | 0, 197888);
	                            i = m;
	                            return
	                        }
	                    } else c[(c[x >> 2] | 0) + 8 >> 2] = c[o >> 2];
	                    if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[x >> 2] | 0)
	                } else {
	                    do if (!(c[G + 364 >> 2] | 0)) {
	                        n = c[(c[w >> 2] | 0) + 8 >> 2] | 0;
	                        if (!(c[D >> 2] | 0)) {
	                            c[x >> 2] = ji(n, 0, c[o >> 2] | 0, 0) | 0;
	                            break
	                        } else {
	                            c[x >> 2] = ki(n, 0, c[D >> 2] | 0, 0) | 0;
	                            break
	                        }
	                    } else c[x >> 2] = ki(c[(c[w >> 2] | 0) + 8 >> 2] | 0, 0, c[o >> 2] | 0, 0) | 0; while (0);
	                    if (!(c[x >> 2] | 0)) {
	                        sQ(c[w >> 2] | 0, 197888);
	                        i = m;
	                        return
	                    }
	                }
	                do if ((c[(c[w >> 2] | 0) + 280 >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)if ((c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0) < 65535) {
	                    b[(c[x >> 2] | 0) + 56 >> 1] = c[(c[(c[w >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    break
	                } else {
	                    b[(c[x >> 2] | 0) + 56 >> 1] = -1;
	                    break
	                } while (0);
	                if (!(c[y >> 2] | 0))zi(c[(c[w >> 2] | 0) + 8 >> 2] | 0, c[x >> 2] | 0) | 0;
	                c[E >> 2] = 0;
	                c[F >> 2] = 0;
	                while (1) {
	                    if ((c[F >> 2] | 0) >= (c[r >> 2] | 0))break;
	                    o = c[E >> 2] | 0;
	                    c[E >> 2] = o + 1;
	                    c[C >> 2] = c[(c[s >> 2] | 0) + (o << 2) >> 2];
	                    o = c[E >> 2] | 0;
	                    c[E >> 2] = o + 1;
	                    c[B >> 2] = c[(c[s >> 2] | 0) + (o << 2) >> 2];
	                    c[A >> 2] = Ih(0, c[B >> 2] | 0, c[C >> 2] | 0) | 0;
	                    if (c[A >> 2] | 0) {
	                        o = c[A >> 2] | 0;
	                        if (!(c[z >> 2] | 0)) {
	                            c[z >> 2] = o;
	                            c[(c[x >> 2] | 0) + 48 >> 2] = o
	                        } else {
	                            c[c[z >> 2] >> 2] = o;
	                            c[z >> 2] = c[A >> 2]
	                        }
	                        if ((c[q >> 2] | 0) != 0 ? (c[p >> 2] | 0) == (c[C >> 2] | 0) : 0)c[(c[x >> 2] | 0) + 36 >> 2] = c[A >> 2];
	                        if (((((c[(c[w >> 2] | 0) + 32 >> 2] | 0) == 0 ? (c[(c[w >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[w >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[w >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[w >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                            o = Xm((c[w >> 2] | 0) + 108 | 0, c[(c[w >> 2] | 0) + 8 >> 2] | 0, c[x >> 2] | 0, c[p >> 2] | 0, c[A >> 2] | 0, c[B >> 2] | 0) | 0;
	                            G = (c[w >> 2] | 0) + 100 | 0;
	                            c[G >> 2] = c[G >> 2] & o
	                        }
	                    }
	                    c[F >> 2] = (c[F >> 2] | 0) + 1
	                }
	                c[(c[w >> 2] | 0) + 264 >> 2] = -1;
	                Qe(c[w >> 2] | 0, c[x >> 2] | 0) | 0;
	                do if (c[y >> 2] | 0) {
	                    B = c[y >> 2] | 0;
	                    C = c[x >> 2] | 0;
	                    if ((c[(c[y >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        zi(B, C) | 0;
	                        break
	                    } else {
	                        xi(B, C) | 0;
	                        break
	                    }
	                } while (0);
	                if ((c[u >> 2] | 0) != 0 ? (c[(c[w >> 2] | 0) + 276 >> 2] & 4 | 0) == 0 : 0)c[t >> 2] = (c[t >> 2] | 0) - (c[u >> 2] | 0);
	                do if ((c[q >> 2] | 0) != 0 ? (c[(c[x >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) {
	                    u = cj(c[(c[w >> 2] | 0) + 8 >> 2] | 0, c[y >> 2] | 0, c[p >> 2] | 0) | 0;
	                    c[(c[x >> 2] | 0) + 36 >> 2] = u;
	                    if ((c[(c[x >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[p >> 2] | 0, 197912) | 0) != 0 : 0) {
	                        u = cj(c[(c[w >> 2] | 0) + 8 >> 2] | 0, c[x >> 2] | 0, c[p >> 2] | 0) | 0;
	                        c[(c[x >> 2] | 0) + 36 >> 2] = u
	                    }
	                    if (!(c[(c[x >> 2] | 0) + 36 >> 2] | 0)) {
	                        c[A >> 2] = Ih(c[x >> 2] | 0, 0, c[p >> 2] | 0) | 0;
	                        if (!(c[A >> 2] | 0)) {
	                            sQ(c[w >> 2] | 0, 197888);
	                            i = m;
	                            return
	                        }
	                        u = c[w >> 2] | 0;
	                        if (c[p >> 2] | 0) {
	                            yQ(u, 201, 197920, c[p >> 2] | 0, 0);
	                            break
	                        } else {
	                            yQ(u, 201, 197960, 0, 0);
	                            break
	                        }
	                    }
	                } while (0);
	                a:do if ((c[t >> 2] | 0) > 0) {
	                    c[F >> 2] = 0;
	                    c[E >> 2] = 0;
	                    while (1) {
	                        if ((c[E >> 2] | 0) >= (c[t >> 2] | 0))break a;
	                        do if ((c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 1 << 2) >> 2] | 0) != 0 ? (c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 2 << 2) >> 2] | 0) == 0 : 0)if (c[(c[w >> 2] | 0) + 364 >> 2] | 0) {
	                            c[H >> 2] = BP(c[(c[w >> 2] | 0) + 296 >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 1 << 2) >> 2] | 0, c[(c[v >> 2] | 0) + (c[F >> 2] << 2) >> 2] | 0) | 0;
	                            if (!(c[H >> 2] | 0)) {
	                                J = 83;
	                                break
	                            }
	                            zQ(c[w >> 2] | 0, c[H >> 2] | 0, 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 3 << 2) >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 4 << 2) >> 2] | 0);
	                            break
	                        } else {
	                            c[D >> 2] = Bh(c[(c[v >> 2] | 0) + (c[F >> 2] << 2) >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 1 << 2) >> 2] | 0, 0, 0) | 0;
	                            if (!(c[D >> 2] | 0)) {
	                                J = 83;
	                                break
	                            }
	                            zQ(c[w >> 2] | 0, c[D >> 2] | 0, 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 3 << 2) >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 4 << 2) >> 2] | 0);
	                            zb[c[135736 >> 2] & 511](c[D >> 2] | 0);
	                            break
	                        } else J = 83; while (0);
	                        if ((J | 0) == 83) {
	                            J = 0;
	                            zQ(c[w >> 2] | 0, c[(c[v >> 2] | 0) + (c[F >> 2] << 2) >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 1 << 2) >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 3 << 2) >> 2] | 0, c[(c[v >> 2] | 0) + ((c[F >> 2] | 0) + 4 << 2) >> 2] | 0)
	                        }
	                        c[E >> 2] = (c[E >> 2] | 0) + 1;
	                        c[F >> 2] = (c[F >> 2] | 0) + 5
	                    }
	                } while (0);
	                if (!(c[(c[w >> 2] | 0) + 104 >> 2] | 0)) {
	                    i = m;
	                    return
	                }
	                if ((c[(c[w >> 2] | 0) + 136 >> 2] | 0) != -1412623820) {
	                    i = m;
	                    return
	                }
	                c[I >> 2] = en((c[w >> 2] | 0) + 108 | 0, c[(c[w >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if ((c[I >> 2] | 0) <= 0)c[(c[w >> 2] | 0) + 100 >> 2] = 0;
	                if ((c[I >> 2] | 0) < 0)c[(c[w >> 2] | 0) + 12 >> 2] = 0;
	                I = an((c[w >> 2] | 0) + 108 | 0, c[(c[w >> 2] | 0) + 8 >> 2] | 0) | 0;
	                F = (c[w >> 2] | 0) + 100 | 0;
	                c[F >> 2] = c[F >> 2] & I;
	                c[(c[w >> 2] | 0) + 136 >> 2] = -1412623819;
	                i = m;
	                return
	            }

	            function gQ(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 40 | 0;
	                h = f + 24 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[f + 36 >> 2] = b;
	                c[f + 32 >> 2] = d;
	                c[f + 28 >> 2] = e;
	                c[h >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                if ((c[k >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 68 >> 2] | 0) != 0 : 0) {
	                    c[j + 12 >> 2] = (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) - (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0);
	                    c[j + 16 >> 2] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    c[j >> 2] = c[k >> 2];
	                    De(c[h >> 2] | 0, j)
	                }
	                c[(c[h >> 2] | 0) + 264 >> 2] = -1;
	                if ((((c[(c[h >> 2] | 0) + 104 >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    j = $m((c[h >> 2] | 0) + 108 | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[k >> 2] | 0) | 0;
	                    k = (c[h >> 2] | 0) + 100 | 0;
	                    c[k >> 2] = c[k >> 2] & j
	                }
	                Re(c[h >> 2] | 0) | 0;
	                i = f;
	                return
	            }

	            function hQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                f = c[(c[h >> 2] | 0) + 8 >> 2] | 0;
	                b = c[g >> 2] | 0;
	                if ((d[c[g >> 2] >> 0] | 0 | 0) == 35)c[j >> 2] = mi(f, b) | 0; else c[j >> 2] = Yh(f, b) | 0;
	                if (zi(c[(c[h >> 2] | 0) + 52 >> 2] | 0, c[j >> 2] | 0) | 0) {
	                    i = e;
	                    return
	                }
	                Rh(c[j >> 2] | 0);
	                i = e;
	                return
	            }

	            function iQ(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 28 | 0;
	                h = f + 24 | 0;
	                j = f + 20 | 0;
	                k = f + 16 | 0;
	                l = f + 12 | 0;
	                m = f + 8 | 0;
	                n = f + 4 | 0;
	                o = f;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                if (!(c[(c[k >> 2] | 0) + 52 >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[l >> 2] = c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 16 >> 2];
	                if (!(c[l >> 2] | 0)) {
	                    c[l >> 2] = AQ(c[k >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 12 >> 2] = c[l >> 2];
	                        c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                        c[(c[l >> 2] | 0) + 20 >> 2] = c[(c[k >> 2] | 0) + 52 >> 2];
	                        c[(c[l >> 2] | 0) + 32 >> 2] = c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 32 >> 2];
	                        c[(c[k >> 2] | 0) + 260 >> 2] = c[j >> 2];
	                        c[(c[k >> 2] | 0) + 264 >> 2] = (c[j >> 2] | 0) + 1;
	                        i = f;
	                        return
	                    } else {
	                        sQ(c[k >> 2] | 0, 198e3);
	                        i = f;
	                        return
	                    }
	                }
	                if ((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 3 : 0)p = (c[(c[l >> 2] | 0) + 8 >> 2] | 0) == 75104; else p = 0;
	                c[m >> 2] = p & 1;
	                if ((c[m >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 264 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[l >> 2] | 0) + 40 >> 2] | 0) != ((c[l >> 2] | 0) + 44 | 0)) {
	                        if ((c[(c[k >> 2] | 0) + 264 >> 2] | 0) == ((c[(c[k >> 2] | 0) + 260 >> 2] | 0) + 1 | 0) ? (CP(c[(c[k >> 2] | 0) + 296 >> 2] | 0, c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0) != 0 : 0) {
	                            p = my(c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            c[(c[l >> 2] | 0) + 40 >> 2] = p
	                        }
	                    } else {
	                        p = my(c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        c[(c[l >> 2] | 0) + 40 >> 2] = p;
	                        c[(c[l >> 2] | 0) + 44 >> 2] = 0
	                    }
	                    p = c[k >> 2] | 0;
	                    if (!(c[(c[l >> 2] | 0) + 40 >> 2] | 0)) {
	                        sQ(p, 198024);
	                        i = f;
	                        return
	                    }
	                    if (((c[p + 260 >> 2] | 0) + (c[j >> 2] | 0) | 0) >>> 0 > 1e7 ? (c[(c[k >> 2] | 0) + 360 >> 2] & 524288 | 0) == 0 : 0) {
	                        sQ(c[k >> 2] | 0, 198072);
	                        i = f;
	                        return
	                    }
	                    if ((c[(c[k >> 2] | 0) + 260 >> 2] | 0) >>> 0 <= (-1 - (c[j >> 2] | 0) | 0) >>> 0 ? ((c[(c[k >> 2] | 0) + 264 >> 2] | 0) + (c[j >> 2] | 0) | 0) >>> 0 <= 2147483647 : 0) {
	                        do if (((c[(c[k >> 2] | 0) + 260 >> 2] | 0) + (c[j >> 2] | 0) | 0) >= (c[(c[k >> 2] | 0) + 264 >> 2] | 0)) {
	                            c[o >> 2] = (c[(c[k >> 2] | 0) + 264 >> 2] | 0) + (c[j >> 2] | 0);
	                            c[o >> 2] = c[o >> 2] << 1;
	                            c[n >> 2] = Hb[c[135760 >> 2] & 511](c[(c[l >> 2] | 0) + 40 >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (c[n >> 2] | 0) {
	                                c[(c[k >> 2] | 0) + 264 >> 2] = c[o >> 2];
	                                c[(c[l >> 2] | 0) + 40 >> 2] = c[n >> 2];
	                                break
	                            }
	                            sQ(c[k >> 2] | 0, 198e3);
	                            i = f;
	                            return
	                        } while (0);
	                        eU((c[(c[l >> 2] | 0) + 40 >> 2] | 0) + (c[(c[k >> 2] | 0) + 260 >> 2] | 0) | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                        n = (c[k >> 2] | 0) + 260 | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + (c[j >> 2] | 0);
	                        a[(c[(c[l >> 2] | 0) + 40 >> 2] | 0) + (c[(c[k >> 2] | 0) + 260 >> 2] | 0) >> 0] = 0;
	                        i = f;
	                        return
	                    }
	                    sQ(c[k >> 2] | 0, 198112);
	                    i = f;
	                    return
	                }
	                if (c[m >> 2] | 0) {
	                    if (jj(c[l >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0)sQ(c[k >> 2] | 0, 198e3);
	                    if (!(c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 12 >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    m = xy(c[(c[l >> 2] | 0) + 40 >> 2] | 0) | 0;
	                    c[(c[k >> 2] | 0) + 260 >> 2] = m;
	                    c[(c[k >> 2] | 0) + 264 >> 2] = (c[(c[k >> 2] | 0) + 260 >> 2] | 0) + 1;
	                    i = f;
	                    return
	                } else {
	                    c[l >> 2] = AQ(c[k >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    if (!(c[l >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    zi(c[(c[k >> 2] | 0) + 52 >> 2] | 0, c[l >> 2] | 0) | 0;
	                    if (!(c[(c[(c[k >> 2] | 0) + 52 >> 2] | 0) + 12 >> 2] | 0)) {
	                        i = f;
	                        return
	                    }
	                    c[(c[k >> 2] | 0) + 260 >> 2] = c[j >> 2];
	                    c[(c[k >> 2] | 0) + 264 >> 2] = (c[j >> 2] | 0) + 1;
	                    i = f;
	                    return
	                }
	            }

	            function jQ(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0;
	                e = i;
	                i = i + 16 | 0;
	                c[e + 8 >> 2] = a;
	                c[e + 4 >> 2] = b;
	                c[e >> 2] = d;
	                i = e;
	                return
	            }

	            function kQ(a, d, e) {
	                a = a | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[g >> 2] = a;
	                c[h >> 2] = d;
	                c[j >> 2] = e;
	                c[k >> 2] = c[g >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                c[m >> 2] = c[(c[k >> 2] | 0) + 52 >> 2];
	                c[l >> 2] = gi(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    i = f;
	                    return
	                }
	                do if ((c[(c[k >> 2] | 0) + 280 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)if ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0) < 65535) {
	                    b[(c[l >> 2] | 0) + 56 >> 1] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    break
	                } else {
	                    b[(c[l >> 2] | 0) + 56 >> 1] = -1;
	                    break
	                } while (0);
	                j = c[k >> 2] | 0;
	                if ((c[(c[k >> 2] | 0) + 216 >> 2] | 0) == 1) {
	                    zi(c[(c[j + 8 >> 2] | 0) + 44 >> 2] | 0, c[l >> 2] | 0) | 0;
	                    i = f;
	                    return
	                }
	                if ((c[j + 216 >> 2] | 0) == 2) {
	                    zi(c[(c[(c[k >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[l >> 2] | 0) | 0;
	                    i = f;
	                    return
	                }
	                if (!(c[m >> 2] | 0)) {
	                    zi(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0;
	                    i = f;
	                    return
	                }
	                k = c[m >> 2] | 0;
	                j = c[l >> 2] | 0;
	                if ((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    zi(k, j) | 0;
	                    i = f;
	                    return
	                } else {
	                    xi(k, j) | 0;
	                    i = f;
	                    return
	                }
	            }

	            function lQ(a, d) {
	                a = a | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[f >> 2] = a;
	                c[g >> 2] = d;
	                c[h >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[k >> 2] = c[(c[h >> 2] | 0) + 52 >> 2];
	                c[j >> 2] = qi(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                do if ((c[(c[h >> 2] | 0) + 280 >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 36 >> 2] | 0) != 0 : 0)if ((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0) < 65535) {
	                    b[(c[j >> 2] | 0) + 56 >> 1] = c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                    break
	                } else {
	                    b[(c[j >> 2] | 0) + 56 >> 1] = -1;
	                    break
	                } while (0);
	                g = c[h >> 2] | 0;
	                if ((c[(c[h >> 2] | 0) + 216 >> 2] | 0) == 1) {
	                    zi(c[(c[g + 8 >> 2] | 0) + 44 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                if ((c[g + 216 >> 2] | 0) == 2) {
	                    zi(c[(c[(c[h >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                if (!(c[k >> 2] | 0)) {
	                    zi(c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[j >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                h = c[k >> 2] | 0;
	                g = c[j >> 2] | 0;
	                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    zi(h, g) | 0;
	                    i = e;
	                    return
	                } else {
	                    xi(h, g) | 0;
	                    i = e;
	                    return
	                }
	            }

	            function mQ(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = c[f >> 2];
	                if (!(c[f >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[l >> 2] = Bi(c[(c[j >> 2] | 0) + 52 >> 2] | 0) | 0;
	                if ((c[l >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 4 : 0) {
	                    jj(c[l >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                c[k >> 2] = pi(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0) | 0;
	                zi(c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[k >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function nQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = c[49538];
	                if ((c[e >> 2] | 0) != 1 & (c[e >> 2] | 0) != 2) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[49538] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function oQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                }
	                do if ((c[g >> 2] | 0) == 2) {
	                    c[(c[f >> 2] | 0) + 56 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 60 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 116 >> 2] = 387;
	                    c[(c[f >> 2] | 0) + 120 >> 2] = 388;
	                    c[(c[f >> 2] | 0) + 124 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 108 >> 2] = -554844497
	                } else {
	                    if ((c[g >> 2] | 0) == 1) {
	                        c[(c[f >> 2] | 0) + 56 >> 2] = 50;
	                        c[(c[f >> 2] | 0) + 60 >> 2] = 51;
	                        c[(c[f >> 2] | 0) + 108 >> 2] = 1;
	                        break
	                    }
	                    c[e >> 2] = -1;
	                    h = c[e >> 2] | 0;
	                    i = d;
	                    return h | 0
	                } while (0);
	                c[c[f >> 2] >> 2] = 36;
	                c[(c[f >> 2] | 0) + 104 >> 2] = 60;
	                c[(c[f >> 2] | 0) + 4 >> 2] = 37;
	                c[(c[f >> 2] | 0) + 8 >> 2] = 38;
	                c[(c[f >> 2] | 0) + 12 >> 2] = 39;
	                c[(c[f >> 2] | 0) + 16 >> 2] = 40;
	                c[(c[f >> 2] | 0) + 20 >> 2] = 41;
	                c[(c[f >> 2] | 0) + 96 >> 2] = 58;
	                c[(c[f >> 2] | 0) + 24 >> 2] = 42;
	                c[(c[f >> 2] | 0) + 32 >> 2] = 44;
	                c[(c[f >> 2] | 0) + 36 >> 2] = 45;
	                c[(c[f >> 2] | 0) + 28 >> 2] = 43;
	                c[(c[f >> 2] | 0) + 40 >> 2] = 46;
	                c[(c[f >> 2] | 0) + 44 >> 2] = 47;
	                c[(c[f >> 2] | 0) + 48 >> 2] = 48;
	                c[(c[f >> 2] | 0) + 52 >> 2] = 49;
	                c[(c[f >> 2] | 0) + 64 >> 2] = 52;
	                c[(c[f >> 2] | 0) + 68 >> 2] = 53;
	                c[(c[f >> 2] | 0) + 100 >> 2] = 59;
	                c[(c[f >> 2] | 0) + 72 >> 2] = 53;
	                c[(c[f >> 2] | 0) + 76 >> 2] = 54;
	                c[(c[f >> 2] | 0) + 80 >> 2] = 55;
	                c[(c[f >> 2] | 0) + 84 >> 2] = 56;
	                c[(c[f >> 2] | 0) + 88 >> 2] = 57;
	                c[(c[f >> 2] | 0) + 92 >> 2] = 57;
	                c[e >> 2] = 0;
	                h = c[e >> 2] | 0;
	                i = d;
	                return h | 0
	            }

	            function pQ() {
	                var a = 0;
	                a = i;
	                oQ(135968, 1) | 0;
	                i = a;
	                return
	            }

	            function qQ(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 108 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                c[c[d >> 2] >> 2] = 36;
	                c[(c[d >> 2] | 0) + 104 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 4 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 8 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 16 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 20 >> 2] = 41;
	                c[(c[d >> 2] | 0) + 96 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 24 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 32 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 36 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 44 >> 2] = 47;
	                c[(c[d >> 2] | 0) + 48 >> 2] = 48;
	                c[(c[d >> 2] | 0) + 52 >> 2] = 49;
	                c[(c[d >> 2] | 0) + 56 >> 2] = 50;
	                c[(c[d >> 2] | 0) + 60 >> 2] = 51;
	                c[(c[d >> 2] | 0) + 64 >> 2] = 0;
	                c[(c[d >> 2] | 0) + 68 >> 2] = 53;
	                c[(c[d >> 2] | 0) + 100 >> 2] = 59;
	                c[(c[d >> 2] | 0) + 72 >> 2] = 65;
	                c[(c[d >> 2] | 0) + 76 >> 2] = 54;
	                c[(c[d >> 2] | 0) + 80 >> 2] = 55;
	                c[(c[d >> 2] | 0) + 84 >> 2] = 56;
	                c[(c[d >> 2] | 0) + 88 >> 2] = 57;
	                c[(c[d >> 2] | 0) + 92 >> 2] = 57;
	                c[(c[d >> 2] | 0) + 108 >> 2] = 1;
	                i = b;
	                return
	            }

	            function rQ() {
	                var a = 0;
	                a = i;
	                qQ(136096);
	                i = a;
	                return
	            }

	            function sQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 20 | 0;
	                g = d + 16 | 0;
	                h = d + 12 | 0;
	                j = d + 8 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 198680;
	                if (!(c[f >> 2] | 0)) {
	                    b = c[h >> 2] | 0;
	                    a = c[f >> 2] | 0;
	                    k = c[j >> 2] | 0;
	                    l = c[g >> 2] | 0;
	                    c[e >> 2] = c[j >> 2];
	                    c[e + 4 >> 2] = 0;
	                    Xd(b, 0, 0, a, 0, 1, 2, 2, 0, 0, k, 0, 0, 0, 0, l, e);
	                    i = d;
	                    return
	                }
	                c[(c[f >> 2] | 0) + 84 >> 2] = 2;
	                if ((c[c[f >> 2] >> 2] | 0) != 0 ? (c[(c[c[f >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497 : 0)c[h >> 2] = c[(c[c[f >> 2] >> 2] | 0) + 124 >> 2];
	                l = c[h >> 2] | 0;
	                h = c[(c[f >> 2] | 0) + 112 >> 2] | 0;
	                k = c[(c[f >> 2] | 0) + 108 >> 2] | 0;
	                a = c[f >> 2] | 0;
	                b = c[j >> 2] | 0;
	                m = c[g >> 2] | 0;
	                c[e >> 2] = c[j >> 2];
	                c[e + 4 >> 2] = 0;
	                Xd(l, h, k, a, 0, 1, 2, 2, 0, 0, b, 0, 0, 0, 0, m, e);
	                c[(c[f >> 2] | 0) + 84 >> 2] = 2;
	                c[(c[f >> 2] | 0) + 172 >> 2] = -1;
	                c[(c[f >> 2] | 0) + 212 >> 2] = 1;
	                i = d;
	                return
	            }

	            function tQ(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                f = c[j >> 2] | 0;
	                e = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                d = c[n >> 2] | 0;
	                b = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(0, 0, 0, f, 0, 1, e, 3, 0, 0, k, d, 0, 0, 0, b, h);
	                if (!(c[j >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                c[(c[j >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[j >> 2] | 0) + 100 >> 2] = 0;
	                if (c[(c[j >> 2] | 0) + 288 >> 2] | 0) {
	                    i = g;
	                    return
	                }
	                c[(c[j >> 2] | 0) + 212 >> 2] = 1;
	                i = g;
	                return
	            }

	            function uQ(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if (((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[h >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = f;
	                    return
	                }
	                if (c[h >> 2] | 0)c[(c[h >> 2] | 0) + 84 >> 2] = c[j >> 2];
	                e = c[h >> 2] | 0;
	                h = c[j >> 2] | 0;
	                j = c[l >> 2] | 0;
	                d = c[k >> 2] | 0;
	                c[g >> 2] = c[l >> 2];
	                Xd(0, 0, 0, e, 0, 1, h, 1, 0, 0, j, 0, 0, 0, 0, d, g);
	                i = f;
	                return
	            }

	            function vQ(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = 0;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (!(c[j >> 2] | 0)) {
	                    f = c[o >> 2] | 0;
	                    e = c[j >> 2] | 0;
	                    d = c[k >> 2] | 0;
	                    b = c[m >> 2] | 0;
	                    a = c[n >> 2] | 0;
	                    p = c[l >> 2] | 0;
	                    q = c[n >> 2] | 0;
	                    c[h >> 2] = c[m >> 2];
	                    c[h + 4 >> 2] = q;
	                    Xd(f, 0, 0, e, 0, 4, d, 2, 0, 0, b, a, 0, 0, 0, p, h);
	                    i = g;
	                    return
	                }
	                c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                if ((c[c[j >> 2] >> 2] | 0) != 0 ? (c[(c[c[j >> 2] >> 2] | 0) + 108 >> 2] | 0) == -554844497 : 0)c[o >> 2] = c[(c[c[j >> 2] >> 2] | 0) + 124 >> 2];
	                p = c[o >> 2] | 0;
	                o = c[(c[j >> 2] | 0) + 112 >> 2] | 0;
	                a = c[(c[j >> 2] | 0) + 108 >> 2] | 0;
	                b = c[j >> 2] | 0;
	                d = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                e = c[n >> 2] | 0;
	                f = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(p, o, a, b, 0, 4, d, 2, 0, 0, k, e, 0, 0, 0, f, h);
	                c[(c[j >> 2] | 0) + 100 >> 2] = 0;
	                i = g;
	                return
	            }

	            function wQ(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                f = i;
	                i = i + 112 | 0;
	                g = f + 44 | 0;
	                h = f + 40 | 0;
	                j = f + 36 | 0;
	                k = f + 32 | 0;
	                l = f + 28 | 0;
	                m = f + 24 | 0;
	                n = f + 20 | 0;
	                o = f + 16 | 0;
	                p = f + 12 | 0;
	                q = f + 8 | 0;
	                r = f + 4 | 0;
	                s = f + 48 | 0;
	                t = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                c[n >> 2] = 1;
	                c[l >> 2] = Mm(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[l >> 2] = Mm(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[n >> 2] = 0
	                }
	                a:while (1) {
	                    if (!(c[l >> 2] | 0)) {
	                        u = 48;
	                        break
	                    }
	                    c[p >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                    b:do if (((c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 40 >> 2] | 0) == 1 ? (c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0) != 0 : 0) ? ((c[p >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) : 0) {
	                        while (1) {
	                            if (((c[(c[p >> 2] | 0) + 48 >> 2] | 0) != 0 ? (e = Nm(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[(c[p >> 2] | 0) + 60 >> 2] | 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 56 >> 2] | 0) | 0, (e | 0) == (c[p >> 2] | 0)) : 0) ? (Nm(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0, c[(c[p >> 2] | 0) + 60 >> 2] | 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 56 >> 2] | 0) | 0) == 0 : 0) {
	                                e = c[p >> 2] | 0;
	                                if (c[(c[p >> 2] | 0) + 56 >> 2] | 0) {
	                                    c[q >> 2] = my(c[e + 56 >> 2] | 0) | 0;
	                                    c[q >> 2] = By(c[q >> 2] | 0, 198608) | 0;
	                                    c[q >> 2] = By(c[q >> 2] | 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0) | 0
	                                } else c[q >> 2] = my(c[e + 8 >> 2] | 0) | 0;
	                                if (!(c[q >> 2] | 0))break;
	                                c[m >> 2] = 0;
	                                c:do if (c[k >> 2] | 0) {
	                                    c[o >> 2] = 0;
	                                    c[m >> 2] = c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                                    while (1) {
	                                        if (!(c[m >> 2] | 0))break c;
	                                        if (qy(c[m >> 2] | 0, c[q >> 2] | 0) | 0)break c;
	                                        c[o >> 2] = (c[o >> 2] | 0) + 2;
	                                        c[m >> 2] = c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2]
	                                    }
	                                } while (0);
	                                if (!(c[m >> 2] | 0))vQ(c[g >> 2] | 0, 538, 198616, c[q >> 2] | 0, c[(c[p >> 2] | 0) + 60 >> 2] | 0);
	                                zb[c[135736 >> 2] & 511](c[q >> 2] | 0)
	                            }
	                            c[p >> 2] = c[(c[p >> 2] | 0) + 36 >> 2];
	                            if (!(c[p >> 2] | 0))break b
	                        }
	                        sQ(c[g >> 2] | 0, 197824)
	                    } while (0);
	                    c[p >> 2] = c[(c[l >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[p >> 2] | 0))break;
	                        d:do if (c[(c[p >> 2] | 0) + 48 >> 2] | 0) {
	                            if (!((c[(c[p >> 2] | 0) + 56 >> 2] | 0) != 0 ? (qy(c[(c[p >> 2] | 0) + 56 >> 2] | 0, 198248) | 0) != 0 : 0))u = 29;
	                            do if ((u | 0) == 29) {
	                                u = 0;
	                                if ((c[(c[p >> 2] | 0) + 56 >> 2] | 0) == 0 ? (qy(c[(c[p >> 2] | 0) + 8 >> 2] | 0, 198248) | 0) != 0 : 0)break;
	                                if (!(c[(c[g >> 2] | 0) + 276 >> 2] & 4))break d
	                            } while (0);
	                            c[r >> 2] = Nm(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0, c[(c[p >> 2] | 0) + 60 >> 2] | 0, c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 56 >> 2] | 0) | 0;
	                            if ((c[r >> 2] | 0) == 0 ? 1 : (c[r >> 2] | 0) == (c[p >> 2] | 0)) {
	                                c[t >> 2] = Bh(c[(c[p >> 2] | 0) + 8 >> 2] | 0, c[(c[p >> 2] | 0) + 56 >> 2] | 0, s, 50) | 0;
	                                if (!(c[t >> 2] | 0)) {
	                                    u = 34;
	                                    break a
	                                }
	                                c[m >> 2] = 0;
	                                e:do if (c[k >> 2] | 0) {
	                                    c[o >> 2] = 0;
	                                    c[m >> 2] = c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2];
	                                    while (1) {
	                                        if (!(c[m >> 2] | 0))break e;
	                                        if (qy(c[m >> 2] | 0, c[t >> 2] | 0) | 0)break e;
	                                        c[o >> 2] = (c[o >> 2] | 0) + 2;
	                                        c[m >> 2] = c[(c[k >> 2] | 0) + (c[o >> 2] << 2) >> 2]
	                                    }
	                                } while (0);
	                                if (!(c[m >> 2] | 0))xQ(c[g >> 2] | 0, c[t >> 2] | 0, c[(c[p >> 2] | 0) + 48 >> 2] | 0, c[j >> 2] | 0);
	                                if ((c[t >> 2] | 0) != (s | 0) ? (c[t >> 2] | 0) != (c[(c[p >> 2] | 0) + 8 >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[t >> 2] | 0)
	                            }
	                        } while (0);
	                        c[p >> 2] = c[(c[p >> 2] | 0) + 36 >> 2]
	                    }
	                    if ((c[n >> 2] | 0) != 1) {
	                        u = 48;
	                        break
	                    }
	                    c[l >> 2] = Mm(c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                    c[n >> 2] = 0
	                }
	                if ((u | 0) == 34) {
	                    sQ(c[g >> 2] | 0, 197824);
	                    i = f;
	                    return
	                } else if ((u | 0) == 48) {
	                    i = f;
	                    return
	                }
	            }

	            function xQ(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
	                g = i;
	                i = i + 96 | 0;
	                h = g;
	                j = g + 80 | 0;
	                k = g + 76 | 0;
	                l = g + 72 | 0;
	                m = g + 68 | 0;
	                n = g + 64 | 0;
	                o = g + 60 | 0;
	                p = g + 56 | 0;
	                q = g + 52 | 0;
	                r = g + 48 | 0;
	                s = g + 44 | 0;
	                t = g + 40 | 0;
	                u = g + 36 | 0;
	                v = g + 32 | 0;
	                w = g + 28 | 0;
	                x = g + 24 | 0;
	                y = g + 20 | 0;
	                z = g + 16 | 0;
	                A = g + 12 | 0;
	                B = g + 8 | 0;
	                C = g + 4 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = c[j >> 2];
	                if (!(c[(c[n >> 2] | 0) + 32 >> 2] | 0)) {
	                    c[p >> 2] = bf(c[n >> 2] | 0, c[k >> 2] | 0, q) | 0;
	                    if ((c[p >> 2] | 0) != 0 ? (d[c[p >> 2] >> 0] | 0 | 0) == 0 : 0) {
	                        j = (qy(c[q >> 2] | 0, 198248) | 0) != 0;
	                        f = c[n >> 2] | 0;
	                        e = c[k >> 2] | 0;
	                        if (j)BQ(f, 35, 198256, e, 0); else yQ(f, 106, 198296, e, 0);
	                        if (c[q >> 2] | 0)zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                        c[q >> 2] = 0;
	                        zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                        c[p >> 2] = my(c[k >> 2] | 0) | 0
	                    }
	                } else {
	                    c[p >> 2] = my(c[k >> 2] | 0) | 0;
	                    c[q >> 2] = 0;
	                    c[s >> 2] = 0
	                }
	                e = c[n >> 2] | 0;
	                if (!(c[p >> 2] | 0)) {
	                    sQ(e, 197824);
	                    if (!(c[q >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                    i = g;
	                    return
	                }
	                if ((c[e + 32 >> 2] | 0) != 0 & (c[l >> 2] | 0) == 0 ? (sp(c[k >> 2] | 0) | 0) != 0 : 0) {
	                    c[r >> 2] = my(c[k >> 2] | 0) | 0;
	                    c[l >> 2] = c[r >> 2]
	                } else {
	                    c[(c[n >> 2] | 0) + 144 >> 2] = 1;
	                    c[r >> 2] = Sm((c[n >> 2] | 0) + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[k >> 2] | 0, c[l >> 2] | 0) | 0;
	                    if ((c[(c[n >> 2] | 0) + 144 >> 2] | 0) != 1)c[(c[n >> 2] | 0) + 100 >> 2] = 0;
	                    if (c[r >> 2] | 0)c[l >> 2] = c[r >> 2]
	                }
	                if ((((((((c[q >> 2] | 0) == 0 ? (c[(c[n >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) ? (d[c[p >> 2] >> 0] | 0 | 0) == 120 : 0) ? (d[(c[p >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[p >> 2] | 0) + 2 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[p >> 2] | 0) + 3 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[p >> 2] | 0) + 4 >> 0] | 0 | 0) == 115 : 0) ? (d[(c[p >> 2] | 0) + 5 >> 0] | 0 | 0) == 0 : 0) {
	                    if (!(c[(c[n >> 2] | 0) + 16 >> 2] | 0)) {
	                        e = (c[n >> 2] | 0) + 248 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                        c[u >> 2] = af(c[n >> 2] | 0, c[l >> 2] | 0, 1, 0, 0, 0) | 0;
	                        e = (c[n >> 2] | 0) + 248 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + -1;
	                        if (!(c[u >> 2] | 0)) {
	                            sQ(c[n >> 2] | 0, 197824);
	                            if (!(c[p >> 2] | 0)) {
	                                i = g;
	                                return
	                            }
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                            i = g;
	                            return
	                        }
	                    } else c[u >> 2] = c[l >> 2];
	                    do if (d[c[u >> 2] >> 0] | 0) {
	                        c[v >> 2] = yl(c[u >> 2] | 0) | 0;
	                        if (!(c[v >> 2] | 0)) {
	                            if (!(c[c[n >> 2] >> 2] | 0))break;
	                            if (!(c[(c[c[n >> 2] >> 2] | 0) + 84 >> 2] | 0))break;
	                            e = c[(c[c[n >> 2] >> 2] | 0) + 84 >> 2] | 0;
	                            f = c[(c[n >> 2] | 0) + 4 >> 2] | 0;
	                            c[h >> 2] = c[u >> 2];
	                            Db[e & 511](f, 198344, h);
	                            break
	                        }
	                        if (((c[c[v >> 2] >> 2] | 0) == 0 ? (c[c[n >> 2] >> 2] | 0) != 0 : 0) ? (c[(c[c[n >> 2] >> 2] | 0) + 84 >> 2] | 0) != 0 : 0) {
	                            f = c[(c[c[n >> 2] >> 2] | 0) + 84 >> 2] | 0;
	                            e = c[(c[n >> 2] | 0) + 4 >> 2] | 0;
	                            c[h >> 2] = c[u >> 2];
	                            Db[f & 511](e, 198376, h)
	                        }
	                        Al(c[v >> 2] | 0)
	                    } while (0);
	                    c[t >> 2] = Ih(c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[u >> 2] | 0, 0) | 0;
	                    if (((((c[t >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                        v = Xm((c[n >> 2] | 0) + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[m >> 2] | 0, c[t >> 2] | 0, c[u >> 2] | 0) | 0;
	                        t = (c[n >> 2] | 0) + 100 | 0;
	                        c[t >> 2] = c[t >> 2] & v
	                    }
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    if ((c[u >> 2] | 0) == (c[l >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    zb[c[135736 >> 2] & 511](c[u >> 2] | 0);
	                    i = g;
	                    return
	                }
	                if ((((((((c[q >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) ? (d[c[q >> 2] >> 0] | 0 | 0) == 120 : 0) ? (d[(c[q >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[q >> 2] | 0) + 2 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[q >> 2] | 0) + 3 >> 0] | 0 | 0) == 110 : 0) ? (d[(c[q >> 2] | 0) + 4 >> 0] | 0 | 0) == 115 : 0) ? (d[(c[q >> 2] | 0) + 5 >> 0] | 0 | 0) == 0 : 0) {
	                    if (!(c[(c[n >> 2] | 0) + 16 >> 2] | 0)) {
	                        u = (c[n >> 2] | 0) + 248 | 0;
	                        c[u >> 2] = (c[u >> 2] | 0) + 1;
	                        c[x >> 2] = af(c[n >> 2] | 0, c[l >> 2] | 0, 1, 0, 0, 0) | 0;
	                        u = (c[n >> 2] | 0) + 248 | 0;
	                        c[u >> 2] = (c[u >> 2] | 0) + -1;
	                        if (!(c[x >> 2] | 0)) {
	                            sQ(c[n >> 2] | 0, 197824);
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                            if (!(c[p >> 2] | 0)) {
	                                i = g;
	                                return
	                            }
	                            zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                            i = g;
	                            return
	                        }
	                    } else c[x >> 2] = c[l >> 2];
	                    if (!(d[c[x >> 2] >> 0] | 0))BQ(c[n >> 2] | 0, 204, 198408, c[p >> 2] | 0, 0);
	                    do if ((c[(c[n >> 2] | 0) + 268 >> 2] | 0) != 0 ? (d[c[x >> 2] >> 0] | 0 | 0) != 0 : 0) {
	                        c[y >> 2] = yl(c[x >> 2] | 0) | 0;
	                        if (!(c[y >> 2] | 0)) {
	                            yQ(c[n >> 2] | 0, 99, 198448, c[p >> 2] | 0, c[l >> 2] | 0);
	                            break
	                        }
	                        if (!(c[c[y >> 2] >> 2] | 0))yQ(c[n >> 2] | 0, 100, 198480, c[p >> 2] | 0, c[l >> 2] | 0);
	                        Al(c[y >> 2] | 0)
	                    } while (0);
	                    c[w >> 2] = Ih(c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[x >> 2] | 0, c[p >> 2] | 0) | 0;
	                    zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                    do if ((((c[w >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                        if (!(c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0))break;
	                        y = Xm((c[n >> 2] | 0) + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[m >> 2] | 0, c[w >> 2] | 0, c[l >> 2] | 0) | 0;
	                        u = (c[n >> 2] | 0) + 100 | 0;
	                        c[u >> 2] = c[u >> 2] & y
	                    } while (0);
	                    if (c[p >> 2] | 0)zb[c[135736 >> 2] & 511](c[p >> 2] | 0);
	                    if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                    if ((c[x >> 2] | 0) == (c[l >> 2] | 0)) {
	                        i = g;
	                        return
	                    }
	                    zb[c[135736 >> 2] & 511](c[x >> 2] | 0);
	                    i = g;
	                    return
	                }
	                a:do if (c[q >> 2] | 0) {
	                    c[s >> 2] = cj(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[q >> 2] | 0) | 0;
	                    x = c[n >> 2] | 0;
	                    if (!(c[s >> 2] | 0)) {
	                        BQ(x, 201, 198520, c[q >> 2] | 0, c[p >> 2] | 0);
	                        D = 101;
	                        break
	                    }
	                    c[z >> 2] = c[(c[x + 52 >> 2] | 0) + 44 >> 2];
	                    while (1) {
	                        if (!(c[z >> 2] | 0)) {
	                            D = 101;
	                            break a
	                        }
	                        if ((c[(c[z >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[p >> 2] | 0, c[(c[z >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) {
	                            if ((c[s >> 2] | 0) == (c[(c[z >> 2] | 0) + 36 >> 2] | 0))break;
	                            if (qy(c[(c[s >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[z >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0)break
	                        }
	                        c[z >> 2] = c[(c[z >> 2] | 0) + 24 >> 2]
	                    }
	                    BQ(c[n >> 2] | 0, 42, 198576, c[p >> 2] | 0, c[(c[s >> 2] | 0) + 8 >> 2] | 0);
	                    c[(c[n >> 2] | 0) + 12 >> 2] = 0;
	                    if (!(c[(c[n >> 2] | 0) + 288 >> 2] | 0))c[(c[n >> 2] | 0) + 212 >> 2] = 1
	                } else {
	                    c[s >> 2] = 0;
	                    D = 101
	                } while (0);
	                do if ((D | 0) == 101) {
	                    c[o >> 2] = bi(c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[s >> 2] | 0, c[p >> 2] | 0, 0) | 0;
	                    b:do if (c[o >> 2] | 0) {
	                        if ((c[(c[n >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[n >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                            z = Zh(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0;
	                            c[(c[o >> 2] | 0) + 12 >> 2] = z;
	                            c[A >> 2] = c[(c[o >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[A >> 2] | 0))break b;
	                                c[(c[A >> 2] | 0) + 20 >> 2] = c[o >> 2];
	                                if (!(c[(c[A >> 2] | 0) + 24 >> 2] | 0))c[(c[o >> 2] | 0) + 16 >> 2] = c[A >> 2];
	                                c[A >> 2] = c[(c[A >> 2] | 0) + 24 >> 2]
	                            }
	                        }
	                        if ((c[l >> 2] | 0) != 0 ? (z = Wh(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0, c[(c[o >> 2] | 0) + 12 >> 2] = z, c[(c[o >> 2] | 0) + 16 >> 2] = c[(c[o >> 2] | 0) + 12 >> 2], (c[(c[o >> 2] | 0) + 12 >> 2] | 0) != 0) : 0)c[(c[(c[o >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] = c[o >> 2]
	                    } while (0);
	                    if (((((c[(c[n >> 2] | 0) + 32 >> 2] | 0) == 0 ? (c[(c[n >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[n >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[n >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                        z = c[n >> 2] | 0;
	                        if (c[(c[n >> 2] | 0) + 16 >> 2] | 0) {
	                            x = Wm(z + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0) | 0;
	                            w = (c[n >> 2] | 0) + 100 | 0;
	                            c[w >> 2] = c[w >> 2] & x;
	                            break
	                        }
	                        x = z + 248 | 0;
	                        c[x >> 2] = (c[x >> 2] | 0) + 1;
	                        c[B >> 2] = af(c[n >> 2] | 0, c[l >> 2] | 0, 1, 0, 0, 0) | 0;
	                        x = (c[n >> 2] | 0) + 248 | 0;
	                        c[x >> 2] = (c[x >> 2] | 0) + -1;
	                        x = c[n >> 2] | 0;
	                        if (!(c[B >> 2] | 0)) {
	                            z = Wm(x + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[l >> 2] | 0) | 0;
	                            w = (c[n >> 2] | 0) + 100 | 0;
	                            c[w >> 2] = c[w >> 2] & z;
	                            break
	                        }
	                        c[C >> 2] = Tm(c[x + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[k >> 2] | 0, c[B >> 2] | 0) | 0;
	                        if (c[C >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[B >> 2] | 0);
	                            c[B >> 2] = c[C >> 2]
	                        }
	                        x = Wm((c[n >> 2] | 0) + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[B >> 2] | 0) | 0;
	                        z = (c[n >> 2] | 0) + 100 | 0;
	                        c[z >> 2] = c[z >> 2] & x;
	                        zb[c[135736 >> 2] & 511](c[B >> 2] | 0);
	                        break
	                    }
	                    if (!(c[(c[n >> 2] | 0) + 276 >> 2] & 8)) {
	                        if (!((c[(c[n >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[n >> 2] | 0) + 96 >> 2] | 0) != 2 : 0)) {
	                            if (!(c[(c[n >> 2] | 0) + 16 >> 2] | 0))break;
	                            if (c[(c[n >> 2] | 0) + 216 >> 2] | 0)break
	                        }
	                        if (qy(c[k >> 2] | 0, 197408) | 0) {
	                            if (Eh(c[l >> 2] | 0, 1) | 0)vQ(c[n >> 2] | 0, 539, 198200, c[l >> 2] | 0, 0);
	                            Cm((c[n >> 2] | 0) + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0;
	                            break
	                        }
	                        x = (Em(c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0) != 0;
	                        z = c[n >> 2] | 0;
	                        if (x) {
	                            Cm(z + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0;
	                            break
	                        }
	                        if (Km(c[z + 8 >> 2] | 0, c[(c[n >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0)Im((c[n >> 2] | 0) + 108 | 0, c[(c[n >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0, c[o >> 2] | 0) | 0
	                    }
	                } while (0);
	                if (c[r >> 2] | 0)zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                if (!(c[q >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                i = g;
	                return
	            }

	            function yQ(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                f = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                e = c[n >> 2] | 0;
	                d = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(0, 0, 0, f, 0, 3, j, 1, 0, 0, k, e, 0, 0, 0, d, h);
	                i = g;
	                return
	            }

	            function zQ(a, b, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                h = i;
	                i = i + 112 | 0;
	                j = h + 48 | 0;
	                k = h + 44 | 0;
	                l = h + 40 | 0;
	                m = h + 36 | 0;
	                n = h + 32 | 0;
	                o = h + 28 | 0;
	                p = h + 24 | 0;
	                q = h + 20 | 0;
	                r = h + 16 | 0;
	                s = h + 12 | 0;
	                t = h + 8 | 0;
	                u = h + 4 | 0;
	                v = h + 52 | 0;
	                w = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = g;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                if (c[l >> 2] | 0)c[p >> 2] = cj(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[l >> 2] | 0) | 0;
	                g = c[j >> 2] | 0;
	                if (c[(c[j >> 2] | 0) + 380 >> 2] | 0) {
	                    c[o >> 2] = c[g + 380 >> 2];
	                    c[(c[j >> 2] | 0) + 380 >> 2] = c[(c[o >> 2] | 0) + 24 >> 2];
	                    f = (c[j >> 2] | 0) + 376 | 0;
	                    c[f >> 2] = (c[f >> 2] | 0) + -1;
	                    f = (c[o >> 2] | 0) + 0 | 0;
	                    e = f + 48 | 0;
	                    do {
	                        c[f >> 2] = 0;
	                        f = f + 4 | 0
	                    } while ((f | 0) < (e | 0));
	                    c[(c[o >> 2] | 0) + 4 >> 2] = 2;
	                    c[(c[o >> 2] | 0) + 20 >> 2] = c[(c[j >> 2] | 0) + 52 >> 2];
	                    c[(c[o >> 2] | 0) + 32 >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                    c[(c[o >> 2] | 0) + 36 >> 2] = c[p >> 2];
	                    f = c[k >> 2] | 0;
	                    if (c[(c[j >> 2] | 0) + 364 >> 2] | 0)c[(c[o >> 2] | 0) + 8 >> 2] = f; else {
	                        e = my(f) | 0;
	                        c[(c[o >> 2] | 0) + 8 >> 2] = e
	                    }
	                    if (!(c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 44 >> 2] | 0))c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 44 >> 2] = c[o >> 2]; else {
	                        c[r >> 2] = c[(c[(c[j >> 2] | 0) + 52 >> 2] | 0) + 44 >> 2];
	                        while (1) {
	                            if (!(c[(c[r >> 2] | 0) + 24 >> 2] | 0))break;
	                            c[r >> 2] = c[(c[r >> 2] | 0) + 24 >> 2]
	                        }
	                        c[(c[r >> 2] | 0) + 24 >> 2] = c[o >> 2];
	                        c[(c[o >> 2] | 0) + 28 >> 2] = c[r >> 2]
	                    }
	                    if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[o >> 2] | 0)
	                } else {
	                    r = c[(c[j >> 2] | 0) + 52 >> 2] | 0;
	                    e = c[p >> 2] | 0;
	                    p = c[k >> 2] | 0;
	                    if (c[g + 364 >> 2] | 0)c[o >> 2] = bi(r, e, p, 0) | 0; else c[o >> 2] = ai(r, e, p, 0) | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        ie(c[j >> 2] | 0, 198176);
	                        i = h;
	                        return
	                    }
	                }
	                a:do if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 32 >> 2] | 0) == 0 : 0) {
	                    p = c[j >> 2] | 0;
	                    if (d[c[n >> 2] >> 0] | 0) {
	                        c[s >> 2] = AQ(p, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        c[(c[o >> 2] | 0) + 12 >> 2] = c[s >> 2];
	                        c[(c[o >> 2] | 0) + 16 >> 2] = c[s >> 2];
	                        if (!(c[s >> 2] | 0))break;
	                        c[(c[s >> 2] | 0) + 32 >> 2] = c[(c[o >> 2] | 0) + 32 >> 2];
	                        c[(c[s >> 2] | 0) + 20 >> 2] = c[o >> 2];
	                        break
	                    }
	                    e = Vh(c[p + 8 >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                    c[(c[o >> 2] | 0) + 12 >> 2] = e;
	                    c[s >> 2] = c[(c[o >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if (!(c[s >> 2] | 0))break a;
	                        c[(c[s >> 2] | 0) + 32 >> 2] = c[(c[o >> 2] | 0) + 32 >> 2];
	                        c[(c[s >> 2] | 0) + 20 >> 2] = c[o >> 2];
	                        if (!(c[(c[s >> 2] | 0) + 24 >> 2] | 0))c[(c[o >> 2] | 0) + 16 >> 2] = c[s >> 2];
	                        c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                    }
	                } else x = 30; while (0);
	                if (((x | 0) == 30 ? (c[m >> 2] | 0) != 0 : 0) ? (c[t >> 2] = AQ(c[j >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0, c[(c[o >> 2] | 0) + 12 >> 2] = c[t >> 2], c[(c[o >> 2] | 0) + 16 >> 2] = c[t >> 2], (c[t >> 2] | 0) != 0) : 0) {
	                    c[(c[t >> 2] | 0) + 32 >> 2] = c[(c[o >> 2] | 0) + 32 >> 2];
	                    c[(c[t >> 2] | 0) + 20 >> 2] = c[o >> 2]
	                }
	                do if (((((c[(c[j >> 2] | 0) + 32 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 104 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (c[(c[(c[j >> 2] | 0) + 8 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) {
	                    if (c[(c[j >> 2] | 0) + 16 >> 2] | 0) {
	                        c[q >> 2] = ly(c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        t = Wm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[q >> 2] | 0) | 0;
	                        s = (c[j >> 2] | 0) + 100 | 0;
	                        c[s >> 2] = c[s >> 2] & t;
	                        break
	                    }
	                    c[q >> 2] = CQ(c[j >> 2] | 0, c[m >> 2] | 0, c[n >> 2] | 0) | 0;
	                    if (!(c[q >> 2] | 0))if (!(d[c[n >> 2] >> 0] | 0)) {
	                        t = Wm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[m >> 2] | 0) | 0;
	                        s = (c[j >> 2] | 0) + 100 | 0;
	                        c[s >> 2] = c[s >> 2] & t;
	                        break
	                    } else {
	                        c[q >> 2] = ly(c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        t = Wm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[q >> 2] | 0) | 0;
	                        s = (c[j >> 2] | 0) + 100 | 0;
	                        c[s >> 2] = c[s >> 2] & t;
	                        break
	                    }
	                    if ((c[(c[j >> 2] | 0) + 352 >> 2] | 0) != 0 ? (c[w >> 2] = Bh(c[k >> 2] | 0, c[l >> 2] | 0, v, 50) | 0, (c[w >> 2] | 0) != 0) : 0) {
	                        c[(c[j >> 2] | 0) + 144 >> 2] = 1;
	                        c[u >> 2] = Sm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[w >> 2] | 0, c[q >> 2] | 0) | 0;
	                        if ((c[(c[j >> 2] | 0) + 144 >> 2] | 0) != 1)c[(c[j >> 2] | 0) + 100 >> 2] = 0;
	                        if ((c[w >> 2] | 0) != (v | 0) ? (c[w >> 2] | 0) != (c[k >> 2] | 0) : 0)zb[c[135736 >> 2] & 511](c[w >> 2] | 0);
	                        if (c[u >> 2] | 0) {
	                            zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                            c[q >> 2] = c[u >> 2]
	                        }
	                    }
	                    t = Wm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0, c[q >> 2] | 0) | 0;
	                    s = (c[j >> 2] | 0) + 100 | 0;
	                    c[s >> 2] = c[s >> 2] & t
	                } else x = 54; while (0);
	                do if ((x | 0) == 54 ? (c[(c[j >> 2] | 0) + 276 >> 2] & 8 | 0) == 0 : 0) {
	                    if (!((c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[j >> 2] | 0) + 96 >> 2] | 0) != 2 : 0)) {
	                        if (!(c[(c[j >> 2] | 0) + 16 >> 2] | 0))break;
	                        if (c[(c[j >> 2] | 0) + 216 >> 2] | 0)break
	                    }
	                    if ((((c[l >> 2] | 0) == (c[(c[j >> 2] | 0) + 312 >> 2] | 0) ? (d[c[k >> 2] >> 0] | 0 | 0) == 105 : 0) ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) == 100 : 0) ? (d[(c[k >> 2] | 0) + 2 >> 0] | 0 | 0) == 0 : 0) {
	                        if (!(c[q >> 2] | 0))c[q >> 2] = ly(c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        if (Eh(c[q >> 2] | 0, 1) | 0)vQ(c[j >> 2] | 0, 539, 198200, c[q >> 2] | 0, 0);
	                        Cm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[q >> 2] | 0, c[o >> 2] | 0) | 0;
	                        break
	                    }
	                    if (Em(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0) {
	                        if (!(c[q >> 2] | 0))c[q >> 2] = ly(c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        Cm((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[q >> 2] | 0, c[o >> 2] | 0) | 0;
	                        break
	                    }
	                    if (Km(c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[(c[j >> 2] | 0) + 52 >> 2] | 0, c[o >> 2] | 0) | 0) {
	                        if (!(c[q >> 2] | 0))c[q >> 2] = ly(c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        Im((c[j >> 2] | 0) + 108 | 0, c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[q >> 2] | 0, c[o >> 2] | 0) | 0
	                    }
	                } while (0);
	                if (!(c[q >> 2] | 0)) {
	                    i = h;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[q >> 2] | 0);
	                i = h;
	                return
	            }

	            function AQ(e, f, g) {
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 28 | 0;
	                k = h + 24 | 0;
	                l = h + 20 | 0;
	                m = h + 16 | 0;
	                n = h + 12 | 0;
	                o = h + 8 | 0;
	                p = h + 32 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = g;
	                c[o >> 2] = 0;
	                if (c[(c[k >> 2] | 0) + 372 >> 2] | 0) {
	                    c[n >> 2] = c[(c[k >> 2] | 0) + 372 >> 2];
	                    c[(c[k >> 2] | 0) + 372 >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                    g = (c[k >> 2] | 0) + 368 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + -1
	                } else c[n >> 2] = Cb[c[135744 >> 2] & 511](60) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    ie(c[k >> 2] | 0, 198e3);
	                    c[j >> 2] = 0;
	                    s = c[j >> 2] | 0;
	                    i = h;
	                    return s | 0
	                }
	                g = (c[n >> 2] | 0) + 0 | 0;
	                f = g + 60 | 0;
	                do {
	                    c[g >> 2] = 0;
	                    g = g + 4 | 0
	                } while ((g | 0) < (f | 0));
	                a:do if (c[(c[k >> 2] | 0) + 364 >> 2] | 0) {
	                    a[p >> 0] = a[(c[l >> 2] | 0) + (c[m >> 2] | 0) >> 0] | 0;
	                    if ((c[m >> 2] | 0) < 8 ? (c[(c[k >> 2] | 0) + 360 >> 2] & 65536 | 0) != 0 : 0) {
	                        c[q >> 2] = (c[n >> 2] | 0) + 44;
	                        eU(c[q >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                        a[(c[q >> 2] | 0) + (c[m >> 2] | 0) >> 0] = 0;
	                        c[o >> 2] = c[q >> 2];
	                        break
	                    }
	                    do if ((c[m >> 2] | 0) <= 3) {
	                        if ((d[p >> 0] | 0 | 0) != 34 ? (d[p >> 0] | 0 | 0) != 39 : 0) {
	                            if ((d[p >> 0] | 0 | 0) != 60)break;
	                            if ((d[(c[l >> 2] | 0) + ((c[m >> 2] | 0) + 1) >> 0] | 0 | 0) == 33)break
	                        }
	                        c[o >> 2] = AP(c[(c[k >> 2] | 0) + 296 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                        break a
	                    } while (0);
	                    do if ((d[c[l >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[l >> 2] >> 0] | 0 | 0) ? (d[c[l >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            t = 20;
	                            break
	                        }
	                        if (!((c[m >> 2] | 0) < 60 ? (d[c[l >> 2] >> 0] | 0 | 0) == 13 : 0))break a
	                    } else t = 20; while (0);
	                    if ((t | 0) == 20 ? (c[m >> 2] | 0) >= 60 : 0)break;
	                    if ((d[p >> 0] | 0 | 0) == 60 ? (d[(c[l >> 2] | 0) + ((c[m >> 2] | 0) + 1) >> 0] | 0 | 0) != 33 : 0) {
	                        c[r >> 2] = 1;
	                        while (1) {
	                            if ((c[r >> 2] | 0) >= (c[m >> 2] | 0))break;
	                            do if ((d[(c[l >> 2] | 0) + (c[r >> 2] | 0) >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[(c[l >> 2] | 0) + (c[r >> 2] | 0) >> 0] | 0 | 0) ? (d[(c[l >> 2] | 0) + (c[r >> 2] | 0) >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[(c[l >> 2] | 0) + (c[r >> 2] | 0) >> 0] | 0 | 0) != 13)break a
	                            } while (0);
	                            c[r >> 2] = (c[r >> 2] | 0) + 1
	                        }
	                        c[o >> 2] = AP(c[(c[k >> 2] | 0) + 296 >> 2] | 0, c[l >> 2] | 0, c[m >> 2] | 0) | 0
	                    }
	                } while (0);
	                c[(c[n >> 2] | 0) + 4 >> 2] = 3;
	                c[(c[n >> 2] | 0) + 8 >> 2] = 75104;
	                if (!(c[o >> 2] | 0)) {
	                    r = ly(c[l >> 2] | 0, c[m >> 2] | 0) | 0;
	                    c[(c[n >> 2] | 0) + 40 >> 2] = r;
	                    if (!(c[(c[n >> 2] | 0) + 40 >> 2] | 0)) {
	                        sQ(c[k >> 2] | 0, 198160);
	                        zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                        c[j >> 2] = 0;
	                        s = c[j >> 2] | 0;
	                        i = h;
	                        return s | 0
	                    }
	                } else c[(c[n >> 2] | 0) + 40 >> 2] = c[o >> 2];
	                do if ((c[(c[k >> 2] | 0) + 280 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                    if ((c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2] | 0) < 65535) {
	                        b[(c[n >> 2] | 0) + 56 >> 1] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2];
	                        break
	                    }
	                    b[(c[n >> 2] | 0) + 56 >> 1] = -1;
	                    if (c[(c[k >> 2] | 0) + 360 >> 2] & 4194304)c[(c[n >> 2] | 0) + 52 >> 2] = c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 28 >> 2]
	                } while (0);
	                if ((c[18774] | 0) != 0 & (c[33968] | 0) != 0)zb[c[135872 >> 2] & 511](c[n >> 2] | 0);
	                c[j >> 2] = c[n >> 2];
	                s = c[j >> 2] | 0;
	                i = h;
	                return s | 0
	            }

	            function BQ(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if (((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 212 >> 2] | 0) != 0 : 0) ? (c[(c[j >> 2] | 0) + 172 >> 2] | 0) == -1 : 0) {
	                    i = g;
	                    return
	                }
	                if (c[j >> 2] | 0)c[(c[j >> 2] | 0) + 84 >> 2] = c[k >> 2];
	                f = c[j >> 2] | 0;
	                j = c[k >> 2] | 0;
	                k = c[m >> 2] | 0;
	                e = c[n >> 2] | 0;
	                d = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                c[h >> 2] = c[m >> 2];
	                c[h + 4 >> 2] = l;
	                Xd(0, 0, 0, f, 0, 3, j, 2, 0, 0, k, e, 0, 0, 0, d, h);
	                i = g;
	                return
	            }

	            function CQ(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 20 | 0;
	                h = f + 16 | 0;
	                j = f + 12 | 0;
	                k = f + 8 | 0;
	                l = f + 4 | 0;
	                m = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = c[j >> 2];
	                while (1) {
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[k >> 2] | 0) >>> 0) {
	                        n = 4;
	                        break
	                    }
	                    e = c[l >> 2] | 0;
	                    c[l >> 2] = e + 1;
	                    if ((d[e >> 0] | 0 | 0) == 38) {
	                        n = 5;
	                        break
	                    }
	                }
	                if ((n | 0) == 4) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                } else if ((n | 0) == 5) {
	                    n = (c[h >> 2] | 0) + 248 | 0;
	                    c[n >> 2] = (c[n >> 2] | 0) + 1;
	                    c[m >> 2] = $e(c[h >> 2] | 0, c[j >> 2] | 0, (c[k >> 2] | 0) - (c[j >> 2] | 0) | 0, 1, 0, 0, 0) | 0;
	                    j = (c[h >> 2] | 0) + 248 | 0;
	                    c[j >> 2] = (c[j >> 2] | 0) + -1;
	                    c[g >> 2] = c[m >> 2];
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                return 0
	            }

	            function DQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    o = c[f >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                b = c[h >> 2] | 0;
	                a:do if ((c[g >> 2] | 0) >>> 0 < 65536) {
	                    if (!(c[b >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    }
	                    c[j >> 2] = 0;
	                    c[k >> 2] = (c[c[h >> 2] >> 2] | 0) - 1;
	                    c[m >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                    while (1) {
	                        if ((c[j >> 2] | 0) > (c[k >> 2] | 0))break a;
	                        c[l >> 2] = ((c[j >> 2] | 0) + (c[k >> 2] | 0) | 0) / 2 | 0;
	                        if ((c[g >> 2] & 65535 | 0) < (e[(c[m >> 2] | 0) + (c[l >> 2] << 2) >> 1] | 0 | 0)) {
	                            c[k >> 2] = (c[l >> 2] | 0) - 1;
	                            continue
	                        }
	                        if ((c[g >> 2] & 65535 | 0) <= (e[(c[m >> 2] | 0) + (c[l >> 2] << 2) + 2 >> 1] | 0 | 0))break;
	                        c[j >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                    c[f >> 2] = 1;
	                    o = c[f >> 2] | 0;
	                    i = d;
	                    return o | 0
	                } else {
	                    if (!(c[b + 4 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        o = c[f >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    }
	                    c[j >> 2] = 0;
	                    c[k >> 2] = (c[(c[h >> 2] | 0) + 4 >> 2] | 0) - 1;
	                    c[n >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                    while (1) {
	                        if ((c[j >> 2] | 0) > (c[k >> 2] | 0))break a;
	                        c[l >> 2] = ((c[j >> 2] | 0) + (c[k >> 2] | 0) | 0) / 2 | 0;
	                        if ((c[g >> 2] | 0) >>> 0 < (c[(c[n >> 2] | 0) + (c[l >> 2] << 3) >> 2] | 0) >>> 0) {
	                            c[k >> 2] = (c[l >> 2] | 0) - 1;
	                            continue
	                        }
	                        if ((c[g >> 2] | 0) >>> 0 <= (c[(c[n >> 2] | 0) + (c[l >> 2] << 3) + 4 >> 2] | 0) >>> 0)break;
	                        c[j >> 2] = (c[l >> 2] | 0) + 1
	                    }
	                    c[f >> 2] = 1;
	                    o = c[f >> 2] | 0;
	                    i = d;
	                    return o | 0
	                } while (0);
	                c[f >> 2] = 0;
	                o = c[f >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function EQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)EQ(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 32 >> 2] | 0)TQ(c[(c[d >> 2] | 0) + 32 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 28 >> 2] | 0) {
	                    a:do if (!(c[(c[d >> 2] | 0) + 4 >> 2] | 0)) {
	                        c[f >> 2] = 0;
	                        while (1) {
	                            if ((c[f >> 2] | 0) >= (c[(c[d >> 2] | 0) + 20 >> 2] | 0))break a;
	                            c[e >> 2] = (c[(c[d >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0);
	                            if (c[(c[e >> 2] | 0) + 4 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 4 >> 2] | 0);
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[e >> 2] | 0) + 8 >> 2] | 0);
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 28 >> 2] | 0)
	                }
	                if (c[(c[d >> 2] | 0) + 4 >> 2] | 0)zP(c[(c[d >> 2] | 0) + 4 >> 2] | 0);
	                f = (c[d >> 2] | 0) + 0 | 0;
	                e = f + 36 | 0;
	                do {
	                    c[f >> 2] = -1;
	                    f = f + 4 | 0
	                } while ((f | 0) < (e | 0));
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function FQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[d >> 2];
	                    c[d >> 2] = c[(c[d >> 2] | 0) + 8 >> 2];
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 0;
	                    EQ(c[e >> 2] | 0)
	                }
	                i = b;
	                return
	            }

	            function GQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function HQ(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = UQ(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 1) | 0;
	                i = e;
	                return d | 0
	            }

	            function IQ(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                e = UQ(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0) | 0;
	                i = f;
	                return e | 0
	            }

	            function JQ(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = UQ(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 2) | 0;
	                i = e;
	                return d | 0
	            }

	            function KQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                while (1) {
	                    if (!(c[e >> 2] | 0))break;
	                    if ((c[(c[e >> 2] | 0) + 28 >> 2] | 0) == (c[(c[e >> 2] | 0) + 16 >> 2] | 0))c[(c[e >> 2] | 0) + 28 >> 2] = -1;
	                    if (c[(c[e >> 2] | 0) + 16 >> 2] | 0) {
	                        a = (c[e >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = (c[a >> 2] | 0) + -1
	                    }
	                    c[f >> 2] = (c[(c[e >> 2] | 0) + 8 >> 2] | 0) - 1;
	                    while (1) {
	                        if ((c[f >> 2] | 0) < 0)break;
	                        c[g >> 2] = c[(c[(c[e >> 2] | 0) + 20 >> 2] | 0) + ((c[f >> 2] << 1) + 1 << 2) >> 2];
	                        if ((c[g >> 2] | 0) > (c[(c[e >> 2] | 0) + 16 >> 2] | 0)) {
	                            a = (c[e >> 2] | 0) + 8 | 0;
	                            c[a >> 2] = (c[a >> 2] | 0) + -1
	                        }
	                        if ((c[g >> 2] | 0) <= (c[(c[e >> 2] | 0) + 16 >> 2] | 0))break;
	                        c[f >> 2] = (c[f >> 2] | 0) + -1
	                    }
	                    c[e >> 2] = c[c[e >> 2] >> 2]
	                }
	                c[d >> 2] = 0;
	                h = c[d >> 2] | 0;
	                i = b;
	                return h | 0
	            }

	            function LQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    while (1) {
	                        if (!(c[e >> 2] | 0)) {
	                            f = 7;
	                            break
	                        }
	                        if (c[(c[(c[e >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2] & 16384) {
	                            f = 5;
	                            break
	                        }
	                        c[e >> 2] = c[c[e >> 2] >> 2]
	                    }
	                    if ((f | 0) == 5) {
	                        c[d >> 2] = 1;
	                        break
	                    } else if ((f | 0) == 7) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                } else c[d >> 2] = -1; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function MQ(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                g = i;
	                i = i + 64 | 0;
	                h = g + 48 | 0;
	                j = g + 44 | 0;
	                k = g + 40 | 0;
	                l = g + 36 | 0;
	                m = g + 32 | 0;
	                n = g + 28 | 0;
	                o = g + 24 | 0;
	                p = g + 20 | 0;
	                q = g + 16 | 0;
	                r = g + 12 | 0;
	                s = g + 8 | 0;
	                t = g + 4 | 0;
	                u = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 0;
	                c[p >> 2] = 0;
	                c[s >> 2] = 0;
	                c[t >> 2] = 0;
	                c[u >> 2] = 1;
	                if (!(c[j >> 2] | 0)) {
	                    c[h >> 2] = 0;
	                    v = c[h >> 2] | 0;
	                    i = g;
	                    return v | 0
	                }
	                c[r >> 2] = c[j >> 2];
	                c[q >> 2] = c[r >> 2];
	                while (1) {
	                    if (!(d[c[q >> 2] >> 0] | 0)) {
	                        w = 41;
	                        break
	                    }
	                    c[s >> 2] = 0;
	                    while (1) {
	                        if (d[c[q >> 2] >> 0] | 0)x = (d[c[q >> 2] >> 0] | 0 | 0) != 124; else x = 0;
	                        y = c[q >> 2] | 0;
	                        if (!x)break;
	                        c[q >> 2] = y + 1
	                    }
	                    j = c[r >> 2] | 0;
	                    if (!(d[y >> 0] | 0))c[p >> 2] = VQ(j, c[k >> 2] | 0, c[m >> 2] | 0) | 0; else {
	                        c[s >> 2] = ly(j, (c[q >> 2] | 0) - (c[r >> 2] | 0) | 0) | 0;
	                        if (c[s >> 2] | 0)c[p >> 2] = VQ(c[s >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0) | 0;
	                        c[q >> 2] = (c[q >> 2] | 0) + 1
	                    }
	                    if (!(c[p >> 2] | 0)) {
	                        w = 48;
	                        break
	                    }
	                    c[o >> 2] = WQ() | 0;
	                    if (!(c[o >> 2] | 0)) {
	                        w = 48;
	                        break
	                    }
	                    if (c[k >> 2] | 0) {
	                        c[(c[o >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                        yP(c[k >> 2] | 0) | 0
	                    }
	                    if (!(c[n >> 2] | 0))c[n >> 2] = c[o >> 2]; else {
	                        c[(c[o >> 2] | 0) + 8 >> 2] = c[(c[n >> 2] | 0) + 8 >> 2];
	                        c[(c[n >> 2] | 0) + 8 >> 2] = c[o >> 2]
	                    }
	                    c[(c[o >> 2] | 0) + 16 >> 2] = c[l >> 2];
	                    c[(c[p >> 2] | 0) + 16 >> 2] = c[o >> 2];
	                    j = c[p >> 2] | 0;
	                    if (c[(c[o >> 2] | 0) + 16 >> 2] & 6)XQ(j); else YQ(j);
	                    if (c[(c[p >> 2] | 0) + 8 >> 2] | 0) {
	                        w = 48;
	                        break
	                    }
	                    ZQ(c[p >> 2] | 0);
	                    c[p >> 2] = 0;
	                    do if (c[u >> 2] | 0) {
	                        if (!(c[t >> 2] | 0)) {
	                            c[t >> 2] = c[(c[o >> 2] | 0) + 16 >> 2] & 768;
	                            break
	                        }
	                        if ((c[t >> 2] | 0) == 256) {
	                            if (!(c[(c[o >> 2] | 0) + 16 >> 2] & 512))break;
	                            c[u >> 2] = 0;
	                            break
	                        }
	                        if ((c[t >> 2] | 0) == 512 ? (c[(c[o >> 2] | 0) + 16 >> 2] & 256 | 0) != 0 : 0)c[u >> 2] = 0
	                    } while (0);
	                    if (c[u >> 2] | 0)_Q(c[o >> 2] | 0) | 0;
	                    if (($Q(c[o >> 2] | 0) | 0) < 0) {
	                        w = 48;
	                        break
	                    }
	                    if (c[s >> 2] | 0) {
	                        zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                        c[s >> 2] = 0
	                    }
	                    c[r >> 2] = c[q >> 2]
	                }
	                if ((w | 0) == 41) {
	                    a:do if (!(c[u >> 2] | 0)) {
	                        c[o >> 2] = c[n >> 2];
	                        while (1) {
	                            if (!(c[o >> 2] | 0))break a;
	                            if (c[(c[o >> 2] | 0) + 32 >> 2] | 0) {
	                                TQ(c[(c[o >> 2] | 0) + 32 >> 2] | 0);
	                                c[(c[o >> 2] | 0) + 32 >> 2] = 0
	                            }
	                            c[o >> 2] = c[(c[o >> 2] | 0) + 8 >> 2]
	                        }
	                    } while (0);
	                    c[h >> 2] = c[n >> 2];
	                    v = c[h >> 2] | 0;
	                    i = g;
	                    return v | 0
	                } else if ((w | 0) == 48) {
	                    if (c[p >> 2] | 0)ZQ(c[p >> 2] | 0);
	                    if (c[n >> 2] | 0)EQ(c[n >> 2] | 0);
	                    if (c[s >> 2] | 0)zb[c[135736 >> 2] & 511](c[s >> 2] | 0);
	                    c[h >> 2] = 0;
	                    v = c[h >> 2] | 0;
	                    i = g;
	                    return v | 0
	                }
	                return 0
	            }

	            function NQ(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                while (1) {
	                    if (!(c[f >> 2] | 0)) {
	                        k = 7;
	                        break
	                    }
	                    c[h >> 2] = aR(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        k = 5;
	                        break
	                    }
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 8 >> 2]
	                }
	                if ((k | 0) == 5) {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else if ((k | 0) == 7) {
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function OQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) {
	                    while (1) {
	                        if (!(c[e >> 2] | 0)) {
	                            h = 11;
	                            break
	                        }
	                        if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                            h = 12;
	                            break
	                        }
	                        c[g >> 2] = bR(c[(c[e >> 2] | 0) + 32 >> 2] | 0) | 0;
	                        if (!(c[g >> 2] | 0)) {
	                            h = 12;
	                            break
	                        }
	                        if (!(c[f >> 2] | 0))c[f >> 2] = c[g >> 2]; else {
	                            c[c[g >> 2] >> 2] = c[c[f >> 2] >> 2];
	                            c[c[f >> 2] >> 2] = c[g >> 2]
	                        }
	                        c[(c[g >> 2] | 0) + 24 >> 2] = c[(c[e >> 2] | 0) + 16 >> 2];
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 8 >> 2]
	                    }
	                    if ((h | 0) == 11) {
	                        c[d >> 2] = c[f >> 2];
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    } else if ((h | 0) == 12) {
	                        GQ(c[f >> 2] | 0);
	                        c[d >> 2] = 0;
	                        j = c[d >> 2] | 0;
	                        i = b;
	                        return j | 0
	                    }
	                }
	                c[d >> 2] = 0;
	                j = c[d >> 2] | 0;
	                i = b;
	                return j | 0
	            }

	            function PQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    while (1) {
	                        if (!(c[e >> 2] | 0)) {
	                            f = 7;
	                            break
	                        }
	                        if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                            f = 5;
	                            break
	                        }
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 8 >> 2]
	                    }
	                    if ((f | 0) == 5) {
	                        c[d >> 2] = 0;
	                        break
	                    } else if ((f | 0) == 7) {
	                        c[d >> 2] = 1;
	                        break
	                    }
	                } else c[d >> 2] = -1; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function QQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 12 | 0;
	                e = b + 8 | 0;
	                f = b + 4 | 0;
	                g = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                a:while (1) {
	                    if (!(c[e >> 2] | 0)) {
	                        j = 14;
	                        break
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                        j = 5;
	                        break
	                    }
	                    c[g >> 2] = 0;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0))break;
	                        if (c[(c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 12 >> 2] | 0) + (c[g >> 2] << 4) >> 2] & 1) {
	                            j = 9;
	                            break a
	                        }
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    if ((c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0) > (c[f >> 2] | 0))c[f >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2];
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 8 >> 2]
	                }
	                if ((j | 0) == 5) {
	                    c[d >> 2] = -1;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 9) {
	                    c[d >> 2] = -2;
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                } else if ((j | 0) == 14) {
	                    c[d >> 2] = c[f >> 2];
	                    h = c[d >> 2] | 0;
	                    i = b;
	                    return h | 0
	                }
	                return 0
	            }

	            function RQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 12345678;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                while (1) {
	                    if (!(c[e >> 2] | 0)) {
	                        h = 11;
	                        break
	                    }
	                    if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                        h = 5;
	                        break
	                    }
	                    if ((c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0) < (c[f >> 2] | 0))c[f >> 2] = c[(c[(c[e >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2];
	                    if (!(c[f >> 2] | 0)) {
	                        h = 9;
	                        break
	                    }
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 8 >> 2]
	                }
	                if ((h | 0) == 5) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else if ((h | 0) == 9) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else if ((h | 0) == 11) {
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function SQ(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0) {
	                    while (1) {
	                        if (!(c[e >> 2] | 0)) {
	                            f = 9;
	                            break
	                        }
	                        if (!(c[(c[e >> 2] | 0) + 32 >> 2] | 0)) {
	                            f = 5;
	                            break
	                        }
	                        if (c[(c[e >> 2] | 0) + 16 >> 2] & 256) {
	                            f = 7;
	                            break
	                        }
	                        c[e >> 2] = c[(c[e >> 2] | 0) + 8 >> 2]
	                    }
	                    if ((f | 0) == 5) {
	                        c[d >> 2] = -1;
	                        break
	                    } else if ((f | 0) == 7) {
	                        c[d >> 2] = 1;
	                        break
	                    } else if ((f | 0) == 9) {
	                        c[d >> 2] = 0;
	                        break
	                    }
	                } else c[d >> 2] = -1; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function TQ(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                if (c[c[d >> 2] >> 2] | 0)zP(c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function UQ(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0;
	                g = i;
	                i = i + 80 | 0;
	                h = g + 72 | 0;
	                j = g + 68 | 0;
	                k = g + 64 | 0;
	                l = g + 60 | 0;
	                m = g + 56 | 0;
	                n = g + 52 | 0;
	                o = g + 48 | 0;
	                p = g + 44 | 0;
	                q = g + 40 | 0;
	                r = g + 36 | 0;
	                s = g + 32 | 0;
	                t = g + 28 | 0;
	                u = g + 24 | 0;
	                v = g + 20 | 0;
	                w = g + 16 | 0;
	                x = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[n >> 2] = 0;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 8 >> 2] | 0) >= 0 : 0) {
	                    a:while (1) {
	                        if (!(c[j >> 2] | 0))break;
	                        c[w >> 2] = c[(c[j >> 2] | 0) + 4 >> 2];
	                        if ((c[m >> 2] | 0) == 1 & (c[k >> 2] | 0) == 0 & (c[l >> 2] | 0) == 0) {
	                            c[(c[j >> 2] | 0) + 8 >> 2] = 0;
	                            c[(c[j >> 2] | 0) + 16 >> 2] = 0;
	                            c[(c[j >> 2] | 0) + 28 >> 2] = -1;
	                            do if (c[(c[w >> 2] | 0) + 16 >> 2] & 32768) {
	                                if (!(c[(c[w >> 2] | 0) + 4 >> 2] | 0)) {
	                                    c[n >> 2] = 1;
	                                    break
	                                }
	                                if (((c[(c[w >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[(c[w >> 2] | 0) + 12 >> 2] | 0) + 12 >> 2] | 0) == 100 : 0) ? (c[c[(c[w >> 2] | 0) + 12 >> 2] >> 2] & 1 | 0) != 0 : 0) {
	                                    c[n >> 2] = 1;
	                                    break
	                                }
	                                if ((c[c[(c[w >> 2] | 0) + 12 >> 2] >> 2] & 4 | 0) != 0 ? (c[q >> 2] = cR(c[j >> 2] | 0, 0, 0) | 0, (c[q >> 2] | 0) < 0) : 0)c[o >> 2] = (c[o >> 2] | 0) + 1
	                            } while (0);
	                            c[j >> 2] = c[c[j >> 2] >> 2];
	                            continue
	                        }
	                        f = c[j >> 2] | 0;
	                        b:do if (c[(c[w >> 2] | 0) + 4 >> 2] | 0) {
	                            if ((c[f + 28 >> 2] | 0) != -1) {
	                                e = (c[j >> 2] | 0) + 16 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                break
	                            }
	                            if ((c[m >> 2] | 0) != 1 & (c[m >> 2] | 0) != 2 ? (c[(c[w >> 2] | 0) + 16 >> 2] & 16384 | 0) == 0 : 0) {
	                                e = (c[j >> 2] | 0) + 16 | 0;
	                                c[e >> 2] = (c[e >> 2] | 0) + 1;
	                                break
	                            }
	                            c[r >> 2] = 0;
	                            c[s >> 2] = c[(c[j >> 2] | 0) + 8 >> 2];
	                            while (1) {
	                                if ((c[r >> 2] | 0) >= (c[s >> 2] | 0))break;
	                                if (c[(c[w >> 2] | 0) + 16 >> 2] & 65536) {
	                                    c[u >> 2] = c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + (c[r >> 2] << 1 << 2) >> 2];
	                                    if (((c[u >> 2] | 0) >= 0 ? (c[q >> 2] = c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + ((c[r >> 2] << 1) + 1 << 2) >> 2], (c[q >> 2] | 0) <= (c[(c[j >> 2] | 0) + 16 >> 2] | 0)) : 0) ? (c[v >> 2] = c[(c[(c[w >> 2] | 0) + 12 >> 2] | 0) + (c[u >> 2] << 4) >> 2] & 1, (c[v >> 2] | 0) != 0 ? 1 : (c[q >> 2] | 0) >= (c[(c[j >> 2] | 0) + 16 >> 2] | 0)) : 0)y = 39
	                                } else {
	                                    c[u >> 2] = c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 8 >> 2] | 0) - 1 << 1 << 2) >> 2];
	                                    if ((c[(c[(c[j >> 2] | 0) + 20 >> 2] | 0) + (((c[(c[j >> 2] | 0) + 8 >> 2] | 0) - 1 << 1) + 1 << 2) >> 2] | 0) < (c[(c[j >> 2] | 0) + 16 >> 2] | 0)) {
	                                        y = 34;
	                                        break a
	                                    }
	                                    c[v >> 2] = 0;
	                                    c[r >> 2] = c[s >> 2];
	                                    y = 39
	                                }
	                                c:do if ((y | 0) == 39) {
	                                    y = 0;
	                                    e = (c[(c[w >> 2] | 0) + 12 >> 2] | 0) + (c[u >> 2] << 4) | 0;
	                                    c[x + 0 >> 2] = c[e + 0 >> 2];
	                                    c[x + 4 >> 2] = c[e + 4 >> 2];
	                                    c[x + 8 >> 2] = c[e + 8 >> 2];
	                                    c[x + 12 >> 2] = c[e + 12 >> 2];
	                                    do if ((c[x + 12 >> 2] | 0) != (c[m >> 2] | 0)) {
	                                        if ((c[x + 12 >> 2] | 0) != 2)if ((c[x + 12 >> 2] | 0) != 100)break c; else break;
	                                        if (c[(c[w >> 2] | 0) + 16 >> 2] & 65536)break c;
	                                        c[(c[j >> 2] | 0) + 28 >> 2] = (c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 1;
	                                        break c
	                                    } while (0);
	                                    c[t >> 2] = 0;
	                                    do if ((c[x + 12 >> 2] | 0) != 100) {
	                                        e = c[x + 8 >> 2] | 0;
	                                        if (!(c[x + 4 >> 2] | 0)) {
	                                            if (!e) {
	                                                c[t >> 2] = 1;
	                                                break
	                                            }
	                                            if (!(c[l >> 2] | 0))break;
	                                            c[t >> 2] = qy(c[x + 8 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                            break
	                                        }
	                                        if (((c[k >> 2] | 0) != 0 ? ((e | 0) != 0 | 0) == ((c[l >> 2] | 0) != 0 | 0) : 0) ? (d[c[x + 4 >> 2] >> 0] | 0 | 0) == (d[c[k >> 2] >> 0] | 0 | 0) : 0) {
	                                            if (!(qy(c[x + 4 >> 2] | 0, c[k >> 2] | 0) | 0))break;
	                                            if ((c[x + 8 >> 2] | 0) != (c[l >> 2] | 0) ? (qy(c[x + 8 >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0)break;
	                                            c[t >> 2] = 1
	                                        }
	                                    } else c[t >> 2] = 1; while (0);
	                                    do if (c[t >> 2] | 0) {
	                                        c[p >> 2] = c[x >> 2] & 2;
	                                        e = (c[p >> 2] | 0) != 0;
	                                        do if (c[v >> 2] | 0)if (e) {
	                                            c[n >> 2] = 1;
	                                            break
	                                        } else {
	                                            cR(c[j >> 2] | 0, (c[u >> 2] | 0) + 1 | 0, (c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 1 | 0) | 0;
	                                            break
	                                        } else if (e) {
	                                            c[n >> 2] = 1;
	                                            break
	                                        } else {
	                                            cR(c[j >> 2] | 0, (c[u >> 2] | 0) + 1 | 0, (c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 1 | 0) | 0;
	                                            break
	                                        } while (0);
	                                        if ((c[n >> 2] | 0) != 1) {
	                                            if (!(c[x >> 2] & 32))break;
	                                            c[n >> 2] = 1
	                                        }
	                                    } while (0);
	                                    if ((c[(c[w >> 2] | 0) + 16 >> 2] & 65536 | 0) == 0 ? (c[t >> 2] | 0) == 0 | (c[p >> 2] | 0) != 0 : 0)c[(c[j >> 2] | 0) + 28 >> 2] = (c[(c[j >> 2] | 0) + 16 >> 2] | 0) + 1
	                                } while (0);
	                                c[r >> 2] = (c[r >> 2] | 0) + 1
	                            }
	                            e = (c[j >> 2] | 0) + 16 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1;
	                            e = c[(c[w >> 2] | 0) + 12 >> 2] | 0;
	                            c[x + 0 >> 2] = c[e + 0 >> 2];
	                            c[x + 4 >> 2] = c[e + 4 >> 2];
	                            c[x + 8 >> 2] = c[e + 8 >> 2];
	                            c[x + 12 >> 2] = c[e + 12 >> 2];
	                            if (!(c[x >> 2] & 4)) {
	                                c[v >> 2] = c[x >> 2] & 1;
	                                do if (c[(c[j >> 2] | 0) + 24 >> 2] & 7) {
	                                    if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) == 1)if (c[(c[j >> 2] | 0) + 24 >> 2] & 6)break b; else break;
	                                    if (!(c[v >> 2] | 0)) {
	                                        if ((c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 2)break b;
	                                        if (!(c[(c[j >> 2] | 0) + 24 >> 2] & 6))break b
	                                    }
	                                } while (0);
	                                if ((c[x + 12 >> 2] | 0) != (c[m >> 2] | 0)) {
	                                    if ((c[m >> 2] | 0) == 2)break;
	                                    if ((c[x + 12 >> 2] | 0) != 100)break
	                                }
	                                c[t >> 2] = 0;
	                                do if ((c[x + 12 >> 2] | 0) != 100) {
	                                    e = c[x + 8 >> 2] | 0;
	                                    if (!(c[x + 4 >> 2] | 0)) {
	                                        if (!e) {
	                                            c[t >> 2] = 1;
	                                            break
	                                        }
	                                        if (!(c[l >> 2] | 0))break;
	                                        c[t >> 2] = qy(c[x + 8 >> 2] | 0, c[l >> 2] | 0) | 0;
	                                        break
	                                    }
	                                    if ((((c[k >> 2] | 0) != 0 ? ((e | 0) != 0 | 0) == ((c[l >> 2] | 0) != 0 | 0) : 0) ? (d[c[x + 4 >> 2] >> 0] | 0 | 0) == (d[c[k >> 2] >> 0] | 0 | 0) : 0) ? (qy(c[x + 4 >> 2] | 0, c[k >> 2] | 0) | 0) != 0 : 0) {
	                                        if ((c[x + 8 >> 2] | 0) != (c[l >> 2] | 0) ? (qy(c[x + 8 >> 2] | 0, c[l >> 2] | 0) | 0) == 0 : 0)break;
	                                        c[t >> 2] = 1
	                                    }
	                                } else c[t >> 2] = 1; while (0);
	                                c[p >> 2] = c[x >> 2] & 2;
	                                if (c[t >> 2] | 0) {
	                                    if (c[p >> 2] | 0)c[n >> 2] = 1; else cR(c[j >> 2] | 0, 1, c[(c[j >> 2] | 0) + 16 >> 2] | 0) | 0;
	                                    if ((c[n >> 2] | 0) != 1 ? (c[x >> 2] & 32 | 0) != 0 : 0)c[n >> 2] = 1
	                                }
	                                if ((c[(c[w >> 2] | 0) + 16 >> 2] & 65536 | 0) == 0 ? (c[t >> 2] | 0) == 0 | (c[p >> 2] | 0) != 0 : 0)c[(c[j >> 2] | 0) + 28 >> 2] = c[(c[j >> 2] | 0) + 16 >> 2]
	                            }
	                        } else {
	                            if (c[f + 24 >> 2] & 1) {
	                                c[j >> 2] = c[c[j >> 2] >> 2];
	                                continue a
	                            }
	                            do if ((c[m >> 2] | 0) != 2) {
	                                if ((c[(c[j >> 2] | 0) + 24 >> 2] & 7 | 0) != 0 ? (c[(c[j >> 2] | 0) + 16 >> 2] | 0) != 0 : 0)break;
	                                c[n >> 2] = 1
	                            } while (0);
	                            e = (c[j >> 2] | 0) + 16 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + 1
	                        } while (0);
	                        c[j >> 2] = c[c[j >> 2] >> 2]
	                    }
	                    if ((y | 0) == 34) {
	                        c[h >> 2] = -1;
	                        z = c[h >> 2] | 0;
	                        i = g;
	                        return z | 0
	                    }
	                    if ((c[o >> 2] | 0) > 0)c[n >> 2] = -1;
	                    c[h >> 2] = c[n >> 2];
	                    z = c[h >> 2] | 0;
	                    i = g;
	                    return z | 0
	                }
	                c[h >> 2] = -1;
	                z = c[h >> 2] | 0;
	                i = g;
	                return z | 0
	            }

	            function VQ(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                if (!(c[g >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[k >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                d = c[k >> 2] | 0;
	                c[d + 0 >> 2] = 0;
	                c[d + 4 >> 2] = 0;
	                c[d + 8 >> 2] = 0;
	                c[d + 12 >> 2] = 0;
	                c[d + 16 >> 2] = 0;
	                c[d + 20 >> 2] = 0;
	                c[d + 24 >> 2] = 0;
	                c[d + 28 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 12 >> 2] = c[h >> 2];
	                c[c[k >> 2] >> 2] = c[g >> 2];
	                c[(c[k >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                if (c[j >> 2] | 0) {
	                    c[l >> 2] = 0;
	                    while (1) {
	                        n = c[l >> 2] | 0;
	                        if (!(c[(c[j >> 2] | 0) + (c[l >> 2] << 1 << 2) >> 2] | 0))break;
	                        c[l >> 2] = n + 1
	                    }
	                    c[(c[k >> 2] | 0) + 28 >> 2] = n
	                } else c[(c[k >> 2] | 0) + 28 >> 2] = 0;
	                c[(c[k >> 2] | 0) + 24 >> 2] = c[j >> 2];
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function WQ() {
	                var a = 0, b = 0, d = 0, e = 0, f = 0, g = 0;
	                a = i;
	                i = i + 16 | 0;
	                b = a + 4 | 0;
	                d = a;
	                c[d >> 2] = Cb[c[135744 >> 2] & 511](36) | 0;
	                if (!(c[d >> 2] | 0)) {
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                f = (c[d >> 2] | 0) + 0 | 0;
	                g = f + 36 | 0;
	                do {
	                    c[f >> 2] = 0;
	                    f = f + 4 | 0
	                } while ((f | 0) < (g | 0));
	                c[(c[d >> 2] | 0) + 24 >> 2] = 10;
	                f = Cb[c[135744 >> 2] & 511]((c[(c[d >> 2] | 0) + 24 >> 2] | 0) * 12 | 0) | 0;
	                c[(c[d >> 2] | 0) + 28 >> 2] = f;
	                if (!(c[(c[d >> 2] | 0) + 28 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[b >> 2] = 0;
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                } else {
	                    c[b >> 2] = c[d >> 2];
	                    e = c[b >> 2] | 0;
	                    i = a;
	                    return e | 0
	                }
	                return 0
	            }

	            function XQ(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)f = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            f = 1;
	                            break
	                        }
	                        f = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    g = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!f)break;
	                    a = c[e >> 2] | 0;
	                    if (!g)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                a:do if ((g | 0) != 47) {
	                    f = (c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 | 0;
	                    c[f >> 2] = c[f >> 2] | 512;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46) {
	                        f = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)h = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    h = 1;
	                                    break
	                                }
	                                h = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            j = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                            if (!h)break;
	                            f = c[e >> 2] | 0;
	                            if (!j)continue;
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        f = c[e >> 2] | 0;
	                        if (!j) {
	                            if (dR(f, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 2, 0, 0) | 0)break;
	                            i = b;
	                            return
	                        }
	                        if ((d[c[f >> 2] >> 0] | 0 | 0) != 47)break;
	                        f = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)k = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    k = 1;
	                                    break
	                                }
	                                k = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            l = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                            if (!k)break;
	                            f = c[e >> 2] | 0;
	                            if (!l)continue;
	                            c[f >> 2] = (c[f >> 2] | 0) + 1
	                        }
	                        b:do if ((l | 0) == 47) {
	                            if ((d[(c[c[e >> 2] >> 2] | 0) + -1 >> 0] | 0 | 0) == 32)break a;
	                            if (9 <= (d[(c[c[e >> 2] >> 2] | 0) + -1 >> 0] | 0 | 0) ? (d[(c[c[e >> 2] >> 2] | 0) + -1 >> 0] | 0 | 0) <= 10 : 0)break a;
	                            if ((d[(c[c[e >> 2] >> 2] | 0) + -1 >> 0] | 0 | 0) == 13)break a;
	                            if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 6, 0, 0) | 0)break a;
	                            f = c[e >> 2] | 0;
	                            if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                            while (1) {
	                                do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                                    if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                                } while (0);
	                                f = c[e >> 2] | 0;
	                                if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                        } while (0);
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)m = 47
	                    } else m = 47;
	                    c:do if ((m | 0) == 47) {
	                        while (1) {
	                            m = 0;
	                            eR(c[e >> 2] | 0);
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0)break a;
	                            while (1) {
	                                do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)n = 1; else {
	                                    if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        n = 1;
	                                        break
	                                    }
	                                    n = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                o = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                                if (!n)break;
	                                f = c[e >> 2] | 0;
	                                if (!o)continue;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                            if ((o | 0) != 47)break;
	                            if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 5, 0, 0) | 0)break a;
	                            f = c[e >> 2] | 0;
	                            if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                            while (1) {
	                                do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)p = 1; else {
	                                    if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        p = 1;
	                                        break
	                                    }
	                                    p = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                q = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                                if (!p)break;
	                                f = c[e >> 2] | 0;
	                                if (!q)continue;
	                                c[f >> 2] = (c[f >> 2] | 0) + 1
	                            }
	                            if ((q | 0) == 47)break a;
	                            if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))break c;
	                            if (d[c[c[e >> 2] >> 2] >> 0] | 0)m = 47; else break
	                        }
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0)) {
	                            i = b;
	                            return
	                        }
	                        c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                        i = b;
	                        return
	                    } while (0);
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                    i = b;
	                    return
	                } while (0);
	                c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                i = b;
	                return
	            }

	            function YQ(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                c[e >> 2] = a;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)f = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            f = 1;
	                            break
	                        }
	                        f = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    g = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!f)break;
	                    a = c[e >> 2] | 0;
	                    if (!g)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                f = c[e >> 2] | 0;
	                do if ((g | 0) == 47) {
	                    a = (c[f + 16 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = c[a >> 2] | 256
	                } else {
	                    if ((d[c[f >> 2] >> 0] | 0 | 0) != 46 ? (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 2] & 7 | 0) == 0 : 0)break;
	                    a = (c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 | 0;
	                    c[a >> 2] = c[a >> 2] | 512
	                } while (0);
	                if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 47 ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) {
	                    if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 6, 0, 0) | 0) {
	                        i = b;
	                        return
	                    }
	                    f = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                    f = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1
	                } else h = 21;
	                if ((((h | 0) == 21 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 46 : 0) ? (d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) == 47 : 0) ? (d[(c[c[e >> 2] >> 2] | 0) + 2 >> 0] | 0 | 0) == 47 : 0) {
	                    if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 6, 0, 0) | 0) {
	                        i = b;
	                        return
	                    }
	                    f = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                    f = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                    f = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[f >> 2] = (c[f >> 2] | 0) + 1;
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)j = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                j = 1;
	                                break
	                            }
	                            j = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        k = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                        if (!j)break;
	                        f = c[e >> 2] | 0;
	                        if (!k)continue;
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    if (!k) {
	                        c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                        i = b;
	                        return
	                    }
	                }
	                k = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                a:do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 64) {
	                    j = c[e >> 2] | 0;
	                    if (k)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                    fR(c[e >> 2] | 0);
	                    while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                l = 1;
	                                break
	                            }
	                            l = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                        } while (0);
	                        m = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 0;
	                        if (!l)break;
	                        j = c[e >> 2] | 0;
	                        if (!m)continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    if (m ? (eR(c[e >> 2] | 0), (c[(c[e >> 2] | 0) + 8 >> 2] | 0) != 0) : 0) {
	                        i = b;
	                        return
	                    }
	                } else {
	                    if ((k | 0) == 47) {
	                        if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 1, 0, 0) | 0) {
	                            i = b;
	                            return
	                        }
	                        j = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)n = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    n = 1;
	                                    break
	                                }
	                                n = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            o = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                            if (!n)break;
	                            j = c[e >> 2] | 0;
	                            if (!o)continue;
	                            c[j >> 2] = (c[j >> 2] | 0) + 1
	                        }
	                        if (!o) {
	                            c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                            i = b;
	                            return
	                        }
	                    }
	                    eR(c[e >> 2] | 0);
	                    if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                        i = b;
	                        return
	                    }
	                    b:while (1) {
	                        do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                        } while (0);
	                        j = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    }
	                    while (1) {
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 47)break a;
	                        j = c[e >> 2] | 0;
	                        f = c[(c[e >> 2] | 0) + 16 >> 2] | 0;
	                        if ((d[(c[c[e >> 2] >> 2] | 0) + 1 >> 0] | 0 | 0) != 47) {
	                            if (dR(j, f, 5, 0, 0) | 0) {
	                                h = 103;
	                                break
	                            }
	                            g = c[e >> 2] | 0;
	                            if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                            while (1) {
	                                do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)p = 1; else {
	                                    if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                        p = 1;
	                                        break
	                                    }
	                                    p = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                                } while (0);
	                                q = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                                if (!p)break;
	                                g = c[e >> 2] | 0;
	                                if (!q)continue;
	                                c[g >> 2] = (c[g >> 2] | 0) + 1
	                            }
	                            r = c[e >> 2] | 0;
	                            if (!q) {
	                                h = 99;
	                                break
	                            }
	                            eR(r);
	                            if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                                h = 103;
	                                break
	                            } else continue
	                        }
	                        if (dR(j, f, 6, 0, 0) | 0) {
	                            h = 103;
	                            break
	                        }
	                        g = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        g = c[e >> 2] | 0;
	                        if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[g >> 2] = (c[g >> 2] | 0) + 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)s = 1; else {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                                    s = 1;
	                                    break
	                                }
	                                s = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                            } while (0);
	                            t = c[e >> 2] | 0;
	                            if (!s)break;
	                            g = c[e >> 2] | 0;
	                            if (!(d[c[t >> 2] >> 0] | 0))continue;
	                            c[g >> 2] = (c[g >> 2] | 0) + 1
	                        }
	                        eR(t);
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0) {
	                            h = 103;
	                            break
	                        }
	                    }
	                    if ((h | 0) == 99) {
	                        c[r + 8 >> 2] = 1;
	                        i = b;
	                        return
	                    } else if ((h | 0) == 103) {
	                        i = b;
	                        return
	                    }
	                } while (0);
	                if (!(d[c[c[e >> 2] >> 2] >> 0] | 0)) {
	                    i = b;
	                    return
	                }
	                c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                i = b;
	                return
	            }

	            function ZQ(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                a = c[d >> 2] | 0;
	                c[a + 0 >> 2] = -1;
	                c[a + 4 >> 2] = -1;
	                c[a + 8 >> 2] = -1;
	                c[a + 12 >> 2] = -1;
	                c[a + 16 >> 2] = -1;
	                c[a + 20 >> 2] = -1;
	                c[a + 24 >> 2] = -1;
	                c[a + 28 >> 2] = -1;
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function _Q(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                b = i;
	                i = i + 48 | 0;
	                d = b + 40 | 0;
	                e = b + 36 | 0;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b;
	                c[e >> 2] = a;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = -1;
	                if ((c[e >> 2] | 0) != 0 ? (c[(c[e >> 2] | 0) + 28 >> 2] | 0) != 0 : 0) {
	                    if ((((c[(c[e >> 2] | 0) + 20 >> 2] | 0) == 1 ? (c[c[(c[e >> 2] | 0) + 28 >> 2] >> 2] | 0) == 2 : 0) ? (c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0) ? (c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + 8 >> 2] | 0) == 0 : 0) {
	                        c[f >> 2] = gR(0) | 0;
	                        if (!(c[f >> 2] | 0)) {
	                            c[d >> 2] = -1;
	                            n = c[d >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        } else {
	                            a = (c[f >> 2] | 0) + 16 | 0;
	                            c[a >> 2] = c[a >> 2] | 16384;
	                            c[(c[e >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                            c[d >> 2] = 0;
	                            n = c[d >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        }
	                    }
	                    c[f >> 2] = gR(((c[(c[e >> 2] | 0) + 20 >> 2] | 0) / 2 | 0) + 1 | 0) | 0;
	                    if (!(c[f >> 2] | 0)) {
	                        c[d >> 2] = -1;
	                        n = c[d >> 2] | 0;
	                        i = b;
	                        return n | 0
	                    }
	                    if (c[(c[e >> 2] | 0) + 4 >> 2] | 0) {
	                        c[c[f >> 2] >> 2] = c[(c[e >> 2] | 0) + 4 >> 2];
	                        yP(c[c[f >> 2] >> 2] | 0) | 0
	                    }
	                    c[g >> 2] = 0;
	                    if (c[(c[e >> 2] | 0) + 16 >> 2] & 256) {
	                        a = (c[f >> 2] | 0) + 16 | 0;
	                        c[a >> 2] = c[a >> 2] | 32768
	                    }
	                    a:while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[e >> 2] | 0) + 20 >> 2] | 0)) {
	                            o = 43;
	                            break
	                        }
	                        a = (c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) | 0;
	                        c[m + 0 >> 2] = c[a + 0 >> 2];
	                        c[m + 4 >> 2] = c[a + 4 >> 2];
	                        c[m + 8 >> 2] = c[a + 8 >> 2];
	                        b:do switch (c[m >> 2] | 0) {
	                            case 1:
	                            {
	                                if (c[g >> 2] | 0)break a;
	                                c[j >> 2] = 1;
	                                break
	                            }
	                            case 2:
	                            {
	                                if ((c[m + 4 >> 2] | 0) == 0 ? (c[m + 8 >> 2] | 0) == 0 : 0) {
	                                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) != ((c[g >> 2] | 0) + 1 | 0))break b;
	                                    if (!(c[k >> 2] & 1))break b;
	                                    if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) == ((c[g >> 2] | 0) + 1 | 0)) {
	                                        a = (c[f >> 2] | 0) + 16 | 0;
	                                        c[a >> 2] = c[a >> 2] | 16384
	                                    }
	                                    c[k >> 2] = c[k >> 2] | 16;
	                                    c[h >> 2] = hR(c[f >> 2] | 0, 0, 0, 100, c[k >> 2] | 0) | 0;
	                                    if ((c[h >> 2] | 0) < 0)break a;
	                                    c[k >> 2] = 0;
	                                    if ((c[l >> 2] | 0) == -1)break b;
	                                    a = (c[(c[f >> 2] | 0) + 12 >> 2] | 0) + (c[l >> 2] << 4) | 0;
	                                    c[a >> 2] = c[a >> 2] | 32;
	                                    c[l >> 2] = -1;
	                                    break b
	                                }
	                                c[h >> 2] = hR(c[f >> 2] | 0, c[m + 4 >> 2] | 0, c[m + 8 >> 2] | 0, 1, c[k >> 2] | 0) | 0;
	                                if ((c[h >> 2] | 0) < 0)break a;
	                                c[l >> 2] = c[h >> 2];
	                                c[k >> 2] = 0;
	                                break
	                            }
	                            case 6:
	                            {
	                                if ((c[k >> 2] & 1 | 0) == 0 ? (c[k >> 2] = c[k >> 2] | 1, (c[(c[f >> 2] | 0) + 16 >> 2] & 65536 | 0) == 0) : 0) {
	                                    a = (c[f >> 2] | 0) + 16 | 0;
	                                    c[a >> 2] = c[a >> 2] | 65536
	                                }
	                                break
	                            }
	                            case 4:
	                            {
	                                c[k >> 2] = c[k >> 2] | 8;
	                                c[l >> 2] = -1;
	                                c[h >> 2] = hR(c[f >> 2] | 0, c[m + 4 >> 2] | 0, c[m + 8 >> 2] | 0, 2, c[k >> 2] | 0) | 0;
	                                c[k >> 2] = 0;
	                                if ((c[h >> 2] | 0) < 0)break a;
	                                break
	                            }
	                            case 8:
	                            {
	                                c[h >> 2] = hR(c[f >> 2] | 0, 0, 0, 1, c[k >> 2] | 0) | 0;
	                                if ((c[h >> 2] | 0) < 0)break a;
	                                c[l >> 2] = c[h >> 2];
	                                c[k >> 2] = 0;
	                                break
	                            }
	                            case 7:
	                            {
	                                c[h >> 2] = hR(c[f >> 2] | 0, 0, c[m + 4 >> 2] | 0, 1, c[k >> 2] | 0) | 0;
	                                if ((c[h >> 2] | 0) < 0)break a;
	                                c[l >> 2] = c[h >> 2];
	                                c[k >> 2] = 0;
	                                break
	                            }
	                            case 3:
	                            {
	                                c[h >> 2] = hR(c[f >> 2] | 0, c[m + 4 >> 2] | 0, c[m + 8 >> 2] | 0, 1, c[k >> 2] | 0) | 0;
	                                if ((c[h >> 2] | 0) < 0)break a;
	                                c[l >> 2] = c[h >> 2];
	                                c[k >> 2] = 0;
	                                break
	                            }
	                            default:
	                            {
	                            }
	                        } while (0);
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    if ((o | 0) == 43) {
	                        if ((c[j >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 16 >> 2] & 7 | 0) == 0 : 0) {
	                            if (!(c[(c[f >> 2] | 0) + 16 >> 2] & 65536)) {
	                                o = (c[f >> 2] | 0) + 16 | 0;
	                                c[o >> 2] = c[o >> 2] | 65536
	                            }
	                            if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) > 0 ? (c[c[(c[f >> 2] | 0) + 12 >> 2] >> 2] & 1 | 0) == 0 : 0) {
	                                o = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                                c[o >> 2] = c[o >> 2] | 1
	                            }
	                        }
	                        if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) > (c[h >> 2] | 0)) {
	                            o = (c[(c[f >> 2] | 0) + 12 >> 2] | 0) + (c[h >> 2] << 4) | 0;
	                            c[o >> 2] = c[o >> 2] | 2;
	                            if (c[j >> 2] | 0) {
	                                j = c[(c[f >> 2] | 0) + 12 >> 2] | 0;
	                                c[j >> 2] = c[j >> 2] | 4
	                            }
	                            c[(c[e >> 2] | 0) + 32 >> 2] = c[f >> 2];
	                            c[d >> 2] = 0;
	                            n = c[d >> 2] | 0;
	                            i = b;
	                            return n | 0
	                        }
	                    }
	                    TQ(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    n = c[d >> 2] | 0;
	                    i = b;
	                    return n | 0
	                }
	                c[d >> 2] = -1;
	                n = c[d >> 2] | 0;
	                i = b;
	                return n | 0
	            }

	            function $Q(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                b = i;
	                i = i + 32 | 0;
	                d = b + 24 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) > 0 ? (c[c[(c[e >> 2] | 0) + 28 >> 2] >> 2] | 0) == 6 : 0) {
	                    c[f >> 2] = 0;
	                    c[g >> 2] = 1;
	                    while (1) {
	                        if ((c[g >> 2] | 0) >= (c[(c[e >> 2] | 0) + 20 >> 2] | 0))break;
	                        c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) + 4 >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) + 4 >> 2];
	                        c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) + 8 >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) + 8 >> 2];
	                        c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) >> 2];
	                        c[f >> 2] = (c[f >> 2] | 0) + 1;
	                        c[g >> 2] = (c[g >> 2] | 0) + 1
	                    }
	                    a = (c[e >> 2] | 0) + 20 | 0;
	                    c[a >> 2] = (c[a >> 2] | 0) + -1
	                }
	                do if ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) >= (c[(c[e >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[h >> 2] = Hb[c[135760 >> 2] & 511](c[(c[e >> 2] | 0) + 28 >> 2] | 0, (c[(c[e >> 2] | 0) + 24 >> 2] << 1) * 12 | 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[(c[e >> 2] | 0) + 28 >> 2] = c[h >> 2];
	                        a = (c[e >> 2] | 0) + 24 | 0;
	                        c[a >> 2] = c[a >> 2] << 1;
	                        break
	                    }
	                    c[d >> 2] = -1;
	                    l = c[d >> 2] | 0;
	                    i = b;
	                    return l | 0
	                } while (0);
	                c[f >> 2] = 0;
	                c[g >> 2] = (c[(c[e >> 2] | 0) + 20 >> 2] | 0) - 1;
	                while (1) {
	                    if ((c[g >> 2] | 0) <= (c[f >> 2] | 0))break;
	                    c[j >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) + 4 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) + 4 >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) + 4 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) + 4 >> 2] = c[j >> 2];
	                    c[j >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) + 8 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) + 8 >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) + 8 >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) + 8 >> 2] = c[j >> 2];
	                    c[k >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[f >> 2] | 0) * 12 | 0) >> 2] = c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) >> 2];
	                    c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[g >> 2] | 0) * 12 | 0) >> 2] = c[k >> 2];
	                    c[g >> 2] = (c[g >> 2] | 0) + -1;
	                    c[f >> 2] = (c[f >> 2] | 0) + 1
	                }
	                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) * 12 | 0) + 4 >> 2] = 0;
	                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[e >> 2] | 0) + 20 >> 2] | 0) * 12 | 0) + 8 >> 2] = 0;
	                f = (c[e >> 2] | 0) + 20 | 0;
	                g = c[f >> 2] | 0;
	                c[f >> 2] = g + 1;
	                c[(c[(c[e >> 2] | 0) + 28 >> 2] | 0) + (g * 12 | 0) >> 2] = 0;
	                c[d >> 2] = 0;
	                l = c[d >> 2] | 0;
	                i = b;
	                return l | 0
	            }

	            function aR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 32 | 0;
	                g = e + 28 | 0;
	                h = e + 24 | 0;
	                j = e + 20 | 0;
	                k = e + 16 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[l + 0 >> 2] = 0;
	                c[l + 4 >> 2] = 0;
	                c[l + 8 >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0) {
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                c[j >> 2] = 0;
	                a:while (1) {
	                    if ((c[j >> 2] | 0) >= (c[(c[g >> 2] | 0) + 20 >> 2] | 0)) {
	                        o = 84;
	                        break
	                    }
	                    c[k >> 2] = (c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[j >> 2] | 0) * 12 | 0);
	                    b:do switch (c[c[k >> 2] >> 2] | 0) {
	                        case 8:
	                        {
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1)o = 83;
	                            break
	                        }
	                        case 3:
	                        {
	                            if ((((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 21 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 13 : 0)break b;
	                            c[m >> 2] = c[(c[h >> 2] | 0) + 12 >> 2];
	                            if (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                                while (1) {
	                                    if (!(c[m >> 2] | 0))break;
	                                    if (((c[(c[m >> 2] | 0) + 4 >> 2] | 0) == 1 ? (d[c[(c[k >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == (d[c[(c[m >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) : 0) ? (qy(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[m >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break;
	                                    c[m >> 2] = c[(c[m >> 2] | 0) + 24 >> 2]
	                                }
	                                if (c[m >> 2] | 0)o = 83
	                            }
	                            break
	                        }
	                        case 2:
	                        {
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1)if (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                                if ((d[c[(c[k >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == (d[c[(c[h >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) ? (qy(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) {
	                                    if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0))if (c[(c[k >> 2] | 0) + 8 >> 2] | 0)break b; else {
	                                        o = 83;
	                                        break b
	                                    }
	                                    if (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) {
	                                        if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)o = 83
	                                    } else o = 83
	                                }
	                            } else o = 83;
	                            break
	                        }
	                        case 5:
	                        {
	                            if (((((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 21 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) ? (c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2], (c[h >> 2] | 0) != 0) : 0)if (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                                if ((d[c[(c[k >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == (d[c[(c[h >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) ? (qy(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) {
	                                    if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0))if (c[(c[k >> 2] | 0) + 8 >> 2] | 0)break b; else {
	                                        o = 83;
	                                        break b
	                                    }
	                                    if (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) {
	                                        if ((c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)o = 83
	                                    } else o = 83
	                                }
	                            } else o = 83;
	                            break
	                        }
	                        case 6:
	                        {
	                            if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0)) {
	                                c[j >> 2] = (c[j >> 2] | 0) + 1;
	                                c[k >> 2] = (c[(c[g >> 2] | 0) + 28 >> 2] | 0) + ((c[j >> 2] | 0) * 12 | 0);
	                                if ((c[c[k >> 2] >> 2] | 0) == 1) {
	                                    o = 84;
	                                    break a
	                                }
	                                if ((c[c[k >> 2] >> 2] | 0) != 2)break b;
	                                if (!(c[(c[k >> 2] | 0) + 4 >> 2] | 0)) {
	                                    o = 55;
	                                    break a
	                                }
	                            }
	                            if (((((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 21 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18 : 0) {
	                                c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                                c:while (1) {
	                                    if (!(c[h >> 2] | 0))break;
	                                    do if (((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1 ? (d[c[(c[k >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) == (d[c[(c[h >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) : 0) ? (qy(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0) {
	                                        if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0))if (!(c[(c[k >> 2] | 0) + 8 >> 2] | 0))break c; else break;
	                                        if (((c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)break c
	                                    } while (0);
	                                    c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2]
	                                }
	                                if (c[h >> 2] | 0) {
	                                    b = c[j >> 2] | 0;
	                                    if ((c[c[k >> 2] >> 2] | 0) == 6) {
	                                        iR(l, b, c[h >> 2] | 0) | 0;
	                                        o = 83;
	                                        break b
	                                    } else {
	                                        iR(l, b - 1 | 0, c[h >> 2] | 0) | 0;
	                                        o = 83;
	                                        break b
	                                    }
	                                }
	                            }
	                            break
	                        }
	                        case 1:
	                        {
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                                c[h >> 2] = c[(c[h >> 2] | 0) + 20 >> 2];
	                                if (!(((c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 21 : 0) ? (c[(c[h >> 2] | 0) + 4 >> 2] | 0) != 13 : 0))o = 83
	                            }
	                            break
	                        }
	                        case 4:
	                        {
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 2) {
	                                if (c[(c[k >> 2] | 0) + 4 >> 2] | 0) {
	                                    if ((d[c[(c[k >> 2] | 0) + 4 >> 2] >> 0] | 0 | 0) != (d[c[(c[h >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0))break b;
	                                    if (!(qy(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[h >> 2] | 0) + 8 >> 2] | 0) | 0))break b
	                                }
	                                b = (c[(c[k >> 2] | 0) + 8 >> 2] | 0) != 0;
	                                if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0))if (b)break b; else {
	                                    o = 83;
	                                    break b
	                                }
	                                if (!(b ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) == 0 : 0))o = 83
	                            }
	                            break
	                        }
	                        case 7:
	                        {
	                            if ((c[(c[h >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                if (!(c[(c[h >> 2] | 0) + 36 >> 2] | 0))if (c[(c[k >> 2] | 0) + 4 >> 2] | 0)break b; else {
	                                    o = 83;
	                                    break b
	                                }
	                                if (c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) {
	                                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 0 ? (qy(c[(c[k >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[h >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0) | 0) != 0 : 0)o = 83
	                                } else o = 83
	                            }
	                            break
	                        }
	                        case 0:
	                        {
	                            o = 84;
	                            break a;
	                            break
	                        }
	                        default:
	                            o = 83
	                    } while (0);
	                    if ((o | 0) == 83) {
	                        o = 0;
	                        c[j >> 2] = (c[j >> 2] | 0) + 1;
	                        continue
	                    }
	                    if (!(c[l + 8 >> 2] | 0)) {
	                        o = 88;
	                        break
	                    }
	                    if ((c[l >> 2] | 0) <= 0) {
	                        o = 90;
	                        break
	                    }
	                    c[l >> 2] = (c[l >> 2] | 0) + -1;
	                    c[j >> 2] = c[(c[l + 8 >> 2] | 0) + (c[l >> 2] << 3) >> 2];
	                    c[h >> 2] = c[(c[l + 8 >> 2] | 0) + (c[l >> 2] << 3) + 4 >> 2]
	                }
	                if ((o | 0) == 55) {
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((o | 0) == 84) {
	                    if (c[l + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[l + 8 >> 2] | 0);
	                    c[f >> 2] = 1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((o | 0) == 88) {
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } else if ((o | 0) == 90) {
	                    zb[c[135736 >> 2] & 511](c[l + 8 >> 2] | 0);
	                    c[f >> 2] = 0;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                return 0
	            }

	            function bR(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](32) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                c[a + 12 >> 2] = 0;
	                c[a + 16 >> 2] = 0;
	                c[a + 20 >> 2] = 0;
	                c[a + 24 >> 2] = 0;
	                c[a + 28 >> 2] = 0;
	                a = Cb[c[135744 >> 2] & 511](32) | 0;
	                c[(c[f >> 2] | 0) + 20 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 20 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 8 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 12 >> 2] = 4;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 4 >> 2] = c[e >> 2];
	                    c[(c[f >> 2] | 0) + 28 >> 2] = -1;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function cR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                while (1) {
	                    if ((c[k >> 2] | 0) >= (c[(c[g >> 2] | 0) + 8 >> 2] | 0))break;
	                    if ((c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + (c[k >> 2] << 1 << 2) >> 2] | 0) < 0) {
	                        m = 4;
	                        break
	                    }
	                    c[k >> 2] = (c[k >> 2] | 0) + 1
	                }
	                if ((m | 0) == 4) {
	                    c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + (c[k >> 2] << 1 << 2) >> 2] = c[h >> 2];
	                    c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + ((c[k >> 2] << 1) + 1 << 2) >> 2] = c[j >> 2];
	                    c[f >> 2] = c[k >> 2];
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                }
	                do if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) >= (c[(c[g >> 2] | 0) + 12 >> 2] | 0)) {
	                    c[l >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] << 2 << 2) | 0;
	                    if (c[l >> 2] | 0) {
	                        c[(c[g >> 2] | 0) + 20 >> 2] = c[l >> 2];
	                        k = (c[g >> 2] | 0) + 12 | 0;
	                        c[k >> 2] = c[k >> 2] << 1;
	                        break
	                    }
	                    c[f >> 2] = -1;
	                    n = c[f >> 2] | 0;
	                    i = e;
	                    return n | 0
	                } while (0);
	                c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + (c[(c[g >> 2] | 0) + 8 >> 2] << 1 << 2) >> 2] = c[h >> 2];
	                h = c[j >> 2] | 0;
	                j = (c[g >> 2] | 0) + 8 | 0;
	                l = c[j >> 2] | 0;
	                c[j >> 2] = l + 1;
	                c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + ((l << 1) + 1 << 2) >> 2] = h;
	                c[f >> 2] = (c[(c[g >> 2] | 0) + 8 >> 2] | 0) - 1;
	                n = c[f >> 2] | 0;
	                i = e;
	                return n | 0
	            }

	            function dR(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 16 | 0;
	                k = g + 12 | 0;
	                l = g + 8 | 0;
	                m = g + 4 | 0;
	                n = g;
	                c[g + 20 >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                do if ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) >= (c[(c[j >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[n >> 2] = Hb[c[135760 >> 2] & 511](c[(c[j >> 2] | 0) + 28 >> 2] | 0, (c[(c[j >> 2] | 0) + 24 >> 2] << 1) * 12 | 0) | 0;
	                    if (c[n >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 28 >> 2] = c[n >> 2];
	                        f = (c[j >> 2] | 0) + 24 | 0;
	                        c[f >> 2] = c[f >> 2] << 1;
	                        break
	                    }
	                    c[h >> 2] = -1;
	                    o = c[h >> 2] | 0;
	                    i = g;
	                    return o | 0
	                } while (0);
	                c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) * 12 | 0) >> 2] = c[k >> 2];
	                c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) * 12 | 0) + 4 >> 2] = c[l >> 2];
	                c[(c[(c[j >> 2] | 0) + 28 >> 2] | 0) + ((c[(c[j >> 2] | 0) + 20 >> 2] | 0) * 12 | 0) + 8 >> 2] = c[m >> 2];
	                m = (c[j >> 2] | 0) + 20 | 0;
	                c[m >> 2] = (c[m >> 2] | 0) + 1;
	                c[h >> 2] = 0;
	                o = c[h >> 2] | 0;
	                i = g;
	                return o | 0
	            }

	            function eR(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b + 32 | 0;
	                f = b + 28 | 0;
	                g = b + 24 | 0;
	                h = b + 20 | 0;
	                j = b + 16 | 0;
	                k = b + 12 | 0;
	                l = b + 8 | 0;
	                m = b + 4 | 0;
	                n = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)o = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            o = 1;
	                            break
	                        }
	                        o = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    p = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!o)break;
	                    a = c[e >> 2] | 0;
	                    if (!p)continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                o = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                a:do if ((p | 0) == 46) {
	                    a = c[e >> 2] | 0;
	                    if (o)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    if (!(dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 2, 0, 0) | 0)) {
	                        i = b;
	                        return
	                    }
	                } else {
	                    a = c[e >> 2] | 0;
	                    if ((o | 0) == 64) {
	                        q = c[e >> 2] | 0;
	                        if (c[(c[a + 16 >> 2] | 0) + 16 >> 2] & 2) {
	                            c[q + 8 >> 2] = 1;
	                            i = b;
	                            return
	                        }
	                        r = c[e >> 2] | 0;
	                        if (d[c[q >> 2] >> 0] | 0)c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        fR(c[e >> 2] | 0);
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0)break;
	                        i = b;
	                        return
	                    }
	                    c[g >> 2] = jR(a) | 0;
	                    a = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        r = c[e >> 2] | 0;
	                        if ((a | 0) != 42) {
	                            c[r + 8 >> 2] = 1;
	                            i = b;
	                            return
	                        }
	                        q = c[e >> 2] | 0;
	                        if (d[c[r >> 2] >> 0] | 0)c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 8, 0, 0) | 0)break;
	                        i = b;
	                        return
	                    }
	                    do if ((a | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            s = 29;
	                            break
	                        }
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13)s = 29
	                    } else s = 29; while (0);
	                    b:do if ((s | 0) == 29) {
	                        c[j >> 2] = 1;
	                        while (1) {
	                            do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                                if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                                if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13)break b
	                            } while (0);
	                            a = c[e >> 2] | 0;
	                            if (!(d[c[c[e >> 2] >> 2] >> 0] | 0))continue;
	                            c[a >> 2] = (c[a >> 2] | 0) + 1
	                        }
	                    } while (0);
	                    a = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 58) {
	                        if ((a | 0) != 42) {
	                            if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 2, c[g >> 2] | 0, 0) | 0)break;
	                            i = b;
	                            return
	                        }
	                        q = c[e >> 2] | 0;
	                        if (c[g >> 2] | 0) {
	                            c[q + 8 >> 2] = 1;
	                            break
	                        }
	                        r = c[e >> 2] | 0;
	                        if (d[c[q >> 2] >> 0] | 0)c[r >> 2] = (c[r >> 2] | 0) + 1;
	                        if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 8, c[f >> 2] | 0, 0) | 0)break;
	                        i = b;
	                        return
	                    }
	                    r = c[e >> 2] | 0;
	                    if (a)c[r >> 2] = (c[r >> 2] | 0) + 1;
	                    if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 58) {
	                        c[k >> 2] = c[g >> 2];
	                        do if ((c[j >> 2] | 0) == 0 ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32 : 0) {
	                            if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                            if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13) {
	                                c[f >> 2] = kR(c[e >> 2] | 0) | 0;
	                                do if ((((d[c[k >> 2] >> 0] | 0 | 0) == 120 ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[k >> 2] | 0) + 2 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[k >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0)if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                                    c[h >> 2] = AP(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, 200288, -1) | 0;
	                                    break
	                                } else {
	                                    c[h >> 2] = my(200288) | 0;
	                                    break
	                                } else s = 53; while (0);
	                                if ((s | 0) == 53) {
	                                    c[l >> 2] = 0;
	                                    while (1) {
	                                        if ((c[l >> 2] | 0) >= (c[(c[e >> 2] | 0) + 28 >> 2] | 0))break;
	                                        if (qy(c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + ((c[l >> 2] << 1) + 1 << 2) >> 2] | 0, c[k >> 2] | 0) | 0) {
	                                            s = 56;
	                                            break
	                                        }
	                                        c[l >> 2] = (c[l >> 2] | 0) + 1
	                                    }
	                                    do if ((s | 0) == 56)if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                                        c[h >> 2] = AP(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[l >> 2] << 1 << 2) >> 2] | 0, -1) | 0;
	                                        break
	                                    } else {
	                                        c[h >> 2] = my(c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[l >> 2] << 1 << 2) >> 2] | 0) | 0;
	                                        break
	                                    } while (0);
	                                    if ((c[l >> 2] | 0) >= (c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                                        c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                                        break a
	                                    }
	                                }
	                                if (!(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0))zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                                c[g >> 2] = 0;
	                                r = c[e >> 2] | 0;
	                                if (c[f >> 2] | 0) {
	                                    if (dR(r, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 2, c[f >> 2] | 0, c[h >> 2] | 0) | 0)break a;
	                                    i = b;
	                                    return
	                                }
	                                a = c[e >> 2] | 0;
	                                if ((d[c[r >> 2] >> 0] | 0 | 0) != 42) {
	                                    c[a + 8 >> 2] = 1;
	                                    break a
	                                }
	                                r = c[e >> 2] | 0;
	                                if (d[c[a >> 2] >> 0] | 0)c[r >> 2] = (c[r >> 2] | 0) + 1;
	                                if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 7, c[h >> 2] | 0, 0) | 0)break a;
	                                i = b;
	                                return
	                            }
	                        } while (0);
	                        c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                        break
	                    }
	                    r = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[r >> 2] = (c[r >> 2] | 0) + 1;
	                    if (!(qy(c[g >> 2] | 0, 200328) | 0)) {
	                        r = (qy(c[g >> 2] | 0, 200336) | 0) != 0;
	                        a = c[e >> 2] | 0;
	                        if (!r) {
	                            c[a + 8 >> 2] = 1;
	                            break
	                        }
	                        if (!(c[(c[a + 16 >> 2] | 0) + 4 >> 2] | 0))zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                        c[g >> 2] = 0;
	                        a = c[e >> 2] | 0;
	                        if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 16 >> 2] & 2) {
	                            c[a + 8 >> 2] = 1;
	                            break
	                        }
	                        fR(a);
	                        if (c[(c[e >> 2] | 0) + 8 >> 2] | 0)break;
	                        i = b;
	                        return
	                    }
	                    if (!(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0))zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                    c[g >> 2] = kR(c[e >> 2] | 0) | 0;
	                    a = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                    if (!(c[g >> 2] | 0)) {
	                        r = c[e >> 2] | 0;
	                        if ((a | 0) != 42) {
	                            c[r + 8 >> 2] = 1;
	                            break
	                        }
	                        q = c[e >> 2] | 0;
	                        if (d[c[r >> 2] >> 0] | 0)c[q >> 2] = (c[q >> 2] | 0) + 1;
	                        if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 8, 0, 0) | 0)break;
	                        i = b;
	                        return
	                    }
	                    if ((a | 0) != 58) {
	                        if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 3, c[g >> 2] | 0, 0) | 0)break;
	                        i = b;
	                        return
	                    }
	                    c[m >> 2] = c[g >> 2];
	                    a = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13) {
	                            c[f >> 2] = kR(c[e >> 2] | 0) | 0;
	                            do if ((d[c[m >> 2] >> 0] | 0 | 0) == 120) {
	                                if ((d[(c[m >> 2] | 0) + 1 >> 0] | 0 | 0) != 109) {
	                                    s = 97;
	                                    break
	                                }
	                                if ((d[(c[m >> 2] | 0) + 2 >> 0] | 0 | 0) != 108) {
	                                    s = 97;
	                                    break
	                                }
	                                if (d[(c[m >> 2] | 0) + 3 >> 0] | 0) {
	                                    s = 97;
	                                    break
	                                }
	                                if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                                    c[h >> 2] = AP(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, 200288, -1) | 0;
	                                    break
	                                } else {
	                                    c[h >> 2] = my(200288) | 0;
	                                    break
	                                }
	                            } else s = 97; while (0);
	                            do if ((s | 0) == 97) {
	                                c[n >> 2] = 0;
	                                while (1) {
	                                    if ((c[n >> 2] | 0) >= (c[(c[e >> 2] | 0) + 28 >> 2] | 0))break;
	                                    if (qy(c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + ((c[n >> 2] << 1) + 1 << 2) >> 2] | 0, c[m >> 2] | 0) | 0) {
	                                        s = 100;
	                                        break
	                                    }
	                                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                                }
	                                do if ((s | 0) == 100)if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                                    c[h >> 2] = AP(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] << 1 << 2) >> 2] | 0, -1) | 0;
	                                    break
	                                } else {
	                                    c[h >> 2] = my(c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[n >> 2] << 1 << 2) >> 2] | 0) | 0;
	                                    break
	                                } while (0);
	                                if ((c[n >> 2] | 0) < (c[(c[e >> 2] | 0) + 28 >> 2] | 0))break;
	                                c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                                break a
	                            } while (0);
	                            if (!(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0))zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            c[g >> 2] = 0;
	                            a = c[e >> 2] | 0;
	                            if (c[f >> 2] | 0) {
	                                if (dR(a, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 3, c[f >> 2] | 0, c[h >> 2] | 0) | 0)break a;
	                                i = b;
	                                return
	                            }
	                            q = c[e >> 2] | 0;
	                            if ((d[c[a >> 2] >> 0] | 0 | 0) != 42) {
	                                c[q + 8 >> 2] = 1;
	                                break a
	                            }
	                            a = c[e >> 2] | 0;
	                            if (d[c[q >> 2] >> 0] | 0)c[a >> 2] = (c[a >> 2] | 0) + 1;
	                            if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 7, c[h >> 2] | 0, 0) | 0)break a;
	                            i = b;
	                            return
	                        }
	                    } while (0);
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 1
	                } while (0);
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                if ((c[f >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                if (!(c[g >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[g >> 2] | 0);
	                i = b;
	                return
	            }

	            function fR(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 20 | 0;
	                f = b + 16 | 0;
	                g = b + 12 | 0;
	                h = b + 8 | 0;
	                j = b + 4 | 0;
	                k = b;
	                c[e >> 2] = a;
	                c[f >> 2] = 0;
	                c[g >> 2] = 0;
	                c[h >> 2] = 0;
	                while (1) {
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 32)l = 1; else {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            l = 1;
	                            break
	                        }
	                        l = (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    m = c[e >> 2] | 0;
	                    if (!l)break;
	                    a = c[e >> 2] | 0;
	                    if (!(d[c[m >> 2] >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                c[g >> 2] = jR(m) | 0;
	                m = d[c[c[e >> 2] >> 2] >> 0] | 0;
	                a:do if (!(c[g >> 2] | 0)) {
	                    l = c[e >> 2] | 0;
	                    if ((m | 0) != 42) {
	                        c[l + 8 >> 2] = 1;
	                        i = b;
	                        return
	                    }
	                    if (!(dR(l, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 4, 0, 0) | 0)) {
	                        l = c[e >> 2] | 0;
	                        if (!(d[c[c[e >> 2] >> 2] >> 0] | 0)) {
	                            i = b;
	                            return
	                        }
	                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        i = b;
	                        return
	                    }
	                } else {
	                    if ((m | 0) != 58) {
	                        if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 4, c[g >> 2] | 0, 0) | 0)break;
	                        i = b;
	                        return
	                    }
	                    c[k >> 2] = c[g >> 2];
	                    l = c[e >> 2] | 0;
	                    if (d[c[c[e >> 2] >> 2] >> 0] | 0)c[l >> 2] = (c[l >> 2] | 0) + 1;
	                    do if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 32) {
	                        if (9 <= (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0)break;
	                        if ((d[c[c[e >> 2] >> 2] >> 0] | 0 | 0) != 13) {
	                            c[f >> 2] = kR(c[e >> 2] | 0) | 0;
	                            do if ((((d[c[k >> 2] >> 0] | 0 | 0) == 120 ? (d[(c[k >> 2] | 0) + 1 >> 0] | 0 | 0) == 109 : 0) ? (d[(c[k >> 2] | 0) + 2 >> 0] | 0 | 0) == 108 : 0) ? (d[(c[k >> 2] | 0) + 3 >> 0] | 0 | 0) == 0 : 0)if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                                c[h >> 2] = AP(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, 200288, -1) | 0;
	                                break
	                            } else {
	                                c[h >> 2] = my(200288) | 0;
	                                break
	                            } else n = 32; while (0);
	                            if ((n | 0) == 32) {
	                                c[j >> 2] = 0;
	                                while (1) {
	                                    if ((c[j >> 2] | 0) >= (c[(c[e >> 2] | 0) + 28 >> 2] | 0))break;
	                                    if (qy(c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + ((c[j >> 2] << 1) + 1 << 2) >> 2] | 0, c[k >> 2] | 0) | 0) {
	                                        n = 35;
	                                        break
	                                    }
	                                    c[j >> 2] = (c[j >> 2] | 0) + 1
	                                }
	                                do if ((n | 0) == 35)if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                                    c[h >> 2] = AP(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[j >> 2] << 1 << 2) >> 2] | 0, -1) | 0;
	                                    break
	                                } else {
	                                    c[h >> 2] = my(c[(c[(c[e >> 2] | 0) + 24 >> 2] | 0) + (c[j >> 2] << 1 << 2) >> 2] | 0) | 0;
	                                    break
	                                } while (0);
	                                if ((c[j >> 2] | 0) >= (c[(c[e >> 2] | 0) + 28 >> 2] | 0)) {
	                                    c[(c[e >> 2] | 0) + 8 >> 2] = 1;
	                                    break a
	                                }
	                            }
	                            if (!(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0))zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                            l = c[e >> 2] | 0;
	                            if (c[f >> 2] | 0) {
	                                if (dR(l, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 4, c[f >> 2] | 0, c[h >> 2] | 0) | 0)break a;
	                                i = b;
	                                return
	                            }
	                            a = c[e >> 2] | 0;
	                            if ((d[c[l >> 2] >> 0] | 0 | 0) != 42) {
	                                c[a + 8 >> 2] = 1;
	                                break a
	                            }
	                            l = c[e >> 2] | 0;
	                            if (d[c[a >> 2] >> 0] | 0)c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            if (dR(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 16 >> 2] | 0, 4, 0, c[h >> 2] | 0) | 0)break a;
	                            i = b;
	                            return
	                        }
	                    } while (0);
	                    if (!(c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0))zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    c[(c[e >> 2] | 0) + 8 >> 2] = 1
	                } while (0);
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) == 0 : 0)zb[c[135736 >> 2] & 511](c[h >> 2] | 0);
	                if (!(c[f >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[(c[e >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) {
	                    i = b;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                i = b;
	                return
	            }

	            function gR(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[e >> 2] = (c[e >> 2] | 0) < 4 ? 4 : a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](20) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = c[f >> 2] | 0;
	                c[a + 0 >> 2] = 0;
	                c[a + 4 >> 2] = 0;
	                c[a + 8 >> 2] = 0;
	                c[a + 12 >> 2] = 0;
	                c[a + 16 >> 2] = 0;
	                a = Cb[c[135744 >> 2] & 511](c[e >> 2] << 4) | 0;
	                c[(c[f >> 2] | 0) + 12 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 12 >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[(c[f >> 2] | 0) + 4 >> 2] = 0;
	                    c[(c[f >> 2] | 0) + 8 >> 2] = c[e >> 2];
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function hR(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 32 | 0;
	                h = g + 24 | 0;
	                j = g + 20 | 0;
	                k = g + 16 | 0;
	                l = g + 12 | 0;
	                m = g + 8 | 0;
	                n = g + 4 | 0;
	                o = g;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                do if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) >= (c[(c[j >> 2] | 0) + 8 >> 2] | 0)) {
	                    c[o >> 2] = Hb[c[135760 >> 2] & 511](c[(c[j >> 2] | 0) + 12 >> 2] | 0, c[(c[j >> 2] | 0) + 8 >> 2] << 1 << 4) | 0;
	                    if (c[o >> 2] | 0) {
	                        c[(c[j >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                        f = (c[j >> 2] | 0) + 8 | 0;
	                        c[f >> 2] = c[f >> 2] << 1;
	                        break
	                    }
	                    c[h >> 2] = -1;
	                    p = c[h >> 2] | 0;
	                    i = g;
	                    return p | 0
	                } while (0);
	                f = (c[j >> 2] | 0) + 4 | 0;
	                e = c[f >> 2] | 0;
	                c[f >> 2] = e + 1;
	                c[o >> 2] = (c[(c[j >> 2] | 0) + 12 >> 2] | 0) + (e << 4);
	                c[c[o >> 2] >> 2] = c[n >> 2];
	                c[(c[o >> 2] | 0) + 4 >> 2] = c[k >> 2];
	                c[(c[o >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                c[(c[o >> 2] | 0) + 12 >> 2] = c[m >> 2];
	                c[h >> 2] = (c[(c[j >> 2] | 0) + 4 >> 2] | 0) - 1;
	                p = c[h >> 2] | 0;
	                i = g;
	                return p | 0
	            }

	            function iR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                do if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) > 0 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) <= (c[c[g >> 2] >> 2] | 0)) {
	                        c[k >> 2] = Hb[c[135760 >> 2] & 511](c[(c[g >> 2] | 0) + 8 >> 2] | 0, c[(c[g >> 2] | 0) + 4 >> 2] << 1 << 3) | 0;
	                        if (c[k >> 2] | 0) {
	                            c[(c[g >> 2] | 0) + 8 >> 2] = c[k >> 2];
	                            d = (c[g >> 2] | 0) + 4 | 0;
	                            c[d >> 2] = c[d >> 2] << 1;
	                            break
	                        }
	                        c[f >> 2] = -1;
	                        l = c[f >> 2] | 0;
	                        i = e;
	                        return l | 0
	                    }
	                } else m = 3; while (0);
	                if ((m | 0) == 3) {
	                    c[(c[g >> 2] | 0) + 4 >> 2] = 4;
	                    c[c[g >> 2] >> 2] = 0;
	                    m = Cb[c[135744 >> 2] & 511](32) | 0;
	                    c[(c[g >> 2] | 0) + 8 >> 2] = m
	                }
	                c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (c[c[g >> 2] >> 2] << 3) >> 2] = c[h >> 2];
	                h = c[j >> 2] | 0;
	                j = c[g >> 2] | 0;
	                m = c[j >> 2] | 0;
	                c[j >> 2] = m + 1;
	                c[(c[(c[g >> 2] | 0) + 8 >> 2] | 0) + (m << 3) + 4 >> 2] = h;
	                c[f >> 2] = 0;
	                l = c[f >> 2] | 0;
	                i = e;
	                return l | 0
	            }

	            function jR(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                while (1) {
	                    do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 32)m = 1; else {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            m = 1;
	                            break
	                        }
	                        m = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    n = c[c[f >> 2] >> 2] | 0;
	                    if (!m)break;
	                    a = c[f >> 2] | 0;
	                    if (!(d[n >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                c[g >> 2] = n;
	                c[h >> 2] = n;
	                c[k >> 2] = oe(0, c[h >> 2] | 0, l) | 0;
	                n = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (((!(65 <= (n | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)o = 15
	                } else if (!(DQ(n, 199744) | 0))o = 15;
	                do if ((o | 0) == 15) {
	                    n = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if ((n | 0) == 95)break
	                    } else {
	                        if (19968 <= (n | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                        if (!((12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329 ^ 1) & (c[k >> 2] | 0) != 95))break
	                    }
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } while (0);
	                a:while (1) {
	                    n = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (n | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)o = 26
	                    } else if (!(DQ(n, 199744) | 0))o = 26;
	                    do if ((o | 0) == 26) {
	                        o = 0;
	                        if ((c[k >> 2] | 0) >= 256) {
	                            if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                        }
	                        n = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (48 <= (n | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        } else {
	                            m = (DQ(n, 200216) | 0) != 0;
	                            if (m | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        }
	                        if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        m = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)q = (m | 0) == 183 & 1; else q = DQ(m, 200272) | 0;
	                        if (!q)break a
	                    } while (0);
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[h >> 2] | 0, l) | 0
	                }
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)c[j >> 2] = AP(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0; else c[j >> 2] = ly(c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                c[c[f >> 2] >> 2] = c[h >> 2];
	                c[e >> 2] = c[j >> 2];
	                p = c[e >> 2] | 0;
	                i = b;
	                return p | 0
	            }

	            function kR(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                b = i;
	                i = i + 32 | 0;
	                e = b + 24 | 0;
	                f = b + 20 | 0;
	                g = b + 16 | 0;
	                h = b + 12 | 0;
	                j = b + 8 | 0;
	                k = b + 4 | 0;
	                l = b;
	                c[f >> 2] = a;
	                c[j >> 2] = 0;
	                while (1) {
	                    do if ((d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 32)m = 1; else {
	                        if (9 <= (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) ? (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) <= 10 : 0) {
	                            m = 1;
	                            break
	                        }
	                        m = (d[c[c[f >> 2] >> 2] >> 0] | 0 | 0) == 13
	                    } while (0);
	                    n = c[c[f >> 2] >> 2] | 0;
	                    if (!m)break;
	                    a = c[f >> 2] | 0;
	                    if (!(d[n >> 0] | 0))continue;
	                    c[a >> 2] = (c[a >> 2] | 0) + 1
	                }
	                c[g >> 2] = n;
	                c[h >> 2] = n;
	                c[k >> 2] = oe(0, c[h >> 2] | 0, l) | 0;
	                n = c[k >> 2] | 0;
	                if ((c[k >> 2] | 0) < 256) {
	                    if (((!(65 <= (n | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)o = 15
	                } else if (!(DQ(n, 199744) | 0))o = 15;
	                do if ((o | 0) == 15) {
	                    n = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (!((n | 0) != 95 & (c[k >> 2] | 0) != 58))break
	                    } else {
	                        if (19968 <= (n | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                        if (!((12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329 ^ 1) & (c[k >> 2] | 0) != 95 & (c[k >> 2] | 0) != 58))break
	                    }
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } while (0);
	                a:while (1) {
	                    n = c[k >> 2] | 0;
	                    if ((c[k >> 2] | 0) < 256) {
	                        if (((!(65 <= (n | 0) & (c[k >> 2] | 0) <= 90) ? !(97 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 122) : 0) ? !(192 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 214) : 0) ? !(216 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 246 | 248 <= (c[k >> 2] | 0)) : 0)o = 26
	                    } else if (!(DQ(n, 199744) | 0))o = 26;
	                    do if ((o | 0) == 26) {
	                        o = 0;
	                        if ((c[k >> 2] | 0) >= 256) {
	                            if (19968 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 40869 | (c[k >> 2] | 0) == 12295)break;
	                            if (12321 <= (c[k >> 2] | 0) & (c[k >> 2] | 0) <= 12329)break
	                        }
	                        n = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256) {
	                            if (48 <= (n | 0) & (c[k >> 2] | 0) <= 57 | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        } else {
	                            m = (DQ(n, 200216) | 0) != 0;
	                            if (m | (c[k >> 2] | 0) == 46 | (c[k >> 2] | 0) == 45 | (c[k >> 2] | 0) == 95)break
	                        }
	                        if ((c[k >> 2] | 0) >= 256 ? (DQ(c[k >> 2] | 0, 200144) | 0) != 0 : 0)break;
	                        m = c[k >> 2] | 0;
	                        if ((c[k >> 2] | 0) < 256)q = (m | 0) == 183 & 1; else q = DQ(m, 200272) | 0;
	                        if (!q)break a
	                    } while (0);
	                    c[h >> 2] = (c[h >> 2] | 0) + (c[l >> 2] | 0);
	                    c[k >> 2] = oe(0, c[h >> 2] | 0, l) | 0
	                }
	                if (c[(c[f >> 2] | 0) + 12 >> 2] | 0)c[j >> 2] = AP(c[(c[f >> 2] | 0) + 12 >> 2] | 0, c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0; else c[j >> 2] = ly(c[g >> 2] | 0, (c[h >> 2] | 0) - (c[g >> 2] | 0) | 0) | 0;
	                c[c[f >> 2] >> 2] = c[h >> 2];
	                c[e >> 2] = c[j >> 2];
	                p = c[e >> 2] | 0;
	                i = b;
	                return p | 0
	            }

	            function lR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) == 0 & (c[g >> 2] | 0) == 0)c[e >> 2] = -1; else {
	                    if (c[g >> 2] | 0) {
	                        if (qy(c[g >> 2] | 0, 200352) | 0) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                        if (qy(c[g >> 2] | 0, 200392) | 0) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                        if (qy(c[g >> 2] | 0, 200432) | 0) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                    }
	                    if (c[f >> 2] | 0) {
	                        if (qy(c[f >> 2] | 0, 200472) | 0) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                        if (qy(c[f >> 2] | 0, 200528) | 0) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                        if (qy(c[f >> 2] | 0, 200584) | 0) {
	                            c[e >> 2] = 1;
	                            break
	                        }
	                    }
	                    c[e >> 2] = 0
	                } while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function mR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = kj() | 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Bm(c[g >> 2] | 0, c[f >> 2] | 0);
	                hz(c[e >> 2] | 0, c[g >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function nR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = kj() | 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                pm(c[g >> 2] | 0, c[f >> 2] | 0);
	                hz(c[e >> 2] | 0, c[g >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function oR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = kj() | 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                wm(c[g >> 2] | 0, c[f >> 2] | 0);
	                hz(c[e >> 2] | 0, c[g >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function pR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = kj() | 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                fd(c[g >> 2] | 0, c[f >> 2] | 0);
	                hz(c[e >> 2] | 0, c[g >> 2] | 0) | 0;
	                i = d;
	                return
	            }

	            function qR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    KR(c[e >> 2] | 0, c[f >> 2] | 0, 0);
	                    c[f >> 2] = c[c[f >> 2] >> 2]
	                }
	                i = d;
	                return
	            }

	            function rR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 16 | 0;
	                g = e + 12 | 0;
	                h = e + 8 | 0;
	                j = e + 4 | 0;
	                k = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = LR(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                j = Jk(c[g >> 2] | 0, c[(c[k >> 2] | 0) + 20 >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 24 >> 2] = j;
	                j = c[k >> 2] | 0;
	                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                    MR(j);
	                    c[f >> 2] = 0;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                } else {
	                    c[f >> 2] = j;
	                    l = c[f >> 2] | 0;
	                    i = e;
	                    return l | 0
	                }
	                return 0
	            }

	            function sR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[l >> 2] = 0;
	                c[k >> 2] = LR(c[h >> 2] | 0, c[j >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                j = Ek(c[g >> 2] | 0, c[(c[k >> 2] | 0) + 20 >> 2] | 0, c[l >> 2] | 0) | 0;
	                c[(c[k >> 2] | 0) + 24 >> 2] = j;
	                j = c[k >> 2] | 0;
	                if (!(c[(c[k >> 2] | 0) + 24 >> 2] | 0)) {
	                    MR(j);
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                } else {
	                    c[f >> 2] = j;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                return 0
	            }

	            function tR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                do if (!((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0))if ((NR(c[f >> 2] | 0, c[g >> 2] | 0) | 0) < 0) {
	                    c[e >> 2] = -1;
	                    break
	                } else {
	                    c[e >> 2] = c[h >> 2];
	                    break
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function uR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } else {
	                    OR(c[f >> 2] | 0, c[g >> 2] | 0);
	                    c[e >> 2] = c[h >> 2];
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                return 0
	            }

	            function vR(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                do if (c[e >> 2] | 0)if (!(c[(c[e >> 2] | 0) + 24 >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    break
	                } else {
	                    c[d >> 2] = Ak(c[(c[e >> 2] | 0) + 24 >> 2] | 0) | 0;
	                    break
	                } else c[d >> 2] = -1; while (0);
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function wR(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = -1;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[f >> 2] = vR(c[e >> 2] | 0) | 0;
	                    MR(c[e >> 2] | 0);
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function xR(a, b, e, f) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 28 | 0;
	                j = g + 24 | 0;
	                k = g + 20 | 0;
	                l = g + 16 | 0;
	                m = g + 12 | 0;
	                n = g + 8 | 0;
	                o = g + 32 | 0;
	                p = g + 4 | 0;
	                q = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                if (!(c[l >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                f = c[l >> 2] | 0;
	                c[n >> 2] = f;
	                c[m >> 2] = f;
	                a:while (1) {
	                    if (!(d[c[n >> 2] >> 0] | 0))break;
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 10) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200640, 5) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 13) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200648, 5) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 9) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200656, 4) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 34) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200664, 6) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 60) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200672, 4) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 62) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200680, 4) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 38) {
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        cz(c[h >> 2] | 0, 200688, 5) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue
	                    }
	                    do if ((d[c[n >> 2] >> 0] | 0 | 0) >= 128) {
	                        if ((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 60 >> 2] | 0) != 0 : 0)break;
	                        c[p >> 2] = 0;
	                        c[q >> 2] = 1;
	                        if ((c[m >> 2] | 0) != (c[n >> 2] | 0))cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) < 192) {
	                            PR(1400, c[k >> 2] | 0, 0);
	                            if (c[j >> 2] | 0) {
	                                f = my(200696) | 0;
	                                c[(c[j >> 2] | 0) + 60 >> 2] = f
	                            }
	                            QR(o, d[c[n >> 2] >> 0] | 0) | 0;
	                            cz(c[h >> 2] | 0, o, -1) | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + 1;
	                            c[m >> 2] = c[n >> 2];
	                            continue a
	                        }
	                        f = c[n >> 2] | 0;
	                        do if ((d[c[n >> 2] >> 0] | 0 | 0) >= 224) {
	                            l = c[n >> 2] | 0;
	                            if ((d[f >> 0] | 0 | 0) < 240) {
	                                c[p >> 2] = (d[l >> 0] | 0) & 15;
	                                c[p >> 2] = c[p >> 2] << 6;
	                                c[p >> 2] = c[p >> 2] | (d[(c[n >> 2] | 0) + 1 >> 0] | 0) & 63;
	                                c[p >> 2] = c[p >> 2] << 6;
	                                c[p >> 2] = c[p >> 2] | (d[(c[n >> 2] | 0) + 2 >> 0] | 0) & 63;
	                                c[q >> 2] = 3;
	                                break
	                            }
	                            if ((d[l >> 0] | 0 | 0) < 248) {
	                                c[p >> 2] = (d[c[n >> 2] >> 0] | 0) & 7;
	                                c[p >> 2] = c[p >> 2] << 6;
	                                c[p >> 2] = c[p >> 2] | (d[(c[n >> 2] | 0) + 1 >> 0] | 0) & 63;
	                                c[p >> 2] = c[p >> 2] << 6;
	                                c[p >> 2] = c[p >> 2] | (d[(c[n >> 2] | 0) + 2 >> 0] | 0) & 63;
	                                c[p >> 2] = c[p >> 2] << 6;
	                                c[p >> 2] = c[p >> 2] | (d[(c[n >> 2] | 0) + 3 >> 0] | 0) & 63;
	                                c[q >> 2] = 4
	                            }
	                        } else {
	                            c[p >> 2] = (d[f >> 0] | 0) & 31;
	                            c[p >> 2] = c[p >> 2] << 6;
	                            c[p >> 2] = c[p >> 2] | (d[(c[n >> 2] | 0) + 1 >> 0] | 0) & 63;
	                            c[q >> 2] = 2
	                        } while (0);
	                        b:do if ((c[q >> 2] | 0) != 1) {
	                            f = c[p >> 2] | 0;
	                            do if ((c[p >> 2] | 0) < 256) {
	                                if (!(9 <= (f | 0) & (c[p >> 2] | 0) <= 10 | (c[p >> 2] | 0) == 13 | 32 <= (c[p >> 2] | 0)))break b
	                            } else {
	                                if (256 <= (f | 0) & (c[p >> 2] | 0) <= 55295)break;
	                                if (57344 <= (c[p >> 2] | 0) & (c[p >> 2] | 0) <= 65533)break;
	                                if (!(65536 <= (c[p >> 2] | 0) & (c[p >> 2] | 0) <= 1114111))break b
	                            } while (0);
	                            QR(o, c[p >> 2] | 0) | 0;
	                            cz(c[h >> 2] | 0, o, -1) | 0;
	                            c[n >> 2] = (c[n >> 2] | 0) + (c[q >> 2] | 0);
	                            c[m >> 2] = c[n >> 2];
	                            continue a
	                        } while (0);
	                        PR(1401, c[k >> 2] | 0, 0);
	                        if (c[j >> 2] | 0) {
	                            f = my(200696) | 0;
	                            c[(c[j >> 2] | 0) + 60 >> 2] = f
	                        }
	                        QR(o, d[c[n >> 2] >> 0] | 0) | 0;
	                        cz(c[h >> 2] | 0, o, -1) | 0;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        c[m >> 2] = c[n >> 2];
	                        continue a
	                    } while (0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                }
	                if ((c[m >> 2] | 0) == (c[n >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                cz(c[h >> 2] | 0, c[m >> 2] | 0, (c[n >> 2] | 0) - (c[m >> 2] | 0) | 0) | 0;
	                i = g;
	                return
	            }

	            function yR(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                h = i;
	                i = i + 160 | 0;
	                j = h + 152 | 0;
	                k = h + 148 | 0;
	                l = h + 144 | 0;
	                m = h + 140 | 0;
	                n = h + 136 | 0;
	                o = h + 132 | 0;
	                p = h + 8 | 0;
	                q = h + 4 | 0;
	                r = h;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[r >> 2] = 0;
	                Rf();
	                if ((c[j >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    i = h;
	                    return
	                }
	                if (!(c[o >> 2] | 0))c[o >> 2] = 200728;
	                g = p + 0 | 0;
	                f = g + 124 | 0;
	                do {
	                    c[g >> 2] = 0;
	                    g = g + 4 | 0
	                } while ((g | 0) < (f | 0));
	                c[p + 28 >> 2] = c[k >> 2];
	                c[p + 24 >> 2] = c[j >> 2];
	                c[p + 36 >> 2] = c[m >> 2];
	                c[p + 40 >> 2] = (c[n >> 2] | 0) != 0 ? 1 : 0;
	                c[p + 16 >> 2] = c[o >> 2];
	                SR(p);
	                o = p + 32 | 0;
	                c[o >> 2] = c[o >> 2] | 32;
	                c[q >> 2] = Nh(c[k >> 2] | 0) | 0;
	                if (c[q >> 2] | 0) {
	                    k = lR(c[(c[q >> 2] | 0) + 56 >> 2] | 0, c[(c[q >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    c[r >> 2] = k;
	                    c[r >> 2] = (c[r >> 2] | 0) < 0 ? 0 : k
	                }
	                k = c[l >> 2] | 0;
	                if (c[r >> 2] | 0) {
	                    TR(p, k);
	                    i = h;
	                    return
	                } else {
	                    OR(p, k);
	                    i = h;
	                    return
	                }
	            }

	            function zR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                Rf();
	                if (!(c[h >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = Fk(c[f >> 2] | 0, 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 13 : 0)yp(c[j >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0); else yR(c[j >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0, 1, 0);
	                zk(c[j >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function AR(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                g = i;
	                i = i + 160 | 0;
	                h = g + 152 | 0;
	                j = g + 148 | 0;
	                k = g + 144 | 0;
	                l = g + 140 | 0;
	                m = g + 136 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                p = g + 4 | 0;
	                q = g;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[m >> 2] = f;
	                c[o >> 2] = 0;
	                c[p >> 2] = 0;
	                c[q >> 2] = 0;
	                if (!(c[k >> 2] | 0))c[k >> 2] = o;
	                if (!(c[j >> 2] | 0)) {
	                    c[c[k >> 2] >> 2] = 0;
	                    i = g;
	                    return
	                }
	                c[c[j >> 2] >> 2] = 0;
	                c[c[k >> 2] >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if (!(c[l >> 2] | 0))c[l >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                if ((c[l >> 2] | 0) != 0 ? (c[q >> 2] = Dd(c[l >> 2] | 0) | 0, (c[q >> 2] | 0) == 0) : 0) {
	                    PR(1403, c[h >> 2] | 0, c[l >> 2] | 0);
	                    i = g;
	                    return
	                }
	                o = wk(c[q >> 2] | 0) | 0;
	                c[p >> 2] = o;
	                if (!o) {
	                    RR(200712);
	                    i = g;
	                    return
	                }
	                o = n + 0 | 0;
	                q = o + 124 | 0;
	                do {
	                    c[o >> 2] = 0;
	                    o = o + 4 | 0
	                } while ((o | 0) < (q | 0));
	                c[n + 28 >> 2] = c[h >> 2];
	                c[n + 24 >> 2] = c[p >> 2];
	                c[n + 36 >> 2] = 0;
	                c[n + 40 >> 2] = (c[m >> 2] | 0) != 0 ? 1 : 0;
	                c[n + 16 >> 2] = c[l >> 2];
	                SR(n);
	                l = n + 32 | 0;
	                c[l >> 2] = c[l >> 2] | 32;
	                NR(n, c[h >> 2] | 0) | 0;
	                Ak(c[p >> 2] | 0) | 0;
	                h = c[p >> 2] | 0;
	                if (c[(c[p >> 2] | 0) + 20 >> 2] | 0) {
	                    n = _y(c[h + 20 >> 2] | 0) | 0;
	                    c[c[k >> 2] >> 2] = n;
	                    n = Vy(c[(c[p >> 2] | 0) + 20 >> 2] | 0) | 0;
	                    l = ly(n, c[c[k >> 2] >> 2] | 0) | 0;
	                    c[c[j >> 2] >> 2] = l
	                } else {
	                    l = _y(c[h + 16 >> 2] | 0) | 0;
	                    c[c[k >> 2] >> 2] = l;
	                    l = Vy(c[(c[p >> 2] | 0) + 16 >> 2] | 0) | 0;
	                    h = ly(l, c[c[k >> 2] >> 2] | 0) | 0;
	                    c[c[j >> 2] >> 2] = h
	                }
	                zk(c[p >> 2] | 0) | 0;
	                if (c[c[j >> 2] >> 2] | 0) {
	                    i = g;
	                    return
	                }
	                if ((c[c[k >> 2] >> 2] | 0) <= 0) {
	                    i = g;
	                    return
	                }
	                c[c[k >> 2] >> 2] = 0;
	                RR(200736);
	                i = g;
	                return
	            }

	            function BR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                AR(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0, 0);
	                i = e;
	                return
	            }

	            function CR(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                AR(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, 0, c[k >> 2] | 0);
	                i = f;
	                return
	            }

	            function DR(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f + 12 | 0;
	                h = f + 8 | 0;
	                j = f + 4 | 0;
	                k = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = e;
	                AR(c[g >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[k >> 2] | 0, 0);
	                i = f;
	                return
	            }

	            function ER(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 160 | 0;
	                f = e + 152 | 0;
	                g = e + 148 | 0;
	                h = e + 144 | 0;
	                j = e + 140 | 0;
	                k = e + 16 | 0;
	                l = e + 12 | 0;
	                m = e + 8 | 0;
	                n = e + 4 | 0;
	                o = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[n >> 2] = 0;
	                if (!(c[h >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                c[m >> 2] = c[(c[h >> 2] | 0) + 60 >> 2];
	                if ((c[m >> 2] | 0) != 0 ? (c[n >> 2] = Dd(c[m >> 2] | 0) | 0, (c[n >> 2] | 0) == 0) : 0) {
	                    zb[c[135736 >> 2] & 511](c[(c[h >> 2] | 0) + 60 >> 2] | 0);
	                    c[(c[h >> 2] | 0) + 60 >> 2] = 0;
	                    c[m >> 2] = 0
	                }
	                c[l >> 2] = Fk(c[g >> 2] | 0, c[n >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[f >> 2] = -1;
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                } else {
	                    n = k + 0 | 0;
	                    g = n + 124 | 0;
	                    do {
	                        c[n >> 2] = 0;
	                        n = n + 4 | 0
	                    } while ((n | 0) < (g | 0));
	                    c[k + 28 >> 2] = c[h >> 2];
	                    c[k + 24 >> 2] = c[l >> 2];
	                    c[k + 36 >> 2] = 0;
	                    c[k + 40 >> 2] = (c[j >> 2] | 0) != 0 ? 1 : 0;
	                    c[k + 16 >> 2] = c[m >> 2];
	                    SR(k);
	                    m = k + 32 | 0;
	                    c[m >> 2] = c[m >> 2] | 32;
	                    NR(k, c[h >> 2] | 0) | 0;
	                    c[o >> 2] = zk(c[l >> 2] | 0) | 0;
	                    c[f >> 2] = c[o >> 2];
	                    p = c[f >> 2] | 0;
	                    i = e;
	                    return p | 0
	                }
	                return 0
	            }

	            function FR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = ER(c[e >> 2] | 0, c[f >> 2] | 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function GR(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                f = i;
	                i = i + 160 | 0;
	                g = f + 152 | 0;
	                h = f + 148 | 0;
	                j = f + 144 | 0;
	                k = f + 140 | 0;
	                l = f + 136 | 0;
	                m = f + 12 | 0;
	                n = f + 8 | 0;
	                o = f + 4 | 0;
	                p = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                c[o >> 2] = 0;
	                if (!(c[j >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                if (!(c[k >> 2] | 0))c[k >> 2] = c[(c[j >> 2] | 0) + 60 >> 2];
	                if ((c[k >> 2] | 0) != 0 ? (c[o >> 2] = Dd(c[k >> 2] | 0) | 0, (c[o >> 2] | 0) == 0) : 0) {
	                    c[g >> 2] = -1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                c[n >> 2] = Ek(c[h >> 2] | 0, c[o >> 2] | 0, c[(c[j >> 2] | 0) + 36 >> 2] | 0) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    c[g >> 2] = -1;
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                } else {
	                    o = m + 0 | 0;
	                    h = o + 124 | 0;
	                    do {
	                        c[o >> 2] = 0;
	                        o = o + 4 | 0
	                    } while ((o | 0) < (h | 0));
	                    c[m + 28 >> 2] = c[j >> 2];
	                    c[m + 24 >> 2] = c[n >> 2];
	                    c[m + 36 >> 2] = 0;
	                    c[m + 40 >> 2] = (c[l >> 2] | 0) != 0 ? 1 : 0;
	                    c[m + 16 >> 2] = c[k >> 2];
	                    SR(m);
	                    k = m + 32 | 0;
	                    c[k >> 2] = c[k >> 2] | 32;
	                    NR(m, c[j >> 2] | 0) | 0;
	                    c[p >> 2] = zk(c[n >> 2] | 0) | 0;
	                    c[g >> 2] = c[p >> 2];
	                    q = c[g >> 2] | 0;
	                    i = f;
	                    return q | 0
	                }
	                return 0
	            }

	            function HR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = GR(c[f >> 2] | 0, c[g >> 2] | 0, c[h >> 2] | 0, 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function IR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = GR(c[f >> 2] | 0, c[g >> 2] | 0, 0, c[h >> 2] | 0) | 0;
	                i = e;
	                return d | 0
	            }

	            function JR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                b = GR(c[e >> 2] | 0, c[f >> 2] | 0, 0, 0) | 0;
	                i = d;
	                return b | 0
	            }

	            function KR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[g >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18) {
	                    i = e;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if (qy(c[(c[g >> 2] | 0) + 12 >> 2] | 0, 201224) | 0) {
	                    i = e;
	                    return
	                }
	                if ((c[h >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 40 >> 2] | 0) == 2 : 0)UR(c[h >> 2] | 0, 2); else Ok(c[f >> 2] | 0, 1, 200760) | 0;
	                h = c[f >> 2] | 0;
	                if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                    Ok(h, 6, 201752) | 0;
	                    Qk(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0) | 0
	                } else Ok(h, 5, 201760) | 0;
	                Ok(c[f >> 2] | 0, 1, 201768) | 0;
	                gz(c[(c[f >> 2] | 0) + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function LR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = Cb[c[135744 >> 2] & 511](124) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    RR(201728);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                b = (c[h >> 2] | 0) + 0 | 0;
	                a = b + 124 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                do if (c[f >> 2] | 0) {
	                    b = Dd(c[f >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 20 >> 2] = b;
	                    b = c[f >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 20 >> 2] | 0) {
	                        a = my(b) | 0;
	                        c[(c[h >> 2] | 0) + 16 >> 2] = a;
	                        c[(c[h >> 2] | 0) + 116 >> 2] = 0;
	                        break
	                    }
	                    PR(1403, 0, b);
	                    MR(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                SR(c[h >> 2] | 0);
	                if ((c[(c[h >> 2] | 0) + 32 >> 2] & 4 | 0) != 0 ? (c[g >> 2] & 4 | 0) == 0 : 0)c[g >> 2] = c[g >> 2] | 4;
	                c[(c[h >> 2] | 0) + 32 >> 2] = c[g >> 2];
	                if (!(c[g >> 2] & 1)) {
	                    if (c[g >> 2] & 128)c[(c[h >> 2] | 0) + 40 >> 2] = 2
	                } else c[(c[h >> 2] | 0) + 40 >> 2] = 1;
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function MR(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zk(c[(c[d >> 2] | 0) + 24 >> 2] | 0) | 0;
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function NR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                d = i;
	                i = i + 64 | 0;
	                e = d + 52 | 0;
	                f = d + 48 | 0;
	                g = d + 44 | 0;
	                h = d + 40 | 0;
	                j = d + 36 | 0;
	                k = d + 32 | 0;
	                l = d + 28 | 0;
	                m = d + 24 | 0;
	                n = d + 20 | 0;
	                o = d + 16 | 0;
	                p = d + 12 | 0;
	                q = d + 8 | 0;
	                r = d + 4 | 0;
	                s = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                c[k >> 2] = c[(c[g >> 2] | 0) + 60 >> 2];
	                c[l >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                c[m >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                c[n >> 2] = c[(c[f >> 2] | 0) + 116 >> 2];
	                c[o >> 2] = c[(c[f >> 2] | 0) + 120 >> 2];
	                c[p >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                c[r >> 2] = 0;
	                Rf();
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 13 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 9 : 0) {
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                do if (!(c[(c[f >> 2] | 0) + 16 >> 2] | 0)) {
	                    b = c[g >> 2] | 0;
	                    if (c[(c[g >> 2] | 0) + 60 >> 2] | 0) {
	                        c[m >> 2] = c[b + 60 >> 2];
	                        break
	                    }
	                    if ((c[b + 76 >> 2] | 0) != 1)c[m >> 2] = xd(c[(c[g >> 2] | 0) + 76 >> 2] | 0) | 0
	                } else c[(c[g >> 2] | 0) + 60 >> 2] = c[(c[f >> 2] | 0) + 16 >> 2]; while (0);
	                if (!(((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 13 ? (c[(c[f >> 2] | 0) + 32 >> 2] & 32 | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] & 16 | 0) == 0 : 0))u = 13;
	                if ((u | 0) == 13 ? (c[(c[f >> 2] | 0) + 32 >> 2] & 64 | 0) == 0 : 0) {
	                    if (!(((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[f >> 2] | 0) + 32 >> 2] & 32 | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] & 16 | 0) == 0 : 0))u = 34;
	                    a:do if ((u | 0) == 34) {
	                        c[q >> 2] = wd(c[m >> 2] | 0) | 0;
	                        if ((((c[m >> 2] | 0) != 0 & (c[l >> 2] | 0) == 0 ? (c[(c[p >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[p >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] & 2 | 0) == 0 : 0) {
	                            do if ((c[q >> 2] | 0) != 1 & (c[q >> 2] | 0) != 0 & (c[q >> 2] | 0) != 22) {
	                                if ((VR(c[f >> 2] | 0, c[m >> 2] | 0) | 0) >= 0) {
	                                    c[r >> 2] = 1;
	                                    break
	                                }
	                                c[(c[g >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                                c[e >> 2] = -1;
	                                t = c[e >> 2] | 0;
	                                i = d;
	                                return t | 0
	                            } while (0);
	                            if ((c[(c[f >> 2] | 0) + 116 >> 2] | 0) == 389)c[(c[f >> 2] | 0) + 116 >> 2] = 0;
	                            if ((c[(c[f >> 2] | 0) + 120 >> 2] | 0) == 389)c[(c[f >> 2] | 0) + 120 >> 2] = 0
	                        }
	                        if (!(c[(c[f >> 2] | 0) + 32 >> 2] & 2)) {
	                            Ok(c[p >> 2] | 0, 14, 201632) | 0;
	                            b = c[p >> 2] | 0;
	                            if (c[(c[g >> 2] | 0) + 56 >> 2] | 0)gz(c[b + 16 >> 2] | 0, c[(c[g >> 2] | 0) + 56 >> 2] | 0) | 0; else Ok(b, 5, 201648) | 0;
	                            if (c[m >> 2] | 0) {
	                                Ok(c[p >> 2] | 0, 10, 201656) | 0;
	                                gz(c[(c[p >> 2] | 0) + 16 >> 2] | 0, c[m >> 2] | 0) | 0
	                            }
	                            b = c[(c[g >> 2] | 0) + 40 >> 2] | 0;
	                            if ((b | 0) == 1)Ok(c[p >> 2] | 0, 17, 201696) | 0; else if (!b)Ok(c[p >> 2] | 0, 16, 201672) | 0;
	                            Ok(c[p >> 2] | 0, 3, 201720) | 0
	                        }
	                        if (c[(c[f >> 2] | 0) + 32 >> 2] & 16)c[j >> 2] = 1;
	                        if ((c[(c[f >> 2] | 0) + 32 >> 2] & 8 | 0) == 0 ? (c[h >> 2] = Nh(c[g >> 2] | 0) | 0, (c[h >> 2] | 0) != 0) : 0) {
	                            b = lR(c[(c[h >> 2] | 0) + 56 >> 2] | 0, c[(c[h >> 2] | 0) + 52 >> 2] | 0) | 0;
	                            c[j >> 2] = b;
	                            c[j >> 2] = (c[j >> 2] | 0) < 0 ? 0 : b
	                        }
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                            c[s >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[s >> 2] | 0))break a;
	                                c[(c[f >> 2] | 0) + 36 >> 2] = 0;
	                                b = c[f >> 2] | 0;
	                                a = c[s >> 2] | 0;
	                                if (c[j >> 2] | 0)TR(b, a); else OR(b, a);
	                                Ok(c[p >> 2] | 0, 1, 200976) | 0;
	                                c[s >> 2] = c[(c[s >> 2] | 0) + 24 >> 2]
	                            }
	                        }
	                    } while (0);
	                    if ((c[r >> 2] | 0) != 0 & (c[l >> 2] | 0) == 0) {
	                        XR(c[f >> 2] | 0) | 0;
	                        c[(c[f >> 2] | 0) + 116 >> 2] = c[n >> 2];
	                        c[(c[f >> 2] | 0) + 120 >> 2] = c[o >> 2]
	                    }
	                    c[(c[g >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                    c[e >> 2] = 0;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                if (c[m >> 2] | 0)rp(c[g >> 2] | 0, c[m >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0))c[m >> 2] = qp(c[g >> 2] | 0) | 0;
	                if (!(c[m >> 2] | 0))c[m >> 2] = 201592;
	                if ((((c[m >> 2] | 0) != 0 & (c[l >> 2] | 0) == 0 ? (c[(c[p >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[p >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) ? (VR(c[f >> 2] | 0, c[m >> 2] | 0) | 0) < 0 : 0) {
	                    c[(c[g >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                    c[e >> 2] = -1;
	                    t = c[e >> 2] | 0;
	                    i = d;
	                    return t | 0
	                }
	                l = c[p >> 2] | 0;
	                p = c[g >> 2] | 0;
	                o = c[m >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 32 >> 2] & 1)wp(l, p, o, 1); else wp(l, p, o, 0);
	                if (c[(c[f >> 2] | 0) + 16 >> 2] | 0)c[(c[g >> 2] | 0) + 60 >> 2] = c[k >> 2];
	                c[e >> 2] = 0;
	                t = c[e >> 2] | 0;
	                i = d;
	                return t | 0
	            }

	            function OR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 24 | 0;
	                g = e + 20 | 0;
	                h = e + 16 | 0;
	                j = e + 12 | 0;
	                k = e + 8 | 0;
	                l = e + 4 | 0;
	                m = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[m >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 19) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 20) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    if (c[(c[f >> 2] | 0) + 32 >> 2] & 16) {
	                        TR(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    if (!((((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 18 ? (c[(c[g >> 2] | 0) + 32 >> 2] | 0) != 0 : 0) ? (c[(c[(c[g >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0) == 13 : 0) ? (c[(c[f >> 2] | 0) + 32 >> 2] & 32 | 0) == 0 : 0))n = 13;
	                    if ((n | 0) == 13 ? (c[(c[f >> 2] | 0) + 32 >> 2] & 64 | 0) == 0 : 0) {
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                            ZR(c[f >> 2] | 0, c[g >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 11) {
	                            _R(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 15) {
	                            nR(c[(c[m >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 16) {
	                            oR(c[(c[m >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                            pR(c[(c[m >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        b = c[g >> 2] | 0;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                            if (!(c[b + 40 >> 2] | 0)) {
	                                i = e;
	                                return
	                            }
	                            a = c[m >> 2] | 0;
	                            o = c[(c[g >> 2] | 0) + 40 >> 2] | 0;
	                            if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 75112) {
	                                Pk(a, o, c[(c[f >> 2] | 0) + 116 >> 2] | 0) | 0;
	                                i = e;
	                                return
	                            } else {
	                                Qk(a, o) | 0;
	                                i = e;
	                                return
	                            }
	                        }
	                        o = c[g >> 2] | 0;
	                        if ((c[b + 4 >> 2] | 0) == 7) {
	                            b = (c[o + 40 >> 2] | 0) != 0;
	                            Ok(c[m >> 2] | 0, 2, 200752) | 0;
	                            Qk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            if (!b) {
	                                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 2)UR(c[f >> 2] | 0, 0);
	                                Ok(c[m >> 2] | 0, 2, 200768) | 0;
	                                i = e;
	                                return
	                            }
	                            if (c[(c[g >> 2] | 0) + 40 >> 2] | 0) {
	                                if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 2)UR(c[f >> 2] | 0, 0); else Ok(c[m >> 2] | 0, 1, 200760) | 0;
	                                Qk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0
	                            }
	                            Ok(c[m >> 2] | 0, 2, 200768) | 0;
	                            i = e;
	                            return
	                        }
	                        b = c[g >> 2] | 0;
	                        if ((c[o + 4 >> 2] | 0) == 8) {
	                            if (!(c[b + 40 >> 2] | 0)) {
	                                i = e;
	                                return
	                            }
	                            Ok(c[m >> 2] | 0, 4, 200776) | 0;
	                            Qk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            Ok(c[m >> 2] | 0, 3, 200784) | 0;
	                            i = e;
	                            return
	                        }
	                        if ((c[b + 4 >> 2] | 0) == 5) {
	                            Ok(c[m >> 2] | 0, 1, 200792) | 0;
	                            Qk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            Ok(c[m >> 2] | 0, 1, 200800) | 0;
	                            i = e;
	                            return
	                        }
	                        b = c[g >> 2] | 0;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 4) {
	                            do if (c[b + 40 >> 2] | 0) {
	                                if (!(d[c[(c[g >> 2] | 0) + 40 >> 2] >> 0] | 0))break;
	                                o = c[(c[g >> 2] | 0) + 40 >> 2] | 0;
	                                c[l >> 2] = o;
	                                c[k >> 2] = o;
	                                while (1) {
	                                    if (!(d[c[l >> 2] >> 0] | 0))break;
	                                    do if ((d[c[l >> 2] >> 0] | 0 | 0) == 93) {
	                                        if ((d[(c[l >> 2] | 0) + 1 >> 0] | 0 | 0) != 93)break;
	                                        if ((d[(c[l >> 2] | 0) + 2 >> 0] | 0 | 0) != 62)break;
	                                        c[l >> 2] = (c[l >> 2] | 0) + 2;
	                                        Ok(c[m >> 2] | 0, 9, 200824) | 0;
	                                        Ok(c[m >> 2] | 0, (c[l >> 2] | 0) - (c[k >> 2] | 0) | 0, c[k >> 2] | 0) | 0;
	                                        Ok(c[m >> 2] | 0, 3, 200840) | 0;
	                                        c[k >> 2] = c[l >> 2]
	                                    } while (0);
	                                    c[l >> 2] = (c[l >> 2] | 0) + 1
	                                }
	                                if ((c[k >> 2] | 0) == (c[l >> 2] | 0)) {
	                                    i = e;
	                                    return
	                                }
	                                Ok(c[m >> 2] | 0, 9, 200824) | 0;
	                                Qk(c[m >> 2] | 0, c[k >> 2] | 0) | 0;
	                                Ok(c[m >> 2] | 0, 3, 200840) | 0;
	                                i = e;
	                                return
	                            } while (0);
	                            Ok(c[m >> 2] | 0, 12, 200808) | 0;
	                            i = e;
	                            return
	                        }
	                        if ((c[b + 4 >> 2] | 0) == 2) {
	                            $R(c[f >> 2] | 0, c[g >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        b = c[f >> 2] | 0;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                            aS(b, c[g >> 2] | 0);
	                            i = e;
	                            return
	                        }
	                        c[h >> 2] = c[b + 40 >> 2];
	                        a:do if ((c[h >> 2] | 0) == 1) {
	                            c[j >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                            while (1) {
	                                if (!(c[j >> 2] | 0))break a;
	                                if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 3)break;
	                                if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 4)break;
	                                if ((c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 5)break;
	                                c[j >> 2] = c[(c[j >> 2] | 0) + 24 >> 2]
	                            }
	                            c[(c[f >> 2] | 0) + 40 >> 2] = 0
	                        } while (0);
	                        Ok(c[m >> 2] | 0, 1, 200848) | 0;
	                        do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                            if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                            Qk(c[m >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            Ok(c[m >> 2] | 0, 1, 200856) | 0
	                        } while (0);
	                        Qk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (c[(c[g >> 2] | 0) + 48 >> 2] | 0)bS(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 48 >> 2] | 0);
	                        if (c[(c[g >> 2] | 0) + 44 >> 2] | 0)cS(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 44 >> 2] | 0);
	                        if (!((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[g >> 2] | 0) + 40 >> 2] | 0) != 0 : 0))n = 80;
	                        do if ((n | 0) == 80) {
	                            if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)break;
	                            if (c[(c[f >> 2] | 0) + 32 >> 2] & 4)break;
	                            if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 2)UR(c[f >> 2] | 0, 0);
	                            Ok(c[m >> 2] | 0, 2, 201584) | 0;
	                            c[(c[f >> 2] | 0) + 40 >> 2] = c[h >> 2];
	                            i = e;
	                            return
	                        } while (0);
	                        if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 2)UR(c[f >> 2] | 0, 1);
	                        Ok(c[m >> 2] | 0, 1, 200968) | 0;
	                        do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                            if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0))break;
	                            Pk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[(c[f >> 2] | 0) + 116 >> 2] | 0) | 0
	                        } while (0);
	                        do if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                            if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 1)Ok(c[m >> 2] | 0, 1, 200976) | 0;
	                            if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) >= 0) {
	                                n = (c[f >> 2] | 0) + 36 | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + 1
	                            }
	                            _R(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                            if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) > 0) {
	                                n = (c[f >> 2] | 0) + 36 | 0;
	                                c[n >> 2] = (c[n >> 2] | 0) + -1
	                            }
	                            if (!(c[33984] | 0))break;
	                            if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 1)break;
	                            n = c[f >> 2] | 0;
	                            if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) > (c[(c[f >> 2] | 0) + 108 >> 2] | 0))p = c[n + 108 >> 2] | 0; else p = c[n + 36 >> 2] | 0;
	                            n = ca(c[(c[f >> 2] | 0) + 112 >> 2] | 0, p) | 0;
	                            Ok(c[m >> 2] | 0, n, (c[f >> 2] | 0) + 44 | 0) | 0
	                        } while (0);
	                        Ok(c[m >> 2] | 0, 2, 201056) | 0;
	                        do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                            if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                            Qk(c[m >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            Ok(c[m >> 2] | 0, 1, 200856) | 0
	                        } while (0);
	                        Qk(c[m >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 2)UR(c[f >> 2] | 0, 0);
	                        Ok(c[m >> 2] | 0, 1, 200968) | 0;
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[h >> 2];
	                        i = e;
	                        return
	                    }
	                    YR(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    i = e;
	                    return
	                }
	                NR(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function PR(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                c[j >> 2] = 0;
	                d = c[f >> 2] | 0;
	                if ((d | 0) == 1400)c[j >> 2] = 201440; else if ((d | 0) == 1403)c[j >> 2] = 201496; else if ((d | 0) == 1401)c[j >> 2] = 201464; else if ((d | 0) == 1402)c[j >> 2] = 201520; else c[j >> 2] = 201552;
	                ce(7, c[f >> 2] | 0, c[g >> 2] | 0, c[j >> 2] | 0, c[h >> 2] | 0);
	                i = e;
	                return
	            }

	            function QR(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = b;
	                c[g >> 2] = d;
	                d = c[f >> 2] | 0;
	                c[f >> 2] = d + 1;
	                a[d >> 0] = 38;
	                d = c[f >> 2] | 0;
	                c[f >> 2] = d + 1;
	                a[d >> 0] = 35;
	                d = c[f >> 2] | 0;
	                c[f >> 2] = d + 1;
	                a[d >> 0] = 120;
	                do if ((c[g >> 2] | 0) >= 16) {
	                    if ((c[g >> 2] | 0) < 256) {
	                        c[h >> 2] = (c[f >> 2] | 0) + 1;
	                        break
	                    }
	                    if ((c[g >> 2] | 0) < 4096) {
	                        c[h >> 2] = (c[f >> 2] | 0) + 2;
	                        break
	                    }
	                    if ((c[g >> 2] | 0) < 65536) {
	                        c[h >> 2] = (c[f >> 2] | 0) + 3;
	                        break
	                    }
	                    d = c[f >> 2] | 0;
	                    if ((c[g >> 2] | 0) < 1048576) {
	                        c[h >> 2] = d + 4;
	                        break
	                    } else {
	                        c[h >> 2] = d + 5;
	                        break
	                    }
	                } else c[h >> 2] = c[f >> 2]; while (0);
	                c[f >> 2] = (c[h >> 2] | 0) + 1;
	                while (1) {
	                    if ((c[g >> 2] | 0) <= 0)break;
	                    do switch (c[g >> 2] & 15 | 0) {
	                        case 14:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 69;
	                            break
	                        }
	                        case 10:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 65;
	                            break
	                        }
	                        case 2:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 50;
	                            break
	                        }
	                        case 7:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 55;
	                            break
	                        }
	                        case 9:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 57;
	                            break
	                        }
	                        case 5:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 53;
	                            break
	                        }
	                        case 12:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 67;
	                            break
	                        }
	                        case 0:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 48;
	                            break
	                        }
	                        case 3:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 51;
	                            break
	                        }
	                        case 11:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 66;
	                            break
	                        }
	                        case 15:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 70;
	                            break
	                        }
	                        case 13:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 68;
	                            break
	                        }
	                        case 6:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 54;
	                            break
	                        }
	                        case 8:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 56;
	                            break
	                        }
	                        case 4:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 52;
	                            break
	                        }
	                        case 1:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 49;
	                            break
	                        }
	                        default:
	                        {
	                            d = c[h >> 2] | 0;
	                            c[h >> 2] = d + -1;
	                            a[d >> 0] = 48
	                        }
	                    } while (0);
	                    c[g >> 2] = c[g >> 2] >> 4
	                }
	                g = c[f >> 2] | 0;
	                c[f >> 2] = g + 1;
	                a[g >> 0] = 59;
	                a[c[f >> 2] >> 0] = 0;
	                i = e;
	                return c[f >> 2] | 0
	            }

	            function RR(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                ce(7, 2, 0, 0, c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function SR(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 16 >> 2] | 0) == 0 ? (c[(c[e >> 2] | 0) + 116 >> 2] | 0) == 0 : 0)c[(c[e >> 2] | 0) + 116 >> 2] = 389;
	                c[g >> 2] = xy(c[33988] | 0) | 0;
	                if ((c[33988] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    b = (c[e >> 2] | 0) + 44 | 0;
	                    h = b + 61 | 0;
	                    do {
	                        a[b >> 0] = 0;
	                        b = b + 1 | 0
	                    } while ((b | 0) < (h | 0))
	                } else {
	                    c[(c[e >> 2] | 0) + 112 >> 2] = c[g >> 2];
	                    c[(c[e >> 2] | 0) + 108 >> 2] = 60 / (c[(c[e >> 2] | 0) + 112 >> 2] | 0) | 0;
	                    c[f >> 2] = 0;
	                    while (1) {
	                        if ((c[f >> 2] | 0) >= (c[(c[e >> 2] | 0) + 108 >> 2] | 0))break;
	                        g = ca(c[f >> 2] | 0, c[(c[e >> 2] | 0) + 112 >> 2] | 0) | 0;
	                        eU((c[e >> 2] | 0) + 44 + g | 0, c[33988] | 0, c[(c[e >> 2] | 0) + 112 >> 2] | 0) | 0;
	                        c[f >> 2] = (c[f >> 2] | 0) + 1
	                    }
	                    f = ca(c[(c[e >> 2] | 0) + 108 >> 2] | 0, c[(c[e >> 2] | 0) + 112 >> 2] | 0) | 0;
	                    a[(c[e >> 2] | 0) + 44 + f >> 0] = 0
	                }
	                if (!(c[33990] | 0)) {
	                    i = d;
	                    return
	                }
	                f = (c[e >> 2] | 0) + 32 | 0;
	                c[f >> 2] = c[f >> 2] | 4;
	                i = d;
	                return
	            }

	            function TR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                e = i;
	                i = i + 48 | 0;
	                f = e + 36 | 0;
	                g = e + 32 | 0;
	                h = e + 28 | 0;
	                j = e + 24 | 0;
	                k = e + 20 | 0;
	                l = e + 16 | 0;
	                m = e + 12 | 0;
	                n = e + 8 | 0;
	                o = e + 4 | 0;
	                p = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 9 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 13 : 0) {
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 19) {
	                        i = e;
	                        return
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 20) {
	                        i = e;
	                        return
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 18) {
	                        aS(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 14) {
	                        ZR(c[f >> 2] | 0, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    b = c[f >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 11) {
	                        dS(b, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    c[n >> 2] = c[b + 24 >> 2];
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 15) {
	                        nR(c[(c[n >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 16) {
	                        oR(c[(c[n >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 17) {
	                        pR(c[(c[n >> 2] | 0) + 16 >> 2] | 0, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    b = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 3) {
	                        if (!(c[b + 40 >> 2] | 0)) {
	                            i = e;
	                            return
	                        }
	                        if ((c[(c[g >> 2] | 0) + 8 >> 2] | 0) != 75104 ? (c[(c[g >> 2] | 0) + 8 >> 2] | 0) == 75112 : 0) {
	                            Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                            i = e;
	                            return
	                        }
	                        Pk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[(c[f >> 2] | 0) + 116 >> 2] | 0) | 0;
	                        i = e;
	                        return
	                    }
	                    a = c[g >> 2] | 0;
	                    if ((c[b + 4 >> 2] | 0) == 7) {
	                        b = (c[a + 40 >> 2] | 0) != 0;
	                        Ok(c[n >> 2] | 0, 2, 200752) | 0;
	                        Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        if (!b) {
	                            Ok(c[n >> 2] | 0, 2, 200768) | 0;
	                            i = e;
	                            return
	                        }
	                        if (c[(c[g >> 2] | 0) + 40 >> 2] | 0) {
	                            Ok(c[n >> 2] | 0, 1, 200760) | 0;
	                            Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0
	                        }
	                        Ok(c[n >> 2] | 0, 2, 200768) | 0;
	                        i = e;
	                        return
	                    }
	                    b = c[g >> 2] | 0;
	                    if ((c[a + 4 >> 2] | 0) == 8) {
	                        if (!(c[b + 40 >> 2] | 0)) {
	                            i = e;
	                            return
	                        }
	                        Ok(c[n >> 2] | 0, 4, 200776) | 0;
	                        Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0) | 0;
	                        Ok(c[n >> 2] | 0, 3, 200784) | 0;
	                        i = e;
	                        return
	                    }
	                    if ((c[b + 4 >> 2] | 0) == 5) {
	                        Ok(c[n >> 2] | 0, 1, 200792) | 0;
	                        Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        Ok(c[n >> 2] | 0, 1, 200800) | 0;
	                        i = e;
	                        return
	                    }
	                    b = c[g >> 2] | 0;
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 4) {
	                        do if (c[b + 40 >> 2] | 0) {
	                            if (!(d[c[(c[g >> 2] | 0) + 40 >> 2] >> 0] | 0))break;
	                            a = c[(c[g >> 2] | 0) + 40 >> 2] | 0;
	                            c[m >> 2] = a;
	                            c[l >> 2] = a;
	                            while (1) {
	                                if (!(d[c[m >> 2] >> 0] | 0))break;
	                                do if ((d[c[m >> 2] >> 0] | 0 | 0) == 93) {
	                                    if ((d[(c[m >> 2] | 0) + 1 >> 0] | 0 | 0) != 93)break;
	                                    if ((d[(c[m >> 2] | 0) + 2 >> 0] | 0 | 0) != 62)break;
	                                    c[m >> 2] = (c[m >> 2] | 0) + 2;
	                                    Ok(c[n >> 2] | 0, 9, 200824) | 0;
	                                    Ok(c[n >> 2] | 0, (c[m >> 2] | 0) - (c[l >> 2] | 0) | 0, c[l >> 2] | 0) | 0;
	                                    Ok(c[n >> 2] | 0, 3, 200840) | 0;
	                                    c[l >> 2] = c[m >> 2]
	                                } while (0);
	                                c[m >> 2] = (c[m >> 2] | 0) + 1
	                            }
	                            if ((c[l >> 2] | 0) == (c[m >> 2] | 0)) {
	                                i = e;
	                                return
	                            }
	                            Ok(c[n >> 2] | 0, 9, 200824) | 0;
	                            Qk(c[n >> 2] | 0, c[l >> 2] | 0) | 0;
	                            Ok(c[n >> 2] | 0, 3, 200840) | 0;
	                            i = e;
	                            return
	                        } while (0);
	                        Ok(c[n >> 2] | 0, 12, 200808) | 0;
	                        i = e;
	                        return
	                    }
	                    l = c[f >> 2] | 0;
	                    if ((c[b + 4 >> 2] | 0) == 2) {
	                        $R(l, c[g >> 2] | 0);
	                        i = e;
	                        return
	                    }
	                    c[h >> 2] = c[l + 40 >> 2];
	                    a:do if ((c[h >> 2] | 0) == 1) {
	                        c[k >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break a;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 3)break;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 5)break;
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                        c[h >> 2] = 0
	                    } while (0);
	                    Ok(c[n >> 2] | 0, 1, 200848) | 0;
	                    do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                        if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                        Qk(c[n >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        Ok(c[n >> 2] | 0, 1, 200856) | 0
	                    } while (0);
	                    Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    if (c[(c[g >> 2] | 0) + 48 >> 2] | 0)bS(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 48 >> 2] | 0);
	                    do if (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 200864) | 0) {
	                        if (c[(c[g >> 2] | 0) + 36 >> 2] | 0)break;
	                        if (c[(c[g >> 2] | 0) + 48 >> 2] | 0)break;
	                        Qk(c[n >> 2] | 0, 200872) | 0
	                    } while (0);
	                    if (c[(c[g >> 2] | 0) + 44 >> 2] | 0)eS(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 44 >> 2] | 0);
	                    do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        if (!(c[(c[g >> 2] | 0) + 20 >> 2] | 0))break;
	                        if ((c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 20 >> 2] | 0) != (c[(c[g >> 2] | 0) + 32 >> 2] | 0))break;
	                        if (!(qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 200912) | 0))break;
	                        if (!(qy(c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0, 200864) | 0))break;
	                        c[k >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                        b:while (1) {
	                            if (!(c[k >> 2] | 0))break;
	                            do if (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 200920) | 0) {
	                                c[o >> 2] = Yi(c[k >> 2] | 0, 200928) | 0;
	                                if (!(c[o >> 2] | 0))break;
	                                l = (ty(c[o >> 2] | 0, 200944) | 0) == 0;
	                                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                                if (l)break b
	                            } while (0);
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                        if (c[k >> 2] | 0)break;
	                        c[j >> 2] = 1
	                    } while (0);
	                    do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                        if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)break;
	                        if (!((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0))q = 86;
	                        do if ((q | 0) == 86) {
	                            k = (fS(c[g >> 2] | 0) | 0) == 1;
	                            if (!(k & (c[j >> 2] | 0) == 0))break;
	                            Ok(c[n >> 2] | 0, 3, 200960) | 0;
	                            i = e;
	                            return
	                        } while (0);
	                        k = (c[j >> 2] | 0) == 1;
	                        Ok(c[n >> 2] | 0, 1, 200968) | 0;
	                        do if (k) {
	                            do if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 1) {
	                                Ok(c[n >> 2] | 0, 1, 200976) | 0;
	                                if (!(c[33984] | 0))break;
	                                o = c[f >> 2] | 0;
	                                if (((c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 1 | 0) > (c[(c[f >> 2] | 0) + 108 >> 2] | 0))r = c[o + 108 >> 2] | 0; else r = (c[o + 36 >> 2] | 0) + 1 | 0;
	                                o = ca(c[(c[f >> 2] | 0) + 112 >> 2] | 0, r) | 0;
	                                Ok(c[n >> 2] | 0, o, (c[f >> 2] | 0) + 44 | 0) | 0
	                            } while (0);
	                            Qk(c[n >> 2] | 0, 200984) | 0;
	                            o = c[n >> 2] | 0;
	                            if (c[(c[f >> 2] | 0) + 16 >> 2] | 0)Qk(o, c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0; else Ok(o, 5, 200728) | 0;
	                            Ok(c[n >> 2] | 0, 4, 201048) | 0;
	                            if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) != 1)break;
	                            Ok(c[n >> 2] | 0, 1, 200976) | 0
	                        } while (0);
	                        Ok(c[n >> 2] | 0, 2, 201056) | 0;
	                        do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                            if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                            Qk(c[n >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                            Ok(c[n >> 2] | 0, 1, 200856) | 0
	                        } while (0);
	                        Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                        Ok(c[n >> 2] | 0, 1, 200968) | 0;
	                        i = e;
	                        return
	                    } while (0);
	                    Ok(c[n >> 2] | 0, 1, 200968) | 0;
	                    if ((c[j >> 2] | 0) == 1) {
	                        do if ((c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 1) {
	                            Ok(c[n >> 2] | 0, 1, 200976) | 0;
	                            if (!(c[33984] | 0))break;
	                            j = c[f >> 2] | 0;
	                            if (((c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 1 | 0) > (c[(c[f >> 2] | 0) + 108 >> 2] | 0))s = c[j + 108 >> 2] | 0; else s = (c[j + 36 >> 2] | 0) + 1 | 0;
	                            j = ca(c[(c[f >> 2] | 0) + 112 >> 2] | 0, s) | 0;
	                            Ok(c[n >> 2] | 0, j, (c[f >> 2] | 0) + 44 | 0) | 0
	                        } while (0);
	                        Qk(c[n >> 2] | 0, 200984) | 0;
	                        s = c[n >> 2] | 0;
	                        if (c[(c[f >> 2] | 0) + 16 >> 2] | 0)Qk(s, c[(c[f >> 2] | 0) + 16 >> 2] | 0) | 0; else Ok(s, 5, 200728) | 0;
	                        Ok(c[n >> 2] | 0, 4, 201048) | 0
	                    }
	                    do if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        if (!(c[(c[g >> 2] | 0) + 40 >> 2] | 0))break;
	                        Pk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[(c[f >> 2] | 0) + 116 >> 2] | 0) | 0
	                    } while (0);
	                    do if (c[(c[g >> 2] | 0) + 12 >> 2] | 0) {
	                        c[p >> 2] = c[(c[f >> 2] | 0) + 40 >> 2];
	                        if ((c[h >> 2] | 0) == 1)Ok(c[n >> 2] | 0, 1, 200976) | 0;
	                        if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) >= 0) {
	                            s = (c[f >> 2] | 0) + 36 | 0;
	                            c[s >> 2] = (c[s >> 2] | 0) + 1
	                        }
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[h >> 2];
	                        dS(c[f >> 2] | 0, c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                        if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) > 0) {
	                            s = (c[f >> 2] | 0) + 36 | 0;
	                            c[s >> 2] = (c[s >> 2] | 0) + -1
	                        }
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[p >> 2];
	                        if (!((c[33984] | 0) != 0 & (c[h >> 2] | 0) == 1))break;
	                        s = c[f >> 2] | 0;
	                        if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) > (c[(c[f >> 2] | 0) + 108 >> 2] | 0))t = c[s + 108 >> 2] | 0; else t = c[s + 36 >> 2] | 0;
	                        s = ca(c[(c[f >> 2] | 0) + 112 >> 2] | 0, t) | 0;
	                        Ok(c[n >> 2] | 0, s, (c[f >> 2] | 0) + 44 | 0) | 0
	                    } while (0);
	                    Ok(c[n >> 2] | 0, 2, 201056) | 0;
	                    do if (c[(c[g >> 2] | 0) + 36 >> 2] | 0) {
	                        if (!(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0))break;
	                        Qk(c[n >> 2] | 0, c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                        Ok(c[n >> 2] | 0, 1, 200856) | 0
	                    } while (0);
	                    Qk(c[n >> 2] | 0, c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                    Ok(c[n >> 2] | 0, 1, 200968) | 0;
	                    i = e;
	                    return
	                }
	                NR(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                i = e;
	                return
	            }

	            function UR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[e >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 24 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                Ok(c[(c[e >> 2] | 0) + 24 >> 2] | 0, 1, 200976) | 0;
	                c[g >> 2] = 0;
	                while (1) {
	                    if ((c[g >> 2] | 0) >= ((c[(c[e >> 2] | 0) + 36 >> 2] | 0) + (c[f >> 2] | 0) | 0))break;
	                    b = c[e >> 2] | 0;
	                    if (((c[(c[e >> 2] | 0) + 36 >> 2] | 0) + (c[f >> 2] | 0) - (c[g >> 2] | 0) | 0) > (c[(c[e >> 2] | 0) + 108 >> 2] | 0))h = c[b + 108 >> 2] | 0; else h = (c[b + 36 >> 2] | 0) + (c[f >> 2] | 0) - (c[g >> 2] | 0) | 0;
	                    b = ca(c[(c[e >> 2] | 0) + 112 >> 2] | 0, h) | 0;
	                    Ok(c[(c[e >> 2] | 0) + 24 >> 2] | 0, b, (c[e >> 2] | 0) + 44 | 0) | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + (c[(c[e >> 2] | 0) + 108 >> 2] | 0)
	                }
	                i = d;
	                return
	            }

	            function VR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                do if (((c[g >> 2] | 0) != 0 ? (c[(c[h >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[h >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) {
	                    f = Dd(c[g >> 2] | 0) | 0;
	                    c[(c[h >> 2] | 0) + 12 >> 2] = f;
	                    if (!(c[(c[h >> 2] | 0) + 12 >> 2] | 0)) {
	                        PR(1403, 0, c[g >> 2] | 0);
	                        c[e >> 2] = -1;
	                        j = c[e >> 2] | 0;
	                        i = d;
	                        return j | 0
	                    }
	                    f = Ly() | 0;
	                    c[(c[h >> 2] | 0) + 20 >> 2] = f;
	                    f = c[h >> 2] | 0;
	                    if (c[(c[h >> 2] | 0) + 20 >> 2] | 0) {
	                        Gd(f, 1) | 0;
	                        break
	                    }
	                    Hd(c[f + 12 >> 2] | 0) | 0;
	                    RR(201600);
	                    c[e >> 2] = -1;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                } while (0);
	                c[e >> 2] = 0;
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function WR(b, e, f, g) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                t = h + 4 | 0;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[p >> 2] = c[l >> 2];
	                c[q >> 2] = c[n >> 2];
	                c[r >> 2] = (c[l >> 2] | 0) + (c[c[m >> 2] >> 2] | 0);
	                c[s >> 2] = (c[n >> 2] | 0) + (c[c[o >> 2] >> 2] | 0);
	                a:while (1) {
	                    if ((c[n >> 2] | 0) >>> 0 >= (c[s >> 2] | 0) >>> 0) {
	                        u = 46;
	                        break
	                    }
	                    if ((c[l >> 2] | 0) >>> 0 >= (c[r >> 2] | 0) >>> 0) {
	                        u = 46;
	                        break
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 60) {
	                        if (((c[r >> 2] | 0) - (c[l >> 2] | 0) | 0) < 4) {
	                            u = 46;
	                            break
	                        }
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 38;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 108;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 116;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 59;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 62) {
	                        if (((c[r >> 2] | 0) - (c[l >> 2] | 0) | 0) < 4) {
	                            u = 46;
	                            break
	                        }
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 38;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 103;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 116;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 59;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        continue
	                    }
	                    if ((d[c[n >> 2] >> 0] | 0 | 0) == 38) {
	                        if (((c[r >> 2] | 0) - (c[l >> 2] | 0) | 0) < 5) {
	                            u = 46;
	                            break
	                        }
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 38;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 97;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 109;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 112;
	                        g = c[l >> 2] | 0;
	                        c[l >> 2] = g + 1;
	                        a[g >> 0] = 59;
	                        c[n >> 2] = (c[n >> 2] | 0) + 1;
	                        continue
	                    }
	                    if (!((d[c[n >> 2] >> 0] | 0 | 0) >= 32 ? (d[c[n >> 2] >> 0] | 0 | 0) < 128 : 0))u = 15;
	                    if (((u | 0) == 15 ? (u = 0, (d[c[n >> 2] >> 0] | 0 | 0) != 10) : 0) ? (d[c[n >> 2] >> 0] | 0 | 0) != 9 : 0) {
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) < 128) {
	                            if (!(9 <= (d[c[n >> 2] >> 0] | 0 | 0) ? (d[c[n >> 2] >> 0] | 0 | 0) <= 10 : 0))u = 41;
	                            if (((u | 0) == 41 ? (u = 0, (d[c[n >> 2] >> 0] | 0 | 0) != 13) : 0) ? 32 > (d[c[n >> 2] >> 0] | 0 | 0) : 0) {
	                                u = 45;
	                                break
	                            }
	                            if (((c[r >> 2] | 0) - (c[l >> 2] | 0) | 0) < 6) {
	                                u = 46;
	                                break
	                            }
	                            g = c[l >> 2] | 0;
	                            f = c[n >> 2] | 0;
	                            c[n >> 2] = f + 1;
	                            c[l >> 2] = QR(g, d[f >> 0] | 0) | 0;
	                            continue
	                        }
	                        if (((c[r >> 2] | 0) - (c[l >> 2] | 0) | 0) < 11) {
	                            u = 46;
	                            break
	                        }
	                        if ((d[c[n >> 2] >> 0] | 0 | 0) < 192) {
	                            u = 21;
	                            break
	                        }
	                        do if ((d[c[n >> 2] >> 0] | 0 | 0) < 224) {
	                            if (((c[s >> 2] | 0) - (c[n >> 2] | 0) | 0) < 2) {
	                                u = 46;
	                                break a
	                            }
	                            c[t >> 2] = (d[c[n >> 2] >> 0] | 0) & 31;
	                            c[t >> 2] = c[t >> 2] << 6;
	                            c[t >> 2] = c[t >> 2] | (d[(c[n >> 2] | 0) + 1 >> 0] | 0) & 63;
	                            c[n >> 2] = (c[n >> 2] | 0) + 2
	                        } else {
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) < 240) {
	                                if (((c[s >> 2] | 0) - (c[n >> 2] | 0) | 0) < 3) {
	                                    u = 46;
	                                    break a
	                                }
	                                c[t >> 2] = (d[c[n >> 2] >> 0] | 0) & 15;
	                                c[t >> 2] = c[t >> 2] << 6;
	                                c[t >> 2] = c[t >> 2] | (d[(c[n >> 2] | 0) + 1 >> 0] | 0) & 63;
	                                c[t >> 2] = c[t >> 2] << 6;
	                                c[t >> 2] = c[t >> 2] | (d[(c[n >> 2] | 0) + 2 >> 0] | 0) & 63;
	                                c[n >> 2] = (c[n >> 2] | 0) + 3;
	                                break
	                            }
	                            if ((d[c[n >> 2] >> 0] | 0 | 0) >= 248) {
	                                u = 31;
	                                break a
	                            }
	                            if (((c[s >> 2] | 0) - (c[n >> 2] | 0) | 0) < 4) {
	                                u = 46;
	                                break a
	                            }
	                            c[t >> 2] = (d[c[n >> 2] >> 0] | 0) & 7;
	                            c[t >> 2] = c[t >> 2] << 6;
	                            c[t >> 2] = c[t >> 2] | (d[(c[n >> 2] | 0) + 1 >> 0] | 0) & 63;
	                            c[t >> 2] = c[t >> 2] << 6;
	                            c[t >> 2] = c[t >> 2] | (d[(c[n >> 2] | 0) + 2 >> 0] | 0) & 63;
	                            c[t >> 2] = c[t >> 2] << 6;
	                            c[t >> 2] = c[t >> 2] | (d[(c[n >> 2] | 0) + 3 >> 0] | 0) & 63;
	                            c[n >> 2] = (c[n >> 2] | 0) + 4
	                        } while (0);
	                        f = c[t >> 2] | 0;
	                        if ((c[t >> 2] | 0) < 256) {
	                            if (!(9 <= (f | 0) & (c[t >> 2] | 0) <= 10 | (c[t >> 2] | 0) == 13 | 32 <= (c[t >> 2] | 0))) {
	                                u = 37;
	                                break
	                            }
	                        } else if ((!(256 <= (f | 0) & (c[t >> 2] | 0) <= 55295) ? !(57344 <= (c[t >> 2] | 0) & (c[t >> 2] | 0) <= 65533) : 0) ? !(65536 <= (c[t >> 2] | 0) & (c[t >> 2] | 0) <= 1114111) : 0) {
	                            u = 37;
	                            break
	                        }
	                        c[l >> 2] = QR(c[l >> 2] | 0, c[t >> 2] | 0) | 0;
	                        continue
	                    }
	                    f = c[n >> 2] | 0;
	                    c[n >> 2] = f + 1;
	                    g = a[f >> 0] | 0;
	                    f = c[l >> 2] | 0;
	                    c[l >> 2] = f + 1;
	                    a[f >> 0] = g
	                }
	                if ((u | 0) == 21) {
	                    PR(1400, 0, 0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                } else if ((u | 0) == 31) {
	                    PR(1401, 0, 0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                } else if ((u | 0) == 37) {
	                    PR(1401, 0, 0);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                } else if ((u | 0) == 45) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 201400, j);
	                    c[n >> 2] = (c[n >> 2] | 0) + 1
	                } else if ((u | 0) == 46) {
	                    c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                    c[c[o >> 2] >> 2] = (c[n >> 2] | 0) - (c[q >> 2] | 0);
	                    c[k >> 2] = 0;
	                    v = c[k >> 2] | 0;
	                    i = h;
	                    return v | 0
	                }
	                c[c[m >> 2] >> 2] = (c[l >> 2] | 0) - (c[p >> 2] | 0);
	                c[c[o >> 2] >> 2] = (c[n >> 2] | 0) - (c[q >> 2] | 0);
	                c[k >> 2] = -1;
	                v = c[k >> 2] | 0;
	                i = h;
	                return v | 0
	            }

	            function XR(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                c[e >> 2] = c[(c[d >> 2] | 0) + 24 >> 2];
	                Ak(c[e >> 2] | 0) | 0;
	                Hd(c[(c[e >> 2] | 0) + 12 >> 2] | 0) | 0;
	                Ry(c[(c[e >> 2] | 0) + 20 >> 2] | 0);
	                c[(c[e >> 2] | 0) + 12 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 20 >> 2] = 0;
	                i = b;
	                return 0
	            }

	            function YR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d + 32 | 0;
	                f = d + 28 | 0;
	                g = d + 24 | 0;
	                h = d + 20 | 0;
	                j = d + 16 | 0;
	                k = d + 12 | 0;
	                l = d + 8 | 0;
	                m = d + 4 | 0;
	                n = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                c[k >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                c[l >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                c[m >> 2] = 0;
	                Rf();
	                c[n >> 2] = c[(c[g >> 2] | 0) + 32 >> 2];
	                do if (c[n >> 2] | 0) {
	                    c[h >> 2] = c[(c[n >> 2] | 0) + 60 >> 2];
	                    if (c[(c[f >> 2] | 0) + 16 >> 2] | 0) {
	                        c[(c[n >> 2] | 0) + 60 >> 2] = c[(c[f >> 2] | 0) + 16 >> 2];
	                        break
	                    }
	                    if (c[(c[n >> 2] | 0) + 60 >> 2] | 0)c[k >> 2] = c[(c[n >> 2] | 0) + 60 >> 2]
	                } while (0);
	                if ((c[k >> 2] | 0) != 0 & (c[n >> 2] | 0) != 0)rp(c[n >> 2] | 0, c[k >> 2] | 0) | 0;
	                if ((c[k >> 2] | 0) == 0 & (c[n >> 2] | 0) != 0)c[k >> 2] = qp(c[n >> 2] | 0) | 0;
	                if (!(c[k >> 2] | 0))c[k >> 2] = 201592;
	                do if (((c[k >> 2] | 0) != 0 & (c[j >> 2] | 0) == 0 ? (c[(c[l >> 2] | 0) + 12 >> 2] | 0) == 0 : 0) ? (c[(c[l >> 2] | 0) + 20 >> 2] | 0) == 0 : 0) {
	                    if ((VR(c[f >> 2] | 0, c[k >> 2] | 0) | 0) >= 0) {
	                        c[m >> 2] = 1;
	                        break
	                    }
	                    c[(c[n >> 2] | 0) + 60 >> 2] = c[h >> 2];
	                    c[e >> 2] = -1;
	                    o = c[e >> 2] | 0;
	                    i = d;
	                    return o | 0
	                } while (0);
	                b = c[l >> 2] | 0;
	                l = c[n >> 2] | 0;
	                a = c[g >> 2] | 0;
	                g = c[k >> 2] | 0;
	                if (c[(c[f >> 2] | 0) + 32 >> 2] & 1)up(b, l, a, g, 1); else up(b, l, a, g, 0);
	                if ((c[m >> 2] | 0) != 0 & (c[j >> 2] | 0) == 0)XR(c[f >> 2] | 0) | 0;
	                if (c[n >> 2] | 0)c[(c[n >> 2] | 0) + 60 >> 2] = c[h >> 2];
	                c[e >> 2] = 0;
	                o = c[e >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function ZR(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[e >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                if (!(c[(c[e >> 2] | 0) + 24 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                Ok(c[g >> 2] | 0, 10, 201336) | 0;
	                Qk(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                if (!(c[(c[f >> 2] | 0) + 52 >> 2] | 0)) {
	                    if (c[(c[f >> 2] | 0) + 56 >> 2] | 0) {
	                        Ok(c[g >> 2] | 0, 8, 201368) | 0;
	                        gz(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0) | 0
	                    }
	                } else {
	                    Ok(c[g >> 2] | 0, 8, 201352) | 0;
	                    gz(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 52 >> 2] | 0) | 0;
	                    Ok(c[g >> 2] | 0, 1, 200760) | 0;
	                    gz(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 56 >> 2] | 0) | 0
	                }
	                if (((((c[(c[f >> 2] | 0) + 48 >> 2] | 0) == 0 ? (c[(c[f >> 2] | 0) + 40 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 44 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 36 >> 2] | 0) == 0 : 0) ? (c[(c[f >> 2] | 0) + 60 >> 2] | 0) == 0 : 0) {
	                    Ok(c[g >> 2] | 0, 1, 200968) | 0;
	                    i = d;
	                    return
	                }
	                Ok(c[g >> 2] | 0, 3, 201384) | 0;
	                do if (c[(c[f >> 2] | 0) + 36 >> 2] | 0) {
	                    if ((c[(c[f >> 2] | 0) + 32 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 32 >> 2] | 0) + 44 >> 2] | 0) != (c[f >> 2] | 0) : 0)break;
	                    mR(c[(c[g >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 36 >> 2] | 0)
	                } while (0);
	                c[h >> 2] = c[(c[e >> 2] | 0) + 40 >> 2];
	                c[j >> 2] = c[(c[e >> 2] | 0) + 36 >> 2];
	                c[k >> 2] = c[(c[e >> 2] | 0) + 28 >> 2];
	                c[(c[e >> 2] | 0) + 40 >> 2] = 0;
	                c[(c[e >> 2] | 0) + 36 >> 2] = -1;
	                c[(c[e >> 2] | 0) + 28 >> 2] = c[(c[f >> 2] | 0) + 32 >> 2];
	                _R(c[e >> 2] | 0, c[(c[f >> 2] | 0) + 12 >> 2] | 0);
	                c[(c[e >> 2] | 0) + 40 >> 2] = c[h >> 2];
	                c[(c[e >> 2] | 0) + 36 >> 2] = c[j >> 2];
	                c[(c[e >> 2] | 0) + 28 >> 2] = c[k >> 2];
	                Ok(c[g >> 2] | 0, 2, 201392) | 0;
	                i = d;
	                return
	            }

	            function _R(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    do if ((c[33984] | 0) != 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) {
	                        if (((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1 ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 8 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 7 : 0)break;
	                        b = c[e >> 2] | 0;
	                        if ((c[(c[e >> 2] | 0) + 36 >> 2] | 0) > (c[(c[e >> 2] | 0) + 108 >> 2] | 0))h = c[b + 108 >> 2] | 0; else h = c[b + 36 >> 2] | 0;
	                        b = ca(c[(c[e >> 2] | 0) + 112 >> 2] | 0, h) | 0;
	                        Ok(c[g >> 2] | 0, b, (c[e >> 2] | 0) + 44 | 0) | 0
	                    } while (0);
	                    OR(c[e >> 2] | 0, c[f >> 2] | 0);
	                    if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 1)Ok(c[g >> 2] | 0, 1, 200976) | 0;
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                }
	                i = d;
	                return
	            }

	            function $R(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                if (!(c[g >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 2)UR(c[e >> 2] | 0, 2); else Ok(c[g >> 2] | 0, 1, 200760) | 0;
	                if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                    Qk(c[g >> 2] | 0, c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                    Ok(c[g >> 2] | 0, 1, 200856) | 0
	                }
	                Qk(c[g >> 2] | 0, c[(c[f >> 2] | 0) + 8 >> 2] | 0) | 0;
	                Ok(c[g >> 2] | 0, 2, 201328) | 0;
	                gS(c[g >> 2] | 0, c[f >> 2] | 0);
	                Ok(c[g >> 2] | 0, 1, 201296) | 0;
	                i = d;
	                return
	            }

	            function aS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                KR(c[(c[e >> 2] | 0) + 24 >> 2] | 0, c[f >> 2] | 0, c[e >> 2] | 0);
	                i = d;
	                return
	            }

	            function bS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    KR(c[(c[e >> 2] | 0) + 24 >> 2] | 0, c[f >> 2] | 0, c[e >> 2] | 0);
	                    c[f >> 2] = c[c[f >> 2] >> 2]
	                }
	                i = d;
	                return
	            }

	            function cS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!((c[f >> 2] | 0) != 0 & (c[f >> 2] | 0) != 0)) {
	                    i = d;
	                    return
	                }
	                do {
	                    $R(c[e >> 2] | 0, c[f >> 2] | 0);
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                } while ((c[f >> 2] | 0) != 0);
	                i = d;
	                return
	            }

	            function dS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                while (1) {
	                    if (!(c[f >> 2] | 0))break;
	                    if (((c[33984] | 0) != 0 ? (c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 1 : 0) ? (c[(c[f >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                        b = c[e >> 2] | 0;
	                        if ((c[(c[e >> 2] | 0) + 36 >> 2] | 0) > (c[(c[e >> 2] | 0) + 108 >> 2] | 0))h = c[b + 108 >> 2] | 0; else h = c[b + 36 >> 2] | 0;
	                        b = ca(c[(c[e >> 2] | 0) + 112 >> 2] | 0, h) | 0;
	                        Ok(c[g >> 2] | 0, b, (c[e >> 2] | 0) + 44 | 0) | 0
	                    }
	                    TR(c[e >> 2] | 0, c[f >> 2] | 0);
	                    if ((c[(c[e >> 2] | 0) + 40 >> 2] | 0) == 1)Ok(c[g >> 2] | 0, 1, 200976) | 0;
	                    c[f >> 2] = c[(c[f >> 2] | 0) + 24 >> 2]
	                }
	                i = d;
	                return
	            }

	            function eS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 28 | 0;
	                g = e + 24 | 0;
	                h = e + 20 | 0;
	                j = e + 16 | 0;
	                k = e + 12 | 0;
	                l = e + 8 | 0;
	                m = e + 4 | 0;
	                n = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = 0;
	                c[j >> 2] = 0;
	                c[k >> 2] = 0;
	                c[l >> 2] = 0;
	                if (!(c[g >> 2] | 0)) {
	                    i = e;
	                    return
	                }
	                c[n >> 2] = c[(c[f >> 2] | 0) + 24 >> 2];
	                c[m >> 2] = c[(c[g >> 2] | 0) + 20 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 201200) | 0) != 0 : 0)c[l >> 2] = c[g >> 2]; else o = 7;
	                    do if ((o | 0) == 7) {
	                        o = 0;
	                        if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 201208) | 0) != 0 : 0) {
	                            c[k >> 2] = c[g >> 2];
	                            break
	                        }
	                        if ((c[(c[g >> 2] | 0) + 36 >> 2] | 0) == 0 ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 201216) | 0) != 0 : 0) {
	                            c[j >> 2] = c[g >> 2];
	                            break
	                        }
	                        if (((c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 201216) | 0) != 0 : 0) ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0, 201224) | 0) != 0 : 0) {
	                            c[h >> 2] = c[g >> 2];
	                            break
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 36 >> 2] | 0)) {
	                            if (((c[(c[g >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2] | 0) != 0 : 0) ? (d[c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 40 >> 2] >> 0] | 0 | 0) != 0 : 0)break;
	                            if (sp(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0) {
	                                if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)Rh(c[(c[g >> 2] | 0) + 12 >> 2] | 0);
	                                b = li(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                c[(c[g >> 2] | 0) + 12 >> 2] = b;
	                                if (c[(c[g >> 2] | 0) + 12 >> 2] | 0)c[(c[(c[g >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] = c[g >> 2]
	                            }
	                        }
	                    } while (0);
	                    $R(c[f >> 2] | 0, c[g >> 2] | 0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                do if ((c[k >> 2] | 0) != 0 & (c[l >> 2] | 0) == 0 & (c[m >> 2] | 0) != 0 ? (c[(c[m >> 2] | 0) + 8 >> 2] | 0) != 0 : 0) {
	                    if (((((((((qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201232) | 0) == 0 ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201240) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201248) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201160) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201256) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201264) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201272) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201144) | 0) == 0 : 0) ? (qy(c[(c[m >> 2] | 0) + 8 >> 2] | 0, 201280) | 0) == 0 : 0)break;
	                    Ok(c[n >> 2] | 0, 5, 201288) | 0;
	                    gS(c[n >> 2] | 0, c[k >> 2] | 0);
	                    Ok(c[n >> 2] | 0, 1, 201296) | 0
	                } while (0);
	                if ((c[j >> 2] | 0) != 0 & (c[h >> 2] | 0) == 0) {
	                    Ok(c[n >> 2] | 0, 11, 201304) | 0;
	                    gS(c[n >> 2] | 0, c[j >> 2] | 0);
	                    Ok(c[n >> 2] | 0, 1, 201296) | 0;
	                    i = e;
	                    return
	                }
	                if (!((c[h >> 2] | 0) != 0 & (c[j >> 2] | 0) == 0)) {
	                    i = e;
	                    return
	                }
	                Ok(c[n >> 2] | 0, 7, 201320) | 0;
	                gS(c[n >> 2] | 0, c[h >> 2] | 0);
	                Ok(c[n >> 2] | 0, 1, 201296) | 0;
	                i = e;
	                return
	            }

	            function fS(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[f >> 2] = a;
	                a:do if (!(c[f >> 2] | 0))c[e >> 2] = -1; else {
	                    if ((c[(c[f >> 2] | 0) + 4 >> 2] | 0) != 1) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if ((c[(c[f >> 2] | 0) + 36 >> 2] | 0) != 0 ? (qy(c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, 201064) | 0) == 0 : 0) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if (c[(c[f >> 2] | 0) + 12 >> 2] | 0) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    do switch (d[c[(c[f >> 2] | 0) + 8 >> 2] >> 0] | 0 | 0) {
	                        case 98:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201104) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            }
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201112) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            }
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201120) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 99:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201136) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 97:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201096) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 109:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 200920) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 102:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201144) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 105:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201160) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            }
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201168) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            }
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201176) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 104:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201152) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 112:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201192) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        case 108:
	                        {
	                            if (qy(c[(c[f >> 2] | 0) + 8 >> 2] | 0, 201184) | 0) {
	                                c[e >> 2] = 1;
	                                break a
	                            } else {
	                                c[e >> 2] = 0;
	                                break a
	                            }
	                            break
	                        }
	                        default:
	                        {
	                            c[e >> 2] = 0;
	                            break a
	                        }
	                    } while (0)
	                } while (0);
	                i = b;
	                return c[e >> 2] | 0
	            }

	            function gS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[g >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    b = c[(c[g >> 2] | 0) + 4 >> 2] | 0;
	                    if ((b | 0) == 5) {
	                        cz(c[(c[e >> 2] | 0) + 16 >> 2] | 0, 200792, 1) | 0;
	                        a = c[(c[e >> 2] | 0) + 16 >> 2] | 0;
	                        h = c[(c[g >> 2] | 0) + 8 >> 2] | 0;
	                        cz(a, h, xy(c[(c[g >> 2] | 0) + 8 >> 2] | 0) | 0) | 0;
	                        cz(c[(c[e >> 2] | 0) + 16 >> 2] | 0, 200800, 1) | 0
	                    } else if ((b | 0) == 3)xR(c[(c[e >> 2] | 0) + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 32 >> 2] | 0, c[f >> 2] | 0, c[(c[g >> 2] | 0) + 40 >> 2] | 0);
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                i = d;
	                return
	            }

	            function hS(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 4 >> 2] | 0) == 0 : 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                oS(c[(c[d >> 2] | 0) + 40 >> 2] | 0);
	                pS(c[(c[d >> 2] | 0) + 36 >> 2] | 0);
	                zP(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function iS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0)) {
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](84) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    qS(0, 201776, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                a = (c[f >> 2] | 0) + 0 | 0;
	                h = a + 84 | 0;
	                do {
	                    c[a >> 2] = 0;
	                    a = a + 4 | 0
	                } while ((a | 0) < (h | 0));
	                c[c[f >> 2] >> 2] = 1;
	                a = xP() | 0;
	                c[(c[f >> 2] | 0) + 24 >> 2] = a;
	                a = AP(c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[e >> 2] | 0, -1) | 0;
	                c[(c[f >> 2] | 0) + 4 >> 2] = a;
	                c[(c[f >> 2] | 0) + 64 >> 2] = 0;
	                a = Lr(0) | 0;
	                c[(c[f >> 2] | 0) + 36 >> 2] = a;
	                if (!(c[(c[f >> 2] | 0) + 36 >> 2] | 0)) {
	                    qS(0, 201816, 0);
	                    jS(c[f >> 2] | 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    c[(c[(c[f >> 2] | 0) + 36 >> 2] | 0) + 196 >> 2] = 1;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function jS(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if ((c[(c[d >> 2] | 0) + 8 >> 2] | 0) != 0 ? (c[(c[d >> 2] | 0) + 12 >> 2] | 0) == 0 : 0)Th(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 36 >> 2] | 0)Nr(c[(c[d >> 2] | 0) + 36 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 52 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 52 >> 2] | 0);
	                zP(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function kS(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                b = i;
	                i = i + 48 | 0;
	                e = b + 36 | 0;
	                f = b + 32 | 0;
	                g = b + 28 | 0;
	                h = b + 24 | 0;
	                j = b + 20 | 0;
	                k = b + 16 | 0;
	                l = b + 12 | 0;
	                m = b + 8 | 0;
	                n = b + 4 | 0;
	                o = b;
	                c[f >> 2] = a;
	                c[g >> 2] = 0;
	                c[l >> 2] = 0;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                c[(c[f >> 2] | 0) + 28 >> 2] = 0;
	                a = c[f >> 2] | 0;
	                do if (!(c[(c[f >> 2] | 0) + 4 >> 2] | 0)) {
	                    q = c[f >> 2] | 0;
	                    if (c[a + 16 >> 2] | 0) {
	                        c[h >> 2] = hg(c[q + 16 >> 2] | 0, c[(c[f >> 2] | 0) + 20 >> 2] | 0, 0, 0, 2) | 0;
	                        if (c[h >> 2] | 0) {
	                            r = my(201944) | 0;
	                            c[(c[h >> 2] | 0) + 72 >> 2] = r;
	                            r = AP(c[(c[f >> 2] | 0) + 24 >> 2] | 0, 201944, -1) | 0;
	                            c[(c[f >> 2] | 0) + 4 >> 2] = r;
	                            c[(c[f >> 2] | 0) + 12 >> 2] = 0;
	                            break
	                        }
	                        rS(c[f >> 2] | 0, 0, 1766, 201904, 0, 0);
	                        c[e >> 2] = 0;
	                        p = c[e >> 2] | 0;
	                        i = b;
	                        return p | 0
	                    } else {
	                        r = c[f >> 2] | 0;
	                        if (c[q + 8 >> 2] | 0) {
	                            c[h >> 2] = c[r + 8 >> 2];
	                            c[l >> 2] = 1;
	                            c[(c[f >> 2] | 0) + 12 >> 2] = 1;
	                            break
	                        }
	                        rS(r, 0, 1758, 201904, 0, 0);
	                        c[e >> 2] = 0;
	                        p = c[e >> 2] | 0;
	                        i = b;
	                        return p | 0
	                    }
	                } else {
	                    c[h >> 2] = gg(c[a + 4 >> 2] | 0, 0, 2) | 0;
	                    r = c[f >> 2] | 0;
	                    if (c[h >> 2] | 0) {
	                        c[r + 12 >> 2] = 0;
	                        break
	                    }
	                    rS(r, 0, 1757, 201856, c[(c[f >> 2] | 0) + 4 >> 2] | 0, 0);
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = b;
	                    return p | 0
	                } while (0);
	                c[j >> 2] = Pi(c[h >> 2] | 0) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    rS(c[f >> 2] | 0, c[h >> 2] | 0, 1759, 201968, 0, 0);
	                    if (!(c[l >> 2] | 0))Th(c[h >> 2] | 0);
	                    c[e >> 2] = 0;
	                    p = c[e >> 2] | 0;
	                    i = b;
	                    return p | 0
	                }
	                do if ((((c[j >> 2] | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[j >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[j >> 2] | 0) + 8 >> 2] | 0, 202008) | 0) != 0 : 0) {
	                    if ((qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[j >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0) {
	                        s = 24;
	                        break
	                    }
	                    c[g >> 2] = sS(c[f >> 2] | 0) | 0;
	                    if (c[g >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 40 >> 2] = c[g >> 2];
	                        c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                        while (1) {
	                            if (!(c[k >> 2] | 0))break;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                                if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)break;
	                                if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)break
	                            }
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                        }
	                        a:do if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 202088) | 0) != 0 : 0) {
	                            if ((qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0)break;
	                            c[m >> 2] = _i(c[k >> 2] | 0) | 0;
	                            if (c[m >> 2] | 0) {
	                                a = AP(c[(c[g >> 2] | 0) + 20 >> 2] | 0, c[m >> 2] | 0, -1) | 0;
	                                c[(c[g >> 2] | 0) + 24 >> 2] = a;
	                                zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                            }
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))break a;
	                                do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                    if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0))break;
	                                    if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)break a;
	                                    if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)break a
	                                } while (0);
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                            }
	                        } while (0);
	                        b:while (1) {
	                            if (!(c[k >> 2] | 0))break;
	                            if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) != 1)break;
	                            if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0))break;
	                            if (!(qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 202096) | 0))break;
	                            if ((qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0)break;
	                            c[n >> 2] = ej(c[k >> 2] | 0, 202104) | 0;
	                            c[o >> 2] = ej(c[k >> 2] | 0, 202112) | 0;
	                            if (!((c[o >> 2] | 0) != 0 ? (d[c[o >> 2] >> 0] | 0 | 0) != 0 : 0))rS(c[f >> 2] | 0, c[k >> 2] | 0, 1759, 202120, 0, 0);
	                            if (!((c[n >> 2] | 0) != 0 ? (d[c[n >> 2] >> 0] | 0 | 0) != 0 : 0))rS(c[f >> 2] | 0, c[k >> 2] | 0, 1759, 202144, 0, 0);
	                            if ((c[n >> 2] | 0) != 0 & (c[o >> 2] | 0) != 0) {
	                                rr(c[(c[f >> 2] | 0) + 36 >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0) | 0;
	                                tS(c[f >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0);
	                                a = (c[g >> 2] | 0) + 28 | 0;
	                                c[a >> 2] = (c[a >> 2] | 0) + 1
	                            }
	                            if (c[o >> 2] | 0)zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                            if (c[n >> 2] | 0)zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))continue b;
	                                do if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                                    if (!(c[(c[k >> 2] | 0) + 36 >> 2] | 0))break;
	                                    if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)continue b;
	                                    if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)continue b
	                                } while (0);
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                            }
	                        }
	                        c:while (1) {
	                            if (!(c[k >> 2] | 0))break;
	                            do if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 202176) | 0) != 0 : 0) {
	                                if ((qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0) {
	                                    s = 81;
	                                    break
	                                }
	                                uS(c[f >> 2] | 0, c[k >> 2] | 0);
	                                a = (c[g >> 2] | 0) + 32 | 0;
	                                c[a >> 2] = (c[a >> 2] | 0) + 1
	                            } else s = 81; while (0);
	                            if ((s | 0) == 81) {
	                                s = 0;
	                                rS(c[f >> 2] | 0, c[k >> 2] | 0, 1759, 202184, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0)
	                            }
	                            c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                            while (1) {
	                                if (!(c[k >> 2] | 0))continue c;
	                                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                                    if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)continue c;
	                                    if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)continue c
	                                }
	                                c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                            }
	                        }
	                        if (!(c[(c[g >> 2] | 0) + 32 >> 2] | 0)) {
	                            rS(c[f >> 2] | 0, c[j >> 2] | 0, 1759, 202232, c[(c[f >> 2] | 0) + 4 >> 2] | 0, 0);
	                            break
	                        }
	                        c[(c[g >> 2] | 0) + 8 >> 2] = c[h >> 2];
	                        if (c[l >> 2] | 0)c[(c[g >> 2] | 0) + 4 >> 2] = 1;
	                        c[l >> 2] = 1
	                    }
	                } else s = 24; while (0);
	                if ((s | 0) == 24)rS(c[f >> 2] | 0, c[j >> 2] | 0, 1759, 202032, c[(c[f >> 2] | 0) + 4 >> 2] | 0, 0);
	                if (!(c[l >> 2] | 0))Th(c[h >> 2] | 0);
	                do if (c[g >> 2] | 0)if (c[(c[f >> 2] | 0) + 28 >> 2] | 0) {
	                    hS(c[g >> 2] | 0);
	                    c[g >> 2] = 0;
	                    break
	                } else {
	                    c[(c[g >> 2] | 0) + 52 >> 2] = c[(c[f >> 2] | 0) + 52 >> 2];
	                    c[(c[g >> 2] | 0) + 44 >> 2] = c[(c[f >> 2] | 0) + 44 >> 2];
	                    c[(c[f >> 2] | 0) + 52 >> 2] = 0;
	                    break
	                } while (0);
	                c[e >> 2] = c[g >> 2];
	                p = c[e >> 2] | 0;
	                i = b;
	                return p | 0
	            }

	            function lS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 16 | 0;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 4 | 0;
	                j = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](64) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    vS(0, 202280, 0);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                b = (c[j >> 2] | 0) + 0 | 0;
	                a = b + 64 | 0;
	                do {
	                    c[b >> 2] = 0;
	                    b = b + 4 | 0
	                } while ((b | 0) < (a | 0));
	                c[c[j >> 2] >> 2] = 2;
	                c[(c[j >> 2] | 0) + 20 >> 2] = c[f >> 2];
	                b = Lr(0) | 0;
	                c[(c[j >> 2] | 0) + 24 >> 2] = b;
	                c[(c[j >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                if (!(c[(c[j >> 2] | 0) + 24 >> 2] | 0)) {
	                    qS(0, 201816, 0);
	                    mS(c[j >> 2] | 0);
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = 0;
	                while (1) {
	                    if ((c[h >> 2] | 0) >= (c[(c[f >> 2] | 0) + 44 >> 2] | 0))break;
	                    if (!(c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + (c[h >> 2] << 1 << 2) >> 2] | 0))break;
	                    if (!(c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + ((c[h >> 2] << 1) + 1 << 2) >> 2] | 0))break;
	                    rr(c[(c[j >> 2] | 0) + 24 >> 2] | 0, c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + ((c[h >> 2] << 1) + 1 << 2) >> 2] | 0, c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + (c[h >> 2] << 1 << 2) >> 2] | 0) | 0;
	                    c[h >> 2] = (c[h >> 2] | 0) + 1
	                }
	                c[e >> 2] = c[j >> 2];
	                k = c[e >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function mS(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)Nr(c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zP(c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function nS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
	                d = i;
	                i = i + 48 | 0;
	                e = d;
	                f = d + 36 | 0;
	                g = d + 32 | 0;
	                h = d + 28 | 0;
	                j = d + 24 | 0;
	                k = d + 20 | 0;
	                l = d + 16 | 0;
	                m = d + 12 | 0;
	                n = d + 8 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                if (((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 20 >> 2] | 0) != 0 : 0) ? !((c[h >> 2] | 0) == 0 ? 1 : (c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 40 >> 2] | 0) == 0) : 0) {
	                    c[(c[g >> 2] | 0) + 12 >> 2] = 0;
	                    c[k >> 2] = Pi(c[h >> 2] | 0) | 0;
	                    if (!(c[k >> 2] | 0)) {
	                        b = c[33976] | 0;
	                        a = c[33980] | 0;
	                        c[e >> 2] = 202344;
	                        c[e + 4 >> 2] = 1679;
	                        Db[b & 511](a, 202312, e);
	                        e = (c[g >> 2] | 0) + 12 | 0;
	                        c[e >> 2] = (c[e >> 2] | 0) + 1;
	                        c[f >> 2] = 1;
	                        o = c[f >> 2] | 0;
	                        i = d;
	                        return o | 0
	                    }
	                    a:do if ((c[(c[g >> 2] | 0) + 4 >> 2] & 1 | 0) == 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) {
	                        c[l >> 2] = c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 36 >> 2];
	                        while (1) {
	                            if (!(c[l >> 2] | 0))break a;
	                            yS(c[g >> 2] | 0, c[l >> 2] | 0);
	                            c[j >> 2] = c[k >> 2];
	                            while (1) {
	                                p = c[l >> 2] | 0;
	                                if (!(c[j >> 2] | 0))break;
	                                c[m >> 2] = c[p + 4 >> 2];
	                                while (1) {
	                                    if (!(c[m >> 2] | 0))break;
	                                    b:do if ((NQ(c[(c[m >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0) | 0) == 1) {
	                                        c[n >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                                        while (1) {
	                                            if (!(c[n >> 2] | 0))break b;
	                                            wS(c[g >> 2] | 0, c[n >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[l >> 2] | 0) | 0;
	                                            c[n >> 2] = c[c[n >> 2] >> 2]
	                                        }
	                                    } while (0);
	                                    c[m >> 2] = c[(c[m >> 2] | 0) + 4 >> 2]
	                                }
	                                c[j >> 2] = xS(c[j >> 2] | 0) | 0
	                            }
	                            c[l >> 2] = c[p >> 2]
	                        }
	                    } else q = 9; while (0);
	                    c:do if ((q | 0) == 9) {
	                        c[j >> 2] = c[k >> 2];
	                        while (1) {
	                            if (!(c[j >> 2] | 0))break c;
	                            c[m >> 2] = c[(c[(c[g >> 2] | 0) + 20 >> 2] | 0) + 40 >> 2];
	                            while (1) {
	                                if (!(c[m >> 2] | 0))break;
	                                d:do if ((NQ(c[(c[m >> 2] | 0) + 20 >> 2] | 0, c[j >> 2] | 0) | 0) == 1) {
	                                    c[n >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                                    while (1) {
	                                        if (!(c[n >> 2] | 0))break d;
	                                        wS(c[g >> 2] | 0, c[n >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[(c[m >> 2] | 0) + 20 >> 2] | 0) | 0;
	                                        c[n >> 2] = c[c[n >> 2] >> 2]
	                                    }
	                                } while (0);
	                                c[m >> 2] = c[c[m >> 2] >> 2]
	                            }
	                            c[j >> 2] = xS(c[j >> 2] | 0) | 0
	                        }
	                    } while (0);
	                    c[f >> 2] = c[(c[g >> 2] | 0) + 12 >> 2];
	                    o = c[f >> 2] | 0;
	                    i = d;
	                    return o | 0
	                }
	                c[f >> 2] = -1;
	                o = c[f >> 2] | 0;
	                i = d;
	                return o | 0
	            }

	            function oS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)zS(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)EQ(c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 24 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 24 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function pS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    if (c[(c[d >> 2] | 0) + 8 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 8 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function qS(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (c[f >> 2] | 0) {
	                    d = (c[f >> 2] | 0) + 28 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1
	                }
	                ce(16, 2, c[h >> 2] | 0, 0, c[g >> 2] | 0);
	                i = e;
	                return
	            }

	            function rS(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h;
	                k = h + 40 | 0;
	                l = h + 36 | 0;
	                m = h + 32 | 0;
	                n = h + 28 | 0;
	                o = h + 24 | 0;
	                p = h + 20 | 0;
	                q = h + 16 | 0;
	                r = h + 12 | 0;
	                s = h + 8 | 0;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                c[q >> 2] = 0;
	                c[r >> 2] = 0;
	                c[s >> 2] = 0;
	                if (c[k >> 2] | 0) {
	                    g = (c[k >> 2] | 0) + 28 | 0;
	                    c[g >> 2] = (c[g >> 2] | 0) + 1;
	                    c[q >> 2] = c[(c[k >> 2] | 0) + 72 >> 2];
	                    c[s >> 2] = c[(c[k >> 2] | 0) + 68 >> 2];
	                    c[r >> 2] = c[(c[k >> 2] | 0) + 80 >> 2]
	                }
	                g = c[r >> 2] | 0;
	                r = c[q >> 2] | 0;
	                q = c[s >> 2] | 0;
	                s = c[k >> 2] | 0;
	                k = c[l >> 2] | 0;
	                l = c[m >> 2] | 0;
	                m = c[o >> 2] | 0;
	                f = c[p >> 2] | 0;
	                e = c[n >> 2] | 0;
	                n = c[p >> 2] | 0;
	                c[j >> 2] = c[o >> 2];
	                c[j + 4 >> 2] = n;
	                Xd(g, r, q, s, k, 16, l, 2, 0, 0, m, f, 0, 0, 0, e, j);
	                i = h;
	                return
	            }

	            function sS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[e >> 2] = a;
	                c[f >> 2] = Cb[c[135744 >> 2] & 511](56) | 0;
	                if (!(c[f >> 2] | 0)) {
	                    qS(c[e >> 2] | 0, 203040, 0);
	                    c[d >> 2] = 0;
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                } else {
	                    a = (c[f >> 2] | 0) + 0 | 0;
	                    h = a + 56 | 0;
	                    do {
	                        c[a >> 2] = 0;
	                        a = a + 4 | 0
	                    } while ((a | 0) < (h | 0));
	                    c[(c[f >> 2] | 0) + 20 >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                    yP(c[(c[f >> 2] | 0) + 20 >> 2] | 0) | 0;
	                    c[d >> 2] = c[f >> 2];
	                    g = c[d >> 2] | 0;
	                    i = b;
	                    return g | 0
	                }
	                return 0
	            }

	            function tS(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                d = c[f >> 2] | 0;
	                do if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                    if (((c[d + 44 >> 2] | 0) + 2 | 0) >= (c[(c[f >> 2] | 0) + 48 >> 2] | 0)) {
	                        c[j >> 2] = Hb[c[135760 >> 2] & 511](c[(c[f >> 2] | 0) + 52 >> 2] | 0, c[(c[f >> 2] | 0) + 48 >> 2] << 2 << 2) | 0;
	                        if (c[j >> 2] | 0) {
	                            c[(c[f >> 2] | 0) + 52 >> 2] = c[j >> 2];
	                            b = (c[f >> 2] | 0) + 48 | 0;
	                            c[b >> 2] = c[b >> 2] << 1;
	                            break
	                        }
	                        qS(0, 203008, 0);
	                        i = e;
	                        return
	                    }
	                } else {
	                    c[d + 48 >> 2] = 10;
	                    b = Cb[c[135744 >> 2] & 511](c[(c[f >> 2] | 0) + 48 >> 2] << 1 << 2) | 0;
	                    c[(c[f >> 2] | 0) + 52 >> 2] = b;
	                    if (c[(c[f >> 2] | 0) + 52 >> 2] | 0) {
	                        c[(c[f >> 2] | 0) + 44 >> 2] = 0;
	                        break
	                    }
	                    qS(0, 203008, 0);
	                    i = e;
	                    return
	                } while (0);
	                d = AP(c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[h >> 2] | 0, -1) | 0;
	                c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + (c[(c[f >> 2] | 0) + 44 >> 2] << 1 << 2) >> 2] = d;
	                d = AP(c[(c[f >> 2] | 0) + 24 >> 2] | 0, c[g >> 2] | 0, -1) | 0;
	                c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 44 >> 2] << 1) + 1 << 2) >> 2] = d;
	                d = (c[f >> 2] | 0) + 44 | 0;
	                c[d >> 2] = (c[d >> 2] | 0) + 1;
	                c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + (c[(c[f >> 2] | 0) + 44 >> 2] << 1 << 2) >> 2] = 0;
	                c[(c[(c[f >> 2] | 0) + 52 >> 2] | 0) + ((c[(c[f >> 2] | 0) + 44 >> 2] << 1) + 1 << 2) >> 2] = 0;
	                i = e;
	                return
	            }

	            function uS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                k = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[j >> 2] = 0;
	                if ((c[e >> 2] | 0) == 0 | (c[f >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                c[k >> 2] = ej(c[f >> 2] | 0, 202488) | 0;
	                if (!(c[k >> 2] | 0))c[k >> 2] = ej(c[f >> 2] | 0, 202464) | 0;
	                c[h >> 2] = AS(c[e >> 2] | 0, c[(c[e >> 2] | 0) + 40 >> 2] | 0, c[f >> 2] | 0, c[k >> 2] | 0) | 0;
	                if (!(c[h >> 2] | 0)) {
	                    if (!(c[k >> 2] | 0)) {
	                        i = d;
	                        return
	                    }
	                    zb[c[135736 >> 2] & 511](c[k >> 2] | 0);
	                    i = d;
	                    return
	                }
	                c[g >> 2] = c[(c[f >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                        if (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)break;
	                        if (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)break
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                }
	                a:while (1) {
	                    if (!(c[g >> 2] | 0))break;
	                    do if ((((c[g >> 2] | 0) != 0 ? (c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[g >> 2] | 0) + 8 >> 2] | 0, 202496) | 0) != 0 : 0) {
	                        if ((qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0) {
	                            l = 22;
	                            break
	                        }
	                        BS(c[e >> 2] | 0, c[h >> 2] | 0, c[g >> 2] | 0);
	                        c[j >> 2] = (c[j >> 2] | 0) + 1
	                    } else l = 22; while (0);
	                    if ((l | 0) == 22) {
	                        l = 0;
	                        rS(c[e >> 2] | 0, c[g >> 2] | 0, 1759, 202504, c[(c[g >> 2] | 0) + 8 >> 2] | 0, 0)
	                    }
	                    c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (!(c[g >> 2] | 0))continue a;
	                        if ((c[(c[g >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[g >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            if (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)continue a;
	                            if (qy(c[(c[(c[g >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)continue a
	                        }
	                        c[g >> 2] = c[(c[g >> 2] | 0) + 24 >> 2]
	                    }
	                }
	                if (c[j >> 2] | 0) {
	                    i = d;
	                    return
	                }
	                rS(c[e >> 2] | 0, c[f >> 2] | 0, 1759, 202544, 0, 0);
	                i = d;
	                return
	            }

	            function vS(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 8 | 0;
	                g = e + 4 | 0;
	                h = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if (c[f >> 2] | 0) {
	                    d = (c[f >> 2] | 0) + 12 | 0;
	                    c[d >> 2] = (c[d >> 2] | 0) + 1;
	                    c[(c[f >> 2] | 0) + 16 >> 2] = 1818
	                }
	                ce(17, 2, c[h >> 2] | 0, 0, c[g >> 2] | 0);
	                i = e;
	                return
	            }

	            function wS(a, b, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                j = i;
	                i = i + 32 | 0;
	                k = j + 24 | 0;
	                l = j + 20 | 0;
	                m = j + 16 | 0;
	                n = j + 12 | 0;
	                o = j + 8 | 0;
	                p = j + 4 | 0;
	                q = j;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                c[o >> 2] = g;
	                c[q >> 2] = 0;
	                c[c[(c[k >> 2] | 0) + 24 >> 2] >> 2] = c[m >> 2];
	                c[(c[(c[k >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] = c[n >> 2];
	                c[p >> 2] = Ps(c[(c[l >> 2] | 0) + 16 >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0) | 0;
	                if (!(c[p >> 2] | 0))c[q >> 2] = 1; else {
	                    a:do switch (c[c[p >> 2] >> 2] | 0) {
	                        case 4:
	                        {
	                            if ((c[(c[p >> 2] | 0) + 24 >> 2] | 0) != 0 ? (d[c[(c[p >> 2] | 0) + 24 >> 2] >> 0] | 0 | 0) != 0 : 0)break a;
	                            c[q >> 2] = 1;
	                            break
	                        }
	                        case 3:
	                        {
	                            if ((Lq(+h[(c[p >> 2] | 0) + 16 >> 3]) | 0) == 0 ? !(+h[(c[p >> 2] | 0) + 16 >> 3] == 0.0) : 0)break a;
	                            c[q >> 2] = 1;
	                            break
	                        }
	                        case 8:
	                        case 7:
	                        case 6:
	                        case 5:
	                        case 0:
	                        {
	                            c[q >> 2] = 1;
	                            break
	                        }
	                        case 2:
	                        {
	                            c[q >> 2] = ((c[(c[p >> 2] | 0) + 8 >> 2] | 0) != 0 ^ 1) & 1;
	                            break
	                        }
	                        case 1:
	                        case 9:
	                        {
	                            if ((c[(c[p >> 2] | 0) + 4 >> 2] | 0) != 0 ? (c[c[(c[p >> 2] | 0) + 4 >> 2] >> 2] | 0) != 0 : 0)break a;
	                            c[q >> 2] = 1;
	                            break
	                        }
	                        default:
	                        {
	                        }
	                    } while (0);
	                    Qq(c[p >> 2] | 0)
	                }
	                if ((c[q >> 2] | 0) != 0 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) {
	                    p = (c[k >> 2] | 0) + 12 | 0;
	                    c[p >> 2] = (c[p >> 2] | 0) + 1
	                } else r = 19;
	                if (((r | 0) == 19 ? (c[q >> 2] | 0) == 0 : 0) ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                    r = (c[k >> 2] | 0) + 12 | 0;
	                    c[r >> 2] = (c[r >> 2] | 0) + 1
	                }
	                CS(c[k >> 2] | 0, c[l >> 2] | 0, c[n >> 2] | 0, c[o >> 2] | 0, ((c[q >> 2] | 0) != 0 ^ 1) & 1);
	                i = j;
	                return ((c[q >> 2] | 0) != 0 ^ 1) & 1 | 0
	            }

	            function xS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (((c[(c[e >> 2] | 0) + 12 >> 2] | 0) != 0 ? (c[(c[(c[e >> 2] | 0) + 12 >> 2] | 0) + 4 >> 2] | 0) != 17 : 0) ? (c[e >> 2] = c[(c[e >> 2] | 0) + 12 >> 2], (c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 14) : 0) {
	                    c[d >> 2] = c[e >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                while (1) {
	                    if (!(c[(c[e >> 2] | 0) + 24 >> 2] | 0))break;
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 24 >> 2];
	                    if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 17)continue;
	                    if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) != 14) {
	                        g = 8;
	                        break
	                    }
	                }
	                if ((g | 0) == 8) {
	                    c[d >> 2] = c[e >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                while (1) {
	                    c[e >> 2] = c[(c[e >> 2] | 0) + 20 >> 2];
	                    if (!(c[e >> 2] | 0)) {
	                        g = 15;
	                        break
	                    }
	                    if ((c[(c[e >> 2] | 0) + 4 >> 2] | 0) == 9) {
	                        g = 11;
	                        break
	                    }
	                    h = c[e >> 2] | 0;
	                    if (c[(c[e >> 2] | 0) + 24 >> 2] | 0) {
	                        g = 13;
	                        break
	                    }
	                    if (!h) {
	                        g = 15;
	                        break
	                    }
	                }
	                if ((g | 0) == 11) {
	                    c[d >> 2] = 0;
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else if ((g | 0) == 13) {
	                    c[e >> 2] = c[h + 24 >> 2];
	                    c[d >> 2] = c[e >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                } else if ((g | 0) == 15) {
	                    c[d >> 2] = c[e >> 2];
	                    f = c[d >> 2] | 0;
	                    i = b;
	                    return f | 0
	                }
	                return 0
	            }

	            function yS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 1024 | 0;
	                e = d;
	                f = d + 12 | 0;
	                g = d + 8 | 0;
	                h = d + 16 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 4 >> 2] & 1) {
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 4 >> 2] & 8) {
	                    i = d;
	                    return
	                }
	                if (c[(c[f >> 2] | 0) + 4 >> 2] & 4) {
	                    b = c[33976] | 0;
	                    a = c[33980] | 0;
	                    c[e >> 2] = 202344;
	                    c[e + 4 >> 2] = 1457;
	                    Db[b & 511](a, 202312, e);
	                    i = d;
	                    return
	                }
	                if (!(c[(c[g >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = d;
	                    return
	                }
	                c[e >> 2] = c[(c[g >> 2] | 0) + 8 >> 2];
	                JT(h, 999, 202368, e) | 0;
	                DS(c[f >> 2] | 0, 0, h);
	                i = d;
	                return
	            }

	            function zS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[d >> 2] = a;
	                while (1) {
	                    if (!(c[d >> 2] | 0))break;
	                    c[e >> 2] = c[c[d >> 2] >> 2];
	                    if (c[(c[d >> 2] | 0) + 12 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 12 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 16 >> 2] | 0)Pq(c[(c[d >> 2] | 0) + 16 >> 2] | 0);
	                    if (c[(c[d >> 2] | 0) + 20 >> 2] | 0)zb[c[135736 >> 2] & 511](c[(c[d >> 2] | 0) + 20 >> 2] | 0);
	                    zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                    c[d >> 2] = c[e >> 2]
	                }
	                i = b;
	                return
	            }

	            function AS(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
	                f = i;
	                i = i + 32 | 0;
	                g = f + 24 | 0;
	                h = f + 20 | 0;
	                j = f + 16 | 0;
	                k = f + 12 | 0;
	                l = f + 8 | 0;
	                m = f + 4 | 0;
	                n = f;
	                c[h >> 2] = a;
	                c[j >> 2] = b;
	                c[k >> 2] = d;
	                c[l >> 2] = e;
	                if ((c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                c[m >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[m >> 2] | 0)) {
	                    qS(c[h >> 2] | 0, 202976, c[k >> 2] | 0);
	                    c[g >> 2] = 0;
	                    o = c[g >> 2] | 0;
	                    i = f;
	                    return o | 0
	                }
	                k = c[m >> 2] | 0;
	                c[k + 0 >> 2] = 0;
	                c[k + 4 >> 2] = 0;
	                c[k + 8 >> 2] = 0;
	                c[(c[m >> 2] | 0) + 8 >> 2] = c[l >> 2];
	                c[c[m >> 2] >> 2] = 0;
	                if (!(c[(c[j >> 2] | 0) + 36 >> 2] | 0))c[(c[j >> 2] | 0) + 36 >> 2] = c[m >> 2]; else {
	                    c[n >> 2] = c[(c[j >> 2] | 0) + 36 >> 2];
	                    while (1) {
	                        if (!(c[c[n >> 2] >> 2] | 0))break;
	                        c[n >> 2] = c[c[n >> 2] >> 2]
	                    }
	                    c[c[n >> 2] >> 2] = c[m >> 2]
	                }
	                c[g >> 2] = c[m >> 2];
	                o = c[g >> 2] | 0;
	                i = f;
	                return o | 0
	            }

	            function BS(a, b, e) {
	                a = a | 0;
	                b = b | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                f = i;
	                i = i + 48 | 0;
	                g = f + 36 | 0;
	                h = f + 32 | 0;
	                j = f + 28 | 0;
	                k = f + 24 | 0;
	                l = f + 20 | 0;
	                m = f + 16 | 0;
	                n = f + 12 | 0;
	                o = f + 8 | 0;
	                p = f + 4 | 0;
	                q = f;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = e;
	                c[l >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    i = f;
	                    return
	                }
	                c[n >> 2] = ej(c[j >> 2] | 0, 202576) | 0;
	                if (!(c[n >> 2] | 0)) {
	                    rS(c[g >> 2] | 0, c[j >> 2] | 0, 1759, 202584, 0, 0);
	                    i = f;
	                    return
	                }
	                e = c[g >> 2] | 0;
	                if (!(d[c[n >> 2] >> 0] | 0)) {
	                    rS(e, c[j >> 2] | 0, 1759, 202616, 0, 0);
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    i = f;
	                    return
	                }
	                c[p >> 2] = ES(e, c[(c[g >> 2] | 0) + 40 >> 2] | 0, c[h >> 2] | 0, c[j >> 2] | 0, c[n >> 2] | 0, 0) | 0;
	                if (!(c[p >> 2] | 0)) {
	                    zb[c[135736 >> 2] & 511](c[n >> 2] | 0);
	                    i = f;
	                    return
	                }
	                c[k >> 2] = c[(c[j >> 2] | 0) + 12 >> 2];
	                while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                        if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)break;
	                        if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)break
	                    }
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                }
	                a:while (1) {
	                    if (!(c[k >> 2] | 0))break;
	                    do if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 202656) | 0) != 0 : 0) {
	                        if ((qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0) {
	                            r = 28;
	                            break
	                        }
	                        c[l >> 2] = (c[l >> 2] | 0) + 1;
	                        c[m >> 2] = ej(c[k >> 2] | 0, 202664) | 0;
	                        if (!(c[m >> 2] | 0)) {
	                            rS(c[g >> 2] | 0, c[k >> 2] | 0, 1759, 202672, 0, 0);
	                            break
	                        }
	                        if (!(d[c[m >> 2] >> 0] | 0)) {
	                            rS(c[g >> 2] | 0, c[k >> 2] | 0, 1759, 202704, 0, 0);
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            break
	                        }
	                        c[o >> 2] = _i(c[k >> 2] | 0) | 0;
	                        c[q >> 2] = FS(c[g >> 2] | 0, 1, c[p >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                        if (!(c[q >> 2] | 0))zb[c[135736 >> 2] & 511](c[m >> 2] | 0)
	                    } else r = 28; while (0);
	                    b:do if ((r | 0) == 28) {
	                        r = 0;
	                        do if ((((c[k >> 2] | 0) != 0 ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[k >> 2] | 0) + 8 >> 2] | 0, 202744) | 0) != 0 : 0) {
	                            if ((qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0)break;
	                            c[l >> 2] = (c[l >> 2] | 0) + 1;
	                            c[m >> 2] = ej(c[k >> 2] | 0, 202664) | 0;
	                            if (!(c[m >> 2] | 0)) {
	                                rS(c[g >> 2] | 0, c[k >> 2] | 0, 1759, 202672, 0, 0);
	                                break b
	                            }
	                            if (!(d[c[m >> 2] >> 0] | 0)) {
	                                rS(c[g >> 2] | 0, c[k >> 2] | 0, 1759, 202704, 0, 0);
	                                zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                                break b
	                            }
	                            c[o >> 2] = _i(c[k >> 2] | 0) | 0;
	                            c[q >> 2] = FS(c[g >> 2] | 0, 2, c[p >> 2] | 0, c[k >> 2] | 0, c[m >> 2] | 0, c[o >> 2] | 0) | 0;
	                            if (c[q >> 2] | 0)break b;
	                            zb[c[135736 >> 2] & 511](c[m >> 2] | 0);
	                            break b
	                        } while (0);
	                        rS(c[g >> 2] | 0, c[k >> 2] | 0, 1759, 202752, c[(c[k >> 2] | 0) + 8 >> 2] | 0, 0)
	                    } while (0);
	                    c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2];
	                    while (1) {
	                        if (!(c[k >> 2] | 0))continue a;
	                        if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? (c[(c[k >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) {
	                            if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0)continue a;
	                            if (qy(c[(c[(c[k >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0)continue a
	                        }
	                        c[k >> 2] = c[(c[k >> 2] | 0) + 24 >> 2]
	                    }
	                }
	                if (c[l >> 2] | 0) {
	                    i = f;
	                    return
	                }
	                rS(c[g >> 2] | 0, c[j >> 2] | 0, 1759, 202808, 0, 0);
	                i = f;
	                return
	            }

	            function CS(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 1056 | 0;
	                h = g;
	                j = g + 52 | 0;
	                k = g + 48 | 0;
	                l = g + 44 | 0;
	                m = g + 40 | 0;
	                n = g + 36 | 0;
	                o = g + 32 | 0;
	                p = g + 56 | 0;
	                q = g + 28 | 0;
	                r = g + 24 | 0;
	                s = g + 20 | 0;
	                t = g + 16 | 0;
	                u = g + 12 | 0;
	                c[j >> 2] = a;
	                c[k >> 2] = b;
	                c[l >> 2] = d;
	                c[m >> 2] = e;
	                c[n >> 2] = f;
	                if ((c[j >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[k >> 2] | 0) == 0) {
	                    i = g;
	                    return
	                }
	                if (((c[(c[j >> 2] | 0) + 4 >> 2] & 1 | 0) != 0 ? (c[(c[j >> 2] | 0) + 4 >> 2] & 4 | 0) == 0 : 0) ? (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 2 : 0) {
	                    i = g;
	                    return
	                }
	                if (c[(c[j >> 2] | 0) + 4 >> 2] & 4) {
	                    f = c[33976] | 0;
	                    e = c[33980] | 0;
	                    c[h >> 2] = 202344;
	                    c[h + 4 >> 2] = 1380;
	                    Db[f & 511](e, 202312, h);
	                    i = g;
	                    return
	                }
	                c[r >> 2] = 0;
	                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 2 & (((c[n >> 2] | 0) != 0 ^ 1) & 1)) {
	                    i = g;
	                    return
	                }
	                if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 & c[n >> 2]) {
	                    i = g;
	                    return
	                }
	                c[q >> 2] = Ni(c[l >> 2] | 0) | 0;
	                c[o >> 2] = Oi(c[l >> 2] | 0) | 0;
	                if (!(c[o >> 2] | 0))c[o >> 2] = c[(c[l >> 2] | 0) + 8 >> 2];
	                if (c[(c[k >> 2] | 0) + 8 >> 2] | 0)c[r >> 2] = GS(c[j >> 2] | 0, c[(c[k >> 2] | 0) + 8 >> 2] | 0, c[l >> 2] | 0) | 0;
	                do if (!(c[r >> 2] | 0))if ((c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1) {
	                    c[r >> 2] = my(202392) | 0;
	                    break
	                } else {
	                    c[r >> 2] = my(202416) | 0;
	                    break
	                } while (0);
	                n = c[q >> 2] | 0;
	                e = c[r >> 2] | 0;
	                c[h >> 2] = c[o >> 2];
	                c[h + 4 >> 2] = n;
	                c[h + 8 >> 2] = e;
	                JT(p, 999, 202440, h) | 0;
	                if (c[(c[j >> 2] | 0) + 4 >> 2] & 8) {
	                    c[s >> 2] = 0;
	                    c[t >> 2] = 0;
	                    c[u >> 2] = 0;
	                    if (c[j >> 2] | 0) {
	                        e = c[j >> 2] | 0;
	                        if (c[(c[j >> 2] | 0) + 60 >> 2] | 0)c[s >> 2] = c[e + 60 >> 2]; else c[t >> 2] = c[e + 52 >> 2];
	                        c[u >> 2] = c[(c[j >> 2] | 0) + 48 >> 2]
	                    }
	                    e = c[s >> 2] | 0;
	                    s = c[t >> 2] | 0;
	                    t = c[u >> 2] | 0;
	                    u = c[l >> 2] | 0;
	                    n = (c[(c[k >> 2] | 0) + 4 >> 2] | 0) == 1 ? 4e3 : 4001;
	                    k = c[q >> 2] | 0;
	                    if (!(c[m >> 2] | 0))v = 0; else v = c[(c[m >> 2] | 0) + 8 >> 2] | 0;
	                    m = c[o >> 2] | 0;
	                    q = c[r >> 2] | 0;
	                    c[h >> 2] = p;
	                    Xd(e, s, t, 0, u, 28, n, 2, 0, k, v, m, q, 0, 0, 202384, h)
	                } else DS(c[j >> 2] | 0, c[l >> 2] | 0, p);
	                zb[c[135736 >> 2] & 511](c[r >> 2] | 0);
	                if (!(c[o >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                if ((c[o >> 2] | 0) == (c[(c[l >> 2] | 0) + 8 >> 2] | 0)) {
	                    i = g;
	                    return
	                }
	                zb[c[135736 >> 2] & 511](c[o >> 2] | 0);
	                i = g;
	                return
	            }

	            function DS(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                g = e + 4 | 0;
	                c[e + 12 >> 2] = a;
	                c[e + 8 >> 2] = b;
	                c[g >> 2] = d;
	                d = c[o >> 2] | 0;
	                c[f >> 2] = c[g >> 2];
	                Ka(d | 0, 202384, f | 0) | 0;
	                i = e;
	                return
	            }

	            function ES(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 40 | 0;
	                k = h + 36 | 0;
	                l = h + 32 | 0;
	                m = h + 28 | 0;
	                n = h + 24 | 0;
	                o = h + 20 | 0;
	                p = h + 16 | 0;
	                q = h + 12 | 0;
	                r = h + 8 | 0;
	                s = h + 4 | 0;
	                t = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0) {
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                c[r >> 2] = MQ(c[o >> 2] | 0, c[(c[k >> 2] | 0) + 24 >> 2] | 0, 1, c[(c[k >> 2] | 0) + 52 >> 2] | 0) | 0;
	                if (!(c[r >> 2] | 0))rS(c[k >> 2] | 0, c[n >> 2] | 0, 1759, 202912, c[o >> 2] | 0, 0);
	                c[q >> 2] = Cb[c[135744 >> 2] & 511](28) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    qS(c[k >> 2] | 0, 202952, c[n >> 2] | 0);
	                    c[j >> 2] = 0;
	                    u = c[j >> 2] | 0;
	                    i = h;
	                    return u | 0
	                }
	                k = c[q >> 2] | 0;
	                c[k + 0 >> 2] = 0;
	                c[k + 4 >> 2] = 0;
	                c[k + 8 >> 2] = 0;
	                c[k + 12 >> 2] = 0;
	                c[k + 16 >> 2] = 0;
	                c[k + 20 >> 2] = 0;
	                c[k + 24 >> 2] = 0;
	                c[(c[q >> 2] | 0) + 8 >> 2] = c[n >> 2];
	                c[(c[q >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                c[(c[q >> 2] | 0) + 20 >> 2] = c[r >> 2];
	                c[(c[q >> 2] | 0) + 24 >> 2] = c[p >> 2];
	                c[c[q >> 2] >> 2] = 0;
	                if (!(c[(c[l >> 2] | 0) + 40 >> 2] | 0))c[(c[l >> 2] | 0) + 40 >> 2] = c[q >> 2]; else {
	                    c[s >> 2] = c[(c[l >> 2] | 0) + 40 >> 2];
	                    while (1) {
	                        if (!(c[c[s >> 2] >> 2] | 0))break;
	                        c[s >> 2] = c[c[s >> 2] >> 2]
	                    }
	                    c[c[s >> 2] >> 2] = c[q >> 2]
	                }
	                c[(c[q >> 2] | 0) + 4 >> 2] = 0;
	                if (!(c[(c[m >> 2] | 0) + 4 >> 2] | 0))c[(c[m >> 2] | 0) + 4 >> 2] = c[q >> 2]; else {
	                    c[t >> 2] = c[(c[m >> 2] | 0) + 4 >> 2];
	                    while (1) {
	                        if (!(c[(c[t >> 2] | 0) + 4 >> 2] | 0))break;
	                        c[t >> 2] = c[(c[t >> 2] | 0) + 4 >> 2]
	                    }
	                    c[(c[t >> 2] | 0) + 4 >> 2] = c[q >> 2]
	                }
	                c[j >> 2] = c[q >> 2];
	                u = c[j >> 2] | 0;
	                i = h;
	                return u | 0
	            }

	            function FS(a, b, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                var h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                h = i;
	                i = i + 48 | 0;
	                j = h + 36 | 0;
	                k = h + 32 | 0;
	                l = h + 28 | 0;
	                m = h + 24 | 0;
	                n = h + 20 | 0;
	                o = h + 16 | 0;
	                p = h + 12 | 0;
	                q = h + 8 | 0;
	                r = h + 4 | 0;
	                s = h;
	                c[k >> 2] = a;
	                c[l >> 2] = b;
	                c[m >> 2] = d;
	                c[n >> 2] = e;
	                c[o >> 2] = f;
	                c[p >> 2] = g;
	                if ((c[k >> 2] | 0) == 0 | (c[m >> 2] | 0) == 0 | (c[n >> 2] | 0) == 0 | (c[o >> 2] | 0) == 0) {
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[r >> 2] = Os(c[(c[k >> 2] | 0) + 36 >> 2] | 0, c[o >> 2] | 0) | 0;
	                if (!(c[r >> 2] | 0)) {
	                    rS(c[k >> 2] | 0, c[n >> 2] | 0, 1759, 202848, c[o >> 2] | 0, 0);
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                c[q >> 2] = Cb[c[135744 >> 2] & 511](24) | 0;
	                if (!(c[q >> 2] | 0)) {
	                    qS(c[k >> 2] | 0, 202888, c[n >> 2] | 0);
	                    c[j >> 2] = 0;
	                    t = c[j >> 2] | 0;
	                    i = h;
	                    return t | 0
	                }
	                k = c[q >> 2] | 0;
	                c[k + 0 >> 2] = 0;
	                c[k + 4 >> 2] = 0;
	                c[k + 8 >> 2] = 0;
	                c[k + 12 >> 2] = 0;
	                c[k + 16 >> 2] = 0;
	                c[k + 20 >> 2] = 0;
	                c[(c[q >> 2] | 0) + 4 >> 2] = c[l >> 2];
	                c[(c[q >> 2] | 0) + 8 >> 2] = c[n >> 2];
	                c[(c[q >> 2] | 0) + 12 >> 2] = c[o >> 2];
	                c[(c[q >> 2] | 0) + 16 >> 2] = c[r >> 2];
	                c[(c[q >> 2] | 0) + 20 >> 2] = c[p >> 2];
	                c[c[q >> 2] >> 2] = 0;
	                if (!(c[(c[m >> 2] | 0) + 16 >> 2] | 0))c[(c[m >> 2] | 0) + 16 >> 2] = c[q >> 2]; else {
	                    c[s >> 2] = c[(c[m >> 2] | 0) + 16 >> 2];
	                    while (1) {
	                        if (!(c[c[s >> 2] >> 2] | 0))break;
	                        c[s >> 2] = c[c[s >> 2] >> 2]
	                    }
	                    c[c[s >> 2] >> 2] = c[q >> 2]
	                }
	                c[j >> 2] = c[q >> 2];
	                t = c[j >> 2] | 0;
	                i = h;
	                return t | 0
	            }

	            function GS(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
	                g = i;
	                i = i + 48 | 0;
	                h = g + 32 | 0;
	                j = g + 28 | 0;
	                k = g + 24 | 0;
	                l = g + 20 | 0;
	                m = g + 16 | 0;
	                n = g + 12 | 0;
	                o = g + 8 | 0;
	                p = g + 4 | 0;
	                q = g;
	                r = g + 36 | 0;
	                c[j >> 2] = b;
	                c[k >> 2] = e;
	                c[l >> 2] = f;
	                c[m >> 2] = 0;
	                if ((c[k >> 2] | 0) == 0 | (c[l >> 2] | 0) == 0) {
	                    c[h >> 2] = c[m >> 2];
	                    s = c[h >> 2] | 0;
	                    i = g;
	                    return s | 0
	                }
	                c[n >> 2] = c[(c[k >> 2] | 0) + 12 >> 2];
	                a:while (1) {
	                    if (!(c[n >> 2] | 0))break;
	                    b:do if ((c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 3 ? (c[(c[n >> 2] | 0) + 4 >> 2] | 0) != 4 : 0) {
	                        do if ((((c[n >> 2] | 0) != 0 ? (c[(c[n >> 2] | 0) + 4 >> 2] | 0) == 1 : 0) ? (c[(c[n >> 2] | 0) + 36 >> 2] | 0) != 0 : 0) ? (qy(c[(c[n >> 2] | 0) + 8 >> 2] | 0, 202464) | 0) != 0 : 0) {
	                            if ((qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50504] | 0) | 0) == 0 ? (qy(c[(c[(c[n >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0, c[50506] | 0) | 0) == 0 : 0)break;
	                            c[p >> 2] = ej(c[n >> 2] | 0, 202472) | 0;
	                            c[o >> 2] = c[l >> 2];
	                            if (c[p >> 2] | 0) {
	                                c[o >> 2] = HS(c[j >> 2] | 0, c[l >> 2] | 0, c[p >> 2] | 0) | 0;
	                                if (!(c[o >> 2] | 0))c[o >> 2] = c[l >> 2];
	                                zb[c[135736 >> 2] & 511](c[p >> 2] | 0)
	                            }
	                            if ((c[(c[o >> 2] | 0) + 36 >> 2] | 0) != 0 ? (c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) != 0 : 0) {
	                                c[m >> 2] = By(c[m >> 2] | 0, c[(c[(c[o >> 2] | 0) + 36 >> 2] | 0) + 12 >> 2] | 0) | 0;
	                                c[m >> 2] = By(c[m >> 2] | 0, 202480) | 0;
	                                c[m >> 2] = By(c[m >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0) | 0;
	                                break b
	                            }
	                            c[m >> 2] = By(c[m >> 2] | 0, c[(c[o >> 2] | 0) + 8 >> 2] | 0) | 0;
	                            break b
	                        } while (0);
	                        c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2];
	                        continue a
	                    } else t = 7; while (0);
	                    if ((t | 0) == 7) {
	                        t = 0;
	                        c[m >> 2] = By(c[m >> 2] | 0, c[(c[n >> 2] | 0) + 40 >> 2] | 0) | 0
	                    }
	                    do if ((c[m >> 2] | 0) != 0 ? (c[q >> 2] = xy(c[m >> 2] | 0) | 0, (c[q >> 2] | 0) > 0) : 0) {
	                        a[r >> 0] = a[(c[m >> 2] | 0) + ((c[q >> 2] | 0) - 1) >> 0] | 0;
	                        if ((((d[r >> 0] | 0 | 0) != 32 ? (d[r >> 0] | 0 | 0) != 10 : 0) ? (d[r >> 0] | 0 | 0) != 13 : 0) ? (d[r >> 0] | 0 | 0) != 9 : 0)break;
	                        while (1) {
	                            if ((((d[r >> 0] | 0 | 0) != 32 ? (d[r >> 0] | 0 | 0) != 10 : 0) ? (d[r >> 0] | 0 | 0) != 13 : 0) ? (d[r >> 0] | 0 | 0) != 9 : 0)break;
	                            c[q >> 2] = (c[q >> 2] | 0) + -1;
	                            if (!(c[q >> 2] | 0))break;
	                            a[r >> 0] = a[(c[m >> 2] | 0) + ((c[q >> 2] | 0) - 1) >> 0] | 0
	                        }
	                        a[(c[m >> 2] | 0) + (c[q >> 2] | 0) >> 0] = 32;
	                        a[(c[m >> 2] | 0) + ((c[q >> 2] | 0) + 1) >> 0] = 0
	                    } while (0);
	                    c[n >> 2] = c[(c[n >> 2] | 0) + 24 >> 2]
	                }
	                c[h >> 2] = c[m >> 2];
	                s = c[h >> 2] | 0;
	                i = g;
	                return s | 0
	            }

	            function HS(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                e = i;
	                i = i + 32 | 0;
	                f = e + 20 | 0;
	                g = e + 16 | 0;
	                h = e + 12 | 0;
	                j = e + 8 | 0;
	                k = e + 4 | 0;
	                l = e;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                c[j >> 2] = d;
	                c[k >> 2] = 0;
	                if ((c[g >> 2] | 0) == 0 | (c[h >> 2] | 0) == 0 | (c[j >> 2] | 0) == 0) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                c[c[(c[g >> 2] | 0) + 24 >> 2] >> 2] = c[(c[h >> 2] | 0) + 32 >> 2];
	                c[(c[(c[g >> 2] | 0) + 24 >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                c[l >> 2] = Rs(c[j >> 2] | 0, c[(c[g >> 2] | 0) + 24 >> 2] | 0) | 0;
	                if (!(c[l >> 2] | 0)) {
	                    c[f >> 2] = 0;
	                    m = c[f >> 2] | 0;
	                    i = e;
	                    return m | 0
	                }
	                if (((c[c[l >> 2] >> 2] | 0) == 1 ? (c[(c[l >> 2] | 0) + 4 >> 2] | 0) != 0 : 0) ? (c[c[(c[l >> 2] | 0) + 4 >> 2] >> 2] | 0) > 0 : 0)c[k >> 2] = c[c[(c[(c[l >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] >> 2];
	                Qq(c[l >> 2] | 0);
	                c[f >> 2] = c[k >> 2];
	                m = c[f >> 2] | 0;
	                i = e;
	                return m | 0
	            }

	            function IS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[g >> 2] = a;
	                c[h >> 2] = b;
	                b = Cb[c[135744 >> 2] & 511](12) | 0;
	                c[j >> 2] = b;
	                if (!b) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 203144, e);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                b = c[j >> 2] | 0;
	                c[b + 0 >> 2] = 0;
	                c[b + 4 >> 2] = 0;
	                c[b + 8 >> 2] = 0;
	                b = Cb[c[135744 >> 2] & 511](12) | 0;
	                c[c[j >> 2] >> 2] = b;
	                if (!b) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 203184, e);
	                    zb[c[135736 >> 2] & 511](c[j >> 2] | 0);
	                    c[f >> 2] = 0;
	                    k = c[f >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[c[c[j >> 2] >> 2] >> 2] = c[c[j >> 2] >> 2];
	                c[(c[c[j >> 2] >> 2] | 0) + 4 >> 2] = c[c[j >> 2] >> 2];
	                c[(c[c[j >> 2] >> 2] | 0) + 8 >> 2] = 0;
	                if (c[g >> 2] | 0)c[(c[j >> 2] | 0) + 4 >> 2] = c[g >> 2];
	                if (c[h >> 2] | 0)c[(c[j >> 2] | 0) + 8 >> 2] = c[h >> 2]; else c[(c[j >> 2] | 0) + 8 >> 2] = 390;
	                c[f >> 2] = c[j >> 2];
	                k = c[f >> 2] | 0;
	                i = d;
	                return k | 0
	            }

	            function JS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    c[h >> 2] = RS(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if (c[h >> 2] | 0) {
	                        c[e >> 2] = c[(c[h >> 2] | 0) + 8 >> 2];
	                        break
	                    } else {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function KS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = SS(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 203224, d);
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else {
	                    c[(c[j >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                    c[h >> 2] = c[(c[h >> 2] | 0) + 4 >> 2];
	                    c[c[j >> 2] >> 2] = c[c[h >> 2] >> 2];
	                    c[(c[c[h >> 2] >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                    c[c[h >> 2] >> 2] = c[j >> 2];
	                    c[(c[j >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function LS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                d = i;
	                i = i + 32 | 0;
	                e = d + 20 | 0;
	                f = d + 16 | 0;
	                g = d + 12 | 0;
	                h = d + 8 | 0;
	                j = d + 4 | 0;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                c[h >> 2] = TS(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                c[j >> 2] = Cb[c[135744 >> 2] & 511](12) | 0;
	                if (!(c[j >> 2] | 0)) {
	                    Db[c[135904 >> 2] & 511](c[33980] | 0, 203224, d);
	                    c[e >> 2] = 1;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                } else {
	                    c[(c[j >> 2] | 0) + 8 >> 2] = c[g >> 2];
	                    c[c[j >> 2] >> 2] = c[c[h >> 2] >> 2];
	                    c[(c[c[h >> 2] >> 2] | 0) + 4 >> 2] = c[j >> 2];
	                    c[c[h >> 2] >> 2] = c[j >> 2];
	                    c[(c[j >> 2] | 0) + 4 >> 2] = c[h >> 2];
	                    c[e >> 2] = 0;
	                    k = c[e >> 2] | 0;
	                    i = d;
	                    return k | 0
	                }
	                return 0
	            }

	            function MS(a) {
	                a = a | 0;
	                var b = 0, d = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                NS(c[d >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[c[d >> 2] >> 2] | 0);
	                zb[c[135736 >> 2] & 511](c[d >> 2] | 0);
	                i = b;
	                return
	            }

	            function NS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 8 | 0;
	                e = b + 4 | 0;
	                f = b;
	                c[d >> 2] = a;
	                if (!(c[d >> 2] | 0)) {
	                    i = b;
	                    return
	                }
	                c[e >> 2] = c[c[c[d >> 2] >> 2] >> 2];
	                while (1) {
	                    if ((c[e >> 2] | 0) == (c[c[d >> 2] >> 2] | 0))break;
	                    c[f >> 2] = c[c[e >> 2] >> 2];
	                    US(c[d >> 2] | 0, c[e >> 2] | 0);
	                    c[e >> 2] = c[f >> 2]
	                }
	                i = b;
	                return
	            }

	            function OS(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0;
	                b = i;
	                i = i + 16 | 0;
	                d = b + 4 | 0;
	                e = b;
	                c[e >> 2] = a;
	                if (!(c[e >> 2] | 0))c[d >> 2] = 0; else c[d >> 2] = c[(c[e >> 2] | 0) + 8 >> 2];
	                i = b;
	                return c[d >> 2] | 0
	            }

	            function PS(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e + 12 | 0;
	                g = e + 8 | 0;
	                h = e + 4 | 0;
	                j = e;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                c[h >> 2] = d;
	                if ((c[f >> 2] | 0) == 0 | (c[g >> 2] | 0) == 0) {
	                    i = e;
	                    return
	                }
	                c[j >> 2] = c[c[c[f >> 2] >> 2] >> 2];
	                while (1) {
	                    if ((c[j >> 2] | 0) == (c[c[f >> 2] >> 2] | 0)) {
	                        k = 6;
	                        break
	                    }
	                    if (!(Hb[c[g >> 2] & 511](c[(c[j >> 2] | 0) + 8 >> 2] | 0, c[h >> 2] | 0) | 0)) {
	                        k = 6;
	                        break
	                    }
	                    c[j >> 2] = c[c[j >> 2] >> 2]
	                }
	                if ((k | 0) == 6) {
	                    i = e;
	                    return
	                }
	            }

	            function QS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 8 | 0;
	                f = d + 4 | 0;
	                g = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if ((c[f >> 2] | 0) >>> 0 >= (c[g >> 2] | 0) >>> 0)if ((c[f >> 2] | 0) == (c[g >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    break
	                } else {
	                    c[e >> 2] = 1;
	                    break
	                } else c[e >> 2] = -1; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function RS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                do if (c[f >> 2] | 0) {
	                    c[h >> 2] = SS(c[f >> 2] | 0, c[g >> 2] | 0) | 0;
	                    if ((c[h >> 2] | 0) == (c[c[f >> 2] >> 2] | 0)) {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                    if (!(Hb[c[(c[f >> 2] | 0) + 8 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0)) {
	                        c[e >> 2] = c[h >> 2];
	                        break
	                    } else {
	                        c[e >> 2] = 0;
	                        break
	                    }
	                } else c[e >> 2] = 0; while (0);
	                i = d;
	                return c[e >> 2] | 0
	            }

	            function SS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = c[c[c[f >> 2] >> 2] >> 2];
	                while (1) {
	                    if ((c[h >> 2] | 0) == (c[c[f >> 2] >> 2] | 0))break;
	                    if ((Hb[c[(c[f >> 2] | 0) + 8 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0) >= 0)break;
	                    c[h >> 2] = c[c[h >> 2] >> 2]
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function TS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 12 | 0;
	                f = d + 8 | 0;
	                g = d + 4 | 0;
	                h = d;
	                c[f >> 2] = a;
	                c[g >> 2] = b;
	                if (!(c[f >> 2] | 0)) {
	                    c[e >> 2] = 0;
	                    j = c[e >> 2] | 0;
	                    i = d;
	                    return j | 0
	                }
	                c[h >> 2] = c[(c[c[f >> 2] >> 2] | 0) + 4 >> 2];
	                while (1) {
	                    if ((c[h >> 2] | 0) == (c[c[f >> 2] >> 2] | 0))break;
	                    if ((Hb[c[(c[f >> 2] | 0) + 8 >> 2] & 511](c[(c[h >> 2] | 0) + 8 >> 2] | 0, c[g >> 2] | 0) | 0) <= 0)break;
	                    c[h >> 2] = c[(c[h >> 2] | 0) + 4 >> 2]
	                }
	                c[e >> 2] = c[h >> 2];
	                j = c[e >> 2] | 0;
	                i = d;
	                return j | 0
	            }

	            function US(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                i = i + 16 | 0;
	                e = d + 4 | 0;
	                f = d;
	                c[e >> 2] = a;
	                c[f >> 2] = b;
	                c[c[(c[f >> 2] | 0) + 4 >> 2] >> 2] = c[c[f >> 2] >> 2];
	                c[(c[c[f >> 2] >> 2] | 0) + 4 >> 2] = c[(c[f >> 2] | 0) + 4 >> 2];
	                if (!(c[(c[e >> 2] | 0) + 4 >> 2] | 0)) {
	                    g = c[33934] | 0;
	                    h = c[f >> 2] | 0;
	                    zb[g & 511](h);
	                    i = d;
	                    return
	                }
	                zb[c[(c[e >> 2] | 0) + 4 >> 2] & 511](c[f >> 2] | 0);
	                g = c[33934] | 0;
	                h = c[f >> 2] | 0;
	                zb[g & 511](h);
	                i = d;
	                return
	            }

	            function VS(a) {
	                a = a | 0;
	                return (a + -97 | 0) >>> 0 < 26 | 0
	            }

	            function WS(a) {
	                a = a | 0;
	                var b = 0, c = 0;
	                b = i;
	                c = (VS(a) | 0) == 0;
	                i = b;
	                return (c ? a : a & 95) | 0
	            }

	            function XS(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0;
	                e = i;
	                f = gT(a) | 0;
	                if (((f | 0) != -1 ? (a = gT(b) | 0, (a | 0) != -1) : 0) ? (d[203264 + f >> 0] | 0) <= 207 : 0) {
	                    g = a << 16 | f;
	                    i = e;
	                    return g | 0
	                }
	                c[(_a() | 0) >> 2] = 22;
	                g = -1;
	                i = e;
	                return g | 0
	            }

	            function YS(a) {
	                a = a | 0;
	                return 0
	            }

	            function ZS(f, g, h, j, k) {
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                j = j | 0;
	                k = k | 0;
	                var l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0, Ca = 0, Da = 0, Ea = 0, Fa = 0, Ga = 0, Ha = 0, Ia = 0;
	                l = i;
	                i = i + 32 | 0;
	                m = l;
	                n = l + 16 | 0;
	                o = l + 12 | 0;
	                p = l + 8 | 0;
	                q = l + 20 | 0;
	                r = f;
	                f = r & 65535;
	                s = r >>> 16;
	                r = s + 1 | 0;
	                t = f + 1 | 0;
	                u = m;
	                c[u >> 2] = 0;
	                c[u + 4 >> 2] = 0;
	                u = a[203264 + s >> 0] | 0;
	                v = a[203264 + f >> 0] | 0;
	                if (!g) {
	                    w = 0;
	                    i = l;
	                    return w | 0
	                }
	                x = c[g >> 2] | 0;
	                if (!x) {
	                    w = 0;
	                    i = l;
	                    return w | 0
	                }
	                y = c[h >> 2] | 0;
	                if (!y) {
	                    w = 0;
	                    i = l;
	                    return w | 0
	                }
	                z = u & 255;
	                A = z + 128 | 0;
	                B = s + 2 | 0;
	                s = z & 3;
	                C = s ^ 1;
	                D = s ^ 2;
	                E = s ^ 3;
	                F = z & 1;
	                G = F ^ 1;
	                H = (z & 254 | 0) == 196;
	                I = F | 2;
	                J = G | 2;
	                K = u << 24 >> 24 == -38;
	                L = u << 24 >> 24 == -40;
	                M = v & 255;
	                N = M + -192 | 0;
	                O = N >>> 0 > 8;
	                P = f;
	                Q = 281312 + N | 0;
	                N = M + 128 | 0;
	                R = 128 - M | 0;
	                S = v << 24 >> 24 == -128;
	                v = f + 2 | 0;
	                f = (u & -2) << 24 >> 24 == -60;
	                u = M & 1;
	                T = u ^ 1;
	                U = u | 2;
	                V = T | 2;
	                W = M & 3;
	                X = W ^ 1;
	                Y = W ^ 2;
	                Z = W ^ 3;
	                _ = (z + -192 | 0) >>> 0 < 7;
	                $ = x;
	                x = y;
	                y = 0;
	                a:while (1) {
	                    aa = a[$ >> 0] | 0;
	                    ba = aa & 255;
	                    b:do if (aa << 24 >> 24 < 0 | _) {
	                        do switch (z | 0) {
	                            case 208:
	                            {
	                                if (x >>> 0 < 2) {
	                                    ca = 22;
	                                    break a
	                                }
	                                da = d[$ + 1 >> 0] | 0;
	                                if (aa << 24 >> 24 != -114) {
	                                    ea = ba + -161 | 0;
	                                    fa = da + -161 | 0;
	                                    if (ea >>> 0 > 83 | fa >>> 0 > 93) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    ia = b[207296 + (ea * 188 | 0) + (fa << 1) >> 1] | 0;
	                                    if (!(ia << 16 >> 16)) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    } else {
	                                        ja = ia & 65535;
	                                        ka = 2;
	                                        ha = 89;
	                                        break b
	                                    }
	                                } else {
	                                    if ((da + -161 | 0) >>> 0 > 62) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    ja = da + 65216 | 0;
	                                    ka = 2;
	                                    ha = 89;
	                                    break b
	                                }
	                                break
	                            }
	                            case 198:
	                            {
	                                if (x >>> 0 < 4) {
	                                    ca = 22;
	                                    break a
	                                }
	                                la = c[$ >> 2] | 0;
	                                ha = 14;
	                                break
	                            }
	                            case 200:
	                            {
	                                da = _S(n, $, x, m) | 0;
	                                if (!da)ma = 1; else if ((da | 0) == -1) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                } else if ((da | 0) == -2) {
	                                    ca = 22;
	                                    break a
	                                } else ma = da;
	                                ja = c[n >> 2] | 0;
	                                ka = ma;
	                                ha = 89;
	                                break b;
	                                break
	                            }
	                            case 224:
	                            {
	                                if (x >>> 0 < 2) {
	                                    ca = 22;
	                                    break a
	                                }
	                                da = d[$ + 1 >> 0] | 0;
	                                ia = da + -64 | 0;
	                                if (ia >>> 0 > 190 | (da + -127 | 0) >>> 0 < 34) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                fa = ia >>> 0 > 62 ? da + -98 | 0 : ia;
	                                ia = ba + -161 | 0;
	                                if (ia >>> 0 <= 88) {
	                                    da = e[281352 + (ia * 314 | 0) + (fa << 1) >> 1] | 0;
	                                    if ((ia | 0) == 39 ? (fa | 0) == 66 | (fa | 0) == 58 | (fa | 0) == 60 : 0)na = 131072; else na = 0;
	                                    ia = na | da;
	                                    if (!ia) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    } else {
	                                        ja = ia;
	                                        ka = 2;
	                                        ha = 89;
	                                        break b
	                                    }
	                                }
	                                ia = ba + -135 | 0;
	                                if (ia >>> 0 > 119) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                da = fa + (((aa & 255) < 161 ? ia : ba + -224 | 0) * 157 | 0) | 0;
	                                ia = e[270968 + (da << 1) >> 1] | 0;
	                                fa = ia | (((e[270968 + ((da >>> 4) + 4867 << 1) >> 1] | 0) >>> (da & 15) | 0) % 2 | 0) << 17;
	                                if ((fa & -65792 | 0) != 56320)if (!fa) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                } else {
	                                    ja = fa;
	                                    ka = 2;
	                                    ha = 89;
	                                    break b
	                                }
	                                if (O)oa = 2; else oa = a[Q >> 0] | 0;
	                                if (oa >>> 0 > (c[k >> 2] | 0) >>> 0) {
	                                    ga = 7;
	                                    ha = 114;
	                                    break a
	                                }
	                                c[o >> 2] = 281328 + (ia & 255);
	                                c[p >> 2] = 4;
	                                pa = 2;
	                                qa = (ZS(P, o, p, j, k) | 0) + y | 0;
	                                break b;
	                                break
	                            }
	                            case 218:
	                            {
	                                if ((aa & 255) < 161) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                break
	                            }
	                            case 216:
	                            case 217:
	                                break;
	                            case 193:
	                            case 194:
	                            case 197:
	                            case 196:
	                            {
	                                if (x >>> 0 < 2) {
	                                    ca = 22;
	                                    break a
	                                }
	                                ia = d[$ + F >> 0] << 8;
	                                fa = ia | d[$ + G >> 0];
	                                da = ia & 64512;
	                                if ((da | 0) == 56320) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                } else if ((da | 0) != 55296) {
	                                    ja = fa;
	                                    ka = 2;
	                                    ha = 89;
	                                    break b
	                                }
	                                if (H) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                if (x >>> 0 < 4) {
	                                    ca = 22;
	                                    break a
	                                }
	                                da = (d[$ + I >> 0] << 8 | d[$ + J >> 0]) + -56320 | 0;
	                                if (da >>> 0 > 1023) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                ja = (fa << 10) + -56557568 + da | 0;
	                                ka = 4;
	                                ha = 89;
	                                break b;
	                                break
	                            }
	                            case 195:
	                            case 192:
	                            {
	                                if (x >>> 0 < 4) {
	                                    ca = 22;
	                                    break a
	                                }
	                                la = d[$ + C >> 0] << 16 | d[$ + s >> 0] << 24 | d[$ + D >> 0] << 8 | d[$ + E >> 0];
	                                ha = 14;
	                                break
	                            }
	                            case 232:
	                            {
	                                if (x >>> 0 < 2) {
	                                    ca = 22;
	                                    break a
	                                }
	                                da = a[$ + 1 >> 0] | 0;
	                                fa = da & 255;
	                                ia = ba + -161 | 0;
	                                ea = fa + -161 | 0;
	                                if (!(ia >>> 0 > 92 | ea >>> 0 > 93)) {
	                                    ra = b[309304 + (ia * 188 | 0) + (ea << 1) >> 1] | 0;
	                                    if (!(ra << 16 >> 16)) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    } else {
	                                        ja = ra & 65535;
	                                        ka = 2;
	                                        ha = 89;
	                                        break b
	                                    }
	                                }
	                                ra = ba + -129 | 0;
	                                if (ra >>> 0 > 92) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                if (ra >>> 0 > 68 & (da & 255) > 82) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                }
	                                da = fa + -65 | 0;
	                                do if (da >>> 0 < 26)sa = da; else {
	                                    if ((fa + -97 | 0) >>> 0 < 26) {
	                                        sa = fa + -71 | 0;
	                                        break
	                                    }
	                                    if ((fa + -129 | 0) >>> 0 >= 126) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    sa = fa + -77 | 0
	                                } while (0);
	                                if (ra >>> 0 < 32)ta = ra * 178 | 0; else ta = (ia * 84 | 0) + 5696 | 0;
	                                fa = sa + 44032 + ta | 0;
	                                if (fa >>> 0 < 44032) {
	                                    ja = fa;
	                                    ka = 2;
	                                    ha = 89;
	                                    break b
	                                } else {
	                                    ua = fa;
	                                    va = 44032
	                                }
	                                while (1) {
	                                    fa = ua - va | 0;
	                                    da = 0;
	                                    ea = 0;
	                                    while (1) {
	                                        wa = 0;
	                                        xa = ea;
	                                        do {
	                                            xa = (((e[309304 + (da * 188 | 0) + (wa << 1) >> 1] | 0) - va | 0) >>> 0 <= fa >>> 0 & 1) + xa | 0;
	                                            wa = wa + 1 | 0
	                                        } while ((wa | 0) != 94);
	                                        da = da + 1 | 0;
	                                        if ((da | 0) == 93)break; else ea = xa
	                                    }
	                                    va = ua + 1 | 0;
	                                    ea = xa + ua | 0;
	                                    if (ea >>> 0 < va >>> 0) {
	                                        ja = ea;
	                                        ka = 2;
	                                        ha = 89;
	                                        break b
	                                    } else ua = ea
	                                }
	                                break
	                            }
	                            case 209:
	                            {
	                                if ((ba + -161 | 0) >>> 0 < 63) {
	                                    ja = ba + 65216 | 0;
	                                    ka = 1;
	                                    ha = 89;
	                                    break b
	                                }
	                                if (x >>> 0 < 2) {
	                                    ca = 22;
	                                    break a
	                                }
	                                ia = a[$ + 1 >> 0] | 0;
	                                ra = ia & 255;
	                                ea = ba + -129 | 0;
	                                if (ea >>> 0 < 31)ya = ea; else {
	                                    if ((ba & 240 | 0) != 224) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    ya = ba + -193 | 0
	                                }
	                                ea = ya << 1;
	                                da = ra + -64 | 0;
	                                if (da >>> 0 < 95) {
	                                    if (ia << 24 >> 24 == 127) {
	                                        ga = 84;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    za = ea;
	                                    Aa = da + (ia << 24 >> 24 >> 7 << 24 >> 24) | 0
	                                } else {
	                                    ia = ra + -159 | 0;
	                                    da = ia >>> 0 < 94;
	                                    za = ea | da & 1;
	                                    Aa = da ? ia : ra
	                                }
	                                ra = b[207296 + (za * 188 | 0) + (Aa << 1) >> 1] | 0;
	                                if (!(ra << 16 >> 16)) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                } else {
	                                    ja = ra & 65535;
	                                    ka = 2;
	                                    ha = 89;
	                                    break b
	                                }
	                                break
	                            }
	                            case 199:
	                            {
	                                ga = 84;
	                                ha = 114;
	                                break a;
	                                break
	                            }
	                            default:
	                            {
	                                if (ba >>> 0 < A >>> 0) {
	                                    ja = ba;
	                                    ka = 1;
	                                    ha = 89;
	                                    break b
	                                }
	                                ra = ba - A | 0;
	                                ia = (ra * 5 | 0) >>> 2;
	                                da = ra << 1 & 6;
	                                ra = d[203264 + (B + ia) >> 0] << 8 - da & 1023 | (d[203264 + (ia + r) >> 0] | 0) >>> da;
	                                da = (ra | 0) == 0 ? ba : e[326792 + (ra << 1) >> 1] | 0;
	                                if ((da | 0) == 1) {
	                                    ga = 84;
	                                    ha = 114;
	                                    break a
	                                } else {
	                                    ja = da;
	                                    ka = 1;
	                                    ha = 89;
	                                    break b
	                                }
	                            }
	                        } while (0);
	                        if ((ha | 0) == 14) {
	                            ha = 0;
	                            if ((la & -2048 | 0) == 55296 | la >>> 0 > 1114111) {
	                                ga = 84;
	                                ha = 114;
	                                break a
	                            } else {
	                                ja = la;
	                                ka = 4;
	                                ha = 89;
	                                break
	                            }
	                        }
	                        da = ba + -129 | 0;
	                        if (da >>> 0 > 125) {
	                            ga = 84;
	                            ha = 114;
	                            break a
	                        }
	                        if (x >>> 0 < 2) {
	                            ca = 22;
	                            break a
	                        }
	                        ra = a[$ + 1 >> 0] | 0;
	                        ia = ra & 255;
	                        if ((ra & 255) < 161 & K) {
	                            ga = 84;
	                            ha = 114;
	                            break a
	                        }
	                        ea = ia + -64 | 0;
	                        if (!(ea >>> 0 > 190 | ra << 24 >> 24 == 127)) {
	                            ja = e[223088 + (da * 380 | 0) + ((ea >>> 0 > 63 ? ia + -65 | 0 : ea) << 1) >> 1] | 0;
	                            ka = 2;
	                            ha = 89;
	                            break
	                        }
	                        if (!((ia + -48 | 0) >>> 0 < 10 & L)) {
	                            ga = 84;
	                            ha = 114;
	                            break a
	                        }
	                        if (x >>> 0 < 4) {
	                            ca = 22;
	                            break a
	                        }
	                        ea = (d[$ + 2 >> 0] | 0) + -129 | 0;
	                        if (ea >>> 0 > 126) {
	                            ga = 84;
	                            ha = 114;
	                            break a
	                        }
	                        ra = (d[$ + 3 >> 0] | 0) + -48 | 0;
	                        if (ra >>> 0 > 9) {
	                            ga = 84;
	                            ha = 114;
	                            break a
	                        }
	                        fa = ((ia + (da * 10 | 0) | 0) * 1260 | 0) + -60352 + (ea * 10 | 0) + ra | 0;
	                        ra = 0;
	                        while (1) {
	                            ea = fa - ra | 0;
	                            da = 0;
	                            ia = 0;
	                            while (1) {
	                                wa = 0;
	                                Ba = ia;
	                                do {
	                                    Ba = (((e[223088 + (da * 380 | 0) + (wa << 1) >> 1] | 0) - ra | 0) >>> 0 <= ea >>> 0 & 1) + Ba | 0;
	                                    wa = wa + 1 | 0
	                                } while ((wa | 0) != 190);
	                                da = da + 1 | 0;
	                                if ((da | 0) == 126)break; else ia = Ba
	                            }
	                            ra = fa + 1 | 0;
	                            ia = Ba + fa | 0;
	                            if (ia >>> 0 < ra >>> 0) {
	                                ja = ia;
	                                ka = 4;
	                                ha = 89;
	                                break
	                            } else fa = ia
	                        }
	                    } else {
	                        ja = ba;
	                        ka = 1;
	                        ha = 89
	                    } while (0);
	                    c:do if ((ha | 0) == 89) {
	                        ha = 0;
	                        switch (M | 0) {
	                            case 195:
	                            case 192:
	                            {
	                                if ((c[k >> 2] | 0) >>> 0 < 4) {
	                                    ga = 7;
	                                    ha = 114;
	                                    break a
	                                }
	                                ba = c[j >> 2] | 0;
	                                a[ba + W >> 0] = ja >>> 24;
	                                a[ba + X >> 0] = ja >>> 16;
	                                a[ba + Y >> 0] = ja >>> 8;
	                                a[ba + Z >> 0] = ja;
	                                c[j >> 2] = ba + 4;
	                                c[k >> 2] = (c[k >> 2] | 0) + -4;
	                                pa = ka;
	                                qa = y;
	                                break c;
	                                break
	                            }
	                            case 199:
	                            {
	                                if (ja >>> 0 > 127) {
	                                    Ca = y;
	                                    ha = 98
	                                } else {
	                                    Da = ja;
	                                    Ea = y
	                                }
	                                break
	                            }
	                            case 200:
	                            {
	                                if ((c[k >> 2] | 0) >>> 0 < 4) {
	                                    ba = CT(q, ja) | 0;
	                                    if ((c[k >> 2] | 0) >>> 0 < ba >>> 0) {
	                                        ga = 7;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    aa = c[j >> 2] | 0;
	                                    eU(aa | 0, q | 0, ba | 0) | 0;
	                                    Fa = aa;
	                                    Ga = ba
	                                } else {
	                                    ba = c[j >> 2] | 0;
	                                    Fa = ba;
	                                    Ga = CT(ba, ja) | 0
	                                }
	                                c[j >> 2] = Fa + Ga;
	                                c[k >> 2] = (c[k >> 2] | 0) - Ga;
	                                pa = ka;
	                                qa = y;
	                                break c;
	                                break
	                            }
	                            case 193:
	                            case 194:
	                            case 197:
	                            case 196:
	                            {
	                                if (ja >>> 0 < 65536 | f) {
	                                    ba = ja >>> 0 > 65535 ? 65533 : ja;
	                                    if ((c[k >> 2] | 0) >>> 0 < 2) {
	                                        ga = 7;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    aa = c[j >> 2] | 0;
	                                    a[aa + u >> 0] = ba >>> 8;
	                                    a[aa + T >> 0] = ba;
	                                    c[j >> 2] = aa + 2;
	                                    c[k >> 2] = (c[k >> 2] | 0) + -2;
	                                    pa = ka;
	                                    qa = y;
	                                    break c
	                                } else {
	                                    if ((c[k >> 2] | 0) >>> 0 < 4) {
	                                        ga = 7;
	                                        ha = 114;
	                                        break a
	                                    }
	                                    aa = ja + -65536 | 0;
	                                    ba = c[j >> 2] | 0;
	                                    a[ba + u >> 0] = aa >>> 18 | 216;
	                                    a[ba + T >> 0] = aa >>> 10;
	                                    a[ba + U >> 0] = aa >>> 8 & 3 | 220;
	                                    a[ba + V >> 0] = aa;
	                                    c[j >> 2] = ba + 4;
	                                    c[k >> 2] = (c[k >> 2] | 0) + -4;
	                                    pa = ka;
	                                    qa = y;
	                                    break c
	                                }
	                                break
	                            }
	                            case 198:
	                            {
	                                if ((c[k >> 2] | 0) >>> 0 < 4) {
	                                    ga = 7;
	                                    ha = 114;
	                                    break a
	                                }
	                                ba = c[j >> 2] | 0;
	                                c[ba >> 2] = ja;
	                                c[j >> 2] = ba + 4;
	                                c[k >> 2] = (c[k >> 2] | 0) + -4;
	                                pa = ka;
	                                qa = y;
	                                break c;
	                                break
	                            }
	                            default:
	                            {
	                                Da = ja;
	                                Ea = y
	                            }
	                        }
	                        d:while (1) {
	                            if ((ha | 0) == 98) {
	                                ha = 0;
	                                Da = 42;
	                                Ea = Ca + 1 | 0
	                            }
	                            if (!(c[k >> 2] | 0)) {
	                                ga = 7;
	                                ha = 114;
	                                break a
	                            }
	                            if (Da >>> 0 < N >>> 0) {
	                                Ha = Da;
	                                break
	                            }
	                            if (S) {
	                                Ca = Ea;
	                                ha = 98;
	                                continue
	                            } else Ia = 0;
	                            while (1) {
	                                ba = (Ia * 5 | 0) >>> 2;
	                                aa = Ia << 1 & 6;
	                                fa = Ia + 1 | 0;
	                                if ((Da | 0) == (e[326792 + ((d[203264 + (v + ba) >> 0] << 8 - aa & 1023 | (d[203264 + (ba + t) >> 0] | 0) >>> aa) << 1) >> 1] | 0)) {
	                                    ha = 105;
	                                    break d
	                                }
	                                if (fa >>> 0 < R >>> 0)Ia = fa; else {
	                                    Ca = Ea;
	                                    ha = 98;
	                                    continue d
	                                }
	                            }
	                        }
	                        if ((ha | 0) == 105) {
	                            ha = 0;
	                            Ha = Ia + 128 | 0
	                        }
	                        fa = c[j >> 2] | 0;
	                        c[j >> 2] = fa + 1;
	                        a[fa >> 0] = Ha;
	                        c[k >> 2] = (c[k >> 2] | 0) + -1;
	                        pa = ka;
	                        qa = Ea
	                    } while (0);
	                    $ = (c[g >> 2] | 0) + pa | 0;
	                    c[g >> 2] = $;
	                    fa = x;
	                    x = x - pa | 0;
	                    c[h >> 2] = x;
	                    if ((fa | 0) == (pa | 0)) {
	                        w = qa;
	                        ha = 116;
	                        break
	                    } else y = qa
	                }
	                if ((ha | 0) == 114)ca = ga; else if ((ha | 0) == 116) {
	                    i = l;
	                    return w | 0
	                }
	                c[(_a() | 0) >> 2] = ca;
	                w = -1;
	                i = l;
	                return w | 0
	            }

	            function _S(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0;
	                g = i;
	                i = i + 16 | 0;
	                h = g;
	                c[h >> 2] = b;
	                j = (f | 0) == 0 ? 328248 : f;
	                f = c[j >> 2] | 0;
	                a:do if (!d) {
	                    if (!f) {
	                        k = 0;
	                        i = g;
	                        return k | 0
	                    }
	                } else {
	                    if (!b) {
	                        c[h >> 2] = h;
	                        l = h
	                    } else l = b;
	                    if (!e) {
	                        k = -2;
	                        i = g;
	                        return k | 0
	                    }
	                    do if (!f) {
	                        m = a[d >> 0] | 0;
	                        n = m & 255;
	                        if (m << 24 >> 24 > -1) {
	                            c[l >> 2] = n;
	                            k = m << 24 >> 24 != 0 & 1;
	                            i = g;
	                            return k | 0
	                        } else {
	                            m = n + -194 | 0;
	                            if (m >>> 0 > 50)break a;
	                            o = e + -1 | 0;
	                            p = c[328040 + (m << 2) >> 2] | 0;
	                            q = d + 1 | 0;
	                            break
	                        }
	                    } else {
	                        o = e;
	                        p = f;
	                        q = d
	                    } while (0);
	                    b:do if (!o)r = p; else {
	                        m = a[q >> 0] | 0;
	                        n = (m & 255) >>> 3;
	                        if ((n + -16 | n + (p >> 26)) >>> 0 > 7)break a; else {
	                            s = o;
	                            t = m;
	                            u = p;
	                            v = q
	                        }
	                        while (1) {
	                            v = v + 1 | 0;
	                            u = (t & 255) + -128 | u << 6;
	                            s = s + -1 | 0;
	                            if ((u | 0) >= 0)break;
	                            if (!s) {
	                                r = u;
	                                break b
	                            }
	                            t = a[v >> 0] | 0;
	                            if ((t & -64) << 24 >> 24 != -128)break a
	                        }
	                        c[j >> 2] = 0;
	                        c[l >> 2] = u;
	                        k = e - s | 0;
	                        i = g;
	                        return k | 0
	                    } while (0);
	                    c[j >> 2] = r;
	                    k = -2;
	                    i = g;
	                    return k | 0
	                } while (0);
	                c[j >> 2] = 0;
	                c[(_a() | 0) >> 2] = 84;
	                k = -1;
	                i = g;
	                return k | 0
	            }

	            function $S(a) {
	                a = a | 0;
	                var b = 0;
	                if (!a)b = 1; else b = (c[a >> 2] | 0) == 0;
	                return b & 1 | 0
	            }

	            function aT(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0;
	                e = i;
	                f = a + 84 | 0;
	                g = c[f >> 2] | 0;
	                h = d + 256 | 0;
	                j = NT(g, 0, h) | 0;
	                if (!j)k = h; else k = j - g | 0;
	                j = k >>> 0 < d >>> 0 ? k : d;
	                eU(b | 0, g | 0, j | 0) | 0;
	                c[a + 4 >> 2] = g + j;
	                b = g + k | 0;
	                c[a + 8 >> 2] = b;
	                c[f >> 2] = b;
	                i = e;
	                return j | 0
	            }

	            function bT(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0;
	                e = i;
	                i = i + 16 | 0;
	                f = e;
	                c[f >> 2] = d;
	                d = dT(a, b, f) | 0;
	                i = e;
	                return d | 0
	            }

	            function cT(e, f, j) {
	                e = e | 0;
	                f = f | 0;
	                j = j | 0;
	                var k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0.0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0, Ca = 0, Da = 0, Ea = 0, Fa = 0, Ga = 0, Ha = 0, Ia = 0, Ja = 0, Ka = 0, La = 0, Ma = 0, Na = 0, Oa = 0, Pa = 0, Qa = 0, Ra = 0, Sa = 0, Ta = 0, Ua = 0, Va = 0, Wa = 0, Xa = 0, Ya = 0, Za = 0, _a = 0, $a = 0, ab = 0, bb = 0, cb = 0, db = 0;
	                k = i;
	                i = i + 304 | 0;
	                l = k + 16 | 0;
	                m = k + 8 | 0;
	                n = k + 33 | 0;
	                o = k;
	                p = k + 32 | 0;
	                q = a[f >> 0] | 0;
	                if (!(q << 24 >> 24)) {
	                    r = 0;
	                    i = k;
	                    return r | 0
	                }
	                s = e + 4 | 0;
	                t = e + 100 | 0;
	                u = e + 108 | 0;
	                v = e + 8 | 0;
	                w = n + 10 | 0;
	                x = n + 33 | 0;
	                y = m + 4 | 0;
	                z = n + 46 | 0;
	                A = n + 94 | 0;
	                B = q;
	                q = 0;
	                C = f;
	                f = 0;
	                D = 0;
	                E = 0;
	                a:while (1) {
	                    b:do if (!(mT(B & 255) | 0)) {
	                        F = (a[C >> 0] | 0) == 37;
	                        c:do if (F) {
	                            H = C + 1 | 0;
	                            I = a[H >> 0] | 0;
	                            do if (I << 24 >> 24 == 37)break c; else if (I << 24 >> 24 == 42) {
	                                J = 0;
	                                K = C + 2 | 0
	                            } else {
	                                L = (I & 255) + -48 | 0;
	                                if (L >>> 0 < 10 ? (a[C + 2 >> 0] | 0) == 36 : 0) {
	                                    c[l >> 2] = c[j >> 2];
	                                    M = L;
	                                    while (1) {
	                                        L = c[l >> 2] | 0;
	                                        N = c[L >> 2] | 0;
	                                        c[l >> 2] = L + 4;
	                                        if (M >>> 0 > 1)M = M + -1 | 0; else break
	                                    }
	                                    J = N;
	                                    K = C + 3 | 0;
	                                    break
	                                }
	                                M = c[j >> 2] | 0;
	                                L = c[M >> 2] | 0;
	                                c[j >> 2] = M + 4;
	                                J = L;
	                                K = H
	                            } while (0);
	                            H = a[K >> 0] | 0;
	                            I = H & 255;
	                            if ((I + -48 | 0) >>> 0 < 10) {
	                                L = I;
	                                I = K;
	                                M = 0;
	                                while (1) {
	                                    O = (M * 10 | 0) + -48 + L | 0;
	                                    P = I + 1 | 0;
	                                    Q = a[P >> 0] | 0;
	                                    L = Q & 255;
	                                    if ((L + -48 | 0) >>> 0 >= 10) {
	                                        R = Q;
	                                        S = P;
	                                        T = O;
	                                        break
	                                    } else {
	                                        I = P;
	                                        M = O
	                                    }
	                                }
	                            } else {
	                                R = H;
	                                S = K;
	                                T = 0
	                            }
	                            if (R << 24 >> 24 == 109) {
	                                M = S + 1 | 0;
	                                U = a[M >> 0] | 0;
	                                V = (J | 0) != 0 & 1;
	                                W = M;
	                                X = 0;
	                                Y = 0
	                            } else {
	                                U = R;
	                                V = 0;
	                                W = S;
	                                X = D;
	                                Y = E
	                            }
	                            M = W + 1 | 0;
	                            switch (U & 255 | 0) {
	                                case 76:
	                                {
	                                    Z = M;
	                                    _ = 2;
	                                    break
	                                }
	                                case 110:
	                                case 112:
	                                case 67:
	                                case 83:
	                                case 91:
	                                case 99:
	                                case 115:
	                                case 88:
	                                case 71:
	                                case 70:
	                                case 69:
	                                case 65:
	                                case 103:
	                                case 102:
	                                case 101:
	                                case 97:
	                                case 120:
	                                case 117:
	                                case 111:
	                                case 105:
	                                case 100:
	                                {
	                                    Z = W;
	                                    _ = 0;
	                                    break
	                                }
	                                case 108:
	                                {
	                                    I = (a[M >> 0] | 0) == 108;
	                                    Z = I ? W + 2 | 0 : M;
	                                    _ = I ? 3 : 1;
	                                    break
	                                }
	                                case 104:
	                                {
	                                    I = (a[M >> 0] | 0) == 104;
	                                    Z = I ? W + 2 | 0 : M;
	                                    _ = I ? -2 : -1;
	                                    break
	                                }
	                                case 116:
	                                case 122:
	                                {
	                                    Z = M;
	                                    _ = 1;
	                                    break
	                                }
	                                case 106:
	                                {
	                                    Z = M;
	                                    _ = 3;
	                                    break
	                                }
	                                default:
	                                {
	                                    $ = V;
	                                    aa = X;
	                                    ba = Y;
	                                    ca = 162;
	                                    break a
	                                }
	                            }
	                            M = d[Z >> 0] | 0;
	                            I = (M & 47 | 0) == 3;
	                            L = I ? M | 32 : M;
	                            M = I ? 1 : _;
	                            if ((L | 0) == 91) {
	                                da = f;
	                                ea = T
	                            } else if ((L | 0) == 99) {
	                                da = f;
	                                ea = (T | 0) < 1 ? 1 : T
	                            } else if ((L | 0) == 110) {
	                                if (!J) {
	                                    fa = q;
	                                    ga = Z;
	                                    ha = f;
	                                    ia = X;
	                                    ja = Y;
	                                    break b
	                                }
	                                switch (M | 0) {
	                                    case -1:
	                                    {
	                                        b[J >> 1] = f;
	                                        fa = q;
	                                        ga = Z;
	                                        ha = f;
	                                        ia = X;
	                                        ja = Y;
	                                        break b;
	                                        break
	                                    }
	                                    case -2:
	                                    {
	                                        a[J >> 0] = f;
	                                        fa = q;
	                                        ga = Z;
	                                        ha = f;
	                                        ia = X;
	                                        ja = Y;
	                                        break b;
	                                        break
	                                    }
	                                    case 3:
	                                    {
	                                        I = J;
	                                        c[I >> 2] = f;
	                                        c[I + 4 >> 2] = ((f | 0) < 0) << 31 >> 31;
	                                        fa = q;
	                                        ga = Z;
	                                        ha = f;
	                                        ia = X;
	                                        ja = Y;
	                                        break b;
	                                        break
	                                    }
	                                    case 0:
	                                    {
	                                        c[J >> 2] = f;
	                                        fa = q;
	                                        ga = Z;
	                                        ha = f;
	                                        ia = X;
	                                        ja = Y;
	                                        break b;
	                                        break
	                                    }
	                                    case 1:
	                                    {
	                                        c[J >> 2] = f;
	                                        fa = q;
	                                        ga = Z;
	                                        ha = f;
	                                        ia = X;
	                                        ja = Y;
	                                        break b;
	                                        break
	                                    }
	                                    default:
	                                    {
	                                        fa = q;
	                                        ga = Z;
	                                        ha = f;
	                                        ia = X;
	                                        ja = Y;
	                                        break b
	                                    }
	                                }
	                            } else {
	                                pT(e, 0);
	                                do {
	                                    I = c[s >> 2] | 0;
	                                    if (I >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                                        c[s >> 2] = I + 1;
	                                        ka = d[I >> 0] | 0
	                                    } else ka = qT(e) | 0
	                                } while ((mT(ka) | 0) != 0);
	                                H = c[s >> 2] | 0;
	                                if (!(c[t >> 2] | 0))la = H; else {
	                                    I = H + -1 | 0;
	                                    c[s >> 2] = I;
	                                    la = I
	                                }
	                                da = (c[u >> 2] | 0) + f + la - (c[v >> 2] | 0) | 0;
	                                ea = T
	                            }
	                            pT(e, ea);
	                            I = c[s >> 2] | 0;
	                            H = c[t >> 2] | 0;
	                            if (I >>> 0 < H >>> 0) {
	                                c[s >> 2] = I + 1;
	                                ma = H
	                            } else {
	                                if ((qT(e) | 0) < 0) {
	                                    $ = V;
	                                    aa = X;
	                                    ba = Y;
	                                    ca = 162;
	                                    break a
	                                }
	                                ma = c[t >> 2] | 0
	                            }
	                            if (ma)c[s >> 2] = (c[s >> 2] | 0) + -1;
	                            d:do switch (L | 0) {
	                                case 71:
	                                case 103:
	                                case 70:
	                                case 102:
	                                case 69:
	                                case 101:
	                                case 65:
	                                case 97:
	                                {
	                                    na = +oT(e, M, 0);
	                                    if ((c[u >> 2] | 0) == ((c[v >> 2] | 0) - (c[s >> 2] | 0) | 0)) {
	                                        oa = V;
	                                        pa = q;
	                                        qa = X;
	                                        ra = Y;
	                                        break a
	                                    }
	                                    if (J)if (!M) {
	                                        g[J >> 2] = na;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break d
	                                    } else if ((M | 0) == 1) {
	                                        h[J >> 3] = na;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break d
	                                    } else if ((M | 0) == 2) {
	                                        h[J >> 3] = na;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break d
	                                    } else {
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break d
	                                    } else {
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y
	                                    }
	                                    break
	                                }
	                                case 111:
	                                {
	                                    va = 8;
	                                    ca = 144;
	                                    break
	                                }
	                                case 117:
	                                case 100:
	                                {
	                                    va = 10;
	                                    ca = 144;
	                                    break
	                                }
	                                case 105:
	                                {
	                                    va = 0;
	                                    ca = 144;
	                                    break
	                                }
	                                case 91:
	                                case 99:
	                                case 115:
	                                {
	                                    H = (L | 0) == 99;
	                                    e:do if ((L & 239 | 0) == 99) {
	                                        cU(n | 0, -1, 257) | 0;
	                                        a[n >> 0] = 0;
	                                        if ((L | 0) == 115) {
	                                            a[x >> 0] = 0;
	                                            a[w + 0 >> 0] = 0;
	                                            a[w + 1 >> 0] = 0;
	                                            a[w + 2 >> 0] = 0;
	                                            a[w + 3 >> 0] = 0;
	                                            a[w + 4 >> 0] = 0;
	                                            wa = Z
	                                        } else wa = Z
	                                    } else {
	                                        I = Z + 1 | 0;
	                                        O = (a[I >> 0] | 0) == 94;
	                                        P = O & 1;
	                                        Q = O ? Z + 2 | 0 : I;
	                                        cU(n | 0, O & 1 | 0, 257) | 0;
	                                        a[n >> 0] = 0;
	                                        O = a[Q >> 0] | 0;
	                                        if (O << 24 >> 24 == 45) {
	                                            I = (P ^ 1) & 255;
	                                            a[z >> 0] = I;
	                                            xa = I;
	                                            ya = Q + 1 | 0
	                                        } else if (O << 24 >> 24 == 93) {
	                                            O = (P ^ 1) & 255;
	                                            a[A >> 0] = O;
	                                            xa = O;
	                                            ya = Q + 1 | 0
	                                        } else {
	                                            xa = (P ^ 1) & 255;
	                                            ya = Q
	                                        }
	                                        Q = ya;
	                                        while (1) {
	                                            P = a[Q >> 0] | 0;
	                                            if (!(P << 24 >> 24)) {
	                                                $ = V;
	                                                aa = X;
	                                                ba = Y;
	                                                ca = 162;
	                                                break a
	                                            } else if (P << 24 >> 24 == 93) {
	                                                wa = Q;
	                                                break e
	                                            } else if (P << 24 >> 24 == 45) {
	                                                O = Q + 1 | 0;
	                                                I = a[O >> 0] | 0;
	                                                if (!(I << 24 >> 24 == 93 | I << 24 >> 24 == 0)) {
	                                                    za = a[Q + -1 >> 0] | 0;
	                                                    if ((za & 255) < (I & 255)) {
	                                                        Aa = za & 255;
	                                                        do {
	                                                            Aa = Aa + 1 | 0;
	                                                            a[n + Aa >> 0] = xa;
	                                                            za = a[O >> 0] | 0
	                                                        } while ((Aa | 0) < (za & 255 | 0));
	                                                        Ba = za;
	                                                        Ca = O
	                                                    } else {
	                                                        Ba = I;
	                                                        Ca = O
	                                                    }
	                                                } else {
	                                                    Ba = 45;
	                                                    Ca = Q
	                                                }
	                                            } else {
	                                                Ba = P;
	                                                Ca = Q
	                                            }
	                                            a[n + ((Ba & 255) + 1) >> 0] = xa;
	                                            Q = Ca + 1 | 0
	                                        }
	                                    } while (0);
	                                    Q = H ? ea + 1 | 0 : 31;
	                                    Aa = (M | 0) == 1;
	                                    za = (V | 0) != 0;
	                                    f:do if (Aa) {
	                                        if (za) {
	                                            Da = iT(Q << 2) | 0;
	                                            if (!Da) {
	                                                $ = V;
	                                                aa = 0;
	                                                ba = Da;
	                                                ca = 162;
	                                                break a
	                                            } else Ea = Da
	                                        } else Ea = J;
	                                        c[m >> 2] = 0;
	                                        c[y >> 2] = 0;
	                                        Da = 0;
	                                        Fa = Q;
	                                        Ga = Ea;
	                                        g:while (1) {
	                                            if (!Ga)while (1) {
	                                                Ha = c[s >> 2] | 0;
	                                                if (Ha >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                                                    c[s >> 2] = Ha + 1;
	                                                    Ia = d[Ha >> 0] | 0
	                                                } else Ia = qT(e) | 0;
	                                                if (!(a[n + (Ia + 1) >> 0] | 0)) {
	                                                    Ja = Da;
	                                                    Ka = 0;
	                                                    break g
	                                                }
	                                                a[p >> 0] = Ia;
	                                                Ha = _S(o, p, 1, m) | 0;
	                                                if ((Ha | 0) == -2)continue; else if ((Ha | 0) == -1) {
	                                                    $ = V;
	                                                    aa = 0;
	                                                    ba = 0;
	                                                    ca = 162;
	                                                    break a
	                                                }
	                                                if (za & (Da | 0) == (Fa | 0)) {
	                                                    La = Da;
	                                                    break
	                                                }
	                                            } else {
	                                                if (za)Ma = Da; else {
	                                                    Na = Da;
	                                                    ca = 98;
	                                                    break
	                                                }
	                                                while (1) {
	                                                    while (1) {
	                                                        P = c[s >> 2] | 0;
	                                                        if (P >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                                                            c[s >> 2] = P + 1;
	                                                            Oa = d[P >> 0] | 0
	                                                        } else Oa = qT(e) | 0;
	                                                        if (!(a[n + (Oa + 1) >> 0] | 0)) {
	                                                            Ja = Ma;
	                                                            Ka = Ga;
	                                                            break g
	                                                        }
	                                                        a[p >> 0] = Oa;
	                                                        P = _S(o, p, 1, m) | 0;
	                                                        if ((P | 0) == -1) {
	                                                            $ = V;
	                                                            aa = 0;
	                                                            ba = Ga;
	                                                            ca = 162;
	                                                            break a
	                                                        } else if ((P | 0) != -2)break
	                                                    }
	                                                    c[Ga + (Ma << 2) >> 2] = c[o >> 2];
	                                                    Ma = Ma + 1 | 0;
	                                                    if ((Ma | 0) == (Fa | 0)) {
	                                                        La = Fa;
	                                                        break
	                                                    }
	                                                }
	                                            }
	                                            P = Fa << 1 | 1;
	                                            O = kT(Ga, P << 2) | 0;
	                                            if (!O) {
	                                                $ = V;
	                                                aa = 0;
	                                                ba = Ga;
	                                                ca = 162;
	                                                break a
	                                            }
	                                            Da = La;
	                                            Fa = P;
	                                            Ga = O
	                                        }
	                                        h:do if ((ca | 0) == 98)while (1) {
	                                            ca = 0;
	                                            while (1) {
	                                                Fa = c[s >> 2] | 0;
	                                                if (Fa >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                                                    c[s >> 2] = Fa + 1;
	                                                    Pa = d[Fa >> 0] | 0
	                                                } else Pa = qT(e) | 0;
	                                                if (!(a[n + (Pa + 1) >> 0] | 0)) {
	                                                    Ja = Na;
	                                                    Ka = Ga;
	                                                    break h
	                                                }
	                                                a[p >> 0] = Pa;
	                                                Fa = _S(o, p, 1, m) | 0;
	                                                if ((Fa | 0) == -1) {
	                                                    $ = 0;
	                                                    aa = 0;
	                                                    ba = Ga;
	                                                    ca = 162;
	                                                    break a
	                                                } else if ((Fa | 0) != -2)break
	                                            }
	                                            c[Ga + (Na << 2) >> 2] = c[o >> 2];
	                                            Na = Na + 1 | 0;
	                                            ca = 98
	                                        } while (0);
	                                        if (!($S(m) | 0)) {
	                                            $ = V;
	                                            aa = 0;
	                                            ba = Ka;
	                                            ca = 162;
	                                            break a
	                                        } else {
	                                            Qa = Ja;
	                                            Ra = 0;
	                                            Sa = Ka
	                                        }
	                                    } else {
	                                        if (za) {
	                                            Ga = iT(Q) | 0;
	                                            if (!Ga) {
	                                                $ = V;
	                                                aa = 0;
	                                                ba = 0;
	                                                ca = 162;
	                                                break a
	                                            } else {
	                                                Ta = 0;
	                                                Ua = Q;
	                                                Va = Ga
	                                            }
	                                            while (1) {
	                                                Ga = Ta;
	                                                do {
	                                                    Fa = c[s >> 2] | 0;
	                                                    if (Fa >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                                                        c[s >> 2] = Fa + 1;
	                                                        Wa = d[Fa >> 0] | 0
	                                                    } else Wa = qT(e) | 0;
	                                                    if (!(a[n + (Wa + 1) >> 0] | 0)) {
	                                                        Qa = Ga;
	                                                        Ra = Va;
	                                                        Sa = 0;
	                                                        break f
	                                                    }
	                                                    a[Va + Ga >> 0] = Wa;
	                                                    Ga = Ga + 1 | 0
	                                                } while ((Ga | 0) != (Ua | 0));
	                                                Ga = Ua << 1 | 1;
	                                                Fa = kT(Va, Ga) | 0;
	                                                if (!Fa) {
	                                                    $ = V;
	                                                    aa = Va;
	                                                    ba = 0;
	                                                    ca = 162;
	                                                    break a
	                                                } else {
	                                                    Da = Ua;
	                                                    Ua = Ga;
	                                                    Va = Fa;
	                                                    Ta = Da
	                                                }
	                                            }
	                                        }
	                                        if (!J) {
	                                            Da = ma;
	                                            while (1) {
	                                                Fa = c[s >> 2] | 0;
	                                                if (Fa >>> 0 < Da >>> 0) {
	                                                    c[s >> 2] = Fa + 1;
	                                                    Xa = d[Fa >> 0] | 0
	                                                } else Xa = qT(e) | 0;
	                                                if (!(a[n + (Xa + 1) >> 0] | 0)) {
	                                                    Qa = 0;
	                                                    Ra = 0;
	                                                    Sa = 0;
	                                                    break f
	                                                }
	                                                Da = c[t >> 2] | 0
	                                            }
	                                        } else {
	                                            Da = ma;
	                                            Fa = 0;
	                                            while (1) {
	                                                Ga = c[s >> 2] | 0;
	                                                if (Ga >>> 0 < Da >>> 0) {
	                                                    c[s >> 2] = Ga + 1;
	                                                    Ya = d[Ga >> 0] | 0
	                                                } else Ya = qT(e) | 0;
	                                                if (!(a[n + (Ya + 1) >> 0] | 0)) {
	                                                    Qa = Fa;
	                                                    Ra = J;
	                                                    Sa = 0;
	                                                    break f
	                                                }
	                                                a[J + Fa >> 0] = Ya;
	                                                Da = c[t >> 2] | 0;
	                                                Fa = Fa + 1 | 0
	                                            }
	                                        }
	                                    } while (0);
	                                    Q = c[s >> 2] | 0;
	                                    if (!(c[t >> 2] | 0))Za = Q; else {
	                                        Fa = Q + -1 | 0;
	                                        c[s >> 2] = Fa;
	                                        Za = Fa
	                                    }
	                                    Fa = Za - (c[v >> 2] | 0) + (c[u >> 2] | 0) | 0;
	                                    if (!Fa) {
	                                        oa = V;
	                                        pa = q;
	                                        qa = Ra;
	                                        ra = Sa;
	                                        break a
	                                    }
	                                    if (!((Fa | 0) == (ea | 0) | H ^ 1)) {
	                                        oa = V;
	                                        pa = q;
	                                        qa = Ra;
	                                        ra = Sa;
	                                        break a
	                                    }
	                                    do if (za)if (Aa) {
	                                        c[J >> 2] = Sa;
	                                        break
	                                    } else {
	                                        c[J >> 2] = Ra;
	                                        break
	                                    } while (0);
	                                    if (!H) {
	                                        if (Sa)c[Sa + (Qa << 2) >> 2] = 0;
	                                        if (!Ra) {
	                                            sa = wa;
	                                            ta = 0;
	                                            ua = Sa
	                                        } else {
	                                            a[Ra + Qa >> 0] = 0;
	                                            sa = wa;
	                                            ta = Ra;
	                                            ua = Sa
	                                        }
	                                    } else {
	                                        sa = wa;
	                                        ta = Ra;
	                                        ua = Sa
	                                    }
	                                    break
	                                }
	                                case 120:
	                                case 88:
	                                case 112:
	                                {
	                                    va = 16;
	                                    ca = 144;
	                                    break
	                                }
	                                default:
	                                {
	                                    sa = Z;
	                                    ta = X;
	                                    ua = Y
	                                }
	                            } while (0);
	                            i:do if ((ca | 0) == 144) {
	                                ca = 0;
	                                Aa = nT(e, va, 0, -1, -1) | 0;
	                                if ((c[u >> 2] | 0) == ((c[v >> 2] | 0) - (c[s >> 2] | 0) | 0)) {
	                                    oa = V;
	                                    pa = q;
	                                    qa = X;
	                                    ra = Y;
	                                    break a
	                                }
	                                if ((L | 0) == 112 & (J | 0) != 0) {
	                                    c[J >> 2] = Aa;
	                                    sa = Z;
	                                    ta = X;
	                                    ua = Y;
	                                    break
	                                }
	                                if (!J) {
	                                    sa = Z;
	                                    ta = X;
	                                    ua = Y
	                                } else switch (M | 0) {
	                                    case -2:
	                                    {
	                                        a[J >> 0] = Aa;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break i;
	                                        break
	                                    }
	                                    case -1:
	                                    {
	                                        b[J >> 1] = Aa;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break i;
	                                        break
	                                    }
	                                    case 0:
	                                    {
	                                        c[J >> 2] = Aa;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break i;
	                                        break
	                                    }
	                                    case 1:
	                                    {
	                                        c[J >> 2] = Aa;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break i;
	                                        break
	                                    }
	                                    case 3:
	                                    {
	                                        za = J;
	                                        c[za >> 2] = Aa;
	                                        c[za + 4 >> 2] = G;
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break i;
	                                        break
	                                    }
	                                    default:
	                                    {
	                                        sa = Z;
	                                        ta = X;
	                                        ua = Y;
	                                        break i
	                                    }
	                                }
	                            } while (0);
	                            fa = ((J | 0) != 0 & 1) + q | 0;
	                            ga = sa;
	                            ha = (c[u >> 2] | 0) + da + (c[s >> 2] | 0) - (c[v >> 2] | 0) | 0;
	                            ia = ta;
	                            ja = ua;
	                            break b
	                        } while (0);
	                        M = C + (F & 1) | 0;
	                        pT(e, 0);
	                        L = c[s >> 2] | 0;
	                        if (L >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                            c[s >> 2] = L + 1;
	                            _a = d[L >> 0] | 0
	                        } else _a = qT(e) | 0;
	                        if ((_a | 0) != (d[M >> 0] | 0)) {
	                            ca = 19;
	                            break a
	                        }
	                        fa = q;
	                        ga = M;
	                        ha = f + 1 | 0;
	                        ia = D;
	                        ja = E
	                    } else {
	                        M = C;
	                        while (1) {
	                            L = M + 1 | 0;
	                            if (!(mT(d[L >> 0] | 0) | 0))break; else M = L
	                        }
	                        pT(e, 0);
	                        do {
	                            F = c[s >> 2] | 0;
	                            if (F >>> 0 < (c[t >> 2] | 0) >>> 0) {
	                                c[s >> 2] = F + 1;
	                                $a = d[F >> 0] | 0
	                            } else $a = qT(e) | 0
	                        } while ((mT($a) | 0) != 0);
	                        F = c[s >> 2] | 0;
	                        if (!(c[t >> 2] | 0))ab = F; else {
	                            L = F + -1 | 0;
	                            c[s >> 2] = L;
	                            ab = L
	                        }
	                        fa = q;
	                        ga = M;
	                        ha = (c[u >> 2] | 0) + f + ab - (c[v >> 2] | 0) | 0;
	                        ia = D;
	                        ja = E
	                    } while (0);
	                    C = ga + 1 | 0;
	                    B = a[C >> 0] | 0;
	                    if (!(B << 24 >> 24)) {
	                        r = fa;
	                        ca = 166;
	                        break
	                    } else {
	                        q = fa;
	                        f = ha;
	                        D = ia;
	                        E = ja
	                    }
	                }
	                if ((ca | 0) == 19) {
	                    if (c[t >> 2] | 0)c[s >> 2] = (c[s >> 2] | 0) + -1;
	                    if ((_a | 0) > -1 | (q | 0) != 0) {
	                        r = q;
	                        i = k;
	                        return r | 0
	                    } else {
	                        bb = 0;
	                        cb = D;
	                        db = E;
	                        ca = 163
	                    }
	                } else if ((ca | 0) == 162)if (!q) {
	                    bb = $;
	                    cb = aa;
	                    db = ba;
	                    ca = 163
	                } else {
	                    oa = $;
	                    pa = q;
	                    qa = aa;
	                    ra = ba
	                } else if ((ca | 0) == 166) {
	                    i = k;
	                    return r | 0
	                }
	                if ((ca | 0) == 163) {
	                    oa = bb;
	                    pa = -1;
	                    qa = cb;
	                    ra = db
	                }
	                if (!oa) {
	                    r = pa;
	                    i = k;
	                    return r | 0
	                }
	                jT(qa);
	                jT(ra);
	                r = pa;
	                i = k;
	                return r | 0
	            }

	            function dT(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                i = i + 112 | 0;
	                f = e;
	                g = f + 0 | 0;
	                h = g + 112 | 0;
	                do {
	                    c[g >> 2] = 0;
	                    g = g + 4 | 0
	                } while ((g | 0) < (h | 0));
	                c[f + 32 >> 2] = 391;
	                c[f + 44 >> 2] = a;
	                c[f + 76 >> 2] = -1;
	                c[f + 84 >> 2] = a;
	                a = cT(f, b, d) | 0;
	                i = e;
	                return a | 0
	            }

	            function eT(b, c) {
	                b = b | 0;
	                c = c | 0;
	                var d = 0, e = 0;
	                d = i;
	                e = fT(b, c) | 0;
	                i = d;
	                return ((a[e >> 0] | 0) == (c & 255) << 24 >> 24 ? e : 0) | 0
	            }

	            function fT(b, d) {
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
	                e = i;
	                f = d & 255;
	                if (!f) {
	                    g = b + (ZT(b | 0) | 0) | 0;
	                    i = e;
	                    return g | 0
	                }
	                a:do if (!(b & 3))h = b; else {
	                    j = d & 255;
	                    k = b;
	                    while (1) {
	                        l = a[k >> 0] | 0;
	                        m = k + 1 | 0;
	                        if (l << 24 >> 24 == 0 ? 1 : l << 24 >> 24 == j << 24 >> 24) {
	                            g = k;
	                            break
	                        }
	                        if (!(m & 3)) {
	                            h = m;
	                            break a
	                        } else k = m
	                    }
	                    i = e;
	                    return g | 0
	                } while (0);
	                b = ca(f, 16843009) | 0;
	                f = c[h >> 2] | 0;
	                b:do if (!((f & -2139062144 ^ -2139062144) & f + -16843009)) {
	                    k = f;
	                    j = h;
	                    while (1) {
	                        m = k ^ b;
	                        l = j + 4 | 0;
	                        if ((m & -2139062144 ^ -2139062144) & m + -16843009) {
	                            n = j;
	                            break b
	                        }
	                        k = c[l >> 2] | 0;
	                        if ((k & -2139062144 ^ -2139062144) & k + -16843009) {
	                            n = l;
	                            break
	                        } else j = l
	                    }
	                } else n = h; while (0);
	                h = d & 255;
	                d = n;
	                while (1) {
	                    n = a[d >> 0] | 0;
	                    if (n << 24 >> 24 == 0 ? 1 : n << 24 >> 24 == h << 24 >> 24) {
	                        g = d;
	                        break
	                    } else d = d + 1 | 0
	                }
	                i = e;
	                return g | 0
	            }

	            function gT(b) {
	                b = b | 0;
	                var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0;
	                c = i;
	                d = a[b >> 0] | 0;
	                a:do if (d << 24 >> 24) {
	                    e = 203264;
	                    while (1) {
	                        f = b;
	                        g = e;
	                        h = d;
	                        while (1) {
	                            j = a[g >> 0] | 0;
	                            if (!(j << 24 >> 24)) {
	                                k = g;
	                                l = h;
	                                m = 16;
	                                break
	                            }
	                            b:do if (!(h << 24 >> 24)) {
	                                n = f;
	                                o = 0
	                            } else {
	                                p = f;
	                                q = h & 255;
	                                r = h;
	                                while (1) {
	                                    s = p + 1 | 0;
	                                    if (!(((q | 32) + -97 | 0) >>> 0 > 26 & (q + -48 | 0) >>> 0 > 10)) {
	                                        n = p;
	                                        o = r;
	                                        break b
	                                    }
	                                    t = a[s >> 0] | 0;
	                                    if (!(t << 24 >> 24)) {
	                                        n = s;
	                                        o = 0;
	                                        break
	                                    } else {
	                                        p = s;
	                                        q = t & 255;
	                                        r = t
	                                    }
	                                }
	                            } while (0);
	                            if ((o & 255 | 32 | 0) != (j & 255 | 0))break;
	                            f = n + 1 | 0;
	                            r = g + 1 | 0;
	                            h = a[f >> 0] | 0;
	                            if (!(h << 24 >> 24)) {
	                                k = r;
	                                l = 0;
	                                m = 16;
	                                break
	                            } else g = r
	                        }
	                        if ((m | 0) == 16 ? (m = 0, l << 24 >> 24 == (a[k >> 0] | 0)) : 0)break;
	                        g = ZT(e | 0) | 0;
	                        h = e + (g + 1) | 0;
	                        do if (!(a[h >> 0] | 0)) {
	                            f = a[e + (g + 2) >> 0] | 0;
	                            if ((f & 255) > 128) {
	                                u = e + (g + 3) | 0;
	                                break
	                            } else {
	                                u = e + (g + 3 + (((128 - (f & 255) | 0) >>> 2) * 5 | 0)) | 0;
	                                break
	                            }
	                        } else u = h; while (0);
	                        if (!(a[u >> 0] | 0)) {
	                            v = -1;
	                            m = 25;
	                            break
	                        } else e = u
	                    }
	                    if ((m | 0) == 25) {
	                        i = c;
	                        return v | 0
	                    }
	                    if (!(a[e >> 0] | 0))w = e; else {
	                        h = e;
	                        while (1) {
	                            g = h + ((ZT(h | 0) | 0) + 1) | 0;
	                            if (!(a[g >> 0] | 0)) {
	                                w = g;
	                                break
	                            } else h = g
	                        }
	                    }
	                } else {
	                    h = 203264;
	                    while (1) {
	                        if (!(a[h >> 0] | 0)) {
	                            w = h;
	                            break a
	                        }
	                        e = ZT(h | 0) | 0;
	                        g = h + (e + 1) | 0;
	                        do if (!(a[g >> 0] | 0)) {
	                            f = a[h + (e + 2) >> 0] | 0;
	                            if ((f & 255) > 128) {
	                                x = h + (e + 3) | 0;
	                                break
	                            } else {
	                                x = h + (e + 3 + (((128 - (f & 255) | 0) >>> 2) * 5 | 0)) | 0;
	                                break
	                            }
	                        } else x = g; while (0);
	                        if (!(a[x >> 0] | 0)) {
	                            v = -1;
	                            break
	                        } else h = x
	                    }
	                    i = c;
	                    return v | 0
	                } while (0);
	                v = w + 1 - 203264 | 0;
	                i = c;
	                return v | 0
	            }

	            function hT(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                var d = 0, e = 0;
	                d = i;
	                e = aT(a, b, c) | 0;
	                i = d;
	                return e | 0
	            }

	            function iT(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0, Ca = 0, Da = 0, Ea = 0, Fa = 0, Ga = 0, Ha = 0, Ia = 0, Ja = 0, Ka = 0, La = 0;
	                b = i;
	                do if (a >>> 0 < 245) {
	                    if (a >>> 0 < 11)d = 16; else d = a + 11 & -8;
	                    e = d >>> 3;
	                    f = c[82064] | 0;
	                    g = f >>> e;
	                    if (g & 3) {
	                        h = (g & 1 ^ 1) + e | 0;
	                        j = h << 1;
	                        k = 328296 + (j << 2) | 0;
	                        l = 328296 + (j + 2 << 2) | 0;
	                        j = c[l >> 2] | 0;
	                        m = j + 8 | 0;
	                        n = c[m >> 2] | 0;
	                        do if ((k | 0) != (n | 0)) {
	                            if (n >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            o = n + 12 | 0;
	                            if ((c[o >> 2] | 0) == (j | 0)) {
	                                c[o >> 2] = k;
	                                c[l >> 2] = n;
	                                break
	                            } else hb()
	                        } else c[82064] = f & ~(1 << h); while (0);
	                        n = h << 3;
	                        c[j + 4 >> 2] = n | 3;
	                        l = j + (n | 4) | 0;
	                        c[l >> 2] = c[l >> 2] | 1;
	                        p = m;
	                        i = b;
	                        return p | 0
	                    }
	                    l = c[82066] | 0;
	                    if (d >>> 0 > l >>> 0) {
	                        if (g) {
	                            n = 2 << e;
	                            k = g << e & (n | 0 - n);
	                            n = (k & 0 - k) + -1 | 0;
	                            k = n >>> 12 & 16;
	                            o = n >>> k;
	                            n = o >>> 5 & 8;
	                            q = o >>> n;
	                            o = q >>> 2 & 4;
	                            r = q >>> o;
	                            q = r >>> 1 & 2;
	                            s = r >>> q;
	                            r = s >>> 1 & 1;
	                            t = (n | k | o | q | r) + (s >>> r) | 0;
	                            r = t << 1;
	                            s = 328296 + (r << 2) | 0;
	                            q = 328296 + (r + 2 << 2) | 0;
	                            r = c[q >> 2] | 0;
	                            o = r + 8 | 0;
	                            k = c[o >> 2] | 0;
	                            do if ((s | 0) != (k | 0)) {
	                                if (k >>> 0 < (c[82068] | 0) >>> 0)hb();
	                                n = k + 12 | 0;
	                                if ((c[n >> 2] | 0) == (r | 0)) {
	                                    c[n >> 2] = s;
	                                    c[q >> 2] = k;
	                                    u = c[82066] | 0;
	                                    break
	                                } else hb()
	                            } else {
	                                c[82064] = f & ~(1 << t);
	                                u = l
	                            } while (0);
	                            l = t << 3;
	                            f = l - d | 0;
	                            c[r + 4 >> 2] = d | 3;
	                            k = r + d | 0;
	                            c[r + (d | 4) >> 2] = f | 1;
	                            c[r + l >> 2] = f;
	                            if (u) {
	                                l = c[82069] | 0;
	                                q = u >>> 3;
	                                s = q << 1;
	                                e = 328296 + (s << 2) | 0;
	                                g = c[82064] | 0;
	                                m = 1 << q;
	                                if (g & m) {
	                                    q = 328296 + (s + 2 << 2) | 0;
	                                    j = c[q >> 2] | 0;
	                                    if (j >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                        v = q;
	                                        w = j
	                                    }
	                                } else {
	                                    c[82064] = g | m;
	                                    v = 328296 + (s + 2 << 2) | 0;
	                                    w = e
	                                }
	                                c[v >> 2] = l;
	                                c[w + 12 >> 2] = l;
	                                c[l + 8 >> 2] = w;
	                                c[l + 12 >> 2] = e
	                            }
	                            c[82066] = f;
	                            c[82069] = k;
	                            p = o;
	                            i = b;
	                            return p | 0
	                        }
	                        k = c[82065] | 0;
	                        if (k) {
	                            f = (k & 0 - k) + -1 | 0;
	                            k = f >>> 12 & 16;
	                            e = f >>> k;
	                            f = e >>> 5 & 8;
	                            l = e >>> f;
	                            e = l >>> 2 & 4;
	                            s = l >>> e;
	                            l = s >>> 1 & 2;
	                            m = s >>> l;
	                            s = m >>> 1 & 1;
	                            g = c[328560 + ((f | k | e | l | s) + (m >>> s) << 2) >> 2] | 0;
	                            s = (c[g + 4 >> 2] & -8) - d | 0;
	                            m = g;
	                            l = g;
	                            while (1) {
	                                g = c[m + 16 >> 2] | 0;
	                                if (!g) {
	                                    e = c[m + 20 >> 2] | 0;
	                                    if (!e)break; else x = e
	                                } else x = g;
	                                g = (c[x + 4 >> 2] & -8) - d | 0;
	                                e = g >>> 0 < s >>> 0;
	                                s = e ? g : s;
	                                m = x;
	                                l = e ? x : l
	                            }
	                            m = c[82068] | 0;
	                            if (l >>> 0 < m >>> 0)hb();
	                            o = l + d | 0;
	                            if (l >>> 0 >= o >>> 0)hb();
	                            r = c[l + 24 >> 2] | 0;
	                            t = c[l + 12 >> 2] | 0;
	                            do if ((t | 0) == (l | 0)) {
	                                e = l + 20 | 0;
	                                g = c[e >> 2] | 0;
	                                if (!g) {
	                                    k = l + 16 | 0;
	                                    f = c[k >> 2] | 0;
	                                    if (!f) {
	                                        y = 0;
	                                        break
	                                    } else {
	                                        z = f;
	                                        A = k
	                                    }
	                                } else {
	                                    z = g;
	                                    A = e
	                                }
	                                while (1) {
	                                    e = z + 20 | 0;
	                                    g = c[e >> 2] | 0;
	                                    if (g) {
	                                        z = g;
	                                        A = e;
	                                        continue
	                                    }
	                                    e = z + 16 | 0;
	                                    g = c[e >> 2] | 0;
	                                    if (!g)break; else {
	                                        z = g;
	                                        A = e
	                                    }
	                                }
	                                if (A >>> 0 < m >>> 0)hb(); else {
	                                    c[A >> 2] = 0;
	                                    y = z;
	                                    break
	                                }
	                            } else {
	                                e = c[l + 8 >> 2] | 0;
	                                if (e >>> 0 < m >>> 0)hb();
	                                g = e + 12 | 0;
	                                if ((c[g >> 2] | 0) != (l | 0))hb();
	                                k = t + 8 | 0;
	                                if ((c[k >> 2] | 0) == (l | 0)) {
	                                    c[g >> 2] = t;
	                                    c[k >> 2] = e;
	                                    y = t;
	                                    break
	                                } else hb()
	                            } while (0);
	                            do if (r) {
	                                t = c[l + 28 >> 2] | 0;
	                                m = 328560 + (t << 2) | 0;
	                                if ((l | 0) == (c[m >> 2] | 0)) {
	                                    c[m >> 2] = y;
	                                    if (!y) {
	                                        c[82065] = c[82065] & ~(1 << t);
	                                        break
	                                    }
	                                } else {
	                                    if (r >>> 0 < (c[82068] | 0) >>> 0)hb();
	                                    t = r + 16 | 0;
	                                    if ((c[t >> 2] | 0) == (l | 0))c[t >> 2] = y; else c[r + 20 >> 2] = y;
	                                    if (!y)break
	                                }
	                                t = c[82068] | 0;
	                                if (y >>> 0 < t >>> 0)hb();
	                                c[y + 24 >> 2] = r;
	                                m = c[l + 16 >> 2] | 0;
	                                do if (m)if (m >>> 0 < t >>> 0)hb(); else {
	                                    c[y + 16 >> 2] = m;
	                                    c[m + 24 >> 2] = y;
	                                    break
	                                } while (0);
	                                m = c[l + 20 >> 2] | 0;
	                                if (m)if (m >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                    c[y + 20 >> 2] = m;
	                                    c[m + 24 >> 2] = y;
	                                    break
	                                }
	                            } while (0);
	                            if (s >>> 0 < 16) {
	                                r = s + d | 0;
	                                c[l + 4 >> 2] = r | 3;
	                                m = l + (r + 4) | 0;
	                                c[m >> 2] = c[m >> 2] | 1
	                            } else {
	                                c[l + 4 >> 2] = d | 3;
	                                c[l + (d | 4) >> 2] = s | 1;
	                                c[l + (s + d) >> 2] = s;
	                                m = c[82066] | 0;
	                                if (m) {
	                                    r = c[82069] | 0;
	                                    t = m >>> 3;
	                                    m = t << 1;
	                                    e = 328296 + (m << 2) | 0;
	                                    k = c[82064] | 0;
	                                    g = 1 << t;
	                                    if (k & g) {
	                                        t = 328296 + (m + 2 << 2) | 0;
	                                        f = c[t >> 2] | 0;
	                                        if (f >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                            B = t;
	                                            C = f
	                                        }
	                                    } else {
	                                        c[82064] = k | g;
	                                        B = 328296 + (m + 2 << 2) | 0;
	                                        C = e
	                                    }
	                                    c[B >> 2] = r;
	                                    c[C + 12 >> 2] = r;
	                                    c[r + 8 >> 2] = C;
	                                    c[r + 12 >> 2] = e
	                                }
	                                c[82066] = s;
	                                c[82069] = o
	                            }
	                            p = l + 8 | 0;
	                            i = b;
	                            return p | 0
	                        } else D = d
	                    } else D = d
	                } else if (a >>> 0 <= 4294967231) {
	                    e = a + 11 | 0;
	                    r = e & -8;
	                    m = c[82065] | 0;
	                    if (m) {
	                        g = 0 - r | 0;
	                        k = e >>> 8;
	                        if (k)if (r >>> 0 > 16777215)E = 31; else {
	                            e = (k + 1048320 | 0) >>> 16 & 8;
	                            f = k << e;
	                            k = (f + 520192 | 0) >>> 16 & 4;
	                            t = f << k;
	                            f = (t + 245760 | 0) >>> 16 & 2;
	                            j = 14 - (k | e | f) + (t << f >>> 15) | 0;
	                            E = r >>> (j + 7 | 0) & 1 | j << 1
	                        } else E = 0;
	                        j = c[328560 + (E << 2) >> 2] | 0;
	                        a:do if (!j) {
	                            F = g;
	                            G = 0;
	                            H = 0
	                        } else {
	                            if ((E | 0) == 31)I = 0; else I = 25 - (E >>> 1) | 0;
	                            f = g;
	                            t = 0;
	                            e = r << I;
	                            k = j;
	                            q = 0;
	                            while (1) {
	                                h = c[k + 4 >> 2] & -8;
	                                n = h - r | 0;
	                                if (n >>> 0 < f >>> 0)if ((h | 0) == (r | 0)) {
	                                    F = n;
	                                    G = k;
	                                    H = k;
	                                    break a
	                                } else {
	                                    J = n;
	                                    K = k
	                                } else {
	                                    J = f;
	                                    K = q
	                                }
	                                n = c[k + 20 >> 2] | 0;
	                                k = c[k + (e >>> 31 << 2) + 16 >> 2] | 0;
	                                h = (n | 0) == 0 | (n | 0) == (k | 0) ? t : n;
	                                if (!k) {
	                                    F = J;
	                                    G = h;
	                                    H = K;
	                                    break
	                                } else {
	                                    f = J;
	                                    t = h;
	                                    e = e << 1;
	                                    q = K
	                                }
	                            }
	                        } while (0);
	                        if ((G | 0) == 0 & (H | 0) == 0) {
	                            j = 2 << E;
	                            g = m & (j | 0 - j);
	                            if (!g) {
	                                D = r;
	                                break
	                            }
	                            j = (g & 0 - g) + -1 | 0;
	                            g = j >>> 12 & 16;
	                            l = j >>> g;
	                            j = l >>> 5 & 8;
	                            o = l >>> j;
	                            l = o >>> 2 & 4;
	                            s = o >>> l;
	                            o = s >>> 1 & 2;
	                            q = s >>> o;
	                            s = q >>> 1 & 1;
	                            L = c[328560 + ((j | g | l | o | s) + (q >>> s) << 2) >> 2] | 0
	                        } else L = G;
	                        if (!L) {
	                            M = F;
	                            N = H
	                        } else {
	                            s = F;
	                            q = L;
	                            o = H;
	                            while (1) {
	                                l = (c[q + 4 >> 2] & -8) - r | 0;
	                                g = l >>> 0 < s >>> 0;
	                                j = g ? l : s;
	                                l = g ? q : o;
	                                g = c[q + 16 >> 2] | 0;
	                                if (g) {
	                                    s = j;
	                                    q = g;
	                                    o = l;
	                                    continue
	                                }
	                                q = c[q + 20 >> 2] | 0;
	                                if (!q) {
	                                    M = j;
	                                    N = l;
	                                    break
	                                } else {
	                                    s = j;
	                                    o = l
	                                }
	                            }
	                        }
	                        if ((N | 0) != 0 ? M >>> 0 < ((c[82066] | 0) - r | 0) >>> 0 : 0) {
	                            o = c[82068] | 0;
	                            if (N >>> 0 < o >>> 0)hb();
	                            s = N + r | 0;
	                            if (N >>> 0 >= s >>> 0)hb();
	                            q = c[N + 24 >> 2] | 0;
	                            m = c[N + 12 >> 2] | 0;
	                            do if ((m | 0) == (N | 0)) {
	                                l = N + 20 | 0;
	                                j = c[l >> 2] | 0;
	                                if (!j) {
	                                    g = N + 16 | 0;
	                                    e = c[g >> 2] | 0;
	                                    if (!e) {
	                                        O = 0;
	                                        break
	                                    } else {
	                                        P = e;
	                                        Q = g
	                                    }
	                                } else {
	                                    P = j;
	                                    Q = l
	                                }
	                                while (1) {
	                                    l = P + 20 | 0;
	                                    j = c[l >> 2] | 0;
	                                    if (j) {
	                                        P = j;
	                                        Q = l;
	                                        continue
	                                    }
	                                    l = P + 16 | 0;
	                                    j = c[l >> 2] | 0;
	                                    if (!j)break; else {
	                                        P = j;
	                                        Q = l
	                                    }
	                                }
	                                if (Q >>> 0 < o >>> 0)hb(); else {
	                                    c[Q >> 2] = 0;
	                                    O = P;
	                                    break
	                                }
	                            } else {
	                                l = c[N + 8 >> 2] | 0;
	                                if (l >>> 0 < o >>> 0)hb();
	                                j = l + 12 | 0;
	                                if ((c[j >> 2] | 0) != (N | 0))hb();
	                                g = m + 8 | 0;
	                                if ((c[g >> 2] | 0) == (N | 0)) {
	                                    c[j >> 2] = m;
	                                    c[g >> 2] = l;
	                                    O = m;
	                                    break
	                                } else hb()
	                            } while (0);
	                            do if (q) {
	                                m = c[N + 28 >> 2] | 0;
	                                o = 328560 + (m << 2) | 0;
	                                if ((N | 0) == (c[o >> 2] | 0)) {
	                                    c[o >> 2] = O;
	                                    if (!O) {
	                                        c[82065] = c[82065] & ~(1 << m);
	                                        break
	                                    }
	                                } else {
	                                    if (q >>> 0 < (c[82068] | 0) >>> 0)hb();
	                                    m = q + 16 | 0;
	                                    if ((c[m >> 2] | 0) == (N | 0))c[m >> 2] = O; else c[q + 20 >> 2] = O;
	                                    if (!O)break
	                                }
	                                m = c[82068] | 0;
	                                if (O >>> 0 < m >>> 0)hb();
	                                c[O + 24 >> 2] = q;
	                                o = c[N + 16 >> 2] | 0;
	                                do if (o)if (o >>> 0 < m >>> 0)hb(); else {
	                                    c[O + 16 >> 2] = o;
	                                    c[o + 24 >> 2] = O;
	                                    break
	                                } while (0);
	                                o = c[N + 20 >> 2] | 0;
	                                if (o)if (o >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                    c[O + 20 >> 2] = o;
	                                    c[o + 24 >> 2] = O;
	                                    break
	                                }
	                            } while (0);
	                            b:do if (M >>> 0 >= 16) {
	                                c[N + 4 >> 2] = r | 3;
	                                c[N + (r | 4) >> 2] = M | 1;
	                                c[N + (M + r) >> 2] = M;
	                                q = M >>> 3;
	                                if (M >>> 0 < 256) {
	                                    o = q << 1;
	                                    m = 328296 + (o << 2) | 0;
	                                    l = c[82064] | 0;
	                                    g = 1 << q;
	                                    do if (!(l & g)) {
	                                        c[82064] = l | g;
	                                        R = 328296 + (o + 2 << 2) | 0;
	                                        S = m
	                                    } else {
	                                        q = 328296 + (o + 2 << 2) | 0;
	                                        j = c[q >> 2] | 0;
	                                        if (j >>> 0 >= (c[82068] | 0) >>> 0) {
	                                            R = q;
	                                            S = j;
	                                            break
	                                        }
	                                        hb()
	                                    } while (0);
	                                    c[R >> 2] = s;
	                                    c[S + 12 >> 2] = s;
	                                    c[N + (r + 8) >> 2] = S;
	                                    c[N + (r + 12) >> 2] = m;
	                                    break
	                                }
	                                o = M >>> 8;
	                                if (o)if (M >>> 0 > 16777215)T = 31; else {
	                                    g = (o + 1048320 | 0) >>> 16 & 8;
	                                    l = o << g;
	                                    o = (l + 520192 | 0) >>> 16 & 4;
	                                    j = l << o;
	                                    l = (j + 245760 | 0) >>> 16 & 2;
	                                    q = 14 - (o | g | l) + (j << l >>> 15) | 0;
	                                    T = M >>> (q + 7 | 0) & 1 | q << 1
	                                } else T = 0;
	                                q = 328560 + (T << 2) | 0;
	                                c[N + (r + 28) >> 2] = T;
	                                c[N + (r + 20) >> 2] = 0;
	                                c[N + (r + 16) >> 2] = 0;
	                                l = c[82065] | 0;
	                                j = 1 << T;
	                                if (!(l & j)) {
	                                    c[82065] = l | j;
	                                    c[q >> 2] = s;
	                                    c[N + (r + 24) >> 2] = q;
	                                    c[N + (r + 12) >> 2] = s;
	                                    c[N + (r + 8) >> 2] = s;
	                                    break
	                                }
	                                j = c[q >> 2] | 0;
	                                if ((T | 0) == 31)U = 0; else U = 25 - (T >>> 1) | 0;
	                                c:do if ((c[j + 4 >> 2] & -8 | 0) != (M | 0)) {
	                                    q = M << U;
	                                    l = j;
	                                    while (1) {
	                                        V = l + (q >>> 31 << 2) + 16 | 0;
	                                        g = c[V >> 2] | 0;
	                                        if (!g)break;
	                                        if ((c[g + 4 >> 2] & -8 | 0) == (M | 0)) {
	                                            W = g;
	                                            break c
	                                        } else {
	                                            q = q << 1;
	                                            l = g
	                                        }
	                                    }
	                                    if (V >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                        c[V >> 2] = s;
	                                        c[N + (r + 24) >> 2] = l;
	                                        c[N + (r + 12) >> 2] = s;
	                                        c[N + (r + 8) >> 2] = s;
	                                        break b
	                                    }
	                                } else W = j; while (0);
	                                j = W + 8 | 0;
	                                m = c[j >> 2] | 0;
	                                q = c[82068] | 0;
	                                if (W >>> 0 >= q >>> 0 & m >>> 0 >= q >>> 0) {
	                                    c[m + 12 >> 2] = s;
	                                    c[j >> 2] = s;
	                                    c[N + (r + 8) >> 2] = m;
	                                    c[N + (r + 12) >> 2] = W;
	                                    c[N + (r + 24) >> 2] = 0;
	                                    break
	                                } else hb()
	                            } else {
	                                m = M + r | 0;
	                                c[N + 4 >> 2] = m | 3;
	                                j = N + (m + 4) | 0;
	                                c[j >> 2] = c[j >> 2] | 1
	                            } while (0);
	                            p = N + 8 | 0;
	                            i = b;
	                            return p | 0
	                        } else D = r
	                    } else D = r
	                } else D = -1; while (0);
	                N = c[82066] | 0;
	                if (N >>> 0 >= D >>> 0) {
	                    M = N - D | 0;
	                    W = c[82069] | 0;
	                    if (M >>> 0 > 15) {
	                        c[82069] = W + D;
	                        c[82066] = M;
	                        c[W + (D + 4) >> 2] = M | 1;
	                        c[W + N >> 2] = M;
	                        c[W + 4 >> 2] = D | 3
	                    } else {
	                        c[82066] = 0;
	                        c[82069] = 0;
	                        c[W + 4 >> 2] = N | 3;
	                        M = W + (N + 4) | 0;
	                        c[M >> 2] = c[M >> 2] | 1
	                    }
	                    p = W + 8 | 0;
	                    i = b;
	                    return p | 0
	                }
	                W = c[82067] | 0;
	                if (W >>> 0 > D >>> 0) {
	                    M = W - D | 0;
	                    c[82067] = M;
	                    W = c[82070] | 0;
	                    c[82070] = W + D;
	                    c[W + (D + 4) >> 2] = M | 1;
	                    c[W + 4 >> 2] = D | 3;
	                    p = W + 8 | 0;
	                    i = b;
	                    return p | 0
	                }
	                do if (!(c[82182] | 0)) {
	                    W = db(30) | 0;
	                    if (!(W + -1 & W)) {
	                        c[82184] = W;
	                        c[82183] = W;
	                        c[82185] = -1;
	                        c[82186] = -1;
	                        c[82187] = 0;
	                        c[82175] = 0;
	                        c[82182] = (jb(0) | 0) & -16 ^ 1431655768;
	                        break
	                    } else hb()
	                } while (0);
	                W = D + 48 | 0;
	                M = c[82184] | 0;
	                N = D + 47 | 0;
	                V = M + N | 0;
	                U = 0 - M | 0;
	                M = V & U;
	                if (M >>> 0 <= D >>> 0) {
	                    p = 0;
	                    i = b;
	                    return p | 0
	                }
	                T = c[82174] | 0;
	                if ((T | 0) != 0 ? (S = c[82172] | 0, R = S + M | 0, R >>> 0 <= S >>> 0 | R >>> 0 > T >>> 0) : 0) {
	                    p = 0;
	                    i = b;
	                    return p | 0
	                }
	                d:do if (!(c[82175] & 4)) {
	                    T = c[82070] | 0;
	                    e:do if (T) {
	                        R = 328704 | 0;
	                        while (1) {
	                            S = c[R >> 2] | 0;
	                            if (S >>> 0 <= T >>> 0 ? (X = R + 4 | 0, (S + (c[X >> 2] | 0) | 0) >>> 0 > T >>> 0) : 0)break;
	                            S = c[R + 8 >> 2] | 0;
	                            if (!S) {
	                                Y = 181;
	                                break e
	                            } else R = S
	                        }
	                        if (R) {
	                            S = V - (c[82067] | 0) & U;
	                            if (S >>> 0 < 2147483647) {
	                                O = Ma(S | 0) | 0;
	                                if ((O | 0) == ((c[R >> 2] | 0) + (c[X >> 2] | 0) | 0)) {
	                                    Z = O;
	                                    _ = S;
	                                    Y = 190
	                                } else {
	                                    $ = O;
	                                    aa = S;
	                                    Y = 191
	                                }
	                            } else ba = 0
	                        } else Y = 181
	                    } else Y = 181; while (0);
	                    do if ((Y | 0) == 181) {
	                        T = Ma(0) | 0;
	                        if ((T | 0) != (-1 | 0)) {
	                            r = T;
	                            S = c[82183] | 0;
	                            O = S + -1 | 0;
	                            if (!(O & r))ca = M; else ca = M - r + (O + r & 0 - S) | 0;
	                            S = c[82172] | 0;
	                            r = S + ca | 0;
	                            if (ca >>> 0 > D >>> 0 & ca >>> 0 < 2147483647) {
	                                O = c[82174] | 0;
	                                if ((O | 0) != 0 ? r >>> 0 <= S >>> 0 | r >>> 0 > O >>> 0 : 0) {
	                                    ba = 0;
	                                    break
	                                }
	                                O = Ma(ca | 0) | 0;
	                                if ((O | 0) == (T | 0)) {
	                                    Z = T;
	                                    _ = ca;
	                                    Y = 190
	                                } else {
	                                    $ = O;
	                                    aa = ca;
	                                    Y = 191
	                                }
	                            } else ba = 0
	                        } else ba = 0
	                    } while (0);
	                    f:do if ((Y | 0) == 190)if ((Z | 0) == (-1 | 0))ba = _; else {
	                        da = Z;
	                        ea = _;
	                        Y = 201;
	                        break d
	                    } else if ((Y | 0) == 191) {
	                        O = 0 - aa | 0;
	                        do if (($ | 0) != (-1 | 0) & aa >>> 0 < 2147483647 & W >>> 0 > aa >>> 0 ? (T = c[82184] | 0, r = N - aa + T & 0 - T, r >>> 0 < 2147483647) : 0)if ((Ma(r | 0) | 0) == (-1 | 0)) {
	                            Ma(O | 0) | 0;
	                            ba = 0;
	                            break f
	                        } else {
	                            fa = r + aa | 0;
	                            break
	                        } else fa = aa; while (0);
	                        if (($ | 0) == (-1 | 0))ba = 0; else {
	                            da = $;
	                            ea = fa;
	                            Y = 201;
	                            break d
	                        }
	                    } while (0);
	                    c[82175] = c[82175] | 4;
	                    ga = ba;
	                    Y = 198
	                } else {
	                    ga = 0;
	                    Y = 198
	                } while (0);
	                if ((((Y | 0) == 198 ? M >>> 0 < 2147483647 : 0) ? (ba = Ma(M | 0) | 0, M = Ma(0) | 0, (ba | 0) != (-1 | 0) & (M | 0) != (-1 | 0) & ba >>> 0 < M >>> 0) : 0) ? (fa = M - ba | 0, M = fa >>> 0 > (D + 40 | 0) >>> 0, M) : 0) {
	                    da = ba;
	                    ea = M ? fa : ga;
	                    Y = 201
	                }
	                if ((Y | 0) == 201) {
	                    ga = (c[82172] | 0) + ea | 0;
	                    c[82172] = ga;
	                    if (ga >>> 0 > (c[82173] | 0) >>> 0)c[82173] = ga;
	                    ga = c[82070] | 0;
	                    g:do if (ga) {
	                        fa = 328704 | 0;
	                        while (1) {
	                            ha = c[fa >> 2] | 0;
	                            ia = fa + 4 | 0;
	                            ja = c[ia >> 2] | 0;
	                            if ((da | 0) == (ha + ja | 0)) {
	                                Y = 213;
	                                break
	                            }
	                            M = c[fa + 8 >> 2] | 0;
	                            if (!M)break; else fa = M
	                        }
	                        if (((Y | 0) == 213 ? (c[fa + 12 >> 2] & 8 | 0) == 0 : 0) ? ga >>> 0 >= ha >>> 0 & ga >>> 0 < da >>> 0 : 0) {
	                            c[ia >> 2] = ja + ea;
	                            M = (c[82067] | 0) + ea | 0;
	                            ba = ga + 8 | 0;
	                            if (!(ba & 7))ka = 0; else ka = 0 - ba & 7;
	                            ba = M - ka | 0;
	                            c[82070] = ga + ka;
	                            c[82067] = ba;
	                            c[ga + (ka + 4) >> 2] = ba | 1;
	                            c[ga + (M + 4) >> 2] = 40;
	                            c[82071] = c[82186];
	                            break
	                        }
	                        M = c[82068] | 0;
	                        if (da >>> 0 < M >>> 0) {
	                            c[82068] = da;
	                            la = da
	                        } else la = M;
	                        M = da + ea | 0;
	                        ba = 328704 | 0;
	                        while (1) {
	                            if ((c[ba >> 2] | 0) == (M | 0)) {
	                                Y = 223;
	                                break
	                            }
	                            $ = c[ba + 8 >> 2] | 0;
	                            if (!$)break; else ba = $
	                        }
	                        if ((Y | 0) == 223 ? (c[ba + 12 >> 2] & 8 | 0) == 0 : 0) {
	                            c[ba >> 2] = da;
	                            M = ba + 4 | 0;
	                            c[M >> 2] = (c[M >> 2] | 0) + ea;
	                            M = da + 8 | 0;
	                            if (!(M & 7))ma = 0; else ma = 0 - M & 7;
	                            M = da + (ea + 8) | 0;
	                            if (!(M & 7))na = 0; else na = 0 - M & 7;
	                            M = da + (na + ea) | 0;
	                            fa = ma + D | 0;
	                            $ = da + fa | 0;
	                            aa = M - (da + ma) - D | 0;
	                            c[da + (ma + 4) >> 2] = D | 3;
	                            h:do if ((M | 0) != (ga | 0)) {
	                                if ((M | 0) == (c[82069] | 0)) {
	                                    N = (c[82066] | 0) + aa | 0;
	                                    c[82066] = N;
	                                    c[82069] = $;
	                                    c[da + (fa + 4) >> 2] = N | 1;
	                                    c[da + (N + fa) >> 2] = N;
	                                    break
	                                }
	                                N = ea + 4 | 0;
	                                W = c[da + (N + na) >> 2] | 0;
	                                if ((W & 3 | 0) == 1) {
	                                    _ = W & -8;
	                                    Z = W >>> 3;
	                                    i:do if (W >>> 0 >= 256) {
	                                        ca = c[da + ((na | 24) + ea) >> 2] | 0;
	                                        X = c[da + (ea + 12 + na) >> 2] | 0;
	                                        do if ((X | 0) == (M | 0)) {
	                                            U = na | 16;
	                                            V = da + (N + U) | 0;
	                                            O = c[V >> 2] | 0;
	                                            if (!O) {
	                                                R = da + (U + ea) | 0;
	                                                U = c[R >> 2] | 0;
	                                                if (!U) {
	                                                    oa = 0;
	                                                    break
	                                                } else {
	                                                    pa = U;
	                                                    qa = R
	                                                }
	                                            } else {
	                                                pa = O;
	                                                qa = V
	                                            }
	                                            while (1) {
	                                                V = pa + 20 | 0;
	                                                O = c[V >> 2] | 0;
	                                                if (O) {
	                                                    pa = O;
	                                                    qa = V;
	                                                    continue
	                                                }
	                                                V = pa + 16 | 0;
	                                                O = c[V >> 2] | 0;
	                                                if (!O)break; else {
	                                                    pa = O;
	                                                    qa = V
	                                                }
	                                            }
	                                            if (qa >>> 0 < la >>> 0)hb(); else {
	                                                c[qa >> 2] = 0;
	                                                oa = pa;
	                                                break
	                                            }
	                                        } else {
	                                            V = c[da + ((na | 8) + ea) >> 2] | 0;
	                                            if (V >>> 0 < la >>> 0)hb();
	                                            O = V + 12 | 0;
	                                            if ((c[O >> 2] | 0) != (M | 0))hb();
	                                            R = X + 8 | 0;
	                                            if ((c[R >> 2] | 0) == (M | 0)) {
	                                                c[O >> 2] = X;
	                                                c[R >> 2] = V;
	                                                oa = X;
	                                                break
	                                            } else hb()
	                                        } while (0);
	                                        if (!ca)break;
	                                        X = c[da + (ea + 28 + na) >> 2] | 0;
	                                        l = 328560 + (X << 2) | 0;
	                                        do if ((M | 0) != (c[l >> 2] | 0)) {
	                                            if (ca >>> 0 < (c[82068] | 0) >>> 0)hb();
	                                            V = ca + 16 | 0;
	                                            if ((c[V >> 2] | 0) == (M | 0))c[V >> 2] = oa; else c[ca + 20 >> 2] = oa;
	                                            if (!oa)break i
	                                        } else {
	                                            c[l >> 2] = oa;
	                                            if (oa)break;
	                                            c[82065] = c[82065] & ~(1 << X);
	                                            break i
	                                        } while (0);
	                                        X = c[82068] | 0;
	                                        if (oa >>> 0 < X >>> 0)hb();
	                                        c[oa + 24 >> 2] = ca;
	                                        l = na | 16;
	                                        V = c[da + (l + ea) >> 2] | 0;
	                                        do if (V)if (V >>> 0 < X >>> 0)hb(); else {
	                                            c[oa + 16 >> 2] = V;
	                                            c[V + 24 >> 2] = oa;
	                                            break
	                                        } while (0);
	                                        V = c[da + (N + l) >> 2] | 0;
	                                        if (!V)break;
	                                        if (V >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                            c[oa + 20 >> 2] = V;
	                                            c[V + 24 >> 2] = oa;
	                                            break
	                                        }
	                                    } else {
	                                        V = c[da + ((na | 8) + ea) >> 2] | 0;
	                                        X = c[da + (ea + 12 + na) >> 2] | 0;
	                                        ca = 328296 + (Z << 1 << 2) | 0;
	                                        do if ((V | 0) != (ca | 0)) {
	                                            if (V >>> 0 < la >>> 0)hb();
	                                            if ((c[V + 12 >> 2] | 0) == (M | 0))break;
	                                            hb()
	                                        } while (0);
	                                        if ((X | 0) == (V | 0)) {
	                                            c[82064] = c[82064] & ~(1 << Z);
	                                            break
	                                        }
	                                        do if ((X | 0) == (ca | 0))ra = X + 8 | 0; else {
	                                            if (X >>> 0 < la >>> 0)hb();
	                                            l = X + 8 | 0;
	                                            if ((c[l >> 2] | 0) == (M | 0)) {
	                                                ra = l;
	                                                break
	                                            }
	                                            hb()
	                                        } while (0);
	                                        c[V + 12 >> 2] = X;
	                                        c[ra >> 2] = V
	                                    } while (0);
	                                    sa = da + ((_ | na) + ea) | 0;
	                                    ta = _ + aa | 0
	                                } else {
	                                    sa = M;
	                                    ta = aa
	                                }
	                                Z = sa + 4 | 0;
	                                c[Z >> 2] = c[Z >> 2] & -2;
	                                c[da + (fa + 4) >> 2] = ta | 1;
	                                c[da + (ta + fa) >> 2] = ta;
	                                Z = ta >>> 3;
	                                if (ta >>> 0 < 256) {
	                                    N = Z << 1;
	                                    W = 328296 + (N << 2) | 0;
	                                    ca = c[82064] | 0;
	                                    l = 1 << Z;
	                                    do if (!(ca & l)) {
	                                        c[82064] = ca | l;
	                                        ua = 328296 + (N + 2 << 2) | 0;
	                                        va = W
	                                    } else {
	                                        Z = 328296 + (N + 2 << 2) | 0;
	                                        R = c[Z >> 2] | 0;
	                                        if (R >>> 0 >= (c[82068] | 0) >>> 0) {
	                                            ua = Z;
	                                            va = R;
	                                            break
	                                        }
	                                        hb()
	                                    } while (0);
	                                    c[ua >> 2] = $;
	                                    c[va + 12 >> 2] = $;
	                                    c[da + (fa + 8) >> 2] = va;
	                                    c[da + (fa + 12) >> 2] = W;
	                                    break
	                                }
	                                N = ta >>> 8;
	                                do if (!N)wa = 0; else {
	                                    if (ta >>> 0 > 16777215) {
	                                        wa = 31;
	                                        break
	                                    }
	                                    l = (N + 1048320 | 0) >>> 16 & 8;
	                                    ca = N << l;
	                                    _ = (ca + 520192 | 0) >>> 16 & 4;
	                                    R = ca << _;
	                                    ca = (R + 245760 | 0) >>> 16 & 2;
	                                    Z = 14 - (_ | l | ca) + (R << ca >>> 15) | 0;
	                                    wa = ta >>> (Z + 7 | 0) & 1 | Z << 1
	                                } while (0);
	                                N = 328560 + (wa << 2) | 0;
	                                c[da + (fa + 28) >> 2] = wa;
	                                c[da + (fa + 20) >> 2] = 0;
	                                c[da + (fa + 16) >> 2] = 0;
	                                W = c[82065] | 0;
	                                Z = 1 << wa;
	                                if (!(W & Z)) {
	                                    c[82065] = W | Z;
	                                    c[N >> 2] = $;
	                                    c[da + (fa + 24) >> 2] = N;
	                                    c[da + (fa + 12) >> 2] = $;
	                                    c[da + (fa + 8) >> 2] = $;
	                                    break
	                                }
	                                Z = c[N >> 2] | 0;
	                                if ((wa | 0) == 31)xa = 0; else xa = 25 - (wa >>> 1) | 0;
	                                j:do if ((c[Z + 4 >> 2] & -8 | 0) != (ta | 0)) {
	                                    N = ta << xa;
	                                    W = Z;
	                                    while (1) {
	                                        ya = W + (N >>> 31 << 2) + 16 | 0;
	                                        ca = c[ya >> 2] | 0;
	                                        if (!ca)break;
	                                        if ((c[ca + 4 >> 2] & -8 | 0) == (ta | 0)) {
	                                            za = ca;
	                                            break j
	                                        } else {
	                                            N = N << 1;
	                                            W = ca
	                                        }
	                                    }
	                                    if (ya >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                        c[ya >> 2] = $;
	                                        c[da + (fa + 24) >> 2] = W;
	                                        c[da + (fa + 12) >> 2] = $;
	                                        c[da + (fa + 8) >> 2] = $;
	                                        break h
	                                    }
	                                } else za = Z; while (0);
	                                Z = za + 8 | 0;
	                                N = c[Z >> 2] | 0;
	                                V = c[82068] | 0;
	                                if (za >>> 0 >= V >>> 0 & N >>> 0 >= V >>> 0) {
	                                    c[N + 12 >> 2] = $;
	                                    c[Z >> 2] = $;
	                                    c[da + (fa + 8) >> 2] = N;
	                                    c[da + (fa + 12) >> 2] = za;
	                                    c[da + (fa + 24) >> 2] = 0;
	                                    break
	                                } else hb()
	                            } else {
	                                N = (c[82067] | 0) + aa | 0;
	                                c[82067] = N;
	                                c[82070] = $;
	                                c[da + (fa + 4) >> 2] = N | 1
	                            } while (0);
	                            p = da + (ma | 8) | 0;
	                            i = b;
	                            return p | 0
	                        }
	                        fa = 328704 | 0;
	                        while (1) {
	                            Aa = c[fa >> 2] | 0;
	                            if (Aa >>> 0 <= ga >>> 0 ? (Ba = c[fa + 4 >> 2] | 0, Ca = Aa + Ba | 0, Ca >>> 0 > ga >>> 0) : 0)break;
	                            fa = c[fa + 8 >> 2] | 0
	                        }
	                        fa = Aa + (Ba + -39) | 0;
	                        if (!(fa & 7))Da = 0; else Da = 0 - fa & 7;
	                        fa = Aa + (Ba + -47 + Da) | 0;
	                        $ = fa >>> 0 < (ga + 16 | 0) >>> 0 ? ga : fa;
	                        fa = $ + 8 | 0;
	                        aa = da + 8 | 0;
	                        if (!(aa & 7))Ea = 0; else Ea = 0 - aa & 7;
	                        aa = ea + -40 - Ea | 0;
	                        c[82070] = da + Ea;
	                        c[82067] = aa;
	                        c[da + (Ea + 4) >> 2] = aa | 1;
	                        c[da + (ea + -36) >> 2] = 40;
	                        c[82071] = c[82186];
	                        c[$ + 4 >> 2] = 27;
	                        c[fa + 0 >> 2] = c[82176];
	                        c[fa + 4 >> 2] = c[82177];
	                        c[fa + 8 >> 2] = c[82178];
	                        c[fa + 12 >> 2] = c[82179];
	                        c[82176] = da;
	                        c[82177] = ea;
	                        c[82179] = 0;
	                        c[82178] = fa;
	                        fa = $ + 28 | 0;
	                        c[fa >> 2] = 7;
	                        if (($ + 32 | 0) >>> 0 < Ca >>> 0) {
	                            aa = fa;
	                            do {
	                                fa = aa;
	                                aa = aa + 4 | 0;
	                                c[aa >> 2] = 7
	                            } while ((fa + 8 | 0) >>> 0 < Ca >>> 0)
	                        }
	                        if (($ | 0) != (ga | 0)) {
	                            aa = $ - ga | 0;
	                            fa = ga + (aa + 4) | 0;
	                            c[fa >> 2] = c[fa >> 2] & -2;
	                            c[ga + 4 >> 2] = aa | 1;
	                            c[ga + aa >> 2] = aa;
	                            fa = aa >>> 3;
	                            if (aa >>> 0 < 256) {
	                                M = fa << 1;
	                                ba = 328296 + (M << 2) | 0;
	                                N = c[82064] | 0;
	                                Z = 1 << fa;
	                                do if (!(N & Z)) {
	                                    c[82064] = N | Z;
	                                    Fa = 328296 + (M + 2 << 2) | 0;
	                                    Ga = ba
	                                } else {
	                                    fa = 328296 + (M + 2 << 2) | 0;
	                                    V = c[fa >> 2] | 0;
	                                    if (V >>> 0 >= (c[82068] | 0) >>> 0) {
	                                        Fa = fa;
	                                        Ga = V;
	                                        break
	                                    }
	                                    hb()
	                                } while (0);
	                                c[Fa >> 2] = ga;
	                                c[Ga + 12 >> 2] = ga;
	                                c[ga + 8 >> 2] = Ga;
	                                c[ga + 12 >> 2] = ba;
	                                break
	                            }
	                            M = aa >>> 8;
	                            if (M)if (aa >>> 0 > 16777215)Ha = 31; else {
	                                Z = (M + 1048320 | 0) >>> 16 & 8;
	                                N = M << Z;
	                                M = (N + 520192 | 0) >>> 16 & 4;
	                                $ = N << M;
	                                N = ($ + 245760 | 0) >>> 16 & 2;
	                                V = 14 - (M | Z | N) + ($ << N >>> 15) | 0;
	                                Ha = aa >>> (V + 7 | 0) & 1 | V << 1
	                            } else Ha = 0;
	                            V = 328560 + (Ha << 2) | 0;
	                            c[ga + 28 >> 2] = Ha;
	                            c[ga + 20 >> 2] = 0;
	                            c[ga + 16 >> 2] = 0;
	                            N = c[82065] | 0;
	                            $ = 1 << Ha;
	                            if (!(N & $)) {
	                                c[82065] = N | $;
	                                c[V >> 2] = ga;
	                                c[ga + 24 >> 2] = V;
	                                c[ga + 12 >> 2] = ga;
	                                c[ga + 8 >> 2] = ga;
	                                break
	                            }
	                            $ = c[V >> 2] | 0;
	                            if ((Ha | 0) == 31)Ia = 0; else Ia = 25 - (Ha >>> 1) | 0;
	                            k:do if ((c[$ + 4 >> 2] & -8 | 0) != (aa | 0)) {
	                                V = aa << Ia;
	                                N = $;
	                                while (1) {
	                                    Ja = N + (V >>> 31 << 2) + 16 | 0;
	                                    Z = c[Ja >> 2] | 0;
	                                    if (!Z)break;
	                                    if ((c[Z + 4 >> 2] & -8 | 0) == (aa | 0)) {
	                                        Ka = Z;
	                                        break k
	                                    } else {
	                                        V = V << 1;
	                                        N = Z
	                                    }
	                                }
	                                if (Ja >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                    c[Ja >> 2] = ga;
	                                    c[ga + 24 >> 2] = N;
	                                    c[ga + 12 >> 2] = ga;
	                                    c[ga + 8 >> 2] = ga;
	                                    break g
	                                }
	                            } else Ka = $; while (0);
	                            $ = Ka + 8 | 0;
	                            aa = c[$ >> 2] | 0;
	                            ba = c[82068] | 0;
	                            if (Ka >>> 0 >= ba >>> 0 & aa >>> 0 >= ba >>> 0) {
	                                c[aa + 12 >> 2] = ga;
	                                c[$ >> 2] = ga;
	                                c[ga + 8 >> 2] = aa;
	                                c[ga + 12 >> 2] = Ka;
	                                c[ga + 24 >> 2] = 0;
	                                break
	                            } else hb()
	                        }
	                    } else {
	                        aa = c[82068] | 0;
	                        if ((aa | 0) == 0 | da >>> 0 < aa >>> 0)c[82068] = da;
	                        c[82176] = da;
	                        c[82177] = ea;
	                        c[82179] = 0;
	                        c[82073] = c[82182];
	                        c[82072] = -1;
	                        aa = 0;
	                        do {
	                            $ = aa << 1;
	                            ba = 328296 + ($ << 2) | 0;
	                            c[328296 + ($ + 3 << 2) >> 2] = ba;
	                            c[328296 + ($ + 2 << 2) >> 2] = ba;
	                            aa = aa + 1 | 0
	                        } while ((aa | 0) != 32);
	                        aa = da + 8 | 0;
	                        if (!(aa & 7))La = 0; else La = 0 - aa & 7;
	                        aa = ea + -40 - La | 0;
	                        c[82070] = da + La;
	                        c[82067] = aa;
	                        c[da + (La + 4) >> 2] = aa | 1;
	                        c[da + (ea + -36) >> 2] = 40;
	                        c[82071] = c[82186]
	                    } while (0);
	                    ea = c[82067] | 0;
	                    if (ea >>> 0 > D >>> 0) {
	                        da = ea - D | 0;
	                        c[82067] = da;
	                        ea = c[82070] | 0;
	                        c[82070] = ea + D;
	                        c[ea + (D + 4) >> 2] = da | 1;
	                        c[ea + 4 >> 2] = D | 3;
	                        p = ea + 8 | 0;
	                        i = b;
	                        return p | 0
	                    }
	                }
	                c[(_a() | 0) >> 2] = 12;
	                p = 0;
	                i = b;
	                return p | 0
	            }

	            function jT(a) {
	                a = a | 0;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0;
	                b = i;
	                if (!a) {
	                    i = b;
	                    return
	                }
	                d = a + -8 | 0;
	                e = c[82068] | 0;
	                if (d >>> 0 < e >>> 0)hb();
	                f = c[a + -4 >> 2] | 0;
	                g = f & 3;
	                if ((g | 0) == 1)hb();
	                h = f & -8;
	                j = a + (h + -8) | 0;
	                do if (!(f & 1)) {
	                    k = c[d >> 2] | 0;
	                    if (!g) {
	                        i = b;
	                        return
	                    }
	                    l = -8 - k | 0;
	                    m = a + l | 0;
	                    n = k + h | 0;
	                    if (m >>> 0 < e >>> 0)hb();
	                    if ((m | 0) == (c[82069] | 0)) {
	                        o = a + (h + -4) | 0;
	                        p = c[o >> 2] | 0;
	                        if ((p & 3 | 0) != 3) {
	                            q = m;
	                            r = n;
	                            break
	                        }
	                        c[82066] = n;
	                        c[o >> 2] = p & -2;
	                        c[a + (l + 4) >> 2] = n | 1;
	                        c[j >> 2] = n;
	                        i = b;
	                        return
	                    }
	                    p = k >>> 3;
	                    if (k >>> 0 < 256) {
	                        k = c[a + (l + 8) >> 2] | 0;
	                        o = c[a + (l + 12) >> 2] | 0;
	                        s = 328296 + (p << 1 << 2) | 0;
	                        if ((k | 0) != (s | 0)) {
	                            if (k >>> 0 < e >>> 0)hb();
	                            if ((c[k + 12 >> 2] | 0) != (m | 0))hb()
	                        }
	                        if ((o | 0) == (k | 0)) {
	                            c[82064] = c[82064] & ~(1 << p);
	                            q = m;
	                            r = n;
	                            break
	                        }
	                        if ((o | 0) != (s | 0)) {
	                            if (o >>> 0 < e >>> 0)hb();
	                            s = o + 8 | 0;
	                            if ((c[s >> 2] | 0) == (m | 0))t = s; else hb()
	                        } else t = o + 8 | 0;
	                        c[k + 12 >> 2] = o;
	                        c[t >> 2] = k;
	                        q = m;
	                        r = n;
	                        break
	                    }
	                    k = c[a + (l + 24) >> 2] | 0;
	                    o = c[a + (l + 12) >> 2] | 0;
	                    do if ((o | 0) == (m | 0)) {
	                        s = a + (l + 20) | 0;
	                        p = c[s >> 2] | 0;
	                        if (!p) {
	                            u = a + (l + 16) | 0;
	                            v = c[u >> 2] | 0;
	                            if (!v) {
	                                w = 0;
	                                break
	                            } else {
	                                x = v;
	                                y = u
	                            }
	                        } else {
	                            x = p;
	                            y = s
	                        }
	                        while (1) {
	                            s = x + 20 | 0;
	                            p = c[s >> 2] | 0;
	                            if (p) {
	                                x = p;
	                                y = s;
	                                continue
	                            }
	                            s = x + 16 | 0;
	                            p = c[s >> 2] | 0;
	                            if (!p)break; else {
	                                x = p;
	                                y = s
	                            }
	                        }
	                        if (y >>> 0 < e >>> 0)hb(); else {
	                            c[y >> 2] = 0;
	                            w = x;
	                            break
	                        }
	                    } else {
	                        s = c[a + (l + 8) >> 2] | 0;
	                        if (s >>> 0 < e >>> 0)hb();
	                        p = s + 12 | 0;
	                        if ((c[p >> 2] | 0) != (m | 0))hb();
	                        u = o + 8 | 0;
	                        if ((c[u >> 2] | 0) == (m | 0)) {
	                            c[p >> 2] = o;
	                            c[u >> 2] = s;
	                            w = o;
	                            break
	                        } else hb()
	                    } while (0);
	                    if (k) {
	                        o = c[a + (l + 28) >> 2] | 0;
	                        s = 328560 + (o << 2) | 0;
	                        if ((m | 0) == (c[s >> 2] | 0)) {
	                            c[s >> 2] = w;
	                            if (!w) {
	                                c[82065] = c[82065] & ~(1 << o);
	                                q = m;
	                                r = n;
	                                break
	                            }
	                        } else {
	                            if (k >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            o = k + 16 | 0;
	                            if ((c[o >> 2] | 0) == (m | 0))c[o >> 2] = w; else c[k + 20 >> 2] = w;
	                            if (!w) {
	                                q = m;
	                                r = n;
	                                break
	                            }
	                        }
	                        o = c[82068] | 0;
	                        if (w >>> 0 < o >>> 0)hb();
	                        c[w + 24 >> 2] = k;
	                        s = c[a + (l + 16) >> 2] | 0;
	                        do if (s)if (s >>> 0 < o >>> 0)hb(); else {
	                            c[w + 16 >> 2] = s;
	                            c[s + 24 >> 2] = w;
	                            break
	                        } while (0);
	                        s = c[a + (l + 20) >> 2] | 0;
	                        if (s)if (s >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                            c[w + 20 >> 2] = s;
	                            c[s + 24 >> 2] = w;
	                            q = m;
	                            r = n;
	                            break
	                        } else {
	                            q = m;
	                            r = n
	                        }
	                    } else {
	                        q = m;
	                        r = n
	                    }
	                } else {
	                    q = d;
	                    r = h
	                } while (0);
	                if (q >>> 0 >= j >>> 0)hb();
	                d = a + (h + -4) | 0;
	                w = c[d >> 2] | 0;
	                if (!(w & 1))hb();
	                if (!(w & 2)) {
	                    if ((j | 0) == (c[82070] | 0)) {
	                        e = (c[82067] | 0) + r | 0;
	                        c[82067] = e;
	                        c[82070] = q;
	                        c[q + 4 >> 2] = e | 1;
	                        if ((q | 0) != (c[82069] | 0)) {
	                            i = b;
	                            return
	                        }
	                        c[82069] = 0;
	                        c[82066] = 0;
	                        i = b;
	                        return
	                    }
	                    if ((j | 0) == (c[82069] | 0)) {
	                        e = (c[82066] | 0) + r | 0;
	                        c[82066] = e;
	                        c[82069] = q;
	                        c[q + 4 >> 2] = e | 1;
	                        c[q + e >> 2] = e;
	                        i = b;
	                        return
	                    }
	                    e = (w & -8) + r | 0;
	                    x = w >>> 3;
	                    do if (w >>> 0 >= 256) {
	                        y = c[a + (h + 16) >> 2] | 0;
	                        t = c[a + (h | 4) >> 2] | 0;
	                        do if ((t | 0) == (j | 0)) {
	                            g = a + (h + 12) | 0;
	                            f = c[g >> 2] | 0;
	                            if (!f) {
	                                s = a + (h + 8) | 0;
	                                o = c[s >> 2] | 0;
	                                if (!o) {
	                                    z = 0;
	                                    break
	                                } else {
	                                    A = o;
	                                    B = s
	                                }
	                            } else {
	                                A = f;
	                                B = g
	                            }
	                            while (1) {
	                                g = A + 20 | 0;
	                                f = c[g >> 2] | 0;
	                                if (f) {
	                                    A = f;
	                                    B = g;
	                                    continue
	                                }
	                                g = A + 16 | 0;
	                                f = c[g >> 2] | 0;
	                                if (!f)break; else {
	                                    A = f;
	                                    B = g
	                                }
	                            }
	                            if (B >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                c[B >> 2] = 0;
	                                z = A;
	                                break
	                            }
	                        } else {
	                            g = c[a + h >> 2] | 0;
	                            if (g >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            f = g + 12 | 0;
	                            if ((c[f >> 2] | 0) != (j | 0))hb();
	                            s = t + 8 | 0;
	                            if ((c[s >> 2] | 0) == (j | 0)) {
	                                c[f >> 2] = t;
	                                c[s >> 2] = g;
	                                z = t;
	                                break
	                            } else hb()
	                        } while (0);
	                        if (y) {
	                            t = c[a + (h + 20) >> 2] | 0;
	                            n = 328560 + (t << 2) | 0;
	                            if ((j | 0) == (c[n >> 2] | 0)) {
	                                c[n >> 2] = z;
	                                if (!z) {
	                                    c[82065] = c[82065] & ~(1 << t);
	                                    break
	                                }
	                            } else {
	                                if (y >>> 0 < (c[82068] | 0) >>> 0)hb();
	                                t = y + 16 | 0;
	                                if ((c[t >> 2] | 0) == (j | 0))c[t >> 2] = z; else c[y + 20 >> 2] = z;
	                                if (!z)break
	                            }
	                            t = c[82068] | 0;
	                            if (z >>> 0 < t >>> 0)hb();
	                            c[z + 24 >> 2] = y;
	                            n = c[a + (h + 8) >> 2] | 0;
	                            do if (n)if (n >>> 0 < t >>> 0)hb(); else {
	                                c[z + 16 >> 2] = n;
	                                c[n + 24 >> 2] = z;
	                                break
	                            } while (0);
	                            n = c[a + (h + 12) >> 2] | 0;
	                            if (n)if (n >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                c[z + 20 >> 2] = n;
	                                c[n + 24 >> 2] = z;
	                                break
	                            }
	                        }
	                    } else {
	                        n = c[a + h >> 2] | 0;
	                        t = c[a + (h | 4) >> 2] | 0;
	                        y = 328296 + (x << 1 << 2) | 0;
	                        if ((n | 0) != (y | 0)) {
	                            if (n >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            if ((c[n + 12 >> 2] | 0) != (j | 0))hb()
	                        }
	                        if ((t | 0) == (n | 0)) {
	                            c[82064] = c[82064] & ~(1 << x);
	                            break
	                        }
	                        if ((t | 0) != (y | 0)) {
	                            if (t >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            y = t + 8 | 0;
	                            if ((c[y >> 2] | 0) == (j | 0))C = y; else hb()
	                        } else C = t + 8 | 0;
	                        c[n + 12 >> 2] = t;
	                        c[C >> 2] = n
	                    } while (0);
	                    c[q + 4 >> 2] = e | 1;
	                    c[q + e >> 2] = e;
	                    if ((q | 0) == (c[82069] | 0)) {
	                        c[82066] = e;
	                        i = b;
	                        return
	                    } else D = e
	                } else {
	                    c[d >> 2] = w & -2;
	                    c[q + 4 >> 2] = r | 1;
	                    c[q + r >> 2] = r;
	                    D = r
	                }
	                r = D >>> 3;
	                if (D >>> 0 < 256) {
	                    w = r << 1;
	                    d = 328296 + (w << 2) | 0;
	                    e = c[82064] | 0;
	                    C = 1 << r;
	                    if (e & C) {
	                        r = 328296 + (w + 2 << 2) | 0;
	                        j = c[r >> 2] | 0;
	                        if (j >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                            E = r;
	                            F = j
	                        }
	                    } else {
	                        c[82064] = e | C;
	                        E = 328296 + (w + 2 << 2) | 0;
	                        F = d
	                    }
	                    c[E >> 2] = q;
	                    c[F + 12 >> 2] = q;
	                    c[q + 8 >> 2] = F;
	                    c[q + 12 >> 2] = d;
	                    i = b;
	                    return
	                }
	                d = D >>> 8;
	                if (d)if (D >>> 0 > 16777215)G = 31; else {
	                    F = (d + 1048320 | 0) >>> 16 & 8;
	                    E = d << F;
	                    d = (E + 520192 | 0) >>> 16 & 4;
	                    w = E << d;
	                    E = (w + 245760 | 0) >>> 16 & 2;
	                    C = 14 - (d | F | E) + (w << E >>> 15) | 0;
	                    G = D >>> (C + 7 | 0) & 1 | C << 1
	                } else G = 0;
	                C = 328560 + (G << 2) | 0;
	                c[q + 28 >> 2] = G;
	                c[q + 20 >> 2] = 0;
	                c[q + 16 >> 2] = 0;
	                E = c[82065] | 0;
	                w = 1 << G;
	                a:do if (E & w) {
	                    F = c[C >> 2] | 0;
	                    if ((G | 0) == 31)H = 0; else H = 25 - (G >>> 1) | 0;
	                    b:do if ((c[F + 4 >> 2] & -8 | 0) != (D | 0)) {
	                        d = D << H;
	                        e = F;
	                        while (1) {
	                            I = e + (d >>> 31 << 2) + 16 | 0;
	                            j = c[I >> 2] | 0;
	                            if (!j)break;
	                            if ((c[j + 4 >> 2] & -8 | 0) == (D | 0)) {
	                                J = j;
	                                break b
	                            } else {
	                                d = d << 1;
	                                e = j
	                            }
	                        }
	                        if (I >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                            c[I >> 2] = q;
	                            c[q + 24 >> 2] = e;
	                            c[q + 12 >> 2] = q;
	                            c[q + 8 >> 2] = q;
	                            break a
	                        }
	                    } else J = F; while (0);
	                    F = J + 8 | 0;
	                    d = c[F >> 2] | 0;
	                    j = c[82068] | 0;
	                    if (J >>> 0 >= j >>> 0 & d >>> 0 >= j >>> 0) {
	                        c[d + 12 >> 2] = q;
	                        c[F >> 2] = q;
	                        c[q + 8 >> 2] = d;
	                        c[q + 12 >> 2] = J;
	                        c[q + 24 >> 2] = 0;
	                        break
	                    } else hb()
	                } else {
	                    c[82065] = E | w;
	                    c[C >> 2] = q;
	                    c[q + 24 >> 2] = C;
	                    c[q + 12 >> 2] = q;
	                    c[q + 8 >> 2] = q
	                } while (0);
	                q = (c[82072] | 0) + -1 | 0;
	                c[82072] = q;
	                if (!q)K = 328712 | 0; else {
	                    i = b;
	                    return
	                }
	                while (1) {
	                    q = c[K >> 2] | 0;
	                    if (!q)break; else K = q + 8 | 0
	                }
	                c[82072] = -1;
	                i = b;
	                return
	            }

	            function kT(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0;
	                d = i;
	                do if (a) {
	                    if (b >>> 0 > 4294967231) {
	                        c[(_a() | 0) >> 2] = 12;
	                        e = 0;
	                        break
	                    }
	                    if (b >>> 0 < 11)f = 16; else f = b + 11 & -8;
	                    g = ST(a + -8 | 0, f) | 0;
	                    if (g) {
	                        e = g + 8 | 0;
	                        break
	                    }
	                    g = iT(b) | 0;
	                    if (!g)e = 0; else {
	                        h = c[a + -4 >> 2] | 0;
	                        j = (h & -8) - ((h & 3 | 0) == 0 ? 8 : 4) | 0;
	                        eU(g | 0, a | 0, (j >>> 0 < b >>> 0 ? j : b) | 0) | 0;
	                        jT(a);
	                        e = g
	                    }
	                } else e = iT(b) | 0; while (0);
	                i = d;
	                return e | 0
	            }

	            function lT(a) {
	                a = a | 0;
	                return (a + -48 | 0) >>> 0 < 10 | 0
	            }

	            function mT(a) {
	                a = a | 0;
	                var b = 0;
	                if ((a | 0) == 32)b = 1; else b = (a + -9 | 0) >>> 0 < 5;
	                return b & 1 | 0
	            }

	            function nT(b, e, f, g, h) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, da = 0, ea = 0, fa = 0, ga = 0;
	                j = i;
	                if (e >>> 0 > 36) {
	                    c[(_a() | 0) >> 2] = 22;
	                    k = 0;
	                    l = 0;
	                    G = k;
	                    i = j;
	                    return l | 0
	                }
	                m = b + 4 | 0;
	                n = b + 100 | 0;
	                do {
	                    o = c[m >> 2] | 0;
	                    if (o >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                        c[m >> 2] = o + 1;
	                        p = d[o >> 0] | 0
	                    } else p = qT(b) | 0
	                } while ((mT(p) | 0) != 0);
	                do if ((p | 0) == 43 | (p | 0) == 45) {
	                    o = ((p | 0) == 45) << 31 >> 31;
	                    q = c[m >> 2] | 0;
	                    if (q >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                        c[m >> 2] = q + 1;
	                        r = d[q >> 0] | 0;
	                        s = o;
	                        break
	                    } else {
	                        r = qT(b) | 0;
	                        s = o;
	                        break
	                    }
	                } else {
	                    r = p;
	                    s = 0
	                } while (0);
	                p = (e | 0) == 0;
	                do if ((e & -17 | 0) == 0 & (r | 0) == 48) {
	                    o = c[m >> 2] | 0;
	                    if (o >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                        c[m >> 2] = o + 1;
	                        t = d[o >> 0] | 0
	                    } else t = qT(b) | 0;
	                    if ((t | 32 | 0) != 120)if (p) {
	                        u = 8;
	                        v = t;
	                        w = 46;
	                        break
	                    } else {
	                        x = e;
	                        y = t;
	                        w = 32;
	                        break
	                    }
	                    o = c[m >> 2] | 0;
	                    if (o >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                        c[m >> 2] = o + 1;
	                        z = d[o >> 0] | 0
	                    } else z = qT(b) | 0;
	                    if ((d[z + 328753 >> 0] | 0) > 15) {
	                        o = (c[n >> 2] | 0) == 0;
	                        if (!o)c[m >> 2] = (c[m >> 2] | 0) + -1;
	                        if (!f) {
	                            pT(b, 0);
	                            k = 0;
	                            l = 0;
	                            G = k;
	                            i = j;
	                            return l | 0
	                        }
	                        if (o) {
	                            k = 0;
	                            l = 0;
	                            G = k;
	                            i = j;
	                            return l | 0
	                        }
	                        c[m >> 2] = (c[m >> 2] | 0) + -1;
	                        k = 0;
	                        l = 0;
	                        G = k;
	                        i = j;
	                        return l | 0
	                    } else {
	                        u = 16;
	                        v = z;
	                        w = 46
	                    }
	                } else {
	                    o = p ? 10 : e;
	                    if ((d[r + 328753 >> 0] | 0) >>> 0 < o >>> 0) {
	                        x = o;
	                        y = r;
	                        w = 32
	                    } else {
	                        if (c[n >> 2] | 0)c[m >> 2] = (c[m >> 2] | 0) + -1;
	                        pT(b, 0);
	                        c[(_a() | 0) >> 2] = 22;
	                        k = 0;
	                        l = 0;
	                        G = k;
	                        i = j;
	                        return l | 0
	                    }
	                } while (0);
	                if ((w | 0) == 32)if ((x | 0) == 10) {
	                    r = y + -48 | 0;
	                    if (r >>> 0 < 10) {
	                        e = r;
	                        r = 0;
	                        do {
	                            r = (r * 10 | 0) + e | 0;
	                            p = c[m >> 2] | 0;
	                            if (p >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                                c[m >> 2] = p + 1;
	                                A = d[p >> 0] | 0
	                            } else A = qT(b) | 0;
	                            e = A + -48 | 0
	                        } while (e >>> 0 < 10 & r >>> 0 < 429496729);
	                        B = r;
	                        C = 0;
	                        D = A
	                    } else {
	                        B = 0;
	                        C = 0;
	                        D = y
	                    }
	                    A = D + -48 | 0;
	                    if (A >>> 0 < 10) {
	                        r = B;
	                        e = C;
	                        p = A;
	                        A = D;
	                        while (1) {
	                            D = mU(r | 0, e | 0, 10, 0) | 0;
	                            z = G;
	                            f = ((p | 0) < 0) << 31 >> 31;
	                            t = ~f;
	                            if (z >>> 0 > t >>> 0 | (z | 0) == (t | 0) & D >>> 0 > ~p >>> 0) {
	                                E = p;
	                                F = r;
	                                H = e;
	                                I = A;
	                                break
	                            }
	                            t = bU(D | 0, z | 0, p | 0, f | 0) | 0;
	                            f = G;
	                            z = c[m >> 2] | 0;
	                            if (z >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                                c[m >> 2] = z + 1;
	                                J = d[z >> 0] | 0
	                            } else J = qT(b) | 0;
	                            z = J + -48 | 0;
	                            if (z >>> 0 < 10 & (f >>> 0 < 429496729 | (f | 0) == 429496729 & t >>> 0 < 2576980378)) {
	                                r = t;
	                                e = f;
	                                p = z;
	                                A = J
	                            } else {
	                                E = z;
	                                F = t;
	                                H = f;
	                                I = J;
	                                break
	                            }
	                        }
	                        if (E >>> 0 > 9) {
	                            K = H;
	                            L = F
	                        } else {
	                            M = 10;
	                            N = F;
	                            O = H;
	                            P = I;
	                            w = 72
	                        }
	                    } else {
	                        K = C;
	                        L = B
	                    }
	                } else {
	                    u = x;
	                    v = y;
	                    w = 46
	                }
	                a:do if ((w | 0) == 46) {
	                    if (!(u + -1 & u)) {
	                        y = a[329016 + ((u * 23 | 0) >>> 5 & 7) >> 0] | 0;
	                        x = a[v + 328753 >> 0] | 0;
	                        B = x & 255;
	                        if (B >>> 0 < u >>> 0) {
	                            C = B;
	                            B = 0;
	                            do {
	                                B = C | B << y;
	                                I = c[m >> 2] | 0;
	                                if (I >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                                    c[m >> 2] = I + 1;
	                                    Q = d[I >> 0] | 0
	                                } else Q = qT(b) | 0;
	                                R = a[Q + 328753 >> 0] | 0;
	                                C = R & 255
	                            } while (C >>> 0 < u >>> 0 & B >>> 0 < 134217728);
	                            S = R;
	                            T = 0;
	                            U = B;
	                            V = Q
	                        } else {
	                            S = x;
	                            T = 0;
	                            U = 0;
	                            V = v
	                        }
	                        C = dU(-1, -1, y | 0) | 0;
	                        I = G;
	                        if ((S & 255) >>> 0 >= u >>> 0 | (T >>> 0 > I >>> 0 | (T | 0) == (I | 0) & U >>> 0 > C >>> 0)) {
	                            M = u;
	                            N = U;
	                            O = T;
	                            P = V;
	                            w = 72;
	                            break
	                        } else {
	                            W = U;
	                            X = T;
	                            Y = S
	                        }
	                        while (1) {
	                            H = $T(W | 0, X | 0, y | 0) | 0;
	                            F = G;
	                            E = Y & 255 | H;
	                            H = c[m >> 2] | 0;
	                            if (H >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                                c[m >> 2] = H + 1;
	                                Z = d[H >> 0] | 0
	                            } else Z = qT(b) | 0;
	                            Y = a[Z + 328753 >> 0] | 0;
	                            if ((Y & 255) >>> 0 >= u >>> 0 | (F >>> 0 > I >>> 0 | (F | 0) == (I | 0) & E >>> 0 > C >>> 0)) {
	                                M = u;
	                                N = E;
	                                O = F;
	                                P = Z;
	                                w = 72;
	                                break a
	                            } else {
	                                W = E;
	                                X = F
	                            }
	                        }
	                    }
	                    C = a[v + 328753 >> 0] | 0;
	                    I = C & 255;
	                    if (I >>> 0 < u >>> 0) {
	                        y = I;
	                        I = 0;
	                        do {
	                            I = y + (ca(I, u) | 0) | 0;
	                            x = c[m >> 2] | 0;
	                            if (x >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                                c[m >> 2] = x + 1;
	                                _ = d[x >> 0] | 0
	                            } else _ = qT(b) | 0;
	                            $ = a[_ + 328753 >> 0] | 0;
	                            y = $ & 255
	                        } while (y >>> 0 < u >>> 0 & I >>> 0 < 119304647);
	                        aa = $;
	                        ba = I;
	                        da = 0;
	                        ea = _
	                    } else {
	                        aa = C;
	                        ba = 0;
	                        da = 0;
	                        ea = v
	                    }
	                    if ((aa & 255) >>> 0 < u >>> 0) {
	                        y = nU(-1, -1, u | 0, 0) | 0;
	                        x = G;
	                        B = da;
	                        F = ba;
	                        E = aa;
	                        H = ea;
	                        while (1) {
	                            if (B >>> 0 > x >>> 0 | (B | 0) == (x | 0) & F >>> 0 > y >>> 0) {
	                                M = u;
	                                N = F;
	                                O = B;
	                                P = H;
	                                w = 72;
	                                break a
	                            }
	                            J = mU(F | 0, B | 0, u | 0, 0) | 0;
	                            A = G;
	                            p = E & 255;
	                            if (A >>> 0 > 4294967295 | (A | 0) == -1 & J >>> 0 > ~p >>> 0) {
	                                M = u;
	                                N = F;
	                                O = B;
	                                P = H;
	                                w = 72;
	                                break a
	                            }
	                            e = bU(p | 0, 0, J | 0, A | 0) | 0;
	                            A = G;
	                            J = c[m >> 2] | 0;
	                            if (J >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                                c[m >> 2] = J + 1;
	                                fa = d[J >> 0] | 0
	                            } else fa = qT(b) | 0;
	                            E = a[fa + 328753 >> 0] | 0;
	                            if ((E & 255) >>> 0 >= u >>> 0) {
	                                M = u;
	                                N = e;
	                                O = A;
	                                P = fa;
	                                w = 72;
	                                break
	                            } else {
	                                B = A;
	                                F = e;
	                                H = fa
	                            }
	                        }
	                    } else {
	                        M = u;
	                        N = ba;
	                        O = da;
	                        P = ea;
	                        w = 72
	                    }
	                } while (0);
	                if ((w | 0) == 72)if ((d[P + 328753 >> 0] | 0) >>> 0 < M >>> 0) {
	                    do {
	                        P = c[m >> 2] | 0;
	                        if (P >>> 0 < (c[n >> 2] | 0) >>> 0) {
	                            c[m >> 2] = P + 1;
	                            ga = d[P >> 0] | 0
	                        } else ga = qT(b) | 0
	                    } while ((d[ga + 328753 >> 0] | 0) >>> 0 < M >>> 0);
	                    c[(_a() | 0) >> 2] = 34;
	                    K = h;
	                    L = g
	                } else {
	                    K = O;
	                    L = N
	                }
	                if (c[n >> 2] | 0)c[m >> 2] = (c[m >> 2] | 0) + -1;
	                if (!(K >>> 0 < h >>> 0 | (K | 0) == (h | 0) & L >>> 0 < g >>> 0)) {
	                    if (!((g & 1 | 0) != 0 | 0 != 0 | (s | 0) != 0)) {
	                        c[(_a() | 0) >> 2] = 34;
	                        m = bU(g | 0, h | 0, -1, -1) | 0;
	                        k = G;
	                        l = m;
	                        G = k;
	                        i = j;
	                        return l | 0
	                    }
	                    if (K >>> 0 > h >>> 0 | (K | 0) == (h | 0) & L >>> 0 > g >>> 0) {
	                        c[(_a() | 0) >> 2] = 34;
	                        k = h;
	                        l = g;
	                        G = k;
	                        i = j;
	                        return l | 0
	                    }
	                }
	                g = ((s | 0) < 0) << 31 >> 31;
	                h = XT(L ^ s | 0, K ^ g | 0, s | 0, g | 0) | 0;
	                k = G;
	                l = h;
	                G = k;
	                i = j;
	                return l | 0
	            }

	            function oT(b, e, f) {
	                b = b | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0.0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, S = 0, T = 0.0, U = 0, V = 0.0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, da = 0, ea = 0, fa = 0.0, ga = 0, ha = 0.0, ia = 0, ja = 0.0, ka = 0, la = 0.0, ma = 0, na = 0.0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0.0, va = 0, wa = 0.0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0.0, Ca = 0, Da = 0, Ea = 0, Fa = 0.0, Ga = 0.0, Ha = 0, Ia = 0, Ja = 0, Ka = 0, La = 0, Ma = 0, Na = 0, Oa = 0, Pa = 0, Qa = 0, Ra = 0, Sa = 0, Ta = 0, Ua = 0, Va = 0, Wa = 0, Xa = 0, Ya = 0, Za = 0, $a = 0, ab = 0, bb = 0, cb = 0, db = 0, eb = 0, fb = 0, gb = 0, hb = 0, ib = 0, jb = 0, kb = 0, lb = 0, mb = 0, nb = 0, ob = 0, pb = 0, qb = 0, rb = 0, sb = 0, tb = 0, ub = 0, vb = 0, wb = 0, xb = 0, yb = 0, zb = 0, Ab = 0, Bb = 0, Cb = 0, Db = 0, Eb = 0, Fb = 0, Gb = 0, Hb = 0, Ib = 0, Jb = 0, Kb = 0, Lb = 0, Mb = 0, Nb = 0, Ob = 0, Pb = 0, Qb = 0, Rb = 0, Sb = 0, Tb = 0, Ub = 0, Vb = 0, Wb = 0, Xb = 0, Yb = 0, Zb = 0, _b = 0, $b = 0, ac = 0, bc = 0, cc = 0, dc = 0, ec = 0, fc = 0, gc = 0, hc = 0, ic = 0, jc = 0, kc = 0, lc = 0, mc = 0, nc = 0, oc = 0, pc = 0, qc = 0, rc = 0, sc = 0, tc = 0, uc = 0, vc = 0, wc = 0, xc = 0, yc = 0, zc = 0, Ac = 0, Bc = 0, Cc = 0, Dc = 0, Ec = 0, Fc = 0.0, Gc = 0, Hc = 0, Ic = 0, Jc = 0, Kc = 0, Lc = 0.0, Mc = 0, Nc = 0.0, Oc = 0.0, Pc = 0.0, Qc = 0.0, Rc = 0.0, Sc = 0, Tc = 0, Uc = 0.0, Vc = 0, Wc = 0.0;
	                g = i;
	                i = i + 512 | 0;
	                h = g;
	                if (!e) {
	                    j = 24;
	                    k = -149
	                } else if ((e | 0) == 1) {
	                    j = 53;
	                    k = -1074
	                } else if ((e | 0) == 2) {
	                    j = 53;
	                    k = -1074
	                } else {
	                    l = 0.0;
	                    i = g;
	                    return +l
	                }
	                e = b + 4 | 0;
	                m = b + 100 | 0;
	                do {
	                    n = c[e >> 2] | 0;
	                    if (n >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                        c[e >> 2] = n + 1;
	                        o = d[n >> 0] | 0
	                    } else o = qT(b) | 0
	                } while ((mT(o) | 0) != 0);
	                do if ((o | 0) == 43 | (o | 0) == 45) {
	                    n = 1 - (((o | 0) == 45 & 1) << 1) | 0;
	                    p = c[e >> 2] | 0;
	                    if (p >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                        c[e >> 2] = p + 1;
	                        q = d[p >> 0] | 0;
	                        r = n;
	                        break
	                    } else {
	                        q = qT(b) | 0;
	                        r = n;
	                        break
	                    }
	                } else {
	                    q = o;
	                    r = 1
	                } while (0);
	                o = q;
	                q = 0;
	                while (1) {
	                    if ((o | 32 | 0) != (a[329032 + q >> 0] | 0)) {
	                        s = o;
	                        t = q;
	                        break
	                    }
	                    do if (q >>> 0 < 7) {
	                        n = c[e >> 2] | 0;
	                        if (n >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                            c[e >> 2] = n + 1;
	                            u = d[n >> 0] | 0;
	                            break
	                        } else {
	                            u = qT(b) | 0;
	                            break
	                        }
	                    } else u = o; while (0);
	                    n = q + 1 | 0;
	                    if (n >>> 0 < 8) {
	                        o = u;
	                        q = n
	                    } else {
	                        s = u;
	                        t = n;
	                        break
	                    }
	                }
	                do if ((t | 0) == 3)x = 23; else if ((t | 0) != 8) {
	                    u = (f | 0) != 0;
	                    if (t >>> 0 > 3 & u)if ((t | 0) == 8)break; else {
	                        x = 23;
	                        break
	                    }
	                    a:do if (!t) {
	                        q = s;
	                        o = 0;
	                        while (1) {
	                            if ((q | 32 | 0) != (a[329048 + o >> 0] | 0)) {
	                                y = q;
	                                z = o;
	                                break a
	                            }
	                            do if (o >>> 0 < 2) {
	                                n = c[e >> 2] | 0;
	                                if (n >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                    c[e >> 2] = n + 1;
	                                    A = d[n >> 0] | 0;
	                                    break
	                                } else {
	                                    A = qT(b) | 0;
	                                    break
	                                }
	                            } else A = q; while (0);
	                            n = o + 1 | 0;
	                            if (n >>> 0 < 3) {
	                                q = A;
	                                o = n
	                            } else {
	                                y = A;
	                                z = n;
	                                break
	                            }
	                        }
	                    } else {
	                        y = s;
	                        z = t
	                    } while (0);
	                    if ((z | 0) == 3) {
	                        o = c[e >> 2] | 0;
	                        if (o >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                            c[e >> 2] = o + 1;
	                            B = d[o >> 0] | 0
	                        } else B = qT(b) | 0;
	                        if ((B | 0) == 40)C = 1; else {
	                            if (!(c[m >> 2] | 0)) {
	                                l = v;
	                                i = g;
	                                return +l
	                            }
	                            c[e >> 2] = (c[e >> 2] | 0) + -1;
	                            l = v;
	                            i = g;
	                            return +l
	                        }
	                        while (1) {
	                            o = c[e >> 2] | 0;
	                            if (o >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                c[e >> 2] = o + 1;
	                                D = d[o >> 0] | 0
	                            } else D = qT(b) | 0;
	                            if (!((D + -48 | 0) >>> 0 < 10 | (D + -65 | 0) >>> 0 < 26) ? !((D + -97 | 0) >>> 0 < 26 | (D | 0) == 95) : 0)break;
	                            C = C + 1 | 0
	                        }
	                        if ((D | 0) == 41) {
	                            l = v;
	                            i = g;
	                            return +l
	                        }
	                        o = (c[m >> 2] | 0) == 0;
	                        if (!o)c[e >> 2] = (c[e >> 2] | 0) + -1;
	                        if (!u) {
	                            c[(_a() | 0) >> 2] = 22;
	                            pT(b, 0);
	                            l = 0.0;
	                            i = g;
	                            return +l
	                        }
	                        if ((C | 0) == 0 | o) {
	                            l = v;
	                            i = g;
	                            return +l
	                        } else E = C;
	                        do {
	                            E = E + -1 | 0;
	                            c[e >> 2] = (c[e >> 2] | 0) + -1
	                        } while ((E | 0) != 0);
	                        l = v;
	                        i = g;
	                        return +l
	                    } else if (!z) {
	                        do if ((y | 0) == 48) {
	                            u = c[e >> 2] | 0;
	                            if (u >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                c[e >> 2] = u + 1;
	                                F = d[u >> 0] | 0
	                            } else F = qT(b) | 0;
	                            if ((F | 32 | 0) != 120) {
	                                if (!(c[m >> 2] | 0)) {
	                                    H = 48;
	                                    break
	                                }
	                                c[e >> 2] = (c[e >> 2] | 0) + -1;
	                                H = 48;
	                                break
	                            }
	                            u = c[e >> 2] | 0;
	                            if (u >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                c[e >> 2] = u + 1;
	                                I = d[u >> 0] | 0;
	                                J = 0
	                            } else {
	                                I = qT(b) | 0;
	                                J = 0
	                            }
	                            while (1) {
	                                if ((I | 0) == 46) {
	                                    x = 70;
	                                    break
	                                } else if ((I | 0) != 48) {
	                                    K = 0;
	                                    L = 0;
	                                    M = 0;
	                                    N = 0;
	                                    O = I;
	                                    P = J;
	                                    Q = 0;
	                                    S = 0;
	                                    T = 1.0;
	                                    U = 0;
	                                    V = 0.0;
	                                    break
	                                }
	                                u = c[e >> 2] | 0;
	                                if (u >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                    c[e >> 2] = u + 1;
	                                    I = d[u >> 0] | 0;
	                                    J = 1;
	                                    continue
	                                } else {
	                                    I = qT(b) | 0;
	                                    J = 1;
	                                    continue
	                                }
	                            }
	                            if ((x | 0) == 70) {
	                                u = c[e >> 2] | 0;
	                                if (u >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                    c[e >> 2] = u + 1;
	                                    W = d[u >> 0] | 0
	                                } else W = qT(b) | 0;
	                                if ((W | 0) == 48) {
	                                    u = 0;
	                                    o = 0;
	                                    while (1) {
	                                        q = c[e >> 2] | 0;
	                                        if (q >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                            c[e >> 2] = q + 1;
	                                            X = d[q >> 0] | 0
	                                        } else X = qT(b) | 0;
	                                        q = bU(u | 0, o | 0, -1, -1) | 0;
	                                        n = G;
	                                        if ((X | 0) == 48) {
	                                            u = q;
	                                            o = n
	                                        } else {
	                                            K = 0;
	                                            L = 0;
	                                            M = q;
	                                            N = n;
	                                            O = X;
	                                            P = 1;
	                                            Q = 1;
	                                            S = 0;
	                                            T = 1.0;
	                                            U = 0;
	                                            V = 0.0;
	                                            break
	                                        }
	                                    }
	                                } else {
	                                    K = 0;
	                                    L = 0;
	                                    M = 0;
	                                    N = 0;
	                                    O = W;
	                                    P = J;
	                                    Q = 1;
	                                    S = 0;
	                                    T = 1.0;
	                                    U = 0;
	                                    V = 0.0
	                                }
	                            }
	                            b:while (1) {
	                                o = O + -48 | 0;
	                                do if (o >>> 0 >= 10) {
	                                    u = O | 32;
	                                    n = (O | 0) == 46;
	                                    if (!((u + -97 | 0) >>> 0 < 6 | n)) {
	                                        Y = O;
	                                        break b
	                                    }
	                                    if (n)if (!Q) {
	                                        Z = L;
	                                        _ = K;
	                                        $ = L;
	                                        aa = K;
	                                        ba = P;
	                                        da = 1;
	                                        ea = S;
	                                        fa = T;
	                                        ga = U;
	                                        ha = V;
	                                        break
	                                    } else {
	                                        Y = 46;
	                                        break b
	                                    } else {
	                                        ia = (O | 0) > 57 ? u + -87 | 0 : o;
	                                        x = 83;
	                                        break
	                                    }
	                                } else {
	                                    ia = o;
	                                    x = 83
	                                } while (0);
	                                if ((x | 0) == 83) {
	                                    x = 0;
	                                    do if (!((K | 0) < 0 | (K | 0) == 0 & L >>> 0 < 8)) {
	                                        if ((K | 0) < 0 | (K | 0) == 0 & L >>> 0 < 14) {
	                                            ja = T * .0625;
	                                            ka = S;
	                                            la = ja;
	                                            ma = U;
	                                            na = V + ja * +(ia | 0);
	                                            break
	                                        }
	                                        if ((ia | 0) == 0 | (S | 0) != 0) {
	                                            ka = S;
	                                            la = T;
	                                            ma = U;
	                                            na = V
	                                        } else {
	                                            ka = 1;
	                                            la = T;
	                                            ma = U;
	                                            na = V + T * .5
	                                        }
	                                    } else {
	                                        ka = S;
	                                        la = T;
	                                        ma = ia + (U << 4) | 0;
	                                        na = V
	                                    } while (0);
	                                    o = bU(L | 0, K | 0, 1, 0) | 0;
	                                    Z = M;
	                                    _ = N;
	                                    $ = o;
	                                    aa = G;
	                                    ba = 1;
	                                    da = Q;
	                                    ea = ka;
	                                    fa = la;
	                                    ga = ma;
	                                    ha = na
	                                }
	                                o = c[e >> 2] | 0;
	                                if (o >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                    c[e >> 2] = o + 1;
	                                    K = aa;
	                                    L = $;
	                                    M = Z;
	                                    N = _;
	                                    O = d[o >> 0] | 0;
	                                    P = ba;
	                                    Q = da;
	                                    S = ea;
	                                    T = fa;
	                                    U = ga;
	                                    V = ha;
	                                    continue
	                                } else {
	                                    K = aa;
	                                    L = $;
	                                    M = Z;
	                                    N = _;
	                                    O = qT(b) | 0;
	                                    P = ba;
	                                    Q = da;
	                                    S = ea;
	                                    T = fa;
	                                    U = ga;
	                                    V = ha;
	                                    continue
	                                }
	                            }
	                            if (!P) {
	                                o = (c[m >> 2] | 0) == 0;
	                                if (!o)c[e >> 2] = (c[e >> 2] | 0) + -1;
	                                if (f) {
	                                    if (!o ? (o = c[e >> 2] | 0, c[e >> 2] = o + -1, (Q | 0) != 0) : 0)c[e >> 2] = o + -2
	                                } else pT(b, 0);
	                                l = +(r | 0) * 0.0;
	                                i = g;
	                                return +l
	                            }
	                            o = (Q | 0) == 0;
	                            u = o ? L : M;
	                            n = o ? K : N;
	                            if ((K | 0) < 0 | (K | 0) == 0 & L >>> 0 < 8) {
	                                o = L;
	                                q = K;
	                                p = U;
	                                while (1) {
	                                    oa = p << 4;
	                                    o = bU(o | 0, q | 0, 1, 0) | 0;
	                                    q = G;
	                                    if (!((q | 0) < 0 | (q | 0) == 0 & o >>> 0 < 8)) {
	                                        pa = oa;
	                                        break
	                                    } else p = oa
	                                }
	                            } else pa = U;
	                            do if ((Y | 32 | 0) == 112) {
	                                p = UT(b, f) | 0;
	                                o = G;
	                                if ((p | 0) == 0 & (o | 0) == -2147483648)if (!f) {
	                                    pT(b, 0);
	                                    l = 0.0;
	                                    i = g;
	                                    return +l
	                                } else {
	                                    if (!(c[m >> 2] | 0)) {
	                                        qa = 0;
	                                        ra = 0;
	                                        break
	                                    }
	                                    c[e >> 2] = (c[e >> 2] | 0) + -1;
	                                    qa = 0;
	                                    ra = 0;
	                                    break
	                                } else {
	                                    qa = p;
	                                    ra = o
	                                }
	                            } else if (!(c[m >> 2] | 0)) {
	                                qa = 0;
	                                ra = 0
	                            } else {
	                                c[e >> 2] = (c[e >> 2] | 0) + -1;
	                                qa = 0;
	                                ra = 0
	                            } while (0);
	                            o = $T(u | 0, n | 0, 2) | 0;
	                            p = bU(o | 0, G | 0, -32, -1) | 0;
	                            o = bU(p | 0, G | 0, qa | 0, ra | 0) | 0;
	                            p = G;
	                            if (!pa) {
	                                l = +(r | 0) * 0.0;
	                                i = g;
	                                return +l
	                            }
	                            if ((p | 0) > 0 | (p | 0) == 0 & o >>> 0 > (0 - k | 0) >>> 0) {
	                                c[(_a() | 0) >> 2] = 34;
	                                l = +(r | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
	                                i = g;
	                                return +l
	                            }
	                            q = k + -106 | 0;
	                            oa = ((q | 0) < 0) << 31 >> 31;
	                            if ((p | 0) < (oa | 0) | (p | 0) == (oa | 0) & o >>> 0 < q >>> 0) {
	                                c[(_a() | 0) >> 2] = 34;
	                                l = +(r | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
	                                i = g;
	                                return +l
	                            }
	                            if ((pa | 0) > -1) {
	                                q = o;
	                                oa = p;
	                                sa = pa;
	                                ja = V;
	                                while (1) {
	                                    ta = sa << 1;
	                                    if (!(ja >= .5)) {
	                                        ua = ja;
	                                        va = ta
	                                    } else {
	                                        ua = ja + -1.0;
	                                        va = ta | 1
	                                    }
	                                    wa = ja + ua;
	                                    ta = bU(q | 0, oa | 0, -1, -1) | 0;
	                                    xa = G;
	                                    if ((va | 0) > -1) {
	                                        q = ta;
	                                        oa = xa;
	                                        sa = va;
	                                        ja = wa
	                                    } else {
	                                        ya = ta;
	                                        za = xa;
	                                        Aa = va;
	                                        Ba = wa;
	                                        break
	                                    }
	                                }
	                            } else {
	                                ya = o;
	                                za = p;
	                                Aa = pa;
	                                Ba = V
	                            }
	                            sa = XT(32, 0, k | 0, ((k | 0) < 0) << 31 >> 31 | 0) | 0;
	                            oa = bU(ya | 0, za | 0, sa | 0, G | 0) | 0;
	                            sa = G;
	                            if (0 > (sa | 0) | 0 == (sa | 0) & j >>> 0 > oa >>> 0)if ((oa | 0) < 0) {
	                                Ca = 0;
	                                x = 126
	                            } else {
	                                Da = oa;
	                                x = 124
	                            } else {
	                                Da = j;
	                                x = 124
	                            }
	                            if ((x | 0) == 124)if ((Da | 0) < 53) {
	                                Ca = Da;
	                                x = 126
	                            } else {
	                                Ea = Da;
	                                Fa = +(r | 0);
	                                Ga = 0.0
	                            }
	                            if ((x | 0) == 126) {
	                                ja = +(r | 0);
	                                Ea = Ca;
	                                Fa = ja;
	                                Ga = +tT(+AT(1.0, 84 - Ca | 0), ja)
	                            }
	                            oa = (Ea | 0) < 32 & Ba != 0.0 & (Aa & 1 | 0) == 0;
	                            ja = Fa * (oa ? 0.0 : Ba) + (Ga + Fa * +(((oa & 1) + Aa | 0) >>> 0)) - Ga;
	                            if (!(ja != 0.0))c[(_a() | 0) >> 2] = 34;
	                            l = +BT(ja, ya);
	                            i = g;
	                            return +l
	                        } else H = y; while (0);
	                        oa = k + j | 0;
	                        sa = 0 - oa | 0;
	                        q = H;
	                        n = 0;
	                        while (1) {
	                            if ((q | 0) == 46) {
	                                x = 137;
	                                break
	                            } else if ((q | 0) != 48) {
	                                Ha = q;
	                                Ia = 0;
	                                Ja = 0;
	                                Ka = n;
	                                La = 0;
	                                break
	                            }
	                            u = c[e >> 2] | 0;
	                            if (u >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                c[e >> 2] = u + 1;
	                                q = d[u >> 0] | 0;
	                                n = 1;
	                                continue
	                            } else {
	                                q = qT(b) | 0;
	                                n = 1;
	                                continue
	                            }
	                        }
	                        if ((x | 0) == 137) {
	                            q = c[e >> 2] | 0;
	                            if (q >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                c[e >> 2] = q + 1;
	                                Ma = d[q >> 0] | 0
	                            } else Ma = qT(b) | 0;
	                            if ((Ma | 0) == 48) {
	                                q = 0;
	                                u = 0;
	                                while (1) {
	                                    xa = bU(q | 0, u | 0, -1, -1) | 0;
	                                    ta = G;
	                                    Na = c[e >> 2] | 0;
	                                    if (Na >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                        c[e >> 2] = Na + 1;
	                                        Oa = d[Na >> 0] | 0
	                                    } else Oa = qT(b) | 0;
	                                    if ((Oa | 0) == 48) {
	                                        q = xa;
	                                        u = ta
	                                    } else {
	                                        Ha = Oa;
	                                        Ia = xa;
	                                        Ja = ta;
	                                        Ka = 1;
	                                        La = 1;
	                                        break
	                                    }
	                                }
	                            } else {
	                                Ha = Ma;
	                                Ia = 0;
	                                Ja = 0;
	                                Ka = n;
	                                La = 1
	                            }
	                        }
	                        c[h >> 2] = 0;
	                        u = Ha + -48 | 0;
	                        q = (Ha | 0) == 46;
	                        c:do if (u >>> 0 < 10 | q) {
	                            ta = h + 496 | 0;
	                            xa = Ha;
	                            Na = 0;
	                            Pa = 0;
	                            Qa = q;
	                            Ra = u;
	                            Sa = Ia;
	                            Ta = Ja;
	                            Ua = Ka;
	                            Va = La;
	                            Wa = 0;
	                            Xa = 0;
	                            Ya = 0;
	                            d:while (1) {
	                                do if (Qa)if (!Va) {
	                                    Za = Na;
	                                    $a = Pa;
	                                    ab = Na;
	                                    bb = Pa;
	                                    cb = Ua;
	                                    db = 1;
	                                    eb = Wa;
	                                    fb = Xa;
	                                    gb = Ya
	                                } else break d; else {
	                                    hb = bU(Na | 0, Pa | 0, 1, 0) | 0;
	                                    ib = G;
	                                    jb = (xa | 0) != 48;
	                                    if ((Xa | 0) >= 125) {
	                                        if (!jb) {
	                                            Za = Sa;
	                                            $a = Ta;
	                                            ab = hb;
	                                            bb = ib;
	                                            cb = Ua;
	                                            db = Va;
	                                            eb = Wa;
	                                            fb = Xa;
	                                            gb = Ya;
	                                            break
	                                        }
	                                        c[ta >> 2] = c[ta >> 2] | 1;
	                                        Za = Sa;
	                                        $a = Ta;
	                                        ab = hb;
	                                        bb = ib;
	                                        cb = Ua;
	                                        db = Va;
	                                        eb = Wa;
	                                        fb = Xa;
	                                        gb = Ya;
	                                        break
	                                    }
	                                    kb = h + (Xa << 2) | 0;
	                                    if (!Wa)lb = Ra; else lb = xa + -48 + ((c[kb >> 2] | 0) * 10 | 0) | 0;
	                                    c[kb >> 2] = lb;
	                                    kb = Wa + 1 | 0;
	                                    mb = (kb | 0) == 9;
	                                    Za = Sa;
	                                    $a = Ta;
	                                    ab = hb;
	                                    bb = ib;
	                                    cb = 1;
	                                    db = Va;
	                                    eb = mb ? 0 : kb;
	                                    fb = (mb & 1) + Xa | 0;
	                                    gb = jb ? hb : Ya
	                                } while (0);
	                                hb = c[e >> 2] | 0;
	                                if (hb >>> 0 < (c[m >> 2] | 0) >>> 0) {
	                                    c[e >> 2] = hb + 1;
	                                    nb = d[hb >> 0] | 0
	                                } else nb = qT(b) | 0;
	                                Ra = nb + -48 | 0;
	                                Qa = (nb | 0) == 46;
	                                if (!(Ra >>> 0 < 10 | Qa)) {
	                                    ob = nb;
	                                    pb = Za;
	                                    qb = ab;
	                                    rb = $a;
	                                    sb = bb;
	                                    tb = cb;
	                                    ub = db;
	                                    vb = eb;
	                                    wb = fb;
	                                    xb = gb;
	                                    x = 160;
	                                    break c
	                                } else {
	                                    xa = nb;
	                                    Na = ab;
	                                    Pa = bb;
	                                    Sa = Za;
	                                    Ta = $a;
	                                    Ua = cb;
	                                    Va = db;
	                                    Wa = eb;
	                                    Xa = fb;
	                                    Ya = gb
	                                }
	                            }
	                            yb = Na;
	                            zb = Pa;
	                            Ab = Sa;
	                            Bb = Ta;
	                            Cb = (Ua | 0) != 0;
	                            Db = Wa;
	                            Eb = Xa;
	                            Fb = Ya;
	                            x = 168
	                        } else {
	                            ob = Ha;
	                            pb = Ia;
	                            qb = 0;
	                            rb = Ja;
	                            sb = 0;
	                            tb = Ka;
	                            ub = La;
	                            vb = 0;
	                            wb = 0;
	                            xb = 0;
	                            x = 160
	                        } while (0);
	                        do if ((x | 0) == 160) {
	                            u = (ub | 0) == 0;
	                            q = u ? qb : pb;
	                            n = u ? sb : rb;
	                            u = (tb | 0) != 0;
	                            if (!(u & (ob | 32 | 0) == 101))if ((ob | 0) > -1) {
	                                yb = qb;
	                                zb = sb;
	                                Ab = q;
	                                Bb = n;
	                                Cb = u;
	                                Db = vb;
	                                Eb = wb;
	                                Fb = xb;
	                                x = 168;
	                                break
	                            } else {
	                                Gb = qb;
	                                Hb = sb;
	                                Ib = u;
	                                Jb = q;
	                                Kb = n;
	                                Lb = vb;
	                                Mb = wb;
	                                Nb = xb;
	                                x = 170;
	                                break
	                            }
	                            u = UT(b, f) | 0;
	                            Va = G;
	                            do if ((u | 0) == 0 & (Va | 0) == -2147483648)if (!f) {
	                                pT(b, 0);
	                                l = 0.0;
	                                i = g;
	                                return +l
	                            } else {
	                                if (!(c[m >> 2] | 0)) {
	                                    Ob = 0;
	                                    Pb = 0;
	                                    break
	                                }
	                                c[e >> 2] = (c[e >> 2] | 0) + -1;
	                                Ob = 0;
	                                Pb = 0;
	                                break
	                            } else {
	                                Ob = u;
	                                Pb = Va
	                            } while (0);
	                            Va = bU(Ob | 0, Pb | 0, q | 0, n | 0) | 0;
	                            Qb = Va;
	                            Rb = qb;
	                            Sb = G;
	                            Tb = sb;
	                            Ub = vb;
	                            Vb = wb;
	                            Wb = xb
	                        } while (0);
	                        if ((x | 0) == 168)if (c[m >> 2] | 0) {
	                            c[e >> 2] = (c[e >> 2] | 0) + -1;
	                            if (Cb) {
	                                Qb = Ab;
	                                Rb = yb;
	                                Sb = Bb;
	                                Tb = zb;
	                                Ub = Db;
	                                Vb = Eb;
	                                Wb = Fb
	                            } else x = 171
	                        } else {
	                            Gb = yb;
	                            Hb = zb;
	                            Ib = Cb;
	                            Jb = Ab;
	                            Kb = Bb;
	                            Lb = Db;
	                            Mb = Eb;
	                            Nb = Fb;
	                            x = 170
	                        }
	                        if ((x | 0) == 170)if (Ib) {
	                            Qb = Jb;
	                            Rb = Gb;
	                            Sb = Kb;
	                            Tb = Hb;
	                            Ub = Lb;
	                            Vb = Mb;
	                            Wb = Nb
	                        } else x = 171;
	                        if ((x | 0) == 171) {
	                            c[(_a() | 0) >> 2] = 22;
	                            pT(b, 0);
	                            l = 0.0;
	                            i = g;
	                            return +l
	                        }
	                        Va = c[h >> 2] | 0;
	                        if (!Va) {
	                            l = +(r | 0) * 0.0;
	                            i = g;
	                            return +l
	                        }
	                        if ((Qb | 0) == (Rb | 0) & (Sb | 0) == (Tb | 0) & ((Tb | 0) < 0 | (Tb | 0) == 0 & Rb >>> 0 < 10) ? j >>> 0 > 30 | (Va >>> j | 0) == 0 : 0) {
	                            l = +(r | 0) * +(Va >>> 0);
	                            i = g;
	                            return +l
	                        }
	                        Va = (k | 0) / -2 | 0;
	                        u = ((Va | 0) < 0) << 31 >> 31;
	                        if ((Sb | 0) > (u | 0) | (Sb | 0) == (u | 0) & Qb >>> 0 > Va >>> 0) {
	                            c[(_a() | 0) >> 2] = 34;
	                            l = +(r | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
	                            i = g;
	                            return +l
	                        }
	                        Va = k + -106 | 0;
	                        u = ((Va | 0) < 0) << 31 >> 31;
	                        if ((Sb | 0) < (u | 0) | (Sb | 0) == (u | 0) & Qb >>> 0 < Va >>> 0) {
	                            c[(_a() | 0) >> 2] = 34;
	                            l = +(r | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
	                            i = g;
	                            return +l
	                        }
	                        if (!Ub)Xb = Vb; else {
	                            if ((Ub | 0) < 9) {
	                                Va = h + (Vb << 2) | 0;
	                                u = c[Va >> 2] | 0;
	                                Ya = Ub;
	                                do {
	                                    u = u * 10 | 0;
	                                    Ya = Ya + 1 | 0
	                                } while ((Ya | 0) != 9);
	                                c[Va >> 2] = u
	                            }
	                            Xb = Vb + 1 | 0
	                        }
	                        if ((Wb | 0) < 9 ? (Wb | 0) <= (Qb | 0) & (Qb | 0) < 18 : 0) {
	                            if ((Qb | 0) == 9) {
	                                l = +(r | 0) * +((c[h >> 2] | 0) >>> 0);
	                                i = g;
	                                return +l
	                            }
	                            if ((Qb | 0) < 9) {
	                                l = +(r | 0) * +((c[h >> 2] | 0) >>> 0) / +(c[329064 + (8 - Qb << 2) >> 2] | 0);
	                                i = g;
	                                return +l
	                            }
	                            Ya = j + 27 + (ca(Qb, -3) | 0) | 0;
	                            Xa = c[h >> 2] | 0;
	                            if ((Ya | 0) > 30 | (Xa >>> Ya | 0) == 0) {
	                                l = +(r | 0) * +(Xa >>> 0) * +(c[329064 + (Qb + -10 << 2) >> 2] | 0);
	                                i = g;
	                                return +l
	                            }
	                        }
	                        Xa = (Qb | 0) % 9 | 0;
	                        if (!Xa) {
	                            Yb = 0;
	                            Zb = 0;
	                            _b = Qb;
	                            $b = Xb
	                        } else {
	                            Ya = (Qb | 0) > -1 ? Xa : Xa + 9 | 0;
	                            Xa = c[329064 + (8 - Ya << 2) >> 2] | 0;
	                            if (Xb) {
	                                Wa = 1e9 / (Xa | 0) | 0;
	                                Ua = 0;
	                                Ta = 0;
	                                Sa = 0;
	                                Pa = Qb;
	                                while (1) {
	                                    Na = h + (Sa << 2) | 0;
	                                    xa = c[Na >> 2] | 0;
	                                    Qa = ((xa >>> 0) / (Xa >>> 0) | 0) + Ta | 0;
	                                    c[Na >> 2] = Qa;
	                                    Ta = ca((xa >>> 0) % (Xa >>> 0) | 0, Wa) | 0;
	                                    xa = Sa;
	                                    Sa = Sa + 1 | 0;
	                                    if ((xa | 0) == (Ua | 0) & (Qa | 0) == 0) {
	                                        ac = Sa & 127;
	                                        bc = Pa + -9 | 0
	                                    } else {
	                                        ac = Ua;
	                                        bc = Pa
	                                    }
	                                    if ((Sa | 0) == (Xb | 0))break; else {
	                                        Ua = ac;
	                                        Pa = bc
	                                    }
	                                }
	                                if (!Ta) {
	                                    cc = ac;
	                                    dc = bc;
	                                    ec = Xb
	                                } else {
	                                    c[h + (Xb << 2) >> 2] = Ta;
	                                    cc = ac;
	                                    dc = bc;
	                                    ec = Xb + 1 | 0
	                                }
	                            } else {
	                                cc = 0;
	                                dc = Qb;
	                                ec = 0
	                            }
	                            Yb = cc;
	                            Zb = 0;
	                            _b = 9 - Ya + dc | 0;
	                            $b = ec
	                        }
	                        e:while (1) {
	                            Pa = h + (Yb << 2) | 0;
	                            if ((_b | 0) < 18) {
	                                Ua = Zb;
	                                Sa = $b;
	                                while (1) {
	                                    Wa = 0;
	                                    Xa = Sa + 127 | 0;
	                                    u = Sa;
	                                    while (1) {
	                                        Va = Xa & 127;
	                                        Qa = h + (Va << 2) | 0;
	                                        xa = $T(c[Qa >> 2] | 0, 0, 29) | 0;
	                                        Na = bU(xa | 0, G | 0, Wa | 0, 0) | 0;
	                                        xa = G;
	                                        if (xa >>> 0 > 0 | (xa | 0) == 0 & Na >>> 0 > 1e9) {
	                                            Ra = nU(Na | 0, xa | 0, 1e9, 0) | 0;
	                                            ta = oU(Na | 0, xa | 0, 1e9, 0) | 0;
	                                            fc = ta;
	                                            gc = Ra
	                                        } else {
	                                            fc = Na;
	                                            gc = 0
	                                        }
	                                        c[Qa >> 2] = fc;
	                                        Qa = (Va | 0) == (Yb | 0);
	                                        if ((Va | 0) != (u + 127 & 127 | 0) | Qa)hc = u; else hc = (fc | 0) == 0 ? Va : u;
	                                        if (Qa)break; else {
	                                            Wa = gc;
	                                            Xa = Va + -1 | 0;
	                                            u = hc
	                                        }
	                                    }
	                                    u = Ua + -29 | 0;
	                                    if (!gc) {
	                                        Ua = u;
	                                        Sa = hc
	                                    } else {
	                                        ic = u;
	                                        jc = gc;
	                                        kc = hc;
	                                        break
	                                    }
	                                }
	                            } else {
	                                if ((_b | 0) == 18) {
	                                    lc = Zb;
	                                    mc = $b
	                                } else {
	                                    nc = Yb;
	                                    oc = Zb;
	                                    pc = _b;
	                                    qc = $b;
	                                    break
	                                }
	                                while (1) {
	                                    if ((c[Pa >> 2] | 0) >>> 0 >= 9007199) {
	                                        nc = Yb;
	                                        oc = lc;
	                                        pc = 18;
	                                        qc = mc;
	                                        break e
	                                    }
	                                    Sa = 0;
	                                    Ua = mc + 127 | 0;
	                                    n = mc;
	                                    while (1) {
	                                        q = Ua & 127;
	                                        u = h + (q << 2) | 0;
	                                        Xa = $T(c[u >> 2] | 0, 0, 29) | 0;
	                                        Wa = bU(Xa | 0, G | 0, Sa | 0, 0) | 0;
	                                        Xa = G;
	                                        if (Xa >>> 0 > 0 | (Xa | 0) == 0 & Wa >>> 0 > 1e9) {
	                                            Va = nU(Wa | 0, Xa | 0, 1e9, 0) | 0;
	                                            Qa = oU(Wa | 0, Xa | 0, 1e9, 0) | 0;
	                                            rc = Qa;
	                                            sc = Va
	                                        } else {
	                                            rc = Wa;
	                                            sc = 0
	                                        }
	                                        c[u >> 2] = rc;
	                                        u = (q | 0) == (Yb | 0);
	                                        if ((q | 0) != (n + 127 & 127 | 0) | u)tc = n; else tc = (rc | 0) == 0 ? q : n;
	                                        if (u)break; else {
	                                            Sa = sc;
	                                            Ua = q + -1 | 0;
	                                            n = tc
	                                        }
	                                    }
	                                    n = lc + -29 | 0;
	                                    if (!sc) {
	                                        lc = n;
	                                        mc = tc
	                                    } else {
	                                        ic = n;
	                                        jc = sc;
	                                        kc = tc;
	                                        break
	                                    }
	                                }
	                            }
	                            Pa = Yb + 127 & 127;
	                            if ((Pa | 0) == (kc | 0)) {
	                                n = kc + 127 & 127;
	                                Ua = h + ((kc + 126 & 127) << 2) | 0;
	                                c[Ua >> 2] = c[Ua >> 2] | c[h + (n << 2) >> 2];
	                                uc = n
	                            } else uc = kc;
	                            c[h + (Pa << 2) >> 2] = jc;
	                            Yb = Pa;
	                            Zb = ic;
	                            _b = _b + 9 | 0;
	                            $b = uc
	                        }
	                        f:while (1) {
	                            vc = qc + 1 & 127;
	                            Ya = h + ((qc + 127 & 127) << 2) | 0;
	                            Ta = nc;
	                            Pa = oc;
	                            n = pc;
	                            while (1) {
	                                Ua = (n | 0) == 18;
	                                Sa = (n | 0) > 27 ? 9 : 1;
	                                wc = Ta;
	                                xc = Pa;
	                                while (1) {
	                                    q = 0;
	                                    while (1) {
	                                        u = q + wc & 127;
	                                        if ((u | 0) == (qc | 0)) {
	                                            yc = 2;
	                                            break
	                                        }
	                                        Wa = c[h + (u << 2) >> 2] | 0;
	                                        u = c[329056 + (q << 2) >> 2] | 0;
	                                        if (Wa >>> 0 < u >>> 0) {
	                                            yc = 2;
	                                            break
	                                        }
	                                        Va = q + 1 | 0;
	                                        if (Wa >>> 0 > u >>> 0) {
	                                            yc = q;
	                                            break
	                                        }
	                                        if ((Va | 0) < 2)q = Va; else {
	                                            yc = Va;
	                                            break
	                                        }
	                                    }
	                                    if ((yc | 0) == 2 & Ua)break f;
	                                    zc = Sa + xc | 0;
	                                    if ((wc | 0) == (qc | 0)) {
	                                        wc = qc;
	                                        xc = zc
	                                    } else break
	                                }
	                                Ua = (1 << Sa) + -1 | 0;
	                                q = 1e9 >>> Sa;
	                                Ac = wc;
	                                Bc = 0;
	                                Va = wc;
	                                Cc = n;
	                                do {
	                                    u = h + (Va << 2) | 0;
	                                    Wa = c[u >> 2] | 0;
	                                    Qa = (Wa >>> Sa) + Bc | 0;
	                                    c[u >> 2] = Qa;
	                                    Bc = ca(Wa & Ua, q) | 0;
	                                    Wa = (Va | 0) == (Ac | 0) & (Qa | 0) == 0;
	                                    Va = Va + 1 & 127;
	                                    Cc = Wa ? Cc + -9 | 0 : Cc;
	                                    Ac = Wa ? Va : Ac
	                                } while ((Va | 0) != (qc | 0));
	                                if (!Bc) {
	                                    Ta = Ac;
	                                    Pa = zc;
	                                    n = Cc;
	                                    continue
	                                }
	                                if ((vc | 0) != (Ac | 0))break;
	                                c[Ya >> 2] = c[Ya >> 2] | 1;
	                                Ta = Ac;
	                                Pa = zc;
	                                n = Cc
	                            }
	                            c[h + (qc << 2) >> 2] = Bc;
	                            nc = Ac;
	                            oc = zc;
	                            pc = Cc;
	                            qc = vc
	                        }
	                        n = wc & 127;
	                        if ((n | 0) == (qc | 0)) {
	                            c[h + (vc + -1 << 2) >> 2] = 0;
	                            Dc = vc
	                        } else Dc = qc;
	                        ja = +((c[h + (n << 2) >> 2] | 0) >>> 0);
	                        n = wc + 1 & 127;
	                        if ((n | 0) == (Dc | 0)) {
	                            Pa = Dc + 1 & 127;
	                            c[h + (Pa + -1 << 2) >> 2] = 0;
	                            Ec = Pa
	                        } else Ec = Dc;
	                        wa = +(r | 0);
	                        Fc = wa * (ja * 1.0e9 + +((c[h + (n << 2) >> 2] | 0) >>> 0));
	                        n = xc + 53 | 0;
	                        Pa = n - k | 0;
	                        if ((Pa | 0) < (j | 0))if ((Pa | 0) < 0) {
	                            Gc = 0;
	                            Hc = 1;
	                            x = 244
	                        } else {
	                            Ic = Pa;
	                            Jc = 1;
	                            x = 243
	                        } else {
	                            Ic = j;
	                            Jc = 0;
	                            x = 243
	                        }
	                        if ((x | 0) == 243)if ((Ic | 0) < 53) {
	                            Gc = Ic;
	                            Hc = Jc;
	                            x = 244
	                        } else {
	                            Kc = Ic;
	                            Lc = 0.0;
	                            Mc = Jc;
	                            Nc = 0.0;
	                            Oc = Fc
	                        }
	                        if ((x | 0) == 244) {
	                            ja = +tT(+AT(1.0, 105 - Gc | 0), Fc);
	                            Pc = +vT(Fc, +AT(1.0, 53 - Gc | 0));
	                            Kc = Gc;
	                            Lc = ja;
	                            Mc = Hc;
	                            Nc = Pc;
	                            Oc = ja + (Fc - Pc)
	                        }
	                        Ta = wc + 2 & 127;
	                        do if ((Ta | 0) == (Ec | 0))Qc = Nc; else {
	                            Ya = c[h + (Ta << 2) >> 2] | 0;
	                            do if (Ya >>> 0 >= 5e8) {
	                                if (Ya >>> 0 > 5e8) {
	                                    Rc = wa * .75 + Nc;
	                                    break
	                                }
	                                if ((wc + 3 & 127 | 0) == (Ec | 0)) {
	                                    Rc = wa * .5 + Nc;
	                                    break
	                                } else {
	                                    Rc = wa * .75 + Nc;
	                                    break
	                                }
	                            } else {
	                                if ((Ya | 0) == 0 ? (wc + 3 & 127 | 0) == (Ec | 0) : 0) {
	                                    Rc = Nc;
	                                    break
	                                }
	                                Rc = wa * .25 + Nc
	                            } while (0);
	                            if ((53 - Kc | 0) <= 1) {
	                                Qc = Rc;
	                                break
	                            }
	                            if (+vT(Rc, 1.0) != 0.0) {
	                                Qc = Rc;
	                                break
	                            }
	                            Qc = Rc + 1.0
	                        } while (0);
	                        wa = Oc + Qc - Lc;
	                        do if ((n & 2147483647 | 0) > (-2 - oa | 0)) {
	                            if (!(+R(+wa) >= 9007199254740992.0)) {
	                                Sc = Mc;
	                                Tc = xc;
	                                Uc = wa
	                            } else {
	                                Sc = (Mc | 0) != 0 & (Kc | 0) == (Pa | 0) ? 0 : Mc;
	                                Tc = xc + 1 | 0;
	                                Uc = wa * .5
	                            }
	                            if ((Tc + 50 | 0) <= (sa | 0) ? !((Sc | 0) != 0 & Qc != 0.0) : 0) {
	                                Vc = Tc;
	                                Wc = Uc;
	                                break
	                            }
	                            c[(_a() | 0) >> 2] = 34;
	                            Vc = Tc;
	                            Wc = Uc
	                        } else {
	                            Vc = xc;
	                            Wc = wa
	                        } while (0);
	                        l = +BT(Wc, Vc);
	                        i = g;
	                        return +l
	                    } else {
	                        if (c[m >> 2] | 0)c[e >> 2] = (c[e >> 2] | 0) + -1;
	                        c[(_a() | 0) >> 2] = 22;
	                        pT(b, 0);
	                        l = 0.0;
	                        i = g;
	                        return +l
	                    }
	                } while (0);
	                if ((x | 0) == 23) {
	                    x = (c[m >> 2] | 0) == 0;
	                    if (!x)c[e >> 2] = (c[e >> 2] | 0) + -1;
	                    if (!(t >>> 0 < 4 | (f | 0) == 0 | x)) {
	                        x = t;
	                        do {
	                            c[e >> 2] = (c[e >> 2] | 0) + -1;
	                            x = x + -1 | 0
	                        } while (x >>> 0 > 3)
	                    }
	                }
	                l = +(r | 0) * w;
	                i = g;
	                return +l
	            }

	            function pT(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                c[a + 104 >> 2] = b;
	                e = c[a + 8 >> 2] | 0;
	                f = c[a + 4 >> 2] | 0;
	                g = e - f | 0;
	                c[a + 108 >> 2] = g;
	                if ((b | 0) != 0 & (g | 0) > (b | 0)) {
	                    c[a + 100 >> 2] = f + b;
	                    i = d;
	                    return
	                } else {
	                    c[a + 100 >> 2] = e;
	                    i = d;
	                    return
	                }
	            }

	            function qT(b) {
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                f = b + 104 | 0;
	                g = c[f >> 2] | 0;
	                if (!((g | 0) != 0 ? (c[b + 108 >> 2] | 0) >= (g | 0) : 0))h = 3;
	                if ((h | 0) == 3 ? (h = HT(b) | 0, (h | 0) >= 0) : 0) {
	                    g = c[f >> 2] | 0;
	                    f = c[b + 8 >> 2] | 0;
	                    if ((g | 0) != 0 ? (j = c[b + 4 >> 2] | 0, k = g - (c[b + 108 >> 2] | 0) + -1 | 0, (f - j | 0) > (k | 0)) : 0)c[b + 100 >> 2] = j + k; else c[b + 100 >> 2] = f;
	                    k = c[b + 4 >> 2] | 0;
	                    if (f) {
	                        j = b + 108 | 0;
	                        c[j >> 2] = f + 1 - k + (c[j >> 2] | 0)
	                    }
	                    j = k + -1 | 0;
	                    if ((d[j >> 0] | 0 | 0) == (h | 0)) {
	                        l = h;
	                        i = e;
	                        return l | 0
	                    }
	                    a[j >> 0] = h;
	                    l = h;
	                    i = e;
	                    return l | 0
	                }
	                c[b + 100 >> 2] = 0;
	                l = -1;
	                i = e;
	                return l | 0
	            }

	            function rT(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0, f = 0, g = 0, j = 0;
	                b = i;
	                h[k >> 3] = a;
	                d = c[k >> 2] | 0;
	                e = c[k + 4 >> 2] | 0;
	                f = dU(d | 0, e | 0, 52) | 0;
	                g = f & 2047;
	                if ((g | 0) == 2047) {
	                    j = (d | 0) == 0 & (e & 1048575 | 0) == 0 & 1;
	                    i = b;
	                    return j | 0
	                } else if (!g) {
	                    j = (d | 0) != 0 | (e & 2147483647 | 0) != 0 ? 3 : 2;
	                    i = b;
	                    return j | 0
	                } else {
	                    j = 4;
	                    i = b;
	                    return j | 0
	                }
	                return 0
	            }

	            function sT(a, b) {
	                a = +a;
	                b = +b;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                h[k >> 3] = a;
	                e = c[k >> 2] | 0;
	                f = c[k + 4 >> 2] | 0;
	                h[k >> 3] = b;
	                g = c[k + 4 >> 2] & -2147483648 | f & 2147483647;
	                c[k >> 2] = e;
	                c[k + 4 >> 2] = g;
	                b = +h[k >> 3];
	                i = d;
	                return +b
	            }

	            function tT(a, b) {
	                a = +a;
	                b = +b;
	                var c = 0, d = 0.0;
	                c = i;
	                d = +sT(a, b);
	                i = c;
	                return +d
	            }

	            function uT(a, b) {
	                a = +a;
	                b = +b;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0.0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0.0;
	                d = i;
	                h[k >> 3] = a;
	                e = c[k >> 2] | 0;
	                f = c[k + 4 >> 2] | 0;
	                h[k >> 3] = b;
	                g = c[k >> 2] | 0;
	                j = c[k + 4 >> 2] | 0;
	                l = dU(e | 0, f | 0, 52) | 0;
	                m = l & 2047;
	                l = dU(g | 0, j | 0, 52) | 0;
	                n = l & 2047;
	                l = f & -2147483648;
	                o = $T(g | 0, j | 0, 1) | 0;
	                p = G;
	                if (!((o | 0) == 0 & (p | 0) == 0) ? (q = j & 2147483647, !(q >>> 0 > 2146435072 | (q | 0) == 2146435072 & g >>> 0 > 0 | (m | 0) == 2047)) : 0) {
	                    q = $T(e | 0, f | 0, 1) | 0;
	                    r = G;
	                    if (!(r >>> 0 > p >>> 0 | (r | 0) == (p | 0) & q >>> 0 > o >>> 0)) {
	                        if (!((q | 0) == (o | 0) & (r | 0) == (p | 0))) {
	                            s = a;
	                            i = d;
	                            return +s
	                        }
	                        s = a * 0.0;
	                        i = d;
	                        return +s
	                    }
	                    if (!m) {
	                        p = $T(e | 0, f | 0, 12) | 0;
	                        r = G;
	                        if ((r | 0) > -1 | (r | 0) == -1 & p >>> 0 > 4294967295) {
	                            o = p;
	                            p = r;
	                            r = 0;
	                            while (1) {
	                                q = r + -1 | 0;
	                                o = $T(o | 0, p | 0, 1) | 0;
	                                p = G;
	                                if (!((p | 0) > -1 | (p | 0) == -1 & o >>> 0 > 4294967295)) {
	                                    t = q;
	                                    break
	                                } else r = q
	                            }
	                        } else t = 0;
	                        r = $T(e | 0, f | 0, 1 - t | 0) | 0;
	                        u = r;
	                        v = G;
	                        w = t
	                    } else {
	                        u = e;
	                        v = f & 1048575 | 1048576;
	                        w = m
	                    }
	                    if (!n) {
	                        m = $T(g | 0, j | 0, 12) | 0;
	                        f = G;
	                        if ((f | 0) > -1 | (f | 0) == -1 & m >>> 0 > 4294967295) {
	                            e = m;
	                            m = f;
	                            f = 0;
	                            while (1) {
	                                t = f + -1 | 0;
	                                e = $T(e | 0, m | 0, 1) | 0;
	                                m = G;
	                                if (!((m | 0) > -1 | (m | 0) == -1 & e >>> 0 > 4294967295)) {
	                                    x = t;
	                                    break
	                                } else f = t
	                            }
	                        } else x = 0;
	                        f = $T(g | 0, j | 0, 1 - x | 0) | 0;
	                        y = f;
	                        z = G;
	                        A = x
	                    } else {
	                        y = g;
	                        z = j & 1048575 | 1048576;
	                        A = n
	                    }
	                    n = XT(u | 0, v | 0, y | 0, z | 0) | 0;
	                    j = G;
	                    g = (j | 0) > -1 | (j | 0) == -1 & n >>> 0 > 4294967295;
	                    a:do if ((w | 0) > (A | 0)) {
	                        x = g;
	                        f = n;
	                        e = j;
	                        m = u;
	                        t = v;
	                        r = w;
	                        while (1) {
	                            if (x)if ((m | 0) == (y | 0) & (t | 0) == (z | 0))break; else {
	                                B = f;
	                                C = e
	                            } else {
	                                B = m;
	                                C = t
	                            }
	                            o = $T(B | 0, C | 0, 1) | 0;
	                            p = G;
	                            q = r + -1 | 0;
	                            D = XT(o | 0, p | 0, y | 0, z | 0) | 0;
	                            E = G;
	                            F = (E | 0) > -1 | (E | 0) == -1 & D >>> 0 > 4294967295;
	                            if ((q | 0) > (A | 0)) {
	                                x = F;
	                                f = D;
	                                e = E;
	                                m = o;
	                                t = p;
	                                r = q
	                            } else {
	                                H = F;
	                                I = o;
	                                J = p;
	                                K = D;
	                                L = E;
	                                M = q;
	                                break a
	                            }
	                        }
	                        s = a * 0.0;
	                        i = d;
	                        return +s
	                    } else {
	                        H = g;
	                        I = u;
	                        J = v;
	                        K = n;
	                        L = j;
	                        M = w
	                    } while (0);
	                    if (H)if ((I | 0) == (y | 0) & (J | 0) == (z | 0)) {
	                        s = a * 0.0;
	                        i = d;
	                        return +s
	                    } else {
	                        N = L;
	                        O = K
	                    } else {
	                        N = J;
	                        O = I
	                    }
	                    if (N >>> 0 < 1048576 | (N | 0) == 1048576 & O >>> 0 < 0) {
	                        I = O;
	                        J = N;
	                        K = M;
	                        while (1) {
	                            L = $T(I | 0, J | 0, 1) | 0;
	                            z = G;
	                            y = K + -1 | 0;
	                            if (z >>> 0 < 1048576 | (z | 0) == 1048576 & L >>> 0 < 0) {
	                                I = L;
	                                J = z;
	                                K = y
	                            } else {
	                                P = L;
	                                Q = z;
	                                R = y;
	                                break
	                            }
	                        }
	                    } else {
	                        P = O;
	                        Q = N;
	                        R = M
	                    }
	                    if ((R | 0) > 0) {
	                        M = bU(P | 0, Q | 0, 0, -1048576) | 0;
	                        N = G;
	                        O = $T(R | 0, 0, 52) | 0;
	                        S = N | G;
	                        T = M | O
	                    } else {
	                        O = dU(P | 0, Q | 0, 1 - R | 0) | 0;
	                        S = G;
	                        T = O
	                    }
	                    c[k >> 2] = T;
	                    c[k + 4 >> 2] = S | l;
	                    s = +h[k >> 3];
	                    i = d;
	                    return +s
	                }
	                U = a * b;
	                s = U / U;
	                i = d;
	                return +s
	            }

	            function vT(a, b) {
	                a = +a;
	                b = +b;
	                var c = 0, d = 0.0;
	                c = i;
	                d = +uT(a, b);
	                i = c;
	                return +d
	            }

	            function wT(a, b) {
	                a = +a;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, j = 0, l = 0.0, m = 0.0, n = 0, o = 0.0;
	                d = i;
	                h[k >> 3] = a;
	                e = c[k >> 2] | 0;
	                f = c[k + 4 >> 2] | 0;
	                g = dU(e | 0, f | 0, 52) | 0;
	                j = g & 2047;
	                if (!j) {
	                    if (a != 0.0) {
	                        l = +wT(a * 18446744073709551616.0, b);
	                        m = l;
	                        n = (c[b >> 2] | 0) + -64 | 0
	                    } else {
	                        m = a;
	                        n = 0
	                    }
	                    c[b >> 2] = n;
	                    o = m;
	                    i = d;
	                    return +o
	                } else if ((j | 0) == 2047) {
	                    o = a;
	                    i = d;
	                    return +o
	                } else {
	                    c[b >> 2] = j + -1022;
	                    c[k >> 2] = e;
	                    c[k + 4 >> 2] = f & -2146435073 | 1071644672;
	                    o = +h[k >> 3];
	                    i = d;
	                    return +o
	                }
	                return +(0.0)
	            }

	            function xT(a, b) {
	                a = +a;
	                b = b | 0;
	                var c = 0, d = 0.0;
	                c = i;
	                d = +wT(a, b);
	                i = c;
	                return +d
	            }

	            function yT(a) {
	                a = +a;
	                var b = 0, d = 0, e = 0, f = 0, g = 0.0, j = 0, l = 0, m = 0, n = 0, o = 0, p = 0.0, q = 0.0, r = 0.0, s = 0.0, t = 0.0, u = 0.0;
	                b = i;
	                h[k >> 3] = a;
	                d = c[k >> 2] | 0;
	                e = c[k + 4 >> 2] | 0;
	                f = (e | 0) < 0;
	                do if (!(e >>> 0 < 1048576 | f)) {
	                    if (e >>> 0 > 2146435071) {
	                        g = a;
	                        i = b;
	                        return +g
	                    }
	                    if ((e | 0) == 1072693248 & ((d | 0) == 0 & 0 == 0)) {
	                        g = 0.0;
	                        i = b;
	                        return +g
	                    } else {
	                        j = d;
	                        l = e;
	                        m = e;
	                        n = -1023
	                    }
	                } else {
	                    if ((d | 0) == 0 & (e & 2147483647 | 0) == 0) {
	                        g = -1.0 / (a * a);
	                        i = b;
	                        return +g
	                    }
	                    if (!f) {
	                        h[k >> 3] = a * 18014398509481984.0;
	                        o = c[k + 4 >> 2] | 0;
	                        j = c[k >> 2] | 0;
	                        l = o;
	                        m = o;
	                        n = -1077;
	                        break
	                    }
	                    g = (a - a) / 0.0;
	                    i = b;
	                    return +g
	                } while (0);
	                l = m + 614242 | 0;
	                c[k >> 2] = j;
	                c[k + 4 >> 2] = (l & 1048575) + 1072079006;
	                a = +h[k >> 3] + -1.0;
	                p = a * (a * .5);
	                q = a / (a + 2.0);
	                r = q * q;
	                s = r * r;
	                h[k >> 3] = a - p;
	                j = c[k + 4 >> 2] | 0;
	                c[k >> 2] = 0;
	                c[k + 4 >> 2] = j;
	                t = +h[k >> 3];
	                u = q * (p + (s * (s * (s * .15313837699209373 + .22222198432149784) + .3999999999940942) + r * (s * (s * (s * .14798198605116586 + .1818357216161805) + .2857142874366239) + .6666666666666735))) + (a - t - p);
	                p = t * .4342944818781689;
	                a = +(n + (l >>> 20) | 0);
	                s = a * .30102999566361177;
	                r = s + p;
	                g = r + (p + (s - r) + (u * .4342944818781689 + (a * 3.694239077158931e-13 + (t + u) * 2.5082946711645275e-11)));
	                i = b;
	                return +g
	            }

	            function zT(a) {
	                a = a | 0;
	                return +v
	            }

	            function AT(a, b) {
	                a = +a;
	                b = b | 0;
	                var d = 0, e = 0.0, f = 0, g = 0, j = 0, l = 0.0;
	                d = i;
	                if ((b | 0) > 1023) {
	                    e = a * 8988465674311579538646525.0e283;
	                    f = b + -1023 | 0;
	                    if ((f | 0) > 1023) {
	                        g = b + -2046 | 0;
	                        j = (g | 0) > 1023 ? 1023 : g;
	                        l = e * 8988465674311579538646525.0e283
	                    } else {
	                        j = f;
	                        l = e
	                    }
	                } else if ((b | 0) < -1022) {
	                    e = a * 2.2250738585072014e-308;
	                    f = b + 1022 | 0;
	                    if ((f | 0) < -1022) {
	                        g = b + 2044 | 0;
	                        j = (g | 0) < -1022 ? -1022 : g;
	                        l = e * 2.2250738585072014e-308
	                    } else {
	                        j = f;
	                        l = e
	                    }
	                } else {
	                    j = b;
	                    l = a
	                }
	                b = $T(j + 1023 | 0, 0, 52) | 0;
	                j = G;
	                c[k >> 2] = b;
	                c[k + 4 >> 2] = j;
	                a = l * +h[k >> 3];
	                i = d;
	                return +a
	            }

	            function BT(a, b) {
	                a = +a;
	                b = b | 0;
	                var c = 0, d = 0.0;
	                c = i;
	                d = +AT(a, b);
	                i = c;
	                return +d
	            }

	            function CT(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var c = 0, d = 0;
	                c = i;
	                if (!a)d = 0; else d = DT(a, b, 0) | 0;
	                i = c;
	                return d | 0
	            }

	            function DT(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0;
	                e = i;
	                if (!b) {
	                    f = 1;
	                    i = e;
	                    return f | 0
	                }
	                if (d >>> 0 < 128) {
	                    a[b >> 0] = d;
	                    f = 1;
	                    i = e;
	                    return f | 0
	                }
	                if (d >>> 0 < 2048) {
	                    a[b >> 0] = d >>> 6 | 192;
	                    a[b + 1 >> 0] = d & 63 | 128;
	                    f = 2;
	                    i = e;
	                    return f | 0
	                }
	                if (d >>> 0 < 55296 | (d & -8192 | 0) == 57344) {
	                    a[b >> 0] = d >>> 12 | 224;
	                    a[b + 1 >> 0] = d >>> 6 & 63 | 128;
	                    a[b + 2 >> 0] = d & 63 | 128;
	                    f = 3;
	                    i = e;
	                    return f | 0
	                }
	                if ((d + -65536 | 0) >>> 0 < 1048576) {
	                    a[b >> 0] = d >>> 18 | 240;
	                    a[b + 1 >> 0] = d >>> 12 & 63 | 128;
	                    a[b + 2 >> 0] = d >>> 6 & 63 | 128;
	                    a[b + 3 >> 0] = d & 63 | 128;
	                    f = 4;
	                    i = e;
	                    return f | 0
	                } else {
	                    c[(_a() | 0) >> 2] = 84;
	                    f = -1;
	                    i = e;
	                    return f | 0
	                }
	                return 0
	            }

	            function ET(a) {
	                a = a | 0;
	                var b = 0;
	                b = (ca(c[a >> 2] | 0, 1103515245) | 0) + 12345 | 0;
	                c[a >> 2] = b;
	                a = b >>> 11 ^ b;
	                b = a << 7 & -1658038656 ^ a;
	                a = b << 15 & -272236544 ^ b;
	                return (a >>> 18 ^ a) >>> 1 | 0
	            }

	            function FT(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                e = b + 74 | 0;
	                f = a[e >> 0] | 0;
	                a[e >> 0] = f + 255 | f;
	                f = b + 20 | 0;
	                e = b + 44 | 0;
	                if ((c[f >> 2] | 0) >>> 0 > (c[e >> 2] | 0) >>> 0)vb[c[b + 36 >> 2] & 511](b, 0, 0) | 0;
	                c[b + 16 >> 2] = 0;
	                c[b + 28 >> 2] = 0;
	                c[f >> 2] = 0;
	                f = c[b >> 2] | 0;
	                if (!(f & 20)) {
	                    g = c[e >> 2] | 0;
	                    c[b + 8 >> 2] = g;
	                    c[b + 4 >> 2] = g;
	                    h = 0;
	                    i = d;
	                    return h | 0
	                }
	                if (!(f & 4)) {
	                    h = -1;
	                    i = d;
	                    return h | 0
	                }
	                c[b >> 2] = f | 32;
	                h = -1;
	                i = d;
	                return h | 0
	            }

	            function GT(b) {
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0;
	                d = i;
	                e = b + 74 | 0;
	                f = a[e >> 0] | 0;
	                a[e >> 0] = f + 255 | f;
	                f = c[b >> 2] | 0;
	                if (!(f & 8)) {
	                    c[b + 8 >> 2] = 0;
	                    c[b + 4 >> 2] = 0;
	                    e = c[b + 44 >> 2] | 0;
	                    c[b + 28 >> 2] = e;
	                    c[b + 20 >> 2] = e;
	                    c[b + 16 >> 2] = e + (c[b + 48 >> 2] | 0);
	                    g = 0;
	                    i = d;
	                    return g | 0
	                } else {
	                    c[b >> 2] = f | 32;
	                    g = -1;
	                    i = d;
	                    return g | 0
	                }
	                return 0
	            }

	            function HT(a) {
	                a = a | 0;
	                var b = 0, e = 0, f = 0;
	                b = i;
	                i = i + 16 | 0;
	                e = b;
	                if ((c[a + 8 >> 2] | 0) == 0 ? (FT(a) | 0) != 0 : 0)f = -1; else if ((vb[c[a + 32 >> 2] & 511](a, e, 1) | 0) == 1)f = d[e >> 0] | 0; else f = -1;
	                i = b;
	                return f | 0
	            }

	            function IT(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                g = e + 16 | 0;
	                h = c[g >> 2] | 0;
	                do if (!h)if (!(GT(e) | 0)) {
	                    j = c[g >> 2] | 0;
	                    break
	                } else {
	                    k = 0;
	                    i = f;
	                    return k | 0
	                } else j = h; while (0);
	                h = e + 20 | 0;
	                g = c[h >> 2] | 0;
	                if ((j - g | 0) >>> 0 < d >>> 0) {
	                    k = vb[c[e + 36 >> 2] & 511](e, b, d) | 0;
	                    i = f;
	                    return k | 0
	                }
	                a:do if ((a[e + 75 >> 0] | 0) > -1) {
	                    j = d;
	                    while (1) {
	                        if (!j) {
	                            l = d;
	                            m = b;
	                            n = g;
	                            o = 0;
	                            break a
	                        }
	                        p = j + -1 | 0;
	                        if ((a[b + p >> 0] | 0) == 10)break; else j = p
	                    }
	                    if ((vb[c[e + 36 >> 2] & 511](e, b, j) | 0) >>> 0 < j >>> 0) {
	                        k = j;
	                        i = f;
	                        return k | 0
	                    } else {
	                        l = d - j | 0;
	                        m = b + j | 0;
	                        n = c[h >> 2] | 0;
	                        o = j;
	                        break
	                    }
	                } else {
	                    l = d;
	                    m = b;
	                    n = g;
	                    o = 0
	                } while (0);
	                eU(n | 0, m | 0, l | 0) | 0;
	                c[h >> 2] = (c[h >> 2] | 0) + l;
	                k = o + l | 0;
	                i = f;
	                return k | 0
	            }

	            function JT(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0;
	                f = i;
	                i = i + 16 | 0;
	                g = f;
	                c[g >> 2] = e;
	                e = LT(a, b, d, g) | 0;
	                i = f;
	                return e | 0
	            }

	            function KT(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                e = i;
	                i = i + 224 | 0;
	                f = e + 120 | 0;
	                g = e + 80 | 0;
	                h = e;
	                j = e + 136 | 0;
	                k = g + 0 | 0;
	                l = k + 40 | 0;
	                do {
	                    c[k >> 2] = 0;
	                    k = k + 4 | 0
	                } while ((k | 0) < (l | 0));
	                c[f >> 2] = c[d >> 2];
	                if ((VT(0, b, f, h, g) | 0) < 0) {
	                    m = -1;
	                    i = e;
	                    return m | 0
	                }
	                d = a + 48 | 0;
	                if (!(c[d >> 2] | 0)) {
	                    k = a + 44 | 0;
	                    l = c[k >> 2] | 0;
	                    c[k >> 2] = j;
	                    n = a + 28 | 0;
	                    c[n >> 2] = j;
	                    o = a + 20 | 0;
	                    c[o >> 2] = j;
	                    c[d >> 2] = 80;
	                    p = a + 16 | 0;
	                    c[p >> 2] = j + 80;
	                    j = VT(a, b, f, h, g) | 0;
	                    if (!l)q = j; else {
	                        vb[c[a + 36 >> 2] & 511](a, 0, 0) | 0;
	                        r = (c[o >> 2] | 0) == 0 ? -1 : j;
	                        c[k >> 2] = l;
	                        c[d >> 2] = 0;
	                        c[p >> 2] = 0;
	                        c[n >> 2] = 0;
	                        c[o >> 2] = 0;
	                        q = r
	                    }
	                } else q = VT(a, b, f, h, g) | 0;
	                m = q;
	                i = e;
	                return m | 0
	            }

	            function LT(b, d, e, f) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                g = i;
	                i = i + 128 | 0;
	                h = g + 112 | 0;
	                j = g;
	                k = j + 0 | 0;
	                l = 329664 | 0;
	                m = k + 112 | 0;
	                do {
	                    c[k >> 2] = c[l >> 2];
	                    k = k + 4 | 0;
	                    l = l + 4 | 0
	                } while ((k | 0) < (m | 0));
	                if ((d + -1 | 0) >>> 0 > 2147483646)if (!d) {
	                    n = h;
	                    o = 1
	                } else {
	                    c[(_a() | 0) >> 2] = 75;
	                    p = -1;
	                    i = g;
	                    return p | 0
	                } else {
	                    n = b;
	                    o = d
	                }
	                d = -2 - n | 0;
	                b = o >>> 0 > d >>> 0 ? d : o;
	                c[j + 48 >> 2] = b;
	                o = j + 20 | 0;
	                c[o >> 2] = n;
	                c[j + 44 >> 2] = n;
	                d = n + b | 0;
	                n = j + 16 | 0;
	                c[n >> 2] = d;
	                c[j + 28 >> 2] = d;
	                d = KT(j, e, f) | 0;
	                if (!b) {
	                    p = d;
	                    i = g;
	                    return p | 0
	                }
	                b = c[o >> 2] | 0;
	                a[b + (((b | 0) == (c[n >> 2] | 0)) << 31 >> 31) >> 0] = 0;
	                p = d;
	                i = g;
	                return p | 0
	            }

	            function MT(b) {
	                b = b | 0;
	                var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
	                c = i;
	                d = b;
	                while (1) {
	                    e = d + 1 | 0;
	                    if (!(mT(a[d >> 0] | 0) | 0))break; else d = e
	                }
	                b = a[d >> 0] | 0;
	                f = b << 24 >> 24;
	                if ((f | 0) == 43) {
	                    g = 0;
	                    h = 5
	                } else if ((f | 0) == 45) {
	                    g = 1;
	                    h = 5
	                } else {
	                    j = d;
	                    k = b;
	                    l = 0
	                }
	                if ((h | 0) == 5) {
	                    j = e;
	                    k = a[e >> 0] | 0;
	                    l = g
	                }
	                if (!(lT(k << 24 >> 24) | 0)) {
	                    m = 0;
	                    n = (l | 0) != 0;
	                    o = 0 - m | 0;
	                    p = n ? m : o;
	                    i = c;
	                    return p | 0
	                } else {
	                    q = j;
	                    r = 0
	                }
	                while (1) {
	                    j = (r * 10 | 0) + 48 - (a[q >> 0] | 0) | 0;
	                    q = q + 1 | 0;
	                    if (!(lT(a[q >> 0] | 0) | 0)) {
	                        m = j;
	                        break
	                    } else r = j
	                }
	                n = (l | 0) != 0;
	                o = 0 - m | 0;
	                p = n ? m : o;
	                i = c;
	                return p | 0
	            }

	            function NT(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                f = i;
	                g = d & 255;
	                h = (e | 0) != 0;
	                a:do if ((b & 3 | 0) != 0 & h) {
	                    j = d & 255;
	                    k = e;
	                    l = b;
	                    while (1) {
	                        if ((a[l >> 0] | 0) == j << 24 >> 24) {
	                            m = k;
	                            n = l;
	                            o = 6;
	                            break a
	                        }
	                        p = l + 1 | 0;
	                        q = k + -1 | 0;
	                        r = (q | 0) != 0;
	                        if ((p & 3 | 0) != 0 & r) {
	                            k = q;
	                            l = p
	                        } else {
	                            s = q;
	                            t = r;
	                            u = p;
	                            o = 5;
	                            break
	                        }
	                    }
	                } else {
	                    s = e;
	                    t = h;
	                    u = b;
	                    o = 5
	                } while (0);
	                if ((o | 0) == 5)if (t) {
	                    m = s;
	                    n = u;
	                    o = 6
	                } else {
	                    v = 0;
	                    w = u
	                }
	                b:do if ((o | 0) == 6) {
	                    u = d & 255;
	                    if ((a[n >> 0] | 0) != u << 24 >> 24) {
	                        s = ca(g, 16843009) | 0;
	                        c:do if (m >>> 0 > 3) {
	                            t = m;
	                            b = n;
	                            while (1) {
	                                h = c[b >> 2] ^ s;
	                                if ((h & -2139062144 ^ -2139062144) & h + -16843009) {
	                                    x = t;
	                                    y = b;
	                                    break c
	                                }
	                                h = b + 4 | 0;
	                                e = t + -4 | 0;
	                                if (e >>> 0 > 3) {
	                                    t = e;
	                                    b = h
	                                } else {
	                                    x = e;
	                                    y = h;
	                                    break
	                                }
	                            }
	                        } else {
	                            x = m;
	                            y = n
	                        } while (0);
	                        if (!x) {
	                            v = 0;
	                            w = y
	                        } else {
	                            s = x;
	                            b = y;
	                            while (1) {
	                                if ((a[b >> 0] | 0) == u << 24 >> 24) {
	                                    v = s;
	                                    w = b;
	                                    break b
	                                }
	                                t = b + 1 | 0;
	                                s = s + -1 | 0;
	                                if (!s) {
	                                    v = 0;
	                                    w = t;
	                                    break
	                                } else b = t
	                            }
	                        }
	                    } else {
	                        v = m;
	                        w = n
	                    }
	                } while (0);
	                i = f;
	                return ((v | 0) != 0 ? w : 0) | 0
	            }

	            function OT(b, c, d) {
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0;
	                e = i;
	                a:do if (!d)f = 0; else {
	                    g = d;
	                    h = b;
	                    j = c;
	                    while (1) {
	                        k = a[h >> 0] | 0;
	                        l = a[j >> 0] | 0;
	                        if (k << 24 >> 24 != l << 24 >> 24)break;
	                        g = g + -1 | 0;
	                        if (!g) {
	                            f = 0;
	                            break a
	                        } else {
	                            h = h + 1 | 0;
	                            j = j + 1 | 0
	                        }
	                    }
	                    f = (k & 255) - (l & 255) | 0
	                } while (0);
	                i = e;
	                return f | 0
	            }

	            function PT(b, c) {
	                b = b | 0;
	                c = c | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0;
	                d = i;
	                e = a[b >> 0] | 0;
	                f = a[c >> 0] | 0;
	                if (e << 24 >> 24 == 0 ? 1 : e << 24 >> 24 != f << 24 >> 24) {
	                    g = e;
	                    h = f
	                } else {
	                    f = b;
	                    b = c;
	                    do {
	                        f = f + 1 | 0;
	                        b = b + 1 | 0;
	                        c = a[f >> 0] | 0;
	                        e = a[b >> 0] | 0
	                    } while (!(c << 24 >> 24 == 0 ? 1 : c << 24 >> 24 != e << 24 >> 24));
	                    g = c;
	                    h = e
	                }
	                i = d;
	                return (g & 255) - (h & 255) | 0
	            }

	            function QT(b, c, e) {
	                b = b | 0;
	                c = c | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
	                f = i;
	                if (!e) {
	                    g = 0;
	                    i = f;
	                    return g | 0
	                }
	                h = a[b >> 0] | 0;
	                a:do if (!(h << 24 >> 24)) {
	                    j = 0;
	                    k = c
	                } else {
	                    l = e;
	                    m = h;
	                    n = b;
	                    o = c;
	                    while (1) {
	                        l = l + -1 | 0;
	                        p = a[o >> 0] | 0;
	                        if (!(p << 24 >> 24 != 0 & (l | 0) != 0 & m << 24 >> 24 == p << 24 >> 24)) {
	                            j = m;
	                            k = o;
	                            break a
	                        }
	                        n = n + 1 | 0;
	                        p = o + 1 | 0;
	                        m = a[n >> 0] | 0;
	                        if (!(m << 24 >> 24)) {
	                            j = 0;
	                            k = p;
	                            break
	                        } else o = p
	                    }
	                } while (0);
	                g = (j & 255) - (d[k >> 0] | 0) | 0;
	                i = f;
	                return g | 0
	            }

	            function RT(a, b, d) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0;
	                e = i;
	                f = a + 20 | 0;
	                g = c[f >> 2] | 0;
	                h = (c[a + 16 >> 2] | 0) - g | 0;
	                a = h >>> 0 > d >>> 0 ? d : h;
	                eU(g | 0, b | 0, a | 0) | 0;
	                c[f >> 2] = (c[f >> 2] | 0) + a;
	                i = e;
	                return d | 0
	            }

	            function ST(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                d = i;
	                e = a + 4 | 0;
	                f = c[e >> 2] | 0;
	                g = f & -8;
	                h = a + g | 0;
	                j = c[82068] | 0;
	                k = f & 3;
	                if (!((k | 0) != 1 & a >>> 0 >= j >>> 0 & a >>> 0 < h >>> 0))hb();
	                l = a + (g | 4) | 0;
	                m = c[l >> 2] | 0;
	                if (!(m & 1))hb();
	                if (!k) {
	                    if (b >>> 0 < 256) {
	                        n = 0;
	                        i = d;
	                        return n | 0
	                    }
	                    if (g >>> 0 >= (b + 4 | 0) >>> 0 ? (g - b | 0) >>> 0 <= c[82184] << 1 >>> 0 : 0) {
	                        n = a;
	                        i = d;
	                        return n | 0
	                    }
	                    n = 0;
	                    i = d;
	                    return n | 0
	                }
	                if (g >>> 0 >= b >>> 0) {
	                    k = g - b | 0;
	                    if (k >>> 0 <= 15) {
	                        n = a;
	                        i = d;
	                        return n | 0
	                    }
	                    c[e >> 2] = f & 1 | b | 2;
	                    c[a + (b + 4) >> 2] = k | 3;
	                    c[l >> 2] = c[l >> 2] | 1;
	                    TT(a + b | 0, k);
	                    n = a;
	                    i = d;
	                    return n | 0
	                }
	                if ((h | 0) == (c[82070] | 0)) {
	                    k = (c[82067] | 0) + g | 0;
	                    if (k >>> 0 <= b >>> 0) {
	                        n = 0;
	                        i = d;
	                        return n | 0
	                    }
	                    l = k - b | 0;
	                    c[e >> 2] = f & 1 | b | 2;
	                    c[a + (b + 4) >> 2] = l | 1;
	                    c[82070] = a + b;
	                    c[82067] = l;
	                    n = a;
	                    i = d;
	                    return n | 0
	                }
	                if ((h | 0) == (c[82069] | 0)) {
	                    l = (c[82066] | 0) + g | 0;
	                    if (l >>> 0 < b >>> 0) {
	                        n = 0;
	                        i = d;
	                        return n | 0
	                    }
	                    k = l - b | 0;
	                    if (k >>> 0 > 15) {
	                        c[e >> 2] = f & 1 | b | 2;
	                        c[a + (b + 4) >> 2] = k | 1;
	                        c[a + l >> 2] = k;
	                        o = a + (l + 4) | 0;
	                        c[o >> 2] = c[o >> 2] & -2;
	                        p = a + b | 0;
	                        q = k
	                    } else {
	                        c[e >> 2] = f & 1 | l | 2;
	                        k = a + (l + 4) | 0;
	                        c[k >> 2] = c[k >> 2] | 1;
	                        p = 0;
	                        q = 0
	                    }
	                    c[82066] = q;
	                    c[82069] = p;
	                    n = a;
	                    i = d;
	                    return n | 0
	                }
	                if (m & 2) {
	                    n = 0;
	                    i = d;
	                    return n | 0
	                }
	                p = (m & -8) + g | 0;
	                if (p >>> 0 < b >>> 0) {
	                    n = 0;
	                    i = d;
	                    return n | 0
	                }
	                q = p - b | 0;
	                k = m >>> 3;
	                do if (m >>> 0 >= 256) {
	                    l = c[a + (g + 24) >> 2] | 0;
	                    o = c[a + (g + 12) >> 2] | 0;
	                    do if ((o | 0) == (h | 0)) {
	                        r = a + (g + 20) | 0;
	                        s = c[r >> 2] | 0;
	                        if (!s) {
	                            t = a + (g + 16) | 0;
	                            u = c[t >> 2] | 0;
	                            if (!u) {
	                                v = 0;
	                                break
	                            } else {
	                                w = u;
	                                x = t
	                            }
	                        } else {
	                            w = s;
	                            x = r
	                        }
	                        while (1) {
	                            r = w + 20 | 0;
	                            s = c[r >> 2] | 0;
	                            if (s) {
	                                w = s;
	                                x = r;
	                                continue
	                            }
	                            r = w + 16 | 0;
	                            s = c[r >> 2] | 0;
	                            if (!s)break; else {
	                                w = s;
	                                x = r
	                            }
	                        }
	                        if (x >>> 0 < j >>> 0)hb(); else {
	                            c[x >> 2] = 0;
	                            v = w;
	                            break
	                        }
	                    } else {
	                        r = c[a + (g + 8) >> 2] | 0;
	                        if (r >>> 0 < j >>> 0)hb();
	                        s = r + 12 | 0;
	                        if ((c[s >> 2] | 0) != (h | 0))hb();
	                        t = o + 8 | 0;
	                        if ((c[t >> 2] | 0) == (h | 0)) {
	                            c[s >> 2] = o;
	                            c[t >> 2] = r;
	                            v = o;
	                            break
	                        } else hb()
	                    } while (0);
	                    if (l) {
	                        o = c[a + (g + 28) >> 2] | 0;
	                        r = 328560 + (o << 2) | 0;
	                        if ((h | 0) == (c[r >> 2] | 0)) {
	                            c[r >> 2] = v;
	                            if (!v) {
	                                c[82065] = c[82065] & ~(1 << o);
	                                break
	                            }
	                        } else {
	                            if (l >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            o = l + 16 | 0;
	                            if ((c[o >> 2] | 0) == (h | 0))c[o >> 2] = v; else c[l + 20 >> 2] = v;
	                            if (!v)break
	                        }
	                        o = c[82068] | 0;
	                        if (v >>> 0 < o >>> 0)hb();
	                        c[v + 24 >> 2] = l;
	                        r = c[a + (g + 16) >> 2] | 0;
	                        do if (r)if (r >>> 0 < o >>> 0)hb(); else {
	                            c[v + 16 >> 2] = r;
	                            c[r + 24 >> 2] = v;
	                            break
	                        } while (0);
	                        r = c[a + (g + 20) >> 2] | 0;
	                        if (r)if (r >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                            c[v + 20 >> 2] = r;
	                            c[r + 24 >> 2] = v;
	                            break
	                        }
	                    }
	                } else {
	                    r = c[a + (g + 8) >> 2] | 0;
	                    o = c[a + (g + 12) >> 2] | 0;
	                    l = 328296 + (k << 1 << 2) | 0;
	                    if ((r | 0) != (l | 0)) {
	                        if (r >>> 0 < j >>> 0)hb();
	                        if ((c[r + 12 >> 2] | 0) != (h | 0))hb()
	                    }
	                    if ((o | 0) == (r | 0)) {
	                        c[82064] = c[82064] & ~(1 << k);
	                        break
	                    }
	                    if ((o | 0) != (l | 0)) {
	                        if (o >>> 0 < j >>> 0)hb();
	                        l = o + 8 | 0;
	                        if ((c[l >> 2] | 0) == (h | 0))y = l; else hb()
	                    } else y = o + 8 | 0;
	                    c[r + 12 >> 2] = o;
	                    c[y >> 2] = r
	                } while (0);
	                if (q >>> 0 < 16) {
	                    c[e >> 2] = p | f & 1 | 2;
	                    y = a + (p | 4) | 0;
	                    c[y >> 2] = c[y >> 2] | 1;
	                    n = a;
	                    i = d;
	                    return n | 0
	                } else {
	                    c[e >> 2] = f & 1 | b | 2;
	                    c[a + (b + 4) >> 2] = q | 3;
	                    f = a + (p | 4) | 0;
	                    c[f >> 2] = c[f >> 2] | 1;
	                    TT(a + b | 0, q);
	                    n = a;
	                    i = d;
	                    return n | 0
	                }
	                return 0
	            }

	            function TT(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var d = 0, e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0;
	                d = i;
	                e = a + b | 0;
	                f = c[a + 4 >> 2] | 0;
	                do if (!(f & 1)) {
	                    g = c[a >> 2] | 0;
	                    if (!(f & 3)) {
	                        i = d;
	                        return
	                    }
	                    h = a + (0 - g) | 0;
	                    j = g + b | 0;
	                    k = c[82068] | 0;
	                    if (h >>> 0 < k >>> 0)hb();
	                    if ((h | 0) == (c[82069] | 0)) {
	                        l = a + (b + 4) | 0;
	                        m = c[l >> 2] | 0;
	                        if ((m & 3 | 0) != 3) {
	                            n = h;
	                            o = j;
	                            break
	                        }
	                        c[82066] = j;
	                        c[l >> 2] = m & -2;
	                        c[a + (4 - g) >> 2] = j | 1;
	                        c[e >> 2] = j;
	                        i = d;
	                        return
	                    }
	                    m = g >>> 3;
	                    if (g >>> 0 < 256) {
	                        l = c[a + (8 - g) >> 2] | 0;
	                        p = c[a + (12 - g) >> 2] | 0;
	                        q = 328296 + (m << 1 << 2) | 0;
	                        if ((l | 0) != (q | 0)) {
	                            if (l >>> 0 < k >>> 0)hb();
	                            if ((c[l + 12 >> 2] | 0) != (h | 0))hb()
	                        }
	                        if ((p | 0) == (l | 0)) {
	                            c[82064] = c[82064] & ~(1 << m);
	                            n = h;
	                            o = j;
	                            break
	                        }
	                        if ((p | 0) != (q | 0)) {
	                            if (p >>> 0 < k >>> 0)hb();
	                            q = p + 8 | 0;
	                            if ((c[q >> 2] | 0) == (h | 0))r = q; else hb()
	                        } else r = p + 8 | 0;
	                        c[l + 12 >> 2] = p;
	                        c[r >> 2] = l;
	                        n = h;
	                        o = j;
	                        break
	                    }
	                    l = c[a + (24 - g) >> 2] | 0;
	                    p = c[a + (12 - g) >> 2] | 0;
	                    do if ((p | 0) == (h | 0)) {
	                        q = 16 - g | 0;
	                        m = a + (q + 4) | 0;
	                        s = c[m >> 2] | 0;
	                        if (!s) {
	                            t = a + q | 0;
	                            q = c[t >> 2] | 0;
	                            if (!q) {
	                                u = 0;
	                                break
	                            } else {
	                                v = q;
	                                w = t
	                            }
	                        } else {
	                            v = s;
	                            w = m
	                        }
	                        while (1) {
	                            m = v + 20 | 0;
	                            s = c[m >> 2] | 0;
	                            if (s) {
	                                v = s;
	                                w = m;
	                                continue
	                            }
	                            m = v + 16 | 0;
	                            s = c[m >> 2] | 0;
	                            if (!s)break; else {
	                                v = s;
	                                w = m
	                            }
	                        }
	                        if (w >>> 0 < k >>> 0)hb(); else {
	                            c[w >> 2] = 0;
	                            u = v;
	                            break
	                        }
	                    } else {
	                        m = c[a + (8 - g) >> 2] | 0;
	                        if (m >>> 0 < k >>> 0)hb();
	                        s = m + 12 | 0;
	                        if ((c[s >> 2] | 0) != (h | 0))hb();
	                        t = p + 8 | 0;
	                        if ((c[t >> 2] | 0) == (h | 0)) {
	                            c[s >> 2] = p;
	                            c[t >> 2] = m;
	                            u = p;
	                            break
	                        } else hb()
	                    } while (0);
	                    if (l) {
	                        p = c[a + (28 - g) >> 2] | 0;
	                        k = 328560 + (p << 2) | 0;
	                        if ((h | 0) == (c[k >> 2] | 0)) {
	                            c[k >> 2] = u;
	                            if (!u) {
	                                c[82065] = c[82065] & ~(1 << p);
	                                n = h;
	                                o = j;
	                                break
	                            }
	                        } else {
	                            if (l >>> 0 < (c[82068] | 0) >>> 0)hb();
	                            p = l + 16 | 0;
	                            if ((c[p >> 2] | 0) == (h | 0))c[p >> 2] = u; else c[l + 20 >> 2] = u;
	                            if (!u) {
	                                n = h;
	                                o = j;
	                                break
	                            }
	                        }
	                        p = c[82068] | 0;
	                        if (u >>> 0 < p >>> 0)hb();
	                        c[u + 24 >> 2] = l;
	                        k = 16 - g | 0;
	                        m = c[a + k >> 2] | 0;
	                        do if (m)if (m >>> 0 < p >>> 0)hb(); else {
	                            c[u + 16 >> 2] = m;
	                            c[m + 24 >> 2] = u;
	                            break
	                        } while (0);
	                        m = c[a + (k + 4) >> 2] | 0;
	                        if (m)if (m >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                            c[u + 20 >> 2] = m;
	                            c[m + 24 >> 2] = u;
	                            n = h;
	                            o = j;
	                            break
	                        } else {
	                            n = h;
	                            o = j
	                        }
	                    } else {
	                        n = h;
	                        o = j
	                    }
	                } else {
	                    n = a;
	                    o = b
	                } while (0);
	                u = c[82068] | 0;
	                if (e >>> 0 < u >>> 0)hb();
	                v = a + (b + 4) | 0;
	                w = c[v >> 2] | 0;
	                if (!(w & 2)) {
	                    if ((e | 0) == (c[82070] | 0)) {
	                        r = (c[82067] | 0) + o | 0;
	                        c[82067] = r;
	                        c[82070] = n;
	                        c[n + 4 >> 2] = r | 1;
	                        if ((n | 0) != (c[82069] | 0)) {
	                            i = d;
	                            return
	                        }
	                        c[82069] = 0;
	                        c[82066] = 0;
	                        i = d;
	                        return
	                    }
	                    if ((e | 0) == (c[82069] | 0)) {
	                        r = (c[82066] | 0) + o | 0;
	                        c[82066] = r;
	                        c[82069] = n;
	                        c[n + 4 >> 2] = r | 1;
	                        c[n + r >> 2] = r;
	                        i = d;
	                        return
	                    }
	                    r = (w & -8) + o | 0;
	                    f = w >>> 3;
	                    do if (w >>> 0 >= 256) {
	                        m = c[a + (b + 24) >> 2] | 0;
	                        p = c[a + (b + 12) >> 2] | 0;
	                        do if ((p | 0) == (e | 0)) {
	                            g = a + (b + 20) | 0;
	                            l = c[g >> 2] | 0;
	                            if (!l) {
	                                t = a + (b + 16) | 0;
	                                s = c[t >> 2] | 0;
	                                if (!s) {
	                                    x = 0;
	                                    break
	                                } else {
	                                    y = s;
	                                    z = t
	                                }
	                            } else {
	                                y = l;
	                                z = g
	                            }
	                            while (1) {
	                                g = y + 20 | 0;
	                                l = c[g >> 2] | 0;
	                                if (l) {
	                                    y = l;
	                                    z = g;
	                                    continue
	                                }
	                                g = y + 16 | 0;
	                                l = c[g >> 2] | 0;
	                                if (!l)break; else {
	                                    y = l;
	                                    z = g
	                                }
	                            }
	                            if (z >>> 0 < u >>> 0)hb(); else {
	                                c[z >> 2] = 0;
	                                x = y;
	                                break
	                            }
	                        } else {
	                            g = c[a + (b + 8) >> 2] | 0;
	                            if (g >>> 0 < u >>> 0)hb();
	                            l = g + 12 | 0;
	                            if ((c[l >> 2] | 0) != (e | 0))hb();
	                            t = p + 8 | 0;
	                            if ((c[t >> 2] | 0) == (e | 0)) {
	                                c[l >> 2] = p;
	                                c[t >> 2] = g;
	                                x = p;
	                                break
	                            } else hb()
	                        } while (0);
	                        if (m) {
	                            p = c[a + (b + 28) >> 2] | 0;
	                            j = 328560 + (p << 2) | 0;
	                            if ((e | 0) == (c[j >> 2] | 0)) {
	                                c[j >> 2] = x;
	                                if (!x) {
	                                    c[82065] = c[82065] & ~(1 << p);
	                                    break
	                                }
	                            } else {
	                                if (m >>> 0 < (c[82068] | 0) >>> 0)hb();
	                                p = m + 16 | 0;
	                                if ((c[p >> 2] | 0) == (e | 0))c[p >> 2] = x; else c[m + 20 >> 2] = x;
	                                if (!x)break
	                            }
	                            p = c[82068] | 0;
	                            if (x >>> 0 < p >>> 0)hb();
	                            c[x + 24 >> 2] = m;
	                            j = c[a + (b + 16) >> 2] | 0;
	                            do if (j)if (j >>> 0 < p >>> 0)hb(); else {
	                                c[x + 16 >> 2] = j;
	                                c[j + 24 >> 2] = x;
	                                break
	                            } while (0);
	                            j = c[a + (b + 20) >> 2] | 0;
	                            if (j)if (j >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                                c[x + 20 >> 2] = j;
	                                c[j + 24 >> 2] = x;
	                                break
	                            }
	                        }
	                    } else {
	                        j = c[a + (b + 8) >> 2] | 0;
	                        p = c[a + (b + 12) >> 2] | 0;
	                        m = 328296 + (f << 1 << 2) | 0;
	                        if ((j | 0) != (m | 0)) {
	                            if (j >>> 0 < u >>> 0)hb();
	                            if ((c[j + 12 >> 2] | 0) != (e | 0))hb()
	                        }
	                        if ((p | 0) == (j | 0)) {
	                            c[82064] = c[82064] & ~(1 << f);
	                            break
	                        }
	                        if ((p | 0) != (m | 0)) {
	                            if (p >>> 0 < u >>> 0)hb();
	                            m = p + 8 | 0;
	                            if ((c[m >> 2] | 0) == (e | 0))A = m; else hb()
	                        } else A = p + 8 | 0;
	                        c[j + 12 >> 2] = p;
	                        c[A >> 2] = j
	                    } while (0);
	                    c[n + 4 >> 2] = r | 1;
	                    c[n + r >> 2] = r;
	                    if ((n | 0) == (c[82069] | 0)) {
	                        c[82066] = r;
	                        i = d;
	                        return
	                    } else B = r
	                } else {
	                    c[v >> 2] = w & -2;
	                    c[n + 4 >> 2] = o | 1;
	                    c[n + o >> 2] = o;
	                    B = o
	                }
	                o = B >>> 3;
	                if (B >>> 0 < 256) {
	                    w = o << 1;
	                    v = 328296 + (w << 2) | 0;
	                    r = c[82064] | 0;
	                    A = 1 << o;
	                    if (r & A) {
	                        o = 328296 + (w + 2 << 2) | 0;
	                        e = c[o >> 2] | 0;
	                        if (e >>> 0 < (c[82068] | 0) >>> 0)hb(); else {
	                            C = o;
	                            D = e
	                        }
	                    } else {
	                        c[82064] = r | A;
	                        C = 328296 + (w + 2 << 2) | 0;
	                        D = v
	                    }
	                    c[C >> 2] = n;
	                    c[D + 12 >> 2] = n;
	                    c[n + 8 >> 2] = D;
	                    c[n + 12 >> 2] = v;
	                    i = d;
	                    return
	                }
	                v = B >>> 8;
	                if (v)if (B >>> 0 > 16777215)E = 31; else {
	                    D = (v + 1048320 | 0) >>> 16 & 8;
	                    C = v << D;
	                    v = (C + 520192 | 0) >>> 16 & 4;
	                    w = C << v;
	                    C = (w + 245760 | 0) >>> 16 & 2;
	                    A = 14 - (v | D | C) + (w << C >>> 15) | 0;
	                    E = B >>> (A + 7 | 0) & 1 | A << 1
	                } else E = 0;
	                A = 328560 + (E << 2) | 0;
	                c[n + 28 >> 2] = E;
	                c[n + 20 >> 2] = 0;
	                c[n + 16 >> 2] = 0;
	                C = c[82065] | 0;
	                w = 1 << E;
	                if (!(C & w)) {
	                    c[82065] = C | w;
	                    c[A >> 2] = n;
	                    c[n + 24 >> 2] = A;
	                    c[n + 12 >> 2] = n;
	                    c[n + 8 >> 2] = n;
	                    i = d;
	                    return
	                }
	                w = c[A >> 2] | 0;
	                if ((E | 0) == 31)F = 0; else F = 25 - (E >>> 1) | 0;
	                a:do if ((c[w + 4 >> 2] & -8 | 0) == (B | 0))G = w; else {
	                    E = B << F;
	                    A = w;
	                    while (1) {
	                        H = A + (E >>> 31 << 2) + 16 | 0;
	                        C = c[H >> 2] | 0;
	                        if (!C)break;
	                        if ((c[C + 4 >> 2] & -8 | 0) == (B | 0)) {
	                            G = C;
	                            break a
	                        } else {
	                            E = E << 1;
	                            A = C
	                        }
	                    }
	                    if (H >>> 0 < (c[82068] | 0) >>> 0)hb();
	                    c[H >> 2] = n;
	                    c[n + 24 >> 2] = A;
	                    c[n + 12 >> 2] = n;
	                    c[n + 8 >> 2] = n;
	                    i = d;
	                    return
	                } while (0);
	                H = G + 8 | 0;
	                B = c[H >> 2] | 0;
	                w = c[82068] | 0;
	                if (!(G >>> 0 >= w >>> 0 & B >>> 0 >= w >>> 0))hb();
	                c[B + 12 >> 2] = n;
	                c[H >> 2] = n;
	                c[n + 8 >> 2] = B;
	                c[n + 12 >> 2] = G;
	                c[n + 24 >> 2] = 0;
	                i = d;
	                return
	            }

	            function UT(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var e = 0, f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
	                e = i;
	                f = a + 4 | 0;
	                g = c[f >> 2] | 0;
	                h = a + 100 | 0;
	                if (g >>> 0 < (c[h >> 2] | 0) >>> 0) {
	                    c[f >> 2] = g + 1;
	                    j = d[g >> 0] | 0
	                } else j = qT(a) | 0;
	                if ((j | 0) == 43 | (j | 0) == 45) {
	                    g = c[f >> 2] | 0;
	                    k = (j | 0) == 45 & 1;
	                    if (g >>> 0 < (c[h >> 2] | 0) >>> 0) {
	                        c[f >> 2] = g + 1;
	                        l = d[g >> 0] | 0
	                    } else l = qT(a) | 0;
	                    if ((l + -48 | 0) >>> 0 > 9 & (b | 0) != 0 ? (c[h >> 2] | 0) != 0 : 0) {
	                        c[f >> 2] = (c[f >> 2] | 0) + -1;
	                        m = l;
	                        n = k
	                    } else {
	                        m = l;
	                        n = k
	                    }
	                } else {
	                    m = j;
	                    n = 0
	                }
	                if ((m + -48 | 0) >>> 0 > 9) {
	                    if (!(c[h >> 2] | 0)) {
	                        o = -2147483648;
	                        p = 0;
	                        G = o;
	                        i = e;
	                        return p | 0
	                    }
	                    c[f >> 2] = (c[f >> 2] | 0) + -1;
	                    o = -2147483648;
	                    p = 0;
	                    G = o;
	                    i = e;
	                    return p | 0
	                } else {
	                    q = m;
	                    r = 0
	                }
	                while (1) {
	                    r = q + -48 + (r * 10 | 0) | 0;
	                    m = c[f >> 2] | 0;
	                    if (m >>> 0 < (c[h >> 2] | 0) >>> 0) {
	                        c[f >> 2] = m + 1;
	                        s = d[m >> 0] | 0
	                    } else s = qT(a) | 0;
	                    if (!((s + -48 | 0) >>> 0 < 10 & (r | 0) < 214748364))break; else q = s
	                }
	                q = ((r | 0) < 0) << 31 >> 31;
	                if ((s + -48 | 0) >>> 0 < 10) {
	                    m = r;
	                    j = q;
	                    k = s;
	                    while (1) {
	                        l = mU(m | 0, j | 0, 10, 0) | 0;
	                        b = G;
	                        g = bU(k | 0, ((k | 0) < 0) << 31 >> 31 | 0, -48, -1) | 0;
	                        t = bU(g | 0, G | 0, l | 0, b | 0) | 0;
	                        b = G;
	                        l = c[f >> 2] | 0;
	                        if (l >>> 0 < (c[h >> 2] | 0) >>> 0) {
	                            c[f >> 2] = l + 1;
	                            u = d[l >> 0] | 0
	                        } else u = qT(a) | 0;
	                        if ((u + -48 | 0) >>> 0 < 10 & ((b | 0) < 21474836 | (b | 0) == 21474836 & t >>> 0 < 2061584302)) {
	                            m = t;
	                            j = b;
	                            k = u
	                        } else {
	                            v = t;
	                            w = b;
	                            x = u;
	                            break
	                        }
	                    }
	                } else {
	                    v = r;
	                    w = q;
	                    x = s
	                }
	                if ((x + -48 | 0) >>> 0 < 10)do {
	                    x = c[f >> 2] | 0;
	                    if (x >>> 0 < (c[h >> 2] | 0) >>> 0) {
	                        c[f >> 2] = x + 1;
	                        y = d[x >> 0] | 0
	                    } else y = qT(a) | 0
	                } while ((y + -48 | 0) >>> 0 < 10);
	                if (c[h >> 2] | 0)c[f >> 2] = (c[f >> 2] | 0) + -1;
	                f = (n | 0) != 0;
	                n = XT(0, 0, v | 0, w | 0) | 0;
	                o = f ? G : w;
	                p = f ? n : v;
	                G = o;
	                i = e;
	                return p | 0
	            }

	            function VT(e, f, g, j, l) {
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                j = j | 0;
	                l = l | 0;
	                var m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0, Ca = 0, Da = 0, Ea = 0, Fa = 0, Ga = 0, Ha = 0, Ia = 0, Ja = 0, Ka = 0, La = 0.0, Ma = 0, Na = 0, Oa = 0, Pa = 0, Qa = 0, Ra = 0.0, Sa = 0, Ta = 0, Ua = 0, Va = 0, Wa = 0, Xa = 0, Ya = 0, Za = 0, $a = 0, ab = 0, bb = 0, cb = 0, db = 0, eb = 0.0, fb = 0.0, gb = 0, hb = 0, ib = 0, jb = 0, kb = 0, mb = 0.0, nb = 0, ob = 0, pb = 0, qb = 0, rb = 0, sb = 0, tb = 0, ub = 0, vb = 0, wb = 0, xb = 0.0, yb = 0, zb = 0, Ab = 0, Bb = 0, Cb = 0, Db = 0, Eb = 0, Fb = 0, Gb = 0, Hb = 0, Ib = 0, Jb = 0, Kb = 0, Lb = 0, Mb = 0, Nb = 0, Ob = 0, Pb = 0, Qb = 0, Rb = 0, Sb = 0, Tb = 0, Ub = 0, Vb = 0, Wb = 0, Xb = 0, Yb = 0, Zb = 0, _b = 0, $b = 0, ac = 0.0, bc = 0.0, cc = 0.0, dc = 0, ec = 0, fc = 0, gc = 0, hc = 0, ic = 0, jc = 0, kc = 0, lc = 0, mc = 0, nc = 0, oc = 0, pc = 0, qc = 0, rc = 0, sc = 0, tc = 0, uc = 0, vc = 0, wc = 0, xc = 0, yc = 0, zc = 0, Ac = 0, Bc = 0, Cc = 0, Dc = 0, Ec = 0, Fc = 0, Gc = 0, Hc = 0, Ic = 0, Jc = 0, Kc = 0, Lc = 0, Mc = 0, Nc = 0, Oc = 0, Pc = 0, Qc = 0, Rc = 0, Sc = 0, Tc = 0, Uc = 0, Vc = 0, Wc = 0, Xc = 0, Yc = 0, Zc = 0, _c = 0, $c = 0, ad = 0, bd = 0, cd = 0, dd = 0, ed = 0, fd = 0, gd = 0, hd = 0, id = 0, jd = 0, kd = 0, ld = 0, md = 0, nd = 0, od = 0, pd = 0, qd = 0, rd = 0, sd = 0, td = 0, ud = 0, vd = 0, wd = 0;
	                m = i;
	                i = i + 864 | 0;
	                n = m + 16 | 0;
	                o = m + 8 | 0;
	                p = m + 836 | 0;
	                q = p;
	                r = m + 824 | 0;
	                s = m + 568 | 0;
	                t = m + 528 | 0;
	                u = m;
	                v = m + 520 | 0;
	                w = (e | 0) != 0;
	                x = t + 40 | 0;
	                y = x;
	                z = t + 39 | 0;
	                t = u + 4 | 0;
	                A = u;
	                B = r + 12 | 0;
	                C = r + 11 | 0;
	                r = B;
	                D = r - q | 0;
	                E = -2 - q | 0;
	                F = r + 2 | 0;
	                H = n + 288 | 0;
	                I = p + 9 | 0;
	                J = I;
	                K = p + 8 | 0;
	                L = 0;
	                M = 0;
	                N = f;
	                f = 0;
	                O = 0;
	                P = 0;
	                a:while (1) {
	                    do if ((f | 0) > -1)if ((O | 0) > (2147483647 - f | 0)) {
	                        c[(_a() | 0) >> 2] = 75;
	                        Q = -1;
	                        break
	                    } else {
	                        Q = O + f | 0;
	                        break
	                    } else Q = f; while (0);
	                    R = a[N >> 0] | 0;
	                    if (!(R << 24 >> 24)) {
	                        S = 352;
	                        break
	                    } else {
	                        T = R;
	                        U = N
	                    }
	                    while (1) {
	                        if (T << 24 >> 24 == 37) {
	                            V = U;
	                            W = U;
	                            S = 9;
	                            break
	                        } else if (!(T << 24 >> 24)) {
	                            X = U;
	                            Y = U;
	                            break
	                        }
	                        R = U + 1 | 0;
	                        T = a[R >> 0] | 0;
	                        U = R
	                    }
	                    b:do if ((S | 0) == 9)while (1) {
	                        S = 0;
	                        if ((a[V + 1 >> 0] | 0) != 37) {
	                            X = V;
	                            Y = W;
	                            break b
	                        }
	                        R = W + 1 | 0;
	                        Z = V + 2 | 0;
	                        if ((a[Z >> 0] | 0) == 37) {
	                            V = Z;
	                            W = R;
	                            S = 9
	                        } else {
	                            X = Z;
	                            Y = R;
	                            break
	                        }
	                    } while (0);
	                    R = Y - N | 0;
	                    if (w)IT(N, R, e) | 0;
	                    if ((Y | 0) != (N | 0)) {
	                        N = X;
	                        f = Q;
	                        O = R;
	                        continue
	                    }
	                    Z = X + 1 | 0;
	                    _ = a[Z >> 0] | 0;
	                    $ = (_ << 24 >> 24) + -48 | 0;
	                    if ($ >>> 0 < 10 ? (a[X + 2 >> 0] | 0) == 36 : 0) {
	                        aa = X + 3 | 0;
	                        ba = a[aa >> 0] | 0;
	                        da = $;
	                        ea = 1;
	                        fa = aa
	                    } else {
	                        ba = _;
	                        da = -1;
	                        ea = P;
	                        fa = Z
	                    }
	                    Z = ba << 24 >> 24;
	                    c:do if ((Z & -32 | 0) == 32) {
	                        _ = ba;
	                        aa = Z;
	                        $ = 0;
	                        ga = fa;
	                        while (1) {
	                            ha = 1 << aa + -32;
	                            if (!(ha & 75913)) {
	                                ia = _;
	                                ja = $;
	                                ka = ga;
	                                break c
	                            }
	                            la = ha | $;
	                            ha = ga + 1 | 0;
	                            ma = a[ha >> 0] | 0;
	                            aa = ma << 24 >> 24;
	                            if ((aa & -32 | 0) != 32) {
	                                ia = ma;
	                                ja = la;
	                                ka = ha;
	                                break
	                            } else {
	                                _ = ma;
	                                $ = la;
	                                ga = ha
	                            }
	                        }
	                    } else {
	                        ia = ba;
	                        ja = 0;
	                        ka = fa
	                    } while (0);
	                    do if (ia << 24 >> 24 == 42) {
	                        Z = ka + 1 | 0;
	                        ga = (a[Z >> 0] | 0) + -48 | 0;
	                        if (ga >>> 0 < 10 ? (a[ka + 2 >> 0] | 0) == 36 : 0) {
	                            c[l + (ga << 2) >> 2] = 10;
	                            na = 1;
	                            oa = ka + 3 | 0;
	                            pa = c[j + ((a[Z >> 0] | 0) + -48 << 3) >> 2] | 0
	                        } else {
	                            if (ea) {
	                                qa = -1;
	                                S = 370;
	                                break a
	                            }
	                            if (!w) {
	                                ra = Z;
	                                sa = ja;
	                                ta = 0;
	                                ua = 0;
	                                break
	                            }
	                            ga = c[g >> 2] | 0;
	                            $ = c[ga >> 2] | 0;
	                            c[g >> 2] = ga + 4;
	                            na = 0;
	                            oa = Z;
	                            pa = $
	                        }
	                        if ((pa | 0) < 0) {
	                            ra = oa;
	                            sa = ja | 8192;
	                            ta = na;
	                            ua = 0 - pa | 0
	                        } else {
	                            ra = oa;
	                            sa = ja;
	                            ta = na;
	                            ua = pa
	                        }
	                    } else {
	                        $ = ia << 24 >> 24;
	                        if (($ + -48 | 0) >>> 0 < 10) {
	                            Z = $;
	                            $ = ka;
	                            ga = 0;
	                            do {
	                                ga = Z + -48 + (ga * 10 | 0) | 0;
	                                $ = $ + 1 | 0;
	                                Z = a[$ >> 0] | 0
	                            } while ((Z + -48 | 0) >>> 0 < 10);
	                            if ((ga | 0) < 0) {
	                                qa = -1;
	                                S = 370;
	                                break a
	                            } else {
	                                ra = $;
	                                sa = ja;
	                                ta = ea;
	                                ua = ga
	                            }
	                        } else {
	                            ra = ka;
	                            sa = ja;
	                            ta = ea;
	                            ua = 0
	                        }
	                    } while (0);
	                    d:do if ((a[ra >> 0] | 0) == 46) {
	                        Z = ra + 1 | 0;
	                        _ = a[Z >> 0] | 0;
	                        if (_ << 24 >> 24 != 42) {
	                            aa = _ << 24 >> 24;
	                            if ((aa + -48 | 0) >>> 0 < 10) {
	                                va = aa;
	                                wa = Z;
	                                xa = 0
	                            } else {
	                                ya = Z;
	                                za = 0;
	                                break
	                            }
	                            while (1) {
	                                Z = va + -48 + (xa * 10 | 0) | 0;
	                                aa = wa + 1 | 0;
	                                va = a[aa >> 0] | 0;
	                                if ((va + -48 | 0) >>> 0 >= 10) {
	                                    ya = aa;
	                                    za = Z;
	                                    break d
	                                } else {
	                                    wa = aa;
	                                    xa = Z
	                                }
	                            }
	                        }
	                        ga = ra + 2 | 0;
	                        $ = (a[ga >> 0] | 0) + -48 | 0;
	                        if ($ >>> 0 < 10 ? (a[ra + 3 >> 0] | 0) == 36 : 0) {
	                            c[l + ($ << 2) >> 2] = 10;
	                            ya = ra + 4 | 0;
	                            za = c[j + ((a[ga >> 0] | 0) + -48 << 3) >> 2] | 0;
	                            break
	                        }
	                        if (ta) {
	                            qa = -1;
	                            S = 370;
	                            break a
	                        }
	                        if (w) {
	                            $ = c[g >> 2] | 0;
	                            Z = c[$ >> 2] | 0;
	                            c[g >> 2] = $ + 4;
	                            ya = ga;
	                            za = Z
	                        } else {
	                            ya = ga;
	                            za = 0
	                        }
	                    } else {
	                        ya = ra;
	                        za = -1
	                    } while (0);
	                    ga = ya;
	                    Z = 0;
	                    while (1) {
	                        Aa = a[ga >> 0] | 0;
	                        $ = (Aa << 24 >> 24) + -65 | 0;
	                        if ($ >>> 0 > 57) {
	                            qa = -1;
	                            S = 370;
	                            break a
	                        }
	                        Ba = ga + 1 | 0;
	                        Ca = a[329096 + (Z * 58 | 0) + $ >> 0] | 0;
	                        Da = Ca & 255;
	                        if ((Da + -1 | 0) >>> 0 < 8) {
	                            ga = Ba;
	                            Z = Da
	                        } else break
	                    }
	                    if (!(Ca << 24 >> 24)) {
	                        qa = -1;
	                        S = 370;
	                        break
	                    }
	                    $ = (da | 0) > -1;
	                    e:do if (Ca << 24 >> 24 == 19)if ($) {
	                        qa = -1;
	                        S = 370;
	                        break a
	                    } else {
	                        Ea = L;
	                        Fa = M;
	                        S = 63
	                    } else {
	                        if ($) {
	                            c[l + (da << 2) >> 2] = Da;
	                            aa = j + (da << 3) | 0;
	                            Ea = c[aa >> 2] | 0;
	                            Fa = c[aa + 4 >> 2] | 0;
	                            S = 63;
	                            break
	                        }
	                        if (!w) {
	                            qa = 0;
	                            S = 370;
	                            break a
	                        }
	                        if ((Ca & 255) > 20) {
	                            Ga = Aa;
	                            Ha = L;
	                            Ia = M
	                        } else do switch (Da | 0) {
	                            case 16:
	                            {
	                                aa = c[g >> 2] | 0;
	                                _ = c[aa >> 2] | 0;
	                                c[g >> 2] = aa + 4;
	                                Ja = 0;
	                                Ka = _ & 255;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 11:
	                            {
	                                _ = c[g >> 2] | 0;
	                                aa = c[_ >> 2] | 0;
	                                c[g >> 2] = _ + 4;
	                                Ja = 0;
	                                Ka = aa;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 12:
	                            {
	                                aa = c[g >> 2] | 0;
	                                _ = aa;
	                                ha = c[_ >> 2] | 0;
	                                la = c[_ + 4 >> 2] | 0;
	                                c[g >> 2] = aa + 8;
	                                Ja = la;
	                                Ka = ha;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 14:
	                            {
	                                ha = c[g >> 2] | 0;
	                                la = c[ha >> 2] | 0;
	                                c[g >> 2] = ha + 4;
	                                Ja = 0;
	                                Ka = la & 65535;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 13:
	                            {
	                                la = c[g >> 2] | 0;
	                                ha = c[la >> 2] | 0;
	                                c[g >> 2] = la + 4;
	                                Ja = (((ha & 65535) << 16 >> 16 | 0) < 0) << 31 >> 31;
	                                Ka = ha << 16 >> 16;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 17:
	                            {
	                                ha = c[g >> 2] | 0;
	                                c[k >> 2] = c[ha >> 2];
	                                c[k + 4 >> 2] = c[ha + 4 >> 2];
	                                La = +h[k >> 3];
	                                c[g >> 2] = ha + 8;
	                                h[k >> 3] = La;
	                                Ja = c[k + 4 >> 2] | 0;
	                                Ka = c[k >> 2] | 0;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 10:
	                            {
	                                ha = c[g >> 2] | 0;
	                                la = c[ha >> 2] | 0;
	                                c[g >> 2] = ha + 4;
	                                Ja = ((la | 0) < 0) << 31 >> 31;
	                                Ka = la;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 15:
	                            {
	                                la = c[g >> 2] | 0;
	                                ha = c[la >> 2] | 0;
	                                c[g >> 2] = la + 4;
	                                Ja = (((ha & 255) << 24 >> 24 | 0) < 0) << 31 >> 31;
	                                Ka = ha << 24 >> 24;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            case 18:
	                            {
	                                ha = c[g >> 2] | 0;
	                                c[k >> 2] = c[ha >> 2];
	                                c[k + 4 >> 2] = c[ha + 4 >> 2];
	                                La = +h[k >> 3];
	                                c[g >> 2] = ha + 8;
	                                h[k >> 3] = La;
	                                Ea = c[k >> 2] | 0;
	                                Fa = c[k + 4 >> 2] | 0;
	                                S = 63;
	                                break e;
	                                break
	                            }
	                            case 9:
	                            {
	                                ha = c[g >> 2] | 0;
	                                la = c[ha >> 2] | 0;
	                                c[g >> 2] = ha + 4;
	                                Ja = M;
	                                Ka = la;
	                                S = 64;
	                                break e;
	                                break
	                            }
	                            default:
	                            {
	                                Ja = M;
	                                Ka = L;
	                                S = 64;
	                                break e
	                            }
	                        } while (0)
	                    } while (0);
	                    if ((S | 0) == 63) {
	                        S = 0;
	                        if (w) {
	                            Ja = Fa;
	                            Ka = Ea;
	                            S = 64
	                        } else {
	                            L = Ea;
	                            M = Fa;
	                            N = Ba;
	                            f = Q;
	                            O = R;
	                            P = ta;
	                            continue
	                        }
	                    }
	                    if ((S | 0) == 64) {
	                        S = 0;
	                        Ga = a[ga >> 0] | 0;
	                        Ha = Ka;
	                        Ia = Ja
	                    }
	                    $ = Ga << 24 >> 24;
	                    la = (Z | 0) != 0 & ($ & 15 | 0) == 3 ? $ & -33 : $;
	                    $ = sa & -65537;
	                    ha = (sa & 8192 | 0) == 0 ? sa : $;
	                    f:do switch (la | 0) {
	                        case 110:
	                        {
	                            switch (Z | 0) {
	                                case 7:
	                                {
	                                    aa = Ha;
	                                    c[aa >> 2] = Q;
	                                    c[aa + 4 >> 2] = ((Q | 0) < 0) << 31 >> 31;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                case 3:
	                                {
	                                    b[Ha >> 1] = Q;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                case 4:
	                                {
	                                    a[Ha >> 0] = Q;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                case 6:
	                                {
	                                    c[Ha >> 2] = Q;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                case 1:
	                                {
	                                    c[Ha >> 2] = Q;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                case 0:
	                                {
	                                    c[Ha >> 2] = Q;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                case 2:
	                                {
	                                    aa = Ha;
	                                    c[aa >> 2] = Q;
	                                    c[aa + 4 >> 2] = ((Q | 0) < 0) << 31 >> 31;
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a;
	                                    break
	                                }
	                                default:
	                                {
	                                    L = Ha;
	                                    M = Ia;
	                                    N = Ba;
	                                    f = Q;
	                                    O = R;
	                                    P = ta;
	                                    continue a
	                                }
	                            }
	                            break
	                        }
	                        case 109:
	                        {
	                            Ma = lb(c[(_a() | 0) >> 2] | 0) | 0;
	                            S = 96;
	                            break
	                        }
	                        case 105:
	                        case 100:
	                        {
	                            if ((Ia | 0) < 0) {
	                                aa = XT(0, 0, Ha | 0, Ia | 0) | 0;
	                                Na = G;
	                                Oa = aa;
	                                Pa = 1;
	                                Qa = 329560;
	                                S = 86;
	                                break f
	                            }
	                            if (!(ha & 2048)) {
	                                aa = ha & 1;
	                                Na = Ia;
	                                Oa = Ha;
	                                Pa = aa;
	                                Qa = (aa | 0) == 0 ? 329560 : 329562;
	                                S = 86
	                            } else {
	                                Na = Ia;
	                                Oa = Ha;
	                                Pa = 1;
	                                Qa = 329561;
	                                S = 86
	                            }
	                            break
	                        }
	                        case 65:
	                        case 71:
	                        case 70:
	                        case 69:
	                        case 97:
	                        case 103:
	                        case 102:
	                        case 101:
	                        {
	                            c[k >> 2] = Ha;
	                            c[k + 4 >> 2] = Ia;
	                            La = +h[k >> 3];
	                            c[o >> 2] = 0;
	                            if ((Ia | 0) >= 0)if (!(ha & 2048)) {
	                                aa = ha & 1;
	                                Ra = La;
	                                Sa = aa;
	                                Ta = (aa | 0) == 0 ? 329585 : 329590
	                            } else {
	                                Ra = La;
	                                Sa = 1;
	                                Ta = 329587
	                            } else {
	                                Ra = -La;
	                                Sa = 1;
	                                Ta = 329584
	                            }
	                            h[k >> 3] = Ra;
	                            aa = c[k + 4 >> 2] & 2146435072;
	                            if (!(aa >>> 0 < 2146435072 | (aa | 0) == 2146435072 & 0 < 0)) {
	                                aa = (la & 32 | 0) != 0;
	                                if (Ra != Ra | 0.0 != 0.0) {
	                                    Ua = 0;
	                                    Va = aa ? 329624 : 329632
	                                } else {
	                                    Ua = Sa;
	                                    Va = aa ? 329608 : 329616
	                                }
	                                aa = Ua + 3 | 0;
	                                _ = (ua | 0) > (aa | 0);
	                                if ((ha & 8192 | 0) == 0 & _) {
	                                    ma = ua - aa | 0;
	                                    cU(s | 0, 32, (ma >>> 0 > 256 ? 256 : ma) | 0) | 0;
	                                    if (ma >>> 0 > 255) {
	                                        Wa = ma;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            Wa = Wa + -256 | 0
	                                        } while (Wa >>> 0 > 255);
	                                        Xa = ma & 255
	                                    } else Xa = ma;
	                                    IT(s, Xa, e) | 0
	                                }
	                                IT(Ta, Ua, e) | 0;
	                                IT(Va, 3, e) | 0;
	                                if ((ha & 73728 | 0) == 8192 & _) {
	                                    Wa = ua - aa | 0;
	                                    cU(s | 0, 32, (Wa >>> 0 > 256 ? 256 : Wa) | 0) | 0;
	                                    if (Wa >>> 0 > 255) {
	                                        Ya = Wa;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            Ya = Ya + -256 | 0
	                                        } while (Ya >>> 0 > 255);
	                                        Za = Wa & 255
	                                    } else Za = Wa;
	                                    IT(s, Za, e) | 0
	                                }
	                                L = Ha;
	                                M = Ia;
	                                N = Ba;
	                                f = Q;
	                                O = _ ? ua : aa;
	                                P = ta;
	                                continue a
	                            }
	                            La = +xT(Ra, o) * 2.0;
	                            Ya = La != 0.0;
	                            if (Ya)c[o >> 2] = (c[o >> 2] | 0) + -1;
	                            ma = la | 32;
	                            if ((ma | 0) == 97) {
	                                $a = la & 32;
	                                ab = ($a | 0) == 0 ? Ta : Ta + 9 | 0;
	                                bb = Sa | 2;
	                                cb = za >>> 0 > 11 ? 0 : 12 - za | 0;
	                                do if (cb) {
	                                    db = cb;
	                                    eb = 8.0;
	                                    do {
	                                        db = db + -1 | 0;
	                                        eb = eb * 16.0
	                                    } while ((db | 0) != 0);
	                                    if ((a[ab >> 0] | 0) == 45) {
	                                        fb = -(eb + (-La - eb));
	                                        break
	                                    } else {
	                                        fb = La + eb - eb;
	                                        break
	                                    }
	                                } else fb = La; while (0);
	                                cb = c[o >> 2] | 0;
	                                aa = (cb | 0) < 0 ? 0 - cb | 0 : cb;
	                                if ((aa | 0) < 0) {
	                                    cb = B;
	                                    _ = aa;
	                                    Wa = ((aa | 0) < 0) << 31 >> 31;
	                                    while (1) {
	                                        db = oU(_ | 0, Wa | 0, 10, 0) | 0;
	                                        cb = cb + -1 | 0;
	                                        a[cb >> 0] = db | 48;
	                                        db = _;
	                                        _ = nU(_ | 0, Wa | 0, 10, 0) | 0;
	                                        if (!(Wa >>> 0 > 9 | (Wa | 0) == 9 & db >>> 0 > 4294967295))break; else Wa = G
	                                    }
	                                    gb = cb;
	                                    hb = _
	                                } else {
	                                    gb = B;
	                                    hb = aa
	                                }
	                                if (!hb)ib = gb; else {
	                                    Wa = gb;
	                                    db = hb;
	                                    while (1) {
	                                        jb = Wa + -1 | 0;
	                                        a[jb >> 0] = (db >>> 0) % 10 | 0 | 48;
	                                        if (db >>> 0 < 10) {
	                                            ib = jb;
	                                            break
	                                        } else {
	                                            Wa = jb;
	                                            db = (db >>> 0) / 10 | 0
	                                        }
	                                    }
	                                }
	                                if ((ib | 0) == (B | 0)) {
	                                    a[C >> 0] = 48;
	                                    kb = C
	                                } else kb = ib;
	                                a[kb + -1 >> 0] = (c[o >> 2] >> 31 & 2) + 43;
	                                db = kb + -2 | 0;
	                                a[db >> 0] = la + 15;
	                                if ((za | 0) < 1)if (!(ha & 8)) {
	                                    mb = fb;
	                                    Wa = p;
	                                    while (1) {
	                                        aa = ~~mb;
	                                        _ = Wa + 1 | 0;
	                                        a[Wa >> 0] = d[329640 + aa >> 0] | $a;
	                                        mb = (mb - +(aa | 0)) * 16.0;
	                                        if ((_ - q | 0) != 1 | mb == 0.0)nb = _; else {
	                                            a[_ >> 0] = 46;
	                                            nb = Wa + 2 | 0
	                                        }
	                                        if (!(mb != 0.0)) {
	                                            ob = nb;
	                                            break
	                                        } else Wa = nb
	                                    }
	                                } else {
	                                    mb = fb;
	                                    Wa = p;
	                                    while (1) {
	                                        _ = ~~mb;
	                                        aa = Wa + 1 | 0;
	                                        a[Wa >> 0] = d[329640 + _ >> 0] | $a;
	                                        mb = (mb - +(_ | 0)) * 16.0;
	                                        if ((aa - q | 0) == 1) {
	                                            a[aa >> 0] = 46;
	                                            pb = Wa + 2 | 0
	                                        } else pb = aa;
	                                        if (!(mb != 0.0)) {
	                                            ob = pb;
	                                            break
	                                        } else Wa = pb
	                                    }
	                                } else {
	                                    mb = fb;
	                                    Wa = p;
	                                    while (1) {
	                                        aa = ~~mb;
	                                        _ = Wa + 1 | 0;
	                                        a[Wa >> 0] = d[329640 + aa >> 0] | $a;
	                                        mb = (mb - +(aa | 0)) * 16.0;
	                                        if ((_ - q | 0) == 1) {
	                                            a[_ >> 0] = 46;
	                                            qb = Wa + 2 | 0
	                                        } else qb = _;
	                                        if (!(mb != 0.0)) {
	                                            ob = qb;
	                                            break
	                                        } else Wa = qb
	                                    }
	                                }
	                                Wa = ob;
	                                $a = db;
	                                if ((za | 0) != 0 & (E + Wa | 0) < (za | 0))rb = F + za - $a | 0; else rb = D - $a + Wa | 0;
	                                $a = rb + bb | 0;
	                                _ = ha & 73728;
	                                aa = (ua | 0) > ($a | 0);
	                                if ((_ | 0) == 0 & aa) {
	                                    cb = ua - $a | 0;
	                                    cU(s | 0, 32, (cb >>> 0 > 256 ? 256 : cb) | 0) | 0;
	                                    if (cb >>> 0 > 255) {
	                                        jb = cb;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            jb = jb + -256 | 0
	                                        } while (jb >>> 0 > 255);
	                                        sb = cb & 255
	                                    } else sb = cb;
	                                    IT(s, sb, e) | 0
	                                }
	                                IT(ab, bb, e) | 0;
	                                if ((_ | 0) == 65536 & aa) {
	                                    jb = ua - $a | 0;
	                                    cU(s | 0, 48, (jb >>> 0 > 256 ? 256 : jb) | 0) | 0;
	                                    if (jb >>> 0 > 255) {
	                                        tb = jb;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            tb = tb + -256 | 0
	                                        } while (tb >>> 0 > 255);
	                                        ub = jb & 255
	                                    } else ub = jb;
	                                    IT(s, ub, e) | 0
	                                }
	                                tb = Wa - q | 0;
	                                IT(p, tb, e) | 0;
	                                bb = r - db | 0;
	                                ab = rb - bb - tb | 0;
	                                if ((ab | 0) > 0) {
	                                    cU(s | 0, 48, (ab >>> 0 > 256 ? 256 : ab) | 0) | 0;
	                                    if (ab >>> 0 > 255) {
	                                        tb = ab;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            tb = tb + -256 | 0
	                                        } while (tb >>> 0 > 255);
	                                        vb = ab & 255
	                                    } else vb = ab;
	                                    IT(s, vb, e) | 0
	                                }
	                                IT(db, bb, e) | 0;
	                                if ((_ | 0) == 8192 & aa) {
	                                    tb = ua - $a | 0;
	                                    cU(s | 0, 32, (tb >>> 0 > 256 ? 256 : tb) | 0) | 0;
	                                    if (tb >>> 0 > 255) {
	                                        Wa = tb;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            Wa = Wa + -256 | 0
	                                        } while (Wa >>> 0 > 255);
	                                        wb = tb & 255
	                                    } else wb = tb;
	                                    IT(s, wb, e) | 0
	                                }
	                                L = Ha;
	                                M = Ia;
	                                N = Ba;
	                                f = Q;
	                                O = aa ? ua : $a;
	                                P = ta;
	                                continue a
	                            }
	                            Wa = (za | 0) < 0 ? 6 : za;
	                            if (Ya) {
	                                _ = (c[o >> 2] | 0) + -28 | 0;
	                                c[o >> 2] = _;
	                                xb = La * 268435456.0;
	                                yb = _
	                            } else {
	                                xb = La;
	                                yb = c[o >> 2] | 0
	                            }
	                            _ = (yb | 0) < 0 ? n : H;
	                            bb = _;
	                            mb = xb;
	                            db = _;
	                            do {
	                                ab = ~~mb >>> 0;
	                                c[db >> 2] = ab;
	                                db = db + 4 | 0;
	                                mb = (mb - +(ab >>> 0)) * 1.0e9
	                            } while (mb != 0.0);
	                            Ya = c[o >> 2] | 0;
	                            if ((Ya | 0) > 0) {
	                                $a = Ya;
	                                aa = _;
	                                tb = db;
	                                while (1) {
	                                    ab = ($a | 0) > 29 ? 29 : $a;
	                                    jb = tb + -4 | 0;
	                                    do if (jb >>> 0 < aa >>> 0)zb = aa; else {
	                                        cb = 0;
	                                        Ab = jb;
	                                        do {
	                                            Bb = $T(c[Ab >> 2] | 0, 0, ab | 0) | 0;
	                                            Cb = bU(Bb | 0, G | 0, cb | 0, 0) | 0;
	                                            Bb = G;
	                                            Db = oU(Cb | 0, Bb | 0, 1e9, 0) | 0;
	                                            c[Ab >> 2] = Db;
	                                            cb = nU(Cb | 0, Bb | 0, 1e9, 0) | 0;
	                                            Ab = Ab + -4 | 0
	                                        } while (Ab >>> 0 >= aa >>> 0);
	                                        if (!cb) {
	                                            zb = aa;
	                                            break
	                                        }
	                                        Ab = aa + -4 | 0;
	                                        c[Ab >> 2] = cb;
	                                        zb = Ab
	                                    } while (0);
	                                    jb = tb;
	                                    while (1) {
	                                        if (jb >>> 0 <= zb >>> 0)break;
	                                        Ab = jb + -4 | 0;
	                                        if (!(c[Ab >> 2] | 0))jb = Ab; else break
	                                    }
	                                    Ab = (c[o >> 2] | 0) - ab | 0;
	                                    c[o >> 2] = Ab;
	                                    if ((Ab | 0) > 0) {
	                                        $a = Ab;
	                                        aa = zb;
	                                        tb = jb
	                                    } else {
	                                        Eb = Ab;
	                                        Fb = zb;
	                                        Gb = jb;
	                                        break
	                                    }
	                                }
	                            } else {
	                                Eb = Ya;
	                                Fb = _;
	                                Gb = db
	                            }
	                            g:do if ((Eb | 0) < 0) {
	                                tb = ((Wa + 25 | 0) / 9 | 0) + 1 | 0;
	                                if ((ma | 0) == 102) {
	                                    aa = _ + (tb << 2) | 0;
	                                    $a = Eb;
	                                    Ab = Fb;
	                                    Bb = Gb;
	                                    while (1) {
	                                        Cb = 0 - $a | 0;
	                                        Db = (Cb | 0) > 9 ? 9 : Cb;
	                                        do if (Ab >>> 0 < Bb >>> 0) {
	                                            Cb = (1 << Db) + -1 | 0;
	                                            Hb = 1e9 >>> Db;
	                                            Ib = 0;
	                                            Jb = Ab;
	                                            do {
	                                                Kb = c[Jb >> 2] | 0;
	                                                c[Jb >> 2] = (Kb >>> Db) + Ib;
	                                                Ib = ca(Kb & Cb, Hb) | 0;
	                                                Jb = Jb + 4 | 0
	                                            } while (Jb >>> 0 < Bb >>> 0);
	                                            Jb = (c[Ab >> 2] | 0) == 0 ? Ab + 4 | 0 : Ab;
	                                            if (!Ib) {
	                                                Lb = Jb;
	                                                Mb = Bb;
	                                                break
	                                            }
	                                            c[Bb >> 2] = Ib;
	                                            Lb = Jb;
	                                            Mb = Bb + 4 | 0
	                                        } else {
	                                            Lb = (c[Ab >> 2] | 0) == 0 ? Ab + 4 | 0 : Ab;
	                                            Mb = Bb
	                                        } while (0);
	                                        cb = (Mb - bb >> 2 | 0) > (tb | 0) ? aa : Mb;
	                                        $a = (c[o >> 2] | 0) + Db | 0;
	                                        c[o >> 2] = $a;
	                                        if (($a | 0) >= 0) {
	                                            Nb = Lb;
	                                            Ob = cb;
	                                            break g
	                                        } else {
	                                            Ab = Lb;
	                                            Bb = cb
	                                        }
	                                    }
	                                } else {
	                                    Pb = Eb;
	                                    Qb = Fb;
	                                    Rb = Gb
	                                }
	                                while (1) {
	                                    Bb = 0 - Pb | 0;
	                                    Ab = (Bb | 0) > 9 ? 9 : Bb;
	                                    do if (Qb >>> 0 < Rb >>> 0) {
	                                        Bb = (1 << Ab) + -1 | 0;
	                                        $a = 1e9 >>> Ab;
	                                        aa = 0;
	                                        jb = Qb;
	                                        do {
	                                            ab = c[jb >> 2] | 0;
	                                            c[jb >> 2] = (ab >>> Ab) + aa;
	                                            aa = ca(ab & Bb, $a) | 0;
	                                            jb = jb + 4 | 0
	                                        } while (jb >>> 0 < Rb >>> 0);
	                                        jb = (c[Qb >> 2] | 0) == 0 ? Qb + 4 | 0 : Qb;
	                                        if (!aa) {
	                                            Sb = jb;
	                                            Tb = Rb;
	                                            break
	                                        }
	                                        c[Rb >> 2] = aa;
	                                        Sb = jb;
	                                        Tb = Rb + 4 | 0
	                                    } else {
	                                        Sb = (c[Qb >> 2] | 0) == 0 ? Qb + 4 | 0 : Qb;
	                                        Tb = Rb
	                                    } while (0);
	                                    if ((Tb - Sb >> 2 | 0) > (tb | 0))Ub = Sb + (tb << 2) | 0; else Ub = Tb;
	                                    Pb = (c[o >> 2] | 0) + Ab | 0;
	                                    c[o >> 2] = Pb;
	                                    if ((Pb | 0) >= 0) {
	                                        Nb = Sb;
	                                        Ob = Ub;
	                                        break
	                                    } else {
	                                        Qb = Sb;
	                                        Rb = Ub
	                                    }
	                                }
	                            } else {
	                                Nb = Fb;
	                                Ob = Gb
	                            } while (0);
	                            do if (Nb >>> 0 < Ob >>> 0) {
	                                db = (bb - Nb >> 2) * 9 | 0;
	                                Ya = c[Nb >> 2] | 0;
	                                if (Ya >>> 0 < 10) {
	                                    Vb = db;
	                                    break
	                                } else {
	                                    Wb = db;
	                                    Xb = 10
	                                }
	                                while (1) {
	                                    Xb = Xb * 10 | 0;
	                                    db = Wb + 1 | 0;
	                                    if (Ya >>> 0 < Xb >>> 0) {
	                                        Vb = db;
	                                        break
	                                    } else Wb = db
	                                }
	                            } else Vb = 0; while (0);
	                            Ya = (ma | 0) == 103;
	                            db = Wa - ((ma | 0) != 102 ? Vb : 0) + ((Ya & (Wa | 0) != 0) << 31 >> 31) | 0;
	                            if ((db | 0) < (((Ob - bb >> 2) * 9 | 0) + -9 | 0)) {
	                                tb = db + 9216 | 0;
	                                db = (tb | 0) / 9 | 0;
	                                Db = _ + (db + -1023 << 2) | 0;
	                                jb = ((tb | 0) % 9 | 0) + 1 | 0;
	                                if ((jb | 0) < 9) {
	                                    tb = 10;
	                                    $a = jb;
	                                    while (1) {
	                                        jb = tb * 10 | 0;
	                                        $a = $a + 1 | 0;
	                                        if (($a | 0) == 9) {
	                                            Yb = jb;
	                                            break
	                                        } else tb = jb
	                                    }
	                                } else Yb = 10;
	                                tb = c[Db >> 2] | 0;
	                                $a = (tb >>> 0) % (Yb >>> 0) | 0;
	                                if (($a | 0) == 0 ? (_ + (db + -1022 << 2) | 0) == (Ob | 0) : 0) {
	                                    Zb = Nb;
	                                    _b = Db;
	                                    $b = Vb
	                                } else S = 232;
	                                do if ((S | 0) == 232) {
	                                    S = 0;
	                                    eb = (((tb >>> 0) / (Yb >>> 0) | 0) & 1 | 0) == 0 ? 9007199254740992.0 : 9007199254740994.0;
	                                    ma = (Yb | 0) / 2 | 0;
	                                    do if ($a >>> 0 < ma >>> 0)ac = .5; else {
	                                        if (($a | 0) == (ma | 0) ? (_ + (db + -1022 << 2) | 0) == (Ob | 0) : 0) {
	                                            ac = 1.0;
	                                            break
	                                        }
	                                        ac = 1.5
	                                    } while (0);
	                                    do if (!Sa) {
	                                        bc = eb;
	                                        cc = ac
	                                    } else {
	                                        if ((a[Ta >> 0] | 0) != 45) {
	                                            bc = eb;
	                                            cc = ac;
	                                            break
	                                        }
	                                        bc = eb * -1.0;
	                                        cc = ac * -1.0
	                                    } while (0);
	                                    ma = tb - $a | 0;
	                                    c[Db >> 2] = ma;
	                                    if (!(bc + cc != bc)) {
	                                        Zb = Nb;
	                                        _b = Db;
	                                        $b = Vb;
	                                        break
	                                    }
	                                    jb = ma + Yb | 0;
	                                    c[Db >> 2] = jb;
	                                    if (jb >>> 0 > 999999999) {
	                                        jb = Nb;
	                                        ma = Db;
	                                        while (1) {
	                                            Bb = ma + -4 | 0;
	                                            c[ma >> 2] = 0;
	                                            if (Bb >>> 0 < jb >>> 0) {
	                                                Ib = jb + -4 | 0;
	                                                c[Ib >> 2] = 0;
	                                                dc = Ib
	                                            } else dc = jb;
	                                            Ib = (c[Bb >> 2] | 0) + 1 | 0;
	                                            c[Bb >> 2] = Ib;
	                                            if (Ib >>> 0 > 999999999) {
	                                                jb = dc;
	                                                ma = Bb
	                                            } else {
	                                                ec = dc;
	                                                fc = Bb;
	                                                break
	                                            }
	                                        }
	                                    } else {
	                                        ec = Nb;
	                                        fc = Db
	                                    }
	                                    ma = (bb - ec >> 2) * 9 | 0;
	                                    jb = c[ec >> 2] | 0;
	                                    if (jb >>> 0 < 10) {
	                                        Zb = ec;
	                                        _b = fc;
	                                        $b = ma;
	                                        break
	                                    } else {
	                                        gc = ma;
	                                        hc = 10
	                                    }
	                                    while (1) {
	                                        hc = hc * 10 | 0;
	                                        ma = gc + 1 | 0;
	                                        if (jb >>> 0 < hc >>> 0) {
	                                            Zb = ec;
	                                            _b = fc;
	                                            $b = ma;
	                                            break
	                                        } else gc = ma
	                                    }
	                                } while (0);
	                                Db = _b + 4 | 0;
	                                ic = Zb;
	                                jc = $b;
	                                kc = Ob >>> 0 > Db >>> 0 ? Db : Ob
	                            } else {
	                                ic = Nb;
	                                jc = Vb;
	                                kc = Ob
	                            }
	                            Db = 0 - jc | 0;
	                            $a = kc;
	                            while (1) {
	                                if ($a >>> 0 <= ic >>> 0) {
	                                    lc = 0;
	                                    break
	                                }
	                                tb = $a + -4 | 0;
	                                if (!(c[tb >> 2] | 0))$a = tb; else {
	                                    lc = 1;
	                                    break
	                                }
	                            }
	                            do if (Ya) {
	                                tb = ((Wa | 0) == 0 & 1) + Wa | 0;
	                                if ((tb | 0) > (jc | 0) & (jc | 0) > -5) {
	                                    mc = la + -1 | 0;
	                                    nc = tb + -1 - jc | 0
	                                } else {
	                                    mc = la + -2 | 0;
	                                    nc = tb + -1 | 0
	                                }
	                                if (ha & 8) {
	                                    oc = mc;
	                                    pc = nc;
	                                    break
	                                }
	                                do if (lc) {
	                                    tb = c[$a + -4 >> 2] | 0;
	                                    if (!tb) {
	                                        qc = 9;
	                                        break
	                                    }
	                                    if (!((tb >>> 0) % 10 | 0)) {
	                                        rc = 10;
	                                        sc = 0
	                                    } else {
	                                        qc = 0;
	                                        break
	                                    }
	                                    while (1) {
	                                        rc = rc * 10 | 0;
	                                        db = sc + 1 | 0;
	                                        if ((tb >>> 0) % (rc >>> 0) | 0) {
	                                            qc = db;
	                                            break
	                                        } else sc = db
	                                    }
	                                } else qc = 9; while (0);
	                                tb = (($a - bb >> 2) * 9 | 0) + -9 | 0;
	                                if ((mc | 32 | 0) == 102) {
	                                    Ab = tb - qc | 0;
	                                    db = (Ab | 0) < 0 ? 0 : Ab;
	                                    oc = mc;
	                                    pc = (nc | 0) < (db | 0) ? nc : db;
	                                    break
	                                } else {
	                                    db = tb + jc - qc | 0;
	                                    tb = (db | 0) < 0 ? 0 : db;
	                                    oc = mc;
	                                    pc = (nc | 0) < (tb | 0) ? nc : tb;
	                                    break
	                                }
	                            } else {
	                                oc = la;
	                                pc = Wa
	                            } while (0);
	                            Wa = (pc | 0) != 0;
	                            if (Wa)tc = 1; else tc = (ha & 8 | 0) != 0;
	                            bb = tc & 1;
	                            Ya = (oc | 32 | 0) == 102;
	                            if (Ya) {
	                                uc = (jc | 0) > 0 ? jc : 0;
	                                vc = 0
	                            } else {
	                                tb = (jc | 0) < 0 ? Db : jc;
	                                if ((tb | 0) < 0) {
	                                    db = B;
	                                    Ab = tb;
	                                    jb = ((tb | 0) < 0) << 31 >> 31;
	                                    while (1) {
	                                        ma = oU(Ab | 0, jb | 0, 10, 0) | 0;
	                                        db = db + -1 | 0;
	                                        a[db >> 0] = ma | 48;
	                                        ma = Ab;
	                                        Ab = nU(Ab | 0, jb | 0, 10, 0) | 0;
	                                        if (!(jb >>> 0 > 9 | (jb | 0) == 9 & ma >>> 0 > 4294967295))break; else jb = G
	                                    }
	                                    wc = db;
	                                    xc = Ab
	                                } else {
	                                    wc = B;
	                                    xc = tb
	                                }
	                                if (!xc)yc = wc; else {
	                                    jb = wc;
	                                    Db = xc;
	                                    while (1) {
	                                        ma = jb + -1 | 0;
	                                        a[ma >> 0] = (Db >>> 0) % 10 | 0 | 48;
	                                        if (Db >>> 0 < 10) {
	                                            yc = ma;
	                                            break
	                                        } else {
	                                            jb = ma;
	                                            Db = (Db >>> 0) / 10 | 0
	                                        }
	                                    }
	                                }
	                                if ((r - yc | 0) < 2) {
	                                    Db = yc;
	                                    while (1) {
	                                        jb = Db + -1 | 0;
	                                        a[jb >> 0] = 48;
	                                        if ((r - jb | 0) < 2)Db = jb; else {
	                                            zc = jb;
	                                            break
	                                        }
	                                    }
	                                } else zc = yc;
	                                a[zc + -1 >> 0] = (jc >> 31 & 2) + 43;
	                                Db = zc + -2 | 0;
	                                a[Db >> 0] = oc;
	                                uc = r - Db | 0;
	                                vc = Db
	                            }
	                            Db = Sa + 1 + pc + bb + uc | 0;
	                            jb = ha & 73728;
	                            tb = (ua | 0) > (Db | 0);
	                            if ((jb | 0) == 0 & tb) {
	                                Ab = ua - Db | 0;
	                                cU(s | 0, 32, (Ab >>> 0 > 256 ? 256 : Ab) | 0) | 0;
	                                if (Ab >>> 0 > 255) {
	                                    db = Ab;
	                                    do {
	                                        IT(s, 256, e) | 0;
	                                        db = db + -256 | 0
	                                    } while (db >>> 0 > 255);
	                                    Ac = Ab & 255
	                                } else Ac = Ab;
	                                IT(s, Ac, e) | 0
	                            }
	                            IT(Ta, Sa, e) | 0;
	                            if ((jb | 0) == 65536 & tb) {
	                                db = ua - Db | 0;
	                                cU(s | 0, 48, (db >>> 0 > 256 ? 256 : db) | 0) | 0;
	                                if (db >>> 0 > 255) {
	                                    bb = db;
	                                    do {
	                                        IT(s, 256, e) | 0;
	                                        bb = bb + -256 | 0
	                                    } while (bb >>> 0 > 255);
	                                    Bc = db & 255
	                                } else Bc = db;
	                                IT(s, Bc, e) | 0
	                            }
	                            do if (Ya) {
	                                bb = ic >>> 0 > _ >>> 0 ? _ : ic;
	                                Ab = bb;
	                                do {
	                                    ma = c[Ab >> 2] | 0;
	                                    if (!ma)Cc = I; else {
	                                        Bb = I;
	                                        Ib = ma;
	                                        while (1) {
	                                            ma = Bb + -1 | 0;
	                                            a[ma >> 0] = (Ib >>> 0) % 10 | 0 | 48;
	                                            if (Ib >>> 0 < 10) {
	                                                Cc = ma;
	                                                break
	                                            } else {
	                                                Bb = ma;
	                                                Ib = (Ib >>> 0) / 10 | 0
	                                            }
	                                        }
	                                    }
	                                    do if ((Ab | 0) == (bb | 0)) {
	                                        if ((Cc | 0) != (I | 0)) {
	                                            Dc = Cc;
	                                            break
	                                        }
	                                        a[K >> 0] = 48;
	                                        Dc = K
	                                    } else {
	                                        if (Cc >>> 0 > p >>> 0)Ec = Cc; else {
	                                            Dc = Cc;
	                                            break
	                                        }
	                                        while (1) {
	                                            Ib = Ec + -1 | 0;
	                                            a[Ib >> 0] = 48;
	                                            if (Ib >>> 0 > p >>> 0)Ec = Ib; else {
	                                                Dc = Ib;
	                                                break
	                                            }
	                                        }
	                                    } while (0);
	                                    IT(Dc, J - Dc | 0, e) | 0;
	                                    Ab = Ab + 4 | 0
	                                } while (Ab >>> 0 <= _ >>> 0);
	                                if (!((ha & 8 | 0) == 0 & (Wa ^ 1)))IT(329656, 1, e) | 0;
	                                if (Ab >>> 0 < $a >>> 0 & (pc | 0) > 0) {
	                                    bb = pc;
	                                    aa = Ab;
	                                    while (1) {
	                                        Ib = c[aa >> 2] | 0;
	                                        if (Ib) {
	                                            Bb = I;
	                                            ma = Ib;
	                                            while (1) {
	                                                Bb = Bb + -1 | 0;
	                                                a[Bb >> 0] = (ma >>> 0) % 10 | 0 | 48;
	                                                if (ma >>> 0 < 10)break; else ma = (ma >>> 0) / 10 | 0
	                                            }
	                                            if (Bb >>> 0 > p >>> 0) {
	                                                Fc = Bb;
	                                                S = 301
	                                            } else Gc = Bb
	                                        } else {
	                                            Fc = I;
	                                            S = 301
	                                        }
	                                        if ((S | 0) == 301)while (1) {
	                                            S = 0;
	                                            ma = Fc + -1 | 0;
	                                            a[ma >> 0] = 48;
	                                            if (ma >>> 0 > p >>> 0) {
	                                                Fc = ma;
	                                                S = 301
	                                            } else {
	                                                Gc = ma;
	                                                break
	                                            }
	                                        }
	                                        IT(Gc, (bb | 0) > 9 ? 9 : bb, e) | 0;
	                                        aa = aa + 4 | 0;
	                                        Bb = bb + -9 | 0;
	                                        if (!(aa >>> 0 < $a >>> 0 & (Bb | 0) > 0)) {
	                                            Hc = Bb;
	                                            break
	                                        } else bb = Bb
	                                    }
	                                } else Hc = pc;
	                                if ((Hc | 0) <= 0)break;
	                                cU(s | 0, 48, (Hc >>> 0 > 256 ? 256 : Hc) | 0) | 0;
	                                if (Hc >>> 0 > 255) {
	                                    bb = Hc;
	                                    do {
	                                        IT(s, 256, e) | 0;
	                                        bb = bb + -256 | 0
	                                    } while (bb >>> 0 > 255);
	                                    Ic = Hc & 255
	                                } else Ic = Hc;
	                                IT(s, Ic, e) | 0
	                            } else {
	                                bb = lc ? $a : ic + 4 | 0;
	                                do if ((pc | 0) > -1) {
	                                    aa = (ha & 8 | 0) == 0;
	                                    Ab = pc;
	                                    Bb = ic;
	                                    do {
	                                        ma = c[Bb >> 2] | 0;
	                                        if (ma) {
	                                            Ib = I;
	                                            ab = ma;
	                                            while (1) {
	                                                Ib = Ib + -1 | 0;
	                                                a[Ib >> 0] = (ab >>> 0) % 10 | 0 | 48;
	                                                if (ab >>> 0 < 10)break; else ab = (ab >>> 0) / 10 | 0
	                                            }
	                                            if ((Ib | 0) != (I | 0))Jc = Ib; else S = 313
	                                        } else S = 313;
	                                        if ((S | 0) == 313) {
	                                            S = 0;
	                                            a[K >> 0] = 48;
	                                            Jc = K
	                                        }
	                                        do if ((Bb | 0) == (ic | 0)) {
	                                            ab = Jc + 1 | 0;
	                                            IT(Jc, 1, e) | 0;
	                                            if ((Ab | 0) < 1 & aa) {
	                                                Kc = ab;
	                                                break
	                                            }
	                                            IT(329656, 1, e) | 0;
	                                            Kc = ab
	                                        } else {
	                                            if (Jc >>> 0 > p >>> 0)Lc = Jc; else {
	                                                Kc = Jc;
	                                                break
	                                            }
	                                            while (1) {
	                                                ab = Lc + -1 | 0;
	                                                a[ab >> 0] = 48;
	                                                if (ab >>> 0 > p >>> 0)Lc = ab; else {
	                                                    Kc = ab;
	                                                    break
	                                                }
	                                            }
	                                        } while (0);
	                                        Ib = J - Kc | 0;
	                                        IT(Kc, (Ab | 0) > (Ib | 0) ? Ib : Ab, e) | 0;
	                                        Ab = Ab - Ib | 0;
	                                        Bb = Bb + 4 | 0
	                                    } while (Bb >>> 0 < bb >>> 0 & (Ab | 0) > -1);
	                                    if ((Ab | 0) <= 0)break;
	                                    cU(s | 0, 48, (Ab >>> 0 > 256 ? 256 : Ab) | 0) | 0;
	                                    if (Ab >>> 0 > 255) {
	                                        Bb = Ab;
	                                        do {
	                                            IT(s, 256, e) | 0;
	                                            Bb = Bb + -256 | 0
	                                        } while (Bb >>> 0 > 255);
	                                        Mc = Ab & 255
	                                    } else Mc = Ab;
	                                    IT(s, Mc, e) | 0
	                                } while (0);
	                                IT(vc, r - vc | 0, e) | 0
	                            } while (0);
	                            if ((jb | 0) == 8192 & tb) {
	                                $a = ua - Db | 0;
	                                cU(s | 0, 32, ($a >>> 0 > 256 ? 256 : $a) | 0) | 0;
	                                if ($a >>> 0 > 255) {
	                                    Wa = $a;
	                                    do {
	                                        IT(s, 256, e) | 0;
	                                        Wa = Wa + -256 | 0
	                                    } while (Wa >>> 0 > 255);
	                                    Nc = $a & 255
	                                } else Nc = $a;
	                                IT(s, Nc, e) | 0
	                            }
	                            L = Ha;
	                            M = Ia;
	                            N = Ba;
	                            f = Q;
	                            O = tb ? ua : Db;
	                            P = ta;
	                            continue a;
	                            break
	                        }
	                        case 117:
	                        {
	                            Na = Ia;
	                            Oa = Ha;
	                            Pa = 0;
	                            Qa = 329560;
	                            S = 86;
	                            break
	                        }
	                        case 88:
	                        case 120:
	                        {
	                            Oc = ha;
	                            Pc = za;
	                            Qc = la;
	                            S = 75;
	                            break
	                        }
	                        case 99:
	                        {
	                            a[z >> 0] = Ha;
	                            Rc = Ha;
	                            Sc = Ia;
	                            Tc = z;
	                            Uc = $;
	                            Vc = 1;
	                            Wc = 0;
	                            Xc = 329560;
	                            Yc = x;
	                            break
	                        }
	                        case 111:
	                        {
	                            Wa = (Ha | 0) == 0 & (Ia | 0) == 0;
	                            if (Wa)Zc = x; else {
	                                jb = x;
	                                _ = Ha;
	                                Ya = Ia;
	                                while (1) {
	                                    db = jb + -1 | 0;
	                                    a[db >> 0] = _ & 7 | 48;
	                                    _ = dU(_ | 0, Ya | 0, 3) | 0;
	                                    Ya = G;
	                                    if ((_ | 0) == 0 & (Ya | 0) == 0) {
	                                        Zc = db;
	                                        break
	                                    } else jb = db
	                                }
	                            }
	                            jb = (ha & 8 | 0) == 0 | Wa;
	                            _c = Ha;
	                            $c = Ia;
	                            ad = Zc;
	                            bd = ha;
	                            cd = za;
	                            dd = jb & 1 ^ 1;
	                            ed = jb ? 329560 : 329565;
	                            S = 91;
	                            break
	                        }
	                        case 67:
	                        {
	                            c[u >> 2] = Ha;
	                            c[t >> 2] = 0;
	                            fd = u;
	                            gd = A;
	                            hd = -1;
	                            S = 101;
	                            break
	                        }
	                        case 83:
	                        {
	                            jb = Ha;
	                            if (!za) {
	                                id = Ha;
	                                jd = jb;
	                                kd = 0;
	                                S = 106
	                            } else {
	                                fd = jb;
	                                gd = Ha;
	                                hd = za;
	                                S = 101
	                            }
	                            break
	                        }
	                        case 112:
	                        {
	                            Oc = ha | 8;
	                            Pc = za >>> 0 > 8 ? za : 8;
	                            Qc = 120;
	                            S = 75;
	                            break
	                        }
	                        case 115:
	                        {
	                            Ma = (Ha | 0) == 0 ? 329576 : Ha;
	                            S = 96;
	                            break
	                        }
	                        default:
	                        {
	                            Rc = Ha;
	                            Sc = Ia;
	                            Tc = N;
	                            Uc = ha;
	                            Vc = za;
	                            Wc = 0;
	                            Xc = 329560;
	                            Yc = x
	                        }
	                    } while (0);
	                    do if ((S | 0) == 75) {
	                        S = 0;
	                        la = Qc & 32;
	                        if (!((Ha | 0) == 0 & (Ia | 0) == 0)) {
	                            R = x;
	                            Z = Ha;
	                            ga = Ia;
	                            do {
	                                R = R + -1 | 0;
	                                a[R >> 0] = d[329640 + (Z & 15) >> 0] | la;
	                                Z = dU(Z | 0, ga | 0, 4) | 0;
	                                ga = G
	                            } while (!((Z | 0) == 0 & (ga | 0) == 0));
	                            if (!(Oc & 8)) {
	                                _c = Ha;
	                                $c = Ia;
	                                ad = R;
	                                bd = Oc;
	                                cd = Pc;
	                                dd = 0;
	                                ed = 329560;
	                                S = 91
	                            } else {
	                                _c = Ha;
	                                $c = Ia;
	                                ad = R;
	                                bd = Oc;
	                                cd = Pc;
	                                dd = 2;
	                                ed = 329560 + (Qc >> 4) | 0;
	                                S = 91
	                            }
	                        } else {
	                            _c = Ha;
	                            $c = Ia;
	                            ad = x;
	                            bd = Oc;
	                            cd = Pc;
	                            dd = 0;
	                            ed = 329560;
	                            S = 91
	                        }
	                    } else if ((S | 0) == 86) {
	                        S = 0;
	                        if (Na >>> 0 > 0 | (Na | 0) == 0 & Oa >>> 0 > 4294967295) {
	                            ga = x;
	                            Z = Oa;
	                            la = Na;
	                            while (1) {
	                                Wa = oU(Z | 0, la | 0, 10, 0) | 0;
	                                ga = ga + -1 | 0;
	                                a[ga >> 0] = Wa | 48;
	                                Wa = Z;
	                                Z = nU(Z | 0, la | 0, 10, 0) | 0;
	                                if (!(la >>> 0 > 9 | (la | 0) == 9 & Wa >>> 0 > 4294967295))break; else la = G
	                            }
	                            ld = ga;
	                            md = Z
	                        } else {
	                            ld = x;
	                            md = Oa
	                        }
	                        if (!md) {
	                            _c = Oa;
	                            $c = Na;
	                            ad = ld;
	                            bd = ha;
	                            cd = za;
	                            dd = Pa;
	                            ed = Qa;
	                            S = 91
	                        } else {
	                            la = ld;
	                            R = md;
	                            while (1) {
	                                Wa = la + -1 | 0;
	                                a[Wa >> 0] = (R >>> 0) % 10 | 0 | 48;
	                                if (R >>> 0 < 10) {
	                                    _c = Oa;
	                                    $c = Na;
	                                    ad = Wa;
	                                    bd = ha;
	                                    cd = za;
	                                    dd = Pa;
	                                    ed = Qa;
	                                    S = 91;
	                                    break
	                                } else {
	                                    la = Wa;
	                                    R = (R >>> 0) / 10 | 0
	                                }
	                            }
	                        }
	                    } else if ((S | 0) == 96) {
	                        S = 0;
	                        R = NT(Ma, 0, za) | 0;
	                        if (!R) {
	                            Rc = Ha;
	                            Sc = Ia;
	                            Tc = Ma;
	                            Uc = $;
	                            Vc = za;
	                            Wc = 0;
	                            Xc = 329560;
	                            Yc = Ma + za | 0;
	                            break
	                        } else {
	                            Rc = Ha;
	                            Sc = Ia;
	                            Tc = Ma;
	                            Uc = $;
	                            Vc = R - Ma | 0;
	                            Wc = 0;
	                            Xc = 329560;
	                            Yc = R;
	                            break
	                        }
	                    } else if ((S | 0) == 101) {
	                        S = 0;
	                        R = 0;
	                        la = 0;
	                        Z = fd;
	                        while (1) {
	                            ga = c[Z >> 2] | 0;
	                            if (!ga) {
	                                nd = R;
	                                od = la;
	                                break
	                            }
	                            Wa = CT(v, ga) | 0;
	                            if ((Wa | 0) < 0 | Wa >>> 0 > (hd - R | 0) >>> 0) {
	                                nd = R;
	                                od = Wa;
	                                break
	                            }
	                            ga = Wa + R | 0;
	                            if (hd >>> 0 > ga >>> 0) {
	                                R = ga;
	                                la = Wa;
	                                Z = Z + 4 | 0
	                            } else {
	                                nd = ga;
	                                od = Wa;
	                                break
	                            }
	                        }
	                        if ((od | 0) < 0) {
	                            qa = -1;
	                            S = 370;
	                            break a
	                        } else {
	                            id = gd;
	                            jd = fd;
	                            kd = nd;
	                            S = 106
	                        }
	                    } while (0);
	                    if ((S | 0) == 91) {
	                        S = 0;
	                        $ = (cd | 0) > -1 ? bd & -65537 : bd;
	                        Z = (_c | 0) != 0 | ($c | 0) != 0;
	                        if (Z | (cd | 0) != 0) {
	                            la = (Z & 1 ^ 1) + (y - ad) | 0;
	                            Rc = _c;
	                            Sc = $c;
	                            Tc = ad;
	                            Uc = $;
	                            Vc = (cd | 0) > (la | 0) ? cd : la;
	                            Wc = dd;
	                            Xc = ed;
	                            Yc = x
	                        } else {
	                            Rc = _c;
	                            Sc = $c;
	                            Tc = x;
	                            Uc = $;
	                            Vc = 0;
	                            Wc = dd;
	                            Xc = ed;
	                            Yc = x
	                        }
	                    } else if ((S | 0) == 106) {
	                        S = 0;
	                        $ = ha & 73728;
	                        la = (ua | 0) > (kd | 0);
	                        if (($ | 0) == 0 & la) {
	                            Z = ua - kd | 0;
	                            cU(s | 0, 32, (Z >>> 0 > 256 ? 256 : Z) | 0) | 0;
	                            if (Z >>> 0 > 255) {
	                                R = Z;
	                                do {
	                                    IT(s, 256, e) | 0;
	                                    R = R + -256 | 0
	                                } while (R >>> 0 > 255);
	                                pd = Z & 255
	                            } else pd = Z;
	                            IT(s, pd, e) | 0
	                        }
	                        h:do if (kd) {
	                            R = 0;
	                            ha = jd;
	                            while (1) {
	                                Wa = c[ha >> 2] | 0;
	                                if (!Wa)break h;
	                                ga = CT(v, Wa) | 0;
	                                R = ga + R | 0;
	                                if ((R | 0) > (kd | 0))break h;
	                                IT(v, ga, e) | 0;
	                                if (R >>> 0 >= kd >>> 0)break; else ha = ha + 4 | 0
	                            }
	                        } while (0);
	                        if (($ | 0) == 8192 & la) {
	                            Z = ua - kd | 0;
	                            cU(s | 0, 32, (Z >>> 0 > 256 ? 256 : Z) | 0) | 0;
	                            if (Z >>> 0 > 255) {
	                                ha = Z;
	                                do {
	                                    IT(s, 256, e) | 0;
	                                    ha = ha + -256 | 0
	                                } while (ha >>> 0 > 255);
	                                qd = Z & 255
	                            } else qd = Z;
	                            IT(s, qd, e) | 0
	                        }
	                        L = id;
	                        M = Ia;
	                        N = Ba;
	                        f = Q;
	                        O = la ? ua : kd;
	                        P = ta;
	                        continue
	                    }
	                    ha = Yc - Tc | 0;
	                    $ = (Vc | 0) < (ha | 0) ? ha : Vc;
	                    R = Wc + $ | 0;
	                    ga = (ua | 0) < (R | 0) ? R : ua;
	                    Wa = Uc & 73728;
	                    jb = (ga | 0) > (R | 0);
	                    if ((Wa | 0) == 0 & jb) {
	                        Ya = ga - R | 0;
	                        cU(s | 0, 32, (Ya >>> 0 > 256 ? 256 : Ya) | 0) | 0;
	                        if (Ya >>> 0 > 255) {
	                            _ = Ya;
	                            do {
	                                IT(s, 256, e) | 0;
	                                _ = _ + -256 | 0
	                            } while (_ >>> 0 > 255);
	                            rd = Ya & 255
	                        } else rd = Ya;
	                        IT(s, rd, e) | 0
	                    }
	                    IT(Xc, Wc, e) | 0;
	                    if ((Wa | 0) == 65536 & jb) {
	                        _ = ga - R | 0;
	                        cU(s | 0, 48, (_ >>> 0 > 256 ? 256 : _) | 0) | 0;
	                        if (_ >>> 0 > 255) {
	                            la = _;
	                            do {
	                                IT(s, 256, e) | 0;
	                                la = la + -256 | 0
	                            } while (la >>> 0 > 255);
	                            sd = _ & 255
	                        } else sd = _;
	                        IT(s, sd, e) | 0
	                    }
	                    if (($ | 0) > (ha | 0)) {
	                        la = $ - ha | 0;
	                        cU(s | 0, 48, (la >>> 0 > 256 ? 256 : la) | 0) | 0;
	                        if (la >>> 0 > 255) {
	                            Ya = la;
	                            do {
	                                IT(s, 256, e) | 0;
	                                Ya = Ya + -256 | 0
	                            } while (Ya >>> 0 > 255);
	                            td = la & 255
	                        } else td = la;
	                        IT(s, td, e) | 0
	                    }
	                    IT(Tc, ha, e) | 0;
	                    if (!((Wa | 0) == 8192 & jb)) {
	                        L = Rc;
	                        M = Sc;
	                        N = Ba;
	                        f = Q;
	                        O = ga;
	                        P = ta;
	                        continue
	                    }
	                    Ya = ga - R | 0;
	                    cU(s | 0, 32, (Ya >>> 0 > 256 ? 256 : Ya) | 0) | 0;
	                    if (Ya >>> 0 > 255) {
	                        $ = Ya;
	                        do {
	                            IT(s, 256, e) | 0;
	                            $ = $ + -256 | 0
	                        } while ($ >>> 0 > 255);
	                        ud = Ya & 255
	                    } else ud = Ya;
	                    IT(s, ud, e) | 0;
	                    L = Rc;
	                    M = Sc;
	                    N = Ba;
	                    f = Q;
	                    O = ga;
	                    P = ta
	                }
	                if ((S | 0) == 352) {
	                    if (e) {
	                        qa = Q;
	                        i = m;
	                        return qa | 0
	                    }
	                    if (!P) {
	                        qa = 0;
	                        i = m;
	                        return qa | 0
	                    } else vd = 1;
	                    while (1) {
	                        P = c[l + (vd << 2) >> 2] | 0;
	                        if (!P) {
	                            wd = vd;
	                            break
	                        }
	                        Q = j + (vd << 3) | 0;
	                        i:do if (P >>> 0 <= 20)do switch (P | 0) {
	                            case 9:
	                            {
	                                e = c[g >> 2] | 0;
	                                ta = c[e >> 2] | 0;
	                                c[g >> 2] = e + 4;
	                                c[Q >> 2] = ta;
	                                break i;
	                                break
	                            }
	                            case 10:
	                            {
	                                ta = c[g >> 2] | 0;
	                                e = c[ta >> 2] | 0;
	                                c[g >> 2] = ta + 4;
	                                ta = Q;
	                                c[ta >> 2] = e;
	                                c[ta + 4 >> 2] = ((e | 0) < 0) << 31 >> 31;
	                                break i;
	                                break
	                            }
	                            case 11:
	                            {
	                                e = c[g >> 2] | 0;
	                                ta = c[e >> 2] | 0;
	                                c[g >> 2] = e + 4;
	                                e = Q;
	                                c[e >> 2] = ta;
	                                c[e + 4 >> 2] = 0;
	                                break i;
	                                break
	                            }
	                            case 12:
	                            {
	                                e = c[g >> 2] | 0;
	                                ta = e;
	                                O = c[ta >> 2] | 0;
	                                f = c[ta + 4 >> 2] | 0;
	                                c[g >> 2] = e + 8;
	                                e = Q;
	                                c[e >> 2] = O;
	                                c[e + 4 >> 2] = f;
	                                break i;
	                                break
	                            }
	                            case 13:
	                            {
	                                f = c[g >> 2] | 0;
	                                e = c[f >> 2] | 0;
	                                c[g >> 2] = f + 4;
	                                f = (e & 65535) << 16 >> 16;
	                                e = Q;
	                                c[e >> 2] = f;
	                                c[e + 4 >> 2] = ((f | 0) < 0) << 31 >> 31;
	                                break i;
	                                break
	                            }
	                            case 14:
	                            {
	                                f = c[g >> 2] | 0;
	                                e = c[f >> 2] | 0;
	                                c[g >> 2] = f + 4;
	                                f = Q;
	                                c[f >> 2] = e & 65535;
	                                c[f + 4 >> 2] = 0;
	                                break i;
	                                break
	                            }
	                            case 15:
	                            {
	                                f = c[g >> 2] | 0;
	                                e = c[f >> 2] | 0;
	                                c[g >> 2] = f + 4;
	                                f = (e & 255) << 24 >> 24;
	                                e = Q;
	                                c[e >> 2] = f;
	                                c[e + 4 >> 2] = ((f | 0) < 0) << 31 >> 31;
	                                break i;
	                                break
	                            }
	                            case 16:
	                            {
	                                f = c[g >> 2] | 0;
	                                e = c[f >> 2] | 0;
	                                c[g >> 2] = f + 4;
	                                f = Q;
	                                c[f >> 2] = e & 255;
	                                c[f + 4 >> 2] = 0;
	                                break i;
	                                break
	                            }
	                            case 17:
	                            {
	                                f = c[g >> 2] | 0;
	                                c[k >> 2] = c[f >> 2];
	                                c[k + 4 >> 2] = c[f + 4 >> 2];
	                                bc = +h[k >> 3];
	                                c[g >> 2] = f + 8;
	                                h[Q >> 3] = bc;
	                                break i;
	                                break
	                            }
	                            case 18:
	                            {
	                                f = c[g >> 2] | 0;
	                                c[k >> 2] = c[f >> 2];
	                                c[k + 4 >> 2] = c[f + 4 >> 2];
	                                bc = +h[k >> 3];
	                                c[g >> 2] = f + 8;
	                                h[Q >> 3] = bc;
	                                break i;
	                                break
	                            }
	                            default:
	                                break i
	                        } while (0); while (0);
	                        vd = vd + 1 | 0;
	                        if ((vd | 0) >= 10) {
	                            qa = 1;
	                            S = 370;
	                            break
	                        }
	                    }
	                    if ((S | 0) == 370) {
	                        i = m;
	                        return qa | 0
	                    }
	                    while (1) {
	                        if (c[l + (wd << 2) >> 2] | 0) {
	                            qa = -1;
	                            S = 370;
	                            break
	                        }
	                        wd = wd + 1 | 0;
	                        if ((wd | 0) >= 10) {
	                            qa = 1;
	                            S = 370;
	                            break
	                        }
	                    }
	                    if ((S | 0) == 370) {
	                        i = m;
	                        return qa | 0
	                    }
	                } else if ((S | 0) == 370) {
	                    i = m;
	                    return qa | 0
	                }
	                return 0
	            }

	            function WT() {
	            }

	            function XT(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0;
	                e = b - d >>> 0;
	                e = b - d - (c >>> 0 > a >>> 0 | 0) >>> 0;
	                return (G = e, a - c >>> 0 | 0) | 0
	            }

	            function YT(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                if ((c | 0) < 32) {
	                    G = b >> c;
	                    return a >>> c | (b & (1 << c) - 1) << 32 - c
	                }
	                G = (b | 0) < 0 ? -1 : 0;
	                return b >> c - 32 | 0
	            }

	            function ZT(b) {
	                b = b | 0;
	                var c = 0;
	                c = b;
	                while (a[c >> 0] | 0)c = c + 1 | 0;
	                return c - b | 0
	            }

	            function _T(b, c) {
	                b = b | 0;
	                c = c | 0;
	                var d = 0, e = 0;
	                d = b + (ZT(b) | 0) | 0;
	                do {
	                    a[d + e >> 0] = a[c + e >> 0];
	                    e = e + 1 | 0
	                } while (a[c + (e - 1) >> 0] | 0);
	                return b | 0
	            }

	            function $T(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                if ((c | 0) < 32) {
	                    G = b << c | (a & (1 << c) - 1 << 32 - c) >>> 32 - c;
	                    return a << c
	                }
	                G = a << c - 32;
	                return 0
	            }

	            function aU(b, c, d) {
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0, f = 0;
	                while ((e | 0) < (d | 0)) {
	                    a[b + e >> 0] = f ? 0 : a[c + e >> 0] | 0;
	                    f = f ? 1 : (a[c + e >> 0] | 0) == 0;
	                    e = e + 1 | 0
	                }
	                return b | 0
	            }

	            function bU(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0;
	                e = a + c >>> 0;
	                return (G = b + d + (e >>> 0 < a >>> 0 | 0) >>> 0, e | 0) | 0
	            }

	            function cU(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, i = 0;
	                f = b + e | 0;
	                if ((e | 0) >= 20) {
	                    d = d & 255;
	                    g = b & 3;
	                    h = d | d << 8 | d << 16 | d << 24;
	                    i = f & ~3;
	                    if (g) {
	                        g = b + 4 - g | 0;
	                        while ((b | 0) < (g | 0)) {
	                            a[b >> 0] = d;
	                            b = b + 1 | 0
	                        }
	                    }
	                    while ((b | 0) < (i | 0)) {
	                        c[b >> 2] = h;
	                        b = b + 4 | 0
	                    }
	                }
	                while ((b | 0) < (f | 0)) {
	                    a[b >> 0] = d;
	                    b = b + 1 | 0
	                }
	                return b - e | 0
	            }

	            function dU(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                if ((c | 0) < 32) {
	                    G = b >>> c;
	                    return a >>> c | (b & (1 << c) - 1) << 32 - c
	                }
	                G = 0;
	                return b >>> c - 32 | 0
	            }

	            function eU(b, d, e) {
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0;
	                if ((e | 0) >= 4096)return Na(b | 0, d | 0, e | 0) | 0;
	                f = b | 0;
	                if ((b & 3) == (d & 3)) {
	                    while (b & 3) {
	                        if (!e)return f | 0;
	                        a[b >> 0] = a[d >> 0] | 0;
	                        b = b + 1 | 0;
	                        d = d + 1 | 0;
	                        e = e - 1 | 0
	                    }
	                    while ((e | 0) >= 4) {
	                        c[b >> 2] = c[d >> 2];
	                        b = b + 4 | 0;
	                        d = d + 4 | 0;
	                        e = e - 4 | 0
	                    }
	                }
	                while ((e | 0) > 0) {
	                    a[b >> 0] = a[d >> 0] | 0;
	                    b = b + 1 | 0;
	                    d = d + 1 | 0;
	                    e = e - 1 | 0
	                }
	                return f | 0
	            }

	            function fU(b, c, d) {
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0;
	                if ((c | 0) < (b | 0) & (b | 0) < (c + d | 0)) {
	                    e = b;
	                    c = c + d | 0;
	                    b = b + d | 0;
	                    while ((d | 0) > 0) {
	                        b = b - 1 | 0;
	                        c = c - 1 | 0;
	                        d = d - 1 | 0;
	                        a[b >> 0] = a[c >> 0] | 0
	                    }
	                    b = e
	                } else eU(b, c, d) | 0;
	                return b | 0
	            }

	            function gU(b, c) {
	                b = b | 0;
	                c = c | 0;
	                var d = 0;
	                do {
	                    a[b + d >> 0] = a[c + d >> 0];
	                    d = d + 1 | 0
	                } while (a[c + (d - 1) >> 0] | 0);
	                return b | 0
	            }

	            function hU(b) {
	                b = b | 0;
	                var c = 0;
	                c = a[n + (b >>> 24) >> 0] | 0;
	                if ((c | 0) < 8)return c | 0;
	                c = a[n + (b >> 16 & 255) >> 0] | 0;
	                if ((c | 0) < 8)return c + 8 | 0;
	                c = a[n + (b >> 8 & 255) >> 0] | 0;
	                if ((c | 0) < 8)return c + 16 | 0;
	                return (a[n + (b & 255) >> 0] | 0) + 24 | 0
	            }

	            function iU(b) {
	                b = b | 0;
	                var c = 0;
	                c = a[m + (b & 255) >> 0] | 0;
	                if ((c | 0) < 8)return c | 0;
	                c = a[m + (b >> 8 & 255) >> 0] | 0;
	                if ((c | 0) < 8)return c + 8 | 0;
	                c = a[m + (b >> 16 & 255) >> 0] | 0;
	                if ((c | 0) < 8)return c + 16 | 0;
	                return (a[m + (b >>> 24) >> 0] | 0) + 24 | 0
	            }

	            function jU(a, b) {
	                a = a | 0;
	                b = b | 0;
	                var c = 0, d = 0, e = 0, f = 0;
	                c = a & 65535;
	                d = b & 65535;
	                e = ca(d, c) | 0;
	                f = a >>> 16;
	                a = (e >>> 16) + (ca(d, f) | 0) | 0;
	                d = b >>> 16;
	                b = ca(d, c) | 0;
	                return (G = (a >>> 16) + (ca(d, f) | 0) + (((a & 65535) + b | 0) >>> 16) | 0, a + b << 16 | e & 65535 | 0) | 0
	            }

	            function kU(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0, f = 0, g = 0, h = 0, i = 0;
	                e = b >> 31 | ((b | 0) < 0 ? -1 : 0) << 1;
	                f = ((b | 0) < 0 ? -1 : 0) >> 31 | ((b | 0) < 0 ? -1 : 0) << 1;
	                g = d >> 31 | ((d | 0) < 0 ? -1 : 0) << 1;
	                h = ((d | 0) < 0 ? -1 : 0) >> 31 | ((d | 0) < 0 ? -1 : 0) << 1;
	                i = XT(e ^ a, f ^ b, e, f) | 0;
	                b = G;
	                a = g ^ e;
	                e = h ^ f;
	                f = XT((pU(i, b, XT(g ^ c, h ^ d, g, h) | 0, G, 0) | 0) ^ a, G ^ e, a, e) | 0;
	                return f | 0
	            }

	            function lU(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0, h = 0, j = 0, k = 0, l = 0, m = 0;
	                f = i;
	                i = i + 8 | 0;
	                g = f | 0;
	                h = b >> 31 | ((b | 0) < 0 ? -1 : 0) << 1;
	                j = ((b | 0) < 0 ? -1 : 0) >> 31 | ((b | 0) < 0 ? -1 : 0) << 1;
	                k = e >> 31 | ((e | 0) < 0 ? -1 : 0) << 1;
	                l = ((e | 0) < 0 ? -1 : 0) >> 31 | ((e | 0) < 0 ? -1 : 0) << 1;
	                m = XT(h ^ a, j ^ b, h, j) | 0;
	                b = G;
	                pU(m, b, XT(k ^ d, l ^ e, k, l) | 0, G, g) | 0;
	                l = XT(c[g >> 2] ^ h, c[g + 4 >> 2] ^ j, h, j) | 0;
	                j = G;
	                i = f;
	                return (G = j, l) | 0
	            }

	            function mU(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0, f = 0;
	                e = a;
	                a = c;
	                c = jU(e, a) | 0;
	                f = G;
	                return (G = (ca(b, a) | 0) + (ca(d, e) | 0) + f | f & 0, c | 0 | 0) | 0
	            }

	            function nU(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                var e = 0;
	                e = pU(a, b, c, d, 0) | 0;
	                return e | 0
	            }

	            function oU(a, b, d, e) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                var f = 0, g = 0;
	                f = i;
	                i = i + 8 | 0;
	                g = f | 0;
	                pU(a, b, d, e, g) | 0;
	                i = f;
	                return (G = c[g + 4 >> 2] | 0, c[g >> 2] | 0) | 0
	            }

	            function pU(a, b, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0, F = 0, H = 0;
	                g = a;
	                h = b;
	                i = h;
	                j = d;
	                k = e;
	                l = k;
	                if (!i) {
	                    m = (f | 0) != 0;
	                    if (!l) {
	                        if (m) {
	                            c[f >> 2] = (g >>> 0) % (j >>> 0);
	                            c[f + 4 >> 2] = 0
	                        }
	                        n = 0;
	                        o = (g >>> 0) / (j >>> 0) >>> 0;
	                        return (G = n, o) | 0
	                    } else {
	                        if (!m) {
	                            n = 0;
	                            o = 0;
	                            return (G = n, o) | 0
	                        }
	                        c[f >> 2] = a | 0;
	                        c[f + 4 >> 2] = b & 0;
	                        n = 0;
	                        o = 0;
	                        return (G = n, o) | 0
	                    }
	                }
	                m = (l | 0) == 0;
	                do if (j) {
	                    if (!m) {
	                        p = (hU(l | 0) | 0) - (hU(i | 0) | 0) | 0;
	                        if (p >>> 0 <= 31) {
	                            q = p + 1 | 0;
	                            r = 31 - p | 0;
	                            s = p - 31 >> 31;
	                            t = q;
	                            u = g >>> (q >>> 0) & s | i << r;
	                            v = i >>> (q >>> 0) & s;
	                            w = 0;
	                            x = g << r;
	                            break
	                        }
	                        if (!f) {
	                            n = 0;
	                            o = 0;
	                            return (G = n, o) | 0
	                        }
	                        c[f >> 2] = a | 0;
	                        c[f + 4 >> 2] = h | b & 0;
	                        n = 0;
	                        o = 0;
	                        return (G = n, o) | 0
	                    }
	                    r = j - 1 | 0;
	                    if (r & j) {
	                        s = (hU(j | 0) | 0) + 33 - (hU(i | 0) | 0) | 0;
	                        q = 64 - s | 0;
	                        p = 32 - s | 0;
	                        y = p >> 31;
	                        z = s - 32 | 0;
	                        A = z >> 31;
	                        t = s;
	                        u = p - 1 >> 31 & i >>> (z >>> 0) | (i << p | g >>> (s >>> 0)) & A;
	                        v = A & i >>> (s >>> 0);
	                        w = g << q & y;
	                        x = (i << q | g >>> (z >>> 0)) & y | g << p & s - 33 >> 31;
	                        break
	                    }
	                    if (f) {
	                        c[f >> 2] = r & g;
	                        c[f + 4 >> 2] = 0
	                    }
	                    if ((j | 0) == 1) {
	                        n = h | b & 0;
	                        o = a | 0 | 0;
	                        return (G = n, o) | 0
	                    } else {
	                        r = iU(j | 0) | 0;
	                        n = i >>> (r >>> 0) | 0;
	                        o = i << 32 - r | g >>> (r >>> 0) | 0;
	                        return (G = n, o) | 0
	                    }
	                } else {
	                    if (m) {
	                        if (f) {
	                            c[f >> 2] = (i >>> 0) % (j >>> 0);
	                            c[f + 4 >> 2] = 0
	                        }
	                        n = 0;
	                        o = (i >>> 0) / (j >>> 0) >>> 0;
	                        return (G = n, o) | 0
	                    }
	                    if (!g) {
	                        if (f) {
	                            c[f >> 2] = 0;
	                            c[f + 4 >> 2] = (i >>> 0) % (l >>> 0)
	                        }
	                        n = 0;
	                        o = (i >>> 0) / (l >>> 0) >>> 0;
	                        return (G = n, o) | 0
	                    }
	                    r = l - 1 | 0;
	                    if (!(r & l)) {
	                        if (f) {
	                            c[f >> 2] = a | 0;
	                            c[f + 4 >> 2] = r & i | b & 0
	                        }
	                        n = 0;
	                        o = i >>> ((iU(l | 0) | 0) >>> 0);
	                        return (G = n, o) | 0
	                    }
	                    r = (hU(l | 0) | 0) - (hU(i | 0) | 0) | 0;
	                    if (r >>> 0 <= 30) {
	                        s = r + 1 | 0;
	                        p = 31 - r | 0;
	                        t = s;
	                        u = i << p | g >>> (s >>> 0);
	                        v = i >>> (s >>> 0);
	                        w = 0;
	                        x = g << p;
	                        break
	                    }
	                    if (!f) {
	                        n = 0;
	                        o = 0;
	                        return (G = n, o) | 0
	                    }
	                    c[f >> 2] = a | 0;
	                    c[f + 4 >> 2] = h | b & 0;
	                    n = 0;
	                    o = 0;
	                    return (G = n, o) | 0
	                } while (0);
	                if (!t) {
	                    B = x;
	                    C = w;
	                    D = v;
	                    E = u;
	                    F = 0;
	                    H = 0
	                } else {
	                    b = d | 0 | 0;
	                    d = k | e & 0;
	                    e = bU(b, d, -1, -1) | 0;
	                    k = G;
	                    h = x;
	                    x = w;
	                    w = v;
	                    v = u;
	                    u = t;
	                    t = 0;
	                    do {
	                        a = h;
	                        h = x >>> 31 | h << 1;
	                        x = t | x << 1;
	                        g = v << 1 | a >>> 31 | 0;
	                        a = v >>> 31 | w << 1 | 0;
	                        XT(e, k, g, a) | 0;
	                        i = G;
	                        l = i >> 31 | ((i | 0) < 0 ? -1 : 0) << 1;
	                        t = l & 1;
	                        v = XT(g, a, l & b, (((i | 0) < 0 ? -1 : 0) >> 31 | ((i | 0) < 0 ? -1 : 0) << 1) & d) | 0;
	                        w = G;
	                        u = u - 1 | 0
	                    } while ((u | 0) != 0);
	                    B = h;
	                    C = x;
	                    D = w;
	                    E = v;
	                    F = 0;
	                    H = t
	                }
	                t = C;
	                C = 0;
	                if (f) {
	                    c[f >> 2] = E;
	                    c[f + 4 >> 2] = D
	                }
	                n = (t | 0) >>> 31 | (B | C) << 1 | (C << 1 | t >>> 31) & 0 | F;
	                o = (t << 1 | 0 >>> 31) & -2 | H;
	                return (G = n, o) | 0
	            }

	            function qU(a, b, c, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                return ub[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, h | 0) | 0
	            }

	            function rU(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vb[a & 511](b | 0, c | 0, d | 0) | 0
	            }

	            function sU(a, b, c, d, e, f, g, h) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                wb[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, h | 0)
	            }

	            function tU(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xb[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function uU(a) {
	                a = a | 0;
	                return yb[a & 511]() | 0
	            }

	            function vU(a, b) {
	                a = a | 0;
	                b = b | 0;
	                zb[a & 511](b | 0)
	            }

	            function wU(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ab[a & 511](b | 0, c | 0)
	            }

	            function xU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Bb[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0
	            }

	            function yU(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Cb[a & 511](b | 0) | 0
	            }

	            function zU(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Db[a & 511](b | 0, c | 0, d | 0)
	            }

	            function AU(a, b, c, d, e, f, g, h, i, j) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                j = j | 0;
	                Eb[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, h | 0, i | 0, j | 0)
	            }

	            function BU(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Fb[a & 511](b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function CU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Gb[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0, g | 0)
	            }

	            function DU(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Hb[a & 511](b | 0, c | 0) | 0
	            }

	            function EU(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Ib[a & 511](b | 0, c | 0, d | 0, e | 0, f | 0) | 0
	            }

	            function FU(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Jb[a & 511](b | 0, c | 0, d | 0, e | 0)
	            }

	            function GU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                da(0);
	                return 0
	            }

	            function HU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function IU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return vc(a | 0) | 0
	            }

	            function JU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return wc(a | 0) | 0
	            }

	            function KU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return xc(a | 0) | 0
	            }

	            function LU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return yc(a | 0, b | 0, c | 0) | 0
	            }

	            function MU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return zc(a | 0, b | 0) | 0
	            }

	            function NU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function OU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function PU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function QU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function RU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function SU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function TU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function UU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function VU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function WU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function XU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function YU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function ZU(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function _U(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function $U(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function aV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function bV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function cV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function dV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Qc(a | 0, b | 0) | 0
	            }

	            function eV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function fV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function gV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function hV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function iV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function jV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function kV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return iT(a | 0) | 0
	            }

	            function lV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return kT(a | 0, b | 0) | 0
	            }

	            function mV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return my(a | 0) | 0
	            }

	            function nV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function oV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function pV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return PP(a | 0) | 0
	            }

	            function qV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return QP(a | 0) | 0
	            }

	            function rV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return RP(a | 0) | 0
	            }

	            function sV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return UP(a | 0, b | 0, c | 0) | 0
	            }

	            function tV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return VP(a | 0, b | 0) | 0
	            }

	            function uV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function vV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function wV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function xV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function yV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function zV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function AV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function BV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function CV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function DV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function EV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function FV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function GV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function HV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function IV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function JV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function KV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return WP(a | 0, b | 0) | 0
	            }

	            function LV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function MV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function NV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return LP(a | 0) | 0
	            }

	            function OV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return MP(a | 0) | 0
	            }

	            function PV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return NP(a | 0) | 0
	            }

	            function QV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return OP(a | 0) | 0
	            }

	            function RV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function SV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return NI(a | 0) | 0
	            }

	            function TV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return OI(a | 0) | 0
	            }

	            function UV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return PI(a | 0) | 0
	            }

	            function VV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return QI(a | 0) | 0
	            }

	            function WV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return RI(a | 0) | 0
	            }

	            function XV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return SI(a | 0) | 0
	            }

	            function YV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return TI(a | 0) | 0
	            }

	            function ZV(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return UI(a | 0) | 0
	            }

	            function _V(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return VI(a | 0) | 0
	            }

	            function $V(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return WI(a | 0) | 0
	            }

	            function aW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return XI(a | 0) | 0
	            }

	            function bW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return YI(a | 0) | 0
	            }

	            function cW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return ZI(a | 0) | 0
	            }

	            function dW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return _I(a | 0) | 0
	            }

	            function eW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return $I(a | 0) | 0
	            }

	            function fW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return aJ(a | 0) | 0
	            }

	            function gW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return bJ(a | 0) | 0
	            }

	            function hW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return cJ(a | 0) | 0
	            }

	            function iW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return dJ(a | 0) | 0
	            }

	            function jW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return eJ(a | 0) | 0
	            }

	            function kW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return fJ(a | 0) | 0
	            }

	            function lW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return gJ(a | 0) | 0
	            }

	            function mW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return hJ(a | 0) | 0
	            }

	            function nW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return iJ(a | 0) | 0
	            }

	            function oW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return jJ(a | 0) | 0
	            }

	            function pW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return kJ(a | 0) | 0
	            }

	            function qW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return lJ(a | 0) | 0
	            }

	            function rW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return mJ(a | 0) | 0
	            }

	            function sW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return nJ(a | 0) | 0
	            }

	            function tW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return oJ(a | 0) | 0
	            }

	            function uW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return pJ(a | 0) | 0
	            }

	            function vW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return qJ(a | 0) | 0
	            }

	            function wW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return rJ(a | 0) | 0
	            }

	            function xW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return sJ(a | 0) | 0
	            }

	            function yW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return tJ(a | 0) | 0
	            }

	            function zW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return uJ(a | 0) | 0
	            }

	            function AW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return vJ(a | 0) | 0
	            }

	            function BW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return wJ(a | 0) | 0
	            }

	            function CW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return xJ(a | 0) | 0
	            }

	            function DW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return yJ(a | 0) | 0
	            }

	            function EW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return zJ(a | 0) | 0
	            }

	            function FW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return AJ(a | 0) | 0
	            }

	            function GW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return BJ(a | 0) | 0
	            }

	            function HW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return CJ(a | 0) | 0
	            }

	            function IW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return DJ(a | 0) | 0
	            }

	            function JW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return EJ(a | 0) | 0
	            }

	            function KW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return FJ(a | 0) | 0
	            }

	            function LW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return GJ(a | 0) | 0
	            }

	            function MW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return HJ(a | 0) | 0
	            }

	            function NW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return IJ(a | 0) | 0
	            }

	            function OW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return JJ(a | 0) | 0
	            }

	            function PW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return KJ(a | 0) | 0
	            }

	            function QW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return LJ(a | 0) | 0
	            }

	            function RW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return MJ(a | 0) | 0
	            }

	            function SW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return NJ(a | 0) | 0
	            }

	            function TW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return OJ(a | 0) | 0
	            }

	            function UW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return PJ(a | 0) | 0
	            }

	            function VW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return QJ(a | 0) | 0
	            }

	            function WW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return RJ(a | 0) | 0
	            }

	            function XW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return SJ(a | 0) | 0
	            }

	            function YW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return TJ(a | 0) | 0
	            }

	            function ZW(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return UJ(a | 0) | 0
	            }

	            function _W(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return VJ(a | 0) | 0
	            }

	            function $W(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return WJ(a | 0) | 0
	            }

	            function aX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return XJ(a | 0) | 0
	            }

	            function bX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return YJ(a | 0) | 0
	            }

	            function cX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return ZJ(a | 0) | 0
	            }

	            function dX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return _J(a | 0) | 0
	            }

	            function eX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return $J(a | 0) | 0
	            }

	            function fX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return aK(a | 0) | 0
	            }

	            function gX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return bK(a | 0) | 0
	            }

	            function hX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return cK(a | 0) | 0
	            }

	            function iX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return dK(a | 0) | 0
	            }

	            function jX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return eK(a | 0) | 0
	            }

	            function kX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return fK(a | 0) | 0
	            }

	            function lX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return gK(a | 0) | 0
	            }

	            function mX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return hK(a | 0) | 0
	            }

	            function nX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return iK(a | 0) | 0
	            }

	            function oX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return jK(a | 0) | 0
	            }

	            function pX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return kK(a | 0) | 0
	            }

	            function qX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return lK(a | 0) | 0
	            }

	            function rX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return mK(a | 0) | 0
	            }

	            function sX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return nK(a | 0) | 0
	            }

	            function tX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return oK(a | 0) | 0
	            }

	            function uX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return pK(a | 0) | 0
	            }

	            function vX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return qK(a | 0) | 0
	            }

	            function wX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return rK(a | 0) | 0
	            }

	            function xX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return sK(a | 0) | 0
	            }

	            function yX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return tK(a | 0) | 0
	            }

	            function zX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return uK(a | 0) | 0
	            }

	            function AX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return vK(a | 0) | 0
	            }

	            function BX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return wK(a | 0) | 0
	            }

	            function CX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return xK(a | 0) | 0
	            }

	            function DX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return yK(a | 0) | 0
	            }

	            function EX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return zK(a | 0) | 0
	            }

	            function FX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return AK(a | 0) | 0
	            }

	            function GX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return BK(a | 0) | 0
	            }

	            function HX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return CK(a | 0) | 0
	            }

	            function IX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return DK(a | 0) | 0
	            }

	            function JX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return EK(a | 0) | 0
	            }

	            function KX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return FK(a | 0) | 0
	            }

	            function LX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return GK(a | 0) | 0
	            }

	            function MX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return HK(a | 0) | 0
	            }

	            function NX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return IK(a | 0) | 0
	            }

	            function OX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return JK(a | 0) | 0
	            }

	            function PX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return KK(a | 0) | 0
	            }

	            function QX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return LK(a | 0) | 0
	            }

	            function RX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return MK(a | 0) | 0
	            }

	            function SX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return NK(a | 0) | 0
	            }

	            function TX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return OK(a | 0) | 0
	            }

	            function UX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return PK(a | 0) | 0
	            }

	            function VX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return QK(a | 0) | 0
	            }

	            function WX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return RK(a | 0) | 0
	            }

	            function XX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return SK(a | 0) | 0
	            }

	            function YX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return TK(a | 0) | 0
	            }

	            function ZX(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return UK(a | 0) | 0
	            }

	            function _X(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return VK(a | 0) | 0
	            }

	            function $X(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return WK(a | 0) | 0
	            }

	            function aY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return XK(a | 0) | 0
	            }

	            function bY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return YK(a | 0) | 0
	            }

	            function cY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return ZK(a | 0) | 0
	            }

	            function dY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return _K(a | 0) | 0
	            }

	            function eY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return $K(a | 0) | 0
	            }

	            function fY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return aL(a | 0) | 0
	            }

	            function gY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return bL(a | 0) | 0
	            }

	            function hY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return cL(a | 0) | 0
	            }

	            function iY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return dL(a | 0) | 0
	            }

	            function jY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return eL(a | 0) | 0
	            }

	            function kY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return RT(a | 0, b | 0, c | 0) | 0
	            }

	            function lY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function mY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Wb(a | 0) | 0
	            }

	            function nY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Xb(a | 0, b | 0) | 0
	            }

	            function oY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Yb(a | 0) | 0
	            }

	            function pY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function qY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function rY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function sY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return ac(a | 0, b | 0, c | 0) | 0
	            }

	            function tY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function uY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return gc(a | 0, b | 0, c | 0) | 0
	            }

	            function vY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function wY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function xY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function yY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function zY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function AY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return nc(a | 0) | 0
	            }

	            function BY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function CY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return nd(a | 0) | 0
	            }

	            function DY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function EY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function FY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function GY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function HY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function IY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function JY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function KY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function LY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function MY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function NY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function OY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function PY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function QY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function RY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return mk() | 0
	            }

	            function SY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function TY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function UY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return nk(a | 0) | 0
	            }

	            function VY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return ok(a | 0) | 0
	            }

	            function WY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return pk(a | 0, b | 0, c | 0) | 0
	            }

	            function XY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return qk(a | 0) | 0
	            }

	            function YY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return _k(a | 0) | 0
	            }

	            function ZY(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return $k(a | 0, b | 0, c | 0) | 0
	            }

	            function _Y(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return bl(a | 0) | 0
	            }

	            function $Y(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return cl(a | 0, b | 0, c | 0) | 0
	            }

	            function aZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return dl(a | 0) | 0
	            }

	            function bZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return el(a | 0, b | 0, c | 0) | 0
	            }

	            function cZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return fl(a | 0, b | 0, c | 0) | 0
	            }

	            function dZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function eZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function fZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return on(a | 0) | 0
	            }

	            function gZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function hZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return vn(a | 0) | 0
	            }

	            function iZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function jZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return yn(a | 0) | 0
	            }

	            function kZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function lZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function mZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function nZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Cn(a | 0, b | 0) | 0
	            }

	            function oZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function pZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function qZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function rZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function sZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function tZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function uZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return _n(a | 0, b | 0) | 0
	            }

	            function vZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function wZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function xZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function yZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function zZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function AZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function BZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function CZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function DZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function EZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function FZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function GZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function HZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function IZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function JZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function KZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function LZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function MZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function NZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function OZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function PZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function QZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function RZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function SZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function TZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function UZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function VZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function WZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function XZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function YZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function ZZ(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return uu(a | 0, b | 0, c | 0) | 0
	            }

	            function _Z(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return ds(a | 0, b | 0) | 0
	            }

	            function $Z(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return es(a | 0, b | 0) | 0
	            }

	            function a_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return js(a | 0, b | 0) | 0
	            }

	            function b_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return vu(a | 0, b | 0, c | 0) | 0
	            }

	            function c_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return wu(a | 0, b | 0) | 0
	            }

	            function d_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return $r(a | 0, b | 0) | 0
	            }

	            function e_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return as(a | 0, b | 0) | 0
	            }

	            function f_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return bs(a | 0, b | 0) | 0
	            }

	            function g_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return hs(a | 0, b | 0) | 0
	            }

	            function h_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return fs(a | 0, b | 0) | 0
	            }

	            function i_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return is(a | 0, b | 0) | 0
	            }

	            function j_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return cs(a | 0, b | 0) | 0
	            }

	            function k_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return xu(a | 0, b | 0) | 0
	            }

	            function l_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return gs(a | 0, b | 0) | 0
	            }

	            function m_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return _r(a | 0, b | 0) | 0
	            }

	            function n_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return dr(a | 0, b | 0) | 0
	            }

	            function o_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function p_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function q_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function r_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function s_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function t_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function u_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function v_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function w_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function x_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function y_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function z_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function A_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return $x(a | 0, b | 0) | 0
	            }

	            function B_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return dy(a | 0, b | 0) | 0
	            }

	            function C_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return fy(a | 0, b | 0) | 0
	            }

	            function D_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return jy(a | 0, b | 0) | 0
	            }

	            function E_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function F_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function G_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function H_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function I_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function J_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function K_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function L_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return RB(a | 0) | 0
	            }

	            function M_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return SB(a | 0) | 0
	            }

	            function N_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return TB(a | 0) | 0
	            }

	            function O_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return UB(a | 0, b | 0, c | 0) | 0
	            }

	            function P_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return VB(a | 0, b | 0) | 0
	            }

	            function Q_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function R_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function S_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function T_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function U_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function V_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function W_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function X_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function Y_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function Z_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function __(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function $_(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function a$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function b$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return hC(a | 0, b | 0) | 0
	            }

	            function c$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function d$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function e$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function f$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function g$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function h$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function i$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function j$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return rC(a | 0, b | 0, c | 0) | 0
	            }

	            function k$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function l$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function m$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function n$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function o$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function p$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function q$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function r$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function s$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function t$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function u$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function v$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function w$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function x$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return GM(a | 0, b | 0, c | 0) | 0
	            }

	            function y$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function z$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function A$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return nN(a | 0, b | 0) | 0
	            }

	            function B$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return oN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function C$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return qN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0) | 0
	            }

	            function D$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function E$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return tN(a | 0, b | 0) | 0
	            }

	            function F$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return uN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function G$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function H$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function I$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function J$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function K$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function L$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function M$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function N$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function O$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return 0
	            }

	            function P$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Q$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return QS(a | 0, b | 0) | 0
	            }

	            function R$(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                return hT(a | 0, b | 0, c | 0) | 0
	            }

	            function S$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                da(1);
	                return 0
	            }

	            function T$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function U$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return vc(a | 0) | 0
	            }

	            function V$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return wc(a | 0) | 0
	            }

	            function W$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return xc(a | 0) | 0
	            }

	            function X$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return zc(a | 0, b | 0) | 0
	            }

	            function Y$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Z$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function _$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function $$(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function a0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function b0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function c0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function d0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function e0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function f0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function g0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function h0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function i0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function j0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function k0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function l0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function m0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function n0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function o0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Qc(a | 0, b | 0) | 0
	            }

	            function p0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function q0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function r0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function s0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function t0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function u0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return iT(a | 0) | 0
	            }

	            function v0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return kT(a | 0, b | 0) | 0
	            }

	            function w0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return my(a | 0) | 0
	            }

	            function x0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function y0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function z0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return PP(a | 0) | 0
	            }

	            function A0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return QP(a | 0) | 0
	            }

	            function B0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return RP(a | 0) | 0
	            }

	            function C0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return VP(a | 0, b | 0) | 0
	            }

	            function D0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function E0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function F0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function G0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function H0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function I0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function J0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function K0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function L0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function M0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function N0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function O0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function P0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Q0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function R0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function S0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function T0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return WP(a | 0, b | 0) | 0
	            }

	            function U0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function V0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function W0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return LP(a | 0) | 0
	            }

	            function X0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return MP(a | 0) | 0
	            }

	            function Y0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return NP(a | 0) | 0
	            }

	            function Z0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return OP(a | 0) | 0
	            }

	            function _0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function $0(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return NI(a | 0) | 0
	            }

	            function a1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return OI(a | 0) | 0
	            }

	            function b1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return PI(a | 0) | 0
	            }

	            function c1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return QI(a | 0) | 0
	            }

	            function d1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return RI(a | 0) | 0
	            }

	            function e1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return SI(a | 0) | 0
	            }

	            function f1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return TI(a | 0) | 0
	            }

	            function g1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return UI(a | 0) | 0
	            }

	            function h1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return VI(a | 0) | 0
	            }

	            function i1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return WI(a | 0) | 0
	            }

	            function j1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return XI(a | 0) | 0
	            }

	            function k1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return YI(a | 0) | 0
	            }

	            function l1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return ZI(a | 0) | 0
	            }

	            function m1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return _I(a | 0) | 0
	            }

	            function n1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return $I(a | 0) | 0
	            }

	            function o1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return aJ(a | 0) | 0
	            }

	            function p1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return bJ(a | 0) | 0
	            }

	            function q1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return cJ(a | 0) | 0
	            }

	            function r1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return dJ(a | 0) | 0
	            }

	            function s1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return eJ(a | 0) | 0
	            }

	            function t1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return fJ(a | 0) | 0
	            }

	            function u1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return gJ(a | 0) | 0
	            }

	            function v1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return hJ(a | 0) | 0
	            }

	            function w1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return iJ(a | 0) | 0
	            }

	            function x1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return jJ(a | 0) | 0
	            }

	            function y1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return kJ(a | 0) | 0
	            }

	            function z1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return lJ(a | 0) | 0
	            }

	            function A1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return mJ(a | 0) | 0
	            }

	            function B1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return nJ(a | 0) | 0
	            }

	            function C1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return oJ(a | 0) | 0
	            }

	            function D1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return pJ(a | 0) | 0
	            }

	            function E1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return qJ(a | 0) | 0
	            }

	            function F1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return rJ(a | 0) | 0
	            }

	            function G1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return sJ(a | 0) | 0
	            }

	            function H1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return tJ(a | 0) | 0
	            }

	            function I1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return uJ(a | 0) | 0
	            }

	            function J1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return vJ(a | 0) | 0
	            }

	            function K1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return wJ(a | 0) | 0
	            }

	            function L1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return xJ(a | 0) | 0
	            }

	            function M1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return yJ(a | 0) | 0
	            }

	            function N1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return zJ(a | 0) | 0
	            }

	            function O1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return AJ(a | 0) | 0
	            }

	            function P1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return BJ(a | 0) | 0
	            }

	            function Q1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return CJ(a | 0) | 0
	            }

	            function R1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return DJ(a | 0) | 0
	            }

	            function S1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return EJ(a | 0) | 0
	            }

	            function T1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return FJ(a | 0) | 0
	            }

	            function U1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return GJ(a | 0) | 0
	            }

	            function V1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return HJ(a | 0) | 0
	            }

	            function W1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return IJ(a | 0) | 0
	            }

	            function X1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return JJ(a | 0) | 0
	            }

	            function Y1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return KJ(a | 0) | 0
	            }

	            function Z1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return LJ(a | 0) | 0
	            }

	            function _1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return MJ(a | 0) | 0
	            }

	            function $1(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return NJ(a | 0) | 0
	            }

	            function a2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return OJ(a | 0) | 0
	            }

	            function b2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return PJ(a | 0) | 0
	            }

	            function c2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return QJ(a | 0) | 0
	            }

	            function d2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return RJ(a | 0) | 0
	            }

	            function e2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return SJ(a | 0) | 0
	            }

	            function f2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return TJ(a | 0) | 0
	            }

	            function g2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return UJ(a | 0) | 0
	            }

	            function h2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return VJ(a | 0) | 0
	            }

	            function i2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return WJ(a | 0) | 0
	            }

	            function j2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return XJ(a | 0) | 0
	            }

	            function k2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return YJ(a | 0) | 0
	            }

	            function l2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return ZJ(a | 0) | 0
	            }

	            function m2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return _J(a | 0) | 0
	            }

	            function n2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return $J(a | 0) | 0
	            }

	            function o2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return aK(a | 0) | 0
	            }

	            function p2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return bK(a | 0) | 0
	            }

	            function q2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return cK(a | 0) | 0
	            }

	            function r2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return dK(a | 0) | 0
	            }

	            function s2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return eK(a | 0) | 0
	            }

	            function t2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return fK(a | 0) | 0
	            }

	            function u2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return gK(a | 0) | 0
	            }

	            function v2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return hK(a | 0) | 0
	            }

	            function w2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return iK(a | 0) | 0
	            }

	            function x2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return jK(a | 0) | 0
	            }

	            function y2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return kK(a | 0) | 0
	            }

	            function z2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return lK(a | 0) | 0
	            }

	            function A2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return mK(a | 0) | 0
	            }

	            function B2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return nK(a | 0) | 0
	            }

	            function C2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return oK(a | 0) | 0
	            }

	            function D2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return pK(a | 0) | 0
	            }

	            function E2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return qK(a | 0) | 0
	            }

	            function F2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return rK(a | 0) | 0
	            }

	            function G2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return sK(a | 0) | 0
	            }

	            function H2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return tK(a | 0) | 0
	            }

	            function I2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return uK(a | 0) | 0
	            }

	            function J2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return vK(a | 0) | 0
	            }

	            function K2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return wK(a | 0) | 0
	            }

	            function L2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return xK(a | 0) | 0
	            }

	            function M2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return yK(a | 0) | 0
	            }

	            function N2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return zK(a | 0) | 0
	            }

	            function O2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return AK(a | 0) | 0
	            }

	            function P2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return BK(a | 0) | 0
	            }

	            function Q2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return CK(a | 0) | 0
	            }

	            function R2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return DK(a | 0) | 0
	            }

	            function S2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return EK(a | 0) | 0
	            }

	            function T2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return FK(a | 0) | 0
	            }

	            function U2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return GK(a | 0) | 0
	            }

	            function V2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return HK(a | 0) | 0
	            }

	            function W2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return IK(a | 0) | 0
	            }

	            function X2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return JK(a | 0) | 0
	            }

	            function Y2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return KK(a | 0) | 0
	            }

	            function Z2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return LK(a | 0) | 0
	            }

	            function _2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return MK(a | 0) | 0
	            }

	            function $2(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return NK(a | 0) | 0
	            }

	            function a3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return OK(a | 0) | 0
	            }

	            function b3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return PK(a | 0) | 0
	            }

	            function c3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return QK(a | 0) | 0
	            }

	            function d3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return RK(a | 0) | 0
	            }

	            function e3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return SK(a | 0) | 0
	            }

	            function f3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return TK(a | 0) | 0
	            }

	            function g3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return UK(a | 0) | 0
	            }

	            function h3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return VK(a | 0) | 0
	            }

	            function i3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return WK(a | 0) | 0
	            }

	            function j3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return XK(a | 0) | 0
	            }

	            function k3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return YK(a | 0) | 0
	            }

	            function l3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return ZK(a | 0) | 0
	            }

	            function m3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return _K(a | 0) | 0
	            }

	            function n3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return $K(a | 0) | 0
	            }

	            function o3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return aL(a | 0) | 0
	            }

	            function p3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return bL(a | 0) | 0
	            }

	            function q3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return cL(a | 0) | 0
	            }

	            function r3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return dL(a | 0) | 0
	            }

	            function s3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return eL(a | 0) | 0
	            }

	            function t3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function u3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Wb(a | 0) | 0
	            }

	            function v3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Xb(a | 0, b | 0) | 0
	            }

	            function w3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Yb(a | 0) | 0
	            }

	            function x3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function y3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function z3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function A3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function B3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function C3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function D3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function E3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function F3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return nc(a | 0) | 0
	            }

	            function G3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function H3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return nd(a | 0) | 0
	            }

	            function I3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Kd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function J3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Ld(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function K3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Md(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function L3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Nd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function M3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Od(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function N3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Pd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function O3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return qd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function P3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return rd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function Q3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Qd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function R3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Rd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function S3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return fo(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function T3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function U3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function V3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function W3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return mk() | 0
	            }

	            function X3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Y3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Z3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return nk(a | 0) | 0
	            }

	            function _3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return ok(a | 0) | 0
	            }

	            function $3(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return qk(a | 0) | 0
	            }

	            function a4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return _k(a | 0) | 0
	            }

	            function b4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return bl(a | 0) | 0
	            }

	            function c4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return dl(a | 0) | 0
	            }

	            function d4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return gl(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function e4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function f4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return on(a | 0) | 0
	            }

	            function g4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function h4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return vn(a | 0) | 0
	            }

	            function i4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function j4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return yn(a | 0) | 0
	            }

	            function k4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function l4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function m4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function n4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return Cn(a | 0, b | 0) | 0
	            }

	            function o4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function p4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function q4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function r4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function s4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function t4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function u4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return _n(a | 0, b | 0) | 0
	            }

	            function v4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function w4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function x4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function y4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function z4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function A4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function B4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function C4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function D4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function E4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function F4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function G4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function H4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function I4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function J4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function K4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function L4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function M4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function N4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function O4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function P4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Q4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function R4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function S4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function T4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function U4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function V4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function W4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function X4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Y4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Z4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return ds(a | 0, b | 0) | 0
	            }

	            function _4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return es(a | 0, b | 0) | 0
	            }

	            function $4(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return js(a | 0, b | 0) | 0
	            }

	            function a5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return wu(a | 0, b | 0) | 0
	            }

	            function b5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return $r(a | 0, b | 0) | 0
	            }

	            function c5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return as(a | 0, b | 0) | 0
	            }

	            function d5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return bs(a | 0, b | 0) | 0
	            }

	            function e5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return hs(a | 0, b | 0) | 0
	            }

	            function f5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return fs(a | 0, b | 0) | 0
	            }

	            function g5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return is(a | 0, b | 0) | 0
	            }

	            function h5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return cs(a | 0, b | 0) | 0
	            }

	            function i5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return xu(a | 0, b | 0) | 0
	            }

	            function j5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return gs(a | 0, b | 0) | 0
	            }

	            function k5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return _r(a | 0, b | 0) | 0
	            }

	            function l5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return dr(a | 0, b | 0) | 0
	            }

	            function m5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function n5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function o5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function p5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function q5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function r5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function s5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function t5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function u5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function v5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function w5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function x5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return $x(a | 0, b | 0) | 0
	            }

	            function y5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return dy(a | 0, b | 0) | 0
	            }

	            function z5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return fy(a | 0, b | 0) | 0
	            }

	            function A5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return jy(a | 0, b | 0) | 0
	            }

	            function B5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function C5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function D5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function E5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function F5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function G5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function H5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function I5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return RB(a | 0) | 0
	            }

	            function J5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return SB(a | 0) | 0
	            }

	            function K5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return TB(a | 0) | 0
	            }

	            function L5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return VB(a | 0, b | 0) | 0
	            }

	            function M5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function N5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function O5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function P5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Q5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function R5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function S5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function T5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function U5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function V5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function W5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function X5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Y5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function Z5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return hC(a | 0, b | 0) | 0
	            }

	            function _5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function $5(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function a6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function b6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function c6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function d6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function e6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function f6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function g6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function h6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function i6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function j6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function k6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function l6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function m6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function n6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function o6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function p6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function q6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function r6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function s6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function t6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function u6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return nN(a | 0, b | 0) | 0
	            }

	            function v6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return oN(a | 0, b | 0, c | 0, 0, 0) | 0
	            }

	            function w6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return pN(a | 0, b | 0, c | 0, 0, 0, 0, 0) | 0
	            }

	            function x6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return qN(a | 0, b | 0, c | 0, 0, 0, 0) | 0
	            }

	            function y6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function z6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return tN(a | 0, b | 0) | 0
	            }

	            function A6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return uN(a | 0, b | 0, c | 0, 0, 0) | 0
	            }

	            function B6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return vN(a | 0, b | 0, c | 0, 0, 0, 0, 0) | 0
	            }

	            function C6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function D6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function E6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function F6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function G6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function H6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function I6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function J6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function K6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return 0
	            }

	            function L6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return WR(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function M6(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                return QS(a | 0, b | 0) | 0
	            }

	            function N6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                da(2)
	            }

	            function O6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function P6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vc(a | 0) | 0
	            }

	            function Q6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wc(a | 0) | 0
	            }

	            function R6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xc(a | 0) | 0
	            }

	            function S6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                yc(a | 0, b | 0, c | 0) | 0
	            }

	            function T6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function U6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Ac(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function V6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Bc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function W6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Dc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function X6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Ec(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Y6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Fc(a | 0, b | 0)
	            }

	            function Z6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Gc(a | 0)
	            }

	            function _6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Hc(a | 0)
	            }

	            function $6(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Wc(a | 0, b | 0, c | 0)
	            }

	            function a7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Xc(a | 0, b | 0)
	            }

	            function b7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Ic(a | 0, b | 0)
	            }

	            function c7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Jc(a | 0, b | 0, c | 0)
	            }

	            function d7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Kc(a | 0, b | 0, c | 0)
	            }

	            function e7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Lc(a | 0, b | 0, c | 0)
	            }

	            function f7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Mc(a | 0, b | 0)
	            }

	            function g7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Nc(a | 0, b | 0, c | 0)
	            }

	            function h7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Oc(a | 0, b | 0, c | 0)
	            }

	            function i7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Pc(a | 0, b | 0, c | 0)
	            }

	            function j7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function k7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Rc(a | 0, b | 0, c | 0)
	            }

	            function l7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Sc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function m7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Tc(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, 0, 0)
	            }

	            function n7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function o7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function p7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jT(a | 0)
	            }

	            function q7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                iT(a | 0) | 0
	            }

	            function r7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function s7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                my(a | 0) | 0
	            }

	            function t7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Td(a | 0, b | 0, c | 0)
	            }

	            function u7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                SP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function v7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                PP(a | 0) | 0
	            }

	            function w7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                QP(a | 0) | 0
	            }

	            function x7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                RP(a | 0) | 0
	            }

	            function y7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                UP(a | 0, b | 0, c | 0) | 0
	            }

	            function z7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function A7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                XP(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function B7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _P(a | 0, b | 0, c | 0, d | 0)
	            }

	            function C7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ZP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function D7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $P(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function E7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                aQ(a | 0, b | 0)
	            }

	            function F7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bQ(a | 0)
	            }

	            function G7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cQ(a | 0)
	            }

	            function H7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dQ(a | 0, b | 0, c | 0)
	            }

	            function I7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                eQ(a | 0, b | 0)
	            }

	            function J7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hQ(a | 0, b | 0)
	            }

	            function K7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                iQ(a | 0, b | 0, c | 0)
	            }

	            function L7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                kQ(a | 0, b | 0, c | 0)
	            }

	            function M7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                lQ(a | 0, b | 0)
	            }

	            function N7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $d(a | 0, b | 0, c | 0)
	            }

	            function O7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _d(a | 0, b | 0, c | 0)
	            }

	            function P7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function Q7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                mQ(a | 0, b | 0, c | 0)
	            }

	            function R7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                TP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function S7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                LP(a | 0) | 0
	            }

	            function T7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                MP(a | 0) | 0
	            }

	            function U7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                NP(a | 0) | 0
	            }

	            function V7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                OP(a | 0) | 0
	            }

	            function W7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jQ(a | 0, b | 0, c | 0)
	            }

	            function X7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                NI(a | 0) | 0
	            }

	            function Y7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                OI(a | 0) | 0
	            }

	            function Z7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                PI(a | 0) | 0
	            }

	            function _7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                QI(a | 0) | 0
	            }

	            function $7(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                RI(a | 0) | 0
	            }

	            function a8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                SI(a | 0) | 0
	            }

	            function b8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                TI(a | 0) | 0
	            }

	            function c8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                UI(a | 0) | 0
	            }

	            function d8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                VI(a | 0) | 0
	            }

	            function e8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                WI(a | 0) | 0
	            }

	            function f8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                XI(a | 0) | 0
	            }

	            function g8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                YI(a | 0) | 0
	            }

	            function h8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ZI(a | 0) | 0
	            }

	            function i8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _I(a | 0) | 0
	            }

	            function j8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $I(a | 0) | 0
	            }

	            function k8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                aJ(a | 0) | 0
	            }

	            function l8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bJ(a | 0) | 0
	            }

	            function m8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cJ(a | 0) | 0
	            }

	            function n8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dJ(a | 0) | 0
	            }

	            function o8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                eJ(a | 0) | 0
	            }

	            function p8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fJ(a | 0) | 0
	            }

	            function q8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gJ(a | 0) | 0
	            }

	            function r8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hJ(a | 0) | 0
	            }

	            function s8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                iJ(a | 0) | 0
	            }

	            function t8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jJ(a | 0) | 0
	            }

	            function u8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                kJ(a | 0) | 0
	            }

	            function v8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                lJ(a | 0) | 0
	            }

	            function w8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                mJ(a | 0) | 0
	            }

	            function x8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nJ(a | 0) | 0
	            }

	            function y8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                oJ(a | 0) | 0
	            }

	            function z8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                pJ(a | 0) | 0
	            }

	            function A8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qJ(a | 0) | 0
	            }

	            function B8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rJ(a | 0) | 0
	            }

	            function C8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                sJ(a | 0) | 0
	            }

	            function D8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tJ(a | 0) | 0
	            }

	            function E8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uJ(a | 0) | 0
	            }

	            function F8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vJ(a | 0) | 0
	            }

	            function G8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wJ(a | 0) | 0
	            }

	            function H8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xJ(a | 0) | 0
	            }

	            function I8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                yJ(a | 0) | 0
	            }

	            function J8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                zJ(a | 0) | 0
	            }

	            function K8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                AJ(a | 0) | 0
	            }

	            function L8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                BJ(a | 0) | 0
	            }

	            function M8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                CJ(a | 0) | 0
	            }

	            function N8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                DJ(a | 0) | 0
	            }

	            function O8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                EJ(a | 0) | 0
	            }

	            function P8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                FJ(a | 0) | 0
	            }

	            function Q8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                GJ(a | 0) | 0
	            }

	            function R8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                HJ(a | 0) | 0
	            }

	            function S8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                IJ(a | 0) | 0
	            }

	            function T8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                JJ(a | 0) | 0
	            }

	            function U8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                KJ(a | 0) | 0
	            }

	            function V8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                LJ(a | 0) | 0
	            }

	            function W8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                MJ(a | 0) | 0
	            }

	            function X8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                NJ(a | 0) | 0
	            }

	            function Y8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                OJ(a | 0) | 0
	            }

	            function Z8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                PJ(a | 0) | 0
	            }

	            function _8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                QJ(a | 0) | 0
	            }

	            function $8(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                RJ(a | 0) | 0
	            }

	            function a9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                SJ(a | 0) | 0
	            }

	            function b9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                TJ(a | 0) | 0
	            }

	            function c9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                UJ(a | 0) | 0
	            }

	            function d9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                VJ(a | 0) | 0
	            }

	            function e9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                WJ(a | 0) | 0
	            }

	            function f9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                XJ(a | 0) | 0
	            }

	            function g9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                YJ(a | 0) | 0
	            }

	            function h9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ZJ(a | 0) | 0
	            }

	            function i9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _J(a | 0) | 0
	            }

	            function j9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $J(a | 0) | 0
	            }

	            function k9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                aK(a | 0) | 0
	            }

	            function l9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bK(a | 0) | 0
	            }

	            function m9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cK(a | 0) | 0
	            }

	            function n9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dK(a | 0) | 0
	            }

	            function o9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                eK(a | 0) | 0
	            }

	            function p9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fK(a | 0) | 0
	            }

	            function q9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gK(a | 0) | 0
	            }

	            function r9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hK(a | 0) | 0
	            }

	            function s9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                iK(a | 0) | 0
	            }

	            function t9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jK(a | 0) | 0
	            }

	            function u9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                kK(a | 0) | 0
	            }

	            function v9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                lK(a | 0) | 0
	            }

	            function w9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                mK(a | 0) | 0
	            }

	            function x9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nK(a | 0) | 0
	            }

	            function y9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                oK(a | 0) | 0
	            }

	            function z9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                pK(a | 0) | 0
	            }

	            function A9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qK(a | 0) | 0
	            }

	            function B9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rK(a | 0) | 0
	            }

	            function C9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                sK(a | 0) | 0
	            }

	            function D9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tK(a | 0) | 0
	            }

	            function E9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uK(a | 0) | 0
	            }

	            function F9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vK(a | 0) | 0
	            }

	            function G9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wK(a | 0) | 0
	            }

	            function H9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xK(a | 0) | 0
	            }

	            function I9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                yK(a | 0) | 0
	            }

	            function J9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                zK(a | 0) | 0
	            }

	            function K9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                AK(a | 0) | 0
	            }

	            function L9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                BK(a | 0) | 0
	            }

	            function M9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                CK(a | 0) | 0
	            }

	            function N9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                DK(a | 0) | 0
	            }

	            function O9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                EK(a | 0) | 0
	            }

	            function P9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                FK(a | 0) | 0
	            }

	            function Q9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                GK(a | 0) | 0
	            }

	            function R9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                HK(a | 0) | 0
	            }

	            function S9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                IK(a | 0) | 0
	            }

	            function T9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                JK(a | 0) | 0
	            }

	            function U9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                KK(a | 0) | 0
	            }

	            function V9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                LK(a | 0) | 0
	            }

	            function W9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                MK(a | 0) | 0
	            }

	            function X9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                NK(a | 0) | 0
	            }

	            function Y9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                OK(a | 0) | 0
	            }

	            function Z9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                PK(a | 0) | 0
	            }

	            function _9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                QK(a | 0) | 0
	            }

	            function $9(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                RK(a | 0) | 0
	            }

	            function aaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                SK(a | 0) | 0
	            }

	            function baa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                TK(a | 0) | 0
	            }

	            function caa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                UK(a | 0) | 0
	            }

	            function daa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                VK(a | 0) | 0
	            }

	            function eaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                WK(a | 0) | 0
	            }

	            function faa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                XK(a | 0) | 0
	            }

	            function gaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                YK(a | 0) | 0
	            }

	            function haa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ZK(a | 0) | 0
	            }

	            function iaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _K(a | 0) | 0
	            }

	            function jaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $K(a | 0) | 0
	            }

	            function kaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                aL(a | 0) | 0
	            }

	            function laa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bL(a | 0) | 0
	            }

	            function maa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cL(a | 0) | 0
	            }

	            function naa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dL(a | 0) | 0
	            }

	            function oaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                eL(a | 0) | 0
	            }

	            function paa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                RT(a | 0, b | 0, c | 0) | 0
	            }

	            function qaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Vb(a | 0)
	            }

	            function raa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Wb(a | 0) | 0
	            }

	            function saa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function taa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Yb(a | 0) | 0
	            }

	            function uaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function vaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _b(a | 0)
	            }

	            function waa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $b(a | 0)
	            }

	            function xaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ac(a | 0, b | 0, c | 0) | 0
	            }

	            function yaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function zaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gc(a | 0, b | 0, c | 0) | 0
	            }

	            function Aaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hc(a | 0)
	            }

	            function Baa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ic(a | 0, b | 0, c | 0)
	            }

	            function Caa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jc(a | 0, b | 0, c | 0)
	            }

	            function Daa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                kc(a | 0, b | 0, c | 0)
	            }

	            function Eaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                lc(a | 0, b | 0, c | 0)
	            }

	            function Faa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nc(a | 0) | 0
	            }

	            function Gaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                md(a | 0, b | 0)
	            }

	            function Haa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nd(a | 0) | 0
	            }

	            function Iaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Jaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Kaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Laa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Maa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Naa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Oaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Paa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Qaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Raa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Saa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Taa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ae(a | 0, b | 0, c | 0)
	            }

	            function Uaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                be(a | 0, b | 0, c | 0)
	            }

	            function Vaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tg(a | 0)
	            }

	            function Waa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                mk() | 0
	            }

	            function Xaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                sh(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Yaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gk(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Zaa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nk(a | 0) | 0
	            }

	            function _aa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ok(a | 0) | 0
	            }

	            function $aa(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                pk(a | 0, b | 0, c | 0) | 0
	            }

	            function aba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qk(a | 0) | 0
	            }

	            function bba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _k(a | 0) | 0
	            }

	            function cba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $k(a | 0, b | 0, c | 0) | 0
	            }

	            function dba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bl(a | 0) | 0
	            }

	            function eba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cl(a | 0, b | 0, c | 0) | 0
	            }

	            function fba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dl(a | 0) | 0
	            }

	            function gba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                el(a | 0, b | 0, c | 0) | 0
	            }

	            function hba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fl(a | 0, b | 0, c | 0) | 0
	            }

	            function iba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function jba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nn(a | 0)
	            }

	            function kba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                on(a | 0) | 0
	            }

	            function lba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                sn(a | 0)
	            }

	            function mba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vn(a | 0) | 0
	            }

	            function nba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xn(a | 0)
	            }

	            function oba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                yn(a | 0) | 0
	            }

	            function pba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                zn(a | 0, b | 0)
	            }

	            function qba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                An(a | 0)
	            }

	            function rba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Bn(a | 0)
	            }

	            function sba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function tba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Dn(a | 0)
	            }

	            function uba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                In(a | 0, b | 0, c | 0)
	            }

	            function vba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Rn(a | 0, b | 0, c | 0)
	            }

	            function wba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Sn(a | 0, b | 0, c | 0)
	            }

	            function xba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Tn(a | 0, b | 0, c | 0)
	            }

	            function yba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Un(a | 0, b | 0, c | 0)
	            }

	            function zba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function Aba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tq(a | 0, b | 0)
	            }

	            function Bba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Qq(a | 0)
	            }

	            function Cba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Bs(a | 0, b | 0)
	            }

	            function Dba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Is(a | 0, b | 0)
	            }

	            function Eba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ns(a | 0, b | 0)
	            }

	            function Fba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ts(a | 0, b | 0)
	            }

	            function Gba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                us(a | 0, b | 0)
	            }

	            function Hba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                os(a | 0, b | 0)
	            }

	            function Iba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Es(a | 0, b | 0)
	            }

	            function Jba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Hs(a | 0, b | 0)
	            }

	            function Kba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ls(a | 0, b | 0)
	            }

	            function Lba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Fs(a | 0, b | 0)
	            }

	            function Mba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ps(a | 0, b | 0)
	            }

	            function Nba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Cs(a | 0, b | 0)
	            }

	            function Oba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nt(a | 0, b | 0)
	            }

	            function Pba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qs(a | 0, b | 0)
	            }

	            function Qba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                zs(a | 0, b | 0)
	            }

	            function Rba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Tr(a | 0, b | 0)
	            }

	            function Sba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ms(a | 0, b | 0)
	            }

	            function Tba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Js(a | 0, b | 0)
	            }

	            function Uba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rs(a | 0, b | 0)
	            }

	            function Vba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ss(a | 0, b | 0)
	            }

	            function Wba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vs(a | 0, b | 0)
	            }

	            function Xba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ws(a | 0, b | 0)
	            }

	            function Yba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xs(a | 0, b | 0)
	            }

	            function Zba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ys(a | 0, b | 0)
	            }

	            function _ba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Gs(a | 0, b | 0)
	            }

	            function $ba(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Ds(a | 0, b | 0)
	            }

	            function aca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                As(a | 0, b | 0)
	            }

	            function bca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ot(a | 0, b | 0)
	            }

	            function cca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uu(a | 0, b | 0, c | 0) | 0
	            }

	            function dca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function eca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function fca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function gca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vu(a | 0, b | 0, c | 0) | 0
	            }

	            function hca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function ica(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function jca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function kca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function lca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function mca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function nca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function oca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function pca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function qca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function rca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function sca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function tca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jv(a | 0, b | 0)
	            }

	            function uca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                pv(a | 0, b | 0)
	            }

	            function vca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qv(a | 0, b | 0)
	            }

	            function wca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rv(a | 0, b | 0)
	            }

	            function xca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                sv(a | 0, b | 0)
	            }

	            function yca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tv(a | 0, b | 0)
	            }

	            function zca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uv(a | 0, b | 0)
	            }

	            function Aca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vv(a | 0, b | 0)
	            }

	            function Bca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tw(a | 0, b | 0, c | 0)
	            }

	            function Cca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Mw(a | 0)
	            }

	            function Dca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Yw(a | 0)
	            }

	            function Eca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function Fca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function Gca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function Hca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function Ica(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function Jca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qB(a | 0)
	            }

	            function Kca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                LB(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, 0, 0)
	            }

	            function Lca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                MB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Mca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                NB(a | 0, b | 0, c | 0)
	            }

	            function Nca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                OB(a | 0, b | 0, c | 0)
	            }

	            function Oca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                PB(a | 0, b | 0)
	            }

	            function Pca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                QB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Qca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                RB(a | 0) | 0
	            }

	            function Rca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                SB(a | 0) | 0
	            }

	            function Sca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                TB(a | 0) | 0
	            }

	            function Tca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                UB(a | 0, b | 0, c | 0) | 0
	            }

	            function Uca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function Vca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                WB(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function Wca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                XB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Xca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                ZB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Yca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                _B(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Zca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                $B(a | 0, b | 0)
	            }

	            function _ca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                aC(a | 0)
	            }

	            function $ca(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                bC(a | 0)
	            }

	            function ada(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                cC(a | 0, b | 0, c | 0)
	            }

	            function bda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                dC(a | 0, b | 0)
	            }

	            function cda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                eC(a | 0, b | 0, c | 0)
	            }

	            function dda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fC(a | 0, b | 0, c | 0)
	            }

	            function eda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gC(a | 0, b | 0, c | 0)
	            }

	            function fda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function gda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                iC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function hda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                jC(a | 0, b | 0, c | 0)
	            }

	            function ida(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                kC(a | 0, b | 0, c | 0)
	            }

	            function jda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                lC(a | 0, b | 0, c | 0)
	            }

	            function kda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                mC(a | 0, b | 0)
	            }

	            function lda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nC(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, 0, 0)
	            }

	            function mda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                oC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function nda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rC(a | 0, b | 0, c | 0) | 0
	            }

	            function oda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uC(a | 0)
	            }

	            function pda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                AD(a | 0, b | 0)
	            }

	            function qda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                lF(a | 0, b | 0, c | 0, d | 0)
	            }

	            function rda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uF(a | 0, b | 0)
	            }

	            function sda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                VA(a | 0)
	            }

	            function tda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wM(a | 0, b | 0, c | 0)
	            }

	            function uda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                xM(a | 0, b | 0)
	            }

	            function vda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                yM(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, 0, 0)
	            }

	            function wda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                zM(a | 0, b | 0, c | 0, d | 0)
	            }

	            function xda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                AM(a | 0, b | 0, c | 0)
	            }

	            function yda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                BM(a | 0, b | 0, c | 0)
	            }

	            function zda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                DM(a | 0, b | 0, c | 0)
	            }

	            function Ada(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                EM(a | 0, b | 0, c | 0)
	            }

	            function Bda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                GM(a | 0, b | 0, c | 0) | 0
	            }

	            function Cda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                FM(a | 0, b | 0)
	            }

	            function Dda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                UM(a | 0)
	            }

	            function Eda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function Fda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                oN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function Gda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                pN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0
	            }

	            function Hda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                qN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0) | 0
	            }

	            function Ida(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                rN(a | 0, b | 0)
	            }

	            function Jda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function Kda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                uN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function Lda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0
	            }

	            function Mda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wN(a | 0, b | 0)
	            }

	            function Nda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                CN(a | 0, b | 0, c | 0)
	            }

	            function Oda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                GN(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Pda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                vO(a | 0, b | 0, c | 0)
	            }

	            function Qda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                wO(a | 0, b | 0, c | 0)
	            }

	            function Rda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Sda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                sP(a | 0, b | 0, c | 0)
	            }

	            function Tda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                fQ(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0, 0, 0)
	            }

	            function Uda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                gQ(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Vda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Wda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function Xda(a, b, c, d, e, f, g) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                hT(a | 0, b | 0, c | 0) | 0
	            }

	            function Yda(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                da(3)
	            }

	            function Zda(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function _da(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vc(a | 0) | 0
	            }

	            function $da(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wc(a | 0) | 0
	            }

	            function aea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xc(a | 0) | 0
	            }

	            function bea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                yc(a | 0, b | 0, c | 0) | 0
	            }

	            function cea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function dea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Ac(a | 0, b | 0, c | 0, d | 0, e | 0, 0)
	            }

	            function eea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Bc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function fea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Cc(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0)
	            }

	            function gea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Dc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function hea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Fc(a | 0, b | 0)
	            }

	            function iea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Gc(a | 0)
	            }

	            function jea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Hc(a | 0)
	            }

	            function kea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Wc(a | 0, b | 0, c | 0)
	            }

	            function lea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Xc(a | 0, b | 0)
	            }

	            function mea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Ic(a | 0, b | 0)
	            }

	            function nea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Jc(a | 0, b | 0, c | 0)
	            }

	            function oea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Kc(a | 0, b | 0, c | 0)
	            }

	            function pea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Lc(a | 0, b | 0, c | 0)
	            }

	            function qea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Mc(a | 0, b | 0)
	            }

	            function rea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Nc(a | 0, b | 0, c | 0)
	            }

	            function sea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Oc(a | 0, b | 0, c | 0)
	            }

	            function tea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Pc(a | 0, b | 0, c | 0)
	            }

	            function uea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function vea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Rc(a | 0, b | 0, c | 0)
	            }

	            function wea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Sc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function xea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Tc(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0, 0, 0)
	            }

	            function yea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function zea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function Aea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jT(a | 0)
	            }

	            function Bea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                iT(a | 0) | 0
	            }

	            function Cea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function Dea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                my(a | 0) | 0
	            }

	            function Eea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Td(a | 0, b | 0, c | 0)
	            }

	            function Fea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                SP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Gea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                PP(a | 0) | 0
	            }

	            function Hea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                QP(a | 0) | 0
	            }

	            function Iea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                RP(a | 0) | 0
	            }

	            function Jea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                UP(a | 0, b | 0, c | 0) | 0
	            }

	            function Kea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function Lea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                XP(a | 0, b | 0, c | 0, d | 0, e | 0, 0)
	            }

	            function Mea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _P(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Nea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                YP(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0)
	            }

	            function Oea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ZP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Pea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                aQ(a | 0, b | 0)
	            }

	            function Qea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bQ(a | 0)
	            }

	            function Rea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cQ(a | 0)
	            }

	            function Sea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dQ(a | 0, b | 0, c | 0)
	            }

	            function Tea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                eQ(a | 0, b | 0)
	            }

	            function Uea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hQ(a | 0, b | 0)
	            }

	            function Vea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                iQ(a | 0, b | 0, c | 0)
	            }

	            function Wea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                kQ(a | 0, b | 0, c | 0)
	            }

	            function Xea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                lQ(a | 0, b | 0)
	            }

	            function Yea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $d(a | 0, b | 0, c | 0)
	            }

	            function Zea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _d(a | 0, b | 0, c | 0)
	            }

	            function _ea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function $ea(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                mQ(a | 0, b | 0, c | 0)
	            }

	            function afa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                TP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function bfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                LP(a | 0) | 0
	            }

	            function cfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                MP(a | 0) | 0
	            }

	            function dfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                NP(a | 0) | 0
	            }

	            function efa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                OP(a | 0) | 0
	            }

	            function ffa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jQ(a | 0, b | 0, c | 0)
	            }

	            function gfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                NI(a | 0) | 0
	            }

	            function hfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                OI(a | 0) | 0
	            }

	            function ifa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                PI(a | 0) | 0
	            }

	            function jfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                QI(a | 0) | 0
	            }

	            function kfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                RI(a | 0) | 0
	            }

	            function lfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                SI(a | 0) | 0
	            }

	            function mfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                TI(a | 0) | 0
	            }

	            function nfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                UI(a | 0) | 0
	            }

	            function ofa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                VI(a | 0) | 0
	            }

	            function pfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                WI(a | 0) | 0
	            }

	            function qfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                XI(a | 0) | 0
	            }

	            function rfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                YI(a | 0) | 0
	            }

	            function sfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ZI(a | 0) | 0
	            }

	            function tfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _I(a | 0) | 0
	            }

	            function ufa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $I(a | 0) | 0
	            }

	            function vfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                aJ(a | 0) | 0
	            }

	            function wfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bJ(a | 0) | 0
	            }

	            function xfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cJ(a | 0) | 0
	            }

	            function yfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dJ(a | 0) | 0
	            }

	            function zfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                eJ(a | 0) | 0
	            }

	            function Afa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fJ(a | 0) | 0
	            }

	            function Bfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gJ(a | 0) | 0
	            }

	            function Cfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hJ(a | 0) | 0
	            }

	            function Dfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                iJ(a | 0) | 0
	            }

	            function Efa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jJ(a | 0) | 0
	            }

	            function Ffa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                kJ(a | 0) | 0
	            }

	            function Gfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                lJ(a | 0) | 0
	            }

	            function Hfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                mJ(a | 0) | 0
	            }

	            function Ifa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nJ(a | 0) | 0
	            }

	            function Jfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                oJ(a | 0) | 0
	            }

	            function Kfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                pJ(a | 0) | 0
	            }

	            function Lfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qJ(a | 0) | 0
	            }

	            function Mfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rJ(a | 0) | 0
	            }

	            function Nfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                sJ(a | 0) | 0
	            }

	            function Ofa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tJ(a | 0) | 0
	            }

	            function Pfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uJ(a | 0) | 0
	            }

	            function Qfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vJ(a | 0) | 0
	            }

	            function Rfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wJ(a | 0) | 0
	            }

	            function Sfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xJ(a | 0) | 0
	            }

	            function Tfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                yJ(a | 0) | 0
	            }

	            function Ufa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                zJ(a | 0) | 0
	            }

	            function Vfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                AJ(a | 0) | 0
	            }

	            function Wfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                BJ(a | 0) | 0
	            }

	            function Xfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                CJ(a | 0) | 0
	            }

	            function Yfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                DJ(a | 0) | 0
	            }

	            function Zfa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                EJ(a | 0) | 0
	            }

	            function _fa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                FJ(a | 0) | 0
	            }

	            function $fa(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                GJ(a | 0) | 0
	            }

	            function aga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                HJ(a | 0) | 0
	            }

	            function bga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                IJ(a | 0) | 0
	            }

	            function cga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                JJ(a | 0) | 0
	            }

	            function dga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                KJ(a | 0) | 0
	            }

	            function ega(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                LJ(a | 0) | 0
	            }

	            function fga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                MJ(a | 0) | 0
	            }

	            function gga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                NJ(a | 0) | 0
	            }

	            function hga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                OJ(a | 0) | 0
	            }

	            function iga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                PJ(a | 0) | 0
	            }

	            function jga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                QJ(a | 0) | 0
	            }

	            function kga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                RJ(a | 0) | 0
	            }

	            function lga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                SJ(a | 0) | 0
	            }

	            function mga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                TJ(a | 0) | 0
	            }

	            function nga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                UJ(a | 0) | 0
	            }

	            function oga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                VJ(a | 0) | 0
	            }

	            function pga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                WJ(a | 0) | 0
	            }

	            function qga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                XJ(a | 0) | 0
	            }

	            function rga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                YJ(a | 0) | 0
	            }

	            function sga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ZJ(a | 0) | 0
	            }

	            function tga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _J(a | 0) | 0
	            }

	            function uga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $J(a | 0) | 0
	            }

	            function vga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                aK(a | 0) | 0
	            }

	            function wga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bK(a | 0) | 0
	            }

	            function xga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cK(a | 0) | 0
	            }

	            function yga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dK(a | 0) | 0
	            }

	            function zga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                eK(a | 0) | 0
	            }

	            function Aga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fK(a | 0) | 0
	            }

	            function Bga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gK(a | 0) | 0
	            }

	            function Cga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hK(a | 0) | 0
	            }

	            function Dga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                iK(a | 0) | 0
	            }

	            function Ega(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jK(a | 0) | 0
	            }

	            function Fga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                kK(a | 0) | 0
	            }

	            function Gga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                lK(a | 0) | 0
	            }

	            function Hga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                mK(a | 0) | 0
	            }

	            function Iga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nK(a | 0) | 0
	            }

	            function Jga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                oK(a | 0) | 0
	            }

	            function Kga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                pK(a | 0) | 0
	            }

	            function Lga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qK(a | 0) | 0
	            }

	            function Mga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rK(a | 0) | 0
	            }

	            function Nga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                sK(a | 0) | 0
	            }

	            function Oga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tK(a | 0) | 0
	            }

	            function Pga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uK(a | 0) | 0
	            }

	            function Qga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vK(a | 0) | 0
	            }

	            function Rga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wK(a | 0) | 0
	            }

	            function Sga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xK(a | 0) | 0
	            }

	            function Tga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                yK(a | 0) | 0
	            }

	            function Uga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                zK(a | 0) | 0
	            }

	            function Vga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                AK(a | 0) | 0
	            }

	            function Wga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                BK(a | 0) | 0
	            }

	            function Xga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                CK(a | 0) | 0
	            }

	            function Yga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                DK(a | 0) | 0
	            }

	            function Zga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                EK(a | 0) | 0
	            }

	            function _ga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                FK(a | 0) | 0
	            }

	            function $ga(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                GK(a | 0) | 0
	            }

	            function aha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                HK(a | 0) | 0
	            }

	            function bha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                IK(a | 0) | 0
	            }

	            function cha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                JK(a | 0) | 0
	            }

	            function dha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                KK(a | 0) | 0
	            }

	            function eha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                LK(a | 0) | 0
	            }

	            function fha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                MK(a | 0) | 0
	            }

	            function gha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                NK(a | 0) | 0
	            }

	            function hha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                OK(a | 0) | 0
	            }

	            function iha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                PK(a | 0) | 0
	            }

	            function jha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                QK(a | 0) | 0
	            }

	            function kha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                RK(a | 0) | 0
	            }

	            function lha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                SK(a | 0) | 0
	            }

	            function mha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                TK(a | 0) | 0
	            }

	            function nha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                UK(a | 0) | 0
	            }

	            function oha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                VK(a | 0) | 0
	            }

	            function pha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                WK(a | 0) | 0
	            }

	            function qha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                XK(a | 0) | 0
	            }

	            function rha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                YK(a | 0) | 0
	            }

	            function sha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ZK(a | 0) | 0
	            }

	            function tha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _K(a | 0) | 0
	            }

	            function uha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $K(a | 0) | 0
	            }

	            function vha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                aL(a | 0) | 0
	            }

	            function wha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bL(a | 0) | 0
	            }

	            function xha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cL(a | 0) | 0
	            }

	            function yha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dL(a | 0) | 0
	            }

	            function zha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                eL(a | 0) | 0
	            }

	            function Aha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                RT(a | 0, b | 0, c | 0) | 0
	            }

	            function Bha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Vb(a | 0)
	            }

	            function Cha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Wb(a | 0) | 0
	            }

	            function Dha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function Eha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Yb(a | 0) | 0
	            }

	            function Fha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function Gha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _b(a | 0)
	            }

	            function Hha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $b(a | 0)
	            }

	            function Iha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ac(a | 0, b | 0, c | 0) | 0
	            }

	            function Jha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function Kha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gc(a | 0, b | 0, c | 0) | 0
	            }

	            function Lha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hc(a | 0)
	            }

	            function Mha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ic(a | 0, b | 0, c | 0)
	            }

	            function Nha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jc(a | 0, b | 0, c | 0)
	            }

	            function Oha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                kc(a | 0, b | 0, c | 0)
	            }

	            function Pha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                lc(a | 0, b | 0, c | 0)
	            }

	            function Qha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nc(a | 0) | 0
	            }

	            function Rha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                md(a | 0, b | 0)
	            }

	            function Sha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nd(a | 0) | 0
	            }

	            function Tha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Uha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Vha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Wha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Xha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Yha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Zha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function _ha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function $ha(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function aia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function bia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function cia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ae(a | 0, b | 0, c | 0)
	            }

	            function dia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                be(a | 0, b | 0, c | 0)
	            }

	            function eia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tg(a | 0)
	            }

	            function fia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                mk() | 0
	            }

	            function gia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nk(a | 0) | 0
	            }

	            function hia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ok(a | 0) | 0
	            }

	            function iia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                pk(a | 0, b | 0, c | 0) | 0
	            }

	            function jia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qk(a | 0) | 0
	            }

	            function kia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _k(a | 0) | 0
	            }

	            function lia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $k(a | 0, b | 0, c | 0) | 0
	            }

	            function mia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bl(a | 0) | 0
	            }

	            function nia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cl(a | 0, b | 0, c | 0) | 0
	            }

	            function oia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dl(a | 0) | 0
	            }

	            function pia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                el(a | 0, b | 0, c | 0) | 0
	            }

	            function qia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fl(a | 0, b | 0, c | 0) | 0
	            }

	            function ria(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function sia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nn(a | 0)
	            }

	            function tia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                on(a | 0) | 0
	            }

	            function uia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                sn(a | 0)
	            }

	            function via(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vn(a | 0) | 0
	            }

	            function wia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xn(a | 0)
	            }

	            function xia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                yn(a | 0) | 0
	            }

	            function yia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                zn(a | 0, b | 0)
	            }

	            function zia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                An(a | 0)
	            }

	            function Aia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Bn(a | 0)
	            }

	            function Bia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function Cia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Dn(a | 0)
	            }

	            function Dia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                In(a | 0, b | 0, c | 0)
	            }

	            function Eia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Rn(a | 0, b | 0, c | 0)
	            }

	            function Fia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Sn(a | 0, b | 0, c | 0)
	            }

	            function Gia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Tn(a | 0, b | 0, c | 0)
	            }

	            function Hia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Un(a | 0, b | 0, c | 0)
	            }

	            function Iia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function Jia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tq(a | 0, b | 0)
	            }

	            function Kia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Qq(a | 0)
	            }

	            function Lia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Bs(a | 0, b | 0)
	            }

	            function Mia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Is(a | 0, b | 0)
	            }

	            function Nia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ns(a | 0, b | 0)
	            }

	            function Oia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ts(a | 0, b | 0)
	            }

	            function Pia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                us(a | 0, b | 0)
	            }

	            function Qia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                os(a | 0, b | 0)
	            }

	            function Ria(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Es(a | 0, b | 0)
	            }

	            function Sia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Hs(a | 0, b | 0)
	            }

	            function Tia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ls(a | 0, b | 0)
	            }

	            function Uia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Fs(a | 0, b | 0)
	            }

	            function Via(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ps(a | 0, b | 0)
	            }

	            function Wia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Cs(a | 0, b | 0)
	            }

	            function Xia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nt(a | 0, b | 0)
	            }

	            function Yia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qs(a | 0, b | 0)
	            }

	            function Zia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                zs(a | 0, b | 0)
	            }

	            function _ia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Tr(a | 0, b | 0)
	            }

	            function $ia(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ms(a | 0, b | 0)
	            }

	            function aja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Js(a | 0, b | 0)
	            }

	            function bja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rs(a | 0, b | 0)
	            }

	            function cja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ss(a | 0, b | 0)
	            }

	            function dja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vs(a | 0, b | 0)
	            }

	            function eja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ws(a | 0, b | 0)
	            }

	            function fja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xs(a | 0, b | 0)
	            }

	            function gja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ys(a | 0, b | 0)
	            }

	            function hja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Gs(a | 0, b | 0)
	            }

	            function ija(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Ds(a | 0, b | 0)
	            }

	            function jja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                As(a | 0, b | 0)
	            }

	            function kja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ot(a | 0, b | 0)
	            }

	            function lja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uu(a | 0, b | 0, c | 0) | 0
	            }

	            function mja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function nja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function oja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function pja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vu(a | 0, b | 0, c | 0) | 0
	            }

	            function qja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function rja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function sja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function tja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function uja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function vja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function wja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function xja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function yja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function zja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function Aja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function Bja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function Cja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jv(a | 0, b | 0)
	            }

	            function Dja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                pv(a | 0, b | 0)
	            }

	            function Eja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qv(a | 0, b | 0)
	            }

	            function Fja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rv(a | 0, b | 0)
	            }

	            function Gja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                sv(a | 0, b | 0)
	            }

	            function Hja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tv(a | 0, b | 0)
	            }

	            function Ija(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uv(a | 0, b | 0)
	            }

	            function Jja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vv(a | 0, b | 0)
	            }

	            function Kja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tw(a | 0, b | 0, c | 0)
	            }

	            function Lja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Mw(a | 0)
	            }

	            function Mja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Yw(a | 0)
	            }

	            function Nja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function Oja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function Pja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function Qja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function Rja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function Sja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qB(a | 0)
	            }

	            function Tja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                LB(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0, 0, 0)
	            }

	            function Uja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                MB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Vja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                NB(a | 0, b | 0, c | 0)
	            }

	            function Wja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                OB(a | 0, b | 0, c | 0)
	            }

	            function Xja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                PB(a | 0, b | 0)
	            }

	            function Yja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                QB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Zja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                RB(a | 0) | 0
	            }

	            function _ja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                SB(a | 0) | 0
	            }

	            function $ja(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                TB(a | 0) | 0
	            }

	            function aka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                UB(a | 0, b | 0, c | 0) | 0
	            }

	            function bka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function cka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                WB(a | 0, b | 0, c | 0, d | 0, e | 0, 0)
	            }

	            function dka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                XB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function eka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                YB(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0)
	            }

	            function fka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                ZB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function gka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                $B(a | 0, b | 0)
	            }

	            function hka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                aC(a | 0)
	            }

	            function ika(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                bC(a | 0)
	            }

	            function jka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                cC(a | 0, b | 0, c | 0)
	            }

	            function kka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                dC(a | 0, b | 0)
	            }

	            function lka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                eC(a | 0, b | 0, c | 0)
	            }

	            function mka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fC(a | 0, b | 0, c | 0)
	            }

	            function nka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gC(a | 0, b | 0, c | 0)
	            }

	            function oka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function pka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                iC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function qka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                jC(a | 0, b | 0, c | 0)
	            }

	            function rka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                kC(a | 0, b | 0, c | 0)
	            }

	            function ska(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                lC(a | 0, b | 0, c | 0)
	            }

	            function tka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                mC(a | 0, b | 0)
	            }

	            function uka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nC(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0, 0, 0)
	            }

	            function vka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                oC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function wka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rC(a | 0, b | 0, c | 0) | 0
	            }

	            function xka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uC(a | 0)
	            }

	            function yka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                AD(a | 0, b | 0)
	            }

	            function zka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                lF(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Aka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uF(a | 0, b | 0)
	            }

	            function Bka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                VA(a | 0)
	            }

	            function Cka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wM(a | 0, b | 0, c | 0)
	            }

	            function Dka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                xM(a | 0, b | 0)
	            }

	            function Eka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                yM(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0, 0, 0)
	            }

	            function Fka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                zM(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Gka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                AM(a | 0, b | 0, c | 0)
	            }

	            function Hka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                BM(a | 0, b | 0, c | 0)
	            }

	            function Ika(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                DM(a | 0, b | 0, c | 0)
	            }

	            function Jka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                EM(a | 0, b | 0, c | 0)
	            }

	            function Kka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                GM(a | 0, b | 0, c | 0) | 0
	            }

	            function Lka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                FM(a | 0, b | 0)
	            }

	            function Mka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                UM(a | 0)
	            }

	            function Nka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function Oka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                oN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function Pka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                pN(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0) | 0
	            }

	            function Qka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                qN(a | 0, b | 0, c | 0, d | 0, e | 0, 0) | 0
	            }

	            function Rka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                rN(a | 0, b | 0)
	            }

	            function Ska(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function Tka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                uN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function Uka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vN(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0) | 0
	            }

	            function Vka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wN(a | 0, b | 0)
	            }

	            function Wka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                CN(a | 0, b | 0, c | 0)
	            }

	            function Xka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                GN(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Yka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                vO(a | 0, b | 0, c | 0)
	            }

	            function Zka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                wO(a | 0, b | 0, c | 0)
	            }

	            function _ka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function $ka(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                sP(a | 0, b | 0, c | 0)
	            }

	            function ala(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                fQ(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0, 0, 0)
	            }

	            function bla(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                gQ(a | 0, b | 0, c | 0, d | 0)
	            }

	            function cla(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function dla(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function ela(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                hT(a | 0, b | 0, c | 0) | 0
	            }

	            function fla() {
	                da(4);
	                return 0
	            }

	            function gla() {
	                return 0
	            }

	            function hla() {
	                return vc(0) | 0
	            }

	            function ila() {
	                return wc(0) | 0
	            }

	            function jla() {
	                return xc(0) | 0
	            }

	            function kla() {
	                return yc(0, 0, 0) | 0
	            }

	            function lla() {
	                return zc(0, 0) | 0
	            }

	            function mla() {
	                return 0
	            }

	            function nla() {
	                return 0
	            }

	            function ola() {
	                return 0
	            }

	            function pla() {
	                return 0
	            }

	            function qla() {
	                return 0
	            }

	            function rla() {
	                return 0
	            }

	            function sla() {
	                return 0
	            }

	            function tla() {
	                return 0
	            }

	            function ula() {
	                return 0
	            }

	            function vla() {
	                return 0
	            }

	            function wla() {
	                return 0
	            }

	            function xla() {
	                return 0
	            }

	            function yla() {
	                return 0
	            }

	            function zla() {
	                return 0
	            }

	            function Ala() {
	                return 0
	            }

	            function Bla() {
	                return 0
	            }

	            function Cla() {
	                return 0
	            }

	            function Dla() {
	                return 0
	            }

	            function Ela() {
	                return Qc(0, 0) | 0
	            }

	            function Fla() {
	                return 0
	            }

	            function Gla() {
	                return 0
	            }

	            function Hla() {
	                return 0
	            }

	            function Ila() {
	                return 0
	            }

	            function Jla() {
	                return Xk(0, 0, 0) | 0
	            }

	            function Kla() {
	                return 0
	            }

	            function Lla() {
	                return iT(0) | 0
	            }

	            function Mla() {
	                return kT(0, 0) | 0
	            }

	            function Nla() {
	                return my(0) | 0
	            }

	            function Ola() {
	                return 0
	            }

	            function Pla() {
	                return 0
	            }

	            function Qla() {
	                return PP(0) | 0
	            }

	            function Rla() {
	                return QP(0) | 0
	            }

	            function Sla() {
	                return RP(0) | 0
	            }

	            function Tla() {
	                return UP(0, 0, 0) | 0
	            }

	            function Ula() {
	                return VP(0, 0) | 0
	            }

	            function Vla() {
	                return 0
	            }

	            function Wla() {
	                return 0
	            }

	            function Xla() {
	                return 0
	            }

	            function Yla() {
	                return 0
	            }

	            function Zla() {
	                return 0
	            }

	            function _la() {
	                return 0
	            }

	            function $la() {
	                return 0
	            }

	            function ama() {
	                return 0
	            }

	            function bma() {
	                return 0
	            }

	            function cma() {
	                return 0
	            }

	            function dma() {
	                return 0
	            }

	            function ema() {
	                return 0
	            }

	            function fma() {
	                return 0
	            }

	            function gma() {
	                return 0
	            }

	            function hma() {
	                return 0
	            }

	            function ima() {
	                return 0
	            }

	            function jma() {
	                return WP(0, 0) | 0
	            }

	            function kma() {
	                return 0
	            }

	            function lma() {
	                return 0
	            }

	            function mma() {
	                return LP(0) | 0
	            }

	            function nma() {
	                return MP(0) | 0
	            }

	            function oma() {
	                return NP(0) | 0
	            }

	            function pma() {
	                return OP(0) | 0
	            }

	            function qma() {
	                return 0
	            }

	            function rma() {
	                return NI(0) | 0
	            }

	            function sma() {
	                return OI(0) | 0
	            }

	            function tma() {
	                return PI(0) | 0
	            }

	            function uma() {
	                return QI(0) | 0
	            }

	            function vma() {
	                return RI(0) | 0
	            }

	            function wma() {
	                return SI(0) | 0
	            }

	            function xma() {
	                return TI(0) | 0
	            }

	            function yma() {
	                return UI(0) | 0
	            }

	            function zma() {
	                return VI(0) | 0
	            }

	            function Ama() {
	                return WI(0) | 0
	            }

	            function Bma() {
	                return XI(0) | 0
	            }

	            function Cma() {
	                return YI(0) | 0
	            }

	            function Dma() {
	                return ZI(0) | 0
	            }

	            function Ema() {
	                return _I(0) | 0
	            }

	            function Fma() {
	                return $I(0) | 0
	            }

	            function Gma() {
	                return aJ(0) | 0
	            }

	            function Hma() {
	                return bJ(0) | 0
	            }

	            function Ima() {
	                return cJ(0) | 0
	            }

	            function Jma() {
	                return dJ(0) | 0
	            }

	            function Kma() {
	                return eJ(0) | 0
	            }

	            function Lma() {
	                return fJ(0) | 0
	            }

	            function Mma() {
	                return gJ(0) | 0
	            }

	            function Nma() {
	                return hJ(0) | 0
	            }

	            function Oma() {
	                return iJ(0) | 0
	            }

	            function Pma() {
	                return jJ(0) | 0
	            }

	            function Qma() {
	                return kJ(0) | 0
	            }

	            function Rma() {
	                return lJ(0) | 0
	            }

	            function Sma() {
	                return mJ(0) | 0
	            }

	            function Tma() {
	                return nJ(0) | 0
	            }

	            function Uma() {
	                return oJ(0) | 0
	            }

	            function Vma() {
	                return pJ(0) | 0
	            }

	            function Wma() {
	                return qJ(0) | 0
	            }

	            function Xma() {
	                return rJ(0) | 0
	            }

	            function Yma() {
	                return sJ(0) | 0
	            }

	            function Zma() {
	                return tJ(0) | 0
	            }

	            function _ma() {
	                return uJ(0) | 0
	            }

	            function $ma() {
	                return vJ(0) | 0
	            }

	            function ana() {
	                return wJ(0) | 0
	            }

	            function bna() {
	                return xJ(0) | 0
	            }

	            function cna() {
	                return yJ(0) | 0
	            }

	            function dna() {
	                return zJ(0) | 0
	            }

	            function ena() {
	                return AJ(0) | 0
	            }

	            function fna() {
	                return BJ(0) | 0
	            }

	            function gna() {
	                return CJ(0) | 0
	            }

	            function hna() {
	                return DJ(0) | 0
	            }

	            function ina() {
	                return EJ(0) | 0
	            }

	            function jna() {
	                return FJ(0) | 0
	            }

	            function kna() {
	                return GJ(0) | 0
	            }

	            function lna() {
	                return HJ(0) | 0
	            }

	            function mna() {
	                return IJ(0) | 0
	            }

	            function nna() {
	                return JJ(0) | 0
	            }

	            function ona() {
	                return KJ(0) | 0
	            }

	            function pna() {
	                return LJ(0) | 0
	            }

	            function qna() {
	                return MJ(0) | 0
	            }

	            function rna() {
	                return NJ(0) | 0
	            }

	            function sna() {
	                return OJ(0) | 0
	            }

	            function tna() {
	                return PJ(0) | 0
	            }

	            function una() {
	                return QJ(0) | 0
	            }

	            function vna() {
	                return RJ(0) | 0
	            }

	            function wna() {
	                return SJ(0) | 0
	            }

	            function xna() {
	                return TJ(0) | 0
	            }

	            function yna() {
	                return UJ(0) | 0
	            }

	            function zna() {
	                return VJ(0) | 0
	            }

	            function Ana() {
	                return WJ(0) | 0
	            }

	            function Bna() {
	                return XJ(0) | 0
	            }

	            function Cna() {
	                return YJ(0) | 0
	            }

	            function Dna() {
	                return ZJ(0) | 0
	            }

	            function Ena() {
	                return _J(0) | 0
	            }

	            function Fna() {
	                return $J(0) | 0
	            }

	            function Gna() {
	                return aK(0) | 0
	            }

	            function Hna() {
	                return bK(0) | 0
	            }

	            function Ina() {
	                return cK(0) | 0
	            }

	            function Jna() {
	                return dK(0) | 0
	            }

	            function Kna() {
	                return eK(0) | 0
	            }

	            function Lna() {
	                return fK(0) | 0
	            }

	            function Mna() {
	                return gK(0) | 0
	            }

	            function Nna() {
	                return hK(0) | 0
	            }

	            function Ona() {
	                return iK(0) | 0
	            }

	            function Pna() {
	                return jK(0) | 0
	            }

	            function Qna() {
	                return kK(0) | 0
	            }

	            function Rna() {
	                return lK(0) | 0
	            }

	            function Sna() {
	                return mK(0) | 0
	            }

	            function Tna() {
	                return nK(0) | 0
	            }

	            function Una() {
	                return oK(0) | 0
	            }

	            function Vna() {
	                return pK(0) | 0
	            }

	            function Wna() {
	                return qK(0) | 0
	            }

	            function Xna() {
	                return rK(0) | 0
	            }

	            function Yna() {
	                return sK(0) | 0
	            }

	            function Zna() {
	                return tK(0) | 0
	            }

	            function _na() {
	                return uK(0) | 0
	            }

	            function $na() {
	                return vK(0) | 0
	            }

	            function aoa() {
	                return wK(0) | 0
	            }

	            function boa() {
	                return xK(0) | 0
	            }

	            function coa() {
	                return yK(0) | 0
	            }

	            function doa() {
	                return zK(0) | 0
	            }

	            function eoa() {
	                return AK(0) | 0
	            }

	            function foa() {
	                return BK(0) | 0
	            }

	            function goa() {
	                return CK(0) | 0
	            }

	            function hoa() {
	                return DK(0) | 0
	            }

	            function ioa() {
	                return EK(0) | 0
	            }

	            function joa() {
	                return FK(0) | 0
	            }

	            function koa() {
	                return GK(0) | 0
	            }

	            function loa() {
	                return HK(0) | 0
	            }

	            function moa() {
	                return IK(0) | 0
	            }

	            function noa() {
	                return JK(0) | 0
	            }

	            function ooa() {
	                return KK(0) | 0
	            }

	            function poa() {
	                return LK(0) | 0
	            }

	            function qoa() {
	                return MK(0) | 0
	            }

	            function roa() {
	                return NK(0) | 0
	            }

	            function soa() {
	                return OK(0) | 0
	            }

	            function toa() {
	                return PK(0) | 0
	            }

	            function uoa() {
	                return QK(0) | 0
	            }

	            function voa() {
	                return RK(0) | 0
	            }

	            function woa() {
	                return SK(0) | 0
	            }

	            function xoa() {
	                return TK(0) | 0
	            }

	            function yoa() {
	                return UK(0) | 0
	            }

	            function zoa() {
	                return VK(0) | 0
	            }

	            function Aoa() {
	                return WK(0) | 0
	            }

	            function Boa() {
	                return XK(0) | 0
	            }

	            function Coa() {
	                return YK(0) | 0
	            }

	            function Doa() {
	                return ZK(0) | 0
	            }

	            function Eoa() {
	                return _K(0) | 0
	            }

	            function Foa() {
	                return $K(0) | 0
	            }

	            function Goa() {
	                return aL(0) | 0
	            }

	            function Hoa() {
	                return bL(0) | 0
	            }

	            function Ioa() {
	                return cL(0) | 0
	            }

	            function Joa() {
	                return dL(0) | 0
	            }

	            function Koa() {
	                return eL(0) | 0
	            }

	            function Loa() {
	                return RT(0, 0, 0) | 0
	            }

	            function Moa() {
	                return 0
	            }

	            function Noa() {
	                return Wb(0) | 0
	            }

	            function Ooa() {
	                return Xb(0, 0) | 0
	            }

	            function Poa() {
	                return Yb(0) | 0
	            }

	            function Qoa() {
	                return Wk(0, 0, 0) | 0
	            }

	            function Roa() {
	                return 0
	            }

	            function Soa() {
	                return 0
	            }

	            function Toa() {
	                return ac(0, 0, 0) | 0
	            }

	            function Uoa() {
	                return Ka(0, 0, 0) | 0
	            }

	            function Voa() {
	                return gc(0, 0, 0) | 0
	            }

	            function Woa() {
	                return 0
	            }

	            function Xoa() {
	                return 0
	            }

	            function Yoa() {
	                return 0
	            }

	            function Zoa() {
	                return 0
	            }

	            function _oa() {
	                return 0
	            }

	            function $oa() {
	                return nc(0) | 0
	            }

	            function apa() {
	                return 0
	            }

	            function bpa() {
	                return nd(0) | 0
	            }

	            function cpa() {
	                return Kd(0, 0, 0, 0) | 0
	            }

	            function dpa() {
	                return Ld(0, 0, 0, 0) | 0
	            }

	            function epa() {
	                return Md(0, 0, 0, 0) | 0
	            }

	            function fpa() {
	                return Nd(0, 0, 0, 0) | 0
	            }

	            function gpa() {
	                return Od(0, 0, 0, 0) | 0
	            }

	            function hpa() {
	                return Pd(0, 0, 0, 0) | 0
	            }

	            function ipa() {
	                return qd(0, 0, 0, 0) | 0
	            }

	            function jpa() {
	                return rd(0, 0, 0, 0) | 0
	            }

	            function kpa() {
	                return Qd(0, 0, 0, 0) | 0
	            }

	            function lpa() {
	                return Rd(0, 0, 0, 0) | 0
	            }

	            function mpa() {
	                return fo(0, 0, 0, 0) | 0
	            }

	            function npa() {
	                return 0
	            }

	            function opa() {
	                return 0
	            }

	            function ppa() {
	                return 0
	            }

	            function qpa() {
	                return 0
	            }

	            function rpa() {
	                return 0
	            }

	            function spa() {
	                return nk(0) | 0
	            }

	            function tpa() {
	                return ok(0) | 0
	            }

	            function upa() {
	                return pk(0, 0, 0) | 0
	            }

	            function vpa() {
	                return qk(0) | 0
	            }

	            function wpa() {
	                return _k(0) | 0
	            }

	            function xpa() {
	                return $k(0, 0, 0) | 0
	            }

	            function ypa() {
	                return bl(0) | 0
	            }

	            function zpa() {
	                return cl(0, 0, 0) | 0
	            }

	            function Apa() {
	                return dl(0) | 0
	            }

	            function Bpa() {
	                return el(0, 0, 0) | 0
	            }

	            function Cpa() {
	                return fl(0, 0, 0) | 0
	            }

	            function Dpa() {
	                return gl(0, 0, 0, 0) | 0
	            }

	            function Epa() {
	                return 0
	            }

	            function Fpa() {
	                return on(0) | 0
	            }

	            function Gpa() {
	                return 0
	            }

	            function Hpa() {
	                return vn(0) | 0
	            }

	            function Ipa() {
	                return 0
	            }

	            function Jpa() {
	                return yn(0) | 0
	            }

	            function Kpa() {
	                return 0
	            }

	            function Lpa() {
	                return 0
	            }

	            function Mpa() {
	                return 0
	            }

	            function Npa() {
	                return Cn(0, 0) | 0
	            }

	            function Opa() {
	                return 0
	            }

	            function Ppa() {
	                return 0
	            }

	            function Qpa() {
	                return 0
	            }

	            function Rpa() {
	                return 0
	            }

	            function Spa() {
	                return 0
	            }

	            function Tpa() {
	                return 0
	            }

	            function Upa() {
	                return _n(0, 0) | 0
	            }

	            function Vpa() {
	                return 0
	            }

	            function Wpa() {
	                return 0
	            }

	            function Xpa() {
	                return 0
	            }

	            function Ypa() {
	                return 0
	            }

	            function Zpa() {
	                return 0
	            }

	            function _pa() {
	                return 0
	            }

	            function $pa() {
	                return 0
	            }

	            function aqa() {
	                return 0
	            }

	            function bqa() {
	                return 0
	            }

	            function cqa() {
	                return 0
	            }

	            function dqa() {
	                return 0
	            }

	            function eqa() {
	                return 0
	            }

	            function fqa() {
	                return 0
	            }

	            function gqa() {
	                return 0
	            }

	            function hqa() {
	                return 0
	            }

	            function iqa() {
	                return 0
	            }

	            function jqa() {
	                return 0
	            }

	            function kqa() {
	                return 0
	            }

	            function lqa() {
	                return 0
	            }

	            function mqa() {
	                return 0
	            }

	            function nqa() {
	                return 0
	            }

	            function oqa() {
	                return 0
	            }

	            function pqa() {
	                return 0
	            }

	            function qqa() {
	                return 0
	            }

	            function rqa() {
	                return 0
	            }

	            function sqa() {
	                return 0
	            }

	            function tqa() {
	                return 0
	            }

	            function uqa() {
	                return 0
	            }

	            function vqa() {
	                return 0
	            }

	            function wqa() {
	                return 0
	            }

	            function xqa() {
	                return uu(0, 0, 0) | 0
	            }

	            function yqa() {
	                return ds(0, 0) | 0
	            }

	            function zqa() {
	                return es(0, 0) | 0
	            }

	            function Aqa() {
	                return js(0, 0) | 0
	            }

	            function Bqa() {
	                return vu(0, 0, 0) | 0
	            }

	            function Cqa() {
	                return wu(0, 0) | 0
	            }

	            function Dqa() {
	                return $r(0, 0) | 0
	            }

	            function Eqa() {
	                return as(0, 0) | 0
	            }

	            function Fqa() {
	                return bs(0, 0) | 0
	            }

	            function Gqa() {
	                return hs(0, 0) | 0
	            }

	            function Hqa() {
	                return fs(0, 0) | 0
	            }

	            function Iqa() {
	                return is(0, 0) | 0
	            }

	            function Jqa() {
	                return cs(0, 0) | 0
	            }

	            function Kqa() {
	                return xu(0, 0) | 0
	            }

	            function Lqa() {
	                return gs(0, 0) | 0
	            }

	            function Mqa() {
	                return _r(0, 0) | 0
	            }

	            function Nqa() {
	                return dr(0, 0) | 0
	            }

	            function Oqa() {
	                return 0
	            }

	            function Pqa() {
	                return 0
	            }

	            function Qqa() {
	                return 0
	            }

	            function Rqa() {
	                return 0
	            }

	            function Sqa() {
	                return 0
	            }

	            function Tqa() {
	                return 0
	            }

	            function Uqa() {
	                return 0
	            }

	            function Vqa() {
	                return 0
	            }

	            function Wqa() {
	                return 0
	            }

	            function Xqa() {
	                return 0
	            }

	            function Yqa() {
	                return 0
	            }

	            function Zqa() {
	                return Kx(0, 0, 0) | 0
	            }

	            function _qa() {
	                return $x(0, 0) | 0
	            }

	            function $qa() {
	                return dy(0, 0) | 0
	            }

	            function ara() {
	                return fy(0, 0) | 0
	            }

	            function bra() {
	                return jy(0, 0) | 0
	            }

	            function cra() {
	                return 0
	            }

	            function dra() {
	                return 0
	            }

	            function era() {
	                return 0
	            }

	            function fra() {
	                return 0
	            }

	            function gra() {
	                return 0
	            }

	            function hra() {
	                return 0
	            }

	            function ira() {
	                return 0
	            }

	            function jra() {
	                return RB(0) | 0
	            }

	            function kra() {
	                return SB(0) | 0
	            }

	            function lra() {
	                return TB(0) | 0
	            }

	            function mra() {
	                return UB(0, 0, 0) | 0
	            }

	            function nra() {
	                return VB(0, 0) | 0
	            }

	            function ora() {
	                return 0
	            }

	            function pra() {
	                return 0
	            }

	            function qra() {
	                return 0
	            }

	            function rra() {
	                return 0
	            }

	            function sra() {
	                return 0
	            }

	            function tra() {
	                return 0
	            }

	            function ura() {
	                return 0
	            }

	            function vra() {
	                return 0
	            }

	            function wra() {
	                return 0
	            }

	            function xra() {
	                return 0
	            }

	            function yra() {
	                return 0
	            }

	            function zra() {
	                return 0
	            }

	            function Ara() {
	                return 0
	            }

	            function Bra() {
	                return hC(0, 0) | 0
	            }

	            function Cra() {
	                return 0
	            }

	            function Dra() {
	                return 0
	            }

	            function Era() {
	                return 0
	            }

	            function Fra() {
	                return 0
	            }

	            function Gra() {
	                return 0
	            }

	            function Hra() {
	                return 0
	            }

	            function Ira() {
	                return 0
	            }

	            function Jra() {
	                return rC(0, 0, 0) | 0
	            }

	            function Kra() {
	                return 0
	            }

	            function Lra() {
	                return 0
	            }

	            function Mra() {
	                return 0
	            }

	            function Nra() {
	                return 0
	            }

	            function Ora() {
	                return 0
	            }

	            function Pra() {
	                return 0
	            }

	            function Qra() {
	                return 0
	            }

	            function Rra() {
	                return 0
	            }

	            function Sra() {
	                return 0
	            }

	            function Tra() {
	                return 0
	            }

	            function Ura() {
	                return 0
	            }

	            function Vra() {
	                return 0
	            }

	            function Wra() {
	                return 0
	            }

	            function Xra() {
	                return GM(0, 0, 0) | 0
	            }

	            function Yra() {
	                return 0
	            }

	            function Zra() {
	                return 0
	            }

	            function _ra() {
	                return nN(0, 0) | 0
	            }

	            function $ra() {
	                return oN(0, 0, 0, 0, 0) | 0
	            }

	            function asa() {
	                return pN(0, 0, 0, 0, 0, 0, 0) | 0
	            }

	            function bsa() {
	                return qN(0, 0, 0, 0, 0, 0) | 0
	            }

	            function csa() {
	                return 0
	            }

	            function dsa() {
	                return tN(0, 0) | 0
	            }

	            function esa() {
	                return uN(0, 0, 0, 0, 0) | 0
	            }

	            function fsa() {
	                return vN(0, 0, 0, 0, 0, 0, 0) | 0
	            }

	            function gsa() {
	                return 0
	            }

	            function hsa() {
	                return 0
	            }

	            function isa() {
	                return 0
	            }

	            function jsa() {
	                return 0
	            }

	            function ksa() {
	                return 0
	            }

	            function lsa() {
	                return 0
	            }

	            function msa() {
	                return 0
	            }

	            function nsa() {
	                return 0
	            }

	            function osa() {
	                return 0
	            }

	            function psa() {
	                return WR(0, 0, 0, 0) | 0
	            }

	            function qsa() {
	                return QS(0, 0) | 0
	            }

	            function rsa() {
	                return hT(0, 0, 0) | 0
	            }

	            function ssa(a) {
	                a = a | 0;
	                da(5)
	            }

	            function tsa(a) {
	                a = a | 0;
	                uc(a | 0, 0, 0, 0)
	            }

	            function usa(a) {
	                a = a | 0;
	                vc(a | 0) | 0
	            }

	            function vsa(a) {
	                a = a | 0;
	                wc(a | 0) | 0
	            }

	            function wsa(a) {
	                a = a | 0;
	                xc(a | 0) | 0
	            }

	            function xsa(a) {
	                a = a | 0;
	                yc(a | 0, 0, 0) | 0
	            }

	            function ysa(a) {
	                a = a | 0;
	                zc(a | 0, 0) | 0
	            }

	            function zsa(a) {
	                a = a | 0;
	                Ac(a | 0, 0, 0, 0, 0, 0)
	            }

	            function Asa(a) {
	                a = a | 0;
	                Bc(a | 0, 0, 0, 0)
	            }

	            function Bsa(a) {
	                a = a | 0;
	                Cc(a | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function Csa(a) {
	                a = a | 0;
	                Dc(a | 0, 0, 0, 0)
	            }

	            function Dsa(a) {
	                a = a | 0;
	                Ec(a | 0, 0, 0, 0, 0)
	            }

	            function Esa(a) {
	                a = a | 0;
	                Fc(a | 0, 0)
	            }

	            function Fsa(a) {
	                a = a | 0;
	                Wc(a | 0, 0, 0)
	            }

	            function Gsa(a) {
	                a = a | 0;
	                Xc(a | 0, 0)
	            }

	            function Hsa(a) {
	                a = a | 0;
	                Ic(a | 0, 0)
	            }

	            function Isa(a) {
	                a = a | 0;
	                Jc(a | 0, 0, 0)
	            }

	            function Jsa(a) {
	                a = a | 0;
	                Kc(a | 0, 0, 0)
	            }

	            function Ksa(a) {
	                a = a | 0;
	                Lc(a | 0, 0, 0)
	            }

	            function Lsa(a) {
	                a = a | 0;
	                Mc(a | 0, 0)
	            }

	            function Msa(a) {
	                a = a | 0;
	                Nc(a | 0, 0, 0)
	            }

	            function Nsa(a) {
	                a = a | 0;
	                Oc(a | 0, 0, 0)
	            }

	            function Osa(a) {
	                a = a | 0;
	                Pc(a | 0, 0, 0)
	            }

	            function Psa(a) {
	                a = a | 0;
	                Qc(a | 0, 0) | 0
	            }

	            function Qsa(a) {
	                a = a | 0;
	                Rc(a | 0, 0, 0)
	            }

	            function Rsa(a) {
	                a = a | 0;
	                Sc(a | 0, 0, 0, 0)
	            }

	            function Ssa(a) {
	                a = a | 0;
	                Tc(a | 0, 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function Tsa(a) {
	                a = a | 0;
	                Uc(a | 0, 0, 0, 0)
	            }

	            function Usa(a) {
	                a = a | 0;
	                Xk(a | 0, 0, 0) | 0
	            }

	            function Vsa(a) {
	                a = a | 0;
	                iT(a | 0) | 0
	            }

	            function Wsa(a) {
	                a = a | 0;
	                kT(a | 0, 0) | 0
	            }

	            function Xsa(a) {
	                a = a | 0;
	                my(a | 0) | 0
	            }

	            function Ysa(a) {
	                a = a | 0;
	                Td(a | 0, 0, 0)
	            }

	            function Zsa(a) {
	                a = a | 0;
	                SP(a | 0, 0, 0, 0)
	            }

	            function _sa(a) {
	                a = a | 0;
	                PP(a | 0) | 0
	            }

	            function $sa(a) {
	                a = a | 0;
	                QP(a | 0) | 0
	            }

	            function ata(a) {
	                a = a | 0;
	                RP(a | 0) | 0
	            }

	            function bta(a) {
	                a = a | 0;
	                UP(a | 0, 0, 0) | 0
	            }

	            function cta(a) {
	                a = a | 0;
	                VP(a | 0, 0) | 0
	            }

	            function dta(a) {
	                a = a | 0;
	                XP(a | 0, 0, 0, 0, 0, 0)
	            }

	            function eta(a) {
	                a = a | 0;
	                _P(a | 0, 0, 0, 0)
	            }

	            function fta(a) {
	                a = a | 0;
	                YP(a | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function gta(a) {
	                a = a | 0;
	                ZP(a | 0, 0, 0, 0)
	            }

	            function hta(a) {
	                a = a | 0;
	                $P(a | 0, 0, 0, 0, 0)
	            }

	            function ita(a) {
	                a = a | 0;
	                aQ(a | 0, 0)
	            }

	            function jta(a) {
	                a = a | 0;
	                dQ(a | 0, 0, 0)
	            }

	            function kta(a) {
	                a = a | 0;
	                eQ(a | 0, 0)
	            }

	            function lta(a) {
	                a = a | 0;
	                hQ(a | 0, 0)
	            }

	            function mta(a) {
	                a = a | 0;
	                iQ(a | 0, 0, 0)
	            }

	            function nta(a) {
	                a = a | 0;
	                kQ(a | 0, 0, 0)
	            }

	            function ota(a) {
	                a = a | 0;
	                lQ(a | 0, 0)
	            }

	            function pta(a) {
	                a = a | 0;
	                $d(a | 0, 0, 0)
	            }

	            function qta(a) {
	                a = a | 0;
	                _d(a | 0, 0, 0)
	            }

	            function rta(a) {
	                a = a | 0;
	                WP(a | 0, 0) | 0
	            }

	            function sta(a) {
	                a = a | 0;
	                mQ(a | 0, 0, 0)
	            }

	            function tta(a) {
	                a = a | 0;
	                TP(a | 0, 0, 0, 0)
	            }

	            function uta(a) {
	                a = a | 0;
	                LP(a | 0) | 0
	            }

	            function vta(a) {
	                a = a | 0;
	                MP(a | 0) | 0
	            }

	            function wta(a) {
	                a = a | 0;
	                NP(a | 0) | 0
	            }

	            function xta(a) {
	                a = a | 0;
	                OP(a | 0) | 0
	            }

	            function yta(a) {
	                a = a | 0;
	                jQ(a | 0, 0, 0)
	            }

	            function zta(a) {
	                a = a | 0;
	                NI(a | 0) | 0
	            }

	            function Ata(a) {
	                a = a | 0;
	                OI(a | 0) | 0
	            }

	            function Bta(a) {
	                a = a | 0;
	                PI(a | 0) | 0
	            }

	            function Cta(a) {
	                a = a | 0;
	                QI(a | 0) | 0
	            }

	            function Dta(a) {
	                a = a | 0;
	                RI(a | 0) | 0
	            }

	            function Eta(a) {
	                a = a | 0;
	                SI(a | 0) | 0
	            }

	            function Fta(a) {
	                a = a | 0;
	                TI(a | 0) | 0
	            }

	            function Gta(a) {
	                a = a | 0;
	                UI(a | 0) | 0
	            }

	            function Hta(a) {
	                a = a | 0;
	                VI(a | 0) | 0
	            }

	            function Ita(a) {
	                a = a | 0;
	                WI(a | 0) | 0
	            }

	            function Jta(a) {
	                a = a | 0;
	                XI(a | 0) | 0
	            }

	            function Kta(a) {
	                a = a | 0;
	                YI(a | 0) | 0
	            }

	            function Lta(a) {
	                a = a | 0;
	                ZI(a | 0) | 0
	            }

	            function Mta(a) {
	                a = a | 0;
	                _I(a | 0) | 0
	            }

	            function Nta(a) {
	                a = a | 0;
	                $I(a | 0) | 0
	            }

	            function Ota(a) {
	                a = a | 0;
	                aJ(a | 0) | 0
	            }

	            function Pta(a) {
	                a = a | 0;
	                bJ(a | 0) | 0
	            }

	            function Qta(a) {
	                a = a | 0;
	                cJ(a | 0) | 0
	            }

	            function Rta(a) {
	                a = a | 0;
	                dJ(a | 0) | 0
	            }

	            function Sta(a) {
	                a = a | 0;
	                eJ(a | 0) | 0
	            }

	            function Tta(a) {
	                a = a | 0;
	                fJ(a | 0) | 0
	            }

	            function Uta(a) {
	                a = a | 0;
	                gJ(a | 0) | 0
	            }

	            function Vta(a) {
	                a = a | 0;
	                hJ(a | 0) | 0
	            }

	            function Wta(a) {
	                a = a | 0;
	                iJ(a | 0) | 0
	            }

	            function Xta(a) {
	                a = a | 0;
	                jJ(a | 0) | 0
	            }

	            function Yta(a) {
	                a = a | 0;
	                kJ(a | 0) | 0
	            }

	            function Zta(a) {
	                a = a | 0;
	                lJ(a | 0) | 0
	            }

	            function _ta(a) {
	                a = a | 0;
	                mJ(a | 0) | 0
	            }

	            function $ta(a) {
	                a = a | 0;
	                nJ(a | 0) | 0
	            }

	            function aua(a) {
	                a = a | 0;
	                oJ(a | 0) | 0
	            }

	            function bua(a) {
	                a = a | 0;
	                pJ(a | 0) | 0
	            }

	            function cua(a) {
	                a = a | 0;
	                qJ(a | 0) | 0
	            }

	            function dua(a) {
	                a = a | 0;
	                rJ(a | 0) | 0
	            }

	            function eua(a) {
	                a = a | 0;
	                sJ(a | 0) | 0
	            }

	            function fua(a) {
	                a = a | 0;
	                tJ(a | 0) | 0
	            }

	            function gua(a) {
	                a = a | 0;
	                uJ(a | 0) | 0
	            }

	            function hua(a) {
	                a = a | 0;
	                vJ(a | 0) | 0
	            }

	            function iua(a) {
	                a = a | 0;
	                wJ(a | 0) | 0
	            }

	            function jua(a) {
	                a = a | 0;
	                xJ(a | 0) | 0
	            }

	            function kua(a) {
	                a = a | 0;
	                yJ(a | 0) | 0
	            }

	            function lua(a) {
	                a = a | 0;
	                zJ(a | 0) | 0
	            }

	            function mua(a) {
	                a = a | 0;
	                AJ(a | 0) | 0
	            }

	            function nua(a) {
	                a = a | 0;
	                BJ(a | 0) | 0
	            }

	            function oua(a) {
	                a = a | 0;
	                CJ(a | 0) | 0
	            }

	            function pua(a) {
	                a = a | 0;
	                DJ(a | 0) | 0
	            }

	            function qua(a) {
	                a = a | 0;
	                EJ(a | 0) | 0
	            }

	            function rua(a) {
	                a = a | 0;
	                FJ(a | 0) | 0
	            }

	            function sua(a) {
	                a = a | 0;
	                GJ(a | 0) | 0
	            }

	            function tua(a) {
	                a = a | 0;
	                HJ(a | 0) | 0
	            }

	            function uua(a) {
	                a = a | 0;
	                IJ(a | 0) | 0
	            }

	            function vua(a) {
	                a = a | 0;
	                JJ(a | 0) | 0
	            }

	            function wua(a) {
	                a = a | 0;
	                KJ(a | 0) | 0
	            }

	            function xua(a) {
	                a = a | 0;
	                LJ(a | 0) | 0
	            }

	            function yua(a) {
	                a = a | 0;
	                MJ(a | 0) | 0
	            }

	            function zua(a) {
	                a = a | 0;
	                NJ(a | 0) | 0
	            }

	            function Aua(a) {
	                a = a | 0;
	                OJ(a | 0) | 0
	            }

	            function Bua(a) {
	                a = a | 0;
	                PJ(a | 0) | 0
	            }

	            function Cua(a) {
	                a = a | 0;
	                QJ(a | 0) | 0
	            }

	            function Dua(a) {
	                a = a | 0;
	                RJ(a | 0) | 0
	            }

	            function Eua(a) {
	                a = a | 0;
	                SJ(a | 0) | 0
	            }

	            function Fua(a) {
	                a = a | 0;
	                TJ(a | 0) | 0
	            }

	            function Gua(a) {
	                a = a | 0;
	                UJ(a | 0) | 0
	            }

	            function Hua(a) {
	                a = a | 0;
	                VJ(a | 0) | 0
	            }

	            function Iua(a) {
	                a = a | 0;
	                WJ(a | 0) | 0
	            }

	            function Jua(a) {
	                a = a | 0;
	                XJ(a | 0) | 0
	            }

	            function Kua(a) {
	                a = a | 0;
	                YJ(a | 0) | 0
	            }

	            function Lua(a) {
	                a = a | 0;
	                ZJ(a | 0) | 0
	            }

	            function Mua(a) {
	                a = a | 0;
	                _J(a | 0) | 0
	            }

	            function Nua(a) {
	                a = a | 0;
	                $J(a | 0) | 0
	            }

	            function Oua(a) {
	                a = a | 0;
	                aK(a | 0) | 0
	            }

	            function Pua(a) {
	                a = a | 0;
	                bK(a | 0) | 0
	            }

	            function Qua(a) {
	                a = a | 0;
	                cK(a | 0) | 0
	            }

	            function Rua(a) {
	                a = a | 0;
	                dK(a | 0) | 0
	            }

	            function Sua(a) {
	                a = a | 0;
	                eK(a | 0) | 0
	            }

	            function Tua(a) {
	                a = a | 0;
	                fK(a | 0) | 0
	            }

	            function Uua(a) {
	                a = a | 0;
	                gK(a | 0) | 0
	            }

	            function Vua(a) {
	                a = a | 0;
	                hK(a | 0) | 0
	            }

	            function Wua(a) {
	                a = a | 0;
	                iK(a | 0) | 0
	            }

	            function Xua(a) {
	                a = a | 0;
	                jK(a | 0) | 0
	            }

	            function Yua(a) {
	                a = a | 0;
	                kK(a | 0) | 0
	            }

	            function Zua(a) {
	                a = a | 0;
	                lK(a | 0) | 0
	            }

	            function _ua(a) {
	                a = a | 0;
	                mK(a | 0) | 0
	            }

	            function $ua(a) {
	                a = a | 0;
	                nK(a | 0) | 0
	            }

	            function ava(a) {
	                a = a | 0;
	                oK(a | 0) | 0
	            }

	            function bva(a) {
	                a = a | 0;
	                pK(a | 0) | 0
	            }

	            function cva(a) {
	                a = a | 0;
	                qK(a | 0) | 0
	            }

	            function dva(a) {
	                a = a | 0;
	                rK(a | 0) | 0
	            }

	            function eva(a) {
	                a = a | 0;
	                sK(a | 0) | 0
	            }

	            function fva(a) {
	                a = a | 0;
	                tK(a | 0) | 0
	            }

	            function gva(a) {
	                a = a | 0;
	                uK(a | 0) | 0
	            }

	            function hva(a) {
	                a = a | 0;
	                vK(a | 0) | 0
	            }

	            function iva(a) {
	                a = a | 0;
	                wK(a | 0) | 0
	            }

	            function jva(a) {
	                a = a | 0;
	                xK(a | 0) | 0
	            }

	            function kva(a) {
	                a = a | 0;
	                yK(a | 0) | 0
	            }

	            function lva(a) {
	                a = a | 0;
	                zK(a | 0) | 0
	            }

	            function mva(a) {
	                a = a | 0;
	                AK(a | 0) | 0
	            }

	            function nva(a) {
	                a = a | 0;
	                BK(a | 0) | 0
	            }

	            function ova(a) {
	                a = a | 0;
	                CK(a | 0) | 0
	            }

	            function pva(a) {
	                a = a | 0;
	                DK(a | 0) | 0
	            }

	            function qva(a) {
	                a = a | 0;
	                EK(a | 0) | 0
	            }

	            function rva(a) {
	                a = a | 0;
	                FK(a | 0) | 0
	            }

	            function sva(a) {
	                a = a | 0;
	                GK(a | 0) | 0
	            }

	            function tva(a) {
	                a = a | 0;
	                HK(a | 0) | 0
	            }

	            function uva(a) {
	                a = a | 0;
	                IK(a | 0) | 0
	            }

	            function vva(a) {
	                a = a | 0;
	                JK(a | 0) | 0
	            }

	            function wva(a) {
	                a = a | 0;
	                KK(a | 0) | 0
	            }

	            function xva(a) {
	                a = a | 0;
	                LK(a | 0) | 0
	            }

	            function yva(a) {
	                a = a | 0;
	                MK(a | 0) | 0
	            }

	            function zva(a) {
	                a = a | 0;
	                NK(a | 0) | 0
	            }

	            function Ava(a) {
	                a = a | 0;
	                OK(a | 0) | 0
	            }

	            function Bva(a) {
	                a = a | 0;
	                PK(a | 0) | 0
	            }

	            function Cva(a) {
	                a = a | 0;
	                QK(a | 0) | 0
	            }

	            function Dva(a) {
	                a = a | 0;
	                RK(a | 0) | 0
	            }

	            function Eva(a) {
	                a = a | 0;
	                SK(a | 0) | 0
	            }

	            function Fva(a) {
	                a = a | 0;
	                TK(a | 0) | 0
	            }

	            function Gva(a) {
	                a = a | 0;
	                UK(a | 0) | 0
	            }

	            function Hva(a) {
	                a = a | 0;
	                VK(a | 0) | 0
	            }

	            function Iva(a) {
	                a = a | 0;
	                WK(a | 0) | 0
	            }

	            function Jva(a) {
	                a = a | 0;
	                XK(a | 0) | 0
	            }

	            function Kva(a) {
	                a = a | 0;
	                YK(a | 0) | 0
	            }

	            function Lva(a) {
	                a = a | 0;
	                ZK(a | 0) | 0
	            }

	            function Mva(a) {
	                a = a | 0;
	                _K(a | 0) | 0
	            }

	            function Nva(a) {
	                a = a | 0;
	                $K(a | 0) | 0
	            }

	            function Ova(a) {
	                a = a | 0;
	                aL(a | 0) | 0
	            }

	            function Pva(a) {
	                a = a | 0;
	                bL(a | 0) | 0
	            }

	            function Qva(a) {
	                a = a | 0;
	                cL(a | 0) | 0
	            }

	            function Rva(a) {
	                a = a | 0;
	                dL(a | 0) | 0
	            }

	            function Sva(a) {
	                a = a | 0;
	                eL(a | 0) | 0
	            }

	            function Tva(a) {
	                a = a | 0;
	                RT(a | 0, 0, 0) | 0
	            }

	            function Uva(a) {
	                a = a | 0;
	                Wb(a | 0) | 0
	            }

	            function Vva(a) {
	                a = a | 0;
	                Xb(a | 0, 0) | 0
	            }

	            function Wva(a) {
	                a = a | 0;
	                Yb(a | 0) | 0
	            }

	            function Xva(a) {
	                a = a | 0;
	                Wk(a | 0, 0, 0) | 0
	            }

	            function Yva(a) {
	                a = a | 0;
	                ac(a | 0, 0, 0) | 0
	            }

	            function Zva(a) {
	                a = a | 0;
	                Ka(a | 0, 0, 0) | 0
	            }

	            function _va(a) {
	                a = a | 0;
	                gc(a | 0, 0, 0) | 0
	            }

	            function $va(a) {
	                a = a | 0;
	                ic(a | 0, 0, 0)
	            }

	            function awa(a) {
	                a = a | 0;
	                jc(a | 0, 0, 0)
	            }

	            function bwa(a) {
	                a = a | 0;
	                kc(a | 0, 0, 0)
	            }

	            function cwa(a) {
	                a = a | 0;
	                lc(a | 0, 0, 0)
	            }

	            function dwa(a) {
	                a = a | 0;
	                nc(a | 0) | 0
	            }

	            function ewa(a) {
	                a = a | 0;
	                md(a | 0, 0)
	            }

	            function fwa(a) {
	                a = a | 0;
	                nd(a | 0) | 0
	            }

	            function gwa(a) {
	                a = a | 0;
	                Kd(a | 0, 0, 0, 0) | 0
	            }

	            function hwa(a) {
	                a = a | 0;
	                Ld(a | 0, 0, 0, 0) | 0
	            }

	            function iwa(a) {
	                a = a | 0;
	                Md(a | 0, 0, 0, 0) | 0
	            }

	            function jwa(a) {
	                a = a | 0;
	                Nd(a | 0, 0, 0, 0) | 0
	            }

	            function kwa(a) {
	                a = a | 0;
	                Od(a | 0, 0, 0, 0) | 0
	            }

	            function lwa(a) {
	                a = a | 0;
	                Pd(a | 0, 0, 0, 0) | 0
	            }

	            function mwa(a) {
	                a = a | 0;
	                qd(a | 0, 0, 0, 0) | 0
	            }

	            function nwa(a) {
	                a = a | 0;
	                rd(a | 0, 0, 0, 0) | 0
	            }

	            function owa(a) {
	                a = a | 0;
	                Qd(a | 0, 0, 0, 0) | 0
	            }

	            function pwa(a) {
	                a = a | 0;
	                Rd(a | 0, 0, 0, 0) | 0
	            }

	            function qwa(a) {
	                a = a | 0;
	                fo(a | 0, 0, 0, 0) | 0
	            }

	            function rwa(a) {
	                a = a | 0;
	                ae(a | 0, 0, 0)
	            }

	            function swa(a) {
	                a = a | 0;
	                be(a | 0, 0, 0)
	            }

	            function twa(a) {
	                a = a | 0;
	                mk() | 0
	            }

	            function uwa(a) {
	                a = a | 0;
	                sh(a | 0, 0, 0, 0, 0)
	            }

	            function vwa(a) {
	                a = a | 0;
	                gk(a | 0, 0, 0, 0, 0)
	            }

	            function wwa(a) {
	                a = a | 0;
	                nk(a | 0) | 0
	            }

	            function xwa(a) {
	                a = a | 0;
	                ok(a | 0) | 0
	            }

	            function ywa(a) {
	                a = a | 0;
	                pk(a | 0, 0, 0) | 0
	            }

	            function zwa(a) {
	                a = a | 0;
	                qk(a | 0) | 0
	            }

	            function Awa(a) {
	                a = a | 0;
	                _k(a | 0) | 0
	            }

	            function Bwa(a) {
	                a = a | 0;
	                $k(a | 0, 0, 0) | 0
	            }

	            function Cwa(a) {
	                a = a | 0;
	                bl(a | 0) | 0
	            }

	            function Dwa(a) {
	                a = a | 0;
	                cl(a | 0, 0, 0) | 0
	            }

	            function Ewa(a) {
	                a = a | 0;
	                dl(a | 0) | 0
	            }

	            function Fwa(a) {
	                a = a | 0;
	                el(a | 0, 0, 0) | 0
	            }

	            function Gwa(a) {
	                a = a | 0;
	                fl(a | 0, 0, 0) | 0
	            }

	            function Hwa(a) {
	                a = a | 0;
	                gl(a | 0, 0, 0, 0) | 0
	            }

	            function Iwa(a) {
	                a = a | 0;
	                on(a | 0) | 0
	            }

	            function Jwa(a) {
	                a = a | 0;
	                vn(a | 0) | 0
	            }

	            function Kwa(a) {
	                a = a | 0;
	                yn(a | 0) | 0
	            }

	            function Lwa(a) {
	                a = a | 0;
	                zn(a | 0, 0)
	            }

	            function Mwa(a) {
	                a = a | 0;
	                Cn(a | 0, 0) | 0
	            }

	            function Nwa(a) {
	                a = a | 0;
	                In(a | 0, 0, 0)
	            }

	            function Owa(a) {
	                a = a | 0;
	                Rn(a | 0, 0, 0)
	            }

	            function Pwa(a) {
	                a = a | 0;
	                Sn(a | 0, 0, 0)
	            }

	            function Qwa(a) {
	                a = a | 0;
	                Tn(a | 0, 0, 0)
	            }

	            function Rwa(a) {
	                a = a | 0;
	                Un(a | 0, 0, 0)
	            }

	            function Swa(a) {
	                a = a | 0;
	                _n(a | 0, 0) | 0
	            }

	            function Twa(a) {
	                a = a | 0;
	                tq(a | 0, 0)
	            }

	            function Uwa(a) {
	                a = a | 0;
	                Bs(a | 0, 0)
	            }

	            function Vwa(a) {
	                a = a | 0;
	                Is(a | 0, 0)
	            }

	            function Wwa(a) {
	                a = a | 0;
	                ns(a | 0, 0)
	            }

	            function Xwa(a) {
	                a = a | 0;
	                ts(a | 0, 0)
	            }

	            function Ywa(a) {
	                a = a | 0;
	                us(a | 0, 0)
	            }

	            function Zwa(a) {
	                a = a | 0;
	                os(a | 0, 0)
	            }

	            function _wa(a) {
	                a = a | 0;
	                Es(a | 0, 0)
	            }

	            function $wa(a) {
	                a = a | 0;
	                Hs(a | 0, 0)
	            }

	            function axa(a) {
	                a = a | 0;
	                ls(a | 0, 0)
	            }

	            function bxa(a) {
	                a = a | 0;
	                Fs(a | 0, 0)
	            }

	            function cxa(a) {
	                a = a | 0;
	                ps(a | 0, 0)
	            }

	            function dxa(a) {
	                a = a | 0;
	                Cs(a | 0, 0)
	            }

	            function exa(a) {
	                a = a | 0;
	                nt(a | 0, 0)
	            }

	            function fxa(a) {
	                a = a | 0;
	                qs(a | 0, 0)
	            }

	            function gxa(a) {
	                a = a | 0;
	                zs(a | 0, 0)
	            }

	            function hxa(a) {
	                a = a | 0;
	                Tr(a | 0, 0)
	            }

	            function ixa(a) {
	                a = a | 0;
	                ms(a | 0, 0)
	            }

	            function jxa(a) {
	                a = a | 0;
	                Js(a | 0, 0)
	            }

	            function kxa(a) {
	                a = a | 0;
	                rs(a | 0, 0)
	            }

	            function lxa(a) {
	                a = a | 0;
	                ss(a | 0, 0)
	            }

	            function mxa(a) {
	                a = a | 0;
	                vs(a | 0, 0)
	            }

	            function nxa(a) {
	                a = a | 0;
	                ws(a | 0, 0)
	            }

	            function oxa(a) {
	                a = a | 0;
	                xs(a | 0, 0)
	            }

	            function pxa(a) {
	                a = a | 0;
	                ys(a | 0, 0)
	            }

	            function qxa(a) {
	                a = a | 0;
	                Gs(a | 0, 0)
	            }

	            function rxa(a) {
	                a = a | 0;
	                Ds(a | 0, 0)
	            }

	            function sxa(a) {
	                a = a | 0;
	                As(a | 0, 0)
	            }

	            function txa(a) {
	                a = a | 0;
	                ot(a | 0, 0)
	            }

	            function uxa(a) {
	                a = a | 0;
	                uu(a | 0, 0, 0) | 0
	            }

	            function vxa(a) {
	                a = a | 0;
	                ds(a | 0, 0) | 0
	            }

	            function wxa(a) {
	                a = a | 0;
	                es(a | 0, 0) | 0
	            }

	            function xxa(a) {
	                a = a | 0;
	                js(a | 0, 0) | 0
	            }

	            function yxa(a) {
	                a = a | 0;
	                vu(a | 0, 0, 0) | 0
	            }

	            function zxa(a) {
	                a = a | 0;
	                wu(a | 0, 0) | 0
	            }

	            function Axa(a) {
	                a = a | 0;
	                $r(a | 0, 0) | 0
	            }

	            function Bxa(a) {
	                a = a | 0;
	                as(a | 0, 0) | 0
	            }

	            function Cxa(a) {
	                a = a | 0;
	                bs(a | 0, 0) | 0
	            }

	            function Dxa(a) {
	                a = a | 0;
	                hs(a | 0, 0) | 0
	            }

	            function Exa(a) {
	                a = a | 0;
	                fs(a | 0, 0) | 0
	            }

	            function Fxa(a) {
	                a = a | 0;
	                is(a | 0, 0) | 0
	            }

	            function Gxa(a) {
	                a = a | 0;
	                cs(a | 0, 0) | 0
	            }

	            function Hxa(a) {
	                a = a | 0;
	                xu(a | 0, 0) | 0
	            }

	            function Ixa(a) {
	                a = a | 0;
	                gs(a | 0, 0) | 0
	            }

	            function Jxa(a) {
	                a = a | 0;
	                _r(a | 0, 0) | 0
	            }

	            function Kxa(a) {
	                a = a | 0;
	                dr(a | 0, 0) | 0
	            }

	            function Lxa(a) {
	                a = a | 0;
	                jv(a | 0, 0)
	            }

	            function Mxa(a) {
	                a = a | 0;
	                pv(a | 0, 0)
	            }

	            function Nxa(a) {
	                a = a | 0;
	                qv(a | 0, 0)
	            }

	            function Oxa(a) {
	                a = a | 0;
	                rv(a | 0, 0)
	            }

	            function Pxa(a) {
	                a = a | 0;
	                sv(a | 0, 0)
	            }

	            function Qxa(a) {
	                a = a | 0;
	                tv(a | 0, 0)
	            }

	            function Rxa(a) {
	                a = a | 0;
	                uv(a | 0, 0)
	            }

	            function Sxa(a) {
	                a = a | 0;
	                vv(a | 0, 0)
	            }

	            function Txa(a) {
	                a = a | 0;
	                tw(a | 0, 0, 0)
	            }

	            function Uxa(a) {
	                a = a | 0;
	                Kx(a | 0, 0, 0) | 0
	            }

	            function Vxa(a) {
	                a = a | 0;
	                $x(a | 0, 0) | 0
	            }

	            function Wxa(a) {
	                a = a | 0;
	                dy(a | 0, 0) | 0
	            }

	            function Xxa(a) {
	                a = a | 0;
	                fy(a | 0, 0) | 0
	            }

	            function Yxa(a) {
	                a = a | 0;
	                jy(a | 0, 0) | 0
	            }

	            function Zxa(a) {
	                a = a | 0;
	                LB(a | 0, 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function _xa(a) {
	                a = a | 0;
	                MB(a | 0, 0, 0, 0)
	            }

	            function $xa(a) {
	                a = a | 0;
	                NB(a | 0, 0, 0)
	            }

	            function aya(a) {
	                a = a | 0;
	                OB(a | 0, 0, 0)
	            }

	            function bya(a) {
	                a = a | 0;
	                PB(a | 0, 0)
	            }

	            function cya(a) {
	                a = a | 0;
	                QB(a | 0, 0, 0, 0)
	            }

	            function dya(a) {
	                a = a | 0;
	                RB(a | 0) | 0
	            }

	            function eya(a) {
	                a = a | 0;
	                SB(a | 0) | 0
	            }

	            function fya(a) {
	                a = a | 0;
	                TB(a | 0) | 0
	            }

	            function gya(a) {
	                a = a | 0;
	                UB(a | 0, 0, 0) | 0
	            }

	            function hya(a) {
	                a = a | 0;
	                VB(a | 0, 0) | 0
	            }

	            function iya(a) {
	                a = a | 0;
	                WB(a | 0, 0, 0, 0, 0, 0)
	            }

	            function jya(a) {
	                a = a | 0;
	                XB(a | 0, 0, 0, 0)
	            }

	            function kya(a) {
	                a = a | 0;
	                YB(a | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function lya(a) {
	                a = a | 0;
	                ZB(a | 0, 0, 0, 0)
	            }

	            function mya(a) {
	                a = a | 0;
	                _B(a | 0, 0, 0, 0, 0)
	            }

	            function nya(a) {
	                a = a | 0;
	                $B(a | 0, 0)
	            }

	            function oya(a) {
	                a = a | 0;
	                cC(a | 0, 0, 0)
	            }

	            function pya(a) {
	                a = a | 0;
	                dC(a | 0, 0)
	            }

	            function qya(a) {
	                a = a | 0;
	                eC(a | 0, 0, 0)
	            }

	            function rya(a) {
	                a = a | 0;
	                fC(a | 0, 0, 0)
	            }

	            function sya(a) {
	                a = a | 0;
	                gC(a | 0, 0, 0)
	            }

	            function tya(a) {
	                a = a | 0;
	                hC(a | 0, 0) | 0
	            }

	            function uya(a) {
	                a = a | 0;
	                iC(a | 0, 0, 0, 0)
	            }

	            function vya(a) {
	                a = a | 0;
	                jC(a | 0, 0, 0)
	            }

	            function wya(a) {
	                a = a | 0;
	                kC(a | 0, 0, 0)
	            }

	            function xya(a) {
	                a = a | 0;
	                lC(a | 0, 0, 0)
	            }

	            function yya(a) {
	                a = a | 0;
	                mC(a | 0, 0)
	            }

	            function zya(a) {
	                a = a | 0;
	                nC(a | 0, 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function Aya(a) {
	                a = a | 0;
	                oC(a | 0, 0, 0, 0)
	            }

	            function Bya(a) {
	                a = a | 0;
	                rC(a | 0, 0, 0) | 0
	            }

	            function Cya(a) {
	                a = a | 0;
	                AD(a | 0, 0)
	            }

	            function Dya(a) {
	                a = a | 0;
	                lF(a | 0, 0, 0, 0)
	            }

	            function Eya(a) {
	                a = a | 0;
	                uF(a | 0, 0)
	            }

	            function Fya(a) {
	                a = a | 0;
	                wM(a | 0, 0, 0)
	            }

	            function Gya(a) {
	                a = a | 0;
	                xM(a | 0, 0)
	            }

	            function Hya(a) {
	                a = a | 0;
	                yM(a | 0, 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function Iya(a) {
	                a = a | 0;
	                zM(a | 0, 0, 0, 0)
	            }

	            function Jya(a) {
	                a = a | 0;
	                AM(a | 0, 0, 0)
	            }

	            function Kya(a) {
	                a = a | 0;
	                BM(a | 0, 0, 0)
	            }

	            function Lya(a) {
	                a = a | 0;
	                DM(a | 0, 0, 0)
	            }

	            function Mya(a) {
	                a = a | 0;
	                EM(a | 0, 0, 0)
	            }

	            function Nya(a) {
	                a = a | 0;
	                GM(a | 0, 0, 0) | 0
	            }

	            function Oya(a) {
	                a = a | 0;
	                FM(a | 0, 0)
	            }

	            function Pya(a) {
	                a = a | 0;
	                nN(a | 0, 0) | 0
	            }

	            function Qya(a) {
	                a = a | 0;
	                oN(a | 0, 0, 0, 0, 0) | 0
	            }

	            function Rya(a) {
	                a = a | 0;
	                pN(a | 0, 0, 0, 0, 0, 0, 0) | 0
	            }

	            function Sya(a) {
	                a = a | 0;
	                qN(a | 0, 0, 0, 0, 0, 0) | 0
	            }

	            function Tya(a) {
	                a = a | 0;
	                rN(a | 0, 0)
	            }

	            function Uya(a) {
	                a = a | 0;
	                tN(a | 0, 0) | 0
	            }

	            function Vya(a) {
	                a = a | 0;
	                uN(a | 0, 0, 0, 0, 0) | 0
	            }

	            function Wya(a) {
	                a = a | 0;
	                vN(a | 0, 0, 0, 0, 0, 0, 0) | 0
	            }

	            function Xya(a) {
	                a = a | 0;
	                wN(a | 0, 0)
	            }

	            function Yya(a) {
	                a = a | 0;
	                CN(a | 0, 0, 0)
	            }

	            function Zya(a) {
	                a = a | 0;
	                GN(a | 0, 0, 0, 0)
	            }

	            function _ya(a) {
	                a = a | 0;
	                vO(a | 0, 0, 0)
	            }

	            function $ya(a) {
	                a = a | 0;
	                wO(a | 0, 0, 0)
	            }

	            function aza(a) {
	                a = a | 0;
	                fP(a | 0, 0, 0, 0)
	            }

	            function bza(a) {
	                a = a | 0;
	                sP(a | 0, 0, 0)
	            }

	            function cza(a) {
	                a = a | 0;
	                fQ(a | 0, 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function dza(a) {
	                a = a | 0;
	                gQ(a | 0, 0, 0, 0)
	            }

	            function eza(a) {
	                a = a | 0;
	                WR(a | 0, 0, 0, 0) | 0
	            }

	            function fza(a) {
	                a = a | 0;
	                QS(a | 0, 0) | 0
	            }

	            function gza(a) {
	                a = a | 0;
	                hT(a | 0, 0, 0) | 0
	            }

	            function hza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                da(6)
	            }

	            function iza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                uc(a | 0, b | 0, 0, 0)
	            }

	            function jza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vc(a | 0) | 0
	            }

	            function kza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                wc(a | 0) | 0
	            }

	            function lza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                xc(a | 0) | 0
	            }

	            function mza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                yc(a | 0, b | 0, 0) | 0
	            }

	            function nza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function oza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Ac(a | 0, b | 0, 0, 0, 0, 0)
	            }

	            function pza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Bc(a | 0, b | 0, 0, 0)
	            }

	            function qza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Cc(a | 0, b | 0, 0, 0, 0, 0, 0)
	            }

	            function rza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Dc(a | 0, b | 0, 0, 0)
	            }

	            function sza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Ec(a | 0, b | 0, 0, 0, 0)
	            }

	            function tza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Gc(a | 0)
	            }

	            function uza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Hc(a | 0)
	            }

	            function vza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Wc(a | 0, b | 0, 0)
	            }

	            function wza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Jc(a | 0, b | 0, 0)
	            }

	            function xza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Kc(a | 0, b | 0, 0)
	            }

	            function yza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Lc(a | 0, b | 0, 0)
	            }

	            function zza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Nc(a | 0, b | 0, 0)
	            }

	            function Aza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Oc(a | 0, b | 0, 0)
	            }

	            function Bza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Pc(a | 0, b | 0, 0)
	            }

	            function Cza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function Dza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Rc(a | 0, b | 0, 0)
	            }

	            function Eza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Sc(a | 0, b | 0, 0, 0)
	            }

	            function Fza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Tc(a | 0, b | 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function Gza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Uc(a | 0, b | 0, 0, 0)
	            }

	            function Hza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Xk(a | 0, b | 0, 0) | 0
	            }

	            function Iza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jT(a | 0)
	            }

	            function Jza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                iT(a | 0) | 0
	            }

	            function Kza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function Lza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                my(a | 0) | 0
	            }

	            function Mza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Td(a | 0, b | 0, 0)
	            }

	            function Nza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                SP(a | 0, b | 0, 0, 0)
	            }

	            function Oza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                PP(a | 0) | 0
	            }

	            function Pza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                QP(a | 0) | 0
	            }

	            function Qza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                RP(a | 0) | 0
	            }

	            function Rza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                UP(a | 0, b | 0, 0) | 0
	            }

	            function Sza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function Tza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                XP(a | 0, b | 0, 0, 0, 0, 0)
	            }

	            function Uza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _P(a | 0, b | 0, 0, 0)
	            }

	            function Vza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                YP(a | 0, b | 0, 0, 0, 0, 0, 0)
	            }

	            function Wza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ZP(a | 0, b | 0, 0, 0)
	            }

	            function Xza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $P(a | 0, b | 0, 0, 0, 0)
	            }

	            function Yza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bQ(a | 0)
	            }

	            function Zza(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cQ(a | 0)
	            }

	            function _za(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dQ(a | 0, b | 0, 0)
	            }

	            function $za(a, b) {
	                a = a | 0;
	                b = b | 0;
	                iQ(a | 0, b | 0, 0)
	            }

	            function aAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                kQ(a | 0, b | 0, 0)
	            }

	            function bAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $d(a | 0, b | 0, 0)
	            }

	            function cAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _d(a | 0, b | 0, 0)
	            }

	            function dAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function eAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                mQ(a | 0, b | 0, 0)
	            }

	            function fAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                TP(a | 0, b | 0, 0, 0)
	            }

	            function gAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                LP(a | 0) | 0
	            }

	            function hAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                MP(a | 0) | 0
	            }

	            function iAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                NP(a | 0) | 0
	            }

	            function jAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                OP(a | 0) | 0
	            }

	            function kAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jQ(a | 0, b | 0, 0)
	            }

	            function lAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                NI(a | 0) | 0
	            }

	            function mAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                OI(a | 0) | 0
	            }

	            function nAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                PI(a | 0) | 0
	            }

	            function oAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                QI(a | 0) | 0
	            }

	            function pAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                RI(a | 0) | 0
	            }

	            function qAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                SI(a | 0) | 0
	            }

	            function rAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                TI(a | 0) | 0
	            }

	            function sAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                UI(a | 0) | 0
	            }

	            function tAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                VI(a | 0) | 0
	            }

	            function uAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                WI(a | 0) | 0
	            }

	            function vAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                XI(a | 0) | 0
	            }

	            function wAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                YI(a | 0) | 0
	            }

	            function xAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ZI(a | 0) | 0
	            }

	            function yAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _I(a | 0) | 0
	            }

	            function zAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $I(a | 0) | 0
	            }

	            function AAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                aJ(a | 0) | 0
	            }

	            function BAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bJ(a | 0) | 0
	            }

	            function CAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cJ(a | 0) | 0
	            }

	            function DAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dJ(a | 0) | 0
	            }

	            function EAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                eJ(a | 0) | 0
	            }

	            function FAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fJ(a | 0) | 0
	            }

	            function GAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gJ(a | 0) | 0
	            }

	            function HAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                hJ(a | 0) | 0
	            }

	            function IAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                iJ(a | 0) | 0
	            }

	            function JAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jJ(a | 0) | 0
	            }

	            function KAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                kJ(a | 0) | 0
	            }

	            function LAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                lJ(a | 0) | 0
	            }

	            function MAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                mJ(a | 0) | 0
	            }

	            function NAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nJ(a | 0) | 0
	            }

	            function OAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                oJ(a | 0) | 0
	            }

	            function PAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                pJ(a | 0) | 0
	            }

	            function QAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                qJ(a | 0) | 0
	            }

	            function RAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                rJ(a | 0) | 0
	            }

	            function SAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                sJ(a | 0) | 0
	            }

	            function TAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                tJ(a | 0) | 0
	            }

	            function UAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                uJ(a | 0) | 0
	            }

	            function VAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vJ(a | 0) | 0
	            }

	            function WAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                wJ(a | 0) | 0
	            }

	            function XAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                xJ(a | 0) | 0
	            }

	            function YAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                yJ(a | 0) | 0
	            }

	            function ZAa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                zJ(a | 0) | 0
	            }

	            function _Aa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                AJ(a | 0) | 0
	            }

	            function $Aa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                BJ(a | 0) | 0
	            }

	            function aBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                CJ(a | 0) | 0
	            }

	            function bBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                DJ(a | 0) | 0
	            }

	            function cBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                EJ(a | 0) | 0
	            }

	            function dBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                FJ(a | 0) | 0
	            }

	            function eBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                GJ(a | 0) | 0
	            }

	            function fBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                HJ(a | 0) | 0
	            }

	            function gBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                IJ(a | 0) | 0
	            }

	            function hBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                JJ(a | 0) | 0
	            }

	            function iBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                KJ(a | 0) | 0
	            }

	            function jBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                LJ(a | 0) | 0
	            }

	            function kBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                MJ(a | 0) | 0
	            }

	            function lBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                NJ(a | 0) | 0
	            }

	            function mBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                OJ(a | 0) | 0
	            }

	            function nBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                PJ(a | 0) | 0
	            }

	            function oBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                QJ(a | 0) | 0
	            }

	            function pBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                RJ(a | 0) | 0
	            }

	            function qBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                SJ(a | 0) | 0
	            }

	            function rBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                TJ(a | 0) | 0
	            }

	            function sBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                UJ(a | 0) | 0
	            }

	            function tBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                VJ(a | 0) | 0
	            }

	            function uBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                WJ(a | 0) | 0
	            }

	            function vBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                XJ(a | 0) | 0
	            }

	            function wBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                YJ(a | 0) | 0
	            }

	            function xBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ZJ(a | 0) | 0
	            }

	            function yBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _J(a | 0) | 0
	            }

	            function zBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $J(a | 0) | 0
	            }

	            function ABa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                aK(a | 0) | 0
	            }

	            function BBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bK(a | 0) | 0
	            }

	            function CBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cK(a | 0) | 0
	            }

	            function DBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dK(a | 0) | 0
	            }

	            function EBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                eK(a | 0) | 0
	            }

	            function FBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fK(a | 0) | 0
	            }

	            function GBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gK(a | 0) | 0
	            }

	            function HBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                hK(a | 0) | 0
	            }

	            function IBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                iK(a | 0) | 0
	            }

	            function JBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jK(a | 0) | 0
	            }

	            function KBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                kK(a | 0) | 0
	            }

	            function LBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                lK(a | 0) | 0
	            }

	            function MBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                mK(a | 0) | 0
	            }

	            function NBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nK(a | 0) | 0
	            }

	            function OBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                oK(a | 0) | 0
	            }

	            function PBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                pK(a | 0) | 0
	            }

	            function QBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                qK(a | 0) | 0
	            }

	            function RBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                rK(a | 0) | 0
	            }

	            function SBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                sK(a | 0) | 0
	            }

	            function TBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                tK(a | 0) | 0
	            }

	            function UBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                uK(a | 0) | 0
	            }

	            function VBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vK(a | 0) | 0
	            }

	            function WBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                wK(a | 0) | 0
	            }

	            function XBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                xK(a | 0) | 0
	            }

	            function YBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                yK(a | 0) | 0
	            }

	            function ZBa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                zK(a | 0) | 0
	            }

	            function _Ba(a, b) {
	                a = a | 0;
	                b = b | 0;
	                AK(a | 0) | 0
	            }

	            function $Ba(a, b) {
	                a = a | 0;
	                b = b | 0;
	                BK(a | 0) | 0
	            }

	            function aCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                CK(a | 0) | 0
	            }

	            function bCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                DK(a | 0) | 0
	            }

	            function cCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                EK(a | 0) | 0
	            }

	            function dCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                FK(a | 0) | 0
	            }

	            function eCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                GK(a | 0) | 0
	            }

	            function fCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                HK(a | 0) | 0
	            }

	            function gCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                IK(a | 0) | 0
	            }

	            function hCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                JK(a | 0) | 0
	            }

	            function iCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                KK(a | 0) | 0
	            }

	            function jCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                LK(a | 0) | 0
	            }

	            function kCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                MK(a | 0) | 0
	            }

	            function lCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                NK(a | 0) | 0
	            }

	            function mCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                OK(a | 0) | 0
	            }

	            function nCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                PK(a | 0) | 0
	            }

	            function oCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                QK(a | 0) | 0
	            }

	            function pCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                RK(a | 0) | 0
	            }

	            function qCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                SK(a | 0) | 0
	            }

	            function rCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                TK(a | 0) | 0
	            }

	            function sCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                UK(a | 0) | 0
	            }

	            function tCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                VK(a | 0) | 0
	            }

	            function uCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                WK(a | 0) | 0
	            }

	            function vCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                XK(a | 0) | 0
	            }

	            function wCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                YK(a | 0) | 0
	            }

	            function xCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ZK(a | 0) | 0
	            }

	            function yCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _K(a | 0) | 0
	            }

	            function zCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $K(a | 0) | 0
	            }

	            function ACa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                aL(a | 0) | 0
	            }

	            function BCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bL(a | 0) | 0
	            }

	            function CCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cL(a | 0) | 0
	            }

	            function DCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dL(a | 0) | 0
	            }

	            function ECa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                eL(a | 0) | 0
	            }

	            function FCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                RT(a | 0, b | 0, 0) | 0
	            }

	            function GCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Vb(a | 0)
	            }

	            function HCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Wb(a | 0) | 0
	            }

	            function ICa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function JCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Yb(a | 0) | 0
	            }

	            function KCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Wk(a | 0, b | 0, 0) | 0
	            }

	            function LCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _b(a | 0)
	            }

	            function MCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $b(a | 0)
	            }

	            function NCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ac(a | 0, b | 0, 0) | 0
	            }

	            function OCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Ka(a | 0, b | 0, 0) | 0
	            }

	            function PCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gc(a | 0, b | 0, 0) | 0
	            }

	            function QCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                hc(a | 0)
	            }

	            function RCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ic(a | 0, b | 0, 0)
	            }

	            function SCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jc(a | 0, b | 0, 0)
	            }

	            function TCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                kc(a | 0, b | 0, 0)
	            }

	            function UCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                lc(a | 0, b | 0, 0)
	            }

	            function VCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nc(a | 0) | 0
	            }

	            function WCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nd(a | 0) | 0
	            }

	            function XCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Kd(a | 0, b | 0, 0, 0) | 0
	            }

	            function YCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Ld(a | 0, b | 0, 0, 0) | 0
	            }

	            function ZCa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Md(a | 0, b | 0, 0, 0) | 0
	            }

	            function _Ca(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Nd(a | 0, b | 0, 0, 0) | 0
	            }

	            function $Ca(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Od(a | 0, b | 0, 0, 0) | 0
	            }

	            function aDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Pd(a | 0, b | 0, 0, 0) | 0
	            }

	            function bDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                qd(a | 0, b | 0, 0, 0) | 0
	            }

	            function cDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                rd(a | 0, b | 0, 0, 0) | 0
	            }

	            function dDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Qd(a | 0, b | 0, 0, 0) | 0
	            }

	            function eDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Rd(a | 0, b | 0, 0, 0) | 0
	            }

	            function fDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fo(a | 0, b | 0, 0, 0) | 0
	            }

	            function gDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ae(a | 0, b | 0, 0)
	            }

	            function hDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                be(a | 0, b | 0, 0)
	            }

	            function iDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                tg(a | 0)
	            }

	            function jDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                mk() | 0
	            }

	            function kDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                sh(a | 0, b | 0, 0, 0, 0)
	            }

	            function lDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gk(a | 0, b | 0, 0, 0, 0)
	            }

	            function mDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nk(a | 0) | 0
	            }

	            function nDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ok(a | 0) | 0
	            }

	            function oDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                pk(a | 0, b | 0, 0) | 0
	            }

	            function pDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                qk(a | 0) | 0
	            }

	            function qDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _k(a | 0) | 0
	            }

	            function rDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $k(a | 0, b | 0, 0) | 0
	            }

	            function sDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bl(a | 0) | 0
	            }

	            function tDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cl(a | 0, b | 0, 0) | 0
	            }

	            function uDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dl(a | 0) | 0
	            }

	            function vDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                el(a | 0, b | 0, 0) | 0
	            }

	            function wDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fl(a | 0, b | 0, 0) | 0
	            }

	            function xDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gl(a | 0, b | 0, 0, 0) | 0
	            }

	            function yDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nn(a | 0)
	            }

	            function zDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                on(a | 0) | 0
	            }

	            function ADa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                sn(a | 0)
	            }

	            function BDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vn(a | 0) | 0
	            }

	            function CDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                xn(a | 0)
	            }

	            function DDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                yn(a | 0) | 0
	            }

	            function EDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                An(a | 0)
	            }

	            function FDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Bn(a | 0)
	            }

	            function GDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function HDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Dn(a | 0)
	            }

	            function IDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                In(a | 0, b | 0, 0)
	            }

	            function JDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Rn(a | 0, b | 0, 0)
	            }

	            function KDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Sn(a | 0, b | 0, 0)
	            }

	            function LDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Tn(a | 0, b | 0, 0)
	            }

	            function MDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Un(a | 0, b | 0, 0)
	            }

	            function NDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function ODa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Qq(a | 0)
	            }

	            function PDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                uu(a | 0, b | 0, 0) | 0
	            }

	            function QDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function RDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function SDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function TDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vu(a | 0, b | 0, 0) | 0
	            }

	            function UDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function VDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function WDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function XDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function YDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function ZDa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function _Da(a, b) {
	                a = a | 0;
	                b = b | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function $Da(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function aEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function bEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function cEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function dEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function eEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                tw(a | 0, b | 0, 0)
	            }

	            function fEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Mw(a | 0)
	            }

	            function gEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Yw(a | 0)
	            }

	            function hEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                Kx(a | 0, b | 0, 0) | 0
	            }

	            function iEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function jEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function kEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function lEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function mEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                qB(a | 0)
	            }

	            function nEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                LB(a | 0, b | 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function oEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                MB(a | 0, b | 0, 0, 0)
	            }

	            function pEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                NB(a | 0, b | 0, 0)
	            }

	            function qEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                OB(a | 0, b | 0, 0)
	            }

	            function rEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                QB(a | 0, b | 0, 0, 0)
	            }

	            function sEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                RB(a | 0) | 0
	            }

	            function tEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                SB(a | 0) | 0
	            }

	            function uEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                TB(a | 0) | 0
	            }

	            function vEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                UB(a | 0, b | 0, 0) | 0
	            }

	            function wEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function xEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                WB(a | 0, b | 0, 0, 0, 0, 0)
	            }

	            function yEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                XB(a | 0, b | 0, 0, 0)
	            }

	            function zEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                YB(a | 0, b | 0, 0, 0, 0, 0, 0)
	            }

	            function AEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                ZB(a | 0, b | 0, 0, 0)
	            }

	            function BEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                _B(a | 0, b | 0, 0, 0, 0)
	            }

	            function CEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                aC(a | 0)
	            }

	            function DEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                bC(a | 0)
	            }

	            function EEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                cC(a | 0, b | 0, 0)
	            }

	            function FEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                eC(a | 0, b | 0, 0)
	            }

	            function GEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fC(a | 0, b | 0, 0)
	            }

	            function HEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gC(a | 0, b | 0, 0)
	            }

	            function IEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function JEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                iC(a | 0, b | 0, 0, 0)
	            }

	            function KEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                jC(a | 0, b | 0, 0)
	            }

	            function LEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                kC(a | 0, b | 0, 0)
	            }

	            function MEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                lC(a | 0, b | 0, 0)
	            }

	            function NEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nC(a | 0, b | 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function OEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                oC(a | 0, b | 0, 0, 0)
	            }

	            function PEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                rC(a | 0, b | 0, 0) | 0
	            }

	            function QEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                uC(a | 0)
	            }

	            function REa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                lF(a | 0, b | 0, 0, 0)
	            }

	            function SEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                VA(a | 0)
	            }

	            function TEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                wM(a | 0, b | 0, 0)
	            }

	            function UEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                yM(a | 0, b | 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function VEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                zM(a | 0, b | 0, 0, 0)
	            }

	            function WEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                AM(a | 0, b | 0, 0)
	            }

	            function XEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                BM(a | 0, b | 0, 0)
	            }

	            function YEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                DM(a | 0, b | 0, 0)
	            }

	            function ZEa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                EM(a | 0, b | 0, 0)
	            }

	            function _Ea(a, b) {
	                a = a | 0;
	                b = b | 0;
	                GM(a | 0, b | 0, 0) | 0
	            }

	            function $Ea(a, b) {
	                a = a | 0;
	                b = b | 0;
	                UM(a | 0)
	            }

	            function aFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function bFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                oN(a | 0, b | 0, 0, 0, 0) | 0
	            }

	            function cFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                pN(a | 0, b | 0, 0, 0, 0, 0, 0) | 0
	            }

	            function dFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                qN(a | 0, b | 0, 0, 0, 0, 0) | 0
	            }

	            function eFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function fFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                uN(a | 0, b | 0, 0, 0, 0) | 0
	            }

	            function gFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vN(a | 0, b | 0, 0, 0, 0, 0, 0) | 0
	            }

	            function hFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                CN(a | 0, b | 0, 0)
	            }

	            function iFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                GN(a | 0, b | 0, 0, 0)
	            }

	            function jFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                vO(a | 0, b | 0, 0)
	            }

	            function kFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                wO(a | 0, b | 0, 0)
	            }

	            function lFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fP(a | 0, b | 0, 0, 0)
	            }

	            function mFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                sP(a | 0, b | 0, 0)
	            }

	            function nFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                fQ(a | 0, b | 0, 0, 0, 0, 0, 0, 0, 0)
	            }

	            function oFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                gQ(a | 0, b | 0, 0, 0)
	            }

	            function pFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                WR(a | 0, b | 0, 0, 0) | 0
	            }

	            function qFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function rFa(a, b) {
	                a = a | 0;
	                b = b | 0;
	                hT(a | 0, b | 0, 0) | 0
	            }

	            function sFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                da(7);
	                return 0
	            }

	            function tFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function uFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return vc(a | 0) | 0
	            }

	            function vFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return wc(a | 0) | 0
	            }

	            function wFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return xc(a | 0) | 0
	            }

	            function xFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return yc(a | 0, b | 0, c | 0) | 0
	            }

	            function yFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return zc(a | 0, b | 0) | 0
	            }

	            function zFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function AFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function BFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function CFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function DFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function EFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function FFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function GFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function HFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function IFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function JFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function KFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function LFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function MFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function NFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function OFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function PFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function QFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function RFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Qc(a | 0, b | 0) | 0
	            }

	            function SFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function TFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function UFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function VFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function WFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function XFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function YFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return iT(a | 0) | 0
	            }

	            function ZFa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return kT(a | 0, b | 0) | 0
	            }

	            function _Fa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return my(a | 0) | 0
	            }

	            function $Fa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function aGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function bGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return PP(a | 0) | 0
	            }

	            function cGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return QP(a | 0) | 0
	            }

	            function dGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return RP(a | 0) | 0
	            }

	            function eGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return UP(a | 0, b | 0, c | 0) | 0
	            }

	            function fGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return VP(a | 0, b | 0) | 0
	            }

	            function gGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function hGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function iGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function jGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function kGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function lGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function mGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function nGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function oGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function pGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function qGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function rGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function sGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function tGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function uGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function vGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function wGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return WP(a | 0, b | 0) | 0
	            }

	            function xGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function yGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function zGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return LP(a | 0) | 0
	            }

	            function AGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return MP(a | 0) | 0
	            }

	            function BGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return NP(a | 0) | 0
	            }

	            function CGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return OP(a | 0) | 0
	            }

	            function DGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function EGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return NI(a | 0) | 0
	            }

	            function FGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return OI(a | 0) | 0
	            }

	            function GGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return PI(a | 0) | 0
	            }

	            function HGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return QI(a | 0) | 0
	            }

	            function IGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return RI(a | 0) | 0
	            }

	            function JGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return SI(a | 0) | 0
	            }

	            function KGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return TI(a | 0) | 0
	            }

	            function LGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return UI(a | 0) | 0
	            }

	            function MGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return VI(a | 0) | 0
	            }

	            function NGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return WI(a | 0) | 0
	            }

	            function OGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return XI(a | 0) | 0
	            }

	            function PGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return YI(a | 0) | 0
	            }

	            function QGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return ZI(a | 0) | 0
	            }

	            function RGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return _I(a | 0) | 0
	            }

	            function SGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return $I(a | 0) | 0
	            }

	            function TGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return aJ(a | 0) | 0
	            }

	            function UGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return bJ(a | 0) | 0
	            }

	            function VGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return cJ(a | 0) | 0
	            }

	            function WGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return dJ(a | 0) | 0
	            }

	            function XGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return eJ(a | 0) | 0
	            }

	            function YGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return fJ(a | 0) | 0
	            }

	            function ZGa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return gJ(a | 0) | 0
	            }

	            function _Ga(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return hJ(a | 0) | 0
	            }

	            function $Ga(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return iJ(a | 0) | 0
	            }

	            function aHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return jJ(a | 0) | 0
	            }

	            function bHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return kJ(a | 0) | 0
	            }

	            function cHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return lJ(a | 0) | 0
	            }

	            function dHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return mJ(a | 0) | 0
	            }

	            function eHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return nJ(a | 0) | 0
	            }

	            function fHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return oJ(a | 0) | 0
	            }

	            function gHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return pJ(a | 0) | 0
	            }

	            function hHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return qJ(a | 0) | 0
	            }

	            function iHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return rJ(a | 0) | 0
	            }

	            function jHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return sJ(a | 0) | 0
	            }

	            function kHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return tJ(a | 0) | 0
	            }

	            function lHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return uJ(a | 0) | 0
	            }

	            function mHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return vJ(a | 0) | 0
	            }

	            function nHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return wJ(a | 0) | 0
	            }

	            function oHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return xJ(a | 0) | 0
	            }

	            function pHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return yJ(a | 0) | 0
	            }

	            function qHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return zJ(a | 0) | 0
	            }

	            function rHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return AJ(a | 0) | 0
	            }

	            function sHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return BJ(a | 0) | 0
	            }

	            function tHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return CJ(a | 0) | 0
	            }

	            function uHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return DJ(a | 0) | 0
	            }

	            function vHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return EJ(a | 0) | 0
	            }

	            function wHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return FJ(a | 0) | 0
	            }

	            function xHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return GJ(a | 0) | 0
	            }

	            function yHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return HJ(a | 0) | 0
	            }

	            function zHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return IJ(a | 0) | 0
	            }

	            function AHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return JJ(a | 0) | 0
	            }

	            function BHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return KJ(a | 0) | 0
	            }

	            function CHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return LJ(a | 0) | 0
	            }

	            function DHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return MJ(a | 0) | 0
	            }

	            function EHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return NJ(a | 0) | 0
	            }

	            function FHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return OJ(a | 0) | 0
	            }

	            function GHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return PJ(a | 0) | 0
	            }

	            function HHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return QJ(a | 0) | 0
	            }

	            function IHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return RJ(a | 0) | 0
	            }

	            function JHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return SJ(a | 0) | 0
	            }

	            function KHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return TJ(a | 0) | 0
	            }

	            function LHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return UJ(a | 0) | 0
	            }

	            function MHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return VJ(a | 0) | 0
	            }

	            function NHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return WJ(a | 0) | 0
	            }

	            function OHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return XJ(a | 0) | 0
	            }

	            function PHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return YJ(a | 0) | 0
	            }

	            function QHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return ZJ(a | 0) | 0
	            }

	            function RHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return _J(a | 0) | 0
	            }

	            function SHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return $J(a | 0) | 0
	            }

	            function THa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return aK(a | 0) | 0
	            }

	            function UHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return bK(a | 0) | 0
	            }

	            function VHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return cK(a | 0) | 0
	            }

	            function WHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return dK(a | 0) | 0
	            }

	            function XHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return eK(a | 0) | 0
	            }

	            function YHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return fK(a | 0) | 0
	            }

	            function ZHa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return gK(a | 0) | 0
	            }

	            function _Ha(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return hK(a | 0) | 0
	            }

	            function $Ha(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return iK(a | 0) | 0
	            }

	            function aIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return jK(a | 0) | 0
	            }

	            function bIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return kK(a | 0) | 0
	            }

	            function cIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return lK(a | 0) | 0
	            }

	            function dIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return mK(a | 0) | 0
	            }

	            function eIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return nK(a | 0) | 0
	            }

	            function fIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return oK(a | 0) | 0
	            }

	            function gIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return pK(a | 0) | 0
	            }

	            function hIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return qK(a | 0) | 0
	            }

	            function iIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return rK(a | 0) | 0
	            }

	            function jIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return sK(a | 0) | 0
	            }

	            function kIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return tK(a | 0) | 0
	            }

	            function lIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return uK(a | 0) | 0
	            }

	            function mIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return vK(a | 0) | 0
	            }

	            function nIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return wK(a | 0) | 0
	            }

	            function oIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return xK(a | 0) | 0
	            }

	            function pIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return yK(a | 0) | 0
	            }

	            function qIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return zK(a | 0) | 0
	            }

	            function rIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return AK(a | 0) | 0
	            }

	            function sIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return BK(a | 0) | 0
	            }

	            function tIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return CK(a | 0) | 0
	            }

	            function uIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return DK(a | 0) | 0
	            }

	            function vIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return EK(a | 0) | 0
	            }

	            function wIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return FK(a | 0) | 0
	            }

	            function xIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return GK(a | 0) | 0
	            }

	            function yIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return HK(a | 0) | 0
	            }

	            function zIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return IK(a | 0) | 0
	            }

	            function AIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return JK(a | 0) | 0
	            }

	            function BIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return KK(a | 0) | 0
	            }

	            function CIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return LK(a | 0) | 0
	            }

	            function DIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return MK(a | 0) | 0
	            }

	            function EIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return NK(a | 0) | 0
	            }

	            function FIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return OK(a | 0) | 0
	            }

	            function GIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return PK(a | 0) | 0
	            }

	            function HIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return QK(a | 0) | 0
	            }

	            function IIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return RK(a | 0) | 0
	            }

	            function JIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return SK(a | 0) | 0
	            }

	            function KIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return TK(a | 0) | 0
	            }

	            function LIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return UK(a | 0) | 0
	            }

	            function MIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return VK(a | 0) | 0
	            }

	            function NIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return WK(a | 0) | 0
	            }

	            function OIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return XK(a | 0) | 0
	            }

	            function PIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return YK(a | 0) | 0
	            }

	            function QIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return ZK(a | 0) | 0
	            }

	            function RIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return _K(a | 0) | 0
	            }

	            function SIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return $K(a | 0) | 0
	            }

	            function TIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return aL(a | 0) | 0
	            }

	            function UIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return bL(a | 0) | 0
	            }

	            function VIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return cL(a | 0) | 0
	            }

	            function WIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return dL(a | 0) | 0
	            }

	            function XIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return eL(a | 0) | 0
	            }

	            function YIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return RT(a | 0, b | 0, c | 0) | 0
	            }

	            function ZIa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function _Ia(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Wb(a | 0) | 0
	            }

	            function $Ia(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Xb(a | 0, b | 0) | 0
	            }

	            function aJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Yb(a | 0) | 0
	            }

	            function bJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function cJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function dJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function eJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return ac(a | 0, b | 0, c | 0) | 0
	            }

	            function fJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function gJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return gc(a | 0, b | 0, c | 0) | 0
	            }

	            function hJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function iJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function jJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function kJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function lJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function mJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return nc(a | 0) | 0
	            }

	            function nJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function oJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return nd(a | 0) | 0
	            }

	            function pJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function qJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function rJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function sJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function tJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function uJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function vJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function wJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function xJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function yJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function zJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function AJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function BJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function CJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function DJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return mk() | 0
	            }

	            function EJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function FJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function GJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return nk(a | 0) | 0
	            }

	            function HJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return ok(a | 0) | 0
	            }

	            function IJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return pk(a | 0, b | 0, c | 0) | 0
	            }

	            function JJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return qk(a | 0) | 0
	            }

	            function KJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return _k(a | 0) | 0
	            }

	            function LJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return $k(a | 0, b | 0, c | 0) | 0
	            }

	            function MJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return bl(a | 0) | 0
	            }

	            function NJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return cl(a | 0, b | 0, c | 0) | 0
	            }

	            function OJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return dl(a | 0) | 0
	            }

	            function PJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return el(a | 0, b | 0, c | 0) | 0
	            }

	            function QJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return fl(a | 0, b | 0, c | 0) | 0
	            }

	            function RJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function SJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function TJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return on(a | 0) | 0
	            }

	            function UJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function VJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return vn(a | 0) | 0
	            }

	            function WJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function XJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return yn(a | 0) | 0
	            }

	            function YJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function ZJa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function _Ja(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function $Ja(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Cn(a | 0, b | 0) | 0
	            }

	            function aKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function bKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function cKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function dKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function eKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function fKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function gKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return _n(a | 0, b | 0) | 0
	            }

	            function hKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function iKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function jKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function kKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function lKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function mKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function nKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function oKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function pKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function qKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function rKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function sKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function tKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function uKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function vKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function wKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function xKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function yKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function zKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function AKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function BKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function CKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function DKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function EKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function FKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function GKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function HKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function IKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function JKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function KKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function LKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return uu(a | 0, b | 0, c | 0) | 0
	            }

	            function MKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return ds(a | 0, b | 0) | 0
	            }

	            function NKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return es(a | 0, b | 0) | 0
	            }

	            function OKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return js(a | 0, b | 0) | 0
	            }

	            function PKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return vu(a | 0, b | 0, c | 0) | 0
	            }

	            function QKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return wu(a | 0, b | 0) | 0
	            }

	            function RKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return $r(a | 0, b | 0) | 0
	            }

	            function SKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return as(a | 0, b | 0) | 0
	            }

	            function TKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return bs(a | 0, b | 0) | 0
	            }

	            function UKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return hs(a | 0, b | 0) | 0
	            }

	            function VKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return fs(a | 0, b | 0) | 0
	            }

	            function WKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return is(a | 0, b | 0) | 0
	            }

	            function XKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return cs(a | 0, b | 0) | 0
	            }

	            function YKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return xu(a | 0, b | 0) | 0
	            }

	            function ZKa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return gs(a | 0, b | 0) | 0
	            }

	            function _Ka(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return _r(a | 0, b | 0) | 0
	            }

	            function $Ka(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return dr(a | 0, b | 0) | 0
	            }

	            function aLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function bLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function cLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function dLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function eLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function fLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function gLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function hLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function iLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function jLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function kLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function lLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function mLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return $x(a | 0, b | 0) | 0
	            }

	            function nLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return dy(a | 0, b | 0) | 0
	            }

	            function oLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return fy(a | 0, b | 0) | 0
	            }

	            function pLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return jy(a | 0, b | 0) | 0
	            }

	            function qLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function rLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function sLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function tLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function uLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function vLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function wLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function xLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return RB(a | 0) | 0
	            }

	            function yLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return SB(a | 0) | 0
	            }

	            function zLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return TB(a | 0) | 0
	            }

	            function ALa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return UB(a | 0, b | 0, c | 0) | 0
	            }

	            function BLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return VB(a | 0, b | 0) | 0
	            }

	            function CLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function DLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function ELa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function FLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function GLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function HLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function ILa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function JLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function KLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function LLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function MLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function NLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function OLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function PLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return hC(a | 0, b | 0) | 0
	            }

	            function QLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function RLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function SLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function TLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function ULa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function VLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function WLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function XLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return rC(a | 0, b | 0, c | 0) | 0
	            }

	            function YLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function ZLa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function _La(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function $La(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function aMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function bMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function cMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function dMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function eMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function fMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function gMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function hMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function iMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function jMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return GM(a | 0, b | 0, c | 0) | 0
	            }

	            function kMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function lMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function mMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return nN(a | 0, b | 0) | 0
	            }

	            function nMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return oN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function oMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return pN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0) | 0
	            }

	            function pMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function qMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return tN(a | 0, b | 0) | 0
	            }

	            function rMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return uN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function sMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return vN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0) | 0
	            }

	            function tMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function uMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function vMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function wMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function xMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function yMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function zMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function AMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function BMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return 0
	            }

	            function CMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function DMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return QS(a | 0, b | 0) | 0
	            }

	            function EMa(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                return hT(a | 0, b | 0, c | 0) | 0
	            }

	            function FMa(a) {
	                a = a | 0;
	                da(8);
	                return 0
	            }

	            function GMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function HMa(a) {
	                a = a | 0;
	                return yc(a | 0, 0, 0) | 0
	            }

	            function IMa(a) {
	                a = a | 0;
	                return zc(a | 0, 0) | 0
	            }

	            function JMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function KMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function LMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function MMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function NMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function OMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function PMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function QMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function RMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function SMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function TMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function UMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function VMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function WMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function XMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function YMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ZMa(a) {
	                a = a | 0;
	                return 0
	            }

	            function _Ma(a) {
	                a = a | 0;
	                return 0
	            }

	            function $Ma(a) {
	                a = a | 0;
	                return Qc(a | 0, 0) | 0
	            }

	            function aNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function bNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function cNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function dNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function eNa(a) {
	                a = a | 0;
	                return Xk(a | 0, 0, 0) | 0
	            }

	            function fNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function gNa(a) {
	                a = a | 0;
	                return kT(a | 0, 0) | 0
	            }

	            function hNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function iNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function jNa(a) {
	                a = a | 0;
	                return UP(a | 0, 0, 0) | 0
	            }

	            function kNa(a) {
	                a = a | 0;
	                return VP(a | 0, 0) | 0
	            }

	            function lNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function mNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function nNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function oNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function pNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function qNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function rNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function sNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function tNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function uNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function vNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function wNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function xNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function yNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function zNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ANa(a) {
	                a = a | 0;
	                return 0
	            }

	            function BNa(a) {
	                a = a | 0;
	                return WP(a | 0, 0) | 0
	            }

	            function CNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function DNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ENa(a) {
	                a = a | 0;
	                return 0
	            }

	            function FNa(a) {
	                a = a | 0;
	                return RT(a | 0, 0, 0) | 0
	            }

	            function GNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function HNa(a) {
	                a = a | 0;
	                return Xb(a | 0, 0) | 0
	            }

	            function INa(a) {
	                a = a | 0;
	                return Wk(a | 0, 0, 0) | 0
	            }

	            function JNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function KNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function LNa(a) {
	                a = a | 0;
	                return ac(a | 0, 0, 0) | 0
	            }

	            function MNa(a) {
	                a = a | 0;
	                return Ka(a | 0, 0, 0) | 0
	            }

	            function NNa(a) {
	                a = a | 0;
	                return gc(a | 0, 0, 0) | 0
	            }

	            function ONa(a) {
	                a = a | 0;
	                return 0
	            }

	            function PNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function QNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function RNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function SNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function TNa(a) {
	                a = a | 0;
	                return 0
	            }

	            function UNa(a) {
	                a = a | 0;
	                return Kd(a | 0, 0, 0, 0) | 0
	            }

	            function VNa(a) {
	                a = a | 0;
	                return Ld(a | 0, 0, 0, 0) | 0
	            }

	            function WNa(a) {
	                a = a | 0;
	                return Md(a | 0, 0, 0, 0) | 0
	            }

	            function XNa(a) {
	                a = a | 0;
	                return Nd(a | 0, 0, 0, 0) | 0
	            }

	            function YNa(a) {
	                a = a | 0;
	                return Od(a | 0, 0, 0, 0) | 0
	            }

	            function ZNa(a) {
	                a = a | 0;
	                return Pd(a | 0, 0, 0, 0) | 0
	            }

	            function _Na(a) {
	                a = a | 0;
	                return qd(a | 0, 0, 0, 0) | 0
	            }

	            function $Na(a) {
	                a = a | 0;
	                return rd(a | 0, 0, 0, 0) | 0
	            }

	            function aOa(a) {
	                a = a | 0;
	                return Qd(a | 0, 0, 0, 0) | 0
	            }

	            function bOa(a) {
	                a = a | 0;
	                return Rd(a | 0, 0, 0, 0) | 0
	            }

	            function cOa(a) {
	                a = a | 0;
	                return fo(a | 0, 0, 0, 0) | 0
	            }

	            function dOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function eOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function fOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function gOa(a) {
	                a = a | 0;
	                return mk() | 0
	            }

	            function hOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function iOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function jOa(a) {
	                a = a | 0;
	                return pk(a | 0, 0, 0) | 0
	            }

	            function kOa(a) {
	                a = a | 0;
	                return $k(a | 0, 0, 0) | 0
	            }

	            function lOa(a) {
	                a = a | 0;
	                return cl(a | 0, 0, 0) | 0
	            }

	            function mOa(a) {
	                a = a | 0;
	                return el(a | 0, 0, 0) | 0
	            }

	            function nOa(a) {
	                a = a | 0;
	                return fl(a | 0, 0, 0) | 0
	            }

	            function oOa(a) {
	                a = a | 0;
	                return gl(a | 0, 0, 0, 0) | 0
	            }

	            function pOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function qOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function rOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function sOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function tOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function uOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function vOa(a) {
	                a = a | 0;
	                return Cn(a | 0, 0) | 0
	            }

	            function wOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function xOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function yOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function zOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function AOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function BOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function COa(a) {
	                a = a | 0;
	                return _n(a | 0, 0) | 0
	            }

	            function DOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function EOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function FOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function GOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function HOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function IOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function JOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function KOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function LOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function MOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function NOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function OOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function POa(a) {
	                a = a | 0;
	                return 0
	            }

	            function QOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ROa(a) {
	                a = a | 0;
	                return 0
	            }

	            function SOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function TOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function UOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function VOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function WOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function XOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function YOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ZOa(a) {
	                a = a | 0;
	                return 0
	            }

	            function _Oa(a) {
	                a = a | 0;
	                return 0
	            }

	            function $Oa(a) {
	                a = a | 0;
	                return 0
	            }

	            function aPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function bPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function cPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function dPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ePa(a) {
	                a = a | 0;
	                return 0
	            }

	            function fPa(a) {
	                a = a | 0;
	                return uu(a | 0, 0, 0) | 0
	            }

	            function gPa(a) {
	                a = a | 0;
	                return ds(a | 0, 0) | 0
	            }

	            function hPa(a) {
	                a = a | 0;
	                return es(a | 0, 0) | 0
	            }

	            function iPa(a) {
	                a = a | 0;
	                return js(a | 0, 0) | 0
	            }

	            function jPa(a) {
	                a = a | 0;
	                return vu(a | 0, 0, 0) | 0
	            }

	            function kPa(a) {
	                a = a | 0;
	                return wu(a | 0, 0) | 0
	            }

	            function lPa(a) {
	                a = a | 0;
	                return $r(a | 0, 0) | 0
	            }

	            function mPa(a) {
	                a = a | 0;
	                return as(a | 0, 0) | 0
	            }

	            function nPa(a) {
	                a = a | 0;
	                return bs(a | 0, 0) | 0
	            }

	            function oPa(a) {
	                a = a | 0;
	                return hs(a | 0, 0) | 0
	            }

	            function pPa(a) {
	                a = a | 0;
	                return fs(a | 0, 0) | 0
	            }

	            function qPa(a) {
	                a = a | 0;
	                return is(a | 0, 0) | 0
	            }

	            function rPa(a) {
	                a = a | 0;
	                return cs(a | 0, 0) | 0
	            }

	            function sPa(a) {
	                a = a | 0;
	                return xu(a | 0, 0) | 0
	            }

	            function tPa(a) {
	                a = a | 0;
	                return gs(a | 0, 0) | 0
	            }

	            function uPa(a) {
	                a = a | 0;
	                return _r(a | 0, 0) | 0
	            }

	            function vPa(a) {
	                a = a | 0;
	                return dr(a | 0, 0) | 0
	            }

	            function wPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function xPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function yPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function zPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function APa(a) {
	                a = a | 0;
	                return 0
	            }

	            function BPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function CPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function DPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function EPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function FPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function GPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function HPa(a) {
	                a = a | 0;
	                return Kx(a | 0, 0, 0) | 0
	            }

	            function IPa(a) {
	                a = a | 0;
	                return $x(a | 0, 0) | 0
	            }

	            function JPa(a) {
	                a = a | 0;
	                return dy(a | 0, 0) | 0
	            }

	            function KPa(a) {
	                a = a | 0;
	                return fy(a | 0, 0) | 0
	            }

	            function LPa(a) {
	                a = a | 0;
	                return jy(a | 0, 0) | 0
	            }

	            function MPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function NPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function OPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function PPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function QPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function RPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function SPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function TPa(a) {
	                a = a | 0;
	                return UB(a | 0, 0, 0) | 0
	            }

	            function UPa(a) {
	                a = a | 0;
	                return VB(a | 0, 0) | 0
	            }

	            function VPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function WPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function XPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function YPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function ZPa(a) {
	                a = a | 0;
	                return 0
	            }

	            function _Pa(a) {
	                a = a | 0;
	                return 0
	            }

	            function $Pa(a) {
	                a = a | 0;
	                return 0
	            }

	            function aQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function bQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function cQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function dQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function eQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function fQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function gQa(a) {
	                a = a | 0;
	                return hC(a | 0, 0) | 0
	            }

	            function hQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function iQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function jQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function kQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function lQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function mQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function nQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function oQa(a) {
	                a = a | 0;
	                return rC(a | 0, 0, 0) | 0
	            }

	            function pQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function qQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function rQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function sQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function tQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function uQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function vQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function wQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function xQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function yQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function zQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function AQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function BQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function CQa(a) {
	                a = a | 0;
	                return GM(a | 0, 0, 0) | 0
	            }

	            function DQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function EQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function FQa(a) {
	                a = a | 0;
	                return nN(a | 0, 0) | 0
	            }

	            function GQa(a) {
	                a = a | 0;
	                return oN(a | 0, 0, 0, 0, 0) | 0
	            }

	            function HQa(a) {
	                a = a | 0;
	                return pN(a | 0, 0, 0, 0, 0, 0, 0) | 0
	            }

	            function IQa(a) {
	                a = a | 0;
	                return qN(a | 0, 0, 0, 0, 0, 0) | 0
	            }

	            function JQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function KQa(a) {
	                a = a | 0;
	                return tN(a | 0, 0) | 0
	            }

	            function LQa(a) {
	                a = a | 0;
	                return uN(a | 0, 0, 0, 0, 0) | 0
	            }

	            function MQa(a) {
	                a = a | 0;
	                return vN(a | 0, 0, 0, 0, 0, 0, 0) | 0
	            }

	            function NQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function OQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function PQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function QQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function RQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function SQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function TQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function UQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function VQa(a) {
	                a = a | 0;
	                return 0
	            }

	            function WQa(a) {
	                a = a | 0;
	                return WR(a | 0, 0, 0, 0) | 0
	            }

	            function XQa(a) {
	                a = a | 0;
	                return QS(a | 0, 0) | 0
	            }

	            function YQa(a) {
	                a = a | 0;
	                return hT(a | 0, 0, 0) | 0
	            }

	            function ZQa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                da(9)
	            }

	            function _Qa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uc(a | 0, b | 0, c | 0, 0)
	            }

	            function $Qa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vc(a | 0) | 0
	            }

	            function aRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                wc(a | 0) | 0
	            }

	            function bRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xc(a | 0) | 0
	            }

	            function cRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                yc(a | 0, b | 0, c | 0) | 0
	            }

	            function dRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function eRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ac(a | 0, b | 0, c | 0, 0, 0, 0)
	            }

	            function fRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Bc(a | 0, b | 0, c | 0, 0)
	            }

	            function gRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Cc(a | 0, b | 0, c | 0, 0, 0, 0, 0)
	            }

	            function hRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Dc(a | 0, b | 0, c | 0, 0)
	            }

	            function iRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ec(a | 0, b | 0, c | 0, 0, 0)
	            }

	            function jRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Fc(a | 0, b | 0)
	            }

	            function kRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Gc(a | 0)
	            }

	            function lRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Hc(a | 0)
	            }

	            function mRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Xc(a | 0, b | 0)
	            }

	            function nRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ic(a | 0, b | 0)
	            }

	            function oRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Mc(a | 0, b | 0)
	            }

	            function pRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function qRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Sc(a | 0, b | 0, c | 0, 0)
	            }

	            function rRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Tc(a | 0, b | 0, c | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function sRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Uc(a | 0, b | 0, c | 0, 0)
	            }

	            function tRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function uRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                jT(a | 0)
	            }

	            function vRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                iT(a | 0) | 0
	            }

	            function wRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function xRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                my(a | 0) | 0
	            }

	            function yRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                SP(a | 0, b | 0, c | 0, 0)
	            }

	            function zRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                PP(a | 0) | 0
	            }

	            function ARa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                QP(a | 0) | 0
	            }

	            function BRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                RP(a | 0) | 0
	            }

	            function CRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                UP(a | 0, b | 0, c | 0) | 0
	            }

	            function DRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function ERa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                XP(a | 0, b | 0, c | 0, 0, 0, 0)
	            }

	            function FRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _P(a | 0, b | 0, c | 0, 0)
	            }

	            function GRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                YP(a | 0, b | 0, c | 0, 0, 0, 0, 0)
	            }

	            function HRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ZP(a | 0, b | 0, c | 0, 0)
	            }

	            function IRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $P(a | 0, b | 0, c | 0, 0, 0)
	            }

	            function JRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                aQ(a | 0, b | 0)
	            }

	            function KRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bQ(a | 0)
	            }

	            function LRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                cQ(a | 0)
	            }

	            function MRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                eQ(a | 0, b | 0)
	            }

	            function NRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hQ(a | 0, b | 0)
	            }

	            function ORa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                lQ(a | 0, b | 0)
	            }

	            function PRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function QRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                TP(a | 0, b | 0, c | 0, 0)
	            }

	            function RRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                LP(a | 0) | 0
	            }

	            function SRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                MP(a | 0) | 0
	            }

	            function TRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                NP(a | 0) | 0
	            }

	            function URa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                OP(a | 0) | 0
	            }

	            function VRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                NI(a | 0) | 0
	            }

	            function WRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                OI(a | 0) | 0
	            }

	            function XRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                PI(a | 0) | 0
	            }

	            function YRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                QI(a | 0) | 0
	            }

	            function ZRa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                RI(a | 0) | 0
	            }

	            function _Ra(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                SI(a | 0) | 0
	            }

	            function $Ra(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                TI(a | 0) | 0
	            }

	            function aSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                UI(a | 0) | 0
	            }

	            function bSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                VI(a | 0) | 0
	            }

	            function cSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                WI(a | 0) | 0
	            }

	            function dSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                XI(a | 0) | 0
	            }

	            function eSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                YI(a | 0) | 0
	            }

	            function fSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ZI(a | 0) | 0
	            }

	            function gSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _I(a | 0) | 0
	            }

	            function hSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $I(a | 0) | 0
	            }

	            function iSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                aJ(a | 0) | 0
	            }

	            function jSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bJ(a | 0) | 0
	            }

	            function kSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                cJ(a | 0) | 0
	            }

	            function lSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dJ(a | 0) | 0
	            }

	            function mSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                eJ(a | 0) | 0
	            }

	            function nSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fJ(a | 0) | 0
	            }

	            function oSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gJ(a | 0) | 0
	            }

	            function pSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hJ(a | 0) | 0
	            }

	            function qSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                iJ(a | 0) | 0
	            }

	            function rSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                jJ(a | 0) | 0
	            }

	            function sSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                kJ(a | 0) | 0
	            }

	            function tSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                lJ(a | 0) | 0
	            }

	            function uSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                mJ(a | 0) | 0
	            }

	            function vSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nJ(a | 0) | 0
	            }

	            function wSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                oJ(a | 0) | 0
	            }

	            function xSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                pJ(a | 0) | 0
	            }

	            function ySa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qJ(a | 0) | 0
	            }

	            function zSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rJ(a | 0) | 0
	            }

	            function ASa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                sJ(a | 0) | 0
	            }

	            function BSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                tJ(a | 0) | 0
	            }

	            function CSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uJ(a | 0) | 0
	            }

	            function DSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vJ(a | 0) | 0
	            }

	            function ESa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                wJ(a | 0) | 0
	            }

	            function FSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xJ(a | 0) | 0
	            }

	            function GSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                yJ(a | 0) | 0
	            }

	            function HSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                zJ(a | 0) | 0
	            }

	            function ISa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                AJ(a | 0) | 0
	            }

	            function JSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                BJ(a | 0) | 0
	            }

	            function KSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                CJ(a | 0) | 0
	            }

	            function LSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                DJ(a | 0) | 0
	            }

	            function MSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                EJ(a | 0) | 0
	            }

	            function NSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                FJ(a | 0) | 0
	            }

	            function OSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                GJ(a | 0) | 0
	            }

	            function PSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                HJ(a | 0) | 0
	            }

	            function QSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                IJ(a | 0) | 0
	            }

	            function RSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                JJ(a | 0) | 0
	            }

	            function SSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                KJ(a | 0) | 0
	            }

	            function TSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                LJ(a | 0) | 0
	            }

	            function USa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                MJ(a | 0) | 0
	            }

	            function VSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                NJ(a | 0) | 0
	            }

	            function WSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                OJ(a | 0) | 0
	            }

	            function XSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                PJ(a | 0) | 0
	            }

	            function YSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                QJ(a | 0) | 0
	            }

	            function ZSa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                RJ(a | 0) | 0
	            }

	            function _Sa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                SJ(a | 0) | 0
	            }

	            function $Sa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                TJ(a | 0) | 0
	            }

	            function aTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                UJ(a | 0) | 0
	            }

	            function bTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                VJ(a | 0) | 0
	            }

	            function cTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                WJ(a | 0) | 0
	            }

	            function dTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                XJ(a | 0) | 0
	            }

	            function eTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                YJ(a | 0) | 0
	            }

	            function fTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ZJ(a | 0) | 0
	            }

	            function gTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _J(a | 0) | 0
	            }

	            function hTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $J(a | 0) | 0
	            }

	            function iTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                aK(a | 0) | 0
	            }

	            function jTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bK(a | 0) | 0
	            }

	            function kTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                cK(a | 0) | 0
	            }

	            function lTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dK(a | 0) | 0
	            }

	            function mTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                eK(a | 0) | 0
	            }

	            function nTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fK(a | 0) | 0
	            }

	            function oTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gK(a | 0) | 0
	            }

	            function pTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hK(a | 0) | 0
	            }

	            function qTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                iK(a | 0) | 0
	            }

	            function rTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                jK(a | 0) | 0
	            }

	            function sTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                kK(a | 0) | 0
	            }

	            function tTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                lK(a | 0) | 0
	            }

	            function uTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                mK(a | 0) | 0
	            }

	            function vTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nK(a | 0) | 0
	            }

	            function wTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                oK(a | 0) | 0
	            }

	            function xTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                pK(a | 0) | 0
	            }

	            function yTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qK(a | 0) | 0
	            }

	            function zTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rK(a | 0) | 0
	            }

	            function ATa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                sK(a | 0) | 0
	            }

	            function BTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                tK(a | 0) | 0
	            }

	            function CTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uK(a | 0) | 0
	            }

	            function DTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vK(a | 0) | 0
	            }

	            function ETa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                wK(a | 0) | 0
	            }

	            function FTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xK(a | 0) | 0
	            }

	            function GTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                yK(a | 0) | 0
	            }

	            function HTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                zK(a | 0) | 0
	            }

	            function ITa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                AK(a | 0) | 0
	            }

	            function JTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                BK(a | 0) | 0
	            }

	            function KTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                CK(a | 0) | 0
	            }

	            function LTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                DK(a | 0) | 0
	            }

	            function MTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                EK(a | 0) | 0
	            }

	            function NTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                FK(a | 0) | 0
	            }

	            function OTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                GK(a | 0) | 0
	            }

	            function PTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                HK(a | 0) | 0
	            }

	            function QTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                IK(a | 0) | 0
	            }

	            function RTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                JK(a | 0) | 0
	            }

	            function STa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                KK(a | 0) | 0
	            }

	            function TTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                LK(a | 0) | 0
	            }

	            function UTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                MK(a | 0) | 0
	            }

	            function VTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                NK(a | 0) | 0
	            }

	            function WTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                OK(a | 0) | 0
	            }

	            function XTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                PK(a | 0) | 0
	            }

	            function YTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                QK(a | 0) | 0
	            }

	            function ZTa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                RK(a | 0) | 0
	            }

	            function _Ta(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                SK(a | 0) | 0
	            }

	            function $Ta(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                TK(a | 0) | 0
	            }

	            function aUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                UK(a | 0) | 0
	            }

	            function bUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                VK(a | 0) | 0
	            }

	            function cUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                WK(a | 0) | 0
	            }

	            function dUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                XK(a | 0) | 0
	            }

	            function eUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                YK(a | 0) | 0
	            }

	            function fUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ZK(a | 0) | 0
	            }

	            function gUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _K(a | 0) | 0
	            }

	            function hUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $K(a | 0) | 0
	            }

	            function iUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                aL(a | 0) | 0
	            }

	            function jUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bL(a | 0) | 0
	            }

	            function kUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                cL(a | 0) | 0
	            }

	            function lUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dL(a | 0) | 0
	            }

	            function mUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                eL(a | 0) | 0
	            }

	            function nUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                RT(a | 0, b | 0, c | 0) | 0
	            }

	            function oUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Vb(a | 0)
	            }

	            function pUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Wb(a | 0) | 0
	            }

	            function qUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function rUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Yb(a | 0) | 0
	            }

	            function sUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function tUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _b(a | 0)
	            }

	            function uUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $b(a | 0)
	            }

	            function vUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ac(a | 0, b | 0, c | 0) | 0
	            }

	            function wUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function xUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gc(a | 0, b | 0, c | 0) | 0
	            }

	            function yUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hc(a | 0)
	            }

	            function zUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nc(a | 0) | 0
	            }

	            function AUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                md(a | 0, b | 0)
	            }

	            function BUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nd(a | 0) | 0
	            }

	            function CUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Kd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function DUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ld(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function EUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Md(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function FUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Nd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function GUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Od(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function HUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Pd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function IUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function JUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function KUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Qd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function LUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Rd(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function MUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fo(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function NUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                tg(a | 0)
	            }

	            function OUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                mk() | 0
	            }

	            function PUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                sh(a | 0, b | 0, c | 0, 0, 0)
	            }

	            function QUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gk(a | 0, b | 0, c | 0, 0, 0)
	            }

	            function RUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nk(a | 0) | 0
	            }

	            function SUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ok(a | 0) | 0
	            }

	            function TUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                pk(a | 0, b | 0, c | 0) | 0
	            }

	            function UUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qk(a | 0) | 0
	            }

	            function VUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _k(a | 0) | 0
	            }

	            function WUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $k(a | 0, b | 0, c | 0) | 0
	            }

	            function XUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bl(a | 0) | 0
	            }

	            function YUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                cl(a | 0, b | 0, c | 0) | 0
	            }

	            function ZUa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dl(a | 0) | 0
	            }

	            function _Ua(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                el(a | 0, b | 0, c | 0) | 0
	            }

	            function $Ua(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fl(a | 0, b | 0, c | 0) | 0
	            }

	            function aVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gl(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function bVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nn(a | 0)
	            }

	            function cVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                on(a | 0) | 0
	            }

	            function dVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                sn(a | 0)
	            }

	            function eVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vn(a | 0) | 0
	            }

	            function fVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xn(a | 0)
	            }

	            function gVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                yn(a | 0) | 0
	            }

	            function hVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                zn(a | 0, b | 0)
	            }

	            function iVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                An(a | 0)
	            }

	            function jVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Bn(a | 0)
	            }

	            function kVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function lVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Dn(a | 0)
	            }

	            function mVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function nVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                tq(a | 0, b | 0)
	            }

	            function oVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Qq(a | 0)
	            }

	            function pVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Bs(a | 0, b | 0)
	            }

	            function qVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Is(a | 0, b | 0)
	            }

	            function rVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ns(a | 0, b | 0)
	            }

	            function sVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ts(a | 0, b | 0)
	            }

	            function tVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                us(a | 0, b | 0)
	            }

	            function uVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                os(a | 0, b | 0)
	            }

	            function vVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Es(a | 0, b | 0)
	            }

	            function wVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Hs(a | 0, b | 0)
	            }

	            function xVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ls(a | 0, b | 0)
	            }

	            function yVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Fs(a | 0, b | 0)
	            }

	            function zVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ps(a | 0, b | 0)
	            }

	            function AVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Cs(a | 0, b | 0)
	            }

	            function BVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nt(a | 0, b | 0)
	            }

	            function CVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qs(a | 0, b | 0)
	            }

	            function DVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                zs(a | 0, b | 0)
	            }

	            function EVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Tr(a | 0, b | 0)
	            }

	            function FVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ms(a | 0, b | 0)
	            }

	            function GVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Js(a | 0, b | 0)
	            }

	            function HVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rs(a | 0, b | 0)
	            }

	            function IVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ss(a | 0, b | 0)
	            }

	            function JVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vs(a | 0, b | 0)
	            }

	            function KVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ws(a | 0, b | 0)
	            }

	            function LVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xs(a | 0, b | 0)
	            }

	            function MVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ys(a | 0, b | 0)
	            }

	            function NVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Gs(a | 0, b | 0)
	            }

	            function OVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Ds(a | 0, b | 0)
	            }

	            function PVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                As(a | 0, b | 0)
	            }

	            function QVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ot(a | 0, b | 0)
	            }

	            function RVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uu(a | 0, b | 0, c | 0) | 0
	            }

	            function SVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function TVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function UVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function VVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vu(a | 0, b | 0, c | 0) | 0
	            }

	            function WVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function XVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function YVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function ZVa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function _Va(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function $Va(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function aWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function bWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function cWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function dWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function eWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function fWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function gWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                jv(a | 0, b | 0)
	            }

	            function hWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                pv(a | 0, b | 0)
	            }

	            function iWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qv(a | 0, b | 0)
	            }

	            function jWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rv(a | 0, b | 0)
	            }

	            function kWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                sv(a | 0, b | 0)
	            }

	            function lWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                tv(a | 0, b | 0)
	            }

	            function mWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uv(a | 0, b | 0)
	            }

	            function nWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vv(a | 0, b | 0)
	            }

	            function oWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Mw(a | 0)
	            }

	            function pWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Yw(a | 0)
	            }

	            function qWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function rWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function sWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function tWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function uWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function vWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qB(a | 0)
	            }

	            function wWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                LB(a | 0, b | 0, c | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function xWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                MB(a | 0, b | 0, c | 0, 0)
	            }

	            function yWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                PB(a | 0, b | 0)
	            }

	            function zWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                QB(a | 0, b | 0, c | 0, 0)
	            }

	            function AWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                RB(a | 0) | 0
	            }

	            function BWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                SB(a | 0) | 0
	            }

	            function CWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                TB(a | 0) | 0
	            }

	            function DWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                UB(a | 0, b | 0, c | 0) | 0
	            }

	            function EWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function FWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                WB(a | 0, b | 0, c | 0, 0, 0, 0)
	            }

	            function GWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                XB(a | 0, b | 0, c | 0, 0)
	            }

	            function HWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                YB(a | 0, b | 0, c | 0, 0, 0, 0, 0)
	            }

	            function IWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                ZB(a | 0, b | 0, c | 0, 0)
	            }

	            function JWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                _B(a | 0, b | 0, c | 0, 0, 0)
	            }

	            function KWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                $B(a | 0, b | 0)
	            }

	            function LWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                aC(a | 0)
	            }

	            function MWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                bC(a | 0)
	            }

	            function NWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                dC(a | 0, b | 0)
	            }

	            function OWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function PWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                iC(a | 0, b | 0, c | 0, 0)
	            }

	            function QWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                mC(a | 0, b | 0)
	            }

	            function RWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nC(a | 0, b | 0, c | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function SWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                oC(a | 0, b | 0, c | 0, 0)
	            }

	            function TWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rC(a | 0, b | 0, c | 0) | 0
	            }

	            function UWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uC(a | 0)
	            }

	            function VWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                AD(a | 0, b | 0)
	            }

	            function WWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                lF(a | 0, b | 0, c | 0, 0)
	            }

	            function XWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uF(a | 0, b | 0)
	            }

	            function YWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                VA(a | 0)
	            }

	            function ZWa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                xM(a | 0, b | 0)
	            }

	            function _Wa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                yM(a | 0, b | 0, c | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function $Wa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                zM(a | 0, b | 0, c | 0, 0)
	            }

	            function aXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                GM(a | 0, b | 0, c | 0) | 0
	            }

	            function bXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                FM(a | 0, b | 0)
	            }

	            function cXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                UM(a | 0)
	            }

	            function dXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function eXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                oN(a | 0, b | 0, c | 0, 0, 0) | 0
	            }

	            function fXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                pN(a | 0, b | 0, c | 0, 0, 0, 0, 0) | 0
	            }

	            function gXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                qN(a | 0, b | 0, c | 0, 0, 0, 0) | 0
	            }

	            function hXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                rN(a | 0, b | 0)
	            }

	            function iXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function jXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                uN(a | 0, b | 0, c | 0, 0, 0) | 0
	            }

	            function kXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                vN(a | 0, b | 0, c | 0, 0, 0, 0, 0) | 0
	            }

	            function lXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                wN(a | 0, b | 0)
	            }

	            function mXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                GN(a | 0, b | 0, c | 0, 0)
	            }

	            function nXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fP(a | 0, b | 0, c | 0, 0)
	            }

	            function oXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                fQ(a | 0, b | 0, c | 0, 0, 0, 0, 0, 0, 0)
	            }

	            function pXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                gQ(a | 0, b | 0, c | 0, 0)
	            }

	            function qXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                WR(a | 0, b | 0, c | 0, 0) | 0
	            }

	            function rXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function sXa(a, b, c) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                hT(a | 0, b | 0, c | 0) | 0
	            }

	            function tXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                da(10)
	            }

	            function uXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function vXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vc(a | 0) | 0
	            }

	            function wXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wc(a | 0) | 0
	            }

	            function xXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xc(a | 0) | 0
	            }

	            function yXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                yc(a | 0, b | 0, c | 0) | 0
	            }

	            function zXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function AXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Ac(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function BXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Bc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function CXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Cc(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0)
	            }

	            function DXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Dc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function EXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Ec(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function FXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Fc(a | 0, b | 0)
	            }

	            function GXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Gc(a | 0)
	            }

	            function HXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Hc(a | 0)
	            }

	            function IXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Wc(a | 0, b | 0, c | 0)
	            }

	            function JXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Xc(a | 0, b | 0)
	            }

	            function KXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Ic(a | 0, b | 0)
	            }

	            function LXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Jc(a | 0, b | 0, c | 0)
	            }

	            function MXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Kc(a | 0, b | 0, c | 0)
	            }

	            function NXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Lc(a | 0, b | 0, c | 0)
	            }

	            function OXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Mc(a | 0, b | 0)
	            }

	            function PXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Nc(a | 0, b | 0, c | 0)
	            }

	            function QXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Oc(a | 0, b | 0, c | 0)
	            }

	            function RXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Pc(a | 0, b | 0, c | 0)
	            }

	            function SXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function TXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Rc(a | 0, b | 0, c | 0)
	            }

	            function UXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Sc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function VXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function WXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function XXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jT(a | 0)
	            }

	            function YXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                iT(a | 0) | 0
	            }

	            function ZXa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function _Xa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                my(a | 0) | 0
	            }

	            function $Xa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Td(a | 0, b | 0, c | 0)
	            }

	            function aYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                SP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function bYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                PP(a | 0) | 0
	            }

	            function cYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                QP(a | 0) | 0
	            }

	            function dYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                RP(a | 0) | 0
	            }

	            function eYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                UP(a | 0, b | 0, c | 0) | 0
	            }

	            function fYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function gYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                XP(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function hYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _P(a | 0, b | 0, c | 0, d | 0)
	            }

	            function iYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                YP(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0)
	            }

	            function jYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ZP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function kYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $P(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function lYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                aQ(a | 0, b | 0)
	            }

	            function mYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bQ(a | 0)
	            }

	            function nYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cQ(a | 0)
	            }

	            function oYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dQ(a | 0, b | 0, c | 0)
	            }

	            function pYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                eQ(a | 0, b | 0)
	            }

	            function qYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hQ(a | 0, b | 0)
	            }

	            function rYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                iQ(a | 0, b | 0, c | 0)
	            }

	            function sYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                kQ(a | 0, b | 0, c | 0)
	            }

	            function tYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                lQ(a | 0, b | 0)
	            }

	            function uYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $d(a | 0, b | 0, c | 0)
	            }

	            function vYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _d(a | 0, b | 0, c | 0)
	            }

	            function wYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function xYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                mQ(a | 0, b | 0, c | 0)
	            }

	            function yYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                TP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function zYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                LP(a | 0) | 0
	            }

	            function AYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                MP(a | 0) | 0
	            }

	            function BYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                NP(a | 0) | 0
	            }

	            function CYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                OP(a | 0) | 0
	            }

	            function DYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jQ(a | 0, b | 0, c | 0)
	            }

	            function EYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                NI(a | 0) | 0
	            }

	            function FYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                OI(a | 0) | 0
	            }

	            function GYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                PI(a | 0) | 0
	            }

	            function HYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                QI(a | 0) | 0
	            }

	            function IYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                RI(a | 0) | 0
	            }

	            function JYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                SI(a | 0) | 0
	            }

	            function KYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                TI(a | 0) | 0
	            }

	            function LYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                UI(a | 0) | 0
	            }

	            function MYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                VI(a | 0) | 0
	            }

	            function NYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                WI(a | 0) | 0
	            }

	            function OYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                XI(a | 0) | 0
	            }

	            function PYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                YI(a | 0) | 0
	            }

	            function QYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ZI(a | 0) | 0
	            }

	            function RYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _I(a | 0) | 0
	            }

	            function SYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $I(a | 0) | 0
	            }

	            function TYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                aJ(a | 0) | 0
	            }

	            function UYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bJ(a | 0) | 0
	            }

	            function VYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cJ(a | 0) | 0
	            }

	            function WYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dJ(a | 0) | 0
	            }

	            function XYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                eJ(a | 0) | 0
	            }

	            function YYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fJ(a | 0) | 0
	            }

	            function ZYa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gJ(a | 0) | 0
	            }

	            function _Ya(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hJ(a | 0) | 0
	            }

	            function $Ya(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                iJ(a | 0) | 0
	            }

	            function aZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jJ(a | 0) | 0
	            }

	            function bZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                kJ(a | 0) | 0
	            }

	            function cZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                lJ(a | 0) | 0
	            }

	            function dZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                mJ(a | 0) | 0
	            }

	            function eZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nJ(a | 0) | 0
	            }

	            function fZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                oJ(a | 0) | 0
	            }

	            function gZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                pJ(a | 0) | 0
	            }

	            function hZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qJ(a | 0) | 0
	            }

	            function iZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rJ(a | 0) | 0
	            }

	            function jZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                sJ(a | 0) | 0
	            }

	            function kZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tJ(a | 0) | 0
	            }

	            function lZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uJ(a | 0) | 0
	            }

	            function mZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vJ(a | 0) | 0
	            }

	            function nZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wJ(a | 0) | 0
	            }

	            function oZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xJ(a | 0) | 0
	            }

	            function pZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                yJ(a | 0) | 0
	            }

	            function qZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                zJ(a | 0) | 0
	            }

	            function rZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                AJ(a | 0) | 0
	            }

	            function sZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                BJ(a | 0) | 0
	            }

	            function tZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                CJ(a | 0) | 0
	            }

	            function uZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                DJ(a | 0) | 0
	            }

	            function vZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                EJ(a | 0) | 0
	            }

	            function wZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                FJ(a | 0) | 0
	            }

	            function xZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                GJ(a | 0) | 0
	            }

	            function yZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                HJ(a | 0) | 0
	            }

	            function zZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                IJ(a | 0) | 0
	            }

	            function AZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                JJ(a | 0) | 0
	            }

	            function BZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                KJ(a | 0) | 0
	            }

	            function CZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                LJ(a | 0) | 0
	            }

	            function DZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                MJ(a | 0) | 0
	            }

	            function EZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                NJ(a | 0) | 0
	            }

	            function FZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                OJ(a | 0) | 0
	            }

	            function GZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                PJ(a | 0) | 0
	            }

	            function HZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                QJ(a | 0) | 0
	            }

	            function IZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                RJ(a | 0) | 0
	            }

	            function JZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                SJ(a | 0) | 0
	            }

	            function KZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                TJ(a | 0) | 0
	            }

	            function LZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                UJ(a | 0) | 0
	            }

	            function MZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                VJ(a | 0) | 0
	            }

	            function NZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                WJ(a | 0) | 0
	            }

	            function OZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                XJ(a | 0) | 0
	            }

	            function PZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                YJ(a | 0) | 0
	            }

	            function QZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ZJ(a | 0) | 0
	            }

	            function RZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _J(a | 0) | 0
	            }

	            function SZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $J(a | 0) | 0
	            }

	            function TZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                aK(a | 0) | 0
	            }

	            function UZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bK(a | 0) | 0
	            }

	            function VZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cK(a | 0) | 0
	            }

	            function WZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dK(a | 0) | 0
	            }

	            function XZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                eK(a | 0) | 0
	            }

	            function YZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fK(a | 0) | 0
	            }

	            function ZZa(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gK(a | 0) | 0
	            }

	            function _Za(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hK(a | 0) | 0
	            }

	            function $Za(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                iK(a | 0) | 0
	            }

	            function a_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jK(a | 0) | 0
	            }

	            function b_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                kK(a | 0) | 0
	            }

	            function c_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                lK(a | 0) | 0
	            }

	            function d_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                mK(a | 0) | 0
	            }

	            function e_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nK(a | 0) | 0
	            }

	            function f_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                oK(a | 0) | 0
	            }

	            function g_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                pK(a | 0) | 0
	            }

	            function h_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qK(a | 0) | 0
	            }

	            function i_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rK(a | 0) | 0
	            }

	            function j_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                sK(a | 0) | 0
	            }

	            function k_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tK(a | 0) | 0
	            }

	            function l_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uK(a | 0) | 0
	            }

	            function m_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vK(a | 0) | 0
	            }

	            function n_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wK(a | 0) | 0
	            }

	            function o_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xK(a | 0) | 0
	            }

	            function p_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                yK(a | 0) | 0
	            }

	            function q_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                zK(a | 0) | 0
	            }

	            function r_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                AK(a | 0) | 0
	            }

	            function s_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                BK(a | 0) | 0
	            }

	            function t_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                CK(a | 0) | 0
	            }

	            function u_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                DK(a | 0) | 0
	            }

	            function v_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                EK(a | 0) | 0
	            }

	            function w_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                FK(a | 0) | 0
	            }

	            function x_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                GK(a | 0) | 0
	            }

	            function y_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                HK(a | 0) | 0
	            }

	            function z_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                IK(a | 0) | 0
	            }

	            function A_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                JK(a | 0) | 0
	            }

	            function B_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                KK(a | 0) | 0
	            }

	            function C_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                LK(a | 0) | 0
	            }

	            function D_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                MK(a | 0) | 0
	            }

	            function E_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                NK(a | 0) | 0
	            }

	            function F_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                OK(a | 0) | 0
	            }

	            function G_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                PK(a | 0) | 0
	            }

	            function H_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                QK(a | 0) | 0
	            }

	            function I_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                RK(a | 0) | 0
	            }

	            function J_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                SK(a | 0) | 0
	            }

	            function K_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                TK(a | 0) | 0
	            }

	            function L_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                UK(a | 0) | 0
	            }

	            function M_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                VK(a | 0) | 0
	            }

	            function N_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                WK(a | 0) | 0
	            }

	            function O_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                XK(a | 0) | 0
	            }

	            function P_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                YK(a | 0) | 0
	            }

	            function Q_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ZK(a | 0) | 0
	            }

	            function R_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _K(a | 0) | 0
	            }

	            function S_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $K(a | 0) | 0
	            }

	            function T_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                aL(a | 0) | 0
	            }

	            function U_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bL(a | 0) | 0
	            }

	            function V_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cL(a | 0) | 0
	            }

	            function W_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dL(a | 0) | 0
	            }

	            function X_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                eL(a | 0) | 0
	            }

	            function Y_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                RT(a | 0, b | 0, c | 0) | 0
	            }

	            function Z_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Vb(a | 0)
	            }

	            function __a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Wb(a | 0) | 0
	            }

	            function $_a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function a$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Yb(a | 0) | 0
	            }

	            function b$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function c$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _b(a | 0)
	            }

	            function d$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $b(a | 0)
	            }

	            function e$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ac(a | 0, b | 0, c | 0) | 0
	            }

	            function f$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function g$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gc(a | 0, b | 0, c | 0) | 0
	            }

	            function h$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hc(a | 0)
	            }

	            function i$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ic(a | 0, b | 0, c | 0)
	            }

	            function j$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jc(a | 0, b | 0, c | 0)
	            }

	            function k$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                kc(a | 0, b | 0, c | 0)
	            }

	            function l$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                lc(a | 0, b | 0, c | 0)
	            }

	            function m$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nc(a | 0) | 0
	            }

	            function n$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                md(a | 0, b | 0)
	            }

	            function o$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nd(a | 0) | 0
	            }

	            function p$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function q$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function r$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function s$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function t$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function u$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function v$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function w$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function x$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function y$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function z$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function A$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ae(a | 0, b | 0, c | 0)
	            }

	            function B$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                be(a | 0, b | 0, c | 0)
	            }

	            function C$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tg(a | 0)
	            }

	            function D$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                mk() | 0
	            }

	            function E$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                sh(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function F$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gk(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function G$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nk(a | 0) | 0
	            }

	            function H$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ok(a | 0) | 0
	            }

	            function I$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                pk(a | 0, b | 0, c | 0) | 0
	            }

	            function J$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qk(a | 0) | 0
	            }

	            function K$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _k(a | 0) | 0
	            }

	            function L$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $k(a | 0, b | 0, c | 0) | 0
	            }

	            function M$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bl(a | 0) | 0
	            }

	            function N$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cl(a | 0, b | 0, c | 0) | 0
	            }

	            function O$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dl(a | 0) | 0
	            }

	            function P$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                el(a | 0, b | 0, c | 0) | 0
	            }

	            function Q$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fl(a | 0, b | 0, c | 0) | 0
	            }

	            function R$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function S$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nn(a | 0)
	            }

	            function T$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                on(a | 0) | 0
	            }

	            function U$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                sn(a | 0)
	            }

	            function V$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vn(a | 0) | 0
	            }

	            function W$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xn(a | 0)
	            }

	            function X$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                yn(a | 0) | 0
	            }

	            function Y$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                zn(a | 0, b | 0)
	            }

	            function Z$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                An(a | 0)
	            }

	            function _$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Bn(a | 0)
	            }

	            function $$a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function a0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Dn(a | 0)
	            }

	            function b0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                In(a | 0, b | 0, c | 0)
	            }

	            function c0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Rn(a | 0, b | 0, c | 0)
	            }

	            function d0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Sn(a | 0, b | 0, c | 0)
	            }

	            function e0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Tn(a | 0, b | 0, c | 0)
	            }

	            function f0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Un(a | 0, b | 0, c | 0)
	            }

	            function g0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function h0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tq(a | 0, b | 0)
	            }

	            function i0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Qq(a | 0)
	            }

	            function j0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Bs(a | 0, b | 0)
	            }

	            function k0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Is(a | 0, b | 0)
	            }

	            function l0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ns(a | 0, b | 0)
	            }

	            function m0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ts(a | 0, b | 0)
	            }

	            function n0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                us(a | 0, b | 0)
	            }

	            function o0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                os(a | 0, b | 0)
	            }

	            function p0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Es(a | 0, b | 0)
	            }

	            function q0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Hs(a | 0, b | 0)
	            }

	            function r0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ls(a | 0, b | 0)
	            }

	            function s0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Fs(a | 0, b | 0)
	            }

	            function t0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ps(a | 0, b | 0)
	            }

	            function u0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Cs(a | 0, b | 0)
	            }

	            function v0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nt(a | 0, b | 0)
	            }

	            function w0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qs(a | 0, b | 0)
	            }

	            function x0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                zs(a | 0, b | 0)
	            }

	            function y0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Tr(a | 0, b | 0)
	            }

	            function z0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ms(a | 0, b | 0)
	            }

	            function A0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Js(a | 0, b | 0)
	            }

	            function B0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rs(a | 0, b | 0)
	            }

	            function C0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ss(a | 0, b | 0)
	            }

	            function D0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vs(a | 0, b | 0)
	            }

	            function E0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ws(a | 0, b | 0)
	            }

	            function F0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xs(a | 0, b | 0)
	            }

	            function G0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ys(a | 0, b | 0)
	            }

	            function H0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Gs(a | 0, b | 0)
	            }

	            function I0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Ds(a | 0, b | 0)
	            }

	            function J0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                As(a | 0, b | 0)
	            }

	            function K0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ot(a | 0, b | 0)
	            }

	            function L0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uu(a | 0, b | 0, c | 0) | 0
	            }

	            function M0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function N0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function O0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function P0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vu(a | 0, b | 0, c | 0) | 0
	            }

	            function Q0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function R0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function S0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function T0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function U0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function V0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function W0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function X0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function Y0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function Z0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function _0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function $0a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function a1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jv(a | 0, b | 0)
	            }

	            function b1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                pv(a | 0, b | 0)
	            }

	            function c1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qv(a | 0, b | 0)
	            }

	            function d1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rv(a | 0, b | 0)
	            }

	            function e1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                sv(a | 0, b | 0)
	            }

	            function f1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tv(a | 0, b | 0)
	            }

	            function g1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uv(a | 0, b | 0)
	            }

	            function h1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vv(a | 0, b | 0)
	            }

	            function i1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tw(a | 0, b | 0, c | 0)
	            }

	            function j1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Mw(a | 0)
	            }

	            function k1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Yw(a | 0)
	            }

	            function l1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function m1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function n1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function o1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function p1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function q1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qB(a | 0)
	            }

	            function r1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                MB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function s1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                NB(a | 0, b | 0, c | 0)
	            }

	            function t1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                OB(a | 0, b | 0, c | 0)
	            }

	            function u1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                PB(a | 0, b | 0)
	            }

	            function v1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                QB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function w1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                RB(a | 0) | 0
	            }

	            function x1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                SB(a | 0) | 0
	            }

	            function y1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                TB(a | 0) | 0
	            }

	            function z1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                UB(a | 0, b | 0, c | 0) | 0
	            }

	            function A1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function B1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                WB(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0)
	            }

	            function C1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                XB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function D1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                YB(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0)
	            }

	            function E1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                ZB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function F1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                _B(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function G1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                $B(a | 0, b | 0)
	            }

	            function H1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                aC(a | 0)
	            }

	            function I1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                bC(a | 0)
	            }

	            function J1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                cC(a | 0, b | 0, c | 0)
	            }

	            function K1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                dC(a | 0, b | 0)
	            }

	            function L1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                eC(a | 0, b | 0, c | 0)
	            }

	            function M1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fC(a | 0, b | 0, c | 0)
	            }

	            function N1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gC(a | 0, b | 0, c | 0)
	            }

	            function O1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function P1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                iC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Q1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                jC(a | 0, b | 0, c | 0)
	            }

	            function R1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                kC(a | 0, b | 0, c | 0)
	            }

	            function S1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                lC(a | 0, b | 0, c | 0)
	            }

	            function T1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                mC(a | 0, b | 0)
	            }

	            function U1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                oC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function V1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rC(a | 0, b | 0, c | 0) | 0
	            }

	            function W1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uC(a | 0)
	            }

	            function X1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                AD(a | 0, b | 0)
	            }

	            function Y1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                lF(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Z1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uF(a | 0, b | 0)
	            }

	            function _1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                VA(a | 0)
	            }

	            function $1a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wM(a | 0, b | 0, c | 0)
	            }

	            function a2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                xM(a | 0, b | 0)
	            }

	            function b2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                zM(a | 0, b | 0, c | 0, d | 0)
	            }

	            function c2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                AM(a | 0, b | 0, c | 0)
	            }

	            function d2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                BM(a | 0, b | 0, c | 0)
	            }

	            function e2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                DM(a | 0, b | 0, c | 0)
	            }

	            function f2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                EM(a | 0, b | 0, c | 0)
	            }

	            function g2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                GM(a | 0, b | 0, c | 0) | 0
	            }

	            function h2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                FM(a | 0, b | 0)
	            }

	            function i2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                UM(a | 0)
	            }

	            function j2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function k2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                oN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function l2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                pN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0
	            }

	            function m2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                qN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0) | 0
	            }

	            function n2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                rN(a | 0, b | 0)
	            }

	            function o2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function p2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                uN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function q2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0
	            }

	            function r2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wN(a | 0, b | 0)
	            }

	            function s2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                CN(a | 0, b | 0, c | 0)
	            }

	            function t2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                GN(a | 0, b | 0, c | 0, d | 0)
	            }

	            function u2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                vO(a | 0, b | 0, c | 0)
	            }

	            function v2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                wO(a | 0, b | 0, c | 0)
	            }

	            function w2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                fP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function x2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                sP(a | 0, b | 0, c | 0)
	            }

	            function y2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                gQ(a | 0, b | 0, c | 0, d | 0)
	            }

	            function z2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function A2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function B2a(a, b, c, d, e, f, g, h, i) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                g = g | 0;
	                h = h | 0;
	                i = i | 0;
	                hT(a | 0, b | 0, c | 0) | 0
	            }

	            function C2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                da(11);
	                return 0
	            }

	            function D2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function E2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vc(a | 0) | 0
	            }

	            function F2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return wc(a | 0) | 0
	            }

	            function G2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return xc(a | 0) | 0
	            }

	            function H2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return yc(a | 0, b | 0, c | 0) | 0
	            }

	            function I2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return zc(a | 0, b | 0) | 0
	            }

	            function J2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function K2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function L2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function M2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function N2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function O2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function P2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Q2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function R2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function S2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function T2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function U2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function V2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function W2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function X2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Y2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Z2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function _2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function $2a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Qc(a | 0, b | 0) | 0
	            }

	            function a3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function b3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function c3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function d3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function e3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function f3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function g3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return iT(a | 0) | 0
	            }

	            function h3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return kT(a | 0, b | 0) | 0
	            }

	            function i3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return my(a | 0) | 0
	            }

	            function j3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function k3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function l3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return PP(a | 0) | 0
	            }

	            function m3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return QP(a | 0) | 0
	            }

	            function n3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return RP(a | 0) | 0
	            }

	            function o3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return UP(a | 0, b | 0, c | 0) | 0
	            }

	            function p3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return VP(a | 0, b | 0) | 0
	            }

	            function q3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function r3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function s3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function t3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function u3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function v3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function w3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function x3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function y3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function z3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function A3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function B3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function C3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function D3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function E3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function F3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function G3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return WP(a | 0, b | 0) | 0
	            }

	            function H3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function I3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function J3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return LP(a | 0) | 0
	            }

	            function K3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return MP(a | 0) | 0
	            }

	            function L3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return NP(a | 0) | 0
	            }

	            function M3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return OP(a | 0) | 0
	            }

	            function N3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function O3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return NI(a | 0) | 0
	            }

	            function P3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return OI(a | 0) | 0
	            }

	            function Q3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return PI(a | 0) | 0
	            }

	            function R3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return QI(a | 0) | 0
	            }

	            function S3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return RI(a | 0) | 0
	            }

	            function T3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return SI(a | 0) | 0
	            }

	            function U3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return TI(a | 0) | 0
	            }

	            function V3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return UI(a | 0) | 0
	            }

	            function W3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return VI(a | 0) | 0
	            }

	            function X3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return WI(a | 0) | 0
	            }

	            function Y3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return XI(a | 0) | 0
	            }

	            function Z3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return YI(a | 0) | 0
	            }

	            function _3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return ZI(a | 0) | 0
	            }

	            function $3a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return _I(a | 0) | 0
	            }

	            function a4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return $I(a | 0) | 0
	            }

	            function b4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return aJ(a | 0) | 0
	            }

	            function c4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return bJ(a | 0) | 0
	            }

	            function d4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return cJ(a | 0) | 0
	            }

	            function e4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return dJ(a | 0) | 0
	            }

	            function f4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return eJ(a | 0) | 0
	            }

	            function g4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return fJ(a | 0) | 0
	            }

	            function h4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return gJ(a | 0) | 0
	            }

	            function i4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return hJ(a | 0) | 0
	            }

	            function j4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return iJ(a | 0) | 0
	            }

	            function k4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return jJ(a | 0) | 0
	            }

	            function l4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return kJ(a | 0) | 0
	            }

	            function m4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return lJ(a | 0) | 0
	            }

	            function n4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return mJ(a | 0) | 0
	            }

	            function o4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return nJ(a | 0) | 0
	            }

	            function p4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return oJ(a | 0) | 0
	            }

	            function q4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return pJ(a | 0) | 0
	            }

	            function r4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return qJ(a | 0) | 0
	            }

	            function s4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return rJ(a | 0) | 0
	            }

	            function t4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return sJ(a | 0) | 0
	            }

	            function u4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return tJ(a | 0) | 0
	            }

	            function v4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return uJ(a | 0) | 0
	            }

	            function w4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vJ(a | 0) | 0
	            }

	            function x4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return wJ(a | 0) | 0
	            }

	            function y4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return xJ(a | 0) | 0
	            }

	            function z4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return yJ(a | 0) | 0
	            }

	            function A4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return zJ(a | 0) | 0
	            }

	            function B4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return AJ(a | 0) | 0
	            }

	            function C4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return BJ(a | 0) | 0
	            }

	            function D4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return CJ(a | 0) | 0
	            }

	            function E4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return DJ(a | 0) | 0
	            }

	            function F4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return EJ(a | 0) | 0
	            }

	            function G4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return FJ(a | 0) | 0
	            }

	            function H4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return GJ(a | 0) | 0
	            }

	            function I4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return HJ(a | 0) | 0
	            }

	            function J4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return IJ(a | 0) | 0
	            }

	            function K4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return JJ(a | 0) | 0
	            }

	            function L4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return KJ(a | 0) | 0
	            }

	            function M4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return LJ(a | 0) | 0
	            }

	            function N4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return MJ(a | 0) | 0
	            }

	            function O4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return NJ(a | 0) | 0
	            }

	            function P4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return OJ(a | 0) | 0
	            }

	            function Q4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return PJ(a | 0) | 0
	            }

	            function R4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return QJ(a | 0) | 0
	            }

	            function S4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return RJ(a | 0) | 0
	            }

	            function T4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return SJ(a | 0) | 0
	            }

	            function U4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return TJ(a | 0) | 0
	            }

	            function V4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return UJ(a | 0) | 0
	            }

	            function W4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return VJ(a | 0) | 0
	            }

	            function X4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return WJ(a | 0) | 0
	            }

	            function Y4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return XJ(a | 0) | 0
	            }

	            function Z4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return YJ(a | 0) | 0
	            }

	            function _4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return ZJ(a | 0) | 0
	            }

	            function $4a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return _J(a | 0) | 0
	            }

	            function a5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return $J(a | 0) | 0
	            }

	            function b5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return aK(a | 0) | 0
	            }

	            function c5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return bK(a | 0) | 0
	            }

	            function d5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return cK(a | 0) | 0
	            }

	            function e5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return dK(a | 0) | 0
	            }

	            function f5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return eK(a | 0) | 0
	            }

	            function g5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return fK(a | 0) | 0
	            }

	            function h5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return gK(a | 0) | 0
	            }

	            function i5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return hK(a | 0) | 0
	            }

	            function j5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return iK(a | 0) | 0
	            }

	            function k5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return jK(a | 0) | 0
	            }

	            function l5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return kK(a | 0) | 0
	            }

	            function m5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return lK(a | 0) | 0
	            }

	            function n5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return mK(a | 0) | 0
	            }

	            function o5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return nK(a | 0) | 0
	            }

	            function p5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return oK(a | 0) | 0
	            }

	            function q5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return pK(a | 0) | 0
	            }

	            function r5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return qK(a | 0) | 0
	            }

	            function s5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return rK(a | 0) | 0
	            }

	            function t5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return sK(a | 0) | 0
	            }

	            function u5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return tK(a | 0) | 0
	            }

	            function v5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return uK(a | 0) | 0
	            }

	            function w5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vK(a | 0) | 0
	            }

	            function x5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return wK(a | 0) | 0
	            }

	            function y5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return xK(a | 0) | 0
	            }

	            function z5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return yK(a | 0) | 0
	            }

	            function A5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return zK(a | 0) | 0
	            }

	            function B5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return AK(a | 0) | 0
	            }

	            function C5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return BK(a | 0) | 0
	            }

	            function D5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return CK(a | 0) | 0
	            }

	            function E5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return DK(a | 0) | 0
	            }

	            function F5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return EK(a | 0) | 0
	            }

	            function G5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return FK(a | 0) | 0
	            }

	            function H5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return GK(a | 0) | 0
	            }

	            function I5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return HK(a | 0) | 0
	            }

	            function J5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return IK(a | 0) | 0
	            }

	            function K5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return JK(a | 0) | 0
	            }

	            function L5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return KK(a | 0) | 0
	            }

	            function M5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return LK(a | 0) | 0
	            }

	            function N5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return MK(a | 0) | 0
	            }

	            function O5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return NK(a | 0) | 0
	            }

	            function P5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return OK(a | 0) | 0
	            }

	            function Q5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return PK(a | 0) | 0
	            }

	            function R5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return QK(a | 0) | 0
	            }

	            function S5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return RK(a | 0) | 0
	            }

	            function T5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return SK(a | 0) | 0
	            }

	            function U5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return TK(a | 0) | 0
	            }

	            function V5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return UK(a | 0) | 0
	            }

	            function W5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return VK(a | 0) | 0
	            }

	            function X5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return WK(a | 0) | 0
	            }

	            function Y5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return XK(a | 0) | 0
	            }

	            function Z5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return YK(a | 0) | 0
	            }

	            function _5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return ZK(a | 0) | 0
	            }

	            function $5a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return _K(a | 0) | 0
	            }

	            function a6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return $K(a | 0) | 0
	            }

	            function b6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return aL(a | 0) | 0
	            }

	            function c6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return bL(a | 0) | 0
	            }

	            function d6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return cL(a | 0) | 0
	            }

	            function e6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return dL(a | 0) | 0
	            }

	            function f6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return eL(a | 0) | 0
	            }

	            function g6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return RT(a | 0, b | 0, c | 0) | 0
	            }

	            function h6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function i6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Wb(a | 0) | 0
	            }

	            function j6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Xb(a | 0, b | 0) | 0
	            }

	            function k6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Yb(a | 0) | 0
	            }

	            function l6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function m6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function n6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function o6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return ac(a | 0, b | 0, c | 0) | 0
	            }

	            function p6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function q6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return gc(a | 0, b | 0, c | 0) | 0
	            }

	            function r6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function s6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function t6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function u6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function v6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function w6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return nc(a | 0) | 0
	            }

	            function x6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function y6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return nd(a | 0) | 0
	            }

	            function z6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function A6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function B6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function C6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return mk() | 0
	            }

	            function D6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function E6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function F6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return nk(a | 0) | 0
	            }

	            function G6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return ok(a | 0) | 0
	            }

	            function H6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return pk(a | 0, b | 0, c | 0) | 0
	            }

	            function I6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return qk(a | 0) | 0
	            }

	            function J6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return _k(a | 0) | 0
	            }

	            function K6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return $k(a | 0, b | 0, c | 0) | 0
	            }

	            function L6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return bl(a | 0) | 0
	            }

	            function M6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return cl(a | 0, b | 0, c | 0) | 0
	            }

	            function N6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return dl(a | 0) | 0
	            }

	            function O6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return el(a | 0, b | 0, c | 0) | 0
	            }

	            function P6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return fl(a | 0, b | 0, c | 0) | 0
	            }

	            function Q6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function R6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return on(a | 0) | 0
	            }

	            function S6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function T6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vn(a | 0) | 0
	            }

	            function U6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function V6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return yn(a | 0) | 0
	            }

	            function W6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function X6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Y6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Z6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Cn(a | 0, b | 0) | 0
	            }

	            function _6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function $6a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function a7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function b7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function c7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function d7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function e7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return _n(a | 0, b | 0) | 0
	            }

	            function f7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function g7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function h7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function i7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function j7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function k7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function l7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function m7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function n7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function o7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function p7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function q7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function r7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function s7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function t7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function u7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function v7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function w7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function x7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function y7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function z7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function A7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function B7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function C7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function D7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function E7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function F7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function G7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function H7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function I7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function J7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return uu(a | 0, b | 0, c | 0) | 0
	            }

	            function K7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return ds(a | 0, b | 0) | 0
	            }

	            function L7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return es(a | 0, b | 0) | 0
	            }

	            function M7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return js(a | 0, b | 0) | 0
	            }

	            function N7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vu(a | 0, b | 0, c | 0) | 0
	            }

	            function O7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return wu(a | 0, b | 0) | 0
	            }

	            function P7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return $r(a | 0, b | 0) | 0
	            }

	            function Q7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return as(a | 0, b | 0) | 0
	            }

	            function R7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return bs(a | 0, b | 0) | 0
	            }

	            function S7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return hs(a | 0, b | 0) | 0
	            }

	            function T7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return fs(a | 0, b | 0) | 0
	            }

	            function U7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return is(a | 0, b | 0) | 0
	            }

	            function V7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return cs(a | 0, b | 0) | 0
	            }

	            function W7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return xu(a | 0, b | 0) | 0
	            }

	            function X7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return gs(a | 0, b | 0) | 0
	            }

	            function Y7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return _r(a | 0, b | 0) | 0
	            }

	            function Z7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return dr(a | 0, b | 0) | 0
	            }

	            function _7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function $7a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function a8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function b8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function c8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function d8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function e8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function f8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function g8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function h8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function i8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function j8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function k8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return $x(a | 0, b | 0) | 0
	            }

	            function l8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return dy(a | 0, b | 0) | 0
	            }

	            function m8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return fy(a | 0, b | 0) | 0
	            }

	            function n8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return jy(a | 0, b | 0) | 0
	            }

	            function o8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function p8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function q8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function r8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function s8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function t8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function u8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function v8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return RB(a | 0) | 0
	            }

	            function w8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return SB(a | 0) | 0
	            }

	            function x8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return TB(a | 0) | 0
	            }

	            function y8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return UB(a | 0, b | 0, c | 0) | 0
	            }

	            function z8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return VB(a | 0, b | 0) | 0
	            }

	            function A8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function B8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function C8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function D8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function E8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function F8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function G8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function H8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function I8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function J8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function K8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function L8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function M8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function N8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return hC(a | 0, b | 0) | 0
	            }

	            function O8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function P8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Q8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function R8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function S8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function T8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function U8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function V8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return rC(a | 0, b | 0, c | 0) | 0
	            }

	            function W8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function X8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Y8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function Z8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function _8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function $8a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function a9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function b9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function c9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function d9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function e9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function f9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function g9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function h9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return GM(a | 0, b | 0, c | 0) | 0
	            }

	            function i9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function j9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function k9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return nN(a | 0, b | 0) | 0
	            }

	            function l9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return oN(a | 0, b | 0, c | 0, d | 0, 0) | 0
	            }

	            function m9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return pN(a | 0, b | 0, c | 0, d | 0, 0, 0, 0) | 0
	            }

	            function n9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return qN(a | 0, b | 0, c | 0, d | 0, 0, 0) | 0
	            }

	            function o9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function p9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return tN(a | 0, b | 0) | 0
	            }

	            function q9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return uN(a | 0, b | 0, c | 0, d | 0, 0) | 0
	            }

	            function r9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return vN(a | 0, b | 0, c | 0, d | 0, 0, 0, 0) | 0
	            }

	            function s9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function t9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function u9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function v9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function w9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function x9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function y9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function z9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function A9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return 0
	            }

	            function B9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return QS(a | 0, b | 0) | 0
	            }

	            function C9a(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                return hT(a | 0, b | 0, c | 0) | 0
	            }

	            function D9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                da(12)
	            }

	            function E9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function F9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vc(a | 0) | 0
	            }

	            function G9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wc(a | 0) | 0
	            }

	            function H9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xc(a | 0) | 0
	            }

	            function I9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                yc(a | 0, b | 0, c | 0) | 0
	            }

	            function J9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function K9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Bc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function L9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Cc(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0)
	            }

	            function M9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Dc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function N9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Ec(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function O9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Fc(a | 0, b | 0)
	            }

	            function P9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Gc(a | 0)
	            }

	            function Q9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Hc(a | 0)
	            }

	            function R9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Wc(a | 0, b | 0, c | 0)
	            }

	            function S9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Xc(a | 0, b | 0)
	            }

	            function T9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Ic(a | 0, b | 0)
	            }

	            function U9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Jc(a | 0, b | 0, c | 0)
	            }

	            function V9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Kc(a | 0, b | 0, c | 0)
	            }

	            function W9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Lc(a | 0, b | 0, c | 0)
	            }

	            function X9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Mc(a | 0, b | 0)
	            }

	            function Y9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Nc(a | 0, b | 0, c | 0)
	            }

	            function Z9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Oc(a | 0, b | 0, c | 0)
	            }

	            function _9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Pc(a | 0, b | 0, c | 0)
	            }

	            function $9a(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function aab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Rc(a | 0, b | 0, c | 0)
	            }

	            function bab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Sc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function cab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Tc(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0, 0, 0)
	            }

	            function dab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Uc(a | 0, b | 0, c | 0, d | 0)
	            }

	            function eab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function fab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jT(a | 0)
	            }

	            function gab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                iT(a | 0) | 0
	            }

	            function hab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function iab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                my(a | 0) | 0
	            }

	            function jab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Td(a | 0, b | 0, c | 0)
	            }

	            function kab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                SP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function lab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                PP(a | 0) | 0
	            }

	            function mab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                QP(a | 0) | 0
	            }

	            function nab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                RP(a | 0) | 0
	            }

	            function oab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                UP(a | 0, b | 0, c | 0) | 0
	            }

	            function pab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function qab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _P(a | 0, b | 0, c | 0, d | 0)
	            }

	            function rab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                YP(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0)
	            }

	            function sab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ZP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function tab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $P(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function uab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                aQ(a | 0, b | 0)
	            }

	            function vab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bQ(a | 0)
	            }

	            function wab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cQ(a | 0)
	            }

	            function xab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dQ(a | 0, b | 0, c | 0)
	            }

	            function yab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                eQ(a | 0, b | 0)
	            }

	            function zab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hQ(a | 0, b | 0)
	            }

	            function Aab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                iQ(a | 0, b | 0, c | 0)
	            }

	            function Bab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                kQ(a | 0, b | 0, c | 0)
	            }

	            function Cab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                lQ(a | 0, b | 0)
	            }

	            function Dab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $d(a | 0, b | 0, c | 0)
	            }

	            function Eab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _d(a | 0, b | 0, c | 0)
	            }

	            function Fab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function Gab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                mQ(a | 0, b | 0, c | 0)
	            }

	            function Hab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                TP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Iab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                LP(a | 0) | 0
	            }

	            function Jab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                MP(a | 0) | 0
	            }

	            function Kab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                NP(a | 0) | 0
	            }

	            function Lab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                OP(a | 0) | 0
	            }

	            function Mab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jQ(a | 0, b | 0, c | 0)
	            }

	            function Nab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                NI(a | 0) | 0
	            }

	            function Oab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                OI(a | 0) | 0
	            }

	            function Pab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                PI(a | 0) | 0
	            }

	            function Qab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                QI(a | 0) | 0
	            }

	            function Rab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                RI(a | 0) | 0
	            }

	            function Sab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                SI(a | 0) | 0
	            }

	            function Tab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                TI(a | 0) | 0
	            }

	            function Uab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                UI(a | 0) | 0
	            }

	            function Vab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                VI(a | 0) | 0
	            }

	            function Wab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                WI(a | 0) | 0
	            }

	            function Xab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                XI(a | 0) | 0
	            }

	            function Yab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                YI(a | 0) | 0
	            }

	            function Zab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ZI(a | 0) | 0
	            }

	            function _ab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _I(a | 0) | 0
	            }

	            function $ab(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $I(a | 0) | 0
	            }

	            function abb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                aJ(a | 0) | 0
	            }

	            function bbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bJ(a | 0) | 0
	            }

	            function cbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cJ(a | 0) | 0
	            }

	            function dbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dJ(a | 0) | 0
	            }

	            function ebb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                eJ(a | 0) | 0
	            }

	            function fbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fJ(a | 0) | 0
	            }

	            function gbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gJ(a | 0) | 0
	            }

	            function hbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hJ(a | 0) | 0
	            }

	            function ibb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                iJ(a | 0) | 0
	            }

	            function jbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jJ(a | 0) | 0
	            }

	            function kbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                kJ(a | 0) | 0
	            }

	            function lbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                lJ(a | 0) | 0
	            }

	            function mbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                mJ(a | 0) | 0
	            }

	            function nbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nJ(a | 0) | 0
	            }

	            function obb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                oJ(a | 0) | 0
	            }

	            function pbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                pJ(a | 0) | 0
	            }

	            function qbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qJ(a | 0) | 0
	            }

	            function rbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rJ(a | 0) | 0
	            }

	            function sbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                sJ(a | 0) | 0
	            }

	            function tbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tJ(a | 0) | 0
	            }

	            function ubb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uJ(a | 0) | 0
	            }

	            function vbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vJ(a | 0) | 0
	            }

	            function wbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wJ(a | 0) | 0
	            }

	            function xbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xJ(a | 0) | 0
	            }

	            function ybb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                yJ(a | 0) | 0
	            }

	            function zbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                zJ(a | 0) | 0
	            }

	            function Abb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                AJ(a | 0) | 0
	            }

	            function Bbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                BJ(a | 0) | 0
	            }

	            function Cbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                CJ(a | 0) | 0
	            }

	            function Dbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                DJ(a | 0) | 0
	            }

	            function Ebb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                EJ(a | 0) | 0
	            }

	            function Fbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                FJ(a | 0) | 0
	            }

	            function Gbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                GJ(a | 0) | 0
	            }

	            function Hbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                HJ(a | 0) | 0
	            }

	            function Ibb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                IJ(a | 0) | 0
	            }

	            function Jbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                JJ(a | 0) | 0
	            }

	            function Kbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                KJ(a | 0) | 0
	            }

	            function Lbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                LJ(a | 0) | 0
	            }

	            function Mbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                MJ(a | 0) | 0
	            }

	            function Nbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                NJ(a | 0) | 0
	            }

	            function Obb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                OJ(a | 0) | 0
	            }

	            function Pbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                PJ(a | 0) | 0
	            }

	            function Qbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                QJ(a | 0) | 0
	            }

	            function Rbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                RJ(a | 0) | 0
	            }

	            function Sbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                SJ(a | 0) | 0
	            }

	            function Tbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                TJ(a | 0) | 0
	            }

	            function Ubb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                UJ(a | 0) | 0
	            }

	            function Vbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                VJ(a | 0) | 0
	            }

	            function Wbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                WJ(a | 0) | 0
	            }

	            function Xbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                XJ(a | 0) | 0
	            }

	            function Ybb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                YJ(a | 0) | 0
	            }

	            function Zbb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ZJ(a | 0) | 0
	            }

	            function _bb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _J(a | 0) | 0
	            }

	            function $bb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $J(a | 0) | 0
	            }

	            function acb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                aK(a | 0) | 0
	            }

	            function bcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bK(a | 0) | 0
	            }

	            function ccb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cK(a | 0) | 0
	            }

	            function dcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dK(a | 0) | 0
	            }

	            function ecb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                eK(a | 0) | 0
	            }

	            function fcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fK(a | 0) | 0
	            }

	            function gcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gK(a | 0) | 0
	            }

	            function hcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hK(a | 0) | 0
	            }

	            function icb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                iK(a | 0) | 0
	            }

	            function jcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jK(a | 0) | 0
	            }

	            function kcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                kK(a | 0) | 0
	            }

	            function lcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                lK(a | 0) | 0
	            }

	            function mcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                mK(a | 0) | 0
	            }

	            function ncb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nK(a | 0) | 0
	            }

	            function ocb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                oK(a | 0) | 0
	            }

	            function pcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                pK(a | 0) | 0
	            }

	            function qcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qK(a | 0) | 0
	            }

	            function rcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rK(a | 0) | 0
	            }

	            function scb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                sK(a | 0) | 0
	            }

	            function tcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tK(a | 0) | 0
	            }

	            function ucb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uK(a | 0) | 0
	            }

	            function vcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vK(a | 0) | 0
	            }

	            function wcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wK(a | 0) | 0
	            }

	            function xcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xK(a | 0) | 0
	            }

	            function ycb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                yK(a | 0) | 0
	            }

	            function zcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                zK(a | 0) | 0
	            }

	            function Acb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                AK(a | 0) | 0
	            }

	            function Bcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                BK(a | 0) | 0
	            }

	            function Ccb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                CK(a | 0) | 0
	            }

	            function Dcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                DK(a | 0) | 0
	            }

	            function Ecb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                EK(a | 0) | 0
	            }

	            function Fcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                FK(a | 0) | 0
	            }

	            function Gcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                GK(a | 0) | 0
	            }

	            function Hcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                HK(a | 0) | 0
	            }

	            function Icb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                IK(a | 0) | 0
	            }

	            function Jcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                JK(a | 0) | 0
	            }

	            function Kcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                KK(a | 0) | 0
	            }

	            function Lcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                LK(a | 0) | 0
	            }

	            function Mcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                MK(a | 0) | 0
	            }

	            function Ncb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                NK(a | 0) | 0
	            }

	            function Ocb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                OK(a | 0) | 0
	            }

	            function Pcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                PK(a | 0) | 0
	            }

	            function Qcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                QK(a | 0) | 0
	            }

	            function Rcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                RK(a | 0) | 0
	            }

	            function Scb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                SK(a | 0) | 0
	            }

	            function Tcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                TK(a | 0) | 0
	            }

	            function Ucb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                UK(a | 0) | 0
	            }

	            function Vcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                VK(a | 0) | 0
	            }

	            function Wcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                WK(a | 0) | 0
	            }

	            function Xcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                XK(a | 0) | 0
	            }

	            function Ycb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                YK(a | 0) | 0
	            }

	            function Zcb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ZK(a | 0) | 0
	            }

	            function _cb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _K(a | 0) | 0
	            }

	            function $cb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $K(a | 0) | 0
	            }

	            function adb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                aL(a | 0) | 0
	            }

	            function bdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bL(a | 0) | 0
	            }

	            function cdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cL(a | 0) | 0
	            }

	            function ddb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dL(a | 0) | 0
	            }

	            function edb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                eL(a | 0) | 0
	            }

	            function fdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                RT(a | 0, b | 0, c | 0) | 0
	            }

	            function gdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Vb(a | 0)
	            }

	            function hdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Wb(a | 0) | 0
	            }

	            function idb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function jdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Yb(a | 0) | 0
	            }

	            function kdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function ldb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _b(a | 0)
	            }

	            function mdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $b(a | 0)
	            }

	            function ndb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ac(a | 0, b | 0, c | 0) | 0
	            }

	            function odb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function pdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gc(a | 0, b | 0, c | 0) | 0
	            }

	            function qdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hc(a | 0)
	            }

	            function rdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ic(a | 0, b | 0, c | 0)
	            }

	            function sdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jc(a | 0, b | 0, c | 0)
	            }

	            function tdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                kc(a | 0, b | 0, c | 0)
	            }

	            function udb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                lc(a | 0, b | 0, c | 0)
	            }

	            function vdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nc(a | 0) | 0
	            }

	            function wdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                md(a | 0, b | 0)
	            }

	            function xdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nd(a | 0) | 0
	            }

	            function ydb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function zdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Adb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Bdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Cdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Ddb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Edb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Fdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Gdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Hdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Idb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Jdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ae(a | 0, b | 0, c | 0)
	            }

	            function Kdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                be(a | 0, b | 0, c | 0)
	            }

	            function Ldb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tg(a | 0)
	            }

	            function Mdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                mk() | 0
	            }

	            function Ndb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                sh(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Odb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gk(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Pdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nk(a | 0) | 0
	            }

	            function Qdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ok(a | 0) | 0
	            }

	            function Rdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                pk(a | 0, b | 0, c | 0) | 0
	            }

	            function Sdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qk(a | 0) | 0
	            }

	            function Tdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _k(a | 0) | 0
	            }

	            function Udb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $k(a | 0, b | 0, c | 0) | 0
	            }

	            function Vdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bl(a | 0) | 0
	            }

	            function Wdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cl(a | 0, b | 0, c | 0) | 0
	            }

	            function Xdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dl(a | 0) | 0
	            }

	            function Ydb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                el(a | 0, b | 0, c | 0) | 0
	            }

	            function Zdb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fl(a | 0, b | 0, c | 0) | 0
	            }

	            function _db(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function $db(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nn(a | 0)
	            }

	            function aeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                on(a | 0) | 0
	            }

	            function beb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                sn(a | 0)
	            }

	            function ceb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vn(a | 0) | 0
	            }

	            function deb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xn(a | 0)
	            }

	            function eeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                yn(a | 0) | 0
	            }

	            function feb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                zn(a | 0, b | 0)
	            }

	            function geb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                An(a | 0)
	            }

	            function heb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Bn(a | 0)
	            }

	            function ieb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function jeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Dn(a | 0)
	            }

	            function keb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                In(a | 0, b | 0, c | 0)
	            }

	            function leb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Rn(a | 0, b | 0, c | 0)
	            }

	            function meb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Sn(a | 0, b | 0, c | 0)
	            }

	            function neb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Tn(a | 0, b | 0, c | 0)
	            }

	            function oeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Un(a | 0, b | 0, c | 0)
	            }

	            function peb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function qeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tq(a | 0, b | 0)
	            }

	            function reb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Qq(a | 0)
	            }

	            function seb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Bs(a | 0, b | 0)
	            }

	            function teb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Is(a | 0, b | 0)
	            }

	            function ueb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ns(a | 0, b | 0)
	            }

	            function veb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ts(a | 0, b | 0)
	            }

	            function web(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                us(a | 0, b | 0)
	            }

	            function xeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                os(a | 0, b | 0)
	            }

	            function yeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Es(a | 0, b | 0)
	            }

	            function zeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Hs(a | 0, b | 0)
	            }

	            function Aeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ls(a | 0, b | 0)
	            }

	            function Beb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Fs(a | 0, b | 0)
	            }

	            function Ceb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ps(a | 0, b | 0)
	            }

	            function Deb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Cs(a | 0, b | 0)
	            }

	            function Eeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nt(a | 0, b | 0)
	            }

	            function Feb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qs(a | 0, b | 0)
	            }

	            function Geb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                zs(a | 0, b | 0)
	            }

	            function Heb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Tr(a | 0, b | 0)
	            }

	            function Ieb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ms(a | 0, b | 0)
	            }

	            function Jeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Js(a | 0, b | 0)
	            }

	            function Keb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rs(a | 0, b | 0)
	            }

	            function Leb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ss(a | 0, b | 0)
	            }

	            function Meb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vs(a | 0, b | 0)
	            }

	            function Neb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ws(a | 0, b | 0)
	            }

	            function Oeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xs(a | 0, b | 0)
	            }

	            function Peb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ys(a | 0, b | 0)
	            }

	            function Qeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Gs(a | 0, b | 0)
	            }

	            function Reb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Ds(a | 0, b | 0)
	            }

	            function Seb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                As(a | 0, b | 0)
	            }

	            function Teb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ot(a | 0, b | 0)
	            }

	            function Ueb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uu(a | 0, b | 0, c | 0) | 0
	            }

	            function Veb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function Web(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function Xeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function Yeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vu(a | 0, b | 0, c | 0) | 0
	            }

	            function Zeb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function _eb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function $eb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function afb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function bfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function cfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function dfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function efb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function ffb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function gfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function hfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function ifb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function jfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jv(a | 0, b | 0)
	            }

	            function kfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                pv(a | 0, b | 0)
	            }

	            function lfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qv(a | 0, b | 0)
	            }

	            function mfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rv(a | 0, b | 0)
	            }

	            function nfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                sv(a | 0, b | 0)
	            }

	            function ofb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tv(a | 0, b | 0)
	            }

	            function pfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uv(a | 0, b | 0)
	            }

	            function qfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vv(a | 0, b | 0)
	            }

	            function rfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tw(a | 0, b | 0, c | 0)
	            }

	            function sfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Mw(a | 0)
	            }

	            function tfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Yw(a | 0)
	            }

	            function ufb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function vfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function wfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function xfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function yfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function zfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qB(a | 0)
	            }

	            function Afb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                LB(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0, 0, 0)
	            }

	            function Bfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                MB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Cfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                NB(a | 0, b | 0, c | 0)
	            }

	            function Dfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                OB(a | 0, b | 0, c | 0)
	            }

	            function Efb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                PB(a | 0, b | 0)
	            }

	            function Ffb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                QB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Gfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                RB(a | 0) | 0
	            }

	            function Hfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                SB(a | 0) | 0
	            }

	            function Ifb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                TB(a | 0) | 0
	            }

	            function Jfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                UB(a | 0, b | 0, c | 0) | 0
	            }

	            function Kfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function Lfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                XB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Mfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                YB(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0)
	            }

	            function Nfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                ZB(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Ofb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                _B(a | 0, b | 0, c | 0, d | 0, e | 0)
	            }

	            function Pfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                $B(a | 0, b | 0)
	            }

	            function Qfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                aC(a | 0)
	            }

	            function Rfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                bC(a | 0)
	            }

	            function Sfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                cC(a | 0, b | 0, c | 0)
	            }

	            function Tfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                dC(a | 0, b | 0)
	            }

	            function Ufb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                eC(a | 0, b | 0, c | 0)
	            }

	            function Vfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fC(a | 0, b | 0, c | 0)
	            }

	            function Wfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gC(a | 0, b | 0, c | 0)
	            }

	            function Xfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function Yfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                iC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Zfb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                jC(a | 0, b | 0, c | 0)
	            }

	            function _fb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                kC(a | 0, b | 0, c | 0)
	            }

	            function $fb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                lC(a | 0, b | 0, c | 0)
	            }

	            function agb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                mC(a | 0, b | 0)
	            }

	            function bgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nC(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0, 0, 0)
	            }

	            function cgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                oC(a | 0, b | 0, c | 0, d | 0)
	            }

	            function dgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rC(a | 0, b | 0, c | 0) | 0
	            }

	            function egb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uC(a | 0)
	            }

	            function fgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                AD(a | 0, b | 0)
	            }

	            function ggb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                lF(a | 0, b | 0, c | 0, d | 0)
	            }

	            function hgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uF(a | 0, b | 0)
	            }

	            function igb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                VA(a | 0)
	            }

	            function jgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wM(a | 0, b | 0, c | 0)
	            }

	            function kgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                xM(a | 0, b | 0)
	            }

	            function lgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                yM(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0, 0, 0)
	            }

	            function mgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                zM(a | 0, b | 0, c | 0, d | 0)
	            }

	            function ngb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                AM(a | 0, b | 0, c | 0)
	            }

	            function ogb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                BM(a | 0, b | 0, c | 0)
	            }

	            function pgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                DM(a | 0, b | 0, c | 0)
	            }

	            function qgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                EM(a | 0, b | 0, c | 0)
	            }

	            function rgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                GM(a | 0, b | 0, c | 0) | 0
	            }

	            function sgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                FM(a | 0, b | 0)
	            }

	            function tgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                UM(a | 0)
	            }

	            function ugb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function vgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                oN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function wgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                pN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0) | 0
	            }

	            function xgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                qN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0) | 0
	            }

	            function ygb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                rN(a | 0, b | 0)
	            }

	            function zgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function Agb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                uN(a | 0, b | 0, c | 0, d | 0, e | 0) | 0
	            }

	            function Bgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vN(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0) | 0
	            }

	            function Cgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wN(a | 0, b | 0)
	            }

	            function Dgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                CN(a | 0, b | 0, c | 0)
	            }

	            function Egb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                GN(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Fgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                vO(a | 0, b | 0, c | 0)
	            }

	            function Ggb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                wO(a | 0, b | 0, c | 0)
	            }

	            function Hgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fP(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Igb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                sP(a | 0, b | 0, c | 0)
	            }

	            function Jgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                fQ(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, 0, 0, 0)
	            }

	            function Kgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                gQ(a | 0, b | 0, c | 0, d | 0)
	            }

	            function Lgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Mgb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function Ngb(a, b, c, d, e, f) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                f = f | 0;
	                hT(a | 0, b | 0, c | 0) | 0
	            }

	            function Ogb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                da(13);
	                return 0
	            }

	            function Pgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Qgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return vc(a | 0) | 0
	            }

	            function Rgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return wc(a | 0) | 0
	            }

	            function Sgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return xc(a | 0) | 0
	            }

	            function Tgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return yc(a | 0, b | 0, 0) | 0
	            }

	            function Ugb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Vgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Wgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Xgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ygb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Zgb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function _gb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function $gb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ahb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function bhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function chb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function dhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ehb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function fhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ghb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function hhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ihb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function jhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function khb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function lhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function mhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function nhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ohb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Xk(a | 0, b | 0, 0) | 0
	            }

	            function phb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function qhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return iT(a | 0) | 0
	            }

	            function rhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return my(a | 0) | 0
	            }

	            function shb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function thb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function uhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return PP(a | 0) | 0
	            }

	            function vhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return QP(a | 0) | 0
	            }

	            function whb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return RP(a | 0) | 0
	            }

	            function xhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return UP(a | 0, b | 0, 0) | 0
	            }

	            function yhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function zhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ahb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Bhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Chb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Dhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ehb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Fhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ghb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Hhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ihb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Jhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Khb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Lhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Mhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Nhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ohb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Phb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Qhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return LP(a | 0) | 0
	            }

	            function Rhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return MP(a | 0) | 0
	            }

	            function Shb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return NP(a | 0) | 0
	            }

	            function Thb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return OP(a | 0) | 0
	            }

	            function Uhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Vhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return NI(a | 0) | 0
	            }

	            function Whb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return OI(a | 0) | 0
	            }

	            function Xhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return PI(a | 0) | 0
	            }

	            function Yhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return QI(a | 0) | 0
	            }

	            function Zhb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return RI(a | 0) | 0
	            }

	            function _hb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return SI(a | 0) | 0
	            }

	            function $hb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return TI(a | 0) | 0
	            }

	            function aib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return UI(a | 0) | 0
	            }

	            function bib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return VI(a | 0) | 0
	            }

	            function cib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return WI(a | 0) | 0
	            }

	            function dib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return XI(a | 0) | 0
	            }

	            function eib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return YI(a | 0) | 0
	            }

	            function fib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return ZI(a | 0) | 0
	            }

	            function gib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return _I(a | 0) | 0
	            }

	            function hib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return $I(a | 0) | 0
	            }

	            function iib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return aJ(a | 0) | 0
	            }

	            function jib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return bJ(a | 0) | 0
	            }

	            function kib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return cJ(a | 0) | 0
	            }

	            function lib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return dJ(a | 0) | 0
	            }

	            function mib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return eJ(a | 0) | 0
	            }

	            function nib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return fJ(a | 0) | 0
	            }

	            function oib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return gJ(a | 0) | 0
	            }

	            function pib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return hJ(a | 0) | 0
	            }

	            function qib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return iJ(a | 0) | 0
	            }

	            function rib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return jJ(a | 0) | 0
	            }

	            function sib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return kJ(a | 0) | 0
	            }

	            function tib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return lJ(a | 0) | 0
	            }

	            function uib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return mJ(a | 0) | 0
	            }

	            function vib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return nJ(a | 0) | 0
	            }

	            function wib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return oJ(a | 0) | 0
	            }

	            function xib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return pJ(a | 0) | 0
	            }

	            function yib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return qJ(a | 0) | 0
	            }

	            function zib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return rJ(a | 0) | 0
	            }

	            function Aib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return sJ(a | 0) | 0
	            }

	            function Bib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return tJ(a | 0) | 0
	            }

	            function Cib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return uJ(a | 0) | 0
	            }

	            function Dib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return vJ(a | 0) | 0
	            }

	            function Eib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return wJ(a | 0) | 0
	            }

	            function Fib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return xJ(a | 0) | 0
	            }

	            function Gib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return yJ(a | 0) | 0
	            }

	            function Hib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return zJ(a | 0) | 0
	            }

	            function Iib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return AJ(a | 0) | 0
	            }

	            function Jib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return BJ(a | 0) | 0
	            }

	            function Kib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return CJ(a | 0) | 0
	            }

	            function Lib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return DJ(a | 0) | 0
	            }

	            function Mib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return EJ(a | 0) | 0
	            }

	            function Nib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return FJ(a | 0) | 0
	            }

	            function Oib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return GJ(a | 0) | 0
	            }

	            function Pib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return HJ(a | 0) | 0
	            }

	            function Qib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return IJ(a | 0) | 0
	            }

	            function Rib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return JJ(a | 0) | 0
	            }

	            function Sib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return KJ(a | 0) | 0
	            }

	            function Tib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return LJ(a | 0) | 0
	            }

	            function Uib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return MJ(a | 0) | 0
	            }

	            function Vib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return NJ(a | 0) | 0
	            }

	            function Wib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return OJ(a | 0) | 0
	            }

	            function Xib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return PJ(a | 0) | 0
	            }

	            function Yib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return QJ(a | 0) | 0
	            }

	            function Zib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return RJ(a | 0) | 0
	            }

	            function _ib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return SJ(a | 0) | 0
	            }

	            function $ib(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return TJ(a | 0) | 0
	            }

	            function ajb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return UJ(a | 0) | 0
	            }

	            function bjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return VJ(a | 0) | 0
	            }

	            function cjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return WJ(a | 0) | 0
	            }

	            function djb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return XJ(a | 0) | 0
	            }

	            function ejb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return YJ(a | 0) | 0
	            }

	            function fjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return ZJ(a | 0) | 0
	            }

	            function gjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return _J(a | 0) | 0
	            }

	            function hjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return $J(a | 0) | 0
	            }

	            function ijb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return aK(a | 0) | 0
	            }

	            function jjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return bK(a | 0) | 0
	            }

	            function kjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return cK(a | 0) | 0
	            }

	            function ljb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return dK(a | 0) | 0
	            }

	            function mjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return eK(a | 0) | 0
	            }

	            function njb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return fK(a | 0) | 0
	            }

	            function ojb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return gK(a | 0) | 0
	            }

	            function pjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return hK(a | 0) | 0
	            }

	            function qjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return iK(a | 0) | 0
	            }

	            function rjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return jK(a | 0) | 0
	            }

	            function sjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return kK(a | 0) | 0
	            }

	            function tjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return lK(a | 0) | 0
	            }

	            function ujb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return mK(a | 0) | 0
	            }

	            function vjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return nK(a | 0) | 0
	            }

	            function wjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return oK(a | 0) | 0
	            }

	            function xjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return pK(a | 0) | 0
	            }

	            function yjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return qK(a | 0) | 0
	            }

	            function zjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return rK(a | 0) | 0
	            }

	            function Ajb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return sK(a | 0) | 0
	            }

	            function Bjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return tK(a | 0) | 0
	            }

	            function Cjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return uK(a | 0) | 0
	            }

	            function Djb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return vK(a | 0) | 0
	            }

	            function Ejb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return wK(a | 0) | 0
	            }

	            function Fjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return xK(a | 0) | 0
	            }

	            function Gjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return yK(a | 0) | 0
	            }

	            function Hjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return zK(a | 0) | 0
	            }

	            function Ijb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return AK(a | 0) | 0
	            }

	            function Jjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return BK(a | 0) | 0
	            }

	            function Kjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return CK(a | 0) | 0
	            }

	            function Ljb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return DK(a | 0) | 0
	            }

	            function Mjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return EK(a | 0) | 0
	            }

	            function Njb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return FK(a | 0) | 0
	            }

	            function Ojb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return GK(a | 0) | 0
	            }

	            function Pjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return HK(a | 0) | 0
	            }

	            function Qjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return IK(a | 0) | 0
	            }

	            function Rjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return JK(a | 0) | 0
	            }

	            function Sjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return KK(a | 0) | 0
	            }

	            function Tjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return LK(a | 0) | 0
	            }

	            function Ujb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return MK(a | 0) | 0
	            }

	            function Vjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return NK(a | 0) | 0
	            }

	            function Wjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return OK(a | 0) | 0
	            }

	            function Xjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return PK(a | 0) | 0
	            }

	            function Yjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return QK(a | 0) | 0
	            }

	            function Zjb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return RK(a | 0) | 0
	            }

	            function _jb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return SK(a | 0) | 0
	            }

	            function $jb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return TK(a | 0) | 0
	            }

	            function akb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return UK(a | 0) | 0
	            }

	            function bkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return VK(a | 0) | 0
	            }

	            function ckb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return WK(a | 0) | 0
	            }

	            function dkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return XK(a | 0) | 0
	            }

	            function ekb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return YK(a | 0) | 0
	            }

	            function fkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return ZK(a | 0) | 0
	            }

	            function gkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return _K(a | 0) | 0
	            }

	            function hkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return $K(a | 0) | 0
	            }

	            function ikb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return aL(a | 0) | 0
	            }

	            function jkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return bL(a | 0) | 0
	            }

	            function kkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return cL(a | 0) | 0
	            }

	            function lkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return dL(a | 0) | 0
	            }

	            function mkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return eL(a | 0) | 0
	            }

	            function nkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return RT(a | 0, b | 0, 0) | 0
	            }

	            function okb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function pkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Wb(a | 0) | 0
	            }

	            function qkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Yb(a | 0) | 0
	            }

	            function rkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Wk(a | 0, b | 0, 0) | 0
	            }

	            function skb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function tkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ukb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return ac(a | 0, b | 0, 0) | 0
	            }

	            function vkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Ka(a | 0, b | 0, 0) | 0
	            }

	            function wkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return gc(a | 0, b | 0, 0) | 0
	            }

	            function xkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ykb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function zkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Akb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Bkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ckb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return nc(a | 0) | 0
	            }

	            function Dkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ekb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return nd(a | 0) | 0
	            }

	            function Fkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Kd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Gkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Ld(a | 0, b | 0, 0, 0) | 0
	            }

	            function Hkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Md(a | 0, b | 0, 0, 0) | 0
	            }

	            function Ikb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Nd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Jkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Od(a | 0, b | 0, 0, 0) | 0
	            }

	            function Kkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Pd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Lkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return qd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Mkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return rd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Nkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Qd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Okb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Rd(a | 0, b | 0, 0, 0) | 0
	            }

	            function Pkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return fo(a | 0, b | 0, 0, 0) | 0
	            }

	            function Qkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Rkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Skb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Tkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return mk() | 0
	            }

	            function Ukb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Vkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Wkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return nk(a | 0) | 0
	            }

	            function Xkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return ok(a | 0) | 0
	            }

	            function Ykb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return pk(a | 0, b | 0, 0) | 0
	            }

	            function Zkb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return qk(a | 0) | 0
	            }

	            function _kb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return _k(a | 0) | 0
	            }

	            function $kb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return $k(a | 0, b | 0, 0) | 0
	            }

	            function alb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return bl(a | 0) | 0
	            }

	            function blb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return cl(a | 0, b | 0, 0) | 0
	            }

	            function clb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return dl(a | 0) | 0
	            }

	            function dlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return el(a | 0, b | 0, 0) | 0
	            }

	            function elb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return fl(a | 0, b | 0, 0) | 0
	            }

	            function flb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return gl(a | 0, b | 0, 0, 0) | 0
	            }

	            function glb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function hlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return on(a | 0) | 0
	            }

	            function ilb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function jlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return vn(a | 0) | 0
	            }

	            function klb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function llb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return yn(a | 0) | 0
	            }

	            function mlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function nlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function olb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function plb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function qlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function rlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function slb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function tlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ulb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function vlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function wlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function xlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ylb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function zlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Alb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Blb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Clb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Dlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Elb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Flb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Glb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Hlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ilb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Jlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Klb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Llb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Mlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Nlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Olb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Plb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Qlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Rlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Slb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Tlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ulb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Vlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Wlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Xlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ylb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Zlb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return uu(a | 0, b | 0, 0) | 0
	            }

	            function _lb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return vu(a | 0, b | 0, 0) | 0
	            }

	            function $lb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function amb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function bmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function cmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function dmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function emb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function fmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function gmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function hmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function imb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function jmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function kmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return Kx(a | 0, b | 0, 0) | 0
	            }

	            function lmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function mmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function nmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function omb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function pmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function qmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function rmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function smb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return RB(a | 0) | 0
	            }

	            function tmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return SB(a | 0) | 0
	            }

	            function umb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return TB(a | 0) | 0
	            }

	            function vmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return UB(a | 0, b | 0, 0) | 0
	            }

	            function wmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function xmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function ymb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function zmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Amb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Bmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Cmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Dmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Emb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Fmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Gmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Hmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Imb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Jmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Kmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Lmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Mmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Nmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Omb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Pmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Qmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return rC(a | 0, b | 0, 0) | 0
	            }

	            function Rmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Smb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Tmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Umb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Vmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Wmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Xmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Ymb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function Zmb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function _mb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function $mb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function anb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function bnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function cnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return GM(a | 0, b | 0, 0) | 0
	            }

	            function dnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function enb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function fnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return oN(a | 0, b | 0, 0, 0, 0) | 0
	            }

	            function gnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return pN(a | 0, b | 0, 0, 0, 0, 0, 0) | 0
	            }

	            function hnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return qN(a | 0, b | 0, 0, 0, 0, 0) | 0
	            }

	            function inb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function jnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return uN(a | 0, b | 0, 0, 0, 0) | 0
	            }

	            function knb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return vN(a | 0, b | 0, 0, 0, 0, 0, 0) | 0
	            }

	            function lnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function mnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function nnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function onb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function pnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function qnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function rnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function snb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function tnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return 0
	            }

	            function unb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return WR(a | 0, b | 0, 0, 0) | 0
	            }

	            function vnb(a, b) {
	                a = a | 0;
	                b = b | 0;
	                return hT(a | 0, b | 0, 0) | 0
	            }

	            function wnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                da(14);
	                return 0
	            }

	            function xnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ynb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return vc(a | 0) | 0
	            }

	            function znb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return wc(a | 0) | 0
	            }

	            function Anb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return xc(a | 0) | 0
	            }

	            function Bnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return yc(a | 0, b | 0, c | 0) | 0
	            }

	            function Cnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return zc(a | 0, b | 0) | 0
	            }

	            function Dnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Enb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Fnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Gnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Hnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Inb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Jnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Knb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Lnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Mnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Nnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Onb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Pnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Qnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Rnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Snb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Tnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Unb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Vnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Qc(a | 0, b | 0) | 0
	            }

	            function Wnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Xnb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ynb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Znb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function _nb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function $nb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function aob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return iT(a | 0) | 0
	            }

	            function bob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return kT(a | 0, b | 0) | 0
	            }

	            function cob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return my(a | 0) | 0
	            }

	            function dob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function eob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function fob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return PP(a | 0) | 0
	            }

	            function gob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return QP(a | 0) | 0
	            }

	            function hob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return RP(a | 0) | 0
	            }

	            function iob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return UP(a | 0, b | 0, c | 0) | 0
	            }

	            function job(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return VP(a | 0, b | 0) | 0
	            }

	            function kob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function lob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function mob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function nob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function oob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function pob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function qob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function rob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function sob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function tob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function uob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function vob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function wob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function xob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function yob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function zob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Aob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return WP(a | 0, b | 0) | 0
	            }

	            function Bob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Cob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Dob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return LP(a | 0) | 0
	            }

	            function Eob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return MP(a | 0) | 0
	            }

	            function Fob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return NP(a | 0) | 0
	            }

	            function Gob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return OP(a | 0) | 0
	            }

	            function Hob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Iob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return NI(a | 0) | 0
	            }

	            function Job(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return OI(a | 0) | 0
	            }

	            function Kob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return PI(a | 0) | 0
	            }

	            function Lob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return QI(a | 0) | 0
	            }

	            function Mob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return RI(a | 0) | 0
	            }

	            function Nob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return SI(a | 0) | 0
	            }

	            function Oob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return TI(a | 0) | 0
	            }

	            function Pob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return UI(a | 0) | 0
	            }

	            function Qob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return VI(a | 0) | 0
	            }

	            function Rob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return WI(a | 0) | 0
	            }

	            function Sob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return XI(a | 0) | 0
	            }

	            function Tob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return YI(a | 0) | 0
	            }

	            function Uob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return ZI(a | 0) | 0
	            }

	            function Vob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return _I(a | 0) | 0
	            }

	            function Wob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return $I(a | 0) | 0
	            }

	            function Xob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return aJ(a | 0) | 0
	            }

	            function Yob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return bJ(a | 0) | 0
	            }

	            function Zob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return cJ(a | 0) | 0
	            }

	            function _ob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return dJ(a | 0) | 0
	            }

	            function $ob(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return eJ(a | 0) | 0
	            }

	            function apb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return fJ(a | 0) | 0
	            }

	            function bpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return gJ(a | 0) | 0
	            }

	            function cpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return hJ(a | 0) | 0
	            }

	            function dpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return iJ(a | 0) | 0
	            }

	            function epb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return jJ(a | 0) | 0
	            }

	            function fpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return kJ(a | 0) | 0
	            }

	            function gpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return lJ(a | 0) | 0
	            }

	            function hpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return mJ(a | 0) | 0
	            }

	            function ipb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return nJ(a | 0) | 0
	            }

	            function jpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return oJ(a | 0) | 0
	            }

	            function kpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return pJ(a | 0) | 0
	            }

	            function lpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return qJ(a | 0) | 0
	            }

	            function mpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return rJ(a | 0) | 0
	            }

	            function npb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return sJ(a | 0) | 0
	            }

	            function opb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return tJ(a | 0) | 0
	            }

	            function ppb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return uJ(a | 0) | 0
	            }

	            function qpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return vJ(a | 0) | 0
	            }

	            function rpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return wJ(a | 0) | 0
	            }

	            function spb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return xJ(a | 0) | 0
	            }

	            function tpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return yJ(a | 0) | 0
	            }

	            function upb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return zJ(a | 0) | 0
	            }

	            function vpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return AJ(a | 0) | 0
	            }

	            function wpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return BJ(a | 0) | 0
	            }

	            function xpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return CJ(a | 0) | 0
	            }

	            function ypb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return DJ(a | 0) | 0
	            }

	            function zpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return EJ(a | 0) | 0
	            }

	            function Apb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return FJ(a | 0) | 0
	            }

	            function Bpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return GJ(a | 0) | 0
	            }

	            function Cpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return HJ(a | 0) | 0
	            }

	            function Dpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return IJ(a | 0) | 0
	            }

	            function Epb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return JJ(a | 0) | 0
	            }

	            function Fpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return KJ(a | 0) | 0
	            }

	            function Gpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return LJ(a | 0) | 0
	            }

	            function Hpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return MJ(a | 0) | 0
	            }

	            function Ipb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return NJ(a | 0) | 0
	            }

	            function Jpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return OJ(a | 0) | 0
	            }

	            function Kpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return PJ(a | 0) | 0
	            }

	            function Lpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return QJ(a | 0) | 0
	            }

	            function Mpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return RJ(a | 0) | 0
	            }

	            function Npb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return SJ(a | 0) | 0
	            }

	            function Opb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return TJ(a | 0) | 0
	            }

	            function Ppb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return UJ(a | 0) | 0
	            }

	            function Qpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return VJ(a | 0) | 0
	            }

	            function Rpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return WJ(a | 0) | 0
	            }

	            function Spb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return XJ(a | 0) | 0
	            }

	            function Tpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return YJ(a | 0) | 0
	            }

	            function Upb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return ZJ(a | 0) | 0
	            }

	            function Vpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return _J(a | 0) | 0
	            }

	            function Wpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return $J(a | 0) | 0
	            }

	            function Xpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return aK(a | 0) | 0
	            }

	            function Ypb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return bK(a | 0) | 0
	            }

	            function Zpb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return cK(a | 0) | 0
	            }

	            function _pb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return dK(a | 0) | 0
	            }

	            function $pb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return eK(a | 0) | 0
	            }

	            function aqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return fK(a | 0) | 0
	            }

	            function bqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return gK(a | 0) | 0
	            }

	            function cqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return hK(a | 0) | 0
	            }

	            function dqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return iK(a | 0) | 0
	            }

	            function eqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return jK(a | 0) | 0
	            }

	            function fqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return kK(a | 0) | 0
	            }

	            function gqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return lK(a | 0) | 0
	            }

	            function hqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return mK(a | 0) | 0
	            }

	            function iqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return nK(a | 0) | 0
	            }

	            function jqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return oK(a | 0) | 0
	            }

	            function kqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return pK(a | 0) | 0
	            }

	            function lqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return qK(a | 0) | 0
	            }

	            function mqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return rK(a | 0) | 0
	            }

	            function nqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return sK(a | 0) | 0
	            }

	            function oqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return tK(a | 0) | 0
	            }

	            function pqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return uK(a | 0) | 0
	            }

	            function qqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return vK(a | 0) | 0
	            }

	            function rqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return wK(a | 0) | 0
	            }

	            function sqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return xK(a | 0) | 0
	            }

	            function tqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return yK(a | 0) | 0
	            }

	            function uqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return zK(a | 0) | 0
	            }

	            function vqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return AK(a | 0) | 0
	            }

	            function wqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return BK(a | 0) | 0
	            }

	            function xqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return CK(a | 0) | 0
	            }

	            function yqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return DK(a | 0) | 0
	            }

	            function zqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return EK(a | 0) | 0
	            }

	            function Aqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return FK(a | 0) | 0
	            }

	            function Bqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return GK(a | 0) | 0
	            }

	            function Cqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return HK(a | 0) | 0
	            }

	            function Dqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return IK(a | 0) | 0
	            }

	            function Eqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return JK(a | 0) | 0
	            }

	            function Fqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return KK(a | 0) | 0
	            }

	            function Gqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return LK(a | 0) | 0
	            }

	            function Hqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return MK(a | 0) | 0
	            }

	            function Iqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return NK(a | 0) | 0
	            }

	            function Jqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return OK(a | 0) | 0
	            }

	            function Kqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return PK(a | 0) | 0
	            }

	            function Lqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return QK(a | 0) | 0
	            }

	            function Mqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return RK(a | 0) | 0
	            }

	            function Nqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return SK(a | 0) | 0
	            }

	            function Oqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return TK(a | 0) | 0
	            }

	            function Pqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return UK(a | 0) | 0
	            }

	            function Qqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return VK(a | 0) | 0
	            }

	            function Rqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return WK(a | 0) | 0
	            }

	            function Sqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return XK(a | 0) | 0
	            }

	            function Tqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return YK(a | 0) | 0
	            }

	            function Uqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return ZK(a | 0) | 0
	            }

	            function Vqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return _K(a | 0) | 0
	            }

	            function Wqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return $K(a | 0) | 0
	            }

	            function Xqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return aL(a | 0) | 0
	            }

	            function Yqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return bL(a | 0) | 0
	            }

	            function Zqb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return cL(a | 0) | 0
	            }

	            function _qb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return dL(a | 0) | 0
	            }

	            function $qb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return eL(a | 0) | 0
	            }

	            function arb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return RT(a | 0, b | 0, c | 0) | 0
	            }

	            function brb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function crb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Wb(a | 0) | 0
	            }

	            function drb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Xb(a | 0, b | 0) | 0
	            }

	            function erb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Yb(a | 0) | 0
	            }

	            function frb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function grb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function hrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function irb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return ac(a | 0, b | 0, c | 0) | 0
	            }

	            function jrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function krb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return gc(a | 0, b | 0, c | 0) | 0
	            }

	            function lrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function mrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function nrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function orb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function prb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function qrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return nc(a | 0) | 0
	            }

	            function rrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function srb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return nd(a | 0) | 0
	            }

	            function trb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function urb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function vrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function wrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function xrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function yrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function zrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Arb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Brb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Crb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Drb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Erb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Frb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Grb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Hrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return mk() | 0
	            }

	            function Irb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Jrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Krb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return nk(a | 0) | 0
	            }

	            function Lrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return ok(a | 0) | 0
	            }

	            function Mrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return pk(a | 0, b | 0, c | 0) | 0
	            }

	            function Nrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return qk(a | 0) | 0
	            }

	            function Orb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return _k(a | 0) | 0
	            }

	            function Prb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return $k(a | 0, b | 0, c | 0) | 0
	            }

	            function Qrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return bl(a | 0) | 0
	            }

	            function Rrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return cl(a | 0, b | 0, c | 0) | 0
	            }

	            function Srb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return dl(a | 0) | 0
	            }

	            function Trb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return el(a | 0, b | 0, c | 0) | 0
	            }

	            function Urb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return fl(a | 0, b | 0, c | 0) | 0
	            }

	            function Vrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Wrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Xrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return on(a | 0) | 0
	            }

	            function Yrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Zrb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return vn(a | 0) | 0
	            }

	            function _rb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function $rb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return yn(a | 0) | 0
	            }

	            function asb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function bsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function csb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function dsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Cn(a | 0, b | 0) | 0
	            }

	            function esb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function fsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function gsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function hsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function isb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function jsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ksb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return _n(a | 0, b | 0) | 0
	            }

	            function lsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function msb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function nsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function osb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function psb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function qsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function rsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ssb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function tsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function usb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function vsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function wsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function xsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ysb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function zsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Asb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Bsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Csb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Dsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Esb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Fsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Gsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Hsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Isb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Jsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ksb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Lsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Msb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Nsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Osb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Psb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return uu(a | 0, b | 0, c | 0) | 0
	            }

	            function Qsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return ds(a | 0, b | 0) | 0
	            }

	            function Rsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return es(a | 0, b | 0) | 0
	            }

	            function Ssb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return js(a | 0, b | 0) | 0
	            }

	            function Tsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return vu(a | 0, b | 0, c | 0) | 0
	            }

	            function Usb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return wu(a | 0, b | 0) | 0
	            }

	            function Vsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return $r(a | 0, b | 0) | 0
	            }

	            function Wsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return as(a | 0, b | 0) | 0
	            }

	            function Xsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return bs(a | 0, b | 0) | 0
	            }

	            function Ysb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return hs(a | 0, b | 0) | 0
	            }

	            function Zsb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return fs(a | 0, b | 0) | 0
	            }

	            function _sb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return is(a | 0, b | 0) | 0
	            }

	            function $sb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return cs(a | 0, b | 0) | 0
	            }

	            function atb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return xu(a | 0, b | 0) | 0
	            }

	            function btb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return gs(a | 0, b | 0) | 0
	            }

	            function ctb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return _r(a | 0, b | 0) | 0
	            }

	            function dtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return dr(a | 0, b | 0) | 0
	            }

	            function etb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ftb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function gtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function htb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function itb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function jtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ktb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ltb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function mtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ntb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function otb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ptb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function qtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return $x(a | 0, b | 0) | 0
	            }

	            function rtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return dy(a | 0, b | 0) | 0
	            }

	            function stb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return fy(a | 0, b | 0) | 0
	            }

	            function ttb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return jy(a | 0, b | 0) | 0
	            }

	            function utb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function vtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function wtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function xtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ytb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function ztb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Atb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Btb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return RB(a | 0) | 0
	            }

	            function Ctb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return SB(a | 0) | 0
	            }

	            function Dtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return TB(a | 0) | 0
	            }

	            function Etb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return UB(a | 0, b | 0, c | 0) | 0
	            }

	            function Ftb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return VB(a | 0, b | 0) | 0
	            }

	            function Gtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Htb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Itb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Jtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ktb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ltb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Mtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ntb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Otb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ptb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Qtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Rtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Stb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ttb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return hC(a | 0, b | 0) | 0
	            }

	            function Utb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Vtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Wtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Xtb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ytb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Ztb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function _tb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function $tb(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return rC(a | 0, b | 0, c | 0) | 0
	            }

	            function aub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function bub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function cub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function dub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function eub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function fub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function gub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function hub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function iub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function jub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function kub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function lub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function mub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function nub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return GM(a | 0, b | 0, c | 0) | 0
	            }

	            function oub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function pub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function qub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return nN(a | 0, b | 0) | 0
	            }

	            function rub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return pN(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0) | 0
	            }

	            function sub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return qN(a | 0, b | 0, c | 0, d | 0, e | 0, 0) | 0
	            }

	            function tub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function uub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return tN(a | 0, b | 0) | 0
	            }

	            function vub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return vN(a | 0, b | 0, c | 0, d | 0, e | 0, 0, 0) | 0
	            }

	            function wub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function xub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function yub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function zub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Aub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Bub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Cub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Dub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Eub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return 0
	            }

	            function Fub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Gub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return QS(a | 0, b | 0) | 0
	            }

	            function Hub(a, b, c, d, e) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                e = e | 0;
	                return hT(a | 0, b | 0, c | 0) | 0
	            }

	            function Iub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                da(15)
	            }

	            function Jub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vc(a | 0) | 0
	            }

	            function Kub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wc(a | 0) | 0
	            }

	            function Lub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xc(a | 0) | 0
	            }

	            function Mub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                yc(a | 0, b | 0, c | 0) | 0
	            }

	            function Nub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                zc(a | 0, b | 0) | 0
	            }

	            function Oub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Ac(a | 0, b | 0, c | 0, d | 0, 0, 0)
	            }

	            function Pub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Cc(a | 0, b | 0, c | 0, d | 0, 0, 0, 0)
	            }

	            function Qub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Ec(a | 0, b | 0, c | 0, d | 0, 0)
	            }

	            function Rub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Fc(a | 0, b | 0)
	            }

	            function Sub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Gc(a | 0)
	            }

	            function Tub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Hc(a | 0)
	            }

	            function Uub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Wc(a | 0, b | 0, c | 0)
	            }

	            function Vub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Xc(a | 0, b | 0)
	            }

	            function Wub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Ic(a | 0, b | 0)
	            }

	            function Xub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Jc(a | 0, b | 0, c | 0)
	            }

	            function Yub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Kc(a | 0, b | 0, c | 0)
	            }

	            function Zub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Lc(a | 0, b | 0, c | 0)
	            }

	            function _ub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Mc(a | 0, b | 0)
	            }

	            function $ub(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Nc(a | 0, b | 0, c | 0)
	            }

	            function avb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Oc(a | 0, b | 0, c | 0)
	            }

	            function bvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Pc(a | 0, b | 0, c | 0)
	            }

	            function cvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Qc(a | 0, b | 0) | 0
	            }

	            function dvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Rc(a | 0, b | 0, c | 0)
	            }

	            function evb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Tc(a | 0, b | 0, c | 0, d | 0, 0, 0, 0, 0, 0)
	            }

	            function fvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Xk(a | 0, b | 0, c | 0) | 0
	            }

	            function gvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jT(a | 0)
	            }

	            function hvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                iT(a | 0) | 0
	            }

	            function ivb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                kT(a | 0, b | 0) | 0
	            }

	            function jvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                my(a | 0) | 0
	            }

	            function kvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Td(a | 0, b | 0, c | 0)
	            }

	            function lvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                PP(a | 0) | 0
	            }

	            function mvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                QP(a | 0) | 0
	            }

	            function nvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                RP(a | 0) | 0
	            }

	            function ovb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                UP(a | 0, b | 0, c | 0) | 0
	            }

	            function pvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                VP(a | 0, b | 0) | 0
	            }

	            function qvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                XP(a | 0, b | 0, c | 0, d | 0, 0, 0)
	            }

	            function rvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                YP(a | 0, b | 0, c | 0, d | 0, 0, 0, 0)
	            }

	            function svb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $P(a | 0, b | 0, c | 0, d | 0, 0)
	            }

	            function tvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                aQ(a | 0, b | 0)
	            }

	            function uvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bQ(a | 0)
	            }

	            function vvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cQ(a | 0)
	            }

	            function wvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dQ(a | 0, b | 0, c | 0)
	            }

	            function xvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                eQ(a | 0, b | 0)
	            }

	            function yvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hQ(a | 0, b | 0)
	            }

	            function zvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                iQ(a | 0, b | 0, c | 0)
	            }

	            function Avb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                kQ(a | 0, b | 0, c | 0)
	            }

	            function Bvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                lQ(a | 0, b | 0)
	            }

	            function Cvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $d(a | 0, b | 0, c | 0)
	            }

	            function Dvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _d(a | 0, b | 0, c | 0)
	            }

	            function Evb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                WP(a | 0, b | 0) | 0
	            }

	            function Fvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                mQ(a | 0, b | 0, c | 0)
	            }

	            function Gvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                LP(a | 0) | 0
	            }

	            function Hvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                MP(a | 0) | 0
	            }

	            function Ivb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                NP(a | 0) | 0
	            }

	            function Jvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                OP(a | 0) | 0
	            }

	            function Kvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jQ(a | 0, b | 0, c | 0)
	            }

	            function Lvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                NI(a | 0) | 0
	            }

	            function Mvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                OI(a | 0) | 0
	            }

	            function Nvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                PI(a | 0) | 0
	            }

	            function Ovb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                QI(a | 0) | 0
	            }

	            function Pvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                RI(a | 0) | 0
	            }

	            function Qvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                SI(a | 0) | 0
	            }

	            function Rvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                TI(a | 0) | 0
	            }

	            function Svb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                UI(a | 0) | 0
	            }

	            function Tvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                VI(a | 0) | 0
	            }

	            function Uvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                WI(a | 0) | 0
	            }

	            function Vvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                XI(a | 0) | 0
	            }

	            function Wvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                YI(a | 0) | 0
	            }

	            function Xvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ZI(a | 0) | 0
	            }

	            function Yvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _I(a | 0) | 0
	            }

	            function Zvb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $I(a | 0) | 0
	            }

	            function _vb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                aJ(a | 0) | 0
	            }

	            function $vb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bJ(a | 0) | 0
	            }

	            function awb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cJ(a | 0) | 0
	            }

	            function bwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dJ(a | 0) | 0
	            }

	            function cwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                eJ(a | 0) | 0
	            }

	            function dwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fJ(a | 0) | 0
	            }

	            function ewb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gJ(a | 0) | 0
	            }

	            function fwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hJ(a | 0) | 0
	            }

	            function gwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                iJ(a | 0) | 0
	            }

	            function hwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jJ(a | 0) | 0
	            }

	            function iwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                kJ(a | 0) | 0
	            }

	            function jwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                lJ(a | 0) | 0
	            }

	            function kwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                mJ(a | 0) | 0
	            }

	            function lwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nJ(a | 0) | 0
	            }

	            function mwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                oJ(a | 0) | 0
	            }

	            function nwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                pJ(a | 0) | 0
	            }

	            function owb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qJ(a | 0) | 0
	            }

	            function pwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rJ(a | 0) | 0
	            }

	            function qwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                sJ(a | 0) | 0
	            }

	            function rwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tJ(a | 0) | 0
	            }

	            function swb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uJ(a | 0) | 0
	            }

	            function twb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vJ(a | 0) | 0
	            }

	            function uwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wJ(a | 0) | 0
	            }

	            function vwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xJ(a | 0) | 0
	            }

	            function wwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                yJ(a | 0) | 0
	            }

	            function xwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                zJ(a | 0) | 0
	            }

	            function ywb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                AJ(a | 0) | 0
	            }

	            function zwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                BJ(a | 0) | 0
	            }

	            function Awb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                CJ(a | 0) | 0
	            }

	            function Bwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                DJ(a | 0) | 0
	            }

	            function Cwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                EJ(a | 0) | 0
	            }

	            function Dwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                FJ(a | 0) | 0
	            }

	            function Ewb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                GJ(a | 0) | 0
	            }

	            function Fwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                HJ(a | 0) | 0
	            }

	            function Gwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                IJ(a | 0) | 0
	            }

	            function Hwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                JJ(a | 0) | 0
	            }

	            function Iwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                KJ(a | 0) | 0
	            }

	            function Jwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                LJ(a | 0) | 0
	            }

	            function Kwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                MJ(a | 0) | 0
	            }

	            function Lwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                NJ(a | 0) | 0
	            }

	            function Mwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                OJ(a | 0) | 0
	            }

	            function Nwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                PJ(a | 0) | 0
	            }

	            function Owb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                QJ(a | 0) | 0
	            }

	            function Pwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                RJ(a | 0) | 0
	            }

	            function Qwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                SJ(a | 0) | 0
	            }

	            function Rwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                TJ(a | 0) | 0
	            }

	            function Swb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                UJ(a | 0) | 0
	            }

	            function Twb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                VJ(a | 0) | 0
	            }

	            function Uwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                WJ(a | 0) | 0
	            }

	            function Vwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                XJ(a | 0) | 0
	            }

	            function Wwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                YJ(a | 0) | 0
	            }

	            function Xwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ZJ(a | 0) | 0
	            }

	            function Ywb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _J(a | 0) | 0
	            }

	            function Zwb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $J(a | 0) | 0
	            }

	            function _wb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                aK(a | 0) | 0
	            }

	            function $wb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bK(a | 0) | 0
	            }

	            function axb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cK(a | 0) | 0
	            }

	            function bxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dK(a | 0) | 0
	            }

	            function cxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                eK(a | 0) | 0
	            }

	            function dxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fK(a | 0) | 0
	            }

	            function exb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gK(a | 0) | 0
	            }

	            function fxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hK(a | 0) | 0
	            }

	            function gxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                iK(a | 0) | 0
	            }

	            function hxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jK(a | 0) | 0
	            }

	            function ixb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                kK(a | 0) | 0
	            }

	            function jxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                lK(a | 0) | 0
	            }

	            function kxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                mK(a | 0) | 0
	            }

	            function lxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nK(a | 0) | 0
	            }

	            function mxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                oK(a | 0) | 0
	            }

	            function nxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                pK(a | 0) | 0
	            }

	            function oxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qK(a | 0) | 0
	            }

	            function pxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rK(a | 0) | 0
	            }

	            function qxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                sK(a | 0) | 0
	            }

	            function rxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tK(a | 0) | 0
	            }

	            function sxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uK(a | 0) | 0
	            }

	            function txb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vK(a | 0) | 0
	            }

	            function uxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wK(a | 0) | 0
	            }

	            function vxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xK(a | 0) | 0
	            }

	            function wxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                yK(a | 0) | 0
	            }

	            function xxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                zK(a | 0) | 0
	            }

	            function yxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                AK(a | 0) | 0
	            }

	            function zxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                BK(a | 0) | 0
	            }

	            function Axb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                CK(a | 0) | 0
	            }

	            function Bxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                DK(a | 0) | 0
	            }

	            function Cxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                EK(a | 0) | 0
	            }

	            function Dxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                FK(a | 0) | 0
	            }

	            function Exb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                GK(a | 0) | 0
	            }

	            function Fxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                HK(a | 0) | 0
	            }

	            function Gxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                IK(a | 0) | 0
	            }

	            function Hxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                JK(a | 0) | 0
	            }

	            function Ixb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                KK(a | 0) | 0
	            }

	            function Jxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                LK(a | 0) | 0
	            }

	            function Kxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                MK(a | 0) | 0
	            }

	            function Lxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                NK(a | 0) | 0
	            }

	            function Mxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                OK(a | 0) | 0
	            }

	            function Nxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                PK(a | 0) | 0
	            }

	            function Oxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                QK(a | 0) | 0
	            }

	            function Pxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                RK(a | 0) | 0
	            }

	            function Qxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                SK(a | 0) | 0
	            }

	            function Rxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                TK(a | 0) | 0
	            }

	            function Sxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                UK(a | 0) | 0
	            }

	            function Txb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                VK(a | 0) | 0
	            }

	            function Uxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                WK(a | 0) | 0
	            }

	            function Vxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                XK(a | 0) | 0
	            }

	            function Wxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                YK(a | 0) | 0
	            }

	            function Xxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ZK(a | 0) | 0
	            }

	            function Yxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _K(a | 0) | 0
	            }

	            function Zxb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $K(a | 0) | 0
	            }

	            function _xb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                aL(a | 0) | 0
	            }

	            function $xb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bL(a | 0) | 0
	            }

	            function ayb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cL(a | 0) | 0
	            }

	            function byb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dL(a | 0) | 0
	            }

	            function cyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                eL(a | 0) | 0
	            }

	            function dyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                RT(a | 0, b | 0, c | 0) | 0
	            }

	            function eyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Vb(a | 0)
	            }

	            function fyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Wb(a | 0) | 0
	            }

	            function gyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Xb(a | 0, b | 0) | 0
	            }

	            function hyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Yb(a | 0) | 0
	            }

	            function iyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Wk(a | 0, b | 0, c | 0) | 0
	            }

	            function jyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _b(a | 0)
	            }

	            function kyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $b(a | 0)
	            }

	            function lyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ac(a | 0, b | 0, c | 0) | 0
	            }

	            function myb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Ka(a | 0, b | 0, c | 0) | 0
	            }

	            function nyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gc(a | 0, b | 0, c | 0) | 0
	            }

	            function oyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hc(a | 0)
	            }

	            function pyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ic(a | 0, b | 0, c | 0)
	            }

	            function qyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jc(a | 0, b | 0, c | 0)
	            }

	            function ryb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                kc(a | 0, b | 0, c | 0)
	            }

	            function syb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                lc(a | 0, b | 0, c | 0)
	            }

	            function tyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nc(a | 0) | 0
	            }

	            function uyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                md(a | 0, b | 0)
	            }

	            function vyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nd(a | 0) | 0
	            }

	            function wyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Kd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function xyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Ld(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function yyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Md(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function zyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Nd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Ayb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Od(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Byb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Pd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Cyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Dyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Eyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Qd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Fyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Rd(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Gyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fo(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Hyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ae(a | 0, b | 0, c | 0)
	            }

	            function Iyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                be(a | 0, b | 0, c | 0)
	            }

	            function Jyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tg(a | 0)
	            }

	            function Kyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                mk() | 0
	            }

	            function Lyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                sh(a | 0, b | 0, c | 0, d | 0, 0)
	            }

	            function Myb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gk(a | 0, b | 0, c | 0, d | 0, 0)
	            }

	            function Nyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nk(a | 0) | 0
	            }

	            function Oyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ok(a | 0) | 0
	            }

	            function Pyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                pk(a | 0, b | 0, c | 0) | 0
	            }

	            function Qyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qk(a | 0) | 0
	            }

	            function Ryb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _k(a | 0) | 0
	            }

	            function Syb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $k(a | 0, b | 0, c | 0) | 0
	            }

	            function Tyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bl(a | 0) | 0
	            }

	            function Uyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cl(a | 0, b | 0, c | 0) | 0
	            }

	            function Vyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dl(a | 0) | 0
	            }

	            function Wyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                el(a | 0, b | 0, c | 0) | 0
	            }

	            function Xyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fl(a | 0, b | 0, c | 0) | 0
	            }

	            function Yyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gl(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function Zyb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nn(a | 0)
	            }

	            function _yb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                on(a | 0) | 0
	            }

	            function $yb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                sn(a | 0)
	            }

	            function azb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vn(a | 0) | 0
	            }

	            function bzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xn(a | 0)
	            }

	            function czb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                yn(a | 0) | 0
	            }

	            function dzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                zn(a | 0, b | 0)
	            }

	            function ezb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                An(a | 0)
	            }

	            function fzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Bn(a | 0)
	            }

	            function gzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Cn(a | 0, b | 0) | 0
	            }

	            function hzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Dn(a | 0)
	            }

	            function izb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                In(a | 0, b | 0, c | 0)
	            }

	            function jzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Rn(a | 0, b | 0, c | 0)
	            }

	            function kzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Sn(a | 0, b | 0, c | 0)
	            }

	            function lzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Tn(a | 0, b | 0, c | 0)
	            }

	            function mzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Un(a | 0, b | 0, c | 0)
	            }

	            function nzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _n(a | 0, b | 0) | 0
	            }

	            function ozb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tq(a | 0, b | 0)
	            }

	            function pzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Qq(a | 0)
	            }

	            function qzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Bs(a | 0, b | 0)
	            }

	            function rzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Is(a | 0, b | 0)
	            }

	            function szb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ns(a | 0, b | 0)
	            }

	            function tzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ts(a | 0, b | 0)
	            }

	            function uzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                us(a | 0, b | 0)
	            }

	            function vzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                os(a | 0, b | 0)
	            }

	            function wzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Es(a | 0, b | 0)
	            }

	            function xzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Hs(a | 0, b | 0)
	            }

	            function yzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ls(a | 0, b | 0)
	            }

	            function zzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Fs(a | 0, b | 0)
	            }

	            function Azb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ps(a | 0, b | 0)
	            }

	            function Bzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Cs(a | 0, b | 0)
	            }

	            function Czb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nt(a | 0, b | 0)
	            }

	            function Dzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qs(a | 0, b | 0)
	            }

	            function Ezb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                zs(a | 0, b | 0)
	            }

	            function Fzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Tr(a | 0, b | 0)
	            }

	            function Gzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ms(a | 0, b | 0)
	            }

	            function Hzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Js(a | 0, b | 0)
	            }

	            function Izb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rs(a | 0, b | 0)
	            }

	            function Jzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ss(a | 0, b | 0)
	            }

	            function Kzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vs(a | 0, b | 0)
	            }

	            function Lzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ws(a | 0, b | 0)
	            }

	            function Mzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xs(a | 0, b | 0)
	            }

	            function Nzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ys(a | 0, b | 0)
	            }

	            function Ozb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Gs(a | 0, b | 0)
	            }

	            function Pzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Ds(a | 0, b | 0)
	            }

	            function Qzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                As(a | 0, b | 0)
	            }

	            function Rzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ot(a | 0, b | 0)
	            }

	            function Szb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uu(a | 0, b | 0, c | 0) | 0
	            }

	            function Tzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                ds(a | 0, b | 0) | 0
	            }

	            function Uzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                es(a | 0, b | 0) | 0
	            }

	            function Vzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                js(a | 0, b | 0) | 0
	            }

	            function Wzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vu(a | 0, b | 0, c | 0) | 0
	            }

	            function Xzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wu(a | 0, b | 0) | 0
	            }

	            function Yzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $r(a | 0, b | 0) | 0
	            }

	            function Zzb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                as(a | 0, b | 0) | 0
	            }

	            function _zb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bs(a | 0, b | 0) | 0
	            }

	            function $zb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hs(a | 0, b | 0) | 0
	            }

	            function aAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fs(a | 0, b | 0) | 0
	            }

	            function bAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                is(a | 0, b | 0) | 0
	            }

	            function cAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cs(a | 0, b | 0) | 0
	            }

	            function dAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xu(a | 0, b | 0) | 0
	            }

	            function eAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gs(a | 0, b | 0) | 0
	            }

	            function fAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _r(a | 0, b | 0) | 0
	            }

	            function gAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dr(a | 0, b | 0) | 0
	            }

	            function hAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jv(a | 0, b | 0)
	            }

	            function iAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                pv(a | 0, b | 0)
	            }

	            function jAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qv(a | 0, b | 0)
	            }

	            function kAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rv(a | 0, b | 0)
	            }

	            function lAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                sv(a | 0, b | 0)
	            }

	            function mAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tv(a | 0, b | 0)
	            }

	            function nAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uv(a | 0, b | 0)
	            }

	            function oAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vv(a | 0, b | 0)
	            }

	            function pAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tw(a | 0, b | 0, c | 0)
	            }

	            function qAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Mw(a | 0)
	            }

	            function rAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Yw(a | 0)
	            }

	            function sAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                Kx(a | 0, b | 0, c | 0) | 0
	            }

	            function tAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $x(a | 0, b | 0) | 0
	            }

	            function uAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dy(a | 0, b | 0) | 0
	            }

	            function vAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fy(a | 0, b | 0) | 0
	            }

	            function wAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jy(a | 0, b | 0) | 0
	            }

	            function xAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qB(a | 0)
	            }

	            function yAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                LB(a | 0, b | 0, c | 0, d | 0, 0, 0, 0, 0, 0)
	            }

	            function zAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                NB(a | 0, b | 0, c | 0)
	            }

	            function AAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                OB(a | 0, b | 0, c | 0)
	            }

	            function BAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                PB(a | 0, b | 0)
	            }

	            function CAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                RB(a | 0) | 0
	            }

	            function DAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                SB(a | 0) | 0
	            }

	            function EAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                TB(a | 0) | 0
	            }

	            function FAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                UB(a | 0, b | 0, c | 0) | 0
	            }

	            function GAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                VB(a | 0, b | 0) | 0
	            }

	            function HAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                WB(a | 0, b | 0, c | 0, d | 0, 0, 0)
	            }

	            function IAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                YB(a | 0, b | 0, c | 0, d | 0, 0, 0, 0)
	            }

	            function JAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                _B(a | 0, b | 0, c | 0, d | 0, 0)
	            }

	            function KAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                $B(a | 0, b | 0)
	            }

	            function LAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                aC(a | 0)
	            }

	            function MAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                bC(a | 0)
	            }

	            function NAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                cC(a | 0, b | 0, c | 0)
	            }

	            function OAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                dC(a | 0, b | 0)
	            }

	            function PAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                eC(a | 0, b | 0, c | 0)
	            }

	            function QAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fC(a | 0, b | 0, c | 0)
	            }

	            function RAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                gC(a | 0, b | 0, c | 0)
	            }

	            function SAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hC(a | 0, b | 0) | 0
	            }

	            function TAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                jC(a | 0, b | 0, c | 0)
	            }

	            function UAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                kC(a | 0, b | 0, c | 0)
	            }

	            function VAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                lC(a | 0, b | 0, c | 0)
	            }

	            function WAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                mC(a | 0, b | 0)
	            }

	            function XAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nC(a | 0, b | 0, c | 0, d | 0, 0, 0, 0, 0, 0)
	            }

	            function YAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rC(a | 0, b | 0, c | 0) | 0
	            }

	            function ZAb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uC(a | 0)
	            }

	            function _Ab(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                AD(a | 0, b | 0)
	            }

	            function $Ab(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uF(a | 0, b | 0)
	            }

	            function aBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                VA(a | 0)
	            }

	            function bBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wM(a | 0, b | 0, c | 0)
	            }

	            function cBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                xM(a | 0, b | 0)
	            }

	            function dBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                yM(a | 0, b | 0, c | 0, d | 0, 0, 0, 0, 0, 0)
	            }

	            function eBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                AM(a | 0, b | 0, c | 0)
	            }

	            function fBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                BM(a | 0, b | 0, c | 0)
	            }

	            function gBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                DM(a | 0, b | 0, c | 0)
	            }

	            function hBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                EM(a | 0, b | 0, c | 0)
	            }

	            function iBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                GM(a | 0, b | 0, c | 0) | 0
	            }

	            function jBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                FM(a | 0, b | 0)
	            }

	            function kBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                UM(a | 0)
	            }

	            function lBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                nN(a | 0, b | 0) | 0
	            }

	            function mBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                oN(a | 0, b | 0, c | 0, d | 0, 0) | 0
	            }

	            function nBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                pN(a | 0, b | 0, c | 0, d | 0, 0, 0, 0) | 0
	            }

	            function oBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                qN(a | 0, b | 0, c | 0, d | 0, 0, 0) | 0
	            }

	            function pBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                rN(a | 0, b | 0)
	            }

	            function qBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                tN(a | 0, b | 0) | 0
	            }

	            function rBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                uN(a | 0, b | 0, c | 0, d | 0, 0) | 0
	            }

	            function sBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vN(a | 0, b | 0, c | 0, d | 0, 0, 0, 0) | 0
	            }

	            function tBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wN(a | 0, b | 0)
	            }

	            function uBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                CN(a | 0, b | 0, c | 0)
	            }

	            function vBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                vO(a | 0, b | 0, c | 0)
	            }

	            function wBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                wO(a | 0, b | 0, c | 0)
	            }

	            function xBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                sP(a | 0, b | 0, c | 0)
	            }

	            function yBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                fQ(a | 0, b | 0, c | 0, d | 0, 0, 0, 0, 0, 0)
	            }

	            function zBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                WR(a | 0, b | 0, c | 0, d | 0) | 0
	            }

	            function ABb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                QS(a | 0, b | 0) | 0
	            }

	            function BBb(a, b, c, d) {
	                a = a | 0;
	                b = b | 0;
	                c = c | 0;
	                d = d | 0;
	                hT(a | 0, b | 0, c | 0) | 0
	            }

	// EMSCRIPTEN_END_FUNCS
	            var ub = [GU, HU, IU, JU, KU, LU, MU, NU, OU, PU, QU, RU, SU, TU, UU, VU, WU, XU, YU, ZU, _U, $U, aV, bV, cV, dV, eV, fV, gV, hV, iV, jV, kV, lV, mV, nV, oV, pV, qV, rV, sV, tV, uV, vV, wV, xV, yV, zV, AV, BV, CV, DV, EV, FV, GV, HV, IV, JV, KV, LV, MV, NV, OV, PV, QV, RV, SV, TV, UV, VV, WV, XV, YV, ZV, _V, $V, aW, bW, cW, dW, eW, fW, gW, hW, iW, jW, kW, lW, mW, nW, oW, pW, qW, rW, sW, tW, uW, vW, wW, xW, yW, zW, AW, BW, CW, DW, EW, FW, GW, HW, IW, JW, KW, LW, MW, NW, OW, PW, QW, RW, SW, TW, UW, VW, WW, XW, YW, ZW, _W, $W, aX, bX, cX, dX, eX, fX, gX, hX, iX, jX, kX, lX, mX, nX, oX, pX, qX, rX, sX, tX, uX, vX, wX, xX, yX, zX, AX, BX, CX, DX, EX, FX, GX, HX, IX, JX, KX, LX, MX, NX, OX, PX, QX, RX, SX, TX, UX, VX, WX, XX, YX, ZX, _X, $X, aY, bY, cY, dY, eY, fY, gY, hY, iY, jY, kY, lY, mY, nY, oY, pY, qY, rY, sY, tY, uY, vY, wY, xY, yY, zY, AY, BY, CY, DY, EY, FY, GY, HY, IY, JY, KY, LY, MY, NY, OY, PY, QY, RY, SY, TY, UY, VY, WY, XY, YY, ZY, _Y, $Y, aZ, bZ, cZ, dZ, eZ, fZ, gZ, hZ, iZ, jZ, kZ, lZ, mZ, nZ, oZ, pZ, qZ, rZ, sZ, tZ, uZ, vZ, wZ, xZ, yZ, zZ, AZ, BZ, CZ, DZ, EZ, FZ, GZ, HZ, IZ, JZ, KZ, LZ, MZ, NZ, OZ, PZ, QZ, RZ, SZ, TZ, UZ, VZ, WZ, XZ, YZ, ZZ, _Z, $Z, a_, b_, c_, d_, e_, f_, g_, h_, i_, j_, k_, l_, m_, n_, o_, p_, q_, r_, s_, t_, u_, v_, w_, x_, y_, z_, A_, B_, C_, D_, E_, F_, G_, H_, I_, J_, K_, L_, M_, N_, O_, P_, Q_, R_, S_, T_, U_, V_, W_, X_, Y_, Z_, __, $_, a$, b$, c$, d$, e$, f$, g$, h$, i$, j$, k$, l$, m$, n$, o$, p$, q$, r$, s$, t$, u$, v$, w$, x$, y$, z$, A$, B$, pN, C$, D$, E$, F$, vN, G$, H$, I$, J$, K$, L$, M$, N$, O$, P$, Q$, R$, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU, GU];
	            var vb = [S$, T$, U$, V$, W$, yc, X$, Y$, Z$, _$, $$, a0, b0, c0, d0, e0, f0, g0, h0, i0, j0, k0, l0, m0, n0, o0, p0, q0, r0, s0, Xk, t0, u0, v0, w0, x0, y0, z0, A0, B0, UP, C0, D0, E0, F0, G0, H0, I0, J0, K0, L0, M0, N0, O0, P0, Q0, R0, S0, T0, U0, V0, W0, X0, Y0, Z0, _0, $0, a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1, l1, m1, n1, o1, p1, q1, r1, s1, t1, u1, v1, w1, x1, y1, z1, A1, B1, C1, D1, E1, F1, G1, H1, I1, J1, K1, L1, M1, N1, O1, P1, Q1, R1, S1, T1, U1, V1, W1, X1, Y1, Z1, _1, $1, a2, b2, c2, d2, e2, f2, g2, h2, i2, j2, k2, l2, m2, n2, o2, p2, q2, r2, s2, t2, u2, v2, w2, x2, y2, z2, A2, B2, C2, D2, E2, F2, G2, H2, I2, J2, K2, L2, M2, N2, O2, P2, Q2, R2, S2, T2, U2, V2, W2, X2, Y2, Z2, _2, $2, a3, b3, c3, d3, e3, f3, g3, h3, i3, j3, k3, l3, m3, n3, o3, p3, q3, r3, s3, RT, t3, u3, v3, w3, Wk, x3, y3, ac, z3, gc, A3, B3, C3, D3, E3, F3, G3, H3, I3, J3, K3, L3, M3, N3, O3, P3, Q3, R3, S3, T3, U3, V3, W3, X3, Y3, Z3, _3, pk, $3, a4, $k, b4, cl, c4, el, fl, d4, e4, f4, g4, h4, i4, j4, k4, l4, m4, n4, o4, p4, q4, r4, s4, t4, u4, v4, w4, x4, y4, z4, A4, B4, C4, D4, E4, F4, G4, H4, I4, J4, K4, L4, M4, N4, O4, P4, Q4, R4, S4, T4, U4, V4, W4, X4, Y4, uu, Z4, _4, $4, vu, a5, b5, c5, d5, e5, f5, g5, h5, i5, j5, k5, l5, m5, n5, o5, p5, q5, r5, s5, t5, u5, v5, w5, Kx, x5, y5, z5, A5, B5, C5, D5, E5, F5, G5, H5, I5, J5, K5, UB, L5, M5, N5, O5, P5, Q5, R5, S5, T5, U5, V5, W5, X5, Y5, Z5, _5, $5, a6, b6, c6, d6, e6, rC, f6, g6, h6, i6, j6, k6, l6, m6, n6, o6, p6, q6, r6, GM, s6, t6, u6, v6, w6, x6, y6, z6, A6, B6, C6, D6, E6, F6, G6, H6, I6, J6, K6, L6, M6, hT, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$, S$];
	            var wb = [N6, O6, P6, Q6, R6, S6, T6, U6, V6, Cc, W6, X6, Y6, Z6, _6, $6, a7, b7, c7, d7, e7, f7, g7, h7, i7, j7, k7, l7, m7, n7, o7, p7, q7, r7, s7, t7, u7, v7, w7, x7, y7, z7, A7, B7, YP, C7, D7, E7, F7, G7, H7, I7, J7, K7, L7, M7, N7, O7, P7, Q7, R7, S7, T7, U7, V7, W7, X7, Y7, Z7, _7, $7, a8, b8, c8, d8, e8, f8, g8, h8, i8, j8, k8, l8, m8, n8, o8, p8, q8, r8, s8, t8, u8, v8, w8, x8, y8, z8, A8, B8, C8, D8, E8, F8, G8, H8, I8, J8, K8, L8, M8, N8, O8, P8, Q8, R8, S8, T8, U8, V8, W8, X8, Y8, Z8, _8, $8, a9, b9, c9, d9, e9, f9, g9, h9, i9, j9, k9, l9, m9, n9, o9, p9, q9, r9, s9, t9, u9, v9, w9, x9, y9, z9, A9, B9, C9, D9, E9, F9, G9, H9, I9, J9, K9, L9, M9, N9, O9, P9, Q9, R9, S9, T9, U9, V9, W9, X9, Y9, Z9, _9, $9, aaa, baa, caa, daa, eaa, faa, gaa, haa, iaa, jaa, kaa, laa, maa, naa, oaa, paa, qaa, raa, saa, taa, uaa, vaa, waa, xaa, yaa, zaa, Aaa, Baa, Caa, Daa, Eaa, Faa, Gaa, Haa, Iaa, Jaa, Kaa, Laa, Maa, Naa, Oaa, Paa, Qaa, Raa, Saa, Taa, Uaa, Vaa, Waa, Xaa, Yaa, Zaa, _aa, $aa, aba, bba, cba, dba, eba, fba, gba, hba, iba, jba, kba, lba, mba, nba, oba, pba, qba, rba, sba, tba, uba, vba, wba, xba, yba, zba, Aba, Bba, Cba, Dba, Eba, Fba, Gba, Hba, Iba, Jba, Kba, Lba, Mba, Nba, Oba, Pba, Qba, Rba, Sba, Tba, Uba, Vba, Wba, Xba, Yba, Zba, _ba, $ba, aca, bca, cca, dca, eca, fca, gca, hca, ica, jca, kca, lca, mca, nca, oca, pca, qca, rca, sca, tca, uca, vca, wca, xca, yca, zca, Aca, Bca, Cca, Dca, Eca, Fca, Gca, Hca, Ica, Jca, Kca, Lca, Mca, Nca, Oca, Pca, Qca, Rca, Sca, Tca, Uca, Vca, Wca, YB, Xca, Yca, Zca, _ca, $ca, ada, bda, cda, dda, eda, fda, gda, hda, ida, jda, kda, lda, mda, nda, oda, pda, qda, rda, sda, tda, uda, vda, wda, xda, yda, zda, Ada, Bda, Cda, Dda, Eda, Fda, Gda, Hda, Ida, Jda, Kda, Lda, Mda, Nda, Oda, Pda, Qda, Rda, Sda, Tda, Uda, Vda, Wda, Xda, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6, N6];
	            var xb = [Yda, Zda, _da, $da, aea, bea, cea, dea, eea, fea, gea, Ec, hea, iea, jea, kea, lea, mea, nea, oea, pea, qea, rea, sea, tea, uea, vea, wea, xea, yea, zea, Aea, Bea, Cea, Dea, Eea, Fea, Gea, Hea, Iea, Jea, Kea, Lea, Mea, Nea, Oea, $P, Pea, Qea, Rea, Sea, Tea, Uea, Vea, Wea, Xea, Yea, Zea, _ea, $ea, afa, bfa, cfa, dfa, efa, ffa, gfa, hfa, ifa, jfa, kfa, lfa, mfa, nfa, ofa, pfa, qfa, rfa, sfa, tfa, ufa, vfa, wfa, xfa, yfa, zfa, Afa, Bfa, Cfa, Dfa, Efa, Ffa, Gfa, Hfa, Ifa, Jfa, Kfa, Lfa, Mfa, Nfa, Ofa, Pfa, Qfa, Rfa, Sfa, Tfa, Ufa, Vfa, Wfa, Xfa, Yfa, Zfa, _fa, $fa, aga, bga, cga, dga, ega, fga, gga, hga, iga, jga, kga, lga, mga, nga, oga, pga, qga, rga, sga, tga, uga, vga, wga, xga, yga, zga, Aga, Bga, Cga, Dga, Ega, Fga, Gga, Hga, Iga, Jga, Kga, Lga, Mga, Nga, Oga, Pga, Qga, Rga, Sga, Tga, Uga, Vga, Wga, Xga, Yga, Zga, _ga, $ga, aha, bha, cha, dha, eha, fha, gha, hha, iha, jha, kha, lha, mha, nha, oha, pha, qha, rha, sha, tha, uha, vha, wha, xha, yha, zha, Aha, Bha, Cha, Dha, Eha, Fha, Gha, Hha, Iha, Jha, Kha, Lha, Mha, Nha, Oha, Pha, Qha, Rha, Sha, Tha, Uha, Vha, Wha, Xha, Yha, Zha, _ha, $ha, aia, bia, cia, dia, eia, fia, sh, gk, gia, hia, iia, jia, kia, lia, mia, nia, oia, pia, qia, ria, sia, tia, uia, via, wia, xia, yia, zia, Aia, Bia, Cia, Dia, Eia, Fia, Gia, Hia, Iia, Jia, Kia, Lia, Mia, Nia, Oia, Pia, Qia, Ria, Sia, Tia, Uia, Via, Wia, Xia, Yia, Zia, _ia, $ia, aja, bja, cja, dja, eja, fja, gja, hja, ija, jja, kja, lja, mja, nja, oja, pja, qja, rja, sja, tja, uja, vja, wja, xja, yja, zja, Aja, Bja, Cja, Dja, Eja, Fja, Gja, Hja, Ija, Jja, Kja, Lja, Mja, Nja, Oja, Pja, Qja, Rja, Sja, Tja, Uja, Vja, Wja, Xja, Yja, Zja, _ja, $ja, aka, bka, cka, dka, eka, fka, _B, gka, hka, ika, jka, kka, lka, mka, nka, oka, pka, qka, rka, ska, tka, uka, vka, wka, xka, yka, zka, Aka, Bka, Cka, Dka, Eka, Fka, Gka, Hka, Ika, Jka, Kka, Lka, Mka, Nka, Oka, Pka, Qka, Rka, Ska, Tka, Uka, Vka, Wka, Xka, Yka, Zka, _ka, $ka, ala, bla, cla, dla, ela, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda, Yda];
	            var yb = [fla, gla, hla, ila, jla, kla, lla, mla, nla, ola, pla, qla, rla, sla, tla, ula, vla, wla, xla, yla, zla, Ala, Bla, Cla, Dla, Ela, Fla, Gla, Hla, Ila, Jla, Kla, Lla, Mla, Nla, Ola, Pla, Qla, Rla, Sla, Tla, Ula, Vla, Wla, Xla, Yla, Zla, _la, $la, ama, bma, cma, dma, ema, fma, gma, hma, ima, jma, kma, lma, mma, nma, oma, pma, qma, rma, sma, tma, uma, vma, wma, xma, yma, zma, Ama, Bma, Cma, Dma, Ema, Fma, Gma, Hma, Ima, Jma, Kma, Lma, Mma, Nma, Oma, Pma, Qma, Rma, Sma, Tma, Uma, Vma, Wma, Xma, Yma, Zma, _ma, $ma, ana, bna, cna, dna, ena, fna, gna, hna, ina, jna, kna, lna, mna, nna, ona, pna, qna, rna, sna, tna, una, vna, wna, xna, yna, zna, Ana, Bna, Cna, Dna, Ena, Fna, Gna, Hna, Ina, Jna, Kna, Lna, Mna, Nna, Ona, Pna, Qna, Rna, Sna, Tna, Una, Vna, Wna, Xna, Yna, Zna, _na, $na, aoa, boa, coa, doa, eoa, foa, goa, hoa, ioa, joa, koa, loa, moa, noa, ooa, poa, qoa, roa, soa, toa, uoa, voa, woa, xoa, yoa, zoa, Aoa, Boa, Coa, Doa, Eoa, Foa, Goa, Hoa, Ioa, Joa, Koa, Loa, Moa, Noa, Ooa, Poa, Qoa, Roa, Soa, Toa, Uoa, Voa, Woa, Xoa, Yoa, Zoa, _oa, $oa, apa, bpa, cpa, dpa, epa, fpa, gpa, hpa, ipa, jpa, kpa, lpa, mpa, npa, opa, ppa, mk, qpa, rpa, spa, tpa, upa, vpa, wpa, xpa, ypa, zpa, Apa, Bpa, Cpa, Dpa, Epa, Fpa, Gpa, Hpa, Ipa, Jpa, Kpa, Lpa, Mpa, Npa, Opa, Ppa, Qpa, Rpa, Spa, Tpa, Upa, Vpa, Wpa, Xpa, Ypa, Zpa, _pa, $pa, aqa, bqa, cqa, dqa, eqa, fqa, gqa, hqa, iqa, jqa, kqa, lqa, mqa, nqa, oqa, pqa, qqa, rqa, sqa, tqa, uqa, vqa, wqa, xqa, yqa, zqa, Aqa, Bqa, Cqa, Dqa, Eqa, Fqa, Gqa, Hqa, Iqa, Jqa, Kqa, Lqa, Mqa, Nqa, Oqa, Pqa, Qqa, Rqa, Sqa, Tqa, Uqa, Vqa, Wqa, Xqa, Yqa, Zqa, _qa, $qa, ara, bra, cra, dra, era, fra, gra, hra, ira, jra, kra, lra, mra, nra, ora, pra, qra, rra, sra, tra, ura, vra, wra, xra, yra, zra, Ara, Bra, Cra, Dra, Era, Fra, Gra, Hra, Ira, Jra, Kra, Lra, Mra, Nra, Ora, Pra, Qra, Rra, Sra, Tra, Ura, Vra, Wra, Xra, Yra, Zra, _ra, $ra, asa, bsa, csa, dsa, esa, fsa, gsa, hsa, isa, jsa, ksa, lsa, msa, nsa, osa, psa, qsa, rsa, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla, fla];
	            var zb = [ssa, tsa, usa, vsa, wsa, xsa, ysa, zsa, Asa, Bsa, Csa, Dsa, Esa, Gc, Hc, Fsa, Gsa, Hsa, Isa, Jsa, Ksa, Lsa, Msa, Nsa, Osa, Psa, Qsa, Rsa, Ssa, Tsa, Usa, jT, Vsa, Wsa, Xsa, Ysa, Zsa, _sa, $sa, ata, bta, cta, dta, eta, fta, gta, hta, ita, bQ, cQ, jta, kta, lta, mta, nta, ota, pta, qta, rta, sta, tta, uta, vta, wta, xta, yta, zta, Ata, Bta, Cta, Dta, Eta, Fta, Gta, Hta, Ita, Jta, Kta, Lta, Mta, Nta, Ota, Pta, Qta, Rta, Sta, Tta, Uta, Vta, Wta, Xta, Yta, Zta, _ta, $ta, aua, bua, cua, dua, eua, fua, gua, hua, iua, jua, kua, lua, mua, nua, oua, pua, qua, rua, sua, tua, uua, vua, wua, xua, yua, zua, Aua, Bua, Cua, Dua, Eua, Fua, Gua, Hua, Iua, Jua, Kua, Lua, Mua, Nua, Oua, Pua, Qua, Rua, Sua, Tua, Uua, Vua, Wua, Xua, Yua, Zua, _ua, $ua, ava, bva, cva, dva, eva, fva, gva, hva, iva, jva, kva, lva, mva, nva, ova, pva, qva, rva, sva, tva, uva, vva, wva, xva, yva, zva, Ava, Bva, Cva, Dva, Eva, Fva, Gva, Hva, Iva, Jva, Kva, Lva, Mva, Nva, Ova, Pva, Qva, Rva, Sva, Tva, Vb, Uva, Vva, Wva, Xva, _b, $b, Yva, Zva, _va, hc, $va, awa, bwa, cwa, dwa, ewa, fwa, gwa, hwa, iwa, jwa, kwa, lwa, mwa, nwa, owa, pwa, qwa, rwa, swa, tg, twa, uwa, vwa, wwa, xwa, ywa, zwa, Awa, Bwa, Cwa, Dwa, Ewa, Fwa, Gwa, Hwa, nn, Iwa, sn, Jwa, xn, Kwa, Lwa, An, Bn, Mwa, Dn, Nwa, Owa, Pwa, Qwa, Rwa, Swa, Twa, Qq, Uwa, Vwa, Wwa, Xwa, Ywa, Zwa, _wa, $wa, axa, bxa, cxa, dxa, exa, fxa, gxa, hxa, ixa, jxa, kxa, lxa, mxa, nxa, oxa, pxa, qxa, rxa, sxa, txa, uxa, vxa, wxa, xxa, yxa, zxa, Axa, Bxa, Cxa, Dxa, Exa, Fxa, Gxa, Hxa, Ixa, Jxa, Kxa, Lxa, Mxa, Nxa, Oxa, Pxa, Qxa, Rxa, Sxa, Txa, Mw, Yw, Uxa, Vxa, Wxa, Xxa, Yxa, qB, Zxa, _xa, $xa, aya, bya, cya, dya, eya, fya, gya, hya, iya, jya, kya, lya, mya, nya, aC, bC, oya, pya, qya, rya, sya, tya, uya, vya, wya, xya, yya, zya, Aya, Bya, uC, Cya, Dya, Eya, VA, Fya, Gya, Hya, Iya, Jya, Kya, Lya, Mya, Nya, Oya, UM, Pya, Qya, Rya, Sya, Tya, Uya, Vya, Wya, Xya, Yya, Zya, _ya, $ya, aza, bza, cza, dza, eza, fza, gza, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa, ssa];
	            var Ab = [hza, iza, jza, kza, lza, mza, nza, oza, pza, qza, rza, sza, Fc, tza, uza, vza, Xc, Ic, wza, xza, yza, Mc, zza, Aza, Bza, Cza, Dza, Eza, Fza, Gza, Hza, Iza, Jza, Kza, Lza, Mza, Nza, Oza, Pza, Qza, Rza, Sza, Tza, Uza, Vza, Wza, Xza, aQ, Yza, Zza, _za, eQ, hQ, $za, aAa, lQ, bAa, cAa, dAa, eAa, fAa, gAa, hAa, iAa, jAa, kAa, lAa, mAa, nAa, oAa, pAa, qAa, rAa, sAa, tAa, uAa, vAa, wAa, xAa, yAa, zAa, AAa, BAa, CAa, DAa, EAa, FAa, GAa, HAa, IAa, JAa, KAa, LAa, MAa, NAa, OAa, PAa, QAa, RAa, SAa, TAa, UAa, VAa, WAa, XAa, YAa, ZAa, _Aa, $Aa, aBa, bBa, cBa, dBa, eBa, fBa, gBa, hBa, iBa, jBa, kBa, lBa, mBa, nBa, oBa, pBa, qBa, rBa, sBa, tBa, uBa, vBa, wBa, xBa, yBa, zBa, ABa, BBa, CBa, DBa, EBa, FBa, GBa, HBa, IBa, JBa, KBa, LBa, MBa, NBa, OBa, PBa, QBa, RBa, SBa, TBa, UBa, VBa, WBa, XBa, YBa, ZBa, _Ba, $Ba, aCa, bCa, cCa, dCa, eCa, fCa, gCa, hCa, iCa, jCa, kCa, lCa, mCa, nCa, oCa, pCa, qCa, rCa, sCa, tCa, uCa, vCa, wCa, xCa, yCa, zCa, ACa, BCa, CCa, DCa, ECa, FCa, GCa, HCa, ICa, JCa, KCa, LCa, MCa, NCa, OCa, PCa, QCa, RCa, SCa, TCa, UCa, VCa, md, WCa, XCa, YCa, ZCa, _Ca, $Ca, aDa, bDa, cDa, dDa, eDa, fDa, gDa, hDa, iDa, jDa, kDa, lDa, mDa, nDa, oDa, pDa, qDa, rDa, sDa, tDa, uDa, vDa, wDa, xDa, yDa, zDa, ADa, BDa, CDa, DDa, zn, EDa, FDa, GDa, HDa, IDa, JDa, KDa, LDa, MDa, NDa, tq, ODa, Bs, Is, ns, ts, us, os, Es, Hs, ls, Fs, ps, Cs, nt, qs, zs, Tr, ms, Js, rs, ss, vs, ws, xs, ys, Gs, Ds, As, ot, PDa, QDa, RDa, SDa, TDa, UDa, VDa, WDa, XDa, YDa, ZDa, _Da, $Da, aEa, bEa, cEa, dEa, jv, pv, qv, rv, sv, tv, uv, vv, eEa, fEa, gEa, hEa, iEa, jEa, kEa, lEa, mEa, nEa, oEa, pEa, qEa, PB, rEa, sEa, tEa, uEa, vEa, wEa, xEa, yEa, zEa, AEa, BEa, $B, CEa, DEa, EEa, dC, FEa, GEa, HEa, IEa, JEa, KEa, LEa, MEa, mC, NEa, OEa, PEa, QEa, AD, REa, uF, SEa, TEa, xM, UEa, VEa, WEa, XEa, YEa, ZEa, _Ea, FM, $Ea, aFa, bFa, cFa, dFa, rN, eFa, fFa, gFa, wN, hFa, iFa, jFa, kFa, lFa, mFa, nFa, oFa, pFa, qFa, rFa, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza, hza];
	            var Bb = [sFa, tFa, uFa, vFa, wFa, xFa, yFa, zFa, AFa, BFa, CFa, DFa, EFa, FFa, GFa, HFa, IFa, JFa, KFa, LFa, MFa, NFa, OFa, PFa, QFa, RFa, SFa, TFa, UFa, VFa, WFa, XFa, YFa, ZFa, _Fa, $Fa, aGa, bGa, cGa, dGa, eGa, fGa, gGa, hGa, iGa, jGa, kGa, lGa, mGa, nGa, oGa, pGa, qGa, rGa, sGa, tGa, uGa, vGa, wGa, xGa, yGa, zGa, AGa, BGa, CGa, DGa, EGa, FGa, GGa, HGa, IGa, JGa, KGa, LGa, MGa, NGa, OGa, PGa, QGa, RGa, SGa, TGa, UGa, VGa, WGa, XGa, YGa, ZGa, _Ga, $Ga, aHa, bHa, cHa, dHa, eHa, fHa, gHa, hHa, iHa, jHa, kHa, lHa, mHa, nHa, oHa, pHa, qHa, rHa, sHa, tHa, uHa, vHa, wHa, xHa, yHa, zHa, AHa, BHa, CHa, DHa, EHa, FHa, GHa, HHa, IHa, JHa, KHa, LHa, MHa, NHa, OHa, PHa, QHa, RHa, SHa, THa, UHa, VHa, WHa, XHa, YHa, ZHa, _Ha, $Ha, aIa, bIa, cIa, dIa, eIa, fIa, gIa, hIa, iIa, jIa, kIa, lIa, mIa, nIa, oIa, pIa, qIa, rIa, sIa, tIa, uIa, vIa, wIa, xIa, yIa, zIa, AIa, BIa, CIa, DIa, EIa, FIa, GIa, HIa, IIa, JIa, KIa, LIa, MIa, NIa, OIa, PIa, QIa, RIa, SIa, TIa, UIa, VIa, WIa, XIa, YIa, ZIa, _Ia, $Ia, aJa, bJa, cJa, dJa, eJa, fJa, gJa, hJa, iJa, jJa, kJa, lJa, mJa, nJa, oJa, pJa, qJa, rJa, sJa, tJa, uJa, vJa, wJa, xJa, yJa, zJa, AJa, BJa, CJa, DJa, EJa, FJa, GJa, HJa, IJa, JJa, KJa, LJa, MJa, NJa, OJa, PJa, QJa, RJa, SJa, TJa, UJa, VJa, WJa, XJa, YJa, ZJa, _Ja, $Ja, aKa, bKa, cKa, dKa, eKa, fKa, gKa, hKa, iKa, jKa, kKa, lKa, mKa, nKa, oKa, pKa, qKa, rKa, sKa, tKa, uKa, vKa, wKa, xKa, yKa, zKa, AKa, BKa, CKa, DKa, EKa, FKa, GKa, HKa, IKa, JKa, KKa, LKa, MKa, NKa, OKa, PKa, QKa, RKa, SKa, TKa, UKa, VKa, WKa, XKa, YKa, ZKa, _Ka, $Ka, aLa, bLa, cLa, dLa, eLa, fLa, gLa, hLa, iLa, jLa, kLa, lLa, mLa, nLa, oLa, pLa, qLa, rLa, sLa, tLa, uLa, vLa, wLa, xLa, yLa, zLa, ALa, BLa, CLa, DLa, ELa, FLa, GLa, HLa, ILa, JLa, KLa, LLa, MLa, NLa, OLa, PLa, QLa, RLa, SLa, TLa, ULa, VLa, WLa, XLa, YLa, ZLa, _La, $La, aMa, bMa, cMa, dMa, eMa, fMa, gMa, hMa, iMa, jMa, kMa, lMa, mMa, nMa, oMa, qN, pMa, qMa, rMa, sMa, tMa, uMa, vMa, wMa, xMa, yMa, zMa, AMa, BMa, CMa, DMa, EMa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa, sFa];
	            var Cb = [FMa, GMa, vc, wc, xc, HMa, IMa, JMa, KMa, LMa, MMa, NMa, OMa, PMa, QMa, RMa, SMa, TMa, UMa, VMa, WMa, XMa, YMa, ZMa, _Ma, $Ma, aNa, bNa, cNa, dNa, eNa, fNa, iT, gNa, my, hNa, iNa, PP, QP, RP, jNa, kNa, lNa, mNa, nNa, oNa, pNa, qNa, rNa, sNa, tNa, uNa, vNa, wNa, xNa, yNa, zNa, ANa, BNa, CNa, DNa, LP, MP, NP, OP, ENa, NI, OI, PI, QI, RI, SI, TI, UI, VI, WI, XI, YI, ZI, _I, $I, aJ, bJ, cJ, dJ, eJ, fJ, gJ, hJ, iJ, jJ, kJ, lJ, mJ, nJ, oJ, pJ, qJ, rJ, sJ, tJ, uJ, vJ, wJ, xJ, yJ, zJ, AJ, BJ, CJ, DJ, EJ, FJ, GJ, HJ, IJ, JJ, KJ, LJ, MJ, NJ, OJ, PJ, QJ, RJ, SJ, TJ, UJ, VJ, WJ, XJ, YJ, ZJ, _J, $J, aK, bK, cK, dK, eK, fK, gK, hK, iK, jK, kK, lK, mK, nK, oK, pK, qK, rK, sK, tK, uK, vK, wK, xK, yK, zK, AK, BK, CK, DK, EK, FK, GK, HK, IK, JK, KK, LK, MK, NK, OK, PK, QK, RK, SK, TK, UK, VK, WK, XK, YK, ZK, _K, $K, aL, bL, cL, dL, eL, FNa, GNa, Wb, HNa, Yb, INa, JNa, KNa, LNa, MNa, NNa, ONa, PNa, QNa, RNa, SNa, nc, TNa, nd, UNa, VNa, WNa, XNa, YNa, ZNa, _Na, $Na, aOa, bOa, cOa, dOa, eOa, fOa, gOa, hOa, iOa, nk, ok, jOa, qk, _k, kOa, bl, lOa, dl, mOa, nOa, oOa, pOa, on, qOa, vn, rOa, yn, sOa, tOa, uOa, vOa, wOa, xOa, yOa, zOa, AOa, BOa, COa, DOa, EOa, FOa, GOa, HOa, IOa, JOa, KOa, LOa, MOa, NOa, OOa, POa, QOa, ROa, SOa, TOa, UOa, VOa, WOa, XOa, YOa, ZOa, _Oa, $Oa, aPa, bPa, cPa, dPa, ePa, fPa, gPa, hPa, iPa, jPa, kPa, lPa, mPa, nPa, oPa, pPa, qPa, rPa, sPa, tPa, uPa, vPa, wPa, xPa, yPa, zPa, APa, BPa, CPa, DPa, EPa, FPa, GPa, HPa, IPa, JPa, KPa, LPa, MPa, NPa, OPa, PPa, QPa, RPa, SPa, RB, SB, TB, TPa, UPa, VPa, WPa, XPa, YPa, ZPa, _Pa, $Pa, aQa, bQa, cQa, dQa, eQa, fQa, gQa, hQa, iQa, jQa, kQa, lQa, mQa, nQa, oQa, pQa, qQa, rQa, sQa, tQa, uQa, vQa, wQa, xQa, yQa, zQa, AQa, BQa, CQa, DQa, EQa, FQa, GQa, HQa, IQa, JQa, KQa, LQa, MQa, NQa, OQa, PQa, QQa, RQa, SQa, TQa, UQa, VQa, WQa, XQa, YQa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa, FMa];
	            var Db = [ZQa, _Qa, $Qa, aRa, bRa, cRa, dRa, eRa, fRa, gRa, hRa, iRa, jRa, kRa, lRa, Wc, mRa, nRa, Jc, Kc, Lc, oRa, Nc, Oc, Pc, pRa, Rc, qRa, rRa, sRa, tRa, uRa, vRa, wRa, xRa, Td, yRa, zRa, ARa, BRa, CRa, DRa, ERa, FRa, GRa, HRa, IRa, JRa, KRa, LRa, dQ, MRa, NRa, iQ, kQ, ORa, $d, _d, PRa, mQ, QRa, RRa, SRa, TRa, URa, jQ, VRa, WRa, XRa, YRa, ZRa, _Ra, $Ra, aSa, bSa, cSa, dSa, eSa, fSa, gSa, hSa, iSa, jSa, kSa, lSa, mSa, nSa, oSa, pSa, qSa, rSa, sSa, tSa, uSa, vSa, wSa, xSa, ySa, zSa, ASa, BSa, CSa, DSa, ESa, FSa, GSa, HSa, ISa, JSa, KSa, LSa, MSa, NSa, OSa, PSa, QSa, RSa, SSa, TSa, USa, VSa, WSa, XSa, YSa, ZSa, _Sa, $Sa, aTa, bTa, cTa, dTa, eTa, fTa, gTa, hTa, iTa, jTa, kTa, lTa, mTa, nTa, oTa, pTa, qTa, rTa, sTa, tTa, uTa, vTa, wTa, xTa, yTa, zTa, ATa, BTa, CTa, DTa, ETa, FTa, GTa, HTa, ITa, JTa, KTa, LTa, MTa, NTa, OTa, PTa, QTa, RTa, STa, TTa, UTa, VTa, WTa, XTa, YTa, ZTa, _Ta, $Ta, aUa, bUa, cUa, dUa, eUa, fUa, gUa, hUa, iUa, jUa, kUa, lUa, mUa, nUa, oUa, pUa, qUa, rUa, sUa, tUa, uUa, vUa, wUa, xUa, yUa, ic, jc, kc, lc, zUa, AUa, BUa, CUa, DUa, EUa, FUa, GUa, HUa, IUa, JUa, KUa, LUa, MUa, ae, be, NUa, OUa, PUa, QUa, RUa, SUa, TUa, UUa, VUa, WUa, XUa, YUa, ZUa, _Ua, $Ua, aVa, bVa, cVa, dVa, eVa, fVa, gVa, hVa, iVa, jVa, kVa, lVa, In, Rn, Sn, Tn, Un, mVa, nVa, oVa, pVa, qVa, rVa, sVa, tVa, uVa, vVa, wVa, xVa, yVa, zVa, AVa, BVa, CVa, DVa, EVa, FVa, GVa, HVa, IVa, JVa, KVa, LVa, MVa, NVa, OVa, PVa, QVa, RVa, SVa, TVa, UVa, VVa, WVa, XVa, YVa, ZVa, _Va, $Va, aWa, bWa, cWa, dWa, eWa, fWa, gWa, hWa, iWa, jWa, kWa, lWa, mWa, nWa, tw, oWa, pWa, qWa, rWa, sWa, tWa, uWa, vWa, wWa, xWa, NB, OB, yWa, zWa, AWa, BWa, CWa, DWa, EWa, FWa, GWa, HWa, IWa, JWa, KWa, LWa, MWa, cC, NWa, eC, fC, gC, OWa, PWa, jC, kC, lC, QWa, RWa, SWa, TWa, UWa, VWa, WWa, XWa, YWa, wM, ZWa, _Wa, $Wa, AM, BM, DM, EM, aXa, bXa, cXa, dXa, eXa, fXa, gXa, hXa, iXa, jXa, kXa, lXa, CN, mXa, vO, wO, nXa, sP, oXa, pXa, qXa, rXa, sXa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa, ZQa];
	            var Eb = [tXa, uXa, vXa, wXa, xXa, yXa, zXa, AXa, BXa, CXa, DXa, EXa, FXa, GXa, HXa, IXa, JXa, KXa, LXa, MXa, NXa, OXa, PXa, QXa, RXa, SXa, TXa, UXa, Tc, VXa, WXa, XXa, YXa, ZXa, _Xa, $Xa, aYa, bYa, cYa, dYa, eYa, fYa, gYa, hYa, iYa, jYa, kYa, lYa, mYa, nYa, oYa, pYa, qYa, rYa, sYa, tYa, uYa, vYa, wYa, xYa, yYa, zYa, AYa, BYa, CYa, DYa, EYa, FYa, GYa, HYa, IYa, JYa, KYa, LYa, MYa, NYa, OYa, PYa, QYa, RYa, SYa, TYa, UYa, VYa, WYa, XYa, YYa, ZYa, _Ya, $Ya, aZa, bZa, cZa, dZa, eZa, fZa, gZa, hZa, iZa, jZa, kZa, lZa, mZa, nZa, oZa, pZa, qZa, rZa, sZa, tZa, uZa, vZa, wZa, xZa, yZa, zZa, AZa, BZa, CZa, DZa, EZa, FZa, GZa, HZa, IZa, JZa, KZa, LZa, MZa, NZa, OZa, PZa, QZa, RZa, SZa, TZa, UZa, VZa, WZa, XZa, YZa, ZZa, _Za, $Za, a_a, b_a, c_a, d_a, e_a, f_a, g_a, h_a, i_a, j_a, k_a, l_a, m_a, n_a, o_a, p_a, q_a, r_a, s_a, t_a, u_a, v_a, w_a, x_a, y_a, z_a, A_a, B_a, C_a, D_a, E_a, F_a, G_a, H_a, I_a, J_a, K_a, L_a, M_a, N_a, O_a, P_a, Q_a, R_a, S_a, T_a, U_a, V_a, W_a, X_a, Y_a, Z_a, __a, $_a, a$a, b$a, c$a, d$a, e$a, f$a, g$a, h$a, i$a, j$a, k$a, l$a, m$a, n$a, o$a, p$a, q$a, r$a, s$a, t$a, u$a, v$a, w$a, x$a, y$a, z$a, A$a, B$a, C$a, D$a, E$a, F$a, G$a, H$a, I$a, J$a, K$a, L$a, M$a, N$a, O$a, P$a, Q$a, R$a, S$a, T$a, U$a, V$a, W$a, X$a, Y$a, Z$a, _$a, $$a, a0a, b0a, c0a, d0a, e0a, f0a, g0a, h0a, i0a, j0a, k0a, l0a, m0a, n0a, o0a, p0a, q0a, r0a, s0a, t0a, u0a, v0a, w0a, x0a, y0a, z0a, A0a, B0a, C0a, D0a, E0a, F0a, G0a, H0a, I0a, J0a, K0a, L0a, M0a, N0a, O0a, P0a, Q0a, R0a, S0a, T0a, U0a, V0a, W0a, X0a, Y0a, Z0a, _0a, $0a, a1a, b1a, c1a, d1a, e1a, f1a, g1a, h1a, i1a, j1a, k1a, l1a, m1a, n1a, o1a, p1a, q1a, LB, r1a, s1a, t1a, u1a, v1a, w1a, x1a, y1a, z1a, A1a, B1a, C1a, D1a, E1a, F1a, G1a, H1a, I1a, J1a, K1a, L1a, M1a, N1a, O1a, P1a, Q1a, R1a, S1a, T1a, nC, U1a, V1a, W1a, X1a, Y1a, Z1a, _1a, $1a, a2a, yM, b2a, c2a, d2a, e2a, f2a, g2a, h2a, i2a, j2a, k2a, l2a, m2a, n2a, o2a, p2a, q2a, r2a, s2a, t2a, u2a, v2a, w2a, x2a, fQ, y2a, z2a, A2a, B2a, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa, tXa];
	            var Fb = [C2a, D2a, E2a, F2a, G2a, H2a, I2a, J2a, K2a, L2a, M2a, N2a, O2a, P2a, Q2a, R2a, S2a, T2a, U2a, V2a, W2a, X2a, Y2a, Z2a, _2a, $2a, a3a, b3a, c3a, d3a, e3a, f3a, g3a, h3a, i3a, j3a, k3a, l3a, m3a, n3a, o3a, p3a, q3a, r3a, s3a, t3a, u3a, v3a, w3a, x3a, y3a, z3a, A3a, B3a, C3a, D3a, E3a, F3a, G3a, H3a, I3a, J3a, K3a, L3a, M3a, N3a, O3a, P3a, Q3a, R3a, S3a, T3a, U3a, V3a, W3a, X3a, Y3a, Z3a, _3a, $3a, a4a, b4a, c4a, d4a, e4a, f4a, g4a, h4a, i4a, j4a, k4a, l4a, m4a, n4a, o4a, p4a, q4a, r4a, s4a, t4a, u4a, v4a, w4a, x4a, y4a, z4a, A4a, B4a, C4a, D4a, E4a, F4a, G4a, H4a, I4a, J4a, K4a, L4a, M4a, N4a, O4a, P4a, Q4a, R4a, S4a, T4a, U4a, V4a, W4a, X4a, Y4a, Z4a, _4a, $4a, a5a, b5a, c5a, d5a, e5a, f5a, g5a, h5a, i5a, j5a, k5a, l5a, m5a, n5a, o5a, p5a, q5a, r5a, s5a, t5a, u5a, v5a, w5a, x5a, y5a, z5a, A5a, B5a, C5a, D5a, E5a, F5a, G5a, H5a, I5a, J5a, K5a, L5a, M5a, N5a, O5a, P5a, Q5a, R5a, S5a, T5a, U5a, V5a, W5a, X5a, Y5a, Z5a, _5a, $5a, a6a, b6a, c6a, d6a, e6a, f6a, g6a, h6a, i6a, j6a, k6a, l6a, m6a, n6a, o6a, p6a, q6a, r6a, s6a, t6a, u6a, v6a, w6a, x6a, y6a, Kd, Ld, Md, Nd, Od, Pd, qd, rd, Qd, Rd, fo, z6a, A6a, B6a, C6a, D6a, E6a, F6a, G6a, H6a, I6a, J6a, K6a, L6a, M6a, N6a, O6a, P6a, gl, Q6a, R6a, S6a, T6a, U6a, V6a, W6a, X6a, Y6a, Z6a, _6a, $6a, a7a, b7a, c7a, d7a, e7a, f7a, g7a, h7a, i7a, j7a, k7a, l7a, m7a, n7a, o7a, p7a, q7a, r7a, s7a, t7a, u7a, v7a, w7a, x7a, y7a, z7a, A7a, B7a, C7a, D7a, E7a, F7a, G7a, H7a, I7a, J7a, K7a, L7a, M7a, N7a, O7a, P7a, Q7a, R7a, S7a, T7a, U7a, V7a, W7a, X7a, Y7a, Z7a, _7a, $7a, a8a, b8a, c8a, d8a, e8a, f8a, g8a, h8a, i8a, j8a, k8a, l8a, m8a, n8a, o8a, p8a, q8a, r8a, s8a, t8a, u8a, v8a, w8a, x8a, y8a, z8a, A8a, B8a, C8a, D8a, E8a, F8a, G8a, H8a, I8a, J8a, K8a, L8a, M8a, N8a, O8a, P8a, Q8a, R8a, S8a, T8a, U8a, V8a, W8a, X8a, Y8a, Z8a, _8a, $8a, a9a, b9a, c9a, d9a, e9a, f9a, g9a, h9a, i9a, j9a, k9a, l9a, m9a, n9a, o9a, p9a, q9a, r9a, s9a, t9a, u9a, v9a, w9a, x9a, y9a, z9a, A9a, WR, B9a, C9a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a, C2a];
	            var Gb = [D9a, E9a, F9a, G9a, H9a, I9a, J9a, Ac, K9a, L9a, M9a, N9a, O9a, P9a, Q9a, R9a, S9a, T9a, U9a, V9a, W9a, X9a, Y9a, Z9a, _9a, $9a, aab, bab, cab, dab, eab, fab, gab, hab, iab, jab, kab, lab, mab, nab, oab, pab, XP, qab, rab, sab, tab, uab, vab, wab, xab, yab, zab, Aab, Bab, Cab, Dab, Eab, Fab, Gab, Hab, Iab, Jab, Kab, Lab, Mab, Nab, Oab, Pab, Qab, Rab, Sab, Tab, Uab, Vab, Wab, Xab, Yab, Zab, _ab, $ab, abb, bbb, cbb, dbb, ebb, fbb, gbb, hbb, ibb, jbb, kbb, lbb, mbb, nbb, obb, pbb, qbb, rbb, sbb, tbb, ubb, vbb, wbb, xbb, ybb, zbb, Abb, Bbb, Cbb, Dbb, Ebb, Fbb, Gbb, Hbb, Ibb, Jbb, Kbb, Lbb, Mbb, Nbb, Obb, Pbb, Qbb, Rbb, Sbb, Tbb, Ubb, Vbb, Wbb, Xbb, Ybb, Zbb, _bb, $bb, acb, bcb, ccb, dcb, ecb, fcb, gcb, hcb, icb, jcb, kcb, lcb, mcb, ncb, ocb, pcb, qcb, rcb, scb, tcb, ucb, vcb, wcb, xcb, ycb, zcb, Acb, Bcb, Ccb, Dcb, Ecb, Fcb, Gcb, Hcb, Icb, Jcb, Kcb, Lcb, Mcb, Ncb, Ocb, Pcb, Qcb, Rcb, Scb, Tcb, Ucb, Vcb, Wcb, Xcb, Ycb, Zcb, _cb, $cb, adb, bdb, cdb, ddb, edb, fdb, gdb, hdb, idb, jdb, kdb, ldb, mdb, ndb, odb, pdb, qdb, rdb, sdb, tdb, udb, vdb, wdb, xdb, ydb, zdb, Adb, Bdb, Cdb, Ddb, Edb, Fdb, Gdb, Hdb, Idb, Jdb, Kdb, Ldb, Mdb, Ndb, Odb, Pdb, Qdb, Rdb, Sdb, Tdb, Udb, Vdb, Wdb, Xdb, Ydb, Zdb, _db, $db, aeb, beb, ceb, deb, eeb, feb, geb, heb, ieb, jeb, keb, leb, meb, neb, oeb, peb, qeb, reb, seb, teb, ueb, veb, web, xeb, yeb, zeb, Aeb, Beb, Ceb, Deb, Eeb, Feb, Geb, Heb, Ieb, Jeb, Keb, Leb, Meb, Neb, Oeb, Peb, Qeb, Reb, Seb, Teb, Ueb, Veb, Web, Xeb, Yeb, Zeb, _eb, $eb, afb, bfb, cfb, dfb, efb, ffb, gfb, hfb, ifb, jfb, kfb, lfb, mfb, nfb, ofb, pfb, qfb, rfb, sfb, tfb, ufb, vfb, wfb, xfb, yfb, zfb, Afb, Bfb, Cfb, Dfb, Efb, Ffb, Gfb, Hfb, Ifb, Jfb, Kfb, WB, Lfb, Mfb, Nfb, Ofb, Pfb, Qfb, Rfb, Sfb, Tfb, Ufb, Vfb, Wfb, Xfb, Yfb, Zfb, _fb, $fb, agb, bgb, cgb, dgb, egb, fgb, ggb, hgb, igb, jgb, kgb, lgb, mgb, ngb, ogb, pgb, qgb, rgb, sgb, tgb, ugb, vgb, wgb, xgb, ygb, zgb, Agb, Bgb, Cgb, Dgb, Egb, Fgb, Ggb, Hgb, Igb, Jgb, Kgb, Lgb, Mgb, Ngb, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a, D9a];
	            var Hb = [Ogb, Pgb, Qgb, Rgb, Sgb, Tgb, zc, Ugb, Vgb, Wgb, Xgb, Ygb, Zgb, _gb, $gb, ahb, bhb, chb, dhb, ehb, fhb, ghb, hhb, ihb, jhb, Qc, khb, lhb, mhb, nhb, ohb, phb, qhb, kT, rhb, shb, thb, uhb, vhb, whb, xhb, VP, yhb, zhb, Ahb, Bhb, Chb, Dhb, Ehb, Fhb, Ghb, Hhb, Ihb, Jhb, Khb, Lhb, Mhb, Nhb, WP, Ohb, Phb, Qhb, Rhb, Shb, Thb, Uhb, Vhb, Whb, Xhb, Yhb, Zhb, _hb, $hb, aib, bib, cib, dib, eib, fib, gib, hib, iib, jib, kib, lib, mib, nib, oib, pib, qib, rib, sib, tib, uib, vib, wib, xib, yib, zib, Aib, Bib, Cib, Dib, Eib, Fib, Gib, Hib, Iib, Jib, Kib, Lib, Mib, Nib, Oib, Pib, Qib, Rib, Sib, Tib, Uib, Vib, Wib, Xib, Yib, Zib, _ib, $ib, ajb, bjb, cjb, djb, ejb, fjb, gjb, hjb, ijb, jjb, kjb, ljb, mjb, njb, ojb, pjb, qjb, rjb, sjb, tjb, ujb, vjb, wjb, xjb, yjb, zjb, Ajb, Bjb, Cjb, Djb, Ejb, Fjb, Gjb, Hjb, Ijb, Jjb, Kjb, Ljb, Mjb, Njb, Ojb, Pjb, Qjb, Rjb, Sjb, Tjb, Ujb, Vjb, Wjb, Xjb, Yjb, Zjb, _jb, $jb, akb, bkb, ckb, dkb, ekb, fkb, gkb, hkb, ikb, jkb, kkb, lkb, mkb, nkb, okb, pkb, Xb, qkb, rkb, skb, tkb, ukb, vkb, wkb, xkb, ykb, zkb, Akb, Bkb, Ckb, Dkb, Ekb, Fkb, Gkb, Hkb, Ikb, Jkb, Kkb, Lkb, Mkb, Nkb, Okb, Pkb, Qkb, Rkb, Skb, Tkb, Ukb, Vkb, Wkb, Xkb, Ykb, Zkb, _kb, $kb, alb, blb, clb, dlb, elb, flb, glb, hlb, ilb, jlb, klb, llb, mlb, nlb, olb, Cn, plb, qlb, rlb, slb, tlb, ulb, _n, vlb, wlb, xlb, ylb, zlb, Alb, Blb, Clb, Dlb, Elb, Flb, Glb, Hlb, Ilb, Jlb, Klb, Llb, Mlb, Nlb, Olb, Plb, Qlb, Rlb, Slb, Tlb, Ulb, Vlb, Wlb, Xlb, Ylb, Zlb, ds, es, js, _lb, wu, $r, as, bs, hs, fs, is, cs, xu, gs, _r, dr, $lb, amb, bmb, cmb, dmb, emb, fmb, gmb, hmb, imb, jmb, kmb, $x, dy, fy, jy, lmb, mmb, nmb, omb, pmb, qmb, rmb, smb, tmb, umb, vmb, VB, wmb, xmb, ymb, zmb, Amb, Bmb, Cmb, Dmb, Emb, Fmb, Gmb, Hmb, Imb, hC, Jmb, Kmb, Lmb, Mmb, Nmb, Omb, Pmb, Qmb, Rmb, Smb, Tmb, Umb, Vmb, Wmb, Xmb, Ymb, Zmb, _mb, $mb, anb, bnb, cnb, dnb, enb, nN, fnb, gnb, hnb, inb, tN, jnb, knb, lnb, mnb, nnb, onb, pnb, qnb, rnb, snb, tnb, unb, QS, vnb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb, Ogb];
	            var Ib = [wnb, xnb, ynb, znb, Anb, Bnb, Cnb, Dnb, Enb, Fnb, Gnb, Hnb, Inb, Jnb, Knb, Lnb, Mnb, Nnb, Onb, Pnb, Qnb, Rnb, Snb, Tnb, Unb, Vnb, Wnb, Xnb, Ynb, Znb, _nb, $nb, aob, bob, cob, dob, eob, fob, gob, hob, iob, job, kob, lob, mob, nob, oob, pob, qob, rob, sob, tob, uob, vob, wob, xob, yob, zob, Aob, Bob, Cob, Dob, Eob, Fob, Gob, Hob, Iob, Job, Kob, Lob, Mob, Nob, Oob, Pob, Qob, Rob, Sob, Tob, Uob, Vob, Wob, Xob, Yob, Zob, _ob, $ob, apb, bpb, cpb, dpb, epb, fpb, gpb, hpb, ipb, jpb, kpb, lpb, mpb, npb, opb, ppb, qpb, rpb, spb, tpb, upb, vpb, wpb, xpb, ypb, zpb, Apb, Bpb, Cpb, Dpb, Epb, Fpb, Gpb, Hpb, Ipb, Jpb, Kpb, Lpb, Mpb, Npb, Opb, Ppb, Qpb, Rpb, Spb, Tpb, Upb, Vpb, Wpb, Xpb, Ypb, Zpb, _pb, $pb, aqb, bqb, cqb, dqb, eqb, fqb, gqb, hqb, iqb, jqb, kqb, lqb, mqb, nqb, oqb, pqb, qqb, rqb, sqb, tqb, uqb, vqb, wqb, xqb, yqb, zqb, Aqb, Bqb, Cqb, Dqb, Eqb, Fqb, Gqb, Hqb, Iqb, Jqb, Kqb, Lqb, Mqb, Nqb, Oqb, Pqb, Qqb, Rqb, Sqb, Tqb, Uqb, Vqb, Wqb, Xqb, Yqb, Zqb, _qb, $qb, arb, brb, crb, drb, erb, frb, grb, hrb, irb, jrb, krb, lrb, mrb, nrb, orb, prb, qrb, rrb, srb, trb, urb, vrb, wrb, xrb, yrb, zrb, Arb, Brb, Crb, Drb, Erb, Frb, Grb, Hrb, Irb, Jrb, Krb, Lrb, Mrb, Nrb, Orb, Prb, Qrb, Rrb, Srb, Trb, Urb, Vrb, Wrb, Xrb, Yrb, Zrb, _rb, $rb, asb, bsb, csb, dsb, esb, fsb, gsb, hsb, isb, jsb, ksb, lsb, msb, nsb, osb, psb, qsb, rsb, ssb, tsb, usb, vsb, wsb, xsb, ysb, zsb, Asb, Bsb, Csb, Dsb, Esb, Fsb, Gsb, Hsb, Isb, Jsb, Ksb, Lsb, Msb, Nsb, Osb, Psb, Qsb, Rsb, Ssb, Tsb, Usb, Vsb, Wsb, Xsb, Ysb, Zsb, _sb, $sb, atb, btb, ctb, dtb, etb, ftb, gtb, htb, itb, jtb, ktb, ltb, mtb, ntb, otb, ptb, qtb, rtb, stb, ttb, utb, vtb, wtb, xtb, ytb, ztb, Atb, Btb, Ctb, Dtb, Etb, Ftb, Gtb, Htb, Itb, Jtb, Ktb, Ltb, Mtb, Ntb, Otb, Ptb, Qtb, Rtb, Stb, Ttb, Utb, Vtb, Wtb, Xtb, Ytb, Ztb, _tb, $tb, aub, bub, cub, dub, eub, fub, gub, hub, iub, jub, kub, lub, mub, nub, oub, pub, qub, oN, rub, sub, tub, uub, uN, vub, wub, xub, yub, zub, Aub, Bub, Cub, Dub, Eub, Fub, Gub, Hub, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb, wnb];
	            var Jb = [Iub, uc, Jub, Kub, Lub, Mub, Nub, Oub, Bc, Pub, Dc, Qub, Rub, Sub, Tub, Uub, Vub, Wub, Xub, Yub, Zub, _ub, $ub, avb, bvb, cvb, dvb, Sc, evb, Uc, fvb, gvb, hvb, ivb, jvb, kvb, SP, lvb, mvb, nvb, ovb, pvb, qvb, _P, rvb, ZP, svb, tvb, uvb, vvb, wvb, xvb, yvb, zvb, Avb, Bvb, Cvb, Dvb, Evb, Fvb, TP, Gvb, Hvb, Ivb, Jvb, Kvb, Lvb, Mvb, Nvb, Ovb, Pvb, Qvb, Rvb, Svb, Tvb, Uvb, Vvb, Wvb, Xvb, Yvb, Zvb, _vb, $vb, awb, bwb, cwb, dwb, ewb, fwb, gwb, hwb, iwb, jwb, kwb, lwb, mwb, nwb, owb, pwb, qwb, rwb, swb, twb, uwb, vwb, wwb, xwb, ywb, zwb, Awb, Bwb, Cwb, Dwb, Ewb, Fwb, Gwb, Hwb, Iwb, Jwb, Kwb, Lwb, Mwb, Nwb, Owb, Pwb, Qwb, Rwb, Swb, Twb, Uwb, Vwb, Wwb, Xwb, Ywb, Zwb, _wb, $wb, axb, bxb, cxb, dxb, exb, fxb, gxb, hxb, ixb, jxb, kxb, lxb, mxb, nxb, oxb, pxb, qxb, rxb, sxb, txb, uxb, vxb, wxb, xxb, yxb, zxb, Axb, Bxb, Cxb, Dxb, Exb, Fxb, Gxb, Hxb, Ixb, Jxb, Kxb, Lxb, Mxb, Nxb, Oxb, Pxb, Qxb, Rxb, Sxb, Txb, Uxb, Vxb, Wxb, Xxb, Yxb, Zxb, _xb, $xb, ayb, byb, cyb, dyb, eyb, fyb, gyb, hyb, iyb, jyb, kyb, lyb, myb, nyb, oyb, pyb, qyb, ryb, syb, tyb, uyb, vyb, wyb, xyb, yyb, zyb, Ayb, Byb, Cyb, Dyb, Eyb, Fyb, Gyb, Hyb, Iyb, Jyb, Kyb, Lyb, Myb, Nyb, Oyb, Pyb, Qyb, Ryb, Syb, Tyb, Uyb, Vyb, Wyb, Xyb, Yyb, Zyb, _yb, $yb, azb, bzb, czb, dzb, ezb, fzb, gzb, hzb, izb, jzb, kzb, lzb, mzb, nzb, ozb, pzb, qzb, rzb, szb, tzb, uzb, vzb, wzb, xzb, yzb, zzb, Azb, Bzb, Czb, Dzb, Ezb, Fzb, Gzb, Hzb, Izb, Jzb, Kzb, Lzb, Mzb, Nzb, Ozb, Pzb, Qzb, Rzb, Szb, Tzb, Uzb, Vzb, Wzb, Xzb, Yzb, Zzb, _zb, $zb, aAb, bAb, cAb, dAb, eAb, fAb, gAb, hAb, iAb, jAb, kAb, lAb, mAb, nAb, oAb, pAb, qAb, rAb, sAb, tAb, uAb, vAb, wAb, xAb, yAb, MB, zAb, AAb, BAb, QB, CAb, DAb, EAb, FAb, GAb, HAb, XB, IAb, ZB, JAb, KAb, LAb, MAb, NAb, OAb, PAb, QAb, RAb, SAb, iC, TAb, UAb, VAb, WAb, XAb, oC, YAb, ZAb, _Ab, lF, $Ab, aBb, bBb, cBb, dBb, zM, eBb, fBb, gBb, hBb, iBb, jBb, kBb, lBb, mBb, nBb, oBb, pBb, qBb, rBb, sBb, tBb, uBb, GN, vBb, wBb, fP, xBb, yBb, gQ, zBb, ABb, BBb, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub, Iub];
	            return {
	                _i64Subtract: XT,
	                _strcat: _T,
	                _free: jT,
	                _main: Sb,
	                _realloc: kT,
	                _strncpy: aU,
	                _memmove: fU,
	                _bitshift64Ashr: YT,
	                _strlen: ZT,
	                _memset: cU,
	                _malloc: iT,
	                _i64Add: bU,
	                _memcpy: eU,
	                _llvm_ctlz_i32: hU,
	                _bitshift64Lshr: dU,
	                _strcpy: gU,
	                _bitshift64Shl: $T,
	                runPostSets: WT,
	                stackAlloc: Kb,
	                stackSave: Lb,
	                stackRestore: Mb,
	                setThrew: Nb,
	                setTempRet0: Qb,
	                getTempRet0: Rb,
	                dynCall_iiiiiiii: qU,
	                dynCall_iiii: rU,
	                dynCall_viiiiiii: sU,
	                dynCall_viiiii: tU,
	                dynCall_i: uU,
	                dynCall_vi: vU,
	                dynCall_vii: wU,
	                dynCall_iiiiiii: xU,
	                dynCall_ii: yU,
	                dynCall_viii: zU,
	                dynCall_viiiiiiiii: AU,
	                dynCall_iiiii: BU,
	                dynCall_viiiiii: CU,
	                dynCall_iii: DU,
	                dynCall_iiiiii: EU,
	                dynCall_viiii: FU
	            }
	        })


	        // EMSCRIPTEN_END_ASM
	        (Module.asmGlobalArg, Module.asmLibraryArg, buffer);
	        var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
	        var _strcat = Module["_strcat"] = asm["_strcat"];
	        var _free = Module["_free"] = asm["_free"];
	        var _main = Module["_main"] = asm["_main"];
	        var _realloc = Module["_realloc"] = asm["_realloc"];
	        var _strncpy = Module["_strncpy"] = asm["_strncpy"];
	        var _memmove = Module["_memmove"] = asm["_memmove"];
	        var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
	        var _strlen = Module["_strlen"] = asm["_strlen"];
	        var _memset = Module["_memset"] = asm["_memset"];
	        var _malloc = Module["_malloc"] = asm["_malloc"];
	        var _i64Add = Module["_i64Add"] = asm["_i64Add"];
	        var _memcpy = Module["_memcpy"] = asm["_memcpy"];
	        var _llvm_ctlz_i32 = Module["_llvm_ctlz_i32"] = asm["_llvm_ctlz_i32"];
	        var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
	        var _strcpy = Module["_strcpy"] = asm["_strcpy"];
	        var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
	        var runPostSets = Module["runPostSets"] = asm["runPostSets"];
	        var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
	        var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
	        var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
	        var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
	        var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
	        var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
	        var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
	        var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
	        var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
	        var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
	        var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
	        var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
	        var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
	        var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
	        var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
	        var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
	        Runtime.stackAlloc = asm["stackAlloc"];
	        Runtime.stackSave = asm["stackSave"];
	        Runtime.stackRestore = asm["stackRestore"];
	        Runtime.setTempRet0 = asm["setTempRet0"];
	        Runtime.getTempRet0 = asm["getTempRet0"];
	        var i64Math = (function () {
	            var goog = {math: {}};
	            goog.math.Long = (function (low, high) {
	                this.low_ = low | 0;
	                this.high_ = high | 0
	            });
	            goog.math.Long.IntCache_ = {};
	            goog.math.Long.fromInt = (function (value) {
	                if (-128 <= value && value < 128) {
	                    var cachedObj = goog.math.Long.IntCache_[value];
	                    if (cachedObj) {
	                        return cachedObj
	                    }
	                }
	                var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
	                if (-128 <= value && value < 128) {
	                    goog.math.Long.IntCache_[value] = obj
	                }
	                return obj
	            });
	            goog.math.Long.fromNumber = (function (value) {
	                if (isNaN(value) || !isFinite(value)) {
	                    return goog.math.Long.ZERO
	                } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
	                    return goog.math.Long.MIN_VALUE
	                } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
	                    return goog.math.Long.MAX_VALUE
	                } else if (value < 0) {
	                    return goog.math.Long.fromNumber(-value).negate()
	                } else {
	                    return new goog.math.Long(value % goog.math.Long.TWO_PWR_32_DBL_ | 0, value / goog.math.Long.TWO_PWR_32_DBL_ | 0)
	                }
	            });
	            goog.math.Long.fromBits = (function (lowBits, highBits) {
	                return new goog.math.Long(lowBits, highBits)
	            });
	            goog.math.Long.fromString = (function (str, opt_radix) {
	                if (str.length == 0) {
	                    throw Error("number format error: empty string")
	                }
	                var radix = opt_radix || 10;
	                if (radix < 2 || 36 < radix) {
	                    throw Error("radix out of range: " + radix)
	                }
	                if (str.charAt(0) == "-") {
	                    return goog.math.Long.fromString(str.substring(1), radix).negate()
	                } else if (str.indexOf("-") >= 0) {
	                    throw Error('number format error: interior "-" character: ' + str)
	                }
	                var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));
	                var result = goog.math.Long.ZERO;
	                for (var i = 0; i < str.length; i += 8) {
	                    var size = Math.min(8, str.length - i);
	                    var value = parseInt(str.substring(i, i + size), radix);
	                    if (size < 8) {
	                        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
	                        result = result.multiply(power).add(goog.math.Long.fromNumber(value))
	                    } else {
	                        result = result.multiply(radixToPower);
	                        result = result.add(goog.math.Long.fromNumber(value))
	                    }
	                }
	                return result
	            });
	            goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;
	            goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;
	            goog.math.Long.TWO_PWR_32_DBL_ = goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
	            goog.math.Long.TWO_PWR_31_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ / 2;
	            goog.math.Long.TWO_PWR_48_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
	            goog.math.Long.TWO_PWR_64_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;
	            goog.math.Long.TWO_PWR_63_DBL_ = goog.math.Long.TWO_PWR_64_DBL_ / 2;
	            goog.math.Long.ZERO = goog.math.Long.fromInt(0);
	            goog.math.Long.ONE = goog.math.Long.fromInt(1);
	            goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);
	            goog.math.Long.MAX_VALUE = goog.math.Long.fromBits(4294967295 | 0, 2147483647 | 0);
	            goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 2147483648 | 0);
	            goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);
	            goog.math.Long.prototype.toInt = (function () {
	                return this.low_
	            });
	            goog.math.Long.prototype.toNumber = (function () {
	                return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ + this.getLowBitsUnsigned()
	            });
	            goog.math.Long.prototype.toString = (function (opt_radix) {
	                var radix = opt_radix || 10;
	                if (radix < 2 || 36 < radix) {
	                    throw Error("radix out of range: " + radix)
	                }
	                if (this.isZero()) {
	                    return "0"
	                }
	                if (this.isNegative()) {
	                    if (this.equals(goog.math.Long.MIN_VALUE)) {
	                        var radixLong = goog.math.Long.fromNumber(radix);
	                        var div = this.div(radixLong);
	                        var rem = div.multiply(radixLong).subtract(this);
	                        return div.toString(radix) + rem.toInt().toString(radix)
	                    } else {
	                        return "-" + this.negate().toString(radix)
	                    }
	                }
	                var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));
	                var rem = this;
	                var result = "";
	                while (true) {
	                    var remDiv = rem.div(radixToPower);
	                    var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
	                    var digits = intval.toString(radix);
	                    rem = remDiv;
	                    if (rem.isZero()) {
	                        return digits + result
	                    } else {
	                        while (digits.length < 6) {
	                            digits = "0" + digits
	                        }
	                        result = "" + digits + result
	                    }
	                }
	            });
	            goog.math.Long.prototype.getHighBits = (function () {
	                return this.high_
	            });
	            goog.math.Long.prototype.getLowBits = (function () {
	                return this.low_
	            });
	            goog.math.Long.prototype.getLowBitsUnsigned = (function () {
	                return this.low_ >= 0 ? this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_
	            });
	            goog.math.Long.prototype.getNumBitsAbs = (function () {
	                if (this.isNegative()) {
	                    if (this.equals(goog.math.Long.MIN_VALUE)) {
	                        return 64
	                    } else {
	                        return this.negate().getNumBitsAbs()
	                    }
	                } else {
	                    var val = this.high_ != 0 ? this.high_ : this.low_;
	                    for (var bit = 31; bit > 0; bit--) {
	                        if ((val & 1 << bit) != 0) {
	                            break
	                        }
	                    }
	                    return this.high_ != 0 ? bit + 33 : bit + 1
	                }
	            });
	            goog.math.Long.prototype.isZero = (function () {
	                return this.high_ == 0 && this.low_ == 0
	            });
	            goog.math.Long.prototype.isNegative = (function () {
	                return this.high_ < 0
	            });
	            goog.math.Long.prototype.isOdd = (function () {
	                return (this.low_ & 1) == 1
	            });
	            goog.math.Long.prototype.equals = (function (other) {
	                return this.high_ == other.high_ && this.low_ == other.low_
	            });
	            goog.math.Long.prototype.notEquals = (function (other) {
	                return this.high_ != other.high_ || this.low_ != other.low_
	            });
	            goog.math.Long.prototype.lessThan = (function (other) {
	                return this.compare(other) < 0
	            });
	            goog.math.Long.prototype.lessThanOrEqual = (function (other) {
	                return this.compare(other) <= 0
	            });
	            goog.math.Long.prototype.greaterThan = (function (other) {
	                return this.compare(other) > 0
	            });
	            goog.math.Long.prototype.greaterThanOrEqual = (function (other) {
	                return this.compare(other) >= 0
	            });
	            goog.math.Long.prototype.compare = (function (other) {
	                if (this.equals(other)) {
	                    return 0
	                }
	                var thisNeg = this.isNegative();
	                var otherNeg = other.isNegative();
	                if (thisNeg && !otherNeg) {
	                    return -1
	                }
	                if (!thisNeg && otherNeg) {
	                    return 1
	                }
	                if (this.subtract(other).isNegative()) {
	                    return -1
	                } else {
	                    return 1
	                }
	            });
	            goog.math.Long.prototype.negate = (function () {
	                if (this.equals(goog.math.Long.MIN_VALUE)) {
	                    return goog.math.Long.MIN_VALUE
	                } else {
	                    return this.not().add(goog.math.Long.ONE)
	                }
	            });
	            goog.math.Long.prototype.add = (function (other) {
	                var a48 = this.high_ >>> 16;
	                var a32 = this.high_ & 65535;
	                var a16 = this.low_ >>> 16;
	                var a00 = this.low_ & 65535;
	                var b48 = other.high_ >>> 16;
	                var b32 = other.high_ & 65535;
	                var b16 = other.low_ >>> 16;
	                var b00 = other.low_ & 65535;
	                var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
	                c00 += a00 + b00;
	                c16 += c00 >>> 16;
	                c00 &= 65535;
	                c16 += a16 + b16;
	                c32 += c16 >>> 16;
	                c16 &= 65535;
	                c32 += a32 + b32;
	                c48 += c32 >>> 16;
	                c32 &= 65535;
	                c48 += a48 + b48;
	                c48 &= 65535;
	                return goog.math.Long.fromBits(c16 << 16 | c00, c48 << 16 | c32)
	            });
	            goog.math.Long.prototype.subtract = (function (other) {
	                return this.add(other.negate())
	            });
	            goog.math.Long.prototype.multiply = (function (other) {
	                if (this.isZero()) {
	                    return goog.math.Long.ZERO
	                } else if (other.isZero()) {
	                    return goog.math.Long.ZERO
	                }
	                if (this.equals(goog.math.Long.MIN_VALUE)) {
	                    return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO
	                } else if (other.equals(goog.math.Long.MIN_VALUE)) {
	                    return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO
	                }
	                if (this.isNegative()) {
	                    if (other.isNegative()) {
	                        return this.negate().multiply(other.negate())
	                    } else {
	                        return this.negate().multiply(other).negate()
	                    }
	                } else if (other.isNegative()) {
	                    return this.multiply(other.negate()).negate()
	                }
	                if (this.lessThan(goog.math.Long.TWO_PWR_24_) && other.lessThan(goog.math.Long.TWO_PWR_24_)) {
	                    return goog.math.Long.fromNumber(this.toNumber() * other.toNumber())
	                }
	                var a48 = this.high_ >>> 16;
	                var a32 = this.high_ & 65535;
	                var a16 = this.low_ >>> 16;
	                var a00 = this.low_ & 65535;
	                var b48 = other.high_ >>> 16;
	                var b32 = other.high_ & 65535;
	                var b16 = other.low_ >>> 16;
	                var b00 = other.low_ & 65535;
	                var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
	                c00 += a00 * b00;
	                c16 += c00 >>> 16;
	                c00 &= 65535;
	                c16 += a16 * b00;
	                c32 += c16 >>> 16;
	                c16 &= 65535;
	                c16 += a00 * b16;
	                c32 += c16 >>> 16;
	                c16 &= 65535;
	                c32 += a32 * b00;
	                c48 += c32 >>> 16;
	                c32 &= 65535;
	                c32 += a16 * b16;
	                c48 += c32 >>> 16;
	                c32 &= 65535;
	                c32 += a00 * b32;
	                c48 += c32 >>> 16;
	                c32 &= 65535;
	                c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
	                c48 &= 65535;
	                return goog.math.Long.fromBits(c16 << 16 | c00, c48 << 16 | c32)
	            });
	            goog.math.Long.prototype.div = (function (other) {
	                if (other.isZero()) {
	                    throw Error("division by zero")
	                } else if (this.isZero()) {
	                    return goog.math.Long.ZERO
	                }
	                if (this.equals(goog.math.Long.MIN_VALUE)) {
	                    if (other.equals(goog.math.Long.ONE) || other.equals(goog.math.Long.NEG_ONE)) {
	                        return goog.math.Long.MIN_VALUE
	                    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
	                        return goog.math.Long.ONE
	                    } else {
	                        var halfThis = this.shiftRight(1);
	                        var approx = halfThis.div(other).shiftLeft(1);
	                        if (approx.equals(goog.math.Long.ZERO)) {
	                            return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE
	                        } else {
	                            var rem = this.subtract(other.multiply(approx));
	                            var result = approx.add(rem.div(other));
	                            return result
	                        }
	                    }
	                } else if (other.equals(goog.math.Long.MIN_VALUE)) {
	                    return goog.math.Long.ZERO
	                }
	                if (this.isNegative()) {
	                    if (other.isNegative()) {
	                        return this.negate().div(other.negate())
	                    } else {
	                        return this.negate().div(other).negate()
	                    }
	                } else if (other.isNegative()) {
	                    return this.div(other.negate()).negate()
	                }
	                var res = goog.math.Long.ZERO;
	                var rem = this;
	                while (rem.greaterThanOrEqual(other)) {
	                    var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));
	                    var log2 = Math.ceil(Math.log(approx) / Math.LN2);
	                    var delta = log2 <= 48 ? 1 : Math.pow(2, log2 - 48);
	                    var approxRes = goog.math.Long.fromNumber(approx);
	                    var approxRem = approxRes.multiply(other);
	                    while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
	                        approx -= delta;
	                        approxRes = goog.math.Long.fromNumber(approx);
	                        approxRem = approxRes.multiply(other)
	                    }
	                    if (approxRes.isZero()) {
	                        approxRes = goog.math.Long.ONE
	                    }
	                    res = res.add(approxRes);
	                    rem = rem.subtract(approxRem)
	                }
	                return res
	            });
	            goog.math.Long.prototype.modulo = (function (other) {
	                return this.subtract(this.div(other).multiply(other))
	            });
	            goog.math.Long.prototype.not = (function () {
	                return goog.math.Long.fromBits(~this.low_, ~this.high_)
	            });
	            goog.math.Long.prototype.and = (function (other) {
	                return goog.math.Long.fromBits(this.low_ & other.low_, this.high_ & other.high_)
	            });
	            goog.math.Long.prototype.or = (function (other) {
	                return goog.math.Long.fromBits(this.low_ | other.low_, this.high_ | other.high_)
	            });
	            goog.math.Long.prototype.xor = (function (other) {
	                return goog.math.Long.fromBits(this.low_ ^ other.low_, this.high_ ^ other.high_)
	            });
	            goog.math.Long.prototype.shiftLeft = (function (numBits) {
	                numBits &= 63;
	                if (numBits == 0) {
	                    return this
	                } else {
	                    var low = this.low_;
	                    if (numBits < 32) {
	                        var high = this.high_;
	                        return goog.math.Long.fromBits(low << numBits, high << numBits | low >>> 32 - numBits)
	                    } else {
	                        return goog.math.Long.fromBits(0, low << numBits - 32)
	                    }
	                }
	            });
	            goog.math.Long.prototype.shiftRight = (function (numBits) {
	                numBits &= 63;
	                if (numBits == 0) {
	                    return this
	                } else {
	                    var high = this.high_;
	                    if (numBits < 32) {
	                        var low = this.low_;
	                        return goog.math.Long.fromBits(low >>> numBits | high << 32 - numBits, high >> numBits)
	                    } else {
	                        return goog.math.Long.fromBits(high >> numBits - 32, high >= 0 ? 0 : -1)
	                    }
	                }
	            });
	            goog.math.Long.prototype.shiftRightUnsigned = (function (numBits) {
	                numBits &= 63;
	                if (numBits == 0) {
	                    return this
	                } else {
	                    var high = this.high_;
	                    if (numBits < 32) {
	                        var low = this.low_;
	                        return goog.math.Long.fromBits(low >>> numBits | high << 32 - numBits, high >>> numBits)
	                    } else if (numBits == 32) {
	                        return goog.math.Long.fromBits(high, 0)
	                    } else {
	                        return goog.math.Long.fromBits(high >>> numBits - 32, 0)
	                    }
	                }
	            });
	            var navigator = {appName: "Modern Browser"};
	            var dbits;
	            var canary = 0xdeadbeefcafe;
	            var j_lm = (canary & 16777215) == 15715070;

	            function BigInteger(a, b, c) {
	                if (a != null)if ("number" == typeof a)this.fromNumber(a, b, c); else if (b == null && "string" != typeof a)this.fromString(a, 256); else this.fromString(a, b)
	            }

	            function nbi() {
	                return new BigInteger(null)
	            }

	            function am1(i, x, w, j, c, n) {
	                while (--n >= 0) {
	                    var v = x * this[i++] + w[j] + c;
	                    c = Math.floor(v / 67108864);
	                    w[j++] = v & 67108863
	                }
	                return c
	            }

	            function am2(i, x, w, j, c, n) {
	                var xl = x & 32767, xh = x >> 15;
	                while (--n >= 0) {
	                    var l = this[i] & 32767;
	                    var h = this[i++] >> 15;
	                    var m = xh * l + h * xl;
	                    l = xl * l + ((m & 32767) << 15) + w[j] + (c & 1073741823);
	                    c = (l >>> 30) + (m >>> 15) + xh * h + (c >>> 30);
	                    w[j++] = l & 1073741823
	                }
	                return c
	            }

	            function am3(i, x, w, j, c, n) {
	                var xl = x & 16383, xh = x >> 14;
	                while (--n >= 0) {
	                    var l = this[i] & 16383;
	                    var h = this[i++] >> 14;
	                    var m = xh * l + h * xl;
	                    l = xl * l + ((m & 16383) << 14) + w[j] + c;
	                    c = (l >> 28) + (m >> 14) + xh * h;
	                    w[j++] = l & 268435455
	                }
	                return c
	            }

	            if (j_lm && navigator.appName == "Microsoft Internet Explorer") {
	                BigInteger.prototype.am = am2;
	                dbits = 30
	            } else if (j_lm && navigator.appName != "Netscape") {
	                BigInteger.prototype.am = am1;
	                dbits = 26
	            } else {
	                BigInteger.prototype.am = am3;
	                dbits = 28
	            }
	            BigInteger.prototype.DB = dbits;
	            BigInteger.prototype.DM = (1 << dbits) - 1;
	            BigInteger.prototype.DV = 1 << dbits;
	            var BI_FP = 52;
	            BigInteger.prototype.FV = Math.pow(2, BI_FP);
	            BigInteger.prototype.F1 = BI_FP - dbits;
	            BigInteger.prototype.F2 = 2 * dbits - BI_FP;
	            var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
	            var BI_RC = new Array;
	            var rr, vv;
	            rr = "0".charCodeAt(0);
	            for (vv = 0; vv <= 9; ++vv)BI_RC[rr++] = vv;
	            rr = "a".charCodeAt(0);
	            for (vv = 10; vv < 36; ++vv)BI_RC[rr++] = vv;
	            rr = "A".charCodeAt(0);
	            for (vv = 10; vv < 36; ++vv)BI_RC[rr++] = vv;
	            function int2char(n) {
	                return BI_RM.charAt(n)
	            }

	            function intAt(s, i) {
	                var c = BI_RC[s.charCodeAt(i)];
	                return c == null ? -1 : c
	            }

	            function bnpCopyTo(r) {
	                for (var i = this.t - 1; i >= 0; --i)r[i] = this[i];
	                r.t = this.t;
	                r.s = this.s
	            }

	            function bnpFromInt(x) {
	                this.t = 1;
	                this.s = x < 0 ? -1 : 0;
	                if (x > 0)this[0] = x; else if (x < -1)this[0] = x + DV; else this.t = 0
	            }

	            function nbv(i) {
	                var r = nbi();
	                r.fromInt(i);
	                return r
	            }

	            function bnpFromString(s, b) {
	                var k;
	                if (b == 16)k = 4; else if (b == 8)k = 3; else if (b == 256)k = 8; else if (b == 2)k = 1; else if (b == 32)k = 5; else if (b == 4)k = 2; else {
	                    this.fromRadix(s, b);
	                    return
	                }
	                this.t = 0;
	                this.s = 0;
	                var i = s.length, mi = false, sh = 0;
	                while (--i >= 0) {
	                    var x = k == 8 ? s[i] & 255 : intAt(s, i);
	                    if (x < 0) {
	                        if (s.charAt(i) == "-")mi = true;
	                        continue
	                    }
	                    mi = false;
	                    if (sh == 0)this[this.t++] = x; else if (sh + k > this.DB) {
	                        this[this.t - 1] |= (x & (1 << this.DB - sh) - 1) << sh;
	                        this[this.t++] = x >> this.DB - sh
	                    } else this[this.t - 1] |= x << sh;
	                    sh += k;
	                    if (sh >= this.DB)sh -= this.DB
	                }
	                if (k == 8 && (s[0] & 128) != 0) {
	                    this.s = -1;
	                    if (sh > 0)this[this.t - 1] |= (1 << this.DB - sh) - 1 << sh
	                }
	                this.clamp();
	                if (mi)BigInteger.ZERO.subTo(this, this)
	            }

	            function bnpClamp() {
	                var c = this.s & this.DM;
	                while (this.t > 0 && this[this.t - 1] == c)--this.t
	            }

	            function bnToString(b) {
	                if (this.s < 0)return "-" + this.negate().toString(b);
	                var k;
	                if (b == 16)k = 4; else if (b == 8)k = 3; else if (b == 2)k = 1; else if (b == 32)k = 5; else if (b == 4)k = 2; else return this.toRadix(b);
	                var km = (1 << k) - 1, d, m = false, r = "", i = this.t;
	                var p = this.DB - i * this.DB % k;
	                if (i-- > 0) {
	                    if (p < this.DB && (d = this[i] >> p) > 0) {
	                        m = true;
	                        r = int2char(d)
	                    }
	                    while (i >= 0) {
	                        if (p < k) {
	                            d = (this[i] & (1 << p) - 1) << k - p;
	                            d |= this[--i] >> (p += this.DB - k)
	                        } else {
	                            d = this[i] >> (p -= k) & km;
	                            if (p <= 0) {
	                                p += this.DB;
	                                --i
	                            }
	                        }
	                        if (d > 0)m = true;
	                        if (m)r += int2char(d)
	                    }
	                }
	                return m ? r : "0"
	            }

	            function bnNegate() {
	                var r = nbi();
	                BigInteger.ZERO.subTo(this, r);
	                return r
	            }

	            function bnAbs() {
	                return this.s < 0 ? this.negate() : this
	            }

	            function bnCompareTo(a) {
	                var r = this.s - a.s;
	                if (r != 0)return r;
	                var i = this.t;
	                r = i - a.t;
	                if (r != 0)return this.s < 0 ? -r : r;
	                while (--i >= 0)if ((r = this[i] - a[i]) != 0)return r;
	                return 0
	            }

	            function nbits(x) {
	                var r = 1, t;
	                if ((t = x >>> 16) != 0) {
	                    x = t;
	                    r += 16
	                }
	                if ((t = x >> 8) != 0) {
	                    x = t;
	                    r += 8
	                }
	                if ((t = x >> 4) != 0) {
	                    x = t;
	                    r += 4
	                }
	                if ((t = x >> 2) != 0) {
	                    x = t;
	                    r += 2
	                }
	                if ((t = x >> 1) != 0) {
	                    x = t;
	                    r += 1
	                }
	                return r
	            }

	            function bnBitLength() {
	                if (this.t <= 0)return 0;
	                return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ this.s & this.DM)
	            }

	            function bnpDLShiftTo(n, r) {
	                var i;
	                for (i = this.t - 1; i >= 0; --i)r[i + n] = this[i];
	                for (i = n - 1; i >= 0; --i)r[i] = 0;
	                r.t = this.t + n;
	                r.s = this.s
	            }

	            function bnpDRShiftTo(n, r) {
	                for (var i = n; i < this.t; ++i)r[i - n] = this[i];
	                r.t = Math.max(this.t - n, 0);
	                r.s = this.s
	            }

	            function bnpLShiftTo(n, r) {
	                var bs = n % this.DB;
	                var cbs = this.DB - bs;
	                var bm = (1 << cbs) - 1;
	                var ds = Math.floor(n / this.DB), c = this.s << bs & this.DM, i;
	                for (i = this.t - 1; i >= 0; --i) {
	                    r[i + ds + 1] = this[i] >> cbs | c;
	                    c = (this[i] & bm) << bs
	                }
	                for (i = ds - 1; i >= 0; --i)r[i] = 0;
	                r[ds] = c;
	                r.t = this.t + ds + 1;
	                r.s = this.s;
	                r.clamp()
	            }

	            function bnpRShiftTo(n, r) {
	                r.s = this.s;
	                var ds = Math.floor(n / this.DB);
	                if (ds >= this.t) {
	                    r.t = 0;
	                    return
	                }
	                var bs = n % this.DB;
	                var cbs = this.DB - bs;
	                var bm = (1 << bs) - 1;
	                r[0] = this[ds] >> bs;
	                for (var i = ds + 1; i < this.t; ++i) {
	                    r[i - ds - 1] |= (this[i] & bm) << cbs;
	                    r[i - ds] = this[i] >> bs
	                }
	                if (bs > 0)r[this.t - ds - 1] |= (this.s & bm) << cbs;
	                r.t = this.t - ds;
	                r.clamp()
	            }

	            function bnpSubTo(a, r) {
	                var i = 0, c = 0, m = Math.min(a.t, this.t);
	                while (i < m) {
	                    c += this[i] - a[i];
	                    r[i++] = c & this.DM;
	                    c >>= this.DB
	                }
	                if (a.t < this.t) {
	                    c -= a.s;
	                    while (i < this.t) {
	                        c += this[i];
	                        r[i++] = c & this.DM;
	                        c >>= this.DB
	                    }
	                    c += this.s
	                } else {
	                    c += this.s;
	                    while (i < a.t) {
	                        c -= a[i];
	                        r[i++] = c & this.DM;
	                        c >>= this.DB
	                    }
	                    c -= a.s
	                }
	                r.s = c < 0 ? -1 : 0;
	                if (c < -1)r[i++] = this.DV + c; else if (c > 0)r[i++] = c;
	                r.t = i;
	                r.clamp()
	            }

	            function bnpMultiplyTo(a, r) {
	                var x = this.abs(), y = a.abs();
	                var i = x.t;
	                r.t = i + y.t;
	                while (--i >= 0)r[i] = 0;
	                for (i = 0; i < y.t; ++i)r[i + x.t] = x.am(0, y[i], r, i, 0, x.t);
	                r.s = 0;
	                r.clamp();
	                if (this.s != a.s)BigInteger.ZERO.subTo(r, r)
	            }

	            function bnpSquareTo(r) {
	                var x = this.abs();
	                var i = r.t = 2 * x.t;
	                while (--i >= 0)r[i] = 0;
	                for (i = 0; i < x.t - 1; ++i) {
	                    var c = x.am(i, x[i], r, 2 * i, 0, 1);
	                    if ((r[i + x.t] += x.am(i + 1, 2 * x[i], r, 2 * i + 1, c, x.t - i - 1)) >= x.DV) {
	                        r[i + x.t] -= x.DV;
	                        r[i + x.t + 1] = 1
	                    }
	                }
	                if (r.t > 0)r[r.t - 1] += x.am(i, x[i], r, 2 * i, 0, 1);
	                r.s = 0;
	                r.clamp()
	            }

	            function bnpDivRemTo(m, q, r) {
	                var pm = m.abs();
	                if (pm.t <= 0)return;
	                var pt = this.abs();
	                if (pt.t < pm.t) {
	                    if (q != null)q.fromInt(0);
	                    if (r != null)this.copyTo(r);
	                    return
	                }
	                if (r == null)r = nbi();
	                var y = nbi(), ts = this.s, ms = m.s;
	                var nsh = this.DB - nbits(pm[pm.t - 1]);
	                if (nsh > 0) {
	                    pm.lShiftTo(nsh, y);
	                    pt.lShiftTo(nsh, r)
	                } else {
	                    pm.copyTo(y);
	                    pt.copyTo(r)
	                }
	                var ys = y.t;
	                var y0 = y[ys - 1];
	                if (y0 == 0)return;
	                var yt = y0 * (1 << this.F1) + (ys > 1 ? y[ys - 2] >> this.F2 : 0);
	                var d1 = this.FV / yt, d2 = (1 << this.F1) / yt, e = 1 << this.F2;
	                var i = r.t, j = i - ys, t = q == null ? nbi() : q;
	                y.dlShiftTo(j, t);
	                if (r.compareTo(t) >= 0) {
	                    r[r.t++] = 1;
	                    r.subTo(t, r)
	                }
	                BigInteger.ONE.dlShiftTo(ys, t);
	                t.subTo(y, y);
	                while (y.t < ys)y[y.t++] = 0;
	                while (--j >= 0) {
	                    var qd = r[--i] == y0 ? this.DM : Math.floor(r[i] * d1 + (r[i - 1] + e) * d2);
	                    if ((r[i] += y.am(0, qd, r, j, 0, ys)) < qd) {
	                        y.dlShiftTo(j, t);
	                        r.subTo(t, r);
	                        while (r[i] < --qd)r.subTo(t, r)
	                    }
	                }
	                if (q != null) {
	                    r.drShiftTo(ys, q);
	                    if (ts != ms)BigInteger.ZERO.subTo(q, q)
	                }
	                r.t = ys;
	                r.clamp();
	                if (nsh > 0)r.rShiftTo(nsh, r);
	                if (ts < 0)BigInteger.ZERO.subTo(r, r)
	            }

	            function bnMod(a) {
	                var r = nbi();
	                this.abs().divRemTo(a, null, r);
	                if (this.s < 0 && r.compareTo(BigInteger.ZERO) > 0)a.subTo(r, r);
	                return r
	            }

	            function Classic(m) {
	                this.m = m
	            }

	            function cConvert(x) {
	                if (x.s < 0 || x.compareTo(this.m) >= 0)return x.mod(this.m); else return x
	            }

	            function cRevert(x) {
	                return x
	            }

	            function cReduce(x) {
	                x.divRemTo(this.m, null, x)
	            }

	            function cMulTo(x, y, r) {
	                x.multiplyTo(y, r);
	                this.reduce(r)
	            }

	            function cSqrTo(x, r) {
	                x.squareTo(r);
	                this.reduce(r)
	            }

	            Classic.prototype.convert = cConvert;
	            Classic.prototype.revert = cRevert;
	            Classic.prototype.reduce = cReduce;
	            Classic.prototype.mulTo = cMulTo;
	            Classic.prototype.sqrTo = cSqrTo;
	            function bnpInvDigit() {
	                if (this.t < 1)return 0;
	                var x = this[0];
	                if ((x & 1) == 0)return 0;
	                var y = x & 3;
	                y = y * (2 - (x & 15) * y) & 15;
	                y = y * (2 - (x & 255) * y) & 255;
	                y = y * (2 - ((x & 65535) * y & 65535)) & 65535;
	                y = y * (2 - x * y % this.DV) % this.DV;
	                return y > 0 ? this.DV - y : -y
	            }

	            function Montgomery(m) {
	                this.m = m;
	                this.mp = m.invDigit();
	                this.mpl = this.mp & 32767;
	                this.mph = this.mp >> 15;
	                this.um = (1 << m.DB - 15) - 1;
	                this.mt2 = 2 * m.t
	            }

	            function montConvert(x) {
	                var r = nbi();
	                x.abs().dlShiftTo(this.m.t, r);
	                r.divRemTo(this.m, null, r);
	                if (x.s < 0 && r.compareTo(BigInteger.ZERO) > 0)this.m.subTo(r, r);
	                return r
	            }

	            function montRevert(x) {
	                var r = nbi();
	                x.copyTo(r);
	                this.reduce(r);
	                return r
	            }

	            function montReduce(x) {
	                while (x.t <= this.mt2)x[x.t++] = 0;
	                for (var i = 0; i < this.m.t; ++i) {
	                    var j = x[i] & 32767;
	                    var u0 = j * this.mpl + ((j * this.mph + (x[i] >> 15) * this.mpl & this.um) << 15) & x.DM;
	                    j = i + this.m.t;
	                    x[j] += this.m.am(0, u0, x, i, 0, this.m.t);
	                    while (x[j] >= x.DV) {
	                        x[j] -= x.DV;
	                        x[++j]++
	                    }
	                }
	                x.clamp();
	                x.drShiftTo(this.m.t, x);
	                if (x.compareTo(this.m) >= 0)x.subTo(this.m, x)
	            }

	            function montSqrTo(x, r) {
	                x.squareTo(r);
	                this.reduce(r)
	            }

	            function montMulTo(x, y, r) {
	                x.multiplyTo(y, r);
	                this.reduce(r)
	            }

	            Montgomery.prototype.convert = montConvert;
	            Montgomery.prototype.revert = montRevert;
	            Montgomery.prototype.reduce = montReduce;
	            Montgomery.prototype.mulTo = montMulTo;
	            Montgomery.prototype.sqrTo = montSqrTo;
	            function bnpIsEven() {
	                return (this.t > 0 ? this[0] & 1 : this.s) == 0
	            }

	            function bnpExp(e, z) {
	                if (e > 4294967295 || e < 1)return BigInteger.ONE;
	                var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e) - 1;
	                g.copyTo(r);
	                while (--i >= 0) {
	                    z.sqrTo(r, r2);
	                    if ((e & 1 << i) > 0)z.mulTo(r2, g, r); else {
	                        var t = r;
	                        r = r2;
	                        r2 = t
	                    }
	                }
	                return z.revert(r)
	            }

	            function bnModPowInt(e, m) {
	                var z;
	                if (e < 256 || m.isEven())z = new Classic(m); else z = new Montgomery(m);
	                return this.exp(e, z)
	            }

	            BigInteger.prototype.copyTo = bnpCopyTo;
	            BigInteger.prototype.fromInt = bnpFromInt;
	            BigInteger.prototype.fromString = bnpFromString;
	            BigInteger.prototype.clamp = bnpClamp;
	            BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
	            BigInteger.prototype.drShiftTo = bnpDRShiftTo;
	            BigInteger.prototype.lShiftTo = bnpLShiftTo;
	            BigInteger.prototype.rShiftTo = bnpRShiftTo;
	            BigInteger.prototype.subTo = bnpSubTo;
	            BigInteger.prototype.multiplyTo = bnpMultiplyTo;
	            BigInteger.prototype.squareTo = bnpSquareTo;
	            BigInteger.prototype.divRemTo = bnpDivRemTo;
	            BigInteger.prototype.invDigit = bnpInvDigit;
	            BigInteger.prototype.isEven = bnpIsEven;
	            BigInteger.prototype.exp = bnpExp;
	            BigInteger.prototype.toString = bnToString;
	            BigInteger.prototype.negate = bnNegate;
	            BigInteger.prototype.abs = bnAbs;
	            BigInteger.prototype.compareTo = bnCompareTo;
	            BigInteger.prototype.bitLength = bnBitLength;
	            BigInteger.prototype.mod = bnMod;
	            BigInteger.prototype.modPowInt = bnModPowInt;
	            BigInteger.ZERO = nbv(0);
	            BigInteger.ONE = nbv(1);
	            function bnpFromRadix(s, b) {
	                this.fromInt(0);
	                if (b == null)b = 10;
	                var cs = this.chunkSize(b);
	                var d = Math.pow(b, cs), mi = false, j = 0, w = 0;
	                for (var i = 0; i < s.length; ++i) {
	                    var x = intAt(s, i);
	                    if (x < 0) {
	                        if (s.charAt(i) == "-" && this.signum() == 0)mi = true;
	                        continue
	                    }
	                    w = b * w + x;
	                    if (++j >= cs) {
	                        this.dMultiply(d);
	                        this.dAddOffset(w, 0);
	                        j = 0;
	                        w = 0
	                    }
	                }
	                if (j > 0) {
	                    this.dMultiply(Math.pow(b, j));
	                    this.dAddOffset(w, 0)
	                }
	                if (mi)BigInteger.ZERO.subTo(this, this)
	            }

	            function bnpChunkSize(r) {
	                return Math.floor(Math.LN2 * this.DB / Math.log(r))
	            }

	            function bnSigNum() {
	                if (this.s < 0)return -1; else if (this.t <= 0 || this.t == 1 && this[0] <= 0)return 0; else return 1
	            }

	            function bnpDMultiply(n) {
	                this[this.t] = this.am(0, n - 1, this, 0, 0, this.t);
	                ++this.t;
	                this.clamp()
	            }

	            function bnpDAddOffset(n, w) {
	                if (n == 0)return;
	                while (this.t <= w)this[this.t++] = 0;
	                this[w] += n;
	                while (this[w] >= this.DV) {
	                    this[w] -= this.DV;
	                    if (++w >= this.t)this[this.t++] = 0;
	                    ++this[w]
	                }
	            }

	            function bnpToRadix(b) {
	                if (b == null)b = 10;
	                if (this.signum() == 0 || b < 2 || b > 36)return "0";
	                var cs = this.chunkSize(b);
	                var a = Math.pow(b, cs);
	                var d = nbv(a), y = nbi(), z = nbi(), r = "";
	                this.divRemTo(d, y, z);
	                while (y.signum() > 0) {
	                    r = (a + z.intValue()).toString(b).substr(1) + r;
	                    y.divRemTo(d, y, z)
	                }
	                return z.intValue().toString(b) + r
	            }

	            function bnIntValue() {
	                if (this.s < 0) {
	                    if (this.t == 1)return this[0] - this.DV; else if (this.t == 0)return -1
	                } else if (this.t == 1)return this[0]; else if (this.t == 0)return 0;
	                return (this[1] & (1 << 32 - this.DB) - 1) << this.DB | this[0]
	            }

	            function bnpAddTo(a, r) {
	                var i = 0, c = 0, m = Math.min(a.t, this.t);
	                while (i < m) {
	                    c += this[i] + a[i];
	                    r[i++] = c & this.DM;
	                    c >>= this.DB
	                }
	                if (a.t < this.t) {
	                    c += a.s;
	                    while (i < this.t) {
	                        c += this[i];
	                        r[i++] = c & this.DM;
	                        c >>= this.DB
	                    }
	                    c += this.s
	                } else {
	                    c += this.s;
	                    while (i < a.t) {
	                        c += a[i];
	                        r[i++] = c & this.DM;
	                        c >>= this.DB
	                    }
	                    c += a.s
	                }
	                r.s = c < 0 ? -1 : 0;
	                if (c > 0)r[i++] = c; else if (c < -1)r[i++] = this.DV + c;
	                r.t = i;
	                r.clamp()
	            }

	            BigInteger.prototype.fromRadix = bnpFromRadix;
	            BigInteger.prototype.chunkSize = bnpChunkSize;
	            BigInteger.prototype.signum = bnSigNum;
	            BigInteger.prototype.dMultiply = bnpDMultiply;
	            BigInteger.prototype.dAddOffset = bnpDAddOffset;
	            BigInteger.prototype.toRadix = bnpToRadix;
	            BigInteger.prototype.intValue = bnIntValue;
	            BigInteger.prototype.addTo = bnpAddTo;
	            var Wrapper = {
	                abs: (function (l, h) {
	                    var x = new goog.math.Long(l, h);
	                    var ret;
	                    if (x.isNegative()) {
	                        ret = x.negate()
	                    } else {
	                        ret = x
	                    }
	                    HEAP32[tempDoublePtr >> 2] = ret.low_;
	                    HEAP32[tempDoublePtr + 4 >> 2] = ret.high_
	                }), ensureTemps: (function () {
	                    if (Wrapper.ensuredTemps)return;
	                    Wrapper.ensuredTemps = true;
	                    Wrapper.two32 = new BigInteger;
	                    Wrapper.two32.fromString("4294967296", 10);
	                    Wrapper.two64 = new BigInteger;
	                    Wrapper.two64.fromString("18446744073709551616", 10);
	                    Wrapper.temp1 = new BigInteger;
	                    Wrapper.temp2 = new BigInteger
	                }), lh2bignum: (function (l, h) {
	                    var a = new BigInteger;
	                    a.fromString(h.toString(), 10);
	                    var b = new BigInteger;
	                    a.multiplyTo(Wrapper.two32, b);
	                    var c = new BigInteger;
	                    c.fromString(l.toString(), 10);
	                    var d = new BigInteger;
	                    c.addTo(b, d);
	                    return d
	                }), stringify: (function (l, h, unsigned) {
	                    var ret = (new goog.math.Long(l, h)).toString();
	                    if (unsigned && ret[0] == "-") {
	                        Wrapper.ensureTemps();
	                        var bignum = new BigInteger;
	                        bignum.fromString(ret, 10);
	                        ret = new BigInteger;
	                        Wrapper.two64.addTo(bignum, ret);
	                        ret = ret.toString(10)
	                    }
	                    return ret
	                }), fromString: (function (str, base, min, max, unsigned) {
	                    Wrapper.ensureTemps();
	                    var bignum = new BigInteger;
	                    bignum.fromString(str, base);
	                    var bigmin = new BigInteger;
	                    bigmin.fromString(min, 10);
	                    var bigmax = new BigInteger;
	                    bigmax.fromString(max, 10);
	                    if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
	                        var temp = new BigInteger;
	                        bignum.addTo(Wrapper.two64, temp);
	                        bignum = temp
	                    }
	                    var error = false;
	                    if (bignum.compareTo(bigmin) < 0) {
	                        bignum = bigmin;
	                        error = true
	                    } else if (bignum.compareTo(bigmax) > 0) {
	                        bignum = bigmax;
	                        error = true
	                    }
	                    var ret = goog.math.Long.fromString(bignum.toString());
	                    HEAP32[tempDoublePtr >> 2] = ret.low_;
	                    HEAP32[tempDoublePtr + 4 >> 2] = ret.high_;
	                    if (error)throw"range error"
	                })
	            };
	            return Wrapper
	        })();
	        if (memoryInitializer) {
	            if (typeof Module["locateFile"] === "function") {
	                memoryInitializer = Module["locateFile"](memoryInitializer)
	            } else if (Module["memoryInitializerPrefixURL"]) {
	                memoryInitializer = Module["memoryInitializerPrefixURL"] + memoryInitializer
	            }
	            
	                addRunDependency("memory initializer");
	                Browser.asyncLoad(memoryInitializer, (function (data) {
	                    HEAPU8.set(data, STATIC_BASE);
	                    removeRunDependency("memory initializer")
	                }), (function (data) {
	                    throw"could not load memory initializer " + memoryInitializer
	                }))
	            
	        }
	        function ExitStatus(status) {
	            this.name = "ExitStatus";
	            this.message = "Program terminated with exit(" + status + ")";
	            this.status = status
	        }

	        ExitStatus.prototype = new Error;
	        ExitStatus.prototype.constructor = ExitStatus;
	        var initialStackTop;
	        var preloadStartTime = null;
	        var calledMain = false;
	        dependenciesFulfilled = function runCaller() {
	            if (!Module["calledRun"] && shouldRunNow)run();
	            if (!Module["calledRun"])dependenciesFulfilled = runCaller
	        };
	        Module["callMain"] = Module.callMain = function callMain(args) {
	            assert(runDependencies == 0, "cannot call main when async dependencies remain! (listen on __ATMAIN__)");
	            assert(__ATPRERUN__.length == 0, "cannot call main when preRun functions remain to be called");
	            args = args || [];
	            ensureInitRuntime();
	            var argc = args.length + 1;

	            function pad() {
	                for (var i = 0; i < 4 - 1; i++) {
	                    argv.push(0)
	                }
	            }

	            var argv = [allocate(intArrayFromString(Module["thisProgram"]), "i8", ALLOC_NORMAL)];
	            pad();
	            for (var i = 0; i < argc - 1; i = i + 1) {
	                argv.push(allocate(intArrayFromString(args[i]), "i8", ALLOC_NORMAL));
	                pad()
	            }
	            argv.push(0);
	            argv = allocate(argv, "i32", ALLOC_NORMAL);
	            initialStackTop = STACKTOP;
	            try {
	                var ret = Module["_main"](argc, argv, 0);
	                exit(ret)
	            } catch (e) {
	                if (e instanceof ExitStatus) {
	                    return
	                } else if (e == "SimulateInfiniteLoop") {
	                    Module["noExitRuntime"] = true;
	                    return
	                } else {
	                    if (e && typeof e === "object" && e.stack)Module.printErr("exception thrown: " + [e, e.stack]);
	                    throw e
	                }
	            } finally {
	                calledMain = true
	            }
	        };
	        function run(args) {
	            args = args || Module["arguments"];
	            if (preloadStartTime === null)preloadStartTime = Date.now();
	            if (runDependencies > 0) {
	                return
	            }
	            preRun();
	            if (runDependencies > 0)return;
	            if (Module["calledRun"])return;
	            function doRun() {
	                if (Module["calledRun"])return;
	                Module["calledRun"] = true;
	                if (ABORT)return;
	                ensureInitRuntime();
	                preMain();
	                if (preloadStartTime !== null) {
	                    if ((Date.now() - preloadStartTime)>15) {
	                        Module.printErr("pre-main prep time: " + (Date.now() - preloadStartTime) + " ms")
	                    }
	                }
	                if (Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();
	                if (Module["_main"] && shouldRunNow)Module["callMain"](args);
	                postRun()
	            }

	            if (Module["setStatus"]) {
	                Module["setStatus"]("Running...");
	                setTimeout((function () {
	                    setTimeout((function () {
	                        Module["setStatus"]("")
	                    }), 1);
	                    doRun()
	                }), 1)
	            } else {
	                doRun()
	            }
	        }

	        Module["run"] = Module.run = run;
	        function exit(status) {
	            if (Module["noExitRuntime"]) {
	                return
	            }
	            ABORT = true;
	            EXITSTATUS = status;
	            STACKTOP = initialStackTop;
	            exitRuntime();
	            
	            throw new ExitStatus(status)
	        }

	        Module["exit"] = Module.exit = exit;
	        function abort(text) {
	            if (text) {
	                Module.print(text);
	                Module.printErr(text)
	            }
	            ABORT = true;
	            EXITSTATUS = 1;
	            var extra = "\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";
	            throw"abort() at " + stackTrace() + extra
	        }

	        Module["abort"] = Module.abort = abort;
	        if (Module["preInit"]) {
	            if (typeof Module["preInit"] == "function")Module["preInit"] = [Module["preInit"]];
	            while (Module["preInit"].length > 0) {
	                Module["preInit"].pop()()
	            }
	        }
	        var shouldRunNow = true;
	        if (Module["noInitialRun"]) {
	            shouldRunNow = false
	        }
	        run()


	        Module['return'] = Module['return'].split('\n').slice(0, -2);

	        // Do this in a JSLint style way...
	        return {
	            errors: Module['return'].length ? Module['return'] : null
	        };
	    }
	})();

	if(true) {module.exports = xmllint}
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2).Buffer))

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */
	/* eslint-disable no-proto */

	'use strict'

	var base64 = __webpack_require__(3)
	var ieee754 = __webpack_require__(4)
	var isArray = __webpack_require__(5)

	exports.Buffer = Buffer
	exports.SlowBuffer = SlowBuffer
	exports.INSPECT_MAX_BYTES = 50

	/**
	 * If `Buffer.TYPED_ARRAY_SUPPORT`:
	 *   === true    Use Uint8Array implementation (fastest)
	 *   === false   Use Object implementation (most compatible, even IE6)
	 *
	 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
	 * Opera 11.6+, iOS 4.2+.
	 *
	 * Due to various browser bugs, sometimes the Object implementation will be used even
	 * when the browser supports typed arrays.
	 *
	 * Note:
	 *
	 *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
	 *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
	 *
	 *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
	 *
	 *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
	 *     incorrect length in some situations.

	 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
	 * get the Object implementation, which is slower but behaves correctly.
	 */
	Buffer.TYPED_ARRAY_SUPPORT = global.TYPED_ARRAY_SUPPORT !== undefined
	  ? global.TYPED_ARRAY_SUPPORT
	  : typedArraySupport()

	/*
	 * Export kMaxLength after typed array support is determined.
	 */
	exports.kMaxLength = kMaxLength()

	function typedArraySupport () {
	  try {
	    var arr = new Uint8Array(1)
	    arr.__proto__ = {__proto__: Uint8Array.prototype, foo: function () { return 42 }}
	    return arr.foo() === 42 && // typed array instances can be augmented
	        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
	        arr.subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
	  } catch (e) {
	    return false
	  }
	}

	function kMaxLength () {
	  return Buffer.TYPED_ARRAY_SUPPORT
	    ? 0x7fffffff
	    : 0x3fffffff
	}

	function createBuffer (that, length) {
	  if (kMaxLength() < length) {
	    throw new RangeError('Invalid typed array length')
	  }
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = new Uint8Array(length)
	    that.__proto__ = Buffer.prototype
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    if (that === null) {
	      that = new Buffer(length)
	    }
	    that.length = length
	  }

	  return that
	}

	/**
	 * The Buffer constructor returns instances of `Uint8Array` that have their
	 * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
	 * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
	 * and the `Uint8Array` methods. Square bracket notation works as expected -- it
	 * returns a single octet.
	 *
	 * The `Uint8Array` prototype remains unmodified.
	 */

	function Buffer (arg, encodingOrOffset, length) {
	  if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
	    return new Buffer(arg, encodingOrOffset, length)
	  }

	  // Common case.
	  if (typeof arg === 'number') {
	    if (typeof encodingOrOffset === 'string') {
	      throw new Error(
	        'If encoding is specified then the first argument must be a string'
	      )
	    }
	    return allocUnsafe(this, arg)
	  }
	  return from(this, arg, encodingOrOffset, length)
	}

	Buffer.poolSize = 8192 // not used by this implementation

	// TODO: Legacy, not needed anymore. Remove in next major version.
	Buffer._augment = function (arr) {
	  arr.__proto__ = Buffer.prototype
	  return arr
	}

	function from (that, value, encodingOrOffset, length) {
	  if (typeof value === 'number') {
	    throw new TypeError('"value" argument must not be a number')
	  }

	  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
	    return fromArrayBuffer(that, value, encodingOrOffset, length)
	  }

	  if (typeof value === 'string') {
	    return fromString(that, value, encodingOrOffset)
	  }

	  return fromObject(that, value)
	}

	/**
	 * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
	 * if value is a number.
	 * Buffer.from(str[, encoding])
	 * Buffer.from(array)
	 * Buffer.from(buffer)
	 * Buffer.from(arrayBuffer[, byteOffset[, length]])
	 **/
	Buffer.from = function (value, encodingOrOffset, length) {
	  return from(null, value, encodingOrOffset, length)
	}

	if (Buffer.TYPED_ARRAY_SUPPORT) {
	  Buffer.prototype.__proto__ = Uint8Array.prototype
	  Buffer.__proto__ = Uint8Array
	  if (typeof Symbol !== 'undefined' && Symbol.species &&
	      Buffer[Symbol.species] === Buffer) {
	    // Fix subarray() in ES2016. See: https://github.com/feross/buffer/pull/97
	    Object.defineProperty(Buffer, Symbol.species, {
	      value: null,
	      configurable: true
	    })
	  }
	}

	function assertSize (size) {
	  if (typeof size !== 'number') {
	    throw new TypeError('"size" argument must be a number')
	  } else if (size < 0) {
	    throw new RangeError('"size" argument must not be negative')
	  }
	}

	function alloc (that, size, fill, encoding) {
	  assertSize(size)
	  if (size <= 0) {
	    return createBuffer(that, size)
	  }
	  if (fill !== undefined) {
	    // Only pay attention to encoding if it's a string. This
	    // prevents accidentally sending in a number that would
	    // be interpretted as a start offset.
	    return typeof encoding === 'string'
	      ? createBuffer(that, size).fill(fill, encoding)
	      : createBuffer(that, size).fill(fill)
	  }
	  return createBuffer(that, size)
	}

	/**
	 * Creates a new filled Buffer instance.
	 * alloc(size[, fill[, encoding]])
	 **/
	Buffer.alloc = function (size, fill, encoding) {
	  return alloc(null, size, fill, encoding)
	}

	function allocUnsafe (that, size) {
	  assertSize(size)
	  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < size; ++i) {
	      that[i] = 0
	    }
	  }
	  return that
	}

	/**
	 * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
	 * */
	Buffer.allocUnsafe = function (size) {
	  return allocUnsafe(null, size)
	}
	/**
	 * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
	 */
	Buffer.allocUnsafeSlow = function (size) {
	  return allocUnsafe(null, size)
	}

	function fromString (that, string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') {
	    encoding = 'utf8'
	  }

	  if (!Buffer.isEncoding(encoding)) {
	    throw new TypeError('"encoding" must be a valid string encoding')
	  }

	  var length = byteLength(string, encoding) | 0
	  that = createBuffer(that, length)

	  var actual = that.write(string, encoding)

	  if (actual !== length) {
	    // Writing a hex string, for example, that contains invalid characters will
	    // cause everything after the first invalid character to be ignored. (e.g.
	    // 'abxxcd' will be treated as 'ab')
	    that = that.slice(0, actual)
	  }

	  return that
	}

	function fromArrayLike (that, array) {
	  var length = array.length < 0 ? 0 : checked(array.length) | 0
	  that = createBuffer(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	function fromArrayBuffer (that, array, byteOffset, length) {
	  array.byteLength // this throws if `array` is not a valid ArrayBuffer

	  if (byteOffset < 0 || array.byteLength < byteOffset) {
	    throw new RangeError('\'offset\' is out of bounds')
	  }

	  if (array.byteLength < byteOffset + (length || 0)) {
	    throw new RangeError('\'length\' is out of bounds')
	  }

	  if (byteOffset === undefined && length === undefined) {
	    array = new Uint8Array(array)
	  } else if (length === undefined) {
	    array = new Uint8Array(array, byteOffset)
	  } else {
	    array = new Uint8Array(array, byteOffset, length)
	  }

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = array
	    that.__proto__ = Buffer.prototype
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that = fromArrayLike(that, array)
	  }
	  return that
	}

	function fromObject (that, obj) {
	  if (Buffer.isBuffer(obj)) {
	    var len = checked(obj.length) | 0
	    that = createBuffer(that, len)

	    if (that.length === 0) {
	      return that
	    }

	    obj.copy(that, 0, 0, len)
	    return that
	  }

	  if (obj) {
	    if ((typeof ArrayBuffer !== 'undefined' &&
	        obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
	      if (typeof obj.length !== 'number' || isnan(obj.length)) {
	        return createBuffer(that, 0)
	      }
	      return fromArrayLike(that, obj)
	    }

	    if (obj.type === 'Buffer' && isArray(obj.data)) {
	      return fromArrayLike(that, obj.data)
	    }
	  }

	  throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
	}

	function checked (length) {
	  // Note: cannot use `length < kMaxLength()` here because that fails when
	  // length is NaN (which is otherwise coerced to zero.)
	  if (length >= kMaxLength()) {
	    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
	                         'size: 0x' + kMaxLength().toString(16) + ' bytes')
	  }
	  return length | 0
	}

	function SlowBuffer (length) {
	  if (+length != length) { // eslint-disable-line eqeqeq
	    length = 0
	  }
	  return Buffer.alloc(+length)
	}

	Buffer.isBuffer = function isBuffer (b) {
	  return !!(b != null && b._isBuffer)
	}

	Buffer.compare = function compare (a, b) {
	  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
	    throw new TypeError('Arguments must be Buffers')
	  }

	  if (a === b) return 0

	  var x = a.length
	  var y = b.length

	  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
	    if (a[i] !== b[i]) {
	      x = a[i]
	      y = b[i]
	      break
	    }
	  }

	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}

	Buffer.isEncoding = function isEncoding (encoding) {
	  switch (String(encoding).toLowerCase()) {
	    case 'hex':
	    case 'utf8':
	    case 'utf-8':
	    case 'ascii':
	    case 'latin1':
	    case 'binary':
	    case 'base64':
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return true
	    default:
	      return false
	  }
	}

	Buffer.concat = function concat (list, length) {
	  if (!isArray(list)) {
	    throw new TypeError('"list" argument must be an Array of Buffers')
	  }

	  if (list.length === 0) {
	    return Buffer.alloc(0)
	  }

	  var i
	  if (length === undefined) {
	    length = 0
	    for (i = 0; i < list.length; ++i) {
	      length += list[i].length
	    }
	  }

	  var buffer = Buffer.allocUnsafe(length)
	  var pos = 0
	  for (i = 0; i < list.length; ++i) {
	    var buf = list[i]
	    if (!Buffer.isBuffer(buf)) {
	      throw new TypeError('"list" argument must be an Array of Buffers')
	    }
	    buf.copy(buffer, pos)
	    pos += buf.length
	  }
	  return buffer
	}

	function byteLength (string, encoding) {
	  if (Buffer.isBuffer(string)) {
	    return string.length
	  }
	  if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
	      (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
	    return string.byteLength
	  }
	  if (typeof string !== 'string') {
	    string = '' + string
	  }

	  var len = string.length
	  if (len === 0) return 0

	  // Use a for loop to avoid recursion
	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'ascii':
	      case 'latin1':
	      case 'binary':
	        return len
	      case 'utf8':
	      case 'utf-8':
	      case undefined:
	        return utf8ToBytes(string).length
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return len * 2
	      case 'hex':
	        return len >>> 1
	      case 'base64':
	        return base64ToBytes(string).length
	      default:
	        if (loweredCase) return utf8ToBytes(string).length // assume utf8
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}
	Buffer.byteLength = byteLength

	function slowToString (encoding, start, end) {
	  var loweredCase = false

	  // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
	  // property of a typed array.

	  // This behaves neither like String nor Uint8Array in that we set start/end
	  // to their upper/lower bounds if the value passed is out of range.
	  // undefined is handled specially as per ECMA-262 6th Edition,
	  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
	  if (start === undefined || start < 0) {
	    start = 0
	  }
	  // Return early if start > this.length. Done here to prevent potential uint32
	  // coercion fail below.
	  if (start > this.length) {
	    return ''
	  }

	  if (end === undefined || end > this.length) {
	    end = this.length
	  }

	  if (end <= 0) {
	    return ''
	  }

	  // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
	  end >>>= 0
	  start >>>= 0

	  if (end <= start) {
	    return ''
	  }

	  if (!encoding) encoding = 'utf8'

	  while (true) {
	    switch (encoding) {
	      case 'hex':
	        return hexSlice(this, start, end)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Slice(this, start, end)

	      case 'ascii':
	        return asciiSlice(this, start, end)

	      case 'latin1':
	      case 'binary':
	        return latin1Slice(this, start, end)

	      case 'base64':
	        return base64Slice(this, start, end)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return utf16leSlice(this, start, end)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = (encoding + '').toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	// The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
	// Buffer instances.
	Buffer.prototype._isBuffer = true

	function swap (b, n, m) {
	  var i = b[n]
	  b[n] = b[m]
	  b[m] = i
	}

	Buffer.prototype.swap16 = function swap16 () {
	  var len = this.length
	  if (len % 2 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 16-bits')
	  }
	  for (var i = 0; i < len; i += 2) {
	    swap(this, i, i + 1)
	  }
	  return this
	}

	Buffer.prototype.swap32 = function swap32 () {
	  var len = this.length
	  if (len % 4 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 32-bits')
	  }
	  for (var i = 0; i < len; i += 4) {
	    swap(this, i, i + 3)
	    swap(this, i + 1, i + 2)
	  }
	  return this
	}

	Buffer.prototype.swap64 = function swap64 () {
	  var len = this.length
	  if (len % 8 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 64-bits')
	  }
	  for (var i = 0; i < len; i += 8) {
	    swap(this, i, i + 7)
	    swap(this, i + 1, i + 6)
	    swap(this, i + 2, i + 5)
	    swap(this, i + 3, i + 4)
	  }
	  return this
	}

	Buffer.prototype.toString = function toString () {
	  var length = this.length | 0
	  if (length === 0) return ''
	  if (arguments.length === 0) return utf8Slice(this, 0, length)
	  return slowToString.apply(this, arguments)
	}

	Buffer.prototype.equals = function equals (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return true
	  return Buffer.compare(this, b) === 0
	}

	Buffer.prototype.inspect = function inspect () {
	  var str = ''
	  var max = exports.INSPECT_MAX_BYTES
	  if (this.length > 0) {
	    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
	    if (this.length > max) str += ' ... '
	  }
	  return '<Buffer ' + str + '>'
	}

	Buffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
	  if (!Buffer.isBuffer(target)) {
	    throw new TypeError('Argument must be a Buffer')
	  }

	  if (start === undefined) {
	    start = 0
	  }
	  if (end === undefined) {
	    end = target ? target.length : 0
	  }
	  if (thisStart === undefined) {
	    thisStart = 0
	  }
	  if (thisEnd === undefined) {
	    thisEnd = this.length
	  }

	  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
	    throw new RangeError('out of range index')
	  }

	  if (thisStart >= thisEnd && start >= end) {
	    return 0
	  }
	  if (thisStart >= thisEnd) {
	    return -1
	  }
	  if (start >= end) {
	    return 1
	  }

	  start >>>= 0
	  end >>>= 0
	  thisStart >>>= 0
	  thisEnd >>>= 0

	  if (this === target) return 0

	  var x = thisEnd - thisStart
	  var y = end - start
	  var len = Math.min(x, y)

	  var thisCopy = this.slice(thisStart, thisEnd)
	  var targetCopy = target.slice(start, end)

	  for (var i = 0; i < len; ++i) {
	    if (thisCopy[i] !== targetCopy[i]) {
	      x = thisCopy[i]
	      y = targetCopy[i]
	      break
	    }
	  }

	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}

	// Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
	// OR the last index of `val` in `buffer` at offset <= `byteOffset`.
	//
	// Arguments:
	// - buffer - a Buffer to search
	// - val - a string, Buffer, or number
	// - byteOffset - an index into `buffer`; will be clamped to an int32
	// - encoding - an optional encoding, relevant is val is a string
	// - dir - true for indexOf, false for lastIndexOf
	function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
	  // Empty buffer means no match
	  if (buffer.length === 0) return -1

	  // Normalize byteOffset
	  if (typeof byteOffset === 'string') {
	    encoding = byteOffset
	    byteOffset = 0
	  } else if (byteOffset > 0x7fffffff) {
	    byteOffset = 0x7fffffff
	  } else if (byteOffset < -0x80000000) {
	    byteOffset = -0x80000000
	  }
	  byteOffset = +byteOffset  // Coerce to Number.
	  if (isNaN(byteOffset)) {
	    // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
	    byteOffset = dir ? 0 : (buffer.length - 1)
	  }

	  // Normalize byteOffset: negative offsets start from the end of the buffer
	  if (byteOffset < 0) byteOffset = buffer.length + byteOffset
	  if (byteOffset >= buffer.length) {
	    if (dir) return -1
	    else byteOffset = buffer.length - 1
	  } else if (byteOffset < 0) {
	    if (dir) byteOffset = 0
	    else return -1
	  }

	  // Normalize val
	  if (typeof val === 'string') {
	    val = Buffer.from(val, encoding)
	  }

	  // Finally, search either indexOf (if dir is true) or lastIndexOf
	  if (Buffer.isBuffer(val)) {
	    // Special case: looking for empty string/buffer always fails
	    if (val.length === 0) {
	      return -1
	    }
	    return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
	  } else if (typeof val === 'number') {
	    val = val & 0xFF // Search for a byte value [0-255]
	    if (Buffer.TYPED_ARRAY_SUPPORT &&
	        typeof Uint8Array.prototype.indexOf === 'function') {
	      if (dir) {
	        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
	      } else {
	        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
	      }
	    }
	    return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
	  }

	  throw new TypeError('val must be string, number or Buffer')
	}

	function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
	  var indexSize = 1
	  var arrLength = arr.length
	  var valLength = val.length

	  if (encoding !== undefined) {
	    encoding = String(encoding).toLowerCase()
	    if (encoding === 'ucs2' || encoding === 'ucs-2' ||
	        encoding === 'utf16le' || encoding === 'utf-16le') {
	      if (arr.length < 2 || val.length < 2) {
	        return -1
	      }
	      indexSize = 2
	      arrLength /= 2
	      valLength /= 2
	      byteOffset /= 2
	    }
	  }

	  function read (buf, i) {
	    if (indexSize === 1) {
	      return buf[i]
	    } else {
	      return buf.readUInt16BE(i * indexSize)
	    }
	  }

	  var i
	  if (dir) {
	    var foundIndex = -1
	    for (i = byteOffset; i < arrLength; i++) {
	      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
	        if (foundIndex === -1) foundIndex = i
	        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
	      } else {
	        if (foundIndex !== -1) i -= i - foundIndex
	        foundIndex = -1
	      }
	    }
	  } else {
	    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength
	    for (i = byteOffset; i >= 0; i--) {
	      var found = true
	      for (var j = 0; j < valLength; j++) {
	        if (read(arr, i + j) !== read(val, j)) {
	          found = false
	          break
	        }
	      }
	      if (found) return i
	    }
	  }

	  return -1
	}

	Buffer.prototype.includes = function includes (val, byteOffset, encoding) {
	  return this.indexOf(val, byteOffset, encoding) !== -1
	}

	Buffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
	  return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
	}

	Buffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
	  return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
	}

	function hexWrite (buf, string, offset, length) {
	  offset = Number(offset) || 0
	  var remaining = buf.length - offset
	  if (!length) {
	    length = remaining
	  } else {
	    length = Number(length)
	    if (length > remaining) {
	      length = remaining
	    }
	  }

	  // must be an even number of digits
	  var strLen = string.length
	  if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

	  if (length > strLen / 2) {
	    length = strLen / 2
	  }
	  for (var i = 0; i < length; ++i) {
	    var parsed = parseInt(string.substr(i * 2, 2), 16)
	    if (isNaN(parsed)) return i
	    buf[offset + i] = parsed
	  }
	  return i
	}

	function utf8Write (buf, string, offset, length) {
	  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
	}

	function asciiWrite (buf, string, offset, length) {
	  return blitBuffer(asciiToBytes(string), buf, offset, length)
	}

	function latin1Write (buf, string, offset, length) {
	  return asciiWrite(buf, string, offset, length)
	}

	function base64Write (buf, string, offset, length) {
	  return blitBuffer(base64ToBytes(string), buf, offset, length)
	}

	function ucs2Write (buf, string, offset, length) {
	  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
	}

	Buffer.prototype.write = function write (string, offset, length, encoding) {
	  // Buffer#write(string)
	  if (offset === undefined) {
	    encoding = 'utf8'
	    length = this.length
	    offset = 0
	  // Buffer#write(string, encoding)
	  } else if (length === undefined && typeof offset === 'string') {
	    encoding = offset
	    length = this.length
	    offset = 0
	  // Buffer#write(string, offset[, length][, encoding])
	  } else if (isFinite(offset)) {
	    offset = offset | 0
	    if (isFinite(length)) {
	      length = length | 0
	      if (encoding === undefined) encoding = 'utf8'
	    } else {
	      encoding = length
	      length = undefined
	    }
	  // legacy write(string, encoding, offset, length) - remove in v0.13
	  } else {
	    throw new Error(
	      'Buffer.write(string, encoding, offset[, length]) is no longer supported'
	    )
	  }

	  var remaining = this.length - offset
	  if (length === undefined || length > remaining) length = remaining

	  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
	    throw new RangeError('Attempt to write outside buffer bounds')
	  }

	  if (!encoding) encoding = 'utf8'

	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'hex':
	        return hexWrite(this, string, offset, length)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Write(this, string, offset, length)

	      case 'ascii':
	        return asciiWrite(this, string, offset, length)

	      case 'latin1':
	      case 'binary':
	        return latin1Write(this, string, offset, length)

	      case 'base64':
	        // Warning: maxLength not taken into account in base64Write
	        return base64Write(this, string, offset, length)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return ucs2Write(this, string, offset, length)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	Buffer.prototype.toJSON = function toJSON () {
	  return {
	    type: 'Buffer',
	    data: Array.prototype.slice.call(this._arr || this, 0)
	  }
	}

	function base64Slice (buf, start, end) {
	  if (start === 0 && end === buf.length) {
	    return base64.fromByteArray(buf)
	  } else {
	    return base64.fromByteArray(buf.slice(start, end))
	  }
	}

	function utf8Slice (buf, start, end) {
	  end = Math.min(buf.length, end)
	  var res = []

	  var i = start
	  while (i < end) {
	    var firstByte = buf[i]
	    var codePoint = null
	    var bytesPerSequence = (firstByte > 0xEF) ? 4
	      : (firstByte > 0xDF) ? 3
	      : (firstByte > 0xBF) ? 2
	      : 1

	    if (i + bytesPerSequence <= end) {
	      var secondByte, thirdByte, fourthByte, tempCodePoint

	      switch (bytesPerSequence) {
	        case 1:
	          if (firstByte < 0x80) {
	            codePoint = firstByte
	          }
	          break
	        case 2:
	          secondByte = buf[i + 1]
	          if ((secondByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)
	            if (tempCodePoint > 0x7F) {
	              codePoint = tempCodePoint
	            }
	          }
	          break
	        case 3:
	          secondByte = buf[i + 1]
	          thirdByte = buf[i + 2]
	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)
	            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
	              codePoint = tempCodePoint
	            }
	          }
	          break
	        case 4:
	          secondByte = buf[i + 1]
	          thirdByte = buf[i + 2]
	          fourthByte = buf[i + 3]
	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)
	            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
	              codePoint = tempCodePoint
	            }
	          }
	      }
	    }

	    if (codePoint === null) {
	      // we did not generate a valid codePoint so insert a
	      // replacement char (U+FFFD) and advance only 1 byte
	      codePoint = 0xFFFD
	      bytesPerSequence = 1
	    } else if (codePoint > 0xFFFF) {
	      // encode to utf16 (surrogate pair dance)
	      codePoint -= 0x10000
	      res.push(codePoint >>> 10 & 0x3FF | 0xD800)
	      codePoint = 0xDC00 | codePoint & 0x3FF
	    }

	    res.push(codePoint)
	    i += bytesPerSequence
	  }

	  return decodeCodePointsArray(res)
	}

	// Based on http://stackoverflow.com/a/22747272/680742, the browser with
	// the lowest limit is Chrome, with 0x10000 args.
	// We go 1 magnitude less, for safety
	var MAX_ARGUMENTS_LENGTH = 0x1000

	function decodeCodePointsArray (codePoints) {
	  var len = codePoints.length
	  if (len <= MAX_ARGUMENTS_LENGTH) {
	    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
	  }

	  // Decode in chunks to avoid "call stack size exceeded".
	  var res = ''
	  var i = 0
	  while (i < len) {
	    res += String.fromCharCode.apply(
	      String,
	      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
	    )
	  }
	  return res
	}

	function asciiSlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; ++i) {
	    ret += String.fromCharCode(buf[i] & 0x7F)
	  }
	  return ret
	}

	function latin1Slice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; ++i) {
	    ret += String.fromCharCode(buf[i])
	  }
	  return ret
	}

	function hexSlice (buf, start, end) {
	  var len = buf.length

	  if (!start || start < 0) start = 0
	  if (!end || end < 0 || end > len) end = len

	  var out = ''
	  for (var i = start; i < end; ++i) {
	    out += toHex(buf[i])
	  }
	  return out
	}

	function utf16leSlice (buf, start, end) {
	  var bytes = buf.slice(start, end)
	  var res = ''
	  for (var i = 0; i < bytes.length; i += 2) {
	    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
	  }
	  return res
	}

	Buffer.prototype.slice = function slice (start, end) {
	  var len = this.length
	  start = ~~start
	  end = end === undefined ? len : ~~end

	  if (start < 0) {
	    start += len
	    if (start < 0) start = 0
	  } else if (start > len) {
	    start = len
	  }

	  if (end < 0) {
	    end += len
	    if (end < 0) end = 0
	  } else if (end > len) {
	    end = len
	  }

	  if (end < start) end = start

	  var newBuf
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    newBuf = this.subarray(start, end)
	    newBuf.__proto__ = Buffer.prototype
	  } else {
	    var sliceLen = end - start
	    newBuf = new Buffer(sliceLen, undefined)
	    for (var i = 0; i < sliceLen; ++i) {
	      newBuf[i] = this[i + start]
	    }
	  }

	  return newBuf
	}

	/*
	 * Need to make sure that buffer isn't trying to write out of bounds.
	 */
	function checkOffset (offset, ext, length) {
	  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
	  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
	}

	Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }

	  return val
	}

	Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    checkOffset(offset, byteLength, this.length)
	  }

	  var val = this[offset + --byteLength]
	  var mul = 1
	  while (byteLength > 0 && (mul *= 0x100)) {
	    val += this[offset + --byteLength] * mul
	  }

	  return val
	}

	Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  return this[offset]
	}

	Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return this[offset] | (this[offset + 1] << 8)
	}

	Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return (this[offset] << 8) | this[offset + 1]
	}

	Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return ((this[offset]) |
	      (this[offset + 1] << 8) |
	      (this[offset + 2] << 16)) +
	      (this[offset + 3] * 0x1000000)
	}

	Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] * 0x1000000) +
	    ((this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    this[offset + 3])
	}

	Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var i = byteLength
	  var mul = 1
	  var val = this[offset + --i]
	  while (i > 0 && (mul *= 0x100)) {
	    val += this[offset + --i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  if (!(this[offset] & 0x80)) return (this[offset])
	  return ((0xff - this[offset] + 1) * -1)
	}

	Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset] | (this[offset + 1] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset + 1] | (this[offset] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset]) |
	    (this[offset + 1] << 8) |
	    (this[offset + 2] << 16) |
	    (this[offset + 3] << 24)
	}

	Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] << 24) |
	    (this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    (this[offset + 3])
	}

	Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, true, 23, 4)
	}

	Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, false, 23, 4)
	}

	Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, true, 52, 8)
	}

	Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, false, 52, 8)
	}

	function checkInt (buf, value, offset, ext, max, min) {
	  if (!Buffer.isBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
	  if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('Index out of range')
	}

	Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    var maxBytes = Math.pow(2, 8 * byteLength) - 1
	    checkInt(this, value, offset, byteLength, maxBytes, 0)
	  }

	  var mul = 1
	  var i = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    var maxBytes = Math.pow(2, 8 * byteLength) - 1
	    checkInt(this, value, offset, byteLength, maxBytes, 0)
	  }

	  var i = byteLength - 1
	  var mul = 1
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  this[offset] = (value & 0xff)
	  return offset + 1
	}

	function objectWriteUInt16 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
	    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
	      (littleEndian ? i : 1 - i) * 8
	  }
	}

	Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = (value & 0xff)
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	function objectWriteUInt32 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffffffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
	    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
	  }
	}

	Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset + 3] = (value >>> 24)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 1] = (value >>> 8)
	    this[offset] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = 0
	  var mul = 1
	  var sub = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
	      sub = 1
	    }
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = byteLength - 1
	  var mul = 1
	  var sub = 0
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
	      sub = 1
	    }
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  if (value < 0) value = 0xff + value + 1
	  this[offset] = (value & 0xff)
	  return offset + 1
	}

	Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = (value & 0xff)
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 3] = (value >>> 24)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (value < 0) value = 0xffffffff + value + 1
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	function checkIEEE754 (buf, value, offset, ext, max, min) {
	  if (offset + ext > buf.length) throw new RangeError('Index out of range')
	  if (offset < 0) throw new RangeError('Index out of range')
	}

	function writeFloat (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 23, 4)
	  return offset + 4
	}

	Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, false, noAssert)
	}

	function writeDouble (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 52, 8)
	  return offset + 8
	}

	Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, false, noAssert)
	}

	// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
	Buffer.prototype.copy = function copy (target, targetStart, start, end) {
	  if (!start) start = 0
	  if (!end && end !== 0) end = this.length
	  if (targetStart >= target.length) targetStart = target.length
	  if (!targetStart) targetStart = 0
	  if (end > 0 && end < start) end = start

	  // Copy 0 bytes; we're done
	  if (end === start) return 0
	  if (target.length === 0 || this.length === 0) return 0

	  // Fatal error conditions
	  if (targetStart < 0) {
	    throw new RangeError('targetStart out of bounds')
	  }
	  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
	  if (end < 0) throw new RangeError('sourceEnd out of bounds')

	  // Are we oob?
	  if (end > this.length) end = this.length
	  if (target.length - targetStart < end - start) {
	    end = target.length - targetStart + start
	  }

	  var len = end - start
	  var i

	  if (this === target && start < targetStart && targetStart < end) {
	    // descending copy from end
	    for (i = len - 1; i >= 0; --i) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
	    // ascending copy from start
	    for (i = 0; i < len; ++i) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else {
	    Uint8Array.prototype.set.call(
	      target,
	      this.subarray(start, start + len),
	      targetStart
	    )
	  }

	  return len
	}

	// Usage:
	//    buffer.fill(number[, offset[, end]])
	//    buffer.fill(buffer[, offset[, end]])
	//    buffer.fill(string[, offset[, end]][, encoding])
	Buffer.prototype.fill = function fill (val, start, end, encoding) {
	  // Handle string cases:
	  if (typeof val === 'string') {
	    if (typeof start === 'string') {
	      encoding = start
	      start = 0
	      end = this.length
	    } else if (typeof end === 'string') {
	      encoding = end
	      end = this.length
	    }
	    if (val.length === 1) {
	      var code = val.charCodeAt(0)
	      if (code < 256) {
	        val = code
	      }
	    }
	    if (encoding !== undefined && typeof encoding !== 'string') {
	      throw new TypeError('encoding must be a string')
	    }
	    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
	      throw new TypeError('Unknown encoding: ' + encoding)
	    }
	  } else if (typeof val === 'number') {
	    val = val & 255
	  }

	  // Invalid ranges are not set to a default, so can range check early.
	  if (start < 0 || this.length < start || this.length < end) {
	    throw new RangeError('Out of range index')
	  }

	  if (end <= start) {
	    return this
	  }

	  start = start >>> 0
	  end = end === undefined ? this.length : end >>> 0

	  if (!val) val = 0

	  var i
	  if (typeof val === 'number') {
	    for (i = start; i < end; ++i) {
	      this[i] = val
	    }
	  } else {
	    var bytes = Buffer.isBuffer(val)
	      ? val
	      : utf8ToBytes(new Buffer(val, encoding).toString())
	    var len = bytes.length
	    for (i = 0; i < end - start; ++i) {
	      this[i + start] = bytes[i % len]
	    }
	  }

	  return this
	}

	// HELPER FUNCTIONS
	// ================

	var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g

	function base64clean (str) {
	  // Node strips out invalid characters like \n and \t from the string, base64-js does not
	  str = stringtrim(str).replace(INVALID_BASE64_RE, '')
	  // Node converts strings with length < 2 to ''
	  if (str.length < 2) return ''
	  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
	  while (str.length % 4 !== 0) {
	    str = str + '='
	  }
	  return str
	}

	function stringtrim (str) {
	  if (str.trim) return str.trim()
	  return str.replace(/^\s+|\s+$/g, '')
	}

	function toHex (n) {
	  if (n < 16) return '0' + n.toString(16)
	  return n.toString(16)
	}

	function utf8ToBytes (string, units) {
	  units = units || Infinity
	  var codePoint
	  var length = string.length
	  var leadSurrogate = null
	  var bytes = []

	  for (var i = 0; i < length; ++i) {
	    codePoint = string.charCodeAt(i)

	    // is surrogate component
	    if (codePoint > 0xD7FF && codePoint < 0xE000) {
	      // last char was a lead
	      if (!leadSurrogate) {
	        // no lead yet
	        if (codePoint > 0xDBFF) {
	          // unexpected trail
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else if (i + 1 === length) {
	          // unpaired lead
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        }

	        // valid lead
	        leadSurrogate = codePoint

	        continue
	      }

	      // 2 leads in a row
	      if (codePoint < 0xDC00) {
	        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	        leadSurrogate = codePoint
	        continue
	      }

	      // valid surrogate pair
	      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000
	    } else if (leadSurrogate) {
	      // valid bmp char, but last char was a lead
	      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	    }

	    leadSurrogate = null

	    // encode utf8
	    if (codePoint < 0x80) {
	      if ((units -= 1) < 0) break
	      bytes.push(codePoint)
	    } else if (codePoint < 0x800) {
	      if ((units -= 2) < 0) break
	      bytes.push(
	        codePoint >> 0x6 | 0xC0,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x10000) {
	      if ((units -= 3) < 0) break
	      bytes.push(
	        codePoint >> 0xC | 0xE0,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x110000) {
	      if ((units -= 4) < 0) break
	      bytes.push(
	        codePoint >> 0x12 | 0xF0,
	        codePoint >> 0xC & 0x3F | 0x80,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else {
	      throw new Error('Invalid code point')
	    }
	  }

	  return bytes
	}

	function asciiToBytes (str) {
	  var byteArray = []
	  for (var i = 0; i < str.length; ++i) {
	    // Node's code seems to be doing this and not & 0x7F..
	    byteArray.push(str.charCodeAt(i) & 0xFF)
	  }
	  return byteArray
	}

	function utf16leToBytes (str, units) {
	  var c, hi, lo
	  var byteArray = []
	  for (var i = 0; i < str.length; ++i) {
	    if ((units -= 2) < 0) break

	    c = str.charCodeAt(i)
	    hi = c >> 8
	    lo = c % 256
	    byteArray.push(lo)
	    byteArray.push(hi)
	  }

	  return byteArray
	}

	function base64ToBytes (str) {
	  return base64.toByteArray(base64clean(str))
	}

	function blitBuffer (src, dst, offset, length) {
	  for (var i = 0; i < length; ++i) {
	    if ((i + offset >= dst.length) || (i >= src.length)) break
	    dst[i + offset] = src[i]
	  }
	  return i
	}

	function isnan (val) {
	  return val !== val // eslint-disable-line no-self-compare
	}

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	'use strict'

	exports.byteLength = byteLength
	exports.toByteArray = toByteArray
	exports.fromByteArray = fromByteArray

	var lookup = []
	var revLookup = []
	var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array

	var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
	for (var i = 0, len = code.length; i < len; ++i) {
	  lookup[i] = code[i]
	  revLookup[code.charCodeAt(i)] = i
	}

	revLookup['-'.charCodeAt(0)] = 62
	revLookup['_'.charCodeAt(0)] = 63

	function placeHoldersCount (b64) {
	  var len = b64.length
	  if (len % 4 > 0) {
	    throw new Error('Invalid string. Length must be a multiple of 4')
	  }

	  // the number of equal signs (place holders)
	  // if there are two placeholders, than the two characters before it
	  // represent one byte
	  // if there is only one, then the three characters before it represent 2 bytes
	  // this is just a cheap hack to not do indexOf twice
	  return b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0
	}

	function byteLength (b64) {
	  // base64 is 4/3 + up to two characters of the original data
	  return (b64.length * 3 / 4) - placeHoldersCount(b64)
	}

	function toByteArray (b64) {
	  var i, l, tmp, placeHolders, arr
	  var len = b64.length
	  placeHolders = placeHoldersCount(b64)

	  arr = new Arr((len * 3 / 4) - placeHolders)

	  // if there are placeholders, only get up to the last complete 4 chars
	  l = placeHolders > 0 ? len - 4 : len

	  var L = 0

	  for (i = 0; i < l; i += 4) {
	    tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)]
	    arr[L++] = (tmp >> 16) & 0xFF
	    arr[L++] = (tmp >> 8) & 0xFF
	    arr[L++] = tmp & 0xFF
	  }

	  if (placeHolders === 2) {
	    tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4)
	    arr[L++] = tmp & 0xFF
	  } else if (placeHolders === 1) {
	    tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2)
	    arr[L++] = (tmp >> 8) & 0xFF
	    arr[L++] = tmp & 0xFF
	  }

	  return arr
	}

	function tripletToBase64 (num) {
	  return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
	}

	function encodeChunk (uint8, start, end) {
	  var tmp
	  var output = []
	  for (var i = start; i < end; i += 3) {
	    tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2])
	    output.push(tripletToBase64(tmp))
	  }
	  return output.join('')
	}

	function fromByteArray (uint8) {
	  var tmp
	  var len = uint8.length
	  var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes
	  var output = ''
	  var parts = []
	  var maxChunkLength = 16383 // must be multiple of 3

	  // go through the array every three bytes, we'll deal with trailing stuff later
	  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
	    parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)))
	  }

	  // pad the end with zeros, but make sure to not forget the extra bytes
	  if (extraBytes === 1) {
	    tmp = uint8[len - 1]
	    output += lookup[tmp >> 2]
	    output += lookup[(tmp << 4) & 0x3F]
	    output += '=='
	  } else if (extraBytes === 2) {
	    tmp = (uint8[len - 2] << 8) + (uint8[len - 1])
	    output += lookup[tmp >> 10]
	    output += lookup[(tmp >> 4) & 0x3F]
	    output += lookup[(tmp << 2) & 0x3F]
	    output += '='
	  }

	  parts.push(output)

	  return parts.join('')
	}


/***/ }),
/* 4 */
/***/ (function(module, exports) {

	exports.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var nBits = -7
	  var i = isLE ? (nBytes - 1) : 0
	  var d = isLE ? -1 : 1
	  var s = buffer[offset + i]

	  i += d

	  e = s & ((1 << (-nBits)) - 1)
	  s >>= (-nBits)
	  nBits += eLen
	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & ((1 << (-nBits)) - 1)
	  e >>= (-nBits)
	  nBits += mLen
	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen)
	    e = e - eBias
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	}

	exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
	  var i = isLE ? 0 : (nBytes - 1)
	  var d = isLE ? 1 : -1
	  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

	  value = Math.abs(value)

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0
	    e = eMax
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2)
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--
	      c *= 2
	    }
	    if (e + eBias >= 1) {
	      value += rt / c
	    } else {
	      value += rt * Math.pow(2, 1 - eBias)
	    }
	    if (value * c >= 2) {
	      e++
	      c /= 2
	    }

	    if (e + eBias >= eMax) {
	      m = 0
	      e = eMax
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen)
	      e = e + eBias
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
	      e = 0
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = (e << mLen) | m
	  eLen += mLen
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128
	}


/***/ }),
/* 5 */
/***/ (function(module, exports) {

	var toString = {}.toString;

	module.exports = Array.isArray || function (arr) {
	  return toString.call(arr) == '[object Array]';
	};


/***/ })
/******/ ])
});
;
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t(function(){try{return require("RAML.XmlValidation")}catch(e){}}(),function(){try{return require("RAML.JsonValidation")}catch(e){}}(),require("typescript")):"function"==typeof define&&define.amd?define(["RAML.XmlValidation","RAML.JsonValidation","typescript"],t):"object"==typeof exports?exports.Parser=t(function(){try{return require("RAML.XmlValidation")}catch(e){}}(),function(){try{return require("RAML.JsonValidation")}catch(e){}}(),require("typescript")):(e.RAML=e.RAML||{},e.RAML.Parser=t(e["RAML.XmlValidation"],e["RAML.JsonValidation"],e.typescript))}(this,function(__WEBPACK_EXTERNAL_MODULE_64__,__WEBPACK_EXTERNAL_MODULE_66__,__WEBPACK_EXTERNAL_MODULE_185__){return function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){"use strict";function r(e,t){return y.load(e,t)}function i(e,t){return y.loadSync(e,t)}function a(e,t){return y.parse(e,t)}function o(e,t){return y.parseSync(e,t)}function s(e,t,n){return y.loadApi(e,t,n).getOrElse(null)}function u(e,t,n){return y.loadApi(e,t,n).getOrElse(null)}function l(e,t){var n=y.virtualFilePath(t),r=y.optionsForContent(e,t,n);return y.loadApi(n,[],r).getOrElse(null)}function p(e,t){var n=y.virtualFilePath(t),r=y.optionsForContent(e,t,n);return y.loadApiAsync(n,[],r)}function c(e,t,n){return y.loadApiAsync(e,t,n)}function f(e,t,n){return y.loadRAMLAsync(e,t,n)}function h(e){return y.getLanguageElementByRuntimeType(e)}function d(e){return t.api10.isFragment(e)}function m(e){return t.api10.asFragment(e)}Object.defineProperty(t,"__esModule",{value:!0});var y=n(1);t.jsonTypings=n(281);var v=n(295);t.api10=n(222),t.api08=n(296),t.load=r,t.loadSync=i,t.parse=a,t.parseSync=o,t.loadApiSync=s,t.loadRAMLSync=u,t.parseRAMLSync=l,t.parseRAML=p,t.loadApi=c,t.loadRAML=f,t.getLanguageElementByRuntimeType=h,t.isFragment=d,t.asFragment=m,t.hl=n(198),t.ll=n(5),t.search=n(209),t.stubs=n(297),t.utils=n(263),t.project=n(298),t.universeHelpers=n(205),t.ds=n(56),t.schema=n(299),t.universes=t.ds.universesInfo,t.parser=n(301),t.expander=n(303),t.wrapperHelper=n(304),"undefined"==typeof Promise&&"undefined"!=typeof window&&(window.Promise=v)},function(e,t,n){"use strict";function r(e,t){var n=b(t);return a(e,t).then(function(e){return B.dump(e,n)})}function i(e,t){var n=b(t),r=o(e,t);return B.dump(r,n)}function a(e,t){t=t||{};var n=e;I(e)&&(t=N(e,t,t.filePath),n=M(t));var r=S(t);return h(n,r).then(function(e){var n;return n=!t.hasOwnProperty("expandLibraries")||t.expandLibraries?U.expandLibrariesHL(e):U.expandTraitsAndResourceTypesHL(e)})}function o(e,t){t=t||{};var n=e;I(e)&&(t=N(e,t,t.filePath),n=M(t));var r,i=S(t),a=p(n,i);return r=!t.hasOwnProperty("expandLibraries")||t.expandLibraries?V.isLibraryType(a.definition())?U.expandLibraryHL(a)||a:U.expandLibrariesHL(a)||a:U.expandTraitsAndResourceTypesHL(a)||a}function s(e,t,n){var r=p(e,t,n);if(!r)return P.empty();var i=r.wrapperNode(),a=Array.isArray(t)?n:t;return _(i,a),new P(i)}function u(e,t,n){var r=p(e,t,n);if(!r)return P.empty();var i=r.wrapperNode(),a=Array.isArray(t)?n:t;return _(i,a),new P(i)}function l(e,t,n){var r=p(e,t,n);return r?new P(r):P.empty()}function p(e,t,n){var r=Array.isArray(t),i=r?t:null,a=r?n:t;a=a||{};var o=y(e,a),s=e.indexOf("://"),u=s!=-1&&s<6?e:w.basename(e),l=o.unit(u);n&&!i&&(i=null);var p;if(l)if(i&&i.length>0){var c=[];i.forEach(function(e){if(!e||0==e.trim().length)throw new Error(W.EXTENSIONS_AND_OVERLAYS_LEGAL_FILE_PATHS.message)}),i.forEach(function(e){c.push(o.unit(e,w.isAbsolute(e)))}),c.forEach(function(e){return v(e,a)}),p=v(U.mergeAPIs(l,c,O.OverlayMergeMode.MERGE),a)}else p=v(l,a),p.setMergeMode(O.OverlayMergeMode.MERGE);if(!l)throw new Error(j.applyTemplate(W.CAN_NOT_RESOLVE,{path:e}));if(a.rejectOnErrors&&p&&p.errors().filter(function(e){return!e.isWarning}).length)throw g(p);return p}function c(e,t,n){var r=f(e,t,n);return r.then(function(e){return e})}function f(e,t,n){return h(e,t,n).then(function(e){if(!e)return null;for(var r=Array.isArray(t),i=r?n:t,a=e;null!=a;){var o=a.wrapperNode();_(o,i);var s=a.getMaster();a=s&&s!==a?s.asElement():null}return e.wrapperNode()})}function h(e,t,n){var r=Array.isArray(t),i=r?t:null,a=r?n:t;a=a||{};var o=y(e,a),s=e.indexOf("://"),u=s!=-1&&s<6?e:w.basename(e);return n&&!i&&(i=null),i&&0!=i.length?(i.forEach(function(e){if(!e||0==e.trim().length)throw new Error(W.EXTENSIONS_AND_OVERLAYS_LEGAL_FILE_PATHS.message)}),m(o,u,a).then(function(e){var t=[];return i.forEach(function(e){t.push(m(o,e,a))}),Promise.all(t).then(function(t){var n=[];t.forEach(function(e){return n.push(e.lowLevel().unit())});var r=U.mergeAPIs(e.lowLevel().unit(),n,O.OverlayMergeMode.MERGE);return r}).then(function(e){return v(e,a)})})):m(o,u,a).then(function(e){return e.setMergeMode(O.OverlayMergeMode.MERGE),e})}function d(e){if(null==e)return null;var t=e.getAdapter(F.RAMLService).getDeclaringNode();return null==t?null:t.wrapperNode()}function m(e,t,n){var r=t.replace(/\\/g,"/");return D.fetchIncludesAndMasterAsync(e,r).then(function(e){try{var t=v(e,n);return n.rejectOnErrors&&t&&t.errors().filter(function(e){return!e.isWarning}).length?Promise.reject(g(t)):t}catch(e){return Promise.reject(e)}})}function y(e,t){t=t||{};var n,r=t.fsResolver,i=t.httpResolver,a=t.reusedNode;if(a){var o=a.lowLevel().unit();n=o.project(),n.namespaceResolver().deleteUnitModel(o.absolutePath()),n.deleteUnit(w.basename(e)),r&&n.setFSResolver(r),i&&n.setHTTPResolver(i)}else{var s=w.dirname(e);n=new L.Project(s,r,i)}return n}function v(e,t,n){if(void 0===n&&(n=!1),t=t||{},!e)return null;var r=null,i=null;e.isRAMLUnit?r=e:(i=e,r=i.lowLevel().unit());var a=r.contents(),o=O.ramlFirstLine(a);if(!o)throw new Error(W.INVALID_FIRST_LINE.message);var s,u,l=o[1];o[2];if("0.8"==l?u="RAML08":"1.0"==l&&(u="RAML10"),!u)throw new Error(W.UNKNOWN_RAML_VERSION.message);if("RAML08"==u&&n)throw new Error(W.EXTENSIONS_AND_OVERLAYS_NOT_SUPPORTED_0_8.message);var p=H(u);p.type(s);return i||(i=O.fromUnit(r),t.reusedNode&&t.reusedNode.lowLevel().unit().absolutePath()==r.absolutePath()&&E(i,t.reusedNode)&&i.setReusedNode(t.reusedNode)),i}function g(e){var t=new Error(W.API_CONTAINS_ERROR.message);return t.parserErrors=O.toParserErrors(e.errors(),e),t}function A(e,t,n){void 0===t&&(t=!1),void 0===n&&(n=!0);var r=H("RAML10"),i=r.type(k.Universe10.Api.name),a=new L.Project(e),o=[];return a.units().forEach(function(e){var r=e.ast();t&&(r=D.toChildCachingNode(r));var a=new C.ApiImpl(new O.ASTNodeImpl(r,null,i,null));n&&(a=U.expandTraitsAndResourceTypes(a)),o.push(a)}),o}function E(e,t){if(!t)return!1;for(var n=e.lowLevel().unit().contents(),r=t.lowLevel().unit().contents(),i=Math.min(n.length,r.length),a=-1,o=0;o<i;o++)if(n.charAt(o)!=r.charAt(o)){a=o;break}for(;a>0&&""==n.charAt(a).replace(/\s/,"");)a--;a<0&&n.length!=r.length&&(a=i);var s=K.deepFindNode(t,a,a+1);if(!s)return!0;if(s.lowLevel().unit().absolutePath()!=e.lowLevel().unit().absolutePath())return!0;var u=s.isElement()?s.asElement():s.parent();if(!u)return!0;var l=u.property();if(!l)return!0;if(V.isAnnotationsProperty(l)&&(u=u.parent()),!u)return!0;for(var p=u;p;){var c=p.definition();if(V.isResourceTypeType(c)||V.isTraitType(c))return!1;var f=p.property();if(!f)return!0;if(V.isTypeDeclarationDescendant(c)&&(V.isTypesProperty(f)||V.isAnnotationTypesProperty(f)))return!1;var h=f.range();if(V.isResourceTypeRefType(h)||V.isTraitRefType(h))return!1;p=p.parent()}return!0}function _(e,t){t=t||{},null!=t.attributeDefaults&&e?e.setAttributeDefaults(t.attributeDefaults):e&&e.setAttributeDefaults(!0)}function T(e,t,n){var r=n||M(t),i=R(r,e,t&&t.fsResolver);return{fsResolver:i,httpResolver:t?t.httpResolver:null,rejectOnErrors:!!t&&t.rejectOnErrors,attributeDefaults:!t||t.attributeDefaults}}function S(e){return e?{fsResolver:e.fsResolver,httpResolver:e.httpResolver,rejectOnErrors:!1,attributeDefaults:!0}:{}}function N(e,t,n){var r=n||M(t),i=R(r,e,t&&t.fsResolver),a={fsResolver:i};if(!t)return a;for(var o=0,s=Object.keys(t);o<s.length;o++){var u=s[o];"fsResolver"!=u&&(a[u]=t[u])}return a}function I(e){return e=e&&e.trim(),!e||(e.length<="#%RAML".length?x.stringStartsWith("#%RAML",e):!!x.stringStartsWith(e,"#%RAML")||e.indexOf("\n")>=0)}function b(e){return e=e||{},{rootNodeDetails:!0,attributeDefaults:!0,serializeMetadata:e.serializeMetadata||!1,expandExpressions:e.expandExpressions,typeReferences:e.typeReferences,expandTypes:e.expandTypes,typeExpansionRecursionDepth:e.typeExpansionRecursionDepth,sourceMap:e.sourceMap}}function R(e,t,n){return null!=e&&(e=e.replace(/\\/g,"/")),{content:function(r){return r===e?t:n?n.content(r):void 0},contentAsync:function(r){return r===e?Promise.resolve(t):n?n.contentAsync(r):void 0}}}function M(e){var t=e&&e.filePath||w.resolve("/#local.raml");return t.replace(/\\/g,"/")}Object.defineProperty(t,"__esModule",{value:!0});var C=n(2),w=n(6),P=n(17),L=n(4),O=n(55),D=n(4),U=n(217),x=n(15),k=n(204),F=n(275),B=n(255),V=n(205),K=n(209),j=n(19),W=n(207),H=n(264);t.load=r,t.loadSync=i,t.parse=a,t.parseSync=o,t.loadApi=s,t.loadRAML=u,t.loadRAMLHL=l,t.loadApiAsync=c,t.loadRAMLAsync=f,t.loadRAMLAsyncHL=h,t.getLanguageElementByRuntimeType=d,t.toError=g,t.loadApis1=A,t.optionsForContent=T,t.loadOptionsForContent=N,t.virtualFSResolver=R,t.virtualFilePath=M},function(e,t,n){"use strict";function r(e){var t=J.getUniverse("RAML10"),n=t.type("Api"),r=$.createStubNode(n,null,e);return r}function i(e){var t=J.getUniverse("RAML10"),n=t.type("LibraryBase"),r=$.createStubNode(n,null,e);return r}function a(e){var t=J.getUniverse("RAML10"),n=t.type("FragmentDeclaration"),r=$.createStubNode(n,null,e);return r}function o(e){var t=J.getUniverse("RAML10"),n=t.type("Trait"),r=$.createStubNode(n,null,e);return r}function s(e){var t=J.getUniverse("RAML10"),n=t.type("MethodBase"),r=$.createStubNode(n,null,e);return r}function u(e){var t=J.getUniverse("RAML10"),n=t.type("Operation"),r=$.createStubNode(n,null,e);return r}function l(e){var t=J.getUniverse("RAML10"),n=t.type("TypeDeclaration"),r=$.createStubNode(n,null,e);return r}function p(e){var t=J.getUniverse("RAML10"),n=t.type("UsesDeclaration"),r=$.createStubNode(n,null,e);return r}function c(e){var t=J.getUniverse("RAML10"),n=t.type("XMLFacetInfo"),r=$.createStubNode(n,null,e);return r}function f(e){var t=J.getUniverse("RAML10"),n=t.type("ArrayTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function h(e){var t=J.getUniverse("RAML10"),n=t.type("UnionTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function d(e){var t=J.getUniverse("RAML10"),n=t.type("ObjectTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function m(e){var t=J.getUniverse("RAML10"),n=t.type("StringTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function y(e){var t=J.getUniverse("RAML10"),n=t.type("BooleanTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function v(e){var t=J.getUniverse("RAML10"),n=t.type("NumberTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function g(e){var t=J.getUniverse("RAML10"),n=t.type("IntegerTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function A(e){var t=J.getUniverse("RAML10"),n=t.type("DateOnlyTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function E(e){var t=J.getUniverse("RAML10"),n=t.type("TimeOnlyTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function _(e){var t=J.getUniverse("RAML10"),n=t.type("DateTimeOnlyTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function T(e){var t=J.getUniverse("RAML10"),n=t.type("DateTimeTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function S(e){var t=J.getUniverse("RAML10"),n=t.type("FileTypeDeclaration"),r=$.createStubNode(n,null,e);return r}function N(e){var t=J.getUniverse("RAML10"),n=t.type("Response"),r=$.createStubNode(n,null,e);return r}function I(e){var t=J.getUniverse("RAML10"),n=t.type("SecuritySchemePart"),r=$.createStubNode(n,null,e);return r}function b(e){var t=J.getUniverse("RAML10"),n=t.type("AbstractSecurityScheme"),r=$.createStubNode(n,null,e);return r}function R(e){var t=J.getUniverse("RAML10"),n=t.type("SecuritySchemeSettings"),r=$.createStubNode(n,null,e);return r}function M(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth1SecuritySchemeSettings"),r=$.createStubNode(n,null,e);return r}function C(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth2SecuritySchemeSettings"),r=$.createStubNode(n,null,e);return r}function w(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth2SecurityScheme"),r=$.createStubNode(n,null,e);return r}function P(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth1SecurityScheme"),r=$.createStubNode(n,null,e);return r}function L(e){var t=J.getUniverse("RAML10"),n=t.type("PassThroughSecurityScheme"),r=$.createStubNode(n,null,e);return r}function O(e){var t=J.getUniverse("RAML10"),n=t.type("BasicSecurityScheme"),r=$.createStubNode(n,null,e);return r}function D(e){var t=J.getUniverse("RAML10"),n=t.type("DigestSecurityScheme"),r=$.createStubNode(n,null,e);return r}function U(e){var t=J.getUniverse("RAML10"),n=t.type("CustomSecurityScheme"),r=$.createStubNode(n,null,e);return r}function x(e){var t=J.getUniverse("RAML10"),n=t.type("Method"),r=$.createStubNode(n,null,e);return r}function k(e){var t=J.getUniverse("RAML10"),n=t.type("ResourceType"),r=$.createStubNode(n,null,e);return r}function F(e){var t=J.getUniverse("RAML10"),n=t.type("ResourceBase"),r=$.createStubNode(n,null,e);return r}function B(e){var t=J.getUniverse("RAML10"),n=t.type("Resource"),r=$.createStubNode(n,null,e);return r}function V(e){var t=J.getUniverse("RAML10"),n=t.type("DocumentationItem"),r=$.createStubNode(n,null,e);return r}function K(e){var t=J.getUniverse("RAML10"),n=t.type("Library"),r=$.createStubNode(n,null,e);return r}function j(e){var t=J.getUniverse("RAML10"),n=t.type("Overlay"),r=$.createStubNode(n,null,e);return r}function W(e){var t=J.getUniverse("RAML10"),n=t.type("Extension"),r=$.createStubNode(n,null,e);return r}function H(e,t,n){return Z.loadApi(e,t,n).getOrElse(null)}function Y(e,t,n){return Z.loadApi(e,t,n).getOrElse(null)}function q(e,t,n){return Z.loadApiAsync(e,t,n)}function G(e,t,n){return Z.loadRAMLAsync(e,t,n)}function X(e){return Z.getLanguageElementByRuntimeType(e)}var z=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var $=n(3),J=n(56),Q=n(219),Z=n(1),ee=n(249),te=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Pt(e)})},t.prototype.wrapperClassName=function(){return"AnnotableImpl"},t.prototype.kind=function(){return"Annotable"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Annotable")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnnotableImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnnotableImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Q.BasicNodeImpl);t.AnnotableImpl=te;var ne=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"ValueTypeImpl"},t.prototype.kind=function(){return"ValueType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ValueType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("undefined.ValueTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("undefined.ValueTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"undefined"},t.prototype.value=function(){return this.attr.value()},t}(Q.AttributeNodeImpl);t.ValueTypeImpl=ne;var re=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"StringTypeImpl"},t.prototype.kind=function(){return"StringType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.StringTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.StringTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return this.attr.value()},t}(ne);t.StringTypeImpl=re;var ie=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"UriTemplateImpl"},t.prototype.kind=function(){return"UriTemplate"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UriTemplate")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.UriTemplateImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.UriTemplateImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.UriTemplateImpl=ie;var ae=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},t.prototype.kind=function(){return"RelativeUriString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("RelativeUriString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.RelativeUriStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.RelativeUriStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ie);t.RelativeUriStringImpl=ae;var oe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},t.prototype.kind=function(){return"FullUriTemplateString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FullUriTemplateString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FullUriTemplateStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FullUriTemplateStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ie);t.FullUriTemplateStringImpl=oe;var se=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},t.prototype.kind=function(){return"StatusCodeString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StatusCodeString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.StatusCodeStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.StatusCodeStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.StatusCodeStringImpl=se;var ue=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"FixedUriStringImpl"},t.prototype.kind=function(){return"FixedUriString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FixedUriString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FixedUriStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FixedUriStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.FixedUriStringImpl=ue;var le=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"ContentTypeImpl"},t.prototype.kind=function(){return"ContentType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ContentType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ContentTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ContentTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.ContentTypeImpl=le;var pe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},t.prototype.kind=function(){return"MarkdownString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MarkdownString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MarkdownStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MarkdownStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.MarkdownStringImpl=pe;var ce=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"SchemaStringImpl"},t.prototype.kind=function(){return"SchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.SchemaStringImpl=ce;var fe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"MimeTypeImpl"},t.prototype.kind=function(){return"MimeType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MimeType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MimeTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MimeTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.MimeTypeImpl=fe;var he=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"AnyTypeImpl"},t.prototype.kind=function(){return"AnyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.AnyTypeImpl=he;var de=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"NumberTypeImpl"},t.prototype.kind=function(){return"NumberType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.NumberTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.NumberTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return this.attr.value()},t}(ne);t.NumberTypeImpl=de;var me=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"IntegerTypeImpl"},t.prototype.kind=function(){return"IntegerType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("IntegerType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.IntegerTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.IntegerTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.IntegerTypeImpl=me;var ye=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"NullTypeImpl"},t.prototype.kind=function(){return"NullType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NullType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.NullTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.NullTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.NullTypeImpl=ye;var ve=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"TimeOnlyTypeImpl"},t.prototype.kind=function(){return"TimeOnlyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TimeOnlyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TimeOnlyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TimeOnlyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.TimeOnlyTypeImpl=ve;var ge=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"DateOnlyTypeImpl"},t.prototype.kind=function(){return"DateOnlyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateOnlyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateOnlyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateOnlyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.DateOnlyTypeImpl=ge;var Ae=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeImpl"},t.prototype.kind=function(){return"DateTimeOnlyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeOnlyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeOnlyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeOnlyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.DateTimeOnlyTypeImpl=Ae;var Ee=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"DateTimeTypeImpl"},t.prototype.kind=function(){return"DateTimeType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.DateTimeTypeImpl=Ee;var _e=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"FileTypeImpl"},t.prototype.kind=function(){return"FileType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FileType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FileTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FileTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.FileTypeImpl=_e;var Te=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},t.prototype.kind=function(){return"BooleanType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.BooleanTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.BooleanTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return this.attr.value()},t}(ne);t.BooleanTypeImpl=Te;var Se=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"AnnotationTargetImpl"},t.prototype.kind=function(){return"AnnotationTarget"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnnotationTarget")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnnotationTargetImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnnotationTargetImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.AnnotationTargetImpl=Se;var Ne=function(e){
function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"ReferenceImpl"},t.prototype.kind=function(){return"Reference"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Reference")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ReferenceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ReferenceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return Q.toStructuredValue(this.attr)},t.prototype.structuredValue=function(){return ee.structuredValue(this)},t.prototype.name=function(){return ee.referenceName(this)},t}(Q.AttributeNodeImpl);t.ReferenceImpl=Ne;var Ie=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"TraitRefImpl"},t.prototype.kind=function(){return"TraitRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TraitRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TraitRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TraitRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.trait=function(){return ee.referencedTrait(this)},t}(Ne);t.TraitRefImpl=Ie;var be=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?u(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.queryParameters=function(){return e.prototype.elements.call(this,"queryParameters")},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.queryString=function(){return e.prototype.element.call(this,"queryString")},t.prototype.responses=function(){return e.prototype.elements.call(this,"responses")},t.prototype.wrapperClassName=function(){return"OperationImpl"},t.prototype.kind=function(){return"Operation"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Operation")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OperationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OperationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(te);t.OperationImpl=be;var Re=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?l(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.facets=function(){return e.prototype.elements.call(this,"facets")},t.prototype.schema_original=function(){return e.prototype.attributes.call(this,"schema",this.toString)},t.prototype.setSchema=function(e){return this.highLevel().attrOrCreate("schema").setValue(""+e),this},t.prototype.type_original=function(){return e.prototype.attributes.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.location=function(){return e.prototype.attribute.call(this,"location",function(e){return new Me(e)})},t.prototype.locationKind=function(){return e.prototype.attribute.call(this,"locationKind",function(e){return new Ce(e)})},t.prototype.default=function(){return e.prototype.attribute.call(this,"default",this.toAny)},t.prototype.setDefault=function(e){return this.highLevel().attrOrCreate("default").setValue(""+e),this},t.prototype.example_original=function(){return e.prototype.element.call(this,"example")},t.prototype.examples_original=function(){return e.prototype.elements.call(this,"examples")},t.prototype.required=function(){return e.prototype.attribute.call(this,"required",this.toBoolean)},t.prototype.setRequired=function(e){return this.highLevel().attrOrCreate("required").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.xml=function(){return e.prototype.element.call(this,"xml")},t.prototype.allowedTargets=function(){return e.prototype.attributes.call(this,"allowedTargets",function(e){return new Se(e)})},t.prototype.isAnnotation=function(){return e.prototype.attribute.call(this,"isAnnotation",this.toBoolean)},t.prototype.setIsAnnotation=function(e){return this.highLevel().attrOrCreate("isAnnotation").setValue(""+e),this},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Pt(e)})},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"TypeDeclarationImpl"},t.prototype.kind=function(){return"TypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.runtimeType=function(){return ee.runtimeType(this)},t.prototype.validateInstance=function(e){return ee.validateInstance(this,e)},t.prototype.validateInstanceWithDetailedStatuses=function(e){return ee.validateInstanceWithDetailedStatuses(this,e)},t.prototype.example=function(){return ee.getTypeExample(this)},t.prototype.examples=function(){return ee.getTypeExamples(this)},t.prototype.fixedFacets=function(){return ee.typeFixedFacets(this)},t.prototype.type=function(){return ee.typeValue(this)},t.prototype.schema=function(){return ee.schemaValue(this)},t.prototype.structuredType=function(){return ee.typeStructuredValue(this)},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new Ue(this.highLevel())},t}(te);t.TypeDeclarationImpl=Re;var Me=function(){function e(e){this.attr=e}return e.prototype.wrapperClassName=function(){return"ModelLocationImpl"},e.prototype.kind=function(){return"ModelLocation"},e.prototype.allKinds=function(){return["ModelLocation"]},e.prototype.allWrapperClassNames=function(){return["RAML10.ModelLocationImpl"]},e.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ModelLocationImpl"==r)return!0}return!1},e.prototype.RAMLVersion=function(){return"RAML10"},e}();t.ModelLocationImpl=Me;var Ce=function(){function e(e){this.attr=e}return e.prototype.wrapperClassName=function(){return"LocationKindImpl"},e.prototype.kind=function(){return"LocationKind"},e.prototype.allKinds=function(){return["LocationKind"]},e.prototype.allWrapperClassNames=function(){return["RAML10.LocationKindImpl"]},e.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.LocationKindImpl"==r)return!0}return!1},e.prototype.RAMLVersion=function(){return"RAML10"},e}();t.LocationKindImpl=Ce;var we=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?p(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.key=function(){return e.prototype.attribute.call(this,"key",this.toString)},t.prototype.setKey=function(e){return this.highLevel().attrOrCreate("key").setValue(""+e),this},t.prototype.value=function(){return e.prototype.attribute.call(this,"value",this.toString)},t.prototype.setValue=function(e){return this.highLevel().attrOrCreate("value").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"UsesDeclarationImpl"},t.prototype.kind=function(){return"UsesDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UsesDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.UsesDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.UsesDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.ast=function(){return ee.referencedNode(this)},t.prototype.scalarsAnnotations=function(){return new Pe(this.highLevel())},t}(te);t.UsesDeclarationImpl=we;var Pe=function(){function e(e){this.node=e}return e.prototype.value=function(){var e=this.node.attr("value");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.UsesDeclarationScalarsAnnotationsImpl=Pe;var Le=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?c(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.attribute=function(){return e.prototype.attribute.call(this,"attribute",this.toBoolean)},t.prototype.setAttribute=function(e){return this.highLevel().attrOrCreate("attribute").setValue(""+e),this},t.prototype.wrapped=function(){return e.prototype.attribute.call(this,"wrapped",this.toBoolean)},t.prototype.setWrapped=function(e){return this.highLevel().attrOrCreate("wrapped").setValue(""+e),this},t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.namespace=function(){return e.prototype.attribute.call(this,"namespace",this.toString)},t.prototype.setNamespace=function(e){return this.highLevel().attrOrCreate("namespace").setValue(""+e),this},t.prototype.prefix=function(){return e.prototype.attribute.call(this,"prefix",this.toString)},t.prototype.setPrefix=function(e){return this.highLevel().attrOrCreate("prefix").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"XMLFacetInfoImpl"},t.prototype.kind=function(){return"XMLFacetInfo"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLFacetInfo")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.XMLFacetInfoImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.XMLFacetInfoImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Oe(this.highLevel())},t}(te);t.XMLFacetInfoImpl=Le;var Oe=function(){function e(e){this.node=e}return e.prototype.attribute=function(){var e=this.node.attr("attribute");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.wrapped=function(){var e=this.node.attr("wrapped");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.name=function(){var e=this.node.attr("name");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.namespace=function(){var e=this.node.attr("namespace");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.prefix=function(){var e=this.node.attr("prefix");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.XMLFacetInfoScalarsAnnotationsImpl=Oe;var De=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?f(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.uniqueItems=function(){return e.prototype.attribute.call(this,"uniqueItems",this.toBoolean)},t.prototype.setUniqueItems=function(e){return this.highLevel().attrOrCreate("uniqueItems").setValue(""+e),this},t.prototype.items_original=function(){return e.prototype.attributes.call(this,"items",this.toString)},t.prototype.setItems=function(e){return this.highLevel().attrOrCreate("items").setValue(""+e),this},t.prototype.minItems=function(){return e.prototype.attribute.call(this,"minItems",this.toNumber)},t.prototype.setMinItems=function(e){return this.highLevel().attrOrCreate("minItems").setValue(""+e),this},t.prototype.maxItems=function(){return e.prototype.attribute.call(this,"maxItems",this.toNumber)},t.prototype.setMaxItems=function(e){return this.highLevel().attrOrCreate("maxItems").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"ArrayTypeDeclarationImpl"},t.prototype.kind=function(){return"ArrayTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ArrayTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ArrayTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ArrayTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.structuredItems=function(){return ee.itemsStructuredValue(this)},t.prototype.items=function(){return ee.getItems(this)},t.prototype.findComponentTypeDeclaration=function(){return ee.findComponentTypeDeclaration(this)},t.prototype.scalarsAnnotations=function(){return new xe(this.highLevel())},t}(Re);t.ArrayTypeDeclarationImpl=De;var Ue=function(){function e(e){this.node=e}return e.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.schema=function(){var e=this.node.attributes("schema");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.type=function(){var e=this.node.attributes("type");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.location=function(){var e=this.node.attr("location");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.locationKind=function(){var e=this.node.attr("locationKind");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.default=function(){var e=this.node.attr("default");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.required=function(){var e=this.node.attr("required");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.allowedTargets=function(){var e=this.node.attributes("allowedTargets");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.isAnnotation=function(){var e=this.node.attr("isAnnotation");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.TypeDeclarationScalarsAnnotationsImpl=Ue;var xe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.uniqueItems=function(){var e=this.node.attr("uniqueItems");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.items=function(){var e=this.node.attributes("items");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},t.prototype.minItems=function(){var e=this.node.attr("minItems");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.maxItems=function(){var e=this.node.attr("maxItems");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Ue);t.ArrayTypeDeclarationScalarsAnnotationsImpl=xe;var ke=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?h(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"UnionTypeDeclarationImpl"},t.prototype.kind=function(){return"UnionTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UnionTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.UnionTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.UnionTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Re);t.UnionTypeDeclarationImpl=ke;var Fe=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?d(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.properties=function(){return e.prototype.elements.call(this,"properties")},t.prototype.minProperties=function(){return e.prototype.attribute.call(this,"minProperties",this.toNumber)},t.prototype.setMinProperties=function(e){return this.highLevel().attrOrCreate("minProperties").setValue(""+e),this},t.prototype.maxProperties=function(){return e.prototype.attribute.call(this,"maxProperties",this.toNumber)},t.prototype.setMaxProperties=function(e){return this.highLevel().attrOrCreate("maxProperties").setValue(""+e),this},t.prototype.additionalProperties=function(){return e.prototype.attribute.call(this,"additionalProperties",this.toBoolean)},t.prototype.setAdditionalProperties=function(e){return this.highLevel().attrOrCreate("additionalProperties").setValue(""+e),this},t.prototype.discriminator=function(){return e.prototype.attribute.call(this,"discriminator",this.toString)},t.prototype.setDiscriminator=function(e){return this.highLevel().attrOrCreate("discriminator").setValue(""+e),this},t.prototype.discriminatorValue=function(){return e.prototype.attribute.call(this,"discriminatorValue",this.toString)},t.prototype.setDiscriminatorValue=function(e){return this.highLevel().attrOrCreate("discriminatorValue").setValue(""+e),this},t.prototype.enum=function(){return e.prototype.attributes.call(this,"enum",this.toAny)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"ObjectTypeDeclarationImpl"},t.prototype.kind=function(){return"ObjectTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ObjectTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ObjectTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ObjectTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Be(this.highLevel())},t}(Re);t.ObjectTypeDeclarationImpl=Fe;var Be=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.minProperties=function(){var e=this.node.attr("minProperties");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.maxProperties=function(){var e=this.node.attr("maxProperties");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.additionalProperties=function(){var e=this.node.attr("additionalProperties");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.discriminator=function(){var e=this.node.attr("discriminator");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.discriminatorValue=function(){var e=this.node.attr("discriminatorValue");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.enum=function(){var e=this.node.attributes("enum");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},t}(Ue);t.ObjectTypeDeclarationScalarsAnnotationsImpl=Be;var Ve=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?m(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.pattern=function(){return e.prototype.attribute.call(this,"pattern",this.toString)},t.prototype.setPattern=function(e){return this.highLevel().attrOrCreate("pattern").setValue(""+e),this},t.prototype.minLength=function(){return e.prototype.attribute.call(this,"minLength",this.toNumber)},t.prototype.setMinLength=function(e){return this.highLevel().attrOrCreate("minLength").setValue(""+e),this},t.prototype.maxLength=function(){return e.prototype.attribute.call(this,"maxLength",this.toNumber)},t.prototype.setMaxLength=function(e){return this.highLevel().attrOrCreate("maxLength").setValue(""+e),this},t.prototype.enum=function(){return e.prototype.attributes.call(this,"enum",this.toString)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},t.prototype.kind=function(){return"StringTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.StringTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.StringTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ke(this.highLevel())},t}(Re);t.StringTypeDeclarationImpl=Ve;var Ke=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.pattern=function(){var e=this.node.attr("pattern");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.minLength=function(){var e=this.node.attr("minLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.maxLength=function(){var e=this.node.attr("maxLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.enum=function(){var e=this.node.attributes("enum");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},t}(Ue);t.StringTypeDeclarationScalarsAnnotationsImpl=Ke;var je=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?y(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.enum=function(){return e.prototype.attributes.call(this,"enum",this.toBoolean)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},t.prototype.kind=function(){return"BooleanTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.BooleanTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.BooleanTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new We(this.highLevel())},t}(Re);t.BooleanTypeDeclarationImpl=je;var We=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.enum=function(){var e=this.node.attributes("enum");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},t}(Ue);t.BooleanTypeDeclarationScalarsAnnotationsImpl=We;var He=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?v(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.minimum=function(){return e.prototype.attribute.call(this,"minimum",this.toNumber)},t.prototype.setMinimum=function(e){return this.highLevel().attrOrCreate("minimum").setValue(""+e),this},t.prototype.maximum=function(){return e.prototype.attribute.call(this,"maximum",this.toNumber)},t.prototype.setMaximum=function(e){return this.highLevel().attrOrCreate("maximum").setValue(""+e),this},t.prototype.enum=function(){return e.prototype.attributes.call(this,"enum",this.toNumber)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.format=function(){return e.prototype.attribute.call(this,"format",this.toString)},t.prototype.setFormat=function(e){return this.highLevel().attrOrCreate("format").setValue(""+e),this},t.prototype.multipleOf=function(){return e.prototype.attribute.call(this,"multipleOf",this.toNumber)},t.prototype.setMultipleOf=function(e){return this.highLevel().attrOrCreate("multipleOf").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},t.prototype.kind=function(){return"NumberTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.NumberTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.NumberTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new qe(this.highLevel())},t}(Re);t.NumberTypeDeclarationImpl=He;var Ye=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?g(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.format=function(){return e.prototype.attribute.call(this,"format",this.toString)},t.prototype.setFormat=function(e){return this.highLevel().attrOrCreate("format").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},t.prototype.kind=function(){return"IntegerTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("IntegerTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.IntegerTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.IntegerTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ge(this.highLevel())},t}(He);t.IntegerTypeDeclarationImpl=Ye;var qe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.minimum=function(){var e=this.node.attr("minimum");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.maximum=function(){var e=this.node.attr("maximum");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.enum=function(){var e=this.node.attributes("enum");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},t.prototype.format=function(){var e=this.node.attr("format");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.multipleOf=function(){var e=this.node.attr("multipleOf");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Ue);t.NumberTypeDeclarationScalarsAnnotationsImpl=qe;var Ge=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.format=function(){var e=this.node.attr("format");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(qe);t.IntegerTypeDeclarationScalarsAnnotationsImpl=Ge;var Xe=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?A(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"DateOnlyTypeDeclarationImpl"},t.prototype.kind=function(){return"DateOnlyTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateOnlyTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateOnlyTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateOnlyTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Re);t.DateOnlyTypeDeclarationImpl=Xe;var ze=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?E(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"TimeOnlyTypeDeclarationImpl"},t.prototype.kind=function(){return"TimeOnlyTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TimeOnlyTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TimeOnlyTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TimeOnlyTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Re);t.TimeOnlyTypeDeclarationImpl=ze;var $e=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?_(t):t,n)||this;
return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeDeclarationImpl"},t.prototype.kind=function(){return"DateTimeOnlyTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeOnlyTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeOnlyTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeOnlyTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Re);t.DateTimeOnlyTypeDeclarationImpl=$e;var Je=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?T(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.format=function(){return e.prototype.attribute.call(this,"format",this.toString)},t.prototype.setFormat=function(e){return this.highLevel().attrOrCreate("format").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"DateTimeTypeDeclarationImpl"},t.prototype.kind=function(){return"DateTimeTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Qe(this.highLevel())},t}(Re);t.DateTimeTypeDeclarationImpl=Je;var Qe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.format=function(){var e=this.node.attr("format");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Ue);t.DateTimeTypeDeclarationScalarsAnnotationsImpl=Qe;var Ze=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?S(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.fileTypes=function(){return e.prototype.attributes.call(this,"fileTypes",function(e){return new le(e)})},t.prototype.minLength=function(){return e.prototype.attribute.call(this,"minLength",this.toNumber)},t.prototype.setMinLength=function(e){return this.highLevel().attrOrCreate("minLength").setValue(""+e),this},t.prototype.maxLength=function(){return e.prototype.attribute.call(this,"maxLength",this.toNumber)},t.prototype.setMaxLength=function(e){return this.highLevel().attrOrCreate("maxLength").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},t.prototype.kind=function(){return"FileTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FileTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FileTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FileTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new et(this.highLevel())},t}(Re);t.FileTypeDeclarationImpl=Ze;var et=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.fileTypes=function(){var e=this.node.attributes("fileTypes");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},t.prototype.minLength=function(){var e=this.node.attr("minLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.maxLength=function(){var e=this.node.attr("maxLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Ue);t.FileTypeDeclarationScalarsAnnotationsImpl=et;var tt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?N(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.code=function(){return e.prototype.attribute.call(this,"code",function(e){return new se(e)})},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Pt(e)})},t.prototype.wrapperClassName=function(){return"ResponseImpl"},t.prototype.kind=function(){return"Response"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Response")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResponseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResponseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.isOkRange=function(){return ee.isOkRange(this)},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new nt(this.highLevel())},t}(te);t.ResponseImpl=tt;var nt=function(){function e(e){this.node=e}return e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.ResponseScalarsAnnotationsImpl=nt;var rt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?I(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Pt(e)})},t.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},t.prototype.kind=function(){return"SecuritySchemePart"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemePart")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SecuritySchemePartImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SecuritySchemePartImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(be);t.SecuritySchemePartImpl=rt;var it=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?s(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new Ie(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new at(e)})},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"MethodBaseImpl"},t.prototype.kind=function(){return"MethodBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MethodBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MethodBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MethodBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Et(this.highLevel())},t}(be);t.MethodBaseImpl=it;var at=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},t.prototype.kind=function(){return"SecuritySchemeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SecuritySchemeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SecuritySchemeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.securitySchemeName=function(){return ee.securitySchemeName(this)},t.prototype.securityScheme=function(){return ee.securityScheme(this)},t}(Ne);t.SecuritySchemeRefImpl=at;var ot=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?b(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.describedBy=function(){return e.prototype.element.call(this,"describedBy")},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},t.prototype.kind=function(){return"AbstractSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AbstractSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AbstractSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AbstractSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new gt(this.highLevel())},t}(te);t.AbstractSecuritySchemeImpl=ot;var st=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?R(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(te);t.SecuritySchemeSettingsImpl=st;var ut=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?M(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.requestTokenUri=function(){return e.prototype.attribute.call(this,"requestTokenUri",function(e){return new ue(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ue(e)})},t.prototype.tokenCredentialsUri=function(){return e.prototype.attribute.call(this,"tokenCredentialsUri",function(e){return new ue(e)})},t.prototype.signatures=function(){return e.prototype.attributes.call(this,"signatures",this.toString)},t.prototype.setSignatures=function(e){return this.highLevel().attrOrCreate("signatures").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth1SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth1SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new lt(this.highLevel())},t}(st);t.OAuth1SecuritySchemeSettingsImpl=ut;var lt=function(){function e(e){this.node=e}return e.prototype.requestTokenUri=function(){var e=this.node.attr("requestTokenUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.authorizationUri=function(){var e=this.node.attr("authorizationUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.tokenCredentialsUri=function(){var e=this.node.attr("tokenCredentialsUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.signatures=function(){var e=this.node.attributes("signatures");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e}();t.OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl=lt;var pt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?C(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.accessTokenUri=function(){return e.prototype.attribute.call(this,"accessTokenUri",function(e){return new ue(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ue(e)})},t.prototype.authorizationGrants=function(){return e.prototype.attributes.call(this,"authorizationGrants",this.toString)},t.prototype.setAuthorizationGrants=function(e){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+e),this},t.prototype.scopes=function(){return e.prototype.attributes.call(this,"scopes",this.toString)},t.prototype.setScopes=function(e){return this.highLevel().attrOrCreate("scopes").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth2SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth2SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new ct(this.highLevel())},t}(st);t.OAuth2SecuritySchemeSettingsImpl=pt;var ct=function(){function e(e){this.node=e}return e.prototype.accessTokenUri=function(){var e=this.node.attr("accessTokenUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.authorizationUri=function(){var e=this.node.attr("authorizationUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.authorizationGrants=function(){var e=this.node.attributes("authorizationGrants");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.scopes=function(){var e=this.node.attributes("scopes");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e}();t.OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl=ct;var ft=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?w(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth2SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth2SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth2SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ot);t.OAuth2SecuritySchemeImpl=ft;var ht=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?P(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth1SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth1SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth1SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ot);t.OAuth1SecuritySchemeImpl=ht;var dt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?L(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"PassThroughSecuritySchemeImpl"},t.prototype.kind=function(){return"PassThroughSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("PassThroughSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.PassThroughSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.PassThroughSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ot);t.PassThroughSecuritySchemeImpl=dt;var mt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?O(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},t.prototype.kind=function(){return"BasicSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BasicSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.BasicSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.BasicSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ot);t.BasicSecuritySchemeImpl=mt;var yt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?D(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},t.prototype.kind=function(){return"DigestSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DigestSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DigestSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DigestSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ot);t.DigestSecuritySchemeImpl=yt;var vt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?U(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},t.prototype.kind=function(){return"CustomSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("CustomSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.CustomSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.CustomSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ot);t.CustomSecuritySchemeImpl=vt;var gt=function(){function e(e){this.node=e}return e.prototype.type=function(){var e=this.node.attr("type");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.AbstractSecuritySchemeScalarsAnnotationsImpl=gt;var At=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?x(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.method=function(){return e.prototype.attribute.call(this,"method",this.toString)},t.prototype.setMethod=function(e){return this.highLevel().attrOrCreate("method").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"MethodImpl"},t.prototype.kind=function(){return"Method"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Method")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MethodImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MethodImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.parentResource=function(){return ee.parentResource(this)},t.prototype.ownerApi=function(){return ee.ownerApi(this)},t.prototype.methodId=function(){return ee.methodId(this)},t.prototype.allSecuredBy=function(){return ee.allSecuredBy(this)},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new _t(this.highLevel())},t}(it);t.MethodImpl=At;var Et=function(){function e(e){this.node=e}return e.prototype.protocols=function(){var e=this.node.attributes("protocols");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.is=function(){var e=this.node.attributes("is");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.securedBy=function(){var e=this.node.attributes("securedBy");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.MethodBaseScalarsAnnotationsImpl=Et;var _t=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Et);t.MethodScalarsAnnotationsImpl=_t;var Tt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?o(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"TraitImpl"},t.prototype.kind=function(){return"Trait"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Trait")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TraitImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TraitImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new St(this.highLevel())},t}(it);t.TraitImpl=Tt;var St=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Et);t.TraitScalarsAnnotationsImpl=St;var Nt=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},t.prototype.kind=function(){return"ResourceTypeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceTypeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceTypeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceTypeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.resourceType=function(){return ee.referencedResourceType(this)},t}(Ne);t.ResourceTypeRefImpl=Nt;var It=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?F(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.methods=function(){return e.prototype.elements.call(this,"methods")},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new Ie(e)})},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",function(e){return new Nt(e)})},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new at(e)})},t.prototype.uriParameters_original=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.wrapperClassName=function(){return"ResourceBaseImpl"},t.prototype.kind=function(){return"ResourceBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.uriParameters=function(){return ee.uriParametersPrimary(this)},t.prototype.allUriParameters=function(){return ee.uriParameters(this)},t.prototype.allSecuredBy=function(){return ee.allSecuredBy(this)},t.prototype.scalarsAnnotations=function(){return new Rt(this.highLevel())},t}(te);t.ResourceBaseImpl=It;var bt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?B(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.relativeUri=function(){return e.prototype.attribute.call(this,"relativeUri",function(e){return new ae(e)})},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Pt(e)})},t.prototype.wrapperClassName=function(){return"ResourceImpl"},t.prototype.kind=function(){return"Resource"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Resource");
},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.completeRelativeUri=function(){return ee.completeRelativeUri(this)},t.prototype.absoluteUri=function(){return ee.absoluteUri(this)},t.prototype.parentResource=function(){return ee.parent(this)},t.prototype.childResource=function(e){return ee.childResource(this,e)},t.prototype.childMethod=function(e){return ee.childMethod(this,e)},t.prototype.ownerApi=function(){return ee.ownerApi(this)},t.prototype.absoluteUriParameters=function(){return ee.absoluteUriParameters(this)},t.prototype.scalarsAnnotations=function(){return new Mt(this.highLevel())},t}(It);t.ResourceImpl=bt;var Rt=function(){function e(e){this.node=e}return e.prototype.is=function(){var e=this.node.attributes("is");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.type=function(){var e=this.node.attr("type");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.securedBy=function(){var e=this.node.attributes("securedBy");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e}();t.ResourceBaseScalarsAnnotationsImpl=Rt;var Mt=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Rt);t.ResourceScalarsAnnotationsImpl=Mt;var Ct=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?k(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},t.prototype.kind=function(){return"ResourceType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new wt(this.highLevel())},t}(It);t.ResourceTypeImpl=Ct;var wt=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Rt);t.ResourceTypeScalarsAnnotationsImpl=wt;var Pt=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.wrapperClassName=function(){return"AnnotationRefImpl"},t.prototype.kind=function(){return"AnnotationRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnnotationRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnnotationRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnnotationRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.annotation=function(){return ee.referencedAnnotation(this)},t}(Ne);t.AnnotationRefImpl=Pt;var Lt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?V(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.content=function(){return e.prototype.attribute.call(this,"content",function(e){return new pe(e)})},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},t.prototype.kind=function(){return"DocumentationItem"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DocumentationItem")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DocumentationItemImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DocumentationItemImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ot(this.highLevel())},t}(te);t.DocumentationItemImpl=Lt;var Ot=function(){function e(e){this.node=e}return e.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.content=function(){var e=this.node.attr("content");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.DocumentationItemScalarsAnnotationsImpl=Ot;var Dt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?a(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"FragmentDeclarationImpl"},t.prototype.kind=function(){return"FragmentDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FragmentDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FragmentDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FragmentDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(te);t.FragmentDeclarationImpl=Dt;var Ut=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?i(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.schemas=function(){return e.prototype.elements.call(this,"schemas")},t.prototype.types=function(){return e.prototype.elements.call(this,"types")},t.prototype.traits_original=function(){return e.prototype.elements.call(this,"traits")},t.prototype.resourceTypes_original=function(){return e.prototype.elements.call(this,"resourceTypes")},t.prototype.annotationTypes=function(){return e.prototype.elements.call(this,"annotationTypes")},t.prototype.securitySchemes=function(){return e.prototype.elements.call(this,"securitySchemes")},t.prototype.wrapperClassName=function(){return"LibraryBaseImpl"},t.prototype.kind=function(){return"LibraryBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("LibraryBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.LibraryBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.LibraryBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.traits=function(){return ee.traitsPrimary(this)},t.prototype.allTraits=function(){return ee.allTraits(this)},t.prototype.resourceTypes=function(){return ee.resourceTypesPrimary(this)},t.prototype.allResourceTypes=function(){return ee.allResourceTypes(this)},t}(Dt);t.LibraryBaseImpl=Ut;var xt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?K(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"LibraryImpl"},t.prototype.kind=function(){return"Library"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Library")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.LibraryImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.LibraryImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.expand=function(){return ee.expandLibrarySpec(this)},t.prototype.scalarsAnnotations=function(){return new kt(this.highLevel())},t}(Ut);t.LibraryImpl=xt;var kt=function(){function e(e){this.node=e}return e.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e}();t.LibraryScalarsAnnotationsImpl=kt;var Ft=function(e){function t(t,n){void 0===n&&(n=!0);var i=e.call(this,"string"==typeof t?r(t):t,n)||this;return i.nodeOrKey=t,i.setAsTopLevel=n,i}return z(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.version=function(){return e.prototype.attribute.call(this,"version",this.toString)},t.prototype.setVersion=function(e){return this.highLevel().attrOrCreate("version").setValue(""+e),this},t.prototype.baseUri=function(){return e.prototype.attribute.call(this,"baseUri",function(e){return new oe(e)})},t.prototype.baseUriParameters_original=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.mediaType=function(){return e.prototype.attributes.call(this,"mediaType",function(e){return new fe(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new at(e)})},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.documentation=function(){return e.prototype.elements.call(this,"documentation")},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Pt(e)})},t.prototype.wrapperClassName=function(){return"ApiImpl"},t.prototype.kind=function(){return"Api"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Api")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ApiImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ApiImpl"==r)return!0}return!1},t.prototype.RAMLVersion_original=function(){return"RAML10"},t.prototype.expand=function(e){return void 0===e&&(e=!1),ee.expandSpec(this,e)},t.prototype.childResource=function(e){return ee.childResource(this,e)},t.prototype.allResources=function(){return ee.allResources(this)},t.prototype.baseUriParameters=function(){return ee.baseUriParametersPrimary(this)},t.prototype.allBaseUriParameters=function(){return ee.baseUriParameters(this)},t.prototype.allProtocols=function(){return ee.allProtocols(this)},t.prototype.RAMLVersion=function(){return ee.RAMLVersion(this)},t.prototype.scalarsAnnotations=function(){return new Vt(this.highLevel())},t}(Ut);t.ApiImpl=Ft;var Bt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?j(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.extends=function(){return e.prototype.attribute.call(this,"extends",this.toString)},t.prototype.setExtends=function(e){return this.highLevel().attrOrCreate("extends").setValue(""+e),this},t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OverlayImpl"},t.prototype.kind=function(){return"Overlay"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Overlay")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OverlayImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OverlayImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Kt(this.highLevel())},t}(Ft);t.OverlayImpl=Bt;var Vt=function(){function e(e){this.node=e}return e.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.version=function(){var e=this.node.attr("version");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.baseUri=function(){var e=this.node.attr("baseUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},e.prototype.protocols=function(){var e=this.node.attributes("protocols");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.mediaType=function(){var e=this.node.attributes("mediaType");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e.prototype.securedBy=function(){var e=this.node.attributes("securedBy");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n})},e}();t.ApiScalarsAnnotationsImpl=Vt;var Kt=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.extends=function(){var e=this.node.attr("extends");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Vt);t.OverlayScalarsAnnotationsImpl=Kt;var jt=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?W(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return z(t,e),t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.extends=function(){return e.prototype.attribute.call(this,"extends",this.toString)},t.prototype.setExtends=function(e){return this.highLevel().attrOrCreate("extends").setValue(""+e),this},t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"ExtensionImpl"},t.prototype.kind=function(){return"Extension"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Extension")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ExtensionImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ExtensionImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Wt(this.highLevel())},t}(Ft);t.ExtensionImpl=jt;var Wt=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return z(t,e),t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.extends=function(){var e=this.node.attr("extends");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Pt(e)});return n},t}(Vt);t.ExtensionScalarsAnnotationsImpl=Wt,t.loadApiSync=H,t.loadRAMLSync=Y,t.loadApi=q,t.loadRAML=G,t.getLanguageElementByRuntimeType=X},function(e,t,n){"use strict";function r(e,t,n){var r=e.definition().property(t);if(!r)return null;var i=r.range(),a=h(i,r,n);return a}function i(e,t,n,r){var i=y.newMap(n.map(function(e){return y.newMapping(y.newScalar(e.key),y.newScalar(e.value))})),a=new d.ASTNode(i,r?r.lowLevel().unit():null,r?r.lowLevel():null,null,null);return new m.StructuredValue(a,r,r?r.definition().property(e):null,t)}function a(e,t,n){var r=e.definition().property(t);if(!r)return null;var i=r.range(),a=e.lowLevel().unit().stub(),o=h(i,r,n,a);return o.isInEdit=!0,o.lowLevel()._unit=a,o._parent=e.copy(),o._parent.lowLevel()._unit=a,o}function o(e,t){return a(e,"resources",t)}function s(e,t){return a(e,"methods",t)}function u(e,t){return a(e,"responses",t)}function l(e,t){return a(e,"body",t)}function p(e,t){return a(e,"uriParameters",t)}function c(e,t){return a(e,"queryParameters",t)}function f(e,t){var n=d.createMapping(e.nameId(),t),r=new m.ASTPropImpl(n,null,e.range(),e);return r}function h(e,t,n,r){void 0===n&&(n=null);var i=d.createNode(n?n:"key",null,r),a=new m.ASTNodeImpl(i,null,e,t);return i.unit()||(i._unit=r),a.children(),a}Object.defineProperty(t,"__esModule",{value:!0});var d=n(4),m=n(55),y=n(21);t.createStub0=r,t.genStructuredValue=i,t.createStub=a,t.createResourceStub=o,t.createMethodStub=s,t.createResponseStub=u,t.createBodyStub=l,t.createUriParameterStub=p,t.createQueryParameterStub=c,t.createAttr=f,t.createStubNode=h},function(e,t,n){"use strict";function r(){return new Y}function i(e){if(null==e)return null;switch(e.kind){case b.Kind.SCALAR:return{errors:[],startPosition:e.startPosition,endPosition:e.endPosition,value:e.value,kind:b.Kind.SCALAR,parent:e.parent};case b.Kind.MAPPING:var t=e;return{errors:[],key:i(t.key),value:i(t.value),startPosition:t.startPosition,endPosition:t.endPosition,kind:b.Kind.MAPPING,parent:t.parent};case b.Kind.MAP:var n=e;return{errors:[],startPosition:e.startPosition,endPosition:e.endPosition,mappings:n.mappings.map(function(e){return i(e)}),kind:b.Kind.MAP,parent:n.parent}}return e}function a(e){var t=e.match(/^.*((\r\n|\n|\r)|$)/gm);return t}function o(e,t){for(var n=a(e),r=[],i=0;i<n.length;i++)0==i?r.push(n[0]):r.push(n[i].substring(t.length));return r.join("")}function s(e){for(var t="",n=0;n<e.length;n++){var r=e[n];if("\r"!=r&&"\n"!=r){if(" "!=r&&"\t"!=r)break;t+=r}}return t}function u(e,t){var n=e.substr(t.offset,t.replacementLength);return n.indexOf("\n")!=-1||(t.text.indexOf("\n")!=-1||void 0)}function l(e){if("null"==e)e=null;else if("~"==e)e=null;else if("true"==e)e=!0;else if("false"==e)e=!1;else{var t=parseFloat(e);isNaN(t)||(""+e).match("^[-+]?[0-9]*\\.?[0-9]+$")&&(e=t)}return e}function p(e,t,n){var r=b.newMapping(b.newScalar(e),b.newMap());return new Q(r,n,t,null,null)}function c(e){var t=b.newMap(e);return new Q(t,null,null,null,null)}function f(e){var t=b.newScalar(e);return new Q(t,null,null,null,null)}function h(e,t,n){return new Q(e,n,t,null,null)}function d(e){var t=b.newMapping(b.newScalar(e),b.newItems());return new Q(t,null,null,null,null)}function m(e,t){void 0===t&&(t=null);var n=b.newMapping(b.newScalar(e),b.newMap());return new Q(n,t,null,null,null)}function y(e,t){var n=b.newMapping(b.newScalar(e),b.newScalar(t));return new Q(n,null,null,null,null)}function v(e){if(!Q.isInstance(e))return null;var t=e,n=new Q(t.yamlNode(),t.unit(),null,null,null,!0);return n._errors=t._errors,n}function g(e){if(!Q.isInstance(e))return null;var t=e,n=new Q(t.yamlNode(),t.unit(),null,null,null,!1);return n._errors=t._errors,n}function A(e){var t=e.highLevelNode();if(t)return t.definition();var n=e.parent();if(!n)return null;var r=e.key();if(!r)return null;var i=n.nodeDefinition();if(!i)return null;if(!i.property)return null;var a=i.property(r);return a?a.range():null}function E(e,t,n,r){if(e.isOverlayOrExtension()){var i=e.getMasterReferenceNode();if(i){var a=i.value();if(a){var o=S.dirname(e.absolutePath()),s=T.toAbsolutePath(o,a);if(!t[s]){if(n[s])return void i.errors().push(new V(n[a]));var u=r[s];u||(u=[],r[s]=u),u.push(i)}}}}}function _(e,t){var n={},r={},i=[],a=function(t){for(var o=[],s={};t<i.length;){var u=i[t],l=u.absolutePath();E(u,n,r,s);var p=u.getIncludeNodes();p.forEach(function(t){var i=t.includePath();if(i){var a=O.getIncludeReference(i);if(a)return void o.push(e.resolveAsync(u.absolutePath(),i));if(i){var p=T.buildPath(i,l,e.getRootPath());if(!n[p]){if(r[p]&&t.errors)return void t.errors().push(new V(r[i]));var c=s[p];c||(c=[],s[p]=c),c.push(t)}}}}),t++}var c=Object.keys(s);if(0==o.length&&0==c.length)return Promise.resolve();var f=o;return c.forEach(function(t){f.push(e.unitAsync(t,!0).then(function(e){n[e.absolutePath()]||(n[e.absolutePath()]=!0,i.push(e))},function(n){var i=e.pathToUnit[t];s[t].forEach(function(e){i||e.errors&&e.errors().push(new V(n))}),r[t]=n,e.failedUnits[t]=n,i&&(n.inner=!0)}))}),Promise.all(f).then(function(e){return a(t)})};return e.unitAsync(t,S.isAbsolute(t)).then(function(e){return i.push(e),n[e.absolutePath()]=!0,a(0)}).then(function(e){return i.length>0?i[0]:null})}Object.defineProperty(t,"__esModule",{value:!0});var T=n(5),S=n(6),N=n(8),I=n(274),b=n(21),R=n(16),M=n(248),C=n(55),w=n(275),P=n(212),L=n(15),O=n(276),D=n(279),U=n(204),x=n(217),k=n(224),F=n(19),B=n(207),V=b.YAMLException;t.Kind={SCALAR:b.Kind.SCALAR};var K=function(){function e(e){this.text="",this.indent=e}return e.prototype.isLastNL=function(){return this.text.length>0&&"\n"==this.text[this.text.length-1]},e.prototype.addWithIndent=function(e,t){this.isLastNL()&&(this.text+=M.indent(e),this.text+=this.indent),this.text+=t},e.prototype.addChar=function(e){this.isLastNL()&&(this.text+=this.indent),this.text+=e},e.prototype.append=function(e){for(var t=0;t<e.length;t++)this.addChar(e[t])},e}();t.MarkupIndentingBuffer=K;var j=function(){function e(e,t,n,r,i){this._path=e,this._content=t,this._tl=n,this._project=r,this._apath=i,this._includedByPaths=[],this._path=null!=this._path?this._path.replace(/\\/g,"/"):null}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&R.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.highLevel=function(){return this._hl?this._hl:(this._hl=C.fromUnit(this),this._hl)},e.prototype.isStubUnit=function(){return this.stu},e.prototype.resolveAsync=function(e){var t=this._project.resolveAsync(this._path,e);return t},e.prototype.getIncludeNodes=function(){var e=this.ast(),t=[];return null==e?[]:(e.gatherIncludes(t),e.children().forEach(function(e){"uses"==e.key()&&e.children().forEach(function(e){t.push({includePath:function(){var t=e.value();return"string"!=typeof t?null:t}})})}),t)},e.prototype.cloneToProject=function(t){var n=new e(this._path,this._content,this._tl,t,this._apath);return n},e.prototype.clone=function(){var t=new e(this._path,this._content,this._tl,this.project(),this._apath);return t},e.prototype.stub=function(){var t=new e(this._path,this._content,this._tl,this.project(),this._apath);return t.stu=!0,t},e.prototype.isDirty=function(){return!1},e.prototype.expandedHighLevel=function(){if(this.expanded)return this.expanded;var e=this.highLevel().asElement(),t=x.expandTraitsAndResourceTypes(e.wrapperNode()),n=t.highLevel();return n._expanded=!0,this.expanded=n,n},e.prototype.absolutePath=function(){return this._apath},e.prototype.isRAMLUnit=function(){var e=this.absolutePath();if(T.isWebPath(e))try{e=N.parse(e).pathname}catch(t){e=this._path}var t=S.extname(e);if(".raml"==t||".yaml"==t||".yml"==t)return!0;if(!t){if(!this._content)return!1;var n=this._content.trim();if(L.stringStartsWith(n,"#%RAML"))return!0;for(var r=n.split("\n"),i=void 0,a=0,o=r;a<o.length;a++){var s=o[a],u=s.trim();if(u&&!L.stringStartsWith(u,"#")){i=s;break}}if(!i)return!0;try{var l=b.load(i,{ignoreDuplicateKeys:!0});return l.kind!=b.Kind.SCALAR}catch(e){return!1}}return!1},e.prototype.contents=function(){return this._content},e.prototype.resolve=function(e){if("string"!=typeof e)return null;var t=this._project.resolve(this._path,e);return t},e.prototype.path=function(){return this._path},e.prototype.lexerErrors=function(){return null==this.errors&&this.ast(),this.errors},e.prototype.ast=function(){var e=this;if(this._node)return this._node;try{var t=b.load(this._content,{ignoreDuplicateKeys:!0});return this.errors=t.errors,this.errors.forEach(function(t){t.mark&&(t.mark.filePath=e.absolutePath())}),this._node=new Q(t,this,null,null,null),this._node._errors=this.errors,this._node}catch(e){return this.errors=[],this.errors.push(new V(e.message)),this._node=null,this._node}},e.prototype.isTopLevel=function(){return this._tl},e.prototype.updateContent=function(e){this._content=e,this.errors=null,this._node=null,this._lineMapper=null},e.prototype.updateContentSafe=function(e){this._content=e,this._lineMapper=null,this._hl=null},e.prototype.project=function(){return this._project},e.prototype.lineMapper=function(){return null==this._lineMapper&&(this._lineMapper=new T.LineMapperImpl(this.contents(),this.absolutePath())),this._lineMapper},e.prototype.isOverlayOrExtension=function(){for(var e=this.contents(),t="",n=null,r=0,i=0,a=0;a<e.length;a++){var o=e.charAt(a);if("\r"==o||"\n"==o){t?n=e.substring(i,a).trim():t=e.substring(0,a).trim();break}" "==o&&(r++,t||2!=r||(t=e.substring(0,a),i=a))}return"Extension"==n||"Overlay"==n},e.prototype.getMasterReferenceNode=function(){return R.find(this.ast().children(),function(e){return e.key()==U.Universe10.Overlay.properties.extends.name})},e.prototype.addIncludedBy=function(e){this.includedByContains(e)||this._includedByPaths.push(e)},e.prototype.includedByContains=function(e){return null!=R.find(this._includedByPaths,function(t){return t==e})},e.prototype.getIncludedByPaths=function(){return this._includedByPaths},e.CLASS_IDENTIFIER="jsyaml2lowLevel.CompilationUnit",e}();t.CompilationUnit=j;var W=n(280).XMLHttpRequest,H=n(280).XMLHttpRequest,Y=function(){function e(){}return e.prototype.open=function(e,t,n){this.xhr=n?new H:new W,this.async=n,this.xhr.open(e,t,n)},e.prototype.setRequestHeader=function(e,t){this.xhr.setRequestHeader(e,t)},e.prototype.getResponseHeader=function(e){return this.xhr.getResponseHeader(e)},e.prototype.getAllResponseHeaders=function(){return this.xhr.getAllResponseHeaders()},e.prototype.send=function(e){var t=this;this.xhr.onload=function(){return t.onResponse(!1)},this.xhr.onerror=function(){return t.onResponse(!0)},this.xhr.send(e)},e.prototype.onResponse=function(e){return this.statusText=this.xhr.statusText,this.responseText=this.xhr.responseText,this.responseType=this.xhr.responseType,this.status=this.xhr.status,e&&this.onerror?void this.onerror():void(this.onload&&this.onload())},e}();t.XMLHttpRequestWrapper=Y,t.buildXHR=r;var q=function(){function e(){}return e.prototype.execute=function(e,t){void 0===t&&(t=!0);var n=r(),i=e.url;t&&(i=this.appendParams(e,e.url)),n.open(e.method,i,!1),this.doRequest(e,n);var a=n.status;if(a>300&&a<400){var o=n.getResponseHeader("location");if(o)return e.url=o,this.execute(e,!1)}var s={status:a,statusText:n.statusText,headers:n.getAllResponseHeaders().split("\n").map(function(e){var t=e.indexOf(":");return{name:e.substring(0,t).trim(),value:e.substring(t+1).trim()}}),content:{text:n.responseText,mimeType:n.responseType}};return s},e.prototype.appendParams=function(e,t){var n=e.queryString&&e.queryString.length>0;if(n){t+="?";var r=[];n&&(r=r.concat(e.queryString.map(function(e){return encodeURIComponent(e.name)+"="+encodeURIComponent(e.value)}))),t+=r.join("&")}return t},e.prototype.log=function(e,t){},e.prototype.executeAsync=function(e,t){void 0===t&&(t=!0);var n=r(),i=e.url;t&&(i=this.appendParams(e,e.url));var a=this;return new Promise(function(t,r){n.open(e.method,i,!0),n.onload=function(){var e=n.status,r={status:e,statusText:n.statusText,headers:n.getAllResponseHeaders().split("\n").map(function(e){var t=e.indexOf(":");return{name:e.substring(0,t).trim(),value:e.substring(t+1).trim()}}),content:{text:n.responseText,mimeType:n.responseType}};t(r)},n.onerror=function(){r(new V(B.NETWORK_ERROR.message))},a.doRequest(e,n)})},e.prototype.doRequest=function(e,t){if(e.headers&&e.headers.forEach(function(e){return t.setRequestHeader(e.name,e.value)}),e.postData)if(e.postData.params){var n=e.postData.params.map(function(e){return encodeURIComponent(e.name)+"="+encodeURIComponent(e.value)}).join("&");t.send(n)}else t.send(e.postData.text);else t.send()},e}();t.SimpleExecutor=q;var G=function(){function e(){this.executor=new q;
}return e.prototype.getResource=function(e){if("undefined"!=typeof atom&&null!=atom){var t=P.get(e);if(t)return t;P.addNotify(e);try{var n={content:""};return this.getResourceAsync(e).then(function(t){try{t.errorMessage?P.set(e,{content:null,errorMessage:null}):(t.errorMessage=null,P.set(e,t))}finally{n.callback&&n.callback(P.get(e)),P.removeNotity(e)}},function(t){P.set(e,{content:null,errorMessage:null}),n.callback&&n.callback(P.get(e)),P.removeNotity(e)}),n}catch(e){console.log("Error"),console.log(e)}}var r=this.executor.execute({method:"get",url:e});if(!r)throw new V(F.applyTemplate(B.UNABLE_TO_EXECUTE_GET,{url:e}));var i=this.toResponse(r,e);return i},e.prototype.getResourceAsync=function(e){var t=this;return this.executor.executeAsync({method:"get",url:e}).then(function(n){if(!n)return Promise.reject(new V(F.applyTemplate(B.UNABLE_TO_EXECUTE_GET,{url:e})));var r=t.toResponse(n,e);return r},function(t){return Promise.reject(F.applyTemplate(B.UNABLE_TO_EXECUTE_GET,{url:e}))})},e.prototype.toResponse=function(e,t){var n=null;e.status>=400&&(n="GET "+t+"\nreturned error: "+e.status,e.statusText&&(n+=" "+e.statusText));var r=null;e.content&&e.content.text&&(r=e.content.text);var i={content:r,errorMessage:n};return i},e}();t.HTTPResolverImpl=G;var X=function(){function e(){}return e.prototype.content=function(e){if("string"!=typeof e&&(e=""+e),!I.existsSync(e))return null;try{return I.readFileSync(e).toString()}catch(e){return null}},e.prototype.list=function(e){return I.readdirSync(e)},e.prototype.contentAsync=function(e){return new Promise(function(t,n){I.readFile(e,function(e,r){if(null!=e)return n(e);var i=r.toString();t(i)})})},e.prototype.listAsync=function(e){return new Promise(function(t,n){I.readdir(e,function(e,t){return null!=e?Promise.reject(e):void n(t)})})},e}();t.FSResolverImpl=X;var z=function(e,t,n){if(t&&(t.startPosition>=e&&(t.startPosition+=n),t.endPosition>e&&(t.endPosition+=n),t.kind==b.Kind.MAPPING)){var r=t;z(e,r.key,n),z(e,r.value,n)}},$=function(e,t){for(var n="",r=e.start()-1;r>0;){var i=t[r];if(" "!=i&&"-"!=i)break;n=" "+n,r--}return n},J=function(){function e(e,t,n){this.rootPath=e,this.resolver=t,this._httpResolver=n,this.listeners=[],this.tlisteners=[],this.pathToUnit={},this.failedUnits={},this._fsEnabled=!0,this._namespaceResolver=new k.NamespaceResolver,null==this.resolver?this.resolver=new X:this._fsEnabled=!1,null==this._httpResolver&&(this._httpResolver=new G)}return e.prototype.getMainUnit=function(){return this.mainUnitPath?this.unit(this.mainUnitPath,!0):null},e.prototype.getRootPath=function(){return this.rootPath},e.prototype.getMainUnitPath=function(){return this.mainUnitPath},e.prototype.setMainUnitPath=function(e){this.mainUnitPath=e},e.prototype.setFSResolver=function(e){this.resolver=e},e.prototype.setHTTPResolver=function(e){this._httpResolver=e},e.prototype.fsEnabled=function(){return this._fsEnabled},e.prototype.cloneWithResolver=function(t,n){void 0===n&&(n=null);var r=new e(this.rootPath,t,n?n:this._httpResolver);for(var i in this.pathToUnit)r.pathToUnit[i]=this.pathToUnit[i].cloneToProject(r);return r},e.prototype.setCachedUnitContent=function(e,t,n){void 0===n&&(n=!0);var r=e,i=T.toAbsolutePath(this.rootPath,e),a=new j(r,t,n,this,i);return this.pathToUnit[i]=a,a},e.prototype.resolveAsync=function(e,t){var n=this;if(!t)return Promise.reject(new V(B.UNIT_PATH_IS_NULL.message));var r=O.getIncludeReference(t),i=t;r&&(t=r.getIncludePath());var a=T.buildPath(t,e,this.rootPath);if(r){var o,s=T.toAbsolutePath(S.dirname(T.toAbsolutePath(this.rootPath,e)),r.encodedName());this.pathToUnit[a]?Promise.resolve(o).then(function(e){return n.pathToUnit[s]=new j(r.encodedName(),O.resolveContents(i,n.pathToUnit[a].contents()),!1,n,s),n.pathToUnit[s]}):this.unitAsync(a,!0).then(function(e){return n.pathToUnit[a]=e,n.pathToUnit[s]=new j(r.encodedName(),O.resolveContents(i,n.pathToUnit[a].contents()),!1,n,s),n.pathToUnit[s]})}return this.unitAsync(a,!0)},e.prototype.resolve=function(e,t){if(!t)return null;t=t.replace(/\\/g,"/");var n=O.getIncludeReference(t),r=t;n&&(t=n.getIncludePath());var i=T.buildPath(t,e,this.rootPath);if(n){this.pathToUnit[i]||(this.pathToUnit[i]=this.unit(i,!0));var a=this.pathToUnit[i],o=T.toAbsolutePath(S.dirname(T.toAbsolutePath(this.rootPath,e)),n.encodedName());return this.pathToUnit[o]?this.pathToUnit[o]:(this.pathToUnit[o]=new j(n.encodedName(),O.resolveContents(r,a&&a.contents()),!1,this,o),this.pathToUnit[o])}return this.unit(i,!0)},e.prototype.units=function(){var e=this;if(!this.resolver.list)throw new V(B.FSRESOLVER_IS_UNABLE_USE_EXTENDEDFSRESOLVER.message);var t=this.resolver.list(this.rootPath).filter(function(e){return".raml"==S.extname(e)});return t.map(function(t){return e.unit(t)}).filter(function(e){return e.isTopLevel()})},e.prototype.unitsAsync=function(){var e=this;return this.resolver.listAsync?this.resolver.listAsync(this.rootPath).then(function(t){var n=t.filter(function(e){return".raml"==S.extname(e)}).map(function(t){return e.unitAsync(t).then(function(e){return e.isTopLevel()?e:null},function(e){return null})});return Promise.all(n).then(function(e){return e.filter(function(e){return null!=e})})}):Promise.reject(new V(B.FSRESOLVER_IS_UNABLE_USE_EXTENDEDFSRESOLVER.message))},e.prototype.lexerErrors=function(){var e=[];return this.units().forEach(function(t){e=e.concat(t.lexerErrors())}),e},e.prototype.deleteUnit=function(e,t){void 0===t&&(t=!1);var n=null;n=T.isWebPath(e)?e:t?e:T.toAbsolutePath(this.rootPath,e),delete this.pathToUnit[n]},e.prototype.unit=function(e,t){if(void 0===t&&(t=!1),t||T.isWebPath(e)){if(null!=this.failedUnits[e]&&!this.failedUnits[e].inner)return null}else{var n=T.toAbsolutePath(this.rootPath,e);if(this.failedUnits[n]&&!this.failedUnits[e].inner)return null}var r,i=null,a=e;if(T.isWebPath(e)){if(this.pathToUnit[a])return this.pathToUnit[a];if(this._httpResolver){if(r=this._httpResolver.getResource(e),r&&r.errorMessage)throw new V(r.errorMessage);i=r?r.content:null}else r=(new G).getResource(a),i=r?r.content:null}else{"/"!=e.charAt(0)||t||(e=e.substr(1));var a=T.toAbsolutePath(this.rootPath,e);if(this.pathToUnit[a])return this.pathToUnit[a];if(T.isWebPath(a))if(this._httpResolver){var o=this._httpResolver.getResource(a);if(o&&o.errorMessage)throw new V(o.errorMessage);i=o?o.content:null}else{var s=(new G).getResource(a);i=s?s.content:null}else i=this.resolver.content(a)}if(null==i)return null;var u=L.stringStartsWith(i,"#%RAML"),l=T.isWebPath(this.rootPath)==T.isWebPath(a)?S.relative(this.rootPath,a):a,p=new j(l,i,u,this,a);return this.pathToUnit[a]=p,r&&(r.callback=function(e){p.updateContent(e&&e.content)}),p},e.prototype.unitAsync=function(e,t){var n=this;void 0===t&&(t=!1);var r=null,i=e;if(T.isWebPath(e)){if(this.pathToUnit[i])return Promise.resolve(this.pathToUnit[i]);if(this._httpResolver){var a=this._httpResolver.getResourceAsync(i);r=a.then(function(e){return e.errorMessage?Promise.reject(new V(e.errorMessage)):e.content})}else r=(new G).getResourceAsync(i).then(function(e){return e.errorMessage?Promise.reject(e.errorMessage):e.content})}else{if("/"!=e.charAt(0)||t||(e=e.substr(1)),i=t?e:T.toAbsolutePath(this.rootPath,e),this.pathToUnit[i])return Promise.resolve(this.pathToUnit[i]);if(T.isWebPath(i))if(this._httpResolver){var a=this._httpResolver.getResourceAsync(i);r=a.then(function(e){return e.errorMessage?Promise.reject(new V(e.errorMessage)):e.content})}else r=(new G).getResourceAsync(i).then(function(e){return e.errorMessage?Promise.reject(new V(e.errorMessage)):e.content});else r=this.resolver.contentAsync(i)}if(null==r)return Promise.resolve(null);var o=T.isWebPath(this.rootPath)==T.isWebPath(i)?S.relative(this.rootPath,i):i;return r.then(function(e){if(null==e)return Promise.reject(new V(F.applyTemplate(B.CAN_NOT_RESOLVE,{path:i})));var t=L.stringStartsWith(e,"#%RAML"),r=new j(o,e,t,n,i);return n.pathToUnit[i]=r,r},function(e){return"object"==typeof e&&e instanceof V?Promise.reject(e):Promise.reject(new V(e.toString()))}).then(function(e){return e.isRAMLUnit()?e:D.isScheme(e.contents())?D.startDownloadingReferencesAsync(e.contents(),e):e})},e.prototype.visualizeNewlines=function(e){for(var t="",n=0;n<e.length;n++){var r=e[n];"\r"==r&&(r="\\r"),"\n"==r&&(r="\\n"),t+=r}return t},e.prototype.indent=function(e){var t=e.unit().contents();if(e==e.root())return"";var n=$(e,t),r=a(e.dump());if(r.length>1&&r[1].trim().length>0){var i=s(r[1]);return n+i}return n+"  "},e.prototype.startIndent=function(e){e.unit().contents();if(e==e.root())return"";var t=a(e.dump());if(t.length>0){console.log("FIRST: "+t[0]);var n=s(t[0]);return n+"  "}return""},e.prototype.canWriteInOneLine=function(e){return!1},e.prototype.isOneLine=function(e){return e.text().indexOf("\n")<0},e.prototype.recalcPositionsUp=function(e){for(var t=e;t;)t.recalcEndPositionFromChilds(),t=t.parent()},e.prototype.add2=function(e,t,n,r,i){void 0===i&&(i=!1);var a=e.unit(),o=(e.root(),null);if(r&&(Q.isInstance(r)&&(o=r),ee.isInstance(r)&&(o=r.point)),e.isValueInclude()){var s=e.children();if(0==s.length)throw new V(B.NOT_IMPLEMENTED_INSERT_INTO_EMPTY_REF.message);var u=s[0].parent();return void this.add2(u,t,n,o,i)}var l=(new M.TextRange(a.contents(),t.start(),t.end()),new M.TextRange(a.contents(),e.start(),e.end()),e.unit().contents());e.valueKind()==b.Kind.SEQ&&(e=h(e.valueAsSeq(),e,e.unit()));var i=this.isJson(e),p=i?"":this.indent(e.isSeq()?e.parent():e),c=p,f=p.length,d=e.isSeq()||e.isMapping()&&(e.isValueSeq()||e.isValueScalar()||!e.asMapping().value);n=n,n&&(i||d&&(c+="  ",f+=2));var m=new K(c);t.markupNode(m,t._actualNode(),0,i);var y=m.text;if(n){var v=M.trimEnd(y),g=y.length-v.length;if(g>0){var A=y.length;y=y.substring(0,A-g),t.shiftNodes(A-g,-g)}}n&&!i?(t.highLevelNode(),e.isMapping(),y=e.isSeq()||e.isMapping()&&(e.isValueSeq()||e.isValueScalar()||!e.asMapping().value)?p+"- "+y:p+y):y=p+y;var E=e.end();if(o)o!=e?E=o.end():i&&n||(E=e.keyEnd()+1,E=new M.TextRange(l,E,E).extendAnyUntilNewLines().endpos());else if(i&&n){var _=e.asSeq();_&&(E=_.items.length>0?_.items[_.items.length-1].endPosition:_.endPosition-1)}else if(r&&ee.isInstance(r)){var T=r;T.type==Z.START&&(E=e.keyEnd()+1,E=new M.TextRange(l,E,E).extendAnyUntilNewLines().endpos())}var S=new M.TextRange(l,0,E);if(E=S.extendToNewlines().reduceSpaces().endpos(),i&&e.isSeq()){var _=e.asSeq();_.items.length>0&&(y=", "+y,f+=2)}else E>0&&"\n"!=l[E-1]&&(y="\n"+y,f++);var N=0;n&&!i&&(y+="\n",N++);var I=l.substring(0,E)+y+l.substring(E,l.length),R=a;if(R.updateContentSafe(I),this.executeReplace(new M.TextRange(l,E,E),y,R),e.root().shiftNodes(E,f+(t.end()-t.start())+N),o){for(var s=e.children(),C=-1,w=0;w<s.length;w++){var P=s[w];if(P.start()==o.start()&&P.end()==o.end()){C=w;break}}C>=0?e.addChild(t,C+1):e.addChild(t)}else e.addChild(t);t.shiftNodes(0,E+f),this.recalcPositionsUp(e),t.setUnit(e.unit()),t.visit(function(t){var n=t;return n.setUnit(e.unit()),!0})},e.prototype.isJsonMap=function(e){if(!e.isMap())return!1;var t=e.text().trim();return t.length>=2&&"{"==t[0]&&"}"==t[t.length-1]},e.prototype.isJsonSeq=function(e){if(!e.isSeq())return!1;var t=e.text().trim();return t.length>=2&&"["==t[0]&&"]"==t[t.length-1]},e.prototype.isJson=function(e){return this.isJsonMap(e)||this.isJsonSeq(e)},e.prototype.remove=function(e,t,n){var r=n.parent();if(n._oldText=n.dump(),this.isOneLine(n)&&n.isMapping()&&n.parent().isMap()){var i=n.parent();if(1==i.asMap().mappings.length&&null!=i.parent())return void this.remove(e,i.parent(),i)}if(this.isOneLine(n)&&n.isScalar()&&n.parent().isSeq()){var a=n.parent(),o=a.asSeq();if(1==o.items.length)return void this.remove(e,a.parent(),a)}if(t.isMapping()&&n.isSeq()){var s=t.parent();return void this.remove(e,s,t)}var u=new M.TextRange(e.contents(),n.start(),n.end()),l=(new M.TextRange(e.contents(),t.start(),t.end()),new M.TextRange(e.contents(),r.start(),r.end()),u.startpos());if(t.isSeq()){var p=n.isSeq()?n:n.parentOfKind(b.Kind.SEQ);u=p&&this.isJson(p)?u.extendSpaces().extendCharIfAny(",").extendSpaces():u.extendToStartOfLine().extendAnyUntilNewLines().extendToNewlines()}t.isMap()&&(u=u.trimEnd().extendAnyUntilNewLines().extendToNewlines(),u=u.extendToStartOfLine().extendUntilNewlinesBack()),t.kind()==b.Kind.MAPPING&&(this.isJson(n)&&this.isOneLine(n)||(u=u.extendSpacesUntilNewLines(),u=u.extendToNewlines(),u=u.extendToStartOfLine().extendUntilNewlinesBack())),n.isSeq()&&(u=u.reduceSpaces());var c=e;c.updateContentSafe(u.remove()),this.executeReplace(u,"",c),n.parent().removeChild(n);var f=-u.len();t.root().shiftNodes(l,f),this.recalcPositionsUp(t)},e.prototype.changeKey=function(e,t,n){var r=new M.TextRange(t.unit().contents(),t.keyStart(),t.keyEnd());if(t.kind()==b.Kind.MAPPING){var i=t._actualNode().key;i.value=n,i.endPosition=i.startPosition+n.length}var a=e;this.executeReplace(r,n,a);var o=n.length-r.len();t.root().shiftNodes(r.startpos(),o,t),this.recalcPositionsUp(t)},e.prototype.executeReplace=function(e,t,n){var r=new T.TextChangeCommand(e.startpos(),e.endpos()-e.startpos(),t,n);n.project();try{this.tlisteners.forEach(function(e){return e(r)})}catch(e){return!1}var i=e.replace(t);return n.updateContentSafe(i),!0},e.prototype.changeValue=function(e,t,n){var r,i=new M.TextRange(t.unit().contents(),t.start(),t.end()),a=0,o=0,s=null,u=null;if(t.kind()==b.Kind.SCALAR){if("string"!=typeof n)throw new V(B.NOT_IMPLEMENTED.message);t.asScalar().value=n,r=n}else if(t.kind()==b.Kind.MAPPING){if(u=t.asMapping(),t.isValueInclude()){var l=t.valueAsInclude(),p=l.value,f=p,h=t.unit().resolve(f);if(null==h)return void console.log(F.applyTemplate(B.ATTR_SETVALUE_NOT_RESOLVE,{path:f}));if(h.isRAMLUnit())return;return void(O.getIncludeReference(p)||h.updateContent(n))}if(i=u.value?i.withStart(t.valueStart()).withEnd(t.valueEnd()):i.withStart(t.keyEnd()+1).withEnd(t.keyEnd()+1),i=i.reduceNewlinesEnd(),null==n)r="",u.value=null;else if("string"==typeof n||null==n){var d=n,m=this.indent(t);if(d&&M.isMultiLine(d)&&(d=""+M.makeMutiLine(d,m.length/2)),r=d,u.value){if(u.value.kind==b.Kind.SEQ){console.log("seq value");u.value.items[0];throw"assign value!!!"}if(u.value.kind==b.Kind.SCALAR){var y=u.value,v=y.value||"";y.value=d,u.value.endPosition=u.value.startPosition+d.length,u.endPosition=u.value.endPosition,o+=d.length-v.length}}else if(console.log("no value"),u.value=b.newScalar(d),u.value.startPosition=t.keyEnd()+1,u.value.endPosition=u.value.startPosition+d.length,u.endPosition=u.value.endPosition,e.contents().length>t.keyEnd()+1){var g=t.keyEnd()+1;":"==e.contents()[g-1]&&(r=" "+r,u.value.startPosition++,u.value.endPosition++,u.endPosition++,o++)}}else{var A=n;if(A.isMapping())n=c([A.asMapping()]),A=n;else if(!A.isMap())throw new V(B.ONLY_MAP_NODES_ALLOWED.message);var E=new K("");A.markupNode(E,A._actualNode(),0,!0),r=""+E.text,A.shiftNodes(0,i.startpos()+o),s=A}}else console.log(F.applyTemplate(B.UNSUPPORTED_CHANGE_VALUE_CASE,{name:t.kindName()}));var _=e;this.executeReplace(i,r,_);var T=r.length-i.len();t.root().shiftNodes(i.endpos()+a,T,t),s&&(u.value=s._actualNode()),this.recalcPositionsUp(t)},e.prototype.initWithRoot=function(e,t){var n=e.end();t.markup(!1),t._actualNode().startPosition=n,t._actualNode().endPosition=n,t.setUnit(e.unit())},e.prototype.execute=function(e){var t=this;e.commands.forEach(function(e){switch(e.kind){case T.CommandKind.CHANGE_VALUE:var n=e.target,r=n.value();r||(r="");var i=e.value;if(console.log("set value: "+typeof r+" ==> "+typeof i),"string"!=typeof r&&"number"!=typeof r&&"boolean"!=typeof r||"string"!=typeof i)if("string"!=typeof r&&"number"!=typeof r&&"boolean"!=typeof r||"string"==typeof i)if("string"!=typeof r&&"string"==typeof i){var a=e.value;if(r.kind()!=b.Kind.MAPPING)throw new V(F.applyTemplate(B.UNSUPPORTED_CASE_ATTRIBUTE_VALUE_CONVERSION,{curval:r,newval:i}));M.isMultiLine(a)?(n.children().forEach(function(e){t.remove(n.unit(),n,e)}),t.changeValue(n.unit(),n,a)):t.changeKey(n.unit(),r,a)}else{if("string"==typeof r||"string"==typeof i)throw new V(F.applyTemplate(B.UNSUPPORTED_CASE_ATTRIBUTE_VALUE_CONVERSION,{curval:r,newval:i}));var o=i;if(o.isMapping()&&(i=c([o.asMapping()])),r==i)break;var s=i;s.asMap();n.children().forEach(function(e){t.remove(n.unit(),n,e)}),s.children().forEach(function(e){}),t.changeValue(n.unit(),n,i)}else t.changeValue(n.unit(),n,i);else r!=i&&t.changeValue(n.unit(),n,i);return;case T.CommandKind.CHANGE_KEY:var n=e.target;return void t.changeKey(n.unit(),n,e.value);case T.CommandKind.ADD_CHILD:var n=e.target,u=e.value;return void t.add2(n,u,e.toSeq,e.insertionPoint);case T.CommandKind.REMOVE_CHILD:var l=e.target,s=e.value;return void t.remove(l.unit(),l,s);case T.CommandKind.INIT_RAML_FILE:var p=e.target,f=e.value;return void t.initWithRoot(p,f);default:return void console.log(F.applyTemplate(B.UNSUPPORTED_COMMAND,{name:T.CommandKind[e.kind]}))}})},e.prototype.replaceYamlNode=function(e,t,n,r,i){var a=b.load(t,{ignoreDuplicateKeys:!0});this.updatePositions(e.start(),a),e.root().shiftNodes(n,r);var o=e.parent(),s=e._actualNode(),u=s.parent;if(a.parent=u,o&&o.kind()==b.Kind.MAP){var l=o._actualNode();l.mappings=l.mappings.map(function(e){return e!=s?e:a})}e.updateFrom(a),this.recalcPositionsUp(e)},e.prototype.executeTextChange2=function(e){var t=e.unit,n=t.contents(),r=e.target;if(r){var i=n.substring(r.start(),r.end());n=n.substr(0,e.offset)+e.text+n.substr(e.offset+e.replacementLength);var a=i.substr(0,e.offset-r.start())+e.text+i.substr(e.offset-r.start()+e.replacementLength);if(t.updateContentSafe(n),e.offset>r.start())try{var o=e.text.length-e.replacementLength,s=e.offset;r.unit().project().replaceYamlNode(r,a,s,o,e.unit)}catch(e){console.log("New node contents (causes error below): \n"+a),console.log("Reparse error: "+e.stack)}}else n=n.substr(0,e.offset)+e.text+n.substr(e.offset+e.replacementLength);t.updateContent(n),this.listeners.forEach(function(e){e(null)}),this.tlisteners.forEach(function(t){t(e)})},e.prototype.executeTextChange=function(e){(new Date).getTime();try{var t=e.unit.contents(),n=e.target;null==n&&(n=this.findNode(e.unit.ast(),e.offset,e.offset+e.replacementLength));var r=e.unit;if(n){var a=t.substring(n.start(),n.end()),o=t;t=t.substr(0,e.offset)+e.text+t.substr(e.offset+e.replacementLength);var s=a.substr(0,e.offset-n.start())+e.text+a.substr(e.offset-n.start()+e.replacementLength);r.updateContentSafe(t);u(o,e);if(e.offset>n.start())try{var l=b.load(s,{ignoreDuplicateKeys:!0});this.updatePositions(n.start(),l);var p=e.text.length-e.replacementLength;if(e.unit.ast().shiftNodes(e.offset,p),null!=l&&l.kind==b.Kind.MAP){var c=l.mappings[0],f=n._actualNode(),h=f.parent,d=new T.ASTDelta,m=e.unit;if(d.commands=[new T.ASTChangeCommand(T.CommandKind.CHANGE_VALUE,new Q(i(f),m,null,null,null),new Q(c,m,null,null,null),0)],h&&h.kind==b.Kind.MAP){var y=h;y.mappings=y.mappings.map(function(e){return e!=f?e:c})}return c.parent=h,this.recalcPositionsUp(n),n.updateFrom(c),this.listeners.forEach(function(e){e(d)}),void this.tlisteners.forEach(function(t){t(e)})}}catch(e){console.log(F.applyTemplate(B.NEW_NODE_CONTENTS_ERROR_BELOW,{content:s})),console.log(F.applyTemplate(B.REPARSE_ERROR,{content:e.stack}))}}else t=t.substr(0,e.offset)+e.text+t.substr(e.offset+e.replacementLength);(new Date).getTime();
//!find node in scope
r.updateContent(t),this.listeners.forEach(function(e){e(null)}),this.tlisteners.forEach(function(t){t(e)})}finally{(new Date).getTime()}},e.prototype.updatePositions=function(e,t){var n=this;if(null!=t)switch(t.startPosition==-1?t.startPosition=e:t.startPosition=e+t.startPosition,t.endPosition=e+t.endPosition,t.kind){case b.Kind.MAP:var r=t;r.mappings.forEach(function(t){return n.updatePositions(e,t)});break;case b.Kind.MAPPING:var i=t;this.updatePositions(e,i.key),this.updatePositions(e,i.value);break;case b.Kind.SCALAR:break;case b.Kind.SEQ:var a=t;a.items.forEach(function(t){return n.updatePositions(e,t)})}},e.prototype.findNode=function(e,t,n){var r=this;if(null==e)return null;var i=e;if(e.start()<=t&&e.end()>=n){var a=e;return i.directChildren().forEach(function(e){var i=r.findNode(e,t,n);i&&(a=i)}),a}return null},e.prototype.addTextChangeListener=function(e){this.tlisteners.push(e)},e.prototype.removeTextChangeListener=function(e){this.tlisteners=this.tlisteners.filter(function(t){return t!=e})},e.prototype.addListener=function(e){this.listeners.push(e)},e.prototype.removeListener=function(e){this.listeners=this.listeners.filter(function(t){return t!=e})},e.prototype.namespaceResolver=function(){return this._namespaceResolver},e}();t.Project=J;var Q=function(){function e(e,t,n,r,i,a,o){void 0===a&&(a=!1),void 0===o&&(o=!1),this._node=e,this._unit=t,this._parent=n,this._anchor=r,this._include=i,this.cacheChildren=a,this._includesContents=o,this._errors=[]}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&R.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.actual=function(){return this._node},e.prototype.yamlNode=function(){return this._node},e.prototype.includesContents=function(){return this._includesContents},e.prototype.setIncludesContents=function(e){this._includesContents=e},e.prototype.gatherIncludes=function(t,n,r,i){var a=this;if(void 0===t&&(t=[]),void 0===n&&(n=null),void 0===r&&(r=null),void 0===i&&(i=!0),null!=this._node){var o=this._node.kind;if(o!=b.Kind.SCALAR)if(o==b.Kind.MAP){var s=this._node;1!=s.mappings.length||i?s.mappings.map(function(t){return new e(t,a._unit,a,r?r:a._anchor,n?n:a._include,a.cacheChildren)}).forEach(function(e){return e.gatherIncludes(t)}):new e(s.mappings[0].value,this._unit,this,n,r,this.cacheChildren).gatherIncludes(t)}else if(o==b.Kind.MAPPING){var u=this._node;null==u.value||new e(u.value,this._unit,this,r?r:this._anchor,n?n:this._include,this.cacheChildren).gatherIncludes(t)}else if(o==b.Kind.SEQ){var l=this._node;l.items.filter(function(e){return null!=e}).map(function(t){return new e(t,a._unit,a,r?r:a._anchor,n?n:a._include,a.cacheChildren)}).forEach(function(e){return e.gatherIncludes(t)})}else o==b.Kind.INCLUDE_REF&&this._unit&&t.push(this);else if(D.isScheme(this._node.value)){var p=D.getReferences(this._node.value,this.unit());p.forEach(function(n){var r=b.newScalar(n);r.kind=b.Kind.INCLUDE_REF;var i=new e(r,a.unit(),null,null,null);t.push(i)})}}},e.prototype.setHighLevelParseResult=function(e){this._highLevelParseResult=e},e.prototype.highLevelParseResult=function(){return this._highLevelParseResult},e.prototype.setHighLevelNode=function(e){this._highLevelNode=e},e.prototype.highLevelNode=function(){return this._highLevelNode},e.prototype.start=function(){return this._node.startPosition},e.prototype.errors=function(){return this._errors},e.prototype.addIncludeError=function(e){if(!R.find(this._errors,function(t){return t.message==e.message})){var t=this._node;t.includeErrors||(t.includeErrors=[]),R.find(t.includeErrors,function(t){return t.message==e.message})||(this._errors.push(e),t.includeErrors.push(e))}},e.prototype.parent=function(){return this._parent},e.prototype.recalcEndPositionFromChilds=function(){var e=(this.children(),this.children()[0]),t=this.children()[this.children().length-1];if(this.isMapping()){var n=this.asMapping();if(n.value)if(n.value.kind==b.Kind.MAP){var r=n.value;r.startPosition<0&&e&&(r.startPosition=e.start()),t&&(this._node.endPosition=t._node.endPosition),this._node.endPosition=Math.max(this._node.endPosition,n.value.endPosition)}else if(n.value.kind==b.Kind.SEQ){var i=n.value;if(i.startPosition<0&&i.items.length>0){var a=i.items[0].startPosition,o=new M.TextRange(this.unit().contents(),a,a);o=o.extendSpacesBack().extendCharIfAnyBack("-"),i.startPosition=o.startpos()}if(i.items.length>0){var s=i.items[i.items.length-1];this._node.endPosition=Math.max(this._node.endPosition,i.endPosition,s.endPosition),i.endPosition=Math.max(this._node.endPosition,i.endPosition,s.endPosition)}}else n.value.kind==b.Kind.SCALAR||t&&(this._node.endPosition=t._node.endPosition)}else t&&(this._node.endPosition=t._node.endPosition)},e.prototype.isValueLocal=function(){if(this._node.kind==b.Kind.MAPPING){var e=this._node.value.kind;return e!=b.Kind.INCLUDE_REF&&e!=b.Kind.ANCHOR_REF}return!0},e.prototype.keyStart=function(){return this._node.kind==b.Kind.MAPPING?this._node.key.startPosition:-1},e.prototype.keyEnd=function(){return this._node.kind==b.Kind.MAPPING?this._node.key.endPosition:-1},e.prototype.valueStart=function(){if(this._node.kind==b.Kind.MAPPING){var e=this.asMapping();return e.value?e.value.startPosition:e.endPosition}return this._node.kind==b.Kind.SCALAR?this.start():-1},e.prototype.valueEnd=function(){if(this._node.kind==b.Kind.MAPPING){var e=this.asMapping();return e.value?e.value.endPosition:e.endPosition}return this._node.kind==b.Kind.SCALAR?this.end():-1},e.prototype.end=function(){return this._node.endPosition},e.prototype.dump=function(){if(this._oldText)return this._oldText;if(this._unit&&this._node.startPosition>0&&this._node.endPosition>0){var e=this._unit.contents().substring(this._node.startPosition,this._node.endPosition);return e=o(e,$(this,this._unit.contents()))}return b.dump(this.dumpToObject(),{})},e.prototype.dumpToObject=function(e){return void 0===e&&(e=!1),this.dumpNode(this._node,e)},e.prototype.dumpNode=function(e,t){var n=this;if(void 0===t&&(t=!1),!e)return null;if(e.kind==b.Kind.INCLUDE_REF){if(this._unit){var r=e,i=r.value,a=null;try{a=this._unit.resolve(i)}catch(e){}if(null==a)return null;if(a.isRAMLUnit()&&this.canInclude(a)){var o=this.unit(),s=a;s.addIncludedBy(o.absolutePath()),o.getIncludedByPaths().forEach(function(e){s.addIncludedBy(e)});var u=a.ast();if(u)return u.dumpToObject(t)}else if(this.canInclude(a))return a.contents()}return null}if(e.kind==b.Kind.SEQ){var p=e,c=[];return p.items.forEach(function(e){return c.push(n.dumpNode(e,t))}),c}if(e.kind==b.Kind.ANCHOR_REF){var f=e;return this.dumpNode(f.value,t)}if(e.kind==b.Kind.MAPPING){var h=e,d={},m=h.value,y=this.dumpNode(m,t);return d[""+this.dumpNode(h.key,t)]=y,d}if(e.kind==b.Kind.SCALAR){var r=e,v=r.value;return r.plainScalar&&(v=l(v)),v}if(e.kind==b.Kind.MAP){var g=e,A={};return g.mappings&&g.mappings.forEach(function(e){var r=n.dumpNode(e.value,t);null==r&&(r=t?"!$$$novalue":r),A[n.dumpNode(e.key,t)+""]=r}),A}},e.prototype.keyKind=function(){return this._node.key?this._node.key.kind:null},e.prototype._actualNode=function(){return this._node},e.prototype.execute=function(e){this.unit()?this.unit().project().execute(e):e.commands.forEach(function(e){switch(e.kind){case T.CommandKind.CHANGE_VALUE:var t=e.target,n=e.value,r=t._actualNode();t.start();return void(r.kind==b.Kind.MAPPING&&(r.value=b.newScalar(""+n)));case T.CommandKind.CHANGE_KEY:var t=e.target,n=e.value,r=t._actualNode();if(r.kind==b.Kind.MAPPING){var i=r.key;i.value=n}return}})},e.prototype.updateFrom=function(e){this._node=e},e.prototype.isAnnotatedScalar=function(){if(!this.unit())return!1;for(var e,t=this;!e&&t;)e=t.highLevelNode(),t=t.parent();if(e){var n=void 0;if(e.isElement())n=e.asElement().definition();else{var r=e.property();n=r&&(r.domain()||r.range())}if(n){var i=n.universe().version();if("RAML08"==i)return!1}}var a;if(this.kind()==b.Kind.MAPPING&&this.valueKind()==b.Kind.MAP?a=this._node.value.mappings:null==this.key()&&this.kind()==b.Kind.MAP&&(a=this._node.mappings),a){var o=a.length>0;return a.forEach(function(e){"value"!==e.key.value&&(e.key.value&&"("==e.key.value.charAt(0)&&")"==e.key.value.charAt(e.key.value.length-1)||(o=!1))}),o}return!1},e.prototype.value=function(t){if(!this._node)return"";if(this._node.kind==b.Kind.SCALAR){if("~"===this._node.value&&null===this._node.valueObject)return null;if(!t&&""+this._node.valueObject===this._node.value)return this._node.valueObject;var n=null;return n=this._node.hasOwnProperty("valueObject")&&null==this._node.valueObject?this._node.valueObject:this._node.value,t||this._node.plainScalar&&(n=l(n)),n}if(this._node.kind==b.Kind.ANCHOR_REF){var r=this._node;return new e(r.value,this._unit,this,null,null).value(t)}if(this._node.kind==b.Kind.MAPPING){var i=this._node;if(null==i.value)return null;if(this.isAnnotatedScalar())for(var a=new e(i.value,this._unit,this,null,null),o=a.children(),s=0;s<o.length;s++)if("value"===o[s].key())return o[s].valueKind()==b.Kind.SEQ?o[s].children().map(function(e){return e.value()}):o[s].value();return new e(i.value,this._unit,this,null,null).value(t)}if(this._node.kind==b.Kind.INCLUDE_REF){var u=this._node.value,p=u,c=null;try{c=this._unit.resolve(p)}catch(e){return F.applyTemplate(B.CAN_NOT_RESOLVE_REASON,{path:p,reason:e.message})}if(null==c)return F.applyTemplate(B.CAN_NOT_RESOLVE,{path:p});if(c.isRAMLUnit()){var f=c.ast();return f?f.value():F.applyTemplate(B.CAN_NOT_RESOLVE_REASON,{path:p,reason:"file is empty"})}var h=c.contents();return M.isMultiLineValue(h)&&(h=M.fromMutiLine(h)),h}if(this._node.kind==b.Kind.MAP){var d=this._node;if(1==d.mappings.length)return new e(d.mappings[0],this._unit,this,null,null);if(this.isAnnotatedScalar())for(var o=this.children(),s=0;s<o.length;s++)if("value"===o[s].key())return o[s].valueKind()==b.Kind.SEQ?o[s].children().map(function(e){return e.value()}):o[s].value()}if(this._node.kind==b.Kind.SEQ){var m=this._node;if(1==m.items.length)return new e(m.items[0],this._unit,this,null,null).value(t)}return null},e.prototype.printDetails=function(e){var t="";e||(e="");var n=this.kindName();return this.kind()==b.Kind.SCALAR?t+=e+"["+n+"] "+this.value()+"\n":this.kind()==b.Kind.MAPPING&&this._node.value&&this._node.value.kind==b.Kind.SCALAR?t+=e+"["+n+"] "+this.key()+" = "+this.value()+"\n":this.kind()==b.Kind.MAPPING?(t+=e+"["+n+"] "+this.key()+" = :\n",this.children().forEach(function(n){t+=n.printDetails(e+"\t")})):(t+=e+"["+n+"] :\n",this.children().forEach(function(n){t+=n.printDetails(e+"\t")})),t},e.prototype.visit=function(e){this.children().forEach(function(t){e(t)&&t.visit(e)})},e.prototype.rawKey=function(){if(!this._node)return"";if(this._node.kind==b.Kind.MAPPING){var e=this._node;if(e.key.kind==b.Kind.SEQ){var t=e.key,n="[";return t.items.forEach(function(e){return n+=e.value}),n+"]"}return e.key.value}if(this._node.kind==b.Kind.INCLUDE_REF){var r=this.children();if(1==r.length)return r[0].key()}return null},e.prototype.key=function(e){void 0===e&&(e=!1);var t=this.rawKey();return e?t:(null!=t&&L.stringEndsWith(t,"?")&&(t=t.substring(0,t.length-1)),t)},e.prototype.optional=function(){var e=this.rawKey();return null!=e&&L.stringEndsWith(e,"?")},e.prototype.addChild=function(e,t){void 0===t&&(t=-1);var n=e;if(n._parent=this,this._oldText=null,this.isMap()){var r=this.asMap();null!=r.mappings&&void 0!=r.mappings||(r.mappings=[]),t>=0?r.mappings.splice(t,0,n.asMapping()):r.mappings.push(n.asMapping())}else if(this.isMapping()){var i=this.asMapping(),a=i.value;if(!i.value&&n.isMap())return void(i.value=n._actualNode());if(i.value&&i.value.kind==b.Kind.SCALAR&&(i.value=null,a=null),a||(a=n.isScalar()||n.highLevelNode()&&n.highLevelNode().property().getAdapter(w.RAMLPropertyParserService).isEmbedMap()?b.newSeq():b.newMap(),i.value=a),a.kind==b.Kind.MAP){var r=a;null!=r.mappings&&void 0!=r.mappings||(r.mappings=[]),n.isScalar(),t>=0?r.mappings.splice(t,0,n.asMapping()):r.mappings.push(n.asMapping())}else{if(a.kind!=b.Kind.SEQ)throw new V(F.applyTemplate(B.INSERT_INTO_MAPPING_VALUE_NOT_SUPPORTED,{value:b.Kind[i.value.kind]}));var o=a;t>=0?o.items.splice(t,0,n._actualNode()):o.items.push(n._actualNode())}}else{if(!this.isSeq())throw new V(F.applyTemplate(B.INSERT_INTO_NOT_SUPPORTED,{name:this.kindName()}));var o=this.asSeq();t>=0?o.items.splice(t,0,n._actualNode()):o.items.push(n._actualNode())}},e.prototype.removeChild=function(e){this._oldText=null;var t,n,r=e;if(this.kind()==b.Kind.SEQ){var i=this.asSeq();t=r._node,n=i.items.indexOf(t),n>-1&&i.items.splice(n,1)}else if(this.kind()==b.Kind.MAP){var a=this.asMap();t=r.asMapping(),n=a.mappings.indexOf(t),n>-1&&a.mappings.splice(n,1)}else{if(this.kind()!=b.Kind.MAPPING)throw new V(F.applyTemplate(B.DELETE_FROM_NOT_SUPPORTED,{name:b.Kind[this.kind()]}));var o=this.asMapping();if(r._actualNode()==o.value)o.value=null;else{var a=o.value;t=r.asMapping(),a&&a.mappings&&(n=a.mappings.indexOf(t),n>-1&&a.mappings.splice(n,1))}}},e.prototype.hasInnerIncludeError=function(){return this.innerIncludeErrors},e.prototype.includeErrors=function(){if(this._node.kind==b.Kind.MAPPING){var t=this._node;if(null==t.value)return[];var n=new e(t.value,this._unit,this,this._anchor,this._include),r=n.includeErrors();return this.innerIncludeErrors=n.hasInnerIncludeError(),r}var i=[];if(this._node.kind==b.Kind.INCLUDE_REF){var t=this._node;if(null==t.value)return[];var a=this.includePath(),o=null;try{o=this._unit.resolve(a)}catch(e){this.innerIncludeErrors=e.inner;var s=F.applyTemplate(B.CAN_NOT_RESOLVE_REASON,{path:a,reason:e.message});return i.push(s),i}var u=this._node.includeErrors;if(u&&u.length>0)return this.innerIncludeErrors=!0,i=u.map(function(e){return"object"==typeof e&&e instanceof V?e.message:e.toString()});if(null==o)return i.push(F.applyTemplate(B.CAN_NOT_RESOLVE,{path:a})),i;if(o.isRAMLUnit()){var l=o.ast();if(l)return[];i.push(F.applyTemplate(B.CAN_NOT_BE_PARSED,{path:a}))}}return i},e.prototype.joinMappingsWithFullIncludeAnchor=function(t,n,r){var i=this,a=R.find(t,function(e){return e.key&&e.value&&e.key.kind==b.Kind.SCALAR&&"<<"==e.key.value&&e.value.kind==b.Kind.ANCHOR_REF});if(!a)return t.map(function(t){return new e(t,i._unit,i,r?r:i._anchor,n?n:i._include,i.cacheChildren)});var o=R.filter(t,function(e){return!(e.key.kind==b.Kind.SCALAR&&"<<"==e.key.value&&e.value.kind==b.Kind.ANCHOR_REF)}),s=new e(a.value,this._unit,this,n,r,this.cacheChildren).children(null,null,!0),u=o.map(function(t){return new e(t,i._unit,i,r?r:i._anchor,n?n:i._include,i.cacheChildren)});return u.concat(s)},e.prototype.children=function(t,n,r){var i=this;if(void 0===t&&(t=null),void 0===n&&(n=null),void 0===r&&(r=!0),null==this._node)return[];if(this.cacheChildren&&this._children)return this._children;var a,o=this._node.kind;if(o==b.Kind.SCALAR)a=[];else if(o==b.Kind.MAP){var s=this._node;a=1!=s.mappings.length||r?this.joinMappingsWithFullIncludeAnchor(s.mappings,t,n):new e(s.mappings[0].value,this._unit,this,t,n,this.cacheChildren).children(null,null,!0)}else if(o==b.Kind.MAPPING){var u=this._node;if(null==u.value)a=[];else{var l=new e(u.value,this._unit,this,n?n:this._anchor,t?t:this._include,this.cacheChildren);a=l.children(),l.includesContents()&&this.setIncludesContents(!0)}}else if(o==b.Kind.SEQ){var p=this._node;a=p.items.filter(function(e){return null!=e}).map(function(r){return new e(r,i._unit,i,n?n:i._anchor,t?t:i._include,i.cacheChildren)})}else if(o==b.Kind.INCLUDE_REF){if(this._unit){var c=this.includePath(),f=null;try{f=this._unit.resolve(c)}catch(e){}if(null==f)a=[];else if(f.isRAMLUnit())if(this.canInclude(f)){var h=this.unit(),d=f;d.addIncludedBy(h.absolutePath()),h.getIncludedByPaths().forEach(function(e){d.addIncludedBy(e)});var m=f.ast();m&&(this.cacheChildren&&(m=v(m)),a=f.ast().children(this,null),this.setIncludesContents(!0))}else this.addIncludeError&&this.addIncludeError(new V(B.RECURSIVE_DEFINITION_EMPTY.message))}a||(a=[])}else{if(o!=b.Kind.ANCHOR_REF)throw new V(F.applyTemplate(B.SHOULD_NEVER_HAPPEN_KIND,{kind:b.Kind[this._node.kind]}));var y=this._node;a=new e(y.value,this._unit,this,null,null,this.cacheChildren).children()}return this.cacheChildren&&(this._children=a),a},e.prototype.canInclude=function(e){for(var t=this.includedFrom();null!=t;){if(t.unit().absolutePath()==e.absolutePath())return!1;t=t.includedFrom()}return!this.unit().includedByContains(e.absolutePath())},e.prototype.directChildren=function(t,n,r){var i=this;if(void 0===t&&(t=null),void 0===n&&(n=null),void 0===r&&(r=!0),this._node){switch(this._node.kind){case b.Kind.SCALAR:return[];case b.Kind.MAP:var a=this._node;return 1!=a.mappings.length||r?a.mappings.map(function(r){return new e(r,i._unit,i,n?n:i._anchor,t?t:i._include)}):new e(a.mappings[0].value,this._unit,this,t,n).directChildren(null,null,!0);case b.Kind.MAPPING:var o=this._node;return null==o.value?[]:new e(o.value,this._unit,this,n?n:this._anchor,t?t:this._include).directChildren();case b.Kind.SEQ:var s=this._node;return s.items.filter(function(e){return null!=e}).map(function(r){return new e(r,i._unit,i,n?n:i._anchor,t?t:i._include)});case b.Kind.INCLUDE_REF:return[];case b.Kind.ANCHOR_REF:return[]}throw new V(F.applyTemplate(B.SHOULD_NEVER_HAPPEN_KIND,{kind:b.Kind[this._node.kind]}))}return[]},e.prototype.anchorId=function(){return this._node.anchorId},e.prototype.unit=function(){return this._unit},e.prototype.containingUnit=function(){return this.valueKind()==b.Kind.INCLUDE_REF?this.unit().resolve(this._node.value.value):this.kind()==b.Kind.INCLUDE_REF?this.unit().resolve(this._node.value):this._unit},e.prototype.includeBaseUnit=function(){return this._unit},e.prototype.setUnit=function(e){this._unit=e},e.prototype.includePath=function(){var e=this.getIncludeString();return e?e:null},e.prototype.includeReference=function(){var e=this.getIncludeString();return e?O.getIncludeReference(e):null},e.prototype.getIncludeString=function(){if(!this._node)return null;if(this._node.kind==b.Kind.INCLUDE_REF){var t=this._node.value;return t}if(this._node.kind==b.Kind.MAPPING){var n=this._node;return null==n.value?null:new e(n.value,this._unit,this,null,null).getIncludeString()}if(this._node.kind==b.Kind.ANCHOR_REF){var r=this._node.value;return new e(r,this._unit,this,null,null).getIncludeString()}return null},e.prototype.anchoredFrom=function(){return this._anchor},e.prototype.includedFrom=function(){return this._include},e.prototype.kind=function(){return this._actualNode().kind},e.prototype.valueKind=function(){if(this._node.kind!=b.Kind.MAPPING)return null;var e=this._node;return e.value?e.value.kind:null},e.prototype.anchorValueKind=function(){if(this.valueKind()==b.Kind.ANCHOR_REF){var e=this._node.value;return e&&e.value&&e.value.kind}return null},e.prototype.resolvedValueKind=function(){var e=this.valueKind();if(e==b.Kind.ANCHOR_REF){var t=this.anchorValueKind();if(t==b.Kind.INCLUDE_REF){var n=this._node.value,r=n.value.value;return this.unitKind(r)}return t}if(e==b.Kind.INCLUDE_REF){var r=this.includePath();return this.unitKind(r)}return e},e.prototype.unitKind=function(e){var t;try{t=this._unit.resolve(e)}catch(e){return null}if(null==t)return b.Kind.SCALAR;if(t.isRAMLUnit()){var n=t.ast();if(n)return n.kind()}return b.Kind.SCALAR},e.prototype.valueKindName=function(){var e=this.valueKind();return void 0!=e?b.Kind[e]:null},e.prototype.kindName=function(){return b.Kind[this.kind()]},e.prototype.indent=function(e,t){void 0===t&&(t="");for(var n="",r=0;r<e;r++)n+="  ";return n+t},e.prototype.replaceNewlines=function(e,t){void 0===t&&(t=null);for(var n="",r=0;r<e.length;r++){var i=e[r];"\r"==i&&(i=null==t?"\\r":t),"\n"==i&&(i=null==t?"\\n":t),n+=i}return n},e.prototype.shortText=function(e,t){void 0===t&&(t=50);var n=this.end()-this.start(),r=n,i=this.unit();!e&&i&&(e=i.contents());var a;if(e){var o=e;a=o?o.substring(this.start(),this.end()):"[no-text]"}else a="[no-unit]";return a="["+this.start()+".."+this.end()+"] "+n+" // "+a+" //",r<n&&(a+="..."),a=this.replaceNewlines(a)},e.prototype.nodeShortText=function(e,t,n){void 0===n&&(n=50);var r=e.endPosition-e.startPosition,i=r,a=this.unit();!t&&a&&(t=a.contents());var o;if(t){var s=t;o=s?s.substring(e.startPosition,e.endPosition):"[no-text]"}else o="[no-unit]";return o="["+e.startPosition+".."+e.endPosition+"] "+r+" // "+o+" //",i<r&&(o+="..."),o=this.replaceNewlines(o)},e.prototype.show=function(e,t,n){void 0===e&&(e=null),void 0===t&&(t=0),void 0===n&&(n=null),e&&0==t&&console.log(e);var r=this.children(),i=this.kindName(),a=this._actualNode().value;this.kind()==b.Kind.MAPPING&&(i+="["+this._actualNode().key.value+"]"),i+=a?"/"+b.Kind[a.kind]:"",0==r.length?(console.log(this.indent(t)+i+" // "+this.shortText(n)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(t+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,n))):(console.log(this.indent(t)+i+" { // "+this.shortText(n)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(t+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,n)),r.forEach(function(e){var r=e;r.show(null,t+1,n)}),console.log(this.indent(t)+"}"))},e.prototype.showParents=function(e,t){void 0===t&&(t=0),e&&0==t&&console.log(e);var n=0;if(this.parent()){var r=this.parent();n=r.showParents(null,t+1)}var i=this.kindName(),a=this._actualNode().value;return i+=a?"/"+b.Kind[a.kind]:"/null",console.log(this.indent(n)+i+" // "+this.shortText(null)),n+1},e.prototype.inlined=function(e){return e==b.Kind.SCALAR||e==b.Kind.INCLUDE_REF},e.prototype.markupNode=function(e,t,n,r){void 0===r&&(r=!1);var i=e.text.length;switch(t.kind){case b.Kind.MAP:r&&e.append("{");for(var o=t.mappings,s=0;s<o.length;s++)r&&s>0&&e.append(", "),this.markupNode(e,o[s],n,r);r&&e.append("}");break;case b.Kind.SEQ:for(var u=t.items,s=0;s<u.length;s++)e.append(this.indent(n,"- ")),this.markupNode(e,u[s],n+1,r);break;case b.Kind.MAPPING:var l=t,p=l.value;if(r){if(!p){e.append("\n");break}if(e.append(l.key.value),e.append(": "),p.kind==b.Kind.SCALAR){var c=p;e.append(c.value)}else{if(p.kind!=b.Kind.MAP)throw new V(F.applyTemplate(B.NOT_IMPLEMENTED_KIND,{kind:b.Kind[p.kind]}));this.markupNode(e,l.value,n+1,r)}break}if(e.addWithIndent(n,l.key.value+":"),!p){e.append("\n");break}if(p.kind==b.Kind.SCALAR)var c=p;l.value?(e.append(this.inlined(l.value.kind)?" ":"\n"),this.markupNode(e,l.value,n+1,r)):e.append("\n");break;case b.Kind.SCALAR:var c=t;if(M.isMultiLine(c.value)){e.append("|\n");for(var f=a(c.value),s=0;s<f.length;s++)e.append(this.indent(n,f[s]));e.append("\n")}else e.append(c.value+"\n");break;case b.Kind.INCLUDE_REF:var h=t;e.append("!include "+h.value+"\n");break;default:throw new V(F.applyTemplate(B.UNKNOWN_NODE_KIND,{kind:b.Kind[t.kind]}))}for(;i<e.text.length&&" "==e.text[i];)i++;t.startPosition=i,t.endPosition=e.text.length},e.prototype.markup=function(e){void 0===e&&(e=!1);var t=new K("");return this.markupNode(t,this._actualNode(),0,e),t.text},e.prototype.root=function(){for(var e=this;e.parent();){var t=e.parent();e=t}return e},e.prototype.parentOfKind=function(e){for(var t=this.parent();t;){if(t.kind()==e)return t;t=t.parent()}return null},e.prototype.find=function(e){var t=null;return this.directChildren().forEach(function(n){n.key()&&n.key()==e&&(t||(t=n))}),t},e.prototype.shiftNodes=function(e,t,n){if(this.directChildren().forEach(function(r){if(n&&n.start()==r.start()&&n.end()==r.end());else{r.shiftNodes(e,t,n)}}),n&&n.start()==this.start()&&n.end()==this.end());else{var r=this._actualNode();r&&z(e,r,t)}return null},e.prototype.isMap=function(){return this.kind()==b.Kind.MAP},e.prototype.isMapping=function(){return this.kind()==b.Kind.MAPPING},e.prototype.isSeq=function(){return this.kind()==b.Kind.SEQ},e.prototype.isScalar=function(){return this.kind()==b.Kind.SCALAR},e.prototype.asMap=function(){if(!this.isMap())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"map",received:this.kindName()}));return this._actualNode()},e.prototype.asMapping=function(){if(!this.isMapping())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping",received:this.kindName()}));return this._actualNode()},e.prototype.asSeq=function(){if(!this.isSeq())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"seq",received:this.kindName()}));return this._actualNode()},e.prototype.asScalar=function(){if(!this.isScalar())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"scalar",received:this.kindName()}));return this._actualNode()},e.prototype.isValueSeq=function(){return this.valueKind()==b.Kind.SEQ},e.prototype.isValueMap=function(){return this.valueKind()==b.Kind.MAP},e.prototype.isValueInclude=function(){return this.valueKind()==b.Kind.INCLUDE_REF},e.prototype.isValueScalar=function(){return this.valueKind()==b.Kind.SCALAR},e.prototype.valueAsSeq=function(){if(!this.isMapping())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping",received:this.kindName()}));if(this.valueKind()!=b.Kind.SEQ)throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping/seq",received:"mapping/"+this.kindName()}));return this.asMapping().value},e.prototype.valueAsMap=function(){if(!this.isMapping())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping",received:this.kindName()}));if(this.valueKind()!=b.Kind.MAP)throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping/map",received:"mapping/"+this.kindName()}));return this.asMapping().value},e.prototype.valueAsScalar=function(){if(!this.isMapping())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping",received:this.kindName()}));if(this.valueKind()!=b.Kind.SCALAR)throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping/scalar",received:"mapping/"+this.kindName()}));return this.asMapping().value},e.prototype.valueAsInclude=function(){if(!this.isMapping())throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping",received:this.kindName()}));if(this.valueKind()!=b.Kind.INCLUDE_REF)throw new V(F.applyTemplate(B.EXPECTED_INSTEAD_OF,{expected:"mapping/include",received:"mapping/"+this.kindName()}));return this.asMapping().value},e.prototype.text=function(e){if(void 0===e&&(e=null),!e){if(!this.unit())return"[no-text]";e=this.unit().contents()}return e.substring(this.start(),this.end())},e.prototype.copy=function(){var t=i(this._actualNode());return new e(t,this._unit,this._parent,this._anchor,this._include,this._includesContents)},e.prototype.nodeDefinition=function(){return A(this)},e.CLASS_IDENTIFIER="jsyaml2lowLevel.ASTNode",e}();t.ASTNode=Q;var Z;!function(e){e[e.NONE=0]="NONE",e[e.START=1]="START",e[e.END=2]="END",e[e.POINT=3]="POINT"}(Z=t.InsertionPointType||(t.InsertionPointType={}));var ee=function(){function e(e,t){void 0===t&&(t=null),this.type=e,this.point=t}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&R.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.after=function(t){return new e(Z.POINT,t)},e.atStart=function(){return new e(Z.START)},e.atEnd=function(){return new e(Z.END)},e.node=function(){return new e(Z.NONE)},e.prototype.show=function(e){e?(console.log(e),console.log(F.applyTemplate(B.INSERTION_POINT_TYPE,{type:Z[this.type]}))):console.log(F.applyTemplate(B.INSERTION_POINT_TYPE,{type:Z[this.type]})),this.type==Z.POINT&&this.point&&this.point.show()},e.CLASS_IDENTIFIER="jsyaml2lowLevel.InsertionPoint",e}();t.InsertionPoint=ee,t.createNode=p,t.createMap=c,t.createScalar=f,t.createSeq=h,t.createSeqNode=d,t.createMapNode=m,t.createMapping=y,t.toChildCachingNode=v,t.toIncludingNode=g,t.getDefinitionForLowLevelNode=A,t.fetchIncludesAndMasterAsync=_},function(e,t,n){"use strict";function r(e,t){return new S(A.CHANGE_VALUE,e,t,-1)}function i(e,t){return new S(A.CHANGE_VALUE,e,t.lowLevel(),-1)}function a(e,t){return new S(A.CHANGE_KEY,e,t,-1)}function o(e,t){return new S(A.REMOVE_CHILD,e,t,-1)}function s(e,t,n,r){void 0===n&&(n=null),void 0===r&&(r=!1);var i=new S(A.ADD_CHILD,e,t,-1);return i.insertionPoint=n,i.toSeq=r,i}function u(e,t){return new S(A.INIT_RAML_FILE,e,t,-1)}function l(e,t,n){if(h.isAbsolute(e)){var r=h.extname(t);".xsd"!=r&&(e=e.substr(1),t=p(n,h.basename(t)))}return c(e)||h.isAbsolute(e)?e:c(t)||h.isAbsolute(t)?p(h.dirname(t),e):p(h.dirname(p(n,t)),e)}function p(e,t){if(c(t))return t;var n;if(c(e)){var r=m.stringEndsWith(e,"/")?e:e+"/";n=d.resolve(r,t).replace(/\\/g,"/")}else n=h.resolve(e,t).replace(/\\/g,"/");return n}function c(e){return null!=e&&(m.stringStartsWith(e,"http://")||m.stringStartsWith(e,"https://"))}function f(e){return e.start&&e.end&&e.unit&&e.key&&e.value&&e.children&&e.includePath}Object.defineProperty(t,"__esModule",{value:!0});var h=n(6),d=n(8),m=n(15),y=n(19),v=n(207),g=function(){function e(){}return e}();t.ASTDelta=g;var A;!function(e){e[e.ADD_CHILD=0]="ADD_CHILD",e[e.REMOVE_CHILD=1]="REMOVE_CHILD",e[e.MOVE_CHILD=2]="MOVE_CHILD",e[e.CHANGE_KEY=3]="CHANGE_KEY",e[e.CHANGE_VALUE=4]="CHANGE_VALUE",e[e.INIT_RAML_FILE=5]="INIT_RAML_FILE"}(A=t.CommandKind||(t.CommandKind={}));var E=function(){function e(e,t,n,r,i){void 0===i&&(i=null),this.offset=e,this.replacementLength=t,this.text=n,this.unit=r,this.target=i}return e}();t.TextChangeCommand=E;var _=function(){function e(){this.commands=[]}return e}();t.CompositeCommand=_;var T;!function(e){e[e.NONE=0]="NONE",e[e.START=1]="START",e[e.END=2]="END",e[e.POINT=3]="POINT"}(T=t.InsertionPointType||(t.InsertionPointType={}));var S=function(){function e(e,t,n,r){this.toSeq=!1,this.kind=e,this.target=t,this.value=n,this.position=r}return e}();t.ASTChangeCommand=S,t.setAttr=r,t.setAttrStructured=i,t.setKey=a,t.removeNode=o,t.insertNode=s,t.initRamlFile=u;var N=function(){function e(e,t){this.content=e,this.absPath=t}return e.prototype.position=function(e){var t=e;this.initMapping();for(var n=0;n<this.mapping.length;n++){var r=this.mapping[n];if(t<r)return{line:n,column:t,position:e};t-=r}if(0==t)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1],position:this.content.length};if(1==t)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1]-1,position:e-1};throw new Error(y.applyTemplate(v.POSITION_EXCEEDS_TEXT_LENGTH,{pos:e,length:this.content.length,absPath:this.absPath}))},e.prototype.initMapping=function(){if(null==this.mapping){if(null==this.content)throw new Error(y.applyTemplate(v.LINE_MAPPER_HAS_NULL_CONTENT,{path:null!=this.absPath?". Path: "+this.absPath:" and null path."}));this.mapping=[];for(var e=0,t=this.content.length,n=0;n<t;n++)"\r"==this.content.charAt(n)?n<t-1&&"\n"==this.content.charAt(n+1)?(this.mapping.push(n-e+2),e=n+2,n++):(this.mapping.push(n-e+1),e=n+1):"\n"==this.content.charAt(n)&&(this.mapping.push(n-e+1),e=n+1);this.mapping.push(t-e)}},e.prototype.toPosition=function(e,t){var n=t;this.initMapping();for(var r=e;r<this.mapping.length;r++){var i=this.mapping[r];if(n<i){for(var a=n,o=0;o<r;o++)a+=this.mapping[o];return{line:r,column:n,position:a}}n-=i}return{line:r,column:n,position:this.content.length}},e}();t.LineMapperImpl=N,t.buildPath=l,t.toAbsolutePath=p,t.isWebPath=c,t.isLowLevelNode=f},function(e,t,n){(function(e){function n(e,t){for(var n=0,r=e.length-1;r>=0;r--){var i=e[r];"."===i?e.splice(r,1):".."===i?(e.splice(r,1),n++):n&&(e.splice(r,1),n--)}if(t)for(;n--;n)e.unshift("..");return e}function r(e,t){if(e.filter)return e.filter(t);for(var n=[],r=0;r<e.length;r++)t(e[r],r,e)&&n.push(e[r]);return n}var i=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,a=function(e){return i.exec(e).slice(1)};t.resolve=function(){for(var t="",i=!1,a=arguments.length-1;a>=-1&&!i;a--){var o=a>=0?arguments[a]:e.cwd();if("string"!=typeof o)throw new TypeError("Arguments to path.resolve must be strings");o&&(t=o+"/"+t,i="/"===o.charAt(0))}return t=n(r(t.split("/"),function(e){return!!e}),!i).join("/"),(i?"/":"")+t||".";
},t.normalize=function(e){var i=t.isAbsolute(e),a="/"===o(e,-1);return e=n(r(e.split("/"),function(e){return!!e}),!i).join("/"),e||i||(e="."),e&&a&&(e+="/"),(i?"/":"")+e},t.isAbsolute=function(e){return"/"===e.charAt(0)},t.join=function(){var e=Array.prototype.slice.call(arguments,0);return t.normalize(r(e,function(e,t){if("string"!=typeof e)throw new TypeError("Arguments to path.join must be strings");return e}).join("/"))},t.relative=function(e,n){function r(e){for(var t=0;t<e.length&&""===e[t];t++);for(var n=e.length-1;n>=0&&""===e[n];n--);return t>n?[]:e.slice(t,n-t+1)}e=t.resolve(e).substr(1),n=t.resolve(n).substr(1);for(var i=r(e.split("/")),a=r(n.split("/")),o=Math.min(i.length,a.length),s=o,u=0;u<o;u++)if(i[u]!==a[u]){s=u;break}for(var l=[],u=s;u<i.length;u++)l.push("..");return l=l.concat(a.slice(s)),l.join("/")},t.sep="/",t.delimiter=":",t.dirname=function(e){var t=a(e),n=t[0],r=t[1];return n||r?(r&&(r=r.substr(0,r.length-1)),n+r):"."},t.basename=function(e,t){var n=a(e)[2];return t&&n.substr(-1*t.length)===t&&(n=n.substr(0,n.length-t.length)),n},t.extname=function(e){return a(e)[3]};var o="b"==="ab".substr(-1)?function(e,t,n){return e.substr(t,n)}:function(e,t,n){return t<0&&(t=e.length+t),e.substr(t,n)}}).call(t,n(7))},function(e,t){function n(){throw new Error("setTimeout has not been defined")}function r(){throw new Error("clearTimeout has not been defined")}function i(e){if(p===setTimeout)return setTimeout(e,0);if((p===n||!p)&&setTimeout)return p=setTimeout,setTimeout(e,0);try{return p(e,0)}catch(t){try{return p.call(null,e,0)}catch(t){return p.call(this,e,0)}}}function a(e){if(c===clearTimeout)return clearTimeout(e);if((c===r||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(e);try{return c(e)}catch(t){try{return c.call(null,e)}catch(t){return c.call(this,e)}}}function o(){m&&h&&(m=!1,h.length?d=h.concat(d):y=-1,d.length&&s())}function s(){if(!m){var e=i(o);m=!0;for(var t=d.length;t;){for(h=d,d=[];++y<t;)h&&h[y].run();y=-1,t=d.length}h=null,m=!1,a(e)}}function u(e,t){this.fun=e,this.array=t}function l(){}var p,c,f=e.exports={};!function(){try{p="function"==typeof setTimeout?setTimeout:n}catch(e){p=n}try{c="function"==typeof clearTimeout?clearTimeout:r}catch(e){c=r}}();var h,d=[],m=!1,y=-1;f.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];d.push(new u(e,t)),1!==d.length||m||i(s)},u.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=l,f.addListener=l,f.once=l,f.off=l,f.removeListener=l,f.removeAllListeners=l,f.emit=l,f.prependListener=l,f.prependOnceListener=l,f.listeners=function(e){return[]},f.binding=function(e){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(e){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}},function(e,t,n){"use strict";function r(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}function i(e,t,n){if(e&&l.isObject(e)&&e instanceof r)return e;var i=new r;return i.parse(e,t,n),i}function a(e){return l.isString(e)&&(e=i(e)),e instanceof r?e.format():r.prototype.format.call(e)}function o(e,t){return i(e,!1,!0).resolve(t)}function s(e,t){return e?i(e,!1,!0).resolveObject(t):t}var u=n(9),l=n(11);t.parse=i,t.resolve=o,t.resolveObject=s,t.format=a,t.Url=r;var p=/^([a-z0-9.+-]+:)/i,c=/:[0-9]*$/,f=/^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,h=["<",">",'"',"`"," ","\r","\n","\t"],d=["{","}","|","\\","^","`"].concat(h),m=["'"].concat(d),y=["%","/","?",";","#"].concat(m),v=["/","?","#"],g=255,A=/^[+a-z0-9A-Z_-]{0,63}$/,E=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,_={javascript:!0,"javascript:":!0},T={javascript:!0,"javascript:":!0},S={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},N=n(12);r.prototype.parse=function(e,t,n){if(!l.isString(e))throw new TypeError("Parameter 'url' must be a string, not "+typeof e);var r=e.indexOf("?"),i=r!==-1&&r<e.indexOf("#")?"?":"#",a=e.split(i),o=/\\/g;a[0]=a[0].replace(o,"/"),e=a.join(i);var s=e;if(s=s.trim(),!n&&1===e.split("#").length){var c=f.exec(s);if(c)return this.path=s,this.href=s,this.pathname=c[1],c[2]?(this.search=c[2],t?this.query=N.parse(this.search.substr(1)):this.query=this.search.substr(1)):t&&(this.search="",this.query={}),this}var h=p.exec(s);if(h){h=h[0];var d=h.toLowerCase();this.protocol=d,s=s.substr(h.length)}if(n||h||s.match(/^\/\/[^@\/]+@[^@\/]+/)){var I="//"===s.substr(0,2);!I||h&&T[h]||(s=s.substr(2),this.slashes=!0)}if(!T[h]&&(I||h&&!S[h])){for(var b=-1,R=0;R<v.length;R++){var M=s.indexOf(v[R]);M!==-1&&(b===-1||M<b)&&(b=M)}var C,w;w=b===-1?s.lastIndexOf("@"):s.lastIndexOf("@",b),w!==-1&&(C=s.slice(0,w),s=s.slice(w+1),this.auth=decodeURIComponent(C)),b=-1;for(var R=0;R<y.length;R++){var M=s.indexOf(y[R]);M!==-1&&(b===-1||M<b)&&(b=M)}b===-1&&(b=s.length),this.host=s.slice(0,b),s=s.slice(b),this.parseHost(),this.hostname=this.hostname||"";var P="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!P)for(var L=this.hostname.split(/\./),R=0,O=L.length;R<O;R++){var D=L[R];if(D&&!D.match(A)){for(var U="",x=0,k=D.length;x<k;x++)U+=D.charCodeAt(x)>127?"x":D[x];if(!U.match(A)){var F=L.slice(0,R),B=L.slice(R+1),V=D.match(E);V&&(F.push(V[1]),B.unshift(V[2])),B.length&&(s="/"+B.join(".")+s),this.hostname=F.join(".");break}}}this.hostname.length>g?this.hostname="":this.hostname=this.hostname.toLowerCase(),P||(this.hostname=u.toASCII(this.hostname));var K=this.port?":"+this.port:"",j=this.hostname||"";this.host=j+K,this.href+=this.host,P&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==s[0]&&(s="/"+s))}if(!_[d])for(var R=0,O=m.length;R<O;R++){var W=m[R];if(s.indexOf(W)!==-1){var H=encodeURIComponent(W);H===W&&(H=escape(W)),s=s.split(W).join(H)}}var Y=s.indexOf("#");Y!==-1&&(this.hash=s.substr(Y),s=s.slice(0,Y));var q=s.indexOf("?");if(q!==-1?(this.search=s.substr(q),this.query=s.substr(q+1),t&&(this.query=N.parse(this.query)),s=s.slice(0,q)):t&&(this.search="",this.query={}),s&&(this.pathname=s),S[d]&&this.hostname&&!this.pathname&&(this.pathname="/"),this.pathname||this.search){var K=this.pathname||"",G=this.search||"";this.path=K+G}return this.href=this.format(),this},r.prototype.format=function(){var e=this.auth||"";e&&(e=encodeURIComponent(e),e=e.replace(/%3A/i,":"),e+="@");var t=this.protocol||"",n=this.pathname||"",r=this.hash||"",i=!1,a="";this.host?i=e+this.host:this.hostname&&(i=e+(this.hostname.indexOf(":")===-1?this.hostname:"["+this.hostname+"]"),this.port&&(i+=":"+this.port)),this.query&&l.isObject(this.query)&&Object.keys(this.query).length&&(a=N.stringify(this.query));var o=this.search||a&&"?"+a||"";return t&&":"!==t.substr(-1)&&(t+=":"),this.slashes||(!t||S[t])&&i!==!1?(i="//"+(i||""),n&&"/"!==n.charAt(0)&&(n="/"+n)):i||(i=""),r&&"#"!==r.charAt(0)&&(r="#"+r),o&&"?"!==o.charAt(0)&&(o="?"+o),n=n.replace(/[?#]/g,function(e){return encodeURIComponent(e)}),o=o.replace("#","%23"),t+i+n+o+r},r.prototype.resolve=function(e){return this.resolveObject(i(e,!1,!0)).format()},r.prototype.resolveObject=function(e){if(l.isString(e)){var t=new r;t.parse(e,!1,!0),e=t}for(var n=new r,i=Object.keys(this),a=0;a<i.length;a++){var o=i[a];n[o]=this[o]}if(n.hash=e.hash,""===e.href)return n.href=n.format(),n;if(e.slashes&&!e.protocol){for(var s=Object.keys(e),u=0;u<s.length;u++){var p=s[u];"protocol"!==p&&(n[p]=e[p])}return S[n.protocol]&&n.hostname&&!n.pathname&&(n.path=n.pathname="/"),n.href=n.format(),n}if(e.protocol&&e.protocol!==n.protocol){if(!S[e.protocol]){for(var c=Object.keys(e),f=0;f<c.length;f++){var h=c[f];n[h]=e[h]}return n.href=n.format(),n}if(n.protocol=e.protocol,e.host||T[e.protocol])n.pathname=e.pathname;else{for(var d=(e.pathname||"").split("/");d.length&&!(e.host=d.shift()););e.host||(e.host=""),e.hostname||(e.hostname=""),""!==d[0]&&d.unshift(""),d.length<2&&d.unshift(""),n.pathname=d.join("/")}if(n.search=e.search,n.query=e.query,n.host=e.host||"",n.auth=e.auth,n.hostname=e.hostname||e.host,n.port=e.port,n.pathname||n.search){var m=n.pathname||"",y=n.search||"";n.path=m+y}return n.slashes=n.slashes||e.slashes,n.href=n.format(),n}var v=n.pathname&&"/"===n.pathname.charAt(0),g=e.host||e.pathname&&"/"===e.pathname.charAt(0),A=g||v||n.host&&e.pathname,E=A,_=n.pathname&&n.pathname.split("/")||[],d=e.pathname&&e.pathname.split("/")||[],N=n.protocol&&!S[n.protocol];if(N&&(n.hostname="",n.port=null,n.host&&(""===_[0]?_[0]=n.host:_.unshift(n.host)),n.host="",e.protocol&&(e.hostname=null,e.port=null,e.host&&(""===d[0]?d[0]=e.host:d.unshift(e.host)),e.host=null),A=A&&(""===d[0]||""===_[0])),g)n.host=e.host||""===e.host?e.host:n.host,n.hostname=e.hostname||""===e.hostname?e.hostname:n.hostname,n.search=e.search,n.query=e.query,_=d;else if(d.length)_||(_=[]),_.pop(),_=_.concat(d),n.search=e.search,n.query=e.query;else if(!l.isNullOrUndefined(e.search)){if(N){n.hostname=n.host=_.shift();var I=!!(n.host&&n.host.indexOf("@")>0)&&n.host.split("@");I&&(n.auth=I.shift(),n.host=n.hostname=I.shift())}return n.search=e.search,n.query=e.query,l.isNull(n.pathname)&&l.isNull(n.search)||(n.path=(n.pathname?n.pathname:"")+(n.search?n.search:"")),n.href=n.format(),n}if(!_.length)return n.pathname=null,n.search?n.path="/"+n.search:n.path=null,n.href=n.format(),n;for(var b=_.slice(-1)[0],R=(n.host||e.host||_.length>1)&&("."===b||".."===b)||""===b,M=0,C=_.length;C>=0;C--)b=_[C],"."===b?_.splice(C,1):".."===b?(_.splice(C,1),M++):M&&(_.splice(C,1),M--);if(!A&&!E)for(;M--;M)_.unshift("..");!A||""===_[0]||_[0]&&"/"===_[0].charAt(0)||_.unshift(""),R&&"/"!==_.join("/").substr(-1)&&_.push("");var w=""===_[0]||_[0]&&"/"===_[0].charAt(0);if(N){n.hostname=n.host=w?"":_.length?_.shift():"";var I=!!(n.host&&n.host.indexOf("@")>0)&&n.host.split("@");I&&(n.auth=I.shift(),n.host=n.hostname=I.shift())}return A=A||n.host&&_.length,A&&!w&&_.unshift(""),_.length?n.pathname=_.join("/"):(n.pathname=null,n.path=null),l.isNull(n.pathname)&&l.isNull(n.search)||(n.path=(n.pathname?n.pathname:"")+(n.search?n.search:"")),n.auth=e.auth||n.auth,n.slashes=n.slashes||e.slashes,n.href=n.format(),n},r.prototype.parseHost=function(){var e=this.host,t=c.exec(e);t&&(t=t[0],":"!==t&&(this.port=t.substr(1)),e=e.substr(0,e.length-t.length)),e&&(this.hostname=e)}},function(e,t,n){var r;(function(e,i){!function(a){function o(e){throw RangeError(L[e])}function s(e,t){for(var n=e.length,r=[];n--;)r[n]=t(e[n]);return r}function u(e,t){var n=e.split("@"),r="";n.length>1&&(r=n[0]+"@",e=n[1]),e=e.replace(P,".");var i=e.split("."),a=s(i,t).join(".");return r+a}function l(e){for(var t,n,r=[],i=0,a=e.length;i<a;)t=e.charCodeAt(i++),t>=55296&&t<=56319&&i<a?(n=e.charCodeAt(i++),56320==(64512&n)?r.push(((1023&t)<<10)+(1023&n)+65536):(r.push(t),i--)):r.push(t);return r}function p(e){return s(e,function(e){var t="";return e>65535&&(e-=65536,t+=U(e>>>10&1023|55296),e=56320|1023&e),t+=U(e)}).join("")}function c(e){return e-48<10?e-22:e-65<26?e-65:e-97<26?e-97:_}function f(e,t){return e+22+75*(e<26)-((0!=t)<<5)}function h(e,t,n){var r=0;for(e=n?D(e/I):e>>1,e+=D(e/t);e>O*S>>1;r+=_)e=D(e/O);return D(r+(O+1)*e/(e+N))}function d(e){var t,n,r,i,a,s,u,l,f,d,m=[],y=e.length,v=0,g=R,A=b;for(n=e.lastIndexOf(M),n<0&&(n=0),r=0;r<n;++r)e.charCodeAt(r)>=128&&o("not-basic"),m.push(e.charCodeAt(r));for(i=n>0?n+1:0;i<y;){for(a=v,s=1,u=_;i>=y&&o("invalid-input"),l=c(e.charCodeAt(i++)),(l>=_||l>D((E-v)/s))&&o("overflow"),v+=l*s,f=u<=A?T:u>=A+S?S:u-A,!(l<f);u+=_)d=_-f,s>D(E/d)&&o("overflow"),s*=d;t=m.length+1,A=h(v-a,t,0==a),D(v/t)>E-g&&o("overflow"),g+=D(v/t),v%=t,m.splice(v++,0,g)}return p(m)}function m(e){var t,n,r,i,a,s,u,p,c,d,m,y,v,g,A,N=[];for(e=l(e),y=e.length,t=R,n=0,a=b,s=0;s<y;++s)m=e[s],m<128&&N.push(U(m));for(r=i=N.length,i&&N.push(M);r<y;){for(u=E,s=0;s<y;++s)m=e[s],m>=t&&m<u&&(u=m);for(v=r+1,u-t>D((E-n)/v)&&o("overflow"),n+=(u-t)*v,t=u,s=0;s<y;++s)if(m=e[s],m<t&&++n>E&&o("overflow"),m==t){for(p=n,c=_;d=c<=a?T:c>=a+S?S:c-a,!(p<d);c+=_)A=p-d,g=_-d,N.push(U(f(d+A%g,0))),p=D(A/g);N.push(U(f(p,0))),a=h(n,v,r==i),n=0,++r}++n,++t}return N.join("")}function y(e){return u(e,function(e){return C.test(e)?d(e.slice(4).toLowerCase()):e})}function v(e){return u(e,function(e){return w.test(e)?"xn--"+m(e):e})}var g=("object"==typeof t&&t&&!t.nodeType&&t,"object"==typeof e&&e&&!e.nodeType&&e,"object"==typeof i&&i);g.global!==g&&g.window!==g&&g.self!==g||(a=g);var A,E=2147483647,_=36,T=1,S=26,N=38,I=700,b=72,R=128,M="-",C=/^xn--/,w=/[^\x20-\x7E]/,P=/[\x2E\u3002\uFF0E\uFF61]/g,L={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},O=_-T,D=Math.floor,U=String.fromCharCode;A={version:"1.3.2",ucs2:{decode:l,encode:p},decode:d,encode:m,toASCII:v,toUnicode:y},r=function(){return A}.call(t,n,t,e),!(void 0!==r&&(e.exports=r))}(this)}).call(t,n(10)(e),function(){return this}())},function(e,t){e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children=[],e.webpackPolyfill=1),e}},function(e,t){"use strict";e.exports={isString:function(e){return"string"==typeof e},isObject:function(e){return"object"==typeof e&&null!==e},isNull:function(e){return null===e},isNullOrUndefined:function(e){return null==e}}},function(e,t,n){"use strict";t.decode=t.parse=n(13),t.encode=t.stringify=n(14)},function(e,t){"use strict";function n(e,t){return Object.prototype.hasOwnProperty.call(e,t)}e.exports=function(e,t,r,i){t=t||"&",r=r||"=";var a={};if("string"!=typeof e||0===e.length)return a;var o=/\+/g;e=e.split(t);var s=1e3;i&&"number"==typeof i.maxKeys&&(s=i.maxKeys);var u=e.length;s>0&&u>s&&(u=s);for(var l=0;l<u;++l){var p,c,f,h,d=e[l].replace(o,"%20"),m=d.indexOf(r);m>=0?(p=d.substr(0,m),c=d.substr(m+1)):(p=d,c=""),f=decodeURIComponent(p),h=decodeURIComponent(c),n(a,f)?Array.isArray(a[f])?a[f].push(h):a[f]=[a[f],h]:a[f]=h}return a}},function(e,t){"use strict";var n=function(e){switch(typeof e){case"string":return e;case"boolean":return e?"true":"false";case"number":return isFinite(e)?e:"";default:return""}};e.exports=function(e,t,r,i){return t=t||"&",r=r||"=",null===e&&(e=void 0),"object"==typeof e?Object.keys(e).map(function(i){var a=encodeURIComponent(n(i))+r;return Array.isArray(e[i])?e[i].map(function(e){return a+encodeURIComponent(n(e))}).join(t):a+encodeURIComponent(n(e[i]))}).join(t):i?encodeURIComponent(n(i))+r+encodeURIComponent(n(e)):""}},function(e,t,n){"use strict";function r(e){var t={};return e.forEach(function(e){return Object.keys(e).forEach(function(n){return t[n]=e[n]})}),t}function i(e,t){return new I(N.find(e||[],t))}function a(e){return Object.keys(e).map(function(t){return[t,e[t]]})}function o(e){var t={};return e.forEach(function(e){return t[e[0]]=e[1]}),t}function s(e,t){return t(e),e}function u(e,t){"object"==typeof e&&Object.keys(e).forEach(function(n){return t(n,e[n])})}function l(e,n,r){void 0===r&&(r=!1);var i={};return e.forEach(function(e){var a=t.shallowCopy(e);r&&delete a[n],i[e[n]]=a}),i}function p(e,t){var n=e.length-t.length;return n>=0&&e.lastIndexOf(t)===n}function c(e,t,n){return void 0===n&&(n=0),e.length-t.length>=n&&e.substring(n,n+t.length)===t}function f(e){return"_"==e[e.length-1]}function h(e,t,n){var r,i=!1;e[t]=function(){return i||(i=!0,r=n.apply(e)),r}}function d(e,n){void 0===n&&(n=f);for(var r in e)n(r)&&t.ifInstanceOf(e[r],Function,function(t){return 0===t.length?h(e,r,t):null})}function m(e,t){void 0!==e&&t(e)}function y(e){return"string"==typeof e&&""!=e&&p(e,".raml")}function v(e){for(var t,n=[],r=new RegExp("require\\('([^']+)'\\)","gi");t=r.exec(e);)n.push(t[1]);for(var i=new RegExp('require\\("([^"]+)"\\)',"gi");t=i.exec(e);)n.push(t[1]);return n=N.unique(n).filter(function(e){return""!=e}),n.sort(),n}function g(e){return"undefined"!=typeof e&&null!=e}function A(e){return 0==e.length?e:e.charAt(0).toUpperCase()+e.substr(1)}function E(e,t,n){void 0===n&&(n=!1);var r=Object.keys(t);if(n){var i={};r.forEach(function(e){return i[e]=!0}),Object.keys(e).forEach(function(e){return i[e]=!0}),r=Object.keys(i)}r.forEach(function(n){var r=e[n];r instanceof Object?(t[n]||(t[n]={}),E(r,t[n],!0)):void 0!=r&&(t[n]=e[n])})}function _(e,t){return Object.keys(t).forEach(function(n){return e=T(e,n,t[n])}),e}function T(e,t,n){for(var r="",i=0,a=e.indexOf(t);a<e.length&&a>=0;a=e.indexOf(t,i))r+=e.substring(i,a),r+=n,i=a+t.length;return r+=e.substring(i,e.length)}function S(e){if(null==e||"object"!=typeof e)return e;var t;if(Array.isArray(e)){t=[];for(var n=0,r=e;n<r.length;n++){var i=r[n];t.push(S(i))}}else{t={};for(var a=0,o=Object.keys(e);a<o.length;a++){var s=o[a];t[s]=S(e[s])}}return t}Object.defineProperty(t,"__esModule",{value:!0});var N=n(16),I=n(17);t.defined=function(e){return null!==e&&void 0!==e},t.flattenArrayOfObjects=r,t.find=i,t.isInstance=function(e,t){return e instanceof t?[e]:[]},t.ifInstanceOf=function(e,t,n){return e instanceof t?n(e):null},t.toTuples=a,t.fromTuples=o,t.collectInstancesOf=function(e,n){return s([],function(r){return e.forEach(function(e){return t.ifInstanceOf(e,n,function(e){return r.push(e)})})})},t.collectInstancesOfInMap=function(e,t){return Object.keys(e).map(function(t){return[t,e[t]]}).filter(function(e){return e[1]instanceof t}).map(function(e){return e})},t.asArray=function(e){return t.defined(e)?e instanceof Array?e:[e]:[]},t.shallowCopy=function(e){return s({},function(t){return Object.keys(e).forEach(function(n){return t[n]=e[n]})})},t.flatMap=function(e,n){return t.flatten(e.map(n))},t.flatten=function(e){return Array.prototype.concat.apply([],e)},t.takeWhile=function(e,t){return s([],function(n){for(var r=0;r<e.length&&t(e[r]);r++)n.push(e[r])})},t.tap=s,t.kv=u,t.indexed=l,t.stringEndsWith=p,t.stringStartsWith=c,t.lazypropkeyfilter=f,t.lazyprops=d,t.iff=m,t.isRAMLUrl=y,t.getAllRequiredExternalModulesFromCode=v,t.serial=function(){var e=0;return function(){return e++}}(),t.isEssential=g,t.firstToUpper=A,t.updateObject=E,t.replaceMap=_,t.replace=T,t.deepCopy=S},function(e,t,n){var r,i;(function(e,n){!function(){var a="object"==typeof self&&self.self===self&&self||"object"==typeof e&&e.global===e&&e||this||{},o=a._,s=Array.prototype,u=Object.prototype,l="undefined"!=typeof Symbol?Symbol.prototype:null,p=s.push,c=s.slice,f=u.toString,h=u.hasOwnProperty,d=Array.isArray,m=Object.keys,y=Object.create,v=function(){},g=function(e){return e instanceof g?e:this instanceof g?void(this._wrapped=e):new g(e)};"undefined"==typeof t||t.nodeType?a._=g:("undefined"!=typeof n&&!n.nodeType&&n.exports&&(t=n.exports=g),t._=g),g.VERSION="1.9.1";var A,E=function(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 3:return function(n,r,i){return e.call(t,n,r,i)};case 4:return function(n,r,i,a){return e.call(t,n,r,i,a)}}return function(){return e.apply(t,arguments)}},_=function(e,t,n){return g.iteratee!==A?g.iteratee(e,t):null==e?g.identity:g.isFunction(e)?E(e,t,n):g.isObject(e)&&!g.isArray(e)?g.matcher(e):g.property(e)};g.iteratee=A=function(e,t){return _(e,t,1/0)};var T=function(e,t){return t=null==t?e.length-1:+t,function(){for(var n=Math.max(arguments.length-t,0),r=Array(n),i=0;i<n;i++)r[i]=arguments[i+t];switch(t){case 0:return e.call(this,r);case 1:return e.call(this,arguments[0],r);case 2:return e.call(this,arguments[0],arguments[1],r)}var a=Array(t+1);for(i=0;i<t;i++)a[i]=arguments[i];return a[t]=r,e.apply(this,a)}},S=function(e){if(!g.isObject(e))return{};if(y)return y(e);v.prototype=e;var t=new v;return v.prototype=null,t},N=function(e){return function(t){return null==t?void 0:t[e]}},I=function(e,t){return null!=e&&h.call(e,t)},b=function(e,t){for(var n=t.length,r=0;r<n;r++){if(null==e)return;e=e[t[r]]}return n?e:void 0},R=Math.pow(2,53)-1,M=N("length"),C=function(e){var t=M(e);return"number"==typeof t&&t>=0&&t<=R};g.each=g.forEach=function(e,t,n){t=E(t,n);var r,i;if(C(e))for(r=0,i=e.length;r<i;r++)t(e[r],r,e);else{var a=g.keys(e);for(r=0,i=a.length;r<i;r++)t(e[a[r]],a[r],e)}return e},g.map=g.collect=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=Array(i),o=0;o<i;o++){var s=r?r[o]:o;a[o]=t(e[s],s,e)}return a};var w=function(e){var t=function(t,n,r,i){var a=!C(t)&&g.keys(t),o=(a||t).length,s=e>0?0:o-1;for(i||(r=t[a?a[s]:s],s+=e);s>=0&&s<o;s+=e){var u=a?a[s]:s;r=n(r,t[u],u,t)}return r};return function(e,n,r,i){var a=arguments.length>=3;return t(e,E(n,i,4),r,a)}};g.reduce=g.foldl=g.inject=w(1),g.reduceRight=g.foldr=w(-1),g.find=g.detect=function(e,t,n){var r=C(e)?g.findIndex:g.findKey,i=r(e,t,n);if(void 0!==i&&i!==-1)return e[i]},g.filter=g.select=function(e,t,n){var r=[];return t=_(t,n),g.each(e,function(e,n,i){t(e,n,i)&&r.push(e)}),r},g.reject=function(e,t,n){return g.filter(e,g.negate(_(t)),n)},g.every=g.all=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=0;a<i;a++){var o=r?r[a]:a;if(!t(e[o],o,e))return!1}return!0},g.some=g.any=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=0;a<i;a++){var o=r?r[a]:a;if(t(e[o],o,e))return!0}return!1},g.contains=g.includes=g.include=function(e,t,n,r){return C(e)||(e=g.values(e)),("number"!=typeof n||r)&&(n=0),g.indexOf(e,t,n)>=0},g.invoke=T(function(e,t,n){var r,i;return g.isFunction(t)?i=t:g.isArray(t)&&(r=t.slice(0,-1),t=t[t.length-1]),g.map(e,function(e){var a=i;if(!a){if(r&&r.length&&(e=b(e,r)),null==e)return;a=e[t]}return null==a?a:a.apply(e,n)})}),g.pluck=function(e,t){return g.map(e,g.property(t))},g.where=function(e,t){return g.filter(e,g.matcher(t))},g.findWhere=function(e,t){return g.find(e,g.matcher(t))},g.max=function(e,t,n){var r,i,a=-(1/0),o=-(1/0);if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e){e=C(e)?e:g.values(e);for(var s=0,u=e.length;s<u;s++)r=e[s],null!=r&&r>a&&(a=r)}else t=_(t,n),g.each(e,function(e,n,r){i=t(e,n,r),(i>o||i===-(1/0)&&a===-(1/0))&&(a=e,o=i)});return a},g.min=function(e,t,n){var r,i,a=1/0,o=1/0;if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e){e=C(e)?e:g.values(e);for(var s=0,u=e.length;s<u;s++)r=e[s],null!=r&&r<a&&(a=r)}else t=_(t,n),g.each(e,function(e,n,r){i=t(e,n,r),(i<o||i===1/0&&a===1/0)&&(a=e,o=i)});return a},g.shuffle=function(e){return g.sample(e,1/0)},g.sample=function(e,t,n){if(null==t||n)return C(e)||(e=g.values(e)),e[g.random(e.length-1)];var r=C(e)?g.clone(e):g.values(e),i=M(r);t=Math.max(Math.min(t,i),0);for(var a=i-1,o=0;o<t;o++){var s=g.random(o,a),u=r[o];r[o]=r[s],r[s]=u}return r.slice(0,t)},g.sortBy=function(e,t,n){var r=0;return t=_(t,n),g.pluck(g.map(e,function(e,n,i){return{value:e,index:r++,criteria:t(e,n,i)}}).sort(function(e,t){var n=e.criteria,r=t.criteria;if(n!==r){if(n>r||void 0===n)return 1;if(n<r||void 0===r)return-1}return e.index-t.index}),"value")};var P=function(e,t){return function(n,r,i){var a=t?[[],[]]:{};return r=_(r,i),g.each(n,function(t,i){var o=r(t,i,n);e(a,t,o)}),a}};g.groupBy=P(function(e,t,n){I(e,n)?e[n].push(t):e[n]=[t]}),g.indexBy=P(function(e,t,n){e[n]=t}),g.countBy=P(function(e,t,n){I(e,n)?e[n]++:e[n]=1});var L=/[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;g.toArray=function(e){return e?g.isArray(e)?c.call(e):g.isString(e)?e.match(L):C(e)?g.map(e,g.identity):g.values(e):[]},g.size=function(e){return null==e?0:C(e)?e.length:g.keys(e).length},g.partition=P(function(e,t,n){e[n?0:1].push(t)},!0),g.first=g.head=g.take=function(e,t,n){return null==e||e.length<1?null==t?void 0:[]:null==t||n?e[0]:g.initial(e,e.length-t)},g.initial=function(e,t,n){return c.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))},g.last=function(e,t,n){return null==e||e.length<1?null==t?void 0:[]:null==t||n?e[e.length-1]:g.rest(e,Math.max(0,e.length-t))},g.rest=g.tail=g.drop=function(e,t,n){return c.call(e,null==t||n?1:t)},g.compact=function(e){return g.filter(e,Boolean)};var O=function(e,t,n,r){r=r||[];for(var i=r.length,a=0,o=M(e);a<o;a++){var s=e[a];if(C(s)&&(g.isArray(s)||g.isArguments(s)))if(t)for(var u=0,l=s.length;u<l;)r[i++]=s[u++];else O(s,t,n,r),i=r.length;else n||(r[i++]=s)}return r};g.flatten=function(e,t){return O(e,t,!1)},g.without=T(function(e,t){return g.difference(e,t)}),g.uniq=g.unique=function(e,t,n,r){g.isBoolean(t)||(r=n,n=t,t=!1),null!=n&&(n=_(n,r));for(var i=[],a=[],o=0,s=M(e);o<s;o++){var u=e[o],l=n?n(u,o,e):u;t&&!n?(o&&a===l||i.push(u),a=l):n?g.contains(a,l)||(a.push(l),i.push(u)):g.contains(i,u)||i.push(u)}return i},g.union=T(function(e){return g.uniq(O(e,!0,!0))}),g.intersection=function(e){for(var t=[],n=arguments.length,r=0,i=M(e);r<i;r++){var a=e[r];if(!g.contains(t,a)){var o;for(o=1;o<n&&g.contains(arguments[o],a);o++);o===n&&t.push(a)}}return t},g.difference=T(function(e,t){return t=O(t,!0,!0),g.filter(e,function(e){return!g.contains(t,e)})}),g.unzip=function(e){for(var t=e&&g.max(e,M).length||0,n=Array(t),r=0;r<t;r++)n[r]=g.pluck(e,r);return n},g.zip=T(g.unzip),g.object=function(e,t){for(var n={},r=0,i=M(e);r<i;r++)t?n[e[r]]=t[r]:n[e[r][0]]=e[r][1];return n};var D=function(e){return function(t,n,r){n=_(n,r);for(var i=M(t),a=e>0?0:i-1;a>=0&&a<i;a+=e)if(n(t[a],a,t))return a;return-1}};g.findIndex=D(1),g.findLastIndex=D(-1),g.sortedIndex=function(e,t,n,r){n=_(n,r,1);for(var i=n(t),a=0,o=M(e);a<o;){var s=Math.floor((a+o)/2);n(e[s])<i?a=s+1:o=s}return a};var U=function(e,t,n){return function(r,i,a){var o=0,s=M(r);if("number"==typeof a)e>0?o=a>=0?a:Math.max(a+s,o):s=a>=0?Math.min(a+1,s):a+s+1;else if(n&&a&&s)return a=n(r,i),r[a]===i?a:-1;if(i!==i)return a=t(c.call(r,o,s),g.isNaN),a>=0?a+o:-1;for(a=e>0?o:s-1;a>=0&&a<s;a+=e)if(r[a]===i)return a;return-1}};g.indexOf=U(1,g.findIndex,g.sortedIndex),g.lastIndexOf=U(-1,g.findLastIndex),g.range=function(e,t,n){null==t&&(t=e||0,e=0),n||(n=t<e?-1:1);for(var r=Math.max(Math.ceil((t-e)/n),0),i=Array(r),a=0;a<r;a++,e+=n)i[a]=e;return i},g.chunk=function(e,t){if(null==t||t<1)return[];for(var n=[],r=0,i=e.length;r<i;)n.push(c.call(e,r,r+=t));return n};var x=function(e,t,n,r,i){if(!(r instanceof t))return e.apply(n,i);var a=S(e.prototype),o=e.apply(a,i);return g.isObject(o)?o:a};g.bind=T(function(e,t,n){if(!g.isFunction(e))throw new TypeError("Bind must be called on a function");var r=T(function(i){return x(e,r,t,this,n.concat(i))});return r}),g.partial=T(function(e,t){var n=g.partial.placeholder,r=function(){for(var i=0,a=t.length,o=Array(a),s=0;s<a;s++)o[s]=t[s]===n?arguments[i++]:t[s];for(;i<arguments.length;)o.push(arguments[i++]);return x(e,r,this,this,o)};return r}),g.partial.placeholder=g,g.bindAll=T(function(e,t){t=O(t,!1,!1);var n=t.length;if(n<1)throw new Error("bindAll must be passed function names");for(;n--;){var r=t[n];e[r]=g.bind(e[r],e)}}),g.memoize=function(e,t){var n=function(r){var i=n.cache,a=""+(t?t.apply(this,arguments):r);return I(i,a)||(i[a]=e.apply(this,arguments)),i[a]};return n.cache={},n},g.delay=T(function(e,t,n){return setTimeout(function(){return e.apply(null,n)},t)}),g.defer=g.partial(g.delay,g,1),g.throttle=function(e,t,n){var r,i,a,o,s=0;n||(n={});var u=function(){s=n.leading===!1?0:g.now(),r=null,o=e.apply(i,a),r||(i=a=null)},l=function(){var l=g.now();s||n.leading!==!1||(s=l);var p=t-(l-s);return i=this,a=arguments,p<=0||p>t?(r&&(clearTimeout(r),r=null),s=l,o=e.apply(i,a),r||(i=a=null)):r||n.trailing===!1||(r=setTimeout(u,p)),o};return l.cancel=function(){clearTimeout(r),s=0,r=i=a=null},l},g.debounce=function(e,t,n){var r,i,a=function(t,n){r=null,n&&(i=e.apply(t,n))},o=T(function(o){if(r&&clearTimeout(r),n){var s=!r;r=setTimeout(a,t),s&&(i=e.apply(this,o))}else r=g.delay(a,t,this,o);return i});return o.cancel=function(){clearTimeout(r),r=null},o},g.wrap=function(e,t){return g.partial(t,e)},g.negate=function(e){return function(){return!e.apply(this,arguments)}},g.compose=function(){var e=arguments,t=e.length-1;return function(){for(var n=t,r=e[t].apply(this,arguments);n--;)r=e[n].call(this,r);return r}},g.after=function(e,t){return function(){if(--e<1)return t.apply(this,arguments)}},g.before=function(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),e<=1&&(t=null),n}},g.once=g.partial(g.before,2),g.restArguments=T;var k=!{toString:null}.propertyIsEnumerable("toString"),F=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],B=function(e,t){var n=F.length,r=e.constructor,i=g.isFunction(r)&&r.prototype||u,a="constructor";for(I(e,a)&&!g.contains(t,a)&&t.push(a);n--;)a=F[n],a in e&&e[a]!==i[a]&&!g.contains(t,a)&&t.push(a)};g.keys=function(e){if(!g.isObject(e))return[];if(m)return m(e);var t=[];for(var n in e)I(e,n)&&t.push(n);return k&&B(e,t),t},g.allKeys=function(e){if(!g.isObject(e))return[];var t=[];for(var n in e)t.push(n);return k&&B(e,t),t},g.values=function(e){for(var t=g.keys(e),n=t.length,r=Array(n),i=0;i<n;i++)r[i]=e[t[i]];return r},g.mapObject=function(e,t,n){t=_(t,n);for(var r=g.keys(e),i=r.length,a={},o=0;o<i;o++){var s=r[o];a[s]=t(e[s],s,e)}return a},g.pairs=function(e){for(var t=g.keys(e),n=t.length,r=Array(n),i=0;i<n;i++)r[i]=[t[i],e[t[i]]];return r},g.invert=function(e){for(var t={},n=g.keys(e),r=0,i=n.length;r<i;r++)t[e[n[r]]]=n[r];return t},g.functions=g.methods=function(e){var t=[];for(var n in e)g.isFunction(e[n])&&t.push(n);return t.sort()};var V=function(e,t){return function(n){var r=arguments.length;if(t&&(n=Object(n)),r<2||null==n)return n;for(var i=1;i<r;i++)for(var a=arguments[i],o=e(a),s=o.length,u=0;u<s;u++){var l=o[u];t&&void 0!==n[l]||(n[l]=a[l])}return n}};g.extend=V(g.allKeys),g.extendOwn=g.assign=V(g.keys),g.findKey=function(e,t,n){t=_(t,n);for(var r,i=g.keys(e),a=0,o=i.length;a<o;a++)if(r=i[a],t(e[r],r,e))return r};var K=function(e,t,n){return t in n};g.pick=T(function(e,t){var n={},r=t[0];if(null==e)return n;g.isFunction(r)?(t.length>1&&(r=E(r,t[1])),t=g.allKeys(e)):(r=K,t=O(t,!1,!1),e=Object(e));for(var i=0,a=t.length;i<a;i++){var o=t[i],s=e[o];r(s,o,e)&&(n[o]=s)}return n}),g.omit=T(function(e,t){var n,r=t[0];return g.isFunction(r)?(r=g.negate(r),t.length>1&&(n=t[1])):(t=g.map(O(t,!1,!1),String),r=function(e,n){return!g.contains(t,n)}),g.pick(e,r,n)}),g.defaults=V(g.allKeys,!0),g.create=function(e,t){var n=S(e);return t&&g.extendOwn(n,t),n},g.clone=function(e){return g.isObject(e)?g.isArray(e)?e.slice():g.extend({},e):e},g.tap=function(e,t){return t(e),e},g.isMatch=function(e,t){var n=g.keys(t),r=n.length;if(null==e)return!r;for(var i=Object(e),a=0;a<r;a++){var o=n[a];if(t[o]!==i[o]||!(o in i))return!1}return!0};var j,W;j=function(e,t,n,r){if(e===t)return 0!==e||1/e===1/t;if(null==e||null==t)return!1;if(e!==e)return t!==t;var i=typeof e;return("function"===i||"object"===i||"object"==typeof t)&&W(e,t,n,r)},W=function(e,t,n,r){e instanceof g&&(e=e._wrapped),t instanceof g&&(t=t._wrapped);var i=f.call(e);if(i!==f.call(t))return!1;switch(i){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!==+e?+t!==+t:0===+e?1/+e===1/t:+e===+t;case"[object Date]":case"[object Boolean]":return+e===+t;case"[object Symbol]":return l.valueOf.call(e)===l.valueOf.call(t)}var a="[object Array]"===i;if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var o=e.constructor,s=t.constructor;if(o!==s&&!(g.isFunction(o)&&o instanceof o&&g.isFunction(s)&&s instanceof s)&&"constructor"in e&&"constructor"in t)return!1}n=n||[],r=r||[];for(var u=n.length;u--;)if(n[u]===e)return r[u]===t;if(n.push(e),r.push(t),a){if(u=e.length,u!==t.length)return!1;for(;u--;)if(!j(e[u],t[u],n,r))return!1}else{var p,c=g.keys(e);if(u=c.length,g.keys(t).length!==u)return!1;for(;u--;)if(p=c[u],!I(t,p)||!j(e[p],t[p],n,r))return!1}return n.pop(),r.pop(),!0},g.isEqual=function(e,t){return j(e,t)},g.isEmpty=function(e){return null==e||(C(e)&&(g.isArray(e)||g.isString(e)||g.isArguments(e))?0===e.length:0===g.keys(e).length)},g.isElement=function(e){return!(!e||1!==e.nodeType)},g.isArray=d||function(e){return"[object Array]"===f.call(e)},g.isObject=function(e){var t=typeof e;return"function"===t||"object"===t&&!!e},g.each(["Arguments","Function","String","Number","Date","RegExp","Error","Symbol","Map","WeakMap","Set","WeakSet"],function(e){
g["is"+e]=function(t){return f.call(t)==="[object "+e+"]"}}),g.isArguments(arguments)||(g.isArguments=function(e){return I(e,"callee")});var H=a.document&&a.document.childNodes;"function"!=typeof/./&&"object"!=typeof Int8Array&&"function"!=typeof H&&(g.isFunction=function(e){return"function"==typeof e||!1}),g.isFinite=function(e){return!g.isSymbol(e)&&isFinite(e)&&!isNaN(parseFloat(e))},g.isNaN=function(e){return g.isNumber(e)&&isNaN(e)},g.isBoolean=function(e){return e===!0||e===!1||"[object Boolean]"===f.call(e)},g.isNull=function(e){return null===e},g.isUndefined=function(e){return void 0===e},g.has=function(e,t){if(!g.isArray(t))return I(e,t);for(var n=t.length,r=0;r<n;r++){var i=t[r];if(null==e||!h.call(e,i))return!1;e=e[i]}return!!n},g.noConflict=function(){return a._=o,this},g.identity=function(e){return e},g.constant=function(e){return function(){return e}},g.noop=function(){},g.property=function(e){return g.isArray(e)?function(t){return b(t,e)}:N(e)},g.propertyOf=function(e){return null==e?function(){}:function(t){return g.isArray(t)?b(e,t):e[t]}},g.matcher=g.matches=function(e){return e=g.extendOwn({},e),function(t){return g.isMatch(t,e)}},g.times=function(e,t,n){var r=Array(Math.max(0,e));t=E(t,n,1);for(var i=0;i<e;i++)r[i]=t(i);return r},g.random=function(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))},g.now=Date.now||function(){return(new Date).getTime()};var Y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},q=g.invert(Y),G=function(e){var t=function(t){return e[t]},n="(?:"+g.keys(e).join("|")+")",r=RegExp(n),i=RegExp(n,"g");return function(e){return e=null==e?"":""+e,r.test(e)?e.replace(i,t):e}};g.escape=G(Y),g.unescape=G(q),g.result=function(e,t,n){g.isArray(t)||(t=[t]);var r=t.length;if(!r)return g.isFunction(n)?n.call(e):n;for(var i=0;i<r;i++){var a=null==e?void 0:e[t[i]];void 0===a&&(a=n,i=r),e=g.isFunction(a)?a.call(e):a}return e};var X=0;g.uniqueId=function(e){var t=++X+"";return e?e+t:t},g.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var z=/(.)^/,$={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},J=/\\|'|\r|\n|\u2028|\u2029/g,Q=function(e){return"\\"+$[e]};g.template=function(e,t,n){!t&&n&&(t=n),t=g.defaults({},t,g.templateSettings);var r=RegExp([(t.escape||z).source,(t.interpolate||z).source,(t.evaluate||z).source].join("|")+"|$","g"),i=0,a="__p+='";e.replace(r,function(t,n,r,o,s){return a+=e.slice(i,s).replace(J,Q),i=s+t.length,n?a+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":o&&(a+="';\n"+o+"\n__p+='"),t}),a+="';\n",t.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";var o;try{o=new Function(t.variable||"obj","_",a)}catch(e){throw e.source=a,e}var s=function(e){return o.call(this,e,g)},u=t.variable||"obj";return s.source="function("+u+"){\n"+a+"}",s},g.chain=function(e){var t=g(e);return t._chain=!0,t};var Z=function(e,t){return e._chain?g(t).chain():t};g.mixin=function(e){return g.each(g.functions(e),function(t){var n=g[t]=e[t];g.prototype[t]=function(){var e=[this._wrapped];return p.apply(e,arguments),Z(this,n.apply(g,e))}}),g},g.mixin(g),g.each(["pop","push","reverse","shift","sort","splice","unshift"],function(e){var t=s[e];g.prototype[e]=function(){var n=this._wrapped;return t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0],Z(this,n)}}),g.each(["concat","join","slice"],function(e){var t=s[e];g.prototype[e]=function(){return Z(this,t.apply(this._wrapped,arguments))}}),g.prototype.value=function(){return this._wrapped},g.prototype.valueOf=g.prototype.toJSON=g.prototype.value,g.prototype.toString=function(){return String(this._wrapped)},r=[],i=function(){return g}.apply(t,r),!(void 0!==i&&(n.exports=i))}()}).call(t,function(){return this}(),n(10)(e))},function(e,t,n){"use strict";var r,i=n(18),a=function(e){return null!=e},o=function(){function e(t){var n=this;this._value=t,this._isDefined=!1,this._isEmpty=!0,this._arr=void 0,this.getOrThrow=function(){return i(n._isDefined,"Opt is empty. Use `Opt#getOrElse` or check `Opt#isDefined`."),n._value},this.value=function(){return n._value},this.isDefined=function(){return n._isDefined},this.isEmpty=function(){return n._isEmpty},this.toArray=function(){return n._arr||(n._arr=n._isDefined?[n._value]:[])},this.getOrElse=function(e){return n._isDefined?n._value:e},this.getOrElseF=function(e){return n._isDefined?n._value:e()},this.map=function(t){return n._isEmpty?e.empty():new e(t(n._value))},this.flatMap=function(t){return n.map(t).getOrElse(e.empty())},this.equals=function(t){return i(t instanceof e,"Expected other to be an `Opt`, but got `%s`",typeof t),n._isDefined===t.isDefined()&&n._value===t.value()},a(this._value)&&(this._isDefined=!0,this._isEmpty=!1)}return e.prototype.forEach=function(e){this.isDefined()&&e(this._value)},e.empty=function(){return r||(r=new e)},e}();e.exports=o},function(e,t,n){(function(t){"use strict";var n=function(e,n,r,i,a,o,s,u){if("production"!==t.env.NODE_ENV&&void 0===n)throw new Error("invariant requires an error message argument");if(!e){var l;if(void 0===n)l=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var p=[r,i,a,o,s,u],c=0;l=new Error(n.replace(/%s/g,function(){return p[c++]})),l.name="Invariant Violation"}throw l.framesToPop=1,l}};e.exports=n}).call(t,n(7))},function(e,t,n){(function(e){"use strict";function r(e,t,n){return new Be.Function(e).call(t,n)}function i(e,t){var n=e.property();return n&&n.getContextRequirements().forEach(function(r){e.checkContextValue(r.name,r.value,r.value)||t.accept(Z(xe.CONTEXT_REQUIREMENT,{name:r.name,value:r.value,propName:n.nameId()},e))}),n}function a(e,t){var n;try{n=e.lowLevel().unit().project().fsEnabled()}catch(e){n=!0}if(n&&"undefined"!=typeof Ee&&Ee){for(var r=["exists","readFile","writeFile","readdir","existsSync","readFileSync","writeFileSync","readdirSync"],i=(Object.keys(Ee),0);i<r.length;i++)if(!Ee[r[i]])return;var a=e.lowLevel().unit().absolutePath(),o=Ae.dirname(a),s=Ae.resolve(o,"raml-lint.js");Ve(s,t,e);var u=Ae.resolve(o,".raml");if(Ee.existsSync(u)){var l=Ee.statSync(u);if(l.isDirectory()){var p=Ee.readdirSync(u);p.forEach(function(n){n.indexOf("-lint.js")!=-1&&Ve(Ae.resolve(u,n),t,e)})}}}}function o(e){return e.nameId()==_e.Universe10.TypeDeclaration.properties.type.name||e.nameId()==_e.Universe10.TypeDeclaration.properties.schema.name}function s(e){return!!l(e)&&e.nameId()==_e.Universe10.TypeDeclaration.properties.default.name}function u(e){return!!l(e)&&e.nameId()==_e.Universe10.TypeDeclaration.properties.example.name}function l(e){return!!e.domain()&&!e.domain().getAdapter(Ne.RAMLService).isUserDefined()}function p(e){return!!l(e)&&e.nameId()==_e.Universe08.MethodBase.properties.securedBy.name}function c(e){e.isElement()||(e=e.parent());for(var t=e&&e.asElement();t;){if(t.definition().getAdapter(Ne.RAMLService).isInlinedTemplates())return t.definition();var n=t.parent();if(!n)break;t=n}return null}function f(e){var n=e.parent(),r=null,i=n.definition();if(n&&ve.UserDefinedClass.isInstance(i)){var a=n.property();if(Te.isIsProperty(a)||Te.isTypeProperty(a)){var o=e.name();if(null!=t.RESERVED_TEMPLATE_PARAMETERS[o])r=Z(xe.INVALID_PARAMETER_NAME,{paramName:o},e);else{var s=o.indexOf(":");if(ge.BasicASTNode.isInstance(e)&&s>=0){var u=o.substring(0,s+1)+" "+o.substring(s+1);r=Z(xe.UNUSED_PARAMETER_MISSING_SEPARATING_SPACE,{paramName:o,correctMapping:u},e,!0)}else r=Z(xe.UNUSED_PARAMETER,{paramName:o},e,!0)}}}if(!r){var l=e.name(),p=Se("RAML08"),c=i.universe().version()==p.version();if(c){var f=_e.Universe08.Parameter.name;_e.Universe10.TypeDeclaration.name;if(c&&i.isAssignableFrom(f)){for(var h=p.type(f).allSubTypes().filter(function(e){return null!=_e.Universe08[e.nameId()].properties[l]}),d={},m=0;m<h.length;m++){var y=h[m];if(!d[y.nameId()]){var v=y.valueRequirements();if(v&&0!=v.length){var g=v.filter(function(e){return"type"==e.name}).map(function(e){return e.value});if(0!=g.length){var A=g[0];d[y.nameId()]=A,y.allSubTypes().forEach(function(e){return h.push(e)})}}}}var E=Object.keys(d).map(function(e){return d[e]}).sort();if(E.length>0){var _=E.map(function(e,t){var n="'"+e+"'";return t==E.length-1?n:t==E.length-2?n+" or ":n+", "}).join("");r=Z(xe.INVALID_PROPERTY_OWNER_TYPE,{propName:l,namesStr:_},e)}}}}return r}function h(e,t){if(e.isElement()){if(e.invalidSequence){var n=e.property().nameId();n=De.sentenceCase(Ue.singular(n)),t.acceptUnique(te(xe.SEQUENCE_NOT_ALLOWED_10,{propName:n},e.lowLevel().parent().parent(),e))}var r=e.asElement();if(r.definition().isAssignableFrom(_e.Universe10.LibraryBase.name)){var i,a=!1,o=!1;r.lowLevel().children().forEach(function(e){"schemas"==e.key()&&(a=!0,i=e),"types"==e.key()&&(o=!0)}),a&&o&&t.accept(Tt(i,r,he.IssueCode.ILLEGAL_PROPERTY_VALUE,!1,"types and schemas are mutually exclusive",!1))}r.definition().requiredProperties()&&r.definition().requiredProperties().length>0;d(e,t),(new at).validate(r,t),(new At).validate(r,t)}else d(e,t);(new vt).validate(e,t)}function d(e,t,n){void 0===n&&(n=!1);var r=e.parent(),i=e.lowLevel().value();if(e.lowLevel()&&(e.lowLevel().keyKind()==ye.Kind.MAP&&t.accept(Z(xe.NODE_KEY_IS_A_MAP,{},e)),e.lowLevel().keyKind()==ye.Kind.SEQ&&null==i)){var a=!1;e.isElement()&&e.asElement().definition().isAssignableFrom(_e.Universe10.TypeDeclaration.name)&&(a=!0),a||t.accept(Z(xe.NODE_KEY_IS_A_SEQUENCE,{},e))}if(e.isUnknown()){if("string"==typeof e.name()&&e.name().indexOf("<<")>=0&&null!=c(r))return(new Ye).validateName(e,t),!1;if(e.needSequence&&t.accept(Z(xe.SEQUENCE_REQUIRED,{name:e.name()},e)),e.needMap)return e.knownProperty?t.accept(Z(xe.PROPERTY_MUST_BE_A_MAP_10,{propName:e.knownProperty.nameId()},e)):t.accept(Z(xe.MAP_REQUIRED,{},e)),!1;if(e.unresolvedRef&&t.accept(Z(xe.UNRESOLVED_REFERENCE,{ref:i},e)),e.knownProperty){if(0==e.lowLevel().includeErrors().length){if(c(r)&&Ce.startsWith(i,"<<")&&Ce.endsWith(i,">>"))return!1;if("body"==e.name()&&e.computedValue("mediaType"))return!1;"~"!=e.lowLevel().value()&&(oe(e,t,xe.SCALAR_PROHIBITED.code,!1)||t.accept(Z(xe.SCALAR_PROHIBITED,{propName:e.name()},e)))}}else{var o="string"==typeof e.name()?e.name().indexOf("<<"):-1;if(o>0&&c(r)&&e.name().indexOf(">>",o))return!1;var s=f(e);s||(s=m(e)),t.accept(s)}}if(e.markCh()&&!e.allowRecursive())return!!e.property()&&(t.accept(Z(xe.RECURSIVE_DEFINITION,{name:e.name()},e)),!1);if(e.definition&&e.definition().isAssignableFrom(_e.Universe10.Operation.name)){var u=v(e.wrapperNode()),l=u.queryStringComesFrom,p=u.queryParamsComesFrom;l&&p&&(t.accept(y(l,e,!1)),t.accept(y(p,e,!0)))}var h=e.definition&&e.definition()&&(e.definition().key()===_e.Universe10.Overlay||e.definition().key()===_e.Universe10.Extension);return h&&S(e,t,n),!0}function m(e){var t,n=e.parent();if(n){var r=n.definition();if(r){var i=e.name(),a=r.nameId();if(be.isPossibleMethodName(i))t=Z(xe.INVALID_METHOD_USAGE,{typeName:a},e);else if("/"==i.charAt(0))t=Z(xe.INVALID_SUBRESOURCE_USAGE,{typeName:a},e);else{var o=r&&r.universe();if(o){var s=St.getInstance().hasProperty(i);if(s){var u=void 0;"RAML10"==o.version()?u="RAML 1.0":"RAML08"==o.version()&&(u="RAML 0.8"),u&&(t=Z(xe.INVALID_PROPERTY_USAGE,{propName:i,typeName:a,ramlVersion:u},e))}}}}}return t||(t=Z(xe.UNKNOWN_NODE,{name:e.name()},e)),t}function y(e,t,n){var r=e,i=e,a=n?_e.Universe10.Operation.properties.queryString.name:_e.Universe10.Operation.properties.queryParameters.name;return r.unit?te(xe.QUERY_STRING_AND_QUERY_PARAMETERS_ARE_MUTUALLY_EXCLUSIVE,{propName:a},r,t):Z(xe.QUERY_STRING_AND_QUERY_PARAMETERS_ARE_MUTUALLY_EXCLUSIVE,{propName:a},i)}function v(e){return{queryParamsComesFrom:g(e,!0),queryStringComesFrom:g(e,!1)}}function g(e,t,n,r){if(void 0===n&&(n=!0),void 0===r&&(r={}),!e)return null;if(e.name){var i=e.name();if(r[i])return;r[i]=!0}var a=E(e,t);if(a)return a;var o=e.is&&e.is()||[],s=me.find(o,function(e){return g(e.trait(),t,n,r)});if(s)return s.highLevel();if(n){var u=e.parentResource&&e.parentResource(),l=u&&A(u,t,r);if(l)return l;if(u=e.parent&&e.parent(),u&&u.highLevel().definition().isAssignableFrom(_e.Universe10.ResourceBase.name))return A(u,t,r)}return null}function A(e,t,n,r){if(void 0===n&&(n={}),void 0===r&&(r={}),e.name){var i=e.name();if(r[i])return;r[i]=!0}var a=e.is(),o=me.find(a,function(e){return g(e.trait(),t,!1,n)});if(o)return o.highLevel();var s=e.type(),u=s&&s.resourceType(),l=u&&A(u,t,n,r);return l?s.highLevel():void 0}function E(e,t){return t?_(e):T(e)}function _(e){var t=e.highLevel();return t.lowLevel&&me.find(t.lowLevel().children(),function(e){return e.key&&e.key()===_e.Universe10.Operation.properties.queryParameters.name})}function T(e){var t=e.highLevel(),n=t.element(_e.Universe10.Operation.properties.queryString.name);return n}function S(e,t,n){if(void 0===n&&(n=!1),!e.parent()){var r=e.asElement();if(r&&r.isAuxilary()){var i=r.getMaster();i&&h(i,t)}}}function N(e,t,n){if(void 0===n&&(n=!1),d(e,t,n))try{var r=e.definition&&e.definition()&&(e.definition().key()===_e.Universe10.Overlay||e.definition().key()===_e.Universe10.Extension),i=r?e.children():e.directChildren();i.filter(function(e){return!n||e.property&&e.property()&&e.property().isRequired()}).forEach(function(n){if(n&&n.errorMessage){var r=n.errorMessage;return void t.accept(Z(r.entry,r.parameters,n.name()?n:e))}n.validate(t)})}finally{e.unmarkCh()}}function I(e,t){if(!e.parent()){try{R(e,t)}finally{b(e,t)}var n=e.lowLevel().unit().contents().length;e.lowLevel().errors().forEach(function(r){var i=r.mark?r.mark.position:0,a=i>=n?i:i+1;if(r.mark&&r.mark.toLineEnd){var o=r.mark.buffer,s=o.indexOf("\n",i);s<0&&(s=o.length),s<o.length&&"\r"==o.charAt(s)&&s--,a=s}var u={code:"YAML_ERROR",message:r.message,node:null,start:i,end:a,isWarning:r.isWarning,path:e.lowLevel().unit()==e.root().lowLevel().unit()?null:e.lowLevel().unit().path(),unit:e.lowLevel().unit()};t.accept(u)})}if(e.isAttr())(new Ge).validate(e,t);else if(e.isElement()){if(e.invalidSequence){var r=e.property().nameId();t.acceptUnique(te(xe.SEQUENCE_NOT_ALLOWED_10,{propName:r},e.lowLevel().parent().parent(),e,!1))}var i=e.asElement();if(Te.isExampleSpecType(i.definition())){var a=i.children();if(0==a.length)return void N(e,t,!0);var o=a.filter(function(e){var t=e.lowLevel().key();return!t||("("!=t.charAt(0)||")"!=t.charAt(t.length-1))&&null==i.definition().property(t)});if(o.length>0)return void N(e,t,!0)}if(i.definition().isAnnotationType()||i.property()&&"annotations"==i.property().nameId())return void(new rt).validate(i,t);if(i.definition().isAssignableFrom(_e.Universe10.UsesDeclaration.name)&&(new dt).validate(i,t),i.definition().isAssignableFrom(_e.Universe10.TypeDeclaration.name))return i.attrs().forEach(function(n){var r=n.property().range().key();if(r==_e.Universe08.RelativeUriString||r==_e.Universe10.RelativeUriString)return void(new $e).validate(n,t);if(r==_e.Universe08.FullUriTemplateString||r==_e.Universe10.FullUriTemplateString)return void(new $e).validate(n,t);if(n.property().getAdapter(Ne.RAMLPropertyService).isKey()){var a=e.property()&&e.property().nameId();if(a==_e.Universe08.Resource.properties.uriParameters.name||a==_e.Universe08.Resource.properties.baseUriParameters.name)return;if(i.property()&&i.property().nameId()==_e.Universe10.MethodBase.properties.body.name)return void(new Je).validate(n,t)}}),(new ct).validate(i,t),(new ft).validate(i,t),(new ut).validate(i,t),(new it).validate(i,t),void(null==i.parent()&&i.elements().filter(function(e){return e.definition().isAssignableFrom(_e.Universe10.UsesDeclaration.name)}).forEach(function(e){return(new dt).validate(e,t)}));if(i.definition().isAssignableFrom(_e.Universe10.LibraryBase.name)){var s,u=!1,l=!1;i.lowLevel().children().forEach(function(e){"schemas"==e.key()&&(u=!0,s=e),"types"==e.key()&&(l=!0)}),u&&l&&t.accept(te(xe.TYPES_AND_SCHEMAS_ARE_EXCLUSIVE,{},s,i))}var p=i.definition().requiredProperties()&&i.definition().requiredProperties().length>0,c=i.definition().getAdapter(Ne.RAMLService).getAllowAny();c?p&&N(e,t,!0):N(e,t),(new gt).validate(i,t),(new lt).validate(i,t),(new at).validate(i,t),(new At).validate(i,t)}else N(e,t);(new vt).validate(e,t)}function b(e,t){if(e.lowLevel()){var n=e.lowLevel().actual();delete n._inc,e.children().forEach(function(e){return b(e,t)})}}function R(e,t){var n=e.lowLevel();if(n){var r=n.actual();if(!r._inc){if(e.isElement()){var i=e.name();null!=c(e)&&(i=i.replace(/<<[^<>]*>>/g,"")),"string"==typeof i&&null!=i&&i.indexOf(" ")!=-1&&t.accept(Z(xe.SPACES_IN_KEY,{value:i},e,!0))}if(r._inc=!0,n){n.includeErrors().forEach(function(n){var r=!1;e.lowLevel().hasInnerIncludeError()&&(r=!0);var i=Z(xe.INCLUDE_ERROR,{msg:n},e,r);t.accept(i)});var a=n.includePath();if(null!=a&&!Ae.isAbsolute(a)&&!de.isWebPath(a)){var o=n.unit().absolutePath();if(n instanceof fe.LowLevelCompositeNode){var s=n.adoptedNodes().find(function(e){return e.includePath()==a});s&&(o=s.unit().absolutePath())}var u=C(Ae.dirname(o),a);if(u>0){var l=Z(xe.PATH_EXCEEDS_ROOT,{},e,!0);t.accept(l)}}}e.children().forEach(function(e){return R(e,t)}),0==e.children().length&&null!=n&&n.children().forEach(function(n){return M(n,t,e)})}}}function M(e,t,n){e.includeErrors().forEach(function(r){var i=!1;e.hasInnerIncludeError()&&(i=!0);var a=te(xe.INCLUDE_ERROR,{msg:r},e,n,i);t.accept(a)});var r=e.includePath();if(null!=r&&!Ae.isAbsolute(r)&&!de.isWebPath(r)){var i=e.unit().absolutePath(),a=C(Ae.dirname(i),r);if(a>0){var o=te(xe.PATH_EXCEEDS_ROOT,{},e,n,!0);t.accept(o)}}e.children().forEach(function(e){return M(e,t,n)})}function C(e,t){for(var n=We(e),r=We(t),i=n.length,a=0,o=0,s=r;o<s.length;o++){var u=s[o];".."==u?(i--,i<0&&(a=Math.min(i,a))):i++}return-1*a}function w(e,t,n,r,i){return e.hasArrayInHierarchy()?P(e,t,n,r,i):!e.hasValueTypeInHierarchy()||L(e,t,n,r,i)}function P(e,t,n,r,i){return!e.arrayInHierarchy().componentType()||w(e.arrayInHierarchy().componentType(),t,n,r)}function L(e,t,n,r,i){try{if(e.key()==_e.Universe10.AnnotationRef){var a=Re.referenceTargets(r,t),o=me.find(a,function(e){return ge.qName(e,t)==n});if(null!=o){var s=o.attributes("allowedTargets");if(s){var u=s.map(function(e){return e.value()});if(u.length>0){var l=!1,p=t.definition().allSuperTypes();p=p.concat([t.definition()]);var c=p.map(function(e){return e.nameId()});if(u.forEach(function(e){"API"==e&&(e="Api"),"NamedExample"==e&&(e="ExampleSpec"),"SecurityScheme"==e&&(e="AbstractSecurityScheme"),"SecuritySchemeSettings"==e&&(e="SecuritySchemeSettings"),me.find(c,function(t){return t==e})?l=!0:("Parameter"==e&&t.computedValue("location")&&(l=!0),"Field"==e&&t.computedValue("field")&&(l=!0))}),!l){var f=u.map(function(e){return"'"+e+"'"}).join(", ");return new Xe(xe.INVALID_ANNOTATION_LOCATION,{aName:n,aValues:f})}}}}return g}if(e.key()==_e.Universe08.SchemaString||e.key()==_e.Universe10.SchemaString){var h=!1;if(ve.UserDefinedProp.isInstance(r)){var d=r,m=d.node();if(m){var y=m.property();y&&(h=Te.isTypeProperty(y)||Te.isSchemaProperty(y))}}if(h)return!1;var v=n&&n.trim().length>0&&("{"==n.trim().charAt(0)||"<"==n.trim().charAt(0)),g=Le.createSchema(n,Y(t.lowLevel(),i&&i.lowLevel()));if(!g)return g;if(g instanceof Error)g.isWarning=!0,v||(g.canBeRef=!0);else{var A=!1;try{JSON.parse(n),A=!0}catch(e){}if(A)try{g.validateSelf()}catch(e){return e.isWarning=!0,e}}return g}if(e.key()==_e.Universe08.StatusCodeString||e.key()==_e.Universe10.StatusCodeString){var E=re(""+n);if(null!=E)return E}if(e.key()==_e.Universe08.BooleanType||e.isAssignableFrom(_e.Universe10.BooleanType.name)){if("true"!==n&&"false"!==n&&n!==!0&&n!==!1)return new Xe(xe.BOOLEAN_EXPECTED);if(i){var _=i.lowLevel().value(!0);if("true"!==_&&"false"!==_)return new Xe(xe.BOOLEAN_EXPECTED)}}if(e.key()==_e.Universe08.NumberType||e.isAssignableFrom(_e.Universe10.NumberType.name)){var T=parseFloat(n);if(isNaN(T))return new Xe(xe.NUMBER_EXPECTED,{propName:r.nameId()})}if((e.key()==_e.Universe08.StringType||e.isAssignableFrom(_e.Universe10.StringType.name))&&null===n&&t&&r){var S=t.attr(r.nameId());if(S&&!S.isAnnotatedScalar()){var N=S.lowLevel().children();if(N&&N.length>0)return new Xe(xe.INVALID_PROPERTY_RANGE,{propName:r.nameId(),range:"string"})}}return!0}catch(e){return e.canBeRef=!0,e}}function O(e){if(!e)return!1;var t=e.toLowerCase(),n=e.toUpperCase();return e!==t&&e!==n}function D(e){if(!e)return null;if(e.isElement()){var n=e,r=n.definition();if(r&&t.typeToName.hasOwnProperty(r.nameId()))return t.typeToName[r.nameId()];if(r.isAssignableFrom(_e.Universe10.TypeDeclaration.name)||r.isAssignableFrom(_e.Universe08.Parameter.name)){if(n.property()&&t.parameterPropertyToName.hasOwnProperty(n.property().nameId()))return t.parameterPropertyToName[n.property().nameId()];if(n.property()&&n.parent()&&n.property().nameId()==_e.Universe10.LibraryBase.properties.types.name&&n.parent().definition()&&n.parent().definition().isAssignableFrom(_e.Universe10.LibraryBase.name))return"type";if(n.property()&&n.parent()&&n.property().nameId()==_e.Universe10.LibraryBase.properties.securitySchemes.name&&n.parent().definition()&&n.parent().definition().isAssignableFrom(_e.Universe10.LibraryBase.name))return"security scheme"}}return null}function U(e,t,n){var r=Re.declRoot(n);fe.LowLevelProxyNode.isInstance(n.lowLevel())&&(n=r),r._cach||(r._cach={});var i=e.id();if(e.domain()&&(i+=e.domain().nameId()),i){var a=r._cach[i];if(a)return null!=a[t]}var o=Re.enumValues(e,n),s={};return o.forEach(function(e){return s[e]=1}),e.id()&&(r._cach[i]=s),null!=s[t]}function x(e,n,r,i){var a="string"==typeof r?r.indexOf("<<"):-1;if(!(a>=0&&r.indexOf(">>",a)>=0&&null!=c(n))&&(F(e,n,i),B(e,n,i),r&&("null"!=r||!e.isAllowNull()))){var o=e.getAdapter(Ne.RAMLPropertyService),s=n.parent(),u=!1,l=fe.LowLevelCompositeNode.isInstance(n.lowLevel())&&n.lowLevel().getMeta("chaining");if(l||(u=U(e,r,s),u||n.lowLevel().unit().absolutePath()===s.lowLevel().unit().absolutePath()||(u=U(e,r,ge.fromUnit(n.lowLevel().unit())))),!u){if("string"==typeof r&&0==r.indexOf("x-")&&e.nameId()==_e.Universe10.TypeDeclaration.properties.type.name)return!0;var p=o.isReference&&o.isReference()&&o.referencesTo&&o.referencesTo()&&o.referencesTo().nameId&&o.referencesTo().nameId(),f=t.typeToName[p]||K(n),h={referencedToName:f,ref:r,typeName:r},d=f?xe.UNRECOGNIZED_ELEMENT:xe.UNRESOLVED_REFERENCE,m=V(d,e,n,r),y=e.range().key()===_e.Universe08.SchemaString;return oe(n,i,m.code,y)||i.accept(Z(m,h,n,y)),!0}return!(!k(n)||!Te.isTraitRefType(n.definition()))&&(i.accept(Z(xe.DUPLICATE_TRAIT_REFERENCE,{refValue:r},n)),!0)}}function k(e){var t,n=e.property().domain().universe().version();if(t="RAML10"==n?ce(pe.serialize(e.lowLevel())):e.value()&&e.value().valueName&&e.value().valueName(),!t)return!1;var r=e.parent&&e.parent();if(!r)return!1;var i=e.name&&e.name();if(!i)return!1;var a=r.attributes&&r.attributes(i);if(!a)return!1;if(0===a.length)return!1;var o=0;return a.forEach(function(e){var r;"RAML10"==n?t=ce(pe.serialize(e.lowLevel())):r=e.value&&e.value()&&e.value().valueName&&e.value().valueName(),r===t&&o++}),o>1}function F(e,t,n){if(Te.isIsProperty(e)){var r=t.lowLevel();if(null!=r){var i=null,a=r.parent(),o=null!=a?a.parent():null;if(r.kind()==ye.Kind.MAPPING&&r.key()&&"is"==r.key()?i=r:null!=a&&a.kind()==ye.Kind.MAPPING&&a.key()&&"is"==a.key()?i=a:null!=o&&o.kind()==ye.Kind.MAPPING&&o.key()&&"is"==o.key()&&(i=o),null!=i){null==i.value()||i.children()&&0!=i.children().length||n.accept(Z(xe.IS_IS_ARRAY,{},t));var s=!1;i.children().forEach(function(e){e.kind()!=ye.Kind.SCALAR&&e.kind()!=ye.Kind.MAP&&(s=!0)}),s&&n.accept(Z(xe.IS_IS_ARRAY,{},t))}}}}function B(e,t,n){if(Te.isTypeProperty(e)&&Te.isResourceTypeRefType(t.definition())){var r=t.lowLevel();null==t.value()&&r&&r.children()&&0==r.children().length?r.kind()==ye.Kind.MAPPING&&null!=r.valueKind()&&n.accept(Z(xe.RESOURCE_TYPE_NAME,{},t)):null==t.value()&&r&&r.children()&&r.children().length>1&&n.accept(Z(xe.MULTIPLE_RESOURCE_TYPES,{},t))}}function V(e,t,n,r){if("type"==t.nameId()&&"RAML08"==t.domain().universe().version()&&t.domain().isAssignableFrom(_e.Universe08.Parameter.name))return xe.TYPES_VARIETY_RESTRICTION;if(null!=n.parent()&&Te.isSecuritySchemaType(n.parent().definition()))return xe.UNRECOGNIZED_SECURITY_SCHEME;if(Te.isAnnotationsProperty(t)){var i=fe.LowLevelCompositeNode.isInstance(n.lowLevel())&&n.lowLevel().getMeta("chaining"),a=n.parent().types(),o=a&&a.getAnnotationTypeRegistry();return i||o&&o.getByChain(r)?xe.LIBRARY_CHAINIG_IN_ANNOTATION_TYPE:xe.UNKNOWN_ANNOTATION_TYPE}return e}function K(e){var t=e&&e.lowLevel()&&e.lowLevel().key();if(t===_e.Universe10.AbstractSecurityScheme.properties.type.name){var n=e.parent()&&e.parent().definition()&&e.parent().definition().nameId();if(n===_e.Universe10.AbstractSecurityScheme.name)return"security scheme type"}else if(t===_e.Universe08.BodyLike.properties.schema.name){var n=e.parent()&&e.parent().definition()&&e.parent().definition().nameId();if(n===_e.Universe08.BodyLike.name)return"schema"}}function j(e,t){var n=t.getValidationPath(),r=H(e,n),i=t.getInternalPath(),a=!1;if(i){var o=H(r,i);o&&o!=r&&(r=o,a=!0)}return{node:r,internalPathUsed:a}}function W(e,t){var n=e.getExtra(Me.SOURCE_EXTRA);return ge.LowLevelWrapperForTypeSystem.isInstance(n)?n.node():null}function H(e,t){if(!t)return e;var n=e.children().filter(function(e){return(!e.isAttr()||!e.asAttr().isFromKey())&&e.name()===t.name});if(e.isElement()&&Te.isTypeDeclarationDescendant(e.asElement().definition())){var r=e.lowLevel();n=me.uniq(e.directChildren().concat(e.children())).filter(function(e){return(!e.isAttr()||!e.asAttr().isFromKey())&&e.name()===t.name}).sort(function(e,t){for(var n=e.lowLevel().parent();n&&n.kind()!=ye.Kind.MAPPING;)n=n.parent();for(var i=t.lowLevel().parent();i&&i.kind()!=ye.Kind.MAPPING;)i=i.parent();return n==r?-1:i==r?1:0})}var i=t.child&&"number"==typeof t.child.name?t.child.name:-1;if(i>=0&&n.length>i)return H(n[i],t.child.child);if(n.length>0)return H(n[0],t.child);if(!e.lowLevel())return e;for(var a=e.lowLevel().children(),o=0;o<a.length;o++)if(a[o].key()===t.name){var s=new ge.BasicASTNode(a[o],e);return H(s,t.child)}if(!isNaN(t.name)&&a[t.name]){var u=a[t.name],s=new ge.BasicASTNode(u,e);return H(s,t.child)}return e}function Y(e,t){var n=e&&e.includeBaseUnit()&&(e.includePath&&e.includePath()?e.includeBaseUnit().resolve(e.includePath()):e.includeBaseUnit());if(t){var r=t&&t.includeBaseUnit()&&(t.includePath&&t.includePath()?t.includeBaseUnit().resolve(t.includePath()):t.includeBaseUnit());r!=n&&(n=r)}return new we.ContentProvider(n)}function q(e){return null!=e&&e.indexOf("json")!=-1}function G(e){return null!=e&&e.indexOf("xml")!=-1}function X(e){var t=z(e);if("body"==t){var n=e.root().attr("mediaType");return n?n.value():null}return t}function z(e){if(e.parent()){var t=e.parent().definition();if(t.key()==_e.Universe08.BodyLike)return e.parent().name();if(e.parent().parent()){var n=e.parent().parent().definition().key();if(n==_e.Universe08.Response||n==_e.Universe10.Response)return e.parent().property().nameId()==_e.Universe08.Response.properties.headers.name?null:e.parent().name();if(n==_e.Universe08.Method||n==_e.Universe10.Method)return e.parent().property().nameId()==_e.Universe10.MethodBase.properties.queryParameters.name||e.parent().property().nameId()==_e.Universe10.MethodBase.properties.headers.name?null:e.parent().name()}}return null}function $(e,t,n,r,i,a,o,s,u,l){if(void 0===u&&(u=!1),void 0===l&&(l=!1),!s)return null;var p=t.start(),c=t.end(),f=t.actual(),h=f&&f.value,d=h&&h.rawValue,m=t.valueKind();m==ye.Kind.ANCHOR_REF&&(m=t.anchorValueKind());var y=m;if(m==ye.Kind.INCLUDE_REF&&(m=t.resolvedValueKind()),m!=ye.Kind.SCALAR&&!u)return null;if(y==ye.Kind.INCLUDE_REF){var v=t.unit().resolve(t.includePath());if(v){var g=v.lineMapper(),A=g.toPosition(s.start.line,s.start.column),E=g.toPosition(s.end.line,s.end.column),_={code:n,isWarning:r,message:i,node:null,start:A.position,end:E.position,path:v.path(),extras:[],unit:v},T=void 0;return T=e?_t(e,n,r,i,a,o,t):Tt(t,null,n,r,i,a,null,l),_.extras.push(T),_}}var S=t.unit().lineMapper(),N=t.valueStart();N<0&&(N=t.start());var I,b,R=S.position(N),M=R.line+s.start.line,C=R.line+s.end.line;if(d&&"string"==typeof d&&"|"==d.charAt(0)){var w=d.indexOf("\n")+1,P=d.indexOf("\n",w);P<0&&(P=d.length);var L=Et.exec(d.substring(w,P))[0].length;I=L+s.start.column,b=L+s.end.column,M++,C++}else I=R.column+s.start.column,b=R.column+s.end.column,h&&(h.singleQuoted||h.doubleQuoted)&&(I++,b++);var O=S.toPosition(M,I),D=S.toPosition(C,b);return O&&D&&(p=O.position,c=D.position),{code:n,isWarning:r,message:i,node:e,start:p,end:c,path:a?t.unit()?t.unit().path():"":null,extras:[],unit:t?t.unit():null}}function J(e,t){return ee(e.getCode(),e.getMessage(),j(t,e).node,e.isWarning())}function Q(e,t,n){var r=null!=n?n:e.isWarning,i=e.internalPath,a=t,o=!1,s=t.lowLevel().valueKind();if(s==ye.Kind.INCLUDE_REF&&(s=t.lowLevel().resolvedValueKind()),i&&s!=ye.Kind.SCALAR){var u=ve.rt.toValidationPath(i);if(u){var l=H(t,u);l&&l!=t&&(a=l,o=!0)}}var p=o?null:e.internalRange;e.filePath&&a.lowLevel().unit().absolutePath()!=e.filePath&&(p=null,e.filePath=null);var c=Z(e.messageEntry,e.parameters,a,r,p);if(e.filePath){var f=t.lowLevel().unit().project().unit(e.filePath,!0);c.unit=f,c.path=e.filePath}return c}function Z(e,t,n,r,i){void 0===r&&(r=!1);var a=ie(e,t),o=Nt.getInstance().isKeyError(e.code);return ee(e.code,a,n,r,i,!1,o)}function ee(e,t,n,r,i,a,o){void 0===r&&(r=!1),void 0===a&&(a=!1),void 0===o&&(o=!1);var s=null,u=null;if(fe.LowLevelProxyNode.isInstance(n.lowLevel()))for(var l=n.lowLevel();!l.primaryNode();){if(!s){var p=l.transformer()&&l.transformer().paramNodesChain(l,o);if(p&&p.length>0){n.lowLevel().valueKind()!=n.lowLevel().resolvedValueKind()?(s=_t(n,e,r,t,!1,u,null,i,a),i=null,a=!1):s=_t(n,e,r,t,!1,u,null);for(var c=s;c.extras.length>0;)c=c.extras[0];for(var f=0;f<p.length;f++){var h=p[f],d=f==p.length-1?i:null,m=f==p.length-1&&a,y=Tt(h,null,e,r,t,!1,d,!0,m);c.extras.push(y),c=y}return s}s=_t(n,e,r,t,!0,u,null,i,a),i=null}n=n.parent(),l=n.lowLevel()}var v=n;if(n&&(u=n.property(),n.lowLevel().unit()!=n.root().lowLevel().unit())){s=_t(n,e,r,t,!0,u,null,i,a),i=null;for(n.lowLevel().unit();n.lowLevel().unit()!=n.root().lowLevel().unit();)u=n.property(),n=n.parent()}if(s){var g=n.lowLevel().unit().project().namespaceResolver();if(g){var A=g.resolveNamespace(n.root().lowLevel().unit(),v.lowLevel().unit());if(A){var E=A.usesNodes.map(function(e){return te(xe.ISSUES_IN_THE_LIBRARY,{value:e.value()},e,e.unit().highLevel(),!0)});E.push(s),E=E.reverse();for(var _=0;_<E.length-1;_++)E[_].extras.push(E[_+1]);return s}}n.property()&&n.property().nameId()==_e.Universe10.FragmentDeclaration.properties.uses.name&&null!=n.parent()&&(u=n.property(),n=n.parent())}var T=_t(n,e,r,t,!1,u,null,i,a);if(s){for(var c=s;c.extras&&c.extras.length>0;)c=c.extras[0];if(c.extras.push(T),n.lowLevel().valueKind()==ye.Kind.INCLUDE_REF){var S=xe.ERROR_IN_INCLUDED_FILE;T.code=S.code,T.message=ie(S,{msg:T.message})}T=s}return T}function te(e,t,n,r,i,a,o){void 0===i&&(i=!1),void 0===a&&(a=!1);var s=ie(e,t);return ne(e.code,s,n,r,i,a,o)}function ne(e,t,n,r,i,a,o){void 0===i&&(i=!1),void 0===a&&(a=!1);var s=null;if(n){var u=r.root().lowLevel().unit();if(r.lowLevel().unit()!=u){s=Tt(n,r,e,i,t,!0,o);var l=r.lowLevel().unit();for(l&&(t=t+" "+l.path());r.lowLevel().unit()!=u;)r=r.parent()}}s&&(o=null,r.property()&&r.property().nameId()==_e.Universe10.FragmentDeclaration.properties.uses.name&&null!=r.parent()&&(r=r.parent()),n=r.lowLevel());var p=Tt(n,r,e,i,t,a,o);return s&&(s.extras.push(p),n.valueKind()==ye.Kind.INCLUDE_REF&&(p.message=ie(xe.ERROR_IN_INCLUDED_FILE,{msg:p.message})),p=s),p}function re(e){if(3!=e.length)return new Xe(xe.STATUS_MUST_BE_3NUMBER);for(var t=0;t<e.length;t++){var n=e[t];if(!me.find(["0","1","2","3","4","5","6","7","8","9"],function(e){return e==n}))return new Xe(xe.STATUS_MUST_BE_3NUMBER);
}return null}function ie(e,t){for(var n="",r=e.message,i=0,a=r.indexOf("{{");a>=0;a=r.indexOf("{{",i)){if(n+=r.substring(i,a),i=r.indexOf("}}",a),i<0){i=a;break}a+="{{".length;var o=r.substring(a,i),s=o.split("|"),u=s[0].trim(),l=be.getTransformersForOccurence(o);i+="}}".length;var p=t[u];if(void 0===p)throw new Error(ie(xe.MESSAGE_PARAMETER_NO_VALUE,{paramName:u}));for(var c=0,f=l;c<f.length;c++){var h=f[c];p=h(p)}n+=p}return n+=r.substring(i,r.length)}function ae(e){if(!e)return!1;if(e=e.trim().toLowerCase(),e.indexOf("\n")>=0||e.indexOf("\r")>=0)return!1;Ce.startsWith(e,"http://")?e=e.substring("http://".length):Ce.startsWith(e,"https://")?e=e.substring("https://".length):Ce.startsWith(e,"./")?e=e.substring("./".length):Ce.startsWith(e,"/")&&(e=e.substring("/".length)),e=e.replace(/\.\.\//g,"");var t=e.split("/");if(0==t.length)return!1;for(var n=0,r=t;n<r.length;n++){var i=r[n];if(!/^[-a-z\\d%_.~+]+$/.test(i))return!1}return!0}function oe(e,t,n,r){if(void 0===r&&(r=!1),n!=xe.SCALAR_PROHIBITED.code&&n!=xe.SCALAR_PROHIBITED_2.code&&"CAN_NOT_PARSE_JSON"!=n&&"TYPE_EXPECTED"!=n&&"CONTENT_DOES_NOT_MATCH_THE_SCHEMA"!=n&&"INHERITING_UNKNOWN_TYPE"!=n&&"SCHEMA_ERROR"!=n&&"UNRECOGNIZED_ELEMENT"!=n)return!1;if(e){var i=e.lowLevel(),a=i.valueKind();if(a==ye.Kind.ANCHOR_REF&&(a=i.anchorValueKind()),a==ye.Kind.INCLUDE_REF)return!1;var o=e.property();o||(o=e.knownProperty);var s=Te.isExampleProperty(o)||Te.isExamplesProperty(o),u=Te.isTypeOrSchemaProperty(o);if(u||o&&Te.isGlobalSchemaType(o.domain())&&Te.isValueProperty(o)&&(u=!0),o&&(u||s||!o.range().isValueType())){var l=e.parent();if(!l)return!1;var p=l.definition(),c=e.lowLevel().value();if("string"==typeof c&&ae(c)){if(c.indexOf(".")<0)return!1;if(s){if(!(Te.isBodyLikeType(p)||Te.isObjectTypeDeclarationSibling(p)||Te.isArrayTypeDeclarationSibling(p)))return!1;if(!(Ce.endsWith(c,".raml")||Ce.endsWith(c,".yml")||Ce.endsWith(c,".yaml")||Ce.endsWith(c,".xml")||Ce.endsWith(c,".json")))return!1}else if(u){if(!(Ce.endsWith(c,".raml")||Ce.endsWith(c,".yml")||Ce.endsWith(c,".yaml")||Ce.endsWith(c,".xml")||Ce.endsWith(c,".json")||Ce.endsWith(c,".xsd")))return!1}else if(!(Ce.endsWith(c,".raml")||Ce.endsWith(c,".yml")||Ce.endsWith(c,".yaml")))return!1;var f=Z(xe.INCLUDE_TAG_MISSING,null,e,r);return t.accept(f),!0}}return!1}}function se(e,t,n,r,i){var a;if(q(e))try{ve.rt.getSchemaUtils().tryParseJSON(t,!0),a=JSON.parse(t)}catch(e){if(e.message.indexOf("Cannot tokenize symbol '<'")<0||!c(r))return Xe.isInstance(e)?oe(r,n,e.messageEntry.code,i)||n.accept(Q(e,r,i)):n.accept(Z(xe.CAN_NOT_PARSE_JSON,{msg:e.message},r,i)),{result:null,status:!1}}if(G(e))try{var o=[],s=[];a=Oe.parseXML(t,{warning:function(e){o.push(e)},error:function(e){s.push(e)},fatalError:function(e){s.push(e)}}),o.length?o.forEach(function(e){return n.accept(Z(xe.CAN_NOT_PARSE_XML,{msg:e},r,i))}):s.length&&s.forEach(function(e){return n.accept(Z(xe.CAN_NOT_PARSE_XML,{msg:e},r,i))})}catch(e){return n.accept(Z(xe.CAN_NOT_PARSE_XML,{msg:e.message},r,i)),{result:null,status:!1}}return{result:a,status:!0}}var ue=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var le=n(4),pe=n(20),ce=n(200),fe=n(199),he=n(198),de=n(5),me=n(16),ye=n(21),ve=n(56),ge=n(55),Ae=n(6),Ee=n(265),_e=n(204),Te=n(205),Se=n(264),Ne=ve,Ie=n(266),be=n(217),Re=n(209),Me=ve.rt,Ce=n(248),we=n(262),Pe=n(212),Le=ve.getSchemaUtils(),Oe=(n(215),n(267)),De=n(225),Ue=n(218),xe=n(207),ke=function(){function e(){this.validateNotStrictExamples=!0}return e}(),Fe=new ke,Be=n(271);t.RESERVED_TEMPLATE_PARAMETERS={resourcePathName:'Part of the resource path following the rightmost "/"',methodName:"Method name",resourcePath:"Path of the resource"};var Ve=function(e,t,n){if(Ee.existsSync(e))try{var i=Ee.readFileSync(e).toString(),a=new Ke(t);r(i,a,null),a.visit(n)}catch(e){console.log("Error in custom linter"),console.log(e)}},Ke=function(){function e(e){this.acceptor=e,this.nodes={}}return e.prototype.error=function(e,t){this.acceptor.accept(Z(xe.INVALID_VALUE_SCHEMA,{iValue:t},e.highLevel()))},e.prototype.errorOnProperty=function(e,t,n){var r=e.highLevel().attr(t);this.acceptor.accept(Z(xe.INVALID_VALUE_SCHEMA,{iValue:n},r))},e.prototype.warningOnProperty=function(e,t,n){var r=e.highLevel().attr(t);this.acceptor.accept(Z(xe.INVALID_VALUE_SCHEMA,{iValue:n},r,!0))},e.prototype.warning=function(e,t){this.acceptor.accept(Z(xe.INVALID_VALUE_SCHEMA,{iValue:t},e.highLevel(),!0))},e.prototype.registerRule=function(e,t){var n=this.nodes[e];n||(n=[],this.nodes[e]=n),n.push(t)},e.prototype.visit=function(e){var t=this,n=e.definition();this.process(n,e),n.allSuperTypes().forEach(function(n){return t.process(n,e)}),e.elements().forEach(function(e){return t.visit(e)})},e.prototype.process=function(e,t){var n=this;if(ve.NodeClass.isInstance(e)&&!e.getAdapter(Ne.RAMLService).getDeclaringNode()){var r=this.nodes[e.nameId()];r&&r.forEach(function(e){return e(t.wrapperNode(),n)})}},e}();(function(){function e(){}return e.prototype.toString=function(){return this.prev?this.value+"."+this.prev.toString():this.value},e.prototype.last=function(){return this.prev?this.prev.last():this},e})();t.typeOfContainingTemplate=c,t.validateBasicFlat=d;(function(){function e(){}return e})();t.validateBasic=N;var je=function(e,t){var n=t.lowLevel().start(),r=[];if(n<0){for(var i=t.attr("key").value().split("."),a=[],o=t.parent(),s=0,u=i;s<u.length;s++){var l=u[s],p=me.find(o.elementsOfKind("uses"),function(e){return e.attr("key")&&e.attr("key").value()==l});a.push(p),o=p.lowLevel().unit().resolve(p.attr("value").value()).highLevel().asElement()}var c=a.map(function(e){return Z(xe.ISSUES_IN_THE_LIBRARY,{value:e.attr("value").value()},e,!0)});c=c.reverse();for(var f=0;f<c.length-1;f++)c[f].extras.push(c[f+1]);return c[0]}return r.push(t),Z(xe.ISSUES_IN_THE_LIBRARY,{value:e.value()},t,!0)};t.validate=I;var We=function(t){t=t.replace(/\\/g,"/").trim(),t.length>1&&":"==t.charAt(1)&&/^win/.test(e.platform)&&(t=t.substring(2));var n=t.split("/");return 0==n[0].length&&(n=n.slice(1)),n.length>0&&0==n[n.length-1].length&&(n=n.slice(0,n.length-1)),n},He=function(e,t,n){try{new RegExp(e)}catch(r){t.accept(Z(xe.ILLEGAL_PATTERN,{value:e},n))}},Ye=function(){function e(){}return e.prototype.validateName=function(e,t){var n=e.name();if(n){var r=e.lowLevel().keyStart();this.check(n,r,e,t)}},e.prototype.validateValue=function(e,t){var n=e.value();if("string"==typeof n){var r=e.lowLevel().valueStart();this.check(n,r,e,t)}},e.prototype.hasTraitOrResourceTypeParent=function(e){for(var t=e.parent();null!=t;){if(!t.definition())return!1;if(Te.isTraitType(t.definition())||Te.isResourceTypeType(t.definition()))return!0;t=t.parent()}return!1},e.prototype.check=function(e,t,n,r){if(!this.hasTraitOrResourceTypeParent(n))return[];for(var i=[],a=0,o=e.indexOf("<<");o>=0;o=e.indexOf("<<",a)){o+="<<".length,a=e.indexOf(">>",o);var s=e.substring(o,a),u=s.indexOf("|"),l=u>=0?s.substring(0,u):s;if(0==l.trim().length){var p=Z(xe.TEMPLATE_PARAMETER_NAME_MUST_CONTAIN_NONWHITESPACE_CHARACTERS,{},n);p.start=t+o,p.end=t+a,r.accept(p)}if(u!=-1){u++;for(var c=s.split("|").slice(1).map(function(e){return e.trim()}),f=be.getTransformNames(),h=0,d=c;h<d.length;h++){var m=d[h];if(!me.find(f,function(e){return m===e||m==="!"+e})){var p=Z(xe.UNKNOWN_FUNCTION,{transformerName:m},n,!1);p.start=t+u,p.end=t+a,r.accept(p)}}}a+=">>".length}return i},e}(),qe=function(){function e(){}return e.prototype.validate=function(t,n){var r=t.parent();if(r&&(r.definition().isAssignableFrom(_e.Universe08.Method.name)||r.definition().isAssignableFrom(_e.Universe10.Method.name))){var i=me.find(r.lowLevel()&&r.lowLevel().children()||[],function(e){var t=e.key();return t&&(_e.Universe08.MethodBase.properties.body.name===t||_e.Universe10.MethodBase.properties.body.name===t)});i&&me.find(e.methodsWithoutRequestBody,function(e){return r.name()===e})&&n.accept(Z(xe.REQUEST_BODY_DISABLED,{methodName:r.name()},r))}},e.methodsWithoutRequestBody=["trace"],e}(),Ge=function(){function e(){}return e.prototype.validate=function(e,t){var n=i(e,t),r=e.value(),a=e.parent(),l=a.definition(),f=l.universe().version(),h=null!=c(a),d=e.property();if(!d.range().hasStructure()){if(ge.StructuredValue.isInstance(r)&&!d.isSelfNode()){if(o(d)&&d.domain().key()==_e.Universe08.BodyLike){var m=new ge.ASTNodeImpl(e.lowLevel(),a,l.universe().type(_e.Universe08.BodyLike.name),d);return void m.validate(t)}if("RAML10"==f&&h)return;t.accept(Z(xe.SCALAR_EXPECTED,{},e))}else{var y=e.lowLevel().valueKind();if(e.lowLevel().valueKind()!=ye.Kind.INCLUDE_REF&&!d.getAdapter(Ne.RAMLPropertyService).isKey()&&!(d.isMultiValue()||Te.isApiType(l)&&Te.isTitleProperty(d))){var v=d.range().key();v!=_e.Universe08.StringType&&v!=_e.Universe08.MarkdownString&&v!=_e.Universe08.MimeType||y!=ye.Kind.SEQ&&y!=ye.Kind.MAPPING&&y!=ye.Kind.MAP&&(!d.isRequired()&&!Te.isMediaTypeProperty(d)||null!=y&&void 0!==y)||d.domain().getAdapter(Ne.RAMLService).isInlinedTemplates()||t.accept(Z(xe.INVALID_PROPERTY_RANGE,{propName:e.name(),range:"string"},e))}}if(e.isAnnotatedScalar()){var g=new rt;e.annotations().forEach(function(e){var n=e.value(),r=n.toHighLevel();r?g.validate(r,t):t.accept(Z(xe.UNKNOWN_ANNOTATION,{aName:n.valueName()},e))})}}var A;if("string"==typeof r?A=r:ge.StructuredValue.isInstance(r)&&(A=r.valueName()),!(A&&A.indexOf("<<")!=-1&&A.indexOf(">>")>A.indexOf("<<")&&((new Ye).validateValue(e,t),h))){if((new qe).validate(e,t),d.range().key()==_e.Universe08.MimeType||d.range().key()==_e.Universe10.MimeType||d.nameId()==_e.Universe10.TypeDeclaration.properties.name.name&&a.property().nameId()==_e.Universe10.MethodBase.properties.body.name)return void(new Je).validate(e,t);if((u(d)||s(d))&&(new mt).validate(e,t),p(d)){if("RAML08"==f){var E=e.lowLevel().parent(),_=ye.Kind.SEQ;fe.LowLevelProxyNode.isInstance(e.lowLevel())?E.valueKind()!=_&&t.accept(Z(xe.SECUREDBY_LIST_08,{},e,!1)):E.kind()!=_&&t.accept(Z(xe.SECUREDBY_LIST_08,{},e,!1))}if((new mt).validate(e,t),"RAML10"==f&&ge.StructuredValue.isInstance(r)){var T=r,S=T.children().filter(function(e){return"scopes"==e.valueName()});if(S.length>0){var N=e.findReferencedValue();if(N){var I=[];S.forEach(function(e){var t=e.children();if(t.length>0)t.forEach(function(e){var t=e.lowLevel().value();null==t||h&&t.indexOf("<<")>=0||I.push(e)});else{var n=e.lowLevel().value();null==n||h&&n.indexOf("<<")>=0||I.push(e)}});var b={},R=N.element(ve.universesInfo.Universe10.AbstractSecurityScheme.properties.settings.name);if(R){var M=R.attributes(ve.universesInfo.Universe10.OAuth2SecuritySchemeSettings.properties.scopes.name);M.forEach(function(e){return b[e.value()]=!0})}for(var C=0,w=I;C<w.length;C++){var P=w[C],L=P.lowLevel().value();b.hasOwnProperty(L)||t.accept(te(xe.INVALID_SECURITY_SCHEME_SCOPE,{invalidScope:L,securityScheme:N.name(),allowedScopes:Object.keys(b).map(function(e){return"'"+e+"'"}).join(", ")},P.lowLevel(),e,!1))}}}}}if(d.nameId()==_e.Universe10.TypeDeclaration.properties.name.name){var O=a.property()&&a.property().nameId();if(O==_e.Universe08.Resource.properties.uriParameters.name||O==_e.Universe08.Resource.properties.baseUriParameters.name)return}var D=d.range().key();if(D==_e.Universe08.RelativeUriString||D==_e.Universe10.RelativeUriString)return void(new $e).validate(e,t);if(D==_e.Universe08.FullUriTemplateString||D==_e.Universe10.FullUriTemplateString)return void(new $e).validate(e,t);if("pattern"==e.name()&&_e.Universe10.StringType==e.definition().key()&&l.isAssignableFrom("StringTypeDeclaration")&&He(e.value(),t,e),"name"==e.name()&&_e.Universe10.StringType==e.definition().key()&&"string"==typeof e.value()&&0==e.value().indexOf("[")&&e.value().lastIndexOf("]")==e.value().length-1&&ge.ASTNodeImpl.isInstance(a)&&_e.Universe10.ObjectTypeDeclaration.properties.properties.name==a.property().nameId()&&ge.ASTNodeImpl.isInstance(a.parent())&&_e.Universe10.ObjectTypeDeclaration==a.parent().definition().key()){var U=e.value().substr(1,e.value().length-2);He(U,t,e)}n.isReference()||n.isDescriminator()?(new Ze).validate(e,t):(new ze).validate(e,t)}},e}();t.isValid=w;var Xe=function(e){function t(n,r){void 0===r&&(r={});var i=e.call(this)||this;return i.messageEntry=n,i.parameters=r,i.isWarning=!1,i.getClassIdentifier=t.prototype.getClassIdentifier,i}return ue(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&me.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ValidationError)},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER_ValidationError)},t.CLASS_IDENTIFIER_ValidationError="linter.ValidationError",t}(Error),ze=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.value(),r=e.property(),i=r.range(),a=i.getAdapter(Ne.RAMLService).getDeclaringNode();if(a&&i.isUserDefined()){var o=a.parsedType(),s=e.parent().lowLevel().dumpToObject(),u=s[e.parent().name()],l=r.canBeValue(),p=l||null===u||void 0===u?u:u[r.nameId()],c=o.validate(p,!0);c.isOk()||c.getErrors().forEach(function(n){return t.accept(ee(n.getCode(),n.getMessage(),e,!1))})}var f=t;if(e.lowLevel().keyKind()!=ye.Kind.SEQ)var h=w(r.range(),e.parent(),n,r,e);else h=!0;if(h instanceof Error&&!h.canBeRef)return Xe.isInstance(h)?f.accept(Q(h,e)):f.accept(Z(xe.SCHEMA_EXCEPTION,{msg:h.message},e,h.isWarning)),void(h=null);if(!h||h instanceof Error)if("value"!=r.nameId()){if(!x(r,e,n,f)){if((r.nameId()==_e.Universe10.TypeDeclaration.properties.schema.name||_e.Universe10.TypeDeclaration.properties.type.name)&&n&&n.trim()&&(r.domain().key()==_e.Universe08.BodyLike||r.domain().key()==_e.Universe10.TypeDeclaration)){var d=n.trim().charAt(0);if("{"!=d&&"<"!=d)return}var m=e.findReferencedValue();if(m instanceof Error){var y=e.findReferenceDeclaration();if(y){var v=void 0,g=void 0;if(Xe.isInstance(m)){var A=m;v=Q(A,y),g=Z(A.messageEntry,A.parameters,e)}else v=Z(xe.SCHEMA_EXCEPTION,{msg:m.message},y),g=Z(xe.SCHEMA_EXCEPTION,{msg:m.message},e);v.extras.push(g),f.accept(v)}}if(!m){if(n&&r.nameId()==_e.Universe10.TypeDeclaration.properties.schema.name){var E=n.trim();if("{"!=E.charAt(0)&&"<"!=E.charAt(0)&&(n.indexOf("|")!=-1||n.indexOf("[]")!=-1||n.indexOf("(")!=-1))return}if(h instanceof Error&&n)return Xe.isInstance(h)?f.accept(Q(h,e)):f.accept(Z(xe.SCHEMA_EXCEPTION,{msg:h.message},e)),void(h=null);if(e.property().isRequired()&&null==e.value())f.accept(Z(xe.EMPTY_VALUE_NOT_ALLOWED,{},e));else{var _=e.lowLevel().valueKind();_!=ye.Kind.MAP&&_!=ye.Kind.SEQ&&_!=ye.Kind.MAPPING||f.accept(Z(xe.EMPTY_VALUE_NOT_ALLOWED,{},e))}}}}else{var T=r.range().key()==_e.Universe08.SchemaString;if(h instanceof Error){var S=h.message;oe(e,f,xe.SCHEMA_ERROR.code,T)||f.accept(Z(xe.SCHEMA_ERROR,{msg:S},e,T))}else{var n=e.value();f.accept(Z(xe.INVALID_VALUE_SCHEMA,{iValue:n},e,T))}}var N=r.enumOptions();if(N){var I=e.parent()&&e.parent().definition(),b=I&&I.isAssignableFrom(_e.Universe10.Api.name),R=I&&I.isAssignableFrom(_e.Universe08.Api.name),M=r.nameId()===_e.Universe08.Api.properties.protocols.name,C=r.nameId()===_e.Universe10.Api.properties.protocols.name;if("string"!=typeof n)return;!R&&!b||!M&&!C||O(n)||(n=n.toUpperCase()),"string"==typeof N?N!=n&&(n&&0==n.indexOf("x-")&&r.nameId()==_e.Universe08.AbstractSecurityScheme.properties.type.name||f.accept(Z(xe.INVALID_VALUE,{iValue:n,aValues:"'"+N+"'"},e))):N.length>0&&(me.find(N,function(e){return e==n})||n&&0==n.indexOf("x-")&&r.nameId()==_e.Universe08.AbstractSecurityScheme.properties.type.name||f.accept(Z(xe.INVALID_VALUE,{iValue:n,aValues:N.map(function(e){return"'"+e+"'"}).join(", ")},e)))}},e}(),$e=function(){function e(){}return e.prototype.validate=function(e,t){try{var n=(new Qe).parseUrl(e.value()||"");if(n.some(function(e){return"version"==e})&&"baseUri"==e.property().nameId()){var r=e.root().attr("version");r||t.accept(Z(xe.MISSING_VERSION,{},e,!1))}n.some(function(e){return 0==e.length})&&t.accept(Z(xe.URI_PARAMETER_NAME_MISSING,{},e,!1))}catch(n){t.accept(Z(xe.URI_EXCEPTION,{msg:n.message},e,!1))}},e}(),Je=function(){function e(){}return e.prototype.validate=function(e,t){try{var n=e.value();if("body"==n&&e.parent().parent()){var r=e.parent().parent().definition().key();(r===_e.Universe08.Response||r===_e.Universe10.Response||e.parent().parent().definition().isAssignableFrom(_e.Universe10.MethodBase.name))&&(n=e.parent().computedValue("mediaType"))}if(null!=c(e)&&"string"==typeof n&&n.indexOf("<<")>=0)return;var i=be.parseMediaType(n);if(!i)return;i.type.match(/[\w\d][\w\d!#\$&\-\^_+\.]*/)||t.accept(Z(xe.INVALID_MEDIATYPE,{mediaType:i.type},e))}catch(n){t.accept(Z(xe.MEDIATYPE_EXCEPTION,{msg:n.message},e))}(e.value()&&"multipart/form-data"==e.value()||"application/x-www-form-urlencoded"==e.value())&&e.parent()&&e.parent().parent()&&e.parent().parent().property()&&e.parent().parent().property().nameId()==_e.Universe10.MethodBase.properties.responses.name&&t.accept(Z(xe.FORM_IN_RESPONSE,{},e,!0))},e}(),Qe=function(){function e(){}return e.prototype.checkBaseUri=function(e,t,n,r){var i=t.root().attr("baseUri");if(i){var a=i.value();try{var o=this.parseUrl(a);me.find(o,function(e){return e==n})||r.accept(Z(xe.UNUSED_URL_PARAMETER,{paramName:""},e))}catch(e){}}else r.accept(Z(xe.UNUSED_URL_PARAMETER,{paramName:""},e))},e.prototype.parseUrl=function(e){for(var t=[],n="",r=!1,i=0,a=0;a<e.length;a++){var o=e[a];"{"!=o?"}"!=o?r&&(n+=o):(i--,r=!1,t.push(n),n=""):(i++,r=!0)}if(i>0)throw new Error(ie(xe.INVALID_RESOURCE_NAME_UNMATCHED_SYMBOL,{symbol:"{"}));if(i<0)throw new Error(ie(xe.INVALID_RESOURCE_NAME_UNMATCHED_SYMBOL,{symbol:"}"}));return t},e.prototype.validate=function(e,t){var n=e.value();if(e.parent().property().nameId()==_e.Universe10.Api.properties.baseUri.name){var r=e.parent().parent();return void this.checkBaseUri(e,r,n,t)}var r=e.parent().parent(),i=r.name();if(r.definition().key()===_e.Universe10.Api||r.definition().key()===_e.Universe08.Api)return void this.checkBaseUri(e,r,n,t);if(r.definition().key()!=_e.Universe10.ResourceType&&r.definition().key()!=_e.Universe08.ResourceType)try{var a=this.parseUrl(i),o=me.find(a,function(e){return e==n});if(!o){var s=e.root().attr(_e.Universe10.Api.properties.baseUri.name);if(s&&e.name()===_e.Universe08.Api.properties.baseUriParameters.name){var u=s.value();if(u&&(a=this.parseUrl(u),a&&a.length>0&&me.find(a,function(e){return e==n})))return}t.accept(Z(xe.UNUSED_URL_PARAMETER,{paramName:"'"+n+"'"},e))}}catch(e){}},e}();t.UrlParameterNameValidator=Qe,t.typeToName={},t.typeToName[_e.Universe08.Trait.name]="trait",t.typeToName[_e.Universe08.ResourceType.name]="resource type",t.typeToName[_e.Universe10.Trait.name]="trait",t.typeToName[_e.Universe10.ResourceType.name]="resource type",t.typeToName[_e.Universe10.AbstractSecurityScheme.name]="security scheme",t.typeToName[_e.Universe10.Method.name]="method",t.typeToName[_e.Universe08.Method.name]="method",t.typeToName[_e.Universe10.Resource.name]="resource",t.typeToName[_e.Universe08.Resource.name]="resource",t.typeToName[_e.Universe10.Api.name]="api",t.typeToName[_e.Universe08.Api.name]="api",t.typeToName[_e.Universe10.Response.name]="response",t.typeToName[_e.Universe08.Response.name]="response",t.typeToName[_e.Universe08.BodyLike.name]="body",t.parameterPropertyToName={},t.parameterPropertyToName[_e.Universe08.MethodBase.properties.headers.name]="header",t.parameterPropertyToName[_e.Universe08.MethodBase.properties.queryParameters.name]="query parameter",t.parameterPropertyToName[_e.Universe08.Api.properties.uriParameters.name]="uri parameter",t.parameterPropertyToName[_e.Universe08.Api.properties.baseUriParameters.name]="base uri parameter",t.parameterPropertyToName[_e.Universe08.BodyLike.properties.formParameters.name]="form parameter",t.parameterPropertyToName[_e.Universe10.MethodBase.properties.headers.name]="header",t.parameterPropertyToName[_e.Universe10.MethodBase.properties.queryParameters.name]="query parameter",t.parameterPropertyToName[_e.Universe10.ResourceBase.properties.uriParameters.name]="uri parameter",t.parameterPropertyToName[_e.Universe10.Api.properties.baseUriParameters.name]="base uri parameter",t.parameterPropertyToName[_e.Universe10.MethodBase.properties.body.name]="body",t.getHumanReadableNodeName=D;var Ze=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.value(),r=n,i=e.property();if("string"==typeof n){if(x(i,e,n,t),ve.ReferenceType.isInstance(i.range())){var a=(i.range(),le.createNode(""+n,e.lowLevel().parent(),e.lowLevel().unit()));a._actualNode().startPosition=e.lowLevel().valueStart(),a._actualNode().endPosition=e.lowLevel().valueEnd();var o=new ge.StructuredValue(a,e.parent(),e.property()),s=o.toHighLevel();s&&s.validate(t)}}else if(ge.StructuredValue.isInstance(n)){var u=n;if(u){r=u.valueName();var l=u.valueName();if(!x(i,e,l,t)){var p=u.toHighLevel();p&&p.validate(t)}}else r=null}else"number"==typeof n||"boolean"==typeof n?e.definition().isAssignableFrom(_e.Universe10.Reference.name)&&x(i,e,n+"",t):e.definition().isAssignableFrom(_e.Universe10.Reference.name)&&x(i,e,null,t);if(r){var c=w(i.range(),e.parent(),r,i);c instanceof Error&&(Xe.isInstance(c)?t.accept(Q(c,e)):t.accept(Z(xe.SCHEMA_EXCEPTION,{msg:c.message},e,c.isWarning)),c=null)}},e}(),et=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.universe(),r=n.getTypedVersion();if(r){if("0.8"!==r&&"1.0"!==r){var i=Z(xe.UNKNOWN_RAML_VERSION,{},e);t.accept(i)}var a=n.getOriginalTopLevelText();if(a){var o={typeName:a};if(a!=e.definition().nameId()){if("Api"==e.definition().nameId()){var i=Z(xe.UNKNOWN_TOPL_LEVEL_TYPE,o,e);t.accept(i)}}else if("Api"==n.getOriginalTopLevelText()){var i=Z(xe.REDUNDANT_FRAGMENT_NAME,o,e);t.accept(i)}}}},e}(),tt=function(){function e(){}return e.prototype.validate=function(e,t){var n=this;e.definition().getAdapter(Ne.RAMLService).getContextRequirements().forEach(function(n){if(!e.checkContextValue(n.name,n.value,n.value)){var r={v1:n.name,v2:n.value,v3:e.definition().nameId()},i=xe.CONTEXT_REQUIREMENT_VIOLATION;"location"==n.name&&"ParameterLocation.FORM"==n.value&&(i=xe.WEB_FORMS),t.accept(Z(i,r,e))}});var r,i=e.definition().getAdapter(Ne.RAMLService).isInlinedTemplates();if(i){for(var a={},o=0,s=e.lowLevel().children();o<s.length;o++){var u=s[o];a[u.key()]=u.value(!0)}for(var l=e.definition().isAssignableFrom(_e.Universe10.Trait.name)?"trait":"resource type",p=be.toUnits(e.lowLevel()),c=new be.ValueTransformer(l,e.definition().nameId(),p,a),f=e.parent(),h=f?f.definition():e.definition();null!=f&&!Te.isResourceType(h)&&!Te.isMethodType(h);)f=f.parent();r=new be.DefaultTransformer(f,c,p)}e.definition().requiredProperties().forEach(function(a){if(i){var o=a.getAdapter(Ne.RAMLPropertyService).meta("templatePaths");if(o){for(var s=e.parent(),u=!1,l=0,p=o;l<p.length;l++){var c=p[l];if(c=c.map(function(e){return r.transform(e).value}),n.checkPathSufficiency(s.lowLevel(),c,s)){u=!0;break}}if(!u)return}}var f=a.range();if(f.hasArrayInHierarchy()&&(f=f.arrayInHierarchy().componentType()),f.hasValueTypeInHierarchy()){var h=e.attr(a.nameId()),d=!1;if(null!=h&&(h.lowLevel().kind()==ye.Kind.SCALAR||h.lowLevel().resolvedValueKind()==ye.Kind.SCALAR?null!=h.value()&&(d=!0):0!=h.lowLevel().children().length&&(d=!0)),!d){var m={propName:a.nameId()},y=xe.MISSING_REQUIRED_PROPERTY,v=e;i?y=xe.VALUE_NOT_PROVIDED:h&&(y=xe.VALUE_FOR_REQUIRED_PROPERTY_NOT_PROVIDED,v=h);var g=Z(y,m,v);t.accept(g)}}else{var A=e.elementsOfKind(a.nameId());if(!A||0==A.length){var E=Z(xe.MISSING_REQUIRED_PROPERTY,{propName:a.nameId()},e);t.accept(E)}}})},e.prototype.checkPathSufficiency=function(e,t,n){if(null==n||null==n.definition())return!1;var r=n.definition();if(Te.isResourceTypeType(r)||Te.isTraitType(r))return!0;if(0==t.length)return!1;if(null==e)return!1;var i=t[0];if(null==i)return!1;if("/"==i)return this.checkPathSufficiency(e,t.slice(1),n);if(0==i.length)return!0;var a=e.children().filter(function(e){return e.key()==i});0==a.length&&t.indexOf("/")<0;var o=a[0];if(fe.LowLevelCompositeNode.isInstance(o)&&(o=o.primaryNode()),null==o)return t.indexOf("/")<0;if("type"==o.key())return!0;if(1==t.length)return null==o||null==o.value();var s=t.slice(1);return this.checkPathSufficiency(o,s,n)},e}(),nt=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.lowLevel().unit();e.lowLevel().visit(function(r){if(r.unit()!=n)return!1;if(r.value()&&r._node&&r._node.value&&r._node.value.doubleQuoted){var i=(r.value()+"").indexOf(":"),a=(r.value()+"").indexOf("\n");if(i!=-1&&a!=-1&&(!r.includePath()||0==r.includePath().length)){var o=Z(xe.SUSPICIOUS_DOUBLEQUOTE,{value:r.value()},e,!0);o.start=r._node.value.startPosition,o.end=r._node.value.endPosition,o.start==o.end&&o.end++,t.accept(o)}}return!0})},e}(),rt=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.definition(),r=n.getAdapter(Ne.RAMLService).getDeclaringNode();if(r){var i=r.parsedType(),a=e.lowLevel().dumpToObject(!0);a&&(a=a[Object.keys(a)[0]]);var o=i.validate(a,!1,!1);o.isOk()||(Te.isAnnotationsProperty(e.property())?o.getErrors().forEach(function(n){if("nothing"==n.getMessage()){var r=e.parent().types(),a=r&&r.getAnnotationTypeRegistry(),o=new ge.StructuredValue(e.lowLevel(),e.parent(),e.property()),s=o.valueName(),u=i.allFacets().filter(function(e){return e.kind()==ve.tsInterfaces.MetaInformationKind.ImportedByChain});if(u.length>0&&a&&a.getByChain(s)){var l=u[0].value();t.accept(Z(xe.LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE,{typeName:s,chainedType:l},e))}else t.accept(Z(xe.UNKNOWN_ANNOTATION_TYPE,{typeName:s},e))}else t.accept(ee(n.getCode(),n.getMessage(),j(e,n).node,!1))}):o.getErrors().forEach(function(n){return t.accept(ee(n.getCode(),n.getMessage(),j(e,n).node,!1))}))}},e}(),it=function(){function e(){this.annotables={API:!0,DocumentationItem:!0,Resource:!0,Method:!0,Response:!0,RequestBody:!0,ResponseBody:!0,TypeDeclaration:!0,Example:!0,ResourceType:!0,Trait:!0,SecurityScheme:!0,SecuritySchemeSettings:!0,AnnotationType:!0,Library:!0,Overlay:!0,Extension:!0}}return e.prototype.validate=function(e,t){var n=(e.definition(),e.parsedType()),r=n.validateType(e.types().getAnnotationTypeRegistry());if(!r.isOk())for(var i=0,a=r.getErrors();i<a.length;i++){var o=a[i],s=W(o,e.lowLevel().unit().project()),u=void 0,l=j(e,o);if(l.node==e&&!l.internalPathUsed){var p=o.getValidationPath();if(p&&p.name==ve.universesInfo.Universe10.TypeDeclaration.properties.type.name&&e.attr(ve.universesInfo.Universe10.TypeDeclaration.properties.schema.name)){var c=p.name;p.name=ve.universesInfo.Universe10.TypeDeclaration.properties.schema.name,l=j(e,o),p.name=c}}var f=l.internalPathUsed?null:o.getInternalRange();if(s){if(u=ne(o.getCode(),o.getMessage(),s,l.node,o.isWarning(),!0,f),s.unit().absolutePath()!=e.lowLevel().unit().absolutePath()){var h=ee(o.getCode(),o.getMessage(),e,o.isWarning());u.extras.push(h)}}else{if(o.getFilePath()&&o.getFilePath()!=e.lowLevel().unit().absolutePath()){var d=e.lowLevel().unit().project().unit(o.getFilePath(),!0);if(d){var m=d.highLevel();if(m){u=ee(o.getCode(),o.getMessage(),m,o.isWarning(),f,!0);var h=ee(o.getCode(),o.getMessage(),l.node,o.isWarning());u.extras.push(h)}}}if(!u){if(oe(l.node,t,o.getCode(),o.isWarning()))continue;u=ee(o.getCode(),o.getMessage(),l.node,o.isWarning(),f)}}var y=o.getFilePath();if(null!=y){var v=e.lowLevel().unit().project().unit(y);v&&(u.unit=v,u.path=y)}t.accept(u)}if(e.property()&&Te.isAnnotationTypesProperty(e.property())||ge.isAnnotationTypeFragment(e))for(var g=e.attributes(_e.Universe10.TypeDeclaration.properties.allowedTargets.name),A=0,E=g;A<E.length;A++){var _=E[A];this.checkAnnotationTarget(_,t)}if(e.property()&&Te.isBodyProperty(e.property())&&1==n.superTypes().length&&n.superTypes()[0]==ve.rt.builtInTypes().get("any")){var T=n.examples(),S=X(e.attr(ve.universesInfo.Universe10.TypeDeclaration.properties.name.name)),N=q(S),I=G(S);if(T.length&&(N||I))for(var b=0,R=T;b<R.length;b++){var M=R[b],C=M.value();if("object"!=typeof C&&"string"==typeof C){var w=void 0;if(1==T.length&&null==M.name()&&(w=e.element("example")),!w)for(var P=0,L=e.elementsOfKind("examples");P<L.length;P++){var O=L[P];if(null==O.name()&&null==M.name()){if(O.attr("value").value()==C){w=O;break}}else if(O.name()==M.name()){w=O;break}}w||(w=e),se(S,C,t,w,!1)}}}},e.prototype.checkAnnotationTarget=function(e,t){var n=e.value();if(null!=n){if("string"!=typeof n)return void t.accept(Z(xe.ANNOTATION_TARGET_MUST_BE_A_STRING,{},e,!1));var r=n;n.replace(/\w|\s/g,"").length>0?t.accept(Z(xe.ALLOWED_TARGETS_MUST_BE_ARRAY,{},e,!1)):this.annotables[r]||t.accept(Z(xe.UNSUPPORTED_ANNOTATION_TARGET,{aTarget:r},e,!1))}},e}(),at=function(){function e(){}return e.prototype.validate=function(e,t){if(!e.definition().isAnnotationType()){if(e.lowLevel().keyKind()==ye.Kind.SEQ){var n=e.definition().isAssignableFrom(_e.Universe10.TypeDeclaration.name);n||t.accept(Z(xe.NODE_KEY_IS_A_SEQUENCE,{},e))}var r=e.name();if(null==r&&(r=e.lowLevel().key(),null==r&&(r="")),e.definition().key()==_e.Universe08.GlobalSchema&&e.lowLevel().valueKind()!=ye.Kind.SCALAR){var o=!1;if(e.lowLevel().valueKind()==ye.Kind.ANCHOR_REF||e.lowLevel().valueKind()==ye.Kind.INCLUDE_REF){var s=e.lowLevel().value();"string"==typeof s&&(o=!0)}o||t.accept(Z(xe.SCHEMA_NAME_MUST_BE_STRING,{name:r},e))}e.parent()||((new et).validate(e,t),e.definition().key()!=_e.Universe08.Api&&e.definition().key()!=_e.Universe10.Api||(new Ie).validateApi(e.wrapperNode(),t),(new nt).validate(e,t),a(e,t)),(new pt).validate(e,t);var u=e.definition();if(u.key()==_e.Universe08.BodyLike&&e.lowLevel().children().map(function(e){return e.key()}).some(function(e){return"formParameters"===e}))if(e.parent()&&e.parent().definition().key()==_e.Universe08.Response){var l=Z(xe.FORM_PARAMS_IN_RESPONSE,{},e);t.accept(l)}else if(e.lowLevel().children().map(function(e){return e.key()}).some(function(e){return"schema"===e||"example"===e})){var l=Z(xe.FORM_PARAMS_WITH_EXAMPLE,{},e);t.accept(l)}if(u.key()==_e.Universe10.OAuth2SecuritySchemeSettings){var p=!1;if(e.attributes("authorizationGrants").forEach(function(e){var n=e.value();if("authorization_code"===n||"implicit"===n)p=!0;else if("password"!==n&&"client_credentials"!==n&&n&&"string"==typeof n&&n.indexOf("://")==-1&&n.indexOf(":")==-1){var r=Z(xe.AUTHORIZATION_GRANTS_ENUM,{},e);t.accept(r)}}),p&&!e.attr("authorizationUri")){var l=Z(xe.AUTHORIZATION_URI_REQUIRED,{},e);t.accept(l)}}if(e.definition().isAssignableFrom(_e.Universe08.Parameter.name)||e.definition().isAssignableFrom(_e.Universe10.TypeDeclaration.name)){var f=e.attributes("enum").map(function(e){return e.value()});if(f.length!=me.uniq(f).length){var l=Z(xe.REPEATING_COMPONENTS_IN_ENUM,{},e);t.accept(l)}if(e.definition().isAssignableFrom(_e.Universe08.NumberTypeDeclaration.name)||e.definition().isAssignableFrom(_e.Universe10.NumberTypeDeclaration.name)){var h=e.definition().isAssignableFrom(_e.Universe08.IntegerTypeDeclaration.name)||e.definition().isAssignableFrom(_e.Universe10.IntegerTypeDeclaration.name);e.attributes("enum").forEach(function(e){var n=h?parseInt(e.value()):parseFloat(e.value()),r=h?!isNaN(n)&&e.value().indexOf(".")===-1:!isNaN(n);if(!r){var i=Z(h?xe.INTEGER_EXPECTED:xe.NUMBER_EXPECTED_2,{},e);t.accept(i)}})}}Te.isResourceTypeType(e.definition())&&null==e.value()&&0==e.lowLevel().children().length&&"RAML08"==e.definition().universe().version()&&e.lowLevel().resolvedValueKind()==ye.Kind.SCALAR&&t.accept(Z(xe.RESOURCE_TYPE_NULL,{},e)),i(e,t);var d=e.value();if(("string"==typeof d||"number"==typeof d||"boolean"==typeof d)&&!e.definition().getAdapter(Ne.RAMLService).allowValue()&&e.parent()&&"~"!=d){var m=null!=c(e)&&"string"==typeof d&&Ce.startsWith(d,"<<")&&Ce.endsWith(d,">>"),y=!0;if(""==d){var v=e.lowLevel().actual()&&e.lowLevel().actual().value;v&&(v.doubleQuoted||v.singleQuoted)||(y=!1);
}if(y&&!m&&!oe(e,t,xe.SCALAR_PROHIBITED_2.code)){var l=Z(xe.SCALAR_PROHIBITED_2,{name:r},e);t.accept(l)}}(new tt).validate(e,t),(new ht).validate(e,t),(new ut).validate(e,t)}},e}(),ot=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.attrValue(_e.Universe10.TypeDeclaration.properties.name.name);"version"==n&&t.accept(Z(xe.VERSION_NOT_ALLOWED,{},e))},e}(),st=function(){function e(e,t,n,r){void 0===r&&(r=!1),this.definitions=e,this.propertyName=t,this.assignableFrom=r,this.validator=n}return e.prototype.validate=function(e,t){var n=e.definition();if(null!=n){var r=!1;if(r=this.assignableFrom?this.definitions.some(function(e){return n.isAssignableFrom(e.name)}):this.definitions.some(function(e){return e===n})){if(null!=this.propertyName){if(null==e.property())return;if(e.property().nameId()!=this.propertyName)return}this.validator.validate(e,t)}}},e}(),ut=function(){function e(){}return e.createRegistry=function(){var t=[];return e.registerValidator(t,[_e.Universe10.TypeDeclaration,_e.Universe08.Parameter],_e.Universe10.Api.properties.baseUriParameters.name,new ot,!0),t},e.registerValidator=function(e,t,n,r,i){void 0===i&&(i=!1);var a=new st(t,n,r,i);e.push(a)},e.prototype.validate=function(t,n){e.entries.forEach(function(e){return e.validate(t,n)})},e.entries=e.createRegistry(),e}(),lt=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.definition();if(n&&(Te.isApiSibling(n)||Te.isMethodBaseSibling(n))){var r=e.lowLevel(),i=r.children().find(function(e){return e.key()==_e.Universe10.Api.properties.protocols.name});if(i){var a=i.value();null==a&&0==i.children().length?t.accept(te(xe.PROTOCOLS_ARRAY,{},i,e)):i.resolvedValueKind()!=ye.Kind.SEQ&&t.accept(te(xe.PROTOCOLS_ARRAY,{},i,e))}}},e}(),pt=function(){function e(){}return e.prototype.allowsAnyChildren=function(e,t){var n=e.property(),r=e.definition();return!(!Te.isAnnotationTypeType(r)&&!Te.isTypeDeclarationTypeOrDescendant(r)||!Te.isAnnotationTypesProperty(n))||(!(e.parent()!=t||!Te.isTypesProperty(n)||!Te.isTypeDeclarationTypeOrDescendant(r))||(!(!Te.isSchemasProperty(n)||!Te.isTypeDeclarationTypeOrDescendant(r))||(!(e.parent()!=t||!Te.isDocumentationProperty(n)||!Te.isDocumentationType(r))||(!!Te.isAnnotationsProperty(n)||(!!Te.isUsesProperty(n)||!!Te.isExamplesProperty(n))))))},e.prototype.nodeAllowedDueToParent=function(e,t){for(var n=e;n!=t&&null!=n;){if(this.allowsAnyChildren(n,t))return!0;n=n.parent()}return!1},e.prototype.validate=function(e,t){var n=e.root();if(!n.isExpanded()||n.lowLevel().unit().absolutePath()==e.lowLevel().unit().absolutePath()){e.property(),e.definition();if(Te.isOverlayType(n.definition())){if(e==n)return void this.validateProperties(e,t);if(!this.nodeAllowedDueToParent(e,n)){var r=n.knownIds();if(r){var i=r.hasOwnProperty(e.id());return i?void this.validateProperties(e,t):void t.accept(Z(xe.INVALID_OVERLAY_NODE,{nodeId:e.id()},e))}}}}},e.prototype.validateProperties=function(e,t){var n=e.root(),r=n.lowLevel().unit().absolutePath(),i=n.isExpanded();e.attrs().forEach(function(n){i&&r!=n.lowLevel().unit().absolutePath()||n.property().getAdapter(Ne.RAMLPropertyService).isKey()||n.parent()==e&&(n.isElement()||Te.isTitlePropertyName(n.name())||Te.isDescriptionPropertyName(n.name())||Te.isDisplayNamePropertyName(n.name())||Te.isUsagePropertyName(n.name())||Te.isExampleProperty(n.property())||Te.isMasterRefProperty(n.property())||Te.isAnnotationsProperty(n.property())||Te.isUsesProperty(n.property())||t.accept(Z(xe.INVALID_OVERRIDE_IN_OVERLAY,{propName:n.name()},n)))})},e}(),ct=function(){function e(){}return e.prototype.validate=function(e,t){var n=this,r=new pt;r.validate(e,t),e.directChildren().forEach(function(e){e.isElement()&&n.validate(e.asElement(),t)})},e}(),ft=function(){function e(){}return e.prototype.val=function(e,t,n){var r=this;if(e.kind()==ye.Kind.MAP||e.kind()==ye.Kind.MAPPING){var i={};e.children().forEach(function(e){var r=e.key();if(r){if(i.hasOwnProperty(r)){var a=Z(xe.KEYS_SHOULD_BE_UNIQUE,{},n,!1);e.unit()==n.lowLevel().unit()&&(a.start=e.keyStart(),a.end=e.keyEnd()),t.accept(a)}i[r]=1}})}e.children().forEach(function(e){r.val(e,t,n)})},e.prototype.validate=function(e,t){this.val(e.lowLevel(),t,e)},e}(),ht=function(){function e(){}return e.prototype.validate=function(e,t){this.validateChildElements(e,t);var n=e.lowLevel().children(),r=me.groupBy(n.filter(function(e){return null!=e.key()}),function(e){return e.key()});this.validateChildAttributes(e,r,t),this.validateUnrecognizedLowLevelChildren(e,r,t)},e.prototype.validateChildElements=function(e,t){var n={},r=e.directChildren().filter(function(e){return e.isElement()});r.forEach(function(e){var t=e;if(!t._computed&&t.name()){var r=t.name()+t.property().nameId();n.hasOwnProperty(r)?t.isNamePatch()||n[r].push(t):n[r]=[t]}}),Object.keys(n).forEach(function(e){var r=n[e];!r||r.length<2||r.forEach(function(e){var n=D(e),r={name:e.name()},i=xe.ALREADY_EXISTS_IN_CONTEXT;n&&(r.capitalized=De.upperCaseFirst(n),i=xe.ALREADY_EXISTS);var a=Z(i,r,e);t.accept(a)})})},e.prototype.validateChildAttributes=function(e,t,n){var r=this.getHighLevelAttributes(e),i=me.groupBy(r,function(e){return e.name()}),a=this.allowsAnyAndHasRequireds(e);Object.keys(i).forEach(function(r){if(!(i[r].length<2)){var o=i[r][0].isUnknown(),s=!o&&i[r][0].property().isMultiValue();s&&(e.definition().isAssignableFrom(_e.Universe08.SecuritySchemeSettings.name)||e.definition().isAssignableFrom(_e.Universe10.SecuritySchemeSettings.name))&&(s=t[r]&&1===t[r].length),(o&&a||!s||s&&null!=t[r]&&t[r].length>1)&&i[r].forEach(function(e){var t={propName:e.property()?e.property().nameId():e.name()},r=xe.PROPERTY_USED,i=D(e.parent());i&&(t.parent=De.upperCaseFirst(i),r=xe.PARENT_PROPERTY_USED);var a=Z(r,t,e);n.accept(a)})}})},e.prototype.validateUnrecognizedLowLevelChildren=function(e,t,n){var r=e.directChildren(),i=me.groupBy(r,function(e){return e.name()});Object.keys(t).forEach(function(r){if(r&&t[r].length>1&&!i[r]){if(e.definition().isAssignableFrom(_e.Universe10.ObjectTypeDeclaration.name))return;var a={propName:r},o=xe.PROPERTY_USED,s=D(e);s&&(a.parent=De.upperCaseFirst(s),o=xe.PARENT_PROPERTY_USED),t[r].forEach(function(t){var r=te(o,a,t,e);r.start=t.keyStart(),r.end=t.keyEnd(),n.accept(r)})}})},e.prototype.filterMultiValueAnnotations=function(e,t,n){this.getHighLevelAttributes(e);Object.keys(t).forEach(function(e){"("!==e.charAt(0)||t[e].length<2})},e.prototype.getHighLevelAttributes=function(e){var t=this.allowsAnyAndHasRequireds(e);return e.directChildren().filter(function(e){return e.isAttr()||t})},e.prototype.allowsAnyAndHasRequireds=function(e){var t=e.definition().requiredProperties(),n=t&&t.length>0,r=e.definition().getAdapter(Ne.RAMLService),i=r&&r.getAllowAny(),a=i&&n;return a},e}(),dt=function(){function e(){}return e.prototype.validate=function(e,t){if(e.definition().isAssignableFrom(_e.Universe10.UsesDeclaration.name)){var n=e.attr(_e.Universe10.UsesDeclaration.properties.value.name),r=n&&n.value();if(null!=r&&"string"==typeof r){var i=e.lowLevel().unit().resolve(r);if(null!=i&&e.root().lowLevel().actual().libExpanded){var a=i,o=a.ast(),s=o.children().filter(function(e){var t=e.key();return Ce.startsWith(t,"(")&&Ce.endsWith(t,")")});if(s.length>0)for(var u=e.root().lowLevel().unit(),l=u.project().namespaceResolver(),p=e.root().definition().universe().type(_e.Universe10.Annotable.name),c=(p.property(_e.Universe10.Annotable.properties.annotations.name),0),f=s;c<f.length;c++){var h=f[c],d=h.dumpToObject(),m={name:h.key().substring(1,h.key().length-1),value:d[Object.keys(d)[0]]};if(m&&m.name){var y=m.name,v=y,g=null,A=y.lastIndexOf(".");A>=0&&(g=y.substring(0,A),v=y.substring(A+1));var E=a;if(g){var _=l.nsMap(a);_.hasOwnProperty(g)&&(E=_[g].unit)}var T=!1;if(E){var S=l.unitModel(E);S.annotationTypes.hasElement(v)||(T=!0)}else T=!0;if(T){var N=Me.messageRegistry.UNKNOWN_ANNOTATION_TYPE,I=te(N,{typeName:y},h,e),b=Z(xe.ISSUES_IN_THE_LIBRARY,{value:r},e,!0);I.extras.push(b),t.accept(I)}}}return}if(i&&null!==i.contents()){if(!Pe.isWaitingFor(r)){var R=[];if(0===i.contents().trim().length)return void t.accept(Z(xe.EMPTY_FILE,{path:r},e,!1));var M=i.highLevel().asElement(),C=new ge.ASTNodeImpl(M.lowLevel(),M.parent(),M.definition(),M.property());if(C.setValueSource(e),C.validate(ge.createBasicValidationAcceptor(R,C)),R.length>0&&e.lowLevel().start()>=0){var w=je(n,e);R.forEach(function(e){e.unit=null==e.unit?i:e.unit,e.path||(e.path=i.path())});for(var P=0,L=R;P<L.length;P++){for(var O=L[P],D=O,U=!1;D.extras&&D.extras.length>0;)if(D=D.extras[0],D==w){U=!0;break}U||(D.extras||(D.extras=[]),D.extras.push(w)),t.accept(O)}}}}else t.accept(Z(xe.INVALID_LIBRARY_PATH,{path:r},e,!1))}}},e}(),mt=function(){function e(){}return e.prototype.validate=function(e,t){var n=this.isStrict(e);if(n||Fe.validateNotStrictExamples){var r=this.parseObject(e,t,n);if(null!=r){var i=this.aquireSchema(e);if(i){var a=r;"object"==typeof a&&(a=e.value()),i.validate(a,t,n)}}}},e.prototype.isExampleNode=function(e){return this.isSingleExampleNode(e)||this.isExampleNodeInMultipleDecl(e)},e.prototype.isSingleExampleNode=function(e){return e.name()==_e.Universe10.TypeDeclaration.properties.example.name},e.prototype.isExampleNodeInMultipleDecl=function(e){var t=e.parent();return!!t&&Te.isExampleSpecType(t.definition())},e.prototype.findParentSchemaOrTypeAttribute=function(e){var t=e.parent().attr(_e.Universe10.TypeDeclaration.properties.schema.name);return t?t:(t=e.parent().attr(_e.Universe10.TypeDeclaration.properties.type.name))?t:e.parent()?(t=e.parent().parent().attr(_e.Universe10.TypeDeclaration.properties.schema.name))?t:(t=e.parent().parent().attr(_e.Universe10.TypeDeclaration.properties.type.name),t?t:null):null},e.prototype.aquireSchema=function(e){var t=e.parent().definition().isAssignableFrom(_e.Universe10.TypeDeclaration.name);if(this.isExampleNode(e)){var n=e;if(this.isExampleNodeInMultipleDecl(e)&&(n=e.parent()),n.parent()&&(n.parent().definition().isAssignableFrom(_e.Universe10.TypeDeclaration.name)&&null===n.parent().parent()?t=!1:n.parent().property().nameId()==_e.Universe10.LibraryBase.properties.types.name&&(t=!1),n.parent().parent())){var r=n.parent().parent().definition().key();r!=_e.Universe08.Method&&r!=_e.Universe10.Method||n.parent().property().nameId()==_e.Universe10.MethodBase.properties.queryParameters.name||(t=!0),r!=_e.Universe08.Response&&r!=_e.Universe10.Response||(t=!0)}}if(e.parent().definition().key()==_e.Universe08.BodyLike||t){var i=this.findParentSchemaOrTypeAttribute(e);if(i){var a=i.value();if(ge.StructuredValue.isInstance(a))return null;var o=(""+a).trim(),s=null;if("{"==o.charAt(0))try{s=Le.getJSONSchema(o,Y(i.lowLevel()))}catch(e){return null}if("<"==o.charAt(0))try{s=Le.getXMLSchema(o)}catch(e){return null}if(s)return{validate:function(t,n,r){try{if(t.__$validated)return;if(s instanceof Error)return void n.accept(Z(xe.INVALID_VALUE_SCHEMA,{iValue:s.message},e,!r));s.validate(t)}catch(t){var a="Cannot assign to read only property '__$validated' of ";if(t.message&&0==t.message.indexOf(a)){var o=t.message.substr(a.length,t.message.length-a.length);return void n.accept(Z(xe.INVALID_JSON_SCHEMA,{propName:o},i,!r))}if("Object.keys called on non-object"==t.message)return;return Xe.isInstance(t)?void(oe(e,n,t.messageEntry.code,!r)||n.accept(Q(t,e,!r))):void n.accept(Z(xe.EXAMPLE_SCHEMA_FAILURE,{msg:t.message},e,!r))}}};if(o.length>0){var u=e.parent(),l=u&&u.parent(),p=u&&u.definition()&&u.definition().isAssignableFrom(_e.Universe10.ObjectTypeDeclaration.name)&&u;if(p=p||l&&l.definition()&&l.definition().isAssignableFrom(_e.Universe10.ObjectTypeDeclaration.name)&&l)return this.typeValidator(p,e)}}}return this.getSchemaFromModel(e)},e.prototype.getSchemaFromModel=function(e){var t=e.parent();return this.typeValidator(t,e)},e.prototype.typeValidator=function(e,t){var n={validate:function(n,r,i){var a=e.parsedType();if(a&&!a.isUnknown()){"number"==typeof n&&a.isString()&&(n=""+n),"boolean"==typeof n&&a.isString()&&(n=""+n),a.getExtra("repeat")&&(n=[n]);var o=a.validate(n,!1);o.isOk()||o.getErrors().forEach(function(e){return r.accept(ee(e.getCode(),e.getMessage(),t,!i,e.getInternalRange()))})}}};return n},e.prototype.toObject=function(e,t,n){var r=t.lowLevel().dumpToObject(!0);return this.testDublication(e,t.lowLevel(),n),r.example?r.example:r.content?r.content:void 0},e.prototype.testDublication=function(e,t,n){var r=this,i={};t.children().forEach(function(t){t.key()&&(i[t.key()]&&n.accept(Z(xe.KEYS_SHOULD_BE_UNIQUE,{},new ge.BasicASTNode(t,e.parent()))),i[t.key()]=t),r.testDublication(e,t,n)})},e.prototype.parseObject=function(e,t,n){var r=null,i=e.value(),a=X(e);if(ge.StructuredValue.isInstance(i))r=this.toObject(e,i,t);else if(a){var o=se(a,i,t,e,!n);if(!o.status)return;r=o.result}else try{if(!(i&&i.length>0)||"["!=i.trim().charAt(0)&&"{"!=i.trim().charAt(0)&&"<"!=i.trim().charAt(0))return i;r=JSON.parse(i)}catch(a){if(0!=i.trim().indexOf("<"))return i;try{r=Oe.parseXML(i)}catch(r){return void t.accept(Z(xe.CAN_NOT_PARSE_XML,{msg:r.message},e,!n))}}return null!=r&&"object"!=typeof r?i:r},e.prototype.isStrict=function(e){if(Te.isDefaultValue(e.property()))return!0;if(Te.isExampleProperty(e.property())&&"RAML08"==e.parent().definition().universe().version())return!1;var t=!1,n=e.parent().attr("strict");return n&&"true"==n.value()&&(t=!0),t},e}();t.ExampleAndDefaultValueValidator=mt;var yt=function(e,t,n){var r=De.sentence(e).toLowerCase();return t||(r=De.ucFirst(r)),n&&(r=Ue.plural(r)),r},vt=function(){function e(){}return e.prototype.validate=function(e,t){if(e.isAttr()){if(!e.optional())return;var n=e,r=n.property();if(r.isMultiValue()||r.range().isArray())return;if(!r.isFromParentKey()){var i=c(n.parent());if(i&&r.isValueProperty()){var a=Z(xe.OPTIONAL_SCLARAR_PROPERTIES_10,{templateName:i.nameId(),propName:n.name()},n,!1);t.accept(a)}}}else if(e.isElement()){var o=e,r=o.property(),s=o.allowsQuestion();s||o.optionalProperties().forEach(function(n){o.children().forEach(function(n){var i={propName:r.nameId(),oPropName:n.lowLevel().key()},a=Z(xe.OPTIONAL_PROPERTIES_10,i,e,!1);t.accept(a)})});var u=e.asElement().definition();if(e.optional()&&"RAML10"==u.universe().version()){var r=e.property(),l=Te.isQueryParametersProperty(r)||Te.isUriParametersProperty(r)||Te.isHeadersProperty(r);if(!(Te.isMethodType(u)||Te.isTypeDeclarationType(u)&&l)){var a=Z(xe.ONLY_METHODS_CAN_BE_OPTIONAL,{},e,!1);t.accept(a)}}}},e}(),gt=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.definition(),r=_e.Universe10.Api.properties.baseUri.name,i=_e.Universe10.Api.properties.baseUriParameters.name,a=_e.Universe10.Resource.properties.relativeUri.name,o=_e.Universe10.ResourceBase.properties.uriParameters.name;if(Te.isApiSibling(n))this.inspectParameters(e,t,r,i);else if(Te.isResourceType(n)){var s=e.root();this.inspectParameters(e,t,r,i,s),this.inspectParameters(e,t,a,o)}else if(Te.isResourceTypeType(n)){var s=e.root();this.inspectParameters(e,t,r,i,s)}},e.prototype.inspectParameters=function(e,t,n,r,i){i=i||e;var a="",o=i.attr(n);o&&(a=o.value(),a&&"string"==typeof a||(a=""));var s=e.elementsOfKind(r);s.forEach(function(n){var i=n.attr(_e.Universe10.TypeDeclaration.properties.name.name);if(i){var o=i.value();if(null!=o&&a.indexOf("{"+o+"}")<0){if(Te.isResourceTypeType(e.definition())&&o.indexOf("<<")>=0)return;var s=De.upperCaseFirst(Ue.singular(De.sentence(r))),u=Z(xe.PROPERTY_UNUSED,{propName:s},n,!0);t.accept(u)}}})},e}(),At=function(){function e(){this.nameProperty=_e.Universe10.ResourceType.properties.name.name}return e.prototype.validate=function(e,t){var n=e.definition();if(Te.isLibraryBaseSibling(n)||Te.isApiType(n)){var r,i,a=(_e.Universe10.LibraryBase.properties.resourceTypes.name,_e.Universe10.ResourceBase.properties.type.name),o=(_e.Universe10.LibraryBase.properties.traits.name,_e.Universe10.MethodBase.properties.is.name);e.root().lowLevel().actual().libExpanded?(r=e.elementsOfKind(_e.Universe10.LibraryBase.properties.resourceTypes.name),i=e.elementsOfKind(_e.Universe10.LibraryBase.properties.traits.name)):(r=Re.globalDeclarations(e).filter(function(e){return Te.isResourceTypeType(e.definition())}),i=Re.globalDeclarations(e).filter(function(e){return Te.isTraitType(e.definition())})),this.checkCycles(r,a,t),this.checkCycles(i,o,t)}},e.prototype.checkCycles=function(e,t,n){var r=this,i={};e.forEach(function(e){var t=r.templateName(e);i[t]=e});var a={};e.forEach(function(e){var o=r.templateName(e);a[o]||r.findCyclesInDefinition(e,t,i).forEach(function(t){t.forEach(function(e){return a[e]=!0}),t=t.reverse();var r=yt(e.definition().nameId()),i=t.join(" -> "),o={typeName:r,cycle:i},s=Z(xe.CYCLE_IN_DEFINITION,o,e,!1);n.accept(s)})})},e.prototype.templateName=function(e){var t=e.attr(this.nameProperty);return t?t.value():null},e.prototype.findCyclesInDefinition=function(e,t,n,r){void 0===r&&(r={});var i=this.templateName(e);if(r[i])return[[i]];var a={};Object.keys(r).forEach(function(e){return a[e]=r[e]}),a[i]=!0;for(var o=[],s=e.attributes(t),u=0;u<s.length;u++){var l=s[u],p=l.value();if(p){var c="string"==typeof p||"number"==typeof p||"boolean"==typeof p?p+"":p.valueName(),f=n[c];if(null!=f){var h=this.findCyclesInDefinition(f,t,n,a);h.forEach(function(e){return o.push(e)})}}}return o.forEach(function(e){return e.push(i)}),o},e}();t.isJson=q,t.isXML=G,t.getMediaType=X;var Et=/^[ ]*/,_t=function(e,t,n,r,i,a,o,s,u){void 0===u&&(u=!1);var l=o?o:e.lowLevel();if(s){var p=$(e,l,t,n,r,i,a,s,u);if(p)return p}var c=l.unit()&&l.unit().contents(),f=c&&c.length,h=l.start(),d=l.end();if(f&&f<d&&(d=f-1),l.key()&&l.keyStart()){var m=l.keyStart();m>0&&(h=m);var y=l.keyEnd();y>0&&(d=y)}if(d<h&&(d=h+1,e.isElement())){var v=e.definition();Te.isApiType(v)&&(h=0==f?0:f-1,d=h)}if(a&&!a.getAdapter(Ne.RAMLPropertyService).isMerged()&&null==e.parent()){var g=me.find(l.children(),function(e){return e.key()==a.nameId()});if(g){var m=g.keyStart(),y=g.keyEnd();m>0&&y>m&&(h=m,d=y)}}return{code:t,isWarning:n,message:r,node:e,start:h,end:d,path:i?l.unit()?l.unit().path():"":null,extras:[],unit:e?l.unit():null}},Tt=function(e,t,n,r,i,a,o,s,u){if(void 0===s&&(s=!1),void 0===u&&(u=!1),o){var l=$(null,e,n,r,i,a,null,o,u,s);if(l)return l}var p=e.unit()&&e.unit().contents(),c=p&&p.length,f=e.start(),h=e.end();if(c&&h>=c&&(h=c-1),e.key()&&e.keyStart()){var d=e.keyStart();d>0&&(f=d);var m=e.keyEnd();m>0&&(h=m)}var y=e.value(!0);return s&&y&&y.length>0&&(f=e.valueStart(),h=e.valueEnd()),{code:n,isWarning:r,message:i,node:t,start:f,end:h,path:a?e.unit()?e.unit().path():"":null,extras:[],unit:e?e.unit():null}};t.toIssue=J,t.createIssue1=Z,t.createIssue=ee,t.createLLIssue=ne,t.validateResponseString=re,t.applyTemplate=ie;var St=function(){function e(){this.propertiesMap={},this.init()}return e.getInstance=function(){return e.instance||(e.instance=new e),e.instance},e.prototype.init=function(){for(var e=ve.getUniverse.availableUniverses(),t=0,n=e;t<n.length;t++)for(var r=n[t],i=ve.getUniverse(r),a=0,o=i.types();a<o.length;a++)for(var s=o[a],u=0,l=s.properties();u<l.length;u++){var p=l[u];this.propertiesMap[p.nameId()]=!0}},e.prototype.hasProperty=function(e){return this.propertiesMap[e]||!1},e}(),Nt=function(){function e(){this.codesMap={},this.init()}return e.getInstance=function(){return e.instance||(e.instance=new e),e.instance},e.prototype.init=function(){for(var e=[xe.NODE_KEY_IS_A_MAP,xe.NODE_KEY_IS_A_SEQUENCE,xe.UNKNOWN_NODE,xe.INVALID_PROPERTY_USAGE,xe.INVALID_SUBRESOURCE_USAGE,xe.INVALID_METHOD_USAGE,xe.SPACES_IN_KEY,xe.UNKNOWN_ANNOTATION,xe.INVALID_ANNOTATION_LOCATION,xe.KEYS_SHOULD_BE_UNIQUE,xe.ALREADY_EXISTS,xe.ALREADY_EXISTS_IN_CONTEXT,xe.PROPERTY_USED,xe.PARENT_PROPERTY_USED,xe.UNKNOWN_ANNOTATION_TYPE,xe.LIBRARY_CHAINIG_IN_ANNOTATION_TYPE,xe.LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE],t=0,n=e;t<n.length;t++){var r=n[t];this.codesMap[r.code]=!0}},e.prototype.isKeyError=function(e){return this.codesMap[e]||!1},e}()}).call(t,n(7))},function(e,t,n){"use strict";function r(e,t){if(void 0===t&&(t=!1),!e)return null;var n=e.kind();if(n==u.Kind.ANCHOR_REF&&(n=e.anchorValueKind()),n==u.Kind.INCLUDE_REF){if(null!=e.unit()){var i=e.includePath(),a=null;try{a=e.unit().resolve(i)}catch(e){}if(null==a)return null;if(!a.isRAMLUnit())return h.ASTNode.isInstance(e)&&!e.canInclude(a)?null:a.contents();if(h.ASTNode.isInstance(e)&&!e.canInclude(a))return null;var o=a.ast();if(o)return r(o,t)}return null}if(n==u.Kind.SEQ){for(var s=[],l=0,p=e.children();l<p.length;l++){var c=p[l];s.push(r(c,t))}return s}if(n==u.Kind.ANCHOR_REF)return r(e.anchoredFrom(),t);if(n==u.Kind.MAPPING){var f={},d=""+e.key(!0),m=e.valueKind();if(m==u.Kind.ANCHOR_REF&&(m=e.anchorValueKind()),m==u.Kind.INCLUDE_REF){var y=e.children();0==y.length?f[d]=e.value():m=null==y[0].key()?u.Kind.SEQ:u.Kind.MAP}if(m==u.Kind.SCALAR)f[d]=e.value();else if(m==u.Kind.SEQ){var s=[];f[d]=s;for(var v=0,g=e.children();v<g.length;v++){var c=g[v];s.push(r(c,t))}}else if(m==u.Kind.MAP){var A={};f[d]=A;for(var E=0,_=e.children();E<_.length;E++){var c=_[E],T=""+c.key(!0),S=r(c,t);void 0===S&&(S=t?"!$$$novalue":null),A[T]=S}}return f[d]}if(n==u.Kind.SCALAR){var N=e.value(!1);return N}if(n==u.Kind.MAP){for(var A={},I=0,b=e.children();I<b.length;I++){var c=b[I],T=""+c.key(!0),S=r(c,!0);A[T]=void 0===S?null:S}return A}}function i(e,t){if(void 0===t&&(t={}),t=t||{},0==e.children().length)return e.value();if(e.children()[0].key()){var n={};if(e.children().forEach(function(e){n[o(e.key(t.rawKey),t)]=i(e,t)}),t&&t.writeErrors){var r=a(e);null!=r&&r.length>0&&(n.__$errors__=r)}return n}var s=[];return e.children().forEach(function(e){s.push(i(e,t))}),s}function a(e){var t=[].concat(e.errors());return e.children().forEach(function(e){var n=e.children();return 0==n.length?void e.errors().forEach(function(e){return t.push(e)}):void(n[0].key()||n.forEach(function(e){0==e.children().length&&e.errors().forEach(function(e){return t.push(e)})}))}),t}function o(e,t){return t&&e&&t.escapeNumericKeys&&0==e.replace(/\d/g,"").trim().length?"__$EscapedKey$__"+e:e}function s(e,t){return e?(t=t||{},t.escapeNumericKeys&&f.stringStartsWith(e,"__$EscapedKey$__")&&0==e.substring("__$EscapedKey$__".length).replace(/\d/g,"").trim().length?e.substring("__$EscapedKey$__".length):e):e}Object.defineProperty(t,"__esModule",{value:!0});var u=n(21),l=n(5),p=n(55),c=n(16),f=n(15),h=n(4),d=n(207),m=u.YAMLException,y=function(){function e(e,t,n,r,i,a){void 0===a&&(a={}),this._absolutePath=e,this._path=t,this._content=n,this._project=r,this._isTopoLevel=i,this.serializeOptions=a,this._node=new v(this,JSON.parse(this._content),null,a)}return e.prototype.highLevel=function(){return p.fromUnit(this)},e.prototype.absolutePath=function(){return this._absolutePath},e.prototype.clone=function(){return null},e.prototype.contents=function(){return this._content},e.prototype.lexerErrors=function(){return[]},e.prototype.path=function(){return this._content},e.prototype.isTopLevel=function(){return this._isTopoLevel},e.prototype.ast=function(){return this._node},e.prototype.expandedHighLevel=function(){return this.highLevel()},e.prototype.isDirty=function(){return!0},e.prototype.getIncludeNodes=function(){return[]},e.prototype.resolveAsync=function(e){return null},e.prototype.isRAMLUnit=function(){return!0},e.prototype.project=function(){return this._project},e.prototype.updateContent=function(e){},e.prototype.ramlVersion=function(){throw new m(d.NOT_IMPLEMENTED.message)},e.prototype.lineMapper=function(){return new l.LineMapperImpl(this.contents(),this.absolutePath())},e.prototype.resolve=function(e){return null},e.prototype.isOverlayOrExtension=function(){return!1},e.prototype.getMasterReferenceNode=function(){return null},e}();t.CompilationUnit=y;var v=function(){function e(e,t,n,r,i){void 0===r&&(r={});var a=this;this._unit=e,this._object=t,this._parent=n,this.options=r,this._key=i,this._isOptional=!1,this._object instanceof Object&&Object.keys(this._object).forEach(function(e){var t=s(e,a.options);if(t!=e){var n=a._object[e];delete a._object[e],a._object[t]=n}}),this._key&&f.stringEndsWith(this._key,"?")&&(this._isOptional=!0,this._key=this._key.substring(0,this._key.length-1))}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&c.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.keyKind=function(){return null},e.prototype.isAnnotatedScalar=function(){return!1},e.prototype.hasInnerIncludeError=function(){return!1},e.prototype.start=function(){return-1},e.prototype.end=function(){return-1},e.prototype.value=function(){return this._object},e.prototype.actual=function(){return this._object},e.prototype.includeErrors=function(){return[]},e.prototype.includePath=function(){return null},e.prototype.includeReference=function(){return null},e.prototype.key=function(){return this._key},e.prototype.optional=function(){return this._isOptional},e.prototype.children=function(){var t=this;return this._object?Array.isArray(this._object)?this._object.map(function(n){return new e(t._unit,n,t,t.options)}):this._object instanceof Object?Object.keys(this._object).map(function(n){return new e(t._unit,t._object[n],t,t.options,n)}):[]:[]},e.prototype.parent=function(){return this._parent},e.prototype.unit=function(){return this._unit},e.prototype.containingUnit=function(){return this._unit},e.prototype.includeBaseUnit=function(){return this._unit},e.prototype.anchorId=function(){return null},e.prototype.errors=function(){return[]},e.prototype.anchoredFrom=function(){return this},e.prototype.includedFrom=function(){return this},e.prototype.visit=function(e){e(this)&&this.children().forEach(function(t){return t.visit(e)})},e.prototype.dumpToObject=function(){return this._object},e.prototype.addChild=function(e){},e.prototype.execute=function(e){},e.prototype.dump=function(){return JSON.stringify(this._object)},e.prototype.keyStart=function(){return-1},e.prototype.keyEnd=function(){return-1},e.prototype.valueStart=function(){return-1},e.prototype.valueEnd=function(){return-1},e.prototype.isValueLocal=function(){return!0},e.prototype.kind=function(){return Array.isArray(this._object)?u.Kind.SEQ:this._object instanceof Object?u.Kind.MAP:u.Kind.SCALAR},e.prototype.valueKind=function(){if(!this._object)return null;var e=typeof this._object;return Array.isArray(this._object)?u.Kind.SEQ:"object"==e?u.Kind.MAP:"string"==e||"number"==e||"boolean"==e?u.Kind.SCALAR:null},e.prototype.anchorValueKind=function(){return null},e.prototype.resolvedValueKind=function(){return this.valueKind()},e.prototype.show=function(e){},e.prototype.setHighLevelParseResult=function(e){this._highLevelParseResult=e},e.prototype.highLevelParseResult=function(){return this._highLevelParseResult},e.prototype.setHighLevelNode=function(e){this._highLevelNode=e},e.prototype.highLevelNode=function(){return this._highLevelNode},e.prototype.text=function(e){throw new m(d.NOT_IMPLEMENTED.message)},e.prototype.copy=function(){throw new m(d.NOT_IMPLEMENTED.message)},e.prototype.markup=function(e){throw new m(d.NOT_IMPLEMENTED.message)},e.prototype.nodeDefinition=function(){return h.getDefinitionForLowLevelNode(this)},e.prototype.includesContents=function(){return!1},e.CLASS_IDENTIFIER="json2LowLeve.AstNode",e}();t.AstNode=v,t.serialize2=r,t.serialize=i},function(e,t,n){"use strict";function r(e){for(var n in e)t.hasOwnProperty(n)||(t[n]=e[n])}Object.defineProperty(t,"__esModule",{value:!0});var i=n(22);t.load=i.load,t.loadAll=i.loadAll,t.safeLoad=i.safeLoad,t.safeLoadAll=i.safeLoadAll;var a=n(53);t.dump=a.dump,t.safeDump=a.safeDump,t.YAMLException=n(25),r(n(23)),r(n(54))},function(e,t,n){"use strict";function r(e){return 10===e||13===e}function i(e){return 9===e||32===e}function a(e){return 9===e||32===e||10===e||13===e}function o(e){return 44===e||91===e||93===e||123===e||125===e}function s(e){var t;return 48<=e&&e<=57?e-48:(t=32|e,97<=t&&t<=102?t-97+10:-1)}function u(e){return 120===e?2:117===e?4:85===e?8:0}function l(e){return 48<=e&&e<=57?e-48:-1}function p(e){return 48===e?"\0":97===e?"":98===e?"\b":116===e?"\t":9===e?"\t":110===e?"\n":118===e?"\v":102===e?"\f":114===e?"\r":101===e?"":32===e?" ":34===e?'"':47===e?"/":92===e?"\\":78===e?"":95===e?" ":76===e?"\u2028":80===e?"\u2029":""}function c(e){return e<=65535?String.fromCharCode(e):String.fromCharCode((e-65536>>10)+55296,(e-65536&1023)+56320)}function f(e,t,n){return void 0===n&&(n=!1),new j(t,new W(e.filename,e.input,e.position,e.line,e.position-e.lineStart),n)}function h(e,t,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=!1);var a=A(e,t);if(a){var o=n+t;if(!e.errorMap[o]){var s=new W(e.filename,e.input,t,a.line,t-a.start);i&&(s.toLineEnd=!0);var u=new j(n,s,r);e.errors.push(u)}}}function d(e,t){var n=f(e,t),r=n.message+n.mark.position;if(!e.errorMap[r]){e.errors.push(n),e.errorMap[r]=1;for(var i=e.position;;){if(e.position>=e.input.length-1)return;var a=e.input.charAt(e.position);if("\n"==a)return e.position--,void(e.position==i&&(e.position+=1));if("\r"==a)return e.position--,void(e.position==i&&(e.position+=1));e.position++}}}function m(e,t){var n=f(e,t);e.onWarning&&e.onWarning.call(null,n)}function y(e,t,n,r){var i,a,o,s,u=e.result;if(u.startPosition==-1&&(u.startPosition=t),t<=n){if(s=e.input.slice(t,n),r)for(i=0,a=s.length;i<a;i+=1)o=s.charCodeAt(i),9===o||32<=o&&o<=1114111||d(e,"expected valid JSON character");u.value+=s,u.endPosition=n}}function v(e,t,n,r,i){if(null!=r){null===t&&(t={startPosition:r.startPosition,endPosition:i.endPosition,parent:null,errors:[],mappings:[],kind:V.Kind.MAP});var a=V.newMapping(r,i);return a.parent=t,r.parent=a,null!=i&&(i.parent=a),!e.ignoreDuplicateKeys&&t.mappings.forEach(function(t){t.key&&t.key.value===(a.key&&a.key.value)&&(h(e,a.key.startPosition,"duplicate key"),h(e,t.key.startPosition,"duplicate key"))}),t.mappings.push(a),t.endPosition=i?i.endPosition:r.endPosition+1,t}}function g(e){var t;t=e.input.charCodeAt(e.position),10===t?e.position++:13===t?(e.position++,10===e.input.charCodeAt(e.position)&&e.position++):d(e,"a line break is expected"),e.line+=1,e.lineStart=e.position,e.lines.push({start:e.lineStart,line:e.line})}function A(e,t){for(var n,r=0;r<e.lines.length&&!(e.lines[r].start>t);r++)n=e.lines[r];return n?n:{start:0,line:0}}function E(e,t,n){for(var a=0,o=e.input.charCodeAt(e.position);0!==o;){for(;i(o);)9===o&&e.errors.push(f(e,"Using tabs can lead to unpredictable results",!0)),o=e.input.charCodeAt(++e.position);if(t&&35===o)do o=e.input.charCodeAt(++e.position);while(10!==o&&13!==o&&0!==o);if(!r(o))break;for(g(e),o=e.input.charCodeAt(e.position),a++,e.lineIndent=0;32===o;)e.lineIndent++,o=e.input.charCodeAt(++e.position)}return-1!==n&&0!==a&&e.lineIndent<n&&m(e,"deficient indentation"),a}function _(e){var t,n=e.position;return t=e.input.charCodeAt(n),!(45!==t&&46!==t||e.input.charCodeAt(n+1)!==t||e.input.charCodeAt(n+2)!==t||(n+=3,t=e.input.charCodeAt(n),0!==t&&!a(t)))}function T(e,t,n){1===n?t.value+=" ":n>1&&(t.value+=K.repeat("\n",n-1))}function S(e,t,n){var s,u,l,p,c,f,h,d,m,v=e.kind,g=e.result,A=V.newScalar();if(A.plainScalar=!0,e.result=A,m=e.input.charCodeAt(e.position),a(m)||o(m)||35===m||38===m||42===m||33===m||124===m||62===m||39===m||34===m||37===m||64===m||96===m)return!1;if((63===m||45===m)&&(u=e.input.charCodeAt(e.position+1),a(u)||n&&o(u)))return!1;for(e.kind="scalar",l=p=e.position,c=!1;0!==m;){if(58===m){if(u=e.input.charCodeAt(e.position+1),a(u)||n&&o(u))break}else if(35===m){if(s=e.input.charCodeAt(e.position-1),a(s))break}else{if(e.position===e.lineStart&&_(e)||n&&o(m))break;if(r(m)){if(f=e.line,h=e.lineStart,d=e.lineIndent,E(e,!1,-1),e.lineIndent>=t){c=!0,m=e.input.charCodeAt(e.position);continue}e.position=p,e.line=f,e.lineStart=h,e.lineIndent=d;break}}if(c&&(y(e,l,p,!1),T(e,A,e.line-f),l=p=e.position,c=!1),i(m)||(p=e.position+1),m=e.input.charCodeAt(++e.position),e.position>=e.input.length)return!1}return y(e,l,p,!1),e.result.startPosition!=-1?(A.rawValue=e.input.substring(A.startPosition,A.endPosition),
!0):(e.kind=v,e.result=g,!1)}function N(e,t){var n,i,a;if(n=e.input.charCodeAt(e.position),39!==n)return!1;var o=V.newScalar();for(o.singleQuoted=!0,e.kind="scalar",e.result=o,o.startPosition=e.position,e.position++,i=a=e.position;0!==(n=e.input.charCodeAt(e.position));)if(39===n){if(y(e,i,e.position,!0),n=e.input.charCodeAt(++e.position),o.endPosition=e.position,39!==n)return!0;i=a=e.position,e.position++}else r(n)?(y(e,i,a,!0),T(e,o,E(e,!1,t)),i=a=e.position):e.position===e.lineStart&&_(e)?d(e,"unexpected end of the document within a single quoted scalar"):(e.position++,a=e.position,o.endPosition=e.position);d(e,"unexpected end of the stream within a single quoted scalar")}function I(e,t){var n,i,a,o,l,p;if(p=e.input.charCodeAt(e.position),34!==p)return!1;e.kind="scalar";var f=V.newScalar();for(f.doubleQuoted=!0,e.result=f,f.startPosition=e.position,e.position++,n=i=e.position;0!==(p=e.input.charCodeAt(e.position));){if(34===p)return y(e,n,e.position,!0),e.position++,f.endPosition=e.position,f.rawValue=e.input.substring(f.startPosition,f.endPosition),!0;if(92===p){if(y(e,n,e.position,!0),p=e.input.charCodeAt(++e.position),r(p))E(e,!1,t);else if(p<256&&(e.allowAnyEscape?se[p]:ae[p]))f.value+=e.allowAnyEscape?ue[p]:oe[p],e.position++;else if((l=u(p))>0){for(a=l,o=0;a>0;a--)p=e.input.charCodeAt(++e.position),(l=s(p))>=0?o=(o<<4)+l:d(e,"expected hexadecimal character");f.value+=c(o),e.position++}else d(e,"unknown escape sequence");n=i=e.position}else r(p)?(y(e,n,i,!0),T(e,f,E(e,!1,t)),n=i=e.position):e.position===e.lineStart&&_(e)?d(e,"unexpected end of the document within a double quoted scalar"):(e.position++,i=e.position)}d(e,"unexpected end of the stream within a double quoted scalar")}function b(e,t){var n,r,i,o,s,u,l,p,c,f,h,m=!0,y=e.tag,g=e.anchor;if(h=e.input.charCodeAt(e.position),91===h)o=93,l=!1,r=V.newItems(),r.startPosition=e.position;else{if(123!==h)return!1;o=125,l=!0,r=V.newMap(),r.startPosition=e.position}for(null!==e.anchor&&(r.anchorId=e.anchor,e.anchorMap[e.anchor]=r),h=e.input.charCodeAt(++e.position);0!==h;){if(E(e,!0,t),h=e.input.charCodeAt(e.position),h===o)return e.position++,e.tag=y,e.anchor=g,e.kind=l?"mapping":"sequence",e.result=r,r.endPosition=e.position,!0;if(!m){var A=e.position;d(e,"missed comma between flow collection entries"),e.position=A+1}if(c=p=f=null,s=u=!1,63===h&&(i=e.input.charCodeAt(e.position+1),a(i)&&(s=u=!0,e.position++,E(e,!0,t))),n=e.line,O(e,t,G,!1,!0),c=e.tag,p=e.result,E(e,!0,t),h=e.input.charCodeAt(e.position),!u&&e.line!==n||58!==h||(s=!0,h=e.input.charCodeAt(++e.position),E(e,!0,t),O(e,t,G,!1,!0),f=e.result),l)v(e,r,c,p,f);else if(s){var _=v(e,null,c,p,f);_.parent=r,r.items.push(_)}else p&&(p.parent=r),r.items.push(p);r.endPosition=e.position+1,E(e,!0,t),h=e.input.charCodeAt(e.position),44===h?(m=!0,h=e.input.charCodeAt(++e.position)):m=!1}d(e,"unexpected end of the stream within a flow collection")}function R(e,t){var n,a,o,s,u=J,p=!1,c=t,f=0,h=!1;if(s=e.input.charCodeAt(e.position),124===s)a=!1;else{if(62!==s)return!1;a=!0}var m=V.newScalar();for(e.kind="scalar",e.result=m,m.startPosition=e.position;0!==s;)if(s=e.input.charCodeAt(++e.position),43===s||45===s)J===u?u=43===s?Z:Q:d(e,"repeat of a chomping mode identifier");else{if(!((o=l(s))>=0))break;0===o?d(e,"bad explicit indentation width of a block scalar; it cannot be less than one"):p?d(e,"repeat of an indentation width identifier"):(c=t+o-1,p=!0)}if(i(s)){do s=e.input.charCodeAt(++e.position);while(i(s));if(35===s)do s=e.input.charCodeAt(++e.position);while(!r(s)&&0!==s)}for(;0!==s;){for(g(e),e.lineIndent=0,s=e.input.charCodeAt(e.position);(!p||e.lineIndent<c)&&32===s;)e.lineIndent++,s=e.input.charCodeAt(++e.position);if(!p&&e.lineIndent>c&&(c=e.lineIndent),r(s))f++;else{if(e.lineIndent<c){u===Z?m.value+=K.repeat("\n",f):u===J&&p&&(m.value+="\n");break}for(a?i(s)?(h=!0,m.value+=K.repeat("\n",f+1)):h?(h=!1,m.value+=K.repeat("\n",f+1)):0===f?p&&(m.value+=" "):m.value+=K.repeat("\n",f):p&&(m.value+=K.repeat("\n",f+1)),p=!0,f=0,n=e.position;!r(s)&&0!==s;)s=e.input.charCodeAt(++e.position);y(e,n,e.position,!1)}}m.endPosition=e.position;for(var v=e.position-1,A=!1;;){var E=e.input[v];if("\r"==E||"\n"==E){A&&v--;break}if(" "!=E&&"\t"!=E)break;v--}return m.endPosition=v,m.rawValue=e.input.substring(m.startPosition,m.endPosition),!0}function M(e,t){var n,r,i,o=e.tag,s=e.anchor,u=V.newItems(),l=!1;for(null!==e.anchor&&(u.anchorId=e.anchor,e.anchorMap[e.anchor]=u),u.startPosition=e.position,i=e.input.charCodeAt(e.position);0!==i&&45===i&&(r=e.input.charCodeAt(e.position+1),a(r));)if(l=!0,e.position++,E(e,!0,-1)&&e.lineIndent<=t)u.items.push(null),i=e.input.charCodeAt(e.position);else if(n=e.line,O(e,t,z,!1,!0),e.result&&(e.result.parent=u,u.items.push(e.result)),E(e,!0,-1),i=e.input.charCodeAt(e.position),(e.line===n||e.lineIndent>t)&&0!==i)d(e,"bad indentation of a sequence entry");else if(e.lineIndent<t)break;return u.endPosition=e.position,!!l&&(e.tag=o,e.anchor=s,e.kind="sequence",e.result=u,u.endPosition=e.position,!0)}function C(e,t,n){var o,s,u,l,p=e.tag,c=e.anchor,f=V.newMap(),h=null,m=null,y=null,g=!1,A=!1;for(f.startPosition=e.position,null!==e.anchor&&(f.anchorId=e.anchor,e.anchorMap[e.anchor]=f),l=e.input.charCodeAt(e.position);0!==l;){if(o=e.input.charCodeAt(e.position+1),u=e.line,63!==l&&58!==l||!a(o)){if(!O(e,n,X,!1,!0))break;if(e.line===u){for(l=e.input.charCodeAt(e.position);i(l);)l=e.input.charCodeAt(++e.position);if(58===l)l=e.input.charCodeAt(++e.position),a(l)||d(e,"a whitespace character is expected after the key-value separator within a block mapping"),g&&(v(e,f,h,m,null),h=m=y=null),A=!0,g=!1,s=!1,h=e.tag,m=e.result;else{if(e.position==e.lineStart&&_(e))break;if(!A)return e.tag=p,e.anchor=c,!0;d(e,"can not read an implicit mapping pair; a colon is missed")}}else{if(!A)return e.tag=p,e.anchor=c,!0;for(d(e,"can not read a block mapping entry; a multiline key may not be an implicit key");e.position>0;)if(l=e.input.charCodeAt(--e.position),r(l)){e.position++;break}}}else 63===l?(g&&(v(e,f,h,m,null),h=m=y=null),A=!0,g=!0,s=!0):g?(g=!1,s=!0):d(e,"incomplete explicit mapping pair; a key node is missed"),e.position+=1,l=o;if((e.line===u||e.lineIndent>t)&&(O(e,t,$,!0,s)&&(g?m=e.result:y=e.result),g||(v(e,f,h,m,y),h=m=y=null),E(e,!0,-1),l=e.input.charCodeAt(e.position)),e.lineIndent>t&&0!==l)d(e,"bad indentation of a mapping entry");else if(e.lineIndent<t)break}return g&&v(e,f,h,m,null),A&&(e.tag=p,e.anchor=c,e.kind="mapping",e.result=f),A}function w(e){var t,n,r,i,o=!1,s=!1;if(i=e.input.charCodeAt(e.position),33!==i)return!1;if(null!==e.tag&&d(e,"duplication of a tag property"),i=e.input.charCodeAt(++e.position),60===i?(o=!0,i=e.input.charCodeAt(++e.position)):33===i?(s=!0,n="!!",i=e.input.charCodeAt(++e.position)):n="!",t=e.position,o){do i=e.input.charCodeAt(++e.position);while(0!==i&&62!==i);e.position<e.length?(r=e.input.slice(t,e.position),i=e.input.charCodeAt(++e.position)):d(e,"unexpected end of the stream within a verbatim tag")}else{for(;0!==i&&!a(i);)33===i&&(s?d(e,"tag suffix cannot contain exclamation marks"):(n=e.input.slice(t-1,e.position+1),re.test(n)||d(e,"named tag handle cannot contain such characters"),s=!0,t=e.position+1)),i=e.input.charCodeAt(++e.position);r=e.input.slice(t,e.position),ne.test(r)&&d(e,"tag suffix cannot contain flow indicator characters")}return r&&!ie.test(r)&&d(e,"tag name cannot contain such characters: "+r),o?e.tag=r:q.call(e.tagMap,n)?e.tag=e.tagMap[n]+r:"!"===n?e.tag="!"+r:"!!"===n?e.tag="tag:yaml.org,2002:"+r:d(e,'undeclared tag handle "'+n+'"'),!0}function P(e){var t,n;if(n=e.input.charCodeAt(e.position),38!==n)return!1;for(null!==e.anchor&&d(e,"duplication of an anchor property"),n=e.input.charCodeAt(++e.position),t=e.position;0!==n&&!a(n)&&!o(n);)n=e.input.charCodeAt(++e.position);return e.position===t&&d(e,"name of an anchor node must contain at least one character"),e.anchor=e.input.slice(t,e.position),!0}function L(e){var t,n,r;e.length,e.input;if(r=e.input.charCodeAt(e.position),42!==r)return!1;for(r=e.input.charCodeAt(++e.position),t=e.position;0!==r&&!a(r)&&!o(r);)r=e.input.charCodeAt(++e.position);return e.position<=t&&(d(e,"name of an alias node must contain at least one character"),e.position=t+1),n=e.input.slice(t,e.position),e.anchorMap.hasOwnProperty(n)||(d(e,'unidentified alias "'+n+'"'),e.position<=t&&(e.position=t+1)),e.result=V.newAnchorRef(n,t,e.position,e.anchorMap[n]),E(e,!0,-1),!0}function O(e,t,n,r,i){var a,o,s,u,l,p,c,f,m=1,y=!1,v=!1;e.tag=null,e.anchor=null,e.kind=null,e.result=null,a=o=s=$===n||z===n,r&&E(e,!0,-1)&&(y=!0,e.lineIndent>t?m=1:e.lineIndent===t?m=0:e.lineIndent<t&&(m=-1));var g=e.position;e.position-e.lineStart;if(1===m)for(;w(e)||P(e);)E(e,!0,-1)?(y=!0,s=a,e.lineIndent>t?m=1:e.lineIndent===t?m=0:e.lineIndent<t&&(m=-1)):s=!1;if(s&&(s=y||i),1!==m&&$!==n||(c=G===n||X===n?t:t+1,f=e.position-e.lineStart,1===m?s&&(M(e,f)||C(e,f,c))||b(e,c)?v=!0:(o&&R(e,c)||N(e,c)||I(e,c)?v=!0:L(e)?(v=!0,null===e.tag&&null===e.anchor||d(e,"alias node should not have any properties")):S(e,c,G===n)&&(v=!0,null===e.tag&&(e.tag="?")),null!==e.anchor&&(e.anchorMap[e.anchor]=e.result,e.result.anchorId=e.anchor)):0===m&&(v=s&&M(e,f))),null!==e.tag&&"!"!==e.tag)if("!include"==e.tag)e.result||(e.result=V.newScalar(),e.result.startPosition=e.position,e.result.endPosition=e.position,d(e,"!include without value")),e.result.kind=V.Kind.INCLUDE_REF;else if("?"===e.tag)for(u=0,l=e.implicitTypes.length;u<l;u+=1){p=e.implicitTypes[u];var A=e.result.value;if(p.resolve(A)){e.result.valueObject=p.construct(e.result.value),e.tag=p.tag,null!==e.anchor&&(e.result.anchorId=e.anchor,e.anchorMap[e.anchor]=e.result);break}}else q.call(e.typeMap,e.tag)?(p=e.typeMap[e.tag],null!==e.result&&p.kind!==e.kind&&d(e,"unacceptable node kind for !<"+e.tag+'> tag; it should be "'+p.kind+'", not "'+e.kind+'"'),p.resolve(e.result)?(e.result=p.construct(e.result),null!==e.anchor&&(e.result.anchorId=e.anchor,e.anchorMap[e.anchor]=e.result)):d(e,"cannot resolve a node with !<"+e.tag+"> explicit tag")):h(e,g,"unknown tag <"+e.tag+">",!1,!0);return null!==e.tag||null!==e.anchor||v}function D(e){var t,n,o,s,u=e.position,l=!1;for(e.version=null,e.checkLineBreaks=e.legacy,e.tagMap={},e.anchorMap={};0!==(s=e.input.charCodeAt(e.position))&&(E(e,!0,-1),s=e.input.charCodeAt(e.position),!(e.lineIndent>0||37!==s));){for(l=!0,s=e.input.charCodeAt(++e.position),t=e.position;0!==s&&!a(s);)s=e.input.charCodeAt(++e.position);for(n=e.input.slice(t,e.position),o=[],n.length<1&&d(e,"directive name must not be less than one character in length");0!==s;){for(;i(s);)s=e.input.charCodeAt(++e.position);if(35===s){do s=e.input.charCodeAt(++e.position);while(0!==s&&!r(s));break}if(r(s))break;for(t=e.position;0!==s&&!a(s);)s=e.input.charCodeAt(++e.position);o.push(e.input.slice(t,e.position))}0!==s&&g(e),q.call(ce,n)?ce[n](e,n,o):(m(e,'unknown document directive "'+n+'"'),e.position++)}return E(e,!0,-1),0===e.lineIndent&&45===e.input.charCodeAt(e.position)&&45===e.input.charCodeAt(e.position+1)&&45===e.input.charCodeAt(e.position+2)?(e.position+=3,E(e,!0,-1)):l&&d(e,"directives end mark is expected"),O(e,e.lineIndent-1,$,!1,!0),E(e,!0,-1),e.checkLineBreaks&&te.test(e.input.slice(u,e.position))&&m(e,"non-ASCII line breaks are interpreted as content"),e.documents.push(e.result),e.position===e.lineStart&&_(e)?void(46===e.input.charCodeAt(e.position)&&(e.position+=3,E(e,!0,-1))):void(e.position<e.length-1&&d(e,"end of the stream or a document separator is expected"))}function U(e,t){e=String(e),t=t||{};var n=e.length;0!==n&&(10!==e.charCodeAt(n-1)&&13!==e.charCodeAt(n-1)&&(e+="\n"),65279===e.charCodeAt(0)&&(e=e.slice(1)));var r=new pe(e,t);for(ee.test(r.input)&&d(r,"the stream contains non-printable characters"),r.input+="\0";32===r.input.charCodeAt(r.position);)r.lineIndent+=1,r.position+=1;for(;r.position<r.length-1;){var i=r.position;if(D(r),r.position<=i)for(;r.position<r.length-1;r.position++){var a=r.input.charAt(r.position);if("\n"==a)break}}var o=r.documents,s=o.length;s>0&&(o[s-1].endPosition=n);for(var u=0,l=o;u<l.length;u++){var p=l[u];p.errors=r.errors,p.startPosition>p.endPosition&&(p.startPosition=p.endPosition)}return o}function x(e,t,n){void 0===n&&(n={});var r,i,a=U(e,n);for(r=0,i=a.length;r<i;r+=1)t(a[r])}function k(e,t){void 0===t&&(t={});var n=U(e,t);if(0!==n.length){if(1===n.length)return n[0];var r=new j("expected a single document in the stream, but found more");return r.mark=new W("","",0,0,0),r.mark.position=n[0].endPosition,n[0].errors.push(r),n[0]}}function F(e,t,n){void 0===n&&(n={}),x(e,t,K.extend({schema:H},n))}function B(e,t){return void 0===t&&(t={}),k(e,K.extend({schema:H},t))}Object.defineProperty(t,"__esModule",{value:!0});for(var V=n(23),K=n(24),j=n(25),W=n(26),H=n(27),Y=n(50),q=Object.prototype.hasOwnProperty,G=1,X=2,z=3,$=4,J=1,Q=2,Z=3,ee=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uD800-\uDFFF\uFFFE\uFFFF]/,te=/[\x85\u2028\u2029]/,ne=/[,\[\]\{\}]/,re=/^(?:!|!!|![a-z\-]+!)$/i,ie=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i,ae=new Array(256),oe=new Array(256),se=new Array(256),ue=new Array(256),le=0;le<256;le++)ue[le]=oe[le]=p(le),ae[le]=oe[le]?1:0,se[le]=1,ae[le]||(ue[le]="\\"+String.fromCharCode(le));var pe=function(){function e(e,t){this.errorMap={},this.errors=[],this.lines=[],this.input=e,this.filename=t.filename||null,this.schema=t.schema||Y,this.onWarning=t.onWarning||null,this.legacy=t.legacy||!1,this.allowAnyEscape=t.allowAnyEscape||!1,this.ignoreDuplicateKeys=t.ignoreDuplicateKeys||!1,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=e.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.documents=[]}return e}(),ce={YAML:function(e,t,n){var r,i,a;null!==e.version&&d(e,"duplication of %YAML directive"),1!==n.length&&d(e,"YAML directive accepts exactly one argument"),r=/^([0-9]+)\.([0-9]+)$/.exec(n[0]),null===r&&d(e,"ill-formed argument of the YAML directive"),i=parseInt(r[1],10),a=parseInt(r[2],10),1!==i&&d(e,"found incompatible YAML document (version 1.2 is required)"),e.version=n[0],e.checkLineBreaks=a<2,2!==a&&d(e,"found incompatible YAML document (version 1.2 is required)")},TAG:function(e,t,n){var r,i;2!==n.length&&d(e,"TAG directive accepts exactly two arguments"),r=n[0],i=n[1],re.test(r)||d(e,"ill-formed tag handle (first argument) of the TAG directive"),q.call(e.tagMap,r)&&d(e,'there is a previously declared suffix for "'+r+'" tag handle'),ie.test(i)||d(e,"ill-formed tag prefix (second argument) of the TAG directive"),e.tagMap[r]=i}};(function(){function e(){}return e})();t.loadAll=x,t.load=k,t.safeLoadAll=F,t.safeLoad=B,e.exports.loadAll=x,e.exports.load=k,e.exports.safeLoadAll=F,e.exports.safeLoad=B},function(e,t){"use strict";function n(e,t){var n=t?t.endPosition:e.endPosition+1,r={key:e,value:t,startPosition:e.startPosition,endPosition:n,kind:u.MAPPING,parent:null,errors:[]};return r}function r(e,t,n,r){return{errors:[],referencesAnchor:e,value:r,startPosition:t,endPosition:n,kind:u.ANCHOR_REF,parent:null}}function i(e){void 0===e&&(e="");var t={errors:[],startPosition:-1,endPosition:-1,value:""+e,kind:u.SCALAR,parent:null,doubleQuoted:!1,rawValue:""+e};return"string"!=typeof e&&(t.valueObject=e),t}function a(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:u.SEQ,parent:null}}function o(){return a()}function s(e){return{errors:[],startPosition:-1,endPosition:-1,mappings:e?e:[],kind:u.MAP,parent:null}}Object.defineProperty(t,"__esModule",{value:!0});var u;!function(e){e[e.SCALAR=0]="SCALAR",e[e.MAPPING=1]="MAPPING",e[e.MAP=2]="MAP",e[e.SEQ=3]="SEQ",e[e.ANCHOR_REF=4]="ANCHOR_REF",e[e.INCLUDE_REF=5]="INCLUDE_REF"}(u=t.Kind||(t.Kind={})),t.newMapping=n,t.newAnchorRef=r,t.newScalar=i,t.newItems=a,t.newSeq=o,t.newMap=s},function(e,t){"use strict";function n(e){return"undefined"==typeof e||null===e}function r(e){return"object"==typeof e&&null!==e}function i(e){return Array.isArray(e)?e:n(e)?[]:[e]}function a(e,t){var n,r,i,a;if(t)for(a=Object.keys(t),n=0,r=a.length;n<r;n+=1)i=a[n],e[i]=t[i];return e}function o(e,t){var n,r="";for(n=0;n<t;n+=1)r+=e;return r}function s(e){return 0===e&&Number.NEGATIVE_INFINITY===1/e}Object.defineProperty(t,"__esModule",{value:!0}),t.isNothing=n,t.isObject=r,t.toArray=i,t.extend=a,t.repeat=o,t.isNegativeZero=s},function(e,t){"use strict";var n=function(){function e(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1),this.name="YAMLException",this.reason=e,this.mark=t,this.message=this.toString(!1),this.isWarning=n}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.toString=function(e){void 0===e&&(e=!1);var t;return t="JS-YAML: "+(this.reason||"(unknown reason)"),!e&&this.mark&&(t+=" "+this.mark.toString()),t},e.CLASS_IDENTIFIER="yaml-ast-parser.YAMLException",e}();e.exports=n},function(e,t,n){"use strict";var r=n(24),i=function(){function e(e,t,n,r,i){this.name=e,this.buffer=t,this.position=n,this.line=r,this.column=i}return e.prototype.getSnippet=function(e,t){void 0===e&&(e=0),void 0===t&&(t=75);var n,i,a,o,s;if(!this.buffer)return null;for(e=e||4,t=t||75,n="",i=this.position;i>0&&-1==="\0\r\n\u2028\u2029".indexOf(this.buffer.charAt(i-1));)if(i-=1,this.position-i>t/2-1){n=" ... ",i+=5;break}for(a="",o=this.position;o<this.buffer.length&&-1==="\0\r\n\u2028\u2029".indexOf(this.buffer.charAt(o));)if(o+=1,o-this.position>t/2-1){a=" ... ",o-=5;break}return s=this.buffer.slice(i,o),r.repeat(" ",e)+n+s+a+"\n"+r.repeat(" ",e+this.position-i+n.length)+"^"},e.prototype.toString=function(e){void 0===e&&(e=!0);var t,n="";return this.name&&(n+='in "'+this.name+'" '),n+="at line "+(this.line+1)+", column "+(this.column+1),e||(t=this.getSnippet(),t&&(n+=":\n"+t)),n},e}();e.exports=i},function(e,t,n){"use strict";var r=n(28),i=new r.Schema({include:[n(30)],implicit:[n(40),n(41)],explicit:[n(42),n(47),n(48),n(49)]});e.exports=i},function(e,t,n){"use strict";function r(e,t,n){var i=[];return e.include.forEach(function(e){n=r(e,t,n)}),e[t].forEach(function(e){n.forEach(function(t,n){t.tag===e.tag&&i.push(n)}),n.push(e)}),n.filter(function(e,t){return-1===i.indexOf(t)})}function i(){function e(e){r[e.tag]=e}var t,n,r={};for(t=0,n=arguments.length;t<n;t+=1)arguments[t].forEach(e);return r}Object.defineProperty(t,"__esModule",{value:!0});var a=n(24),o=n(25),s=n(29),u=function(){function e(e){this.include=e.include||[],this.implicit=e.implicit||[],this.explicit=e.explicit||[],this.implicit.forEach(function(e){if(e.loadKind&&"scalar"!==e.loadKind)throw new o("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.")}),this.compiledImplicit=r(this,"implicit",[]),this.compiledExplicit=r(this,"explicit",[]),this.compiledTypeMap=i(this.compiledImplicit,this.compiledExplicit)}return e.DEFAULT=null,e.create=function(){var t,n;switch(arguments.length){case 1:t=e.DEFAULT,n=arguments[0];break;case 2:t=arguments[0],n=arguments[1];break;default:throw new o("Wrong number of arguments for Schema.create function")}if(t=a.toArray(t),n=a.toArray(n),!t.every(function(t){return t instanceof e}))throw new o("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");if(!n.every(function(e){return e instanceof s.Type}))throw new o("Specified list of YAML types (or a single Type object) contains a non-Type object.");return new e({include:t,explicit:n})},e}();t.Schema=u},function(e,t,n){"use strict";function r(e){var t={};return null!==e&&Object.keys(e).forEach(function(n){e[n].forEach(function(e){t[String(e)]=n})}),t}Object.defineProperty(t,"__esModule",{value:!0});var i=n(25),a=["kind","resolve","construct","instanceOf","predicate","represent","defaultStyle","styleAliases"],o=["scalar","sequence","mapping"],s=function(){function e(e,t){if(t=t||{},Object.keys(t).forEach(function(t){if(-1===a.indexOf(t))throw new i('Unknown option "'+t+'" is met in definition of "'+e+'" YAML type.')}),this.tag=e,this.kind=t.kind||null,this.resolve=t.resolve||function(){return!0},this.construct=t.construct||function(e){return e},this.instanceOf=t.instanceOf||null,this.predicate=t.predicate||null,this.represent=t.represent||null,this.defaultStyle=t.defaultStyle||null,this.styleAliases=r(t.styleAliases||null),-1===o.indexOf(this.kind))throw new i('Unknown kind "'+this.kind+'" is specified for "'+e+'" YAML type.')}return e}();t.Type=s},function(e,t,n){"use strict";var r=n(28);e.exports=new r.Schema({include:[n(31)]})},function(e,t,n){"use strict";var r=n(28);e.exports=new r.Schema({include:[n(32)],implicit:[n(36),n(37),n(38),n(39)]})},function(e,t,n){"use strict";var r=n(28);e.exports=new r.Schema({explicit:[n(33),n(34),n(35)]})},function(e,t,n){"use strict";var r=n(29);e.exports=new r.Type("tag:yaml.org,2002:str",{kind:"scalar",construct:function(e){return null!==e?e:""}})},function(e,t,n){"use strict";var r=n(29);e.exports=new r.Type("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(e){return null!==e?e:[]}})},function(e,t,n){"use strict";var r=n(29);e.exports=new r.Type("tag:yaml.org,2002:map",{kind:"mapping",construct:function(e){return null!==e?e:{}}})},function(e,t,n){"use strict";function r(e){if(null===e)return!0;var t=e.length;return 1===t&&"~"===e||4===t&&("null"===e||"Null"===e||"NULL"===e)}function i(){return null}function a(e){return null===e}var o=n(29);e.exports=new o.Type("tag:yaml.org,2002:null",{kind:"scalar",resolve:r,construct:i,predicate:a,represent:{canonical:function(){return"~"},lowercase:function(){return"null"},uppercase:function(){return"NULL"},camelcase:function(){return"Null"}},defaultStyle:"lowercase"})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;var t=e.length;return 4===t&&("true"===e||"True"===e||"TRUE"===e)||5===t&&("false"===e||"False"===e||"FALSE"===e)}function i(e){return"true"===e||"True"===e||"TRUE"===e}function a(e){return"[object Boolean]"===Object.prototype.toString.call(e)}var o=n(29);e.exports=new o.Type("tag:yaml.org,2002:bool",{kind:"scalar",resolve:r,construct:i,predicate:a,represent:{lowercase:function(e){return e?"true":"false"},uppercase:function(e){return e?"TRUE":"FALSE"},camelcase:function(e){return e?"True":"False"}},defaultStyle:"lowercase"})},function(e,t,n){"use strict";function r(e){return 48<=e&&e<=57||65<=e&&e<=70||97<=e&&e<=102}function i(e){return 48<=e&&e<=55}function a(e){return 48<=e&&e<=57}function o(e){if(null===e)return!1;var t,n=e.length,o=0,s=!1;if(!n)return!1;if(t=e[o],"-"!==t&&"+"!==t||(t=e[++o]),"0"===t){if(o+1===n)return!0;if(t=e[++o],"b"===t){for(o++;o<n;o++)if(t=e[o],"_"!==t){if("0"!==t&&"1"!==t)return!1;s=!0}return s}if("x"===t){for(o++;o<n;o++)if(t=e[o],"_"!==t){if(!r(e.charCodeAt(o)))return!1;s=!0}return s}for(;o<n;o++)if(t=e[o],"_"!==t){if(!i(e.charCodeAt(o)))return!1;s=!0}return s}for(;o<n;o++)if(t=e[o],"_"!==t){if(":"===t)break;if(!a(e.charCodeAt(o)))return!1;s=!0}return!!s&&(":"!==t||/^(:[0-5]?[0-9])+$/.test(e.slice(o)))}function s(e){var t,n,r=e,i=1,a=[];return r.indexOf("_")!==-1&&(r=r.replace(/_/g,"")),t=r[0],"-"!==t&&"+"!==t||("-"===t&&(i=-1),r=r.slice(1),t=r[0]),"0"===r?0:"0"===t?"b"===r[1]?i*parseInt(r.slice(2),2):"x"===r[1]?i*parseInt(r,16):i*parseInt(r,8):r.indexOf(":")!==-1?(r.split(":").forEach(function(e){a.unshift(parseInt(e,10))}),r=0,n=1,a.forEach(function(e){r+=e*n,n*=60}),i*r):i*parseInt(r,10)}function u(e){return"[object Number]"===Object.prototype.toString.call(e)&&0===e%1&&!l.isNegativeZero(e)}var l=n(24),p=n(29);e.exports=new p.Type("tag:yaml.org,2002:int",{kind:"scalar",resolve:o,construct:s,predicate:u,represent:{binary:function(e){return"0b"+e.toString(2)},octal:function(e){return"0"+e.toString(8)},decimal:function(e){return e.toString(10)},hexadecimal:function(e){return"0x"+e.toString(16).toUpperCase()}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;return!!l.test(e)}function i(e){var t,n,r,i;return t=e.replace(/_/g,"").toLowerCase(),n="-"===t[0]?-1:1,i=[],0<="+-".indexOf(t[0])&&(t=t.slice(1)),".inf"===t?1===n?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:".nan"===t?NaN:0<=t.indexOf(":")?(t.split(":").forEach(function(e){i.unshift(parseFloat(e,10))}),t=0,r=1,i.forEach(function(e){t+=e*r,r*=60}),n*t):n*parseFloat(t,10)}function a(e,t){if(isNaN(e))switch(t){case"lowercase":return".nan";case"uppercase":return".NAN";case"camelcase":return".NaN"}else if(Number.POSITIVE_INFINITY===e)switch(t){case"lowercase":return".inf";case"uppercase":return".INF";case"camelcase":return".Inf"}else if(Number.NEGATIVE_INFINITY===e)switch(t){case"lowercase":return"-.inf";case"uppercase":return"-.INF";case"camelcase":return"-.Inf"}else if(s.isNegativeZero(e))return"-0.0";return e.toString(10)}function o(e){return"[object Number]"===Object.prototype.toString.call(e)&&(0!==e%1||s.isNegativeZero(e))}var s=n(24),u=n(29),l=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");e.exports=new u.Type("tag:yaml.org,2002:float",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a,defaultStyle:"lowercase"})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;var t;return t=s.exec(e),null!==t}function i(e){var t,n,r,i,a,o,u,l,p,c,f=0,h=null;if(t=s.exec(e),null===t)throw new Error("Date resolve error");if(n=+t[1],r=+t[2]-1,i=+t[3],!t[4])return new Date(Date.UTC(n,r,i));if(a=+t[4],o=+t[5],u=+t[6],t[7]){for(f=t[7].slice(0,3);f.length<3;)f+="0";f=+f}return t[9]&&(l=+t[10],p=+(t[11]||0),h=6e4*(60*l+p),"-"===t[9]&&(h=-h)),c=new Date(Date.UTC(n,r,i,a,o,u,f)),h&&c.setTime(c.getTime()-h),c}function a(e){return e.toISOString()}var o=n(29),s=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");e.exports=new o.Type("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:r,construct:i,instanceOf:Date,represent:a})},function(e,t,n){"use strict";function r(e){return"<<"===e||null===e}var i=n(29);e.exports=new i.Type("tag:yaml.org,2002:merge",{kind:"scalar",resolve:r})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;var t,n,r=0,i=e.length,a=l;for(n=0;n<i;n++)if(t=a.indexOf(e.charAt(n)),!(t>64)){if(t<0)return!1;r+=6}return r%8===0}function i(e){var t,n,r=e.replace(/[\r\n=]/g,""),i=r.length,a=l,o=0,u=[];for(t=0;t<i;t++)t%4===0&&t&&(u.push(o>>16&255),u.push(o>>8&255),u.push(255&o)),o=o<<6|a.indexOf(r.charAt(t));return n=i%4*6,0===n?(u.push(o>>16&255),u.push(o>>8&255),u.push(255&o)):18===n?(u.push(o>>10&255),u.push(o>>2&255)):12===n&&u.push(o>>4&255),s?new s(u):u}function a(e){var t,n,r="",i=0,a=e.length,o=l;for(t=0;t<a;t++)t%3===0&&t&&(r+=o[i>>18&63],r+=o[i>>12&63],r+=o[i>>6&63],r+=o[63&i]),i=(i<<8)+e[t];return n=a%3,0===n?(r+=o[i>>18&63],r+=o[i>>12&63],r+=o[i>>6&63],r+=o[63&i]):2===n?(r+=o[i>>10&63],r+=o[i>>4&63],r+=o[i<<2&63],r+=o[64]):1===n&&(r+=o[i>>2&63],r+=o[i<<4&63],r+=o[64],r+=o[64]),r}function o(e){return s&&s.isBuffer(e)}var s=n(43).Buffer,u=n(29),l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";e.exports=new u.Type("tag:yaml.org,2002:binary",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a})},function(e,t,n){(function(e){/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */
"use strict";function r(){try{var e=new Uint8Array(1);return e.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===e.foo()&&"function"==typeof e.subarray&&0===e.subarray(1,1).byteLength}catch(e){return!1}}function i(){return o.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function a(e,t){if(i()<t)throw new RangeError("Invalid typed array length");return o.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t),e.__proto__=o.prototype):(null===e&&(e=new o(t)),e.length=t),e}function o(e,t,n){if(!(o.TYPED_ARRAY_SUPPORT||this instanceof o))return new o(e,t,n);if("number"==typeof e){if("string"==typeof t)throw new Error("If encoding is specified then the first argument must be a string");return p(this,e)}return s(this,e,t,n)}function s(e,t,n,r){if("number"==typeof t)throw new TypeError('"value" argument must not be a number');return"undefined"!=typeof ArrayBuffer&&t instanceof ArrayBuffer?h(e,t,n,r):"string"==typeof t?c(e,t,n):d(e,t)}function u(e){if("number"!=typeof e)throw new TypeError('"size" argument must be a number');if(e<0)throw new RangeError('"size" argument must not be negative')}function l(e,t,n,r){return u(t),t<=0?a(e,t):void 0!==n?"string"==typeof r?a(e,t).fill(n,r):a(e,t).fill(n):a(e,t)}function p(e,t){if(u(t),e=a(e,t<0?0:0|m(t)),!o.TYPED_ARRAY_SUPPORT)for(var n=0;n<t;++n)e[n]=0;return e}function c(e,t,n){if("string"==typeof n&&""!==n||(n="utf8"),!o.isEncoding(n))throw new TypeError('"encoding" must be a valid string encoding');var r=0|v(t,n);e=a(e,r);var i=e.write(t,n);return i!==r&&(e=e.slice(0,i)),e}function f(e,t){var n=t.length<0?0:0|m(t.length);e=a(e,n);for(var r=0;r<n;r+=1)e[r]=255&t[r];return e}function h(e,t,n,r){if(t.byteLength,n<0||t.byteLength<n)throw new RangeError("'offset' is out of bounds");if(t.byteLength<n+(r||0))throw new RangeError("'length' is out of bounds");return t=void 0===n&&void 0===r?new Uint8Array(t):void 0===r?new Uint8Array(t,n):new Uint8Array(t,n,r),o.TYPED_ARRAY_SUPPORT?(e=t,e.__proto__=o.prototype):e=f(e,t),e}function d(e,t){if(o.isBuffer(t)){var n=0|m(t.length);return e=a(e,n),0===e.length?e:(t.copy(e,0,0,n),e)}if(t){if("undefined"!=typeof ArrayBuffer&&t.buffer instanceof ArrayBuffer||"length"in t)return"number"!=typeof t.length||$(t.length)?a(e,0):f(e,t);if("Buffer"===t.type&&Z(t.data))return f(e,t.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}function m(e){if(e>=i())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+i().toString(16)+" bytes");return 0|e}function y(e){return+e!=e&&(e=0),o.alloc(+e)}function v(e,t){if(o.isBuffer(e))return e.length;if("undefined"!=typeof ArrayBuffer&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer))return e.byteLength;"string"!=typeof e&&(e=""+e);var n=e.length;if(0===n)return 0;for(var r=!1;;)switch(t){case"ascii":case"latin1":case"binary":return n;case"utf8":case"utf-8":case void 0:return Y(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*n;case"hex":return n>>>1;case"base64":return X(e).length;default:if(r)return Y(e).length;t=(""+t).toLowerCase(),r=!0}}function g(e,t,n){var r=!1;if((void 0===t||t<0)&&(t=0),t>this.length)return"";if((void 0===n||n>this.length)&&(n=this.length),n<=0)return"";if(n>>>=0,t>>>=0,n<=t)return"";for(e||(e="utf8");;)switch(e){case"hex":return O(this,t,n);case"utf8":case"utf-8":return C(this,t,n);case"ascii":return P(this,t,n);case"latin1":case"binary":return L(this,t,n);case"base64":return M(this,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return D(this,t,n);default:if(r)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),r=!0}}function A(e,t,n){var r=e[t];e[t]=e[n],e[n]=r}function E(e,t,n,r,i){if(0===e.length)return-1;if("string"==typeof n?(r=n,n=0):n>2147483647?n=2147483647:n<-2147483648&&(n=-2147483648),n=+n,isNaN(n)&&(n=i?0:e.length-1),n<0&&(n=e.length+n),n>=e.length){if(i)return-1;n=e.length-1}else if(n<0){if(!i)return-1;n=0}if("string"==typeof t&&(t=o.from(t,r)),o.isBuffer(t))return 0===t.length?-1:_(e,t,n,r,i);if("number"==typeof t)return t&=255,o.TYPED_ARRAY_SUPPORT&&"function"==typeof Uint8Array.prototype.indexOf?i?Uint8Array.prototype.indexOf.call(e,t,n):Uint8Array.prototype.lastIndexOf.call(e,t,n):_(e,[t],n,r,i);throw new TypeError("val must be string, number or Buffer")}function _(e,t,n,r,i){function a(e,t){return 1===o?e[t]:e.readUInt16BE(t*o)}var o=1,s=e.length,u=t.length;if(void 0!==r&&(r=String(r).toLowerCase(),"ucs2"===r||"ucs-2"===r||"utf16le"===r||"utf-16le"===r)){if(e.length<2||t.length<2)return-1;o=2,s/=2,u/=2,n/=2}var l;if(i){var p=-1;for(l=n;l<s;l++)if(a(e,l)===a(t,p===-1?0:l-p)){if(p===-1&&(p=l),l-p+1===u)return p*o}else p!==-1&&(l-=l-p),p=-1}else for(n+u>s&&(n=s-u),l=n;l>=0;l--){for(var c=!0,f=0;f<u;f++)if(a(e,l+f)!==a(t,f)){c=!1;break}if(c)return l}return-1}function T(e,t,n,r){n=Number(n)||0;var i=e.length-n;r?(r=Number(r),r>i&&(r=i)):r=i;var a=t.length;if(a%2!==0)throw new TypeError("Invalid hex string");r>a/2&&(r=a/2);for(var o=0;o<r;++o){var s=parseInt(t.substr(2*o,2),16);if(isNaN(s))return o;e[n+o]=s}return o}function S(e,t,n,r){return z(Y(t,e.length-n),e,n,r)}function N(e,t,n,r){return z(q(t),e,n,r)}function I(e,t,n,r){return N(e,t,n,r)}function b(e,t,n,r){return z(X(t),e,n,r)}function R(e,t,n,r){return z(G(t,e.length-n),e,n,r)}function M(e,t,n){return 0===t&&n===e.length?J.fromByteArray(e):J.fromByteArray(e.slice(t,n))}function C(e,t,n){n=Math.min(e.length,n);for(var r=[],i=t;i<n;){var a=e[i],o=null,s=a>239?4:a>223?3:a>191?2:1;if(i+s<=n){var u,l,p,c;switch(s){case 1:a<128&&(o=a);break;case 2:u=e[i+1],128===(192&u)&&(c=(31&a)<<6|63&u,c>127&&(o=c));break;case 3:u=e[i+1],l=e[i+2],128===(192&u)&&128===(192&l)&&(c=(15&a)<<12|(63&u)<<6|63&l,c>2047&&(c<55296||c>57343)&&(o=c));break;case 4:u=e[i+1],l=e[i+2],p=e[i+3],128===(192&u)&&128===(192&l)&&128===(192&p)&&(c=(15&a)<<18|(63&u)<<12|(63&l)<<6|63&p,c>65535&&c<1114112&&(o=c))}}null===o?(o=65533,s=1):o>65535&&(o-=65536,r.push(o>>>10&1023|55296),o=56320|1023&o),r.push(o),i+=s}return w(r)}function w(e){var t=e.length;if(t<=ee)return String.fromCharCode.apply(String,e);for(var n="",r=0;r<t;)n+=String.fromCharCode.apply(String,e.slice(r,r+=ee));return n}function P(e,t,n){var r="";n=Math.min(e.length,n);for(var i=t;i<n;++i)r+=String.fromCharCode(127&e[i]);return r}function L(e,t,n){var r="";n=Math.min(e.length,n);for(var i=t;i<n;++i)r+=String.fromCharCode(e[i]);return r}function O(e,t,n){var r=e.length;(!t||t<0)&&(t=0),(!n||n<0||n>r)&&(n=r);for(var i="",a=t;a<n;++a)i+=H(e[a]);return i}function D(e,t,n){for(var r=e.slice(t,n),i="",a=0;a<r.length;a+=2)i+=String.fromCharCode(r[a]+256*r[a+1]);return i}function U(e,t,n){if(e%1!==0||e<0)throw new RangeError("offset is not uint");if(e+t>n)throw new RangeError("Trying to access beyond buffer length")}function x(e,t,n,r,i,a){if(!o.isBuffer(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>i||t<a)throw new RangeError('"value" argument is out of bounds');if(n+r>e.length)throw new RangeError("Index out of range")}function k(e,t,n,r){t<0&&(t=65535+t+1);for(var i=0,a=Math.min(e.length-n,2);i<a;++i)e[n+i]=(t&255<<8*(r?i:1-i))>>>8*(r?i:1-i)}function F(e,t,n,r){t<0&&(t=4294967295+t+1);for(var i=0,a=Math.min(e.length-n,4);i<a;++i)e[n+i]=t>>>8*(r?i:3-i)&255}function B(e,t,n,r,i,a){if(n+r>e.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("Index out of range")}function V(e,t,n,r,i){return i||B(e,t,n,4,3.4028234663852886e38,-3.4028234663852886e38),Q.write(e,t,n,r,23,4),n+4}function K(e,t,n,r,i){return i||B(e,t,n,8,1.7976931348623157e308,-1.7976931348623157e308),Q.write(e,t,n,r,52,8),n+8}function j(e){if(e=W(e).replace(te,""),e.length<2)return"";for(;e.length%4!==0;)e+="=";return e}function W(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function H(e){return e<16?"0"+e.toString(16):e.toString(16)}function Y(e,t){t=t||1/0;for(var n,r=e.length,i=null,a=[],o=0;o<r;++o){if(n=e.charCodeAt(o),n>55295&&n<57344){if(!i){if(n>56319){(t-=3)>-1&&a.push(239,191,189);continue}if(o+1===r){(t-=3)>-1&&a.push(239,191,189);continue}i=n;continue}if(n<56320){(t-=3)>-1&&a.push(239,191,189),i=n;continue}n=(i-55296<<10|n-56320)+65536}else i&&(t-=3)>-1&&a.push(239,191,189);if(i=null,n<128){if((t-=1)<0)break;a.push(n)}else if(n<2048){if((t-=2)<0)break;a.push(n>>6|192,63&n|128)}else if(n<65536){if((t-=3)<0)break;a.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(n<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;a.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return a}function q(e){for(var t=[],n=0;n<e.length;++n)t.push(255&e.charCodeAt(n));return t}function G(e,t){for(var n,r,i,a=[],o=0;o<e.length&&!((t-=2)<0);++o)n=e.charCodeAt(o),r=n>>8,i=n%256,a.push(i),a.push(r);return a}function X(e){return J.toByteArray(j(e))}function z(e,t,n,r){for(var i=0;i<r&&!(i+n>=t.length||i>=e.length);++i)t[i+n]=e[i];return i}function $(e){return e!==e}var J=n(44),Q=n(45),Z=n(46);t.Buffer=o,t.SlowBuffer=y,t.INSPECT_MAX_BYTES=50,o.TYPED_ARRAY_SUPPORT=void 0!==e.TYPED_ARRAY_SUPPORT?e.TYPED_ARRAY_SUPPORT:r(),t.kMaxLength=i(),o.poolSize=8192,o._augment=function(e){return e.__proto__=o.prototype,e},o.from=function(e,t,n){return s(null,e,t,n)},o.TYPED_ARRAY_SUPPORT&&(o.prototype.__proto__=Uint8Array.prototype,o.__proto__=Uint8Array,"undefined"!=typeof Symbol&&Symbol.species&&o[Symbol.species]===o&&Object.defineProperty(o,Symbol.species,{value:null,configurable:!0})),o.alloc=function(e,t,n){return l(null,e,t,n)},o.allocUnsafe=function(e){return p(null,e)},o.allocUnsafeSlow=function(e){return p(null,e)},o.isBuffer=function(e){return!(null==e||!e._isBuffer)},o.compare=function(e,t){if(!o.isBuffer(e)||!o.isBuffer(t))throw new TypeError("Arguments must be Buffers");if(e===t)return 0;for(var n=e.length,r=t.length,i=0,a=Math.min(n,r);i<a;++i)if(e[i]!==t[i]){n=e[i],r=t[i];break}return n<r?-1:r<n?1:0},o.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},o.concat=function(e,t){if(!Z(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return o.alloc(0);var n;if(void 0===t)for(t=0,n=0;n<e.length;++n)t+=e[n].length;var r=o.allocUnsafe(t),i=0;for(n=0;n<e.length;++n){var a=e[n];if(!o.isBuffer(a))throw new TypeError('"list" argument must be an Array of Buffers');a.copy(r,i),i+=a.length}return r},o.byteLength=v,o.prototype._isBuffer=!0,o.prototype.swap16=function(){var e=this.length;if(e%2!==0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var t=0;t<e;t+=2)A(this,t,t+1);return this},o.prototype.swap32=function(){var e=this.length;if(e%4!==0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var t=0;t<e;t+=4)A(this,t,t+3),A(this,t+1,t+2);return this},o.prototype.swap64=function(){var e=this.length;if(e%8!==0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var t=0;t<e;t+=8)A(this,t,t+7),A(this,t+1,t+6),A(this,t+2,t+5),A(this,t+3,t+4);return this},o.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?C(this,0,e):g.apply(this,arguments)},o.prototype.equals=function(e){if(!o.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e||0===o.compare(this,e)},o.prototype.inspect=function(){var e="",n=t.INSPECT_MAX_BYTES;return this.length>0&&(e=this.toString("hex",0,n).match(/.{2}/g).join(" "),this.length>n&&(e+=" ... ")),"<Buffer "+e+">"},o.prototype.compare=function(e,t,n,r,i){if(!o.isBuffer(e))throw new TypeError("Argument must be a Buffer");if(void 0===t&&(t=0),void 0===n&&(n=e?e.length:0),void 0===r&&(r=0),void 0===i&&(i=this.length),t<0||n>e.length||r<0||i>this.length)throw new RangeError("out of range index");if(r>=i&&t>=n)return 0;if(r>=i)return-1;if(t>=n)return 1;if(t>>>=0,n>>>=0,r>>>=0,i>>>=0,this===e)return 0;for(var a=i-r,s=n-t,u=Math.min(a,s),l=this.slice(r,i),p=e.slice(t,n),c=0;c<u;++c)if(l[c]!==p[c]){a=l[c],s=p[c];break}return a<s?-1:s<a?1:0},o.prototype.includes=function(e,t,n){return this.indexOf(e,t,n)!==-1},o.prototype.indexOf=function(e,t,n){return E(this,e,t,n,!0)},o.prototype.lastIndexOf=function(e,t,n){return E(this,e,t,n,!1)},o.prototype.write=function(e,t,n,r){if(void 0===t)r="utf8",n=this.length,t=0;else if(void 0===n&&"string"==typeof t)r=t,n=this.length,t=0;else{if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t|=0,isFinite(n)?(n|=0,void 0===r&&(r="utf8")):(r=n,n=void 0)}var i=this.length-t;if((void 0===n||n>i)&&(n=i),e.length>0&&(n<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");r||(r="utf8");for(var a=!1;;)switch(r){case"hex":return T(this,e,t,n);case"utf8":case"utf-8":return S(this,e,t,n);case"ascii":return N(this,e,t,n);case"latin1":case"binary":return I(this,e,t,n);case"base64":return b(this,e,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return R(this,e,t,n);default:if(a)throw new TypeError("Unknown encoding: "+r);r=(""+r).toLowerCase(),a=!0}},o.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var ee=4096;o.prototype.slice=function(e,t){var n=this.length;e=~~e,t=void 0===t?n:~~t,e<0?(e+=n,e<0&&(e=0)):e>n&&(e=n),t<0?(t+=n,t<0&&(t=0)):t>n&&(t=n),t<e&&(t=e);var r;if(o.TYPED_ARRAY_SUPPORT)r=this.subarray(e,t),r.__proto__=o.prototype;else{var i=t-e;r=new o(i,void 0);for(var a=0;a<i;++a)r[a]=this[a+e]}return r},o.prototype.readUIntLE=function(e,t,n){e|=0,t|=0,n||U(e,t,this.length);for(var r=this[e],i=1,a=0;++a<t&&(i*=256);)r+=this[e+a]*i;return r},o.prototype.readUIntBE=function(e,t,n){e|=0,t|=0,n||U(e,t,this.length);for(var r=this[e+--t],i=1;t>0&&(i*=256);)r+=this[e+--t]*i;return r},o.prototype.readUInt8=function(e,t){return t||U(e,1,this.length),this[e]},o.prototype.readUInt16LE=function(e,t){return t||U(e,2,this.length),this[e]|this[e+1]<<8},o.prototype.readUInt16BE=function(e,t){return t||U(e,2,this.length),this[e]<<8|this[e+1]},o.prototype.readUInt32LE=function(e,t){return t||U(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},o.prototype.readUInt32BE=function(e,t){return t||U(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},o.prototype.readIntLE=function(e,t,n){e|=0,t|=0,n||U(e,t,this.length);for(var r=this[e],i=1,a=0;++a<t&&(i*=256);)r+=this[e+a]*i;return i*=128,r>=i&&(r-=Math.pow(2,8*t)),r},o.prototype.readIntBE=function(e,t,n){e|=0,t|=0,n||U(e,t,this.length);for(var r=t,i=1,a=this[e+--r];r>0&&(i*=256);)a+=this[e+--r]*i;return i*=128,a>=i&&(a-=Math.pow(2,8*t)),a},o.prototype.readInt8=function(e,t){return t||U(e,1,this.length),128&this[e]?(255-this[e]+1)*-1:this[e]},o.prototype.readInt16LE=function(e,t){t||U(e,2,this.length);var n=this[e]|this[e+1]<<8;return 32768&n?4294901760|n:n},o.prototype.readInt16BE=function(e,t){t||U(e,2,this.length);var n=this[e+1]|this[e]<<8;return 32768&n?4294901760|n:n},o.prototype.readInt32LE=function(e,t){return t||U(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},o.prototype.readInt32BE=function(e,t){return t||U(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},o.prototype.readFloatLE=function(e,t){return t||U(e,4,this.length),Q.read(this,e,!0,23,4)},o.prototype.readFloatBE=function(e,t){return t||U(e,4,this.length),Q.read(this,e,!1,23,4)},o.prototype.readDoubleLE=function(e,t){return t||U(e,8,this.length),Q.read(this,e,!0,52,8)},o.prototype.readDoubleBE=function(e,t){return t||U(e,8,this.length),Q.read(this,e,!1,52,8)},o.prototype.writeUIntLE=function(e,t,n,r){if(e=+e,t|=0,n|=0,!r){var i=Math.pow(2,8*n)-1;x(this,e,t,n,i,0)}var a=1,o=0;for(this[t]=255&e;++o<n&&(a*=256);)this[t+o]=e/a&255;return t+n},o.prototype.writeUIntBE=function(e,t,n,r){if(e=+e,t|=0,n|=0,!r){var i=Math.pow(2,8*n)-1;x(this,e,t,n,i,0)}var a=n-1,o=1;for(this[t+a]=255&e;--a>=0&&(o*=256);)this[t+a]=e/o&255;return t+n},o.prototype.writeUInt8=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,1,255,0),o.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[t]=255&e,t+1},o.prototype.writeUInt16LE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,2,65535,0),o.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):k(this,e,t,!0),t+2},o.prototype.writeUInt16BE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,2,65535,0),o.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):k(this,e,t,!1),t+2},o.prototype.writeUInt32LE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,4,4294967295,0),o.TYPED_ARRAY_SUPPORT?(this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e):F(this,e,t,!0),t+4},o.prototype.writeUInt32BE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,4,4294967295,0),o.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):F(this,e,t,!1),t+4},o.prototype.writeIntLE=function(e,t,n,r){if(e=+e,t|=0,!r){var i=Math.pow(2,8*n-1);x(this,e,t,n,i-1,-i)}var a=0,o=1,s=0;for(this[t]=255&e;++a<n&&(o*=256);)e<0&&0===s&&0!==this[t+a-1]&&(s=1),this[t+a]=(e/o>>0)-s&255;return t+n},o.prototype.writeIntBE=function(e,t,n,r){if(e=+e,t|=0,!r){var i=Math.pow(2,8*n-1);x(this,e,t,n,i-1,-i)}var a=n-1,o=1,s=0;for(this[t+a]=255&e;--a>=0&&(o*=256);)e<0&&0===s&&0!==this[t+a+1]&&(s=1),this[t+a]=(e/o>>0)-s&255;return t+n},o.prototype.writeInt8=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,1,127,-128),o.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),e<0&&(e=255+e+1),this[t]=255&e,t+1},o.prototype.writeInt16LE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,2,32767,-32768),o.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):k(this,e,t,!0),t+2},o.prototype.writeInt16BE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,2,32767,-32768),o.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):k(this,e,t,!1),t+2},o.prototype.writeInt32LE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,4,2147483647,-2147483648),o.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24):F(this,e,t,!0),t+4},o.prototype.writeInt32BE=function(e,t,n){return e=+e,t|=0,n||x(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),o.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):F(this,e,t,!1),t+4},o.prototype.writeFloatLE=function(e,t,n){return V(this,e,t,!0,n)},o.prototype.writeFloatBE=function(e,t,n){return V(this,e,t,!1,n)},o.prototype.writeDoubleLE=function(e,t,n){return K(this,e,t,!0,n)},o.prototype.writeDoubleBE=function(e,t,n){return K(this,e,t,!1,n)},o.prototype.copy=function(e,t,n,r){if(n||(n=0),r||0===r||(r=this.length),t>=e.length&&(t=e.length),t||(t=0),r>0&&r<n&&(r=n),r===n)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("sourceStart out of bounds");if(r<0)throw new RangeError("sourceEnd out of bounds");r>this.length&&(r=this.length),e.length-t<r-n&&(r=e.length-t+n);var i,a=r-n;if(this===e&&n<t&&t<r)for(i=a-1;i>=0;--i)e[i+t]=this[i+n];else if(a<1e3||!o.TYPED_ARRAY_SUPPORT)for(i=0;i<a;++i)e[i+t]=this[i+n];else Uint8Array.prototype.set.call(e,this.subarray(n,n+a),t);return a},o.prototype.fill=function(e,t,n,r){if("string"==typeof e){if("string"==typeof t?(r=t,t=0,n=this.length):"string"==typeof n&&(r=n,n=this.length),1===e.length){var i=e.charCodeAt(0);i<256&&(e=i)}if(void 0!==r&&"string"!=typeof r)throw new TypeError("encoding must be a string");if("string"==typeof r&&!o.isEncoding(r))throw new TypeError("Unknown encoding: "+r)}else"number"==typeof e&&(e&=255);if(t<0||this.length<t||this.length<n)throw new RangeError("Out of range index");if(n<=t)return this;t>>>=0,n=void 0===n?this.length:n>>>0,e||(e=0);var a;if("number"==typeof e)for(a=t;a<n;++a)this[a]=e;else{var s=o.isBuffer(e)?e:Y(new o(e,r).toString()),u=s.length;for(a=0;a<n-t;++a)this[a+t]=s[a%u]}return this};var te=/[^+\/0-9A-Za-z-_]/g}).call(t,function(){return this}())},function(e,t){"use strict";function n(e){var t=e.length;if(t%4>0)throw new Error("Invalid string. Length must be a multiple of 4");return"="===e[t-2]?2:"="===e[t-1]?1:0}function r(e){return 3*e.length/4-n(e)}function i(e){var t,r,i,a,o,s=e.length;a=n(e),o=new p(3*s/4-a),r=a>0?s-4:s;var u=0;for(t=0;t<r;t+=4)i=l[e.charCodeAt(t)]<<18|l[e.charCodeAt(t+1)]<<12|l[e.charCodeAt(t+2)]<<6|l[e.charCodeAt(t+3)],o[u++]=i>>16&255,o[u++]=i>>8&255,o[u++]=255&i;return 2===a?(i=l[e.charCodeAt(t)]<<2|l[e.charCodeAt(t+1)]>>4,o[u++]=255&i):1===a&&(i=l[e.charCodeAt(t)]<<10|l[e.charCodeAt(t+1)]<<4|l[e.charCodeAt(t+2)]>>2,o[u++]=i>>8&255,o[u++]=255&i),o}function a(e){return u[e>>18&63]+u[e>>12&63]+u[e>>6&63]+u[63&e]}function o(e,t,n){for(var r,i=[],o=t;o<n;o+=3)r=(e[o]<<16)+(e[o+1]<<8)+e[o+2],i.push(a(r));return i.join("")}function s(e){for(var t,n=e.length,r=n%3,i="",a=[],s=16383,l=0,p=n-r;l<p;l+=s)a.push(o(e,l,l+s>p?p:l+s));return 1===r?(t=e[n-1],i+=u[t>>2],i+=u[t<<4&63],i+="=="):2===r&&(t=(e[n-2]<<8)+e[n-1],i+=u[t>>10],i+=u[t>>4&63],i+=u[t<<2&63],i+="="),a.push(i),a.join("")}t.byteLength=r,t.toByteArray=i,t.fromByteArray=s;for(var u=[],l=[],p="undefined"!=typeof Uint8Array?Uint8Array:Array,c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f=0,h=c.length;f<h;++f)u[f]=c[f],l[c.charCodeAt(f)]=f;l["-".charCodeAt(0)]=62,l["_".charCodeAt(0)]=63},function(e,t){t.read=function(e,t,n,r,i){var a,o,s=8*i-r-1,u=(1<<s)-1,l=u>>1,p=-7,c=n?i-1:0,f=n?-1:1,h=e[t+c];for(c+=f,a=h&(1<<-p)-1,h>>=-p,p+=s;p>0;a=256*a+e[t+c],c+=f,p-=8);for(o=a&(1<<-p)-1,a>>=-p,p+=r;p>0;o=256*o+e[t+c],c+=f,p-=8);if(0===a)a=1-l;else{if(a===u)return o?NaN:(h?-1:1)*(1/0);o+=Math.pow(2,r),a-=l}return(h?-1:1)*o*Math.pow(2,a-r)},t.write=function(e,t,n,r,i,a){var o,s,u,l=8*a-i-1,p=(1<<l)-1,c=p>>1,f=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,h=r?0:a-1,d=r?1:-1,m=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,o=p):(o=Math.floor(Math.log(t)/Math.LN2),t*(u=Math.pow(2,-o))<1&&(o--,u*=2),t+=o+c>=1?f/u:f*Math.pow(2,1-c),t*u>=2&&(o++,u/=2),o+c>=p?(s=0,o=p):o+c>=1?(s=(t*u-1)*Math.pow(2,i),o+=c):(s=t*Math.pow(2,c-1)*Math.pow(2,i),o=0));i>=8;e[n+h]=255&s,h+=d,s/=256,i-=8);for(o=o<<i|s,l+=i;l>0;e[n+h]=255&o,h+=d,o/=256,l-=8);e[n+h-d]|=128*m}},function(e,t){var n={}.toString;e.exports=Array.isArray||function(e){return"[object Array]"==n.call(e)}},function(e,t,n){"use strict";function r(e){if(null===e)return!0;var t,n,r,i,a,u=[],l=e;for(t=0,n=l.length;t<n;t+=1){if(r=l[t],a=!1,"[object Object]"!==s.call(r))return!1;for(i in r)if(o.call(r,i)){if(a)return!1;a=!0}if(!a)return!1;if(-1!==u.indexOf(i))return!1;u.push(i)}return!0}function i(e){return null!==e?e:[]}var a=n(29),o=Object.prototype.hasOwnProperty,s=Object.prototype.toString;e.exports=new a.Type("tag:yaml.org,2002:omap",{kind:"sequence",resolve:r,construct:i})},function(e,t,n){"use strict";function r(e){if(null===e)return!0;if(e.kind!=o.Kind.SEQ)return!1;var t,n,r,i=e.items;for(t=0,n=i.length;t<n;t+=1){if(r=i[t],"[object Object]"!==s.call(r))return!1;if(!Array.isArray(r.mappings))return!1;if(1!==r.mappings.length)return!1}return!0}function i(e){if(null===e||!Array.isArray(e.items))return[];var t,n,r,i=e.items;for(r=o.newItems(),r.parent=e.parent,r.startPosition=e.startPosition,r.endPosition=e.endPosition,t=0,n=i.length;t<n;t+=1){var a=i[t],s=a.mappings[0],u=o.newItems();u.parent=r,u.startPosition=s.key.startPosition,u.endPosition=s.value.startPosition,s.key.parent=u,s.value.parent=u,u.items=[s.key,s.value],r.items.push(u)}return r}var a=n(29),o=n(23),s=Object.prototype.toString;e.exports=new a.Type("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:r,construct:i})},function(e,t,n){"use strict";function r(e){return null===e||e.kind==o.Kind.MAP}function i(e){return null!==e?e:{}}var a=n(29),o=n(23);Object.prototype.hasOwnProperty;e.exports=new a.Type("tag:yaml.org,2002:set",{kind:"mapping",resolve:r,construct:i})},function(e,t,n){"use strict";var r=n(28),i=new r.Schema({include:[n(27)],explicit:[n(51),n(52)]});r.Schema.DEFAULT=i,e.exports=i},function(e,t,n){"use strict";function r(){return!0}function i(){}function a(){return""}function o(e){return"undefined"==typeof e}var s=n(29);e.exports=new s.Type("tag:yaml.org,2002:js/undefined",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;if(0===e.length)return!1;var t=e,n=/\/([gim]*)$/.exec(e),r="";if("/"===t[0]){if(n&&(r=n[1]),r.length>3)return!1;if("/"!==t[t.length-r.length-1])return!1;t=t.slice(1,t.length-r.length-1)}try{new RegExp(t,r);return!0}catch(e){return!1}}function i(e){var t=e,n=/\/([gim]*)$/.exec(e),r="";return"/"===t[0]&&(n&&(r=n[1]),t=t.slice(1,t.length-r.length-1)),new RegExp(t,r)}function a(e){var t="/"+e.source+"/";return e.global&&(t+="g"),e.multiline&&(t+="m"),e.ignoreCase&&(t+="i"),t}function o(e){return"[object RegExp]"===Object.prototype.toString.call(e)}var s=n(29);e.exports=new s.Type("tag:yaml.org,2002:js/regexp",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a})},function(e,t,n){"use strict";function r(e,t){var n,r,i,a,o,s,u;if(null===t)return{};for(n={},r=Object.keys(t),i=0,a=r.length;i<a;i+=1)o=r[i],s=String(t[o]),"!!"===o.slice(0,2)&&(o="tag:yaml.org,2002:"+o.slice(2)),u=e.compiledTypeMap[o],u&&w.call(u.styleAliases,s)&&(s=u.styleAliases[s]),n[o]=s;return n}function i(e){var t,n,r;if(t=e.toString(16).toUpperCase(),e<=255)n="x",r=2;else if(e<=65535)n="u",r=4;else{if(!(e<=4294967295))throw new b("code point within a string may not be greater than 0xFFFFFFFF");n="U",r=8}return"\\"+n+I.repeat("0",r-t.length)+t}function a(e){this.schema=e.schema||R,this.indent=Math.max(1,e.indent||2),this.skipInvalid=e.skipInvalid||!1,this.flowLevel=I.isNothing(e.flowLevel)?-1:e.flowLevel,this.styleMap=r(this.schema,e.styles||null),this.implicitTypes=this.schema.compiledImplicit,this.explicitTypes=this.schema.compiledExplicit,this.tag=null,this.result="",this.duplicates=[],this.usedDuplicates=null}function o(e,t){for(var n,r=I.repeat(" ",t),i=0,a=-1,o="",s=e.length;i<s;)a=e.indexOf("\n",i),a===-1?(n=e.slice(i),i=s):(n=e.slice(i,a+1),i=a+1),n.length&&"\n"!==n&&(o+=r),o+=n;return o}function s(e,t){return"\n"+I.repeat(" ",e.indent*t)}function u(e,t){var n,r,i;for(n=0,r=e.implicitTypes.length;n<r;n+=1)if(i=e.implicitTypes[n],i.resolve(t))return!0;return!1}function l(e){this.source=e,this.result="",this.checkpoint=0}function p(e,t,n){var r,i,a,s,p,f,m,y,v,g,A,E,_,T,S,N,I,b,R,M,C;if(0===t.length)return void(e.dump="''");if(0==t.indexOf("!include"))return void(e.dump=""+t);if(0==t.indexOf("!$$$novalue"))return void(e.dump="");if(-1!==te.indexOf(t))return void(e.dump="'"+t+"'");for(r=!0,i=t.length?t.charCodeAt(0):0,a=D===i||D===t.charCodeAt(t.length-1),W!==i&&q!==i&&G!==i&&$!==i||(r=!1),a?(r=!1,s=!1,p=!1):(s=!0,p=!0),f=!0,m=new l(t),y=!1,v=0,g=0,A=e.indent*n,E=80,A<40?E-=A:E=40,T=0;T<t.length;T++){if(_=t.charCodeAt(T),r){if(h(_))continue;r=!1}f&&_===V&&(f=!1),S=ee[_],N=d(_),(S||N)&&(_!==L&&_!==x&&_!==V?(s=!1,p=!1):_===L&&(y=!0,f=!1,T>0&&(I=t.charCodeAt(T-1),I===D&&(p=!1,s=!1)),s&&(b=T-v,v=T,b>g&&(g=b))),_!==x&&(f=!1),m.takeUpTo(T),m.escapeChar())}if(r&&u(e,t)&&(r=!1),R="",(s||p)&&(M=0,t.charCodeAt(t.length-1)===L&&(M+=1,t.charCodeAt(t.length-2)===L&&(M+=1)),0===M?R="-":2===M&&(R="+")),p&&g<E&&(s=!1),y||(p=!1),r)e.dump=t;else if(f)e.dump="'"+t+"'";else if(s)C=c(t,E),e.dump=">"+R+"\n"+o(C,A);else if(p)R||(t=t.replace(/\n$/,"")),e.dump="|"+R+"\n"+o(t,A);else{if(!m)throw new Error("Failed to dump scalar value");m.finish(),e.dump='"'+m.result+'"'}}function c(e,t){var n,r="",i=0,a=e.length,o=/\n+$/.exec(e);for(o&&(a=o.index+1);i<a;)n=e.indexOf("\n",i),n>a||n===-1?(r&&(r+="\n\n"),r+=f(e.slice(i,a),t),i=a):(r&&(r+="\n\n"),r+=f(e.slice(i,n),t),i=n+1);return o&&"\n"!==o[0]&&(r+=o[0]),r}function f(e,t){if(""===e)return e;for(var n,r,i,a=/[^\s] [^\s]/g,o="",s=0,u=0,l=a.exec(e);l;)n=l.index,n-u>t&&(r=s!==u?s:n,o&&(o+="\n"),i=e.slice(u,r),o+=i,u=r+1),s=n+1,l=a.exec(e);return o&&(o+="\n"),o+=u!==s&&e.length-u>t?e.slice(u,s)+"\n"+e.slice(s+1):e.slice(u)}function h(e){return P!==e&&L!==e&&O!==e&&j!==e&&X!==e&&z!==e&&J!==e&&Z!==e&&k!==e&&B!==e&&K!==e&&U!==e&&Q!==e&&Y!==e&&V!==e&&x!==e&&F!==e&&H!==e&&!ee[e]&&!d(e)}function d(e){return!(32<=e&&e<=126||133===e||160<=e&&e<=55295||57344<=e&&e<=65533||65536<=e&&e<=1114111)}function m(e,t,n){var r,i,a="",o=e.tag;for(r=0,i=n.length;r<i;r+=1)E(e,t,n[r],!1,!1)&&(0!==r&&(a+=", "),a+=e.dump);e.tag=o,e.dump="["+a+"]"}function y(e,t,n,r){var i,a,o="",u=e.tag;for(i=0,a=n.length;i<a;i+=1)E(e,t+1,n[i],!0,!0)&&(r&&0===i||(o+=s(e,t)),o+="- "+e.dump);e.tag=u,e.dump=o||"[]"}function v(e,t,n){var r,i,a,o,s,u="",l=e.tag,p=Object.keys(n);for(r=0,i=p.length;r<i;r+=1)s="",0!==r&&(s+=", "),a=p[r],o=n[a],E(e,t,a,!1,!1)&&(e.dump.length>1024&&(s+="? "),s+=e.dump+": ",E(e,t,o,!1,!1)&&(s+=e.dump,u+=s));e.tag=l,e.dump="{"+u+"}"}function g(e,t,n,r){var i,a,o,u,l,p,c="",f=e.tag,h=Object.keys(n);for(i=0,a=h.length;i<a;i+=1)p="",r&&0===i||(p+=s(e,t)),o=h[i],u=n[o],E(e,t+1,o,!0,!0)&&(l=null!==e.tag&&"?"!==e.tag||e.dump&&e.dump.length>1024,l&&(p+=e.dump&&L===e.dump.charCodeAt(0)?"?":"? "),p+=e.dump,l&&(p+=s(e,t)),E(e,t+1,u,!0,l)&&(p+=e.dump&&L===e.dump.charCodeAt(0)?":":": ",p+=e.dump,c+=p));e.tag=f,e.dump=c||"{}"}function A(e,t,n){var r,i,a,o,s,u;for(i=n?e.explicitTypes:e.implicitTypes,a=0,o=i.length;a<o;a+=1)if(s=i[a],(s.instanceOf||s.predicate)&&(!s.instanceOf||"object"==typeof t&&t instanceof s.instanceOf)&&(!s.predicate||s.predicate(t))){if(e.tag=n?s.tag:"?",s.represent){if(u=e.styleMap[s.tag]||s.defaultStyle,"[object Function]"===C.call(s.represent))r=s.represent(t,u);else{if(!w.call(s.represent,u))throw new b("!<"+s.tag+'> tag resolver accepts not "'+u+'" style');r=s.represent[u](t,u)}e.dump=r}return!0}return!1}function E(e,t,n,r,i){e.tag=null,e.dump=n,A(e,n,!1)||A(e,n,!0);var a=C.call(e.dump);r&&(r=0>e.flowLevel||e.flowLevel>t),(null!==e.tag&&"?"!==e.tag||2!==e.indent&&t>0)&&(i=!1);var o,s,u="[object Object]"===a||"[object Array]"===a;if(u&&(o=e.duplicates.indexOf(n),s=o!==-1),s&&e.usedDuplicates[o])e.dump="*ref_"+o;else{if(u&&s&&!e.usedDuplicates[o]&&(e.usedDuplicates[o]=!0),"[object Object]"===a)r&&0!==Object.keys(e.dump).length?(g(e,t,e.dump,i),s&&(e.dump="&ref_"+o+(0===t?"\n":"")+e.dump)):(v(e,t,e.dump),s&&(e.dump="&ref_"+o+" "+e.dump));else if("[object Array]"===a)r&&0!==e.dump.length?(y(e,t,e.dump,i),s&&(e.dump="&ref_"+o+(0===t?"\n":"")+e.dump)):(m(e,t,e.dump),s&&(e.dump="&ref_"+o+" "+e.dump));else{if("[object String]"!==a){if(e.skipInvalid)return!1;throw new b("unacceptable kind of an object to dump "+a)}"?"!==e.tag&&p(e,e.dump,t)}null!==e.tag&&"?"!==e.tag&&(e.dump="!<"+e.tag+"> "+e.dump)}return!0}function _(e,t){var n,r,i=[],a=[];for(T(e,i,a),n=0,r=a.length;n<r;n+=1)t.duplicates.push(i[a[n]]);t.usedDuplicates=new Array(r)}function T(e,t,n){var r,i,a;C.call(e);if(null!==e&&"object"==typeof e)if(i=t.indexOf(e),-1!==i)-1===n.indexOf(i)&&n.push(i);else if(t.push(e),Array.isArray(e))for(i=0,a=e.length;i<a;i+=1)T(e[i],t,n);else for(r=Object.keys(e),i=0,a=r.length;i<a;i+=1)T(e[r[i]],t,n)}function S(e,t){t=t||{};var n=new a(t);return _(e,n),E(n,0,e,!0,!0)?n.dump+"\n":""}function N(e,t){return S(e,I.extend({schema:M},t))}Object.defineProperty(t,"__esModule",{value:!0});var I=n(24),b=n(25),R=n(50),M=n(27),C=Object.prototype.toString,w=Object.prototype.hasOwnProperty,P=9,L=10,O=13,D=32,U=33,x=34,k=35,F=37,B=38,V=39,K=42,j=44,W=45,H=58,Y=62,q=63,G=64,X=91,z=93,$=96,J=123,Q=124,Z=125,ee={};ee[0]="\\0",ee[7]="\\a",ee[8]="\\b",ee[9]="\\t",ee[10]="\\n",ee[11]="\\v",ee[12]="\\f",ee[13]="\\r",ee[27]="\\e",ee[34]='\\"',ee[92]="\\\\",ee[133]="\\N",ee[160]="\\_",ee[8232]="\\L",ee[8233]="\\P";var te=["y","Y","yes","Yes","YES","on","On","ON","n","N","no","No","NO","off","Off","OFF"];l.prototype.takeUpTo=function(e){var t;if(e<this.checkpoint)throw t=new Error("position should be > checkpoint"),t.position=e,t.checkpoint=this.checkpoint,t;return this.result+=this.source.slice(this.checkpoint,e),this.checkpoint=e,this},l.prototype.escapeChar=function(){var e,t;return e=this.source.charCodeAt(this.checkpoint),t=ee[e]||i(e),this.result+=t,this.checkpoint+=1,
this},l.prototype.finish=function(){this.source.length>this.checkpoint&&this.takeUpTo(this.source.length)},t.dump=S,t.safeDump=N},function(e,t){"use strict";function n(e){if(["true","True","TRUE"].lastIndexOf(e)>=0)return!0;if(["false","False","FALSE"].lastIndexOf(e)>=0)return!1;throw'Invalid boolean "'+e+'"'}function r(e){return 0===e.lastIndexOf("0o",0)?parseInt(e.substring(2),8):parseInt(e)}function i(e){var t=r(e);if(isNaN(t))throw'Invalid integer "'+e+'"';return t}function a(e){if([".nan",".NaN",".NAN"].lastIndexOf(e)>=0)return NaN;var t=/^([-+])?(?:\.inf|\.Inf|\.INF)$/,n=t.exec(e);if(n)return"-"===n[1]?-(1/0):1/0;var r=parseFloat(e);if(!isNaN(r))return r;throw'Invalid float "'+e+'"'}function o(e){if(void 0===e)return s.null;if(e.doubleQuoted||!e.plainScalar||e.singleQuoted)return s.string;var t=e.value;if(["null","Null","NULL","~",""].indexOf(t)>=0)return s.null;if(null===t||void 0===t)return s.null;if(["true","True","TRUE","false","False","FALSE"].indexOf(t)>=0)return s.bool;var n=/^[-+]?[0-9]+$/,r=/^0o[0-7]+$/,i=/^0x[0-9a-fA-F]+$/;if(n.test(t)||r.test(t)||i.test(t))return s.int;var a=/^[-+]?(\.[0-9]+|[0-9]+(\.[0-9]*)?)([eE][-+]?[0-9]+)?$/,o=/^[-+]?(\.inf|\.Inf|\.INF)$/;return a.test(t)||o.test(t)||[".nan",".NaN",".NAN"].indexOf(t)>=0?s.float:s.string}Object.defineProperty(t,"__esModule",{value:!0}),t.parseYamlBoolean=n,t.parseYamlInteger=i,t.parseYamlFloat=a;var s;!function(e){e[e.null=0]="null",e[e.bool=1]="bool",e[e.int=2]="int",e[e.float=3]="float",e[e.string=4]="string"}(s=t.ScalarType||(t.ScalarType={})),t.determineScalarType=o},function(e,t,n){"use strict";function r(e,t){var n=e.name();if(D.LowLevelProxyNode.isInstance(t.lowLevel())){if(D.LowLevelProxyNode.isInstance(e.lowLevel()))return n;var r=t.root().lowLevel().unit(),i=r.project().namespaceResolver(),a=e.lowLevel().unit(),o=i.resolveNamespace(t.lowLevel().unit(),a);if(null!=o){var s=o.namespace();if(null!=s)return s+"."+n}}if(e.lowLevel().unit()!=t.lowLevel().unit())for(var u=t;;){if(u.lowLevel().includePath()||null==u.parent()){u.unitMap||(u.unitMap={},u.asElement().elements().forEach(function(e){if(e.definition().key()==j.Universe10.UsesDeclaration){var t=e.attr("value");if(t){var n=M(e)?e.lowLevel().unit():e.root().lowLevel().unit(),r=n.resolve(t.value());if(null!=r){var i=e.attr("key");i&&(u.unitMap[r.absolutePath()]=i.value())}}}}));var l=u.unitMap[e.lowLevel().unit().absolutePath()];if(l)return l+"."+n}if(!u.parent())break;u=u.parent()}return n}function i(e){var t=e;return t&&t.valueName&&t.toHighLevel&&t.toHighLevel2}function a(e){var t=e.property();if(!t)return!1;var n=e.parent(),r=n&&n.definition();if(!r)return!1;if("RAML08"==r.universe().version()){if(J.isStringTypeDeclarationDescendant(r)&&(J.isExampleProperty(t)||J.isDefaultValue(t)||J.isEnumProperty(t)))return!0}else if(J.isTypeOrSchemaProperty(t)&&J.isTypeDeclarationDescendant(r))return!1;return!!J.isStringTypeType(t.range())}function o(e){var t=e;return t&&t.isString&&t.isFromKey&&t.isEmbedded}function s(e){var t=q.newMap([q.newMapping(q.newScalar("example"),e.lowLevel().actual())]),n=q.newMapping(q.newScalar("types"),q.newMap([q.newMapping(q.newScalar("__AUX_TYPE__"),t)])),r=q.newMap([n]),i=new W.ASTNode(r,e.lowLevel().unit(),null,null,null),a=Z.parseFromAST(new pe(i,e)),o=Z.toNominal(a.types()[0],function(e){return null});return o}function u(e){if(!e.trim().startsWith("#%RAML 1.0"))return null;var t=l(e),n=t&&t.length>2&&t[2]||"Api";return"API"==n?n="Api":"NamedExample"==n?n="ExampleSpec":"DataType"==n?n="TypeDeclaration":"SecurityScheme"==n?n="AbstractSecurityScheme":"AnnotationTypeDeclaration"==n&&(n="TypeDeclaration"),n}function l(e){return e.match(/^\s*#%RAML\s+(\d\.\d)\s*(\w*)\s*$/m)}function p(e){var t=e.lowLevel()&&e.lowLevel().unit()&&e.lowLevel().unit().contents();return null==t?null:he(t,e.lowLevel()).ptype}function c(e){if(null==e)return null;var t=e.contents(),n=e.ast(),r=he(t,n),i=r.ptype,a=r.localUniverse,o=a.type(i);o||(o=a.type("Api"));var s=new fe(n,null,o,null);s.setUniverse(a);var u=o&&o.universe();return u&&"RAML10"==u.version()?o.isAssignableFrom(U.universesInfo.Universe10.LibraryBase.name)||s.children():s.children(),s}function f(e,t){if(t){var n=t.root().lowLevel().unit();return n?new re.PointOfViewValidationAcceptorImpl(e,t.root()):{accept:function(t){e.push(t)},begin:function(){},end:function(){},acceptUnique:function(t){for(var n=0,r=e;n<r.length;n++){var i=r[n];if(i.start==t.start&&i.message==t.message)return}this.accept(t)}}}}function h(e){if(null!=e.parent())return!1;var t=e.lowLevel().unit();if(null==t)return!1;var n=t.contents(),r=l(n);return!(r.length<3)&&"AnnotationTypeDeclaration"==r[2]}function d(e,t,n){var r=e.validationIssue;if(!r){var i=e.issueCode||t,a=e.node||n,o=e.message||B.createIssue1(ie.PLUGIN_REPORTS_AN_ERROR,{pluginId:t},a,!1).message,s=e.isWarning;r=B.createIssue(i,o,a,s)}return r}function m(e){for(var t=[],n=P.getNodeValidationPlugins(),r=0,i=n;r<i.length;r++){var a=i[r],o=a.process(e);o&&o.forEach(function(n){var r=d(n,a.id(),e);t.push(r)})}return t}function y(e){for(var t=new de(e),n=[],r=P.getNodeAnnotationValidationPlugins(),i=0,a=r;i<a.length;i++){var o=a[i],s=o.process(t);s&&s.forEach(function(t){var r=d(t,o.id(),e);n.push(r)})}return n}function v(e,t){var n=e.map(function(e){return A(e,t)}),r=g(n);return r}function g(e){var t=[],n={};e.map(function(e){n[JSON.stringify(e)]=e});for(var r=Object.keys(n),i=0;i<r.length;i++)t.push(n[r[i]]);return t}function A(e,t){var n=e.node&&e.node.lowLevel()&&e.node.lowLevel().unit().lineMapper()||t.lowLevel().unit().lineMapper(),r=null;try{r=n.position(e.start)}catch(e){console.warn(e)}var i=null;try{i=n.position(e.end)}catch(e){console.warn(e)}var a;a=e.path?e.path:e.node?e.node.lowLevel().unit().path():k.declRoot(t).lowLevel().unit().path();var o={code:e.code,message:e.message,path:a,range:{start:r,end:i},isWarning:e.isWarning};return e.extras&&e.extras.length>0&&(o.trace=e.extras.map(function(e){return A(e,t)})),o}function E(e){if(e.kind()==q.Kind.SCALAR)return void(T(e.value())&&e.addMeta("skipValidation",!0));var t=e.childWithKey(U.universesInfo.Universe10.TypeDeclaration.properties.type.name),n=e.childWithKey(U.universesInfo.Universe10.TypeDeclaration.properties.schema.name),r=[];t&&(t.kind()==q.Kind.SEQ?r=r.concat(t.children()):r.push(t)),n&&(n&&n.kind()==q.Kind.SEQ?r=r.concat(n.children()):r.push(n));for(var i=!1,a=0,o=r;a<o.length;a++){var s=o[a];if(s.kind()==q.Kind.SCALAR){var u=s.value();i=i||T(u)}else s.kind()!=q.Kind.MAP&&s.kind()!=q.Kind.MAPPING||E(s)}for(var l=0,p=e.children();l<p.length;l++){var c=p[l],f=c.key();T(f)?c.addMeta("skipValidation",!0):"string"==typeof c.value()?T(c.value())&&c.addMeta("skipValidation",!0):f&&f.length>0&&"("==f.charAt(0)&&")"==f.charAt(f.length-1)&&S(c.node())&&c.addMeta("skipValidation",!0)}i&&e.addMeta("skipValidation",!0);var h=e.childWithKey(U.universesInfo.Universe10.ObjectTypeDeclaration.properties.properties.name);_(h);var d=e.childWithKey(U.universesInfo.Universe10.TypeDeclaration.properties.facets.name);_(d);var m=e.childWithKey(U.universesInfo.Universe10.ArrayTypeDeclaration.properties.items.name);if(m)if(m.kind()==q.Kind.SCALAR)T(m.value())&&m.addMeta("skipValidation",!0);else if(m.kind()==q.Kind.MAP||m.kind()==q.Kind.MAPPING)for(var y=0,v=m.children();y<v.length;y++){var g=v[y];E(g)}}function _(e){if(e)for(var t=0,n=e.children();t<n.length;t++){var r=n[t];E(r)}}function T(e){if("string"==typeof e){var t=e.indexOf("<<");if(t>=0&&e.indexOf(">>",t)>0)return!0}return!1}function S(e){var t=e.value();if("string"==typeof t&&t.indexOf("<<")!=-1)return!0;for(var n=e.children(),r=0;r<n.length;r++)if(S(n[r]))return!0;return!1}function N(e,t){void 0===t&&(t=!1);var n,r=e.lowLevel(),i=r.unit().absolutePath(),a=I(r);if(r.kind()!=q.Kind.INCLUDE_REF&&r.valueKind()!=q.Kind.INCLUDE_REF||a.absolutePath()!=i||!r.includePath()){if(a.isRAMLUnit()&&a.ast()){var o=a.ast().includePath();o&&(n=o)}}else n=r.includePath();if(n||(n=a.absolutePath()),t&&i==n)return null;if(!L.isWebPath(n)){var s=a.project().getRootPath();n=ee.relative(s,n).replace(/\\/g,"/")}return n}function I(e){for(var t=e.unit(),n=t;e.kind()==q.Kind.INCLUDE_REF||e.valueKind()==q.Kind.INCLUDE_REF;){var r=e.includePath(),i=n.resolve(r);if(!i)break;if(n=i,!n.isRAMLUnit())break;e=n.ast()}return n}function b(e,t){var n=null;try{var r=JSON.parse(t);if(r&&"object"==typeof r&&1==Object.keys(r).length&&r.hasOwnProperty("$ref")){var i=r.$ref;if("string"==typeof i){var a=i.indexOf("#");if(a>=0){var o=i.substring(0,a),s=i.substring(a);if(s.length>1){var u=e.lowLevel().unit().resolve(o);if(u){var l=u.contents(),p=JSON.parse(l),c=te.create(s),f=c.resolve(p,function(){return null});Array.isArray(f)&&f.length&&(n=JSON.stringify(f[0],null,2))}}}}}}catch(e){}return n}function R(e,t){if(!e.id()||e.id()!=t.id()){for(var n=0,r=e.types();n<r.length;n++){var i=r[n];t.getType(i.name())||t.add(i)}for(var a=0,o=e.annotationTypes();a<o.length;a++){var i=o[a];t.getType(i.name())||t.addAnnotationType(i)}for(var s=e.libraries(),u=0,l=Object.keys(s);u<l.length;u++){var p=l[u],c=s[p],f=t.library(p);f?R(c,f):t.addLibrary(p,c)}}}function M(e){var t=e.lowLevel().unit(),n=t.contents();if(!n.trim().startsWith("#%RAML"))return!1;var r=u(n),i=e.isElement()?e.asElement():e.parent(),a=i.definition().universe().type(r);return null==a||!J.isLibraryBaseSibling(a)}var C=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var w=n(56),P=n(198),L=n(5),O=n(16),D=n(199),U=w,x=n(208),k=n(209),F=n(216),B=n(19),V=n(217),K=n(247),j=n(204),W=n(4),H=n(248),Y=U,q=n(21),G=n(249),X=n(255),z=n(250),$=n(257),J=n(205),Q=n(212),Z=w.rt,ee=n(6),te=n(260),ne=n(262),re=n(263),ie=n(207);t.qName=r;var ae=function(){function e(e,t){this._node=e,this._parent=t,this._implicit=!1,this.values={},e&&e.setHighLevelParseResult(this)}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&O.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.getKind=function(){return P.NodeKind.BASIC},e.prototype.asAttr=function(){return null},e.prototype.asElement=function(){return null},e.prototype.hashkey=function(){return this._hashkey||(this._hashkey=this.parent()?this.parent().hashkey()+"/"+this.name():this.name()),this._hashkey},e.prototype.root=function(){return this.parent()?this.parent().root():this},e.prototype.version=function(){return""},e.prototype.getLowLevelStart=function(){return this.lowLevel().kind()===W.Kind.SCALAR?this.lowLevel().start():this.lowLevel().keyStart()},e.prototype.getLowLevelEnd=function(){return this.lowLevel().kind()===W.Kind.SCALAR?this.lowLevel().end():this.lowLevel().keyEnd()},e.prototype.isSameNode=function(e){return!(!e||e.lowLevel().actual()!=this.lowLevel().actual())},e.prototype.checkContextValue=function(e,t,n){var r=this.computedValue(e);return!(!r||r.indexOf(t)==-1)||(t==r||"false"==t)},e.prototype.printDetails=function(e){return(e?e:"")+"Unkown\n"},e.prototype.testSerialize=function(e){return(e?e:"")+"Unkown\n"},e.prototype.errors=function(){var e=[],t=f(e,this);return this.validate(t),e},e.prototype.markCh=function(){for(var e=this.lowLevel();D.LowLevelProxyNode.isInstance(e);)e=e.originalNode();return e=e._node?e._node:e,!!e.markCh||void(e.markCh=1)},e.prototype.unmarkCh=function(){for(var e=this.lowLevel();D.LowLevelProxyNode.isInstance(e);)e=e.originalNode();e=e._node?e._node:e,delete e.markCh},e.prototype.validate=function(e){B.validate(this,e);for(var t=0,n=m(this);t<n.length;t++){var r=n[t];e.accept(r)}for(var i=0,a=y(this);i<a.length;i++){var r=a[i];e.accept(r)}},e.prototype.allowRecursive=function(){return!1},e.prototype.setComputed=function(e,t){this.values[e]=t},e.prototype.setValueSource=function(e){this._valueSource=e},e.prototype.computedValue=function(e){var t=this.values[e];if(!t){if(this.parent())return this.parent().computedValue(e);if(this._valueSource)return this._valueSource.computedValue(e);if(this.isElement()){var n=this.asElement().getMaster();if(n)return n.computedValue(e)}}return t},e.prototype.lowLevel=function(){return this._node},e.prototype.name=function(){var e=this.lowLevel().key();return e?e:""},e.prototype.optional=function(){var e=this.lowLevel(),t=e.optional();if(null!=e.key())return t;var n=this.property();if(!n||!n.isMultiValue())return t;for(var r=e.parent();r&&null==r.highLevelNode();){if(r.kind()==q.Kind.MAPPING)return r.optional();r=r.parent()}return t},e.prototype.parent=function(){return this._parent},e.prototype.setParent=function(e){this._parent=e},e.prototype.isElement=function(){return!1},e.prototype.directChildren=function(){return this.children()},e.prototype.children=function(){return[]},e.prototype.isAttached=function(){return null!=this.parent()},e.prototype.isImplicit=function(){return this._implicit},e.prototype.isAttr=function(){return!1},e.prototype.isUnknown=function(){return!0},e.prototype.id=function(){var e=this;if(this.cachedId)return this.cachedId;if(this._parent){var t=this.parent().id();t+="."+this.name();var n=this.parent().directChildren().filter(function(t){return t.name()==e.name()});if(n.length>1){var r=n.indexOf(this);t+="["+r+"]"}return this.cachedId=t,t}return this.cachedId="",this.cachedId},e.prototype.localId=function(){return this.name()},e.prototype.resetIDs=function(){this.cachedId=null,this.cachedFullId=null},e.prototype.fullLocalId=function(){var e=this;if(this.cachedFullId)return this.cachedFullId;if(this._parent){var t=".";t+=null!=this.property()&&J.isAnnotationsProperty(this.property())?this.lowLevel().key():this.name();var n=this.parent().directChildren().filter(function(t){return t.name()==e.name()});if(n.length>1){var r=n.indexOf(this);t+="["+r+"]"}return this.cachedFullId=t,t}return this.cachedFullId=this.localId(),this.cachedFullId},e.prototype.property=function(){return null},e.prototype.reuseMode=function(){return this._reuseMode},e.prototype.setReuseMode=function(e){this._reuseMode=e},e.prototype.isReused=function(){return this._isReused},e.prototype.setReused=function(e){this._isReused=e,this.children().forEach(function(t){return t.setReused(e)})},e.prototype.setJSON=function(e){this._jsonCache=e},e.prototype.getJSON=function(){return this._jsonCache},e.CLASS_IDENTIFIER="highLevelImpl.BasicASTNode",e}();t.BasicASTNode=ae;var oe=function(){function e(e,t,n,r){void 0===r&&(r=null),this.node=e,this._parent=t,this.kv=r,this._pr=n}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&O.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.valueName=function(){var e=null;return this.kv&&(e=this.kv),e=this.node.key(),this._pr&&this._pr.isAnnotation()&&e&&"("==e.charAt(0)&&(e=e.substring(1,e.length-1)),e},e.prototype.children=function(){return this.node.children().map(function(t){return new e(t,null,null)})},e.prototype.lowLevel=function(){return this.node},e.prototype.toHighLevel=function(e){if(!e&&this._parent&&(e=this._parent),this._hl)return this._hl;var t=this.valueName(),n=e;if(D.LowLevelProxyNode.isInstance(this.node)){var i=this.node.definingUnitSequence(),a=i&&i[0]&&i[0].highLevel().asElement(),o=a&&a.lowLevel().unit().absolutePath();o==e.lowLevel().unit().absolutePath()?a=e:o==e.root().lowLevel().unit().absolutePath()&&(a=e.root()),n=a||n}var s=k.referenceTargets(this._pr,n).filter(function(e){return r(e,n)==t});if(s&&s[0]){var u=s[0].localType(),l=new fe(this.node,e,u,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(e){l.setComputed(e.name,e.value)}),this._hl=l,l}return null},e.prototype.toHighLevel2=function(e){!e&&this._parent&&(e=this._parent);var t=this.valueName(),n=k.referenceTargets(this._pr,e).filter(function(n){return r(n,e)==t});if(n&&n[0]){var i=n[0].localType(),a=new fe(this.node,e,i,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(e){a.setComputed(e.name,e.value)}),a}if(this._pr.range()){var a=new fe(this.node.parent(),e,this._pr.range(),this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(e){a.setComputed(e.name,e.value)}),a}return null},e.prototype.resetHighLevelNode=function(){this._hl=null},e.CLASS_IDENTIFIER="highLevelImpl.StructuredValue",e}();t.StructuredValue=oe,t.isStructuredValue=i;var se=function(e){function t(t,n,r,i,a){void 0===a&&(a=!1);var o=e.call(this,t,n)||this;return o._def=r,o._prop=i,o.fromKey=a,o}return C(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&O.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ASTPropImpl)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_ASTPropImpl)},t.prototype.definition=function(){return this._def},t.prototype.asAttr=function(){return this},t.prototype.errors=function(){var e=[],t=f(e,this);return this.parent().validate(t),e},t.prototype.isString=function(){return!(!this._def||this._def.key()!==j.Universe08.StringType&&this._def.key()!=j.Universe10.StringType)},t.prototype.isAnnotatedScalar=function(){return!this.property().isAnnotation()&&!this.property().isKey()&&this.lowLevel().isAnnotatedScalar()},t.prototype.annotations=function(){var e=this.lowLevel().children(),n=[],r=this.definition().universe().type(j.Universe10.Annotable.name);if(!r)return n;for(var i=r.property("annotations"),a=0;a<e.length;a++){var o=e[a],s=o.key();if(null!=s&&"("==s[0]&&")"==s[s.length-1]){var u=new t(o,this.parent(),i.range(),i);n.push(u)}}return n},t.prototype.getKind=function(){return P.NodeKind.ATTRIBUTE},t.prototype.owningWrapper=function(){return{node:this.parent().wrapperNode(),property:this.name()}},t.prototype.patchType=function(e){this._def=e},t.prototype.findReferenceDeclaration=function(){var e=this,t=k.referenceTargets(this.property(),this.parent()),n=this.value();if(oe.isInstance(n))var i=n,a=i.valueName();else var a=""+n;var o=O.find(t,function(t){return r(t,e.parent())==a});return o},t.prototype.findReferencedValue=function(){var e=this.findReferenceDeclaration();if(e){var t=e.attr("value"),n=e.definition().key();if(n===j.Universe08.GlobalSchema){if(t){var r=t.value();if(r){var i=B.isValid(this._def,this.parent(),r,t.property(),t);return i}}return null}}return e},t.prototype.isElement=function(){return!1},t.prototype.property=function(){return this._prop},t.prototype.convertMultivalueToString=function(e){for(var t=0,n=2;" "==e[n];)t++,n++;var r=H.splitOnLines(e);return r=r.map(function(e){return e.substring(t,e.length)}),r.join("")},t.prototype.overrideValue=function(e){this._value=e},t.prototype.value=function(){return null!=this._value?this._value:(this._value=this.calcValue(),this._value)},t.prototype.plainValue=function(){var e=this,t=this.value();if(oe.isInstance(t)){var n=t,r=n.lowLevel();t=r?r.dumpToObject():null;var i=this.property(),a=i.range(),o=J.isTypeProperty(i)||J.isSchemaProperty(i)||J.isItemsProperty(i);if(a.isAssignableFrom("Reference")){var s=Object.keys(t)[0],u=n.valueName(),l=t[s];void 0===l&&(l=null),t={name:u,value:l}}else if(o){var p=this.lowLevel(),c=U.getUniverse("RAML10").type(j.Universe10.TypeDeclaration.name),f=(U.getUniverse("RAML10").type(j.Universe10.LibraryBase.name),new fe(p,this.parent(),c,i));f.patchType(x.doDescrimination(f)),f.patchProp(this.property()),t=f}else if(J.isItemsProperty(i)&&"object"==typeof t){var h=Array.isArray(t),d=!h;if(h&&(d=null!=O.find(t,function(e){return"object"==typeof e})),d){t=null;var m=this.parent().lowLevel();m.children().forEach(function(n){if("items"==n.key()){var r=U.getUniverse("RAML10").type(j.Universe10.TypeDeclaration.name),i=U.getUniverse("RAML10").type(j.Universe10.LibraryBase.name),a=new fe(n,e.parent(),r,i.property(j.Universe10.LibraryBase.properties.types.name));a.patchType(x.doDescrimination(a)),t=a}})}}}return t},t.prototype.calcValue=function(){if(this._computed)return this.computedValue(this.property().nameId());if(this.fromKey){var e=this.parent(),t=e.definition();if("RAML08"==t.universe().version())return this._node.key();if(J.isNameProperty(this.property())&&t.isAssignableFrom(j.Universe10.TypeDeclaration.name)){var n=e.attr("required");if(n&&null!=n.value())return this._node.optional()?this._node.key()+"?":this._node.key()}return this._node.key()}if(this.property().isAnnotation()&&this._node.key()&&"annotations"!=this._node.key())return new oe(this._node,this.parent(),this._prop);var r=a(this),i=this._node.value(r);if(this.property().isSelfNode()&&(i&&!W.ASTNode.isInstance(i)||(i=this._node,0==i.children().length&&(i=null))),W.ASTNode.isInstance(i)||D.LowLevelProxyNode.isInstance(i)){var o=!1;if(this.property().range().hasStructure()||this._node.isAnnotatedScalar()&&this._node.children().forEach(function(e){"value"===e.key()&&(i=e.value(r),o=!0)}),!o)return this._sval?this._sval:(this._sval=new oe(i,this.parent(),this._prop),this._sval)}if("string"==typeof i&&H.isMultiLineValue(i)){var s=this.convertMultivalueToString(i);return s}if(null==i&&this._node.children().length>0&&this.property()&&(J.isTypeOrSchemaProperty(this.property())||J.isItemsProperty(this.property()))&&this.parent()&&J.isTypeDeclarationDescendant(this.parent().definition()))return new oe(this._node,this.parent(),this._prop);if(this.property()&&(J.isTypeOrSchemaProperty(this.property())||J.isItemsProperty(this.property()))&&this.parent()&&J.isTypeDeclarationDescendant(this.parent().definition())&&"string"==typeof i&&this.lowLevel().valueKind()==q.Kind.INCLUDE_REF){var u=b(this,i);u&&(i=u)}return i},t.prototype.name=function(){return this._prop.nameId()},t.prototype.printDetails=function(e){var t=this.definition().nameId(),n=this.property().range().nameId(),r=(e?e:"")+(this.name()+" : "+t+"["+n+"]  =  "+this.value())+(this.property().isKey()&&this.optional()?"?":"")+"\n";if(oe.isInstance(this.value())){var i=this.value().toHighLevel();i&&i.printDetails&&(r+=i.printDetails(e+"\t"))}return r},t.prototype.testSerialize=function(e){var t=this.definition().nameId(),n=(e?e:"")+(this.name()+" : "+t+"  =  "+this.value())+"\n";if(oe.isInstance(this.value())){var r=this.value().toHighLevel();if(r&&r.testSerialize)n+=r.testSerialize((e?e:"")+"  ");else{var i=this.value().lowLevel(),a=i.dumpToObject(),o=JSON.stringify(a),s="",u=o.split("\n");u.forEach(function(t){return s+=(e?e:"")+"  "+t+"\n"}),n+=s+"\n"}}return n},t.prototype.isAttr=function(){return!0},t.prototype.isUnknown=function(){return!1},t.prototype.setValue=function(e){F.setValue(this,e),this._value=null},t.prototype.setKey=function(e){F.setKey(this,e),this._value=null},t.prototype.children=function(){return[]},t.prototype.addStringValue=function(e){F.addStringValue(this,e),this._value=null},t.prototype.addStructuredValue=function(e){F.addStructuredValue(this,e),this._value=null},t.prototype.addValue=function(e){if(!this.property().isMultiValue())throw new Error(ie.SETVALUE_ONLY_MULTI_VALUES_PROPERTIES.message);"string"==typeof e?this.addStringValue(e):this.addStructuredValue(e),this._value=null},t.prototype.isEmbedded=function(){var e=this.lowLevel().asMapping().key.value;return this.property().canBeValue()&&e!=this.property().nameId()},t.prototype.remove=function(){F.removeAttr(this)},t.prototype.setValues=function(e){F.setValues(this,e),this._value=null},t.prototype.isEmpty=function(){if(!this.property().isMultiValue())throw new Error(ie.ISEMPTY_ONLY_MULTI_VALUES_ATTRIBUTES.message);var e=this.parent(),t=(e.lowLevel(),e.attributes(this.name()));if(0==t.length)return!0;if(1==t.length){var n=t[0].lowLevel();return!(!n.isMapping()||null!=n.value())}return!1},t.prototype.isFromKey=function(){return this.fromKey},t.CLASS_IDENTIFIER_ASTPropImpl="highLevelImpl.ASTPropImpl",t}(ae);t.ASTPropImpl=se,t.isASTPropImpl=o;var ue,le=new x.BasicNodeBuilder;!function(e){e[e.MERGE=0]="MERGE",e[e.AGGREGATE=1]="AGGREGATE"}(ue=t.OverlayMergeMode||(t.OverlayMergeMode={}));var pe=function(e){function t(n,r){var i=e.call(this)||this;i._node=n,i._highLevelRoot=r;var a=r.root(),o=a.getMaster();if(o&&i._node===r.lowLevel()){var s=r.getMasterCounterPart();s&&(i._toMerge=new t(s.lowLevel(),s))}return i}return C(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&O.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_LowLevelWrapperForTypeSystem)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_LowLevelWrapperForTypeSystem)},t.prototype.contentProvider=function(){var e=this._node&&this._node.includeBaseUnit()&&(this._node.includePath&&this._node.includePath()?this._node.includeBaseUnit().resolve(this._node.includePath()):this._node.includeBaseUnit());return new ne.ContentProvider(e)},t.prototype.path=function(){return this._node.unit()&&this._node.unit().absolutePath()},t.prototype.key=function(){var e=this._node.key();return this._node.optional()&&(e+="?"),e},t.prototype.value=function(){var e=this._node.resolvedValueKind();if(e===q.Kind.SEQ)return this.children().map(function(e){return e.value()});if(e===q.Kind.MAP){var t=this._node.dumpToObject(!1);return t[this.key()]}if(this._node.kind()==q.Kind.MAP){var t=this._node.dumpToObject(!1);return t}var n=this._node.value();return n},t.prototype.children=function(){var e=this;if(this._children)return this._children;var n="uses"==this.key();if(n){var r=this._node.parent(),i=r.parent();null!=i&&this._node.unit().absolutePath()==i.unit().absolutePath()&&(n=!1)}n?this._children=this._node.children().map(function(t){return new ce(t,e._highLevelRoot)}):this._children=this._node.children().map(function(n){return new t(n,e._highLevelRoot)}),this.childByKey={};for(var a=0;a<this._children.length;a++){var o=this._children[a];this.childByKey[o.key()]=o}if(this._toMerge)for(var s=this._toMerge.children(),a=0;a<s.length;a++){var o=s[a],u=this.childByKey[o.key()];u?u._toMerge=o:(this._children.push(o),this.childByKey[o.key()]=o)}return this._children},t.prototype.childWithKey=function(e){return this._children||this.children(),this.childByKey[e]},t.prototype.kind=function(){var e=this._node.valueKind();if(e==q.Kind.MAPPING||null===e)return Z.NodeKind.MAP;if(e==q.Kind.MAP)return Z.NodeKind.MAP;var t=this._node.kind();return t==q.Kind.MAP?Z.NodeKind.MAP:e==q.Kind.SEQ?Z.NodeKind.ARRAY:(e==q.Kind.INCLUDE_REF||e==q.Kind.ANCHOR_REF)&&this._node.children().length>0?Z.NodeKind.MAP:Z.NodeKind.SCALAR},t.prototype.getSource=function(){if(!this._node)return null;var e=this._node.highLevelNode();if(!e){var t=this._node.start(),n=k.deepFindNode(this._highLevelRoot,t,t,!0,!1);return n&&(this._node.setHighLevelParseResult(n),fe.isInstance(n)&&this._node.setHighLevelNode(n)),n}return e},t.prototype.node=function(){return this._node},t.prototype.getMeta=function(e){return this.ownMeta&&this.ownMeta.hasOwnProperty(e)?this.ownMeta[e]:D.LowLevelProxyNode.isInstance(this._node)&&this._node.getMeta(e)},t.prototype.addMeta=function(e,t){this.ownMeta||(this.ownMeta={}),this.ownMeta[e]=t},t.CLASS_IDENTIFIER_LowLevelWrapperForTypeSystem="highLevelImpl.LowLevelWrapperForTypeSystem",t}(w.SourceProvider);t.LowLevelWrapperForTypeSystem=pe;var ce=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return C(t,e),t.prototype.children=function(){var e=this._node.unit().resolve(this.value());return e&&e.isRAMLUnit()&&e.contents().trim().length>0?new pe(e.ast(),this._highLevelRoot).children():[]},t.prototype.path=function(){var e=this._node.unit()&&this._node.unit().resolve(this.value());return e&&e.absolutePath()},t.prototype.anchor=function(){return this._node.actual()},t.prototype.childWithKey=function(e){for(var t=this.children(),n=0;n<t.length;n++)if(t[n].key()==e)return t[n];return null},t}(pe);t.UsesNodeWrapperFoTypeSystem=ce,t.auxiliaryTypeForExample=s;var fe=function(e){function t(t,n,r,i){var a=e.call(this,t,n)||this;return a._def=r,a._prop=i,a._expanded=!1,a._allowQuestion=!1,a._subTypesCache=null,a._auxChecked=!1,a.overlayMergeMode=ue.MERGE,t&&t.setHighLevelNode(a),D.LowLevelProxyNode.isInstance(t)&&(a._expanded=!0),a}return C(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&O.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ASTNodeImpl)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_ASTNodeImpl)},t.prototype.createIssue=function(e){return B.toIssue(e,this)},t.prototype.validate=function(t){var n=this.definition().key();if((n==j.Universe10.Api||n==j.Universe08.Api||n==j.Universe10.Extension)&&!this.isExpanded()){var r=V.expandTraitsAndResourceTypes(this.wrapperNode()),i=r.highLevel();return i.resetChildren(),i.children(),i._expanded=!0,i.clearTypesCache(),void i.validate(t)}n!=j.Universe10.Overlay&&n!=j.Universe10.Extension||this.clearTypesCache(),e.prototype.validate.call(this,t)},t.prototype.clearTypesCache=function(){if(this._types=null,this.lowLevel()){var e=this.lowLevel().actual();e.types=null}},t.prototype.types=function(e){var t=this;if(void 0===e&&(e=!1),!this._types){var n=this.root().lowLevel().actual().libExpanded===!0,r=this.lowLevel().unit(),i=this.definition().key()===j.Universe10.Library;if(r&&this.parent()&&this.definition()&&!i){var a=this.parent().lowLevel().unit(),o=(a.absolutePath(),r.absolutePath(),this.lowLevel().includePath()),s=!n&&null!=o,u=this.parent(),l="RAML10"==this.definition().universe().version();if(l&&o&&!n&&D.LowLevelCompositeNode.isInstance(this.lowLevel())&&(J.isMethodType(u.definition())||J.isResourceType(u.definition()))){var p=this.lowLevel().adoptedNodes(),c=p.find(function(e){return e.includePath()==o});if(c){var f=c.unit().resolve(o);if(f){var h=f.highLevel();u=h.isElement()?h.asElement():u}}}var d=u.types(),m=this.definition();if(!s||!m||!J.canBeFragment(m))return d;var y=r.resolve(o);if(!y||!y.isRAMLUnit())return d;var v=y.highLevel().asElement().types();return R(d,v),this._types=v,v}var g=this.lowLevel().actual();if(g.types)return g.types;if(r){var A=r.project();if(!n&&r.absolutePath()!=A.getMainUnitPath()){var E=A.getMainUnit();if(E){var _=A.namespaceResolver(),T=_.unitModel(E).extensionSet();if(!T[r.absolutePath()]){var S=E.highLevel().types(!0);if(S){var N=_.resolveNamespace(E,r);if(N){for(var I=N.namespaceSegments,b=S,M=0;M<I.length;){for(var C=void 0,P=M;P<I.length;P++){var L=I.slice(M,P+1).join(".");C=b.library(L),C&&(M=P+1,b=C)}if(null==C){b=null;break}}b&&(this._types=b)}}}}}}if(!this._types){var O=n;this._types=Z.parseFromAST(new pe(this.lowLevel(),this),O),this._types.types().forEach(function(e){var n=K.convertType(t,e);n.putExtra(w.USER_DEFINED_EXTRA,!0)})}this.lowLevel().actual().libExpanded&&(this._types.uses={}),e||(g.types=this._types)}return this._types},t.prototype.setTypes=function(e){this._types=e},t.prototype.parsedType=function(){var e=this;if(!this._ptype){var t=this.root(),n=t.definition()&&J.isApiSibling(t.definition()),r=this.root().lowLevel().actual().libExpanded===!0;if((!n||r)&&this.definition().isAssignableFrom(j.Universe10.TypeDeclaration.name)){var i=this.parent();if(i&&i.definition().isAssignableFrom(j.Universe10.TypeDeclaration.name)){var a=i.parsedType();if(null!=a)if(J.isPropertiesProperty(this.property())){var o=this.name(),s=a.properties().find(function(e){return e.name()==o});if(s){var u=s.range();if(u)return u}}else if(J.isItemsProperty(this.property())){var l=a.componentType();if(l)return l}else if(J.isTypeProperty(this.property())){var p=a.superTypes(),l=p&&1==p.length&&p[0];if(l)return l}}else if(i&&i.definition().isAssignableFrom(j.Universe10.LibraryBase.name)&&J.isAnnotationTypesProperty(this.property())){
var l=this.types().annotationTypes().find(function(t){return t.name()==e.name()});if(l)return l}}var c=new pe(this.lowLevel(),this);if(B.typeOfContainingTemplate(this)&&E(c),"RAML08"==this.universe().version()&&J.isStringTypeDeclarationDescendant(this.definition())&&c.addMeta("acceptAllScalarsAsStrings",!0),this.property()&&this.property().nameId()==j.Universe10.MethodBase.properties.body.name){var f=this.isParametrizedType();this._ptype=Z.parseTypeFromAST(this.name(),c,this.types(),!0,!1,!1,f)}else{var h=this.property()&&this.property().nameId()==j.Universe10.LibraryBase.properties.annotationTypes.name,d=!this.property()||this.property().nameId()==j.Universe10.LibraryBase.properties.types.name||this.property().nameId()==j.Universe10.LibraryBase.properties.schemas.name;if(!h&&null==this.parent()){var m=this.universe();m&&m.getOriginalTopLevelText()&&"AnnotationTypeDeclaration"==m.getOriginalTopLevelText()&&(h=!0)}this._ptype=Z.parseTypeFromAST(this.name(),c,this.types(),!1,h,d)}this.property()&&J.isTypesProperty(this.property())&&this.parent()&&J.isApiType(this.parent().definition())&&this._ptype.putExtra&&this._ptype.putExtra(w.DEFINED_IN_TYPES_EXTRA,!0);var y=this._ptype;y.putExtra(w.USER_DEFINED_EXTRA,!0),this._ptype.putExtra(w.SOURCE_EXTRA,this)}return this._ptype},t.prototype.isParametrizedType=function(){var e=!1,t=this.attr(j.Universe10.TypeDeclaration.properties.type.name);if(t||(t=this.attr(j.Universe10.TypeDeclaration.properties.schema.name)),t){var n=t.value();if("string"==typeof n&&n.indexOf("<<")>=0)for(var r=this.parent();null!=r;){if(J.isResourceTypeType(r.definition())||J.isTraitType(r.definition())){e=!0;break}r=r.parent()}}return e},t.prototype.localType=function(){return K.typeFromNode(this)},t.prototype.patchProp=function(e){this._prop=e},t.prototype.getKind=function(){return P.NodeKind.NODE},t.prototype.wrapperNode=function(){if(!this._wrapperNode){if(J.isExampleSpecType(this.definition())){var e=s(this),t=G.examplesFromNominal(e,this,!0,!1);return t[0]}var n=this.definition()&&this.definition().universe();n&&"RAML10"==n.version()?this.definition()&&this.definition().isAssignableFrom(U.universesInfo.Universe10.LibraryBase.name)||this.children():this.children(),this._wrapperNode=this.buildWrapperNode()}return this._wrapperNode},t.prototype.asElement=function(){return this},t.prototype.buildWrapperNode=function(){var e=this.definition().universe().version();return"RAML10"==e?z.buildWrapperNode(this):"RAML08"==e?$.buildWrapperNode(this):null},t.prototype.propertiesAllowedToUse=function(){var e=this;return this.definition().allProperties().filter(function(t){return e.isAllowedToUse(t)})},t.prototype.isAllowedToUse=function(e){var t=this,n=!0;return!e.getAdapter(Y.RAMLPropertyService).isSystem()&&(e.getContextRequirements().forEach(function(e){if(e.name.indexOf("(")!=-1)return!0;var r=t.computedValue(e.name);r?n=n&&r==e.value:e.value&&(n=!1)}),n)},t.prototype.allowRecursive=function(){return!!this.definition().getAdapter(Y.RAMLService).isUserDefined()},t.prototype.setWrapperNode=function(e){this._wrapperNode=e},t.prototype.setAssociatedType=function(e){this._associatedDef=e},t.prototype.associatedType=function(){return this._associatedDef},t.prototype.knownIds=function(){return this.isAuxilary(),this._knownIds?this._knownIds:{}},t.prototype.findById=function(e){var t=this,n=this.root();if(n!=this)return n.findById(e);if(!this._knownIds){this._knownIds={};var r=k.allChildren(this);r.forEach(function(e){return t._knownIds[e.id()]=e})}if(this.isAuxilary()){if(!this._slaveIds){this._slaveIds={},this._slaveIds[this.id()]=this;var r=k.allChildren(this);r.forEach(function(e){return t._slaveIds[e.id()]=e})}var i=this._slaveIds[e];if(i)return i}return this._knownIds[e]},t.prototype.isAuxilary=function(){if(this._isAux)return!0;if(this._auxChecked)return!1;this._auxChecked=!0;var e=this.getMaster();return!!e&&(this._isAux=!0,this.initilizeKnownIDs(e),!0)},t.prototype.initilizeKnownIDs=function(e){var t=this;this._knownIds={};var n=k.allChildren(e);n.forEach(function(e){return t._knownIds[e.id()]=e}),this._knownIds[""]=e},t.prototype.getMaster=function(){if(this.masterApi)return this.masterApi;var e=this.calculateMasterByRef();return e&&e.setSlave(this),e},t.prototype.overrideMaster=function(e){this.masterApi=e,this.resetAuxilaryState(),e&&e.setSlave(this)},t.prototype.setSlave=function(e){this.slave=e},t.prototype.setMergeMode=function(e){this.overlayMergeMode=e,this.resetAuxilaryState()},t.prototype.getMergeMode=function(){return this.overlayMergeMode},t.prototype.calculateMasterByRef=function(){var e=this.lowLevel().unit();if(!e)return null;var t=e.getMasterReferenceNode();if(!t||!t.value())return null;var n=this.lowLevel();if(n.master)return n.master;var r=t.value(),i=this.lowLevel().unit().project().resolve(this.lowLevel().unit().path(),r);if(!i)return null;var a=i.expandedHighLevel();return a.setMergeMode(this.overlayMergeMode),n.master=a,a},t.prototype.resetAuxilaryState=function(){this._isAux=!1,this._auxChecked=!1,this._knownIds=null,this.clearChildrenCache()},t.prototype.printDetails=function(e){var t="";e||(e="");var n=this.definition().nameId(),r=this.property()?this.property().range().nameId():"",i=this.property()?this.property().nameId():"";return t+=e+n+"["+r+"] <--- "+i+"\n",this.children().forEach(function(n){t+=n.printDetails(e+"\t")}),t},t.prototype.testSerialize=function(e){var t="";e||(e="");var n=this.definition().nameId(),r=this.property()?this.property().nameId():"";return t+=e+n+" <-- "+r+"\n",this.children().forEach(function(n){n.testSerialize&&(t+=n.testSerialize(e+"  "))}),t},t.prototype.getExtractedChildren=function(){var e=this.root();if(e.isAuxilary()){if(e._knownIds){var t=e._knownIds[this.id()];if(t){var n=t.children();return n}}return[]}return[]},t.prototype.getMasterCounterPart=function(){var e=this.root();if(e.isAuxilary()){if(e._knownIds){var t=e._knownIds[this.id()];return t}return null}return null},t.prototype.getSlaveCounterPart=function(){var e=this.root();return e.slave?e.slave.findById(this.id()):null},t.prototype.getLastSlaveCounterPart=function(){var e=this.root(),t=e.slave;if(null==t)return null;for(;null!=t.slave;)t=t.slave;return""==this.id()?t:t.findById(this.id())},t.prototype.getExtractedLowLevelChildren=function(e){var t=this.root();if(t.isAuxilary()){if(t._knownLowLevelIds){var n=t._knownLowLevelIds[this.id()];if(n)return n.children()}return[]}return[]},t.prototype.allowsQuestion=function(){return this._allowQuestion||this.definition().getAdapter(Y.RAMLService).getAllowQuestion()},t.prototype.findReferences=function(){var e=this,t=[];k.refFinder(this.root(),this,t),t.length>1&&(t=t.filter(function(t){return t!=e&&t.parent()!=e}));var n=[];return t.forEach(function(e){O.find(n,function(t){return t==e})||n.push(e)}),n},t.prototype.setNamePatch=function(e){this._patchedName=e},t.prototype.isNamePatch=function(){return this._patchedName},t.prototype.name=function(){if(this._patchedName)return this._patchedName;var t=O.find(this.directChildren(),function(e){return e.property()&&e.property().getAdapter(Y.RAMLPropertyService).isKey()});if(t&&se.isInstance(t)){var n=null,r=this.definition(),i=r.universe().version();if(r&&"RAML10"==i&&t.isFromKey()){var a=this._computedKey||this._node.key();n=this._node.optional()?a+"?":a}else n=t.value();return n}return e.prototype.name.call(this)},t.prototype.findElementAtOffset=function(e){return this._findNode(this,e,e)},t.prototype.isElement=function(){return!0},t.prototype.universe=function(){return this._universe?this._universe:this.definition().universe()},t.prototype.setUniverse=function(e){this._universe=e},t.prototype._findNode=function(e,t,n){var r=this;if(null==e)return null;if(e.lowLevel()&&e.lowLevel().start()<=t&&e.lowLevel().end()>=n){var i=e;return e.elements().forEach(function(a){if(a.lowLevel().unit()==e.lowLevel().unit()){var o=r._findNode(a,t,n);o&&(i=o)}}),i}return null},t.prototype.isStub=function(){return!this.lowLevel().unit()||this.lowLevel().unit().isStubUnit()},t.prototype.add=function(e){F.addToNode(this,e)},t.prototype.remove=function(e){F.removeNodeFrom(this,e)},t.prototype.dump=function(e){return this._node.dump()},t.prototype.patchType=function(e){this._def=e;this._associatedDef;this._associatedDef=null,this._children=null,this._mergedChildren=null},t.prototype.children=function(){var e=this.lowLevel();return e&&e.isValueInclude&&e.isValueInclude()&&Q.isWaitingFor(e.includePath())?(this._children=null,[]):this._children?this._mergedChildren?this._mergedChildren:(this._mergedChildren=this.mergeChildren(this._children,this.getExtractedChildren()),this._mergedChildren):this._node?(this._children=le.process(this,this._node.children()),this._children=this._children.filter(function(e){return null!=e}),this.mergeChildren(this._children,this.getExtractedChildren())):[]},t.prototype.mergeChildren=function(e,t){var n=this,r=this.root();if(r.overlayMergeMode==ue.AGGREGATE)return e.concat(t);if(r.overlayMergeMode==ue.MERGE){var i=[];return e.forEach(function(e){var r=O.find(t,function(t){return t.fullLocalId()==e.fullLocalId()});r?n.mergeChild(i,e,r):i.push(e)}),t.forEach(function(t){var n=O.find(e,function(e){return t.fullLocalId()==e.fullLocalId()});n||i.push(t)}),i}return null},t.prototype.mergeLowLevelChildren=function(e,t){var n=this,r=this.root();if(r.overlayMergeMode==ue.AGGREGATE)return e.concat(t);if(r.overlayMergeMode==ue.MERGE){var i=[];return e.forEach(function(e){var r=O.find(t,function(t){return t.key()==e.key()});r?n.mergeLowLevelChild(i,e,r):i.push(e)}),t.forEach(function(t){var n=O.find(e,function(e){return t.key()==e.key()});n||i.push(t)}),i}return null},t.prototype.mergeLowLevelChild=function(e,t,n){return t.kind()!=n.kind()?(e.push(t),void e.push(n)):void e.push(t)},t.prototype.mergeChild=function(e,t,n){return t.getKind()!=n.getKind()?(e.push(t),void e.push(n)):t.getKind()==P.NodeKind.NODE?void e.push(t):t.getKind()==P.NodeKind.ATTRIBUTE?void e.push(t):t.getKind()==P.NodeKind.BASIC?(e.push(t),void e.push(n)):void 0},t.prototype.directChildren=function(){return this._children?this._children:this._node?(this._children=le.process(this,this._node.children()),this._mergedChildren=null,this._children):[]},t.prototype.resetChildren=function(){this._children=null,this._mergedChildren=null},t.prototype.isEmptyRamlFile=function(){var e=this.lowLevel().root();return e.isScalar()},t.prototype.initRamlFile=function(){F.initEmptyRAMLFile(this)},t.prototype.createAttr=function(e,t){F.createAttr(this,e,t)},t.prototype.isAttr=function(){return!1},t.prototype.isUnknown=function(){return!1},t.prototype.value=function(){return this._node.value()},t.prototype.valuesOf=function(e){var t=this._def.property(e);return null!=t?this.elements().filter(function(e){return e.property()==t}):[]},t.prototype.attr=function(e){return O.find(this.attrs(),function(t){return t.name()==e})},t.prototype.attrOrCreate=function(e){var t=this.attr(e);return t||this.createAttr(e,""),this.attr(e)},t.prototype.attrValue=function(e){var t=this.attr(e);return t?t.value():null},t.prototype.attributes=function(e){return O.filter(this.attrs(),function(t){return t.name()==e})},t.prototype.attrs=function(){var e=this.children().filter(function(e){return e.isAttr()});if(this._patchedName){var t=O.find(this.definition().allProperties(),function(e){return e.getAdapter(Y.RAMLPropertyService).isKey()});if(t){var n=new se(this.lowLevel(),this,t.range(),t,!0);return n._value=this._patchedName,[n].concat(e)}}return e},t.prototype.elements=function(){return this.children().filter(function(e){return!e.isAttr()&&!e.isUnknown()})},t.prototype.element=function(e){var t=this.elementsOfKind(e);return t.length>0?t[0]:null},t.prototype.elementsOfKind=function(e){var t=this.elements().filter(function(t){return t.property().nameId()==e});return t},t.prototype.definition=function(){return this._def},t.prototype.property=function(){return this._prop},t.prototype.isExpanded=function(){return this._expanded},t.prototype.copy=function(){return new t(this.lowLevel().copy(),this.parent(),this.definition(),this.property())},t.prototype.clearChildrenCache=function(){this._children=null,this._mergedChildren=null},t.prototype.optionalProperties=function(){var e=this.definition();if(null==e)return[];var t=[],n={},r=this.lowLevel().children();r.forEach(function(e){e.optional()&&(n[e.key()]=!0)});var i=e.allProperties();return i.forEach(function(e){var r=e;n[r.nameId()]&&t.push(r.nameId())}),t},t.prototype.setReuseMode=function(e){this._reuseMode=e,this._children&&this.lowLevel().valueKind()!=q.Kind.SEQ&&this._children.forEach(function(t){return t.setReuseMode(e)})},t.prototype.reusedNode=function(){return this._reusedNode},t.prototype.setReusedNode=function(e){this._reusedNode=e},t.prototype.resetRuntimeTypes=function(){delete this._associatedDef,this.elements().forEach(function(e){return e.resetRuntimeTypes()})},t.prototype.toJSON=function(e){return new X.JsonSerializer(e).dump(this)},t.CLASS_IDENTIFIER_ASTNodeImpl="highLevelImpl.ASTNodeImpl",t}(ae);t.ASTNodeImpl=fe,t.universeProvider=n(264);var he=function(e,n){var r=l(e),i=r&&r[1]||"",a=u(e),o=r&&r.length>2&&r[2],s="1.0"==i?new U.Universe(null,"RAML10",t.universeProvider("RAML10"),"RAML10"):new U.Universe(null,"RAML08",t.universeProvider("RAML08"));return s.setOriginalTopLevelText(o),s.setTopLevel(a),s.setTypedVersion(i),{ptype:a,localUniverse:s}};t.ramlFirstLine=l,t.getFragmentDefenitionName=p,t.fromUnit=c,t.createBasicValidationAcceptor=f,t.isAnnotationTypeFragment=h;var de=function(){function e(e){this._node=e}return e.prototype.kind=function(){return"AnnotatedNode"},e.prototype.annotationsMap=function(){var e=this;return this._annotationsMap||(this._annotationsMap={},this.annotations().forEach(function(t){var n=t.name(),r=n.lastIndexOf(".");r>=0&&(n=n.substring(r+1)),e._annotationsMap[n]=t})),this._annotationsMap},e.prototype.annotations=function(){if(!this._annotations){var e=[];this._node.isElement()?e=this._node.asElement().attributes(U.universesInfo.Universe10.Annotable.properties.annotations.name):this._node.isAttr()&&(e=this._node.asAttr().annotations()),this._annotations=e.map(function(e){return new me(e)})}return this._annotations},e.prototype.value=function(){if(this._node.isElement())return this._node.asElement().wrapperNode().toJSON();if(this._node.isAttr()){var e=this._node.asAttr().value();return oe.isInstance(e)?e.lowLevel().dump():e}return this._node.lowLevel().dump()},e.prototype.name=function(){return this._node.name()},e.prototype.entry=function(){return this._node},e}();t.AnnotatedNode=de;var me=function(){function e(e){this.attr=e}return e.prototype.name=function(){return this.attr.value().valueName()},e.prototype.value=function(){var e=this.attr.value();if(oe.isInstance(e)){var t=e.lowLevel().dumpToObject(),n=Object.keys(t)[0];return t[n]}return e},e.prototype.definition=function(){var e=this.attr.parent(),t=this.name(),n=k.referenceTargets(this.attr.property(),e).filter(function(n){return r(n,e)==t});return 0==n.length?null:n[0].parsedType()},e}();t.AnnotationInstance=me,t.applyNodeValidationPlugins=m,t.applyNodeAnnotationValidationPlugins=y,t.toParserErrors=v,t.actualPath=N,t.actualUnit=I,t.resolveSchemaFragment=b},function(e,t,n){"use strict";function r(){return t.rt.getSchemaUtils()}function i(e){e.isUnion?e.addAdapter(new I(e)):e.range&&e.addAdapter(new N(e))}function a(e){return e.getSource&&"function"==typeof e.getSource}function o(e){var t=e;return t.genuineUserDefinedType&&t.isUserDefined&&t.isUserDefined()}function s(e,t,n,r,i){var a=new E(e,t);return a.withDomain(n,i).withRange(r)}var u=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0}),t.rt=n(57);var l=t.rt.nominalTypes;t.getSchemaUtils=r,t.TOP_LEVEL_EXTRA=t.rt.TOP_LEVEL_EXTRA,t.DEFINED_IN_TYPES_EXTRA=t.rt.DEFINED_IN_TYPES_EXTRA,t.USER_DEFINED_EXTRA=t.rt.USER_DEFINED_EXTRA,t.SOURCE_EXTRA=t.rt.SOURCE_EXTRA,t.tsInterfaces=t.rt.tsInterfaces,t.injector={inject:function(e){i(e)}},l.registerInjector(t.injector);var p=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return u(t,e),t}(l.AbstractType);t.AbstractType=p;var c=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return u(t,e),t}(l.ValueType);t.ValueType=c;var f=function(){function e(){}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.getSource=function(){return null},e.CLASS_IDENTIFIER="definitionSystem.SourceProvider",e}();t.SourceProvider=f,t.isSourceProvider=a;var h=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.values=[],t}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER)return!0}return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.CLASS_IDENTIFIER="definitionSystem.EnumType",t}(c);t.EnumType=h;var d=function(e){function t(t,n,r,i){var a=e.call(this,t,i,n)||this;return a.referenceTo=r,a}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER)return!0}return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.prototype.getReferencedType=function(){return this.universe().type(this.referenceTo)},t.prototype.hasStructure=function(){return!0},t.CLASS_IDENTIFIER="definitionSystem.ReferenceType",t}(c);t.ReferenceType=d;var m=function(e){function t(t,n,r,i){return void 0===i&&(i=""),e.call(this,t,n,r)||this}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER)return!0}return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.prototype.allProperties=function(t){return void 0===t&&(t={}),e.prototype.allProperties.call(this,t)},t.CLASS_IDENTIFIER="definitionSystem.NodeClass",t}(l.StructuredType);t.NodeClass=m;var y=function(e){function t(t,n,r,i,a){var o=e.call(this,t,n,i,a)||this;return o.getAdapter(I).setDeclaringNode(r),o}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER_UserDefinedClass)return!0}return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_UserDefinedClass)},t.prototype.key=function(){return null},t.prototype.isUserDefined=function(){return!0},t.prototype.typeId=function(){var e=this.nameId(),t=this.getAdapter(I).getDeclaringNode();if(t){e+=t.lowLevel().start();var n=t.lowLevel().unit();n&&(e+=n.absolutePath())}return e},t.prototype.hasValueTypeInHierarchy=function(){return!!this._value||(this.isAssignableFrom("ObjectTypeDeclaration"),!1)},t.prototype.isGenuineUserDefinedType=function(){return null!=this.genuineUserDefinedType()},t.prototype.genuineUserDefinedType=function(){var e=this.getAdapter(I).getDeclaringNode();return e?this:null},t.CLASS_IDENTIFIER_UserDefinedClass="definitionSystem.UserDefinedClass",t}(m);t.UserDefinedClass=y,t.isUserDefinedClass=o;var v=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return u(t,e),t.prototype.allProperties=function(e){void 0===e&&(e={});var t=this.superTypes()[0].allProperties();if(0==t.length){var n=this.getAdapter(I).getDeclaringNode(),r=new _("value",n);r.withDomain(this),r.withCanBeValue(),r.withRequired(!1);this.superTypes()[0];t=[],r.withRange(r.node().asElement().definition().universe().type("string")),t.push(r)}return t},t.prototype.isAnnotationType=function(){return!0},t}(y);t.AnnotationType=v;var g=function(e){function t(t,n,r,i){void 0===n&&(n=""),void 0===r&&(r=null),void 0===i&&(i="RAML08");var a=e.call(this,n)||this;return a._parent=r,a._classes=[],a._uversion="RAML08",a.aMap={},a.matchedObjects=t,a._uversion=i,a}return u(t,e),t.prototype.matched=function(){return this.matchedObjects?this.matchedObjects:this._parent?this._parent.matched():void 0},t.prototype.setTopLevel=function(e){this._topLevel=e},t.prototype.getTopLevel=function(){return this._topLevel},t.prototype.setOriginalTopLevelText=function(e){this._originalTopLevelText=e},t.prototype.getOriginalTopLevelText=function(){return this._originalTopLevelText},t.prototype.setTypedVersion=function(e){this._typedVersion=e},t.prototype.getTypedVersion=function(){return this._typedVersion},t.prototype.version=function(){return this._uversion},t.prototype.setUniverseVersion=function(e){this._uversion=e},t.prototype.types=function(){var e=[].concat(this._classes);return null!=this._parent&&(e=e.concat(this._parent.types())),e},t.prototype.type=function(e){if(this.aMap[e])return this.aMap[e];for(var t,n=0;n<this._classes.length;n++)if(this._classes[n].nameId()==e){t=this._classes[n];break}if(null==t&&this._parent){var t=this._parent.type(e);if(t instanceof p){var r=t;r._universe=this}}return t},t.prototype.register=function(e){return this._classes.push(e),e instanceof m&&this._classes.forEach(function(t){if(t instanceof m){var n=t;n.getAdapter(I).getExtendedType()==e&&e.getAdapter(I).getRuntimeExtenders().push(t)}}),this},t.prototype.registerAlias=function(e,t){this.aMap[e]=t},t.prototype.unregister=function(e){this._classes=this._classes.filter(function(t){return t!=e});var t=e.superTypes();return t.forEach(function(t){var n=t;n._superTypes=n._superTypes.filter(function(t){return t!=e})}),t=e.subTypes(),t.forEach(function(t){var n=t;n._subTypes=n._subTypes.filter(function(t){return t!=e})}),this},t.prototype.registerSuperClass=function(e,t){var n=e,r=t;n._superTypes.push(t),r._subTypes.push(e)},t}(l.Described);t.Universe=g,t.prop=s;var A=function(){function e(e,t){this.name=e,this.value=t}return e}();t.ChildValueConstraint=A;var E=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._isFromParentValue=!1,t._isFromParentKey=!1,t._key=!1,t._declaresFields=!1,t._describes=null,t._canBeDuplicator=!1,t._allowsNull=!1,t._canBeValue=!1,t._isInherited=!1,t._selfNode=!1,t._noDirectParse=!1,t._contextReq=[],t.determinesChildValues=[],t}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER_Property_def)return!0}return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_Property_def)},t.prototype.isPrimitive=function(){return this.range().isValueType()&&!(this.range()instanceof d)},t.prototype.withNoDirectParse=function(){this._noDirectParse=!0},t.prototype.isNoDirectParse=function(){return this._noDirectParse},t.prototype.withSelfNode=function(){this._selfNode=!0},t.prototype.isSelfNode=function(){return this._selfNode},t.prototype.matchKey=function(t){return null!=this._groupName?this.isAnnotation()?"("==t.charAt(0)&&")"==t.charAt(t.length-1):this._groupName==t:e.prototype.matchKey.call(this,t)},t.prototype.valueDocProvider=function(){return this._vprovider},t.prototype.setValueDocProvider=function(e){return this._vprovider=e,this},t.prototype.suggester=function(){return this._suggester},t.prototype.setValueSuggester=function(e){this._suggester=e},t.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},t.prototype.getOftenKeys=function(){return this._oftenKeys},t.prototype.withOftenKeys=function(e){return this._oftenKeys=e,this},t.prototype.withCanBeValue=function(){return this._canBeValue=!0,this},t.prototype.withInherited=function(e){this._isInherited=e},t.prototype.isInherited=function(){return this._isInherited},t.prototype.isAllowNull=function(){return this._allowsNull},t.prototype.withAllowNull=function(){this._allowsNull=!0},t.prototype.getCanBeDuplicator=function(){return this._canBeDuplicator},t.prototype.canBeValue=function(){return this._canBeValue},t.prototype.setCanBeDuplicator=function(){return this._canBeDuplicator=!0,!0},t.prototype.inheritedContextValue=function(){return this._inheritsValueFromContext},t.prototype.withInheritedContextValue=function(e){return this._inheritsValueFromContext=e,this},t.prototype.withContextRequirement=function(e,t){this._contextReq.push({name:e,value:t})},t.prototype.getContextRequirements=function(){return this._contextReq},t.prototype.withDescribes=function(e){return this._describes=e,this},t.prototype.describesAnnotation=function(){return null!=this._describes},t.prototype.describedAnnotation=function(){return this._describes},t.prototype.isReference=function(){return this.range()instanceof d},t.prototype.referencesTo=function(){return this.range().getReferencedType()},t.prototype.newInstanceName=function(){return this._newInstanceName?this._newInstanceName:this.range().nameId()},t.prototype.withThisPropertyDeclaresFields=function(e){return void 0===e&&(e=!0),this._declaresFields=e,this},t.prototype.isThisPropertyDeclaresTypeFields=function(){return this._declaresFields},t.prototype.withNewInstanceName=function(e){return this._newInstanceName=e,this},t.prototype.addChildValueConstraint=function(e){this.determinesChildValues.push(e)},t.prototype.getChildValueConstraints=function(){return this.determinesChildValues},t.prototype.childRestrictions=function(){return this.determinesChildValues},t.prototype.id=function(){return this._id?this._id:this._groupName?this.domain().getAdapter(I).getDeclaringNode()?null:(this._id=this._groupName+this.domain().nameId(),this._id):null},t.prototype.isAnnotation=function(){return"annotations"==this._groupName&&this.domain()&&!this.domain().isUserDefined()},t.prototype.withFromParentValue=function(e){return void 0===e&&(e=!0),this._isFromParentValue=e,this},t.prototype.withFromParentKey=function(e){return void 0===e&&(e=!0),this._isFromParentKey=e,this},t.prototype.isFromParentKey=function(){return this._isFromParentKey},t.prototype.isFromParentValue=function(){return this._isFromParentValue},t.prototype.withGroupName=function(e){return this._groupName=e,this},t.prototype.unmerge=function(){return this._groupName=this.nameId(),this},t.prototype.merge=function(){return this._groupName=null,this},t.prototype.withKey=function(e){return this._key=e,this},t.prototype.isKey=function(){return this._key},t.prototype.isMerged=function(){return null==this._groupName},t.prototype.groupName=function(){return this._groupName},t.prototype.key=function(){return null},t.CLASS_IDENTIFIER_Property_def="definitionSystem.Property",t}(l.Property);t.Property=E;var _=function(e){function t(t,n){var r=e.call(this,t)||this;return r._node=n,r}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=e.getClassIdentifier(),r=0;r<n.length;r++)if(n[r]==t.CLASS_IDENTIFIER)return!0;return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER)},t.prototype.withDisplayName=function(e){this._displayName=e},t.prototype.getDisplayName=function(){return this._displayName},t.prototype.node=function(){return this._node||null==this.sourceProvider||(this._node=this.sourceProvider.getSource()),this._node},t.prototype.setSourceProvider=function(e){this.sourceProvider=e},t.CLASS_IDENTIFIER="definitionSystem.UserDefinedProp",t}(E);t.UserDefinedProp=_;var T=function(){function e(){}return e.prototype.setDocTableName=function(e){this._documentationTableName=e},e.prototype.docTableName=function(){return this._documentationTableName},e.prototype.setHidden=function(e){this._isHidden=e},e.prototype.isHidden=function(){return this._isHidden},e.prototype.setMarkdownDescription=function(e){this._markdownDescription=e},e.prototype.markdownDescription=function(){return this._markdownDescription},e.prototype.setValueDescription=function(e){this._valueDescription=e},e.prototype.valueDescription=function(){return this._valueDescription},e}();t.RAMLPropertyDocumentationService=T;var S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return u(t,e),t.prototype.isSystem=function(){return this._isSystemProperty},t.prototype.withSystem=function(e){return this._isSystemProperty=e,this},t.prototype.isEmbedMap=function(){return this._isEmbededMap},t.prototype.withEmbedMap=function(){return this._isEmbededMap=!0,this},t}(T);t.RAMLPropertyParserService=S;var N=function(e){function t(t){var n=e.call(this)||this;if(n._property=t,n._meta={},!t)throw new Error;return n}return u(t,e),t.prototype.valueDocProvider=function(){return this._property.valueDocProvider()},t.prototype.withPropertyGrammarType=function(e){this._propertyGrammarType=e},t.prototype.getPropertyGrammarType=function(){return this._propertyGrammarType},t.prototype.id=function(){return this._property.nameId()},t.prototype.range=function(){return this._property.range()},t.prototype.domain=function(){return this._property.domain()},t.prototype.isAllowNull=function(){return this._property.isAllowNull()},t.prototype.referencesTo=function(){return this._property.referencesTo()},t.prototype.isReference=function(){return this._property.isReference()},t.prototype.nameId=function(){return this._property.nameId()},t.prototype.priority=function(){return this.isKey()?128:this.isReference()?64:this.isTypeExpr()?32:"example"==this.nameId()?0:-1024},t.prototype.isKey=function(){return this._property instanceof E&&this._property.isKey()},t.prototype.isMerged=function(){return this._property instanceof E&&this._property.isMerged()},t.prototype.isTypeExpr=function(){return this.texpr},t.prototype.isExampleProperty=function(){return this.example},t.prototype.setExample=function(e){this.example=e},t.prototype.setTypeExpression=function(e){this.texpr=e},t.prototype.isDescriminating=function(){return this._property.isDescriminator()},t.prototype.putMeta=function(e,t){this._meta[e]=t},t.prototype.meta=function(e){return this._meta[e]},t}(S);t.RAMLPropertyService=N;var I=function(){function e(e){
//!!!
this._allowsOptionalProperties=!1,this._possibleInterfaces=[],
//!!!
this._canInherit=[],this._declaredBy=[],
//!!!
this._aliases=[],
//!!!???
this._defining=[],this._runtimeExtenders=[],
//!!!???
this._declaresType=null,
//!!!
this._isTemplate=!1,
//!!!
this._contextRequirements=[],this._type=e}return e.prototype.withAllowQuestion=function(){this._allowsOptionalProperties=!0},e.prototype.getAllowQuestion=function(){return this._allowsOptionalProperties},e.prototype.withCanInherit=function(e){this._canInherit.push(e)},e.prototype.getReferenceIs=function(){return this._referenceIs},e.prototype.withReferenceIs=function(e){this._referenceIs=e},e.prototype.descriminatorValue=function(){return 0==this.valueRequirements().length?this.nameId():this.valueRequirements()[0].value},e.prototype.getCanInherit=function(){return this._canInherit},e.prototype.withAllowAny=function(){this._allowsAnyChildren=!0},e.prototype.getAllowAny=function(){return this._allowsAnyChildren||this._type.isExternal()},e.prototype.globallyDeclaredBy=function(){return this._declaredBy},e.prototype.setGloballyDeclaredBy=function(e){this._declaredBy.push(e)},e.prototype.setDeclaringNode=function(e){this._node=e},e.prototype.nameId=function(){return this._type.nameId()},e.prototype.universe=function(){return this._type.universe()},e.prototype.isAssignableFrom=function(e){return this._type.isAssignableFrom(e)},e.prototype.setConsumesRefs=function(e){this._consumesRef=e},e.prototype.definingPropertyIsEnough=function(e){this._defining.push(e)},e.prototype.getDefining=function(){return this._defining},e.prototype.getConsumesRefs=function(){return this._consumesRef},e.prototype.addAlias=function(e){this._aliases.push(e)},e.prototype.getAliases=function(){return this._aliases},e.prototype.valueRequirements=function(){return this._type.valueRequirements()},e.prototype.isAnnotation=function(){return this._annotationChecked?this._isAnnotation:(this._annotationChecked=!0,this._isAnnotation=this._type.allSuperTypes().some(function(e){return e.key()&&"AnnotationRef"==e.key().name}),this._isAnnotation)},e.prototype.allowValue=function(){return this._allowsValueSet?this._allowsValue:this._type.allProperties().some(function(e){return e.isFromParentValue()||e.canBeValue()})?(this._allowsValue=!0,this._allowsValueSet=!0,!0):(this._allowsValueSet=!0,!1)},e.prototype.key=function(){return this._type.key()},e.prototype.getRepresentationOf=function(){return this._representationOf},e.prototype.getPath=function(){return""},e.prototype.isDeclaration=function(){return!!this._isTemplate||(!!this._convertsToGlobal||(!!this._declaresType||!(!this.key()||"Library"!==this.key().name)))},e.prototype.isGlobalDeclaration=function(){return!!this._actuallyExports||(!!this._isTemplate||!!this._declaresType)},e.prototype.isTypeSystemMember=function(){return null!=this._declaresType},e.prototype.getExtendedType=function(){return this.universe().type(this._declaresType)},e.prototype.setInlinedTemplates=function(e){return this._isTemplate=e,this},e.prototype.getRuntimeExtenders=function(){return this._runtimeExtenders},e.prototype.isInlinedTemplates=function(){return this._isTemplate},e.prototype.setExtendedTypeName=function(t){this._declaresType=t;var n=this.universe().type(t);if(n instanceof m){var r=n;r.getAdapter(e)._runtimeExtenders.push(this._type)}},e.prototype.getKeyProp=function(){for(var e=this._type.allProperties(),t=0;t<e.length;t++)if(e[t].getAdapter(N).isKey())return e[t];return null},e.prototype.withActuallyExports=function(e){this._actuallyExports=e},e.prototype.withConvertsToGlobal=function(e){this._convertsToGlobal=e},e.prototype.getConvertsToGlobal=function(){return this._convertsToGlobal},e.prototype.getActuallyExports=function(){return this._actuallyExports},e.prototype.isUserDefined=function(){return this._type instanceof m?this._type.isUserDefined():this._type instanceof p&&this._type.isUserDefined()},e.prototype.withContextRequirement=function(e,t){this._contextRequirements.push({name:e,value:t})},e.prototype.getContextRequirements=function(){return this._contextRequirements},e.prototype.findMembersDeterminer=function(){for(var e=this._type.allProperties(),t=0;t<e.length;t++)if(e[t].isThisPropertyDeclaresTypeFields())return e[t];return null},e.prototype.getDeclaringNode=function(){if(this._node)return this._node;if(this._type){var e=this._type.getExtra(t.SOURCE_EXTRA);return e?e instanceof f||e.getSource&&"function"==typeof e.getSource?e.getSource():e:null}return null},e.prototype.registerSupertypes=function(e){var t=this,n=this._type.universe();e.forEach(function(e){var r=n.type(e);r&&t._type.addSuperType(r)})},e.prototype.registerPossibleInterfaces=function(e){for(var t=this._type.universe(),n=0,r=e;n<r.length;n++){var i=r[n],a=t.type(i);if(!a)return;this._possibleInterfaces.push(a)}},e.prototype.possibleInterfaces=function(){return this._possibleInterfaces},e}();t.RAMLService=I;var b={},R=n(178),M=R.universeDumps,C=n(181),w=n(197);t.universesInfo=w,t.getUniverse=function(){var e=function(e){if(b[e])return b[e];var t=M[e],n=C.toDefSystem(t,"RAML08"==e?w.Universe08:w.Universe10);return n&&(n.setUniverseVersion(e),b[e]=n),n};return e.availableUniverses=function(){return Object.keys(M)},e}()},function(e,t,n){"use strict";function r(){return P}function i(e){return e instanceof S.AbstractType}function a(e,t){return void 0===t&&(t=S.builtInRegistry()),N.parseJSONTypeCollection(e,t)}function o(e){return N.parseJSON(null,e,S.builtInRegistry())}function s(e){return e.types||e.annotationTypes?N.parseJSONTypeCollection(e):N.parseJSON(null,e)}function u(e,t){return N.parseJSON(null,e,t?t.getTypeRegistry():S.builtInRegistry())}function l(e,t){return void 0===t&&(t=!1),N.parseTypeCollection(e,S.builtInRegistry(),t)}function p(e,t,n,r,i,a,o){if(void 0===r&&(r=!1),void 0===i&&(i=!1),void 0===a&&(a=!0),void 0===o&&(o=!1),a){var s;if(s=i?n.getAnnotationType(e):n.getType(e),null!=s)return s}return N.parse(e,t,n?n.getTypeRegistry():S.builtInRegistry(),r,i,a,o,!1,[])}function c(e){return N.storeAsJSON(e)}function f(e,t,n){void 0===n&&(n=!1),S.autoCloseFlag=n;try{return t.validate(e,n)}finally{S.autoCloseFlag=!1}}function h(e,t){return e.validateType(t.getAnnotationTypeRegistry())}function d(e,t){return t.ac(e)}function m(e){return e.canDoAc()}function y(){return I.getInstance().allPrototypes()}function v(){return S.builtInRegistry()}function g(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return S.derive(e,t)}function A(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return S.union(e,t)}function E(e){w.setPropertyConstructor(e)}function _(e,t){return w.toNominal(e,t)}function T(e){return S.toValidationPath(e)}Object.defineProperty(t,"__esModule",{value:!0});var S=n(58);t.tsInterfaces=n(74);var N=n(171),I=n(135),b=n(75),R=n(77),M=n(77),C=n(77),w=n(174);t.nominalTypes=n(175),t.nominalInterfaces=n(176),t.typeExpressions=n(177);var P=n(60);t.TOP_LEVEL_EXTRA=t.tsInterfaces.TOP_LEVEL_EXTRA,t.DEFINED_IN_TYPES_EXTRA=t.tsInterfaces.DEFINED_IN_TYPES_EXTRA,t.USER_DEFINED_EXTRA=t.tsInterfaces.USER_DEFINED_EXTRA,t.SOURCE_EXTRA=t.tsInterfaces.SOURCE_EXTRA,t.messageRegistry=n(72),t.getSchemaUtils=r,t.isParsedType=i,t.loadTypeCollection=a,t.loadType=o,t.parse=s,t.parseType=u;var L;!function(e){e[e.SCALAR=0]="SCALAR",e[e.ARRAY=1]="ARRAY",e[e.MAP=2]="MAP"}(L=t.NodeKind||(t.NodeKind={})),t.parseFromAST=l,t.parseTypeFromAST=p,t.dump=c,t.validate=f,t.validateTypeDefinition=h,t.performAC=d,t.checkACStatus=m,t.builtInFacets=y,t.builtInTypes=v,t.derive=g,t.unify=A;var O=function(){function e(e){this.target=e}return e.prototype.addProperty=function(e,t,n){return this.target.declareProperty(e,t,n),this},e.prototype.closeType=function(){return this.target.addMeta(new b.KnownPropertyRestriction(!1)),this},e.prototype.annotate=function(e,t){return this.target.addMeta(new R.Annotation(e,t,"("+t+")")),this},e.prototype.customFacet=function(e,t){return this.target.addMeta(new M.CustomFacet(e,t)),this},e.prototype.customFacetDeclaration=function(e,t,n){return void 0===n&&(n=!0),this.target.addMeta(new C.FacetDeclaration(e,t,n)),this},e.prototype.addSimpleFacet=function(e,t){return this.target.addMeta(I.getInstance().buildFacet(e,t)),this},e.prototype.getResult=function(){return this.target},e}();t.TypeConstructor=O,t.setPropertyConstructor=E,t.toNominal=_,t.toValidationPath=T},function(e,t,n){"use strict";function r(){return new I(I.OK,"","",null)}function i(e,t,n,r,i){void 0===n&&(n={}),void 0===r&&(r=I.ERROR),void 0===i&&(i=!1);var a=b(e,n);return new I(r,e.code,a,t,i)}function a(){return ie}function o(e,t){return new ne(e,t)}function s(e,t){return new re(e,t)}function u(e,n){var r=new ee(e);return n.forEach(function(e){return r.addSuper(e)}),r.isSubTypeOf(t.NIL)?r.nullable=!0:1==n.length&&n[0]==t.ANY&&(r.nullable=!0),r}function l(e){return u(e,[t.OBJECT])}function p(e,t,n){if(t.isScalar()&&n.isScalar()){if(t.allSubTypes().indexOf(n)!=-1)return t;if(n.allSubTypes().indexOf(t)!=-1)return n}var r=t.oneMeta(P.Discriminator),i=n.oneMeta(P.Discriminator);if(r&&i&&r.property===i.property){var a=t.descValue(),o=n.descValue();if(a!==o){var s=e[r.property];if(s===a)return t;if(s===o)return n}}return null}function c(e){return parseFloat(e)==parseInt(e)&&!isNaN(e)}function f(e){for(var t=[];null!=e;){if(null!=e.name()){t.push(e.name());break}if(!(e instanceof ee))break;var n=e.contextMeta();if(null==n)break;t.push(n.path()),e=n._owner}return t.reverse()}function h(e,n,a){var o=n.metaOfType(P.Discriminator);if(0==o.length)return null;var s=o[0].value(),u=T.find([n].concat(n.allSuperTypes()),function(e){return e.getExtra(t.GLOBAL)});if(!u)return null;var l=u.name(),p=n.metaOfType(P.DiscriminatorValue);if(0!=p.length&&(l=p[0].value()),l){if(e.hasOwnProperty(s)){var c=e[s];if(c!=l){var f=i(I.CODE_INCORRECT_DISCRIMINATOR,this,{rootType:u.name(),value:c,propName:s},I.WARNING);return d(f,{name:s,child:a}),f}return r()}var h=i(I.CODE_MISSING_DISCRIMINATOR,this,{rootType:u.name(),propName:s});return d(h,a),h}}function d(e,t){if(e.getValidationPath()){for(var n=m(t),r=n;r.child;)r=r.child;r.child=e.getValidationPath(),e.setValidationPath(n)}else e.setValidationPath(t);e.getSubStatuses().forEach(function(e){d(e,t)})}function m(e){if(e){for(var t=e,n=null,r=null;t;)if(n){var i={name:t.name};r.child=i,t=t.child,r=i}else n={name:t.name},r=n,t=t.child,r=n;return n}return null}function y(e){for(var t=N.getAnnotationValidationPlugins(),n=[],r=0,i=t;r<i.length;r++){var a=i[r],o=a.process(e);o&&o.forEach(function(t){n.push(g(t,a.id(),e.entry()))})}return n}function v(e,t){for(var n=N.getTypeValidationPlugins(),r=[],i=0,a=n;i<a.length;i++){var o=a[i],s=o.process(e,t);s&&s.forEach(function(t){r.push(g(t,o.id(),e))})}return r}function g(e,n,r){var i=e.isWarning?I.WARNING:I.ERROR,a=e.issueCode||n,o=e.message||b(t.messageRegistry.PLUGIN_REPORTS_AN_ERROR,{pluginId:n}),s=new I(i,a,o,r);return s.setValidationPath(e.path),s}function A(e){if(!e)return null;if(e=e.trim(),0==e.length)return null;if("#"==e.charAt(0)&&(e=e.substring(1)),"/"==e.charAt(0)&&(e=e.substring(1)),0==e.length)return null;for(var t=e.split("/"),n={name:t[0]},r=n,i=1;i<t.length;i++){var a={name:t[i]};r.child=a,r=a}return n}function E(e){return!e||e.isSubTypeOf(t.UNKNOWN)&&!e.oneMeta(P.SkipValidation)}var _=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var T=n(59),S=n(60),N=n(74);t.messageRegistry=n(72);var I=function(){function e(e,t,n,r,i){void 0===i&&(i=!1),this.takeNodeFromSource=i,this.subStatus=[],this.severity=e,this.code=t,this.message=n,this.source=r}return e.prototype.getValidationPath=function(){return this.vp},e.prototype.getValidationPathAsString=function(){if(!this.vp)return"";for(var e="",t=this.vp;t;)e+=t.name,t.child&&(e+="/"),t=t.child;return e},e.prototype.setValidationPath=function(e){this.vp=e},e.prototype.addSubStatus=function(t,n){if(void 0===n&&(n=null),t){n&&d(t,{name:n}),this.subStatus.push(t);var r=e.OK;t.isOk()||(t.isError()?r=e.ERROR:t.isWarning()?r=e.WARNING:t.isInfo()&&(r=e.INFO)),this.severity<r&&(this.severity=r,this.message=t.getMessage())}},e.prototype.getErrors=function(){if(this.isError()||this.isWarning()){if(this.subStatus.length>0){var e=[];return this.subStatus.forEach(function(t){return e=e.concat(t.getErrors())}),e}return[this]}return[]},e.prototype.getSubStatuses=function(){return this.subStatus},e.prototype.getSeverity=function(){return this.severity},e.prototype.getMessage=function(){return this.message},e.prototype.setMessage=function(e){this.message=e},e.prototype.getSource=function(){return this.source},e.prototype.getCode=function(){return this.code},e.prototype.setCode=function(e){this.code=e},e.prototype.isWarning=function(){return this.severity==e.WARNING},e.prototype.isError=function(){return this.severity==e.ERROR},e.prototype.isOk=function(){return this.severity===e.OK},e.prototype.isInfo=function(){return this.severity===e.INFO},e.prototype.setSource=function(e){this.source=e},e.prototype.toString=function(){return this.isOk()?"OK":this.message},e.prototype.getExtra=function(e){return this.takeNodeFromSource&&e==N.SOURCE_EXTRA&&this.source instanceof R?this.source.node():null},e.prototype.putExtra=function(e,t){},e.prototype.setInternalRange=function(e){this.internalRange=e},e.prototype.getInternalRange=function(){return this.internalRange},e.prototype.getInternalPath=function(){return this.internalPath},e.prototype.setInternalPath=function(e){this.internalPath=e},e.prototype.getFilePath=function(){return this.filePath},e.prototype.setFilePath=function(e){this.filePath=e},e.CODE_CONFLICTING_TYPE_KIND=4,e.CODE_INCORRECT_DISCRIMINATOR=t.messageRegistry.INCORRECT_DISCRIMINATOR,e.CODE_MISSING_DISCRIMINATOR=t.messageRegistry.MISSING_DISCRIMINATOR,e.ERROR=3,e.INFO=1,e.OK=0,e.WARNING=2,e}();t.Status=I,t.ok=r,t.SCHEMA_AND_TYPE=N.SCHEMA_AND_TYPE_EXTRA,t.GLOBAL=N.GLOBAL_EXTRA,t.TOPLEVEL=N.TOP_LEVEL_EXTRA,t.SOURCE_EXTRA=N.SOURCE_EXTRA;var b=function(e,n){for(var r="",i=e.message,a=0,o=i.indexOf("{{");o>=0;o=i.indexOf("{{",a)){if(r+=i.substring(a,o),a=i.indexOf("}}",o),a<0){a=o;break}o+="{{".length;var s=i.substring(o,a);a+="}}".length;var u=n[s];if(void 0===u)throw new Error(b(t.messageRegistry.MESSAGE_PARAMETER_NO_VALUE,{paramName:s}));r+=u}return r+=i.substring(a,i.length)};t.error=i;var R=function(){function e(e){this._inheritable=e,this._annotations=[]}return e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER_TypeInformation)},e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&T.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER_TypeInformation)},e.prototype.node=function(){return this._node},e.prototype.setNode=function(e){this._node=e},e.prototype.owner=function(){return this._owner},e.prototype.isInheritable=function(){return this._inheritable},e.prototype.validateSelf=function(e){var t=r();if(this.node()&&this.node().getMeta("skipValidation"))return t;for(var n=0,i=this._annotations;n<i.length;n++){var a=i[n],o=a.validateSelf(e);o.isOk()||t.addSubStatus(o)}for(var s=new Ae(this,e),u=y(s),l=0,p=u;l<p.length;l++){var c=p[l];c.isOk()||t.addSubStatus(c)}return d(t,{name:this.facetName()}),this.validateSelfIndividual(t,e)},e.prototype.validateSelfIndividual=function(e,t){return e},e.prototype.requiredTypes=function(){return[]},e.prototype.annotations=function(){return this._annotations},e.prototype.addAnnotation=function(e){this._annotations.push(e)},e.prototype.isConstraint=function(){return!1},e.CLASS_IDENTIFIER_TypeInformation="typesystem.TypeInformation",e}();t.TypeInformation=R;var M=null,C=function(e){function t(t){return void 0===t&&(t=!0),e.call(this,t)||this}return _(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_Constraint)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_Constraint)},t.prototype.intersect=function(e,n){var r=e.id()+""+n.id();if(t.intersections.hasOwnProperty(r))return t.intersections[r];var i=s(r,[e,n]);return t.intersections[r]=i,i},t.prototype.release=function(e){delete t.intersections[e.name()]},t.prototype.nothing=function(e,t){return void 0===t&&(t="Conflicting restrictions"),new se(M,t,e)},t.prototype.composeWith=function(e){return null},t.prototype.preoptimize=function(){null===M&&(M=new oe(null,null,"top")),M=M.push(this);try{return this.innerOptimize()}finally{M=M.pop()}},t.prototype.innerOptimize=function(){return this},t.prototype.tryCompose=function(e){null===M&&(M=new oe(null,null,"top")),M=M.push(this);try{return this.composeWith(e)}finally{M=M.pop()}},t.prototype.kind=function(){return N.MetaInformationKind.Constraint},t.prototype.conflictMessage=function(e,t){return null},t.prototype.isConstraint=function(){return!0},t.CLASS_IDENTIFIER_Constraint="typesystem.TypeInformation",t.intersections={},t}(R);t.Constraint=C;var w=n(75),P=n(77),L=n(135),O=n(75),D=n(77),U=n(77),x=n(75),k=n(75),F=n(136),B=n(77),V=n(75);t.autoCloseFlag=!1;var K=function(){function e(e,t,n){void 0===e&&(e=null),void 0===n&&(n=!1),this._parent=e,this._c=t,this.isAnnotationsReg=n,this._types={},this.typeList=[],this.chainedTypes={}}return e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER_TypeRegistry)},e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&T.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER_TypeRegistry)},e.prototype.put=function(e,t){this._types[e]=t},e.prototype.addType=function(e){e.isAnonymous()||(this._types[e.name()]=e,this.typeList.push(e))},e.prototype.get=function(e){return this._types.hasOwnProperty(e)?this._types[e]:null!=this._parent?this._parent.get(e):null},e.prototype.getByChain=function(e){var t=this.get(e);return t||(t=this.chainedTypes[e]),t?t:(t=this.getTypeByChainFromCollection(e,this._c),t&&(this.chainedTypes[e]=t),t)},e.prototype.getTypeByChainFromCollection=function(e,t){var n=this.isAnnotationsReg?t.getAnnotationType(e):t.getType(e);if(n)return n;for(var r=e.indexOf(".");r>=0;r=e.indexOf(".",r+1)){var i=e.substring(0,r),a=e.substr(r+1),o=t.library(i);if(o&&(n=this.getTypeByChainFromCollection(a,o)))return n}return null},e.prototype.types=function(){return this.typeList},e.prototype.typeMap=function(){return this._types},e.prototype.parent=function(){return this._parent},e.CLASS_IDENTIFIER_TypeRegistry="typesystem.TypeRegistry",e}();t.TypeRegistry=K;var j=function(){function e(){}return e.prototype.getInfos=function(e){if(e.getExtra("PInfos"))return e.getExtra("PInfos");var t={};return e.meta().forEach(function(e){if(e instanceof w.HasProperty){var n=e.value();t[n]={name:n,type:null}}}),e.meta().forEach(function(e){if(e instanceof w.PropertyIs){var n=e.propertyName();t[n]&&(t[n].type=e.value())}}),e.putExtra("PInfos",t),t},e.prototype.validate=function(e,t){var n=this,r=this.getInfos(e),i=!1;return Object.keys(r).forEach(function(e){i=i||n.validateInfo(r[e],t)}),i},e.prototype.validateInfo=function(e,t){var n=this;if(t.some(function(t){return t==e}))return!0;if(e.type instanceof ne){var r=e.type,i=!0;return r.options().forEach(function(r){n.validate(r,[e].concat(t))||(i=!1)}),i}return e.type.isArray()?void 0:this.validate(e.type,[e].concat(t))},e.prototype.validateType=function(e){var t=this,n=this.getInfos(e),r=[];return Object.keys(n).forEach(function(e){t.validateInfo(n[e],[])&&r.push(e)}),r},e}(),W=function(e){function n(n,r,i){var a=e.call(this,I.ERROR,t.messageRegistry.RESTRICTIONS_CONFLICT.code,null,i)||this;return a._conflicting=n,a._stack=r,a.source=i,a.computeMessage(),a}return _(n,e),n.prototype.computeMessage=function(){var e=null;if(null!=this._stack&&this._stack.getRestriction()instanceof w.MinMaxRestriction){var t=this._stack.getRestriction();e=this._conflicting.conflictMessage(t.facetPath(),t.value())}null==e&&(e=this._conflicting+" and "+(null!=this._stack?this._stack.getRestriction().toString():""));var n="";if(this.source instanceof q){for(var r=[],i=this._stack;i;){var a=i.getRestriction();if(a instanceof x.PropertyIs){var o={name:a.propId()};r.length>0&&(o.child=r[r.length-1]),r.push(o)}i=i.pop()}d(this,r.pop());var s=w.anotherRestrictionComponent();n=s?" between types '"+f(this.source)+"' and '"+f(s)+"'":" in type '"+f(this.source)+"'"}this.message="Restrictions conflict"+n+": "+e},n.prototype.getConflictDescription=function(){var e="";return e+="Restrictions coflict:\n",e+=this._stack.getRestriction()+" conflicts with "+this._conflicting+"\n",e+="at\n",e+=this._stack.pop()},n.prototype.getConflicting=function(){return this._conflicting},n.prototype.getStack=function(){return this._stack},n.prototype.toRestriction=function(){return new se(this._stack,this.message,this._conflicting)},n}(I);t.RestrictionsConflict=W;var H=0;t.VALIDATED_TYPE=null;var Y=function(){function e(e){if(w.MatchesProperty.isInstance(e)){this._matches=e;var t=this._matches.facetName();"propertyIs"==t?this.isProp=!0:"mapPropertyIs"==t?this.isMap=!0:"additionalProperties"==t&&(this.isAdditionalProp=!0)}else this.isFacet=!0,this._facetDecl=e}return e.prototype.name=function(){return this.isFacet?this._facetDecl.actualName():this._matches.path()},e.prototype.isPattern=function(){return this.isMap},e.prototype.isAdditional=function(){return this.isAdditionalProp},e.prototype.declaredAt=function(){return this.isFacet?this._facetDecl.owner():this._matches.owner()},e.prototype.range=function(){return this.isFacet?this._facetDecl.type():this._matches.range()},e.prototype.required=function(){return void 0!==this._required?this._required:this.isProp?!this.property().isOptional():this.isMap?!this.mapProperty().isOptional():!!this.isAdditionalProp&&!this.additionalProperty().isOptional()},e.prototype.setRequired=function(e){this._required=e},e.prototype.property=function(){return this.isProp?this._matches:null},e.prototype.mapProperty=function(){return this.isMap?this._matches:null},e.prototype.additionalProperty=function(){return this.isAdditionalProp?this._matches:null},e.prototype.annotations=function(){return this._matches?this._matches.annotations():[]},e}();t.PropertyInfo=Y;var q=function(){function e(e){this._name=e,this.metaInfo=[],this._subTypes=[],this.innerid=H++,this.extras={},this._locked=!1}return e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER_AbstractType)},e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&T.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER_AbstractType)},e.prototype.annotation=function(e){for(var t=0,n=this.annotations();t<n.length;t++){var r=n[t];if(r.name()==e)return r.value()}return null},e.prototype.isAssignableFrom=function(e){if(e.allSuperTypes().indexOf(this)!=-1)return!0;var t=this.restrictions().filter(function(e){return!P.DiscriminatorValue.isInstance(e)}),n=e.restrictions(),r=!0;return t.forEach(function(e){var t=!1;n.forEach(function(n){var r=e.composeWith(n);r==n&&(t=!0),ue.isInstance(n)&&null!=r&&r==e&&(t=!0)}),r=r&&t}),r},e.prototype.registry=function(){return this._collection},e.prototype.cloneWithFilter=function(e,t){var n=this.clone(),r=[];return this.metaInfo.forEach(function(t){var i=e(t,n);"boolean"==typeof i?i&&r.push(t):i&&r.push(i)}),n.metaInfo=r,n},e.prototype.options=function(){if(this.isUnion()){var e=[];return this.allSuperTypes().forEach(function(t){if(ne.isInstance(t)){var n=t.options();e=e.concat(n)}}),T.unique(e)}return[this]},e.prototype.allOptions=function(){if(this.isUnion()){var e=[];return this.allSuperTypes().forEach(function(t){if(ne.isInstance(t)){var n=t.allOptions();e=e.concat(n)}}),T.unique(e)}return[this]},e.prototype.examples=function(){return F.exampleFromInheritedType2(this)},e.prototype.collection=function(){if(!this._collection&&this._contextMeta){var e=this._contextMeta;if(e)return e.owner().collection()}return this._collection},e.prototype.getExtra=function(e){return this.extras[e]},e.prototype.putExtra=function(e,t){this.extras[e]=t},e.prototype.id=function(){return this.innerid},e.prototype.knownProperties=function(){return this.metaOfType(V.MatchesProperty)},e.prototype.lock=function(){this._locked=!0},e.prototype.isLocked=function(){return this._locked},e.prototype.patchName=function(e){this._name=e},e.prototype.allFacets=function(){return this.meta().filter(function(e){return!P.DiscriminatorValue.isInstance(e)||e.isStrict()})},e.prototype.declaredFacets=function(){return this.declaredMeta()},e.prototype.isSubTypeOf=function(e){return e===t.ANY||this===e||this.superTypes().some(function(t){return t.isSubTypeOf(e)})},e.prototype.isSuperTypeOf=function(e){return this===e||this.allSubTypes().indexOf(e)!=-1},e.prototype.addMeta=function(e){this.metaInfo.push(e),e._owner=this,this.propertyInfos=null,this.propertiesMap=null,this.definedFacetInfos=null,this.definedFacetInfosMap=null},e.prototype.name=function(){return this._name},e.prototype.label=function(){return this._name},e.prototype.subTypes=function(){return this._subTypes},e.prototype.superTypes=function(){return[]},e.prototype.addSupertypeAnnotation=function(e,t){if(e&&0!=e.length){this.supertypeAnnotations||(this.supertypeAnnotations=[]);var n=this.supertypeAnnotations[t];n||(n={},this.supertypeAnnotations[t]=n);for(var r=0,i=e;r<i.length;r++){var a=i[r];n[a.facetName()]=a}}},e.prototype.validateType=function(e){var n=this;void 0===e&&(e=a());var r=new I(I.OK,"","",this);if(this.validateHierarchy(r),this.getExtra(N.PARSE_ERROR)&&r.addSubStatus(this.getExtra(N.PARSE_ERROR)),r.isOk()){if(r.addSubStatus(this.checkConfluent()),this.isExternal()&&"external"==this.kind()){var o=this;if(o.isJSON())try{var s=S.getJSONSchema(o.schema(),o.getContentProvider&&o.getContentProvider());s&&s.validateSelf()}catch(e){if("Maximum call stack size exceeded"==e.message)return i(t.messageRegistry.CIRCULAR_REFS_IN_JSON_SCHEMA,this);if(ge.isInstance(e)){var u=e,l=i(u.messageEntry,this,u.parameters,u.isWarning?I.WARNING:I.ERROR);l.setInternalRange(u.internalRange),l.setInternalPath(A(u.internalPath)),l.setFilePath(u.filePath),r.addSubStatus(l)}else r.addSubStatus(i(t.messageRegistry.JSON_SCHEMA_VALIDATION_EXCEPTION,this,{msg:e.message}))}}r.isOk()&&this.superTypes().forEach(function(t){if(t.isAnonymous()){var n=t.validateType(e);n.isOk()||(d(n,{name:"type"}),r.addSubStatus(n))}})}if(this.getExtra(t.SCHEMA_AND_TYPE)&&r.addSubStatus(i(t.messageRegistry.SCHEMA_AND_TYPE,this)),r.isOk()&&this.validateMeta(e).getErrors().forEach(function(e){return r.addSubStatus(e)}),this.isObject()){var p={};this.restrictions().forEach(function(e){e.owner()!=n&&e instanceof w.HasProperty&&(p[e.value()]=!0)}),this.declaredMeta().forEach(function(e){e instanceof w.HasProperty&&delete p[e.value()]}),this.declaredMeta().forEach(function(e){if(e instanceof w.PropertyIs){var a=e;p.hasOwnProperty(a.propertyName())&&r.addSubStatus(i(t.messageRegistry.REQUIRED_OVERRIDE_OPTIONAL,n,{propertyName:a.propertyName()}))}});var c=(new j).validateType(this);c.length>0&&c.forEach(function(e){var a=i(t.messageRegistry.CYCLIC_DEPENDENCY,n,{typeName:e});d(a,{name:e}),r.addSubStatus(a)})}if(this.supertypeAnnotations)for(var f=0;f<this.supertypeAnnotations.length;f++)for(var h=this.supertypeAnnotations[f],m=0,g=Object.keys(h);m<g.length;m++){var E=g[m],_=h[E],T=_.validateSelf(e);T.isOk()||(d(T,{name:"type",child:{name:f}}),r.addSubStatus(T))}for(var b=v(this,e),R=0,M=b;R<M.length;R++){var C=M[R];r.addSubStatus(C)}for(var P=new _e(this,e),L=y(P),O=0,D=L;O<D.length;O++){var C=D[O];r.addSubStatus(C)}return r},e.prototype.validateHierarchy=function(e){var n=this;if(this.isAnonymous()||this.getExtra(N.TOP_LEVEL_EXTRA)&&a().get(this.name())&&e.addSubStatus(i(t.messageRegistry.REDEFINIG_BUILDTIN,this,{typeName:this.name()})),this.isSubTypeOf(t.RECURRENT)&&e.addSubStatus(i(t.messageRegistry.RECURRENT_DEFINITION,this),"type"),E(this)){var r=this.metaOfType(P.ImportedByChain);if(r.length>0){var o=[];r.forEach(function(e){o.push(i(t.messageRegistry.INHERITING_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN,n,{typeName:e.value()}))}),o.forEach(function(t){return e.addSubStatus(t,"type")})}else e.addSubStatus(i(t.messageRegistry.INHERITING_UNKNOWN_TYPE,this),"type")}if(this.isUnion()){for(var s=this.typeFamily(),u=[],l=!1,p=!1,c=0,f=s;c<f.length;c++){var h=f[c];h.isSubTypeOf(t.RECURRENT)?l=!0:h.isSubTypeOf(t.UNKNOWN)&&(p=!0),h.metaOfType(P.ImportedByChain).forEach(function(e){return u.push(e)})}l&&e.addSubStatus(i(t.messageRegistry.RECURRENT_UNION_OPTION,this),"type"),p&&(u.length>0?(u=T.unique(u),u.length>0&&u.forEach(function(r){var a=r.value(),o=t.messageRegistry.UNION_OPTION_TYPE_DEPENDS_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN;n.options().some(function(e){return e.name()==a})&&(o=t.messageRegistry.UNION_OPTION_TYPE_OPTION_IMPORTED_THROUGH_LIBRARY_CHAIN),e.addSubStatus(i(o,n,{typeName:a}),"type")})):e.addSubStatus(i(t.messageRegistry.UNKNOWN_UNION_OPTION,this),"type"))}if(this.isArray()){for(var m=this.familyWithArray(),y=this.getExtra(N.HAS_ITEMS)?"items":"type",v=[],l=!1,g=!1,A=0,_=m;A<_.length;A++){var h=_[A];h==this||h===t.RECURRENT?l=!0:h==t.UNKNOWN&&(g=!0),h.metaOfType(P.ImportedByChain).forEach(function(e){return v.push(e)})}if(l)e.addSubStatus(i(t.messageRegistry.RECURRENT_ARRAY_DEFINITION,this),y);else if(g){var S=this.oneMeta(k.ComponentShouldBeOfType).value().name();v.length>0?(v=T.unique(v),v.forEach(function(r){var a=S,o=t.messageRegistry.ARRAY_COMPONENT_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN;a?r.value()!=a&&(o=t.messageRegistry.ARRAY_COMPONENT_TYPE_DEPENDES_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN,a=r.value()):S=r.value(),e.addSubStatus(i(o,n,{componentTypeName:S,typeName:a}),y)})):e.addSubStatus(i(t.messageRegistry.UNKNOWN_ARRAY_COMPONENT_TYPE,this,{componentTypeName:S}),y)}}var I=this.superTypes(),b=!1,R=!1;if(I.length>1&&I.forEach(function(e){e.isExternal()?b=!0:R=!0}),b&&R&&e.addSubStatus(i(t.messageRegistry.EXTERNALS_MIX,this)),this instanceof ne){var M=this;M.options().forEach(function(r){r.isExternal()&&e.addSubStatus(i(t.messageRegistry.EXTERNALS_MIX,n))})}if(this.isExternal()&&this.getExtra(N.HAS_FACETS)){var C=this.getExtra(N.HAS_FACETS);if(C.length){var w=C[C.length-1],L=i(t.messageRegistry.EXTERNAL_FACET,this,{name:w});d(L,{name:w}),e.addSubStatus(L)}}},e.prototype.familyWithArray=function(){if(this.oneMeta(P.SkipValidation))return[];var e=[];this.fillSuperTypes(e,!0);var t=this.oneMeta(k.ComponentShouldBeOfType);if(t){var n=t.value();n.oneMeta(P.SkipValidation)||(e=e.concat(n.familyWithArray().concat(n)))}return e},e.prototype.validateMeta=function(e){var t=new I(I.OK,"","",this);return this.declaredMeta().forEach(function(n){n.validateSelf(e).getErrors().forEach(function(e){return t.addSubStatus(e)})}),this.validateFacets(t),t},e.prototype.validateFacets=function(e){var n=this,r={},a={},o={};this.meta().forEach(function(e){if(e instanceof D.FacetDeclaration){var t=e;r[t.actualName()]=t,t.isOptional()||t.owner()!==n&&(o[t.actualName()]=t),t.owner()!=n&&(a[t.actualName()]=t)}}),this.declaredMeta().forEach(function(r){if(r instanceof D.FacetDeclaration){var o=r;if(o.owner()==n){var s=o.actualName();a.hasOwnProperty(s)&&e.addSubStatus(i(t.messageRegistry.OVERRIDE_FACET,n,{name:s}));var u=L.getInstance().facetPrototypeWithName(s);(u&&u.isApplicable(n)||"type"==s||"properties"==o.facetName()||"schema"==s||"facets"==s||"uses"==s)&&e.addSubStatus(i(t.messageRegistry.OVERRIDE_BUILTIN_FACET,n,{name:s})),"("==s.charAt(0)&&e.addSubStatus(i(t.messageRegistry.FACET_START_BRACKET,n,{name:s}))}}});var s={};this.meta().forEach(function(e){e instanceof x.PropertyIs&&(s[e.propId()]=!0)});for(var u=0,l=this.meta();u<l.length;u++){var p=l[u];if(p instanceof U.CustomFacet){var c=p;if(c.node()&&c.node().getMeta("skipValidation"))continue;var f=c.facetName();if(r.hasOwnProperty(f)){var h=r[f],m=h.value();if(h.owner()==this&&c.owner()==this){var y=i(t.messageRegistry.FACET_CAN_NOT_BE_FIXED_BY_THE_DECLARING_TYPE,c);
y.setValidationPath({name:f}),e.addSubStatus(y)}else{for(var v=m.validateDirect(c.value(),!1,!1),g=0,A=v.getErrors();g<A.length;g++){var E=A[g];d(E,{name:f}),e.addSubStatus(E)}delete o[f]}}else this.isExternal()?e.addSubStatus(i(t.messageRegistry.FACET_PROHIBITED_FOR_EXTERNALS,c,{facetName:f},I.ERROR,!0)):e.addSubStatus(i(t.messageRegistry.UNKNOWN_FACET,c,{facetName:f},I.ERROR,!0))}}Object.getOwnPropertyNames(o).length>0&&e.addSubStatus(i(t.messageRegistry.MISSING_REQUIRED_FACETS,this,{facetsList:Object.keys(o).map(function(e){return"'"+e+"'"}).join(",")}))},e.prototype.allSuperTypes=function(){var e=[];return this.fillSuperTypes(e),e},e.prototype.fillSuperTypes=function(e,t){void 0===t&&(t=!1);for(var n=0,r=this.superTypes();n<r.length;n++){var i=r[n];t&&i.oneMeta(P.SkipValidation)||T.contains(e,i)||(e.push(i),i.fillSuperTypes(e))}},e.prototype.allSubTypes=function(){var e=[];return this.fillSubTypes(e),e},e.prototype.fillSubTypes=function(e){this.subTypes().forEach(function(t){T.contains(e,t)||(e.push(t),t.fillSubTypes(e))})},e.prototype.inherit=function(e){var t=new ee(e);return t.addSuper(this),t},e.prototype.isAnonymous=function(){return!this._name||0===this._name.length},e.prototype.isEmpty=function(){return(null==this.extras||!this.extras.hasOwnProperty(N.PARSE_ERROR))&&(!(this.metaInfo.length>2)&&0==this.metaInfo.filter(function(e){return!B.NotScalar.isInstance(e)&&(P.DiscriminatorValue.isInstance(e)?e.isStrict():!P.SourceMap.isInstance(e)&&!P.ImportedByChain.isInstance(e))}).length)},e.prototype.isArray=function(){return this===t.ARRAY||this.allSuperTypes().indexOf(t.ARRAY)!=-1},e.prototype.propertySet=function(){var e=[];return this.meta().forEach(function(t){if(t instanceof x.PropertyIs){var n=t;e.push(n.propertyName())}}),T.uniq(e)},e.prototype.checkConfluent=function(){if(this.oneMeta(P.SkipValidation))return r();if(this.computeConfluent)return r();this.computeConfluent=!0;var e=w.anotherRestrictionComponentsCount();try{var t=w.optimize(this.restrictions()),n=T.find(t,function(e){return e instanceof ae});if(n){var i=null,a=null;if(n instanceof se){var o=n;i=o.getStack(),a=o.another()}var s=new W(a,i,this);return s}return r()}finally{this.computeConfluent=!1,w.releaseAnotherRestrictionComponent(e)}},e.prototype.isObject=function(){return this==t.OBJECT||T.some(this.allSuperTypes(),function(e){return e.isObject()})},e.prototype.isExternal=function(){return this==t.EXTERNAL||this.allSuperTypes().indexOf(t.EXTERNAL)!=-1},e.prototype.isBoolean=function(){return this==t.BOOLEAN||this.allSuperTypes().indexOf(t.BOOLEAN)!=-1},e.prototype.isString=function(){return this==t.STRING||this.allSuperTypes().indexOf(t.STRING)!=-1},e.prototype.isNumber=function(){return this==t.NUMBER||this.allSuperTypes().indexOf(t.NUMBER)!=-1},e.prototype.isFile=function(){return this==t.FILE||this.allSuperTypes().indexOf(t.FILE)!=-1},e.prototype.isScalar=function(){return this==t.SCALAR||this.allSuperTypes().indexOf(t.SCALAR)!=-1},e.prototype.isDateTime=function(){return this==t.DATETIME||this.allSuperTypes().indexOf(t.DATETIME)!=-1},e.prototype.isDateOnly=function(){return this==t.DATE_ONLY||this.allSuperTypes().indexOf(t.DATE_ONLY)!=-1},e.prototype.isTimeOnly=function(){return this==t.TIME_ONLY||this.allSuperTypes().indexOf(t.TIME_ONLY)!=-1},e.prototype.isInteger=function(){return this==t.INTEGER||this.allSuperTypes().indexOf(t.INTEGER)!=-1},e.prototype.isDateTimeOnly=function(){return this==t.DATETIME_ONLY||this.allSuperTypes().indexOf(t.DATETIME_ONLY)!=-1},e.prototype.isUnknown=function(){return this==t.UNKNOWN||this.allSuperTypes().indexOf(t.UNKNOWN)!=-1},e.prototype.isRecurrent=function(){return this==t.RECURRENT||this.allSuperTypes().indexOf(t.RECURRENT)!=-1},e.prototype.isBuiltin=function(){return this.metaInfo.indexOf(Q)!=-1},e.prototype.exampleObject=function(){return F.example(this)},e.prototype.isPolymorphic=function(){return this.meta().some(function(e){return e instanceof X})},e.prototype.restrictions=function(e){if(void 0===e&&(e=!1),this.isUnion()){var t=[];return this.superTypes().forEach(function(e){t=t.concat(e.restrictions())}),t=t.concat(this.meta().filter(function(e){return e instanceof C}))}var n=[],r=null;return this.meta().forEach(function(t){if(t instanceof C){if(t instanceof ue&&e){if(r)return;r=t}n.push(t)}}),n},e.prototype.customFacets=function(){return this.declaredMeta().filter(function(e){return e instanceof P.CustomFacet})},e.prototype.allCustomFacets=function(){return this.meta().filter(function(e){return e instanceof P.CustomFacet})},e.prototype.isUnion=function(){var e=!1;return!this.isBuiltin()&&(this.allSuperTypes().forEach(function(t){return e=e||t instanceof ne}),e)},e.prototype.isIntersection=function(){var e=!1;return!this.isBuiltin()&&(this.allSuperTypes().forEach(function(t){return e=e||t instanceof re}),e)},e.prototype.meta=function(){return[].concat(this.metaInfo)},e.prototype.validateDirect=function(e,n,r,a){var o=this;void 0===n&&(n=!1),void 0===r&&(r=!0),void 0===a&&(a=null);var s=t.VALIDATED_TYPE;try{var u=t.autoCloseFlag;n&&(t.autoCloseFlag=!0),t.VALIDATED_TYPE=this;var l=new I(I.OK,"","",this);if(!(r||null!==e&&void 0!==e||this.nullable)){var p=null;return this.restrictions(!0).forEach(function(e){if(e instanceof le){if(p)return;p=e}}),p?i(t.messageRegistry.TYPE_EXPECTED,p,{expectedType:p.value(),actualType:"null"}):i(t.messageRegistry.OBJECT_EXPECTED,this)}if(this.restrictions(!0).forEach(function(t){return l.addSubStatus(t.check(e,a))}),(n||t.autoCloseFlag)&&this.isObject()&&!this.oneMeta(O.KnownPropertyRestriction)){var c=new O.KnownPropertyRestriction(!1);c.patchOwner(this),c.check(e).getErrors().forEach(function(e){var t=new I(I.WARNING,e.getCode(),e.getMessage(),o);d(t,e.getValidationPath()),l.addSubStatus(t)})}}finally{t.autoCloseFlag=u,t.VALIDATED_TYPE=s}return l},e.prototype.validate=function(e,n,a){void 0===n&&(n=!1),void 0===a&&(a=!0);var o=t.autoCloseFlag;if(!(a||null!==e&&void 0!==e||this.nullable))return i(t.messageRegistry.NULL_NOT_ALLOWED,this);n&&(t.autoCloseFlag=!0);try{var s=[],u=T.find([this].concat(this.allSuperTypes()),function(e){return e.getExtra(t.GLOBAL)}),l=this.allSubTypes().concat(this);u&&u!=this&&(l=l.concat(u.allSubTypes()),l.push(u));for(var p,c=0,f=l;c<f.length;c++){var d=f[c],m=h(e,d),y=d.validateDirect(e,n||o);if(m){if(m.isOk())return y;s.push(m)}else if(y.isOk())return y;p=y}if(0==s.length)return p;var v=r();return s.forEach(function(e){return v.addSubStatus(e)}),s.pop()}finally{t.autoCloseFlag=o}},e.prototype.declareMapProperty=function(e,t){return null!=t&&this.addMeta(new w.MapPropertyIs(e,t)),t},e.prototype.closeUnknownProperties=function(){this.addMeta(new O.KnownPropertyRestriction(!1))},e.prototype.annotations=function(){return this.metaOfType(P.Annotation)},e.prototype.declaredAnnotations=function(){return this.declaredMeta().filter(function(e){return P.Annotation.isInstance(e)})},e.prototype.scalarsAnnotations=function(){return this.sAnnotations(this.meta())},e.prototype.declaredScalarsAnnotations=function(){return this.sAnnotations(this.declaredFacets())},e.prototype.sAnnotations=function(e){e=e.filter(function(e){return e.kind()!=N.MetaInformationKind.FacetDeclaration&&e.kind()!=N.MetaInformationKind.Example&&e.kind()!=N.MetaInformationKind.Examples&&"propertyIs"!=e.facetName()});for(var t={},n=function(e){var n=e.annotations();return n&&n.length?void(t[e.facetName()]=[n.map(function(t){var n=new P.Annotation(t.name(),t.value(),t.getPath());return n.setOwnerFacet(e),n})]):"continue"},r=0,i=e;r<i.length;r++){var a=i[r];n(a)}return this.supertypeAnnotations&&this.supertypeAnnotations.length&&(t.type=this.supertypeAnnotations.map(function(e){return Object.keys(e).map(function(t){return new P.Annotation(e[t].name(),e[t].value(),e[t].getPath())})})),t},e.prototype.componentType=function(){var e=this.metaOfType(k.ComponentShouldBeOfType);if(0==e.length)return null;if(1==e.length)return e[0].value();for(var t=e.map(function(e){return e.value()}),n=[].concat(t),r=function(e){for(var n=[],r=0,i=t;r<i.length;r++){var a=i[r];e!=a&&a.isAssignableFrom(e)&&n.push(a)}t=t.filter(function(e){return n.indexOf(e)<0})},i=0,a=n;i<a.length;i++){var o=a[i];r(o)}var s=u(null,t);return s},e.prototype.canDoAc=function(){for(var e=T.uniq(this.typeFamily()),t=new I(I.OK,"","",this),n=0;n<e.length;n++)for(var r=0;r<e.length;r++)if(n!=r){var i=e[n],a=e[r],o=this.emptyIntersectionOrDiscriminator(i,a);t.addSubStatus(o)}return t},e.prototype.emptyIntersectionOrDiscriminator=function(e,t){if(t===e)return r();if(t.isScalar()&&e.isScalar())return r();var n=s("",[e,t]),i=n.checkConfluent();return i.isOk()?this.checkDiscriminator(e,t):r()},e.prototype.properties=function(){if(null==this.propertyInfos){this.propertiesMap={},this.propertyInfos=[];for(var e=this.meta(),t=0,n=e;t<n.length;t++){var r=n[t];if(w.MatchesProperty.isInstance(r)){var i=new Y(r),a=i.name();this.propertiesMap[a]||(this.propertiesMap[a]=i),this.propertyInfos.push(i)}}}return this.propertyInfos},e.prototype.declaredProperties=function(){var e=this;return this.properties().filter(function(t){return t.declaredAt()==e})},e.prototype.allDefinedFacets=function(){if(null==this.definedFacetInfos){this.definedFacetInfosMap={},this.definedFacetInfos=[];for(var e=this.meta(),t=0,n=e;t<n.length;t++){var r=n[t];if(P.FacetDeclaration.isInstance(r)&&!r.isBuiltIn()){var i=new Y(r);this.definedFacetInfosMap[r.facetName()]||(this.definedFacetInfosMap[i.name()]=i),this.definedFacetInfos.push(i)}}}return this.definedFacetInfos},e.prototype.definedFacets=function(){var e=this;return this.allDefinedFacets().filter(function(t){return t.declaredAt()==e})},e.prototype.property=function(e){return this.propertyInfos||this.properties(),this.propertiesMap[e]},e.prototype.checkDiscriminator=function(e,n){var a=i(t.messageRegistry.DISCRIMINATOR_NEEDED,this,{name1:e.name(),name2:n.name()}),o=e.oneMeta(P.Discriminator),s=n.oneMeta(P.Discriminator);if(null!=o&&null!=s&&o.value()===s.value()){var u=e.name(),l=n.name(),p=e.oneMeta(P.DiscriminatorValue);null!=p&&(u=p.value());var c=n.oneMeta(P.DiscriminatorValue);if(null!=c&&(l=c.value()),u!==l)return r();a=i(t.messageRegistry.SAME_DISCRIMINATOR_VALUE,this,{name1:e.name(),name2:n.name()})}return a},e.prototype.ac=function(e){if(!this.isPolymorphic()&&!this.isUnion())return this;if(this.isBuiltin())return this;var n=T.uniq(this.typeFamily());if(0==n.length)return t.NOTHING;if(this.isScalar())return this.isNumber()?"number"==typeof e?this:t.NOTHING:this.isString()?"string"==typeof e?this:t.NOTHING:this.isBoolean()?"boolean"==typeof e?this:t.NOTHING:this;if(1===n.length)return n[0];var r=[];n.forEach(function(t){var n=t.validateDirect(e,!0);n.isOk()&&r.push(t)});var i=this.discriminate(e,r);return i?i:t.NOTHING},e.prototype.declareProperty=function(e,t,n){return n||this.addMeta(new w.HasProperty(e)),null!=t&&this.addMeta(new w.PropertyIs(e,t)),this},e.prototype.discriminate=function(e,t){for(var n=[].concat(t),r=[].concat(t);n.length>1;){var i=!1;e:for(var a=0;a<r.length;a++)for(var o=0;o<r.length;o++){var s=r[a],u=r[o];if(s!=u){var l=p(e,s,u);if(l===s){r=r.filter(function(e){return e!=u}),i=!0;break e}if(l===u){r=r.filter(function(e){return e!=s}),i=!0;break e}r=r.filter(function(e){return e!=s&&e!=u}),i=!0;break e}}n=r}return 1==n.length?n[0]:null},e.prototype.oneMeta=function(e){return T.find(this.meta(),function(t){return t instanceof e})},e.prototype.metaOfType=function(e){return this.meta().filter(function(t){return t instanceof e})},e.prototype.declaredMeta=function(){return this.metaInfo},e.prototype.descValue=function(){var e=this.oneMeta(P.DiscriminatorValue);return e?e.value():this.name()},e.prototype.isAbstractOrInternal=function(){return this.metaInfo.some(function(e){return e instanceof z||e instanceof $})},e.prototype.typeFamily=function(){if(this.isUnion()){var e=[];return this.allSuperTypes().forEach(function(t){if(t instanceof ne)for(var n=t.allOptions(),r=0;r<n.length;r++)e=e.concat(n[r].typeFamily())}),T.unique(e)}var t=[];return this.isAbstractOrInternal()||t.push(this),this.allSubTypes().forEach(function(e){e.isAbstractOrInternal()||t.push(e)}),T.unique(t)},e.prototype.hasPropertiesFacet=function(){return this.metaInfo.some(function(e){return e instanceof P.HasPropertiesFacet})},e.prototype.sourceMap=function(){return null},e.CLASS_IDENTIFIER_AbstractType="typesystem.AbstractType",e}();t.AbstractType=q;var G=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return _(n,e),n.prototype.requiredType=function(){return t.ANY},n.prototype.kind=function(){return N.MetaInformationKind.Modifier},n}(R);t.Modifier=G;var X=function(e){function t(){return e.call(this,!0)||this}return _(t,e),t.prototype.facetName=function(){return"polymorphic"},t.prototype.value=function(){return!0},t}(G);t.Polymorphic=X;var z=function(e){function t(){return e.call(this,!1)||this}return _(t,e),t.prototype.value=function(){return!0},t.prototype.facetName=function(){return"abstract"},t}(G);t.Abstract=z;var $=function(e){function t(){return e.call(this,!1)||this}return _(t,e),t.prototype.facetName=function(){return"abstract"},t.prototype.value=function(){return!0},t}(G);t.Internal=$;var J=function(e){function t(){return e.call(this,!1)||this}return _(t,e),t.prototype.facetName=function(){return"builtIn"},t.prototype.value=function(){return!0},t}(G),Q=new J,Z=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return _(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_RootType)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_RootType)},t.prototype.kind=function(){return"root"},t.prototype.clone=function(){return this},t.CLASS_IDENTIFIER_RootType="typesystem.RootType",t}(q);t.RootType=Z;var ee=function(e){function n(){var t=null!==e&&e.apply(this,arguments)||this;return t._superTypes=[],t}return _(n,e),n.prototype.getClassIdentifier=function(){var t=e.prototype.getClassIdentifier.call(this);return t.concat(n.CLASS_IDENTIFIER_InheritedType)},n.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),n.CLASS_IDENTIFIER_InheritedType)},n.prototype.superTypes=function(){return this._superTypes},n.prototype.clone=function(){if(this.isBuiltin())return this;var e=new n(this._name);return e._superTypes=this._superTypes,e},n.prototype.knownProperties=function(){var e=this.metaOfType(V.MatchesProperty);return this.superTypes().forEach(function(t){e=e.concat(t.knownProperties())}),e},n.prototype.kind=function(){return"inherited"},n.prototype.meta=function(){var t=this,n=e.prototype.meta.call(this),r=!1;return this.superTypes().forEach(function(e){e.meta().forEach(function(e){if(e instanceof O.KnownPropertyRestriction){if(r)return;var i=new O.KnownPropertyRestriction(!1);return i.patchOwner(t),void n.push(i)}e.isInheritable()&&n.push(e)})}),n},n.prototype.addSuper=function(e){this._superTypes.push(e),e.isLocked()||e._subTypes.push(this),e.nullable&&(this.nullable=!0)},n.prototype.label=function(){var t=this.metaOfType(k.ComponentShouldBeOfType);return t.length>0?t[0].value().label()+"[]":e.prototype.label.call(this)},n.prototype.contextMeta=function(){return this._contextMeta},n.prototype.setContextMeta=function(e){this._contextMeta=e},n.prototype.patch=function(e){var n=this;for(var r in e)e.hasOwnProperty(r)&&(this[r]=e[r]);this.metaInfo.filter(function(t){return t._owner===e}).forEach(function(e){return e._owner=n});for(var i=0;i<this._superTypes.length;i++){var a=this._superTypes[i];(a==this||a.allSuperTypes().indexOf(this)>=0)&&(this._superTypes[i]=t.RECURRENT)}},n.CLASS_IDENTIFIER_InheritedType="typesystem.InheritedType",n}(q);t.InheritedType=ee;var te=function(e){function t(t,n){var r=e.call(this,t)||this;return r._options=n,r}return _(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_DerivedType)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_DerivedType)},t.prototype.cloneWithFilter=function(e,t){var n=this.clone(),r=[];return t&&(n._options=this.options().map(function(e){return t(e)})),this.metaInfo.forEach(function(t){var i=e(t,n);"boolean"==typeof i?i&&r.push(t):i&&r.push(i)}),n.metaInfo=r,n},t.prototype.allOptions=function(){var e=this,t=[];return this._options.forEach(function(n){n.kind()==e.kind()?t=t.concat(n.allOptions()):t.push(n)}),T.unique(t)},t.prototype.options=function(){return this._options},t.CLASS_IDENTIFIER_DerivedType="typesystem.DerivedType",t}(q);t.DerivedType=te;var ne=function(e){function n(t,n){var r=e.call(this,t,n)||this;return r.options().forEach(function(e){e.nullable&&(r.nullable=!0)}),r}return _(n,e),n.prototype.getClassIdentifier=function(){var t=e.prototype.getClassIdentifier.call(this);return t.concat(n.CLASS_IDENTIFIER_UnionType)},n.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),n.CLASS_IDENTIFIER_UnionType)},n.prototype.kind=function(){return"union"},n.prototype.clone=function(){return new n(this.name(),this.options())},n.prototype.isSubTypeOf=function(e){var t=!0;return this.allOptions().forEach(function(n){n.isSubTypeOf(e)||(t=!1)}),t},n.prototype.validate=function(e){return this.validateDirect(e)},n.prototype.typeFamily=function(){var e=[];return this.allOptions().forEach(function(t){e=e.concat(t.typeFamily())}),e},n.prototype.knownProperties=function(){var e=this.metaOfType(V.MatchesProperty);return this.options().forEach(function(t){e=e.concat(t.knownProperties())}),e},n.prototype.validateDirect=function(e,t){void 0===t&&(t=!1);var n=new I(I.OK,"","",this);return this.restrictions().forEach(function(t){return n.addSubStatus(t.check(e,null))}),n},n.prototype.isUnion=function(){return!0},n.prototype.isObject=function(){return T.all(this.allOptions(),function(e){return e.isObject()})},n.prototype.restrictions=function(){return[new he(this.allOptions().map(function(e){return new de(e.restrictions())}),t.messageRegistry.UNION_TYPE_FAILURE,t.messageRegistry.UNION_TYPE_FAILURE_DETAILS)]},n.prototype.label=function(){return this.options().map(function(e){return e.label()}).join("|")},n.CLASS_IDENTIFIER_UnionType="typesystem.UnionType",n}(te);t.UnionType=ne;var re=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return _(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_IntersectionType)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_IntersectionType)},t.prototype.kind=function(){return"intersection"},t.prototype.clone=function(){return new t(this.name(),this.options())},t.prototype.restrictions=function(){var e=[];return this.allOptions().forEach(function(t){t.oneMeta(P.SkipValidation)||(e=e.concat(t.restrictions()))}),[new de(e)]},t.prototype.label=function(){return this.options().map(function(e){return e.label()}).join("&")},t.prototype.isIntersection=function(){return!0},t.CLASS_IDENTIFIER_IntersectionType="typesystem.IntersectionType",t}(te);t.IntersectionType=re;var ie=new K;t.builtInRegistry=a,t.union=o,t.intersect=s,t.derive=u,t.deriveObjectType=l;var ae=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return _(n,e),n.prototype.check=function(e){return null===e||void 0===e?r():i(t.messageRegistry.NOTHING,this)},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"nothing"},n.prototype.value=function(){return"!!!"},n}(C);t.NothingRestriction=ae;var oe=function(){function e(e,t,n){this._previous=e,this._restriction=t,this.id=n}return e.prototype.getRestriction=function(){return this._restriction},e.prototype.pop=function(){return this._previous},e.prototype.push=function(t){return new e(this,t,t.toString())},e}();t.RestrictionStackEntry=oe;var se=function(e){function t(t,n,r){var i=e.call(this)||this;return i._entry=t,i._message=n,i._another=r,i}return _(t,e),t.prototype.getMessage=function(){return this._message},t.prototype.getStack=function(){return this._entry},t.prototype.another=function(){return this._another},t}(ae);t.NothingRestrictionWithLocation=se;var ue=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return _(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_GenericTypeOf)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_GenericTypeOf)},t.CLASS_IDENTIFIER_GenericTypeOf="typesystem.GenericTypeOf",t}(C);t.GenericTypeOf=ue;var le=function(e){function n(t){var n=e.call(this)||this;return n.val=t,n}return _(n,e),n.prototype.check=function(e){var n=typeof e;return null===e||void 0===e?r():(Array.isArray(e)&&(n="array"),n===this.val?r():i(t.messageRegistry.TYPE_EXPECTED,this,{expectedType:this.val,actualType:n}))},n.prototype.value=function(){return this.val},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"typeOf"},n.prototype.composeWith=function(e){if(e instanceof n){var t=e;return t.val==this.val?this:this.nothing(e)}return null},n.prototype.toString=function(){return"should be of type "+this.val},n}(ue);t.TypeOfRestriction=le;var pe=function(e){function n(){return e.call(this)||this}return _(n,e),n.prototype.check=function(e){return"number"==typeof e&&c(e)?r():i(t.messageRegistry.INTEGER_EXPECTED,this)},n.prototype.requiredType=function(){return t.ANY},n.prototype.value=function(){return!0},n.prototype.facetName=function(){return"should be integer"},n}(ue);t.IntegerRestriction=pe;var ce=function(e){function n(){return e.call(this,"nil")||this}return _(n,e),n.prototype.check=function(e){return null===e||void 0==e||"null"===e?r():i(t.messageRegistry.NULL_EXPECTED,this)},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"should be nil"},n}(le);t.NullRestriction=ce;var fe=function(e){function n(){return e.call(this)||this}return _(n,e),n.prototype.check=function(e){return e?"number"==typeof e||"boolean"==typeof e||"string"==typeof e?r():i(t.messageRegistry.SCALAR_EXPECTED,this):r()},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return t.messageRegistry.SHOULD_BE_SCALAR.message},n.prototype.value=function(){return!0},n}(ue);t.ScalarRestriction=fe;var he=function(e){function n(t,n,r){var i=e.call(this)||this;return i.val=t,i._extraMessage=n,i._extraOptionMessage=r,i}return _(n,e),n.prototype.check=function(e,t){for(var n=this,a=new I(I.OK,"","",this),o=[],s=0;s<this.val.length;s++){var u=this.val[s].check(e,t);if(u.isOk())return r();o.push(u)}if(o.length>0){for(var l=0,p=o;l<p.length;l++){var c=p[l],f=null,h=c.getSource();if(h instanceof R){var d=h.owner();d&&(f=d.label())}c.getErrors().forEach(function(e){var t=e.getMessage(),r=e.getCode();if(f&&(t=f+": "+t),n._extraOptionMessage){var o=i(n._extraOptionMessage,n,{msg:t});t=o.getMessage(),r=o.getCode()}e.setMessage(t),e.setCode(r),a.addSubStatus(e)})}if(this._extraMessage){var m=0;o.forEach(function(e){return m=Math.max(m,e.getSeverity())}),a.addSubStatus(new I(m,this._extraMessage.code,this._extraMessage.message,this))}}return a},n.prototype.value=function(){return this.val.map(function(e){return e.value()})},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"or"},n}(C);t.OrRestriction=he;var de=function(e){function n(t){var n=e.call(this)||this;return n.val=t,n}return _(n,e),n.prototype.value=function(){return this.val.map(function(e){return e.value()})},n.prototype.options=function(){return this.val},n.prototype.check=function(e,t){for(var n=0;n<this.val.length;n++){var i=this.val[n].check(e,t);if(!i.isOk())return i}return r()},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"and"},n}(C);t.AndRestriction=de,t.ANY=new Z("any"),t.SCALAR=t.ANY.inherit("scalar"),t.OBJECT=t.ANY.inherit("object"),t.ARRAY=t.ANY.inherit("array"),t.EXTERNAL=t.ANY.inherit("external"),t.NUMBER=t.SCALAR.inherit("number"),t.INTEGER=t.NUMBER.inherit("integer"),t.BOOLEAN=t.SCALAR.inherit("boolean"),t.STRING=t.SCALAR.inherit("string"),t.NIL=t.SCALAR.inherit("nil"),t.DATE_ONLY=t.SCALAR.inherit("date-only"),t.TIME_ONLY=t.SCALAR.inherit("time-only"),t.DATETIME_ONLY=t.SCALAR.inherit("datetime-only"),t.DATETIME=t.SCALAR.inherit("datetime"),t.FILE=t.SCALAR.inherit("file"),t.NOTHING=new Z("nothing"),t.UNION=t.ANY.inherit("union"),t.UNKNOWN=t.NOTHING.inherit("unknown"),t.REFERENCE=t.NOTHING.inherit("reference"),t.RECURRENT=t.NOTHING.inherit("recurrent"),t.ANY.addMeta(Q),t.NIL.addMeta(Q),t.UNION.addMeta(Q),t.SCALAR.addMeta(Q),t.OBJECT.addMeta(Q),t.ARRAY.addMeta(Q),t.NUMBER.addMeta(Q),t.INTEGER.addMeta(Q),t.BOOLEAN.addMeta(Q),t.STRING.addMeta(Q),t.EXTERNAL.addMeta(Q),t.UNKNOWN.addMeta(Q),t.RECURRENT.addMeta(Q),t.DATE_ONLY.addMeta(Q),t.TIME_ONLY.addMeta(Q),t.DATETIME_ONLY.addMeta(Q),t.DATETIME.addMeta(Q),t.FILE.addMeta(Q),t.UNKNOWN.addMeta(Q),t.UNKNOWN.lock(),t.RECURRENT.addMeta(Q),t.RECURRENT.lock(),t.EXTERNAL.lock(),t.UNION.lock(),t.REFERENCE.lock(),ie.addType(t.ANY),ie.addType(t.SCALAR),ie.addType(t.OBJECT),ie.addType(t.ARRAY),ie.addType(t.NUMBER),ie.addType(t.INTEGER),ie.addType(t.BOOLEAN),ie.addType(t.NIL),ie.addType(t.STRING),ie.addType(t.DATE_ONLY),ie.addType(t.TIME_ONLY),ie.addType(t.DATETIME_ONLY),ie.addType(t.DATETIME),ie.addType(t.FILE),t.NOTHING.addMeta(new ae),t.NUMBER.addMeta(new le("number")),t.NUMBER.addMeta(new D.FacetDeclaration("format",t.STRING,!0,!0)),t.BOOLEAN.addMeta(new le("boolean")),t.OBJECT.addMeta(new le("object")),t.ARRAY.addMeta(new le("array")),t.STRING.addMeta(new le("string")),t.INTEGER.addMeta(new pe),t.NIL.addMeta(new ce);var me=n(137);t.DATE_ONLY.addMeta(new me.DateOnlyR),t.TIME_ONLY.addMeta(new me.TimeOnlyR),t.DATETIME_ONLY.addMeta(new me.DateTimeOnlyR),t.DATETIME.addMeta(new me.DateTimeR),t.FILE.addMeta(new le("string"));var ye=t.ARRAY.inherit("");ye.addMeta(new k.ComponentShouldBeOfType(t.STRING)),t.FILE.addMeta(new D.FacetDeclaration("fileTypes",ye,!0,!0)),t.FILE.addMeta(new D.FacetDeclaration("minLength",t.INTEGER,!0,!0)),t.FILE.addMeta(new D.FacetDeclaration("maxLength",t.INTEGER,!0,!0)),t.DATETIME.addMeta(new D.FacetDeclaration("format",t.STRING,!0,!0)),t.NIL.nullable=!0,t.SCALAR.addMeta(new fe),ie.types().forEach(function(e){return e.lock()});var ve=function(e){function n(n,r,i,a,o){void 0===o&&(o=null);var s=e.call(this,n)||this;return s._content=r,s.json=i,s.provider=a,s.addMeta(new w.MatchToSchema(r,o?o:a)),s.addSuper(t.EXTERNAL),s}return _(n,e),n.prototype.getClassIdentifier=function(){var t=e.prototype.getClassIdentifier.call(this);return t.concat(n.CLASS_IDENTIFIER_ExternalType)},n.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),n.CLASS_IDENTIFIER_ExternalType)},n.prototype.getContentProvider=function(){return this.provider},n.prototype.setContentProvider=function(e){this.provider=e},n.prototype.kind=function(){return"external"},n.prototype.isJSON=function(){return this.json},n.prototype.schema=function(){return this._content},n.CLASS_IDENTIFIER_ExternalType="typesystem.ExternalType",n}(ee);t.ExternalType=ve,t.typePath=f;var ge=function(e){function t(n,r){void 0===r&&(r={});var i=e.call(this)||this;return i.messageEntry=n,i.parameters=r,i.isWarning=!1,i.message=b(n,r),i.getClassIdentifier=t.prototype.getClassIdentifier,i}return _(t,e),t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER_ValidationError)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&T.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ValidationError)},t.CLASS_IDENTIFIER_ValidationError="linter.ValidationError",t}(Error);t.ValidationError=ge,t.setValidationPath=d,t.patchPath=m;var Ae=function(){function e(e,t){this._facet=e,this.reg=t}return e.prototype.kind=function(){return"AnnotatedFacet"},e.prototype.annotationsMap=function(){var e=this;return this._annotationsMap||(this._annotationsMap={},this.annotations().forEach(function(t){return e._annotationsMap[t.name()]=t})),this._annotationsMap},e.prototype.annotations=function(){var e=this;return this._annotations||(this._annotations=this._facet.annotations().map(function(t){return new Te(t,e.reg)})),this._annotations},e.prototype.value=function(){return this._facet.value()},e.prototype.name=function(){return this._facet.facetName()},e.prototype.entry=function(){return this._facet},e}();t.AnnotatedFacet=Ae;var Ee=n(171),_e=function(){function e(e,t){this._type=e,this.reg=t}return e.prototype.kind=function(){return"AnnotatedType"},e.prototype.annotationsMap=function(){var e=this;return this._annotationsMap||(this._annotationsMap={},this.annotations().forEach(function(t){var n=t.name(),r=n.lastIndexOf(".");r>=0&&(n=n.substring(r+1)),e._annotationsMap[n]=t})),this._annotationsMap},e.prototype.annotations=function(){var e=this;return this._annotations||(this._annotations=this._type.meta().filter(function(e){return e.kind()==N.MetaInformationKind.Annotation}).map(function(t){return new Te(t,e.reg)})),this._annotations},e.prototype.value=function(){return Ee.storeAsJSON(this._type)},e.prototype.name=function(){return this._type.name()},e.prototype.entry=function(){return this._type},e}();t.AnnotatedType=_e;var Te=function(){function e(e,t){this.actual=e}return e.prototype.name=function(){return this.actual.facetName()},e.prototype.value=function(){return this.actual.value()},e.prototype.definition=function(){var e=ie.get(this.actual.facetName());return e},e.prototype.annotation=function(){return this.actual},e}();t.AnnotationInstance=Te,t.applyAnnotationValidationPlugins=y,t.applyTypeValidationPlugins=v,t.toValidationPath=A,t.isUnknown=E},function(e,t,n){var r,i;(function(e,n){!function(){var a="object"==typeof self&&self.self===self&&self||"object"==typeof e&&e.global===e&&e||this||{},o=a._,s=Array.prototype,u=Object.prototype,l="undefined"!=typeof Symbol?Symbol.prototype:null,p=s.push,c=s.slice,f=u.toString,h=u.hasOwnProperty,d=Array.isArray,m=Object.keys,y=Object.create,v=function(){},g=function(e){return e instanceof g?e:this instanceof g?void(this._wrapped=e):new g(e)};"undefined"==typeof t||t.nodeType?a._=g:("undefined"!=typeof n&&!n.nodeType&&n.exports&&(t=n.exports=g),t._=g),g.VERSION="1.9.1";var A,E=function(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 3:return function(n,r,i){return e.call(t,n,r,i)};case 4:return function(n,r,i,a){return e.call(t,n,r,i,a)}}return function(){return e.apply(t,arguments)}},_=function(e,t,n){return g.iteratee!==A?g.iteratee(e,t):null==e?g.identity:g.isFunction(e)?E(e,t,n):g.isObject(e)&&!g.isArray(e)?g.matcher(e):g.property(e)};g.iteratee=A=function(e,t){return _(e,t,1/0)};var T=function(e,t){return t=null==t?e.length-1:+t,function(){for(var n=Math.max(arguments.length-t,0),r=Array(n),i=0;i<n;i++)r[i]=arguments[i+t];switch(t){case 0:return e.call(this,r);case 1:return e.call(this,arguments[0],r);case 2:return e.call(this,arguments[0],arguments[1],r)}var a=Array(t+1);for(i=0;i<t;i++)a[i]=arguments[i];return a[t]=r,e.apply(this,a)}},S=function(e){if(!g.isObject(e))return{};if(y)return y(e);v.prototype=e;var t=new v;return v.prototype=null,t},N=function(e){return function(t){return null==t?void 0:t[e]}},I=function(e,t){return null!=e&&h.call(e,t)},b=function(e,t){for(var n=t.length,r=0;r<n;r++){if(null==e)return;e=e[t[r]]}return n?e:void 0},R=Math.pow(2,53)-1,M=N("length"),C=function(e){
var t=M(e);return"number"==typeof t&&t>=0&&t<=R};g.each=g.forEach=function(e,t,n){t=E(t,n);var r,i;if(C(e))for(r=0,i=e.length;r<i;r++)t(e[r],r,e);else{var a=g.keys(e);for(r=0,i=a.length;r<i;r++)t(e[a[r]],a[r],e)}return e},g.map=g.collect=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=Array(i),o=0;o<i;o++){var s=r?r[o]:o;a[o]=t(e[s],s,e)}return a};var w=function(e){var t=function(t,n,r,i){var a=!C(t)&&g.keys(t),o=(a||t).length,s=e>0?0:o-1;for(i||(r=t[a?a[s]:s],s+=e);s>=0&&s<o;s+=e){var u=a?a[s]:s;r=n(r,t[u],u,t)}return r};return function(e,n,r,i){var a=arguments.length>=3;return t(e,E(n,i,4),r,a)}};g.reduce=g.foldl=g.inject=w(1),g.reduceRight=g.foldr=w(-1),g.find=g.detect=function(e,t,n){var r=C(e)?g.findIndex:g.findKey,i=r(e,t,n);if(void 0!==i&&i!==-1)return e[i]},g.filter=g.select=function(e,t,n){var r=[];return t=_(t,n),g.each(e,function(e,n,i){t(e,n,i)&&r.push(e)}),r},g.reject=function(e,t,n){return g.filter(e,g.negate(_(t)),n)},g.every=g.all=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=0;a<i;a++){var o=r?r[a]:a;if(!t(e[o],o,e))return!1}return!0},g.some=g.any=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=0;a<i;a++){var o=r?r[a]:a;if(t(e[o],o,e))return!0}return!1},g.contains=g.includes=g.include=function(e,t,n,r){return C(e)||(e=g.values(e)),("number"!=typeof n||r)&&(n=0),g.indexOf(e,t,n)>=0},g.invoke=T(function(e,t,n){var r,i;return g.isFunction(t)?i=t:g.isArray(t)&&(r=t.slice(0,-1),t=t[t.length-1]),g.map(e,function(e){var a=i;if(!a){if(r&&r.length&&(e=b(e,r)),null==e)return;a=e[t]}return null==a?a:a.apply(e,n)})}),g.pluck=function(e,t){return g.map(e,g.property(t))},g.where=function(e,t){return g.filter(e,g.matcher(t))},g.findWhere=function(e,t){return g.find(e,g.matcher(t))},g.max=function(e,t,n){var r,i,a=-(1/0),o=-(1/0);if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e){e=C(e)?e:g.values(e);for(var s=0,u=e.length;s<u;s++)r=e[s],null!=r&&r>a&&(a=r)}else t=_(t,n),g.each(e,function(e,n,r){i=t(e,n,r),(i>o||i===-(1/0)&&a===-(1/0))&&(a=e,o=i)});return a},g.min=function(e,t,n){var r,i,a=1/0,o=1/0;if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e){e=C(e)?e:g.values(e);for(var s=0,u=e.length;s<u;s++)r=e[s],null!=r&&r<a&&(a=r)}else t=_(t,n),g.each(e,function(e,n,r){i=t(e,n,r),(i<o||i===1/0&&a===1/0)&&(a=e,o=i)});return a},g.shuffle=function(e){return g.sample(e,1/0)},g.sample=function(e,t,n){if(null==t||n)return C(e)||(e=g.values(e)),e[g.random(e.length-1)];var r=C(e)?g.clone(e):g.values(e),i=M(r);t=Math.max(Math.min(t,i),0);for(var a=i-1,o=0;o<t;o++){var s=g.random(o,a),u=r[o];r[o]=r[s],r[s]=u}return r.slice(0,t)},g.sortBy=function(e,t,n){var r=0;return t=_(t,n),g.pluck(g.map(e,function(e,n,i){return{value:e,index:r++,criteria:t(e,n,i)}}).sort(function(e,t){var n=e.criteria,r=t.criteria;if(n!==r){if(n>r||void 0===n)return 1;if(n<r||void 0===r)return-1}return e.index-t.index}),"value")};var P=function(e,t){return function(n,r,i){var a=t?[[],[]]:{};return r=_(r,i),g.each(n,function(t,i){var o=r(t,i,n);e(a,t,o)}),a}};g.groupBy=P(function(e,t,n){I(e,n)?e[n].push(t):e[n]=[t]}),g.indexBy=P(function(e,t,n){e[n]=t}),g.countBy=P(function(e,t,n){I(e,n)?e[n]++:e[n]=1});var L=/[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;g.toArray=function(e){return e?g.isArray(e)?c.call(e):g.isString(e)?e.match(L):C(e)?g.map(e,g.identity):g.values(e):[]},g.size=function(e){return null==e?0:C(e)?e.length:g.keys(e).length},g.partition=P(function(e,t,n){e[n?0:1].push(t)},!0),g.first=g.head=g.take=function(e,t,n){return null==e||e.length<1?null==t?void 0:[]:null==t||n?e[0]:g.initial(e,e.length-t)},g.initial=function(e,t,n){return c.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))},g.last=function(e,t,n){return null==e||e.length<1?null==t?void 0:[]:null==t||n?e[e.length-1]:g.rest(e,Math.max(0,e.length-t))},g.rest=g.tail=g.drop=function(e,t,n){return c.call(e,null==t||n?1:t)},g.compact=function(e){return g.filter(e,Boolean)};var O=function(e,t,n,r){r=r||[];for(var i=r.length,a=0,o=M(e);a<o;a++){var s=e[a];if(C(s)&&(g.isArray(s)||g.isArguments(s)))if(t)for(var u=0,l=s.length;u<l;)r[i++]=s[u++];else O(s,t,n,r),i=r.length;else n||(r[i++]=s)}return r};g.flatten=function(e,t){return O(e,t,!1)},g.without=T(function(e,t){return g.difference(e,t)}),g.uniq=g.unique=function(e,t,n,r){g.isBoolean(t)||(r=n,n=t,t=!1),null!=n&&(n=_(n,r));for(var i=[],a=[],o=0,s=M(e);o<s;o++){var u=e[o],l=n?n(u,o,e):u;t&&!n?(o&&a===l||i.push(u),a=l):n?g.contains(a,l)||(a.push(l),i.push(u)):g.contains(i,u)||i.push(u)}return i},g.union=T(function(e){return g.uniq(O(e,!0,!0))}),g.intersection=function(e){for(var t=[],n=arguments.length,r=0,i=M(e);r<i;r++){var a=e[r];if(!g.contains(t,a)){var o;for(o=1;o<n&&g.contains(arguments[o],a);o++);o===n&&t.push(a)}}return t},g.difference=T(function(e,t){return t=O(t,!0,!0),g.filter(e,function(e){return!g.contains(t,e)})}),g.unzip=function(e){for(var t=e&&g.max(e,M).length||0,n=Array(t),r=0;r<t;r++)n[r]=g.pluck(e,r);return n},g.zip=T(g.unzip),g.object=function(e,t){for(var n={},r=0,i=M(e);r<i;r++)t?n[e[r]]=t[r]:n[e[r][0]]=e[r][1];return n};var D=function(e){return function(t,n,r){n=_(n,r);for(var i=M(t),a=e>0?0:i-1;a>=0&&a<i;a+=e)if(n(t[a],a,t))return a;return-1}};g.findIndex=D(1),g.findLastIndex=D(-1),g.sortedIndex=function(e,t,n,r){n=_(n,r,1);for(var i=n(t),a=0,o=M(e);a<o;){var s=Math.floor((a+o)/2);n(e[s])<i?a=s+1:o=s}return a};var U=function(e,t,n){return function(r,i,a){var o=0,s=M(r);if("number"==typeof a)e>0?o=a>=0?a:Math.max(a+s,o):s=a>=0?Math.min(a+1,s):a+s+1;else if(n&&a&&s)return a=n(r,i),r[a]===i?a:-1;if(i!==i)return a=t(c.call(r,o,s),g.isNaN),a>=0?a+o:-1;for(a=e>0?o:s-1;a>=0&&a<s;a+=e)if(r[a]===i)return a;return-1}};g.indexOf=U(1,g.findIndex,g.sortedIndex),g.lastIndexOf=U(-1,g.findLastIndex),g.range=function(e,t,n){null==t&&(t=e||0,e=0),n||(n=t<e?-1:1);for(var r=Math.max(Math.ceil((t-e)/n),0),i=Array(r),a=0;a<r;a++,e+=n)i[a]=e;return i},g.chunk=function(e,t){if(null==t||t<1)return[];for(var n=[],r=0,i=e.length;r<i;)n.push(c.call(e,r,r+=t));return n};var x=function(e,t,n,r,i){if(!(r instanceof t))return e.apply(n,i);var a=S(e.prototype),o=e.apply(a,i);return g.isObject(o)?o:a};g.bind=T(function(e,t,n){if(!g.isFunction(e))throw new TypeError("Bind must be called on a function");var r=T(function(i){return x(e,r,t,this,n.concat(i))});return r}),g.partial=T(function(e,t){var n=g.partial.placeholder,r=function(){for(var i=0,a=t.length,o=Array(a),s=0;s<a;s++)o[s]=t[s]===n?arguments[i++]:t[s];for(;i<arguments.length;)o.push(arguments[i++]);return x(e,r,this,this,o)};return r}),g.partial.placeholder=g,g.bindAll=T(function(e,t){t=O(t,!1,!1);var n=t.length;if(n<1)throw new Error("bindAll must be passed function names");for(;n--;){var r=t[n];e[r]=g.bind(e[r],e)}}),g.memoize=function(e,t){var n=function(r){var i=n.cache,a=""+(t?t.apply(this,arguments):r);return I(i,a)||(i[a]=e.apply(this,arguments)),i[a]};return n.cache={},n},g.delay=T(function(e,t,n){return setTimeout(function(){return e.apply(null,n)},t)}),g.defer=g.partial(g.delay,g,1),g.throttle=function(e,t,n){var r,i,a,o,s=0;n||(n={});var u=function(){s=n.leading===!1?0:g.now(),r=null,o=e.apply(i,a),r||(i=a=null)},l=function(){var l=g.now();s||n.leading!==!1||(s=l);var p=t-(l-s);return i=this,a=arguments,p<=0||p>t?(r&&(clearTimeout(r),r=null),s=l,o=e.apply(i,a),r||(i=a=null)):r||n.trailing===!1||(r=setTimeout(u,p)),o};return l.cancel=function(){clearTimeout(r),s=0,r=i=a=null},l},g.debounce=function(e,t,n){var r,i,a=function(t,n){r=null,n&&(i=e.apply(t,n))},o=T(function(o){if(r&&clearTimeout(r),n){var s=!r;r=setTimeout(a,t),s&&(i=e.apply(this,o))}else r=g.delay(a,t,this,o);return i});return o.cancel=function(){clearTimeout(r),r=null},o},g.wrap=function(e,t){return g.partial(t,e)},g.negate=function(e){return function(){return!e.apply(this,arguments)}},g.compose=function(){var e=arguments,t=e.length-1;return function(){for(var n=t,r=e[t].apply(this,arguments);n--;)r=e[n].call(this,r);return r}},g.after=function(e,t){return function(){if(--e<1)return t.apply(this,arguments)}},g.before=function(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),e<=1&&(t=null),n}},g.once=g.partial(g.before,2),g.restArguments=T;var k=!{toString:null}.propertyIsEnumerable("toString"),F=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],B=function(e,t){var n=F.length,r=e.constructor,i=g.isFunction(r)&&r.prototype||u,a="constructor";for(I(e,a)&&!g.contains(t,a)&&t.push(a);n--;)a=F[n],a in e&&e[a]!==i[a]&&!g.contains(t,a)&&t.push(a)};g.keys=function(e){if(!g.isObject(e))return[];if(m)return m(e);var t=[];for(var n in e)I(e,n)&&t.push(n);return k&&B(e,t),t},g.allKeys=function(e){if(!g.isObject(e))return[];var t=[];for(var n in e)t.push(n);return k&&B(e,t),t},g.values=function(e){for(var t=g.keys(e),n=t.length,r=Array(n),i=0;i<n;i++)r[i]=e[t[i]];return r},g.mapObject=function(e,t,n){t=_(t,n);for(var r=g.keys(e),i=r.length,a={},o=0;o<i;o++){var s=r[o];a[s]=t(e[s],s,e)}return a},g.pairs=function(e){for(var t=g.keys(e),n=t.length,r=Array(n),i=0;i<n;i++)r[i]=[t[i],e[t[i]]];return r},g.invert=function(e){for(var t={},n=g.keys(e),r=0,i=n.length;r<i;r++)t[e[n[r]]]=n[r];return t},g.functions=g.methods=function(e){var t=[];for(var n in e)g.isFunction(e[n])&&t.push(n);return t.sort()};var V=function(e,t){return function(n){var r=arguments.length;if(t&&(n=Object(n)),r<2||null==n)return n;for(var i=1;i<r;i++)for(var a=arguments[i],o=e(a),s=o.length,u=0;u<s;u++){var l=o[u];t&&void 0!==n[l]||(n[l]=a[l])}return n}};g.extend=V(g.allKeys),g.extendOwn=g.assign=V(g.keys),g.findKey=function(e,t,n){t=_(t,n);for(var r,i=g.keys(e),a=0,o=i.length;a<o;a++)if(r=i[a],t(e[r],r,e))return r};var K=function(e,t,n){return t in n};g.pick=T(function(e,t){var n={},r=t[0];if(null==e)return n;g.isFunction(r)?(t.length>1&&(r=E(r,t[1])),t=g.allKeys(e)):(r=K,t=O(t,!1,!1),e=Object(e));for(var i=0,a=t.length;i<a;i++){var o=t[i],s=e[o];r(s,o,e)&&(n[o]=s)}return n}),g.omit=T(function(e,t){var n,r=t[0];return g.isFunction(r)?(r=g.negate(r),t.length>1&&(n=t[1])):(t=g.map(O(t,!1,!1),String),r=function(e,n){return!g.contains(t,n)}),g.pick(e,r,n)}),g.defaults=V(g.allKeys,!0),g.create=function(e,t){var n=S(e);return t&&g.extendOwn(n,t),n},g.clone=function(e){return g.isObject(e)?g.isArray(e)?e.slice():g.extend({},e):e},g.tap=function(e,t){return t(e),e},g.isMatch=function(e,t){var n=g.keys(t),r=n.length;if(null==e)return!r;for(var i=Object(e),a=0;a<r;a++){var o=n[a];if(t[o]!==i[o]||!(o in i))return!1}return!0};var j,W;j=function(e,t,n,r){if(e===t)return 0!==e||1/e===1/t;if(null==e||null==t)return!1;if(e!==e)return t!==t;var i=typeof e;return("function"===i||"object"===i||"object"==typeof t)&&W(e,t,n,r)},W=function(e,t,n,r){e instanceof g&&(e=e._wrapped),t instanceof g&&(t=t._wrapped);var i=f.call(e);if(i!==f.call(t))return!1;switch(i){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!==+e?+t!==+t:0===+e?1/+e===1/t:+e===+t;case"[object Date]":case"[object Boolean]":return+e===+t;case"[object Symbol]":return l.valueOf.call(e)===l.valueOf.call(t)}var a="[object Array]"===i;if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var o=e.constructor,s=t.constructor;if(o!==s&&!(g.isFunction(o)&&o instanceof o&&g.isFunction(s)&&s instanceof s)&&"constructor"in e&&"constructor"in t)return!1}n=n||[],r=r||[];for(var u=n.length;u--;)if(n[u]===e)return r[u]===t;if(n.push(e),r.push(t),a){if(u=e.length,u!==t.length)return!1;for(;u--;)if(!j(e[u],t[u],n,r))return!1}else{var p,c=g.keys(e);if(u=c.length,g.keys(t).length!==u)return!1;for(;u--;)if(p=c[u],!I(t,p)||!j(e[p],t[p],n,r))return!1}return n.pop(),r.pop(),!0},g.isEqual=function(e,t){return j(e,t)},g.isEmpty=function(e){return null==e||(C(e)&&(g.isArray(e)||g.isString(e)||g.isArguments(e))?0===e.length:0===g.keys(e).length)},g.isElement=function(e){return!(!e||1!==e.nodeType)},g.isArray=d||function(e){return"[object Array]"===f.call(e)},g.isObject=function(e){var t=typeof e;return"function"===t||"object"===t&&!!e},g.each(["Arguments","Function","String","Number","Date","RegExp","Error","Symbol","Map","WeakMap","Set","WeakSet"],function(e){g["is"+e]=function(t){return f.call(t)==="[object "+e+"]"}}),g.isArguments(arguments)||(g.isArguments=function(e){return I(e,"callee")});var H=a.document&&a.document.childNodes;"function"!=typeof/./&&"object"!=typeof Int8Array&&"function"!=typeof H&&(g.isFunction=function(e){return"function"==typeof e||!1}),g.isFinite=function(e){return!g.isSymbol(e)&&isFinite(e)&&!isNaN(parseFloat(e))},g.isNaN=function(e){return g.isNumber(e)&&isNaN(e)},g.isBoolean=function(e){return e===!0||e===!1||"[object Boolean]"===f.call(e)},g.isNull=function(e){return null===e},g.isUndefined=function(e){return void 0===e},g.has=function(e,t){if(!g.isArray(t))return I(e,t);for(var n=t.length,r=0;r<n;r++){var i=t[r];if(null==e||!h.call(e,i))return!1;e=e[i]}return!!n},g.noConflict=function(){return a._=o,this},g.identity=function(e){return e},g.constant=function(e){return function(){return e}},g.noop=function(){},g.property=function(e){return g.isArray(e)?function(t){return b(t,e)}:N(e)},g.propertyOf=function(e){return null==e?function(){}:function(t){return g.isArray(t)?b(e,t):e[t]}},g.matcher=g.matches=function(e){return e=g.extendOwn({},e),function(t){return g.isMatch(t,e)}},g.times=function(e,t,n){var r=Array(Math.max(0,e));t=E(t,n,1);for(var i=0;i<e;i++)r[i]=t(i);return r},g.random=function(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))},g.now=Date.now||function(){return(new Date).getTime()};var Y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},q=g.invert(Y),G=function(e){var t=function(t){return e[t]},n="(?:"+g.keys(e).join("|")+")",r=RegExp(n),i=RegExp(n,"g");return function(e){return e=null==e?"":""+e,r.test(e)?e.replace(i,t):e}};g.escape=G(Y),g.unescape=G(q),g.result=function(e,t,n){g.isArray(t)||(t=[t]);var r=t.length;if(!r)return g.isFunction(n)?n.call(e):n;for(var i=0;i<r;i++){var a=null==e?void 0:e[t[i]];void 0===a&&(a=n,i=r),e=g.isFunction(a)?a.call(e):a}return e};var X=0;g.uniqueId=function(e){var t=++X+"";return e?e+t:t},g.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var z=/(.)^/,$={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},J=/\\|'|\r|\n|\u2028|\u2029/g,Q=function(e){return"\\"+$[e]};g.template=function(e,t,n){!t&&n&&(t=n),t=g.defaults({},t,g.templateSettings);var r=RegExp([(t.escape||z).source,(t.interpolate||z).source,(t.evaluate||z).source].join("|")+"|$","g"),i=0,a="__p+='";e.replace(r,function(t,n,r,o,s){return a+=e.slice(i,s).replace(J,Q),i=s+t.length,n?a+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":o&&(a+="';\n"+o+"\n__p+='"),t}),a+="';\n",t.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";var o;try{o=new Function(t.variable||"obj","_",a)}catch(e){throw e.source=a,e}var s=function(e){return o.call(this,e,g)},u=t.variable||"obj";return s.source="function("+u+"){\n"+a+"}",s},g.chain=function(e){var t=g(e);return t._chain=!0,t};var Z=function(e,t){return e._chain?g(t).chain():t};g.mixin=function(e){return g.each(g.functions(e),function(t){var n=g[t]=e[t];g.prototype[t]=function(){var e=[this._wrapped];return p.apply(e,arguments),Z(this,n.apply(g,e))}}),g},g.mixin(g),g.each(["pop","push","reverse","shift","sort","splice","unshift"],function(e){var t=s[e];g.prototype[e]=function(){var n=this._wrapped;return t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0],Z(this,n)}}),g.each(["concat","join","slice"],function(e){var t=s[e];g.prototype[e]=function(){return Z(this,t.apply(this._wrapped,arguments))}}),g.prototype.value=function(){return this._wrapped},g.prototype.valueOf=g.prototype.toJSON=g.prototype.value,g.prototype.toString=function(){return String(this._wrapped)},r=[],i=function(){return g}.apply(t,r),!(void 0!==i&&(n.exports=i))}()}).call(t,function(){return this}(),n(10)(e))},function(e,t,n){(function(e){"use strict";function r(e){var t=null!=e.rootPath&&"function"==typeof e.rootPath,n=null!=e.isWebPath&&"function"==typeof e.isWebPath,r=null!=e.relativePath&&"function"==typeof e.relativePath;return t&&n&&r}function i(e){if(null==e||0==e.trim().length)return e;var t="https://".length;if(e.length>=t&&"https://"==e.substring(0,t))return e;e=e.replace("//","__/DOUBLESLASH/__"),e=e.replace(/^([a-zA-Z]):/,"$1__/COLON/__");var n="https://__/APPENDED_PROTOCOL/__";return"/"!=e.charAt(0)&&(n+="/"),n+e}function a(e){if(null==e||0==e.trim().length)return e;var t="https://__/APPENDED_PROTOCOL/__",n=t.length;return e.length<n||e.substring(0,n)!=t?e:(e=e.substring(n,e.length),e.indexOf("__/COLON/__")>0&&"/"==e.charAt(0)&&(e=e.substring(1)),e=e.replace("__/DOUBLESLASH/__","//").replace("__/COLON/__",":"))}function o(e,t){var n=k(t,e),r=!!M&&P.getValue(n);if(r&&r.provider)return r;var i=new D(e,t);return P.setValue(n,i),i}function s(e,t){var n=(k(t,e),!!M&&P.getValue(e));if(n)return n;var r=new x(e,t);return M&&P.setValue(e,r),r}function u(e,t){var n=e&&e.trim().length>0&&"{"==e.trim().charAt(0),r=k(t,e),i=!!M&&P.getValue(r);if(i)return i;try{var a=new D(e,t);return M&&P.setValue(r,a),a}catch(i){if(M&&T.ValidationError.isInstance(i)&&n)return P.setValue(r,i),i;try{var a=new x(e,t);return P.setValue(r,a),a}catch(e){if(M){var o=new T.ValidationError(S.messageRegistry.CAN_NOT_PARSE_SCHEMA);return P.setValue(r,o),o}}}}function l(e,t){for(var n=e.getElementsByTagNameNS("*",t),r=[],i=0;i<n.length;i++){var a=n[i];a.parentNode===e&&r.push(a)}return r}function p(e,t,n){null==n&&(n=c(e)),n.length>0&&(n+=":");for(var r=e.getElementsByTagName(n+t),i=[],a=0;a<r.length;a++){var o=r[a];o.parentNode===e&&i.push(o)}return i}function c(e){var t="";if(e){var n=e;if(e.ownerDocument&&(n=e.ownerDocument),n){var r=n.documentElement;r&&(t=r.prefix)}}return t}function f(e,t){void 0===t&&(t=!1);var n,r,i=t?S.messageRegistry.CAN_NOT_PARSE_JSON:S.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,a=F.length,o=B.length;if(e.substring(0,a)==F)n=F,r=a;else{if(e.substring(0,o)!=B)return new T.ValidationError(i,{msg:e});n=B,r=o}if(n&&r){var s=e.indexOf("\n",r);s<0&&(s=e.length);var u=e.substring(r).trim(),l=u.indexOf("<");l<0?l=0:l++;var p=u.indexOf("\n");p<0&&(p=u.length);var c=u.lastIndexOf("at",p);c<0?c=p:c+="at".length;var f=u.lastIndexOf(">",c);f<0&&(f=c);var h=u.substring(l,f),d=u.substring(c,p).trim(),m=d.indexOf(":");try{var y=parseInt(d.substring(0,m))-1,v=parseInt(d.substring(m+1,d.length))-1,g=n+" '"+h+"'",A=new T.ValidationError(i,{msg:g});return A.internalRange={start:{line:y,column:v,position:null},end:{line:y,column:v+h.length,position:null}},A}catch(e){}}return new T.ValidationError(S.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,{msg:e})}function h(e,t,n){if(!n||"string"!=typeof n)return null;t=t||N(e,{verbose:!0}),"#"==n.charAt(0)&&(n=n.substring(1)),"/"==n.charAt(0)&&(n=n.substring(1));var r=t;if(n.length>0)for(var i=n.split("/"),a=0,o=i;a<o.length;a++){var s=o[a],u=d(r,s);if(null==u)break;r=u}var l=r.loc.start,p=r.loc.end;return{start:{line:l.line-1,column:l.column-1,position:l.offset},end:{line:p.line-1,column:p.column-1,position:p.offset}}}function d(e,t){return"property"==e.type&&(e=e.value),"object"==e.type?g.find(e.children,function(e){return e.key.value==t}):"array"==e.type?e.children[t]:"array"==e.type?e:null}function m(e,t){try{if("string"!=typeof e)return;N(e,{verbose:!0})}catch(e){var n=f(e.message,t);throw n}}function y(e){return g.unique(v(e,[]))}function v(e,t){return Array.isArray(e)?e.forEach(function(e){return v(e,t)}):null!=e&&"object"==typeof e&&Object.keys(e).forEach(function(n){"$ref"===n&&"string"==typeof e[n]?t.push(a(e[n])):"object"==typeof e[n]&&v(e[n],t)}),t}Object.defineProperty(t,"__esModule",{value:!0});var g=n(61),A=n(62),E=n(65),_=n(67).DOMParser,T=n(58),S=n(58),N=n(70),I=n(71),b=function(){function e(){}return e}();t.ValidationResult=b;var R={errorHandler:{warning:function(){return null},error:function(){return null},fatalError:function(){return null}}},M=!0,C=5242880,w=function(){function e(){this.errors={},this.size=0}return e.prototype.getValue=function(e){var t=this.errors[e];return t?t.value:null},e.prototype.setValue=function(e,t){var n=this.errors[e];if(n)n.value=t;else for(n={key:e,value:t},this.top&&(this.top.next=n),this.top=n,this.last||(this.last=n),this.errors[e]=n,this.size+=e.length;this.size>C&&this.last;){var r=this.last.key;delete this.errors[r],this.size-=r.length,this.last=this.last.next}},e}(),P=new w;e.cleanCache=function(){P=new w};var L=function(){function e(){}return e.prototype.contextPath=function(){return""},e.prototype.normalizePath=function(e){return""},e.prototype.content=function(e){return""},e.prototype.hasAsyncRequests=function(){return!1},e.prototype.resolvePath=function(e,t){return""},e.prototype.isAbsolutePath=function(e){return!1},e.prototype.contentAsync=function(e){var t=this;return{then:function(n){return n(t.content(e))},resolve:function(){return null}}},e.prototype.promiseResolve=function(e){return{then:function(t){return t(e)},resolve:function(){return null}}},e}(),O=function(e,t,n){return"__EXAMPLE_"+(""+e).trim()+t.trim()+n},D=function(){function e(e,t){if(this.schema=e,this.provider=t,this.customErrors=[],this.EXAMPLE_ERROR_ENTRY=S.messageRegistry.CONTENT_DOES_NOT_MATCH_THE_SCHEMA,this.SCHEMA_ERROR_ENTRY=S.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,t?this.provider=t:this.provider=new L,!e||0==e.trim().length||"{"!=e.trim().charAt(0))throw new T.ValidationError(S.messageRegistry.INVALID_JSON_SCHEMA);m(e,!1);var r=JSON.parse(e);if(r){try{var i=n(73),a=this.provider.contextPath();this.setupId(r,a),this.updateGraph(r,a);var o=""+r.$schema;o.indexOf("http://json-schema.org/draft-04/")==-1?(this.customErrors=(new I.Draft3Validator).validate(e),r=i.v4(r)):this.fixRequired(r)}catch(e){if(T.ValidationError.isInstance(e))throw e;throw new T.ValidationError(S.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,{msg:e.message})}delete r.$schema,this.jsonSchema=r}}return e.prototype.fixRequired=function(e){},e.prototype.getType=function(){return"source.json"},e.prototype.validateObject=function(e){this.validate(JSON.stringify(e))},e.prototype.getMissingReferences=function(e,t){var n=this;void 0===t&&(t=!1);var r=[],i=E.getValidator();e.forEach(function(e){return i.setRemoteReference(e.reference,e.content||{})});var a=null;if(this.jsonSchema.id&&"string"==typeof this.jsonSchema.id){a=this.jsonSchema.id;var o=a.indexOf("#");o!=-1&&(a=a.substr(0,o))}try{i.validateSchema(this.jsonSchema)}catch(e){return[]}var r=i.getMissingRemoteReferences(),s=[];return r&&(s=g.filter(r,function(e){return!i.isResourceLoaded(e)&&e!=a})),t?s.map(function(e){return n.provider.normalizePath(e)}):s},e.prototype.getSchemaPath=function(e,t){if(void 0===t&&(t=!1),!e)return"";if(!e.id)return"";var n=e.id.trim();if(n.lastIndexOf("#")!==n.length-1)return n;var r=n.substr(0,n.length-1);return t?this.provider.normalizePath(r):r},e.prototype.patchSchema=function(e){var t=this;if(!e)return e;if(!e.id)return e;var n=e.id.trim();n.lastIndexOf("#")!==n.length-1&&(n+="#",e.id=n);var r=n.substr(0,n.length-1);if(!this.provider.isAbsolutePath(r))return e;r=this.provider.normalizePath(r);var a=[];this.collectRefContainers(e,a),a.forEach(function(e){var n=e.$ref;if("string"==typeof n&&0!==n.indexOf("#")){n.indexOf("#")===-1&&(n+="#");var a;a=t.provider.isAbsolutePath(n)?i(n):t.provider.resolvePath(r,n),e.$ref=a}})},e.prototype.removeFragmentPartOfIDs=function(e){var t=this;if(e){if(Array.isArray(e))return void e.forEach(function(e){return t.removeFragmentPartOfIDs(e)});if("object"==typeof e){var n=e.id;if(n&&"string"==typeof e.id){var r=n.indexOf("#");r>=0&&(n=n.substring(0,r).trim(),n?e.id=n:delete e.id)}Object.keys(e).forEach(function(n){return t.removeFragmentPartOfIDs(e[n])})}}},e.prototype.collectRefContainers=function(e,t){var n=this;Object.keys(e).forEach(function(r){return"$ref"===r?void t.push(e):void(e[r]&&"object"==typeof e[r]&&n.collectRefContainers(e[r],t))})},e.prototype.validate=function(e,t){var r=this;void 0===t&&(t=[]);var i=O(e,this.schema,this.provider.contextPath()),o=P.getValue(i);if(o){if(o instanceof Error)throw o}else{var s=O("__SCHEMA_VALIDATION__",this.schema,this.provider.contextPath()),u=P.getValue(s);if(u&&u instanceof Error){if(T.ValidationError.isInstance(u)){var l=u,p=new T.ValidationError(l.messageEntry,l.parameters);p.filePath=l.filePath,p.additionalErrors=l.additionalErrors,p.internalPath=l.internalPath,p.isWarning=l.isWarning,u=p}throw u}if(0==t.length&&(m(e,!0),this.jsonSchema.id)){var c=this.jsonSchema.id;if("#"==c.charAt(c.length-1)){var f=c.substring(0,c.length-1);t.push({reference:f,content:this.jsonSchema})}}var h=JSON.parse(e),d=E.getValidator();t.forEach(function(e){return d.setRemoteReference(e.reference,e.content)}),d.validate(h,this.jsonSchema);var y=d.getMissingRemoteReferences().filter(function(e){return!g.find(t,function(t){return e===t.reference})});if(!y||0===y.length)return void this.acceptErrors(i,d.getLastErrors(),e,!0);var v=[];y.forEach(function(e){var t,o=a(e),s={reference:e};try{var u=n(73),l=r.provider.content(o);m(l,!0);var p=JSON.parse(l),c=r.provider.normalizePath(o);r.setupId(p,c),r.updateGraph(p,c),t=u.v4(p),delete t.$schema,s.content=t}catch(e){if(T.ValidationError.isInstance(e))throw e.filePath=o,P.setValue(i,e),e;s.error=e}finally{v.push(s)}}),this.provider.hasAsyncRequests()||(v.forEach(function(e){t.push(e)}),this.validate(e,t))}},e.checkIfNonObjectAssignmentFailure=function(e){var t="__$validated",n="called on non-object";if(!e)return null;if(e.indexOf(t)!=-1){var r="Cannot assign to read only property '__$validated' of ",i="Cannot create property '__$validated' on string '";return 0==e.indexOf(r)&&e.length>r.length?e.substr(r.length,e.length-r.length):0==e.indexOf(i)&&e.length>i.length+1&&"'"==e.charAt(e.length-1)?e.substr(i.length,e.length-i.length-1):""}return e.indexOf(n)!=-1?"":null},e.prototype.validateSelf=function(t){var r=this;void 0===t&&(t=[]);var i=O("__SCHEMA_VALIDATION__",this.schema,this.provider.contextPath()),o=P.getValue(i);if(o){if(o instanceof Error)throw o}else{var s=E.getValidator();t.forEach(function(e){return s.setRemoteReference(e.reference,e.content)});try{delete this.jsonSchema.id,s.validateSchema(this.jsonSchema)}catch(t){var u=e.checkIfNonObjectAssignmentFailure(t.message);if(null!==u){var l=u,p="Assignment to non-object.";l&&(p="Unexpected value '"+l+"'"),this.acceptErrors(i,[{message:p,params:[]}],null,!0,!0)}throw t}var c=s.getMissingRemoteReferences().filter(function(e){return!g.find(t,function(t){return e===t.reference})});if(!c||0===c.length)return void this.acceptErrors(i,s.getLastErrors(),null,!0,!0);var f=[];c.forEach(function(e,t){if(!(t>0)){var o,s=a(e),u={reference:e};try{var l=n(73),p=r.provider.content(s);m(p,!0);var c=JSON.parse(p),h=r.provider.normalizePath(s);r.setupId(c,h),r.updateGraph(c,h),o=l.v4(c),delete o.$schema,u.content=o}catch(e){if(T.ValidationError.isInstance(e))throw e.filePath=s,P.setValue(i,e),e;u.error=e}finally{f.push(u)}}}),this.provider.hasAsyncRequests()||(f.forEach(function(e){t.push(e)}),this.validateSelf(t))}},e.prototype.setupId=function(e,t){t&&e&&(this.removeFragmentPartOfIDs(e),e.id&&(this.provider.isAbsolutePath(e.id)||(e.id=this.provider.resolvePath(t,e.id))),e.id=t.replace(/\\/g,"/"),"#"!=e.id.charAt(e.id.length-1)&&(e.id=e.id+"#"),e.id=i(e.id),this.patchSchema(e))},e.prototype.acceptErrors=function(t,n,r,i,a){var o=this;void 0===i&&(i=!1),void 0===a&&(a=!1);var s=null!=r,u=null!=r?r:this.schema;if(n&&n.length>0||null==r&&this.customErrors.length>0){n=n||[];var l=N(u,{verbose:!0}),p=n.map(function(t){var n,i=s&&e.EXAMPLE_ERROR_CODES[t.code];n=i?o.EXAMPLE_ERROR_ENTRY:o.SCHEMA_ERROR_ENTRY;var p=new T.ValidationError(n,{msg:t.message});return(i||null==r)&&(p.internalRange=h(u,l,t.path)),p.isWarning=a,p.error=t,p.internalPath=t.path,p});null==r&&this.customErrors.forEach(function(e){var t=new T.ValidationError(e.entry,e.params);t.internalRange=e.range,t.isWarning=e.isWarning,t.error=e,t.internalPath=e.path,p.push(t)});var c=p[0];if(c.additionalErrors=p.slice(1),P.setValue(t,c),i)throw c}else P.setValue(t,1)},e.prototype.contentAsync=function(e){var t,r=this,i=a(e),o=n(73),s=this.provider.contentAsync(i);if(!s)return this.provider.promiseResolve({reference:i,content:null,error:new T.ValidationError(S.messageRegistry.REFERENCE_NOT_FOUND,{ref:i})});var u=s.then(function(n){var a={reference:e};try{m(n,!0);var s=JSON.parse(n),u=r.provider.normalizePath(i);r.setupId(s,u),r.updateGraph(s,u),t=o.v4(s),delete t.$schema,a.content=t}catch(e){throw a.error=e,a.reference=i,e}return a});return u},e.prototype.updateGraph=function(e,t){t.indexOf("#")<0&&(t+="#"),this.graph||(this.graph=new j(t));var n=this.graph.addNode(e,t);if(n){if(r(this.provider)){var i=this.provider,a=i.rootPath(),o=a.length;n=n.map(function(e){var t=e.trim();return i.isWebPath(t)?i.isWebPath(a)&&t.length>=o&&t.substring(0,o)==a&&(t=t.substring(o)):t=i.relativePath(a,t).replace(/\\/g,"/"),t.length&&"#"==t.charAt(t.length-1)&&(t=t.substring(0,t.length-1)),t})}var s=new T.ValidationError(S.messageRegistry.CIRCULAR_REFS_IN_JSON_SCHEMA_DETAILS,{cycle:n.join(" -> ")});throw s}},e.SCHEMA_ERROR_CODES={KEYWORD_TYPE_EXPECTED:!0,KEYWORD_MUST_BE:!0,KEYWORD_DEPENDENCY:!0,KEYWORD_PATTERN:!0,KEYWORD_UNDEFINED_STRICT:!0,KEYWORD_VALUE_TYPE:!0,CUSTOM_MODE_FORCE_PROPERTIES:!0,UNKNOWN_FORMAT:!0,PARENT_SCHEMA_VALIDATION_FAILED:!0,REF_UNRESOLVED:!0,KEYWORD_UNEXPECTED:!0,SCHEMA_NOT_AN_OBJECT:!0,SCHEMA_NOT_REACHABLE:!0,UNRESOLVABLE_REFERENCE:!0},e.EXAMPLE_ERROR_CODES={MULTIPLE_OF:!0,MAXIMUM:!0,MAXIMUM_EXCLUSIVE:!0,MAX_LENGTH:!0,MIN_LENGTH:!0,PATTERN:!0,ARRAY_ADDITIONAL_ITEMS:!0,ARRAY_LENGTH_LONG:!0,ARRAY_LENGTH_SHORT:!0,ARRAY_UNIQUE:!0,OBJECT_PROPERTIES_MAXIMUM:!0,OBJECT_PROPERTIES_MINIMUM:!0,OBJECT_MISSING_REQUIRED_PROPERTY:!0,OBJECT_ADDITIONAL_PROPERTIES:!0,OBJECT_DEPENDENCY_KEY:!0,ENUM_MISMATCH:!0,ANY_OF_MISSING:!0,ONE_OF_MISSING:!0,ONE_OF_MULTIPLE:!0,NOT_PASSED:!0,INVALID_FORMAT:!0,UNKNOWN_FORMAT:!0,INVALID_TYPE:!0},e}();t.JSONSchemaObject=D;var U=10,x=function(){function e(e,t){if(this.schema=e,this.provider=t,this.extraElementData=null,this.references={},this.contentToResult={},t||(this.provider=new L),"<"!=e.charAt(0))throw new T.ValidationError(S.messageRegistry.INVALID_XML_SCHEMA);this.schemaString=this.handleReferenceElement(e)}return e.prototype.getType=function(){return"text.xml"},e.prototype.validateObject=function(e){if(this.extraElementData){var t=Object.keys(e)[0],n=new T.ValidationError(S.messageRegistry.EXTERNAL_TYPE_ERROR,{typeName:this.extraElementData.requestedName,objectName:t});if(!this.extraElementData.type&&!this.extraElementData.originalName)return void this.acceptErrors("key",[n],!0);if(this.extraElementData.originalName&&t!==this.extraElementData.originalName)return void this.acceptErrors("key",[n],!0);if(this.extraElementData.type){var r=e[t];delete e[t],e[this.extraElementData.name]=r}}this.validate(A.jsonToXml(e))},e.prototype.collectReferences=function(e,t,n){var r,i=this;r=new _(R).parseFromString(e);var a=p(r,"schema",this.namspacePrefix)[0],o=l(a,"import"),s=l(a,"include"),u=o.concat(s);return u.forEach(function(e){var r=e.getAttribute("schemaLocation");if(r){var a=i.provider.resolvePath(t,r),o=n[a];if(!o){var s,u=Object.keys(n).length,l=i.provider.content(a);try{s=i.collectReferences(l,a,n)}catch(e){s=l}o=A.createXmlSchemaReference(a,u,s),n[a]=o}e.setAttribute("schemaLocation","file_"+o.virtualIndex+".xsd")}}),r.toString()},e.prototype.getMissingReferences=function(){var e,t=this;e=new _(R).parseFromString(this.schemaString);var n=p(e,"schema",this.namspacePrefix)[0],r=p(n,"import",this.namspacePrefix),i=p(n,"include",this.namspacePrefix),a=r.concat(i),o=[];return a.forEach(function(e){var n=e.getAttribute("schemaLocation");if(n){var r=t.provider.resolvePath(t.provider.contextPath(),n);
o.push(r)}}),o},e.prototype.collectReferencesAsync=function(e,t,n){var r,i=this;r=new _(R).parseFromString(e);var a=p(r,"schema",this.namspacePrefix)[0],o=l(a,"import"),s=l(a,"include"),u=o.concat(s);return Promise.all(u.map(function(e){var r=e.getAttribute("schemaLocation");if(r){var a=i.provider.resolvePath(t,r),o=n[a];return o?(e.setAttribute("schemaLocation","file_"+o.virtualIndex+".xsd"),{}):i.provider.contentAsync(a).then(function(t){return i.collectReferencesAsync(t,a,n).then(function(e){return e},function(e){return t}).then(function(t){var r=Object.keys(n).length;return o=A.createXmlSchemaReference(a,r,t),n[a]=o,e.setAttribute("schemaLocation","file_"+o.virtualIndex+".xsd"),{}})})}return{}})).then(function(e){return Promise.resolve(r.toString())})},e.prototype.loadSchemaReferencesAsync=function(){return this.collectReferencesAsync(this.schemaString,this.provider.contextPath(),{})},e.prototype.validate=function(e){try{var t=this.contentToResult[e];if(t===!1)return;if(t)throw t;var n={},r=this.collectReferences(this.schemaString,this.provider.contextPath(),n),i=A.getValidator(r);if(this.provider.hasAsyncRequests())return;var a=i.validate(e,Object.keys(n).map(function(e){return n[e]}));this.acceptErrors("key",a,!0),this.contentToResult[e]=!1,Object.keys(this.contentToResult).length>U&&(this.contentToResult={})}catch(t){throw this.contentToResult[e]=t,t}},e.prototype.handleReferenceElement=function(e){var t=new _(R).parseFromString(e);this.namspacePrefix=c(t);var n=p(t,"schema",this.namspacePrefix)[0],r=p(n,"element",this.namspacePrefix),i=g.find(r,function(e){return"true"===e.getAttribute("extraelement")});if(!i)return e;var a={};return a.name=i.getAttribute("name"),a.type=i.getAttribute("type"),a.originalName=i.getAttribute("originalname"),a.requestedName=i.getAttribute("requestedname"),a.type||n.removeChild(i),i.removeAttribute("originalname"),i.removeAttribute("requestedname"),i.removeAttribute("extraelement"),this.extraElementData=a,t.toString()},e.prototype.acceptErrors=function(e,t,n){if(void 0===n&&(n=!1),t&&t.length>0){var r=t.map(function(e){return e.message}).join(", "),i=new T.ValidationError(S.messageRegistry.CONTENT_DOES_NOT_MATCH_THE_SCHEMA,{msg:r});if(i.errors=t,P.setValue(e,i),n)throw i}else;},e}();t.XMLSchemaObject=x,t.getJSONSchema=o;var k=function(e,t){var n="";e&&(n=e.contextPath());var r="__SCHEMA_"+(""+t).trim()+n.trim();return r};t.getXMLSchema=s,t.createSchema=u;var F="Cannot tokenize symbol",B="Unexpected token";t.messageToValidationError=f,t.getJSONRange=h,t.tryParseJSON=m;var V=function(){function e(e){this.segments=e}return e.prototype.length=function(){return this.segments.length},e}(),K=function(){function e(e){this.url=e,this.processed=!1,this.refFromRoot=new V([]),this.refsOut={},this.referees={}}return e}(),j=function(){function e(e){this.rootPath=e,this.nodes={}}return e.prototype.node=function(e){return this.nodes[e]},e.prototype.addNode=function(e,t){var n=this.nodes[t];if(n){if(n.processed)return}else n=new K(t),this.nodes[t]=n;for(var r=y(e),i=Object.keys(n.referees).map(function(e){return n.referees[e]}),a=null,o=function(e){var r=n.referees[e];r&&(a=[s.rootPath].concat(r.refFromRoot.segments).concat(r.refsOut[t].segments).concat([e]));var o=s.nodes[e];o||(o=new K(e),o.refFromRoot=new V(n.refFromRoot.segments.concat([e])),s.nodes[e]=o);for(var u=i.filter(function(e){return!o.referees[e.url]}),l=0,p=u;l<p.length;l++){var c=p[l];o.referees[c.url]=c,c.refsOut[e]=new V(c.refsOut[t].segments.concat([e]))}n.refsOut[e]=new V([e]),o.referees[n.url]=n},s=this,u=0,l=r;u<l.length;u++){var p=l[u];o(p)}return n.processed=!0,a},e}()}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(e,t){return o.find(e,t)}function i(e,t){return o.filter(e,t)}function a(e){return o.unique(e)}Object.defineProperty(t,"__esModule",{value:!0});var o=n(59);t.find=r,t.filter=i,t.unique=a},function(e,t,n){"use strict";function r(e,t,n){return{originalPath:e,virtualIndex:t,patchedContent:n}}function i(e){if(!e)return"";var t=Object.keys(e)[0],n=e[t];if("#text"==t)return n;if(!n&&""!==n)return"";var r="<"+t,a=n.$||{};return Object.keys(a).forEach(function(e){r=r+" "+e+'="'+a[e]+'"'}),r+=">","string"==typeof n?r+=p(n):Object.keys(n).forEach(function(e){if("$"!==e){if("_"===e&&"string"==typeof n[e])return void(r+=p(n[e]));if("object"!=typeof n[e]||n[e].length)if("string"!=typeof n[e]&&n[e]){if("object"==typeof n[e]&&n[e].length)for(var t=n[e],a=0;a<t.length;a++){var o=t[a],s={};s[e]=o,r+=i(s)}}else{var s={};s[e]=n[e]||"",r+=i(s)}else{var s={};s[e]=n[e],r+=i(s)}}}),r=r+"</"+t+">"}function a(e){return new l(e)}function o(e){var t=e&&Object.keys(e)[0];if(t){var n=e[t];s(n)}return i(e)}function s(e){if(e&&"string"!=typeof e){var t=[];Object.keys(e).forEach(function(n){if("$"!=n)if(0===n.indexOf("@")){var r={key:n,value:e[n]};t.push(r)}else if(u(e[n])){var i=e[n];i.forEach(function(e){return s(e)})}else"string"!=typeof e[n]&&s(e[n])}),e.$||(e.$={});var n=e.$;t.forEach(function(t){delete e[t.key];var r=t.key.substring(1);n[r]=t.value})}}function u(e){return!!e&&("object"==typeof e&&"number"==typeof e.length)}Object.defineProperty(t,"__esModule",{value:!0});var l,p=n(63);try{l=n(64).XMLValidator}catch(e){}if(!l){var c=function(){function e(e){}return e.prototype.validate=function(e,t){return[]},e}();l=c}t.createXmlSchemaReference=r,t.getValidator=a,t.jsonToXml=o},function(e,t){/*!
	 * escape-html
	 * Copyright(c) 2012-2013 TJ Holowaychuk
	 * Copyright(c) 2015 Andreas Lubbe
	 * Copyright(c) 2015 Tiancheng "Timothy" Gu
	 * MIT Licensed
	 */
"use strict";function n(e){var t=""+e,n=r.exec(t);if(!n)return t;var i,a="",o=0,s=0;for(o=n.index;o<t.length;o++){switch(t.charCodeAt(o)){case 34:i="&quot;";break;case 38:i="&amp;";break;case 39:i="&#39;";break;case 60:i="&lt;";break;case 62:i="&gt;";break;default:continue}s!==o&&(a+=t.substring(s,o)),s=o+1,a+=i}return s!==o?a+t.substring(s,o):a}var r=/["'&<>]/;e.exports=n},function(e,t){if("undefined"==typeof __WEBPACK_EXTERNAL_MODULE_64__){var n=new Error('Cannot find module "RAML.XmlValidation"');throw n.code="MODULE_NOT_FOUND",n}e.exports=__WEBPACK_EXTERNAL_MODULE_64__},function(e,t,n){"use strict";function r(){return new i}Object.defineProperty(t,"__esModule",{value:!0});var i;try{i=n(66).JSONValidator}catch(e){}if(!i){var a=function(){function e(){}return e.prototype.setRemoteReference=function(e,t){},e.prototype.validateSchema=function(e){},e.prototype.getMissingRemoteReferences=function(){return[]},e.prototype.isResourceLoaded=function(e){return!0},e.prototype.validate=function(e,t){},e.prototype.getLastErrors=function(){return[]},e}();i=a}t.getValidator=r},function(e,t){if("undefined"==typeof __WEBPACK_EXTERNAL_MODULE_66__){var n=new Error('Cannot find module "RAML.JsonValidation"');throw n.code="MODULE_NOT_FOUND",n}e.exports=__WEBPACK_EXTERNAL_MODULE_66__},function(e,t,n){function r(e){this.options=e||{locator:{}}}function i(e,t,n){function r(t){var r=e[t];!r&&o&&(r=2==e.length?function(n){e(t,n)}:e),i[t]=r&&function(e){r("[xmldom "+t+"]\t"+e+s(n))}||function(){}}if(!e){if(t instanceof a)return t;e=t}var i={},o=e instanceof Function;return n=n||{},r("warning"),r("error"),r("fatalError"),i}function a(){this.cdata=!1}function o(e,t){t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber}function s(e){if(e)return"\n@"+(e.systemId||"")+"#[line:"+e.lineNumber+",col:"+e.columnNumber+"]"}function u(e,t,n){return"string"==typeof e?e.substr(t,n):e.length>=t+n||t?new java.lang.String(e,t,n)+"":e}function l(e,t){e.currentElement?e.currentElement.appendChild(t):e.doc.appendChild(t)}r.prototype.parseFromString=function(e,t){var n=this.options,r=new p,o=n.domBuilder||new a,s=n.errorHandler,u=n.locator,l=n.xmlns||{},c={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return u&&o.setDocumentLocator(u),r.errorHandler=i(s,o,u),r.domBuilder=n.domBuilder||o,/\/x?html?$/.test(t)&&(c.nbsp=" ",c.copy="©",l[""]="http://www.w3.org/1999/xhtml"),l.xml=l.xml||"http://www.w3.org/XML/1998/namespace",e?r.parse(e,l,c):r.errorHandler.error("invalid doc source"),o.doc},a.prototype={startDocument:function(){this.doc=(new c).createDocument(null,null,null),this.locator&&(this.doc.documentURI=this.locator.systemId)},startElement:function(e,t,n,r){var i=this.doc,a=i.createElementNS(e,n||t),s=r.length;l(this,a),this.currentElement=a,this.locator&&o(this.locator,a);for(var u=0;u<s;u++){var e=r.getURI(u),p=r.getValue(u),n=r.getQName(u),c=i.createAttributeNS(e,n);this.locator&&o(r.getLocator(u),c),c.value=c.nodeValue=p,a.setAttributeNode(c)}},endElement:function(e,t,n){var r=this.currentElement;r.tagName;this.currentElement=r.parentNode},startPrefixMapping:function(e,t){},endPrefixMapping:function(e){},processingInstruction:function(e,t){var n=this.doc.createProcessingInstruction(e,t);this.locator&&o(this.locator,n),l(this,n)},ignorableWhitespace:function(e,t,n){},characters:function(e,t,n){if(e=u.apply(this,arguments)){if(this.cdata)var r=this.doc.createCDATASection(e);else var r=this.doc.createTextNode(e);this.currentElement?this.currentElement.appendChild(r):/^\s*$/.test(e)&&this.doc.appendChild(r),this.locator&&o(this.locator,r)}},skippedEntity:function(e){},endDocument:function(){this.doc.normalize()},setDocumentLocator:function(e){(this.locator=e)&&(e.lineNumber=0)},comment:function(e,t,n){e=u.apply(this,arguments);var r=this.doc.createComment(e);this.locator&&o(this.locator,r),l(this,r)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(e,t,n){var r=this.doc.implementation;if(r&&r.createDocumentType){var i=r.createDocumentType(e,t,n);this.locator&&o(this.locator,i),l(this,i)}},warning:function(e){console.warn("[xmldom warning]\t"+e,s(this.locator))},error:function(e){console.error("[xmldom error]\t"+e,s(this.locator))},fatalError:function(e){throw console.error("[xmldom fatalError]\t"+e,s(this.locator)),e}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(e){a.prototype[e]=function(){return null}});var p=n(68).XMLReader,c=t.DOMImplementation=n(69).DOMImplementation;t.XMLSerializer=n(69).XMLSerializer,t.DOMParser=r},function(e,t){function n(){}function r(e,t,n,r,l){function h(e){if(e>65535){e-=65536;var t=55296+(e>>10),n=56320+(1023&e);return String.fromCharCode(t,n)}return String.fromCharCode(e)}function d(e){var t=e.slice(1,-1);return t in n?n[t]:"#"===t.charAt(0)?h(parseInt(t.substr(1).replace("x","0x"))):(l.error("entity not found:"+e),e)}function m(t){if(t>S){var n=e.substring(S,t).replace(/&#?\w+;/g,d);E&&y(S),r.characters(n,0,t-S),S=t}}function y(t,n){for(;t>=g&&(n=A.exec(e));)v=n.index,g=v+n[0].length,E.lineNumber++;E.columnNumber=t-v+1}for(var v=0,g=0,A=/.*(?:\r\n?|\n)|.*$/g,E=r.locator,_=[{currentNSMap:t}],T={},S=0;;){try{var N=e.indexOf("<",S);if(N<0){if(!e.substr(S).match(/^\s*$/)){var I=r.doc,b=I.createTextNode(e.substr(S));I.appendChild(b),r.currentElement=b}return}switch(N>S&&m(N),e.charAt(N+1)){case"/":var R=e.indexOf(">",N+3),M=e.substring(N+2,R),C=_.pop();R<0?(M=e.substring(N+2).replace(/[\s<].*/,""),l.error("end tag name: "+M+" is not complete:"+C.tagName),R=N+1+M.length):M.match(/\s</)&&(M=M.replace(/[\s<].*/,""),l.error("end tag name: "+M+" maybe not complete"),R=N+1+M.length);var w=C.localNSMap,P=C.tagName==M,L=P||C.tagName&&C.tagName.toLowerCase()==M.toLowerCase();if(L){if(r.endElement(C.uri,C.localName,M),w)for(var O in w)r.endPrefixMapping(O);P||l.fatalError("end tag name: "+M+" is not match the current start tagName:"+C.tagName)}else _.push(C);R++;break;case"?":E&&y(N),R=c(e,N,r);break;case"!":E&&y(N),R=p(e,N,r,l);break;default:E&&y(N);var D=new f,U=_[_.length-1].currentNSMap,R=a(e,N,D,U,d,l),x=D.length;if(!D.closed&&u(e,R,D.tagName,T)&&(D.closed=!0,n.nbsp||l.warning("unclosed xml attribute")),E&&x){for(var k=i(E,{}),F=0;F<x;F++){var B=D[F];y(B.offset),B.locator=i(E,{})}r.locator=k,o(D,r,U)&&_.push(D),r.locator=E}else o(D,r,U)&&_.push(D);"http://www.w3.org/1999/xhtml"!==D.uri||D.closed?R++:R=s(e,R,D.tagName,d,r)}}catch(e){l.error("element parse error: "+e),R=-1}R>S?S=R:m(Math.max(N,S)+1)}}function i(e,t){return t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber,t}function a(e,t,n,r,i,a){for(var o,s,u=++t,l=g;;){var p=e.charAt(u);switch(p){case"=":if(l===A)o=e.slice(t,u),l=_;else{if(l!==E)throw new Error("attribute equal must after attrName");l=_}break;case"'":case'"':if(l===_||l===A){if(l===A&&(a.warning('attribute value must after "="'),o=e.slice(t,u)),t=u+1,u=e.indexOf(p,t),!(u>0))throw new Error("attribute value no end '"+p+"' match");s=e.slice(t,u).replace(/&#?\w+;/g,i),n.add(o,s,t-1),l=S}else{if(l!=T)throw new Error('attribute value must after "="');s=e.slice(t,u).replace(/&#?\w+;/g,i),n.add(o,s,t),a.warning('attribute "'+o+'" missed start quot('+p+")!!"),t=u+1,l=S}break;case"/":switch(l){case g:n.setTagName(e.slice(t,u));case S:case N:case I:l=I,n.closed=!0;case T:case A:case E:break;default:throw new Error("attribute invalid close char('/')")}break;case"":return a.error("unexpected end of input"),l==g&&n.setTagName(e.slice(t,u)),u;case">":switch(l){case g:n.setTagName(e.slice(t,u));case S:case N:case I:break;case T:case A:s=e.slice(t,u),"/"===s.slice(-1)&&(n.closed=!0,s=s.slice(0,-1));case E:l===E&&(s=o),l==T?(a.warning('attribute "'+s+'" missed quot(")!!'),n.add(o,s.replace(/&#?\w+;/g,i),t)):("http://www.w3.org/1999/xhtml"===r[""]&&s.match(/^(?:disabled|checked|selected)$/i)||a.warning('attribute "'+s+'" missed value!! "'+s+'" instead!!'),n.add(s,s,t));break;case _:throw new Error("attribute value missed!!")}return u;case"":p=" ";default:if(p<=" ")switch(l){case g:n.setTagName(e.slice(t,u)),l=N;break;case A:o=e.slice(t,u),l=E;break;case T:var s=e.slice(t,u).replace(/&#?\w+;/g,i);a.warning('attribute "'+s+'" missed quot(")!!'),n.add(o,s,t);case S:l=N}else switch(l){case E:n.tagName;"http://www.w3.org/1999/xhtml"===r[""]&&o.match(/^(?:disabled|checked|selected)$/i)||a.warning('attribute "'+o+'" missed value!! "'+o+'" instead2!!'),n.add(o,o,t),t=u,l=A;break;case S:a.warning('attribute space is required"'+o+'"!!');case N:l=A,t=u;break;case _:l=T,t=u;break;case I:throw new Error("elements closed character '/' and '>' must be connected to")}}u++}}function o(e,t,n){for(var r=e.tagName,i=null,a=e.length;a--;){var o=e[a],s=o.qName,u=o.value,p=s.indexOf(":");if(p>0)var c=o.prefix=s.slice(0,p),f=s.slice(p+1),h="xmlns"===c&&f;else f=s,c=null,h="xmlns"===s&&"";o.localName=f,h!==!1&&(null==i&&(i={},l(n,n={})),n[h]=i[h]=u,o.uri="http://www.w3.org/2000/xmlns/",t.startPrefixMapping(h,u))}for(var a=e.length;a--;){o=e[a];var c=o.prefix;c&&("xml"===c&&(o.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==c&&(o.uri=n[c||""]))}var p=r.indexOf(":");p>0?(c=e.prefix=r.slice(0,p),f=e.localName=r.slice(p+1)):(c=null,f=e.localName=r);var d=e.uri=n[c||""];if(t.startElement(d,f,r,e),!e.closed)return e.currentNSMap=n,e.localNSMap=i,!0;if(t.endElement(d,f,r),i)for(c in i)t.endPrefixMapping(c)}function s(e,t,n,r,i){if(/^(?:script|textarea)$/i.test(n)){var a=e.indexOf("</"+n+">",t),o=e.substring(t+1,a);if(/[&<]/.test(o))return/^script$/i.test(n)?(i.characters(o,0,o.length),a):(o=o.replace(/&#?\w+;/g,r),i.characters(o,0,o.length),a)}return t+1}function u(e,t,n,r){var i=r[n];return null==i&&(i=e.lastIndexOf("</"+n+">"),i<t&&(i=e.lastIndexOf("</"+n)),r[n]=i),i<t}function l(e,t){for(var n in e)t[n]=e[n]}function p(e,t,n,r){var i=e.charAt(t+2);switch(i){case"-":if("-"===e.charAt(t+3)){var a=e.indexOf("-->",t+4);return a>t?(n.comment(e,t+4,a-t-4),a+3):(r.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==e.substr(t+3,6)){var a=e.indexOf("]]>",t+9);return n.startCDATA(),n.characters(e,t+9,a-t-9),n.endCDATA(),a+3}var o=d(e,t),s=o.length;if(s>1&&/!doctype/i.test(o[0][0])){var u=o[1][0],l=s>3&&/^public$/i.test(o[2][0])&&o[3][0],p=s>4&&o[4][0],c=o[s-1];return n.startDTD(u,l&&l.replace(/^(['"])(.*?)\1$/,"$2"),p&&p.replace(/^(['"])(.*?)\1$/,"$2")),n.endDTD(),c.index+c[0].length}}return-1}function c(e,t,n){var r=e.indexOf("?>",t);if(r){var i=e.substring(t,r).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(i){i[0].length;return n.processingInstruction(i[1],i[2]),r+2}return-1}return-1}function f(e){}function h(e,t){return e.__proto__=t,e}function d(e,t){var n,r=[],i=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(i.lastIndex=t,i.exec(e);n=i.exec(e);)if(r.push(n),n[1])return r}var m=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,y=new RegExp("[\\-\\.0-9"+m.source.slice(1,-1)+"\\u00B7\\u0300-\\u036F\\u203F-\\u2040]"),v=new RegExp("^"+m.source+y.source+"*(?::"+m.source+y.source+"*)?$"),g=0,A=1,E=2,_=3,T=4,S=5,N=6,I=7;n.prototype={parse:function(e,t,n){var i=this.domBuilder;i.startDocument(),l(t,t={}),r(e,t,n,i,this.errorHandler),i.endDocument()}},f.prototype={setTagName:function(e){if(!v.test(e))throw new Error("invalid tagName:"+e);this.tagName=e},add:function(e,t,n){if(!v.test(e))throw new Error("invalid attribute:"+e);this[this.length++]={qName:e,value:t,offset:n}},length:0,getLocalName:function(e){return this[e].localName},getLocator:function(e){return this[e].locator},getQName:function(e){return this[e].qName},getURI:function(e){return this[e].uri},getValue:function(e){return this[e].value}},h({},h.prototype)instanceof h||(h=function(e,t){function n(){}n.prototype=t,n=new n;for(t in e)n[t]=e[t];return n}),t.XMLReader=n},function(e,t){function n(e,t){for(var n in e)t[n]=e[n]}function r(e,t){function r(){}var i=e.prototype;if(Object.create){var a=Object.create(t.prototype);i.__proto__=a}i instanceof t||(r.prototype=t.prototype,r=new r,n(i,r),e.prototype=i=r),i.constructor!=e&&("function"!=typeof e&&console.error("unknow Class:"+e),i.constructor=e)}function i(e,t){if(t instanceof Error)var n=t;else n=this,Error.call(this,ie[e]),this.message=ie[e],Error.captureStackTrace&&Error.captureStackTrace(this,i);return n.code=e,t&&(this.message=this.message+": "+t),n}function a(){}function o(e,t){this._node=e,this._refresh=t,s(this)}function s(e){var t=e._node._inc||e._node.ownerDocument._inc;if(e._inc!=t){var r=e._refresh(e._node);K(e,"length",r.length),n(r,e),e._inc=t}}function u(){}function l(e,t){for(var n=e.length;n--;)if(e[n]===t)return n}function p(e,t,n,r){if(r?t[l(t,r)]=n:t[t.length++]=n,e){n.ownerElement=e;var i=e.ownerDocument;i&&(r&&g(i,e,r),v(i,e,n))}}function c(e,t,n){var r=l(t,n);if(!(r>=0))throw i(oe,new Error(e.tagName+"@"+n));for(var a=t.length-1;r<a;)t[r]=t[++r];if(t.length=a,e){var o=e.ownerDocument;o&&(g(o,e,n),n.ownerElement=null)}}function f(e){if(this._features={},e)for(var t in e)this._features=e[t]}function h(){}function d(e){return"<"==e&&"&lt;"||">"==e&&"&gt;"||"&"==e&&"&amp;"||'"'==e&&"&quot;"||"&#"+e.charCodeAt()+";"}function m(e,t){if(t(e))return!0;if(e=e.firstChild)do if(m(e,t))return!0;while(e=e.nextSibling)}function y(){}function v(e,t,n){e&&e._inc++;var r=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==r&&(t._nsMap[n.prefix?n.localName:""]=n.value)}function g(e,t,n,r){e&&e._inc++;var i=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==i&&delete t._nsMap[n.prefix?n.localName:""]}function A(e,t,n){if(e&&e._inc){e._inc++;var r=t.childNodes;if(n)r[r.length++]=n;else{for(var i=t.firstChild,a=0;i;)r[a++]=i,i=i.nextSibling;r.length=a}}}function E(e,t){var n=t.previousSibling,r=t.nextSibling;return n?n.nextSibling=r:e.firstChild=r,r?r.previousSibling=n:e.lastChild=n,A(e.ownerDocument,e),t}function _(e,t,n){var r=t.parentNode;if(r&&r.removeChild(t),t.nodeType===te){var i=t.firstChild;if(null==i)return t;var a=t.lastChild}else i=a=t;var o=n?n.previousSibling:e.lastChild;i.previousSibling=o,a.nextSibling=n,o?o.nextSibling=i:e.firstChild=i,null==n?e.lastChild=a:n.previousSibling=a;do i.parentNode=e;while(i!==a&&(i=i.nextSibling));return A(e.ownerDocument||e,e),t.nodeType==te&&(t.firstChild=t.lastChild=null),t}function T(e,t){var n=t.parentNode;if(n){var r=e.lastChild;n.removeChild(t);var r=e.lastChild}var r=e.lastChild;return t.parentNode=e,t.previousSibling=r,t.nextSibling=null,r?r.nextSibling=t:e.firstChild=t,e.lastChild=t,A(e.ownerDocument,e,t),t}function S(){this._nsMap={}}function N(){}function I(){}function b(){}function R(){}function M(){}function C(){}function w(){}function P(){}function L(){}function O(){}function D(){}function U(){}function x(e,t){var n=[],r=9==this.nodeType?this.documentElement:this,i=r.prefix,a=r.namespaceURI;if(a&&null==i){var i=r.lookupPrefix(a);if(null==i)var o=[{namespace:a,prefix:null}]}return F(this,n,e,t,o),n.join("")}function k(e,t,n){var r=e.prefix||"",i=e.namespaceURI;if(!r&&!i)return!1;if("xml"===r&&"http://www.w3.org/XML/1998/namespace"===i||"http://www.w3.org/2000/xmlns/"==i)return!1;for(var a=n.length;a--;){var o=n[a];if(o.prefix==r)return o.namespace!=i}return!0}function F(e,t,n,r,i){if(r){if(e=r(e),!e)return;if("string"==typeof e)return void t.push(e)}switch(e.nodeType){case Y:i||(i=[]);var a=(i.length,e.attributes),o=a.length,s=e.firstChild,u=e.tagName;n=W===e.namespaceURI||n,t.push("<",u);for(var l=0;l<o;l++){var p=a.item(l);"xmlns"==p.prefix?i.push({prefix:p.localName,namespace:p.value}):"xmlns"==p.nodeName&&i.push({prefix:"",namespace:p.value})}for(var l=0;l<o;l++){var p=a.item(l);if(k(p,n,i)){var c=p.prefix||"",f=p.namespaceURI,h=c?" xmlns:"+c:" xmlns";t.push(h,'="',f,'"'),i.push({prefix:c,namespace:f})}F(p,t,n,r,i)}if(k(e,n,i)){var c=e.prefix||"",f=e.namespaceURI,h=c?" xmlns:"+c:" xmlns";t.push(h,'="',f,'"'),i.push({prefix:c,namespace:f})}if(s||n&&!/^(?:meta|link|img|br|hr|input)$/i.test(u)){if(t.push(">"),n&&/^script$/i.test(u))for(;s;)s.data?t.push(s.data):F(s,t,n,r,i),s=s.nextSibling;else for(;s;)F(s,t,n,r,i),s=s.nextSibling;t.push("</",u,">")}else t.push("/>");return;case Z:case te:for(var s=e.firstChild;s;)F(s,t,n,r,i),s=s.nextSibling;return;case q:return t.push(" ",e.name,'="',e.value.replace(/[<&"]/g,d),'"');case G:return t.push(e.data.replace(/[<&]/g,d));case X:return t.push("<![CDATA[",e.data,"]]>");case Q:return t.push("<!--",e.data,"-->");case ee:var m=e.publicId,y=e.systemId;if(t.push("<!DOCTYPE ",e.name),m)t.push(' PUBLIC "',m),y&&"."!=y&&t.push('" "',y),t.push('">');else if(y&&"."!=y)t.push(' SYSTEM "',y,'">');else{var v=e.internalSubset;v&&t.push(" [",v,"]"),t.push(">")}return;case J:return t.push("<?",e.target," ",e.data,"?>");case z:return t.push("&",e.nodeName,";");default:t.push("??",e.nodeName)}}function B(e,t,n){var r;switch(t.nodeType){case Y:r=t.cloneNode(!1),r.ownerDocument=e;case te:break;case q:n=!0}if(r||(r=t.cloneNode(!1)),r.ownerDocument=e,r.parentNode=null,n)for(var i=t.firstChild;i;)r.appendChild(B(e,i,n)),i=i.nextSibling;return r}function V(e,t,n){var r=new t.constructor;for(var i in t){var o=t[i];"object"!=typeof o&&o!=r[i]&&(r[i]=o)}switch(t.childNodes&&(r.childNodes=new a),r.ownerDocument=e,r.nodeType){case Y:var s=t.attributes,l=r.attributes=new u,p=s.length;l._ownerElement=r;for(var c=0;c<p;c++)r.setAttributeNode(V(e,s.item(c),!0));break;case q:n=!0}if(n)for(var f=t.firstChild;f;)r.appendChild(V(e,f,n)),f=f.nextSibling;return r}function K(e,t,n){e[t]=n}function j(e){switch(e.nodeType){case Y:case te:var t=[];for(e=e.firstChild;e;)7!==e.nodeType&&8!==e.nodeType&&t.push(j(e)),e=e.nextSibling;return t.join("");default:return e.nodeValue}}var W="http://www.w3.org/1999/xhtml",H={},Y=H.ELEMENT_NODE=1,q=H.ATTRIBUTE_NODE=2,G=H.TEXT_NODE=3,X=H.CDATA_SECTION_NODE=4,z=H.ENTITY_REFERENCE_NODE=5,$=H.ENTITY_NODE=6,J=H.PROCESSING_INSTRUCTION_NODE=7,Q=H.COMMENT_NODE=8,Z=H.DOCUMENT_NODE=9,ee=H.DOCUMENT_TYPE_NODE=10,te=H.DOCUMENT_FRAGMENT_NODE=11,ne=H.NOTATION_NODE=12,re={},ie={},ae=(re.INDEX_SIZE_ERR=(ie[1]="Index size error",1),re.DOMSTRING_SIZE_ERR=(ie[2]="DOMString size error",2),re.HIERARCHY_REQUEST_ERR=(ie[3]="Hierarchy request error",3)),oe=(re.WRONG_DOCUMENT_ERR=(ie[4]="Wrong document",4),re.INVALID_CHARACTER_ERR=(ie[5]="Invalid character",5),re.NO_DATA_ALLOWED_ERR=(ie[6]="No data allowed",6),re.NO_MODIFICATION_ALLOWED_ERR=(ie[7]="No modification allowed",7),re.NOT_FOUND_ERR=(ie[8]="Not found",8)),se=(re.NOT_SUPPORTED_ERR=(ie[9]="Not supported",9),re.INUSE_ATTRIBUTE_ERR=(ie[10]="Attribute in use",10));re.INVALID_STATE_ERR=(ie[11]="Invalid state",11),re.SYNTAX_ERR=(ie[12]="Syntax error",12),re.INVALID_MODIFICATION_ERR=(ie[13]="Invalid modification",13),re.NAMESPACE_ERR=(ie[14]="Invalid namespace",14),re.INVALID_ACCESS_ERR=(ie[15]="Invalid access",15);i.prototype=Error.prototype,n(re,i),a.prototype={length:0,item:function(e){return this[e]||null},toString:function(e,t){for(var n=[],r=0;r<this.length;r++)F(this[r],n,e,t);return n.join("")}},o.prototype.item=function(e){return s(this),this[e]},r(o,a),u.prototype={length:0,item:a.prototype.item,getNamedItem:function(e){for(var t=this.length;t--;){var n=this[t];if(n.nodeName==e)return n}},setNamedItem:function(e){var t=e.ownerElement;if(t&&t!=this._ownerElement)throw new i(se);var n=this.getNamedItem(e.nodeName);return p(this._ownerElement,this,e,n),n},setNamedItemNS:function(e){var t,n=e.ownerElement;if(n&&n!=this._ownerElement)throw new i(se);return t=this.getNamedItemNS(e.namespaceURI,e.localName),p(this._ownerElement,this,e,t),t},removeNamedItem:function(e){var t=this.getNamedItem(e);return c(this._ownerElement,this,t),t},removeNamedItemNS:function(e,t){var n=this.getNamedItemNS(e,t);return c(this._ownerElement,this,n),n},getNamedItemNS:function(e,t){for(var n=this.length;n--;){var r=this[n];if(r.localName==t&&r.namespaceURI==e)return r}return null}},f.prototype={hasFeature:function(e,t){var n=this._features[e.toLowerCase()];return!(!n||t&&!(t in n))},createDocument:function(e,t,n){var r=new y;if(r.implementation=this,r.childNodes=new a,r.doctype=n,n&&r.appendChild(n),t){var i=r.createElementNS(e,t);r.appendChild(i)}return r},createDocumentType:function(e,t,n){var r=new C;return r.name=e,r.nodeName=e,r.publicId=t,r.systemId=n,r}},h.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(e,t){return _(this,e,t)},replaceChild:function(e,t){this.insertBefore(e,t),t&&this.removeChild(t)},removeChild:function(e){return E(this,e)},appendChild:function(e){return this.insertBefore(e,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(e){return V(this.ownerDocument||this,this,e)},normalize:function(){for(var e=this.firstChild;e;){var t=e.nextSibling;t&&t.nodeType==G&&e.nodeType==G?(this.removeChild(t),e.appendData(t.data)):(e.normalize(),e=t)}},isSupported:function(e,t){return this.ownerDocument.implementation.hasFeature(e,t)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(e){for(var t=this;t;){var n=t._nsMap;if(n)for(var r in n)if(n[r]==e)return r;t=t.nodeType==q?t.ownerDocument:t.parentNode}return null},lookupNamespaceURI:function(e){for(var t=this;t;){var n=t._nsMap;if(n&&e in n)return n[e];t=t.nodeType==q?t.ownerDocument:t.parentNode}return null},isDefaultNamespace:function(e){var t=this.lookupPrefix(e);return null==t}},n(H,h),n(H,h.prototype),y.prototype={nodeName:"#document",nodeType:Z,doctype:null,documentElement:null,_inc:1,insertBefore:function(e,t){if(e.nodeType==te){for(var n=e.firstChild;n;){var r=n.nextSibling;this.insertBefore(n,t),n=r}return e}return null==this.documentElement&&e.nodeType==Y&&(this.documentElement=e),_(this,e,t),e.ownerDocument=this,e},removeChild:function(e){return this.documentElement==e&&(this.documentElement=null),E(this,e)},importNode:function(e,t){return B(this,e,t)},getElementById:function(e){var t=null;return m(this.documentElement,function(n){if(n.nodeType==Y&&n.getAttribute("id")==e)return t=n,!0}),t},createElement:function(e){var t=new S;t.ownerDocument=this,t.nodeName=e,t.tagName=e,t.childNodes=new a;var n=t.attributes=new u;return n._ownerElement=t,t},createDocumentFragment:function(){var e=new O;return e.ownerDocument=this,e.childNodes=new a,e},createTextNode:function(e){var t=new b;return t.ownerDocument=this,t.appendData(e),t},createComment:function(e){var t=new R;return t.ownerDocument=this,t.appendData(e),t},createCDATASection:function(e){var t=new M;return t.ownerDocument=this,t.appendData(e),t},createProcessingInstruction:function(e,t){var n=new D;return n.ownerDocument=this,n.tagName=n.target=e,n.nodeValue=n.data=t,n},createAttribute:function(e){var t=new N;return t.ownerDocument=this,t.name=e,t.nodeName=e,t.localName=e,t.specified=!0,t},createEntityReference:function(e){var t=new L;return t.ownerDocument=this,t.nodeName=e,t},createElementNS:function(e,t){var n=new S,r=t.split(":"),i=n.attributes=new u;return n.childNodes=new a,n.ownerDocument=this,n.nodeName=t,n.tagName=t,n.namespaceURI=e,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,i._ownerElement=n,n},createAttributeNS:function(e,t){var n=new N,r=t.split(":");return n.ownerDocument=this,n.nodeName=t,n.name=t,n.namespaceURI=e,n.specified=!0,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,n}},r(y,h),S.prototype={nodeType:Y,hasAttribute:function(e){return null!=this.getAttributeNode(e)},getAttribute:function(e){var t=this.getAttributeNode(e);return t&&t.value||""},getAttributeNode:function(e){return this.attributes.getNamedItem(e)},setAttribute:function(e,t){var n=this.ownerDocument.createAttribute(e);n.value=n.nodeValue=""+t,this.setAttributeNode(n)},removeAttribute:function(e){var t=this.getAttributeNode(e);t&&this.removeAttributeNode(t)},appendChild:function(e){return e.nodeType===te?this.insertBefore(e,null):T(this,e)},setAttributeNode:function(e){return this.attributes.setNamedItem(e)},setAttributeNodeNS:function(e){return this.attributes.setNamedItemNS(e)},removeAttributeNode:function(e){return this.attributes.removeNamedItem(e.nodeName)},removeAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);n&&this.removeAttributeNode(n)},hasAttributeNS:function(e,t){return null!=this.getAttributeNodeNS(e,t)},getAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);return n&&n.value||""},setAttributeNS:function(e,t,n){var r=this.ownerDocument.createAttributeNS(e,t);r.value=r.nodeValue=""+n,this.setAttributeNode(r)},getAttributeNodeNS:function(e,t){return this.attributes.getNamedItemNS(e,t)},getElementsByTagName:function(e){return new o(this,function(t){var n=[];return m(t,function(r){r===t||r.nodeType!=Y||"*"!==e&&r.tagName!=e||n.push(r)}),n})},getElementsByTagNameNS:function(e,t){return new o(this,function(n){var r=[];return m(n,function(i){i===n||i.nodeType!==Y||"*"!==e&&i.namespaceURI!==e||"*"!==t&&i.localName!=t||r.push(i)}),r})}},y.prototype.getElementsByTagName=S.prototype.getElementsByTagName,y.prototype.getElementsByTagNameNS=S.prototype.getElementsByTagNameNS,r(S,h),N.prototype.nodeType=q,r(N,h),I.prototype={data:"",substringData:function(e,t){return this.data.substring(e,e+t)},appendData:function(e){e=this.data+e,this.nodeValue=this.data=e,this.length=e.length},insertData:function(e,t){this.replaceData(e,0,t)},appendChild:function(e){throw new Error(ie[ae])},deleteData:function(e,t){this.replaceData(e,t,"")},replaceData:function(e,t,n){var r=this.data.substring(0,e),i=this.data.substring(e+t);n=r+n+i,this.nodeValue=this.data=n,this.length=n.length}},r(I,h),b.prototype={nodeName:"#text",nodeType:G,splitText:function(e){var t=this.data,n=t.substring(e);t=t.substring(0,e),this.data=this.nodeValue=t,this.length=t.length;var r=this.ownerDocument.createTextNode(n);return this.parentNode&&this.parentNode.insertBefore(r,this.nextSibling),r}},r(b,I),R.prototype={nodeName:"#comment",nodeType:Q},r(R,I),M.prototype={nodeName:"#cdata-section",nodeType:X},r(M,I),C.prototype.nodeType=ee,r(C,h),w.prototype.nodeType=ne,r(w,h),P.prototype.nodeType=$,r(P,h),L.prototype.nodeType=z,r(L,h),O.prototype.nodeName="#document-fragment",O.prototype.nodeType=te,r(O,h),D.prototype.nodeType=J,r(D,h),U.prototype.serializeToString=function(e,t,n){return x.call(e,t,n)},h.prototype.toString=x;try{Object.defineProperty&&(Object.defineProperty(o.prototype,"length",{get:function(){return s(this),this.$$length}}),Object.defineProperty(h.prototype,"textContent",{get:function(){return j(this)},set:function(e){switch(this.nodeType){case Y:case te:for(;this.firstChild;)this.removeChild(this.firstChild);(e||String(e))&&this.appendChild(this.ownerDocument.createTextNode(e));break;default:this.data=e,this.value=e,this.nodeValue=e}}}),K=function(e,t,n){e["$$"+t]=n})}catch(e){}t.DOMImplementation=f,t.XMLSerializer=U},function(e,t,n){var r,i,a;!function(n,o){i=[e],r=o,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a))}(this,function(e){"use strict";function t(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function n(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function r(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}function i(e,t,n){var r=e.split(/\n|\r\n?|\f/),i=r[t-1],a=new Array(n).join(" ")+"^";return i+"\n"+a}function a(e){return e>="1"&&e<="9"}function o(e){return e>="0"&&e<="9"}function s(e){return o(e)||e>="a"&&e<="f"||e>="A"&&e<="F"}function u(e){return"e"===e||"E"===e}function l(e,t,n,r){var i=e.charAt(t);if("\r"===i)t++,n++,r=1,"\n"===e.charAt(t)&&t++;else if("\n"===i)t++,n++,r=1;else{if("\t"!==i&&" "!==i)return null;t++,r++}return{index:t,line:n,column:r}}function p(e,t,n,r){var i=e.charAt(t);return i in R?{type:R[i],line:n,column:r+1,index:t+1,value:null}:null}function c(e,t,n,r){for(var i in M)if(M.hasOwnProperty(i)&&e.substr(t,i.length)===i){var a=M[i],o=a.type,s=a.value;return{type:o,line:n,column:r+i.length,index:t+i.length,value:s}}return null}function f(e,t,n,r){for(var i=t,a="",o=C._START_;t<e.length;){var u=e.charAt(t);switch(o){case C._START_:if('"'!==u)return null;o=C.START_QUOTE_OR_CHAR,t++;break;case C.START_QUOTE_OR_CHAR:if("\\"===u)o=C.ESCAPE,a+=u,t++;else{if('"'===u)return t++,{type:b.STRING,line:n,column:r+t-i,index:t,value:a};a+=u,t++}break;case C.ESCAPE:if(!(u in w))return null;if(a+=u,t++,"u"===u)for(var l=0;l<4;l++){var p=e.charAt(t);if(!p||!s(p))return null;a+=p,t++}o=C.START_QUOTE_OR_CHAR}}}function h(e,t,n,r){var i=t,s=t,l=P._START_;e:for(;t<e.length;){var p=e.charAt(t);switch(l){case P._START_:if("-"===p)l=P.MINUS;else if("0"===p)s=t+1,l=P.ZERO;else{if(!a(p))return null;s=t+1,l=P.DIGIT}break;case P.MINUS:if("0"===p)s=t+1,l=P.ZERO;else{if(!a(p))return null;s=t+1,l=P.DIGIT}break;case P.ZERO:if("."===p)l=P.POINT;else{if(!u(p))break e;l=P.EXP}break;case P.DIGIT:if(o(p))s=t+1;else if("."===p)l=P.POINT;else{if(!u(p))break e;l=P.EXP}break;case P.POINT:if(!o(p))break e;s=t+1,l=P.DIGIT_FRACTION;break;case P.DIGIT_FRACTION:if(o(p))s=t+1;else{if(!u(p))break e;l=P.EXP}break;case P.EXP:if("+"===p||"-"===p)l=P.EXP_DIGIT_OR_SIGN;else{if(!o(p))break e;s=t+1,l=P.EXP_DIGIT_OR_SIGN}break;case P.EXP_DIGIT_OR_SIGN:if(!o(p))break e;s=t+1}t++}return s>0?{type:b.NUMBER,line:n,column:r+s-i,index:s,value:parseFloat(e.substring(i,s))}:null}function d(e,t){for(var n=1,r=1,i=0,a=[];i<e.length;){var o=[e,i,n,r],s=l.apply(void 0,o);if(s)i=s.index,n=s.line,r=s.column;else{var u=p.apply(void 0,o)||c.apply(void 0,o)||f.apply(void 0,o)||h.apply(void 0,o);if(u){var d={type:u.type,value:u.value,loc:_(n,r,i,u.line,u.column,u.index,t.source)};a.push(d),i=u.index,n=u.line,r=u.column}else S(I.cannotTokenizeSymbol(e.charAt(i),n,r),e,n,r)}}return a}function m(e,t,n,r){for(var i=void 0,a={type:"object",children:[]},o=O._START_;n<t.length;){var s=t[n];switch(o){case O._START_:if(s.type!==b.LEFT_BRACE)return null;i=s,o=O.OPEN_OBJECT,n++;break;case O.OPEN_OBJECT:if(s.type===b.RIGHT_BRACE)return r.verbose&&(a.loc=_(i.loc.start.line,i.loc.start.column,i.loc.start.offset,s.loc.end.line,s.loc.end.column,s.loc.end.offset,r.source)),{value:a,index:n+1};var u=y(e,t,n,r);a.children.push(u.value),o=O.PROPERTY,n=u.index;break;case O.PROPERTY:if(s.type===b.RIGHT_BRACE)return r.verbose&&(a.loc=_(i.loc.start.line,i.loc.start.column,i.loc.start.offset,s.loc.end.line,s.loc.end.column,s.loc.end.offset,r.source)),{value:a,index:n+1};s.type===b.COMMA?(o=O.COMMA,n++):S(N.unexpectedToken(e.substring(s.loc.start.offset,s.loc.end.offset),s.loc.start.line,s.loc.start.column),e,s.loc.start.line,s.loc.start.column);break;case O.COMMA:var l=y(e,t,n,r);l?(n=l.index,a.children.push(l.value),o=O.PROPERTY):S(N.unexpectedToken(e.substring(s.loc.start.offset,s.loc.end.offset),s.loc.start.line,s.loc.start.column),e,s.loc.start.line,s.loc.start.column)}}S(N.unexpectedEnd())}function y(e,t,n,r){for(var i=void 0,a={type:"property",key:null,value:null},o=O._START_;n<t.length;){var s=t[n];switch(o){case D._START_:if(s.type!==b.STRING)return null;var u={type:"identifier",value:s.value};r.verbose&&(u.loc=s.loc),i=s,a.key=u,o=D.KEY,n++;break;case D.KEY:s.type===b.COLON?(o=D.COLON,n++):S(N.unexpectedToken(e.substring(s.loc.start.offset,s.loc.end.offset),s.loc.start.line,s.loc.start.column),e,s.loc.start.line,s.loc.start.column);break;case D.COLON:var l=A(e,t,n,r);return a.value=l.value,r.verbose&&(a.loc=_(i.loc.start.line,i.loc.start.column,i.loc.start.offset,l.value.loc.end.line,l.value.loc.end.column,l.value.loc.end.offset,r.source)),{value:a,index:l.index}}}}function v(e,t,n,r){for(var i=void 0,a={type:"array",children:[]},o=U._START_,s=void 0;n<t.length;)switch(s=t[n],
o){case U._START_:if(s.type!==b.LEFT_BRACKET)return null;i=s,o=U.OPEN_ARRAY,n++;break;case U.OPEN_ARRAY:if(s.type===b.RIGHT_BRACKET)return r.verbose&&(a.loc=_(i.loc.start.line,i.loc.start.column,i.loc.start.offset,s.loc.end.line,s.loc.end.column,s.loc.end.offset,r.source)),{value:a,index:n+1};var u=A(e,t,n,r);n=u.index,a.children.push(u.value),o=U.VALUE;break;case U.VALUE:if(s.type===b.RIGHT_BRACKET)return r.verbose&&(a.loc=_(i.loc.start.line,i.loc.start.column,i.loc.start.offset,s.loc.end.line,s.loc.end.column,s.loc.end.offset,r.source)),n++,{value:a,index:n};s.type===b.COMMA?(o=U.COMMA,n++):S(N.unexpectedToken(e.substring(s.loc.start.offset,s.loc.end.offset),s.loc.start.line,s.loc.start.column),e,s.loc.start.line,s.loc.start.column);break;case U.COMMA:var l=A(e,t,n,r);n=l.index,a.children.push(l.value),o=U.VALUE}S(N.unexpectedEnd())}function g(e,t,n,r){var i=t[n],a=L.indexOf(i.type)!==-1;if(a){var o={type:"literal",value:i.value,rawValue:e.substring(i.loc.start.offset,i.loc.end.offset)};return r.verbose&&(o.loc=i.loc),{value:o,index:n+1}}return null}function A(e,t,n,r){var i=t[n],a=g.apply(void 0,arguments)||m.apply(void 0,arguments)||v.apply(void 0,arguments);return a?a:void S(N.unexpectedToken(e.substring(i.loc.start.offset,i.loc.end.offset),i.loc.start.line,i.loc.start.column),e,i.loc.start.line,i.loc.start.column)}var E=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},_=function(e,t,n,r,i,a,o){return{start:{line:e,column:t,offset:n},end:{line:r,column:i,offset:a},source:o||null}},T=function(e){function a(e,r,o,s){t(this,a);var u=o?e+"\n"+i(r,o,s):e,l=n(this,Object.getPrototypeOf(a).call(this,u));return l.rawMessage=e,l}return r(a,e),a}(SyntaxError),S=function(e,t,n,r){throw new T(e,t,n,r)},N={unexpectedEnd:function(){return"Unexpected end of JSON input"},unexpectedToken:function(e,t,n){return"Unexpected token <"+e+"> at "+t+":"+n}},I={cannotTokenizeSymbol:function(e,t,n){return"Cannot tokenize symbol <"+e+"> at "+t+":"+n}},b={LEFT_BRACE:0,RIGHT_BRACE:1,LEFT_BRACKET:2,RIGHT_BRACKET:3,COLON:4,COMMA:5,STRING:6,NUMBER:7,TRUE:8,FALSE:9,NULL:10},R={"{":b.LEFT_BRACE,"}":b.RIGHT_BRACE,"[":b.LEFT_BRACKET,"]":b.RIGHT_BRACKET,":":b.COLON,",":b.COMMA},M={true:{type:b.TRUE,value:!0},false:{type:b.FALSE,value:!1},null:{type:b.NULL,value:null}},C={_START_:0,START_QUOTE_OR_CHAR:1,ESCAPE:2},w={'"':0,"\\":1,"/":2,b:3,f:4,n:5,r:6,t:7,u:8},P={_START_:0,MINUS:1,ZERO:2,DIGIT:3,POINT:4,DIGIT_FRACTION:5,EXP:6,EXP_DIGIT_OR_SIGN:7},L=[b.STRING,b.NUMBER,b.TRUE,b.FALSE,b.NULL],O={_START_:0,OPEN_OBJECT:1,PROPERTY:2,COMMA:3},D={_START_:0,KEY:1,COLON:2},U={_START_:0,OPEN_ARRAY:1,VALUE:2,COMMA:3},x={verbose:!0,source:null},k=function(e,t){t=E({},x,t);var n=d(e,t);0===n.length&&S(N.unexpectedEnd());var r=A(e,n,0,t);if(r.index===n.length)return r.value;var i=n[r.index];S(N.unexpectedToken(e.substring(i.loc.start.offset,i.loc.end.offset),i.loc.start.line,i.loc.start.column),e,i.loc.start.line,i.loc.start.column)};e.exports=k})},function(e,t,n){"use strict";var r=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var i=n(70),a=n(72),o=n(60),s=function(){function e(e,t,n,r,i){this.entry=e,this.params=t,this.path=n,this.range=r,this.isWarning=i}return e}(),u=function(){function e(){}return e.prototype.validate=function(e){var t=i(e,{verbose:!0}),n=JSON.parse(e),r=[];return this.validateInternal(n,t,r,""),r},e.prototype.validateInternal=function(e,t,n,r){var i=this,a=0==r.length?"":"/"==r.charAt(r.length-1)?r:r+"/";this.doValidate(e,t,a).forEach(function(e){return n.push(e)}),"object"==typeof e&&Object.keys(e).forEach(function(r){var o=e[r];if(null==o||"object"!=typeof o||"properties"!==r&&"patternProperties"!==r)"items"!==r&&"additionalItems"!==r&&"additionalProperties"!=r||i.validateInternal(o,t,n,a+"/"+r);else for(var s=0,u=Object.keys(o);s<u.length;s++){var l=u[s],p=a+"properties/"+l;i.validateInternal(o[l],t,n,p)}})},e.prototype.createError=function(e,t,n,r,i){var a=o.getJSONRange("",n,r),u=new s(e,t,r,a,i);return u},e}(),l=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.doValidate=function(e,t,n){var r=[];if("object"!=typeof e||Array.isArray(e))return r;var i=e.required;if(null!=i&&!Array.isArray(i)){var o=n+"required",s=this.createError(a.REQUIRED_MUST_BE_ARRAY_IN_DRAFT_4,{},t,o,!1);r.push(s)}return r},t}(u);t.Draft4Validator=l;var p=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.doValidate=function(e,t,n){var r=[];if("object"!=typeof e||Array.isArray(e))return r;var i=e.required;if(null!=i&&"boolean"!=typeof i){var o=n+"required",s=this.createError(a.REQUIRED_MUST_BE_BOOLEAN_IN_DRAFT_3,{},t,o,!1);r.push(s)}return r},t}(u);t.Draft3Validator=p},function(e,t){e.exports={12:{code:"12",message:""},SCHEMA_AND_TYPE:{code:"SCHEMA_AND_TYPE",message:"'schema' and 'type' are mutually exclusive"},REQUIRED_OVERRIDE_OPTIONAL:{code:"REQUIRED_OVERRIDE_OPTIONAL",message:"Can not override required property '{{propertyName}}' to be optional"},CYCLIC_DEPENDENCY:{code:"CYCLIC_DEPENDENCY",message:"'{{typeName}}' has cyclic dependency"},REDEFINIG_BUILDTIN:{code:"REDEFINIG_BUILDTIN",message:"Redefining a built in type: {{typeName}}"},RECURRENT_DEFINITION:{code:"RECURRENT_DEFINITION",message:"Recurrent type definition"},INHERITING_UNKNOWN_TYPE:{code:"INHERITING_UNKNOWN_TYPE",message:"Inheriting from unknown type"},INHERITING_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN:{code:"INHERITING_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN",message:"Inheriting the '{{typeName}}' type imported through a library chain. Library chaining is not allowed."},RECURRENT_UNION_OPTION:{code:"RECURRENT_UNION_OPTION",message:"Recurrent type as an option of union type"},UNKNOWN_UNION_OPTION:{code:"UNKNOWN_UNION_OPTION",message:"Unknown type as an option of union type"},UNION_OPTION_TYPE_OPTION_IMPORTED_THROUGH_LIBRARY_CHAIN:{code:"UNION_OPTION_TYPE_OPTION_IMPORTED_THROUGH_LIBRARY_CHAIN",message:"Union type option '{{typeName}}' imported through a library chain. Library chaining is not allowed."},UNION_OPTION_TYPE_DEPENDS_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN:{code:"UNION_OPTION_TYPE_OPTION_DEPENDS_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN",message:"Union type depends on '{{typeName}}' type imported through a library chain. Library chaining is not allowed."},RECURRENT_ARRAY_DEFINITION:{code:"RECURRENT_ARRAY_DEFINITION",message:"Recurrent array type definition"},UNKNOWN_ARRAY_COMPONENT_TYPE:{code:"UNKNOWN_ARRAY_COMPONENT",message:"Referring to unknown type '{{componentTypeName}}' as an array component type"},ARRAY_COMPONENT_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN:{code:"ARRAY_COMPONENT_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN",message:"Array component type '{{componentTypeName}}' imported through a library chain. Library chaining is not allowed."},ARRAY_COMPONENT_TYPE_DEPENDES_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN:{code:"ARRAY_COMPONENT_TYPE_DEPENDES_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN",message:"Array component type '{{componentTypeName}}' inherits the '{{typeName}}' type imported through a library chain. Library chaining is not allowed."},EXTERNALS_MIX:{code:"EXTERNALS_MIX",message:"It is not allowed to mix RAML types with externals"},EXTERNAL_FACET:{code:"EXTERNAL_FACET",message:"External types can not declare facet '{{name}}'"},OVERRIDE_FACET:{code:"OVERRIDE_FACET",message:"Facet '{{name}}' can not be overriden"},OVERRIDE_BUILTIN_FACET:{code:"OVERRIDE_BUILTIN_FACET",message:"Built in facet '{{name}}' can not be overriden"},FACET_START_BRACKET:{code:"FACET_START_BRACKET",message:"Facet '{{name}}' can not start from '('"},FACET_PROHIBITED_FOR_EXTERNALS:{code:"FACET_PROHIBITED_FOR_EXTERNALS",message:"'{{facetName}}' facet is prohibited for external types"},UNKNOWN_FACET:{code:"UNKNOWN_FACET",message:"Specifying unknown facet: '{{facetName}}'"},MISSING_REQUIRED_FACETS:{code:"MISSING_REQUIRED_FACETS",message:"Missing required facets: {{facetsList}}"},OBJECT_EXPECTED:{code:"OBJECT_EXPECTED",message:"object is expected"},NULL_NOT_ALLOWED:{code:"NULL_NOT_ALLOWED",message:"Null or undefined value is not allowed"},DISCRIMINATOR_NEEDED:{code:"DISCRIMINATOR_NEEDED",message:"Can not discriminate types '{{name1}}' and '{{name2}}' without discriminator"},SAME_DISCRIMINATOR_VALUE:{code:"SAME_DISCRIMINATOR_VALUE",message:"Types '{{name1}}' and '{{name2}}' have same discriminator value"},DISPLAY_NAME_STRING:{code:"DISPLAY_NAME_STRING",message:"Property 'displayName' must be a string"},DESCRIPTION_STRING:{code:"DESCRIPTION_STRING",message:"Property 'description' must be a string"},NOTHING:{code:"NOTHING",message:"nothing"},TYPE_EXPECTED:{code:"TYPE_EXPECTED",message:"Expected type '{{expectedType}}' but got '{{actualType}}'"},INTEGER_EXPECTED:{code:"INTEGER_EXPECTED",message:"integer is expected"},NULL_EXPECTED:{code:"NULL_EXPECTED",message:"null is expected"},SCALAR_EXPECTED:{code:"SCALAR_EXPECTED",message:"Scalar is expected here"},INCORRECT_DISCRIMINATOR:{code:"INCORRECT_DISCRIMINATOR",message:"None of the '{{rootType}}' type known subtypes declare '{{value}}' as value of discriminating property '{{propName}}'."},MISSING_DISCRIMINATOR:{code:"MISSING_DISCRIMINATOR",message:"Instance of '{{rootType}}' subtype misses value of the discriminating property '{{propName}}'."},INVALID_DATEONLY:{code:"INVALID_DATEONLY",message:"'date-only' instance should match 'yyyy-mm-dd' pattern"},INVALID_TIMEONLY:{code:"INVALID_TIMEONLY",message:"'time-only' instance should match 'hh:mm:ss[.ff...]' pattern"},INVALID_DATETIMEONLY:{code:"INVALID_DATETIMEONLY",message:"'datetime-only' instance should match 'yyyy-mm-ddThh:mm:ss[.ff...]' pattern"},INVALID_RFC3339:{code:"INVALID_RFC3339",message:"Valid rfc3339 formatted string is expected"},INVALID_RFC2616:{code:"INVALID_RFC2616",message:"Valid rfc2616 formatted string is expected"},INVALID_DATTIME:{code:"INVALID_DATTIME",message:"Valid datetime formatted string is expected"},UNKNOWN_ANNOTATION_TYPE:{code:"UNKNOWN_ANNOTATION_TYPE",message:"Using unknown annotation type: '{{typeName}}'"},LIBRARY_CHAINIG_IN_ANNOTATION_TYPE:{code:"LIBRARY_CHAINIG_IN_ANNOTATION_TYPE",message:"Annotation type '{{typeName}}' imported through a library chain. Library chainig is not allowed."},LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE:{code:"LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE",message:"Annotation type '{{typeName}}' depends on '{{chainedType}}' imported through a library chain. Library chainig is not allowed."},INVALID_ANNOTATION_VALUE:{code:"INVALID_ANNOTATION_VALUE",message:"Invalid annotation value {{msg}}"},CAN_NOT_PARSE_JSON:{code:"CAN_NOT_PARSE_JSON",message:"Can not parse JSON example: {{msg}}"},INVALID_XML:{code:"INVALID_XML",message:"Invalid XML."},STRICT_BOOLEAN:{code:"STRICT_BOOLEAN",message:"'strict' should be boolean"},INVALID_PROPERTY_RANGE:{code:"INVALID_PROPERTY_RANGE",message:"Property '{{propName}}' must be a {{range}}"},INVALID_EXMAPLE:{code:"INVALID_EXMAPLE",message:"Using invalid 'example': {{msg}}"},ADDITIONAL_PROPERTIES_BOOLEAN:{code:"REQUIRED_BOOLEAN",message:"Value of 'additionalProperties' facet should be boolean"},REQUIRED_BOOLEAN:{code:"REQUIRED_BOOLEAN",message:"Value of 'required' facet should be boolean"},UNIQUE_ITEMS_BOOLEAN:{code:"UNIQUE_ITEMS_BOOLEAN",message:"Value of 'uniqueItems' facet should be boolean"},EXMAPLES_MAP:{code:"EXMAPLES_MAP",message:"'examples' value should be a map"},INVALID_DEFAULT_VALUE:{code:"INVALID_DEFAULT_VALUE",message:"Using invalid 'defaultValue': {{msg}}"},DISCRIMINATOR_FOR_UNION:{code:"DISCRIMINATOR_FOR_UNION",message:"You can not specify 'discriminator' for union types"},DISCRIMINATOR_FOR_OBJECT:{code:"DISCRIMINATOR_FOR_OBJECT",message:"You only can use 'discriminator' with object types"},DISCRIMINATOR_FOR_INLINE:{code:"DISCRIMINATOR_FOR_INLINE",message:"You can not specify 'discriminator' for inline type declarations"},UNKNOWN_FOR_DISCRIMINATOR:{code:"UNKNOWN_FOR_DISCRIMINATOR",message:"Using unknown property '{{value}}' as discriminator"},SCALAR_FOR_DISCRIMINATOR:{code:"SCALAR_FOR_DISCRIMINATOR",message:"It is only allowed to use scalar properties as discriminators"},DISCRIMINATOR_VALUE_WITHOUT_DISCRIMINATOR:{code:"DISCRIMINATOR_VALUE_WITHOUT_DISCRIMINATOR",message:"You can not use 'discriminatorValue' without declaring 'discriminator'"},INVALID_DISCRIMINATOR_VALUE:{code:"INVALID_DISCRIMINATOR_VALUE",message:"Using invalid 'disciminatorValue': {{msg}}"},PROPERTIES_MAP:{code:"PROPERTIES_MAP",message:"'properties' should be a map"},FACETS_MAP:{code:"FACETS_MAP",message:"'facets' should be a map"},VALIDATING_AGAINST_UNKNOWN:{code:"VALIDATING_AGAINST_UNKNOWN",message:"Validating instance against unknown type: '{{typeName}}'"},EXTERNAL_IN_PROPERTY_DEFINITION:{code:"EXTERNAL_IN_PROPERTY_DEFINITION",message:"It is not allowed to use external types in property definitions"},EXTERNAL_IN_FACET_DEFINITION:{code:"EXTERNAL_IN_FACET_DEFINITION",message:"It is not allowed to use external types in facet definitions"},UNKNOWN_IN_PROPERTY_DEFINITION:{code:"UNKNOWN_IN_PROPERTY_DEFINITION",message:"Property '{{propName}}' refers to unknown type '{{typeName}}'"},LIBRARY_CHAINIG_IN_PROPERTY_TYPE:{code:"LIBRARY_CHAINIG_IN_PROPERTY_TYPE",message:"Property '{{propName}}' refers to type '{{typeName}}' imported through a library chain. Library chainig is not allowed."},LIBRARY_CHAINIG_IN_PROPERTY_TYPE_SUPERTYPE:{code:"LIBRARY_CHAINIG_IN_PROPERTY_TYPE_SUPERTYPE",message:"Property '{{propName}}' type depends on '{{typeName}}' type imported through a library chain. Library chainig is not allowed."},UNKNOWN_IN_FACET_DEFINITION:{code:"UNKNOWN_IN_FACET_DEFINITION",message:"Facet '{{facetName}}' refers to unknown type '{{typeName}}'"},LIBRARY_CHAINIG_IN_FACET_TYPE:{code:"LIBRARY_CHAINIG_IN_FACET_TYPE",message:"Facet '{{propName}}' refers to type '{{typeName}}' imported through a library chain. Library chainig is not allowed."},LIBRARY_CHAINIG_IN_FACET_TYPE_SUPERTYPE:{code:"LIBRARY_CHAINIG_IN_FACET_TYPE_SUPERTYPE",message:"Facet '{{propName}}' type depends on '{{typeName}}' type imported through a library chain. Library chainig is not allowed."},ERROR_IN_RANGE:{code:"ERROR_IN_RANGE",message:"Property '{{propName}}' range type has error: {{msg}}"},ERROR_IN_FACET_RANGE:{code:"ERROR_IN_FACET_RANGE",message:"Facet '{{facetName}}' range type has error: {{msg}}"},INCORRECT_SCHEMA:{code:"INCORRECT_SCHEMA",message:"Incorrect schema: {{msg}}"},UNABLE_TO_VALIDATE_XML:{code:"UNABLE_TO_VALIDATE_XML",message:"Unable to validate example against schema (xmllint)"},CIRCULAR_REFS_IN_JSON_SCHEMA:{code:"CIRCULAR_REFS_IN_JSON_SCHEMA",message:"JSON schema contains circular references"},CIRCULAR_REFS_IN_JSON_SCHEMA_DETAILS:{code:"CIRCULAR_REFS_IN_JSON_SCHEMA_DETAILS",message:"JSON schema contains circular references: {{cycle}}"},EXAMPLE_SCHEMA_FAILURE:{code:"EXAMPLE_SCHEMA_FAILURE",message:"Example does not conform to schema: {{msg}}"},JOSN_EXAMPLE_VALIDATION_EXCEPTION:{code:"JOSN_EXAMPLE_VALIDATION_EXCEPTION",message:"Validating example against schema caused an exception: {{msg}}"},UNKNOWN_PROPERTY:{code:"UNKNOWN_PROPERTY",message:"Unknown property: '{{propName}}'"},REQUIRED_PROPERTY_MISSING:{code:"REQUIRED_PROPERTY_MISSING",message:"Required property '{{propName}}' is missing"},INVALID_REGEXP:{code:"INVALID_REGEXP",message:"{{msg}}"},FACET_USAGE_RESTRICTION:{code:"FACET_USAGE_RESTRICTION",message:"{{facetName}} facet can only be used with {{typeNames}} types"},FACET_REQUIRE_NUMBER:{code:"FACET_REQUIRE_NUMBER",message:"'{{facetName}}' value should be a number"},FACET_REQUIRE_INTEGER:{code:"FACET_REQUIRE_INTEGER",message:"'{{facetName}}' value should be an integer"},MIN_VALUE:{code:"MIN_VALUE",message:"'{{facetName}}' value should be at least {{minValue}}"},EVEN_RATIO:{code:"EVEN_RATIO",message:"result of division of {{val1}} on {{val2}} should be integer"},MUST_BE_UNIQUE:{code:"MUST_BE_UNIQUE",message:"items should be unique"},ARRAY_AGAINST_UNKNOWN:{code:"ARRAY_AGAINST_UNKNOWN",message:"Array instance is validated against unknown type: '{{typeName}}'"},INVALID_COMPONENT_TYPE:{code:"INVALID_COMPONENT_TYPE",message:"Component type has error: {{msg}}"},EXTERNAL_AS_COMPONENT:{code:"EXTERNAL_AS_COMPONENT",message:"It is not allowed to use external types as array component types in types and type properties declarations"},PATTERN_VIOLATION:{code:"PATTERN_VIOLATION",message:"String should match to '{{value}}'"},ALLOWED_FORMAT_VALUES:{code:"ALLOWED_FORMAT_VALUES",message:"Following format values are allowed: {{allowedValues}}"},ENUM_RESTRICTION:{code:"ENUM_RESTRICTION",message:"value should be one of: {{values}}"},ENUM_OWNER_TYPES:{code:"ENUM_OWNER_TYPES",message:"'enum' facet can only be used with: {{typeNames}}"},ENUM_ARRAY:{code:"ENUM_ARRAY",message:"'enum' facet value must be defined by array"},RESTRICTIONS_CONFLICT:{code:"RESTRICTIONS_CONFLICT",message:null},MINMAX_RESTRICTION_VIOLATION:{code:"MINMAX_RESTRICTION_VIOLATION",message:null},UNION_TYPE_FAILURE:{code:"UNION_TYPE_FAILURE",message:"Union type options do not pass validation"},UNION_TYPE_FAILURE_DETAILS:{code:"UNION_TYPE_FAILURE_DETAILS",message:"Union type option does not pass validation ({{msg}})"},INVALID_JSON_SCHEMA_DETAILS:{code:"INVALID_JSON_SCHEMA_DETAILS",message:"Invalid JSON schema: {{msg}}"},INVALID_JSON_SCHEMA:{code:"INVALID_JSON_SCHEMA",message:"Invalid JSON schema"},JSON_SCHEMA_VALIDATION_EXCEPTION:{code:"JSON_SCHEMA_VALIDATION_EXCEPTION",message:"Schema validation exception: {{msg}}"},REFERENCE_NOT_FOUND:{code:"REFERENCE_NOT_FOUND",message:"Reference not found: {{ref}}"},INVALID_XML_SCHEMA:{code:"INVALID_XML_SCHEMA",message:"Invalid XML schema content"},INVALID_ANNOTATION_LOCATION:{code:"INVALID_ANNOTATION_LOCATION",message:"Annotation '{{aName}}' can not be placed at this location, allowed targets are: {{aValues}}"},CONTENT_DOES_NOT_MATCH_THE_SCHEMA:{code:"CONTENT_DOES_NOT_MATCH_THE_SCHEMA",message:"Content is not valid according to schema: {{msg}}"},EXTERNAL_TYPE_ERROR:{code:"EXTERNAL_TYPE_ERROR",message:"Referenced type '{{typeName}}' does not match '{{objectName}}' root node"},CAN_NOT_PARSE_SCHEMA:{code:"CAN_NOT_PARSE_SCHEMA",message:"Can not parse schema"},FILE_TYPES_SHOULD_BE_AN_ARRAY:{code:"FILE_TYPES_SHOULD_BE_AN_ARRAY",message:"'fileTypes' value should be an array of strings"},FACET_CAN_NOT_BE_FIXED_BY_THE_DECLARING_TYPE:{code:"FACET_CAN_NOT_BE_FIXED_BY_THE_DECLARING_TYPE",message:"A facet  can not be fixed by the declaring type"},ITEMS_SHOULD_BE_REFERENCE_OR_INLINE_TYPE:{code:"ITEMS_SHOULD_BE_REFERENCE_OR_INLINE_TYPE",message:"The 'items' property value should be either a reference to an existing type or an inline type declaration"},ITEMS_DEFINED_FOR_NON_ARRAY:{code:"ITEMS_DEFINED_FOR_NON_ARRAY",message:"The 'items' property can only be defined for array types"},VALUE_SHOULD_BE_POSITIVE:{code:"VALUE_SHOULD_BE_POSITIVE",message:"Value of the '{{facetName}}' facet should be positive"},PLUGIN_REPORTS_AN_ERROR:{code:"PLUGIN_REPORTS_AN_ERROR",message:"The {{pluginId}} plugin reports an error"},MESSAGE_PARAMETER_NO_VALUE:{code:"MESSAGE_PARAMETER_NO_VALUE",message:"Message parameter '{{paramName}}' has no value specified."},VALIDATE_ONLY_ON_RUNTIME_TYPES_INSTANCES:{code:"VALIDATE_ONLY_ON_RUNTIME_TYPES_INSTANCES",message:"Validate can be used only on runtime types instances"},SHOULD_BE_ALREADY_OWNED:{code:"SHOULD_BE_ALREADY_OWNED",message:"Should be already owned by this"},ALREADY_INCLUDED:{code:"ALREADY_INCLUDED",message:"Already included"},SHOULD_BE_NEVER_CALLED:{code:"SHOULD_BE_NEVER_CALLED",message:"Should be never called"},VALUE_SHOULD_NOT_BE_MORE:{code:"VALUE_SHOULD_NOT_BE_MORE",message:"value should not be more than"},VALUE_SHOULD_NOT_BE_LESS:{code:"VALUE_SHOULD_NOT_BE_LESS",message:"value should not be less than"},ARRAY_ITEMS_COUNT_SHOULD_NOT_BE_MORE:{code:"ARRAY_ITEMS_COUNT_SHOULD_NOT_BE_MORE",message:"array items count should not be more than"},ARRAY_ITEMS_COUNT_SHOULD_NOT_BE_LESS:{code:"ARRAY_ITEMS_COUNT_SHOULD_NOT_BE_LESS",message:"array items count should not be less than"},STRING_SHOULD_NOT_BE_MORE:{code:"STRING_SHOULD_NOT_BE_MORE",message:"string length should not be more than"},STRING_SHOULD_NOT_BE_LESS:{code:"STRING_SHOULD_NOT_BE_LESS",message:"string length should not be less than"},OBJECT_PROPERTIES_SHOULD_NOT_BE_MORE:{code:"OBJECT_PROPERTIES_SHOULD_NOT_BE_MORE",message:"object properties count should not be more than"},OBJECT_PROPERTIES_SHOULD_NOT_BE_LESS:{code:"OBJECT_PROPERTIES_SHOULD_NOT_BE_LESS",message:"object properties count should not be less than"},ITEMS_SHOULD_BE_OF_TYPE:{code:"ITEMS_SHOULD_BE_OF_TYPE",message:"items should be of type '{{type}}'"},RESTRICTIONS_CANNT_BE_COMPOSED:{code:"RESTRICTIONS_CANNT_BE_COMPOSED",message:"{{name}} can not be composed at one type"},SHOULD_PASS_REXEXP:{code:"SHOULD_PASS_REXEXP",message:"should pass reg exp:{{rexexp}}"},NO_COMMON_FILE_TYPES:{code:"NO_COMMON_FILE_TYPES",message:"no common file types"},INVALID_FILETYPES_FACET_VALUE:{code:"INVALID_FILETYPES_FACET_VALUE",message:"invalid 'fileTypes' facet value"},SUPPORTED_FILE_TYPES:{code:"SUPPORTED_FILE_TYPES",message:"supported file types: {{types}}"},SHOULD_BE_SCALAR:{code:"SHOULD_BE_SCALAR",message:"should be scalar"},UNEXPECTED_XML_ELEMENT:{code:"UNEXPECTED_XML_ELEMENT",message:"Unexpected element '{{name}}'"},UNEXPECTED_XML_ATTRIBUTE:{code:"UNEXPECTED_XML_ATTRIBUTE",message:"Unexpected attribute '{{name}}'"},TEXT_CONTENT_NOT_ALLOWED_FOR_THE_XML_ELEMENT:{code:"TEXT_CONTENT_NOT_ALLOWED_FOR_THE_XML_ELEMENT",message:"The node is not allowed to have text content"},REQUIRED_MUST_BE_ARRAY_IN_DRAFT_4:{code:"REQUIRED_MUST_BE_ARRAY_IN_DRAFT_4",message:"Draft 4 schema must have array as 'required' property value"},REQUIRED_MUST_BE_BOOLEAN_IN_DRAFT_3:{code:"REQUIRED_MUST_BE_BOOLEAN_IN_DRAFT_3",message:"Draft 3 schema must have boolean as 'required' property value"}}},function(e,t,n){(function(){function t(e,t){Array.isArray(e)||(e=[e]);for(var n=!!t,r=[],i=0;i<e.length;i++){var a=e[i];"object"==typeof a?(r.push(a),n=!0):r.push({type:a})}return n&&r}function n(e){if(e.type)if("string"!=typeof e.type){var r=t(e.type);r&&(e.anyOf=r,delete e.type)}else"any"==e.type&&delete e.type;if(e.extends){var i=e.extends;Array.isArray(i)||(i=[i]),e.allOf=i,delete e.extends}if(e.disallow&&("string"==typeof e.disallow?e.not={type:e.disallow}:e.not={anyOf:t(e.disallow,!0)},delete e.disallow),e.properties){var a=Array.isArray(e.required)?e.required:[];for(var o in e.properties){var s=e.properties[o];s&&"boolean"==typeof s.required&&(s.required&&a.push(o),delete s.required)}a.length&&(e.required=a)}if(e.dependencies)for(var o in e.dependencies)"string"==typeof e.dependencies[o]&&(e.dependencies[o]=[e.dependencies[o]]);"boolean"==typeof e.required&&delete e.required,"undefined"!=typeof e.divisibleBy&&(e.multipleOf=e.divisibleBy,delete e.divisibleBy);for(var o in e)if("properties"===o||"patternProperties"===o||"dependencies"===o)for(var u in e[o])e[o][u]=n(e[o][u]);else if("enum"!==o)if(Array.isArray(e[o]))for(var l=0;l<e[o].length;l++)e[o][l]=n(e[o][l]);else"object"==typeof e[o]&&(e[o]=n(e[o]));return e}var r={v4:n};return e.exports=r,r})()},function(e,t){(function(e){"use strict";function n(){var t=e.ramlValidation;if(t){var n=t.typeValidators;if(Array.isArray(n))return n}return[]}function r(){var t=e.ramlValidation;if(t){var n=t.typesystemAnnotationValidators;if(Array.isArray(n))return n}return[]}Object.defineProperty(t,"__esModule",{value:!0}),t.REPEAT="repeat",t.PARSE_ERROR="parseError",t.TOP_LEVEL_EXTRA="topLevel",t.DEFINED_IN_TYPES_EXTRA="definedInTypes",t.USER_DEFINED_EXTRA="USER_DEFINED",t.SOURCE_EXTRA="SOURCE",t.SCHEMA_AND_TYPE_EXTRA="SCHEMA",t.GLOBAL_EXTRA="GLOBAL",t.HAS_FACETS="HAS_FACETS",t.HAS_ITEMS="HAS_ITEMS";var i;!function(e){e[e.Description=0]="Description",e[e.NotScalar=1]="NotScalar",e[e.DisplayName=2]="DisplayName",e[e.Usage=3]="Usage",e[e.Annotation=4]="Annotation",e[e.FacetDeclaration=5]="FacetDeclaration",e[e.CustomFacet=6]="CustomFacet",e[e.Example=7]="Example",e[e.Required=8]="Required",e[e.HasPropertiesFacet=9]="HasPropertiesFacet",e[e.AllowedTargets=10]="AllowedTargets",e[e.Examples=11]="Examples",e[e.XMLInfo=12]="XMLInfo",e[e.Default=13]="Default",e[e.Constraint=14]="Constraint",e[e.Modifier=15]="Modifier",e[e.Discriminator=16]="Discriminator",e[e.DiscriminatorValue=17]="DiscriminatorValue",e[e.SchemaPath=18]="SchemaPath",e[e.SourceMap=19]="SourceMap",e[e.ParserMetadata=20]="ParserMetadata",e[e.ImportedByChain=21]="ImportedByChain",e[e.AcceptAllScalarsAsStrings=22]="AcceptAllScalarsAsStrings",e[e.SkipValidation=23]="SkipValidation",e[e.TypeAttributeValue=24]="TypeAttributeValue"}(i=t.MetaInformationKind||(t.MetaInformationKind={})),t.getTypeValidationPlugins=n,t.getAnnotationValidationPlugins=r}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(){return b.length>0?b[b.length-1]:null}function i(e){for(var t;e;)t=e.owner(),e=t instanceof c.InheritedType?t.contextMeta():null;b.push(t)}function a(e){for(void 0===e&&(e=0);b.length>e;)b.pop()}function o(){return b.length}function s(e){e=e.map(function(e){return e.preoptimize()});var t=[];e.forEach(function(e){if(e instanceof y.AndRestriction){var n=e;n.options().forEach(function(e){t.push(e)})}else t.push(e)});for(var n=!0;n;){n=!1;for(var r=0;r<t.length;r++){for(var i=0;i<t.length;i++){var a=t[r],o=t[i];if(a!==o){var s=a.tryCompose(o);if(s){var u=t.filter(function(e){return e!==a&&e!==o});u.push(s),n=!0,t=u;break}}}if(n)break}}return t}function u(e){if(!c.isUnknown(e))return null;if(null!=e.name())return e;for(var t=0,n=e.superTypes();t<n.length;t++){var r=n[t],i=u(r);if(null!=i)return i}return e}function l(e,t,n,r,i){if(void 0===i&&(i=!1),e.isExternal()){var a=void 0;return a=i?c.error(h.EXTERNAL_IN_FACET_DEFINITION,r):c.error(h.EXTERNAL_IN_PROPERTY_DEFINITION,r),c.setValidationPath(a,{name:t}),a}if(c.isUnknown(e)){var o=u(e),a=void 0,s=e.metaOfType(g.ImportedByChain),l=[];if(i?s.length>0?s.forEach(function(e){var n=h.LIBRARY_CHAINIG_IN_FACET_TYPE,i=o.name();e.value()!=i&&(n=h.LIBRARY_CHAINIG_IN_FACET_TYPE_SUPERTYPE,i=e.value());var a=c.error(n,r,{propName:t,typeName:i});l.push(a)}):(f=c.error(h.UNKNOWN_IN_FACET_DEFINITION,r,{facetName:t,msg:o.name()}),l.push(f)):s.length>0?s.forEach(function(e){var n=h.LIBRARY_CHAINIG_IN_PROPERTY_TYPE,i=o.name();e.value()!=i&&(n=h.LIBRARY_CHAINIG_IN_PROPERTY_TYPE_SUPERTYPE,i=e.value());var a=c.error(n,r,{propName:t,typeName:i});l.push(a)}):(f=c.error(h.UNKNOWN_IN_PROPERTY_DEFINITION,r,{propName:t,typeName:o.name()}),l.push(f)),l.forEach(function(e){return c.setValidationPath(e,{name:t,child:{name:"type"}})}),1==l.length)return l[0];var p=c.ok();return l.forEach(function(e){return p.addSubStatus(e)}),p}if(e.isSubTypeOf(c.RECURRENT))return f=c.error(h.CYCLIC_DEPENDENCY,r,{typeName:e.name()});if(e.isAnonymous()){var f=e.validateType(n);if(!f.isOk()){var d;return d=i?c.error(h.ERROR_IN_FACET_RANGE,r,{facetName:t,msg:f.getMessage()}):c.error(h.ERROR_IN_RANGE,r,{propName:t,msg:f.getMessage()}),f.getErrors().forEach(function(e){d.addSubStatus(e)}),c.setValidationPath(d,{name:t}),d}return f}if(e.isUnion()){var y=m.find(e.typeFamily(),function(e){return c.isUnknown(e)});if(y){var a=void 0;return a=i?c.error(h.UNKNOWN_IN_FACET_DEFINITION,r,{facetName:t,msg:y.name()}):c.error(h.UNKNOWN_IN_PROPERTY_DEFINITION,r,{propName:t,typeName:y.name()}),c.setValidationPath(a,{name:t}),a}}return c.ok()}var p=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var c=n(58),f=n(76),h=c.messageRegistry,d=n(60),m=n(59),y=n(58),v=n(58),g=n(77),A=n(77),E=n(77),_=function(e){function t(t,n){void 0===n&&(n=!1);var r=e.call(this)||this;return r._type=t,r.optional=n,r}return p(t,e),t.prototype.matches=function(e){return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_MatchesProperty)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_MatchesProperty)},t.prototype.check=function(e,t){throw new Error(h.SHOULD_BE_NEVER_CALLED.message)},t.prototype.patchPath=function(e,t){if(e){for(var n=e,r=null,i=null;n;)if(r){var a={name:n.name};i.child=a,n=n.child,i=a}else r={name:n.name},i=r;return r.child={name:t},r}return{name:t}},t.prototype.validateProp=function(e,t,n,r){var i=e[t],a=n.validate(i,!1,!1);if(!a.isOk()){if(n.isUnknown()||n.isRecurrent()){var o=c.error(h.VALIDATING_AGAINST_UNKNOWN,this,{typeName:n.name()});return c.setValidationPath(o,this.patchPath(r,t)),o}var o=new v.Status(v.Status.OK,"","",this);return a.getErrors().forEach(function(e){return o.addSubStatus(e)}),c.setValidationPath(o,this.patchPath(r,t)),o}return c.ok()},t.prototype.validateSelfIndividual=function(e,t){return l(this._type,this.propId(),t,this,!1)},t.prototype.range=function(){return this._type},t.prototype.isOptional=function(){return this.optional},t.CLASS_IDENTIFIER_MatchesProperty="restrictions.MatchesProperty",t}(c.Constraint);t.MatchesProperty=_;var T=function(e){function t(t,n){var r=e.call(this)||this;return r._value=t,r.provider=n,r}return p(t,e),t.prototype.value=function(){return this._value},t.prototype.check=function(e){var t=null,n=this.value();if("{"==n.charAt(0))try{t=d.getJSONSchema(n,this.provider)}catch(e){if(c.ValidationError.isInstance(e)){var r=e,i=r.isWarning?c.Status.WARNING:c.Status.ERROR,a=c.error(r.messageEntry,this,r.parameters,i,r.parameters);return a}return c.error(h.INCORRECT_SCHEMA,this,{msg:e.message})}if("<"==n.charAt(0))try{t=d.getXMLSchema(n,this.provider)}catch(e){return c.ok()}if(t)try{"string"==typeof e?t.validate(e):t.validateObject(e)}catch(e){if(c.ValidationError.isInstance(e)){var r=e,o=c.Status.ERROR;r.isWarning&&(o=c.Status.WARNING);var s=c.error(r.messageEntry,this,r.parameters,o);if(s.setInternalRange(r.internalRange),s.setInternalPath(c.toValidationPath(r.internalPath)),s.setFilePath(r.filePath),!r.additionalErrors||0==r.additionalErrors.length)return s;var u=c.ok();u.addSubStatus(s);for(var l=0,p=r.additionalErrors;l<p.length;l++){var f=p[l],m=c.error(f.messageEntry,this,f.parameters,o);m.setInternalRange(f.internalRange),m.setInternalPath(c.toValidationPath(f.internalPath)),m.setFilePath(f.filePath),u.addSubStatus(m)}return u}return"!_PERF_!"==e.message?c.error(h.UNABLE_TO_VALIDATE_XML,this,{},c.Status.WARNING):"Maximum call stack size exceeded"==e.message?c.error(h.CIRCULAR_REFS_IN_JSON_SCHEMA,this):c.error(h.EXAMPLE_SCHEMA_FAILURE,this,{msg:e.message})}return c.ok()},t.prototype.facetName=function(){return"schema"},t.prototype.requiredType=function(){return c.EXTERNAL},t}(c.Constraint);t.MatchToSchema=T;var S=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_KnownPropertyRestriction)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_KnownPropertyRestriction)},t.prototype.facetName=function(){return"closed"},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.value=function(){return this._value},t.prototype.patchOwner=function(e){this._owner=e},
t.prototype.check=function(e){var t=this;if(this._value===!1&&e&&"object"==typeof e&&!Array.isArray(e)){var n={};Object.getOwnPropertyNames(e).forEach(function(e){return n[e]=!0});var r=this.owner().knownProperties();Object.getOwnPropertyNames(e).forEach(function(e){r.forEach(function(t){t.matches(e)&&delete n[e]})});var i=Object.keys(n);if((this.owner().hasPropertiesFacet()||r.length>0)&&i.length>0){var a=new c.Status(c.Status.OK,"","",this);return i.forEach(function(e){var n=c.error(h.UNKNOWN_PROPERTY,t,{propName:e});c.setValidationPath(n,{name:e}),a.addSubStatus(n)}),a}}return c.ok()},t.prototype.composeWith=function(e){if(!this._value)return null;if(e instanceof t){var n=e;if(m.isEqual(this.owner().propertySet(),n.owner().propertySet()))return n}if(e instanceof N){var r=e,i=r.value(),a=this.owner().propertySet();if(a.indexOf(i)==-1)return this.nothing(r)}},t.CLASS_IDENTIFIER_KnownPropertyRestriction="typesystem.KnownPropertyRestriction",t}(c.Constraint);t.KnownPropertyRestriction=S;var N=function(e){function t(t){var n=e.call(this)||this;return n.name=t,n}return p(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_HasProperty)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_HasProperty)},t.prototype.check=function(e){return e&&"object"==typeof e&&!Array.isArray(e)?e.hasOwnProperty(this.name)?c.ok():c.error(h.REQUIRED_PROPERTY_MISSING,this,{propName:this.name}):c.ok()},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.facetName=function(){return"hasProperty"},t.prototype.value=function(){return this.name},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.name===this.name)return this}return null},t.CLASS_IDENTIFIER_HasProperty="restrictions.HasProperty",t}(c.Constraint);t.HasProperty=N;var I=function(e){function t(t,n,r){void 0===r&&(r=!1);var i=e.call(this,n,r)||this;return i.name=t,i.type=n,i}return p(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_PropertyIs)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_PropertyIs)},t.prototype.matches=function(e){return e===this.name},t.prototype.path=function(){return this.name},t.prototype.check=function(e,t){if(e&&"object"==typeof e&&e.hasOwnProperty(this.name)){var n=this.validateProp(e,this.name,this.type,t);return n}return c.ok()},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.propId=function(){return this.name},t.prototype.propertyName=function(){return this.name},t.prototype.facetName=function(){return"propertyIs"},t.prototype.value=function(){return this.type},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.name===this.name){if(this.type.typeFamily().indexOf(n.type)!=-1)return n;if(n.type.typeFamily().indexOf(this.type)!=-1)return this;i(e);var r=this.intersect(this.type,n.type);try{var a=r.checkConfluent();if(!a.isOk()){var o=a;return o.toRestriction()}return new t(this.name,r)}finally{this.release(r)}}}return null},t.CLASS_IDENTIFIER_PropertyIs="restrictions.PropertyIs",t}(_);t.PropertyIs=I;var b=[];t.anotherRestrictionComponent=r,t.releaseAnotherRestrictionComponent=a,t.anotherRestrictionComponentsCount=o;var R=function(e){function t(t,n,r){void 0===r&&(r=!1);var i=e.call(this,n,r)||this;return i.regexp=t,i.type=n,i}return p(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_MapPropertyIs)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_MapPropertyIs)},t.prototype.path=function(){return"/"+this.regexp+"/"},t.prototype.matches=function(e){return!!e.match(this.regexp)},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.propId=function(){return"["+this.regexp+"]"},t.prototype.facetName=function(){return"mapPropertyIs"},t.prototype.value=function(){return this.type},t.prototype.regexpValue=function(){return this.regexp},t.prototype.validateSelfIndividual=function(t,n){var r=this.checkValue();return r?c.error(h.INVALID_REGEXP,this,{msg:r}):e.prototype.validateSelfIndividual.call(this,t,n)},t.prototype.checkValue=function(){try{new RegExp(this.regexp)}catch(e){return e.message}return null},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.regexp===this.regexp){if(this.type.typeFamily().indexOf(n.type)!=-1)return n;if(n.type.typeFamily().indexOf(this.type)!=-1)return this;var r=this.intersect(this.type,n.type);try{var i=r.checkConfluent();if(!i.isOk()){var a=i;return a.toRestriction()}return new t(this.regexp,r)}finally{this.release(r)}}}return null},t.prototype.check=function(e,t){if(e&&"object"==typeof e){var n={};null!=this._owner&&this._owner.meta().filter(function(e){return e instanceof I}).forEach(function(e){n[e.propertyName()]=!0});for(var r=new c.Status(c.Status.OK,"","",this),i=0,a=Object.getOwnPropertyNames(e);i<a.length;i++){var o=a[i];if(!n[o]&&o.match(this.regexp)){var s=this.validateProp(e,o,this.type,t);s.isOk()||r.addSubStatus(s)}}return r}return c.ok()},t.CLASS_IDENTIFIER_MapPropertyIs="restrictions.MapPropertyIs",t}(_);t.MapPropertyIs=R;var M=function(e){function t(t,n){void 0===n&&(n=!1);var r=e.call(this,t,n)||this;return r.type=t,r}return p(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_AdditionalPropertyIs)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_AdditionalPropertyIs)},t.prototype.path=function(){return"/.*/"},t.prototype.matches=function(e){return!0},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.propId=function(){return"[]"},t.prototype.facetName=function(){return"additionalProperties"},t.prototype.value=function(){return this.type},t.prototype.match=function(e){for(var t=this.owner().metaOfType(I),n=this.owner().metaOfType(R),r=0;r<t.length;r++)if(t[r].matches(e))return!0;for(var r=0;r<n.length;r++)if(n[r].matches(e))return!0;return!1},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(this.type.typeFamily().indexOf(n.type)!=-1)return n;if(n.type.typeFamily().indexOf(this.type)!=-1)return this;var r=this.intersect(this.type,n.type);try{var i=r.checkConfluent();if(!i.isOk()){var a=i;return a.toRestriction()}return new t(r)}finally{this.release(r)}}return null},t.prototype.check=function(e,t){var n=this,r=this.type,i=new c.Status(c.Status.OK,"","",this);return e&&"object"==typeof e&&Object.getOwnPropertyNames(e).forEach(function(a){if(!n.match(a)){var o=n.validateProp(e,a,r,t);o.isOk()||i.addSubStatus(o)}}),i},t.CLASS_IDENTIFIER_AdditionalPropertyIs="restrictions.AdditionalPropertyIs",t}(_);t.AdditionalPropertyIs=M;var C=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return p(t,e),t.prototype.requiredTypes=function(){return[]},t.prototype.checkOwner=function(e){if(this.owner().oneMeta(A.SkipValidation))return!0;var t=!1;if(e.isUnion())for(var n=e.typeFamily(),r=0,i=n;r<i.length;r++){var a=i[r];if(this.owner().isSubTypeOf(a)){t=!0;break}}else t=this.owner().isSubTypeOf(e);return t},t.prototype.validateSelfIndividual=function(e,t){var n=this,r=!1;if(this.checkOwner(this.requiredType()))if(this.requiredTypes()&&this.requiredTypes().length>0){var i=(this.owner(),m.find(this.requiredTypes(),function(e){return n.checkOwner(e)}));i&&(r=!0)}else r=!0;var a;if(r)a=this.checkValue();else{var o=this.requiredType().name();this.requiredTypes()&&this.requiredTypes().length>0&&(o="["+this.requiredTypes().map(function(e){return e.name()}).join()+"]");var a=c.error(h.FACET_USAGE_RESTRICTION,this,{facetName:this.facetName(),typeNames:o})}if(a&&!a.isOk())return c.setValidationPath(a,{name:this.facetName()}),a;var s=[e,a].filter(function(e){return e&&!e.isOk()});if(0==s.length)return c.ok();if(1==s.length)return s[0];for(var u=c.ok(),l=0,p=s;l<p.length;l++){var f=p[l];u.addSubStatus(f)}return u},t}(c.Constraint);t.FacetRestriction=C;var w=function(e){function t(t,n,r,i,a,o){var s=e.call(this)||this;return s._facetName=t,s._value=n,s._max=r,s._opposite=i,s._requiredType=a,s._isInt=o,s}return p(t,e),t.prototype.facetName=function(){return this._facetName},t.prototype.isIntConstraint=function(){return this._isInt},t.prototype.isMax=function(){return this._max},t.prototype.value=function(){return this._value},t.prototype.check=function(e){var t=this.extractValue(e);if("number"==typeof t)if(this.isMax()){if(this.value()<t)return this.createError()}else if(this.value()>t)return this.createError();return c.ok()},t.prototype.createError=function(){return new v.Status(v.Status.ERROR,h.MINMAX_RESTRICTION_VIOLATION.code,this.toString(),this)},t.prototype.minValue=function(){return this._isInt?0:Number.NEGATIVE_INFINITY},t.prototype.requiredType=function(){return this._requiredType},t.prototype.checkValue=function(){return"number"!=typeof this._value?c.error(h.FACET_REQUIRE_NUMBER,this,{facetName:this.facetName()},c.Status.ERROR,!0):this.isIntConstraint()&&!new f.BigNumber(this.value().toString()).isInteger()?c.error(h.FACET_REQUIRE_INTEGER,this,{facetName:this.facetName()},c.Status.ERROR,!0):this.value()<this.minValue()?c.error(h.MIN_VALUE,this,{facetName:this.facetName(),minValue:this.minValue()},c.Status.ERROR,!0):void 0},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.facetName()==this.facetName()&&n.isMax()==this.isMax())return this.isMax()?this.value()>n.value()?n:this:this.value()<n.value()?n:this;if(n.facetName()===this._opposite)if(this.isMax()){if(n.value()>this.value())return this.nothing(e)}else if(n.value()<this.value())return this.nothing(e)}return null},t.prototype.facetPath=function(){var e=[this.facetName()],t=this._owner;if(null!=t&&t instanceof c.InheritedType){var n=t;e=c.typePath(n).concat(e)}return e.join(".")},t.prototype.toString=function(){return"'"+this.facetPath()+"="+this.value()+"' i.e. "+this.textMessagePart()+" "+this.value()},t.prototype.conflictMessage=function(e,t){var n=this.isMax()?["less","higher"]:["higher","less"];return"['"+this.facetPath()+"="+this.value()+"' is "+n[0]+" than '"+e+"="+t+"'. The "+this._opposite+" cannot be "+n[1]+" than the "+this.facetName()+".]"},t}(C);t.MinMaxRestriction=w;var P=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.value=function(){return this._value},t.prototype.check=function(e){if("number"==typeof e){var t=new f.BigNumber(e.toString()),n=new f.BigNumber(this.value().toString()),r=t.dividedBy(n);if(!r.isInteger())return c.error(h.EVEN_RATIO,this,{val1:e,val2:this.value()})}return c.ok()},t.prototype.composeWith=function(e){return null},t.prototype.facetName=function(){return"multipleOf"},t.prototype.checkValue=function(){return"number"!=typeof this._value?c.error(h.FACET_REQUIRE_NUMBER,this,{facetName:this.facetName()},c.Status.ERROR,!0):this._value<=0?c.error(h.VALUE_SHOULD_BE_POSITIVE,this,{facetName:this.facetName()},c.Status.ERROR,!0):null},t.prototype.requiredType=function(){return c.NUMBER},t}(C);t.MultipleOf=P;var L=function(e){function t(t){return e.call(this,"maximum",t,!0,"minimum",c.NUMBER,!1)||this}return p(t,e),t.prototype.extractValue=function(e){return e},t.prototype.textMessagePart=function(){return h.VALUE_SHOULD_NOT_BE_MORE.message},t}(w);t.Maximum=L;var O=function(e){function t(t){return e.call(this,"minimum",t,!1,"maximum",c.NUMBER,!1)||this}return p(t,e),t.prototype.extractValue=function(e){return e},t.prototype.textMessagePart=function(){return h.VALUE_SHOULD_NOT_BE_LESS.message},t}(w);t.Minimum=O;var D=function(e){function t(t){return e.call(this,"maxItems",t,!0,"minItems",c.ARRAY,!0)||this}return p(t,e),t.prototype.extractValue=function(e){if(Array.isArray(e))return e.length},t.prototype.textMessagePart=function(){return h.ARRAY_ITEMS_COUNT_SHOULD_NOT_BE_MORE.message},t}(w);t.MaxItems=D;var U=function(e){function t(t){return e.call(this,"minItems",t,!1,"maxItems",c.ARRAY,!0)||this}return p(t,e),t.prototype.extractValue=function(e){if(Array.isArray(e))return e.length},t.prototype.textMessagePart=function(){return h.ARRAY_ITEMS_COUNT_SHOULD_NOT_BE_LESS.message},t}(w);t.MinItems=U;var x=function(e){function t(t){return e.call(this,"maxLength",t,!0,"minLength",new c.UnionType("string and file",[c.STRING,c.FILE]),!0)||this}return p(t,e),t.prototype.extractValue=function(e){return"string"==typeof e?e.length:0},t.prototype.textMessagePart=function(){return h.STRING_SHOULD_NOT_BE_MORE.message},t}(w);t.MaxLength=x;var k=function(e){function t(t){return e.call(this,"minLength",t,!1,"maxLength",new c.UnionType("string and file",[c.STRING,c.FILE]),!0)||this}return p(t,e),t.prototype.extractValue=function(e){return"string"==typeof e?e.length:0},t.prototype.textMessagePart=function(){return h.STRING_SHOULD_NOT_BE_LESS.message},t}(w);t.MinLength=k;var F=function(e){function t(t){return e.call(this,"maxProperties",t,!0,"minProperties",c.OBJECT,!0)||this}return p(t,e),t.prototype.extractValue=function(e){return Object.keys(e).length},t.prototype.textMessagePart=function(){return h.OBJECT_PROPERTIES_SHOULD_NOT_BE_MORE.message},t}(w);t.MaxProperties=F;var B=function(e){function t(t){return e.call(this,"minProperties",t,!1,"maxProperties",c.OBJECT,!0)||this}return p(t,e),t.prototype.extractValue=function(e){return Object.keys(e).length},t.prototype.textMessagePart=function(){return h.OBJECT_PROPERTIES_SHOULD_NOT_BE_LESS.message},t}(w);t.MinProperties=B;var V=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.facetName=function(){return"uniqueItems"},t.prototype.requiredType=function(){return c.ARRAY},t.prototype.check=function(e){if(!this._value)return c.ok();if(Array.isArray(e)){var t=e;if(m.unique(t).length!=t.length)return c.error(h.MUST_BE_UNIQUE,this)}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n._value==this._value)return this}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){return"boolean"!=typeof this._value?c.error(h.UNIQUE_ITEMS_BOOLEAN,this):null},t.prototype.toString=function(){return h.MUST_BE_UNIQUE.message},t}(C);t.UniqueItems=V;var K=function(e){function t(t){var n=e.call(this)||this;return n.type=t,n}return p(t,e),t.prototype.facetName=function(){return"items"},t.prototype.requiredType=function(){return c.ARRAY},t.prototype.toString=function(){var e=this.type&&this.type.name();return c.error(h.ITEMS_SHOULD_BE_OF_TYPE,this,{type:e}).getMessage()},t.prototype.check=function(e){var t=new c.Status(c.Status.OK,"","",this);if(Array.isArray(e))for(var n=e,r=0;r<n.length;r++){var i=this.type.validate(n[r],!1,!1);if(!i.isOk()){var a=this.type;if(a.isUnknown()||a.isRecurrent()){var o=c.error(h.ARRAY_AGAINST_UNKNOWN,this,{typeName:a.name()});return o}}c.setValidationPath(i,{name:""+r}),t.addSubStatus(i)}return t},t.prototype.validateSelfIndividual=function(e,t){var n=this;if(this.type.isAnonymous()){var r=this.type.validateType(t);return r.isOk()||e.addSubStatus(c.error(h.INVALID_COMPONENT_TYPE,this,{msg:e.getMessage()})),e}var i=this.type.metaOfType(g.ImportedByChain);if(i.length>0)i.forEach(function(t){var r=n.type.name(),i=null,a=h.ARRAY_COMPONENT_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN;t.value()!=i&&(a=h.ARRAY_COMPONENT_TYPE_DEPENDES_ON_TYPE_IMPORTED_THROUGH_LIBRARY_CHAIN,i=t.value()),e.addSubStatus(c.error(a,n,{componentTypeName:r,typeName:i}))});else if(this.type.isExternal()){var a=c.error(h.EXTERNAL_AS_COMPONENT,this);a.setValidationPath({name:"items"}),e.addSubStatus(a)}else if(c.isUnknown(this.type)||this.type.isSubTypeOf(c.RECURRENT))e.addSubStatus(c.error(h.UNKNOWN_ARRAY_COMPONENT_TYPE,this,{componentTypeName:this.type.name()}));else if(this.type.isUnion()){var o=m.find(this.type.typeFamily(),function(e){return c.isUnknown(e)});o&&e.addSubStatus(c.error(h.UNKNOWN_ARRAY_COMPONENT_TYPE,this,{componentTypeName:o.name()}))}return e},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(this.type.typeFamily().indexOf(n.type)!=-1)return n;if(n.type.typeFamily().indexOf(this.type)!=-1)return this;var r=this.intersect(this.type,n.type);try{var i=r.checkConfluent();if(!i.isOk()){var a=i;return a.toRestriction()}return new t(r)}finally{this.release(r)}}return null},t.prototype.checkValue=function(){return null},t.prototype.value=function(){return this.type},t}(C);t.ComponentShouldBeOfType=K;var j=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.facetName=function(){return"pattern"},t.prototype.requiredType=function(){return c.STRING},t.prototype.check=function(e){if("string"==typeof e){var t=e;try{var n=t.match(this._value),r=!1;if(n)for(var i=0,a=n;i<a.length;i++){var o=a[i];if(o.length==t.length){r=!0;break}}if(!r)return c.error(h.PATTERN_VIOLATION,this,{value:this.value()})}catch(e){}}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;return n._value===this._value?this:this.nothing(e,c.error(h.SHOULD_PASS_REXEXP,this,{name:"pattern restrictions"}).getMessage())}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){try{new RegExp(this._value)}catch(e){return c.error(h.INVALID_REGEXP,this,{msg:e.message},c.Status.ERROR,!0)}return null},t.prototype.toString=function(){return c.error(h.SHOULD_PASS_REXEXP,this,{rexexp:this.value}).getMessage()},t}(C);t.Pattern=j;var W=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.facetName=function(){return"fileTypes"},t.prototype.requiredType=function(){return c.FILE},t.prototype.check=function(e){return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e,r=m.intersection(this._value,n._value);return r.length>0?new t(r):this.nothing(e,h.NO_COMMON_FILE_TYPES.message)}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){if(!Array.isArray(this._value))return c.error(h.FILE_TYPES_SHOULD_BE_AN_ARRAY,this);for(var e=0,t=this._value;e<t.length;e++){var n=t[e];if("string"!=typeof n)return c.error(h.FILE_TYPES_SHOULD_BE_AN_ARRAY,this)}return c.ok()},t.prototype.toString=function(){return this.checkValue().isOk()?c.error(h.SUPPORTED_FILE_TYPES,this,{types:this._value.join(", ")}).getMessage():h.INVALID_FILETYPES_FACET_VALUE.message},t}(C);t.FileTypes=W;var H=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.facetName=function(){return"format"},t.prototype.requiredType=function(){return c.SCALAR},t.prototype.requiredTypes=function(){return[c.NUMBER,c.INTEGER,c.DATETIME]},t.prototype.check=function(e){return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;return n._value===this._value?this:this.nothing(e,c.error(h.SHOULD_PASS_REXEXP,this,{name:"Format"}).getMessage())}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){var e=this;try{var t=[];if(this.owner().isSubTypeOf(c.INTEGER))t=["int32","int64","int","long","int16","int8"];else if(this.owner().isSubTypeOf(c.NUMBER))t=["int32","int64","int","long","float","double","int16","int8"];else{if(!this.owner().isSubTypeOf(c.DATETIME))return null;t=["rfc3339","rfc2616"]}var n=m.find(t,function(t){return t==e.value()});if(!n)return c.error(h.ALLOWED_FORMAT_VALUES,this,{allowedValues:t.map(function(e){return"'"+e+"'"}).join(", ")},c.Status.ERROR,!0)}catch(e){return new v.Status(v.Status.ERROR,"",e.message,this)}return null},t.prototype.toString=function(){return"should have format:"+this.value},t}(C);t.Format=H;var Y=function(e){function t(t){var n=e.call(this)||this;return n._value=t,n}return p(t,e),t.prototype.facetName=function(){return"enum"},t.prototype.requiredType=function(){return c.ANY},t.prototype.check=function(e){if(!this.checkStatus){var t=this.value();if(this.owner().oneMeta(E.AcceptAllScalarsAsStrings)&&null!=e&&(t=t.concat(t.map(function(e){return""+e}))),Array.isArray(t)||(t=[t]),!t.some(function(t){return t==e})){var n=Array.isArray(this._value)?this._value.map(function(e){return e&&"object"==typeof e?JSON.stringify(e,null,2):"'"+e+"'"}).join(", "):"'"+this._value+"'";return c.error(h.ENUM_RESTRICTION,this,{values:n})}}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e,r=m.intersection(this._value,n._value);return 0==r.length?this.nothing(e):new t(r)}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){var e=this;if(!this.owner().isSubTypeOf(this.requiredType()))return c.error(h.ENUM_OWNER_TYPES,this,{typeNames:this.requiredType().name()},c.Status.ERROR,!0);if(this.requiredTypes()&&this.requiredTypes().length>0){var t=this.owner(),n=m.find(this.requiredTypes(),function(e){return t.isSubTypeOf(e)});if(!n){var r="["+this.requiredTypes().map(function(e){return"'"+e.name()+"'"}).join(", ")+"]";return c.error(h.ENUM_OWNER_TYPES,this,{typeNames:r},c.Status.ERROR,!0)}}if(!Array.isArray(this._value))return c.error(h.ENUM_ARRAY,this,{},c.Status.ERROR,!0);var i=c.ok();this.checkStatus=!0;try{this._value.forEach(function(t,n){var r=e.owner().validate(t);r.isOk()||(c.setValidationPath(r,{name:n}),i.addSubStatus(r))})}finally{this.checkStatus=!1}return i},t.prototype.toString=function(){var e=Array.isArray(this._value)?this._value.map(function(e){return"'"+e+"'"}).join(", "):"'"+this._value+"'";return"value should be one of: "+e},t}(C);t.Enum=Y,t.optimize=s,t.validatePropertyType=l},function(e,t,n){var r;!function(i){"use strict";function a(e){function t(e,r){var i,a,o,s,u,l,p=this;if(!(p instanceof t))return W&&w(26,"constructor call without new",e),new t(e,r);if(null!=r&&H(r,2,64,D,"base")){if(r|=0,l=e+"",10==r)return p=new t(e instanceof t?e:l),P(p,k+p.e+1,F);if((s="number"==typeof e)&&0*e!=0||!new RegExp("^-?"+(i="["+T.slice(0,r)+"]+")+"(?:\\."+i+")?$",r<37?"i":"").test(l))return O(p,l,s,r);s?(p.s=1/e<0?(l=l.slice(1),-1):1,W&&l.replace(/^0\.0*|\./,"").length>15&&w(D,_,e),s=!1):p.s=45===l.charCodeAt(0)?(l=l.slice(1),-1):1,l=n(l,10,r,p.s)}else{if(e instanceof t)return p.s=e.s,p.e=e.e,p.c=(e=e.c)?e.slice():e,void(D=0);if((s="number"==typeof e)&&0*e==0){if(p.s=1/e<0?(e=-e,-1):1,e===~~e){for(a=0,o=e;o>=10;o/=10,a++);return p.e=a,p.c=[e],void(D=0)}l=e+""}else{if(!y.test(l=e+""))return O(p,l,s);p.s=45===l.charCodeAt(0)?(l=l.slice(1),-1):1}}for((a=l.indexOf("."))>-1&&(l=l.replace(".","")),(o=l.search(/e/i))>0?(a<0&&(a=o),a+=+l.slice(o+1),l=l.substring(0,o)):a<0&&(a=l.length),o=0;48===l.charCodeAt(o);o++);for(u=l.length;48===l.charCodeAt(--u););if(l=l.slice(o,u+1))if(u=l.length,s&&W&&u>15&&(e>I||e!==g(e))&&w(D,_,p.s*e),a=a-o-1,a>j)p.c=p.e=null;else if(a<K)p.c=[p.e=0];else{if(p.e=a,p.c=[],o=(a+1)%N,a<0&&(o+=N),o<u){for(o&&p.c.push(+l.slice(0,o)),u-=N;o<u;)p.c.push(+l.slice(o,o+=N));l=l.slice(o),o=N-l.length}else o-=u;for(;o--;l+="0");p.c.push(+l)}else p.c=[p.e=0];D=0}function n(e,n,r,i){var a,o,u,l,p,f,d,m=e.indexOf("."),y=k,v=F;for(r<37&&(e=e.toLowerCase()),m>=0&&(u=G,G=0,e=e.replace(".",""),d=new t(r),p=d.pow(e.length-m),G=u,d.c=c(h(s(p.c),p.e),10,n),d.e=d.c.length),f=c(e,r,n),o=u=f.length;0==f[--u];f.pop());if(!f[0])return"0";if(m<0?--o:(p.c=f,p.e=o,p.s=i,p=L(p,d,y,v,n),f=p.c,l=p.r,o=p.e),a=o+y+1,m=f[a],u=n/2,l=l||a<0||null!=f[a+1],l=v<4?(null!=m||l)&&(0==v||v==(p.s<0?3:2)):m>u||m==u&&(4==v||l||6==v&&1&f[a-1]||v==(p.s<0?8:7)),a<1||!f[0])e=l?h("1",-y):"0";else{if(f.length=a,l)for(--n;++f[--a]>n;)f[a]=0,a||(++o,f=[1].concat(f));for(u=f.length;!f[--u];);for(m=0,e="";m<=u;e+=T.charAt(f[m++]));e=h(e,o)}return e}function r(e,n,r,i){var a,o,u,l,p;if(r=null!=r&&H(r,0,8,i,E)?0|r:F,!e.c)return e.toString();if(a=e.c[0],u=e.e,null==n)p=s(e.c),p=19==i||24==i&&u<=B?f(p,u):h(p,u);else if(e=P(new t(e),n,r),o=e.e,p=s(e.c),l=p.length,19==i||24==i&&(n<=o||o<=B)){for(;l<n;p+="0",l++);p=f(p,o)}else if(n-=u,p=h(p,o),o+1>l){if(--n>0)for(p+=".";n--;p+="0");}else if(n+=o-l,n>0)for(o+1==l&&(p+=".");n--;p+="0");return e.s<0&&a?"-"+p:p}function i(e,n){var r,i,a=0;for(p(e[0])&&(e=e[0]),r=new t(e[0]);++a<e.length;){if(i=new t(e[a]),!i.s){r=i;break}n.call(r,i)&&(r=i)}return r}function m(e,t,n,r,i){return(e<t||e>n||e!=d(e))&&w(r,(i||"decimal places")+(e<t||e>n?" out of range":" not an integer"),e),!0}function C(e,t,n){for(var r=1,i=t.length;!t[--i];t.pop());for(i=t[0];i>=10;i/=10,r++);return(n=r+n*N-1)>j?e.c=e.e=null:n<K?e.c=[e.e=0]:(e.e=n,e.c=t),e}function w(e,t,n){var r=new Error(["new BigNumber","cmp","config","div","divToInt","eq","gt","gte","lt","lte","minus","mod","plus","precision","random","round","shift","times","toDigits","toExponential","toFixed","toFormat","toFraction","pow","toPrecision","toString","BigNumber"][e]+"() "+t+": "+n);throw r.name="BigNumber Error",D=0,r}function P(e,t,n,r){var i,a,o,s,u,l,p,c=e.c,f=b;if(c){e:{for(i=1,s=c[0];s>=10;s/=10,i++);if(a=t-i,a<0)a+=N,o=t,u=c[l=0],p=u/f[i-o-1]%10|0;else if(l=v((a+1)/N),l>=c.length){if(!r)break e;for(;c.length<=l;c.push(0));u=p=0,i=1,a%=N,o=a-N+1}else{for(u=s=c[l],i=1;s>=10;s/=10,i++);a%=N,o=a-N+i,p=o<0?0:u/f[i-o-1]%10|0}if(r=r||t<0||null!=c[l+1]||(o<0?u:u%f[i-o-1]),r=n<4?(p||r)&&(0==n||n==(e.s<0?3:2)):p>5||5==p&&(4==n||r||6==n&&(a>0?o>0?u/f[i-o]:0:c[l-1])%10&1||n==(e.s<0?8:7)),t<1||!c[0])return c.length=0,r?(t-=e.e+1,c[0]=f[(N-t%N)%N],e.e=-t||0):c[0]=e.e=0,e;if(0==a?(c.length=l,s=1,l--):(c.length=l+1,s=f[N-a],c[l]=o>0?g(u/f[i-o]%f[o])*s:0),r)for(;;){if(0==l){for(a=1,o=c[0];o>=10;o/=10,a++);for(o=c[0]+=s,s=1;o>=10;o/=10,s++);a!=s&&(e.e++,c[0]==S&&(c[0]=1));break}if(c[l]+=s,c[l]!=S)break;c[l--]=0,s=1}for(a=c.length;0===c[--a];c.pop());}e.e>j?e.c=e.e=null:e.e<K&&(e.c=[e.e=0])}return e}var L,O,D=0,U=t.prototype,x=new t(1),k=20,F=4,B=-7,V=21,K=-1e7,j=1e7,W=!0,H=m,Y=!1,q=1,G=0,X={decimalSeparator:".",groupSeparator:",",groupSize:3,secondaryGroupSize:0,fractionGroupSeparator:" ",fractionGroupSize:0};return t.another=a,t.ROUND_UP=0,t.ROUND_DOWN=1,t.ROUND_CEIL=2,t.ROUND_FLOOR=3,t.ROUND_HALF_UP=4,t.ROUND_HALF_DOWN=5,t.ROUND_HALF_EVEN=6,t.ROUND_HALF_CEIL=7,t.ROUND_HALF_FLOOR=8,t.EUCLID=9,t.config=t.set=function(){var e,t,n=0,r={},i=arguments,a=i[0],o=a&&"object"==typeof a?function(){if(a.hasOwnProperty(t))return null!=(e=a[t])}:function(){if(i.length>n)return null!=(e=i[n++])};return o(t="DECIMAL_PLACES")&&H(e,0,M,2,t)&&(k=0|e),r[t]=k,o(t="ROUNDING_MODE")&&H(e,0,8,2,t)&&(F=0|e),r[t]=F,o(t="EXPONENTIAL_AT")&&(p(e)?H(e[0],-M,0,2,t)&&H(e[1],0,M,2,t)&&(B=0|e[0],V=0|e[1]):H(e,-M,M,2,t)&&(B=-(V=0|(e<0?-e:e)))),r[t]=[B,V],o(t="RANGE")&&(p(e)?H(e[0],-M,-1,2,t)&&H(e[1],1,M,2,t)&&(K=0|e[0],j=0|e[1]):H(e,-M,M,2,t)&&(0|e?K=-(j=0|(e<0?-e:e)):W&&w(2,t+" cannot be zero",e))),r[t]=[K,j],o(t="ERRORS")&&(e===!!e||1===e||0===e?(D=0,H=(W=!!e)?m:l):W&&w(2,t+A,e)),r[t]=W,o(t="CRYPTO")&&(e===!0||e===!1||1===e||0===e?e?(e="undefined"==typeof crypto,!e&&crypto&&(crypto.getRandomValues||crypto.randomBytes)?Y=!0:W?w(2,"crypto unavailable",e?void 0:crypto):Y=!1):Y=!1:W&&w(2,t+A,e)),r[t]=Y,o(t="MODULO_MODE")&&H(e,0,9,2,t)&&(q=0|e),r[t]=q,o(t="POW_PRECISION")&&H(e,0,M,2,t)&&(G=0|e),r[t]=G,o(t="FORMAT")&&("object"==typeof e?X=e:W&&w(2,t+" not an object",e)),r[t]=X,r},t.max=function(){return i(arguments,U.lt)},t.min=function(){return i(arguments,U.gt)},t.random=function(){var e=9007199254740992,n=Math.random()*e&2097151?function(){return g(Math.random()*e)}:function(){return 8388608*(1073741824*Math.random()|0)+(8388608*Math.random()|0)};return function(e){var r,i,a,o,s,u=0,l=[],p=new t(x);if(e=null!=e&&H(e,0,M,14)?0|e:k,o=v(e/N),Y)if(crypto.getRandomValues){for(r=crypto.getRandomValues(new Uint32Array(o*=2));u<o;)s=131072*r[u]+(r[u+1]>>>11),s>=9e15?(i=crypto.getRandomValues(new Uint32Array(2)),r[u]=i[0],r[u+1]=i[1]):(l.push(s%1e14),u+=2);u=o/2}else if(crypto.randomBytes){for(r=crypto.randomBytes(o*=7);u<o;)s=281474976710656*(31&r[u])+1099511627776*r[u+1]+4294967296*r[u+2]+16777216*r[u+3]+(r[u+4]<<16)+(r[u+5]<<8)+r[u+6],s>=9e15?crypto.randomBytes(7).copy(r,u):(l.push(s%1e14),u+=7);u=o/7}else Y=!1,W&&w(14,"crypto unavailable",crypto);if(!Y)for(;u<o;)s=n(),s<9e15&&(l[u++]=s%1e14);for(o=l[--u],e%=N,o&&e&&(s=b[N-e],l[u]=g(o/s)*s);0===l[u];l.pop(),u--);if(u<0)l=[a=0];else{for(a=-1;0===l[0];l.splice(0,1),a-=N);for(u=1,s=l[0];s>=10;s/=10,u++);u<N&&(a-=N-u)}return p.e=a,p.c=l,p}}(),L=function(){function e(e,t,n){var r,i,a,o,s=0,u=e.length,l=t%R,p=t/R|0;for(e=e.slice();u--;)a=e[u]%R,o=e[u]/R|0,r=p*a+o*l,i=l*a+r%R*R+s,s=(i/n|0)+(r/R|0)+p*o,e[u]=i%n;return s&&(e=[s].concat(e)),e}function n(e,t,n,r){var i,a;if(n!=r)a=n>r?1:-1;else for(i=a=0;i<n;i++)if(e[i]!=t[i]){a=e[i]>t[i]?1:-1;break}return a}function r(e,t,n,r){for(var i=0;n--;)e[n]-=i,i=e[n]<t[n]?1:0,e[n]=i*r+e[n]-t[n];for(;!e[0]&&e.length>1;e.splice(0,1));}return function(i,a,s,u,l){var p,c,f,h,d,m,y,v,A,E,_,T,I,b,R,M,C,w=i.s==a.s?1:-1,L=i.c,O=a.c;if(!(L&&L[0]&&O&&O[0]))return new t(i.s&&a.s&&(L?!O||L[0]!=O[0]:O)?L&&0==L[0]||!O?0*w:w/0:NaN);for(v=new t(w),A=v.c=[],c=i.e-a.e,w=s+c+1,l||(l=S,c=o(i.e/N)-o(a.e/N),w=w/N|0),f=0;O[f]==(L[f]||0);f++);if(O[f]>(L[f]||0)&&c--,w<0)A.push(1),h=!0;else{for(b=L.length,M=O.length,f=0,w+=2,d=g(l/(O[0]+1)),d>1&&(O=e(O,d,l),L=e(L,d,l),M=O.length,b=L.length),I=M,E=L.slice(0,M),_=E.length;_<M;E[_++]=0);C=O.slice(),C=[0].concat(C),R=O[0],O[1]>=l/2&&R++;do{if(d=0,p=n(O,E,M,_),p<0){if(T=E[0],M!=_&&(T=T*l+(E[1]||0)),d=g(T/R),d>1)for(d>=l&&(d=l-1),m=e(O,d,l),y=m.length,_=E.length;1==n(m,E,y,_);)d--,r(m,M<y?C:O,y,l),y=m.length,p=1;else 0==d&&(p=d=1),m=O.slice(),y=m.length;if(y<_&&(m=[0].concat(m)),r(E,m,_,l),_=E.length,p==-1)for(;n(O,E,M,_)<1;)d++,r(E,M<_?C:O,_,l),_=E.length}else 0===p&&(d++,E=[0]);A[f++]=d,E[0]?E[_++]=L[I]||0:(E=[L[I]],_=1)}while((I++<b||null!=E[0])&&w--);h=null!=E[0],A[0]||A.splice(0,1)}if(l==S){for(f=1,w=A[0];w>=10;w/=10,f++);P(v,s+(v.e=f+c*N-1)+1,u,h)}else v.e=c,v.r=+h;return v}}(),O=function(){var e=/^(-?)0([xbo])(?=\w[\w.]*$)/i,n=/^([^.]+)\.$/,r=/^\.([^.]+)$/,i=/^-?(Infinity|NaN)$/,a=/^\s*\+(?=[\w.])|^\s+|\s+$/g;return function(o,s,u,l){var p,c=u?s:s.replace(a,"");if(i.test(c))o.s=isNaN(c)?null:c<0?-1:1;else{if(!u&&(c=c.replace(e,function(e,t,n){return p="x"==(n=n.toLowerCase())?16:"b"==n?2:8,l&&l!=p?e:t}),l&&(p=l,c=c.replace(n,"$1").replace(r,"0.$1")),s!=c))return new t(c,p);W&&w(D,"not a"+(l?" base "+l:"")+" number",s),o.s=null}o.c=o.e=null,D=0}}(),U.absoluteValue=U.abs=function(){var e=new t(this);return e.s<0&&(e.s=1),e},U.ceil=function(){return P(new t(this),this.e+1,2)},U.comparedTo=U.cmp=function(e,n){return D=1,u(this,new t(e,n))},U.decimalPlaces=U.dp=function(){var e,t,n=this.c;if(!n)return null;if(e=((t=n.length-1)-o(this.e/N))*N,t=n[t])for(;t%10==0;t/=10,e--);return e<0&&(e=0),e},U.dividedBy=U.div=function(e,n){return D=3,L(this,new t(e,n),k,F)},U.dividedToIntegerBy=U.divToInt=function(e,n){return D=4,L(this,new t(e,n),0,1)},U.equals=U.eq=function(e,n){return D=5,0===u(this,new t(e,n))},U.floor=function(){return P(new t(this),this.e+1,3)},U.greaterThan=U.gt=function(e,n){return D=6,u(this,new t(e,n))>0},U.greaterThanOrEqualTo=U.gte=function(e,n){return D=7,1===(n=u(this,new t(e,n)))||0===n},U.isFinite=function(){return!!this.c},U.isInteger=U.isInt=function(){return!!this.c&&o(this.e/N)>this.c.length-2},U.isNaN=function(){return!this.s},U.isNegative=U.isNeg=function(){return this.s<0},U.isZero=function(){return!!this.c&&0==this.c[0]},U.lessThan=U.lt=function(e,n){return D=8,u(this,new t(e,n))<0},U.lessThanOrEqualTo=U.lte=function(e,n){return D=9,(n=u(this,new t(e,n)))===-1||0===n},U.minus=U.sub=function(e,n){var r,i,a,s,u=this,l=u.s;if(D=10,e=new t(e,n),n=e.s,!l||!n)return new t(NaN);if(l!=n)return e.s=-n,u.plus(e);var p=u.e/N,c=e.e/N,f=u.c,h=e.c;if(!p||!c){if(!f||!h)return f?(e.s=-n,e):new t(h?u:NaN);if(!f[0]||!h[0])return h[0]?(e.s=-n,e):new t(f[0]?u:3==F?-0:0)}if(p=o(p),c=o(c),
f=f.slice(),l=p-c){for((s=l<0)?(l=-l,a=f):(c=p,a=h),a.reverse(),n=l;n--;a.push(0));a.reverse()}else for(i=(s=(l=f.length)<(n=h.length))?l:n,l=n=0;n<i;n++)if(f[n]!=h[n]){s=f[n]<h[n];break}if(s&&(a=f,f=h,h=a,e.s=-e.s),n=(i=h.length)-(r=f.length),n>0)for(;n--;f[r++]=0);for(n=S-1;i>l;){if(f[--i]<h[i]){for(r=i;r&&!f[--r];f[r]=n);--f[r],f[i]+=S}f[i]-=h[i]}for(;0==f[0];f.splice(0,1),--c);return f[0]?C(e,f,c):(e.s=3==F?-1:1,e.c=[e.e=0],e)},U.modulo=U.mod=function(e,n){var r,i,a=this;return D=11,e=new t(e,n),!a.c||!e.s||e.c&&!e.c[0]?new t(NaN):!e.c||a.c&&!a.c[0]?new t(a):(9==q?(i=e.s,e.s=1,r=L(a,e,0,3),e.s=i,r.s*=i):r=L(a,e,0,q),a.minus(r.times(e)))},U.negated=U.neg=function(){var e=new t(this);return e.s=-e.s||null,e},U.plus=U.add=function(e,n){var r,i=this,a=i.s;if(D=12,e=new t(e,n),n=e.s,!a||!n)return new t(NaN);if(a!=n)return e.s=-n,i.minus(e);var s=i.e/N,u=e.e/N,l=i.c,p=e.c;if(!s||!u){if(!l||!p)return new t(a/0);if(!l[0]||!p[0])return p[0]?e:new t(l[0]?i:0*a)}if(s=o(s),u=o(u),l=l.slice(),a=s-u){for(a>0?(u=s,r=p):(a=-a,r=l),r.reverse();a--;r.push(0));r.reverse()}for(a=l.length,n=p.length,a-n<0&&(r=p,p=l,l=r,n=a),a=0;n;)a=(l[--n]=l[n]+p[n]+a)/S|0,l[n]=S===l[n]?0:l[n]%S;return a&&(l=[a].concat(l),++u),C(e,l,u)},U.precision=U.sd=function(e){var t,n,r=this,i=r.c;if(null!=e&&e!==!!e&&1!==e&&0!==e&&(W&&w(13,"argument"+A,e),e!=!!e&&(e=null)),!i)return null;if(n=i.length-1,t=n*N+1,n=i[n]){for(;n%10==0;n/=10,t--);for(n=i[0];n>=10;n/=10,t++);}return e&&r.e+1>t&&(t=r.e+1),t},U.round=function(e,n){var r=new t(this);return(null==e||H(e,0,M,15))&&P(r,~~e+this.e+1,null!=n&&H(n,0,8,15,E)?0|n:F),r},U.shift=function(e){var n=this;return H(e,-I,I,16,"argument")?n.times("1e"+d(e)):new t(n.c&&n.c[0]&&(e<-I||e>I)?n.s*(e<0?0:1/0):n)},U.squareRoot=U.sqrt=function(){var e,n,r,i,a,u=this,l=u.c,p=u.s,c=u.e,f=k+4,h=new t("0.5");if(1!==p||!l||!l[0])return new t(!p||p<0&&(!l||l[0])?NaN:l?u:1/0);if(p=Math.sqrt(+u),0==p||p==1/0?(n=s(l),(n.length+c)%2==0&&(n+="0"),p=Math.sqrt(n),c=o((c+1)/2)-(c<0||c%2),p==1/0?n="1e"+c:(n=p.toExponential(),n=n.slice(0,n.indexOf("e")+1)+c),r=new t(n)):r=new t(p+""),r.c[0])for(c=r.e,p=c+f,p<3&&(p=0);;)if(a=r,r=h.times(a.plus(L(u,a,f,1))),s(a.c).slice(0,p)===(n=s(r.c)).slice(0,p)){if(r.e<c&&--p,n=n.slice(p-3,p+1),"9999"!=n&&(i||"4999"!=n)){+n&&(+n.slice(1)||"5"!=n.charAt(0))||(P(r,r.e+k+2,1),e=!r.times(r).eq(u));break}if(!i&&(P(a,a.e+k+2,0),a.times(a).eq(u))){r=a;break}f+=4,p+=4,i=1}return P(r,r.e+k+1,F,e)},U.times=U.mul=function(e,n){var r,i,a,s,u,l,p,c,f,h,d,m,y,v,g,A=this,E=A.c,_=(D=17,e=new t(e,n)).c;if(!(E&&_&&E[0]&&_[0]))return!A.s||!e.s||E&&!E[0]&&!_||_&&!_[0]&&!E?e.c=e.e=e.s=null:(e.s*=A.s,E&&_?(e.c=[0],e.e=0):e.c=e.e=null),e;for(i=o(A.e/N)+o(e.e/N),e.s*=A.s,p=E.length,h=_.length,p<h&&(y=E,E=_,_=y,a=p,p=h,h=a),a=p+h,y=[];a--;y.push(0));for(v=S,g=R,a=h;--a>=0;){for(r=0,d=_[a]%g,m=_[a]/g|0,u=p,s=a+u;s>a;)c=E[--u]%g,f=E[u]/g|0,l=m*c+f*d,c=d*c+l%g*g+y[s]+r,r=(c/v|0)+(l/g|0)+m*f,y[s--]=c%v;y[s]=r}return r?++i:y.splice(0,1),C(e,y,i)},U.toDigits=function(e,n){var r=new t(this);return e=null!=e&&H(e,1,M,18,"precision")?0|e:null,n=null!=n&&H(n,0,8,18,E)?0|n:F,e?P(r,e,n):r},U.toExponential=function(e,t){return r(this,null!=e&&H(e,0,M,19)?~~e+1:null,t,19)},U.toFixed=function(e,t){return r(this,null!=e&&H(e,0,M,20)?~~e+this.e+1:null,t,20)},U.toFormat=function(e,t){var n=r(this,null!=e&&H(e,0,M,21)?~~e+this.e+1:null,t,21);if(this.c){var i,a=n.split("."),o=+X.groupSize,s=+X.secondaryGroupSize,u=X.groupSeparator,l=a[0],p=a[1],c=this.s<0,f=c?l.slice(1):l,h=f.length;if(s&&(i=o,o=s,s=i,h-=i),o>0&&h>0){for(i=h%o||o,l=f.substr(0,i);i<h;i+=o)l+=u+f.substr(i,o);s>0&&(l+=u+f.slice(i)),c&&(l="-"+l)}n=p?l+X.decimalSeparator+((s=+X.fractionGroupSize)?p.replace(new RegExp("\\d{"+s+"}\\B","g"),"$&"+X.fractionGroupSeparator):p):l}return n},U.toFraction=function(e){var n,r,i,a,o,u,l,p,c,f=W,h=this,d=h.c,m=new t(x),y=r=new t(x),v=l=new t(x);if(null!=e&&(W=!1,u=new t(e),W=f,(f=u.isInt())&&!u.lt(x)||(W&&w(22,"max denominator "+(f?"out of range":"not an integer"),e),e=!f&&u.c&&P(u,u.e+1,1).gte(x)?u:null)),!d)return h.toString();for(c=s(d),a=m.e=c.length-h.e-1,m.c[0]=b[(o=a%N)<0?N+o:o],e=!e||u.cmp(m)>0?a>0?m:y:u,o=j,j=1/0,u=new t(c),l.c[0]=0;p=L(u,m,0,1),i=r.plus(p.times(v)),1!=i.cmp(e);)r=v,v=i,y=l.plus(p.times(i=y)),l=i,m=u.minus(p.times(i=m)),u=i;return i=L(e.minus(r),v,0,1),l=l.plus(i.times(y)),r=r.plus(i.times(v)),l.s=y.s=h.s,a*=2,n=L(y,v,a,F).minus(h).abs().cmp(L(l,r,a,F).minus(h).abs())<1?[y.toString(),v.toString()]:[l.toString(),r.toString()],j=o,n},U.toNumber=function(){return+this},U.toPower=U.pow=function(e,n){var r,i,a,o=g(e<0?-e:+e),s=this;if(null!=n&&(D=23,n=new t(n)),!H(e,-I,I,23,"exponent")&&(!isFinite(e)||o>I&&(e/=0)||parseFloat(e)!=e&&!(e=NaN))||0==e)return r=Math.pow(+s,e),new t(n?r%n:r);for(n?e>1&&s.gt(x)&&s.isInt()&&n.gt(x)&&n.isInt()?s=s.mod(n):(a=n,n=null):G&&(r=v(G/N+2)),i=new t(x);;){if(o%2){if(i=i.times(s),!i.c)break;r?i.c.length>r&&(i.c.length=r):n&&(i=i.mod(n))}if(o=g(o/2),!o)break;s=s.times(s),r?s.c&&s.c.length>r&&(s.c.length=r):n&&(s=s.mod(n))}return n?i:(e<0&&(i=x.div(i)),a?i.mod(a):r?P(i,G,F):i)},U.toPrecision=function(e,t){return r(this,null!=e&&H(e,1,M,24,"precision")?0|e:null,t,24)},U.toString=function(e){var t,r=this,i=r.s,a=r.e;return null===a?i?(t="Infinity",i<0&&(t="-"+t)):t="NaN":(t=s(r.c),t=null!=e&&H(e,2,64,25,"base")?n(h(t,a),0|e,10,i):a<=B||a>=V?f(t,a):h(t,a),i<0&&r.c[0]&&(t="-"+t)),t},U.truncated=U.trunc=function(){return P(new t(this),this.e+1,1)},U.valueOf=U.toJSON=function(){var e,t=this,n=t.e;return null===n?t.toString():(e=s(t.c),e=n<=B||n>=V?f(e,n):h(e,n),t.s<0?"-"+e:e)},U.isBigNumber=!0,null!=e&&t.config(e),t}function o(e){var t=0|e;return e>0||e===t?t:t-1}function s(e){for(var t,n,r=1,i=e.length,a=e[0]+"";r<i;){for(t=e[r++]+"",n=N-t.length;n--;t="0"+t);a+=t}for(i=a.length;48===a.charCodeAt(--i););return a.slice(0,i+1||1)}function u(e,t){var n,r,i=e.c,a=t.c,o=e.s,s=t.s,u=e.e,l=t.e;if(!o||!s)return null;if(n=i&&!i[0],r=a&&!a[0],n||r)return n?r?0:-s:o;if(o!=s)return o;if(n=o<0,r=u==l,!i||!a)return r?0:!i^n?1:-1;if(!r)return u>l^n?1:-1;for(s=(u=i.length)<(l=a.length)?u:l,o=0;o<s;o++)if(i[o]!=a[o])return i[o]>a[o]^n?1:-1;return u==l?0:u>l^n?1:-1}function l(e,t,n){return(e=d(e))>=t&&e<=n}function p(e){return"[object Array]"==Object.prototype.toString.call(e)}function c(e,t,n){for(var r,i,a=[0],o=0,s=e.length;o<s;){for(i=a.length;i--;a[i]*=t);for(a[r=0]+=T.indexOf(e.charAt(o++));r<a.length;r++)a[r]>n-1&&(null==a[r+1]&&(a[r+1]=0),a[r+1]+=a[r]/n|0,a[r]%=n)}return a.reverse()}function f(e,t){return(e.length>1?e.charAt(0)+"."+e.slice(1):e)+(t<0?"e":"e+")+t}function h(e,t){var n,r;if(t<0){for(r="0.";++t;r+="0");e=r+e}else if(n=e.length,++t>n){for(r="0",t-=n;--t;r+="0");e+=r}else t<n&&(e=e.slice(0,t)+"."+e.slice(t));return e}function d(e){return e=parseFloat(e),e<0?v(e):g(e)}var m,y=/^-?(\d+(\.\d*)?|\.\d+)(e[+-]?\d+)?$/i,v=Math.ceil,g=Math.floor,A=" not a boolean or binary digit",E="rounding mode",_="number type has more than 15 significant digits",T="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_",S=1e14,N=14,I=9007199254740991,b=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9,1e10,1e11,1e12,1e13],R=1e7,M=1e9;m=a(),m.default=m.BigNumber=m,r=function(){return m}.call(t,n,t,e),!(void 0!==r&&(e.exports=r))}(this)},function(e,t,n){"use strict";function r(e,t){return y.serializeToXML(e,t)}function i(e,t){if("string"==typeof e&&(t.isObject()||t.isArray()||t.isExternal()||t.isUnion())){var n=e,r=n.trim().charAt(0);if(!t.isExternal()&&("{"==r||"["==r||"null"==n.trim()))try{return JSON.parse(n)}catch(e){if(t.isObject()||t.isArray()){var i=p.error(c.CAN_NOT_PARSE_JSON,this,{msg:e.message});return i}}if("<"==r)try{var a=y.readObject(n,t),o=y.getXmlErrors(a);if(o){var s=p.error(c.INVALID_XML,null);return o.forEach(function(e){return s.addSubStatus(e)}),s}return a}catch(e){}}return t.getExtra(v.REPEAT)&&(e=[e]),e}function a(e,t,n){t?p.setValidationPath(e,{name:"examples",child:{name:n}}):p.setValidationPath(e,{name:"examples",child:{name:n,child:{name:"value"}}})}function o(e,t,n,r,i){for(var a=0,o=j;a<o.length;a++){var u=o[a];s(e,t,u,n,r,i)}}function s(e,t,n,r,i,a){var o=n.propName,s=n.propType;if(e&&"object"==typeof e&&e.hasOwnProperty(o)){var l=e[o];if(null==l){var c=p.error(n.messageEntry,this),f=u(t,a,{name:o});p.setValidationPath(c,f),i.addSubStatus(c)}else if(typeof l!=s){var f=null;if("object"==typeof l&&(f=u(t,a,{name:"value"}),Object.keys(l).forEach(function(n){if("("==n.charAt(0)&&")"==n.charAt(n.length-1)){var s=new b(n.substring(1,n.length-1),e[o][n],n,!0),l=s.validateSelf(r),c=u(t,a,{name:o,child:{name:n}});p.setValidationPath(l,c),i.addSubStatus(l)}})),!l.value&&typeof l.value!=s){var c=p.error(n.messageEntry,this);p.setValidationPath(c,{name:"examples",child:{name:t,child:{name:o,child:f}}}),i.addSubStatus(c)}}}}function u(e,t,n){var r=n;return e&&(r={name:e,child:n}),{name:t,child:r}}var l=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var p=n(58),c=p.messageRegistry,f=n(58),h=n(75),d=n(75),m=n(59),y=n(78),v=n(74),g=function(e){function t(t,n,r){void 0===r&&(r=!1);var i=e.call(this,r)||this;return i._name=t,i._value=n,i}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_MetaInfo)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_MetaInfo)},t.prototype.value=function(){return this._value},t.prototype.requiredType=function(){return p.ANY},t.prototype.facetName=function(){return this._name},t.prototype.kind=function(){return null},t.CLASS_IDENTIFIER_MetaInfo="metainfo.MetaInfo",t}(p.TypeInformation);t.MetaInfo=g;var A=function(e){function t(t){return e.call(this,"description",t)||this}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_Description)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_Description)},t.prototype.kind=function(){return v.MetaInformationKind.Description},t.prototype.validateSelfIndividual=function(e,t){var n=this.value(),r={string:!0,number:!0,boolean:!0},i=p.ok();return null===n||r[typeof n]||(i=p.error(c.INVALID_PROPERTY_RANGE,this,{propName:this.facetName(),range:"string"}),p.setValidationPath(i,{name:this.facetName()})),e.addSubStatus(i),e},t.CLASS_IDENTIFIER_Description="metainfo.Description",t}(g);t.Description=A;var E=function(e){function t(){return e.call(this,"notScalar",!0)||this}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_NotScalar)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_NotScalar)},t.prototype.kind=function(){return v.MetaInformationKind.NotScalar},t.CLASS_IDENTIFIER_NotScalar="metainfo.NotScalar",t}(g);t.NotScalar=E;var _=function(e){function t(t){var n=e.call(this,"importedByChain",t,!0)||this;return n._typeName=t,n}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_ImportedByChain)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ImportedByChain)},t.prototype.kind=function(){return v.MetaInformationKind.ImportedByChain},t.CLASS_IDENTIFIER_ImportedByChain="metainfo.ImportedByChain",t}(g);t.ImportedByChain=_;var T=function(e){function t(){return e.call(this,"acceptAllScalarsAsStrings",null,!0)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.AcceptAllScalarsAsStrings},t}(g);t.AcceptAllScalarsAsStrings=T;var S=function(e){function t(){return e.call(this,"skipValidation",null,!0)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.SkipValidation},t}(g);t.SkipValidation=S;var N=function(e){function t(t){return e.call(this,"displayName",t)||this}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_DisplayName)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_DisplayName)},t.prototype.kind=function(){return v.MetaInformationKind.DisplayName},t.prototype.validateSelfIndividual=function(e,t){var n=this.value(),r={string:!0,number:!0,boolean:!0},i=p.ok();return null===n||r[typeof n]||(i=p.error(c.INVALID_PROPERTY_RANGE,this,{propName:this.facetName(),range:"string"}),p.setValidationPath(i,{name:this.facetName()})),e.addSubStatus(i),e},t.CLASS_IDENTIFIER_DisplayName="metainfo.DisplayName",t}(g);t.DisplayName=N;var I=function(e){function t(t){return e.call(this,"usage",t)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.Usage},t}(g);t.Usage=I;var b=function(e){function t(t,n,r,i,a){void 0===i&&(i=!1),void 0===a&&(a=-1);var o=e.call(this,t,n)||this;return o.path=r,o.ofExample=i,o._index=a,o}return l(t,e),t.prototype.name=function(){return this.facetName()},t.prototype.definition=function(){var e=this.owner();if(e){var t=e.collection();if(t){var n=t.getAnnotationType(this.facetName());return n}}return null},t.prototype.validateSelfIndividual=function(t,n){var r=n.get(this.facetName());if(!r){var i=void 0;return i=n.getByChain(this.facetName())?p.error(c.LIBRARY_CHAINIG_IN_ANNOTATION_TYPE,this,{typeName:this.facetName()}):p.error(c.UNKNOWN_ANNOTATION_TYPE,this,{typeName:this.facetName()}),i.setValidationPath({name:this.path}),i}var a=p.ok(),o=this.value();o||r.isString()&&(o="");var s=r.metaOfType(L),u=this.ofExample?"Example":"TypeDeclaration";if(s.length>0){var l=[],f=s.filter(function(e){var t=e.value();return Array.isArray(t)?(l=l.concat(t),t.indexOf(u)>=0):(l.push(t),t==u)});if(0==f.length){var h=l.map(function(e){return"'"+e+"'"}).join(", "),d=p.error(c.INVALID_ANNOTATION_LOCATION,this,{aName:e.prototype.facetName.call(this),aValues:h});a.addSubStatus(d)}}var m,y=r.metaOfType(_);if(y.length>0&&p.isUnknown(r)&&n.getByChain(r.name())){var v=y[0].value();m=p.error(c.LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE,this,{typeName:this.facetName(),chainedType:v})}else{var g=r.validateDirect(o,!0,!1);g.isOk()||(m=p.error(c.INVALID_ANNOTATION_VALUE,this,{msg:g.getMessage()}),m.addSubStatus(g))}return m&&a.addSubStatus(m),p.setValidationPath(a,{name:this.path}),a},t.prototype.kind=function(){return v.MetaInformationKind.Annotation},t.prototype.ownerFacet=function(){return this._ownerFacet},t.prototype.setOwnerFacet=function(e){this._ownerFacet=e},t.prototype.getPath=function(){return this.path},t}(g);t.Annotation=b;var R=function(e){function t(t,n,r,i){void 0===i&&(i=!1);var a=e.call(this,t,n,!0)||this;return a.name=t,a._type=n,a.optional=r,a.builtIn=i,a}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_FacetDeclaration)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_FacetDeclaration)},t.prototype.actualName=function(){return"?"==this.name.charAt(this.name.length-1)?this.name.substr(0,this.name.length-1):this.name},t.prototype.isOptional=function(){return this.optional},t.prototype.type=function(){return this._type},t.prototype.kind=function(){return v.MetaInformationKind.FacetDeclaration},t.prototype.isBuiltIn=function(){return this.builtIn},t.prototype.validateSelfIndividual=function(e,t){return d.validatePropertyType(this._type,this.name,t,this,!1)},t.CLASS_IDENTIFIER_FacetDeclaration="metainfo.FacetDeclaration",t}(g);t.FacetDeclaration=R;var M=function(e){function t(t,n){return e.call(this,t,n,!0)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.CustomFacet},t}(g);t.CustomFacet=M;var C=function(e){function t(t){return e.call(this,"example",t)||this}return l(t,e),t.prototype.validateSelfIndividual=function(e,t){var n=p.ok();n.addSubStatus(this.validateValue(t));var r=this.validateAnnotations(t);return p.setValidationPath(r,{name:this.facetName()}),n.addSubStatus(r),n},t.prototype.validateValue=function(e){if(!this.owner().oneMeta(S)){var t=this.value(),n=!1,r=p.ok();if("object"==typeof t&&t&&t.hasOwnProperty("value")){if(o(t,null,e,r,this.facetName()),t.strict===!1||t.strict&&"object"==typeof t.strict&&t.strict.value===!1)return r;t=t.value,n=!0}var a=t;if(a=i(t,this.owner()),a instanceof p.Status&&!a.isOk())return p.setValidationPath(a,{name:"example"}),r.addSubStatus(a),r;var s=this.owner().validateDirect(a,!0,!1);if(!s.isOk()){"string"==typeof this.value();var u=p.error(c.INVALID_EXMAPLE,this,{msg:s.getMessage()});s.getErrors().forEach(function(e){u.addSubStatus(e),n?p.setValidationPath(e,{name:"example",child:{name:"value"}}):p.setValidationPath(e,{name:"example"})}),r.addSubStatus(u)}return r}},t.prototype.validateAnnotations=function(e){var t=p.ok(),n=this.value();if("object"==typeof n&&n&&n.value)for(var r=Object.keys(n).filter(function(e){return e.length>2&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)}),i=0,a=r;i<a.length;i++){var o=a[i],s=n[o],u=o.substring(1,o.length-1),l=new b(u,s,o,!0);t.addSubStatus(l.validateSelf(e))}return t},t.prototype.example=function(){var e=this.value();return"object"==typeof e&&e&&e.value&&(e=e.value),i(e,this.owner())},t.prototype.asXMLString=function(){var e=this.value();if("string"==typeof e&&0===e.trim().indexOf("<"))return e;var t=i(e,this.owner());return r(t,this.owner())},t.prototype.kind=function(){return v.MetaInformationKind.Example},t}(g);t.Example=C;var w=function(e){function t(t){return e.call(this,"required",t)||this}return l(t,e),t.prototype.validateSelfIndividual=function(e,t){return"boolean"!=typeof this.value()&&(e=p.error(c.REQUIRED_BOOLEAN,this),p.setValidationPath(e,{name:this.facetName()})),e},t.prototype.kind=function(){return v.MetaInformationKind.Required},t}(g);t.Required=w;var P=function(e){function t(){return e.call(this,"hasPropertiesFacet",null)||this}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_HasPropertiesFacet)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_HasPropertiesFacet)},t.prototype.kind=function(){return v.MetaInformationKind.HasPropertiesFacet},t.CLASS_IDENTIFIER_HasPropertiesFacet="metainfo.HasPropertiesFacet",t}(g);t.HasPropertiesFacet=P;var L=function(e){function t(t){return e.call(this,"allowedTargets",t)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.AllowedTargets},t}(g);t.AllowedTargets=L;var O=function(e){function t(t){return e.call(this,"examples",t)||this}return l(t,e),t.prototype.examples=function(){var e=this,t=this.value(),n=[];return Object.keys(t).forEach(function(r){if("object"==typeof t[r]&&t[r]){var a=t[r].value;a||(a=t[r]);var o=i(a,e.owner());n.push(o)}}),n},t.prototype.asXMLStrings=function(){var e=this,t=this.value(),n={};return Object.keys(t).forEach(function(a){var o=t[a];if("string"==typeof o&&0===o.trim().indexOf("<"))return void(n[a]=o);var s=i(o,e.owner());n[a]=r(s,e.owner())}),n},t.prototype.validateSelfIndividual=function(e,t){var n=this,r=this.value();if("object"!=typeof r||null!=r&&Array.isArray(r))return p.error(c.EXMAPLES_MAP,this,{},f.Status.ERROR,!0);var s=new f.Status(f.Status.OK,"","",this);return r&&Object.keys(r).forEach(function(e){var u=r[e];if(void 0!==u){var l=null!=u&&"object"==typeof u&&u.hasOwnProperty("value");l&&Object.keys(u).forEach(function(n){if("("==n.charAt(0)&&")"==n.charAt(n.length-1)){var i=new b(n.substring(1,n.length-1),r[e][n],n,!0),a=i.validateSelf(t);p.setValidationPath(a,{name:"examples",child:{name:e,child:{name:n}}}),s.addSubStatus(a)}});var c=u;if(l&&(c=u.value,o(u,e,t,s,n.facetName()),u.strict===!1||u.strict&&"object"==typeof u.strict&&u.strict.value===!1))return;var f=c;if(!n.owner().isExternal()&&(f=i(c,n.owner()),f instanceof p.Status))return a(f,!l,e),void s.addSubStatus(f);var h=n.owner().validate(f,!0,!1);h.getErrors().forEach(function(t){s.addSubStatus(t),a(t,!l,e)})}}),s},t.prototype.kind=function(){return v.MetaInformationKind.Examples},t}(g);t.Examples=O;var D=function(e){function t(t){return e.call(this,"xml",t)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.XMLInfo},t}(g);t.XMLInfo=D;var U=function(e){function t(t){return e.call(this,"default",t)||this}return l(t,e),t.prototype.validateSelfIndividual=function(e,t){var n=this,r=this.owner().validateDirect(this.value(),!0);if(!r.isOk()){var i=p.error(c.INVALID_DEFAULT_VALUE,this,{msg:r.getMessage()});r.getErrors().forEach(function(e){i.addSubStatus(e),p.setValidationPath(e,{name:n.facetName()})}),e.addSubStatus(i)}return e},t.prototype.kind=function(){return v.MetaInformationKind.Default},t}(g);t.Default=U;var x=function(e){function t(t){return e.call(this,"schemaPath",t,!0)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.SchemaPath},t}(g);t.SchemaPath=x;var k=function(e){function t(t){return e.call(this,"sourceMap",t)||this}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_SourceMap)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_SourceMap)},t.prototype.kind=function(){return v.MetaInformationKind.SourceMap},t.CLASS_IDENTIFIER_SourceMap="metainfo.SourceMap",t}(g);t.SourceMap=k;var F=function(e){function t(t){return e.call(this,"typeAttributeValue",t)||this}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_TypeAttributeValue)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_TypeAttributeValue)},t.prototype.kind=function(){return v.MetaInformationKind.TypeAttributeValue},t.CLASS_IDENTIFIER_TypeAttributeValue="metainfo.TypeAttributeValue",t}(g);t.TypeAttributeValue=F;var B=function(e){function t(t){return e.call(this,"__METADATA__",t)||this}return l(t,e),t.prototype.kind=function(){return v.MetaInformationKind.ParserMetadata},t}(g);t.ParserMetadata=B;var V=function(e){function t(t){var n=e.call(this,!0)||this;return n.property=t,n}return l(t,e),t.prototype.requiredType=function(){return p.OBJECT},t.prototype.value=function(){return this.property},t.prototype.facetName=function(){return"discriminator"},t.prototype.validateSelfIndividual=function(e,t){var n=this;if(this.owner().isUnion())e=p.error(c.DISCRIMINATOR_FOR_UNION,this);else if(this.owner().isSubTypeOf(p.OBJECT))if(this.owner().getExtra(p.GLOBAL)===!1)e=p.error(c.DISCRIMINATOR_FOR_INLINE,this);else{var r=m.find(this.owner().meta(),function(e){return e instanceof h.PropertyIs&&e.propertyName()==n.value()});r?r.value().isScalar()||(e=p.error(c.SCALAR_FOR_DISCRIMINATOR,this)):e=p.error(c.UNKNOWN_FOR_DISCRIMINATOR,this,{value:this.value()},p.Status.WARNING)}else e=p.error(c.DISCRIMINATOR_FOR_OBJECT,this);return e.getValidationPath()||p.setValidationPath(e,{name:this.facetName()}),e},t.prototype.kind=function(){return v.MetaInformationKind.Discriminator},t}(p.TypeInformation);t.Discriminator=V;var K=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,!1)||this;return r._value=t,r.strict=n,r._value&&"object"==typeof r._value&&("boolean"==typeof r._value.strict&&(r.strict=r._value.strict),r._value=r._value.value),r}return l(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_DiscriminatorValue)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&m.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_DiscriminatorValue)},t.prototype.check=function(e,n){var r=this.owner(),i=this.value(),a=r.metaOfType(V);if(0==a.length)return p.ok();var o=a[0].value();if(i){if(e.hasOwnProperty(o)){for(var s=this.owner().allSubTypes().concat(this.owner()),u={},l=0,c=s;l<c.length;l++){var h=c[l],d=h.metaOfType(t);d&&d.length>0&&d.forEach(function(e){return u[e.value()]=!0})}var m=e[o];if(!u[m]){var y=p.error(f.Status.CODE_INCORRECT_DISCRIMINATOR,this,{rootType:r.name(),value:m,propName:o},f.Status.WARNING);return p.setValidationPath(y,{name:o,child:n}),y}return p.ok()}var v=p.error(f.Status.CODE_MISSING_DISCRIMINATOR,this,{rootType:r.name(),propName:o});return p.setValidationPath(v,n),v}return p.ok()},t.prototype.facetName=function(){return"discriminatorValue"},t.prototype.validateSelfIndividual=function(e,t){if(this.strict){var n=this.owner().oneMeta(V);if(this.owner().isSubTypeOf(p.OBJECT))if(this.owner().getExtra(p.GLOBAL)===!1)e.addSubStatus(p.error(c.DISCRIMINATOR_FOR_INLINE,this));else if(n){var r=m.find(this.owner().meta(),function(e){return e instanceof h.PropertyIs&&e.propertyName()==n.value()});if(r){var i=r.value().validate(this.value());i.isOk()||e.addSubStatus(p.error(c.INVALID_DISCRIMINATOR_VALUE,this,{msg:i.getMessage()}))}}else e.addSubStatus(p.error(c.DISCRIMINATOR_VALUE_WITHOUT_DISCRIMINATOR,this));else e.addSubStatus(p.error(c.DISCRIMINATOR_FOR_OBJECT,this))}return e.getValidationPath()||p.setValidationPath(e,{name:this.facetName()}),e},t.prototype.requiredType=function(){return p.OBJECT},t.prototype.value=function(){return this._value},t.prototype.kind=function(){return v.MetaInformationKind.DiscriminatorValue},t.prototype.isStrict=function(){return this.strict},t.CLASS_IDENTIFIER_DiscriminatorValue="metainfo.DiscriminatorValue",t}(p.Constraint);t.DiscriminatorValue=K;var j=[{propName:"strict",propType:"boolean",messageEntry:c.STRICT_BOOLEAN},{propName:"displayName",propType:"string",messageEntry:c.DISPLAY_NAME_STRING},{propName:"description",propType:"string",messageEntry:c.DESCRIPTION_STRING}]},function(e,t,n){"use strict";function r(e,t,n,r){void 0===n&&(n=0),void 0===r&&(r=!0);for(var i="<"+e,a=0;a<n;a++)i="    "+i;return t&&Object.keys(t).length>0&&Object.keys(t).forEach(function(e){"string"==typeof t[e]&&(i=i+" "+e+'="'+t[e]+'"')}),i=i+">"+(r?"\n":"")}function i(e,t){void 0===t&&(t=0);for(var n="</"+e,r=0;r<t&&r>-1;r++)n="    "+n;var n=(t>-1?"\n":"")+n+">\n";return n}function a(e,t){t=h(t);var n=C(t),a=T(t),s=r(n,o(e,a)),u={};if(u[n]=e,t.isArray()){t.meta().filter(function(e){return e instanceof x.ComponentShouldBeOfType})[0];s+=p(u,t,1,!0)}else s+=l(e,a,1);var s=s+i(n);return s}function o(e,t){var n={},r=U.filter(t,function(e){return w(e.value()).attribute});return r.forEach(function(t){var r=t.propId(),i=M(t);e[r]&&(n[i]=e[r].toString())}),n}function s(e,t,n){var a=Object.keys(e)[0],p=e[a],c=null;if(t.isScalar()){var f=T(t);c=r(a,o(p,f),n,!t.isScalar())+p.toString()}else{if(t.isUnion())return s(e,u(p,t),n);var f=T(t);c=r(a,o(p,f),n,!t.isScalar())+l(p,f,n+1)}return c+=i(a,t.isScalar()?-1:n)}function u(e,t){var n=t.typeFamily(),r=[],i=null;return n.forEach(function(t){var n=a(e,t);if(n){var i=c(n,t);if(i){var o=f(i);r.push({type:t,errors:o&&o.length||0})}}}),i=r.length>0?r[0]:{type:n[0]},r.forEach(function(e){e.errors<i.errors&&(i=e)}),i.type}function l(e,t,n){var r=U.filter(t,function(e){return!w(e.value()).attribute}),i="";return r.forEach(function(t){var r=M(t),a=t.propId(),o={};o[r]=e[a],i+=t.value().isArray()?p(o,t.value(),n):e[a]||""===e[a]?s(o,t.value(),n):""}),i}function p(e,t,n,a){void 0===a&&(a=!1);var o=Object.keys(e)[0],u=e[o],l=w(t),p=a||l.wrapped,c="",f=R(t),h=f&&f.name(),d=n;return p&&!a&&(c=r(o,null,n),d+=1),u&&L(u)&&u.forEach(function(e){var t={};t[p?h:o]=e,c+=s(t,f,d)}),p&&(c+=i(o,n)),c}function c(e,t){var n=null,r={};return r.explicitChildren=!1,r.explicitArray=!1,r.explicitRoot=m(t)||!t.isExternal(),O.parseString(e,r,function(e,t){if(n=t,e)throw new Error}),n=m(t)?n:v(n,h(t))}function f(e){var t=e[B];return delete e[B],t&&0!==t.length?t.map(function(e){return new F.Status(F.Status.ERROR,"",e,{})}):null}function h(e){return e&&d(e)&&e.superTypes()&&0!==e.superTypes().length?1===e.superTypes().length?e.superTypes()[0]:U.find(e.allSuperTypes(),function(e){return"object"===e.name()})||e:e}function d(e){return!!e&&!!U.find(V,function(t){return e.name()===t})}function m(e){return!!y(e)||!!U.find(e.allSuperTypes(),function(e){return y(e)})}function y(e){return!(!e.isExternal()||!e._content||"string"!=typeof e._content||0!==e._content.trim().indexOf("<"))}function v(e,t){var n,r=Object.keys(e)[0],i=e[r],a=[];C(t);if(t.isArray()){var o=[],s=[],u=t.meta().filter(function(e){return e instanceof x.ComponentShouldBeOfType})[0],l=u&&u.value().name();s.push(l),n=I(i,t,a,!0),_(i,a,o,s)}else n=E(i,t.isUnion()?A(i,t):t,a);return n[B]=a,n}function g(e,t){var n,r=[];n=E(e,t,r);var i=t.validateDirect(n,!0,!1).getErrors();return r.length+(i&&i.length)}function A(e,t){var n=[];if(t.typeFamily().forEach(function(t){return n.push({type:t,errors:g(JSON.parse(JSON.stringify(e)),t)})}),0===n.length)return t;var r=n[0];return n.forEach(function(e){e.errors<r.errors&&(r=e)}),r.type}function E(e,t,n){var r={};if(!t)return e;if(t.isScalar())return P(t,e,n);if(t.isUnion())return E(e,A(e,t),n);var i=T(t),a=[],o=[];return S(e,i,a).forEach(function(e){return r[Object.keys(e)[0]]=e[Object.keys(e)[0]]}),N(e,i,o,n).forEach(function(e){return r[Object.keys(e)[0]]=e[Object.keys(e)[0]]}),_(e,n,a,o),r}function _(e,n,r,i,a){if(void 0===a&&(a=!1),"object"==typeof e){e.$||(e.$={}),r.forEach(function(t){delete e.$[t]}),i.forEach(function(t){delete e[t]});var o=Object.keys(e.$);delete e.$;var s=Object.keys(e);o.forEach(function(e){n.push(D.error(t.messageRegistry.UNEXPECTED_XML_ATTRIBUTE,null,{name:e}).getMessage())}),s.forEach(function(r){var i;i="_"==r&&"string"==typeof e[r]?D.error(t.messageRegistry.TEXT_CONTENT_NOT_ALLOWED_FOR_THE_XML_ELEMENT,null).getMessage():D.error(t.messageRegistry.UNEXPECTED_XML_ELEMENT,null,{name:r}).getMessage(),n.push(i),a&&delete e[r]})}}function T(e){return e.meta().filter(function(e){return e instanceof x.PropertyIs}).map(function(e){return e})||[]}function S(e,t,n){var r=e.$;if(!r)return[];var i=U.filter(t,function(e){return w(e.value()).attribute});return i.map(function(e){var t={},i=e.propId(),a=M(e);n.push(a);var o=r[a];return t[i]=P(e.value(),o),null===t[i]?null:t}).filter(function(e){return e})}function N(e,t,n,r){var i=U.filter(t,function(e){return!w(e.value()).attribute});return i.map(function(t){var i={},a=(w(t.value()),t.propId()),o=M(t);n.push(o);var s=e[o];return t.value().isArray()?i[a]=I(e[o],t.value(),r):i[a]=s||""===s?E(s,t.value(),r):null,null===i[a]?null:i}).filter(function(e){return e})}function I(e,t,n,r){void 0===r&&(r=!1);var i=w(t),a=r||i.wrapped,o=R(t),s=o&&o.name();if(a){var u=e;e=e&&e[s],_(u,n,[],[s],!0)}return e?(e=b(e),e=L(e)?e.map(function(e){return E(e,o,n)}):"object"==typeof e&&e||[]):[]}function b(e){return L(e)?e:"object"==typeof e?[e]:[]}function R(e){if(!e||!e.isArray())return null;var t=e.meta().filter(function(e){return e instanceof x.ComponentShouldBeOfType});return t&&t.length>0&&t[0].value()}function M(e){var t=w(e.value()),n=e.propId(),r=t.name||n;return t.namespace&&(r=t.namespace+":"+r),(t.prefix||"")+r}function C(e){var t=w(e),n=e.name();""===n&&e.isUnion()&&(n="object");var r=t.name||n;return(t.prefix||"")+r;
}function w(e){var t=e.meta().filter(function(e){return e instanceof k.XMLInfo}).map(function(e){return e})[0],n={attribute:!1,wrapped:!1,name:!1,namespace:!1,prefix:!1};if(!t)return n;var r=t.value();return r?(Object.keys(n).forEach(function(e){n[e]=r[e]||n[e]}),n):n}function P(e,t,n){if(void 0===n&&(n=[]),"object"==typeof t){var r=P(e,t._);return delete t._,_(t,n,[],[],!0),r}if(!t&&""!==t.trim())return null;if(e.isNumber()){var i=parseFloat(t);if(!isNaN(i))return i}if(e.isBoolean()){if("true"===t)return!0;if("false"===t)return!1}return"string"==typeof t?t:null}function L(e){return!!e&&("object"==typeof e&&"number"==typeof e.length)}Object.defineProperty(t,"__esModule",{value:!0});var O=n(79),D=n(58),U=n(59),x=n(75),k=n(77),F=n(58);t.messageRegistry=n(72);var B="@unexpected_root_attributes_and_elements",V=["application/x-www-form-urlencoded","application/json","application/xml","multipart/form-data"];t.serializeToXML=a,t.readObject=c,t.getXmlErrors=f},function(e,t,n){(function(){"use strict";var e,r,i,a,o=function(e,t){function n(){this.constructor=e}for(var r in t)s.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},s={}.hasOwnProperty;r=n(80),e=n(81),i=n(104),a=n(134),t.defaults=r.defaults,t.processors=a,t.ValidationError=function(e){function t(e){this.message=e}return o(t,e),t}(Error),t.Builder=e.Builder,t.Parser=i.Parser,t.parseString=i.parseString}).call(this)},function(e,t){(function(){t.defaults={.1:{explicitCharkey:!1,trim:!0,normalize:!0,normalizeTags:!1,attrkey:"@",charkey:"#",explicitArray:!1,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!1,validator:null,xmlns:!1,explicitChildren:!1,childkey:"@@",charsAsChildren:!1,includeWhiteChars:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,emptyTag:""},.2:{explicitCharkey:!1,trim:!1,normalize:!1,normalizeTags:!1,attrkey:"$",charkey:"_",explicitArray:!0,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!0,validator:null,xmlns:!1,explicitChildren:!1,preserveChildrenOrder:!1,childkey:"$$",charsAsChildren:!1,includeWhiteChars:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,rootName:"root",xmldec:{version:"1.0",encoding:"UTF-8",standalone:!0},doctype:null,renderOpts:{pretty:!0,indent:"  ",newline:"\n"},headless:!1,chunkSize:1e4,emptyTag:"",cdata:!1}}}).call(this)},function(e,t,n){(function(){"use strict";var e,r,i,a,o,s={}.hasOwnProperty;e=n(82),r=n(80).defaults,a=function(e){return"string"==typeof e&&(e.indexOf("&")>=0||e.indexOf(">")>=0||e.indexOf("<")>=0)},o=function(e){return"<![CDATA["+i(e)+"]]>"},i=function(e){return e.replace("]]>","]]]]><![CDATA[>")},t.Builder=function(){function t(e){var t,n,i;this.options={},n=r[.2];for(t in n)s.call(n,t)&&(i=n[t],this.options[t]=i);for(t in e)s.call(e,t)&&(i=e[t],this.options[t]=i)}return t.prototype.buildObject=function(t){var n,i,u,l,p;return n=this.options.attrkey,i=this.options.charkey,1===Object.keys(t).length&&this.options.rootName===r[.2].rootName?(p=Object.keys(t)[0],t=t[p]):p=this.options.rootName,u=function(e){return function(t,r){var l,p,c,f,h,d;if("object"!=typeof r)e.options.cdata&&a(r)?t.raw(o(r)):t.txt(r);else if(Array.isArray(r)){for(f in r)if(s.call(r,f)){p=r[f];for(h in p)c=p[h],t=u(t.ele(h),c).up()}}else for(h in r)if(s.call(r,h))if(p=r[h],h===n){if("object"==typeof p)for(l in p)d=p[l],t=t.att(l,d)}else if(h===i)t=e.options.cdata&&a(p)?t.raw(o(p)):t.txt(p);else if(Array.isArray(p))for(f in p)s.call(p,f)&&(c=p[f],t="string"==typeof c?e.options.cdata&&a(c)?t.ele(h).raw(o(c)).up():t.ele(h,c).up():u(t.ele(h),c).up());else"object"==typeof p?t=u(t.ele(h),p).up():"string"==typeof p&&e.options.cdata&&a(p)?t=t.ele(h).raw(o(p)).up():(null==p&&(p=""),t=t.ele(h,p.toString()).up());return t}}(this),l=e.create(p,this.options.xmldec,this.options.doctype,{headless:this.options.headless,allowSurrogateChars:this.options.allowSurrogateChars}),u(l,t).end(this.options.renderOpts)},t}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u;u=n(83),o=u.assign,s=u.isFunction,t=n(84),r=n(102),a=n(100),i=n(103),e.exports.create=function(e,n,r,i){var a,s;if(null==e)throw new Error("Root element needs a name");return i=o({},n,r,i),a=new t(i),s=a.element(e),i.headless||(a.declaration(i),null==i.pubID&&null==i.sysID||a.doctype(i)),s},e.exports.begin=function(e,n,i){var a;return s(e)&&(a=[e,n],n=a[0],i=a[1],e={}),n?new r(e,n,i):new t(e)},e.exports.stringWriter=function(e){return new a(e)},e.exports.streamWriter=function(e,t){return new i(e,t)}}).call(this)},function(e,t){(function(){var t,n,r,i,a,o,s=[].slice,u={}.hasOwnProperty;t=function(){var e,t,n,r,a,o;if(o=arguments[0],a=2<=arguments.length?s.call(arguments,1):[],i(Object.assign))Object.assign.apply(null,arguments);else for(e=0,n=a.length;e<n;e++)if(r=a[e],null!=r)for(t in r)u.call(r,t)&&(o[t]=r[t]);return o},i=function(e){return!!e&&"[object Function]"===Object.prototype.toString.call(e)},a=function(e){var t;return!!e&&("function"==(t=typeof e)||"object"===t)},n=function(e){return i(Array.isArray)?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e)},r=function(e){var t;if(n(e))return!e.length;for(t in e)if(u.call(e,t))return!1;return!0},o=function(e){var t,n;return a(e)&&(n=Object.getPrototypeOf(e))&&(t=n.constructor)&&"function"==typeof t&&t instanceof t&&Function.prototype.toString.call(t)===Function.prototype.toString.call(Object)},e.exports.assign=t,e.exports.isFunction=i,e.exports.isObject=a,e.exports.isArray=n,e.exports.isEmpty=r,e.exports.isPlainObject=o}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s=function(e,t){function n(){this.constructor=e}for(var r in t)u.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},u={}.hasOwnProperty;o=n(83).isPlainObject,r=n(85),a=n(99),i=n(100),e.exports=t=function(e){function t(e){t.__super__.constructor.call(this,null),e||(e={}),e.writer||(e.writer=new i),this.options=e,this.stringify=new a(e),this.isDocument=!0}return s(t,e),t.prototype.end=function(e){var t;return e?o(e)&&(t=e,e=this.options.writer.set(t)):e=this.options.writer,e.document(this)},t.prototype.toString=function(e){return this.options.writer.set(e).document(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p,c,f,h,d,m={}.hasOwnProperty;d=n(83),h=d.isObject,f=d.isFunction,c=d.isEmpty,o=null,t=null,r=null,i=null,a=null,l=null,p=null,u=null,e.exports=s=function(){function e(e){this.parent=e,this.parent&&(this.options=this.parent.options,this.stringify=this.parent.stringify),this.children=[],o||(o=n(86),t=n(88),r=n(89),i=n(90),a=n(91),l=n(96),p=n(97),u=n(98))}return e.prototype.element=function(e,t,n){var r,i,a,o,s,u,l,p,d,y;if(u=null,null==t&&(t={}),t=t.valueOf(),h(t)||(d=[t,n],n=d[0],t=d[1]),null!=e&&(e=e.valueOf()),Array.isArray(e))for(a=0,l=e.length;a<l;a++)i=e[a],u=this.element(i);else if(f(e))u=this.element(e.apply());else if(h(e)){for(s in e)if(m.call(e,s))if(y=e[s],f(y)&&(y=y.apply()),h(y)&&c(y)&&(y=null),!this.options.ignoreDecorators&&this.stringify.convertAttKey&&0===s.indexOf(this.stringify.convertAttKey))u=this.attribute(s.substr(this.stringify.convertAttKey.length),y);else if(!this.options.separateArrayItems&&Array.isArray(y))for(o=0,p=y.length;o<p;o++)i=y[o],r={},r[s]=i,u=this.element(r);else h(y)?(u=this.element(s),u.element(y)):u=this.element(s,y)}else u=!this.options.ignoreDecorators&&this.stringify.convertTextKey&&0===e.indexOf(this.stringify.convertTextKey)?this.text(n):!this.options.ignoreDecorators&&this.stringify.convertCDataKey&&0===e.indexOf(this.stringify.convertCDataKey)?this.cdata(n):!this.options.ignoreDecorators&&this.stringify.convertCommentKey&&0===e.indexOf(this.stringify.convertCommentKey)?this.comment(n):!this.options.ignoreDecorators&&this.stringify.convertRawKey&&0===e.indexOf(this.stringify.convertRawKey)?this.raw(n):!this.options.ignoreDecorators&&this.stringify.convertPIKey&&0===e.indexOf(this.stringify.convertPIKey)?this.instruction(e.substr(this.stringify.convertPIKey.length),n):this.node(e,t,n);if(null==u)throw new Error("Could not create any elements with: "+e);return u},e.prototype.insertBefore=function(e,t,n){var r,i,a;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),a=this.parent.children.splice(i),r=this.parent.element(e,t,n),Array.prototype.push.apply(this.parent.children,a),r},e.prototype.insertAfter=function(e,t,n){var r,i,a;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),a=this.parent.children.splice(i+1),r=this.parent.element(e,t,n),Array.prototype.push.apply(this.parent.children,a),r},e.prototype.remove=function(){var e,t;if(this.isRoot)throw new Error("Cannot remove the root element");return e=this.parent.children.indexOf(this),[].splice.apply(this.parent.children,[e,e-e+1].concat(t=[])),t,this.parent},e.prototype.node=function(e,t,n){var r,i;return null!=e&&(e=e.valueOf()),t||(t={}),t=t.valueOf(),h(t)||(i=[t,n],n=i[0],t=i[1]),r=new o(this,e,t),null!=n&&r.text(n),this.children.push(r),r},e.prototype.text=function(e){var t;return t=new p(this,e),this.children.push(t),this},e.prototype.cdata=function(e){var n;return n=new t(this,e),this.children.push(n),this},e.prototype.comment=function(e){var t;return t=new r(this,e),this.children.push(t),this},e.prototype.commentBefore=function(e){var t,n,r;return n=this.parent.children.indexOf(this),r=this.parent.children.splice(n),t=this.parent.comment(e),Array.prototype.push.apply(this.parent.children,r),this},e.prototype.commentAfter=function(e){var t,n,r;return n=this.parent.children.indexOf(this),r=this.parent.children.splice(n+1),t=this.parent.comment(e),Array.prototype.push.apply(this.parent.children,r),this},e.prototype.raw=function(e){var t;return t=new l(this,e),this.children.push(t),this},e.prototype.instruction=function(e,t){var n,r,i,a,o;if(null!=e&&(e=e.valueOf()),null!=t&&(t=t.valueOf()),Array.isArray(e))for(a=0,o=e.length;a<o;a++)n=e[a],this.instruction(n);else if(h(e))for(n in e)m.call(e,n)&&(r=e[n],this.instruction(n,r));else f(t)&&(t=t.apply()),i=new u(this,e,t),this.children.push(i);return this},e.prototype.instructionBefore=function(e,t){var n,r,i;return r=this.parent.children.indexOf(this),i=this.parent.children.splice(r),n=this.parent.instruction(e,t),Array.prototype.push.apply(this.parent.children,i),this},e.prototype.instructionAfter=function(e,t){var n,r,i;return r=this.parent.children.indexOf(this),i=this.parent.children.splice(r+1),n=this.parent.instruction(e,t),Array.prototype.push.apply(this.parent.children,i),this},e.prototype.declaration=function(e,t,n){var r,a;return r=this.document(),a=new i(r,e,t,n),r.children[0]instanceof i?r.children[0]=a:r.children.unshift(a),r.root()||r},e.prototype.doctype=function(e,t){var n,r,i,o,s,u,l,p,c,f;for(r=this.document(),i=new a(r,e,t),c=r.children,o=s=0,l=c.length;s<l;o=++s)if(n=c[o],n instanceof a)return r.children[o]=i,i;for(f=r.children,o=u=0,p=f.length;u<p;o=++u)if(n=f[o],n.isRoot)return r.children.splice(o,0,i),i;return r.children.push(i),i},e.prototype.up=function(){if(this.isRoot)throw new Error("The root node has no parent. Use doc() if you need to get the document object.");return this.parent},e.prototype.root=function(){var e;for(e=this;e;){if(e.isDocument)return e.rootObject;if(e.isRoot)return e;e=e.parent}},e.prototype.document=function(){var e;for(e=this;e;){if(e.isDocument)return e;e=e.parent}},e.prototype.end=function(e){return this.document().end(e)},e.prototype.prev=function(){var e;if(e=this.parent.children.indexOf(this),e<1)throw new Error("Already at the first node");return this.parent.children[e-1]},e.prototype.next=function(){var e;if(e=this.parent.children.indexOf(this),e===-1||e===this.parent.children.length-1)throw new Error("Already at the last node");return this.parent.children[e+1]},e.prototype.importDocument=function(e){var t;return t=e.root().clone(),t.parent=this,t.isRoot=!1,this.children.push(t),this},e.prototype.ele=function(e,t,n){return this.element(e,t,n)},e.prototype.nod=function(e,t,n){return this.node(e,t,n)},e.prototype.txt=function(e){return this.text(e)},e.prototype.dat=function(e){return this.cdata(e)},e.prototype.com=function(e){return this.comment(e)},e.prototype.ins=function(e,t){return this.instruction(e,t)},e.prototype.doc=function(){return this.document()},e.prototype.dec=function(e,t,n){return this.declaration(e,t,n)},e.prototype.dtd=function(e,t){return this.doctype(e,t)},e.prototype.e=function(e,t,n){return this.element(e,t,n)},e.prototype.n=function(e,t,n){return this.node(e,t,n)},e.prototype.t=function(e){return this.text(e)},e.prototype.d=function(e){return this.cdata(e)},e.prototype.c=function(e){return this.comment(e)},e.prototype.r=function(e){return this.raw(e)},e.prototype.i=function(e,t){return this.instruction(e,t)},e.prototype.u=function(){return this.up()},e.prototype.importXMLBuilder=function(e){return this.importDocument(e)},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u=function(e,t){function n(){this.constructor=e}for(var r in t)l.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},l={}.hasOwnProperty;s=n(83),o=s.isObject,a=s.isFunction,i=n(85),t=n(87),e.exports=r=function(e){function n(e,t,r){if(n.__super__.constructor.call(this,e),null==t)throw new Error("Missing element name");this.name=this.stringify.eleName(t),this.attributes={},null!=r&&this.attribute(r),e.isDocument&&(this.isRoot=!0,this.documentObject=e,e.rootObject=this)}return u(n,e),n.prototype.clone=function(){var e,t,n,r;n=Object.create(this),n.isRoot&&(n.documentObject=null),n.attributes={},r=this.attributes;for(t in r)l.call(r,t)&&(e=r[t],n.attributes[t]=e.clone());return n.children=[],this.children.forEach(function(e){var t;return t=e.clone(),t.parent=n,n.children.push(t)}),n},n.prototype.attribute=function(e,n){var r,i;if(null!=e&&(e=e.valueOf()),o(e))for(r in e)l.call(e,r)&&(i=e[r],this.attribute(r,i));else a(n)&&(n=n.apply()),this.options.skipNullAttributes&&null==n||(this.attributes[e]=new t(this,e,n));return this},n.prototype.removeAttribute=function(e){var t,n,r;if(null==e)throw new Error("Missing attribute name");if(e=e.valueOf(),Array.isArray(e))for(n=0,r=e.length;n<r;n++)t=e[n],delete this.attributes[t];else delete this.attributes[e];return this},n.prototype.toString=function(e){return this.options.writer.set(e).element(this)},n.prototype.att=function(e,t){return this.attribute(e,t)},n.prototype.a=function(e,t){return this.attribute(e,t)},n}(i)}).call(this)},function(e,t){(function(){var t;e.exports=t=function(){function e(e,t,n){if(this.options=e.options,this.stringify=e.stringify,null==t)throw new Error("Missing attribute name of element "+e.name);if(null==n)throw new Error("Missing attribute value for attribute "+t+" of element "+e.name);this.name=this.stringify.attName(t),this.value=this.stringify.attValue(n)}return e.prototype.clone=function(){return Object.create(this)},e.prototype.toString=function(e){return this.options.writer.set(e).attribute(this)},e}()}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;r=n(85),e.exports=t=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing CDATA text");this.text=this.stringify.cdata(n)}return i(t,e),t.prototype.clone=function(){return Object.create(this)},t.prototype.toString=function(e){return this.options.writer.set(e).cdata(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;r=n(85),e.exports=t=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing comment text");this.text=this.stringify.comment(n)}return i(t,e),t.prototype.clone=function(){return Object.create(this)},t.prototype.toString=function(e){return this.options.writer.set(e).comment(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i,a=function(e,t){function n(){this.constructor=e}for(var r in t)o.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},o={}.hasOwnProperty;i=n(83).isObject,r=n(85),e.exports=t=function(e){function t(e,n,r,a){var o;t.__super__.constructor.call(this,e),i(n)&&(o=n,n=o.version,r=o.encoding,a=o.standalone),n||(n="1.0"),this.version=this.stringify.xmlVersion(n),null!=r&&(this.encoding=this.stringify.xmlEncoding(r)),null!=a&&(this.standalone=this.stringify.xmlStandalone(a))}return a(t,e),t.prototype.toString=function(e){return this.options.writer.set(e).declaration(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l=function(e,t){function n(){this.constructor=e}for(var r in t)p.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},p={}.hasOwnProperty;u=n(83).isObject,s=n(85),t=n(92),i=n(93),r=n(94),a=n(95),e.exports=o=function(e){function n(e,t,r){var i,a;n.__super__.constructor.call(this,e),this.documentObject=e,u(t)&&(i=t,t=i.pubID,r=i.sysID),null==r&&(a=[t,r],r=a[0],t=a[1]),null!=t&&(this.pubID=this.stringify.dtdPubID(t)),null!=r&&(this.sysID=this.stringify.dtdSysID(r))}return l(n,e),n.prototype.element=function(e,t){var n;return n=new r(this,e,t),this.children.push(n),this},n.prototype.attList=function(e,n,r,i,a){var o;return o=new t(this,e,n,r,i,a),this.children.push(o),this},n.prototype.entity=function(e,t){var n;return n=new i(this,!1,e,t),this.children.push(n),this},n.prototype.pEntity=function(e,t){var n;return n=new i(this,!0,e,t),this.children.push(n),this},n.prototype.notation=function(e,t){var n;return n=new a(this,e,t),this.children.push(n),this},n.prototype.toString=function(e){return this.options.writer.set(e).docType(this)},n.prototype.ele=function(e,t){return this.element(e,t)},n.prototype.att=function(e,t,n,r,i){return this.attList(e,t,n,r,i)},n.prototype.ent=function(e,t){return this.entity(e,t)},n.prototype.pent=function(e,t){return this.pEntity(e,t)},n.prototype.not=function(e,t){return this.notation(e,t)},n.prototype.up=function(){return this.root()||this.documentObject},n}(s)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;r=n(85),e.exports=t=function(e){function t(e,n,r,i,a,o){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing DTD element name");if(null==r)throw new Error("Missing DTD attribute name");if(!i)throw new Error("Missing DTD attribute type");if(!a)throw new Error("Missing DTD attribute default");if(0!==a.indexOf("#")&&(a="#"+a),!a.match(/^(#REQUIRED|#IMPLIED|#FIXED|#DEFAULT)$/))throw new Error("Invalid default value type; expected: #REQUIRED, #IMPLIED, #FIXED or #DEFAULT");if(o&&!a.match(/^(#FIXED|#DEFAULT)$/))throw new Error("Default value only applies to #FIXED or #DEFAULT");this.elementName=this.stringify.eleName(n),this.attributeName=this.stringify.attName(r),this.attributeType=this.stringify.dtdAttType(i),this.defaultValue=this.stringify.dtdAttDefault(o),this.defaultValueType=a}return i(t,e),t.prototype.toString=function(e){return this.options.writer.set(e).dtdAttList(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i,a=function(e,t){function n(){this.constructor=e}for(var r in t)o.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},o={}.hasOwnProperty;i=n(83).isObject,r=n(85),e.exports=t=function(e){function t(e,n,r,a){if(t.__super__.constructor.call(this,e),null==r)throw new Error("Missing entity name");if(null==a)throw new Error("Missing entity value");if(this.pe=!!n,this.name=this.stringify.eleName(r),i(a)){if(!a.pubID&&!a.sysID)throw new Error("Public and/or system identifiers are required for an external entity");if(a.pubID&&!a.sysID)throw new Error("System identifier is required for a public external entity");if(null!=a.pubID&&(this.pubID=this.stringify.dtdPubID(a.pubID)),null!=a.sysID&&(this.sysID=this.stringify.dtdSysID(a.sysID)),null!=a.nData&&(this.nData=this.stringify.dtdNData(a.nData)),this.pe&&this.nData)throw new Error("Notation declaration is not allowed in a parameter entity")}else this.value=this.stringify.dtdEntityValue(a)}return a(t,e),t.prototype.toString=function(e){return this.options.writer.set(e).dtdEntity(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;r=n(85),e.exports=t=function(e){function t(e,n,r){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing DTD element name");r||(r="(#PCDATA)"),Array.isArray(r)&&(r="("+r.join(",")+")"),this.name=this.stringify.eleName(n),this.value=this.stringify.dtdElementValue(r)}return i(t,e),t.prototype.toString=function(e){return this.options.writer.set(e).dtdElement(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;r=n(85),e.exports=t=function(e){function t(e,n,r){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing notation name");if(!r.pubID&&!r.sysID)throw new Error("Public or system identifiers are required for an external entity");this.name=this.stringify.eleName(n),null!=r.pubID&&(this.pubID=this.stringify.dtdPubID(r.pubID)),null!=r.sysID&&(this.sysID=this.stringify.dtdSysID(r.sysID))}return i(t,e),t.prototype.toString=function(e){return this.options.writer.set(e).dtdNotation(this)},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;t=n(85),e.exports=r=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing raw text");this.value=this.stringify.raw(n)}return i(t,e),t.prototype.clone=function(){return Object.create(this)},t.prototype.toString=function(e){return this.options.writer.set(e).raw(this)},t}(t)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;t=n(85),e.exports=r=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing element text");this.value=this.stringify.eleText(n)}return i(t,e),t.prototype.clone=function(){return Object.create(this)},t.prototype.toString=function(e){return this.options.writer.set(e).text(this)},t}(t)}).call(this)},function(e,t,n){(function(){var t,r,i=function(e,t){function n(){this.constructor=e}for(var r in t)a.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;t=n(85),e.exports=r=function(e){function t(e,n,r){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing instruction target");this.target=this.stringify.insTarget(n),r&&(this.value=this.stringify.insValue(r))}return i(t,e),t.prototype.clone=function(){return Object.create(this)},t.prototype.toString=function(e){return this.options.writer.set(e).processingInstruction(this)},t}(t)}).call(this)},function(e,t){(function(){var t,n=function(e,t){return function(){return e.apply(t,arguments)}},r={}.hasOwnProperty;e.exports=t=function(){function e(e){this.assertLegalChar=n(this.assertLegalChar,this);var t,i,a;e||(e={}),this.noDoubleEncoding=e.noDoubleEncoding,i=e.stringify||{};for(t in i)r.call(i,t)&&(a=i[t],this[t]=a)}return e.prototype.eleName=function(e){return e=""+e||"",this.assertLegalChar(e)},e.prototype.eleText=function(e){return e=""+e||"",this.assertLegalChar(this.elEscape(e))},e.prototype.cdata=function(e){return e=""+e||"",e=e.replace("]]>","]]]]><![CDATA[>"),this.assertLegalChar(e)},e.prototype.comment=function(e){if(e=""+e||"",e.match(/--/))throw new Error("Comment text cannot contain double-hypen: "+e);return this.assertLegalChar(e)},e.prototype.raw=function(e){return""+e||""},e.prototype.attName=function(e){return e=""+e||""},e.prototype.attValue=function(e){return e=""+e||"",this.attEscape(e)},e.prototype.insTarget=function(e){return""+e||""},e.prototype.insValue=function(e){if(e=""+e||"",e.match(/\?>/))throw new Error("Invalid processing instruction value: "+e);return e},e.prototype.xmlVersion=function(e){if(e=""+e||"",!e.match(/1\.[0-9]+/))throw new Error("Invalid version number: "+e);return e},e.prototype.xmlEncoding=function(e){if(e=""+e||"",!e.match(/^[A-Za-z](?:[A-Za-z0-9._-]|-)*$/))throw new Error("Invalid encoding: "+e);return e},e.prototype.xmlStandalone=function(e){return e?"yes":"no"},e.prototype.dtdPubID=function(e){return""+e||""},e.prototype.dtdSysID=function(e){return""+e||""},e.prototype.dtdElementValue=function(e){return""+e||""},e.prototype.dtdAttType=function(e){return""+e||""},e.prototype.dtdAttDefault=function(e){return null!=e?""+e||"":e},e.prototype.dtdEntityValue=function(e){return""+e||""},e.prototype.dtdNData=function(e){return""+e||""},e.prototype.convertAttKey="@",e.prototype.convertPIKey="?",e.prototype.convertTextKey="#text",e.prototype.convertCDataKey="#cdata",e.prototype.convertCommentKey="#comment",e.prototype.convertRawKey="#raw",e.prototype.assertLegalChar=function(e){var t;if(t=e.match(/[\0\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/))throw new Error("Invalid character in string: "+e+" at index "+t.index);return e},e.prototype.elEscape=function(e){var t;return t=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,e.replace(t,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\r/g,"&#xD;")},e.prototype.attEscape=function(e){var t;return t=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,e.replace(t,"&amp;").replace(/</g,"&lt;").replace(/"/g,"&quot;").replace(/\t/g,"&#x9;").replace(/\n/g,"&#xA;").replace(/\r/g,"&#xD;")},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p,c,f,h,d,m,y=function(e,t){function n(){this.constructor=e}for(var r in t)v.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},v={}.hasOwnProperty;u=n(90),l=n(91),t=n(88),r=n(89),p=n(86),f=n(96),d=n(97),c=n(98),i=n(92),a=n(94),o=n(93),s=n(95),m=n(101),e.exports=h=function(e){function n(e){n.__super__.constructor.call(this,e)}return y(n,e),n.prototype.document=function(e){var t,n,i,a,o;for(this.textispresent=!1,a="",o=e.children,n=0,i=o.length;n<i;n++)t=o[n],a+=function(){switch(!1){case!(t instanceof u):return this.declaration(t);case!(t instanceof l):return this.docType(t);case!(t instanceof r):return this.comment(t);case!(t instanceof c):return this.processingInstruction(t);default:return this.element(t,0)}}.call(this);return this.pretty&&a.slice(-this.newline.length)===this.newline&&(a=a.slice(0,-this.newline.length)),a},n.prototype.attribute=function(e){return" "+e.name+'="'+e.value+'"'},n.prototype.cdata=function(e,t){return this.space(t)+"<![CDATA["+e.text+"]]>"+this.newline},n.prototype.comment=function(e,t){return this.space(t)+"<!-- "+e.text+" -->"+this.newline},n.prototype.declaration=function(e,t){var n;return n=this.space(t),n+='<?xml version="'+e.version+'"',null!=e.encoding&&(n+=' encoding="'+e.encoding+'"'),null!=e.standalone&&(n+=' standalone="'+e.standalone+'"'),n+=this.spacebeforeslash+"?>",n+=this.newline},n.prototype.docType=function(e,n){var u,l,p,f,h;if(n||(n=0),f=this.space(n),f+="<!DOCTYPE "+e.root().name,e.pubID&&e.sysID?f+=' PUBLIC "'+e.pubID+'" "'+e.sysID+'"':e.sysID&&(f+=' SYSTEM "'+e.sysID+'"'),e.children.length>0){for(f+=" [",f+=this.newline,h=e.children,l=0,p=h.length;l<p;l++)u=h[l],f+=function(){switch(!1){case!(u instanceof i):return this.dtdAttList(u,n+1);case!(u instanceof a):return this.dtdElement(u,n+1);case!(u instanceof o):return this.dtdEntity(u,n+1);case!(u instanceof s):return this.dtdNotation(u,n+1);case!(u instanceof t):return this.cdata(u,n+1);case!(u instanceof r):return this.comment(u,n+1);case!(u instanceof c):return this.processingInstruction(u,n+1);default:throw new Error("Unknown DTD node type: "+u.constructor.name)}}.call(this);f+="]"}return f+=this.spacebeforeslash+">",f+=this.newline},n.prototype.element=function(e,n){var i,a,o,s,u,l,h,m,y,g,A,E,_;n||(n=0),_=!1,this.textispresent?(this.newline="",this.pretty=!1):(this.newline=this.newlinedefault,this.pretty=this.prettydefault),E=this.space(n),m="",m+=E+"<"+e.name,y=e.attributes;for(h in y)v.call(y,h)&&(i=y[h],m+=this.attribute(i));if(0===e.children.length||e.children.every(function(e){return""===e.value}))m+=this.allowEmpty?"></"+e.name+">"+this.newline:this.spacebeforeslash+"/>"+this.newline;else if(this.pretty&&1===e.children.length&&null!=e.children[0].value)m+=">",m+=e.children[0].value,m+="</"+e.name+">"+this.newline;else{if(this.dontprettytextnodes)for(g=e.children,o=0,u=g.length;o<u;o++)if(a=g[o],null!=a.value){this.textispresent++,_=!0;break}for(this.textispresent&&(this.newline="",this.pretty=!1,E=this.space(n)),m+=">"+this.newline,A=e.children,s=0,l=A.length;s<l;s++)a=A[s],m+=function(){switch(!1){case!(a instanceof t):return this.cdata(a,n+1);case!(a instanceof r):return this.comment(a,n+1);case!(a instanceof p):return this.element(a,n+1);case!(a instanceof f):return this.raw(a,n+1);case!(a instanceof d):return this.text(a,n+1);case!(a instanceof c):return this.processingInstruction(a,n+1);default:throw new Error("Unknown XML node type: "+a.constructor.name)}}.call(this);_&&this.textispresent--,this.textispresent||(this.newline=this.newlinedefault,this.pretty=this.prettydefault),m+=E+"</"+e.name+">"+this.newline}return m},n.prototype.processingInstruction=function(e,t){var n;return n=this.space(t)+"<?"+e.target,e.value&&(n+=" "+e.value),n+=this.spacebeforeslash+"?>"+this.newline},n.prototype.raw=function(e,t){return this.space(t)+e.value+this.newline},n.prototype.text=function(e,t){return this.space(t)+e.value+this.newline},n.prototype.dtdAttList=function(e,t){var n;return n=this.space(t)+"<!ATTLIST "+e.elementName+" "+e.attributeName+" "+e.attributeType,"#DEFAULT"!==e.defaultValueType&&(n+=" "+e.defaultValueType),e.defaultValue&&(n+=' "'+e.defaultValue+'"'),n+=this.spacebeforeslash+">"+this.newline},n.prototype.dtdElement=function(e,t){return this.space(t)+"<!ELEMENT "+e.name+" "+e.value+this.spacebeforeslash+">"+this.newline},n.prototype.dtdEntity=function(e,t){var n;return n=this.space(t)+"<!ENTITY",e.pe&&(n+=" %"),n+=" "+e.name,e.value?n+=' "'+e.value+'"':(e.pubID&&e.sysID?n+=' PUBLIC "'+e.pubID+'" "'+e.sysID+'"':e.sysID&&(n+=' SYSTEM "'+e.sysID+'"'),e.nData&&(n+=" NDATA "+e.nData)),n+=this.spacebeforeslash+">"+this.newline},n.prototype.dtdNotation=function(e,t){var n;return n=this.space(t)+"<!NOTATION "+e.name,e.pubID&&e.sysID?n+=' PUBLIC "'+e.pubID+'" "'+e.sysID+'"':e.pubID?n+=' PUBLIC "'+e.pubID+'"':e.sysID&&(n+=' SYSTEM "'+e.sysID+'"'),n+=this.spacebeforeslash+">"+this.newline},n.prototype.openNode=function(e,t){var n,r,i,a;if(t||(t=0),e instanceof p){i=this.space(t)+"<"+e.name,a=e.attributes;for(r in a)v.call(a,r)&&(n=a[r],i+=this.attribute(n));return i+=(e.children?">":"/>")+this.newline}return i=this.space(t)+"<!DOCTYPE "+e.rootNodeName,e.pubID&&e.sysID?i+=' PUBLIC "'+e.pubID+'" "'+e.sysID+'"':e.sysID&&(i+=' SYSTEM "'+e.sysID+'"'),i+=(e.children?" [":">")+this.newline},n.prototype.closeNode=function(e,t){
switch(t||(t=0),!1){case!(e instanceof p):return this.space(t)+"</"+e.name+">"+this.newline;case!(e instanceof l):return this.space(t)+"]>"+this.newline}},n}(m)}).call(this)},function(e,t){(function(){var t,n={}.hasOwnProperty;e.exports=t=function(){function e(e){var t,r,i,a,o,s,u,l,p;e||(e={}),this.pretty=e.pretty||!1,this.allowEmpty=null!=(r=e.allowEmpty)&&r,this.pretty?(this.indent=null!=(i=e.indent)?i:"  ",this.newline=null!=(a=e.newline)?a:"\n",this.offset=null!=(o=e.offset)?o:0,this.dontprettytextnodes=null!=(s=e.dontprettytextnodes)?s:0):(this.indent="",this.newline="",this.offset=0,this.dontprettytextnodes=0),this.spacebeforeslash=null!=(u=e.spacebeforeslash)?u:"",this.spacebeforeslash===!0&&(this.spacebeforeslash=" "),this.newlinedefault=this.newline,this.prettydefault=this.pretty,l=e.writer||{};for(t in l)n.call(l,t)&&(p=l[t],this[t]=p)}return e.prototype.set=function(e){var t,r,i;e||(e={}),"pretty"in e&&(this.pretty=e.pretty),"allowEmpty"in e&&(this.allowEmpty=e.allowEmpty),this.pretty?(this.indent="indent"in e?e.indent:"  ",this.newline="newline"in e?e.newline:"\n",this.offset="offset"in e?e.offset:0,this.dontprettytextnodes="dontprettytextnodes"in e?e.dontprettytextnodes:0):(this.indent="",this.newline="",this.offset=0,this.dontprettytextnodes=0),this.spacebeforeslash="spacebeforeslash"in e?e.spacebeforeslash:"",this.spacebeforeslash===!0&&(this.spacebeforeslash=" "),this.newlinedefault=this.newline,this.prettydefault=this.pretty,r=e.writer||{};for(t in r)n.call(r,t)&&(i=r[t],this[t]=i);return this},e.prototype.space=function(e){var t;return this.pretty?(t=(e||0)+this.offset+1,t>0?new Array(t).join(this.indent):""):""},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p,c,f,h,d,m,y,v,g,A,E,_,T={}.hasOwnProperty;_=n(83),A=_.isObject,g=_.isFunction,E=_.isPlainObject,f=n(86),r=n(88),i=n(89),d=n(96),v=n(97),h=n(98),l=n(90),p=n(91),a=n(92),s=n(93),o=n(94),u=n(95),t=n(87),y=n(99),m=n(100),e.exports=c=function(){function e(e,t,n){var r;e||(e={}),e.writer?E(e.writer)&&(r=e.writer,e.writer=new m(r)):e.writer=new m(e),this.options=e,this.writer=e.writer,this.stringify=new y(e),this.onDataCallback=t||function(){},this.onEndCallback=n||function(){},this.currentNode=null,this.currentLevel=-1,this.openTags={},this.documentStarted=!1,this.documentCompleted=!1,this.root=null}return e.prototype.node=function(e,t,n){var r;if(null==e)throw new Error("Missing node name");if(this.root&&this.currentLevel===-1)throw new Error("Document can only have one root node");return this.openCurrent(),e=e.valueOf(),null==t&&(t={}),t=t.valueOf(),A(t)||(r=[t,n],n=r[0],t=r[1]),this.currentNode=new f(this,e,t),this.currentNode.children=!1,this.currentLevel++,this.openTags[this.currentLevel]=this.currentNode,null!=n&&this.text(n),this},e.prototype.element=function(e,t,n){return this.currentNode&&this.currentNode instanceof p?this.dtdElement.apply(this,arguments):this.node(e,t,n)},e.prototype.attribute=function(e,n){var r,i;if(!this.currentNode||this.currentNode.children)throw new Error("att() can only be used immediately after an ele() call in callback mode");if(null!=e&&(e=e.valueOf()),A(e))for(r in e)T.call(e,r)&&(i=e[r],this.attribute(r,i));else g(n)&&(n=n.apply()),this.options.skipNullAttributes&&null==n||(this.currentNode.attributes[e]=new t(this,e,n));return this},e.prototype.text=function(e){var t;return this.openCurrent(),t=new v(this,e),this.onData(this.writer.text(t,this.currentLevel+1)),this},e.prototype.cdata=function(e){var t;return this.openCurrent(),t=new r(this,e),this.onData(this.writer.cdata(t,this.currentLevel+1)),this},e.prototype.comment=function(e){var t;return this.openCurrent(),t=new i(this,e),this.onData(this.writer.comment(t,this.currentLevel+1)),this},e.prototype.raw=function(e){var t;return this.openCurrent(),t=new d(this,e),this.onData(this.writer.raw(t,this.currentLevel+1)),this},e.prototype.instruction=function(e,t){var n,r,i,a,o;if(this.openCurrent(),null!=e&&(e=e.valueOf()),null!=t&&(t=t.valueOf()),Array.isArray(e))for(n=0,a=e.length;n<a;n++)r=e[n],this.instruction(r);else if(A(e))for(r in e)T.call(e,r)&&(i=e[r],this.instruction(r,i));else g(t)&&(t=t.apply()),o=new h(this,e,t),this.onData(this.writer.processingInstruction(o,this.currentLevel+1));return this},e.prototype.declaration=function(e,t,n){var r;if(this.openCurrent(),this.documentStarted)throw new Error("declaration() must be the first node");return r=new l(this,e,t,n),this.onData(this.writer.declaration(r,this.currentLevel+1)),this},e.prototype.doctype=function(e,t,n){if(this.openCurrent(),null==e)throw new Error("Missing root node name");if(this.root)throw new Error("dtd() must come before the root node");return this.currentNode=new p(this,t,n),this.currentNode.rootNodeName=e,this.currentNode.children=!1,this.currentLevel++,this.openTags[this.currentLevel]=this.currentNode,this},e.prototype.dtdElement=function(e,t){var n;return this.openCurrent(),n=new o(this,e,t),this.onData(this.writer.dtdElement(n,this.currentLevel+1)),this},e.prototype.attList=function(e,t,n,r,i){var o;return this.openCurrent(),o=new a(this,e,t,n,r,i),this.onData(this.writer.dtdAttList(o,this.currentLevel+1)),this},e.prototype.entity=function(e,t){var n;return this.openCurrent(),n=new s(this,!1,e,t),this.onData(this.writer.dtdEntity(n,this.currentLevel+1)),this},e.prototype.pEntity=function(e,t){var n;return this.openCurrent(),n=new s(this,!0,e,t),this.onData(this.writer.dtdEntity(n,this.currentLevel+1)),this},e.prototype.notation=function(e,t){var n;return this.openCurrent(),n=new u(this,e,t),this.onData(this.writer.dtdNotation(n,this.currentLevel+1)),this},e.prototype.up=function(){if(this.currentLevel<0)throw new Error("The document node has no parent");return this.currentNode?(this.currentNode.children?this.closeNode(this.currentNode):this.openNode(this.currentNode),this.currentNode=null):this.closeNode(this.openTags[this.currentLevel]),delete this.openTags[this.currentLevel],this.currentLevel--,this},e.prototype.end=function(){for(;this.currentLevel>=0;)this.up();return this.onEnd()},e.prototype.openCurrent=function(){if(this.currentNode)return this.currentNode.children=!0,this.openNode(this.currentNode)},e.prototype.openNode=function(e){if(!e.isOpen)return!this.root&&0===this.currentLevel&&e instanceof f&&(this.root=e),this.onData(this.writer.openNode(e,this.currentLevel)),e.isOpen=!0},e.prototype.closeNode=function(e){if(!e.isClosed)return this.onData(this.writer.closeNode(e,this.currentLevel)),e.isClosed=!0},e.prototype.onData=function(e){return this.documentStarted=!0,this.onDataCallback(e)},e.prototype.onEnd=function(){return this.documentCompleted=!0,this.onEndCallback()},e.prototype.ele=function(){return this.element.apply(this,arguments)},e.prototype.nod=function(e,t,n){return this.node(e,t,n)},e.prototype.txt=function(e){return this.text(e)},e.prototype.dat=function(e){return this.cdata(e)},e.prototype.com=function(e){return this.comment(e)},e.prototype.ins=function(e,t){return this.instruction(e,t)},e.prototype.dec=function(e,t,n){return this.declaration(e,t,n)},e.prototype.dtd=function(e,t,n){return this.doctype(e,t,n)},e.prototype.e=function(e,t,n){return this.element(e,t,n)},e.prototype.n=function(e,t,n){return this.node(e,t,n)},e.prototype.t=function(e){return this.text(e)},e.prototype.d=function(e){return this.cdata(e)},e.prototype.c=function(e){return this.comment(e)},e.prototype.r=function(e){return this.raw(e)},e.prototype.i=function(e,t){return this.instruction(e,t)},e.prototype.att=function(){return this.currentNode&&this.currentNode instanceof p?this.attList.apply(this,arguments):this.attribute.apply(this,arguments)},e.prototype.a=function(){return this.currentNode&&this.currentNode instanceof p?this.attList.apply(this,arguments):this.attribute.apply(this,arguments)},e.prototype.ent=function(e,t){return this.entity(e,t)},e.prototype.pent=function(e,t){return this.pEntity(e,t)},e.prototype.not=function(e,t){return this.notation(e,t)},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p,c,f,h,d,m,y=function(e,t){function n(){this.constructor=e}for(var r in t)v.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},v={}.hasOwnProperty;u=n(90),l=n(91),t=n(88),r=n(89),p=n(86),f=n(96),d=n(97),c=n(98),i=n(92),a=n(94),o=n(93),s=n(95),m=n(101),e.exports=h=function(e){function n(e,t){this.stream=e,n.__super__.constructor.call(this,t)}return y(n,e),n.prototype.document=function(e){var t,n,i,a,o,s,p,f;for(s=e.children,n=0,a=s.length;n<a;n++)t=s[n],t.isLastRootNode=!1;for(e.children[e.children.length-1].isLastRootNode=!0,p=e.children,f=[],i=0,o=p.length;i<o;i++)switch(t=p[i],!1){case!(t instanceof u):f.push(this.declaration(t));break;case!(t instanceof l):f.push(this.docType(t));break;case!(t instanceof r):f.push(this.comment(t));break;case!(t instanceof c):f.push(this.processingInstruction(t));break;default:f.push(this.element(t))}return f},n.prototype.attribute=function(e){return this.stream.write(" "+e.name+'="'+e.value+'"')},n.prototype.cdata=function(e,t){return this.stream.write(this.space(t)+"<![CDATA["+e.text+"]]>"+this.endline(e))},n.prototype.comment=function(e,t){return this.stream.write(this.space(t)+"<!-- "+e.text+" -->"+this.endline(e))},n.prototype.declaration=function(e,t){return this.stream.write(this.space(t)),this.stream.write('<?xml version="'+e.version+'"'),null!=e.encoding&&this.stream.write(' encoding="'+e.encoding+'"'),null!=e.standalone&&this.stream.write(' standalone="'+e.standalone+'"'),this.stream.write(this.spacebeforeslash+"?>"),this.stream.write(this.endline(e))},n.prototype.docType=function(e,n){var u,l,p,f;if(n||(n=0),this.stream.write(this.space(n)),this.stream.write("<!DOCTYPE "+e.root().name),e.pubID&&e.sysID?this.stream.write(' PUBLIC "'+e.pubID+'" "'+e.sysID+'"'):e.sysID&&this.stream.write(' SYSTEM "'+e.sysID+'"'),e.children.length>0){for(this.stream.write(" ["),this.stream.write(this.endline(e)),f=e.children,l=0,p=f.length;l<p;l++)switch(u=f[l],!1){case!(u instanceof i):this.dtdAttList(u,n+1);break;case!(u instanceof a):this.dtdElement(u,n+1);break;case!(u instanceof o):this.dtdEntity(u,n+1);break;case!(u instanceof s):this.dtdNotation(u,n+1);break;case!(u instanceof t):this.cdata(u,n+1);break;case!(u instanceof r):this.comment(u,n+1);break;case!(u instanceof c):this.processingInstruction(u,n+1);break;default:throw new Error("Unknown DTD node type: "+u.constructor.name)}this.stream.write("]")}return this.stream.write(this.spacebeforeslash+">"),this.stream.write(this.endline(e))},n.prototype.element=function(e,n){var i,a,o,s,u,l,h,m;n||(n=0),m=this.space(n),this.stream.write(m+"<"+e.name),l=e.attributes;for(u in l)v.call(l,u)&&(i=l[u],this.attribute(i));if(0===e.children.length||e.children.every(function(e){return""===e.value}))this.allowEmpty?this.stream.write("></"+e.name+">"):this.stream.write(this.spacebeforeslash+"/>");else if(this.pretty&&1===e.children.length&&null!=e.children[0].value)this.stream.write(">"),this.stream.write(e.children[0].value),this.stream.write("</"+e.name+">");else{for(this.stream.write(">"+this.newline),h=e.children,o=0,s=h.length;o<s;o++)switch(a=h[o],!1){case!(a instanceof t):this.cdata(a,n+1);break;case!(a instanceof r):this.comment(a,n+1);break;case!(a instanceof p):this.element(a,n+1);break;case!(a instanceof f):this.raw(a,n+1);break;case!(a instanceof d):this.text(a,n+1);break;case!(a instanceof c):this.processingInstruction(a,n+1);break;default:throw new Error("Unknown XML node type: "+a.constructor.name)}this.stream.write(m+"</"+e.name+">")}return this.stream.write(this.endline(e))},n.prototype.processingInstruction=function(e,t){return this.stream.write(this.space(t)+"<?"+e.target),e.value&&this.stream.write(" "+e.value),this.stream.write(this.spacebeforeslash+"?>"+this.endline(e))},n.prototype.raw=function(e,t){return this.stream.write(this.space(t)+e.value+this.endline(e))},n.prototype.text=function(e,t){return this.stream.write(this.space(t)+e.value+this.endline(e))},n.prototype.dtdAttList=function(e,t){return this.stream.write(this.space(t)+"<!ATTLIST "+e.elementName+" "+e.attributeName+" "+e.attributeType),"#DEFAULT"!==e.defaultValueType&&this.stream.write(" "+e.defaultValueType),e.defaultValue&&this.stream.write(' "'+e.defaultValue+'"'),this.stream.write(this.spacebeforeslash+">"+this.endline(e))},n.prototype.dtdElement=function(e,t){return this.stream.write(this.space(t)+"<!ELEMENT "+e.name+" "+e.value),this.stream.write(this.spacebeforeslash+">"+this.endline(e))},n.prototype.dtdEntity=function(e,t){return this.stream.write(this.space(t)+"<!ENTITY"),e.pe&&this.stream.write(" %"),this.stream.write(" "+e.name),e.value?this.stream.write(' "'+e.value+'"'):(e.pubID&&e.sysID?this.stream.write(' PUBLIC "'+e.pubID+'" "'+e.sysID+'"'):e.sysID&&this.stream.write(' SYSTEM "'+e.sysID+'"'),e.nData&&this.stream.write(" NDATA "+e.nData)),this.stream.write(this.spacebeforeslash+">"+this.endline(e))},n.prototype.dtdNotation=function(e,t){return this.stream.write(this.space(t)+"<!NOTATION "+e.name),e.pubID&&e.sysID?this.stream.write(' PUBLIC "'+e.pubID+'" "'+e.sysID+'"'):e.pubID?this.stream.write(' PUBLIC "'+e.pubID+'"'):e.sysID&&this.stream.write(' SYSTEM "'+e.sysID+'"'),this.stream.write(this.spacebeforeslash+">"+this.endline(e))},n.prototype.endline=function(e){return e.isLastRootNode?"":this.newline},n}(m)}).call(this)},function(e,t,n){(function(){"use strict";var e,r,i,a,o,s,u,l,p=function(e,t){return function(){return e.apply(t,arguments)}},c=function(e,t){function n(){this.constructor=e}for(var r in t)f.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},f={}.hasOwnProperty;u=n(105),i=n(107),e=n(133),s=n(134),l=n(122).setImmediate,r=n(80).defaults,a=function(e){return"object"==typeof e&&null!=e&&0===Object.keys(e).length},o=function(e,t,n){var r,i,a;for(r=0,i=e.length;r<i;r++)a=e[r],t=a(t,n);return t},t.Parser=function(n){function i(e){this.parseString=p(this.parseString,this),this.reset=p(this.reset,this),this.assignOrPush=p(this.assignOrPush,this),this.processAsync=p(this.processAsync,this);var n,i,a;if(!(this instanceof t.Parser))return new t.Parser(e);this.options={},i=r[.2];for(n in i)f.call(i,n)&&(a=i[n],this.options[n]=a);for(n in e)f.call(e,n)&&(a=e[n],this.options[n]=a);this.options.xmlns&&(this.options.xmlnskey=this.options.attrkey+"ns"),this.options.normalizeTags&&(this.options.tagNameProcessors||(this.options.tagNameProcessors=[]),this.options.tagNameProcessors.unshift(s.normalize)),this.reset()}return c(i,n),i.prototype.processAsync=function(){var e,t;try{return this.remaining.length<=this.options.chunkSize?(e=this.remaining,this.remaining="",this.saxParser=this.saxParser.write(e),this.saxParser.close()):(e=this.remaining.substr(0,this.options.chunkSize),this.remaining=this.remaining.substr(this.options.chunkSize,this.remaining.length),this.saxParser=this.saxParser.write(e),l(this.processAsync))}catch(e){if(t=e,!this.saxParser.errThrown)return this.saxParser.errThrown=!0,this.emit(t)}},i.prototype.assignOrPush=function(e,t,n){return t in e?(e[t]instanceof Array||(e[t]=[e[t]]),e[t].push(n)):this.options.explicitArray?e[t]=[n]:e[t]=n},i.prototype.reset=function(){var e,t,n,r;return this.removeAllListeners(),this.saxParser=u.parser(this.options.strict,{trim:!1,normalize:!1,xmlns:this.options.xmlns}),this.saxParser.errThrown=!1,this.saxParser.onerror=function(e){return function(t){if(e.saxParser.resume(),!e.saxParser.errThrown)return e.saxParser.errThrown=!0,e.emit("error",t)}}(this),this.saxParser.onend=function(e){return function(){if(!e.saxParser.ended)return e.saxParser.ended=!0,e.emit("end",e.resultObject)}}(this),this.saxParser.ended=!1,this.EXPLICIT_CHARKEY=this.options.explicitCharkey,this.resultObject=null,r=[],e=this.options.attrkey,t=this.options.charkey,this.saxParser.onopentag=function(n){return function(i){var a,s,u,l,p;if(u={},u[t]="",!n.options.ignoreAttrs){p=i.attributes;for(a in p)f.call(p,a)&&(e in u||n.options.mergeAttrs||(u[e]={}),s=n.options.attrValueProcessors?o(n.options.attrValueProcessors,i.attributes[a],a):i.attributes[a],l=n.options.attrNameProcessors?o(n.options.attrNameProcessors,a):a,n.options.mergeAttrs?n.assignOrPush(u,l,s):u[e][l]=s)}return u["#name"]=n.options.tagNameProcessors?o(n.options.tagNameProcessors,i.name):i.name,n.options.xmlns&&(u[n.options.xmlnskey]={uri:i.uri,local:i.local}),r.push(u)}}(this),this.saxParser.onclosetag=function(e){return function(){var n,i,s,u,l,p,c,h,d,m;if(p=r.pop(),l=p["#name"],e.options.explicitChildren&&e.options.preserveChildrenOrder||delete p["#name"],p.cdata===!0&&(n=p.cdata,delete p.cdata),d=r[r.length-1],p[t].match(/^\s*$/)&&!n?(i=p[t],delete p[t]):(e.options.trim&&(p[t]=p[t].trim()),e.options.normalize&&(p[t]=p[t].replace(/\s{2,}/g," ").trim()),p[t]=e.options.valueProcessors?o(e.options.valueProcessors,p[t],l):p[t],1===Object.keys(p).length&&t in p&&!e.EXPLICIT_CHARKEY&&(p=p[t])),a(p)&&(p=""!==e.options.emptyTag?e.options.emptyTag:i),null!=e.options.validator&&(m="/"+function(){var e,t,n;for(n=[],e=0,t=r.length;e<t;e++)u=r[e],n.push(u["#name"]);return n}().concat(l).join("/"),function(){var t;try{return p=e.options.validator(m,d&&d[l],p)}catch(n){return t=n,e.emit("error",t)}}()),e.options.explicitChildren&&!e.options.mergeAttrs&&"object"==typeof p)if(e.options.preserveChildrenOrder){if(d){d[e.options.childkey]=d[e.options.childkey]||[],c={};for(s in p)f.call(p,s)&&(c[s]=p[s]);d[e.options.childkey].push(c),delete p["#name"],1===Object.keys(p).length&&t in p&&!e.EXPLICIT_CHARKEY&&(p=p[t])}}else u={},e.options.attrkey in p&&(u[e.options.attrkey]=p[e.options.attrkey],delete p[e.options.attrkey]),!e.options.charsAsChildren&&e.options.charkey in p&&(u[e.options.charkey]=p[e.options.charkey],delete p[e.options.charkey]),Object.getOwnPropertyNames(p).length>0&&(u[e.options.childkey]=p),p=u;return r.length>0?e.assignOrPush(d,l,p):(e.options.explicitRoot&&(h=p,p={},p[l]=h),e.resultObject=p,e.saxParser.ended=!0,e.emit("end",e.resultObject))}}(this),n=function(e){return function(n){var i,a;if(a=r[r.length-1])return a[t]+=n,e.options.explicitChildren&&e.options.preserveChildrenOrder&&e.options.charsAsChildren&&(e.options.includeWhiteChars||""!==n.replace(/\\n/g,"").trim())&&(a[e.options.childkey]=a[e.options.childkey]||[],i={"#name":"__text__"},i[t]=n,e.options.normalize&&(i[t]=i[t].replace(/\s{2,}/g," ").trim()),a[e.options.childkey].push(i)),a}}(this),this.saxParser.ontext=n,this.saxParser.oncdata=function(e){return function(e){var t;if(t=n(e))return t.cdata=!0}}(this)},i.prototype.parseString=function(t,n){var r;null!=n&&"function"==typeof n&&(this.on("end",function(e){return this.reset(),n(null,e)}),this.on("error",function(e){return this.reset(),n(e)}));try{return t=t.toString(),""===t.trim()?(this.emit("end",null),!0):(t=e.stripBOM(t),this.options.async?(this.remaining=t,l(this.processAsync),this.saxParser):this.saxParser.write(t).close())}catch(e){if(r=e,!this.saxParser.errThrown&&!this.saxParser.ended)return this.emit("error",r),this.saxParser.errThrown=!0;if(this.saxParser.ended)throw r}},i}(i.EventEmitter),t.parseString=function(e,n,r){var i,a,o;return null!=r?("function"==typeof r&&(i=r),"object"==typeof n&&(a=n)):("function"==typeof n&&(i=n),a={}),o=new t.Parser(a),o.parseString(e,i)}}).call(this)},function(e,t,n){(function(e){!function(t){function r(e,n){if(!(this instanceof r))return new r(e,n);var i=this;a(i),i.q=i.c="",i.bufferCheckPosition=t.MAX_BUFFER_LENGTH,i.opt=n||{},i.opt.lowercase=i.opt.lowercase||i.opt.lowercasetags,i.looseCase=i.opt.lowercase?"toLowerCase":"toUpperCase",i.tags=[],i.closed=i.closedRoot=i.sawRoot=!1,i.tag=i.error=null,i.strict=!!e,i.noscript=!(!e&&!i.opt.noscript),i.state=j.BEGIN,i.strictEntities=i.opt.strictEntities,i.ENTITIES=i.strictEntities?Object.create(t.XML_ENTITIES):Object.create(t.ENTITIES),i.attribList=[],i.opt.xmlns&&(i.ns=Object.create(k)),i.trackPosition=i.opt.position!==!1,i.trackPosition&&(i.position=i.line=i.column=0),d(i,"onready")}function i(e){for(var n=Math.max(t.MAX_BUFFER_LENGTH,10),r=0,i=0,a=w.length;i<a;i++){var o=e[w[i]].length;if(o>n)switch(w[i]){case"textNode":y(e);break;case"cdata":m(e,"oncdata",e.cdata),e.cdata="";break;case"script":m(e,"onscript",e.script),e.script="";break;default:g(e,"Max buffer length exceeded: "+w[i])}r=Math.max(r,o)}var s=t.MAX_BUFFER_LENGTH-r;e.bufferCheckPosition=s+e.position}function a(e){for(var t=0,n=w.length;t<n;t++)e[w[t]]=""}function o(e){y(e),""!==e.cdata&&(m(e,"oncdata",e.cdata),e.cdata=""),""!==e.script&&(m(e,"onscript",e.script),e.script="")}function s(e,t){return new u(e,t)}function u(e,t){if(!(this instanceof u))return new u(e,t);P.apply(this),this._parser=new r(e,t),this.writable=!0,this.readable=!0;var n=this;this._parser.onend=function(){n.emit("end")},this._parser.onerror=function(e){n.emit("error",e),n._parser.error=null},this._decoder=null,L.forEach(function(e){Object.defineProperty(n,"on"+e,{get:function(){return n._parser["on"+e]},set:function(t){return t?void n.on(e,t):(n.removeAllListeners(e),n._parser["on"+e]=t,t)},enumerable:!0,configurable:!1})})}function l(e){return" "===e||"\n"===e||"\r"===e||"\t"===e}function p(e){return'"'===e||"'"===e}function c(e){return">"===e||l(e)}function f(e,t){return e.test(t)}function h(e,t){return!f(e,t)}function d(e,t,n){e[t]&&e[t](n)}function m(e,t,n){e.textNode&&y(e),d(e,t,n)}function y(e){e.textNode=v(e.opt,e.textNode),e.textNode&&d(e,"ontext",e.textNode),e.textNode=""}function v(e,t){return e.trim&&(t=t.trim()),e.normalize&&(t=t.replace(/\s+/g," ")),t}function g(e,t){return y(e),e.trackPosition&&(t+="\nLine: "+e.line+"\nColumn: "+e.column+"\nChar: "+e.c),t=new Error(t),e.error=t,d(e,"onerror",t),e}function A(e){return e.sawRoot&&!e.closedRoot&&E(e,"Unclosed root tag"),e.state!==j.BEGIN&&e.state!==j.BEGIN_WHITESPACE&&e.state!==j.TEXT&&g(e,"Unexpected end"),y(e),e.c="",e.closed=!0,d(e,"onend"),r.call(e,e.strict,e.opt),e}function E(e,t){if("object"!=typeof e||!(e instanceof r))throw new Error("bad call to strictFail");e.strict&&g(e,t)}function _(e){e.strict||(e.tagName=e.tagName[e.looseCase]());var t=e.tags[e.tags.length-1]||e,n=e.tag={name:e.tagName,attributes:{}};e.opt.xmlns&&(n.ns=t.ns),e.attribList.length=0,m(e,"onopentagstart",n)}function T(e,t){var n=e.indexOf(":"),r=n<0?["",e]:e.split(":"),i=r[0],a=r[1];return t&&"xmlns"===e&&(i="xmlns",a=""),{prefix:i,local:a}}function S(e){if(e.strict||(e.attribName=e.attribName[e.looseCase]()),e.attribList.indexOf(e.attribName)!==-1||e.tag.attributes.hasOwnProperty(e.attribName))return void(e.attribName=e.attribValue="");if(e.opt.xmlns){var t=T(e.attribName,!0),n=t.prefix,r=t.local;if("xmlns"===n)if("xml"===r&&e.attribValue!==U)E(e,"xml: prefix must be bound to "+U+"\nActual: "+e.attribValue);else if("xmlns"===r&&e.attribValue!==x)E(e,"xmlns: prefix must be bound to "+x+"\nActual: "+e.attribValue);else{var i=e.tag,a=e.tags[e.tags.length-1]||e;i.ns===a.ns&&(i.ns=Object.create(a.ns)),i.ns[r]=e.attribValue}e.attribList.push([e.attribName,e.attribValue])}else e.tag.attributes[e.attribName]=e.attribValue,m(e,"onattribute",{name:e.attribName,value:e.attribValue});e.attribName=e.attribValue=""}function N(e,t){if(e.opt.xmlns){var n=e.tag,r=T(e.tagName);n.prefix=r.prefix,n.local=r.local,n.uri=n.ns[r.prefix]||"",n.prefix&&!n.uri&&(E(e,"Unbound namespace prefix: "+JSON.stringify(e.tagName)),n.uri=r.prefix);var i=e.tags[e.tags.length-1]||e;n.ns&&i.ns!==n.ns&&Object.keys(n.ns).forEach(function(t){m(e,"onopennamespace",{prefix:t,uri:n.ns[t]})});for(var a=0,o=e.attribList.length;a<o;a++){var s=e.attribList[a],u=s[0],l=s[1],p=T(u,!0),c=p.prefix,f=p.local,h=""===c?"":n.ns[c]||"",d={name:u,value:l,prefix:c,local:f,uri:h};c&&"xmlns"!==c&&!h&&(E(e,"Unbound namespace prefix: "+JSON.stringify(c)),d.uri=c),e.tag.attributes[u]=d,m(e,"onattribute",d)}e.attribList.length=0}e.tag.isSelfClosing=!!t,e.sawRoot=!0,e.tags.push(e.tag),m(e,"onopentag",e.tag),t||(e.noscript||"script"!==e.tagName.toLowerCase()?e.state=j.TEXT:e.state=j.SCRIPT,e.tag=null,e.tagName=""),e.attribName=e.attribValue="",e.attribList.length=0}function I(e){if(!e.tagName)return E(e,"Weird empty close tag."),e.textNode+="</>",void(e.state=j.TEXT);if(e.script){if("script"!==e.tagName)return e.script+="</"+e.tagName+">",e.tagName="",void(e.state=j.SCRIPT);m(e,"onscript",e.script),e.script=""}var t=e.tags.length,n=e.tagName;e.strict||(n=n[e.looseCase]());for(var r=n;t--;){var i=e.tags[t];if(i.name===r)break;E(e,"Unexpected close tag")}if(t<0)return E(e,"Unmatched closing tag: "+e.tagName),e.textNode+="</"+e.tagName+">",void(e.state=j.TEXT);e.tagName=n;for(var a=e.tags.length;a-- >t;){var o=e.tag=e.tags.pop();e.tagName=e.tag.name,m(e,"onclosetag",e.tagName);var s={};for(var u in o.ns)s[u]=o.ns[u];var l=e.tags[e.tags.length-1]||e;e.opt.xmlns&&o.ns!==l.ns&&Object.keys(o.ns).forEach(function(t){var n=o.ns[t];m(e,"onclosenamespace",{prefix:t,uri:n})})}0===t&&(e.closedRoot=!0),e.tagName=e.attribValue=e.attribName="",e.attribList.length=0,e.state=j.TEXT}function b(e){var t,n=e.entity,r=n.toLowerCase(),i="";return e.ENTITIES[n]?e.ENTITIES[n]:e.ENTITIES[r]?e.ENTITIES[r]:(n=r,"#"===n.charAt(0)&&("x"===n.charAt(1)?(n=n.slice(2),t=parseInt(n,16),i=t.toString(16)):(n=n.slice(1),t=parseInt(n,10),i=t.toString(10))),n=n.replace(/^0+/,""),isNaN(t)||i.toLowerCase()!==n?(E(e,"Invalid character entity"),"&"+e.entity+";"):String.fromCodePoint(t))}function R(e,t){"<"===t?(e.state=j.OPEN_WAKA,e.startTagPosition=e.position):l(t)||(E(e,"Non-whitespace before first tag."),e.textNode=t,e.state=j.TEXT)}function M(e,t){var n="";return t<e.length&&(n=e.charAt(t)),n}function C(e){var t=this;if(this.error)throw this.error;if(t.closed)return g(t,"Cannot write after close. Assign an onready handler.");if(null===e)return A(t);"object"==typeof e&&(e=e.toString());for(var n=0,r="";;){if(r=M(e,n++),t.c=r,!r)break;switch(t.trackPosition&&(t.position++,"\n"===r?(t.line++,t.column=0):t.column++),t.state){case j.BEGIN:if(t.state=j.BEGIN_WHITESPACE,"\ufeff"===r)continue;R(t,r);continue;case j.BEGIN_WHITESPACE:R(t,r);continue;case j.TEXT:if(t.sawRoot&&!t.closedRoot){for(var a=n-1;r&&"<"!==r&&"&"!==r;)r=M(e,n++),r&&t.trackPosition&&(t.position++,"\n"===r?(t.line++,t.column=0):t.column++);t.textNode+=e.substring(a,n-1)}"<"!==r||t.sawRoot&&t.closedRoot&&!t.strict?(l(r)||t.sawRoot&&!t.closedRoot||E(t,"Text data outside of root node."),"&"===r?t.state=j.TEXT_ENTITY:t.textNode+=r):(t.state=j.OPEN_WAKA,t.startTagPosition=t.position);continue;case j.SCRIPT:"<"===r?t.state=j.SCRIPT_ENDING:t.script+=r;continue;case j.SCRIPT_ENDING:"/"===r?t.state=j.CLOSE_TAG:(t.script+="<"+r,t.state=j.SCRIPT);continue;case j.OPEN_WAKA:if("!"===r)t.state=j.SGML_DECL,t.sgmlDecl="";else if(l(r));else if(f(F,r))t.state=j.OPEN_TAG,t.tagName=r;else if("/"===r)t.state=j.CLOSE_TAG,t.tagName="";else if("?"===r)t.state=j.PROC_INST,t.procInstName=t.procInstBody="";else{if(E(t,"Unencoded <"),t.startTagPosition+1<t.position){var o=t.position-t.startTagPosition;r=new Array(o).join(" ")+r}t.textNode+="<"+r,t.state=j.TEXT}continue;case j.SGML_DECL:(t.sgmlDecl+r).toUpperCase()===O?(m(t,"onopencdata"),t.state=j.CDATA,t.sgmlDecl="",t.cdata=""):t.sgmlDecl+r==="--"?(t.state=j.COMMENT,t.comment="",t.sgmlDecl=""):(t.sgmlDecl+r).toUpperCase()===D?(t.state=j.DOCTYPE,(t.doctype||t.sawRoot)&&E(t,"Inappropriately located doctype declaration"),t.doctype="",t.sgmlDecl=""):">"===r?(m(t,"onsgmldeclaration",t.sgmlDecl),t.sgmlDecl="",t.state=j.TEXT):p(r)?(t.state=j.SGML_DECL_QUOTED,t.sgmlDecl+=r):t.sgmlDecl+=r;continue;case j.SGML_DECL_QUOTED:r===t.q&&(t.state=j.SGML_DECL,t.q=""),t.sgmlDecl+=r;continue;case j.DOCTYPE:">"===r?(t.state=j.TEXT,m(t,"ondoctype",t.doctype),t.doctype=!0):(t.doctype+=r,"["===r?t.state=j.DOCTYPE_DTD:p(r)&&(t.state=j.DOCTYPE_QUOTED,t.q=r));continue;case j.DOCTYPE_QUOTED:t.doctype+=r,r===t.q&&(t.q="",t.state=j.DOCTYPE);continue;case j.DOCTYPE_DTD:t.doctype+=r,"]"===r?t.state=j.DOCTYPE:p(r)&&(t.state=j.DOCTYPE_DTD_QUOTED,t.q=r);continue;case j.DOCTYPE_DTD_QUOTED:t.doctype+=r,r===t.q&&(t.state=j.DOCTYPE_DTD,t.q="");continue;case j.COMMENT:"-"===r?t.state=j.COMMENT_ENDING:t.comment+=r;continue;case j.COMMENT_ENDING:"-"===r?(t.state=j.COMMENT_ENDED,t.comment=v(t.opt,t.comment),t.comment&&m(t,"oncomment",t.comment),t.comment=""):(t.comment+="-"+r,t.state=j.COMMENT);continue;case j.COMMENT_ENDED:">"!==r?(E(t,"Malformed comment"),t.comment+="--"+r,t.state=j.COMMENT):t.state=j.TEXT;continue;case j.CDATA:"]"===r?t.state=j.CDATA_ENDING:t.cdata+=r;continue;case j.CDATA_ENDING:"]"===r?t.state=j.CDATA_ENDING_2:(t.cdata+="]"+r,t.state=j.CDATA);continue;case j.CDATA_ENDING_2:">"===r?(t.cdata&&m(t,"oncdata",t.cdata),m(t,"onclosecdata"),t.cdata="",t.state=j.TEXT):"]"===r?t.cdata+="]":(t.cdata+="]]"+r,t.state=j.CDATA);continue;case j.PROC_INST:"?"===r?t.state=j.PROC_INST_ENDING:l(r)?t.state=j.PROC_INST_BODY:t.procInstName+=r;continue;case j.PROC_INST_BODY:if(!t.procInstBody&&l(r))continue;"?"===r?t.state=j.PROC_INST_ENDING:t.procInstBody+=r;continue;case j.PROC_INST_ENDING:">"===r?(m(t,"onprocessinginstruction",{name:t.procInstName,body:t.procInstBody}),t.procInstName=t.procInstBody="",t.state=j.TEXT):(t.procInstBody+="?"+r,t.state=j.PROC_INST_BODY);continue;case j.OPEN_TAG:f(B,r)?t.tagName+=r:(_(t),">"===r?N(t):"/"===r?t.state=j.OPEN_TAG_SLASH:(l(r)||E(t,"Invalid character in tag name"),t.state=j.ATTRIB));continue;case j.OPEN_TAG_SLASH:">"===r?(N(t,!0),I(t)):(E(t,"Forward-slash in opening tag not followed by >"),t.state=j.ATTRIB);continue;case j.ATTRIB:if(l(r))continue;">"===r?N(t):"/"===r?t.state=j.OPEN_TAG_SLASH:f(F,r)?(t.attribName=r,t.attribValue="",t.state=j.ATTRIB_NAME):E(t,"Invalid attribute name");continue;case j.ATTRIB_NAME:"="===r?t.state=j.ATTRIB_VALUE:">"===r?(E(t,"Attribute without value"),t.attribValue=t.attribName,S(t),N(t)):l(r)?t.state=j.ATTRIB_NAME_SAW_WHITE:f(B,r)?t.attribName+=r:E(t,"Invalid attribute name");continue;case j.ATTRIB_NAME_SAW_WHITE:if("="===r)t.state=j.ATTRIB_VALUE;else{if(l(r))continue;E(t,"Attribute without value"),t.tag.attributes[t.attribName]="",t.attribValue="",m(t,"onattribute",{name:t.attribName,value:""}),t.attribName="",">"===r?N(t):f(F,r)?(t.attribName=r,t.state=j.ATTRIB_NAME):(E(t,"Invalid attribute name"),t.state=j.ATTRIB)}continue;case j.ATTRIB_VALUE:if(l(r))continue;p(r)?(t.q=r,t.state=j.ATTRIB_VALUE_QUOTED):(E(t,"Unquoted attribute value"),t.state=j.ATTRIB_VALUE_UNQUOTED,t.attribValue=r);continue;case j.ATTRIB_VALUE_QUOTED:if(r!==t.q){"&"===r?t.state=j.ATTRIB_VALUE_ENTITY_Q:t.attribValue+=r;continue}S(t),t.q="",t.state=j.ATTRIB_VALUE_CLOSED;continue;case j.ATTRIB_VALUE_CLOSED:l(r)?t.state=j.ATTRIB:">"===r?N(t):"/"===r?t.state=j.OPEN_TAG_SLASH:f(F,r)?(E(t,"No whitespace between attributes"),t.attribName=r,t.attribValue="",t.state=j.ATTRIB_NAME):E(t,"Invalid attribute name");continue;case j.ATTRIB_VALUE_UNQUOTED:if(!c(r)){"&"===r?t.state=j.ATTRIB_VALUE_ENTITY_U:t.attribValue+=r;continue}S(t),">"===r?N(t):t.state=j.ATTRIB;continue;case j.CLOSE_TAG:if(t.tagName)">"===r?I(t):f(B,r)?t.tagName+=r:t.script?(t.script+="</"+t.tagName,t.tagName="",t.state=j.SCRIPT):(l(r)||E(t,"Invalid tagname in closing tag"),t.state=j.CLOSE_TAG_SAW_WHITE);else{if(l(r))continue;h(F,r)?t.script?(t.script+="</"+r,t.state=j.SCRIPT):E(t,"Invalid tagname in closing tag."):t.tagName=r}continue;case j.CLOSE_TAG_SAW_WHITE:if(l(r))continue;">"===r?I(t):E(t,"Invalid characters in closing tag");continue;case j.TEXT_ENTITY:case j.ATTRIB_VALUE_ENTITY_Q:case j.ATTRIB_VALUE_ENTITY_U:var s,u;switch(t.state){case j.TEXT_ENTITY:s=j.TEXT,u="textNode";break;case j.ATTRIB_VALUE_ENTITY_Q:s=j.ATTRIB_VALUE_QUOTED,u="attribValue";break;case j.ATTRIB_VALUE_ENTITY_U:s=j.ATTRIB_VALUE_UNQUOTED,u="attribValue"}";"===r?(t[u]+=b(t),t.entity="",t.state=s):f(t.entity.length?K:V,r)?t.entity+=r:(E(t,"Invalid character in entity name"),t[u]+="&"+t.entity+r,t.entity="",t.state=s);continue;default:throw new Error(t,"Unknown state: "+t.state)}}return t.position>=t.bufferCheckPosition&&i(t),t}t.parser=function(e,t){return new r(e,t)},t.SAXParser=r,t.SAXStream=u,
t.createStream=s,t.MAX_BUFFER_LENGTH=65536;var w=["comment","sgmlDecl","textNode","tagName","doctype","procInstName","procInstBody","entity","attribName","attribValue","cdata","script"];t.EVENTS=["text","processinginstruction","sgmldeclaration","doctype","comment","opentagstart","attribute","opentag","closetag","opencdata","cdata","closecdata","error","end","ready","script","opennamespace","closenamespace"],Object.create||(Object.create=function(e){function t(){}t.prototype=e;var n=new t;return n}),Object.keys||(Object.keys=function(e){var t=[];for(var n in e)e.hasOwnProperty(n)&&t.push(n);return t}),r.prototype={end:function(){A(this)},write:C,resume:function(){return this.error=null,this},close:function(){return this.write(null)},flush:function(){o(this)}};var P;try{P=n(106).Stream}catch(e){P=function(){}}var L=t.EVENTS.filter(function(e){return"error"!==e&&"end"!==e});u.prototype=Object.create(P.prototype,{constructor:{value:u}}),u.prototype.write=function(t){if("function"==typeof e&&"function"==typeof e.isBuffer&&e.isBuffer(t)){if(!this._decoder){var r=n(132).StringDecoder;this._decoder=new r("utf8")}t=this._decoder.write(t)}return this._parser.write(t.toString()),this.emit("data",t),!0},u.prototype.end=function(e){return e&&e.length&&this.write(e),this._parser.end(),!0},u.prototype.on=function(e,t){var n=this;return n._parser["on"+e]||L.indexOf(e)===-1||(n._parser["on"+e]=function(){var t=1===arguments.length?[arguments[0]]:Array.apply(null,arguments);t.splice(0,0,e),n.emit.apply(n,t)}),P.prototype.on.call(n,e,t)};var O="[CDATA[",D="DOCTYPE",U="http://www.w3.org/XML/1998/namespace",x="http://www.w3.org/2000/xmlns/",k={xml:U,xmlns:x},F=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,B=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/,V=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,K=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/,j=0;t.STATE={BEGIN:j++,BEGIN_WHITESPACE:j++,TEXT:j++,TEXT_ENTITY:j++,OPEN_WAKA:j++,SGML_DECL:j++,SGML_DECL_QUOTED:j++,DOCTYPE:j++,DOCTYPE_QUOTED:j++,DOCTYPE_DTD:j++,DOCTYPE_DTD_QUOTED:j++,COMMENT_STARTING:j++,COMMENT:j++,COMMENT_ENDING:j++,COMMENT_ENDED:j++,CDATA:j++,CDATA_ENDING:j++,CDATA_ENDING_2:j++,PROC_INST:j++,PROC_INST_BODY:j++,PROC_INST_ENDING:j++,OPEN_TAG:j++,OPEN_TAG_SLASH:j++,ATTRIB:j++,ATTRIB_NAME:j++,ATTRIB_NAME_SAW_WHITE:j++,ATTRIB_VALUE:j++,ATTRIB_VALUE_QUOTED:j++,ATTRIB_VALUE_CLOSED:j++,ATTRIB_VALUE_UNQUOTED:j++,ATTRIB_VALUE_ENTITY_Q:j++,ATTRIB_VALUE_ENTITY_U:j++,CLOSE_TAG:j++,CLOSE_TAG_SAW_WHITE:j++,SCRIPT:j++,SCRIPT_ENDING:j++},t.XML_ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'"},t.ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'",AElig:198,Aacute:193,Acirc:194,Agrave:192,Aring:197,Atilde:195,Auml:196,Ccedil:199,ETH:208,Eacute:201,Ecirc:202,Egrave:200,Euml:203,Iacute:205,Icirc:206,Igrave:204,Iuml:207,Ntilde:209,Oacute:211,Ocirc:212,Ograve:210,Oslash:216,Otilde:213,Ouml:214,THORN:222,Uacute:218,Ucirc:219,Ugrave:217,Uuml:220,Yacute:221,aacute:225,acirc:226,aelig:230,agrave:224,aring:229,atilde:227,auml:228,ccedil:231,eacute:233,ecirc:234,egrave:232,eth:240,euml:235,iacute:237,icirc:238,igrave:236,iuml:239,ntilde:241,oacute:243,ocirc:244,ograve:242,oslash:248,otilde:245,ouml:246,szlig:223,thorn:254,uacute:250,ucirc:251,ugrave:249,uuml:252,yacute:253,yuml:255,copy:169,reg:174,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,ordf:170,laquo:171,not:172,shy:173,macr:175,deg:176,plusmn:177,sup1:185,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,times:215,divide:247,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,int:8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830},Object.keys(t.ENTITIES).forEach(function(e){var n=t.ENTITIES[e],r="number"==typeof n?String.fromCharCode(n):n;t.ENTITIES[e]=r});for(var W in t.STATE)t.STATE[t.STATE[W]]=W;j=t.STATE,/*! http://mths.be/fromcodepoint v0.1.0 by @mathias */
String.fromCodePoint||!function(){var e=String.fromCharCode,t=Math.floor,n=function(){var n,r,i=16384,a=[],o=-1,s=arguments.length;if(!s)return"";for(var u="";++o<s;){var l=Number(arguments[o]);if(!isFinite(l)||l<0||l>1114111||t(l)!==l)throw RangeError("Invalid code point: "+l);l<=65535?a.push(l):(l-=65536,n=(l>>10)+55296,r=l%1024+56320,a.push(n,r)),(o+1===s||a.length>i)&&(u+=e.apply(null,a),a.length=0)}return u};Object.defineProperty?Object.defineProperty(String,"fromCodePoint",{value:n,configurable:!0,writable:!0}):String.fromCodePoint=n}()}(t)}).call(t,n(43).Buffer)},function(e,t,n){function r(){i.call(this)}e.exports=r;var i=n(107).EventEmitter,a=n(108);a(r,i),r.Readable=n(109),r.Writable=n(128),r.Duplex=n(129),r.Transform=n(130),r.PassThrough=n(131),r.Stream=r,r.prototype.pipe=function(e,t){function n(t){e.writable&&!1===e.write(t)&&l.pause&&l.pause()}function r(){l.readable&&l.resume&&l.resume()}function a(){p||(p=!0,e.end())}function o(){p||(p=!0,"function"==typeof e.destroy&&e.destroy())}function s(e){if(u(),0===i.listenerCount(this,"error"))throw e}function u(){l.removeListener("data",n),e.removeListener("drain",r),l.removeListener("end",a),l.removeListener("close",o),l.removeListener("error",s),e.removeListener("error",s),l.removeListener("end",u),l.removeListener("close",u),e.removeListener("close",u)}var l=this;l.on("data",n),e.on("drain",r),e._isStdio||t&&t.end===!1||(l.on("end",a),l.on("close",o));var p=!1;return l.on("error",s),e.on("error",s),l.on("end",u),l.on("close",u),e.on("close",u),e.emit("pipe",l),e}},function(e,t){function n(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function r(e){return"function"==typeof e}function i(e){return"number"==typeof e}function a(e){return"object"==typeof e&&null!==e}function o(e){return void 0===e}e.exports=n,n.EventEmitter=n,n.prototype._events=void 0,n.prototype._maxListeners=void 0,n.defaultMaxListeners=10,n.prototype.setMaxListeners=function(e){if(!i(e)||e<0||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},n.prototype.emit=function(e){var t,n,i,s,u,l;if(this._events||(this._events={}),"error"===e&&(!this._events.error||a(this._events.error)&&!this._events.error.length)){if(t=arguments[1],t instanceof Error)throw t;var p=new Error('Uncaught, unspecified "error" event. ('+t+")");throw p.context=t,p}if(n=this._events[e],o(n))return!1;if(r(n))switch(arguments.length){case 1:n.call(this);break;case 2:n.call(this,arguments[1]);break;case 3:n.call(this,arguments[1],arguments[2]);break;default:s=Array.prototype.slice.call(arguments,1),n.apply(this,s)}else if(a(n))for(s=Array.prototype.slice.call(arguments,1),l=n.slice(),i=l.length,u=0;u<i;u++)l[u].apply(this,s);return!0},n.prototype.addListener=function(e,t){var i;if(!r(t))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,r(t.listener)?t.listener:t),this._events[e]?a(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,a(this._events[e])&&!this._events[e].warned&&(i=o(this._maxListeners)?n.defaultMaxListeners:this._maxListeners,i&&i>0&&this._events[e].length>i&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),"function"==typeof console.trace&&console.trace())),this},n.prototype.on=n.prototype.addListener,n.prototype.once=function(e,t){function n(){this.removeListener(e,n),i||(i=!0,t.apply(this,arguments))}if(!r(t))throw TypeError("listener must be a function");var i=!1;return n.listener=t,this.on(e,n),this},n.prototype.removeListener=function(e,t){var n,i,o,s;if(!r(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;if(n=this._events[e],o=n.length,i=-1,n===t||r(n.listener)&&n.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(a(n)){for(s=o;s-- >0;)if(n[s]===t||n[s].listener&&n[s].listener===t){i=s;break}if(i<0)return this;1===n.length?(n.length=0,delete this._events[e]):n.splice(i,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},n.prototype.removeAllListeners=function(e){var t,n;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[e]&&delete this._events[e],this;if(0===arguments.length){for(t in this._events)"removeListener"!==t&&this.removeAllListeners(t);return this.removeAllListeners("removeListener"),this._events={},this}if(n=this._events[e],r(n))this.removeListener(e,n);else if(n)for(;n.length;)this.removeListener(e,n[n.length-1]);return delete this._events[e],this},n.prototype.listeners=function(e){var t;return t=this._events&&this._events[e]?r(this._events[e])?[this._events[e]]:this._events[e].slice():[]},n.prototype.listenerCount=function(e){if(this._events){var t=this._events[e];if(r(t))return 1;if(t)return t.length}return 0},n.listenerCount=function(e,t){return e.listenerCount(t)}},function(e,t){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e}},function(e,t,n){t=e.exports=n(110),t.Stream=t,t.Readable=t,t.Writable=n(121),t.Duplex=n(120),t.Transform=n(126),t.PassThrough=n(127)},function(e,t,n){(function(t,r){"use strict";function i(e){return k.from(e)}function a(e){return k.isBuffer(e)||e instanceof F}function o(e,t,n){return"function"==typeof e.prependListener?e.prependListener(t,n):void(e._events&&e._events[t]?D(e._events[t])?e._events[t].unshift(n):e._events[t]=[n,e._events[t]]:e.on(t,n))}function s(e,t){O=O||n(120),e=e||{},this.objectMode=!!e.objectMode,t instanceof O&&(this.objectMode=this.objectMode||!!e.readableObjectMode);var r=e.highWaterMark,i=this.objectMode?16:16384;this.highWaterMark=r||0===r?r:i,this.highWaterMark=Math.floor(this.highWaterMark),this.buffer=new W,this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.destroyed=!1,this.defaultEncoding=e.defaultEncoding||"utf8",this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(j||(j=n(125).StringDecoder),this.decoder=new j(e.encoding),this.encoding=e.encoding)}function u(e){return O=O||n(120),this instanceof u?(this._readableState=new s(e,this),this.readable=!0,e&&("function"==typeof e.read&&(this._read=e.read),"function"==typeof e.destroy&&(this._destroy=e.destroy)),void x.call(this)):new u(e)}function l(e,t,n,r,a){var o=e._readableState;if(null===t)o.reading=!1,m(e,o);else{var s;a||(s=c(o,t)),s?e.emit("error",s):o.objectMode||t&&t.length>0?("string"==typeof t||o.objectMode||Object.getPrototypeOf(t)===k.prototype||(t=i(t)),r?o.endEmitted?e.emit("error",new Error("stream.unshift() after end event")):p(e,o,t,!0):o.ended?e.emit("error",new Error("stream.push() after EOF")):(o.reading=!1,o.decoder&&!n?(t=o.decoder.write(t),o.objectMode||0!==t.length?p(e,o,t,!1):g(e,o)):p(e,o,t,!1))):r||(o.reading=!1)}return f(o)}function p(e,t,n,r){t.flowing&&0===t.length&&!t.sync?(e.emit("data",n),e.read(0)):(t.length+=t.objectMode?1:n.length,r?t.buffer.unshift(n):t.buffer.push(n),t.needReadable&&y(e)),g(e,t)}function c(e,t){var n;return a(t)||"string"==typeof t||void 0===t||e.objectMode||(n=new TypeError("Invalid non-string/buffer chunk")),n}function f(e){return!e.ended&&(e.needReadable||e.length<e.highWaterMark||0===e.length)}function h(e){return e>=q?e=q:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}function d(e,t){return e<=0||0===t.length&&t.ended?0:t.objectMode?1:e!==e?t.flowing&&t.length?t.buffer.head.data.length:t.length:(e>t.highWaterMark&&(t.highWaterMark=h(e)),e<=t.length?e:t.ended?t.length:(t.needReadable=!0,0))}function m(e,t){if(!t.ended){if(t.decoder){var n=t.decoder.end();n&&n.length&&(t.buffer.push(n),t.length+=t.objectMode?1:n.length)}t.ended=!0,y(e)}}function y(e){var t=e._readableState;t.needReadable=!1,t.emittedReadable||(K("emitReadable",t.flowing),t.emittedReadable=!0,t.sync?L(v,e):v(e))}function v(e){K("emit readable"),e.emit("readable"),N(e)}function g(e,t){t.readingMore||(t.readingMore=!0,L(A,e,t))}function A(e,t){for(var n=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(K("maybeReadMore read 0"),e.read(0),n!==t.length);)n=t.length;t.readingMore=!1}function E(e){return function(){var t=e._readableState;K("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,0===t.awaitDrain&&U(e,"data")&&(t.flowing=!0,N(e))}}function _(e){K("readable nexttick read 0"),e.read(0)}function T(e,t){t.resumeScheduled||(t.resumeScheduled=!0,L(S,e,t))}function S(e,t){t.reading||(K("resume read 0"),e.read(0)),t.resumeScheduled=!1,t.awaitDrain=0,e.emit("resume"),N(e),t.flowing&&!t.reading&&e.read(0)}function N(e){var t=e._readableState;for(K("flow",t.flowing);t.flowing&&null!==e.read(););}function I(e,t){if(0===t.length)return null;var n;return t.objectMode?n=t.buffer.shift():!e||e>=t.length?(n=t.decoder?t.buffer.join(""):1===t.buffer.length?t.buffer.head.data:t.buffer.concat(t.length),t.buffer.clear()):n=b(e,t.buffer,t.decoder),n}function b(e,t,n){var r;return e<t.head.data.length?(r=t.head.data.slice(0,e),t.head.data=t.head.data.slice(e)):r=e===t.head.data.length?t.shift():n?R(e,t):M(e,t),r}function R(e,t){var n=t.head,r=1,i=n.data;for(e-=i.length;n=n.next;){var a=n.data,o=e>a.length?a.length:e;if(i+=o===a.length?a:a.slice(0,e),e-=o,0===e){o===a.length?(++r,n.next?t.head=n.next:t.head=t.tail=null):(t.head=n,n.data=a.slice(o));break}++r}return t.length-=r,i}function M(e,t){var n=k.allocUnsafe(e),r=t.head,i=1;for(r.data.copy(n),e-=r.data.length;r=r.next;){var a=r.data,o=e>a.length?a.length:e;if(a.copy(n,n.length-e,0,o),e-=o,0===e){o===a.length?(++i,r.next?t.head=r.next:t.head=t.tail=null):(t.head=r,r.data=a.slice(o));break}++i}return t.length-=i,n}function C(e){var t=e._readableState;if(t.length>0)throw new Error('"endReadable()" called on non-empty stream');t.endEmitted||(t.ended=!0,L(w,t,e))}function w(e,t){e.endEmitted||0!==e.length||(e.endEmitted=!0,t.readable=!1,t.emit("end"))}function P(e,t){for(var n=0,r=e.length;n<r;n++)if(e[n]===t)return n;return-1}var L=n(111);e.exports=u;var O,D=n(112);u.ReadableState=s;var U=(n(107).EventEmitter,function(e,t){return e.listeners(t).length}),x=n(113),k=n(114).Buffer,F=t.Uint8Array||function(){},B=n(115);B.inherits=n(116);var V=n(117),K=void 0;K=V&&V.debuglog?V.debuglog("stream"):function(){};var j,W=n(118),H=n(119);B.inherits(u,x);var Y=["error","close","destroy","pause","resume"];Object.defineProperty(u.prototype,"destroyed",{get:function(){return void 0!==this._readableState&&this._readableState.destroyed},set:function(e){this._readableState&&(this._readableState.destroyed=e)}}),u.prototype.destroy=H.destroy,u.prototype._undestroy=H.undestroy,u.prototype._destroy=function(e,t){this.push(null),t(e)},u.prototype.push=function(e,t){var n,r=this._readableState;return r.objectMode?n=!0:"string"==typeof e&&(t=t||r.defaultEncoding,t!==r.encoding&&(e=k.from(e,t),t=""),n=!0),l(this,e,t,!1,n)},u.prototype.unshift=function(e){return l(this,e,null,!0,!1)},u.prototype.isPaused=function(){return this._readableState.flowing===!1},u.prototype.setEncoding=function(e){return j||(j=n(125).StringDecoder),this._readableState.decoder=new j(e),this._readableState.encoding=e,this};var q=8388608;u.prototype.read=function(e){K("read",e),e=parseInt(e,10);var t=this._readableState,n=e;if(0!==e&&(t.emittedReadable=!1),0===e&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return K("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?C(this):y(this),null;if(e=d(e,t),0===e&&t.ended)return 0===t.length&&C(this),null;var r=t.needReadable;K("need readable",r),(0===t.length||t.length-e<t.highWaterMark)&&(r=!0,K("length less than watermark",r)),t.ended||t.reading?(r=!1,K("reading or ended",r)):r&&(K("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1,t.reading||(e=d(n,t)));var i;return i=e>0?I(e,t):null,null===i?(t.needReadable=!0,e=0):t.length-=e,0===t.length&&(t.ended||(t.needReadable=!0),n!==e&&t.ended&&C(this)),null!==i&&this.emit("data",i),i},u.prototype._read=function(e){this.emit("error",new Error("_read() is not implemented"))},u.prototype.pipe=function(e,t){function n(e,t){K("onunpipe"),e===f&&t&&t.hasUnpiped===!1&&(t.hasUnpiped=!0,a())}function i(){K("onend"),e.end()}function a(){K("cleanup"),e.removeListener("close",l),e.removeListener("finish",p),e.removeListener("drain",y),e.removeListener("error",u),e.removeListener("unpipe",n),f.removeListener("end",i),f.removeListener("end",c),f.removeListener("data",s),v=!0,!h.awaitDrain||e._writableState&&!e._writableState.needDrain||y()}function s(t){K("ondata"),g=!1;var n=e.write(t);!1!==n||g||((1===h.pipesCount&&h.pipes===e||h.pipesCount>1&&P(h.pipes,e)!==-1)&&!v&&(K("false write response, pause",f._readableState.awaitDrain),f._readableState.awaitDrain++,g=!0),f.pause())}function u(t){K("onerror",t),c(),e.removeListener("error",u),0===U(e,"error")&&e.emit("error",t)}function l(){e.removeListener("finish",p),c()}function p(){K("onfinish"),e.removeListener("close",l),c()}function c(){K("unpipe"),f.unpipe(e)}var f=this,h=this._readableState;switch(h.pipesCount){case 0:h.pipes=e;break;case 1:h.pipes=[h.pipes,e];break;default:h.pipes.push(e)}h.pipesCount+=1,K("pipe count=%d opts=%j",h.pipesCount,t);var d=(!t||t.end!==!1)&&e!==r.stdout&&e!==r.stderr,m=d?i:c;h.endEmitted?L(m):f.once("end",m),e.on("unpipe",n);var y=E(f);e.on("drain",y);var v=!1,g=!1;return f.on("data",s),o(e,"error",u),e.once("close",l),e.once("finish",p),e.emit("pipe",f),h.flowing||(K("pipe resume"),f.resume()),e},u.prototype.unpipe=function(e){var t=this._readableState,n={hasUnpiped:!1};if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes?this:(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this,n),this);if(!e){var r=t.pipes,i=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var a=0;a<i;a++)r[a].emit("unpipe",this,n);return this}var o=P(t.pipes,e);return o===-1?this:(t.pipes.splice(o,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this,n),this)},u.prototype.on=function(e,t){var n=x.prototype.on.call(this,e,t);if("data"===e)this._readableState.flowing!==!1&&this.resume();else if("readable"===e){var r=this._readableState;r.endEmitted||r.readableListening||(r.readableListening=r.needReadable=!0,r.emittedReadable=!1,r.reading?r.length&&y(this):L(_,this))}return n},u.prototype.addListener=u.prototype.on,u.prototype.resume=function(){var e=this._readableState;return e.flowing||(K("resume"),e.flowing=!0,T(this,e)),this},u.prototype.pause=function(){return K("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(K("pause"),this._readableState.flowing=!1,this.emit("pause")),this},u.prototype.wrap=function(e){var t=this._readableState,n=!1,r=this;e.on("end",function(){if(K("wrapped end"),t.decoder&&!t.ended){var e=t.decoder.end();e&&e.length&&r.push(e)}r.push(null)}),e.on("data",function(i){if(K("wrapped data"),t.decoder&&(i=t.decoder.write(i)),(!t.objectMode||null!==i&&void 0!==i)&&(t.objectMode||i&&i.length)){var a=r.push(i);a||(n=!0,e.pause())}});for(var i in e)void 0===this[i]&&"function"==typeof e[i]&&(this[i]=function(t){return function(){return e[t].apply(e,arguments)}}(i));for(var a=0;a<Y.length;a++)e.on(Y[a],r.emit.bind(r,Y[a]));return r._read=function(t){K("wrapped _read",t),n&&(n=!1,e.resume())},r},u._fromList=I}).call(t,function(){return this}(),n(7))},function(e,t,n){(function(t){"use strict";function n(e,n,r,i){if("function"!=typeof e)throw new TypeError('"callback" argument must be a function');var a,o,s=arguments.length;switch(s){case 0:case 1:return t.nextTick(e);case 2:return t.nextTick(function(){e.call(null,n)});case 3:return t.nextTick(function(){e.call(null,n,r)});case 4:return t.nextTick(function(){e.call(null,n,r,i)});default:for(a=new Array(s-1),o=0;o<a.length;)a[o++]=arguments[o];return t.nextTick(function(){e.apply(null,a)})}}!t.version||0===t.version.indexOf("v0.")||0===t.version.indexOf("v1.")&&0!==t.version.indexOf("v1.8.")?e.exports=n:e.exports=t.nextTick}).call(t,n(7))},function(e,t){var n={}.toString;e.exports=Array.isArray||function(e){return"[object Array]"==n.call(e)}},function(e,t,n){e.exports=n(107).EventEmitter},function(e,t,n){function r(e,t){for(var n in e)t[n]=e[n]}function i(e,t,n){return o(e,t,n)}var a=n(43),o=a.Buffer;o.from&&o.alloc&&o.allocUnsafe&&o.allocUnsafeSlow?e.exports=a:(r(a,t),t.Buffer=i),r(o,i),i.from=function(e,t,n){if("number"==typeof e)throw new TypeError("Argument must not be a number");return o(e,t,n)},i.alloc=function(e,t,n){if("number"!=typeof e)throw new TypeError("Argument must be a number");var r=o(e);return void 0!==t?"string"==typeof n?r.fill(t,n):r.fill(t):r.fill(0),r},i.allocUnsafe=function(e){if("number"!=typeof e)throw new TypeError("Argument must be a number");return o(e)},i.allocUnsafeSlow=function(e){if("number"!=typeof e)throw new TypeError("Argument must be a number");return a.SlowBuffer(e)}},function(e,t,n){(function(e){function n(e){return Array.isArray?Array.isArray(e):"[object Array]"===y(e)}function r(e){return"boolean"==typeof e}function i(e){return null===e}function a(e){return null==e}function o(e){return"number"==typeof e}function s(e){return"string"==typeof e}function u(e){return"symbol"==typeof e}function l(e){return void 0===e}function p(e){return"[object RegExp]"===y(e)}function c(e){return"object"==typeof e&&null!==e}function f(e){return"[object Date]"===y(e)}function h(e){return"[object Error]"===y(e)||e instanceof Error}function d(e){return"function"==typeof e}function m(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||"undefined"==typeof e}function y(e){return Object.prototype.toString.call(e)}t.isArray=n,t.isBoolean=r,t.isNull=i,t.isNullOrUndefined=a,t.isNumber=o,t.isString=s,t.isSymbol=u,t.isUndefined=l,t.isRegExp=p,t.isObject=c,t.isDate=f,t.isError=h,t.isFunction=d,t.isPrimitive=m,t.isBuffer=e.isBuffer}).call(t,n(43).Buffer)},function(e,t){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e}},function(e,t){},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function i(e,t,n){e.copy(t,n)}var a=n(114).Buffer;e.exports=function(){function e(){r(this,e),this.head=null,this.tail=null,this.length=0}return e.prototype.push=function(e){var t={data:e,next:null};this.length>0?this.tail.next=t:this.head=t,this.tail=t,++this.length},e.prototype.unshift=function(e){var t={data:e,next:this.head};0===this.length&&(this.tail=t),this.head=t,++this.length},e.prototype.shift=function(){if(0!==this.length){var e=this.head.data;return 1===this.length?this.head=this.tail=null:this.head=this.head.next,--this.length,e}},e.prototype.clear=function(){this.head=this.tail=null,this.length=0},e.prototype.join=function(e){if(0===this.length)return"";for(var t=this.head,n=""+t.data;t=t.next;)n+=e+t.data;return n},e.prototype.concat=function(e){if(0===this.length)return a.alloc(0);if(1===this.length)return this.head.data;for(var t=a.allocUnsafe(e>>>0),n=this.head,r=0;n;)i(n.data,t,r),r+=n.data.length,n=n.next;return t},e}()},function(e,t,n){"use strict";function r(e,t){var n=this,r=this._readableState&&this._readableState.destroyed,i=this._writableState&&this._writableState.destroyed;return r||i?void(t?t(e):!e||this._writableState&&this._writableState.errorEmitted||o(a,this,e)):(this._readableState&&(this._readableState.destroyed=!0),this._writableState&&(this._writableState.destroyed=!0),void this._destroy(e||null,function(e){!t&&e?(o(a,n,e),n._writableState&&(n._writableState.errorEmitted=!0)):t&&t(e)}))}function i(){this._readableState&&(this._readableState.destroyed=!1,this._readableState.reading=!1,this._readableState.ended=!1,this._readableState.endEmitted=!1),this._writableState&&(this._writableState.destroyed=!1,this._writableState.ended=!1,this._writableState.ending=!1,this._writableState.finished=!1,this._writableState.errorEmitted=!1)}function a(e,t){e.emit("error",t)}var o=n(111);e.exports={destroy:r,undestroy:i}},function(e,t,n){"use strict";function r(e){return this instanceof r?(l.call(this,e),p.call(this,e),e&&e.readable===!1&&(this.readable=!1),e&&e.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,e&&e.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",i)):new r(e)}function i(){this.allowHalfOpen||this._writableState.ended||o(a,this)}function a(e){e.end()}var o=n(111),s=Object.keys||function(e){var t=[];for(var n in e)t.push(n);return t};e.exports=r;var u=n(115);u.inherits=n(116);var l=n(110),p=n(121);u.inherits(r,l);for(var c=s(p.prototype),f=0;f<c.length;f++){var h=c[f];r.prototype[h]||(r.prototype[h]=p.prototype[h])}Object.defineProperty(r.prototype,"destroyed",{get:function(){return void 0!==this._readableState&&void 0!==this._writableState&&(this._readableState.destroyed&&this._writableState.destroyed)},set:function(e){void 0!==this._readableState&&void 0!==this._writableState&&(this._readableState.destroyed=e,this._writableState.destroyed=e)}}),r.prototype._destroy=function(e,t){this.push(null),this.end(),o(t,e)}},function(e,t,n){(function(t,r,i){"use strict";function a(e){var t=this;this.next=null,this.entry=null,this.finish=function(){R(t,e)}}function o(e){return D.from(e)}function s(e){return D.isBuffer(e)||e instanceof U}function u(){}function l(e,t){C=C||n(120),e=e||{},this.objectMode=!!e.objectMode,t instanceof C&&(this.objectMode=this.objectMode||!!e.writableObjectMode);var r=e.highWaterMark,i=this.objectMode?16:16384;this.highWaterMark=r||0===r?r:i,this.highWaterMark=Math.floor(this.highWaterMark),this.finalCalled=!1,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1,this.destroyed=!1;var o=e.decodeStrings===!1;this.decodeStrings=!o,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){g(t,e)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new a(this)}function p(e){return C=C||n(120),k.call(p,this)||this instanceof C?(this._writableState=new l(e,this),this.writable=!0,e&&("function"==typeof e.write&&(this._write=e.write),"function"==typeof e.writev&&(this._writev=e.writev),"function"==typeof e.destroy&&(this._destroy=e.destroy),"function"==typeof e.final&&(this._final=e.final)),void O.call(this)):new p(e)}function c(e,t){var n=new Error("write after end");e.emit("error",n),M(t,n)}function f(e,t,n,r){var i=!0,a=!1;return null===n?a=new TypeError("May not write null values to stream"):"string"==typeof n||void 0===n||t.objectMode||(a=new TypeError("Invalid non-string/buffer chunk")),a&&(e.emit("error",a),M(r,a),i=!1),i}function h(e,t,n){return e.objectMode||e.decodeStrings===!1||"string"!=typeof t||(t=D.from(t,n)),t}function d(e,t,n,r,i,a){if(!n){var o=h(t,r,i);r!==o&&(n=!0,i="buffer",r=o)}var s=t.objectMode?1:r.length;t.length+=s;var u=t.length<t.highWaterMark;if(u||(t.needDrain=!0),t.writing||t.corked){var l=t.lastBufferedRequest;t.lastBufferedRequest={chunk:r,encoding:i,isBuf:n,callback:a,next:null},l?l.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1}else m(e,t,!1,s,r,i,a);return u}function m(e,t,n,r,i,a,o){t.writelen=r,t.writecb=o,t.writing=!0,t.sync=!0,n?e._writev(i,t.onwrite):e._write(i,a,t.onwrite),t.sync=!1}function y(e,t,n,r,i){--t.pendingcb,n?(M(i,r),M(I,e,t),e._writableState.errorEmitted=!0,e.emit("error",r)):(i(r),e._writableState.errorEmitted=!0,e.emit("error",r),I(e,t))}function v(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}function g(e,t){var n=e._writableState,r=n.sync,i=n.writecb;if(v(n),t)y(e,n,r,t,i);else{var a=T(n);a||n.corked||n.bufferProcessing||!n.bufferedRequest||_(e,n),r?w(A,e,n,a,i):A(e,n,a,i)}}function A(e,t,n,r){n||E(e,t),t.pendingcb--,r(),I(e,t)}function E(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}function _(e,t){t.bufferProcessing=!0;var n=t.bufferedRequest;if(e._writev&&n&&n.next){var r=t.bufferedRequestCount,i=new Array(r),o=t.corkedRequestsFree;o.entry=n;for(var s=0,u=!0;n;)i[s]=n,n.isBuf||(u=!1),n=n.next,s+=1;i.allBuffers=u,m(e,t,!0,t.length,i,"",o.finish),t.pendingcb++,t.lastBufferedRequest=null,o.next?(t.corkedRequestsFree=o.next,o.next=null):t.corkedRequestsFree=new a(t)}else{for(;n;){var l=n.chunk,p=n.encoding,c=n.callback,f=t.objectMode?1:l.length;if(m(e,t,!1,f,l,p,c),n=n.next,t.writing)break}null===n&&(t.lastBufferedRequest=null)}t.bufferedRequestCount=0,t.bufferedRequest=n,t.bufferProcessing=!1}function T(e){return e.ending&&0===e.length&&null===e.bufferedRequest&&!e.finished&&!e.writing}function S(e,t){e._final(function(n){t.pendingcb--,n&&e.emit("error",n),t.prefinished=!0,e.emit("prefinish"),I(e,t)})}function N(e,t){t.prefinished||t.finalCalled||("function"==typeof e._final?(t.pendingcb++,t.finalCalled=!0,M(S,e,t)):(t.prefinished=!0,e.emit("prefinish")))}function I(e,t){var n=T(t);return n&&(N(e,t),0===t.pendingcb&&(t.finished=!0,e.emit("finish"))),n}function b(e,t,n){t.ending=!0,I(e,t),n&&(t.finished?M(n):e.once("finish",n)),t.ended=!0,e.writable=!1}function R(e,t,n){var r=e.entry;for(e.entry=null;r;){var i=r.callback;t.pendingcb--,i(n),r=r.next}t.corkedRequestsFree?t.corkedRequestsFree.next=e:t.corkedRequestsFree=e}var M=n(111);e.exports=p;var C,w=!t.browser&&["v0.10","v0.9."].indexOf(t.version.slice(0,5))>-1?r:M;p.WritableState=l;var P=n(115);P.inherits=n(116);var L={deprecate:n(124)},O=n(113),D=n(114).Buffer,U=i.Uint8Array||function(){},x=n(119);P.inherits(p,O),l.prototype.getBuffer=function(){for(var e=this.bufferedRequest,t=[];e;)t.push(e),e=e.next;return t},function(){try{Object.defineProperty(l.prototype,"buffer",{get:L.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.","DEP0003")})}catch(e){}}();var k;"function"==typeof Symbol&&Symbol.hasInstance&&"function"==typeof Function.prototype[Symbol.hasInstance]?(k=Function.prototype[Symbol.hasInstance],Object.defineProperty(p,Symbol.hasInstance,{value:function(e){return!!k.call(this,e)||e&&e._writableState instanceof l}})):k=function(e){return e instanceof this},p.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe, not readable"))},p.prototype.write=function(e,t,n){var r=this._writableState,i=!1,a=s(e)&&!r.objectMode;return a&&!D.isBuffer(e)&&(e=o(e)),"function"==typeof t&&(n=t,t=null),a?t="buffer":t||(t=r.defaultEncoding),"function"!=typeof n&&(n=u),r.ended?c(this,n):(a||f(this,r,e,n))&&(r.pendingcb++,i=d(this,r,a,e,t,n)),i},p.prototype.cork=function(){var e=this._writableState;e.corked++},p.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,e.writing||e.corked||e.finished||e.bufferProcessing||!e.bufferedRequest||_(this,e))},p.prototype.setDefaultEncoding=function(e){if("string"==typeof e&&(e=e.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((e+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+e);return this._writableState.defaultEncoding=e,this},p.prototype._write=function(e,t,n){n(new Error("_write() is not implemented"))},p.prototype._writev=null,p.prototype.end=function(e,t,n){var r=this._writableState;"function"==typeof e?(n=e,e=null,t=null):"function"==typeof t&&(n=t,t=null),null!==e&&void 0!==e&&this.write(e,t),r.corked&&(r.corked=1,this.uncork()),r.ending||r.finished||b(this,r,n)},Object.defineProperty(p.prototype,"destroyed",{get:function(){return void 0!==this._writableState&&this._writableState.destroyed},set:function(e){this._writableState&&(this._writableState.destroyed=e)}}),p.prototype.destroy=x.destroy,p.prototype._undestroy=x.undestroy,p.prototype._destroy=function(e,t){this.end(),t(e)}}).call(t,n(7),n(122).setImmediate,function(){return this}())},function(e,t,n){function r(e,t){this._id=e,this._clearFn=t}var i=Function.prototype.apply;t.setTimeout=function(){return new r(i.call(setTimeout,window,arguments),clearTimeout)},t.setInterval=function(){return new r(i.call(setInterval,window,arguments),clearInterval)},t.clearTimeout=t.clearInterval=function(e){e&&e.close()},r.prototype.unref=r.prototype.ref=function(){},r.prototype.close=function(){this._clearFn.call(window,this._id)},t.enroll=function(e,t){clearTimeout(e._idleTimeoutId),e._idleTimeout=t},t.unenroll=function(e){clearTimeout(e._idleTimeoutId),e._idleTimeout=-1},t._unrefActive=t.active=function(e){clearTimeout(e._idleTimeoutId);var t=e._idleTimeout;t>=0&&(e._idleTimeoutId=setTimeout(function(){e._onTimeout&&e._onTimeout()},t))},n(123),t.setImmediate=setImmediate,t.clearImmediate=clearImmediate},function(e,t,n){(function(e,t){!function(e,n){"use strict";function r(e){"function"!=typeof e&&(e=new Function(""+e));for(var t=new Array(arguments.length-1),n=0;n<t.length;n++)t[n]=arguments[n+1];var r={callback:e,args:t};return m[d]=r,h(d),d++}function i(e){delete m[e]}function a(e){var t=e.callback,r=e.args;switch(r.length){case 0:t();break;case 1:t(r[0]);break;case 2:t(r[0],r[1]);break;case 3:t(r[0],r[1],r[2]);break;default:t.apply(n,r)}}function o(e){if(y)setTimeout(o,0,e);else{var t=m[e];if(t){y=!0;try{a(t)}finally{i(e),y=!1}}}}function s(){h=function(e){t.nextTick(function(){o(e)})}}function u(){if(e.postMessage&&!e.importScripts){var t=!0,n=e.onmessage;return e.onmessage=function(){t=!1},e.postMessage("","*"),e.onmessage=n,t}}function l(){var t="setImmediate$"+Math.random()+"$",n=function(n){n.source===e&&"string"==typeof n.data&&0===n.data.indexOf(t)&&o(+n.data.slice(t.length))};e.addEventListener?e.addEventListener("message",n,!1):e.attachEvent("onmessage",n),h=function(n){e.postMessage(t+n,"*")}}function p(){var e=new MessageChannel;e.port1.onmessage=function(e){var t=e.data;o(t)},h=function(t){e.port2.postMessage(t)}}function c(){var e=v.documentElement;h=function(t){var n=v.createElement("script");n.onreadystatechange=function(){o(t),n.onreadystatechange=null,e.removeChild(n),n=null},e.appendChild(n)}}function f(){h=function(e){setTimeout(o,0,e)}}if(!e.setImmediate){var h,d=1,m={},y=!1,v=e.document,g=Object.getPrototypeOf&&Object.getPrototypeOf(e);g=g&&g.setTimeout?g:e,"[object process]"==={}.toString.call(e.process)?s():u()?l():e.MessageChannel?p():v&&"onreadystatechange"in v.createElement("script")?c():f(),g.setImmediate=r,g.clearImmediate=i}}("undefined"==typeof self?"undefined"==typeof e?this:e:self)}).call(t,function(){return this}(),n(7))},function(e,t){(function(t){function n(e,t){function n(){if(!i){if(r("throwDeprecation"))throw new Error(t);r("traceDeprecation")?console.trace(t):console.warn(t),i=!0}return e.apply(this,arguments)}if(r("noDeprecation"))return e;var i=!1;return n}function r(e){try{if(!t.localStorage)return!1}catch(e){return!1}var n=t.localStorage[e];return null!=n&&"true"===String(n).toLowerCase()}e.exports=n}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(e){if(!e)return"utf8";for(var t;;)switch(e){case"utf8":case"utf-8":return"utf8";case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return"utf16le";case"latin1":case"binary":return"latin1";case"base64":case"ascii":case"hex":
return e;default:if(t)return;e=(""+e).toLowerCase(),t=!0}}function i(e){var t=r(e);if("string"!=typeof t&&(g.isEncoding===A||!A(e)))throw new Error("Unknown encoding: "+e);return t||e}function a(e){this.encoding=i(e);var t;switch(this.encoding){case"utf16le":this.text=f,this.end=h,t=4;break;case"utf8":this.fillLast=l,t=4;break;case"base64":this.text=d,this.end=m,t=3;break;default:return this.write=y,void(this.end=v)}this.lastNeed=0,this.lastTotal=0,this.lastChar=g.allocUnsafe(t)}function o(e){return e<=127?0:e>>5===6?2:e>>4===14?3:e>>3===30?4:-1}function s(e,t,n){var r=t.length-1;if(r<n)return 0;var i=o(t[r]);return i>=0?(i>0&&(e.lastNeed=i-1),i):--r<n?0:(i=o(t[r]),i>=0?(i>0&&(e.lastNeed=i-2),i):--r<n?0:(i=o(t[r]),i>=0?(i>0&&(2===i?i=0:e.lastNeed=i-3),i):0))}function u(e,t,n){if(128!==(192&t[0]))return e.lastNeed=0,"�".repeat(n);if(e.lastNeed>1&&t.length>1){if(128!==(192&t[1]))return e.lastNeed=1,"�".repeat(n+1);if(e.lastNeed>2&&t.length>2&&128!==(192&t[2]))return e.lastNeed=2,"�".repeat(n+2)}}function l(e){var t=this.lastTotal-this.lastNeed,n=u(this,e,t);return void 0!==n?n:this.lastNeed<=e.length?(e.copy(this.lastChar,t,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(e.copy(this.lastChar,t,0,e.length),void(this.lastNeed-=e.length))}function p(e,t){var n=s(this,e,t);if(!this.lastNeed)return e.toString("utf8",t);this.lastTotal=n;var r=e.length-(n-this.lastNeed);return e.copy(this.lastChar,0,r),e.toString("utf8",t,r)}function c(e){var t=e&&e.length?this.write(e):"";return this.lastNeed?t+"�".repeat(this.lastTotal-this.lastNeed):t}function f(e,t){if((e.length-t)%2===0){var n=e.toString("utf16le",t);if(n){var r=n.charCodeAt(n.length-1);if(r>=55296&&r<=56319)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=e[e.length-2],this.lastChar[1]=e[e.length-1],n.slice(0,-1)}return n}return this.lastNeed=1,this.lastTotal=2,this.lastChar[0]=e[e.length-1],e.toString("utf16le",t,e.length-1)}function h(e){var t=e&&e.length?this.write(e):"";if(this.lastNeed){var n=this.lastTotal-this.lastNeed;return t+this.lastChar.toString("utf16le",0,n)}return t}function d(e,t){var n=(e.length-t)%3;return 0===n?e.toString("base64",t):(this.lastNeed=3-n,this.lastTotal=3,1===n?this.lastChar[0]=e[e.length-1]:(this.lastChar[0]=e[e.length-2],this.lastChar[1]=e[e.length-1]),e.toString("base64",t,e.length-n))}function m(e){var t=e&&e.length?this.write(e):"";return this.lastNeed?t+this.lastChar.toString("base64",0,3-this.lastNeed):t}function y(e){return e.toString(this.encoding)}function v(e){return e&&e.length?this.write(e):""}var g=n(114).Buffer,A=g.isEncoding||function(e){switch(e=""+e,e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}};t.StringDecoder=a,a.prototype.write=function(e){if(0===e.length)return"";var t,n;if(this.lastNeed){if(t=this.fillLast(e),void 0===t)return"";n=this.lastNeed,this.lastNeed=0}else n=0;return n<e.length?t?t+this.text(e,n):this.text(e,n):t||""},a.prototype.end=c,a.prototype.text=p,a.prototype.fillLast=function(e){return this.lastNeed<=e.length?(e.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(e.copy(this.lastChar,this.lastTotal-this.lastNeed,0,e.length),void(this.lastNeed-=e.length))}},function(e,t,n){"use strict";function r(e){this.afterTransform=function(t,n){return i(e,t,n)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function i(e,t,n){var r=e._transformState;r.transforming=!1;var i=r.writecb;if(!i)return e.emit("error",new Error("write callback called multiple times"));r.writechunk=null,r.writecb=null,null!==n&&void 0!==n&&e.push(n),i(t);var a=e._readableState;a.reading=!1,(a.needReadable||a.length<a.highWaterMark)&&e._read(a.highWaterMark)}function a(e){if(!(this instanceof a))return new a(e);s.call(this,e),this._transformState=new r(this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,e&&("function"==typeof e.transform&&(this._transform=e.transform),"function"==typeof e.flush&&(this._flush=e.flush)),this.once("prefinish",function(){"function"==typeof this._flush?this._flush(function(e,n){o(t,e,n)}):o(t)})}function o(e,t,n){if(t)return e.emit("error",t);null!==n&&void 0!==n&&e.push(n);var r=e._writableState,i=e._transformState;if(r.length)throw new Error("Calling transform done when ws.length != 0");if(i.transforming)throw new Error("Calling transform done when still transforming");return e.push(null)}e.exports=a;var s=n(120),u=n(115);u.inherits=n(116),u.inherits(a,s),a.prototype.push=function(e,t){return this._transformState.needTransform=!1,s.prototype.push.call(this,e,t)},a.prototype._transform=function(e,t,n){throw new Error("_transform() is not implemented")},a.prototype._write=function(e,t,n){var r=this._transformState;if(r.writecb=n,r.writechunk=e,r.writeencoding=t,!r.transforming){var i=this._readableState;(r.needTransform||i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark)}},a.prototype._read=function(e){var t=this._transformState;null!==t.writechunk&&t.writecb&&!t.transforming?(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform)):t.needTransform=!0},a.prototype._destroy=function(e,t){var n=this;s.prototype._destroy.call(this,e,function(e){t(e),n.emit("close")})}},function(e,t,n){"use strict";function r(e){return this instanceof r?void i.call(this,e):new r(e)}e.exports=r;var i=n(126),a=n(115);a.inherits=n(116),a.inherits(r,i),r.prototype._transform=function(e,t,n){n(null,e)}},function(e,t,n){e.exports=n(121)},function(e,t,n){e.exports=n(120)},function(e,t,n){e.exports=n(109).Transform},function(e,t,n){e.exports=n(109).PassThrough},function(e,t,n){function r(e){if(e&&!u(e))throw new Error("Unknown encoding: "+e)}function i(e){return e.toString(this.encoding)}function a(e){this.charReceived=e.length%2,this.charLength=this.charReceived?2:0}function o(e){this.charReceived=e.length%3,this.charLength=this.charReceived?3:0}var s=n(43).Buffer,u=s.isEncoding||function(e){switch(e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},l=t.StringDecoder=function(e){switch(this.encoding=(e||"utf8").toLowerCase().replace(/[-_]/,""),r(e),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=a;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=o;break;default:return void(this.write=i)}this.charBuffer=new s(6),this.charReceived=0,this.charLength=0};l.prototype.write=function(e){for(var t="";this.charLength;){var n=e.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:e.length;if(e.copy(this.charBuffer,this.charReceived,0,n),this.charReceived+=n,this.charReceived<this.charLength)return"";e=e.slice(n,e.length),t=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var r=t.charCodeAt(t.length-1);if(!(r>=55296&&r<=56319)){if(this.charReceived=this.charLength=0,0===e.length)return t;break}this.charLength+=this.surrogateSize,t=""}this.detectIncompleteChar(e);var i=e.length;this.charLength&&(e.copy(this.charBuffer,0,e.length-this.charReceived,i),i-=this.charReceived),t+=e.toString(this.encoding,0,i);var i=t.length-1,r=t.charCodeAt(i);if(r>=55296&&r<=56319){var a=this.surrogateSize;return this.charLength+=a,this.charReceived+=a,this.charBuffer.copy(this.charBuffer,a,0,a),e.copy(this.charBuffer,0,0,a),t.substring(0,i)}return t},l.prototype.detectIncompleteChar=function(e){for(var t=e.length>=3?3:e.length;t>0;t--){var n=e[e.length-t];if(1==t&&n>>5==6){this.charLength=2;break}if(t<=2&&n>>4==14){this.charLength=3;break}if(t<=3&&n>>3==30){this.charLength=4;break}}this.charReceived=t},l.prototype.end=function(e){var t="";if(e&&e.length&&(t=this.write(e)),this.charReceived){var n=this.charReceived,r=this.charBuffer,i=this.encoding;t+=r.slice(0,n).toString(i)}return t}},function(e,t){(function(){"use strict";t.stripBOM=function(e){return"\ufeff"===e[0]?e.substring(1):e}}).call(this)},function(e,t){(function(){"use strict";var e;e=new RegExp(/(?!xmlns)^.*:/),t.normalize=function(e){return e.toLowerCase()},t.firstCharLowerCase=function(e){return e.charAt(0).toLowerCase()+e.slice(1)},t.stripPrefix=function(t){return t.replace(e,"")},t.parseNumbers=function(e){return isNaN(e)||(e=e%1===0?parseInt(e,10):parseFloat(e)),e},t.parseBooleans=function(e){return/^(?:true|false)$/i.test(e)&&(e="true"===e.toLowerCase()),e}}).call(this)},function(e,t,n){"use strict";function r(){return h?h:h=new f}Object.defineProperty(t,"__esModule",{value:!0});var i=n(58),a=n(77),o=n(58),s=n(75),u=n(77),l=n(77),p=n(75),c=function(){function e(e,t){this._construct=e,this._constructWithValue=t}return e.prototype.isSimple=function(){return null!=this._constructWithValue},e.prototype.newInstance=function(){return this._construct()},e.prototype.createWithValue=function(e){return this._constructWithValue(e)},e.prototype.isApplicable=function(e){var t=this.newInstance(),n=t.requiredType(),r=t.requiredTypes();return r&&r.length>0?r.some(function(t){return e.isSubTypeOf(t)}):e.isSubTypeOf(n)},e.prototype.isInheritable=function(){return this.newInstance().isInheritable()},e.prototype.isConstraint=function(){return this.newInstance()instanceof i.Constraint},e.prototype.isMeta=function(){return!this.isConstraint()},e.prototype.name=function(){return this.newInstance().facetName()},e}();t.FacetPrototype=c;var f=function(){function e(){var e=this;this.constraints=[new c(function(){return new s.MinProperties(1)},function(e){return new s.MinProperties(e)}),new c(function(){return new s.MaxProperties(1)},function(e){return new s.MaxProperties(e)}),new c(function(){return new s.MinItems(1)},function(e){return new s.MinItems(e)}),new c(function(){return new s.MaxItems(1)},function(e){return new s.MaxItems(e)}),new c(function(){return new s.MinLength(1)},function(e){return new s.MinLength(e)}),new c(function(){return new s.MaxLength(1)},function(e){return new s.MaxLength(e)}),new c(function(){return new s.Minimum(1)},function(e){return new s.Minimum(e)}),new c(function(){return new p.MultipleOf(1)},function(e){return new p.MultipleOf(e)}),new c(function(){return new s.Maximum(1)},function(e){return new s.Maximum(e)}),new c(function(){return new s.Enum([""])},function(e){return new s.Enum(e)}),new c(function(){return new s.Pattern(".")},function(e){return new s.Pattern(e)}),new c(function(){return new s.Format("")},function(e){return new s.Format(e)}),new c(function(){return new s.PropertyIs("x",i.ANY)},null),new c(function(){return new s.AdditionalPropertyIs(i.ANY)},null),new c(function(){return new s.MapPropertyIs(".",i.ANY)},null),new c(function(){return new s.HasProperty("x")},null),new c(function(){return new s.UniqueItems(!0)},function(e){return new s.UniqueItems(e)}),new c(function(){return new s.ComponentShouldBeOfType(i.ANY)},null),new c(function(){return new s.KnownPropertyRestriction(!1)},function(e){return new s.KnownPropertyRestriction(e)}),new c(function(){return new s.FileTypes([""])},function(e){return new s.FileTypes(e)})],this.meta=[new c(function(){return new a.Discriminator("kind")},function(e){return new a.Discriminator(e)}),new c(function(){return new a.DiscriminatorValue("x")},function(e){return new a.DiscriminatorValue(e)}),new c(function(){return new u.Default("")},function(e){return new u.Default(e)}),new c(function(){return new u.Example("")},function(e){return new u.Example(e)}),new c(function(){return new l.Required(!0)},function(e){return new l.Required(e)}),new c(function(){return new a.Examples({})},function(e){return new a.Examples(e)}),new c(function(){return new u.Description("")},function(e){return new u.Description(e)}),new c(function(){return new u.DisplayName("")},function(e){return new u.DisplayName(e)}),new c(function(){return new o.Abstract},function(e){return new o.Abstract}),new c(function(){return new o.Polymorphic},function(e){return new o.Polymorphic}),new c(function(){return new l.XMLInfo({})},function(e){return new l.XMLInfo(e)}),new c(function(){return new l.AllowedTargets({})},function(e){return new l.AllowedTargets(e)}),new c(function(){return new u.SourceMap({})},function(e){return new u.SourceMap(e)}),new c(function(){return new u.ParserMetadata({})},function(e){return new u.ParserMetadata(e)})],this.known={},this.allPrototypes().forEach(function(t){return e.known[t.name()]=t})}return e.prototype.allPrototypes=function(){return this.meta.concat(this.constraints)},e.prototype.buildFacet=function(e,t){return this.known.hasOwnProperty(e)&&this.known[e].isSimple()?this.known[e].createWithValue(t):null},e.prototype.facetPrototypeWithName=function(e){return this.known.hasOwnProperty(e)?this.known[e]:null},e.prototype.applyableTo=function(e){return this.allPrototypes().filter(function(t){return t.isApplicable(e)})},e.prototype.allMeta=function(){return this.allPrototypes().filter(function(e){return e.isMeta()})},e}();t.Registry=f;var h;t.getInstance=r},function(e,t,n){"use strict";function r(e){var t=e.oneMeta(p.Example);if(t)return t.example();if(e.getExtra(h))return null;e.putExtra(h,!0);try{var n=e.oneMeta(p.Examples);if(n){var i=n.examples();if(i&&i.length>0)return i[0]}var a=e.oneMeta(p.Default);if(a)return a.value();if(e.isObject()){var o={};return e.meta().forEach(function(e){if(e instanceof f.PropertyIs){var t=e,n=r(t.value());o[t.propertyName()]=n}}),e.superTypes().forEach(function(e){if(e.oneMeta(p.Example)||e.oneMeta(p.Examples)){var t=r(e);t&&"object"==typeof t&&Object.keys(t).forEach(function(e){o[e]=t[e]})}}),o}if(e.isArray()){var s=e.oneMeta(c.ComponentShouldBeOfType),u=[];return s&&u.push(r(s.value())),u}return e.isUnion()?r(e.typeFamily()[0]):e.isNumber()?1:!!e.isBoolean()||"some value"}finally{e.putExtra(h,!1)}}function i(e,t){var n=e[t];return null!=n&&"object"==typeof n?n.value:n}function a(e){var t=[];if(!e||"object"!=typeof e)return t;for(var n=0,r=Object.keys(e).filter(function(e){return e.length>0&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)});n<r.length;n++){var i=r[n],a=i.substring(1,i.length-1),o=e[i],s=new p.Annotation(a,o,i);t.push(s)}return t}function o(e){var t=[],n=e.oneMeta(p.Examples);if(n){var r=n.value();if(r&&"object"==typeof r){var i;Object.keys(r).forEach(function(a){var o=Array.isArray(r)?null:a,s=r[a],u=y({asXMLString:function(){return i||(i=n.asXMLStrings()),i[a]},ownerType:function(){return e}},s,o);t.push(u)})}}var a=e.oneMeta(p.Example);if(a){var o=a.example();null!=o&&t.push(y(a,a.value(),void 0,!0))}return t}function s(e){for(var t=o(e),n=[],r=0,i=t;r<i.length;r++){var a=i[r],s=a,u=new m(s.rawValue(),s.name(),s.displayName(),s.description(),s.strict(),s.annotations(),s.isSingle(),s.isEmpty());if(s.scalarsAnnotations())for(var l=0,p=Object.keys(s.scalarsAnnotations());l<p.length;l++)for(var c=p[l],f=s.scalarsAnnotations()[c],h=0,d=Object.keys(f);h<d.length;h++){var y=d[h];u.registerScalarAnnotatoion(f[y],c)}n.push(u)}return n}function u(e,t){var n=e.getAdapter(l.InheritedType);if(n){var r=o(n);if(r&&r.length>0)return r;if(t&&e.isUserDefined()&&!e.isGenuineUserDefinedType()&&e.genuineUserDefinedTypeInHierarchy()){var i=e.genuineUserDefinedTypeInHierarchy(),a=i.getAdapter(l.InheritedType);if(a){var s=o(a);if(s&&s.length>0)return s}}}if(n){var u=new d(null,void 0,void 0,void 0,!1,void 0,void 0,!0);return u.setOwnerType(n),[u]}return[]}Object.defineProperty(t,"__esModule",{value:!0});var l=n(58),p=n(77),c=n(75),f=n(75),h="exampleCalculation";t.example=r;var d=function(){function e(e,t,n,r,i,a,o,s){void 0===t&&(t=void 0),void 0===n&&(n=void 0),void 0===r&&(r=void 0),void 0===i&&(i=!0),void 0===o&&(o=!1),void 0===s&&(s=!1),this._value=e,this._name=t,this._displayName=n,this._description=r,this._strict=i,this._annotations=a,this._isSingle=o,this._empty=s,this.isExpanded=!1,this._scalarsAnnotations={},this._annotations?this._hasAnnotations=!0:this._annotations={},"boolean"!=typeof this._strict&&(this._strict=!1)}return e.prototype.rawValue=function(){return this._value},e.prototype.isEmpty=function(){return this._empty},e.prototype.isJSONString=function(){if(void 0!==this._isJSONString)return this._isJSONString;this._isJSONString=!1;var e=this.firstCharacter();if("{"==e||"["==e)try{JSON.parse(this._value),this._isJSONString=!0}catch(e){}return this._isJSONString},e.prototype.isXMLString=function(){var e=this.firstCharacter();return"<"==e},e.prototype.firstCharacter=function(){if(null==this._value)return null;if("string"!=typeof this._value)return null;var e=this._value.trim();return 0==e.length?null:e.charAt(0)},e.prototype.asXMLString=function(){return this.isXMLString()?this._value:this._owner?this._owner.asXMLString():null},e.prototype.isYAML=function(){return"string"!=typeof this._value||!(this.isJSONString()||this.isXMLString())},e.prototype.asString=function(){return"string"==typeof this._value?""+this._value:JSON.stringify(this._value,null,2)},e.prototype.asJSON=function(){if(this.isJSONString())try{return JSON.parse(this._value)}catch(e){return null}return this.isYAML()?this._value:this.asString()},e.prototype.original=function(){return this._value},e.prototype.expandAsString=function(){return JSON.stringify(this.expandAsJSON(),null,2)},e.prototype.expandAsJSON=function(){return this.isEmpty()?this.isExpanded?this._expandedValue:(this._expandedValue=r(this._ownerType),this.isExpanded=!0,this._expandedValue):this._value},e.prototype.isSingle=function(){return this._isSingle},e.prototype.strict=function(){return this._strict},e.prototype.description=function(){return this._description},e.prototype.displayName=function(){return this._displayName},e.prototype.annotations=function(){return this._annotations},e.prototype.name=function(){return this._name},e.prototype.scalarsAnnotations=function(){return this._scalarsAnnotations},e.prototype.registerScalarAnnotatoion=function(e,t){this._hasScalarAnnotations=!0;var n=this._scalarsAnnotations[t];n||(n={},this._scalarsAnnotations[t]=n),n[e.facetName()]=e},e.prototype.setOwner=function(e){this._owner=e},e.prototype.owner=function(){return this._owner},e.prototype.setOwnerType=function(e){this._ownerType=e},e.prototype.ownerType=function(){return this._ownerType},e.prototype.hasAnnotations=function(){return this._hasAnnotations},e.prototype.hasScalarAnnotations=function(){return this._hasScalarAnnotations},e}(),m=function(){function e(e,t,n,r,i,a,o,s){void 0===t&&(t=void 0),void 0===n&&(n=void 0),void 0===r&&(r=void 0),void 0===i&&(i=!0),void 0===o&&(o=!1),void 0===s&&(s=!1),this._value=e,this._name=t,this._displayName=n,this._description=r,this._strict=i,this._annotations=a,this._isSingle=o,this._empty=s,this.isExpanded=!1,this._scalarsAnnotations={},this._annotations?this._hasAnnotations=!0:this._annotations={}}return e.prototype.annotationsMap=function(){var e={},t=this.scalarsAnnotations();return Object.keys(t).forEach(function(n){var r=[];Object.keys(t[n]).forEach(function(e){r.push(t[n][e])}),e[n]=r}),e},e.prototype.isEmpty=function(){return this._empty},e.prototype.isJSONString=function(){var e=this.firstCharacter();return"{"==e||"["==e},e.prototype.isXMLString=function(){var e=this.firstCharacter();return"<"==e},e.prototype.firstCharacter=function(){if(null==this._value)return null;if("string"!=typeof this._value)return null;var e=this._value.trim();return 0==e.length?null:e.charAt(0)},e.prototype.asXMLString=function(){return this.isXMLString()?this._value:this._owner?this._owner.asXMLString():null},e.prototype.isYAML=function(){return"string"!=typeof this._value||!(this.isJSONString()||this.isXMLString())},e.prototype.asString=function(){return"string"==typeof this._value?""+this._value:JSON.stringify(this._value,null,2)},e.prototype.asJSON=function(){if(this.isJSONString())try{return JSON.parse(this._value)}catch(e){return null}return this.isYAML()?this._value:this.asString()},e.prototype.original=function(){return this._value},e.prototype.expandAsString=function(){return JSON.stringify(this.expandAsJSON(),null,2)},e.prototype.expandAsJSON=function(){return this.isEmpty()?this.isExpanded?this._expandedValue:(this._expandedValue=r(this._ownerType),this.isExpanded=!0,this._expandedValue):this._value},e.prototype.value=function(){return this.expandAsJSON()},e.prototype.isSingle=function(){return this._isSingle},e.prototype.strict=function(){return this._strict},e.prototype.description=function(){return this._description},e.prototype.displayName=function(){return this._displayName},e.prototype.annotations=function(){var e=this,t=[];return Object.keys(this._annotations).forEach(function(n){t.push(e._annotations[n])}),t},e.prototype.name=function(){return this._name},e.prototype.scalarsAnnotations=function(){return this._scalarsAnnotations},e.prototype.registerScalarAnnotatoion=function(e,t){this._hasScalarAnnotations=!0;var n=this._scalarsAnnotations[t];n||(n={},this._scalarsAnnotations[t]=n),n[e.facetName()]=e},e.prototype.setOwner=function(e){this._owner=e},e.prototype.owner=function(){return this._owner},e.prototype.setOwnerType=function(e){this._ownerType=e},e.prototype.ownerType=function(){return this._ownerType},e.prototype.hasAnnotations=function(){return this._hasAnnotations},e.prototype.hasScalarAnnotations=function(){return this._hasScalarAnnotations},e}(),y=function(e,t,n,r){void 0===n&&(n=null),void 0===r&&(r=!1);var o;if(null!=t)if(t.hasOwnProperty("value")){var s=t.value,u=i(t,"displayName"),l=i(t,"description"),p=i(t,"strict"),c={};a(t).forEach(function(e){c[e.facetName()]=e}),o=new d(s,n,u,l,p,c,r);for(var f=0,h=a(t.displayName);f<h.length;f++){var m=h[f];o.registerScalarAnnotatoion(m,"displayName")}for(var y=0,v=a(t.description);y<v.length;y++){var m=v[y];o.registerScalarAnnotatoion(m,"description")}for(var g=0,A=a(t.strict);g<A.length;g++){var m=A[g];o.registerScalarAnnotatoion(m,"strict")}}else o=new d(t,n,void 0,void 0,!0,void 0,r);else o=new d(null,n,null,null,!0,{},r);return o&&o.setOwner(e),o};t.exampleFromInheritedType2=s,t.exampleFromNominal=u},function(e,t,n){"use strict";function r(e){return a(e,"YYYY-MM-DD")}function i(e){var t="11 "+e.trim(),n="YY HH:mm:ss";if(!s.isValid(t,n))return!1;var r=s.parse(t,n,!1),i=s.format(r,n,!1);return i.trim()==t.trim()}function a(e,t){var n=/^(\d{4})-\d{2}-\d{2}$/,r=e.match(n);if(!r||2!=r.length)return!1;var i=parseInt(r[1]);return!((i<70||i>99)&&!s.isValid(e,t))}var o=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var s=n(138),u=n(58),l=u.messageRegistry,p=function(e){function t(){return e.call(this,"date-only")||this}return o(t,e),t.prototype.check=function(e){return"string"==typeof e&&r(e)?u.ok():u.error(l.INVALID_DATEONLY,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.facetName=function(){return"should be date-only"},t}(u.TypeOfRestriction);t.DateOnlyR=p;var c=function(e){function t(){return e.call(this,"time-only")||this}return o(t,e),t.prototype.check=function(e){if("string"==typeof e){var t=/^([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,n=e.match(t);if(!n)return u.error(l.INVALID_TIMEONLY,this);var r=n[1];return i(r)?u.ok():u.error(l.INVALID_TIMEONLY,this)}return u.error(l.INVALID_TIMEONLY,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.facetName=function(){return"should be time-only"},t}(u.TypeOfRestriction);t.TimeOnlyR=c;var f=function(e){function t(){return e.call(this,"datetime-only")||this}return o(t,e),t.prototype.check=function(e){if("string"==typeof e){var t=/^(\d{4}-\d{2}-\d{2})T([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,n=e.match(t);if(!n||n.length<3)return u.error(l.INVALID_DATETIMEONLY,this);var a=n[1],o=n[2];return r(a)&&i(o)?u.ok():u.error(l.INVALID_DATETIMEONLY,this)}return u.error(l.INVALID_DATETIMEONLY,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.facetName=function(){return"should be datetime-only"},t}(u.TypeOfRestriction);t.DateTimeOnlyR=f;var h=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+\d{2}[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{4}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,d=/(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)\,[ ]+\d{2}-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-\d{2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,m=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{1,2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,y=/^(\d{4}-\d{2}-\d{2})T(\d{2}:\d{2}:\d{2})(?:\.\d+)?((?:[\+\-]\d{2}:\d{2})|Z)$/,v=function(e){function t(){return e.call(this,"datetime")||this}return o(t,e),t.prototype.check=function(e){var t=u.VALIDATED_TYPE,n=!1;if(t.allFacets().forEach(function(e){"format"==e.facetName()&&"rfc2616"===e.value()&&(n=!0)}),"string"==typeof e){if(!n){var a=e.match(y);if(!a||a.length<3)return u.error(l.INVALID_RFC3339,this);var o=a[1],s=a[2];return r(o)&&i(s)?u.ok():u.error(l.INVALID_RFC3339,this)}return e.match(h)||e.match(d)||e.match(m)?u.ok():u.error(l.INVALID_RFC2616,this)}return u.error(l.INVALID_DATTIME,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.facetName=function(){return"should be datetime"},t}(u.TypeOfRestriction);t.DateTimeR=v},function(e,t,n){var r,i;/**
	 * @preserve date-and-time.js (c) KNOWLEDGECODE | MIT
	 */
!function(a){"use strict";var o={},s="en",u={en:{MMMM:["January","February","March","April","May","June","July","August","September","October","November","December"],MMM:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dddd:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],ddd:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dd:["Su","Mo","Tu","We","Th","Fr","Sa"],A:["a.m.","p.m."],formatter:{YYYY:function(e){return("000"+e.getFullYear()).slice(-4)},YY:function(e){return("0"+e.getFullYear()).slice(-2)},Y:function(e){return""+e.getFullYear()},MMMM:function(e){return this.MMMM[e.getMonth()]},MMM:function(e){return this.MMM[e.getMonth()]},MM:function(e){return("0"+(e.getMonth()+1)).slice(-2)},M:function(e){return""+(e.getMonth()+1)},DD:function(e){return("0"+e.getDate()).slice(-2)},D:function(e){return""+e.getDate()},HH:function(e){return("0"+e.getHours()).slice(-2)},H:function(e){return""+e.getHours()},A:function(e){return this.A[e.getHours()>11|0]},hh:function(e){return("0"+(e.getHours()%12||12)).slice(-2)},h:function(e){return""+(e.getHours()%12||12)},mm:function(e){return("0"+e.getMinutes()).slice(-2)},m:function(e){return""+e.getMinutes()},ss:function(e){return("0"+e.getSeconds()).slice(-2)},s:function(e){return""+e.getSeconds()},SSS:function(e){return("00"+e.getMilliseconds()).slice(-3)},SS:function(e){return("0"+(e.getMilliseconds()/10|0)).slice(-2)},S:function(e){return""+(e.getMilliseconds()/100|0)},dddd:function(e){return this.dddd[e.getDay()]},ddd:function(e){return this.ddd[e.getDay()]},dd:function(e){return this.dd[e.getDay()]},Z:function(e){var t=e.utc?0:e.getTimezoneOffset()/.6;return(t>0?"-":"+")+("000"+Math.abs(t-t%100*.4)).slice(-4)},post:function(e){return e}},parser:{find:function(e,t){for(var n,r=-1,i=0,a=0,o=e.length;a<o;a++)n=e[a],!t.indexOf(n)&&n.length>i&&(r=a,i=n.length);return{index:r,length:i}},MMMM:function(e){return this.parser.find(this.MMMM,e)},MMM:function(e){return this.parser.find(this.MMM,e)},A:function(e){return this.parser.find(this.A,e)},h:function(e,t){return(12===e?0:e)+12*t},pre:function(e){return e}}}};o.format=function(e,t,n){var r=o.addMinutes(e,n?e.getTimezoneOffset():0),i=u[s],a=i.formatter;return r.utc=n,t.replace(/(\[[^\[\]]*]|\[.*\][^\[]*\]|YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|ddd?d?|.)/g,function(e){var n=a[e];return n?a.post(n.call(i,r,t)):e.replace(/\[(.*)]/,"$1")})},o.parse=function(e,t,n){for(var r,i,a,l,p,c,f,h,d=u[s],m=d.parser.pre(e),y=0,v=/(MMMM?|A)|(YYYY)|(SSS)|(MM|DD|HH|hh|mm|ss)|(YY|M|D|H|h|m|s|SS)|(S)|(.)/g,g={2:/^\d{1,4}/,3:/^\d{1,3}/,4:/^\d\d/,5:/^\d\d?/,6:/^\d/},A={Y:1970,M:1,D:1,H:0,m:0,s:0,S:0};r=v.exec(t);){for(i=0,l=1,a="";!a;)a=r[++i];if(p=a.charAt(0),c=m.slice(y),i<2?(f=d.parser[a].call(d,c,t),A[p]=f.index,"M"===p&&A[p]++,l=f.length):i<7&&(f=(c.match(g[i])||[""])[0],A[p]=0|("S"===p?(f+"000").slice(0,-a.length):f),l=f.length),!l)return NaN;y+=l}return y===m.length&&f?(A.Y+=A.Y<70?2e3:A.Y<100?1900:0,A.H=A.H||d.parser.h(A.h||0,A.A||0),h=new Date(A.Y,A.M-1,A.D,A.H,A.m,A.s,A.S),A.Y!==h.getFullYear()||A.M-1!==h.getMonth()||A.D!==h.getDate()||A.H!==h.getHours()||A.m!==h.getMinutes()||A.s!==h.getSeconds()||A.S!==h.getMilliseconds()?NaN:n?o.addMinutes(h,-h.getTimezoneOffset()):h):NaN},o.isValid=function(e,t){return!!o.parse(e,t)},o.addYears=function(e,t){return o.addMonths(e,12*t)},o.addMonths=function(e,t){var n=new Date(e.getTime());return n.setMonth(n.getMonth()+t),n},o.addDays=function(e,t){var n=new Date(e.getTime());return n.setDate(n.getDate()+t),n},o.addHours=function(e,t){return o.addMilliseconds(e,36e5*t)},o.addMinutes=function(e,t){return o.addMilliseconds(e,6e4*t)},o.addSeconds=function(e,t){return o.addMilliseconds(e,1e3*t)},o.addMilliseconds=function(e,t){return new Date(e.getTime()+t)},o.subtract=function(e,t){var n=e.getTime()-t.getTime();return{toMilliseconds:function(){return n},toSeconds:function(){return n/1e3|0},toMinutes:function(){return n/6e4|0},toHours:function(){return n/36e5|0},toDays:function(){return n/864e5|0}}},o.isLeapYear=function(e){var t=e.getFullYear();return!((t%4||!(t%100))&&t%400)},o.isSameDay=function(e,t){return o.format(e,"YYYYMMDD")===o.format(t,"YYYYMMDD")},o.locale=function(e){return e&&("en"!==e&&a&&n(139)("./"+e),s=e),s},o.getLocales=function(e){return u[e||s]},o.setLocales=function(e,t){var n=function(e,t){var n,r,i=function(){};i.prototype=t,n=new i;for(r in e)e.hasOwnProperty(r)&&(n[r]=e[r]);return n},r=u[e]||u.en,i=n(t,r);t.formatter&&(i.formatter=n(t.formatter,r.formatter)),t.parser&&(i.parser=n(t.parser,r.parser)),u[e]=i},"object"==typeof e&&"object"==typeof e.exports?e.exports=o:(r=[],i=function(){return o}.apply(t,r),!(void 0!==i&&(e.exports=i)))}(this)},function(e,t,n){function r(e){return n(i(e))}function i(e){return a[e]||function(){throw new Error("Cannot find module '"+e+"'.")}()}var a={"./ar":140,"./ar.js":140,"./az":141,"./az.js":141,"./bn":142,"./bn.js":142,"./cs":143,"./cs.js":143,"./de":144,"./de.js":144,"./el":145,"./el.js":145,"./es":146,"./es.js":146,"./fa":147,"./fa.js":147,"./fr":148,"./fr.js":148,"./hi":149,"./hi.js":149,"./hu":150,"./hu.js":150,"./id":151,"./id.js":151,"./it":152,"./it.js":152,"./ja":153,"./ja.js":153,"./jv":154,"./jv.js":154,"./ko":155,"./ko.js":155,"./my":156,"./my.js":156,"./nl":157,"./nl.js":157,"./pa-in":158,"./pa-in.js":158,"./pl":159,"./pl.js":159,"./pt":160,"./pt.js":160,"./ro":161,"./ro.js":161,"./ru":162,"./ru.js":162,"./sr":163,"./sr.js":163,"./th":164,"./th.js":164,"./tr":165,"./tr.js":165,"./uk":166,"./uk.js":166,"./uz":167,"./uz.js":167,"./vi":168,"./vi.js":168,"./zh-cn":169,"./zh-cn.js":169,"./zh-tw":170,"./zh-tw.js":170};r.keys=function(){return Object.keys(a)},r.resolve=i,e.exports=r,r.id=139},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Arabic (ar)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){var t=["٠","١","٢","٣","٤","٥","٦","٧","٨","٩"],n={"٠":0,"١":1,"٢":2,"٣":3,"٤":4,"٥":5,"٦":6,"٧":7,"٨":8,"٩":9};e.setLocales("ar",{MMMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],MMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],dddd:["الأحد","الإثنين","الثلاثاء","الأربعاء","الخميس","الجمعة","السبت"],ddd:["أحد","إثنين","ثلاثاء","أربعاء","خميس","جمعة","سبت"],dd:["ح","ن","ث","ر","خ","ج","س"],A:["ص","م"],formatter:{post:function(e){return e.replace(/\d/g,function(e){return t[0|e]})}},parser:{pre:function(e){return e.replace(/[٠١٢٣٤٥٦٧٨٩]/g,function(e){return""+n[e]})}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Azerbaijani (az)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("az",{MMMM:["yanvar","fevral","mart","aprel","may","iyun","iyul","avqust","sentyabr","oktyabr","noyabr","dekabr"],MMM:["yan","fev","mar","apr","may","iyn","iyl","avq","sen","okt","noy","dek"],dddd:["Bazar","Bazar ertəsi","Çərşənbə axşamı","Çərşənbə","Cümə axşamı","Cümə","Şənbə"],ddd:["Baz","BzE","ÇAx","Çər","CAx","Cüm","Şən"],dd:["Bz","BE","ÇA","Çə","CA","Cü","Şə"],A:["gecə","səhər","gündüz","axşam"],formatter:{A:function(e){var t=e.getHours();return t<4?this.A[0]:t<12?this.A[1]:t<17?this.A[2]:this.A[3]}},parser:{h:function(e,t){return t<2?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Bengali (bn)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("bn",{MMMM:["জানুয়ারী","ফেবুয়ারী","মার্চ","এপ্রিল","মে","জুন","জুলাই","অগাস্ট","সেপ্টেম্বর","অক্টোবর","নভেম্বর","ডিসেম্বর"],MMM:["জানু","ফেব","মার্চ","এপর","মে","জুন","জুল","অগ","সেপ্ট","অক্টো","নভ","ডিসেম্"],dddd:["রবিবার","সোমবার","মঙ্গলবার","বুধবার","বৃহস্পত্তিবার","শুক্রবার","শনিবার"],ddd:["রবি","সোম","মঙ্গল","বুধ","বৃহস্পত্তি","শুক্র","শনি"],dd:["রব","সম","মঙ্গ","বু","ব্রিহ","শু","শনি"],A:["রাত","সকাল","দুপুর","বিকাল"],formatter:{A:function(e){var t=e.getHours();return t<4?this.A[0]:t<10?this.A[1]:t<17?this.A[2]:t<20?this.A[3]:this.A[0]}},parser:{h:function(e,t){return t<1?e<4||e>11?e:e+12:t<2?e:t<3&&e>9?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Czech (cs)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("cs",{MMMM:["leden","únor","březen","duben","květen","červen","červenec","srpen","září","říjen","listopad","prosinec"],MMM:["led","úno","bře","dub","kvě","čvn","čvc","srp","zář","říj","lis","pro"],dddd:["neděle","pondělí","úterý","středa","čtvrtek","pátek","sobota"],ddd:["ne","po","út","st","čt","pá","so"],dd:["ne","po","út","st","čt","pá","so"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve German (de)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("de",{MMMM:["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],MMM:["Jan.","Febr.","Mrz.","Apr.","Mai","Jun.","Jul.","Aug.","Sept.","Okt.","Nov.","Dez."],dddd:["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],ddd:["So.","Mo.","Di.","Mi.","Do.","Fr.","Sa."],dd:["So","Mo","Di","Mi","Do","Fr","Sa"],A:["Uhr nachmittags","Uhr morgens"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Greek (el)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("el",{MMMM:{nominative:["Ιανουάριος","Φεβρουάριος","Μάρτιος","Απρίλιος","Μάιος","Ιούνιος","Ιούλιος","Αύγουστος","Σεπτέμβριος","Οκτώβριος","Νοέμβριος","Δεκέμβριος"],genitive:["Ιανουαρίου","Φεβρουαρίου","Μαρτίου","Απριλίου","Μαΐου","Ιουνίου","Ιουλίου","Αυγούστου","Σεπτεμβρίου","Οκτωβρίου","Νοεμβρίου","Δεκεμβρίου"]},MMM:["Ιαν","Φεβ","Μαρ","Απρ","Μαϊ","Ιουν","Ιουλ","Αυγ","Σεπ","Οκτ","Νοε","Δεκ"],dddd:["Κυριακή","Δευτέρα","Τρίτη","Τετάρτη","Πέμπτη","Παρασκευή","Σάββατο"],ddd:["Κυρ","Δευ","Τρι","Τετ","Πεμ","Παρ","Σαβ"],dd:["Κυ","Δε","Τρ","Τε","Πε","Πα","Σα"],A:["πμ","μμ"],formatter:{MMMM:function(e,t){return this.MMMM[/D.*MMMM/.test(t)?"genitive":"nominative"][e.getMonth()]},hh:function(e){return("0"+e.getHours()%12).slice(-2)},h:function(e){return e.getHours()%12}},parser:{MMMM:function(e,t){return this.parser.find(this.MMMM[/D.*MMMM/.test(t)?"genitive":"nominative"],e)}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Spanish (es)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("es",{MMMM:["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],MMM:["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sep.","oct.","nov.","dic."],dddd:["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],ddd:["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],dd:["do","lu","ma","mi","ju","vi","sá"],A:["de la mañana","de la tarde","de la noche"],formatter:{A:function(e){var t=e.getHours();return t<12?this.A[0]:t<19?this.A[1]:this.A[2]}},parser:{h:function(e,t){return t<1?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Persian (fa)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){var t=["۰","۱","۲","۳","۴","۵","۶","۷","۸","۹"],n={"۰":0,"۱":1,"۲":2,"۳":3,"۴":4,"۵":5,"۶":6,"۷":7,"۸":8,"۹":9};e.setLocales("fa",{MMMM:["ژانویه","فوریه","مارس","آوریل","مه","ژوئن","ژوئیه","اوت","سپتامبر","اکتبر","نوامبر","دسامبر"],MMM:["ژانویه","فوریه","مارس","آوریل","مه","ژوئن","ژوئیه","اوت","سپتامبر","اکتبر","نوامبر","دسامبر"],dddd:["یک‌شنبه","دوشنبه","سه‌شنبه","چهارشنبه","پنج‌شنبه","جمعه","شنبه"],ddd:["یک‌شنبه","دوشنبه","سه‌شنبه","چهارشنبه","پنج‌شنبه","جمعه","شنبه"],dd:["ی","د","س","چ","پ","ج","ش"],A:["قبل از ظهر","بعد از ظهر"],formatter:{post:function(e){return e.replace(/\d/g,function(e){return t[0|e]})}},parser:{pre:function(e){return e.replace(/[۰۱۲۳۴۵۶۷۸۹]/g,function(e){return""+n[e]})}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve French (fr)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("fr",{MMMM:["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],MMM:["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],dddd:["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"],ddd:["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],dd:["Di","Lu","Ma","Me","Je","Ve","Sa"],A:["matin","l'après-midi"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Hindi (hi)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("hi",{MMMM:["जनवरी","फ़रवरी","मार्च","अप्रैल","मई","जून","जुलाई","अगस्त","सितम्बर","अक्टूबर","नवम्बर","दिसम्बर"],MMM:["जन.","फ़र.","मार्च","अप्रै.","मई","जून","जुल.","अग.","सित.","अक्टू.","नव.","दिस."],dddd:["रविवार","सोमवार","मंगलवार","बुधवार","गुरूवार","शुक्रवार","शनिवार"],ddd:["रवि","सोम","मंगल","बुध","गुरू","शुक्र","शनि"],dd:["र","सो","मं","बु","गु","शु","श"],A:["रात","सुबह","दोपहर","शाम"],formatter:{A:function(e){var t=e.getHours();return t<4?this.A[0]:t<10?this.A[1]:t<17?this.A[2]:t<20?this.A[3]:this.A[0]}},parser:{h:function(e,t){return t<1?e<4||e>11?e:e+12:t<2?e:t<3&&e>9?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Hungarian (hu)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("hu",{MMMM:["január","február","március","április","május","június","július","augusztus","szeptember","október","november","december"],MMM:["jan","feb","márc","ápr","máj","jún","júl","aug","szept","okt","nov","dec"],dddd:["vasárnap","hétfő","kedd","szerda","csütörtök","péntek","szombat"],ddd:["vas","hét","kedd","sze","csüt","pén","szo"],dd:["v","h","k","sze","cs","p","szo"],A:["de","du"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Indonesian (id)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("id",{MMMM:["Januari","Februari","Maret","April","Mei","Juni","Juli","Agustus","September","Oktober","November","Desember"],MMM:["Jan","Feb","Mar","Apr","Mei","Jun","Jul","Ags","Sep","Okt","Nov","Des"],dddd:["Minggu","Senin","Selasa","Rabu","Kamis","Jumat","Sabtu"],ddd:["Min","Sen","Sel","Rab","Kam","Jum","Sab"],dd:["Mg","Sn","Sl","Rb","Km","Jm","Sb"],A:["pagi","siang","sore","malam"],formatter:{A:function(e){var t=e.getHours();return t<11?this.A[0]:t<15?this.A[1]:t<19?this.A[2]:this.A[3]}},parser:{h:function(e,t){return t<1?e:t<2&&e>=11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Italian (it)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("it",{MMMM:["gennaio","febbraio","marzo","aprile","maggio","giugno","luglio","agosto","settembre","ottobre","novembre","dicembre"],MMM:["gen","feb","mar","apr","mag","giu","lug","ago","set","ott","nov","dic"],dddd:["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"],ddd:["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],dd:["Do","Lu","Ma","Me","Gi","Ve","Sa"],A:["di mattina","di pomerrigio"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Japanese (ja)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ja",{MMMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["日曜日","月曜日","火曜日","水曜日","木曜日","金曜日","土曜日"],ddd:["日","月","火","水","木","金","土"],dd:["日","月","火","水","木","金","土"],A:["午前","午後"],formatter:{hh:function(e){return("0"+e.getHours()%12).slice(-2)},h:function(e){return e.getHours()%12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Javanese (jv)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("jv",{MMMM:["Januari","Februari","Maret","April","Mei","Juni","Juli","Agustus","September","Oktober","Nopember","Desember"],MMM:["Jan","Feb","Mar","Apr","Mei","Jun","Jul","Ags","Sep","Okt","Nop","Des"],dddd:["Minggu","Senen","Seloso","Rebu","Kemis","Jemuwah","Septu"],ddd:["Min","Sen","Sel","Reb","Kem","Jem","Sep"],dd:["Mg","Sn","Sl","Rb","Km","Jm","Sp"],A:["enjing","siyang","sonten","ndalu"],formatter:{A:function(e){var t=e.getHours();return t<11?this.A[0]:t<15?this.A[1]:t<19?this.A[2]:this.A[3]}},parser:{h:function(e,t){return t<1?e:t<2&&e>=11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Korean (ko)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ko",{MMMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],MMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dddd:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"],ddd:["일","월","화","수","목","금","토"],dd:["일","월","화","수","목","금","토"],A:["오전","오후"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Burmese (my)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){var t=["၀","၁","၂","၃","၄","၅","၆","၇","၈","၉"],n={"၀":0,"၁":1,"၂":2,"၃":3,"၄":4,"၅":5,"၆":6,"၇":7,"၈":8,"၉":9};e.setLocales("my",{MMMM:["ဇန်နဝါရီ","ဖေဖော်ဝါရီ","မတ်","ဧပြီ","မေ","ဇွန်","ဇူလိုင်","သြဂုတ်","စက်တင်ဘာ","အောက်တိုဘာ","နိုဝင်ဘာ","ဒီဇင်ဘာ"],MMM:["ဇန်","ဖေ","မတ်","ပြီ","မေ","ဇွန်","လိုင်","သြ","စက်","အောက်","နို","ဒီ"],dddd:["တနင်္ဂနွေ","တနင်္လာ","အင်္ဂါ","ဗုဒ္ဓဟူး","ကြာသပတေး","သောကြာ","စနေ"],ddd:["နွေ","လာ","ဂါ","ဟူး","ကြာ","သော","နေ"],dd:["နွေ","လာ","ဂါ","ဟူး","ကြာ","သော","နေ"],formatter:{post:function(e){return e.replace(/\d/g,function(e){return t[0|e]})}},parser:{pre:function(e){return e.replace(/[၀၁၂၃၄၅၆၇၈၉]/g,function(e){return""+n[e]})}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Dutch (nl)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("nl",{MMMM:["januari","februari","maart","april","mei","juni","juli","augustus","september","oktober","november","december"],MMM:{withdots:["jan.","feb.","mrt.","apr.","mei","jun.","jul.","aug.","sep.","okt.","nov.","dec."],withoutdots:["jan","feb","mrt","apr","mei","jun","jul","aug","sep","okt","nov","dec"]},dddd:["zondag","maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag"],ddd:["zo.","ma.","di.","wo.","do.","vr.","za."],dd:["Zo","Ma","Di","Wo","Do","Vr","Za"],formatter:{MMM:function(e,t){return this.MMM[/-MMM-/.test(t)?"withoutdots":"withdots"][e.getMonth()]}},parser:{MMM:function(e,t){return this.parser.find(this.MMM[/-MMM-/.test(t)?"withoutdots":"withdots"],e)}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Punjabi (pa-in)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){var t=["੦","੧","੨","੩","੪","੫","੬","੭","੮","੯"],n={"੦":0,"੧":1,"੨":2,"੩":3,"੪":4,"੫":5,"੬":6,"੭":7,"੮":8,"੯":9};e.setLocales("pa-in",{MMMM:["ਜਨਵਰੀ","ਫ਼ਰਵਰੀ","ਮਾਰਚ","ਅਪ੍ਰੈਲ","ਮਈ","ਜੂਨ","ਜੁਲਾਈ","ਅਗਸਤ","ਸਤੰਬਰ","ਅਕਤੂਬਰ","ਨਵੰਬਰ","ਦਸੰਬਰ"],MMM:["ਜਨਵਰੀ","ਫ਼ਰਵਰੀ","ਮਾਰਚ","ਅਪ੍ਰੈਲ","ਮਈ","ਜੂਨ","ਜੁਲਾਈ","ਅਗਸਤ","ਸਤੰਬਰ","ਅਕਤੂਬਰ","ਨਵੰਬਰ","ਦਸੰਬਰ"],dddd:["ਐਤਵਾਰ","ਸੋਮਵਾਰ","ਮੰਗਲਵਾਰ","ਬੁਧਵਾਰ","ਵੀਰਵਾਰ","ਸ਼ੁੱਕਰਵਾਰ","ਸ਼ਨੀਚਰਵਾਰ"],ddd:["ਐਤ","ਸੋਮ","ਮੰਗਲ","ਬੁਧ","ਵੀਰ","ਸ਼ੁਕਰ","ਸ਼ਨੀ"],dd:["ਐਤ","ਸੋਮ","ਮੰਗਲ","ਬੁਧ","ਵੀਰ","ਸ਼ੁਕਰ","ਸ਼ਨੀ"],A:["ਰਾਤ","ਸਵੇਰ","ਦੁਪਹਿਰ","ਸ਼ਾਮ"],formatter:{A:function(e){var t=e.getHours();return t<4?this.A[0]:t<10?this.A[1]:t<17?this.A[2]:t<20?this.A[3]:this.A[0]},post:function(e){return e.replace(/\d/g,function(e){return t[0|e]})}},parser:{h:function(e,t){return t<1?e<4||e>11?e:e+12:t<2?e:t<3&&e>=10?e:e+12},pre:function(e){return e.replace(/[੦੧੨੩੪੫੬੭੮੯]/g,function(e){return""+n[e]})}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Polish (pl)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("pl",{MMMM:{nominative:["styczeń","luty","marzec","kwiecień","maj","czerwiec","lipiec","sierpień","wrzesień","październik","listopad","grudzień"],subjective:["stycznia","lutego","marca","kwietnia","maja","czerwca","lipca","sierpnia","września","października","listopada","grudnia"]},MMM:["sty","lut","mar","kwi","maj","cze","lip","sie","wrz","paź","lis","gru"],dddd:["niedziela","poniedziałek","wtorek","środa","czwartek","piątek","sobota"],ddd:["nie","pon","wt","śr","czw","pt","sb"],dd:["Nd","Pn","Wt","Śr","Cz","Pt","So"],formatter:{MMMM:function(e,t){return this.MMMM[/D MMMM/.test(t)?"subjective":"nominative"][e.getMonth()]}},parser:{MMMM:function(e,t){return this.parser.find(this.MMMM[/D MMMM/.test(t)?"subjective":"nominative"],e)}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Portuguese (pt)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("pt",{MMMM:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],MMM:["Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez"],dddd:["Domingo","Segunda-Feira","Terça-Feira","Quarta-Feira","Quinta-Feira","Sexta-Feira","Sábado"],ddd:["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],dd:["Dom","2ª","3ª","4ª","5ª","6ª","Sáb"],A:["da madrugada","da manhã","da tarde","da noite"],formatter:{A:function(e){var t=e.getHours();return t<5?this.A[0]:t<12?this.A[1]:t<19?this.A[2]:this.A[3]}},parser:{h:function(e,t){return t<2?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Romanian (ro)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ro",{MMMM:["ianuarie","februarie","martie","aprilie","mai","iunie","iulie","august","septembrie","octombrie","noiembrie","decembrie"],MMM:["ian.","febr.","mart.","apr.","mai","iun.","iul.","aug.","sept.","oct.","nov.","dec."],dddd:["duminică","luni","marți","miercuri","joi","vineri","sâmbătă"],ddd:["Dum","Lun","Mar","Mie","Joi","Vin","Sâm"],dd:["Du","Lu","Ma","Mi","Jo","Vi","Sâ"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Russian (ru)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ru",{MMMM:["Января","Февраля","Марта","Апреля","Мая","Июня","Июля","Августа","Сентября","Октября","Ноября","Декабря"],MMM:["янв","фев","мар","апр","мая","июня","июля","авг","сен","окт","ноя","дек"],dddd:["Воскресенье","Понедельник","Вторник","Среду","Четверг","Пятницу","Субботу"],ddd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],dd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],A:["ночи","утра","дня","вечера"],formatter:{A:function(e){var t=e.getHours();return t<4?this.A[0]:t<12?this.A[1]:t<17?this.A[2]:this.A[3]}},parser:{h:function(e,t){return t<2?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Serbian (sr)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("sr",{MMMM:["januar","februar","mart","april","maj","jun","jul","avgust","septembar","oktobar","novembar","decembar"],MMM:["jan.","feb.","mar.","apr.","maj","jun","jul","avg.","sep.","okt.","nov.","dec."],dddd:["nedelja","ponedeljak","utorak","sreda","četvrtak","petak","subota"],ddd:["ned.","pon.","uto.","sre.","čet.","pet.","sub."],dd:["ne","po","ut","sr","če","pe","su"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Thai (th)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("th",{MMMM:["มกราคม","กุมภาพันธ์","มีนาคม","เมษายน","พฤษภาคม","มิถุนายน","กรกฎาคม","สิงหาคม","กันยายน","ตุลาคม","พฤศจิกายน","ธันวาคม"],MMM:["ม.ค.","ก.พ.","มี.ค.","เม.ย.","พ.ค.","มิ.ย.","ก.ค.","ส.ค.","ก.ย.","ต.ค.","พ.ย.","ธ.ค."],dddd:["อาทิตย์","จันทร์","อังคาร","พุธ","พฤหัสบดี","ศุกร์","เสาร์"],ddd:["อาทิตย์","จันทร์","อังคาร","พุธ","พฤหัส","ศุกร์","เสาร์"],dd:["อา.","จ.","อ.","พ.","พฤ.","ศ.","ส."],A:["ก่อนเที่ยง","หลังเที่ยง"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Turkish (tr)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("tr",{MMMM:["Ocak","Şubat","Mart","Nisan","Mayıs","Haziran","Temmuz","Ağustos","Eylül","Ekim","Kasım","Aralık"],MMM:["Oca","Şub","Mar","Nis","May","Haz","Tem","Ağu","Eyl","Eki","Kas","Ara"],dddd:["Pazar","Pazartesi","Salı","Çarşamba","Perşembe","Cuma","Cumartesi"],ddd:["Paz","Pts","Sal","Çar","Per","Cum","Cts"],dd:["Pz","Pt","Sa","Ça","Pe","Cu","Ct"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Ukrainian (uk)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("uk",{MMMM:["січня","лютого","березня","квітня","травня","червня","липня","серпня","вересня","жовтня","листопада","грудня"],MMM:["січ","лют","бер","квіт","трав","черв","лип","серп","вер","жовт","лист","груд"],dddd:{nominative:["неділя","понеділок","вівторок","середа","четвер","п’ятниця","субота"],accusative:["неділю","понеділок","вівторок","середу","четвер","п’ятницю","суботу"],genitive:["неділі","понеділка","вівторка","середи","четверга","п’ятниці","суботи"]},ddd:["нд","пн","вт","ср","чт","пт","сб"],dd:["нд","пн","вт","ср","чт","пт","сб"],A:["ночі","ранку","дня","вечора"],formatter:{A:function(e){var t=e.getHours();return t<4?this.A[0]:t<12?this.A[1]:t<17?this.A[2]:this.A[3]},dddd:function(e,t){var n="nominative";return/(\[[ВвУу]\]) ?dddd/.test(t)?n="accusative":/\[?(?:минулої|наступної)? ?\] ?dddd/.test(t)&&(n="genitive"),this.dddd[n][e.getDay()]}},parser:{h:function(e,t){return t<2?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Uzbek (uz)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("uz",{MMMM:["январ","феврал","март","апрел","май","июн","июл","август","сентябр","октябр","ноябр","декабр"],MMM:["янв","фев","мар","апр","май","июн","июл","авг","сен","окт","ноя","дек"],dddd:["Якшанба","Душанба","Сешанба","Чоршанба","Пайшанба","Жума","Шанба"],ddd:["Якш","Душ","Сеш","Чор","Пай","Жум","Шан"],dd:["Як","Ду","Се","Чо","Па","Жу","Ша"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Vietnamese (vi)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("vi",{MMMM:["tháng 1","tháng 2","tháng 3","tháng 4","tháng 5","tháng 6","tháng 7","tháng 8","tháng 9","tháng 10","tháng 11","tháng 12"],MMM:["Th01","Th02","Th03","Th04","Th05","Th06","Th07","Th08","Th09","Th10","Th11","Th12"],dddd:["chủ nhật","thứ hai","thứ ba","thứ tư","thứ năm","thứ sáu","thứ bảy"],ddd:["CN","T2","T3","T4","T5","T6","T7"],dd:["CN","T2","T3","T4","T5","T6","T7"],A:["sa","ch"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Chinese (zh-cn)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("zh-cn",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["凌晨","早上","上午","中午","下午","晚上"],formatter:{A:function(e){var t=100*e.getHours()+e.getMinutes();return t<600?this.A[0]:t<900?this.A[1]:t<1130?this.A[2]:t<1230?this.A[3]:t<1800?this.A[4]:this.A[5]}},parser:{h:function(e,t){return t<4?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Chinese (zh-tw)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("zh-tw",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["早上","上午","中午","下午","晚上"],formatter:{A:function(e){var t=100*e.getHours()+e.getMinutes();return t<900?this.A[0]:t<1130?this.A[1]:t<1230?this.A[2]:t<1800?this.A[3]:this.A[4]}},parser:{h:function(e,t){return t<3?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(138)):(i=[n(138)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){"use strict";function r(e,t,n,r){return void 0===n&&(n=_.builtInRegistry()),v(e,new D(null,t,!1,r),n,!1,!1,!0,!1,!1,[])}function i(e,t,n){return void 0===t&&(t=_.builtInRegistry()),u(new D(null,e,!1,n),t)}function a(e){return"?"==e.charAt(e.length-1)}function o(e,t){void 0===t&&(t=_.builtInRegistry());var n=e.provider&&e.provider();return u(new D(null,e,!1,n),t)}function s(e){return new F(e)}function u(e,t,n){void 0===n&&(n=!1);var r=new x(e.path());if(e.anchor){if(e.anchor().__$$)return e.anchor().__$$;e.anchor().__$$=r}var i=e.childWithKey("types");i&&i.kind()===E.ARRAY&&(i=s(i));var a=e.childWithKey("schemas");a&&a.kind()===E.ARRAY&&(a=s(a));var o=new k(i,a,t,r);if(i&&i.kind()!==E.SCALAR&&i.children().filter(function(e){return e.key()&&!0}).forEach(function(e){var t=_.derive(e.key(),[_.REFERENCE]);r.add(t),o.addType(t)}),a&&a.kind()!==E.SCALAR&&a.children().filter(function(e){return e.key()&&!0}).forEach(function(e){var t=_.derive(e.key(),[_.REFERENCE]);r.add(t),o.addType(t)}),!n){var l=e.childWithKey("uses");l&&l.kind()===E.ARRAY&&(l=s(l)),l&&l.kind()===E.MAP&&l.children().forEach(function(e){r.addLibrary(e.key(),u(e,t))})}i&&i.kind()!==E.SCALAR&&i.children().filter(function(e){return e.key()&&!0}).forEach(function(e){o.get(e.key())}),a&&a.kind()!==E.SCALAR&&a.children().filter(function(e){return e.key()&&!0}).forEach(function(e){o.get(e.key())}),o.types().forEach(function(e){return r.add(e)});var i=e.childWithKey("annotationTypes");return i&&i.kind()===E.ARRAY&&(i=s(i)),null!=i&&i.kind()===E.MAP&&i.children().forEach(function(e){r.addAnnotationType(v(e.key(),e,o,!1,!0,!1,!1,!1,[]))}),r}function l(e,t,n){var r=new U,i=!1,o=e.childWithKey("required");if(o){var s=o.value();if("boolean"==typeof s)i=!0;else if(s&&"object"==typeof s&&"boolean"==typeof s.value){i=!0;var u=Object.keys(s).filter(function(e){return e=e.trim(),e.length>1&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)});u.length&&(r.annotations=u.map(function(e){return e=e.trim(),{name:e.substring(1,e.length-1).trim(),key:e,value:s[e]}}))}s===!1&&(r.optional=!0,r.id=e.key())}var l=e.key();!i&&a(e.key())&&(l=l.substr(0,l.length-1),r.optional=!0),null!=l&&0==l.length||"/.*/"===l?r.additonal=!0:"/"==l.charAt(0)&&"/"==l.charAt(l.length-1)&&(l=l.substring(1,l.length-1),r.regExp=!0);var p=[].concat(n);p.push(l),r.type=v(null,e,t,!1,!1,!1,!1,!0,p);var c=e.getMeta("chaining");if(c&&c.length>0&&0==r.type.metaOfType(M.ImportedByChain).length){var f=r.type;if(r.type.isArray()){var h=r.type.metaOfType(N.ComponentShouldBeOfType);if(h&&h.length>0){var d=h[0].value();f=_.derive("",[d]),h[0].type=f}}else if(r.type.isUnion()){var m=r.type.allOptions();m.length>0&&(f=_.derive("",[m[0]]),m[0]=f)}if(0==f.metaOfType(M.ImportedByChain).length){!f.isSubTypeOf(_.UNKNOWN)&&_.InheritedType.isInstance(f)&&f.addSuper(_.UNKNOWN);for(var y=0,g=c;y<g.length;y++){var A=g[y];f.addMeta(new M.ImportedByChain(A.value))}}f.isSubTypeOf(_.UNKNOWN)||_.InheritedType.isInstance(f)&&f.addSuper(_.UNKNOWN);for(var E=0,T=c;E<T.length;E++){var A=T[E];f.addMeta(new M.ImportedByChain(A.value))}}return r.id=l,r}function p(e){var t=new B;t.name=e.name(),t.superTypes=e.superTypes().map(function(e){return h(e)}),t.annotations=[],t.customFacets=[],t.facetDeclarations=[],t.basicFacets=[],t.properties=[];var n={};return e.declaredMeta().forEach(function(e){if(e instanceof M.Annotation)t.annotations.push(e);else if(e instanceof M.CustomFacet)t.customFacets.push(e);else if(e instanceof M.NotScalar)t.notAScalar=!0;else if(e instanceof C.FacetDeclaration)t.facetDeclarations.push(e);else if(e instanceof N.HasProperty)if(n.hasOwnProperty(e.value()))n[e.value()].optional=!1;else{var r=new U;r.optional=!1,r.id=e.value(),r.type=_.ANY,n[e.value()]=r}else if(e instanceof N.AdditionalPropertyIs){var r=new U;r.optional=!1,r.id=".*",r.additonal=!0,r.type=e.value(),r.optional=e.isOptional(),r.regExp=!0,n["/.*/"]=r}else if(N.MapPropertyIs.isInstance(e)){var r=new U;r.optional=!1,r.id=e.regexpValue(),r.regExp=!0,r.type=e.value(),r.optional=e.isOptional(),n[e.regexpValue()]=r}else if(N.PropertyIs.isInstance(e))if(n.hasOwnProperty(e.propertyName()))n[e.propertyName()].type=e.value();else{var r=new U;r.optional=!0,r.id=e.propertyName(),r.type=e.value(),n[e.propertyName()]=r}else N.KnownPropertyRestriction.isInstance(e)?t.additionalProperties=e.value():M.DiscriminatorValue.isInstance(e)?e.isStrict()&&t.basicFacets.push(e):M.HasPropertiesFacet.isInstance(e)||t.basicFacets.push(e)}),Object.keys(n).forEach(function(e){return t.properties.push(n[e])}),t}function c(e){return e instanceof I.AbstractType?p(e).toJSON():f(e)}function f(e){var t={},n={};e.types().forEach(function(e){n[e.name()]=c(e)}),Object.keys(n).length>0&&(t.types=n);var n={};return e.annotationTypes().forEach(function(e){n[e.name()]=c(e)}),Object.keys(n).length>0&&(t.annotationTypes=n),t}function h(e){if(e.isAnonymous()){if(e.isArray()){var t=e.oneMeta(N.ComponentShouldBeOfType);if(t){var n=t.value();return n.isAnonymous()&&n.isUnion()?"("+h(n)+")[]":h(n)+"[]"}}return e.isUnion()?e.options().map(function(e){return h(e)}).join(" | "):e.superTypes().map(function(e){return h(e)}).join(" , ")}return e.name()}function d(e,t){if(t===_.ANY||e===t||e.superTypes().some(function(e){return d(e,t)}))return!0;if(e.isUnion()&&e.options){var n=e.options();if(n.some(function(e){return d(e,t)}))return!0}if(t.isUnion()&&t.options){var n=t.options();if(n.some(function(t){return e==t}))return!0}return!1}function m(e,t){var n=e.requiredType(),r=e.requiredTypes();return r&&r.length>0?r.some(function(e){return d(t,e)}):d(t,n)}function y(e,t){for(var n=t.kind()==E.ARRAY?t.children():[t],r=0;r<n.length;r++)for(var i=n[r].children(),a=0,o=i;a<o.length;a++){var s=o[a],u=s.key();if(u&&"("==u.charAt(0)&&")"==u.charAt(u.length-1)){var l=u.substring(1,u.length-1),p=new M.Annotation(l,s.value(),u,!1,r);p.setOwnerFacet(e),p._owner=e._owner,e.addAnnotation(p)}}}function v(e,t,n,r,i,a,o,p,c){void 0===n&&(n=_.builtInRegistry()),0==c.length&&(c=[e]);var f=t.childWithKey("uses");if(f&&(f.kind()===E.ARRAY&&(f=s(f)),f.kind()===E.MAP)){var h=new x(t.path());f.children().forEach(function(e){h.addLibrary(e.key(),u(e,_.builtInRegistry()))}),n=new k(null,null,n,h)}if(t.kind()==E.SCALAR){var d,A=t.value();if(d=null==A||"Null"==A||"NULL"==A?_.STRING:b.parseToType(""+A,n,t,null,p),null==e)return V(d,t),d;var I=_.derive(e,[d]),C=t.getMeta("chaining");if(d&&C&&C.length>0){var w=I;if(d.isArray()){var L=d.metaOfType(N.ComponentShouldBeOfType);if(L&&L.length>0){var D=L[0].value();w=_.derive("",[D]),L[0].type=w}}else if(d.isUnion()){var U=d.allOptions();U.length>0&&(w=_.derive("",[U[0]]),U[0]=w)}if(0==w.metaOfType(M.ImportedByChain).length){w.isSubTypeOf(_.UNKNOWN)||w.addSuper(_.UNKNOWN);for(var F=0,B=C;F<B.length;F++){var K=B[F];w.addMeta(new M.ImportedByChain(K.value))}}}return k.isInstance(n)&&(I=g(I,n)),V(I,t),I}if(t.kind()==E.ARRAY){var j=[];t.children().forEach(function(e){j.push(b.parseToType(""+e.value(),n,t,null,p))});var I=_.derive(e,j);return k.isInstance(n)&&(I=g(I,n)),V(I,t),I}var W=[],H=t.childWithKey("type"),Y=!1;H?t.childWithKey("schema")&&(Y=!0):H=t.childWithKey("schema");var q=[];if(!H||!H.children().length&&!H.value()||o)W=r?t.childWithKey("properties")?[_.OBJECT]:[_.ANY]:t.childWithKey("properties")?[_.OBJECT]:[_.STRING];else{var G=[],X=H.childWithKey("value");if(!X||X.kind()!=E.SCALAR&&X.kind()!=E.ARRAY||(G=[H.children().filter(function(e){var t=e.key();return!!t&&("("==t.charAt(0)&&")"==t.charAt(t.length-1))})],H=X),H.kind()==E.SCALAR){var A=H.value();if(null==A||"Null"==A||"NULL"==A)W=[_.STRING];else{var z=H.contentProvider?H.contentProvider():null,$=b.parseToType(""+A,n,t,z,p);W=[$]}}else if(H.kind()==E.ARRAY)W=H.children().map(function(e){var t=e.childWithKey("value");return!t||t.kind()!=E.SCALAR&&t.kind()!=E.ARRAY?G.push([]):(G.push(e.children().filter(function(e){var t=e.key();return!!t&&("("==t.charAt(0)&&")"==t.charAt(t.length-1))})),e=t),e.value()}).map(function(e){return b.parseToType(""+e,n,t,null,p)});else if(H.kind()==E.MAP){var J=[].concat(c);J.push("#super"),W=[v("",H,n,!1,!1,!1,!1,!1,J)]}if(G.length>0&&G.filter(function(e){return e.length>0}).length>0)for(var Q=0,Z=G;Q<Z.length;Q++){var ee=Z[Q],te=[];q.push(te);for(var ne=0,re=ee;ne<re.length;ne++){var ie=re[ne],ae=ie.key(),oe=ae.substring(1,ae.length-1),se=new M.Annotation(oe,ie.value(),ae);se.setNode(ie),te.push(se)}}}for(var ue=0,le=W;ue<le.length;ue++){var $=le[ue];$.superTypes().indexOf(_.REFERENCE)>=0&&n.get($.name())}var pe=_.derive(e,W);o&&H&&pe.addMeta(new M.TypeAttributeValue(H.value()));for(var ce=0;ce<q.length;ce++){var fe=q[ce];pe.addSupertypeAnnotation(fe,ce)}null!=e&&e.length>0&&k.isInstance(n)&&(pe=g(pe,n));var he=pe,de=null;if(t.children().forEach(function(e){var r=e.key(),i=e.childWithKey("value"),a=e;if("example"!=r&&"discriminatorValue"!=r&&i&&(a=i),r&&"type"!==r&&"uses"!==r&&"schema"!==r&&("properties"!=r&&"additionalProperties"!=r||!pe.isSubTypeOf(_.OBJECT))){var s;if("items"==r){if(pe.isSubTypeOf(_.ARRAY)){var u=[],l=[a];if(a.kind()==E.ARRAY){l=a.children();var f=_.error(T.ITEMS_SHOULD_BE_REFERENCE_OR_INLINE_TYPE,he);f.setValidationPath({name:"items"}),pe.putExtra(S.PARSE_ERROR,f)}var u=l.map(function(e){var r=e.childWithKey("value");if(!r||r.kind()!=E.SCALAR&&r.kind()!=E.MAP||(e=r),e.kind()==E.SCALAR){var i=e.value();if(null==i||"Null"==i||"NULL"==i)return _.STRING;var o=b.parseToType(""+i,n,t);return V(o,a),o}if(e.kind()==E.MAP){var s=[].concat(c);return s.push("#super"),v("",e,n,!1,!1,!1,!1,!1,s)}}),h=1==u.length?u[0]:_.derive("",u);return s=new P.ComponentShouldBeOfType(h),he.addMeta(s),he.putExtra(S.HAS_ITEMS,!0),y(s,e),s}if(!o){var d=_.error(T.ITEMS_DEFINED_FOR_NON_ARRAY,he);d.setValidationPath({name:"items"}),pe.putExtra(S.PARSE_ERROR,d)}}else{if("required"==r&&!p)return;if("facets"===r)return void(de=[r]);if("default"==r||"xml"==r||"required"==r)de=de?de.concat(r):[r];else if("("==r.charAt(0)&&")"==r.charAt(r.length-1)){var g=new M.Annotation(r.substr(1,r.length-2),a.value(),r);return g.setNode(a),void pe.addMeta(g)}if(s=R.getInstance().buildFacet(r,a.value()),s&&("format"!=r||m(s,pe)))s.setNode(a),pe.addMeta(s);else{var A=new M.CustomFacet(r,a.value());A.setNode(a),pe.addMeta(A)}}s&&y(s,e)}}),0==pe.metaOfType(M.DiscriminatorValue).length&&a&&pe.addMeta(new M.DiscriminatorValue(pe.name(),!1)),pe.isSubTypeOf(_.OBJECT)){var me=t.childWithKey("properties"),ye=!1;if(me)if(pe.addMeta(new M.HasPropertiesFacet),me.kind()==E.MAP)me.children().forEach(function(e){ye=!0;var t=[].concat(c);t.push("#props"),l(e,n,t).add(pe,t)});else{var ve=_.error(T.PROPERTIES_MAP,he);ve.setValidationPath({name:"properties"}),pe.putExtra(S.PARSE_ERROR,ve)}var ge=t.childWithKey("additionalProperties");if(ge){var X=ge.childWithKey("value");if(X&&(ge=X),"boolean"==typeof ge.value())pe.addMeta(new O.KnownPropertyRestriction(ge.value()));else{var ve=_.error(T.ADDITIONAL_PROPERTIES_BOOLEAN,he);ve.setValidationPath({name:"additionalProperties"}),pe.putExtra(S.PARSE_ERROR,ve)}}}var me=t.childWithKey("facets");if(me)if(me.kind()==E.MAP)me.children().forEach(function(e){var t=[].concat(c);t.push("#facets");var r=l(e,n,t);pe.addMeta(new M.FacetDeclaration(r.id,r.type,r.optional))});else{var ve=_.error(T.FACETS_MAP,he);ve.setValidationPath({name:"facets"}),pe.putExtra(S.PARSE_ERROR,ve)}if(pe.isAnonymous()&&pe.isEmpty()&&1==pe.superTypes().length){var Ae=pe.superTypes()[0];return V(Ae,t),Ae}return t.kind()!=E.SCALAR&&pe.addMeta(new M.NotScalar),Y&&he.putExtra(_.SCHEMA_AND_TYPE,!0),he.putExtra(_.GLOBAL,a),he.putExtra(_.SOURCE_EXTRA,t),de&&he.putExtra(S.HAS_FACETS,de),V(he,t),t.getMeta("acceptAllScalarsAsStrings")&&he.addMeta(new M.AcceptAllScalarsAsStrings),he}function g(e,t){for(var n,r=t;r&&!(n=r.typeMap()[e.name()]);)r=r.parent();return null!=n&&n.isSubTypeOf(_.REFERENCE)?null!=n&&n.isSubTypeOf(_.REFERENCE)&&(n.patch(e),e=n):t.addType(e),e.putExtra(S.TOP_LEVEL_EXTRA,!0),e}var A=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var E,_=n(58),T=_.messageRegistry,S=n(74),N=n(75),I=n(58),b=n(172),R=n(135),M=n(77),C=n(77),w=n(58),P=n(75),L=n(59),O=n(75);!function(e){e[e.SCALAR=0]="SCALAR",e[e.ARRAY=1]="ARRAY",e[e.MAP=2]="MAP"}(E=t.NodeKind||(t.NodeKind={}));var D=function(){function e(e,t,n,r){void 0===n&&(n=!1),this._key=e,this.obj=t,this.inArr=n,this.provider=r}return e.prototype.value=function(){return this.obj},e.prototype.key=function(){if(!this._key&&this.kind()===E.MAP&&this.inArr){var e=Object.keys(this.obj);if(1===e.length)return e[0]}return this._key},e.prototype.childWithKey=function(t){return null==this.obj?null:this.obj.hasOwnProperty(t)?new e(t,this.obj[t],!1,this.contentProvider()):null},e.prototype.children=function(){var t=this;return Array.isArray(this.obj)?this.obj.map(function(n){return new e(null,n,!0,t.contentProvider())}):this.obj&&"object"==typeof this.obj?Object.keys(this.obj).map(function(n){return new e(n,t.obj[n],!1,t.provider)}):[]},e.prototype.kind=function(){return this.obj?Array.isArray(this.obj)?E.ARRAY:"object"==typeof this.obj?E.MAP:E.SCALAR:E.SCALAR},e.prototype.contentProvider=function(){return this.provider},e.prototype.getMeta=function(e){return null},e.prototype.path=function(){return JSON.stringify(this.obj)},e}();t.parseJSON=r,t.parseJSONTypeCollection=i;var U=function(){function e(){}return e.prototype.add=function(e,t){this.optional||this.additonal||this.regExp||this.type.isSubTypeOf(_.NIL)||e.addMeta(new N.HasProperty(this.id));var n;if(n=this.additonal?new N.AdditionalPropertyIs(this.type):this.regExp?new N.MapPropertyIs(this.id,this.type,this.optional):new N.PropertyIs(this.id,this.type,this.optional),null!=n&&(e.addMeta(n),this.type instanceof _.InheritedType&&null==this.type.name()&&this.type.setContextMeta(n),this.annotations&&this.annotations.length))for(var r=0,i=this.annotations;r<i.length;r++){var a=i[r],o=new M.Annotation(a.name,a.value,a.key);o.setOwnerFacet(n),n.addAnnotation(o)}},e}();t.PropertyBean=U;var x=function(){function e(e){this._id=e,this._types=[],this._typeMap={},this.uses={},this._annotationTypes=[],this._annotationTypeMap={}}return e.prototype.id=function(){return this._id},e.prototype.library=function(e){return this.uses[e]},e.prototype.addLibrary=function(e,t){this.uses[e]=t},e.prototype.add=function(e){this._types=this._types.filter(function(t){return t.name()!=e.name()}),this._types.push(e),this._typeMap[e.name()]=e},e.prototype.getType=function(e){return this._typeMap.hasOwnProperty(e)?this._typeMap[e]:null},e.prototype.addAnnotationType=function(e){this._annotationTypes.push(e),this._annotationTypeMap[e.name()]=e},e.prototype.getAnnotationType=function(e){return this._annotationTypeMap.hasOwnProperty(e)?this._annotationTypeMap[e]:null},e.prototype.types=function(){return this._types},e.prototype.annotationTypes=function(){return this._annotationTypes},e.prototype.getAnnotationTypeRegistry=function(){var e=this,t=new w.TypeRegistry(_.builtInRegistry(),this,!0);return this.annotationTypes().forEach(function(e){return t.addType(e)}),Object.keys(this.uses).forEach(function(n){e.uses[n].annotationTypes().forEach(function(e){return t.put(n+"."+e.name(),e)})}),t},e.prototype.getTypeRegistry=function(){var e=this,t=new w.TypeRegistry(_.builtInRegistry(),this);return this.types().forEach(function(e){return t.addType(e)}),Object.keys(this.uses).forEach(function(n){e.uses[n].types().forEach(function(e){return t.put(n+"."+e.name(),e)})}),t},e.prototype.libraries=function(){return this.uses},e}();t.TypeCollection=x;var k=function(e){function t(t,n,r,i){var a=e.call(this,r,i)||this;return a.toParse=t,a.schemas=n,a.parsing={},a}return A(t,e),t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_AccumulatingRegistry)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&L.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_AccumulatingRegistry)},t.prototype.get=function(t,n){void 0===n&&(n=!1);var r=e.prototype.get.call(this,t);if(n&&r&&r.isSubTypeOf(_.REFERENCE))return r;if(!r||r.isSubTypeOf(_.REFERENCE)){var i=this.toParse?this.toParse.childWithKey(t):null;if(i||(i=this.schemas?this.schemas.childWithKey(t):null),i){if(this.parsing[t]){var a=_.derive(t,[_.RECURRENT]);return r&&r.isSubTypeOf(_.REFERENCE)?r.patch(a):r=a,r}this.parsing[t]=!0;try{var o=v(t,i,this,!1,!1,!0,!1,!1,[])}finally{delete this.parsing[t]}return o}var s=t.indexOf(".");if(s!=-1){var u=t.substring(0,s),l=t.substr(s+1),p=this._c.library(u);if(p){var c=p.getType(l);if(c)return c}}}return r},t.CLASS_IDENTIFIER_AccumulatingRegistry="parse.AccumulatingRegistry",t}(_.TypeRegistry);t.AccumulatingRegistry=k,t.parseTypes=o;var F=function(){function e(e){this.n=e}return e.prototype.key=function(){return null},e.prototype.value=function(){return null},e.prototype.childWithKey=function(e){for(var t=this.children(),n=0;n<t.length;n++)if(t[n].key()==e)return t[n];return null},e.prototype.children=function(){return this.n.children().map(function(e){var t=e.children();return 1==t.length?t[0]:e})},e.prototype.kind=function(){return E.MAP},e.prototype.getMeta=function(e){return null},e.prototype.path=function(){return this.n.path()},e}();t.parseTypeCollection=u,t.parsePropertyBean=l;var B=function(){function e(){}return e.prototype.toJSON=function(){var e={};if(this.superTypes&&this.superTypes.length>0&&(1==this.superTypes.length?e.type=this.superTypes[0]:e.type=this.superTypes),this.customFacets&&this.customFacets.forEach(function(t){return e[t.facetName()]=t.value()}),this.annotations&&this.annotations.forEach(function(t){return e["("+t.facetName()+")"]=t.value()}),this.facetDeclarations&&this.facetDeclarations.length>0){var t={};this.facetDeclarations.forEach(function(e){var n=e.facetName();e.isOptional()&&(n+="?");var r=null;r=e.type().isAnonymous()?e.type().isEmpty()?h(e.type()):p(e.type()).toJSON():h(e.type()),t[n]=r}),e.facets=t}if(this.properties&&this.properties.length>0){var n={};this.properties.forEach(function(e){var t=e.id;e.optional&&(t+="?"),e.additonal&&(t="/.*/"),e.regExp&&(t="/"+e.id+"/");var r=null;r=e.type.isAnonymous()?e.type.isEmpty()?h(e.type):p(e.type).toJSON():h(e.type),n[t]=r}),e.properties=n}return this.basicFacets&&this.basicFacets.forEach(function(t){e[t.facetName()]=t.value()}),1==Object.keys(e).length&&!this.notAScalar&&e.type?e.type:(void 0!==this.additionalProperties&&(e.additionalProperties=this.additionalProperties),e)},e}();t.TypeProto=B,t.toProto=p,t.storeAsJSON=c;var V=function(e,t){t.getMeta("skipValidation")&&e.addMeta(new M.SkipValidation)};t.parse=v},function(e,t,n){"use strict";function r(e,t,n,r,i){if(void 0===r&&(r=null),void 0===i&&(i=!1),null==e)return null;try{var o=e.trim();if(o.length>0){var s="{"==o.charAt(0);if(s||"<"==o.charAt(0)&&o.length>1&&"<"!=o.charAt(1)){var u=n,l=void 0;do l=u,u=l.childWithKey("type");while(u);var c=l&&l.contentProvider&&l.contentProvider();return new h.ExternalType("",o,s,c,r)}var f=p(e),d=a(f,t,i);return d}return h.derive(e,[h.STRING])}catch(t){return h.derive(e,[h.UNKNOWN])}}function i(e,t){for(;e>0;){var n=h.derive("",[h.ARRAY]);n.addMeta(new m.ComponentShouldBeOfType(t)),t=n,e--}return t}function a(e,t,n){if("union"==e.type){var r=e;return h.union("",[a(r.first,t,n),a(r.rest,t,n)])}if("parens"==e.type){var s=e,u=a(s.expr,t,n);return i(s.arr,u)}var l=e;if("?"==l.value.charAt(l.value.length-1)){var p=o(t,l.value.substr(0,l.value.length-1),n);p||(p=h.derive(l.value,[h.UNKNOWN])),p=h.union(l.value,[p,h.NIL]);var c=l.arr;return i(c,p)}var p=o(t,l.value,n);if(!p){p=h.derive(l.value,[h.UNKNOWN]);var f=t.getByChain(l.value);f&&p.addMeta(new y.ImportedByChain(l.value))}var c=l.arr;return i(c,p)}function o(e,t,n){return d.AccumulatingRegistry.isInstance(e)?e.get(t,n):e.get(t)}function s(e){if(e.isSubTypeOf(h.ARRAY)){var t=e.oneMeta(m.ComponentShouldBeOfType);return t?t.value().isUnion()?"("+s(t.value())+")[]":s(t.value())+"[]":"array"}if(e instanceof h.UnionType){var n=e;return n.options().map(function(e){return s(e)}).join(" | ")}return e.isAnonymous()&&e.isEmpty()?e.superTypes().map(function(e){return s(e)}).join(" , "):e.name()}function u(e,t){if(t(e),"union"==e.type){var n=e;u(n.first,t),u(n.rest,t)}else if("parens"==e.type){var r=e;u(r.expr,t)}}function l(e){var t,n=0;if("name"==e.type){var r=e;t=r.value,n=r.arr}else if("union"==e.type){var i=e;t=l(i.first)+" | "+l(i.rest)}else if("parens"==e.type){var a=e;t="("+l(a.expr)+")",n=a.arr}for(;--n>=0;)t+="[]";return t}function p(e){var t=f.parse(e);return t=c(t)}function c(e){if("name"==e.type){var t=e,n=t.value;if(n&&n.length&&"?"==n.charAt(n.length-1)){var r=n.substring(0,n.length-1),i=p(r),a={type:"union",first:i,rest:{type:"name",value:"nil"}};return"number"==typeof t.arr&&t.arr>0&&(a={type:"parens",expr:a,arr:t.arr}),a}return t}if("union"==e.type){var o=e;o.first=c(o.first),o.rest=c(o.rest)}else if("parens"==e.type){var s=e;s.expr=c(s.expr)}return e}Object.defineProperty(t,"__esModule",{value:!0});var f=n(173),h=n(58),d=n(171),m=n(75),y=n(77);t.parseToType=r,t.storeToString=s,t.visit=u,t.serializeToString=l,t.parse=p},function(e,t){"use strict";var n=function(){function e(e,t){function n(){this.constructor=e}n.prototype=t.prototype,e.prototype=new n}function t(e,n,r,i){this.message=e,this.expected=n,this.found=r,this.location=i,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,t)}function n(e){function n(t){var n,r,i=G[t];if(i)return i;for(n=t-1;!G[n];)n--;for(i=G[n],i={line:i.line,column:i.column,seenCR:i.seenCR};n<t;)r=e.charAt(n),"\n"===r?(i.seenCR||i.line++,i.column=1,i.seenCR=!1):"\r"===r||"\u2028"===r||"\u2029"===r?(i.line++,i.column=1,i.seenCR=!0):(i.column++,i.seenCR=!1),n++;return G[t]=i,i}function r(e,t){var r=n(e),i=n(t);return{start:{offset:e,line:r.line,column:r.column},end:{offset:t,line:i.line,column:i.column}}}function i(e){Y<X||(Y>X&&(X=Y,z=[]),z.push(e))}function a(e,n,r,i){function a(e){var t=1;for(e.sort(function(e,t){return e.description<t.description?-1:e.description>t.description?1:0});t<e.length;)e[t-1]===e[t]?e.splice(t,1):t++}function o(e,t){function n(e){function t(e){return e.charCodeAt(0).toString(16).toUpperCase()}return e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+t(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+t(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+t(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+t(e)})}var r,i,a,o=new Array(e.length);for(a=0;a<e.length;a++)o[a]=e[a].description;return r=e.length>1?o.slice(0,-1).join(", ")+" or "+o[e.length-1]:o[0],i=t?'"'+n(t)+'"':"end of input","Expected "+r+" but "+i+" found."}return null!==n&&a(n),new t(null!==e?e:o(n,r),n,r,i)}function o(){var t,n,r,a,u,p,c,f;return t=Y,n=l(),n!==h?(r=s(),r!==h?(a=Y,u=l(),u!==h?(124===e.charCodeAt(Y)?(p=y,Y++):(p=h,0===$&&i(v)),p!==h?(c=l(),c!==h?(f=o(),f!==h?(u=[u,p,c,f],a=u):(Y=a,a=h)):(Y=a,a=h)):(Y=a,a=h)):(Y=a,a=h),a===h&&(a=null),a!==h?(q=t,n=g(r,a),t=n):(Y=t,t=h)):(Y=t,t=h)):(Y=t,t=h),t}function s(){var t,n,r,a,s,p,c,f,d,m;if(t=Y,40===e.charCodeAt(Y)?(n=A,Y++):(n=h,0===$&&i(E)),n!==h)if(r=l(),r!==h)if(a=o(),a!==h)if(s=l(),s!==h)if(41===e.charCodeAt(Y)?(p=_,Y++):(p=h,0===$&&i(T)),p!==h){for(c=[],f=Y,d=l(),d!==h?(e.substr(Y,2)===S?(m=S,Y+=2):(m=h,0===$&&i(N)),m!==h?(d=[d,m],f=d):(Y=f,f=h)):(Y=f,f=h);f!==h;)c.push(f),f=Y,d=l(),d!==h?(e.substr(Y,2)===S?(m=S,Y+=2):(m=h,0===$&&i(N)),m!==h?(d=[d,m],f=d):(Y=f,f=h)):(Y=f,f=h);c!==h?(q=t,n=I(a,c),t=n):(Y=t,t=h)}else Y=t,t=h;else Y=t,t=h;else Y=t,t=h;else Y=t,t=h;else Y=t,t=h;return t===h&&(t=u()),t}function u(){var t,n,r,a,o,s;if($++,t=Y,n=[],r=p(),r!==h)for(;r!==h;)n.push(r),r=p();else n=h;if(n!==h){for(r=[],a=Y,o=l(),o!==h?(e.substr(Y,2)===S?(s=S,Y+=2):(s=h,0===$&&i(N)),s!==h?(o=[o,s],a=o):(Y=a,a=h)):(Y=a,a=h);a!==h;)r.push(a),a=Y,o=l(),o!==h?(e.substr(Y,2)===S?(s=S,Y+=2):(s=h,0===$&&i(N)),s!==h?(o=[o,s],a=o):(Y=a,a=h)):(Y=a,a=h);r!==h?(q=t,n=R(n,r),t=n):(Y=t,t=h)}else Y=t,t=h;return $--,t===h&&(n=h,0===$&&i(b)),t}function l(){var t,n;for($++,t=[],C.test(e.charAt(Y))?(n=e.charAt(Y),Y++):(n=h,0===$&&i(w));n!==h;)t.push(n),C.test(e.charAt(Y))?(n=e.charAt(Y),Y++):(n=h,0===$&&i(w));return $--,t===h&&(n=h,0===$&&i(M)),t}function p(){var t;return P.test(e.charAt(Y))?(t=e.charAt(Y),Y++):(t=h,0===$&&i(L)),t===h&&(95===e.charCodeAt(Y)?(t=O,Y++):(t=h,0===$&&i(D)),t===h&&(45===e.charCodeAt(Y)?(t=U,Y++):(t=h,0===$&&i(x)),t===h&&(46===e.charCodeAt(Y)?(t=k,Y++):(t=h,0===$&&i(F)),t===h&&(B.test(e.charAt(Y))?(t=e.charAt(Y),Y++):(t=h,0===$&&i(V)),t===h&&(K.test(e.charAt(Y))?(t=e.charAt(Y),Y++):(t=h,0===$&&i(j)),t===h&&(63===e.charCodeAt(Y)?(t=W,Y++):(t=h,0===$&&i(H)))))))),t}var c,f=arguments.length>1?arguments[1]:{},h={},d={Term:o},m=o,y="|",v={type:"literal",value:"|",description:'"|"'},g=function(e,t){return t?{type:"union",first:e,rest:t[3]}:e},A="(",E={type:"literal",value:"(",description:'"("'},_=")",T={type:"literal",value:")",description:'")"'},S="[]",N={type:"literal",value:"[]",description:'"[]"'},I=function(e,t){return{type:"parens",expr:e,arr:t.length}},b={type:"other",description:"name"},R=function(e,t){return{type:"name",value:e.join(""),arr:t.length}},M={type:"other",description:"whitespace"},C=/^[ \t\n\r]/,w={type:"class",value:"[ \\t\\n\\r]",description:"[ \\t\\n\\r]"},P=/^[A-Z]/,L={type:"class",value:"[A-Z]",description:"[A-Z]"},O="_",D={type:"literal",value:"_",description:'"_"'},U="-",x={type:"literal",value:"-",description:'"-"'},k=".",F={type:"literal",value:".",description:'"."'},B=/^[a-z:#\/]/,V={type:"class",value:"[a-z]",description:"[a-z]"},K=/^[0-9]/,j={type:"class",value:"[0-9]",description:"[0-9]"},W="?",H={type:"literal",value:"?",description:'"?"'},Y=0,q=0,G=[{line:1,column:1,seenCR:!1}],X=0,z=[],$=0;if("startRule"in f){if(!(f.startRule in d))throw new Error("Can't start parsing from rule \""+f.startRule+'".');m=d[f.startRule]}if(c=m(),c!==h&&Y===e.length)return c;throw c!==h&&Y<e.length&&i({type:"end",description:"end of input"}),a(null,z,X<e.length?e.charAt(X):null,X<e.length?r(X,X+1):r(X,X))}return e(t,Error),{SyntaxError:t,parse:n}}();e.exports=n},function(e,t,n){"use strict";function r(e){o=e}function i(e,t,n){void 0===n&&(n=null);var r=null;if(e.getExtra(m))return e.getExtra(m);if(!e){var y=t("any");y||(r=new l.StructuredType(e.name()))}if(e.isBuiltin()){var v="any"!=e.name()&&"array"!=e.name()?t(e.name()):null;r=v?v:e.isScalar()?new l.ValueType(e.name(),null):new l.StructuredType(e.name())}else if(e.isObject())r=new l.StructuredType(e.name(),null);else if(e.isArray()){var g=new l.Array(e.name(),null);r=g,e.putExtra(m,r);var A=e.oneMeta(c.ComponentShouldBeOfType),E=A?A.value():s.ANY;g.setComponent(i(E,t))}else if(e instanceof s.UnionType){var _=new l.Union(e.name(),null);0==e.superTypes().length&&_._superTypes.push(i(s.UNION,t,n)),e.putExtra(m,_),e.options().forEach(function(n){if(null==_.left)_.left=i(n,t);else if(null==_.right)_.right=i(n,t);else{var r=new l.Union(e.name(),null);r.left=_.right,r.right=i(n,t),_.right=r}}),r=_}else if(e.isScalar())r=new l.ValueType(e.name(),null);else if(e instanceof s.ExternalType){var T=e,S=new l.ExternalType(T.name());S.schemaString=T.schema(),r=S}if(r||(r=new l.StructuredType(e.name())),e.superTypes().forEach(function(e){var n=i(e,t);e.isBuiltin()?r._superTypes.push(n):r.addSuperType(n)}),e.isEmpty()){if(e.isArray()&&1==e.superTypes().length&&e.superTypes()[0].isAnonymous()){var N=r.superTypes()[0];N.setName(e.name()),N._subTypes=N._subTypes.filter(function(e){return e!=r}),r=N}if(e.isUnion()&&1==e.superTypes().length&&e.superTypes()[0].isAnonymous()){var N=r.superTypes()[0];N.setName(e.name()),N._subTypes=N._subTypes.filter(function(e){return e!=r}),r=N}}e.putExtra(m,r);var I=p.toProto(e);I.properties.forEach(function(e){var n=e.regExp?"/"+e.id+"/":e.id,a=o?o(n):new l.Property(n);a.withDomain(r),a.withRange(i(e.type,t)),e.optional||a.withRequired(!0),e.regExp&&a.withKeyRegexp(n)}),I.facetDeclarations.filter(function(e){return!e.isBuiltIn()}).forEach(function(e){var n=o?o(e.facetName()):new l.Property(e.facetName());n.withRange(i(e.type(),t)),r.addFacet(n)}),e.customFacets().forEach(function(e){r.fixFacet(e.facetName(),e.value())});for(var b={example:!0,examples:!0},R=e.meta().filter(function(t){if(!(t instanceof h.Discriminator||t instanceof h.DiscriminatorValue)){if(!(t instanceof c.FacetRestriction||t instanceof h.MetaInfo||t instanceof c.KnownPropertyRestriction))return!1;if(t instanceof h.FacetDeclaration||t instanceof h.CustomFacet)return!1}var n=t.requiredType(),r=n.isUnion()?n.allOptions():[n];if(!d.some(r,function(t){return e.isSubTypeOf(t)}))return!1;var i=t.facetName();return!b[i]&&("discriminatorValue"==i?t.isStrict():"allowedTargets"==i||null!=f.getInstance().facetPrototypeWithName(i))}),M=0,C=R;M<C.length;M++){var w=C[M],P=w.facetName();"closed"==P&&(P="additionalProperties"),r.fixFacet(P,w.value(),!0)}return r.addAdapter(e),e.isBuiltin()||r.putExtra(u.USER_DEFINED_EXTRA,!0),e.isEmpty()&&r.addAdapter(new l.Empty),r._validator=a(e),e.isBuiltin()?r.buildIn=!0:e.subTypes().forEach(function(e){i(e,t,n)}),r}function a(e){return function(t){return e.validate(t,!1).getErrors()}}Object.defineProperty(t,"__esModule",{value:!0});var o,s=n(58),u=n(74),l=n(175),p=n(171),c=n(75),f=n(135),h=n(77),d=n(59),m="nominal";t.setPropertyConstructor=r,t.toNominal=i},function(e,t,n){"use strict";function r(e){c.push(e)}function i(e){var t=e.typeId();if(!t){var n=e.getAdapter(l.InheritedType);t=n&&n.id()+""||""}return t}var a=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof N&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var o=n(176),s=n(74),u=n(61),l=n(58),p=n(72),c=[];t.registerInjector=r;var f=function(){function e(){var e=this;this.adapters=[],c.forEach(function(t){return t.inject(e)})}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER_Adaptable)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER_Adaptable)},e.prototype.addAdapter=function(e){this.adapters.push(e)},e.prototype.getAdapter=function(e){var t=null;return this.adapters.forEach(function(n){n instanceof e&&(t=n)}),t},e.prototype.getAdapters=function(){return this.adapters},e.CLASS_IDENTIFIER_Adaptable="nominal-types.Adaptable",e}();t.Adaptable=f;var h=function(e){function t(t,n){void 0===n&&(n="");var r=e.call(this)||this;return r._name=t,r._description=n,r._tags=[],r._annotations=[],r}return a(t,e),t.prototype.nameId=function(){
return this._name},t.prototype.description=function(){return this._description},t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER_Described)return!0}return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_Described)},t.prototype.addAnnotation=function(e){this._annotations.push(e)},t.prototype.removeAnnotation=function(e){this._annotations=this._annotations.filter(function(t){return t!=e})},t.prototype.annotations=function(){return[].concat(this._annotations)},t.prototype.tags=function(){return this._tags},t.prototype.withDescription=function(e){return this._description=e,this},t.prototype.setName=function(e){this._name=e},t.CLASS_IDENTIFIER_Described="nominal-types.Described",t}(f);t.Described=h;var d=function(e){function t(t,n){var r=e.call(this,t.nameId())||this;return r.type=t,r.parameters=n,r}return a(t,e),t.prototype.parameterNames=function(){return Object.keys(this.parameters)},t.prototype.parameter=function(e){return this.parameters[e]},t.prototype.getType=function(){return this.type},t}(h);t.Annotation=d;var m=function(){function e(){}return e}();t.Empty=m;var y=function(){function e(){}return e.prototype.type=function(e){return null},e.prototype.version=function(){return"Empty"},e.prototype.types=function(){return[]},e.prototype.matched=function(){return{}},e}(),v=new y,g=n(136),A=function(e){function t(t,n,r){void 0===n&&(n=v),void 0===r&&(r="");var i=e.call(this,t)||this;return i._universe=n,i._path=r,i._customProperties=[],i._facets=[],i._superTypes=[],i._subTypes=[],i._requirements=[],i._fixedFacets={},i._fixedBuildInFacets={},i.uc=!1,i}return a(t,e),t.prototype.properties=function(){return[]},t.prototype.externalInHierarchy=function(){var e=this.allSuperTypes(),t=null;return e.forEach(function(e){e instanceof I&&(t=e)}),t},t.prototype.addFacet=function(e){this._facets.push(e)},t.prototype.validate=function(e){if(!this._validator)throw new Error(p.VALIDATE_ONLY_ON_RUNTIME_TYPES_INSTANCES.message);return this._validator(e)},t.prototype.allFacets=function(e){if(void 0===e&&(e={}),this._allFacets)return this._allFacets;if(e[this.nameId()])return[];e[this.typeId()]=this;var n={};return this.superTypes().length>0&&this.superTypes().forEach(function(r){r instanceof t&&r.allFacets(e).forEach(function(e){return n[e.nameId()]=e})}),this._facets.forEach(function(e){return n[e.nameId()]=e}),this._allFacets=Object.keys(n).map(function(e){return n[e]}),this._allFacets},t.prototype.facets=function(){return[].concat(this._facets)},t.prototype.facet=function(e){return u.find(this.allFacets(),function(t){return t.nameId()==e})},t.prototype.typeId=function(){return this.nameId()},t.prototype.allProperties=function(e){if(void 0===e&&(e={}),this._props)return this._props;var n=i(this);if(e[n])return[];e[n]=this;var r={};this.superTypes().length>0&&this.superTypes().forEach(function(n){n instanceof t?n.allProperties(e).forEach(function(e){return r[e.nameId()]=e}):n.allProperties().forEach(function(e){return r[e.nameId()]=e})});for(var a in this.fixedFacets())delete r[a];return this.properties().forEach(function(e){return r[e.nameId()]=e}),this._props=Object.keys(r).map(function(e){return r[e]}),this._props},t.prototype.property=function(e){return u.find(this.allProperties(),function(t){return t.nameId()==e})},t.prototype.hasValueTypeInHierarchy=function(){return null!=u.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e.hasValueTypeInHierarchy()}finally{t.uc=!1}})},t.prototype.isAnnotationType=function(){return!1},t.prototype.hasStructure=function(){return!1},t.prototype.key=function(){return this._key?this._key:this._universe&&(this._key=this.universe().matched()[this.nameId()],!this._key)?null:this._key},t.prototype.hasArrayInHierarchy=function(){var e=null!=u.find(this.allSuperTypes(),function(e){return e instanceof N});return e},t.prototype.arrayInHierarchy=function(){var e=this.allSuperTypes(),t=null;return e.forEach(function(e){e instanceof N&&(t=e)}),t},t.prototype.unionInHierarchy=function(){var e=this.allSuperTypes(),t=null;return e.forEach(function(e){e instanceof S&&(t=e)}),t},t.prototype.hasExternalInHierarchy=function(){return null!=u.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e instanceof I}finally{t.uc=!1}})},t.prototype.hasUnionInHierarchy=function(){return null!=u.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e.hasUnionInHierarchy()}finally{t.uc=!1}})},t.prototype.fixFacet=function(e,t,n){void 0===n&&(n=!1),n?this._fixedBuildInFacets[e]=t:this._fixedFacets[e]=t},t.prototype.getFixedFacets=function(){return this.fixedFacets()},t.prototype.fixedFacets=function(){return this.collectFixedFacets(!1)},t.prototype.fixedBuiltInFacets=function(){return this.collectFixedFacets(!0)},t.prototype.collectFixedFacets=function(e){for(var t=e?this._fixedBuildInFacets:this._fixedFacets,n={},r=0,i=Object.keys(t);r<i.length;r++){var a=i[r];n[a]=t[a]}return this.contributeFacets(n),n},t.prototype.allFixedFacets=function(){return this.collectAllFixedFacets(!1)},t.prototype.allFixedBuiltInFacets=function(){return this.collectAllFixedFacets(!0)},t.prototype.collectAllFixedFacets=function(e){if(e&&this._abf)return this._abf;if(!e&&this._af)return this._af;var t=this.allSuperTypes();t.push(this);var n={};return t.forEach(function(t){for(var r=e?t.fixedBuiltInFacets():t.fixedFacets(),i=0,a=Object.keys(r);i<a.length;i++){var o=a[i];n[o]=r[o]}}),this._af=n,n},t.prototype.contributeFacets=function(e){},t.prototype.getPath=function(){return this._path},t.prototype.setNameAtRuntime=function(e){this._nameAtRuntime=e},t.prototype.getNameAtRuntime=function(){return this._nameAtRuntime},t.prototype.universe=function(){return this._universe?this._universe:new y},t.prototype.superTypes=function(){return[].concat(this._superTypes)},t.prototype.isAssignableFrom=function(e){if(this.nameId()==e)return!this.isUserDefined();for(var t=this.allSuperTypes(),n=0;n<t.length;n++)if(t[n].nameId()==e)return!0;return!1},t.prototype.annotationType=function(){return null},t.prototype.subTypes=function(){return[].concat(this._subTypes)},t.prototype.allSubTypes=function(){var e=[];return this.subTypes().forEach(function(t){e.push(t),e=e.concat(t.allSubTypes())}),u.unique(e)},t.prototype.allSuperTypes=function(){if(this._allSupers)return this._allSupers;var e=[];return this.allSuperTypesRecurrent(this,{},e),this._allSupers=u.unique(e),this._allSupers},t.prototype.allSuperTypesRecurrent=function(e,t,n){var r=this;e.superTypes().forEach(function(e){var a=i(e);if(!a){var o=e.getAdapter(l.InheritedType);a=o&&o.id()+""||""}t[a]||(n.push(e),t[a]=e,r.allSuperTypesRecurrent(e,t,n))})},t.prototype.addSuperType=function(e){e._subTypes.push(this),this._superTypes.push(e)},t.prototype.addRequirement=function(e,t){this._requirements.push(new o.ValueRequirement(e,t))},t.prototype.valueRequirements=function(){return this._requirements},t.prototype.requiredProperties=function(){return this.allProperties().filter(function(e){return e.isRequired()})},t.prototype.printDetails=function(e,n){var r=this;e||(e=""),n||(n={hideProperties:!1,hideSuperTypeProperties:!1,printStandardSuperclasses:!1});var i="  ",a="",o=this.getTypeClassName();a+=e+this.nameId()+"["+o+"]\n";var s=this.properties();s&&s.length>0&&!n.hideProperties&&(a+=e+i+"Properties:\n",s.forEach(function(n){var r="",o=n.range();o instanceof h&&(r+=o.nameId()),o instanceof t&&(r+="[",r+=o.getTypeClassName(),r+="]"),a+=e+i+i+n.nameId()+" : "+r+"\n"}));var l=this.superTypes(),p=l;return l&&!n.printStandardSuperclasses&&(p=u.filter(l,function(e){var n=e instanceof h?e.nameId():"",i=e instanceof t?e.getTypeClassName():"";return!r.isStandardSuperclass(n,i)})),p&&p.length>0&&(a+=e+i+"Super types:\n",p.forEach(function(t){a+=t.printDetails(e+i+i,{hideProperties:n.hideSuperTypeProperties,hideSuperTypeProperties:n.hideSuperTypeProperties,printStandardSuperclasses:n.printStandardSuperclasses})})),a},t.prototype.getTypeClassName=function(){return this.constructor.toString().match(/\w+/g)[1]},t.prototype.isStandardSuperclass=function(e,t){return"TypeDeclaration"===e&&"NodeClass"===t||("ObjectTypeDeclaration"===e&&"NodeClass"===t||"RAMLLanguageElement"===e&&"NodeClass"===t)},t.prototype.examples=function(e){return g.exampleFromNominal(this,e)},t.prototype.isGenuineUserDefinedType=function(){if(this.buildIn)return!1;if(this.properties()&&this.properties().length>0)return!0;var e=this.fixedFacets();if(e&&Object.keys(e).length>0)return!0;var t=this.fixedBuiltInFacets();return!!(t&&Object.keys(t).length>0)||this.isTopLevel()&&this.nameId()&&this.nameId().length>0},t.prototype.genuineUserDefinedTypeInHierarchy=function(){if(this.isGenuineUserDefinedType())return this;var e=null,t=this.allSuperTypes();return t.forEach(function(t){!e&&t.isGenuineUserDefinedType()&&(e=t)}),e},t.prototype.hasGenuineUserDefinedTypeInHierarchy=function(){return null!=u.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e.isGenuineUserDefinedType()}finally{t.uc=!1}})},t.prototype.customProperties=function(){return[].concat(this._customProperties)},t.prototype.allCustomProperties=function(){var e=[];return this.superTypes().forEach(function(t){return e=e.concat(t.allCustomProperties())}),e=e.concat(this.customProperties())},t.prototype.registerCustomProperty=function(e){if(e.domain()!=this)throw new Error(p.SHOULD_BE_ALREADY_OWNED.message);if(this._customProperties.indexOf(e)!=-1)throw new Error(p.ALREADY_INCLUDED.message);this._customProperties.push(e)},t.prototype.setCustom=function(e){this._isCustom=e},t.prototype.isCustom=function(){return this._isCustom},t.prototype.isUnion=function(){return!1},t.prototype.union=function(){return null},t.prototype.isExternal=function(){return!1},t.prototype.external=function(){return null},t.prototype.isArray=function(){return!1},t.prototype.isObject=function(){if("object"==this.nameId())return!0;for(var e=0,t=this.allSuperTypes();e<t.length;e++){var n=t[e];if(n.isObject())return!0}return!1},t.prototype.array=function(){return null},t.prototype.isValueType=function(){return!1},t.prototype.kind=function(){var e=[];return this.isObject()&&e.push("object"),this.isArray()&&e.push("array"),this.isValueType()&&e.push("value"),this.isUnion()&&e.push("union"),this.isAnnotationType()&&e.push("annotation"),this.isExternal()&&e.push("external"),e},t.prototype.isBuiltIn=function(){return this.buildIn},t.prototype.setBuiltIn=function(e){this.buildIn=e},t.prototype.isTopLevel=function(){return!(!this.getExtra(s.DEFINED_IN_TYPES_EXTRA)&&!this.getExtra(s.TOP_LEVEL_EXTRA))},t.prototype.isUserDefined=function(){return this.getExtra(s.USER_DEFINED_EXTRA)&&!this.buildIn},t.prototype.putExtra=function(e,t){var n=this.getExtraAdapter();n&&n.putExtra(e,t)},t.prototype.getExtra=function(e){var t=this.getExtraAdapter();return t?t.getExtra(e):null},t.prototype.getExtraAdapter=function(){if(this.getAdapters()){var e=u.find(this.getAdapters(),function(e){if(e.getExtra&&"function"==typeof e.getExtra&&e.putExtra&&"function"==typeof e.putExtra)return!0});return e}return null},t}(h);t.AbstractType=A;var E=function(e){function t(t,n,r,i){return void 0===n&&(n=null),void 0===r&&(r=""),void 0===i&&(i=""),e.call(this,t,n,r)||this}return a(t,e),t.prototype.hasStructure=function(){return!1},t.prototype.hasValueTypeInHierarchy=function(){return!0},t.prototype.isValueType=function(){return!0},t.prototype.isUnionType=function(){return!1},t.prototype.isObject=function(){return!1},t}(A);t.ValueType=E;var _=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._properties=[],t}return a(t,e),t.prototype.hasStructure=function(){return!0},t.prototype.propertyIndex=function(e){for(var t=this.properties(),n=0;n<t.length;n++)if(t[n].nameId()==e)return n;return-1},t.prototype.addProperty=function(e,t){return new T(e).withDomain(this).withRange(t)},t.prototype.allPropertyIndex=function(e){for(var t=this.allProperties(),n=0;n<t.length;n++)if(t[n].nameId()==e)return n;return-1},t.prototype.properties=function(){return[].concat(this._properties)},t.prototype.registerProperty=function(e){if(e.domain()!=this)throw new Error(p.SHOULD_BE_ALREADY_OWNED.message);if(this._properties.indexOf(e)!=-1)throw new Error(p.ALREADY_INCLUDED.message);this._properties.push(e)},t}(A);t.StructuredType=_;var T=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._keyShouldStartFrom=null,t._isRequired=!1,t._isMultiValue=!1,t._descriminates=!1,t._defaultBooleanValue=null,t._defaultIntegerValue=null,t}return a(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER_Property)return!0}return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_Property)},t.prototype.withMultiValue=function(e){return void 0===e&&(e=!0),this._isMultiValue=e,this},t.prototype.withDescriminating=function(e){return this._descriminates=e,this},t.prototype.withRequired=function(e){return this._isRequired=e,this},t.prototype.isRequired=function(){return this._isRequired},t.prototype.withKeyRestriction=function(e){return this._keyShouldStartFrom=e,this},t.prototype.withDomain=function(e,t){return void 0===t&&(t=!1),this._ownerClass=e,t?e.registerCustomProperty(this):e.registerProperty(this),this},t.prototype.setDefaultVal=function(e){return this._defaultValue=e,this},t.prototype.setDefaultBooleanVal=function(e){return this._defaultBooleanValue=e,this},t.prototype.setDefaultIntegerVal=function(e){return this._defaultIntegerValue=e,this},t.prototype.defaultValue=function(){return null!=this._defaultValue?this._defaultValue:null!=this._defaultBooleanValue?this._defaultBooleanValue:null!=this._defaultIntegerValue?this._defaultIntegerValue:null},t.prototype.isPrimitive=function(){return!1},t.prototype.withRange=function(e){return this._nodeRange=e,this},t.prototype.isValueProperty=function(){return this._nodeRange.hasValueTypeInHierarchy()},t.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},t.prototype.keyPrefix=function(){return this._keyShouldStartFrom},t.prototype.withEnumOptions=function(e){return this._enumOptions=e,this},t.prototype.withKeyRegexp=function(e){return this._keyRegexp=e,this},t.prototype.getKeyRegexp=function(){return this._keyRegexp},t.prototype.matchKey=function(e){if(null==e)return!1;if(null!=this._groupName)return this._groupName==e;if(null!=this._keyShouldStartFrom&&0==e.indexOf(this._keyShouldStartFrom))return!0;if(this._enumOptions&&this._enumOptions.indexOf(e)!=-1)return!0;if(this.getKeyRegexp())try{if(new RegExp(this.getKeyRegexp()).test(e))return!0}catch(e){}return!1},t.prototype.getFacetValidator=function(){return this.facetValidator},t.prototype.setFacetValidator=function(e){this.facetValidator=e},t.prototype.domain=function(){return this._ownerClass},t.prototype.range=function(){return this._nodeRange},t.prototype.isMultiValue=function(){return!(!this.range()||!this.range().hasArrayInHierarchy())||this._isMultiValue},t.prototype.isDescriminator=function(){return this._descriminates},t.CLASS_IDENTIFIER_Property="nominal-types.Property",t}(h);t.Property=T;var S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return a(t,e),t.prototype.key=function(){return null},t.prototype.leftType=function(){return this.left},t.prototype.rightType=function(){return this.right},t.prototype.isUserDefined=function(){return!0},t.prototype.unionInHierarchy=function(){return this},t.prototype.union=function(){return this},t.prototype.hasUnionInHierarchy=function(){return!0},t.prototype.isUnion=function(){return!0},t.prototype.isObject=function(){return this.leftType().isObject()&&this.rightType().isObject()},t.prototype.hasArrayInHierarchy=function(){return this.left&&this.right?this.left.hasArrayInHierarchy()||this.right.hasArrayInHierarchy():this.left?this.left.hasArrayInHierarchy():this.right?this.right.hasArrayInHierarchy():void 0},t}(A);t.Union=S;var N=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return a(t,e),t.prototype.hasArrayInHierarchy=function(){return!0},t.prototype.isArray=function(){return!0},t.prototype.isObject=function(){return!1},t.prototype.arrayInHierarchy=function(){return this},t.prototype.array=function(){return this},t.prototype.isUserDefined=function(){return!0},t.prototype.componentType=function(){return this.component},t.prototype.setComponent=function(e){this.component=e},t.prototype.key=function(){return null},t}(A);t.Array=N;var I=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return a(t,e),t.prototype.externalInHierarchy=function(){return this},t.prototype.typeId=function(){return this.schemaString},t.prototype.schema=function(){return this.schemaString},t.prototype.isUserDefined=function(){return!0},t.prototype.hasExternalInHierarchy=function(){return!0},t.prototype.isExternal=function(){return!0},t.prototype.external=function(){return this},t}(_);t.ExternalType=I},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this.name=e,this.value=t}return e}();t.ValueRequirement=n},function(e,t,n){"use strict";function r(e,t){o.visit(e,t)}function i(e){return o.serializeToString(e)}function a(e){return o.parse(e)}Object.defineProperty(t,"__esModule",{value:!0});var o=n(172);t.visit=r,t.serializeToString=i,t.parse=a},function(e,t,n){"use strict";function r(e){var t=e[0],n={};return e.forEach(function(e){return n[e.name]=e}),e.forEach(function(e){var t=e.imports;Object.keys(t).forEach(function(e){var r=t[e];t[e]=n[r]})}),t}Object.defineProperty(t,"__esModule",{value:!0}),t.universeDumps={RAML08:r(n(179)),RAML10:r(n(180))}},function(e,t){e.exports=[{classes:[{name:"GlobalSchema",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the global schema, used to refer on schema content"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.actuallyExports",arguments:["value"]},{name:"MetaModel.description",arguments:["Content of the schema"]}],extends:[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The title property is a short plain text description of the RESTful API. The value SHOULD be suitable for use as a title for the contained user documentation."]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If the RAML API definition is targeted to a specific API version, the API definition MUST contain a version property. The version property is OPTIONAL and should not be used if: The API itself is not versioned. The API definition does not change between versions. The API architect can decide whether a change to user documentation elements, but no change to the API's resources, constitutes a version change. The API architect MAY use any versioning scheme so long as version numbers retain the same format. For example, 'v3', 'v3.0', and 'V3' are all allowed, but are not considered to be equal."]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["(Optional during development; Required after implementation) A RESTful API's resources are defined relative to the API's base URI. The use of the baseUri field is OPTIONAL to allow describing APIs that have not yet been implemented. After the API is implemented (even a mock implementation) and can be accessed at a service endpoint, the API definition MUST contain a baseUri property. The baseUri property's value MUST conform to the URI specification RFC2396 or a Level 1 Template URI as defined in RFC6570. The baseUri property SHOULD only be used as a reference value."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["Base uri parameters are named parameters which described template parameters in the base uri"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["URI parameters can be further defined by using the uriParameters property. The use of uriParameters is OPTIONAL. The uriParameters property MUST be a map in which each key MUST be the name of the URI parameter as defined in the baseUri property. The uriParameters CANNOT contain a key named version because it is a reserved URI parameter name. The value of the uriParameters property is itself a map that specifies  the property's attributes as named parameters"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A RESTful API can be reached HTTP, HTTPS, or both. The protocols property MAY be used to specify the protocols that an API supports. If the protocols property is not specified, the protocol specified at the baseUri property is used. The protocols property MUST be an array of strings, of values `HTTP` and/or `HTTPS`."]}],valueConstraint:null,optional:!1},{name:"mediaType",type:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/formdata"]]},{name:"MetaModel.description",arguments:["(Optional) The media types returned by API responses, and expected from API requests that accept a body, MAY be defaulted by specifying the mediaType property. This property is specified at the root level of the API definition. The property's value MAY be a single string with a valid media type described in the specification."]},{name:"MetaModel.inherited",arguments:[]}],valueConstraint:null,optional:!1},{name:"schemas",type:{base:{typeName:"GlobalSchema",nameSpace:"",basicName:"GlobalSchema",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["To better achieve consistency and simplicity, the API definition SHOULD include an OPTIONAL schemas property in the root section. The schemas property specifies collections of schemas that could be used anywhere in the API definition. The value of the schemas property is an array of maps; in each map, the keys are the schema name, and the values are schema definitions. The schema definitions MAY be included inline or by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemes to apply to all methods, these must be defined in the securitySchemes declaration."]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemes that can be applied using securedBy"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Resources are identified by their relative URI, which MUST begin with a slash (/). A resource defined as a root-level property is called a top-level resource. Its property's key is the resource's URI relative to the baseUri. A resource defined as a child property of another resource is called a nested resource, and its property's key is its URI relative to its parent resource's URI. Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property. The key of a resource, i.e. its relative URI, MAY consist of multiple URI path fragments separated by slashes; e.g. `/bom/items` may indicate the collection of items in a bill of materials as a single resource. However, if the individual URI path fragments are themselves resources, the API definition SHOULD use nested resources to describe this structure; e.g. if `/bom` is itself a resource then `/items` should be a nested resource of `/bom`, while `/bom/items` should not be used."]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The API definition can include a variety of documents that serve as a user guides and reference documentation for the API. Such documents can clarify how the API works or provide business context. Documentation-generators MUST include all the sections in an API definition's documentation property in the documentation output, and they MUST preserve the order in which the documentation is declared. To add user documentation to the API, include the documentation property at the root of the API definition. The documentation property MUST be an array of documents. Each document MUST contain title and content attributes, both of which are REQUIRED. If the documentation property is specified, it MUST include at least one document. Documentation-generators MUST process the content field as if it was defined using Markdown."]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",
Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!0,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Referencable",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[],isInterface:!0,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DeclaresDynamicType",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[],isInterface:!0,annotations:[],extends:[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"T",nameSpace:"",basicName:"T",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUri",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["Mardown string is a string which can contain markdown as an extension this markdown should support links with RAML Pointers since 1.0"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSonSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType&&this.mediaType.isJSON()"]},{name:"MetaModel.description",arguments:["JSON schema"]}],extends:[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["xml"]},{name:"MetaModel.description",arguments:["XSD schema"]}],extends:[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ExampleString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONExample",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isJSON()"]}],extends:[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLExample",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isXML()"]}],extends:[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},{classes:[{name:"RAMLSimpleElement",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},{classes:[{name:"Parameter",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the parameter"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The type attribute specifies the primitive type of the parameter's resolved value. API clients MUST return/throw an error if the parameter's resolved value does not match the specified type. If type is not specified, it defaults to string."]},{name:"MetaModel.canBeDuplicator",arguments:[]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ParameterLocation",nameSpace:"",basicName:"ParameterLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Set to true if parameter is required"]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The default attribute specifies the default value to use for the property if the property is omitted or its value is not specified. This SHOULD NOT be interpreted as a requirement for the client to send the default attribute's value if there is no other value to send. Instead, the default attribute's value is the value the server uses if the client does not send a value."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional) The example attribute shows an example value for the property. This can be used, e.g., by documentation generators to generate sample values for the property."]}],valueConstraint:null,optional:!1},{name:"repeat",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The repeat attribute specifies that the parameter can be repeated. If the parameter can be used multiple times, the repeat parameter value MUST be set to 'true'. Otherwise, the default value is 'false' and the parameter may not be repeated."]},{name:"MetaModel.defaultBooleanValue",arguments:[!1]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For parameters defined inside traits and resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The pattern attribute is a regular expression that a parameter of type string MUST match. Regular expressions MUST follow the regular expression specification from ECMA 262/Perl 5. The pattern MAY be enclosed in double quotes for readability and clarity."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The minLength attribute specifies the parameter value's minimum number of characters."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The maxLength attribute specifies the parameter value's maximum number of characters."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]}],extends:[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a string representation of a date as defined in RFC2616 Section 3.3. "]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.requireValue",arguments:["location","ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ParameterLocation",members:["QUERY","HEADERS","URI","FORM","BURI"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"BodyLike",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Mime type of the request or response body"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.requireValue",arguments:["this.name.isForm()","false"]},{name:"MetaModel.description",arguments:["The structure of a request or response body MAY be further specified by the schema property under the appropriate media type. The schema key CANNOT be specified if a body's media type is application/x-www-form-urlencoded or multipart/form-data. All parsers of RAML MUST be able to interpret JSON Schema and XML Schema. Schema MAY be declared inline or in an external file. However, if the schema is sufficiently large so as to make it difficult for a person to read the API definition, or the schema is reused across multiple APIs or across multiple miles in the same API, the !include user-defined data type SHOULD be used instead of including the content inline. Alternatively, the value of the schema field MAY be the name of a schema specified in the root-level schemas property, or it MAY be declared in an external file and included by using the by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"Sys.ExampleString",nameSpace:"Sys",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Documentation generators MUST use body properties' example attributes to generate example invocations."]}],valueConstraint:null,optional:!1},{name:"formParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["Web forms REQUIRE special encoding and custom declaration. If the API's media type is either application/x-www-form-urlencoded or multipart/form-data, the formParameters property MUST specify the name-value pairs that the API is expecting. The formParameters property is a map in which the key is the name of the web form parameter, and the value is itself a map the specifies the web form parameter's attributes."]}],valueConstraint:null,optional:!1},{name:"schemaContent",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns schema content for the cases when schema is inlined, when schema is included, and when schema is a reference."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Human readable description of the body"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For bodies defined inside traits and resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.canInherit",arguments:["mediaType"]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"XMLBody",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"schema",type:{typeName:"Sys.XMLSchemaString",nameSpace:"Sys",basicName:"XMLSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["XSD Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isXML()"]},{name:"MetaModel.description",arguments:["Needed to set connection between xml related mime types and xsd schema"]}],extends:[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONBody",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"schema",type:{typeName:"Sys.JSonSchemaString",nameSpace:"Sys",basicName:"JSonSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["JSON Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isJSON()"]},{name:"MetaModel.description",arguments:["Needed to set connection between json related mime types and json schema"]}],extends:[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",
typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.HEADERS"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["An API's methods may support custom header values in responses. The custom, non-standard HTTP headers MUST be specified by the headers property. API's may include the the placeholder token {?} in a header name to indicate that any number of headers that conform to the specified format can be sent in responses. This is particularly useful for APIs that allow HTTP headers that conform to some naming convention to send arbitrary, custom data."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Each response MAY contain a body property, which conforms to the same structure as request body properties (see Body). Responses that can return more than one response code MAY therefore have multiple bodies defined. For APIs without a priori knowledge of the response types for their responses, `*/*` MAY be used to indicate that responses that do not matching other defined data types MUST be accepted. Processing applications MUST match the most descriptive media type first if `*/*` is used."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For responses defined inside traits and resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},{classes:[{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Method"]},{name:"MetaModel.description",arguments:["Methods that can be called on this resource"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Children resources"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Security.TraitRef",nameSpace:"Security",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource type"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},{classes:[{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Resource methods MAY have one or more responses. Responses MAY be described using the description property, and MAY include example attributes or schema properties."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"Bodies.BodyLike",nameSpace:"Bodies",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override an API's protocols value for that single method by setting a different value for the fields."]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemas to apply, these must be defined in the securitySchemes declaration. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme. Security schemas may also be applied to a resource with securedBy, which is equivalent to applying the security schemas to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"queryParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.QUERY"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.HEADERS"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Method object allows description of http methods"]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","patch","options","head","trace","connect"]]},{name:"MetaModel.description",arguments:["Method that can be called"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For methods defined inside resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the security scheme part"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{headers:[{name:"MetaModel.markdownDescription",arguments:["Optional array of headers, documenting the possible headers that could be accepted."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the request header names and whose values describe the values."]}],queryParameters:[{name:"MetaModel.markdownDescription",arguments:["Query parameters, used by the schema in order to authorize the request. Mutually exclusive with queryString."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the query parameter names and whose values describe the values."]}],queryString:[{name:"MetaModel.description",arguments:["Specifies the query string, used by the schema in order to authorize the request. Mutually exclusive with queryParameters."]},{name:"MetaModel.valueDescription",arguments:["Type name or type declaration"]}],responses:[{name:"MetaModel.description",arguments:["Optional array of responses, describing the possible responses that could be sent."]}],description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the security scheme part"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","DigestSecurityScheme Authentication","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0, <br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* x-&lt;other&gt;"]
}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or refresh_token."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials <br>* implicit<br>* refresh_token."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}]},function(e,t){e.exports=[{classes:[{name:"Library",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why library exist"]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Namespace which the library is imported under"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"LibraryBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"schemas",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "types" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "types" property, as the "schemas" alias for that property name may be removed in a future RAML version. The "types" property allows for XML and JSON schemas.']}],valueConstraint:null,optional:!1},{name:"types",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.MODELS"]},{name:"MetaModel.description",arguments:["Declarations of (data) types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of (data) types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map type names to type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]},{name:"MetaModel.description",arguments:["Declarations of traits for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of traits for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map trait names to trait declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]},{name:"MetaModel.description",arguments:["Declarations of resource types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of resource types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map resource type names to resource type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"annotationTypes",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["decls","true"]},{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of annotation types for use by annotations"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of annotation types for use by annotations."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map annotation type names to annotation type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemas declarations"]},{name:"MetaModel.description",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.markdownDescription",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map security scheme names to security scheme declarations; or an array of such objects"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.internalClass",arguments:[]}],extends:[{typeName:"FragmentDeclaration",nameSpace:"",basicName:"FragmentDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the API"]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The version of the API, e.g. 'v1'"]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A URI that's to be used as the base of all the resources' URIs. Often used as the base of the URL of each resource, containing the location of the API. Can be a template URI."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.BURI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Named parameters used in the baseUri (template)"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["The protocols supported by the API"]},{name:"MetaModel.valueDescription",arguments:['Array of strings, with each being "HTTP" or "HTTPS", case-insensitive']}],valueConstraint:null,optional:!1},{name:"mediaType",type:{base:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]},{name:"MetaModel.description",arguments:['The default media type to use for request and response bodies (payloads), e.g. "application/json"']},{name:"MetaModel.inherited",arguments:[]},{name:"MetaModel.valueDescription",arguments:["Media type string"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The security schemes that apply to every resource and method in the API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["The resources of the API, identified as relative URIs that begin with a slash (/). Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property, e.g.: /users, /{groupId}, etc"]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Additional overall documentation for the API"]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:['Returns RAML version. "RAML10" string is returned for RAML 1.0. "RAML08" string is returned for RAML 0.8.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this API. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"Overlay",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why overlay exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the overlay is applied to."]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Extension",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why extension exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the extension is applied to"]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"UsesDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name prefix (without dot) used to refer imported declarations"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"FragmentDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"uses",type:{base:{typeName:"UsesDeclaration",nameSpace:"",basicName:"UsesDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!0,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"
},{classes:[{name:"ValueType",methods:[{returnType:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},name:"value",start:170,end:210,text:"\n\n  value():string {\n    return null\n  }",arguments:[]}],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]},{name:"MetaModel.alias",arguments:["string"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]},{name:"MetaModel.alias",arguments:["any"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]},{name:"MetaModel.alias",arguments:["number"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["integer"]},{name:"MetaModel.alias",arguments:["integer"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NullType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["null"]},{name:"MetaModel.alias",arguments:["null"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["time-only"]},{name:"MetaModel.alias",arguments:["time-only"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["date-only"]},{name:"MetaModel.alias",arguments:["date-only"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime-only"]},{name:"MetaModel.alias",arguments:["datetime-only"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime"]},{name:"MetaModel.alias",arguments:["datetime"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["file"]},{name:"MetaModel.alias",arguments:["file"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]},{name:"MetaModel.alias",arguments:["boolean"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[{name:"structuredValue",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUriString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ContentType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["[GitHub Flavored Markdown](https://help.github.com/articles/github-flavored-markdown/)"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]},{name:"MetaModel.alias",arguments:["schema"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},{classes:[{name:"ExampleSpec",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["String representation of example"]},{name:"MetaModel.required",arguments:[]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of example, if possible"]}],valueConstraint:null,optional:!1},{name:"strict",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["By default, examples are validated against any type declaration. Set this to false to allow examples that need not validate."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Example identifier, if specified"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the example"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the example"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this example. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"TypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Type name for top level types. For properties and parameters -- property o parameter name, respectively. For bodies -- media type."]},{name:"MetaModel.extraMetaKey",arguments:["headers"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"facets",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.declaringFields",arguments:[]},{name:"MetaModel.description",arguments:["When extending from a type you can define new facets (which can then be set to concrete values by subtypes)."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"fixedFacets",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns facets fixed by the type. Value is an object with properties named after facets fixed. Value of each property is a value of the corresponding facet."]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "type" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "type" property, as the "schema" alias for that property name may be removed in a future RAML version. The "type" property allows for XML and JSON schemas.']},{name:"MetaModel.valueDescription",arguments:["Single string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["A base type which the current type extends, or more generally a type expression."]},{name:"MetaModel.valueDescription",arguments:["string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"structuredType",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.description",arguments:["Inlined supertype definition."]},{name:"MetaModel.valueDescription",arguments:["Inlined supertype definition"]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ModelLocation",nameSpace:"",basicName:"ModelLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"locationKind",type:{typeName:"LocationKind",nameSpace:"",basicName:"LocationKind",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Kind of location"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Provides default value for a property"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string or yaml map/sequence. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the examples property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"examples",type:{base:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the example property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.requireValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["For property or parameter states if it is required."]},{name:"MetaModel.describesAnnotation",arguments:["required"]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the type"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1},{name:"xml",type:{typeName:"XMLFacetInfo",nameSpace:"",basicName:"XMLFacetInfo",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"allowedTargets",type:{base:{typeName:"AnnotationTarget",nameSpace:"",basicName:"AnnotationTarget",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["API","DocumentationItem","Resource","Method","Response","RequestBody","ResponseBody","TypeDeclaration","NamedExample","ResourceType","Trait","SecurityScheme","SecuritySchemeSettings","AnnotationTypeDeclaration","Library","Overlay","Extension","Scalar"]]},{name:"MetaModel.description",arguments:["Restrictions on where annotations of this type can be applied. If this property is specified, annotations of this type may only be applied on a property corresponding to one of the target names specified as the value of this property."]},{name:"MetaModel.valueDescription",arguments:["An array, or single, of names allowed target nodes."]}],valueConstraint:null,optional:!1},{name:"isAnnotation",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type represents annotation"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in traits or resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this type. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"XMLFacetInfo",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"attribute",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If attribute is set to true, a type instance should be serialized as an XML attribute. It can only be true for scalar types."]}],valueConstraint:null,optional:!1},{name:"wrapped",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If wrapped is set to true, a type instance should be wrapped in its own XML element. It can not be true for scalar types and it can not be true at the same moment when attribute is true."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to override the name of the XML element or XML attribute in it's XML representation."]}],valueConstraint:null,optional:!1},{name:"namespace",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the name of the XML namespace."]}],valueConstraint:null,optional:!1},{name:"prefix",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the prefix which will be used during serialization to XML."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ArrayTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"array"},optional:!1},{name:"uniqueItems",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["uniqueItems"]},{name:"MetaModel.description",arguments:["Should items in array be unique"]}],valueConstraint:null,optional:!1},{name:"items",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.description",arguments:["Array component type."]},{name:"MetaModel.valueDescription",arguments:["Inline type declaration or type name."]}],valueConstraint:null,optional:!1},{name:"structuredItems",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.description",arguments:["Inlined component type definition"]},{name:"MetaModel.valueDescription",arguments:["Inlined component type definition"]}],valueConstraint:null,optional:!1},{name:"minItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minItems"]},{name:"MetaModel.description",arguments:["Minimum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to 0"]}],valueConstraint:null,optional:!1},{name:"maxItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxItems"]},{name:"MetaModel.description",arguments:["Maximum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to undefined."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.alias",arguments:["array"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"UnionTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"union"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.requireValue",arguments:["locationKind","LocationKind.MODELS"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ObjectTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[{name:"MetaModel.hide",arguments:[]}],valueConstraint:{isCallConstraint:!1,value:"object"},optional:!1},{name:"properties",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["The properties that instances of this type may or must have."]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the properties' names and whose values are property declarations."]}],valueConstraint:null,optional:!1},{name:"minProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minProperties"]},{name:"MetaModel.description",arguments:["The minimum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"maxProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxProperties"]},{name:"MetaModel.description",arguments:["The maximum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"additionalProperties",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",
arguments:["A Boolean that indicates if an object instance has additional properties."]}],valueConstraint:null,optional:!1},{name:"discriminator",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Type property name to be used as discriminator, or boolean"]}],valueConstraint:null,optional:!1},{name:"discriminatorValue",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The value of discriminator for the type."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.definingPropertyIsEnough",arguments:["properties"]},{name:"MetaModel.setsContextValue",arguments:["field","true"]},{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["pattern"]},{name:"MetaModel.description",arguments:["Regular expression that this string should path"]},{name:"MetaModel.valueDescription",arguments:["regexp"]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minLength"]},{name:"MetaModel.description",arguments:["Minimum length of the string"]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxLength"]},{name:"MetaModel.description",arguments:["Maximum length of the string"]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1},{name:"enum",type:{base:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minimum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maximum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","float","double","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1},{name:"multipleOf",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:['A numeric instance is valid against "multipleOf" if the result of the division of the instance by this keyword\'s value is an integer.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "full-date" notation of RFC3339, namely yyyy-mm-dd (no implications about time or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"time-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "partial-time" notation of RFC3339, namely hh:mm:ss[.ff...] (no implications about date or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['combined date-only and time-only with a separator of "T", namely yyyy-mm-ddThh:mm:ss[.ff...] (no implications about timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["rfc3339","rfc2616"]]},{name:"MetaModel.description",arguments:["Format used for this date time rfc3339 or rfc2616"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['a timestamp, either in the "date-time" notation of RFC3339, if format is omitted or is set to rfc3339, or in the format defined in RFC2616, if format is set to rfc2616.']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Indicates whether the instance is array"]}],valueConstraint:null,optional:!1},{name:"items",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Returns components of array instances"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ModelLocation",members:["QUERY","HEADERS","URI","FORM","BURI","ANNOTATION","MODEL","SECURITYSCHEMATYPE"]},{name:"LocationKind",members:["APISTRUCTURE","DECLARATIONS","MODELS"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Declarations:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["Detailed information about any response headers returned by this method"]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the response header names and whose values describe the values."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["The body of the response: a body declaration"]},{name:"MetaModel.valueDescription",arguments:["Object whose properties are either<br>* Media types and whose values are type objects describing the request body for that media type, or<br>* a type object describing the request body for the default media type specified in the root mediaType property."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the response"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For responses defined in traits or resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the response"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this response. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},{classes:[{name:"Annotable",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"annotations",type:{base:{typeName:"Decls.AnnotationRef",nameSpace:"Decls",basicName:"AnnotationRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},typeKind:1},annotations:[{name:"MetaModel.noDirectParse",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","datamodel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["location","datamodel.ModelLocation.ANNOTATION"]},{name:"MetaModel.description",arguments:["Most of RAML model elements may have attached annotations decribing additional meta data about this element"]},{name:"MetaModel.documentationTableLabel",arguments:["(&lt;annotationName&gt;)"]},{name:"MetaModel.valueDescription",arguments:["A value corresponding to the declared type of this annotation."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},{classes:[{name:"AnnotationRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"annotation",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced annotation"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Annotations allow you to attach information to your API"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnnotationTarget",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Elements to which this Annotation can be applied (enum)"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},{classes:[{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the trait display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override the protocols specified in the resource or at the API root, by employing this property."]},{name:"MetaModel.valueDescription",arguments:["array of strings of value HTTP or HTTPS, or a single string of such kind, case-insensitive"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","options","head","patch","trace","connect"]]},{name:"MetaModel.description",arguments:["Method that can be called"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"
}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the method display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"Operation",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"queryParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.QUERY"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming  a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"queryString",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.description",arguments:["Specifies the query string needed by this method. Mutually exclusive with queryParameters."]}],valueConstraint:null,optional:!1},{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["response","true"]},{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Information about the expected responses to a request"]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the HTTP status codes of the responses and whose values describe the responses."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.description",arguments:['Annotations to be applied to this security scheme part. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"signatures",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HMAC-SHA1","RSA-SHA1","PLAINTEXT"]]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["List of the signature methods used by the server. Available methods: HMAC-SHA1, RSA-SHA1, PLAINTEXT"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oftenKeys",arguments:[["authorization_code","password","client_credentials","implicit"]]},{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or any absolute url."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials<br>* implicit <br>*  or any absolute url."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","Digest Authentication","Pass Through","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0,<br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* Pass Through<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]},{name:"MetaModel.description",arguments:["The description MAY be used to describe a securityScheme."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the security scheme display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"PassThroughSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Pass Through"},optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},{classes:[{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]},{name:"MetaModel.markdownDescription",arguments:["The methods available on this resource."]},{name:"MetaModel.documentationTableLabel",arguments:["get?<br>patch?<br>put?<br>post?<br>delete?<br>options?<br>head?"]},{name:"MetaModel.valueDescription",arguments:["Object describing the method"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Methods.TraitRef",nameSpace:"Methods",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the traits to apply to all methods declared (implicitly or explicitly) for this resource. Individual methods may override this declaration"]},{name:"MetaModel.valueDescription",arguments:["array, which can contain each of the following elements:<br>* name of unparametrized trait <br>* a key-value pair with trait name as key and a map of trait parameters as value<br>* inline trait declaration <br><br>(or a single element of any above kind)"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The resource type which this resource inherits."]},{name:"MetaModel.valueDescription",arguments:["one of the following elements:<br>* name of unparametrized resource type<br>* a key-value pair with resource type name as key and a map of its parameters as value<br>* inline resource type declaration"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["The security schemes that apply to all methods declared (implicitly or explicitly) for this resource."]},{name:"MetaModel.valueDescription",arguments:["array of security scheme names or a single security scheme name"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.URI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Detailed information about any URI parameters of this resource"]},{name:"MetaModel.valueDescription",arguments:["object whose property names are the URI parameter names and whose values describe the values"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:['A nested resource is identified as any property whose name begins with a slash ("/") and is therefore treated as a relative URI.']},{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.valueDescription",arguments:["object describing the nested resource"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the resource."]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this resource. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",
Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},{classes:[{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1},{name:"fileTypes",type:{base:{typeName:"Sys.ContentType",nameSpace:"Sys",basicName:"ContentType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of valid content-type strings for the file. The file type */* should be a valid value."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The minLength attribute specifies the parameter value's minimum number of bytes."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The maxLength attribute specifies the parameter value's maximum number of bytes."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}]},function(e,t,n){"use strict";function r(e,t){var n=new s.Universe(t,""),r={};return T(e,n,{},r),Object.keys(r).forEach(function(e){A(r[e],n)}),Object.keys(r).forEach(function(e){E(r[e],n)}),Object.keys(r).forEach(function(e){_(r[e],n)}),n.types().forEach(function(e){if(e instanceof s.NodeClass){var t=e;if(t.properties().forEach(function(e){var t=e.range(),n=e;t.hasValueTypeInHierarchy()||t.properties().forEach(function(e){if(e.getAdapter(p.RAMLPropertyService).isKey()){var t=e.keyPrefix();t&&(n.withKeyRestriction(t),n.merge());var r=e.enumOptions();r&&(n.withEnumOptions(r),n.merge())}})}),t.getAdapter(p.RAMLService).isGlobalDeclaration()){if(t.getAdapter(p.RAMLService).getActuallyExports()&&"$self"!=t.getAdapter(p.RAMLService).getActuallyExports()){var r=t.property(t.getAdapter(p.RAMLService).getActuallyExports()).range();if(r.hasValueTypeInHierarchy()){var i=r.getAdapter(p.RAMLService);i.setGloballyDeclaredBy(t)}}if(t.getAdapter(p.RAMLService).getConvertsToGlobal()){var r=n.type(t.getAdapter(p.RAMLService).getConvertsToGlobal());if(r.hasValueTypeInHierarchy()){var i=r.getAdapter(p.RAMLService);i.setGloballyDeclaredBy(t)}}}}}),n}function i(e,t,n,r,i){var a=s.prop(e.name(),"",t,n,r);e.isMultiValue()&&a.withMultiValue(!0),a.unmerge(),n||console.log(e.name()+":"+t.nameId()+" has undefined type"),n.hasValueTypeInHierarchy()||n.properties().forEach(function(e){if(e.getAdapter(p.RAMLPropertyService).isKey()){var t=e.keyPrefix();t&&(a.withKeyRestriction(t),a.merge());var n=e.enumOptions();n&&(a.withEnumOptions(n),a.merge())}}),S(e,a,i)}var a=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var o=n(182),s=n(56),u=n(190),l=n(191),p=s,c=function(){function e(e,t){this._field=e,this._clazz=t}return e.prototype.name=function(){return this._field.name},e.prototype.range=function(){return this._clazz.getModule().typeFor(this._field.type,this._clazz)},e.prototype.isMultiValue=function(){return this._field.type.typeKind==o.TypeKind.ARRAY},e.prototype.isKey=function(){return null!=u.find(this._field.annotations,function(e){return"MetaModel.key"==e.name})},e.prototype.isSimpleValue=function(){return null!=u.find(this._field.annotations,function(e){return"MetaModel.value"==e.name})},e.prototype.annotations=function(){return this._field.annotations},e}(),f=function(){function e(e,t){this._field=e,this._clazz=t}return e.prototype.name=function(){return this._field.name},e.prototype.value=function(){return this._field.valueConstraint},e}(),h=function(){function e(e,t){this._clazz=e,this.mw=t}return e.prototype.typeMeta=function(){return this._clazz.annotations},e.prototype.path=function(){return this.mw.path()},e.prototype.getModule=function(){return this.mw},e.prototype.typeArgs=function(){return this._clazz.typeParameters},e.prototype.typConstraints=function(){var e=this;return this._clazz.typeParameterConstraint.map(function(t){return t?e.mw.classForName(t):null})},e.prototype.methods=function(){return this._clazz.methods},e.prototype.name=function(){return this._clazz.name},e.prototype.members=function(){var e=this;return this._clazz.fields.filter(function(e){return null==e.valueConstraint}).map(function(t){return new c(t,e)})},e.prototype.constraints=function(){var e=this;return this._clazz.fields.filter(function(e){return null!=e.valueConstraint}).map(function(t){return new f(t,e)})},e.prototype.isSubTypeOf=function(e){if(this==e)return!0;var t=!1;return this.getAllSuperTypes().forEach(function(n){t||(t=t||n.isSubTypeOf(e))}),t},e.prototype.getExtendsClauses=function(){return this._clazz.extends},e.prototype.getSuperTypes=function(){var e=this,t=[];return this._clazz.extends.forEach(function(n){var r=e.mw.classForName(n.typeName);r&&t.push(r)}),t},e.prototype.getAllSuperTypes=function(){var e=this,t=[];return this._clazz.extends.forEach(function(n){var r=e.mw.classForName(n.typeName);if(r){var i=r.getAllSuperTypes();t.push(r),t.concat(i)}}),u.unique(t)},e.prototype.annotationOverridings=function(){return this._clazz.annotationOverridings},e}(),d=function(){function e(){}return e.prototype.members=function(){return[]},e.prototype.methods=function(){return[]},e.prototype.isSubTypeOf=function(e){return!1},e.prototype.getSuperTypes=function(){return[]},e.prototype.getAllSuperTypes=function(){return[]},e.prototype.name=function(){return null},e.prototype.constraints=function(){return[]},e.prototype.typeMeta=function(){return[]},e.prototype.getModule=function(){throw new Error("Not implemented")},e.prototype.annotationOverridings=function(){return{}},e}(),m=function(e){function t(t,n){var r=e.call(this)||this;return r._clazz=t,r.mw=n,r}return a(t,e),t.prototype.getModule=function(){return this.mw},t.prototype.values=function(){return this._clazz.members},t.prototype.name=function(){return this._clazz.name},t}(d),y=function(e){function t(t,n){var r=e.call(this)||this;return r._clazz=t,r.mw=n,r}return a(t,e),t.prototype.elements=function(){return this._clazz},t.prototype.name=function(){return this._clazz.map(function(e){return e.name()}).join("|")},t}(d),v=function(){function e(e){var t=this;this._univers=e,this.name2Class={},this.namespaceToMod={},this._classes=[],e.classes.forEach(function(e){var n=new h(e,t);t._classes.push(n),t.name2Class[e.name]=n,e.moduleName&&(t.name2Class[e.moduleName+"."+e.name]=n)}),e.enumDeclarations.forEach(function(e){var n=new m(e,t);t._classes.push(n),t.name2Class[e.name]=n})}return e.prototype.typeFor=function(e,t){var n=this;switch(e.typeKind){case o.TypeKind.BASIC:var r=e,i=r.typeName;"string"==i&&(i="StringType"),"number"==i&&(i="NumberType"),"boolean"==i&&(i="BooleanType"),"any"==i&&(i="AnyType");var a=u.indexOf(t.typeArgs(),i);if(a!=-1){var s=t.typConstraints()[a];return s?s:this.classForName("ValueType")}return this.classForName(i);case o.TypeKind.UNION:var l=e;return new y(l.options.map(function(e){return n.typeFor(e,t)}),this);case o.TypeKind.ARRAY:var p=e;return this.typeFor(p.base,t)}return null},e.prototype.path=function(){return this._univers.name},e.prototype.classForName=function(e,t){var n=this;if(void 0===t&&(t={}),!e)return null;var r=this.name2Class[e];if(!r&&!t[this.path()]){t[this.path()]=this;var i=e.indexOf(".");if(i!=-1){var a=this.namespaceToMod[e.substring(0,i)];if(!a)throw new Error;return a.classForName(e.substring(i+1),t)}Object.keys(this.namespaceToMod).forEach(function(i){if("MetaModel"!=i){var a=n.namespaceToMod[i].classForName(e,t);a&&(r=a)}})}return r},e.prototype.classes=function(){return this._classes},e}(),g=function(e,t){if(e){var n;if(e instanceof y){throw new Error("Union type support was removed from definition system")}return n=t.type(e.name())}},A=function(e,t){var n=e.classForName("ValueType");e.classes().forEach(function(e){if(e instanceof m){var r=new s.EnumType(e.name(),t,e.getModule().path());return r.values=e.values(),void t.register(r)}if(e.isSubTypeOf(n)){var i=e.getAllSuperTypes();i.push(e);var a=null;if(i.forEach(function(e){var t=e.getExtendsClauses();t.forEach(function(e){if(e.typeKind==o.TypeKind.BASIC){var t=e;if("Reference"==t.basicName){var n=t.typeArguments[0];a=n.typeName;var r=a.indexOf(".");r!=-1&&(a=a.substring(r+1))}}})}),a){var u=new s.ReferenceType(e.name(),e.getModule().path(),a,t);u.setBuiltIn(!0),t.register(u)}else{var l=new s.ValueType(e.name(),t,e.getModule().path());l.setBuiltIn(!0),t.register(l)}}else{var p=new s.NodeClass(e.name(),t,e.getModule().path());p.setBuiltIn(!0),t.register(p)}})},E=function(e,t){e.classes().forEach(function(e){e.getSuperTypes().forEach(function(n){var r=t.type(e.name()),i=t.type(n.name());if(!r||!i){var r=t.type(e.name()),i=t.type(n.name());throw new Error}t.registerSuperClass(r,i)})})},_=function(e,t){e.classes().forEach(function(e){var n=t.type(e.name());e.typeMeta().forEach(function(n){var r=g(e,t);l.handleTypeAnnotation(n,r)}),e.members().forEach(function(e){var r=e.range(),a=g(r,t);null==a&&console.log(r+":"+e.name());var o=e.annotations().map(function(e){return e.name}).indexOf("MetaModel.customHandling")>=0;i(e,n,a,o)}),Object.keys(e.annotationOverridings()).forEach(function(r){var a=[].concat(e.annotationOverridings()[r]),o={};a.forEach(function(e){return o[e.name]=!0});for(var s,u=e.getSuperTypes(),l={},p=0;p<u.length;p++){var c=u[p];if(!l[c.name()]){l[c.name()]=!0,c.getSuperTypes().forEach(function(e){return u.push(e)});var f=c.annotationOverridings()[r];if(f)f.filter(function(e){return!o[e.name]}).forEach(function(e){o[e.name]=!0,a.push(e)});else for(var h=c.members(),d=0;d<h.length;d++){var m=h[d];if(m.name()==r){s=m;break}}if(s){var y=s.annotations();y.filter(function(e){return!o[e.name]}).forEach(function(e){o[e.name]=!0,a.push(e)});break}}}if(s){var v=s.range(),A=g(v,t);null==A&&console.log(v+":"+e.name()),i(s,n,A,!1,a)}}),e.methods().forEach(function(e){}),e.constraints().forEach(function(e){if(e.value().isCallConstraint)throw new Error;var t=e.value();n.addRequirement(e.name(),""+t.value)})}),t.types().forEach(function(e){var n=e;n.getAdapter(p.RAMLService).getAliases().forEach(function(e){return t.registerAlias(e,n)})})},T=function(e,t,n,r){if(e.name.indexOf("metamodel.ts")==-1){if(r[e.name])return r[e.name];var i=new v(e);return n[e.name]=i,r[e.name]=i,Object.keys(e.imports).forEach(function(a){var o=e.imports[a];if(n[o.name])return void(i.namespaceToMod[a]=n[o.name]);var s=T(o,t,n,r);i.namespaceToMod[a]=s}),n[e.name]=null,i}};t.toDefSystem=r;var S=function(e,t,n){n||(n=e.annotations()),n.forEach(function(e){var n=e.name.substring(e.name.lastIndexOf(".")+1);l.annotationHandlers[n]||console.log("Can not find handler for:"),l.annotationHandlers[n](e,t)})}},function(e,t,n){"use strict";function r(e,t){return{name:e,methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:t,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}}function i(e,t,n){return a.parseStruct(e,t,n)}Object.defineProperty(t,"__esModule",{value:!0}),t.helpers=n(183);var a=n(188),o=function(){function e(){}return e}();t.EnumDeclaration=o;var s;!function(e){e[e.BASIC=0]="BASIC",e[e.ARRAY=1]="ARRAY",e[e.UNION=2]="UNION"}(s=t.TypeKind||(t.TypeKind={})),t.classDecl=r,t.parseStruct=i},function(e,t,n){"use strict";function r(e,t){if(e.typeKind==a.TypeKind.ARRAY)return t?[]:[r(e.base)[0]+"[]"];if(e.typeKind==a.TypeKind.BASIC){var n=e,i=n.basicName,o=n.nameSpace&&n.nameSpace.trim();return null!=o&&o.length>0&&"RamlWrapper"!=o&&(i=o+"."+i),n.typeArguments&&0!=n.typeArguments.length&&(i+="<"+n.typeArguments.map(function(e){return r(e)}).join(", ")+">"),t?n.nameSpace&&t[n.nameSpace]?[i]:[]:[i]}if(e.typeKind==a.TypeKind.UNION){var s=e,u=[];return s.options.forEach(function(e){return u=u.concat(r(e,t))}),u}return[]}function i(e){return o.getHelperMethods(e)}Object.defineProperty(t,"__esModule",{value:!0});var a=n(182),o=n(184),s={RamlWrapper:!0},u=function(){function e(e,t,n,r,i){this.originalName=e,this.wrapperMethodName=t,this.returnType=n,this.args=r,this.meta=i}return e.prototype.targetWrappers=function(){var e=!0,t=[];return this.args.forEach(function(n){var i=r(n.type,s);if(0!=i.length)return e&&0==t.length?void(t=t.concat(i)):(t=[],void(e=!1))}),t},e.prototype.callArgs=function(){return this.args.map(function(e){return 0==r(e.type,s).length?e:{name:"this",type:null,optional:!1,defaultValue:void 0}})},e}();t.HelperMethod=u,t.flatten=r,t.getHelperMethods=i},function(e,t,n){"use strict";function r(e){var t=[],n=l.readFileSync(u.resolve(e)).toString(),r=o.createSourceFile("sample.ts",n,o.ScriptTarget.ES3,!0);return s.Matching.visit(r,function(r){var s=r;if(s.kind==o.SyntaxKind.FunctionDeclaration){var u=i(s,n);if(!u)return;var l=s.name.text,f=l;u.name?f=u.name:u.name=l;var f=u.name?u.name:l,h=s.parameters?s.parameters.map(function(t){return a(t,e)}):[],d=(!!u.override&&u.override,p.buildType(s.type,e));t.push(new c.HelperMethod(l,f,d,h,u))}}),t}function i(e,t){var n=o.getLeadingCommentRanges(t,e.pos);if(!n)return null;var r=n.map(function(e){return t.substring(e.pos,e.end)}).join("\n"),i=r.indexOf("__$helperMethod__");if(i<0)return null;i+="__$helperMethod__".length;var a=r.indexOf("__$meta__");if(a<0)return{comment:f(r.substring(i))};var s=f(r.substring(i,a)),u=r.indexOf("{",a);if(u<0)return{comment:s};try{var l=JSON.parse(f(r.substring(u)));return l.comment=s.trim().length>0?s:null,l.override=l.override||!1,l.primary=l.primary||!1,l.deprecated=l.deprecated||!1,l}catch(e){console.log(e)}return{}}function a(e,t){var n,r=e.name.text,i=p.buildType(e.type,t),a=null!=e.questionToken;return null!=e.initializer&&(n=p.parseArg(e.initializer),a=!0),{name:r,type:i,defaultValue:n,optional:a}}Object.defineProperty(t,"__esModule",{value:!0});var o=n(185),s=n(186),u=n(6),l=n(187),p=n(188),c=n(183);t.getHelperMethods=r;var f=function(e){return e.replace(/^\s*\/\*+/g,"").replace(/\*+\/\s*$/g,"").split("\n").map(function(e){return e.replace(/^\s*\/\//g,"").replace(/^\s*\* {0,1}/g,"")}).join("\n").trim()}},function(e,t){e.exports=__WEBPACK_EXTERNAL_MODULE_185__},function(e,t,n){"use strict";var r=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var i,a=n(185);!function(e){function t(n,r){var i=r(n);if(i)return i==e.SKIP?null:i;var o=a.forEachChild(n,function(e){var n=t(e,r);if(n)return n});return o}function n(e,t){void 0===t&&(t=function(e){return!0});for(var n=e.split("."),r=null,a=0;a<n.length;a++){var s=n[a],u=s.indexOf("(*)"),l=!1;u!=-1&&(s=s.substr(0,u),l=!0),r=null==r?"*"==s?o():i(s):new N(r,"*"==s?o():i(s),t),l&&(r=new _(r,t))}return r}function i(e){return new A(e)}function o(){return new E}function s(e,t){return void 0===t&&(t=function(e){return!0}),new _(e,t)}function u(e,t){return void 0===t&&(t=function(e){return!0}),new g(e,t)}function l(e,t,n){return void 0===n&&(n=function(e){return!0}),new y(e,t,n)}function p(e,t,n){return void 0===n&&(n=function(e){return!0}),new v(e,t,n)}function c(){return new m}function f(){return new d}var h=function(){function e(){}return e.prototype.match=function(e){throw new Error},e.prototype.nodeType=function(){throw new Error},e.prototype.doMatch=function(e){return e?this.nodeType()==e.kind?this.match(e):void 0:null},e}();e.BasicMatcher=h;var d=function(e){function t(){return e.call(this)||this}return r(t,e),t.prototype.match=function(e){return e},t.prototype.nodeType=function(){return a.SyntaxKind.ClassDeclaration},t}(h);e.ClassDeclarationMatcher=d;var m=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.match=function(e){return e},t.prototype.nodeType=function(){return a.SyntaxKind.PropertyDeclaration},t}(h);e.FieldMatcher=m;var y=function(e){function t(t,n,r){var i=e.call(this)||this;return i.left=t,i.right=n,i.tr=r,i}return r(t,e),t.prototype.match=function(e){return e.operatorToken.kind==a.SyntaxKind.EqualsToken&&this.left.doMatch(e.left)&&this.right.doMatch(e.right)?this.tr(e):null},t.prototype.nodeType=function(){return a.SyntaxKind.BinaryExpression},t}(h);e.AssignmentExpressionMatcher=y;var v=function(e){function t(t,n,r){var i=e.call(this)||this;return i.left=t,i.right=n,i.tr=r,i}return r(t,e),t.prototype.match=function(e){if(this.left.doMatch(e.name)&&this.right.doMatch(e.initializer))return this.tr(e)},t.prototype.nodeType=function(){return a.SyntaxKind.VariableDeclaration},t}(h);e.VariableDeclarationMatcher=v;var g=function(e){function t(t,n){var r=e.call(this)||this;return r.expression=t,r.tr=n,r}return r(t,e),t.prototype.match=function(e){var t=this.expression.doMatch(e.expression);if(t){var n=this.tr(e.expression);return 1==n?t:n}return null},t.prototype.nodeType=function(){return a.SyntaxKind.ExpressionStatement},t}(h),A=function(e){function t(t){var n=e.call(this)||this;return n.val=t,n}return r(t,e),t.prototype.match=function(e){return e.text==this.val||null},t.prototype.nodeType=function(){return a.SyntaxKind.Identifier},t}(h),E=function(){function e(){}return e.prototype.doMatch=function(e){return!0},e.prototype.nodeType=function(){return null},e}(),_=function(e){function t(t,n){var r=e.call(this)||this;return r.calleeMatcher=t,r.tr=n,r}return r(t,e),t.prototype.match=function(e){return this.calleeMatcher.doMatch(e.expression)?this.tr(e):null},t.prototype.nodeType=function(){return a.SyntaxKind.CallExpression},t}(h);e.SKIP={},e.visit=t;var T=function(){function e(e,t){this._base=t,this.arguments=null,this.name=e}return e}();e.PathNode=T;var S=function(){function e(e,t){this._baseNode=t,this.path=[],this.base=e}return e.prototype.start=function(){return this._baseNode.pos},e.prototype.startLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.start())},e.prototype.endLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.end())},e.prototype.end=function(){var e=this.path[this.path.length-1]._callExpression;return e?e.end:this.start()},e.prototype.toString=function(){return this.path.map(function(e){return e.name}).join(".")},e}();e.CallPath=S;var N=function(e){function t(t,n,r){var i=e.call(this)||this;return i.objectMatcher=t,i.propertyMatcher=n,i.tr=r,i}return r(t,e),t.prototype.match=function(e){return this.objectMatcher.doMatch(e.expression)&&this.propertyMatcher.doMatch(e.name)?this.tr(e):null},t.prototype.nodeType=function(){return a.SyntaxKind.PropertyAccessExpression},t}(h);e.memberFromExp=n;var I=function(){function e(e){this.rootMatcher=e}return e.prototype.doMatch=function(e){if(e.kind==a.SyntaxKind.CallExpression){var t=e,n=this.doMatch(t.expression);if(n)return n.path.length>0&&null==n.path[n.path.length-1].arguments?(n.path[n.path.length-1].arguments=t.arguments,n.path[n.path.length-1]._callExpression=t,n):null}else if(e.kind==a.SyntaxKind.PropertyAccessExpression){var r=e,i=this.doMatch(r.expression);if(i)return r.name.kind==a.SyntaxKind.Identifier?(i.path.push(new T(r.name.text,r.name)),i):null}else if(e.kind==a.SyntaxKind.Identifier){var o=e;if(this.rootMatcher.doMatch(o))return new S(o.text,o)}return null},e.prototype.nodeType=function(){return null},e}();e.CallBaseMatcher=I,e.ident=i,e.anyNode=o,e.call=s,e.exprStmt=u,e.assign=l,e.varDecl=p,e.field=c,e.classDeclaration=f}(i=t.Matching||(t.Matching={}))},function(e,t){function n(e){return null}function r(e,t){}function i(e){return!1}function a(e){}function o(e){}function s(e){return{isDirectory:function(){return!1},isSymbolicLink:function(){return!1},isFile:function(){return!1}}}function u(e){return this.statSync(e)}function l(e,t){return[]}function p(e){}t.readFileSync=n,t.writeFileSync=r,t.existsSync=i,t.mkdirSync=a,t.readdirSync=o,t.statSync=s,t.lstatSync=u,t.list=l,t.onChange=p},function(e,t,n){"use strict";function r(e){return A.createSourceFile("sample.ts",e,A.ScriptTarget.ES3,!0)}function i(e,n,s){var u=r(e),l={classes:[],aliases:[],enumDeclarations:[],imports:{},name:s};n[s]=l;var p=null;return t.tsm.Matching.visit(u,function(r){if(r.kind==A.SyntaxKind.ModuleDeclaration){var u=r;p=u.name.text}if(r.kind==A.SyntaxKind.ImportEqualsDeclaration){var c=r,f=c.name.text;if("RamlWrapper"==f)return;var h=c.moduleReference,d=h.expression,m=d.text,v=E.resolve(E.dirname(s)+"/",m)+".ts";if(!E.existsSync(v))throw new Error("Path "+m+" resolve to "+v+"do not exists");if(!n[v]){var g=E.readFileSync(v);i(g,n,v)}l.imports[f]=n[v]}if(r.kind==A.SyntaxKind.TypeAliasDeclaration){var _=r;if(_.name){var N=_.name.text,I=y(_.type,s);l.aliases.push({name:N,type:I})}}if(r.kind==A.SyntaxKind.EnumDeclaration){var b=r,R=[];b.members&&b.members.forEach(function(e){R.push(e.name.text)}),b.name&&l.enumDeclarations.push({name:b.name.text,members:R})}var M=r.kind==A.SyntaxKind.InterfaceDeclaration,C=r.kind==A.SyntaxKind.ClassDeclaration;if(M||C){var w=r;if(w){var P={},L=T.classDecl(w.name.text,M);return L.moduleName=p,l.classes.push(L),w.members.forEach(function(t){if(t.kind==A.SyntaxKind.MethodDeclaration){var n=t,r=o(n,e,s);L.methods.push(r)}var i=S.doMatch(t);if(i){var u=a(i,s);if("$"==u.name)L.annotations=u.annotations;else if("$"!=u.name.charAt(0)||"$ref"==u.name)P[u.name]=u,L.fields.push(u);else{var l=u.name.substr(1),p=P[l];if(p)p.annotations=u.annotations;else if("$$"!=u.name){var c=L.annotationOverridings[l];c||(c=[]),L.annotationOverridings[l]=c.concat(u.annotations)}}}}),w.typeParameters&&w.typeParameters.forEach(function(e){L.typeParameters.push(e.name.text),null==e.constraint?L.typeParameterConstraint.push(null):L.typeParameterConstraint.push(e.constraint.typeName.text)}),w.heritageClauses&&w.heritageClauses.forEach(function(e){e.types.forEach(function(t){if(e.token==A.SyntaxKind.ExtendsKeyword)L.extends.push(y(t,s));else{if(e.token!=A.SyntaxKind.ImplementsKeyword)throw new Error("Unknown token class heritage");L.implements.push(y(t,s))}})}),t.tsm.Matching.SKIP}}}),l}function a(e,t){return{name:e.name.text,type:y(e.type,t),annotations:"$"==e.name.text.charAt(0)?l(e.initializer):[],valueConstraint:"$"!=e.name.text.charAt(0)?u(e.initializer):null,optional:null!=e.questionToken}}function o(e,t,n){var r=e.name.text,i=t.substring(e.pos,e.end),a=[];e.parameters.forEach(function(e){a.push(s(e,t,n))});var o={returnType:y(e.type,n),name:r,start:e.pos,end:e.end,text:i,arguments:a};return o}function s(e,t,n){var r=t.substring(e.pos,e.end);return{name:e.name.text,start:e.pos,end:e.end,text:r,type:y(e.type,n)}}function u(e){return null==e?null:e.kind==A.SyntaxKind.CallExpression?{isCallConstraint:!0,value:p(e)}:{isCallConstraint:!1,value:c(e)}}function l(e){if(null==e)return[];if(e.kind==A.SyntaxKind.ArrayLiteralExpression){var t=e,n=[];return t.elements.forEach(function(e){n.push(p(e))}),n}throw new Error("Only Array Literals supported now")}function p(e){if(e.kind==A.SyntaxKind.CallExpression){var t=e,n=f(t.expression),r={name:n,arguments:[]};return t.arguments.forEach(function(e){r.arguments.push(c(e))}),r}throw new Error("Only call expressions may be annotations")}function c(e){if(e.kind==A.SyntaxKind.StringLiteral){var t=e;return t.text}if(e.kind==A.SyntaxKind.NoSubstitutionTemplateLiteral){var n=e;return n.text}if(e.kind==A.SyntaxKind.ArrayLiteralExpression){var r=e,i=[];return r.elements.forEach(function(e){i.push(c(e))}),i}if(e.kind==A.SyntaxKind.TrueKeyword)return!0;if(e.kind==A.SyntaxKind.PropertyAccessExpression){var a=e;return c(a.expression)+"."+c(a.name)}if(e.kind==A.SyntaxKind.Identifier){var o=e;return o.text}if(e.kind==A.SyntaxKind.FalseKeyword)return!1;if(e.kind==A.SyntaxKind.NumericLiteral){var s=e;return Number(s.text)}if(e.kind==A.SyntaxKind.BinaryExpression){var u=e;if(u.operatorToken.kind=A.SyntaxKind.PlusToken)return c(u.left)+c(u.right)}throw new Error("Unknown value in annotation")}function f(e){if(e.kind==A.SyntaxKind.Identifier)return e.text;if(e.kind==A.SyntaxKind.PropertyAccessExpression){var t=e;return f(t.expression)+"."+f(t.name)}throw new Error("Only simple identifiers are supported now")}function h(e,t){var n=e.indexOf("."),r=n!=-1?e.substring(0,n):"",i=n!=-1?e.substring(n+1):e;return{typeName:e,nameSpace:r,basicName:i,typeKind:_.TypeKind.BASIC,typeArguments:[],modulePath:t}}function d(e){return{base:e,typeKind:_.TypeKind.ARRAY}}function m(e){return{options:e,typeKind:_.TypeKind.UNION}}function y(e,t){if(null==e)return null;if(e.kind==A.SyntaxKind.StringKeyword)return h("string",null);if(e.kind==A.SyntaxKind.NumberKeyword)return h("number",null);if(e.kind==A.SyntaxKind.BooleanKeyword)return h("boolean",null);if(e.kind==A.SyntaxKind.AnyKeyword)return h("any",null);if(e.kind==A.SyntaxKind.VoidKeyword)return h("void",null);if(e.kind==A.SyntaxKind.TypeReference){var n=e,r=h(g(n.typeName),t);return n.typeArguments&&n.typeArguments.forEach(function(e){r.typeArguments.push(y(e,t))}),r}if(e.kind==A.SyntaxKind.ArrayType){var i=e;return d(y(i.elementType,t))}if(e.kind==A.SyntaxKind.UnionType){var a=e;return m(a.types.map(function(e){return y(e,t)}))}if(e.kind==A.SyntaxKind.ExpressionWithTypeArguments){var o=e,r=h(v(o.expression),t);return o.typeArguments&&o.typeArguments.forEach(function(e){r.typeArguments.push(y(e,t))}),r}throw new Error("Case not supported: "+e.kind)}function v(e){return e.name?e.name.text:e.text}function g(e){if(e.kind==A.SyntaxKind.Identifier)return e.text;var t=e;return g(t.left)+"."+g(t.right)}Object.defineProperty(t,"__esModule",{value:!0});var A=n(185);t.tsm=n(186),t.helperMethodExtractor=n(184);var E=n(189),_=n(182),T=n(182),S=t.tsm.Matching.field();t.parseStruct=i,t.parseArg=c,t.buildType=y},function(e,t,n){"use strict";function r(e,t){return s.resolve(e,t)}function i(e){return u.readFileSync(e).toString()}function a(e){return s.dirname(e)}function o(e){return u.existsSync(e)}Object.defineProperty(t,"__esModule",{value:!0});var s=n(6),u=n(187);t.resolve=r,t.readFileSync=i,t.dirname=a,t.existsSync=o},function(e,t,n){var r,i;(function(e,n){!function(){var a="object"==typeof self&&self.self===self&&self||"object"==typeof e&&e.global===e&&e||this||{},o=a._,s=Array.prototype,u=Object.prototype,l="undefined"!=typeof Symbol?Symbol.prototype:null,p=s.push,c=s.slice,f=u.toString,h=u.hasOwnProperty,d=Array.isArray,m=Object.keys,y=Object.create,v=function(){},g=function(e){return e instanceof g?e:this instanceof g?void(this._wrapped=e):new g(e)};"undefined"==typeof t||t.nodeType?a._=g:("undefined"!=typeof n&&!n.nodeType&&n.exports&&(t=n.exports=g),t._=g),g.VERSION="1.9.1";var A,E=function(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 3:return function(n,r,i){return e.call(t,n,r,i)};case 4:return function(n,r,i,a){return e.call(t,n,r,i,a)}}return function(){return e.apply(t,arguments)}},_=function(e,t,n){return g.iteratee!==A?g.iteratee(e,t):null==e?g.identity:g.isFunction(e)?E(e,t,n):g.isObject(e)&&!g.isArray(e)?g.matcher(e):g.property(e)};g.iteratee=A=function(e,t){return _(e,t,1/0)};var T=function(e,t){return t=null==t?e.length-1:+t,function(){for(var n=Math.max(arguments.length-t,0),r=Array(n),i=0;i<n;i++)r[i]=arguments[i+t];switch(t){case 0:return e.call(this,r);case 1:return e.call(this,arguments[0],r);case 2:return e.call(this,arguments[0],arguments[1],r)}var a=Array(t+1);for(i=0;i<t;i++)a[i]=arguments[i];return a[t]=r,e.apply(this,a)}},S=function(e){if(!g.isObject(e))return{};if(y)return y(e);v.prototype=e;var t=new v;return v.prototype=null,t},N=function(e){return function(t){return null==t?void 0:t[e]}},I=function(e,t){return null!=e&&h.call(e,t)},b=function(e,t){for(var n=t.length,r=0;r<n;r++){if(null==e)return;e=e[t[r]]}return n?e:void 0},R=Math.pow(2,53)-1,M=N("length"),C=function(e){var t=M(e);return"number"==typeof t&&t>=0&&t<=R};g.each=g.forEach=function(e,t,n){t=E(t,n);var r,i;if(C(e))for(r=0,i=e.length;r<i;r++)t(e[r],r,e);else{var a=g.keys(e);for(r=0,i=a.length;r<i;r++)t(e[a[r]],a[r],e)}return e},g.map=g.collect=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=Array(i),o=0;o<i;o++){var s=r?r[o]:o;a[o]=t(e[s],s,e)}return a};var w=function(e){var t=function(t,n,r,i){var a=!C(t)&&g.keys(t),o=(a||t).length,s=e>0?0:o-1;for(i||(r=t[a?a[s]:s],s+=e);s>=0&&s<o;s+=e){var u=a?a[s]:s;r=n(r,t[u],u,t)}return r};return function(e,n,r,i){var a=arguments.length>=3;return t(e,E(n,i,4),r,a)}};g.reduce=g.foldl=g.inject=w(1),g.reduceRight=g.foldr=w(-1),g.find=g.detect=function(e,t,n){var r=C(e)?g.findIndex:g.findKey,i=r(e,t,n);if(void 0!==i&&i!==-1)return e[i]},g.filter=g.select=function(e,t,n){var r=[];return t=_(t,n),g.each(e,function(e,n,i){t(e,n,i)&&r.push(e)}),r},g.reject=function(e,t,n){return g.filter(e,g.negate(_(t)),n)},g.every=g.all=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=0;a<i;a++){var o=r?r[a]:a;if(!t(e[o],o,e))return!1}return!0},g.some=g.any=function(e,t,n){t=_(t,n);for(var r=!C(e)&&g.keys(e),i=(r||e).length,a=0;a<i;a++){var o=r?r[a]:a;if(t(e[o],o,e))return!0}return!1},g.contains=g.includes=g.include=function(e,t,n,r){return C(e)||(e=g.values(e)),("number"!=typeof n||r)&&(n=0),g.indexOf(e,t,n)>=0},g.invoke=T(function(e,t,n){var r,i;return g.isFunction(t)?i=t:g.isArray(t)&&(r=t.slice(0,-1),t=t[t.length-1]),g.map(e,function(e){var a=i;if(!a){if(r&&r.length&&(e=b(e,r)),null==e)return;a=e[t]}return null==a?a:a.apply(e,n)})}),g.pluck=function(e,t){return g.map(e,g.property(t))},g.where=function(e,t){return g.filter(e,g.matcher(t))},g.findWhere=function(e,t){return g.find(e,g.matcher(t))},g.max=function(e,t,n){var r,i,a=-(1/0),o=-(1/0);if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e){e=C(e)?e:g.values(e);for(var s=0,u=e.length;s<u;s++)r=e[s],null!=r&&r>a&&(a=r)}else t=_(t,n),g.each(e,function(e,n,r){i=t(e,n,r),(i>o||i===-(1/0)&&a===-(1/0))&&(a=e,o=i)});return a},g.min=function(e,t,n){var r,i,a=1/0,o=1/0;if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e){e=C(e)?e:g.values(e);for(var s=0,u=e.length;s<u;s++)r=e[s],
null!=r&&r<a&&(a=r)}else t=_(t,n),g.each(e,function(e,n,r){i=t(e,n,r),(i<o||i===1/0&&a===1/0)&&(a=e,o=i)});return a},g.shuffle=function(e){return g.sample(e,1/0)},g.sample=function(e,t,n){if(null==t||n)return C(e)||(e=g.values(e)),e[g.random(e.length-1)];var r=C(e)?g.clone(e):g.values(e),i=M(r);t=Math.max(Math.min(t,i),0);for(var a=i-1,o=0;o<t;o++){var s=g.random(o,a),u=r[o];r[o]=r[s],r[s]=u}return r.slice(0,t)},g.sortBy=function(e,t,n){var r=0;return t=_(t,n),g.pluck(g.map(e,function(e,n,i){return{value:e,index:r++,criteria:t(e,n,i)}}).sort(function(e,t){var n=e.criteria,r=t.criteria;if(n!==r){if(n>r||void 0===n)return 1;if(n<r||void 0===r)return-1}return e.index-t.index}),"value")};var P=function(e,t){return function(n,r,i){var a=t?[[],[]]:{};return r=_(r,i),g.each(n,function(t,i){var o=r(t,i,n);e(a,t,o)}),a}};g.groupBy=P(function(e,t,n){I(e,n)?e[n].push(t):e[n]=[t]}),g.indexBy=P(function(e,t,n){e[n]=t}),g.countBy=P(function(e,t,n){I(e,n)?e[n]++:e[n]=1});var L=/[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;g.toArray=function(e){return e?g.isArray(e)?c.call(e):g.isString(e)?e.match(L):C(e)?g.map(e,g.identity):g.values(e):[]},g.size=function(e){return null==e?0:C(e)?e.length:g.keys(e).length},g.partition=P(function(e,t,n){e[n?0:1].push(t)},!0),g.first=g.head=g.take=function(e,t,n){return null==e||e.length<1?null==t?void 0:[]:null==t||n?e[0]:g.initial(e,e.length-t)},g.initial=function(e,t,n){return c.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))},g.last=function(e,t,n){return null==e||e.length<1?null==t?void 0:[]:null==t||n?e[e.length-1]:g.rest(e,Math.max(0,e.length-t))},g.rest=g.tail=g.drop=function(e,t,n){return c.call(e,null==t||n?1:t)},g.compact=function(e){return g.filter(e,Boolean)};var O=function(e,t,n,r){r=r||[];for(var i=r.length,a=0,o=M(e);a<o;a++){var s=e[a];if(C(s)&&(g.isArray(s)||g.isArguments(s)))if(t)for(var u=0,l=s.length;u<l;)r[i++]=s[u++];else O(s,t,n,r),i=r.length;else n||(r[i++]=s)}return r};g.flatten=function(e,t){return O(e,t,!1)},g.without=T(function(e,t){return g.difference(e,t)}),g.uniq=g.unique=function(e,t,n,r){g.isBoolean(t)||(r=n,n=t,t=!1),null!=n&&(n=_(n,r));for(var i=[],a=[],o=0,s=M(e);o<s;o++){var u=e[o],l=n?n(u,o,e):u;t&&!n?(o&&a===l||i.push(u),a=l):n?g.contains(a,l)||(a.push(l),i.push(u)):g.contains(i,u)||i.push(u)}return i},g.union=T(function(e){return g.uniq(O(e,!0,!0))}),g.intersection=function(e){for(var t=[],n=arguments.length,r=0,i=M(e);r<i;r++){var a=e[r];if(!g.contains(t,a)){var o;for(o=1;o<n&&g.contains(arguments[o],a);o++);o===n&&t.push(a)}}return t},g.difference=T(function(e,t){return t=O(t,!0,!0),g.filter(e,function(e){return!g.contains(t,e)})}),g.unzip=function(e){for(var t=e&&g.max(e,M).length||0,n=Array(t),r=0;r<t;r++)n[r]=g.pluck(e,r);return n},g.zip=T(g.unzip),g.object=function(e,t){for(var n={},r=0,i=M(e);r<i;r++)t?n[e[r]]=t[r]:n[e[r][0]]=e[r][1];return n};var D=function(e){return function(t,n,r){n=_(n,r);for(var i=M(t),a=e>0?0:i-1;a>=0&&a<i;a+=e)if(n(t[a],a,t))return a;return-1}};g.findIndex=D(1),g.findLastIndex=D(-1),g.sortedIndex=function(e,t,n,r){n=_(n,r,1);for(var i=n(t),a=0,o=M(e);a<o;){var s=Math.floor((a+o)/2);n(e[s])<i?a=s+1:o=s}return a};var U=function(e,t,n){return function(r,i,a){var o=0,s=M(r);if("number"==typeof a)e>0?o=a>=0?a:Math.max(a+s,o):s=a>=0?Math.min(a+1,s):a+s+1;else if(n&&a&&s)return a=n(r,i),r[a]===i?a:-1;if(i!==i)return a=t(c.call(r,o,s),g.isNaN),a>=0?a+o:-1;for(a=e>0?o:s-1;a>=0&&a<s;a+=e)if(r[a]===i)return a;return-1}};g.indexOf=U(1,g.findIndex,g.sortedIndex),g.lastIndexOf=U(-1,g.findLastIndex),g.range=function(e,t,n){null==t&&(t=e||0,e=0),n||(n=t<e?-1:1);for(var r=Math.max(Math.ceil((t-e)/n),0),i=Array(r),a=0;a<r;a++,e+=n)i[a]=e;return i},g.chunk=function(e,t){if(null==t||t<1)return[];for(var n=[],r=0,i=e.length;r<i;)n.push(c.call(e,r,r+=t));return n};var x=function(e,t,n,r,i){if(!(r instanceof t))return e.apply(n,i);var a=S(e.prototype),o=e.apply(a,i);return g.isObject(o)?o:a};g.bind=T(function(e,t,n){if(!g.isFunction(e))throw new TypeError("Bind must be called on a function");var r=T(function(i){return x(e,r,t,this,n.concat(i))});return r}),g.partial=T(function(e,t){var n=g.partial.placeholder,r=function(){for(var i=0,a=t.length,o=Array(a),s=0;s<a;s++)o[s]=t[s]===n?arguments[i++]:t[s];for(;i<arguments.length;)o.push(arguments[i++]);return x(e,r,this,this,o)};return r}),g.partial.placeholder=g,g.bindAll=T(function(e,t){t=O(t,!1,!1);var n=t.length;if(n<1)throw new Error("bindAll must be passed function names");for(;n--;){var r=t[n];e[r]=g.bind(e[r],e)}}),g.memoize=function(e,t){var n=function(r){var i=n.cache,a=""+(t?t.apply(this,arguments):r);return I(i,a)||(i[a]=e.apply(this,arguments)),i[a]};return n.cache={},n},g.delay=T(function(e,t,n){return setTimeout(function(){return e.apply(null,n)},t)}),g.defer=g.partial(g.delay,g,1),g.throttle=function(e,t,n){var r,i,a,o,s=0;n||(n={});var u=function(){s=n.leading===!1?0:g.now(),r=null,o=e.apply(i,a),r||(i=a=null)},l=function(){var l=g.now();s||n.leading!==!1||(s=l);var p=t-(l-s);return i=this,a=arguments,p<=0||p>t?(r&&(clearTimeout(r),r=null),s=l,o=e.apply(i,a),r||(i=a=null)):r||n.trailing===!1||(r=setTimeout(u,p)),o};return l.cancel=function(){clearTimeout(r),s=0,r=i=a=null},l},g.debounce=function(e,t,n){var r,i,a=function(t,n){r=null,n&&(i=e.apply(t,n))},o=T(function(o){if(r&&clearTimeout(r),n){var s=!r;r=setTimeout(a,t),s&&(i=e.apply(this,o))}else r=g.delay(a,t,this,o);return i});return o.cancel=function(){clearTimeout(r),r=null},o},g.wrap=function(e,t){return g.partial(t,e)},g.negate=function(e){return function(){return!e.apply(this,arguments)}},g.compose=function(){var e=arguments,t=e.length-1;return function(){for(var n=t,r=e[t].apply(this,arguments);n--;)r=e[n].call(this,r);return r}},g.after=function(e,t){return function(){if(--e<1)return t.apply(this,arguments)}},g.before=function(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),e<=1&&(t=null),n}},g.once=g.partial(g.before,2),g.restArguments=T;var k=!{toString:null}.propertyIsEnumerable("toString"),F=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],B=function(e,t){var n=F.length,r=e.constructor,i=g.isFunction(r)&&r.prototype||u,a="constructor";for(I(e,a)&&!g.contains(t,a)&&t.push(a);n--;)a=F[n],a in e&&e[a]!==i[a]&&!g.contains(t,a)&&t.push(a)};g.keys=function(e){if(!g.isObject(e))return[];if(m)return m(e);var t=[];for(var n in e)I(e,n)&&t.push(n);return k&&B(e,t),t},g.allKeys=function(e){if(!g.isObject(e))return[];var t=[];for(var n in e)t.push(n);return k&&B(e,t),t},g.values=function(e){for(var t=g.keys(e),n=t.length,r=Array(n),i=0;i<n;i++)r[i]=e[t[i]];return r},g.mapObject=function(e,t,n){t=_(t,n);for(var r=g.keys(e),i=r.length,a={},o=0;o<i;o++){var s=r[o];a[s]=t(e[s],s,e)}return a},g.pairs=function(e){for(var t=g.keys(e),n=t.length,r=Array(n),i=0;i<n;i++)r[i]=[t[i],e[t[i]]];return r},g.invert=function(e){for(var t={},n=g.keys(e),r=0,i=n.length;r<i;r++)t[e[n[r]]]=n[r];return t},g.functions=g.methods=function(e){var t=[];for(var n in e)g.isFunction(e[n])&&t.push(n);return t.sort()};var V=function(e,t){return function(n){var r=arguments.length;if(t&&(n=Object(n)),r<2||null==n)return n;for(var i=1;i<r;i++)for(var a=arguments[i],o=e(a),s=o.length,u=0;u<s;u++){var l=o[u];t&&void 0!==n[l]||(n[l]=a[l])}return n}};g.extend=V(g.allKeys),g.extendOwn=g.assign=V(g.keys),g.findKey=function(e,t,n){t=_(t,n);for(var r,i=g.keys(e),a=0,o=i.length;a<o;a++)if(r=i[a],t(e[r],r,e))return r};var K=function(e,t,n){return t in n};g.pick=T(function(e,t){var n={},r=t[0];if(null==e)return n;g.isFunction(r)?(t.length>1&&(r=E(r,t[1])),t=g.allKeys(e)):(r=K,t=O(t,!1,!1),e=Object(e));for(var i=0,a=t.length;i<a;i++){var o=t[i],s=e[o];r(s,o,e)&&(n[o]=s)}return n}),g.omit=T(function(e,t){var n,r=t[0];return g.isFunction(r)?(r=g.negate(r),t.length>1&&(n=t[1])):(t=g.map(O(t,!1,!1),String),r=function(e,n){return!g.contains(t,n)}),g.pick(e,r,n)}),g.defaults=V(g.allKeys,!0),g.create=function(e,t){var n=S(e);return t&&g.extendOwn(n,t),n},g.clone=function(e){return g.isObject(e)?g.isArray(e)?e.slice():g.extend({},e):e},g.tap=function(e,t){return t(e),e},g.isMatch=function(e,t){var n=g.keys(t),r=n.length;if(null==e)return!r;for(var i=Object(e),a=0;a<r;a++){var o=n[a];if(t[o]!==i[o]||!(o in i))return!1}return!0};var j,W;j=function(e,t,n,r){if(e===t)return 0!==e||1/e===1/t;if(null==e||null==t)return!1;if(e!==e)return t!==t;var i=typeof e;return("function"===i||"object"===i||"object"==typeof t)&&W(e,t,n,r)},W=function(e,t,n,r){e instanceof g&&(e=e._wrapped),t instanceof g&&(t=t._wrapped);var i=f.call(e);if(i!==f.call(t))return!1;switch(i){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!==+e?+t!==+t:0===+e?1/+e===1/t:+e===+t;case"[object Date]":case"[object Boolean]":return+e===+t;case"[object Symbol]":return l.valueOf.call(e)===l.valueOf.call(t)}var a="[object Array]"===i;if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var o=e.constructor,s=t.constructor;if(o!==s&&!(g.isFunction(o)&&o instanceof o&&g.isFunction(s)&&s instanceof s)&&"constructor"in e&&"constructor"in t)return!1}n=n||[],r=r||[];for(var u=n.length;u--;)if(n[u]===e)return r[u]===t;if(n.push(e),r.push(t),a){if(u=e.length,u!==t.length)return!1;for(;u--;)if(!j(e[u],t[u],n,r))return!1}else{var p,c=g.keys(e);if(u=c.length,g.keys(t).length!==u)return!1;for(;u--;)if(p=c[u],!I(t,p)||!j(e[p],t[p],n,r))return!1}return n.pop(),r.pop(),!0},g.isEqual=function(e,t){return j(e,t)},g.isEmpty=function(e){return null==e||(C(e)&&(g.isArray(e)||g.isString(e)||g.isArguments(e))?0===e.length:0===g.keys(e).length)},g.isElement=function(e){return!(!e||1!==e.nodeType)},g.isArray=d||function(e){return"[object Array]"===f.call(e)},g.isObject=function(e){var t=typeof e;return"function"===t||"object"===t&&!!e},g.each(["Arguments","Function","String","Number","Date","RegExp","Error","Symbol","Map","WeakMap","Set","WeakSet"],function(e){g["is"+e]=function(t){return f.call(t)==="[object "+e+"]"}}),g.isArguments(arguments)||(g.isArguments=function(e){return I(e,"callee")});var H=a.document&&a.document.childNodes;"function"!=typeof/./&&"object"!=typeof Int8Array&&"function"!=typeof H&&(g.isFunction=function(e){return"function"==typeof e||!1}),g.isFinite=function(e){return!g.isSymbol(e)&&isFinite(e)&&!isNaN(parseFloat(e))},g.isNaN=function(e){return g.isNumber(e)&&isNaN(e)},g.isBoolean=function(e){return e===!0||e===!1||"[object Boolean]"===f.call(e)},g.isNull=function(e){return null===e},g.isUndefined=function(e){return void 0===e},g.has=function(e,t){if(!g.isArray(t))return I(e,t);for(var n=t.length,r=0;r<n;r++){var i=t[r];if(null==e||!h.call(e,i))return!1;e=e[i]}return!!n},g.noConflict=function(){return a._=o,this},g.identity=function(e){return e},g.constant=function(e){return function(){return e}},g.noop=function(){},g.property=function(e){return g.isArray(e)?function(t){return b(t,e)}:N(e)},g.propertyOf=function(e){return null==e?function(){}:function(t){return g.isArray(t)?b(e,t):e[t]}},g.matcher=g.matches=function(e){return e=g.extendOwn({},e),function(t){return g.isMatch(t,e)}},g.times=function(e,t,n){var r=Array(Math.max(0,e));t=E(t,n,1);for(var i=0;i<e;i++)r[i]=t(i);return r},g.random=function(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))},g.now=Date.now||function(){return(new Date).getTime()};var Y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},q=g.invert(Y),G=function(e){var t=function(t){return e[t]},n="(?:"+g.keys(e).join("|")+")",r=RegExp(n),i=RegExp(n,"g");return function(e){return e=null==e?"":""+e,r.test(e)?e.replace(i,t):e}};g.escape=G(Y),g.unescape=G(q),g.result=function(e,t,n){g.isArray(t)||(t=[t]);var r=t.length;if(!r)return g.isFunction(n)?n.call(e):n;for(var i=0;i<r;i++){var a=null==e?void 0:e[t[i]];void 0===a&&(a=n,i=r),e=g.isFunction(a)?a.call(e):a}return e};var X=0;g.uniqueId=function(e){var t=++X+"";return e?e+t:t},g.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var z=/(.)^/,$={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},J=/\\|'|\r|\n|\u2028|\u2029/g,Q=function(e){return"\\"+$[e]};g.template=function(e,t,n){!t&&n&&(t=n),t=g.defaults({},t,g.templateSettings);var r=RegExp([(t.escape||z).source,(t.interpolate||z).source,(t.evaluate||z).source].join("|")+"|$","g"),i=0,a="__p+='";e.replace(r,function(t,n,r,o,s){return a+=e.slice(i,s).replace(J,Q),i=s+t.length,n?a+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":o&&(a+="';\n"+o+"\n__p+='"),t}),a+="';\n",t.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";var o;try{o=new Function(t.variable||"obj","_",a)}catch(e){throw e.source=a,e}var s=function(e){return o.call(this,e,g)},u=t.variable||"obj";return s.source="function("+u+"){\n"+a+"}",s},g.chain=function(e){var t=g(e);return t._chain=!0,t};var Z=function(e,t){return e._chain?g(t).chain():t};g.mixin=function(e){return g.each(g.functions(e),function(t){var n=g[t]=e[t];g.prototype[t]=function(){var e=[this._wrapped];return p.apply(e,arguments),Z(this,n.apply(g,e))}}),g},g.mixin(g),g.each(["pop","push","reverse","shift","sort","splice","unshift"],function(e){var t=s[e];g.prototype[e]=function(){var n=this._wrapped;return t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0],Z(this,n)}}),g.each(["concat","join","slice"],function(e){var t=s[e];g.prototype[e]=function(){return Z(this,t.apply(this._wrapped,arguments))}}),g.prototype.value=function(){return this._wrapped},g.prototype.valueOf=g.prototype.toJSON=g.prototype.value,g.prototype.toString=function(){return String(this._wrapped)},r=[],i=function(){return g}.apply(t,r),!(void 0!==i&&(n.exports=i))}()}).call(t,function(){return this}(),n(10)(e))},function(e,t,n){"use strict";function r(e,t){"MetaModel.declaresSubTypeOf"==e.name&&t.getAdapter(u.RAMLService).setExtendedTypeName(e.arguments[0]),"MetaModel.nameAtRuntime"==e.name&&t.setNameAtRuntime(e.arguments[0]),"MetaModel.description"==e.name&&t.withDescription(e.arguments[0]),"MetaModel.inlinedTemplates"==e.name&&t.getAdapter(u.RAMLService).setInlinedTemplates(!0),"MetaModel.requireValue"==e.name&&t.getAdapter(u.RAMLService).withContextRequirement(""+e.arguments[0],""+e.arguments[1]),"MetaModel.referenceIs"==e.name&&t.getAdapter(u.RAMLService).withReferenceIs(""+e.arguments[0]),"MetaModel.actuallyExports"==e.name&&t.getAdapter(u.RAMLService).withActuallyExports(""+e.arguments[0]),"MetaModel.convertsToGlobalOfType"==e.name&&t.getAdapter(u.RAMLService).withConvertsToGlobal(""+e.arguments[0]),"MetaModel.allowAny"==e.name&&t.getAdapter(u.RAMLService).withAllowAny(),"MetaModel.allowQuestion"==e.name&&t.getAdapter(u.RAMLService).withAllowQuestion(),"MetaModel.alias"==e.name&&t.getAdapter(u.RAMLService).addAlias(""+e.arguments[0]),"MetaModel.consumesRefs"==e.name&&t.getAdapter(u.RAMLService).setConsumesRefs(!0),"MetaModel.canInherit"==e.name&&t.getAdapter(u.RAMLService).withCanInherit(""+e.arguments[0]),"MetaModel.definingPropertyIsEnough"==e.name&&t.getAdapter(u.RAMLService).definingPropertyIsEnough(""+e.arguments[0]),"MetaModel.customHandling"==e.name&&t.setCustom(!0),"MetaModel.superclasses"==e.name&&t.getAdapter(u.RAMLService).registerSupertypes(e.arguments[0]),"MetaModel.possibleInterfaces"==e.name&&t.getAdapter(u.RAMLService).registerPossibleInterfaces(e.arguments[0])}function i(e,n){t.annotationHandlers[n.name](n,e)}Object.defineProperty(t,"__esModule",{value:!0});var a=n(56),o=n(192),s=n(190),u=a;t.handleTypeAnnotation=r,t.annotationHandlers={key:function(e,t){t.withFromParentKey(),t.withKey(!0)},value:function(e,t){t.withFromParentValue()},canBeValue:function(e,t){t.withCanBeValue()},unmerged:function(e,t){t.unmerge()},startFrom:function(e,t){t.withKeyRestriction(e.arguments[0]),t.merge()},oneOf:function(e,t){t.withEnumOptions(e.arguments[0])},oftenKeys:function(e,t){t.withOftenKeys(e.arguments[0])},embeddedInMaps:function(e,t){t.getAdapter(u.RAMLPropertyParserService).withEmbedMap()},system:function(e,t){t.getAdapter(u.RAMLPropertyParserService).withSystem(!0)},required:function(e,t){"false"!=e.arguments[0]&&e.arguments[0]!==!1&&t.withRequired(!0)},noDirectParse:function(e,t){"false"!=e.arguments[0]&&e.arguments[0]!==!1&&t.withNoDirectParse()},setsContextValue:function(e,t){t.addChildValueConstraint(new a.ChildValueConstraint(""+e.arguments[0],""+e.arguments[1]))},defaultValue:function(e,t){t.setDefaultVal(""+e.arguments[0])},defaultIntegerValue:function(e,t){t.setDefaultIntegerVal(e.arguments[0])},defaultBooleanValue:function(e,t){t.setDefaultBooleanVal(e.arguments[0])},facetId:function(e,t){"minItems"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Array){var n=Number.parseInt(""+t.value());if(n>e.length)return"array should contain at least "+t.value()+" items"}return null}),"enum"==e.arguments[0]&&t.setFacetValidator(function(e,t){var n=e+"",r=t;try{if(!r.some(function(e){return e==n}))return"value should be one of :"+r.join(",")}catch(e){return}return null}),"maxItems"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Array){var n=Number.parseInt(""+t);if(n<e.length)return"array should contain not more then "+t.value()+" items"}return null}),"minProperties"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Object){var n=Number.parseInt(""+t);if(n>Object.keys(e).length)return"object should contain at least "+t.value()+" properties"}return null}),"maxProperties"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Object){var n=Number.parseInt(""+t);if(n<Object.keys(e).length)return"object should contain not more then "+t.value()+" properties"}return null}),"uniqueItems"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(t instanceof Array){var n=s.unique(t).length;if(n<t.length)return"array should contain only unique items"}return null}),"minLength"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("number"!=typeof e&&"boolean"!=typeof e||(e=""+e),"string"==typeof e){var n=Number.parseInt(""+t);if(n>e.length)return"string length should be at least "+n}return null}),"maxLength"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("number"!=typeof e&&"boolean"!=typeof e||(e=""+e),"string"==typeof e){var n=Number.parseInt(""+t);if(n<e.length)return"string length should be not more then "+n}return null}),"minimum"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("string"==typeof e&&(e=parseFloat(e)),"number"==typeof e){var n=parseFloat(t);if(n>e)return"value should be not less then "+n}return null}),"maximum"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("string"==typeof e&&(e=parseFloat(e)),"number"==typeof e){var n=parseFloat(t);if(n<e)return"value should be not more then "+n}return null}),"pattern"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("number"!=typeof e&&"boolean"!=typeof e||(e=""+e),"string"==typeof e){var n=new RegExp(t);if(!n.test(e))return"string should match to "+t}return null})},extraMetaKey:function(e,t){"statusCodes"==e.arguments[0]&&(t.withOftenKeys(o.statusCodes.filter(function(e){return e.code.indexOf("x")<0}).map(function(e){return e.code})),t.setValueDocProvider(function(e){var t=s.find(o.statusCodes,function(t){return t.code==e});return t?e+":"+t.description:null})),"headers"==e.arguments[0]&&(t.setValueSuggester(function(e){if(e.property()){var t=e.property().getChildValueConstraints();if(s.find(t,function(e){return"location"==e.name&&"Params.ParameterLocation.HEADERS"==e.value}))return o.headers.map(function(e){return e.header});if(e.property()&&"headers"==e.property().nameId())return o.headers.map(function(e){return e.header})}return null}),t.setValueDocProvider(function(e){var t=s.find(o.headers,function(t){return t.header==e});return t?e+":"+t.description:null})),"methods"==e.arguments[0]&&t.setValueDocProvider(function(e){var t=s.find(o.methods,function(t){return t.method==e.toUpperCase()});return t?e+":"+t.description:null})},requireValue:function(e,t){t.withContextRequirement(""+e.arguments[0],""+e.arguments[1])},allowMultiple:function(e,t){t.withMultiValue(!0)},constraint:function(e,t){},newInstanceName:function(e,t){t.withNewInstanceName(""+e.arguments[0])},declaringFields:function(e,t){t.withThisPropertyDeclaresFields()},describesAnnotation:function(e,t){t.withDescribes(e.arguments[0])},allowNull:function(e,t){t.withAllowNull()},descriminatingProperty:function(e,t){t.withDescriminating(!0)},description:function(e,t){t.withDescription(""+e.arguments[0])},inherited:function(e,t){t.withInherited(!0)},selfNode:function(e,t){t.withSelfNode()},grammarTokenKind:function(e,t){t.getAdapter(u.RAMLPropertyService).withPropertyGrammarType(""+e.arguments[0])},canInherit:function(e,t){t.withInheritedContextValue(""+e.arguments[0])},canBeDuplicator:function(e,t){t.setCanBeDuplicator()},example:function(e,t){t.getAdapter(u.RAMLPropertyService).setExample(!0)},typeExpression:function(e,t){t.getAdapter(u.RAMLPropertyService).setTypeExpression(!0)},hide:function(e,t){0==e.arguments.length?t.getAdapter(u.RAMLPropertyDocumentationService).setHidden(!0):t.getAdapter(u.RAMLPropertyDocumentationService).setHidden(e.arguments[0])},documentationTableLabel:function(e,t){t.getAdapter(u.RAMLPropertyDocumentationService).setDocTableName(""+e.arguments[0])},markdownDescription:function(e,t){t.getAdapter(u.RAMLPropertyDocumentationService).setMarkdownDescription(""+e.arguments[0])},valueDescription:function(e,t){t.getAdapter(u.RAMLPropertyDocumentationService).setValueDescription(null!=e.arguments[0]?""+e.arguments[0]:null)},customHandling:function(e,t){}},t.recordAnnotation=i},function(e,t,n){var r;r=function(){"use strict";var e=n(193),t={},r={},i=n(194),a=n(195),o=n(196);return e.forEach(function(e){var n,i=parseInt(e.code,10);i.toString()===e.code&&(n=e.phrase.toUpperCase().replace(/[^A-Z]/g,"_"),t[i]=e.phrase,r[n]=e.code)}),{statusCodes:e,statusCodesToPhrases:t,statusPhrasesToCodes:r,methods:i,headers:a,relations:o}}.call(t,n,t,e),!(void 0!==r&&(e.exports=r))},function(e,t){e.exports=[{code:"1xx",phrase:"**Informational**",description:'"indicates an interim response for communicating connection status or request progress prior to completing the requested action and sending a final response." ~ [sure](http://www.urbandictionary.com/define.php?term=sure)',spec_title:"RFC7231#6.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.2"},{code:"100",phrase:"Continue",description:'"indicates that the initial part of a request has been received and has not yet been rejected by the server."',spec_title:"RFC7231#6.2.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.2.1"},{code:"101",phrase:"Switching Protocols",description:'"indicates that the server understands and is willing to comply with the client\'s request, via the Upgrade header field, for a change in the application protocol being used on this connection."',spec_title:"RFC7231#6.2.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.2.2"},{code:"2xx",phrase:"**Successful**",description:'"indicates that the client\'s request was successfully received, understood, and accepted." ~ [cool](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3"},{code:"200",phrase:"OK",description:'"indicates that the request has succeeded."',spec_title:"RFC7231#6.3.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3.1"},{code:"201",phrase:"Created",description:'"indicates that the request has been fulfilled and has resulted in one or more new resources being created."',spec_title:"RFC7231#6.3.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"202",phrase:"Accepted",description:'"indicates that the request has been accepted for processing, but the processing has not been completed."',spec_title:"RFC7231#6.3.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3.3"},{code:"203",phrase:"Non-Authoritative Information",description:'"indicates that the request was successful but the enclosed payload has been modified from that of the origin server\'s 200 (OK) response by a transforming proxy."',spec_title:"RFC7231#6.3.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3.4"},{code:"204",phrase:"No Content",description:'"indicates that the server has successfully fulfilled the request and that there is no additional content to send in the response payload body."',spec_title:"RFC7231#6.3.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3.5"},{code:"205",phrase:"Reset Content",description:'"indicates that the server has fulfilled the request and desires that the user agent reset the "document view", which caused the request to be sent, to its original state as received from the origin server."',spec_title:"RFC7231#6.3.6",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.3.6"},{code:"206",phrase:"Partial Content",description:'"indicates that the server is successfully fulfilling a range request for the target resource by transferring one or more parts of the selected representation that correspond to the satisfiable ranges found in the requests\'s Range header field."',spec_title:"RFC7233#4.1",spec_href:"https://tools.ietf.org/html/rfc7233#section-4.1"},{code:"3xx",phrase:"**Redirection**",description:'"indicates that further action needs to be taken by the user agent in order to fulfill the request." ~ [ask that dude over there](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4"},{code:"300",phrase:"Multiple Choices",description:'"indicates that the target resource has more than one representation, each with its own more specific identifier, and information about the alternatives is being provided so that the user (or user agent) can select a preferred representation by redirecting its request to one or more of those identifiers."',spec_title:"RFC7231#6.4.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4.1"},{code:"301",phrase:"Moved Permanently",description:'"indicates that the target resource has been assigned a new permanent URI and any future references to this resource ought to use one of the enclosed URIs."',spec_title:"RFC7231#6.4.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4.2"},{code:"302",phrase:"Found",description:'"indicates that the target resource resides temporarily under a different URI."',spec_title:"RFC7231#6.4.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4.3"},{code:"303",phrase:"See Other",description:'"indicates that the server is redirecting the user agent to a different resource, as indicated by a URI in the Location header field, that is intended to provide an indirect response to the original request."',spec_title:"RFC7231#6.4.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4.4"},{code:"304",phrase:"Not Modified",description:'"indicates that a conditional GET request has been received and would have resulted in a 200 (OK) response if it were not for the fact that the condition has evaluated to false."',spec_title:"RFC7232#4.1",spec_href:"https://tools.ietf.org/html/rfc7232#section-4.1"},{code:"305",phrase:"Use Proxy",description:"*deprecated*",spec_title:"RFC7231#6.4.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4.5"},{code:"307",phrase:"Temporary Redirect",description:'"indicates that the target resource resides temporarily under a different URI and the user agent MUST NOT change the request method if it performs an automatic redirection to that URI."',spec_title:"RFC7231#6.4.7",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.4.7"},{code:"4xx",phrase:"**Client Error**",description:'"indicates that the client seems to have erred." ~ [*you* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5"},{code:"400",phrase:"Bad Request",description:'"indicates that the server cannot or will not process the request because the received syntax is invalid, nonsensical, or exceeds some limitation on what the server is willing to process."',spec_title:"RFC7231#6.5.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.1"},{code:"401",phrase:"Unauthorized",description:'"indicates that the request has not been applied because it lacks valid authentication credentials for the target resource."',spec_title:"RFC7235#6.3.1",spec_href:"https://tools.ietf.org/html/rfc7235#section-3.1"},{code:"402",phrase:"Payment Required",description:"*reserved*",spec_title:"RFC7231#6.5.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.2"},{code:"403",phrase:"Forbidden",description:'"indicates that the server understood the request but refuses to authorize it."',spec_title:"RFC7231#6.5.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.3"},{code:"404",phrase:"Not Found",description:'"indicates that the origin server did not find a current representation for the target resource or is not willing to disclose that one exists."',spec_title:"RFC7231#6.5.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.4"},{code:"405",phrase:"Method Not Allowed",description:'"indicates that the method specified in the request-line is known by the origin server but not supported by the target resource."',spec_title:"RFC7231#6.5.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.5"},{code:"406",phrase:"Not Acceptable",description:'"indicates that the target resource does not have a current representation that would be acceptable to the user agent, according to the proactive negotiation header fields received in the request, and the server is unwilling to supply a default representation."',spec_title:"RFC7231#6.5.6",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.6"},{code:"407",phrase:"Proxy Authentication Required",description:'"is similar to 401 (Unauthorized), but indicates that the client needs to authenticate itself in order to use a proxy."',spec_title:"RFC7235#3.2",spec_href:"https://tools.ietf.org/html/rfc7235#section-3.2"},{code:"408",phrase:"Request Timeout",description:'"indicates that the server did not receive a complete request message within the time that it was prepared to wait."',spec_title:"RFC7231#6.5.7",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.7"},{code:"409",phrase:"Conflict",description:'"indicates that the request could not be completed due to a conflict with the current state of the resource."',spec_title:"RFC7231#6.5.8",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.8"},{code:"410",phrase:"Gone",description:'"indicates that access to the target resource is no longer available at the origin server and that this condition is likely to be permanent."',spec_title:"RFC7231#6.5.9",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.9"},{code:"411",phrase:"Length Required",description:'"indicates that the server refuses to accept the request without a defined Content-Length."',spec_title:"RFC7231#6.5.10",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.10"},{code:"412",phrase:"Precondition Failed",description:'"indicates that one or more preconditions given in the request header fields evaluated to false when tested on the server."',spec_title:"RFC7232#4.2",spec_href:"https://tools.ietf.org/html/rfc7232#section-4.2"},{code:"413",phrase:"Payload Too Large",description:'"indicates that the server is refusing to process a request because the request payload is larger than the server is willing or able to process."',spec_title:"RFC7231#6.5.11",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.11"},{code:"414",phrase:"URI Too Long",description:'"indicates that the server is refusing to service the request because the request-target is longer than the server is willing to interpret."',spec_title:"RFC7231#6.5.12",
spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.12"},{code:"415",phrase:"Unsupported Media Type",description:'"indicates that the origin server is refusing to service the request because the payload is in a format not supported by the target resource for this method."',spec_title:"RFC7231#6.5.13",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.13"},{code:"416",phrase:"Range Not Satisfiable",description:'"indicates that none of the ranges in the request\'s Range header field overlap the current extent of the selected resource or that the set of ranges requested has been rejected due to invalid ranges or an excessive request of small or overlapping ranges."',spec_title:"RFC7233#4.4",spec_href:"https://tools.ietf.org/html/rfc7233#section-4.4"},{code:"417",phrase:"Expectation Failed",description:'"indicates that the expectation given in the request\'s Expect header field could not be met by at least one of the inbound servers."',spec_title:"RFC7231#6.5.14",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.14"},{code:"418",phrase:"I'm a teapot",description:'"Any attempt to brew coffee with a teapot should result in the error code 418 I\'m a teapot."',spec_title:"RFC2324#2.3.1",spec_href:"https://tools.ietf.org/html/rfc2324#section-2.3.1"},{code:"426",phrase:"Upgrade Required",description:'"indicates that the server refuses to perform the request using the current protocol but might be willing to do so after the client upgrades to a different protocol."',spec_title:"RFC7231#6.5.15",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.5.15"},{code:"5xx",phrase:"**Server Error**",description:'"indicates that the server is aware that it has erred or is incapable of performing the requested method." ~ [*we* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.6",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6"},{code:"500",phrase:"Internal Server Error",description:'"indicates that the server encountered an unexpected condition that prevented it from fulfilling the request."',spec_title:"RFC7231#6.6.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6.1"},{code:"501",phrase:"Not Implemented",description:'"indicates that the server does not support the functionality required to fulfill the request."',spec_title:"RFC7231#6.6.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6.2"},{code:"502",phrase:"Bad Gateway",description:'"indicates that the server, while acting as a gateway or proxy, received an invalid response from an inbound server it accessed while attempting to fulfill the request."',spec_title:"RFC7231#6.6.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6.3"},{code:"503",phrase:"Service Unavailable",description:'"indicates that the server is currently unable to handle the request due to a temporary overload or scheduled maintenance, which will likely be alleviated after some delay."',spec_title:"RFC7231#6.6.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6.4"},{code:"504",phrase:"Gateway Time-out",description:'"indicates that the server, while acting as a gateway or proxy, did not receive a timely response from an upstream server it needed to access in order to complete the request."',spec_title:"RFC7231#6.6.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6.5"},{code:"505",phrase:"HTTP Version Not Supported",description:'"indicates that the server does not support, or refuses to support, the protocol version that was used in the request message."',spec_title:"RFC7231#6.6.6",spec_href:"https://tools.ietf.org/html/rfc7231#section-6.6.6"},{code:"102",phrase:"Processing",description:'"is an interim response used to inform the client that the server has accepted the complete request, but has not yet completed it."',spec_title:"RFC5218#10.1",spec_href:"https://tools.ietf.org/html/rfc2518#section-10.1"},{code:"207",phrase:"Multi-Status",description:'"provides status for multiple independent operations."',spec_title:"RFC5218#10.2",spec_href:"https://tools.ietf.org/html/rfc2518#section-10.2"},{code:"226",phrase:"IM Used",description:'"The server has fulfilled a GET request for the resource, and the response is a representation of the result of one or more instance-manipulations applied to the current instance."',spec_title:"RFC3229#10.4.1",spec_href:"https://tools.ietf.org/html/rfc3229#section-10.4.1"},{code:"308",phrase:"Permanent Redirect",description:'"The target resource has been assigned a new permanent URI and any future references to this resource outght to use one of the enclosed URIs. [...] This status code is similar to 301 Moved Permanently (Section 7.3.2 of rfc7231), except that it does not allow rewriting the request method from POST to GET."',spec_title:"RFC7538",spec_href:"https://tools.ietf.org/html/rfc7538"},{code:"422",phrase:"Unprocessable Entity",description:'"means the server understands the content type of the request entity (hence a 415(Unsupported Media Type) status code is inappropriate), and the syntax of the request entity is correct (thus a 400 (Bad Request) status code is inappropriate) but was unable to process the contained instructions."',spec_title:"RFC5218#10.3",spec_href:"https://tools.ietf.org/html/rfc2518#section-10.3"},{code:"423",phrase:"Locked",description:'"means the source or destination resource of a method is locked."',spec_title:"RFC5218#10.4",spec_href:"https://tools.ietf.org/html/rfc2518#section-10.4"},{code:"424",phrase:"Failed Dependency",description:'"means that the method could not be performed on the resource because the requested action depended on another action and that action failed."',spec_title:"RFC5218#10.5",spec_href:"https://tools.ietf.org/html/rfc2518#section-10.5"},{code:"428",phrase:"Precondition Required",description:'"indicates that the origin server requires the request to be conditional."',spec_title:"RFC6585#3",spec_href:"https://tools.ietf.org/html/rfc6585#section-3"},{code:"429",phrase:"Too Many Requests",description:'"indicates that the user has sent too many requests in a given amount of time ("rate limiting")."',spec_title:"RFC6585#4",spec_href:"https://tools.ietf.org/html/rfc6585#section-4"},{code:"431",phrase:"Request Header Fields Too Large",description:'"indicates that the server is unwilling to process the request because its header fields are too large."',spec_title:"RFC6585#5",spec_href:"https://tools.ietf.org/html/rfc6585#section-5"},{code:"451",phrase:"Unavailable For Legal Reasons",description:'"This status code indicates that the server is denying access to the resource in response to a legal demand."',spec_title:"draft-ietf-httpbis-legally-restricted-status",spec_href:"https://tools.ietf.org/html/draft-ietf-httpbis-legally-restricted-status"},{code:"506",phrase:"Variant Also Negotiates",description:'"indicates that the server has an internal configuration error: the chosen variant resource is configured to engage in transparent content negotiation itself, and is therefore not a proper end point in the negotiation process."',spec_title:"RFC2295#8.1",spec_href:"https://tools.ietf.org/html/rfc2295#section-8.1"},{code:"507",phrase:"Insufficient Storage",description:'"means the method could not be performed on the resource because the server is unable to store the representation needed to successfully complete the request."',spec_title:"RFC5218#10.6",spec_href:"https://tools.ietf.org/html/rfc2518#section-10.6"},{code:"511",phrase:"Network Authentication Required",description:'"indicates that the client needs to authenticate to gain network access."',spec_title:"RFC6585#6",spec_href:"https://tools.ietf.org/html/rfc6585#section-6"},{code:"7xx",phrase:"**Developer Error**",description:"[err](http://www.urbandictionary.com/define.php?term=err)",spec_title:"7xx-rfc",spec_href:"http://documentup.com/joho/7XX-rfc"}]},function(e,t){e.exports=[{method:"CONNECT",description:'"requests that the recipient establish a tunnel to the destination origin server identified by the request-target and, if successful, thereafter restrict its behavior to blind forwarding of packets, in both directions, until the connection is closed."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.6",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.6"},{method:"DELETE",description:'"requests that the origin server remove the association between the target resource and its current functionality."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.5"},{method:"GET",description:'"requests transfer of a current selected representation for the target resource."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.1"},{method:"HEAD",description:'"is identical to GET except that the server MUST NOT send a message body in the response (i.e., the response terminates at the end of the header block)."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.2"},{method:"OPTIONS",description:'"requests information about the communication options available on the request/response chain identified by the effective request URI."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.7",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.7"},{method:"POST",description:'"requests that the target resource process the representation enclosed in the request according to the resource\'s own specific semantics."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC7231#4.3.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.3"},{method:"PUT",description:'"requests that the state of the target resource be created or replaced with the state defined by the representation enclosed in the request message payload."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.4"},{method:"TRACE",description:'"is used to invoke a remote, application-layer loopback of the request message."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.8",spec_href:"https://tools.ietf.org/html/rfc7231#section-4.3.8"},{method:"ACL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3744#8.1",spec_href:"https://tools.ietf.org/html/rfc3744#section-8.1"},{method:"BASELINE-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#12.6",spec_href:"https://tools.ietf.org/html/rfc3253#section-12.6"},{method:"BIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#4",spec_href:"https://tools.ietf.org/html/rfc5842#section-4"},{method:"CHECKIN",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.4",spec_href:"https://tools.ietf.org/html/rfc3253#section-4.4"},{method:"CHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.3",spec_href:"https://tools.ietf.org/html/rfc3253#section-4.3"},{method:"COPY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.8",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.8"},{method:"LABEL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#8.2",spec_href:"https://tools.ietf.org/html/rfc3253#section-8.2"},{method:"LINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.2",spec_href:"https://tools.ietf.org/html/rfc2068#section-19.6.1.2"},{method:"LOCK",description:"",safe:!1,idempotent:!1,cacheable:"",spec_title:"RFC4918#9.10",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.10"},{method:"MERGE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#11.2",spec_href:"https://tools.ietf.org/html/rfc3253#section-11.2"},{method:"MKACTIVITY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#13.5",spec_href:"https://tools.ietf.org/html/rfc3253#section-13.5"},{method:"MKCALENDAR",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4791#5.3.1",spec_href:"https://tools.ietf.org/html/rfc4791#section-5.3.1"},{method:"MKCOL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.3",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.3"},{method:"MKREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#6",spec_href:"https://tools.ietf.org/html/rfc4437#section-6"},{method:"MKWORKSPACE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#6.3",spec_href:"https://tools.ietf.org/html/rfc3253#section-6.3"},{method:"MOVE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.9",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.9"},{method:"ORDERPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3648#7",spec_href:"https://tools.ietf.org/html/rfc3648#section-7"},{method:"PATCH",description:'"requests that a set of changes described in the request entity be applied to the resource identified by the Request-URI."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC5789",spec_href:"https://tools.ietf.org/html/rfc5789#section-2"},{method:"PROPFIND",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.1",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.1"},{method:"PROPPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.2",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.2"},{method:"REBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#6",spec_href:"https://tools.ietf.org/html/rfc5842#section-6"},{method:"REPORT",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.6",spec_href:"https://tools.ietf.org/html/rfc3253#section-3.6"},{method:"SEARCH",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC5323#2",spec_href:"https://tools.ietf.org/html/rfc5323#section-2"},{method:"UNBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#5",spec_href:"https://tools.ietf.org/html/rfc5842#section-5"},{method:"UNCHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.5",spec_href:"https://tools.ietf.org/html/rfc3253#section-4.5"},{method:"UNLINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.3",spec_href:"https://tools.ietf.org/html/rfc2068#section-19.6.1.3"},{method:"UNLOCK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.11",spec_href:"https://tools.ietf.org/html/rfc4918#section-9.11"},{method:"UPDATE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#7.1",spec_href:"https://tools.ietf.org/html/rfc3253#section-7.1"},{method:"UPDATEREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#7",spec_href:"https://tools.ietf.org/html/rfc4437#section-7"},{method:"VERSION-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.5",spec_href:"https://tools.ietf.org/html/rfc3253#section-3.5"}]},function(e,t){e.exports=[{header:"Content-Encoding",description:'"indicates what content codings have been applied to the representation, beyond those inherent in the media type, and thus what decoding mechanisms have to be applied in order to obtain data in the media type referenced by the Content-Type header field."',spec_title:"RFC7231#3.1.2.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-3.1.2.2"},{header:"Content-Language",description:'"describes the natural language(s) of the intended audience for the representation."',spec_title:"RFC7231#3.1.3.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-3.1.3.2"},{header:"Content-Location",description:'"references a URI that can be used as an identifier for a specific resource corresponding to the representation in this message\'s payload."',spec_title:"RFC7231#3.1.4.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-3.1.4.2"},{header:"Content-Type",description:'"indicates the media type of the associated representation: either the representation enclosed in the message payload or the selected representation, as determined by the message semantics."',spec_title:"RFC7231#3.1.1.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-3.1.1.5"},{header:"Content-Length",description:'"can provide the anticipated size, as a decimal number of octets, for a potential payload body."',spec_title:"RFC7230#3.3.2",spec_href:"https://tools.ietf.org/html/rfc7230#section-3.3.2"},{header:"Content-Range",description:'"is sent in a single part 206 (Partial Content) response to indicate the partial range of the selected representation enclosed as the message payload, sent in each part of a multipart 206 response to indicate the range enclosed within each body part, and sent in 416 (Range Not Satisfiable) responses to provide information about the selected representation."',spec_title:"RFC7233#4.2",spec_href:"https://tools.ietf.org/html/rfc7233#section-4.2"},{header:"Transfer-Encoding",description:'"lists the transfer coding names corresponding to the sequence of transfer codings that have been (or will be) applied to the payload body in order to form the message body."',spec_title:"RFC7230#3.3.1",spec_href:"https://tools.ietf.org/html/rfc7230#section-3.3.1"},{header:"Cache-Control",description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"https://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expect",description:'"is used to indicate that particular server behaviors are required by the client."',spec_title:"RFC7231#5.1.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.1.1"},{header:"Host",description:'"provides the host and port information from the target URI, enabling the origin server to distinguish among resources while servicing requests for multiple host names on a single IP address."',spec_title:"RFC7230#5.4",spec_href:"https://tools.ietf.org/html/rfc7230#section-5.4"},{header:"HTTP2-Settings",description:'"A request that upgrades from HTTP/1.1 to HTTP/2 MUST include exactly one HTTP2-Settings header field. The HTTP2-Settings header field is a connection-specific header field that includes parameters that govern the HTTP/2 connection, provided in anticipation of the server accepting the request to upgrade."',spec_title:"RFC7540#3.2.1",spec_href:"https://tools.ietf.org/html/rfc7540#section-3.2.1"},{header:"Max-Forwards",description:'"provides a mechanism with the TRACE and OPTIONS methods to limit the number of times that the request is forwarded by proxies."',spec_title:"RFC7231#5.1.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.1.2"},{header:"Pragma",description:'"allows backwards compatibility with HTTP/1.0 caches, so that clients can specify a "no-cache" request that they will understand (as Cache-Control was not defined until HTTP/1.1)."',spec_title:"RFC7234#7.4",spec_href:"https://tools.ietf.org/html/rfc7234#section-7.4"},{header:"Range",description:'"modifies the method semantics to request transfer of only one or more subranges of the selected representation data, rather than the entire selected representation data."',spec_title:"RFC7233#3.1",spec_href:"https://tools.ietf.org/html/rfc7233#section-3.1"},{header:"TE",description:'"indicates what transfer codings, besides chunked, the client is willing to accept in response, and whether or not the client is willing to accept trailer fields in a chunked transfer coding."',spec_title:"RFC7230#4.3",spec_href:"https://tools.ietf.org/html/rfc7230#section-4.3"},{header:"If-Match",description:'"can be used to make a request method conditional on the current existence or value of an entity-tag for one or more representations of the target resource."',spec_title:"RFC7232#3.1",spec_href:"https://tools.ietf.org/html/rfc7232#section-3.1"},{header:"If-Modified-Since",description:'"can be used with GET or HEAD to make the method conditional by modification date: if the selected representation has not been modified since the time specified in this field, then do not perform the request method; instead, respond as detailed below."',spec_title:"RFC7232#3.3",spec_href:"https://tools.ietf.org/html/rfc7232#section-3.3"},{header:"If-None-Match",description:'"can be used to make a request method conditional on not matching any of the current entity-tag values for representations of the target resource."',spec_title:"RFC7232#3.2",spec_href:"https://tools.ietf.org/html/rfc7232#section-3.2"},{header:"If-Range",description:'"Informally, its meaning is: if the representation is unchanged, send me the part(s) that I am requesting in Range; otherwise, send me the entire representation."',spec_title:"RFC7233#3.2",spec_href:"https://tools.ietf.org/html/rfc7233#section-3.2"},{header:"If-Unmodified-Since",description:'"can be used to make a request method conditional by modification date: if the selected representation has been modified since the time specified in this field, then the server MUST NOT perform the requested operation and MUST instead respond with the 412 (Precondition Failed) status code."',spec_title:"RFC7232#3.4",spec_href:"https://tools.ietf.org/html/rfc7232#section-3.4"},{header:"Accept",description:'"can be used to specify certain media types which are acceptable for the response."',spec_title:"RFC7231#5.3.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.3.2"},{header:"Accept-Charset",description:'"can be sent by a user agent to indicate what charsets are acceptable in textual response content."',spec_title:"RFC7231#5.3.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.3.3"},{header:"Accept-Encoding",description:'"can be used by user agents to indicate what response content-codings are acceptable in the response."',spec_title:"RFC7231#5.3.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.3.4"},{header:"Accept-Language",description:'"can be used by user agents to indicate the set of natural languages that are preferred in the response."',spec_title:"RFC7231#5.3.5",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.3.5"},{header:"Authorization",description:'"allows a user agent to authenticate itself with a server -- usually, but not necessarily, after receiving a 401 (Unauthorized) response."',spec_title:"RFC7235#4.1",spec_href:"https://tools.ietf.org/html/rfc7235#section-4.1"},{header:"Proxy-Authorization",description:'"allows the client to identify itself (or its user) to a proxy that requires authentication."',spec_title:"RFC7235#4.3",spec_href:"https://tools.ietf.org/html/rfc7235#section-4.3"},{header:"DNT",description:'"defined as the means for expressing a user\'s tracking preference via HTTP."',spec_title:"Tracking Preference Expression (DNT)",spec_href:"https://www.w3.org/TR/tracking-dnt/#dnt-header-field"},{header:"From",description:'"contains an Internet email address for a human user who controls the requesting user agent."',spec_title:"RFC7231#5.5.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.5.1"},{header:"Referer",description:'"allows the user agent to specify a URI reference for the resource from which the target URI was obtained (i.e., the "referrer", though the field name is misspelled)."',spec_title:"RFC7231#5.5.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.5.2"},{header:"User-Agent",description:'"contains information about the user agent originating the request, which is often used by servers to help identify the scope of reported interoperability problems, to work around or tailor responses to avoid particular user agent limitations, and for analytics regarding browser or operating system use."',spec_title:"RFC7231#5.5.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-5.5.3"},{header:"Age",description:'"conveys the sender\'s estimate of the amount of time since the response was generated or successfully validated at the origin server."',spec_title:"RFC7234#5.1",spec_href:"https://tools.ietf.org/html/rfc7234#section-5.1"},{header:"Expires",description:'"gives the date/time after which the response is considered stale."',spec_title:"RFC7234#7.3",spec_href:"https://tools.ietf.org/html/rfc7234#section-7.3"},{header:"Date",description:'"represents the date and time at which the message was originated"',spec_title:"RFC7231#7.1.1.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-7.1.1.2"},{header:"Location",description:'"is used in some responses to refer to a specific resource in relation to the response."',spec_title:"RFC7231#7.1.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-7.1.2"},{header:"Retry-After",description:'"indicates how long the user agent ought to wait before making a follow-up request."',spec_title:"RFC7231#7.1.3",spec_href:"https://tools.ietf.org/html/rfc7231#section-7.1.3"},{header:"Tk",description:'"defined as an OPTIONAL means for indicating the tracking status that applied to the corresponding request and as a REQUIRED means for indicating that a state-changing request has resulted in an interactive change to the tracking status. "',spec_title:"Tracking Preference Expression (DNT)",spec_href:"https://www.w3.org/TR/tracking-dnt/#response-header-field"},{header:"Vary",description:'"describes what parts of a request message, aside from the method and request target, might influence the origin server\'s process for selecting and representing the response."',spec_title:"RFC7231#7.1.4",spec_href:"https://tools.ietf.org/html/rfc7231#section-7.1.4"},{header:"Warning",description:'"is used to carry additional information about the status or transformation of a message that might not be reflected in the message."',spec_title:"RFC7234#7.6",spec_href:"https://tools.ietf.org/html/rfc7234#section-7.6"},{header:"ETag",description:'"provides the current entity-tag for the selected representation, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.3",spec_href:"https://tools.ietf.org/html/rfc7232#section-2.3"},{header:"Last-Modified",description:'"provides a timestamp indicating the date and time at which the origin server believes the selected representation was last modified, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.2",spec_href:"https://tools.ietf.org/html/rfc7232#section-2.2"},{header:"WWW-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the effective request URI."',spec_title:"RFC7235#4.4",spec_href:"https://tools.ietf.org/html/rfc7235#section-4.4"},{header:"Proxy-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the proxy for this effective request URI."',spec_title:"RFC7235#4.2",spec_href:"https://tools.ietf.org/html/rfc7235#section-4.2"},{header:"Accept-Ranges",description:'"allows a server to indicate that it supports range requests for the target resource."',spec_title:"RFC7233#2.3",spec_href:"https://tools.ietf.org/html/rfc7233#section-2.3"},{header:"Allow",description:'"lists the set of methods advertised as supported by the target resource."',spec_title:"RFC7231#7.4.1",spec_href:"https://tools.ietf.org/html/rfc7231#section-7.4.1"},{header:"Server",description:'"contains information about the software used by the origin server to handle the request, which is often used by clients to help identify the scope of reported interoperability problems, to work around or tailor requests to avoid particular server limitations, and for analytics regarding server or operating system use."',spec_title:"RFC7231#7.4.2",spec_href:"https://tools.ietf.org/html/rfc7231#section-7.4.2"},{header:"Accept-Patch",description:'"used to specify the patch document formats accepted by the server."',spec_title:"RFC5789#3.1",spec_href:"https://tools.ietf.org/html/rfc5789#section-3.1"},{header:"Accept-Post",description:'"indicates server support for specific media types for entity bodies in HTTP POST requests."',spec_title:"draft-wilde-accept-post",spec_href:"https://tools.ietf.org/html/draft-wilde-accept-post"},{header:"Access-Control-Allow-Credentials",description:'"indicates whether the response to request can be exposed when the omit credentials flag is unset"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-allow-credentials-response-header"},{header:"Access-Control-Allow-Headers",description:'"indicates, as part of the response to a preflight request, which header field names can be used during the actual request"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-allow-headers-response-header"},{header:"Access-Control-Allow-Methods",description:'"indicates, as part of the response to a preflight request, which methods can be used during the actual request"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-allow-methods-response-header"},{header:"Access-Control-Allow-Origin",description:'"indicates whether a resource can be shared"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-allow-origin-response-header"},{header:"Access-Control-Expose-Headers",description:'"indicates which headers are safe to expose to the API of a CORS API specification"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-expose-headers-response-header"},{header:"Access-Control-Max-Age",description:'"indicates how long the results of a preflight request can be cached in a preflight result cache"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-max-age-response-header"},{header:"Access-Control-Request-Headers",description:'"indicates which headers will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-request-headers-request-header"},{header:"Access-Control-Request-Method",description:'"indicates which method will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"https://www.w3.org/TR/cors/#access-control-request-method-request-header"},{header:"Content-Disposition",description:'"standard"',spec_title:"RFC6266",spec_href:"https://tools.ietf.org/html/rfc6266"},{header:"Content-Security-Policy",description:'"is the preferred mechanism for delivering a CSP policy"',spec_title:"CSP",spec_href:"https://www.w3.org/TR/CSP/#content-security-policy-header-field"},{header:"Content-Security-Policy-Report-Only",description:'"lets servers experiment with policies by monitoring (rather than enforcing) a policy"',spec_title:"CSP",spec_href:"https://www.w3.org/TR/CSP/#content-security-policy-report-only-header-field"},{header:"Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"https://tools.ietf.org/html/rfc6265"},{header:"Forwarded",description:'"standard"',spec_title:"RFC7239",spec_href:"https://tools.ietf.org/html/rfc7239"},{header:"Link",description:'"provides a means for serialising one or more links in HTTP headers."',spec_title:"RFC5988#5",spec_href:"https://tools.ietf.org/html/rfc5988#section-5"},{header:"Origin",description:'"standard"',spec_title:"RFC6454",spec_href:"https://tools.ietf.org/html/rfc6454"},{header:"Prefer",description:'"is used to indicate that particular server behaviors are preferred by the client, but not required for successful completion of the request."',spec_title:"RFC7240#2",spec_href:"https://tools.ietf.org/html/rfc7240#section-2"},{header:"Preference-Applied",description:'"MAY be included within a response message as an indication as to which Prefer tokens were honored by the server and applied to the processing of a request."',spec_title:"RFC7240#3",spec_href:"https://tools.ietf.org/html/rfc7240#section-3"},{header:"Set-Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"https://tools.ietf.org/html/rfc6265"},{header:"Strict-Transport-Security",description:'"standard"',spec_title:"RFC6797",spec_href:"https://tools.ietf.org/html/rfc6797"},{header:"Via",description:'""',
spec_title:"RFC7230#5.7.1",spec_href:"https://tools.ietf.org/html/rfc7230#section-5.7.1"},{header:"A-IM",description:'""',spec_title:"RFC3229#10.5.3",spec_href:"https://tools.ietf.org/html/rfc3229#section-10.5.3"},{header:"Accept-CH",description:'"advertise support for Client Hints"',spec_title:"draft-grigorik-http-client-hints",spec_href:"https://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Accept-Features",description:'"can be used by a user agent to give information about the presence or absence of certain features in the feature set of the current request."',spec_title:"RFC2295#8.2",spec_href:"https://tools.ietf.org/html/rfc2295#section-8.2"},{header:"ALPN",description:'"indicates the application-layer protocol that a client intends to use within the tunnel, or a set of protocols that might be used within the tunnel."',spec_title:"RFC7639#2",spec_href:"https://tools.ietf.org/html/rfc7639#section-2"},{header:"Alt-Svc",description:'"is advertising the availability of alternate services to HTTP/1.1 and HTTP/2.0 clients by adding an Alt-Svc header field to responses."',spec_title:"draft-nottingham-httpbis-alt-svc",spec_href:"https://tools.ietf.org/html/draft-nottingham-httpbis-alt-svc"},{header:"Alternates",description:'"is used to convey the list of variants bound to a negotiable resource."',spec_title:"RFC2295#8.3",spec_href:"https://tools.ietf.org/html/rfc2295#section-8.3"},{header:"Apply-To-Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"https://tools.ietf.org/html/rfc4437"},{header:"CH",description:'"describes an example list of client preferences that the server can use to adapt and optimize the resource to satisfy a given request."',spec_title:"draft-grigorik-http-client-hints",spec_href:"https://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Content-Base",description:'"obsoleted"',spec_title:"RFC2068",spec_href:"https://tools.ietf.org/html/rfc2068"},{header:"Content-DPR",description:'"is a number that indicates the ratio between physical pixels over CSS px of the selected image response."',spec_title:"draft-grigorik-http-client-hints",spec_href:"https://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"https://tools.ietf.org/html/rfc2965"},{header:"DASL",description:'"standard"',spec_title:"RFC5323",spec_href:"https://tools.ietf.org/html/rfc5323"},{header:"DAV",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"Delta-Base",description:'""',spec_title:"RFC3229#10.5.1",spec_href:"https://tools.ietf.org/html/rfc3229#section-10.5.1"},{header:"Depth",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"Destination",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"DPR",description:'"is a number that, in requests, indicates the client’s current Device Pixel Ratio (DPR), which is the ratio of physical pixels over CSS px of the layout viewport on the device."',spec_title:"draft-grigorik-http-client-hints",spec_href:"https://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Encryption",description:'"describes the encrypted content encoding(s) that have been applied to a payload body, and therefore how those content encoding(s) can be removed."',spec_title:"draft-thomson-http-encryption",spec_href:"https://tools.ietf.org/html/draft-thomson-http-encryption#section-3"},{header:"Encryption-Key",description:'"can be used to describe the input keying material used in the Encryption header field."',spec_title:"draft-thomson-http-encryption",spec_href:"https://tools.ietf.org/html/draft-thomson-http-encryption#section-4"},{header:"IM",description:'""',spec_title:"RFC3229#10.5.2",spec_href:"https://tools.ietf.org/html/rfc3229#section-10.5.2"},{header:"If",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"If-Schedule-Tag-Match",description:'"standard"',spec_title:"RFC6638",spec_href:"https://tools.ietf.org/html/rfc6638"},{header:"Key",description:'"allows an origin server to describe the cache key for a negotiated response: a short algorithm that can be used upon later requests to determine if the same response is reusable."',spec_title:"draft-fielding-http-key",spec_href:"https://tools.ietf.org/html/draft-fielding-http-key"},{header:"Last-Event-ID",description:'"The value of the event source\'s last event ID string, encoded as UTF-8."',spec_title:"Server-Sent Events",spec_href:"https://www.w3.org/TR/eventsource/#last-event-id"},{header:"Link-Template",description:'"provides a means for serialising one or more links into HTTP headers."',spec_title:"draft-nottingham-link-template",spec_href:"https://tools.ietf.org/html/draft-nottingham-link-template"},{header:"Lock-Token",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"MD",description:'"is a number that, in requests, indicates the client’s maximum downlink speed in megabits per second (Mbps), which is the standardized, or generally accepted, maximum download data rate for the underlying connection technology in use by the client."',spec_title:"draft-grigorik-http-client-hints",spec_href:"https://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Negotiate",description:'"can contain directives for any content negotiation process initiated by the request."',spec_title:"RFC2295#8.4",spec_href:"https://tools.ietf.org/html/rfc2295#section-8.4"},{header:"Nice",description:'"indicates that a request is less important than a request that doesn\'t bear this header."',spec_title:"draft-thomson-http-nice",spec_href:"https://tools.ietf.org/html/draft-thomson-http-nice"},{header:"Overwrite",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"POE",description:'"The POE HTTP header is a request-header field whose field-value indicates the version of POE that a client supports."',spec_title:"draft-nottingham-http-poe",spec_href:"https://tools.ietf.org/html/draft-nottingham-http-poe"},{header:"POE-Links",description:'"The POE-Links HTTP header is an entity-header field whose field-value is a comma-separated list of quoted URI-references (without fragment identifiers) that the origin server asserts to be POE resources. The contents of the POE-Links response header SHOULD correspond to links found in the content of the response body."',spec_title:"draft-nottingham-http-poe",spec_href:"https://tools.ietf.org/html/draft-nottingham-http-poe"},{header:"Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"https://tools.ietf.org/html/rfc4437"},{header:"RW",description:'"is a number that, in requests, indicates the Resource Width (RW) in CSS px, which is either the display width of the requested resource (e.g. display width of an image), or the layout viewport width if the resource does not have a display width (e.g. a non-image asset)."',spec_title:"draft-grigorik-http-client-hints",spec_href:"https://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Schedule-Reply",description:'"standard"',spec_title:"RFC6638",spec_href:"https://tools.ietf.org/html/rfc6638"},{header:"Schedule-Tag",description:'"standard"',spec_title:"RFC6638",spec_href:"https://tools.ietf.org/html/rfc6638"},{header:"Sec-WebSocket-Accept",description:'"standard"',spec_title:"RFC6455",spec_href:"https://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Extensions",description:'"standard"',spec_title:"RFC6455",spec_href:"https://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Key",description:'"standard"',spec_title:"RFC6455",spec_href:"https://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Protocol",description:'"standard"',spec_title:"RFC6455",spec_href:"https://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Version",description:'"standard"',spec_title:"RFC6455",spec_href:"https://tools.ietf.org/html/rfc6455"},{header:"Set-Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"https://tools.ietf.org/html/rfc2965"},{header:"SLUG",description:'"standard"',spec_title:"RFC5023",spec_href:"https://tools.ietf.org/html/rfc5023"},{header:"Status-URI",description:'""',spec_title:"RFC2518",spec_href:"https://tools.ietf.org/html/rfc2518#section-9.7"},{header:"Sunset",description:'"allows a server to communicate the fact that a resource is expected to become unresponsive at a specific point in time."',spec_title:"draft-wilde-sunset-header",spec_href:"https://tools.ietf.org/html/draft-wilde-sunset-header"},{header:"Surrogate-Capability",description:'""',spec_title:"Edge Architecture",spec_href:"https://www.w3.org/TR/edge-arch"},{header:"Surrogate-Control",description:'""',spec_title:"Edge Architecture",spec_href:"https://www.w3.org/TR/edge-arch"},{header:"TCN",description:'"is used by a server to signal that the resource is transparently negotiated."',spec_title:"RFC2295#8.5",spec_href:"https://tools.ietf.org/html/rfc2295#section-8.5"},{header:"Timeout",description:'"standard"',spec_title:"RFC4918",spec_href:"https://tools.ietf.org/html/rfc4918"},{header:"Variant-Vary",description:'"can be used in a choice response to record any vary information which applies to the variant data (the entity body combined with some of the entity headers) contained in the response, rather than to the response as a whole."',spec_title:"RFC2295#8.6",spec_href:"https://tools.ietf.org/html/rfc2295#section-8.6"},{header:"X-Frame-Options",description:'"indicates a policy that specifies whether the browser should render the transmitted resource within a &lt;frame&gt; or an &lt;iframe&gt;. Servers can declare this policy in the header of their HTTP responses to prevent clickjacking attacks, which ensures that their content is not embedded into other pages or frames."',spec_title:"RFC7034",spec_href:"https://tools.ietf.org/html/rfc7034"}]},function(e,t){e.exports=[{relation:"about",description:'"Refers to a resource that is the subject of the link\'s context."',spec_title:"RFC6903",spec_href:"https://tools.ietf.org/html/rfc6903"},{relation:"alternate",description:'"Refers to a substitute for this context"',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-alternate"},{relation:"appendix",description:'"Refers to an appendix."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"archives",description:'"Refers to a collection of records, documents, or other materials of historical interest."',spec_title:"HTML5linksWD",spec_href:"https://www.w3.org/TR/2011/WD-html5-20110113/links.html#rel-archives"},{relation:"author",description:'"Refers to the context\'s author."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-author"},{relation:"bookmark",description:'"Gives a permanent link to use for bookmarking purposes."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-bookmark"},{relation:"canonical",description:'"Designates the preferred version of a resource (the IRI and its contents)."',spec_title:"RFC6596",spec_href:"https://tools.ietf.org/html/rfc6596"},{relation:"chapter",description:'"Refers to a chapter in a collection of resources."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"collection",description:'"The target IRI points to a resource which represents the collection resource for the context IRI."',spec_title:"RFC6573",spec_href:"https://tools.ietf.org/html/rfc6573"},{relation:"contents",description:'"Refers to a table of contents."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"copyright",description:'"Refers to a copyright statement that applies to the link\'s context."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"create-form",description:'"The target IRI points to a resource where a submission form can be obtained."',spec_title:"RFC6861",spec_href:"https://tools.ietf.org/html/rfc6861"},{relation:"current",description:'"Refers to a resource containing the most recent item(s) in a collection of resources."',spec_title:"RFC5005",spec_href:"https://tools.ietf.org/html/rfc5005"},{relation:"describedby",description:'"Refers to a resource providing information about the link\'s context."',spec_title:"POWDER",spec_href:"https://www.w3.org/TR/powder-dr/#assoc-linking"},{relation:"describes",description:"\"The relationship A 'describes' B asserts that resource A provides a description of resource B. There are no constraints on the format or representation of either A or B, neither are there any further constraints on either resource.\"",spec_title:"RFC6892",spec_href:"https://tools.ietf.org/html/rfc6892"},{relation:"disclosure",description:'"Refers to a list of patent disclosures made with respect to material for which `disclosure` relation is specified."',spec_title:"RFC6579",spec_href:"https://tools.ietf.org/html/rfc6579"},{relation:"duplicate",description:'"Refers to a resource whose available representations are byte-for-byte identical with the corresponding representations of the context IRI."',spec_title:"RFC6249",spec_href:"https://tools.ietf.org/html/rfc6249"},{relation:"edit",description:'"Refers to a resource that can be used to edit the link\'s context."',spec_title:"RFC5023",spec_href:"https://tools.ietf.org/html/rfc5023"},{relation:"edit-form",description:'"The target IRI points to a resource where a submission form for editing associated resource can be obtained."',spec_title:"RFC6861",spec_href:"https://tools.ietf.org/html/rfc6861"},{relation:"edit-media",description:'"Refers to a resource that can be used to edit media associated with the link\'s context."',spec_title:"RFC5023",spec_href:"https://tools.ietf.org/html/rfc5023"},{relation:"enclosure",description:'"Identifies a related resource that is potentially large and might require special handling."',spec_title:"RFC4287",spec_href:"https://tools.ietf.org/html/rfc4287"},{relation:"first",description:'"An IRI that refers to the furthest preceding resource in a series of resources."',spec_title:"RFC5988",spec_href:"https://tools.ietf.org/html/rfc5988"},{relation:"glossary",description:'"Refers to a glossary of terms."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"help",description:'"Refers to context-sensitive help."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-help"},{relation:"hosts",description:'"Refers to a resource hosted by the server indicated by the link context."',spec_title:"RFC6690",spec_href:"https://tools.ietf.org/html/rfc6690"},{relation:"hub",description:'"Refers to a hub that enables registration for notification of updates to the context."',spec_title:"pubsubhubbub",spec_href:"http://pubsubhubbub.googlecode.com"},{relation:"icon",description:'"Refers to an icon representing the link\'s context."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-icon"},{relation:"index",description:'"Refers to an index."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"item",description:'"The target IRI points to a resource that is a member of the collection represented by the context IRI."',spec_title:"RFC6573",spec_href:"https://tools.ietf.org/html/rfc6573"},{relation:"last",description:'"An IRI that refers to the furthest following resource in a series of resources."',spec_title:"RFC5988",spec_href:"https://tools.ietf.org/html/rfc5988"},{relation:"latest-version",description:'"Points to a resource containing the latest (e.g., current) version of the context."',spec_title:"RFC5829",spec_href:"https://tools.ietf.org/html/rfc5829"},{relation:"license",description:'"Refers to a license associated with this context."',spec_title:"RFC4946",spec_href:"https://tools.ietf.org/html/rfc4946"},{relation:"lrdd",description:'"Refers to further information about the link\'s context, expressed as a LRDD (Link-based Resource Descriptor Document) resource. See [RFC6415](https://tools.ietf.org/html/rfc6415) for information about processing this relation type in host-meta documents. When used elsewhere, it refers to additional links and other metadata. Multiple instances indicate additional LRDD resources. LRDD resources MUST have an "application/xrd+xml" representation, and MAY have others."',spec_title:"RFC6415",spec_href:"https://tools.ietf.org/html/rfc6415"},{relation:"monitor",description:'"Refers to a resource that can be used to monitor changes in an HTTP resource."',spec_title:"RFC5989",spec_href:"https://tools.ietf.org/html/rfc5989"},{relation:"monitor-group",description:'"Refers to a resource that can be used to monitor changes in a specified group of HTTP resources."',spec_title:"RFC5989",spec_href:"https://tools.ietf.org/html/rfc5989"},{relation:"next",description:'"Indicates that the link\'s context is a part of a series, and that the next in the series is the link target."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-next"},{relation:"next-archive",description:'"Refers to the immediately following archive resource."',spec_title:"RFC5005",spec_href:"https://tools.ietf.org/html/rfc5005"},{relation:"nofollow",description:'"Indicates that the context’s original author or publisher does not endorse the link target."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-nofollow"},{relation:"noreferrer",description:'"Indicates that no referrer information is to be leaked when following the link."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-noreferrer"},{relation:"payment",description:'"Indicates a resource where payment is accepted."',spec_title:"RFC5988",spec_href:"https://tools.ietf.org/html/rfc5988"},{relation:"predecessor-version",description:'"Points to a resource containing the predecessor version in the version history."',spec_title:"RFC5829",spec_href:"https://tools.ietf.org/html/rfc5829"},{relation:"prefetch",description:'"Indicates that the link target should be preemptively cached."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-prefetch"},{relation:"prev",description:'"Indicates that the link\'s context is a part of a series, and that the previous in the series is the link target."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-prev"},{relation:"preview",description:'"Refers to a resource that provides a preview of the link\'s context."',spec_title:"RFC6903",spec_href:"https://tools.ietf.org/html/rfc6903"},{relation:"previous",description:'"Refers to the previous resource in an ordered series of resources. Synonym for `prev`."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"prev-archive",description:'"Refers to the immediately preceding archive resource."',spec_title:"RFC5005",spec_href:"https://tools.ietf.org/html/rfc5005"},{relation:"privacy-policy",description:'"Refers to a privacy policy associated with the link\'s context."',spec_title:"RFC6903",spec_href:"https://tools.ietf.org/html/rfc6903"},{relation:"profile",description:"Identifying that a resource representation conforms to a certain profile, without affecting the non-profile semantics of the resource representation",spec_title:"RFC6906",spec_href:"https://tools.ietf.org/html/rfc6906"},{relation:"related",description:'"Identifies a related resource."',spec_title:"RFC4287",spec_href:"https://tools.ietf.org/html/rfc4287"},{relation:"replies",description:'"Identifies a resource that is a reply to the context of the link."',spec_title:"RFC4685",spec_href:"https://tools.ietf.org/html/rfc4685"},{relation:"search",description:'"Refers to a resource that can be used to search through the link\'s context and related resources."',spec_title:"OpenSearch",spec_href:"http://www.opensearch.org/Specifications/OpenSearch/1.1"},{relation:"section",description:'"Refers to a section in a collection of resources."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"self",description:'"Conveys an identifier for the link\'s context."',spec_title:"RFC4287",spec_href:"https://tools.ietf.org/html/rfc4287"},{relation:"service",description:'"Indicates a URI that can be used to retrieve a service document."',spec_title:"RFC5023",spec_href:"https://tools.ietf.org/html/rfc5023"},{relation:"start",description:'"Refers to the first resource in a collection of resources."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"stylesheet",description:'"Refers to a stylesheet."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-stylesheet"},{relation:"subsection",description:'"Refers to a resource serving as a subsection in a collection of resources."',spec_title:"HTML401",spec_href:"https://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"successor-version",description:'"Points to a resource containing the successor version in the version history."',spec_title:"RFC5829",spec_href:"https://tools.ietf.org/html/rfc5829"},{relation:"tag",description:'"Gives a tag (identified by the given address) that applies to the current document."',spec_title:"HTML5links",spec_href:"https://www.w3.org/TR/html5/links.html#link-type-tag"},{relation:"terms-of-service",description:'"Refers to the terms of service associated with the link\'s context."',spec_title:"RFC6903",spec_href:"https://tools.ietf.org/html/rfc6903"},{relation:"type",description:'"Refers to a resource identifying the abstract semantic type of which the link\'s context is considered to be an instance."',spec_title:"RFC6903",spec_href:"https://tools.ietf.org/html/rfc6903"},{relation:"up",description:'"Refers to a parent document in a hierarchy of documents."',spec_title:"RFC5988",spec_href:"https://tools.ietf.org/html/rfc5988"},{relation:"version-history",description:'"Points to a resource containing the version history for the context."',spec_title:"RFC5829",spec_href:"https://tools.ietf.org/html/rfc5829"},{relation:"via",description:'"Identifies a resource that is the source of the information in the link\'s context."',spec_title:"RFC4287",spec_href:"https://tools.ietf.org/html/rfc4287"},{relation:"working-copy",description:'"Points to a working copy for this resource."',spec_title:"RFC5829",spec_href:"https://tools.ietf.org/html/rfc5829"},{relation:"working-copy-of",description:'"Points to the versioned resource from which this working copy was obtained."',spec_title:"RFC5829",spec_href:"https://tools.ietf.org/html/rfc5829"},{relation:"blocked-by",description:'"Identifies the entity blocking access to a resource folllowing on receipt of a legal demand."',spec_title:"draft-ietf-httpbis-legally-restricted-status",spec_href:"https://tools.ietf.org/html/draft-ietf-httpbis-legally-restricted-status"}]},function(e,t){"use strict";var n={Universe08:{GlobalSchema:{name:"GlobalSchema",properties:{key:{name:"key",range:"StringType",domain:"GlobalSchema"},value:{name:"value",range:"SchemaString",domain:"GlobalSchema"}}},Api:{name:"Api",properties:{title:{name:"title",range:"StringType",domain:"Api"},version:{name:"version",range:"StringType",domain:"Api"},baseUri:{name:"baseUri",range:"FullUriTemplateString",domain:"Api"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Api"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Api"},protocols:{name:"protocols",range:"StringType",domain:"Api"},mediaType:{name:"mediaType",range:"MimeType",domain:"Api"},schemas:{name:"schemas",range:"GlobalSchema",domain:"Api"},traits:{name:"traits",range:"Trait",domain:"Api"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Api"},securitySchemes:{name:"securitySchemes",range:"AbstractSecurityScheme",domain:"Api"},resourceTypes:{name:"resourceTypes",range:"ResourceType",domain:"Api"},resources:{name:"resources",range:"Resource",domain:"Api"},documentation:{name:"documentation",range:"DocumentationItem",domain:"Api"},RAMLVersion:{name:"RAMLVersion"}}},DocumentationItem:{name:"DocumentationItem",properties:{title:{name:"title",range:"StringType",domain:"DocumentationItem"},content:{name:"content",range:"MarkdownString",domain:"DocumentationItem"}}},ValueType:{name:"ValueType",properties:{}},StringType:{name:"StringType",properties:{}},AnyType:{name:"AnyType",properties:{}},NumberType:{name:"NumberType",properties:{}},BooleanType:{name:"BooleanType",properties:{}},Referencable:{name:"Referencable",properties:{}},Reference:{name:"Reference",properties:{structuredValue:{name:"structuredValue"},name:{name:"name"}}},DeclaresDynamicType:{name:"DeclaresDynamicType",properties:{}},UriTemplate:{name:"UriTemplate",properties:{}},RelativeUriString:{name:"RelativeUriString",properties:{}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{}},FixedUri:{name:"FixedUri",properties:{}},MarkdownString:{name:"MarkdownString",properties:{}},SchemaString:{name:"SchemaString",properties:{}},JSonSchemaString:{name:"JSonSchemaString",properties:{}},XMLSchemaString:{name:"XMLSchemaString",properties:{}},ExampleString:{name:"ExampleString",properties:{}},StatusCodeString:{name:"StatusCodeString",properties:{}},JSONExample:{name:"JSONExample",properties:{}},XMLExample:{name:"XMLExample",properties:{}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties",range:"TypeInstanceProperty",domain:"TypeInstance"},isScalar:{name:"isScalar",range:"BooleanType",domain:"TypeInstance"},value:{name:"value",range:"AnyType",domain:"TypeInstance"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name",range:"StringType",domain:"TypeInstanceProperty"},value:{name:"value",range:"TypeInstance",domain:"TypeInstanceProperty"},values:{name:"values",range:"TypeInstance",domain:"TypeInstanceProperty"},isArray:{name:"isArray",range:"BooleanType",domain:"TypeInstanceProperty"}}},RAMLSimpleElement:{name:"RAMLSimpleElement",properties:{}},Parameter:{name:"Parameter",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},parametrizedProperties:{name:"parametrizedProperties"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},pattern:{name:"pattern",range:"StringType",domain:"StringTypeDeclaration"},enum:{name:"enum",range:"StringType",domain:"StringTypeDeclaration"},minLength:{name:"minLength",range:"NumberType",domain:"StringTypeDeclaration"},maxLength:{name:"maxLength",range:"NumberType",domain:"StringTypeDeclaration"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},DateTypeDeclaration:{name:"DateTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"AnyType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},ParameterLocation:{name:"ParameterLocation",properties:{}},MimeType:{name:"MimeType",properties:{}},BodyLike:{name:"BodyLike",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"SchemaString",domain:"BodyLike"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"},schemaContent:{name:"schemaContent"},parametrizedProperties:{name:"parametrizedProperties"}}},XMLBody:{name:"XMLBody",
properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"XMLSchemaString",domain:"XMLBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},JSONBody:{name:"JSONBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"JSonSchemaString",domain:"JSONBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},Response:{name:"Response",properties:{code:{name:"code",range:"StatusCodeString",domain:"Response"},headers:{name:"headers",range:"Parameter",domain:"Response"},body:{name:"body",range:"BodyLike",domain:"Response"},description:{name:"description",range:"MarkdownString",domain:"Response"},parametrizedProperties:{name:"parametrizedProperties"}}},Resource:{name:"Resource",properties:{relativeUri:{name:"relativeUri",range:"RelativeUriString",domain:"Resource"},type:{name:"type",range:"ResourceTypeRef",domain:"Resource"},is:{name:"is",range:"TraitRef",domain:"Resource"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Resource"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Resource"},methods:{name:"methods",range:"Method",domain:"Resource"},resources:{name:"resources",range:"Resource",domain:"Resource"},displayName:{name:"displayName",range:"StringType",domain:"Resource"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Resource"},description:{name:"description",range:"MarkdownString",domain:"Resource"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{resourceType:{name:"resourceType"}}},ResourceType:{name:"ResourceType",properties:{name:{name:"name",range:"StringType",domain:"ResourceType"},usage:{name:"usage",range:"StringType",domain:"ResourceType"},methods:{name:"methods",range:"Method",domain:"ResourceType"},is:{name:"is",range:"TraitRef",domain:"ResourceType"},type:{name:"type",range:"ResourceTypeRef",domain:"ResourceType"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"ResourceType"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"ResourceType"},displayName:{name:"displayName",range:"StringType",domain:"ResourceType"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"ResourceType"},description:{name:"description",range:"MarkdownString",domain:"ResourceType"},parametrizedProperties:{name:"parametrizedProperties"}}},MethodBase:{name:"MethodBase",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"}}},Method:{name:"Method",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},method:{name:"method",range:"StringType",domain:"Method"},is:{name:"is",range:"TraitRef",domain:"Method"},parametrizedProperties:{name:"parametrizedProperties"}}},Trait:{name:"Trait",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},name:{name:"name",range:"StringType",domain:"Trait"},usage:{name:"usage",range:"StringType",domain:"Trait"},displayName:{name:"displayName",range:"StringType",domain:"Trait"},parametrizedProperties:{name:"parametrizedProperties"}}},TraitRef:{name:"TraitRef",properties:{trait:{name:"trait"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{responses:{name:"responses",range:"Response",domain:"SecuritySchemePart"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"SecuritySchemePart"},headers:{name:"headers",range:"Parameter",domain:"SecuritySchemePart"},description:{name:"description",range:"MarkdownString",domain:"SecuritySchemePart"},displayName:{name:"displayName",range:"StringType",domain:"SecuritySchemePart"},is:{name:"is",range:"TraitRef",domain:"SecuritySchemePart"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{securitySchemeName:{name:"securitySchemeName"},securityScheme:{name:"securityScheme"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{requestTokenUri:{name:"requestTokenUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},tokenCredentialsUri:{name:"tokenCredentialsUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{accessTokenUri:{name:"accessTokenUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationGrants:{name:"authorizationGrants",range:"StringType",domain:"OAuth2SecuritySchemeSettings"},scopes:{name:"scopes",range:"StringType",domain:"OAuth2SecuritySchemeSettings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth2SecuritySchemeSettings",domain:"OAuth2SecurityScheme"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth1SecuritySchemeSettings",domain:"OAuth1SecurityScheme"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}}},Universe10:{Library:{name:"Library",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},usage:{name:"usage"},name:{name:"name"}}},LibraryBase:{name:"LibraryBase",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"}}},Api:{name:"Api",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},RAMLVersion:{name:"RAMLVersion",range:"StringType",domain:"Api"}}},Overlay:{name:"Overlay",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},extends:{name:"extends"}}},Extension:{name:"Extension",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},extends:{name:"extends"}}},UsesDeclaration:{name:"UsesDeclaration",properties:{annotations:{name:"annotations"},key:{name:"key"},value:{name:"value"}}},FragmentDeclaration:{name:"FragmentDeclaration",properties:{annotations:{name:"annotations"},uses:{name:"uses"}}},DocumentationItem:{name:"DocumentationItem",properties:{annotations:{name:"annotations"},title:{name:"title"},content:{name:"content"}}},ValueType:{name:"ValueType",properties:{annotations:{name:"annotations"}}},StringType:{name:"StringType",properties:{annotations:{name:"annotations"}}},AnyType:{name:"AnyType",properties:{annotations:{name:"annotations"}}},NumberType:{name:"NumberType",properties:{annotations:{name:"annotations"}}},IntegerType:{name:"IntegerType",properties:{annotations:{name:"annotations"}}},NullType:{name:"NullType",properties:{annotations:{name:"annotations"}}},TimeOnlyType:{name:"TimeOnlyType",properties:{annotations:{name:"annotations"}}},DateOnlyType:{name:"DateOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeOnlyType:{name:"DateTimeOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeType:{name:"DateTimeType",properties:{annotations:{name:"annotations"}}},FileType:{name:"FileType",properties:{annotations:{name:"annotations"}}},BooleanType:{name:"BooleanType",properties:{annotations:{name:"annotations"}}},Reference:{name:"Reference",properties:{annotations:{name:"annotations"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"Reference"},name:{name:"name",range:"StringType",domain:"Reference"}}},UriTemplate:{name:"UriTemplate",properties:{annotations:{name:"annotations"}}},StatusCodeString:{name:"StatusCodeString",properties:{annotations:{name:"annotations"}}},RelativeUriString:{name:"RelativeUriString",properties:{annotations:{name:"annotations"}}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{annotations:{name:"annotations"}}},FixedUriString:{name:"FixedUriString",properties:{annotations:{name:"annotations"}}},ContentType:{name:"ContentType",properties:{annotations:{name:"annotations"}}},MarkdownString:{name:"MarkdownString",properties:{annotations:{name:"annotations"}}},SchemaString:{name:"SchemaString",properties:{annotations:{name:"annotations"}}},ExampleSpec:{name:"ExampleSpec",properties:{annotations:{name:"annotations"},value:{name:"value"},strict:{name:"strict"},name:{name:"name"},displayName:{name:"displayName"},description:{name:"description"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"ExampleSpec"}}},TypeDeclaration:{name:"TypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fixedFacets:{name:"fixedFacets",range:"TypeInstance",domain:"TypeDeclaration"},structuredType:{name:"structuredType",range:"TypeInstance",domain:"TypeDeclaration"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"TypeDeclaration"}}},XMLFacetInfo:{name:"XMLFacetInfo",properties:{annotations:{name:"annotations"},attribute:{name:"attribute"},wrapped:{name:"wrapped"},name:{name:"name"},namespace:{name:"namespace"},prefix:{name:"prefix"}}},ArrayTypeDeclaration:{name:"ArrayTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},uniqueItems:{name:"uniqueItems"},items:{name:"items"},minItems:{name:"minItems"},maxItems:{name:"maxItems"},structuredItems:{name:"structuredItems",range:"TypeInstance",domain:"ArrayTypeDeclaration"}}},UnionTypeDeclaration:{name:"UnionTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},ObjectTypeDeclaration:{name:"ObjectTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},properties:{name:"properties"},minProperties:{name:"minProperties"},maxProperties:{name:"maxProperties"},additionalProperties:{name:"additionalProperties"},discriminator:{name:"discriminator"},discriminatorValue:{name:"discriminatorValue"},enum:{name:"enum"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},pattern:{name:"pattern"},minLength:{name:"minLength"},maxLength:{name:"maxLength"},enum:{name:"enum"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},enum:{name:"enum"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},enum:{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},enum:{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},DateOnlyTypeDeclaration:{name:"DateOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},TimeOnlyTypeDeclaration:{name:"TimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeOnlyTypeDeclaration:{name:"DateTimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeTypeDeclaration:{name:"DateTimeTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},format:{name:"format"}}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties"},isScalar:{name:"isScalar"},value:{name:"value"},isArray:{name:"isArray"},items:{name:"items"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name"},value:{name:"value"},values:{name:"values"},isArray:{name:"isArray"}}},ModelLocation:{name:"ModelLocation",properties:{}},LocationKind:{name:"LocationKind",properties:{}},MimeType:{name:"MimeType",properties:{annotations:{name:"annotations"}}},Response:{name:"Response",properties:{annotations:{name:"annotations"},code:{name:"code"},headers:{name:"headers"},body:{name:"body"},description:{name:"description"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Response"}}},Annotable:{name:"Annotable",properties:{annotations:{name:"annotations"}}},AnnotationRef:{name:"AnnotationRef",properties:{annotations:{name:"annotations"},annotation:{name:"annotation",range:"TypeDeclaration",domain:"AnnotationRef"}}},AnnotationTarget:{name:"AnnotationTarget",properties:{annotations:{name:"annotations"}}},TraitRef:{name:"TraitRef",properties:{annotations:{name:"annotations"},trait:{name:"trait",range:"Trait",domain:"TraitRef"}}},Trait:{name:"Trait",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Trait"}}},MethodBase:{name:"MethodBase",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"}}},Method:{name:"Method",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},method:{name:"method"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Method"}}},Operation:{name:"Operation",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{annotations:{name:"annotations"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{annotations:{name:"annotations"},requestTokenUri:{name:"requestTokenUri"},authorizationUri:{name:"authorizationUri"},tokenCredentialsUri:{name:"tokenCredentialsUri"},signatures:{name:"signatures"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{annotations:{name:"annotations"},accessTokenUri:{name:"accessTokenUri"},authorizationUri:{name:"authorizationUri"},authorizationGrants:{name:"authorizationGrants"},scopes:{name:"scopes"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{annotations:{name:"annotations"},securitySchemeName:{name:"securitySchemeName",range:"StringType",domain:"SecuritySchemeRef"},securityScheme:{name:"securityScheme",range:"AbstractSecurityScheme",domain:"SecuritySchemeRef"}}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},PassThroughSecurityScheme:{name:"PassThroughSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{annotations:{name:"annotations"},resourceType:{name:"resourceType",range:"ResourceType",domain:"ResourceTypeRef"}}},ResourceType:{name:"ResourceType",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"ResourceType"}}},ResourceBase:{name:"ResourceBase",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"}}},Resource:{name:"Resource",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},relativeUri:{name:"relativeUri"},displayName:{name:"displayName"},resources:{name:"resources"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fileTypes:{name:"fileTypes"},minLength:{name:"minLength"},maxLength:{name:"maxLength"}}}}};e.exports=n},function(e,t){(function(e){"use strict";function n(e){return e.asElement&&e.getKind&&e.asAttr&&e.lowLevel}function r(){var t=e.ramlValidation;if(t){var n=t.nodeValidators;if(Array.isArray(n))return n}return[]}function i(){var t=e.ramlValidation;if(t){var n=t.astAnnotationValidators;if(Array.isArray(n))return n}return[]}Object.defineProperty(t,"__esModule",{value:!0});var a;!function(e){e[e.BASIC=0]="BASIC",e[e.NODE=1]="NODE",e[e.ATTRIBUTE=2]="ATTRIBUTE"}(a=t.NodeKind||(t.NodeKind={}));var o;!function(e){e[e.RAML10=0]="RAML10",e[e.RAML08=1]="RAML08"}(o=t.RAMLVersion||(t.RAMLVersion={})),t.isParseResult=n;var s;!function(e){e[e.UNRESOLVED_REFERENCE=0]="UNRESOLVED_REFERENCE",e[e.YAML_ERROR=1]="YAML_ERROR",e[e.UNKNOWN_NODE=2]="UNKNOWN_NODE",e[e.MISSING_REQUIRED_PROPERTY=3]="MISSING_REQUIRED_PROPERTY",e[e.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE=4]="PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE",e[e.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT=5]="KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT",e[e.UNABLE_TO_RESOLVE_INCLUDE_FILE=6]="UNABLE_TO_RESOLVE_INCLUDE_FILE",e[e.INVALID_VALUE_SCHEMA=7]="INVALID_VALUE_SCHEMA",e[e.MISSED_CONTEXT_REQUIREMENT=8]="MISSED_CONTEXT_REQUIREMENT",e[e.NODE_HAS_VALUE=9]="NODE_HAS_VALUE",e[e.ONLY_OVERRIDE_ALLOWED=10]="ONLY_OVERRIDE_ALLOWED",e[e.ILLEGAL_PROPERTY_VALUE=11]="ILLEGAL_PROPERTY_VALUE",e[e.ILLEGAL_PROPERTY=12]="ILLEGAL_PROPERTY",e[e.INVALID_PROPERTY=13]="INVALID_PROPERTY"}(s=t.IssueCode||(t.IssueCode={})),t.getNodeValidationPlugins=r,t.getNodeAnnotationValidationPlugins=i}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(e){var t=e;return t.valueName&&t.toHighLevel&&t.toHighLevel2}var i=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var a=n(21),o=n(20),s=n(200),u=n(4),l=n(15),p=n(204),c=n(56),f=n(205),h=n(206),d=n(16),m=n(207),y=function(){function e(e,t,n){this._parent=e,this._transformer=t,this.ramlVersion=n}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&d.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.hasInnerIncludeError=function(){
return this._originalNode.hasInnerIncludeError()},e.prototype.keyKind=function(){return this._originalNode.keyKind()},e.prototype.primaryNode=function(){return null},e.prototype.isAnnotatedScalar=function(){return this._originalNode.isAnnotatedScalar()},e.prototype.actual=function(){return this._originalNode?this._originalNode.actual():this},e.prototype.transformer=function(){return this._transformer},e.prototype.setTransformer=function(e){this._transformer=e},e.prototype.originalNode=function(){return this._originalNode},e.prototype.start=function(){return this._originalNode.start()},e.prototype.end=function(){return this._originalNode.end()},e.prototype.value=function(e){throw new Error(m.METHOD_MUST_BE_OVERRIDDEN.message)},e.prototype.includeErrors=function(){return this._originalNode.includeErrors()},e.prototype.includePath=function(){return this._originalNode.includePath()},e.prototype.includeReference=function(){return this._originalNode.includeReference()},e.prototype.setKeyOverride=function(e){this._keyOverride=e},e.prototype.setValueOverride=function(e){this._valueOverride=e},e.prototype.key=function(e){return void 0===e&&(e=!1),this._keyOverride?this._keyOverride:this._originalNode.key(e)},e.prototype.optional=function(){return this.originalNode().optional()},e.prototype.children=function(){throw new Error(m.METHOD_MUST_BE_OVERRIDDEN.message)},e.prototype.parent=function(){return this._parent},e.prototype.unit=function(){return this._originalNode.unit()},e.prototype.containingUnit=function(){return this._originalNode.containingUnit()},e.prototype.includeBaseUnit=function(){return this._originalNode.unit()},e.prototype.anchorId=function(){return this._originalNode.anchorId()},e.prototype.errors=function(){return this._originalNode.errors()},e.prototype.anchoredFrom=function(){return this._originalNode.anchoredFrom()},e.prototype.includedFrom=function(){return this._originalNode.includedFrom()},e.prototype.visit=function(e){e(this)&&this.children().forEach(function(t){return t.visit(e)})},e.prototype.addChild=function(e){},e.prototype.execute=function(e){},e.prototype.dump=function(){return null},e.prototype.dumpToObject=function(e){var t=o.serialize2(this,e);if(this.kind()==a.Kind.MAPPING){var n={};return n[this.key(!0)]=t,n}return t},e.prototype.keyStart=function(){return this._originalNode.keyStart()},e.prototype.keyEnd=function(){return this._originalNode.keyEnd()},e.prototype.valueStart=function(){return this._originalNode.valueStart()},e.prototype.valueEnd=function(){return this._originalNode.valueEnd()},e.prototype.isValueLocal=function(){return this._originalNode.isValueLocal()},e.prototype.kind=function(){return this._originalNode.kind()},e.prototype.valueKind=function(){return this._originalNode.valueKind()},e.prototype.anchorValueKind=function(){return this._originalNode.anchorValueKind()},e.prototype.resolvedValueKind=function(){return this._originalNode.resolvedValueKind()},e.prototype.show=function(e){this._originalNode.show(e)},e.prototype.setHighLevelParseResult=function(e){this._highLevelParseResult=e},e.prototype.highLevelParseResult=function(){return this._highLevelParseResult},e.prototype.setHighLevelNode=function(e){this._highLevelNode=e},e.prototype.highLevelNode=function(){return this._highLevelNode?this._highLevelNode:this._originalNode.highLevelNode()},e.prototype.text=function(e){throw new Error(m.NOT_IMPLEMENTED.message)},e.prototype.copy=function(){throw new Error(m.NOT_IMPLEMENTED.message)},e.prototype.markup=function(e){throw new Error(m.NOT_IMPLEMENTED.message)},e.prototype.nodeDefinition=function(){return u.getDefinitionForLowLevelNode(this)},e.prototype.includesContents=function(){return this._originalNode.includesContents()},e.prototype.root=function(){for(var e=this;e.parent();){var t=e.parent();e=t}return e},e.prototype.find=function(e){var t=null;return this.children().forEach(function(n){n.key()&&n.key()==e&&(t||(t=n))}),t},e.prototype.isMap=function(){return this.kind()==a.Kind.MAP},e.prototype.isMapping=function(){return this.kind()==a.Kind.MAPPING},e.prototype.isSeq=function(){return this.kind()==a.Kind.SEQ},e.prototype.isScalar=function(){return this.kind()==a.Kind.SCALAR},e.prototype.isValueSeq=function(){return this.valueKind()==a.Kind.SEQ},e.prototype.isValueMap=function(){return this.valueKind()==a.Kind.MAP},e.prototype.isValueInclude=function(){return this.valueKind()==a.Kind.INCLUDE_REF},e.prototype.isValueScalar=function(){return this.valueKind()==a.Kind.SCALAR},e.prototype.definingUnitSequence=function(){var e=h.toOriginal(this).key(),t=this.transformer();return t?t.definingUnitSequence(e):null},e.prototype.addMeta=function(e,t){this._meta=this._meta||{},this._meta[e]=t},e.prototype.getMeta=function(e){return this._meta&&this._meta[e]},e.CLASS_IDENTIFIER="LowLevelASTProxy.LowLevelProxyNode",e}();t.LowLevelProxyNode=y;var v=function(e){function t(t,n,r,i,a){void 0===a&&(a=!0);var o=e.call(this,n,r,i)||this;o.isPrimary=a,o._adoptedNodes=[],o._preserveAnnotations=!1,o.nonMergableChildren={};var s=o.parent()?o.parent().originalNode():null;return g.isInstance(t)?o._originalNode=t:o._originalNode=new g(t,s,r,o.ramlVersion),o._adoptedNodes.push(o._originalNode),o}return i(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&d.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_LowLevelCompositeNode)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_LowLevelCompositeNode)},t.prototype.originalNode=function(){return this._originalNode},t.prototype.adoptedNodes=function(){return this._adoptedNodes},t.prototype.primaryNode=function(){return this.isPrimary?this._originalNode:null},t.prototype.parent=function(){return this._parent},t.prototype.adopt=function(e,t){for(;y.isInstance(e);)e=e.originalNode();t||(t=this._transformer);var n=this.parent()?this.parent().originalNode():null,r=new g(e,n,t,this.ramlVersion);this._adoptedNodes.push(r),this._children&&this._children.forEach(function(e){return e._parent=null}),this._children=null,this.highLevelNode()&&this.highLevelNode().resetChildren()},t.prototype.value=function(e){if(this._valueOverride)return this._valueOverride;var t,n=this._adoptedNodes.filter(function(e){return null!=e.value()});if(t=n.length>0?n[0].value(e):this._originalNode.value(e),g.isInstance(t)){var r=t.key();if(r)for(var i=this;1==i.children().length&&(i.kind()==a.Kind.MAPPING||i.kind()==a.Kind.MAP||i.kind()==a.Kind.SEQ);)if(i=i.children()[0],i.originalNode().key()==r){t=i;break}this._valueOverride=t}return t},t.prototype.patchAdoptedNodes=function(e){var t=this;this._adoptedNodes=[],e.forEach(function(e){return t.adopt(e.node,e.transformer)}),this._adoptedNodes.length>0&&(this._originalNode=this._adoptedNodes[0]),this.resetChildren()},t.prototype.children=function(){var e=this;if(this._children)return this._children;for(var n=[],r=!1,i=!1,o=0,s=this._adoptedNodes;o<s.length;o++){var u=s[o],l=u.children();if(l&&l.length>0&&(i=!0,l[0].key()&&this.originalNode().valueKind()!=a.Kind.SEQ&&(r=!0)),r&&i)break}if(r)n=this.collectChildrenWithKeys();else if(i){n=this.collectChildrenWithKeys();var p={};this._adoptedNodes.forEach(function(r){return r.children().filter(function(e){return!e.key()}).forEach(function(i){var a=r==e.primaryNode(),o=e.buildKey(i);if(a||!p[o]){p[o]=!0;var s=r.transformer()?r.transformer():e.transformer(),u=g.isInstance(i)?i.originalNode():i;n.push(new t(u,e,s,e.ramlVersion,a))}})})}else n=[];return this._children=n,this._preserveAnnotations&&this._children.forEach(function(e){return e.preserveAnnotations()}),n},t.prototype.buildKey=function(e){var t=o.serialize(e),n=this.nodeDefinition();if(n&&(n.key()==p.Universe08.TraitRef||n.key()==p.Universe08.ResourceTypeRef||n.key()==p.Universe10.TraitRef||n.key()==p.Universe10.ResourceTypeRef)&&t&&"object"==typeof t){var r=Object.keys(t);r.length>0&&(t=r[0])}return null==t?"":s(t)},t.prototype.collectChildrenWithKeys=function(){for(var e=this,n=[],r={},i=0,a=this._adoptedNodes;i<a.length;i++)for(var o=a[i],s=o==this.primaryNode(),u=0,f=o.children();u<f.length;u++){var h=f[u],d=h.originalNode().key();if(!this.nonMergableChildren[d]||o==this._originalNode){if(d&&o.transformer()){var m=null!=d&&this._preserveAnnotations&&l.stringStartsWith(d,"(")&&l.stringEndsWith(d,")");m||(d=o.transformer().transform(d).value)}if(!this.skipKey(d,s)&&d){var y=r.hasOwnProperty(d)&&r[d];y||(y=[],r[d]=y),y.push({node:h.originalNode(),transformer:o.transformer(),isPrimary:s})}}}var v=this.key()&&"/"==this.key()[0],g=c.getUniverse("RAML10").type(p.Universe10.Method.name),A=g.property(p.Universe10.Method.properties.method.name).enumOptions();return Object.keys(r).forEach(function(i){var a=r[i],o=!0,s=!1,u=A.indexOf(i)>=0;if(a.forEach(function(t){var n=t.node.optional()&&("RAML10"!=e.ramlVersion||v&&u);o=o&&n,s=s||t.isPrimary}),s){var l=[];a.filter(function(e){return e.isPrimary}).forEach(function(n){var r=n.transformer?n.transformer:e.transformer();l.push(new t(n.node,e,r,e.ramlVersion,!0))});var p=l[0];a.filter(function(e){return!e.isPrimary}).forEach(function(e){p.adopt(e.node,e.transformer)}),l.forEach(function(e){return n.push(e)})}else if(!o){for(var c=a[0].transformer?a[0].transformer:e.transformer(),p=new t(a[0].node,e,c,e.ramlVersion,!1),f=1;f<a.length;f++)p.adopt(a[f].node,a[f].transformer);n.push(p)}}),n},t.prototype.isResource=function(){return this.highLevelNode()&&f.isResourceType(this.highLevelNode().definition())},t.prototype.skipKey=function(e,t){if(t)return!1;if("RAML08"!=this.ramlVersion)return!1;p.Universe08.Method,p.Universe08.Resource;return!1},t.prototype.valueKind=function(){if(this._originalNode.kind()!=a.Kind.MAPPING)return null;for(var e=0;e<this._adoptedNodes.length;e++){var t=this._adoptedNodes[e],n=t.originalNode().actual();if(n&&null!=n.value)return t.valueKind()}return null},t.prototype.includePath=function(){for(var e=0;e<this._adoptedNodes.length;e++){var t=this._adoptedNodes[e],n=t.includePath();if(null!=n)return n}return null},t.prototype.includeBaseUnit=function(){for(var t=0;t<this._adoptedNodes.length;t++){var n=this._adoptedNodes[t],r=n.includePath();if(null!=r)return n.unit()}return e.prototype.includeBaseUnit.call(this)},t.prototype.includeReference=function(){for(var e=0;e<this._adoptedNodes.length;e++){var t=this._adoptedNodes[e];if(null!=t.value())return t.includeReference()}return null},t.prototype.optional=function(){return d.all(this._adoptedNodes,function(e){return e.optional()})},t.prototype.replaceChild=function(e,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=null),this._children||(this._children=[]);var a;if(t.isInstance(n)?(a=n,a._parent=this):a=new t(n,this,null,this.ramlVersion),null==e)return this._children.push(a),a;var o=this._children.indexOf(e);return o>=0?this._children[o]=a:this._children.push(a),a},t.prototype.removeChild=function(e){if(this._children&&null!=e){var t=this._children.indexOf(e);if(t>=0){for(var n=t;n<this._children.length-1;n++)this._children[n]=this._children[n+1];this._children.pop()}}},t.prototype.setChildren=function(e){var n=this;return null==e?void(this._children=null):(this._children=e.map(function(e){return t.isInstance(e)?e:new t(e,n,null,n.ramlVersion)}),void(this._preserveAnnotations&&this._children.forEach(function(e){return e.preserveAnnotations()})))},t.prototype.resetChildren=function(){this._children=null},t.prototype.preserveAnnotations=function(){this._preserveAnnotations=!0,this._children&&this._children.forEach(function(e){return e.preserveAnnotations()})},t.prototype.filterChildren=function(){this.children();var e={},t=[];this._children.forEach(function(n){if(null!=n.key())return void t.push(n);var r=JSON.stringify(o.serialize(n));e[r]||(e[r]=!0,t.push(n))}),this._children=t},t.prototype.containingUnit=function(){for(var e={},t=0,n=this.adoptedNodes();t<n.length;t++){var r=n[t],i=r.containingUnit();i&&(e[i.absolutePath()]=!0)}return Object.keys(e).length<=1?this._originalNode.containingUnit():null},t.prototype.takeOnlyOriginalChildrenWithKey=function(e){this.nonMergableChildren[e]=!0},t.CLASS_IDENTIFIER_LowLevelCompositeNode="LowLevelASTProxy.LowLevelCompositeNode",t}(y);t.LowLevelCompositeNode=v;var g=function(e){function t(t,n,r,i){var a=e.call(this,n,r,i)||this;return a._originalNode=t,a}return i(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&d.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_LowLevelValueTransformingNode)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_LowLevelValueTransformingNode)},t.prototype.value=function(e){var n=this.originalNode().value(e),r=this.transformer();if(r){var i=r.transform(n,e);n=i.value}return null==n||"object"!=typeof n||Array.isArray(n)?(null!=n&&e&&(n=""+n),n):new t(n,this._parent,this._transformer,this.ramlVersion)},t.prototype.children=function(){var e=this,n=null,r=this.originalNode();if(null!=this._transformer){var i=this._transformer.children(r);null!=i&&(n=i)}return null==n&&(n=r.children()),n.map(function(n){return new t(n,e,e._transformer,e.ramlVersion)})},t.prototype.valueKind=function(){var t=this._transformer&&this._transformer.valueKind(this.originalNode());return null!=t?t:e.prototype.valueKind.call(this)},t.prototype.anchorValueKind=function(){var t=this._transformer&&this._transformer.anchorValueKind(this.originalNode());return null!=t?t:e.prototype.anchorValueKind.call(this)},t.prototype.resolvedValueKind=function(){var t=this._transformer&&this._transformer.resolvedValueKind(this.originalNode());return null!=t?t:e.prototype.resolvedValueKind.call(this)},t.prototype.includePath=function(){var t=this._transformer&&this._transformer.includePath(this.originalNode());return null!=t?t:e.prototype.includePath.call(this)},t.prototype.parent=function(){return this._parent},t.prototype.key=function(t){void 0===t&&(t=!1);var n=e.prototype.key.call(this,t);if(null!=this.transformer()){var r=this.transformer().transform(n).value;return u.ASTNode.isInstance(r)||y.isInstance(r)?JSON.stringify(r.dumpToObject()):"object"==typeof r?null:r}return n},t.CLASS_IDENTIFIER_LowLevelValueTransformingNode="LowLevelASTProxy.LowLevelValueTransformingNode",t}(y);t.LowLevelValueTransformingNode=g,t.isLowLevelProxyNode=r},function(e,t,n){var r="undefined"!=typeof JSON?JSON:n(201);e.exports=function(e,t){t||(t={}),"function"==typeof t&&(t={cmp:t});var n=t.space||"";"number"==typeof n&&(n=Array(n+1).join(" "));var o="boolean"==typeof t.cycles&&t.cycles,s=t.replacer||function(e,t){return t},u=t.cmp&&function(e){return function(t){return function(n,r){var i={key:n,value:t[n]},a={key:r,value:t[r]};return e(i,a)}}}(t.cmp),l=[];return function e(t,p,c,f){var h=n?"\n"+new Array(f+1).join(n):"",d=n?": ":":";if(c&&c.toJSON&&"function"==typeof c.toJSON&&(c=c.toJSON()),c=s.call(t,p,c),void 0!==c){if("object"!=typeof c||null===c)return r.stringify(c);if(i(c)){for(var m=[],y=0;y<c.length;y++){var v=e(c,y,c[y],f+1)||r.stringify(null);m.push(h+n+v)}return"["+m.join(",")+h+"]"}if(l.indexOf(c)!==-1){if(o)return r.stringify("__cycle__");throw new TypeError("Converting circular structure to JSON")}l.push(c);for(var g=a(c).sort(u&&u(c)),m=[],y=0;y<g.length;y++){var p=g[y],A=e(c,p,c[p],f+1);if(A){var E=r.stringify(p)+d+A;m.push(h+n+E)}}return l.splice(l.indexOf(c),1),"{"+m.join(",")+h+"}"}}({"":e},"",e,0)};var i=Array.isArray||function(e){return"[object Array]"==={}.toString.call(e)},a=Object.keys||function(e){var t=Object.prototype.hasOwnProperty||function(){return!0},n=[];for(var r in e)t.call(e,r)&&n.push(r);return n}},function(e,t,n){t.parse=n(202),t.stringify=n(203)},function(e,t){var n,r,i,a,o={'"':'"',"\\":"\\","/":"/",b:"\b",f:"\f",n:"\n",r:"\r",t:"\t"},s=function(e){throw{name:"SyntaxError",message:e,at:n,text:i}},u=function(e){return e&&e!==r&&s("Expected '"+e+"' instead of '"+r+"'"),r=i.charAt(n),n+=1,r},l=function(){var e,t="";for("-"===r&&(t="-",u("-"));r>="0"&&r<="9";)t+=r,u();if("."===r)for(t+=".";u()&&r>="0"&&r<="9";)t+=r;if("e"===r||"E"===r)for(t+=r,u(),"-"!==r&&"+"!==r||(t+=r,u());r>="0"&&r<="9";)t+=r,u();return e=+t,isFinite(e)?e:void s("Bad number")},p=function(){var e,t,n,i="";if('"'===r)for(;u();){if('"'===r)return u(),i;if("\\"===r)if(u(),"u"===r){for(n=0,t=0;t<4&&(e=parseInt(u(),16),isFinite(e));t+=1)n=16*n+e;i+=String.fromCharCode(n)}else{if("string"!=typeof o[r])break;i+=o[r]}else i+=r}s("Bad string")},c=function(){for(;r&&r<=" ";)u()},f=function(){switch(r){case"t":return u("t"),u("r"),u("u"),u("e"),!0;case"f":return u("f"),u("a"),u("l"),u("s"),u("e"),!1;case"n":return u("n"),u("u"),u("l"),u("l"),null}s("Unexpected '"+r+"'")},h=function(){var e=[];if("["===r){if(u("["),c(),"]"===r)return u("]"),e;for(;r;){if(e.push(a()),c(),"]"===r)return u("]"),e;u(","),c()}}s("Bad array")},d=function(){var e,t={};if("{"===r){if(u("{"),c(),"}"===r)return u("}"),t;for(;r;){if(e=p(),c(),u(":"),Object.hasOwnProperty.call(t,e)&&s('Duplicate key "'+e+'"'),t[e]=a(),c(),"}"===r)return u("}"),t;u(","),c()}}s("Bad object")};a=function(){switch(c(),r){case"{":return d();case"[":return h();case'"':return p();case"-":return l();default:return r>="0"&&r<="9"?l():f()}},e.exports=function(e,t){var o;return i=e,n=0,r=" ",o=a(),c(),r&&s("Syntax error"),"function"==typeof t?function e(n,r){var i,a,o=n[r];if(o&&"object"==typeof o)for(i in o)Object.prototype.hasOwnProperty.call(o,i)&&(a=e(o,i),void 0!==a?o[i]=a:delete o[i]);return t.call(n,r,o)}({"":o},""):o}},function(e,t){function n(e){return s.lastIndex=0,s.test(e)?'"'+e.replace(s,function(e){var t=u[e];return"string"==typeof t?t:"\\u"+("0000"+e.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+e+'"'}function r(e,t){var s,u,l,p,c,f=i,h=t[e];switch(h&&"object"==typeof h&&"function"==typeof h.toJSON&&(h=h.toJSON(e)),"function"==typeof o&&(h=o.call(t,e,h)),typeof h){case"string":return n(h);case"number":return isFinite(h)?String(h):"null";case"boolean":case"null":return String(h);case"object":if(!h)return"null";if(i+=a,c=[],"[object Array]"===Object.prototype.toString.apply(h)){for(p=h.length,s=0;s<p;s+=1)c[s]=r(s,h)||"null";return l=0===c.length?"[]":i?"[\n"+i+c.join(",\n"+i)+"\n"+f+"]":"["+c.join(",")+"]",i=f,l}if(o&&"object"==typeof o)for(p=o.length,s=0;s<p;s+=1)u=o[s],"string"==typeof u&&(l=r(u,h),l&&c.push(n(u)+(i?": ":":")+l));else for(u in h)Object.prototype.hasOwnProperty.call(h,u)&&(l=r(u,h),l&&c.push(n(u)+(i?": ":":")+l));return l=0===c.length?"{}":i?"{\n"+i+c.join(",\n"+i)+"\n"+f+"}":"{"+c.join(",")+"}",i=f,l}}var i,a,o,s=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,u={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};e.exports=function(e,t,n){var s;if(i="",a="","number"==typeof n)for(s=0;s<n;s+=1)a+=" ";else"string"==typeof n&&(a=n);if(o=t,t&&"function"!=typeof t&&("object"!=typeof t||"number"!=typeof t.length))throw new Error("JSON.stringify");return r("",{"":e})}},function(e,t,n){"use strict";var r=n(56);e.exports=r.universesInfo},function(e,t,n){"use strict";function r(e){return!!e&&(e.nameId()===Je.Universe10.Api.properties.documentation.name||e.nameId()===Je.Universe08.Api.properties.documentation.name)}function i(e){return e===Je.Universe10.Trait.properties.usage.name||e===Je.Universe08.Trait.properties.usage.name||e===Je.Universe10.ResourceType.properties.usage.name||e===Je.Universe08.ResourceType.properties.usage.name||e===Je.Universe10.Library.properties.usage.name||e===Je.Universe10.Overlay.properties.usage.name||e===Je.Universe10.Extension.properties.usage.name}function a(e){return!!e&&i(e.nameId())}function o(e){return!!e&&(e.nameId()==Je.Universe10.Overlay.properties.extends.name||e.nameId()==Je.Universe10.Extension.properties.extends.name)}function s(e){return e===Je.Universe10.TypeDeclaration.properties.description.name||"description"===e}function u(e){return!!e&&s(e.nameId())}function l(e){return e===Je.Universe10.TypeDeclaration.properties.required.name||e===Je.Universe08.Parameter.properties.required.name||"required"===e}function p(e){return e===Je.Universe10.TypeDeclaration.properties.displayName.name||"displayName"===e}function c(e){return!!e&&p(e.nameId())}function f(e){return!!e&&l(e.nameId())}function h(e){return e===Je.Universe10.Api.properties.title.name||e===Je.Universe08.Api.properties.title.name||e===Je.Universe10.DocumentationItem.properties.title.name||e===Je.Universe08.DocumentationItem.properties.title.name||e===Je.Universe10.Overlay.properties.title.name||e===Je.Universe10.Extension.properties.title.name}function d(e){return!!e&&h(e.nameId())}function m(e){return!!e&&y(e.nameId())}function y(e){return e===Je.Universe08.MethodBase.properties.headers.name||e===Je.Universe08.Response.properties.headers.name||e===Je.Universe08.SecuritySchemePart.properties.headers.name||e===Je.Universe10.MethodBase.properties.headers.name||e===Je.Universe10.Response.properties.headers.name}function v(e){return!!e&&g(e.nameId())}function g(e){return e===Je.Universe08.BodyLike.properties.formParameters.name}function A(e){return!!e&&E(e.nameId())}function E(e){return e===Je.Universe08.MethodBase.properties.queryParameters.name||e===Je.Universe08.SecuritySchemePart.properties.queryParameters.name||e===Je.Universe10.MethodBase.properties.queryParameters.name}function _(e){return!!e&&(e.nameId()===Je.Universe10.Api.properties.annotations.name||e.nameId()===Je.Universe10.TypeDeclaration.properties.annotations.name||e.nameId()===Je.Universe10.Response.properties.annotations.name)}function T(e){return!!e&&e.nameId()===Je.Universe10.AnnotationRef.properties.annotation.name}function S(e){return!!e&&(e.nameId()===Je.Universe10.MethodBase.properties.is.name||e.nameId()===Je.Universe08.Method.properties.is.name||e.nameId()===Je.Universe10.ResourceBase.properties.is.name||e.nameId()===Je.Universe08.ResourceType.properties.is.name||e.nameId()===Je.Universe08.Resource.properties.is.name)}function N(e){return!!e&&(e.nameId()===Je.Universe10.Api.properties.securedBy.name||e.nameId()===Je.Universe08.Api.properties.securedBy.name||e.nameId()===Je.Universe10.MethodBase.properties.securedBy.name||e.nameId()===Je.Universe08.MethodBase.properties.securedBy.name||e.nameId()===Je.Universe08.ResourceType.properties.securedBy.name||e.nameId()===Je.Universe08.Resource.properties.securedBy.name||e.nameId()===Je.Universe10.ResourceBase.properties.securedBy.name)}function I(e){return!!e&&(e.nameId()===Je.Universe10.LibraryBase.properties.securitySchemes.name||e.nameId()===Je.Universe08.Api.properties.securitySchemes.name)}function b(e){return!!e&&(e.nameId()===Je.Universe10.SecuritySchemeRef.properties.securityScheme.name||e.nameId()===Je.Universe08.SecuritySchemeRef.properties.securityScheme.name)}function R(e){return M(e)||k(e)}function M(e){return!!e&&(e.nameId()===Je.Universe10.AbstractSecurityScheme.properties.type.name||e.nameId()===Je.Universe08.AbstractSecurityScheme.properties.type.name||e.nameId()===Je.Universe08.ResourceType.properties.type.name||e.nameId()===Je.Universe08.Resource.properties.type.name||e.nameId()===Je.Universe08.Parameter.properties.type.name||e.nameId()===Je.Universe10.ResourceBase.properties.type.name||e.nameId()===Je.Universe10.TypeDeclaration.properties.type.name)}function C(e){return!!e&&e.nameId()===Je.Universe10.ArrayTypeDeclaration.properties.items.name}function w(e){return!!e&&e.nameId()===Je.Universe10.ArrayTypeDeclaration.properties.structuredItems.name}function P(e){return!!e&&e.nameId()===Je.Universe10.ObjectTypeDeclaration.properties.properties.name}function L(e){return!!e&&(e.nameId()===Je.Universe10.MethodBase.properties.responses.name||e.nameId()===Je.Universe08.MethodBase.properties.responses.name)}function O(e){return!!e&&(e.nameId()===Je.Universe10.Api.properties.protocols.name||e.nameId()===Je.Universe08.Api.properties.protocols.name||e.nameId()===Je.Universe10.MethodBase.properties.protocols.name)}function D(e){return!!e&&(e.nameId()===Je.Universe10.TypeDeclaration.properties.name.name||e.nameId()===Je.Universe10.TypeDeclaration.properties.name.name||e.nameId()===Je.Universe08.AbstractSecurityScheme.properties.name.name||e.nameId()===Je.Universe10.AbstractSecurityScheme.properties.name.name||e.nameId()===Je.Universe08.Trait.properties.name.name||e.nameId()===Je.Universe10.Trait.properties.name.name||"name"===e.nameId())}function U(e){return!!e&&(e.nameId()===Je.Universe10.MethodBase.properties.body.name||e.nameId()===Je.Universe08.MethodBase.properties.body.name||e.nameId()===Je.Universe10.Response.properties.body.name||e.nameId()===Je.Universe08.Response.properties.body.name)}function x(e){return!!e&&(e.nameId()===Je.Universe10.TypeDeclaration.properties.default.name||e.nameId()===Je.Universe08.Parameter.properties.default.name)}function k(e){return!!e&&(e.nameId()===Je.Universe08.BodyLike.properties.schema.name||e.nameId()===Je.Universe08.XMLBody.properties.schema.name||e.nameId()===Je.Universe08.JSONBody.properties.schema.name||e.nameId()===Je.Universe10.TypeDeclaration.properties.schema.name)}function F(e){return!!e&&(e.nameId()===Je.Universe08.Api.properties.traits.name||e.nameId()===Je.Universe10.LibraryBase.properties.traits.name)}function B(e){return!!e&&(e.nameId()===Je.Universe08.TraitRef.properties.trait.name||e.nameId()===Je.Universe10.TraitRef.properties.trait.name)}function V(e){return!!e&&(e.nameId()===Je.Universe08.Api.properties.resourceTypes.name||e.nameId()===Je.Universe10.LibraryBase.properties.resourceTypes.name)}function K(e){return!!e&&(e.nameId()===Je.Universe08.ResourceTypeRef.properties.resourceType.name||e.nameId()===Je.Universe10.ResourceTypeRef.properties.resourceType.name)}function j(e){return!!e&&e.nameId()===Je.Universe10.TypeDeclaration.properties.facets.name}function W(e){return!!e&&(e.nameId()===Je.Universe08.Api.properties.schemas.name||e.nameId()===Je.Universe10.LibraryBase.properties.schemas.name)}function H(e){return!!e&&(e.nameId()===Je.Universe10.Api.properties.resources.name||e.nameId()===Je.Universe08.Api.properties.resources.name||e.nameId()===Je.Universe10.Resource.properties.resources.name||e.nameId()===Je.Universe08.Resource.properties.resources.name)}function Y(e){return!!e&&(e.nameId()===Je.Universe10.ResourceBase.properties.methods.name||e.nameId()===Je.Universe08.Resource.properties.methods.name||e.nameId()===Je.Universe08.ResourceType.properties.methods.name)}function q(e){return e&&e.nameId()===Je.Universe10.LibraryBase.properties.types.name}function G(e){return!!e&&(e.nameId()===Je.Universe10.TypeDeclaration.properties.example.name||"example"===e.nameId())}function X(e){return!!e&&(e.nameId()===Je.Universe10.StringTypeDeclaration.properties.enum.name||e.nameId()===Je.Universe10.NumberTypeDeclaration.properties.enum.name||e.nameId()===Je.Universe08.StringTypeDeclaration.properties.enum.name)}function z(e){return!!e&&(e.nameId()===Je.Universe10.TypeDeclaration.properties.example.name||e.nameId()===Je.Universe10.TypeDeclaration.properties.examples.name)}function $(e){return!!e&&e.nameId()===Je.Universe08.GlobalSchema.properties.value.name}function J(e){return!!e&&(e.nameId()===Je.Universe08.Api.properties.uriParameters.name||e.nameId()===Je.Universe08.ResourceType.properties.uriParameters.name||e.nameId()===Je.Universe08.Resource.properties.uriParameters.name||e.nameId()===Je.Universe10.ResourceBase.properties.uriParameters.name)}function Q(e){return!!e&&(e.nameId()===Je.Universe08.Resource.properties.baseUriParameters.name||e.nameId()===Je.Universe08.Api.properties.baseUriParameters.name||e.nameId()===Je.Universe10.Api.properties.baseUriParameters.name)}function Z(e){return!!e&&(e.nameId()===Je.Universe08.Api.properties.RAMLVersion.name||e.nameId()===Je.Universe10.Api.properties.RAMLVersion.name)}function ee(e){return!!e&&e.nameId()===Je.Universe10.FragmentDeclaration.properties.uses.name}function te(e){return!!e&&e.nameId()===Je.Universe10.LibraryBase.properties.annotationTypes.name}function ne(e){return e.key()==Je.Universe10.Method||e.key()==Je.Universe08.Method}function re(e){return e.key()==Je.Universe10.Api||e.key()==Je.Universe08.Api}function ie(e){return e.key()==Je.Universe10.BooleanType||e.key()==Je.Universe08.BooleanType}function ae(e){return e.key()==Je.Universe10.MarkdownString||e.key()==Je.Universe08.MarkdownString}function oe(e){return e.key()==Je.Universe10.Resource||e.key()==Je.Universe08.Resource}function se(e){return e.key()==Je.Universe10.Trait||e.key()==Je.Universe08.Trait}function ue(e){return e.key()==Je.Universe10.TraitRef||e.key()==Je.Universe08.TraitRef}function le(e){return e.key()==Je.Universe10.ResourceTypeRef||e.key()==Je.Universe08.ResourceTypeRef}function pe(e){return e.key()==Je.Universe08.GlobalSchema}function ce(e){return e.key()==Je.Universe10.AbstractSecurityScheme||e.key()==Je.Universe08.AbstractSecurityScheme}function fe(e){return e.isAssignableFrom(Je.Universe10.AbstractSecurityScheme.name)}function he(e){return e.key()==Je.Universe10.SecuritySchemeRef||e.key()==Je.Universe08.SecuritySchemeRef}function de(e){return e.key()==Je.Universe10.TypeDeclaration}function me(e){return e.key()==Je.Universe10.Response||e.key()==Je.Universe08.Response}function ye(e){return e.key()==Je.Universe08.BodyLike}function ve(e){return e.key()==Je.Universe10.Overlay}function ge(e){return!1}function Ae(e){return e.key()==Je.Universe10.ResourceType||e.key()==Je.Universe08.ResourceType}function Ee(e){return e.key()==Je.Universe10.SchemaString||e.key()==Je.Universe08.SchemaString}function _e(e){return e.key()==Je.Universe10.MethodBase||e.key()==Je.Universe08.MethodBase}function Te(e){return e.key()==Je.Universe10.Library}function Se(e){return e.key()==Je.Universe10.StringType||e.key()==Je.Universe08.StringType}function Ne(e){return e.key()==Je.Universe10.AnyType||e.key()==Je.Universe08.AnyType}function Ie(e){return e.key()==Je.Universe10.ExampleSpec}function be(e){return e.key()==Je.Universe10.Extension}function Re(e){return e.isAssignableFrom(Je.Universe10.TypeDeclaration.name)}function Me(e){return e.key()==Je.Universe10.DocumentationItem||e.key()==Je.Universe08.DocumentationItem}function Ce(e){return e.isAssignableFrom(Je.Universe10.AnnotationRef.name)}function we(e){return e.isAssignableFrom(Je.Universe10.Api.name)||e.isAssignableFrom(Je.Universe08.Api.name)}function Pe(e){return e.isAssignableFrom(Je.Universe10.LibraryBase.name)}function Le(e){return e.isAssignableFrom(Je.Universe10.ResourceBase.name)||e.isAssignableFrom(Je.Universe08.Resource.name)}function Oe(e){return e.isAssignableFrom(Je.Universe10.ObjectTypeDeclaration.name)}function De(e){return e.isAssignableFrom(Je.Universe10.ArrayTypeDeclaration.name)}function Ue(e){return e.isAssignableFrom(Je.Universe10.TypeDeclaration.name)}function xe(e){return e.isAssignableFrom(Je.Universe08.Parameter.name)}function ke(e){return e.isAssignableFrom(Je.Universe10.StringTypeDeclaration.name)}function Fe(e){return e.isAssignableFrom(Je.Universe10.StringType.name)}function Be(e){return e.isAssignableFrom(Je.Universe10.TypeDeclaration.name)}function Ve(e){return e.isAssignableFrom(Je.Universe10.MethodBase.name)||e.isAssignableFrom(Je.Universe08.MethodBase.name)}function Ke(e){return e.key()==Je.Universe10.SecuritySchemePart||e.key()==Je.Universe08.SecuritySchemePart}function je(e){return e.nameId()===Je.Universe08.Api.properties.mediaType.name||e.nameId()===Je.Universe10.Api.properties.mediaType.name}function We(e){return"RAML08"==e.universe().version()}function He(e){return"RAML10"==e.universe().version()}function Ye(e){return We(e.definition())}function qe(e){return We(e.definition())}function Ge(e){return He(e.definition())}function Xe(e){return He(e.definition())}function ze(e){return A(e)||m(e)||J(e)||Q(e)}function $e(e){return Ae(e)||se(e)||Ie(e)||ce(e)||Ue(e)}Object.defineProperty(t,"__esModule",{value:!0});var Je=n(204);t.isDocumentationProperty=r,t.isUsagePropertyName=i,t.isUsageProperty=a,t.isMasterRefProperty=o,t.isDescriptionPropertyName=s,
t.isDescriptionProperty=u,t.isRequiredPropertyName=l,t.isDisplayNamePropertyName=p,t.isDisplayNameProperty=c,t.isRequiredProperty=f,t.isTitlePropertyName=h,t.isTitleProperty=d,t.isHeadersProperty=m,t.isHeadersPropertyName=y,t.isFormParametersProperty=v,t.isFormParametersPropertyName=g,t.isQueryParametersProperty=A,t.isQueryParametersPropertyName=E,t.isAnnotationsProperty=_,t.isAnnotationProperty=T,t.isIsProperty=S,t.isSecuredByProperty=N,t.isSecuritySchemesProperty=I,t.isSecuritySchemeProperty=b,t.isTypeOrSchemaProperty=R,t.isTypeProperty=M,t.isItemsProperty=C,t.isStructuredItemsProperty=w,t.isPropertiesProperty=P,t.isResponsesProperty=L,t.isProtocolsProperty=O,t.isNameProperty=D,t.isBodyProperty=U,t.isDefaultValue=x,t.isSchemaProperty=k,t.isTraitsProperty=F,t.isTraitProperty=B,t.isResourceTypesProperty=V,t.isResourceTypeProperty=K,t.isFacetsProperty=j,t.isSchemasProperty=W,t.isResourcesProperty=H,t.isMethodsProperty=Y,t.isTypesProperty=q,t.isExampleProperty=G,t.isEnumProperty=X,t.isExamplesProperty=z,t.isValueProperty=$,t.isUriParametersProperty=J,t.isBaseUriParametersProperty=Q,t.isRAMLVersionProperty=Z,t.isUsesProperty=ee,t.isAnnotationTypesProperty=te,t.isMethodType=ne,t.isApiType=re,t.isBooleanTypeType=ie,t.isMarkdownStringType=ae,t.isResourceType=oe,t.isTraitType=se,t.isTraitRefType=ue,t.isResourceTypeRefType=le,t.isGlobalSchemaType=pe,t.isSecuritySchemaType=ce,t.isSecuritySchemaTypeDescendant=fe,t.isSecuritySchemeRefType=he,t.isTypeDeclarationType=de,t.isResponseType=me,t.isBodyLikeType=ye,t.isOverlayType=ve,t.isAnnotationTypeType=ge,t.isResourceTypeType=Ae,t.isSchemaStringType=Ee,t.isMethodBaseType=_e,t.isLibraryType=Te,t.isStringTypeType=Se,t.isAnyTypeType=Ne,t.isExampleSpecType=Ie,t.isExtensionType=be,t.isTypeDeclarationTypeOrDescendant=Re,t.isDocumentationType=Me,t.isAnnotationRefTypeOrDescendant=Ce,t.isApiSibling=we,t.isLibraryBaseSibling=Pe,t.isResourceBaseSibling=Le,t.isObjectTypeDeclarationSibling=Oe,t.isArrayTypeDeclarationSibling=De,t.isTypeDeclarationDescendant=Ue,t.isParameterDescendant=xe,t.isStringTypeDeclarationDescendant=ke,t.isStringTypeDescendant=Fe,t.isTypeDeclarationSibling=Be,t.isMethodBaseSibling=Ve,t.isSecuritySchemePartType=Ke,t.isMediaTypeProperty=je,t.isRAML08Type=We,t.isRAML10Type=He,t.isRAML08Node=Ye,t.isRAML08Attribute=qe,t.isRAML10Node=Ge,t.isRAML10Attribute=Xe,t.isParametersProperty=ze,t.canBeFragment=$e},function(e,t,n){"use strict";function r(e){if(null==e||"string"!=typeof e)return{status:S.NOT_REQUIRED};for(var t="",n={},r=0,i=e.indexOf("<<");i>=0;i=e.indexOf("<<",r)){if(t+=e.substring(r,i),r=e.indexOf(">>",i),r<0)return{status:S.ERROR};r+=">>".length;var a=e.substring(i,r),o=N+i+N;n[o]=a,t+=o}return 0==t.length?{status:S.NOT_REQUIRED}:(t+=e.substring(r,e.length),{resultingString:t,substitutions:n,status:S.OK})}function i(e,t){if(null==e)return{status:S.NOT_REQUIRED};for(var n="",r=0,i=e.indexOf(N);i>=0;i=e.indexOf(N,r)){if(n+=e.substring(r,i),r=e.indexOf(N,i+1),r<0)return{status:S.ERROR};r+=N.length;var a=e.substring(i,r),o=t[a];if(null==o)return{status:S.ERROR};n+=o}return 0==n.length?{status:S.NOT_REQUIRED}:(n+=e.substring(r,e.length),{resultingString:n,substitutions:t,status:S.OK})}function a(e){var t=!1;if(!e)return!1;if("?"==e.charAt(e.length-1))t=!0;else for(var n=0;n<e.length;n++){var r=e.charAt(n);if("|"==r||"("==r||"["==r){t=!0;break}}return t}function o(e){var t=e.parent&&e.parent();return t=t&&t.parent&&t.parent(),t=t&&t.parent&&t.parent(),t=t&&t.parent&&t.parent(),t&&t.key&&t.key()===E.Universe10.Api.properties.resourceTypes.name}function s(e,t,n){var r=e.lowLevel(),i=e.definition().universe().version(),a=l(r),s=o(a),p=E.Universe10.MethodBase.properties.is.name,c=_.find(r.children(),function(e){return e.key()==p}),f=c;if(null==f){var h=new v.ASTNode(y.newMapping(y.newScalar(p),y.newItems()),a.unit(),a,null,null);f=r.replaceChild(null,h)}var d=s?null:_.find(a.children(),function(e){return e.key()==p}),g=null!=d&&d.unit().absolutePath()==n?d.children():[],S=g.concat(t.map(function(e){var t=u(e.node,f);if(null!=t){var n=new A.LowLevelCompositeNode(t,f,e.transformer,i);return n}return null})).filter(function(e){return null!=e});if(0==S.length&&t.length<=1)return c;f.setChildren(S),f.filterChildren(),S=f.children();var N=e.directChildren(),I=e.definition().property("is"),b=I.range();N&&(N=N.filter(function(e){var t=e.property();return null==t||!T.isIsProperty(t)}),e._children=N.concat(S.map(function(t){return new m.ASTPropImpl(t,e,b,I)})));var R=e.children();return R&&(R=R.filter(function(e){var t=e.property();return null==t||!T.isIsProperty(t)}),e._mergedChildren=R.concat(S.map(function(t){return new m.ASTPropImpl(t,e,b,I)}))),f}function u(e,t){t=l(t),e=l(e);var n=e.actual();if(null==n)return null;if(e.key()==E.Universe10.MethodBase.properties.is.name&&(n=e.yamlNode().value),null==n)return null;if(n.kind==y.Kind.SEQ&&(n=n.items[0]),null==n)return null;var r=new v.ASTNode(n,e.unit(),t,null,null);return r}function l(e){for(var t=0;t<2&&A.LowLevelProxyNode.isInstance(e);t++)e=e.originalNode();return e}function p(e){return!!e&&(null!=e.namespace&&"function"==typeof e.namespace&&null!=e.name&&"function"==typeof e.name&&null!=e.collectionName&&"function"==typeof e.collectionName&&null!=e.referencedUnit&&"function"==typeof e.referencedUnit&&null!=e.mode&&"function"==typeof e.mode)}function c(e,t,n){var r=n[0].project().namespaceResolver();if(!e)return null;var i="",a=e,o=e.lastIndexOf(".");o>=0&&(i=e.substring(0,o),a=e.substring(o+1));for(var s,u=!1,l=n.length;l>0;l--){var p=n[l-1],c=p.highLevel();if(c.isElement()&&T.isLibraryType(c.asElement().definition())){if(u)break;u=!0}var f=p;if(i){f=null;var h=r.nsMap(p);if(h){var d=h[i];d&&(f=d.unit)}}if(f){var m=f.highLevel();if(m&&m.isElement()&&(s=_.find(m.asElement().elementsOfKind(t),function(e){return e.name()==a})))break}}return s}function f(e){var t=e.indexOf("<<");if(t<0)return!1;if(0!=t)return!0;var n=e.indexOf(">>",t);return n+">>".length!=e.length}function h(e){var t,n=e.getExtra("SOURCE");if(m.LowLevelWrapperForTypeSystem.isInstance(n))t=n.node();else if(m.ASTNodeImpl.isInstance(n))t=n.lowLevel();else if(v.ASTNode.isInstance(n)||A.LowLevelProxyNode.isInstance(n)||g.AstNode.isInstance(n));if(!t)return null;var r=t.unit();return r}Object.defineProperty(t,"__esModule",{value:!0});var d,m=n(55),y=n(21),v=n(4),g=n(20),A=n(199),E=n(204),_=n(16),T=n(205);!function(e){e[e.DEFAULT=0]="DEFAULT",e[e.PATH=1]="PATH"}(d=t.PatchMode||(t.PatchMode={}));var S;!function(e){e[e.OK=0]="OK",e[e.NOT_REQUIRED=1]="NOT_REQUIRED",e[e.ERROR=2]="ERROR"}(S=t.ParametersEscapingStatus||(t.ParametersEscapingStatus={}));var N="__P_A_R_A_M_E_T_E_R__";t.escapeTemplateParameters=r,t.unescapeTemplateParameters=i,t.checkExpression=a,t.patchMethodIs=s,t.prepareTraitRefNode=u,t.toOriginal=l;var I=function(){function e(e,t,n,r,i,a){this._namespace=e,this._name=t,this._collectionName=n,this._referencedUnit=r,this._isChained=i,this._mode=a,this.gotQuestion=!1;var o=this._name.length;"string"!=typeof this._name&&(this._name=""+this._name),this._name&&"?"==this._name.charAt(o-1)&&(this.gotQuestion=!0,this._name=this._name.substring(0,o-1))}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&_.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER_PatchedReference)},e.prototype.getClassIdentifier=function(){return[e.CLASS_IDENTIFIER_PatchedReference]},e.prototype.namespace=function(){return this._namespace},e.prototype.name=function(){return this._name},e.prototype.collectionName=function(){return this._collectionName},e.prototype.referencedUnit=function(){return this._referencedUnit},e.prototype.mode=function(){return this._mode},e.prototype.value=function(){if(null==this._namespace)return this._name;var e=this._mode==d.PATH?"/":".";return this._namespace+e+this._name+(this.gotQuestion?"?":"")},e.prototype.isChained=function(){return this._isChained},e.CLASS_IDENTIFIER_PatchedReference="referencePatcher.PatchedReference",e}();t.PatchedReference=I,t.instanceOfPatchedReference=p;(function(){function e(e){this.name=e,this.array=[]}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&_.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.CLASS_IDENTIFIER="referencePatcher.ElementsCollection",e})(),function(){function e(e){this.unit=e}return e}();t.getDeclaration=c,t.isCompoundValue=f;t.typeUnit=h},function(e,t){e.exports={34:{code:"34",message:""},INVALID_PARAMETER_NAME:{code:"INVALID_PARAMETER_NAME",message:"Invalid parameter name: '{{paramName}}' is reserved"},UNUSED_PARAMETER:{code:"UNUSED_PARAMETER",message:"Unused parameter: '{{paramName}}'"},UNUSED_PARAMETER_MISSING_SEPARATING_SPACE:{code:"UNUSED_PARAMETER_MISSING_SEPARATING_SPACE",message:"Unused parameter: '{{paramName}}'. Probably, separating space is missing after colon and supposed mapping is '{{correctMapping}}'"},INVALID_PROPERTY_OWNER_TYPE:{code:"INVALID_PROPERTY_OWNER_TYPE",message:"Property '{{propName}}' can only be used if type is {{namesStr}}"},NODE_KEY_IS_A_MAP:{code:"NODE_KEY_IS_A_MAP",message:"Node key can not be a map"},NODE_KEY_IS_A_SEQUENCE:{code:"NODE_KEY_IS_A_SEQUENCE",message:"Node key can not be a sequence"},SEQUENCE_REQUIRED:{code:"SEQUENCE_REQUIRED",message:"Node: '{{name}}' should be wrapped in sequence"},PROPERTY_MUST_BE_A_MAP_10:{code:"PROPERTY_MUST_BE_A_MAP_10",message:"'{{propName}}' should be a map in RAML 1.0"},PROPERTY_MUST_BE_A_MAP:{code:"PROPERTY_MUST_BE_A_MAP",message:"Property '{{propName}}' should be a map"},PROPERTY_MUST_BE_A_SEQUENCE:{code:"PROPERTY_MUST_BE_A_SEQUENCE",message:"Property '{{propName}}' should be a sequence"},INVALID_PROPERTY_RANGE:{code:"INVALID_PROPERTY_RANGE",message:"Property '{{propName}}' must be a {{range}}"},MAP_REQUIRED:{code:"MAP_REQUIRED",message:"should be a map in RAML 1.0"},UNRESOLVED_REFERENCE:{code:"UNRESOLVED_REFERENCE",message:"Reference: '{{ref}}' can not be resolved"},SCALAR_PROHIBITED:{code:"SCALAR_PROHIBITED",message:"Property '{{propName}}' can not have scalar value"},UNKNOWN_NODE:{code:"UNKNOWN_NODE",message:"Unknown node: '{{name}}'"},INVALID_PROPERTY_USAGE:{code:"INVALID_PROPERTY_USAGE",message:"{{ramlVersion}} does not allow using '{{propName}}' property within {{typeName | !pluralize |!sentencecase | !lowercase}}"},INVALID_SUBRESOURCE_USAGE:{code:"INVALID_SUBRESOURCE_USAGE",message:"Subresources are not allowed in {{typeName | !pluralize |!sentencecase | !lowercase}}"},INVALID_METHOD_USAGE:{code:"INVALID_METHOD_USAGE",message:"Declaring methods is not allowed in {{typeName | !pluralize |!sentencecase | !lowercase}}"},RECURSIVE_DEFINITION:{code:"RECURSIVE_DEFINITION",message:"Recursive definition: '{{name}}'"},QUERY_STRING_AND_QUERY_PARAMETERS_ARE_MUTUALLY_EXCLUSIVE:{code:"QUERY_STRING_AND_QUERY_PARAMETERS_ARE_MUTUALLY_EXCLUSIVE",message:"'queryString' and 'queryParameters' properties are mutually exclusive. '{{propName}}' is already specified."},ISSUES_IN_THE_LIBRARY:{code:"ISSUES_IN_THE_LIBRARY",message:"Issues in the used library: '{{value}}'"},INVALID_LIBRARY_PATH:{code:"INVALID_LIBRARY_PATH",message:"Can not resolve library from path: '{{path}}'"},EMPTY_FILE:{code:"EMPTY_FILE",message:"Empty file: {{path}}"},SPACES_IN_KEY:{code:"SPACES_IN_KEY",message:"Keys should not have spaces '{{value}}'"},INCLUDE_ERROR:{code:"INCLUDE_ERROR",message:"{{msg}}"},PATH_EXCEEDS_ROOT:{code:"PATH_EXCEEDS_ROOT",message:"Resolved include path exceeds file system root"},ILLEGAL_PATTERN:{code:"ILLEGAL_PATTERN",message:"Illegal pattern: '{{value}}'"},UNKNOWN_FUNCTION:{code:"UNKNOWN_FUNCTION",message:"Unknown function applied to parameter: '{{transformerName}}'"},REQUEST_BODY_DISABLED:{code:"REQUEST_BODY_DISABLED",message:"Request body is disabled for '{{methodName}}' method."},SCALAR_EXPECTED:{code:"SCALAR_EXPECTED",message:"Scalar is expected here"},UNKNOWN_ANNOTATION:{code:"UNKNOWN_ANNOTATION",message:"Unknown annotation: '{{aName}}'"},SECUREDBY_LIST_08:{code:"SECUREDBY_LIST_08",message:"'securedBy' should be a list in RAML08"},INVALID_ANNOTATION_LOCATION:{code:"INVALID_ANNOTATION_LOCATION",message:"Annotation '{{aName}}' can not be placed at this location, allowed targets are: {{aValues}}"},BOOLEAN_EXPECTED:{code:"BOOLEAN_EXPECTED",message:"'true' or 'false' is expected here"},NUMBER_EXPECTED:{code:"NUMBER_EXPECTED",message:"Value of '{{propName}}' must be a number"},STATUS_MUST_BE_3NUMBER:{code:"STATUS_MUST_BE_3NUMBER",message:"Status code should be 3 digits number."},EMPTY_VALUE_NOT_ALLOWED:{code:"EMPTY_VALUE_NOT_ALLOWED",message:"Empty value is not allowed here"},INVALID_VALUE_SCHEMA:{code:"INVALID_VALUE_SCHEMA",message:"Invalid value schema: '{{iValue}}'"},INVALID_VALUE:{code:"INVALID_VALUE",message:"Invalid value: '{{iValue}}'. Allowed values are: {{aValues}}"},SCHEMA_EXCEPTION:{code:"SCHEMA_EXCEPTION",message:"Schema exception: {{msg}}"},SCHEMA_ERROR:{code:"SCHEMA_ERROR",message:"{{msg}}"},MISSING_VERSION:{code:"MISSING_VERSION",message:"Missing 'version'"},URI_PARAMETER_NAME_MISSING:{code:"URI_PARAMETER_NAME_MISSING",message:"URI parameter must have name specified"},URI_EXCEPTION:{code:"URI_EXCEPTION",message:"{{msg}}"},INVALID_MEDIATYPE:{code:"INVALID_MEDIATYPE",message:"Invalid media type '{{mediaType}}'"},MEDIATYPE_EXCEPTION:{code:"MEDIATYPE_EXCEPTION",message:"{{msg}}"},FORM_IN_RESPONSE:{code:"FORM_IN_RESPONSE",message:"Form related media types can not be used in responses"},UNUSED_URL_PARAMETER:{code:"UNUSED_URL_PARAMETER",message:"Unused url parameter {{paramName}}"},UNRECOGNIZED_ELEMENT:{code:"UNRECOGNIZED_ELEMENT",message:"Unrecognized {{referencedToName}}: '{{ref}}'."},TYPES_VARIETY_RESTRICTION:{code:"TYPES_VARIETY_RESTRICTION",message:"Type can be either of: string, number, integer, file, date or boolean"},UNRECOGNIZED_SECURITY_SCHEME:{code:"UNRECOGNIZED_SECURITY_SCHEME",message:"Unrecognized security scheme type: '{{ref}}'. Allowed values are: 'OAuth 1.0', 'OAuth 2.0', 'Basic Authentication', 'DigestSecurityScheme Authentication', 'x-{other}'"},DUPLICATE_TRAIT_REFERENCE:{code:"DUPLICATE_TRAIT_REFERENCE",message:"Duplicate trait reference: '{{refValue}}'."},IS_IS_ARRAY:{code:"IS_IS_ARRAY",message:"Property 'is' must be an array"},RESOURCE_TYPE_NAME:{code:"RESOURCE_TYPE_NAME",message:"Resource type name must be provided"},MULTIPLE_RESOURCE_TYPES:{code:"MULTIPLE_RESOURCE_TYPES",message:"A resource or resourceType can inherit from a single resourceType"},UNKNOWN_RAML_VERSION:{code:"UNKNOWN_RAML_VERSION",message:"Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'"},UNKNOWN_TOPL_LEVEL_TYPE:{code:"UNKNOWN_TOPL_LEVEL_TYPE",message:"Unknown top level type: '{{typeName}}'"},REDUNDANT_FRAGMENT_NAME:{code:"REDUNDANT_FRAGMENT_NAME",message:"Redundant fragment name: '{{typeName}}'"},CONTEXT_REQUIREMENT_VIOLATION:{code:"CONTEXT_REQUIREMENT_VIOLATION",message:"{{v1}} should be {{v2}} to use type {{v3}}"},WEB_FORMS:{code:"WEB_FORMS",message:"File type can be only used in web forms"},MISSING_REQUIRED_PROPERTY:{code:"MISSING_REQUIRED_PROPERTY",message:"Missing required property '{{propName}}'"},VALUE_FOR_REQUIRED_PROPERTY_NOT_PROVIDED:{code:"VALUE_FOR_REQUIRED_PROPERTY_NOT_PROVIDED",message:"Value is not provided for required property '{{propName}}'"},VALUE_NOT_PROVIDED:{code:"VALUE_NOT_PROVIDED",message:"Value is not provided for parameter: '{{propName}}'"},SUSPICIOUS_DOUBLEQUOTE:{code:"SUSPICIOUS_DOUBLEQUOTE",message:'Suspicious double quoted multiline scalar, it is likely that you forgot closing "{{value}}'},ANNOTATION_TARGET_MUST_BE_A_STRING:{code:"ANNOTATION_TARGET_MUST_BE_A_STRING",message:"Annotation target must be set by a string"},ALLOWED_TARGETS_MUST_BE_ARRAY:{code:"ALLOWED_TARGETS_MUST_BE_ARRAY",message:"'allowedTargets' property value must be an array of type names or a single type name"},UNSUPPORTED_ANNOTATION_TARGET:{code:"UNSUPPORTED_ANNOTATION_TARGET",message:"Unsupported annotation target: '{{aTarget}}'"},SCHEMA_NAME_MUST_BE_STRING:{code:"SCHEMA_NAME_MUST_BE_STRING",message:"Schema '{{name}}' must be a string"},FORM_PARAMS_IN_RESPONSE:{code:"FORM_PARAMS_IN_RESPONSE",message:"Form parameters can not be used in response"},FORM_PARAMS_WITH_EXAMPLE:{code:"FORM_PARAMS_WITH_EXAMPLE",message:"'formParameters' property cannot be used together with the 'example' or 'schema' properties"},AUTHORIZATION_GRANTS_ENUM:{code:"AUTHORIZATION_GRANTS_ENUM",message:"'authorizationGrants' value should be one of 'authorization_code', 'implicit', 'password', 'client_credentials' or to be an abolute URI"},AUTHORIZATION_URI_REQUIRED:{code:"AUTHORIZATION_URI_REQUIRED",message:"'authorizationUri' is required when `authorization_code` or `implicit` grant type are used "},REPEATING_COMPONENTS_IN_ENUM:{code:"REPEATING_COMPONENTS_IN_ENUM",message:"'enum' value contains repeating components"},INTEGER_EXPECTED:{code:"INTEGER_EXPECTED",message:"Integer is expected"},NUMBER_EXPECTED_2:{code:"NUMBER_EXPECTED_2",message:"Number is expected"},RESOURCE_TYPE_NULL:{code:"RESOURCE_TYPE_NULL",message:"Resource type can not be null"},SCALAR_PROHIBITED_2:{code:"SCALAR_PROHIBITED_2",message:"Node '{{name}}' can not be a scalar"},VERSION_NOT_ALLOWED:{code:"VERSION_NOT_ALLOWED",message:"'version' parameter not allowed here",comment:"I dont like the message, but its coming from JS 0.8 parser @Denis"},INVALID_OVERLAY_NODE:{code:"INVALID_OVERLAY_NODE",message:"The '{{nodeId}}' node does not match any node of the master api."},INVALID_OVERRIDE_IN_OVERLAY:{code:"INVALID_OVERRIDE_IN_OVERLAY",message:"Property '{{propName}}' is not allowed to be overriden or added in overlays"},KEYS_SHOULD_BE_UNIQUE:{code:"KEYS_SHOULD_BE_UNIQUE",message:"Keys should be unique"},ALREADY_EXISTS:{code:"ALREADY_EXISTS",message:"{{capitalized}} '{{name}}' already exists"},ALREADY_EXISTS_IN_CONTEXT:{code:"ALREADY_EXISTS_IN_CONTEXT",message:"{{name}}' already exists in this context"},PROPERTY_USED:{code:"PROPERTY_USED",message:"Property already used: '{{propName}}'"},PARENT_PROPERTY_USED:{code:"PARENT_PROPERTY_USED",message:"{{parent}} property already used: '{{propName}}'"},INVALID_JSON_SCHEMA:{code:"INVALID_JSON_SCHEMA",message:"Invalid JSON schema. Unexpected value '{{propName}}'"},EXAMPLE_SCHEMA_FAILURE:{code:"EXAMPLE_SCHEMA_FAILURE",message:"Example does not conform to schema: {{msg}}"},CAN_NOT_PARSE_JSON:{code:"CAN_NOT_PARSE_JSON",message:"Can not parse JSON: {{msg}}"},CAN_NOT_PARSE_XML:{code:"CAN_NOT_PARSE_XML",message:"Can not parse XML: {{msg}}"},OPTIONAL_SCLARAR_PROPERTIES_10:{code:"OPTIONAL_SCLARAR_PROPERTIES_10",message:"Optional scalar properties are not allowed in {{templateName|!pluralize|!sentencecase|!lowercase}} and their descendants: '{{propName}}?'"},OPTIONAL_PROPERTIES_10:{code:"OPTIONAL_PROPERTIES_10",message:"Optional properties are not allowed in '{{propName|!pluralize|!sentencecase|!lowercase}}': '{{oPropName}}'"},ONLY_METHODS_CAN_BE_OPTIONAL:{code:"ONLY_METHODS_CAN_BE_OPTIONAL",message:"Only method nodes can be optional"},PROPERTY_UNUSED:{code:"PROPERTY_UNUSED",message:"{{propName}} unused"},CYCLE_IN_DEFINITION:{code:"CYCLE_IN_DEFINITION",message:"{{typeName}} definition contains cycle: {{cycle}}"},SEQUENCE_NOT_ALLOWED_10:{code:"SEQUENCE_NOT_ALLOWED_10",message:"In RAML 1.0 {{propName|!singularize|!sentencecase|!lowercase}} is not allowed to have sequence as definition"},MAP_EXPECTED:{code:"MAP_EXPECTED",message:"Map is expected here"},ERROR_IN_INCLUDED_FILE:{code:"ERROR_IN_INCLUDED_FILE",message:"Error in the included file: {{msg}}"},NODE_SHOULD_HAVE_VALUE:{code:"NODE_SHOULD_HAVE_VALUE",message:"node should have at least one member value"},NAMED_PARAMETER_NEEDS_TYPE:{code:"NAMED_PARAMETER_NEEDS_TYPE",message:"named parameter needs at least one type"},ENUM_IS_EMPTY:{code:"ENUM_IS_EMPTY",message:"enum is empty"},ENUM_MUST_BE_AN_ARRAY:{code:"ENUM_MUST_BE_AN_ARRAY",message:"the value of enum must be an array"},DEFINITION_SHOULD_BE_A_MAP:{code:"DEFINITION_SHOULD_BE_A_MAP",message:"{{typeName}} definition should be a map"},RESOURCES_SHARE_SAME_URI:{code:"RESOURCES_SHARE_SAME_URI",message:"Resources share same URI"},TYPES_AND_SCHEMAS_ARE_EXCLUSIVE:{code:"TYPES_AND_SCHEMAS_ARE_EXCLUSIVE",message:"'types' and 'schemas' are mutually exclusive"},TEMPLATE_PARAMETER_NAME_MUST_CONTAIN_NONWHITESPACE_CHARACTERS:{code:"TEMPLATE_PARAMETER_NAME_MUST_CONTAIN_NONWHITESPACE_CHARACTERS",message:"Trait or resource type parameter name must contain non whitespace characters"},INVALID_SECURITY_SCHEME_SCOPE:{code:"INVALID_SECURITY_SCHEME_SCOPE",message:"The '{{invalidScope}}' scope is not allowed for the '{{securityScheme}}' security scheme. Allowed scopes are: {{allowedScopes}}."},INCLUDE_TAG_MISSING:{code:"INCLUDE_TAG_MISSING",message:"The '!include' tag is missing"},LIBRARY_PATH_MUST_BE_A_STRING:{code:"LIBRARY_PATH_MUST_BE_A_STRING",message:"Library path must be string"},INVALID_RESOURCE_NAME_UNMATCHED_SYMBOL:{code:"INVALID_RESOURCE_NAME_UNMATCHED_SYMBOL",message:"Invalid resource name: unmatched '{{symbol}}'"},MESSAGE_PARAMETER_NO_VALUE:{code:"MESSAGE_PARAMETER_NO_VALUE",message:"Message parameter '{{paramName}}' has no value specified."},SETVALUE_ONLY_MULTI_VALUES_PROPERTIES:{code:"SETVALUE_ONLY_MULTI_VALUES_PROPERTIES",message:"setValue(string) only apply to multi-values properties"},ISEMPTY_ONLY_MULTI_VALUES_ATTRIBUTES:{code:"ISEMPTY_ONLY_MULTI_VALUES_ATTRIBUTES",message:"isEmpty() only apply to multi-values attributes"},PLUGIN_REPORTS_AN_ERROR:{code:"PLUGIN_REPORTS_AN_ERROR",message:"The {{pluginId}} plugin reports an error"},PROPERTIES_SHOULD_HAVE_SAME_GRAMMAR_KIND:{code:"PROPERTIES_SHOULD_HAVE_SAME_GRAMMAR_KIND",message:"Different properties with same name should have same grammar kind at this moment"},MISSING_TITLE:{code:"MISSING_TITLE",message:"missing title"},INVALID_ARGUMENT:{code:"INVALID_ARGUMENT",message:"Invalid Argument"},METHOD_OWNED_BY:{code:"METHOD_OWNED_BY",message:"Method is supposed to be owned by Resource or ResourceType. Here the method is owned by {{owner}}"},POSITION_EXCEEDS_TEXT_LENGTH:{code:"POSITION_EXCEEDS_TEXT_LENGTH",message:"Character position exceeds text length: {{pos}} > + {{length}}. Unit path: {{absPath}}"},LINE_MAPPER_HAS_NULL_CONTENT:{code:"LINE_MAPPER_HAS_NULL_CONTENT",message:"Line Mapper has been given null content{{path}}"},EXTENSIONS_AND_OVERLAYS_LEGAL_FILE_PATHS:{code:"EXTENSIONS_AND_OVERLAYS_LEGAL_FILE_PATHS",message:"Extensions and overlays list should contain legal file paths"},CAN_NOT_RESOLVE:{code:"CAN_NOT_RESOLVE",message:"Can not resolve {{path}}"},CAN_NOT_RESOLVE_REASON:{code:"CAN_NOT_RESOLVE_REASON",message:"Can not resolve {{path}} due to: {{reason}}"},INVALID_FIRST_LINE:{code:"INVALID_FIRST_LINE",message:"Invalid first line. A RAML document is expected to start with '#%RAML <version> <?fragment type>'."},EXTENSIONS_AND_OVERLAYS_NOT_SUPPORTED_0_8:{code:"EXTENSIONS_AND_OVERLAYS_NOT_SUPPORTED_0_8",message:"Extensions and overlays are not supported in RAML 0.8."},API_CONTAINS_ERROR:{code:"API_CONTAINS_ERROR",message:"Api contains errors."},COULD_NOT_SET_STRUCTURED_VALUE:{code:"COULD_NOT_SET_STRUCTURED_VALUE",message:"couldn't set structured value to a key: {{key}}"},NOT_IMPLEMENTED:{code:"NOT_IMPLEMENTED",message:"not implemented"},COULD_NOT_MIX_TYPES_INHERITANCE:{code:"COULD_NOT_MIX_TYPES_INHERITANCE",message:"couldn't mix user defined and basic types in inheritance"},SPECIFY_APIPATH:{code:"SPECIFY_APIPATH",message:"Please, specify -apiPath parameter"},UNABLE_TO_EXECUTE_GET:{code:"UNABLE_TO_EXECUTE_GET",message:"Unable to execute GET {{url}}"},UNIT_PATH_IS_NULL:{code:"UNIT_PATH_IS_NULL",message:"Unit path is null"},FSRESOLVER_IS_UNABLE_USE_EXTENDEDFSRESOLVER:{code:"FSRESOLVER_IS_UNABLE_USE_EXTENDEDFSRESOLVER",message:"Provided FSResolver is unable to list files. Please, use ExtendedFSResolver."},NOT_IMPLEMENTED_INSERT_INTO_EMPTY_REF:{code:"NOT_IMPLEMENTED_INSERT_INTO_EMPTY_REF",message:"not implemented: insert into empty include ref"},ATTR_SETVALUE_NOT_RESOLVE:{code:"ATTR_SETVALUE_NOT_RESOLVE",message:"attr.setValue: couldn't resolve: {{path}}"},ONLY_MAP_NODES_ALLOWED:{code:"ONLY_MAP_NODES_ALLOWED",message:"only MAP/MAPPING nodes allowed as values"},UNSUPPORTED_CHANGE_VALUE_CASE:{code:"UNSUPPORTED_CHANGE_VALUE_CASE",message:"Unsupported change value case: {{name}}"},UNSUPPORTED_CASE_ATTRIBUTE_VALUE_CONVERSION:{code:"UNSUPPORTED_CASE_ATTRIBUTE_VALUE_CONVERSION",message:"Unsupported case: attribute value conversion: {{curval}} ==> {{newval}} not supported"},UNSUPPORTED_COMMAND:{code:"UNSUPPORTED_COMMAND",message:"UNSUPPORTED_COMMAND: {{name}}"},NEW_NODE_CONTENTS_ERROR_BELOW:{code:"NEW_NODE_CONTENTS_ERROR_BELOW",message:"New node contents (causes error below): \n {{content}}"},REPARSE_ERROR:{code:"REPARSE_ERROR",message:"Reparse error {{content}}"},INSERT_INTO_MAPPING_VALUE_NOT_SUPPORTED:{code:"INSERT_INTO_MAPPING_VALUE_NOT_SUPPORTED",message:"Insert into mapping with {{value}} value not supported"},INSERT_INTO_NOT_SUPPORTED:{code:"INSERT_INTO_NOT_SUPPORTED",message:"Insert into {{name}} unsupported"},DELETE_FROM_NOT_SUPPORTED:{code:"DELETE_FROM_NOT_SUPPORTED",message:"Delete from {{name}} unsupported"},CAN_NOT_BE_PARSED:{code:"CAN_NOT_BE_PARSED",message:"{path} can not be parsed"},RECURSIVE_DEFINITION_EMPTY:{code:"RECURSIVE_DEFINITION_EMPTY",message:"Recursive definition"},SHOULD_NEVER_HAPPEN_KIND:{code:"SHOULD_NEVER_HAPPEN_KIND",message:"Should never happen; kind : {{kind}}"},UNKNOWN_NODE_KIND:{code:"UNKNOWN_NODE_KIND",message:"Unknown node kind: '{{kind}}'"},NOT_IMPLEMENTED_KIND:{code:"NOT_IMPLEMENTED_KIND",message:"markup not implemented: {{kind}}"},EXPECTED_INSTEAD_OF:{code:"EXPECTED_INSTEAD_OF",message:"{{expected}} expected instead of {{received}}"},INSERTION_POINT_TYPE:{code:"INSERTION_POINT_TYPE",message:"insertion point type: {{type}}"},UNSUPPORTED_OPERATION_EXCEPTION:{code:"UNSUPPORTED_OPERATION_EXCEPTION",message:"Unsupported operation exception"},UNABLE_TO_FIND_CHILD:{code:"UNABLE_TO_FIND_CHILD",message:"Unable to find correct child"},NETWORK_ERROR:{code:"NETWORK_ERROR",message:"Network Error"},COULD_NOT_LOAD_API_FROM:{code:"COULD_NOT_LOAD_API_FROM",message:"couldn't load api from {{path}}"},METHOD_MUST_BE_OVERRIDDEN:{code:"METHOD_MUST_BE_OVERRIDDEN",message:"The method must be overridden"},UNKNOWN_ANNOTATION_TYPE:{code:"UNKNOWN_ANNOTATION_TYPE",message:"Using unknown annotation type: '{{typeName}}'"},LIBRARY_CHAINIG_IN_ANNOTATION_TYPE:{code:"LIBRARY_CHAINIG_IN_ANNOTATION_TYPE",message:"Annotation type '{{typeName}}' imported through a library chain. Library chainig is not allowed."},LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE:{code:"LIBRARY_CHAINIG_IN_ANNOTATION_TYPE_SUPERTYPE",message:"Annotation type '{{typeName}}' depends on '{{chainedType}}' imported through a library chain. Library chainig is not allowed."},PROTOCOLS_ARRAY:{code:"PROTOCOLS_ARRAY",message:"'protocols' value should be a non empty array"}}},function(e,t,n){"use strict";function r(e,t){if(void 0===t&&(t=0),t>20)return[];try{var n=[],i=e.leftType();i&&n.push(i);var a=e.rightType();if(a)if(a.hasUnionInHierarchy()){var o=r(a.unionInHierarchy(),t+1);n=n.concat(o)}else n.push(a);return n}finally{}}function i(e){var t=e.definition();if(!t||!M.isTypeDeclarationDescendant(t))return!1;var n=e.lowLevel();if(n.valueKind()!==_.Kind.SEQ)return!1;var r=n.children();if(null==r)return!1;for(var i=0,a=r;i<a.length;i++){var o=a[i];if(o.kind()!==_.Kind.SCALAR)return!1}return!0}function a(e,t){var n=e.definition().universe();if(!t)return[n.type(R.Universe10.StringTypeDeclaration.name)];var r=e.parsedType(),i=o(r,n);return i}function o(e,t){void 0===t&&(t=S.getUniverse("RAML10"));var n=[];return e.isString()?n.push(t.type(R.Universe10.StringTypeDeclaration.name)):e.isNumber()?(e.isInteger()&&n.push(t.type(R.Universe10.IntegerTypeDeclaration.name)),n.push(t.type(R.Universe10.NumberTypeDeclaration.name))):e.isBoolean()?n.push(t.type(R.Universe10.BooleanTypeDeclaration.name)):e.isObject()?n.push(t.type(R.Universe10.ObjectTypeDeclaration.name)):e.isArray()?n.push(t.type(R.Universe10.ArrayTypeDeclaration.name)):e.isFile()?n.push(t.type(R.Universe10.FileTypeDeclaration.name)):e.isDateTime()?n.push(t.type(R.Universe10.DateTimeTypeDeclaration.name)):e.isDateTimeOnly()?n.push(t.type(R.Universe10.DateTimeOnlyTypeDeclaration.name)):e.isDateOnly()?n.push(t.type(R.Universe10.DateOnlyTypeDeclaration.name)):e.isTimeOnly()&&n.push(t.type(R.Universe10.TimeOnlyTypeDeclaration.name)),e.isUnion()&&n.push(t.type(R.Universe10.UnionTypeDeclaration.name)),0==n.length&&n.push(t.type(R.Universe10.TypeDeclaration.name)),n}function s(e){return function(t){var n=e.type(t);if(!n){new g.UserDefinedClass("",e,null,"","")}return n}}function u(e,t){var n=e.asElement();if(null==n)return null;var r=n.elementsOfKind(R.Universe10.TypeDeclaration.properties.facets.name);return null==r||0==r.length?null:T.find(r,function(e){return t==e.attrValue(R.Universe10.TypeDeclaration.properties.name.name)})}function l(e){var t=e.owner();if(null==t)return null;var n=e.facetName();if(!n)return null;var r=t.getExtra(w.SOURCE_EXTRA);return null==r?null:S.isSourceProvider(r)||A.isParseResult(r)?{getSource:function(){if(S.isSourceProvider(r)){var e=r.getSource();if(e&&A.isParseResult(e))return u(e,n)}else if(A.isParseResult(r))return u(r,n);return null},getClassIdentifier:function(){return[g.SourceProvider.CLASS_IDENTIFIER]}}:null}function p(e,t,n){for(var r,i=0,a=e;i<a.length;i++){var o=a[i];if(null!=o){var s=t.parsedType();if(!r){r=new g.NodeClass(t.name(),t.definition().universe(),"",""),r.addAdapter(s);var u=t.property();(M.isPropertiesProperty(u)||M.isItemsProperty(u)||M.isFacetsProperty(u))&&r.putExtra(L.USER_DEFINED_EXTRA,!0)}r._superTypes.push(o),c(r,t,n)}}return r}function c(e,t,n){var r=t.parsedType();r.allFacets().forEach(function(r){if(r.kind()==g.tsInterfaces.MetaInformationKind.FacetDeclaration){var i=l(r),a=null;null!=i?(a=new g.UserDefinedProp(r.facetName(),null),a.setSourceProvider(i)):a=new g.Property(r.facetName(),"");var o=null;o=n?n.definition().universe():t.definition().universe(),a.withRange(o.type("StringType")),a.withDomain(e),a.withGroupName(r.facetName()),a.withRequired(!1),r.value(),w.setPropertyConstructor(function(e){var t=new g.Property(e,"");return t.unmerge(),t}),a.withRange(w.toNominal(r.value(),s(t.definition().universe())))}})}function f(e,t,n){var r=n.attr("type");if(r){var i=a(n,r.value()),o=p(i,n,t);return o&&0==o.superTypes().length&&o._superTypes.push(n.definition().universe().type(R.Universe10.TypeDeclaration.name)),o}var s=R.Universe10.ObjectTypeDeclaration.properties.properties.name;if(e){if("body"==e.nameId()||T.find(n.lowLevel().children(),function(e){return e.key()===s}))return n.definition().universe().type(R.Universe10.ObjectTypeDeclaration.name)}else if(!t&&n.lowLevel()&&T.find(n.lowLevel().children(),function(e){return e.key()===s}))return n.definition().universe().type(R.Universe10.ObjectTypeDeclaration.name);return n.definition().universe().type(R.Universe10.StringTypeDeclaration.name)}function h(e){try{var t=e.definition().nameId(),n=t===R.Universe10.Api.name||t===R.Universe08.Api.name;if(!n&&!e.property()&&!e.parent()&&e.definition().nameId()===N.getFragmentDefenitionName(e)){if(e.property()&&e.property().nameId()===R.Universe10.LibraryBase.properties.annotationTypes.name)return d(null,null,e);if(M.isTypeDeclarationDescendant(e.definition()))return d(null,null,e);var r=null,i=e.definition().allSubTypes();return i.forEach(function(t){!r&&y(t,e,null)&&(r=t)}),r}}catch(e){}return d(e.property(),e.parent(),e)}function d(e,t,n){var r=n.lowLevel();e&&e.nameId()==R.Universe10.FragmentDeclaration.properties.uses.name&&e.range().nameId()==R.Universe10.Library.name;var i=e?e.range().nameId():n.definition().nameId();if(r._node&&r._node.descriminate)return null;r._node&&(r._node.descriminate=1);try{if(i==R.Universe10.TypeDeclaration.name||M.isItemsProperty(e)||M.isTypeProperty(e)||M.isSchemaProperty(e)){var a=f(e,t,n);if(e||!e&&!t&&n.lowLevel()){if(e&&null!=a&&(e.nameId()==R.Universe10.MethodBase.properties.body.name||e.nameId()==R.Universe10.ArrayTypeDeclaration.properties.items.name||e.nameId()==R.Universe10.Response.properties.headers.name||e.nameId()==R.Universe10.MethodBase.properties.queryParameters.name)){
var o=new g.UserDefinedClass(n.lowLevel().key(),a.universe(),n,n.lowLevel().unit()?n.lowLevel().unit().path():"","");return o._superTypes.push(a),o}if(null!=a&&M.isAnnotationTypeType(n.definition())){var s=m(a),o=new g.UserDefinedClass(n.lowLevel().key(),a.universe(),n,n.lowLevel().unit()?n.lowLevel().unit().path():"","");return o._superTypes.push(s),o._superTypes.push(a),o}}if(a)return a}var u=null;if(e&&t){var l=b.findAllSubTypes(e,t);return l.length>0&&l.forEach(function(e){u||y(e,n,u)&&(u=e)}),u}}finally{r._node&&delete r._node.descriminate}}function m(e){for(var t,n=[e].concat(e.allSuperTypes()),r=0;r<n.length;r++){var i=n[r];if(!i.isUserDefined()){if(i.isUnion()){var a=i,o=a.leftType(),s=(a.leftType(),m(o)),u=m(o);if(s.isAssignableFrom(u.nameId())&&(null==t||s.isAssignableFrom(t.nameId()))){t=s;continue}if(u.isAssignableFrom(s.nameId())&&(null==t||u.isAssignableFrom(t.nameId()))){t=u;continue}t=e.universe().type(R.Universe10.UnionTypeDeclaration.name);break}if(i.isArray()){t=e.universe().type(R.Universe10.ArrayTypeDeclaration.name);break}for(var l=i.subTypes(),p=0;p<l.length;p++){var c=l[p];c.isAssignableFrom(R.Universe10.TypeDeclaration.name)&&(null==t?t=c:c.isAssignableFrom(t.nameId())&&(t=c))}}}return null!=t?t:e.universe().type(R.Universe10.TypeDeclaration.name)}function y(e,t,n){if(t.isAttr()||t.isUnknown())return!1;var r=t,i=T.find(e.superTypes(),function(t){var n=T.find(t.allProperties(),function(e){return e.isDescriminator()});if(n){var i=r.attr(n.nameId());if(i&&i.value()==e.nameId())return!0}return!1});if(i)return!0;if(0==e.valueRequirements().length)return!1;var a=!0;return e.valueRequirements().forEach(function(t){var i=r.attr(t.name);if(i)if(i.value()==t.value);else if(e.getAdapter(C.RAMLService).getConsumesRefs()){var o=i.value(),s=[];e.superTypes().forEach(function(e){return e.allSubTypes().forEach(function(e){s.push(e)})});var u=[];T.unique(s).forEach(function(e){u.push(e.nameId()),e.valueRequirements().forEach(function(e){u.push(e.value)}),e.getAdapter(C.RAMLService).getAliases().forEach(function(e){return u.push(e)})}),T.find(u,function(e){return e==o})&&(a=!1)}else a=!1;else{var l=e.getAdapter(C.RAMLService).getDefining(),p=!1;if(l.forEach(function(e){r.lowLevel().children().forEach(function(t){t.key()==e&&(p=!0)})}),p)return void(a=!0);if(n)a=!1;else{var c=e.property(t.name);c&&c.defaultValue()==t.value||(a=!1)}}}),a}function v(e){var t=e.root().definition();if(M.isTraitType(t)||M.isResourceTypeType(t))return!0;if(!t||!M.isLibraryBaseSibling(t)&&!M.isApiType(t))return!1;var n=e.lowLevel();I.LowLevelProxyNode.isInstance(n)&&(n=P.toOriginal(n));for(var r;n.parent();)r=n,n=n.parent();var i=r&&r.key();return i==S.universesInfo.Universe10.LibraryBase.properties.traits.name||i==S.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name}Object.defineProperty(t,"__esModule",{value:!0});var g=n(56),A=n(198),E=n(19),_=n(21),T=n(16),S=g,N=n(55),I=n(199),b=n(209),R=n(204),M=n(205),C=g,w=g.rt,P=n(206),L=g.tsInterfaces,O=n(207),D=n(215),U=function(){function e(e){this._props=e;for(var t=0,n=e.filter(function(e){return g.Property.isInstance(e)});t<n.length;t++){var r=n[t];r.isFromParentValue()&&(this.parentValue=this.parentValue||r),r.isFromParentKey()&&(this.parentKey=this.parentKey||r),r.canBeValue()&&(this.canBeValue=this.canBeValue||r)}}return e.prototype.add=function(e){this._props.push(e)},e.prototype.match=function(e){var t=this,n=null,r="";return this._props.forEach(function(i){i.getAdapter(C.RAMLPropertyService).isSystem()||i!=t.parentValue&&i!=t.parentKey&&i.matchKey(e)&&(null!=i.keyPrefix()?i.keyPrefix().length>=r.length&&(r=i.keyPrefix(),n=i):(n=i,r=i.nameId()))}),n},e}(),x=0,k=function(){function e(){this.shouldDescriminate=!1}return e.prototype.process=function(e,t){var n=this,a=e.lowLevel(),o=e;o._mergedChildren=null;var s=a._node?a._node:a;try{if(s.currentChildren)return s.currentChildren;if(!e.definition())return;if(null==e.parent()&&!this.shouldDescriminate){this.shouldDescriminate=!0;try{var u=this.process(e,t),l=e;l._children=u,l._mergedChildren=null;var p=h(e);p&&l.patchType(p);var u=this.process(e,t);l._children=u,l._mergedChildren=null}finally{this.shouldDescriminate=!1}}if(e.definition().hasUnionInHierarchy()&&e.parent()&&e.property().nameId()==R.Universe10.LibraryBase.properties.annotations.name){var c=r(e.definition().unionInHierarchy()),f=null,d=null,m=null,y=1e3,v=e;if(c.forEach(function(r){if(!f&&!r.hasUnionInHierarchy()){v.patchType(r);if(0==x){x++;try{for(var i=n.process(e,t),a=0,o=0;o<i.length;o++)i[o].isUnknown()&&a++;0==a&&(f=i),y>a&&(y=a,d=i,m=r)}finally{x--}}}}),f)return v.patchType(m),f;d&&v.patchType(m)}var g=new U(e.definition().allProperties());if(null==e.parent()||e.lowLevel().includePath()){var A=e.definition().universe();"RAML10"==A.version()&&(e.definition().property("uses")||A.type("FragmentDeclaration").allProperties().forEach(function(e){return g.add(e)}))}var E=e,T=E._allowQuestion||e.definition().getAdapter(C.RAMLService).getAllowQuestion(),S=[];if(g.parentKey){if(e.lowLevel().key()){var I=new N.ASTPropImpl(e.lowLevel(),e,g.parentKey.range(),g.parentKey,!0);S.push(I);var b=e.property()&&M.isBodyProperty(e.property())&&e.lowLevel().key()==e.property().nameId();if(b){F(E);I.overrideValue(E._computedKey)}}if(e.lowLevel().valueKind()===_.Kind.SEQ&&!i(e)){var w=new N.BasicASTNode(e.lowLevel(),E);return w.errorMessage={entry:O.DEFINITION_SHOULD_BE_A_MAP,parameters:{typeName:e.definition().nameId()}},S.push(w),S}}if(null!=e.lowLevel().value(!0))if(g.parentValue)S.push(new N.ASTPropImpl(e.lowLevel(),e,g.parentValue.range(),g.parentValue));else if(g.canBeValue){var P=e.lowLevel().value();null==P&&(P=e.lowLevel().value(!0)),"string"==typeof P&&P.trim().length>0&&S.push(new N.ASTPropImpl(e.lowLevel(),e,g.canBeValue.range(),g.canBeValue))}if(E._children=S,E._mergedChildren=null,E.definition().getAdapter(C.RAMLService).isUserDefined())S=this.processChildren(t,E,S,T,g);else if(E.definition().key()==R.Universe08.Api||E.definition().key()==R.Universe10.Api){var L=t.filter(function(e){return"uses"==e.key()});S=this.processChildren(L,E,S,T,g);var D=t.filter(function(e){return"types"==e.key()});S=this.processChildren(D,E,S,T,g);var k=t.filter(function(e){return"types"!=e.key()&&"uses"!=e.key()});S=this.processChildren(k,E,S,T,g)}else S=this.processChildren(t,E,S,T,g);return E._children=S,E._mergedChildren=null,S}finally{}},e.prototype.isTypeDeclarationShortcut=function(e,t){var n=M.isTypeOrSchemaProperty(t),r=e.definition()&&M.isTypeDeclarationTypeOrDescendant(e.definition());return!!(r&&n&&e.lowLevel()&&e.lowLevel().valueKind()===_.Kind.SEQ)},e.prototype.processChildren=function(e,t,n,r,i){var a=this,o=R.Universe10.TypeDeclaration.name,s=R.Universe10.TypeDeclaration.properties.type.name,u=R.Universe10.ArrayTypeDeclaration.properties.items.name;if(t.definition()&&t.definition().isAssignableFrom(o)&&t.lowLevel()&&i.canBeValue&&(i.canBeValue.nameId()===s||i.canBeValue.nameId()===u)&&t.lowLevel()._node&&t.lowLevel()._node.value&&t.lowLevel()._node.value.kind===_.Kind.SEQ)return e.forEach(function(e){var r=new N.ASTPropImpl(e,t,i.canBeValue.range(),i.canBeValue);n.push(r)}),n;var l=t.root().lowLevel().unit();e.forEach(function(e){if(i.canBeValue&&a.isTypeDeclarationShortcut(t,i.canBeValue))return void n.push(new N.ASTPropImpl(e,t,i.canBeValue.range(),i.canBeValue));var o=e.key(),s=null!=o?i.match(o):null;if(null!=s){var u=s.range();if(s.isAnnotation()&&"annotations"!=o){var p=new N.ASTPropImpl(e,t,u,s);return void n.push(p)}var c=!1,f=s.isMultiValue();u.isArray()?(f=!0,u=u.array().componentType(),c=!0):u.hasArrayInHierarchy()&&(f=!0,c=!0);var h,m=!1;if(t.reuseMode()&&e.valueKind()!=_.Kind.SEQ){var y=t.reusedNode();if(y){var A=[e],b=t.lowLevel();!s.isMerged()&&f&&(h=[],A=e.children(),b=e);for(var w=0,P=A;w<P.length;w++){var L=P[w],U=L.containingUnit();if(U&&U.absolutePath()!=l.absolutePath()){var x=T.find(y.children(),function(e){return e.lowLevel().key()==L.key()});if(x&&x.lowLevel().unit().absolutePath()==U.absolutePath()){m=!0,n.push(x),x.setReused(!0),x.setParent(t),x.isElement()&&x.resetRuntimeTypes(),t.isExpanded()&&(b.replaceChild(L,x.lowLevel()),I.LowLevelCompositeNode.isInstance(x.lowLevel())&&x.lowLevel().setTransformer(b.transformer()));continue}}h&&h.push(L)}}}if(!h){if(m)return;h=e.children()}if(u.hasValueTypeInHierarchy()){var k=h,B=e.valueKind()==_.Kind.SEQ;if((B&&k.length>0||k.length>1)&&f)if(k.length>1&&M.isTypeDeclarationDescendant(t.definition())&&(M.isTypeOrSchemaProperty(s)||M.isItemsProperty(s))&&e.valueKind()!=_.Kind.SEQ){var p=new N.ASTPropImpl(e,t,u,s);n.push(p),t.setComputed(s.nameId(),p)}else{var V=[];k.forEach(function(e){var r=new N.ASTPropImpl(e,t,u,s);n.push(r),V.push(e.value())}),s.isInherited()&&t.setComputed(s.nameId(),V)}else{s.isInherited()&&t.setComputed(s.nameId(),e.value());var K=new N.ASTPropImpl(e,t,u,s),j=e;if(e.isAnnotatedScalar()&&(j=T.find(e.children(),function(e){return"value"==e.key()})),j.valueKind()==_.Kind.SEQ||j.valueKind()==_.Kind.MAP){var W=s.range().nameId();s.getAdapter(C.RAMLPropertyService).isExampleProperty()||("MarkdownString"==W?W="string":"StringType"==W?W="string":"NumberType"==W?W="number":"BooleanType"==W&&(W="boolean"),"string"!=W&&"number"!=W&&"boolean"!=W||(K.errorMessage={entry:O.INVALID_PROPERTY_RANGE,parameters:{propName:s.groupName(),range:W}},0==h.length&&"enum"==s.groupName()&&(K.errorMessage={entry:O.ENUM_IS_EMPTY,parameters:{}},e.valueKind()==_.Kind.MAP&&(K.errorMessage={entry:O.ENUM_MUST_BE_AN_ARRAY,parameters:{}}))))}n.push(K)}return}var H=[];if(t._children=n,t._mergedChildren=null,null!=e.value()&&("string"==typeof e.value()||"boolean"==typeof e.value()||"number"==typeof e.value())&&(""+e.value()).trim().length>0){var Y=s.range();if(!Y.allProperties().some(function(e){var t=e;return!!t&&(t.canBeValue()&&t.isFromParentValue())})){var q=new N.BasicASTNode(e,t);q.getLowLevelEnd=function(){return-1},q.getLowLevelStart=function(){return-1},q.knownProperty=s,n.push(q)}}if(s.isMerged()){var G=new N.ASTNodeImpl(e,t,u,s);G._allowQuestion=r,H.push(G)}else if(f)if(s.getAdapter(C.RAMLPropertyService).isEmbedMap()){var X=h,z=[],$=!1;if(X.forEach(function(e){e.kind()==_.Kind.INCLUDE_REF&&"RAML08"==t.universe().version()?e.children().forEach(function(e){var n=new N.ASTNodeImpl(e,t,u,s);n._allowQuestion=r,H.push(n),$=!0}):z.push(e)}),X=z,0==X.length){if(s.range().key()==R.Universe08.ResourceType&&!$){var J=new N.BasicASTNode(e,t);J.errorMessage={entry:O.PROPERTY_MUST_BE_A_MAP,parameters:{propName:s.nameId()}},n.push(J)}if(e.valueKind()==_.Kind.SCALAR&&s.range().key()==R.Universe08.AbstractSecurityScheme){var J=new N.BasicASTNode(e.parent(),t);J.errorMessage={entry:O.PROPERTY_MUST_BE_A_MAP,parameters:{propName:s.nameId()}},n.push(J)}}if(X.forEach(function(e){var i=e.children();if(i.length>0&&"RAML08"==t.universe().version()&&M.isSchemasProperty(s))for(var a=0,o=i;a<o.length;a++){var l=o[a],p=new N.ASTNodeImpl(l,t,u,s);p._allowQuestion=r,H.push(p)}else if(e.key()||1!=i.length)if("RAML10"==t.universe().version()){var c=new N.ASTNodeImpl(e,t,u,s);c._allowQuestion=r,H.push(c)}else{var f=new N.BasicASTNode(e,t);n.push(f),e.key()&&(f.needSequence=!0)}else if("RAML10"!=t.universe().version()||t.parent()){var c=new N.ASTNodeImpl(i[0],t,u,s);c._allowQuestion=r,H.push(c)}}),"RAML10"==t.universe().version()&&e.valueKind()==_.Kind.SEQ){var q=new N.BasicASTNode(e,t);n.push(q),q.needMap=!0,q.knownProperty=s}}else{var Q={},Z=[];if(g.NodeClass.isInstance(u)){var ee=u;ee.getAdapter(C.RAMLService).getCanInherit().length>0&&ee.getAdapter(C.RAMLService).getCanInherit().forEach(function(n){for(var i=t.computedValue(n),a=Array.isArray(i)?i:[i],o=0;o<a.length;o++){var l=a[o];if(l&&s.nameId()==R.Universe10.Response.properties.body.name){for(var p=T.find(h,function(e){return e.key()==l}),c=e;c.originalNode;)c=c.originalNode();var f=T.find(c.children(),function(e){try{return D.parse(e.key()),!0}catch(e){return!1}});if(!f){var m=t.parent().definition().key(),y=new N.ASTNodeImpl(e,t,u,s);y._computedKey=l,m!=R.Universe10.MethodBase&&m!=R.Universe08.MethodBase||y.setComputed("form","true");var v=F(t),g=d(s,t,y);g&&(v||g.setName(l),y.patchType(g));var A=y.children();y._children=A.filter(function(e){return!e.isUnknown()}),y._mergedChildren=null,y._allowQuestion=r,p||Z.push(y),y.children().forEach(function(e){var t=e.property();if(t&&t.getAdapter(C.RAMLPropertyService).isKey()){var n=e;return void(n._computed=!0)}if(e.isElement()&&(e.property().getAdapter(C.RAMLPropertyService).isMerged()||(Q[e.property().nameId()]=!0)),e.property().isAnnotation()){var n=e,r=n.value(),i="";i=N.StructuredValue.isInstance(r)?r.valueName():""+r,Q["("+i+")"]=!0}else Q[e.name()]=!0});var E=y.definition().allProperties();if(y.localType().isAssignableFrom("unknown"))for(var _=0,S=y.definition().allSuperTypes().filter(function(e){return!e.isUserDefined()});_<S.length;_++)for(var I=S[_],b=0,M=I.allSubTypes();b<M.length;b++){var w=M[b];w.properties().forEach(function(e){return E.push(e)})}E.forEach(function(e){e.getAdapter(C.RAMLPropertyService).isKey()||e.getAdapter(C.RAMLPropertyService).isSystem()||y.lowLevel().children().some(function(t){return t.key()==e.nameId()})&&(Q[e.nameId()]=!0)}),y._computed=!0}}}})}var te=[];if(0==h.length&&e.valueKind()==_.Kind.SEQ&&s.range().key()==R.Universe08.Parameter){var J=new N.BasicASTNode(e,t);J.errorMessage={entry:O.PROPERTY_MUST_BE_A_MAP,parameters:{propName:s.nameId()}},n.push(J)}if("documentation"===s.nameId()&&e.resolvedValueKind()!==_.Kind.SEQ){if(!t.definition().getAdapter(C.RAMLService).isUserDefined()){var J=new N.BasicASTNode(e,t);J.errorMessage={entry:O.PROPERTY_MUST_BE_A_SEQUENCE,parameters:{propName:s.nameId()}},n.push(J)}}else h.forEach(function(e){if(!Q[e.key()])if(e.valueKind()==_.Kind.SEQ){var i="RAML10"==t.definition().universe().version();if(e.children().forEach(function(n){var a=new N.ASTNodeImpl(n,t,u,s);a._allowQuestion=r,a.setNamePatch(e.key()),i&&(a.invalidSequence=!0),te.push(a)}),0==e.children().length){var a=new N.BasicASTNode(e,t);s.range().key()==R.Universe08.Parameter?a.errorMessage={entry:O.NAMED_PARAMETER_NEEDS_TYPE,parameters:{}}:a.errorMessage={entry:O.NODE_SHOULD_HAVE_VALUE,parameters:{}},n.push(a)}}else{var o=new N.ASTNodeImpl(e,t,u,s),l=s.domain().key();"body"!=s.nameId()||l!=R.Universe08.MethodBase&&l!=R.Universe10.MethodBase||o.setComputed("form","true"),o._allowQuestion=r,te.push(o)}});te.length>0?te.forEach(function(e){return H.push(e)}):Z.forEach(function(e){return H.push(e)})}else H.push(new N.ASTNodeImpl(e,t,u,s));t._children=t._children.concat(H),t._mergedChildren=null,n=n.concat(H),H.forEach(function(e){var n=d(s,t,e);n&&n!=e.definition()&&e.patchType(n),e._associatedDef=null,s.childRestrictions().forEach(function(t){e.setComputed(t.name,t.value)});e.definition()})}else{var ne=new N.BasicASTNode(e,t),re=!I.LowLevelCompositeNode.isInstance(e)||null!=e.primaryNode();if(!re){var ie=E.typeOfContainingTemplate(ne),ae=o?o.indexOf("<<"):-1,oe=ae>=0&&o.indexOf(">>",ae)>=0;ie?oe||(re=!0):(re=!0,M.isMethodType(t.definition())?ie=t.definition().universe().type(S.universesInfo.Universe10.Trait.name):M.isResourceType(t.definition())&&(ie=t.definition().universe().type(S.universesInfo.Universe10.ResourceType.name)),ie&&null!=ie.property(o)&&(re=!1),re&&oe&&(re=!v(t)))}re&&n.push(ne)}});var p=t.reusedNode();if(p&&t.lowLevel().valueKind()!=_.Kind.SEQ){var c={};p.elements().forEach(function(e){return c[e.property().nameId()+"_"+e.lowLevel().key()]=e}),p.attrs().forEach(function(e){return c[e.property().nameId()+"_"+e.lowLevel().key()]=e}),n.filter(function(e){return e.isElement()||e.isAttr()}).forEach(function(e){var n=c[e.property().nameId()+"_"+e.lowLevel().key()];n&&n!=e&&e.isElement()&&e.lowLevel().parent().valueKind()!=_.Kind.SEQ&&(e.setReusedNode(n),e.setReuseMode(t.reuseMode()))})}return n},e}();t.BasicNodeBuilder=k,t.mapType=o,t.doDescrimination=h;var F=function(e){for(var t=!1,n=e;n;){var r=n.definition();if(M.isTraitType(r)||M.isResourceTypeType(r)){t=!0;break}n=n.parent()}return t}},function(e,t,n){"use strict";function r(e,t,n){return N.findDeclaration(e,t,n)}function i(e,t){return N.findUsages(e,t)}function a(e){return N.globalDeclarations(e)}function o(e,t,n){N.refFinder(e,t,n)}function s(e,t){return N.findDeclarationByNode(e,t)}function u(e,t){return N.determineCompletionKind(e,t)}function l(e,t){return N.enumValues(e,t)}function p(e,t){return I.qName(e,t)}function c(e,t){return N.subTypesWithLocals(e,t)}function f(e,t){return N.nodesDeclaringType(e,t)}function h(e){return N.isExampleNodeContent(e)}function d(e){return N.findExampleContentType(e)}function m(e,t){return N.parseDocumentationContent(e,t)}function y(e,t){return N.parseStructuredExample(e,t)}function v(e){return N.isExampleNode(e)}function g(e,t){return N.referenceTargets(e,t)}function A(e){return b.getNominalTypeSource(e)}function E(e,t){return N.findAllSubTypes(e,t)}function _(e){return N.declRoot(e)}function T(e,t,n,r,i){return void 0===r&&(r=!0),void 0===i&&(i=!0),N.deepFindNode(e,t,n,r,i)}function S(e){return N.allChildren(e)}Object.defineProperty(t,"__esModule",{value:!0});var N=n(210),I=n(55),b=n(211);t.findDeclaration=r,t.findUsages=i,t.globalDeclarations=a,t.refFinder=o,t.findDeclarationByNode=s;var R;!function(e){e[e.VALUE_COMPLETION=0]="VALUE_COMPLETION",e[e.KEY_COMPLETION=1]="KEY_COMPLETION",e[e.PATH_COMPLETION=2]="PATH_COMPLETION",e[e.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",e[e.VERSION_COMPLETION=4]="VERSION_COMPLETION",e[e.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",e[e.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",e[e.INCOMMENT=7]="INCOMMENT"}(R=t.LocationKind||(t.LocationKind={})),t.determineCompletionKind=u,t.enumValues=l,t.qName=p,t.subTypesWithLocals=c,t.nodesDeclaringType=f,t.isExampleNodeContent=h,t.findExampleContentType=d,t.parseDocumentationContent=m,t.parseStructuredExample=y,t.isExampleNode=v,t.referenceTargets=g,t.getNominalTypeSource=A,t.findAllSubTypes=E,t.declRoot=_,t.deepFindNode=T,t.allChildren=S},function(e,t,n){"use strict";function r(e){for(var t=[],n={};null!=e.parent();)e.lowLevel().includePath()&&(t=t.concat(a(e,n))),e=e.parent();return t=t.concat(a(e,n))}function i(e){var t=e.node();if(t&&U.isParseResult(t))return t;var n=K.getNominalPropertySource2(e);return n?n.getSource():null}function a(e,t,n){if(void 0===t&&(t={}),void 0===n&&(n=[]),!e.lowLevel())return[];var r=e.lowLevel().unit().absolutePath();if(t[r]=!0,!F.ASTNodeImpl.isInstance(e))return n;var i=!1;return e.elements().forEach(function(e){if(e.definition().key()==B.Universe10.UsesDeclaration){if(i)return;var r=e.attr("value");if(r){var o=e.lowLevel().unit().resolve(r.value());if(o&&j.isWaitingFor(o.absolutePath()))return void(i=!0);null!=o&&o.isRAMLUnit()&&!t[o.absolutePath()]&&o.highLevel().isElement()&&a(o.highLevel().asElement(),t,n)}}else n.push(e)}),n}function o(e,t){for(var n="",r=e-1;r>=0;r--){var i=t.charAt(r);if(" "==i||"\t"==i)n?n+=i:n=i;else if("\r"==i||"\n"==i)return n}}function s(e,t,n,r,i){if(void 0===r&&(r=!0),void 0===i&&(i=!0),null==e)return null;if(e.lowLevel()&&e.lowLevel().start()<=t&&e.lowLevel().end()>=n){if(F.ASTNodeImpl.isInstance(e)){for(var a=e,o=r?a.children():a.directChildren(),u=0;u<o.length;u++)if(r||o[u].lowLevel().unit()==e.lowLevel().unit()){var l=s(o[u],t,n,r);if(l)return!i&&F.ASTPropImpl.isInstance(l)&&(l=l.parent()),l}return e}if(F.ASTPropImpl.isInstance(e)){var p=e;if(!p.property().isKey()){var c=p.value();if(F.StructuredValue.isInstance(c)){var f=c,h=f.toHighLevel2();if(h&&!r&&h.lowLevel().unit()!=e.lowLevel().unit())return null;var l=s(h,t,n,r);if(l)return!i&&F.ASTPropImpl.isInstance(l)&&(l=l.parent()),l}return i?p:p.parent()}return null}return null}return null}function u(e,t){for(var n=-1,r=t-1;r>=0;r--){var i=e.charAt(r);if("\r"==i||"\n"==i||" "==i||"\t"==i||'"'==i||"'"==i||":"==i){n=r+1;break}}for(var a=-1,r=t;r<e.length;r++){var i=e.charAt(r);if("\r"==i||"\n"==i||" "==i||"\t"==i||'"'==i||"'"==i||":"==i){a=r;break}}return n!=-1&&a!=-1?e.substring(n,a):""}function l(e,t){for(var n="",r=t;r>=0;r--){var i=e[r];if(" "==i||"\r"==i||"\n"==i||"|"==i||"["==i||"]"==i||":"==i||"("==i||")"==i)break;n=i+n}for(var r=t+1;r<e.length;r++){var i=e[r];if(" "==i||"\r"==i||"\n"==i||"|"==i||"["==i||"]"==i||":"==i||"("==i||")"==i||","==i)break;n+=i}return n}function p(e,t){var n=m(e,t);if(n){if(F.ASTNodeImpl.isInstance(n)){var r=n;return{node:r,results:r.findReferences()}}F.ASTPropImpl.isInstance(n)}var i=s(F.fromUnit(e),t,t,!1);if(F.ASTNodeImpl.isInstance(i))return{node:i,results:i.findReferences()};if(F.ASTPropImpl.isInstance(i)){var a=i;if(a.property().canBeValue())return{node:a.parent(),results:a.parent().findReferences()}}return{node:null,results:[]}}function c(e,t){var n=e;if(n.getAdapter(V.RAMLPropertyService).isTypeExpr()){var i=r(t).filter(function(e){var t=e.definition().key();return t===B.Universe08.GlobalSchema||e.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)});return i}if(n.getAdapter(V.RAMLPropertyService).isDescriminating()){var a=b(n.range(),t);return a}if(n.isReference()){var o=n.referencesTo(),a=b(o,t);return a}if(n.range().hasValueTypeInHierarchy()){var s=n.range().getAdapter(V.RAMLService);if(s.globallyDeclaredBy().length>0){var i=r(t).filter(function(e){return null!=x.find(s.globallyDeclaredBy(),function(t){return t==e.definition()})});return i}}return[]}function f(e,t){if(t){var n=[];if(e.getAdapter(V.RAMLPropertyService).isTypeExpr()){var i=r(t).filter(function(e){var t=e.definition().key();return t===B.Universe08.GlobalSchema||e.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)});n=i.map(function(e){return F.qName(e,t)});var a=t.definition().universe().type(B.Universe10.TypeDeclaration.name);if(a){var o=a.allSubTypes();n=n.concat(o.map(function(e){return e.getAdapter(V.RAMLService).descriminatorValue()}))}return n}var s=e.range().key();if((s==B.Universe08.SchemaString||s==B.Universe10.SchemaString)&&"RAML10"==e.range().universe().version()&&e.range().hasValueTypeInHierarchy()){var i=r(t).filter(function(e){return e.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)});n=i.map(function(e){return F.qName(e,t)})}if(e.getAdapter(V.RAMLPropertyService).isDescriminating()){var o=S(e.domain(),t);n=n.concat(o.map(function(e){return e.getAdapter(V.RAMLService).descriminatorValue()}))}else if(e.isReference()){var u=b(e.referencesTo(),t);n=u.map(function(e){return F.qName(e,t)})}else if(e.range().hasValueTypeInHierarchy()){var l=e.range().getAdapter(V.RAMLService);if(l.globallyDeclaredBy().length>0){var i=r(t).filter(function(e){return null!=x.find(l.globallyDeclaredBy(),function(t){return t==e.definition()})});n=n.concat(i.map(function(e){return F.qName(e,t)}))}}return e.isAllowNull()&&n.push("null"),e.enumOptions()&&(n=n.concat(e.enumOptions())),n}return e.enumOptions()&&"string"==typeof e.enumOptions()?[e.enumOptions()+""]:e.enumOptions()}function h(e){return e.isElement()&&e.asElement().definition().key()!=B.Universe10.Library?null:e.asElement().attrValue("name")}function d(e,t){var n=e.lowLevel().unit();if(!n)return null;var r=e.lowLevel().start(),i=e.lowLevel().end();if(null!=t&&t==H.KEY_COMPLETION?(r=e.lowLevel().keyStart(),i=e.lowLevel().keyEnd()):null!=t&&t==H.VALUE_COMPLETION&&(r=e.lowLevel().valueStart(),i=e.lowLevel().valueEnd()),r==-1||i==-1)return null;var a=Math.floor((r+i)/2);return m(n,a,t)}function m(e,t,n){var r=s(F.fromUnit(e),t,t,!1),a=null;if(r.isElement()&&r.asElement().definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)&&r.asElement().directChildren().forEach(function(e){if(e.isUnknown()&&e.getLowLevelStart()<t&&e.getLowLevelEnd()>t){var n=r.asElement().localType();n.allFacets().forEach(function(t){if(t.nameId()==e.lowLevel().key()&&k.UserDefinedProp.isInstance(t)){var n=i(t);a=n}})}}),!r.property())return r;if("example"==r.property().nameId()){r.parent().localType();r.lowLevel().children().forEach(function(e){"example"==e.key()&&e.children().forEach(function(e){if(e.start()<t&&e.end()>t){var n=r.parent().asElement().localType();n.allProperties().forEach(function(t){if(t.nameId()==e.key()&&k.UserDefinedProp.isInstance(t)){var n=i(t);a=n}})}})})}if(a)return a;var o=null!=n?n:_(e.contents(),t);if(o==H.VALUE_COMPLETION){var l=r;if(F.ASTPropImpl.isInstance(r)){var p=r;if(p&&p.value()){if(!F.StructuredValue.isInstance(p.value()))return W(t,e.contents(),p,l);var c=p.value(),f=c.toHighLevel();if(f){var h=x.find(f.attrs(),function(e){return e.lowLevel().start()<t&&e.lowLevel().end()>=t});if(h)return W(t,e.contents(),h,f,p.property())}}}else{var d=l.property();if(d)return W(t,e.contents(),null,l,d)}}if(o==H.KEY_COMPLETION||o==H.SEQUENCE_KEY_COPLETION){var l=r,m=r.property();if(D.UserDefinedProp.isInstance(m)){var g=m;return i(g)}if(F.ASTNodeImpl.isInstance(r)&&D.isUserDefinedClass(l.definition())){var A=l.definition();return A.isAssignableFrom("TypeDeclaration")?r:A.getAdapter(V.RAMLService).getDeclaringNode()}if(F.ASTPropImpl.isInstance(r)){var T=r;if(E(T)){var S=y(T);if(S){var N=v(T,S);if(N){var r=s(N,t,t);if(m=r.property(),D.UserDefinedProp.isInstance(m)){var g=m;return i(g)}if(F.ASTNodeImpl.isInstance(r)&&D.isUserDefinedClass(l.definition())){var A=l.definition();return A.getAdapter(V.RAMLService).getDeclaringNode()}}}}}}if(o==H.PATH_COMPLETION){var I=u(e.contents(),t);if(I){var b=e.resolve(I);return b}}}function y(e){var t=null;if(e.isElement()?t=e:e.isAttr()&&(t=e.parent()),!t.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)){var n=t.parent();if(!n)return null;if(n.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name))t=n;else{if(n=n.parent(),null==n)return null;if(!n.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name))return null;t=n}}return t.localType()}function v(e,t){return F.StructuredValue.isInstance(e.value())?new F.ASTNodeImpl(e.value().lowLevel(),e.parent(),t,e.property()):null}function g(e,t){return new F.ASTNodeImpl(e.lowLevel(),e,t,e.property())}function A(e){return e.definition().key()==B.Universe10.ExampleSpec}function E(e){var t=B.Universe10.TypeDeclaration.properties.example.name,n=B.Universe10.ObjectTypeDeclaration.name;if(!F.ASTPropImpl.isInstance(e))return!1;var r=e,i=r.parent(),a=i&&i.property();a&&a.nameId();return!!(t===r.name()&&r.isString()&&F.ASTNodeImpl.isInstance(i)&&i.definition().isAssignableFrom(n))}function _(e,t){for(var n=!1,r=!1,i=!1,a=t-1;a>=0;a--){var s=e.charAt(a);if("("==s)i=!0;else{if(i){if("\r"==s||"\n"==s){for(var u=!1,l=t-1;l<e.length;l++){var p=e[l];if(")"==p&&(u=!0),"\r"==p||"\n"==p)break;if(":"==p){i=!1;break}}if(i&&u)return H.ANNOTATION_COMPLETION;break}if(" "==s||"\t"==s)continue;break}if("\r"==s||"\n"==s)break;if(":"==s)break}}for(var a=t-1;a>=0;a--){var s=e.charAt(a);if("#"==s){if(0==a)return H.VERSION_COMPLETION;for(var l=a-1;l>=0;l--){var c=e.charAt(l);if("\r"==c||"\n"==c)break;if("!"==c&&e.indexOf("!include",l)==l)return H.PATH_COMPLETION}return H.INCOMMENT}if(":"==s)return n?H.DIRECTIVE_COMPLETION:H.VALUE_COMPLETION;if("\r"==s||"\n"==s){for(var f=!1,h=o(t,e),d=a;d>0;d--){if(s=e.charAt(d),":"==s){if(f){var m=o(d,e);if(m.length<h.length)return H.VALUE_COMPLETION}break}"|"!=s?("\r"!=s&&"\n"!=s||(f=!1)," "!=s&&"\t"!=s&&(f=!1)):f=!0}return r?H.SEQUENCE_KEY_COPLETION:H.KEY_COMPLETION}if("-"==s&&(r=!0),"!"==s){if(e.indexOf("!include",a)==a)return H.PATH_COMPLETION;e.indexOf("!i",a)==a&&(n=!0)}}}function T(e,t){if(!t)return null;for(var n=t.split("/"),r=e,i=0;i<n.length;i++)if("#"!=n[i]){if(r=x.find(r.children(),function(e){return e.key()==n[i]}),!r)return null}else r=e.unit().ast();return r}function S(e,n){if(null==e)return[];var i=e.nameId();n=t.declRoot(n);var a=n;if(a._subTypesCache){var o=a._subTypesCache[i];if(o)return o}else a._subTypesCache={};var s=e.allSubTypes();if(e.getAdapter(V.RAMLService).getRuntimeExtenders().length>0&&n){var u=r(n),l=e.getAdapter(V.RAMLService).getRuntimeExtenders();n.root();l.forEach(function(t){var n=u.filter(function(n){var r=n.definition().allSuperTypes();r.push(n.definition());var i=n.definition()==t||null!=x.find(r,function(e){return e==t})||null!=x.find(r,function(t){return t==e});return i});s=s.concat(n.map(function(e){return e.localType()}))})}return s=x.unique(s),a._subTypesCache[i]=s,s}function N(e,n,i){n=t.declRoot(n);var a=r(n),o=x.find(a,function(t){return F.qName(t,n)==e&&t.property()&&t.property().nameId()==B.Universe10.LibraryBase.properties.types.name});return o.localType()}function I(e,n,i){n=t.declRoot(n);var a=r(n),o=x.find(a,function(t){return F.qName(t,n)==e&&t.property()&&t.property().nameId()==B.Universe10.LibraryBase.properties.schemas.name});return o.localType()}function b(e,t){var n=[],i=[e].concat(e.getAdapter(V.RAMLService).getRuntimeExtenders());if(t){var a=t;i.forEach(function(e){var t=r(a),i=t.filter(function(t){return t.definition().isAssignableFrom(e.nameId())});n=n.concat(i)})}var o=!e.hasValueTypeInHierarchy();if(o&&e.getAdapter(V.RAMLService).isInlinedTemplates()&&t){var a=t,s=r(a).filter(function(t){return t.definition()==e});n=n.concat(s)}else{var a=t,u={};e.allSubTypes().forEach(function(e){return u[e.nameId()]=!0}),u[e.nameId()]=!0;var s=r(a).filter(function(e){return u[e.definition().nameId()]});n=n.concat(s)}return n}function R(e,t){var n=e.range();return S(n,t)}function M(e,t){if(t){if(e.isDescriminator()){var n=e.range(),i=n.getAdapter(V.RAMLService).getRuntimeExtenders();if(i.length>0&&t){var a=[];return i.forEach(function(e){var n=r(t).filter(function(t){return t.definition()==e});a=a.concat(n)}),a}return[]}if(e.isReference())return b(e.referencesTo(),t);if(e.range().hasValueTypeInHierarchy()){var o=e.range().getAdapter(V.RAMLService);if(o.globallyDeclaredBy&&o.globallyDeclaredBy().length>0){var s=r(t).filter(function(e){return null!=x.find(o.globallyDeclaredBy(),function(t){return t==e.definition()})});return s}}}return[]}function C(e){var t=[];return w(e,t),t}function w(e,t){e.children().forEach(function(e){t.push(e),w(e,t)})}function P(e,t,n){e.elements().forEach(function(e){P(e,t,n);e.definition()}),e.attrs().forEach(function(r){var i=r.property(),a=r.value();if(D.UserDefinedProp.isInstance(i)){var o=i.node();o==t?n.push(r):o&&o.lowLevel().start()==t.lowLevel().start()&&o.lowLevel().unit()==t.lowLevel().unit()&&n.push(r)}if(E(r)){var s=y(r);if(s){var u=v(r,s);u&&P(u,t,n)}}else if(i.getAdapter(V.RAMLPropertyService).isTypeExpr()&&"string"==typeof a){var l=e.localType();Y(l,r,t,n);var p=h(t);if(p&&a.indexOf(p)!=-1){var c=L(r);c&&c.lowLevel().start()==t.lowLevel().start()&&n.push(r)}}if(i.isReference()||i.isDescriminator()){if("string"==typeof a){var f=M(i,e);x.find(f,function(e){return e.name()==a&&e==t})&&n.push(r);var p=h(t);if(p&&a.indexOf(p)!=-1){var c=L(r);c&&c.lowLevel().start()==t.lowLevel().start()&&n.push(r)}}else if(F.StructuredValue.isInstance(a)){var d=a;if(d){var m=d.valueName(),f=M(i,e);x.find(f,function(e){return e.name()==m&&e==t})&&n.push(r);var g=d.toHighLevel();g&&P(g,t,n);var p=h(t);if(p&&m.indexOf(p)!=-1){var c=L(g);c&&c.lowLevel().start()==t.lowLevel().start()&&n.push(r)}}}}else{var f=M(i,e);x.find(f,function(e){return e.name()==a&&e==t})&&n.push(r)}})}function L(e){if(!e.lowLevel)return null;var t=e.lowLevel();if(!t)return null;if(t.key()){var n=Math.floor((t.keyEnd()+t.keyStart())/2),r=O(t.unit(),n);if(r)return r}if(t.value()){var n=Math.floor((t.valueEnd()+t.valueStart())/2),r=O(t.unit(),n);if(r)return r}return null}function O(e,t){var n=m(e,t);if(n&&n.isElement&&n.isElement())for(var r=n.asElement(),i=r;i;){if(i.definition().key()==B.Universe10.Library)return i;i=i.parent()}return null}Object.defineProperty(t,"__esModule",{value:!0});var D=n(56),U=n(198),x=n(16),k=n(56),F=n(55),B=n(204),V=k,K=n(211),j=n(212);t.declRoot=function(e){for(var t=e;;){if(t.definition().key()==B.Universe10.Library)break;var n=t.parent();if(!n)break;t=n}return t},t.globalDeclarations=r,t.findDeclarations=a,t.deepFindNode=s,t.extractName=l;var W=function(e,t,n,r,a){void 0===a&&(a=n.property());var o=c(a,r),s=l(t,e),u=x.find(o,function(e){return F.qName(e,r)==s});if(u)return u;if(D.UserDefinedProp.isInstance(a)){
var p=a;return i(p)}return null};t.findUsages=p,t.referenceTargets=c,t.enumValues=f,t.findDeclarationByNode=d,t.findDeclaration=m,t.findExampleContentType=y,t.parseDocumentationContent=v,t.parseStructuredExample=g,t.isExampleNode=A,t.isExampleNodeContent=E,t.determineCompletionKind=_;var H;!function(e){e[e.VALUE_COMPLETION=0]="VALUE_COMPLETION",e[e.KEY_COMPLETION=1]="KEY_COMPLETION",e[e.PATH_COMPLETION=2]="PATH_COMPLETION",e[e.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",e[e.VERSION_COMPLETION=4]="VERSION_COMPLETION",e[e.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",e[e.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",e[e.INCOMMENT=7]="INCOMMENT"}(H=t.LocationKind||(t.LocationKind={})),t.resolveReference=T,t.subTypesWithLocals=S,t.subTypesWithName=N,t.schemasWithName=I,t.nodesDeclaringType=b,t.findAllSubTypes=R,t.allChildren=C;var Y=function(e,t,n,r){var i=e.getAdapter(V.RAMLService).getDeclaringNode();if(i&&n.isSameNode(i))return void r.push(t);if(e.isArray()&&Y(e.array().componentType(),t,n,r),e.isUnion()){var a=e.union();Y(a.leftType(),t,n,r),Y(a.rightType(),t,n,r)}e.superTypes().some(function(e){return e.nameId()==n.name()})&&r.push(t)};t.refFinder=P},function(e,t,n){"use strict";function r(e){var t=e.getExtra(p.SOURCE_EXTRA);return null==t?null:l.isSourceProvider(t)?t:f.isLowLevelNode(t)?{getSource:function(){return t.highLevelNode()}}:c.isParseResult(t)?{getSource:function(){return t}}:null}function i(e){return r(e)}function a(e){var t=e.getAdapters();return t?d.find(t,function(e){return l.rt.isParsedType(e)}):null}function o(e){if(!e)return null;var t=e.getExtra(p.SOURCE_EXTRA);if(t)return r(e);var n=a(e);return n?i(n):null}function s(e,t){var n=o(e);return n?{getSource:function(){var e=n.getSource(),r=e.asElement();if(null==r)return null;var i=r.elementsOfKind(h.Universe10.ObjectTypeDeclaration.properties.properties.name);return null==i||0==i.length?null:d.find(i,function(e){return t==e.attrValue(h.Universe10.TypeDeclaration.properties.name.name)})}}:null}function u(e){return s(e.domain(),e.nameId())}Object.defineProperty(t,"__esModule",{value:!0});var l=n(56),p=l.rt,c=n(198),f=n(5),h=n(204),d=n(16);t.getExtraProviderSource=r,t.getRTypeSource=i,t.findRTypeByNominal=a,t.getNominalTypeSource=o,t.getNominalPropertySource=s,t.getNominalPropertySource2=u},function(e,t,n){"use strict";function r(){return Object.keys(h).length>0}function i(e){f.push(e)}function a(e){h[e]=!0}function o(e){delete h[e],f.forEach(function(t){return t(e)})}function s(e){return!!h[e]}function u(e,t){c.set(e,t)}function l(e){return c.get(e)}Object.defineProperty(t,"__esModule",{value:!0});var p=(n(213),n(214)),c=p(50);t.hasAsyncRequests=r,t.addLoadCallback=i;var f=[],h={};t.addNotify=a,t.removeNotity=o,t.isWaitingFor=s,t.set=u,t.get=l},function(e,t){"use strict";var n=function(){function e(e,t,n,r){if("number"!=typeof e)throw new TypeError("statusCode must be a number but was "+typeof e);if(null===t)throw new TypeError("headers cannot be null");if("object"!=typeof t)throw new TypeError("headers must be an object but was "+typeof t);this.statusCode=e;var i={};for(var a in t)i[a.toLowerCase()]=t[a];this.headers=i,this.body=n,this.url=r}return e.prototype.getBody=function(e){if(this.statusCode>=300){var t=new Error("Server responded with status code "+this.statusCode+":\n"+this.body.toString());throw t.statusCode=this.statusCode,t.headers=this.headers,t.body=this.body,t.url=this.url,t}return e&&"string"!=typeof this.body?this.body.toString(e):this.body},e}();e.exports=n},function(e,t,n){var r,i,a;!function(n,o){"use strict";"object"==typeof e&&"object"==typeof e.exports?e.exports=o():(i=[],r=o,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}("object"==typeof window?window:this,function(){"use strict";function e(n){return this instanceof e?void(this._LRUCacheState=new t(n)):new e(n)}function t(e){this.capacity=e>0?+e:Number.MAX_SAFE_INTEGER||Number.MAX_VALUE,this.data=Object.create?Object.create(null):{},this.hash=Object.create?Object.create(null):{},this.linkedList=new n}function n(){this.length=0,this.head=null,this.end=null}function r(e){this.key=e,this.p=null,this.n=null}function i(e,t){t!==e.head&&(e.end?e.end===t&&(e.end=t.n):e.end=t,a(t.n,t.p),a(t,e.head),e.head=t,e.head.n=null)}function a(e,t){e!==t&&(e&&(e.p=t),t&&(t.n=e))}var o=void 0,s=e.prototype;return s.get=function(e){var t=this._LRUCacheState,n=t.hash[e];if(n)return i(t.linkedList,n),t.data[e]},s.set=function(e,t){var n=this._LRUCacheState,a=n.hash[e];return t===o?this:(a||(n.hash[e]=new r(e),n.linkedList.length+=1,a=n.hash[e]),i(n.linkedList,a),n.data[e]=t,n.linkedList.length>n.capacity&&this.remove(n.linkedList.end.key),this)},s.update=function(e,t){return this.has(e)&&this.set(e,t(this.get(e))),this},s.remove=function(e){var t=this._LRUCacheState,n=t.hash[e];return n?(n===t.linkedList.head&&(t.linkedList.head=n.p),n===t.linkedList.end&&(t.linkedList.end=n.n),a(n.n,n.p),delete t.hash[e],delete t.data[e],t.linkedList.length-=1,this):this},s.removeAll=function(){return this._LRUCacheState=new t(this._LRUCacheState.capacity),this},s.info=function(){var e=this._LRUCacheState;return{capacity:e.capacity,length:e.linkedList.length}},s.keys=function(){for(var e=[],t=this._LRUCacheState.linkedList.head;t;)e.push(t.key),t=t.p;return e},s.has=function(e){return!!this._LRUCacheState.hash[e]},s.staleKey=function(){return this._LRUCacheState.linkedList.end&&this._LRUCacheState.linkedList.end.key},s.popStale=function(){var e=this.staleKey();if(!e)return null;var t=[e,this._LRUCacheState.data[e]];return this.remove(e),t},e})},function(e,t){function n(e){if(!e||"object"!=typeof e)throw new TypeError("argument obj is required");var t=e.parameters,n=e.subtype,r=e.suffix,i=e.type;if(!i||!h.test(i))throw new TypeError("invalid type");if(!n||!f.test(n))throw new TypeError("invalid subtype");var o=i+"/"+n;if(r){if(!h.test(r))throw new TypeError("invalid suffix");o+="+"+r}if(t&&"object"==typeof t)for(var s,u=Object.keys(t).sort(),p=0;p<u.length;p++){if(s=u[p],!l.test(s))throw new TypeError("invalid parameter name");o+="; "+s+"="+a(t[s])}return o}function r(e){if(!e)throw new TypeError("argument string is required");if("object"==typeof e&&(e=i(e)),"string"!=typeof e)throw new TypeError("argument string is required to be a string");var t,n,r,a=e.indexOf(";"),u=a!==-1?e.substr(0,a):e,l=o(u),c={};for(s.lastIndex=a;n=s.exec(e);){if(n.index!==a)throw new TypeError("invalid parameter format");a+=n[0].length,t=n[1].toLowerCase(),r=n[2],'"'===r[0]&&(r=r.substr(1,r.length-2).replace(p,"$1")),c[t]=r}if(a!==-1&&a!==e.length)throw new TypeError("invalid parameter format");return l.parameters=c,l}function i(e){return"function"==typeof e.getHeader?e.getHeader("content-type"):"object"==typeof e.headers?e.headers&&e.headers["content-type"]:void 0}function a(e){var t=String(e);if(l.test(t))return t;if(t.length>0&&!u.test(t))throw new TypeError("invalid parameter value");return'"'+t.replace(c,"\\$1")+'"'}function o(e){var t=d.exec(e.toLowerCase());if(!t)throw new TypeError("invalid media type");var n,r=t[1],i=t[2],a=i.lastIndexOf("+");a!==-1&&(n=i.substr(a+1),i=i.substr(0,a));var o={type:r,subtype:i,suffix:n};return o}/*!
	 * media-typer
	 * Copyright(c) 2014 Douglas Christopher Wilson
	 * MIT Licensed
	 */
var s=/; *([!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) *= *("(?:[ !\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u0020-\u007e])*"|[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) */g,u=/^[\u0020-\u007e\u0080-\u00ff]+$/,l=/^[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+$/,p=/\\([\u0000-\u007f])/g,c=/([\\"])/g,f=/^[A-Za-z0-9][A-Za-z0-9!#$&^_.-]{0,126}$/,h=/^[A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126}$/,d=/^ *([A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126})\/([A-Za-z0-9][A-Za-z0-9!#$&^_.+-]{0,126}) *$/;t.format=n,t.parse=r},function(e,t,n){"use strict";function r(e){for(var t=-1,n=e.lowLevel().children(),r=0;r<n.length;r++){var i=n[r];if(i.isMapping()){var a=i.asMapping().key.value,o=e.definition().property(a);o&&(o.isFromParentValue()||o.range().hasValueTypeInHierarchy())&&(t=r)}}return t}function i(e,t,n,r){var i=null,a=n&&n.getAdapter(R.RAMLPropertyService).isEmbedMap();if(a&&T.find(e.lowLevel().children(),function(e){return e.key()==n.nameId()})&&(a=!1),r||a){var o=v(e);i=o?o:A.InsertionPoint.atStart()}return i}function a(e){for(var t=e;t.originalNode&&t.originalNode();)t=t.originalNode();return t.asMapping()}function o(e,t){e.isStub()||e.clearChildrenCache();var n=e.children(),r=t.property()&&t.property().getAdapter(R.RAMLPropertyService).isEmbedMap();r&&T.find(e.lowLevel().children(),function(e){return e.key()==t.property().nameId()})&&(r=!1);if(!t.isAttr()&&!r||b.isMethodType(e.definition())&&t.property&&b.isIsProperty(t.property())){var i=t.property().nameId(),o=e.definition(),s=(o.allProperties(),e.lowLevel().children()),u=t.property();if(b.isTraitsProperty(u)||b.isResourceTypesProperty(u))return T.find(s,function(e){return!!e.isMapping()&&a(e).key.value===t.property().nameId()});var l=o.propertyIndex(i);if(l<0)return null;for(var p=0;p<s.length;p++){var c=s[p];if(c.isMapping()){var f=a(c).key.value,h=o.propertyIndex(f);if(h>l){var d=p-1;return d<0?null:(console.log("insert to node: "+d),s[d])}}}return null}for(var m=null,p=0;p<n.length&&n[p].isAttr();p++)n[p].property&&n[p].property()&&b.isIsProperty(n[p].property())||(m=n[p].lowLevel());return null==m&&(m=e.lowLevel()),m}function s(e,t){if(e.isStub()){if(N.ASTNodeImpl.isInstance(t)){var n=t;if(n.isInEdit)return}if(!e._children)return;return void(e._children=e._children.filter(function(e){return e!=t}))}var r=new _.CompositeCommand;if(N.ASTNodeImpl.isInstance(t)){var i=t;i.property().getAdapter(R.RAMLPropertyService).isMerged()?r.commands.push(_.removeNode(e.lowLevel(),i.lowLevel())):1==e.elementsOfKind(i.property().nameId()).length?r.commands.push(_.removeNode(e.lowLevel(),i.lowLevel().parent().parent())):r.commands.push(_.removeNode(e.lowLevel(),i.lowLevel()))}else r.commands.push(_.removeNode(e.lowLevel(),t.lowLevel()));e.lowLevel().execute(r)}function u(e){var t=(e.lowLevel().root(),new _.CompositeCommand),n=A.createMap([]);t.commands.push(_.initRamlFile(e.lowLevel(),n)),e.lowLevel().execute(t);var r=e.root();r._node=n,r.clearChildrenCache()}function l(e,t){if(t!=e.value()){var n=new _.CompositeCommand;if("string"==typeof t){var r=t;e.property().isFromParentKey()||e.property().isAnnotation()?(e.property().isAnnotation()&&(r="("+r+")"),n.commands.push(_.setKey(e.lowLevel(),r))):r&&0!=r.length||e.isEmbedded()?(r||(r=""),n.commands.push(_.setAttr(e.lowLevel(),r))):(n.commands.push(_.removeNode(e.lowLevel().parent(),e.lowLevel())),e.parent().clearChildrenCache())}else{if(e.property().isFromParentKey())throw new Error(M.applyTemplate(C.COULD_NOT_SET_STRUCTURED_VALUE,{key:e.property().nameId()}));var i=t;n.commands.push(_.setAttrStructured(e.lowLevel(),i))}e.lowLevel().execute(n)}}function p(e,t){var n=A.createScalar(t),r=e.lowLevel();r.isScalar()?r=r.parent():r.isMapping();var i=new _.CompositeCommand;i.commands.push(_.insertNode(r,n,null,!0)),e.lowLevel().execute(i),e.parent().clearChildrenCache()}function c(e,t){var n=e.lowLevel();if(n.isScalar())n=n.parent();else if(n.isMapping()){e.lowLevel()}var r=new _.CompositeCommand;r.commands.push(_.insertNode(n,t.lowLevel(),null,!0)),e.lowLevel().execute(r),e.parent().clearChildrenCache()}function f(e){var t=e.lowLevel().parent();if(!e.property().isMultiValue()&&e.isEmbedded())e.setValue("");else{var n=new _.CompositeCommand;n.commands.push(_.removeNode(t,e.lowLevel())),e.lowLevel().execute(n),e.parent().clearChildrenCache()}}function h(e,t){if(!e.property().isMultiValue())throw new Error(C.SETVALUE_ONLY_MULTI_VALUES_PROPERTIES.message);var n=e.parent();if(n&&m(n)){var r=new _.CompositeCommand;return r.commands.push(_.setAttr(n.lowLevel(),t[0])),void n.lowLevel().execute(r)}if(e.isEmpty());else{var i=(n.lowLevel(),n.attributes(e.name()));i.forEach(function(e){return e.remove()})}1==t.length&&e.property().isDescriminator()?n.attrOrCreate(e.name()).setValue(t[0]):t.forEach(function(t){return n.attrOrCreate(e.name()).addValue(t)})}function d(e,t){if(t!=e.name()){var n=new _.CompositeCommand;n.commands.push(_.setKey(e.lowLevel(),t)),e.lowLevel().execute(n)}}function m(e){return!!(e.definition()&&e.definition().isAssignableFrom(I.Universe10.TypeDeclaration.name)&&e.lowLevel()&&e.lowLevel().valueKind()===S.Kind.SCALAR)}function y(e,t,n){var a=A.createMapping(t,n);if(e.definition()&&e.definition().isAssignableFrom(I.Universe10.TypeDeclaration.name)&&e.lowLevel()&&(e.lowLevel().valueKind()===S.Kind.SCALAR||!e.lowLevel()._node.value)){var o=t,s=A.createMapping(o,e.lowLevel().value()),u=new _.CompositeCommand;u.commands.push(_.setAttr(e.lowLevel(),"")),e.lowLevel().execute(u),u=new _.CompositeCommand;var l=i(e,s,e.definition().property(o),!0);u.commands.push(_.insertNode(e.lowLevel(),s,l)),e.lowLevel().execute(u),e.resetChildren();var p=e.attr(o)&&e.attr(o).lowLevel();if(p)return u=new _.CompositeCommand,u.commands.push(_.setAttr(p,n)),p.execute(u),void e.clearChildrenCache()}if(e.isStub()){var c=r(e);e.lowLevel().addChild(a,c+1)}else{e.isEmptyRamlFile()&&e.initRamlFile();var u=new _.CompositeCommand,l=i(e,a,e.definition().property(t),!0);u.commands.push(_.insertNode(e.lowLevel(),a,l)),e.lowLevel().execute(u)}e.clearChildrenCache()}function v(e){var t=e.lowLevel().children(),n=r(e);return n<0?null:t[n]}function g(e,t){!e.isStub()&&e.isEmptyRamlFile()&&e.initRamlFile();var n=t.lowLevel();if(e._children||(e._children=[]),!t.property()){var i=t,a=e.definition().allProperties(),s=null;if(a.forEach(function(e){var t=e.range();t==i.definition()&&(s=e);var n=T.find(i.definition().allSuperTypes(),function(e){return e==t});n&&(s=e)}),!s)throw new Error(C.UNABLE_TO_FIND_CHILD.message);i.patchProp(s)}var u=o(e,t),l=new _.CompositeCommand,p=null;if(t.property().getAdapter(R.RAMLPropertyService).isMerged()||t.property().range().hasValueTypeInHierarchy())l.commands.push(_.insertNode(e.lowLevel(),t.lowLevel(),u)),p=e.lowLevel();else{var c=t.property().nameId(),f=e.lowLevel(),h=e.lowLevel().find(c);if(p=h,h){var d=null===h.value()&&h.key&&h.key()===I.Universe10.Api.properties.types.name,m=!d&&t.property().getAdapter(R.RAMLPropertyService).isEmbedMap();l.commands.push(_.insertNode(h,t.lowLevel(),u,m))}else{var y=null;if(t.property().getAdapter(R.RAMLPropertyService).isEmbedMap()){var v="RAML10"==e.definition().universe().version();y=n.isValueMap()&&v?A.createMapNode(c):b.isLibraryType(e.definition())&&b.isTraitsProperty(t.property())&&v?A.createMapNode(c):b.isLibraryType(e.definition())&&b.isResourceTypesProperty(t.property())&&v?A.createMapNode(c):b.isLibraryBaseSibling(e.definition())&&b.isTypesProperty(t.property())&&v?A.createMapNode(c):A.createSeqNode(c),y.addChild(t.lowLevel())}else y=A.createNode(c),y.addChild(t.lowLevel());l.commands.push(_.insertNode(f,y,u)),p=f}}if(e.isStub()){var g=r(e);return g<0?e._children.push(t):e._children.splice(g,0,t),void l.commands.forEach(function(e){return p.addChild(e.value)})}e.lowLevel().execute(l),e._children.push(t),t.setParent(e)}Object.defineProperty(t,"__esModule",{value:!0});var A=n(4),E=n(56),_=n(5),T=n(16),S=n(21),N=n(55),I=n(204),b=n(205),R=E,M=n(19),C=n(207);t.removeNodeFrom=s,t.initEmptyRAMLFile=u,t.setValue=l,t.addStringValue=p,t.addStructuredValue=c,t.removeAttr=f,t.setValues=h,t.setKey=d,t.createAttr=y,t.addToNode=g},function(e,t,n){"use strict";function r(e){if(!M.BasicNodeImpl.isInstance(e))return null;var t=e,n=i(t.highLevel());if(!n)return null;var r=n.wrapperNode();return r.setAttributeDefaults(t.getDefaultsCalculator().isEnabled()),r}function i(e){if(null==e)return null;var t=e.definition();if(!t||!O.isApiSibling(t))return null;var n=(new x).expandTraitsAndResourceTypes(e);return n}function a(e){if(!e)return null;var t=s(e.highLevel());if(!t)return null;var n=t.wrapperNode();return n.setAttributeDefaults(e.getDefaultsCalculator().isEnabled()),n}function o(e){if(!e)return null;var t=u(e.highLevel());if(!t)return null;var n=t.wrapperNode();return n.setAttributeDefaults(e.getDefaultsCalculator().isEnabled()),n}function s(e){return(new k).expandLibraries(e)}function u(e){return(new k).expandLibrary(e)}function l(e,t,n){var r=T.fromUnit(e);if(!r)throw new Error("couldn't load api from "+e.absolutePath());if(!t||0==t.length)return r.asElement();for(var i=[],a=0;a<t.length;a++){var o=t[a],s=T.fromUnit(o);if(!s)throw new Error("couldn't load api from "+o.absolutePath());i.push(s)}var u=p(r.asElement(),i,n);return u}function p(e,t,n,r,i){void 0===r&&(r=null),void 0===i&&(i=!1);for(var a,o=e,s=0,u=t;s<u.length;s++){var l=u[s];i&&I.LowLevelProxyNode.isInstance(o.lowLevel())&&(a||(a=new x),a.expandHighLevelNode(o,r,e,i)),l.overrideMaster(o),l.setMergeMode(n),o=l}return o}function c(e){for(var t=[],n=0,r=e;n<r.length;n++){var i=r[n];f(t,i,!0)}return t}function f(e,t,n){void 0===n&&(n=!1);var r=n?e:e.concat([]),i=t.unit();if(null==i)return r;if(0==r.length)r.push(i);else{var a=r[r.length-1].absolutePath();i.absolutePath()!=a&&r.push(i)}return r}function h(e){for(var t=[];e;)t.push(e),e=e.parent();return c(t)}function d(){return B.map(function(e){return e.name})}function m(e){for(var t=[],n=e.split("|").slice(1),r=0,i=n;r<i.length;r++)for(var a=i[r],o=0;o<B.length;o++)if(a.match(B[o].regexp)){t.push(B[o].transformer);break}return t}function y(e){if(!W){W={};for(var t=L.getUniverse("RAML10").type(L.universesInfo.Universe10.Method.name),n=0,r=t.property(L.universesInfo.Universe10.Method.properties.method.name).enumOptions();n<r.length;n++){var i=r[n];W[i]=!0}}return W[e]}function v(e,t,n,r){if(!e)return null;var i="",a=e,o=e.lastIndexOf(".");o>=0&&(i=e.substring(0,o),a=e.substring(o+1));for(var s,u=!1,l=r,p=l.length;p>0;p--){var c=l[p-1],f=T.ramlFirstLine(c.contents()),h=f&&3==f.length&&f[2];if(h==L.universesInfo.Universe10.Library.name){if(u)break;u=!0}var d=c;if(i){d=null;var m=n.nsMap(c);if(m){var y=m[i];y&&(d=y.unit)}}if(d){var v=n.unitModel(d),g=v[t];if(P.ElementsCollection.isInstance(g)){if(s=g.getElement(a))break;if(1==p&&(h==L.universesInfo.Universe10.Extension.name||h==L.universesInfo.Universe10.Overlay.name)){var A=P.extendedUnit(c);A&&(p++,r[0]=A)}}}}return s}function g(e){var t=e.children().filter(function(e){var t=e.key();return t&&t.length>0&&"/"==t.charAt(0)});return t}function A(e){return e?"*/*"==e?null:(e.indexOf("/*")==e.length-2&&(e=e.substring(0,e.length-2)+"/xxx"),D.parse(e)):null}var E=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var _=n(4),T=n(55),S=n(21),N=n(15),I=n(199),b=n(218),R=n(16),M=n(219),C=n(223),w=n(206),P=n(224),L=n(56),O=n(205),D=(n(207),n(215)),U=n(225);t.expandTraitsAndResourceTypes=r,t.expandTraitsAndResourceTypesHL=i,t.expandLibraries=a,t.expandLibrary=o,t.expandLibrariesHL=s,t.expandLibraryHL=u,t.mergeAPIs=l;var x=function(){function e(){}return e.prototype.expandTraitsAndResourceTypes=function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1),this.init(e);var r=e.lowLevel();if(!r)return e;if(r.actual().libExpanded)return e;var i=this.createHighLevelNode(e,!1,t);if(e.definition().key()==L.universesInfo.Universe10.Overlay)return i;var a=e.lowLevel().unit(),o=a.project().namespaceResolver().hasFragments(a),s=this.expandHighLevelNode(i,t,e,o);return s?s:e},e.prototype.init=function(e){var t=e.lowLevel(),n=T.ramlFirstLine(t.unit().contents());n&&n.length>=2&&"0.8"==n[1]?this.ramlVersion="RAML08":this.ramlVersion="RAML10";var r=t.children().filter(function(e){return e.key()==L.universesInfo.Universe10.Api.properties.mediaType.name});r.length>0&&(this.defaultMediaType=r[0].value());var i=e.lowLevel().unit(),a=i.project();a.setMainUnitPath(i.absolutePath()),this.namespaceResolver=a.namespaceResolver()},e.prototype.expandHighLevelNode=function(e,t,n,r){var i=this;void 0===r&&(r=!1),this.init(e),e.setMergeMode(n.getMergeMode());var a=!1,o=e.lowLevel();if(I.LowLevelCompositeNode.isInstance(o)){var s=g(o);s.forEach(function(e){return a=i.processResource(e)||a})}if(!a&&!r&&null==e.getMaster())return null;if(T.ASTNodeImpl.isInstance(e)){var u=e;null!=u.reusedNode()&&u.setReuseMode(!0)}return"RAML10"==this.ramlVersion&&(t=t||new C.ReferencePatcher,t.process(o),o.actual().referencePatcher=t),e},e.prototype.createHighLevelNode=function(e,t,n,r,i){void 0===t&&(t=!0),void 0===n&&(n=null),void 0===r&&(r=!1),void 0===i&&(i=!0),i&&this.init(e);for(var a=e,o=[],s=a;s;){var u,l=s.lowLevel(),c=T.ramlFirstLine(l.unit().contents());c&&(c.length<3||c[2]!=L.universesInfo.Universe10.Overlay.name)||r?(I.LowLevelCompositeNode.isInstance(l)&&(l=l.originalNode().originalNode()),u=new I.LowLevelCompositeNode(l,null,null,this.ramlVersion)):u=l;var f=s.definition(),h=new T.ASTNodeImpl(u,null,f,null);if(h.setUniverse(s.universe()),o.push(h),!t)break;R.find(l.children(),function(e){return e.key()==L.universesInfo.Universe10.Overlay.properties.extends.name});s=s.getMaster()}var d=o.pop();o=o.reverse();var m=a.getMergeMode(),y=p(d,o,m,n,r);return y.setReusedNode(a.reusedNode()),y},e.prototype.processResource=function(e,t){var n=this;void 0===t&&(t=[]);var r=!1,i=t.concat(e),a=this.collectResourceData(e,e,void 0,void 0,i);if(!I.LowLevelProxyNode.isInstance(e))return r;e.preserveAnnotations(),e.takeOnlyOriginalChildrenWithKey(L.universesInfo.Universe10.ResourceBase.properties.type.name),e.takeOnlyOriginalChildrenWithKey(L.universesInfo.Universe10.FragmentDeclaration.properties.uses.name),a.filter(function(e){return null!=e.resourceType}).forEach(function(t){var n=t.resourceType.node,i=t.resourceType.transformer;i.owner=e,e.adopt(n,i),r=!0});for(var o,s=e.children().filter(function(e){return y(e.key())}),u=function(){var e=c.key();c.takeOnlyOriginalChildrenWithKey(L.universesInfo.Universe10.FragmentDeclaration.properties.uses.name),o=[],a.forEach(function(t){var n=t.methodTraits[e];n&&(o=o.concat(n),n.forEach(function(e){var t=e.node,n=e.transformer;n.owner=c,c.adopt(t,n),r=!0}));var i=t.traits;i&&(o=o.concat(i),i.forEach(function(e){var t=e.node,n=e.transformer;n.owner=c,c.adopt(t,n),r=!0}))})},l=0,p=s;l<p.length;l++){var c=p[l];u()}var f=g(e);return f.forEach(function(e){return r=n.processResource(e,i)||r}),s.forEach(function(e){return n.mergeBodiesForMethod(e)}),r},e.prototype.mergeBodiesForMethod=function(e){var t=e;if(I.LowLevelCompositeNode.isInstance(t)&&null!=this.defaultMediaType){for(var n,r=[],i=t.children(),a=0,o=i;a<o.length;a++){var s=o[a];if(s.key()==L.universesInfo.Universe10.Method.properties.body.name)n=s;else if(s.key()==L.universesInfo.Universe10.Method.properties.responses.name)for(var u=s.children(),l=0,p=u;l<p.length;l++)for(var c=p[l],f=c.children(),h=0,d=f;h<d.length;h++){var m=d[h];m.key()==L.universesInfo.Universe10.Response.properties.body.name&&r.push(m)}}n&&r.push(n);for(var y=0,v=r;y<v.length;y++){var g=v[y];this.mergeBodies(g)}}},e.prototype.mergeBodies=function(e){for(var t,n=[],r=[],i=[],a=[],o=!1,s=0,u=e.children();s<u.length;s++){var l=u[s],p=l.key();if(p==this.defaultMediaType)t=l,i.push({node:C.toOriginal(l),transformer:l.transformer()});else try{A(p),r.push(l)}catch(e){var c=C.toOriginal(l).parent();a.indexOf(c)<0&&(i.push({node:c,transformer:l.transformer()}),a.push(c)),Y[l.key()]&&(o=!0),n.push(l)}}if(0==n.length||null==t&&0==r.length)return!1;if(o){for(var f=0,h=n;f<h.length;f++){var l=h[f];e.removeChild(l)}if(null==t){var d=C.toOriginal(e),m=S.newMapping(S.newScalar(this.defaultMediaType),S.newMap([])),y=new _.ASTNode(m,d.unit(),d,null,null);t=e.replaceChild(null,y)}return t.patchAdoptedNodes(i),!0}},e.prototype.collectResourceData=function(e,t,n,r,i,a){void 0===n&&(n=[]),void 0===i&&(i=[]),void 0===a&&(a={}),i=i.concat([t]);for(var o=this.extractTraits(t,r,i),s={},u=0,l=t.children();u<l.length;u++){var p=l[u],f=p.key();if(y(f)){var h=this.extractTraits(p,r,i);h&&h.length>0&&(s[f]=h)}}var d,m=R.find(t.children(),function(e){return e.key()==L.universesInfo.Universe10.ResourceBase.properties.type.name});if(null!=m){var v=c(i);m.valueKind()==S.Kind.SCALAR&&(m=_.createScalar(m.value())),d=this.readGenerictData(e,m,t,"resource type",r,v)}var g={resourceType:d,traits:o,methodTraits:s};if(n.push(g),d){var A=d.node,E=A.key()+"/"+A.unit().absolutePath();a[E]?g.resourceType=null:(a[E]=!0,this.collectResourceData(e,A,n,d.transformer,i,a))}return n},e.prototype.extractTraits=function(e,t,n,r){void 0===r&&(r={}),n=n.concat([e]);for(var i=[],a=-1;a<i.length;a++)for(var o=a<0?null:i[a],s=o?o.node:e,u=o?o.unitsChain:c(n),l=o?o.transformer:t,p=0,h=s.children().filter(function(e){return e.key()==L.universesInfo.Universe10.MethodBase.properties.is.name});p<h.length;p++)for(var d=h[p],m=0,y=d.children();m<y.length;m++){var v=y[m],g=f(u,v),A=this.readGenerictData(e,v,s,"trait",l,g);if(A){var E=A.name;r[E]=!0,i.push(A)}}return i},e.prototype.readGenerictData=function(e,t,n,r,i,a){void 0===a&&(a=[]);var o=t.value();if(o){var s,u=b.plural(U.camelCase(r)),l=!1;if("string"==typeof o)s=o;else{if(!_.ASTNode.isInstance(o)&&!I.LowLevelProxyNode.isInstance(o))return null;l=!0,s=o.key()}if(!s)return null;i&&(s=i.transform(s).value);var p={},c={},f={},h=v(s,u,this.namespaceResolver,a);if(h){var d=new j(e,null,a);if(l){if("RAML08"==this.ramlVersion)o.children().forEach(function(e){return p[e.key()]=e.value()});else for(var m=0,y=o.children();m<y.length;m++){var g=y[m],A=C.toOriginal(g),E=g.resolvedValueKind();E==S.Kind.SCALAR||E?(p[g.key()]=A.value(),c[g.key()]=A):f[g.key()]=A}Object.keys(p).forEach(function(e){var t=d.transform(p[e]);t&&"object"!=typeof t&&(p[e]=t)})}var T=new K(r,s,a,p,c,f,i),N=new j(null,T,a);return{name:s,transformer:N,parentTransformer:i,node:h,ref:t,unitsChain:a}}return null}},e}();t.TraitsAndResourceTypesExpander=x;var k=function(){function e(){}return e.prototype.expandLibraries=function(e){var t=e;if(null==t)return null;if(!O.isApiSibling(e.definition()))return null;I.LowLevelCompositeNode.isInstance(t.lowLevel())&&(t=t.lowLevel().unit().highLevel().asElement());var n=new x,r=new C.ReferencePatcher,i=n.createHighLevelNode(t,!0,r,!0),a=n.expandHighLevelNode(i,r,t,!0);return this.processNode(r,a),a},e.prototype.expandLibrary=function(e){var t=e;if(null==t)return null;var n=new x,r=new C.ReferencePatcher,i=n.createHighLevelNode(t,!0,r,!0),a=i.lowLevel();return r.process(a),r.expandLibraries(a,!0),i},e.prototype.processNode=function(e,t){if(null!=t){var n=t.getMaster();this.processNode(e,n);var r=t.lowLevel(),i=T.ramlFirstLine(r.unit().contents());3==i.length&&"Overlay"==i[2]&&e.process(r),e.expandLibraries(r)}},e}();t.LibraryExpander=k,t.toUnits=h;var F=function(){function e(t,n){this.name=t,this.regexp=new RegExp(e.leftTransformRegexp.source+t+e.rightTransformRegexp.source),this.transformer=n}return e.leftTransformRegexp=/\s*!\s*/,e.rightTransformRegexp=/\s*$/,e}(),B=[new F("singularize",function(e){return b.singular(e)}),new F("pluralize",function(e){return b.plural(e)}),new F("uppercase",function(e){return e?e.toUpperCase():e}),new F("lowercase",function(e){return e?e.toLowerCase():e}),new F("lowercamelcase",function(e){return e?U.camelCase(e):e}),new F("uppercamelcase",function(e){if(!e)return e;var t=U.camelCase(e);return t[0].toUpperCase()+t.substring(1,t.length)}),new F("lowerunderscorecase",function(e){if(!e)return e;var t=U.snake(e);return t.toLowerCase()}),new F("upperunderscorecase",function(e){if(!e)return e;var t=U.snake(e);return t.toUpperCase()}),new F("lowerhyphencase",function(e){if(!e)return e;var t=U.param(e);return t.toLowerCase()}),new F("upperhyphencase",function(e){if(!e)return e;var t=U.param(e);return t.toUpperCase()}),new F("sentencecase",function(e){if(!e)return e;var t=U.sentenceCase(e);return t[0].toUpperCase()+t.substring(1)})];t.getTransformNames=d,t.getTransformersForOccurence=m;var V=function(){function e(){this.buf=null}return e.prototype.append=function(e){""!==e&&(null!=this.buf?null!=e&&("string"!=typeof this.buf&&(this.buf=""+this.buf),this.buf+=e):""!==e&&(this.buf=e))},e.prototype.value=function(){return null!=this.buf?this.buf:""},e}(),K=function(){function e(e,t,n,r,i,a,o){this.templateKind=e,this.templateName=t,this.unitsChain=n,this.scalarParamValues=r,this.scalarParams=i,this.structuredParams=a,this.vDelegate=o}return e.prototype.transform=function(e,t,n,r){var i={},a=[];if("string"==typeof e){if(this.structuredParams&&N.stringStartsWith(e,"<<")&&N.stringEndsWith(e,">>")){var o=e.substring(2,e.length-2),s=this.structuredParams[o];if(null!=s)return{value:s,errors:a}}for(var u=e,l=new V,p=0,c=u.indexOf("<<");c>=0;c=u.indexOf("<<",p)){l.append(u.substring(p,c));var f=c;if(c+="<<".length,p=this.paramUpperBound(u,c),p==-1)break;var h=u.substring(c,p);p+=">>".length;var d,y=u.substring(f,p),o=void 0,v=m(h);if(v.length>0){var g=h.indexOf("|");if(o=h.substring(0,g).trim(),d=this.scalarParamValues[o],d&&"string"==typeof d&&d.indexOf("<<")>=0&&this.vDelegate&&(d=this.vDelegate.transform(d,t,n,r).value),d){w.PatchedReference.isInstance(d)&&(d=d.value());for(var A=0,E=v;A<E.length;A++){var _=E[A];d=_(d)}}}else o=h.trim(),d=this.scalarParamValues[o],d&&"string"==typeof d&&d.indexOf("<<")>=0&&this.vDelegate&&(d=this.vDelegate.transform(d,t,n,r).value);null!==d&&void 0!==d||(i[o]=!0,d=y),l.append(d)}return l.append(u.substring(p,u.length)),{value:l.value(),errors:a}}return{value:e,errors:a}},e.prototype.paramUpperBound=function(e,t){for(var n=0,r=t;r<e.length;r++)if(N.stringStartsWith(e,"<<",r))n++,r++;else if(N.stringStartsWith(e,">>",r)){if(0==n)return r;n--,r++}return e.length},e.prototype.children=function(e){var t=this.substitutionNode(e);return t?t.children():null},e.prototype.valueKind=function(e){var t=this.substitutionNode(e);return t?t.valueKind():null},e.prototype.anchorValueKind=function(e){var t=this.substitutionNode(e);return t&&t.valueKind()==S.Kind.ANCHOR_REF?t.anchorValueKind():null},e.prototype.resolvedValueKind=function(e){var t=this.substitutionNode(e);return t&&t.resolvedValueKind()},e.prototype.includePath=function(e){var t=this.substitutionNode(e);return t?t.includePath():null},e.prototype.substitutionNode=function(e,t,n){void 0===t&&(t=[]),void 0===n&&(n=!1);var r=this.paramName(e,n),i=r&&(this.scalarParams[r]||this.structuredParams[r]);return i?(t.push(i),this.vDelegate?this.vDelegate.substitutionNode(i,t)||i:i):null},e.prototype.paramNodesChain=function(e,t){var n=[];return this.substitutionNode(C.toOriginal(e),n,t),n.length>0?n:null},e.prototype.paramName=function(e,t){var n;t?e.kind()==S.Kind.MAPPING&&(n=(""+e.key()).trim()):e.valueKind()==S.Kind.SCALAR&&(n=(""+e.value()).trim());var r;return n&&(N.stringStartsWith(n,"(")&&N.stringEndsWith(n,")")&&(n=n.substring(1,n.length-1)),N.stringStartsWith(n,"<<")&&N.stringEndsWith(n,">>")&&(r=n.substring(2,n.length-2))),r},e.prototype.definingUnitSequence=function(e){if(e.length<2)return null;if("("==e.charAt(0)&&")"==e.charAt(e.length-1)&&(e=e.substring(1,e.length-1)),e.length<4)return null;if("<<"!=e.substring(0,2))return null;if(">>"!=e.substring(e.length-2,e.length))return null;var t=e.substring(2,e.length-2);return t.indexOf("<<")>=0||t.indexOf(">>")>=0?null:this._definingUnitSequence(t)},e.prototype._definingUnitSequence=function(e){return this.scalarParamValues&&this.scalarParamValues[e]?this.unitsChain:this.vDelegate?this.vDelegate._definingUnitSequence(e):null},e}();t.ValueTransformer=K;var j=function(e){function t(t,n,r){var i=e.call(this,null!=n?n.templateKind:"",null!=n?n.templateName:"",r)||this;return i.owner=t,i.delegate=n,i}return E(t,e),t.prototype.transform=function(t,n,r,i){if(null==t||null!=r&&!r())return{value:t,errors:[]};var a={value:t,errors:[]},o=!1;H.forEach(function(e){return o=o||t.toString().indexOf("<<"+e)>=0}),o&&(this.initParams(),a=e.prototype.transform.call(this,t,n,r,i));var s=null!=this.delegate?this.delegate.transform(a.value,n,r,i):a.value;return null!=r&&r()&&null!=i&&(s.value=i(s.value,this)),s},t.prototype.initParams=function(){for(var e,t,n="",r=this.owner,i=r,a=null;i;){var o=i.key();if(null!=o)if(N.stringStartsWith(o,"/")){if(!t)for(var s=o.split("/"),u=s.length-1;u>=0;u--){var l=s[u];if(l.indexOf("{")==-1){t=s[u];break}l.length>0&&(a=l)}n=o+n}else e=o;i=i.parent()}t||a&&(t=""),this.scalarParamValues={resourcePath:n,resourcePathName:t},e&&(this.scalarParamValues.methodName=e)},t.prototype.children=function(e){return null!=this.delegate?this.delegate.children(e):null},t.prototype.valueKind=function(e){return null!=this.delegate?this.delegate.valueKind(e):null},t.prototype.includePath=function(e){return null!=this.delegate?this.delegate.includePath(e):null},t.prototype.anchorValueKind=function(e){return null!=this.delegate?this.delegate.anchorValueKind(e):null},t.prototype.resolvedValueKind=function(e){return null!=this.delegate?this.delegate.resolvedValueKind(e):null},t.prototype.substitutionNode=function(e,t,n){return void 0===t&&(t=[]),void 0===n&&(n=!1),this.delegate?this.delegate.substitutionNode(e,t,n):null},t.prototype._definingUnitSequence=function(e){return this.scalarParamValues&&this.scalarParamValues[e]?this.unitsChain:this.delegate?this.delegate._definingUnitSequence(e):null},t}(K);t.DefaultTransformer=j;var W,H=["resourcePath","resourcePathName","methodName"];t.isPossibleMethodName=y;var Y={};Y[L.universesInfo.Universe10.TypeDeclaration.properties.type.name]=!0,Y[L.universesInfo.Universe10.TypeDeclaration.properties.example.name]=!0,Y[L.universesInfo.Universe08.BodyLike.properties.schema.name]=!0,Y[L.universesInfo.Universe10.ObjectTypeDeclaration.properties.properties.name]=!0,t.parseMediaType=A},function(e,t,n){!function(t,n){e.exports=n()}(this,function(){function e(e){return"string"==typeof e?new RegExp("^"+e+"$","i"):e}function t(e,t){return e===t?t:e===e.toUpperCase()?t.toUpperCase():e[0]===e[0].toUpperCase()?t.charAt(0).toUpperCase()+t.substr(1).toLowerCase():t.toLowerCase()}function n(e,t){return e.replace(/\$(\d{1,2})/g,function(e,n){return t[n]||""})}function r(e,r){return e.replace(r[0],function(i,a){var o=n(r[1],arguments);return""===i?t(e[a-1],o):t(i,o)})}function i(e,t,n){if(!e.length||p.hasOwnProperty(e))return t;for(var i=n.length;i--;){var a=n[i];if(a[0].test(t))return r(t,a)}return t}function a(e,n,r){return function(a){var o=a.toLowerCase();return n.hasOwnProperty(o)?t(a,o):e.hasOwnProperty(o)?t(a,e[o]):i(o,a,r)}}function o(e,t,n,r){return function(r){var a=r.toLowerCase();return!!t.hasOwnProperty(a)||!e.hasOwnProperty(a)&&i(a,a,n)===a}}function s(e,t,n){var r=1===t?s.singular(e):s.plural(e);return(n?t+" ":"")+r}var u=[],l=[],p={},c={},f={};return s.plural=a(f,c,u),s.isPlural=o(f,c,u),s.singular=a(c,f,l),s.isSingular=o(c,f,l),s.addPluralRule=function(t,n){u.push([e(t),n])},s.addSingularRule=function(t,n){l.push([e(t),n])},s.addUncountableRule=function(e){return"string"==typeof e?void(p[e.toLowerCase()]=!0):(s.addPluralRule(e,"$0"),void s.addSingularRule(e,"$0"))},s.addIrregularRule=function(e,t){t=t.toLowerCase(),e=e.toLowerCase(),f[e]=t,c[t]=e},[["I","we"],["me","us"],["he","they"],["she","they"],["them","them"],["myself","ourselves"],["yourself","yourselves"],["itself","themselves"],["herself","themselves"],["himself","themselves"],["themself","themselves"],["is","are"],["was","were"],["has","have"],["this","these"],["that","those"],["echo","echoes"],["dingo","dingoes"],["volcano","volcanoes"],["tornado","tornadoes"],["torpedo","torpedoes"],["genus","genera"],["viscus","viscera"],["stigma","stigmata"],["stoma","stomata"],["dogma","dogmata"],["lemma","lemmata"],["schema","schemata"],["anathema","anathemata"],["ox","oxen"],["axe","axes"],["die","dice"],["yes","yeses"],["foot","feet"],["eave","eaves"],["goose","geese"],["tooth","teeth"],["quiz","quizzes"],["human","humans"],["proof","proofs"],["carve","carves"],["valve","valves"],["looey","looies"],["thief","thieves"],["groove","grooves"],["pickaxe","pickaxes"],["whiskey","whiskies"]].forEach(function(e){return s.addIrregularRule(e[0],e[1])}),[[/s?$/i,"s"],[/[^\u0000-\u007F]$/i,"$0"],[/([^aeiou]ese)$/i,"$1"],[/(ax|test)is$/i,"$1es"],[/(alias|[^aou]us|tlas|gas|ris)$/i,"$1es"],[/(e[mn]u)s?$/i,"$1s"],[/([^l]ias|[aeiou]las|[emjzr]as|[iu]am)$/i,"$1"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1i"],[/(alumn|alg|vertebr)(?:a|ae)$/i,"$1ae"],[/(seraph|cherub)(?:im)?$/i,"$1im"],[/(her|at|gr)o$/i,"$1oes"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i,"$1a"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i,"$1a"],[/sis$/i,"ses"],[/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i,"$1$2ves"],[/([^aeiouy]|qu)y$/i,"$1ies"],[/([^ch][ieo][ln])ey$/i,"$1ies"],[/(x|ch|ss|sh|zz)$/i,"$1es"],[/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i,"$1ices"],[/(m|l)(?:ice|ouse)$/i,"$1ice"],[/(pe)(?:rson|ople)$/i,"$1ople"],[/(child)(?:ren)?$/i,"$1ren"],[/eaux$/i,"$0"],[/m[ae]n$/i,"men"],["thou","you"]].forEach(function(e){return s.addPluralRule(e[0],e[1])}),[[/s$/i,""],[/(ss)$/i,"$1"],[/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i,"$1fe"],[/(ar|(?:wo|[ae])l|[eo][ao])ves$/i,"$1f"],[/ies$/i,"y"],[/\b([pl]|zomb|(?:neck|cross)?t|coll|faer|food|gen|goon|group|lass|talk|goal|cut)ies$/i,"$1ie"],[/\b(mon|smil)ies$/i,"$1ey"],[/(m|l)ice$/i,"$1ouse"],[/(seraph|cherub)im$/i,"$1"],[/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|tlas|gas|(?:her|at|gr)o|ris)(?:es)?$/i,"$1"],[/(analy|ba|diagno|parenthe|progno|synop|the|empha|cri)(?:sis|ses)$/i,"$1sis"],[/(movie|twelve|abuse|e[mn]u)s$/i,"$1"],[/(test)(?:is|es)$/i,"$1is"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1us"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i,"$1um"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i,"$1on"],[/(alumn|alg|vertebr)ae$/i,"$1a"],[/(cod|mur|sil|vert|ind)ices$/i,"$1ex"],[/(matr|append)ices$/i,"$1ix"],[/(pe)(rson|ople)$/i,"$1rson"],[/(child)ren$/i,"$1"],[/(eau)x?$/i,"$1"],[/men$/i,"man"]].forEach(function(e){return s.addSingularRule(e[0],e[1])}),["adulthood","advice","agenda","aid","alcohol","ammo","anime","athletics","audio","bison","blood","bream","buffalo","butter","carp","cash","chassis","chess","clothing","cod","commerce","cooperation","corps","debris","diabetes","digestion","elk","energy","equipment","excretion","expertise","flounder","fun","gallows","garbage","graffiti","headquarters","health","herpes","highjinks","homework","housework","information","jeans","justice","kudos","labour","literature","machinery","mackerel","mail","media","mews","moose","music","manga","news","pike","plankton","pliers","pollution","premises","rain","research","rice","salmon","scissors","series","sewage","shambles","shrimp","species","staff","swine","tennis","traffic","transporation","trout","tuna","wealth","welfare","whiting","wildebeest","wildlife","you",/[^aeiou]ese$/i,/deer$/i,/fish$/i,/measles$/i,/o[iu]s$/i,/pox$/i,/sheep$/i].forEach(s.addUncountableRule),s})},function(e,t,n){"use strict";function r(e){var t=e.value();if("string"==typeof t||null==t){
var n=f.createNode(t,null,e.lowLevel().unit());n._actualNode().startPosition=e.lowLevel().valueStart(),n._actualNode().endPosition=e.lowLevel().valueEnd();var r=new c.StructuredValue(n,e.parent(),e.property());return r}return t}function i(e){var t=e._meta;t.resetPrimitiveValuesMeta();var n=e.highLevel();return n.definition().allProperties().forEach(function(r){var i=r.nameId(),a=n.attributes(i),o=!1,s=!1;if(a.forEach(function(e){o=o||null!=e.value(),s=s||e.optional()}),!o){var u=e.getDefaultsCalculator(),l=u.attributeDefaultIfEnabled(n,r);if(null!=l){var p=u.insertionKind(n,r);p==h.InsertionKind.CALCULATED?t.registerCalculatedValue(i):p==h.InsertionKind.BY_DEFAULT&&t.registerInsertedAsDefaultValue(i)}}}),t}function a(e,t){return t?e.map(function(e){return t(e)}):e.map(function(e){return e.value()})}function o(e){var t=[],n=e.errors();null!=n&&(t=t.concat(n));var r=t.map(function(t){return u(e,t)}),i=s(r);return i}function s(e){var t=[],n={};e.map(function(e){n[JSON.stringify(e)]=e});for(var r=Object.keys(n),i=0;i<r.length;i++)t.push(n[r[i]]);return t}function u(e,t){var n;n=t.unit?t.unit:t.node?t.node.lowLevel().unit():d.declRoot(e).lowLevel().unit();var r=n&&n.lineMapper()||e.lowLevel().unit().lineMapper(),i=null;try{i=r.position(t.start)}catch(e){console.warn(e)}var a=null;try{a=r.position(t.end)}catch(e){console.warn(e)}var o=t.path||n&&n.path(),s={code:t.code,message:t.message,path:o,range:{start:i,end:a},isWarning:t.isWarning};return t.extras&&t.extras.length>0&&(s.trace=t.extras.map(function(t){return u(e,t)})),s}function l(e){if(e.isScalar())return!0;for(var t=e.allSuperTypes().filter(function(e){return e.isUnion()||e.isIntersection()}),n=0,r=t;n<r.length;n++){for(var i=r[n],a=!0,o=0,s=i.allOptions();o<s.length;o++){var u=s[o];if(a=a||l(u),!a)break}if(a)return!0}return!1}var p=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var c=n(55),f=n(4),h=(n(56),n(220)),d=n(209),m=n(205),y=n(221),v=n(21),g=function(){function e(e,t){void 0===t&&(t=!0),this._node=e,this._meta=new N(!1,!1,m.isMethodType(this.highLevel().definition())&&this.optional()),t&&e.setWrapperNode(this)}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.wrapperClassName=function(){return"BasicNodeImpl"},e.prototype.kind=function(){return"BasicNode"},e.prototype.allKinds=function(){return["BasicNode"]},e.prototype.allWrapperClassNames=function(){return["BasicNodeImpl"]},e.prototype.parent=function(){var e=this._node.parent();return e?e.wrapperNode():null},e.prototype.highLevel=function(){return this._node},e.prototype.patchNode=function(e){this._node=e},e.prototype.attributes=function(e,t){var n=this._node.attributes(e);if(!n||0==n.length){var r=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(e));return null==r?[]:Array.isArray(r)?r:[r]}return a(n,t)},e.prototype.attribute=function(e,t){var n=this._node.attr(e);if(t&&t!=this.toString&&t!=this.toBoolean&&t!=this.toNumber&&t!=this.toAny)return null==n?null:t(n);var r=n?n.value():null;return null==r&&(r=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(e))),null==r?null:t?t(r):r},e.prototype.elements=function(e){var t=this._node.elementsOfKind(e);return t?t.map(function(e){return e.wrapperNode()}):null},e.prototype.element=function(e){var t=this._node.element(e);return t?t.wrapperNode():null},e.prototype.add=function(e){this.highLevel().add(e.highLevel())},e.prototype.addToProp=function(e,t){var n=e.highLevel(),r=this.highLevel().definition().property(t);n._prop=r,this.highLevel().add(n)},e.prototype.remove=function(e){this.highLevel().remove(e.highLevel())},e.prototype.dump=function(){return this.highLevel().dump("yaml")},e.prototype.toString=function(e){var t;return t=e&&e.lowLevel&&e.property?e.value():e,null!=t?t.toString():t},e.prototype.toAny=function(e){var t;if(e.lowLevel&&e.property){var n=e,r=n.value();t=r?r:new _(n.lowLevel())}else t=e;return c.StructuredValue.isInstance(t)&&(t=new _(t.lowLevel().parent())),t},e.prototype.toBoolean=function(e){var t;return t=e.lowLevel&&e.property?e.value():e,null!=t?"true"==t.toString():t},e.prototype.toNumber=function(e){var t;if(t=e.lowLevel&&e.property?e.value():e,!t)return t;try{var n=parseFloat(t.toString());return n}catch(e){}return Number.MAX_VALUE},e.prototype.errors=function(){return o(this._node)},e.prototype.definition=function(){return this.highLevel().definition()},e.prototype.runtimeDefinition=function(){return m.isTypeDeclarationSibling(this.highLevel().definition())?this.highLevel().localType():null},e.prototype.toJSON=function(e){var t=A;A=this.attributeDefaults();try{return new y.JsonSerializer(e).dump(this)}finally{A=t}},e.prototype.optional=function(){var e=this.highLevel();return null!=e&&e.optional()},e.prototype.optionalProperties=function(){return this.highLevel()?this.highLevel().optionalProperties():[]},e.prototype.getDefaultsCalculator=function(){return this.defaultsCalculator?this.defaultsCalculator:(this.parent()&&(this.defaultsCalculator=this.parent().getDefaultsCalculator()),this.defaultsCalculator||(this.defaultsCalculator=new h.AttributeDefaultsCalculator(A)),this.defaultsCalculator)},e.prototype.setAttributeDefaults=function(e){this.defaultsCalculator=new h.AttributeDefaultsCalculator(e)},e.prototype.attributeDefaults=function(){return this.getDefaultsCalculator()&&this.getDefaultsCalculator().isEnabled()},e.prototype.meta=function(){return i(this)},e.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},e.CLASS_IDENTIFIER="parserCore.BasicNodeImpl",e}();t.BasicNodeImpl=g;var A=!0,E=function(){function e(e){this._meta=new S,this.attr=e}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.highLevel=function(){return this.attr},e.prototype.wrapperClassName=function(){return"AttributeNodeImpl"},e.prototype.kind=function(){return"AttributeNode"},e.prototype.allKinds=function(){return["AttributeNode"]},e.prototype.allWrapperClassNames=function(){return["AttributeNodeImpl"]},e.prototype.optional=function(){var e=this.highLevel();return null!=e&&e.optional()},e.prototype.meta=function(){return this._meta},e.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},e.prototype.parent=function(){var e=this.attr.parent();return e?e.wrapperNode():null},e.prototype.toJSON=function(e){return new y.JsonSerializer(e).dump(this)},e.CLASS_IDENTIFIER="parserCore.AttributeNodeImpl",e}();t.AttributeNodeImpl=E,t.toStructuredValue=r;var _=function(){function e(e,t){this.type=t,Array.isArray(e)?this.children=e:this.node=e}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.properties=function(){return this.isArray()?[]:this.getChildren().map(function(e){return new T(e)})},e.prototype.getChildren=function(){return this.node&&this.node.children()||this.children},e.prototype.value=function(){return this.node&&this.node.value()},e.prototype.isScalar=function(){return!!this.node&&(0==this.node.children().length&&(!this.type||l(this.type)))},e.prototype.toJSON=function(){return(new y.JsonSerializer).serializeTypeInstance(this)},e.prototype.isArray=function(){return!!this.node&&(this.type?this.type.isArray():this.node&&this.node.valueKind()==v.Kind.SEQ)},e.prototype.items=function(){return this.isArray()?this.node.children().map(function(t){return new e(t)}):null},e.CLASS_IDENTIFIER="parserCore.TypeInstanceImpl",e}();t.TypeInstanceImpl=_;var T=function(){function e(e){this.node=e}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.name=function(){return this.node.optional()?this.node.key()+"?":this.node.key()},e.prototype.value=function(){if(this.isArray()){var e=this.node.children();return e.length>0?new _(e[0]):null}return new _(this.node)},e.prototype.values=function(){return this.isArray()?this.node.children().map(function(e){return new _(e)}):[new _(this.node)]},e.prototype.isArray=function(){var e=this.node.children();if(e.length>0&&null==e[0].key())return!0;var t=this.node.highLevelNode();if(t){var n=t.property();if(n){var r=n.range();if(r)return r.isArray()}}return this.node.valueKind()==v.Kind.SEQ},e.CLASS_IDENTIFIER="parserCore.TypeInstancePropertyImpl",e}();t.TypeInstancePropertyImpl=T;var S=function(){function e(e,t,n){void 0===e&&(e=!1),void 0===t&&(t=!1),void 0===n&&(n=!1),this._insertedAsDefault=e,this._calculated=t,this._optional=n}return e.prototype.calculated=function(){return this._calculated},e.prototype.insertedAsDefault=function(){return this._insertedAsDefault},e.prototype.setCalculated=function(){this._calculated=!0},e.prototype.setInsertedAsDefault=function(){this._insertedAsDefault=!0},e.prototype.setOptional=function(){this._optional=!0},e.prototype.optional=function(){return this._optional},e.prototype.isDefault=function(){return!(this._insertedAsDefault||this._calculated||this._optional)},e.prototype.toJSON=function(){var e={};return this._calculated&&(e.calculated=!0),this._insertedAsDefault&&(e.insertedAsDefault=!0),this._optional&&(e.optional=!0),e},e}();t.ValueMetadataImpl=S;var N=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.valuesMeta={},t}return p(t,e),t.prototype.primitiveValuesMeta=function(){return this.valuesMeta},t.prototype.registerInsertedAsDefaultValue=function(e){var t=this.valuesMeta[e];null==t?this.valuesMeta[e]=new S(!0):t.setInsertedAsDefault()},t.prototype.registerCalculatedValue=function(e){var t=this.valuesMeta[e];null==t?this.valuesMeta[e]=new S(!1,!0):t.setCalculated()},t.prototype.registerOptionalValue=function(e){var t=this.valuesMeta[e];null==t?this.valuesMeta[e]=new S(!1,!1,!0):t.setOptional()},t.prototype.resetPrimitiveValuesMeta=function(){this.valuesMeta={}},t.prototype.isDefault=function(){return!!e.prototype.isDefault.call(this)&&0==Object.keys(this.valuesMeta).length},t.prototype.toJSON=function(){var t=this,n=e.prototype.toJSON.call(this),r={},i=Object.keys(this.valuesMeta);return i.length>0&&(i.forEach(function(e){var n=t.valuesMeta[e].toJSON();Object.keys(n).length>0&&(r[e]=n)}),n.primitiveValuesMeta=r),n},t}(S);t.NodeMetadataImpl=N,t.fillElementMeta=i,t.attributesToValues=a,t.errors=o,t.filterErrors=s,t.basicError=u},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(56),i=n(204),a=n(205),o=r,s=n(209),u=function(){function e(e,t){void 0===t&&(t=!1),this.enabled=e,this.toHighLevel=t,this.unconditionalValueCalculators=[new v],this.valueCalculators=[new h,new f,new c,new p,new d(this.toHighLevel),new m,new y]}return e.prototype.attributeDefaultIfEnabled=function(e,t){return this.enabled?this.getAttributeDefault(e,t):this.getUnconditionalAttributeDefault(t,e)},e.prototype.getUnconditionalAttributeDefault=function(e,t){if(!t||!e)return null;for(var n=0;n<this.unconditionalValueCalculators.length;n++){var r=this.unconditionalValueCalculators[n];if(r.matches(e,t)){var i=r.calculate(e,t);if(null!=i)return i}}return null},e.prototype.getAttributeDefault=function(e,t){if(!e||!t)return null;try{return this.getAttributeDefault2(t,e)}catch(e){return console.log(e),null}},e.prototype.getWrapperAttributeDefault=function(e,t){var n=e.highLevel();if(null==n)return null;var r=n.definition().property(t);return null==r?null:this.getAttributeDefault(n,r)},e.prototype.getAttributeDefault2=function(e,t){for(var n=0;n<this.valueCalculators.length;n++){var r=this.valueCalculators[n];if(r.matches(e,t)){var i=r.calculate(e,t);if(null!=i)return i}}return a.isTypeProperty(e)&&t.attr("schema")&&null!=t.attr("schema").value()?null:null!=e.defaultValue()?e.defaultValue():null},e.prototype.isEnabled=function(){return this.enabled},e.prototype.insertionKind=function(e,t){for(var n=0;n<this.valueCalculators.length;n++){var r=this.valueCalculators[n];if(r.matches(t,e))return r.kind(e,t)}return null!=t.defaultValue()?l.BY_DEFAULT:null},e}();t.AttributeDefaultsCalculator=u;var l;!function(e){e[e.CALCULATED=0]="CALCULATED",e[e.BY_DEFAULT=1]="BY_DEFAULT"}(l=t.InsertionKind||(t.InsertionKind={}));var p=function(){function e(){}return e.prototype.calculate=function(e,t){var n=s.declRoot(t);if(n&&a.isApiSibling(n.definition())){var r=n.attr(i.Universe10.Api.properties.mediaType.name);if(r)return r.value()}return null},e.prototype.matches=function(e,t){if(!a.isNameProperty(e))return!1;var n=t.definition();if(!n)return!1;if(!a.isBodyLikeType(n)&&!a.isTypeDeclarationSibling(n))return!1;var r=t.parent();if(null==r)return!1;var i=r.definition();if(null==i)return!1;if(!a.isResponseType(i)&&!a.isMethodBaseSibling(i))return!1;for(var o=r;o;){var s=o.definition();if(a.isTraitType(s))return!1;if(a.isResourceTypeType(s))return!1;o=o.parent()}return!0},e.prototype.kind=function(e,t){return l.CALCULATED},e}(),c=function(){function e(){}return e.prototype.calculate=function(e,t){var n=t.definition();if(null==n)return null;var r=n.getAdapter(o.RAMLService),i=r.getKeyProp();if(null!=i){var a=t.attrValue(i.nameId());return null!=a?a:new u(!0).getAttributeDefault(t,i)}return null},e.prototype.matches=function(e,t){var n=t.definition();return null!=n&&((a.isTypeDeclarationSibling(n)||n.isAssignableFrom(i.Universe08.Parameter.name)||a.isResourceType(n))&&a.isDisplayNameProperty(e))},e.prototype.kind=function(e,t){return l.CALCULATED},e}(),f=function(){function e(){}return e.prototype.calculate=function(e,t){return t.attr("schema")&&null!=t.attr("schema").value()?null:t.lowLevel().children().filter(function(e){return"properties"==e.key()}).length?"object":t.property()&&"body"==t.property().nameId()?"any":"string"},e.prototype.matches=function(e,t){return a.isTypeProperty(e)&&null!=t.definition()&&a.isTypeDeclarationSibling(t.definition())},e.prototype.kind=function(e,t){var n=e.attr("schema");return n&&n.value()?null:l.BY_DEFAULT},e}(),h=function(){function e(){}return e.prototype.calculate=function(e,t){var n=t.definition(),r=t.property();if(null==n)return null;var i=n.getAdapter(o.RAMLService),s=i.getKeyProp();if(null!=s){var u=t.attr(s.nameId());if(null!=u&&u.optional())return!1}if(null!=r){if(a.isHeadersProperty(r)||a.isFormParametersProperty(r)||a.isQueryParametersProperty(r))return"RAML08"!=e.domain().universe().version();if(a.isUriParametersProperty(r)||a.isBaseUriParametersProperty(r))return!0}return null!=e.defaultValue()?e.defaultValue():null},e.prototype.matches=function(e,t){return a.isRequiredProperty(e)},e.prototype.kind=function(e,t){if(a.isRequiredProperty(t)){var n=e.property();if((a.isPropertiesProperty(n)||a.isHeadersProperty(n)||a.isBaseUriParametersProperty(n)||a.isUriParametersProperty(n)||a.isQueryParametersProperty(n))&&e.lowLevel().optional())return null}return l.BY_DEFAULT},e}(),d=function(){function e(e){void 0===e&&(e=!1),this.toHighLevel=e}return e.prototype.calculate=function(e,t){if(a.isApiSibling(t.definition()))return null;var n,r=t.definition();if(a.isMethodType(r)){var i=t.parent();if(i){var o=i.getLastSlaveCounterPart();o&&(i=o),n=this.toHighLevel?i.attributes("securedBy"):i.wrapperNode().securedBy()}}if(!n||0==n.length){for(;null!=t&&!a.isApiSibling(t.definition());)t=t.parent();if(t){var s=t.getLastSlaveCounterPart();s&&(t=s),n=this.toHighLevel?t.attributes("securedBy"):t.wrapperNode().securedBy()}}return n&&n.length>0?n:null},e.prototype.matches=function(e,t){var n=t.definition();return null!=n&&a.isSecuredByProperty(e)},e.prototype.kind=function(e,t){return l.CALCULATED},e}(),m=function(){function e(){}return e.prototype.calculate=function(e,t){for(;null!=t&&!a.isApiSibling(t.definition());)t=t.parent();var n,r=t.attr(i.Universe10.Api.properties.baseUri.name);if(r){var o=r.value();if(o&&"string"==typeof o){var s=o.indexOf("://");s>=0&&(n=[o.substring(0,s).toUpperCase()]),n||(n=["HTTP"])}}return n},e.prototype.matches=function(e,t){if(!a.isProtocolsProperty(e))return!1;var n=t.definition(),r=!1;if(a.isApiSibling(n))r=!0;else if(a.isResourceType(n))r=!0;else if(a.isMethodType(n)){var i=t.parent();r=i&&a.isResourceType(i.definition())}return r},e.prototype.kind=function(e,t){return l.CALCULATED},e}(),y=function(){function e(){}return e.prototype.calculate=function(e,t){for(;null!=t&&!a.isApiSibling(t.definition());)t=t.parent();var n=t.attr(i.Universe10.Api.properties.version.name);if(n){var r=n.value();if(r&&r.trim())return[r]}return null},e.prototype.matches=function(e,t){if(!a.isEnumProperty(e))return!1;var n=t.property();if(!n)return!1;if(!a.isBaseUriParametersProperty(n))return!1;var r=t.attr(i.Universe10.TypeDeclaration.properties.name.name),o=r&&r.value();return"version"==o},e.prototype.kind=function(e,t){return l.CALCULATED},e}(),v=function(){function e(){}return e.prototype.calculate=function(e,t){var n=t.definition();if(null==n)return null;var r=n.getAdapter(o.RAMLService);if(null==r)return null;var i=r.getKeyProp();if(null==i)return null;var a=t.attr(i.nameId());return null==a?null:!a.optional()&&null},e.prototype.matches=function(e,t){return a.isRequiredProperty(e)},e.prototype.kind=function(e,t){return l.BY_DEFAULT},e}()},function(e,t,n){"use strict";function r(e,t){return void 0===t&&(t=!0),new _({rootNodeDetails:!0,serializeMetadata:t}).dump(e)}function i(e){if(e.properties().length)return!1;if(e.annotations().length)return!1;if(e.facets().length)return!1;var t=e.fixedFacets();if(t&&Object.keys(t).length)return!1;var n=e.fixedBuiltInFacets();return(!n||!Object.keys(n).length)&&!e.description()}function a(e){if(!e.parent())return!0;if(e.lowLevel().libProcessed)return!1;if(!m.isLibraryType(e.root().definition()))return!1;var t=e.lowLevel().includePath();if(null==t)return!1;var n=e.lowLevel().unit().resolve(t);return!(!n||!n.contents().startsWith("#%RAML"))}var o=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var s=n(204),u=n(219),l=n(199),p=n(56),c=p.tsInterfaces,f=n(21),h=n(55),d=n(208),m=n(205),y=n(204),v=n(15),g=n(16),A=n(222),E=n(6);t.dump=r;var _=function(){function e(e){this.options=e,this.nodeTransformers=[new q,new K,new j,new $,new R,new U,new x,new X,new L,new O,new W,new H,new k,new z,new G],this.nodePropertyTransformers=[new b,new M,new C,new P,new w,new D,new Y],this.ignore=new S([new T(m.isResponseType,m.isDisplayNameProperty),new T(m.isApiSibling,m.isDisplayNameProperty),new T(m.isAnnotationRefTypeOrDescendant,m.isAnnotationProperty),new T(m.isSecuritySchemeRefType,m.isSecuritySchemeProperty),new T(m.isTraitRefType,m.isTraitProperty),new T(m.isResourceTypeRefType,m.isResourceTypeProperty),new T(m.isApiSibling,m.isRAMLVersionProperty),new T(m.isTypeDeclarationDescendant,m.isStructuredItemsProperty)]),this.missingProperties=new J,this.options=this.options||{},null==this.options.serializeMetadata&&(this.options.serializeMetadata=!0)}return e.prototype.printMissingProperties=function(){return this.missingProperties.print()},e.prototype.dump=function(e){var t=e.highLevel(),n=t&&t.parent(),r=!n&&this.options.rootNodeDetails,i=this.dumpInternal(e,r,!0);return i},e.prototype.dumpInternal=function(e,t,n,r){var i=this;if(void 0===t&&(t=!1),void 0===n&&(n=!1),null==e)return null;if(u.BasicNodeImpl.isInstance(e)){var o={},l=e,c=l.highLevel().definition();c.allProperties().filter(function(e){return!i.ignore.match(l.definition(),e)&&!(!n&&"uses"==e.nameId()&&!a(l.highLevel()))}).forEach(function(e){o[e.nameId()]=e}),c.allCustomProperties().filter(function(e){return!i.ignore.match(l.definition(),e)}).forEach(function(e){o[e.nameId()]=e});var f=this.dumpProperties(o,e);if(o.schema&&this.options.dumpSchemaContents&&o.schema.range().key()==y.Universe08.SchemaString){var d=l.highLevel().root().elementsOfKind("schemas");d.forEach(function(e){if(e.name()==f.schema){var t=e.attr("value");t&&(f.schema=t.value(),f.schemaContent=t.value())}})}if(this.serializeScalarsAnnotations(f,l,o),this.serializeMeta(f,l),this.canBeFragment(e)&&A.isFragment(e)){var v=A.asFragment(e),g=v.uses();g.length>0&&(f.uses=g.map(function(e){return e.toJSON()}))}if(m.isTypeDeclarationDescendant(c)){var E=l.highLevel().property();if(E&&!(m.isHeadersProperty(E)||m.isQueryParametersProperty(E)||m.isUriParametersProperty(E)||m.isPropertiesProperty(E)||m.isBaseUriParametersProperty(E))){delete f.required;var _=f.__METADATA__;if(_){var T=_.primitiveValuesMeta;T&&delete T.required}}}if(this.options.sourceMap&&"object"==typeof f){var S=h.actualPath(e.highLevel());e.highLevel().lowLevel()&&e.highLevel().lowLevel().actual()&&e.highLevel().lowLevel().actual().actualPath&&(S=e.highLevel().lowLevel().actual().actualPath);var N=f.sourceMap;N||(N={},f.sourceMap=N),N.path||(N.path=S)}this.nodeTransformers.forEach(function(t){t.match(e,r||e.highLevel().property())&&(f=t.transform(f,e))});var I={};if(t){if(c){var b=c.universe(),R=b.version();I.ramlVersion=R;var M=c.nameId();if(!M&&c.isAssignableFrom(p.universesInfo.Universe10.TypeDeclaration.name)){var C=b.type(p.universesInfo.Universe10.TypeDeclaration.name),w={};C.allSubTypes().forEach(function(e){return w[e.nameId()]=!0});for(var P=0,L=c.allSuperTypes();P<L.length;P++){var O=L[P];if(w[O.nameId()]){M=O.nameId();break}}}I.type=M}I.specification=f,I.errors=this.dumpErrors(l.errors())}else I=f;return I}if(u.AttributeNodeImpl.isInstance(e)){var o={},D=e,c=D.highLevel().definition(),U=D.highLevel().property().range();U.isArray()&&(U=U.array().componentType()),c.allCustomProperties().filter(function(e){return!i.ignore.match(U,e)}).forEach(function(e){o[e.nameId()]=e});var x=U.isValueType();if(x&&D.value){var k=D.value();if(null==k||"number"==typeof k||"string"==typeof k||"boolean"==typeof k)return k;if(U.isAssignableFrom(s.Universe08.StringType.name)&&h.StructuredValue.isInstance(k)){var F=k,B=F.lowLevel();return k=B?B.dumpToObject():null}}var f=this.dumpProperties(o,e);return this.nodeTransformers.forEach(function(t){t.match(e,e.highLevel().property())&&(f=t.transform(f,e))}),this.serializeScalarsAnnotations(f,e,o),this.serializeMeta(f,D),f}return u.TypeInstanceImpl.isInstance(e)?this.serializeTypeInstance(e):u.TypeInstancePropertyImpl.isInstance(e)?this.serializeTypeInstanceProperty(e):e},e.prototype.canBeFragment=function(e){var t=e.definition(),n=[t].concat(t.allSubTypes()),r=n.filter(function(e){return e.getAdapter(p.RAMLService).possibleInterfaces().filter(function(e){return e.nameId()==p.universesInfo.Universe10.FragmentDeclaration.name}).length>0});return r.length>0},e.prototype.dumpErrors=function(e){var t=this;return e.map(function(e){var n=t.dumpErrorBasic(e);return e.trace&&e.trace.length>0&&(n.trace=t.dumpErrors(e.trace)),n}).sort(function(e,t){return e.path!=t.path?e.path.localeCompare(t.path):null==t.range.start?1:null==e.range.start?-1:e.range.start.position!=t.range.start.position?e.range.start.position-t.range.start.position:e.code-t.code})},e.prototype.dumpErrorBasic=function(e){var t={code:e.code,message:e.message,path:e.path,line:e.line,column:e.column,position:e.start,range:e.range};return e.isWarning===!0&&(t.isWarning=!0),t},e.prototype.stringLooksLikeXML=function(e){return"<"===e[0]&&">"===e[e.length-1]},e.prototype.stringLooksLikeJSON=function(e){return"{"===e[0]&&"}"===e[e.length-1]},e.prototype.dumpProperties=function(e,t){var n,r=this,a={};t.highLevel().isElement()&&(n=t.highLevel().definition());var o={};if(Object.keys(e).forEach(function(l){var y;if(n&&(y=n.property(l),y||(y=g.find(n.allCustomProperties(),function(e){return e.nameId()==l}))),!t[l])return void r.missingProperties.addProperty(e[l],t.kind());var v=e[l],A=t[l](),_=A;if(_&&"structuredType"==l&&"object"==typeof _){_=null;var T=t.highLevel(),S=T.lowLevel();S.children().forEach(function(e){if("type"==e.key()||"schema"==e.key()){var t=T.definition().universe().type(s.Universe10.TypeDeclaration.name),n=T.definition().universe().type(s.Universe10.TypeDeclaration.name),i=new h.ASTNodeImpl(e,T,t,n.property(e.key()));i.patchType(d.doDescrimination(i)),_=r.dumpInternal(i.wrapperNode(),!1,!1,y),l=e.key()}})}else if("items"==l&&"object"==typeof _){var N=Array.isArray(_),I=!N;if(N&&(I=null!=g.find(_,function(e){return"object"==typeof e})),I){_=null;var T=t.highLevel(),S=T.lowLevel();S.children().forEach(function(e){if("items"==e.key()){var t,n=T.definition().universe().type(s.Universe10.TypeDeclaration.name),a=T.definition().universe().type(s.Universe10.ArrayTypeDeclaration.name),o=void 0,u=e,p=void 0;do if(t=!0,o=new h.ASTNodeImpl(u,T,n,a.property(s.Universe10.ArrayTypeDeclaration.properties.items.name)),p=o.localType(),p&&i(p)&&1==p.superTypes().length){var m=u.children().filter(function(e){return"type"==e.key()});if(1==m.length){if(m[0].resolvedValueKind()==f.Kind.SCALAR){_=m[0].value();break}u=m[0],t=!1}}while(!t);null==_&&(o.patchType(d.doDescrimination(o)),_=r.dumpInternal(o.wrapperNode(),!1,!1,y)),p.getExtra(c.TOP_LEVEL_EXTRA)&&"object"==typeof _&&!Array.isArray(_)&&(_=_.type),Array.isArray(_)&&1==_.length&&(_=_[0]),l=e.key()}})}}var b=Array.isArray(_)?_.length>0:null!=_;if(n&&n.isAssignableFrom("TypeDeclaration")&&("type"===l||"schema"==l)&&b)if(Array.isArray(_)){var R=_.length>0?_[0]:null;if(null==R){var M=t.getDefaultsCalculator();if(M){var C=p.getUniverse("RAML10").type("TypeDeclaration").property("type");R=M.attributeDefaultIfEnabled(t.highLevel().asElement(),C)}_[0]=R}var T=t.highLevel(),w=T.localType(),P=!1,L=!1;if(w&&w.hasExternalInHierarchy()){var O=R.trim();P="{"===O[0]&&"}"===O[O.length-1],L="<"===O[0]&&">"===O[O.length-1]}P?a.typePropertyKind="JSON":L?a.typePropertyKind="XML":a.typePropertyKind="TYPE_EXPRESSION"}else"object"==typeof _&&(a.typePropertyKind="INPLACE");if(("type"===l||"schema"==l)&&_&&_.forEach&&"string"==typeof _[0]){var O=_[0].trim(),D=r.stringLooksLikeJSON(O),U=r.stringLooksLikeXML(O);if(D||U){var x=t.highLevel().lowLevel().includePath&&t.highLevel().lowLevel().includePath();if(!x&&t.highLevel().isElement()){var k=t.highLevel().asElement().attr("type");k||(k=t.highLevel().asElement().attr("schema")),k&&(x=k.lowLevel().includePath&&k.lowLevel().includePath())}if(x){var F=x.indexOf("#"),B="";F>=0&&(B=x.substring(F),x=x.substring(0,F));var V,K=t.highLevel().lowLevel().unit().resolve(x).absolutePath();V=0===K.indexOf("http://")||0===K.indexOf("https://")?K:E.relative(t.highLevel().lowLevel().unit().project().getRootPath(),K),V=V.replace(/\\/g,"/");var j=V+B;if(a.schemaPath=j,r.options.sourceMap){var W=a.sourceMap;W||(W={},a.sourceMap=W),W.path=j}}}}if((_||"type"!=l)&&(_||"schema"!=l)&&(_||"items"!=l)){if(t.definition&&m.isTypeDeclarationDescendant(t.definition())&&m.isTypeProperty(v)){var H=t[s.Universe10.TypeDeclaration.properties.schema.name]();if(null!=H&&(!Array.isArray(H)||0!=H.length))return;var T=t.highLevel(),S=T.lowLevel(),Y=!1;if(S.children().forEach(function(e){if("schema"==e.key())return void(Y=!0)}),Y)return}if(Array.isArray(_)){for(var q=[],G=0,X=_;G<X.length;G++){var z=X[G],$=r.dumpInternal(z);"examples"===l&&r.options&&r.options.dumpXMLRepresentationOfExamples&&z.expandable&&z.expandable._owner&&($.asXMLString=z.expandable.asXMLString()),q.push($)}if(0==q.length&&u.BasicNodeImpl.isInstance(t)&&!r.isDefined(t,l))return;for(var J=0,Q=r.nodePropertyTransformers;J<Q.length;J++){var Z=Q[J];Z.match(t,v)&&(q=Z.transform(q,t))}if(a[l]=q,e[l].isValueProperty()&&A){for(var ee=[],te=0,ne=A;te<ne.length;te++){var re=ne[te];if(u.AttributeNodeImpl.isInstance(re)){var ie=re.highLevel(),ae=h.actualPath(ie,!0);ee.push(ae)}else ee.push(null)}ee.filter(function(e){return null!=e}).length>0&&(o[l]=ee.map(function(e){return{path:e}}))}}else{var z=r.dumpInternal(_);if(u.TypeInstanceImpl.isInstance(_))return void(a[l]=z);if(null==z&&u.BasicNodeImpl.isInstance(t)&&!r.isDefined(t,l))return;if(u.BasicNodeImpl.isInstance(t)&&r.nodePropertyTransformers.forEach(function(e){e.match(t,v)&&(z=e.transform(z,t))}),a[l]=z,"example"===l&&r.options&&r.options.dumpXMLRepresentationOfExamples&&_.expandable&&_.expandable._owner&&(z.asXMLString=_.expandable.asXMLString()),A&&e[l].isValueProperty()){var oe=Array.isArray(A)?A[0]:A;if(u.AttributeNodeImpl.isInstance(oe)){var ie=oe.highLevel();if(!ie.isFromKey()){var ae=h.actualPath(ie,!0);ae&&(o[l]=[{path:ae}])}}}}}}),this.options.sourceMap&&Object.keys(o).length>0){var l=a.sourceMap;l||(l={},a.sourceMap=l),l.scalarsSources=o}return a},e.prototype.serializeScalarsAnnotations=function(e,t,n){var r=this;if(t.scalarsAnnotations){for(var i={},a=t.scalarsAnnotations(),o=0,s=Object.keys(n);o<s.length;o++){var u=s[o];if(a[u]){var l=a[u]();if(l.length>0)if(Array.isArray(l[0])){var p=[];l.forEach(function(e,t){p.push(e.map(function(e){return r.dumpInternal(e)}))}),p.filter(function(e){return e.length>0}).length>0&&(i[u]=p)}else i[u]=l.map(function(e){return r.dumpInternal(e)})}}Object.keys(i).length>0&&(e.scalarsAnnotations=i)}},e.prototype.serializeMeta=function(e,t){if(this.options.serializeMetadata){var n=t.meta();n.isDefault()||(e.__METADATA__=n.toJSON())}},e.prototype.serializeTypeInstance=function(e){var t=this;if(e.isScalar())return e.value();if(e.isArray())return e.items().map(function(e){return t.serializeTypeInstance(e)});var n=e.properties();if(0==n.length)return null;var r={};return n.forEach(function(e){return r[e.name()]=t.serializeTypeInstanceProperty(e)}),r},e.prototype.serializeTypeInstanceProperty=function(e){var t=this;if(e.isArray()){var n=e.values(),r=[];return n.forEach(function(e){return r.push(t.serializeTypeInstance(e))}),r}return this.serializeTypeInstance(e.value())},e.prototype.isDefined=function(e,t){var n=e.highLevel();return n.elementsOfKind(t).length>0||n.attributes(t).length>0},e}();t.JsonSerializer=_;var T=function(){function e(e,t){this.typeMatcher=e,this.propMatcher=t}return e.prototype.match=function(e,t){return(null==e||this.typeMatcher(e))&&(null==t||this.propMatcher(t))},e}(),S=function(){function e(e){this.matchers=e}return e.prototype.match=function(e,t){for(var n=this.matchers.length,r=0;r<n;r++)if(this.matchers[r].match(e,t))return!0;return!1},e}(),N=function(){function e(e,t){this.matcher=e,this.propName=t}return e.prototype.match=function(e,t){return this.matcher.match(e.definition(),t)},e.prototype.transform=function(e){var t=this;if(Array.isArray(e)&&e.length>0&&e[0][this.propName]){var n={};return e.forEach(function(e){var r=e[t.propName],i=n[r];i?Array.isArray(i)?i.push(e):n[r]=[i,e]:n[r]=e}),n}return e},e}(),I=function(){function e(e,t){this.matcher=e,this.propName=t}return e.prototype.match=function(e,t){return this.matcher.match(e.definition?e.definition():null,t)},e.prototype.transform=function(e){if(Array.isArray(e))return e;var t={};return t[e[this.propName]]=e,
t},e}(),b=function(e){function t(){return e.call(this,new S([new T(m.isApiSibling,m.isBaseUriParametersProperty),new T(m.isResourceBaseSibling,m.isUriParametersProperty),new T(m.isResourceBaseSibling,m.isQueryParametersProperty),new T(m.isTraitType,m.isQueryParametersProperty),new T(m.isMethodType,m.isQueryParametersProperty),new T(m.isSecuritySchemePartType,m.isQueryParametersProperty),new T(m.isTraitType,m.isHeadersProperty),new T(m.isMethodType,m.isHeadersProperty),new T(m.isSecuritySchemePartType,m.isHeadersProperty),new T(m.isResponseType,m.isHeadersProperty),new T(m.isBodyLikeType,m.isFormParametersProperty)]),"name")||this}return o(t,e),t}(N),R=function(e){function t(){return e.call(this,new S([new T(m.isLibraryBaseSibling,m.isTypesProperty),new T(function(e){return m.isLibraryBaseSibling(e)&&m.isRAML10Type(e)},m.isSchemasProperty)]),"name")||this}return o(t,e),t.prototype.match=function(e,t){var n=null!=e.parent()&&this.matcher.match(e.parent().definition(),t);return!!n},t}(I),M=(function(e){function t(){return e.call(this,new S([new T(m.isLibraryBaseSibling,m.isUsesProperty)]),"name")||this}return o(t,e),t}(N),function(e){function t(){return e.call(this,new S([new T(m.isObjectTypeDeclarationSibling,m.isPropertiesProperty)]),"name")||this}return o(t,e),t}(N)),C=function(e){function t(){return e.call(this,new S([new T(m.isMethodBaseSibling,m.isResponsesProperty)]),"code")||this}return o(t,e),t}(N),w=function(e){function t(){return e.call(this,new S([new T(function(e){return!0},m.isAnnotationsProperty)]),"name")||this}return o(t,e),t}(N),P=function(e){function t(){return e.call(this,new S([new T(m.isResponseType,m.isBodyProperty),new T(m.isMethodBaseSibling,m.isBodyProperty)]),"name")||this}return o(t,e),t}(N),L=function(e){function t(){return e.call(this,new S([new T(m.isTraitType,m.isTraitsProperty)]),"name")||this}return o(t,e),t}(I),O=function(e){function t(){return e.call(this,new S([new T(m.isResourceTypeType,m.isResourceTypesProperty)]),"name")||this}return o(t,e),t.prototype.transform=function(t){var n=y.Universe10.ResourceBase.properties.methods.name;if(Array.isArray(t))return t;var r=t[n];return r&&r.forEach(function(e){var n=Object.keys(e);if(n.length>0){var r=n[0];t[r]=e[r]}}),delete t[n],e.prototype.transform.call(this,t)},t}(I),D=function(e){function t(){return e.call(this,new S([new T(m.isTypeDeclarationSibling,m.isFacetsProperty)]),"name")||this}return o(t,e),t}(N),U=function(e){function t(){return e.call(this,null,"name")||this}return o(t,e),t.prototype.match=function(e,t){return null!=t&&m.isSecuritySchemesProperty(t)},t}(I),x=function(e){function t(){return e.call(this,new S([new T(m.isLibraryBaseSibling,m.isAnnotationTypesProperty)]),"name")||this}return o(t,e),t.prototype.match=function(e,t){return null!=e.parent()&&this.matcher.match(e.parent().definition(),t)},t}(I),k=function(e){function t(){return e.call(this,null,"method")||this}return o(t,e),t.prototype.match=function(e,t){return null!=e.parent()&&m.isResourceTypeType(e.parent().definition())&&m.isMethodsProperty(t)},t}(I),F=s.Universe10.ExampleSpec.properties.name.name,B=s.Universe10.ExampleSpec.properties.value.name,V="structuredContent",K=(function(){function e(){}return e.prototype.match=function(e,t){return m.isExampleSpecType(e.definition())},e.prototype.transform=function(e){var t=this;if(Array.isArray(e)&&e.length>0){if(e[0][F]){var n={};return e.forEach(function(e){return n[e[F]]=t.getActualExample(e)}),n}var r=e.map(function(e){return t.getActualExample(e)});return r}return e},e.prototype.getActualExample=function(e){return e[V]?e[V]:e[B]},e}(),function(){function e(){}return e.prototype.match=function(e,t){return e.definition&&m.isTypeDeclarationSibling(e.definition())},e.prototype.transform=function(e){var t=Array.isArray(e),n=t?e:[e];return n.forEach(function(e){var t=e.example;t&&(e.example=t.structuredValue,e.structuredExample=t)}),t?n:n[0]},e}()),j=function(){function e(){}return e.prototype.match=function(e,t){return e.definition&&m.isTypeDeclarationSibling(e.definition())},e.prototype.transform=function(e,t){var n=t.highLevel();if(null==n||!n.isElement())return e;var r=n.asElement(),i=s.Universe10.TypeDeclaration.properties.default.name,a=r.attr(i);if(null==a||null!=a.value())return e;var o=Array.isArray(e),u=o?e:[e];return u.forEach(function(e){if(null==e[i]){var t=a.lowLevel().dumpToObject();"object"==typeof t&&t.hasOwnProperty(i)?e[i]=t[i]:e[i]=t}}),o?u:u[0]},e}(),W=function(){function e(){this.matcher=new T(function(e){return m.isApiType(e)&&m.isRAML08Type(e)},m.isSchemasProperty)}return e.prototype.match=function(e,t){return null!=e.parent()&&this.matcher.match(e.parent().definition(),t)},e.prototype.transform=function(e){if(Array.isArray(e))return e;var t={};return t[e.key]=e.value,e.sourceMap&&e.sourceMap.path&&(t.sourceMap={path:e.sourceMap.path}),t},e.prototype.getActualExample=function(e){return e[V]?e[V]:e[B]},e}(),H=function(){function e(){}return e.prototype.match=function(e,t){return null!=t&&m.isProtocolsProperty(t)},e.prototype.transform=function(e){return"string"==typeof e?e.toUpperCase():Array.isArray(e)?e.map(function(e){return e.toUpperCase()}):e},e}(),Y=function(){function e(){this.usecases=new S([new T(m.isApiSibling,m.isMediaTypeProperty)])}return e.prototype.match=function(e,t){return this.usecases.match(e.definition(),t)},e.prototype.transform=function(e){return Array.isArray(e)&&1==e.length?e[0]:e},e}(),q=function(){function e(){}return e.prototype.match=function(e,t){return null!=t&&m.isResourcesProperty(t)},e.prototype.transform=function(e,t){if(Array.isArray(e))return e;var n=e[y.Universe10.Resource.properties.relativeUri.name];if(n){for(var r=n.trim().split("/");r.length>0&&0==r[0].length;)r.shift();e.relativeUriPathSegments=r,e.absoluteUri=t.absoluteUri()}return e},e}(),G=function(){function e(){}return e.prototype.match=function(e,t){return!(!e.parent()||!e.parent().highLevel().lowLevel().libProcessed)&&(m.isAnnotationTypesProperty(t)||m.isTypesProperty(t)||m.isResourceTypesProperty(t)||m.isTraitsProperty(t)||m.isSecuritySchemesProperty(t))},e.prototype.transform=function(e,t){for(var n=t.highLevel().lowLevel(),r=n.key(),i=n;l.LowLevelProxyNode.isInstance(i);)i=i.originalNode();var a=i.key(),o=e[Object.keys(e)[0]];return o.name=a,o.displayName==r&&(o.displayName=a),e},e}(),X=function(){function e(){}return e.prototype.match=function(e,t){var n=e.highLevel();if(!n)return!1;var r=n.definition();return!!r&&(m.isResourceTypeType(r)||m.isTraitType(r)||m.isMethodType(r)||m.isResponseType(r)||m.isParameterDescendant(r)||m.isBodyLikeType(r)||m.isTypeDeclarationDescendant(r))},e.prototype.transform=function(e){if(Array.isArray(e))return e;var t=s.Universe10.Trait.properties.parametrizedProperties.name,n=e[t];return n&&(Object.keys(n).forEach(function(t){e[t]=n[t]}),delete e[t]),e},e}(),z=function(){function e(){}return e.prototype.match=function(e,t){return null!=t&&(m.isSecuredByProperty(t)||m.isIsProperty(t)||null!=e.parent()&&(m.isResourceType(e.parent().highLevel().definition())||m.isResourceTypeType(e.parent().highLevel().definition()))&&m.isTypeProperty(t))},e.prototype.transform=function(e){return e?Array.isArray(e)?e:this.toSimpleValue(e):null},e.prototype.toSimpleValue=function(e){var t=e.name,n=e.structuredValue;if(n){var r={};return r[t]=n,r}return t},e}(),$=function(){function e(){}return e.prototype.match=function(e,t){if(!u.BasicNodeImpl.isInstance(e))return!1;var n=e.highLevel(),r=n.definition();if(!m.isTypeDeclarationDescendant(r))return!1;var i=n.localType();return!(!i||!i.isArray())},e.prototype.transform=function(e){var t=y.Universe10.TypeDeclaration.properties.type.name,n=y.Universe10.TypeDeclaration.properties.schema.name,r=y.Universe10.ArrayTypeDeclaration.properties.items.name,i=e[t];return i||(i=e[n]),1==i.length&&v.stringEndsWith(i[0],"[]")&&(null==e[r]&&(e[r]=i[0].substring(0,i[0].length-2)),i[0]="array"),e},e}(),J=function(){function e(){this.map={}}return e.prototype.addProperty=function(e,t){var n=this.map[t];n||(n=new Q(t),this.map[t]=n),n.addProperty(e)},e.prototype.print=function(){var e=this;return Object.keys(this.map).map(function(t){return e.map[t].print()}).join("\n")+"\n"},e}(),Q=function(){function e(e){this.typeName=e,this.map={}}return e.prototype.addProperty=function(e){var t=e.domain().nameId(),n=this.map[t];n||(n=new Z(t),this.map[t]=n),n.addProperty(e)},e.prototype.print=function(){var e=this;return this.typeName+":\n"+Object.keys(this.map).map(function(t){return"    "+e.map[t].print()}).join("\n")},e}(),Z=function(){function e(e){this.typeName=e,this.map={}}return e.prototype.addProperty=function(e){var t=e.nameId();this.map[t]=e},e.prototype.print=function(){return this.typeName+": "+Object.keys(this.map).sort().join(", ")},e}();t.isEmpty=i},function(e,t){"use strict";function n(e){return"Api"==e.kind()&&"RAML10"==e.RAMLVersion()}function r(e){return"LibraryBase"==e.kind()&&"RAML10"==e.RAMLVersion()}function i(e){return"Annotable"==e.kind()&&"RAML10"==e.RAMLVersion()}function a(e){return"AnnotationRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function o(e){return"Reference"==e.kind()&&"RAML10"==e.RAMLVersion()}function s(e){return"ValueType"==e.kind()&&"RAML10"==e.RAMLVersion()}function u(e){return"StringType"==e.kind()&&"RAML10"==e.RAMLVersion()}function l(e){return"UriTemplate"==e.kind()&&"RAML10"==e.RAMLVersion()}function p(e){return"RelativeUriString"==e.kind()&&"RAML10"==e.RAMLVersion()}function c(e){return"FullUriTemplateString"==e.kind()&&"RAML10"==e.RAMLVersion()}function f(e){return"StatusCodeString"==e.kind()&&"RAML10"==e.RAMLVersion()}function h(e){return"FixedUriString"==e.kind()&&"RAML10"==e.RAMLVersion()}function d(e){return"ContentType"==e.kind()&&"RAML10"==e.RAMLVersion()}function m(e){return"MarkdownString"==e.kind()&&"RAML10"==e.RAMLVersion()}function y(e){return"SchemaString"==e.kind()&&"RAML10"==e.RAMLVersion()}function v(e){return"MimeType"==e.kind()&&"RAML10"==e.RAMLVersion()}function g(e){return"AnyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function A(e){return"NumberType"==e.kind()&&"RAML10"==e.RAMLVersion()}function E(e){return"IntegerType"==e.kind()&&"RAML10"==e.RAMLVersion()}function _(e){return"NullType"==e.kind()&&"RAML10"==e.RAMLVersion()}function T(e){return"TimeOnlyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function S(e){return"DateOnlyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function N(e){return"DateTimeOnlyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function I(e){return"DateTimeType"==e.kind()&&"RAML10"==e.RAMLVersion()}function b(e){return"FileType"==e.kind()&&"RAML10"==e.RAMLVersion()}function R(e){return"BooleanType"==e.kind()&&"RAML10"==e.RAMLVersion()}function M(e){return"AnnotationTarget"==e.kind()&&"RAML10"==e.RAMLVersion()}function C(e){return"TraitRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function w(e){return"Trait"==e.kind()&&"RAML10"==e.RAMLVersion()}function P(e){return"MethodBase"==e.kind()&&"RAML10"==e.RAMLVersion()}function L(e){return"Operation"==e.kind()&&"RAML10"==e.RAMLVersion()}function O(e){return"TypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function D(e){return"ModelLocation"==e.kind()&&"RAML10"==e.RAMLVersion()}function U(e){return"LocationKind"==e.kind()&&"RAML10"==e.RAMLVersion()}function x(e){return"ExampleSpec"==e.kind()&&"RAML10"==e.RAMLVersion()}function k(e){return"UsesDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function F(e){return"XMLFacetInfo"==e.kind()&&"RAML10"==e.RAMLVersion()}function B(e){return"ArrayTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function V(e){return"UnionTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function K(e){return"ObjectTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function j(e){return"StringTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function W(e){return"BooleanTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function H(e){return"NumberTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function Y(e){return"IntegerTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function q(e){return"DateOnlyTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function G(e){return"TimeOnlyTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function X(e){return"DateTimeOnlyTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function z(e){return"DateTimeTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function $(e){return"FileTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function J(e){return"Response"==e.kind()&&"RAML10"==e.RAMLVersion()}function Q(e){return"SecuritySchemePart"==e.kind()&&"RAML10"==e.RAMLVersion()}function Z(e){return"SecuritySchemeRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function ee(e){return"AbstractSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function te(e){return"SecuritySchemeSettings"==e.kind()&&"RAML10"==e.RAMLVersion()}function ne(e){return"OAuth1SecuritySchemeSettings"==e.kind()&&"RAML10"==e.RAMLVersion()}function re(e){return"OAuth2SecuritySchemeSettings"==e.kind()&&"RAML10"==e.RAMLVersion()}function ie(e){return"OAuth2SecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function ae(e){return"OAuth1SecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function oe(e){return"PassThroughSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function se(e){return"BasicSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function ue(e){return"DigestSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function le(e){return"CustomSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function pe(e){return"Method"==e.kind()&&"RAML10"==e.RAMLVersion()}function ce(e){return"ResourceTypeRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function fe(e){return"ResourceType"==e.kind()&&"RAML10"==e.RAMLVersion()}function he(e){return"ResourceBase"==e.kind()&&"RAML10"==e.RAMLVersion()}function de(e){return"Resource"==e.kind()&&"RAML10"==e.RAMLVersion()}function me(e){return"DocumentationItem"==e.kind()&&"RAML10"==e.RAMLVersion()}function ye(e){return"Library"==e.kind()&&"RAML10"==e.RAMLVersion()}function ve(e){return"Overlay"==e.kind()&&"RAML10"==e.RAMLVersion()}function ge(e){return"Extension"==e.kind()&&"RAML10"==e.RAMLVersion()}function Ae(e){return null==e.highLevel().parent()}function Ee(e){return Ae(e)?e:null}Object.defineProperty(t,"__esModule",{value:!0}),t.isApi=n,t.isLibraryBase=r,t.isAnnotable=i,t.isAnnotationRef=a,t.isReference=o,t.isValueType=s,t.isStringType=u,t.isUriTemplate=l,t.isRelativeUriString=p,t.isFullUriTemplateString=c,t.isStatusCodeString=f,t.isFixedUriString=h,t.isContentType=d,t.isMarkdownString=m,t.isSchemaString=y,t.isMimeType=v,t.isAnyType=g,t.isNumberType=A,t.isIntegerType=E,t.isNullType=_,t.isTimeOnlyType=T,t.isDateOnlyType=S,t.isDateTimeOnlyType=N,t.isDateTimeType=I,t.isFileType=b,t.isBooleanType=R,t.isAnnotationTarget=M,t.isTraitRef=C,t.isTrait=w,t.isMethodBase=P,t.isOperation=L,t.isTypeDeclaration=O,t.isModelLocation=D,t.isLocationKind=U,t.isExampleSpec=x,t.isUsesDeclaration=k,t.isXMLFacetInfo=F,t.isArrayTypeDeclaration=B,t.isUnionTypeDeclaration=V,t.isObjectTypeDeclaration=K,t.isStringTypeDeclaration=j,t.isBooleanTypeDeclaration=W,t.isNumberTypeDeclaration=H,t.isIntegerTypeDeclaration=Y,t.isDateOnlyTypeDeclaration=q,t.isTimeOnlyTypeDeclaration=G,t.isDateTimeOnlyTypeDeclaration=X,t.isDateTimeTypeDeclaration=z,t.isFileTypeDeclaration=$,t.isResponse=J,t.isSecuritySchemePart=Q,t.isSecuritySchemeRef=Z,t.isAbstractSecurityScheme=ee,t.isSecuritySchemeSettings=te,t.isOAuth1SecuritySchemeSettings=ne,t.isOAuth2SecuritySchemeSettings=re,t.isOAuth2SecurityScheme=ie,t.isOAuth1SecurityScheme=ae,t.isPassThroughSecurityScheme=oe,t.isBasicSecurityScheme=se,t.isDigestSecurityScheme=ue,t.isCustomSecurityScheme=le,t.isMethod=pe,t.isResourceTypeRef=ce,t.isResourceType=fe,t.isResourceBase=he,t.isResource=de,t.isDocumentationItem=me,t.isLibrary=ye,t.isOverlay=ve,t.isExtension=ge,t.isFragment=Ae,t.asFragment=Ee},function(e,t,n){"use strict";function r(){if(!m){m={};for(var e=0,n=Object.keys(t.transitions);e<n.length;e++){var r=n[e],i=t.transitions[r],a=new w(r,i,m);m[r]=a}for(var o=new L,s=0,u=Object.keys(m);s<u.length;s++){var r=u[s];m[r].init(o)}}}function i(e,t){var n=e.kind()==g.Kind.SCALAR||e.valueKind()==g.Kind.SCALAR;if(n){var r=e.value(!0);r?"string"==typeof r&&(r=r.trim(),r||(n=!1)):n=!1}else n=!1;return n}function a(e,t){return e.valueKind()==g.Kind.SEQ}function o(e,t){return!(!t.globalScope||!t.globalScope.hasRootMediaType)&&null==S.find(e.children(),function(e){return e.key()&&e.key().indexOf("/")>=0})}function s(e,t){return t.referencePatcher.patchType(e,t),!1}function u(e,t){return t.meta.templatesCollection=I.universesInfo.Universe10.LibraryBase.properties.traits.name,e.kind()!=g.Kind.SCALAR&&null==e.key()&&(e=e.children()[0]),t.referencePatcher.patchReference(e,t,"traits"),!1}function l(e,t){t.meta.templatesCollection=I.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name;var n=e.children();if(n.length>0)t.referencePatcher.patchReference(n[0],t,"resourceTypes");else{var r=e,i=new _.LowLevelCompositeNode(A.createScalar(e.value()),null,r.transformer(),"RAML10",!0);t.referencePatcher.patchReference(i,t,"resourceTypes"),t.registerOnly||r.setValueOverride(i.value())}return!1}function p(e,t){var n=h(e).key(),r=e,i=r.transformer(),a=t.referencePatcher.resolveReferenceValue(n.substring(1,n.length-1),t,i,"annotationTypes");return a&&(t.referencePatcher.registerPatchedReference(a),t.registerOnly||(r.setKeyOverride("("+a.value()+")"),a.isChained()&&r.addMeta("chaining",[{value:a.value(),kind:"annotationRef"}]))),!1}function c(e,t){return"securedBy"==e.key()&&(e=e.children()[0]),t.referencePatcher.patchReference(e,t,"securitySchemes"),!1}function f(e,t){var n=S.find(e.children(),function(e){return e.key()==I.universesInfo.Universe10.MethodBase.properties.is.name});return n&&n.filterChildren(),!1}function h(e){for(var t=0;t<2&&_.LowLevelProxyNode.isInstance(e);t++)e=e.originalNode();return e}function d(e){for(var t=0,n=e.elements();t<n.length;t++){var r=n[t];d(r)}for(var i=0,a=e.attrs();i<a.length;i++){var o=a[i],s=o.value();v.StructuredValue.isInstance(s)&&s.resetHighLevelNode()}delete e.lowLevel().actual().types,delete e._ptype,delete e._types,e.setAssociatedType(null)}Object.defineProperty(t,"__esModule",{value:!0});var m,y=n(5),v=n(55),g=n(21),A=n(4),E=n(15),_=n(199),T=n(204),S=n(16),N=n(224),I=n(56),b=I.rt.typeExpressions,R=n(206);n(225);t.transitions={Api:{traits:{$action:"$Trait",$toChildren:!0},resourceTypes:{$action:"$ResourceType",$toChildren:!0},types:{$action:"$TypeDeclaration",$toChildren:!0},annotationTypes:{$action:"$TypeDeclaration",$toChildren:!0},baseUriParameters:{$action:"$TypeDeclaration",$toChildren:!0},securedBy:"$SecuritySchemeReferences","//.+/":"$Resource","/\\(.+\\)/":"$Annotation"},Resource:{get:"$Method",put:"$Method",post:"$Method",delete:"$Method",options:"$Method",head:"$Method",patch:"$Method",is:"$TraitReferences",type:{$action:"##patchResourceTypeReference"},uriParameters:{$action:"$TypeDeclaration",$toChildren:!0},securedBy:"$SecuritySchemeReferences","/\\(.+\\)/":"$Annotation","//.+/":"$Resource",$action:"##filterTraits"},Method:{body:"$Body",responses:{$action:"$Response",$toChildren:!0},is:"$TraitReferences",queryParameters:{$action:"$TypeDeclaration",$toChildren:!0},queryString:{$action:"$TypeDeclaration"},headers:{$action:"$TypeDeclaration",$toChildren:!0},securedBy:"$SecuritySchemeReferences","/\\(.+\\)/":"$Annotation",$action:"##filterTraits"},ResourceType:{get:"$Method",put:"$Method",post:"$Method",delete:"$Method",options:"$Method",head:"$Method",patch:"$Method",is:"$TraitReferences",type:{$action:"##patchResourceTypeReference"},uriParameters:{$action:"$TypeDeclaration",$toChildren:!0},securedBy:"$SecuritySchemeReferences","/\\(.+\\)/":"$Annotation"},Trait:{body:"$Body",responses:{"/\\d{3,3}/":"$Response"},queryParameters:{$action:"$TypeDeclaration",$toChildren:!0},queryString:{$action:"$TypeDeclaration"},headers:{$action:"$TypeDeclaration",$toChildren:!0},securedBy:"$SecuritySchemeReferences","/\\(.+\\)/":"$Annotation"},Response:{body:"$Body",headers:{$action:"$TypeDeclaration",$toChildren:!0},"/\\(.+\\)/":"$Annotation"},Body:{oneOf:[{$conditions:["isBodyWithDefaultMediaType"],$action:"$TypeDeclaration"},{$action:"$TypeDeclaration",$toChildren:!0}]},TypeDeclaration:{oneOf:[{$conditions:["isScalar"],$action:"##patch"},{$conditions:["isArray"],$action:"$TypeDeclaration",$toChildren:!0},{type:"$TypeDeclaration",items:"$TypeDeclaration",properties:{"/.+/":"$TypeDeclaration"},facets:{$action:"$TypeDeclaration",$toChildren:!0},"/\\(.+\\)/":"$Annotation",$action:"##removeUses"}]},Annotation:{$action:"##patchAnnotationName"},TraitReferences:{$action:"##patchTraitReference",$toChildren:!0},SecuritySchemeReferences:{$action:"##patchSecuritySchemeReference",$toChildren:!0}};var M=function(){function e(){}return e}();t.Scope=M;var C;!function(e){e[e.BASIC=0]="BASIC",e[e.ONE_OF=1]="ONE_OF",e[e.ACTION=2]="ACTION",e[e.MIXED=3]="MIXED"}(C=t.TransitionKind||(t.TransitionKind={}));var w=function(){function e(e,t,n){this.title=e,this.localMap=t,this.globalMap=n,this.applyToChildren=!1}return e.prototype.processNode=function(e,t){if(this.kind!=C.ONE_OF){if(this.kind==C.BASIC||this.kind==C.MIXED)for(var n=0,r=e.children();n<r.length;n++){var i=r[n],a=i.key();if(a){var o=this.staticTransitions[a];if(!o)for(var s=0,u=this.regexpTransitions;s<u.length;s++){var l=u[s];if(a.match(l.regexp)){o=l.transition;break}}o&&this.applyMappedTransition(i,o,t)}}this.kind!=C.ACTION&&this.kind!=C.MIXED||(null!=this.action?this.action(e,t):this.applyMappedTransition(e,this.children[0],t))}else for(var p=0,c=this.children;p<c.length;p++){var f=c[p];if(f.checkConditions(e,t)){this.applyMappedTransition(e,f,t);break}}},e.prototype.applyMappedTransition=function(e,t,n){var r=n.appendUnitIfNeeded(e);if(t.applyToChildren)for(var i=0,a=e.children();i<a.length;i++){var o=a[i],s=n.appendUnitIfNeeded(o);t.processNode(o,n),s&&n.popUnit()}else t.processNode(e,n);r&&n.popUnit()},e.prototype.checkConditions=function(e,t){if(!this.conditions)return!0;for(var n=!0,r=0,i=this.conditions;r<i.length;r++){var a=i[r];n=n&&a(e,t)}return n},e.prototype.init=function(t){var n=this;this.conditions=this.localMap.$conditions&&this.localMap.$conditions.map(function(e){return t.condition(e)}),this.localMap.$toChildren&&(this.applyToChildren=!0);var r=this.localMap.oneOf;if(r)this.kind=C.ONE_OF,this.children=r.map(function(t,r){return new e(n.title+"["+r+"]",t,n.globalMap)}),this.children.forEach(function(e){return e.init(t)});else{var i=this.localMap.$action;if(i&&(0==Object.keys(this.localMap).filter(function(e){return"$"!=e.charAt(0)}).length?this.kind=C.ACTION:this.kind=C.MIXED,E.stringStartsWith(i,"##")?this.action=t.action(i):"$"==i.charAt(0)&&(this.children=[this.globalMap[i.substring(1)]])),null==this.kind)this.kind=C.BASIC;else if(this.kind==C.ACTION)return;this.regexpTransitions=[],this.staticTransitions={};for(var a=0,o=Object.keys(this.localMap).filter(function(e){return"$"!=e.charAt(0)});a<o.length;a++){var s=o[a];if(s&&(s=s.trim())){var u,l=this.localMap[s];if("string"==typeof l?"$"==l.charAt(0)&&(u=this.globalMap[l.substring(1)]):"object"!=typeof l||Array.isArray(l)||(u=new e(this.title+"."+s,l,this.globalMap),u.init(t)),u)if("/"==s.charAt(0)){var p=new RegExp(s.substring(1,s.length-1));this.regexpTransitions.push({regexp:p,transition:u})}else this.staticTransitions[s]=u}}}},e}();t.Transition=w;var P=function(){function e(e,t,n,r){this.referencePatcher=e,this.rootUnit=t,this.globalScope=n,this.resolver=r,this.meta={},this.registerOnly=!1,this.units=[t]}return e.prototype.lastUnit=function(){return this.units[this.units.length-1]},e.prototype.appendUnitIfNeeded=function(e){if(A.CompilationUnit.isInstance(e)){var t=e;return t.absolutePath()!=this.lastUnit().absolutePath()&&(this.units.push(t),!0)}var n=h(e),r=n.unit();if(n.valueKind()==g.Kind.INCLUDE_REF){var i=n.includePath(),a=r.resolve(i);return!!a&&(this.units.push(a),!0)}return r.absolutePath()!=this.lastUnit().absolutePath()&&(this.units.push(r),!0)},e.prototype.popUnit=function(){this.units.pop()},e}();t.State=P;var L=function(){function e(){}return e.prototype.action=function(e){var t;return"##patch"==e?t=s:"##patchTraitReference"==e?t=u:"##patchResourceTypeReference"==e?t=l:"##patchAnnotationName"==e?t=p:"##patchSecuritySchemeReference"==e?t=c:"##filterTraits"==e?t=f:"##removeUses"==e&&(t=function(e,t){return t.referencePatcher.removeUses(e),!0}),t},e.prototype.condition=function(e){return"isScalar"==e?i:"isArray"==e?a:"isBodyWithDefaultMediaType"==e?o:null},e}();t.ReferencePatcherActionsAndConditionsFactory=L;var O=function(){function e(e){void 0===e&&(e=R.PatchMode.DEFAULT),this.mode=e,this._outerDependencies={},this._libModels={},this.needTypesReset=!1}return e.prototype.process=function(e,t,n,i,a,o){var s=this;void 0===t&&(t=e),void 0===n&&(n="Api"),void 0===i&&(i=!1),void 0===a&&(a=!1),r();var u=new M;u.hasRootMediaType=null!=S.find(e.children(),function(e){return"mediaType"==e.key()});var l=t.unit(),p=l.project().namespaceResolver(),c=new P(this,l,u,p),f=m[n];f&&f.processNode(e,c),a&&this.patchNodeName(e,c,o),i?this.removeUses(e):this.patchUses(e,p),e.children().forEach(function(e){return s.removeUses(e)}),e.libProcessed=!0},e.prototype.patchType=function(e,t){var n=this;t.referencePatcher.removeUses(e);var r="types",i=e,a=e.value(!0).toString().trim(),o=a[0],s=a[a.length-1];if(!("{"===o&&"}"==s||"<"===o&&">"==s)){var u=R.checkExpression(a),l=i.transformer(),p=a,c={status:R.ParametersEscapingStatus.NOT_REQUIRED},f=l?l.unitsChain:null;if(null!=l||a.indexOf("<<")>=0){var d=h(i),m=d.value();if(c=R.escapeTemplateParameters(m),c.status==R.ParametersEscapingStatus.OK)p=u?c.resultingString:m;else{if(c.status==R.ParametersEscapingStatus.ERROR)return;l=null}}var y;if(f){y=[];for(var v=0,g=f;v<g.length;v++){var A=g[v];y.push(t.appendUnitIfNeeded(A))}}var E,_=t.appendUnitIfNeeded(e),T=[];if(u){var S=!1,N=!1;try{var I=b.parse(p);b.visit(I,function(e){if("name"==e.type){var i,a=e,o=a.value,s={status:R.ParametersEscapingStatus.NOT_REQUIRED};if(c.status==R.ParametersEscapingStatus.OK)if(i=c.substitutions[o],null==i){if(s=R.unescapeTemplateParameters(o,c.substitutions),s.status==R.ParametersEscapingStatus.OK)o=s.resultingString;else if(s.status==R.ParametersEscapingStatus.ERROR)return void(S=!0)}else o=i;if(null==l&&(null!=i||s.status==R.ParametersEscapingStatus.OK))return void(a.value=o);var u=n.resolveReferenceValue(o,t,l,r);null!=u&&(a.value=u.value(),N=!0,n.registerPatchedReference(u),u.isChained()&&T.push({kind:"type",value:a.value}))}})}catch(e){}E=N&&!S?b.serializeToString(I):a}else if(c.status!=R.ParametersEscapingStatus.OK||null!=l){p.indexOf("<<")>=0&&R.isCompoundValue(p)&&(p=a,l=null);var M=this.resolveReferenceValue(p,t,l,r);null!=M&&(this.registerPatchedReference(M),E=M.value(),M.isChained()&&T.push({kind:"type",value:E}))}if(null==E||t.registerOnly||(i.setValueOverride(E),T.length>0&&i.addMeta("chaining",T)),_&&t.popUnit(),y)for(var C=0;C<y.filter(function(e){return e}).length;C++)t.popUnit();return!1}},e.prototype.resolveReferenceValue=function(e,t,n,r){var i,a=this,o="annotationTypes"==r;if(n&&e&&e.indexOf("<<")>=0){var s=!0,u=t.resolver.nsMap(t.rootUnit),l=n.transform(e,!0,function(){return s},function(e,n){var i=a.resolveReferenceValueBasic(e,t,r,n.unitsChain);null==i&&(i=new R.PatchedReference(null,e,r,t.rootUnit,!1,R.PatchMode.DEFAULT));var l,p=i.namespace();if(p){var c=u&&u[p];c&&(l=c.unit)}l||(l=t.rootUnit);var f=t.resolver.unitModel(l);return s=o?(f.annotationTypes.hasElement(i.name()),!1):(f.types.hasElement(i.name()),!1),i});i=l.value}return void 0!==i&&R.instanceOfPatchedReference(i)||(i=this.resolveReferenceValueBasic(e,t,r)),i},e.prototype.resolveReferenceValueBasic=function(e,t,n,r){if(null==e||"string"!=typeof e)return null;var i="types"==n||"annotationTypes"==n,a=i&&E.stringEndsWith(e,"?"),o=a?e.substring(0,e.length-1):e;if(!(o.indexOf("<<")>=0)){var s,u,l,p=o.lastIndexOf("."),c=r||t.units;if(p>=0){l=o.substring(0,p),u=o.substring(p+1);for(var f=c.length;f>0;f--){var h=c[f-1],d=this.libExpMode?t.resolver.expandedNSMap(h):t.resolver.nsMap(h),m=d&&d[l];if(null!=m&&(s=m.unit,null!=s))break}}else{if(i&&null!=I.rt.builtInTypes().get(o))return null;u=o,s=c[c.length-1]}if(null==s&&!this.libExpMode){if(l&&l.length>0){for(var v=void 0,f=c.length;f>0;f--){var h=c[f-1],g=t.resolver.expandedNSMap(h),m=g&&g[l];if(null!=m&&(v=m.unit,null!=v))break}if(null!=v){var A=t.resolver.resolveNamespace(t.rootUnit,v);if(null!=A){var _=A.namespace();return a&&(u+="?"),new R.PatchedReference(_,u,n,v,!0,this.mode)}}}return null}if(s.absolutePath()==t.rootUnit.absolutePath())return null==l||0==l.length?null:new R.PatchedReference(null,u,n,s,!1,this.mode);var T=t.resolver.resolveNamespace(t.rootUnit,s);if(null==T)return null;var S=T.namespace();if(null==S)return null;if(this.mode==R.PatchMode.PATH){var N=s.absolutePath().replace(/\\/g,"/");y.isWebPath(N)||(N="file://"+N),S=N+"#/"+n}return a&&(u+="?"),new R.PatchedReference(S,u,n,s,!1,this.mode)}},e.prototype.patchNodeName=function(e,t,n){var r=e,i=r.key(),a="annotationTypes"==n;a&&(i=i.substring(1,i.length-1));var o=this.resolveReferenceValueBasic(i,t,n,[r.unit()]);if(null!=o){this.registerPatchedReference(o);var s=o.value();a&&(s="("+s+")"),t.registerOnly||r.setKeyOverride(s)}},e.prototype.patchReference=function(e,t,n,r){void 0===r&&(r=!1);var i=e;if(_.LowLevelProxyNode.isInstance(i)){var a=i.transformer();if(e.kind()==g.Kind.SCALAR){var o=i.value();if(null!=a){var s=h(i);o=s.value()}var u=this.resolveReferenceValue(o,t,a,n);if(null!=u){var l=u.value();t.registerOnly||i.setValueOverride(l),this.registerPatchedReference(u)}}else{var p=h(e).key(),o=p;if(null!=p){var u=this.resolveReferenceValue(o,t,a,n);if(null!=u){var l=u.value();t.registerOnly||e.setKeyOverride(l),this.registerPatchedReference(u)}var c=t.meta.templatesCollection;if(c&&(null==u&&o.indexOf(".")<0&&(u=new R.PatchedReference("",o,c,t.rootUnit,!1,R.PatchMode.DEFAULT)),u)){var f=t.resolver.getComponent(t.rootUnit,c,u.namespace(),u.name());if(f)for(var d=m[I.universesInfo.Universe10.TypeDeclaration.name],y=0,v=e.children();y<v.length;y++){var A=v[y];if(f.typeValuedParameters[A.key()]){var E=new P(t.referencePatcher,t.rootUnit,t.globalScope,t.resolver);E.units=t.units,E.registerOnly=!0,d.processNode(A,E)}}}}}}},e.prototype.patchUses=function(e,t){if(_.LowLevelCompositeNode.isInstance(e)){var n=e.unit(),r=t.expandedPathMap(n);if(null!=r){var i=t.pathMap(n);i||(i={});for(var a=e,o=e.children(),s=T.Universe10.FragmentDeclaration.properties.uses.name,u=o.filter(function(e){return e.key()==s}),l=h(e),p=l;_.LowLevelProxyNode.isInstance(p);)p=p.originalNode();var c,f=Object.keys(i).map(function(e){return r[e]}),d=Object.keys(r).map(function(e){return r[e]}).filter(function(e){return!i[e.absolutePath()]}),m=(n.absolutePath(),{});if(u.length>0)c=u[0],c.children().forEach(function(e){return m[e.key()]=!0});else{var y=A.createMapNode("uses");y._parent=p,y.setUnit(p.unit()),c=a.replaceChild(null,y)}for(var v=0,g=f.concat(d);v<g.length;v++){var E=g[v];E.absolutePath();if(!m[E.namespace()]){var S=E.includePath,N=A.createMapping(E.namespace(),S);N.setUnit(p.unit()),N.actual().actualPath=E.usesNodes[0].unit().path(),c.replaceChild(null,N)}}}}},e.prototype.removeUses=function(e){if(_.LowLevelCompositeNode.isInstance(e)){var t=e,n=e.children(),r=n.filter(function(e){return e.key()==T.Universe10.FragmentDeclaration.properties.uses.name});r.length>0&&t.removeChild(r[0])}},e.prototype.registerPatchedReference=function(e){var t=e.collectionName();if(t){var n=e.referencedUnit().absolutePath(),r=this._outerDependencies[n];null==r&&(r={},this._outerDependencies[n]=r);var i=r[t];null==i&&(i={},r[t]=i),i[e.name()]=e}},e.prototype.expandLibraries=function(e,t){void 0===t&&(t=!1);var n=this.libExpMode;if(this.libExpMode=!0,!e.actual().libExpanded){var r=e.unit(),i=r.project(),a=[],o=i.namespaceResolver(),s=o.expandedPathMap(r);if(null!=s){for(var u=Object.keys(s).sort(),l=0,p=u;l<p.length;l++){var c=p[l],f=this._libModels[c];
if(null==f&&(f=o.unitModel(s[c].unit))){var h=f.unit,d=h.ast().children().filter(function(e){return e.key()&&"("==e.key().charAt(0)&&")"==e.key().charAt(e.key().length-1)});if(d.length>0)for(var m=0,y=d;m<y.length;m++){var v=y[m],g=v.key(),A=g.length;"("==g.charAt(0)&&")"==g.charAt(A-1)&&(g=g.substring(1,A-1));var E=new P(this,r,new M,o);E.appendUnitIfNeeded(h);var _=this.resolveReferenceValueBasic(g,E,"annotationTypes");_&&this.registerPatchedReference(_)}}f&&a.push(f)}for(var T=!1,S=0,I=a;S<I.length;S++)for(var f=I[S],b=0,R=Object.keys(f);b<R.length;b++){var C=R[b],w=f[C];N.ElementsCollection.isInstance(w)&&(T=this.contributeCollection(e,w)||T)}if(T){var L=!1;do L=this.patchDependencies(e,t);while(L);t||this.removeUnusedDependencies(e)}}this.patchUses(e,o),e.actual().libExpanded=!0,this.needTypesReset&&this.resetHighLevel(e),this.libExpMode=n}},e.prototype.patchDependencies=function(e,t){for(var n=!1,r=e.unit(),i=r.absolutePath(),a=0,o=e.children();a<o.length;a++){var s=o[a],u=s.key(),l=D[u];if(l)for(var p,c,f,h=function(){if(v.libProcessed)return"continue";if(d.removeUses(v),!t){if(p=v.unit().absolutePath(),p==i&&null==v.includePath())return"continue";if(c=d._outerDependencies[p],null==c)return"continue";if(f=c[u],null==f)return"continue";var a=f[v.key()];if(null==a)return"continue";if(u==I.universesInfo.Universe10.LibraryBase.properties.types.name){var o=v.children().filter(function(e){return e.key()==I.universesInfo.Universe10.ObjectTypeDeclaration.properties.discriminator.name});if(o.length>0){d.needTypesReset=!0;var s=r.highLevel().types(),h=s.getTypeRegistry().getByChain(a.value());if(h)for(var m=r.project().namespaceResolver(),y=0,g=h.allSubTypes();y<g.length;y++){var E=g[y],_=E.name();if(_){var T=R.typeUnit(E);if(T){var S=m.resolveNamespace(r,T);if(S){var N=S.namespace(),b=new R.PatchedReference(N,_,I.universesInfo.Universe10.LibraryBase.properties.types.name,T,!1,d.mode);d.registerPatchedReference(b)}}}}}var M=I.universesInfo.Universe10.ObjectTypeDeclaration.properties.discriminatorValue.name,C=v.children().filter(function(e){return e.key()==M});if(!C.length){var w=A.createMapNode(M,v.unit()),P=A.createMapping("strict",!1),L=A.createMapping("value",v.key());w.addChild(L),w.addChild(P),v.replaceChild(null,w)}}}d.process(v,e,l,!0,!0),n=!0},d=this,m=0,y=s.children();m<y.length;m++){var v=y[m];h()}}return n},e.prototype.removeUnusedDependencies=function(e){for(var t=e,n=t.unit().absolutePath(),r=0,i=e.children();r<i.length;r++){var a=i[r];if(D[a.key()])for(var o=0,s=[].concat(a.children());o<s.length;o++){var u=s[o];if(!u.libProcessed){var l=u.unit().absolutePath();l!=n&&a.removeChild(u)}}}},e.prototype.contributeCollection=function(e,t){var n=e;if(0==t.array.length)return!1;var r=t.name,i=S.find(n.children(),function(e){return e.key()==r});if(null==i){var a=A.createMapNode(r,n.unit());i=n.replaceChild(null,a)}for(var o=!1,s=0,u=t.array;s<u.length;s++){var l=u[s];i.children().some(function(e){var t=h(e);return t.unit().absolutePath()==l.unit().absolutePath()&&(l.key()==t.key()&&l.unit().absolutePath()==t.unit().absolutePath())})||(i.replaceChild(null,l),o=!0)}return o},e.prototype.resetHighLevel=function(e){var t=e.highLevelNode();t&&(d(t),t.resetChildren())},e}();t.ReferencePatcher=O,t.toOriginal=h;var D={types:"TypeDeclaration",annotationTypes:"TypeDeclaration",traits:"Trait",resourceTypes:"ResourceType",securitySchemes:"SecuritySchemePart"}},function(e,t,n){"use strict";function r(e){var t=e.ast(),n=R.find(t.children(),function(e){return e.key()==E.Universe10.Extension.properties.extends.name}),r=n&&n.value(),i=e.resolve(r);return i===e?null:r}function i(){if(!O){O={};for(var e=0,t=Object.keys(S.transitions);e<t.length;e++){var n=t[e],r=S.transitions[n],i=new S.Transition(n,r,O);O[n]=i}for(var a=new U,o=0,s=Object.keys(O);o<s.length;o++){var n=s[o];O[n].init(a)}}}function a(e,t){var n=b.universesInfo.Universe10.LibraryBase.properties.traits.name;return e.kind()!=_.Kind.SCALAR&&null==e.key()&&(e=e.children()[0]),e.kind()!=_.Kind.SCALAR&&(p(e,t,n),!1)}function o(e,t){if(e.valueKind()!=_.Kind.SCALAR&&0!=e.children().length){e=e.children()[0];var n=b.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name;return p(e,t,n),!1}}function s(e,t){var n=e.value();return"string"==typeof n&&(l(n,t),!1)}function u(e,t){var n=e.key();if(!n)return!1;var r=n.substring(1,n.length-1);l(r,t)}function l(e,t){M.stringStartsWith(e,"<<")&&M.stringEndsWith(e,">>")&&(e=e.substring("<<".length,e.length-">>".length),e.indexOf("<<")<0&&(t.meta.params[e]=!0))}function p(e,t,n){for(var r=[],i=0,a=e.children();i<a.length;i++){var o=a[i];if(o.valueKind()==_.Kind.SCALAR){var s=o.value();"string"==typeof s&&M.stringStartsWith(s,"<<")&&M.stringEndsWith(s,">>")&&(s=s.substring(2,s.length-2),s.indexOf("<<")>=0||r.push({setParam:o.key(),readParam:s}))}}if(0!=r.length){for(var u=e.key(),l=[],p=u.length,c=0;c<p;c++)"."==u.charAt(c)&&l.push(c);var f;if(l.length>0)for(var c=l.length-1;c>=0;c--){var h=l[c],d=u.substring(0,h),m=u.substring(h+1,p);f=t.resolver.getComponent(t.rootUnit,n,d,m,t.meta.passed)}else f=t.resolver.getComponent(t.rootUnit,n,null,u,t.meta.passed);if(f&&f.isInitialized())for(var y=0,v=r;y<v.length;y++){var g=v[y];f.typeValuedParameters[g.setParam]&&(t.meta.params[g.readParam]=!0)}}}function c(e,t){return!1}function f(e){var t=e.ast(),n=R.find(t.children(),function(e){return e.key()==E.Universe10.Extension.properties.extends.name}),r=n&&n.value();return r?e.resolve(r):null}function h(e,t,n){var r=e.unit.ast();if(r&&m(e.unit)){for(var i="0.8"==I.ramlFirstLine(e.unit.contents())[1],a=0,o=r.children();a<o.length;a++){var s=o[a],u=s.key();u==b.universesInfo.Universe10.LibraryBase.properties.types.name?y(e.types,s.children()):u==b.universesInfo.Universe10.LibraryBase.properties.annotationTypes.name?y(e.annotationTypes,s.children()):u==b.universesInfo.Universe10.LibraryBase.properties.securitySchemes.name?y(e.securitySchemes,s.children(),i):u==b.universesInfo.Universe10.LibraryBase.properties.traits.name?y(e.traits,s.children(),i):u==b.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name&&y(e.resourceTypes,s.children(),i)}if(!i){for(var l=e.resourceTypes.templateModels,p=l&&Object.keys(l).map(function(e){return l[e]})||[],c=e.traits.templateModels,f=c&&Object.keys(c).map(function(e){return c[e]})||[],h=0,v=f;h<v.length;h++){var g=v[h];d(g,t,n)}for(var A=0,E=p;A<E.length;A++){var _=E[A];d(_,t,n)}}if(e.isOverlayOrExtension()){var T=e.unit.ast(),S=T.children().filter(function(e){return e.key()==b.universesInfo.Universe10.Overlay.properties.extends.name});if(S.length>0){var N=S[0],R=N.value();if(R){var M=e.unit.resolve(R);if(M){var C=t.unitModel(M);e.master=C}}}}}}function d(e,t,n){void 0===n&&(n={});var r=O[e.kind];if(r){var i=e.id();if(!n[i]){n[i]=!0;try{var a=new S.Scope,o=e.node.unit().project().getMainUnit();if(o){var s=o.ast(),u=I.ramlFirstLine(o.contents());if(s&&3==u.length){var l="1.0"==u[1]?b.getUniverse("RAML10"):b.getUniverse("RAML08");if(l){var p=u[2],c=l.type(p);c&&T.isApiSibling(c)&&(a.hasRootMediaType=null!=R.find(s.children(),function(e){return"mediaType"==e.key()}))}}}var f=new S.State(null,e.node.unit(),a,t);f.meta.params={},f.meta.passed=n,r.processNode(e.node,f),e.typeValuedParameters=f.meta.params}finally{delete n[i]}}}}function m(e){var t=I.ramlFirstLine(e.contents());if(!t)return!1;if(t.length<3||!t[2])return!0;var n=t[2],r=b.getUniverse("RAML10");if(!r)return!1;var i=r.type(n);return!!i&&T.isLibraryBaseSibling(i)}function y(e,t,n){void 0===n&&(n=!1);var r;n?(r=[],t.forEach(function(e){var t=e.children();t.length>0&&r.push(t[0])})):r=t,r.forEach(function(t){e.array.push(t);var n=t.key();e.map[n]=t;var r=v(t,e.name);r&&(e.templateModels||(e.templateModels={}),e.templateModels[n]=r)})}function v(e,t){var n;if(t==b.universesInfo.Universe10.LibraryBase.properties.traits.name?n=b.universesInfo.Universe10.Trait.name:t==b.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name&&(n=b.universesInfo.Universe10.ResourceType.name),n){i();var r=O[n];if(!r)return null;var a=e.key();return new D(a,n,e,null)}}Object.defineProperty(t,"__esModule",{value:!0});var g=n(5),A=n(6),E=n(204),_=n(21),T=n(205),S=n(223),N=n(212),I=n(55),b=n(56),R=n(16),M=n(15),C=function(){function e(){this.expandedAbsToNsMap={},this._expandedNSMap={},this.byPathMap={},this.byNsMap={},this._hasFragments={},this._unitModels={}}return e.prototype.hasTemplates=function(e){var t=this.unitModel(e);if(!t.traits.isEmpty()||!t.resourceTypes.isEmpty())return!0;var n=this.expandedPathMap(e);if(n)for(var i=0,a=Object.keys(n);i<a.length;i++){var o=a[i],s=n[o].unit,u=this.unitModel(s);if(!u.traits.isEmpty()||!u.resourceTypes.isEmpty())return!0}for(var l=r(e);l;)if(e=e.resolve(l)){if(t=this.unitModel(e),!t.traits.isEmpty()||!t.resourceTypes.isEmpty())return!0;l=r(e)}else l=null;return!1},e.prototype.resolveNamespace=function(e,t){if(null==t)return null;var n=t.absolutePath(),r=this.expandedPathMap(e);if(!r)return null;var i=r[n];return i},e.prototype.expandedNSMap=function(e){var t=e.absolutePath(),n=this._expandedNSMap[t];if(void 0===n){var r=this.expandedPathMap(e);if(r){n={};for(var i=0,a=Object.keys(r);i<a.length;i++){var o=a[i],s=r[o];n[s.namespace()]=s}}else n=null;this._expandedNSMap[t]=n}return n},e.prototype.expandedPathMap=function(e){var t=e.absolutePath(),n=this.expandedAbsToNsMap[t];return void 0===n&&(n=this.calculateExpandedNamespaces(e),0==Object.keys(n).length&&(n=null),this.expandedAbsToNsMap[t]=n),n},e.prototype.calculateExpandedNamespaces=function(e){for(var t=this,n=A.dirname(e.absolutePath()),i={},a=[];e;){a.push(new w([],e,""));var o=e;e=null;var s=o.ast();if(s&&s.kind()!=_.Kind.SCALAR){var u=I.ramlFirstLine(o.contents());if(u&&3==u.length&&(u[2]==b.universesInfo.Universe10.Overlay.name||u[2]==b.universesInfo.Universe10.Extension.name)){var l=r(o);l&&(e=o.resolve(l),e&&N.isWaitingFor(e.absolutePath())&&(e=null))}}}for(var p,c,f,h,s,d,m,y=function(){p={},c={},f=a[v],h=f.unit;var e=h.absolutePath();return s=h.ast(),s&&s.kind()!=_.Kind.SCALAR?(d=f.steps()+1,m=function(r){if(r){var o=r.children(),s=r.unit(),u=s.absolutePath();if(null==r.parent()){if(p[u])return;if(p[u]=!0,u!=e){var l=I.ramlFirstLine(s.contents());l&&3==l.length&&"1.0"==l[1]&&(t._hasFragments[e]=!0)}var h=t.pathMap(s);if(h)for(var y=0,v=Object.keys(h);y<v.length;y++){var E=v[y],T=h[E],S=f.namespaceSegments.concat(T.namespaceSegments),N=f.usesNodes.concat(T.usesNodes),b=i[E];if(b){if(b.steps()<d)continue;if(b.steps()==d&&t.lexLessEq(b.namespaceSegments,S))continue}var R,M=T.includePath,C=T.absolutePath();R=A.isAbsolute(f.includePath)||g.isWebPath(f.includePath)?C:A.isAbsolute(M)||g.isWebPath(M)?C:g.isWebPath(n)!=g.isWebPath(C)?C:n.length>0&&C.length>0&&n.charAt(0).toLowerCase()!=C.charAt(0).toLowerCase()?C:A.relative(n,C),R=R.replace(/\\/g,"/");var P=new w(N,T.unit,R);c[P.absolutePath()]||(i[E]=P,a.push(P),c[P.absolutePath()]=!0)}}o.forEach(function(e){if(e.valueKind()==_.Kind.INCLUDE_REF){var t=s.resolve(e.includePath());if(t){if(!t.isRAMLUnit())return;m(t.ast())}}else m(e)}),null==r.parent()&&(p[u]=!1)}},void m(s)):"continue"},v=0;v<a.length;v++)y();for(var E={},T=0,S=Object.keys(i);T<S.length;T++){for(var R=S[T],f=i[R],M=f.namespace(),v=0;E[M];)M=f.namespace()+v++;M!=f.namespace()&&(f.namespaceSegments=M.split(".")),E[M]=!0}return i},e.prototype.pathMap=function(e){var t=e.absolutePath(),n=this.byPathMap[t];return void 0===n&&(n=this.calculateNamespaces(e),0==Object.keys(n).length&&(n=null),this.byPathMap[t]=n),n},e.prototype.nsMap=function(e){var t=e.absolutePath(),n=this.byNsMap[t];if(void 0===n){var r=this.pathMap(e);if(null==r)n=null;else{n={};for(var i=0,a=Object.keys(r);i<a.length;i++){var o=a[i],s=r[o];n[s.namespace()]=s}}this.byNsMap[t]=n}return n},e.prototype.calculateNamespaces=function(e){var t=A.dirname(e.absolutePath()),n={},r=e.ast(),i=r.children().filter(function(e){return e.key()==E.Universe10.FragmentDeclaration.properties.uses.name});if(r.actual()&&r.actual().usesNode&&(i=[r.actual().usesNode]),0==i.length)return n;for(var a=[],o=0,s=i;o<s.length;o++){var u=s[o];a=a.concat(u.children())}if(0==a.length)return n;for(var l=0,p=a;l<p.length;l++){var u=p[l],c=u.value(),f=e.resolve(c);if(null!=f){var h,i=[u],d=f.absolutePath();h=g.isWebPath(c)?f.absolutePath():A.relative(t,f.absolutePath()),h=h.replace(/\\/g,"/");var m=new w(i,f,h);n[d]=m}}var y=e.ast();if(y&&y.kind()!=_.Kind.SCALAR){var v=I.ramlFirstLine(e.contents());if(3==v.length&&(v[2]==b.universesInfo.Universe10.Overlay.name||v[2]==b.universesInfo.Universe10.Extension.name)){var T=R.find(y.children(),function(e){return e.key()==E.Universe10.Extension.properties.extends.name});if(T){var S,N=T.value(!0);try{S=e.resolve(N)}catch(e){}if(S){var M=this.pathMap(S);if(M)for(var C=0,P=Object.keys(M);C<P.length;C++){var L=P[C];n[L]=M[L]}}}}}return n},e.prototype.lexLessEq=function(e,t){if(e.length>t.length)return!1;if(e.length<t.length)return!0;for(var n=0;n<e.length;n++){var r=e[n],i=t[n];if(r<i)return!0;if(r>i)return!1}return!0},e.prototype.hasFragments=function(e){if(!e.isRAMLUnit())return!1;var t=I.ramlFirstLine(e.contents());return!(!t||t.length<2||"1.0"!=t[1])&&(this.expandedPathMap(e),!!this._hasFragments[e.absolutePath()])},e.prototype.unitModel=function(e,t){var n=e.absolutePath(),r=this._unitModels[n];return r?r:(r=new L(e),this._unitModels[n]=r,h(r,this,t),r)},e.prototype.deleteUnitModel=function(e){delete this._unitModels[e]},e.prototype.getComponent=function(e,t,n,r,i){var a=this.expandedNSMap(e);if(a){var o=e;if(n){var s=a[n];o=s?s.unit:null}if(o){var u=this.unitModel(o,i),l=u[t];if(l&&P.isInstance(l)){var p=l.getTemplateModel(r);return p&&!p.isInitialized()&&d(p,this,i),p}}}},e}();t.NamespaceResolver=C;var w=function(){function e(e,t,n){this.usesNodes=e,this.unit=t,this.includePath=n,this.namespaceSegments=this.usesNodes.map(function(e){return e.key()})}return e.prototype.steps=function(){return this.namespaceSegments.length},e.prototype.namespace=function(){return this.namespaceSegments.join(".")},e.prototype.absolutePath=function(){return this.unit.absolutePath()},e}();t.UsesInfo=w;var P=function(){function e(e){this.name=e,this.array=[],this.map={}}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&R.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.hasElement=function(e){return null!=this.map[e]},e.prototype.getElement=function(e){return this.map[e]},e.prototype.getTemplateModel=function(e){return this.templateModels?this.templateModels[e]:null},e.prototype.isEmpty=function(){return 0==this.array.length},e.CLASS_IDENTIFIER="namespaceResolver.ElementsCollection",e}();t.ElementsCollection=P;var L=function(){function e(e){this.unit=e,this.init()}return e.prototype.type=function(){return this._type},e.prototype.init=function(){this.types=new P(b.universesInfo.Universe10.LibraryBase.properties.types.name),this.annotationTypes=new P(b.universesInfo.Universe10.LibraryBase.properties.annotationTypes.name),this.securitySchemes=new P(b.universesInfo.Universe10.LibraryBase.properties.securitySchemes.name),this.traits=new P(b.universesInfo.Universe10.LibraryBase.properties.traits.name),this.resourceTypes=new P(b.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name);var e=I.ramlFirstLine(this.unit.contents());e&&(e.length<3||!e[2]?this._type=b.universesInfo.Universe10.Api.name:this._type=e[2])},e.prototype.isOverlayOrExtension=function(){return this._type==b.universesInfo.Universe10.Overlay.name||this._type==b.universesInfo.Universe10.Extension.name},e.prototype.extensionSet=function(){if(!this._extensionSet){this._extensionSet={},this._extensionChain=[];for(var e=this;e;){var t=e.unit.absolutePath();if(this._extensionSet[t])break;this._extensionSet[t]=e,this._extensionChain.push(e),e=e.master}}return this._extensionSet},e.prototype.extensionChain=function(){return this._extensionChain||this.extensionSet(),this._extensionChain},e}();t.UnitModel=L;var O,D=function(){function e(e,t,n,r){this.name=e,this.kind=t,this.node=n,this.typeValuedParameters=r}return e.prototype.isInitialized=function(){return null!=this.typeValuedParameters},e.prototype.id=function(){return this.node.unit().absolutePath()+"|"+this.kind+"|"+this.node.key()},e}();t.TemplateModel=D;var U=function(){function e(){this.parent=new S.ReferencePatcherActionsAndConditionsFactory}return e.prototype.action=function(e){var t=c;return"##patch"==e?t=s:"##patchAnnotationName"==e?t=u:"##patchResourceTypeReference"==e?t=o:"##patchTraitReference"==e&&(t=a),t},e.prototype.condition=function(e){return this.parent.condition(e)},e}();t.NamespaceResolverActionsAndConditionsFactory=U,t.extendedUnit=f,t.initUnitModel=h,t.isLibraryBaseDescendant=m},function(e,t,n){t.no=t.noCase=n(226),t.dot=t.dotCase=n(231),t.swap=t.swapCase=n(232),t.path=t.pathCase=n(234),t.upper=t.upperCase=n(233),t.lower=t.lowerCase=n(227),t.camel=t.camelCase=n(235),t.snake=t.snakeCase=n(236),t.title=t.titleCase=n(237),t.param=t.paramCase=n(238),t.header=t.headerCase=n(239),t.pascal=t.pascalCase=n(240),t.constant=t.constantCase=n(242),t.sentence=t.sentenceCase=n(243),t.isUpper=t.isUpperCase=n(244),t.isLower=t.isLowerCase=n(245),t.ucFirst=t.upperCaseFirst=n(241),t.lcFirst=t.lowerCaseFirst=n(246)},function(e,t,n){var r=n(227),i=n(228),a=n(229),o=n(230);e.exports=function(e,t,n){function s(e,t,r){return 0===t||t===r.length-e.length?"":n}return null==e?"":(n="string"!=typeof n?" ":n,e=String(e).replace(a,"$1 $2").replace(o,"$1 $2").replace(i,s),r(e,t))}},function(e,t){var n={tr:{regexp:/\u0130|\u0049|\u0049\u0307/g,map:{"İ":"i",I:"ı","İ":"i"}},az:{regexp:/[\u0130]/g,map:{"İ":"i",I:"ı","İ":"i"}},lt:{regexp:/[\u0049\u004A\u012E\u00CC\u00CD\u0128]/g,map:{I:"i̇",J:"j̇","Į":"į̇","Ì":"i̇̀","Í":"i̇́","Ĩ":"i̇̃"}}};e.exports=function(e,t){var r=n[t];return e=null==e?"":String(e),r&&(e=e.replace(r.regexp,function(e){return r.map[e]})),e.toLowerCase()}},function(e,t){e.exports=/[^A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC0-9\xB2\xB3\xB9\xBC-\xBE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0DE6-\u0DEF\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uA9F0-\uA9F9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]+/g},function(e,t){e.exports=/([a-z\xB5\xDF-\xF6\xF8-\xFF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0529\u052B\u052D\u052F\u0561-\u0587\u13F8-\u13FD\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA699\uA69B\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793-\uA795\uA797\uA799\uA79B\uA79D\uA79F\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7B5\uA7B7\uA7FA\uAB30-\uAB5A\uAB60-\uAB65\uAB70-\uABBF\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A0-9\xB2\xB3\xB9\xBC-\xBE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0DE6-\u0DEF\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uA9F0-\uA9F9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])([A-Z\xC0-\xD6\xD8-\xDE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u037F\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0528\u052A\u052C\u052E\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u13A0-\u13F5\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA698\uA69A\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA796\uA798\uA79A\uA79C\uA79E\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA-\uA7AD\uA7B0-\uA7B4\uA7B6\uFF21-\uFF3A])/g},function(e,t){e.exports=/([A-Z\xC0-\xD6\xD8-\xDE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u037F\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0528\u052A\u052C\u052E\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u13A0-\u13F5\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA698\uA69A\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA796\uA798\uA79A\uA79C\uA79E\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA-\uA7AD\uA7B0-\uA7B4\uA7B6\uFF21-\uFF3A])([A-Z\xC0-\xD6\xD8-\xDE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u037F\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0528\u052A\u052C\u052E\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u13A0-\u13F5\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA698\uA69A\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA796\uA798\uA79A\uA79C\uA79E\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA-\uA7AD\uA7B0-\uA7B4\uA7B6\uFF21-\uFF3A][a-z\xB5\xDF-\xF6\xF8-\xFF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0529\u052B\u052D\u052F\u0561-\u0587\u13F8-\u13FD\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA699\uA69B\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793-\uA795\uA797\uA799\uA79B\uA79D\uA79F\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7B5\uA7B7\uA7FA\uAB30-\uAB5A\uAB60-\uAB65\uAB70-\uABBF\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A])/g;
},function(e,t,n){var r=n(226);e.exports=function(e,t){return r(e,t,".")}},function(e,t,n){var r=n(233),i=n(227);e.exports=function(e,t){if(null==e)return"";for(var n="",a=0;a<e.length;a++){var o=e[a],s=r(o,t);n+=s===o?i(o,t):s}return n}},function(e,t){var n={tr:{regexp:/[\u0069]/g,map:{i:"İ"}},az:{regexp:/[\u0069]/g,map:{i:"İ"}},lt:{regexp:/[\u0069\u006A\u012F]\u0307|\u0069\u0307[\u0300\u0301\u0303]/g,map:{"i̇":"I","j̇":"J","į̇":"Į","i̇̀":"Ì","i̇́":"Í","i̇̃":"Ĩ"}}};e.exports=function(e,t){var r=n[t];return e=null==e?"":String(e),r&&(e=e.replace(r.regexp,function(e){return r.map[e]})),e.toUpperCase()}},function(e,t,n){var r=n(226);e.exports=function(e,t){return r(e,t,"/")}},function(e,t,n){var r=n(233),i=n(226);e.exports=function(e,t,n){var a=i(e,t);return n||(a=a.replace(/ (?=\d)/g,"_")),a.replace(/ (.)/g,function(e,n){return r(n,t)})}},function(e,t,n){var r=n(226);e.exports=function(e,t){return r(e,t,"_")}},function(e,t,n){var r=n(226),i=n(233);e.exports=function(e,t){return r(e,t).replace(/^.| ./g,function(e){return i(e,t)})}},function(e,t,n){var r=n(226);e.exports=function(e,t){return r(e,t,"-")}},function(e,t,n){var r=n(226),i=n(233);e.exports=function(e,t){return r(e,t,"-").replace(/^.|-./g,function(e){return i(e,t)})}},function(e,t,n){var r=n(235),i=n(241);e.exports=function(e,t,n){return i(r(e,t,n),t)}},function(e,t,n){var r=n(233);e.exports=function(e,t){return null==e?"":(e=String(e),r(e.charAt(0),t)+e.substr(1))}},function(e,t,n){var r=n(233),i=n(236);e.exports=function(e,t){return r(i(e,t),t)}},function(e,t,n){var r=n(226),i=n(241);e.exports=function(e,t){return i(r(e,t),t)}},function(e,t,n){var r=n(233);e.exports=function(e,t){return r(e,t)===e}},function(e,t,n){var r=n(227);e.exports=function(e,t){return r(e,t)===e}},function(e,t,n){var r=n(227);e.exports=function(e,t){return null==e?"":(e=String(e),r(e.charAt(0),t)+e.substr(1))}},function(e,t,n){"use strict";function r(e,t){var n=e.root().definition().universe(),i=e.lowLevel().key();if(i){var a=y.ASTPropImpl.isInstance(e)?e:null;_(i,t,a,!0,n,!0)}if(e.children().forEach(function(e){return r(e,t)}),y.ASTPropImpl.isInstance(e)){var o=e,s=o.value();if("string"==typeof s){var u=s;_(u,t,o,!1,n)}else e.lowLevel().visit(function(e){if(e.value()){var r=e.value()+"";_(r,t,o,!0,n)}return!0})}else if(y.BasicASTNode.isInstance(e)){var s=e.lowLevel().value();if("string"==typeof s){var u=s;_(u,t,null,!1,n)}else e.lowLevel().visit(function(e){if(e.value()){var r=e.value()+"";_(r,t,null,!0,n)}return!0})}}function i(e,t,n){void 0===n&&(n=[]),e.optional()&&(n=n.concat("/"));var r=e.value();if("string"==typeof r)for(var a=r,o=E(a),s=o.parameterUsages,u=0,l=s;u<l.length;u++){var p=l[u],c=t[p];null==c&&(c=[],t[p]=c),c.push(n)}else for(var f=0,h=e.children();f<h.length;f++){var d=h[f];i(d,t,n.concat(d.key()))}}function a(e,t){var n={},a={};r(t,n),i(t.lowLevel(),a);for(var o=0,s=Object.keys(a);o<s.length;o++){var u=s[o];a[u]=d.unique(a[u])}e.getAdapter(v.RAMLService).setInlinedTemplates(!0),Object.keys(n).forEach(function(r){var i=null;n[r].length>0&&(i=n[r][0].attr);var o=new f.UserDefinedProp(r,i);o.withDomain(e);var s=a[r];o.getAdapter(v.RAMLPropertyService).putMeta("templatePaths",s);var u;if("RAML10"==t.definition().universe().version()){var l=n[r].filter(function(e){return A.isStringTypeType(e.tp)}).length>0;u=l?m.Universe10.StringType.name:m.Universe10.AnyType.name}else u=m.Universe08.StringType.name;var p=d.unique(n[r].map(function(e){return e.tp})).filter(function(e){return e&&e.nameId()!=u});o.withRange(1==p.length?p[0]:t.definition().universe().type(u)),o.withRequired(!0),1==p.length&&"RAML10"==t.definition().universe().version()&&p[0].key()==m.Universe10.SchemaString&&o.getAdapter(v.RAMLPropertyService).setTypeExpression(!0),o.unmerge()});var l=new f.UserDefinedProp("____key",t);return l.withDomain(e),l.withKey(!0),l.withFromParentKey(!0),l.withRange(t.definition().universe().type(m.Universe08.StringType.name)),e}function o(e,t){"RAML08"==t.universe().version()&&e.getAdapter(v.RAMLService).withAllowAny();var n=t.property(t.getAdapter(v.RAMLService).getReferenceIs());return n&&n.range().properties().forEach(function(t){var n=new f.Property(t.nameId());n.unmerge(),n.withDomain(e),n.withRange(t.range()),n.withMultiValue(t.isMultiValue())}),e}function s(e){if(!e)return null;if(e.associatedType())return e.associatedType();var t=e.root(),n=t.definition()&&A.isApiSibling(t.definition()),r=e.root().lowLevel().libProcessed;if((!n||r)&&e.definition().isAssignableFrom(m.Universe10.TypeDeclaration.name)){var i=e.parent();if(i&&i.definition().isAssignableFrom(m.Universe10.TypeDeclaration.name)){var s=i.localType();if(null!=s)if(A.isPropertiesProperty(e.property())){var l=e.name(),p=s.properties().find(function(e){return e.nameId()==l});if(p){var c=p.range();if(c)return c}}else if(A.isItemsProperty(e.property())&&s.isArray()){var d=s.array().componentType();if(d)return d}else if(A.isTypeProperty(e.property())){var y=s.superTypes(),d=y&&1==y.length&&y[0];if(d)return d}}}var g=e.lowLevel().unit(),E=g?g.path():"";h.setPropertyConstructor(function(t){var n=null,r=e.elementsOfKind("properties").filter(function(e){return e.name()==t});r&&(n=r[0]);var i=new f.UserDefinedProp(t,n);return i.unmerge(),i});try{var _=e.definition();if(e.property()&&e.property().nameId()==m.Universe10.LibraryBase.properties.annotationTypes.name){var S=new T(e.name(),e.definition().universe(),e,E,""),N=u(e);S._superTypes.push(N),0==e.elementsOfKind(m.Universe10.ObjectTypeDeclaration.properties.properties.name).length&&S.getAdapter(v.RAMLService).withAllowAny();var I=_.getAdapter(v.RAMLService).getExtendedType();return I&&S._superTypes.push(I),S}var S=new f.UserDefinedClass(e.name(),e.definition().universe(),e,E,"");if(e.setAssociatedType(S),_.getAdapter(v.RAMLService).isInlinedTemplates())return a(S,e);if(_.getAdapter(v.RAMLService).getReferenceIs())return o(S,_);var b=u(e);b.getAdapter(v.RAMLService).setDeclaringNode(e),e.setAssociatedType(b)}finally{h.setPropertyConstructor(null)}return b}function u(e){return h.toNominal(e.parsedType(),function(t){var n=e.definition().universe().type(t);if(!n){new f.UserDefinedClass("",e.definition().universe(),e,"","")}return n})}function l(e){return function(t){var n=e.type(t);if(!n){new f.UserDefinedClass("",e,null,"","")}return n}}function p(e,t){var n=d.find(e.elementsOfKind("types"),function(e){return e.name()==t.name()});n&&h.setPropertyConstructor(function(e){var t=n.elementsOfKind("properties").filter(function(t){return t.name()==e}),r=null;if(t&&t.length>0)r=t[0];else{var t=n.elementsOfKind("facets").filter(function(t){return t.name()==e});t&&t.length>0&&(r=t[0])}var i=new f.UserDefinedProp(e,r);return i.unmerge(),i});var r=l(e.definition().universe());return h.toNominal(t,r)}var c=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var f=n(56),h=f.rt,d=n(16),m=n(204),y=n(55),v=f,g=n(19),A=n(205);h.setPropertyConstructor(function(e){var t=new f.Property(e);return t.unmerge(),t});var E=function(e,t){void 0===t&&(t=!1),t&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)&&(e=e.substring(1,e.length-1));for(var n=[],r=0;;){var i=e.indexOf("<<",r);if(i==-1)break;var a=e.indexOf(">>",i),o=0==i&&a==e.length-2,s=e.substring(i+2,a);r=i+2;var u=s.indexOf("|");u!=-1&&(o=!1,s=s.substring(0,u)),s=s.trim(),n.push(s)}return{parameterUsages:n,isFull:o}},_=function(e,t,n,r,i,a){void 0===a&&(a=!1);var o=E(e,a),s=o.parameterUsages,u=o.isFull,l=n?n.property().range():null;a&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)?(l=i.type(m.Universe10.SchemaString.name),r=!1):n&&(n.property().nameId()!=m.Universe10.TypeDeclaration.properties.type.name&&n.property().nameId()!=m.Universe10.TypeDeclaration.properties.schema.name||n.property().domain().key()==m.Universe10.TypeDeclaration&&(l=i.type(m.Universe10.SchemaString.name))),!u||r?l=i.type(m.Universe10.StringType.name):null==l&&"RAML10"==i.version()&&(l=i.type(m.Universe10.AnyType.name));for(var p=0,c=s;p<c.length;p++){var f=c[p];if(null==g.RESERVED_TEMPLATE_PARAMETERS[f]){var h=t[f];h?h.push({tp:l,attr:n}):t[f]=[{tp:l,attr:n}]}}},T=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return c(t,e),t.prototype.allProperties=function(e){void 0===e&&(e={});var t=this.superTypes()[0].allProperties();if(1==t.length&&"annotations"==t[0].nameId()){var n=this.getAdapter(f.RAMLService).getDeclaringNode(),r=new f.UserDefinedProp("value",n);r.withDomain(this),r.withCanBeValue(),r.withRequired(!1);this.superTypes()[0];t=[],r.withRange(r.node().asElement().definition().universe().type("string")),t.push(r)}return t},t.prototype.isAnnotationType=function(){return!0},t}(f.UserDefinedClass);t.typeFromNode=s,t.convertType=p},function(e,t){"use strict";function n(e){return e&&e.indexOf("\n")>=0}function r(e){return n(e)&&e.length>2&&"|"==e[0]&&("\n"==e[1]||"\r"==e[1]||"\n"==e[2])}function i(e,t){var r="";if(n(e)){r+="|\n";for(var i=f(e),a=0;a<i.length;a++)r+=s(t,i[a])}else r+=e;return r}function a(e){if(!r(e))return e;for(var t=null,n=f(e),i=1;i<n.length;i++){var a=n[i],o=a.substring(2);t?t+=o:t=o}return t}function o(e){if(!e)return e;for(var t=0;t<e.length;){var n=e[t];if("\r"!=n&&"\n"!=n&&" "!=n&&"\t"!=n)break;t++}return e.substring(t,e.length)}function s(e,t){void 0===t&&(t="");for(var n="",r=0;r<e;r++)n+="  ";return n+t}function u(e,t){void 0===t&&(t=""),console.log(s(e,t))}function l(e,t){void 0===t&&(t=null);for(var n="",r=0;r<e.length;r++){var i=e[r];"\r"==i&&(i=null==t?"\\r":t),"\n"==i&&(i=null==t?"\\n":t),n+=i}return n}function p(e){for(var t=e.length;t>0;){var n=e[t-1];if(" "!=n&&"\t"!=n&&"\r"!=n&&"\n"!=n)break;t--}return e.substring(0,t)}function c(e){return o(p(e))}function f(e){var t=e.match(/^.*((\r\n|\n|\r)|$)/gm);return t}function h(e,t){if(!e||!t||e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[n]!=t[n])return!1;return!0}function d(e,t){if(!e||!t||e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[e.length-1-n]!=t[t.length-1-n])return!1;return!0}function m(e){return e.charAt(0).toUpperCase()+e.slice(1)}Object.defineProperty(t,"__esModule",{value:!0}),t.isMultiLine=n,t.isMultiLineValue=r,t.makeMutiLine=i,t.fromMutiLine=a,t.trimStart=o,t.indent=s,t.print=u,t.replaceNewlines=l,t.trimEnd=p,t.trim=c,t.splitOnLines=f,t.startsWith=h,t.endsWith=d,t.capitalize=m;var y=function(){function e(e,t,n){this.contents=e,this.start=t,this.end=n}return e.prototype.text=function(){return this.contents.substring(this.start,this.end)},e.prototype.startpos=function(){return this.start},e.prototype.endpos=function(){return this.end},e.prototype.len=function(){return this.end-this.start},e.prototype.unitText=function(){return this.contents},e.prototype.withStart=function(t){return new e(this.contents,t,this.end)},e.prototype.withEnd=function(t){return new e(this.contents,this.start,t)},e.prototype.sub=function(e,t){return this.contents.substring(e,t)},e.prototype.trimStart=function(){for(var t=this.start;t<this.contents.length-1;){var n=this.contents[t];if(" "!=n&&"\t"!=n)break;t++}return new e(this.contents,t,this.end)},e.prototype.trimEnd=function(){for(var t=this.end;t>0;){var n=this.contents[t-1];if(" "!=n&&"\t"!=n)break;t--}return new e(this.contents,this.start,t)},e.prototype.extendToStartOfLine=function(){for(var t=this.start;t>0;){var n=this.contents[t-1];if("\r"==n||"\n"==n)break;t--}return new e(this.contents,t,this.end)},e.prototype.extendAnyUntilNewLines=function(){var t=this.end;if(t>0){var n=this.contents[t-1];if("\n"==n)return this}for(;t<this.contents.length-1;){var r=this.contents[t];if("\r"==r||"\n"==r)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendSpacesUntilNewLines=function(){var t=this.end;if(t>0){var n=this.contents[t-1];if("\n"==n)return this}for(;t<this.contents.length-1;){var r=this.contents[t];if(" "!=r)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendSpaces=function(){for(var t=this.end;t<this.contents.length-1;){var n=this.contents[t];if(" "!=n)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendSpacesBack=function(){for(var t=this.start;t>0;){var n=this.contents[t-1];if(" "!=n)break;t--}return new e(this.contents,t,this.end)},e.prototype.extendCharIfAny=function(t){var n=this.end;return n<this.contents.length-1&&this.contents[n]==t&&n++,new e(this.contents,this.start,n)},e.prototype.extendCharIfAnyBack=function(t){var n=this.start;return n>0&&this.contents[n-1]==t&&n--,new e(this.contents,n,this.end)},e.prototype.extendToNewlines=function(){var t=this.end;if(t>0){var n=this.contents[t-1];if("\n"==n)return this}for(;t<this.contents.length-1;){var r=this.contents[t];if("\r"!=r&&"\n"!=r)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendUntilNewlinesBack=function(){for(var t=this.start;t>0;){var n=this.contents[t-1];if("\r"==n||"\n"==n)break;t--}return new e(this.contents,t,this.end)},e.prototype.reduceNewlinesEnd=function(){for(var t=this.end;t>this.start;){var n=this.contents[t-1];if("\r"!=n&&"\n"!=n)break;t--}return new e(this.contents,this.start,t)},e.prototype.reduceSpaces=function(){for(var t=this.end;t>this.start;){var n=this.contents[t-1];if(" "!=n)break;t--}return new e(this.contents,this.start,t)},e.prototype.replace=function(e){return this.sub(0,this.start)+e+this.sub(this.end,this.unitText().length)},e.prototype.remove=function(){return this.sub(0,this.start)+this.sub(this.end,this.unitText().length)},e}();t.TextRange=y},function(e,t,n){"use strict";function r(e){return e.highLevel().localType()}function i(e){return e.highLevel().localType()}function a(e){var t=new we.Project(Le.dirname(e)),n=t.unit(Le.basename(e));return n&&n.isRAMLUnit()?Ae.fromUnit(n).wrapperNode():null}function o(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==Ie.Universe10.Resource.name);return t}function s(e){return Re.expandLibrary(e)}function u(e,t){return void 0===t&&(t=!1),t?p(e):l(e)}function l(e){var t=e.highLevel().lowLevel();return Me.LowLevelProxyNode.isInstance(t)?e:Re.expandTraitsAndResourceTypes(e)}function p(e){return Re.expandLibraries(e)}function c(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==Ie.Universe10.Resource.name);n=x(e);var r=n.baseUri(),i=r?r.value():"";return i=i?i:"",e&&(i=i.replace(/\/+$/,"")),t=i+t}function f(e,t){return e.runtimeType().validate(t).map(function(e){return e.getMessage()})}function h(e,t){return e.runtimeType().validate(t)}function d(e){return m(e)}function m(e){return e.highLevel().lowLevel().actual().libExpanded?e.traits_original():Ue.allTraits(e.highLevel(),!0).map(function(e){return e.wrapperNode()})}function y(e){return v(e)}function v(e){return e.highLevel().lowLevel().actual().libExpanded?e.resourceTypes_original():Ue.allResourceTypes(e.highLevel(),!0).map(function(e){return e.wrapperNode()})}function g(e){var t=[],n=e;do e=n,t.push(e.relativeUri().value()),n=e.parent();while(n.definition().key().name==Ie.Universe10.Resource.name);return t.reverse()}function A(e){return de.ResourceImpl.isInstance(e.parent())?e.parent():null}function E(e){var t=e.parent();return t.definition().key().name==Ie.Universe10.Resource.name?t:null}function _(e,t){if(null==e)return null;var n=e.resources();return n?(n=n.filter(function(e){return e.relativeUri().value()==t}),0==n.length?null:n[0]):null}function T(e,t){if(!e)return null;for(var n=null,r=0;r<t.length;r++){if(n=_(e,t[r]),!n)return null;e=n}return n}function S(e,t){return e?e.methods().filter(function(e){return e.method()==t}):null}function N(e,t,n){var r=T(e,t);return r?S(r,n):null}function I(e){return Oe.isApiSibling(e.definition())}function b(e){for(var t=e;!I(t);)t=t.parent();return t}function R(e){var t=e.parent();if(de.ResourceImpl.isInstance(t))return o(t)+" "+e.method().toLowerCase();if(de.ResourceTypeImpl.isInstance(t))return t.name()+" "+e.method().toLowerCase();throw new Error(Ee.applyTemplate(xe.METHOD_OWNED_BY,{owner:e.definition().key().name}))}function M(e){var t=e.code().value(),n=Ee.validateResponseString(t);if(null!=n)return!1;try{if(parseInt(t.charAt(0))<4)return!0}catch(e){}return!1}function C(e){var t=[],n=function(e){t.push(e),e.resources().forEach(function(e){return n(e)})};return e.resources().forEach(function(e){return n(e)}),t}function w(e,t){for(var n={};null!=t;)L(t).forEach(function(e){return n[e.name()]=new Ve(e)}),t=E(t);var r=ve.ramlPathMatch(o(t),n,{})(e);return r?new be(Object.keys(r.params).map(function(e){return new Be(e,r.params[e])})):be.empty()}function P(e){return L(e)}function L(e){var t=e.uriParameters_original();if(!de.ResourceImpl.isInstance(e))return t;var n=e.relativeUri().value(),r=Ie.Universe10.ResourceBase.properties.uriParameters.name;return pe(t,n,e,r)}function O(e){return D(e)}function D(e){var t=e.baseUri()?e.baseUri().value():"",n=e.baseUriParameters_original(),r=Ie.Universe10.Api.properties.baseUriParameters.name;return pe(n,t,e,r)}function U(e){var t=[],n=e;do e=n,t=L(e).concat(t),n=x(e);while(n.definition().key().name==Ie.Universe10.Resource.name);var r=n;r.baseUriParameters();return t=D(r).concat(t)}function x(e){var t=e.parent();if(!t)return null;var n=t.highLevel().getSlaveCounterPart();return n&&(t=n.wrapperNode()),t}function k(e){return F(e)}function F(e){return e.protocols().map(function(e){return e.toUpperCase()})}function B(e){return V(e)}function V(e){return e.securedBy()}function K(e){var t=e.highLevel();if(!t)return"";var n=t.value();return n?n.toString():""}function j(e){var t=e.highLevel();if(!t)return null;var n=Ce.findDeclarationByNode(t,Ce.LocationKind.VALUE_COMPLETION);if(!n)return null;if(!n.getKind||n.getKind()!=ge.NodeKind.NODE)return null;var r=n.wrapperNode();return de.AbstractSecuritySchemeImpl.isInstance(r)?r:null}function W(e){return e.highLevel().definition().universe().version()}function H(e){var t=e.value().lowLevel(),n=null,r=t.highLevelParseResult();if(r){var i=null,a=!1;if(r.isAttr()?(a=Oe.isAnnotationsProperty(r.property()),i=r.parent().types()):r.isElement()&&(i=r.asElement().types()),i){var o=e.name(),s=o.indexOf(".")>=0;if(s){var u=a?i.getAnnotationTypeRegistry():i.getTypeRegistry();n=u.get(o)}else n=a?i.getAnnotationType(o):i.getType(o)}}return new ye.TypeInstanceImpl(t,n)}function Y(e){var t=e.highLevel().value();return"string"==typeof t||null==t?t:Ae.StructuredValue.isInstance(t)?t.valueName():null}function q(e){return z(e)}function G(e){return z(e)}function X(e){return z(e)}function z(e){var t=e.highLevel(),n=t.parent(),r=e.name(),i=Ce.referenceTargets(t.property(),n).filter(function(e){return Ae.qName(e,n)==r});return 0==i.length?null:i[0].wrapperNode()}function $(e,t,n,r){void 0===r&&(r=!0);var i=t.lowLevel(),a=t.definition().property(n?"example":"examples"),o=Te.getUniverse("RAML10"),s=o.type(Ne.Universe10.ExampleSpec.name),u=e.examples().filter(function(e){return null!=e&&!e.isEmpty()&&e.isSingle()==n});return u.map(function(e){var n=e.asJSON(),o=e.isSingle()?"example":null,u=i.unit(),l=new Pe.AstNode(u,n,i,null,o),p=r?new Ae.ASTNodeImpl(l,t,s,a):t,c=e.annotations(),f=ke(c,l,p,u),h=e.scalarsAnnotations(),d={};Object.keys(h).forEach(function(e){return d[e]=ke(h[e],l,p,u)});var m=new Ke(p,e,f,{description:function(){return d.description||[]},displayName:function(){return d.displayName||[]},strict:function(){return d.strict||[]}});return m})}function J(e,t){void 0===t&&(t=!1);var n=e.runtimeDefinition();if(!n)return[];var r=n.getExtra(Se.TOP_LEVEL_EXTRA),i=e.highLevel().property(),a=i&&(Oe.isTypesProperty(i)||Oe.isSchemasProperty(i));if(a||!r){var o=e.highLevel();return $(n,o,t)}return[]}function Q(e){var t=J(e,!0);return t.length>0?t[0]:null}function Z(e){return J(e)}function ee(e){var t=e.runtimeDefinition(),n=t.fixedFacets();if(e.kind()==Ne.Universe10.UnionTypeDeclaration.name)for(var r=t.allFixedBuiltInFacets(),i=0,a=Object.keys(r);i<a.length;i++){var o=a[i];n[o]=r[o]}else for(var s=Object.keys(n),u=0,l=s;u<l.length;u++){var o=l[u];null==t.facet(o)&&delete n[o]}if(0==Object.keys(n).length)return null;var p=new Pe.AstNode(null,n);return new ye.TypeInstanceImpl(p)}function te(e){return e.type_original()}function ne(e){return e.schema_original()}function re(e){var t=e.highLevel().attributes(Te.universesInfo.Universe10.TypeDeclaration.properties.type.name);t=t.concat(e.highLevel().attributes(Te.universesInfo.Universe10.TypeDeclaration.properties.schema.name));for(var n=t.map(function(e){return e.value()}),r=0,i=n;r<i.length;r++){var a=i[r];if(Ae.StructuredValue.isInstance(a)){var o=new ye.TypeInstanceImpl(a.lowLevel());return o}}return null}function ie(e){for(var t=e.highLevel().attributes(Te.universesInfo.Universe10.ArrayTypeDeclaration.properties.items.name),n=t.map(function(e){return e.value()}),r=0,i=n;r<i.length;r++){var a=i[r];if(Ae.StructuredValue.isInstance(a)){var o=new ye.TypeInstanceImpl(a.lowLevel());return o}}return null}function ae(e){var t=e.value(),n=e.highLevel().lowLevel().unit().resolve(t),r=n.highLevel(),i=r.asElement();if(i){var a=i.wrapperNode();return he.isLibrary(a)?(a.setAttributeDefaults(e.attributeDefaults()),a):null}return null}function oe(e){var t=e.highLevel().attributes(Te.universesInfo.Universe10.ArrayTypeDeclaration.properties.items.name),n=t.filter(function(e){return Ae.StructuredValue.isInstance(e.value())});if(0==n.length)return e.items_original().map(function(e){return null===e||"NULL"===e||"Null"===e?"string":e});var r=!1,i=t.map(function(e){var t=e.value();return null==t?null:"string"==typeof t?t:(Ae.StructuredValue.isInstance(t)&&(r=!0),t.toString())});return r?null:i}function se(e){var t=e.highLevel();if(!t)return null;var n=t.attr(Ie.Universe10.TypeDeclaration.properties.type.name);if(null==n)return null;var r=n.lowLevel();if(null==r)return null;var i=n.value();if(!i||"string"!=typeof i)return null;var a=r.end()-i.length+1,o=n.lowLevel().unit();if(!o)return null;var s=Ce.findDeclaration(o,a);return s&&s.getKind&&s.getKind()==ge.NodeKind.NODE&&Oe.isTypeDeclarationSibling(s.definition())?s.wrapperNode():null}function ue(e){var t=e.runtimeType();if(!t)return null;if(!t.isArray()||!t.componentType)return null;var n=t,r=n.componentType();if(!r)return null;var i=Ce.getNominalTypeSource(r);if(!i)return null;var a=i.getSource();if(!a)return null;if(!a.isElement())return null;if(!Oe.isTypeDeclarationSibling(a.definition()))return null;var o=a.wrapperNode();return o}function le(e){var t=e.items_original();if(t&&"string"!=typeof t&&(!Array.isArray(t)||0!=t.length)){var n=e.highLevel(),r=Ne.Universe10.ArrayTypeDeclaration.properties.items.name,i=n.attr(r),a=n.definition().universe().type(Ne.Universe10.TypeDeclaration.name),o=n.definition().universe().type(Ne.Universe10.ArrayTypeDeclaration.name),s=new Ae.ASTNodeImpl(i.lowLevel(),n,a,o.property(r));s.patchType(De.doDescrimination(s))}var u=ue(e);return u?u:se(e)}function pe(e,t,n,r){"string"!=typeof t&&(t="");var i=n.highLevel(),a=i.definition(),o=a.property(r),s={};e.forEach(function(e){var t=s[e.name()];t||(t=[],s[e.name()]=t),t.push(e)});for(var u=[],l=0,p={},c=t.indexOf("{");c>=0&&(l=t.indexOf("}",++c),!(l<0));c=t.indexOf("{",l)){var f=t.substring(c,l);if(p[f]=!0,s[f])s[f].forEach(function(e){return u.push(e)});else{var h=a.universe(),d=h.type(Ne.Universe10.StringTypeDeclaration.name),m=_e.createStubNode(d,null,f,i.lowLevel().unit()),y=me.buildWrapperNode(m),v=y.highLevel();v.setParent(i),y.meta().setCalculated(),y.setName(f),v.patchProp(o),u.push(y)}}return Object.keys(s).filter(function(e){return!p[e]}).forEach(function(e){return s[e].forEach(function(e){return u.push(e)})}),u}function ce(e){if(e.kind()==Ne.Universe10.Method.name||Oe.isTypeDeclarationSibling(e.definition())){for(var t=!1,n=e.highLevel().parent();null!=n;){var r=n.definition();if(Oe.isResourceTypeType(r)||Oe.isTraitType(r)){t=!0;break}n=n.parent()}if(!t)return null}var i=e.highLevel();if(null==i)return null;var a=i.lowLevel();if(null==a)return null;var o=a.children().filter(function(e){var t=e.key();return!!t&&(("("!=t.charAt(0)||")"!=t.charAt(t.length-1))&&t.indexOf("<<")>=0)});if(0==o.length)return null;var s=new ye.TypeInstanceImpl(o);return s}var fe=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var he=n(222),de=n(2),me=n(250),ye=n(219),ve=n(251),ge=n(198),Ae=n(55),Ee=n(19),_e=n(3),Te=n(56),Se=Te.tsInterfaces,Ne=n(204),Ie=n(204),be=n(17),Re=n(217),Me=n(199),Ce=n(209),we=n(4),Pe=n(20),Le=n(6),Oe=n(205),De=n(208),Ue=n(254),xe=n(207);t.resolveType=r,t.runtimeType=i,t.load=a,t.completeRelativeUri=o,t.expandLibrarySpec=s,t.expandSpec=u,t.expandTraitsAndResourceTypes=l,t.expandLibraries=p,t.absoluteUri=c,t.validateInstance=f,t.validateInstanceWithDetailedStatuses=h,t.traitsPrimary=d,t.allTraits=m,t.resourceTypesPrimary=y,t.allResourceTypes=v,t.relativeUriSegments=g,t.parentResource=A,t.parent=E,t.childResource=_,t.getResource=T,t.childMethod=S,t.getMethod=N,t.ownerApi=b,t.methodId=R,t.isOkRange=M,t.allResources=C,t.matchUri=w;t.uriParametersPrimary=P,t.uriParameters=L,t.baseUriParametersPrimary=O,t.baseUriParameters=D,t.absoluteUriParameters=U,t.protocolsPrimary=k,t.allProtocols=F,t.securedByPrimary=B,t.allSecuredBy=V,t.securitySchemeName=K,t.securityScheme=j,t.RAMLVersion=W,t.structuredValue=H,t.referenceName=Y,t.referencedTrait=q,t.referencedAnnotation=G,t.referencedResourceType=X;var ke=function(e,t,n,r){var i=[];if(e)for(var a=Te.getUniverse("RAML10"),o=a.type("Annotable").property("annotations"),s=0,u=Object.keys(e);s<u.length;s++){var l=u[s],p=e[l],c=new Pe.AstNode(r,p.value(),t,null,"("+l+")"),f=new Ae.ASTPropImpl(c,n,o.range(),o),h=new de.AnnotationRefImpl(f);i.push(h)}return i};t.examplesFromNominal=$,t.getTypeExample=Q,t.getTypeExamples=Z,t.typeFixedFacets=ee,t.typeValue=te,t.schemaValue=ne,t.typeStructuredValue=re,t.itemsStructuredValue=ie,t.referencedNode=ae,t.getItems=oe,t.findComponentTypeDeclaration=le,t.getTemplateParametrizedProperties=ce;var Fe=function(){function e(e,t){this._content=e,this._name=t}return e.prototype.name=function(){return this._name},e.prototype.content=function(){return this._content},e}();t.SchemaDef=Fe;var Be=function(){function e(e,t){this.key=e,this.value=t}return e}();t.ParamValue=Be;var Ve=function(){function e(e){this._param=e,this.description=e.description()?e.description().value():this.description,this.displayName=e.displayName(),this.type=e.type().length>0?e.type()[0]:"string",this.example=e.example(),this.required=e.required(),this.default=e.default()}return e}(),Ke=function(e){function t(t,n,r,i){var a=e.call(this,t)||this;return a.expandable=n,a._annotations=r,a._scalarAnnotations=i,a}return fe(t,e),t.prototype.value=function(){return this.expandable.asString()},t.prototype.structuredValue=function(){var e;e=this.expandable.isJSONString()||this.expandable.isYAML()?this.expandable.asJSON():this.expandable.original();var t=this._node.lowLevel(),n=this.expandable.isSingle()?"example":null,r=new Pe.AstNode(t.unit(),e,t,null,n);return new ye.TypeInstanceImpl(r)},t.prototype.strict=function(){return this.expandable.strict()},t.prototype.description=function(){var e=this.expandable.description();if(null==e&&null!==e)return null;var t=_e.createAttr(this._node.definition().property(Ne.Universe10.ExampleSpec.properties.description.name),e);t.lowLevel().setUnit(this._node.lowLevel().unit());var n=new de.MarkdownStringImpl(t);return n},t.prototype.name=function(){return this.expandable.name()},t.prototype.displayName=function(){return this.expandable.displayName()},t.prototype.annotations=function(){return this._annotations},t.prototype.scalarsAnnotations=function(){return this._scalarAnnotations},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t}(ye.BasicNodeImpl);t.ExampleSpecImpl=Ke},function(e,t,n){"use strict";function r(e){return e.isBuiltIn()?s[e.nameId()]:null}function i(e,t){void 0===t&&(t=!0);var n=e.definition(),i=(n.nameId(),r(n));if(!i){for(var o=a(n),u=n.allSuperTypes().sort(function(e,t){return o[e.nameId()]-o[t.nameId()]}),l=null,p=0;p<u.length;p++){var c=u[p].nameId();if(i=r(u[p]),"DataElement"!=c){if("hl.BasicNode"!=c&&i)break}else l=c}i||(l=c)}return i||(i=s["hl.BasicNode"]),i(e,t)}function a(e,t,n){void 0===t&&(t={}),void 0===n&&(n={});var r=e.nameId();if(!n[r]){n[r]=!0;var i=null!=t[r]&&t[r]+1||0,o=e.superTypes();return o.forEach(function(e){var r=e.nameId(),o=t[r];(null==o||i>o)&&(t[r]=i,a(e,t,n))}),delete n[r],t}}Object.defineProperty(t,"__esModule",{value:!0});var o=n(2);t.buildWrapperNode=i;var s={AbstractSecurityScheme:function(e,t){return new o.AbstractSecuritySchemeImpl(e,t)},Annotable:function(e,t){return new o.AnnotableImpl(e,t)},AnnotationRef:function(e){return new o.AnnotationRefImpl(e)},AnnotationTarget:function(e){return new o.AnnotationTargetImpl(e)},AnyType:function(e){return new o.AnyTypeImpl(e)},Api:function(e,t){return new o.ApiImpl(e,t)},ArrayTypeDeclaration:function(e,t){return new o.ArrayTypeDeclarationImpl(e,t)},BasicSecurityScheme:function(e,t){return new o.BasicSecuritySchemeImpl(e,t)},BooleanType:function(e){return new o.BooleanTypeImpl(e)},BooleanTypeDeclaration:function(e,t){return new o.BooleanTypeDeclarationImpl(e,t)},ContentType:function(e){return new o.ContentTypeImpl(e)},CustomSecurityScheme:function(e,t){return new o.CustomSecuritySchemeImpl(e,t)},DateOnlyType:function(e){return new o.DateOnlyTypeImpl(e)},DateOnlyTypeDeclaration:function(e,t){return new o.DateOnlyTypeDeclarationImpl(e,t)},DateTimeOnlyType:function(e){return new o.DateTimeOnlyTypeImpl(e)},DateTimeOnlyTypeDeclaration:function(e,t){return new o.DateTimeOnlyTypeDeclarationImpl(e,t)},DateTimeType:function(e){return new o.DateTimeTypeImpl(e)},DateTimeTypeDeclaration:function(e,t){return new o.DateTimeTypeDeclarationImpl(e,t)},DigestSecurityScheme:function(e,t){return new o.DigestSecuritySchemeImpl(e,t)},DocumentationItem:function(e,t){return new o.DocumentationItemImpl(e,t)},Extension:function(e,t){return new o.ExtensionImpl(e,t)},FileType:function(e){return new o.FileTypeImpl(e)},FileTypeDeclaration:function(e,t){return new o.FileTypeDeclarationImpl(e,t)},FixedUriString:function(e){return new o.FixedUriStringImpl(e)},FragmentDeclaration:function(e,t){return new o.FragmentDeclarationImpl(e,t)},FullUriTemplateString:function(e){return new o.FullUriTemplateStringImpl(e)},IntegerType:function(e){return new o.IntegerTypeImpl(e)},IntegerTypeDeclaration:function(e,t){return new o.IntegerTypeDeclarationImpl(e,t)},Library:function(e,t){return new o.LibraryImpl(e,t)},LibraryBase:function(e,t){return new o.LibraryBaseImpl(e,t)},LocationKind:function(e){return new o.LocationKindImpl(e)},MarkdownString:function(e){return new o.MarkdownStringImpl(e)},Method:function(e,t){return new o.MethodImpl(e,t)},MethodBase:function(e,t){return new o.MethodBaseImpl(e,t)},MimeType:function(e){return new o.MimeTypeImpl(e)},ModelLocation:function(e){return new o.ModelLocationImpl(e)},NullType:function(e){return new o.NullTypeImpl(e)},NumberType:function(e){return new o.NumberTypeImpl(e)},NumberTypeDeclaration:function(e,t){return new o.NumberTypeDeclarationImpl(e,t)},OAuth1SecurityScheme:function(e,t){return new o.OAuth1SecuritySchemeImpl(e,t)},OAuth1SecuritySchemeSettings:function(e,t){return new o.OAuth1SecuritySchemeSettingsImpl(e,t)},OAuth2SecurityScheme:function(e,t){return new o.OAuth2SecuritySchemeImpl(e,t)},OAuth2SecuritySchemeSettings:function(e,t){return new o.OAuth2SecuritySchemeSettingsImpl(e,t)},ObjectTypeDeclaration:function(e,t){
return new o.ObjectTypeDeclarationImpl(e,t)},Operation:function(e,t){return new o.OperationImpl(e,t)},Overlay:function(e,t){return new o.OverlayImpl(e,t)},PassThroughSecurityScheme:function(e,t){return new o.PassThroughSecuritySchemeImpl(e,t)},Reference:function(e){return new o.ReferenceImpl(e)},RelativeUriString:function(e){return new o.RelativeUriStringImpl(e)},Resource:function(e,t){return new o.ResourceImpl(e,t)},ResourceBase:function(e,t){return new o.ResourceBaseImpl(e,t)},ResourceType:function(e,t){return new o.ResourceTypeImpl(e,t)},ResourceTypeRef:function(e){return new o.ResourceTypeRefImpl(e)},Response:function(e,t){return new o.ResponseImpl(e,t)},SchemaString:function(e){return new o.SchemaStringImpl(e)},SecuritySchemePart:function(e,t){return new o.SecuritySchemePartImpl(e,t)},SecuritySchemeRef:function(e){return new o.SecuritySchemeRefImpl(e)},SecuritySchemeSettings:function(e,t){return new o.SecuritySchemeSettingsImpl(e,t)},StatusCodeString:function(e){return new o.StatusCodeStringImpl(e)},StringType:function(e){return new o.StringTypeImpl(e)},StringTypeDeclaration:function(e,t){return new o.StringTypeDeclarationImpl(e,t)},TimeOnlyType:function(e){return new o.TimeOnlyTypeImpl(e)},TimeOnlyTypeDeclaration:function(e,t){return new o.TimeOnlyTypeDeclarationImpl(e,t)},Trait:function(e,t){return new o.TraitImpl(e,t)},TraitRef:function(e){return new o.TraitRefImpl(e)},TypeDeclaration:function(e,t){return new o.TypeDeclarationImpl(e,t)},UnionTypeDeclaration:function(e,t){return new o.UnionTypeDeclarationImpl(e,t)},UriTemplate:function(e){return new o.UriTemplateImpl(e)},UsesDeclaration:function(e,t){return new o.UsesDeclarationImpl(e,t)},ValueType:function(e){return new o.ValueTypeImpl(e)},XMLFacetInfo:function(e,t){return new o.XMLFacetInfoImpl(e,t)}}},function(e,t,n){"use strict";function r(e,t,n,r){var i=r.end!==!1,a=r.strict,o="";r.sensitive||(o+="i");var s=e.replace(c,function(e,r,i,a){if(a)return"\\"+a;n.push({name:i,prefix:r||"/"}),r=r?"\\"+r:"";var o=t[i],s=o&&l[o.type]||"[^"+(r||"\\/")+"]+",u=o&&o.required===!1;return Array.isArray(o.enum)&&o.enum.length&&(s="(?:"+o.enum.map(function(e){return String(e).replace(p,"\\$1")}).join("|")+")"),r+"("+s+")"+(u?"?":"")}),u="/"===e.charAt(e.length-1);return a||(s=(u?s.slice(0,-2):s)+"(?:\\/(?=$))?"),s+=i?"$":a&&u?"":"(?=\\/|$)",new RegExp("^"+s+(i?"$":""),o)}function i(e){try{return decodeURIComponent(e)}catch(n){var t=new Error('Failed to decode param "'+e+'"');throw t.status=400,t}}function a(e,t,n){if(n=n||{},"/"===e&&n.end===!1)return o;t=t||{};var a=[],l=r(e,t,a,n),p=s.sanitize()(t),c=u.validate()(t);return function(e){var n=l.exec(e);if(!n)return!1;if(t.mediaTypeExtension&&n.length>1&&!n[n.length-1]){var r=n[n.length-2],o=r.lastIndexOf(".");o>=0&&(n[n.length-2]=r.substring(0,o),n[n.length-1]=r.substring(o))}for(var s=n[0],u={},f=1;f<n.length;f++){var h=a[f-1],d=n[f];u[h.name]=null==d?d:i(d)}return u=p(u),!!c(u).valid&&{path:s,params:u}}}function o(e){return{path:"",params:{}}}Object.defineProperty(t,"__esModule",{value:!0});var s=n(252),u=n(253),l={number:"[-+]?\\d+(?:\\.\\d+)?",integer:"[-+]?\\d+",date:"(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), \\d{2} (?:Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) \\d{4} (?:[0-1]\\d|2[0-3]):[0-5]\\d:[0-5]\\d GMT",boolean:"(?:true|false)"},p=/([.*+?=^!:${}()|[\]\/\\])/g,c=new RegExp(["([.\\/])?\\{([^}]+)\\}",p.source].join("|"),"g");t.ramlPathMatch=a},function(e,t){"use strict";function n(e){return null==e}function r(e){return n(e)?"":String(e)}function i(e){return[0,!1,"","0","false"].indexOf(e)===-1}function a(e){return isFinite(e)?Number(e):null}function o(e){return e%1===0?Number(e):null}function s(e){return isNaN(Date.parse(e))?null:new Date(e)}function u(e,t,r){var i=Array.isArray(e)?e:[e],a=i.map(function(e){function i(e,t,n){for(var r=0;r<a.length;r++){var i=a[r],e=i(e,t,n);if(null!=e)return e}return null}var a=[],o=r[e.type];return"function"==typeof o&&a.push(o),Object.keys(e).filter(function(e){return"type"!==e&&"repeat"!==e&&"default"!==e}).forEach(function(n){var r=t[n];"function"==typeof r&&a.push(r(e[n],n))}),function(t,r,a){if(n(t))return null!=e.default?i(e.default,r,a):e.repeat&&!e.required?[]:t;if(e.repeat){var o=Array.isArray(t)?t:[t];return o=o.map(function(e){return i(e,r,a)}),o.some(n)?null:t}if(Array.isArray(t)){if(t.length>1)return null;t=t[0]}return i(t,r,a)}});return function(e,t,n){for(var r=0;r<a.length;r++){var i=a[r],o=i(e,t,n);if(null!=o)return o}return e}}function l(){function e(e){return u(e,n,l)}var t,n={},l={string:r,number:a,integer:o,boolean:i,date:s},p=function(e){if(!e)return function(){return{}};var t={};return Object.keys(e).forEach(function(n){t[n]=p.rule(e[n])}),function(e){e=e||{};var n={};return Object.keys(t).forEach(function(r){var i=e[r],a=t[r];Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=a(i,r,e))}),n}};return t=p,t.rule=e,t.TYPES=l,t.RULES=n,t}Object.defineProperty(t,"__esModule",{value:!0}),t.sanitize=l},function(e,t,n){(function(e){"use strict";function n(e){return"[object Date]"===v.call(e)&&!isNaN(e.getTime())}function r(e){return"boolean"==typeof e}function i(e){return"string"==typeof e}function a(e){return"number"==typeof e&&e%1===0}function o(e){return"number"==typeof e&&isFinite(e)}function s(e){return function(t){return t>=e}}function u(e){return function(t){return t<=e}}function l(t){return function(n){return e.byteLength(n)>=t}}function p(t){return function(n){return e.byteLength(n)<=t}}function c(e){return e&&0!=e.length?function(t){return e.indexOf(t)>-1}:function(e){return!0}}function f(e){var t="string"==typeof e?new RegExp(e):e;return t.test.bind(t)}function h(e,t,n,r,i){return{valid:e,rule:r,attr:i,value:n,key:t}}function d(e,t){var n=[];return Object.keys(e).forEach(function(r){var i=t[r];if(i){var a=e[r];n.push([r,i(a,r),a])}}),function(e,t,r){for(var i=0;i<n.length;i++){var a=n[i],o=a[0],s=a[1],u=a[2],l=s(e,t,r);if(!l)return h(!1,t,e,o,u)}return h(!0,t,e)}}function m(e,t,n){var r=Array.isArray(e)?e:[e],i=!r.length,a=[],o=[];return r.forEach(function(e){var n=[e.type||"string",d(e,t)];e.required||(i=!0),e.repeat?o.push(n):a.push(n)}),function(e,t,r){if(null==e)return h(i,t,e,"required",!i);var s=Array.isArray(e),u=s?e:[e],l=s?o:a;if(!l.length)return h(!1,t,e,"repeat",!s);var p=null,c=e;return l.some(function(e){var i=u.every(function(i){var a=e[0],o=n[a]&&n[a](i,t,r);return o||(p=h(!1,t,c,"type",a)),o});return!!i&&(u.every(function(n){var r=e[1];return p=r(n,t),p.valid}),!0)}),p}}function y(){function e(e){return m(e,d,h)}var t,h={date:n,number:o,integer:a,boolean:r,string:i},d={minimum:s,maximum:u,minLength:l,maxLength:p,enum:c,pattern:f},y=function(t){if(!t)return function(e){return{valid:!0,errors:[]}};var n={};return Object.keys(t).forEach(function(r){n[r]=e(t[r])}),function(e){e=e||{};var t=Object.keys(n).map(function(t){var r=e[t],i=n[t];return i(r,t,e)}).filter(function(e){return!e.valid});return{valid:0===t.length,errors:t}}};return t=y,t.rule=e,t.TYPES=h,t.RULES=d,t}Object.defineProperty(t,"__esModule",{value:!0});var v=Object.prototype.toString;t.validate=y}).call(t,n(43).Buffer)},function(e,t,n){"use strict";function r(e,t){void 0===t&&(t=!1);var n=I.Universe10.ResourceBase.properties.uriParameters.name,r=e.elementsOfKind(n);if(!P.isResourceType(e.definition()))return r;var i=e.attr(I.Universe10.Resource.properties.relativeUri.name),o=i.value();return a(r,o,e,n,t,i)}function i(e,t){void 0===t&&(t=!0);var n=e.attr(I.Universe10.Api.properties.baseUri.name),r=n?n.value():"",i=I.Universe10.Api.properties.baseUriParameters.name,o=e.elementsOfKind(i);return a(o,r,e,i,t,n)}function a(e,t,n,r,i,a){if("string"!=typeof t)return[];var o=n.definition(),s=o.property(r);if(!t)return[];var u={};e.forEach(function(e){var t=u[e.name()];t||(t=[],u[e.name()]=t),t.push(e)});for(var l=[],p=0,c={},f=t.indexOf("{");f>=0&&(p=t.indexOf("}",++f),!(p<0));f=t.indexOf("{",p)){var h=t.substring(f,p);if(c[h]=!0,u[h])u[h].forEach(function(e){return l.push(e)});else{var d=_.actualUnit(a.lowLevel()),m=o.universe(),y=m.type(N.Universe10.StringTypeDeclaration.name),v=T.createStubNode(y,null,h,d);v.setParent(n),i&&v.wrapperNode().meta().setCalculated(),v.attrOrCreate("name").setValue(h),v.patchProp(s),l.push(v)}}return Object.keys(u).filter(function(e){return!c[e]}).forEach(function(e){return u[e].forEach(function(e){return l.push(e)})}),l}function o(e){var t="",n=e;do e=n,t=e.attr(N.Universe10.Resource.properties.relativeUri.name).value()+t,n=e.parent();while(P.isResourceType(n.definition()));return t}function s(e){if(!P.isResourceType(e.definition()))return null;var t="",n=e;do e=n,t=e.attr(N.Universe10.Resource.properties.relativeUri.name).value()+t,n=e.parent();while(P.isResourceType(n.definition()));var r="";n=n.getSlaveCounterPart()||n;var i=n.attr(N.Universe10.Api.properties.baseUri.name);return i&&(r=i?i.value():""),r=r?r:"",e&&(r=r.replace(/\/+$/,"")),t=r+t}function u(e,t){void 0===t&&(t=!1);var n=c(e,!0,t);return n.length>0?n[0]:null}function l(e,t){return void 0===t&&(t=!1),c(e,!1,t)}function p(e,t){void 0===t&&(t=!1);var n;n=e.isJSONString()||e.isYAML()?e.asJSON():e.original();var r={value:n,strict:e.strict(),name:e.name()};if(e.hasAnnotations()){var i=e.annotations(),a=f(i);a.length>0&&(r.annotations=a)}if(e.hasScalarAnnotations()){var o=e.scalarsAnnotations(),s={};Object.keys(o).forEach(function(e){var t=f(o[e]);t.length>0&&(s[e]=[t])}),Object.keys(s).length>0&&(r.scalarsAnnotations=s)}var u=e.displayName();u&&(r.displayName=u);var l=e.description();return null!=l&&(r.description=l),t&&(r.asXMLString=e.asXMLString()),r}function c(e,t,n){void 0===n&&(n=!1);var r=e.localType();r.isAnnotationType()&&(r=S.find(r.superTypes(),function(e){return e.nameId()==r.nameId()}));var i=r.examples().filter(function(e){return null!=e&&!e.isEmpty()&&e.isSingle()==t}).map(function(e){return p(e,n)});return i}function f(e){var t=[];return e&&Object.keys(e).forEach(function(n){t.push({name:n,value:e[n].value()})}),t}function h(e,t){return void 0===t&&(t=!0),e.lowLevel().actual().libExpanded?[]:m(e,function(e){return P.isTraitType(e)},t,"Trait")}function d(e,t){return void 0===t&&(t=!0),e.lowLevel().actual().libExpanded?[]:m(e,function(e){return P.isResourceTypeType(e)},t,"ResourceType")}function m(e,t,n,r){var i=w.globalDeclarations(e).filter(function(e){return t(e.definition())}),a=e.lowLevel(),o=a.includePath();o||(o=a.unit().path());for(var s="RAML10"==e.definition().universe().version()&&!P.isOverlayType(e.definition()),u=s?new R.TraitsAndResourceTypesExpander:null,l=[],p=new C.ReferencePatcher,c="ResourceType"==r?"resourceTypes":"traits",f=e.definition().allProperties().find(function(e){return e.nameId()==c}),h=0,d=i;h<d.length;h++){var m=d[h],y=m.lowLevel().unit().path();s&&(M.LowLevelProxyNode.isInstance(m.lowLevel())||(m=u.createHighLevelNode(m,!1,p,!0,!1),p.process(m.lowLevel(),e.lowLevel(),r,!0,!0),m.setParent(e),m.patchProp(f))),n&&y!=o&&m.wrapperNode().meta().setCalculated(),l.push(m)}return l}function y(e){return v(e)}function v(e,t){var n=e.attr(I.Universe08.BodyLike.properties.schema.name);if(!n)return null;var r=n.value();if(!r)return null;if(b.stringStartsWith(r,"{")||b.stringStartsWith(r,"[")||b.stringStartsWith(r,"<"))return n;var i;if(t)i=t[r];else{var a=e.root(),o=a.elementsOfKind(I.Universe08.Api.properties.schemas.name);i=S.find(o,function(e){return e.name()==r})}if(!i)return n;if(!i)return n;if(!i.getKind||i.getKind()!=E.NodeKind.NODE)return n;if(i.definition().key()!=I.Universe08.GlobalSchema)return n;var s=i.attr(I.Universe08.GlobalSchema.properties.value.name);return null==s?null:s}function g(e){var t=e.definition();if(P.isMethodType(t)||P.isTypeDeclarationDescendant(t)){for(var n=!1,r=e.parent();null!=r;){var i=r.definition();if(P.isResourceTypeType(i)||P.isTraitType(i)){n=!0;break}r=r.parent()}if(!n)return null}if(null==e)return null;var a=e.lowLevel();if(null==a)return null;var o=a.children().filter(function(e){var t=e.key();return!!t&&(("("!=t.charAt(0)||")"!=t.charAt(t.length-1))&&t.indexOf("<<")>=0)});if(0==o.length)return null;var s={};return o.forEach(function(e){var t=e.dumpToObject();Object.keys(t).forEach(function(e){return s[e]=t[e]})}),s}function A(e){var t=e.localType(),n=t.fixedFacets(),r=Object.keys(n),i=[];if(t.hasUnionInHierarchy())i=r.map(function(e){return{name:e,value:n[e]}});else for(var a=0,o=r;a<o.length;a++){var s=o[a];null!=t.facet(s)&&i.push({name:s,value:n[s]})}return 0==i.length?null:i}Object.defineProperty(t,"__esModule",{value:!0});var E=n(198),_=n(55),T=n(3),S=n(16),N=n(204),I=n(204),b=n(15),R=n(217),M=n(199),C=n(223),w=n(209),P=n(205);t.uriParameters=r,t.baseUriParameters=i,t.completeRelativeUri=o,t.absoluteUri=s,t.typeExample=u,t.typeExamples=l,t.dumpExpandableExample=p,t.allTraits=h,t.allResourceTypes=d,t.schemaContent08=y,t.schemaContent08Internal=v,t.getTemplateParametrizedProperties=g,t.typeFixedFacets=A},function(e,t,n){"use strict";function r(e,t){return new K(t).dump(e)}function i(e,t){var n=_.actualPath(e),r=t.sourceMap;r||(r={},t.sourceMap=r),r.path||(r.path=n)}function a(e,t,n,r,i){if(!t)return e;var a={};e&&e.arr.forEach(function(e){var t=a[e.name()];t||(t=[],a[e.name()]=t),t.push(e)});for(var o=new j(r),s=0,u={},l=!1,p=t.indexOf("{");p>=0&&(s=t.indexOf("}",++p),!(s<0));p=t.indexOf("{",s)){var c=t.substring(p,s);if(u[c]=!0,a[c])a[c].forEach(function(e){o.registerValue(e),o.registerMeta(null)});else{l=!0;var f=n.definition().universe(),h=f.type(L.Universe10.StringTypeDeclaration.name),d=x.createStubNode(h,null,c,n.lowLevel().unit());if(d.setParent(n),d.attrOrCreate("name").setValue(c),d.patchProp(r),o.registerValue(d),i){o.hasMeta=!0;var m=new y.NodeMetadataImpl;m.setCalculated(),o.registerMeta(m)}}}return l?(Object.keys(a).filter(function(e){return!u[e]}).forEach(function(e){return a[e].forEach(function(e){o.registerValue(e),o.hasMeta&&o.registerMeta(null)})}),o):e}function o(e,t,n,r){if(0==t.length)return null;var i=e.lowLevel().unit().absolutePath(),a=new j(n);return t.forEach(function(e){if(a.registerValue(e),r)if(e.lowLevel().unit().absolutePath()!=i){a.hasMeta=!0;var t=new y.NodeMetadataImpl;t.setCalculated(),a.mArr.push(t)}else a.mArr.push(null)}),a}function s(e,t,n,r){var i;if(e.isElement())i=e.asElement().definition();else if(e.isAttr()){var a=e.asAttr().property();a&&(i=a.range())}if((i instanceof A.UserDefinedClass||i.isUserDefined())&&(i=k.find(i.allSuperTypes(),function(e){return!e.isUserDefined()})),null==i)return n;var o=i.universe().version(),s=r[o];if(!s)return n;var u=s[i.nameId()];if(!u)return n;var l=t?t.nameId():"__$$anyprop__",p=u[l];if(p||(p=u.__$$anyprop__),!p)return n;for(var c=0,f=p;c<f.length;c++){var h=f[c];n=h.transform(n,e,t)}return n}function u(e,t){for(var n=0,r=e;n<r.length;n++){var i=r[n],a=i.registrationInfo();if(a)for(var o=0,s=Object.keys(a);o<s.length;o++){var u=s[o],l=a[u],p=t[u];null==p&&(p={},t[u]=p);for(var c=0,f=Object.keys(l);c<f.length;c++){var h=f[c],d=l[h],m=p[h];null==m&&(m={},p[h]=m);for(var y=0,v=Object.keys(d);y<v.length;y++){var g=v[y],A=m[g];if(null==A){if(A=[],"__$$anyprop__"!=g){var E=m.__$$anyprop__;E&&(A=A.concat(E))}m[g]=A}if("__$$anyprop__"==g)for(var _=0,T=Object.keys(m);_<T.length;_++){var S=T[_];m[S].push(i)}else A.push(i)}}}}}function l(e){if(0==e.length)return{};for(var t=e[0],n=1;n<e.length;n++){var r=e[n];t=p(t,r)}return t}function p(e,t){for(var n=0,r=Object.keys(t);n<r.length;n++){var i=r[n],a=e[i],o=t[i];null==a?e[i]=o:"object"==typeof a&&"object"==typeof o&&(e[i]=p(a,o))}return e}function c(e){for(var t,n=e.first,r=e.rest;"parens"==n.type&&0==n.arr;)n=n.expr;for(;"parens"==r.type&&0==r.arr;)r=r.expr;return t="union"==n.type?c(n):[n],"union"==r.type?t=t.concat(c(r)):t.push(r),t}function f(e){var t=e.lowLevel().includePath&&e.lowLevel().includePath();if(!t){var n=e.attr("type");n||(n=e.attr("schema")),n&&(t=n.lowLevel().includePath&&n.lowLevel().includePath())}var r;if(t){var i=t.indexOf("#"),a="";i>=0&&(a=t.substring(i),t=t.substring(0,i));var o=e.lowLevel().unit().resolve(t).absolutePath(),s=void 0;s=O.stringStartsWith(o,"http://")||O.stringStartsWith(o,"https://")?o:F.relative(e.lowLevel().unit().project().getRootPath(),o),s=s.replace(/\\/g,"/"),r=s+a}return r}function h(e,t){for(var n=t.key(),r=t;v.LowLevelProxyNode.isInstance(r);)r=r.originalNode();var i=r.key();if(v.LowLevelProxyNode.isInstance(t)&&i&&i.indexOf("<<")>=0&&t.key().indexOf("<<")<=0&&(i=t.key()),null!=i){var a=e;a.displayName==n&&(a.displayName=i)}}var d=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var m=n(204),y=n(219),v=n(199),g=n(21),A=n(56),E=A.tsInterfaces,_=n(55),T=n(19),S=n(4),N=n(20),I=n(206),b=n(223),R=n(256),M=n(221),C=A.rt,w=C.typeExpressions,P=n(205),L=n(204),O=n(15),D=n(220),U=n(254),x=n(3),k=n(16),F=n(6),B="application/raml+yaml";t.dump=r;var V=function(e){var t,n=e.root();if(n){var r=n.lowLevel();if(r){var i=r.unit();i&&(t=i.absolutePath())}}return t};t.appendSourcePath=i;var K=function(){function e(e){this.options=e,this.nodePropertyTransformers=[new Z],this.nodeTransformersMap={},this.nodePropertyTransformersMap={},this.options=this.options||{},null==this.options.allParameters&&(this.options.allParameters=!0),null==this.options.expandSecurity&&(this.options.expandSecurity=!0),null==this.options.serializeMetadata&&(this.options.serializeMetadata=!1),null==this.options.attributeDefaults&&(this.options.attributeDefaults=!0),null==this.options.expandExpressions&&(this.options.expandExpressions=!0),null==this.options.expandTypes||this.options.expandTypes&&(this.options.typeExpansionRecursionDepth||(this.options.typeExpansionRecursionDepth=0)),this.defaultsCalculator=new D.AttributeDefaultsCalculator(!0,!0),this.nodeTransformers=[new ee,new Q(this.options,this),new te(this.options,this),new se(this),new ne,new re,new ie,new ae,new oe,new pe,new ue(this.options.expandSecurity),new le(this.options.allParameters,this.options.serializeMetadata)],u(this.nodeTransformers,this.nodeTransformersMap),u(this.nodePropertyTransformers,this.nodePropertyTransformersMap)}return e.prototype.init=function(e){this._astRoot=e,this.helpersMap={baseUriParameters:W,uriParameters:H};var t=e.isElement();if(t){e.types();var n=e.asElement(),r=n.definition();if("RAML08"==r.universe().version()&&P.isApiType(r)){var i={};n.elementsOfKind(L.Universe08.Api.properties.schemas.name).forEach(function(e){return i[e.name()]=e}),this.helpersMap.schemaContent=new q(i)}P.isApiSibling(r)?(this.helpersMap.traits=new Y(U.allTraits(n,!1)),this.helpersMap.resourceTypes=new Y(U.allResourceTypes(n,!1))):P.isLibraryType(r)||delete this.options.expandTypes}},e.prototype.astRoot=function(){return this._astRoot},e.prototype.dispose=function(){delete this.helpersMap},e.prototype.dump=function(e){this.init(e);var t=e.isElement(),n=e.parent(),r=!n&&this.options.rootNodeDetails,i=V(e),a=this.dumpInternal(e,null,i,null,!0);if(r){var o=a;if(a={},a.specification=o,t){var s=e.asElement(),u=s.definition();if(u){var l=u.universe(),p=l.version();a.ramlVersion=p;var c=u.nameId();if(!c&&u.isAssignableFrom(A.universesInfo.Universe10.TypeDeclaration.name)){var f=l.type(A.universesInfo.Universe10.TypeDeclaration.name),h={};f.allSubTypes().forEach(function(e){return h[e.nameId()]=!0});for(var d=0,m=u.allSuperTypes();d<m.length;d++){var v=m[d];if(h[v.nameId()]){c=v.nameId();break}}}a.type=c}a.errors=this.dumpErrors(y.errors(s))}}return this.dispose(),a},e.prototype.dumpInternal=function(e,t,n,r,a){var o=this;if(void 0===a&&(a=!1),null==e)return null;if(e.isReused()){var u=e.getJSON();if(null!=u)return u}var l={};if(e.isElement()){var p={},c=e.asElement(),h=c.definition(),d=t||c.property();if(P.isExampleSpecType(h))if(null!=c.parent())l="";else{var m=_.auxiliaryTypeForExample(c),E=U.dumpExpandableExample(m.examples()[0],this.options.dumpXMLRepresentationOfExamples),T=c.elementsOfKind("uses").map(function(e){return o.dumpInternal(e,e.property(),n)});T.length>0&&(E.uses=T),l=E}else{for(var N={},I=c.attrs().concat(c.children().filter(function(e){return!e.isAttr()})),b=0,R=I;b<R.length;b++){var M=R[b],C=M.property();if(null!=C){var w=C.nameId(),O=p[w];null==O&&(O=new j(C),p[w]=O),O.registerValue(M)}else{var x=M.lowLevel();x.key()}}for(var F,B,V={},K={},W=function(e){if(A.UserDefinedProp.isInstance(e))return"continue";var t=e.nameId();if(!a&&"uses"==t&&P.isApiSibling(c.root().definition()))return"continue";var i=p[t];P.isTypeProperty(e)&&i&&1==i.arr.length&&i.arr[0].isAttr()&&null==i.arr[0].asAttr().value()&&(i=void 0),i=H.applyHelpers(i,c,e,H.options.serializeMetadata);var u=N[t],d=void 0;if(void 0!==i){if(i.isMultiValue){if(d=i.arr.map(function(e,t){var r=i.hasMeta?i.mArr[t]:null;return o.dumpInternal(e,i.prop,n,r)}),e.isValueProperty()){var m=[],v=[],g=!1;i.arr.filter(function(e){return e.isAttr()}).map(function(e){return e.asAttr()}).filter(function(e){return e.isAnnotatedScalar()}).forEach(function(e){var t=e.annotations().map(function(e){return o.dumpInternal(e,null,n)});g=g||t.length>0,m.push(t),v.push(_.actualPath(e,!0))}),g&&(V[t]=m),v.filter(function(e){return null!=e}).length>0&&(K[t]=v.map(function(e){return{path:e}}))}P.isTypeDeclarationDescendant(h)&&P.isTypeProperty(e)&&i.arr.map(function(e){return e.value()}).filter(function(e){return _.isStructuredValue(e)}).length>0&&(d=d[0])}else if(d=H.dumpInternal(i.val,i.prop,n),e.isValueProperty()){var E=i.val.asAttr();if(E.isAnnotatedScalar()){var T=E.annotations().map(function(e){return o.dumpInternal(e,null,n)});T.length>0&&(V[t]=[T])}if(!E.isFromKey()){var S=_.actualPath(E,!0);S&&(K[t]=[{path:S}])}}}else void 0!==u?d=u:H.options.attributeDefaults&&(F=H.defaultsCalculator.attributeDefaultIfEnabled(c,e),null!=F&&(r=r||new y.NodeMetadataImpl,Array.isArray(F)?F=F.map(function(t){return _.isASTPropImpl(t)?o.dumpInternal(t,e,n):t}):_.BasicASTNode.isInstance(F)&&(F=H.dumpInternal(F,e,n)),d=F,null!=d&&e.isMultiValue()&&!Array.isArray(d)&&(d=[d]),B=H.defaultsCalculator.insertionKind(c,e),B==D.InsertionKind.CALCULATED?r.registerCalculatedValue(t):B==D.InsertionKind.BY_DEFAULT&&r.registerInsertedAsDefaultValue(t)));if(d=s(c,e,d,H.nodePropertyTransformersMap),null!=d){if(("type"===t||"schema"==t)&&d&&d.forEach&&"string"==typeof d[0]){var I=d[0].trim(),b="{"===I[0]&&"}"===I[I.length-1],R="<"===I[0]&&">"===I[I.length-1];if(b||R){var M=f(c);if(M){l.schemaPath=M;var C=l.sourceMap;C||(C={},l.sourceMap=C),C.path=M}}}l[t]=d}},H=this,Y=0,q=h.allProperties().concat(h.allCustomProperties());Y<q.length;Y++){var G=q[Y];W(G)}if(this.options.dumpSchemaContents&&p.schema&&p.schema.prop.range().key()==L.Universe08.SchemaString){var X=c.root().elementsOfKind("schemas");X.forEach(function(e){if(e.name()==l.schema){var t=e.attr("value");t&&(l.schema=t.value(),l.schemaContent=t.value())}})}if(this.options.serializeMetadata&&this.serializeMeta(l,c,r),Object.keys(V).length>0&&(l.scalarsAnnotations=V),this.options.sourceMap&&Object.keys(K).length>0){var z=l.sourceMap;z||(z={},l.sourceMap=z),z.scalarsSources=K}var $=U.getTemplateParametrizedProperties(c);if($&&(l.parametrizedProperties=$),P.isTypeDeclarationDescendant(h)){var J=U.typeFixedFacets(c);J&&(l.fixedFacets=J)}l=s(c,d,l,this.nodeTransformersMap)}this.options.sourceMap&&"object"==typeof l&&i(c,l)}else if(e.isAttr()){var Q=e.asAttr(),Z=Q.value(),C=Q.property(),ee=C.range(),te=ee.isValueType();if(te&&Q.value&&(Z=Q.value(),null==Z&&P.isAnyTypeType(ee))){var ne=Q.lowLevel();if(Q.isAnnotatedScalar()&&(ne=k.find(ne.children(),function(e){return"value"==e.key()})),ne&&ne.valueKind()!=g.Kind.SCALAR){Z=Q.lowLevel().dumpToObject();var re=C.nameId();Q.lowLevel().key()==re&&"object"==typeof Z&&Z.hasOwnProperty(re)&&(Z=Z[re])}}null==Z||"number"!=typeof Z&&"string"!=typeof Z&&"boolean"!=typeof Z?_.isStructuredValue(Z)?(Z=Q.plainValue(),_.BasicASTNode.isInstance(Z)&&(Z=this.dumpInternal(Z,t||Q.property(),n,null,!0))):(S.ASTNode.isInstance(Z)||v.LowLevelProxyNode.isInstance(Z))&&(Z=Z.dumpToObject()):P.isStringTypeDescendant(C.range())&&(Z=""+Z),Z=s(Q,t||Q.property(),Z,this.nodeTransformersMap),l=Z}else{var x=e.lowLevel();l=x?x.dumpToObject():null}return e.setJSON(l),l},e.prototype.getDefaultsCalculator=function(){return this.defaultsCalculator},e.prototype.canBeFragment=function(e){var t=e.definition(),n=[t].concat(t.allSubTypes()),r=n.filter(function(e){return e.getAdapter(A.RAMLService).possibleInterfaces().filter(function(e){return e.nameId()==A.universesInfo.Universe10.FragmentDeclaration.name}).length>0});return r.length>0},e.prototype.dumpErrors=function(e){var t=this;return e.map(function(e){var n=t.dumpErrorBasic(e);return e.trace&&e.trace.length>0&&(n.trace=t.dumpErrors(e.trace)),n}).sort(function(e,t){return e.path!=t.path?e.path.localeCompare(t.path):null==t.range.start?1:null==e.range.start?-1:null==t.range.start?1:null==e.range.start?-1:e.range.start.position!=t.range.start.position?e.range.start.position-t.range.start.position:e.code-t.code})},e.prototype.dumpErrorBasic=function(e){var t={code:e.code,message:e.message,path:e.path,line:e.line,column:e.column,position:e.start,range:e.range};return e.isWarning===!0&&(t.isWarning=!0),t},e.prototype.serializeMeta=function(e,t,n){if(this.options.serializeMetadata){var r=t.definition(),i=P.isMethodType(r)&&t.optional();if(n||i){var a=n||new y.NodeMetadataImpl(!1,!1);i&&a.setOptional(),e.__METADATA__=a.toJSON()}}},e.prototype.applyHelpers=function(e,t,n,r){var i=n.nameId(),a=this.helpersMap[i];if(!a)return e;var o=a.apply(t,e,n,r);return o?o:e},e}();t.JsonSerializer=K;var j=function(){function e(e){this.prop=e,this.arr=[],this.mArr=[],this.isMultiValue=e.isMultiValue()}return e.prototype.registerValue=function(e){this.isMultiValue?this.arr.push(e):this.val=e},e.prototype.registerMeta=function(e){this.isMultiValue&&this.mArr.push(e)},e}(),W={apply:function(e,t,n,r){var i=e.attr(L.Universe10.Api.properties.baseUri.name),o=i?i.value():"";return a(t,o,e,n,r)}},H={apply:function(e,t,n,r){var i=e.attr(L.Universe10.Resource.properties.relativeUri.name);if(!i)return t;var o=i.value();return a(t,o,e,n,r)}},Y=function(){function e(e){this.arr=e}return e.prototype.apply=function(e,t,n,r){return o(e,this.arr,n,r)},e}(),q=function(){function e(e){this.schemasCache08=e}return e.prototype.apply=function(e,t,n,r){var i=null,a=U.schemaContent08Internal(e,this.schemasCache08);return a&&(i=new j(n),i.registerValue(a)),i},e}();t.applyTransformersMap=s;var G=function(){function e(){}return e.prototype.match=function(e,t){if(null==e)return!1;var n=this.registrationInfo(),r=e.universe().version();if((e instanceof A.UserDefinedClass||e.isUserDefined())&&(e=k.find(e.allSuperTypes(),function(e){return!e.isUserDefined()}),null==e))return null==t;var i=n[r];if(!i)return!1;var a=i[e.nameId()];if(!a)return!1;var o=null==t||a[t.nameId()]===!0||a.__$$anyprop__===!0;return o},e}(),X=function(e){function t(t,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=["RAML10","RAML08"]);var a=e.call(this)||this;return a.typeName=t,a.propName=n,a.applyToDescendatns=r,a.restrictToUniverses=i,a}return d(t,e),t.prototype.registrationInfo=function(){var e=this;if(this.regInfo)return this.regInfo;for(var t={},n=[],r=0,i=this.restrictToUniverses;r<i.length;r++){var a=i[r],o={};t[a]=o,n.push(o)}for(var s=0,u=Object.keys(t);s<u.length;s++){var a=u[s],l=A.getUniverse(a).type(this.typeName);if(l){var p=t[a],c=[this.typeName];this.applyToDescendatns&&l.allSubTypes().forEach(function(e){return c.push(e.nameId())});for(var f=0,h=c;f<h.length;f++){var d=h[f],m={};null!=this.propName?m[this.propName]=!0:m.__$$anyprop__=!0,p[d]=m}}}return this.regInfo={},Object.keys(t).forEach(function(n){var r=t[n];Object.keys(r).length>0&&(e.regInfo[n]=r)}),this.regInfo},t}(G),z=function(){function e(e){this.matcher=e}return e.prototype.match=function(e,t){var n;if(e.isElement())n=e.asElement().definition();else if(e.isAttr()){var r=e.asAttr().property();r&&(n=r.range())}return!!n&&this.matcher.match(n,t)},e.prototype.registrationInfo=function(){return this.matcher.registrationInfo()},e}(),$=function(e){function t(t,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=["RAML10","RAML08"]);var a=e.call(this,new X(t,n,r,i))||this;return a.typeName=t,a.propName=n,a.applyToDescendatns=r,a.restrictToUniverses=i,a}return d(t,e),t}(z),J=function(e){function t(t){var n=e.call(this)||this;return n.matchers=t,n}return d(t,e),t.prototype.registrationInfo=function(){return this.regInfo?this.regInfo:(this.regInfo=l(this.matchers.map(function(e){return e.registrationInfo()})),this.regInfo)},t}(G),Q=function(e){function t(t,n){void 0===t&&(t={});var r=e.call(this,L.Universe10.Resource.name,null,!0)||this;return r.options=t,r.owner=n,r}return d(t,e),t.prototype.transform=function(e,t){if(Array.isArray(e))return e;var n=e[L.Universe10.Resource.properties.relativeUri.name];if(n){for(var r=n.trim().split("/");r.length>0&&0==r[0].length;)r.shift();if(e.relativeUriPathSegments=r,e.absoluteUri=U.absoluteUri(t.asElement()),e.completeRelativeUri=U.completeRelativeUri(t.asElement()),P.isResourceType(t.parent().definition()))e.parentUri=U.completeRelativeUri(t.parent()),e.absoluteParentUri=U.absoluteUri(t.parent());else{e.parentUri="";var i=this.owner.astRoot().asElement()||t.parent(),a=i.attr(L.Universe10.Api.properties.baseUri.name),o=a&&a.value()||"";e.absoluteParentUri=o}}return e},t}($),Z=function(e){function t(){return e.call(this,L.Universe10.TypeDeclaration.name,L.Universe10.ArrayTypeDeclaration.properties.items.name,!0)||this}return d(t,e),t.prototype.transform=function(e,t){if(!e||!Array.isArray(e)||1!=e.length||"object"!=typeof e[0]||!t.isElement())return e;var n,r,i,a=t.asElement(),o=e[0],s=a.definition().universe().type(m.Universe10.TypeDeclaration.name),u=a.definition().universe().type(m.Universe10.ArrayTypeDeclaration.name),l=a.attr("items").lowLevel();do if(i=!0,n=new _.ASTNodeImpl(l,a,s,u.property(m.Universe10.ArrayTypeDeclaration.properties.items.name)),r=n.localType(),r&&M.isEmpty(r)&&1==r.superTypes().length){var p=l.children().filter(function(e){return"type"==e.key()});if(1==p.length){if(p[0].resolvedValueKind()==g.Kind.SCALAR){o=p[0].value();break}l=p[0],i=!1,o=o.type[0]}}while(!i);return r.getExtra(E.TOP_LEVEL_EXTRA)&&"object"==typeof o&&!Array.isArray(o)&&(o=o.type),Array.isArray(o)||(o=[o]),o},t}($),ee=function(e){function t(){return e.call(this,L.Universe10.Method.name,null,!0)||this}return d(t,e),t.prototype.transform=function(e,t){if(Array.isArray(e))return e;var n=t.parent();return P.isResourceType(n.definition())?(e.parentUri=U.completeRelativeUri(n),e.absoluteParentUri=U.absoluteUri(n),e):e},t}($),te=function(e){function t(t,n){void 0===t&&(t={});var r=e.call(this,L.Universe10.TypeDeclaration.name,null,!0)||this;return r.options=t,r.owner=n,r.facetsToExtract={maxItems:!0,minItems:!0,discriminatorValue:!0,discriminator:!0,pattern:!0,minLength:!0,maxLength:!0,enum:!0,minimum:!0,maximum:!0,format:!0,fileTypes:!0},r}return d(t,e),t.prototype.transform=function(e,t,n){var r=this,a=t.property();if(this.options.expandTypes&&t&&t.isElement()){var o=t.parent();if(o&&P.isTypeDeclarationDescendant(o.definition()))return{};var s=t.asElement().parsedType(),u=null!=T.typeOfContainingTemplate(t),l=a&&P.isAnnotationTypesProperty(a),p=new R.TypeExpander({node:t.asElement(),typeCollection:t.types(),typeExpansionRecursionDepth:this.options.typeExpansionRecursionDepth,serializeMetadata:this.options.serializeMetadata,sourceMap:this.options.sourceMap,isInsideTemplate:u,isAnnotationType:l}).serializeType(s);return a&&P.isParametersProperty(a)&&(p.name&&O.stringEndsWith(p.name,"?")?(p.name=p.name.substring(0,p.name.length-1),p.hasOwnProperty("required")||(p.required=!1)):p.hasOwnProperty("required")||(p.required=!0,this.appendMeta(p,"required","insertedAsDefault")),p.displayName&&O.stringEndsWith(p.displayName,"?")&&(p.displayName=p.displayName.substring(0,p.displayName.length-1)),
e.hasOwnProperty("enum")&&!p.hasOwnProperty("enum")&&(p.enum=e.enum,this.appendMeta(p,"enum","calculated")),e.__METADATA__&&e.__METADATA__.calculated===!0&&this.appendMeta(p,null,"calculated")),a&&P.isBodyProperty(a)&&(p.name!=e.name&&(p.name=e.name,p.displayName=e.displayName),this.appendMeta(p,"name","calculated",e.__METADATA__),this.appendMeta(p,"displayName","calculated",e.__METADATA__)),e&&"object"==typeof e&&e.hasOwnProperty("parametrizedProperties")&&(p.parametrizedProperties=e.parametrizedProperties),p}var c=Array.isArray(e);if(c&&0==e.length)return e;var f=c?e[0]:e;this.options.sourceMap&&i(t,f);var h=f[A.universesInfo.Universe10.ObjectTypeDeclaration.properties.additionalProperties.name];"boolean"!=typeof h&&h&&delete f[A.universesInfo.Universe10.ObjectTypeDeclaration.properties.additionalProperties.name];var d=a,m=t.asElement().localType().getExtra(E.TOP_LEVEL_EXTRA),y=a&&(P.isTypesProperty(a)||P.isSchemasProperty(a));if(y||!m){var v=U.typeExample(t.asElement(),this.options.dumpXMLRepresentationOfExamples);if(v)f.examples=[v];else{var g=U.typeExamples(t.asElement(),this.options.dumpXMLRepresentationOfExamples);g.length>0&&(f.examples=g)}delete f.example,null!=f.examples&&(f.simplifiedExamples=f.examples.map(function(e){if(null==e)return e;var t=e.value;return null==t?t:"object"==typeof t?JSON.stringify(t):t}))}if(f.hasOwnProperty("schema")){if(f.hasOwnProperty("type")){var _=f.type;Array.isArray(_)||(_=[_],f.type=_),f.type=k.unique(_)}else f.type=f.schema;delete f.schema}n&&P.isSchemaProperty(n)&&"schema"==f.name&&(f.name="type","schema"==f.displayName&&(f.displayName="type")),Array.isArray(f.type)||(f.type=[f.type]);var S=t.isElement()&&t.asElement().parsedType();if(S&&S.isUnion()){var N=t.root().types().getTypeRegistry();S.declaredFacets().filter(function(e){return!f.hasOwnProperty(e.facetName())&&(!!e.validateSelf(N).isOk()&&(!!r.facetsToExtract[e.facetName()]&&("discriminatorValue"!=e.facetName()||e.isStrict())))}).forEach(function(e){return f[e.facetName()]=e.value()})}if(f.mediaType=B,t&&t.isElement()){var I=t.asElement(),b=I.localType().isExternal()?I.localType():null;if(!b)for(var M=0,C=I.localType().allSuperTypes();M<C.length;M++){var w=C[M];w.isExternal()&&(b=w)}if(b){var L=b.external().schema().trim();if(O.stringStartsWith(L,"<")?f.mediaType="application/xml":f.mediaType="application/json",e.type&&e.type.length){var D=e.type[0];"string"==typeof D&&(D=D.trim(),D==L&&(e.type[0]=D))}}}if(!d||!(P.isHeadersProperty(d)||P.isQueryParametersProperty(d)||P.isUriParametersProperty(d)||P.isPropertiesProperty(d)||P.isBaseUriParametersProperty(d))){delete f.required;var x=f.__METADATA__;if(x){var F=x.primitiveValuesMeta;F&&(delete F.required,Object.keys(F).length||delete x.primitiveValuesMeta),Object.keys(x).length||delete f.__METADATA__}}var _=f.type;if(_.forEach&&"string"==typeof _[0]){var V=t.asElement().localType();if(V&&V.hasExternalInHierarchy()){var K=_[0].trim(),j="{"===K[0]&&"}"===K[K.length-1],W="<"===K[0]&&">"===K[K.length-1];j?f.typePropertyKind="JSON":W?f.typePropertyKind="XML":f.typePropertyKind="TYPE_EXPRESSION"}else f.typePropertyKind="TYPE_EXPRESSION"}else"object"==typeof _&&(f.typePropertyKind="INPLACE");return this.options.expandExpressions&&this.processExpressions(f,t),e},t.prototype.processExpressions=function(e,t){this.parseExpressions(e,t)},t.prototype.parseExpressions=function(e,t){var n=e.type,r=Array.isArray(n)&&n.map(function(e){return"string"==typeof e});if(this.parseExpressionsForProperty(e,"items",t),this.parseExpressionsForProperty(e,"type",t),r)for(var i=t.asElement().parsedType(),a=function(t){if(!r[t])return"continue";var n=e.type[t];if(n&&"object"==typeof n){var a=!1;o.isEmptyUnion(i)||1!=e.type.length||(a=Object.keys(n).filter(function(t){return"type"!=t&&!e.hasOwnProperty(t)}).length>0),a?Object.keys(n).forEach(function(t){e[t]=n[t]}):n.name||(n.name="type",n.displayName="type",n.typePropertyKind="TYPE_EXPRESSION",o.appendMeta(n,"displayName","calculated"))}},o=this,s=0;s<e.type.length;s++)a(s)},t.prototype.appendSource=function(e,t){this.options.sourceMap&&t&&(e.sourceMap=t)},t.prototype.appendMeta=function(e,t,n,r){if(this.options.serializeMetadata){var i=null!=r,a=i&&r.primitiveValuesMeta;if(!i||a){var o=a&&a[t];if(i){if(!o)return;if(!o[n])return}var s=e.__METADATA__;if(s||(s={},e.__METADATA__=s),null==t)return void(s[n]=!0);var u=s.primitiveValuesMeta;u||(u={},s.primitiveValuesMeta=u);var l=u[t];l||(l={},u[t]=l),l[n]=!0}}},t.prototype.isEmptyUnion=function(e){return!!e.isUnion()&&!e.isEmpty()},t.prototype.parseExpressionsForProperty=function(e,t,n){var r=e[t];if(r){var i=!1;if(!Array.isArray(r)){if(r&&"object"==typeof r)return void(r.unfolded?e.prop=r.unfolded:this.parseExpressions(r,n));"string"==typeof r&&(i=!0,r=[r])}for(var a=[],o=0;o<r.length;o++){var s=r[o];if(s&&"object"==typeof s&&(s.unfolded?s=s.unfolded:this.parseExpressions(s,n)),"string"==typeof s){var u=s,l=I.checkExpression(u);if(l){var p={status:I.ParametersEscapingStatus.NOT_REQUIRED};if(s.indexOf("<<")>=0)if(p=I.escapeTemplateParameters(s),p.status==I.ParametersEscapingStatus.OK){if(u=p.resultingString,l=I.checkExpression(u),!l){a.push(s);continue}}else if(p.status==I.ParametersEscapingStatus.ERROR){a.push(s);continue}var c=void 0;try{c=w.parse(u)}catch(e){a.push(s);continue}if(c){var f=this.expressionToObject(c,p,n,e.sourceMap);null!=f&&a.push(f)}else a.push(s)}else{var h=this.options.typeReferences?this.typeReference(n,s):s;a.push(h)}}else a.push(s)}e[t]=i?a[0]:a}},t.prototype.expressionToObject=function(e,t,n,r){var i,a=0;if("name"==e.type){var o=e;if(a=o.arr,i=o.value,t.status==I.ParametersEscapingStatus.OK){var s=I.unescapeTemplateParameters(i,t.substitutions);s.status==I.ParametersEscapingStatus.OK&&(i=s.resultingString)}this.options.typeReferences&&(i=this.typeReference(n,i))}else if("union"==e.type){var u=e;i={type:["union"],anyOf:[]};for(var l=c(u),p=0,f=l;p<f.length;p++){var h=f[p];if(null==h){i=null;break}var d=this.expressionToObject(h,t,n,r);i.anyOf.push(d)}i.anyOf=k.unique(i.anyOf),this.appendSource(i,r)}else if("parens"==e.type){var m=e;a=m.arr,i=this.expressionToObject(m.expr,t,n,r)}if(null!=i&&a>0)for(;a-- >0;)i={type:["array"],items:[i]},a>0&&(i.name="items",i.displayName="items",i.typePropertyKind="TYPE_EXPRESSION",this.appendMeta(i,"displayName","calculated"),this.appendSource(i,r));return"object"==typeof i&&(i.typePropertyKind="TYPE_EXPRESSION",i.sourceMap=r),i},t.prototype.typeReference=function(e,t){if(!t)return t;var n=this.owner.astRoot(),r=n.isElement()&&n.asElement().types(),i=r&&r.getTypeRegistry().getByChain(t);if(i)if(i.isBuiltin());else{var a=i.getExtra(C.SOURCE_EXTRA),o=void 0;_.BasicASTNode.isInstance(a)?o=a.lowLevel():S.ASTNode.isInstance(a)||N.AstNode.isInstance(a)||v.LowLevelProxyNode.isInstance(a)?o=a:_.LowLevelWrapperForTypeSystem.isInstance(a)&&(o=a.node());var s=n.lowLevel();if(s.actual().libExpanded)t="#/specification/types/"+i.name();else{var u="",l=s.unit(),p=o.unit();if(p.absolutePath()!=l.absolutePath()){var c=p.project().namespaceResolver(),f=c.expandedPathMap(l)[p.absolutePath()];u+=f.includePath}t=u+"#/specification/types/"+i.name()}}else;return t},t}($),ne=function(e){function t(){return e.call(this,new J([new X(L.Universe10.TypeDeclaration.name,L.Universe10.LibraryBase.properties.annotationTypes.name,!0,["RAML10"]),new X(L.Universe10.TypeDeclaration.name,L.Universe10.LibraryBase.properties.types.name,!0,["RAML10"]),new X(L.Universe10.Trait.name,L.Universe10.LibraryBase.properties.traits.name,!0,["RAML10"]),new X(L.Universe10.AbstractSecurityScheme.name,L.Universe10.LibraryBase.properties.securitySchemes.name,!0,["RAML10"]),new X(L.Universe10.ResourceType.name,L.Universe10.LibraryBase.properties.resourceTypes.name,!0,["RAML10"])]))||this}return d(t,e),t.prototype.transform=function(e,t){return t.parent()&&t.parent().lowLevel().libProcessed?(h(e,t.lowLevel()),e):e},t}(z),re=function(e){function t(){return e.call(this,new J([new X(L.Universe10.ResourceType.name,null,!0),new X(L.Universe10.Trait.name,null,!0),new X(L.Universe10.Method.name,null,!0),new X(L.Universe10.Response.name,null,!0),new X(L.Universe08.Parameter.name,null,!0),new X(L.Universe08.BodyLike.name,null,!0),new X(L.Universe10.TypeDeclaration.name,null,!0)]))||this}return d(t,e),t.prototype.transform=function(e,t){if(Array.isArray(e))return e;var n=A.universesInfo.Universe10.Trait.properties.parametrizedProperties.name,r=e[n];return r&&(Object.keys(r).forEach(function(t){e[t]=r[t]}),delete e[n]),e},t}(z),ie=function(e){function t(){return e.call(this,L.Universe08.GlobalSchema.name,L.Universe08.Api.properties.schemas.name,!0,["RAML08"])||this}return d(t,e),t.prototype.transform=function(e,t){return Array.isArray(e)?e:(e.sourceMap&&(delete e.sourceMap.scalarsSources,0==Object.keys(e.sourceMap).length&&delete e.sourceMap),e.name=e.key,delete e.key,e)},t}($),ae=function(e){function t(){return e.call(this,new J([new X(L.Universe10.Api.name,L.Universe10.Api.properties.protocols.name,!0),new X(L.Universe10.MethodBase.name,L.Universe10.MethodBase.properties.protocols.name,!0)]))||this}return d(t,e),t.prototype.transform=function(e,t){return"string"==typeof e?e.toUpperCase():Array.isArray(e)?e.map(function(e){return e.toUpperCase()}):e},t}(z),oe=function(e){function t(){return e.call(this,new J([new X(L.Universe10.SecuritySchemeRef.name,L.Universe10.Api.properties.securedBy.name,!0),new X(L.Universe10.TraitRef.name,L.Universe10.MethodBase.properties.is.name,!0),new X(L.Universe10.ResourceTypeRef.name,L.Universe10.ResourceBase.properties.type.name,!0)]))||this}return d(t,e),t.prototype.transform=function(e,t){return null==e?null:Array.isArray(e)?e:this.toSimpleValue(e)},t.prototype.toSimpleValue=function(e){if("object"!=typeof e)return{name:e};var t={name:e.name},n=e.value;return n&&Object.keys(n).forEach(function(e){t.parameters=t.parameters||[],t.parameters.push({name:e,value:n[e]})}),t},t}(z),se=function(e){function t(t){var n=e.call(this,L.Universe10.LibraryBase.name,null,!0,["RAML10"])||this;return n.dumper=t,n}return d(t,e),t.prototype.getReferencePatcher=function(){return this.referencePatcher=this.referencePatcher||new b.ReferencePatcher,this.referencePatcher},t.prototype.transform=function(e,t){var n=t.lowLevel(),r=n&&n.actual(),i=r&&r.libExpanded;if(!i)return e;var a=e[A.universesInfo.Universe10.FragmentDeclaration.properties.uses.name];if(!a||!Array.isArray(a)||0==a.length)return e;var o=n.unit(),s=o.project().namespaceResolver();if(!s)return e;var u=s.expandedNSMap(o);if(!u)return e;for(var l=A.universesInfo.Universe10.Library.properties.usage.name,p=A.universesInfo.Universe10.Annotable.properties.annotations.name,c=0,f=a;c<f.length;c++){var h=f[c],d=h.key,m=u[d];if(m){var y=m.unit,v=y.ast(),g=v.children().filter(function(e){var t=e.key();return O.stringStartsWith(t,"(")&&O.stringEndsWith(t,")")}),E=v.children().find(function(e){return e.key()==l});if(E&&(h[l]=E.value()),g.length>0){for(var _=t.root().definition().universe().type(L.Universe10.Annotable.name),T=_.property(L.Universe10.Annotable.properties.annotations.name),S=[],N=0,I=g;N<I.length;N++){var R=I[N],M=R.dumpToObject(),C={name:R.key().substring(1,R.key().length-1),value:M[Object.keys(M)[0]]};if(C&&C.name){var w=C.name,P=o.ast().children().some(function(e){return e.key()==L.Universe10.Api.properties.mediaType.name}),D=new b.Scope;D.hasRootMediaType=P;var U=new b.State(this.getReferencePatcher(),o,D,s),x=this.getReferencePatcher().resolveReferenceValueBasic(w,U,T.nameId(),[o,y]);x&&(C.name=x.value(),S.push(C))}}S.length>0&&(h[p]=S)}}}return e},t}($),ue=function(e){function t(t){void 0===t&&(t=!1);var n=e.call(this,new J([new X(L.Universe10.Api.name,null,!0),new X(L.Universe10.Overlay.name,null,!0),new X(L.Universe10.Extension.name,null,!0),new X(L.Universe10.Library.name,null,!0)]))||this;return n.enabled=t,n}return d(t,e),t.prototype.match=function(t,n){return!!this.enabled&&e.prototype.match.call(this,t,n)},t.prototype.registrationInfo=function(){return this.enabled?e.prototype.registrationInfo.call(this):null},t.prototype.transform=function(e,t){return this.processApi(e),e},t.prototype.processApi=function(e){var t=e[A.universesInfo.Universe10.Api.properties.securitySchemes.name];if(t&&0!=t.length){for(var n={},r=0,i=t;r<i.length;r++){var a=i[r];n[a.name]=a}this.expandSecuredBy(e,n);var o=e[A.universesInfo.Universe10.Api.properties.resources.name];if(o)for(var s=0,u=o;s<u.length;s++){var l=u[s];this.processResource(l,n)}var p=e[A.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name];if(p)for(var c=0,f=p;c<f.length;c++){var l=f[c];this.processResource(l,n)}var h=e[A.universesInfo.Universe10.LibraryBase.properties.traits.name];if(h)for(var d=0,m=h;d<m.length;d++){var y=m[d];this.expandSecuredBy(y,n)}return e}},t.prototype.processResource=function(e,t){this.expandSecuredBy(e,t);var n=e[A.universesInfo.Universe10.Resource.properties.methods.name];if(n)for(var r=0,i=n;r<i.length;r++){var a=i[r];this.expandSecuredBy(a,t)}var o=e[A.universesInfo.Universe10.Resource.properties.resources.name];if(o)for(var s=0,u=o;s<u.length;s++){var l=u[s];this.processResource(l,t)}},t.prototype.expandSecuredBy=function(e,t){var n=e[A.universesInfo.Universe10.ResourceBase.properties.securedBy.name];if(n)for(var r=0;r<n.length;r++){var i=n[r];if(null!=i){var a=void 0;if("string"==typeof i)a=t[i];else if("object"==typeof i){var o=i;i=i.name,a=JSON.parse(JSON.stringify(t[i]));var s=o.parameters;if(s&&s.length>0){var u=a.settings;u||(u={},a.settings=u);for(var l=0,p=s;l<p.length;l++){var c=p[l];u[c.name]=c.value}}}a&&(n[r]=a)}}},t}(z),le=function(e){function t(t,n){void 0===t&&(t=!1),void 0===n&&(n=!1);var r=e.call(this,new J([new X(L.Universe10.Api.name,null,!0)]))||this;return r.enabled=t,r.serializeMetadata=n,r}return d(t,e),t.prototype.match=function(t,n){return!!this.enabled&&e.prototype.match.call(this,t,n)},t.prototype.registrationInfo=function(){return this.enabled?e.prototype.registrationInfo.call(this):null},t.prototype.transform=function(e,t,n){return this.processApi(e),e},t.prototype.processApi=function(e){for(var t=this.extract(e,A.universesInfo.Universe10.Api.properties.baseUriParameters.name),n=e[A.universesInfo.Universe10.Resource.properties.resources.name]||[],r=0,i=n;r<i.length;r++){var a=i[r];this.processResource(a,t)}},t.prototype.processResource=function(e,t){var n=A.universesInfo.Universe10.Resource.properties.uriParameters.name,r=this.extract(e,n),i=t.concat(e[n]||[]);i.length>0&&(e[n]=i);for(var a=t.concat(r),o=e[A.universesInfo.Universe10.ResourceBase.properties.methods.name]||[],s=0,u=o;s<u.length;s++){var l=u[s];this.processMethod(l,a)}for(var p=e[A.universesInfo.Universe10.Resource.properties.resources.name]||[],c=0,f=p;c<f.length;c++){var h=f[c];this.processResource(h,a)}},t.prototype.processMethod=function(e,t){this.appendSecurityData(e);var n=A.universesInfo.Universe10.Resource.properties.uriParameters.name,r=t.concat(e[n]||[]);r.length>0&&(e[n]=r)},t.prototype.appendSecurityData=function(e){for(var t=A.universesInfo.Universe10.Operation.properties.headers.name,n=A.universesInfo.Universe10.Operation.properties.responses.name,r=A.universesInfo.Universe10.Operation.properties.queryParameters.name,i=e[A.universesInfo.Universe10.Method.properties.securedBy.name]||[],a=0,o=i;a<o.length;a++){var s=o[a];if(s){var u=s[A.universesInfo.Universe10.AbstractSecurityScheme.properties.describedBy.name]||{},l=this.extract(u,t),p=this.extract(u,n),c=this.extract(u,r);l.length>0&&(e[t]=(e[t]||[]).concat(l)),p.length>0&&(e[n]=(e[n]||[]).concat(p)),c.length>0&&(e[r]=(e[r]||[]).concat(c))}}},t.prototype.extract=function(e,t){var n=e[t]||[];if(n=JSON.parse(JSON.stringify(n)),this.serializeMetadata)for(var r=0,i=n;r<i.length;r++){var a=i[r],o=a.__METADATA__;o||(o={},a.__METADATA__=o),o.calculated=!0}return n},t.uriParamsPropName=L.Universe10.ResourceBase.properties.uriParameters.name,t.methodsPropName=L.Universe10.ResourceBase.properties.methods.name,t.resourcesPropName=L.Universe10.Api.properties.resources.name,t.queryParametersPropName=L.Universe10.Method.properties.queryParameters.name,t.headersPropName=L.Universe10.Method.properties.headers.name,t.securedByPropName=L.Universe10.Method.properties.securedBy.name,t.responsesPropName=L.Universe10.Method.properties.responses.name,t}(z),pe=function(e){function t(){return e.call(this,new J([new X(L.Universe10.LibraryBase.name,null,!0,["RAML10"])]))||this}return d(t,e),t.prototype.transform=function(e,t){if(!e)return e;if(!e.hasOwnProperty("schemas"))return e;var n=e.schemas;if(e.hasOwnProperty("types")){var r=e.types;e.types=r.concat(n)}else e.types=n;return delete e.schemas,e},t}(z);t.mergeRegInfos=l,t.toOptionsArray=c,t.getSchemaPath=f,t.patchDisplayName=h},function(e,t,n){"use strict";function r(e,t){if(t){if(!e)return t;for(var n=0,r=Object.keys(t);n<r.length;n++){var i=r[n];if(e.hasOwnProperty(i)){if("primitiveValuesMeta"==i)for(var a=0,o=Object.keys(t.primitiveValuesMeta);a<o.length;a++){var s=o[a];e.primitiveValuesMeta.hasOwnProperty(s)||(e.primitiveValuesMeta[s]=t.primitiveValuesMeta[s])}}else e[i]=t[i]}}}function i(e){for(var t=[],n=0,r=e;n<r.length;n++){var i=r[n],a=c.builtInTypes().get(i);if(a){var o=p.mapType(a);o.forEach(function(e){return t.push(e)})}}var s={};return t.forEach(function(e){e.properties().forEach(function(e){return s[e.nameId()]=!0})}),s}function a(e,t){if(void 0===t&&(t=!1),e.isUnion()||e.isBuiltin()||e.name())return!1;if(!t&&1!=e.superTypes().length)return!1;var n=e.declaredFacets().filter(function(e){var t=e.facetName();if(P.indexOf(t)>=0)return!1;if("discriminatorValue"==t){var n=e.isStrict;return"function"!=typeof n||n.call(e)}if("__METADATA__"==t){var r=e.value(),i=r.primitiveValuesMeta;return!(!i&&0==Object.keys(r).length)&&(!i||!!Object.keys(i).filter(function(e){return"displayName"!=e&&"required"!=e}).length)}return!0});return 0==n.length}function o(e){if(!e)return null;var t=h.find(e.declaredFacets(),function(e){return e.kind()==f.MetaInformationKind.TypeAttributeValue});return t?t.value():null}function s(e,t){if(!e||!m.ASTNodeImpl.isInstance(e))return null;var n=e.attr("type")||e.attr("schema")||e;return m.resolveSchemaFragment(n,t)}var u=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var l=n(56),p=n(208),c=l.rt,f=c.tsInterfaces,h=n(16),d=n(21),m=n(55),y=n(206),v=l.rt.typeExpressions,g=n(255),A=function(){function e(e,t,n,r,i,a,o){void 0===i&&(i=!1),void 0===o&&(o=null),this._original=e,this._name=t,this._type=n,this._required=r,this.isFacet=i,this._metadata=a,this._src=o}return e.prototype.name=function(){return this._original?this._original.name():this._name},e.prototype.original=function(){return this._original},e.prototype.append=function(t,n){var r;if(this._type.isUnion()){var i=this._type,a=n.branchingOption(i.branchId()),o=i.options()[a];if(o.isBuiltIn())r=o;else{var s=new T(o.original(),[],null,[],[],o.name());o.append(s,n),r=s}}else{var s=new T(this._type.original(),[],null,[],[],this._type.name());this._type.append(s,n),r=s}var u=new e(this._original,this._name,r,this.required(),this.isFacet,this.metadata(),this._src);this.isFacet?t.addFacet(u):t.addProperty(u)},e.prototype.setType=function(e){this._type=e},e.prototype.type=function(){return this._type},e.prototype.required=function(){return null!=this._required?this._required:this._original.required()},e.prototype.metadata=function(){return this._metadata},e.prototype.annotations=function(){return this._original?this._original.annotations():[]},e.prototype.source=function(){var e=this._original||this._src;return e?new T(e.declaredAt(),[],null,[],[],null):null},e}();t.PropertyEntry=A;var E=function(){function e(e,t){this._original=e,this._superTypes=t,this._id=""+_++}return e.prototype.id=function(){return this._id},e.prototype.branchingRegistry=function(){return this._branchingRegistry},e.prototype.setBranchingRegistry=function(e){this._branchingRegistry=e},e.prototype.name=function(){return this._original&&this._original.name()},e.prototype.isUnion=function(){return!1},e.prototype.isBuiltIn=function(){return!1},e.prototype.isExternal=function(){if(this._original)return this._original.isExternal();for(var e=0,t=this.superTypes();e<t.length;e++){var n=t[e];if(n.isExternal())return!0}return!1},e.prototype.isUnknown=function(){return!(!this._original||!this._original.isUnknown())&&null==h.find(this._original.allFacets(),function(e){return"importedByChain"==e.facetName()})},e.prototype.schema=function(){if(this._original){var e=h.find([this._original].concat(this._original.allSuperTypes()),function(e){return"external"==e.kind()});return e?e.schema():null}for(var t=0,n=this.superTypes();t<n.length;t++){var r=n[t],i=r.schema();if(i)return i}return null},e.prototype.isIntersection=function(){return!1},e.prototype.addSuperType=function(e){this._superTypes=this._superTypes||[],this._superTypes.indexOf(e)<0&&this._superTypes.push(e)},e.prototype.superTypes=function(){return this._superTypes},e.prototype.original=function(){return this._original},e.prototype.append=function(e,t){},e.prototype.clone=function(){throw new Error("not implemented")},e.prototype.possibleBuiltInTypes=function(){throw new Error("not implemented")},e.prototype.declaredFacets=function(){var e=[];return this._original&&(e=this._original.declaredFacets(),e=e.filter(function(e){return e.kind()!=f.MetaInformationKind.Example&&e.kind()!=f.MetaInformationKind.Examples})),e},e.prototype.allFacets=function(){var e=this.meta(),t=e.filter(function(e){return e.kind()!=f.MetaInformationKind.FacetDeclaration});return t},e.prototype.isRecursionPoint=function(){return!1},e.prototype.examples=function(e){if(this._original){var t=this._original.examples();return t}return[]},e.prototype.declaredExampleFacets=function(){var e=[];return this._original&&(e=this._original.declaredFacets(),e=e.filter(function(e){return e.kind()==f.MetaInformationKind.Example||e.kind()==f.MetaInformationKind.Examples})),e},e.prototype.meta=function(){var e=[];if(this._original)e=this._original.allFacets();else for(var t=0,n=this.superTypes();t<n.length;t++){var r=n[t];r.allFacets().forEach(function(t){return e.push(t)})}return e=e.filter(function(e){return e.kind()!=f.MetaInformationKind.Example&&e.kind()!=f.MetaInformationKind.Examples&&e.kind()!=f.MetaInformationKind.FacetDeclaration})},e.prototype.schemaPath=function(){if(!this.original()||!this.original().superTypes().filter(function(e){return 1==e.superTypes().length&&"external"==e.superTypes()[0].name()}).length)return null;var e=h.find(this.meta(),function(e){return e.kind()==f.MetaInformationKind.SchemaPath});return e&&e.value()},e.prototype.sourceMap=function(){return this.getOneMetaValue(f.MetaInformationKind.SchemaPath)},e.prototype.displayName=function(){return this.getOneMetaValue(f.MetaInformationKind.DisplayName)},e.prototype.getOneMetaValue=function(e){var t=h.find(this.declaredFacets(),function(t){return t.kind()==e});return t?t.value():null},e.prototype.typeAttributeValue=function(){return o(this._original)||this._typeAttrVal},e.prototype.setTypeAttributeValue=function(e){this._typeAttrVal=e},e}();t.AbstractTypeEntry=E;var _=0,T=function(e){function t(t,n,r,i,a,o){void 0===n&&(n=[]),void 0===i&&(i=[]),void 0===a&&(a=[]);var s=e.call(this,t,n)||this;return s._componentType=r,s._properties=i,s._facets=a,s._name=o,s.facets=[],s}return u(t,e),t.prototype.setDepth=function(e){this._depth=e},t.prototype.depth=function(){return this._depth},t.prototype.clone=function(e){return new t(this._original,[],e,[],[],this.name())},t.prototype.possibleBuiltInTypes=function(e){if(void 0===e&&(e={}),this.name()){if(e[this.name()])return[];e[this.name()]=!0}for(var t=[],n=0,r=this.superTypes();n<r.length;n++){var i=r[n];t=t.concat(i.possibleBuiltInTypes(e))}var a={};return t.forEach(function(e){return a[e]=!0}),t.forEach(function(e){var t=c.builtInTypes().get(e);t&&t.allSuperTypes().forEach(function(e){return delete a[e.name()]})}),delete a.unknown,t=Object.keys(a)},t.prototype.componentType=function(){return this._componentType},t.prototype.setComponentType=function(e){this._componentType=e},t.prototype.properties=function(){return this._properties},t.prototype.definedFacets=function(){return this._facets},t.prototype.addProperty=function(e){this._properties.push(e)},t.prototype.addFacet=function(e){this._facets.push(e)},t.prototype.append=function(e,n){if(this._original&&"union"!=this._original.kind()&&(e._original=this._original),!this.isExternal()){if(n.typeMap().hasType(this)&&0==this.depth())return void e.setIsRecursionPoint();null!=this._typeAttrVal&&e.setTypeAttributeValue(this._typeAttrVal),n.typeMap().addType(this);try{if(this._componentType){var r=n.expander().expandHierarchy(this._componentType,this._componentType.branchingRegistry(),n.typeMap());e.setComponentType(r)}if(this._properties.length>0){for(var i={},a=0,o=this._properties;a<o.length;a++){var s=o[a],u=s.name(),l=i[u];l||(l=[],i[u]=l),l.push(s)}for(var p=function(r){var a=i[r];if(1==a.length)a[0].append(e,n);else{var o=new t(null,[],null,[],[],null),s=!1;a.forEach(function(e){o.addSuperType(e.type()),s=s||e.required()});var u=new A(null,r,o,s,!1,null,a[0].original());u.append(e,n)}},c=0,f=Object.keys(i);c<f.length;c++){var u=f[c];p(u)}}if(this._facets.length>0)for(var h=0,d=this._facets;h<d.length;h++){var m=d[h];m.append(e,n)}for(var y=0,v=this.superTypes();y<v.length;y++){var g=v[y];g.append(e,n),g.isUnion()||e.addSuperType(g)}}finally{n.typeMap().removeType(this)}}},t.prototype.name=function(){return this._name||e.prototype.name.call(this)},t.prototype.setName=function(e){return this._name=e},t.prototype.isRecursionPoint=function(){return this._isRecursionPoint},t.prototype.setIsRecursionPoint=function(e){void 0===e&&(e=!0),this._isRecursionPoint=e},t}(E);t.GeneralTypeEntry=T;var S=function(e){function t(t){var n=e.call(this,t,[])||this;return n._original=t,n}return u(t,e),t.prototype.possibleBuiltInTypes=function(){return[this._original.name()]},t.prototype.isBuiltIn=function(){return!0},t.prototype.append=function(e,t){e.addSuperType(this)},t}(E);t.BuiltInTypeEntry=S;var N=function(e){function t(t,n,r){var i=e.call(this,t,[])||this;return i._options=n,i._branchId=r,i}return u(t,e),t.prototype.isUnion=function(){return!0},t.prototype.branchId=function(){return this._branchId},t.prototype.append=function(e,t){var n=t.branchingOption(this._branchId),r=this._options[n];r.isBuiltIn()||null==r.name()?e.setName(this.name()):e.setName(r.name()),r.append(e,t)},t.prototype.clone=function(){throw new Error("Not implemented")},t.prototype.possibleBuiltInTypes=function(e){void 0===e&&(e={});var t=[];if(this.name()){if(e[this.name()])return[];e[this.name()]=!0}return this._options.forEach(function(n){return t=t.concat(n.possibleBuiltInTypes(e))}),t=h.unique(t)},t.prototype.options=function(){return this._options},t}(E);t.UnionTypeEntry=N;var I=function(e){function t(t,n){var r=e.call(this,t,[])||this;return r.options=n,r}return u(t,e),t.prototype.isIntersection=function(){return!0},t.prototype.append=function(e,t){throw new Error("not implemented")},t.prototype.clone=function(){throw new Error("Not implemented")},t.prototype.possibleBuiltInTypes=function(e){if(void 0===e&&(e={}),this.name()){if(e[this.name()])return[];e[this.name()]=!0}for(var t=this.options.map(function(t){return t.possibleBuiltInTypes(e)}),n=t[0],r=1;r<t.length;r++)n=h.intersection(n,t[r]);return n},t}(E);t.IntersectionTypeEntry=I;var b=function(){function e(){this.typeMapById={},this.typeMapByName={},this.propertiesMap={}}return e.prototype.addType=function(e){var t=e.id();t&&(this.typeMapById[t]=e),e.name()&&(this.typeMapByName[e.name()]=e)},e.prototype.removeType=function(e){e.id()&&delete this.typeMapById[e.id()],e.name()&&delete this.typeMapByName[e.name()]},e.prototype.hasType=function(e){var t=e.id();return void 0!==this.typeMapById[t]},e.prototype.hasTypeByName=function(e){return void 0!==this.typeMapByName[e]},e.prototype.typeByName=function(e){return this.typeMapByName[e]},e.prototype.addProperty=function(e,t,n){var r=this.propKey(e,t);this.propertiesMap[r]=n},e.prototype.property=function(e,t){var n=this.propKey(e,t);return this.propertiesMap[n]},e.prototype.propKey=function(e,t){return e+"/"+t},e}();t.BasicTypeMap=b;var R=function(){function e(e,t,n){void 0===n&&(n=new b),this.arr=e,this._expander=t,this._typeMap=n}return e.prototype.branchingOption=function(e){if(e>this.arr.length-1)throw new Error("Branch index exceeds total branches count");return this.arr[e]},e.prototype.typeMap=function(){return this._typeMap},e.prototype.expander=function(){return this._expander},e}(),M=function(){function e(e){this._expander=e,this.arr=[]}return e.prototype.expander=function(){return this._expander},e.prototype.nextBranchId=function(e){var t=this.arr.length;return this.arr.push(e),t},e.prototype.possibleBranches=function(e){for(var t=this,n=[],r=[],i=1,a=1,o=this.arr.length,s=0;s<o;s++)n.push(i),r.push(a),i*=this.arr[s],a*=this.arr[o-1-s];r=r.reverse();for(var u=[],s=0;s<i;s++)u.push([]);for(var s=0;s<o;s++)for(var l=0,p=this.arr[s],c=0;c<n[s];c++)for(var f=0;f<p;f++)for(var h=0;h<r[s];h++)u[l++].push(f);var d=u.map(function(n){return new R(n,t.expander(),e)});return d},e}(),C=function(){function e(e){void 0===e&&(e={}),this.options=e,"number"!=typeof this.options.typeExpansionRecursionDepth&&(this.options.typeExpansionRecursionDepth=-1),"boolean"!=typeof this.options.serializeMetadata&&(this.options.serializeMetadata=!1)}return e.prototype.serializeType=function(e){var t=this.createHierarchyEntry(e,this.options.typeExpansionRecursionDepth),n=this.options.typeExpansionRecursionDepth>=0;n&&(t=this.expandHierarchy(t,t.branchingRegistry()));var r=this.dump(t,n);return r},e.prototype.createHierarchyEntry=function(e,t,n,r){void 0===n&&(n=new b);var i=!1;r||(i=!0,r=new M(this));var a=this.doCreateHierarchyEntry(e,t,n,r);return i&&a.setBranchingRegistry(r),a},e.prototype.doCreateHierarchyEntry=function(e,t,n,r){if(void 0===n&&(n=new b),e.isBuiltin()){var i=n.typeByName(e.name());return i||(i=new S(e),n.addType(i)),i}var s=0;if(!e.name()&&e.isEmpty()&&2==e.superTypes().length&&1==e.superTypes().filter(function(e){return"unknown"!=e.name()}).length&&(e=h.find(e.superTypes(),function(e){return"unknown"!=e.name()})),e.name()&&n.hasTypeByName(e.name())){if(t<=0)return n.typeByName(e.name());s=t,t--}if(this.options.isInsideTemplate&&1==e.superTypes().length){var u=void 0,l=o(e);if(u=l?l:e.superTypes()[0].isBuiltin()?e.name():e.superTypes()[0].name(),u&&u.indexOf("<<")>=0){var p=this.processExpression(u,t,n,r,e);if(p)return p}}if(e.isUnion()&&0==e.superTypes().length){for(var c=e.options(),f=[],d=0,m=c;d<m.length;d++){var y=m[d];f.push(this.createHierarchyEntry(y,t,n,r))}var v=r.nextBranchId(f.length),g=new N(e,f,v);return g}var A=new T(e,[],null,[],[],e.name());A.setDepth(s),null==e.name()||n.hasTypeByName(e.name())||n.addType(A);var E=[];if(t==-1)for(var _=e.superTypes(),I=_,R=0,M=I;R<M.length;R++){var C=M[R],w=this.createHierarchyEntry(C,t,n,r);E.push(w)}else for(var _=e.allSuperTypes(),I=_.filter(function(e){return!e.isUnion()}),P=0,L=I;P<L.length;P++){var C=L[P];if(C.isBuiltin()){var w=this.createHierarchyEntry(C,t,n,r);E.push(w)}}var O=e.allOptions(),D=t>=0?e.properties():e.declaredProperties();if(t>=0&&O.length>1){for(var f=[],U=0,x=O;U<x.length;U++){var y=x[U];f.push(this.createHierarchyEntry(y,t,n,r))}var v=r.nextBranchId(f.length),g=new N(e,f,v);E.push(g)}if(e.isArray()){var k=e.componentType();if(k){a(k)&&(k=k.superTypes()[0]);var F=this.createHierarchyEntry(k,t,n);A.setComponentType(F)}}var B=[];if(D.length>0)for(var V=0,K=D;V<K.length;V++){var j=K[V],W=this.processPropertyHierarchy(j,t,e,n,r);B.push(W);
}for(var H=0,Y=E;H<Y.length;H++){var C=Y[H];A.addSuperType(C)}for(var q=0,G=B;q<G.length;q++){var W=G[q];A.addProperty(W)}var X=t>=0?e.allDefinedFacets():e.definedFacets();if(X.length>0)for(var z=0,$=X;z<$.length;z++){var j=$[z],J=this.processPropertyHierarchy(j,t,e,n,r,!0);A.addFacet(J)}return t==this.options.typeExpansionRecursionDepth&&n.removeType(A),A},e.prototype.processExpression=function(e,t,n,r,i){void 0===n&&(n=new b);var a=y.checkExpression(e);if(!a)return null;var o,s=y.escapeTemplateParameters(e);if(s.status!=y.ParametersEscapingStatus.OK)return null;if(o=s.resultingString,a=y.checkExpression(o),!a)return null;var u;try{if(u=v.parse(o),!u)return null;var l=this.expressionToObject(u,s,t,n,r,i);return l}catch(e){return null}},e.prototype.expressionToObject=function(e,t,n,r,i,a){void 0===r&&(r=new b);var o,s=0;if("name"==e.type){var u=e;s=u.arr;var p=u.value;if(t.status==y.ParametersEscapingStatus.OK){var c=y.unescapeTemplateParameters(p,t.substitutions);c.status==y.ParametersEscapingStatus.OK&&(p=c.resultingString)}var f=l.rt.builtInTypes().get(p);if(f||(f=this.options.typeCollection.getType(p)),f)o=this.createHierarchyEntry(f,n,r,i);else{var h=new T(l.rt.builtInTypes().get("unknown"),[],null,[],[],"unknown"),d=0===s?a:null;o=new T(d,[h],null,[],[],p),o.setTypeAttributeValue(p)}}else if("union"==e.type){for(var m=e,v=g.toOptionsArray(m),A=[],E=0,_=v;E<_.length;E++){var I=_[E];if(null==I){o=null;break}var R=this.expressionToObject(I,t,n,r,i);A.push(R)}var M=i.nextBranchId(A.length);o=new N(a,A,M)}else if("parens"==e.type){var C=e;s=C.arr,o=this.expressionToObject(C.expr,t,n,r,i,a)}if(null!=o&&s>0)for(var w=new S(l.rt.builtInTypes().get("array"));s-- >0;){var d=0===s?a:null;o=new T(null,[w],o,[],[],null)}return o},e.prototype.extractParserMetadata=function(e){var t,n=e.declaredFacets().filter(function(e){return"__METADATA__"==e.facetName()});return n.length&&(t=n[0].value()),t},e.prototype.processPropertyHierarchy=function(e,t,n,i,o,s){void 0===s&&(s=!1);var u=e.range(),l=this.extractParserMetadata(u),p=e.declaredAt(),c=t;if(p.name()&&(!n.name()||p.name()!=n.name())&&i.hasTypeByName(p.name())&&t<=0){var f=i.property(p.name(),e.name());if(f)return f;c--}a(u)&&(u=u.superTypes()[0],t>=0&&r(l,this.extractParserMetadata(u)));var h=new A(e,null,null,e.required(),s,l);p.name()&&i.addProperty(p.name(),e.name(),h);var d=this.createHierarchyEntry(u,c,i,o);return h.setType(d),h},e.prototype.expandHierarchy=function(e,t,n){if(!t)return e;for(var r=[],i=0,a=t.possibleBranches(n);i<a.length;i++){var o=a[i],s=new T(null,[],null,[],[],null);e.append(s,o),r.push(s)}if(1==r.length)return r[0];var u=new N(e.original(),r,-1);return u},e.prototype.appendSourceFromExtras=function(e,t){if(this.options.sourceMap&&!e.sourceMap){var n=void 0,r=t.original()&&t.original().getExtra("SOURCE");if(r){var i=void 0;if(m.LowLevelWrapperForTypeSystem.isInstance(r))i=r.node();else if(m.ASTNodeImpl.isInstance(r)){var a=void 0;t.isExternal()&&(a=g.getSchemaPath(r),a&&(e.schemaPath=a,n={path:a})),n||(n={path:m.actualPath(r)})}else r.obj&&r.obj.sourceMap&&(n=r.obj.sourceMap);i&&(n=i.includePath()?{path:i.unit().resolve(i.includePath()).path()}:{path:i.unit().path()})}n&&this.spreadSources(e,n)}},e.prototype.spreadSources=function(e,t){var n=this;"object"==typeof e&&(e.sourceMap||(e.sourceMap=t,e.items&&e.items.forEach(function(e){return n.spreadSources(e,t)}),e.anyOf&&e.anyOf.forEach(function(e){return n.spreadSources(e,t)}),e.properties&&e.properties.forEach(function(e){return n.spreadSources(e,t)}),e.facets&&e.facets.forEach(function(e){return n.spreadSources(e,t)}),e.xml&&this.spreadSources(e.xml,t)))},e.prototype.dump=function(e,t){var n=this,r={},i=e.name();if(i&&(r.name=i,e.isRecursionPoint()))return r={type:["any"]},this.appendSourceFromExtras(r,e),r;var o=e.superTypes();if(e.isBuiltIn())r={type:[i],typePropertyKind:"TYPE_EXPRESSION"};else if(e.isExternal())if(!t&&o[0].name()&&e.original().allSuperTypes().length>3)r.type=[o[0].name()],r.typePropertyKind="TYPE_EXPRESSION";else{var u=e.schema();if(u){u=u.trim();var l=s(this.options.node,u);l&&(u=l),r.type=[u],e.schemaPath()&&(r.schemaPath=e.schemaPath());var p="{"===u[0]&&"}"===u[u.length-1],c="<"===u[0]&&">"===u[u.length-1];p?r.typePropertyKind="JSON":c?r.typePropertyKind="XML":r.typePropertyKind="TYPE_EXPRESSION"}}else if(e.isUnion()){r.typePropertyKind="TYPE_EXPRESSION";var f=e,h=f.options();if(h.length>0){r.type=["union"];var d=[];r.anyOf=d;for(var m=0,y=h;m<y.length;m++){var v=y[m];if(!t&&v.name())d.push(v.name());else{var g=this.dump(v,t);if(this.appendSourceFromExtras(g,f),this.options.isInsideTemplate)if(g.name==e.name()&&g.type){var A=g.type;A.length&&A[0].indexOf("<<")>=0&&(g=A[0])}else g.name&&g.name.indexOf("<<")>=0&&(g=g.name);d.push(g)}}}}else{o.length&&(o[0].name()||o[0].isUnion())?r.typePropertyKind="TYPE_EXPRESSION":r.typePropertyKind="INPLACE";var E=e,_=void 0;if(this.options.isInsideTemplate){if(_=e.typeAttributeValue(),!_){var T=e.original()&&e.original().superTypes();if(T&&1==T.length&&T[0].isUnknown()){var S=T[0].name();S.indexOf("<<")>=0&&(_=S)}}_&&!Array.isArray(_)&&(_=[_])}if(_)r.type=_,r.typePropertyKind="TYPE_EXPRESSION";else if(t){var N=E.possibleBuiltInTypes();N.length>0&&(r.type=N)}else{for(var N=[],I=0,b=o;I<b.length;I++){var R=b[I];if(R.name())N.push(R.name());else{var M=this.dump(R,t);M.name="type";var C=R.displayName();M.displayName=C||"type",C||this.appendMeta(M,"displayName","calculated"),N.push(M)}}r.type=N}var w=E.properties();if(w&&w.length>0){var P=[];r.properties=P;for(var L=0,O=w;L<O.length;L++){var D=O[L],U=this.dumpProperty(D,E,t);P.push(U)}}var x=E.definedFacets();if(x&&x.length>0){var k=[];r.facets=k;for(var F=0,B=x;F<B.length;F++){var V=B[F],K=this.dumpProperty(V,E,t,!0);k.push(K)}}var j=E.componentType();if(j){var W=[j];!t&&a(j.original(),!0)&&j.superTypes().length>1&&(W=j.superTypes()),r.items=W.map(function(r){if(!t&&r.name())return r.name();var i=n.dump(j,t);if(n.appendSourceFromExtras(i,E),j.isUnion()||i.name||(i.name="items",i.displayName="items",n.appendMeta(i,"displayName","calculated")),n.options.isInsideTemplate)if(i.name==e.name()&&i.type){var a=i.type;a.length&&a[0].indexOf("<<")>=0&&(i=a[0])}else i.name&&i.name.indexOf("<<")>=0&&(i=i.name);return i})}this.dumpFacets(e,r,t)}var H=e.examples(t);if(H.length>0){var Y=[],q=[];r.examples=q,r.simplifiedExamples=Y;for(var G=0,X=H;G<X.length;G++){var z=X[G];this.processExample(z,Y,q)}}var $=e.original()&&e.original().annotations();return this.dumpAnnotations($,r),this.dumpScalarsAnnotations(e,r,t),this.dumpMeta(e,r,t),this.appendSourceFromExtras(r,e),this.patchDisplayName(e,r),this.checkIfTypePropertyIsDefault(e,r),r},e.prototype.dumpScalarsAnnotations=function(e,t,n){var r=e.original()&&(n?e.original().scalarsAnnotations():e.original().declaredScalarsAnnotations());if(r){var i=Object.keys(r);if(i.length){var a={};t.scalarsAnnotations=a;for(var o=0,s=i;o<s.length;o++){var u=s[o];a[u]=r[u].map(function(e){return e.map(function(e){return{name:e.name(),value:e.value()}})})}}}},e.prototype.processExample=function(e,t,n){var r;if(e.isJSONString()||e.isYAML()){var i=e.asJSON();r=null!=i?i:e.original()}else r=e.original();var a=!1;if(Array.isArray(r))for(var o=0,s=r;o<s.length;o++){var u=s[o];if(Array.isArray(u)||"object"==typeof r){a=!0;break}}else"object"==typeof r&&null!=r&&(a=!0);var l=a?JSON.stringify(r):r;t.push(l);var p={strict:e.strict(),value:r};e.name()&&(p.name=e.name()),null!=e.displayName()&&(p.displayName=e.displayName()),e.description()&&(p.description=e.description());var c=e.annotations();if(this.dumpAnnotations(c,p),e.hasScalarAnnotations()){for(var f=e.scalarsAnnotations(),h={},d=0,m=Object.keys(f);d<m.length;d++){var y=m[d];if(f[y]){h[y]=[[]];for(var v=0,g=Object.keys(f[y]);v<g.length;v++){var A=g[v];h[y][0].push({name:A,value:f[y][A].value()})}}}Object.keys(h).length&&(p.scalarsAnnotations=h)}n.push(p)},e.prototype.checkIfTypePropertyIsDefault=function(e,t){if(!(e.isBuiltIn()||e.original()&&e.original().isUnion()))if(e.isUnknown()||!e.original()||this.sourceHasKey(e,"type")||this.sourceHasKey(e,"schema"))this.removeMeta(t,"type");else{var n=!1;n=!Array.isArray(t.type)||!t.type.length||"array"!=t.type[0],n&&this.appendMeta(t,"type","insertedAsDefault")}},e.prototype.dumpProperty=function(e,t,n,r){void 0===r&&(r=!1);var i,a=e.type();if(!n&&a.name()?(i={type:[a.name()],displayName:e.name(),typePropertyKind:"TYPE_EXPRESSION"},this.appendMeta(i,"displayName","calculated")):(i=this.dump(a,n),this.options.isInsideTemplate&&null!=i.name&&i.name.indexOf("<<")>=0&&(i={type:[i.name],typePropertyKind:"TYPE_EXPRESSION"}),i.__METADATA__&&(i.__METADATA__=JSON.parse(JSON.stringify(i.__METADATA__))),(null==i.displayName||a.name())&&(i.displayName=e.name(),this.appendMeta(i,"displayName","calculated"))),this.appendSourceFromExtras(i,e.source()||t),i.name=e.name(),r||(i.required=e.required()),!r&&e.required()){var o=!1;if(e.original()){if(e.original().range().getExtra("HAS_FACETS")){var s=e.original().range().getExtra("HAS_FACETS");s.length&&s.indexOf("required")>=0&&(o=!0)}o||this.appendMeta(i,"required","insertedAsDefault")}else a.name()||a.isBuiltIn()?this.appendMeta(i,"required","insertedAsDefault"):this.sourceHasKey(a,"required")||this.appendMeta(i,"required","insertedAsDefault")}var u=a;if((a.isBuiltIn()||a.original()&&a.original().isBuiltin())&&e.original()){var l=e.original().range();l.isBuiltin()||(u=new T(l,[],null,[],[],null))}if((n||u!=a)&&this.checkIfTypePropertyIsDefault(u,i),this.checkIfPropertyTypeIsCalculated(i,e,r,n),e.annotations()&&e.annotations().length){var p=i.scalarsAnnotations;p||(p={},i.scalarsAnnotations=p),p.required=[[]];for(var c=0,f=e.annotations();c<f.length;c++){var h=f[c];p.required[0].push({name:h.name(),value:h.value()})}}return i},e.prototype.dumpAnnotations=function(e,t){if(e&&e.length>0){var n=[];t.annotations=n,e.forEach(function(e){n.push({name:e.name(),value:e.value()})})}},e.prototype.dumpFacets=function(e,t,n){var r=[];if(e.original()){r=n?e.original().allCustomFacets()||[]:e.original().customFacets()||[];var a={};e.original().allDefinedFacets().forEach(function(e){return a[e.name()]=!0}),r=r.filter(function(e){return a[e.facetName()]===!0})}if(this.options.isInsideTemplate){var o=[];r=r.filter(function(e){return!(e.facetName().indexOf("<<")>=0)||(o.push(e),!1)});for(var s=0,u=o;s<u.length;s++){var l=u[s];t[l.facetName()]=l.value()}}if(r&&r.length>0){var p=[];t.fixedFacets=p,r.forEach(function(e){try{var t=e.value();"object"==typeof t&&JSON.stringify(t),p.push({name:e.facetName(),value:t})}catch(t){console.log("Error while dumping "+e.facetName()),console.log(t)}})}for(var c=e.possibleBuiltInTypes({}),h=i(c),d={},m=n?e.allFacets():e.declaredFacets(),y=0,v=m;y<v.length;y++){var g=v[y];if(g.kind()!=f.MetaInformationKind.DiscriminatorValue||g.isStrict()){var A=g.facetName();if(h[A]){var E=d[A];E||(E=[],d[A]=E),E.push(g)}}}for(var _=0,T=Object.keys(d);_<T.length;_++){var A=T[_],E=d[A],S=void 0;S=1==E.length?E[0].value():this.mergeFacetValues(E),"string"!=typeof S&&"number"!=typeof S&&"boolean"!=typeof S||("allowedTargets"!=A||Array.isArray(S)?"enum"==A&&(Array.isArray(S)||(S=[S]),e.original()&&e.original().isString()&&(S=S.map(function(e){return""+e}))):S=[S],t[A]=S)}},e.prototype.mergeFacetValues=function(e){if(0==e.length)return null;for(var t,n=0,r=e;n<r.length;n++){var i=r[n];if(t)i.isConstraint()&&(t=t.composeWith(i));else{if(!i.isConstraint())return i.value();t=i}}return t?t.value():e[0].value()},e.prototype.dumpMeta=function(e,t,n){for(var r=n?e.meta():e.declaredFacets(),i=0,a=r;i<a.length;i++){var o=a[i],s=o.facetName();if(w.getInstance().hasProperty(s))t.hasOwnProperty(s)||(t[s]=o.value(),"allowedTargets"!=s||Array.isArray(o.value())?"enum"==s&&(Array.isArray(o.value())||(t[s]=[o.value()]),e.original()&&e.original().isString()&&(t[s]=t[s].map(function(e){return""+e}))):t[s]=[o.value()]);else if("closed"==s){var u=o.value();t.additionalProperties=u}}},e.prototype.sourceHasKey=function(e,t){var n=e.original()&&e.original().getExtra("SOURCE"),r=null;if(n)if(m.LowLevelWrapperForTypeSystem.isInstance(n)){var i=n.childWithKey(t);r=i&&null!=i.value()}else if(m.ASTNodeImpl.isInstance(n)){var a=n.attr(t);r=a&&null!=a.value()}else n.obj&&(r=null!=n.obj[t]);return r},e.prototype.appendMeta=function(e,t,n){if(this.options.serializeMetadata){var r=e.__METADATA__;r||(r={},e.__METADATA__=r);var i=r.primitiveValuesMeta;i||(i={},r.primitiveValuesMeta=i);var a=i[t];a||(a={},i[t]=a),a[n]=!0}},e.prototype.removeMeta=function(e,t){if(this.options.serializeMetadata){var n=e.__METADATA__;if(n){var r=n.primitiveValuesMeta;if(r){var i=r[t];i&&(delete r[t],Object.keys(n.primitiveValuesMeta)||(delete n.primitiveValuesMeta,Object.keys(n)||delete e.__METADATA__))}}}},e.prototype.checkIfPropertyTypeIsCalculated=function(e,t,n,r){if(this.options.serializeMetadata){var i=t.original()&&t.original().declaredAt().getExtra("SOURCE");if(i){var a=void 0;if(m.ASTNodeImpl.isInstance(i)?a=i.lowLevel():m.LowLevelWrapperForTypeSystem.isInstance(i)&&(a=i.node()),a){var o=h.find(a.children(),function(e){return e.key()==(n?"facets":"properties")});if(o){var s=h.find(o.children(),function(e){return e.key()==t.name()});if(s)if(s.resolvedValueKind()==d.Kind.SCALAR)r&&!l.rt.builtInTypes().get(s.value())||this.removeMeta(e,"type");else if(s.resolvedValueKind()==d.Kind.SEQ){var u=s.children();if(u.length>1)this.removeMeta(e,"type");else if(1==u.length&&u[0].resolvedValueKind()==d.Kind.SCALAR){var p=u[0];r&&!l.rt.builtInTypes().get(p.value())||this.removeMeta(e,"type")}}else{var c=h.find(s.children(),function(e){return"type"==e.key()});if(c||(c=h.find(s.children(),function(e){return"schema"==e.key()})),c)if(c.resolvedValueKind()==d.Kind.SEQ){var u=c.children();if(u.length>1)this.removeMeta(e,"type");else if(1==u.length&&u[0].resolvedValueKind()==d.Kind.SCALAR){var p=u[0];r&&!l.rt.builtInTypes().get(p.value())||this.removeMeta(e,"type")}}else c.resolvedValueKind()==d.Kind.SCALAR&&(r&&!l.rt.builtInTypes().get(c.value())||this.removeMeta(e,"type"))}}}}}},e.prototype.patchDisplayName=function(e,t){if(!t.displayName&&t.name){t.displayName=t.name;var n=void 0,r=e.original()&&e.original().getExtra("SOURCE");if(r)if(m.LowLevelWrapperForTypeSystem.isInstance(r))n=r.node();else if(m.ASTNodeImpl.isInstance(r)){n=r.lowLevel()}n?g.patchDisplayName(t,n):t.displayName=t.name,this.appendMeta(t,"displayName","calculated")}t.hasOwnProperty("displayName")&&null!=t.displayName&&(t.displayName=""+t.displayName)},e}();t.TypeExpander=C;var w=function(){function e(){this.map={},this.init()}return e.getInstance=function(){return e.instance||(e.instance=new e),e.instance},e.prototype.init=function(){for(var e=[l.getUniverse("RAML10").type(l.universesInfo.Universe10.TypeDeclaration.name),l.getUniverse("RAML10").type(l.universesInfo.Universe10.StringTypeDeclaration.name),l.getUniverse("RAML10").type(l.universesInfo.Universe10.FileTypeDeclaration.name)],t=0,n=e;t<n.length;t++)for(var r=n[t],i=0,a=r.properties();i<a.length;i++){var o=a[i];o.nameId()!=l.universesInfo.Universe10.TypeDeclaration.properties.schema.name&&(this.map[o.nameId()]=!0)}this.map.sourceMap=!0,this.map.__METADATA__=!0},e.prototype.hasProperty=function(e){return this.map.hasOwnProperty(e)},e.instance=new e,e}(),P=["typePropertyKind","sourceMap","required","__METADATA__","notScalar"]},function(e,t,n){"use strict";function r(e){return e.isBuiltIn()?s[e.nameId()]:null}function i(e,t){void 0===t&&(t=!0);var n=e.definition(),i=(n.nameId(),r(n));if(!i){for(var o=a(n),u=n.allSuperTypes().sort(function(e,t){return o[e.nameId()]-o[t.nameId()]}),l=null,p=0;p<u.length;p++){var c=u[p].nameId();if(i=r(u[p]),"DataElement"!=c){if("hl.BasicNode"!=c&&i)break}else l=c}i||(l=c)}return i||(i=s["hl.BasicNode"]),i(e,t)}function a(e,t,n){void 0===t&&(t={}),void 0===n&&(n={});var r=e.nameId();if(!n[r]){n[r]=!0;var i=null!=t[r]&&t[r]+1||0,o=e.superTypes();return o.forEach(function(e){var r=e.nameId(),o=t[r];(null==o||i>o)&&(t[r]=i,a(e,t,n))}),delete n[r],t}}Object.defineProperty(t,"__esModule",{value:!0});var o=n(258);t.buildWrapperNode=i;var s={AbstractSecurityScheme:function(e,t){return new o.AbstractSecuritySchemeImpl(e,t)},AnyType:function(e){return new o.AnyTypeImpl(e)},Api:function(e,t){return new o.ApiImpl(e,t)},BasicSecurityScheme:function(e,t){return new o.BasicSecuritySchemeImpl(e,t)},BodyLike:function(e,t){return new o.BodyLikeImpl(e,t)},BooleanType:function(e){return new o.BooleanTypeImpl(e)},BooleanTypeDeclaration:function(e,t){return new o.BooleanTypeDeclarationImpl(e,t)},CustomSecurityScheme:function(e,t){return new o.CustomSecuritySchemeImpl(e,t)},DateTypeDeclaration:function(e,t){return new o.DateTypeDeclarationImpl(e,t)},DigestSecurityScheme:function(e,t){return new o.DigestSecuritySchemeImpl(e,t)},DocumentationItem:function(e,t){return new o.DocumentationItemImpl(e,t)},ExampleString:function(e){return new o.ExampleStringImpl(e)},FileTypeDeclaration:function(e,t){return new o.FileTypeDeclarationImpl(e,t)},FixedUri:function(e){return new o.FixedUriImpl(e)},FullUriTemplateString:function(e){return new o.FullUriTemplateStringImpl(e)},GlobalSchema:function(e,t){return new o.GlobalSchemaImpl(e,t)},IntegerTypeDeclaration:function(e,t){return new o.IntegerTypeDeclarationImpl(e,t)},JSONBody:function(e,t){return new o.JSONBodyImpl(e,t)},JSONExample:function(e){return new o.JSONExampleImpl(e)},JSonSchemaString:function(e){return new o.JSonSchemaStringImpl(e)},MarkdownString:function(e){return new o.MarkdownStringImpl(e)},Method:function(e,t){return new o.MethodImpl(e,t)},MethodBase:function(e,t){return new o.MethodBaseImpl(e,t)},MimeType:function(e){return new o.MimeTypeImpl(e)},NumberType:function(e){return new o.NumberTypeImpl(e)},NumberTypeDeclaration:function(e,t){return new o.NumberTypeDeclarationImpl(e,t)},OAuth1SecurityScheme:function(e,t){return new o.OAuth1SecuritySchemeImpl(e,t)},OAuth1SecuritySchemeSettings:function(e,t){return new o.OAuth1SecuritySchemeSettingsImpl(e,t)},OAuth2SecurityScheme:function(e,t){return new o.OAuth2SecuritySchemeImpl(e,t)},OAuth2SecuritySchemeSettings:function(e,t){return new o.OAuth2SecuritySchemeSettingsImpl(e,t)},Parameter:function(e,t){return new o.ParameterImpl(e,t)},ParameterLocation:function(e){return new o.ParameterLocationImpl(e)},RAMLSimpleElement:function(e,t){return new o.RAMLSimpleElementImpl(e,t)},Reference:function(e){return new o.ReferenceImpl(e)},RelativeUriString:function(e){return new o.RelativeUriStringImpl(e)},Resource:function(e,t){return new o.ResourceImpl(e,t)},ResourceType:function(e,t){return new o.ResourceTypeImpl(e,t)},ResourceTypeRef:function(e){return new o.ResourceTypeRefImpl(e)},Response:function(e,t){return new o.ResponseImpl(e,t)},SchemaString:function(e){return new o.SchemaStringImpl(e)},SecuritySchemePart:function(e,t){return new o.SecuritySchemePartImpl(e,t)},SecuritySchemeRef:function(e){return new o.SecuritySchemeRefImpl(e)},SecuritySchemeSettings:function(e,t){return new o.SecuritySchemeSettingsImpl(e,t)},StatusCodeString:function(e){return new o.StatusCodeStringImpl(e)},StringType:function(e){return new o.StringTypeImpl(e)},StringTypeDeclaration:function(e,t){return new o.StringTypeDeclarationImpl(e,t)},Trait:function(e,t){return new o.TraitImpl(e,t)},TraitRef:function(e){return new o.TraitRefImpl(e)},UriTemplate:function(e){return new o.UriTemplateImpl(e)},ValueType:function(e){return new o.ValueTypeImpl(e)},XMLBody:function(e,t){return new o.XMLBodyImpl(e,t)},XMLExample:function(e){return new o.XMLExampleImpl(e)},XMLSchemaString:function(e){return new o.XMLSchemaStringImpl(e)}}},function(e,t,n){"use strict";function r(e){var t=w.getUniverse("RAML08"),n=t.type("Method"),r=C.createStubNode(n,null,e);return r}function i(e){var t=w.getUniverse("RAML08"),n=t.type("StringTypeDeclaration"),r=C.createStubNode(n,null,e);return r}function a(e){var t=w.getUniverse("RAML08"),n=t.type("BooleanTypeDeclaration"),r=C.createStubNode(n,null,e);return r}function o(e){var t=w.getUniverse("RAML08"),n=t.type("NumberTypeDeclaration"),r=C.createStubNode(n,null,e);return r}function s(e){var t=w.getUniverse("RAML08"),n=t.type("IntegerTypeDeclaration"),r=C.createStubNode(n,null,e);return r}function u(e){var t=w.getUniverse("RAML08"),n=t.type("DateTypeDeclaration"),r=C.createStubNode(n,null,e);return r}function l(e){var t=w.getUniverse("RAML08"),n=t.type("FileTypeDeclaration"),r=C.createStubNode(n,null,e);return r}function p(e){var t=w.getUniverse("RAML08"),n=t.type("XMLBody"),r=C.createStubNode(n,null,e);return r}function c(e){var t=w.getUniverse("RAML08"),n=t.type("JSONBody"),r=C.createStubNode(n,null,e);return r}function f(e){var t=w.getUniverse("RAML08"),n=t.type("SecuritySchemePart"),r=C.createStubNode(n,null,e);return r}function h(e){var t=w.getUniverse("RAML08"),n=t.type("Trait"),r=C.createStubNode(n,null,e);return r}function d(e){var t=w.getUniverse("RAML08"),n=t.type("OAuth1SecuritySchemeSettings"),r=C.createStubNode(n,null,e);return r}function m(e){var t=w.getUniverse("RAML08"),n=t.type("OAuth2SecuritySchemeSettings"),r=C.createStubNode(n,null,e);return r}function y(e){var t=w.getUniverse("RAML08"),n=t.type("OAuth2SecurityScheme"),r=C.createStubNode(n,null,e);return r}function v(e){var t=w.getUniverse("RAML08"),n=t.type("OAuth1SecurityScheme"),r=C.createStubNode(n,null,e);return r}function g(e){var t=w.getUniverse("RAML08"),n=t.type("BasicSecurityScheme"),r=C.createStubNode(n,null,e);return r}function A(e){var t=w.getUniverse("RAML08"),n=t.type("DigestSecurityScheme"),r=C.createStubNode(n,null,e);return r}function E(e){var t=w.getUniverse("RAML08"),n=t.type("CustomSecurityScheme"),r=C.createStubNode(n,null,e);return r}function _(e){var t=w.getUniverse("RAML08"),n=t.type("GlobalSchema"),r=C.createStubNode(n,null,e);return r}function T(e){var t=w.getUniverse("RAML08"),n=t.type("DocumentationItem"),r=C.createStubNode(n,null,e);return r}function S(e,t,n){return L.loadApi(e,t,n).getOrElse(null)}function N(e,t,n){return L.loadApi(e,t,n).getOrElse(null)}function I(e,t,n){return L.loadApiAsync(e,t,n)}function b(e,t,n){return L.loadRAMLAsync(e,t,n)}function R(e){return L.getLanguageElementByRuntimeType(e)}var M=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var C=n(3),w=n(56),P=n(219),L=n(1),O=n(259),D=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.version=function(){return e.prototype.attribute.call(this,"version",this.toString)},t.prototype.setVersion=function(e){return this.highLevel().attrOrCreate("version").setValue(""+e),this},t.prototype.baseUri=function(){return e.prototype.attribute.call(this,"baseUri",function(e){return new Me(e)})},t.prototype.baseUriParameters_original=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.uriParameters=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.mediaType=function(){return e.prototype.attribute.call(this,"mediaType",function(e){return new Ie(e)})},t.prototype.schemas=function(){return e.prototype.elements.call(this,"schemas")},t.prototype.traits_original=function(){return e.prototype.elements.call(this,"traits")},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.securitySchemes=function(){return e.prototype.elements.call(this,"securitySchemes")},t.prototype.resourceTypes_original=function(){return e.prototype.elements.call(this,"resourceTypes")},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.documentation=function(){return e.prototype.elements.call(this,"documentation")},t.prototype.wrapperClassName=function(){return"ApiImpl"},t.prototype.kind=function(){return"Api"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Api")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ApiImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ApiImpl"==r)return!0}return!1},t.prototype.RAMLVersion_original=function(){return"RAML08"},t.prototype.expand=function(){return O.expandTraitsAndResourceTypes(this)},t.prototype.traits=function(){return O.traitsPrimary(this)},t.prototype.allTraits=function(){return O.allTraits(this)},t.prototype.resourceTypes=function(){return O.resourceTypesPrimary(this)},t.prototype.allResourceTypes=function(){return O.allResourceTypes(this)},t.prototype.childResource=function(e){return O.childResource(this,e)},t.prototype.allResources=function(){return O.allResources(this)},t.prototype.baseUriParameters=function(){return O.baseUriParametersPrimary(this)},t.prototype.allBaseUriParameters=function(){return O.baseUriParameters(this)},t.prototype.allProtocols=function(){return O.allProtocols(this)},t.prototype.RAMLVersion=function(){return O.RAMLVersion(this)},t}(P.BasicNodeImpl);t.ApiImpl=D;var U=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"ValueTypeImpl"},t.prototype.kind=function(){return"ValueType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ValueType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("undefined.ValueTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("undefined.ValueTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"undefined"},t.prototype.value=function(){return this.attr.value()},t}(P.AttributeNodeImpl);t.ValueTypeImpl=U;var x=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"AnyTypeImpl"},t.prototype.kind=function(){return"AnyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.AnyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.AnyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(U);t.AnyTypeImpl=x;var k=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"NumberTypeImpl"},t.prototype.kind=function(){return"NumberType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.NumberTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.NumberTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return this.attr.value()},t}(U);t.NumberTypeImpl=k;var F=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},t.prototype.kind=function(){return"BooleanType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BooleanTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BooleanTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return this.attr.value()},t}(U);t.BooleanTypeImpl=F;var B=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"ReferenceImpl"},t.prototype.kind=function(){return"Reference"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Reference")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ReferenceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ReferenceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return P.toStructuredValue(this.attr)},t.prototype.structuredValue=function(){return O.structuredValue(this)},t.prototype.name=function(){return O.referenceName(this)},t}(P.AttributeNodeImpl);t.ReferenceImpl=B;var V=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},t.prototype.kind=function(){return"ResourceTypeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceTypeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResourceTypeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResourceTypeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.resourceType=function(){return O.referencedResourceType(this)},t}(B);t.ResourceTypeRefImpl=V;var K=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.methods=function(){return e.prototype.elements.call(this,"methods")},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new he(e)})},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",function(e){return new V(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.uriParameters=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.baseUriParameters=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"ResourceTypeImpl";
},t.prototype.kind=function(){return"ResourceType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResourceTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResourceTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(P.BasicNodeImpl);t.ResourceTypeImpl=K;var j=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.responses=function(){return e.prototype.elements.call(this,"responses")},t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.baseUriParameters=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.queryParameters=function(){return e.prototype.elements.call(this,"queryParameters")},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"MethodBaseImpl"},t.prototype.kind=function(){return"MethodBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MethodBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MethodBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MethodBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(P.BasicNodeImpl);t.MethodBaseImpl=j;var W=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.code=function(){return e.prototype.attribute.call(this,"code",function(e){return new Y(e)})},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"ResponseImpl"},t.prototype.kind=function(){return"Response"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Response")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResponseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResponseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.isOkRange=function(){return O.isOkRange(this)},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(P.BasicNodeImpl);t.ResponseImpl=W;var H=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"StringTypeImpl"},t.prototype.kind=function(){return"StringType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.StringTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.StringTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return this.attr.value()},t}(U);t.StringTypeImpl=H;var Y=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},t.prototype.kind=function(){return"StatusCodeString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StatusCodeString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.StatusCodeStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.StatusCodeStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.StatusCodeStringImpl=Y;var q=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.location=function(){return e.prototype.attribute.call(this,"location",function(e){return new G(e)})},t.prototype.required=function(){return e.prototype.attribute.call(this,"required",this.toBoolean)},t.prototype.setRequired=function(e){return this.highLevel().attrOrCreate("required").setValue(""+e),this},t.prototype.default=function(){return e.prototype.attribute.call(this,"default",this.toAny)},t.prototype.setDefault=function(e){return this.highLevel().attrOrCreate("default").setValue(""+e),this},t.prototype.example=function(){return e.prototype.attribute.call(this,"example",this.toAny)},t.prototype.setExample=function(e){return this.highLevel().attrOrCreate("example").setValue(""+e),this},t.prototype.repeat=function(){return e.prototype.attribute.call(this,"repeat",this.toBoolean)},t.prototype.setRepeat=function(e){return this.highLevel().attrOrCreate("repeat").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"ParameterImpl"},t.prototype.kind=function(){return"Parameter"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Parameter")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ParameterImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ParameterImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(P.BasicNodeImpl);t.ParameterImpl=q;var G=function(){function e(e){this.attr=e}return e.prototype.wrapperClassName=function(){return"ParameterLocationImpl"},e.prototype.kind=function(){return"ParameterLocation"},e.prototype.allKinds=function(){return["ParameterLocation"]},e.prototype.allWrapperClassNames=function(){return["RAML08.ParameterLocationImpl"]},e.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ParameterLocationImpl"==r)return!0}return!1},e.prototype.RAMLVersion=function(){return"RAML08"},e}();t.ParameterLocationImpl=G;var X=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},t.prototype.kind=function(){return"MarkdownString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MarkdownString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MarkdownStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MarkdownStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.MarkdownStringImpl=X;var z=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?i(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.pattern=function(){return e.prototype.attribute.call(this,"pattern",this.toString)},t.prototype.setPattern=function(e){return this.highLevel().attrOrCreate("pattern").setValue(""+e),this},t.prototype.enum=function(){return e.prototype.attributes.call(this,"enum",this.toString)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.minLength=function(){return e.prototype.attribute.call(this,"minLength",this.toNumber)},t.prototype.setMinLength=function(e){return this.highLevel().attrOrCreate("minLength").setValue(""+e),this},t.prototype.maxLength=function(){return e.prototype.attribute.call(this,"maxLength",this.toNumber)},t.prototype.setMaxLength=function(e){return this.highLevel().attrOrCreate("maxLength").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},t.prototype.kind=function(){return"StringTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.StringTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.StringTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.StringTypeDeclarationImpl=z;var $=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?a(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},t.prototype.kind=function(){return"BooleanTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BooleanTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BooleanTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.BooleanTypeDeclarationImpl=$;var J=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?o(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.minimum=function(){return e.prototype.attribute.call(this,"minimum",this.toNumber)},t.prototype.setMinimum=function(e){return this.highLevel().attrOrCreate("minimum").setValue(""+e),this},t.prototype.maximum=function(){return e.prototype.attribute.call(this,"maximum",this.toNumber)},t.prototype.setMaximum=function(e){return this.highLevel().attrOrCreate("maximum").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},t.prototype.kind=function(){return"NumberTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.NumberTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.NumberTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.NumberTypeDeclarationImpl=J;var Q=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?s(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},t.prototype.kind=function(){return"IntegerTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("IntegerTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.IntegerTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.IntegerTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(J);t.IntegerTypeDeclarationImpl=Q;var Z=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?u(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"DateTypeDeclarationImpl"},t.prototype.kind=function(){return"DateTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.DateTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.DateTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.DateTypeDeclarationImpl=Z;var ee=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?l(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},t.prototype.kind=function(){return"FileTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FileTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.FileTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.FileTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.FileTypeDeclarationImpl=ee;var te=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.schema=function(){return e.prototype.attribute.call(this,"schema",function(e){return new ne(e)})},t.prototype.example=function(){return e.prototype.attribute.call(this,"example",function(e){return new ae(e)})},t.prototype.formParameters=function(){return e.prototype.elements.call(this,"formParameters")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"BodyLikeImpl"},t.prototype.kind=function(){return"BodyLike"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BodyLike")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BodyLikeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BodyLikeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.schemaContent=function(){return O.schemaContent(this)},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(P.BasicNodeImpl);t.BodyLikeImpl=te;var ne=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"SchemaStringImpl"},t.prototype.kind=function(){return"SchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.SchemaStringImpl=ne;var re=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"JSonSchemaStringImpl"},t.prototype.kind=function(){return"JSonSchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("JSonSchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.JSonSchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.JSonSchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ne);t.JSonSchemaStringImpl=re;var ie=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"XMLSchemaStringImpl"},t.prototype.kind=function(){return"XMLSchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLSchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.XMLSchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.XMLSchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ne);t.XMLSchemaStringImpl=ie;var ae=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"ExampleStringImpl"},t.prototype.kind=function(){return"ExampleString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ExampleString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ExampleStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ExampleStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.ExampleStringImpl=ae;var oe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"JSONExampleImpl"},t.prototype.kind=function(){return"JSONExample"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("JSONExample")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.JSONExampleImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.JSONExampleImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ae);t.JSONExampleImpl=oe;var se=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"XMLExampleImpl"},t.prototype.kind=function(){return"XMLExample"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLExample")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.XMLExampleImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.XMLExampleImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ae);t.XMLExampleImpl=se;var ue=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?p(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.schema=function(){return e.prototype.attribute.call(this,"schema",function(e){return new ie(e)})},t.prototype.wrapperClassName=function(){return"XMLBodyImpl"},t.prototype.kind=function(){return"XMLBody"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLBody")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.XMLBodyImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.XMLBodyImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(te);t.XMLBodyImpl=ue;var le=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?c(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.schema=function(){return e.prototype.attribute.call(this,"schema",function(e){return new re(e)})},t.prototype.wrapperClassName=function(){return"JSONBodyImpl"},t.prototype.kind=function(){return"JSONBody"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("JSONBody")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.JSONBodyImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.JSONBodyImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(te);t.JSONBodyImpl=le;var pe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},t.prototype.kind=function(){return"SecuritySchemeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SecuritySchemeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SecuritySchemeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.securitySchemeName=function(){return O.securitySchemeName(this)},t.prototype.securityScheme=function(){return O.securityScheme(this)},t}(B);t.SecuritySchemeRefImpl=pe;var ce=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.describedBy=function(){return e.prototype.element.call(this,"describedBy")},t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},t.prototype.kind=function(){return"AbstractSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AbstractSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.AbstractSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.AbstractSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(P.BasicNodeImpl);t.AbstractSecuritySchemeImpl=ce;var fe=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?f(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new he(e)})},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.queryParameters=function(){return e.prototype.elements.call(this,"queryParameters")},t.prototype.responses=function(){return e.prototype.elements.call(this,"responses")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},t.prototype.kind=function(){return"SecuritySchemePart"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemePart")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SecuritySchemePartImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SecuritySchemePartImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(j);t.SecuritySchemePartImpl=fe;var he=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"TraitRefImpl"},t.prototype.kind=function(){return"TraitRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TraitRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.TraitRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.TraitRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.trait=function(){return O.referencedTrait(this)},t}(B);t.TraitRefImpl=he;var de=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?h(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"TraitImpl"},t.prototype.kind=function(){return"Trait"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Trait")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.TraitImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.TraitImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(j);t.TraitImpl=de;var me=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(P.BasicNodeImpl);t.SecuritySchemeSettingsImpl=me;var ye=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?d(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.requestTokenUri=function(){return e.prototype.attribute.call(this,"requestTokenUri",function(e){return new ve(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ve(e)})},t.prototype.tokenCredentialsUri=function(){return e.prototype.attribute.call(this,"tokenCredentialsUri",function(e){return new ve(e)})},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth1SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth1SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(me);t.OAuth1SecuritySchemeSettingsImpl=ye;var ve=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"FixedUriImpl"},t.prototype.kind=function(){return"FixedUri"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FixedUri")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.FixedUriImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.FixedUriImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.FixedUriImpl=ve;var ge=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?m(t):t,n)||this;return r.nodeOrKey=t,
r.setAsTopLevel=n,r}return M(t,e),t.prototype.accessTokenUri=function(){return e.prototype.attribute.call(this,"accessTokenUri",function(e){return new ve(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ve(e)})},t.prototype.authorizationGrants=function(){return e.prototype.attributes.call(this,"authorizationGrants",this.toString)},t.prototype.setAuthorizationGrants=function(e){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+e),this},t.prototype.scopes=function(){return e.prototype.attributes.call(this,"scopes",this.toString)},t.prototype.setScopes=function(e){return this.highLevel().attrOrCreate("scopes").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth2SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth2SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(me);t.OAuth2SecuritySchemeSettingsImpl=ge;var Ae=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?y(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth2SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth2SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth2SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.OAuth2SecuritySchemeImpl=Ae;var Ee=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?v(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth1SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth1SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth1SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.OAuth1SecuritySchemeImpl=Ee;var _e=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?g(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},t.prototype.kind=function(){return"BasicSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BasicSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BasicSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BasicSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.BasicSecuritySchemeImpl=_e;var Te=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?A(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},t.prototype.kind=function(){return"DigestSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DigestSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.DigestSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.DigestSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.DigestSecuritySchemeImpl=Te;var Se=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?E(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},t.prototype.kind=function(){return"CustomSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("CustomSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.CustomSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.CustomSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.CustomSecuritySchemeImpl=Se;var Ne=function(e){function t(t,n){void 0===n&&(n=!0);var i=e.call(this,"string"==typeof t?r(t):t,n)||this;return i.nodeOrKey=t,i.setAsTopLevel=n,i}return M(t,e),t.prototype.method=function(){return e.prototype.attribute.call(this,"method",this.toString)},t.prototype.setMethod=function(e){return this.highLevel().attrOrCreate("method").setValue(""+e),this},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new he(e)})},t.prototype.wrapperClassName=function(){return"MethodImpl"},t.prototype.kind=function(){return"Method"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Method")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MethodImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MethodImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parentResource=function(){return O.parentResource(this)},t.prototype.ownerApi=function(){return O.ownerApi(this)},t.prototype.methodId=function(){return O.methodId(this)},t.prototype.allSecuredBy=function(){return O.allSecuredBy(this)},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(j);t.MethodImpl=Ne;var Ie=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"MimeTypeImpl"},t.prototype.kind=function(){return"MimeType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MimeType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MimeTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MimeTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.MimeTypeImpl=Ie;var be=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"UriTemplateImpl"},t.prototype.kind=function(){return"UriTemplate"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UriTemplate")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.UriTemplateImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.UriTemplateImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.UriTemplateImpl=be;var Re=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},t.prototype.kind=function(){return"RelativeUriString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("RelativeUriString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.RelativeUriStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.RelativeUriStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(be);t.RelativeUriStringImpl=Re;var Me=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},t.prototype.kind=function(){return"FullUriTemplateString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FullUriTemplateString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.FullUriTemplateStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.FullUriTemplateStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(be);t.FullUriTemplateStringImpl=Me;var Ce=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.wrapperClassName=function(){return"RAMLSimpleElementImpl"},t.prototype.kind=function(){return"RAMLSimpleElement"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("RAMLSimpleElement")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.RAMLSimpleElementImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.RAMLSimpleElementImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(P.BasicNodeImpl);t.RAMLSimpleElementImpl=Ce;var we=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?T(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.content=function(){return e.prototype.attribute.call(this,"content",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},t.prototype.kind=function(){return"DocumentationItem"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DocumentationItem")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.DocumentationItemImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.DocumentationItemImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(Ce);t.DocumentationItemImpl=we;var Pe=function(e){function t(t,n){void 0===n&&(n=!0);var r=e.call(this,"string"==typeof t?_(t):t,n)||this;return r.nodeOrKey=t,r.setAsTopLevel=n,r}return M(t,e),t.prototype.key=function(){return e.prototype.attribute.call(this,"key",this.toString)},t.prototype.setKey=function(e){return this.highLevel().attrOrCreate("key").setValue(""+e),this},t.prototype.value=function(){return e.prototype.attribute.call(this,"value",function(e){return new ne(e)})},t.prototype.wrapperClassName=function(){return"GlobalSchemaImpl"},t.prototype.kind=function(){return"GlobalSchema"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("GlobalSchema")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.GlobalSchemaImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.GlobalSchemaImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(Ce);t.GlobalSchemaImpl=Pe;var Le=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return M(t,e),t.prototype.relativeUri=function(){return e.prototype.attribute.call(this,"relativeUri",function(e){return new Re(e)})},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",function(e){return new V(e)})},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new he(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.uriParameters_original=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.methods=function(){return e.prototype.elements.call(this,"methods")},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.baseUriParameters=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new X(e)})},t.prototype.wrapperClassName=function(){return"ResourceImpl"},t.prototype.kind=function(){return"Resource"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Resource")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResourceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResourceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.completeRelativeUri=function(){return O.completeRelativeUri(this)},t.prototype.absoluteUri=function(){return O.absoluteUri(this)},t.prototype.parentResource=function(){return O.parent(this)},t.prototype.childResource=function(e){return O.childResource(this,e)},t.prototype.childMethod=function(e){return O.childMethod(this,e)},t.prototype.ownerApi=function(){return O.ownerApi(this)},t.prototype.uriParameters=function(){return O.uriParametersPrimary(this)},t.prototype.allUriParameters=function(){return O.uriParameters(this)},t.prototype.absoluteUriParameters=function(){return O.absoluteUriParameters(this)},t.prototype.allSecuredBy=function(){return O.allSecuredBy(this)},t}(P.BasicNodeImpl);t.ResourceImpl=Le,t.loadApiSync=S,t.loadRAMLSync=N,t.loadApi=I,t.loadRAML=b,t.getLanguageElementByRuntimeType=R},function(e,t,n){"use strict";function r(e){var t=new re.Project(ie.dirname(e)),n=t.unit(ie.basename(e));return n&&n.isRAMLUnit()?z.fromUnit(n).wrapperNode():null}function i(e){var t=e.highLevel().lowLevel();return Q.LowLevelProxyNode.isInstance(t)?e:J.expandTraitsAndResourceTypes(e)}function a(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==$.Universe08.Resource.name);return t}function o(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==$.Universe08.Resource.name);var r=n.baseUri(),i=r?r.value():"";return i=i?i:"",e&&(i=i.replace(/\/+$/,"")),t=i+t}function s(e){return z.qName(e.highLevel(),e.highLevel().root())}function u(e){return l(e)}function l(e){return f(e,function(e){return ne.isTraitType(e)})}function p(e){return c(e)}function c(e){return f(e,function(e){return ne.isResourceTypeType(e)})}function f(e,t){var n=te.globalDeclarations(e.highLevel()).filter(function(e){return t(e.definition())}),r=e.highLevel().lowLevel();if(!r)return[];var i=r.includePath();i||(i=r.unit().path());var a=n.map(function(e){var t,n=e.lowLevel().unit().path();return n!=i?(t=q.buildWrapperNode(e,!1),t.meta().setCalculated()):t=e.wrapperNode(),t});return a}function h(e){var t=[],n=e;do e=n,t.push(e.relativeUri().value()),n=e.parent();while(n.definition().key().name==$.Universe08.Resource.name);return t.reverse()}function d(e){return Y.ResourceImpl.isInstance(e.parent())?e.parent():null}function m(e){var t=e.parent();return t.definition().key().name==$.Universe08.Resource.name,null}function y(e,t){if(null==e)return null;var n=e.resources();return n?(n=n.filter(function(e){return e.relativeUri().value()==t}),0==n.length?null:n[0]):null}function v(e,t){if(!e)return null;for(var n=null,r=0;r<t.length;r++){if(n=y(e,t[r]),!n)return null;e=n}return n}function g(e,t){return e?e.methods().filter(function(e){return e.method()==t}):null}function A(e,t,n){var r=v(e,t);return null==r?null:g(r,n)}function E(e){return e.definition().key().name==$.Universe08.Api.name}function _(e){for(var t=e;!E(t);)t=t.parent();return t}function T(e){var t=e.parent();if(Y.ResourceImpl.isInstance(t))return a(t)+" "+e.method().toLowerCase();if(Y.ResourceTypeImpl.isInstance(t))return t.name()+" "+e.method().toLowerCase();throw new Error(Z.applyTemplate(oe.METHOD_OWNED_BY,{owner:e.definition().key().name}))}function S(e){var t=e.code().value(),n=Z.validateResponseString(t);if(null!=n)return!1;try{if(parseInt(t.charAt(0))<4)return!0}catch(e){}return!1}function N(e){var t=[],n=function(e){t.push(e),e.resources().forEach(function(e){return n(e)})};return e.resources().forEach(function(e){return n(e)}),t}function I(e){return b(e)}function b(e){var t=e.relativeUri(),n=t.value(),r=e.uriParameters_original(),i=$.Universe08.Resource.properties.uriParameters.name,a=t.highLevel().lowLevel();return j(r,n,e,i,a)}function R(e){return M(e)}function M(e){var t=e.baseUri(),n=t?t.value():"",r=e.baseUriParameters_original(),i=$.Universe08.Api.properties.baseUriParameters.name,a=t&&t.highLevel().lowLevel();return j(r,n,e,i,a)}function C(e){var t=[],n=e;do e=n,t=b(e).concat(t),n=e.parent();while(n.definition().key().name==$.Universe10.Resource.name);var r=n;r.baseUriParameters();return t=M(r).concat(t)}function w(e){return P(e)}function P(e){return e.protocols().map(function(e){return e.toUpperCase()})}function L(e){return O(e)}function O(e){return e.securedBy()}function D(e){var t=e.highLevel();if(!t)return"";var n=t.value();return n?n.toString():""}function U(e){var t=e.highLevel();if(!t)return null;var n=te.findDeclarationByNode(t,te.LocationKind.VALUE_COMPLETION);if(!n)return null;if(!n.getKind||n.getKind()!=X.NodeKind.NODE)return null;var r=n.wrapperNode();return Y.AbstractSecuritySchemeImpl.isInstance(r)?r:null}function x(e){return e.highLevel().definition().universe().version()}function k(e){var t=e.value().lowLevel();return new G.TypeInstanceImpl(t)}function F(e){var t=e.highLevel().value();return"string"==typeof t||null==t?t:t.valueName()}function B(e){return K(e)}function V(e){return K(e)}function K(e){var t=e.highLevel(),n=t.parent(),r=e.name(),i=te.referenceTargets(t.property(),n).filter(function(e){return z.qName(e,n)==r});return 0==i.length?null:i[0].wrapperNode()}function j(e,t,n,r,i){var a=n.highLevel(),o=a.definition().property(r);"string"!=typeof t&&(t="");var s={};e.forEach(function(e){var t=s[e.name()];t||(t=[],s[e.name()]=t),t.push(e)});for(var u=[],l=0,p={},c=t.indexOf("{");c>=0&&(l=t.indexOf("}",++c),!(l<0));c=t.indexOf("{",l)){var f=t.substring(c,l);if(p[f]=!0,s[f])s[f].forEach(function(e){return u.push(e)});else{var h=i&&z.actualUnit(i),d=new Y.StringTypeDeclarationImpl(f);d.setName(f);var m=d.highLevel();m.lowLevel().setUnit(h),m.setParent(a),d.meta().setCalculated(),m.patchProp(o),u.push(d)}}return Object.keys(s).filter(function(e){return!p[e]}).forEach(function(e){return s[e].forEach(function(e){return u.push(e)})}),u}function W(e){var t=e.schema();if(null==t)return null;var n=t.value();if(!n)return null;if(ee.stringStartsWith(n,"{")||ee.stringStartsWith(n,"[")||ee.stringStartsWith(n,"<"))return n;var r=e.highLevel(),i=r.root(),a=i.elementsOfKind($.Universe08.Api.properties.schemas.name),o=ae.find(a,function(e){return e.name()==n});if(!o)return n;if(!o.getKind||o.getKind()!=X.NodeKind.NODE)return n;if(o.definition().key()!=$.Universe08.GlobalSchema)return n;var s=o.attr($.Universe08.GlobalSchema.properties.value.name);return null==s?null:s.value()}function H(e){var t=e.highLevel();if(null==t)return null;var n=t.lowLevel();if(null==n)return null;var r=n.children().filter(function(e){return e.key().indexOf("<<")>=0});if(0==r.length)return null;var i=new G.TypeInstanceImpl(r);return i}Object.defineProperty(t,"__esModule",{value:!0});var Y=n(258),q=n(257),G=n(219),X=n(198),z=n(55),$=n(204),J=n(217),Q=n(199),Z=n(19),ee=n(15),te=n(209),ne=n(205),re=n(4),ie=n(6),ae=n(16),oe=n(207);t.load=r,t.expandTraitsAndResourceTypes=i,t.completeRelativeUri=a,t.absoluteUri=o,t.qName=s,t.traitsPrimary=u,t.allTraits=l,t.resourceTypesPrimary=p,t.allResourceTypes=c,t.relativeUriSegments=h,t.parentResource=d,t.parent=m,t.childResource=y,t.getResource=v,t.childMethod=g,t.getMethod=A,t.ownerApi=_,t.methodId=T,t.isOkRange=S,t.allResources=N;t.uriParametersPrimary=I,t.uriParameters=b,t.baseUriParametersPrimary=R,t.baseUriParameters=M,t.absoluteUriParameters=C,t.protocolsPrimary=w,t.allProtocols=P,t.securedByPrimary=L,t.allSecuredBy=O,t.securitySchemeName=D,t.securityScheme=U,t.RAMLVersion=x,t.structuredValue=k,t.referenceName=F,t.referencedTrait=B,t.referencedResourceType=V,t.schemaContent=W,t.getTemplateParametrizedProperties=H},function(e,t,n){(function(e,r){!function(i){"use strict";function a(e,t){e=Array.isArray(e)?e:[e];var n,r;for(n=0;n<e.length;n++){var i=e[n];if(r="function"==typeof i?i():i,!r)throw t=t||"Failed contract requirement:".concat(i),new Error("function"==typeof t?t():t)}}function o(e,t,n){n=Array.isArray(n)?n:[n];for(var r,i=t,a=e.length,o=n.length;++i<a;)for(r=-1;++r<o;)if(e[i]===n[r])return i;return-1}function s(e,t,n,r){var i=t-1,a=-1,o=r.length;if(n-t<o)throw new Error("Expected `".concat(r,"` beginning at character ",t,"."));for(;++i<n&&++a<o;)if(e[i]!==r[a])throw new Error("Unexpected character at position ".concat(i," expected `",r,"` beginning at position ",t,"."))}function u(e,t,n){var r=e[t],i=t,a=e.length,o=[];for(o.push(t);++i<a;)if(e[i]===r)o.push(t);else if(e[i]===n&&(o.pop(),0===o.length))break;if(o.length)throw new Error("Expected `".concat(e[0],"` to have a matching `",n,"`."));return i}function l(e,t){var n=t.cursor,r=t.result,a=e.length,s=o(e,n,["]","["]);s<n&&(s=a);var u=i.create(e.substring(n,s));r.push(function(e,t){t=t||[];var n=u.get(e);return"undefined"!=typeof n&&t.push(n),t}),t.cursor=s-1}function p(e,t,n){s(e,t.cursor,e.length,n)}function c(e,t,n){for(var r,i,a,o=-1,s=Array.isArray(e)?e:[e],u=t.length;++o<u&&s.length;){for(i=-1,a=s.length,r=[];++i<a;)r=t[o](s[i],r,n);s=r}return s}function f(e,t,n,r){n=n||[];var i,a,o,s=-1;if("object"==typeof e&&null!==e&&(o=c(e,t,r),o.length&&(n=n.concat(o)),!Array.isArray(e)))for(i=Object.keys(e),a=i.length;++s<a;)n=f(e[i[s]],t,n,r);return n}function h(e,t){var n=t.result,r=[];t.result=r,n.push(function(e,t,n){return f(e,r,t,n)}),S(e,t),t.result=n}function d(e,t){if(t=t||[],"object"==typeof e&&null!==e)if(Array.isArray(e))t=t.concat(e);else for(var n=-1,r=Object.keys(e),i=r.length;++n<i;)t.push(e[r[n]]);return t}function m(e,t,n){for(var r,o,s,u=-1,l=e.length,p={},c=[];++u<l;)switch(r=e[u],a([!1],"Expressions are not implemented in this version."),r){case"#":o=e.indexOf(" ",u),o<u&&(o=l),s=e.substring(u,o),p[s]||(p[s]=i.create(s)),c.push({kind:"v",ref:p[s]}),u=o}}function y(e,t){var n="!"===e[t.cursor];n&&t.cursor++,p(e,t,"{");var r=u(e,t.cursor,"}"),i=e.substring(t.cursor+1,r);t.result.push(m(i,n,t.offset)),t.cursor=r}function v(e,t){var n=t.cursor,r=(t.result,e.length),i=e.indexOf("]",n);i<n&&(i=r);var a=e.substring(n,i);t.result.push(function(e,t,n){var r;if(e){if(0===a.length&&"function"==typeof n?r=n:"object"==typeof n&&n&&(r=!n[a]&&n.RESOLVER?n.RESOLVER(a):n[a]),!r)throw new Error("Missing user-supplied function: `".concat(a.length?a:"@","`."));return r(e,t,n)}return t}),t.cursor=i-1}function g(e){var t={result:[],stack:[],cursor:-1,offset:0};return S(e,t),t.result}function A(e,t){var n=t.cursor,r=e.indexOf(")",n);s(e,n,r,"take("),n+=5;for(var a,o=e.slice(n,r).split(","),u=-1,l=o.length;++u<l;){if(a=o[u].split("="),1===a.length)a=i.create(a[0]),a={name:a.path[a.path.length-1],ptr:a};else{if(2!==a.length)throw new Error("Invalid `take` expression");a={name:a[0],ptr:i.create(a[1])}}n+=o[u].length,o[u]=a}t.result.push(function(e,t){t=t||[];for(var n={},r=-1,i=o.length;++r<i;)n[o[r].name]=o[r].ptr.get(e);return t.push(n),t}),t.cursor=r}function E(e,t,n){for(var r=t;e[r]>="0"&&e[r]<="9";)r+=1;if(r===t)throw new Error("Expected an integer at position ".concat(r,"."));return r-t}function _(e,t,n,r,i){var a,o=1;return s(e,t,n,r),t+=r.length-1,"("===e[t+1]&&(t+=2,a=E(e,t,n),o=parseInt(e.substring(t,t+a),10),t+=a,s(e,t,n,")"),++t),i.push({kind:r[0],index:o}),t}function T(e,t){var n=t.cursor-1,r=e.length,i=e.indexOf("]",t.cursor),a=null,o=!1,u=[];for(i<n&&(i=r);++n<i;)switch(e[n]){case" ":null!==a&&(u.push({kind:"i",index:parseInt(e.substring(a,n),10)}),a=null,o=!0);break;case",":null!==a&&(u.push({kind:"i",index:parseInt(e.substring(a,n),10)}),a=null),o&&(o=!1);break;case".":s(e,n,i,".."),null!==a&&(u.push({kind:"s",index:parseInt(e.substring(a,n),10)}),a=null),n++,o&&(o=!1);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":if(o)throw new Error("Unexpected numeral at position ".concat(n," expected punctuation."));null===a&&(a=n);break;case"l":if(o)throw new Error("Unexpected numeral at position ".concat(n," expected punctuation."));n=_(e,n,i,"last",u);break;case"f":if(o)throw new Error("Unexpected numeral at position ".concat(n," expected punctuation."));n=_(e,n,i,"first",u);break;case"c":if(o)throw new Error("Unexpected numeral at position ".concat(n," expected punctuation."));n=_(e,n,i,"count",u)}null!==a&&u.push({kind:"i",index:parseInt(e.substring(a,n),10)}),t.result.push(function(e,t){if(t=t||[],Array.isArray(e))for(var n,r,i=-1,a=u.length,o=e.length;++i<a;){var s=u[i];switch(s.kind){case"c":t.push(o);break;case"f":for(n=-1;++n<s.index&&n<o;)t.push(e[n]);break;case"l":for(n=o,r=o-s.index;--n>=r&&n>0;)t.push(e[n]);break;case"i":case"s":if(s.index<o&&(t.push(e[s.index]),"s"===s.kind))for(n=s.index,r=++i<a?u[i].index:o-1;++n<=r;)t.push(e[n])}}return t}),t.cursor=i-1}function S(e,t){if(a(["string"==typeof e],"Selector must be a string."),0===e.length)return[];for(var n,r=e.length;++t.cursor<r;)switch(n=e[t.cursor]){case"/":case"#":l(e,t);break;case"[":t.stack.push(t.cursor);break;case"]":if(!t.stack.length)throw new Error("Unexpected `]` at cursor position ".concat(t.cursor,"."));t.stack.pop();break;case".":p(e,t,".."),++t.cursor,h(e,t);break;case"*":p(e,t,"*]"),t.result.push(d);break;case"{":case"!":y(e,t);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":T(e,t);break;case"l":T(e,t);break;case"f":T(e,t);break;case"c":T(e,t);break;case"t":A(e,t);break;case"@":t.cursor+=1,v(e,t);break;default:throw new Error("Unexpected character at position ".concat(t.cursor,": ",n,"."))}a([!t.stack.length],function(){return"Unexpected end; unclosed scope beginning at cursor position ".concat(t.stack.pop(),".")})}function N(e,t,n){return c(e,t,n)}function I(e){Object.defineProperties(this,{selectors:{value:g(e),enumerable:!0},resolve:{value:function(e,t){return c(e,this.selectors,t)},enumerable:!0}})}var b,R,M=[];"object"==typeof e&&e?(b=e,R=e.JsonPath):"undefined"!=typeof window?(b=window,R=window.JsonPath):b={},R&&M.push(function(){b.JsonPath===I&&(b.JsonPath=R,R=null)}),i?M.push(function(e){e&&(i=e)}):i||("undefined"!=typeof b.JsonPointer?(i=b.JsonPointer,M.push(function(e){e&&(i=e)})):i=n(261)),I.parseSelector=g,I.executeSelectors=N,I.create=function(e){return new I(e)},I.resolve=function(e,t,n){var r=g(t);return c(e,r,n)},I.noConflict=function(e){return M&&(M.forEach(function(t){t(e)}),M=null),I},"undefined"!=typeof r&&r&&"object"==typeof t&&t&&r.exports===t?r.exports=I:b.JsonPath=I}("undefined"!=typeof JsonPointer?JsonPointer:null)}).call(t,function(){return this}(),n(10)(e))},function(e,t,n){(function(e,n){!function(r){"use strict";function i(e){if("string"!=typeof e)throw new TypeError("Invalid type: JSON Pointers are represented as strings.");if(0===e.length)return[];if("/"!==e[0])throw new ReferenceError("Invalid JSON Pointer syntax. Non-empty pointer must begin with a solidus `/`.");for(var t=e.substring(1).split("/"),n=-1,r=t.length;++n<r;)t[n]=t[n].replace("~1","/").replace("~0","~");return t}function a(e){if(e&&!Array.isArray(e))throw new TypeError("Invalid type: path must be an array of segments.");if(0===e.length)return"";for(var t=[],n=-1,r=e.length;++n<r;)t.push(e[n].replace("~","~0").replace("/","~1"));return"/".concat(t.join("/"))}function o(e){if("string"!=typeof e)throw new TypeError("Invalid type: JSON Pointers are represented as strings.");if(0===e.length||"#"!==e[0])throw new ReferenceError("Invalid JSON Pointer syntax; URI fragment idetifiers must begin with a hash.");if(1===e.length)return[];if("/"!==e[1])throw new ReferenceError("Invalid JSON Pointer syntax.");for(var t=e.substring(2).split("/"),n=-1,r=t.length;++n<r;)t[n]=decodeURIComponent(t[n]).replace("~1","/").replace("~0","~");return t}function s(e){if(e&&!Array.isArray(e))throw new TypeError("Invalid type: path must be an array of segments.");if(0===e.length)return"#";for(var t=[],n=-1,r=e.length;++n<r;)t.push(encodeURIComponent(e[n].replace("~","~0").replace("/","~1")));return"#/".concat(t.join("/"))}function u(e,t){var n=t.length,r=0;if(0===n||n>1&&"0"===t[0])return-1;if(1===n&&"-"===t[0])return e.length;for(;++r<n;)if(t[r]<"0"||t[r]>"9")return-1;return parseInt(t,10)}function l(e,t){if("undefined"!=typeof e){var n,r,i=e,a=t.length,o=-1;if(a){for(;++o<a&&i;)if(n=t[o],Array.isArray(i)){if(isNaN(n))return;if(r=u(i,n),!(i.length>r))return;i=i[r]}else i=i[n];return i}return e}}function p(e,t,n,i){if(0===n.length)throw new Error("Cannot set the root object; assign it directly.");if("undefined"!=typeof e){var a,o,s,l=e,p=n.length,c=n.length-1,f=-1;if(!p)return l;for(;++f<p;)if(a=n[f],Array.isArray(l)){if(o=u(l,a),!(l.length>o)){if(l.length===o)return l.push(t),r;throw new ReferenceError("Not found: ".concat(i(n.slice(0,f+1),!0),"."))}if(f===c)return s=l[o],l[o]=t,s;l=l[o]}else{if(f===c)return s=l[a],l[a]=t,s;if(l=l[a],"undefined"==typeof l)throw new ReferenceError("Not found: ".concat(i(n.slice(0,f+1),!0),"."))}if(f===p)return l}}function c(e){if(this.encode=e.length>0&&"#"===e[0]?s:a,Array.isArray(e))this.path=e;else{var t=e.length>0&&"#"===e[0]?o:i;this.path=t(e)}}var f,h,d=[];"object"==typeof e&&e?(f=e,h=e.JsonPointer):"undefined"!=typeof window?(f=window,h=window.JsonPointer):f={},h&&d.push(function(){f.JsonPointer===c&&(f.JsonPointer=h,
h=r)}),Object.defineProperty(c.prototype,"pointer",{enumerable:!0,get:function(){return a(this.path)}}),Object.defineProperty(c.prototype,"uriFragmentIdentifier",{enumerable:!0,get:function(){return s(this.path)}}),c.prototype.get=function(e){return l(e,this.path)},c.prototype.set=function(e,t){return p(e,t,this.path,this.encode)},c.prototype.toString=function(){return this.pointer},c.create=function(e){return new c(e)},c.get=function(e,t){var n=t.length>0&&"#"===t[0]?o:i;return l(e,n(t))},c.set=function(e,t,n){var r=t.length>0&&"#"===t[0]?s:a,u=t.length>0&&"#"===t[0]?o:i;return p(e,n,u(t),r)},c.decodePointer=i,c.encodePointer=a,c.decodeUriFragmentIdentifier=o,c.encodeUriFragmentIdentifier=s,c.noConflict=function(){return d&&(d.forEach(function(e){e()}),d=null),c},"undefined"!=typeof n&&n&&"object"==typeof t&&t&&n.exports===t?n.exports=c:f.JsonPointer=c}()}).call(t,function(){return this}(),n(10)(e))},function(e,t,n){"use strict";function r(e){return a.isWebPath(e)}Object.defineProperty(t,"__esModule",{value:!0});var i=n(6),a=n(5),o=n(212),s=function(){function e(e){this.unit=e}return e.prototype.contextPath=function(){if(!this.unit)return"";var e=this.unit.absolutePath();return e||""},e.prototype.normalizePath=function(e){if(!e)return e;var t;if(r(e)){var n=0===e.toLowerCase().indexOf("https")?"https://":"http://";t=n+i.normalize(e.substring(n.length)).replace(/\\/g,"/")}else t=i.normalize(e).replace(/\\/g,"/");return t},e.prototype.content=function(e){var t=this.normalizePath(e),n=this.toRelativeIfNeeded(t),r=this.unit.resolve(n);return r?r.contents()||"":""},e.prototype.contentAsync=function(e){var t=this.normalizePath(e),n=this.toRelativeIfNeeded(t),r=this.unit.resolveAsync(n);if(!r)return Promise.resolve("");var i=r.then(function(e){return e&&e.contents()||""});return i},e.prototype.toRelativeIfNeeded=function(e){var t=e;return!i.isAbsolute(e)||r(e)||r(this.unit.absolutePath())||(t=i.relative(i.dirname(this.unit.absolutePath()),e)),t},e.prototype.hasAsyncRequests=function(){return o.hasAsyncRequests()},e.prototype.resolvePath=function(e,t){return a.buildPath(t,e,this.unit.project().getRootPath())},e.prototype.isAbsolutePath=function(e){return!!e&&(!!r(e)||i.isAbsolute(e))},e.prototype.promiseResolve=function(e){return Promise.resolve(e)},e.prototype.rootPath=function(){return this.unit.project().getRootPath()},e.prototype.isWebPath=function(e){return a.isWebPath(e)},e.prototype.relativePath=function(e,t){return i.relative(e,t)},e}();t.ContentProvider=s},function(e,t,n){"use strict";function r(){return l.hasAsyncRequests()}function i(e){l.addLoadCallback(e)}function a(){return h.getTransformNames()}function o(e){return p.getFragmentDefenitionName(e)}function s(e,t,n){if(c.ReferenceType.isInstance(n.range())){var r=(n.range(),f.createNode(e));return new p.StructuredValue(r,t,n)}return e}function u(e){return(new d.UrlParameterNameValidator).parseUrl(e)}Object.defineProperty(t,"__esModule",{value:!0});var l=n(212),p=n(55),c=n(56),f=n(4),h=n(217),d=n(19),m=n(208),y=n(204);t.hasAsyncRequests=r,t.addLoadCallback=i,t.getTransformerNames=a,t.updateType=function(e){var t=m.doDescrimination(e);null==t&&e.property()&&(t=e.property().range()),t&&e.patchType(t)},t.getFragmentDefenitionName=o,t.genStructuredValue=s,t.parseUrl=u;var v=function(){function e(e,t){this.node=e,this.targetUnitRoot=t}return e}();t.UnitLink=v;var g=function(){function e(e,t){this.errors=e,this.primaryUnitRoot=t}return e.prototype.accept=function(e){this.transformIssue(e),this.errors.push(e)},e.prototype.transformIssue=function(e){var t=this,n=null,r=this.findIssueTail(e);r.node&&(n=r.node.lowLevel().unit());var i=this.primaryUnitRoot.lowLevel().unit();if(n&&i&&n!=i){var a=this.findPathToNodeUnit(this.primaryUnitRoot,r.node);if(a&&a.length>0){var o=a.map(function(n){return t.convertConnectingNodeToError(n,e)});if(o&&o.length>0)for(var s=r,u=o.length-1;u>=0;u--){var l=o[u];s.extras=[],s.extras.push(l),s=l}}}},e.prototype.begin=function(){},e.prototype.end=function(){},e.prototype.acceptUnique=function(e){for(var t=0,n=this.errors;t<n.length;t++){var r=n[t];if(r.start==e.start&&r.message==e.message)return}this.accept(e)},e.prototype.findPathToNodeUnit=function(e,t){return t.lowLevel()&&t.lowLevel().unit()?this.findPathToNodeUnitRecursively(e,t.lowLevel().unit()):[]},e.prototype.findPathToNodeUnitRecursively=function(e,t){for(var n=this.findUnitLinks(e),r=0;r<n.length;r++){var i=n[r];if(i.targetUnitRoot&&i.targetUnitRoot.lowLevel()&&i.targetUnitRoot.lowLevel().unit()==t)return[i.node];var a=this.findPathToNodeUnitRecursively(i.targetUnitRoot,t);if(a)return a.unshift(i.node),a}return null},e.prototype.findUnitLinks=function(e){var t=[];return t=t.concat(this.findMasterLinks(e))},e.prototype.findMasterLinks=function(e){if(!e.getMaster)return[];var t=e.getMaster();if(!t)return[];var n=e.asElement().attr(y.Universe10.Extension.properties.extends.name);return n&&n.value()?[new v(n,t)]:[]},e.prototype.convertConnectingNodeToError=function(e,t){if(!e)return null;var n=e.lowLevel(),r=n.start(),i=n.end(),a=this.generateLinkMessageByNode(e,t);return{code:t.code,isWarning:t.isWarning,message:a,node:e,start:r,end:i,path:n.unit()?n.unit().path():"",extras:[],unit:n.unit()}},e.prototype.generateLinkMessageByNode=function(e,t){return e.property().nameId()==y.Universe10.Extension.properties.extends.name?"Error in the master file: "+t.message:t.message},e.prototype.findIssueTail=function(e){return e.extras&&0!=e.extras.length?this.findIssueTail(e.extras[0]):e},e}();t.PointOfViewValidationAcceptorImpl=g},function(e,t,n){"use strict";var r=n(56);e.exports=r.getUniverse},function(e,t){},function(e,t,n){"use strict";var r=n(19),i=n(207),a=function(){function e(){this.uriToResources={},this.conflictingUriToResources={}}return e.prototype.validateApi=function(e,t){var n=this,a=e.resources();a.forEach(function(e){n.acceptResource(e);var t=e.resources();t.forEach(function(e){return n.acceptResource(e)})});for(var o in this.conflictingUriToResources){var a=this.conflictingUriToResources[o];if(a.length>1){var s={};a.forEach(function(e){var t=e.highLevel(),n="";null!=t.parent()&&(n+=t.parent().id()+"."),n+=t.localId();var r=s[n];null==r&&(r=[],s[n]=r),r.push(e)});var u=Object.keys(s);u.length>1&&a.forEach(function(e){t.accept(r.createIssue1(i.RESOURCES_SHARE_SAME_URI,{},e.highLevel(),!1))})}}},e.prototype.acceptResource=function(e){var t=e.absoluteUri(),n=this.uriToResources[t];n||(n=[],this.uriToResources[t]=n),n.push(e),n.length>1&&(this.conflictingUriToResources[t]=n)},e}();e.exports=a},function(e,t,n){"use strict";function r(e,t,n){null==n&&(n=i(e)),n.length>0&&(n+=":");for(var r=e.getElementsByTagName(n+t),a=[],o=0;o<r.length;o++){var s=r[o];s.parentNode===e&&a.push(s)}return a}function i(e){var t="";if(e){var n=e;if(e.ownerDocument&&(n=e.ownerDocument),n){var r=n.documentElement;r&&(t=r.prefix)}}return t}function a(e){try{if(e=e.trim(),!c.stringStartsWith(e,"<")&&c.stringEndsWith(e,">"))return!1;var t=new p.DOMParser(f).parseFromString(e),n=r(t,"schema",i(t));return n.length>0}catch(e){return!1}}function o(e){var t={};if(1==e.nodeType){if(e.attributes.length>0)for(var n=0;n<e.attributes.length;n++){var r=e.attributes.item(n);t["@"+r.nodeName]=r.nodeValue}}else 3==e.nodeType&&(t=e.nodeValue);if(e.hasChildNodes())for(var i=0;i<e.childNodes.length;i++){var a=e.childNodes.item(i),s=a.nodeName;if(void 0!=s)if("undefined"==typeof t[s])t[s]=o(a);else{if("undefined"==typeof t[s].push){var u=t[s];t[s]=[],t[s].push(u)}t[s].push(o(a))}}return t}function s(e){if("object"==typeof e)for(var t in e)if("object"==typeof e[t]){for(var n in e[t])if("#text"==n){var r=e[t]["#text"];"string"!=typeof r&&(r=r.join("")),r=r.trim(),0==r.length&&delete e[t]["#text"]}s(e[t])}return e}function u(e){if("object"==typeof e)for(var t in e)if("object"==typeof e[t]){var n=Object.keys(e[t]);1==n.length&&"#text"==n[0]&&(e[t]=e[t]["#text"]),u(e[t])}return e}function l(e,t){var n=t?{errorHandler:t}:f,r=new p.DOMParser(n);if(!e||0==e.trim().indexOf("<<"))return null;var i=r.parseFromString(e);return u(s(o(i)))}Object.defineProperty(t,"__esModule",{value:!0});var p=n(268),c=n(15),f={errorHandler:{warning:function(){return null},error:function(){return null},fatalError:function(){return null}}};t.isXmlScheme=a,t.parseXML=l},function(e,t,n){function r(e){this.options=e||{locator:{}}}function i(e,t,n){function r(t){var r=e[t];!r&&o&&(r=2==e.length?function(n){e(t,n)}:e),i[t]=r&&function(e){r("[xmldom "+t+"]\t"+e+s(n))}||function(){}}if(!e){if(t instanceof a)return t;e=t}var i={},o=e instanceof Function;return n=n||{},r("warning"),r("error"),r("fatalError"),i}function a(){this.cdata=!1}function o(e,t){t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber}function s(e){if(e)return"\n@"+(e.systemId||"")+"#[line:"+e.lineNumber+",col:"+e.columnNumber+"]"}function u(e,t,n){return"string"==typeof e?e.substr(t,n):e.length>=t+n||t?new java.lang.String(e,t,n)+"":e}function l(e,t){e.currentElement?e.currentElement.appendChild(t):e.doc.appendChild(t)}r.prototype.parseFromString=function(e,t){var n=this.options,r=new p,o=n.domBuilder||new a,s=n.errorHandler,u=n.locator,l=n.xmlns||{},c={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return u&&o.setDocumentLocator(u),r.errorHandler=i(s,o,u),r.domBuilder=n.domBuilder||o,/\/x?html?$/.test(t)&&(c.nbsp=" ",c.copy="©",l[""]="http://www.w3.org/1999/xhtml"),l.xml=l.xml||"http://www.w3.org/XML/1998/namespace",e?r.parse(e,l,c):r.errorHandler.error("invalid doc source"),o.doc},a.prototype={startDocument:function(){this.doc=(new c).createDocument(null,null,null),this.locator&&(this.doc.documentURI=this.locator.systemId)},startElement:function(e,t,n,r){var i=this.doc,a=i.createElementNS(e,n||t),s=r.length;l(this,a),this.currentElement=a,this.locator&&o(this.locator,a);for(var u=0;u<s;u++){var e=r.getURI(u),p=r.getValue(u),n=r.getQName(u),c=i.createAttributeNS(e,n);this.locator&&o(r.getLocator(u),c),c.value=c.nodeValue=p,a.setAttributeNode(c)}},endElement:function(e,t,n){var r=this.currentElement;r.tagName;this.currentElement=r.parentNode},startPrefixMapping:function(e,t){},endPrefixMapping:function(e){},processingInstruction:function(e,t){var n=this.doc.createProcessingInstruction(e,t);this.locator&&o(this.locator,n),l(this,n)},ignorableWhitespace:function(e,t,n){},characters:function(e,t,n){if(e=u.apply(this,arguments)){if(this.cdata)var r=this.doc.createCDATASection(e);else var r=this.doc.createTextNode(e);this.currentElement?this.currentElement.appendChild(r):/^\s*$/.test(e)&&this.doc.appendChild(r),this.locator&&o(this.locator,r)}},skippedEntity:function(e){},endDocument:function(){this.doc.normalize()},setDocumentLocator:function(e){(this.locator=e)&&(e.lineNumber=0)},comment:function(e,t,n){e=u.apply(this,arguments);var r=this.doc.createComment(e);this.locator&&o(this.locator,r),l(this,r)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(e,t,n){var r=this.doc.implementation;if(r&&r.createDocumentType){var i=r.createDocumentType(e,t,n);this.locator&&o(this.locator,i),l(this,i)}},warning:function(e){console.warn("[xmldom warning]\t"+e,s(this.locator))},error:function(e){console.error("[xmldom error]\t"+e,s(this.locator))},fatalError:function(e){throw console.error("[xmldom fatalError]\t"+e,s(this.locator)),e}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(e){a.prototype[e]=function(){return null}});var p=n(269).XMLReader,c=t.DOMImplementation=n(270).DOMImplementation;t.XMLSerializer=n(270).XMLSerializer,t.DOMParser=r},function(e,t){function n(){}function r(e,t,n,r,l){function h(e){if(e>65535){e-=65536;var t=55296+(e>>10),n=56320+(1023&e);return String.fromCharCode(t,n)}return String.fromCharCode(e)}function d(e){var t=e.slice(1,-1);return t in n?n[t]:"#"===t.charAt(0)?h(parseInt(t.substr(1).replace("x","0x"))):(l.error("entity not found:"+e),e)}function m(t){if(t>S){var n=e.substring(S,t).replace(/&#?\w+;/g,d);E&&y(S),r.characters(n,0,t-S),S=t}}function y(t,n){for(;t>=g&&(n=A.exec(e));)v=n.index,g=v+n[0].length,E.lineNumber++;E.columnNumber=t-v+1}for(var v=0,g=0,A=/.*(?:\r\n?|\n)|.*$/g,E=r.locator,_=[{currentNSMap:t}],T={},S=0;;){try{var N=e.indexOf("<",S);if(N<0){if(!e.substr(S).match(/^\s*$/)){var I=r.doc,b=I.createTextNode(e.substr(S));I.appendChild(b),r.currentElement=b}return}switch(N>S&&m(N),e.charAt(N+1)){case"/":var R=e.indexOf(">",N+3),M=e.substring(N+2,R),C=_.pop();R<0?(M=e.substring(N+2).replace(/[\s<].*/,""),l.error("end tag name: "+M+" is not complete:"+C.tagName),R=N+1+M.length):M.match(/\s</)&&(M=M.replace(/[\s<].*/,""),l.error("end tag name: "+M+" maybe not complete"),R=N+1+M.length);var w=C.localNSMap,P=C.tagName==M,L=P||C.tagName&&C.tagName.toLowerCase()==M.toLowerCase();if(L){if(r.endElement(C.uri,C.localName,M),w)for(var O in w)r.endPrefixMapping(O);P||l.fatalError("end tag name: "+M+" is not match the current start tagName:"+C.tagName)}else _.push(C);R++;break;case"?":E&&y(N),R=c(e,N,r);break;case"!":E&&y(N),R=p(e,N,r,l);break;default:E&&y(N);var D=new f,U=_[_.length-1].currentNSMap,R=a(e,N,D,U,d,l),x=D.length;if(!D.closed&&u(e,R,D.tagName,T)&&(D.closed=!0,n.nbsp||l.warning("unclosed xml attribute")),E&&x){for(var k=i(E,{}),F=0;F<x;F++){var B=D[F];y(B.offset),B.locator=i(E,{})}r.locator=k,o(D,r,U)&&_.push(D),r.locator=E}else o(D,r,U)&&_.push(D);"http://www.w3.org/1999/xhtml"!==D.uri||D.closed?R++:R=s(e,R,D.tagName,d,r)}}catch(e){l.error("element parse error: "+e),R=-1}R>S?S=R:m(Math.max(N,S)+1)}}function i(e,t){return t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber,t}function a(e,t,n,r,i,a){for(var o,s,u=++t,l=g;;){var p=e.charAt(u);switch(p){case"=":if(l===A)o=e.slice(t,u),l=_;else{if(l!==E)throw new Error("attribute equal must after attrName");l=_}break;case"'":case'"':if(l===_||l===A){if(l===A&&(a.warning('attribute value must after "="'),o=e.slice(t,u)),t=u+1,u=e.indexOf(p,t),!(u>0))throw new Error("attribute value no end '"+p+"' match");s=e.slice(t,u).replace(/&#?\w+;/g,i),n.add(o,s,t-1),l=S}else{if(l!=T)throw new Error('attribute value must after "="');s=e.slice(t,u).replace(/&#?\w+;/g,i),n.add(o,s,t),a.warning('attribute "'+o+'" missed start quot('+p+")!!"),t=u+1,l=S}break;case"/":switch(l){case g:n.setTagName(e.slice(t,u));case S:case N:case I:l=I,n.closed=!0;case T:case A:case E:break;default:throw new Error("attribute invalid close char('/')")}break;case"":return a.error("unexpected end of input"),l==g&&n.setTagName(e.slice(t,u)),u;case">":switch(l){case g:n.setTagName(e.slice(t,u));case S:case N:case I:break;case T:case A:s=e.slice(t,u),"/"===s.slice(-1)&&(n.closed=!0,s=s.slice(0,-1));case E:l===E&&(s=o),l==T?(a.warning('attribute "'+s+'" missed quot(")!!'),n.add(o,s.replace(/&#?\w+;/g,i),t)):("http://www.w3.org/1999/xhtml"===r[""]&&s.match(/^(?:disabled|checked|selected)$/i)||a.warning('attribute "'+s+'" missed value!! "'+s+'" instead!!'),n.add(s,s,t));break;case _:throw new Error("attribute value missed!!")}return u;case"":p=" ";default:if(p<=" ")switch(l){case g:n.setTagName(e.slice(t,u)),l=N;break;case A:o=e.slice(t,u),l=E;break;case T:var s=e.slice(t,u).replace(/&#?\w+;/g,i);a.warning('attribute "'+s+'" missed quot(")!!'),n.add(o,s,t);case S:l=N}else switch(l){case E:n.tagName;"http://www.w3.org/1999/xhtml"===r[""]&&o.match(/^(?:disabled|checked|selected)$/i)||a.warning('attribute "'+o+'" missed value!! "'+o+'" instead2!!'),n.add(o,o,t),t=u,l=A;break;case S:a.warning('attribute space is required"'+o+'"!!');case N:l=A,t=u;break;case _:l=T,t=u;break;case I:throw new Error("elements closed character '/' and '>' must be connected to")}}u++}}function o(e,t,n){for(var r=e.tagName,i=null,a=e.length;a--;){var o=e[a],s=o.qName,u=o.value,p=s.indexOf(":");if(p>0)var c=o.prefix=s.slice(0,p),f=s.slice(p+1),h="xmlns"===c&&f;else f=s,c=null,h="xmlns"===s&&"";o.localName=f,h!==!1&&(null==i&&(i={},l(n,n={})),n[h]=i[h]=u,o.uri="http://www.w3.org/2000/xmlns/",t.startPrefixMapping(h,u))}for(var a=e.length;a--;){o=e[a];var c=o.prefix;c&&("xml"===c&&(o.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==c&&(o.uri=n[c||""]))}var p=r.indexOf(":");p>0?(c=e.prefix=r.slice(0,p),f=e.localName=r.slice(p+1)):(c=null,f=e.localName=r);var d=e.uri=n[c||""];if(t.startElement(d,f,r,e),!e.closed)return e.currentNSMap=n,e.localNSMap=i,!0;if(t.endElement(d,f,r),i)for(c in i)t.endPrefixMapping(c)}function s(e,t,n,r,i){if(/^(?:script|textarea)$/i.test(n)){var a=e.indexOf("</"+n+">",t),o=e.substring(t+1,a);if(/[&<]/.test(o))return/^script$/i.test(n)?(i.characters(o,0,o.length),a):(o=o.replace(/&#?\w+;/g,r),i.characters(o,0,o.length),a)}return t+1}function u(e,t,n,r){var i=r[n];return null==i&&(i=e.lastIndexOf("</"+n+">"),i<t&&(i=e.lastIndexOf("</"+n)),r[n]=i),i<t}function l(e,t){for(var n in e)t[n]=e[n]}function p(e,t,n,r){var i=e.charAt(t+2);switch(i){case"-":if("-"===e.charAt(t+3)){var a=e.indexOf("-->",t+4);return a>t?(n.comment(e,t+4,a-t-4),a+3):(r.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==e.substr(t+3,6)){var a=e.indexOf("]]>",t+9);return n.startCDATA(),n.characters(e,t+9,a-t-9),n.endCDATA(),a+3}var o=d(e,t),s=o.length;if(s>1&&/!doctype/i.test(o[0][0])){var u=o[1][0],l=s>3&&/^public$/i.test(o[2][0])&&o[3][0],p=s>4&&o[4][0],c=o[s-1];return n.startDTD(u,l&&l.replace(/^(['"])(.*?)\1$/,"$2"),p&&p.replace(/^(['"])(.*?)\1$/,"$2")),n.endDTD(),c.index+c[0].length}}return-1}function c(e,t,n){var r=e.indexOf("?>",t);if(r){var i=e.substring(t,r).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(i){i[0].length;return n.processingInstruction(i[1],i[2]),r+2}return-1}return-1}function f(e){}function h(e,t){return e.__proto__=t,e}function d(e,t){var n,r=[],i=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(i.lastIndex=t,i.exec(e);n=i.exec(e);)if(r.push(n),n[1])return r}var m=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,y=new RegExp("[\\-\\.0-9"+m.source.slice(1,-1)+"\\u00B7\\u0300-\\u036F\\u203F-\\u2040]"),v=new RegExp("^"+m.source+y.source+"*(?::"+m.source+y.source+"*)?$"),g=0,A=1,E=2,_=3,T=4,S=5,N=6,I=7;n.prototype={parse:function(e,t,n){var i=this.domBuilder;i.startDocument(),l(t,t={}),r(e,t,n,i,this.errorHandler),i.endDocument()}},f.prototype={setTagName:function(e){if(!v.test(e))throw new Error("invalid tagName:"+e);this.tagName=e},add:function(e,t,n){if(!v.test(e))throw new Error("invalid attribute:"+e);this[this.length++]={qName:e,value:t,offset:n}},length:0,getLocalName:function(e){return this[e].localName},getLocator:function(e){return this[e].locator},getQName:function(e){return this[e].qName},getURI:function(e){return this[e].uri},getValue:function(e){return this[e].value}},h({},h.prototype)instanceof h||(h=function(e,t){function n(){}n.prototype=t,n=new n;for(t in e)n[t]=e[t];return n}),t.XMLReader=n},function(e,t){function n(e,t){for(var n in e)t[n]=e[n]}function r(e,t){function r(){}var i=e.prototype;if(Object.create){var a=Object.create(t.prototype);i.__proto__=a}i instanceof t||(r.prototype=t.prototype,r=new r,n(i,r),e.prototype=i=r),i.constructor!=e&&("function"!=typeof e&&console.error("unknow Class:"+e),i.constructor=e)}function i(e,t){if(t instanceof Error)var n=t;else n=this,Error.call(this,ie[e]),this.message=ie[e],Error.captureStackTrace&&Error.captureStackTrace(this,i);return n.code=e,t&&(this.message=this.message+": "+t),n}function a(){}function o(e,t){this._node=e,this._refresh=t,s(this)}function s(e){var t=e._node._inc||e._node.ownerDocument._inc;if(e._inc!=t){var r=e._refresh(e._node);K(e,"length",r.length),n(r,e),e._inc=t}}function u(){}function l(e,t){for(var n=e.length;n--;)if(e[n]===t)return n}function p(e,t,n,r){if(r?t[l(t,r)]=n:t[t.length++]=n,e){n.ownerElement=e;var i=e.ownerDocument;i&&(r&&g(i,e,r),v(i,e,n))}}function c(e,t,n){var r=l(t,n);if(!(r>=0))throw i(oe,new Error(e.tagName+"@"+n));for(var a=t.length-1;r<a;)t[r]=t[++r];if(t.length=a,e){var o=e.ownerDocument;o&&(g(o,e,n),n.ownerElement=null)}}function f(e){if(this._features={},e)for(var t in e)this._features=e[t]}function h(){}function d(e){return"<"==e&&"&lt;"||">"==e&&"&gt;"||"&"==e&&"&amp;"||'"'==e&&"&quot;"||"&#"+e.charCodeAt()+";"}function m(e,t){if(t(e))return!0;if(e=e.firstChild)do if(m(e,t))return!0;while(e=e.nextSibling)}function y(){}function v(e,t,n){e&&e._inc++;var r=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==r&&(t._nsMap[n.prefix?n.localName:""]=n.value)}function g(e,t,n,r){e&&e._inc++;var i=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==i&&delete t._nsMap[n.prefix?n.localName:""]}function A(e,t,n){if(e&&e._inc){e._inc++;var r=t.childNodes;if(n)r[r.length++]=n;else{for(var i=t.firstChild,a=0;i;)r[a++]=i,i=i.nextSibling;r.length=a}}}function E(e,t){var n=t.previousSibling,r=t.nextSibling;return n?n.nextSibling=r:e.firstChild=r,r?r.previousSibling=n:e.lastChild=n,A(e.ownerDocument,e),t}function _(e,t,n){var r=t.parentNode;if(r&&r.removeChild(t),t.nodeType===te){var i=t.firstChild;if(null==i)return t;var a=t.lastChild}else i=a=t;var o=n?n.previousSibling:e.lastChild;i.previousSibling=o,a.nextSibling=n,o?o.nextSibling=i:e.firstChild=i,null==n?e.lastChild=a:n.previousSibling=a;do i.parentNode=e;while(i!==a&&(i=i.nextSibling));return A(e.ownerDocument||e,e),t.nodeType==te&&(t.firstChild=t.lastChild=null),t}function T(e,t){var n=t.parentNode;if(n){var r=e.lastChild;n.removeChild(t);var r=e.lastChild}var r=e.lastChild;return t.parentNode=e,t.previousSibling=r,t.nextSibling=null,r?r.nextSibling=t:e.firstChild=t,e.lastChild=t,A(e.ownerDocument,e,t),t}function S(){this._nsMap={}}function N(){}function I(){}function b(){}function R(){}function M(){}function C(){}function w(){}function P(){}function L(){}function O(){}function D(){}function U(){}function x(e,t){var n=[],r=9==this.nodeType?this.documentElement:this,i=r.prefix,a=r.namespaceURI;if(a&&null==i){var i=r.lookupPrefix(a);if(null==i)var o=[{namespace:a,prefix:null}]}return F(this,n,e,t,o),n.join("")}function k(e,t,n){var r=e.prefix||"",i=e.namespaceURI;if(!r&&!i)return!1;if("xml"===r&&"http://www.w3.org/XML/1998/namespace"===i||"http://www.w3.org/2000/xmlns/"==i)return!1;for(var a=n.length;a--;){var o=n[a];if(o.prefix==r)return o.namespace!=i}return!0}function F(e,t,n,r,i){if(r){if(e=r(e),!e)return;if("string"==typeof e)return void t.push(e)}switch(e.nodeType){case Y:i||(i=[]);var a=(i.length,e.attributes),o=a.length,s=e.firstChild,u=e.tagName;n=W===e.namespaceURI||n,t.push("<",u);for(var l=0;l<o;l++){var p=a.item(l);"xmlns"==p.prefix?i.push({prefix:p.localName,namespace:p.value}):"xmlns"==p.nodeName&&i.push({prefix:"",namespace:p.value})}for(var l=0;l<o;l++){var p=a.item(l);if(k(p,n,i)){var c=p.prefix||"",f=p.namespaceURI,h=c?" xmlns:"+c:" xmlns";t.push(h,'="',f,'"'),i.push({prefix:c,namespace:f})}F(p,t,n,r,i)}if(k(e,n,i)){var c=e.prefix||"",f=e.namespaceURI,h=c?" xmlns:"+c:" xmlns";t.push(h,'="',f,'"'),i.push({prefix:c,namespace:f})}if(s||n&&!/^(?:meta|link|img|br|hr|input)$/i.test(u)){if(t.push(">"),n&&/^script$/i.test(u))for(;s;)s.data?t.push(s.data):F(s,t,n,r,i),s=s.nextSibling;else for(;s;)F(s,t,n,r,i),s=s.nextSibling;t.push("</",u,">")}else t.push("/>");return;case Z:case te:for(var s=e.firstChild;s;)F(s,t,n,r,i),s=s.nextSibling;return;case q:return t.push(" ",e.name,'="',e.value.replace(/[<&"]/g,d),'"');case G:return t.push(e.data.replace(/[<&]/g,d));case X:return t.push("<![CDATA[",e.data,"]]>");case Q:return t.push("<!--",e.data,"-->");case ee:var m=e.publicId,y=e.systemId;if(t.push("<!DOCTYPE ",e.name),m)t.push(' PUBLIC "',m),y&&"."!=y&&t.push('" "',y),t.push('">');else if(y&&"."!=y)t.push(' SYSTEM "',y,'">');else{var v=e.internalSubset;v&&t.push(" [",v,"]"),t.push(">")}return;case J:return t.push("<?",e.target," ",e.data,"?>");case z:return t.push("&",e.nodeName,";");default:t.push("??",e.nodeName)}}function B(e,t,n){var r;switch(t.nodeType){case Y:r=t.cloneNode(!1),r.ownerDocument=e;case te:break;case q:n=!0}if(r||(r=t.cloneNode(!1)),r.ownerDocument=e,r.parentNode=null,n)for(var i=t.firstChild;i;)r.appendChild(B(e,i,n)),i=i.nextSibling;return r}function V(e,t,n){var r=new t.constructor;for(var i in t){var o=t[i];"object"!=typeof o&&o!=r[i]&&(r[i]=o)}switch(t.childNodes&&(r.childNodes=new a),r.ownerDocument=e,r.nodeType){case Y:var s=t.attributes,l=r.attributes=new u,p=s.length;l._ownerElement=r;for(var c=0;c<p;c++)r.setAttributeNode(V(e,s.item(c),!0));break;case q:n=!0}if(n)for(var f=t.firstChild;f;)r.appendChild(V(e,f,n)),f=f.nextSibling;return r}function K(e,t,n){e[t]=n}function j(e){switch(e.nodeType){case Y:case te:var t=[];for(e=e.firstChild;e;)7!==e.nodeType&&8!==e.nodeType&&t.push(j(e)),e=e.nextSibling;return t.join("");default:return e.nodeValue}}var W="http://www.w3.org/1999/xhtml",H={},Y=H.ELEMENT_NODE=1,q=H.ATTRIBUTE_NODE=2,G=H.TEXT_NODE=3,X=H.CDATA_SECTION_NODE=4,z=H.ENTITY_REFERENCE_NODE=5,$=H.ENTITY_NODE=6,J=H.PROCESSING_INSTRUCTION_NODE=7,Q=H.COMMENT_NODE=8,Z=H.DOCUMENT_NODE=9,ee=H.DOCUMENT_TYPE_NODE=10,te=H.DOCUMENT_FRAGMENT_NODE=11,ne=H.NOTATION_NODE=12,re={},ie={},ae=(re.INDEX_SIZE_ERR=(ie[1]="Index size error",1),re.DOMSTRING_SIZE_ERR=(ie[2]="DOMString size error",2),re.HIERARCHY_REQUEST_ERR=(ie[3]="Hierarchy request error",3)),oe=(re.WRONG_DOCUMENT_ERR=(ie[4]="Wrong document",4),re.INVALID_CHARACTER_ERR=(ie[5]="Invalid character",5),re.NO_DATA_ALLOWED_ERR=(ie[6]="No data allowed",6),re.NO_MODIFICATION_ALLOWED_ERR=(ie[7]="No modification allowed",7),re.NOT_FOUND_ERR=(ie[8]="Not found",8)),se=(re.NOT_SUPPORTED_ERR=(ie[9]="Not supported",9),re.INUSE_ATTRIBUTE_ERR=(ie[10]="Attribute in use",10));re.INVALID_STATE_ERR=(ie[11]="Invalid state",11),re.SYNTAX_ERR=(ie[12]="Syntax error",12),re.INVALID_MODIFICATION_ERR=(ie[13]="Invalid modification",13),re.NAMESPACE_ERR=(ie[14]="Invalid namespace",14),re.INVALID_ACCESS_ERR=(ie[15]="Invalid access",15);i.prototype=Error.prototype,n(re,i),a.prototype={length:0,item:function(e){return this[e]||null},toString:function(e,t){for(var n=[],r=0;r<this.length;r++)F(this[r],n,e,t);return n.join("")}},o.prototype.item=function(e){return s(this),this[e]},r(o,a),u.prototype={length:0,item:a.prototype.item,getNamedItem:function(e){for(var t=this.length;t--;){var n=this[t];if(n.nodeName==e)return n}},setNamedItem:function(e){var t=e.ownerElement;if(t&&t!=this._ownerElement)throw new i(se);var n=this.getNamedItem(e.nodeName);return p(this._ownerElement,this,e,n),n},setNamedItemNS:function(e){var t,n=e.ownerElement;if(n&&n!=this._ownerElement)throw new i(se);return t=this.getNamedItemNS(e.namespaceURI,e.localName),p(this._ownerElement,this,e,t),t},removeNamedItem:function(e){var t=this.getNamedItem(e);return c(this._ownerElement,this,t),t},removeNamedItemNS:function(e,t){var n=this.getNamedItemNS(e,t);return c(this._ownerElement,this,n),n},getNamedItemNS:function(e,t){for(var n=this.length;n--;){var r=this[n];if(r.localName==t&&r.namespaceURI==e)return r}return null}},f.prototype={hasFeature:function(e,t){var n=this._features[e.toLowerCase()];return!(!n||t&&!(t in n))},createDocument:function(e,t,n){var r=new y;if(r.implementation=this,r.childNodes=new a,r.doctype=n,n&&r.appendChild(n),t){var i=r.createElementNS(e,t);r.appendChild(i)}return r},createDocumentType:function(e,t,n){var r=new C;return r.name=e,r.nodeName=e,r.publicId=t,r.systemId=n,r}},h.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(e,t){return _(this,e,t)},replaceChild:function(e,t){this.insertBefore(e,t),t&&this.removeChild(t)},removeChild:function(e){return E(this,e)},appendChild:function(e){return this.insertBefore(e,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(e){return V(this.ownerDocument||this,this,e)},normalize:function(){for(var e=this.firstChild;e;){var t=e.nextSibling;t&&t.nodeType==G&&e.nodeType==G?(this.removeChild(t),e.appendData(t.data)):(e.normalize(),e=t)}},isSupported:function(e,t){return this.ownerDocument.implementation.hasFeature(e,t)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(e){for(var t=this;t;){var n=t._nsMap;if(n)for(var r in n)if(n[r]==e)return r;t=t.nodeType==q?t.ownerDocument:t.parentNode}return null},lookupNamespaceURI:function(e){for(var t=this;t;){var n=t._nsMap;if(n&&e in n)return n[e];t=t.nodeType==q?t.ownerDocument:t.parentNode}return null},isDefaultNamespace:function(e){var t=this.lookupPrefix(e);return null==t}},n(H,h),n(H,h.prototype),y.prototype={nodeName:"#document",nodeType:Z,doctype:null,documentElement:null,_inc:1,insertBefore:function(e,t){if(e.nodeType==te){for(var n=e.firstChild;n;){var r=n.nextSibling;this.insertBefore(n,t),n=r}return e}return null==this.documentElement&&e.nodeType==Y&&(this.documentElement=e),_(this,e,t),e.ownerDocument=this,e},removeChild:function(e){return this.documentElement==e&&(this.documentElement=null),E(this,e)},importNode:function(e,t){return B(this,e,t)},getElementById:function(e){var t=null;return m(this.documentElement,function(n){if(n.nodeType==Y&&n.getAttribute("id")==e)return t=n,!0}),t},createElement:function(e){var t=new S;t.ownerDocument=this,t.nodeName=e,t.tagName=e,t.childNodes=new a;var n=t.attributes=new u;return n._ownerElement=t,t},createDocumentFragment:function(){var e=new O;return e.ownerDocument=this,e.childNodes=new a,e},createTextNode:function(e){var t=new b;return t.ownerDocument=this,t.appendData(e),t},createComment:function(e){var t=new R;return t.ownerDocument=this,t.appendData(e),t},createCDATASection:function(e){var t=new M;return t.ownerDocument=this,t.appendData(e),t},createProcessingInstruction:function(e,t){var n=new D;return n.ownerDocument=this,n.tagName=n.target=e,n.nodeValue=n.data=t,n},createAttribute:function(e){var t=new N;return t.ownerDocument=this,t.name=e,t.nodeName=e,t.localName=e,t.specified=!0,t},createEntityReference:function(e){var t=new L;return t.ownerDocument=this,t.nodeName=e,t},createElementNS:function(e,t){var n=new S,r=t.split(":"),i=n.attributes=new u;return n.childNodes=new a,n.ownerDocument=this,n.nodeName=t,n.tagName=t,n.namespaceURI=e,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,i._ownerElement=n,n},createAttributeNS:function(e,t){var n=new N,r=t.split(":");return n.ownerDocument=this,n.nodeName=t,n.name=t,n.namespaceURI=e,n.specified=!0,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,n}},r(y,h),S.prototype={nodeType:Y,hasAttribute:function(e){return null!=this.getAttributeNode(e)},getAttribute:function(e){var t=this.getAttributeNode(e);return t&&t.value||""},getAttributeNode:function(e){return this.attributes.getNamedItem(e)},setAttribute:function(e,t){var n=this.ownerDocument.createAttribute(e);n.value=n.nodeValue=""+t,this.setAttributeNode(n)},removeAttribute:function(e){var t=this.getAttributeNode(e);t&&this.removeAttributeNode(t)},appendChild:function(e){return e.nodeType===te?this.insertBefore(e,null):T(this,e)},setAttributeNode:function(e){return this.attributes.setNamedItem(e)},setAttributeNodeNS:function(e){return this.attributes.setNamedItemNS(e)},removeAttributeNode:function(e){return this.attributes.removeNamedItem(e.nodeName)},removeAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);n&&this.removeAttributeNode(n)},hasAttributeNS:function(e,t){return null!=this.getAttributeNodeNS(e,t)},getAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);return n&&n.value||""},setAttributeNS:function(e,t,n){var r=this.ownerDocument.createAttributeNS(e,t);r.value=r.nodeValue=""+n,this.setAttributeNode(r)},getAttributeNodeNS:function(e,t){return this.attributes.getNamedItemNS(e,t)},getElementsByTagName:function(e){return new o(this,function(t){var n=[];return m(t,function(r){r===t||r.nodeType!=Y||"*"!==e&&r.tagName!=e||n.push(r)}),n})},getElementsByTagNameNS:function(e,t){return new o(this,function(n){var r=[];return m(n,function(i){i===n||i.nodeType!==Y||"*"!==e&&i.namespaceURI!==e||"*"!==t&&i.localName!=t||r.push(i);
}),r})}},y.prototype.getElementsByTagName=S.prototype.getElementsByTagName,y.prototype.getElementsByTagNameNS=S.prototype.getElementsByTagNameNS,r(S,h),N.prototype.nodeType=q,r(N,h),I.prototype={data:"",substringData:function(e,t){return this.data.substring(e,e+t)},appendData:function(e){e=this.data+e,this.nodeValue=this.data=e,this.length=e.length},insertData:function(e,t){this.replaceData(e,0,t)},appendChild:function(e){throw new Error(ie[ae])},deleteData:function(e,t){this.replaceData(e,t,"")},replaceData:function(e,t,n){var r=this.data.substring(0,e),i=this.data.substring(e+t);n=r+n+i,this.nodeValue=this.data=n,this.length=n.length}},r(I,h),b.prototype={nodeName:"#text",nodeType:G,splitText:function(e){var t=this.data,n=t.substring(e);t=t.substring(0,e),this.data=this.nodeValue=t,this.length=t.length;var r=this.ownerDocument.createTextNode(n);return this.parentNode&&this.parentNode.insertBefore(r,this.nextSibling),r}},r(b,I),R.prototype={nodeName:"#comment",nodeType:Q},r(R,I),M.prototype={nodeName:"#cdata-section",nodeType:X},r(M,I),C.prototype.nodeType=ee,r(C,h),w.prototype.nodeType=ne,r(w,h),P.prototype.nodeType=$,r(P,h),L.prototype.nodeType=z,r(L,h),O.prototype.nodeName="#document-fragment",O.prototype.nodeType=te,r(O,h),D.prototype.nodeType=J,r(D,h),U.prototype.serializeToString=function(e,t,n){return x.call(e,t,n)},h.prototype.toString=x;try{Object.defineProperty&&(Object.defineProperty(o.prototype,"length",{get:function(){return s(this),this.$$length}}),Object.defineProperty(h.prototype,"textContent",{get:function(){return j(this)},set:function(e){switch(this.nodeType){case Y:case te:for(;this.firstChild;)this.removeChild(this.firstChild);(e||String(e))&&this.appendChild(this.ownerDocument.createTextNode(e));break;default:this.data=e,this.value=e,this.nodeValue=e}}}),K=function(e,t,n){e["$$"+t]=n})}catch(e){}t.DOMImplementation=f,t.XMLSerializer=U},function(e,t,n){(function(e){(function(){var r,i=[].slice;r=n(272),t.allowUnsafeEval=function(t){var n;n=e.eval;try{return e.eval=function(e){return r.runInThisContext(e)},t()}finally{e.eval=n}},t.allowUnsafeNewFunction=function(n){var r;r=e.Function;try{return e.Function=t.Function,n()}finally{e.Function=r}},t.Function=function(){var e,t,n,a,o,s,u;for(n=2<=arguments.length?i.call(arguments,0,o=arguments.length-1):(o=0,[]),e=arguments[o++],a=[],s=0,u=n.length;s<u;s++)t=n[s],"string"==typeof t&&(t=t.split(/\s*,\s*/)),a.push.apply(a,t);return r.runInThisContext("(function("+a.join(", ")+") {\n  "+e+"\n})")},t.Function.prototype=e.Function.prototype}).call(this)}).call(t,function(){return this}())},function(module,exports,__webpack_require__){function Context(){}var indexOf=__webpack_require__(273),Object_keys=function(e){if(Object.keys)return Object.keys(e);var t=[];for(var n in e)t.push(n);return t},forEach=function(e,t){if(e.forEach)return e.forEach(t);for(var n=0;n<e.length;n++)t(e[n],n,e)},defineProp=function(){try{return Object.defineProperty({},"_",{}),function(e,t,n){Object.defineProperty(e,t,{writable:!0,enumerable:!1,configurable:!0,value:n})}}catch(e){return function(e,t,n){e[t]=n}}}(),globals=["Array","Boolean","Date","Error","EvalError","Function","Infinity","JSON","Math","NaN","Number","Object","RangeError","ReferenceError","RegExp","String","SyntaxError","TypeError","URIError","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","eval","isFinite","isNaN","parseFloat","parseInt","undefined","unescape"];Context.prototype={};var Script=exports.Script=function(e){return this instanceof Script?void(this.code=e):new Script(e)};Script.prototype.runInContext=function(e){if(!(e instanceof Context))throw new TypeError("needs a 'context' argument.");var t=document.createElement("iframe");t.style||(t.style={}),t.style.display="none",document.body.appendChild(t);var n=t.contentWindow,r=n.eval,i=n.execScript;!r&&i&&(i.call(n,"null"),r=n.eval),forEach(Object_keys(e),function(t){n[t]=e[t]}),forEach(globals,function(t){e[t]&&(n[t]=e[t])});var a=Object_keys(n),o=r.call(n,this.code);return forEach(Object_keys(n),function(t){(t in e||indexOf(a,t)===-1)&&(e[t]=n[t])}),forEach(globals,function(t){t in e||defineProp(e,t,n[t])}),document.body.removeChild(t),o},Script.prototype.runInThisContext=function(){return eval(this.code)},Script.prototype.runInNewContext=function(e){var t=Script.createContext(e),n=this.runInContext(t);return forEach(Object_keys(t),function(n){e[n]=t[n]}),n},forEach(Object_keys(Script.prototype),function(e){exports[e]=Script[e]=function(t){var n=Script(t);return n[e].apply(n,[].slice.call(arguments,1))}}),exports.createScript=function(e){return exports.Script(e)},exports.createContext=Script.createContext=function(e){var t=new Context;return"object"==typeof e&&forEach(Object_keys(e),function(n){t[n]=e[n]}),t}},function(e,t){var n=[].indexOf;e.exports=function(e,t){if(n)return e.indexOf(t);for(var r=0;r<e.length;++r)if(e[r]===t)return r;return-1}},function(e,t){},function(e,t,n){"use strict";var r=n(56);e.exports=r},function(e,t,n){(function(e){"use strict";function r(e){if(!e)return e;var t=e.indexOf("#");return t==-1?e:e.substring(0,t)}function i(e){if(!e)return null;"string"!=typeof e&&(e=""+e);var t=e.indexOf("#");if(t==-1)return null;var n=t==e.length-1?"":e.substring(t+1,e.length),i=n.split("/");return 0==i.length?null:(""==i[0].trim()&&i.splice(0,1),new d(n,r(e),i))}function a(){return[new m,new v]}function o(e,t){if(!e)return t;var n=i(e);if(!n)return t;var a=r(e);return s(a,n,t).content}function s(e,t,n){var r=c.find(a(),function(t){return t.isApplicable(e,n)});return r?r.resolveReference(n,t):{content:n,validation:[]}}function u(e,t,n){if(!n)return[];var r=c.find(a(),function(t){return t.isApplicable(e,n)});return r?r.completeReference(n,t):[]}function l(e,t){return!!e&&(!!t&&e.lastIndexOf(t)===e.length-t.length)}function p(e,t){for(var n=e.getElementsByTagName(t),r=[],i=0;i<n.length;i++){var a=n[i];a.parentNode===e&&r.push(a)}return r}Object.defineProperty(t,"__esModule",{value:!0});var c=n(16),f=n(268).DOMParser,h=n(277);t.getIncludePath=r,t.getIncludeReference=i,t.getIncludeReferenceResolvers=a,t.resolveContents=o,t.resolve=s,t.completeReference=u;var d=function(){function t(e,t,n){this.includePath=t,this.segments=n,this.originalString=e}return t.prototype.getIncludePath=function(){return this.includePath},t.prototype.getFragments=function(){return this.segments},t.prototype.asString=function(){return this.originalString},t.prototype.encodedName=function(t){return void 0===t&&(t=!0),h.encode(new e(this.includePath+"/"+this.asString()))+(t?this.includePath.substring(this.includePath.lastIndexOf(".")):"")},t}(),m=function(){function e(){}return e.prototype.isApplicable=function(e,t){return e&&(l(e.trim(),".js")||l(e.trim(),".json"))},e.prototype.resolveReference=function(e,t){try{var n={};return n.$ref=t.getIncludePath()+"#"+t.getFragments().map(function(e){return"/"+e}).join(""),{content:JSON.stringify(n,null,2),validation:[]}}catch(e){console.log(e)}return{content:e,validation:[]}},e.prototype.completeReference=function(e,t){try{var n=JSON.parse(e),r=t.getFragments();if(!r||0==r.length)return this.getChildren(n);for(var i=n,a=t.asString().lastIndexOf("/")==t.asString().length-1,o=(a?r.length:r.length-1,0);o<r.length-1;o++){var s=r[o];if(i=this.findChild(i,s),!i)return[]}if(a)return this.getChildren(i);var u=r[r.length-1],l=[];return this.getChildren(i).forEach(function(e){0==e.indexOf(u)&&l.push(e)}),l}catch(e){console.log(e)}return[]},e.prototype.findChild=function(e,t){var n=t.replace("~1","/");return n=t.replace("~0","~"),e[n]},e.prototype.getChildren=function(e){return Object.keys(e)},e}(),y={errorHandler:{warning:function(){return null},error:function(){return null},fatalError:function(){return null}}},v=function(){function e(){}return e.prototype.isApplicable=function(e,t){return e&&(l(e.trim(),".xml")||l(e.trim(),".xsd"))},e.prototype.resolveReference=function(e,t){try{var n=new f(y).parseFromString(e),r=t.asString(),i=t.encodedName(!1),a=p(n,"xs:schema")[0],o=p(a,"xs:element"),s=p(a,"xs:complexType"),u=c.find(o,function(e){return e.getAttribute("name")===r}),l=u?c.find(s,function(e){return e.getAttribute("name")===u.getAttribute("type")}):c.find(s,function(e){return e.getAttribute("name")===r}),h=n.createElement("xs:element");h.setAttribute("name",i),l&&h.setAttribute("type",l.getAttribute("name")),u&&h.setAttribute("originalname",u.getAttribute("name")),h.setAttribute("requestedname",r),h.setAttribute("extraelement","true"),a.appendChild(h);var d=n.toString(),m=d,v=d.indexOf("?>");if(v>0&&d.length>v+2){var g=d.charAt(v+2);"\n"!=g&&(m=d.slice(0,v+2)+"\n"+d.slice(v+2))}return{content:m,validation:[]}}catch(e){console.log(e)}return{content:e,validation:[]}},e.prototype.completeReference=function(e,t){try{var n=new f(y).parseFromString(e),r=[],i=p(n,"xs:schema")[0],a=p(i,"xs:element"),o=p(i,"xs:complexType");a.forEach(function(e){return r.push(e.getAttribute("name"))}),o.forEach(function(e){return r.push(e.getAttribute("name"))});var s=0===t.asString().trim().length;return s?r:r.filter(function(e){return 0===e.indexOf(t.asString())})}catch(e){return[]}},e}()}).call(t,n(43).Buffer)},function(e,t,n){e.exports=n(278)},function(e,t,n){(function(e){/*!
	 * urlsafe-base64
	 */
t.version="1.0.0",t.encode=function(e){return e.toString("base64").replace(/\+/g,"-").replace(/\//g,"_").replace(/=+$/,"")},t.decode=function(t){return t+=Array(5-t.length%4).join("="),t=t.replace(/\-/g,"+").replace(/\_/g,"/"),new e(t,"base64")},t.validate=function(e){return/^[A-Za-z0-9\-_]+$/.test(e)}}).call(t,n(43).Buffer)},function(e,t,n){"use strict";function r(e){if(!e||!e.trim()||"{"!=e.trim().charAt(0))return!1;try{var t=JSON.parse(e);return t&&"object"==typeof t}catch(t){return s.isXmlScheme(e)}}function i(e,t){if(s.isXmlScheme(e))return p.getXMLSchema(e,new u.ContentProvider(t)).loadSchemaReferencesAsync().then(function(){return t});var n=p.getJSONSchema(e,new u.ContentProvider(t)),r=n.getMissingReferences([]).map(function(e){return n.contentAsync(e)});if(0===r.length)return Promise.resolve(t);var i=Promise.all(r),a=o(i,n);return a.then(function(){return t})}function a(e,t){var n=p.createSchema(e,new u.ContentProvider(t));return n&&n.getMissingReferences?n.getMissingReferences([],!0):[]}function o(e,t){return e.then(function(e){if(e.length>0){var n=t.getMissingReferences(e);if(0===n.length)return[];var r=[];return n.forEach(function(e){r.push(t.contentAsync(e))}),o(Promise.all(r.concat(e)),t)}return Promise.resolve([])})}Object.defineProperty(t,"__esModule",{value:!0});var s=n(267),u=n(262),l=n(56),p=l.getSchemaUtils();t.isScheme=r,t.startDownloadingReferencesAsync=i,t.getReferences=a},function(e,t){t.XMLHttpRequest=XMLHttpRequest},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.api10=n(282),t.common10=n(283),t.datamodel10=n(284),t.methods10=n(285),t.resources10=n(286),t.security10=n(287),t.api08=n(288),t.bodies08=n(289),t.common08=n(290),t.methods08=n(291),t.parameters08=n(292),t.resources08=n(293),t.security08=n(294)},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})},function(e,t,n){(function(t){!function(n){function r(){}function i(e,t){return function(){e.apply(t,arguments)}}function a(e){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],c(e,this)}function o(e,t){for(;3===e._state;)e=e._value;return 0===e._state?void e._deferreds.push(t):(e._handled=!0,void a._immediateFn(function(){var n=1===e._state?t.onFulfilled:t.onRejected;if(null===n)return void(1===e._state?s:u)(t.promise,e._value);var r;try{r=n(e._value)}catch(e){return void u(t.promise,e)}s(t.promise,r)}))}function s(e,t){try{if(t===e)throw new TypeError("A promise cannot be resolved with itself.");if(t&&("object"==typeof t||"function"==typeof t)){var n=t.then;if(t instanceof a)return e._state=3,e._value=t,void l(e);if("function"==typeof n)return void c(i(n,t),e)}e._state=1,e._value=t,l(e)}catch(t){u(e,t)}}function u(e,t){e._state=2,e._value=t,l(e)}function l(e){2===e._state&&0===e._deferreds.length&&a._immediateFn(function(){e._handled||a._unhandledRejectionFn(e._value)});for(var t=0,n=e._deferreds.length;t<n;t++)o(e,e._deferreds[t]);e._deferreds=null}function p(e,t,n){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof t?t:null,this.promise=n}function c(e,t){var n=!1;try{e(function(e){n||(n=!0,s(t,e))},function(e){n||(n=!0,u(t,e))})}catch(e){if(n)return;n=!0,u(t,e)}}var f=setTimeout;a.prototype.catch=function(e){return this.then(null,e)},a.prototype.then=function(e,t){var n=new this.constructor(r);return o(this,new p(e,t,n)),n},a.all=function(e){var t=Array.prototype.slice.call(e);return new a(function(e,n){function r(a,o){try{if(o&&("object"==typeof o||"function"==typeof o)){var s=o.then;if("function"==typeof s)return void s.call(o,function(e){r(a,e)},n)}t[a]=o,0===--i&&e(t)}catch(e){n(e)}}if(0===t.length)return e([]);for(var i=t.length,a=0;a<t.length;a++)r(a,t[a])})},a.resolve=function(e){return e&&"object"==typeof e&&e.constructor===a?e:new a(function(t){t(e)})},a.reject=function(e){return new a(function(t,n){n(e)})},a.race=function(e){return new a(function(t,n){for(var r=0,i=e.length;r<i;r++)e[r].then(t,n)})},a._immediateFn="function"==typeof t&&function(e){t(e)}||function(e){f(e,0)},a._unhandledRejectionFn=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)},a._setImmediateFn=function(e){a._immediateFn=e},a._setUnhandledRejectionFn=function(e){a._unhandledRejectionFn=e},"undefined"!=typeof e&&e.exports?e.exports=a:n.Promise||(n.Promise=a)}(this)}).call(t,n(122).setImmediate)},function(e,t){"use strict";function n(e){return"Api"==e.kind()&&"RAML08"==e.RAMLVersion()}function r(e){return"FullUriTemplateString"==e.kind()&&"RAML08"==e.RAMLVersion()}function i(e){return"UriTemplate"==e.kind()&&"RAML08"==e.RAMLVersion()}function a(e){return"StringType"==e.kind()&&"RAML08"==e.RAMLVersion()}function o(e){return"ValueType"==e.kind()&&"RAML08"==e.RAMLVersion()}function s(e){return"AnyType"==e.kind()&&"RAML08"==e.RAMLVersion()}function u(e){return"NumberType"==e.kind()&&"RAML08"==e.RAMLVersion()}function l(e){return"BooleanType"==e.kind()&&"RAML08"==e.RAMLVersion()}function p(e){return"Reference"==e.kind()&&"RAML08"==e.RAMLVersion()}function c(e){return"ResourceTypeRef"==e.kind()&&"RAML08"==e.RAMLVersion()}function f(e){return"ResourceType"==e.kind()&&"RAML08"==e.RAMLVersion()}function h(e){return"Method"==e.kind()&&"RAML08"==e.RAMLVersion()}function d(e){return"MethodBase"==e.kind()&&"RAML08"==e.RAMLVersion()}function m(e){return"Response"==e.kind()&&"RAML08"==e.RAMLVersion()}function y(e){return"StatusCodeString"==e.kind()&&"RAML08"==e.RAMLVersion()}function v(e){return"Parameter"==e.kind()&&"RAML08"==e.RAMLVersion()}function g(e){return"ParameterLocation"==e.kind()&&"RAML08"==e.RAMLVersion()}function A(e){return"MarkdownString"==e.kind()&&"RAML08"==e.RAMLVersion()}function E(e){return"StringTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function _(e){return"BooleanTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function T(e){return"NumberTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function S(e){return"IntegerTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function N(e){return"DateTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function I(e){return"FileTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function b(e){return"BodyLike"==e.kind()&&"RAML08"==e.RAMLVersion()}function R(e){return"SchemaString"==e.kind()&&"RAML08"==e.RAMLVersion()}function M(e){return"JSonSchemaString"==e.kind()&&"RAML08"==e.RAMLVersion()}function C(e){return"XMLSchemaString"==e.kind()&&"RAML08"==e.RAMLVersion()}function w(e){return"ExampleString"==e.kind()&&"RAML08"==e.RAMLVersion()}function P(e){return"JSONExample"==e.kind()&&"RAML08"==e.RAMLVersion()}function L(e){return"XMLExample"==e.kind()&&"RAML08"==e.RAMLVersion()}function O(e){return"XMLBody"==e.kind()&&"RAML08"==e.RAMLVersion()}function D(e){return"JSONBody"==e.kind()&&"RAML08"==e.RAMLVersion()}function U(e){return"SecuritySchemeRef"==e.kind()&&"RAML08"==e.RAMLVersion()}function x(e){return"AbstractSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function k(e){return"SecuritySchemePart"==e.kind()&&"RAML08"==e.RAMLVersion()}function F(e){return"TraitRef"==e.kind()&&"RAML08"==e.RAMLVersion()}function B(e){return"Trait"==e.kind()&&"RAML08"==e.RAMLVersion()}function V(e){return"SecuritySchemeSettings"==e.kind()&&"RAML08"==e.RAMLVersion()}function K(e){return"OAuth1SecuritySchemeSettings"==e.kind()&&"RAML08"==e.RAMLVersion()}function j(e){return"FixedUri"==e.kind()&&"RAML08"==e.RAMLVersion()}function W(e){return"OAuth2SecuritySchemeSettings"==e.kind()&&"RAML08"==e.RAMLVersion()}function H(e){return"OAuth2SecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function Y(e){return"OAuth1SecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function q(e){return"BasicSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function G(e){return"DigestSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function X(e){return"CustomSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function z(e){return"MimeType"==e.kind()&&"RAML08"==e.RAMLVersion()}function $(e){return"RelativeUriString"==e.kind()&&"RAML08"==e.RAMLVersion()}function J(e){return"GlobalSchema"==e.kind()&&"RAML08"==e.RAMLVersion()}function Q(e){return"RAMLSimpleElement"==e.kind()&&"RAML08"==e.RAMLVersion()}function Z(e){return"DocumentationItem"==e.kind()&&"RAML08"==e.RAMLVersion()}function ee(e){return"Resource"==e.kind()&&"RAML08"==e.RAMLVersion()}Object.defineProperty(t,"__esModule",{value:!0}),t.isApi=n,t.isFullUriTemplateString=r,t.isUriTemplate=i,t.isStringType=a,t.isValueType=o,t.isAnyType=s,t.isNumberType=u,t.isBooleanType=l,t.isReference=p,t.isResourceTypeRef=c,t.isResourceType=f,t.isMethod=h,t.isMethodBase=d,t.isResponse=m,t.isStatusCodeString=y,t.isParameter=v,t.isParameterLocation=g,t.isMarkdownString=A,t.isStringTypeDeclaration=E,t.isBooleanTypeDeclaration=_,t.isNumberTypeDeclaration=T,t.isIntegerTypeDeclaration=S,t.isDateTypeDeclaration=N,t.isFileTypeDeclaration=I,t.isBodyLike=b,t.isSchemaString=R,t.isJSonSchemaString=M,t.isXMLSchemaString=C,t.isExampleString=w,t.isJSONExample=P,t.isXMLExample=L,t.isXMLBody=O,t.isJSONBody=D,t.isSecuritySchemeRef=U,t.isAbstractSecurityScheme=x,t.isSecuritySchemePart=k,t.isTraitRef=F,t.isTrait=B,t.isSecuritySchemeSettings=V,t.isOAuth1SecuritySchemeSettings=K,t.isFixedUri=j,t.isOAuth2SecuritySchemeSettings=W,t.isOAuth2SecurityScheme=H,t.isOAuth1SecurityScheme=Y,t.isBasicSecurityScheme=q,t.isDigestSecurityScheme=G,t.isCustomSecurityScheme=X,t.isMimeType=z,t.isRelativeUriString=$,t.isGlobalSchema=J,t.isRAMLSimpleElement=Q,t.isDocumentationItem=Z,t.isResource=ee},function(e,t,n){"use strict";function r(e,t,n,r){return void 0===n&&(n=null),T.createStubNode(e,t,n,r)}function i(e,t,n){return T.createStub(e,t,n)}function a(e,t,n){return T.createStub0(e,t,n)}function o(e,t){return T.createResourceStub(e,t)}function s(e,t){return T.createMethodStub(e,t)}function u(e,t){return T.createResponseStub(e,t)}function l(e,t){return T.createBodyStub(e,t)}function p(e,t){return T.createUriParameterStub(e,t)}function c(e,t){return T.createQueryParameterStub(e,t)}function f(e,t,n,r,i){return void 0===i&&(i=!1),new E.ASTPropImpl(e,t,n,r,i)}function h(e,t,n,r){return new E.ASTNodeImpl(e,t,n,r)}function d(e,t,n,r){return new S(e,t,n,r)}function m(e,t,n,r){return new N(e,t,n,r)}function y(e,t){return _.createMapping(e,t)}function v(){return _.createMap([])}function g(e,t){return T.createAttr(e,t)}var A=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();Object.defineProperty(t,"__esModule",{value:!0});var E=n(55),_=n(4),T=n(3);t.createStubNode=r,t.createStub=i,t.createStubNoParentPatch=a,t.createResourceStub=o,t.createMethodStub=s,t.createResponseStub=u,t.createBodyStub=l,t.createUriParameterStub=p,t.createQueryParameterStub=c,t.createASTPropImpl=f,t.createASTNodeImpl=h,t.createVirtualASTPropImpl=d,t.createVirtualNodeImpl=m;var S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return A(t,e),t.prototype.value=function(){return""},t}(E.ASTPropImpl),N=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return A(t,e),t.prototype.value=function(){return""},t}(E.ASTNodeImpl);t.createMapping=y,t.createMap=v,t.createAttr=g},function(e,t,n){"use strict";function r(e,t,n){return new i.Project(e,t,n)}Object.defineProperty(t,"__esModule",{value:!0});var i=n(4);t.createProject=r},function(e,t,n){"use strict";function r(e,t){var n=n.createProject(m.dirname(e)),r={$ref:t},i=JSON.stringify(r),a=n.setCachedUnitContent(m.basename(e),i),s=o(i,a);return s.jsonSchema.$ref}function i(e,t){return v.createSchema(e,new y.ContentProvider(t))}function a(e){return v.getXMLSchema(e)}function o(e,t){return v.getJSONSchema(e,new y.ContentProvider(t))}function s(e,t,n){return h.completeReference(e,t,n)}function u(e){return h.getIncludePath(e)}function l(e){return h.getIncludeReference(e)}function p(){return new d.SchemaToModelGenerator}function c(){return new d.ModelToSchemaGenerator}Object.defineProperty(t,"__esModule",{value:!0});var f=n(56),h=n(276),d=n(300),m=n(6),y=n(262),v=f.getSchemaUtils();t.dereference=r,t.createSchema=i,t.getXMLSchema=a,t.getJSONSchema=o,t.completeReference=s,t.getIncludePath=u,t.getIncludeReference=l,t.createSchemaModelGenerator=p,t.createModelToSchemaGenerator=c},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(16),i=n(248),a=n(2),o=n(207),s=function(){function e(){}return e.prototype.generateText=function(e){var t=this,n=JSON.parse(e),r=n.items;if(!r)return"";var i="",a=r instanceof Array?r:[r];return i+="types:\n",a.forEach(function(e){i+="  - "+e.title+":\n",i+=t.generateObj(e,3)}),i},e.prototype.generateObj=function(e,t){var n="";if(n+=i.indent(t,"type: "+e.type)+"\n",e.properties){n+=i.indent(t,"properties:\n");for(var r in e.properties){var a=e.properties[r];n+=i.indent(t+1,r+":\n"),n+="object"==a.type?this.generateObj(a,t+2):i.indent(t+2,"type: "+a.type)+"\n"}return n}},e.prototype.generateTo=function(e,t,n){var r=this,i=JSON.parse(t),o=i.items;if(o){var s=o instanceof Array?o:[o],u=[];return s.forEach(function(t){var n=new a.ObjectTypeDeclarationImpl(t.title);r.generateObjTo(n,t),new a.BasicSecuritySchemeImpl(e).addToProp(n,"types"),u.push(t.title)}),u}i.title&&(n=i.title);var l=new a.ObjectTypeDeclarationImpl(n);return this.generateObjTo(l,i),new a.BasicSecuritySchemeImpl(e).addToProp(l,"types"),[n]},e.prototype.generateObjTo=function(e,t){if(e.setType(t.type),t.properties)for(var n in t.properties){var r=t.properties[n],i=this.makeTypeField(n,r);"array"==r.type,e.addToProp(i,"properties")}},e.prototype.makeTypeField=function(e,t){var n=this.makeType(e,t.type);if(t.type&&n.setType(t.type),"number"==t.type){var r=n;void 0!=t.minimum&&r.setMinimum(t.minimum),void 0!=t.maximum&&r.setMaximum(t.maximum)}if("array"==t.type){var i=t.items.type;n.setType(i+"[]");var a=n;void 0!=t.minItems&&a.setMinItems(t.minItems),void 0!=t.maxItems&&a.setMaxItems(t.maxItems),void 0!=t.uniqueItems&&a.setUniqueItems(t.uniqueItems)}return"object"==t.type&&this.generateObjTo(n,t),n},e.prototype.makeType=function(e,t){return"number"==t?new a.NumberTypeDeclarationImpl(e):"string"==t?new a.StringTypeDeclarationImpl(e):"array"==t?new a.ArrayTypeDeclarationImpl(e):new a.ObjectTypeDeclarationImpl(e)},e.prototype.generateItemsTo=function(e,t){var n=t.items;if(n){var r=n instanceof Array?n:[n];r.forEach(function(e){})}},e}();t.SchemaToModelGenerator=s;var u=function(){function e(){}return e.prototype.generateSchema=function(e){var t=this.generateType(e);return t.$schema="http://json-schema.org/draft-04/schema#",t},e.prototype.isSimpleType=function(e){return"string"==e||"number"==e||"boolean"==e||"object"==e},e.prototype.generateType=function(e){var t=this.allTypes(e),n={};n.title=e.attrValue("name");if(e.attrValue("type")){var i=e.attributes("type"),a=!1,s=!1;for(var u in i){var l=i[u].value(),p=i[u].lowLevel();if(n.type="",p.isValueInclude()){var c=JSON.parse(l);n.type="object",n.properties=c.properties}else if(this.isSimpleType(l)){if(n.type=l,s=!0,a)throw new Error(o.COULD_NOT_MIX_TYPES_INHERITANCE.message)}else{var f=this.resolveType(e,l);if(f){var h=this.generateTypeExp(l,t);if(n.properties?r.extend(n.properties,h.properties):n.properties=h.properties,n.type="object",a=!0,s)throw new Error(o.COULD_NOT_MIX_TYPES_INHERITANCE.message)}else{var h=this.generateTypeExp(l,t);n.type="object",a=!0,h.anyOf&&(n.anyOf=h.anyOf)}}}}else n.type="object";var d=this.generateProperties(e);return n.properties?r.extend(n.properties,d):n.properties=d,n},e.prototype.makeUnion=function(e,t){var n=this,r=[];return e.forEach(function(e){e=e.trim(),t[e]?r.push({type:"object",properties:n.generateType(t[e]).properties}):r.push({type:e})}),r},e.prototype.generateTypeExp=function(e,t){var n={};if(i.endsWith(e,"[]"))n.type="array",n.items={type:e.substring(0,e.length-2)};else if(e.indexOf("|")>0){var r=e.split("|");n.anyOf=this.makeUnion(r,t)}else if(t[e]){var a=this.generateType(t[e]);n.type="object",n.properties=a.properties}else n.type=e;return n},e.prototype.allTypes=function(e){var t=e.root(),n=t.elementsOfKind("types"),r={};return n.forEach(function(e){r[e.name()]=e}),r},e.prototype.resolveType=function(e,t){var n=this.allTypes(e);return n[t]},e.prototype.generateProperty=function(e,t){var n=this,i=this.allTypes(e),a={},o=e.definition().allProperties();o.forEach(function(t){if("name"!=t.nameId()){var o=e.attrValue(t.nameId());if(null!=o&&void 0!=o&&"undefined"!=o)if("type"==t.nameId()){var s=n.generateTypeExp(o,i);r.extend(a,s)}else if("enum"==t.nameId()){var u=e.attributes("enum"),l=u.map(function(e){return e.value()});a.enum=l}else a[t.nameId()]=o}}),t&&(a.required=!1);var s=(e.elements(),this.generateProperties(e));return Object.getOwnPropertyNames(s).length>0&&(a.properties=s),a},e.prototype.generateProperties=function(e){var t=this,n={},r=e.elements(),i=!0;return r.forEach(function(e){var r=e.attrValue("name");if("string"==typeof r){r=r.trim();var a=e.optional();n[r]=t.generateProperty(e,a),i=!1}}),n},e}();t.ModelToSchemaGenerator=u},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.modify=n(302)},function(e,t,n){"use strict";function r(e){return new u.TypeDeclarationImpl(e)}function i(e){return new u.ObjectTypeDeclarationImpl(e)}function a(e,t){e.setSchema(t)}function o(e,t){var n=(l.getUniverse("RAML10").type(l.universesInfo.Universe10.ExampleSpec.name),l.universesInfo.Universe10.TypeDeclaration.properties.example.name),r=e.highLevel(),i=r.lowLevel(),a=r.children().filter(function(e){return e.lowLevel().key()==n}),o=p.createNode(n);c.setAttr(o,t),a.length>0&&(c.removeNode(i,a[0].lowLevel()),a[0]._node=o,c.insertNode(i,o)),r.createAttr&&r.createAttr(n,t)}function s(e,t){e.add(t)}Object.defineProperty(t,"__esModule",{value:!0});var u=n(2),l=n(56),p=n(4),c=n(5);t.createTypeDeclaration=r,t.createObjectTypeDeclaration=i,t.setTypeDeclarationSchema=a,t.setTypeDeclarationExample=o,t.addChild=s},function(e,t,n){"use strict";function r(e){return i.expandTraitsAndResourceTypes(e)}Object.defineProperty(t,"__esModule",{value:!0});var i=n(217);t.expandTraitsAndResourceTypes=r},function(e,t,n){"use strict";function r(e){return i.completeRelativeUri(e)}Object.defineProperty(t,"__esModule",{value:!0});var i=n(249);t.completeRelativeUri=r}])});